(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous OpenCVJSModule.
    define(function () {
      return (root.cv = factory());
    });
  } else if (typeof OpenCVJSModule === 'object' && OpenCVJSModule.exports) {
    // Node. Does not work with strict CommonJS, but
    // only CommonJS-like environments that support OpenCVJSModule.exports,
    // like Node.
    OpenCVJSModule.exports = factory();
  } else {
    // Browser globals
    root.cv = factory();
  }
}(this, function () {
  var cv = function(cv) {
  cv = cv || {};
  var OpenCVJSModule = cv;

var OpenCVJSModule;if(!OpenCVJSModule)OpenCVJSModule=(typeof cv!=="undefined"?cv:null)||{};var OpenCVJSModuleOverrides={};for(var key in OpenCVJSModule){if(OpenCVJSModule.hasOwnProperty(key)){OpenCVJSModuleOverrides[key]=OpenCVJSModule[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(OpenCVJSModule["ENVIRONMENT"]){if(OpenCVJSModule["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(OpenCVJSModule["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(OpenCVJSModule["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(OpenCVJSModule["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided OpenCVJSModule['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!OpenCVJSModule["print"])OpenCVJSModule["print"]=console.log;if(!OpenCVJSModule["printErr"])OpenCVJSModule["printErr"]=console.warn;var nodeFS;var nodePath;OpenCVJSModule["read"]=function shell_read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};OpenCVJSModule["readBinary"]=function readBinary(filename){var ret=OpenCVJSModule["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};OpenCVJSModule["load"]=function load(f){globalEval(read(f))};if(!OpenCVJSModule["thisProgram"]){if(process["argv"].length>1){OpenCVJSModule["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{OpenCVJSModule["thisProgram"]="unknown-program"}}OpenCVJSModule["arguments"]=process["argv"].slice(2);if(typeof OpenCVJSModule!=="undefined"){OpenCVJSModule["exports"]=OpenCVJSModule}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));OpenCVJSModule["inspect"]=(function(){return"[Emscripten OpenCVJSModule object]"})}else if(ENVIRONMENT_IS_SHELL){if(!OpenCVJSModule["print"])OpenCVJSModule["print"]=print;if(typeof printErr!="undefined")OpenCVJSModule["printErr"]=printErr;if(typeof read!="undefined"){OpenCVJSModule["read"]=read}else{OpenCVJSModule["read"]=function shell_read(){throw"no read() available"}}OpenCVJSModule["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){OpenCVJSModule["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){OpenCVJSModule["arguments"]=arguments}if(typeof quit==="function"){OpenCVJSModule["quit"]=(function(status,toThrow){quit(status)})}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){OpenCVJSModule["read"]=function shell_read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(ENVIRONMENT_IS_WORKER){OpenCVJSModule["readBinary"]=function readBinary(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}OpenCVJSModule["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){OpenCVJSModule["arguments"]=arguments}if(typeof console!=="undefined"){if(!OpenCVJSModule["print"])OpenCVJSModule["print"]=function shell_print(x){console.log(x)};if(!OpenCVJSModule["printErr"])OpenCVJSModule["printErr"]=function shell_printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!OpenCVJSModule["print"])OpenCVJSModule["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){OpenCVJSModule["load"]=importScripts}if(typeof OpenCVJSModule["setWindowTitle"]==="undefined"){OpenCVJSModule["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!OpenCVJSModule["load"]&&OpenCVJSModule["read"]){OpenCVJSModule["load"]=function load(f){globalEval(OpenCVJSModule["read"](f))}}if(!OpenCVJSModule["print"]){OpenCVJSModule["print"]=(function(){})}if(!OpenCVJSModule["printErr"]){OpenCVJSModule["printErr"]=OpenCVJSModule["print"]}if(!OpenCVJSModule["arguments"]){OpenCVJSModule["arguments"]=[]}if(!OpenCVJSModule["thisProgram"]){OpenCVJSModule["thisProgram"]="./this.program"}if(!OpenCVJSModule["quit"]){OpenCVJSModule["quit"]=(function(status,toThrow){throw toThrow})}OpenCVJSModule.print=OpenCVJSModule["print"];OpenCVJSModule.printErr=OpenCVJSModule["printErr"];OpenCVJSModule["preRun"]=[];OpenCVJSModule["postRun"]=[];for(var key in OpenCVJSModuleOverrides){if(OpenCVJSModuleOverrides.hasOwnProperty(key)){OpenCVJSModule[key]=OpenCVJSModuleOverrides[key]}}OpenCVJSModuleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value;return value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return OpenCVJSModule["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return OpenCVJSModule["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;OpenCVJSModule.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=HEAP32[DYNAMICTOP_PTR>>2];var end=(ret+size+15|0)&-16;HEAP32[DYNAMICTOP_PTR>>2]=end;if(end>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){HEAP32[DYNAMICTOP_PTR>>2]=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};OpenCVJSModule["Runtime"]=Runtime;var ABORT=0;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=OpenCVJSModule["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=Runtime.stackAlloc(len);stringToUTF8(str,ret,len)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};var sourceRegex=/^function\s*[a-zA-Z$_0-9]*\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource=null;function ensureJSsource(){if(!JSsource){JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){ensureJSsource();funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"=("+convertCode.returnValue+");"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){ensureJSsource();funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();OpenCVJSModule["ccall"]=ccall;OpenCVJSModule["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}OpenCVJSModule["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}OpenCVJSModule["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;OpenCVJSModule["ALLOC_NORMAL"]=ALLOC_NORMAL;OpenCVJSModule["ALLOC_STACK"]=ALLOC_STACK;OpenCVJSModule["ALLOC_STATIC"]=ALLOC_STATIC;OpenCVJSModule["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;OpenCVJSModule["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}OpenCVJSModule["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}OpenCVJSModule["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return OpenCVJSModule["UTF8ToString"](ptr)}OpenCVJSModule["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}OpenCVJSModule["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}OpenCVJSModule["stringToAscii"]=stringToAscii;var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(u8Array,idx){var endPtr=idx;while(u8Array[endPtr])++endPtr;if(endPtr-idx>16&&u8Array.subarray&&UTF8Decoder){return UTF8Decoder.decode(u8Array.subarray(idx,endPtr))}else{var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}}OpenCVJSModule["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}OpenCVJSModule["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}OpenCVJSModule["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}OpenCVJSModule["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}OpenCVJSModule["lengthBytesUTF8"]=lengthBytesUTF8;var UTF16Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf-16le"):undefined;function demangle(func){var __cxa_demangle_func=OpenCVJSModule["___cxa_demangle"]||OpenCVJSModule["__cxa_demangle"];if(__cxa_demangle_func){try{var s=func.substr(1);var len=lengthBytesUTF8(s)+1;var buf=_malloc(len);stringToUTF8(s,buf,len);var status=_malloc(4);var ret=__cxa_demangle_func(buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){var regex=/__Z[\w\d_]+/g;return text.replace(regex,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(OpenCVJSModule["extraStackTrace"])js+="\n"+OpenCVJSModule["extraStackTrace"]();return demangleAll(js)}OpenCVJSModule["stackTrace"]=stackTrace;var WASM_PAGE_SIZE=65536;var ASMJS_PAGE_SIZE=16777216;var MIN_TOTAL_MEMORY=16777216;function alignUp(x,multiple){if(x%multiple>0){x+=multiple-x%multiple}return x}var HEAP,buffer,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBuffer(buf){OpenCVJSModule["buffer"]=buffer=buf}function updateGlobalBufferViews(){OpenCVJSModule["HEAP8"]=HEAP8=new Int8Array(buffer);OpenCVJSModule["HEAP16"]=HEAP16=new Int16Array(buffer);OpenCVJSModule["HEAP32"]=HEAP32=new Int32Array(buffer);OpenCVJSModule["HEAPU8"]=HEAPU8=new Uint8Array(buffer);OpenCVJSModule["HEAPU16"]=HEAPU16=new Uint16Array(buffer);OpenCVJSModule["HEAPU32"]=HEAPU32=new Uint32Array(buffer);OpenCVJSModule["HEAPF32"]=HEAPF32=new Float32Array(buffer);OpenCVJSModule["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE,STATICTOP,staticSealed;var STACK_BASE,STACKTOP,STACK_MAX;var DYNAMIC_BASE,DYNAMICTOP_PTR;STATIC_BASE=STATICTOP=STACK_BASE=STACKTOP=STACK_MAX=DYNAMIC_BASE=DYNAMICTOP_PTR=0;staticSealed=false;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set OpenCVJSModule.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}if(!OpenCVJSModule["reallocBuffer"])OpenCVJSModule["reallocBuffer"]=(function(size){var ret;try{if(ArrayBuffer.transfer){ret=ArrayBuffer.transfer(buffer,size)}else{var oldHEAP8=HEAP8;ret=new ArrayBuffer(size);var temp=new Int8Array(ret);temp.set(oldHEAP8)}}catch(e){return false}var success=_emscripten_replace_memory(ret);if(!success)return false;return ret});function enlargeMemory(){var PAGE_MULTIPLE=OpenCVJSModule["usingWasm"]?WASM_PAGE_SIZE:ASMJS_PAGE_SIZE;var LIMIT=2147483648-PAGE_MULTIPLE;if(HEAP32[DYNAMICTOP_PTR>>2]>LIMIT){return false}var OLD_TOTAL_MEMORY=TOTAL_MEMORY;TOTAL_MEMORY=Math.max(TOTAL_MEMORY,MIN_TOTAL_MEMORY);while(TOTAL_MEMORY<HEAP32[DYNAMICTOP_PTR>>2]){if(TOTAL_MEMORY<=536870912){TOTAL_MEMORY=alignUp(2*TOTAL_MEMORY,PAGE_MULTIPLE)}else{TOTAL_MEMORY=Math.min(alignUp((3*TOTAL_MEMORY+2147483648)/4,PAGE_MULTIPLE),LIMIT)}}var replacement=OpenCVJSModule["reallocBuffer"](TOTAL_MEMORY);if(!replacement||replacement.byteLength!=TOTAL_MEMORY){TOTAL_MEMORY=OLD_TOTAL_MEMORY;return false}updateGlobalBuffer(replacement);updateGlobalBufferViews();return true}var byteLength;try{byteLength=Function.prototype.call.bind(Object.getOwnPropertyDescriptor(ArrayBuffer.prototype,"byteLength").get);byteLength(new ArrayBuffer(4))}catch(e){byteLength=(function(buffer){return buffer.byteLength})}var TOTAL_STACK=OpenCVJSModule["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=OpenCVJSModule["TOTAL_MEMORY"]||134217728;if(TOTAL_MEMORY<TOTAL_STACK)OpenCVJSModule.printErr("TOTAL_MEMORY should be larger than TOTAL_STACK, was "+TOTAL_MEMORY+"! (TOTAL_STACK="+TOTAL_STACK+")");if(OpenCVJSModule["buffer"]){buffer=OpenCVJSModule["buffer"]}else{{buffer=new ArrayBuffer(TOTAL_MEMORY)}}updateGlobalBufferViews();function getTotalMemory(){return TOTAL_MEMORY}HEAP32[0]=1668509029;HEAP16[1]=25459;if(HEAPU8[2]!==115||HEAPU8[3]!==99)throw"Runtime error: expected the system to be little-endian!";OpenCVJSModule["HEAP"]=HEAP;OpenCVJSModule["buffer"]=buffer;OpenCVJSModule["HEAP8"]=HEAP8;OpenCVJSModule["HEAP16"]=HEAP16;OpenCVJSModule["HEAP32"]=HEAP32;OpenCVJSModule["HEAPU8"]=HEAPU8;OpenCVJSModule["HEAPU16"]=HEAPU16;OpenCVJSModule["HEAPU32"]=HEAPU32;OpenCVJSModule["HEAPF32"]=HEAPF32;OpenCVJSModule["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){OpenCVJSModule["dynCall_v"](func)}else{OpenCVJSModule["dynCall_vi"](func,callback.arg)}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(OpenCVJSModule["preRun"]){if(typeof OpenCVJSModule["preRun"]=="function")OpenCVJSModule["preRun"]=[OpenCVJSModule["preRun"]];while(OpenCVJSModule["preRun"].length){addOnPreRun(OpenCVJSModule["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(OpenCVJSModule["postRun"]){if(typeof OpenCVJSModule["postRun"]=="function")OpenCVJSModule["postRun"]=[OpenCVJSModule["postRun"]];while(OpenCVJSModule["postRun"].length){addOnPostRun(OpenCVJSModule["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}OpenCVJSModule["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}OpenCVJSModule["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}OpenCVJSModule["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}OpenCVJSModule["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}OpenCVJSModule["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}OpenCVJSModule["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}OpenCVJSModule["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");var lastChar,end;if(dontAddNull){end=buffer+lengthBytesUTF8(string);lastChar=HEAP8[end]}stringToUTF8(string,buffer,Infinity);if(dontAddNull)HEAP8[end]=lastChar}OpenCVJSModule["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}OpenCVJSModule["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}OpenCVJSModule["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_round=Math.round;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(OpenCVJSModule["monitorRunDependencies"]){OpenCVJSModule["monitorRunDependencies"](runDependencies)}}OpenCVJSModule["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(OpenCVJSModule["monitorRunDependencies"]){OpenCVJSModule["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}OpenCVJSModule["removeRunDependency"]=removeRunDependency;OpenCVJSModule["preloadedImages"]={};OpenCVJSModule["preloadedAudios"]={};var ASM_CONSTS=[];STATIC_BASE=Runtime.GLOBAL_BASE;STATICTOP=STATIC_BASE+1165600;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){___cxx_global_var_init_32()})},{func:(function(){__GLOBAL__sub_I_versions_pb_cc()})},{func:(function(){__GLOBAL__sub_I_status_cc()})},{func:(function(){__GLOBAL__sub_I_descriptor_pb_cc()})},{func:(function(){__GLOBAL__sub_I_message_cc()})},{func:(function(){___cxx_global_var_init()})},{func:(function(){___cxx_global_var_init_28()})},{func:(function(){___cxx_global_var_init_29()})},{func:(function(){___cxx_global_var_init_30()})},{func:(function(){___cxx_global_var_init_31()})},{func:(function(){__GLOBAL__sub_I_op_def_pb_cc()})},{func:(function(){___cxx_global_var_init_33()})},{func:(function(){___cxx_global_var_init_34()})},{func:(function(){___cxx_global_var_init_35()})},{func:(function(){___cxx_global_var_init_36()})},{func:(function(){___cxx_global_var_init_37()})},{func:(function(){___cxx_global_var_init_38()})},{func:(function(){__GLOBAL__sub_I_bind_cpp()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})},{func:(function(){__GLOBAL__sub_I_tensor_pb_cc()})},{func:(function(){__GLOBAL__sub_I_system_cpp()})},{func:(function(){__GLOBAL__sub_I_kmeans_cpp()})},{func:(function(){__GLOBAL__sub_I_umatrix_cpp()})},{func:(function(){__GLOBAL__sub_I_imgwarp_cpp()})},{func:(function(){__GLOBAL__sub_I_color_lab_cpp()})},{func:(function(){__GLOBAL__sub_I_dnn_cpp()})},{func:(function(){__GLOBAL__sub_I_init_cpp()})},{func:(function(){__GLOBAL__sub_I_attr_value_pb_cc()})},{func:(function(){__GLOBAL__sub_I_types_pb_cc()})},{func:(function(){__GLOBAL__sub_I_bindings_cpp()})},{func:(function(){__GLOBAL__sub_I_graph_pb_cc()})},{func:(function(){__GLOBAL__sub_I_tensor_shape_pb_cc()})},{func:(function(){__GLOBAL__sub_I_opencv_caffe_pb_cc()})},{func:(function(){__GLOBAL__sub_I_opencv_onnx_pb_cc()})},{func:(function(){__GLOBAL__sub_I_darknet_io_cpp()})},{func:(function(){__GLOBAL__sub_I_prior_box_layer_cpp()})},{func:(function(){__GLOBAL__sub_I_detection_output_layer_cpp()})},{func:(function(){__GLOBAL__sub_I_function_pb_cc()})});allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,192,11,177,162,10,240,111,63,32,224,31,224,31,224,239,63,136,103,16,107,42,224,127,63,240,7,252,1,127,192,239,63,118,10,129,95,71,220,135,63,18,250,1,170,28,161,239,63,227,3,252,176,168,192,143,63,32,248,129,31,248,129,239,63,116,165,70,67,164,206,147,63,181,219,160,172,16,99,239,63,26,177,213,7,27,185,151,63,113,66,74,158,101,68,239,63,151,145,175,39,192,159,155,63,181,10,35,68,246,37,239,63,0,51,120,14,155,130,159,63,8,31,124,240,193,7,239,63,127,217,35,137,217,176,161,63,2,142,69,248,199,233,238,63,95,189,254,185,135,158,163,63,192,236,1,179,7,204,238,63,212,228,200,175,91,138,165,63,235,1,186,122,128,174,238,63,252,220,50,246,88,116,167,63,103,183,240,171,49,145,238,63,235,227,200,14,131,92,169,63,228,80,151,165,26,116,238,63,190,113,25,113,221,66,171,63,116,229,1,201,58,87,238,63,82,11,219,138,107,39,173,63,115,26,220,121,145,58,238,63,166,98,17,192,48,10,175,63,30,30,30,30,30,30,238,63,113,228,152,53,152,117,176,63,30,224,1,30,224,1,238,63,224,122,163,238,54,101,177,63,138,134,248,227,214,229,237,63,22,20,10,47,246,83,178,63,202,29,160,220,1,202,237,63,208,209,27,150,215,65,179,63,219,129,185,118,96,174,237,63,240,70,166,190,220,46,180,63,138,127,30,35,242,146,237,63,63,24,6,63,7,27,181,63,52,44,184,84,182,119,237,63,195,80,55,169,88,6,182,63,178,114,117,128,172,92,237,63,75,107,229,138,210,240,182,63,29,212,65,29,212,65,237,63,204,18,123,109,118,218,183,63,26,91,252,163,44,39,237,63,32,155,49,214,69,195,184,63,116,192,110,143,181,12,237,63,172,51,32,70,66,171,185,63,198,191,68,92,110,242,236,63,99,213,74,58,109,146,186,63,11,155,3,137,86,216,236,63,161,237,176,43,200,120,187,63,231,203,1,150,109,190,236,63,67,199,91,143,84,94,188,63,145,225,94,5,179,164,236,63,93,179,108,214,19,67,189,63,66,138,251,90,38,139,236,63,229,242,42,110,7,39,190,63,28,199,113,28,199,113,236,63,166,98,17,192,48,10,191,63,134,73,13,209,148,88,236,63,186,234,219,49,145,236,191,63,240,248,195,1,143,63,236,63,110,89,202,18,21,103,192,63,28,160,46,57,181,38,236,63,89,142,208,124,126,215,192,63,224,192,129,3,7,14,236,63,172,66,103,132,133,71,193,63,139,141,134,238,131,245,235,63,160,103,47,213,42,183,193,63,247,6,148,137,43,221,235,63,203,90,10,25,111,38,194,63,123,62,136,101,253,196,235,63,35,245,31,248,82,149,194,63,208,186,193,20,249,172,235,63,210,127,228,24,215,3,195,63,35,255,24,43,30,149,235,63,116,143,30,32,252,113,195,63,139,51,218,61,108,125,235,63,41,198,236,176,194,223,195,63,5,238,190,227,226,101,235,63,30,125,203,108,43,77,196,63,79,27,232,180,129,78,235,63,229,85,154,243,54,186,196,63,206,6,216,74,72,55,235,63,55,180,161,227,229,38,197,63,217,128,108,64,54,32,235,63,133,32,152,217,56,147,197,63,164,34,217,49,75,9,235,63,211,147,167,112,48,255,197,63,40,175,161,188,134,242,234,63,80,173,114,66,205,106,198,63,94,144,148,127,232,219,234,63,28,210,25,231,15,214,198,63,27,112,197,26,112,197,234,63,164,55,64,245,248,64,199,63,253,235,135,47,29,175,234,63,9,217,16,2,137,171,199,63,190,99,106,96,239,152,234,63,234,87,67,161,192,21,200,63,89,225,48,81,230,130,234,63,16,201,32,101,160,127,200,63,109,26,208,166,1,109,234,63,64,109,136,222,40,233,200,63,74,138,104,7,65,87,234,63,180,86,244,156,90,82,201,63,26,164,65,26,164,65,234,63,131,251,125,46,54,187,201,63,160,28,197,135,42,44,234,63,99,181,226,31,188,35,202,63,2,75,122,249,211,22,234,63,24,47,136,252,236,139,202,63,26,160,1,26,160,1,234,63,242,191,128,78,201,243,202,63,217,51,16,149,142,236,233,63,164,181,143,158,81,91,203,63,45,104,107,23,159,215,233,63,214,140,45,116,134,194,203,63,2,161,228,78,209,194,233,63,192,24,140,85,104,41,204,63,218,16,85,234,36,174,233,63,33,154,154,199,247,143,204,63,154,153,153,153,153,153,233,63,220,197,9,78,53,246,204,63,255,192,142,13,47,133,233,63,145,187,79,107,33,92,205,63,114,184,12,248,228,112,233,63,125,236,171,160,188,193,205,63,174,119,227,11,187,92,233,63,229,242,42,110,7,39,206,63,224,233,214,252,176,72,233,63,95,90,170,82,2,140,206,63,230,44,155,127,198,52,233,63,54,89,220,203,173,240,206,63,41,226,208,73,251,32,233,63,55,123,75,86,10,85,207,63,213,144,1,18,79,13,233,63,42,62,94,109,24,185,207,63,250,24,156,143,193,249,232,63,28,80,173,69,108,14,208,63,63,55,241,122,82,230,232,63,64,208,180,148,37,64,208,63,211,24,48,141,1,211,232,63,13,89,205,95,184,113,208,63,58,255,98,128,206,191,232,63,227,144,115,226,36,163,208,63,170,243,107,15,185,172,232,63,75,183,154,87,107,212,208,63,156,137,1,246,192,153,232,63,213,74,174,249,139,5,209,63,74,176,171,240,229,134,232,63,176,168,147,2,135,54,209,63,185,146,192,188,39,116,232,63,14,166,171,171,92,103,209,63,24,134,97,24,134,97,232,63,111,35,212,45,13,152,209,63,20,6,120,194,0,79,232,63,250,153,105,193,152,200,209,63,221,190,178,122,151,60,232,63,242,162,72,158,255,248,209,63,160,164,130,1,74,42,232,63,101,121,207,251,65,41,210,63,24,24,24,24,24,24,232,63,57,118,223,16,96,89,210,63,6,24,96,128,1,6,232,63,163,134,222,19,90,137,210,63,64,127,1,253,5,244,231,63,36,157,184,58,48,185,210,63,29,79,90,81,37,226,231,63,48,29,225,186,226,232,210,63,244,5,125,65,95,208,231,63,132,65,84,201,113,24,211,63,124,1,46,146,179,190,231,63,84,125,152,154,221,71,211,63,195,236,224,8,34,173,231,63,90,216,191,98,38,119,211,63,139,57,182,107,170,155,231,63,233,69,105,85,76,166,211,63,200,164,120,129,76,138,231,63,15,247,193,165,79,213,211,63,13,198,154,17,8,121,231,63,227,167,134,134,48,4,212,63,177,169,52,228,220,103,231,63,19,232,4,42,239,50,212,63,109,117,1,194,202,86,231,63,194,94,28,194,139,97,212,63,70,23,93,116,209,69,231,63,208,9,64,128,6,144,212,63,141,254,65,197,240,52,231,63,160,120,119,149,95,190,212,63,188,222,70,127,40,36,231,63,105,2,96,50,151,236,212,63,9,124,156,109,120,19,231,63,45,248,45,135,173,26,213,63,112,129,11,92,224,2,231,63,98,210,173,195,162,72,213,63,23,96,242,22,96,242,230,63,108,90,69,23,119,118,213,63,199,55,67,107,247,225,230,63,225,207,244,176,42,164,213,63,97,200,129,38,166,209,230,63,202,9,88,191,189,209,213,63,23,108,193,22,108,193,230,63,211,147,167,112,48,255,213,63,61,26,163,10,73,177,230,63,149,199,185,242,130,44,214,63,144,114,83,209,60,161,230,63,242,225,3,115,181,89,214,63,192,208,136,58,71,145,230,63,174,20,155,30,200,134,214,63,23,104,129,22,104,129,230,63,61,148,53,34,187,179,214,63,26,103,1,54,159,113,230,63,227,161,43,170,142,224,214,63,249,34,81,106,236,97,230,63,53,146,120,226,66,13,215,63,163,74,59,133,79,82,230,63,6,208,187,246,215,57,215,63,100,33,11,89,200,66,230,63,206,219,57,18,78,102,215,63,222,192,138,184,86,51,230,63,162,71,221,95,165,146,215,63,64,98,1,119,250,35,230,63,191,175,55,10,222,190,215,63,148,174,49,104,179,20,230,63,195,175,130,59,248,234,215,63,6,22,88,96,129,5,230,63,149,212,160,29,244,22,216,63,252,45,41,52,100,246,229,63,23,139,30,218,209,66,216,63,231,21,208,184,91,231,229,63,160,11,51,154,145,110,216,63,165,226,236,195,103,216,229,63,90,66,193,134,51,154,216,63,87,16,147,43,136,201,229,63,138,180,88,200,183,197,216,63,145,250,71,198,188,186,229,63,199,98,54,135,30,241,216,63,192,90,1,107,5,172,229,63,61,168,69,235,103,28,217,63,170,204,35,241,97,157,229,63,250,22,33,28,148,71,217,63,237,88,129,48,210,142,229,63,88,81,19,65,163,114,217,63,96,5,88,1,86,128,229,63,138,224,23,129,149,157,217,63,58,107,80,60,237,113,229,63,98,8,220,2,107,200,217,63,226,82,124,186,151,99,229,63,75,152,191,236,35,243,217,63,85,85,85,85,85,85,229,63,149,185,213,100,192,29,218,63,254,130,187,230,37,71,229,63,10,187,229,144,64,72,218,63,235,15,244,72,9,57,229,63,234,217,107,150,164,114,218,63,75,5,168,86,255,42,229,63,73,8,154,154,236,156,218,63,21,248,226,234,7,29,229,63,228,176,88,194,24,199,218,63,197,196,17,225,34,15,229,63,107,120,71,50,41,241,218,63,21,80,1,21,80,1,229,63,91,252,189,14,30,27,219,63,155,76,221,98,143,243,228,63,98,143,204,123,247,68,219,63,57,5,47,167,224,229,228,63,93,243,60,157,181,110,219,63,76,44,220,190,67,216,228,63,251,16,147,150,88,152,219,63,110,175,37,135,184,202,228,63,10,173,13,139,224,193,219,63,225,143,166,221,62,189,228,63,123,27,167,157,77,235,219,63,91,191,82,160,214,175,228,63,38,240,21,241,159,20,220,63,74,1,118,173,127,162,228,63,77,173,205,167,215,61,220,63,103,208,178,227,57,149,228,63,247,111,255,227,244,102,220,63,128,72,1,34,5,136,228,63,33,154,154,199,247,143,220,63,123,20,174,71,225,122,228,63,201,122,77,116,224,184,220,63,102,96,89,52,206,109,228,63,235,243,133,11,175,225,220,63,154,207,245,199,203,96,228,63,100,30,114,174,99,10,221,63,202,118,199,226,217,83,228,63,213,235,0,126,254,50,221,63,251,217,98,101,248,70,228,63,131,198,226,154,127,91,221,63,77,238,171,48,39,58,228,63,62,47,138,37,231,131,221,63,135,31,213,37,102,45,228,63,84,89,44,62,53,172,221,63,81,89,94,38,181,32,228,63,160,196,193,4,106,212,221,63,20,20,20,20,20,20,228,63,181,213,6,153,133,252,221,63,102,101,14,209,130,7,228,63,38,108,124,26,136,36,222,63,251,19,176,63,1,251,227,63,4,119,104,168,113,76,222,63,7,175,165,66,143,238,227,63,135,135,214,97,66,116,222,63,2,169,228,188,44,226,227,63,245,97,152,101,250,155,222,63,198,117,170,145,217,213,227,63,192,140,70,210,153,195,222,63,231,171,123,164,149,201,227,63,244,221,64,198,32,235,222,63,85,41,35,217,96,189,227,63,236,6,175,95,143,18,223,63,20,59,177,19,59,177,227,63,91,30,129,188,229,57,223,63,34,200,122,56,36,165,227,63,172,40,112,250,35,97,223,63,99,127,24,44,28,153,227,63,194,158,254,54,74,136,223,63,142,8,102,211,34,141,227,63,30,243,120,143,88,175,223,63,20,56,129,19,56,129,227,63,113,21,246,32,79,214,223,63,238,69,201,209,91,117,227,63,152,244,87,8,46,253,223,63,72,7,222,243,141,105,227,63,138,255,37,177,250,17,224,63,248,42,159,95,206,93,227,63,254,208,165,165,82,37,224,63,193,120,43,251,28,82,227,63,59,99,206,239,158,56,224,63,70,19,224,172,121,70,227,63,210,38,169,157,223,75,224,63,178,188,87,91,228,58,227,63,156,69,38,189,20,95,224,63,250,29,106,237,92,47,227,63,64,223,28,92,62,114,224,63,191,16,43,74,227,35,227,63,14,69,75,136,92,133,224,63,182,235,233,88,119,24,227,63,32,53,87,79,111,152,224,63,144,209,48,1,25,13,227,63,209,20,206,190,118,171,224,63,96,2,196,42,200,1,227,63,130,42,37,228,114,190,224,63,104,47,161,189,132,246,226,63,183,214,185,204,99,209,224,63,75,209,254,161,78,235,226,63,139,204,209,133,73,228,224,63,151,128,75,192,37,224,226,63,125,73,155,28,36,247,224,63,160,80,45,1,10,213,226,63,150,76,45,158,243,9,225,63,160,44,129,77,251,201,226,63,248,204,135,23,184,28,225,63,17,55,90,142,249,190,226,63,188,239,147,149,113,47,225,63,64,43,1,173,4,180,226,63,68,61,36,37,32,66,225,63,5,193,243,146,28,169,226,63,233,213,244,210,195,84,225,63,158,18,228,41,65,158,226,63,14,166,171,171,92,103,225,63,165,4,184,91,114,147,226,63,160,153,216,187,234,121,225,63,19,176,136,18,176,136,226,63,6,207,245,15,110,140,225,63,77,206,161,56,250,125,226,63,110,201,103,180,230,158,225,63,53,39,129,184,80,115,226,63,158,162,125,181,84,177,225,63,39,1,214,124,179,104,226,63,36,60,113,31,184,195,225,63,241,146,128,112,34,94,226,63,3,112,103,254,16,214,225,63,178,119,145,126,157,83,226,63,208,64,112,94,95,232,225,63,146,36,73,146,36,73,226,63,76,9,135,75,163,250,225,63,91,96,23,151,183,62,226,63,109,171,146,209,220,12,226,63,223,188,154,120,86,52,226,63,235,190,101,252,11,31,226,63,42,18,160,34,1,42,226,63,66,191,190,215,48,49,226,63,120,251,33,129,183,31,226,63,51,57,72,111,75,67,226,63,230,85,72,128,121,21,226,63,203,247,152,206,91,85,226,63,217,192,103,12,71,11,226,63,223,48,52,1,98,103,226,63,18,32,1,18,32,1,226,63,26,177,137,18,94,121,226,63,112,31,193,125,4,247,225,63,130,7,246,13,80,139,226,63,76,184,127,60,244,236,225,63,138,176,194,254,55,157,226,63,116,184,63,59,239,226,225,63,173,64,38,240,21,175,226,63,189,74,46,103,245,216,225,63,139,142,68,237,233,192,226,63,29,129,162,173,6,207,225,63,157,220,46,1,180,210,226,63,89,224,28,252,34,197,225,63,104,2,228,54,116,228,226,63,41,237,70,64,74,187,225,63,70,149,80,153,42,246,226,63,227,186,242,103,124,177,225,63,190,16,79,51,215,7,227,63,150,123,26,97,185,167,225,63,106,254,167,15,122,25,227,63,158,17,224,25,1,158,225,63,113,29,18,57,19,43,227,63,156,162,140,128,83,148,225,63,148,137,50,186,162,60,227,63,219,43,144,131,176,138,225,63,211,225,156,157,40,78,227,63,18,24,129,17,24,129,225,63,160,110,211,237,164,95,227,63,132,214,27,25,138,119,225,63,181,71,71,181,23,113,227,63,121,115,66,137,6,110,225,63,126,121,88,254,128,130,227,63,1,50,252,80,141,100,225,63,25,42,86,211,224,147,227,63,13,39,117,95,30,91,225,63,249,189,126,62,55,165,227,63,201,213,253,163,185,81,225,63,34,252,255,73,132,182,227,63,59,205,10,14,95,72,225,63,5,50,247,255,199,199,227,63,36,71,52,141,14,63,225,63,250,86,113,106,2,217,227,63,17,200,53,17,200,53,225,63,91,47,107,147,51,234,227,63,172,192,237,137,139,44,225,63,66,111,209,132,91,251,227,63,51,48,93,231,88,35,225,63,233,220,128,72,122,12,228,63,38,72,167,25,48,26,225,63,174,114,70,232,143,29,228,63,17,17,17,17,17,17,225,63,191,128,223,109,156,46,228,63,128,16,1,190,251,7,225,63,103,206,249,226,159,63,228,63,17,240,254,16,240,254,224,63,10,187,51,81,154,80,228,63,162,37,179,250,237,245,224,63,194,94,28,194,139,97,228,63,144,156,230,107,245,236,224,63,173,170,51,63,116,114,228,63,17,96,130,85,6,228,224,63,223,136,234,209,83,131,228,63,150,70,143,168,32,219,224,63,7,252,162,131,42,148,228,63,58,158,53,86,68,210,224,63,187,62,176,93,248,164,228,63,59,218,188,79,113,201,224,63,115,226,86,105,189,181,228,63,113,65,139,134,167,192,224,63,57,238,204,175,121,198,228,63,200,157,37,236,230,183,224,63,0,253,57,58,45,215,228,63,181,236,46,114,47,175,224,63,176,91,183,17,216,231,228,63,167,16,104,10,129,166,224,63,232,38,80,63,122,248,228,63,96,131,175,166,219,157,224,63,107,104,1,204,19,9,229,63,84,9,1,57,63,149,224,63,70,52,186,192,164,25,229,63,226,101,117,179,171,140,224,63,170,197,91,38,45,42,229,63,132,16,66,8,33,132,224,63,124,155,185,5,173,58,229,63,226,234,184,41,159,123,224,63,151,148,153,103,36,75,229,63,198,247,71,10,38,115,224,63,205,11,180,84,147,91,229,63,251,18,121,156,181,106,224,63,153,243,179,213,249,107,229,63,252,169,241,210,77,98,224,63,144,241,54,243,87,124,229,63,134,117,114,160,238,89,224,63,137,121,205,181,173,140,229,63,4,52,215,247,151,81,224,63,125,232,250,37,251,156,229,63,197,100,22,204,73,73,224,63,44,159,53,76,64,173,229,63,16,4,65,16,4,65,224,63,115,28,231,48,125,189,229,63,252,71,130,183,198,56,224,63,100,23,108,220,177,205,229,63,26,94,31,181,145,48,224,63,35,153,20,87,222,221,229,63,233,41,119,252,100,40,224,63,117,22,36,169,2,238,229,63,8,4,2,129,64,32,224,63,24,137,209,218,30,254,229,63,55,122,81,54,36,24,224,63,216,136,71,244,50,14,230,63,16,16,16,16,16,16,224,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,224,63,4,0,0,0,0,0,0,0,112,93,0,0,23,0,0,0,24,0,0,0,252,255,255,255,252,255,255,255,112,93,0,0,25,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,248,238,2,0,33,59,3,0,248,238,2,0,49,59,3,0,248,238,2,0,68,59,3,0,248,238,2,0,173,59,3,0,236,239,2,0,129,59,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,93,59,3,0,0,0,0,0,1,0,0,0,96,16,0,0,0,0,0,0,180,239,2,0,210,59,3,0,0,0,0,0,120,16,0,0,180,239,2,0,247,59,3,0,1,0,0,0,120,16,0,0,248,238,2,0,52,60,3,0,236,239,2,0,118,60,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,82,60,3,0,0,0,0,0,1,0,0,0,184,16,0,0,0,0,0,0,180,239,2,0,162,60,3,0,0,0,0,0,208,16,0,0,180,239,2,0,199,60,3,0,1,0,0,0,208,16,0,0,236,239,2,0,34,61,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,254,60,3,0,0,0,0,0,1,0,0,0,8,17,0,0,0,0,0,0,180,239,2,0,78,61,3,0,0,0,0,0,32,17,0,0,180,239,2,0,115,61,3,0,1,0,0,0,32,17,0,0,236,239,2,0,222,61,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,170,61,3,0,0,0,0,0,1,0,0,0,88,17,0,0,0,0,0,0,180,239,2,0,26,62,3,0,0,0,0,0,112,17,0,0,180,239,2,0,79,62,3,0,1,0,0,0,112,17,0,0,248,238,2,0,133,62,3,0,236,239,2,0,195,62,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,149,62,3,0,0,0,0,0,1,0,0,0,176,17,0,0,0,0,0,0,180,239,2,0,249,62,3,0,0,0,0,0,200,17,0,0,180,239,2,0,40,63,3,0,1,0,0,0,200,17,0,0,248,238,2,0,88,63,3,0,236,239,2,0,149,63,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,98,63,3,0,0,0,0,0,1,0,0,0,8,18,0,0,0,0,0,0,180,239,2,0,208,63,3,0,0,0,0,0,32,18,0,0,180,239,2,0,4,64,3,0,1,0,0,0,32,18,0,0,236,239,2,0,108,64,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,57,64,3,0,0,0,0,0,1,0,0,0,88,18,0,0,0,0,0,0,180,239,2,0,167,64,3,0,0,0,0,0,112,18,0,0,180,239,2,0,219,64,3,0,1,0,0,0,112,18,0,0,248,238,2,0,16,65,3,0,180,239,2,0,31,65,3,0,0,0,0,0,0,18,0,0,180,239,2,0,42,65,3,0,1,0,0,0,0,18,0,0,248,238,2,0,54,65,3,0,248,238,2,0,103,65,3,0,32,239,2,0,86,65,3,0,216,18,0,0,0,0,0,0,32,239,2,0,69,65,3,0,224,18,0,0,0,0,0,0,248,238,2,0,140,65,3,0,248,238,2,0,171,65,3,0,248,238,2,0,202,65,3,0,248,238,2,0,233,65,3,0,248,238,2,0,8,66,3,0,248,238,2,0,39,66,3,0,248,238,2,0,70,66,3,0,248,238,2,0,123,66,3,0,248,238,2,0,173,66,3,0,248,238,2,0,197,66,3,0,248,238,2,0,216,66,3,0,248,238,2,0,231,66,3,0,248,238,2,0,3,67,3,0,248,238,2,0,28,67,3,0,248,238,2,0,105,67,3,0,236,239,2,0,42,67,3,0,0,0,0,0,1,0,0,0,112,19,0,0,0,0,0,0,248,238,2,0,150,67,3,0,208,239,2,0,23,69,3,0,248,238,2,0,81,70,3,0,180,239,2,0,111,70,3,0,0,0,0,0,216,79,0,0,180,239,2,0,133,70,3,0,1,0,0,0,216,79,0,0,208,239,2,0,156,70,3,0,180,239,2,0,247,70,3,0,0,0,0,0,160,19,0,0,180,239,2,0,22,71,3,0,1,0,0,0,160,19,0,0,32,239,2,0,54,71,3,0,64,27,0,0,0,0,0,0,180,239,2,0,82,71,3,0,0,0,0,0,240,19,0,0,180,239,2,0,111,71,3,0,1,0,0,0,240,19,0,0,180,239,2,0,141,71,3,0,0,0,0,0,48,76,0,0,180,239,2,0,153,71,3,0,1,0,0,0,48,76,0,0,248,238,2,0,187,71,3,0,32,239,2,0,166,71,3,0,64,20,0,0,0,0,0,0,208,239,2,0,220,71,3,0,32,239,2,0,16,72,3,0,240,19,0,0,0,0,0,0,180,239,2,0,48,72,3,0,0,0,0,0,96,20,0,0,180,239,2,0,81,72,3,0,1,0,0,0,96,20,0,0,248,238,2,0,157,72,3,0,32,239,2,0,115,72,3,0,144,20,0,0,0,0,0,0,32,239,2,0,211,72,3,0,64,27,0,0,0,0,0,0,180,239,2,0,223,72,3,0,0,0,0,0,168,20,0,0,180,239,2,0,236,72,3,0,1,0,0,0,168,20,0,0,248,238,2,0,16,73,3,0,32,239,2,0,250,72,3,0,216,20,0,0,0,0,0,0,180,239,2,0,59,73,3,0,0,0,0,0,24,78,0,0,180,239,2,0,76,73,3,0,1,0,0,0,24,78,0,0,248,238,2,0,120,73,3,0,32,239,2,0,94,73,3,0,16,21,0,0,0,0,0,0,180,239,2,0,158,73,3,0,0,0,0,0,64,27,0,0,180,239,2,0,175,73,3,0,1,0,0,0,64,27,0,0,180,239,2,0,193,73,3,0,0,0,0,0,200,78,0,0,180,239,2,0,210,73,3,0,1,0,0,0,200,78,0,0,236,239,2,0,40,74,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,228,73,3,0,0,0,0,0,1,0,0,0,104,21,0,0,0,0,0,0,180,239,2,0,122,74,3,0,0,0,0,0,208,75,0,0,180,239,2,0,143,74,3,0,1,0,0,0,208,75,0,0,248,238,2,0,195,74,3,0,32,239,2,0,165,74,3,0,184,21,0,0,0,0,0,0,180,239,2,0,15,75,3,0,0,0,0,0,8,78,0,0,180,239,2,0,41,75,3,0,1,0,0,0,8,78,0,0,236,239,2,0,134,75,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,68,75,3,0,0,0,0,0,1,0,0,0,240,21,0,0,0,0,0,0,248,238,2,0,44,76,3,0,32,239,2,0,9,76,3,0,32,22,0,0,0,0,0,0,236,239,2,0,140,76,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,91,76,3,0,0,0,0,0,1,0,0,0,56,22,0,0,0,0,0,0,180,239,2,0,197,76,3,0,0,0,0,0,208,77,0,0,180,239,2,0,209,76,3,0,1,0,0,0,208,77,0,0,248,238,2,0,243,76,3,0,32,239,2,0,222,76,3,0,136,22,0,0,0,0,0,0,236,239,2,0,146,77,3,0,0,0,0,0,1,0,0,0,88,16,0,0,0,0,0,0,236,239,2,0,77,77,3,0,0,0,0,0,1,0,0,0,160,22,0,0,0,0,0,0,180,239,2,0,229,77,3,0,0,0,0,0,152,78,0,0,180,239,2,0,2,78,3,0,1,0,0,0,152,78,0,0,248,238,2,0,70,78,3,0,32,239,2,0,32,78,3,0,240,22,0,0,0,0,0,0,208,239,2,0,120,78,3,0,248,238,2,0,162,78,3,0,180,239,2,0,187,78,3,0,0,0,0,0,16,23,0,0,180,239,2,0,213,78,3,0,1,0,0,0,16,23,0,0,180,239,2,0,64,79,3,0,0,0,0,0,0,76,0,0,180,239,2,0,92,79,3,0,1,0,0,0,0,76,0,0,248,238,2,0,158,79,3,0,32,239,2,0,121,79,3,0,88,23,0,0,0,0,0,0,208,239,2,0,207,79,3,0,180,239,2,0,248,79,3,0,0,0,0,0,192,76,0,0,180,239,2,0,5,80,3,0,1,0,0,0,192,76,0,0,208,239,2,0,19,80,3,0,248,238,2,0,69,80,3,0,32,239,2,0,47,80,3,0,160,23,0,0,0,0,0,0,180,239,2,0,137,80,3,0,0,0,0,0,144,76,0,0,180,239,2,0,148,80,3,0,1,0,0,0,144,76,0,0,248,238,2,0,180,80,3,0,32,239,2,0,160,80,3,0,216,23,0,0,0,0,0,0,208,239,2,0,212,80,3,0,180,239,2,0,44,81,3,0,0,0,0,0,112,76,0,0,180,239,2,0,57,81,3,0,1,0,0,0,112,76,0,0,248,238,2,0,93,81,3,0,32,239,2,0,71,81,3,0,24,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,44,180,41,188,166,23,185,63,10,166,105,60,184,248,200,63,5,159,213,46,6,148,210,63,99,169,174,166,226,125,216,63,59,246,6,56,93,43,222,63,200,104,174,57,59,199,225,63,214,29,9,37,243,76,228,63,204,59,127,102,158,160,230,63,65,23,21,107,128,188,232,63,163,161,14,41,102,155,234,63,176,189,128,241,178,56,236,63,70,141,50,207,107,144,237,63,219,45,198,86,65,159,238,63,176,92,247,207,151,98,239,63,37,37,209,163,141,216,239,63,0,0,0,0,0,0,240,63,38,37,209,163,141,216,239,63,176,92,247,207,151,98,239,63,219,45,198,86,65,159,238,63,70,141,50,207,107,144,237,63,177,189,128,241,178,56,236,63,165,161,14,41,102,155,234,63,66,23,21,107,128,188,232,63,205,59,127,102,158,160,230,63,214,29,9,37,243,76,228,63,200,104,174,57,59,199,225,63,63,246,6,56,93,43,222,63,101,169,174,166,226,125,216,63,6,159,213,46,6,148,210,63,23,166,105,60,184,248,200,63,60,180,41,188,166,23,185,63,159,113,189,255,249,165,161,60,43,180,41,188,166,23,185,191,14,166,105,60,184,248,200,191,1,159,213,46,6,148,210,191,97,169,174,166,226,125,216,191,59,246,6,56,93,43,222,191,198,104,174,57,59,199,225,191,212,29,9,37,243,76,228,191,204,59,127,102,158,160,230,191,62,23,21,107,128,188,232,191,163,161,14,41,102,155,234,191,176,189,128,241,178,56,236,191,68,141,50,207,107,144,237,191,218,45,198,86,65,159,238,191,175,92,247,207,151,98,239,191,38,37,209,163,141,216,239,191,0,0,0,0,0,0,240,191,38,37,209,163,141,216,239,191,176,92,247,207,151,98,239,191,219,45,198,86,65,159,238,191,69,141,50,207,107,144,237,191,177,189,128,241,178,56,236,191,165,161,14,41,102,155,234,191,64,23,21,107,128,188,232,191,206,59,127,102,158,160,230,191,218,29,9,37,243,76,228,191,200,104,174,57,59,199,225,191,64,246,6,56,93,43,222,191,110,169,174,166,226,125,216,191,8,159,213,46,6,148,210,191,27,166,105,60,184,248,200,191,37,180,41,188,166,23,185,191,32,239,2,0,131,90,3,0,168,98,0,0,0,0,0,0,248,238,2,0,185,95,3,0,64,0,0,0,0,0,0,0,64,93,0,0,11,0,0,0,12,0,0,0,192,255,255,255,192,255,255,255,64,93,0,0,13,0,0,0,14,0,0,0,64,0,0,0,0,0,0,0,160,93,0,0,17,0,0,0,18,0,0,0,56,0,0,0,248,255,255,255,160,93,0,0,19,0,0,0,20,0,0,0,192,255,255,255,192,255,255,255,160,93,0,0,21,0,0,0,22,0,0,0,0,0,0,0,32,239,2,0,50,95,3,0,48,93,0,0,0,0,0,0,32,239,2,0,116,95,3,0,160,93,0,0,0,0,0,0,248,238,2,0,230,115,3,0,56,0,0,0,0,0,0,0,112,93,0,0,23,0,0,0,24,0,0,0,200,255,255,255,200,255,255,255,112,93,0,0,25,0,0,0,26,0,0,0,32,239,2,0,160,115,3,0,112,93,0,0,0,0,0,0,236,239,2,0,46,117,3,0,0,0,0,0,1,0,0,0,64,26,0,0,0,0,0,0,236,239,2,0,91,117,3,0,0,0,0,0,1,0,0,0,64,26,0,0,0,0,0,0,248,238,2,0,163,123,3,0,32,239,2,0,1,126,3,0,72,32,0,0,0,0,0,0,32,239,2,0,37,126,3,0,72,32,0,0,0,0,0,0,32,239,2,0,73,126,3,0,72,32,0,0,0,0,0,0,236,239,2,0,61,127,3,0,0,0,0,0,1,0,0,0,64,26,0,0,0,0,0,0,248,238,2,0,220,127,3,0,248,238,2,0,56,158,3,0,32,239,2,0,207,157,3,0,152,27,0,0,0,0,0,0,32,239,2,0,44,157,3,0,152,27,0,0,0,0,0,0,32,239,2,0,185,157,3,0,152,27,0,0,0,0,0,0,32,239,2,0,227,157,3,0,152,27,0,0,0,0,0,0,32,239,2,0,23,158,3,0,152,27,0,0,0,0,0,0,32,239,2,0,7,158,3,0,152,27,0,0,0,0,0,0,32,239,2,0,42,158,3,0,152,27,0,0,0,0,0,0,32,239,2,0,68,158,3,0,152,27,0,0,0,0,0,0,32,239,2,0,116,158,3,0,152,27,0,0,0,0,0,0,248,238,2,0,4,160,3,0,32,239,2,0,141,158,3,0,144,27,0,0,0,0,0,0,32,239,2,0,88,159,3,0,48,28,0,0,0,0,0,0,32,239,2,0,130,165,3,0,144,98,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,205,59,127,102,158,160,230,63,204,59,127,102,158,160,230,63,70,141,50,207,107,144,237,63,99,169,174,166,226,125,216,63,176,92,247,207,151,98,239,63,10,166,105,60,184,248,200,63,38,37,209,163,141,216,239,63,44,180,41,188,166,23,185,63,126,109,121,227,33,246,239,63,21,216,13,241,101,31,169,63,13,205,132,96,136,253,239,63,127,102,163,247,85,33,153,63,219,146,155,22,98,255,239,63,135,199,222,252,209,33,137,63,146,138,142,133,216,255,239,63,118,0,103,254,240,33,121,63,2,29,98,33,246,255,239,63,195,164,204,190,248,33,105,63,230,110,88,136,253,255,239,63,66,71,230,174,250,33,89,63,52,26,22,98,255,255,239,63,55,179,236,42,251,33,73,63,117,134,133,216,255,255,239,63,248,78,238,73,251,33,57,63,156,97,33,246,255,255,239,63,2,181,174,81,251,33,41,63,103,88,136,253,255,255,239,63,245,207,158,83,251,33,25,63,26,22,98,255,255,255,239,63,106,215,26,84,251,33,9,63,134,133,216,255,255,255,239,63,72,217,57,84,251,33,249,62,98,33,246,255,255,255,239,63,78,152,65,84,251,33,233,62,88,136,253,255,255,255,239,63,136,124,67,84,251,33,217,62,22,98,255,255,255,255,239,63,196,216,67,84,251,33,201,62,134,216,255,255,255,255,239,63,0,53,68,84,251,33,185,62,33,246,255,255,255,255,239,63,136,124,67,84,251,33,169,62,136,253,255,255,255,255,239,63,136,124,67,84,251,33,153,62,98,255,255,255,255,255,239,63,103,94,70,84,251,33,137,62,217,255,255,255,255,255,239,63,169,154,64,84,251,33,121,62,246,255,255,255,255,255,239,63,36,34,76,84,251,33,105,62,254,255,255,255,255,255,239,63,36,34,76,84,251,33,89,62,255,255,255,255,255,255,239,63,58,4,30,84,251,33,73,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,57,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,41,62,32,239,2,0,77,167,3,0,120,30,0,0,0,0,0,0,248,238,2,0,100,167,3,0,32,239,2,0,116,167,3,0,120,30,0,0,0,0,0,0,32,239,2,0,119,168,3,0,144,98,0,0,0,0,0,0,32,239,2,0,214,168,3,0,176,30,0,0,0,0,0,0,248,238,2,0,232,168,3,0,32,239,2,0,248,168,3,0,176,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,192,0,0,0,0,0,0,224,193,0,0,0,224,255,255,239,199,255,255,255,255,255,255,239,255,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,224,255,239,64,0,0,0,0,192,255,223,64,0,0,192,255,255,255,223,65,0,0,0,224,255,255,239,71,255,255,255,255,255,255,239,127,0,0,0,0,0,0,0,0,248,238,2,0,9,176,3,0,248,238,2,0,25,176,3,0,32,239,2,0,16,177,3,0,136,31,0,0,0,0,0,0,32,239,2,0,179,176,3,0,72,31,0,0,0,0,0,0,32,239,2,0,200,176,3,0,144,98,0,0,0,0,0,0,32,239,2,0,39,177,3,0,80,31,0,0,0,0,0,0,32,239,2,0,60,177,3,0,136,31,0,0,0,0,0,0,32,239,2,0,85,177,3,0,136,31,0,0,0,0,0,0,32,239,2,0,179,177,3,0,136,31,0,0,0,0,0,0,32,239,2,0,208,177,3,0,136,31,0,0,0,0,0,0,32,239,2,0,226,177,3,0,136,31,0,0,0,0,0,0,32,239,2,0,250,177,3,0,144,98,0,0,0,0,0,0,32,239,2,0,68,178,3,0,144,98,0,0,0,0,0,0,32,239,2,0,139,178,3,0,144,98,0,0,0,0,0,0,32,239,2,0,213,178,3,0,144,98,0,0,0,0,0,0,32,239,2,0,30,179,3,0,144,98,0,0,0,0,0,0,32,239,2,0,99,179,3,0,144,98,0,0,0,0,0,0,248,238,2,0,68,180,3,0,248,238,2,0,101,188,3,0,32,239,2,0,95,187,3,0,144,98,0,0,0,0,0,0,248,238,2,0,120,188,3,0,32,239,2,0,153,192,3,0,104,32,0,0,0,0,0,0,32,239,2,0,177,192,3,0,144,98,0,0,0,0,0,0,32,239,2,0,183,199,3,0,160,32,0,0,0,0,0,0,248,238,2,0,201,199,3,0,32,239,2,0,227,199,3,0,144,98,0,0,0,0,0,0,32,239,2,0,194,203,3,0,200,32,0,0,0,0,0,0,248,238,2,0,210,203,3,0,32,239,2,0,235,203,3,0,144,98,0,0,0,0,0,0,32,239,2,0,153,204,3,0,160,32,0,0,0,0,0,0,32,239,2,0,172,204,3,0,144,98,0,0,0,0,0,0,32,239,2,0,139,207,3,0,200,32,0,0,0,0,0,0,32,239,2,0,157,207,3,0,144,98,0,0,0,0,0,0,32,239,2,0,145,210,3,0,160,32,0,0,0,0,0,0,32,239,2,0,164,210,3,0,144,98,0,0,0,0,0,0,32,239,2,0,54,214,3,0,200,32,0,0,0,0,0,0,32,239,2,0,72,214,3,0,144,98,0,0,0,0,0,0,32,239,2,0,99,216,3,0,72,32,0,0,0,0,0,0,32,239,2,0,133,216,3,0,72,32,0,0,0,0,0,0,32,239,2,0,109,217,3,0,72,32,0,0,0,0,0,0,248,238,2,0,34,226,3,0,248,238,2,0,55,226,3,0,248,238,2,0,79,226,3,0,248,238,2,0,236,227,3,0,32,239,2,0,145,229,3,0,144,33,0,0,0,0,0,0,32,239,2,0,178,229,3,0,144,98,0,0,0,0,0,0,32,239,2,0,7,230,3,0,144,33,0,0,0,0,0,0,32,239,2,0,40,230,3,0,144,98,0,0,0,0,0,0,32,239,2,0,125,230,3,0,144,33,0,0,0,0,0,0,32,239,2,0,158,230,3,0,144,98,0,0,0,0,0,0,32,239,2,0,243,230,3,0,144,33,0,0,0,0,0,0,32,239,2,0,20,231,3,0,144,98,0,0,0,0,0,0,32,239,2,0,105,231,3,0,144,33,0,0,0,0,0,0,32,239,2,0,138,231,3,0,144,98,0,0,0,0,0,0,32,239,2,0,223,231,3,0,144,33,0,0,0,0,0,0,32,239,2,0,0,232,3,0,144,98,0,0,0,0,0,0,32,239,2,0,85,232,3,0,144,33,0,0,0,0,0,0,32,239,2,0,118,232,3,0,144,98,0,0,0,0,0,0,32,239,2,0,203,232,3,0,144,33,0,0,0,0,0,0,32,239,2,0,236,232,3,0,144,98,0,0,0,0,0,0,32,239,2,0,65,233,3,0,144,33,0,0,0,0,0,0,32,239,2,0,98,233,3,0,144,98,0,0,0,0,0,0,32,239,2,0,183,233,3,0,144,33,0,0,0,0,0,0,32,239,2,0,216,233,3,0,144,98,0,0,0,0,0,0,32,239,2,0,149,234,3,0,144,33,0,0,0,0,0,0,32,239,2,0,192,234,3,0,240,34,0,0,0,0,0,0,32,239,2,0,245,234,3,0,144,98,0,0,0,0,0,0,32,239,2,0,94,235,3,0,144,33,0,0,0,0,0,0,32,239,2,0,137,235,3,0,32,35,0,0,0,0,0,0,32,239,2,0,190,235,3,0,144,98,0,0,0,0,0,0,32,239,2,0,54,237,3,0,152,33,0,0,0,0,0,0,32,239,2,0,106,237,3,0,80,35,0,0,0,0,0,0,32,239,2,0,162,237,3,0,144,98,0,0,0,0,0,0,32,239,2,0,15,238,3,0,152,33,0,0,0,0,0,0,32,239,2,0,67,238,3,0,128,35,0,0,0,0,0,0,32,239,2,0,123,238,3,0,144,98,0,0,0,0,0,0,32,239,2,0,232,238,3,0,152,33,0,0,0,0,0,0,32,239,2,0,28,239,3,0,176,35,0,0,0,0,0,0,32,239,2,0,84,239,3,0,144,98,0,0,0,0,0,0,32,239,2,0,193,239,3,0,152,33,0,0,0,0,0,0,32,239,2,0,245,239,3,0,224,35,0,0,0,0,0,0,32,239,2,0,45,240,3,0,144,98,0,0,0,0,0,0,32,239,2,0,154,240,3,0,152,33,0,0,0,0,0,0,32,239,2,0,206,240,3,0,16,36,0,0,0,0,0,0,32,239,2,0,97,241,3,0,144,98,0,0,0,0,0,0,32,239,2,0,206,241,3,0,152,33,0,0,0,0,0,0,32,239,2,0,2,242,3,0,64,36,0,0,0,0,0,0,32,239,2,0,58,242,3,0,144,98,0,0,0,0,0,0,32,239,2,0,167,242,3,0,152,33,0,0,0,0,0,0,32,239,2,0,219,242,3,0,112,36,0,0,0,0,0,0,32,239,2,0,19,243,3,0,144,98,0,0,0,0,0,0,32,239,2,0,128,243,3,0,152,33,0,0,0,0,0,0,32,239,2,0,180,243,3,0,160,36,0,0,0,0,0,0,32,239,2,0,236,243,3,0,144,98,0,0,0,0,0,0,32,239,2,0,89,244,3,0,152,33,0,0,0,0,0,0,32,239,2,0,141,244,3,0,208,36,0,0,0,0,0,0,32,239,2,0,197,244,3,0,144,98,0,0,0,0,0,0,32,239,2,0,50,245,3,0,152,33,0,0,0,0,0,0,32,239,2,0,112,245,3,0,0,37,0,0,0,0,0,0,32,239,2,0,178,245,3,0,144,98,0,0,0,0,0,0,32,239,2,0,80,246,3,0,152,33,0,0,0,0,0,0,32,239,2,0,141,246,3,0,80,37,0,0,0,0,0,0,32,239,2,0,211,246,3,0,48,37,0,0,0,0,0,0,32,239,2,0,20,247,3,0,144,98,0,0,0,0,0,0,32,239,2,0,143,247,3,0,152,33,0,0,0,0,0,0,32,239,2,0,204,247,3,0,144,37,0,0,0,0,0,0,32,239,2,0,18,248,3,0,112,37,0,0,0,0,0,0,32,239,2,0,83,248,3,0,144,98,0,0,0,0,0,0,32,239,2,0,206,248,3,0,16,37,0,0,0,0,0,0,32,239,2,0,21,249,3,0,144,98,0,0,0,0,0,0,32,239,2,0,145,249,3,0,144,98,0,0,0,0,0,0,32,239,2,0,250,249,3,0,144,98,0,0,0,0,0,0,32,239,2,0,99,250,3,0,144,98,0,0,0,0,0,0,32,239,2,0,204,250,3,0,144,98,0,0,0,0,0,0,32,239,2,0,53,251,3,0,144,98,0,0,0,0,0,0,32,239,2,0,158,251,3,0,144,98,0,0,0,0,0,0,32,239,2,0,7,252,3,0,144,98,0,0,0,0,0,0,32,239,2,0,112,252,3,0,144,98,0,0,0,0,0,0,32,239,2,0,217,252,3,0,144,98,0,0,0,0,0,0,32,239,2,0,176,253,3,0,144,98,0,0,0,0,0,0,32,239,2,0,36,255,3,0,160,33,0,0,0,0,0,0,32,239,2,0,84,255,3,0,144,98,0,0,0,0,0,0,32,239,2,0,185,255,3,0,160,33,0,0,0,0,0,0,32,239,2,0,233,255,3,0,144,98,0,0,0,0,0,0,32,239,2,0,78,0,4,0,160,33,0,0,0,0,0,0,32,239,2,0,126,0,4,0,144,98,0,0,0,0,0,0,32,239,2,0,227,0,4,0,160,33,0,0,0,0,0,0,32,239,2,0,19,1,4,0,144,98,0,0,0,0,0,0,32,239,2,0,120,1,4,0,160,33,0,0,0,0,0,0,32,239,2,0,168,1,4,0,144,98,0,0,0,0,0,0,32,239,2,0,13,2,4,0,160,33,0,0,0,0,0,0,32,239,2,0,61,2,4,0,144,98,0,0,0,0,0,0,32,239,2,0,162,2,4,0,160,33,0,0,0,0,0,0,32,239,2,0,210,2,4,0,144,98,0,0,0,0,0,0,32,239,2,0,55,3,4,0,160,33,0,0,0,0,0,0,32,239,2,0,103,3,4,0,144,98,0,0,0,0,0,0,32,239,2,0,204,3,4,0,160,33,0,0,0,0,0,0,32,239,2,0,252,3,4,0,144,98,0,0,0,0,0,0,32,239,2,0,97,4,4,0,160,33,0,0,0,0,0,0,32,239,2,0,145,4,4,0,144,98,0,0,0,0,0,0,32,239,2,0,246,4,4,0,160,33,0,0,0,0,0,0,32,239,2,0,38,5,4,0,144,98,0,0,0,0,0,0,32,239,2,0,139,5,4,0,160,33,0,0,0,0,0,0,32,239,2,0,187,5,4,0,144,98,0,0,0,0,0,0,32,239,2,0,32,6,4,0,160,33,0,0,0,0,0,0,32,239,2,0,80,6,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([144,98,0,0,0,0,0,0,32,239,2,0,200,6,4,0,144,98,0,0,0,0,0,0,32,239,2,0,169,9,4,0,72,32,0,0,0,0,0,0,32,239,2,0,62,10,4,0,72,32,0,0,0,0,0,0,32,239,2,0,170,10,4,0,72,32,0,0,0,0,0,0,32,239,2,0,22,11,4,0,72,32,0,0,0,0,0,0,32,239,2,0,130,11,4,0,72,32,0,0,0,0,0,0,32,239,2,0,251,11,4,0,72,32,0,0,0,0,0,0,32,239,2,0,127,12,4,0,72,32,0,0,0,0,0,0,32,239,2,0,3,13,4,0,72,32,0,0,0,0,0,0,32,239,2,0,135,13,4,0,72,32,0,0,0,0,0,0,32,239,2,0,11,14,4,0,72,32,0,0,0,0,0,0,32,239,2,0,159,14,4,0,72,32,0,0,0,0,0,0,32,239,2,0,17,15,4,0,72,32,0,0,0,0,0,0,32,239,2,0,131,15,4,0,72,32,0,0,0,0,0,0,32,239,2,0,245,15,4,0,72,32,0,0,0,0,0,0,32,239,2,0,103,16,4,0,72,32,0,0,0,0,0,0,32,239,2,0,230,16,4,0,72,32,0,0,0,0,0,0,32,239,2,0,4,17,4,0,72,32,0,0,0,0,0,0,32,239,2,0,34,17,4,0,72,32,0,0,0,0,0,0,32,239,2,0,64,17,4,0,72,32,0,0,0,0,0,0,32,239,2,0,94,17,4,0,72,32,0,0,0,0,0,0,32,239,2,0,124,17,4,0,72,32,0,0,0,0,0,0,32,239,2,0,187,17,4,0,72,32,0,0,0,0,0,0,32,239,2,0,2,18,4,0,72,32,0,0,0,0,0,0,32,239,2,0,91,18,4,0,72,32,0,0,0,0,0,0,32,239,2,0,180,18,4,0,72,32,0,0,0,0,0,0,32,239,2,0,13,19,4,0,72,32,0,0,0,0,0,0,32,239,2,0,36,19,4,0,72,32,0,0,0,0,0,0,32,239,2,0,102,19,4,0,72,32,0,0,0,0,0,0,32,239,2,0,168,19,4,0,72,32,0,0,0,0,0,0,32,239,2,0,235,19,4,0,72,32,0,0,0,0,0,0,32,239,2,0,45,20,4,0,72,32,0,0,0,0,0,0,32,239,2,0,69,21,4,0,72,32,0,0,0,0,0,0,32,239,2,0,59,26,4,0,72,32,0,0,0,0,0,0,32,239,2,0,75,26,4,0,72,32,0,0,0,0,0,0,32,239,2,0,149,30,4,0,72,32,0,0,0,0,0,0,32,239,2,0,175,30,4,0,72,32,0,0,0,0,0,0,32,239,2,0,191,34,4,0,72,32,0,0,0,0,0,0,32,239,2,0,10,35,4,0,72,32,0,0,0,0,0,0,32,239,2,0,85,35,4,0,72,32,0,0,0,0,0,0,32,239,2,0,148,35,4,0,72,32,0,0,0,0,0,0,32,239,2,0,211,35,4,0,72,32,0,0,0,0,0,0,32,239,2,0,19,36,4,0,72,32,0,0,0,0,0,0,32,239,2,0,155,41,4,0,168,20,0,0,0,0,0,0,32,239,2,0,59,39,4,0,72,32,0,0,0,0,0,0,32,239,2,0,109,39,4,0,144,98,0,0,0,0,0,0,32,239,2,0,210,39,4,0,72,32,0,0,0,0,0,0,32,239,2,0,4,40,4,0,144,98,0,0,0,0,0,0,32,239,2,0,105,40,4,0,72,32,0,0,0,0,0,0,32,239,2,0,157,40,4,0,144,98,0,0,0,0,0,0,32,239,2,0,4,41,4,0,72,32,0,0,0,0,0,0,32,239,2,0,54,41,4,0,144,98,0,0,0,0,0,0,32,239,2,0,184,41,4,0,144,98,0,0,0,0,0,0,32,239,2,0,239,42,4,0,72,32,0,0,0,0,0,0,32,239,2,0,233,50,4,0,144,33,0,0,0,0,0,0,32,239,2,0,250,50,4,0,144,33,0,0,0,0,0,0,32,239,2,0,11,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,28,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,45,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,62,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,79,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,96,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,113,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,130,51,4,0,144,33,0,0,0,0,0,0,32,239,2,0,147,51,4,0,144,98,0,0,0,0,0,0,32,239,2,0,215,51,4,0,144,98,0,0,0,0,0,0,32,239,2,0,27,52,4,0,144,98,0,0,0,0,0,0,32,239,2,0,95,52,4,0,144,98,0,0,0,0,0,0,32,239,2,0,163,52,4,0,144,98,0,0,0,0,0,0,32,239,2,0,231,52,4,0,144,98,0,0,0,0,0,0,32,239,2,0,43,53,4,0,144,98,0,0,0,0,0,0,32,239,2,0,111,53,4,0,144,98,0,0,0,0,0,0,32,239,2,0,179,53,4,0,144,98,0,0,0,0,0,0,32,239,2,0,247,53,4,0,144,98,0,0,0,0,0,0,32,239,2,0,213,54,4,0,152,33,0,0,0,0,0,0,32,239,2,0,233,54,4,0,144,98,0,0,0,0,0,0,32,239,2,0,48,55,4,0,152,33,0,0,0,0,0,0,32,239,2,0,68,55,4,0,144,98,0,0,0,0,0,0,32,239,2,0,139,55,4,0,152,33,0,0,0,0,0,0,32,239,2,0,159,55,4,0,144,98,0,0,0,0,0,0,32,239,2,0,230,55,4,0,152,33,0,0,0,0,0,0,32,239,2,0,250,55,4,0,144,98,0,0,0,0,0,0,32,239,2,0,65,56,4,0,152,33,0,0,0,0,0,0,32,239,2,0,85,56,4,0,144,98,0,0,0,0,0,0,32,239,2,0,156,56,4,0,152,33,0,0,0,0,0,0,32,239,2,0,176,56,4,0,144,98,0,0,0,0,0,0,32,239,2,0,247,56,4,0,152,33,0,0,0,0,0,0,32,239,2,0,11,57,4,0,144,98,0,0,0,0,0,0,32,239,2,0,82,57,4,0,152,33,0,0,0,0,0,0,32,239,2,0,102,57,4,0,144,98,0,0,0,0,0,0,32,239,2,0,173,57,4,0,152,33,0,0,0,0,0,0,32,239,2,0,193,57,4,0,144,98,0,0,0,0,0,0,32,239,2,0,8,58,4,0,152,33,0,0,0,0,0,0,32,239,2,0,28,58,4,0,144,98,0,0,0,0,0,0,32,239,2,0,99,58,4,0,152,33,0,0,0,0,0,0,32,239,2,0,119,58,4,0,144,98,0,0,0,0,0,0,32,239,2,0,190,58,4,0,152,33,0,0,0,0,0,0,32,239,2,0,210,58,4,0,144,98,0,0,0,0,0,0,32,239,2,0,44,59,4,0,144,33,0,0,0,0,0,0,32,239,2,0,64,59,4,0,144,33,0,0,0,0,0,0,32,239,2,0,84,59,4,0,144,33,0,0,0,0,0,0,32,239,2,0,104,59,4,0,144,33,0,0,0,0,0,0,32,239,2,0,124,59,4,0,144,33,0,0,0,0,0,0,32,239,2,0,144,59,4,0,144,98,0,0,0,0,0,0,32,239,2,0,215,59,4,0,144,98,0,0,0,0,0,0,32,239,2,0,30,60,4,0,144,98,0,0,0,0,0,0,32,239,2,0,101,60,4,0,144,98,0,0,0,0,0,0,32,239,2,0,172,60,4,0,144,98,0,0,0,0,0,0,32,239,2,0,85,62,4,0,72,32,0,0,0,0,0,0,32,239,2,0,120,62,4,0,72,32,0,0,0,0,0,0,32,239,2,0,52,105,5,0,72,32,0,0,0,0,0,0,32,239,2,0,128,105,5,0,72,32,0,0,0,0,0,0,32,239,2,0,202,105,5,0,72,32,0,0,0,0,0,0,32,239,2,0,19,106,5,0,72,32,0,0,0,0,0,0,32,239,2,0,104,106,5,0,72,32,0,0,0,0,0,0,32,239,2,0,16,107,5,0,72,32,0,0,0,0,0,0,32,239,2,0,97,107,5,0,72,32,0,0,0,0,0,0,32,239,2,0,176,107,5,0,72,32,0,0,0,0,0,0,32,239,2,0,254,107,5,0,72,32,0,0,0,0,0,0,32,239,2,0,88,108,5,0,72,32,0,0,0,0,0,0,32,239,2,0,116,109,5,0,72,32,0,0,0,0,0,0,32,239,2,0,37,110,5,0,72,32,0,0,0,0,0,0,32,239,2,0,82,110,5,0,72,32,0,0,0,0,0,0,32,239,2,0,127,110,5,0,72,32,0,0,0,0,0,0,32,239,2,0,173,110,5,0,72,32,0,0,0,0,0,0,32,239,2,0,219,110,5,0,72,32,0,0,0,0,0,0,32,239,2,0,9,111,5,0,72,32,0,0,0,0,0,0,32,239,2,0,55,111,5,0,72,32,0,0,0,0,0,0,32,239,2,0,101,111,5,0,72,32,0,0,0,0,0,0,32,239,2,0,147,111,5,0,72,32,0,0,0,0,0,0,32,239,2,0,193,111,5,0,72,32,0,0,0,0,0,0,32,239,2,0,239,111,5,0,72,32,0,0,0,0,0,0,32,239,2,0,30,112,5,0,72,32,0,0,0,0,0,0,32,239,2,0,77,112,5,0,72,32,0,0,0,0,0,0,32,239,2,0,126,112,5,0,72,32,0,0,0,0,0,0,32,239,2,0,191,121,5,0,144,33,0,0,0,0,0,0,32,239,2,0,247,121,5,0,144,33,0,0,0,0,0,0,32,239,2,0,47,122,5,0,144,33,0,0,0,0,0,0,32,239,2,0,103,122,5,0,144,33,0,0,0,0,0,0,32,239,2,0,159,122,5,0,144,33,0,0,0,0,0,0,32,239,2,0,215,122,5,0,144,33,0,0,0,0,0,0,32,239,2,0,15,123,5,0,144,33,0,0,0,0,0,0,32,239,2,0,71,123,5,0,144,33,0,0,0,0,0,0,32,239,2,0,127,123,5,0,144,33,0,0,0,0,0,0,32,239,2,0,183,123,5,0,144,33,0,0,0,0,0,0,32,239,2,0,239,123,5,0,144,98,0,0,0,0,0,0,32,239,2,0,92,124,5,0,144,98,0,0,0,0,0,0,32,239,2,0,201,124,5,0,144,98,0,0,0,0,0,0,32,239,2,0,54,125,5,0,144,98,0,0,0,0,0,0,32,239,2,0,163,125,5,0,144,98,0,0,0,0,0,0,32,239,2,0,16,126,5,0,144,98,0,0,0,0,0,0,32,239,2,0,125,126,5,0,144,98,0,0,0,0,0,0,32,239,2,0,234,126,5,0,144,98,0,0,0,0,0,0,32,239,2,0,87,127,5,0,144,98,0,0,0,0,0,0,32,239,2,0,196,127,5,0,144,98,0,0,0,0,0,0,32,239,2,0,75,128,5,0,152,33,0,0,0,0,0,0,32,239,2,0,137,128,5,0,152,33,0,0,0,0,0,0,32,239,2,0,199,128,5,0,152,33,0,0,0,0,0,0,32,239,2,0,5,129,5,0,152,33,0,0,0,0,0,0,32,239,2,0,67,129,5,0,152,33,0,0,0,0,0,0,32,239,2,0,129,129,5,0,152,33,0,0,0,0,0,0,32,239,2,0,191,129,5,0,152,33,0,0,0,0,0,0,32,239,2,0,253,129,5,0,152,33,0,0,0,0,0,0,32,239,2,0,59,130,5,0,152,33,0,0,0,0,0,0,32,239,2,0,121,130,5,0,152,33,0,0,0,0,0,0,32,239,2,0,183,130,5,0,144,98,0,0,0,0,0,0,32,239,2,0,42,131,5,0,144,98,0,0,0,0,0,0,32,239,2,0,157,131,5,0,144,98,0,0,0,0,0,0,32,239,2,0,16,132,5,0,144,98,0,0,0,0,0,0,32,239,2,0,131,132,5,0,144,98,0,0,0,0,0,0,32,239,2,0,246,132,5,0,144,98,0,0,0,0,0,0,32,239,2,0,105,133,5,0,144,98,0,0,0,0,0,0,32,239,2,0,220,133,5,0,144,98,0,0,0,0,0,0,32,239,2,0,79,134,5,0,144,98,0,0,0,0,0,0,32,239,2,0,194,134,5,0,144,98,0,0,0,0,0,0,32,239,2,0,255,135,5,0,160,33,0,0,0,0,0,0,32,239,2,0,49,136,5,0,144,98,0,0,0,0,0,0,32,239,2,0,152,136,5,0,160,33,0,0,0,0,0,0,32,239,2,0,202,136,5,0,144,98,0,0,0,0,0,0,32,239,2,0,49,137,5,0,160,33,0,0,0,0,0,0,32,239,2,0,99,137,5,0,144,98,0,0,0,0,0,0,32,239,2,0,202,137,5,0,160,33,0,0,0,0,0,0,32,239,2,0,252,137,5,0,144,98,0,0,0,0,0,0,32,239,2,0,99,138,5,0,160,33,0,0,0,0,0,0,32,239,2,0,149,138,5,0,144,98,0,0,0,0,0,0,32,239,2,0,252,138,5,0,160,33,0,0,0,0,0,0,32,239,2,0,46,139,5,0,144,98,0,0,0,0,0,0,32,239,2,0,149,139,5,0,160,33,0,0,0,0,0,0,32,239,2,0,199,139,5,0,144,98,0,0,0,0,0,0,32,239,2,0,46,140,5,0,160,33,0,0,0,0,0,0,32,239,2,0,96,140,5,0,144,98,0,0,0,0,0,0,32,239,2,0,199,140,5,0,160,33,0,0,0,0,0,0,32,239,2,0,249,140,5,0,144,98,0,0,0,0,0,0,32,239,2,0,96,141,5,0,160,33,0,0,0,0,0,0,32,239,2,0,146,141,5,0,144,98,0,0,0,0,0,0,32,239,2,0,127,143,5,0,72,32,0,0,0,0,0,0,32,239,2,0,174,143,5,0,72,32,0,0,0,0,0,0,32,239,2,0,221,143,5,0,72,32,0,0,0,0,0,0,32,239,2,0,12,144,5,0,72,32,0,0,0,0,0,0,32,239,2,0,59,144,5,0,72,32,0,0,0,0,0,0,32,239,2,0,106,144,5,0,72,32,0,0,0,0,0,0,32,239,2,0,153,144,5,0,72,32,0,0,0,0,0,0,32,239,2,0,197,144,5,0,72,32,0,0,0,0,0,0,32,239,2,0,7,146,5,0,72,32,0,0,0,0,0,0,32,239,2,0,155,146,5,0,72,32,0,0,0,0,0,0,32,239,2,0,82,147,5,0,72,32,0,0,0,0,0,0,32,239,2,0,126,147,5,0,72,32,0,0,0,0,0,0,32,239,2,0,183,147,5,0,72,32,0,0,0,0,0,0,32,239,2,0,227,147,5,0,72,32,0,0,0,0,0,0,32,239,2,0,9,156,5,0,72,32,0,0,0,0,0,0,32,239,2,0,67,156,5,0,72,32,0,0,0,0,0,0,32,239,2,0,126,156,5,0,72,32,0,0,0,0,0,0,32,239,2,0,164,156,5,0,72,32,0,0,0,0,0,0,32,239,2,0,74,160,5,0,144,98,0,0,0,0,0,0,32,239,2,0,221,163,5,0,72,32,0,0,0,0,0,0,32,239,2,0,241,163,5,0,72,32,0,0,0,0,0,0,32,239,2,0,97,164,5,0,72,32,0,0,0,0,0,0,32,239,2,0,147,164,5,0,72,32,0,0,0,0,0,0,32,239,2,0,197,164,5,0,72,32,0,0,0,0,0,0,32,239,2,0,247,164,5,0,72,32,0,0,0,0,0,0,32,239,2,0,41,165,5,0,72,32,0,0,0,0,0,0,32,239,2,0,91,165,5,0,72,32,0,0,0,0,0,0,32,239,2,0,21,166,5,0,72,32,0,0,0,0,0,0,32,239,2,0,63,166,5,0,72,32,0,0,0,0,0,0,32,239,2,0,105,166,5,0,72,32,0,0,0,0,0,0,32,239,2,0,147,166,5,0,72,32,0,0,0,0,0,0,32,239,2,0,189,166,5,0,72,32,0,0,0,0,0,0,32,239,2,0,229,166,5,0,72,32,0,0,0,0,0,0,32,239,2,0,13,167,5,0,72,32,0,0,0,0,0,0,32,239,2,0,53,167,5,0,72,32,0,0,0,0,0,0,32,239,2,0,115,167,5,0,72,32,0,0,0,0,0,0,32,239,2,0,152,167,5,0,72,32,0,0,0,0,0,0,32,239,2,0,189,167,5,0,72,32,0,0,0,0,0,0,32,239,2,0,224,167,5,0,72,32,0,0,0,0,0,0,32,239,2,0,3,168,5,0,72,32,0,0,0,0,0,0,32,239,2,0,53,168,5,0,72,32,0,0,0,0,0,0,32,239,2,0,98,168,5,0,72,32,0,0,0,0,0,0,32,239,2,0,143,168,5,0,72,32,0,0,0,0,0,0,32,239,2,0,188,168,5,0,72,32,0,0,0,0,0,0,32,239,2,0,233,168,5,0,72,32,0,0,0,0,0,0,32,239,2,0,22,169,5,0,72,32,0,0,0,0,0,0,32,239,2,0,67,169,5,0,72,32,0,0,0,0,0,0,32,239,2,0,110,169,5,0,72,32,0,0,0,0,0,0,32,239,2,0,153,169,5,0,72,32,0,0,0,0,0,0,32,239,2,0,196,169,5,0,72,32,0,0,0,0,0,0,32,239,2,0,239,169,5,0,72,32,0,0,0,0,0,0,32,239,2,0,26,170,5,0,72,32,0,0,0,0,0,0,32,239,2,0,124,175,5,0,72,32,0,0,0,0,0,0,32,239,2,0,168,175,5,0,72,32,0,0,0,0,0,0,32,239,2,0,212,175,5,0,72,32,0,0,0,0,0,0,32,239,2,0,0,176,5,0,72,32,0,0,0,0,0,0,32,239,2,0,44,176,5,0,72,32,0,0,0,0,0,0,32,239,2,0,88,176,5,0,72,32,0,0,0,0,0,0,32,239,2,0,132,176,5,0,72,32,0,0,0,0,0,0,32,239,2,0,176,176,5,0,72,32,0,0,0,0,0,0,32,239,2,0,74,179,5,0,56,81,0,0,0,0,0,0,108,0,0,0,0,0,0,0,64,93,0,0,11,0,0,0,12,0,0,0,148,255,255,255,148,255,255,255,64,93,0,0,13,0,0,0,14,0,0,0,32,239,2,0,120,193,5,0,48,93,0,0,0,0,0,0,32,239,2,0,167,193,5,0,64,93,0,0,0,0,0,0,236,239,2,0,47,204,5,0,0,0,0,0,1,0,0,0,112,56,0,0,0,0,0,0,248,238,2,0,176,204,5,0,60,0,0,0,0,0,0,0,64,93,0,0,11,0,0,0,12,0,0,0,196,255,255,255,196,255,255,255,64,93,0,0,13,0,0,0,14,0,0,0,32,239,2,0,10,205,5,0,64,93,0,0,0,0,0,0,32,239,2,0,221,209,5,0,144,98,0,0,0,0,0,0,248,238,2,0,104,210,5,0,32,239,2,0,232,210,5,0,192,56,0,0,0,0,0,0,32,239,2,0,103,211,5,0,144,98,0,0,0,0,0,0,32,239,2,0,47,213,5,0,192,56,0,0,0,0,0,0,32,239,2,0,174,213,5,0,144,98,0,0,0,0,0,0,32,239,2,0,60,214,5,0,192,56,0,0,0,0,0,0,32,239,2,0,194,214,5,0,144,98,0,0,0,0,0,0,32,239,2,0,133,215,5,0,192,56,0,0,0,0,0,0,32,239,2,0,20,216,5,0,144,98,0,0,0,0,0,0,32,239,2,0,203,216,5,0,192,56,0,0,0,0,0,0,32,239,2,0,79,217,5,0,144,98,0,0,0,0,0,0,32,239,2,0,229,217,5,0,192,56,0,0,0,0,0,0,32,239,2,0,94,218,5,0,144,98,0,0,0,0,0,0,32,239,2,0,219,218,5,0,192,56,0,0,0,0,0,0,32,239,2,0,83,219,5,0,144,98,0,0,0,0,0,0,32,239,2,0,220,219,5,0,192,56,0,0,0,0,0,0,32,239,2,0,84,220,5,0,144,98,0,0,0,0,0,0,32,239,2,0,225,220,5,0,192,56,0,0,0,0,0,0,32,239,2,0,91,221,5,0,144,98,0,0,0,0,0,0,32,239,2,0,216,221,5,0,192,56,0,0,0,0,0,0,32,239,2,0,77,222,5,0,144,98,0,0,0,0,0,0,32,239,2,0,197,222,5,0,192,56,0,0,0,0,0,0,32,239,2,0,62,223,5,0,144,98,0,0,0,0,0,0,32,239,2,0,144,224,5,0,192,56,0,0,0,0,0,0,32,239,2,0,11,225,5,0,144,98,0,0,0,0,0,0,32,239,2,0,28,226,5,0,192,56,0,0,0,0,0,0,32,239,2,0,11,235,5,0,144,98,0,0,0,0,0,0,32,239,2,0,13,237,5,0,144,98,0,0,0,0,0,0,32,239,2,0,71,238,5,0,144,98,0,0,0,0,0,0,112,0,0,0,0,0,0,0,64,93,0,0,11,0,0,0,12,0,0,0,144,255,255,255,144,255,255,255,64,93,0,0,13,0,0,0,14,0,0,0,112,0,0,0,0,0,0,0,160,93,0,0,17,0,0,0,18,0,0,0,104,0,0,0,248,255,255,255,160,93,0,0,19,0,0,0,20,0,0,0,144,255,255,255,144,255,255,255,160,93,0,0,21,0,0,0,22,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,112,93,0,0,23,0,0,0,24,0,0,0,152,255,255,255,152,255,255,255,112,93,0,0,25,0,0,0,26,0,0,0,32,239,2,0,55,247,5,0,160,93,0,0,0,0,0,0,32,239,2,0,81,248,5,0,48,93,0,0,0,0,0,0,32,239,2,0,57,249,5,0,64,27,0,0,0,0,0,0,248,238,2,0,89,249,5,0,32,239,2,0,109,252,5,0,144,98,0,0,0,0,0,0,32,239,2,0,52,253,5,0,144,98,0,0,0,0,0,0,32,239,2,0,231,254,5,0,56,59,0,0,0,0,0,0,32,239,2,0,42,2,6,0,72,59,0,0,0,0,0,0,32,239,2,0,129,9,6,0,56,59,0,0,0,0,0,0,32,239,2,0,89,9,6,0,56,59,0,0,0,0,0,0,32,239,2,0,236,7,6,0,56,59,0,0,0,0,0,0,32,239,2,0,197,7,6,0,56,59,0,0,0,0,0,0,32,239,2,0,138,8,6,0,144,98,0,0,0,0,0,0,32,239,2,0,255,23,6,0,64,84,0,0,0,0,0,0,32,239,2,0,27,21,6,0,112,60,0,0,0,0,0,0,32,239,2,0,226,17,6,0,64,84,0,0,0,0,0,0,248,238,2,0,6,18,6,0,32,239,2,0,158,20,6,0,104,60,0,0,0,0,0,0,32,239,2,0,131,18,6,0,64,84,0,0,0,0,0,0,32,239,2,0,163,18,6,0,72,60,0,0,0,0,0,0,32,239,2,0,218,18,6,0,88,60,0,0,0,0,0,0,32,239,2,0,179,19,6,0,64,84,0,0,0,0,0,0,248,238,2,0,210,20,6,0,32,239,2,0,244,21,6,0,248,83,0,0,0,0,0,0,32,239,2,0,3,23,6,0,56,60,0,0,0,0,0,0,32,239,2,0,122,29,6,0,64,84,0,0,0,0,0,0,32,239,2,0,117,36,6,0,64,84,0,0,0,0,0,0,32,239,2,0,231,33,6,0,112,60,0,0,0,0,0,0,32,239,2,0,181,33,6,0,224,60,0,0,0,0,0,0,32,239,2,0,251,31,6,0,64,84,0,0,0,0,0,0,32,239,2,0,225,32,6,0,208,60,0,0,0,0,0,0,32,239,2,0,87,36,6,0,64,84,0,0,0,0,0,0,32,239,2,0,96,35,6,0,192,60,0,0,0,0,0,0,32,239,2,0,58,38,6,0,64,84,0,0,0,0,0,0,32,239,2,0,230,37,6,0,64,84,0,0,0,0,0,0,32,239,2,0,219,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,93,112,6,0,64,84,0,0,0,0,0,0,32,239,2,0,133,112,6,0,64,84,0,0,0,0,0,0,32,239,2,0,169,112,6,0,64,84,0,0,0,0,0,0,32,239,2,0,207,112,6,0,64,84,0,0,0,0,0,0,32,239,2,0,18,113,6,0,64,84,0,0,0,0,0,0,32,239,2,0,240,112,6,0,64,84,0,0,0,0,0,0,32,239,2,0,116,113,6,0,64,84,0,0,0,0,0,0,32,239,2,0,51,113,6,0,64,84,0,0,0,0,0,0,32,239,2,0,89,113,6,0,64,84,0,0,0,0,0,0,32,239,2,0,188,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,151,113,6,0,64,84,0,0,0,0,0,0,32,239,2,0,183,113,6,0,64,84,0,0,0,0,0,0,32,239,2,0,214,113,6,0,64,84,0,0,0,0,0,0,32,239,2,0,1,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,36,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,71,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,103,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,145,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,176,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,209,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,241,114,6,0,64,84,0,0,0,0,0,0,32,239,2,0,22,115,6,0,64,84,0,0,0,0,0,0,32,239,2,0,58,115,6,0,64,84,0,0,0,0,0,0,32,239,2,0,95,115,6,0,64,84,0,0,0,0,0,0,32,239,2,0,132,115,6,0,64,84,0,0,0,0,0,0,32,239,2,0,167,115,6,0,64,84,0,0,0,0,0,0,32,239,2,0,201,115,6,0,64,84,0,0,0,0,0,0,32,239,2,0,239,115,6,0,64,84,0,0,0,0,0,0,32,239,2,0,16,116,6,0,64,84,0,0,0,0,0,0,32,239,2,0,54,116,6,0,64,84,0,0,0,0,0,0,32,239,2,0,89,116,6,0,64,84,0,0,0,0,0,0,32,239,2,0,120,116,6,0,64,84,0,0,0,0,0,0,32,239,2,0,160,116,6,0,64,84,0,0,0,0,0,0,32,239,2,0,200,116,6,0,64,84,0,0,0,0,0,0,32,239,2,0,237,116,6,0,64,84,0,0,0,0,0,0,32,239,2,0,17,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,52,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,84,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,123,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,157,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,223,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,254,117,6,0,64,84,0,0,0,0,0,0,32,239,2,0,30,118,6,0,64,84,0,0,0,0,0,0,32,239,2,0,63,118,6,0,64,84,0,0,0,0,0,0,32,239,2,0,98,118,6,0,64,84,0,0,0,0,0,0,32,239,2,0,135,118,6,0,64,84,0,0,0,0,0,0,32,239,2,0,172,118,6,0,64,84,0,0,0,0,0,0,32,239,2,0,206,118,6,0,64,84,0,0,0,0,0,0,32,239,2,0,243,118,6,0,64,84,0,0,0,0,0,0,32,239,2,0,18,119,6,0,64,84,0,0,0,0,0,0,32,239,2,0,51,119,6,0,64,84,0,0,0,0,0,0,32,239,2,0,86,119,6,0,64,84,0,0,0,0,0,0,32,239,2,0,119,119,6,0,64,84,0,0,0,0,0,0,32,239,2,0,150,119,6,0,64,84,0,0,0,0,0,0,32,239,2,0,188,119,6,0,64,84,0,0,0,0,0,0,32,239,2,0,237,119,6,0,64,84,0,0,0,0,0,0,32,239,2,0,13,120,6,0,64,84,0,0,0,0,0,0,32,239,2,0,45,120,6,0,64,84,0,0,0,0,0,0,32,239,2,0,8,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,82,120,6,0,64,84,0,0,0,0,0,0,32,239,2,0,118,120,6,0,64,84,0,0,0,0,0,0,32,239,2,0,159,120,6,0,64,84,0,0,0,0,0,0,32,239,2,0,194,120,6,0,64,84,0,0,0,0,0,0,32,239,2,0,237,120,6,0,64,84,0,0,0,0,0,0,32,239,2,0,41,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,67,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,128,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,97,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,162,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,185,121,6,0,64,84,0,0,0,0,0,0,32,239,2,0,190,133,6,0,64,84,0,0,0,0,0,0,32,239,2,0,52,132,6,0,64,84,0,0,0,0,0,0,32,239,2,0,200,132,6,0,64,84,0,0,0,0,0,0,32,239,2,0,88,132,6,0,64,84,0,0,0,0,0,0,32,239,2,0,132,132,6,0,64,84,0,0,0,0,0,0,32,239,2,0,166,132,6,0,64,84,0,0,0,0,0,0,32,239,2,0,7,133,6,0,64,84,0,0,0,0,0,0,32,239,2,0,226,132,6,0,64,84,0,0,0,0,0,0,32,239,2,0,36,133,6,0,64,84,0,0,0,0,0,0,32,239,2,0,162,133,6,0,64,84,0,0,0,0,0,0,32,239,2,0,76,133,6,0,64,84,0,0,0,0,0,0,32,239,2,0,108,133,6,0,64,84,0,0,0,0,0,0,32,239,2,0,134,133,6,0,64,84,0,0,0,0,0,0,32,239,2,0,76,141,6,0,144,98,0,0,0,0,0,0,32,239,2,0,202,142,6,0,160,66,0,0,0,0,0,0,32,239,2,0,148,142,6,0,72,32,0,0,0,0,0,0,32,239,2,0,250,142,6,0,144,59,0,0,0,0,0,0,32,239,2,0,159,143,6,0,144,98,0,0,0,0,0,0,32,239,2,0,84,144,6,0,224,66,0,0,0,0,0,0,32,239,2,0,29,144,6,0,72,32,0,0,0,0,0,0,32,239,2,0,133,144,6,0,144,59,0,0,0,0,0,0,32,239,2,0,245,144,6,0,144,98,0,0,0,0,0,0,32,239,2,0,168,145,6,0,32,67,0,0,0,0,0,0,32,239,2,0,114,145,6,0,72,32,0,0,0,0,0,0,32,239,2,0,216,145,6,0,144,59,0,0,0,0,0,0,32,239,2,0,73,146,6,0,144,98,0,0,0,0,0,0,32,239,2,0,2,147,6,0,96,67,0,0,0,0,0,0,32,239,2,0,201,146,6,0,72,32,0,0,0,0,0,0,32,239,2,0,53,147,6,0,144,59,0,0,0,0,0,0,32,239,2,0,166,147,6,0,144,98,0,0,0,0,0,0,32,239,2,0,87,148,6,0,160,67,0,0,0,0,0,0,32,239,2,0,34,148,6,0,72,32,0,0,0,0,0,0,32,239,2,0,134,148,6,0,144,59,0,0,0,0,0,0,32,239,2,0,245,148,6,0,144,98,0,0,0,0,0,0,32,239,2,0,172,149,6,0,224,67,0,0,0,0,0,0,32,239,2,0,116,149,6,0,72,32,0,0,0,0,0,0,32,239,2,0,222,149,6,0,144,59,0,0,0,0,0,0,32,239,2,0,75,150,6,0,144,98,0,0,0,0,0,0,32,239,2,0,254,150,6,0,32,68,0,0,0,0,0,0,32,239,2,0,200,150,6,0,72,32,0,0,0,0,0,0,32,239,2,0,46,151,6,0,144,59,0,0,0,0,0,0,32,239,2,0,169,151,6,0,144,98,0,0,0,0,0,0,32,239,2,0,94,152,6,0,96,68,0,0,0,0,0,0,32,239,2,0,39,152,6,0,72,32,0,0,0,0,0,0,32,239,2,0,143,152,6,0,144,59,0,0,0,0,0,0,32,239,2,0,33,153,6,0,144,98,0,0,0,0,0,0,32,239,2,0,72,154,6,0,160,68,0,0,0,0,0,0,32,239,2,0,9,154,6,0,72,32,0,0,0,0,0,0,32,239,2,0,129,154,6,0,144,59,0,0,0,0,0,0,32,239,2,0,230,154,6,0,144,98,0,0,0,0,0,0,32,239,2,0,232,156,6,0,208,68,0,0,0,0,0,0,32,239,2,0,5,157,6,0,56,59,0,0,0,0,0,0,32,239,2,0,107,157,6,0,144,98,0,0,0,0,0,0,32,239,2,0,193,160,6,0,16,69,0,0,0,0,0,0,32,239,2,0,142,160,6,0,72,32,0,0,0,0,0,0,32,239,2,0,228,160,6,0,56,59,0,0,0,0,0,0,32,239,2,0,77,161,6,0,144,98,0,0,0,0,0,0,32,239,2,0,85,162,6,0,64,69,0,0,0,0,0,0,32,239,2,0,119,162,6,0,56,59,0,0,0,0,0,0,32,239,2,0,218,162,6,0,144,98,0,0,0,0,0,0,32,239,2,0,54,165,6,0,192,59,0,0,0,0,0,0,32,239,2,0,5,165,6,0,72,32,0,0,0,0,0,0,32,239,2,0,134,165,6,0,144,98,0,0,0,0,0,0,32,239,2,0,169,167,6,0,160,69,0,0,0,0,0,0,32,239,2,0,196,167,6,0,56,59,0,0,0,0,0,0,32,239,2,0,32,168,6,0,144,98,0,0,0,0,0,0,32,239,2,0,136,168,6,0,144,69,0,0,0,0,0,0,32,239,2,0,224,168,6,0,144,98,0,0,0,0,0,0,32,239,2,0,239,169,6,0,240,69,0,0,0,0,0,0,32,239,2,0,18,170,6,0,56,59,0,0,0,0,0,0,32,239,2,0,119,170,6,0,144,98,0,0,0,0,0,0,32,239,2,0,159,171,6,0,32,70,0,0,0,0,0,0,32,239,2,0,187,171,6,0,56,59,0,0,0,0,0,0,32,239,2,0,25,172,6,0,144,98,0,0,0,0,0,0,32,239,2,0,161,175,6,0,160,59,0,0,0,0,0,0,32,239,2,0,110,174,6,0,72,32,0,0,0,0,0,0,32,239,2,0,243,175,6,0,144,98,0,0,0,0,0,0,32,239,2,0,29,177,6,0,128,70,0,0,0,0,0,0,32,239,2,0,57,177,6,0,56,59,0,0,0,0,0,0,32,239,2,0,150,177,6,0,144,98,0,0,0,0,0,0,32,239,2,0,209,179,6,0,176,70,0,0,0,0,0,0,32,239,2,0,236,179,6,0,56,59,0,0,0,0,0,0,32,239,2,0,198,180,6,0,144,98,0,0,0,0,0,0,32,239,2,0,45,181,6,0,224,70,0,0,0,0,0,0,32,239,2,0,71,181,6,0,56,59,0,0,0,0,0,0,32,239,2,0,165,181,6,0,144,98,0,0,0,0,0,0,32,239,2,0,103,183,6,0,16,71,0,0,0,0,0,0,32,239,2,0,133,183,6,0,56,59,0,0,0,0,0,0,32,239,2,0,227,183,6,0,144,98,0,0,0,0,0,0,32,239,2,0,60,185,6,0,64,71,0,0,0,0,0,0,32,239,2,0,86,185,6,0,56,59,0,0,0,0,0,0,32,239,2,0,178,185,6,0,144,98,0,0,0,0,0,0,32,239,2,0,139,186,6,0,56,59,0,0,0,0,0,0,32,239,2,0,67,188,6,0,96,71,0,0,0,0,0,0,32,239,2,0,145,188,6,0,144,98,0,0,0,0,0,0,32,239,2,0,108,190,6,0,176,71,0,0,0,0,0,0,32,239,2,0,72,190,6,0,72,32,0,0,0,0,0,0,32,239,2,0,132,190,6,0,56,59,0,0,0,0,0,0,32,239,2,0,222,190,6,0,144,98,0,0,0,0,0,0,32,239,2,0,229,193,6,0,224,71,0,0,0,0,0,0,32,239,2,0,2,194,6,0,56,59,0,0,0,0,0,0,32,239,2,0,93,194,6,0,144,98,0,0,0,0,0,0,32,239,2,0,229,194,6,0,16,72,0,0,0,0,0,0,32,239,2,0,253,194,6,0,56,59,0,0,0,0,0,0,32,239,2,0,86,195,6,0,144,98,0,0,0,0,0,0,32,239,2,0,111,199,6,0,176,59,0,0,0,0,0,0,32,239,2,0,51,199,6,0,72,32,0,0,0,0,0,0,32,239,2,0,195,199,6,0,144,98,0,0,0,0,0,0,32,239,2,0,3,203,6,0,112,72,0,0,0,0,0,0,32,239,2,0,33,203,6,0,144,59,0,0,0,0,0,0,32,239,2,0,135,203,6,0,144,98,0,0,0,0,0,0,32,239,2,0,68,205,6,0,160,72,0,0,0,0,0,0,32,239,2,0,102,205,6,0,56,59,0,0,0,0,0,0,32,239,2,0,200,205,6,0,144,98,0,0,0,0,0,0,32,239,2,0,57,208,6,0,208,72,0,0,0,0,0,0,32,239,2,0,83,208,6,0,56,59,0,0,0,0,0,0,32,239,2,0,70,211,6,0,144,98,0,0,0,0,0,0,32,239,2,0,132,216,6,0,0,73,0,0,0,0,0,0,32,239,2,0,168,216,6,0,56,59,0,0,0,0,0,0,32,239,2,0,12,217,6,0,144,98,0,0,0,0,0,0,32,239,2,0,173,218,6,0,56,59,0,0,0,0,0,0,32,239,2,0,229,219,6,0,32,73,0,0,0,0,0,0,32,239,2,0,53,220,6,0,144,98,0,0,0,0,0,0,32,239,2,0,31,223,6,0,96,73,0,0,0,0,0,0,32,239,2,0,59,223,6,0,56,59,0,0,0,0,0,0,32,239,2,0,153,223,6,0,144,98,0,0,0,0,0,0,32,239,2,0,229,226,6,0,160,73,0,0,0,0,0,0,32,239,2,0,158,226,6,0,72,32,0,0,0,0,0,0,32,239,2,0,1,227,6,0,56,59,0,0,0,0,0,0,32,239,2,0,99,227,6,0,144,98,0,0,0,0,0,0,32,239,2,0,208,227,6,0,56,59,0,0,0,0,0,0,32,239,2,0,227,233,6,0,240,73,0,0,0,0,0,0,32,239,2,0,217,231,6,0,72,32,0,0,0,0,0,0,32,239,2,0,3,234,6,0,0,74,0,0,0,0,0,0,32,239,2,0,39,234,6,0,192,73,0,0,0,0,0,0,32,239,2,0,27,235,6,0,144,98,0,0,0,0,0,0,32,239,2,0,189,236,6,0,240,73,0,0,0,0,0,0,32,239,2,0,91,236,6,0,72,32,0,0,0,0,0,0,32,239,2,0,140,236,6,0,72,32,0,0,0,0,0,0,32,239,2,0,229,236,6,0,56,59,0,0,0,0,0,0,32,239,2,0,60,237,6,0,144,98,0,0,0,0,0,0,32,239,2,0,10,242,6,0,80,74,0,0,0,0,0,0,32,239,2,0,86,242,6,0,144,98,0,0,0,0,0,0,32,239,2,0,43,243,6,0,56,59,0,0,0,0,0,0,32,239,2,0,78,244,6,0,144,74,0,0,0,0,0,0,32,239,2,0,155,244,6,0,144,98,0,0,0,0,0,0,32,239,2,0,207,245,6,0,208,74,0,0,0,0,0,0,32,239,2,0,233,245,6,0,56,59,0,0,0,0,0,0,32,239,2,0,233,254,6,0,64,84,0,0,0,0,0,0,32,239,2,0,49,249,6,0,64,84,0,0,0,0,0,0,32,239,2,0,198,254,6,0,64,84,0,0,0,0,0,0,32,239,2,0,158,254,6,0,64,84,0,0,0,0,0,0,32,239,2,0,245,251,6,0,112,60,0,0,0,0,0,0,32,239,2,0,186,251,6,0,80,75,0,0,0,0,0,0,32,239,2,0,238,249,6,0,64,84,0,0,0,0,0,0,32,239,2,0,221,250,6,0,64,75,0,0,0,0,0,0,32,239,2,0,158,253,6,0,48,75,0,0,0,0,0,0,32,239,2,0,146,5,7,0,64,84,0,0,0,0,0,0,32,239,2,0,164,4,7,0,64,84,0,0,0,0,0,0,32,239,2,0,136,4,7,0,64,84,0,0,0,0,0,0,32,239,2,0,103,3,7,0,64,84,0,0,0,0,0,0,32,239,2,0,2,4,7,0,64,84,0,0,0,0,0,0,32,239,2,0,194,6,7,0,64,84,0,0,0,0,0,0,32,239,2,0,138,7,7,0,200,78,0,0,0,0,0,0,32,239,2,0,158,7,7,0,208,75,0,0,0,0,0,0,32,239,2,0,183,7,7,0,144,98,0,0,0,0,0,0,32,239,2,0,24,8,7,0,200,78,0,0,0,0,0,0,32,239,2,0,51,8,7,0,0,76,0,0,0,0,0,0,32,239,2,0,83,8,7,0,144,98,0,0,0,0,0,0,32,239,2,0,67,10,7,0,200,78,0,0,0,0,0,0,32,239,2,0,25,11,7,0,48,76,0,0,0,0,0,0,32,239,2,0,41,11,7,0,144,98,0,0,0,0,0,0,32,239,2,0,21,13,7,0,112,76,0,0,0,0,0,0,32,239,2,0,39,13,7,0,200,78,0,0,0,0,0,0,32,239,2,0,155,13,7,0,144,98,0,0,0,0,0,0,32,239,2,0,229,13,7,0,200,78,0,0,0,0,0,0,32,239,2,0,35,15,7,0,144,76,0,0,0,0,0,0,32,239,2,0,66,15,7,0,144,98,0,0,0,0,0,0,32,239,2,0,139,15,7,0,200,78,0,0,0,0,0,0,32,239,2,0,191,16,7,0,192,76,0,0,0,0,0,0,32,239,2,0,209,16,7,0,144,98,0,0,0,0,0,0,32,239,2,0,248,17,7,0,72,32,0,0,0,0,0,0,32,239,2,0,32,18,7,0,72,32,0,0,0,0,0,0,32,239,2,0,83,18,7,0,72,32,0,0,0,0,0,0,32,239,2,0,11,20,7,0,72,32,0,0,0,0,0,0,32,239,2,0,47,20,7,0,72,32,0,0,0,0,0,0,32,239,2,0,21,21,7,0,72,32,0,0,0,0,0,0,32,239,2,0,55,21,7,0,72,32,0,0,0,0,0,0,32,239,2,0,81,22,7,0,72,32,0,0,0,0,0,0,32,239,2,0,27,23,7,0,72,32,0,0,0,0,0,0,32,239,2,0,98,23,7,0,72,32,0,0,0,0,0,0,32,239,2,0,19,24,7,0,72,32,0,0,0,0,0,0,32,239,2,0,106,24,7,0,72,32,0,0,0,0,0,0,32,239,2,0,173,24,7,0,72,32,0,0,0,0,0,0,32,239,2,0,216,24,7,0,72,32,0,0,0,0,0,0,32,239,2,0,253,24,7,0,200,78,0,0,0,0,0,0,32,239,2,0,228,25,7,0,208,77,0,0,0,0,0,0,32,239,2,0,244,25,7,0,144,98,0,0,0,0,0,0,248,238,2,0,55,26,7,0,32,239,2,0,33,27,7,0,64,27,0,0,0,0,0,0,32,239,2,0,21,28,7,0,8,78,0,0,0,0,0,0,32,239,2,0,210,27,7,0,144,98,0,0,0,0,0,0,32,239,2,0,160,31,7,0,8,78,0,0,0,0,0,0,32,239,2,0,255,28,7,0,144,98,0,0,0,0,0,0,32,239,2,0,113,29,7,0,144,98,0,0,0,0,0,0,32,239,2,0,7,31,7,0,144,98,0,0,0,0,0,0,32,239,2,0,84,31,7,0,144,98,0,0,0,0,0,0,32,239,2,0,69,33,7,0,144,98,0,0,0,0,0,0,32,239,2,0,173,33,7,0,200,78,0,0,0,0,0,0,32,239,2,0,201,33,7,0,152,78,0,0,0,0,0,0,32,239,2,0,234,33,7,0,144,98,0,0,0,0,0,0,32,239,2,0,35,35,7,0,64,27,0,0,0,0,0,0,248,238,2,0,16,36,7,0,32,239,2,0,164,35,7,0,144,98,0,0,0,0,0,0,32,239,2,0,118,38,7,0,216,78,0,0,0,0,0,0,32,239,2,0,86,37,7,0,144,98,0,0,0,0,0,0,32,239,2,0,164,37,7,0,144,98,0,0,0,0,0,0,32,239,2,0,15,38,7,0,144,98,0,0,0,0,0,0,32,239,2,0,177,39,7,0,216,78,0,0,0,0,0,0,32,239,2,0,149,38,7,0,144,98,0,0,0,0,0,0,32,239,2,0,255,38,7,0,144,98,0,0,0,0,0,0,32,239,2,0,101,39,7,0,144,98,0,0,0,0,0,0,32,239,2,0,153,42,7,0,176,79,0,0,0,0,0,0,32,239,2,0,197,40,7,0,72,32,0,0,0,0,0,0,32,239,2,0,70,41,7,0,144,98,0,0,0,0,0,0,32,239,2,0,214,41,7,0,144,98,0,0,0,0,0,0,32,239,2,0,182,42,7,0,64,27,0,0,0,0,0,0,32,239,2,0,211,42,7,0,144,98,0,0,0,0,0,0,248,238,2,0,77,43,7,0,248,238,2,0,62,47,7,0,32,239,2,0,92,43,7,0,72,32,0,0,0,0,0,0,32,239,2,0,244,45,7,0,72,32,0,0,0,0,0,0,32,239,2,0,159,57,7],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([96,20,0,0,0,0,0,0,32,239,2,0,41,56,7,0,72,32,0,0,0,0,0,0,32,239,2,0,221,57,7,0,144,98,0,0,0,0,0,0,32,239,2,0,139,58,7,0,72,32,0,0,0,0,0,0,32,239,2,0,16,62,7,0,80,80,0,0,0,0,0,0,32,239,2,0,64,62,7,0,96,80,0,0,0,0,0,0,32,239,2,0,94,62,7,0,64,27,0,0,0,0,0,0,32,239,2,0,119,62,7,0,144,98,0,0,0,0,0,0,32,239,2,0,190,63,7,0,144,80,0,0,0,0,0,0,32,239,2,0,236,63,7,0,160,80,0,0,0,0,0,0,32,239,2,0,8,64,7,0,64,27,0,0,0,0,0,0,32,239,2,0,32,64,7,0,144,98,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,32,239,2,0,56,68,7,0,224,80,0,0,0,0,0,0,248,238,2,0,96,68,7,0,32,239,2,0,139,68,7,0,96,86,0,0,0,0,0,0,32,239,2,0,71,69,7,0,96,86,0,0,0,0,0,0,32,239,2,0,161,70,7,0,224,80,0,0,0,0,0,0,248,238,2,0,210,70,7,0,248,238,2,0,129,71,7,0,32,239,2,0,195,74,7,0,168,98,0,0,0,0,0,0,248,238,2,0,230,74,7,0,32,239,2,0,1,75,7,0,56,81,0,0,0,0,0,0,248,238,2,0,126,78,7,0,32,239,2,0,44,99,7,0,200,85,0,0,0,0,0,0,32,239,2,0,127,99,7,0,208,83,0,0,0,0,0,0,32,239,2,0,19,101,7,0,56,81,0,0,0,0,0,0,32,239,2,0,19,116,7,0,56,81,0,0,0,0,0,0,32,239,2,0,107,117,7,0,56,81,0,0,0,0,0,0,32,239,2,0,249,117,7,0,56,81,0,0,0,0,0,0,32,239,2,0,79,146,7,0,64,84,0,0,0,0,0,0,32,239,2,0,97,142,7,0,64,84,0,0,0,0,0,0,32,239,2,0,48,142,7,0,64,84,0,0,0,0,0,0,32,239,2,0,179,142,7,0,64,84,0,0,0,0,0,0,32,239,2,0,135,142,7,0,64,84,0,0,0,0,0,0,32,239,2,0,7,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,214,142,7,0,64,84,0,0,0,0,0,0,32,239,2,0,47,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,81,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,116,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,153,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,185,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,218,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,251,143,7,0,64,84,0,0,0,0,0,0,32,239,2,0,30,144,7,0,64,84,0,0,0,0,0,0,32,239,2,0,62,144,7,0,64,84,0,0,0,0,0,0,32,239,2,0,104,144,7,0,64,84,0,0,0,0,0,0,32,239,2,0,147,144,7,0,64,84,0,0,0,0,0,0,32,239,2,0,250,144,7,0,64,84,0,0,0,0,0,0,32,239,2,0,192,144,7,0,64,84,0,0,0,0,0,0,32,239,2,0,34,145,7,0,64,84,0,0,0,0,0,0,32,239,2,0,75,145,7,0,64,84,0,0,0,0,0,0,32,239,2,0,116,145,7,0,64,84,0,0,0,0,0,0,32,239,2,0,3,146,7,0,64,84,0,0,0,0,0,0,32,239,2,0,158,145,7,0,64,84,0,0,0,0,0,0,32,239,2,0,208,145,7,0,64,84,0,0,0,0,0,0,32,239,2,0,39,146,7,0,64,84,0,0,0,0,0,0,248,238,2,0,117,146,7,0,32,239,2,0,156,146,7,0,104,83,0,0,0,0,0,0,32,239,2,0,172,148,7,0,64,84,0,0,0,0,0,0,32,239,2,0,207,148,7,0,160,85,0,0,0,0,0,0,32,239,2,0,209,149,7,0,0,86,0,0,0,0,0,0,32,239,2,0,12,150,7,0,104,60,0,0,0,0,0,0,32,239,2,0,237,161,7,0,80,84,0,0,0,0,0,0,248,238,2,0,11,163,7,0,32,239,2,0,93,167,7,0,224,80,0,0,0,0,0,0,32,239,2,0,135,167,7,0,24,81,0,0,0,0,0,0,248,238,2,0,204,167,7,0,32,239,2,0,215,170,7,0,16,84,0,0,0,0,0,0,32,239,2,0,4,171,7,0,248,83,0,0,0,0,0,0,236,239,2,0,89,171,7,0,0,0,0,0,1,0,0,0,56,84,0,0,0,0,0,0,248,238,2,0,153,171,7,0,32,239,2,0,55,173,7,0,32,81,0,0,0,0,0,0,248,238,2,0,24,179,7,0,32,239,2,0,24,174,7,0,104,84,0,0,0,0,0,0,32,239,2,0,85,174,7,0,120,84,0,0,0,0,0,0,32,239,2,0,153,174,7,0,136,84,0,0,0,0,0,0,248,238,2,0,216,174,7,0,32,239,2,0,11,175,7,0,120,84,0,0,0,0,0,0,32,239,2,0,57,175,7,0,176,84,0,0,0,0,0,0,32,239,2,0,117,175,7,0,120,84,0,0,0,0,0,0,32,239,2,0,236,175,7,0,208,84,0,0,0,0,0,0,32,239,2,0,43,176,7,0,120,84,0,0,0,0,0,0,32,239,2,0,96,176,7,0,240,84,0,0,0,0,0,0,32,239,2,0,159,176,7,0,120,84,0,0,0,0,0,0,32,239,2,0,212,176,7,0,16,85,0,0,0,0,0,0,32,239,2,0,19,177,7,0,120,84,0,0,0,0,0,0,32,239,2,0,72,177,7,0,48,85,0,0,0,0,0,0,32,239,2,0,135,177,7,0,120,84,0,0,0,0,0,0,32,239,2,0,188,177,7,0,80,85,0,0,0,0,0,0,32,239,2,0,251,177,7,0,120,84,0,0,0,0,0,0,32,239,2,0,48,178,7,0,112,85,0,0,0,0,0,0,32,239,2,0,111,178,7,0,120,84,0,0,0,0,0,0,32,239,2,0,164,178,7,0,144,85,0,0,0,0,0,0,32,239,2,0,227,178,7,0,120,84,0,0,0,0,0,0,248,238,2,0,55,179,7,0,32,239,2,0,213,179,7,0,160,85,0,0,0,0,0,0,248,238,2,0,65,182,7,0,248,238,2,0,127,182,7,0,248,238,2,0,181,182,7,0,32,239,2,0,29,184,7,0,184,85,0,0,0,0,0,0,32,239,2,0,126,188,7,0,208,83,0,0,0,0,0,0,32,239,2,0,198,188,7,0,80,81,0,0,0,0,0,0,248,238,2,0,155,190,7,0,32,239,2,0,200,190,7,0,0,86,0,0,0,0,0,0,248,238,2,0,189,191,7,0,248,238,2,0,226,191,7,0,248,238,2,0,7,192,7,0,248,238,2,0,44,192,7,0,248,238,2,0,81,192,7,0,248,238,2,0,118,192,7,0,248,238,2,0,155,192,7,0,32,239,2,0,192,192,7,0,104,60,0,0,0,0,0,0,248,238,2,0,62,194,7,0,248,238,2,0,144,230,7,0,32,239,2,0,130,228,7,0,48,26,0,0,0,0,0,0,248,238,2,0,154,208,7,0,32,239,2,0,92,210,7,0,248,86,0,0,0,0,0,0,32,239,2,0,224,208,7,0,168,86,0,0,0,0,0,0,32,239,2,0,8,209,7,0,184,86,0,0,0,0,0,0,248,238,2,0,53,209,7,0,32,239,2,0,154,209,7,0,208,86,0,0,0,0,0,0,248,238,2,0,185,209,7,0,32,239,2,0,209,209,7,0,192,86,0,0,0,0,0,0,32,239,2,0,246,209,7,0,192,86,0,0,0,0,0,0,248,238,2,0,124,210,7,0,32,239,2,0,52,212,7,0,248,86,0,0,0,0,0,0,32,239,2,0,26,211,7,0,40,87,0,0,0,0,0,0,208,239,2,0,178,210,7,0,32,239,2,0,89,211,7,0,184,86,0,0,0,0,0,0,32,239,2,0,159,211,7,0,72,87,0,0,0,0,0,0,32,239,2,0,199,211,7,0,184,86,0,0,0,0,0,0,32,239,2,0,168,212,7,0,104,87,0,0,0,0,0,0,32,239,2,0,208,212,7,0,184,86,0,0,0,0,0,0,32,239,2,0,253,212,7,0,136,87,0,0,0,0,0,0,32,239,2,0,37,213,7,0,184,86,0,0,0,0,0,0,32,239,2,0,233,219,7,0,248,86,0,0,0,0,0,0,32,239,2,0,20,216,7,0,208,86,0,0,0,0,0,0,32,239,2,0,188,218,7,0,248,86,0,0,0,0,0,0,32,239,2,0,33,218,7,0,0,88,0,0,0,0,0,0,180,239,2,0,163,217,7,0,0,0,0,0,232,87,0,0,180,239,2,0,206,217,7,0,0,0,0,0,248,87,0,0,248,238,2,0,248,217,7,0,32,239,2,0,108,218,7,0,184,86,0,0,0,0,0,0,32,239,2,0,137,219,7,0,248,86,0,0,0,0,0,0,32,239,2,0,173,219,7,0,72,32,0,0,0,0,0,0,32,239,2,0,66,220,7,0,248,86,0,0,0,0,0,0,32,239,2,0,165,220,7,0,248,86,0,0,0,0,0,0,32,239,2,0,131,220,7,0,208,86,0,0,0,0,0,0,32,239,2,0,207,220,7,0,248,86,0,0,0,0,0,0,32,239,2,0,132,221,7,0,248,86,0,0,0,0,0,0,32,239,2,0,161,221,7,0,152,88,0,0,0,0,0,0,208,239,2,0,102,221,7,0,32,239,2,0,221,221,7,0,184,86,0,0,0,0,0,0,32,239,2,0,73,222,7,0,192,88,0,0,0,0,0,0,248,238,2,0,44,222,7,0,32,239,2,0,125,222,7,0,184,86,0,0,0,0,0,0,32,239,2,0,184,222,7,0,224,88,0,0,0,0,0,0,248,238,2,0,216,222,7,0,32,239,2,0,247,222,7,0,224,88,0,0,0,0,0,0,32,239,2,0,200,224,7,0,224,88,0,0,0,0,0,0,32,239,2,0,68,224,7,0,224,88,0,0,0,0,0,0,32,239,2,0,169,223,7,0,80,89,0,0,0,0,0,0,180,239,2,0,43,223,7,0,0,0,0,0,56,89,0,0,180,239,2,0,86,223,7,0,0,0,0,0,72,89,0,0,248,238,2,0,128,223,7,0,32,239,2,0,244,223,7,0,184,86,0,0,0,0,0,0,32,239,2,0,104,224,7,0,224,88,0,0,0,0,0,0,32,239,2,0,140,224,7,0,72,32,0,0,0,0,0,0,32,239,2,0,239,224,7,0,224,88,0,0,0,0,0,0,32,239,2,0,22,225,7,0,224,88,0,0,0,0,0,0,32,239,2,0,64,225,7,0,224,88,0,0,0,0,0,0,32,239,2,0,100,225,7,0,224,88,0,0,0,0,0,0,32,239,2,0,176,227,7,0,8,90,0,0,0,0,0,0,32,239,2,0,129,226,7,0,224,89,0,0,0,0,0,0,248,238,2,0,160,226,7,0,32,239,2,0,184,226,7,0,208,89,0,0,0,0,0,0,32,239,2,0,221,226,7,0,208,89,0,0,0,0,0,0,248,238,2,0,214,227,7,0,32,239,2,0,251,227,7,0,8,90,0,0,0,0,0,0,32,239,2,0,53,228,7,0,8,90,0,0,0,0,0,0,32,239,2,0,95,228,7,0,8,90,0,0,0,0,0,0,32,239,2,0,162,230,7,0,80,90,0,0,0,0,0,0,32,239,2,0,200,230,7,0,184,86,0,0,0,0,0,0,32,239,2,0,245,230,7,0,112,90,0,0,0,0,0,0,32,239,2,0,90,231,7,0,184,86,0,0,0,0,0,0,32,239,2,0,61,233,7,0,72,32,0,0,0,0,0,0,49,244,70,62,15,206,131,63,254,130,43,101,71,21,87,64,0,0,0,0,0,0,144,63,0,0,0,0,0,0,240,63,97,128,119,62,154,44,240,63,116,133,21,211,176,89,240,63,200,155,117,24,69,135,240,63,15,137,249,108,88,181,240,63,162,209,211,50,236,227,240,63,81,91,18,208,1,19,241,63,224,45,169,174,154,66,241,63,123,81,125,60,184,114,241,63,117,203,111,235,91,163,241,63,170,185,104,49,135,212,241,63,214,140,98,136,59,6,242,63,56,98,117,110,122,56,242,63,221,124,226,101,69,107,242,63,225,222,31,245,157,158,242,63,11,3,228,166,133,210,242,63,21,183,49,10,254,6,243,63,255,22,100,178,8,60,243,63,203,169,58,55,167,113,243,63,247,159,229,52,219,167,243,63,34,52,18,76,166,222,243,63,42,46,247,33,10,22,244,63,45,137,97,96,8,78,244,63,208,60,193,181,162,134,244,63,39,42,54,213,218,191,244,63,167,44,157,118,178,249,244,63,130,79,157,86,43,52,245,63,218,39,181,54,71,111,245,63,41,84,72,221,7,171,245,63,72,33,173,21,111,231,245,63,133,85,58,176,126,36,246,63,37,34,85,130,56,98,246,63,205,59,127,102,158,160,246,63,47,26,101,60,178,223,246,63,116,95,236,232,117,31,247,63,201,103,66,86,235,95,247,63,135,1,235,115,20,161,247,63,98,78,207,54,243,226,247,63,19,206,76,153,137,37,248,63,237,146,68,155,217,104,248,63,219,160,42,66,229,172,248,63,54,119,21,153,174,241,248,63,229,197,205,176,55,55,249,63,80,78,222,159,130,125,249,63,144,240,163,130,145,196,249,63,101,229,93,123,102,12,250,63,93,37,62,178,3,85,250,63,191,253,121,85,107,158,250,63,173,211,90,153,159,232,250,63,251,21,79,184,162,51,251,63,71,94,251,242,118,127,251,63,210,193,75,144,30,204,251,63,156,82,133,221,155,25,252,63,75,209,87,46,241,103,252,63,105,144,239,220,32,183,252,63,124,137,7,74,45,7,253,63,135,164,251,220,24,88,253,63,133,50,219,3,230,169,253,63,95,155,123,51,151,252,253,63,246,63,139,231,46,80,254,63,218,144,164,162,175,164,254,63,39,90,97,238,27,250,254,63,64,69,110,91,118,80,255,63,216,144,158,129,193,167,255,63,239,57,250,254,66,46,230,63,236,239,2,0,172,244,7,0,0,0,0,0,1,0,0,0,112,19,0,0,0,0,0,0,236,239,2,0,109,244,7,0,0,0,0,0,1,0,0,0,112,19,0,0,0,0,0,0,248,238,2,0,78,244,7,0,248,238,2,0,47,244,7,0,248,238,2,0,16,244,7,0,248,238,2,0,241,243,7,0,248,238,2,0,210,243,7,0,32,239,2,0,251,255,7,0,24,93,0,0,0,0,0,0,248,238,2,0,233,255,7,0,32,239,2,0,37,0,8,0,24,93,0,0,0,0,0,0,248,238,2,0,79,0,8,0,248,238,2,0,128,0,8,0,236,239,2,0,177,0,8,0,0,0,0,0,1,0,0,0,8,93,0,0,3,244,255,255,236,239,2,0,224,0,8,0,0,0,0,0,1,0,0,0,32,93,0,0,3,244,255,255,236,239,2,0,15,1,8,0,0,0,0,0,1,0,0,0,8,93,0,0,3,244,255,255,236,239,2,0,62,1,8,0,0,0,0,0,1,0,0,0,32,93,0,0,3,244,255,255,236,239,2,0,109,1,8,0,3,0,0,0,2,0,0,0,64,93,0,0,2,0,0,0,112,93,0,0,2,8,0,0,12,0,0,0,0,0,0,0,64,93,0,0,11,0,0,0,12,0,0,0,244,255,255,255,244,255,255,255,64,93,0,0,13,0,0,0,14,0,0,0,32,239,2,0,157,1,8,0,56,93,0,0,0,0,0,0,32,239,2,0,182,1,8,0,48,93,0,0,0,0,0,0,32,239,2,0,245,1,8,0,56,93,0,0,0,0,0,0,32,239,2,0,13,2,8,0,48,93,0,0,0,0,0,0,32,239,2,0,37,2,8,0,56,94,0,0,0,0,0,0,32,239,2,0,57,2,8,0,136,98,0,0,0,0,0,0,32,239,2,0,79,2,8,0,56,94,0,0,0,0,0,0,236,239,2,0,137,2,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,120,94,0,0,0,0,0,0,236,239,2,0,205,2,8,0,0,0,0,0,1,0,0,0,144,94,0,0,0,0,0,0,248,238,2,0,227,2,8,0,236,239,2,0,252,2,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,184,94,0,0,0,0,0,0,236,239,2,0,64,3,8,0,0,0,0,0,1,0,0,0,144,94,0,0,0,0,0,0,236,239,2,0,100,3,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,240,94,0,0,0,0,0,0,236,239,2,0,168,3,8,0,0,0,0,0,1,0,0,0,8,95,0,0,0,0,0,0,248,238,2,0,190,3,8,0,236,239,2,0,215,3,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,48,95,0,0,0,0,0,0,236,239,2,0,27,4,8,0,0,0,0,0,1,0,0,0,8,95,0,0,0,0,0,0,236,239,2,0,113,5,8,0,0,0,0,0,3,0,0,0,56,94,0,0,2,0,0,0,112,95,0,0,2,0,0,0,120,95,0,0,0,8,0,0,248,238,2,0,216,5,8,0,248,238,2,0,182,5,8,0,236,239,2,0,235,5,8,0,0,0,0,0,3,0,0,0,56,94,0,0,2,0,0,0,112,95,0,0,2,0,0,0,168,95,0,0,0,8,0,0,248,238,2,0,48,6,8,0,236,239,2,0,82,6,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,208,95,0,0,0,8,0,0,248,238,2,0,151,6,8,0,236,239,2,0,172,6,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,208,95,0,0,0,8,0,0,236,239,2,0,241,6,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,24,96,0,0,2,0,0,0,248,238,2,0,13,7,8,0,236,239,2,0,34,7,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,24,96,0,0,2,0,0,0,236,239,2,0,62,7,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,24,96,0,0,2,0,0,0,236,239,2,0,90,7,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,24,96,0,0,2,0,0,0,236,239,2,0,133,7,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,160,96,0,0,0,0,0,0,248,238,2,0,203,7,8,0,236,239,2,0,239,7,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,200,96,0,0,0,0,0,0,248,238,2,0,53,8,8,0,236,239,2,0,84,8,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,240,96,0,0,0,0,0,0,248,238,2,0,154,8,8,0,236,239,2,0,179,8,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,24,97,0,0,0,0,0,0,248,238,2,0,249,8,8,0,236,239,2,0,18,9,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,64,97,0,0,2,0,0,0,248,238,2,0,39,9,8,0,236,239,2,0,190,9,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,64,97,0,0,2,0,0,0,32,239,2,0,63,9,8,0,120,97,0,0,0,0,0,0,236,239,2,0,98,9,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,152,97,0,0,2,0,0,0,248,238,2,0,133,9,8,0,32,239,2,0,156,9,8,0,120,97,0,0,0,0,0,0,236,239,2,0,211,9,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,152,97,0,0,2,0,0,0,236,239,2,0,245,9,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,152,97,0,0,2,0,0,0,236,239,2,0,23,10,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,152,97,0,0,2,0,0,0,32,239,2,0,58,10,8,0,56,94,0,0,0,0,0,0,236,239,2,0,80,10,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,64,98,0,0,2,0,0,0,248,238,2,0,98,10,8,0,236,239,2,0,119,10,8,0,0,0,0,0,2,0,0,0,56,94,0,0,2,0,0,0,64,98,0,0,2,0,0,0,32,239,2,0,137,10,8,0,56,94,0,0,0,0,0,0,32,239,2,0,158,10,8,0,56,94,0,0,0,0,0,0,248,238,2,0,179,10,8,0,236,239,2,0,204,10,8,0,0,0,0,0,1,0,0,0,136,98,0,0,0,0,0,0,248,238,2,0,32,12,8,0,32,239,2,0,128,12,8,0,192,98,0,0,0,0,0,0,32,239,2,0,45,12,8,0,208,98,0,0,0,0,0,0,248,238,2,0,78,12,8,0,32,239,2,0,91,12,8,0,176,98,0,0,0,0,0,0,32,239,2,0,98,13,8,0,168,98,0,0,0,0,0,0,32,239,2,0,114,13,8,0,232,98,0,0,0,0,0,0,32,239,2,0,131,13,8,0,232,98,0,0,0,0,0,0,32,239,2,0,162,13,8,0,168,98,0,0,0,0,0,0,32,239,2,0,210,13,8,0,192,98,0,0,0,0,0,0,32,239,2,0,174,13,8,0,40,99,0,0,0,0,0,0,32,239,2,0,244,13,8,0,192,98,0,0,0,0,0,0,152,239,2,0,28,14,8,0,152,239,2,0,30,14,8,0,152,239,2,0,33,14,8,0,152,239,2,0,225,236,6,0,180,239,2,0,35,14,8,0,1,0,0,0,112,99,0,0,152,239,2,0,223,236,6,0,152,239,2,0,39,14,8,0,152,239,2,0,41,14,8,0,152,239,2,0,254,185,7,0,152,239,2,0,43,14,8,0,152,239,2,0,45,14,8,0,152,239,2,0,162,19,8,0,152,239,2,0,47,14,8,0,152,239,2,0,6,186,7,0,152,239,2,0,49,14,8,0,32,239,2,0,51,14,8,0,192,98,0,0,0,0,0,0,32,239,2,0,84,14,8,0,176,98,0,0,0,0,0,0,88,99,0,0,168,99,0,0,88,99,0,0,176,99,0,0,88,99,0,0,64,16,0,0,88,99,0,0,72,16,0,0,88,99,0,0,80,16,0,0,88,99,0,0,168,99,0,0,144,16,0,0,88,99,0,0,144,16,0,0,168,99,0,0,88,99,0,0,144,16,0,0,176,99,0,0,168,99,0,0,176,99,0,0,160,16,0,0,176,16,0,0,120,16,0,0,176,99,0,0,104,99,0,0,120,16,0,0,176,99,0,0,168,99,0,0,232,16,0,0,88,99,0,0,232,16,0,0,200,99,0,0,88,99,0,0,232,16,0,0,176,99,0,0,200,99,0,0,176,99,0,0,248,16,0,0,176,16,0,0,208,16,0,0,176,99,0,0,104,99,0,0,208,16,0,0,176,99,0,0,200,99,0,0,56,17,0,0,88,99,0,0,56,17,0,0,208,99,0,0,88,99,0,0,56,17,0,0,176,99,0,0,208,99,0,0,176,99,0,0,72,17,0,0,176,16,0,0,32,17,0,0,176,99,0,0,104,99,0,0,32,17,0,0,176,99,0,0,208,99,0,0,136,17,0,0,88,99,0,0,136,17,0,0,168,17,0,0,88,99,0,0,136,17,0,0,176,99,0,0,168,17,0,0,176,99,0,0,152,17,0,0,176,16,0,0,112,17,0,0,176,99,0,0,104,99,0,0,112,17,0,0,176,99,0,0,168,17,0,0,224,17,0,0,88,99,0,0,224,17,0,0,0,18,0,0,88,99,0,0,224,17,0,0,176,99,0,0,0,18,0,0,176,99,0,0,240,17,0,0,176,16,0,0,200,17,0,0,176,99,0,0,104,99,0,0,200,17,0,0,176,99,0,0,0,18,0,0,56,18,0,0,88,99,0,0,56,18,0,0,80,16,0,0,88,99,0,0,56,18,0,0,176,99,0,0,80,16,0,0,176,99,0,0,72,18,0,0,176,16,0,0,32,18,0,0,176,99,0,0,104,99,0,0,32,18,0,0,176,99,0,0,80,16,0,0,136,18,0,0,88,99,0,0,136,18,0,0,168,18,0,0,88,99,0,0,136,18,0,0,176,99,0,0,168,18,0,0,176,99,0,0,152,18,0,0,176,16,0,0,112,18,0,0,176,99,0,0,104,99,0,0,112,18,0,0,176,99,0,0,168,18,0,0,176,18,0,0,176,18,0,0,0,18,0,0,176,18,0,0,208,18,0,0,168,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,240,18,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,176,99,0,0,0,18,0,0,208,18,0,0,168,99,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,176,99,0,0,192,18,0,0,168,99,0,0,192,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,0,18,0,0,192,18,0,0,168,99,0,0,88,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,176,18,0,0,208,18,0,0,168,99,0,0,0,18,0,0,192,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,192,18,0,0,56,19,0,0,88,99,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,104,99,0,0,192,18,0,0,176,99,0,0,192,18,0,0,168,99,0,0,0,18,0,0,192,18,0,0,208,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,192,18,0,0,80,16,0,0,88,99,0,0,0,18,0,0,240,18,0,0,88,99,0,0,0,18,0,0,240,18,0,0,0,18,0,0,208,18,0,0,0,18,0,0,176,16,0,0,0,18,0,0,168,99,0,0,176,16,0,0,0,18,0,0,168,99,0,0,168,99,0,0,112,99,0,0,176,18,0,0,168,99,0,0,112,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,112,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,136,99,0,0,176,18,0,0,168,99,0,0,136,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,136,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,152,99,0,0,176,18,0,0,168,99,0,0,152,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,152,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,160,99,0,0,176,18,0,0,168,99,0,0,160,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,160,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,200,99,0,0,176,18,0,0,168,99,0,0,200,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,200,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,176,18,0,0,168,99,0,0,208,99,0,0,176,18,0,0,168,99,0,0,168,99,0,0,176,16,0,0,72,16,0,0,80,16,0,0,72,16,0,0,80,19,0,0,72,16,0,0,48,26,0,0,168,99,0,0,96,19,0,0,0,18,0,0,88,19,0,0,0,18,0,0,0,18,0,0,88,19,0,0,0,18,0,0,240,18,0,0,168,99,0,0,168,99,0,0,176,16,0,0,0,18,0,0,80,16,0,0,64,19,0,0,120,19,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,208,99,0,0,208,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,104,99,0,0,208,99,0,0,0,18,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,17,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,17,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,80,16,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,18,0,0,168,17,0,0,104,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,18,0,0,168,17,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,18,0,0,168,17,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,18,0,0,88,99,0,0,200,17,0,0,176,16,0,0,0,18,0,0,0,18,0,0,176,16,0,0,208,99,0,0,88,99,0,0,200,17,0,0,176,16,0,0,0,18,0,0,0,18,0,0,176,16,0,0,176,16,0,0,104,99,0,0,88,99,0,0,200,17,0,0,176,16,0,0,0,18,0,0,0,18,0,0,176,16,0,0,176,16,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,64,19,0,0,168,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,64,19,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,64,19,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,104,99,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,208,99,0,0,168,99,0,0,168,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,168,99,0,0,168,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,17,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,88,99,0,0,208,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,88,99,0,0,208,99,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,200,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,168,99,0,0,168,17,0,0,88,99,0,0,0,18,0,0,200,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,200,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,200,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,200,17,0,0,168,99,0,0,240,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,200,17,0,0,168,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,18,0,0,176,16,0,0,152,19,0,0,88,99,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,18,0,0,176,16,0,0,88,99,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,240,18,0,0,88,99,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,240,18,0,0,88,99,0,0,0,18,0,0,176,16,0,0,0,18,0,0,176,16,0,0,176,16,0,0,0,18,0,0,104,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,104,99,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,168,17,0,0,208,18,0,0,208,99,0,0,208,99,0,0,208,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,208,18,0,0,208,99,0,0,208,99,0,0,208,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,208,18,0,0,208,99,0,0,208,99,0,0,208,99,0,0,240,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,208,18,0,0,208,99,0,0,208,99,0,0,208,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,72,16,0,0,240,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,72,16,0,0,240,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,72,16,0,0,240,18,0,0,88,99,0,0,168,17,0,0,208,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,112,17,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,168,17,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,168,17,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,168,17,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,200,17,0,0,0,18,0,0,168,99,0,0,168,99,0,0,168,17,0,0,88,99,0,0,0,18,0,0,200,17,0,0,0,18,0,0,168,99,0,0,168,99,0,0,208,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,64,19,0,0,0,18,0,0,208,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,64,19,0,0,208,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,72,16,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,64,16,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,208,18,0,0,168,17,0,0,0,18,0,0,168,99,0,0,208,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,104,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,168,99,0,0,104,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,168,99,0,0,104,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,80,16,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,80,16,0,0,0,18,0,0,0,18,0,0,168,99,0,0,88,99,0,0,32,18,0,0,120,16,0,0,168,99,0,0,208,99,0,0,88,99,0,0,32,18,0,0,120,16,0,0,168,99,0,0,88,99,0,0,200,17,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,0,18,0,0,0,18],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([104,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,168,99,0,0,0,18,0,0,64,19,0,0,168,99,0,0,168,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,168,99,0,0,0,18,0,0,64,19,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,17,0,0,168,17,0,0,240,18,0,0,208,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,240,18,0,0,0,18,0,0,0,18,0,0,240,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,200,17,0,0,200,17,0,0,176,16,0,0,104,19,0,0,0,18,0,0,104,99,0,0,104,19,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,168,17,0,0,168,99,0,0,168,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,168,17,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,168,17,0,0,168,99,0,0,208,99,0,0,0,18,0,0,168,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,168,99,0,0,208,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,168,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,0,18,0,0,64,16,0,0,104,99,0,0,88,99,0,0,0,18,0,0,208,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,120,19,0,0,168,17,0,0,168,99,0,0,208,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,104,99,0,0,88,99,0,0,0,18,0,0,120,19,0,0,168,17,0,0,168,99,0,0,208,99,0,0,240,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,120,19,0,0,168,17,0,0,168,99,0,0,208,99,0,0,240,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,120,19,0,0,168,17,0,0,168,99,0,0,208,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,208,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,80,16,0,0,240,18,0,0,168,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,80,16,0,0,240,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,80,16,0,0,240,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,80,16,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,168,99,0,0,168,99,0,0,0,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,0,18,0,0,168,17,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,0,18,0,0,168,17,0,0,208,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,0,18,0,0,168,17,0,0,88,99,0,0,0,18,0,0,0,18,0,0,168,99,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,88,99,0,0,168,99,0,0,104,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,168,99,0,0,104,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,88,99,0,0,0,18,0,0,200,17,0,0,208,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,168,99,0,0,240,18,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,168,99,0,0,88,99,0,0,0,18,0,0,0,18,0,0,0,18,0,0,208,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,18,0,0,240,18,0,0,104,99,0,0,104,99,0,0,168,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,18,0,0,240,18,0,0,104,99,0,0,104,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,18,0,0,240,18,0,0,104,99,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,18,0,0,240,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,208,18,0,0,0,18,0,0,0,18,0,0,208,99,0,0,160,19,0,0,120,19,0,0,120,19,0,0,120,19,0,0,160,19,0,0,120,19,0,0,120,19,0,0,160,19,0,0,120,19,0,0,160,19,0,0,120,19,0,0,176,16,0,0,176,16,0,0,160,19,0,0,120,19,0,0,176,16,0,0,160,19,0,0,176,16,0,0,176,16,0,0,160,19,0,0,176,16,0,0,160,19,0,0,120,19,0,0,104,99,0,0,104,99,0,0,216,79,0,0,120,19,0,0,120,19,0,0,104,99,0,0,216,79,0,0,120,19,0,0,168,19,0,0,168,19,0,0,208,18,0,0,208,18,0,0,208,18,0,0,208,18,0,0,168,99,0,0,168,99,0,0,208,99,0,0,200,19,0,0,208,99,0,0,104,99,0,0,168,99,0,0,104,99,0,0,168,19,0,0,120,19,0,0,208,16,0,0,88,99,0,0,216,79,0,0,0,18,0,0,88,99,0,0,216,79,0,0,0,18,0,0,32,18,0,0,32,17,0,0,208,99,0,0,208,18,0,0,208,18,0,0,208,99,0,0,208,99,0,0,104,99,0,0,88,99,0,0,216,79,0,0,0,18,0,0,32,18,0,0,32,17,0,0,208,99,0,0,208,18,0,0,208,18,0,0,208,99,0,0,208,99,0,0,88,99,0,0,216,79,0,0,0,18,0,0,32,18,0,0,32,17,0,0,208,99,0,0,208,18,0,0,208,18,0,0,208,99,0,0,88,99,0,0,216,79,0,0,0,18,0,0,32,18,0,0,32,17,0,0,208,99,0,0,208,18,0,0,208,18,0,0,88,99,0,0,216,79,0,0,0,18,0,0,32,18,0,0,32,17,0,0,208,99,0,0,208,18,0,0,88,99,0,0,216,79,0,0,0,18,0,0,32,18,0,0,32,17,0,0,208,99,0,0,88,99,0,0,216,79,0,0,0,18,0,0,32,18,0,0,32,17,0,0,88,99,0,0,160,19,0,0,0,18,0,0,120,19,0,0,208,99,0,0,240,18,0,0,88,99,0,0,160,19,0,0,0,18,0,0,120,19,0,0,208,99,0,0,88,99,0,0,160,19,0,0,0,18,0,0,120,19,0,0,88,99,0,0,160,19,0,0,0,18,0,0,0,18,0,0,160,19,0,0,120,19,0,0,0,18,0,0,160,19,0,0,88,99,0,0,160,19,0,0,200,17,0,0,120,19,0,0,88,99,0,0,160,19,0,0,200,17,0,0,88,99,0,0,160,19,0,0,200,17,0,0,176,16,0,0,88,99,0,0,240,19,0,0,0,18,0,0,0,18,0,0,208,99,0,0,88,99,0,0,240,19,0,0,0,18,0,0,0,18,0,0,88,99,0,0,240,19,0,0,0,18,0,0,88,99,0,0,48,76,0,0,104,99,0,0,88,99,0,0,48,76,0,0,168,99,0,0,168,99,0,0,48,20,0,0,104,99,0,0,48,20,0,0,72,20,0,0,104,99,0,0,104,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,88,20,0,0,72,20,0,0,104,99,0,0,104,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,72,20,0,0,104,99,0,0,104,99,0,0,200,99,0,0,168,99,0,0,72,20,0,0,104,99,0,0,104,99,0,0,200,99,0,0,72,20,0,0,104,99,0,0,104,99,0,0,72,20,0,0,104,99,0,0,72,20,0,0,88,99,0,0,48,76,0,0,88,20,0,0,208,99,0,0,48,20,0,0,120,19,0,0,48,76,0,0,88,20,0,0,48,20,0,0,88,99,0,0,48,76,0,0,208,99,0,0,152,20,0,0,168,99,0,0,208,99,0,0,104,99,0,0,152,20,0,0,168,99,0,0,208,99,0,0,152,20,0,0,168,99,0,0,152,20,0,0,88,99,0,0,96,20,0,0,0,18,0,0,0,18,0,0,208,99,0,0,88,99,0,0,96,20,0,0,0,18,0,0,0,18,0,0,88,99,0,0,168,20,0,0,208,18,0,0,224,20,0,0,208,99,0,0,208,18,0,0,224,20,0,0,208,99,0,0,224,20,0,0,88,99,0,0,184,20,0,0,88,99,0,0,168,20,0,0,208,99,0,0,208,18,0,0,200,20,0,0,208,99,0,0,200,20,0,0,88,99,0,0,168,20,0,0,0,18,0,0,0,18,0,0,24,21,0,0,168,99,0,0,104,99,0,0,24,21,0,0,168,99,0,0,24,21,0,0,120,19,0,0,200,78,0,0,88,99,0,0,200,78,0,0,0,18,0,0,112,18,0,0,0,18,0,0,88,99,0,0,200,78,0,0,0,18,0,0,112,18,0,0,88,99,0,0,200,78,0,0,200,17,0,0,128,21,0,0,200,17,0,0,88,99,0,0,200,78,0,0,200,17,0,0,128,21,0,0,88,99,0,0,200,78,0,0,0,18,0,0,112,18,0,0,0,18,0,0,88,99,0,0,200,78,0,0,200,17,0,0,128,21,0,0,200,17,0,0,168,99,0,0,88,21,0,0,88,99,0,0,200,78,0,0,0,18,0,0,0,18,0,0,112,18,0,0,0,18,0,0,104,99,0,0,88,99,0,0,200,78,0,0,0,18,0,0,0,18,0,0,112,18,0,0,0,18,0,0,104,99,0,0,88,21,0,0,168,99,0,0,168,21,0,0,120,19,0,0,208,75,0,0,208,99,0,0,168,21,0,0,88,99,0,0,208,75,0,0,104,99,0,0,88,99,0,0,208,75,0,0,168,99,0,0,192,21,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,104,99,0,0,208,99,0,0,192,21,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,104,99,0,0,192,21,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,192,21,0,0,168,99,0,0,208,99,0,0,208,99,0,0,192,21,0,0,168,99,0,0,208,99,0,0,192,21,0,0,168,99,0,0,192,21,0,0,192,21,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,168,99,0,0,104,99,0,0,208,99,0,0,88,99,0,0,208,75,0,0,208,99,0,0,104,99,0,0,168,21,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,8,22,0,0,200,99,0,0,0,18,0,0,104,99,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,8,22,0,0,200,99,0,0,0,18,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,8,22,0,0,200,99,0,0,88,99,0,0,8,78,0,0,0,18,0,0,8,22,0,0,200,99,0,0,200,17,0,0,104,99,0,0,88,99,0,0,8,78,0,0,0,18,0,0,8,22,0,0,200,99,0,0,200,17,0,0,88,99,0,0,8,78,0,0,0,18,0,0,8,22,0,0,200,99,0,0,40,22,0,0,120,19,0,0,88,99,0,0,208,21,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,8,22,0,0,168,99,0,0,0,18,0,0,104,99,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,8,22,0,0,168,99,0,0,0,18,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,8,22,0,0,168,99,0,0,88,99,0,0,8,78,0,0,0,18,0,0,8,22,0,0,168,99,0,0,200,17,0,0,104,99,0,0,88,99,0,0,8,78,0,0,0,18,0,0,8,22,0,0,168,99,0,0,200,17,0,0,88,99,0,0,8,78,0,0,0,18,0,0,8,22,0,0,168,99,0,0,88,99,0,0,8,78,0,0,200,17,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,80,22,0,0,0,18,0,0,88,99,0,0,8,78,0,0,0,18,0,0,0,18,0,0,80,22,0,0,88,99,0,0,8,78,0,0,0,18,0,0,80,22,0,0,200,17,0,0,88,99,0,0,8,78,0,0,0,18,0,0,80,22,0,0,104,99,0,0,224,21,0,0,120,19,0,0,208,77,0,0,104,99,0,0,120,22,0,0,88,99,0,0,208,77,0,0,168,99,0,0,168,99,0,0,120,22,0,0,144,22,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,144,22,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,144,22,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,208,99,0,0,144,22,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,168,99,0,0,144,22,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,208,99,0,0,144,22,0,0,168,99,0,0,168,99,0,0,168,99,0,0,208,99,0,0,144,22,0,0,168,99,0,0,168,99,0,0,168,99,0,0,144,22,0,0,168,99,0,0,168,99,0,0,144,22,0,0,168,99,0,0,144,22,0,0,88,99,0,0,208,77,0,0,104,99,0,0,88,99,0,0,208,77,0,0,0,18,0,0,184,22,0,0,32,18,0,0,120,19,0,0,152,78,0,0,104,99,0,0,224,22,0,0,168,99,0,0,224,22,0,0,248,22,0,0,168,99,0,0,104,99,0,0,8,23,0,0,248,22,0,0,168,99,0,0,104,99,0,0,248,22,0,0,168,99,0,0,248,22,0,0,8,23,0,0,224,22,0,0,88,99,0,0,152,78,0,0,104,99,0,0,88,99,0,0,152,78,0,0,168,99,0,0,88,99,0,0,152,78,0,0,8,23,0,0,104,99,0,0,16,23,0,0,120,19,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,18,0,0,208,18,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,18,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,208,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,208,99,0,0,168,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,208,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,24,23,0,0,24,23,0,0,120,19,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,18,0,0,208,18,0,0,104,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,18,0,0,208,18,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,18,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,208,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,208,99,0,0,168,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,208,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,16,0,0,32,17,0,0,104,99,0,0,40,23,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,18,0,0,208,18,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,208,99,0,0,168,99,0,0,168,99,0,0,208,18,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,208,99,0,0,168,99,0,0,168,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,208,99,0,0,168,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,208,99,0,0,88,99,0,0,16,23,0,0,0,18,0,0,32,18,0,0,120,19,0,0,0,76,0,0,104,99,0,0,72,23,0,0,168,99,0,0,72,23,0,0,96,23,0,0,168,99,0,0,104,99,0,0,112,23,0,0,96,23,0,0,168,99,0,0,104,99,0,0,96,23,0,0,168,99,0,0,96,23,0,0,112,23,0,0,72,23,0,0,88,99,0,0,0,76,0,0,104,99,0,0,88,99,0,0,0,76,0,0,168,99,0,0,88,99,0,0,0,76,0,0,112,23,0,0,88,99,0,0,192,76,0,0,168,99,0,0,120,19,0,0,192,76,0,0,88,99,0,0,192,76,0,0,152,23,0,0,168,99,0,0,136,23,0,0,152,23,0,0,136,23,0,0,208,99,0,0,136,23,0,0,168,23,0,0,152,23,0,0,168,99,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,88,20,0,0,168,23,0,0,152,23,0,0,168,99,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,168,23,0,0,152,23,0,0,168,99,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,23,0,0,152,23,0,0,168,99,0,0,168,99,0,0,200,99,0,0,168,23,0,0,152,23,0,0,168,99,0,0,168,99,0,0,168,23,0,0,152,23,0,0,168,99,0,0,168,23,0,0,152,23,0,0,168,23,0,0,88,99,0,0,192,76,0,0,208,99,0,0,88,99,0,0,192,76,0,0,88,20,0,0,88,20,0,0,136,23,0,0,120,19,0,0,144,76,0,0,88,99,0,0,144,76,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,240,23,0,0,168,99,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,240,23,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,240,23,0,0,224,23,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,99,0,0,168,99,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,99,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,99,0,0,224,23,0,0,168,99,0,0,224,23,0,0,168,99,0,0,200,23,0,0,88,99,0,0,144,76,0,0,208,99,0,0,88,99,0,0,144,76,0,0,240,23,0,0,120,19,0,0,112,76,0,0,32,24,0,0,168,99,0,0,168,99,0,0,200,99,0,0,32,24,0,0,168,99,0,0,168,99,0,0,32,24,0,0,168,99,0,0,32,24,0,0,32,24,0,0,176,16,0,0,176,16,0,0,200,99,0,0,200,99,0,0,176,16,0,0,32,24,0,0,176,16,0,0,176,16,0,0,200,99,0,0,200,99,0,0,32,24,0,0,168,99,0,0,168,99,0,0,176,16,0,0,176,16,0,0,200,99,0,0,200,99,0,0,176,16,0,0,32,24,0,0,168,99,0,0,168,99,0,0,176,16,0,0,176,16,0,0,200,99,0,0,200,99,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,166,89,3,0,195,86,3,0,67,4,0,0,0,0,0,0,223,89,3,0,4,90,3,0,11,90,3,0,0,0,0,0,48,26,0,0,1,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,64,26,0,0,3,0,0,0,4,0,0,0,1,0,0,0,1,0,0,0,64,0,0,0,0,0,0,0,192,26,0,0,5,0,0,0,6,0,0,0,56,0,0,0,248,255,255,255,192,26,0,0,7,0,0,0,8,0,0,0,192,255,255,255,192,255,255,255,192,26,0,0,9,0,0,0,10,0,0,0,0,0,0,0,176,26,0,0,15,0,0,0,16,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,8,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,16,140,0,0,124,26,0,0,84,26,0,0,104,26,0,0,228,26,0,0,248,26,0,0,164,26,0,0,144,26,0,0,56,140,0,0,36,140,0,0,56,0,0,0,0,0,0,0,0,27,0,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,0,27,0,0,29,0,0,0,30,0,0,0,180,140,0,0,228,26,0,0,248,26,0,0,200,140,0,0,231,180,17,0,0,0,0,0,16,27,0,0,31,0,0,0,32,0,0,0,6,0,0,0,2,0,0,0,0,0,0,0,40,27,0,0,33,0,0,0,34,0,0,0,7,0,0,0,3,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,10,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,64,27,0,0,35,0,0,0,36,0,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,104,27,0,0,38,0,0,0,39,0,0,0,8,0,0,0,0,0,0,0,88,27,0,0,38,0,0,0,40,0,0,0,9,0,0,0,0,0,0,0,72,27,0,0,38,0,0,0,41,0,0,0,10,0,0,0,0,0,0,0,120,27,0,0,42,0,0,0,43,0,0,0,9,0,0,0,11,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,133,128,3,0,23,128,3,0,36,1,0,0,5,0,0,0,23,201,17,0,173,128,3,0,128,234,7,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,117,148,3,0,123,148,3,0,129,148,3,0,136,148,3,0,143,148,3,0,150,148,3,0,157,148,3,0,164,148,3,0,206,148,3,0,24,15,8,0,58,15,8,0,33,15,8,0,211,14,8,0,27,15,8,0,213,14,8,0,241,148,3,0,0,149,3,0,9,149,3,0,22,149,3,0,44,149,3,0,54,149,3,0,79,149,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,89,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,106,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,128,0,0,0,129,0,0,0,130,0,0,0,131,0,0,0,123,0,0,0,132,0,0,0,133,0,0,0,134,0,0,0,135,0,0,0,136,0,0,0,137,0,0,0,138,0,0,0,139,0,0,0,140,0,0,0,141,0,0,0,142,0,0,0,143,0,0,0,144,0,0,0,145,0,0,0,146,0,0,0,147,0,0,0,148,0,0,0,106,0,0,0,13,0,0,0,13,0,0,0,14,0,0,0,14,0,0,0,15,0,0,0,15,0,0,0,16,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,144,148,0,0,0,0,0,0,160,27,0,0,44,0,0,0,45,0,0,0,8,0,0,0,17,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,23,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,128,149,0,0,12,149,0,0,0,0,0,0,176,27,0,0,44,0,0,0,46,0,0,0,10,0,0,0,25,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,0,0,0,0,192,27,0,0,44,0,0,0,47,0,0,0,11,0,0,0,27,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,96,151,0,0,116,150,0,0,0,150,0,0,0,0,0,0,208,27,0,0,44,0,0,0,48,0,0,0,12,0,0,0,28,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,29,0,0,0,20,0,0,0,30,0,0,0,22,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,25,0,0,0,28,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,0,0,0,0,224,27,0,0,44,0,0,0,49,0,0,0,13,0,0,0,31,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,32,0,0,0,21,0,0,0,33,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,29,0,0,0,30,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,236,150,0,0,0,0,0,0,240,27,0,0,44,0,0,0,50,0,0,0,14,0,0,0,34,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,3,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,0,0,0,0,0,28,0,0,44,0,0,0,51,0,0,0,15,0,0,0,35,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,1,0,0,0,25,0,0,0,31,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,0,0,0,0,16,28,0,0,44,0,0,0,52,0,0,0,16,0,0,0,36,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,0,0,0,0,32,28,0,0,44,0,0,0,53,0,0,0,17,0,0,0,37,0,0,0,11,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,6,0,0,0,2,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,24,0,0,0,27,0,0,0,9,0,0,0,212,151,0,0,0,0,0,0,56,28,0,0,10,0,0,0,11,0,0,0,12,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,0,0,0,0,72,28,0,0,57,0,0,0,58,0,0,0,1,0,0,0,6,0,0,0,13,0,0,0,32,0,0,0,14,0,0,0,149,0,0,0,150,0,0,0,1,0,0,0,18,0,0,0,183,163,3,0,204,158,3,0,191,3,0,0,3,0,0,0,23,201,17,0,228,163,3,0,236,163,3,0,69,164,3,0,204,158,3,0,197,3,0,0,3,0,0,0,23,201,17,0,228,163,3,0,236,163,3,0,69,164,3,0,204,158,3,0,198,3,0,0,3,0,0,0,23,201,17,0,145,164,3,0,236,163,3,0,69,164,3,0,204,158,3,0,203,3,0,0,1,0,0,0,23,201,17,0,125,164,3,0,134,164,3,0,251,164,3,0,204,158,3,0,223,3,0,0,3,0,0,0,23,201,17,0,228,163,3,0,236,163,3,0,251,164,3,0,204,158,3,0,224,3,0,0,3,0,0,0,23,201,17,0,145,164,3,0,236,163,3,0,251,164,3,0,204,158,3,0,225,3,0,0,3,0,0,0,23,201,17,0,73,165,3,0,236,163,3,0,251,164,3,0,204,158,3,0,230,3,0,0,1,0,0,0,23,201,17,0,125,164,3,0,134,164,3,0,251,164,3,0,204,158,3,0,231,3,0,0,1,0,0,0,23,201,17,0,125,164,3,0,62,165,3,0,0,0,0,0,128,30,0,0,33,0,0,0,59,0,0,0,60,0,0,0,0,0,0,0,104,30,0,0,34,0,0,0,61,0,0,0,62,0,0,0,0,0,0,0,88,28,0,0,63,0,0,0,64,0,0,0,65,0,0,0,19,0,0,0,66,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,0,0,0,0,184,30,0,0,12,0,0,0,67,0,0,0,68,0,0,0,0,0,0,0,160,30,0,0,13,0,0,0,69,0,0,0,70,0,0,0,0,0,0,0,144,30,0,0,63,0,0,0,71,0,0,0,72,0,0,0,20,0,0,0,73,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,12,0,0,0,15,0,0,0,16,0,0,0,18,0,0,0,20,0,0,0,24,0,0,0,25,0,0,0,27,0,0,0,30,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,45,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,75,0,0,0,80,0,0,0,81,0,0,0,90,0,0,0,96,0,0,0,100,0,0,0,108,0,0,0,120,0,0,0,125,0,0,0,128,0,0,0,135,0,0,0,144,0,0,0,150,0,0,0,160,0,0,0,162,0,0,0,180,0,0,0,192,0,0,0,200,0,0,0,216,0,0,0,225,0,0,0,240,0,0,0,243,0,0,0,250,0,0,0,0,1,0,0,14,1,0,0,32,1,0,0,44,1,0,0,64,1,0,0,68,1,0,0,104,1,0,0,119,1,0,0,128,1,0,0,144,1,0,0,149,1,0,0,176,1,0,0,194,1,0,0,224,1,0,0,230,1,0,0,244,1,0,0,0,2,0,0,28,2,0,0,64,2,0,0,88,2,0,0,113,2,0,0,128,2,0,0,136,2,0,0,163,2,0,0,208,2,0,0,217,2,0,0,238,2,0,0,0,3,0,0,32,3,0,0,42,3,0,0,96,3,0,0,132,3,0,0,192,3,0,0,204,3,0,0,232,3,0,0,0,4,0,0,56,4,0,0,101,4,0,0,128,4,0,0,176,4,0,0,191,4,0,0,226,4,0,0,0,5,0,0,16,5,0,0,70,5,0,0,160,5,0,0,178,5,0,0,220,5,0,0,0,6,0,0,64,6,0,0,84,6,0,0,192,6,0,0,8,7,0,0,83,7,0,0,128,7,0,0,152,7,0,0,208,7,0,0,233,7,0,0,0,8,0,0,112,8,0,0,139,8,0,0,202,8,0,0,0,9,0,0,96,9,0,0,126,9,0,0,196,9,0,0,0,10,0,0,32,10,0,0,140,10,0,0,64,11,0,0,100,11,0,0,184,11,0,0,0,12,0,0,53,12,0,0,128,12,0,0,168,12,0,0,47,13,0,0,128,13,0,0,16,14,0,0,61,14,0,0,166,14,0,0,0,15,0,0,48,15,0,0,160,15,0,0,210,15,0,0,0,16,0,0,224,16,0,0,22,17,0,0,148,17,0,0,0,18,0,0,192,18,0,0,252,18,0,0,136,19,0,0,0,20,0,0,64,20,0,0,24,21,0,0,249,21,0,0,128,22,0,0,200,22,0,0,112,23,0,0,187,23,0,0,0,24,0,0,106,24,0,0,0,25,0,0,80,25,0,0,161,25,0,0,94,26,0,0,0,27,0,0,32,28,0,0,122,28,0,0,76,29,0,0,0,30,0,0,96,30,0,0,64,31,0,0,164,31,0,0,0,32,0,0,192,33,0,0,44,34,0,0,40,35,0,0,0,36,0,0,159,36,0,0,128,37,0,0,248,37,0,0,16,39,0,0,141,39,0,0,0,40,0,0,128,40,0,0,48,42,0,0,183,42,0,0,242,43,0,0,0,45,0,0,144,45,0,0,224,46,0,0,118,47,0,0,0,48,0,0,212,48,0,0,0,50,0,0,160,50,0,0,66,51,0,0,188,52,0,0,0,54,0,0,64,56,0,0,244,56,0,0,152,58,0,0,0,60,0,0,192,60,0,0,9,61,0,0,128,62,0,0,72,63,0,0,0,64,0,0,235,65,0,0,128,67,0,0,88,68,0,0,80,70,0,0,49,71,0,0,0,72,0,0,62,73,0,0,0,75,0,0,240,75,0,0,227,76,0,0,32,78,0,0,26,79,0,0,0,80,0,0,0,81,0,0,96,84,0,0,110,85,0,0,228,87,0,0,0,90,0,0,32,91,0,0,192,93,0,0,236,94,0,0,0,96,0,0,168,97,0,0,0,100,0,0,64,101,0,0,132,102,0,0,120,105,0,0,0,108,0,0,221,109,0,0,128,112,0,0,232,113,0,0,48,117,0,0,167,118,0,0,0,120,0,0,128,121,0,0,18,122,0,0,0,125,0,0,144,126,0,0,0,128,0,0,37,128,0,0,214,131,0,0,0,135,0,0,176,136,0,0,160,140,0,0,98,142,0,0,0,144,0,0,124,146,0,0,0,150,0,0,224,151,0,0,198,153,0,0,64,156,0,0,52,158,0,0,0,160,0,0,0,162,0,0,192,168,0,0,220,170,0,0,200,175,0,0,0,180,0,0,64,182,0,0,27,183,0,0,128,187,0,0,216,189,0,0,0,192,0,0,80,195,0,0,193,197,0,0,0,200,0,0,128,202,0,0,8,205,0,0,240,210,0,0,147,213,0,0,0,216,0,0,186,219,0,0,0,225,0,0,208,227,0,0,169,230,0,0,96,234,0,0,78,237,0,0,0,240,0,0,0,243,0,0,36,244,0,0,0,250,0,0,32,253,0,0,0,0,1,0,74,0,1,0,172,7,1,0,0,14,1,0,96,17,1,0,64,25,1,0,196,28,1,0,0,32,1,0,248,36,1,0,0,44,1,0,192,47,1,0,45,49,1,0,140,51,1,0,128,56,1,0,104,60,1,0,0,64,1,0,0,68,1,0,151,73,1,0,128,81,1,0,184,85,1,0,144,95,1,0,245,99,1,0,0,104,1,0,128,108,1,0,54,110,1,0,0,119,1,0,176,123,1,0,0,128,1,0,111,128,1,0,160,134,1,0,130,139,1,0,0,144,1,0,0,149,1,0,16,154,1,0,224,165,1,0,38,171,1,0,0,176,1,0,116,183,1,0,0,194,1,0,160,199,1,0,82,205,1,0,192,212,1,0,156,218,1,0,0,224,1,0,0,230,1,0,72,232,1,0,0,244,1,0,64,250,1,0,0,0,2,0,148,0,2,0,88,15,2,0,0,28,2,0,192,34,2,0,81,37,2,0,128,50,2,0,136,57,2,0,0,64,2,0,240,73,2,0,67,81,2,0,0,88,2,0,128,95,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30720);allocate([90,98,2,0,24,103,2,0,0,113,2,0,208,120,2,0,0,128,2,0,185,128,2,0,0,136,2,0,46,147,2,0,0,163,2,0,112,171,2,0,251,179,2,0,32,191,2,0,234,199,2,0,0,208,2,0,0,217,2,0,108,220,2,0,0,238,2,0,96,247,2,0,0,0,3,0,222,0,3,0,64,13,3,0,4,23,3,0,0,32,3,0,0,42,3,0,32,52,3,0,192,75,3,0,76,86,3,0,0,96,3,0,232,110,3,0,0,132,3,0,64,143,3,0,135,147,3,0,164,154,3,0,128,169,3,0,56,181,3,0,0,192,3,0,0,204,3,0,144,208,3,0,197,220,3,0,0,232,3,0,128,244,3,0,0,0,4,0,40,1,4,0,176,30,4,0,223,43,4,0,0,56,4,0,128,69,4,0,162,74,4,0,0,101,4,0,16,115,4,0,0,128,4,0,77,129,4,0,224,147,4,0,134,162,4,0,0,176,4,0,0,191,4,0,180,196,4,0,48,206,4,0,0,226,4,0,160,241,4,0,0,0,5,0,114,1,5,0,0,16,5,0,92,38,5,0,0,70,5,0,224,86,5,0,246,103,5,0,64,126,5,0,212,143,5,0,0,160,5,0,0,178,5,0,216,184,5,0,0,220,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,0,128,26,6,0,8,46,6,0,0,64,6,0,0,84,6,0,64,104,6,0,243,111,6,0,128,151,6,0,152,172,6,0,0,192,6,0,208,221,6,0,201,243,6,0,0,8,7,0,128,30,7,0,14,39,7,0,72,53,7,0,0,83,7,0,112,106,7,0,0,128,7,0,43,130,7,0,0,152,7,0,32,161,7,0,138,185,7,0,0,208,7,0,0,233,7,0,0,0,8,0,80,2,8,0,241,27,8,0,96,61,8,0,190,87,8,0,0,112,8,0,0,139,8,0,68,149,8,0,0,202,8,0,32,230,8,0,0,0,9,0,154,2,9,0,192,39,9,0,12,69,9,0,0,96,9,0,0,126,9,0,104,137,9,0,96,156,9,0,0,196,9,0,64,227,9,0,0,0,10,0,228,2,10,0,0,32,10,0,184,76,10,0,0,140,10,0,192,173,10,0,149,186,10,0,236,207,10,0,128,252,10,0,168,31,11,0,0,64,11,0,0,100,11,0,176,113,11,0,79,150,11,0,0,184,11,0,128,221,11,0,194,235,11,0,0,0,12,0,120,3,12,0,0,53,12,0,16,92,12,0,0,128,12,0,157,131,12,0,0,168,12,0,128,208,12,0,230,223,12,0,0,47,13,0,48,89,13,0,0,128,13,0,231,131,13,0,160,187,13,0,146,231,13,0,0,16,14,0,0,61,14,0,28,78,14,0,144,106,14,0,0,166,14,0,224,212,14,0,0,0,15,0,86,4,15,0,0,48,15,0,64,66,15,0,20,115,15,0,0,160,15,0,0,210,15,0,0,0,16,0,160,4,16,0,226,55,16,0,192,122,16,0,124,175,16,0,0,224,16,0,0,22,17,0,136,42,17,0,0,148,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,0,128,79,18,0,24,138,18,0,0,192,18,0,0,252,18,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,0,128,198,19,0,0,0,20,0,200,5,20,0,0,64,20,0,112,153,20,0,91,219,20,0,0,24,21,0,128,91,21,0,42,117,21,0,216,159,21,0,0,249,21,0,80,63,22,0,0,128,22,0,129,134,22,0,0,200,22,0,96,227,22,0,158,44,23,0,0,112,23,0,0,187,23,0,132,215,23,0,0,0,24,0,240,6,24,0,211,83,24,0,0,106,24,0,32,184,24,0,0,0,25,0,58,7,25,0,0,80,25,0,0,161,25,0,204,191,25,0,0,94,26,0,96,178,26,0,0,0,27,0,206,7,27,0,64,119,27,0,36,207,27,0,0,32,28,0,0,122,28,0,56,156,28,0,32,213,28,0,0,76,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,0,0,96,30,0,128,132,30,0,40,230,30,0,0,64,31,0,0,164,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,0,128,245,32,0,248,94,33,0,0,192,33,0,0,44,34,0,16,85,34,0,237,194,34,0,0,40,35,0,128,152,35,0,70,195,35,0,0,0,36,0,104,10,36,0,0,159,36,0,48,20,37,0,0,128,37,0,215,138,37,0,0,248,37,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,0,0,141,39,0,0,0,40,0,144,11,40,0,0,128,40,0,181,139,40,0,224,50,41,0,182,182,41,0,0,48,42,0,0,183,42,0,84,234,42,0,176,63,43,0,0,242,43,0,160,126,44,0,0,0,45,0,2,13,45,0,0,144,45,0,192,198,45,0,60,89,46,0,0,224,46,0,0,118,47,0,8,175,47,0,0,0,48,0,224,13,48,0,166,167,48,0,0,212,48,0,64,112,49,0,0,0,50,0,116,14,50,0,0,160,50,0,0,66,51,0,152,127,51,0,0,188,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,0,128,238,54,0,72,158,55,0,0,64,56,0,0,244,56,0,112,56,57,0,64,170,57,0,139,239,57,0,0,152,58,0,128,83,59,0,202,154,59,0,0,0,60,0,88,17,60,0,0,192,60,0,0,9,61,0,80,204,61,0,0,128,62,0,17,146,62,0,0,72,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,0,0,235,65,0,240,189,66,0,0,128,67,0,131,147,67,0,0,88,68,0,32,170,68,0,218,133,69,0,0,80,70,0,0,49,71,0,140,134,71,0,0,0,72,0,208,20,72,0,121,251,72,0,0,62,73,0,96,40,74,0,0,0,75,0,174,21,75,0,0,240,75,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,0,0,26,79,0,0,0,80,0,32,23,80,0,0,0,81,0,106,23,81,0,192,101,82,0,108,109,83,0,0,96,84,0,0,110,85,0,168,212,85,0,96,127,86,0,0,228,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,0,0,32,91,0,128,141,91,0,120,178,92,0,0,192,93,0,0,236,94,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,0,128,224,98,0,0,0,100,0,232,28,100,0,0,64,101,0,0,132,102,0,48,255,102,0,199,72,104,0,0,120,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,0,0,221,109,0,144,60,111,0,0,128,112,0,133,160,112,0,0,232,113,0,224,112,114,0,128,84,115,0,22,223,115,0,0,48,117,0,0,167,118,0,148,53,119,0,0,0,120,0,176,34,120,0,0,128,121,0,31,163,121,0,0,18,122,0,160,152,123,0,0,0,125,0,34,36,125,0,0,144,126,0,0,0,128,0,0,37,128,0,252,190,128,0,16,191,129,0,0,214,131,0,224,123,133,0,0,0,135,0,6,39,135,0,0,176,136,0,64,84,137,0,180,11,139,0,0,160,140,0,0,98,142,0,24,13,143,0,0,0,144,0,160,41,144,0,242,246,145,0,0,124,146,0,192,80,148,0,249,2,149,0,0,0,150,0,92,43,150,0,0,224,151,0,128,150,152,0,0,198,153,0,200,126,154,0,0,64,156,0,0,52,158,0,0,0,160,0,64,46,160,0,187,238,160,0,0,0,162,0,212,46,162,0,128,203,164,0,216,218,166,0,0,192,168,0,0,220,170,0,80,169,171,0,192,254,172,0,161,206,173,0,0,200,175,0,128,250,177,0,94,208,178,0,0,0,180,0,8,52,180,0,0,64,182,0,0,27,183,0,240,100,185,0,0,128,187,0,51,182,187,0,0,216,189,0,32,188,190,0,0,0,192,0,128,55,192,0,122,30,193,0,152,158,194,0,0,80,195,0,0,193,197,0,0,0,200,0,208,57,200,0,0,128,202,0,137,186,202,0,0,8,205,0,96,254,205,0,142,145,208,0,0,240,210,0,0,147,213,0,164,147,214,0,0,0,216,0,112,62,216,0,0,186,219,0,32,121,222,0,0,0,225,0,10,65,225,0,0,208,227,0,192,225,228,0,0,169,230,0,44,190,231,0,0,96,234,0,0,78,237,0,40,107,238,0,0,0,240,0,96,69,240,0,0,0,243,0,62,70,243,0,0,36,244,0,64,49,247,0,0,0,250,0,68,72,250,0,0,32,253,0,0,0,0,1,0,74,0,1,248,125,1,1,32,126,3,1,0,172,7,1,192,247,10,1,141,56,12,1,0,0,14,1,12,78,14,1,0,96,17,1,128,168,18,1,104,23,22,1,0,64,25,1,0,196,28,1,48,26,30,1,0,0,32,1,64,83,32,1,183,173,33,1,228,237,35,1,0,248,36,1,128,161,40,1,242,5,42,1,0,0,44,1,184,86,44,1,0,192,47,1,0,45,49,1,0,140,51,1,144,253,52,1,0,128,56,1,85,218,56,1,0,104,60,1,0,0,64,1,128,92,64,1,118,221,65,1,0,0,68,1,168,93,68,1,0,151,73,1,176,181,77,1,0,128,81,1,143,225,81,1,0,184,85,1,160,82,87,1,128,253,89,1,66,157,91,1,0,144,95,1,0,245,99,1,188,160,101,1,0,0,104,1,16,104,104,1,0,128,108,1,93,233,108,1,0,54,110,1,224,201,114,1,0,0,119,1,102,108,119,1,0,176,123,1,64,120,125,1,0,0,128,1,0,111,128,1,244,60,130,1,48,61,133,1,0,160,134,1,0,130,139,1,0,0,144,1,160,115,144,1,0,0,149,1,18,117,149,1,0,16,154,1,192,252,155,1,28,35,161,1,0,224,165,1,0,38,171,1,72,39,173,1,0,0,176,1,224,124,176,1,0,116,183,1,64,242,188,1,235,8,191,1,0,0,194,1,20,130,194,1,0,160,199,1,128,195,201,1,0,82,205,1,88,124,207,1,0,192,212,1,0,156,218,1,80,214,220,1,0,0,224,1,192,138,224,1,49,204,226,1,0,0,230,1,124,140,230,1,0,72,232,1,128,98,238,1,0,0,244,1,136,144,244,1,0,64,250,1,0,0,0,2,0,148,0,2,240,251,2,2,64,252,6,2,227,107,9,2,0,88,15,2,128,239,21,2,26,113,24,2,0,0,28,2,24,156,28,2,0,192,34,2,0,81,37,2,208,46,44,2,0,128,50,2,153,34,51,2,0,136,57,2,96,52,60,2,0,0,64,2,128,166,64,2,110,91,67,2,200,219,71,2,0,240,73,2,0,67,81,2,228,11,84,2,0,0,88,2,112,173,88,2,0,128,95,2,155,47,96,2,0,90,98,2,0,24,103,2,32,251,105,2,0,0,113,2,170,180,113,2,0,208,120,2,0,0,128,2,0,185,128,2,236,186,131,2,0,0,136,2,80,187,136,2,0,46,147,2,96,107,155,2,0,0,163,2,30,195,163,2,0,112,171,2,64,165,174,2,0,251,179,2,132,58,183,2,0,32,191,2,0,234,199,2,120,65,203,2,0,0,208,2,32,208,208,2,0,0,217,2,186,210,217,2,0,108,220,2,192,147,229,2,221,14,233,2,0,0,238,2,204,216,238,2,0,96,247,2,128,240,250,2,0,0,0,3,0,222,0,3,232,121,4,3,96,122,10,3,0,64,13,3,0,4,23,3,0,0,32,3,64,231,32,3,167,169,36,3,0,0,42,3,36,234,42,3,0,32,52,3,128,249,55,3,56,70,66,3,0,192,75,3,0,76,86,3,144,78,90,3,0,0,96,3,192,249,96,3,37,9,101,3,0,232,110,3,128,228,121,3,214,17,126,3,0,0,132,3,40,4,133,3,0,64,143,3,0,135,147,3,0,164,154,3,176,248,158,3,0,128,169,3,255,142,170,3,0,56,181,3,160,172,185,3,0,0,192,3,128,21,193,3,98,152,197,3,0,0,204,3,248,24,205,3,0,144,208,3,0,197,220,3,0,0,232,3,16,33,233,3,0,128,244,3,173,164,245,3,0,0,0,4,0,40,1,4,224,247,5,4,128,248,13,4,198,215,18,4,0,176,30,4,0,223,43,4,52,226,48,4,0,0,56,4,48,56,57,4,0,128,69,4,0,162,74,4,160,93,88,4,0,0,101,4,50,69,102,4,0,16,115,4,192,104,120,4,0,0,128,4,0,77,129,4,220,182,134,4,144,183,143,4,0,224,147,4,0,134,162,4,200,23,168,4,0,0,176,4,224,90,177,4,0,0,191,4,54,95,192,4,0,180,196,4,0,48,206,4,64,246,211,4,0,0,226,4,84,105,227,4,0,160,241,4,0,0,0,5,0,114,1,5,216,117,7,5,0,0,16,5,160,118,17,5,0,92,38,5,192,214,54,5,193,26,61,5,0,0,70,5,60,134,71,5,0,224,86,5,128,74,93,5,0,246,103,5,8,117,110,5,0,64,126,5,0,212,143,5,240,130,150,5,0,0,160,5,64,160,161,5,147,100,168,5,0,0,178,5,116,165,179,5,0,216,184,5,128,39,203,5,186,29,210,5,0,0,220,5,152,177,221,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,208,243,8,6,192,244,20,6,0,128,26,6,169,67,28,6,0,8,46,6,0,0,64,6,128,206,65,6,78,83,73,6,0,0,84,6,72,212,85,6,0,64,104,6,0,243,111,6,112,140,132,6,0,128,151,6,203,103,153,6,0,152,172,6,32,157,180,6,0,0,192,6,128,243,193,6,74,18,202,6,0,208,221,6,0,201,243,6,172,35,252,6,0,0,8,7,80,8,10,7,0,128,30,7,209,142,32,7,0,14,39,7,0,72,53,7,96,241,61,7,0,0,83,7,254,29,85,7,0,112,106,7,64,89,115,7,0,0,128,7,0,43,130,7,196,48,139,7,0,0,152,7,240,49,154,7,0,32,161,7,0,138,185,7,0,0,208,7,32,66,210,7,0,0,233,7,90,73,235,7,0,0,0,8,0,80,2,8,192,239,11,8,0,241,27,8,140,175,37,8,0,96,61,8,0,190,87,8,104,196,97,8,0,0,112,8,96,112,114,8,0,0,139,8,0,68,149,8,64,187,176,8,151,44,187,8,0,0,202,8,100,138,204,8,0,32,230,8,128,209,240,8,0,0,0,9,0,154,2,9,184,109,13,9,32,111,31,9,0,192,39,9,0,12,69,9,144,47,80,9,0,0,96,9,192,181,98,9,245,252,109,9,0,0,126,9,108,190,128,9,0,104,137,9,0,96,156,9,128,236,167,9,0,0,196,9,168,210,198,9,0,64,227,9,0,0,0,10,0,228,2,10,176,235,14,10,0,0,32,10,64,237,34,10,111,27,47,10,0,184,76,10,128,173,109,10,130,53,122,10,0,0,140,10,120,12,143,10,0,192,173,10,0,149,186,10,0,236,207,10,16,234,220,10,0,128,252,10,253,172,255,10,0,168,31,11,224,5,45,11,0,0,64,11,128,64,67,11,38,201,80,11,0,0,100,11,232,74,103,11,0,176,113,11,0,79,150,11,116,59,164,11,0,0,184,11,48,99,187,11,0,128,221,11,7,238,224,11,0,194,235,11,0,0,0,12,0,120,3,12,160,231,17,12,128,233,41,12,0,0,53,12,82,135,56,12,0,16,92,12,0,0,128,12,0,157,131,12,156,166,146,12,0,0,168,12,144,168,171,12,0,128,208,12,0,230,223,12,224,24,9,13,0,0,47,13,150,207,50,13,0,48,89,13,64,58,105,13,0,0,128,13,0,231,131,13,148,36,148,13,0,160,187,13,0,146,231,13,88,71,248,13,0,0,16,14,160,16,20,14,0,0,61,14,162,29,65,14,0,28,78,14,0,144,106,14,192,226,123,14,81,74,141,14,0,0,166,14,252,59,170,14,0,224,212,14,128,178,230,14,0,0,0,15,0,86,4,15,136,97,22,15,0,0,48,15,224,99,52,15,0,64,66,15,0,20,115,15,0,0,160,15,64,132,164,15,67,80,183,15,0,0,210,15,180,146,214,15,0,0,0,16,0,160,4,16,128,223,23,16,0,226,55,16,24,95,75,16,0,192,122,16,0,124,175,16,208,136,195,16,0,0,224,16,192,224,228,16,185,45,249,16,0,0,22,17,0,136,42,17,128,118,97,17,46,89,118,17,0,0,148,17,200,20,153,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,112,219,26,18,64,222,62,18,0,128,79,18,251,202,84,18,0,24,138,18,32,95,160,18,0,0,192,18,128,107,197,18,234,249,219,18,0,0,252,18,216,124,1,19,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,80,165,141,19,0,128,198,19,97,55,204,19,0,0,0,20,0,200,5,20,96,215,29,20,0,0,64,20,128,218,69,20,222,54,94,20,0,112,153,20,0,91,219,20,4,107,244,20,0,0,24,21,240,24,30,21,0,128,91,21,0,42,117,21,0,216,159,21,32,212,185,21,0,0,249,21,250,89,255,21,0,80,63,22,192,11,90,22,0,0,128,22,0,129,134,22,76,146,161,22,0,0,200,22,208,149,206,22,0,96,227,22,0,158,44,23,232,118,72,23,0,0,112,23,96,198,118,23,0,0,187,23,14,220,193,23,0,132,215,23,0,0,0,24,0,240,6,24,64,207,35,24,0,211,83,24,0,0,106,24,164,14,113,24,0,32,184,24,0,0,0,25,0,58,7,25,56,77,37,25,0,0,80,25,32,81,87,25,0,0,161,25,0,204,191,25,192,49,18,26,197,133,49,26,0,0,94,26,44,159,101,26,0,96,178,26,128,116,210,26,0,0,0,27,0,206,7,27,40,73,40,27,0,64,119,27,0,36,207,27,176,142,240,27,0,0,32,28,64,33,40,28,223,246,73,28,0,0,122,28,68,59,130,28,0,56,156,28,0,32,213,28,128,197,247,28,162,148,26,29,0,0,76,29,248,119,84,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,16,195,44,30,0,0,96,30,192,199,104,30,0,128,132,30,77,82,141,30,0,40,230,30,0,0,64,31,128,8,73,31,134,160,110,31,0,0,164,31,104,37,173,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,48,190,150,32,0,128,245,32,247,6,255,32,0,248,94,33,160,17,135,33,0,0,192,33,128,193,201,33,114,91,242,33,0,0,44,34,0,16,85,34,0,237,194,34,92,178,236,34,0,0,40,35,144,41,50,35,0,128,152,35,21,202,162,35,0,70,195,35,0,0,0,36,0,104,10,36,224,182,53,36,128,188,125,36,0,0,159,36,246,149,169,36,0,48,20,37,64,190,64,37,0,0,128,37,0,215,138,37,212,243,183,37,0,0,248,37,176,249,2,38,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,160,74,27,39,0,0,141,39,194,110,152,39,0,0,0,40,0,144,11,40,192,174,59,40,0,0,128,40,0,181,139,40,188,109,188,40,0,224,50,41,0,182,182,41,8,214,232,41,0,0,48,42,224,49,60,42,0,0,183,42,0,84,234,42,0,176,63,43,64,168,115,43,243,222,167,43,0,0,242,43,244,179,254,43,0,160,126,44,128,23,180,44,0,0,0,45,0,2,13,45,152,36,67,45,0,0,144,45,160,43,157,45,0,192,198,45,0,60,89,46,208,237,144,46,0,0,224,46,192,140,237,46,201,240,37,47,0,0,118,47,28,184,131,47,0,8,175,47,0,0,0,48,0,224,13,48,128,158,71,48,0,166,167,48,0,0,212,48,72,29,226,48,0,64,112,49,0,0,0,50,0,116,14,50,112,154,74,50,0,0,160,50,64,162,174,50,43,137,235,50,0,0,66,51,0,152,127,51,128,99,36,52,138,11,99,52,0,0,188,52,88,62,203,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,80,146,80,54,0,128,238,54,241,96,254,54,0,72,158,55,96,29,225,55,0,0,64,56,128,66,80,56,190,237,147,56,0,0,244,56,136,118,4,57,0,112,56,57,0,64,170,57,0,139,239,57,68,41,53,58,0,0,152,58,240,239,168,58,0,128,83,59,35,166,100,59,0,202,154,59,0,0,0,60,0,88,17,60,32,134,89,60,0,0,192,60,128,143,209,60,0,0,9,61,154,164,26,61,0,80,204,61,0,0,128,62,0,17,146,62,12,65,221,62,0,0,72,63,208,74,90,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,96,124,45,65,0,0,235,65,238,13,254,65,0,240,189,66,64,35,14,67,0,0,128,67,0,131,147,67,228,182,228,67,0,0,88,68,0,32,170,68,0,218,133,69,184,100,217,69,0,0,80,70,32,83,100,70,0,0,49,71,42,148,69,71,0,140,134,71,0,0,0,72,0,208,20,72,192,109,107,72,149,115,194,72,0,121,251,72,0,0,62,73,236,43,83,73,0,96,40,74,128,124,129,74,0,0,0,75,0,174,21,75,168,231,111,75,0,0,240,75,96,243,5,76,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,64,149,54,78,79,145,148,78,0,0,26,79,132,221,48,79,0,0,0,80,0,32,23,80,128,93,119,80,0,0,0,81,0,106,23,81,120,219,120,81,0,192,101,82,0,108,109,83,16,172,209,83,0,0,96,84,192,99,120,84,157,228,221,84,0,0,110,85,0,168,212,85,0,96,127,86,128,80,231,86,230,189,79,87,0,0,228,87,232,103,253,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,48,73,134,90,0,0,32,91,64,87,58,91,0,128,141,91,231,246,167,91,0,120,178,92,160,219,33,93,0,0,192,93,128,25,219,93,146,225,75,94,0,0,236,94,56,112,7,95,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,144,58,196,97,0,128,224,98,229,20,253,98,0,0,0,100,0,232,28,100,224,52,149,100,0,0,64,101,128,68,93,101,86,18,215,101,0,0,132,102,0,48,255,102,0,199,72,104,20,23,198,104,0,0,120,105,176,124,150,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,160,36,161,108,0,0,221,109,226,193,252,109,0,144,60,111,192,58,194,111,0,0,128,112,0,133,160,112,124,219,39,113,0,0,232,113,16,237,8,114,0,224,112,114,0,128,84,115,0,22,223,115,136,82,106,116,0,0,48,117,224,223,81,117,0,0,167,118,70,76,201,118,0,148,53,119,0,0,0,120,0,176,34,120,64,12,179,120,0,0,128,121,0,31,163,121,0,0,18,122,52,73,53,122,0,160,152,123,0,0,0,125,0,34,36,125,24,130,186,125,0,0,144,126,160,149,180,126,29,0,0,0,29,0,0,0,30,0,0,0,30,0,0,0,31,0,0,0,31,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,0,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,0,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,56,32,0,0,74,0,0,0,75,0,0,0,76,0,0,0,21,0,0,0,77,0,0,0,0,0,0,0,40,32,0,0,78,0,0,0,79,0,0,0,80,0,0,0,21,0,0,0,81,0,0,0,0,0,0,0,24,32,0,0,82,0,0,0,83,0,0,0,84,0,0,0,21,0,0,0,85,0,0,0,0,0,0,0,8,32,0,0,86,0,0,0,87,0,0,0,88,0,0,0,21,0,0,0,89,0,0,0,0,0,0,0,248,31,0,0,90,0,0,0,91,0,0,0,92,0,0,0,21,0,0,0,93,0,0,0,0,0,0,0,232,31,0,0,94,0,0,0,95,0,0,0,96,0,0,0,21,0,0,0,97,0,0,0,0,0,0,0,216,31,0,0,98,0,0,0,99,0,0,0,41,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,200,31,0,0,98,0,0,0,100,0,0,0,42,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,184,31,0,0,98,0,0,0,101,0,0,0,43,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,168,31,0,0,98,0,0,0,102,0,0,0,44,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,152,31,0,0,98,0,0,0,103,0,0,0,45,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,88,31,0,0,98,0,0,0,104,0,0,0,46,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,120,31,0,0,105,0,0,0,106,0,0,0,107,0,0,0,21,0,0,0,108,0,0,0,0,0,0,0,104,31,0,0,12,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,131,177,3,0,137,177,3,0,142,177,3,0,149,177,3,0,221,79,7,0,155,177,3,0,163,177,3,0,171,177,3,0,0,0,0,0,80,32,0,0,112,0,0,0,113,0,0,0,7,0,0,0,13,0,0,0,114,0,0,0,19,0,0,0,0,0,0,0,88,32,0,0,115,0,0,0,116,0,0,0,117,0,0,0,21,0,0,0,118,0,0,0,0,0,0,0,128,32,0,0,119,0,0,0,120,0,0,0,121,0,0,0,21,0,0,0,122,0,0,0,0,0,0,0,112,32,0,0,123,0,0,0,124,0,0,0,14,0,0,0,20,0,0,0,15,0,0,0,16,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,4,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,21,0,0,0,20,0,0,0,128,0,0,0,21,0,0,0,22,0,0,0,47,0,0,0,8,0,0,0,22,0,0,0,8,0,0,0,8,0,0,0,14,0,0,0,0,0,0,195,0,0,254,194,0,0,252,194,0,0,250,194,0,0,248,194,0,0,246,194,0,0,244,194,0,0,242,194,0,0,240,194,0,0,238,194,0,0,236,194,0,0,234,194,0,0,232,194,0,0,230,194,0,0,228,194,0,0,226,194,0,0,224,194,0,0,222,194,0,0,220,194,0,0,218,194,0,0,216,194,0,0,214,194,0,0,212,194,0,0,210,194,0,0,208,194,0,0,206,194,0,0,204,194,0,0,202,194,0,0,200,194,0,0,198,194,0,0,196,194,0,0,194,194,0,0,192,194,0,0,190,194,0,0,188,194,0,0,186,194,0,0,184,194,0,0,182,194,0,0,180,194,0,0,178,194,0,0,176,194,0,0,174,194,0,0,172,194,0,0,170,194,0,0,168,194,0,0,166,194,0,0,164,194,0,0,162,194,0,0,160,194,0,0,158,194,0,0,156,194,0,0,154,194,0,0,152,194,0,0,150,194,0,0,148,194,0,0,146,194,0,0,144,194,0,0,142,194,0,0,140,194,0,0,138,194,0,0,136,194,0,0,134,194,0,0,132,194,0,0,130,194,0,0,128,194,0,0,124,194,0,0,120,194,0,0,116,194,0,0,112,194,0,0,108,194,0,0,104,194,0,0,100,194,0,0,96,194,0,0,92,194,0,0,88,194,0,0,84,194,0,0,80,194,0,0,76,194,0,0,72,194,0,0,68,194,0,0,64,194,0,0,60,194,0,0,56,194,0,0,52,194,0,0,48,194,0,0,44,194,0,0,40,194,0,0,36,194,0,0,32,194,0,0,28,194,0,0,24,194,0,0,20,194,0,0,16,194,0,0,12,194,0,0,8,194,0,0,4,194,0,0,0,194,0,0,248,193,0,0,240,193,0,0,232,193,0,0,224,193,0,0,216,193,0,0,208,193,0,0,200,193,0,0,192,193,0,0,184,193,0,0,176,193,0,0,168,193,0,0,160,193,0,0,152,193,0,0,144,193,0,0,136,193,0,0,128,193,0,0,112,193,0,0,96,193,0,0,80,193,0,0,64,193,0,0,48,193,0,0,32,193,0,0,16,193,0,0,0,193,0,0,224,192,0,0,192,192,0,0,160,192,0,0,128,192,0,0,64,192,0,0,0,192,0,0,128,191,0,0,0,0,0,0,128,63,0,0,0,64,0,0,64,64,0,0,128,64,0,0,160,64,0,0,192,64,0,0,224,64,0,0,0,65,0,0,16,65,0,0,32,65,0,0,48,65,0,0,64,65,0,0,80,65,0,0,96,65,0,0,112,65,0,0,128,65,0,0,136,65,0,0,144,65,0,0,152,65,0,0,160,65,0,0,168,65,0,0,176,65,0,0,184,65,0,0,192,65,0,0,200,65,0,0,208,65,0,0,216,65,0,0,224,65,0,0,232,65,0,0,240,65,0,0,248,65,0,0,0,66,0,0,4,66,0,0,8,66,0,0,12,66,0,0,16,66,0,0,20,66,0,0,24,66,0,0,28,66,0,0,32,66,0,0,36,66,0,0,40,66,0,0,44,66,0,0,48,66,0,0,52,66,0,0,56,66,0,0,60,66,0,0,64,66,0,0,68,66,0,0,72,66,0,0,76,66,0,0,80,66,0,0,84,66,0,0,88,66,0,0,92,66,0,0,96,66,0,0,100,66,0,0,104,66,0,0,108,66,0,0,112,66,0,0,116,66,0,0,120,66,0,0,124,66,0,0,128,66,0,0,130,66,0,0,132,66,0,0,134,66,0,0,136,66,0,0,138,66,0,0,140,66,0,0,142,66,0,0,144,66,0,0,146,66,0,0,148,66,0,0,150,66,0,0,152,66,0,0,154,66,0,0,156,66,0,0,158,66,0,0,160,66,0,0,162,66,0,0,164,66,0,0,166,66,0,0,168,66,0,0,170,66,0,0,172,66,0,0,174,66,0,0,176,66,0,0,178,66,0,0,180,66,0,0,182,66,0,0,184,66,0,0,186,66,0,0,188,66,0,0,190,66,0,0,192,66,0,0,194,66,0,0,196,66,0,0,198,66,0,0,200,66,0,0,202,66,0,0,204,66,0,0,206,66,0,0,208,66,0,0,210,66,0,0,212,66,0,0,214,66,0,0,216,66,0,0,218,66,0,0,220,66,0,0,222,66,0,0,224,66,0,0,226,66,0,0,228,66,0,0,230,66,0,0,232,66,0,0,234,66,0,0,236,66,0,0,238,66,0,0,240,66,0,0,242,66,0,0,244,66,0,0,246,66,0,0,248,66,0,0,250,66,0,0,252,66,0,0,254,66,0,0,0,67,0,0,1,67,0,0,2,67,0,0,3,67,0,0,4,67,0,0,5,67,0,0,6,67,0,0,7,67,0,0,8,67,0,0,9,67,0,0,10,67,0,0,11,67,0,0,12,67,0,0,13,67,0,0,14,67,0,0,15,67,0,0,16,67,0,0,17,67,0,0,18,67,0,0,19,67,0,0,20,67,0,0,21,67,0,0,22,67,0,0,23,67,0,0,24,67,0,0,25,67,0,0,26,67,0,0,27,67,0,0,28,67,0,0,29,67,0,0,30,67,0,0,31,67,0,0,32,67,0,0,33,67,0,0,34,67,0,0,35,67,0,0,36,67,0,0,37,67,0,0,38,67,0,0,39,67,0,0,40,67,0,0,41,67,0,0,42,67,0,0,43,67,0,0,44,67,0,0,45,67,0,0,46,67,0,0,47,67,0,0,48,67,0,0,49,67,0,0,50,67,0,0,51,67,0,0,52,67,0,0,53,67,0,0,54,67,0,0,55,67,0,0,56,67,0,0,57,67,0,0,58,67,0,0,59,67,0,0,60,67,0,0,61,67,0,0,62,67,0,0,63,67,0,0,64,67,0,0,65,67,0,0,66,67,0,0,67,67,0,0,68,67,0,0,69,67,0,0,70,67,0,0,71,67,0,0,72,67,0,0,73,67,0,0,74,67,0,0,75,67,0,0,76,67,0,0,77,67,0,0,78,67,0,0,79,67,0,0,80,67,0,0,81,67,0,0,82,67,0,0,83,67,0,0,84,67,0,0,85,67,0,0,86,67,0,0,87,67,0,0,88,67,0,0,89,67,0,0,90,67,0,0,91,67,0,0,92,67,0,0,93,67,0,0,94,67,0,0,95,67,0,0,96,67,0,0,97,67,0,0,98,67,0,0,99,67,0,0,100,67,0,0,101,67,0,0,102,67,0,0,103,67,0,0,104,67,0,0,105,67,0,0,106,67,0,0,107,67,0,0,108,67,0,0,109,67,0,0,110,67,0,0,111,67,0,0,112,67,0,0,113,67,0,0,114,67,0,0,115,67,0,0,116,67,0,0,117,67,0,0,118,67,0,0,119,67,0,0,120,67,0,0,121,67,0,0,122,67,0,0,123,67,0,0,124,67,0,0,125,67,0,0,126,67,0,0,127,67,0,0,0,0,168,32,0,0,129,0,0,0,130,0,0,0,131,0,0,0,21,0,0,0,132,0,0,0,0,0,0,0,144,32,0,0,133,0,0,0,134,0,0,0,33,0,0,0,23,0,0,0,48,0,0,0,11,0,0,0,38,0,0,0,49,0,0,0,50,0,0,0,135,0,0,0,0,0,0,0,208,32,0,0,136,0,0,0,137,0,0,0,138,0,0,0,21,0,0,0,139,0,0,0,0,0,0,0,184,32,0,0,140,0,0,0,141,0,0,0,22,0,0,0,29,0,0,0,0,0,0,0,240,32,0,0,142,0,0,0,143,0,0,0,144,0,0,0,21,0,0,0,145,0,0,0,0,0,0,0,224,32,0,0,133,0,0,0,146,0,0,0,34,0,0,0,24,0,0,0,51,0,0,0,12,0,0,0,39,0,0,0,52,0,0,0,53,0,0,0,147,0,0,0,0,0,0,0,16,33,0,0,148,0,0,0,149,0,0,0,150,0,0,0,21,0,0,0,151,0,0,0,0,0,0,0,0,33,0,0,140,0,0,0,152,0,0,0,23,0,0,0,30,0,0,0,0,0,0,0,48,33,0,0,153,0,0,0,154,0,0,0,155,0,0,0,21,0,0,0,156,0,0,0,0,0,0,0,32,33,0,0,133,0,0,0,157,0,0,0,35,0,0,0,25,0,0,0,54,0,0,0,13,0,0,0,40,0,0,0,55,0,0,0,56,0,0,0,158,0,0,0,0,0,0,0,80,33,0,0,159,0,0,0,160,0,0,0,161,0,0,0,21,0,0,0,162,0,0,0,0,0,0,0,64,33,0,0,140,0,0,0,163,0,0,0,24,0,0,0,31,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,12,0,0,0,13,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,0,0,0,0,17,0,0,0,18,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,0,0,0,0,96,33,0,0,38,0,0,0,164,0,0,0,26,0,0,0,0,0,0,0,112,33,0,0,165,0,0,0,166,0,0,0,27,0,0,0,0,0,0,0,128,33,0,0,167,0,0,0,168,0,0,0,28,0,0,0,0,0,0,0,144,33,0,0,169,0,0,0,170,0,0,0,1,0,0,0,0,0,0,0,152,33,0,0,171,0,0,0,172,0,0,0,1,0,0,0,173,0,0,0,0,0,0,0,160,33,0,0,174,0,0,0,175,0,0,0,1,0,0,0,176,0,0,0,0,0,0,0,168,33,0,0,177,0,0,0,178,0,0,0,9,0,0,0,10,0,0,0,29,0,0,0,22,0,0,0,0,0,0,0,64,35,0,0,179,0,0,0,180,0,0,0,181,0,0,0,21,0,0,0,182,0,0,0,0,0,0,0,16,35,0,0,183,0,0,0,184,0,0,0,185,0,0,0,21,0,0,0,186,0,0,0,0,0,0,0,224,34,0,0,187,0,0,0,188,0,0,0,189,0,0,0,21,0,0,0,190,0,0,0,0,0,0,0,192,34,0,0,191,0,0,0,192,0,0,0,193,0,0,0,21,0,0,0,194,0,0,0,0,0,0,0,160,34,0,0,195,0,0,0,196,0,0,0,197,0,0,0,21,0,0,0,198,0,0,0,0,0,0,0,128,34,0,0,199,0,0,0,200,0,0,0,201,0,0,0,21,0,0,0,202,0,0,0,0,0,0,0,96,34,0,0,203,0,0,0,204,0,0,0,205,0,0,0,21,0,0,0,206,0,0,0,0,0,0,0,64,34,0,0,207,0,0,0,208,0,0,0,209,0,0,0,21,0,0,0,210,0,0,0,0,0,0,0,32,34,0,0,211,0,0,0,212,0,0,0,213,0,0,0,21,0,0,0,214,0,0,0,0,0,0,0,0,34,0,0,215,0,0,0,216,0,0,0,217,0,0,0,21,0,0,0,218,0,0,0,0,0,0,0,224,33,0,0,219,0,0,0,220,0,0,0,221,0,0,0,21,0,0,0,222,0,0,0,0,0,0,0,192,33,0,0,223,0,0,0,224,0,0,0,225,0,0,0,21,0,0,0,226,0,0,0,0,0,0,0,176,33,0,0,227,0,0,0,228,0,0,0,23,0,0,0,0,0,0,0,208,33,0,0,229,0,0,0,230,0,0,0,24,0,0,0,0,0,0,0,240,33,0,0,231,0,0,0,232,0,0,0,25,0,0,0,0,0,0,0,16,34,0,0,233,0,0,0,234,0,0,0,26,0,0,0,0,0,0,0,48,34,0,0,235,0,0,0,236,0,0,0,27,0,0,0,0,0,0,0,80,34,0,0,237,0,0,0,238,0,0,0,28,0,0,0,0,0,0,0,112,34,0,0,239,0,0,0,240,0,0,0,29,0,0,0,0,0,0,0,144,34,0,0,241,0,0,0,242,0,0,0,30,0,0,0,0,0,0,0,176,34,0,0,243,0,0,0,244,0,0,0,31,0,0,0,0,0,0,0,208,34,0,0,245,0,0,0,246,0,0,0,32,0,0,0,0,0,0,0,0,35,0,0,247,0,0,0,248,0,0,0,33,0,0,0,0,0,0,0,240,34,0,0,247,0,0,0,249,0,0,0,34,0,0,0,0,0,0,0,48,35,0,0,250,0,0,0,251,0,0,0,35,0,0,0,0,0,0,0,32,35,0,0,250,0,0,0,252,0,0,0,36,0,0,0,0,0,0,0,80,38,0,0,253,0,0,0,254,0,0,0,255,0,0,0,21,0,0,0,0,1,0,0,0,0,0,0,64,38,0,0,1,1,0,0,2,1,0,0,3,1,0,0,21,0,0,0,4,1,0,0,0,0,0,0,48,38,0,0,5,1,0,0,6,1,0,0,7,1,0,0,21,0,0,0,8,1,0,0,0,0,0,0,32,38,0,0,9,1,0,0,10,1,0,0,11,1,0,0,21,0,0,0,12,1,0,0,0,0,0,0,16,38,0,0,13,1,0,0,14,1,0,0,15,1,0,0,21,0,0,0,16,1,0,0,0,0,0,0,0,38,0,0,17,1,0,0,18,1,0,0,19,1,0,0,21,0,0,0,20,1,0,0,0,0,0,0,240,37,0,0,21,1,0,0,22,1,0,0,23,1,0,0,21,0,0,0,24,1,0,0,0,0,0,0,224,37,0,0,25,1,0,0,26,1,0,0,27,1,0,0,21,0,0,0,28,1,0,0,0,0,0,0,208,37,0,0,29,1,0,0,30,1,0,0,31,1,0,0,21,0,0,0,32,1,0,0,0,0,0,0,192,37,0,0,33,1,0,0,34,1,0,0,35,1,0,0,21,0,0,0,36,1,0,0,0,0,0,0,160,37,0,0,37,1,0,0,38,1,0,0,39,1,0,0,21,0,0,0,40,1,0,0,0,0,0,0,96,37,0,0,41,1,0,0,42,1,0,0,43,1,0,0,21,0,0,0,44,1,0,0,0,0,0,0,32,37,0,0,45,1,0,0,46,1,0,0,47,1,0,0,21,0,0,0,48,1,0,0,0,0,0,0,240,36,0,0,49,1,0,0,50,1,0,0,51,1,0,0,21,0,0,0,52,1,0,0,0,0,0,0,192,36,0,0,53,1,0,0,54,1,0,0,55,1,0,0,21,0,0,0,56,1,0,0,0,0,0,0,144,36,0,0,57,1,0,0,58,1,0,0,59,1,0,0,21,0,0,0,60,1,0,0,0,0,0,0,96,36,0,0,61,1,0,0,62,1,0,0,63,1,0,0,21,0,0,0,64,1,0,0,0,0,0,0,48,36,0,0,65,1,0,0,66,1,0,0,67,1,0,0,21,0,0,0,68,1,0,0,0,0,0,0,0,36,0,0,69,1,0,0,70,1,0,0,71,1,0,0,21,0,0,0,72,1,0,0,0,0,0,0,208,35,0,0,73,1,0,0,74,1,0,0,75,1,0,0,21,0,0,0,76,1,0,0,0,0,0,0,160,35,0,0,77,1,0,0,78,1,0,0,79,1,0,0,21,0,0,0,80,1,0,0,0,0,0,0,112,35,0,0,81,1,0,0,82,1,0,0,83,1,0,0,21,0,0,0,84,1,0,0,0,0,0,0,96,35,0,0,85,1,0,0,86,1,0,0,36,0,0,0,173,0,0,0,0,0,0,0,80,35,0,0,85,1,0,0,87,1,0,0,37,0,0,0,173,0,0,0,0,0,0,0,144,35,0,0,88,1,0,0,89,1,0,0,38,0,0,0,173,0,0,0,0,0,0,0,128,35,0,0,88,1,0,0,90,1,0,0,39,0,0,0,173,0,0,0,0,0,0,0,192,35,0,0,91,1,0,0,92,1,0,0,40,0,0,0,173,0,0,0,0,0,0,0,176,35,0,0,91,1,0,0,93,1,0,0,41,0,0,0,173,0,0,0,0,0,0,0,240,35,0,0,94,1,0,0,95,1,0,0,42,0,0,0,173,0,0,0,0,0,0,0,224,35,0,0,94,1,0,0,96,1,0,0,43,0,0,0,173,0,0,0,0,0,0,0,32,36,0,0,97,1,0,0,98,1,0,0,44,0,0,0,173,0,0,0,0,0,0,0,16,36,0,0,97,1,0,0,99,1,0,0,45,0,0,0,173,0,0,0,0,0,0,0,80,36,0,0,100,1,0,0,101,1,0,0,46,0,0,0,173,0,0,0,0,0,0,0,64,36,0,0,100,1,0,0,102,1,0,0,47,0,0,0,173,0,0,0,0,0,0,0,128,36,0,0,103,1,0,0,104,1,0,0,48,0,0,0,173,0,0,0,0,0,0,0,112,36,0,0,103,1,0,0,105,1,0,0,49,0,0,0,173,0,0,0,0,0,0,0,176,36,0,0,106,1,0,0,107,1,0,0,50,0,0,0,173,0,0,0,0,0,0,0,160,36,0,0,106,1,0,0,108,1,0,0,51,0,0,0,173,0,0,0,0,0,0,0,224,36,0,0,109,1,0,0,110,1,0,0,52,0,0,0,173,0,0,0,0,0,0,0,208,36,0,0,109,1,0,0,111,1,0,0,53,0,0,0,173,0,0,0,0,0,0,0,16,37,0,0,112,1,0,0,113,1,0,0,54,0,0,0,173,0,0,0,0,0,0,0,0,37,0,0,112,1,0,0,114,1,0,0,55,0,0,0,173,0,0,0,0,0,0,0,64,37,0,0,115,1,0,0,116,1,0,0,56,0,0,0,173,0,0,0,0,0,0,0,48,37,0,0,115,1,0,0,117,1,0,0,57,0,0,0,173],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+40960);allocate([80,37,0,0,115,1,0,0,118,1,0,0,58,0,0,0,173,0,0,0,0,0,0,0,128,37,0,0,119,1,0,0,120,1,0,0,59,0,0,0,173,0,0,0,0,0,0,0,112,37,0,0,119,1,0,0,121,1,0,0,60,0,0,0,173,0,0,0,0,0,0,0,144,37,0,0,119,1,0,0,122,1,0,0,61,0,0,0,173,0,0,0,0,0,0,0,176,37,0,0,112,1,0,0,123,1,0,0,62,0,0,0,173,0,0,0,0,0,0,0,96,38,0,0,63,0,0,0,124,1,0,0,125,1,0,0,25,0,0,0,126,1,0,0,0,0,0,0,0,40,0,0,127,1,0,0,128,1,0,0,129,1,0,0,21,0,0,0,130,1,0,0,0,0,0,0,224,39,0,0,131,1,0,0,132,1,0,0,133,1,0,0,21,0,0,0,134,1,0,0,0,0,0,0,192,39,0,0,135,1,0,0,136,1,0,0,137,1,0,0,21,0,0,0,138,1,0,0,0,0,0,0,160,39,0,0,139,1,0,0,140,1,0,0,141,1,0,0,21,0,0,0,142,1,0,0,0,0,0,0,128,39,0,0,143,1,0,0,144,1,0,0,145,1,0,0,21,0,0,0,146,1,0,0,0,0,0,0,96,39,0,0,147,1,0,0,148,1,0,0,149,1,0,0,21,0,0,0,150,1,0,0,0,0,0,0,64,39,0,0,151,1,0,0,152,1,0,0,153,1,0,0,21,0,0,0,154,1,0,0,0,0,0,0,32,39,0,0,155,1,0,0,156,1,0,0,157,1,0,0,21,0,0,0,158,1,0,0,0,0,0,0,0,39,0,0,159,1,0,0,160,1,0,0,161,1,0,0,21,0,0,0,162,1,0,0,0,0,0,0,224,38,0,0,163,1,0,0,164,1,0,0,165,1,0,0,21,0,0,0,166,1,0,0,0,0,0,0,192,38,0,0,167,1,0,0,168,1,0,0,169,1,0,0,21,0,0,0,170,1,0,0,0,0,0,0,160,38,0,0,171,1,0,0,172,1,0,0,173,1,0,0,21,0,0,0,174,1,0,0,0,0,0,0,128,38,0,0,175,1,0,0,176,1,0,0,177,1,0,0,21,0,0,0,178,1,0,0,0,0,0,0,112,38,0,0,179,1,0,0,180,1,0,0,24,0,0,0,176,0,0,0,0,0,0,0,144,38,0,0,181,1,0,0,182,1,0,0,25,0,0,0,176,0,0,0,0,0,0,0,176,38,0,0,183,1,0,0,184,1,0,0,26,0,0,0,176,0,0,0,0,0,0,0,208,38,0,0,185,1,0,0,186,1,0,0,27,0,0,0,176,0,0,0,0,0,0,0,240,38,0,0,187,1,0,0,188,1,0,0,28,0,0,0,176,0,0,0,0,0,0,0,16,39,0,0,189,1,0,0,190,1,0,0,29,0,0,0,176,0,0,0,0,0,0,0,48,39,0,0,191,1,0,0,192,1,0,0,30,0,0,0,176,0,0,0,0,0,0,0,80,39,0,0,193,1,0,0,194,1,0,0,31,0,0,0,176,0,0,0,0,0,0,0,112,39,0,0,195,1,0,0,196,1,0,0,32,0,0,0,176,0,0,0,0,0,0,0,144,39,0,0,197,1,0,0,198,1,0,0,33,0,0,0,176,0,0,0,0,0,0,0,176,39,0,0,199,1,0,0,200,1,0,0,34,0,0,0,176,0,0,0,0,0,0,0,208,39,0,0,201,1,0,0,202,1,0,0,35,0,0,0,176,0,0,0,0,0,0,0,240,39,0,0,203,1,0,0,204,1,0,0,36,0,0,0,176,0,0,0,0,0,0,0,16,40,0,0,205,1,0,0,206,1,0,0,207,1,0,0,21,0,0,0,208,1,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,41,0,0,209,1,0,0,210,1,0,0,29,0,0,0,63,0,0,0,0,0,0,0,64,0,0,0,65,0,0,0,0,0,0,0,66,0,0,0,67,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,38,0,0,0,39,0,0,0,0,0,0,0,40,0,0,0,41,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,81,0,0,0,82,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,84,0,0,0,85,0,0,0,0,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,0,0,0,0,91,0,0,0,92,0,0,0,0,0,0,0,0,0,0,0,32,40,0,0,211,1,0,0,212,1,0,0,30,0,0,0,0,0,0,0,48,40,0,0,213,1,0,0,214,1,0,0,31,0,0,0,0,0,0,0,64,40,0,0,215,1,0,0,216,1,0,0,32,0,0,0,0,0,0,0,80,40,0,0,217,1,0,0,218,1,0,0,33,0,0,0,0,0,0,0,96,40,0,0,219,1,0,0,220,1,0,0,34,0,0,0,0,0,0,0,112,40,0,0,221,1,0,0,222,1,0,0,35,0,0,0,0,0,0,0,128,40,0,0,223,1,0,0,224,1,0,0,36,0,0,0,0,0,0,0,144,40,0,0,225,1,0,0,226,1,0,0,37,0,0,0,0,0,0,0,160,40,0,0,227,1,0,0,228,1,0,0,38,0,0,0,0,0,0,0,176,40,0,0,229,1,0,0,230,1,0,0,39,0,0,0,0,0,0,0,192,40,0,0,231,1,0,0,232,1,0,0,40,0,0,0,0,0,0,0,208,40,0,0,233,1,0,0,234,1,0,0,41,0,0,0,0,0,0,0,224,40,0,0,235,1,0,0,236,1,0,0,42,0,0,0,0,0,0,0,240,40,0,0,237,1,0,0,238,1,0,0,43,0,0,0,0,0,0,0,0,41,0,0,239,1,0,0,240,1,0,0,44,0,0,0,0,0,0,0,16,41,0,0,38,0,0,0,241,1,0,0,45,0,0,0,0,0,0,0,32,41,0,0,38,0,0,0,242,1,0,0,46,0,0,0,0,0,0,0,48,41,0,0,38,0,0,0,243,1,0,0,47,0,0,0,0,0,0,0,64,41,0,0,38,0,0,0,244,1,0,0,48,0,0,0,0,0,0,0,80,41,0,0,38,0,0,0,245,1,0,0,49,0,0,0,0,0,0,0,96,41,0,0,246,1,0,0,247,1,0,0,50,0,0,0,0,0,0,0,112,41,0,0,248,1,0,0,249,1,0,0,51,0,0,0,0,0,0,0,128,41,0,0,250,1,0,0,251,1,0,0,52,0,0,0,0,0,0,0,144,41,0,0,252,1,0,0,253,1,0,0,53,0,0,0,0,0,0,0,160,41,0,0,254,1,0,0,255,1,0,0,54,0,0,0,0,0,0,0,192,41,0,0,38,0,0,0,0,2,0,0,55,0,0,0,0,0,0,0,208,41,0,0,38,0,0,0,1,2,0,0,56,0,0,0,0,0,0,0,224,41,0,0,38,0,0,0,2,2,0,0,57,0,0,0,0,0,0,0,240,41,0,0,38,0,0,0,3,2,0,0,58,0,0,0,0,0,0,0,0,42,0,0,38,0,0,0,4,2,0,0,59,0,0,0,0,0,0,0,16,42,0,0,5,2,0,0,6,2,0,0,60,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,128,63,0,0,128,192,0,0,128,63,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,193,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,48,42,0,0,7,2,0,0,8,2,0,0,61,0,0,0,0,0,0,0,32,42,0,0,38,0,0,0,9,2,0,0,62,0,0,0,0,0,0,0,80,42,0,0,38,0,0,0,10,2,0,0,63,0,0,0,0,0,0,0,64,42,0,0,38,0,0,0,11,2,0,0,64,0,0,0,0,0,0,0,0,0,0,63,0,0,128,62,171,170,42,62,0,0,0,62,205,204,204,61,171,170,170,61,40,73,146,61,0,0,128,61,0,0,0,0,96,42,0,0,12,2,0,0,13,2,0,0,65,0,0,0,0,0,0,0,112,42,0,0,14,2,0,0,15,2,0,0,66,0,0,0,0,0,0,0,128,42,0,0,16,2,0,0,17,2,0,0,67,0,0,0,0,0,0,0,144,42,0,0,18,2,0,0,19,2,0,0,68,0,0,0,0,0,0,0,160,42,0,0,20,2,0,0,21,2,0,0,69,0,0,0,0,0,0,0,176,42,0,0,22,2,0,0,23,2,0,0,70,0,0,0,0,0,0,0,80,43,0,0,24,2,0,0,25,2,0,0,26,2,0,0,21,0,0,0,27,2,0,0,0,0,0,0,192,42,0,0,28,2,0,0,29,2,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,57,0,0,0,1,0,0,0,1,0,0,0,71,0,0,0,72,0,0,0,30,2,0,0,0,0,0,0,64,43,0,0,31,2,0,0,32,2,0,0,33,2,0,0,21,0,0,0,34,2,0,0,0,0,0,0,48,43,0,0,35,2,0,0,36,2,0,0,73,0,0,0,0,0,0,0,32,43,0,0,37,2,0,0,38,2,0,0,39,2,0,0,21,0,0,0,40,2,0,0,0,0,0,0,16,43,0,0,41,2,0,0,42,2,0,0,74,0,0,0,0,0,0,0,0,43,0,0,43,2,0,0,44,2,0,0,45,2,0,0,21,0,0,0,46,2,0,0,0,0,0,0,240,42,0,0,47,2,0,0,48,2,0,0,75,0,0,0,0,0,0,0,224,42,0,0,49,2,0,0,50,2,0,0,51,2,0,0,21,0,0,0,52,2,0,0,0,0,0,0,208,42,0,0,53,2,0,0,54,2,0,0,76,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,62,0,0,0,63,0,0,128,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,61,0,0,128,62,0,0,192,62,0,0,128,62,0,0,128,61,0,0,0,0,0,0,0,0,0,0,0,61,0,0,224,61,0,0,96,62,0,0,144,62,0,0,96,62,0,0,224,61,0,0,0,61,0,0,0,0,96,43,0,0,38,0,0,0,55,2,0,0,77,0,0,0,0,0,0,0,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,5,246,127,63,19,216,127,63,47,166,127,63,92,96,127,63,158,6,127,63,253,152,126,63,130,23,126,63,54,130,125,63,36,217,124,63,93,28,124,63,236,75,123,63,226,103,122,63,82,112,121,63,77,101,120,63,234,70,119,63,63,21,118,63,100,208,116,63,112,120,115,63,130,13,114,63,178,143,112,63,32,255,110,63,237,91,109,63,54,166,107,63,30,222,105,63,202,3,104,63,93,23,102,63,1,25,100,63,219,8,98,63,20,231,95,63,215,179,93,63,81,111,91,63,174,25,89,63,30,179,86,63,207,59,84,63,242,179,81,63,189,27,79,63,96,115,76,63,19,187,73,63,10,243,70,63,124,27,68,63,166,52,65,63,189,62,62,63,255,57,59,63,167,38,56,63,244,4,53,63,34,213,49,63,114,151,46,63,37,76,43,63,124,243,39,63,186,141,36,63,36,27,33,63,254,155,29,63,140,16,26,63,25,121,22,63,231,213,18,63,68,39,15,63,118,109,11,63,203,168,7,63,137,217,3,63,0,0,0,63,247,56,248,62,149,94,240,62,113,113,232,62,45,114,224,62,109,97,216,62,200,63,208,62,232,13,200,62,112,204,191,62,255,123,183,62,66,29,175,62,224,176,166,62,122,55,158,62,190,177,149,62,88,32,141,62,237,131,132,62,96,186,119,62,149,89,102,62,206,230,84,62,111,99,67,62,213,208,49,62,94,48,32,62,101,131,14,62,157,150,249,61,10,19,214,61,176,126,178,61,127,220,142,61,70,94,86,61,199,242,14,61,86,248,142,60,0,0,0,0,86,248,142,188,199,242,14,189,70,94,86,189,127,220,142,189,176,126,178,189,10,19,214,189,157,150,249,189,101,131,14,190,94,48,32,190,213,208,49,190,111,99,67,190,206,230,84,190,149,89,102,190,96,186,119,190,237,131,132,190,88,32,141,190,190,177,149,190,122,55,158,190,224,176,166,190,66,29,175,190,255,123,183,190,112,204,191,190,232,13,200,190,200,63,208,190,109,97,216,190,45,114,224,190,113,113,232,190,149,94,240,190,247,56,248,190,0,0,0,191,137,217,3,191,203,168,7,191,118,109,11,191,68,39,15,191,231,213,18,191,25,121,22,191,140,16,26,191,254,155,29,191,36,27,33,191,186,141,36,191,124,243,39,191,37,76,43,191,114,151,46,191,34,213,49,191,244,4,53,191,167,38,56,191,255,57,59,191,189,62,62,191,166,52,65,191,124,27,68,191,10,243,70,191,19,187,73,191,96,115,76,191,189,27,79,191,242,179,81,191,207,59,84,191,30,179,86,191,174,25,89,191,81,111,91,191,215,179,93,191,20,231,95,191,219,8,98,191,1,25,100,191,93,23,102,191,202,3,104,191,30,222,105,191,54,166,107,191,237,91,109,191,32,255,110,191,178,143,112,191,130,13,114,191,112,120,115,191,100,208,116,191,63,21,118,191,234,70,119,191,77,101,120,191,82,112,121,191,226,103,122,191,236,75,123,191,93,28,124,191,36,217,124,191,54,130,125,191,130,23,126,191,253,152,126,191,158,6,127,191,92,96,127,191,47,166,127,191,19,216,127,191,5,246,127,191,0,0,128,191,5,246,127,191,19,216,127,191,47,166,127,191,92,96,127,191,158,6,127,191,253,152,126,191,130,23,126,191,54,130,125,191,36,217,124,191,93,28,124,191,236,75,123,191,226,103,122,191,82,112,121,191,77,101,120,191,234,70,119,191,63,21,118,191,100,208,116,191,112,120,115,191,130,13,114,191,178,143,112,191,32,255,110,191,237,91,109,191,54,166,107,191,30,222,105,191,202,3,104,191,93,23,102,191,1,25,100,191,219,8,98,191,20,231,95,191,215,179,93,191,81,111,91,191,174,25,89,191,30,179,86,191,207,59,84,191,242,179,81,191,189,27,79,191,96,115,76,191,19,187,73,191,10,243,70,191,124,27,68,191,166,52,65,191,189,62,62,191,255,57,59,191,167,38,56,191,244,4,53,191,34,213,49,191,114,151,46,191,37,76,43,191,124,243,39,191,186,141,36,191,36,27,33,191,254,155,29,191,140,16,26,191,25,121,22,191,231,213,18,191,68,39,15,191,118,109,11,191,203,168,7,191,137,217,3,191,0,0,0,191,247,56,248,190,149,94,240,190,113,113,232,190,45,114,224,190,109,97,216,190,200,63,208,190,232,13,200,190,112,204,191,190,255,123,183,190,66,29,175,190,224,176,166,190,122,55,158,190,190,177,149,190,88,32,141,190,237,131,132,190,96,186,119,190,149,89,102,190,206,230,84,190,111,99,67,190,213,208,49,190,94,48,32,190,101,131,14,190,157,150,249,189,10,19,214,189,176,126,178,189,127,220,142,189,70,94,86,189,199,242,14,189,86,248,142,188,0,0,0,128,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,168,0,0,0,177,0,0,0,185,0,0,0,194,0,0,0,202,0,0,0,210,0,0,0,218,0,0,0,224,0,0,0,231,0,0,0,236,0,0,0,241,0,0,0,246,0,0,0,249,0,0,0,252,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,252,0,0,0,249,0,0,0,246,0,0,0,241,0,0,0,236,0,0,0,231,0,0,0,224,0,0,0,218,0,0,0,210,0,0,0,202,0,0,0,194,0,0,0,185,0,0,0,177,0,0,0,168,0,0,0,158,0,0,0,149,0,0,0,140,0,0,0,131,0,0,0,122,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,89,0,0,0,82,0,0,0,75,0,0,0,68,0,0,0,62,0,0,0,56,0,0,0,50,0,0,0,45,0,0,0,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,25,0,0,0,22,0,0,0,19,0,0,0,16,0,0,0,14,0,0,0,12,0,0,0,11,0,0,0,9,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,5,0,0,0,69,17,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,151,0,0,0,152,0,0,0,153,0,0,0,154,0,0,0,155,0,0,0,156,0,0,0,157,0,0,0,158,0,0,0,159,0,0,0,160,0,0,0,161,0,0,0,162,0,0,0,163,0,0,0,164,0,0,0,165,0,0,0,166,0,0,0,167,0,0,0,168,0,0,0,169,0,0,0,170,0,0,0,171,0,0,0,172,0,0,0,173,0,0,0,174,0,0,0,175,0,0,0,176,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,69,16,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,201,55,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,205,10,0,0,225,8,0,0,3,8,0,0,4,8,0,0,5,8,0,0,6,8,0,0,7,8,0,0,8,8,0,0,9,8,0,0,10,8,0,0,11,8,0,0,12,8,0,0,13,8,0,0,14,8,0,0,15,8,0,0,16,8,0,0,17,8,0,0,18,8,0,0,19,8,0,0,20,8,0,0,21,8,0,0,22,8,0,0,23,8,0,0,24,8,0,0,25,8,0,0,26,8,0,0,27,8,0,0,28,8,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,103,8,0,0,104,8,0,0,105,8,0,0,106,8,0,0,107,8,0,0,108,8,0,0,109,8,0,0,110,8,0,0,111,8,0,0,112,8,0,0,113,8,0,0,114,8,0,0,115,8,0,0,116,8,0,0,117,8,0,0,118,8,0,0,119,8,0,0,120,8,0,0,121,8,0,0,122,8,0,0,123,8,0,0,124,8,0,0,125,8,0,0,126,8,0,0,127,8,0,0,128,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,48,0,0,151,8,0,0,166,8,0,0,169,8,0,0,227,8,0,0,226,8,0,0,223,8,0,0,224,8,0,0,168,8,0,0,173,8,0,0,174,8,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,152,8,0,0,153,8,0,0,154,8,0,0,155,8,0,0,156,8,0,0,157,8,0,0,158,8,0,0,159,8,0,0,160,8,0,0,161,8,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,209,7,0,0,210,7,0,0,211,7,0,0,212,7,0,0,213,7,0,0,214,7,0,0,215,7,0,0,216,7,0,0,217,7,0,0,218,7,0,0,219,7,0,0,220,7,0,0,221,7,0,0,222,7,0,0,223,7,0,0,224,7,0,0,225,7,0,0,226,7,0,0,227,7,0,0,228,7,0,0,229,7,0,0,230,7,0,0,231,7,0,0,232,7,0,0,233,7,0,0,234,7,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,53,8,0,0,54,8,0,0,55,8,0,0,56,8,0,0,57,8,0,0,58,8,0,0,59,8,0,0,60,8,0,0,61,8,0,0,62,8,0,0,63,8,0,0,64,8,0,0,65,8,0,0,66,8,0,0,67,8,0,0,68,8,0,0,69,8,0,0,70,8,0,0,71,8,0,0,72,8,0,0,73,8,0,0,74,8,0,0,75,8,0,0,76,8,0,0,77,8,0,0,78,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,241,10,0,0,242,10,0,0,243,10,0,0,244,10,0,0,245,10,0,0,246,10,0,0,247,10,0,0,248,10,0,0,249,10,0,0,250,10,0,0,251,10,0,0,252,10,0,0,253,10,0,0,254,10,0,0,255,10,0,0,0,11,0,0,1,11,0,0,2,11,0,0,3,11,0,0,4,11,0,0,5,11,0,0,6,11,0,0,7,11,0,0,8,11,0,0,9,11,0,0,10,11,0,0,11,11,0,0,12,11,0,0,13,11,0,0,14,11,0,0,15,11,0,0,16,11,0,0,85,11,0,0,86,11,0,0,87,11,0,0,88,11,0,0,89,11,0,0,90,11,0,0,91,11,0,0,92,11,0,0,93,11,0,0,94,11,0,0,95,11,0,0,96,11,0,0,97,11,0,0,98,11,0,0,99,11,0,0,100,11,0,0,101,11,0,0,102,11,0,0,103,11,0,0,104,11,0,0,105,11,0,0,106,11,0,0,107,11,0,0,108,11,0,0,109,11,0,0,110,11,0,0,111,11,0,0,112,11,0,0,113,11,0,0,114,11,0,0,115,11,0,0,116,11,0,0,201,23,0,0,151,8,0,0,192,12,0,0,206,12,0,0,210,12,0,0,197,12,0,0,161,12,0,0,196,12,0,0,205,12,0,0,199,12,0,0,200,12,0,0,151,12,0,0,153,12,0,0,189,12,0,0,152,12,0,0,188,12,0,0,198,12,0,0,178,12,0,0,179,12,0,0,180,12,0,0,181,12,0,0,182,12,0,0,183,12,0,0,184,12,0,0,185,12,0,0,186,12,0,0,187,12,0,0,190,12,0,0,191,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,193,12,0,0,162,12,0,0,235,11,0,0,236,11,0,0,237,11,0,0,238,11,0,0,239,11,0,0,240,11,0,0,241,11,0,0,242,11,0,0,243,11,0,0,244,11,0,0,245,11,0,0,246,11,0,0,247,11,0,0,16,8,0,0,249,11,0,0,250,11,0,0,251,11,0,0,252,11,0,0,253,11,0,0,254,11,0,0,255,11,0,0,0,12,0,0,1,12,0,0,2,12,0,0,3,12,0,0,4,12,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,79,12,0,0,80,12,0,0,81,12,0,0,82,12,0,0,83,12,0,0,84,12,0,0,85,12,0,0,86,12,0,0,87,12,0,0,88,12,0,0,89,12,0,0,90,12,0,0,91,12,0,0,92,12,0,0,93,12,0,0,94,12,0,0,95,12,0,0,96,12,0,0,97,12,0,0,98,12,0,0,99,12,0,0,100,12,0,0,101,12,0,0,102,12,0,0,103,12,0,0,104,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,142,12,0,0,156,12,0,0,160,12,0,0,147,12,0,0,161,12,0,0,146,12,0,0,155,12,0,0,149,12,0,0,150,12,0,0,151,12,0,0,153,12,0,0,139,12,0,0,152,12,0,0,138,12,0,0,148,12,0,0,128,12,0,0,129,12,0,0,130,12,0,0,131,12,0,0,132,12,0,0,133,12,0,0,134,12,0,0,135,12,0,0,136,12,0,0,137,12,0,0,140,12,0,0,141,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,143,12,0,0,162,12,0,0,185,11,0,0,186,11,0,0,187,11,0,0,188,11,0,0,189,11,0,0,190,11,0,0,191,11,0,0,192,11,0,0,193,11,0,0,194,11,0,0,195,11,0,0,196,11,0,0,197,11,0,0,222,7,0,0,199,11,0,0,200,11,0,0,201,11,0,0,202,11,0,0,203,11,0,0,204,11,0,0,205,11,0,0,206,11,0,0,207,11,0,0,208,11,0,0,209,11,0,0,210,11,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,29,12,0,0,30,12,0,0,31,12,0,0,32,12,0,0,33,12,0,0,34,12,0,0,35,12,0,0,36,12,0,0,37,12,0,0,38,12,0,0,39,12,0,0,40,12,0,0,41,12,0,0,42,12,0,0,43,12,0,0,44,12,0,0,45,12,0,0,46,12,0,0,47,12,0,0,48,12,0,0,49,12,0,0,50,12,0,0,51,12,0,0,52,12,0,0,53,12,0,0,54,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,118,17,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,189,4,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,27,4,0,0,28,4,0,0,29,4,0,0,30,4,0,0,31,4,0,0,32,4,0,0,33,4,0,0,34,4,0,0,35,4,0,0,36,4,0,0,37,4,0,0,38,4,0,0,39,4,0,0,40,4,0,0,41,4,0,0,42,4,0,0,43,4,0,0,44,4,0,0,45,4,0,0,46,4,0,0,47,4,0,0,48,4,0,0,49,4,0,0,50,4,0,0,51,4,0,0,52,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,127,4,0,0,128,4,0,0,129,4,0,0,130,4,0,0,131,4,0,0,132,4,0,0,133,4,0,0,134,4,0,0,135,4,0,0,136,4,0,0,137,4,0,0,138,4,0,0,139,4,0,0,140,4,0,0,141,4,0,0,142,4,0,0,143,4,0,0,144,4,0,0,145,4,0,0,146,4,0,0,147,4,0,0,148,4,0,0,149,4,0,0,150,4,0,0,151,4,0,0,152,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,118,16,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,165,8,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,233,3,0,0,234,3,0,0,235,3,0,0,236,3,0,0,237,3,0,0,238,3,0,0,239,3,0,0,240,3,0,0,241,3,0,0,242,3,0,0,243,3,0,0,244,3,0,0,245,3,0,0,246,3,0,0,247,3,0,0,248,3,0,0,249,3,0,0,250,3,0,0,251,3,0,0,252,3,0,0,253,3,0,0,254,3,0,0,255,3,0,0,0,4,0,0,1,4,0,0,2,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,77,4,0,0,78,4,0,0,79,4,0,0,80,4,0,0,81,4,0,0,82,4,0,0,83,4,0,0,84,4,0,0,85,4,0,0,86,4,0,0,87,4,0,0,88,4,0,0,89,4,0,0,90,4,0,0,91,4,0,0,92,4,0,0,93,4,0,0,94,4,0,0,95,4,0,0,96,4,0,0,97,4,0,0,98,4,0,0,99,4,0,0,100,4,0,0,101,4,0,0,102,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,201,23,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,247,9,0,0,248,9,0,0,249,9,0,0,250,9,0,0,251,9,0,0,252,9,0,0,253,9,0,0,254,9,0,0,255,9,0,0,0,10,0,0,1,10,0,0,2,10,0,0,3,10,0,0,4,10,0,0,5,10,0,0,6,10,0,0,7,10,0,0,8,10,0,0,9,10,0,0,10,10,0,0,11,10,0,0,12,10,0,0,13,10,0,0,14,10,0,0,15,10,0,0,16,10,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,74,2,0,0,201,8,0,0,91,10,0,0,92,10,0,0,93,10,0,0,94,10,0,0,95,10,0,0,96,10,0,0,97,10,0,0,98,10,0,0,99,10,0,0,100,10,0,0,101,10,0,0,102,10,0,0,103,10,0,0,104,10,0,0,105,10,0,0,106,10,0,0,107,10,0,0,108,10,0,0,109,10,0,0,110,10,0,0,111,10,0,0,112,10,0,0,113,10,0,0,114,10,0,0,115,10,0,0,116,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,17,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,39,2,0,0,40,2,0,0,41,2,0,0,42,2,0,0,43,2,0,0,44,2,0,0,45,2,0,0,46,2,0,0,47,2,0,0,48,2,0,0,49,2,0,0,50,2,0,0,51,2,0,0,52,2,0,0,53,2,0,0,54,2,0,0,55,2,0,0,56,2,0,0,57,2,0,0,58,2,0,0,59,2,0,0,60,2,0,0,61,2,0,0,62,2,0,0,63,2,0,0,64,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,139,2,0,0,140,2,0,0,141,2,0,0,142,2,0,0,143,2,0,0,144,2,0,0,145,2,0,0,146,2,0,0,147,2,0,0,148,2,0,0,149,2,0,0,150,2,0,0,151,2,0,0,152,2,0,0,153,2,0,0,154,2,0,0,155,2,0,0,156,2,0,0,157,2,0,0,158,2,0,0,159,2,0,0,160,2,0,0,161,2,0,0,162,2,0,0,163,2,0,0,164,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,201,16,0,0,151,8,0,0,154,10,0,0,168,10,0,0,172,10,0,0,159,10,0,0,173,10,0,0,158,10,0,0,167,10,0,0,161,10,0,0,162,10,0,0,163,10,0,0,165,10,0,0,151,10,0,0,164,10,0,0,150,10,0,0,160,10,0,0,140,10,0,0,141,10,0,0,142,10,0,0,143,10,0,0,144,10,0,0,145,10,0,0,146,10,0,0,147,10,0,0,148,10,0,0,149,10,0,0,152,10,0,0,153,10,0,0,170,10,0,0,166,10,0,0,171,10,0,0,155,10,0,0,174,10,0,0,197,9,0,0,198,9,0,0,199,9,0,0,200,9,0,0,201,9,0,0,202,9,0,0,203,9,0,0,204,9,0,0,205,9,0,0,206,9,0,0,207,9,0,0,208,9,0,0,209,9,0,0,210,9,0,0,211,9,0,0,212,9,0,0,213,9,0,0,214,9,0,0,215,9,0,0,216,9,0,0,217,9,0,0,218,9,0,0,219,9,0,0,220,9,0,0,221,9,0,0,222,9,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,41,10,0,0,42,10,0,0,43,10,0,0,44,10,0,0,45,10,0,0,46,10,0,0,47,10,0,0,48,10,0,0,49,10,0,0,50,10,0,0,51,10,0,0,52,10,0,0,53,10,0,0,54,10,0,0,55,10,0,0,56,10,0,0,57,10,0,0,58,10,0,0,59,10,0,0,60,10,0,0,61,10,0,0,62,10,0,0,63,10,0,0,64,10,0,0,65,10,0,0,66,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,245,1,0,0,246,1,0,0,247,1,0,0,248,1,0,0,249,1,0,0,250,1,0,0,251,1,0,0,252,1,0,0,253,1,0,0,254,1,0,0,255,1,0,0,0,2,0,0,1,2,0,0,2,2,0,0,3,2,0,0,4,2,0,0,5,2,0,0,6,2,0,0,7,2,0,0,8,2,0,0,9,2,0,0,10,2,0,0,11,2,0,0,12,2,0,0,13,2,0,0,14,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,89,2,0,0,90,2,0,0,91,2,0,0,92,2,0,0,93,2,0,0,94,2,0,0,95,2,0,0,96,2,0,0,97,2,0,0,98,2,0,0,99,2,0,0,100,2,0,0,101,2,0,0,102,2,0,0,103,2,0,0,104,2,0,0,105,2,0,0,106,2,0,0,107,2,0,0,108,2,0,0,109,2,0,0,110,2,0,0,111,2,0,0,112,2,0,0,113,2,0,0,114,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,160,44,0,0,56,2,0,0,57,2,0,0,58,2,0,0,21,0,0,0,59,2,0,0,0,0,0,0,144,44,0,0,60,2,0,0,61,2,0,0,62,2,0,0,21,0,0,0,63,2,0,0,0,0,0,0,128,44,0,0,64,2,0,0,65,2,0,0,66,2,0,0,21,0,0,0,67,2,0,0,0,0,0,0,112,44,0,0,68,2,0,0,69,2,0,0,70,2,0,0,21,0,0,0,71,2,0,0,0,0,0,0,96,44,0,0,72,2,0,0,73,2,0,0,74,2,0,0,21,0,0,0,75,2,0,0,0,0,0,0,80,44,0,0,76,2,0,0,77,2,0,0,78,2,0,0,21,0,0,0,79,2,0,0,0,0,0,0,64,44,0,0,80,2,0,0,81,2,0,0,82,2,0,0,21,0,0,0,83,2,0,0,0,0,0,0,48,44,0,0,84,2,0,0,85,2,0,0,86,2,0,0,21,0,0,0,87,2,0,0,0,0,0,0,32,44,0,0,88,2,0,0,89,2,0,0,90,2,0,0,21,0,0,0,91,2,0,0,0,0,0,0,16,44,0,0,92,2,0,0,93,2,0,0,94,2,0,0,21,0,0,0,95,2,0,0,0,0,0,0,0,44,0,0,169,0,0,0,96,2,0,0,37,0,0,0,0,0,0,0,240,43,0,0,169,0,0,0,97,2,0,0,38,0,0,0,0,0,0,0,224,43,0,0,169,0,0,0,98,2,0,0,39,0,0,0,0,0,0,0,208,43,0,0,169,0,0,0,99,2,0,0,40,0,0,0,0,0,0,0,192,43,0,0,169,0,0,0,100,2,0,0,41,0,0,0,0,0,0,0,176,43,0,0,169,0,0,0,101,2,0,0,42,0,0,0,0,0,0,0,160,43,0,0,169,0,0,0,102,2,0,0,43,0,0,0,0,0,0,0,144,43,0,0,169,0,0,0,103,2,0,0,44,0,0,0,0,0,0,0,128,43,0,0,169,0,0,0,104,2,0,0,45,0,0,0,0,0,0,0,112,43,0,0,169,0,0,0,105,2,0,0,46,0,0,0,0,0,0,0,32,46,0,0,106,2,0,0,107,2,0,0,108,2,0,0,21,0,0,0,109,2,0,0,0,0,0,0,16,46,0,0,110,2,0,0,111,2,0,0,68,0,0,0,112,2,0,0,0,0,0,0,224,45,0,0,113,2,0,0,114,2,0,0,115,2,0,0,21,0,0,0,116,2,0,0,0,0,0,0,208,45,0,0,117,2,0,0,118,2,0,0,69,0,0,0,119,2,0,0,0,0,0,0,192,45,0,0,120,2,0,0,121,2,0,0,122,2,0,0,21,0,0,0,123,2,0,0,0,0,0,0,176,45,0,0,124,2,0,0,125,2,0,0,70,0,0,0,126,2,0,0,0,0,0,0,160,45,0,0,127,2,0,0,128,2,0,0,129,2,0,0,21,0,0,0,130,2,0,0,0,0,0,0,144,45,0,0,131,2,0,0,132,2,0,0,71,0,0,0,133,2,0,0,0,0,0,0,128,45,0,0,134,2,0,0,135,2,0,0,136,2,0,0,21,0,0,0,137,2,0,0,0,0,0,0,112,45,0,0,138,2,0,0,139,2,0,0,72,0,0,0,140,2,0,0,0,0,0,0,96,45,0,0,141,2,0,0,142,2,0,0,143,2,0,0,21,0,0,0,144,2,0,0,0,0,0,0,80,45,0,0,145,2,0,0,146,2,0,0,73],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+51204);allocate([147,2,0,0,0,0,0,0,64,45,0,0,148,2,0,0,149,2,0,0,150,2,0,0,21,0,0,0,151,2,0,0,0,0,0,0,48,45,0,0,152,2,0,0,153,2,0,0,74,0,0,0,154,2,0,0,0,0,0,0,32,45,0,0,155,2,0,0,156,2,0,0,157,2,0,0,21,0,0,0,158,2,0,0,0,0,0,0,16,45,0,0,159,2,0,0,160,2,0,0,75,0,0,0,161,2,0,0,0,0,0,0,0,45,0,0,162,2,0,0,163,2,0,0,164,2,0,0,21,0,0,0,165,2,0,0,0,0,0,0,240,44,0,0,166,2,0,0,167,2,0,0,76,0,0,0,168,2,0,0,0,0,0,0,224,44,0,0,169,2,0,0,170,2,0,0,171,2,0,0,21,0,0,0,172,2,0,0,0,0,0,0,208,44,0,0,173,2,0,0,174,2,0,0,77,0,0,0,175,2,0,0,0,0,0,0,192,44,0,0,176,2,0,0,177,2,0,0,178,2,0,0,21,0,0,0,179,2,0,0,0,0,0,0,176,44,0,0,180,2,0,0,181,2,0,0,78,0,0,0,182,2,0,0,0,0,0,0,0,46,0,0,183,2,0,0,184,2,0,0,185,2,0,0,21,0,0,0,186,2,0,0,0,0,0,0,240,45,0,0,187,2,0,0,188,2,0,0,79,0,0,0,189,2,0,0,0,0,0,0,192,46,0,0,190,2,0,0,191,2,0,0,192,2,0,0,21,0,0,0,193,2,0,0,0,0,0,0,176,46,0,0,194,2,0,0,195,2,0,0,196,2,0,0,21,0,0,0,197,2,0,0,0,0,0,0,160,46,0,0,198,2,0,0,199,2,0,0,200,2,0,0,21,0,0,0,201,2,0,0,0,0,0,0,144,46,0,0,202,2,0,0,203,2,0,0,204,2,0,0,21,0,0,0,205,2,0,0,0,0,0,0,128,46,0,0,206,2,0,0,207,2,0,0,208,2,0,0,21,0,0,0,209,2,0,0,0,0,0,0,112,46,0,0,169,0,0,0,210,2,0,0,47,0,0,0,0,0,0,0,96,46,0,0,169,0,0,0,211,2,0,0,48,0,0,0,0,0,0,0,80,46,0,0,169,0,0,0,212,2,0,0,49,0,0,0,0,0,0,0,64,46,0,0,169,0,0,0,213,2,0,0,50,0,0,0,0,0,0,0,48,46,0,0,169,0,0,0,214,2,0,0,51,0,0,0,0,0,0,0,224,46,0,0,38,0,0,0,215,2,0,0,78,0,0,0,0,0,0,0,208,46,0,0,38,0,0,0,216,2,0,0,79,0,0,0,23,201,17,0,154,62,4,0,171,62,4,0,202,62,4,0,225,62,4,0,249,62,4,0,15,63,4,0,32,63,4,0,62,63,4,0,79,63,4,0,86,63,4,0,101,63,4,0,118,63,4,0,130,63,4,0,152,63,4,0,169,63,4,0,198,63,4,0,218,63,4,0,252,63,4,0,21,64,4,0,48,64,4,0,60,64,4,0,79,64,4,0,91,64,4,0,113,64,4,0,125,64,4,0,139,64,4,0,154,62,4,0,171,62,4,0,156,64,4,0,168,64,4,0,249,62,4,0,139,64,4,0,62,63,4,0,185,64,4,0,79,63,4,0,101,63,4,0,224,64,4,0,130,63,4,0,152,63,4,0,236,64,4,0,169,63,4,0,2,65,4,0,198,63,4,0,19,65,4,0,48,64,4,0,38,65,4,0,68,65,4,0,113,64,4,0,94,65,4,0,118,65,4,0,145,65,4,0,162,65,4,0,195,65,4,0,224,65,4,0,248,65,4,0,14,66,4,0,31,66,4,0,62,66,4,0,79,66,4,0,86,66,4,0,103,66,4,0,120,66,4,0,132,66,4,0,154,66,4,0,171,66,4,0,204,66,4,0,226,66,4,0,22,67,4,0,55,67,4,0,82,67,4,0,94,67,4,0,113,67,4,0,125,67,4,0,147,67,4,0,159,67,4,0,173,67,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,184,67,4,0,201,67,4,0,208,67,4,0,220,67,4,0,227,67,4,0,234,67,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,249,67,4,0,19,68,4,0,45,68,4,0,66,68,4,0,92,68,4,0,113,68,4,0,131,68,4,0,163,68,4,0,183,68,4,0,201,68,4,0,225,68,4,0,79,63,4,0,242,68,4,0,23,69,4,0,43,69,4,0,64,69,4,0,90,69,4,0,116,69,4,0,132,69,4,0,159,69,4,0,177,69,4,0,197,69,4,0,209,69,4,0,231,69,4,0,243,69,4,0,5,70,4,0,16,70,4,0,41,70,4,0,78,70,4,0,104,70,4,0,135,70,4,0,165,70,4,0,197,70,4,0,229,70,4,0,12,71,4,0,27,71,4,0,52,71,4,0,70,71,4,0,103,71,4,0,121,71,4,0,43,69,4,0,164,71,4,0,187,71,4,0,210,71,4,0,233,71,4,0,247,71,4,0,14,72,4,0,45,72,4,0,69,72,4,0,97,72,4,0,127,72,4,0,159,72,4,0,182,72,4,0,201,72,4,0,233,72,4,0,2,73,4,0,26,73,4,0,60,73,4,0,88,73,4,0,118,73,4,0,150,73,4,0,175,73,4,0,188,73,4,0,237,73,4,0,43,69,4,0,15,74,4,0,47,74,4,0,73,74,4,0,97,74,4,0,124,74,4,0,142,74,4,0,176,74,4,0,201,74,4,0,241,74,4,0,21,75,4,0,57,75,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,82,75,4,0,111,75,4,0,137,75,4,0,171,75,4,0,201,75,4,0,23,201,17,0,23,201,17,0,226,75,4,0,28,76,4,0,37,76,4,0,46,76,4,0,57,76,4,0,68,76,4,0,93,76,4,0,118,76,4,0,166,76,4,0,169,76,4,0,172,76,4,0,197,76,4,0,206,76,4,0,225,76,4,0,255,76,4,0,13,77,4,0,41,77,4,0,70,77,4,0,82,77,4,0,120,77,4,0,149,77,4,0,162,77,4,0,177,77,4,0,201,77,4,0,227,77,4,0,250,77,4,0,28,78,4,0,35,78,4,0,47,78,4,0,68,78,4,0,100,78,4,0,107,78,4,0,122,78,4,0,137,78,4,0,144,78,4,0,151,78,4,0,163,78,4,0,175,78,4,0,187,78,4,0,204,78,4,0,217,78,4,0,232,78,4,0,247,78,4,0,5,79,4,0,27,79,4,0,70,79,4,0,108,79,4,0,23,201,17,0,145,79,4,0,169,79,4,0,231,79,4,0,23,201,17,0,238,79,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,251,79,4,0,23,201,17,0,81,80,4,0,23,201,17,0,135,80,4,0,23,201,17,0,151,80,4,0,23,201,17,0,164,80,4,0,23,201,17,0,218,80,4,0,225,80,4,0,23,201,17,0,237,80,4,0,71,81,4,0,169,81,4,0,6,82,4,0,126,82,4,0,17,83,4,0,194,83,4,0,102,84,4,0,244,84,4,0,125,85,4,0,171,85,4,0,18,86,4,0,96,86,4,0,208,86,4,0,43,87,4,0,65,87,4,0,23,201,17,0,100,87,4,0,143,87,4,0,186,87,4,0,218,87,4,0,250,87,4,0,23,201,17,0,26,88,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,43,88,4,0,60,88,4,0,107,88,4,0,146,88,4,0,178,88,4,0,200,88,4,0,217,88,4,0,7,89,4,0,24,89,4,0,31,89,4,0,54,89,4,0,71,89,4,0,83,89,4,0,105,89,4,0,122,89,4,0,167,89,4,0,195,89,4,0,245,89,4,0,22,90,4,0,65,90,4,0,77,90,4,0,100,90,4,0,112,90,4,0,134,90,4,0,146,90,4,0,160,90,4,0,43,88,4,0,60,88,4,0,177,90,4,0,189,90,4,0,178,88,4,0,160,90,4,0,7,89,4,0,206,90,4,0,24,89,4,0,54,89,4,0,0,91,4,0,83,89,4,0,105,89,4,0,12,91,4,0,122,89,4,0,29,91,4,0,167,89,4,0,46,91,4,0,65,90,4,0,65,91,4,0,103,91,4,0,145,91,4,0,157,91,4,0,193,91,4,0,228,91,4,0,13,92,4,0,95,92,4,0,144,92,4,0,215,92,4,0,16,93,4,0,71,93,4,0,130,93,4,0,206,93,4,0,1,94,4,0,52,94,4,0,129,94,4,0,188,94,4,0,21,95,4,0,85,95,4,0,144,95,4,0,207,95,4,0,16,96,4,0,93,96,4,0,150,96,4,0,200,96,4,0,10,97,4,0,75,97,4,0,123,97,4,0,195,97,4,0,15,98,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,96,98,4,0,113,98,4,0,120,98,4,0,132,98,4,0,139,98,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,152,98,4,0,188,98,4,0,224,98,4,0,255,98,4,0,35,99,4,0,72,99,4,0,90,99,4,0,136,99,4,0,158,99,4,0,176,99,4,0,200,99,4,0,24,89,4,0,217,99,4,0,254,99,4,0,20,100,4,0,57,100,4,0,93,100,4,0,129,100,4,0,147,100,4,0,184,100,4,0,202,100,4,0,224,100,4,0,236,100,4,0,2,101,4,0,14,101,4,0,34,101,4,0,51,101,4,0,99,101,4,0,160,101,4,0,194,101,4,0,243,101,4,0,25,102,4,0,71,102,4,0,109,102,4,0,164,102,4,0,183,102,4,0,220,102,4,0,238,102,4,0,23,103,4,0,51,103,4,0,108,103,4,0,145,103,4,0,170,103,4,0,209,103,4,0,246,103,4,0,6,104,4,0,39,104,4,0,82,104,4,0,110,104,4,0,150,104,4,0,196,104,4,0,241,104,4,0,32,105,4,0,61,105,4,0,109,105,4,0,144,105,4,0,193,105,4,0,249,105,4,0,51,106,4,0,83,106,4,0,123,106,4,0,188,106,4,0,225,106,4,0,34,107,4,0,80,107,4,0,127,107,4,0,174,107,4,0,228,107,4,0,3,108,4,0,35,108,4,0,66,108,4,0,104,108,4,0,138,108,4,0,187,108,4,0,227,108,4,0,17,109,4,0,64,109,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,109,109,4,0,162,109,4,0,194,109,4,0,240,109,4,0,26,110,4,0,23,201,17,0,23,201,17,0,59,110,4,0,147,110,4,0,156,110,4,0,165,110,4,0,182,110,4,0,199,110,4,0,232,110,4,0,9,111,4,0,169,76,4,0,72,111,4,0,75,111,4,0,112,111,4,0,123,111,4,0,154,111,4,0,187,111,4,0,201,111,4,0,238,111,4,0,31,112,4,0,43,112,4,0,104,112,4,0,153,112,4,0,166,112,4,0,185,112,4,0,209,112,4,0,239,112,4,0,1,113,4,0,43,113,4,0,50,113,4,0,62,113,4,0,91,113,4,0,144,113,4,0,151,113,4,0,174,113,4,0,197,113,4,0,204,113,4,0,211,113,4,0,223,113,4,0,235,113,4,0,247,113,4,0,8,114,4,0,21,114,4,0,38,114,4,0,55,114,4,0,73,114,4,0,95,114,4,0,166,114,4,0,220,114,4,0,17,115,4,0,29,115,4,0,41,115,4,0,50,115,4,0,85,115,4,0,148,115,4,0,200,115,4,0,238,115,4,0,74,116,4,0,178,116,4,0,23,201,17,0,23,201,17,0,23,201,17,0,27,117,4,0,63,117,4,0,95,117,4,0,112,117,4,0,162,117,4,0,210,117,4,0,236,117,4,0,0,118,4,0,23,118,4,0,50,118,4,0,73,118,4,0,88,118,4,0,101,118,4,0,116,118,4,0,131,118,4,0,174,118,4,0,217,118,4,0,24,119,4,0,64,119,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,124,119,4,0,131,119,4,0,138,119,4,0,145,119,4,0,152,119,4,0,159,119,4,0,166,119,4,0,23,201,17,0,173,119,4,0,180,119,4,0,187,119,4,0,194,119,4,0,23,201,17,0,201,119,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,208,119,4,0,227,119,4,0,246,119,4,0,9,120,4,0,28,120,4,0,39,120,4,0,50,120,4,0,61,120,4,0,72,120,4,0,119,120,4,0,166,120,4,0,213,120,4,0,4,121,4,0,47,121,4,0,86,121,4,0,23,201,17,0,137,121,4,0,154,121,4,0,165,121,4,0,177,121,4,0,194,121,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,211,121,4,0,248,121,4,0,5,122,4,0,16,122,4,0,29,122,4,0,54,122,4,0,66,122,4,0,78,122,4,0,23,201,17,0,23,201,17,0,95,122,4,0,159,122,4,0,207,122,4,0,238,122,4,0,13,123,4,0,44,123,4,0,75,123,4,0,23,201,17,0,23,201,17,0,23,201,17,0,115,123,4,0,140,123,4,0,161,123,4,0,187,123,4,0,219,123,4,0,0,124,4,0,21,124,4,0,50,124,4,0,114,124,4,0,134,124,4,0,200,124,4,0,58,125,4,0,230,125,4,0,52,126,4,0,114,126,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,141,126,4,0,154,126,4,0,175,126,4,0,204,126,4,0,211,121,4,0,241,126,4,0,30,127,4,0,99,127,4,0,168,127,4,0,13,128,4,0,81,128,4,0,146,128,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,207,128,4,0,239,128,4,0,49,129,4,0,97,129,4,0,147,129,4,0,187,129,4,0,223,129,4,0,35,130,4,0,82,130,4,0,104,130,4,0,141,130,4,0,188,130,4,0,214,130,4,0,10,131,4,0,47,131,4,0,110,131,4,0,157,131,4,0,248,131,4,0,61,132,4,0,125,132,4,0,155,132,4,0,193,132,4,0,220,132,4,0,6,133,4,0,43,133,4,0,79,133,4,0,207,128,4,0,239,128,4,0,109,133,4,0,135,133,4,0,147,129,4,0,79,133,4,0,35,130,4,0,162,133,4,0,82,130,4,0,141,130,4,0,245,133,4,0,214,130,4,0,10,131,4,0,16,134,4,0,47,131,4,0,78,134,4,0,110,131,4,0,115,134,4,0,125,132,4,0,152,134,4,0,215,134,4,0,6,133,4,0,34,135,4,0,95,135,4,0,162,135,4,0,194,135,4,0,2,136,4,0,52,136,4,0,102,136,4,0,142,136,4,0,178,136,4,0,242,136,4,0,33,137,4,0,55,137,4,0,92,137,4,0,139,137,4,0,165,137,4,0,217,137,4,0,254,137,4,0,61,138,4,0,106,138,4,0,195,138,4,0,4,139,4,0,60,139,4,0,90,139,4,0,128,139,4,0,155,139,4,0,197,139,4,0,234,139,4,0,14,140,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,44,140,4,0,51,140,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,63,140,4,0,125,140,4,0,180,140,4,0,228,140,4,0,32,141,4,0,83,141,4,0,121,141,4,0,201,141,4,0,252,141,4,0,29,142,4,0,73,142,4,0,120,142,4,0,142,142,4,0,222,142,4,0,17,143,4,0,72,143,4,0,132,143,4,0,187,143,4,0,228,143,4,0,24,144,4,0,51,144,4,0,102,144,4,0,129,144,4,0,171,144,4,0,208,144,4,0,251,144,4,0,25,145,4,0,87,145,4,0,163,145,4,0,200,145,4,0,20,146,4,0,72,146,4,0,128,146,4,0,178,146,4,0,247,146,4,0,17,147,4,0,66,147,4,0,94,147,4,0,143,147,4,0,179,147,4,0,248,147,4,0,47,148,4,0,83,148,4,0,139,148,4,0,194,148,4,0,220,148,4,0,12,149,4,0,80,149,4,0,113,149,4,0,167,149,4,0,237,149,4,0,43,150,4,0,104,150,4,0,148,150,4,0,215,150,4,0,5,151,4,0,50,151,4,0,116,151,4,0,171,151,4,0,222,151,4,0,17,152,4,0,77,152,4,0,108,152,4,0,196,152,4,0,248,147,4,0,4,153,4,0,71,153,4,0,124,153,4,0,167,153,4,0,215,153,4,0,246,153,4,0,220,148,4,0,54,154,4,0,126,154,4,0,200,154,4,0,12,155,4,0,63,155,4,0,136,155,4,0,189,155,4,0,238,155,4,0,70,156,4,0,154,156,4,0,23,201,17,0,176,156,4,0,217,156,4,0,29,157,4,0,94,157,4,0,23,201,17,0,23,201,17,0,23,201,17,0,138,157,4,0,225,157,4,0,42,158,4,0,114,158,4,0,233,158,4,0,95,159,4,0,23,201,17,0,135,159,4,0,138,159,4,0,141,159,4,0,196,159,4,0,215,159,4,0,27,160,4,0,103,160,4,0,127,160,4,0,190,160,4,0,5,161,4,0,46,161,4,0,144,161,4,0,215,161,4,0,228,161,4,0,245,161,4,0,13,162,4,0,41,162,4,0,70,162,4,0,127,162,4,0,139,162,4,0,161,162,4,0,182,162,4,0,199,162,4,0,206,162,4,0,238,162,4,0,14,163,4,0,36,163,4,0,58,163,4,0,107,163,4,0,156,163,4,0,165,163,4,0,174,163,4,0,181,163,4,0,193,163,4,0,200,163,4,0,212,163,4,0,229,163,4,0,246,163,4,0,2,164,4,0,15,164,4,0,44,164,4,0,56,164,4,0,73,164,4,0,90,164,4,0,99,164,4,0,108,164,4,0,127,164,4,0,146,164,4,0,189,164,4,0,221,164,4,0,237,164,4,0,251,164,4,0,9,165,4,0,37,165,4,0,54,165,4,0,71,165,4,0,88,165,4,0,23,201,17,0,105,165,4,0,128,165,4,0,151,165,4,0,174,165,4,0,197,165,4,0,225,165,4,0,250,165,4,0,19,166,4,0,44,166,4,0,69,166,4,0,142,166,4,0,169,166,4,0,188,166,4,0,240,166,4,0,63,167,4,0,116,167,4,0,167,167,4,0,248,167,4,0,50,168,4,0,116,168,4,0,138,168,4,0,216,168,4,0,15,169,4,0,97,169,4,0,23,201,17,0,119,169,4,0,167,169,4,0,229,169,4,0,17,170,4,0,64,170,4,0,112,170,4,0,159,170,4,0,210,170,4,0,6,171,4,0,56,171,4,0,107,171,4,0,147,171,4,0,191,171,4,0,213,171,4,0,25,172,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,93,172,4,0,130,172,4,0,167,172,4,0,207,172,4,0,247,172,4,0,13,173,4,0,35,173,4,0,86,173,4,0,137,173,4,0,185,173,4,0,233,173,4,0,1,174,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,65,174,4,0,97,174,4,0,183,174,4,0,247,174,4,0,49,175,4,0,89,175,4,0,125,175,4,0,202,175,4,0,249,175,4,0,15,176,4,0,54,176,4,0,101,176,4,0,127,176,4,0,179,176,4,0,216,176,4,0,47,177,4,0,102,177,4,0,227,177,4,0,56,178,4,0,124,178,4,0,154,178,4,0,198,178,4,0,225,178,4,0,11,179,4,0,48,179,4,0,84,179,4,0,65,174,4,0,97,174,4,0,114,179,4,0,140,179,4,0,49,175,4,0,84,179,4,0,202,175,4,0,167,179,4,0,249,175,4,0,54,176,4,0,18,180,4,0,127,176,4,0,179,176,4,0,45,180,4,0,216,176,4,0,107,180,4,0,47,177,4,0,144,180,4,0,124,178,4,0,181,180,4,0,244,180,4,0,11,179,4,0,79,181,4,0,156,181,4,0,239,181,4,0,15,182,4,0,93,182,4,0,161,182,4,0,219,182,4,0,3,183,4,0,39,183,4,0,121,183,4,0,168,183,4,0,190,183,4,0,231,183,4,0,22,184,4,0,48,184,4,0,100,184,4,0,137,184,4,0,220,184,4,0,15,185,4,0,134,185,4,0,213,185,4,0,27,186,4,0,57,186,4,0,105,186,4,0,132,186,4,0,174,186,4,0,211,186,4,0,247,186,4,0,21,187,4,0,106,187,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,165,187,4,0,172,187,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,184,187,4,0,4,188,4,0,67,188,4,0,123,188,4,0,191,188,4,0,252,188,4,0,38,189,4,0,154,189,4,0,205,189,4,0,238,189,4,0,30,190,4,0,77,190,4,0,99,190,4,0,179,190,4,0,230,190,4,0,45,191,4,0,113,191,4,0,176,191,4,0,219,191,4,0,27,192,4,0,58,192,4,0,109,192,4,0,136,192,4,0,178,192,4,0,215,192,4,0,0,193,4,0,30,193,4,0,108,193,4,0,218,193,4,0,16,194,4,0,103,194,4,0,165,194,4,0,227,194,4,0,33,195,4,0,120,195,4,0,150,195,4,0,205,195,4,0,249,195,4,0,46,196,4,0,91,196,4,0,178,196,4,0,241,196,4,0,25,197,4,0,86,197,4,0,154,197,4,0,184,197,4,0,245,197,4,0,62,198,4,0,107,198,4,0,173,198,4,0,3,199,4,0,79,199,4,0,148,199,4,0,198,199,4,0,23,200,4,0,75,200,4,0,144,200,4,0,228,200,4,0,31,201,4,0,82,201,4,0,145,201,4,0,209,201,4,0,244,201,4,0,88,202,4,0,178,196,4,0,160,202,4,0,241,202,4,0,48,203,4,0,99,203,4,0,155,203,4,0,190,203,4,0,6,204,4,0,58,204,4,0,138,204,4,0,220,204,4,0,44,205,4,0,103,205,4,0,184,205,4,0,245,205,4,0,53,206,4,0,153,206,4,0,0,207,4,0,23,201,17,0,22,207,4,0,71,207,4,0,155,207,4,0,236,207,4,0,23,201,17,0,23,201,17,0,34,208,4,0,123,208,4,0,2,209,4,0,103,209,4,0,207,209,4,0,118,210,4,0,32,211,4,0,23,201,17,0,169,76,4,0,72,111,4,0,72,211,4,0,151,211,4,0,172,211,4,0,4,212,4,0,96,212,4,0,120,212,4,0,195,212,4,0,34,213,4,0,93,213,4,0,215,213,4,0,153,112,4,0,54,214,4,0,185,112,4,0,71,214,4,0,99,214,4,0,128,214,4,0,191,214,4,0,203,214,4,0,62,113,4,0,225,214,4,0,144,113,4,0,167,172,4,0,207,172,4,0,247,172,4,0,13,173,4,0,35,173,4,0,86,173,4,0,242,214,4,0,251,214,4,0,197,113,4,0,4,215,4,0,204,113,4,0,211,113,4,0,16,215,4,0,33,215,4,0,235,113,4,0,50,215,4,0,73,215,4,0,223,113,4,0,102,215,4,0,119,215,4,0,147,110,4,0,156,110,4,0,136,215,4,0,155,215,4,0,174,215,4,0,217,215,4,0,9,216,4,0,25,216,4,0,39,216,4,0,53,216,4,0,38,114,4,0,21,114,4,0,89,216,4,0,106,216,4,0,123,216,4,0,142,216,4,0,169,216,4,0,196,216,4,0,223,216,4,0,250,216,4,0,26,217,4,0,47,217,4,0,68,217,4,0,89,217,4,0,110,217,4,0,197,217,4,0,224,217,4,0,1,174,4,0,243,217,4,0,86,218,4,0,139,218,4,0,202,218,4,0,43,219,4,0,153,219,4,0,73,114,4,0,235,219,4,0,69,220,4,0,125,220,4,0,228,220,4,0,23,201,17,0,250,220,4,0,69,221,4,0,153,221,4,0,205,221,4,0,4,222,4,0,64,222,4,0,117,222,4,0,174,222,4,0,3,223,4,0,72,223,4,0,131,223,4,0,179,223,4,0,231,223,4,0,253,223,4,0,93,224,4,0,189,224,4,0,214,224,4,0,239,224,4,0,8,225,4,0,23,201,17,0,33,225,4,0,111,225,4,0,210,225,4,0,10,226,4,0,102,226,4,0,197,226,4,0,31,227,4,0,110,227,4,0,166,227,4,0,225,227,4,0,34,228,4,0,100,228,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,190,228,4,0,213,228,4,0,248,228,4,0,27,229,4,0,27,229,4,0,94,229,4,0,157,229,4,0,189,229,4,0,221,229,4,0,13,230,4,0,45,230,4,0,77,230,4,0,166,230,4,0,214,230,4,0,128,231,4,0,65,232,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,190,228,4,0,213,228,4,0,248,228,4,0,117,232,4,0,27,229,4,0,94,229,4,0,157,229,4,0,189,229,4,0,221,229,4,0,13,230,4,0,45,230,4,0,180,232,4,0,248,232,4,0,214,230,4,0,40,233,4,0,205,233,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,110,234,4,0,147,234,4,0,189,234,4,0,245,234,4,0,45,235,4,0,71,235,4,0,97,235,4,0,172,235,4,0,247,235,4,0,55,236,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+61444);allocate([119,236,4,0,145,236,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,0,237,4,0,36,237,4,0,120,237,4,0,196,237,4,0,2,238,4,0,50,238,4,0,88,238,4,0,176,238,4,0,216,238,4,0,232,238,4,0,16,239,4,0,56,239,4,0,82,239,4,0,128,239,4,0,164,239,4,0,244,239,4,0,40,240,4,0,134,240,4,0,198,240,4,0,28,241,4,0,56,241,4,0,104,241,4,0,130,241,4,0,176,241,4,0,206,241,4,0,238,241,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,18,242,4,0,92,242,4,0,228,242,4,0,54,243,4,0,140,243,4,0,236,243,4,0,70,244,4,0,174,244,4,0,26,245,4,0,92,245,4,0,160,245,4,0,18,246,4,0,98,246,4,0,192,246,4,0,10,247,4,0,78,247,4,0,182,247,4,0,12,248,4,0,138,248,4,0,210,248,4,0,29,249,4,0,105,249,4,0,177,249,4,0,255,249,4,0,102,250,4,0,184,250,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,15,251,4,0,85,251,4,0,155,251,4,0,219,251,4,0,33,252,4,0,105,252,4,0,150,252,4,0,244,252,4,0,36,253,4,0,82,253,4,0,128,253,4,0,216,238,4,0,168,253,4,0,248,253,4,0,40,254,4,0,112,254,4,0,182,254,4,0,252,254,4,0,36,255,4,0,130,255,4,0,160,255,4,0,208,255,4,0,234,255,4,0,24,0,5,0,54,0,5,0,86,0,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,122,0,5,0,186,0,5,0,231,0,5,0,19,1,5,0,83,1,5,0,129,1,5,0,183,1,5,0,1,2,5,0,58,2,5,0,95,2,5,0,142,2,5,0,200,2,5,0,233,2,5,0,63,3,5,0,125,3,5,0,183,3,5,0,240,3,5,0,52,4,5,0,98,4,5,0,141,4,5,0,179,4,5,0,231,4,5,0,20,5,5,0,89,5,5,0,169,5,5,0,231,5,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,169,76,4,0,72,111,4,0,49,6,5,0,130,6,5,0,154,6,5,0,220,6,5,0,54,7,5,0,87,7,5,0,186,7,5,0,49,8,5,0,72,8,5,0,205,8,5,0,68,9,5,0,100,9,5,0,146,9,5,0,208,9,5,0,28,10,5,0,74,10,5,0,184,10,5,0,230,10,5,0,20,11,5,0,159,11,5,0,2,12,5,0,18,12,5,0,66,12,5,0,114,12,5,0,185,12,5,0,201,12,5,0,231,12,5,0,5,13,5,0,26,13,5,0,66,13,5,0,125,13,5,0,145,13,5,0,165,13,5,0,223,13,5,0,91,14,5,0,254,14,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,169,76,4,0,72,111,4,0,100,15,5,0,183,15,5,0,211,15,5,0,37,16,5,0,135,16,5,0,154,16,5,0,229,16,5,0,64,17,5,0,121,17,5,0,243,17,5,0,78,18,5,0,91,18,5,0,108,18,5,0,130,18,5,0,158,18,5,0,190,18,5,0,1,19,5,0,18,19,5,0,35,19,5,0,144,19,5,0,224,19,5,0,231,19,5,0,15,20,5,0,55,20,5,0,204,113,4,0,211,113,4,0,223,113,4,0,72,20,5,0,84,20,5,0,106,20,5,0,147,110,4,0,156,110,4,0,135,20,5,0,157,20,5,0,43,219,4,0,86,218,4,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,65,174,4,0,220,20,5,0,97,174,4,0,114,179,4,0,23,21,5,0,49,175,4,0,78,21,5,0,213,21,5,0,45,22,5,0,92,22,5,0,158,22,5,0,239,22,5,0,127,176,4,0,202,175,4,0,216,176,4,0,107,180,4,0,47,177,4,0,183,174,4,0,124,178,4,0,30,23,5,0,75,23,5,0,11,179,4,0,166,23,5,0,213,23,5,0,8,24,5,0,60,24,5,0,122,24,5,0,181,24,5,0,0,25,5,0,55,25,5,0,132,25,5,0,244,25,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,184,187,4,0,73,26,5,0,167,26,5,0,237,26,5,0,7,27,5,0,191,188,4,0,48,27,5,0,159,27,5,0,241,27,5,0,32,28,5,0,98,28,5,0,169,28,5,0,210,28,5,0,6,29,5,0,230,190,4,0,53,29,5,0,45,191,4,0,67,188,4,0,90,29,5,0,120,29,5,0,161,29,5,0,178,192,4,0,3,30,5,0,44,30,5,0,95,30,5,0,147,30,5,0,203,30,5,0,254,30,5,0,65,31,5,0,112,31,5,0,179,31,5,0,19,32,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,94,32,5,0,156,32,5,0,41,33,5,0,114,33,5,0,226,33,5,0,112,34,5,0,232,34,5,0,88,35,5,0,225,35,5,0,36,36,5,0,119,36,5,0,236,36,5,0,69,37,5,0,176,37,5,0,243,37,5,0,92,38,5,0,197,38,5,0,89,39,5,0,233,39,5,0,64,40,5,0,161,40,5,0,242,40,5,0,45,41,5,0,140,41,5,0,232,41,5,0,59,42,5,0,94,32,5,0,156,32,5,0,130,42,5,0,219,42,5,0,226,33,5,0,59,42,5,0,88,35,5,0,0,43,5,0,225,35,5,0,119,36,5,0,165,43,5,0,69,37,5,0,176,37,5,0,222,43,5,0,243,37,5,0,138,44,5,0,92,38,5,0,9,45,5,0,64,40,5,0,72,45,5,0,186,45,5,0,140,41,5,0,76,46,5,0,228,46,5,0,81,47,5,0,147,47,5,0,32,48,5,0,113,48,5,0,227,48,5,0,108,49,5,0,228,49,5,0,94,50,5,0,231,50,5,0,42,51,5,0,129,51,5,0,251,51,5,0,79,52,5,0,195,52,5,0,13,53,5,0,122,53,5,0,229,53,5,0,123,54,5,0,7,55,5,0,94,55,5,0,186,55,5,0,17,56,5,0,78,56,5,0,177,56,5,0,13,57,5,0,101,57,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,162,57,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,196,57,5,0,44,58,5,0,132,58,5,0,199,58,5,0,39,59,5,0,118,59,5,0,191,59,5,0,105,60,5,0,219,60,5,0,38,61,5,0,114,61,5,0,218,61,5,0,16,62,5,0,190,62,5,0,48,63,5,0,137,63,5,0,246,63,5,0,91,64,5,0,168,64,5,0,251,64,5,0,37,65,5,0,115,65,5,0,169,65,5,0,247,65,5,0,73,66,5,0,145,66,5,0,216,66,5,0,63,67,5,0,193,67,5,0,31,68,5,0,148,68,5,0,244,68,5,0,89,69,5,0,169,69,5,0,36,70,5,0,87,70,5,0,192,70,5,0,246,70,5,0,70,71,5,0,143,71,5,0,48,63,5,0,18,72,5,0,88,72,5,0,177,72,5,0,24,73,5,0,74,73,5,0,152,73,5,0,11,74,5,0,81,74,5,0,184,74,5,0,34,75,5,0,130,75,5,0,229,75,5,0,40,76,5,0,150,76,5,0,215,76,5,0,47,77,5,0,157,77,5,0,233,77,5,0,43,78,5,0,129,78,5,0,220,78,5,0,13,79,5,0,128,79,5,0,208,79,5,0,41,80,5,0,164,80,5,0,13,81,5,0,71,81,5,0,162,81,5,0,206,81,5,0,30,82,5,0,87,82,5,0,179,82,5,0,22,83,5,0,116,83,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,189,83,5,0,48,84,5,0,133,84,5,0,240,84,5,0,97,85,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,169,76,4,0,72,111,4,0,177,85,5,0,18,86,5,0,67,86,5,0,186,86,5,0,76,87,5,0,125,87,5,0,230,87,5,0,108,88,5,0,189,88,5,0,83,89,5,0,68,9,5,0,100,9,5,0,146,9,5,0,208,9,5,0,217,89,5,0,25,90,5,0,184,10,5,0,230,10,5,0,125,90,5,0,11,91,5,0,2,12,5,0,120,91,5,0,173,91,5,0,114,12,5,0,185,12,5,0,201,12,5,0,231,12,5,0,5,13,5,0,26,13,5,0,66,13,5,0,125,13,5,0,145,13,5,0,165,13,5,0,226,91,5,0,106,92,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,169,76,4,0,72,111,4,0,238,92,5,0,95,93,5,0,132,93,5,0,232,93,5,0,100,94,5,0,128,94,5,0,221,94,5,0,84,95,5,0,157,95,5,0,94,96,5,0,213,96,5,0,245,96,5,0,32,97,5,0,94,97,5,0,167,97,5,0,231,97,5,0,89,98,5,0,132,98,5,0,175,98,5,0,59,99,5,0,160,99,5,0,176,99,5,0,238,99,5,0,44,100,5,0,185,12,5,0,201,12,5,0,231,12,5,0,115,100,5,0,136,100,5,0,176,100,5,0,125,13,5,0,145,13,5,0,235,100,5,0,37,101,5,0,173,101,5,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,23,201,17,0,0,0,0,0,0,0,0,0,0,47,0,0,38,0,0,0,217,2,0,0,80,0,0,0,0,0,0,0,240,46,0,0,38,0,0,0,218,2,0,0,81,0,0,0,0,0,0,0,48,47,0,0,38,0,0,0,219,2,0,0,82,0,0,0,0,0,0,0,32,47,0,0,38,0,0,0,220,2,0,0,83,0,0,0,0,0,0,0,16,47,0,0,38,0,0,0,221,2,0,0,84,0,0,0,0,0,0,0,80,47,0,0,38,0,0,0,222,2,0,0,85,0,0,0,0,0,0,0,64,47,0,0,38,0,0,0,223,2,0,0,86,0,0,0,0,0,0,0,128,47,0,0,38,0,0,0,224,2,0,0,87,0,0,0,0,0,0,0,112,47,0,0,38,0,0,0,225,2,0,0,88,0,0,0,0,0,0,0,96,47,0,0,38,0,0,0,226,2,0,0,89,0,0,0,0,0,0,0,176,47,0,0,38,0,0,0,227,2,0,0,90,0,0,0,0,0,0,0,160,47,0,0,38,0,0,0,228,2,0,0,91,0,0,0,0,0,0,0,144,47,0,0,38,0,0,0,229,2,0,0,92,0,0,0,0,0,0,0,192,47,0,0,38,0,0,0,230,2,0,0,93,0,0,0,0,0,0,0,208,47,0,0,38,0,0,0,231,2,0,0,94,0,0,0,70,38,0,0,35,75,0,0,151,14,0,0,0,0,0,0,0,48,0,0,38,0,0,0,232,2,0,0,95,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,0,0,0,0,240,47,0,0,38,0,0,0,233,2,0,0,96,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,0,0,0,0,224,47,0,0,38,0,0,0,234,2,0,0,97,0,0,0,0,0,0,0,48,48,0,0,38,0,0,0,235,2,0,0,98,0,0,0,0,0,0,0,32,48,0,0,38,0,0,0,236,2,0,0,99,0,0,0,0,0,0,0,16,48,0,0,38,0,0,0,237,2,0,0,100,0,0,0,0,0,0,0,64,48,0,0,38,0,0,0,238,2,0,0,101,0,0,0,0,0,0,0,80,48,0,0,38,0,0,0,239,2,0,0,102,0,0,0,0,0,0,0,96,48,0,0,38,0,0,0,240,2,0,0,103,0,0,0,0,0,0,0,112,48,0,0,38,0,0,0,241,2,0,0,104,0,0,0,175,112,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,175,112,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,175,112,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,167,113,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,167,113,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,167,113,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,165,114,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,165,114,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,165,114,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,163,115,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,163,115,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,163,115,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,157,116,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,157,116,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,157,116,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,151,117,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,151,117,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,151,117,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,151,118,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,151,118,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,151,118,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,151,119,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,151,119,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,151,119,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,0,0,0,0,176,49,0,0,242,2,0,0,243,2,0,0,244,2,0,0,21,0,0,0,245,2,0,0,0,0,0,0,160,49,0,0,246,2,0,0,247,2,0,0,248,2,0,0,21,0,0,0,249,2,0,0,0,0,0,0,144,49,0,0,250,2,0,0,251,2,0,0,252,2,0,0,21,0,0,0,253,2,0,0,0,0,0,0,128,49,0,0,254,2,0,0,255,2,0,0,0,3,0,0,21,0,0,0,1,3,0,0,0,0,0,0,112,49,0,0,2,3,0,0,3,3,0,0,4,3,0,0,21,0,0,0,5,3,0,0,0,0,0,0,96,49,0,0,6,3,0,0,7,3,0,0,8,3,0,0,21,0,0,0,9,3,0,0,0,0,0,0,80,49,0,0,10,3,0,0,11,3,0,0,12,3,0,0,21,0,0,0,13,3,0,0,0,0,0,0,64,49,0,0,14,3,0,0,15,3,0,0,16,3,0,0,21,0,0,0,17,3,0,0,0,0,0,0,48,49,0,0,18,3,0,0,19,3,0,0,20,3,0,0,21,0,0,0,21,3,0,0,0,0,0,0,32,49,0,0,22,3,0,0,23,3,0,0,24,3,0,0,21,0,0,0,25,3,0,0,0,0,0,0,16,49,0,0,169,0,0,0,26,3,0,0,52,0,0,0,0,0,0,0,0,49,0,0,169,0,0,0,27,3,0,0,53,0,0,0,0,0,0,0,240,48,0,0,169,0,0,0,28,3,0,0,54,0,0,0,0,0,0,0,224,48,0,0,169,0,0,0,29,3,0,0,55,0,0,0,0,0,0,0,208,48,0,0,169,0,0,0,30,3,0,0,56,0,0,0,0,0,0,0,192,48,0,0,169,0,0,0,31,3,0,0,57,0,0,0,0,0,0,0,176,48,0,0,169,0,0,0,32,3,0,0,58,0,0,0,0,0,0,0,160,48,0,0,169,0,0,0,33,3,0,0,59,0,0,0,0,0,0,0,144,48,0,0,169,0,0,0,34,3,0,0,60,0,0,0,0,0,0,0,128,48,0,0,169,0,0,0,35,3,0,0,61,0,0,0,0,0,0,0,240,50,0,0,36,3,0,0,37,3,0,0,38,3,0,0,21,0,0,0,39,3,0,0,0,0,0,0,224,50,0,0,40,3,0,0,41,3,0,0,42,3,0,0,21,0,0,0,43,3,0,0,0,0,0,0,208,50,0,0,44,3,0,0,45,3,0,0,46,3,0,0,21,0,0,0,47,3,0,0,0,0,0,0,192,50,0,0,48,3,0,0,49,3,0,0,50,3,0,0,21,0,0,0,51,3,0,0,0,0,0,0,176,50,0,0,52,3,0,0,53,3,0,0,54,3,0,0,21,0,0,0,55,3,0,0,0,0,0,0,160,50,0,0,56,3,0,0,57,3,0,0,58,3,0,0,21,0,0,0,59,3,0,0,0,0,0,0,144,50,0,0,60,3,0,0,61,3,0,0,62,3,0,0,21,0,0,0,63,3,0,0,0,0,0,0,128,50,0,0,64,3,0,0,65,3,0,0,66,3,0,0,21,0,0,0,67,3,0,0,0,0,0,0,112,50,0,0,68,3,0,0,69,3,0,0,70,3,0,0,21,0,0,0,71,3,0,0,0,0,0,0,96,50,0,0,72,3,0,0,73,3,0,0,74,3,0,0,21,0,0,0,75,3,0,0,0,0,0,0,80,50,0,0,171,0,0,0,76,3,0,0,80,0,0,0,173,0,0,0,0,0,0,0,64,50,0,0,171,0,0,0,77,3,0,0,81,0,0,0,173,0,0,0,0,0,0,0,48,50,0,0,171,0,0,0,78,3,0,0,82,0,0,0,173,0,0,0,0,0,0,0,32,50,0,0,171,0,0,0,79,3,0,0,83,0,0,0,173,0,0,0,0,0,0,0,16,50,0,0,171,0,0,0,80,3,0,0,84,0,0,0,173,0,0,0,0,0,0,0,0,50,0,0,171,0,0,0,81,3,0,0,85,0,0,0,173,0,0,0,0,0,0,0,240,49,0,0,171,0,0,0,82,3,0,0,86,0,0,0,173,0,0,0,0,0,0,0,224,49,0,0,171,0,0,0,83,3,0,0,87,0,0,0,173,0,0,0,0,0,0,0,208,49,0,0,171,0,0,0,84,3,0,0,88,0,0,0,173,0,0,0,0,0,0,0,192,49,0,0,171,0,0,0,85,3,0,0,89,0,0,0,173,0,0,0,0,0,0,0,48,52,0,0,86,3,0,0,87,3,0,0,88,3,0,0,21,0,0,0,89,3,0,0,0,0,0,0,16,52,0,0,90,3,0,0,91,3,0,0,92,3,0,0,21,0,0,0,93,3,0,0,0,0,0,0,240,51,0,0,94,3,0,0,95,3,0,0,96,3,0,0,21,0,0,0,97,3,0,0,0,0,0,0,208,51,0,0,98,3,0,0,99,3,0,0,100,3,0,0,21,0,0,0,101,3,0,0,0,0,0,0,176,51,0,0,102,3,0,0,103,3,0,0,104,3,0,0,21,0,0,0,105,3,0,0,0,0,0,0,144,51,0,0,106,3,0,0,107,3,0,0,108,3,0,0,21,0,0,0,109,3,0,0,0,0,0,0,112,51,0,0,110,3,0,0,111,3,0,0,112,3,0,0,21,0,0,0,113,3,0,0,0,0,0,0,80,51,0,0,114,3,0,0,115,3,0,0,116,3,0,0,21,0,0,0,117,3,0,0,0,0,0,0,48,51,0,0,118,3,0,0,119,3,0,0,120,3,0,0,21,0,0,0,121,3,0,0,0,0,0,0,16,51,0,0,122,3,0,0,123,3,0,0,124,3,0,0,21,0,0,0,125,3,0,0,0,0,0,0,0,51,0,0,126,3,0,0,127,3,0,0,42,0,0,0,176,0,0,0,0,0,0,0,32,51,0,0,128,3,0,0,129,3,0,0,43,0,0,0,176,0,0,0,0,0,0,0,64,51,0,0,130,3,0,0,131,3,0,0,44,0,0,0,176,0,0,0,0,0,0,0,96,51,0,0,132,3,0,0,133,3,0,0,45,0,0,0,176,0,0,0,0,0,0,0,128,51,0,0,134,3,0,0,135,3,0,0,46,0,0,0,176,0,0,0,0,0,0,0,160,51,0,0,136,3,0,0,137,3,0,0,47,0,0,0,176,0,0,0,0,0,0,0,192,51,0,0,138,3,0,0,139,3,0,0,48,0,0,0,176,0,0,0,0,0,0,0,224,51,0,0,140,3,0,0,141,3,0,0,49,0,0,0,176,0,0,0,0,0,0,0,0,52,0,0,142,3,0,0,143,3,0,0,50,0,0,0,176,0,0,0,0,0,0,0,32,52,0,0,144,3,0,0,145,3,0,0,51,0,0,0,176,0,0,0,153,6,0,0,185,5,0,0,227,2,0,0,103,3,0,0,113,11,0,0,40,1,0,0,79,0,0,0,232,1,0,0,52,15,0,0,0,0,0,0,96,52,0,0,38,0,0,0,146,3,0,0,105,0,0,0,0,0,0,0,80,52,0,0,38,0,0,0,147,3,0,0,106,0,0,0,0,0,0,0,64,52,0,0,38,0,0,0,148,3,0,0,107,0,0,0,217,51,0,0,104,231,255,255,6,248,255,255,126,240,255,255,4,30,0,0,170,0,0,0,228,0,0,0,188,252,255,255,235,16,0,0,0,0,0,0,144,52,0,0,38,0,0,0,149,3,0,0,108,0,0,0,0,0,0,0,128,52,0,0,38,0,0,0,150,3,0,0,109,0,0,0,0,0,0,0,112,52,0,0,38,0,0,0,151,3,0,0,110,0,0,0,0,0,0,0,208,52,0,0,38,0,0,0,152,3,0,0,111,0,0,0,0,0,0,0,192,52,0,0,38,0,0,0,153,3,0,0,112,0,0,0,0,0,0,0,176,52,0,0,38,0,0,0,154,3,0,0,113,0,0,0,0,0,0,0,160,52,0,0,38,0,0,0,155,3,0,0,114,0,0,0,3,0,0,0,0,0,0,0,16,53,0,0,38,0,0,0,156,3,0,0,115,0,0,0,0,0,0,0,0,53,0,0,38,0,0,0,157,3,0,0,116,0,0,0,0,0,0,0,240,52,0,0,38,0,0,0,158,3,0,0,117,0,0,0,0,0,0,0,224,52,0,0,38,0,0,0,159,3,0,0,118,0,0,0,15,148,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,15,148,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,15,148,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,11,149,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,11,149,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,11,149,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,7,150,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,7,150,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,7,150,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,1,151,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,1,151,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,1,151,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,193,153,5,0,32,152,5,0,136,3,0,0,0,0,0,0,35,154,5,0,82,30,7,0,234,152,5,0,115,152,5,0,32,152,5,0,239,0,0,0,0,0,0,0,219,152,5,0,82,30,7,0,234,152,5,0,34,153,5,0,32,152,5,0,113,0,0,0,0,0,0,0,219,152,5,0,82,30,7,0,234,152,5,0,34,153,5,0,32,152,5,0,131,0,0,0,5,0,0,0,132,153,5,0,173,153,5,0,183,153,5,0,196,156,5,0,32,152,5,0,197,6,0,0,0,0,0,0,47,157,5,0,82,30,7,0,76,157,5,0,0,0,0,0,80,53,0,0,38,0,0,0,160,3,0,0,119,0,0,0,0,0,0,0,64,53,0,0,38,0,0,0,161,3,0,0,120,0,0,0,0,0,0,0,48,53,0,0,38,0,0,0,162,3,0,0,121,0,0,0,0,0,0,0,32,53,0,0,38,0,0,0,163,3,0,0,122,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,96,53,0,0,63,0,0,0,164,3,0,0,165,3,0,0,26,0,0,0,166,3,0,0,0,0,0,0,128,53,0,0,38,0,0,0,167,3,0,0,123,0,0,0,0,0,0,0,112,53,0,0,38,0,0,0,168,3,0,0,124,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,176,53,0,0,38,0,0,0,169,3,0,0,125,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,160,53,0,0,38,0,0,0,170,3,0,0,126,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,43,135,54,63,78,98,16,63,135,22,153,62,162,69,22,63,213,120,233,61,18,131,96,63,109,231,251,62,0,0,0,0,144,53,0,0,38,0,0,0,171,3,0,0,127,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,224,53,0,0,38,0,0,0,172,3,0,0,128,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,208,53,0,0,38,0,0,0,173,3,0,0,129,0,0,0,129,149,179,63,180,200,54,191,197,32,176,190,170,241,226,63,133,235,145,63,106,188,20,191,113,61,202,190,74,12,2,64,0,0,0,0,192,53,0,0,38,0,0,0,174,3,0,0,130,0,0,0,0,0,0,0,96,54,0,0,38,0,0,0,175,3,0,0,131,0,0,0,0,0,0,0,80,54,0,0,38,0,0,0,176,3,0,0,132,0,0,0,0,0,0,0,64,54,0,0,38,0,0,0,177,3,0,0,133,0,0,0,0,0,0,0,48,54,0,0,38,0,0,0,178,3,0,0,134,0,0,0,0,0,0,0,32,54,0,0,38,0,0,0,179,3,0,0,135,0,0,0,0,0,0,0,16,54,0,0,38,0,0,0,180,3,0,0,136,0,0,0,0,0,0,0,0,54,0,0,38,0,0,0,181,3,0,0,137,0,0,0,0,0,0,0,240,53,0,0,38,0,0,0,182,3,0,0,138,0,0,0,0,0,0,0,160,54,0,0,38,0,0,0,183,3,0,0,139,0,0,0,0,0,0,0,144,54,0,0,38,0,0,0,184,3,0,0,140,0,0,0,0,0,0,0,128,54,0,0,38,0,0,0,185,3,0,0,141,0,0,0,0,0,0,0,112,54,0,0,38,0,0,0,186,3,0,0,142,0,0,0,0,0,0,0,176,54,0,0,38,0,0,0,187,3,0,0,143,0,0,0,0,0,0,0,112,55,0,0,38,0,0,0,188,3,0,0,144,0,0,0,0,0,0,0,96,55,0,0,38,0,0,0,189,3,0,0,145,0,0,0,0,0,0,0,80,55,0,0,38,0,0,0,190,3,0,0,146,0,0,0,0,0,0,0,64,55,0,0,38,0,0,0,191,3,0,0,147,0,0,0,0,0,0,0,48,55,0,0,38,0,0,0,192,3,0,0,148,0,0,0,0,0,0,0,32,55,0,0,38,0,0,0,193,3,0,0,149,0,0,0,0,0,0,0,16,55,0,0,38,0,0,0,194,3,0,0,150,0,0,0,0,0,0,0,0,55,0,0,38,0,0,0,195,3,0,0,151,0,0,0,0,0,0,0,240,54,0,0,38,0,0,0,196,3,0,0,152,0,0,0,0,0,0,0,224,54,0,0,38,0,0,0,197,3,0,0,153,0,0,0,0,0,0,0,208,54,0,0,38,0,0,0,198,3,0,0,154,0,0,0,0,0,0,0,192,54,0,0,38,0,0,0,199,3,0,0,155,0,0,0,13,171,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,13,171,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,13,171,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,251,172,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,251,172,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,251,172,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,3,174,5,0,159,170,5,0,3,1,0,0,0,0,0,0,145,172,5,0,187,172,5,0,191,172,5,0,3,174,5,0,159,170,5,0,4,1,0,0,0,0,0,0,78,172,5,0,121,172,5,0,125,172,5,0,3,174,5,0,159,170,5,0,5,1,0,0,0,0,0,0,15,172,5,0,48,172,5,0,54,172,5,0,0,0,0,0,176,55,0,0,38,0,0,0,200,3,0,0,156,0,0,0,0,0,0,0,160,55,0,0,38,0,0,0,201,3,0,0,157,0,0,0,0,0,0,0,144,55,0,0,38,0,0,0,202,3,0,0,158,0,0,0,0,0,0,0,128,55,0,0,38,0,0,0,203,3,0,0,159,0,0,0,0,0,0,0,240,55,0,0,38,0,0,0,204,3,0,0,160,0,0,0,0,0,0,0,224,55,0,0,38,0,0,0,205,3,0,0,161,0,0,0,0,0,0,0,208,55,0,0,38,0,0,0,206,3,0,0,162,0,0,0,0,0,0,0,192,55,0,0,38,0,0,0,207,3,0,0,163,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,208,3,0,0,209,3,0,0,210,3,0,0,108,0,0,0,0,0,0,0,72,56,0,0,211,3,0,0,212,3,0,0,148,255,255,255,148,255,255,255,72,56,0,0,213,3,0,0,214,3,0,0,64,58,1,0,28,56,0,0,48,56,0,0,84,58,1,0,0,0,0,0,56,56,0,0,215,3,0,0,216,3,0,0,164,0,0,0,5,0,0,0,90,0,0,0,41,0,0,0,23,0,0,0,3,0,0,0,2,0,0,0,24,0,0,0,5,0,0,0,27,0,0,0,3,0,0,0,28,0,0,0,24,201,5,0,214,194,5,0,68,5,0,0,1,0,0,0,23,201,17,0,231,202,5,0,195,212,5,0,24,201,5,0,214,194,5,0,69,5,0,0,1,0,0,0,23,201,17,0,218,202,5,0,195,212,5,0,24,201,5,0,214,194,5,0,157,6,0,0,1,0,0,0,23,201,17,0,70,202,5,0,195,212,5,0,24,201,5,0,214,194,5,0,157,6,0,0,1,0,0,0,23,201,17,0,54,202,5,0,223,212,5,0,24,201,5,0,214,194,5,0,165,6,0,0,1,0,0,0,23,201,17,0,34,202,5,0,195,212,5,0,24,201,5,0,214,194,5,0,165,6,0,0,1,0,0,0,23,201,17,0,13,202,5,0,219,193,6,0,24,201,5,0,214,194,5,0,166,6,0,0,1,0,0,0,23,201,17,0,250,201,5,0,195,212,5,0,24,201,5,0,214,194,5,0,166,6,0,0,1,0,0,0,23,201,17,0,230,201,5,0,219,193,6,0,24,201,5,0,214,194,5,0,8,7,0,0,1,0,0,0,23,201,17,0,214,201,5,0,195,212,5,0,24,201,5,0,214,194,5,0,8,7,0,0,1,0,0,0,23,201,17,0,197,201,5,0,223,212,5,0,24,201,5,0,214,194,5,0,62,7,0,0,1,0,0,0,23,201,17,0,180,201,5,0,219,193,6,0,24,201,5,0,214,194,5,0,62,7,0,0,1,0,0,0,23,201,17,0,164,201,5,0,140,207,6,0,24,201,5,0,214,194,5,0,63,7,0,0,1,0,0,0,23,201,17,0,147,201,5,0,219,193,6,0,24,201,5,0,214,194,5,0,63,7,0,0,1,0,0,0,23,201,17,0,131,201,5,0,140,207,6,0,60,0,0,0,0,0,0,0,160,56,0,0,217,3,0,0,218,3,0,0,196,255,255,255,196,255,255,255,160,56,0,0,219,3,0,0,220,3,0,0,64,60,1,0,132,56,0,0,152,56,0,0,84,60,1,0,0,0,0,0,56,58,0,0,63,0,0,0,221,3,0,0,222,3,0,0,29,0,0,0,223,3,0,0,0,0,0,0,24,58,0,0,63,0,0,0,224,3,0,0,225,3,0,0,30,0,0,0,226,3,0,0,0,0,0,0,248,57,0,0,63,0,0,0,227,3,0,0,228,3,0,0,31,0,0,0,229,3,0,0,0,0,0,0,216,57,0,0,63,0,0,0,230,3,0,0,231,3,0,0,32,0,0,0,232,3,0,0,0,0,0,0,184,57,0,0,63,0,0,0,233,3,0,0,234,3,0,0,33,0,0,0,235,3,0,0,0,0,0,0,152,57,0,0,63,0,0,0,236,3,0,0,237,3,0,0,34,0,0,0,238,3,0,0,0,0,0,0,120,57,0,0,63,0,0,0,239,3,0,0,240,3,0,0,35,0,0,0,241,3,0,0,0,0,0,0,88,57,0,0,63,0,0,0,242,3,0,0,243,3,0,0,36,0,0,0,244,3,0,0,0,0,0,0,56,57,0,0,63,0,0,0,245,3,0,0,246,3,0,0,37,0,0,0,247,3,0,0,0,0,0,0,24,57,0,0,63,0,0,0,248,3,0,0,249,3,0,0,38,0,0,0,250,3,0,0,0,0,0,0,248,56,0,0,63,0,0,0,251,3,0,0,252,3,0,0,39,0,0,0,253,3,0,0,0,0,0,0,216,56,0,0,63,0,0,0,254,3,0,0,255,3,0,0,40,0,0,0,0,4,0,0,0,0,0,0,176,56,0,0,63,0,0,0,1,4,0,0,2,4,0,0,41,0,0,0,3,4,0,0,0,0,0,0,200,56,0,0,4,4,0,0,5,4,0,0,11,0,0,0,42,0,0,0,0,0,0,0,192,56,0,0,4,4,0,0,6,4,0,0,11,0,0,0,42,0,0,0,0,0,0,0,232,56,0,0,4,4,0,0,7,4,0,0,11,0,0,0,43,0,0,0,20,212,5,0,232,208,5,0,86,2,0,0,1,0,0,0,23,201,17,0,204,212,5,0,223,212,5,0,20,212,5,0,232,208,5,0,86,2,0,0,1,0,0,0,23,201,17,0,177,212,5,0,195,212,5,0,0,0,0,0,8,57,0,0,4,4,0,0,8,4,0,0,11,0,0,0,42,0,0,0,0,0,0,0,40,57,0,0,4,4,0,0,9,4,0,0,11,0,0,0,44,0,0,0,0,0,0,0,72,57,0,0,4,4,0,0,10,4,0,0,11,0,0,0,45,0,0,0,0,0,0,0,104,57,0,0,4,4,0,0,11,4,0,0,11,0,0,0,42,0,0,0,0,0,0,0,136,57,0,0,4,4,0,0,12,4,0,0,11,0,0,0,46,0,0,0,0,0,0,0,168,57,0,0,4,4,0,0,13,4,0,0,12,0,0,0,42,0,0,0,0,0,0,0,200,57,0,0,4,4,0,0,14,4,0,0,11,0,0,0,42,0,0,0,0,0,0,0,232,57,0,0,4,4,0,0,15,4,0,0,11,0,0,0,42,0,0,0,0,0,0,0,8,58,0,0,4,4,0,0,16,4,0,0,11,0,0,0,42,0,0,0,0,0,0,0,40,58,0,0,4,4,0,0,17,4,0,0,11,0,0,0,47,0,0,0,213,223,5,0,232,208,5,0,5,1,0,0,1,0,0,0,23,201,17,0,129,224,5,0,219,193,6,0,213,223,5,0,232,208,5,0,5,1,0,0,1,0,0,0,23,201,17,0,115,224,5,0,140,207,6,0,0,0,0,0,72,58,0,0,4,4,0,0,18,4,0,0,11,0,0,0,48,0,0,0,133,225,5,0,232,208,5,0,226,0,0,0,1,0,0,0,23,201,17,0,129,224,5,0,219,193,6,0,133,225,5,0,232,208,5,0,226,0,0,0,1,0,0,0,23,201,17,0,115,224,5,0,140,207,6,0,0,0,0,0,88,58,0,0,63,0,0,0,19,4,0,0,20,4,0,0,42,0,0,0,21,4,0,0,136,235,5,0,140,235,5,0,146,235,5,0,153,235,5,0,0,0,0,0,0,0,0,0,104,58,0,0,63],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+71684);allocate([22,4,0,0,23,4,0,0,43,0,0,0,24,4,0,0,0,0,0,0,120,58,0,0,25,4,0,0,26,4,0,0,27,4,0,0,21,0,0,0,28,4,0,0,25,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,165,0,0,0,29,4,0,0,26,0,0,0,30,4,0,0,31,4,0,0,112,0,0,0,0,0,0,0,24,59,0,0,32,4,0,0,33,4,0,0,104,0,0,0,248,255,255,255,24,59,0,0,34,4,0,0,35,4,0,0,144,255,255,255,144,255,255,255,24,59,0,0,36,4,0,0,37,4,0,0,124,64,1,0,188,58,0,0,148,58,0,0,168,58,0,0,252,58,0,0,16,59,0,0,228,58,0,0,208,58,0,0,164,64,1,0,144,64,1,0,0,0,0,0,40,59,0,0,38,4,0,0,39,4,0,0,1,0,0,0,1,0,0,0,91,0,0,0,49,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,27,0,0,0,5,0,0,0,44,0,0,0,3,0,0,0,45,0,0,0,0,0,0,0,56,59,0,0,40,4,0,0,41,4,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,51,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,14,0,0,0,37,251,5,0,121,248,5,0,134,0,0,0,0,0,0,0,224,251,5,0,5,252,5,0,12,252,5,0,37,251,5,0,121,248,5,0,137,0,0,0,1,0,0,0,162,251,5,0,208,251,5,0,220,251,5,0,0,0,0,0,80,59,0,0,63,0,0,0,43,4,0,0,44,4,0,0,51,0,0,0,45,4,0,0,0,0,0,0,112,59,0,0,46,4,0,0,47,4,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,65,0,0,0,50,0,0,0,52,0,0,0,46,0,0,0,52,0,0,0,53,0,0,0,60,0,0,0,66,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,33,0,0,0,14,0,0,0,0,0,0,0,96,59,0,0,63,0,0,0,48,4,0,0,49,4,0,0,54,0,0,0,50,4,0,0,245,253,5,0,121,248,5,0,205,1,0,0,1,0,0,0,23,201,17,0,108,254,5,0,140,207,6,0,0,0,0,0,208,59,0,0,63,0,0,0,51,4,0,0,52,4,0,0,55,0,0,0,53,4,0,0,0,0,0,0,128,59,0,0,54,4,0,0,55,4,0,0,56,4,0,0,57,4,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,88,0,0,0,104,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,20,0,0,0,255,255,255,255,24,0,0,0,32,0,0,0,40,0,0,0,44,0,0,0,48,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,64,0,0,0,68,0,0,0,8,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,4,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,44,0,0,0,8,0,0,0,0,0,0,0,224,59,0,0,58,4,0,0,59,4,0,0,166,0,0,0,28,0,0,0,56,0,0,0,29,0,0,0,30,0,0,0,60,4,0,0,31,0,0,0,167,0,0,0,168,0,0,0,57,0,0,0,32,0,0,0,169,0,0,0,58,0,0,0,33,0,0,0,15,0,0,0,34,0,0,0,170,0,0,0,171,0,0,0,61,4,0,0,35,0,0,0,172,0,0,0,36,0,0,0,173,0,0,0,0,0,0,0,255,255,255,255,124,0,0,0,12,0,0,0,255,255,255,255,24,0,0,0,28,0,0,0,35,0,0,0,24,0,0,0,37,0,0,0,255,255,255,255,52,0,0,0,120,24,8,0,248,24,8,0,64,25,8,0,88,25,8,0,0,0,0,0,40,60,0,0,62,4,0,0,63,4,0,0,166,0,0,0,37,0,0,0,59,0,0,0,38,0,0,0,39,0,0,0,64,4,0,0,40,0,0,0,167,0,0,0,168,0,0,0,60,0,0,0,41,0,0,0,174,0,0,0,58,0,0,0,42,0,0,0,16,0,0,0,34,0,0,0,175,0,0,0,176,0,0,0,61,4,0,0,35,0,0,0,177,0,0,0,36,0,0,0,178,0,0,0,0,0,0,0,56,60,0,0,65,4,0,0,66,4,0,0,179,0,0,0,43,0,0,0,61,0,0,0,44,0,0,0,45,0,0,0,67,4,0,0,46,0,0,0,167,0,0,0,180,0,0,0,62,0,0,0,47,0,0,0,181,0,0,0,58,0,0,0,48,0,0,0,17,0,0,0,34,0,0,0,182,0,0,0,183,0,0,0,61,4,0,0,49,0,0,0,184,0,0,0,36,0,0,0,185,0,0,0,50,0,0,0,51,0,0,0,0,0,0,0,0,60,0,0,68,4,0,0,69,4,0,0,166,0,0,0,52,0,0,0,63,0,0,0,53,0,0,0,54,0,0,0,70,4,0,0,55,0,0,0,167,0,0,0,168,0,0,0,64,0,0,0,56,0,0,0,186,0,0,0,58,0,0,0,57,0,0,0,18,0,0,0,34,0,0,0,187,0,0,0,188,0,0,0,61,4,0,0,35,0,0,0,189,0,0,0,36,0,0,0,190,0,0,0,0,0,0,0,240,59,0,0,71,4,0,0,72,4,0,0,65,0,0,0,19,0,0,0,66,0,0,0,20,0,0,0,191,0,0,0,192,0,0,0,58,0,0,0,59,0,0,0,73,4,0,0,74,4,0,0,193,0,0,0,194,0,0,0,67,0,0,0,195,0,0,0,60,0,0,0,61,0,0,0,196,0,0,0,0,0,0,0,128,60,0,0,65,4,0,0,75,4,0,0,179,0,0,0,43,0,0,0,61,0,0,0,44,0,0,0,45,0,0,0,67,4,0,0,46,0,0,0,167,0,0,0,180,0,0,0,62,0,0,0,47,0,0,0,181,0,0,0,58,0,0,0,48,0,0,0,17,0,0,0,34,0,0,0,182,0,0,0,183,0,0,0,61,4,0,0,49,0,0,0,184,0,0,0,36,0,0,0,185,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,72,60,0,0,65,4,0,0,76,4,0,0,179,0,0,0,43,0,0,0,61,0,0,0,44,0,0,0,45,0,0,0,67,4,0,0,46,0,0,0,167,0,0,0,180,0,0,0,62,0,0,0,47,0,0,0,181,0,0,0,58,0,0,0,48,0,0,0,17,0,0,0,34,0,0,0,182,0,0,0,197,0,0,0,61,4,0,0,49,0,0,0,184,0,0,0,36,0,0,0,1,0,0,0,50,0,0,0,51,0,0,0,0,0,0,0,88,60,0,0,77,4,0,0,78,4,0,0,179,0,0,0,43,0,0,0,61,0,0,0,44,0,0,0,45,0,0,0,67,4,0,0,46,0,0,0,167,0,0,0,180,0,0,0,62,0,0,0,47,0,0,0,181,0,0,0,58,0,0,0,48,0,0,0,17,0,0,0,34,0,0,0,182,0,0,0,197,0,0,0,61,4,0,0,49,0,0,0,184,0,0,0,36,0,0,0,1,0,0,0,50,0,0,0,51,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,160,0,0,0,156,0,0,0,164,0,0,0,152,0,0,0,136,0,0,0,8,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,88,0,0,0,104,0,0,0,120,0,0,0,0,0,0,0,144,60,0,0,79,4,0,0,80,4,0,0,166,0,0,0,64,0,0,0,67,0,0,0,65,0,0,0,66,0,0,0,81,4,0,0,67,0,0,0,167,0,0,0,168,0,0,0,68,0,0,0,68,0,0,0,198,0,0,0,58,0,0,0,69,0,0,0,21,0,0,0,34,0,0,0,199,0,0,0,200,0,0,0,61,4,0,0,35,0,0,0,201,0,0,0,36,0,0,0,202,0,0,0,0,0,0,0,255,255,255,255,172,0,0,0,176,25,8,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,28,0,0,0,32,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,4,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,60,0,0,0,64,0,0,0,8,0,0,0,68,0,0,0,24,0,0,0,0,0,0,0,160,60,0,0,82,4,0,0,83,4,0,0,166,0,0,0,70,0,0,0,69,0,0,0,71,0,0,0,72,0,0,0,84,4,0,0,73,0,0,0,167,0,0,0,168,0,0,0,70,0,0,0,74,0,0,0,203,0,0,0,58,0,0,0,75,0,0,0,22,0,0,0,34,0,0,0,204,0,0,0,205,0,0,0,61,4,0,0,35,0,0,0,206,0,0,0,36,0,0,0,207,0,0,0,0,0,0,0,255,255,255,255,40,0,0,0,9,0,0,0,16,0,0,0,24,0,0,0,18,0,0,0,255,255,255,255,76,0,0,0,104,26,8,0,144,26,8,0,168,26,8,0,0,0,0,0,240,60,0,0,85,4,0,0,86,4,0,0,166,0,0,0,76,0,0,0,71,0,0,0,77,0,0,0,78,0,0,0,87,4,0,0,79,0,0,0,167,0,0,0,168,0,0,0,72,0,0,0,80,0,0,0,208,0,0,0,58,0,0,0,81,0,0,0,23,0,0,0,34,0,0,0,209,0,0,0,210,0,0,0,61,4,0,0,35,0,0,0,211,0,0,0,36,0,0,0,212,0,0,0,0,0,0,0,176,60,0,0,88,4,0,0,89,4,0,0,73,0,0,0,24,0,0,0,74,0,0,0,20,0,0,0,191,0,0,0,192,0,0,0,82,0,0,0,83,0,0,0,90,4,0,0,91,4,0,0,193,0,0,0,194,0,0,0,67,0,0,0,195,0,0,0,84,0,0,0,85,0,0,0,213,0,0,0,0,0,0,0,192,60,0,0,92,4,0,0,93,4,0,0,214,0,0,0,86,0,0,0,75,0,0,0,87,0,0,0,45,0,0,0,94,4,0,0,88,0,0,0,167,0,0,0,215,0,0,0,76,0,0,0,89,0,0,0,216,0,0,0,58,0,0,0,90,0,0,0,25,0,0,0,34,0,0,0,182,0,0,0,217,0,0,0,61,4,0,0,91,0,0,0,184,0,0,0,36,0,0,0,218,0,0,0,92,0,0,0,93,0,0,0,0,0,0,0,224,60,0,0,92,4,0,0,95,4,0,0,214,0,0,0,86,0,0,0,75,0,0,0,87,0,0,0,45,0,0,0,94,4,0,0,88,0,0,0,167,0,0,0,215,0,0,0,76,0,0,0,89,0,0,0,216,0,0,0,58,0,0,0,90,0,0,0,25,0,0,0,34,0,0,0,182,0,0,0,197,0,0,0,61,4,0,0,91,0,0,0,184,0,0,0,36,0,0,0,1,0,0,0,92,0,0,0,93,0,0,0,0,0,0,0,208,60,0,0,96,4,0,0,97,4,0,0,214,0,0,0,86,0,0,0,75,0,0,0,87,0,0,0,45,0,0,0,94,4,0,0,88,0,0,0,167,0,0,0,215,0,0,0,76,0,0,0,89,0,0,0,216,0,0,0,58,0,0,0,90,0,0,0,25,0,0,0,34,0,0,0,182,0,0,0,197,0,0,0,61,4,0,0,91,0,0,0,184,0,0,0,36,0,0,0,1,0,0,0,92,0,0,0,93,0,0,0,0,0,0,0,0,61,0,0,92,4,0,0,98,4,0,0,214,0,0,0,86,0,0,0,75,0,0,0,87,0,0,0,45,0,0,0,94,4,0,0,88,0,0,0,167,0,0,0,215,0,0,0,76,0,0,0,89,0,0,0,216,0,0,0,58,0,0,0,90,0,0,0,25,0,0,0,34,0,0,0,182,0,0,0,217,0,0,0,61,4,0,0,91,0,0,0,184,0,0,0,36,0,0,0,218,0,0,0,94,0,0,0,95,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,8,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,24,0,0,0,0,0,0,0,16,61,0,0,99,4,0,0,100,4,0,0,166,0,0,0,96,0,0,0,77,0,0,0,97,0,0,0,98,0,0,0,101,4,0,0,99,0,0,0,167,0,0,0,168,0,0,0,78,0,0,0,100,0,0,0,219,0,0,0,58,0,0,0,101,0,0,0,26,0,0,0,34,0,0,0,220,0,0,0,221,0,0,0,61,4,0,0,35,0,0,0,222,0,0,0,36,0,0,0,223,0,0,0,0,0,0,0,255,255,255,255,32,0,0,0,7,0,0,0,255,255,255,255,32,0,0,0,16,27,8,0,48,27,8,0,0,0,0,0,32,61,0,0,102,4,0,0,103,4,0,0,166,0,0,0,102,0,0,0,79,0,0,0,103,0,0,0,104,0,0,0,104,4,0,0,105,0,0,0,167,0,0,0,168,0,0,0,80,0,0,0,106,0,0,0,224,0,0,0,58,0,0,0,107,0,0,0,27,0,0,0,34,0,0,0,225,0,0,0,226,0,0,0,61,4,0,0,35,0,0,0,227,0,0,0,36,0,0,0,228,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,84,0,0,0,16,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,104,0,0,0,80,0,0,0,88,0,0,0,92,0,0,0,96,0,0,0,100,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,6,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,21,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,88,0,0,0,92,0,0,0,16,0,0,0,120,0,0,0,121,0,0,0,28,0,0,0,96,0,0,0,100,0,0,0,104,0,0,0,108,0,0,0,112,0,0,0,116,0,0,0,124,0,0,0,40,0,0,0,52,0,0,0,64,0,0,0,76,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,8,0,0,0,9,0,0,0,255,255,255,255,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,10,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,48,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,44,0,0,0,32,0,0,0,40,0,0,0,36,0,0,0,49,0,0,0,2,0,0,0,8,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,7,0,0,0,4,0,0,0,6,0,0,0,5,0,0,0,9,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,32,0,0,0,36,0,0,0,40,0,0,0,28,0,0,0,44,0,0,0,16,0,0,0,48,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,4,0,0,0,255,255,255,255,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,40,0,0,0,28,0,0,0,44,0,0,0,36,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,5,0,0,0,4,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,92,0,0,0,32,0,0,0,60,0,0,0,48,0,0,0,100,0,0,0,96,0,0,0,101,0,0,0,76,0,0,0,16,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,2,0,0,0,1,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,100,0,0,0,116,0,0,0,88,0,0,0,16,0,0,0,112,0,0,0,44,0,0,0,120,0,0,0,60,0,0,0,32,0,0,0,124,0,0,0,168,0,0,0,196,0,0,0,128,0,0,0,132,0,0,0,204,0,0,0,136,0,0,0,212,0,0,0,92,0,0,0,140,0,0,0,144,0,0,0,148,0,0,0,152,0,0,0,104,0,0,0,156,0,0,0,76,0,0,0,208,0,0,0,160,0,0,0,96,0,0,0,169,0,0,0,216,0,0,0,192,0,0,0,164,0,0,0,184,0,0,0,108,0,0,0,200,0,0,0,176,0,0,0,220,0,0,0,170,0,0,0,197,0,0,0,172,0,0,0,3,0,0,0,7,0,0,0,0,0,0,0,255,255,255,255,6,0,0,0,255,255,255,255,8,0,0,0,255,255,255,255,255,255,255,255,9,0,0,0,20,0,0,0,27,0,0,0,10,0,0,0,11,0,0,0,30,0,0,0,12,0,0,0,32,0,0,0,1,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,4,0,0,0,17,0,0,0,255,255,255,255,31,0,0,0,18,0,0,0,2,0,0,0,21,0,0,0,33,0,0,0,26,0,0,0,19,0,0,0,25,0,0,0,5,0,0,0,29,0,0,0,24,0,0,0,34,0,0,0,22,0,0,0,28,0,0,0,23,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,36,0,0,0,32,0,0,0,16,0,0,0,40,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,36,0,0,0,32,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,56,0,0,0,16,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,136,0,0,0,140,0,0,0,16,0,0,0,32,0,0,0,104,1,0,0,48,0,0,0,60,0,0,0,76,0,0,0,124,0,0,0,92,0,0,0,108,0,0,0,144,0,0,0,148,0,0,0,152,0,0,0,156,0,0,0,44,1,0,0,52,1,0,0,160,0,0,0,164,0,0,0,168,0,0,0,64,1,0,0,172,0,0,0,76,1,0,0,176,0,0,0,180,0,0,0,184,0,0,0,48,1,0,0,36,1,0,0,188,0,0,0,28,1,0,0,192,0,0,0,196,0,0,0,200,0,0,0,204,0,0,0,208,0,0,0,212,0,0,0,60,1,0,0,24,1,0,0,216,0,0,0,220,0,0,0,224,0,0,0,84,1,0,0,80,1,0,0,68,1,0,0,228,0,0,0,232,0,0,0,12,1,0,0,88,1,0,0,92,1,0,0,96,1,0,0,8,1,0,0,72,1,0,0,32,1,0,0,236,0,0,0,20,1,0,0,100,1,0,0,56,1,0,0,240,0,0,0,244,0,0,0,16,1,0,0,248,0,0,0,252,0,0,0,0,1,0,0,40,1,0,0,4,1,0,0,0,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,56,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,41,0,0,0,43,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,46,0,0,0,9,0,0,0,49,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,42,0,0,0,39,0,0,0,13,0,0,0,37,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,45,0,0,0,36,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,51,0,0,0,50,0,0,0,47,0,0,0,23,0,0,0,24,0,0,0,33,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,32,0,0,0,48,0,0,0,38,0,0,0,25,0,0,0,35,0,0,0,55,0,0,0,44,0,0,0,26,0,0,0,27,0,0,0,34,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,40,0,0,0,31,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,16,0,0,0,37,0,0,0,38,0,0,0,5,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,255,255,255,255,3,0,0,0,4,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,17,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,72,0,0,0,112,0,0,0,16,0,0,0,28,0,0,0,40,0,0,0,52,0,0,0,76,0,0,0,80,0,0,0,84,0,0,0,88,0,0,0,92,0,0,0,96,0,0,0,116,0,0,0,64,0,0,0,68,0,0,0,100,0,0,0,108,0,0,0,104,0,0,0,2,0,0,0,12,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,13,0,0,0,0,0,0,0,1,0,0,0,9,0,0,0,11,0,0,0,10,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,28,0,0,0,16,0,0,0,0,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,32,0,0,0,40,0,0,0,44,0,0,0,20,0,0,0,28,0,0,0,36,0,0,0,37,0,0,0,48,0,0,0,0,0,0,0,2,0,0,0,4,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,3,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,36,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,80,0,0,0,32,0,0,0,44,0,0,0,56,0,0,0,68,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,28,0,0,0,16,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,28,0,0,0,32,0,0,0,16,0,0,0,20,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,56,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,44,0,0,0,48,0,0,0,52,0,0,0,20,0,0,0,28,0,0,0,37,0,0,0,24,0,0,0,0,0,0,0,11,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,1,0,0,0,3,0,0,0,6,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,29,0,0,0,16,0,0,0,20,0,0,0,32,0,0,0,28,0,0,0,2,0,0,0,4,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,28,0,0,0,32,0,0,0,16,0,0,0,36,0,0,0,20,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,17,0,0,0,16,0,0,0,20,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,44,0,0,0,48,0,0,0,20,0,0,0,28,0,0,0,32,0,0,0,60,0,0,0,36,0,0,0,40,0,0,0,52,0,0,0,56,0,0,0,64,0,0,0,0,0,0,0,2,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,10,0,0,0,12,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,16,0,0,0,20,0,0,0,28,0,0,0,29,0,0,0,2,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,4,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,28,0,0,0,32,0,0,0,16,0,0,0,24,0,0,0,20,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,32,0,0,0,16,0,0,0,28,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,48,0,0,0,20,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,44,0,0,0,24,0,0,0,41,0,0,0,28,0,0,0,0,0,0,0,9,0,0,0,1,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,8,0,0,0,2,0,0,0,7,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,160,0,0,0,88,0,0,0,104,0,0,0,32,1,0,0,48,0,0,0,132,0,0,0,148,0,0,0,64,0,0,0,76,0,0,0,120,0,0,0,240,0,0,0,224,0,0,0,168,0,0,0,20,1,0,0,172,0,0,0,176,0,0,0,180,0,0,0,236,0,0,0,228,0,0,0,24,1,0,0,184,0,0,0,188,0,0,0,244,0,0,0,192,0,0,0,196,0,0,0,200,0,0,0,204,0,0,0,220,0,0,0,0,1,0,0,208,0,0,0,216,0,0,0,248,0,0,0,12,1,0,0,16,1,0,0,252,0,0,0,8,1,0,0,232,0,0,0,212,0,0,0,4,1,0,0,28,1,0,0,164,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,32,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,2,0,0,0,29,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,19,0,0,0,17,0,0,0,30,0,0,0,6,0,0,0,7,0,0,0,21,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,15,0,0,0,24,0,0,0,12,0,0,0,14,0,0,0,22,0,0,0,27,0,0,0,28,0,0,0,23,0,0,0,26,0,0,0,18,0,0,0,13,0,0,0,25,0,0,0,31,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,56,0,0,0,60,0,0,0,88,0,0,0,144,0,0,0,76,0,0,0,80,0,0,0,92,0,0,0,96,0,0,0,148,0,0,0,152,0,0,0,100,0,0,0,156,0,0,0,160,0,0,0,164,0,0,0,168,0,0,0,176,0,0,0,64,0,0,0,172,0,0,0,68,0,0,0,104,0,0,0,108,0,0,0,116,0,0,0,16,0,0,0,32,0,0,0,44,0,0,0,120,0,0,0,180,0,0,0,184,0,0,0,188,0,0,0,124,0,0,0,72,0,0,0,128,0,0,0,132,0,0,0,136,0,0,0,112,0,0,0,117,0,0,0,140,0,0,0,84,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,23,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,10,0,0,0,24,0,0,0,25,0,0,0,11,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,31,0,0,0,2,0,0,0,30,0,0,0,3,0,0,0,12,0,0,0,13,0,0,0,15,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,17,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,18,0,0,0,4,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,14,0,0,0,16,0,0,0,22,0,0,0,7,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,44,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,40,0,0,0,44,0,0,0,48,0,0,0,16,0,0,0,28,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,255,255,255,255,3,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,48,61,0,0,105,4,0,0,106,4,0,0,166,0,0,0,108,0,0,0,81,0,0,0,109,0,0,0,45,0,0,0,107,4,0,0,110,0,0,0,167,0,0,0,168,0,0,0,82,0,0,0,111,0,0,0,229,0,0,0,58,0,0,0,112,0,0,0,28,0,0,0,34,0,0,0,230,0,0,0,231,0,0,0,61,4,0,0,35,0,0,0,232,0,0,0,36,0,0,0,233,0,0,0,0,0,0,0,6,0,0,0,32,0,0,0,7,0,0,0,23,0,0,0,108,0,0,0,34,0,0,0,40,0,0,0,32,0,0,0,41,0,0,0,47,0,0,0,28,0,0,0,48,0,0,0,57,0,0,0,28,0,0,0,61,0,0,0,83,0,0,0,128,0,0,0,100,0,0,0,115,0,0,0,52,0,0,0,125,0,0,0,137,0,0,0,52,0,0,0,144,0,0,0,157,0,0,0,48,0,0,0,165,0,0,0,179,0,0,0,104,0,0,0,188,0,0,0,233,0,0,0,232,0,0,0,17,1,0,0,26,1,0,0,44,0,0,0,30,1,0,0,38,1,0,0,40,0,0,0,41,1,0,0,51,1,0,0,60,0,0,0,56,1,0,0,65,1,0,0,32,0,0,0,69,1,0,0,139,1,0,0,112,1,0,0,204,1,0,0,216,1,0,0,44,0,0,0,223,1,0,0,231,1,0,0,28,0,0,0,234,1,0,0,242,1,0,0,28,0,0,0,245,1,0,0,253,1,0,0,28,0,0,0,0,2,0,0,7,2,0,0,24,0,0,0,9,2,0,0,18,2,0,0,28,0,0,0,22,2,0,0,30,2,0,0,28,0,0,0,33,2,0,0,40,2,0,0,24,0,0,0,42,2,0,0,65,2,0,0,120,0,0,0,83,2,0,0,90,2,0,0,32,0,0,0,92,2,0,0,107,2,0,0,52,0,0,0,117,2,0,0,125,2,0,0,28,0,0,0,128,2,0,0,139,2,0,0,40,0,0,0,145,2,0,0,152,2,0,0,24,0,0,0,154,2,0,0,165,2,0,0,96,0,0,0,171,2,0,0,179,2,0,0,36,0,0,0,182,2,0,0,188,2,0,0,20,0,0,0,189,2,0,0,199,2,0,0,36,0,0,0,204,2,0,0,212,2,0,0,28,0,0,0,215,2,0,0,222,2,0,0,24,0,0,0,224,2,0,0,232,2,0,0,28,0,0,0,235,2,0,0,241,2,0,0,20,0,0,0,242,2,0,0,248,2,0,0,20,0,0,0,249,2,0,0,10,3,0,0,60,0,0,0,22,3,0,0,28,3,0,0,20,0,0,0,29,3,0,0,40,3,0,0,36,0,0,0,46,3,0,0,52,3,0,0,32,0,0,0,53,3,0,0,61,3,0,0,28,0,0,0,64,3,0,0,75,3,0,0,40,0,0,0,81,3,0,0,90,3,0,0,32,0,0,0,94,3,0,0,102,3,0,0,24,0,0,0,105,3,0,0,111,3,0,0,20,0,0,0,112,3,0,0,130,3,0,0,68,0,0,0,143,3,0,0,151,3,0,0,28,0,0,0,154,3,0,0,163,3,0,0,32,0,0,0,167,3,0,0,177,3,0,0,32,0,0,0,182,3,0,0,190,3,0,0,28,0,0,0,193,3,0,0,200,3,0,0,24,0,0,0,202,3,0,0,210,3,0,0,28,0,0,0,213,3,0,0,223,3,0,0,36,0,0,0,228,3,0,0,234,3,0,0,20,0,0,0,235,3,0,0,243,3,0,0,36,0,0,0,246,3,0,0,253,3,0,0,24,0,0,0,255,3,0,0,5,4,0,0,20,0,0,0,6,4,0,0,13,4,0,0,24,0,0,0,15,4,0,0,21,4,0,0,20,0,0,0,22,4,0,0,40,4,0,0,64,0,0,0,53,4,0,0,61,4,0,0,28,0,0,0,64,4,0,0,112,4,0,0,40,1,0,0,155,4,0,0,198,4,0,0,196,0,0,0,236,4,0,0,243,4,0,0,24,0,0,0,245,4,0,0,2,5,0,0,48,0,0,0,10,5,0,0,18,5,0,0,28,0,0,0,21,5,0,0,34,5,0,0,64,0,0,0,42,5,0,0,50,5,0,0,28,0,0,0,96,27,8,0,128,27,8,0,240,27,8,0,16,28,8,0,48,28,8,0,80,28,8,0,208,28,8,0,8,29,8,0,64,29,8,0,112,29,8,0,216,29,8,0,192,30,8,0,240,30,8,0,24,31,8,0,88,31,8,0,120,31,8,0,232,32,8,0,24,33,8,0,56,33,8,0,88,33,8,0,120,33,8,0,144,33,8,0,176,33,8,0,208,33,8,0,232,33,8,0,96,34,8,0,128,34,8,0,184,34,8,0,216,34,8,0,0,35,8,0,24,35,8,0,120,35,8,0,160,35,8,0,184,35,8,0,224,35,8,0,0,36,8,0,24,36,8,0,56,36,8,0,80,36,8,0,104,36,8,0,168,36,8,0,192,36,8,0,232,36,8,0,8,37,8,0,40,37,8,0,80,37,8,0,112,37,8,0,136,37,8,0,160,37,8,0,232,37,8,0,8,38,8,0,40,38,8,0,72,38,8,0,104,38,8,0,128,38,8,0,160,38,8,0,200,38,8,0,224,38,8,0,8,39,8,0,32,39,8,0,56,39,8,0,80,39,8,0,104,39,8,0,168,39,8,0,200,39,8,0,240,40,8,0,184,41,8,0,208,41,8,0,0,42,8,0,32,42,8,0,96,42,8,0,0,0,0,0,64,61,0,0,108,4,0,0,109,4,0,0,166,0,0,0,113,0,0,0,83,0,0,0,109,0,0,0,45,0,0,0,110,4,0,0,114,0,0,0,167,0,0,0,168,0,0,0,84,0,0,0,115,0,0,0,234,0,0,0,58,0,0,0,116,0,0,0,29,0,0,0,34,0,0,0,235,0,0,0,236,0,0,0,61,4,0,0,35,0,0,0,237,0,0,0,36,0,0,0,238,0,0,0,0,0,0,0,80,61,0,0,111,4,0,0,112,4,0,0,166,0,0,0,117,0,0,0,85,0,0,0,109,0,0,0,45,0,0,0,113,4,0,0,118,0,0,0,167,0,0,0,168,0,0,0,86,0,0,0,119,0,0,0,239,0,0,0,58,0,0,0,120,0,0,0,30,0,0,0,34,0,0,0,240,0,0,0,241,0,0,0,61,4,0,0,35,0,0,0,242,0,0,0,36,0,0,0,243,0,0,0,0,0,0,0,96,61,0,0,114,4,0,0,115,4,0,0,166,0,0,0,121,0,0,0,87,0,0,0,109,0,0,0,45,0,0,0,116,4,0,0,122,0,0,0,167,0,0,0,168,0,0,0,88,0,0,0,123,0,0,0,244,0,0,0,58,0,0,0,124,0,0,0,31,0,0,0,34,0,0,0,245,0,0,0,246,0,0,0,61,4,0,0,35,0,0,0,247,0,0,0,36,0,0,0,248,0,0,0,0,0,0,0,112,61,0,0,117,4,0,0,118,4,0,0,166,0,0,0,125,0,0,0,89,0,0,0,109,0,0,0,45,0,0,0,119,4,0,0,126,0,0,0,167,0,0,0,168,0,0,0,90,0,0,0,127,0,0,0,249,0,0,0,58,0,0,0,128,0,0,0,32,0,0,0,34,0,0,0,250,0,0,0,251,0,0,0,61,4,0,0,35,0,0,0,252,0,0,0,36,0,0,0,253,0,0,0,0,0,0,0,128,61,0,0,120,4,0,0,121,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+81924);allocate([166,0,0,0,129,0,0,0,91,0,0,0,109,0,0,0,45,0,0,0,122,4,0,0,130,0,0,0,167,0,0,0,168,0,0,0,92,0,0,0,131,0,0,0,254,0,0,0,58,0,0,0,132,0,0,0,33,0,0,0,34,0,0,0,255,0,0,0,0,1,0,0,61,4,0,0,35,0,0,0,1,1,0,0,36,0,0,0,2,1,0,0,0,0,0,0,144,61,0,0,123,4,0,0,124,4,0,0,166,0,0,0,133,0,0,0,93,0,0,0,109,0,0,0,45,0,0,0,125,4,0,0,134,0,0,0,167,0,0,0,168,0,0,0,94,0,0,0,135,0,0,0,3,1,0,0,58,0,0,0,136,0,0,0,34,0,0,0,34,0,0,0,4,1,0,0,5,1,0,0,61,4,0,0,35,0,0,0,6,1,0,0,36,0,0,0,7,1,0,0,0,0,0,0,160,61,0,0,126,4,0,0,127,4,0,0,166,0,0,0,137,0,0,0,95,0,0,0,109,0,0,0,45,0,0,0,128,4,0,0,138,0,0,0,167,0,0,0,168,0,0,0,96,0,0,0,139,0,0,0,8,1,0,0,58,0,0,0,140,0,0,0,35,0,0,0,34,0,0,0,9,1,0,0,10,1,0,0,61,4,0,0,35,0,0,0,11,1,0,0,36,0,0,0,12,1,0,0,0,0,0,0,176,61,0,0,129,4,0,0,130,4,0,0,166,0,0,0,141,0,0,0,97,0,0,0,109,0,0,0,45,0,0,0,131,4,0,0,142,0,0,0,167,0,0,0,168,0,0,0,98,0,0,0,143,0,0,0,13,1,0,0,58,0,0,0,144,0,0,0,36,0,0,0,34,0,0,0,14,1,0,0,15,1,0,0,61,4,0,0,35,0,0,0,16,1,0,0,36,0,0,0,17,1,0,0,0,0,0,0,192,61,0,0,132,4,0,0,133,4,0,0,166,0,0,0,145,0,0,0,99,0,0,0,109,0,0,0,45,0,0,0,134,4,0,0,146,0,0,0,167,0,0,0,168,0,0,0,100,0,0,0,147,0,0,0,18,1,0,0,58,0,0,0,148,0,0,0,37,0,0,0,34,0,0,0,19,1,0,0,20,1,0,0,61,4,0,0,35,0,0,0,21,1,0,0,36,0,0,0,22,1,0,0,0,0,0,0,208,61,0,0,135,4,0,0,136,4,0,0,166,0,0,0,149,0,0,0,101,0,0,0,109,0,0,0,45,0,0,0,137,4,0,0,150,0,0,0,167,0,0,0,168,0,0,0,102,0,0,0,151,0,0,0,23,1,0,0,58,0,0,0,152,0,0,0,38,0,0,0,34,0,0,0,24,1,0,0,25,1,0,0,61,4,0,0,35,0,0,0,26,1,0,0,36,0,0,0,27,1,0,0,0,0,0,0,224,61,0,0,138,4,0,0,139,4,0,0,166,0,0,0,153,0,0,0,103,0,0,0,109,0,0,0,45,0,0,0,140,4,0,0,154,0,0,0,167,0,0,0,168,0,0,0,104,0,0,0,155,0,0,0,28,1,0,0,58,0,0,0,156,0,0,0,39,0,0,0,34,0,0,0,29,1,0,0,30,1,0,0,61,4,0,0,35,0,0,0,31,1,0,0,36,0,0,0,32,1,0,0,0,0,0,0,240,61,0,0,141,4,0,0,142,4,0,0,166,0,0,0,157,0,0,0,105,0,0,0,109,0,0,0,45,0,0,0,143,4,0,0,158,0,0,0,167,0,0,0,168,0,0,0,106,0,0,0,159,0,0,0,33,1,0,0,58,0,0,0,160,0,0,0,40,0,0,0,34,0,0,0,34,1,0,0,35,1,0,0,61,4,0,0,35,0,0,0,36,1,0,0,36,0,0,0,37,1,0,0,0,0,0,0,0,62,0,0,144,4,0,0,145,4,0,0,166,0,0,0,161,0,0,0,107,0,0,0,109,0,0,0,45,0,0,0,146,4,0,0,162,0,0,0,167,0,0,0,168,0,0,0,108,0,0,0,163,0,0,0,38,1,0,0,58,0,0,0,164,0,0,0,41,0,0,0,34,0,0,0,39,1,0,0,40,1,0,0,61,4,0,0,35,0,0,0,41,1,0,0,36,0,0,0,42,1,0,0,0,0,0,0,16,62,0,0,147,4,0,0,148,4,0,0,166,0,0,0,165,0,0,0,109,0,0,0,109,0,0,0,45,0,0,0,149,4,0,0,166,0,0,0,167,0,0,0,168,0,0,0,110,0,0,0,167,0,0,0,43,1,0,0,58,0,0,0,168,0,0,0,42,0,0,0,34,0,0,0,44,1,0,0,45,1,0,0,61,4,0,0,35,0,0,0,46,1,0,0,36,0,0,0,47,1,0,0,0,0,0,0,32,62,0,0,150,4,0,0,151,4,0,0,166,0,0,0,169,0,0,0,111,0,0,0,109,0,0,0,45,0,0,0,152,4,0,0,170,0,0,0,167,0,0,0,168,0,0,0,112,0,0,0,171,0,0,0,48,1,0,0,58,0,0,0,172,0,0,0,43,0,0,0,34,0,0,0,49,1,0,0,50,1,0,0,61,4,0,0,35,0,0,0,51,1,0,0,36,0,0,0,52,1,0,0,0,0,0,0,48,62,0,0,153,4,0,0,154,4,0,0,166,0,0,0,173,0,0,0,113,0,0,0,109,0,0,0,45,0,0,0,155,4,0,0,174,0,0,0,167,0,0,0,168,0,0,0,114,0,0,0,175,0,0,0,53,1,0,0,58,0,0,0,176,0,0,0,44,0,0,0,34,0,0,0,54,1,0,0,55,1,0,0,61,4,0,0,35,0,0,0,56,1,0,0,36,0,0,0,57,1,0,0,0,0,0,0,64,62,0,0,156,4,0,0,157,4,0,0,166,0,0,0,177,0,0,0,115,0,0,0,109,0,0,0,45,0,0,0,158,4,0,0,178,0,0,0,167,0,0,0,168,0,0,0,116,0,0,0,179,0,0,0,58,1,0,0,58,0,0,0,180,0,0,0,45,0,0,0,34,0,0,0,59,1,0,0,60,1,0,0,61,4,0,0,35,0,0,0,61,1,0,0,36,0,0,0,62,1,0,0,0,0,0,0,80,62,0,0,159,4,0,0,160,4,0,0,166,0,0,0,181,0,0,0,117,0,0,0,109,0,0,0,45,0,0,0,161,4,0,0,182,0,0,0,167,0,0,0,168,0,0,0,118,0,0,0,183,0,0,0,63,1,0,0,58,0,0,0,184,0,0,0,46,0,0,0,34,0,0,0,64,1,0,0,65,1,0,0,61,4,0,0,35,0,0,0,66,1,0,0,36,0,0,0,67,1,0,0,0,0,0,0,96,62,0,0,162,4,0,0,163,4,0,0,166,0,0,0,185,0,0,0,119,0,0,0,109,0,0,0,45,0,0,0,164,4,0,0,186,0,0,0,167,0,0,0,168,0,0,0,120,0,0,0,187,0,0,0,68,1,0,0,58,0,0,0,188,0,0,0,47,0,0,0,34,0,0,0,69,1,0,0,70,1,0,0,61,4,0,0,35,0,0,0,71,1,0,0,36,0,0,0,72,1,0,0,0,0,0,0,112,62,0,0,165,4,0,0,166,4,0,0,166,0,0,0,189,0,0,0,121,0,0,0,109,0,0,0,45,0,0,0,167,4,0,0,190,0,0,0,167,0,0,0,168,0,0,0,122,0,0,0,191,0,0,0,73,1,0,0,58,0,0,0,192,0,0,0,48,0,0,0,34,0,0,0,74,1,0,0,75,1,0,0,61,4,0,0,35,0,0,0,76,1,0,0,36,0,0,0,77,1,0,0,0,0,0,0,128,62,0,0,168,4,0,0,169,4,0,0,166,0,0,0,193,0,0,0,123,0,0,0,109,0,0,0,45,0,0,0,170,4,0,0,194,0,0,0,167,0,0,0,168,0,0,0,124,0,0,0,195,0,0,0,78,1,0,0,58,0,0,0,196,0,0,0,49,0,0,0,34,0,0,0,79,1,0,0,80,1,0,0,61,4,0,0,35,0,0,0,81,1,0,0,36,0,0,0,82,1,0,0,0,0,0,0,144,62,0,0,171,4,0,0,172,4,0,0,166,0,0,0,197,0,0,0,125,0,0,0,109,0,0,0,45,0,0,0,173,4,0,0,198,0,0,0,167,0,0,0,168,0,0,0,126,0,0,0,199,0,0,0,83,1,0,0,58,0,0,0,200,0,0,0,50,0,0,0,34,0,0,0,84,1,0,0,85,1,0,0,61,4,0,0,35,0,0,0,86,1,0,0,36,0,0,0,87,1,0,0,0,0,0,0,160,62,0,0,174,4,0,0,175,4,0,0,166,0,0,0,201,0,0,0,127,0,0,0,109,0,0,0,45,0,0,0,176,4,0,0,202,0,0,0,167,0,0,0,168,0,0,0,128,0,0,0,203,0,0,0,88,1,0,0,58,0,0,0,204,0,0,0,51,0,0,0,34,0,0,0,89,1,0,0,90,1,0,0,61,4,0,0,35,0,0,0,91,1,0,0,36,0,0,0,92,1,0,0,0,0,0,0,176,62,0,0,177,4,0,0,178,4,0,0,166,0,0,0,205,0,0,0,129,0,0,0,109,0,0,0,45,0,0,0,179,4,0,0,206,0,0,0,167,0,0,0,168,0,0,0,130,0,0,0,207,0,0,0,93,1,0,0,58,0,0,0,208,0,0,0,52,0,0,0,34,0,0,0,94,1,0,0,95,1,0,0,61,4,0,0,35,0,0,0,96,1,0,0,36,0,0,0,97,1,0,0,0,0,0,0,192,62,0,0,180,4,0,0,181,4,0,0,166,0,0,0,209,0,0,0,131,0,0,0,109,0,0,0,45,0,0,0,182,4,0,0,210,0,0,0,167,0,0,0,168,0,0,0,132,0,0,0,211,0,0,0,98,1,0,0,58,0,0,0,212,0,0,0,53,0,0,0,34,0,0,0,99,1,0,0,100,1,0,0,61,4,0,0,35,0,0,0,101,1,0,0,36,0,0,0,102,1,0,0,0,0,0,0,208,62,0,0,183,4,0,0,184,4,0,0,166,0,0,0,213,0,0,0,133,0,0,0,109,0,0,0,45,0,0,0,185,4,0,0,214,0,0,0,167,0,0,0,168,0,0,0,134,0,0,0,215,0,0,0,103,1,0,0,58,0,0,0,216,0,0,0,54,0,0,0,34,0,0,0,104,1,0,0,105,1,0,0,61,4,0,0,35,0,0,0,106,1,0,0,36,0,0,0,107,1,0,0,0,0,0,0,224,62,0,0,186,4,0,0,187,4,0,0,166,0,0,0,217,0,0,0,135,0,0,0,109,0,0,0,45,0,0,0,188,4,0,0,218,0,0,0,167,0,0,0,168,0,0,0,136,0,0,0,219,0,0,0,108,1,0,0,58,0,0,0,220,0,0,0,55,0,0,0,34,0,0,0,109,1,0,0,110,1,0,0,61,4,0,0,35,0,0,0,111,1,0,0,36,0,0,0,112,1,0,0,0,0,0,0,240,62,0,0,189,4,0,0,190,4,0,0,166,0,0,0,221,0,0,0,137,0,0,0,109,0,0,0,45,0,0,0,191,4,0,0,222,0,0,0,167,0,0,0,168,0,0,0,138,0,0,0,223,0,0,0,113,1,0,0,58,0,0,0,224,0,0,0,56,0,0,0,34,0,0,0,114,1,0,0,115,1,0,0,61,4,0,0,35,0,0,0,116,1,0,0,36,0,0,0,117,1,0,0,0,0,0,0,0,63,0,0,192,4,0,0,193,4,0,0,166,0,0,0,225,0,0,0,139,0,0,0,109,0,0,0,45,0,0,0,194,4,0,0,226,0,0,0,167,0,0,0,168,0,0,0,140,0,0,0,227,0,0,0,118,1,0,0,58,0,0,0,228,0,0,0,57,0,0,0,34,0,0,0,119,1,0,0,120,1,0,0,61,4,0,0,35,0,0,0,121,1,0,0,36,0,0,0,122,1,0,0,0,0,0,0,16,63,0,0,195,4,0,0,196,4,0,0,166,0,0,0,229,0,0,0,141,0,0,0,109,0,0,0,45,0,0,0,197,4,0,0,230,0,0,0,167,0,0,0,168,0,0,0,142,0,0,0,231,0,0,0,123,1,0,0,58,0,0,0,232,0,0,0,58,0,0,0,34,0,0,0,124,1,0,0,125,1,0,0,61,4,0,0,35,0,0,0,126,1,0,0,36,0,0,0,127,1,0,0,0,0,0,0,32,63,0,0,198,4,0,0,199,4,0,0,166,0,0,0,233,0,0,0,143,0,0,0,109,0,0,0,45,0,0,0,200,4,0,0,234,0,0,0,167,0,0,0,168,0,0,0,144,0,0,0,235,0,0,0,128,1,0,0,58,0,0,0,236,0,0,0,59,0,0,0,34,0,0,0,129,1,0,0,130,1,0,0,61,4,0,0,35,0,0,0,131,1,0,0,36,0,0,0,132,1,0,0,0,0,0,0,48,63,0,0,201,4,0,0,202,4,0,0,166,0,0,0,237,0,0,0,145,0,0,0,109,0,0,0,45,0,0,0,203,4,0,0,238,0,0,0,167,0,0,0,168,0,0,0,146,0,0,0,239,0,0,0,133,1,0,0,58,0,0,0,240,0,0,0,60,0,0,0,34,0,0,0,134,1,0,0,135,1,0,0,61,4,0,0,35,0,0,0,136,1,0,0,36,0,0,0,137,1,0,0,0,0,0,0,64,63,0,0,204,4,0,0,205,4,0,0,166,0,0,0,241,0,0,0,147,0,0,0,109,0,0,0,45,0,0,0,206,4,0,0,242,0,0,0,167,0,0,0,168,0,0,0,148,0,0,0,243,0,0,0,138,1,0,0,58,0,0,0,244,0,0,0,61,0,0,0,34,0,0,0,139,1,0,0,140,1,0,0,61,4,0,0,35,0,0,0,141,1,0,0,36,0,0,0,142,1,0,0,0,0,0,0,80,63,0,0,207,4,0,0,208,4,0,0,166,0,0,0,245,0,0,0,149,0,0,0,109,0,0,0,45,0,0,0,209,4,0,0,246,0,0,0,167,0,0,0,168,0,0,0,150,0,0,0,247,0,0,0,143,1,0,0,58,0,0,0,248,0,0,0,62,0,0,0,34,0,0,0,144,1,0,0,145,1,0,0,61,4,0,0,35,0,0,0,146,1,0,0,36,0,0,0,147,1,0,0,0,0,0,0,96,63,0,0,210,4,0,0,211,4,0,0,166,0,0,0,249,0,0,0,151,0,0,0,109,0,0,0,45,0,0,0,212,4,0,0,250,0,0,0,167,0,0,0,168,0,0,0,152,0,0,0,251,0,0,0,148,1,0,0,58,0,0,0,252,0,0,0,63,0,0,0,34,0,0,0,149,1,0,0,150,1,0,0,61,4,0,0,35,0,0,0,151,1,0,0,36,0,0,0,152,1,0,0,0,0,0,0,112,63,0,0,213,4,0,0,214,4,0,0,166,0,0,0,253,0,0,0,153,0,0,0,109,0,0,0,45,0,0,0,215,4,0,0,254,0,0,0,167,0,0,0,168,0,0,0,154,0,0,0,255,0,0,0,153,1,0,0,58,0,0,0,0,1,0,0,64,0,0,0,34,0,0,0,154,1,0,0,155,1,0,0,61,4,0,0,35,0,0,0,156,1,0,0,36,0,0,0,157,1,0,0,0,0,0,0,128,63,0,0,216,4,0,0,217,4,0,0,166,0,0,0,1,1,0,0,155,0,0,0,109,0,0,0,45,0,0,0,218,4,0,0,2,1,0,0,167,0,0,0,168,0,0,0,156,0,0,0,3,1,0,0,158,1,0,0,58,0,0,0,4,1,0,0,65,0,0,0,34,0,0,0,159,1,0,0,160,1,0,0,61,4,0,0,35,0,0,0,161,1,0,0,36,0,0,0,162,1,0,0,0,0,0,0,144,63,0,0,219,4,0,0,220,4,0,0,166,0,0,0,5,1,0,0,157,0,0,0,109,0,0,0,45,0,0,0,221,4,0,0,6,1,0,0,167,0,0,0,168,0,0,0,158,0,0,0,7,1,0,0,163,1,0,0,58,0,0,0,8,1,0,0,66,0,0,0,34,0,0,0,164,1,0,0,165,1,0,0,61,4,0,0,35,0,0,0,166,1,0,0,36,0,0,0,167,1,0,0,0,0,0,0,160,63,0,0,222,4,0,0,223,4,0,0,166,0,0,0,9,1,0,0,159,0,0,0,109,0,0,0,45,0,0,0,224,4,0,0,10,1,0,0,167,0,0,0,168,0,0,0,160,0,0,0,11,1,0,0,168,1,0,0,58,0,0,0,12,1,0,0,67,0,0,0,34,0,0,0,169,1,0,0,170,1,0,0,61,4,0,0,35,0,0,0,171,1,0,0,36,0,0,0,172,1,0,0,0,0,0,0,176,63,0,0,225,4,0,0,226,4,0,0,166,0,0,0,13,1,0,0,161,0,0,0,109,0,0,0,45,0,0,0,227,4,0,0,14,1,0,0,167,0,0,0,168,0,0,0,162,0,0,0,15,1,0,0,173,1,0,0,58,0,0,0,16,1,0,0,68,0,0,0,34,0,0,0,174,1,0,0,175,1,0,0,61,4,0,0,35,0,0,0,176,1,0,0,36,0,0,0,177,1,0,0,0,0,0,0,192,63,0,0,228,4,0,0,229,4,0,0,166,0,0,0,17,1,0,0,163,0,0,0,109,0,0,0,45,0,0,0,230,4,0,0,18,1,0,0,167,0,0,0,168,0,0,0,164,0,0,0,19,1,0,0,178,1,0,0,58,0,0,0,20,1,0,0,69,0,0,0,34,0,0,0,179,1,0,0,180,1,0,0,61,4,0,0,35,0,0,0,181,1,0,0,36,0,0,0,182,1,0,0,0,0,0,0,208,63,0,0,231,4,0,0,232,4,0,0,166,0,0,0,21,1,0,0,165,0,0,0,109,0,0,0,45,0,0,0,233,4,0,0,22,1,0,0,167,0,0,0,168,0,0,0,166,0,0,0,23,1,0,0,183,1,0,0,58,0,0,0,24,1,0,0,70,0,0,0,34,0,0,0,184,1,0,0,185,1,0,0,61,4,0,0,35,0,0,0,186,1,0,0,36,0,0,0,187,1,0,0,0,0,0,0,224,63,0,0,234,4,0,0,235,4,0,0,166,0,0,0,25,1,0,0,167,0,0,0,109,0,0,0,45,0,0,0,236,4,0,0,26,1,0,0,167,0,0,0,168,0,0,0,168,0,0,0,27,1,0,0,188,1,0,0,58,0,0,0,28,1,0,0,71,0,0,0,34,0,0,0,189,1,0,0,190,1,0,0,61,4,0,0,35,0,0,0,191,1,0,0,36,0,0,0,192,1,0,0,0,0,0,0,240,63,0,0,237,4,0,0,238,4,0,0,166,0,0,0,29,1,0,0,169,0,0,0,109,0,0,0,45,0,0,0,239,4,0,0,30,1,0,0,167,0,0,0,168,0,0,0,170,0,0,0,31,1,0,0,193,1,0,0,58,0,0,0,32,1,0,0,72,0,0,0,34,0,0,0,194,1,0,0,195,1,0,0,61,4,0,0,35,0,0,0,196,1,0,0,36,0,0,0,197,1,0,0,0,0,0,0,0,64,0,0,240,4,0,0,241,4,0,0,166,0,0,0,33,1,0,0,171,0,0,0,109,0,0,0,45,0,0,0,242,4,0,0,34,1,0,0,167,0,0,0,168,0,0,0,172,0,0,0,35,1,0,0,198,1,0,0,58,0,0,0,36,1,0,0,73,0,0,0,34,0,0,0,199,1,0,0,200,1,0,0,61,4,0,0,35,0,0,0,201,1,0,0,36,0,0,0,202,1,0,0,0,0,0,0,16,64,0,0,243,4,0,0,244,4,0,0,166,0,0,0,37,1,0,0,173,0,0,0,109,0,0,0,45,0,0,0,245,4,0,0,38,1,0,0,167,0,0,0,168,0,0,0,174,0,0,0,39,1,0,0,203,1,0,0,58,0,0,0,40,1,0,0,74,0,0,0,34,0,0,0,204,1,0,0,205,1,0,0,61,4,0,0,35,0,0,0,206,1,0,0,36,0,0,0,207,1,0,0,0,0,0,0,32,64,0,0,246,4,0,0,247,4,0,0,166,0,0,0,41,1,0,0,175,0,0,0,109,0,0,0,45,0,0,0,248,4,0,0,42,1,0,0,167,0,0,0,168,0,0,0,176,0,0,0,43,1,0,0,208,1,0,0,58,0,0,0,44,1,0,0,75,0,0,0,34,0,0,0,209,1,0,0,210,1,0,0,61,4,0,0,35,0,0,0,211,1,0,0,36,0,0,0,212,1,0,0,0,0,0,0,48,64,0,0,249,4,0,0,250,4,0,0,166,0,0,0,45,1,0,0,177,0,0,0,109,0,0,0,45,0,0,0,251,4,0,0,46,1,0,0,167,0,0,0,168,0,0,0,178,0,0,0,47,1,0,0,213,1,0,0,58,0,0,0,48,1,0,0,76,0,0,0,34,0,0,0,214,1,0,0,215,1,0,0,61,4,0,0,35,0,0,0,216,1,0,0,36,0,0,0,217,1,0,0,0,0,0,0,64,64,0,0,252,4,0,0,253,4,0,0,166,0,0,0,49,1,0,0,179,0,0,0,109,0,0,0,45,0,0,0,254,4,0,0,50,1,0,0,167,0,0,0,168,0,0,0,180,0,0,0,51,1,0,0,218,1,0,0,58,0,0,0,52,1,0,0,77,0,0,0,34,0,0,0,219,1,0,0,220,1,0,0,61,4,0,0,35,0,0,0,221,1,0,0,36,0,0,0,222,1,0,0,0,0,0,0,80,64,0,0,255,4,0,0,0,5,0,0,166,0,0,0,53,1,0,0,181,0,0,0,109,0,0,0,45,0,0,0,1,5,0,0,54,1,0,0,167,0,0,0,168,0,0,0,182,0,0,0,55,1,0,0,223,1,0,0,58,0,0,0,56,1,0,0,78,0,0,0,34,0,0,0,224,1,0,0,225,1,0,0,61,4,0,0,35,0,0,0,226,1,0,0,36,0,0,0,227,1,0,0,0,0,0,0,96,64,0,0,2,5,0,0,3,5,0,0,166,0,0,0,57,1,0,0,183,0,0,0,109,0,0,0,45,0,0,0,4,5,0,0,58,1,0,0,167,0,0,0,168,0,0,0,184,0,0,0,59,1,0,0,228,1,0,0,58,0,0,0,60,1,0,0,79,0,0,0,34,0,0,0,229,1,0,0,230,1,0,0,61,4,0,0,35,0,0,0,231,1,0,0,36,0,0,0,232,1,0,0,0,0,0,0,112,64,0,0,5,5,0,0,6,5,0,0,166,0,0,0,61,1,0,0,185,0,0,0,109,0,0,0,45,0,0,0,7,5,0,0,62,1,0,0,167,0,0,0,168,0,0,0,186,0,0,0,63,1,0,0,233,1,0,0,58,0,0,0,64,1,0,0,80,0,0,0,34,0,0,0,234,1,0,0,235,1,0,0,61,4,0,0,35,0,0,0,236,1,0,0,36,0,0,0,237,1,0,0,0,0,0,0,128,64,0,0,8,5,0,0,9,5,0,0,166,0,0,0,65,1,0,0,187,0,0,0,109,0,0,0,45,0,0,0,10,5,0,0,66,1,0,0,167,0,0,0,168,0,0,0,188,0,0,0,67,1,0,0,238,1,0,0,58,0,0,0,68,1,0,0,81,0,0,0,34,0,0,0,239,1,0,0,240,1,0,0,61,4,0,0,35,0,0,0,241,1,0,0,36,0,0,0,242,1,0,0,0,0,0,0,144,64,0,0,11,5,0,0,12,5,0,0,166,0,0,0,69,1,0,0,189,0,0,0,109,0,0,0,45,0,0,0,13,5,0,0,70,1,0,0,167,0,0,0,168,0,0,0,190,0,0,0,71,1,0,0,243,1,0,0,58,0,0,0,72,1,0,0,82,0,0,0,34,0,0,0,244,1,0,0,245,1,0,0,61,4,0,0,35,0,0,0,246,1,0,0,36,0,0,0,247,1,0,0,0,0,0,0,160,64,0,0,14,5,0,0,15,5,0,0,166,0,0,0,73,1,0,0,191,0,0,0,109,0,0,0,45,0,0,0,16,5,0,0,74,1,0,0,167,0,0,0,168,0,0,0,192,0,0,0,75,1,0,0,248,1,0,0,58,0,0,0,76,1,0,0,83,0,0,0,34,0,0,0,249,1,0,0,250,1,0,0,61,4,0,0,35,0,0,0,251,1,0,0,36,0,0,0,252,1,0,0,0,0,0,0,176,64,0,0,17,5,0,0,18,5,0,0,166,0,0,0,77,1,0,0,193,0,0,0,109,0,0,0,45,0,0,0,19,5,0,0,78,1,0,0,167,0,0,0,168,0,0,0,194,0,0,0,79,1,0,0,253,1,0,0,58,0,0,0,80,1,0,0,84,0,0,0,34,0,0,0,254,1,0,0,255,1,0,0,61,4,0,0,35,0,0,0,0,2,0,0,36,0,0,0,1,2,0,0,0,0,0,0,192,64,0,0,20,5,0,0,21,5,0,0,166,0,0,0,81,1,0,0,195,0,0,0,109,0,0,0,45,0,0,0,22,5,0,0,82,1,0,0,167,0,0,0,168,0,0,0,196,0,0,0,83,1,0,0,2,2,0,0,58,0,0,0,84,1,0,0,85,0,0,0,34,0,0,0,3,2,0,0,4,2,0,0,61,4,0,0,35,0,0,0,5,2,0,0,36,0,0,0,6,2,0,0,0,0,0,0,208,64,0,0,23,5,0,0,24,5,0,0,166,0,0,0,85,1,0,0,197,0,0,0,109,0,0,0,45,0,0,0,25,5,0,0,86,1,0,0,167,0,0,0,168,0,0,0,198,0,0,0,87,1,0,0,7,2,0,0,58,0,0,0,88,1,0,0,86,0,0,0,34,0,0,0,8,2,0,0,9,2,0,0,61,4,0,0,35,0,0,0,10,2,0,0,36,0,0,0,11,2,0,0,0,0,0,0,224,64,0,0,26,5,0,0,27,5,0,0,166,0,0,0,89,1,0,0,199,0,0,0,109,0,0,0,45,0,0,0,28,5,0,0,90,1,0,0,167,0,0,0,168,0,0,0,200,0,0,0,91,1,0,0,12,2,0,0,58,0,0,0,92,1,0,0,87,0,0,0,34,0,0,0,13,2,0,0,14,2,0,0,61,4,0,0,35,0,0,0,15,2,0,0,36,0,0,0,16,2,0,0,0,0,0,0,240,64,0,0,29,5,0,0,30,5,0,0,166,0,0,0,93,1,0,0,201,0,0,0,109,0,0,0,45,0,0,0,31,5,0,0,94,1,0,0,167,0,0,0,168,0,0,0,202,0,0,0,95,1,0,0,17,2,0,0,58,0,0,0,96,1,0,0,88,0,0,0,34,0,0,0,18,2,0,0,19,2,0,0,61,4,0,0,35,0,0,0,20,2,0,0,36,0,0,0,21,2,0,0,0,0,0,0,0,65,0,0,32,5,0,0,33,5,0,0,166,0,0,0,97,1,0,0,203,0,0,0,109,0,0,0,45,0,0,0,34,5,0,0,98,1,0,0,167,0,0,0,168,0,0,0,204,0,0,0,99,1,0,0,22,2,0,0,58,0,0,0,100,1,0,0,89,0,0,0,34,0,0,0,23,2,0,0,24,2,0,0,61,4,0,0,35,0,0,0,25,2,0,0,36,0,0,0,26,2,0,0,0,0,0,0,16,65,0,0,35,5,0,0,36,5,0,0,166,0,0,0,101,1,0,0,205,0,0,0,109,0,0,0,45,0,0,0,37,5,0,0,102,1,0,0,167,0,0,0,168,0,0,0,206,0,0,0,103,1,0,0,27,2,0,0,58,0,0,0,104,1,0,0,90,0,0,0,34,0,0,0,28,2,0,0,29,2,0,0,61,4,0,0,35,0,0,0,30,2,0,0,36,0,0,0,31,2,0,0,0,0,0,0,32,65,0,0,38,5,0,0,39,5,0,0,166,0,0,0,105,1,0,0,207,0,0,0,109,0,0,0,45,0,0,0,40,5,0,0,106,1,0,0,167,0,0,0,168,0,0,0,208,0,0,0,107,1,0,0,32,2,0,0,58,0,0,0,108,1,0,0,91,0,0,0,34,0,0,0,33,2,0,0,34,2,0,0,61,4,0,0,35,0,0,0,35,2,0,0,36,0,0,0,36,2,0,0,0,0,0,0,48,65,0,0,41,5,0,0,42,5,0,0,166,0,0,0,109,1,0,0,209,0,0,0,109,0,0,0,45,0,0,0,43,5,0,0,110,1,0,0,167,0,0,0,168,0,0,0,210,0,0,0,111,1,0,0,37,2,0,0,58,0,0,0,112,1,0,0,92,0,0,0,34,0,0,0,38,2,0,0,39,2,0,0,61,4,0,0,35,0,0,0,40,2,0,0,36,0,0,0,41,2,0,0,0,0,0,0,64,65,0,0,44,5,0,0,45,5,0,0,166,0,0,0,113,1,0,0,211,0,0,0,109,0,0,0,45,0,0,0,46,5,0,0,114,1,0,0,167,0,0,0,168,0,0,0,212,0,0,0,115,1,0,0,42,2,0,0,58,0,0,0,116,1,0,0,93,0,0,0,34,0,0,0,43,2,0,0,44,2,0,0,61,4,0,0,35,0,0,0,45,2,0,0,36,0,0,0,46,2,0,0,0,0,0,0,80,65,0,0,47,5,0,0,48,5,0,0,166,0,0,0,117,1,0,0,213,0,0,0,109,0,0,0,45,0,0,0,49,5,0,0,118,1,0,0,167,0,0,0,168,0,0,0,214,0,0,0,119,1,0,0,47,2,0,0,58,0,0,0,120,1,0,0,94,0,0,0,34,0,0,0,48,2,0,0,49,2,0,0,61,4,0,0,35,0,0,0,50,2,0,0,36,0,0,0,51,2,0,0,0,0,0,0,96,65,0,0,50,5,0,0,51,5,0,0,166,0,0,0,121,1,0,0,215,0,0,0,109,0,0,0,45,0,0,0,52,5,0,0,122,1,0,0,167,0,0,0,168,0,0,0,216,0,0,0,123,1,0,0,52,2,0,0,58,0,0,0,124,1,0,0,95,0,0,0,34,0,0,0,53,2,0,0,54,2,0,0,61,4,0,0,35,0,0,0,55,2,0,0,36,0,0,0,56,2,0,0,0,0,0,0,112,65,0,0,53,5,0,0,54,5,0,0,166,0,0,0,125,1,0,0,217,0,0,0,109,0,0,0,45,0,0,0,55,5,0,0,126,1,0,0,167,0,0,0,168,0,0,0,218,0,0,0,127,1,0,0,57,2,0,0,58,0,0,0,128,1,0,0,96,0,0,0,34,0,0,0,58,2,0,0,59,2,0,0,61,4,0,0,35,0,0,0,60,2,0,0,36,0,0,0,61,2,0,0,0,0,0,0,128,65,0,0,56,5,0,0,57,5,0,0,166,0,0,0,129,1,0,0,219,0,0,0,109,0,0,0,45,0,0,0,58,5,0,0,130,1,0,0,167,0,0,0,168,0,0,0,220,0,0,0,131,1,0,0,62,2,0,0,58,0,0,0,132,1,0,0,97,0,0,0,34,0,0,0,63,2,0,0,64,2,0,0,61,4,0,0,35,0,0,0,65,2,0,0,36,0,0,0,66,2,0,0,0,0,0,0,144,65,0,0,59,5,0,0,60,5,0,0,166,0,0,0,133,1,0,0,221,0,0,0,109,0,0,0,45,0,0,0,61,5,0,0,134,1,0,0,167,0,0,0,168,0,0,0,222,0,0,0,135,1,0,0,67,2,0,0,58,0,0,0,136,1,0,0,98,0,0,0,34,0,0,0,68,2,0,0,69,2,0,0,61,4,0,0,35,0,0,0,70,2,0,0,36,0,0,0,71,2,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,88,0,0,0,100,0,0,0,96,0,0,0,124,0,0,0,120,0,0,0,112,0,0,0,92,0,0,0,104,0,0,0,108,0,0,0,16,0,0,0,28,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,8,0,0,0,7,0,0,0,6,0,0,0,1,0,0,0,4,0,0,0,5,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,64,0,0,0,68,0,0,0,76,0,0,0,48,0,0,0,72,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,1,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,72,0,0,0,16,0,0,0,48,0,0,0,52,0,0,0,56,0,0,0,80,0,0,0,60,0,0,0,64,0,0,0,32,0,0,0,5,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,6,0,0,0,3,0,0,0,4,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,96,0,0,0,32,0,0,0,100,0,0,0,48,0,0,0,64,0,0,0,80,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,140,0,0,0,136,0,0,0,28,0,0,0,44,0,0,0,60,0,0,0,76,0,0,0,124,0,0,0,132,0,0,0,128,0,0,0,92,0,0,0,108,0,0,0,255,255,255,255,4,0,0,0,3,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,2,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,32,0,0,0,255,255,255,255,40,0,0,0,48,0,0,0,16,0,0,0,24,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,24,0,0,0,255,255,255,255,32,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,160,65,0,0,62,5,0,0,63,5,0,0,166,0,0,0,137,1,0,0,223,0,0,0,109,0,0,0,45,0,0,0,64,5,0,0,138,1,0,0,167,0,0,0,168,0,0,0,224,0,0,0,139,1,0,0,72,2,0,0,58,0,0,0,140,1,0,0,99,0,0,0,34,0,0,0,73,2,0,0,74,2,0,0,61,4,0,0,35,0,0,0,75,2,0,0,36,0,0,0,76,2,0,0,0,0,0,0,19,0,0,0,128,0,0,0,33,0,0,0,41,0,0,0,28,0,0,0,44,0,0,0,56,0,0,0,80,0,0,0,63,0,0,0,77,0,0,0,88,0,0,0,86,0,0,0,93,0,0,0,24,0,0,0,95,0,0,0,107,0,0,0,104,0,0,0,114,0,0,0,121,0,0,0,32,0,0,0,123,0,0,0,140,0,0,0,144,0,0,0,152,0,0,0,161,0,0,0,40,0,0,0,164,0,0,0,170,0,0,0,32,0,0,0,171,0,0,0,178,0,0,0,24,0,0,0,180,0,0,0,188,0,0,0,28,0,0,0,190,0,0,0,197,0,0,0,32,0,0,0,8,45,8,0,136,45,8,0,168,45,8,0,248,45,8,0,80,46,8,0,104,46,8,0,208,46,8,0,240,46,8,0,128,47,8,0,184,47,8,0,216,47,8,0,240,47,8,0,24,48,8,0,0,0,0,0,176,65,0,0,65,5,0,0,66,5,0,0,166,0,0,0,141,1,0,0,225,0,0,0,109,0,0,0,45,0,0,0,67,5,0,0,142,1,0,0,167,0,0,0,168,0,0,0,226,0,0,0,143,1,0,0,77,2,0,0,58,0,0,0,144,1,0,0,100,0,0,0,34,0,0,0,78,2,0,0,79,2,0,0,61,4,0,0,35,0,0,0,80,2,0,0,36,0,0,0,81,2,0,0,0,0,0,0,192,65,0,0,68,5,0,0,69,5,0,0,166,0,0,0,145,1,0,0,227,0,0,0,109,0,0,0,45,0,0,0,70,5,0,0,146,1,0,0,167,0,0,0,168,0,0,0,228,0,0,0,147,1,0,0,82,2,0,0,58,0,0,0,148,1,0,0,101,0,0,0,34,0,0,0,83,2,0,0,84,2,0,0,61,4,0,0,35,0,0,0,85,2,0,0,36,0,0,0,86,2,0,0,0,0,0,0,208,65,0,0,71,5,0,0,72,5,0,0,166,0,0,0,149,1,0,0,229,0,0,0,109,0,0,0,45,0,0,0,73,5,0,0,150,1,0,0,167,0,0,0,168,0,0,0,230,0,0,0,151,1,0,0,87,2,0,0,58,0,0,0,152,1,0,0,102,0,0,0,34,0,0,0,88,2,0,0,89,2,0,0,61,4,0,0,35,0,0,0,90,2,0,0,36,0,0,0,91,2,0,0,0,0,0,0,224,65,0,0,74,5,0,0,75,5,0,0,166,0,0,0,153,1,0,0,231,0,0,0,109,0,0,0,45,0,0,0,76,5,0,0,154,1,0,0,167,0,0,0,168,0,0,0,232,0,0,0,155,1,0,0,92,2,0,0,58,0,0,0,156,1,0,0,103,0,0,0,34,0,0,0,93,2,0,0,94,2,0,0,61,4,0,0,35,0,0,0,95,2,0,0,36,0,0,0,96,2,0,0,0,0,0,0,240,65,0,0,77,5,0,0,78,5,0,0,166,0,0,0,157,1,0,0,233,0,0,0,109,0,0,0,45,0,0,0,79,5,0,0,158,1,0,0,167,0,0,0,168,0,0,0,234,0,0,0,159,1,0,0,97,2,0,0,58,0,0,0,160,1,0,0,104,0,0,0,34,0,0,0,98,2,0,0,99,2,0,0,61,4,0,0,35,0,0,0,100,2,0,0,36,0,0,0,101,2,0,0,0,0,0,0,0,66,0,0,80,5,0,0,81,5,0,0,166,0,0,0,161,1,0,0,235,0,0,0,109,0,0,0,45,0,0,0,82,5,0,0,162,1,0,0,167,0,0,0,168,0,0,0,236,0,0,0,163,1,0,0,102,2,0,0,58,0,0,0,164,1,0,0,105,0,0,0,34,0,0,0,103,2,0,0,104,2,0,0,61,4,0,0,35,0,0,0,105,2,0,0,36,0,0,0,106,2,0,0,0,0,0,0,16,66,0,0,83,5,0,0,84,5,0,0,166,0,0,0,165,1,0,0,237,0,0,0,109,0,0,0,45,0,0,0,85,5,0,0,166,1,0,0,167,0,0,0,168,0,0,0,238,0,0,0,167,1,0,0,107,2,0,0,58,0,0,0,168,1,0,0,106,0,0,0,34,0,0,0,108,2,0,0,109,2,0,0,61,4,0,0,35,0,0,0,110,2,0,0,36,0,0,0,111,2,0,0,0,0,0,0,32,66,0,0,86,5,0,0,87,5,0,0,166,0,0,0,169,1,0,0,239,0,0,0,109,0,0,0,45,0,0,0,88,5,0,0,170,1,0,0,167,0,0,0,168,0,0,0,240,0,0,0,171,1,0,0,112,2,0,0,58,0,0,0,172,1,0,0,107,0,0,0,34,0,0,0,113,2,0,0,114,2,0,0,61,4,0,0,35,0,0,0,115,2,0,0,36,0,0,0,116,2,0,0,0,0,0,0,48,66,0,0,89,5,0,0,90,5,0,0,166,0,0,0,173,1,0,0,241,0,0,0,109,0,0,0,45,0,0,0,91,5,0,0,174,1,0,0,167,0,0,0,168,0,0,0,242,0,0,0,175,1,0,0,117,2,0,0,58,0,0,0,176,1,0,0,108,0,0,0,34,0,0,0,118,2,0,0,119,2,0,0,61,4,0,0,35,0,0,0,120,2,0,0,36,0,0,0,121,2,0,0,0,0,0,0,64,66,0,0,92,5,0,0,93,5,0,0,166,0,0,0,177,1,0,0,243,0,0,0,109,0,0,0,45,0,0,0,94,5,0,0,178,1,0,0,167,0,0,0,168,0,0,0,244,0,0,0,179,1,0,0,122,2,0,0,58,0,0,0,180,1,0,0,109,0,0,0,34,0,0,0,123,2,0,0,124,2,0,0,61,4,0,0,35,0,0,0,125,2,0,0,36,0,0,0,126,2,0,0,0,0,0,0,80,66,0,0,95,5,0,0,96,5,0,0,166,0,0,0,181,1,0,0,245,0,0,0,109,0,0,0,45,0,0,0,97,5,0,0,182,1,0,0,167,0,0,0,168,0,0,0,246,0,0,0,183,1,0,0,127,2,0,0,58,0,0,0,184,1,0,0,110,0,0,0,34,0,0,0,128,2,0,0,129,2,0,0,61,4,0,0,35,0,0,0,130,2,0,0,36,0,0,0,131,2,0,0,0,0,0,0,96,66,0,0,98,5,0,0,99,5,0,0,166,0,0,0,185,1,0,0,247,0,0,0,109,0,0,0,45,0,0,0,100,5,0,0,186,1,0,0,167,0,0,0,168,0,0,0,248,0,0,0,187,1,0,0,132,2,0,0,58,0,0,0,188,1,0,0,111,0,0,0,34,0,0,0,133,2,0,0,134,2,0,0,61,4,0,0,35,0,0,0,135,2,0,0,36,0,0,0,136,2,0,0,0,0,0,0,128,66,0,0,40,4,0,0,101,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,53,0,0,0,46,0,0,0,47,0,0,0,249,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,62,0,0,0,71,0,0,0,49,0,0,0,250,0,0,0,72,0,0,0,42,4,0,0,34,0,0,0,112,0,0,0,52,0,0,0,0,0,0,0,112,66,0,0,63,0,0,0,102,5,0,0,103,5,0,0,251,0,0,0,104,5,0,0,0,0,0,0,144,66,0,0,38,0,0,0,105,5,0,0,137,2,0,0,0,0,0,0,192,66,0,0,40,4,0,0,106,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,54,0,0,0,46,0,0,0,47,0,0,0,252,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,62,0,0,0,76,0,0,0,49,0,0,0,253,0,0,0,77,0,0,0,42,4,0,0,35,0,0,0,113,0,0,0,53,0,0,0,0,0,0,0,176,66,0,0,63,0,0,0,107,5,0,0,108,5,0,0,254,0,0,0,109,5,0,0,0,0,0,0,208,66,0,0,38,0,0,0,110,5,0,0,138,2,0,0,0,0,0,0,0,67,0,0,40,4,0,0,111,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,55,0,0,0,46,0,0,0,47,0,0,0,255,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,62,0,0,0,81,0,0,0,49,0,0,0,0,1,0,0,82,0,0,0,42,4,0,0,36,0,0,0,114,0,0,0,54,0,0,0,0,0,0,0,240,66,0,0,63,0,0,0,112,5,0,0,113,5,0,0,1,1,0,0,114,5,0,0,0,0,0,0,16,67,0,0,38,0,0,0,115,5,0,0,139,2,0,0,0,0,0,0,64,67,0,0,40,4,0,0,116,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,56,0,0,0,46,0,0,0,47,0,0,0,2,1,0,0,83,0,0,0,84,0,0,0,85,0,0,0,62,0,0,0,86,0,0,0,49,0,0,0,3,1,0,0,87,0,0,0,42,4,0,0,37,0,0,0,115,0,0,0,55,0,0,0,0,0,0,0,48,67,0,0,63,0,0,0,117,5,0,0,118,5,0,0,4,1,0,0,119,5,0,0,0,0,0,0,80,67,0,0,38,0,0,0,120,5,0,0,140,2,0,0,0,0,0,0,128,67,0,0,40,4,0,0,121,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,57,0,0,0,46,0,0,0,47],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+92164);allocate([5,1,0,0,88,0,0,0,89,0,0,0,90,0,0,0,62,0,0,0,91,0,0,0,49,0,0,0,6,1,0,0,92,0,0,0,42,4,0,0,38,0,0,0,116,0,0,0,56,0,0,0,0,0,0,0,112,67,0,0,63,0,0,0,122,5,0,0,123,5,0,0,7,1,0,0,124,5,0,0,0,0,0,0,144,67,0,0,38,0,0,0,125,5,0,0,141,2,0,0,0,0,0,0,192,67,0,0,40,4,0,0,126,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,58,0,0,0,46,0,0,0,47,0,0,0,8,1,0,0,93,0,0,0,94,0,0,0,95,0,0,0,62,0,0,0,96,0,0,0,49,0,0,0,9,1,0,0,97,0,0,0,42,4,0,0,39,0,0,0,117,0,0,0,57,0,0,0,0,0,0,0,176,67,0,0,63,0,0,0,127,5,0,0,128,5,0,0,10,1,0,0,129,5,0,0,0,0,0,0,208,67,0,0,38,0,0,0,130,5,0,0,142,2,0,0,0,0,0,0,0,68,0,0,40,4,0,0,131,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,59,0,0,0,46,0,0,0,47,0,0,0,11,1,0,0,98,0,0,0,99,0,0,0,100,0,0,0,62,0,0,0,101,0,0,0,49,0,0,0,12,1,0,0,102,0,0,0,42,4,0,0,40,0,0,0,118,0,0,0,58,0,0,0,0,0,0,0,240,67,0,0,63,0,0,0,132,5,0,0,133,5,0,0,13,1,0,0,134,5,0,0,0,0,0,0,16,68,0,0,38,0,0,0,135,5,0,0,143,2,0,0,0,0,0,0,64,68,0,0,40,4,0,0,136,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,60,0,0,0,46,0,0,0,47,0,0,0,14,1,0,0,103,0,0,0,104,0,0,0,105,0,0,0,62,0,0,0,106,0,0,0,49,0,0,0,15,1,0,0,107,0,0,0,42,4,0,0,41,0,0,0,119,0,0,0,59,0,0,0,0,0,0,0,48,68,0,0,63,0,0,0,137,5,0,0,138,5,0,0,16,1,0,0,139,5,0,0,0,0,0,0,80,68,0,0,38,0,0,0,140,5,0,0,144,2,0,0,0,0,0,0,112,68,0,0,63,0,0,0,141,5,0,0,142,5,0,0,17,1,0,0,143,5,0,0,0,0,0,0,128,68,0,0,144,5,0,0,145,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,61,0,0,0,46,0,0,0,47,0,0,0,18,1,0,0,108,0,0,0,109,0,0,0,110,0,0,0,62,0,0,0,111,0,0,0,49,0,0,0,19,1,0,0,112,0,0,0,42,4,0,0,42,0,0,0,120,0,0,0,60,0,0,0,0,0,0,0,144,68,0,0,38,0,0,0,146,5,0,0,145,2,0,0,0,0,0,0,176,68,0,0,63,0,0,0,147,5,0,0,148,5,0,0,20,1,0,0,149,5,0,0,0,0,0,0,192,68,0,0,150,5,0,0,151,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,113,0,0,0,50,0,0,0,62,0,0,0,46,0,0,0,47,0,0,0,21,1,0,0,60,0,0,0,114,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,43,0,0,0,14,0,0,0,0,0,0,0,224,68,0,0,63,0,0,0,152,5,0,0,153,5,0,0,22,1,0,0,154,5,0,0,0,0,0,0,240,68,0,0,155,5,0,0,156,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,63,0,0,0,46,0,0,0,47,0,0,0,23,1,0,0,115,0,0,0,116,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,24,1,0,0,50,0,0,0,64,0,0,0,42,4,0,0,44,0,0,0,121,0,0,0,0,0,0,0,0,69,0,0,38,0,0,0,157,5,0,0,146,2,0,0,0,0,0,0,32,69,0,0,63,0,0,0,158,5,0,0,159,5,0,0,25,1,0,0,160,5,0,0,0,0,0,0,48,69,0,0,40,4,0,0,161,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,64,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,45,0,0,0,14,0,0,0,0,0,0,0,80,69,0,0,63,0,0,0,162,5,0,0,163,5,0,0,26,1,0,0,164,5,0,0,0,0,0,0,96,69,0,0,40,4,0,0,165,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,65,0,0,0,46,0,0,0,47,0,0,0,27,1,0,0,117,0,0,0,118,0,0,0,119,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,46,0,0,0,14,0,0,0,0,0,0,0,112,69,0,0,166,5,0,0,167,5,0,0,147,2,0,0,0,0,0,0,128,69,0,0,63,0,0,0,168,5,0,0,169,5,0,0,28,1,0,0,170,5,0,0,0,0,0,0,144,69,0,0,171,5,0,0,172,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,120,0,0,0,50,0,0,0,66,0,0,0,46,0,0,0,47,0,0,0,29,1,0,0,60,0,0,0,121,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,47,0,0,0,14,0,0,0,0,0,0,0,192,69,0,0,171,5,0,0,173,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,122,0,0,0,50,0,0,0,66,0,0,0,46,0,0,0,47,0,0,0,30,1,0,0,60,0,0,0,123,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,48,0,0,0,14,0,0,0,0,0,0,0,176,69,0,0,63,0,0,0,174,5,0,0,175,5,0,0,31,1,0,0,176,5,0,0,0,0,0,0,208,69,0,0,63,0,0,0,177,5,0,0,178,5,0,0,32,1,0,0,179,5,0,0,0,0,0,0,224,69,0,0,180,5,0,0,181,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,124,0,0,0,50,0,0,0,67,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,49,0,0,0,14,0,0,0,0,0,0,0,0,70,0,0,63,0,0,0,182,5,0,0,183,5,0,0,33,1,0,0,184,5,0,0,0,0,0,0,16,70,0,0,40,4,0,0,185,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,68,0,0,0,46,0,0,0,47,0,0,0,34,1,0,0,125,0,0,0,126,0,0,0,127,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,50,0,0,0,122,0,0,0,0,0,0,0,48,70,0,0,63,0,0,0,186,5,0,0,187,5,0,0,35,1,0,0,188,5,0,0,0,0,0,0,64,70,0,0,189,5,0,0,190,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,69,0,0,0,46,0,0,0,47,0,0,0,36,1,0,0,128,0,0,0,129,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,37,1,0,0,50,0,0,0,64,0,0,0,42,4,0,0,51,0,0,0,123,0,0,0,154,174,6,0,191,172,6,0,142,0,0,0,0,0,0,0,23,201,17,0,122,175,6,0,131,175,6,0,154,174,6,0,191,172,6,0,142,0,0,0,1,0,0,0,23,201,17,0,111,175,6,0,140,207,6,0,0,0,0,0,80,70,0,0,38,0,0,0,191,5,0,0,148,2,0,0,0,0,0,0,96,70,0,0,63,0,0,0,192,5,0,0,193,5,0,0,38,1,0,0,194,5,0,0,0,0,0,0,112,70,0,0,40,4,0,0,195,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,70,0,0,0,46,0,0,0,47,0,0,0,39,1,0,0,60,0,0,0,130,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,52,0,0,0,14,0,0,0,0,0,0,0,144,70,0,0,63,0,0,0,196,5,0,0,197,5,0,0,40,1,0,0,198,5,0,0,0,0,0,0,160,70,0,0,40,4,0,0,199,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,71,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,53,0,0,0,124,0,0,0,0,0,0,0,208,70,0,0,40,4,0,0,200,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,72,0,0,0,46,0,0,0,47,0,0,0,41,1,0,0,60,0,0,0,131,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,54,0,0,0,14,0,0,0,0,0,0,0,192,70,0,0,63,0,0,0,201,5,0,0,202,5,0,0,42,1,0,0,203,5,0,0,0,0,0,0,240,70,0,0,63,0,0,0,204,5,0,0,205,5,0,0,43,1,0,0,206,5,0,0,0,0,0,0,0,71,0,0,40,4,0,0,207,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,73,0,0,0,46,0,0,0,47,0,0,0,44,1,0,0,132,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,55,0,0,0,14,0,0,0,0,0,0,0,32,71,0,0,63,0,0,0,208,5,0,0,209,5,0,0,45,1,0,0,210,5,0,0,0,0,0,0,48,71,0,0,211,5,0,0,212,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,133,0,0,0,50,0,0,0,74,0,0,0,46,0,0,0,47,0,0,0,46,1,0,0,60,0,0,0,134,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,56,0,0,0,125,0,0,0,0,0,0,0,80,71,0,0,63,0,0,0,213,5,0,0,214,5,0,0,47,1,0,0,215,5,0,0,0,0,0,0,112,71,0,0,216,5,0,0,217,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,75,0,0,0,46,0,0,0,47,0,0,0,48,1,0,0,60,0,0,0,135,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,57,0,0,0,14,0,0,0,0,0,0,0,96,71,0,0,216,5,0,0,218,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,51,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,14,0,0,0,0,0,0,0,128,71,0,0,63,0,0,0,219,5,0,0,220,5,0,0,49,1,0,0,221,5,0,0,0,0,0,0,144,71,0,0,40,4,0,0,222,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,76,0,0,0,46,0,0,0,47,0,0,0,50,1,0,0,136,0,0,0,137,0,0,0,138,0,0,0,63,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,126,0,0,0,0,0,0,0,160,71,0,0,38,0,0,0,223,5,0,0,149,2,0,0,0,0,0,0,192,71,0,0,63,0,0,0,224,5,0,0,225,5,0,0,51,1,0,0,226,5,0,0,0,0,0,0,208,71,0,0,227,5,0,0,228,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,139,0,0,0,50,0,0,0,77,0,0,0,46,0,0,0,47,0,0,0,52,1,0,0,60,0,0,0,140,0,0,0,141,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,58,0,0,0,127,0,0,0,82,193,6,0,110,191,6,0,51,1,0,0,6,0,0,0,23,201,17,0,205,193,6,0,219,193,6,0,82,193,6,0,110,191,6,0,52,1,0,0,1,0,0,0,23,201,17,0,190,193,6,0,188,193,6,0,82,193,6,0,110,191,6,0,52,1,0,0,1,0,0,0,23,201,17,0,173,193,6,0,188,193,6,0,0,0,0,0,240,71,0,0,63,0,0,0,229,5,0,0,230,5,0,0,53,1,0,0,231,5,0,0,0,0,0,0,0,72,0,0,232,5,0,0,233,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,142,0,0,0,50,0,0,0,78,0,0,0,46,0,0,0,47,0,0,0,54,1,0,0,60,0,0,0,143,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,55,1,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,128,0,0,0,0,0,0,0,32,72,0,0,63,0,0,0,234,5,0,0,235,5,0,0,56,1,0,0,236,5,0,0,0,0,0,0,48,72,0,0,237,5,0,0,238,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,144,0,0,0,50,0,0,0,79,0,0,0,46,0,0,0,47,0,0,0,57,1,0,0,145,0,0,0,146,0,0,0,147,0,0,0,64,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,59,0,0,0,129,0,0,0,148,0,0,0,149,0,0,0,0,0,0,0,176,59,0,0,237,5,0,0,239,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,51,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,14,0,0,0,0,0,0,0,64,72,0,0,240,5,0,0,241,5,0,0,150,2,0,0,0,0,0,0,80,72,0,0,63,0,0,0,242,5,0,0,243,5,0,0,58,1,0,0,244,5,0,0,0,0,0,0,96,72,0,0,245,5,0,0,246,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,80,0,0,0,46,0,0,0,47,0,0,0,59,1,0,0,150,0,0,0,151,0,0,0,62,0,0,0,62,0,0,0,152,0,0,0,49,0,0,0,60,1,0,0,153,0,0,0,42,4,0,0,60,0,0,0,130,0,0,0,61,0,0,0,53,202,6,0,83,200,6,0,52,0,0,0,1,0,0,0,23,201,17,0,147,202,6,0,140,207,6,0,0,0,0,0,128,72,0,0,63,0,0,0,247,5,0,0,248,5,0,0,61,1,0,0,249,5,0,0,0,0,0,0,144,72,0,0,40,4,0,0,250,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,154,0,0,0,50,0,0,0,81,0,0,0,46,0,0,0,47,0,0,0,62,1,0,0,60,0,0,0,155,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,61,0,0,0,14,0,0,0,0,0,0,0,176,72,0,0,63,0,0,0,251,5,0,0,252,5,0,0,63,1,0,0,253,5,0,0,0,0,0,0,192,72,0,0,40,4,0,0,254,5,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,156,0,0,0,50,0,0,0,82,0,0,0,46,0,0,0,47,0,0,0,64,1,0,0,157,0,0,0,158,0,0,0,62,0,0,0,62,0,0,0,159,0,0,0,49,0,0,0,50,0,0,0,160,0,0,0,42,4,0,0,62,0,0,0,131,0,0,0,17,207,6,0,57,206,6,0,86,0,0,0,1,0,0,0,164,207,6,0,196,207,6,0,212,207,6,0,17,207,6,0,57,206,6,0,96,0,0,0,1,0,0,0,23,201,17,0,149,207,6,0,140,207,6,0,17,207,6,0,57,206,6,0,96,0,0,0,1,0,0,0,23,201,17,0,125,207,6,0,140,207,6,0,0,0,0,0,224,72,0,0,63,0,0,0,255,5,0,0,0,6,0,0,65,1,0,0,1,6,0,0,0,0,0,0,240,72,0,0,2,6,0,0,3,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,83,0,0,0,46,0,0,0,47,0,0,0,66,1,0,0,60,0,0,0,161,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,63,0,0,0,14,0,0,0,0,0,0,0,16,73,0,0,63,0,0,0,4,6,0,0,5,6,0,0,67,1,0,0,6,6,0,0,0,0,0,0,48,73,0,0,7,6,0,0,8,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,162,0,0,0,50,0,0,0,84,0,0,0,46,0,0,0,47,0,0,0,68,1,0,0,60,0,0,0,163,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,64,0,0,0,14,0,0,0,0,0,0,0,32,73,0,0,7,6,0,0,9,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,51,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,14,0,0,0,0,0,0,0,64,73,0,0,63,0,0,0,10,6,0,0,11,6,0,0,69,1,0,0,12,6,0,0,0,0,0,0,80,73,0,0,13,6,0,0,14,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,164,0,0,0,50,0,0,0,85,0,0,0,46,0,0,0,47,0,0,0,70,1,0,0,165,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,65,0,0,0,14,0,0,0,124,222,6,0,209,220,6,0,137,0,0,0,4,0,0,0,23,201,17,0,24,223,6,0,14,223,6,0,124,222,6,0,209,220,6,0,137,0,0,0,4,0,0,0,23,201,17,0,4,223,6,0,14,223,6,0,124,222,6,0,209,220,6,0,138,0,0,0,4,0,0,0,23,201,17,0,252,222,6,0,243,222,6,0,124,222,6,0,209,220,6,0,138,0,0,0,4,0,0,0,23,201,17,0,234,222,6,0,243,222,6,0,0,0,0,0,112,73,0,0,63,0,0,0,15,6,0,0,16,6,0,0,71,1,0,0,17,6,0,0,0,0,0,0,128,73,0,0,18,6,0,0,19,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,166,0,0,0,50,0,0,0,86,0,0,0,46,0,0,0,47,0,0,0,72,1,0,0,60,0,0,0,167,0,0,0,168,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,66,0,0,0,14,0,0,0,0,0,0,0,144,73,0,0,38,0,0,0,20,6,0,0,151,2,0,0,0,0,0,0,208,73,0,0,21,6,0,0,22,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,169,0,0,0,50,0,0,0,87,0,0,0,46,0,0,0,47,0,0,0,73,1,0,0,170,0,0,0,171,0,0,0,172,0,0,0,65,0,0,0,63,0,0,0,74,1,0,0,75,1,0,0,64,0,0,0,42,4,0,0,67,0,0,0,132,0,0,0,88,0,0,0,0,0,0,0,192,73,0,0,23,6,0,0,24,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,51,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,14,0,0,0,0,0,0,0,176,73,0,0,63,0,0,0,25,6,0,0,26,6,0,0,76,1,0,0,27,6,0,0,0,0,0,0,224,73,0,0,28,6,0,0,29,6,0,0,152,2,0,0,0,0,0,0,240,73,0,0,23,6,0,0,30,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,173,0,0,0,50,0,0,0,51,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,65,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,14,0,0,0,1,0,0,0,0,0,0,0,32,74,0,0,31,6,0,0,32,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,174,0,0,0,50,0,0,0,89,0,0,0,46,0,0,0,47,0,0,0,77,1,0,0,175,0,0,0,176,0,0,0,62,0,0,0,65,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,68,0,0,0,133,0,0,0,90,0,0,0,0,0,0,0,16,74,0,0,63,0,0,0,33,6,0,0,34,6,0,0,78,1,0,0,35,6,0,0,0,0,0,0,64,74,0,0,38,0,0,0,36,6,0,0,153,2,0,0,0,0,0,0,48,74,0,0,38,0,0,0,37,6,0,0,154,2,0,0,0,0,0,0,96,74,0,0,63,0,0,0,38,6,0,0,39,6,0,0,79,1,0,0,40,6,0,0,0,0,0,0,112,74,0,0,41,6,0,0,42,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,177,0,0,0,50,0,0,0,91,0,0,0,80,1,0,0,81,1,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,69,0,0,0,14,0,0,0,92,0,0,0,155,2,0,0,156,2,0,0,157,2,0,0,0,0,0,0,128,74,0,0,63,0,0,0,43,6,0,0,44,6,0,0,82,1,0,0,45,6,0,0,0,0,0,0,160,74,0,0,46,6,0,0,47,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,178,0,0,0,50,0,0,0,93,0,0,0,46,0,0,0,47,0,0,0,83,1,0,0,60,0,0,0,179,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,70,0,0,0,14,0,0,0,0,0,0,0,144,74,0,0,48,6,0,0,49,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,51,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,32,0,0,0,14,0,0,0,0,0,0,0,176,74,0,0,63,0,0,0,50,6,0,0,51,6,0,0,84,1,0,0,52,6,0,0,0,0,0,0,192,74,0,0,40,4,0,0,53,6,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,58,0,0,0,59,0,0,0,50,0,0,0,94,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,62,0,0,0,63,0,0,0,49,0,0,0,50,0,0,0,64,0,0,0,42,4,0,0,71,0,0,0,14,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,4,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,92,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,8,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,12,0,0,0,0,0,0,0,224,74,0,0,54,6,0,0,55,6,0,0,166,0,0,0,189,1,0,0,85,1,0,0,190,1,0,0,191,1,0,0,56,6,0,0,192,1,0,0,167,0,0,0,168,0,0,0,86,1,0,0,193,1,0,0,158,2,0,0,58,0,0,0,194,1,0,0,134,0,0,0,34,0,0,0,159,2,0,0,160,2,0,0,61,4,0,0,35,0,0,0,161,2,0,0,36,0,0,0,162,2,0,0,0,0,0,0,255,255,255,255,44,0,0,0,7,0,0,0,14,0,0,0,24,0,0,0,16,0,0,0,255,255,255,255,100,0,0,0,26,0,0,0,255,255,255,255,32,0,0,0,33,0,0,0,255,255,255,255,20,0,0,0,176,48,8,0,224,48,8,0,248,48,8,0,96,49,8,0,128,49,8,0,0,0,0,0,240,74,0,0,57,6,0,0,58,6,0,0,166,0,0,0,195,1,0,0,87,1,0,0,196,1,0,0,197,1,0,0,59,6,0,0,198,1,0,0,167,0,0,0,168,0,0,0,88,1,0,0,199,1,0,0,163,2,0,0,58,0,0,0,200,1,0,0,135,0,0,0,34,0,0,0,164,2,0,0,165,2,0,0,61,4,0,0,35,0,0,0,166,2,0,0,36,0,0,0,167,2,0,0,0,0,0,0,0,75,0,0,60,6,0,0,61,6,0,0,166,0,0,0,201,1,0,0,89,1,0,0,202,1,0,0,203,1,0,0,62,6,0,0,204,1,0,0,167,0,0,0,168,0,0,0,90,1,0,0,205,1,0,0,168,2,0,0,58,0,0,0,206,1,0,0,136,0,0,0,34,0,0,0,169,2,0,0,170,2,0,0,61,4,0,0,35,0,0,0,171,2,0,0,36,0,0,0,172,2,0,0,0,0,0,0,16,75,0,0,63,6,0,0,64,6,0,0,166,0,0,0,207,1,0,0,91,1,0,0,208,1,0,0,209,1,0,0,65,6,0,0,210,1,0,0,167,0,0,0,168,0,0,0,92,1,0,0,211,1,0,0,173,2,0,0,58,0,0,0,212,1,0,0,137,0,0,0,34,0,0,0,174,2,0,0,175,2,0,0,61,4,0,0,35,0,0,0,176,2,0,0,36,0,0,0,177,2,0,0,0,0,0,0,32,75,0,0,66,6,0,0,67,6,0,0,93,1,0,0,138,0,0,0,94,1,0,0,20,0,0,0,191,0,0,0,192,0,0,0,213,1,0,0,214,1,0,0,68,6,0,0,69,6,0,0,193,0,0,0,194,0,0,0,67,0,0,0,195,0,0,0,215,1,0,0,216,1,0,0,178,2,0,0,0,0,0,0,48,75,0,0,70,6,0,0,71,6,0,0,179,2,0,0,217,1,0,0,95,1,0,0,218,1,0,0,45,0,0,0,72,6,0,0,219,1,0,0,167,0,0,0,180,2,0,0,96,1,0,0,220,1,0,0,181,2,0,0,58,0,0,0,221,1,0,0,139,0,0,0,34,0,0,0,182,0,0,0,182,2,0,0,61,4,0,0,222,1,0,0,184,0,0,0,36,0,0,0,183,2,0,0,223,1,0,0,224,1,0,0,0,0,0,0,80,75,0,0,70,6,0,0,73,6,0,0,179,2,0,0,217,1,0,0,95,1,0,0,218,1,0,0,45,0,0,0,72,6,0,0,219,1,0,0,167,0,0,0,180,2,0,0,96,1,0,0,220,1,0,0,181,2,0,0,58,0,0,0,221,1,0,0,139,0,0,0,34,0,0,0,182,0,0,0,197,0,0,0,61,4,0,0,222,1,0,0,184,0,0,0,36,0,0,0,1,0,0,0,223,1,0,0,224,1,0,0,0,0,0,0,64,75,0,0,74,6,0,0,75,6,0,0,179,2,0,0,217,1,0,0,95,1,0,0,218,1,0,0,45,0,0,0,72,6,0,0,219,1,0,0,167,0,0,0,180,2,0,0,96,1,0,0,220,1,0,0,181,2,0,0,58,0,0,0,221,1,0,0,139,0,0,0,34,0,0,0,182,0,0,0,197,0,0,0,61,4,0,0,222,1,0,0,184,0,0,0,36,0,0,0,1,0,0,0,223,1,0,0,224,1,0,0,0,0,0,0,96,75,0,0,70,6,0,0,76,6,0,0,179,2,0,0,217,1,0,0,95,1,0,0,218,1,0,0,45,0,0,0,72,6,0,0,219,1,0,0,167,0,0,0,180,2,0,0,96,1,0,0,220,1,0,0,181,2,0,0,58,0,0,0,221,1,0,0,139,0,0,0,34,0,0,0,182,0,0,0,182,2,0,0,61,4,0,0,222,1,0,0,184,0,0,0,36,0,0,0,183,2,0,0,225,1,0,0,226,1,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,12,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,32,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,12,0,0,0,20,0,0,0,16,0,0,0,40,0,0,0,32,0,0,0,24,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,56,0,0,0,8,0,0,0,24,0,0,0,40,0,0,0,68,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,12,0,0,0,8,0,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,8,0,0,0,0,0,0,0,112,75,0,0,77,6,0,0,78,6,0,0,166,0,0,0,227,1,0,0,97,1,0,0,228,1,0,0,229,1,0,0,79,6,0,0,230,1,0,0,167,0,0,0,168,0,0,0,98,1,0,0,231,1,0,0,184,2,0,0,58,0,0,0,232,1,0,0,140,0,0,0,34,0,0,0,185,2,0,0,186,2,0,0,61,4,0,0,35,0,0,0,187,2,0,0,36,0,0,0,188,2,0,0,0,0,0,0,255,255,255,255,40,0,0,0,12,0,0,0,255,255,255,255,48,0,0,0,24,0,0,0,255,255,255,255,80,0,0,0,40,0,0,0,255,255,255,255,20,0,0,0,47,0,0,0,255,255,255,255,28,0,0,0,192,49,8,0,232,49,8,0,24,50,8,0,104,50,8,0,128,50,8,0,0,0,0,0,128,75,0,0,80,6,0,0,81,6,0,0,166,0,0,0,233,1,0,0,99,1,0,0,234,1,0,0,235,1,0,0,82,6,0,0,236,1,0,0,167,0,0,0,168,0,0,0,100,1,0,0,237,1,0,0,189,2,0,0,58,0,0,0,238,1,0,0,141,0,0,0,34,0,0,0,190,2,0,0,191,2,0,0,61,4,0,0,35,0,0,0,192,2,0,0,36,0,0,0,193,2,0,0,0,0,0,0,144,75,0,0,83,6,0,0,84,6,0,0,166,0,0,0,239,1,0,0,101,1,0,0,240,1,0,0,241,1,0,0,85,6,0,0,242,1,0,0,167,0,0,0,168,0,0,0,102,1,0,0,243,1,0,0,194,2,0,0,58,0,0,0,244,1,0,0,142,0,0,0,34,0,0,0,195,2,0,0,196,2,0,0,61,4,0,0,35,0,0,0,197,2,0,0,36,0,0,0,198,2,0,0,0,0,0,0,160,75,0,0,86,6,0,0,87,6,0,0,166,0,0,0,245,1,0,0,103,1,0,0,246,1,0,0,247,1,0,0,88,6,0,0,248,1,0,0,167,0,0,0,168,0,0,0,104,1,0,0,249,1,0,0,199,2,0,0,58,0,0,0,250,1,0,0,143,0,0,0,34,0,0,0,200,2,0,0,201,2,0,0,61,4,0,0,35,0,0,0,202,2,0,0,36,0,0,0,203,2,0,0,0,0,0,0,176,75,0,0,89,6,0,0,90,6,0,0,166,0,0,0,251,1,0,0,105,1,0,0,252,1,0,0,253,1,0,0,91,6,0,0,254,1,0,0,167,0,0,0,168,0,0,0,106,1,0,0,255,1,0,0,204,2,0,0,58,0,0,0,0,2,0,0,144,0,0,0,34,0,0,0,205,2,0,0,206,2,0,0,61,4,0,0,35,0,0,0,207,2,0,0,36,0,0,0,208,2,0,0,255,255,255,255,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,24,0,0,0,28,0,0,0,8,0,0,0,0,0,0,0,192,75,0,0,92,6,0,0,93,6,0,0,166,0,0,0,1,2,0,0,107,1,0,0,2,2,0,0,3,2,0,0,94,6,0,0,4,2,0,0,167,0,0,0,168,0,0,0,108,1,0,0,5,2,0,0,209,2,0,0,58,0,0,0,6,2,0,0,145,0,0,0,34,0,0,0,210,2,0,0,211,2,0,0,61,4,0,0,35,0,0,0,212,2,0,0,36,0,0,0,213,2,0,0,0,0,0,0,255,255,255,255,36,0,0,0,200,50,8,0,0,0,0,0,240,75,0,0,95,6,0,0,96,6,0,0,97,6,0,0,21,0,0,0,98,6,0,0,0,0,0,0,224,75,0,0,99,6,0,0,100,6,0,0,37,0,0,0,214,2,0,0,215,2,0,0,7,2,0,0,6,0,0,0,216,2,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,92,0,0,0,8,2,0,0,9,2,0,0,10,2,0,0,217,2,0,0,11,2,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,218,2,0,0,12,2,0,0,219,2,0,0,13,2,0,0,4,0,0,0,4,0,0,0,0,0,0,0,32,76,0,0,101,6,0,0,102,6,0,0,103,6,0,0,21,0,0,0,104,6,0,0,0,0,0,0,16,76,0,0,99,6,0,0,105,6,0,0,37,0,0,0,214,2,0,0,215,2,0,0,7,2,0,0,6,0,0,0,220,2,0,0,99,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,92,0,0,0,8,2,0,0,9,2,0,0,10,2,0,0,221,2,0,0,14,2,0,0,222,2,0,0,15,2,0,0,223,2,0,0,16,2,0,0,0,0,0,0,80,76,0,0,106,6,0,0,107,6,0,0,108,6,0,0,21,0,0,0,109,6,0,0,0,0,0,0,64,76,0,0,99,6,0,0,110,6,0,0,37,0,0,0,224,2,0,0,225,2,0,0,7,2,0,0,6,0,0,0,226,2,0,0,100,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,93,0,0,0,17,2,0,0,18,2,0,0,19,2,0,0,227,2,0,0,20,2,0,0,228,2,0,0,21,2,0,0,5,0,0,0,5,0,0,0,229,2,0,0,22,2,0,0,230,2,0,0,23,2,0,0,231,2,0,0,24,2,0,0,0,0,0,0,96,76,0,0,111,6,0,0,112,6,0,0,37,0,0,0,214,2,0,0,215,2,0,0,7,2,0,0,6,0,0,0,232,2,0,0,100,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,94,0,0,0,25,2,0,0,26,2,0,0,27,2,0,0,0,0,0,0,128,76,0,0,113,6,0,0,114,6,0,0,115,6,0,0,21,0,0,0,116,6,0,0,0,0,0,0,160,76,0,0,99,6,0,0,117,6,0,0,37,0,0,0,214,2,0,0,215,2,0,0,7,2,0,0,6,0,0,0,233,2,0,0,100,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,95,0,0,0,28,2,0,0,29,2,0,0,30,2,0,0,234,2,0,0,31,2,0,0,6,0,0,0,6,0,0,0,235,2,0,0,32,2,0,0,236,2,0,0,33,2,0,0,237,2,0,0,34,2,0,0,238,2,0,0,35,2,0,0,239,2,0,0,36,2,0,0,240,2,0,0,37,2,0,0,241,2,0,0,38,2,0,0,8,0,0,0,253,255,255,255,9,0,0,0,5,0,0,0,4,0,0,0,2,0,0,0,7,0,0,0,244,255,255,255,245,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,7,0,0,0,244,255,255,255,12,0,0,0,243,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,12,0,0,0,1,0,0,0,249,255,255,255,1,0,0,0,6,0,0,0,254,255,255,255,246,255,255,255,254,255,255,255,252,255,255,255,243,255,255,255,243,255,255,255,245,255,255,255,248,255,255,255,243,255,255,255,253,255,255,255,244,255,255,255,247,255,255,255,10,0,0,0,4,0,0,0,11,0,0,0,9,0,0,0,243,255,255,255,248,255,255,255,248,255,255,255,247,255,255,255,245,255,255,255,7,0,0,0,247,255,255,255,12,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,6,0,0,0,252,255,255,255,251,255,255,255,253,255,255,255,0,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,253,255,255,255,247,255,255,255,0,0,0,0,249,255,255,255,5,0,0,0,12,0,0,0,250,255,255,255,12,0,0,0,255,255,255,255,253,255,255,255,6,0,0,0,254,255,255,255,12,0,0,0,250,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,11,0,0,0,243,255,255,255,12,0,0,0,248,255,255,255,4,0,0,0,7,0,0,0,5,0,0,0,1,0,0,0,5,0,0,0,253,255,255,255,10,0,0,0,253,255,255,255,3,0,0,0,249,255,255,255,6,0,0,0,12,0,0,0,248,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,254,255,255,255,11,0,0,0,255,255,255,255,246,255,255,255,243,255,255,255,12,0,0,0,248,255,255,255,10,0,0,0,249,255,255,255,3,0,0,0,251,255,255,255,253,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,7,0,0,0,246,255,255,255,244,255,255,255,250,255,255,255,11,0,0,0,5,0,0,0,244,255,255,255,6,0,0,0,249,255,255,255,5,0,0,0,250,255,255,255,7,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,4,0,0,0,251,255,255,255,9,0,0,0,11,0,0,0,11,0,0,0,243,255,255,255,4,0,0,0,7,0,0,0,4,0,0,0,12,0,0,0,2,0,0,0,255,255,255,255,4,0,0,0,4,0,0,0,252,255,255,255,244,255,255,255,254,255,255,255,7,0,0,0,248,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,4,0,0,0,11,0,0,0,9,0,0,0,12,0,0,0,0,0,0,0,248,255,255,255,1,0,0,0,243,255,255,255,243,255,255,255,254,255,255,255,248,255,255,255,2,0,0,0,253,255,255,255,254,255,255,255,254,255,255,255,3,0,0,0,250,255,255,255,9,0,0,0,252,255,255,255,247,255,255,255,8,0,0,0,12,0,0,0,10,0,0,0,7,0,0,0,0,0,0,0,9,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,251,255,255,255,11,0,0,0,246,255,255,255,243,255,255,255,250,255,255,255,245,255,255,255,0,0,0,0,10,0,0,0,7,0,0,0,12,0,0,0,1,0,0,0,250,255,255,255,253,255,255,255,250,255,255,255,12,0,0,0,10,0,0,0,247,255,255,255,12,0,0,0,252,255,255,255,243,255,255,255,8,0,0,0,248,255,255,255,244,255,255,255,243,255,255,255,0,0,0,0,248,255,255,255,252,255,255,255,3,0,0,0,3,0,0,0,7,0,0,0,8,0,0,0,5,0,0,0,7,0,0,0,10,0,0,0,249,255,255,255,255,255,255,255,7,0,0,0,1,0,0,0,244,255,255,255,3,0,0,0,246,255,255,255,5,0,0,0,6,0,0,0,2,0,0,0,252,255,255,255,3,0,0,0,246,255,255,255,243,255,255,255,0,0,0,0,243,255,255,255,5,0,0,0,243,255,255,255,249,255,255,255,244,255,255,255,12,0,0,0,243,255,255,255,3,0,0,0,245,255,255,255,8,0,0,0,249,255,255,255,12,0,0,0,252,255,255,255,7,0,0,0,6,0,0,0,246,255,255,255,12,0,0,0,8,0,0,0,247,255,255,255,255,255,255,255,249,255,255,255,250,255,255,255,254,255,255,255,251,255,255,255,0,0,0,0,12,0,0,0,244,255,255,255,5],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+102404);allocate([249,255,255,255,5,0,0,0,3,0,0,0,246,255,255,255,8,0,0,0,243,255,255,255,249,255,255,255,249,255,255,255,252,255,255,255,5,0,0,0,253,255,255,255,254,255,255,255,255,255,255,255,249,255,255,255,2,0,0,0,9,0,0,0,5,0,0,0,245,255,255,255,245,255,255,255,243,255,255,255,251,255,255,255,243,255,255,255,255,255,255,255,6,0,0,0,0,0,0,0,255,255,255,255,5,0,0,0,253,255,255,255,5,0,0,0,2,0,0,0,252,255,255,255,243,255,255,255,252,255,255,255,12,0,0,0,247,255,255,255,250,255,255,255,247,255,255,255,6,0,0,0,244,255,255,255,246,255,255,255,248,255,255,255,252,255,255,255,10,0,0,0,2,0,0,0,12,0,0,0,253,255,255,255,7,0,0,0,12,0,0,0,12,0,0,0,12,0,0,0,249,255,255,255,243,255,255,255,250,255,255,255,5,0,0,0,252,255,255,255,9,0,0,0,253,255,255,255,4,0,0,0,7,0,0,0,255,255,255,255,12,0,0,0,2,0,0,0,249,255,255,255,6,0,0,0,251,255,255,255,1,0,0,0,243,255,255,255,11,0,0,0,244,255,255,255,5,0,0,0,253,255,255,255,7,0,0,0,254,255,255,255,250,255,255,255,7,0,0,0,248,255,255,255,12,0,0,0,249,255,255,255,243,255,255,255,249,255,255,255,245,255,255,255,244,255,255,255,1,0,0,0,253,255,255,255,12,0,0,0,12,0,0,0,2,0,0,0,250,255,255,255,3,0,0,0,0,0,0,0,252,255,255,255,3,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,243,255,255,255,1,0,0,0,9,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,250,255,255,255,1,0,0,0,255,255,255,255,3,0,0,0,12,0,0,0,9,0,0,0,1,0,0,0,12,0,0,0,6,0,0,0,255,255,255,255,247,255,255,255,255,255,255,255,3,0,0,0,243,255,255,255,243,255,255,255,246,255,255,255,5,0,0,0,7,0,0,0,7,0,0,0,10,0,0,0,12,0,0,0,12,0,0,0,251,255,255,255,12,0,0,0,9,0,0,0,6,0,0,0,3,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,243,255,255,255,6,0,0,0,10,0,0,0,2,0,0,0,244,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,8,0,0,0,4,0,0,0,250,255,255,255,2,0,0,0,6,0,0,0,12,0,0,0,243,255,255,255,9,0,0,0,244,255,255,255,10,0,0,0,3,0,0,0,248,255,255,255,4,0,0,0,249,255,255,255,9,0,0,0,245,255,255,255,12,0,0,0,252,255,255,255,250,255,255,255,1,0,0,0,12,0,0,0,2,0,0,0,248,255,255,255,6,0,0,0,247,255,255,255,7,0,0,0,252,255,255,255,2,0,0,0,3,0,0,0,3,0,0,0,254,255,255,255,6,0,0,0,3,0,0,0,11,0,0,0,0,0,0,0,3,0,0,0,253,255,255,255,8,0,0,0,248,255,255,255,7,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,245,255,255,255,251,255,255,255,250,255,255,255,252,255,255,255,246,255,255,255,11,0,0,0,251,255,255,255,10,0,0,0,251,255,255,255,248,255,255,255,253,255,255,255,12,0,0,0,246,255,255,255,5,0,0,0,247,255,255,255,0,0,0,0,8,0,0,0,255,255,255,255,12,0,0,0,250,255,255,255,4,0,0,0,250,255,255,255,6,0,0,0,245,255,255,255,246,255,255,255,12,0,0,0,248,255,255,255,7,0,0,0,4,0,0,0,254,255,255,255,6,0,0,0,7,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,12,0,0,0,251,255,255,255,248,255,255,255,251,255,255,255,2,0,0,0,7,0,0,0,250,255,255,255,10,0,0,0,12,0,0,0,247,255,255,255,243,255,255,255,248,255,255,255,248,255,255,255,251,255,255,255,243,255,255,255,251,255,255,255,254,255,255,255,8,0,0,0,248,255,255,255,9,0,0,0,243,255,255,255,247,255,255,255,245,255,255,255,247,255,255,255,0,0,0,0,1,0,0,0,248,255,255,255,1,0,0,0,254,255,255,255,7,0,0,0,252,255,255,255,9,0,0,0,1,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,252,255,255,255,11,0,0,0,250,255,255,255,12,0,0,0,245,255,255,255,244,255,255,255,247,255,255,255,250,255,255,255,4,0,0,0,3,0,0,0,7,0,0,0,7,0,0,0,12,0,0,0,5,0,0,0,5,0,0,0,10,0,0,0,8,0,0,0,0,0,0,0,252,255,255,255,2,0,0,0,8,0,0,0,247,255,255,255,12,0,0,0,251,255,255,255,243,255,255,255,0,0,0,0,7,0,0,0,2,0,0,0,12,0,0,0,255,255,255,255,2,0,0,0,1,0,0,0,7,0,0,0,5,0,0,0,11,0,0,0,7,0,0,0,247,255,255,255,3,0,0,0,5,0,0,0,6,0,0,0,248,255,255,255,243,255,255,255,252,255,255,255,248,255,255,255,9,0,0,0,251,255,255,255,9,0,0,0,253,255,255,255,253,255,255,255,252,255,255,255,249,255,255,255,253,255,255,255,244,255,255,255,6,0,0,0,5,0,0,0,8,0,0,0,0,0,0,0,249,255,255,255,6,0,0,0,250,255,255,255,12,0,0,0,243,255,255,255,6,0,0,0,251,255,255,255,254,255,255,255,1,0,0,0,246,255,255,255,3,0,0,0,10,0,0,0,4,0,0,0,1,0,0,0,8,0,0,0,252,255,255,255,254,255,255,255,254,255,255,255,2,0,0,0,243,255,255,255,2,0,0,0,244,255,255,255,12,0,0,0,12,0,0,0,254,255,255,255,243,255,255,255,0,0,0,0,250,255,255,255,4,0,0,0,1,0,0,0,9,0,0,0,3,0,0,0,250,255,255,255,246,255,255,255,253,255,255,255,251,255,255,255,253,255,255,255,243,255,255,255,255,255,255,255,1,0,0,0,7,0,0,0,5,0,0,0,12,0,0,0,245,255,255,255,4,0,0,0,254,255,255,255,5,0,0,0,249,255,255,255,243,255,255,255,9,0,0,0,247,255,255,255,251,255,255,255,7,0,0,0,1,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,248,255,255,255,7,0,0,0,6,0,0,0,249,255,255,255,252,255,255,255,249,255,255,255,1,0,0,0,248,255,255,255,11,0,0,0,249,255,255,255,248,255,255,255,243,255,255,255,6,0,0,0,244,255,255,255,248,255,255,255,2,0,0,0,4,0,0,0,3,0,0,0,9,0,0,0,10,0,0,0,251,255,255,255,12,0,0,0,3,0,0,0,250,255,255,255,251,255,255,255,250,255,255,255,7,0,0,0,8,0,0,0,253,255,255,255,9,0,0,0,248,255,255,255,2,0,0,0,244,255,255,255,2,0,0,0,8,0,0,0,245,255,255,255,254,255,255,255,246,255,255,255,3,0,0,0,244,255,255,255,243,255,255,255,249,255,255,255,247,255,255,255,245,255,255,255,0,0,0,0,246,255,255,255,251,255,255,255,5,0,0,0,253,255,255,255,11,0,0,0,8,0,0,0,254,255,255,255,243,255,255,255,255,255,255,255,12,0,0,0,255,255,255,255,248,255,255,255,0,0,0,0,9,0,0,0,243,255,255,255,245,255,255,255,244,255,255,255,251,255,255,255,246,255,255,255,254,255,255,255,246,255,255,255,11,0,0,0,253,255,255,255,9,0,0,0,254,255,255,255,243,255,255,255,2,0,0,0,253,255,255,255,3,0,0,0,2,0,0,0,247,255,255,255,243,255,255,255,252,255,255,255,0,0,0,0,252,255,255,255,6,0,0,0,253,255,255,255,246,255,255,255,252,255,255,255,12,0,0,0,254,255,255,255,249,255,255,255,250,255,255,255,245,255,255,255,252,255,255,255,9,0,0,0,6,0,0,0,253,255,255,255,6,0,0,0,11,0,0,0,243,255,255,255,11,0,0,0,251,255,255,255,5,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,6,0,0,0,7,0,0,0,251,255,255,255,12,0,0,0,254,255,255,255,255,255,255,255,12,0,0,0,0,0,0,0,7,0,0,0,252,255,255,255,248,255,255,255,253,255,255,255,254,255,255,255,249,255,255,255,1,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,244,255,255,255,248,255,255,255,243,255,255,255,249,255,255,255,254,255,255,255,250,255,255,255,248,255,255,255,248,255,255,255,5,0,0,0,250,255,255,255,247,255,255,255,251,255,255,255,255,255,255,255,252,255,255,255,5,0,0,0,243,255,255,255,7,0,0,0,248,255,255,255,10,0,0,0,1,0,0,0,5,0,0,0,5,0,0,0,243,255,255,255,1,0,0,0,0,0,0,0,10,0,0,0,243,255,255,255,9,0,0,0,12,0,0,0,10,0,0,0,255,255,255,255,5,0,0,0,248,255,255,255,10,0,0,0,247,255,255,255,255,255,255,255,11,0,0,0,1,0,0,0,243,255,255,255,247,255,255,255,253,255,255,255,250,255,255,255,2,0,0,0,255,255,255,255,246,255,255,255,1,0,0,0,12,0,0,0,243,255,255,255,1,0,0,0,248,255,255,255,246,255,255,255,8,0,0,0,245,255,255,255,10,0,0,0,250,255,255,255,2,0,0,0,243,255,255,255,3,0,0,0,250,255,255,255,7,0,0,0,243,255,255,255,12,0,0,0,247,255,255,255,246,255,255,255,246,255,255,255,251,255,255,255,249,255,255,255,246,255,255,255,248,255,255,255,248,255,255,255,243,255,255,255,4,0,0,0,250,255,255,255,8,0,0,0,5,0,0,0,3,0,0,0,12,0,0,0,8,0,0,0,243,255,255,255,252,255,255,255,2,0,0,0,253,255,255,255,253,255,255,255,5,0,0,0,243,255,255,255,10,0,0,0,244,255,255,255,4,0,0,0,243,255,255,255,5,0,0,0,255,255,255,255,247,255,255,255,9,0,0,0,252,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,3,0,0,0,247,255,255,255,244,255,255,255,1,0,0,0,250,255,255,255,1,0,0,0,3,0,0,0,2,0,0,0,4,0,0,0,248,255,255,255,246,255,255,255,246,255,255,255,246,255,255,255,9,0,0,0,8,0,0,0,243,255,255,255,12,0,0,0,12,0,0,0,248,255,255,255,244,255,255,255,250,255,255,255,251,255,255,255,2,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,10,0,0,0,6,0,0,0,11,0,0,0,248,255,255,255,6,0,0,0,8,0,0,0,8,0,0,0,244,255,255,255,249,255,255,255,10,0,0,0,250,255,255,255,5,0,0,0,253,255,255,255,247,255,255,255,253,255,255,255,9,0,0,0,255,255,255,255,243,255,255,255,255,255,255,255,5,0,0,0,253,255,255,255,249,255,255,255,253,255,255,255,4,0,0,0,248,255,255,255,254,255,255,255,248,255,255,255,3,0,0,0,4,0,0,0,2,0,0,0,12,0,0,0,12,0,0,0,2,0,0,0,251,255,255,255,3,0,0,0,11,0,0,0,6,0,0,0,247,255,255,255,11,0,0,0,243,255,255,255,3,0,0,0,255,255,255,255,7,0,0,0,12,0,0,0,11,0,0,0,255,255,255,255,12,0,0,0,4,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,6,0,0,0,4,0,0,0,245,255,255,255,4,0,0,0,12,0,0,0,2,0,0,0,252,255,255,255,2,0,0,0,1,0,0,0,246,255,255,255,250,255,255,255,248,255,255,255,1,0,0,0,243,255,255,255,7,0,0,0,245,255,255,255,1,0,0,0,243,255,255,255,12,0,0,0,245,255,255,255,243,255,255,255,6,0,0,0,0,0,0,0,11,0,0,0,243,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,4,0,0,0,243,255,255,255,3,0,0,0,247,255,255,255,254,255,255,255,247,255,255,255,8,0,0,0,250,255,255,255,253,255,255,255,243,255,255,255,250,255,255,255,248,255,255,255,254,255,255,255,5,0,0,0,247,255,255,255,8,0,0,0,10,0,0,0,2,0,0,0,7,0,0,0,3,0,0,0,247,255,255,255,255,255,255,255,250,255,255,255,255,255,255,255,255,255,255,255,9,0,0,0,5,0,0,0,11,0,0,0,254,255,255,255,11,0,0,0,253,255,255,255,12,0,0,0,248,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,255,255,255,255,4,0,0,0,0,0,0,0,10,0,0,0,3,0,0,0,250,255,255,255,4,0,0,0,5,0,0,0,243,255,255,255,0,0,0,0,246,255,255,255,5,0,0,0,5,0,0,0,8,0,0,0,12,0,0,0,11,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,250,255,255,255,7,0,0,0,252,255,255,255,8,0,0,0,244,255,255,255,246,255,255,255,4,0,0,0,246,255,255,255,9,0,0,0,7,0,0,0,3,0,0,0,12,0,0,0,4,0,0,0,9,0,0,0,249,255,255,255,10,0,0,0,254,255,255,255,7,0,0,0,0,0,0,0,12,0,0,0,254,255,255,255,255,255,255,255,250,255,255,255,0,0,0,0,245,255,255,255,0,0,0,0,176,76,0,0,118,6,0,0,119,6,0,0,120,6,0,0,21,0,0,0,121,6,0,0,0,0,0,0,224,76,0,0,122,6,0,0,123,6,0,0,124,6,0,0,21,0,0,0,125,6,0,0,0,0,0,0,208,76,0,0,99,6,0,0,126,6,0,0,37,0,0,0,242,2,0,0,243,2,0,0,7,2,0,0,6,0,0,0,244,2,0,0,100,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,96,0,0,0,39,2,0,0,40,2,0,0,41,2,0,0,245,2,0,0,42,2,0,0,246,2,0,0,43,2,0,0,247,2,0,0,44,2,0,0,7,0,0,0,7,0,0,0,248,2,0,0,45,2,0,0,249,2,0,0,46,2,0,0,250,2,0,0,47,2,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,255,255,255,255,253,255,255,255,254,255,255,255,254,255,255,255,253,255,255,255,255,255,255,255,253,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,1,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,254,255,255,255,254,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,254,255,255,255,1,0,0,0,255,255,255,255,2,0,0,0,0,0,0,0,240,76,0,0,38,0,0,0,127,6,0,0,251,2,0,0,0,0,0,0,0,77,0,0,38,0,0,0,128,6,0,0,252,2,0,0,0,0,0,0,16,77,0,0,38,0,0,0,129,6,0,0,253,2,0,0,0,0,0,0,48,77,0,0,38,0,0,0,130,6,0,0,254,2,0,0,0,0,0,0,32,77,0,0,38,0,0,0,131,6,0,0,255,2,0,0,0,0,0,0,64,77,0,0,38,0,0,0,132,6,0,0,0,3,0,0,148,155,208,60,182,145,192,60,246,122,151,60,156,20,75,60,197,0,232,59,39,219,97,59,184,92,187,58,182,145,192,60,135,195,177,60,124,213,139,60,144,119,59,60,111,42,214,59,177,125,80,59,22,245,172,58,246,122,151,60,124,213,139,60,153,254,91,60,129,119,19,60,4,120,168,59,82,1,36,59,128,13,136,58,156,20,75,60,144,119,59,60,129,119,19,60,40,179,197,59,39,219,97,59,57,223,219,58,173,101,54,58,197,0,232,59,111,42,214,59,4,120,168,59,39,219,97,59,202,2,1,59,183,47,123,58,126,95,208,57,39,219,97,59,177,125,80,59,82,1,36,59,57,223,219,58,183,47,123,58,38,135,244,57,134,219,74,57,184,92,187,58,22,245,172,58,128,13,136,58,173,101,54,58,126,95,208,57,134,219,74,57,134,70,168,56,0,0,0,0,80,77,0,0,38,0,0,0,133,6,0,0,1,3,0,0,0,0,0,0,176,77,0,0,38,0,0,0,134,6,0,0,2,3,0,0,0,0,0,0,160,77,0,0,38,0,0,0,135,6,0,0,3,3,0,0,0,0,0,0,144,77,0,0,38,0,0,0,136,6,0,0,4,3,0,0,0,0,0,0,128,77,0,0,137,6,0,0,138,6,0,0,5,3,0,0,0,0,0,0,112,77,0,0,38,0,0,0,139,6,0,0,6,3,0,0,0,0,0,0,96,77,0,0,140,6,0,0,141,6,0,0,7,3,0,0,0,0,0,0,192,77,0,0,38,0,0,0,142,6,0,0,8,3,0,0,0,0,0,0,224,77,0,0,143,6,0,0,144,6,0,0,37,0,0,0,214,2,0,0,215,2,0,0,7,2,0,0,6,0,0,0,9,3,0,0,101,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,92,0,0,0,8,2,0,0,9,2,0,0,10,2,0,0,102,0,0,0,10,3,0,0,48,2,0,0,11,3,0,0,49,2,0,0,12,3,0,0,50,2,0,0,13,3,0,0,51,2,0,0,0,0,0,0,120,218,117,60,45,46,196,60,242,29,1,61,60,13,29,61,238,237,54,61,1,78,79,61,100,132,102,61,98,203,124,61,25,38,137,61,199,146,147,61,94,183,157,61,78,157,167,61,224,75,177,61,82,201,186,61,186,26,196,61,86,68,205,61,212,73,214,61,207,46,223,61,98,245,231,61,44,160,240,61,68,49,249,61,99,213,0,62,33,7,5,62,165,46,9,62,119,76,13,62,162,97,17,62,105,110,21,62,17,115,25,62,164,112,29,62,35,103,33,62,88,87,37,62,255,64,41,62,36,37,45,62,201,3,49,62,47,221,52,62,154,177,56,62,145,129,60,62,18,77,64,62,31,20,68,62,128,215,71,62,53,151,75,62,63,83,79,62,225,11,83,62,93,193,86,62,180,115,90,62,108,35,94,62,66,208,97,62,120,122,101,62,83,34,105,62,210,199,108,62,244,106,112,62,65,12,116,62,117,171,119,62,212,72,123,62,92,228,126,62,41,63,129,62,124,11,131,62,228,214,132,62,165,161,134,62,223,107,136,62,114,53,138,62,93,254,139,62,227,198,141,62,193,142,143,62,92,86,145,62,113,29,147,62,33,228,148,62,143,170,150,62,151,112,152,62,126,54,154,62,1,252,155,62,64,193,157,62,127,134,159,62,90,75,161,62,52,16,163,62,237,212,164,62,133,153,166,62,28,94,168,62,180,34,170,62,75,231,171,62,193,171,173,62,88,112,175,62,17,53,177,62,202,249,178,62,165,190,180,62,161,131,182,62,191,72,184,62,31,14,186,62,162,211,187,62,70,153,189,62,78,95,191,62,120,37,193,62,230,235,194,62,183,178,196,62,204,121,198,62,70,65,200,62,3,9,202,62,36,209,203,62,170,153,205,62,149,98,207,62,6,44,209,62,220,245,210,62,22,192,212,62,215,138,214,62,252,85,216,62,201,33,218,62,28,238,219,62,212,186,221,62,51,136,223,62,59,86,225,62,200,36,227,62,220,243,228,62,185,195,230,62,29,148,232,62,40,101,234,62,219,54,236,62,87,9,238,62,123,220,239,62,104,176,241,62,253,132,243,62,92,90,245,62,131,48,247,62,83,7,249,62,13,223,250,62,145,183,252,62,0,145,254,62,156,53,0,63,28,35,1,63,18,17,2,63,126,255,2,63,95,238,3,63,181,221,4,63,129,205,5,63,211,189,6,63,155,174,7,63,216,159,8,63,155,145,9,63,228,131,10,63,180,118,11,63,249,105,12,63,213,93,13,63,55,82,14,63,48,71,15,63,159,60,16,63,181,50,17,63,82,41,18,63,134,32,19,63,97,24,20,63,195,16,21,63,187,9,22,63,92,3,23,63,147,253,23,63,114,248,24,63,249,243,25,63,40,240,26,63,238,236,27,63,108,234,28,63,146,232,29,63,96,231,30,63,230,230,31,63,20,231,32,63,12,232,33,63,171,233,34,63,3,236,35,63,36,239,36,63,254,242,37,63,144,247,38,63,235,252,39,63,16,3,41,63,255,9,42,63,165,17,43,63,38,26,44,63,129,35,45,63,165,45,46,63,147,56,47,63,91,68,48,63,13,81,49,63,137,94,50,63,240,108,51,63,49,124,52,63,76,140,53,63,98,157,54,63,83,175,55,63,64,194,56,63,6,214,57,63,200,234,58,63,134,0,60,63,64,23,61,63,228,46,62,63,132,71,63,63,49,97,64,63,217,123,65,63,141,151,66,63,78,180,67,63,28,210,68,63,246,240,69,63,220,16,71,63,223,49,72,63,0,84,73,63,62,119,74,63,153,155,75,63,18,193,76,63,201,231,77,63,140,15,79,63,143,56,80,63,191,98,81,63,46,142,82,63,203,186,83,63,184,232,84,63,211,23,86,63,61,72,87,63,230,121,88,63,239,172,89,63,55,225,90,63,223,22,92,63,215,77,93,63,47,134,94,63,232,191,95,63,18,251,96,63,155,55,98,63,151,117,99,63,3,181,100,63,241,245,101,63,97,56,103,63,66,124,104,63,181,193,105,63,171,8,107,63,51,81,108,63,95,155,109,63,29,231,110,63,127,52,112,63,132,131,113,63,44,212,114,63,137,38,116,63,171,122,117,63,129,208,118,63,11,40,120,63,107,129,121,63,160,220,122,63,155,57,124,63,124,152,125,63,51,249,126,63,224,45,128,63,34,224,128,63,96,147,129,63,153,71,130,63,34,253,130,63,83,179,131,63,127,106,132,63,251,34,133,63,114,220,133,63,230,150,134,63,168,82,135,63,19,15,136,63,33,205,136,63,42,140,137,63,48,76,138,63,132,13,139,63,213,207,139,63,201,147,140,63,184,88,141,63,247,30,142,63,50,230,142,63,16,175,143,63,62,121,144,63,103,68,145,63,52,17,146,63,80,223,146,63,188,174,147,63,204,127,148,63,215,81,149,63,217,37,150,63,43,251,150,63,204,209,151,63,17,170,152,63,249,131,153,63,49,95,154,63,96,60,155,63,51,27,156,63,85,251,156,63,110,221,157,63,43,193,158,63,139,166,159,63,227,141,160,63,222,118,161,63,208,97,162,63,186,78,163,63,71,61,164,63,31,46,165,63,155,32,166,63,98,21,167,63,32,12,168,63,213,4,169,63,214,255,169,63,34,253,170,63,101,252,171,63,244,253,172,63,205,1,174,63,70,8,175,63,182,16,176,63,25,28,177,63,116,41,178,63,193,57,179,63,173,76,180,63,229,97,181,63,99,122,182,63,45,149,183,63,234,178,184,63,153,211,185,63,144,247,186,63,38,30,188,63,2,72,189,63,37,117,190,63,60,165,191,63,237,216,192,63,228,15,194,63,119,74,195,63,81,136,196,63,25,202,197,63,208,15,199,63,33,89,200,63,97,166,201,63,144,247,202,63,85,77,204,63,9,167,205,63,83,5,207,63,224,103,208,63,87,207,209,63,100,59,211,63,176,172,212,63,146,34,214,63,6,158,215,63,184,30,217,63,169,164,218,63,127,48,220,63,59,194,221,63,50,90,223,63,14,248,224,63,203,156,226,63,195,71,228,63,240,249,229,63,83,179,231,63,235,115,233,63,12,60,235,63,95,12,237,63,143,228,238,63,151,197,240,63,121,175,242,63,135,162,244,63,107,159,246,63,34,166,248,63,2,183,250,63,7,211,252,63,47,250,254,63,188,150,0,64,112,182,1,64,135,220,2,64,171,9,4,64,176,61,5,64,62,121,6,64,169,188,7,64,112,8,9,64,230,92,10,64,136,186,11,64,255,33,13,64,201,147,14,64,140,16,16,64,242,152,17,64,161,45,19,64,192,207,20,64,246,127,22,64,62,63,24,64,19,15,26,64,111,240,27,64,205,228,29,64,208,237,31,64,69,13,34,64,78,69,36,64,95,152,38,64,238,8,41,64,107,154,43,64,156,80,46,64,194,47,49,64,29,61,52,64,57,127,55,64,160,253,58,64,253,193,62,64,111,216,66,64,177,80,71,64,20,63,76,64,114,191,81,64,161,248,87,64,79,35,95,64,120,151,103,64,146,232,113,64,179,41,127,64,25,226,136,64,133,177,152,64,63,85,5,67,0,0,0,0,240,77,0,0,145,6,0,0,146,6,0,0,147,6,0,0,21,0,0,0,148,6,0,0,0,0,0,0,0,78,0,0,149,6,0,0,150,6,0,0,151,6,0,0,0,0,0,0,8,78,0,0,152,6,0,0,153,6,0,0,154,6,0,0,14,3,0,0,15,3,0,0,52,2,0,0,6,0,0,0,7,0,0,0,16,3,0,0,1,0,0,0,155,6,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,24,78,0,0,152,6,0,0,156,6,0,0,154,6,0,0,14,3,0,0,15,3,0,0,52,2,0,0,6,0,0,0,7,0,0,0,16,3,0,0,53,2,0,0,155,6,0,0,180,0,0,0,97,0,0,0,1,0,0,0,0,0,0,0,40,78,0,0,157,6,0,0,158,6,0,0,159,6,0,0,21,0,0,0,160,6,0,0,0,0,0,0,56,78,0,0,161,6,0,0,162,6,0,0,163,6,0,0,17,3,0,0,18,3,0,0,52,2,0,0,6,0,0,0,7,0,0,0,19,3,0,0,54,2,0,0,164,6,0,0,181,0,0,0,98,0,0,0,2,0,0,0,0,0,0,0,72,78,0,0,165,6,0,0,166,6,0,0,167,6,0,0,21,0,0,0,168,6,0,0,0,0,0,0,88,78,0,0,169,6,0,0,170,6,0,0,171,6,0,0,21,0,0,0,172,6,0,0,0,0,0,0,120,78,0,0,173,6,0,0,174,6,0,0,175,6,0,0,21,0,0,0,176,6,0,0,157,30,7,0,213,26,7,0,164,4,0,0,3,0,0,0,23,201,17,0,220,30,7,0,230,30,7,0,0,0,0,0,104,78,0,0,177,6,0,0,178,6,0,0,179,6,0,0,21,0,0,0,180,6,0,0,157,30,7,0,213,26,7,0,205,4,0,0,3,0,0,0,23,201,17,0,220,30,7,0,230,30,7,0,0,0,0,0,136,78,0,0,181,6,0,0,182,6,0,0,183,6,0,0,21,0,0,0,184,6,0,0,56,1,1,0,211,0,2,32,138,0,3,64,81,0,4,80,39,0,5,112,22,0,6,48,13,0,7,16,10,0,8,96,9,0,173,130,172,2,173,242,172,2,11,208,172,2,12,224,172,2,173,242,172,2,14,128,172,2,15,144,172,2,16,160,17,0,173,98,172,2,18,176,172,2,19,192,172,2,20,208,172,2,21,224,172,2,173,242,172,2,23,160,172,2,24,176,172,2,25,192,35,0,26,128,31,0,27,144,28,0,173,98,172,2,29,208,172,2,30,224,172,2,173,242,172,2,32,16,172,2,33,208,172,2,34,224,172,2,173,242,172,2,36,16,172,2,37,208,172,2,38,224,172,2,173,242,65,16,40,112,56,0,41,224,172,2,42,240,50,0,43,16,46,0,44,48,45,0,173,98,172,2,173,210,172,2,47,160,172,2,48,176,172,2,49,192,172,2,173,210,172,2,51,128,172,2,52,144,172,2,53,160,172,2,54,176,172,2,55,192,172,2,173,210,172,18,57,224,172,18,58,128,172,18,59,144,172,18,60,160,172,18,61,176,172,18,62,192,172,18,63,208,64,16,173,98,172,18,173,242,172,2,66,224,172,2,67,240,75,0,68,16,71,0,69,48,70,0,173,98,172,2,173,210,172,2,72,160,172,2,73,176,172,2,74,192,172,2,173,210,172,2,76,128,172,2,77,144,172,2,78,160,172,2,79,176,172,2,80,192,172,2,173,210,110,16,82,80,100,0,83,192,172,2,84,208,172,2,85,224,94,0,86,240,90,0,87,16,88,0,173,50,172,2,89,160,172,2,173,178,172,2,91,128,172,2,92,144,172,2,93,160,172,2,173,178,172,2,95,96,172,2,96,112,172,2,97,128,172,2,98,144,172,2,99,160,172,2,173,178,172,18,101,192,172,18,102,112,172,18,103,128,172,18,104,144,172,18,105,160,172,18,106,176,172,18,107,208,108,16,173,98,172,18,109,224,172,18,173,242,128,0,111,192,172,2,112,208,172,2,113,224,122,0,114,240,118,0,115,16,116,0,173,50,172,2,117,160,172,2,173,178,172,2,119,128,172,2,120,144,172,2,121,160,172,2,173,178,172,2,123,96,172,2,124,112,172,2,125,128,172,2,126,144,172,2,127,160,172,2,173,178,172,18,129,192,172,18,130,112,172,18,131,128,172,18,132,144,172,18,133,160,172,18,134,176,172,18,135,208,172,18,136,224,137,16,173,98,172,18,173,242,177,16,139,64,161,0,140,176,172,2,141,192,172,2,142,208,157,0,143,160,152,0,144,224,148,0,145,240,146,0,173,18,172,2,147,128,172,2,173,146,172,2,149,96,172,2,150,112,172,2,151,128,172,2,173,146,172,2,153,80,172,2,154,96,172,2,155,112,172,2,156,128,172,2,173,146,172,2,158,16,172,2,159,48,172,2,160,224,172,2,173,242,172,18,162,176,172,18,163,112,172,18,164,128,172,18,165,144,172,18,166,160,173,16,167,96,170,16,168,80,169,16,173,50,172,18,173,194,172,18,171,192,172,18,172,208,172,18,173,226,172,18,174,192,172,18,175,208,172,18,176,224,172,18,173,242,199,0,178,176,172,2,179,192,172,2,180,208,195,0,181,160,190,0,182,224,186,0,183,240,184,0,173,18,172,2,185,128,172,2,173,146,172,2,187,96,172,2,188,112,172,2,189,128,172,2,173,146,172,2,191,80,172,2,192,96,172,2,193,112,172,2,194,128,172,2,173,146,172,2,196,16,172,2,197,48,172,2,198,224,172,2,173,242,172,18,200,176,172,18,201,112,172,18,202,128,172,18,203,144,172,18,204,160,172,18,205,192,172,18,206,208,209,16,207,96,208,16,173,82,172,18,173,226,172,18,210,224,172,18,173,242,10,17,212,32,239,0,213,144,172,2,214,160,172,2,215,176,234,0,216,128,229,0,217,192,225,0,218,208,222,0,219,224,220,0,173,242,172,2,221,96,172,2,173,114,172,2,223,80,172,2,224,96,172,2,173,114,172,2,226,64,172,2,227,80,172,2,228,96,172,2,173,114,172,2,230,48,172,2,231,64,172,2,232,80,172,2,233,96,172,2,173,114,172,2,235,16,172,2,236,192,172,2,237,208,172,2,238,224,172,2,173,242,172,18,240,144,172,18,241,112,172,18,242,128,4,17,243,96,255,16,244,80,251,16,245,64,248,16,246,48,247,16,173,18,172,18,173,162,172,18,249,160,172,18,250,176,172,18,173,194,172,18,252,160,172,18,253,176,172,18,254,192,172,18,173,210,172,18,0,161,172,18,1,177,172,18,2,193,172,18,3,209,172,18,173,226,172,18,5,161,172,18,6,177,172,18,7,193,172,18,8,209,172,18,9,225,172,18,173,242,37,1,11,145,172,2,12,161,172,2,13,177,32,1,14,129,27,1,15,193,23,1,16,209,20,1,17,225,18,1,173,242,172,2,19,97,172,2,173,114,172,2,21,81,172,2,22,97,172,2,173,114,172,2,24,65,172,2,25,81,172,2,26,97,172,2,173,114,172,2,28,49,172,2,29,65,172,2,30,81,172,2,31,97,172,2,173,114,172,2,33,17,172,2,34,193,172,2,35,209,172,2,36,225,172,2,173,242,172,18,38,145,172,18,39,113,172,18,40,129,172,18,41,161,172,18,42,177,52,17,43,97,49,17,44,81,47,17,45,65,46,17,173,50,172,18,173,194,172,18,48,193,172,18,173,210,172,18,50,193,172,18,51,209,172,18,173,226,172,18,53,193,172,18,54,209,172,18,55,225,172,18,173,242,112,18,57,1,112,1,58,33,85,1,59,145,172,2,60,113,172,2,61,129,79,1,62,97,74,1,63,81,70,1,64,65,67,1,65,49,66,1,173,18,172,2,173,162,172,2,68,161,172,2,69,177,172,2,173,194,172,2,71,161,172,2,72,177,172,2,73,193,172,2,173,210,172,2,75,161,172,2,76,177,172,2,77,193,172,2,78,209,172,2,173,226,172,2,80,161,172,2,81,177,172,2,82,193,172,2,83,209,172,2,84,225,172,2,173,242,172,18,86,145,172,18,87,161,172,18,88,177,107,17,89,129,102,17,90,193,98,17,91,209,95,17,92,225,93,17,173,242,172,18,94,97,172,18,173,114,172,18,96,81,172,18,97,97,172,18,173,114,172,18,99,65,172,18,100,81,172,18,101,97,172,18,173,114,172,18,103,49,172,18,104,65,172,18,105,81,172,18,106,97,172,18,173,114,172,18,108,17,172,18,109,193,172,18,110,209,172,18,111,225,172,18,173,242,66,18,113,33,152,1,114,65,130,1,115,177,172,2,116,113,172,2,117,129,172,2,118,145,172,2,119,161,126,1,120,97,123,1,121,81,122,1,173,50,172,2,173,194,172,2,124,193,172,2,125,209,172,2,173,226,172,2,127,193,172,2,128,209,172,2,129,225,172,2,173,242,172,18,131,177,172,18,132,193,172,18,133,209,148,17,134,161,143,17,135,225,139,17,136,241,137,17,173,18,172,18,138,129,172,18,173,146,172,18,140,97,172,18,141,113,172,18,142,129,172,18,173,146,172,18,144,81,172,18,145,97,172,18,146,113,172,18,147,129,172,18,173,146,172,18,149,17,172,18,150,49,172,18,151,225,172,18,173,242,32,18,153,65,182,1,154,81,164,1,155,193,172,2,156,113,172,2,157,129,172,2,158,145,172,2,159,161,172,2,160,177,172,2,161,209,162,1,173,98,172,2,163,225,172,2,173,242,172,18,165,193,172,18,166,209,172,18,167,225,176,17,168,241,172,17,169,17,170,17,173,50,172,18,171,161,172,18,173,178,172,18,173,129,172,18,174,145,172,18,175,161,172,18,173,178,172,18,177,97,172,18,178,113,172,18,179,129,172,18,180,145,172,18,181,161,172,18,173,178,4,18,183,81,209,1,184,113,193,1,185,225,172,2,186,129,172,2,187,145,172,2,188,161,172,2,189,177,172,2,190,193,172,2,191,209,192,1,173,98,172,2,173,242,172,18,194,225,172,18,195,241,203,17,196,17,199,17,197,49,198,17,173,98,172,18,173,210,172,18,200,161,172,18,201,177,172,18,202,193,172,18,173,210,172,18,204,129,172,18,205,145,172,18,206,161,172,18,207,177,172,18,208,193,172,18,173,210,244,17,210,113,227,17,211,49,218,17,212,17,215,17,213,97,214,17,173,130,172,18,173,242,172,18,216,209,172,18,217,225,172,18,173,242,172,18,219,129,172,18,220,145,172,18,221,161,222,17,173,98,172,18,223,177,172,18,224,193,172,18,225,209,172,18,226,225,172,18,173,242,172,18,228,161,172,18,229,177,172,18,230,193,240,17,231,129,236,17,232,145,233,17,173,98,172,18,234,209,172,18,235,225,172,18,173,242,172,18,237,17,172,18,238,209,172,18,239,225,172,18,173,242,172,18,241,17,172,18,242,209,172,18,243,225,172,18,173,242,172,18,245,225,172,18,246,241,254,17,247,17,250,17,248,49,249,17,173,98,172,18,173,210,172,18,251,161,172,18,252,177,172,18,253,193,172,18,173,210,172,18,255,129,172,18,0,146,172,18,1,162,172,18,2,178,172,18,3,194,172,18,173,210,14,2,5,194,172,2,6,114,172,2,7,130,172,2,8,146,172,2,9,162,172,2,10,178,172,2,11,210,172,2,12,226,13,2,173,98,172,2,173,242,172,18,15,194,172,18,16,210,172,18,17,226,26,18,18,242,22,18,19,18,20,18,173,50,172,18,21,162,172,18,173,178,172,18,23,130,172,18,24,146,172,18,25,162,172,18,173,178,172,18,27,98,172,18,28,114,172,18,29,130,172,18,30,146,172,18,31,162,172,18,173,178,44,2,33,178,172,2,34,114,172,2,35,130,172,2,36,146,172,2,37,162,172,2,38,194,172,2,39,210,42,2,40,98,41,2,173,82,172,2,173,226,172,2,43,226,172,2,173,242,172,18,45,178,172,18,46,194,172,18,47,210,62,18,48,162,57,18,49,226,53,18,50,242,51,18,173,18,172,18,52,130,172,18,173,146,172,18,54,98,172,18,55,114,172,18,56,130,172,18,173,146,172,18,58,82,172,18,59,98,172,18,60,114,172,18,61,130,172,18,173,146,172,18,63,18,172,18,64,50,172,18,65,226,172,18,173,242,85,2,67,146,172,2,68,114,172,2,69,130,172,2,70,162,172,2,71,178,81,2,72,98,78,2,73,82,76,2,74,66,75,2,173,50,172,2,173,194,172,2,77,194,172,2,173,210,172,2,79,194,172,2,80,210,172,2,173,226,172,2,82,194,172,2,83,210,172,2,84,226,172,2,173,242,172,18,86,146,172,18,87,162,172,18,88,178,107,18,89,130,102,18,90,194,98,18,91,210,95,18,92,226,93,18,173,242,172,18,94,98,172,18,173,114,172,18,96,82,172,18,97,98,172,18,173,114,172,18,99,66,172,18,100,82,172,18,101,98,172,18,173,114,172,18,103,50,172,18,104,66,172,18,105,82,172,18,106,98,172,18,173,114,172,18,108,18,172,18,109,194,172,18,110,210,172,18,111,226,172,18,173,242,142,2,113,114,172,2,114,130,172,2,115,146,136,2,116,98,131,2,117,82,127,2,118,66,124,2,119,50,122,2,120,34,121,2,173,18,172,2,173,162,172,2,123,162,172,2,173,178,172,2,125,162,172,2,126,178,172,2,173,194,172,2,128,162,172,2,129,178,172,2,130,194,172,2,173,210,172,2,132,162,172,2,133,178,172,2,134,194,172,2,135,210,172,2,173,226,172,2,137,162,172,2,138,178,172,2,139,194,172,2,140,210,172,2,141,226,172,2,173,242,172,18,143,114,172,18,144,130,172,18,145,146,166,18,146,98,161,18,147,82,157,18,148,66,154,18,149,50,152,18,150,34,151,18,173,18,172,18,173,162,172,18,153,162,172,18,173,178,172,18,155,162,172,18,156,178,172,18,173,194,172,18,158,162,172,18,159,178,172,18,160,194,172,18,173,210,172,18,162,162,172,18,163,178,172,18,164,194,172,18,165,210,172,18,173,226,172,18,167,162,172,18,168,178,172,18,169,194,172,18,170,210,172,18,171,226,172,18,173,242,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,146,0,1,0,101,0,2,32,49,0,3,80,38,0,4,144,28,0,5,112,21,0,6,16,15,0,7,96,11,0,8,48,9,0,64,65,63,1,10,160,63,1,64,177,63,1,12,128,63,1,13,160,14,0,64,65,63,1,64,177,63,1,16,176,19,0,17,48,18,0,64,65,63,1,64,161,63,1,20,128,63,1,64,161,63,1,22,96,63,1,23,128,26,0,24,64,25,0,64,49,63,1,64,161,63,1,27,160,63,1,64,177,63,1,29,16,35,0,30,176,33,0,31,48,32,0,64,65,63,1,64,161,63,1,34,128,63,1,64,161,63,1,36,96,63,1,37,48,63,1,64,65,63,1,39,48,63,1,40,64,46,0,41,112,44,0,42,16,43,0,64,97,63,1,64,177,63,1,45,96,63,1,64,129,63,1,47,16,48,0,64,97,63,1,64,177,89,16,50,112,80,16,51,144,75,16,52,80,68,0,53,16,61,0,54,64,57,0,55,160,63,1,56,48,63,1,64,177,63,17,58,96,63,17,59,128,63,17,60,176,63,17,64,161,63,17,62,96,63,17,63,128,66,16,64,160,65,16,64,65,63,17,64,177,63,17,67,48,63,17,64,65,63,17,69,96,63,17,70,128,73,16,71,64,72,16,64,49,63,17,64,161,63,17,74,160,63,17,64,177,63,1,76,16,63,1,77,48,63,1,78,64,63,1,79,160,63,1,64,177,63,1,81,160,63,1,82,176,86,0,83,144,63,1,84,16,85,0,64,49,63,1,64,129,63,1,87,16,63,1,88,48,63,1,64,65,63,1,90,160,63,1,91,176,98,0,92,144,95,0,93,16,94,0,64,49,63,1,64,129,63,1,96,96,63,1,97,128,63,1,64,113,63,1,99,16,63,1,100,48,63,1,64,65,123,0,102,112,63,1,103,144,63,1,104,128,119,0,105,80,113,0,106,16,110,0,107,160,108,0,64,177,63,1,109,96,63,1,64,65,63,1,111,96,63,1,112,48,63,1,64,65,63,1,114,96,117,0,115,64,116,0,64,49,63,1,64,161,63,1,118,160,63,1,64,177,63,1,120,160,63,1,121,176,122,0,64,17,63,1,64,97,63,17,124,112,63,17,125,80,138,16,126,32,63,17,127,96,134,16,128,64,131,16,129,48,130,16,64,17,63,17,64,129,63,17,132,144,63,17,133,128,63,17,64,161,63,17,135,144,63,17,136,128,63,17,137,160,63,17,64,177,63,17,139,144,63,17,140,96,63,17,141,128,144,16,142,64,143,16,64,49,63,17,64,161,63,17,145,160,63,17,64,177,19,17,147,0,230,16,148,32,200,16,149,176,185,16,150,48,169,16,151,80,163,16,152,144,160,16,153,112,156,16,154,16,155,16,64,65,63,17,64,161,63,17,157,96,63,17,158,128,159,16,64,65,63,17,64,161,63,17,161,16,162,16,64,65,63,17,64,161,63,17,164,64,168,16,165,112,166,16,64,17,63,17,167,96,63,17,64,129,63,17,64,17,178,16,170,160,176,16,171,144,175,16,172,112,173,16,64,17,63,17,174,96,63,17,64,129,63,17,64,17,63,17,177,16,63,17,64,65,63,1,179,112,63,1,180,144,63,1,181,80,63,1,182,64,63,1,183,96,63,1,184,128,63,1,64,161,192,16,186,144,63,17,187,128,63,17,188,160,191,16,189,112,190,16,64,17,63,17,64,97,63,17,64,17,63,1,193,80,63,1,194,112,63,1,195,144,63,1,196,64,63,1,197,96,63,1,198,128,199,0,64,49,63,1,64,161,220,16,201,64,213,16,202,80,210,16,203,112,63,17,204,96,207,16,205,48,206,16,64,17,63,17,64,129,63,17,208,144,63,17,209,128,63,17,64,161,63,17,211,16,63,17,212,96,63,17,64,49,63,1,214,112,63,1,215,144,63,1,216,80,63,1,217,96,63,1,218,128,63,1,219,160,63,1,64,177,63,1,221,80,63,1,222,112,63,1,223,144,63,1,224,96,63,1,225,128,228,0,226,160,227,0,64,65,61,1,64,177,63,1,229,48,63,1,64,65,253,0,231,112,63,1,232,80,245,0,233,32,63,1,234,96,241,0,235,64,238,0,236,48,237,0,64,17,63,1,64,129,63,1,239,144,63,1,240,128,63,1,64,161,63,1,242,144,63,1,243,128,63,1,244,160,63,1,64,177,63,1,246,144,63,1,247,96,63,1,248,128,251,0,249,64,250,0,64,49,63,1,64,161,63,1,252,160,63,1,64,177,63,17,254,112,63,17,255,144,63,17,0,129,15,17,1,81,9,17,2,17,6,17,3,161,4,17,64,177,63,17,5,97,63,17,64,65,63,17,7,97,63,17,8,49,63,17,64,65,63,17,10,97,13,17,11,65,12,17,64,49,63,17,64,161,63,17,14,161,63,17,64,177,63,17,16,161,63,17,17,177,18,17,64,17,63,17,64,97,40,1,20,81,63,1,21,113,33,1,22,145,63,1,23,97,30,1,24,65,28,1,25,49,26,1,64,129,63,1,27,17,63,1,64,33,63,1,29,129,63,1,64,161,63,1,31,177,63,1,32,129,63,1,64,161,63,1,34,33,63,1,35,49,63,1,36,65,38,1,37,17,63,1,64,97,63,1,39,97,63,1,64,129,61,17,41,81,63,17,42,113,54,17,43,145,63,17,44,97,51,17,45,65,49,17,46,49,47,17,64,129,63,17,48,17,63,17,64,33,63,17,50,129,63,17,64,161,63,17,52,177,63,17,53,129,63,17,64,161,63,17,55,33,63,17,56,49,63,17,57,65,59,17,58,17,63,17,64,97,63,17,60,97,63,17,64,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,181,0,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+112644);allocate([54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,137,65,136,1,9,160,136,1,137,177,136,1,11,128,136,1,12,160,13,0,137,177,136,1,14,64,136,1,137,113,136,1,16,176,19,0,17,48,18,0,137,65,136,1,137,161,136,1,20,128,136,1,137,161,136,1,22,96,136,1,23,112,136,1,24,128,27,0,25,64,26,0,137,49,136,1,137,161,136,1,28,160,136,1,137,177,136,1,30,48,136,1,31,64,34,0,32,16,33,0,137,97,136,1,137,177,136,1,35,96,136,1,36,112,136,1,137,129,136,1,38,144,136,1,39,112,136,1,40,128,48,0,41,16,45,0,42,160,43,0,137,177,136,1,44,96,136,1,137,65,136,1,46,96,136,1,47,48,136,1,137,65,136,1,49,96,52,0,50,64,51,0,137,49,136,1,137,161,136,1,53,160,136,1,137,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,136,1,62,160,63,0,137,33,136,1,137,113,136,17,65,96,136,17,66,32,136,17,67,112,136,17,137,129,72,0,69,96,136,1,70,112,136,1,71,128,136,1,137,161,136,17,73,96,136,17,74,32,136,17,75,112,76,16,137,17,136,17,137,129,136,17,78,32,136,17,79,112,81,16,80,16,136,17,137,97,136,17,82,96,136,17,137,129,136,1,84,176,136,1,85,128,136,1,86,160,89,0,87,16,88,0,137,33,136,1,137,113,136,1,90,96,136,1,137,113,136,1,92,176,136,1,93,160,101,0,94,48,98,0,95,16,96,0,137,33,136,1,97,112,136,1,137,129,136,1,99,96,136,1,100,112,136,1,137,129,136,1,102,128,105,0,103,16,104,0,137,33,136,1,137,113,136,1,106,96,136,1,137,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,136,1,113,48,136,1,137,177,136,17,115,96,136,17,116,112,136,17,117,128,136,17,118,176,136,17,137,161,136,17,120,96,136,17,121,112,136,17,122,128,125,16,123,160,124,16,137,65,136,17,137,177,136,17,126,48,136,17,137,65,136,17,128,96,136,17,129,112,136,17,130,128,133,16,131,64,132,16,137,49,136,17,137,161,136,17,134,160,136,17,137,177,136,17,136,96,136,17,137,112,143,16,138,128,141,16,139,64,140,16,137,49,136,17,137,161,136,17,142,160,136,17,137,177,136,17,144,32,136,17,145,16,136,17,146,48,136,17,137,65,153,0,148,32,136,1,149,16,136,1,150,48,136,1,151,64,136,1,152,160,136,1,137,177,134,17,154,32,136,17,155,48,136,17,156,64,136,17,157,112,159,16,158,16,136,17,137,97,136,17,160,96,136,17,137,129,174,0,162,32,136,1,163,160,136,1,164,176,171,0,165,144,168,0,166,16,167,0,137,49,136,1,137,129,136,1,169,96,136,1,170,112,136,1,137,129,136,1,172,16,136,1,173,48,136,1,137,65,136,1,175,144,136,1,176,112,136,1,177,128,136,1,178,160,136,1,179,176,180,0,137,17,136,1,137,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,136,1,186,96,193,0,187,64,190,0,188,48,189,0,137,17,136,1,137,129,136,1,191,144,136,1,192,128,136,1,137,161,136,1,194,144,136,1,195,128,136,1,196,160,136,1,137,177,136,17,198,144,136,17,199,128,136,17,200,160,136,17,201,176,136,17,202,112,203,16,137,17,136,17,137,97,136,17,205,144,136,17,206,112,136,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,137,177,136,17,212,96,136,17,137,65,136,17,214,96,136,17,215,48,136,17,137,65,136,17,217,96,220,16,218,64,219,16,137,49,136,17,137,161,136,17,221,160,136,17,137,177,136,17,223,160,136,17,224,176,225,16,137,17,136,17,137,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,136,17,233,48,136,17,137,177,136,1,235,96,136,1,236,112,136,1,237,128,136,1,238,176,136,1,137,161,136,1,240,96,136,1,241,112,136,1,242,128,245,0,243,160,244,0,137,65,136,1,137,177,136,1,246,48,136,1,137,65,136,1,248,96,136,1,249,112,136,1,250,128,253,0,251,64,252,0,137,49,136,1,137,161,136,1,254,160,136,1,137,177,136,17,0,49,136,17,1,65,8,17,2,81,5,17,3,17,4,17,137,97,136,17,137,177,136,17,6,97,136,17,7,113,136,17,137,129,136,17,9,17,136,17,10,161,136,17,137,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,137,65,136,17,18,161,136,17,137,177,136,17,20,129,136,17,21,161,22,17,137,177,136,17,23,65,136,17,137,113,136,17,25,177,28,17,26,49,27,17,137,65,136,17,137,161,136,17,29,129,136,17,137,161,136,17,31,97,136,17,32,113,136,17,33,129,36,17,34,65,35,17,137,49,136,17,137,161,136,17,37,161,136,17,137,177,136,17,39,161,136,17,40,177,43,17,41,17,42,17,137,49,136,17,137,129,136,17,44,97,136,17,45,113,136,17,137,129,136,17,47,49,136,17,48,65,55,17,49,81,52,17,50,17,51,17,137,97,136,17,137,177,136,17,53,97,136,17,54,113,136,17,137,129,136,17,56,17,136,17,57,161,136,17,137,177,80,17,59,145,136,17,60,113,136,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,137,177,136,17,66,97,136,17,137,65,136,17,68,97,136,17,69,49,136,17,137,65,136,17,71,97,74,17,72,65,73,17,137,49,136,17,137,161,136,17,75,161,136,17,137,177,136,17,77,161,136,17,78,177,79,17,137,17,136,17,137,97,136,1,81,81,134,1,82,145,136,1,83,97,136,1,84,113,136,1,85,129,88,1,86,65,87,1,137,49,136,1,137,161,136,1,89,161,136,1,137,177,112,1,91,81,104,1,92,145,136,1,93,97,136,1,94,113,101,1,95,65,99,1,96,49,97,1,137,129,136,1,98,17,136,1,137,33,136,1,100,129,136,1,137,161,136,1,102,177,136,1,103,129,136,1,137,161,136,1,105,33,136,1,106,49,136,1,107,65,136,1,108,113,110,1,109,17,136,1,137,97,136,1,111,97,136,1,137,129,134,17,113,81,126,17,114,145,136,17,115,97,136,17,116,113,123,17,117,65,121,17,118,49,119,17,137,129,136,17,120,17,136,17,137,33,136,17,122,129,136,17,137,161,136,17,124,177,136,17,125,129,136,17,137,161,136,17,127,33,136,17,128,49,136,17,129,65,136,17,130,113,132,17,131,17,136,17,137,97,136,17,133,97,136,17,137,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,42,0,1,0,27,0,2,32,16,0,3,48,12,0,4,80,8,0,5,112,6,0,115,16,114,0,7,64,114,0,115,96,10,0,9,16,114,0,115,64,114,0,11,64,114,0,115,96,14,0,13,112,114,0,115,16,114,0,15,16,114,0,115,64,22,0,17,112,114,0,18,96,21,0,19,80,20,0,115,16,114,0,115,64,114,0,115,16,114,16,23,80,112,16,24,48,112,16,25,112,114,16,26,64,114,16,115,96,32,0,28,80,114,0,29,112,114,0,30,96,31,0,115,16,114,0,115,64,112,16,33,80,114,16,34,48,39,16,35,32,37,16,36,16,114,16,115,64,114,16,38,64,114,16,115,96,112,16,40,112,112,16,41,64,112,16,113,96,92,16,43,0,77,16,44,32,57,0,45,112,53,16,46,48,51,16,47,80,49,16,48,16,114,16,115,64,114,16,50,64,114,16,115,96,114,16,52,16,114,16,115,64,114,0,54,80,112,0,55,48,114,0,56,64,114,0,115,96,69,16,58,112,64,16,59,48,63,16,60,80,61,16,115,16,114,16,62,64,114,16,115,96,114,16,115,16,114,16,65,96,68,16,66,80,67,16,115,16,114,16,115,64,114,16,115,16,112,16,70,48,75,16,71,80,73,16,72,16,112,16,113,64,112,16,74,64,112,16,113,96,112,16,76,16,112,16,113,64,87,0,78,80,114,0,79,48,84,0,80,32,82,0,81,16,114,0,115,64,114,0,83,64,114,0,115,96,112,0,85,112,112,0,86,64,112,0,113,96,112,16,88,80,114,16,89,112,114,16,90,96,91,16,115,16,114,16,115,64,102,0,93,48,112,0,94,80,99,0,95,32,97,0,96,16,112,0,113,64,112,0,98,64,112,0,113,96,112,0,100,112,112,0,101,64,112,0,113,96,112,16,103,48,112,16,104,80,109,16,105,32,107,16,106,16,112,16,113,64,112,16,108,64,112,16,113,96,112,16,110,112,112,16,111,64,112,16,113,96,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,145,0,1,0,100,0,2,32,49,0,3,80,38,0,4,144,28,0,5,112,21,0,6,16,15,0,7,96,11,0,8,48,9,0,89,65,86,1,10,160,88,1,89,177,86,1,12,128,86,1,13,160,14,0,89,65,88,1,89,177,86,1,16,176,19,0,17,48,18,0,89,65,86,1,89,161,86,1,20,128,86,1,89,161,86,1,22,96,86,1,23,128,26,0,24,64,25,0,89,49,86,1,89,161,86,1,27,160,86,1,89,177,86,1,29,16,35,0,30,176,33,0,31,48,32,0,87,65,86,1,87,161,86,1,34,128,86,1,87,161,86,1,36,96,86,1,37,48,86,1,87,65,86,1,39,48,86,1,40,64,46,0,41,112,44,0,42,16,43,0,87,97,86,1,87,177,86,1,45,96,86,1,87,129,86,1,47,16,48,0,87,97,86,1,87,177,85,16,50,144,80,16,51,112,75,16,52,80,68,0,53,16,61,0,54,64,57,0,55,160,86,1,56,48,88,1,89,177,86,17,58,96,86,17,59,128,88,17,60,176,88,17,89,161,86,17,62,96,86,17,63,128,66,16,64,160,65,16,89,65,88,17,89,177,86,17,67,48,88,17,89,65,86,17,69,96,86,17,70,128,73,16,71,64,72,16,89,49,86,17,89,161,86,17,74,160,86,17,89,177,86,1,76,16,86,1,77,48,86,1,78,64,86,1,79,160,86,1,89,177,86,1,81,16,86,1,82,48,86,1,83,64,86,1,84,160,86,1,87,177,86,1,86,160,86,1,87,176,97,0,88,144,94,0,89,112,92,0,90,16,91,0,87,49,86,1,87,129,86,1,93,96,86,1,87,129,86,1,95,16,96,0,87,49,86,1,87,129,86,1,98,16,86,1,99,48,86,1,87,65,122,0,101,112,86,1,102,144,86,1,103,128,118,0,104,80,112,0,105,16,109,0,106,160,107,0,87,177,86,1,108,96,86,1,89,65,86,1,110,96,86,1,111,48,86,1,89,65,86,1,113,96,116,0,114,64,115,0,87,49,86,1,87,161,86,1,117,160,86,1,87,177,86,1,119,160,86,1,120,176,121,0,87,17,86,1,87,97,86,17,123,112,86,17,124,80,137,16,125,32,86,17,126,96,133,16,127,64,130,16,128,48,129,16,87,17,86,17,87,129,86,17,131,144,86,17,132,128,86,17,89,161,86,17,134,144,86,17,135,128,86,17,136,160,86,17,89,177,86,17,138,144,86,17,139,96,86,17,140,128,143,16,141,64,142,16,87,49,86,17,87,161,86,17,144,160,86,17,87,177,44,17,146,0,255,16,147,32,194,16,148,144,183,16,149,80,173,16,150,112,166,16,151,16,160,16,152,96,156,16,153,48,154,16,89,65,86,17,155,160,88,17,89,177,86,17,157,128,86,17,158,160,159,16,89,65,88,17,89,177,86,17,161,176,164,16,162,48,163,16,89,65,86,17,89,161,86,17,165,128,86,17,89,161,86,17,167,96,86,17,168,128,171,16,169,64,170,16,89,49,86,17,89,161,86,17,172,160,86,17,89,177,86,17,174,16,180,16,175,176,178,16,176,48,177,16,87,65,86,17,87,161,86,17,179,128,86,17,87,161,86,17,181,96,86,17,182,48,86,17,87,65,86,17,184,160,86,17,185,176,191,16,186,112,189,16,187,16,188,16,87,49,86,17,87,129,86,17,190,96,86,17,87,129,86,17,192,16,193,16,87,49,86,17,87,129,240,0,195,144,225,0,196,80,220,0,197,112,213,16,198,16,206,16,199,64,202,16,200,160,86,17,201,48,88,17,89,177,86,1,203,96,86,1,204,128,88,1,205,176,88,1,89,161,86,1,207,96,86,1,208,128,211,0,209,160,210,0,89,65,88,1,89,177,86,1,212,48,88,1,89,65,86,1,214,96,86,1,215,128,218,0,216,64,217,0,89,49,86,1,89,161,86,1,219,160,86,1,89,177,86,17,221,16,86,17,222,48,86,17,223,64,86,17,224,160,86,17,89,177,86,17,226,48,86,17,227,64,237,16,228,80,234,16,229,112,232,16,230,16,231,16,89,97,86,17,89,177,86,17,233,96,86,17,89,129,86,17,235,16,236,16,87,97,86,17,87,177,86,17,238,16,86,17,239,160,86,17,87,177,86,17,241,48,86,17,242,64,252,16,243,80,249,16,244,112,247,16,245,16,246,16,87,97,86,17,87,177,86,17,248,96,86,17,87,129,86,17,250,16,251,16,87,97,86,17,87,177,86,17,253,16,86,17,254,160,86,17,87,177,22,1,0,113,86,1,1,81,14,1,2,33,86,1,3,97,10,1,4,65,7,1,5,49,6,1,87,17,86,1,87,129,86,1,8,145,86,1,9,129,86,1,89,161,86,1,11,145,86,1,12,129,86,1,13,161,86,1,89,177,86,1,15,145,86,1,16,97,86,1,17,129,20,1,18,65,19,1,87,49,86,1,87,161,86,1,21,161,86,1,87,177,86,17,23,113,86,17,24,145,86,17,25,129,40,17,26,81,34,17,27,17,31,17,28,161,29,17,87,177,86,17,30,97,86,17,89,65,86,17,32,97,86,17,33,49,86,17,89,65,86,17,35,97,38,17,36,65,37,17,87,49,86,17,87,161,86,17,39,161,86,17,87,177,86,17,41,161,86,17,42,177,43,17,87,17,86,17,87,97,65,1,45,81,86,1,46,113,58,1,47,145,86,1,48,97,55,1,49,65,53,1,50,49,51,1,87,129,86,1,52,17,86,1,87,33,86,1,54,129,86,1,87,161,86,1,56,177,86,1,57,129,86,1,87,161,86,1,59,33,86,1,60,49,86,1,61,65,63,1,62,17,86,1,87,97,86,1,64,97,86,1,87,129,86,17,66,81,86,17,67,113,79,17,68,145,86,17,69,97,76,17,70,65,74,17,71,49,72,17,87,129,86,17,73,17,86,17,87,33,86,17,75,129,86,17,87,161,86,17,77,177,86,17,78,129,86,17,87,161,86,17,80,33,86,17,81,49,86,17,82,65,84,17,83,17,86,17,87,97,86,17,85,97,86,17,87,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,135,65,134,1,9,160,134,1,137,177,134,1,11,128,134,1,12,160,13,0,137,177,134,1,14,64,136,1,137,113,134,1,16,176,19,0,17,48,18,0,135,65,134,1,135,161,134,1,20,128,134,1,135,161,134,1,22,96,134,1,23,112,134,1,24,128,27,0,25,64,26,0,137,49,134,1,137,161,134,1,28,160,134,1,137,177,134,1,30,48,134,1,31,64,34,0,32,16,33,0,135,97,134,1,135,177,134,1,35,96,134,1,36,112,134,1,135,129,134,1,38,144,134,1,39,112,134,1,40,128,48,0,41,16,45,0,42,160,43,0,135,177,134,1,44,96,134,1,137,65,134,1,46,96,134,1,47,48,134,1,137,65,134,1,49,96,52,0,50,64,51,0,135,49,134,1,135,161,134,1,53,160,134,1,135,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,134,1,62,160,63,0,137,33,136,1,137,113,134,17,65,96,134,17,66,32,136,17,67,112,136,17,137,129,72,0,69,96,134,1,70,112,134,1,71,128,136,1,137,161,134,17,73,96,134,17,74,32,134,17,75,112,76,16,137,17,136,17,137,129,134,17,78,32,134,17,79,112,81,16,80,16,134,17,137,97,134,17,82,96,134,17,137,129,134,1,84,176,134,1,85,128,134,1,86,160,89,0,87,16,88,0,137,33,134,1,137,113,134,1,90,96,134,1,137,113,134,1,92,176,134,1,93,160,101,0,94,48,98,0,95,16,96,0,135,33,134,1,97,112,134,1,137,129,134,1,99,96,134,1,100,112,134,1,137,129,134,1,102,128,105,0,103,16,104,0,135,33,134,1,135,113,134,1,106,96,134,1,135,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,134,1,113,48,134,1,137,177,134,17,115,96,134,17,116,112,134,17,117,128,136,17,118,176,136,17,137,161,134,17,120,96,134,17,121,112,134,17,122,128,125,16,123,160,124,16,137,65,136,17,137,177,134,17,126,48,136,17,137,65,134,17,128,96,134,17,129,112,134,17,130,128,133,16,131,64,132,16,137,49,134,17,137,161,134,17,134,160,134,17,137,177,134,17,136,96,134,17,137,112,143,16,138,128,141,16,139,64,140,16,135,49,134,17,135,161,134,17,142,160,134,17,135,177,134,17,144,32,134,17,145,16,134,17,146,48,134,17,137,65,153,0,148,32,134,1,149,16,134,1,150,48,134,1,151,64,134,1,152,160,134,1,135,177,134,17,154,32,134,17,155,48,134,17,156,64,134,17,157,112,159,16,158,16,134,17,135,97,134,17,160,96,134,17,135,129,174,0,162,32,134,1,163,160,134,1,164,176,171,0,165,144,168,0,166,16,167,0,135,49,134,1,135,129,134,1,169,96,134,1,170,112,134,1,135,129,134,1,172,16,134,1,173,48,134,1,135,65,134,1,175,144,134,1,176,112,134,1,177,128,134,1,178,160,134,1,179,176,180,0,135,17,134,1,135,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,134,1,186,96,193,0,187,64,190,0,188,48,189,0,135,17,134,1,135,129,134,1,191,144,134,1,192,128,134,1,137,161,134,1,194,144,134,1,195,128,134,1,196,160,134,1,137,177,134,17,198,144,134,17,199,128,134,17,200,160,134,17,201,176,134,17,202,112,203,16,137,17,134,17,137,97,134,17,205,144,134,17,206,112,134,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,137,177,134,17,212,96,136,17,137,65,134,17,214,96,134,17,215,48,136,17,137,65,134,17,217,96,220,16,218,64,219,16,137,49,134,17,137,161,134,17,221,160,134,17,137,177,134,17,223,160,134,17,224,176,225,16,135,17,134,17,135,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,134,17,233,48,134,17,137,177,134,1,235,96,134,1,236,112,134,1,237,128,136,1,238,176,136,1,137,161,134,1,240,96,134,1,241,112,134,1,242,128,245,0,243,160,244,0,137,65,136,1,137,177,134,1,246,48,136,1,137,65,134,1,248,96,134,1,249,112,134,1,250,128,253,0,251,64,252,0,137,49,134,1,137,161,134,1,254,160,134,1,137,177,134,17,0,49,134,17,1,65,8,17,2,81,5,17,3,17,4,17,135,97,134,17,135,177,134,17,6,97,134,17,7,113,134,17,137,129,134,17,9,17,134,17,10,161,134,17,135,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,135,65,134,17,18,161,134,17,137,177,134,17,20,129,134,17,21,161,22,17,137,177,134,17,23,65,136,17,137,113,134,17,25,177,28,17,26,49,27,17,135,65,134,17,135,161,134,17,29,129,134,17,135,161,134,17,31,97,134,17,32,113,134,17,33,129,36,17,34,65,35,17,137,49,134,17,137,161,134,17,37,161,134,17,137,177,134,17,39,161,134,17,40,177,43,17,41,17,42,17,135,49,134,17,135,129,134,17,44,97,134,17,45,113,134,17,135,129,134,17,47,49,134,17,48,65,55,17,49,81,52,17,50,17,51,17,135,97,134,17,135,177,134,17,53,97,134,17,54,113,134,17,135,129,134,17,56,17,134,17,57,161,134,17,135,177,80,17,59,145,134,17,60,113,134,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,135,177,134,17,66,97,134,17,137,65,134,17,68,97,134,17,69,49,134,17,137,65,134,17,71,97,74,17,72,65,73,17,135,49,134,17,135,161,134,17,75,161,134,17,135,177,134,17,77,161,134,17,78,177,79,17,135,17,134,17,135,97,134,1,81,81,134,1,82,145,134,1,83,97,134,1,84,113,134,1,85,129,88,1,86,65,87,1,135,49,134,1,135,161,134,1,89,161,134,1,135,177,112,1,91,81,104,1,92,145,134,1,93,97,134,1,94,113,101,1,95,65,99,1,96,49,97,1,135,129,134,1,98,17,134,1,135,33,134,1,100,129,134,1,135,161,134,1,102,177,134,1,103,129,134,1,135,161,134,1,105,33,134,1,106,49,134,1,107,65,134,1,108,113,110,1,109,17,134,1,135,97,134,1,111,97,134,1,135,129,134,17,113,81,126,17,114,145,134,17,115,97,134,17,116,113,123,17,117,65,121,17,118,49,119,17,135,129,134,17,120,17,134,17,135,33,134,17,122,129,134,17,135,161,134,17,124,177,134,17,125,129,134,17,135,161,134,17,127,33,134,17,128,49,134,17,129,65,134,17,130,113,132,17,131,17,134,17,135,97,134,17,133,97,134,17,135,129,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,38,0,1,0,23,0,2,32,12,0,3,48,9,0,4,80,7,0,5,16,6,0,111,64,108,0,111,112,108,0,8,64,108,0,111,96,108,0,10,16,11,0,109,64,108,0,109,112,18,0,13,112,108,0,14,96,17,0,15,80,16,0,111,16,108,0,111,64,108,0,109,16,108,16,19,80,108,16,20,48,108,16,21,112,108,16,22,64,110,16,111,96,28,0,24,80,108,0,25,112,108,0,26,96,27,0,109,16,108,0,109,64,108,16,29,80,108,16,30,48,35,16,31,32,33,16,32,16,108,16,111,64,108,16,34,64,108,16,111,96,108,16,36,112,108,16,37,64,108,16,111,96,88,16,39,0,73,16,40,32,53,0,41,112,49,16,42,48,47,16,43,80,45,16,44,16,110,16,111,64,108,16,46,64,110,16,111,96,108,16,48,16,108,16,111,64,108,0,50,80,108,0,51,48,108,0,52,64,110,0,111,96,65,16,54,112,60,16,55,48,59,16,56,80,57,16,111,16,108,16,58,64,110,16,111,96,108,16,109,16,108,16,61,96,64,16,62,80,63,16,111,16,108,16,111,64,108,16,109,16,108,16,66,48,71,16,67,80,69,16,68,16,108,16,111,64,108,16,70,64,108,16,111,96,108,16,72,16,108,16,109,64,83,0,74,80,108,0,75,48,80,0,76,32,78,0,77,16,108,0,111,64,108,0,79,64,108,0,111,96,108,0,81,112,108,0,82,64,108,0,111,96,108,16,84,80,108,16,85,112,108,16,86,96,87,16,109,16,108,16,109,64,98,0,89,48,108,0,90,80,95,0,91,32,93,0,92,16,108,0,109,64,108,0,94,64,108,0,109,96,108,0,96,112,108,0,97,64,108,0,109,96,108,16,99,48,108,16,100,80,105,16,101,32,103,16,102,16,108,16,109,64,108,16,104,64,108,16,109,96,108,16,106,112,108,16,107,64,108,16,109,96,252,0,0,0,253,0,0,0,254,0,0,0,255,0,0,0,0,0,0,0,184,78,0,0,185,6,0,0,186,6,0,0,187,6,0,0,21,0,0,0,188,6,0,0,0,0,0,0,168,78,0,0,99,6,0,0,189,6,0,0,37,0,0,0,214,2,0,0,215,2,0,0,7,2,0,0,6,0,0,0,20,3,0,0,103,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,92,0,0,0,8,2,0,0,9,2,0,0,10,2,0,0,21,3,0,0,55,2,0,0,22,3,0,0,56,2,0,0,23,3,0,0,57,2,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,253,255,255,255,255,255,255,255,254,255,255,255,254,255,255,255,255,255,255,255,253,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,253,255,255,255,2,0,0,0,254,255,255,255,3,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,3,0,0,0,254,255,255,255,2,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,254,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,2,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,253,255,255,255,0,0,0,0,254,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,0,0,0,0,253,255,255,255,1,0,0,0,254,255,255,255,2,0,0,0,255,255,255,255,3,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,3,0,0,0,255,255,255,255,2,0,0,0,254,255,255,255,1,0,0,0,38,0,1,0,23,0,2,32,12,0,3,48,9,0,4,80,7,0,5,16,6,0,109,64,108,0,109,112,108,0,8,64,108,0,109,96,108,0,10,16,11,0,109,64,108,0,109,112,18,0,13,112,108,0,14,96,17,0,15,80,16,0,109,16,108,0,109,64,108,0,109,16,108,16,19,80,108,16,20,48,108,16,21,112,108,16,22,64,108,16,109,96,28,0,24,80,108,0,25,112,108,0,26,96,27,0,109,16,108,0,109,64,108,16,29,80,108,16,30,48,35,16,31,32,33,16,32,16,108,16,109,64,108,16,34,64,108,16,109,96,108,16,36,112,108,16,37,64,108,16,109,96,88,16,39,0,73,16,40,32,53,0,41,112,49,16,42,48,47,16,43,80,45,16,44,16,108,16,109,64,108,16,46,64,108,16,109,96,108,16,48,16,108,16,109,64,108,0,50,80,108,0,51,48,108,0,52,64,108,0,109,96,65,16,54,112,60,16,55,48,59,16,56,80,57,16,109,16,108,16,58,64,108,16,109,96,108,16,109,16,108,16,61,96,64,16,62,80,63,16,109,16,108,16,109,64,108,16,109,16,108,16,66,48,71,16,67,80,69,16,68,16,108,16,109,64,108,16,70,64,108,16,109,96,108,16,72,16,108,16,109,64,83,0,74,80,108,0,75,48,80,0,76,32,78,0,77,16,108,0,109,64,108,0,79,64,108,0,109,96,108,0,81,112,108,0,82,64,108,0,109,96,108,16,84,80,108,16,85,112,108,16,86,96,87,16,109,16,108,16,109,64,98,0,89,48,108,0,90,80,95,0,91,32,93,0,92,16,108,0,109,64,108,0,94,64,108,0,109,96,108,0,96,112,108,0,97,64,108,0,109,96,108,16,99,48,108,16,100,80,105,16,101,32,103,16,102,16,108,16,109,64,108,16,104,64,108,16,109,96,108,16,106,112,108,16,107,64,108,16,109,96,254,0,0,0,255,0,0,0,181,0,1,0,54,0,2,80,37,0,3,32,29,0,4,144,21,0,5,16,15,0,6,96,10,0,7,48,8,0,135,65,134,1,9,160,134,1,135,177,134,1,11,128,134,1,12,160,13,0,135,177,134,1,14,64,134,1,135,113,134,1,16,176,19,0,17,48,18,0,135,65,134,1,135,161,134,1,20,128,134,1,135,161,134,1,22,96,134,1,23,112,134,1,24,128,27,0,25,64,26,0,135,49,134,1,135,161,134,1,28,160,134,1,135,177,134,1,30,48,134,1,31,64,34,0,32,16,33,0,135,97,134,1,135,177,134,1,35,96,134,1,36,112,134,1,135,129,134,1,38,144,134,1,39,112,134,1,40,128,48,0,41,16,45,0,42,160,43,0,135,177,134,1,44,96,134,1,135,65,134,1,46,96,134,1,47,48,134,1,135,65,134,1,49,96,52,0,50,64,51,0,135,49,134,1,135,161,134,1,53,160,134,1,135,177,161,16,55,80,107,0,56,144,91,16,57,48,83,16,58,64,77,0,59,176,68,0,60,16,64,0,61,128,134,1,62,160,63,0,135,33,134,1,135,113,134,17,65,96,134,17,66,32,134,17,67,112,134,17,135,129,72,0,69,96,134,1,70,112,134,1,71,128,134,1,135,161,134,17,73,96,134,17,74,32,134,17,75,112,76,16,135,17,134,17,135,129,134,17,78,32,134,17,79,112,81,16,80,16,134,17,135,97,134,17,82,96,134,17,135,129,134,1,84,176,134,1,85,128,134,1,86,160,89,0,87,16,88,0,135,33,134,1,135,113,134,1,90,96,134,1,135,113,134,1,92,176,134,1,93,160,101,0,94,48,98,0,95,16,96,0,135,33,134,1,97,112,134,1,135,129,134,1,99,96,134,1,100,112,134,1,135,129,134,1,102,128,105,0,103,16,104,0,135,33,134,1,135,113,134,1,106,96,134,1,135,113,147,16,108,144,135,0,109,32,127,0,110,16,119,0,111,64,114,0,112,160,134,1,113,48,134,1,135,177,134,17,115,96,134,17,116,112,134,17,117,128,134,17,118,176,134,17,135,161,134,17,120,96,134,17,121,112,134,17,122,128,125,16,123,160,124,16,135,65,134,17,135,177,134,17,126,48,134,17,135,65,134,17,128,96,134,17,129,112,134,17,130,128,133,16,131,64,132,16,135,49,134,17,135,161,134,17,134,160,134,17,135,177,134,17,136,96,134,17,137,112,143,16,138,128,141,16,139,64,140,16,135,49,134,17,135,161,134,17,142,160,134,17,135,177,134,17,144,32,134,17,145,16,134,17,146,48,134,17,135,65,153,0,148,32,134,1,149,16,134,1,150,48,134,1,151,64,134,1,152,160,134,1,135,177,134,17,154,32,134,17,155,48,134,17,156,64,134,17,157,112,159,16,158,16,134,17,135,97,134,17,160,96,134,17,135,129,174,0,162,32,134,1,163,160,134,1,164,176,171,0,165,144,168,0,166,16,167,0,135,49,134,1,135,129,134,1,169,96,134,1,170,112,134,1,135,129,134,1,172,16,134,1,173,48,134,1,135,65,134,1,175,144,134,1,176,112,134,1,177,128,134,1,178,160,134,1,179,176,180,0,135,17,134,1,135,97,90,17,182,0,226,0,183,32,204,0,184,80,197,0,185,112,134,1,186,96,193,0,187,64,190,0,188,48,189,0,135,17,134,1,135,129,134,1,191,144,134,1,192,128,134,1,135,161,134,1,194,144,134,1,195,128,134,1,196,160,134,1,135,177,134,17,198,144,134,17,199,128,134,17,200,160,134,17,201,176,134,17,202,112,203,16,135,17,134,17,135,97,134,17,205,144,134,17,206,112,134,17,207,128,222,16,208,80,216,16,209,16,213,16,210,160,211,16,135,177,134,17,212,96,134,17,135,65,134,17,214,96,134,17,215,48,134,17,135,65,134,17,217,96,220,16,218,64,219,16,135,49,134,17,135,161,134,17,221,160,134,17,135,177,134,17,223,160,134,17,224,176,225,16,135,17,134,17,135,97,58,17,227,32,11,1,228,144,255,0,229,80,247,16,230,16,239,16,231,64,234,16,232,160,134,17,233,48,134,17,135,177,134,1,235,96,134,1,236,112,134,1,237,128,134,1,238,176,134,1,135,161,134,1,240,96,134,1,241,112,134,1,242,128,245,0,243,160,244,0,135,65,134,1,135,177,134,1,246,48,134,1,135,65,134,1,248,96,134,1,249,112,134,1,250,128,253,0,251,64,252,0,135,49,134,1,135,161,134,1,254,160,134,1,135,177,134,17,0,49,134,17,1,65,8,17,2,81,5,17,3,17,4,17,135,97,134,17,135,177,134,17,6,97,134,17,7,113,134,17,135,129,134,17,9,17,134,17,10,161,134,17,135,177,46,17,12,145,38,17,13,81,30,17,14,17,24,17,15,97,19,17,16,49,17,17,135,65,134,17,18,161,134,17,135,177,134,17,20,129,134,17,21,161,22,17,135,177,134,17,23,65,134,17,135,113,134,17,25,177,28,17,26,49,27,17,135,65,134,17,135,161,134,17,29,129,134,17,135,161,134,17,31,97,134,17,32,113,134,17,33,129,36,17,34,65,35,17,135,49,134,17,135,161,134,17,37,161,134,17,135,177,134,17,39,161,134,17,40,177,43,17,41,17,42,17,135,49,134,17,135,129,134,17,44,97,134,17,45,113,134,17,135,129,134,17,47,49,134,17,48,65,55,17,49,81,52,17,50,17,51,17,135,97,134,17,135,177,134,17,53,97,134,17,54,113,134,17,135,129,134,17,56,17,134,17,57,161,134,17,135,177,80,17,59,145,134,17,60,113,134,17,61,129,76,17,62,81,70,17,63,17,67,17,64,161,65,17,135,177,134,17,66,97,134,17,135,65,134,17,68,97,134,17,69,49,134,17,135,65,134,17,71,97,74,17,72,65,73,17,135,49,134,17,135,161,134,17,75,161,134,17,135,177,134,17,77,161,134,17,78,177,79,17,135,17,134,17,135,97,134,1,81,81,134,1,82,145,134,1,83,97,134,1,84,113,134,1,85,129,88,1,86,65,87,1,135,49,134,1,135,161,134,1,89,161,134,1,135,177,112,1,91,81,104,1,92,145,134,1,93,97,134,1,94,113,101,1,95,65,99,1,96,49,97,1,135,129,134,1,98,17,134,1,135,33,134,1,100,129,134,1,135,161,134,1,102,177,134,1,103,129,134,1,135,161,134,1,105,33,134,1,106,49,134,1,107,65,134,1,108,113,110,1,109,17,134,1,135,97,134,1,111,97,134,1,135,129,134,17,113,81,126,17,114,145,134,17,115,97,134,17,116,113,123,17,117,65,121,17,118,49,119,17,135,129,134,17,120,17,134,17,135,33,134,17,122,129,134,17,135,161,134,17,124,177,134,17,125,129,134,17,135,161,134,17,127,33,134,17,128,49,134,17,129,65,134,17,130,113,132,17,131,17,134,17,135,97,134,17,133,97,134,17,135,129,254,0,0,0,255,0,0,0,43,3,1,0,4,1,2,80,38,16,3,32,72,7,4,112,5,16,72,151,72,7,6,144,15,16,7,16,8,16,72,103,72,7,9,96,72,7,10,128,13,0,11,64,12,0,73,55,72,7,73,167,72,7,14,160,72,7,73,183,30,0,16,16,20,16,17,96,72,7,18,128,72,7,19,160,72,7,73,183,27,0,21,96,72,7,22,128,25,0,23,64,24,0,73,55,72,7,73,167,72,7,26,160,72,7,73,183,72,7,28,128,72,7,29,160,72,7,73,183,31,16,72,103,72,7,32,96,72,7,33,128,36,0,34,64,35,0,73,55,72,7,73,167,72,7,37,160,72,7,73,183,225,0,39,32,89,16,40,112,53,16,41,144,42,16,72,23,72,7,43,16,46,0,44,96,72,7,45,48,72,7,73,71,50,16,47,96,72,7,48,48,72,7,49,64,72,7,73,183,72,7,51,48,72,7,52,64,72,7,73,183,77,0,54,144,55,16,72,23,72,7,56,16,63,16,57,96,72,7,58,176,61,0,59,48,60,0,73,71,72,7,73,167,72,7,62,128,72,7,73,167,71,0,64,96,68,0,65,48,66,0,73,71,72,7,67,160,72,7,73,183,72,7,69,128,72,7,70,160,72,7,73,183,72,7,72,176,75,0,73,48,74,0,73,71,72,7,73,167,72,7,76,128,72,7,73,167,78,16,72,23,72,7,79,16,82,0,80,96,72,7,81,48,72,7,73,71,86,16,83,96,72,7,84,48,72,7,85,64,72,7,73,183,72,7,87,48,72,7,88,64,72,7,73,183,125,16,90,144,113,0,91,112,97,16,92,16,93,16,72,103,72,7,94,96,72,7,95,48,72,7,96,64,72,7,73,135,108,0,98,16,101,0,99,96,72,7,100,48,72,7,73,71,105,16,102,96,72,7,103,48,72,7,104,64,72,7,73,183,72,7,106,48,72,7,107,64,72,7,73,183,109,16,72,103,72,7,110,96,72,7,111,48,72,7,112,64,72,7,73,135,114,16,72,23,72,7,115,16,118,0,116,96,72,7,117,48,72,7,73,71,122,16,119,96,72,7,120,48,72,7,121,64,72,7,73,183,72,7,123,48,72,7,124,64,72,7,73,183,189,0,126,112,167,0,127,144,136,16,128,16,129,16,72,103,72,7,130,96,72,7,131,128,134,0,132,64,133,0,73,55,72,7,73,167,72,7,135,160,72,7,73,183,159,0,137,16,144,16,138,96,72,7,139,176,142,0,140,48,141,0,73,71,72,7,73,167,72,7,143,128,72,7,73,167,153,0,145,96,149,0,146,48,147,0,73,71,72,7,148,160,72,7,73,183,72,7,150,128,72,7,151,160,152,0,73,71,72,7,73,183,72,7,154,176,157,0,155,48,156,0,73,71,72,7,73,167,72,7,158,128,72,7,73,167,160,16,72,103,72,7,161,96,72,7,162,128,165,0,163,64,164,0,73,55,72,7,73,167,72,7,166,160,72,7,73,183,173,16,168,16,169,16,72,103,72,7,170,96,72,7,171,48,72,7,172,64,72,7,73,135,184,0,174,16,177,0,175,96,72,7,176,48,72,7,73,71,181,16,178,96,72,7,179,48,72,7,180,64,72,7,73,183,72,7,182,48,72,7,183,64,72,7,73,183,185,16,72,103,72,7,186,96,72,7,187,48,72,7,188,64,72,7,73,135,213,0,190,144,191,16,72,23,72,7,192,16,199,16,193,96,72,7,194,176,197,0,195,48,196,0,73,71,72,7,73,167,72,7,198,128,72,7,73,167,207,0,200,96,204,0,201,48,202,0,73,71,72,7,203,160,72,7,73,183,72,7,205,128,72,7,206,160,72,7,73,183,72,7,208,176,211,0,209,48,210,0,73,71,72,7,73,167,72,7,212,128,72,7,73,167,214,16,72,23,72,7,215,16,218,0,216,96,72,7,217,48,72,7,73,71,222,16,219,96,72,7,220,48,72,7,221,64,72,7,73,183,72,7,223,48,72,7,224,64,72,7,73,183,72,7,226,112,227,16,72,151,72,7,228,144,237,16,229,16,230,16,72,103,72,7,231,96,72,7,232,128,235,0,233,64,234,0,73,55,72,7,73,167,72,7,236,160,72,7,73,183,252,0,238,16,242,16,239,96,72,7,240,128,72,7,241,160,72,7,73,183,249,0,243,96,72,7,244,128,247,0,245,64,246,0,73,55,72,7,73,167,72,7,248,160,72,7,73,183,72,7,250,128,72,7,251,160,72,7,73,183,253,16,72,103,72,7,254,96,72,7,255,128,2,1,0,65,1,1,73,55,72,7,73,167,72,7,3,161,72,7,73,183,83,18,5,81,140,17,6,145,25,1,7,113,8,17,72,39,72,7,9,33,10,17,72,23,72,7,11,17,16,1,12,97,72,7,13,49,72,7,14,65,72,7,15,161,72,7,73,183,21,17,17,97,72,7,18,49,72,7,19,65,72,7,20,161,72,7,73,183,72,7,22,49,72,7,23,65,72,7,24,161,72,7,73,183,122,17,26,113,54,17,27,33,36,1,28,17,29,1,72,103,72,23,30,97,72,23,31,129,34,17,32,65,33,17,73,55,72,23,73,167,72,23,35,161,72,23,73,183,46,17,37,17,38,1,72,103,72,23,39,97,43,17,40,65,41,17,73,55,72,23,42,129,72,23,73,167,72,23,44,129,72,23,45,161,72,23,73,183,47,1,72,103,72,23,48,97,72,23,49,129,52,17,50,65,51,17,73,55,72,23,73,167,72,23,53,161,72,23,73,183,96,1,55,33,64,17,56,17,57,1,72,103,72,23,58,97,72,23,59,129,62,17,60,65,61,17,73,55,72,23,73,167,72,23,63,161,72,23,73,183,88,1,65,17,70,1,66,97,72,7,67,49,72,7,68,65,72,7,69,161,72,7,73,183,84,17,71,97,78,1,72,65,75,1,73,161,72,7,74,49,72,7,73,183,72,23,76,129,72,23,77,177,72,23,73,167,72,23,79,129,82,17,80,161,81,17,73,71,72,23,73,183,72,23,83,49,72,23,73,71,72,7,85,49,72,7,86,65,72,7,87,161,72,7,73,183,89,1,72,103,72,23,90,97,72,23,91,129,94,17,92,65,93,17,73,55,72,23,73,167,72,23,95,161,72,23,73,183,105,1,97,17,98,1,72,103,72,23,99,97,72,23,100,129,103,17,101,65,102,17,73,55,72,23,73,167,72,23,104,161,72,23,73,183,114,17,106,17,107,1,72,103,72,23,108,97,72,23,109,129,112,17,110,65,111,17,73,55,72,23,73,167,72,23,113,161,72,23,73,183,115,1,72,103,72,23,116,97,72,23,117,129,120,17,118,65,119,17,73,55,72,23,73,167,72,23,121,161,72,23,73,183,123,17,72,39,72,7,124,33,125,17,72,23,72,7,126,17,131,1,127,97,72,7,128,49,72,7,129,65,72,7,130,161,72,7,73,183,136,17,132,97,72,7,133,49,72,7,134,65,72,7,135,161,72,7,73,183,72,7,137,49,72,7,138,65,72,7,139,161,72,7,73,183,13,2,141,145,176,17,142,113,159,1,143,33,144,17,72,23,72,7,145,17,150,1,146,97,72,7,147,161,72,7,148,177,149,1,73,55,72,7,73,135,155,17,151,97,72,7,152,161,72,7,153,177,154,1,73,55,72,7,73,135,72,7,156,161,72,7,157,177,158,1,73,55,72,7,73,135,72,23,160,33,165,17,161,17,162,1,72,103,72,23,163,97,72,23,164,49,72,23,73,71,171,1,166,17,167,1,72,103,72,23,168,97,72,23,169,49,72,23,170,65,72,23,73,135,172,1,72,103,72,23,173,97,72,23,174,49,72,23,175,65,72,23,73,135,251,1,177,113,201,17,178,33,184,17,179,17,180,17,72,103,72,7,181,97,72,7,182,129,72,7,183,161,72,7,73,183,196,1,185,17,189,1,186,97,72,7,187,129,72,7,188,161,72,7,73,183,193,17,190,97,72,7,191,129,72,7,192,161,72,7,73,183,72,7,194,129,72,7,195,161,72,7,73,183,197,17,72,103,72,7,198,97,72,7,199,129,72,7,200,161,72,7,73,183,228,1,202,33,208,17,203,17,204,17,72,103,72,7,205,97,72,7,206,129,72,7,207,161,72,7,73,183,223,1,209,17,214,1,210,97,72,7,211,161,72,7,212,177,213,1,73,55,72,7,73,135,219,17,215,97,72,7,216,161,72,7,217,177,218,1,73,55,72,7,73,135,72,7,220,161,72,7,221,177,222,1,73,55,72,7,73,135,224,17,72,103,72,7,225,97,72,7,226,129,72,7,227,161,72,7,73,183,234,17,229,17,230,17,72,103,72,7,231,97,72,7,232,129,72,7,233,161,72,7,73,183,246,1,235,17,239,1,236,97,72,7,237,129,72,7,238,161,72,7,73,183,243,17,240,97,72,7,241,129,72,7,242,161,72,7,73,183,72,7,244,129,72,7,245,161,72,7,73,183,247,17,72,103,72,7,248,97,72,7,249,129,72,7,250,161,72,7,73,183,252,17,72,39,72,7,253,33,254,17,72,23,72,7,255,17,4,2,0,98,72,7,1,162,72,7,2,178,3,2,73,55,72,7,73,135,9,18,5,98,72,7,6,162,72,7,7,178,8,2,73,55,72,7,73,135,72,7,10,162,72,7,11,178,12,2,73,55,72,7,73,135,32,18,14,34,15,2,72,119,72,23,16,114,21,18,17,18,18,2,72,103,72,23,19,98,72,23,20,50,72,23,73,71,27,2,22,18,23,2,72,103,72,23,24,98,72,23,25,50,72,23,26,66,72,23,73,135,28,2,72,103,72,23,29,98,72,23,30,50,72,23,31,66,72,23,73,135,72,7,33,34,50,2,34,114,35,18,72,23,72,7,36,18,41,2,37,98,72,7,38,50,72,7,39,66,72,7,40,162,72,7,73,183,46,18,42,98,72,7,43,50,72,7,44,66,72,7,45,162,72,7,73,183,72,7,47,50,72,7,48,66,72,7,49,162,72,7,73,183,67,18,51,114,52,18,72,23,72,7,53,18,58,2,54,98,72,7,55,50,72,7,56,66,72,7,57,162,72,7,73,183],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+122884);allocate([63,18,59,98,72,7,60,50,72,7,61,66,72,7,62,162,72,7,73,183,72,7,64,50,72,7,65,66,72,7,66,162,72,7,73,183,68,18,72,23,72,7,69,18,74,2,70,98,72,7,71,50,72,7,72,66,72,7,73,162,72,7,73,183,79,18,75,98,72,7,76,50,72,7,77,66,72,7,78,162,72,7,73,183,72,7,80,50,72,7,81,66,72,7,82,162,72,7,73,183,110,18,84,34,72,7,85,114,86,18,72,151,72,7,87,146,93,18,88,18,89,18,72,103,72,7,90,98,72,7,91,130,72,7,92,162,72,7,73,183,105,2,94,18,98,2,95,98,72,7,96,130,72,7,97,162,72,7,73,183,102,18,99,98,72,7,100,130,72,7,101,162,72,7,73,183,72,7,103,130,72,7,104,162,72,7,73,183,106,18,72,103,72,7,107,98,72,7,108,130,72,7,109,162,72,7,73,183,17,3,111,34,162,18,112,114,129,18,113,146,114,18,72,23,72,7,115,18,120,2,116,98,72,7,117,50,72,7,118,66,72,7,119,162,72,7,73,183,125,18,121,98,72,7,122,50,72,7,123,66,72,7,124,162,72,7,73,183,72,7,126,50,72,7,127,66,72,7,128,162,72,7,73,183,146,2,130,146,131,18,72,23,72,7,132,18,137,2,133,98,72,7,134,162,72,7,135,178,136,2,73,55,72,7,73,135,142,18,138,98,72,7,139,162,72,7,140,178,141,2,73,55,72,7,73,135,72,7,143,162,72,7,144,178,145,2,73,55,72,7,73,135,147,18,72,23,72,7,148,18,153,2,149,98,72,7,150,50,72,7,151,66,72,7,152,162,72,7,73,183,158,18,154,98,72,7,155,50,72,7,156,66,72,7,157,162,72,7,73,183,72,7,159,50,72,7,160,66,72,7,161,162,72,7,73,183,196,18,163,146,180,2,164,114,165,18,72,23,72,7,166,18,171,2,167,98,72,7,168,50,72,7,169,66,72,7,170,162,72,7,73,183,176,18,172,98,72,7,173,50,72,7,174,66,72,7,175,162,72,7,73,183,72,7,177,50,72,7,178,66,72,7,179,162,72,7,73,183,181,18,72,23,72,7,182,18,187,2,183,98,72,7,184,50,72,7,185,66,72,7,186,162,72,7,73,183,192,18,188,98,72,7,189,50,72,7,190,66,72,7,191,162,72,7,73,183,72,7,193,50,72,7,194,66,72,7,195,162,72,7,73,183,240,2,197,114,224,2,198,146,204,18,199,18,200,18,72,103,72,7,201,98,72,7,202,130,72,7,203,162,72,7,73,183,219,2,205,18,210,2,206,98,72,7,207,162,72,7,208,178,209,2,73,55,72,7,73,135,215,18,211,98,72,7,212,162,72,7,213,178,214,2,73,55,72,7,73,135,72,7,216,162,72,7,217,178,218,2,73,55,72,7,73,135,220,18,72,103,72,7,221,98,72,7,222,130,72,7,223,162,72,7,73,183,225,18,72,23,72,7,226,18,231,2,227,98,72,7,228,50,72,7,229,66,72,7,230,162,72,7,73,183,236,18,232,98,72,7,233,50,72,7,234,66,72,7,235,162,72,7,73,183,72,7,237,50,72,7,238,66,72,7,239,162,72,7,73,183,1,3,241,146,242,18,72,23,72,7,243,18,248,2,244,98,72,7,245,162,72,7,246,178,247,2,73,55,72,7,73,135,253,18,249,98,72,7,250,162,72,7,251,178,252,2,73,55,72,7,73,135,72,7,254,162,72,7,255,178,0,3,73,55,72,7,73,135,2,19,72,23,72,7,3,19,8,3,4,99,72,7,5,51,72,7,6,67,72,7,7,163,72,7,73,183,13,19,9,99,72,7,10,51,72,7,11,67,72,7,12,163,72,7,73,183,72,7,14,51,72,7,15,67,72,7,16,163,72,7,73,183,72,7,18,115,19,19,72,151,72,7,20,147,26,19,21,19,22,19,72,103,72,7,23,99,72,7,24,131,72,7,25,163,72,7,73,183,38,3,27,19,31,3,28,99,72,7,29,131,72,7,30,163,72,7,73,183,35,19,32,99,72,7,33,131,72,7,34,163,72,7,73,183,72,7,36,131,72,7,37,163,72,7,73,183,39,19,72,103,72,7,40,99,72,7,41,131,72,7,42,163,72,7,73,183,85,22,44,3,49,20,45,83,96,3,46,147,47,3,72,39,72,23,48,35,61,3,49,115,50,3,72,23,72,23,51,19,54,19,52,99,72,23,53,51,72,23,73,71,58,3,55,99,72,23,56,51,72,23,57,67,72,23,73,183,72,23,59,51,72,23,60,67,72,23,73,183,84,19,62,115,68,3,63,19,64,3,72,103,72,23,65,99,72,23,66,51,72,23,67,67,72,23,73,135,79,19,69,19,72,19,70,99,72,23,71,51,72,23,73,71,76,3,73,99,72,23,74,51,72,23,75,67,72,23,73,183,72,23,77,51,72,23,78,67,72,23,73,183,80,3,72,103,72,23,81,99,72,23,82,51,72,23,83,67,72,23,73,135,85,3,72,23,72,23,86,19,89,19,87,99,72,23,88,51,72,23,73,71,93,3,90,99,72,23,91,51,72,23,92,67,72,23,73,183,72,23,94,51,72,23,95,67,72,23,73,183,255,19,97,147,123,3,98,115,99,3,72,39,72,23,100,35,101,3,72,23,72,23,102,19,109,3,103,99,72,23,104,179,107,19,105,51,106,19,73,71,72,23,73,167,72,23,108,131,72,23,73,167,117,19,110,99,114,19,111,51,112,19,73,71,72,23,113,163,72,23,73,183,72,23,115,131,72,23,116,163,72,23,73,183,72,23,118,179,121,19,119,51,120,19,73,71,72,23,73,167,72,23,122,131,72,23,73,167,230,19,124,115,157,3,125,35,134,3,126,19,127,3,72,103,72,23,128,99,72,23,129,131,132,19,130,67,131,19,73,55,72,23,73,167,72,23,133,163,72,23,73,183,149,19,135,19,139,3,136,99,72,23,137,131,72,23,138,163,72,23,73,183,146,19,140,99,72,23,141,131,144,19,142,67,143,19,73,55,72,23,73,167,72,23,145,163,72,23,73,183,72,23,147,131,72,23,148,163,72,23,73,183,150,3,72,103,72,23,151,99,72,23,152,131,155,19,153,67,154,19,73,55,72,23,73,167,72,23,156,163,72,23,73,183,198,19,158,35,167,3,159,19,160,3,72,103,72,23,161,99,72,23,162,131,165,19,163,67,164,19,73,55,72,23,73,167,72,23,166,163,72,23,73,183,190,19,168,19,175,3,169,99,72,23,170,179,173,19,171,51,172,19,73,71,72,23,73,167,72,23,174,131,72,23,73,167,184,19,176,99,180,19,177,51,178,19,73,71,72,23,179,163,72,23,73,183,72,23,181,131,72,23,182,163,183,19,73,71,72,23,73,183,72,23,185,179,188,19,186,51,187,19,73,71,72,23,73,167,72,23,189,131,72,23,73,167,191,3,72,103,72,23,192,99,72,23,193,131,196,19,194,67,195,19,73,55,72,23,73,167,72,23,197,163,72,23,73,183,207,3,199,19,200,3,72,103,72,23,201,99,72,23,202,131,205,19,203,67,204,19,73,55,72,23,73,167,72,23,206,163,72,23,73,183,222,19,208,19,212,3,209,99,72,23,210,131,72,23,211,163,72,23,73,183,219,19,213,99,72,23,214,131,217,19,215,67,216,19,73,55,72,23,73,167,72,23,218,163,72,23,73,183,72,23,220,131,72,23,221,163,72,23,73,183,223,3,72,103,72,23,224,99,72,23,225,131,228,19,226,67,227,19,73,55,72,23,73,167,72,23,229,163,72,23,73,183,231,3,72,39,72,23,232,35,233,3,72,23,72,23,234,19,241,3,235,99,72,23,236,179,239,19,237,51,238,19,73,71,72,23,73,167,72,23,240,131,72,23,73,167,249,19,242,99,246,19,243,51,244,19,73,71,72,23,245,163,72,23,73,183,72,23,247,131,72,23,248,163,72,23,73,183,72,23,250,179,253,19,251,51,252,19,73,71,72,23,73,167,72,23,254,131,72,23,73,167,0,4,72,39,72,23,1,36,14,4,2,116,3,4,72,23,72,23,4,20,7,20,5,100,72,23,6,52,72,23,73,71,11,4,8,100,72,23,9,52,72,23,10,68,72,23,73,183,72,23,12,52,72,23,13,68,72,23,73,183,37,20,15,116,21,4,16,20,17,4,72,103,72,23,18,100,72,23,19,52,72,23,20,68,72,23,73,135,32,20,22,20,25,20,23,100,72,23,24,52,72,23,73,71,29,4,26,100,72,23,27,52,72,23,28,68,72,23,73,183,72,23,30,52,72,23,31,68,72,23,73,183,33,4,72,103,72,23,34,100,72,23,35,52,72,23,36,68,72,23,73,135,38,4,72,23,72,23,39,20,42,20,40,100,72,23,41,52,72,23,73,71,46,4,43,100,72,23,44,52,72,23,45,68,72,23,73,183,72,23,47,52,72,23,48,68,72,23,73,183,125,5,50,84,139,4,51,36,77,20,52,116,53,4,72,151,72,23,54,148,60,4,55,20,56,4,72,103,72,23,57,100,72,23,58,132,72,23,59,164,72,23,73,183,72,20,61,20,65,4,62,100,72,23,63,132,72,23,64,164,72,23,73,183,69,20,66,100,72,23,67,132,72,23,68,164,72,23,73,183,72,23,70,132,72,23,71,164,72,23,73,183,73,4,72,103,72,23,74,100,72,23,75,132,72,23,76,164,72,23,73,183,72,7,78,116,95,20,79,148,84,4,80,20,81,20,72,103,72,7,82,100,72,7,83,52,72,7,73,71,90,20,85,20,86,20,72,103,72,7,87,100,72,7,88,52,72,7,89,68,72,7,73,135,91,20,72,103,72,7,92,100,72,7,93,52,72,7,94,68,72,7,73,135,123,4,96,148,105,20,97,20,98,20,72,103,72,7,99,100,72,7,100,132,103,4,101,68,102,4,73,55,72,7,73,167,72,7,104,164,72,7,73,183,115,4,106,20,107,20,72,103,72,7,108,100,112,4,109,68,110,4,73,55,72,7,111,132,72,7,73,167,72,7,113,132,72,7,114,164,72,7,73,183,116,20,72,103,72,7,117,100,72,7,118,132,121,4,119,68,120,4,73,55,72,7,73,167,72,7,122,164,72,7,73,183,128,4,124,20,125,20,72,103,72,7,126,100,72,7,127,52,72,7,73,71,134,20,129,20,130,20,72,103,72,7,131,100,72,7,132,52,72,7,133,68,72,7,73,135,135,20,72,103,72,7,136,100,72,7,137,52,72,7,138,68,72,7,73,135,71,21,140,36,201,20,141,116,158,4,142,148,143,4,72,23,72,23,144,20,149,4,145,100,72,23,146,52,72,23,147,68,72,23,148,164,72,23,73,183,154,20,150,100,72,23,151,52,72,23,152,68,72,23,153,164,72,23,73,183,72,23,155,52,72,23,156,68,72,23,157,164,72,23,73,183,185,20,159,148,165,4,160,20,161,4,72,103,72,23,162,100,72,23,163,132,72,23,164,164,72,23,73,183,180,20,166,20,171,4,167,100,72,23,168,164,72,23,169,180,170,20,73,55,72,23,73,135,176,20,172,100,72,23,173,164,72,23,174,180,175,20,73,55,72,23,73,135,72,23,177,164,72,23,178,180,179,20,73,55,72,23,73,135,181,4,72,103,72,23,182,100,72,23,183,132,72,23,184,164,72,23,73,183,186,4,72,23,72,23,187,20,192,4,188,100,72,23,189,52,72,23,190,68,72,23,191,164,72,23,73,183,197,20,193,100,72,23,194,52,72,23,195,68,72,23,196,164,72,23,73,183,72,23,198,52,72,23,199,68,72,23,200,164,72,23,73,183,21,5,202,116,219,20,203,148,204,4,72,23,72,23,205,20,210,4,206,100,72,23,207,164,72,23,208,180,209,20,73,55,72,23,73,135,215,20,211,100,72,23,212,164,72,23,213,180,214,20,73,55,72,23,73,135,72,23,216,164,72,23,217,180,218,20,73,55,72,23,73,135,5,5,220,148,229,4,221,20,222,20,72,103,72,7,223,100,72,7,224,132,227,4,225,68,226,4,73,55,72,7,73,167,72,7,228,164,72,7,73,183,253,20,230,20,235,20,231,100,72,23,232,52,72,23,233,68,72,23,234,164,72,23,73,183,249,4,236,100,243,20,237,68,240,4,238,164,72,7,239,132,72,7,73,183,72,23,241,52,72,23,242,180,72,23,73,167,72,7,244,132,247,4,245,164,246,4,73,71,72,7,73,183,72,7,248,52,72,7,73,71,72,23,250,52,72,23,251,68,72,23,252,164,72,23,73,183,254,20,72,103,72,7,255,100,72,7,0,133,3,5,1,69,2,5,73,55,72,7,73,167,72,7,4,165,72,7,73,183,6,5,72,23,72,23,7,21,12,5,8,101,72,23,9,53,72,23,10,69,72,23,11,165,72,23,73,183,17,21,13,101,72,23,14,53,72,23,15,69,72,23,16,165,72,23,73,183,72,23,18,53,72,23,19,69,72,23,20,165,72,23,73,183,38,5,22,149,23,5,72,23,72,23,24,21,29,5,25,101,72,23,26,53,72,23,27,69,72,23,28,165,72,23,73,183,34,21,30,101,72,23,31,53,72,23,32,69,72,23,33,165,72,23,73,183,72,23,35,53,72,23,36,69,72,23,37,165,72,23,73,183,55,21,39,149,40,5,72,23,72,23,41,21,46,5,42,101,72,23,43,165,72,23,44,181,45,21,73,55,72,23,73,135,51,21,47,101,72,23,48,165,72,23,49,181,50,21,73,55,72,23,73,135,72,23,52,165,72,23,53,181,54,21,73,55,72,23,73,135,56,5,72,23,72,23,57,21,62,5,58,101,72,23,59,53,72,23,60,69,72,23,61,165,72,23,73,183,67,21,63,101,72,23,64,53,72,23,65,69,72,23,66,165,72,23,73,183,72,23,68,53,72,23,69,69,72,23,70,165,72,23,73,183,100,5,72,117,73,21,72,151,72,7,74,149,83,5,75,21,76,21,72,103,72,7,77,101,72,7,78,133,81,5,79,69,80,5,73,55,72,7,73,167,72,7,82,165,72,7,73,183,92,21,84,21,85,21,72,103,72,7,86,101,72,7,87,133,90,5,88,69,89,5,73,55,72,7,73,167,72,7,91,165,72,7,73,183,93,21,72,103,72,7,94,101,72,7,95,133,98,5,96,69,97,5,73,55,72,7,73,167,72,7,99,165,72,7,73,183,72,23,101,149,72,23,102,117,108,5,103,21,104,5,72,103,72,23,105,101,72,23,106,133,72,23,107,165,72,23,73,183,120,21,109,21,113,5,110,101,72,23,111,133,72,23,112,165,72,23,73,183,117,21,114,101,72,23,115,133,72,23,116,165,72,23,73,183,72,23,118,133,72,23,119,165,72,23,73,183,121,5,72,103,72,23,122,101,72,23,123,133,72,23,124,165,72,23,73,183,152,5,126,37,72,23,127,117,128,5,72,151,72,23,129,149,135,5,130,21,131,5,72,103,72,23,132,101,72,23,133,133,72,23,134,165,72,23,73,183,147,21,136,21,140,5,137,101,72,23,138,133,72,23,139,165,72,23,73,183,144,21,141,101,72,23,142,133,72,23,143,165,72,23,73,183,72,23,145,133,72,23,146,165,72,23,73,183,148,5,72,103,72,23,149,101,72,23,150,133,72,23,151,165,72,23,73,183,59,22,153,37,204,5,154,117,171,5,155,149,156,5,72,23,72,23,157,21,162,5,158,101,72,23,159,53,72,23,160,69,72,23,161,165,72,23,73,183,167,21,163,101,72,23,164,53,72,23,165,69,72,23,166,165,72,23,73,183,72,23,168,53,72,23,169,69,72,23,170,165,72,23,73,183,188,21,172,149,173,5,72,23,72,23,174,21,179,5,175,101,72,23,176,165,72,23,177,181,178,21,73,55,72,23,73,135,184,21,180,101,72,23,181,165,72,23,182,181,183,21,73,55,72,23,73,135,72,23,185,165,72,23,186,181,187,21,73,55,72,23,73,135,189,5,72,23,72,23,190,21,195,5,191,101,72,23,192,53,72,23,193,69,72,23,194,165,72,23,73,183,200,21,196,101,72,23,197,53,72,23,198,69,72,23,199,165,72,23,73,183,72,23,201,53,72,23,202,69,72,23,203,165,72,23,73,183,238,5,205,149,222,21,206,117,207,5,72,23,72,23,208,21,213,5,209,101,72,23,210,53,72,23,211,69,72,23,212,165,72,23,73,183,218,21,214,101,72,23,215,53,72,23,216,69,72,23,217,165,72,23,73,183,72,23,219,53,72,23,220,69,72,23,221,165,72,23,73,183,223,5,72,23,72,23,224,21,229,5,225,101,72,23,226,53,72,23,227,69,72,23,228,165,72,23,73,183,234,21,230,101,72,23,231,53,72,23,232,69,72,23,233,165,72,23,73,183,72,23,235,53,72,23,236,69,72,23,237,165,72,23,73,183,26,22,239,117,10,22,240,149,246,5,241,21,242,5,72,103,72,23,243,101,72,23,244,133,72,23,245,165,72,23,73,183,5,22,247,21,252,5,248,101,72,23,249,165,72,23,250,181,251,21,73,55,72,23,73,135,1,22,253,101,72,23,254,165,72,23,255,181,0,22,73,55,72,23,73,135,72,23,2,166,72,23,3,182,4,22,73,55,72,23,73,135,6,6,72,103,72,23,7,102,72,23,8,134,72,23,9,166,72,23,73,183,11,6,72,23,72,23,12,22,17,6,13,102,72,23,14,54,72,23,15,70,72,23,16,166,72,23,73,183,22,22,18,102,72,23,19,54,72,23,20,70,72,23,21,166,72,23,73,183,72,23,23,54,72,23,24,70,72,23,25,166,72,23,73,183,43,22,27,150,28,6,72,23,72,23,29,22,34,6,30,102,72,23,31,166,72,23,32,182,33,22,73,55,72,23,73,135,39,22,35,102,72,23,36,166,72,23,37,182,38,22,73,55,72,23,73,135,72,23,40,166,72,23,41,182,42,22,73,55,72,23,73,135,44,6,72,23,72,23,45,22,50,6,46,102,72,23,47,54,72,23,48,70,72,23,49,166,72,23,73,183,55,22,51,102,72,23,52,54,72,23,53,70,72,23,54,166,72,23,73,183,72,23,56,54,72,23,57,70,72,23,58,166,72,23,73,183,72,23,60,118,61,6,72,151,72,23,62,150,68,6,63,22,64,6,72,103,72,23,65,102,72,23,66,134,72,23,67,166,72,23,73,183,80,22,69,22,73,6,70,102,72,23,71,134,72,23,72,166,72,23,73,183,77,22,74,102,72,23,75,134,72,23,76,166,72,23,73,183,72,23,78,134,72,23,79,166,72,23,73,183,81,6,72,103,72,23,82,102,72,23,83,134,72,23,84,166,72,23,73,183,207,22,86,86,87,6,72,119,72,23,88,118,117,6,89,38,90,6,72,151,72,23,91,150,100,6,92,22,93,6,72,103,72,23,94,102,72,23,95,134,98,22,96,70,97,22,73,55,72,23,73,167,72,23,99,166,72,23,73,183,109,22,101,22,102,6,72,103,72,23,103,102,72,23,104,134,107,22,105,70,106,22,73,55,72,23,73,167,72,23,108,166,72,23,73,183,110,6,72,103,72,23,111,102,72,23,112,134,115,22,113,70,114,22,73,55,72,23,73,167,72,23,116,166,72,23,73,183,179,22,118,38,135,6,119,150,124,22,120,22,121,6,72,103,72,23,122,102,72,23,123,54,72,23,73,71,130,6,125,22,126,6,72,103,72,23,127,102,72,23,128,54,72,23,129,70,72,23,73,135,131,6,72,103,72,23,132,102,72,23,133,54,72,23,134,70,72,23,73,135,163,22,136,150,145,6,137,22,138,6,72,103,72,23,139,102,72,23,140,134,143,22,141,70,142,22,73,55,72,23,73,167,72,23,144,166,72,23,73,183,155,22,146,22,147,6,72,103,72,23,148,102,152,22,149,70,150,22,73,55,72,23,151,134,72,23,73,167,72,23,153,134,72,23,154,166,72,23,73,183,156,6,72,103,72,23,157,102,72,23,158,134,161,22,159,70,160,22,73,55,72,23,73,167,72,23,162,166,72,23,73,183,168,22,164,22,165,6,72,103,72,23,166,102,72,23,167,54,72,23,73,71,174,6,169,22,170,6,72,103,72,23,171,102,72,23,172,54,72,23,173,70,72,23,73,135,175,6,72,103,72,23,176,102,72,23,177,54,72,23,178,70,72,23,73,135,180,6,72,151,72,23,181,150,190,6,182,22,183,6,72,103,72,23,184,102,72,23,185,134,188,22,186,70,187,22,73,55,72,23,73,167,72,23,189,166,72,23,73,183,199,22,191,22,192,6,72,103,72,23,193,102,72,23,194,134,197,22,195,70,196,22,73,55,72,23,73,167,72,23,198,166,72,23,73,183,200,6,72,103,72,23,201,102,72,23,202,134,205,22,203,70,204,22,73,55,72,23,73,167,72,23,206,166,72,23,73,183,72,7,208,86,72,7,209,118,238,22,210,38,211,22,72,151,72,7,212,150,221,6,213,22,214,22,72,103,72,7,215,102,72,7,216,134,219,6,217,70,218,6,73,55,72,7,73,167,72,7,220,166,72,7,73,183,230,22,222,22,223,22,72,103,72,7,224,102,72,7,225,134,228,6,226,70,227,6,73,55,72,7,73,167,72,7,229,166,72,7,73,183,231,22,72,103,72,7,232,102,72,7,233,134,236,6,234,70,235,6,73,55,72,7,73,167,72,7,237,166,72,7,73,183,44,7,239,38,0,23,240,150,245,6,241,22,242,22,72,103,72,7,243,102,72,7,244,54,72,7,73,71,251,22,246,22,247,22,72,103,72,7,248,102,72,7,249,54,72,7,250,70,72,7,73,135,252,22,72,103,72,7,253,102,72,7,254,54,72,7,255,70,72,7,73,135,28,7,1,151,10,23,2,23,3,23,72,103,72,7,4,103,72,7,5,135,8,7,6,71,7,7,73,55,72,7,73,167,72,7,9,167,72,7,73,183,20,7,11,23,12,23,72,103,72,7,13,103,17,7,14,71,15,7,73,55,72,7,16,135,72,7,73,167,72,7,18,135,72,7,19,167,72,7,73,183,21,23,72,103,72,7,22,103,72,7,23,135,26,7,24,71,25,7,73,55,72,7,73,167,72,7,27,167,72,7,73,183,33,7,29,23,30,23,72,103,72,7,31,103,72,7,32,55,72,7,73,71,39,23,34,23,35,23,72,103,72,7,36,103,72,7,37,55,72,7,38,71,72,7,73,135,40,23,72,103,72,7,41,103,72,7,42,55,72,7,43,71,72,7,73,135,45,23,72,151,72,7,46,151,55,7,47,23,48,23,72,103,72,7,49,103,72,7,50,135,53,7,51,71,52,7,73,55,72,7,73,167,72,7,54,167,72,7,73,183,64,23,56,23,57,23,72,103,72,7,58,103,72,7,59,135,62,7,60,71,61,7,73,55,72,7,73,167,72,7,63,167,72,7,73,183,65,23,72,103,72,7,66,103,72,7,67,135,70,7,68,71,69,7,73,55,72,7,73,167,72,7,71,167,72,7,73,183,254,0,0,0,255,0,0,0,56,1,1,0,211,0,2,32,138,0,3,64,81,0,4,80,39,0,5,112,22,0,6,48,13,0,7,16,10,0,8,96,9,0,173,130,172,2,173,242,172,2,11,208,172,2,12,224,172,2,173,242,172,2,14,128,172,2,15,144,172,2,16,160,17,0,173,98,172,2,18,176,172,2,19,192,172,2,20,208,172,2,21,224,172,2,173,242,172,2,23,160,172,2,24,176,172,2,25,192,35,0,26,128,31,0,27,144,28,0,173,98,172,2,29,208,172,2,30,224,172,2,173,242,172,2,32,16,172,2,33,208,172,2,34,224,172,2,173,242,172,2,36,16,172,2,37,208,172,2,38,224,172,2,173,242,65,16,40,112,56,0,41,224,172,2,42,240,50,0,43,16,46,0,44,48,45,0,173,98,172,2,173,210,172,2,47,160,172,2,48,176,172,2,49,192,172,2,173,210,172,2,51,128,172,2,52,144,172,2,53,160,172,2,54,176,172,2,55,192,172,2,173,210,172,18,57,224,172,18,58,128,172,18,59,144,172,18,60,160,172,18,61,176,172,18,62,192,172,18,63,208,64,16,173,98,172,18,173,242,172,2,66,224,172,2,67,240,75,0,68,16,71,0,69,48,70,0,173,98,172,2,173,210,172,2,72,160,172,2,73,176,172,2,74,192,172,2,173,210,172,2,76,128,172,2,77,144,172,2,78,160,172,2,79,176,172,2,80,192,172,2,173,210,110,16,82,80,100,0,83,192,172,2,84,208,172,2,85,224,94,0,86,240,90,0,87,16,88,0,173,50,172,2,89,160,172,2,173,178,172,2,91,128,172,2,92,144,172,2,93,160,172,2,173,178,172,2,95,96,172,2,96,112,172,2,97,128,172,2,98,144,172,2,99,160,172,2,173,178,172,18,101,192,172,18,102,112,172,18,103,128,172,18,104,144,172,18,105,160,172,18,106,176,172,18,107,208,108,16,173,98,172,18,109,224,172,18,173,242,128,0,111,192,172,2,112,208,172,2,113,224,122,0,114,240,118,0,115,16,116,0,173,50,172,2,117,160,172,2,173,178,172,2,119,128,172,2,120,144,172,2,121,160,172,2,173,178,172,2,123,96,172,2,124,112,172,2,125,128,172,2,126,144,172,2,127,160,172,2,173,178,172,18,129,192,172,18,130,112,172,18,131,128,172,18,132,144,172,18,133,160,172,18,134,176,172,18,135,208,172,18,136,224,137,16,173,98,172,18,173,242,177,16,139,64,161,0,140,176,172,2,141,192,172,2,142,208,157,0,143,160,152,0,144,224,148,0,145,240,146,0,173,18,172,2,147,128,172,2,173,146,172,2,149,96,172,2,150,112,172,2,151,128,172,2,173,146,172,2,153,80,172,2,154,96,172,2,155,112,172,2,156,128,172,2,173,146,172,2,158,16,172,2,159,48,172,2,160,224,172,2,173,242,172,18,162,176,172,18,163,112,172,18,164,128,172,18,165,144,172,18,166,160,173,16,167,96,170,16,168,80,169,16,173,50,172,18,173,194,172,18,171,192,172,18,172,208,172,18,173,226,172,18,174,192,172,18,175,208,172,18,176,224,172,18,173,242,199,0,178,176,172,2,179,192,172,2,180,208,195,0,181,160,190,0,182,224,186,0,183,240,184,0,173,18,172,2,185,128,172,2,173,146,172,2,187,96,172,2,188,112,172,2,189,128,172,2,173,146,172,2,191,80,172,2,192,96,172,2,193,112,172,2,194,128,172,2,173,146,172,2,196,16,172,2,197,48,172,2,198,224,172,2,173,242,172,18,200,176,172,18,201,112,172,18,202,128,172,18,203,144,172,18,204,160,172,18,205,192,172,18,206,208,209,16,207,96,208,16,173,82,172,18,173,226,172,18,210,224,172,18,173,242,10,17,212,32,239,0,213,144,172,2,214,160,172,2,215,176,234,0,216,128,229,0,217,192,225,0,218,208,222,0,219,224,220,0,173,242,172,2,221,96,172,2,173,114,172,2,223,80,172,2,224,96,172,2,173,114,172,2,226,64,172,2,227,80,172,2,228,96,172,2,173,114,172,2,230,48,172,2,231,64,172,2,232,80,172,2,233,96,172,2,173,114,172,2,235,16,172,2,236,192,172,2,237,208,172,2,238,224,172,2,173,242,172,18,240,144,172,18,241,112,172,18,242,128,4,17,243,96,255,16,244,80,251,16,245,64,248,16,246,48,247,16,173,18,172,18,173,162,172,18,249,160,172,18,250,176,172,18,173,194,172,18,252,160,172,18,253,176,172,18,254,192,172,18,173,210,172,18,0,161,172,18,1,177,172,18,2,193,172,18,3,209,172,18,173,226,172,18,5,161,172,18,6,177,172,18,7,193,172,18,8,209,172,18,9,225,172,18,173,242,37,1,11,145,172,2,12,161,172,2,13,177,32,1,14,129,27,1,15,193,23,1,16,209,20,1,17,225,18,1,173,242,172,2,19,97,172,2,173,114,172,2,21,81,172,2,22,97,172,2,173,114,172,2,24,65,172,2,25,81,172,2,26,97,172,2,173,114,172,2,28,49,172,2,29,65,172,2,30,81,172,2,31,97,172,2,173,114,172,2,33,17,172,2,34,193,172,2,35,209,172,2,36,225,172,2,173,242,172,18,38,145,172,18,39,113,172,18,40,129,172,18,41,161,172,18,42,177,52,17,43,97,49,17,44,81,47,17,45,65,46,17,173,50,172,18,173,194,172,18,48,193,172,18,173,210,172,18,50,193,172,18,51,209,172,18,173,226,172,18,53,193,172,18,54,209,172,18,55,225,172,18,173,242,112,18,57,1,112,1,58,33,85,1,59,145,172,2,60,113,172,2,61,129,79,1,62,97,74,1,63,81,70,1,64,65,67,1,65,49,66,1,173,18,172,2,173,162,172,2,68,161,172,2,69,177,172,2,173,194,172,2,71,161,172,2,72,177,172,2,73,193,172,2,173,210,172,2,75,161,172,2,76,177,172,2,77,193,172,2,78,209,172,2,173,226,172,2,80,161,172,2,81,177,172,2,82,193,172,2,83,209,172,2,84,225,172,2,173,242,172,18,86,145,172,18,87,161,172,18,88,177,107,17,89,129,102,17,90,193,98,17,91,209,95,17,92,225,93,17,173,242,172,18,94,97,172,18,173,114,172,18,96,81,172,18,97,97,172,18,173,114,172,18,99,65,172,18,100,81,172,18,101,97,172,18,173,114,172,18,103,49,172,18,104,65,172,18,105,81,172,18,106,97,172,18,173,114,172,18,108,17,172,18,109,193,172,18,110,209,172,18,111,225,172,18,173,242,66,18,113,33,152,1,114,65,130,1,115,177,172,2,116,113,172,2,117,129,172,2,118,145,172,2,119,161,126,1,120,97,123,1,121,81,122,1,173,50,172,2,173,194,172,2,124,193,172,2,125,209,172,2,173,226,172,2,127,193,172,2,128,209,172,2,129,225,172,2,173,242,172,18,131,177,172,18,132,193,172,18,133,209,148,17,134,161,143,17,135,225,139,17,136,241,137,17,173,18,172,18,138,129,172,18,173,146,172,18,140,97,172,18,141,113,172,18,142,129,172,18,173,146,172,18,144,81,172,18,145,97,172,18,146,113,172,18,147,129,172,18,173,146,172,18,149,17,172,18,150,49,172,18,151,225,172,18,173,242,32,18,153,65,182,1,154,81,164,1,155,193,172,2,156,113,172,2,157,129,172,2,158,145,172,2,159,161,172,2,160,177,172,2,161,209,162,1,173,98,172,2,163,225,172,2,173,242,172,18,165,193,172,18,166,209,172,18,167,225,176,17,168,241,172,17,169,17,170,17,173,50,172,18,171,161,172,18,173,178,172,18,173,129,172,18,174,145,172,18,175,161,172,18,173,178,172,18,177,97,172,18,178,113,172,18,179,129,172,18,180,145,172,18,181,161,172,18,173,178,4,18,183,81,209,1,184,113,193,1,185,225,172,2,186,129,172,2,187,145,172,2,188,161,172,2,189,177,172,2,190,193,172,2,191,209,192,1,173,98,172,2,173,242,172,18,194,225,172,18,195,241,203,17,196,17,199,17,197,49,198,17,173,98,172,18,173,210,172,18,200,161,172,18,201,177,172,18,202,193,172,18,173,210,172,18,204,129,172,18,205,145,172,18,206,161,172,18,207,177,172,18,208,193,172,18,173,210,244,17,210,113,227,17,211,49,218,17,212,17,215,17,213,97,214,17,173,130,172,18,173,242,172,18,216,209,172,18,217,225,172,18,173,242,172,18,219,129,172,18,220,145,172,18,221,161,222,17,173,98,172,18,223,177,172,18,224,193,172,18,225,209,172,18,226,225,172,18,173,242,172,18,228,161,172,18,229,177,172,18,230,193,240,17,231,129,236,17,232,145,233,17,173,98,172,18,234,209,172,18,235,225,172,18,173,242,172,18,237,17,172,18,238,209,172,18,239,225,172,18,173,242,172,18,241,17,172,18,242,209,172,18,243,225,172,18,173,242,172,18,245,225,172,18,246,241,254,17,247,17,250,17,248,49,249,17,173,98,172,18,173,210,172,18,251,161,172,18,252,177,172,18,253,193,172,18,173,210,172,18,255,129,172,18,0,146,172,18,1,162,172,18,2,178,172,18,3,194,172,18,173,210,14,2,5,194,172,2,6,114,172,2,7,130,172,2,8,146,172,2,9,162,172,2,10,178,172,2,11,210,172,2,12,226,13,2,173,98,172,2,173,242,172,18,15,194,172,18,16,210,172,18,17,226,26,18,18,242,22,18,19,18,20,18,173,50,172,18,21,162,172,18,173,178,172,18,23,130,172,18,24,146,172,18,25,162,172,18,173,178,172,18,27,98,172,18,28,114,172,18,29,130,172,18,30,146,172,18,31,162,172,18,173,178,44,2,33,178,172,2,34,114,172,2,35,130,172,2,36,146,172,2,37,162,172,2,38,194,172,2,39,210,42,2,40,98,41,2,173,82,172,2,173,226,172,2,43,226,172,2,173,242,172,18,45,178,172,18,46,194,172,18,47,210,62,18,48,162,57,18,49,226,53,18,50,242,51,18,173,18,172,18,52,130,172,18,173,146,172,18,54,98,172,18,55,114,172,18,56,130,172,18,173,146,172,18,58,82,172,18,59,98,172,18,60,114,172,18,61,130,172,18,173,146,172,18,63,18,172,18,64,50,172,18,65,226,172,18,173,242,85,2,67,146,172,2,68,114,172,2,69,130,172,2,70,162,172,2,71,178,81,2,72,98,78,2,73,82,76,2,74,66,75,2,173,50,172,2,173,194,172,2,77,194,172,2,173,210,172,2,79,194,172,2,80,210,172,2,173,226,172,2,82,194,172,2,83,210,172,2,84,226,172,2,173,242,172,18,86,146,172,18,87,162,172,18,88,178,107,18,89,130,102,18,90,194,98,18,91,210,95,18,92,226,93,18,173,242,172,18,94,98,172,18,173,114,172,18,96,82,172,18,97,98,172,18,173,114,172,18,99,66,172,18,100,82,172,18,101,98,172,18,173,114,172,18,103,50,172,18,104,66,172,18,105,82,172,18,106,98,172,18,173,114,172,18,108,18,172,18,109,194,172,18,110,210,172,18,111,226,172,18,173,242,142,2,113,114,172,2,114,130,172,2,115,146,136,2,116,98,131,2,117,82,127,2,118,66,124,2,119,50,122,2,120,34,121,2,173,18,172,2,173,162,172,2,123,162,172,2,173,178,172,2,125,162,172,2,126,178,172,2,173,194,172,2,128,162,172,2,129,178,172,2,130,194,172,2,173,210,172,2,132,162,172,2,133,178,172,2,134,194,172,2,135,210,172,2,173,226,172,2,137,162,172,2,138,178,172,2,139,194,172,2,140,210,172,2,141,226,172,2,173,242,172,18,143,114,172,18,144,130,172,18,145,146,166,18,146,98,161,18,147,82,157,18,148,66,154,18,149,50,152,18,150,34,151,18,173,18,172,18,173,162,172,18,153,162,172,18,173,178,172,18,155,162,172,18,156,178,172,18,173,194,172,18,158,162,172,18,159,178,172,18,160,194,172,18,173,210,172,18,162,162,172,18,163,178,172,18,164,194,172,18,165,210,172,18,173,226,172,18,167,162,172,18,168,178,172,18,169,194,172,18,170,210,172,18,171,226,172,18,173,242,254,0,0,0,255,0,0,0,0,0,0,0,216,78,0,0,190,6,0,0,191,6,0,0,146,0,0,0,24,3,0,0,58,2,0,0,147,0,0,0,148,0,0,0,25,3,0,0,192,6,0,0,1,0,0,0,109,1,0,0,182,0,0,0,193,6,0,0,0,0,0,0,224,78,0,0,194,6,0,0,195,6,0,0,196,6,0,0,21,0,0,0,197,6,0,0,0,0,0,0,240,78,0,0,198,6,0,0,199,6,0,0,149,0,0,0,26,3,0,0,59,2,0,0,147,0,0,0,150,0,0,0,25,3,0,0,192,6,0,0,2,0,0,0,109,1,0,0,183,0,0,0,200,6,0,0,0,0,0,0,0,79,0,0,201,6,0,0,202,6,0,0,203,6,0,0,21,0,0,0,204,6,0,0,0,0,0,0,32,79,0,0,205,6,0,0,206,6,0,0,207,6,0,0,21,0,0,0,208,6,0,0,0,0,0,0,16,79,0,0,209,6,0,0,210,6,0,0,211,6,0,0,21,0,0,0,212,6,0,0,0,0,0,0,48,79,0,0,213,6,0,0,214,6,0,0,151,0,0,0,27,3,0,0,60,2,0,0,147,0,0,0,152,0,0,0,25,3,0,0,192,6,0,0,1,0,0,0,110,1,0,0,184,0,0,0,215,6,0,0,0,0,0,0,96,79,0,0,216,6,0,0,217,6,0,0,218,6,0,0,21,0,0,0,219,6,0,0,0,0,0,0,80,79,0,0,220,6,0,0,221,6,0,0,222,6,0,0,21,0,0,0,223,6,0,0,0,0,0,0,64,79,0,0,224,6,0,0,225,6,0,0,226,6,0,0,21,0,0,0,227,6,0,0,0,0,0,0,112,79,0,0,228,6,0,0,229,6,0,0,37,0,0,0,4,0,0,0,28,3,0,0,61,2,0,0,6,0,0,0,7,0,0,0,111,1,0,0,1,0,0,0,1,0,0,0,1,0,0,0,62,2,0,0,29,3,0,0,63,2,0,0,64,2,0,0,30,3,0,0,31,3,0,0,0,0,0,0,128,79,0,0,230,6,0,0,231,6,0,0,32,3,0,0,0,0,0,0,160,79,0,0,63,0,0,0,232,6,0,0,233,6,0,0,112,1,0,0,234,6,0,0,0,0,0,0,144,79,0,0,63,0,0,0,235,6,0,0,236,6,0,0,113,1,0,0,237,6,0,0,0,0,0,0,192,79,0,0,238,6,0,0,239,6,0,0,240,6,0,0,21,0,0,0,241,6,0,0,0,0,0,0,208,79,0,0,242,6,0,0,243,6,0,0,62,0,0,0,33,3,0,0,0,0,0,0,216,79,0,0,244,6,0,0,245,6,0,0,34,3,0,0,114,1,0,0,185,0,0,0,153,0,0,0,186,0,0,0,35,3,0,0,99,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,100,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,224,79,0,0,246,6,0,0,247,6,0,0,36,3,0,0,0,0,0,0,240,79,0,0,248,6,0,0,249,6,0,0,37,3,0,0,60,133,91,61,105,191,22,190,2,153,98,189,108,247,79,61,246,123,236,61,167,217,46,189,62,226,61,61,57,250,95,189,212,151,168,61,35,124,213,61,136,247,187,188,168,158,53,60,147,226,97,60,59,62,229,61,79,209,79,60,24,169,174,61,149,54,129,189,240,173,5,62,38,231,165,61,19,100,85,189,154,195,48,189,193,79,191,61,81,255,225,61,15,146,155,189,76,255,97,189,6,230,54,189,19,114,241,60,66,152,58,61,65,71,105,187,217,33,160,61,168,84,158,61,18,154,161,61,195,227,126,61,40,89,184,61,26,104,18,189,208,217,11,61,93,138,104,61,160,134,67,189,86,118,25,61,50,58,16,189,138,114,142,61,23,168,29,189,94,104,44,60,232,56,142,60,25,146,222,61,48,45,179,61,33,25,88,59,61,96,223,61,226,18,162,61,158,217,212,61,161,93,171,60,17,114,237,61,236,252,6,62,68,84,202,61,23,168,91,61,71,37,138,189,4,202,229,187,53,239,171,59,152,142,4,61,71,172,102,60,194,224,180,60,128,219,207,60,177,72,58,61,179,120,147,61,81,51,0,61,72,128,128,189,73,155,172,60,190,51,119,61,192,222,176,61,41,126,148,59,40,174,179,60,10,56,189,60,116,18,100,61,159,175,216,188,243,55,54,61,22,115,232,60,125,210,183,61,99,190,54,61,182,208,183,61,13,229,153,61,235,252,188,60,210,50,213,61,174,108,130,61,189,113,115,61,27,55,150,59,51,211,85,61,176,184,136,61,249,46,171,61,189,118,137,61,18,84,134,61,23,254,32,189,43,17,22,188,31,148,113,189,77,185,230,60,254,31,78,61,63,222,138,61,58,89,10,61,73,193,31,186,241,14,147,188,138,157,252,188,195,101,85,188,236,125,243,188,194,56,1,60,97,108,16,189,197,25,36,187,177,214,86,61,86,124,241,61,186,143,177,188,134,15,89,61,120,255,135,61,224,151,84,61,44,140,7,188,73,121,248,60,160,75,111,61,138,106,131,187,176,213,204,187,146,37,112,61,119,248,201,188,55,50,99,61,112,131,168,189,36,39,148,189,151,19,62,61,38,88,86,188,162,78,205,188,91,3,254,60,230,26,63,189,56,17,60,189,116,168,241,60,104,54,119,61,163,225,183,60,11,39,139,188,123,102,42,60,181,84,57,60,104,252,93,61,38,131,174,188,138,4,49,189,99,32,22,189,106,144,56,60,4,134,213,188,109,139,182,188,10,201,184,188,45,97,12,189,146,1,254,187,175,193,125,189,2,158,6,60,249,75,195,61,243,245,23,189,179,46,142,189,24,75,21,62,111,40,95,189,111,107,168,188,104,105,107,61,83,226,227,60,227,242,144,189,143,26,84,189,14,150,213,189,104,26,230,189,217,49,154,61,131,208,154,189,209,243,179,189,185,111,244,60,80,135,218,60,161,117,98,60,57,64,147,188,220,169,0,189,94,224,171,188,8,235,184,61,33,245,74,61,218,122,12,62,186,15,233,61,101,244,235,58,184,127,59,189,210,161,145,186,226,244,193,189,219,124,237,189,42,226,55,61,158,41,146,60,0,25,73,59,8,208,220,61,17,135,92,59,89,14,222,189,116,78,152,189,28,194,215,189,189,237,152,188,204,110,36,62,200,60,166,187,61,243,47,189,202,125,193,187,233,129,16,60,28,142,116,188,208,255,77,189,89,217,3,190,106,97,102,58,215,135,84,188,1,128,155,189,113,161,218,188,73,223,53,186,30,40,197,60,193,68,145,188,107,238,29,189,202,193,112,189,97,132,5,61,31,88,3,62,75,223,128,61,220,150,134,187,126,53,225,61,178,101,90,60,243,27,171,60,76,96,37,61,199,110,85,189,253,236,158,61,2,15,131,61,92,153,107,189,249,226,205,189,239,179,153,61,123,74,175,188,138,36,147,60,241,157,25,59,108,95,44,189,172,161,150,61,165,159,80,61,8,127,245,188,80,201,181,188,47,111,9,61,222,253,52,61,239,149,100,189,200,86,78,189,29,75,58,189,3,5,98,60,215,46,176,60,241,191,179,188,98,28,12,190,99,216,95,61,236,187,131,60,30,118,89,61,202,141,64,61,14,59,175,58,76,38,155,61,83,32,197,61,91,64,18,60,75,241,230,188,124,141,222,61,240,223,12,189,115,64,145,189,175,244,117,189,3,49,222,188,170,210,231,187,204,26,134,188,9,5,91,60,0,57,211,189,62,249,72,61,11,205,106,189,225,186,223,188,129,194,42,60,31,209,170,189,196,255,22,61,150,50,122,61,19,184,88,60,108,240,159,189,218,156,26,61,128,206,11,189,179,182,121,189,82,135,44,189,151,121,163,189,154,29,165,186,201,124,249,188,70,150,74,188,33,71,129,189,72,46,68,61,41,128,60,189,237,165,175,61,225,134,206,60,245,200,244,60,31,62,211,61,235,150,144,61,87,41,57,61,213,80,53,189,215,158,6,62,92,193,171,61,190,82,177,60,183,30,11,187,54,254,22,189,187,250,169,188,8,224,28,189,217,197,122,188,68,87,220,60,92,11,243,61,96,138,119,189,42,38,228,188,72,150,67,189,89,213,71,61,77,17,130,61,130,37,15,61,56,107,112,60,98,133,154,58,149,99,51,61,37,124,5,59,6,37,34,189,204,191,47,188,243,237,210,59,41,121,245,60,165,5,12,189,158,150,160,188,6,191,71,188,65,50,143,187,232,217,208,188,80,201,216,60,71,188,133,188,198,217,211,59,117,21,158,188,68,221,156,59,59,66,75,61,108,5,28,61,82,205,148,61,81,218,107,61,10,65,25,189,209,13,135,60,217,125,10,188,194,181,35,61,121,163,167,189,56,45,216,60,30,238,36,189,252,215,224,188,243,196,38,189,122,192,137,58,108,51,66,189,54,229,137,189,176,156,14,60,246,156,179,188,44,104,177,58,100,109,250,188,51,193,243,188,35,145,236,188,252,92,70,188,196,198,69,189,68,173,185,189,146,45,204,189,8,32,22,189,47,208,104,186,104,207,139,189,1,224,152,188,144,150,20,189,225,187,102,188,164,137,153,60,106,13,170,188,14,75,187,61,11,76,17,189,87,13,93,61,130,253,43,61,177,78,85,60,134,159,10,189,127,229,249,189,178,229,139,61,117,49,24,189,46,155,28,60,251,179,165,59,0,206,103,61,179,11,128,59,78,18,230,60,113,5,98,189,43,7,24,189,28,74,232,188,237,15,53,189,255,18,41,188,37,75,154,60,174,47,11,188,255,231,192,189,243,249,79,188,8,196,174,188,56,181,208,189,104,167,160,189,188,172,31,59,151,56,134,187,165,6,69,60,150,36,132,189,30,246,216,189,120,233,201,188,8,51,180,188,110,151,151,189,7,55,149,61,11,168,104,58,251,116,35,60,132,188,10,60,96,203,24,61,232,252,237,188,39,93,18,61,43,247,51,189,111,14,246,189,149,28,2,61,197,227,52,187,231,175,221,61,50,132,80,61,228,98,88,187,43,223,81,189,107,104,165,59,165,0,104,189,167,106,196,187,228,205,90,189,239,28,72,188,205,145,83,60,117,125,34,60,184,12,248,187,157,171,125,189,24,41,19,187],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+133124);allocate([50,210,162,60,37,98,165,188,235,219,142,189,254,50,135,189,252,45,9,189,174,122,182,189,15,24,10,189,115,177,151,189,246,40,184,188,197,79,124,189,250,6,54,59,138,109,106,189,171,76,68,189,216,250,153,61,188,183,53,59,95,133,44,61,61,254,253,60,138,52,88,61,209,251,33,61,34,82,246,188,111,196,29,189,239,192,228,188,27,140,235,188,138,226,122,60,187,39,179,60,189,1,163,188,9,73,36,59,72,25,210,189,39,6,68,189,79,133,236,188,238,90,124,59,143,58,54,60,246,219,7,60,159,140,69,189,163,119,56,189,173,22,24,189,74,29,143,189,182,83,225,189,208,109,48,187,112,252,242,58,179,134,114,189,31,16,122,189,139,56,173,189,89,115,57,189,253,100,105,58,21,164,112,189,22,8,48,187,199,89,130,188,205,194,20,61,5,0,97,61,193,130,149,61,246,80,181,59,145,20,131,61,235,93,151,60,233,213,188,187,124,132,3,189,14,81,139,59,101,31,63,60,93,224,189,186,112,160,184,60,101,234,9,189,14,4,143,61,17,99,138,187,47,184,17,188,66,174,162,189,26,251,84,61,62,110,120,61,206,78,41,61,103,201,188,58,61,78,196,189,56,101,34,189,239,88,45,61,233,101,143,60,16,211,55,189,19,243,248,187,80,193,164,60,123,110,63,61,128,140,184,61,53,41,161,189,98,203,63,189,30,21,80,189,188,222,130,187,88,252,90,189,134,226,49,60,190,109,19,189,123,93,145,189,177,120,17,61,202,147,219,60,159,49,14,61,67,171,146,60,117,26,96,61,59,159,29,60,249,66,2,189,4,53,112,61,133,236,190,60,131,201,133,60,43,15,102,189,142,211,209,189,97,7,170,189,135,83,149,61,54,152,161,188,176,153,214,188,22,153,203,188,210,139,61,189,234,26,195,58,108,220,97,61,187,55,80,188,101,167,159,188,242,135,130,61,213,228,76,61,10,144,246,188,45,143,15,60,136,176,202,188,247,122,97,189,76,28,228,58,8,140,8,189,151,218,121,60,180,223,238,61,156,119,173,186,83,87,135,189,66,242,104,61,66,193,52,186,2,82,52,189,81,138,193,61,13,246,44,189,251,149,91,189,120,199,145,60,51,212,209,60,12,211,226,189,57,209,15,188,138,36,52,188,125,150,212,189,54,60,254,60,151,128,172,188,7,249,150,189,42,207,82,61,46,181,216,61,249,126,176,189,225,235,236,188,37,242,50,60,255,1,21,62,205,2,19,187,127,78,110,189,198,92,151,189,14,134,105,61,159,121,4,62,211,64,76,189,46,137,208,61,56,249,77,61,246,40,0,62,164,231,187,61,143,44,131,61,199,151,121,60,151,192,193,61,171,32,122,61,20,24,18,190,105,193,239,188,237,70,226,60,137,73,177,60,15,67,123,186,12,81,45,189,236,16,202,189,3,10,49,61,189,132,112,61,253,50,70,189,22,107,129,61,41,50,200,60,214,188,19,189,126,205,25,60,209,183,47,61,190,84,40,188,146,13,167,61,92,57,179,61,88,20,7,190,209,179,5,60,12,236,109,188,32,226,241,60,238,27,20,61,2,14,9,187,145,12,184,60,189,21,197,61,162,194,192,61,159,152,239,188,21,14,160,189,234,121,180,188,26,193,4,187,110,92,51,60,202,79,108,188,240,136,232,60,216,89,243,61,9,208,238,59,167,226,211,189,142,218,154,61,130,232,167,188,78,140,145,59,116,214,131,60,123,108,72,189,107,94,179,189,234,119,251,187,98,128,181,61,111,199,121,61,40,120,134,61,250,46,240,59,154,192,17,61,134,177,30,189,61,252,203,188,239,171,138,189,39,142,203,61,131,170,46,188,4,151,98,60,198,71,149,189,93,214,244,59,227,134,217,61,219,209,235,188,36,66,195,60,39,33,6,189,78,16,175,60,231,44,29,61,7,201,200,60,103,255,47,189,141,43,237,188,134,53,90,61,117,153,117,60,129,191,76,61,234,125,4,62,115,88,192,61,249,208,47,61,180,151,9,189,89,117,139,189,79,115,56,60,228,13,49,62,216,133,12,189,112,27,128,189,194,135,148,188,129,42,240,61,136,252,122,189,60,185,177,189,209,124,12,189,35,229,63,61,88,37,167,61,188,242,16,61,86,59,150,60,33,223,231,61,236,154,5,61,106,175,69,189,163,142,143,60,136,41,147,188,96,80,214,189,215,75,88,187,13,124,112,57,66,195,110,60,224,187,174,188,64,59,213,188,132,196,33,188,204,14,47,61,188,77,172,188,236,183,163,189,165,55,214,60,217,252,172,188,52,164,142,189,132,195,9,190,1,136,140,189,64,171,199,187,87,253,168,61,59,223,31,62,27,145,33,59,59,143,17,60,90,27,42,189,100,85,168,60,89,47,88,61,156,243,252,188,234,208,230,60,116,188,14,62,22,125,156,61,109,150,20,189,48,255,246,188,158,138,37,189,122,239,94,188,250,16,127,189,179,80,224,188,228,8,11,62,166,3,28,62,227,228,92,189,48,226,228,189,70,182,176,60,230,214,59,60,222,166,87,189,181,17,135,189,97,54,225,188,59,234,241,61,239,55,50,62,122,95,123,189,234,89,225,189,24,115,93,188,131,6,143,188,126,170,175,189,101,22,55,189,66,27,122,189,139,67,216,61,208,15,85,62,39,231,187,189,236,5,58,58,117,156,18,61,251,195,147,61,79,1,182,60,135,186,149,60,238,143,1,188,108,12,116,60,52,175,20,62,220,153,131,189,54,249,244,60,210,42,236,186,88,160,101,188,131,217,42,189,163,212,114,187,77,44,186,189,245,251,194,61,251,39,181,61,75,59,217,188,106,33,247,188,110,234,209,60,82,249,17,61,98,97,28,189,134,216,106,60,93,228,184,60,185,72,235,60,40,40,36,60,72,175,129,189,124,179,49,61,162,101,143,61,18,191,64,189,39,228,149,189,174,124,215,60,141,121,254,60,118,40,136,61,126,128,223,61,171,152,133,188,149,105,238,60,214,42,237,60,22,170,164,61,66,187,142,61,180,55,139,61,108,112,199,59,1,130,136,59,193,209,182,61,166,227,255,188,42,50,221,60,66,124,63,60,2,169,133,188,207,16,151,59,155,124,11,60,226,43,17,189,18,79,18,61,100,211,140,59,130,99,161,188,52,37,16,188,135,197,196,61,93,1,125,60,13,183,32,189,10,174,149,61,240,68,120,61,106,20,10,57,220,199,2,188,38,140,196,60,113,55,121,189,224,189,224,188,5,71,96,189,240,55,41,189,191,206,17,61,42,75,250,60,47,61,244,60,243,43,24,62,53,188,144,60,132,70,241,60,192,161,72,61,59,64,40,60,190,84,230,60,94,79,169,61,108,209,223,60,155,200,74,188,22,217,240,61,133,187,27,61,73,145,7,189,163,4,172,59,162,144,201,188,210,123,220,60,250,46,93,61,194,136,207,189,20,198,130,61,84,238,148,188,54,25,185,60,9,91,18,61,55,220,42,60,148,31,42,189,59,154,37,189,68,164,134,60,197,135,170,61,200,229,241,57,105,107,89,189,101,210,174,189,139,10,211,186,127,64,177,188,154,23,146,188,58,23,30,61,162,14,174,61,103,84,141,188,135,164,176,61,236,45,225,61,73,245,187,61,208,11,174,61,161,153,156,61,206,147,100,61,32,167,220,60,157,188,204,61,163,194,185,61,84,139,136,61,244,142,112,61,170,36,184,188,89,45,159,61,241,31,254,61,212,82,1,62,134,185,92,186,182,30,114,60,48,184,187,61,128,143,67,187,206,110,132,189,150,136,144,189,199,177,91,57,113,15,181,60,130,217,176,188,232,45,176,189,124,44,187,188,213,175,131,59,62,189,28,60,121,230,169,188,242,218,61,189,11,217,248,187,13,172,97,188,88,192,58,189,38,9,8,190,36,151,177,189,28,175,21,189,102,63,59,60,9,172,6,61,196,239,51,189,152,157,123,61,9,92,53,62,168,176,212,61,12,196,89,60,100,47,206,61,52,254,254,61,178,93,55,189,147,83,185,61,109,250,59,61,255,183,228,61,110,223,175,61,187,71,67,61,8,35,219,58,163,80,193,60,181,2,28,189,86,13,0,61,244,52,157,188,125,109,105,189,254,191,193,188,129,130,133,189,134,89,101,189,86,90,145,189,2,62,7,189,95,75,65,189,38,59,210,188,176,239,88,60,78,11,189,189,219,6,98,189,246,9,65,189,86,123,10,189,108,157,137,189,179,248,65,60,248,2,191,189,96,149,134,60,163,59,27,61,85,200,216,187,132,171,159,61,235,104,148,61,160,197,64,61,79,184,206,188,27,1,139,188,25,64,165,189,114,6,119,61,29,152,215,61,165,104,135,189,121,231,243,60,195,199,214,60,115,200,156,60,76,168,173,189,174,123,129,189,142,246,10,190,37,143,156,189,187,174,24,60,229,201,165,189,98,218,208,189,40,40,85,189,217,135,103,60,158,192,159,189,224,109,154,188,201,202,153,189,138,151,207,189,129,127,85,189,138,167,203,189,240,30,175,186,148,229,129,189,70,39,43,189,242,105,253,189,200,14,232,188,128,29,120,189,183,204,110,61,87,188,155,61,145,90,132,189,22,121,3,60,53,41,237,61,79,144,252,61,91,19,162,60,121,129,50,187,149,165,111,61,124,119,63,189,88,221,82,61,97,15,44,187,253,119,230,61,145,159,202,61,18,102,200,61,218,215,62,189,57,159,52,188,67,104,143,189,51,11,253,60,118,43,210,188,125,28,157,189,62,10,80,59,171,216,220,189,194,149,189,188,53,29,227,189,227,229,39,188,178,67,255,60,247,91,75,189,87,237,186,60,210,57,180,59,61,154,172,189,37,97,22,190,192,25,158,189,1,161,8,190,108,93,57,189,3,11,203,189,79,20,212,60,7,26,14,61,203,9,63,61,199,95,239,61,129,147,197,61,57,94,222,61,249,91,109,188,59,30,48,61,100,130,138,189,212,169,174,58,94,193,18,62,91,31,155,61,80,185,187,61,233,113,104,61,132,242,231,61,185,73,53,188,167,238,168,60,163,53,235,189,96,112,153,189,148,164,234,188,35,0,81,188,54,65,142,189,192,225,206,189,39,125,40,189,94,111,181,188,0,185,80,188,206,50,153,189,14,48,216,189,210,25,156,189,242,143,204,189,190,147,234,189,6,70,247,189,40,198,192,189,180,92,146,189,231,18,38,189,31,247,122,189,172,229,44,61,219,115,157,61,209,231,39,61,56,173,1,62,181,92,22,62,47,215,94,62,101,66,0,62,214,189,60,62,95,27,218,186,103,212,27,59,158,211,108,60,229,190,15,61,8,121,217,60,160,162,140,60,151,30,92,61,206,47,241,60,254,233,231,61,138,96,115,188,10,0,132,188,166,53,243,186,223,246,139,188,0,166,94,189,143,44,89,189,16,119,87,61,231,193,18,189,243,194,179,185,194,91,178,58,153,179,53,189,83,50,45,189,212,102,6,61,187,126,96,189,178,217,208,189,168,149,147,189,21,250,219,189,117,230,193,188,208,128,210,61,2,21,52,187,214,207,4,189,76,38,189,60,124,80,232,60,131,241,211,61,188,128,72,62,38,246,209,61,98,168,164,61,162,83,98,61,89,176,7,190,141,104,19,190,38,131,77,59,3,188,10,189,40,149,18,60,170,111,93,61,155,246,162,187,14,211,66,188,205,84,148,57,202,206,31,189,165,166,72,189,70,81,177,60,72,147,98,188,9,150,151,188,12,35,153,60,123,181,200,188,249,187,187,60,18,221,167,61,252,138,7,61,174,179,217,189,242,169,202,60,8,232,90,61,203,0,197,188,16,220,4,189,75,241,181,187,115,11,164,189,63,82,230,60,249,126,45,61,36,74,152,60,124,202,72,61,169,164,107,188,219,40,122,188,224,117,167,60,155,39,77,189,192,214,45,61,214,227,155,61,113,197,74,61,8,154,118,189,167,153,139,187,183,124,6,62,12,185,107,188,41,119,160,188,2,166,37,189,5,119,254,189,146,90,58,59,87,141,78,189,217,206,186,189,99,161,240,59,153,72,192,61,161,171,241,61,252,194,154,59,39,157,145,59,246,135,163,189,199,4,20,189,168,242,55,61,42,8,184,188,150,188,63,61,132,170,86,61,228,183,176,60,121,142,60,189,201,68,68,188,19,46,225,188,195,122,11,62,18,121,180,61,52,201,159,189,26,103,159,59,5,250,130,188,140,216,39,60,156,221,13,189,101,195,188,188,153,6,178,189,10,76,136,61,139,252,108,61,254,112,1,190,50,7,189,60,30,69,150,61,243,30,154,61,29,127,74,61,228,149,183,188,180,90,204,189,104,91,20,62,116,144,134,189,89,225,160,189,15,218,231,60,23,213,10,186,102,71,63,189,112,33,242,189,174,206,250,189,40,88,29,190,27,59,243,188,10,113,165,61,119,94,10,62,237,162,235,61,143,45,66,61,140,114,97,60,236,188,111,189,98,244,123,188,216,246,98,189,107,17,204,60,191,44,235,188,232,45,226,60,27,21,116,62,114,214,100,62,145,19,211,61,219,179,141,189,17,129,207,189,190,212,78,190,26,118,78,189,48,19,139,62,156,95,189,62,225,216,176,62,108,248,148,62,118,105,103,61,125,253,40,61,114,184,153,61,149,72,224,188,19,48,10,188,144,230,150,61,75,124,135,60,145,146,192,189,55,21,196,189,45,142,113,60,49,254,145,189,117,192,13,189,255,68,234,61,158,211,12,62,41,198,130,189,88,60,129,189,89,70,6,60,55,7,238,61,163,133,165,59,84,180,155,189,139,32,137,61,222,180,131,62,160,24,185,61,42,151,147,62,65,208,6,62,204,154,89,189,74,20,175,188,107,254,12,189,198,29,128,189,249,186,31,61,250,82,60,62,139,52,133,62,204,55,10,61,199,104,152,60,191,90,67,62,198,246,57,62,73,52,97,59,239,197,248,188,231,141,73,62,231,34,181,62,97,173,127,62,237,255,3,189,174,86,148,62,17,161,220,62,207,149,157,62,20,78,191,60,5,74,202,189,137,138,224,187,210,50,183,61,18,237,166,189,211,194,228,60,166,5,126,62,205,139,49,62,43,65,127,61,187,167,213,189,175,135,42,190,128,37,7,190,7,186,174,189,39,87,69,190,197,156,10,190,89,189,99,62,230,205,200,62,41,46,136,62,26,203,73,188,163,125,38,60,138,2,9,62,175,34,246,61,231,198,70,189,208,26,162,189,247,24,144,61,37,25,126,59,53,244,122,189,94,193,25,190,253,154,233,189,222,60,175,189,26,39,152,189,203,5,37,190,223,79,7,62,49,138,131,62,61,97,105,61,46,136,140,61,59,143,197,187,94,46,2,188,38,151,68,61,242,29,137,61,206,216,157,188,219,53,126,61,242,188,9,62,106,177,130,189,53,138,67,187,153,169,14,189,104,17,247,59,113,144,31,61,191,201,234,61,213,205,136,60,59,161,7,60,29,124,245,187,143,223,239,189,238,31,218,189,38,12,212,189,255,142,76,189,207,179,72,186,253,180,247,60,144,240,66,189,27,143,149,189,174,151,110,189,148,184,6,190,235,230,217,189,97,151,70,190,211,66,204,189,226,45,162,189,166,214,242,57,153,96,45,186,247,87,34,62,87,85,175,61,243,224,156,189,19,39,164,189,253,122,124,189,128,56,154,60,83,87,63,186,250,25,140,61,201,112,29,61,129,157,79,62,55,147,97,62,146,100,172,187,138,247,109,60,241,171,129,189,191,180,234,60,122,101,104,61,13,70,249,61,235,43,29,61,198,161,17,61,91,37,218,188,116,137,210,189,135,168,133,189,141,163,226,189,58,21,184,189,95,236,206,189,243,203,4,60,62,12,195,59,151,113,214,60,1,188,139,188,173,48,223,189,53,241,163,189,181,217,230,189,54,93,125,189,15,2,122,189,97,212,130,60,131,161,114,189,79,187,192,61,93,18,106,62,5,171,5,61,249,181,138,61,91,100,184,189,144,196,38,60,111,62,158,60,113,181,176,61,237,74,106,188,118,91,224,61,140,28,42,62,23,112,199,188,148,148,7,189,65,136,45,189,104,163,70,60,213,137,201,187,1,108,142,61,17,3,247,60,45,120,146,60,201,223,227,60,234,200,99,189,53,215,18,188,215,161,75,189,133,207,153,61,93,110,145,60,12,64,113,61,170,117,163,189,79,104,21,61,211,254,116,187,48,41,182,189,194,172,131,189,1,61,165,189,23,34,18,61,226,15,146,189,52,142,236,187,228,236,195,189,80,39,55,62,49,178,24,62,184,147,169,60,81,128,77,189,112,127,76,189,73,160,128,60,180,228,202,189,12,57,132,61,98,249,28,62,131,185,64,62,138,104,239,61,107,22,65,188,13,73,182,188,106,21,156,188,203,90,210,61,158,59,238,187,45,226,238,61,49,133,23,62,26,43,159,61,236,155,196,60,132,158,91,189,118,158,161,188,12,121,97,60,57,9,138,61,221,163,133,189,84,139,106,61,27,4,197,188,213,140,15,190,162,251,169,188,222,80,61,189,209,11,64,189,199,230,150,188,85,41,158,61,43,198,70,189,19,131,122,60,194,27,73,190,158,136,221,61,122,122,27,61,167,59,193,189,35,133,163,189,241,149,10,189,25,242,226,61,247,72,183,60,211,20,2,62,134,83,93,62,118,27,239,60,136,218,152,59,190,106,210,189,65,211,70,189,117,244,98,187,206,50,177,61,88,114,184,60,170,88,197,61,81,238,47,62,5,230,189,189,85,189,240,57,137,22,240,189,38,16,250,189,240,52,31,190,21,212,147,61,241,255,88,189,139,211,26,61,215,250,82,61,28,190,27,189,168,138,30,61,203,42,28,190,179,26,178,189,48,155,165,188,18,182,40,61,38,108,27,190,168,61,129,60,219,231,209,61,19,198,245,59,228,12,141,60,138,219,139,189,60,105,196,188,165,37,135,189,62,217,48,189,185,43,165,189,49,113,218,59,29,138,8,61,0,71,145,61,123,146,168,61,40,183,134,189,60,49,137,189,96,8,143,189,201,72,133,189,129,216,16,190,220,13,196,188,170,209,132,61,193,182,16,60,77,118,189,61,123,199,154,189,173,146,79,189,169,173,200,189,97,72,137,189,187,239,15,190,183,244,4,61,239,141,0,62,223,79,144,60,38,235,4,62,89,50,39,189,127,218,243,189,110,175,23,190,227,142,171,189,181,222,249,189,104,80,76,61,90,45,94,61,124,27,128,187,214,90,5,61,12,59,2,190,182,207,152,189,102,162,105,189,134,58,142,188,160,97,164,189,130,146,94,189,146,217,140,188,147,113,236,60,58,55,145,60,58,171,187,189,34,123,106,59,86,118,207,189,119,101,217,188,8,136,166,189,15,157,29,189,135,203,71,186,184,216,132,61,150,122,73,62,23,125,73,189,43,146,144,189,145,249,70,189,182,200,42,188,33,146,170,189,12,237,21,61,61,108,23,189,117,138,75,61,108,199,168,61,243,38,0,190,233,200,122,189,184,155,25,189,189,248,213,59,232,220,209,189,31,102,210,60,44,10,148,59,59,244,24,189,167,88,57,188,182,173,93,189,247,34,105,58,235,185,253,189,33,23,116,189,70,85,254,189,167,248,123,189,209,182,149,189,138,3,200,60,132,215,143,61,198,150,154,189,87,123,70,186,143,147,185,189,92,39,166,189,85,186,141,189,50,94,28,60,102,222,71,188,138,244,158,58,238,166,17,188,171,44,170,189,28,122,58,189,234,243,219,189,209,26,105,189,127,159,14,190,104,227,184,61,75,220,26,62,134,22,2,61,39,230,53,62,53,248,172,57,118,5,83,61,76,155,201,189,203,13,194,189,5,138,175,189,82,80,38,62,54,0,70,62,64,124,12,60,165,0,235,61,34,196,116,188,62,80,9,61,236,160,183,189,95,62,190,188,18,51,218,60,73,46,95,61,232,222,16,189,152,171,147,189,189,105,139,189,35,185,255,188,206,253,114,189,251,249,48,190,108,139,34,190,100,3,75,189,65,89,131,60,7,170,253,189,226,29,14,62,65,213,91,62,218,87,10,62,106,246,86,62,224,41,181,61,94,248,165,61,99,197,25,61,45,78,249,61,75,100,227,61,157,248,217,61,191,194,14,62,35,101,238,61,213,106,23,62,155,152,71,60,130,45,62,60,217,82,17,61,132,27,180,61,200,226,138,188,154,137,157,189,48,173,168,189,238,142,222,59,115,100,201,188,188,90,5,62,63,82,224,61,31,227,201,61,211,251,65,61,188,81,50,189,30,96,27,190,108,87,55,190,1,6,214,189,235,102,9,190,137,216,135,189,219,219,1,189,14,16,140,189,89,115,232,189,209,7,143,189,93,106,67,62,42,68,52,62,199,82,158,61,142,67,205,61,13,131,186,62,202,218,144,62,120,238,1,62,23,63,35,62,170,5,16,62,249,105,229,189,46,11,15,190,178,31,186,189,199,116,16,190,142,155,81,61,122,150,44,187,216,18,221,189,247,248,198,189,0,121,88,189,112,66,128,60,245,19,78,61,218,202,143,61,51,187,242,188,214,191,144,60,76,172,170,61,200,137,3,189,76,152,160,59,56,114,84,61,99,172,78,189,128,29,197,189,255,237,206,188,68,167,141,61,84,227,70,60,252,121,90,61,104,9,13,189,236,239,205,189,144,215,128,189,180,225,177,59,115,142,206,187,189,250,185,60,58,251,144,188,27,23,6,61,194,163,158,61,209,163,254,59,88,126,78,61,58,3,135,60,25,46,190,188,198,94,203,189,150,233,187,188,213,180,166,60,205,122,170,189,63,73,174,61,159,229,24,189,88,105,132,189,65,82,121,189,159,22,12,62,160,228,234,189,199,152,31,189,229,72,146,189,175,92,47,59,79,20,21,189,113,181,201,189,213,146,225,189,192,22,51,62,241,85,52,62,20,199,36,190,21,117,148,189,84,97,128,60,215,32,115,62,137,171,154,61,176,106,128,189,189,146,149,189,149,67,130,62,129,22,45,62,187,75,167,189,178,59,114,189,180,245,33,189,151,103,223,59,227,0,102,189,242,144,149,189,79,95,249,189,163,165,253,61,25,37,98,62,186,12,99,189,99,152,7,189,28,196,106,61,155,126,71,62,82,131,36,61,214,185,132,189,181,255,252,189,152,212,63,62,77,63,197,189,182,54,229,189,195,11,254,61,140,122,32,62,201,46,69,62,106,36,223,61,55,234,10,61,158,114,5,190,101,122,102,189,45,216,184,189,9,125,112,62,46,102,142,62,163,213,136,62,60,154,148,61,131,160,41,62,8,66,101,62,158,100,152,61,116,18,87,190,9,98,165,189,81,237,25,190,30,217,143,61,206,168,222,61,57,236,57,62,117,46,77,62,25,250,10,62,126,8,244,189,167,251,227,189,147,79,65,190,2,209,120,61,83,186,82,62,113,56,254,61,53,251,32,61,150,97,149,62,212,13,151,62,183,159,142,62,65,192,147,188,128,117,42,62,190,78,69,62,49,180,155,60,51,214,118,61,40,148,26,59,154,75,127,60,186,198,221,60,199,31,233,61,199,227,247,61,137,11,32,61,44,242,61,61,255,191,184,61,177,29,244,61,129,230,109,187,6,224,181,60,196,178,211,61,235,174,49,62,76,20,251,61,185,99,66,62,63,37,33,62,86,44,62,60,8,129,138,188,147,43,126,186,40,189,147,61,149,81,62,60,168,239,54,62,247,188,122,62,199,117,58,62,24,158,78,62,127,162,116,61,86,118,18,188,17,206,189,188,181,212,19,62,79,136,16,62,91,35,98,61,28,31,130,61,213,214,67,190,205,96,208,61,185,154,150,62,23,106,135,62,129,98,191,61,47,130,28,62,250,185,74,62,117,218,232,61,239,71,2,190,75,25,91,190,190,131,164,188,101,124,134,189,208,41,136,188,120,66,33,189,143,184,67,61,238,129,77,61,211,86,188,188,92,239,78,190,237,252,130,189,208,130,12,62,52,219,102,62,239,116,24,62,151,233,177,61,232,176,138,62,218,229,164,62,231,86,200,61,146,173,61,190,33,117,48,190,250,164,42,188,201,49,36,61,17,5,44,61,72,129,165,189,113,210,25,189,203,0,69,189,125,229,85,189,94,77,94,190,72,163,135,189,5,71,241,60,15,111,60,189,246,73,87,189,231,180,172,189,252,80,233,60,55,249,14,61,233,194,7,60,91,84,226,189,209,151,229,189,40,179,163,188,75,238,91,189,164,164,181,189,199,129,64,190,221,174,94,189,203,70,77,189,215,253,93,189,229,250,123,189,226,192,221,189,210,10,50,61,175,127,36,61,208,43,121,60,60,79,249,189,127,229,71,189,81,116,52,188,154,39,5,61,182,38,118,189,197,141,252,188,115,4,188,188,143,109,140,189,148,183,179,189,241,164,115,190,4,229,187,189,132,217,98,189,75,253,48,189,240,49,243,189,62,237,44,189,120,165,120,189,128,180,67,60,147,177,213,60,12,108,31,189,96,155,134,188,156,40,213,188,119,227,85,188,58,145,32,61,125,105,133,189,94,162,56,60,50,176,205,187,133,211,222,188,79,4,228,189,120,46,7,61,155,123,196,60,99,26,39,61,34,92,216,189,182,95,116,61,52,211,67,60,219,58,2,189,47,168,138,188,92,11,125,189,166,220,150,60,202,147,180,187,178,181,139,189,95,189,2,189,201,125,195,189,61,67,248,60,224,139,72,189,24,196,238,188,125,5,8,190,201,237,67,189,14,45,199,59,8,126,109,188,192,201,8,190,214,103,198,189,132,129,230,188,204,209,70,60,54,49,136,61,86,10,167,188,121,196,8,62,28,52,117,61,245,139,21,188,16,79,64,190,231,156,245,189,150,227,129,189,101,114,73,60,26,75,146,61,5,103,219,61,86,9,227,61,122,137,134,61,46,48,242,188,222,202,38,190,64,75,15,190,2,196,83,188,14,0,29,61,130,253,186,61,69,85,80,189,247,21,102,61,132,155,31,189,103,169,128,189,190,80,235,189,130,16,18,190,186,145,57,189,116,236,130,60,169,193,187,61,156,108,177,61,216,25,72,61,11,41,107,189,107,242,154,189,54,122,47,190,67,149,214,188,153,246,202,188,3,131,219,60,128,4,238,61,123,252,179,61,109,238,30,62,51,231,64,61,237,128,56,61,42,47,209,189,173,196,251,189,23,115,69,189,167,168,96,189,121,52,96,61,136,116,150,61,253,113,100,61,220,35,168,189,237,215,13,61,61,167,86,190,192,247,190,189,118,178,120,59,162,45,20,61,56,113,43,62,207,140,144,61,97,255,208,61,47,43,139,189,20,142,83,59,30,234,0,190,59,43,51,190,103,65,170,60,107,148,157,189,155,138,249,61,13,67,184,61,118,87,68,61,177,33,233,189,24,202,164,189,146,171,131,190,132,127,165,189,57,14,223,59,109,12,240,188,40,216,71,187,237,116,227,189,29,153,61,189,248,47,160,189,250,90,252,59,126,223,209,189,50,167,158,58,35,173,82,62,103,192,4,189,210,28,10,60,79,116,159,60,161,70,68,188,136,76,21,190,169,104,45,61,243,176,135,187,230,159,140,189,216,55,199,188,211,137,10,190,58,2,165,58,124,252,233,189,13,71,48,189,217,214,138,188,192,76,106,61,113,64,36,190,216,39,227,60,83,54,97,61,77,181,25,190,187,181,109,60,109,137,192,60,76,43,48,189,104,211,74,189,26,59,94,62,36,102,1,189,115,213,160,188,202,179,58,62,54,176,5,189,100,14,61,187,151,13,130,60,146,173,254,186,98,135,159,189,20,116,63,61,38,253,204,187,191,205,182,61,145,169,90,62,248,144,77,60,9,92,143,189,123,242,114,189,52,93,154,188,137,98,48,189,61,139,241,61,236,101,29,61,46,8,32,189,240,218,102,61,3,2,200,189,20,92,172,188,43,252,14,60,121,52,224,188,20,102,81,189,33,12,46,62,78,35,242,60,168,138,171,60,48,83,172,61,0,162,8,189,201,43,20,189,229,231,109,189,92,179,181,189,109,214,239,60,119,163,138,62,32,214,120,61,160,39,153,61,6,127,28,62,28,23,32,189,16,248,80,189,177,249,27,188,197,9,6,189,213,231,178,189,54,85,156,61,187,39,147,189,26,188,13,62,196,0,160,61,97,28,4,190,7,208,96,189,177,51,103,189,134,201,6,189,87,16,229,189,16,170,25,61,122,221,116,189,3,128,187,189,63,185,103,61,82,72,49,189,202,175,249,188,46,135,103,188,249,129,208,189,182,193,98,188,59,40,78,62,32,205,123,188,187,125,156,189,14,241,113,61,61,108,160,189,217,168,121,188,71,167,153,189,135,199,193,189,74,188,25,190,219,91,36,62,5,194,184,61,41,136,173,61,149,179,10,61,103,86,187,189,115,208,187,189,155,12,174,189,145,174,81,189,177,160,213,189,160,168,42,60,226,19,251,188,156,73,191,61,212,16,132,61,205,247,30,189,22,52,76,189,161,125,23,190,32,255,84,189,82,173,175,188,166,223,35,61,201,96,254,61,240,175,151,188,16,159,40,189,88,197,244,189,94,216,71,189,25,163,178,189,39,39,173,189,2,12,216,189,195,112,230,61,168,126,220,61,217,160,68,62,80,10,123,61,8,5,224,188,113,240,180,189,6,20,46,190,32,87,17,189,175,170,175,187,45,241,169,61,8,255,147,61,211,206,43,61,150,58,63,61,31,46,15,60,8,244,142,61,140,134,103,61,115,210,112,61,13,236,202,60,17,210,200,60,65,164,254,61,163,98,101,61,105,8,141,61,74,59,30,61,239,194,152,61,112,122,185,60,132,4,117,60,252,237,129,61,228,60,142,61,97,46,240,60,65,3,240,61,131,113,57,61,195,11,5,61,40,126,8,59,234,126,167,60,234,138,233,61,148,73,48,61,150,252,131,61,35,31,75,61,203,103,167,61,130,61,189,61,3,124,72,61,131,143,184,60,17,96,135,188,204,97,155,61,66,100,120,61,156,228,14,62,128,38,227,60,244,67,145,61,248,26,174,61,222,94,139,60,16,118,185,61,37,30,171,62,37,122,78,62,123,34,201,61,19,216,162,61,121,19,178,61,160,163,2,190,212,252,13,190,203,95,135,189,177,251,224,189,14,139,11,61,135,230,54,188,112,33,149,189,218,128,10,190,168,135,3,190,139,108,183,61,167,213,187,61,207,176,206,61,88,119,111,62,25,150,176,62,173,201,202,61,82,20,164,60,30,164,252,61,87,198,155,61,179,145,24,190,57,25,32,190,129,2,133,189,89,57,144,188,110,112,11,61,50,66,7,190,250,212,247,189,33,86,59,190,232,148,41,190,110,231,178,60,123,126,225,188,191,146,148,60,234,230,163,60,160,65,88,60,152,117,164,61,243,248,71,60,66,115,67,59,125,38,86,188,26,139,116,61,93,241,90,189,167,134,10,189,150,204,33,188,95,175,140,189,82,17,34,61,45,159,254,188,220,208,106,189,61,246,177,60,76,98,42,61,212,55,44,59,93,38,69,61,6,172,191,61,185,21,6,188,240,70,141,60,103,176,208,188,202,117,75,189,209,209,195,188,94,255,135,61,146,40,129,189,247,94,58,60,224,240,100,61,187,181,168,189,26,29,201,60,187,160,250,188,162,96,183,189,148,81,140,61,182,65,147,61,130,222,155,189,39,251,0,60,34,192,0,188,117,11,118,61,102,154,56,188,187,67,59,187,110,127,67,189,36,106,154,60,244,168,25,62,173,98,128,189,221,241,162,188,234,131,58,60,254,105,179,61,86,226,30,61,218,107,30,188,254,26,164,189,190,94,131,61,68,78,95,188,115,24,187,189,90,200,143,60,249,168,54,61,154,166,197,61,31,207,85,61,16,208,15,187,18,35,144,189,152,254,130,188,143,45,6,62,172,49,204,188,222,43,41,188,195,214,237,188,65,224,55,61,152,221,82,61,182,56,152,60,166,36,239,188,55,248,169,61,103,5,60,189,59,60,33,190,121,183,185,189,220,128,243,188,114,247,4,62,208,143,100,62,39,113,120,62,244,51,21,61,5,139,97,189,119,64,47,59,189,10,29,189,142,21,132,61,124,19,29,61,13,88,28,61,121,51,128,62,96,42,175,62,189,15,166,62,125,195,64,62,237,31,176,189,203,55,52,190,163,216,28,190,123,5,203,189,44,248,233,188,205,71,89,189,157,130,139,186,59,6,136,189,89,202,153,189,207,193,111,60,205,169,154,189,176,190,56,189,239,97,10,188,57,45,145,60,137,162,38,61,238,210,79,62,150,247,32,62,190,247,105,61,0,164,134,62,108,24,22,62,46,131,125,60,50,246,78,189,210,250,30,189,47,149,107,188,167,240,73,189,74,4,240,61,142,196,118,62,236,132,135,62,246,75,162,62,1,236,206,61,77,161,51,188,174,248,95,188,184,37,47,62,4,120,77,62,154,99,47,59,165,249,66,188,145,104,59,62,112,188,193,61,60,52,130,189,93,149,132,189,145,193,97,60,163,120,205,189,102,215,130,189,93,75,121,59,114,51,126,61,50,243,211,61,251,60,137,62,255,1,6,60,117,151,189,188,130,24,25,60,2,98,188,61,128,201,22,61,75,190,15,188,230,226,197,189,134,120,222,188,169,70,10,62,130,142,183,61,39,79,215,187,1,31,3,189,181,249,145,62,127,84,164,62,235,145,61,62,87,185,17,190,111,219,15,190,176,18,147,189,214,159,175,189,38,100,177,189,53,87,50,190,1,190,69,58,215,113,101,61,74,29,11,62,244,45,75,189,45,222,157,189,188,166,218,61,120,136,52,189,85,164,147,189,74,16,22,61,115,56,148,62,36,146,210,62,149,114,140,62,151,81,141,189,77,229,91,190,115,134,31,190,135,63,72,190,28,191,27,190,244,202,230,189,55,225,151,61,162,120,66,62,139,131,137,62,215,237,159,60,190,198,38,60,49,239,176,60,124,65,162,187,144,235,50,189,25,69,2,190,193,174,136,189,200,234,230,189,243,197,52,61,215,124,100,61,155,156,31,61,152,20,18,61,116,130,112,189,223,78,151,189,165,247,55,190,227,132,175,189,220,101,28,190,149,172,118,189,92,91,143,189,64,81,223,187,15,232,128,61,177,173,43,186,46,235,56,188,150,145,187,188,126,160,70,61,122,155,41,61,200,128,114,62,196,242,20,62,151,4,163,60,206,109,246,61,133,237,125,59,142,117,197,187,87,121,114,189,89,68,251,188,97,126,159,189,44,229,221,61,254,110,176,60,221,143,226,60,151,214,34,61,132,129,249,189,105,181,72,189,192,146,203,189,130,43,132,189,183,223,12,190,133,109,24,189,95,158,231,60,39,58,50,189,124,57,156,60,104,158,210,189,108,74,104,189,200,96,220,189,134,25,197,189,70,231,195,189,54,151,85,188,150,91,252,60,199,20,104,60,62,117,111,61,193,235,177,187,231,212,126,61,34,0,8,189,148,24,139,189,159,54,109,189,24,153,3,62,75,128,25,62,44,221,20,61,76,13,18,62,113,95,49,61,80,34,78,61,230,174,102,189,34,147,131,60,94,179,51,61,16,208,100,62,242,255,32,62,66,64,64,189,136,76,246,60,171,186,37,187,154,49,106,61,112,53,154,189,56,91,233,188,18,172,140,189,205,5,148,187,175,108,132,61,243,28,115,189,0,182,64,189,90,208,150,189,35,97,70,61,84,111,9,190,86,124,200,189,38,7,210,189,119,195,15,61,138,159,66,61,246,143,28,189,26,124,199,61,203,22,67,61,109,99,33,61,34,164,169,189,13,165,195,61,2,99,78,61,52,176,89,62,5,146,197,61,95,194,4,61,70,171,83,61,70,3,61,61,73,92,49,61,140,224,218,188,244,51,128,189,77,146,188,188,138,207,64,62,180,129,215,61,19,171,48,61,82,226,136,60,36,123,172,189,179,33,114,61,80,187,216,189,113,225,70,189,88,127,171,189,48,64,159,61,19,132,24,61,199,186,246,189,159,93,159,59,212,119,215,189,16,151,134,61,30,45,154,189,30,241,4,189,84,30,202,189,237,255,238,188,182,82,59,190,1,170,23,62,201,100,23,60,149,96,50,189,6,180,185,60,75,39,243,189,253,132,36,189,52,218,231,60,195,204,102,62,154,151,82,62,194,6,43,62,97,186,184,61,77,25,85,60,168,229,199,61,226,143,22,189,73,141,158,188,203,52,141,189,50,108,165,61,250,11,67,62,165,172,231,61,251,46,40,61,14,29,229,189,12,167,48,61,253,239,61,190,76,41,231,189,199,28,180,189,182,64,170,60,51,160,28,190,119,203,241,61,81,192,52,188,83,139,35,190,247,106,176,60,10,79,86,189,68,232,221,189,49,113,14,190,150,131,114,61,150,79,207,189,150,149,78,62,153,124,186,61,186,30,154,188,190,196,195,61,69,155,24,189,39,100,193,189,38,243,199,189,102,204,111,61,179,184,169,61,156,76,4,62,40,3,176,61,151,182,35,187,239,122,196,60,28,27,186,59,244,242,128,189,20,13,5,190,138,239,29,61,6,113,84,61,86,0,222,61,185,118,10,189,226,149,1,190,44,40,93,189,28,183,152,189,254,254,65,189,216,41,208,189,91,133,153,61,134,103,166,61,107,204,156,61,163,200,76,189,237,78,3,190,78,138,157,189,108,200,231,189,4,192,186,189,107,75,105,189,192,146,214,61,224,244,152,61,150,136,133,60,196,58,3,188,79,205,134,189,68,159,36,189,215,207,63,189,89,74,156,188,186,59,225,189,211,43,73,61,39,28,240,60,113,240,43,61,146,128,108,189,3,14,198,189,203,63,19,189,211,89,11,189,235,106,146,189,82,101,216,189,69,29,217,61,121,219,129,61,11,208,120,188,218,109,195,187,192,56,156,189,133,50,103,187,127,220,219,188,193,60,210,189,196,156,219,188,22,78,39,62,109,61,254,60,20,43,188,60,12,17,133,60,226,212,221,189,252,148,189,188,119,50,68,189,152,137,98,189,229,83,132,189,112,237,214,61,224,43,62,61,244,128,155,189,191,221,125,189,238,46,185,189,140,213,108,188,227,9,48,189,101,165,230,189,206,24,234,189,122,7,2,61,63,161,22,189,128,207,242,188,83,96,135,189,79,28,8,190,215,145,144,189,118,239,172,189,14,80,216,188,129,38,146,189,184,198,58,61,0,52,111,60,190,53,56,62,201,171,53,61,21,71,255,189,165,51,235,188,139,52,220,189,247,1,11,189,203,75,27,189,178,192,208,60,87,61,160,60,82,19,69,62,213,251,14,62,58,219,113,189,108,14,152,189,66,60,213,189,237,20,202,58,209,62,147,60,120,98,5,62,124,69,58,61,89,229,105,189,238,19,219,189,192,33,10,190,82,113,133,189,137,54,131,189,149,225,133,187,41,248,90,188,135,241,50,61,92,153,230,189,250,137,105,189,72,129,132,189,60,240,170,189,192,171,42,189,172,98,109,189,182,232,168,189,210,55,107,189,39,26,173,61,165,57,9,189,252,41,15,62,11,180,7,62,116,111,155,61,65,107,154,61,99,243,248,61,47,116,67,62,164,30,26,62,62,154,89,62,70,122,17,62,147,190,84,60,190,148,152,61,143,84,134,61,68,79,139,60,238,217,56,61,62,147,45,62,56,40,210,61,91,213,39,62,186,124,97,61,35,112,13,189,137,150,176,61,65,135,162,61,28,222,34,61,236,203,166,60,125,173,129,59,169,209,5,61,12,4,28,62,216,148,84,60,136,19,166,189,67,157,102,60,11,104,144,59,67,54,27,190,233,70,233,189,147,88,153,189,10,3,0,188,35,62,225,188,230,131,208,189,201,219,12,62,16,111,15,62,186,15,10,62,100,227,140,62,157,93,175,62,206,117,156,61,111,220,148,61,30,255,74,62,2,59,37,62,63,122,43,189,197,232,2,190,231,166,201,189,206,205,1,61,204,191,224,61,182,33,26,190,83,157,182,189,179,51,146,189,5,31,42,189,231,239,204,59,82,135,79,60,143,184,215,61,30,141,2,62,182,29,27,62,49,132,117,60,85,37,129,61,33,84,76,188,26,200,179,189,123,36,175,189,101,215,244,189,199,242,173,189,98,179,237,188,213,47,196,188,229,126,9,190,154,94,226,189,127,151,19,190,128,174,27,190,104,185,34,61,21,26,195,185,212,17,44,189,168,16,122,61,57,14,156,60,3,61,53,188,147,94,238,187,185,23,121,188,141,122,144,58,253,183,74,189,183,27,164,189,204,116,187,59,55,89,172,61,26,152,133,189,173,20,22,61,193,249,218,188,102,29,247,189,15,163,23,189,142,7,118,61,240,107,133,60,134,110,202,187,115,199,167,61,249,227,95,187,0,39,235,60,73,220,109,61,57,41,75,61,223,41,61,61,78,197,72,189,112,171,216,189,130,82,186,60,154,54,247,61,111,137,18,59,196,90,201,61,205,98,247,188,186,1,229,189,164,52,75,189,82,182,204,60,129,42,24,189,150,174,132,188,235,141,216,60,22,2,250,187,1,30,236,188,88,178,127,189,46,217,172,189,71,226,147,61,7,196,148,61,41,217,127,60,69,75,253,60,74,250,139,60,4,136,27,189,176,197,80,187,48,10,133,60,122,183,231,188,252,26,231,61,11,98,173,186,22,111,159,189,114,164,147,189,133,32,10,61,189,236,248,61,78,159,186,60,160,21,88,189,135,41,157,188,167,2,5,62,248,46,94,61,92,32,191,60,92,7,37,61,149,206,253,61,182,119,194,61,218,55,188,61,234,134,162,61,93,168,15,60,159,153,47,62,57,122,11,188,4,18,164,189,25,48,139,189,80,21,72,61,18,60,54,60,146,119,160,189,84,124,150,186,252,238,12,189,18,21,233,60,206,154,157,61,183,200,144,189,83,181,60,188,129,230,11,188,38,55,136,188,71,141,42,189,102,52,93,61,254,56,234,60,173,91,239,60,172,237,76,61,51,178,224,187,86,190,133,188,190,86,159,61,239,151,37,61,49,77,71,188,108,135,108,59,197,123,129,189,13,231,194,61,93,220,3,62,159,201,30,188,200,242,40,60,159,53,84,61,115,34,25,188,91,184,134,188,23,161,70,189,33,230,49,189,191,87,215,61,139,203,164,61,239,9,61,189,254,213,34,189,111,99,115,188,142,28,6,62,112,179,120,188,172,151,134,189,182,130,36,189,211,136,151,60,151,219,199,60,170,55,165,61,113,37,229,58,243,117,144,61,173,159,180,61,180,147,166,187,99,41,134,189,138,74,169,189,199,88,159,189,29,34,110,60,83,87,179,189,150,166,51,60,198,193,14,188,243,15,207,61,53,79,198,60,63,99,137,189,217,122,164,60,155,91,194,59,208,35,93,61,142,97,154,61,104,223,167,60,128,182,183,60,30,75,36,61,66,228,189,186,238,85,137,187,217,104,130,61,55,94,205,60,236,111,199,60,8,210,112,61,37,213,6,188,193,143,75,188,143,13,45,61,103,195,143,188,217,11,116,61,236,107,28,61,127,241,149,188,69,126,48,189,25,34,53,189,219,73,199,188,175,137,185,60,209,135,5,59,30,31,68,60,107,212,53,61,231,57,249,61,47,145,19,61,63,238,212,188,227,232,1,187,199,162,167,60,15,49,216,188,90,170,250,186,141,44,191,189,233,65,19,189,68,231,33,188,147,65,140,189,188,33,63,189,187,228,203,189,158,75,44,189,69,188,213,60,114,238,20,60,145,50,146,189,236,105,221,185,59,185,144,60,251,205,225,60,19,89,86,60,164,1,38,61,210,149,195,60,160,157,90,61,8,218,204,60,44,155,75,189,81,85,255,189,227,68,52,62,228,2,251,61,217,217,153,189,93,157,14,60,31,95,105,189,86,138,20,189,63,160,15,188,180,100,70,188,50,145,193,189,2,105,153,61,213,126,164,188,122,166,219,188,219,94,132,189,219,160,120,188,16,112,240,59,66,243,198,59,185,207,190,189,203,103,59,189,123,204,7,62,95,243,29,62,30,167,135,188,59,29,227,188,152,199,86,189,119,10,193,188,214,167,192,188,70,34,209,189,228,209,3,190,101,253,20,62,13,52,0,62,21,198,143,59,52,12,229,60,193,198,83,61,53,230,188,61,73,65,113,61,8,179,194,60,43,133,227,188,148,179,194,61,84,201,190,60,107,12,190,188,121,214,3,189,76,82,122,188,61,147,38,188,236,28,219,188,58,107,82,61,148,65,162,60,192,7,134,61,220,11,143,188,127,41,40,60,228,226,127,60,18,238,80,58,97,175,155,61,238,61,156,60,238,143,252,188,91,62,117,189,205,74,189,61,32,11,21,62,188,181,41,60,89,84,253,60,35,216,195,189,146,190,27,189,240,89,207,60,186,68,252,60,50,108,145,189,36,109,8,61,81,94,48,187,138,189,1,61,174,80,107,61,122,134,5,61,137,178,250,58,148,217,2,61,181,87,151,61,169,16,180,60,141,84,156,61,181,226,6,61,86,113,186,189,78,65,65,61,39,247,121,61,131,87,36,188,189,217,191,59,98,117,121,188,223,87,190,60,115,196,216,61,56,212,142,59,177,45,122,61,195,96,112,61,108,57,255,188,84,3,71,60,7,116,175,61,246,20,129,59,112,143,206,188,0,249,246,186,18,245,166,60,132,83,36,186,92,153,72,61,48,85,47,189,26,106,69,189,145,34,69,189,39,195,109,188,200,244,80,61,241,163,19,188,12,142,8,189,188,122,32,61,242,226,43,61,76,206,47,61,24,40,230,60,149,188,245,60,9,44,39,61,206,25,21,60,226,184,198,61,189,147,212,61,85,104,192,60,179,233,154,187,34,81,40,60],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+143364);allocate([227,11,213,61,31,59,247,61,236,14,201,61,77,250,213,188,137,7,21,61,74,132,113,61,124,69,71,61,202,91,68,61,22,5,31,189,25,168,242,188,163,65,72,188,202,197,38,61,142,131,157,60,7,108,187,188,155,84,8,61,252,75,152,60,246,212,184,61,154,212,27,61,72,100,105,188,224,12,160,60,124,150,205,60,79,228,10,189,186,254,103,189,204,130,134,188,236,142,111,61,119,10,62,61,218,98,171,60,124,55,4,62,53,246,75,62,34,131,158,61,6,213,237,187,198,231,38,61,150,106,2,61,253,132,182,58,224,16,106,188,243,209,152,60,92,175,174,61,252,185,10,62,13,42,229,61,132,203,35,61,126,29,196,61,53,138,215,188,105,166,13,189,52,143,66,189,18,168,120,189,128,160,154,59,128,2,132,61,5,181,200,188,143,157,96,189,171,194,62,189,57,91,166,188,122,146,14,189,45,119,192,189,244,16,131,189,228,212,147,188,50,69,184,59,110,216,217,187,104,124,133,189,89,34,228,59,34,98,152,188,193,232,45,189,139,161,111,189,41,156,84,187,214,181,157,61,80,61,231,61,65,57,203,61,250,89,243,188,174,16,101,61,58,46,69,61,235,238,200,189,218,166,191,189,140,48,6,189,61,190,85,61,119,161,41,61,94,197,128,59,170,190,78,189,103,110,35,62,183,240,60,61,94,27,255,188,63,119,62,189,146,28,5,189,97,181,198,188,213,151,48,189,20,113,48,61,242,140,192,189,181,67,66,189,128,137,77,188,104,36,135,189,79,184,95,59,163,54,102,189,197,151,238,187,96,177,117,189,25,31,6,189,9,20,151,189,230,17,81,59,142,95,158,189,193,55,110,61,29,110,202,188,165,184,29,61,139,181,13,62,208,177,29,62,111,212,141,60,115,22,114,188,10,219,212,61,197,88,83,61,63,97,159,188,249,99,12,189,197,93,71,189,0,47,189,61,92,206,219,61,196,175,120,61,204,3,94,188,243,22,151,60,221,146,14,189,251,130,27,189,94,26,98,57,124,212,94,189,34,209,154,60,33,125,108,188,171,163,213,188,89,174,240,188,252,224,222,60,122,29,127,189,11,97,243,188,106,86,12,189,102,141,210,189,93,5,138,189,251,33,86,189,55,163,9,61,131,251,230,189,217,170,142,189,37,184,14,190,69,63,21,60,167,33,132,57,206,123,133,187,52,31,252,61,139,88,191,61,48,142,149,61,24,250,3,61,251,69,154,61,15,86,27,61,103,49,76,189,63,213,147,60,93,181,220,60,240,12,10,62,87,119,60,61,212,56,40,61,115,78,174,61,74,52,252,61,160,103,88,60,113,155,78,61,76,48,181,187,64,43,184,189,67,67,184,188,19,144,167,189,242,134,124,61,245,99,5,189,193,33,47,188,123,214,88,188,125,38,245,189,232,21,61,189,129,147,247,189,136,127,138,189,153,179,177,189,180,199,131,189,161,52,145,60,141,29,14,61,242,198,223,189,127,229,246,60,216,171,15,62,28,44,37,62,36,44,56,62,203,13,231,61,224,170,215,61,209,100,182,61,50,99,158,61,84,30,137,61,215,122,175,60,66,222,131,61,36,151,200,61,114,81,107,61,71,112,228,60,114,174,215,60,161,140,163,61,114,59,139,59,25,235,10,60,122,128,219,188,6,72,173,187,151,40,177,188,235,104,153,189,197,252,168,189,134,121,168,188,178,33,40,188,2,97,151,186,250,235,22,186,67,172,147,189,6,239,149,189,61,5,72,189,116,44,223,189,94,34,153,189,82,153,181,189,33,224,188,189,182,188,223,189,175,156,213,189,62,227,162,61,79,192,226,60,4,86,233,61,114,77,64,62,189,183,7,61,166,156,175,60,214,178,111,61,10,251,10,187,108,15,119,187,128,66,227,60,210,247,255,188,120,12,112,60,15,98,132,60,16,13,100,188,91,100,52,189,220,254,94,189,36,95,22,190,21,197,25,190,51,181,56,61,33,210,169,58,13,27,101,60,90,205,101,61,34,109,71,189,127,167,67,189,43,214,5,188,205,208,22,187,117,75,187,188,133,107,245,61,68,165,64,189,14,133,180,189,141,88,155,189,11,45,221,189,227,98,4,189,4,93,119,60,103,99,70,189,226,133,34,189,40,100,196,61,122,154,93,60,242,229,110,188,246,42,44,60,81,243,248,188,87,194,131,60,195,196,146,58,81,232,76,188,79,146,59,59,11,130,49,61,49,138,21,190,247,117,159,188,189,171,190,188,155,180,161,188,137,179,162,61,18,60,182,188,198,64,137,189,21,102,14,61,115,162,235,61,143,59,222,188,243,103,136,188,139,88,129,61,87,14,168,189,20,53,152,61,171,89,73,61,67,10,55,189,254,47,116,188,207,143,151,61,71,156,238,189,219,254,80,61,209,189,58,61,42,82,114,189,11,15,181,61,184,20,130,188,192,121,24,190,107,237,160,61,152,238,64,61,47,114,92,189,130,40,150,189,108,165,19,189,216,221,31,62,188,171,156,61,75,24,116,189,171,117,227,188,23,77,227,61,169,246,25,61,221,36,54,189,55,16,74,61,212,115,92,60,131,190,141,61,175,212,150,61,115,14,98,61,180,136,237,60,103,4,192,61,227,106,215,61,150,13,53,189,96,230,156,60,201,143,105,187,160,94,21,62,203,168,210,61,122,156,50,189,52,73,2,190,103,226,185,61,255,187,227,61,179,49,119,189,232,35,198,61,35,14,183,61,203,181,144,61,164,64,213,60,227,161,191,59,90,145,114,189,158,35,253,61,248,186,107,59,122,129,68,59,171,119,23,61,83,94,167,60,64,192,42,61,131,24,40,60,178,209,94,188,186,37,131,188,171,112,211,60,234,207,190,60,255,92,67,59,150,130,133,60,62,60,136,61,179,216,111,61,246,190,74,60,201,133,84,188,40,79,144,60,151,133,80,61,106,33,134,61,102,73,53,189,184,98,31,59,12,105,73,59,65,199,136,61,254,72,48,189,218,86,49,60,31,161,132,189,175,6,39,61,206,207,254,61,174,181,168,61,2,12,152,61,242,137,38,61,239,108,141,61,200,182,195,61,127,77,2,62,0,169,174,188,176,94,174,61,125,5,43,189,20,122,218,188,129,120,155,60,69,225,7,61,181,231,26,60,86,254,74,188,214,197,45,189,68,145,104,188,65,54,17,189,215,244,199,188,203,217,177,61,254,143,44,61,224,193,201,60,184,3,53,188,57,102,164,187,17,56,243,60,5,201,212,60,9,135,128,188,19,238,56,61,185,214,142,61,58,145,177,61,243,214,139,61,45,177,209,61,145,109,93,61,216,28,134,61,243,43,26,189,248,209,95,60,19,201,144,61,249,178,91,61,239,135,68,61,94,191,239,61,242,231,95,61,52,33,153,188,213,238,129,61,238,124,254,60,158,178,172,61,81,216,168,188,3,131,28,61,46,209,226,187,69,222,209,59,71,94,80,188,50,127,144,56,48,4,58,61,56,156,155,188,5,161,77,189,127,213,245,60,157,167,50,60,125,66,148,59,250,212,210,60,131,169,195,188,252,12,44,189,168,120,226,58,193,223,116,189,82,222,222,188,51,161,134,61,144,31,61,60,190,91,79,60,116,15,151,61,102,180,22,188,72,72,73,189,240,16,174,60,123,52,132,61,73,29,51,61,81,148,7,189,109,177,19,61,114,47,222,187,44,99,25,60,191,41,143,60,137,51,131,189,103,135,139,189,192,126,165,61,186,148,227,188,143,18,224,60,81,240,130,61,215,60,136,61,150,135,104,61,148,242,176,61,80,197,248,187,118,228,164,188,168,50,66,189,65,191,135,188,30,18,133,188,171,60,99,61,226,230,24,187,151,129,55,60,176,138,123,61,134,183,128,189,158,214,178,189,7,189,190,189,118,207,46,189,202,169,182,59,15,3,69,61,243,75,145,60,28,21,176,59,132,252,23,62,185,251,128,189,126,114,240,188,200,92,234,61,127,51,78,189,25,77,185,59,232,27,170,60,164,131,59,189,216,249,65,189,41,146,242,60,38,156,190,189,66,245,52,189,58,100,76,189,48,98,33,189,72,250,85,60,217,93,128,61,55,245,25,61,97,67,173,61,252,233,13,62,213,41,71,61,0,110,129,189,98,166,103,189,110,124,154,60,22,148,6,189,113,25,10,61,190,50,144,189,60,229,56,189,173,23,100,60,241,157,167,61,174,19,148,189,80,136,195,60,50,246,178,60,213,118,213,60,45,103,41,188,236,89,24,60,21,114,251,59,176,137,27,62,144,127,169,60,184,112,199,189,186,38,182,189,157,26,159,189,52,15,191,60,59,188,145,188,235,123,5,189,17,139,167,189,182,239,173,189,13,156,187,60,243,209,232,189,68,151,17,189,205,180,57,189,175,107,234,188,111,231,138,61,195,95,54,60,165,0,201,60,209,69,2,62,182,147,165,61,121,198,19,189,243,183,53,60,218,192,68,61,143,242,14,189,184,62,11,61,60,188,104,189,119,211,12,60,61,55,140,187,78,86,4,61,66,6,85,188,159,22,42,188,161,104,162,189,164,126,8,60,117,43,188,60,149,14,86,188,143,36,154,188,135,197,52,61,38,178,106,61,190,18,26,189,135,29,159,60,188,170,215,58,148,28,28,189,38,166,43,61,46,96,25,190,212,233,56,189,255,43,70,60,113,16,179,187,47,240,134,188,117,10,250,59,56,125,153,189,88,88,172,61,102,54,205,61,149,73,73,188,236,56,134,61,52,136,58,61,130,152,161,61,73,33,249,60,64,134,143,60,200,149,188,61,181,77,196,185,231,13,216,61,216,249,63,61,135,57,155,60,36,52,217,188,205,111,142,187,30,145,178,59,13,170,108,60,224,238,112,61,51,170,8,189,76,147,60,61,150,168,213,189,178,155,157,60,67,247,150,60,196,66,140,188,200,22,182,188,18,61,64,61,181,18,126,189,172,1,105,188,251,213,178,61,50,210,157,189,62,254,217,60,67,35,48,189,202,84,253,188,89,127,17,189,34,130,154,188,101,250,75,189,149,1,32,61,35,197,60,61,115,105,75,61,125,31,47,61,195,78,61,189,227,89,217,188,168,105,12,60,1,70,29,61,42,86,110,61,24,245,30,61,155,193,144,185,29,7,252,60,60,208,5,189,81,36,92,189,134,63,76,61,44,230,26,188,58,189,18,61,150,98,45,187,26,218,140,186,53,172,242,60,193,8,115,188,19,191,250,60,35,145,200,60,230,49,151,60,101,120,6,61,69,197,16,189,187,156,49,188,247,91,55,188,146,244,242,186,122,226,27,186,175,88,54,189,23,131,67,59,226,117,128,61,78,76,176,188,121,133,72,187,124,179,79,189,193,246,122,60,41,45,82,60,127,165,83,61,80,9,27,60,147,65,91,187,139,86,234,61,187,4,32,189,184,49,47,187,116,109,251,60,84,210,57,188,180,158,241,60,150,235,235,60,138,236,29,61,16,88,13,189,251,62,187,61,80,172,176,188,164,213,120,61,252,205,126,189,229,78,159,60,35,3,219,59,200,84,136,189,84,171,14,60,236,142,13,61,100,107,199,60,81,138,7,190,99,23,43,189,57,139,169,188,221,255,46,60,101,166,118,60,199,244,153,189,164,96,123,187,82,254,128,189,103,8,236,188,155,39,6,190,200,229,147,189,86,9,190,187,198,117,12,188,16,238,26,61,199,70,226,60,104,113,74,61,176,140,240,188,7,141,196,61,233,102,157,60,160,231,121,61,166,24,68,189,178,7,98,188,135,142,242,187,160,223,181,188,236,62,87,188,76,202,254,59,135,215,251,61,58,216,240,60,121,54,19,61,210,130,159,189,129,167,57,188,97,91,209,57,235,117,121,189,220,214,55,188,241,147,153,187,109,83,156,61,202,55,138,189,208,6,103,189,171,174,87,189,61,162,58,188,7,17,133,188,216,39,65,189,66,19,52,188,214,203,43,60,39,73,87,59,4,252,109,189,182,177,157,189,190,108,8,189,109,108,43,61,24,123,14,61,171,97,186,60,114,206,188,60,142,63,218,59,175,160,224,61,154,81,194,187,88,255,70,189,226,41,44,189,202,206,190,189,115,228,200,187,167,116,208,188,160,214,95,60,6,127,22,60,140,69,151,188,38,75,102,189,166,103,35,189,114,244,159,189,105,132,226,59,239,5,116,61,116,204,31,189,69,199,128,60,236,155,67,188,35,231,225,187,97,104,253,188,34,106,41,189,189,7,128,188,133,154,60,189,80,184,234,60,14,188,177,189,13,103,4,189,214,187,91,189,93,192,108,188,102,112,143,189,112,142,177,189,195,43,57,189,107,17,47,61,7,99,255,60,59,112,167,61,255,32,49,60,55,168,130,61,99,235,125,61,32,200,234,60,11,92,193,60,133,188,137,61,237,17,5,189,28,162,25,188,28,73,169,61,168,250,183,188,133,243,81,61,65,145,152,188,79,170,161,60,146,99,163,188,94,150,220,189,166,68,2,61,77,75,84,59,172,122,175,188,99,85,46,189,168,1,67,61,19,109,47,61,64,217,102,61,140,66,153,188,162,241,98,61,85,65,249,188,190,110,110,60,60,201,135,189,194,92,111,189,102,45,25,189,57,117,199,189,151,230,3,189,225,51,102,189,113,156,212,189,107,142,151,61,240,216,137,59,55,120,5,61,20,115,12,59,181,203,81,61,145,201,80,188,16,92,195,60,173,192,129,61,17,232,161,189,102,136,171,61,0,197,161,189,110,75,133,189,43,172,204,188,120,218,133,61,20,162,34,61,180,132,72,61,39,159,63,188,160,11,35,189,41,191,104,61,252,180,114,61,136,1,63,188,41,139,162,189,21,102,44,189,120,143,90,60,86,94,185,61,31,210,206,61,24,201,34,189,210,245,74,60,186,162,153,189,17,186,21,189,202,48,48,189,228,194,188,61,136,12,243,57,55,144,233,60,105,136,175,60,65,121,6,57,106,231,235,60,66,52,175,189,37,51,70,189,195,156,166,61,160,201,107,189,68,167,103,60,150,99,13,61,46,145,135,189,199,28,250,188,217,158,242,60,193,60,151,189,96,18,58,60,208,109,88,61,77,75,159,189,26,165,172,188,136,194,97,189,162,248,9,190,0,59,248,60,191,170,137,61,6,185,126,189,182,170,110,189,102,24,128,61,190,56,237,60,156,80,136,188,99,73,20,189,236,19,132,188,37,126,191,186,81,127,15,62,151,212,18,188,77,33,5,189,184,236,93,59,160,134,45,59,88,157,9,61,30,151,197,188,236,63,45,189,120,113,218,61,42,78,213,192,11,181,150,62,143,85,202,189,106,161,4,190,65,73,161,61,240,105,198,62,33,231,133,62,9,113,21,62,101,252,123,61,60,75,168,62,124,153,104,62,218,31,136,189,212,155,177,189,58,205,66,61,223,140,218,61,226,57,27,61,170,69,228,61,23,239,199,188,175,10,156,62,229,100,130,62,20,203,141,189,93,24,169,61,83,203,22,62,123,104,167,62,25,118,24,62,204,98,98,61,123,49,180,189,42,0,134,62,118,226,18,62,215,164,219,60,217,237,115,62,46,173,70,62,210,197,102,61,197,203,211,188,39,21,13,189,224,99,32,190,34,25,82,62,212,73,182,61,157,42,15,190,223,25,205,189,161,243,26,189,193,115,239,188,209,231,99,189,14,47,8,61,44,68,135,188,72,248,30,62,37,64,125,62,145,95,255,189,194,77,70,189,90,217,126,189,214,84,70,62,126,225,149,59,1,165,97,61,2,159,191,61,178,188,43,62,91,154,43,62,176,201,154,60,152,108,92,62,109,26,251,61,141,98,185,61,29,170,137,189,162,210,72,189,243,2,204,189,120,155,119,62,67,87,194,189,91,122,52,190,129,92,226,58,74,179,9,190,176,229,213,61,143,168,80,61,214,57,166,61,134,198,147,61,138,33,249,61,73,16,46,59,12,144,152,190,8,203,8,190,112,65,118,189,129,120,189,189,246,152,72,189,129,147,173,189,5,111,56,190,140,16,30,189,36,181,176,61,5,222,9,190,93,165,219,189,81,20,8,62,14,244,16,62,68,105,127,62,73,102,5,62,146,3,246,188,44,240,149,61,141,156,5,188,86,70,163,60,40,209,146,61,82,73,157,57,229,242,159,188,161,248,177,188,71,232,39,189,178,217,177,189,44,157,143,61,54,203,117,62,245,219,135,62,223,250,48,61,144,193,42,62,182,75,187,61,14,131,121,61,244,111,23,189,193,116,186,189,117,148,163,61,69,14,97,62,126,229,33,62,42,254,15,190,140,49,48,189,49,152,255,61,2,213,191,61,183,94,211,61,64,76,194,61,174,242,164,61,29,4,13,62,106,107,36,62,228,74,45,190,244,24,101,60,213,119,158,62,195,46,138,187,140,74,106,189,207,18,132,189,20,117,102,60,44,214,184,62,16,174,128,62,106,218,165,189,60,249,52,189,81,164,123,61,210,28,25,189,142,90,161,189,8,229,253,60,162,207,135,61,125,89,26,61,22,251,27,62,76,196,187,189,151,198,143,61,165,21,95,62,222,60,21,61,28,152,156,189,91,238,204,59,10,101,193,189,126,139,30,62,48,186,188,188,37,176,73,190,91,121,201,188,135,191,54,62,141,94,77,189,49,35,60,189,14,248,124,186,29,118,223,61,131,23,61,61,173,50,35,190,249,192,14,188,135,49,41,61,146,235,198,61,21,86,106,189,123,76,132,189,175,8,158,61,31,101,52,62,72,164,13,62,130,169,134,61,7,240,214,189,58,232,146,60,110,134,11,62,138,5,62,188,105,138,64,61,102,247,164,61,30,136,140,61,191,98,173,61,28,97,17,189,214,2,187,189,149,158,41,189,186,188,121,61,61,183,208,189,226,146,163,189,182,20,176,189,254,215,185,188,228,103,163,61,199,213,200,189,101,167,95,189,165,104,37,61,172,1,154,62,129,176,3,62,146,61,194,61,216,45,66,61,160,137,208,61,141,67,125,61,69,13,38,190,87,118,81,190,45,9,16,189,5,197,207,61,181,82,136,188,181,84,222,188,14,158,9,190,205,62,15,188,234,146,209,61,13,56,235,61,222,1,30,60,88,169,128,61,255,8,115,62,9,223,43,62,188,91,89,61,173,78,78,188,113,198,48,61,124,15,23,59,63,31,133,61,4,116,31,189,160,193,166,188,206,255,27,62,141,12,50,61,91,125,245,188,62,234,47,189,204,10,5,61,112,67,140,61,21,0,227,189,124,127,227,189,197,85,229,61,100,202,7,187,112,65,182,187,27,213,169,61,106,106,217,59,82,127,221,189,41,151,198,60,10,20,177,189,244,112,66,190,98,75,143,188,11,13,68,62,173,193,251,187,5,220,3,190,183,183,27,189,159,142,7,190,179,67,188,61,168,55,163,61,54,148,218,189,47,223,250,187,206,227,48,62,67,169,61,60,78,236,33,60,44,131,170,61,21,56,217,188,221,6,21,62,65,158,29,62,190,106,5,190,142,30,223,189,157,244,254,61,54,204,80,187,20,203,205,189,57,39,118,60,110,219,119,189,239,89,215,60,150,150,177,189,123,17,45,190,242,180,156,61,232,244,92,62,210,255,50,61,41,205,6,190,81,49,78,188,182,15,57,189,238,9,242,189,79,87,119,190,219,78,43,190,111,183,164,188,250,40,163,188,173,138,208,189,38,85,219,189,198,20,44,188,233,16,56,61,121,59,66,62,113,84,94,62,172,196,60,189,5,78,54,61,90,130,76,62,238,120,19,189,82,128,24,190,238,206,90,60,190,80,160,189,96,116,249,60,225,155,102,61,208,152,201,188,88,113,170,61,245,215,203,61,115,131,33,189,143,54,14,190,89,162,179,59,78,151,197,188,216,214,15,190,195,242,135,189,31,187,139,188,65,183,23,60,154,149,109,189,121,91,233,188,196,90,124,189,244,51,245,59,193,27,34,190,177,77,26,190,63,169,54,189,174,73,215,189,252,113,59,189,207,219,216,187,91,10,200,188,131,19,241,189,41,118,244,189,225,41,52,190,157,132,146,189,110,196,243,61,195,17,228,61,167,116,48,61,197,231,14,61,91,120,190,61,187,123,0,60,181,250,106,61,92,228,222,189,67,198,163,189,132,128,108,62,245,132,165,60,171,236,59,60,6,128,202,61,158,123,207,61,115,133,247,188,124,154,147,188,204,236,115,189,215,104,217,189,83,32,179,60,158,98,21,189,199,241,163,61,162,156,40,61,146,36,168,189,84,26,241,61,236,161,253,60,43,79,96,189,171,61,172,189,151,60,62,190,244,26,123,189,54,3,28,189,93,197,226,189,82,44,135,190,200,7,157,61,95,236,157,189,140,242,12,190,1,104,20,61,92,85,142,62,40,153,156,60,190,165,220,61,134,117,19,62,108,118,164,61,102,50,92,62,250,99,106,62,142,234,148,61,115,71,159,61,164,26,246,61,120,67,154,61,150,120,128,61,191,213,250,61,157,188,72,189,177,222,40,62,75,89,38,62,145,241,40,61,220,13,34,60,134,89,200,189,228,131,30,189,30,163,188,188,12,205,245,189,167,62,80,62,248,111,126,62,203,103,25,62,37,150,20,189,99,154,169,189,192,5,185,189,255,90,222,188,214,2,155,189,172,255,163,190,111,18,3,186,38,198,18,190,23,71,133,189,39,108,63,190,24,122,4,62,96,115,238,61,77,15,58,62,198,134,46,62,8,116,214,62,5,139,235,62,55,221,170,62,32,12,108,62,0,225,67,61,175,33,56,189,172,112,139,189,21,139,15,62,58,150,55,189,215,52,175,61,186,103,189,61,1,190,219,189,91,206,5,190,141,150,83,190,238,179,234,61,186,191,162,190,126,1,157,189,235,110,30,61,236,219,89,62,42,142,131,188,8,144,1,190,72,135,39,190,156,50,87,62,142,145,204,61,23,102,1,190,125,151,242,61,232,45,158,60,141,9,177,188,69,161,197,189,30,252,228,189,253,76,77,190,82,72,18,62,8,85,106,62,196,233,180,190,92,115,55,190,170,70,239,61,34,57,129,62,56,245,1,189,118,166,64,190,95,208,34,190,88,230,197,62,73,128,250,61,143,251,86,62,98,189,201,62,200,210,183,62,179,124,133,62,76,108,46,62,169,46,96,60,176,4,18,190,92,31,214,188,241,155,66,188,167,33,26,190,204,41,65,61,82,67,219,189,34,226,22,190,140,49,64,190,221,125,62,190,137,10,85,190,36,124,111,61,168,142,149,189,188,59,114,190,228,103,163,189,166,185,21,190,194,223,111,189,91,150,207,189,151,2,146,189,53,153,145,189,59,115,239,61,99,237,111,62,102,18,157,62,159,203,164,62,143,194,117,62,221,9,150,61,67,113,71,188,125,234,216,60,52,130,77,61,50,29,42,62,46,115,106,62,25,144,125,61,13,55,32,62,11,239,82,62,226,34,247,61,80,252,24,61,201,233,43,62,219,135,148,62,52,128,215,62,109,116,78,188,40,101,66,62,148,221,156,62,201,114,242,61,226,200,195,189,123,49,148,189,8,173,7,190,39,164,101,190,166,11,1,190,182,18,186,60,143,109,145,62,77,104,82,61,235,1,115,186,29,148,112,189,128,181,170,189,227,164,16,190,114,20,64,190,118,136,79,190,119,77,72,61,237,131,124,62,222,59,226,62,166,94,175,62,73,44,137,61,239,115,92,62,36,181,64,62,145,242,147,189,45,35,85,190,154,93,247,188,152,106,54,62,204,69,12,62,239,168,49,189,193,113,57,190,129,9,188,61,53,238,237,61,6,187,1,190,182,243,197,190,31,128,188,62,230,205,137,62,93,79,180,189,54,30,236,188,86,98,190,61,68,107,197,60,240,223,60,61,134,255,52,62,0,28,11,62,104,232,255,61,128,40,72,62,231,113,24,189,239,58,43,62,247,120,65,62,45,64,91,61,34,81,136,189,40,238,8,62,98,132,144,189,238,91,237,61,236,23,28,62,7,154,239,189,15,126,226,189,22,77,55,190,217,118,218,60,234,236,164,61,164,197,153,61,102,46,144,189,56,192,76,60,173,252,178,60,75,30,15,190,73,99,180,188,117,57,197,189,154,6,133,189,52,129,2,190,144,50,98,188,65,212,221,189,45,9,32,62,188,118,25,62,145,123,58,188,90,41,132,61,187,241,238,60,73,103,224,60,67,199,142,61,181,108,29,62,47,135,29,61,74,64,108,62,81,247,129,62,87,205,115,61,127,137,56,189,98,188,102,60,115,158,145,61,58,203,140,61,103,96,196,61,93,26,191,59,66,93,20,62,163,234,215,60,132,243,137,189,174,215,52,189,204,123,252,189,101,28,163,188,158,66,174,59,114,168,223,61,222,199,81,187,128,11,178,188,0,111,17,62,138,6,137,189,67,231,245,189,149,42,65,190,92,87,76,60,216,125,71,189,195,154,74,188,141,67,61,190,30,163,44,62,251,201,136,62,131,107,110,61,64,163,52,189,76,55,9,61,233,215,54,62,79,30,214,61,74,182,250,61,215,51,164,61,102,103,49,62,215,217,152,62,34,109,131,61,208,182,90,61,114,134,50,62,18,135,108,62,206,170,239,61,88,59,42,62,108,63,105,62,49,9,247,61,232,50,53,62,181,169,58,188,0,30,177,189,229,126,7,188,97,195,83,61,195,12,29,190,17,255,112,189,223,22,108,189,37,59,118,189,220,217,215,60,86,154,36,190,189,54,27,189,148,246,70,189,36,38,40,61,58,36,181,188,74,65,119,61,99,155,84,61,142,143,38,62,237,215,13,62,201,142,77,189,142,147,194,187,66,6,146,61,30,192,2,62,83,90,127,61,152,221,19,62,79,175,148,61,207,50,75,62,213,32,124,62,117,31,160,189,242,37,20,189,73,131,155,61,1,219,65,61,187,214,94,188,137,152,178,61,83,5,163,60,56,48,185,60,123,189,123,188,201,115,189,189,199,41,154,61,4,86,238,189,23,217,78,61,167,205,56,61,138,144,42,62,2,155,147,61,149,71,119,61,176,232,6,62,145,240,45,190,144,47,33,189,174,128,66,189,46,2,35,189,42,55,81,190,43,217,177,60,181,140,4,62,0,115,173,188,247,147,49,62,114,252,144,189,24,11,131,189,27,185,142,61,86,70,131,189,206,80,252,189,185,79,142,188,187,213,83,190,46,227,134,61,8,227,231,61,86,102,202,60,59,27,146,189,108,36,137,189,250,69,201,189,223,223,128,189,0,82,155,61,97,27,113,60,157,190,158,60,63,226,7,62,115,241,151,189,169,105,183,189,76,168,160,189,75,58,74,190,61,213,49,190,70,97,87,61,225,179,53,61,97,140,232,61,44,182,201,61,226,120,158,61,182,157,54,188,25,55,69,190,166,97,40,190,131,165,58,61,194,162,82,62,79,120,73,61,241,130,168,189,105,28,10,62,115,243,61,62,155,58,15,61,102,220,244,189,75,35,230,189,213,180,235,189,37,91,93,189,67,58,60,190,229,242,159,189,141,69,67,62,178,161,187,61,78,126,139,59,44,125,40,189,36,182,123,189,126,253,16,190,3,124,71,190,14,17,247,189,93,55,165,60,183,155,224,61,246,7,138,61,206,168,121,188,109,226,116,190,245,130,135,190,199,158,61,190,186,187,78,61,21,86,170,60,24,35,18,61,219,24,187,60,160,55,85,189,11,10,3,190,60,134,231,189,226,229,105,190,104,61,132,190,193,224,90,189,48,132,156,61,255,178,123,61,111,45,115,62,248,27,109,59,179,210,100,189,184,92,221,189,74,13,237,188,86,183,58,61,57,99,88,61,146,206,192,186,151,253,186,60,110,250,115,61,101,223,213,189,163,61,158,189,152,247,88,190,250,42,89,190,114,251,229,60,38,85,155,61,45,62,133,60,156,195,37,62,87,180,9,62,27,100,18,60,164,198,68,189,31,248,152,61,15,123,161,59,245,19,206,188,195,128,69,62,69,100,152,61,31,18,158,62,167,232,136,62,32,240,192,61,149,16,172,187,47,51,44,61,159,173,3,189,208,100,127,60,12,120,129,62,94,130,51,62,1,136,187,60,44,68,167,61,50,115,129,61,110,135,38,62,156,23,71,62,220,128,111,62,35,75,134,62,148,106,63,62,156,49,172,61,115,161,146,190,150,37,90,190,195,40,72,189,47,167,84,190,150,33,46,190,28,64,63,60,196,96,190,189,177,105,69,190,233,12,140,190,25,114,108,62,25,145,136,62,17,27,164,62,179,36,152,62,206,84,12,63,189,30,156,62,26,223,7,62,221,68,125,62,116,150,89,62,97,254,138,190,249,131,17,190,191,41,44,187,254,38,244,189,213,118,3,62,56,246,204,61,162,122,107,189,193,167,249,189,170,98,106,190,162,37,79,62,238,177,204,190,113,30,190,190,170,69,196,189,89,78,130,189,125,63,37,190,252,82,159,190,162,239,150,190,212,238,119,62,117,34,65,60,199,187,195,61,188,33,165,62,242,7,3,63,135,80,165,62,124,99,160,62,175,125,49,62,175,151,38,59,83,35,244,188,187,71,166,62,193,255,166,190,45,92,174,190,95,155,13,190,228,46,66,187,74,152,233,189,10,47,193,190,137,152,226,190,114,139,89,62,54,63,254,187,67,169,61,188,184,200,45,62,124,12,158,62,112,123,162,62,119,21,10,63,169,106,170,62,233,211,106,61,245,161,139,189,59,226,208,61,146,179,136,62,133,153,86,62,62,34,182,62,34,171,187,61,223,82,46,62,92,56,0,62,234,93,140,62,20,209,143,61,213,4,209,60,45,148,76,61,224,45,16,186,128,14,51,61,75,63,17,190,9,193,170,60,231,252,4,62,129,95,131,62,27,18,215,61,46,230,23,62,67,199,46,62,51,221,235,60,182,160,151,61,13,226,35,62,30,110,207,62,114,24,124,62,81,78,180,62,126,1,45,62,233,152,99,62,140,100,135,62,44,14,135,61,192,235,179,60,164,197,153,189,214,173,190,61,0,202,223,60,53,121,202,61,83,202,107,61,228,106,164,189,7,121,61,62,135,251,160,62,68,222,170,62,49,209,0,62,160,255,150,62,14,162,197,62,132,215,94,62,225,235,59,190,139,167,142,190,61,124,25,187,222,232,227,188,7,125,9,190,83,231,169,190,242,235,7,188,105,27,255,61,29,1,92,61,170,239,188,190,60,162,194,189,249,103,86,62,18,247,216,62,84,87,190,62,172,230,217,61,12,35,189,62,157,161,248,62,244,191,108,62,113,3,14,190,100,203,178,190,173,135,143,189,137,126,237,60,161,45,167,189,119,191,202,190,97,80,22,190,127,21,224,188,195,213,129,61,6,131,139,190,239,202,110,61,120,41,173,62,207,217,226,61,35,159,87,189,218,117,111,190,161,218,224,188,109,114,248,60,68,78,31,62,217,39,192,189,12,92,158,60,14,17,247,61,31,45,206,59,11,66,217,189,1,246,113,190,190,80,16,190,121,92,180,189,53,238,205,188,128,101,85,190,146,233,208,188,17,167,19,62,204,13,70,189,7,98,217,189,210,56,156,190,231,197,233,189,207,74,186,61,213,203,167,62,153,215,17,61,52,15,192,189,102,188,45,59,220,47,47,190,106,165,64,190,202,196,93,190,147,30,86,190,162,212,94,189,37,235,32,62,0,254,105,189,49,93,136,61,104,66,19,60,229,183,40,61,188,33,13,61,40,68,160,189,195,101,85,61,144,46,182,188,86,45,137,61,83,174,240,189,181,194,148,189,75,6,128,61,0,227,25,61,66,179,107,189,133,237,159,190,237,185,12,61,134,57,1,189,86,42,40,59,29,90,84,190,11,179,144,189,25,229,153,188,239,143,55,189,208,241,81,188,169,77,156,189,105,30,160,61,179,153,195,60,151,198,239,61,182,157,182,60,171,90,82,190,115,133,119,189,87,176,141,188,208,43,158,187,213,94,164,190,195,187,188,189,140,19,31,61,164,228,149,61,65,68,138,189,145,66,217,60,90,18,48,62,200,211,178,61,161,74,13,61,232,160,11,189,168,29,30,62,18,159,123,189,77,161,243,59,64,133,227,189,17,143,196,189,60,132,113,60,241,127,7,190,163,205,241,188,151,197,68,190,237,17,202,61,18,21,170,60,152,76,53,62,210,29,132,189,85,249,94,189,88,88,112,189,34,136,243,186,220,159,43,62,176,230,128,60,134,145,94,61,198,250,134,60,169,218,62,62,164,196,46,188,184,4,96,61,168,200,1,62,40,73,87,60,254,10,185,61,137,208,8,190,99,152,147,188,40,72,28,190,101,25,226,60,95,7,14,190,28,236,77,189,197,229,56,61,61,41,243,189,238,36,194,61,165,160,43,190,162,153,199,61,49,154,21,188,212,183,76,62,93,253,88,189,156,253,33,62,136,218,54,62,100,93,220,189,29,115,30,60,241,45,172,189,147,229,36,189,241,155,82,190,132,184,210,61,17,224,100,62,38,229,46,61,75,201,242,61,208,70,174,188,101,82,227,61,10,216,30,190,185,226,226,60,54,145,25,190,49,40,83,61,252,81,4,190,71,176,49,62,162,126,151,61,3,149,65,190,253,103,13,189,240,109,218,189,36,9,66,188,63,30,74,190,205,173,96,62,255,151,59,62,203,243,96,189,21,111,20,62,218,146,21,61,125,236,174,189,83,145,106,190,183,40,19,190,213,177,74,189,170,100,32,62,51,25,14,188,84,170,132,189,249,163,168,61,78,43,21,62,65,215,62,59,246,41,87,190,27,185,238,189,73,157,160,61,181,53,98,62,185,110,138,189,72,27,71,61,88,230,173,61,234,148,135,189,68,110,230,189,80,254,94,190,41,63,169,189,206,167,142,188,151,202,107,62,131,221,144,189,72,81,135,61,18,108,92,62,195,186,145,61,102,160,178,189,177,22,79,190,183,67,67,188,41,231,203,61,192,232,50,62,43,193,130,189,175,235,247,189,145,99,107,60,222,228,7,62,91,206,165,187,255,121,122,190,113,1,56,190,45,236,9,190,183,95,190,60,51,192,69,190,18,165,157,189,32,96,173,188,125,4,254,186,237,186,39,190,21,57,228,189,35,105,87,190,120,94,42,190,54,90,14,61,9,110,36,60,72,139,179,188,237,74,139,61,245,244,177,189,218,228,128,190,163,202,136,190,235,30,25,61,56,245,129,59,191,129,9,61,100,36,27,190,65,97,208,60,219,247,168,188,175,237,157,190,112,176,175,190,98,244,188,189,79,33,215,188,198,51,232,188,124,154,19,61,95,13,16,61,201,147,4,62,157,70,250,61,127,75,128,60,6,157,144,189,169,49,193,189,216,71,135,189,166,70,40,189,43,247,34,62,126,225,149,61,192,94,225,61,135,168,50,62,164,226,159,61,112,207,115,188,249,248,4,60,144,106,88,60,234,90,155,61,173,76,72,62,51,112,128,61,254,43,139,61,174,154,103,61,15,154,29,190,166,38,17,190,24,149,148,189,106,79,9,61,65,14,202,188,246,182,9,62,153,242,161,61,122,196,8,62,196,148,104,62,251,229,147,60,15,123,161,59,206,56,45,62,105,110,133,61,159,200,147,61,71,202,6,62,130,58,197,61,24,93,94,61,191,156,217,61,47,196,234,61,50,202,243,61,38,228,3,63,7,94,125,62,201,233,75,62,65,11,89,62,144,158,2,62,210,224,150,190,63,145,71,190,56,192,76,189,193,225,229,189,35,18,5,188,11,96,202,187,3,178,23,61,148,21,227,189,30,253,127,190,169,23,28,62,125,64,112,62,41,5,29,62,57,213,178,62,77,220,46,63,57,242,32,62,54,174,255,61,209,7,203,61,209,231,131,61,146,92,126,190,254,12,31,190,85,18,217,188,55,26,192,188,180,233,72,61,224,218,233,189,9,196,235,59,157,17,53,190,114,252,192,190,49,121,187,62,171,65,56,190,123,18,24,190,92,4,198,59,16,33,46,62,248,109,200,61,92,62,210,189,21,87,133,190,65,215,126,62,60,161,23,61,46,228,241,189,189,26,160,61,195,212,70,62,94,102,88,62,182,186,188,62,233,240,184,62,33,34,5,62,220,215,193,61,127,218,104,62,214,84,54,190,211,18,235,189,129,152,4,188,60,160,108,62,36,9,66,188,181,136,200,189,175,205,166,190,187,72,17,62,50,57,245,61,14,245,107,190,95,121,240,189,12,201,233,189,45,64,27,61,54,90,238,61,8,6,96,62,143,168,208,189,159,146,115,61,247,59,244,61,221,40,50,60,171,208,0,189,77,102,60,61,98,158,245,61,69,42,140,62,36,151,159,62,221,9,134,62,3,124,71,62,17,254,173,62,30,50,117,62,213,91,131,61,45,235,158,61,106,190,202,61,148,250,18,62,79,8,61,62,241,160,25,61,230,231,102,62,25,230,196,61,41,232,22,190,45,210,84,190,145,239,50,190,196,237,176,189,166,129,31,189,39,104,35,62,75,59,181,189,85,161,129,186,216,127,221,61,68,23,212,188,142,234,148,189,169,247,212,60,179,235,222,187,158,237,177,189,177,249,56,188,149,212,137,190,152,221,211,189,208,208,255,189,170,67,238,189,161,218,16,62,171,207,85,62,54,33,45,61,137,178,135,62,164,55,4,63,45,208,94,62,163,92,154,188,135,108,160,190,90,103,44,190,87,10,65,61,148,77,185,61,22,250,224,189,171,176,153,188,157,185,87,62,126,2,144,62,122,140,50,189,186,221,11,189,129,122,115,190,73,20,10,190,235,112,148,189,89,165,212,189,34,26,29,61,79,3,158,62,87,147,23,62,9,223,59,189,127,217,253,189,175,235,87,190,144,16,133,189,179,183,20,189,1,105,63,189,246,8,181,188,53,38,196,61,228,159,209,62,104,92,120,61,123,133,133,189,153,73,84,61,105,56,229,60,17,111,29,188,64,252,12,190,33,149,194,189,67,4,156,188,93,136,53,62,54,228,31,60,227,168,188,189,129,235,138,188,153,18,9,190,182,134,242,189,84,59,3,189,207,158,203,187,213,35,173,189,58,3,131,61,158,209,150,189,248,166,41,62,241,47,226,61,181,194,52,61,22,190,62,61,182,72,90,61,81,48,99,189,11,38,126,60,214,111,190,62,38,172,109,62,26,162,138,188,241,242,212,61,158,235,187,189,130,143,193,59,79,30,86,62,30,54,33,62,226,0,250,60,249,47,128,62,90,69,127,61,182,103,22,61,126,229,193,61,80,197,141,60,198,54,41,188,11,209,161,189,79,120,137,60,82,68,230,189,193,28,125,61,146,65,46,61,153,215,1,190,47,110,35,188,44,125,104,189,24,39,62,61,149,98,71,190,157,190,14,190,210,139,26,189,222,199,33,62,202,53,133,188,78,156,252,61,181,24,108,62,49,153,170,61,132,72,134,188,135,252,115,61,213,91,131,188,144,164,132,189,253,130,109,62,90,99,32,62,212,186,13,61,130,31,21,62,235,57,41,61,146,116,13,61,213,145,163,60,51,168,182,189,84,25,70,188,111,159,157,62,141,122,88,62,164,139,205,188,150,206,23,190,61,125,4,190,42,31,130,61,187,127,140,189,167,36,139,189,54,201,15,189,88,228,87,62,209,174,130,61,105,138,128,61,185,23,184,189,98,76,250,188,243,85,114,60,29,146,90,189,12,231,26,189,255,91,73,190,210,109,9,60,128,70,169,189,70,125,18,62,77,134,131,61,174,240,142,61,253,159,67,62,60,80,199,61,57,240,234,188,226,57,155,61,185,85,160,62,153,158,176,61,94,160,84,62,46,228,145,60,178,161,251,61,223,249,101,62,177,107,43,62,97,168,195,188,39,74,66,61,178,44,176,62,58,64,64,62,252,113,11,62,196,35,17,62,13,169,130,61,61,70,57,61,124,101,158,189,176,3,103,187,130,0,41,190,165,216,209,188,158,7,151,189,178,98,40,62,52,128,55,60,195,101,21,190,201,255,228,188,21,230,125,189,235,82,35,189,156,51,18,190,193,170,26,62,115,159,28,189,233,181,89,61,231,0,161,61,192,64,176,61,180,3,206,61,126,30,3,62,152,107,145,189,246,181,238,189,155,114,85,62,142,63,81,61,221,95,157,61,13,251,189,60,169,161,173,189,216,42,65,188,184,90,23,62,143,224,70,189,46,85,233,189,149,15,145,62,52,132,67,62,41,8,190,61,226,61,7,61,165,216,17,190,71,230,17,190,146,204,202,189,150,4,40,189,28,37,47,189,145,44,80,62,154,8,91,189,202,196,45,61,232,47,100,62,29,4,157,188,74,95,8,190,47,108,141,190,86,16,3,189,189,53,240,61,72,24,54,62,64,166,117,189,129,152,132,189,171,178,239,189,172,54,31,190,233,214,203,189,86,15,40,62,54,148,218,188,117,31,192,189,149,186,116,62,73,48,213,187,102,73,0,60,29,204,134,61,202,135,80,190,196,177,206,189,51,194,91,189,146,232,5,190,221,66,215,60,136,245,6,62,122,28,6,61,12,61,2,62,68,253,238,61,42,253,36,190,104,62,143,190,165,73,129,190,76,226,44,187,163,91,47,61,127,50,198,61,58,122,252,189,69,212,132,61,115,75,43,188,196,8,97,190,48,19,117,190,69,188,213,189,122,168,109,189,229,122,91,189,41,206,209,60,44,17,168,59,244,167,205,189,130,60,59,189,131,21,71,190,23,102,1,190,13,26,250,188,137,149,81,61,91,36,93,62,38,138,48,62,27,13,96,189,121,117,62,190,52,133,142,190,117,87,70,190,13,27,37,189,231,198,116,59,124,155,254,187,238,10,253,61,73,190,66,62,84,87,158,189,252,112,240,61,120,13,90,62,189,58,71,60,106,250,236,56,67,229,223,60,218,170,36,61,62,94,8,61,91,180,96,62,28,152,60,62,100,201,132,62,101,86,159,62,103,14,169,61,147,24,68,189,24,153,160,189,254,15,48,60,173,52,169,61,108,181,159,62,103,126,157,62,99,42,125,59,138,89,175,60,166,43,216,188,117,85,160,188,149,155,168,60,34,28,115,189,34,110,206,60,155,203,133,62,113,198,176,61,140,15,19,62,195,187,220,61,36,151,127,59,37,235,64,190,60,244,29,189,31,46,217,189,95,40,0,190,241,45,44,188,32,69,93,61,237,240,119,62,3,237,142,62,23,184,92,62,84,169,177,62,225,183,225,62,158,38,115,62,17,198,111,62,88,113,154,62,185,251,44,62,205,91,85,190,113,228,1,190,143,25,40,60,73,216,247,61,9,249,128,189,37,119,88,189,93,50,78,61,36,71,122,189,84,112,136,190,85,132,219,61,24,150,15,62,174,100,143,62,48,102,147,62,207,19,191,62,251,59,27,62,45,181,94,60,21,200,236,61,242,119,111,60,75,60,144,190,161,76,115,190,155,61,240,189,57,155,14,184,79,5,12,190,80,252,72,190,83,5,195,189,68,81,0,190,95,67,128,190,191,124,114,62,128,14,147,189,195,70,25,189,210,140,69,61,59,168,164,62,126,81,130,61,112,237,196,60,84,168,238,188,207,134,108,62,126,114,36,62,61,15,30,190,170,102,86,188,209,177,163,189,225,237,193,61,138,61,36,62,147,144,56,62,1,193,92,61,188,90,206,61,113,199,147,62,43,110,28,61,120,13,58,62,194,49,107,62,112,93,225,62,98,216,129,61,189,141,205,59,20,237,170,60,110,105,173,62,106,50,131,62,204,236,51,189,155,200,236,61,180,1,88,59,226,35,50,62,22,163,174,60,130,172,39,189,159,146,243,189,211,193,58,62,137,149,113,62,217,10,90,189,220,160,118,188,249,246,206,189,36,66,195,61,197,89,81,61,7,183,37,62,66,150,5,61,235,82,35,62,88,57,148,61,114,135,205,60,42,139,194,60,20,206,238,60,162,39,37,62,156,21,241,189,4,61,20,189,212,16,53,190,231,228,37,190,160,250,103,62,244,106,160,189,155,115,48,61,115,16,244,189,238,178,95,61,116,152,207,189,18,46,132,189,129,36,236,189,1,106,10,62,192,5,153,62,174,211,200,61,7,38,183,61,101,169,245,187,173,20,226,61,79,32,236,188,41,174,170,60,203,191,22,189,190,107,0,62,44,183,68,62,223,107,72,189,125,62,74,59,92,255,46,188,68,251,152,61,252,57,133,188,174,188,196,61,136,218,118,61,231,115,238,187,116,122,14,62,246,35,165,189,62,7,22,61,45,63,176,61,129,37,7,62,39,135,175,61,11,68,207,60,47,133,103,62,231,110,71,62,145,210,44,61,98,162,33,190,89,22,140,189,69,216,16,190,195,185,230,189,204,69,156,189,112,124,141,189,229,38,234,189,255,231,208,189,154,93,7,62,81,77,137,189,165,103,218,61,56,189,75,62,27,188,47,62,45,64,43,62,120,40,10,189,77,45,219,188,125,65,171,61,200,11,25,62,109,111,55,187,61,185,166,185,168,143,64,60,208,240,134,61,61,10,183,189,219,51,75,189,10,248,101,62,194,190,93,62,177,251,14,189,67,60,146,188,215,132,180,189,56,190,246,59,209,8,118,62,149,14,150,61,14,77,89,60,223,135,51,62,149,243,69,60,103,127,192,61,91,97,122,60,251,201,216,61,220,41,221,61,143,84,159,61,174,242,196,189,255,8,163,189,114,22,54,62,53,207,17,62,97,140,8,61,229,242,159,189,74,38,167,189,187,123,64,189,87,206,14,62,119,17,166,60,214,59,252,189,183,121,51,62,3,124,215,61,196,208,106,61,158,179,165,61,144,162,78,188,103,210,198,189,19,15,168,61,10,19,198,189,3,233,130,189,174,186,78,62,243,61,3,62,163,145,15,189,117,0,4,189,118,140,139,189,216,100,237,189,78,185,194,61,112,36,176,189],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+153604);allocate([252,83,138,189,243,29,252,60,5,253,5,61,154,36,182,61,109,143,94,61,114,23,33,189,94,132,233,189,201,202,47,62,141,8,230,189,152,222,94,190,61,128,133,61,100,172,118,61,67,201,68,62,219,167,99,61,234,64,6,190,87,205,19,190,183,93,104,61,237,40,14,189,74,38,167,189,143,139,10,190,216,244,32,186,37,144,178,61,143,111,111,60,4,171,138,61,13,140,220,61,223,50,103,62,118,197,172,61,34,252,11,188,231,141,83,61,147,30,70,189,54,148,26,189,13,171,120,189,187,238,45,59,69,187,138,60,167,59,175,61,165,192,130,188,162,209,157,188,27,241,228,61,250,125,127,61,18,222,78,62,181,110,67,61,223,25,45,61,67,199,142,61,47,190,120,62,62,117,172,60,117,30,149,189,126,169,31,190,79,144,216,188,83,231,17,61,10,104,162,189,183,210,235,188,161,244,69,189,161,128,173,61,1,19,120,189,31,133,171,189,71,3,40,190,21,225,38,189,150,147,176,189,55,51,122,60,81,134,170,187,32,98,131,188,143,169,59,61,213,146,78,189,3,8,159,189,216,214,239,61,117,119,29,60,123,49,20,188,159,117,13,188,205,206,98,189,254,15,176,189,117,177,233,60,219,50,96,189,134,31,44,190,36,15,52,62,237,211,145,61,20,91,193,188,95,68,27,61,113,116,149,187,240,106,185,188,27,155,253,61,247,120,193,61,21,87,149,189,115,217,8,190,121,230,101,188,27,46,18,190,2,45,221,188,223,49,76,190,7,98,89,60,206,111,104,62,57,69,71,61,122,23,47,190,166,96,77,189,30,27,1,60,226,117,125,61,119,73,156,60,216,126,50,189,164,55,28,189,174,12,10,62,209,148,93,61,154,66,167,189,5,21,53,62,195,71,68,61,112,94,28,189,134,118,78,61,182,129,219,189,74,153,20,189,239,172,221,60,193,26,167,61,192,207,56,187,188,91,185,61,109,141,8,189,185,0,116,189,115,156,91,60,102,131,204,189,137,67,150,61,35,132,175,62,34,84,201,61,39,136,26,190,230,146,170,188,228,78,105,189,57,125,61,61,212,209,49,189,160,253,24,190,26,52,4,190,184,145,50,188,192,32,105,188,141,68,56,190,157,131,231,189,245,158,74,189,174,43,134,189,244,222,184,61,233,71,67,188,155,232,179,61,177,48,196,61,81,162,21,62,35,19,208,61,17,225,159,61,165,190,172,189,217,205,204,189,15,240,164,188,2,126,77,189,163,115,126,61,156,220,111,60,200,209,156,60,29,174,21,61,36,68,57,62,152,251,100,188,169,189,136,189,85,222,142,186,214,55,144,189,121,144,158,187,222,33,197,186,12,62,13,61,175,33,56,189,31,45,78,189,215,135,181,189,13,250,50,190,102,188,237,189,109,112,82,190,158,96,127,60,242,119,47,189,127,104,198,189,42,142,19,190,210,229,77,189,228,132,73,190,105,138,224,61,98,246,138,62,205,230,49,62,206,83,221,61,5,49,32,62,104,121,254,61,208,38,199,61,240,107,116,62,66,233,171,61,113,114,223,61,135,80,101,62,222,204,136,62,130,86,224,60,94,130,211,60,90,18,0,62,181,249,191,61,48,73,37,61,56,74,30,61,125,145,80,188,64,133,19,62,45,206,88,61,141,183,21,188,97,109,172,61,88,30,36,62,101,111,41,189,33,206,67,60,174,184,248,189,88,140,218,189,145,212,66,189,223,138,68,61,184,172,130,190,181,226,155,189,92,27,202,61,29,119,26,190,27,161,47,190,33,89,32,190,125,236,110,61,42,254,63,62,24,119,211,62,80,228,13,63,129,150,190,62,84,167,115,62,21,31,255,61,81,250,226,61,155,29,41,60,25,170,50,190,6,128,138,189,28,178,1,187,201,87,18,62,10,73,38,61,1,20,163,60,91,176,212,60,47,134,50,189,87,66,247,189,197,171,204,61,36,125,186,61,12,62,125,62,159,32,81,62,197,29,47,189,172,115,140,189,82,183,243,189,25,232,218,60,5,194,14,61,238,149,121,189,12,62,205,188,106,132,190,189,59,226,16,189,87,206,110,190,112,67,76,189,205,92,32,189,115,130,182,188,243,229,133,189,67,5,17,193,0,0,0,0,0,80,0,0,250,6,0,0,251,6,0,0,37,0,0,0,38,3,0,0,39,3,0,0,8,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,40,3,0,0,65,2,0,0,41,3,0,0,66,2,0,0,42,3,0,0,8,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,12,0,0,0,13,0,0,0,13,0,0,0,14,0,0,0,14,0,0,0,67,2,0,0,43,3,0,0,68,2,0,0,44,3,0,0,15,0,0,0,15,0,0,0,0,0,0,0,16,80,0,0,38,0,0,0,252,6,0,0,45,3,0,0,0,0,0,0,32,80,0,0,253,6,0,0,254,6,0,0,255,6,0,0,21,0,0,0,0,7,0,0,0,0,0,0,48,80,0,0,38,0,0,0,1,7,0,0,46,3,0,0,0,0,0,0,112,80,0,0,2,7,0,0,3,7,0,0,4,7,0,0,21,0,0,0,5,7,0,0,0,0,0,0,64,80,0,0,35,0,0,0,6,7,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,63,0,0,0,47,3,0,0,48,3,0,0,69,2,0,0,49,3,0,0,50,3,0,0,51,3,0,0,70,2,0,0,52,3,0,0,16,0,0,0,16,0,0,0,0,0,0,0,176,80,0,0,7,7,0,0,8,7,0,0,9,7,0,0,21,0,0,0,10,7,0,0,0,0,0,0,128,80,0,0,35,0,0,0,11,7,0,0,37,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,6,0,0,0,7,0,0,0,104,0,0,0,12,7,0,0,71,2,0,0,53,3,0,0,17,0,0,0,17,0,0,0,72,2,0,0,54,3,0,0,73,2,0,0,55,3,0,0,74,2,0,0,56,3,0,0,75,2,0,0,57,3,0,0,18,0,0,0,18,0,0,0,76,2,0,0,58,3,0,0,41,92,15,62,41,92,15,62,102,247,228,62,102,247,228,62,102,247,228,62,100,0,0,0,0,0,0,0,208,80,0,0,13,7,0,0,14,7,0,0,154,0,0,0,59,3,0,0,115,1,0,0,77,2,0,0,0,0,0,0,232,80,0,0,15,7,0,0,16,7,0,0,155,0,0,0,60,3,0,0,78,2,0,0,156,0,0,0,79,2,0,0,0,0,0,0,248,80,0,0,15,7,0,0,17,7,0,0,157,0,0,0,61,3,0,0,80,2,0,0,156,0,0,0,79,2,0,0,0,0,0,0,8,81,0,0,18,7,0,0,19,7,0,0,158,0,0,0,62,3,0,0,116,1,0,0,81,2,0,0,0,0,0,0,40,81,0,0,20,7,0,0,21,7,0,0,82,2,0,0,0,0,0,0,64,81,0,0,208,3,0,0,22,7,0,0,23,7,0,0,105,0,0,0,198,234,7,0,102,234,7,0,150,234,7,0,138,234,7,0,4,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,7,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,9,0,0,0,3,0,0,0,8,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,1,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,7,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,9,0,0,0,3,0,0,0,8,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,150,234,7,0,246,20,8,0,134,20,8,0,208,79,7,0,214,79,7,0,221,79,7,0,227,79,7,0,235,79,7,0,83,20,8,0,243,79,7,0,250,79,7,0,0,80,7,0,8,80,7,0,14,80,7,0,21,80,7,0,26,80,7,0,35,80,7,0,44,80,7,0,51,80,7,0,150,234,7,0,221,79,7,0,208,79,7,0,14,80,7,0,214,79,7,0,246,20,8,0,134,20,8,0,83,20,8,0,21,80,7,0,243,79,7,0,0,80,7,0,150,234,7,0,58,80,7,0,67,80,7,0,76,80,7,0,0,0,0,0,136,81,0,0,208,3,0,0,24,7,0,0,25,7,0,0,215,88,7,0,227,88,7,0,242,88,7,0,255,88,7,0,11,89,7,0,28,89,7,0,43,89,7,0,57,89,7,0,0,0,0,0,104,81,0,0,26,7,0,0,27,7,0,0,106,0,0,0,107,0,0,0,0,0,0,0,88,81,0,0,28,7,0,0,29,7,0,0,159,0,0,0,0,0,0,0,120,81,0,0,208,3,0,0,30,7,0,0,31,7,0,0,0,0,0,0,152,81,0,0,208,3,0,0,32,7,0,0,33,7,0,0,0,0,0,0,168,81,0,0,208,3,0,0,34,7,0,0,35,7,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,120,0,0,0,124,0,0,0,16,0,0,0,96,0,0,0,108,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,80,0,0,0,132,0,0,0,136,0,0,0,128,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,4,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,20,0,0,0,24,0,0,0,16,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,144,0,0,0,16,0,0,0,80,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,0,148,0,0,0,112,0,0,0,128,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,255,255,255,255,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,32,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,40,0,0,0,48,0,0,0,52,0,0,0,24,0,0,0,20,0,0,0,28,0,0,0,44,0,0,0,32,0,0,0,36,0,0,0,0,0,0,0,6,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,3,0,0,0,7,0,0,0,4,0,0,0,5,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,64,0,0,0,16,0,0,0,68,0,0,0,32,0,0,0,48,0,0,0,0,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,24,0,0,0,20,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,32,0,0,0,16,0,0,0,36,0,0,0,0,0,0,0,255,255,255,255,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,92,0,0,0,56,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,80,0,0,0,60,0,0,0,64,0,0,0,68,0,0,0,72,0,0,0,76,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,2,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,8,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,56,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,32,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,49,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,24,0,0,0,20,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,48,0,0,0,52,0,0,0,32,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,20,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,36,0,0,0,40,0,0,0,255,255,255,255,0,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,64,0,0,0,68,0,0,0,48,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,1,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,255,255,255,255,0,0,0,0,1,0,0,0,2,0,0,0,8,0,0,0,4,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,16,0,0,0,255,255,255,255,0,0,0,0,184,81,0,0,36,7,0,0,37,7,0,0,166,0,0,0,83,2,0,0,117,1,0,0,84,2,0,0,85,2,0,0,38,7,0,0,86,2,0,0,167,0,0,0,168,0,0,0,118,1,0,0,87,2,0,0,63,3,0,0,58,0,0,0,88,2,0,0,160,0,0,0,34,0,0,0,64,3,0,0,65,3,0,0,61,4,0,0,35,0,0,0,66,3,0,0,36,0,0,0,67,3,0,0,0,0,0,0,6,0,0,0,32,0,0,0,7,0,0,0,24,0,0,0,140,0,0,0,36,0,0,0,44,0,0,0,28,0,0,0,47,0,0,0,54,0,0,0,24,0,0,0,56,0,0,0,71,0,0,0,152,0,0,0,81,0,0,0,87,0,0,0,48,0,0,0,88,0,0,0,103,0,0,0,56,0,0,0,113,0,0,0,120,0,0,0,24,0,0,0,122,0,0,0,129,0,0,0,24,0,0,0,131,0,0,0,141,0,0,0,72,0,0,0,146,0,0,0,154,0,0,0,28,0,0,0,157,0,0,0,165,0,0,0,40,0,0,0,168,0,0,0,179,0,0,0,36,0,0,0,185,0,0,0,209,0,0,0,96,0,0,0,228,0,0,0,238,0,0,0,52,0,0,0,243,0,0,0,255,0,0,0,60,0,0,0,6,1,0,0,12,1,0,0,48,0,0,0,13,1,0,0,21,1,0,0,52,0,0,0,24,1,0,0,31,1,0,0,52,0,0,0,33,1,0,0,40,1,0,0,52,0,0,0,42,1,0,0,50,1,0,0,56,0,0,0,53,1,0,0,60,1,0,0,24,0,0,0,62,1,0,0,74,1,0,0,72,0,0,0,81,1,0,0,91,1,0,0,72,0,0,0,96,1,0,0,102,1,0,0,32,0,0,0,103,1,0,0,112,1,0,0,44,0,0,0,116,1,0,0,122,1,0,0,32,0,0,0,40,51,8,0,72,51,8,0,216,51,8,0,248,51,8,0,16,52,8,0,168,52,8,0,216,52,8,0,16,53,8,0,40,53,8,0,64,53,8,0,136,53,8,0,168,53,8,0,208,53,8,0,248,53,8,0,88,54,8,0,144,54,8,0,208,54,8,0,0,55,8,0,56,55,8,0,112,55,8,0,168,55,8,0,224,55,8,0,248,55,8,0,64,56,8,0,136,56,8,0,168,56,8,0,216,56,8,0,0,0,0,0,200,81,0,0,39,7,0,0,40,7,0,0,166,0,0,0,89,2,0,0,119,1,0,0,90,2,0,0,91,2,0,0,41,7,0,0,92,2,0,0,167,0,0,0,168,0,0,0,120,1,0,0,93,2,0,0,68,3,0,0,58,0,0,0,94,2,0,0,161,0,0,0,34,0,0,0,69,3,0,0,70,3,0,0,61,4,0,0,35,0,0,0,71,3,0,0,36,0,0,0,72,3,0,0,0,0,0,0,216,81,0,0,42,7,0,0,43,7,0,0,166,0,0,0,95,2,0,0,121,1,0,0,96,2,0,0,97,2,0,0,44,7,0,0,98,2,0,0,167,0,0,0,168,0,0,0,122,1,0,0,99,2,0,0,73,3,0,0,58,0,0,0,100,2,0,0,162,0,0,0,34,0,0,0,74,3,0,0,75,3,0,0,61,4,0,0,35,0,0,0,76,3,0,0,36,0,0,0,77,3,0,0,0,0,0,0,232,81,0,0,45,7,0,0,46,7,0,0,166,0,0,0,101,2,0,0,123,1,0,0,102,2,0,0,103,2,0,0,47,7,0,0,104,2,0,0,167,0,0,0,168,0,0,0,124,1,0,0,105,2,0,0,78,3,0,0,58,0,0,0,106,2,0,0,163,0,0,0,34,0,0,0,79,3,0,0,80,3,0,0,61,4,0,0,35,0,0,0,81,3,0,0,36,0,0,0,82,3,0,0,0,0,0,0,248,81,0,0,48,7,0,0,49,7,0,0,166,0,0,0,107,2,0,0,125,1,0,0,108,2,0,0,109,2,0,0,50,7,0,0,110,2,0,0,167,0,0,0,168,0,0,0,126,1,0,0,111,2,0,0,83,3,0,0,58,0,0,0,112,2,0,0,164,0,0,0,34,0,0,0,84,3,0,0,85,3,0,0,61,4,0,0,35,0,0,0,86,3,0,0,36,0,0,0,87,3,0,0,0,0,0,0,8,82,0,0,51,7,0,0,52,7,0,0,166,0,0,0,113,2,0,0,127,1,0,0,114,2,0,0,115,2,0,0,53,7,0,0,116,2,0,0,167,0,0,0,168,0,0,0,128,1,0,0,117,2,0,0,88,3,0,0,58,0,0,0,118,2,0,0,165,0,0,0,34,0,0,0,89,3,0,0,90,3,0,0,61,4,0,0,35,0,0,0,91,3,0,0,36,0,0,0,92,3,0,0,0,0,0,0,24,82,0,0,54,7,0,0,55,7,0,0,166,0,0,0,119,2,0,0,129,1,0,0,120,2,0,0,121,2,0,0,56,7,0,0,122,2,0,0,167,0,0,0,168,0,0,0,130,1,0,0,123,2,0,0,93,3,0,0,58,0,0,0,124,2,0,0,166,0,0,0,34,0,0,0,94,3,0,0,95,3,0,0,61,4,0,0,35,0,0,0,96,3,0,0,36,0,0,0,97,3,0,0,0,0,0,0,40,82,0,0,57,7,0,0,58,7,0,0,166,0,0,0,125,2,0,0,131,1,0,0,126,2,0,0,127,2,0,0,59,7,0,0,128,2,0,0,167,0,0,0,168,0,0,0,132,1,0,0,129,2,0,0,98,3,0,0,58,0,0,0,130,2,0,0,167,0,0,0,34,0,0,0,99,3,0,0,100,3,0,0,61,4,0,0,35,0,0,0,101,3,0,0,36,0,0,0,102,3,0,0,0,0,0,0,56,82,0,0,60,7,0,0,61,7,0,0,166,0,0,0,131,2,0,0,133,1,0,0,132,2,0,0,133,2,0,0,62,7,0,0,134,2,0,0,167,0,0,0,168,0,0,0,134,1,0,0,135,2,0,0,103,3,0,0,58,0,0,0,136,2,0,0,168,0,0,0,34,0,0,0,104,3,0,0,105,3,0,0,61,4,0,0,35,0,0,0,106,3,0,0,36,0,0,0,107,3,0,0,0,0,0,0,72,82,0,0,63,7,0,0,64,7,0,0,166,0,0,0,137,2,0,0,135,1,0,0,138,2,0,0,139,2,0,0,65,7,0,0,140,2,0,0,167,0,0,0,168,0,0,0,136,1,0,0,141,2,0,0,108,3,0,0,58,0,0,0,142,2,0,0,169,0,0,0,34,0,0,0,109,3,0,0,110,3,0,0,61,4,0,0,35,0,0,0,111,3,0,0,36,0,0,0,112,3,0,0,0,0,0,0,88,82,0,0,66,7,0,0,67,7,0,0,166,0,0,0,143,2,0,0,137,1,0,0,144,2,0,0,145,2,0,0,68,7,0,0,146,2,0,0,167,0,0,0,168,0,0,0,138,1,0,0,147,2,0,0,113,3,0,0,58,0,0,0,148,2,0,0,170,0,0,0,34,0,0,0,114,3,0,0,115,3,0,0,61,4,0,0,35,0,0,0,116,3,0,0,36,0,0,0,117,3,0,0,0,0,0,0,104,82,0,0,69,7,0,0,70,7,0,0,166,0,0,0,149,2,0,0,139,1,0,0,150,2,0,0,151,2,0,0,71,7,0,0,152,2,0,0,167,0,0,0,168,0,0,0,140,1,0,0,153,2,0,0,118,3,0,0,58,0,0,0,154,2,0,0,171,0,0,0,34,0,0,0,119,3,0,0,120,3,0,0,61,4,0,0,35,0,0,0,121,3,0,0,36,0,0,0,122,3,0,0,0,0,0,0,120,82,0,0,72,7,0,0,73,7,0,0,166,0,0,0,155,2,0,0,141,1,0,0,156,2,0,0,157,2,0,0,74,7,0,0,158,2,0,0,167,0,0,0,168,0,0,0,142,1,0,0,159,2,0,0,123,3,0,0,58,0,0,0,160,2,0,0,172,0,0,0,34,0,0,0,124,3,0,0,125,3,0,0,61,4,0,0,35,0,0,0,126,3,0,0,36,0,0,0,127,3,0,0,0,0,0,0,136,82,0,0,75,7,0,0,76,7,0,0,166,0,0,0,161,2,0,0,143,1,0,0,162,2,0,0,163,2,0,0,77,7,0,0,164,2,0,0,167,0,0,0,168,0,0,0,144,1,0,0,165,2,0,0,128,3,0,0,58,0,0,0,166,2,0,0,173,0,0,0,34,0,0,0,129,3,0,0,130,3,0,0,61,4,0,0,35,0,0,0,131,3,0,0,36,0,0,0,132,3,0,0,0,0,0,0,152,82,0,0,78,7,0,0,79,7,0,0,166,0,0,0,167,2,0,0,145,1,0,0,168,2,0,0,169,2,0,0,80,7,0,0,170,2,0,0,167,0,0,0,168,0,0,0,146,1,0,0,171,2,0,0,133,3,0,0,58,0,0,0,172,2,0,0,174,0,0,0,34,0,0,0,134,3,0,0,135,3,0,0,61,4,0,0,35,0,0,0,136,3,0,0,36,0,0,0,137,3,0,0,0,0,0,0,168,82,0,0,81,7,0,0,82,7,0,0,166,0,0,0,173,2,0,0,147,1,0,0,174,2,0,0,175,2,0,0,83,7,0,0,176,2,0,0,167,0,0,0,168,0,0,0,148,1,0,0,177,2,0,0,138,3,0,0,58,0,0,0,178,2,0,0,175,0,0,0,34,0,0,0,139,3,0,0,140,3,0,0,61,4,0,0,35,0,0,0,141,3,0,0,36,0,0,0,142,3,0,0,0,0,0,0,184,82,0,0,84,7,0,0,85,7,0,0,166,0,0,0,179,2,0,0,149,1,0,0,180,2,0,0,181,2,0,0,86,7,0,0,182,2,0,0,167,0,0,0,168,0,0,0,150,1,0,0,183,2,0,0,143,3,0,0,58,0,0,0,184,2,0,0,176,0,0,0,34,0,0,0,144,3,0,0,145,3,0,0,61,4,0,0,35,0,0,0,146,3,0,0,36,0,0,0,147,3,0,0,0,0,0,0,200,82,0,0,87,7,0,0,88,7,0,0,166,0,0,0,185,2,0,0,151,1,0,0,186,2,0,0,187,2,0,0,89,7,0,0,188,2,0,0,167,0,0,0,168,0,0,0,152,1,0,0,189,2,0,0,148,3,0,0,58,0,0,0,190,2,0,0,177,0,0,0,34,0,0,0,149,3,0,0,150,3,0,0,61,4,0,0,35,0,0,0,151,3,0,0,36,0,0,0,152,3,0,0,0,0,0,0,216,82,0,0,90,7,0,0,91,7,0,0,166,0,0,0,191,2,0,0,153,1,0,0,192,2,0,0,193,2,0,0,92,7,0,0,194,2,0,0,167,0,0,0,168,0,0,0,154,1,0,0,195,2,0,0,153,3,0,0,58,0,0,0,196,2,0,0,178,0,0,0,34,0,0,0,154,3,0,0,155,3,0,0,61,4,0,0,35,0,0,0,156,3,0,0,36,0,0,0,157,3,0,0,0,0,0,0,232,82,0,0,93,7,0,0,94,7,0,0,166,0,0,0,197,2,0,0,155,1,0,0,198,2,0,0,199,2,0,0,95,7,0,0,200,2,0,0,167,0,0,0,168,0,0,0,156,1,0,0,201,2,0,0,158,3,0,0,58,0,0,0,202,2,0,0,179,0,0,0,34,0,0,0,159,3,0,0,160,3,0,0,61,4,0,0,35,0,0,0,161,3,0,0,36,0,0,0,162,3,0,0,0,0,0,0,248,82,0,0,96,7,0,0,97,7,0,0,166,0,0,0,203,2,0,0,157,1,0,0,204,2,0,0,205,2,0,0,98,7,0,0,206,2,0,0,167,0,0,0,168,0,0,0,158,1,0,0,207,2,0,0,163,3,0,0,58,0,0,0,208,2,0,0,180,0,0,0,34,0,0,0,164,3,0,0,165,3,0,0,61,4,0,0,35,0,0,0,166,3,0,0,36,0,0,0,167,3,0,0,0,0,0,0,8,83,0,0,99,7,0,0,100,7,0,0,166,0,0,0,209,2,0,0,159,1,0,0,210,2,0,0,211,2,0,0,101,7,0,0,212,2,0,0,167,0,0,0,168,0,0,0,160,1,0,0,213,2,0,0,168,3,0,0,58,0,0,0,214,2,0,0,181,0,0,0,34,0,0,0,169,3,0,0,170,3,0,0,61,4,0,0,35,0,0,0,171,3,0,0,36,0,0,0,172,3,0,0,0,0,0,0,24,83,0,0,102,7,0,0,103,7,0,0,166,0,0,0,215,2,0,0,161,1,0,0,216,2,0,0,217,2,0,0,104,7,0,0,218,2,0,0,167,0,0,0,168,0,0,0,162,1,0,0,219,2,0,0,173,3,0,0,58,0,0,0,220,2,0,0,182,0,0,0,34,0,0,0,174,3,0,0,175,3,0,0,61,4,0,0,35,0,0,0,176,3,0,0,36,0,0,0,177,3,0,0,0,0,0,0,40,83,0,0,105,7,0,0,106,7,0,0,166,0,0,0,221,2,0,0,163,1,0,0,222,2,0,0,223,2,0,0,107,7,0,0,224,2,0,0,167,0,0,0,168,0,0,0,164,1,0,0,225,2,0,0,178,3,0,0,58,0,0,0,226,2,0,0,183,0,0,0,34,0,0,0,179,3,0,0,180,3,0,0,61,4,0,0,35,0,0,0,181,3,0,0,36,0,0,0,182,3,0,0,0,0,0,0,56,83,0,0,108,7,0,0,109,7,0,0,166,0,0,0,227,2,0,0,165,1,0,0,228,2,0,0,229,2,0,0,110,7,0,0,230,2,0,0,167,0,0,0,168,0,0,0,166,1,0,0,231,2,0,0,183,3,0,0,58,0,0,0,232,2,0,0,184,0,0,0,34,0,0,0,184,3,0,0,185,3,0,0,61,4,0,0,35,0,0,0,186,3,0,0,36,0,0,0,187,3,0,0,0,0,0,0,72,83,0,0,111,7,0,0,112,7,0,0,166,0,0,0,233,2,0,0,167,1,0,0,234,2,0,0,235,2,0,0,113,7,0,0,236,2,0,0,167,0,0,0,168,0,0,0,168,1,0,0,237,2,0,0,188,3,0,0,58,0,0,0,238,2,0,0,185,0,0,0,34,0,0,0,189,3,0,0,190,3,0,0,61,4,0,0,35,0,0,0,191,3,0,0,36,0,0,0,192,3,0,0,0,0,0,0,88,83,0,0,114,7,0,0,115,7,0,0,166,0,0,0,239,2,0,0,169,1,0,0,240,2,0,0,241,2,0,0,116,7,0,0,242,2,0,0,167,0,0,0,168,0,0,0,170,1,0,0,243,2,0,0,193,3,0,0,58,0,0,0,244,2,0,0,186,0,0,0,34,0,0,0,194,3,0,0,195,3,0,0,61,4,0,0,35,0,0,0,196,3,0,0,36,0,0,0,197,3,0,0,4,0,0,0,5,0,0,0,7,0,0,0,2,0,0,0,6,0,0,0,3,0,0,0,4,0,0,0,8,0,0,0,2,0,0,0,0,0,0,0,112,83,0,0,117,7,0,0,118,7,0,0,187,0,0,0,188,0,0,0,13,0,0,0,189,0,0,0,171,1,0,0,0,0,0,0,128,83,0,0,119,7,0,0,120,7,0,0,166,0,0,0,245,2,0,0,172,1,0,0,246,2,0,0,45,0,0,0,121,7,0,0,247,2,0,0,167,0,0,0,168,0,0,0,173,1,0,0,248,2,0,0,198,3,0,0,58,0,0,0,249,2,0,0,190,0,0,0,34,0,0,0,182,0,0,0,197,0,0,0,61,4,0,0,35,0,0,0,199,3,0,0,36,0,0,0,200,3,0,0,0,0,0,0,144,83,0,0,122,7,0,0,123,7,0,0,174,1,0,0,0,0,0,0,160,83,0,0,124,7,0,0,125,7,0,0,191,0,0,0,0,0,0,0,192,83,0,0,126,7,0,0,127,7,0,0,175,1,0,0,176,1,0,0,177,1,0,0,192,0,0,0,193,0,0,0,187,0,0,0,194,0,0,0,188,0,0,0,195,0,0,0,189,0,0,0,196,0,0,0,190,0,0,0,108,0,0,0,66,0,0,0,191,0,0,0,197,0,0,0,198,0,0,0,199,0,0,0,200,0,0,0,9,0,0,0,10,0,0,0,201,0,0,0,109,0,0,0,202,0,0,0,203,0,0,0,14,0,0,0,15,0,0,0,110,0,0,0,67,0,0,0,111,0,0,0,68,0,0,0,2,0,0,0,3,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,16,0,0,0,116,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,1,0,0,0,2,0,0,0,22,0,0,0,69,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,72,0,0,0,70,0,0,0,101,0,0,0,71,0,0,0,102,0,0,0,3,0,0,0,4,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,26,0,0,0,117,0,0,0,76,0,0,0,118,0,0,0,77,0,0,0,4,0,0,0,5,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,27,0,0,0,123,0,0,0,178,1,0,0,179,1,0,0,250,2,0,0,251,2,0,0,30,0,0,0,31,0,0,0,73,0,0,0,180,1,0,0,28,0,0,0,74,0,0,0,29,0,0,0,124,0,0,0,125,0,0,0,204,0,0,0,205,0,0,0,148,154,7,0,164,154,7,0,178,154,7,0,192,154,7,0,207,154,7,0,222,154,7,0,237,154,7,0,251,154,7,0,8,155,7,0,21,155,7,0,36,155,7,0,0,0,0,0,216,83,0,0,128,7,0,0,129,7,0,0,206,0,0,0,201,3,0,0,181,1,0,0,252,2,0,0,0,0,0,0,232,83,0,0,130,7,0,0,131,7,0,0,207,0,0,0,182,1,0,0,0,0,0,0,248,83,0,0,132,7,0,0,133,7,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,253,2,0,0,134,7,0,0,135,7,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,84,0,0,136,7,0,0,137,7,0,0,183,1,0,0,208,0,0,0,184,1,0,0,209,0,0,0,202,3,0,0,203,3,0,0,254,2,0,0,255,2,0,0,138,7,0,0,139,7,0,0,204,3,0,0,205,3,0,0,192,0,0,0,206,3,0,0,0,3,0,0,1,3,0,0,207,3,0,0,0,0,0,0,88,84,0,0,140,7,0,0,141,7,0,0,185,1,0,0,186,1,0,0,30,0,0,0,208,3,0,0,126,0,0,0,193,0,0,0,209,3,0,0,127,0,0,0,128,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,189,1,0,0,195,0,0,0,212,0,0,0,0,0,0,0,144,84,0,0,140,7,0,0,142,7,0,0,190,1,0,0,191,1,0,0,33,0,0,0,210,3,0,0,129,0,0,0,196,0,0,0,211,3,0,0,130,0,0,0,131,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,192,1,0,0,197,0,0,0,213,0,0,0,0,0,0,0,160,84,0,0,140,7,0,0,143,7,0,0,193,1,0,0,194,1,0,0,34,0,0,0,212,3,0,0,132,0,0,0,198,0,0,0,213,3,0,0,133,0,0,0,134,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,195,1,0,0,199,0,0,0,214,0,0,0,0,0,0,0,192,84,0,0,140,7,0,0,144,7,0,0,196,1,0,0,197,1,0,0,35,0,0,0,214,3,0,0,135,0,0,0,200,0,0,0,215,3,0,0,136,0,0,0,137,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,198,1,0,0,215,0,0,0,0,0,0,0,224,84,0,0,140,7,0,0,145,7,0,0,199,1,0,0,200,1,0,0,36,0,0,0,216,3,0,0,138,0,0,0,201,0,0,0,217,3,0,0,139,0,0,0,140,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,3,0,0,0,216,0,0,0,0,0,0,0,0,85,0,0,140,7,0,0,146,7,0,0,201,1,0,0,202,1,0,0,37,0,0,0,218,3,0,0,141,0,0,0,202,0,0,0,219,3,0,0,142,0,0,0,143,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,4,0,0,0,217,0,0,0,0,0,0,0,32,85,0,0,140,7,0,0,147,7,0,0,203,1,0,0,204,1,0,0,38,0,0,0,220,3,0,0,144,0,0,0,203,0,0,0,221,3,0,0,145,0,0,0,146,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,205,1,0,0,218,0,0,0,0,0,0,0,64,85,0,0,140,7,0,0,148,7,0,0,206,1,0,0,207,1,0,0,39,0,0,0,222,3,0,0,147,0,0,0,204,0,0,0,223,3,0,0,148,0,0,0,149,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,208,1,0,0,219,0,0,0,0,0,0,0,96,85,0,0,140,7,0,0,149,7,0,0,209,1,0,0,210,1,0,0,40,0,0,0,224,3,0,0,150,0,0,0,205,0,0,0,225,3,0,0,151,0,0,0,152,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,211,1,0,0,220,0,0,0,0,0,0,0,128,85,0,0,140,7,0,0,150,7,0,0,212,1,0,0,213,1,0,0,41,0,0,0,226,3,0,0,153,0,0,0,206,0,0,0,227,3,0,0,154,0,0,0,155,0,0,0,187,1,0,0,188,1,0,0,210,0,0,0,211,0,0,0,31,0,0,0,194,0,0,0,32,0,0,0,214,1,0,0,221,0,0,0,0,0,0,0,168,85,0,0,151,7,0,0,152,7,0,0,215,1,0,0,0,0,0,0,192,85,0,0,153,7,0,0,154,7,0,0,207,0,0,0,208,0,0,0,209,0,0,0,156,0,0,0,157,0,0,0,1,0,0,0,2,0,0,0,210,0,0,0,211,0,0,0,158,0,0,0,78,0,0,0,103,0,0,0,104,0,0,0,0,0,0,0,208,85,0,0,155,7,0,0,156,7,0,0,212,0,0,0,0,0,0,0,224,85,0,0,157,7,0,0,158,7,0,0,159,0,0,0,160,0,0,0,0,0,0,0,240,85,0,0,159,7,0,0,160,7,0,0,222,0,0,0,216,1,0,0,213,0,0,0,0,0,0,0,8,86,0,0,124,7,0,0,161,7,0,0,223,0,0,0,0,0,0,0,0,1,0,0,0,9,0,0,0,0,0,0,8,0,0,0,1,0,0,0,32,32,32,32,0,0,0,0,106,194,7,0,224,179,17,0,23,201,17,0,106,203,7,0,0,0,0,0,104,86,0,0,162,7,0,0,163,7,0,0,161,0,0,0,105,0,0,0,1,0,0,0,228,3,0,0,224,0,0,0,164,7,0,0,24,168,2,0,228,167,2,0,0,0,0,0,112,88,0,0,165,7,0,0,166,7,0,0,167,7,0,0,106,0,0,0,1,0,0,0,229,3,0,0,230,3,0,0,2,3,0,0,3,3,0,0,4,3,0,0,5,3,0,0,231,3,0,0,162,0,0,0,0,0,0,0,96,88,0,0,168,7,0,0,169,7,0,0,170,7,0,0,107,0,0,0,2,0,0,0,232,3,0,0,233,3,0,0,6,3,0,0,7,3,0,0,8,3,0,0,9,3,0,0,234,3,0,0,163,0,0,0,0,0,0,0,136,86,0,0,171,7,0,0,172,7,0,0,173,7,0,0,108,0,0,0,2,0,0,0,235,3,0,0,236,3,0,0,10,3,0,0,11,3,0,0,12,3,0,0,13,3,0,0,237,3,0,0,164,0,0,0,32,164,2,0,0,0,0,0,152,86,0,0,238,3,0,0,214,0,0,0,215,0,0,0,216,0,0,0,217,1,0,0,218,1,0,0,14,3,0,0,15,3,0,0,217,0,0,0,174,7,0,0,175,7,0,0,0,0,0,0,216,86,0,0,176,7,0,0,177,7,0,0,16,3,0,0,3,0,0,0,19,0,0,0,178,7,0,0,165,0,0,0,166,0,0,0,0,0,0,0,192,86,0,0,176,7,0,0,179,7,0,0,17,3,0,0,1,0,0,0,20,0,0,0,1,0,0,0,165,0,0,0,166,0,0,0,0,0,0,0,232,86,0,0,176,7,0,0,180,7,0,0,17,3,0,0,4,0,0,0,20,0,0,0,181,7,0,0,165,0,0,0,166,0,0,0,0,0,0,0,0,87,0,0,182,7,0,0,183,7,0,0,184,7,0,0,107,0,0,0,2,0,0,0,239,3,0,0,240,3,0,0,18,3,0,0,19,3,0,0,20,3,0,0,21,3,0,0,241,3,0,0,167,0,0,0,68,165,2,0,16,165,2,0,0,0,0,0,16,87,0,0,242,3,0,0,218,0,0,0,219,0,0,0,220,0,0,0,219,1,0,0,220,1,0,0,22,3,0,0,23,3,0,0,221,0,0,0,174,7,0,0,185,7,0,0,0,0,0,0,56,87,0,0,243,3,0,0,222,0,0,0,223,0,0,0,224,0,0,0,221,1,0,0,222,1,0,0,24,3,0,0,25,3,0,0,225,0,0,0,174,7,0,0,186,7,0,0,0,0,0,0,152,87,0,0,187,7,0,0,188,7,0,0,189,7,0,0,107,0,0,0,2,0,0,0,244,3,0,0,245,3,0,0,26,3,0,0,27,3,0,0,28,3,0,0,29,3,0,0,246,3,0,0,168,0,0,0,240,165,2,0,188,165,2,0,0,0,0,0,88,87,0,0,247,3,0,0,226,0,0,0,227,0,0,0,228,0,0,0,223,1,0,0,224,1,0,0,30,3,0,0,31,3,0,0,229,0,0,0,174,7,0,0,190,7,0,0,0,0,0,0,120,87,0,0,248,3,0,0,230,0,0,0,231,0,0,0,232,0,0,0,225,1,0,0,226,1,0,0,32,3,0,0,33,3,0,0,233,0,0,0,174,7,0,0,191,7,0,0,0,0,0,0,112,86,0,0,1,0,0,0,192,7,0,0,1,0,0,0,0,0,0,0,168,87,0,0,193,7,0,0,194,7,0,0,34,3,0,0,5,0,0,0,21,0,0,0,1,0,0,0,4,0,0,0,8,0,0,0,16,0,0,0,32,0,0,0,0,0,0,0,184,87,0,0,195,7,0,0,196,7,0,0,197,7,0,0,107,0,0,0,2,0,0,0,249,3,0,0,250,3,0,0,35,3,0,0,36,3,0,0,37,3,0,0,38,3,0,0,251,3,0,0,169,0,0,0,168,166,2,0,0,0,0,0,200,87,0,0,252,3,0,0,234,0,0,0,235,0,0,0,236,0,0,0,227,1,0,0,228,1,0,0,39,3,0,0,40,3,0,0,237,0,0,0,174,7,0,0,198,7,0,0,1,0,0,0,5,0,0,0,10,0,0,0,15,0,0,0,16,0,0,0,32,0,0,0,64,0,0,0,128,0,0,0,0,1,0,0,0,0,0,0,16,88,0,0,199,7,0,0,200,7,0,0,201,7,0,0,107,0,0,0,2,0,0,0,253,3,0,0,254,3,0,0,41,3,0,0,42,3,0,0,43,3,0,0,44,3,0,0,255,3,0,0,170,0,0,0,0,0,0,0,32,88,0,0,38,0,0,0,202,7,0,0,0,4,0,0,0,0,0,0,48,88,0,0,203,7,0,0,204,7,0,0,205,7,0,0,107,0,0,0,2,0,0,0,1,4,0,0,2,4,0,0,45,3,0,0,46,3,0,0,47,3,0,0,48,3,0,0,3,4,0,0,171,0,0,0,0,0,0,0,64,88,0,0,206,7,0,0,207,7,0,0,208,7,0,0,109,0,0,0,2,0,0,0,4,4,0,0,5,4,0,0,49,3,0,0,50,3,0,0,51,3,0,0,52,3,0,0,6,4,0,0,172,0,0,0,0,0,0,0,80,88,0,0,193,7,0,0,209,7,0,0,53,3,0,0,6,0,0,0,22,0,0,0,0,0,0,0,128,88,0,0,7,4,0,0,238,0,0,0,239,0,0,0,240,0,0,0,229,1,0,0,230,1,0,0,54,3,0,0,55,3,0,0,241,0,0,0,174,7],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+163844);allocate([210,7,0,0,0,0,0,0,168,88,0,0,8,4,0,0,242,0,0,0,243,0,0,0,244,0,0,0,231,1,0,0,232,1,0,0,56,3,0,0,57,3,0,0,245,0,0,0,174,7,0,0,211,7,0,0,0,0,0,0,176,89,0,0,212,7,0,0,213,7,0,0,214,7,0,0,110,0,0,0,3,0,0,0,9,4,0,0,10,4,0,0,58,3,0,0,59,3,0,0,60,3,0,0,61,3,0,0,11,4,0,0,173,0,0,0,0,0,0,0,160,89,0,0,215,7,0,0,216,7,0,0,217,7,0,0,111,0,0,0,4,0,0,0,12,4,0,0,13,4,0,0,62,3,0,0,63,3,0,0,64,3,0,0,65,3,0,0,14,4,0,0,174,0,0,0,0,0,0,0,208,88,0,0,218,7,0,0,219,7,0,0,220,7,0,0,112,0,0,0,4,0,0,0,15,4,0,0,16,4,0,0,66,3,0,0,67,3,0,0,68,3,0,0,69,3,0,0,17,4,0,0,175,0,0,0,0,0,0,0,232,88,0,0,221,7,0,0,222,7,0,0,223,7,0,0,111,0,0,0,4,0,0,0,18,4,0,0,19,4,0,0,70,3,0,0,71,3,0,0,72,3,0,0,73,3,0,0,20,4,0,0,176,0,0,0,0,0,0,0,248,88,0,0,224,7,0,0,225,7,0,0,226,7,0,0,111,0,0,0,4,0,0,0,21,4,0,0,22,4,0,0,74,3,0,0,75,3,0,0,76,3,0,0,77,3,0,0,23,4,0,0,177,0,0,0,0,0,0,0,8,89,0,0,227,7,0,0,228,7,0,0,229,7,0,0,111,0,0,0,4,0,0,0,24,4,0,0,25,4,0,0,78,3,0,0,79,3,0,0,80,3,0,0,81,3,0,0,26,4,0,0,178,0,0,0,184,169,2,0,0,0,0,0,24,89,0,0,27,4,0,0,246,0,0,0,247,0,0,0,248,0,0,0,233,1,0,0,234,1,0,0,82,3,0,0,83,3,0,0,249,0,0,0,174,7,0,0,230,7,0,0,0,0,0,0,96,89,0,0,231,7,0,0,232,7,0,0,233,7,0,0,111,0,0,0,4,0,0,0,28,4,0,0,29,4,0,0,84,3,0,0,85,3,0,0,86,3,0,0,87,3,0,0,30,4,0,0,179,0,0,0,0,0,0,0,112,89,0,0,38,0,0,0,234,7,0,0,31,4,0,0,0,0,0,0,128,89,0,0,235,7,0,0,236,7,0,0,237,7,0,0,111,0,0,0,4,0,0,0,32,4,0,0,33,4,0,0,88,3,0,0,89,3,0,0,90,3,0,0,91,3,0,0,34,4,0,0,180,0,0,0,0,0,0,0,144,89,0,0,238,7,0,0,239,7,0,0,240,7,0,0,113,0,0,0,4,0,0,0,35,4,0,0,36,4,0,0,92,3,0,0,93,3,0,0,94,3,0,0,95,3,0,0,37,4,0,0,181,0,0,0,0,0,0,0,48,90,0,0,241,7,0,0,242,7,0,0,243,7,0,0,114,0,0,0,5,0,0,0,38,4,0,0,39,4,0,0,96,3,0,0,97,3,0,0,98,3,0,0,99,3,0,0,40,4,0,0,182,0,0,0,0,0,0,0,32,90,0,0,244,7,0,0,245,7,0,0,246,7,0,0,115,0,0,0,6,0,0,0,41,4,0,0,42,4,0,0,100,3,0,0,101,3,0,0,102,3,0,0,103,3,0,0,43,4,0,0,183,0,0,0,0,0,0,0,192,89,0,0,247,7,0,0,248,7,0,0,249,7,0,0,116,0,0,0,6,0,0,0,44,4,0,0,45,4,0,0,104,3,0,0,105,3,0,0,106,3,0,0,107,3,0,0,46,4,0,0,184,0,0,0,0,0,0,0,232,89,0,0,250,7,0,0,251,7,0,0,108,3,0,0,250,0,0,0,109,3,0,0,252,7,0,0,185,0,0,0,186,0,0,0,0,0,0,0,208,89,0,0,250,7,0,0,253,7,0,0,110,3,0,0,1,0,0,0,111,3,0,0,1,0,0,0,185,0,0,0,186,0,0,0,0,0,0,0,248,89,0,0,250,7,0,0,254,7,0,0,110,3,0,0,251,0,0,0,111,3,0,0,255,7,0,0,185,0,0,0,186,0,0,0,0,0,0,0,16,90,0,0,0,8,0,0,1,8,0,0,2,8,0,0,115,0,0,0,6,0,0,0,47,4,0,0,48,4,0,0,112,3,0,0,113,3,0,0,114,3,0,0,115,3,0,0,49,4,0,0,187,0,0,0,88,172,2,0,36,172,2,0,0,0,0,0,64,90,0,0,50,4,0,0,252,0,0,0,253,0,0,0,254,0,0,0,235,1,0,0,236,1,0,0,116,3,0,0,117,3,0,0,255,0,0,0,174,7,0,0,3,8,0,0,0,0,0,0,96,90,0,0,51,4,0,0,0,1,0,0,1,1,0,0,2,1,0,0,237,1,0,0,238,1,0,0,118,3,0,0,119,3,0,0,3,1,0,0,174,7,0,0,4,8,0,0,0,0,0,0,128,90,0,0,38,0,0,0,5,8,0,0,52,4,0,0,169,237,7,0,185,237,7,0,23,201,17,0,196,237,7,0,207,237,7,0,220,237,7,0,231,237,7,0,251,237,7,0,8,238,7,0,23,201,17,0,0,0,0,0,150,48,7,119,44,97,14,238,186,81,9,153,25,196,109,7,143,244,106,112,53,165,99,233,163,149,100,158,50,136,219,14,164,184,220,121,30,233,213,224,136,217,210,151,43,76,182,9,189,124,177,126,7,45,184,231,145,29,191,144,100,16,183,29,242,32,176,106,72,113,185,243,222,65,190,132,125,212,218,26,235,228,221,109,81,181,212,244,199,133,211,131,86,152,108,19,192,168,107,100,122,249,98,253,236,201,101,138,79,92,1,20,217,108,6,99,99,61,15,250,245,13,8,141,200,32,110,59,94,16,105,76,228,65,96,213,114,113,103,162,209,228,3,60,71,212,4,75,253,133,13,210,107,181,10,165,250,168,181,53,108,152,178,66,214,201,187,219,64,249,188,172,227,108,216,50,117,92,223,69,207,13,214,220,89,61,209,171,172,48,217,38,58,0,222,81,128,81,215,200,22,97,208,191,181,244,180,33,35,196,179,86,153,149,186,207,15,165,189,184,158,184,2,40,8,136,5,95,178,217,12,198,36,233,11,177,135,124,111,47,17,76,104,88,171,29,97,193,61,45,102,182,144,65,220,118,6,113,219,1,188,32,210,152,42,16,213,239,137,133,177,113,31,181,182,6,165,228,191,159,51,212,184,232,162,201,7,120,52,249,0,15,142,168,9,150,24,152,14,225,187,13,106,127,45,61,109,8,151,108,100,145,1,92,99,230,244,81,107,107,98,97,108,28,216,48,101,133,78,0,98,242,237,149,6,108,123,165,1,27,193,244,8,130,87,196,15,245,198,217,176,101,80,233,183,18,234,184,190,139,124,136,185,252,223,29,221,98,73,45,218,21,243,124,211,140,101,76,212,251,88,97,178,77,206,81,181,58,116,0,188,163,226,48,187,212,65,165,223,74,215,149,216,61,109,196,209,164,251,244,214,211,106,233,105,67,252,217,110,52,70,136,103,173,208,184,96,218,115,45,4,68,229,29,3,51,95,76,10,170,201,124,13,221,60,113,5,80,170,65,2,39,16,16,11,190,134,32,12,201,37,181,104,87,179,133,111,32,9,212,102,185,159,228,97,206,14,249,222,94,152,201,217,41,34,152,208,176,180,168,215,199,23,61,179,89,129,13,180,46,59,92,189,183,173,108,186,192,32,131,184,237,182,179,191,154,12,226,182,3,154,210,177,116,57,71,213,234,175,119,210,157,21,38,219,4,131,22,220,115,18,11,99,227,132,59,100,148,62,106,109,13,168,90,106,122,11,207,14,228,157,255,9,147,39,174,0,10,177,158,7,125,68,147,15,240,210,163,8,135,104,242,1,30,254,194,6,105,93,87,98,247,203,103,101,128,113,54,108,25,231,6,107,110,118,27,212,254,224,43,211,137,90,122,218,16,204,74,221,103,111,223,185,249,249,239,190,142,67,190,183,23,213,142,176,96,232,163,214,214,126,147,209,161,196,194,216,56,82,242,223,79,241,103,187,209,103,87,188,166,221,6,181,63,75,54,178,72,218,43,13,216,76,27,10,175,246,74,3,54,96,122,4,65,195,239,96,223,85,223,103,168,239,142,110,49,121,190,105,70,140,179,97,203,26,131,102,188,160,210,111,37,54,226,104,82,149,119,12,204,3,71,11,187,185,22,2,34,47,38,5,85,190,59,186,197,40,11,189,178,146,90,180,43,4,106,179,92,167,255,215,194,49,207,208,181,139,158,217,44,29,174,222,91,176,194,100,155,38,242,99,236,156,163,106,117,10,147,109,2,169,6,9,156,63,54,14,235,133,103,7,114,19,87,0,5,130,74,191,149,20,122,184,226,174,43,177,123,56,27,182,12,155,142,210,146,13,190,213,229,183,239,220,124,33,223,219,11,212,210,211,134,66,226,212,241,248,179,221,104,110,131,218,31,205,22,190,129,91,38,185,246,225,119,176,111,119,71,183,24,230,90,8,136,112,106,15,255,202,59,6,102,92,11,1,17,255,158,101,143,105,174,98,248,211,255,107,97,69,207,108,22,120,226,10,160,238,210,13,215,84,131,4,78,194,179,3,57,97,38,103,167,247,22,96,208,77,71,105,73,219,119,110,62,74,106,209,174,220,90,214,217,102,11,223,64,240,59,216,55,83,174,188,169,197,158,187,222,127,207,178,71,233,255,181,48,28,242,189,189,138,194,186,202,48,147,179,83,166,163,180,36,5,54,208,186,147,6,215,205,41,87,222,84,191,103,217,35,46,122,102,179,184,74,97,196,2,27,104,93,148,43,111,42,55,190,11,180,161,142,12,195,27,223,5,90,141,239,2,45,0,0,0,0,65,49,27,25,130,98,54,50,195,83,45,43,4,197,108,100,69,244,119,125,134,167,90,86,199,150,65,79,8,138,217,200,73,187,194,209,138,232,239,250,203,217,244,227,12,79,181,172,77,126,174,181,142,45,131,158,207,28,152,135,81,18,194,74,16,35,217,83,211,112,244,120,146,65,239,97,85,215,174,46,20,230,181,55,215,181,152,28,150,132,131,5,89,152,27,130,24,169,0,155,219,250,45,176,154,203,54,169,93,93,119,230,28,108,108,255,223,63,65,212,158,14,90,205,162,36,132,149,227,21,159,140,32,70,178,167,97,119,169,190,166,225,232,241,231,208,243,232,36,131,222,195,101,178,197,218,170,174,93,93,235,159,70,68,40,204,107,111,105,253,112,118,174,107,49,57,239,90,42,32,44,9,7,11,109,56,28,18,243,54,70,223,178,7,93,198,113,84,112,237,48,101,107,244,247,243,42,187,182,194,49,162,117,145,28,137,52,160,7,144,251,188,159,23,186,141,132,14,121,222,169,37,56,239,178,60,255,121,243,115,190,72,232,106,125,27,197,65,60,42,222,88,5,79,121,240,68,126,98,233,135,45,79,194,198,28,84,219,1,138,21,148,64,187,14,141,131,232,35,166,194,217,56,191,13,197,160,56,76,244,187,33,143,167,150,10,206,150,141,19,9,0,204,92,72,49,215,69,139,98,250,110,202,83,225,119,84,93,187,186,21,108,160,163,214,63,141,136,151,14,150,145,80,152,215,222,17,169,204,199,210,250,225,236,147,203,250,245,92,215,98,114,29,230,121,107,222,181,84,64,159,132,79,89,88,18,14,22,25,35,21,15,218,112,56,36,155,65,35,61,167,107,253,101,230,90,230,124,37,9,203,87,100,56,208,78,163,174,145,1,226,159,138,24,33,204,167,51,96,253,188,42,175,225,36,173,238,208,63,180,45,131,18,159,108,178,9,134,171,36,72,201,234,21,83,208,41,70,126,251,104,119,101,226,246,121,63,47,183,72,36,54,116,27,9,29,53,42,18,4,242,188,83,75,179,141,72,82,112,222,101,121,49,239,126,96,254,243,230,231,191,194,253,254,124,145,208,213,61,160,203,204,250,54,138,131,187,7,145,154,120,84,188,177,57,101,167,168,75,152,131,59,10,169,152,34,201,250,181,9,136,203,174,16,79,93,239,95,14,108,244,70,205,63,217,109,140,14,194,116,67,18,90,243,2,35,65,234,193,112,108,193,128,65,119,216,71,215,54,151,6,230,45,142,197,181,0,165,132,132,27,188,26,138,65,113,91,187,90,104,152,232,119,67,217,217,108,90,30,79,45,21,95,126,54,12,156,45,27,39,221,28,0,62,18,0,152,185,83,49,131,160,144,98,174,139,209,83,181,146,22,197,244,221,87,244,239,196,148,167,194,239,213,150,217,246,233,188,7,174,168,141,28,183,107,222,49,156,42,239,42,133,237,121,107,202,172,72,112,211,111,27,93,248,46,42,70,225,225,54,222,102,160,7,197,127,99,84,232,84,34,101,243,77,229,243,178,2,164,194,169,27,103,145,132,48,38,160,159,41,184,174,197,228,249,159,222,253,58,204,243,214,123,253,232,207,188,107,169,128,253,90,178,153,62,9,159,178,127,56,132,171,176,36,28,44,241,21,7,53,50,70,42,30,115,119,49,7,180,225,112,72,245,208,107,81,54,131,70,122,119,178,93,99,78,215,250,203,15,230,225,210,204,181,204,249,141,132,215,224,74,18,150,175,11,35,141,182,200,112,160,157,137,65,187,132,70,93,35,3,7,108,56,26,196,63,21,49,133,14,14,40,66,152,79,103,3,169,84,126,192,250,121,85,129,203,98,76,31,197,56,129,94,244,35,152,157,167,14,179,220,150,21,170,27,0,84,229,90,49,79,252,153,98,98,215,216,83,121,206,23,79,225,73,86,126,250,80,149,45,215,123,212,28,204,98,19,138,141,45,82,187,150,52,145,232,187,31,208,217,160,6,236,243,126,94,173,194,101,71,110,145,72,108,47,160,83,117,232,54,18,58,169,7,9,35,106,84,36,8,43,101,63,17,228,121,167,150,165,72,188,143,102,27,145,164,39,42,138,189,224,188,203,242,161,141,208,235,98,222,253,192,35,239,230,217,189,225,188,20,252,208,167,13,63,131,138,38,126,178,145,63,185,36,208,112,248,21,203,105,59,70,230,66,122,119,253,91,181,107,101,220,244,90,126,197,55,9,83,238,118,56,72,247,177,174,9,184,240,159,18,161,51,204,63,138,114,253,36,147,0,0,0,0,55,106,194,1,110,212,132,3,89,190,70,2,220,168,9,7,235,194,203,6,178,124,141,4,133,22,79,5,184,81,19,14,143,59,209,15,214,133,151,13,225,239,85,12,100,249,26,9,83,147,216,8,10,45,158,10,61,71,92,11,112,163,38,28,71,201,228,29,30,119,162,31,41,29,96,30,172,11,47,27,155,97,237,26,194,223,171,24,245,181,105,25,200,242,53,18,255,152,247,19,166,38,177,17,145,76,115,16,20,90,60,21,35,48,254,20,122,142,184,22,77,228,122,23,224,70,77,56,215,44,143,57,142,146,201,59,185,248,11,58,60,238,68,63,11,132,134,62,82,58,192,60,101,80,2,61,88,23,94,54,111,125,156,55,54,195,218,53,1,169,24,52,132,191,87,49,179,213,149,48,234,107,211,50,221,1,17,51,144,229,107,36,167,143,169,37,254,49,239,39,201,91,45,38,76,77,98,35,123,39,160,34,34,153,230,32,21,243,36,33,40,180,120,42,31,222,186,43,70,96,252,41,113,10,62,40,244,28,113,45,195,118,179,44,154,200,245,46,173,162,55,47,192,141,154,112,247,231,88,113,174,89,30,115,153,51,220,114,28,37,147,119,43,79,81,118,114,241,23,116,69,155,213,117,120,220,137,126,79,182,75,127,22,8,13,125,33,98,207,124,164,116,128,121,147,30,66,120,202,160,4,122,253,202,198,123,176,46,188,108,135,68,126,109,222,250,56,111,233,144,250,110,108,134,181,107,91,236,119,106,2,82,49,104,53,56,243,105,8,127,175,98,63,21,109,99,102,171,43,97,81,193,233,96,212,215,166,101,227,189,100,100,186,3,34,102,141,105,224,103,32,203,215,72,23,161,21,73,78,31,83,75,121,117,145,74,252,99,222,79,203,9,28,78,146,183,90,76,165,221,152,77,152,154,196,70,175,240,6,71,246,78,64,69,193,36,130,68,68,50,205,65,115,88,15,64,42,230,73,66,29,140,139,67,80,104,241,84,103,2,51,85,62,188,117,87,9,214,183,86,140,192,248,83,187,170,58,82,226,20,124,80,213,126,190,81,232,57,226,90,223,83,32,91,134,237,102,89,177,135,164,88,52,145,235,93,3,251,41,92,90,69,111,94,109,47,173,95,128,27,53,225,183,113,247,224,238,207,177,226,217,165,115,227,92,179,60,230,107,217,254,231,50,103,184,229,5,13,122,228,56,74,38,239,15,32,228,238,86,158,162,236,97,244,96,237,228,226,47,232,211,136,237,233,138,54,171,235,189,92,105,234,240,184,19,253,199,210,209,252,158,108,151,254,169,6,85,255,44,16,26,250,27,122,216,251,66,196,158,249,117,174,92,248,72,233,0,243,127,131,194,242,38,61,132,240,17,87,70,241,148,65,9,244,163,43,203,245,250,149,141,247,205,255,79,246,96,93,120,217,87,55,186,216,14,137,252,218,57,227,62,219,188,245,113,222,139,159,179,223,210,33,245,221,229,75,55,220,216,12,107,215,239,102,169,214,182,216,239,212,129,178,45,213,4,164,98,208,51,206,160,209,106,112,230,211,93,26,36,210,16,254,94,197,39,148,156,196,126,42,218,198,73,64,24,199,204,86,87,194,251,60,149,195,162,130,211,193,149,232,17,192,168,175,77,203,159,197,143,202,198,123,201,200,241,17,11,201,116,7,68,204,67,109,134,205,26,211,192,207,45,185,2,206,64,150,175,145,119,252,109,144,46,66,43,146,25,40,233,147,156,62,166,150,171,84,100,151,242,234,34,149,197,128,224,148,248,199,188,159,207,173,126,158,150,19,56,156,161,121,250,157,36,111,181,152,19,5,119,153,74,187,49,155,125,209,243,154,48,53,137,141,7,95,75,140,94,225,13,142,105,139,207,143,236,157,128,138,219,247,66,139,130,73,4,137,181,35,198,136,136,100,154,131,191,14,88,130,230,176,30,128,209,218,220,129,84,204,147,132,99,166,81,133,58,24,23,135,13,114,213,134,160,208,226,169,151,186,32,168,206,4,102,170,249,110,164,171,124,120,235,174,75,18,41,175,18,172,111,173,37,198,173,172,24,129,241,167,47,235,51,166,118,85,117,164,65,63,183,165,196,41,248,160,243,67,58,161,170,253,124,163,157,151,190,162,208,115,196,181,231,25,6,180,190,167,64,182,137,205,130,183,12,219,205,178,59,177,15,179,98,15,73,177,85,101,139,176,104,34,215,187,95,72,21,186,6,246,83,184,49,156,145,185,180,138,222,188,131,224,28,189,218,94,90,191,237,52,152,190,0,0,0,0,101,103,188,184,139,200,9,170,238,175,181,18,87,151,98,143,50,240,222,55,220,95,107,37,185,56,215,157,239,40,180,197,138,79,8,125,100,224,189,111,1,135,1,215,184,191,214,74,221,216,106,242,51,119,223,224,86,16,99,88,159,87,25,80,250,48,165,232,20,159,16,250,113,248,172,66,200,192,123,223,173,167,199,103,67,8,114,117,38,111,206,205,112,127,173,149,21,24,17,45,251,183,164,63,158,208,24,135,39,232,207,26,66,143,115,162,172,32,198,176,201,71,122,8,62,175,50,160,91,200,142,24,181,103,59,10,208,0,135,178,105,56,80,47,12,95,236,151,226,240,89,133,135,151,229,61,209,135,134,101,180,224,58,221,90,79,143,207,63,40,51,119,134,16,228,234,227,119,88,82,13,216,237,64,104,191,81,248,161,248,43,240,196,159,151,72,42,48,34,90,79,87,158,226,246,111,73,127,147,8,245,199,125,167,64,213,24,192,252,109,78,208,159,53,43,183,35,141,197,24,150,159,160,127,42,39,25,71,253,186,124,32,65,2,146,143,244,16,247,232,72,168,61,88,20,155,88,63,168,35,182,144,29,49,211,247,161,137,106,207,118,20,15,168,202,172,225,7,127,190,132,96,195,6,210,112,160,94,183,23,28,230,89,184,169,244,60,223,21,76,133,231,194,209,224,128,126,105,14,47,203,123,107,72,119,195,162,15,13,203,199,104,177,115,41,199,4,97,76,160,184,217,245,152,111,68,144,255,211,252,126,80,102,238,27,55,218,86,77,39,185,14,40,64,5,182,198,239,176,164,163,136,12,28,26,176,219,129,127,215,103,57,145,120,210,43,244,31,110,147,3,247,38,59,102,144,154,131,136,63,47,145,237,88,147,41,84,96,68,180,49,7,248,12,223,168,77,30,186,207,241,166,236,223,146,254,137,184,46,70,103,23,155,84,2,112,39,236,187,72,240,113,222,47,76,201,48,128,249,219,85,231,69,99,156,160,63,107,249,199,131,211,23,104,54,193,114,15,138,121,203,55,93,228,174,80,225,92,64,255,84,78,37,152,232,246,115,136,139,174,22,239,55,22,248,64,130,4,157,39,62,188,36,31,233,33,65,120,85,153,175,215,224,139,202,176,92,51,59,182,89,237,94,209,229,85,176,126,80,71,213,25,236,255,108,33,59,98,9,70,135,218,231,233,50,200,130,142,142,112,212,158,237,40,177,249,81,144,95,86,228,130,58,49,88,58,131,9,143,167,230,110,51,31,8,193,134,13,109,166,58,181,164,225,64,189,193,134,252,5,47,41,73,23,74,78,245,175,243,118,34,50,150,17,158,138,120,190,43,152,29,217,151,32,75,201,244,120,46,174,72,192,192,1,253,210,165,102,65,106,28,94,150,247,121,57,42,79,151,150,159,93,242,241,35,229,5,25,107,77,96,126,215,245,142,209,98,231,235,182,222,95,82,142,9,194,55,233,181,122,217,70,0,104,188,33,188,208,234,49,223,136,143,86,99,48,97,249,214,34,4,158,106,154,189,166,189,7,216,193,1,191,54,110,180,173,83,9,8,21,154,78,114,29,255,41,206,165,17,134,123,183,116,225,199,15,205,217,16,146,168,190,172,42,70,17,25,56,35,118,165,128,117,102,198,216,16,1,122,96,254,174,207,114,155,201,115,202,34,241,164,87,71,150,24,239,169,57,173,253,204,94,17,69,6,238,77,118,99,137,241,206,141,38,68,220,232,65,248,100,81,121,47,249,52,30,147,65,218,177,38,83,191,214,154,235,233,198,249,179,140,161,69,11,98,14,240,25,7,105,76,161,190,81,155,60,219,54,39,132,53,153,146,150,80,254,46,46,153,185,84,38,252,222,232,158,18,113,93,140,119,22,225,52,206,46,54,169,171,73,138,17,69,230,63,3,32,129,131,187,118,145,224,227,19,246,92,91,253,89,233,73,152,62,85,241,33,6,130,108,68,97,62,212,170,206,139,198,207,169,55,126,56,65,127,214,93,38,195,110,179,137,118,124,214,238,202,196,111,214,29,89,10,177,161,225,228,30,20,243,129,121,168,75,215,105,203,19,178,14,119,171,92,161,194,185,57,198,126,1,128,254,169,156,229,153,21,36,11,54,160,54,110,81,28,142,167,22,102,134,194,113,218,62,44,222,111,44,73,185,211,148,240,129,4,9,149,230,184,177,123,73,13,163,30,46,177,27,72,62,210,67,45,89,110,251,195,246,219,233,166,145,103,81,31,169,176,204,122,206,12,116,148,97,185,102,241,6,5,222,0,0,0,0,119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25,112,106,244,143,233,99,165,53,158,100,149,163,14,219,136,50,121,220,184,164,224,213,233,30,151,210,217,136,9,182,76,43,126,177,124,189,231,184,45,7,144,191,29,145,29,183,16,100,106,176,32,242,243,185,113,72,132,190,65,222,26,218,212,125,109,221,228,235,244,212,181,81,131,211,133,199,19,108,152,86,100,107,168,192,253,98,249,122,138,101,201,236,20,1,92,79,99,6,108,217,250,15,61,99,141,8,13,245,59,110,32,200,76,105,16,94,213,96,65,228,162,103,113,114,60,3,228,209,75,4,212,71,210,13,133,253,165,10,181,107,53,181,168,250,66,178,152,108,219,187,201,214,172,188,249,64,50,216,108,227,69,223,92,117,220,214,13,207,171,209,61,89,38,217,48,172,81,222,0,58,200,215,81,128,191,208,97,22,33,180,244,181,86,179,196,35,207,186,149,153,184,189,165,15,40,2,184,158,95,5,136,8,198,12,217,178,177,11,233,36,47,111,124,135,88,104,76,17,193,97,29,171,182,102,45,61,118,220,65,144,1,219,113,6,152,210,32,188,239,213,16,42,113,177,133,137,6,182,181,31,159,191,228,165,232,184,212,51,120,7,201,162,15,0,249,52,150,9,168,142,225,14,152,24,127,106,13,187,8,109,61,45,145,100,108,151,230,99,92,1,107,107,81,244,28,108,97,98,133,101,48,216,242,98,0,78,108,6,149,237,27,1,165,123,130,8,244,193,245,15,196,87,101,176,217,198,18,183,233,80,139,190,184,234,252,185,136,124,98,221,29,223,21,218,45,73,140,211,124,243,251,212,76,101,77,178,97,88,58,181,81,206,163,188,0,116,212,187,48,226,74,223,165,65,61,216,149,215,164,209,196,109,211,214,244,251,67,105,233,106,52,110,217,252,173,103,136,70,218,96,184,208,68,4,45,115,51,3,29,229,170,10,76,95,221,13,124,201,80,5,113,60,39,2,65,170,190,11,16,16,201,12,32,134,87,104,181,37,32,111,133,179,185,102,212,9,206,97,228,159,94,222,249,14,41,217,201,152,176,208,152,34,199,215,168,180,89,179,61,23,46,180,13,129,183,189,92,59,192,186,108,173,237,184,131,32,154,191,179,182,3,182,226,12,116,177,210,154,234,213,71,57,157,210,119,175,4,219,38,21,115,220,22,131,227,99,11,18,148,100,59,132,13,109,106,62,122,106,90,168,228,14,207,11,147,9,255,157,10,0,174,39,125,7,158,177,240,15,147,68,135,8,163,210,30,1,242,104,105,6,194,254,247,98,87,93,128,101,103,203,25,108,54,113,110,107,6,231,254,212,27,118,137,211,43,224,16,218,122,90,103,221,74,204,249,185,223,111,142,190,239,249,23,183,190,67,96,176,142,213,214,214,163,232,161,209,147,126,56,216,194,196,79,223,242,82,209,187,103,241,166,188,87,103,63,181,6,221,72,178,54,75,216,13,43,218,175,10,27,76,54,3,74,246,65,4,122,96,223,96,239,195,168,103,223,85,49,110,142,239,70,105,190,121,203,97,179,140,188,102,131,26,37,111,210,160,82,104,226,54,204,12,119,149,187,11,71,3,34,2,22,185,85,5,38,47,197,186,59,190,178,189,11,40,43,180,90,146,92,179,106,4,194,215,255,167,181,208,207,49,44,217,158,139,91,222,174,29,155,100,194,176,236,99,242,38,117,106,163,156,2,109,147,10,156,9,6,169,235,14,54,63,114,7,103,133,5,0,87,19,149,191,74,130,226,184,122,20,123,177,43,174,12,182,27,56,146,210,142,155,229,213,190,13,124,220,239,183,11,219,223,33,134,211,210,212,241,212,226,66,104,221,179,248,31,218,131,110,129,190,22,205,246,185,38,91,111,176,119,225,24,183,71,119,136,8,90,230,255,15,106,112,102,6,59,202,17,1,11,92,143,101,158,255,248,98,174,105,97,107,255,211,22,108,207,69,160,10,226,120,215,13,210,238,78,4,131,84,57,3,179,194,167,103,38,97,208,96,22,247,73,105,71,77,62,110,119,219,174,209,106,74,217,214,90,220,64,223,11,102,55,216,59,240,169,188,174,83,222,187,158,197,71,178,207,127,48,181,255,233,189,189,242,28,202,186,194,138,83,179,147,48,36,180,163,166,186,208,54,5,205,215,6,147,84,222,87,41,35,217,103,191,179,102,122,46,196,97,74,184,93,104,27,2,42,111,43,148,180,11,190,55,195,12,142,161,90,5,223,27,45,2,239,141,0,0,0,0,25,27,49,65,50,54,98,130,43,45,83,195,100,108,197,4,125,119,244,69,86,90,167,134,79,65,150,199,200,217,138,8,209,194,187,73,250,239,232,138,227,244,217,203,172,181,79,12,181,174,126,77,158,131,45,142,135,152,28,207,74,194,18,81,83,217,35,16,120,244,112,211,97,239,65,146,46,174,215,85,55,181,230,20,28,152,181,215,5,131,132,150,130,27,152,89,155,0,169,24,176,45,250,219,169,54,203,154,230,119,93,93,255,108,108,28,212,65,63,223,205,90,14,158,149,132,36,162,140,159,21,227,167,178,70,32,190,169,119,97,241,232,225,166,232,243,208,231,195,222,131,36,218,197,178,101,93,93,174,170,68,70,159,235,111,107,204,40,118,112,253,105,57,49,107,174,32,42,90,239,11,7,9,44,18,28,56,109,223,70,54,243,198,93,7,178,237,112,84,113,244,107,101,48,187,42,243,247,162,49,194,182,137,28,145,117,144,7,160,52,23,159,188,251,14,132,141,186,37,169,222,121,60,178,239,56,115,243,121,255,106,232,72,190,65,197,27,125,88,222,42,60,240,121,79,5,233,98,126,68,194,79,45,135,219,84,28,198,148,21,138,1,141,14,187,64,166,35,232,131,191,56,217,194,56,160,197,13,33,187,244,76,10,150,167,143,19,141,150,206,92,204,0,9,69,215,49,72,110,250,98,139,119,225,83,202,186,187,93,84,163,160,108,21,136,141,63,214,145,150,14,151,222,215,152,80,199,204,169,17,236,225,250,210,245,250,203,147,114,98,215,92,107,121,230,29,64,84,181,222,89,79,132,159,22,14,18,88,15,21,35,25,36,56,112,218,61,35,65,155,101,253,107,167,124,230,90,230,87,203,9,37,78,208,56,100,1,145,174,163,24,138,159,226,51,167,204,33,42,188,253,96,173,36,225,175,180,63,208,238,159,18,131,45,134,9,178,108,201,72,36,171,208,83,21,234,251,126,70,41,226,101,119,104,47,63,121,246,54,36,72,183,29,9,27,116,4,18,42,53,75,83,188,242,82,72,141,179,121,101,222,112,96,126,239,49,231,230,243,254,254,253,194,191,213,208,145,124,204,203,160,61,131,138,54,250,154,145,7,187,177,188,84,120,168,167,101,57,59,131,152,75,34,152,169,10,9,181,250,201,16,174,203,136,95,239,93,79,70,244,108,14,109,217,63,205,116,194,14,140,243,90,18,67,234,65,35,2,193,108,112,193,216,119,65,128,151,54,215,71,142,45,230,6,165,0,181,197,188,27,132,132,113,65,138,26,104,90,187,91,67,119,232,152,90,108,217,217,21,45,79,30,12,54,126,95,39,27,45,156,62,0,28,221,185,152,0,18,160,131,49,83,139,174,98,144,146,181,83,209,221,244,197,22,196,239,244,87,239,194,167,148,246,217,150,213,174,7,188,233,183,28,141,168,156,49,222,107,133,42,239,42,202,107,121,237,211,112,72,172,248,93,27,111,225,70,42,46,102,222,54,225,127,197,7,160,84,232,84,99,77,243,101,34,2,178,243,229,27,169,194,164,48,132,145,103,41,159,160,38,228,197,174,184,253,222,159,249,214,243,204,58,207,232,253,123,128,169,107,188,153,178,90,253,178,159,9,62,171,132,56,127,44,28,36,176,53,7,21,241,30,42,70,50,7,49,119,115,72,112,225,180,81,107,208,245,122,70,131,54,99,93,178,119,203,250,215,78,210,225,230,15,249,204,181,204,224,215,132,141,175,150,18,74,182,141,35,11,157,160,112,200,132,187,65,137,3,35,93,70,26,56,108,7,49,21,63,196,40,14,14,133,103,79,152,66,126,84,169,3,85,121,250,192,76,98,203,129,129,56,197,31,152,35,244,94,179,14,167,157,170,21,150,220,229,84,0,27,252,79,49,90,215,98,98,153,206,121,83,216,73,225,79,23,80,250,126,86,123,215,45,149,98,204,28,212,45,141,138,19,52,150,187,82,31,187,232,145,6,160,217,208,94,126,243,236,71,101,194,173,108,72,145,110,117,83,160,47,58,18,54,232,35,9,7,169,8,36,84,106,17,63,101,43,150,167,121,228,143,188,72,165,164,145,27,102,189,138,42,39,242,203,188,224,235,208,141,161,192,253,222,98,217,230,239,35,20,188,225,189,13,167,208,252,38,138,131,63,63,145,178,126,112,208,36,185,105,203,21,248,66,230,70,59,91,253,119,122,220,101,107,181,197,126,90,244,238,83,9,55,247,72,56,118,184,9,174,177,161,18,159,240,138,63,204,51,147,36,253,114,0,0,0,0,1,194,106,55,3,132,212,110,2,70,190,89,7,9,168,220,6,203,194,235,4,141,124,178,5,79,22,133,14,19,81,184,15,209,59,143,13,151,133,214,12,85,239,225,9,26,249,100,8,216,147,83,10,158,45,10,11,92,71,61,28,38,163,112,29,228,201,71,31,162,119,30,30,96,29,41,27,47,11,172,26,237,97,155,24,171,223,194,25,105,181,245,18,53,242,200,19,247,152,255,17,177,38,166,16,115,76,145,21,60,90,20,20,254,48,35,22,184,142,122,23,122,228,77,56,77,70,224,57,143,44,215,59,201,146,142,58,11,248,185,63,68,238,60,62,134,132,11,60,192,58,82,61,2,80,101,54,94,23,88,55,156,125,111,53,218,195,54,52,24,169,1,49,87,191,132,48,149,213,179,50,211,107,234,51,17,1,221,36,107,229,144,37,169,143,167,39,239,49,254,38,45,91,201,35,98,77,76,34,160,39,123,32,230,153,34,33,36,243,21,42,120,180,40,43,186,222,31,41,252,96,70,40,62,10,113,45,113,28,244,44,179,118,195,46,245,200,154,47,55,162,173,112,154,141,192,113,88,231,247,115,30,89,174,114,220,51,153,119,147,37,28,118,81,79,43,116,23,241,114,117,213,155,69,126,137,220,120,127,75,182,79,125,13,8,22,124,207,98,33,121,128,116,164,120,66,30,147,122,4,160,202,123,198,202,253,108,188,46,176,109,126,68,135,111,56,250,222,110,250,144,233,107,181,134,108,106,119,236,91,104,49,82,2,105,243,56,53,98,175,127,8,99,109,21,63,97,43,171,102,96,233,193,81,101,166,215,212,100,100,189,227,102,34,3,186,103,224,105,141,72,215,203,32,73,21,161,23,75,83,31,78,74,145,117,121,79,222,99,252,78,28,9,203,76,90,183,146,77,152,221,165,70,196,154,152,71,6,240,175,69,64,78,246,68,130,36,193,65,205,50,68,64,15,88,115,66,73,230,42,67,139,140,29,84,241,104,80,85,51,2,103,87,117,188,62,86,183,214,9,83,248,192,140,82,58,170,187,80,124,20,226,81,190,126,213,90,226,57,232,91,32,83,223,89,102,237,134,88,164,135,177,93,235,145,52,92,41,251,3,94,111,69,90,95,173,47,109,225,53,27,128,224,247,113,183,226,177,207,238,227,115,165,217,230,60,179,92,231,254,217,107,229,184,103,50,228,122,13,5,239,38,74,56,238,228,32,15,236,162,158,86,237,96,244,97,232,47,226,228,233,237,136,211,235,171,54,138,234,105,92,189,253,19,184,240,252,209,210,199,254,151,108,158,255,85,6,169,250,26,16,44,251,216,122,27,249,158,196,66,248,92,174,117,243,0,233,72,242,194,131,127,240,132,61,38,241,70,87,17,244,9,65,148,245,203,43,163,247,141,149,250,246,79,255,205,217,120,93,96,216,186,55,87,218,252,137,14,219,62,227,57,222,113,245,188,223,179,159,139,221,245,33,210,220,55,75,229,215,107,12,216,214,169,102,239,212,239,216,182,213,45,178,129,208,98,164,4,209,160,206,51,211,230,112,106,210,36,26,93,197,94,254,16,196,156,148,39,198,218,42,126,199,24,64,73,194,87,86,204,195,149,60,251,193,211,130,162,192,17,232,149,203,77,175,168,202,143,197,159,200,201,123,198,201,11,17,241,204,68,7,116,205,134,109,67,207,192,211,26,206,2,185,45,145,175,150,64,144,109,252,119,146,43,66,46,147,233,40,25,150,166,62,156,151,100,84,171,149,34,234,242,148,224,128,197,159,188,199,248,158,126,173,207,156,56,19,150,157,250,121,161,152,181,111,36,153,119,5,19,155,49,187,74,154,243,209,125,141,137,53,48,140,75,95,7,142,13,225,94,143,207,139,105,138,128,157,236,139,66,247,219,137,4,73,130,136,198,35,181,131,154,100,136,130,88,14,191,128,30,176,230,129,220,218,209,132,147,204,84,133,81,166,99,135,23,24,58,134,213,114,13,169,226,208,160,168,32,186,151,170,102,4,206,171,164,110,249,174,235,120,124,175,41,18,75,173,111,172,18,172,173,198,37,167,241,129,24,166,51,235,47,164,117,85,118,165,183,63,65,160,248,41,196,161,58,67,243,163,124,253,170,162,190,151,157,181,196,115,208,180,6,25,231,182,64,167,190,183,130,205,137,178,205,219,12,179,15,177,59,177,73,15,98,176,139,101,85,187,215,34,104,186,21,72,95,184,83,246,6,185,145,156,49,188,222,138,180,189,28,224,131,191,90,94,218,190,152,52,237,0,0,0,0,184,188,103,101,170,9,200,139,18,181,175,238,143,98,151,87,55,222,240,50,37,107,95,220,157,215,56,185,197,180,40,239,125,8,79,138,111,189,224,100,215,1,135,1,74,214,191,184,242,106,216,221,224,223,119,51,88,99,16,86,80,25,87,159,232,165,48,250,250,16,159,20,66,172,248,113,223,123,192,200,103,199,167,173,117,114,8,67,205,206,111,38,149,173,127,112,45,17,24,21,63,164,183,251,135,24,208,158,26,207,232,39,162,115,143,66,176,198,32,172,8,122,71,201,160,50,175,62,24,142,200,91,10,59,103,181,178,135,0,208,47,80,56,105,151,236,95,12,133,89,240,226,61,229,151,135,101,134,135,209,221,58,224,180,207,143,79,90,119,51,40,63,234,228,16,134,82,88,119,227,64,237,216,13,248,81,191,104,240,43,248,161,72,151,159,196,90,34,48,42,226,158,87,79,127,73,111,246,199,245,8,147,213,64,167,125,109,252,192,24,53,159,208,78,141,35,183,43,159,150,24,197,39,42,127,160,186,253,71,25,2,65,32,124,16,244,143,146,168,72,232,247,155,20,88,61,35,168,63,88,49,29,144,182,137,161,247,211,20,118,207,106,172,202,168,15,190,127,7,225,6,195,96,132,94,160,112,210,230,28,23,183,244,169,184,89,76,21,223,60,209,194,231,133,105,126,128,224,123,203,47,14,195,119,72,107,203,13,15,162,115,177,104,199,97,4,199,41,217,184,160,76,68,111,152,245,252,211,255,144,238,102,80,126,86,218,55,27,14,185,39,77,182,5,64,40,164,176,239,198,28,12,136,163,129,219,176,26,57,103,215,127,43,210,120,145,147,110,31,244,59,38,247,3,131,154,144,102,145,47,63,136,41,147,88,237,180,68,96,84,12,248,7,49,30,77,168,223,166,241,207,186,254,146,223,236,70,46,184,137,84,155,23,103,236,39,112,2,113,240,72,187,201,76,47,222,219,249,128,48,99,69,231,85,107,63,160,156,211,131,199,249,193,54,104,23,121,138,15,114,228,93,55,203,92,225,80,174,78,84,255,64,246,232,152,37,174,139,136,115,22,55,239,22,4,130,64,248,188,62,39,157,33,233,31,36,153,85,120,65,139,224,215,175,51,92,176,202,237,89,182,59,85,229,209,94,71,80,126,176,255,236,25,213,98,59,33,108,218,135,70,9,200,50,233,231,112,142,142,130,40,237,158,212,144,81,249,177,130,228,86,95,58,88,49,58,167,143,9,131,31,51,110,230,13,134,193,8,181,58,166,109,189,64,225,164,5,252,134,193,23,73,41,47,175,245,78,74,50,34,118,243,138,158,17,150,152,43,190,120,32,151,217,29,120,244,201,75,192,72,174,46,210,253,1,192,106,65,102,165,247,150,94,28,79,42,57,121,93,159,150,151,229,35,241,242,77,107,25,5,245,215,126,96,231,98,209,142,95,222,182,235,194,9,142,82,122,181,233,55,104,0,70,217,208,188,33,188,136,223,49,234,48,99,86,143,34,214,249,97,154,106,158,4,7,189,166,189,191,1,193,216,173,180,110,54,21,8,9,83,29,114,78,154,165,206,41,255,183,123,134,17,15,199,225,116,146,16,217,205,42,172,190,168,56,25,17,70,128,165,118,35,216,198,102,117,96,122,1,16,114,207,174,254,202,115,201,155,87,164,241,34,239,24,150,71,253,173,57,169,69,17,94,204,118,77,238,6,206,241,137,99,220,68,38,141,100,248,65,232,249,47,121,81,65,147,30,52,83,38,177,218,235,154,214,191,179,249,198,233,11,69,161,140,25,240,14,98,161,76,105,7,60,155,81,190,132,39,54,219,150,146,153,53,46,46,254,80,38,84,185,153,158,232,222,252,140,93,113,18,52,225,22,119,169,54,46,206,17,138,73,171,3,63,230,69,187,131,129,32,227,224,145,118,91,92,246,19,73,233,89,253,241,85,62,152,108,130,6,33,212,62,97,68,198,139,206,170,126,55,169,207,214,127,65,56,110,195,38,93,124,118,137,179,196,202,238,214,89,29,214,111,225,161,177,10,243,20,30,228,75,168,121,129,19,203,105,215,171,119,14,178,185,194,161,92,1,126,198,57,156,169,254,128,36,21,153,229,54,160,54,11,142,28,81,110,134,102,22,167,62,218,113,194,44,111,222,44,148,211,185,73,9,4,129,240,177,184,230,149,163,13,73,123,27,177,46,30,67,210,62,72,251,110,89,45,233,219,246,195,81,103,145,166,204,176,169,31,116,12,206,122,102,185,97,148,222,5,6,241,0,0,0,0,0,0,0,0,239,1,0,0,4,0,4,0,8,0,4,0,240,1,0,0,4,0,5,0,16,0,8,0,240,1,0,0,4,0,6,0,32,0,32,0,240,1,0,0,4,0,4,0,16,0,16,0,241,1,0,0,8,0,16,0,32,0,32,0,241,1,0,0,8,0,16,0,128,0,128,0,241,1,0,0,8,0,32,0,128,0,0,1,241,1,0,0,32,0,128,0,2,1,0,4,241,1,0,0,32,0,2,1,2,1,0,16,241,1,0,0,38,250,2,0,56,206,2,0,1,1,0,0,30,1,0,0,15,0,0,0,174,249,2,0,192,205,2,0,0,0,0,0,30,0,0,0,15,0,0,0,0,0,0,0,116,205,2,0,0,0,0,0,19,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,12,0,0,0,13,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,10,0,0,0,12,0,0,0,14,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,40,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,80,0,0,0,96,0,0,0,112,0,0,0,128,0,0,0,160,0,0,0,192,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,0,128,0,0,0,192,0,0,0,0,1,0,0,128,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,180,207,2,0,20,0,0,0,67,46,85,84,70,45,56,0,0,0,0,0,0,0,0,0,0,0,0,0,222,18,4,149,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,152,207,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+174084);allocate([13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,176,208,2,0,5,0,0,0,0,0,0,0,0,0,0,0,120,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,0,0,0,226,0,0,0,5,193,17,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,168,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,208,2,0,40,210,2,0,9,0,0,0,0,0,0,0,0,0,0,0,120,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,227,0,0,0,0,0,0,0,226,0,0,0,13,197,17,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,210,2,0,5,0,0,0,0,0,0,0,0,0,0,0,120,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,228,0,0,0,226,0,0,0,21,201,17,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,229,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,95,112,137,0,255,9,47,15,166,255,2,0,208,213,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,212,219,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,5,0,0,0,7,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,211,0,0,0,1,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,121,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,143,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,169,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,187,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,209,0,0,0,0,0,0,0,24,93,0,0,6,8,0,0,7,8,0,0,0,0,0,0,48,93,0,0,8,8,0,0,9,8,0,0,1,0,0,0,1,0,0,0,91,0,0,0,49,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,27,0,0,0,5,0,0,0,44,0,0,0,3,0,0,0,45,0,0,0,0,0,0,0,56,93,0,0,10,8,0,0,11,8,0,0,53,4,0,0,230,0,0,0,117,0,0,0,188,0,0,0,121,3,0,0,122,3,0,0,231,0,0,0,123,3,0,0,124,3,0,0,242,1,0,0,232,0,0,0,243,1,0,0,8,0,0,0,0,0,0,0,64,93,0,0,11,0,0,0,12,0,0,0,248,255,255,255,248,255,255,255,64,93,0,0,13,0,0,0,14,0,0,0,240,225,2,0,4,226,2,0,8,0,0,0,0,0,0,0,88,93,0,0,12,8,0,0,13,8,0,0,248,255,255,255,248,255,255,255,88,93,0,0,14,8,0,0,15,8,0,0,32,226,2,0,52,226,2,0,28,16,0,0,48,16,0,0,4,0,0,0,0,0,0,0,136,93,0,0,16,8,0,0,17,8,0,0,252,255,255,255,252,255,255,255,136,93,0,0,18,8,0,0,19,8,0,0,88,226,2,0,108,226,2,0,12,0,0,0,0,0,0,0,160,93,0,0,17,0,0,0,18,0,0,0,4,0,0,0,248,255,255,255,160,93,0,0,19,0,0,0,20,0,0,0,244,255,255,255,244,255,255,255,160,93,0,0,21,0,0,0,22,0,0,0,136,226,2,0,204,93,0,0,224,93,0,0,28,16,0,0,48,16,0,0,176,226,2,0,156,226,2,0,0,0,0,0,232,93,0,0,20,8,0,0,21,8,0,0,54,4,0,0,230,0,0,0,117,0,0,0,188,0,0,0,125,3,0,0,122,3,0,0,231,0,0,0,123,3,0,0,124,3,0,0,242,1,0,0,233,0,0,0,244,1,0,0,0,0,0,0,248,93,0,0,22,8,0,0,23,8,0,0,55,4,0,0,1,0,0,0,91,0,0,0,49,0,0,0,126,3,0,0,3,0,0,0,2,0,0,0,27,0,0,0,5,0,0,0,44,0,0,0,234,0,0,0,245,1,0,0,0,0,0,0,8,94,0,0,24,8,0,0,25,8,0,0,56,4,0,0,230,0,0,0,117,0,0,0,188,0,0,0,121,3,0,0,122,3,0,0,231,0,0,0,127,3,0,0,128,3,0,0,246,1,0,0,232,0,0,0,243,1,0,0,0,0,0,0,24,94,0,0,26,8,0,0,27,8,0,0,57,4,0,0,1,0,0,0,91,0,0,0,49,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,129,3,0,0,130,3,0,0,247,1,0,0,3,0,0,0,45,0,0,0,0,0,0,0,40,94,0,0,28,8,0,0,29,8,0,0,30,8,0,0,75,0,0,0,189,0,0,0,235,0,0,0,0,0,0,0,72,94,0,0,31,8,0,0,32,8,0,0,30,8,0,0,76,0,0,0,190,0,0,0,236,0,0,0,0,0,0,0,88,94,0,0,33,8,0,0,34,8,0,0,30,8,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,152,94,0,0,35,8,0,0,36,8,0,0,30,8,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,0,0,0,0,208,94,0,0,37,8,0,0,38,8,0,0,30,8,0,0,77,0,0,0,78,0,0,0,54,0,0,0,79,0,0,0,55,0,0,0,1,0,0,0,2,0,0,0,80,0,0,0,0,0,0,0,16,95,0,0,39,8,0,0,40,8,0,0,30,8,0,0,81,0,0,0,82,0,0,0,56,0,0,0,83,0,0,0,57,0,0,0,3,0,0,0,4,0,0,0,84,0,0,0,0,0,0,0,72,95,0,0,41,8,0,0,42,8,0,0,30,8,0,0,131,3,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,2,0,0,0,248,255,255,255,72,95,0,0,132,3,0,0,133,3,0,0,134,3,0,0,135,3,0,0,136,3,0,0,137,3,0,0,138,3,0,0,0,0,0,0,128,95,0,0,43,8,0,0,44,8,0,0,30,8,0,0,139,3,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,3,0,0,0,248,255,255,255,128,95,0,0,140,3,0,0,141,3,0,0,142,3,0,0,143,3,0,0,144,3,0,0,145,3,0,0,146,3,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,176,95,0,0,45,8,0,0,46,8,0,0,30,8,0,0,1,0,0,0,0,0,0,0,216,95,0,0,47,8,0,0,48,8,0,0,30,8,0,0,2,0,0,0,0,0,0,0,248,95,0,0,49,8,0,0,50,8,0,0,30,8,0,0,147,3,0,0,148,3,0,0,58,4,0,0,59,4,0,0,60,4,0,0,61,4,0,0,149,3,0,0,62,4,0,0,63,4,0,0,0,0,0,0,32,96,0,0,51,8,0,0,52,8,0,0,30,8,0,0,150,3,0,0,151,3,0,0,64,4,0,0,65,4,0,0,66,4,0,0,67,4,0,0,152,3,0,0,68,4,0,0,69,4,0,0,0,0,0,0,64,96,0,0,53,8,0,0,54,8,0,0,30,8,0,0,153,3,0,0,154,3,0,0,70,4,0,0,71,4,0,0,72,4,0,0,73,4,0,0,155,3,0,0,74,4,0,0,75,4,0,0,0,0,0,0,96,96,0,0,55,8,0,0,56,8,0,0,30,8,0,0,156,3,0,0,157,3,0,0,76,4,0,0,77,4,0,0,78,4,0,0,79,4,0,0,158,3,0,0,80,4,0,0,81,4,0,0,0,0,0,0,128,96,0,0,57,8,0,0,58,8,0,0,30,8,0,0,3,0,0,0,4,0,0,0,0,0,0,0,168,96,0,0,59,8,0,0,60,8,0,0,30,8,0,0,5,0,0,0,6,0,0,0,0,0,0,0,208,96,0,0,61,8,0,0,62,8,0,0,30,8,0,0,1,0,0,0,68,0,0,0,0,0,0,0,248,96,0,0,63,8,0,0,64,8,0,0,30,8,0,0,2,0,0,0,69,0,0,0,0,0,0,0,32,97,0,0,65,8,0,0,66,8,0,0,30,8,0,0,237,0,0,0,118,0,0,0,82,4,0,0,0,0,0,0,72,97,0,0,67,8,0,0,68,8,0,0,30,8,0,0,238,0,0,0,119,0,0,0,83,4,0,0,0,0,0,0,160,97,0,0,69,8,0,0,70,8,0,0,30,8,0,0,4,0,0,0,5,0,0,0,85,0,0,0,159,3,0,0,160,3,0,0,86,0,0,0,161,3,0,0,0,0,0,0,104,97,0,0,69,8,0,0,71,8,0,0,30,8,0,0,4,0,0,0,5,0,0,0,85,0,0,0,159,3,0,0,160,3,0,0,86,0,0,0,161,3,0,0,0,0,0,0,208,97,0,0,72,8,0,0,73,8,0,0,30,8,0,0,6,0,0,0,7,0,0,0,87,0,0,0,162,3,0,0,163,3,0,0,88,0,0,0,164,3,0,0,0,0,0,0,16,98,0,0,74,8,0,0,75,8,0,0,30,8,0,0,0,0,0,0,32,98,0,0,76,8,0,0,77,8,0,0,30,8,0,0,248,1,0,0,239,0,0,0,249,1,0,0,240,0,0,0,250,1,0,0,42,0,0,0,241,0,0,0,89,0,0,0,0,0,0,0,104,98,0,0,78,8,0,0,79,8,0,0,30,8,0,0,165,3,0,0,166,3,0,0,84,4,0,0,85,4,0,0,86,4,0,0,0,0,0,0,120,98,0,0,80,8,0,0,81,8,0,0,30,8,0,0,167,3,0,0,168,3,0,0,87,4,0,0,88,4,0,0,89,4,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,56,94,0,0,69,8,0,0,82,8,0,0,30,8,0,0,0,0,0,0,72,98,0,0,69,8,0,0,83,8,0,0,30,8,0,0,242,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,251,1,0,0,243,0,0,0,252,1,0,0,244,0,0,0,253,1,0,0,46,0,0,0,245,0,0,0,90,0,0,0,0,0,0,0,176,97,0,0,69,8,0,0,84,8,0,0,30,8,0,0,8,0,0,0,9,0,0,0,91,0,0,0,169,3,0,0,170,3,0,0,92,0,0,0,171,3,0,0,0,0,0,0,240,97,0,0,69,8,0,0,85,8,0,0,30,8,0,0,10,0,0,0,11,0,0,0,93,0,0,0,172,3,0,0,173,3,0,0,94,0,0,0,174,3,0,0,0,0,0,0,120,97,0,0,69,8,0,0,86,8,0,0,30,8,0,0,4,0,0,0,5,0,0,0,85,0,0,0,159,3,0,0,160,3,0,0,86,0,0,0,161,3,0,0,0,0,0,0,120,95,0,0,132,3,0,0,133,3,0,0,134,3,0,0,135,3,0,0,136,3,0,0,137,3,0,0,138,3,0,0,0,0,0,0,168,95,0,0,140,3,0,0,141,3,0,0,142,3,0,0,143,3,0,0,144,3,0,0,145,3,0,0,146,3,0,0,2,0,0,0,23,12,8,0,0,0,0,0,176,98,0,0,87,8,0,0,88,8,0,0,89,8,0,0,90,8,0,0,246,0,0,0,120,0,0,0,79,0,0,0,191,0,0,0,0,0,0,0,216,98,0,0,87,8,0,0,91,8,0,0,89,8,0,0,90,8,0,0,246,0,0,0,121,0,0,0,80,0,0,0,192,0,0,0,0,0,0,0,232,98,0,0,92,8,0,0,93,8,0,0,175,3,0,0,0,0,0,0,248,98,0,0,92,8,0,0,94,8,0,0,175,3,0,0,0,0,0,0,8,99,0,0,92,8,0,0,95,8,0,0,175,3,0,0,0,0,0,0,24,99,0,0,96,8,0,0,97,8,0,0,176,3,0,0,0,0,0,0,72,99,0,0,87,8,0,0,98,8,0,0,89,8,0,0,90,8,0,0,247,0,0,0,0,0,0,0,56,99,0,0,87,8,0,0,99,8,0,0,89,8,0,0,90,8,0,0,248,0,0,0,0,0,0,0,216,99,0,0,87,8,0,0,100,8,0,0,89,8,0,0,90,8,0,0,249,0,0,0,0,0,0,0,232,99,0,0,87,8,0,0,101,8,0,0,89,8,0,0,90,8,0,0,246,0,0,0,122,0,0,0,81,0,0,0,193,0,0,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,192,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,160,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,224,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,144,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,208,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,176,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,240,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,200,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,168,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,232,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,152,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,216,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,184,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,248,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,196,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,164,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,228,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,148,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,212,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,180,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,244,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,204,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,172,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,236,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,156,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,220,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,188,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,252,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,194,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,162,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,226,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,146,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,210,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,178,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,242,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,202,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,170,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,234,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,154,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,218,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,186,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,250,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,198,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,166,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,230,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,150,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,214,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,182,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,246,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,206,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,174,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,238,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,158,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,222,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,190,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,254,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,193,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,161,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,225,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,145,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,209,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,177,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,241,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,201,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,169,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,233,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,153,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,217,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,185,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,249,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,197,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,165,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,229,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,149,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,213,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,181,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,245,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,205,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,173,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,237,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,157,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,221,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,189,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,253,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,195,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,163,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,227,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,147,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,211,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,179,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,243,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,203,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,171,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,235,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,155,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,219,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,187,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,251,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,199,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,167,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,231,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,151,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,215,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,183,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,247,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,207,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,175,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,239,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,159,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,223,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,191,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+184324);allocate([16,5,1,0,23,5,1,1,19,5,17,0,27,5,1,16,17,5,5,0,25,5,1,4,21,5,65,0,29,5,1,64,16,5,3,0,24,5,1,2,20,5,33,0,28,5,1,32,18,5,9,0,26,5,1,8,22,5,129,0,64,5,0,0,16,5,2,0,23,5,129,1,19,5,25,0,27,5,1,24,17,5,7,0,25,5,1,6,21,5,97,0,29,5,1,96,16,5,4,0,24,5,1,3,20,5,49,0,28,5,1,48,18,5,13,0,26,5,1,12,22,5,193,0,64,5,0,0,16,0,17,0,18,0,0,0,8,0,7,0,9,0,6,0,10,0,5,0,11,0,4,0,12,0,3,0,13,0,2,0,14,0,1,0,15,0,1,0,2,0,3,0,4,0,5,0,7,0,9,0,13,0,17,0,25,0,33,0,49,0,65,0,97,0,129,0,193,0,1,1,129,1,1,2,1,3,1,4,1,6,1,8,1,12,1,16,1,24,1,32,1,48,1,64,1,96,0,0,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,13,0,15,0,17,0,19,0,23,0,27,0,31,0,35,0,43,0,51,0,59,0,67,0,83,0,99,0,115,0,131,0,163,0,195,0,227,0,2,1,0,0,0,0,16,0,16,0,16,0,16,0,17,0,17,0,18,0,18,0,19,0,19,0,20,0,20,0,21,0,21,0,22,0,22,0,23,0,23,0,24,0,24,0,25,0,25,0,26,0,26,0,27,0,27,0,28,0,28,0,29,0,29,0,64,0,64,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,17,0,17,0,17,0,17,0,18,0,18,0,18,0,18,0,19,0,19,0,19,0,19,0,20,0,20,0,20,0,20,0,21,0,21,0,21,0,21,0,16,0,77,0,202,0,0,0,5,0,16,0,5,0,8,0,5,0,24,0,5,0,4,0,5,0,20,0,5,0,12,0,5,0,28,0,5,0,2,0,5,0,18,0,5,0,10,0,5,0,26,0,5,0,6,0,5,0,22,0,5,0,14,0,5,0,30,0,5,0,1,0,5,0,17,0,5,0,9,0,5,0,25,0,5,0,5,0,5,0,21,0,5,0,13,0,5,0,29,0,5,0,3,0,5,0,19,0,5,0,11,0,5,0,27,0,5,0,7,0,5,0,23,0,5,0,12,0,8,0,140,0,8,0,76,0,8,0,204,0,8,0,44,0,8,0,172,0,8,0,108,0,8,0,236,0,8,0,28,0,8,0,156,0,8,0,92,0,8,0,220,0,8,0,60,0,8,0,188,0,8,0,124,0,8,0,252,0,8,0,2,0,8,0,130,0,8,0,66,0,8,0,194,0,8,0,34,0,8,0,162,0,8,0,98,0,8,0,226,0,8,0,18,0,8,0,146,0,8,0,82,0,8,0,210,0,8,0,50,0,8,0,178,0,8,0,114,0,8,0,242,0,8,0,10,0,8,0,138,0,8,0,74,0,8,0,202,0,8,0,42,0,8,0,170,0,8,0,106,0,8,0,234,0,8,0,26,0,8,0,154,0,8,0,90,0,8,0,218,0,8,0,58,0,8,0,186,0,8,0,122,0,8,0,250,0,8,0,6,0,8,0,134,0,8,0,70,0,8,0,198,0,8,0,38,0,8,0,166,0,8,0,102,0,8,0,230,0,8,0,22,0,8,0,150,0,8,0,86,0,8,0,214,0,8,0,54,0,8,0,182,0,8,0,118,0,8,0,246,0,8,0,14,0,8,0,142,0,8,0,78,0,8,0,206,0,8,0,46,0,8,0,174,0,8,0,110,0,8,0,238,0,8,0,30,0,8,0,158,0,8,0,94,0,8,0,222,0,8,0,62,0,8,0,190,0,8,0,126,0,8,0,254,0,8,0,1,0,8,0,129,0,8,0,65,0,8,0,193,0,8,0,33,0,8,0,161,0,8,0,97,0,8,0,225,0,8,0,17,0,8,0,145,0,8,0,81,0,8,0,209,0,8,0,49,0,8,0,177,0,8,0,113,0,8,0,241,0,8,0,9,0,8,0,137,0,8,0,73,0,8,0,201,0,8,0,41,0,8,0,169,0,8,0,105,0,8,0,233,0,8,0,25,0,8,0,153,0,8,0,89,0,8,0,217,0,8,0,57,0,8,0,185,0,8,0,121,0,8,0,249,0,8,0,5,0,8,0,133,0,8,0,69,0,8,0,197,0,8,0,37,0,8,0,165,0,8,0,101,0,8,0,229,0,8,0,21,0,8,0,149,0,8,0,85,0,8,0,213,0,8,0,53,0,8,0,181,0,8,0,117,0,8,0,245,0,8,0,13,0,8,0,141,0,8,0,77,0,8,0,205,0,8,0,45,0,8,0,173,0,8,0,109,0,8,0,237,0,8,0,29,0,8,0,157,0,8,0,93,0,8,0,221,0,8,0,61,0,8,0,189,0,8,0,125,0,8,0,253,0,8,0,19,0,9,0,19,1,9,0,147,0,9,0,147,1,9,0,83,0,9,0,83,1,9,0,211,0,9,0,211,1,9,0,51,0,9,0,51,1,9,0,179,0,9,0,179,1,9,0,115,0,9,0,115,1,9,0,243,0,9,0,243,1,9,0,11,0,9,0,11,1,9,0,139,0,9,0,139,1,9,0,75,0,9,0,75,1,9,0,203,0,9,0,203,1,9,0,43,0,9,0,43,1,9,0,171,0,9,0,171,1,9,0,107,0,9,0,107,1,9,0,235,0,9,0,235,1,9,0,27,0,9,0,27,1,9,0,155,0,9,0,155,1,9,0,91,0,9,0,91,1,9,0,219,0,9,0,219,1,9,0,59,0,9,0,59,1,9,0,187,0,9,0,187,1,9,0,123,0,9,0,123,1,9,0,251,0,9,0,251,1,9,0,7,0,9,0,7,1,9,0,135,0,9,0,135,1,9,0,71,0,9,0,71,1,9,0,199,0,9,0,199,1,9,0,39,0,9,0,39,1,9,0,167,0,9,0,167,1,9,0,103,0,9,0,103,1,9,0,231,0,9,0,231,1,9,0,23,0,9,0,23,1,9,0,151,0,9,0,151,1,9,0,87,0,9,0,87,1,9,0,215,0,9,0,215,1,9,0,55,0,9,0,55,1,9,0,183,0,9,0,183,1,9,0,119,0,9,0,119,1,9,0,247,0,9,0,247,1,9,0,15,0,9,0,15,1,9,0,143,0,9,0,143,1,9,0,79,0,9,0,79,1,9,0,207,0,9,0,207,1,9,0,47,0,9,0,47,1,9,0,175,0,9,0,175,1,9,0,111,0,9,0,111,1,9,0,239,0,9,0,239,1,9,0,31,0,9,0,31,1,9,0,159,0,9,0,159,1,9,0,95,0,9,0,95,1,9,0,223,0,9,0,223,1,9,0,63,0,9,0,63,1,9,0,191,0,9,0,191,1,9,0,127,0,9,0,127,1,9,0,255,0,9,0,255,1,9,0,0,0,7,0,64,0,7,0,32,0,7,0,96,0,7,0,16,0,7,0,80,0,7,0,48,0,7,0,112,0,7,0,8,0,7,0,72,0,7,0,40,0,7,0,104,0,7,0,24,0,7,0,88,0,7,0,56,0,7,0,120,0,7,0,4,0,7,0,68,0,7,0,36,0,7,0,100,0,7,0,20,0,7,0,84,0,7,0,52,0,7,0,116,0,7,0,3,0,8,0,131,0,8,0,67,0,8,0,195,0,8,0,35,0,8,0,163,0,8,0,99,0,8,0,227,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,117,115,104,0,73,110,116,86,101,99,116,111,114,0,70,108,111,97,116,86,101,99,116,111,114,0,68,111,117,98,108,101,86,101,99,116,111,114,0,80,111,105,110,116,86,101,99,116,111,114,0,77,97,116,86,101,99,116,111,114,0,82,101,99,116,86,101,99,116,111,114,0,75,101,121,80,111,105,110,116,86,101,99,116,111,114,0,101,121,101,0,111,110,101,115,0,122,101,114,111,115,0,114,111,119,115,0,99,111,108,115,0,109,97,116,83,105,122,101,0,115,116,101,112,0,100,97,116,97,56,83,0,100,97,116,97,49,54,85,0,100,97,116,97,49,54,83,0,100,97,116,97,51,50,83,0,100,97,116,97,51,50,70,0,100,97,116,97,54,52,70,0,101,108,101,109,83,105,122,101,0,101,108,101,109,83,105,122,101,49,0,99,104,97,110,110,101,108,115,0,114,111,119,0,114,111,119,82,97,110,103,101,0,99,111,108,82,97,110,103,101,0,115,116,101,112,49,0,99,111,108,0,109,117,108,0,105,110,118,0,114,111,105,0,117,99,104,97,114,80,116,114,0,99,104,97,114,80,116,114,0,115,104,111,114,116,80,116,114,0,117,115,104,111,114,116,80,116,114,0,105,110,116,80,116,114,0,102,108,111,97,116,80,116,114,0,100,111,117,98,108,101,80,116,114,0,99,104,97,114,65,116,0,117,99,104,97,114,65,116,0,115,104,111,114,116,65,116,0,117,115,104,111,114,116,65,116,0,105,110,116,65,116,0,102,108,111,97,116,65,116,0,100,111,117,98,108,101,65,116,0,82,97,110,103,101,0,84,101,114,109,67,114,105,116,101,114,105,97,0,109,97,120,67,111,117,110,116,0,35,116,121,112,101,0,121,0,82,101,99,116,0,82,101,99,116,50,102,0,82,111,116,97,116,101,100,82,101,99,116,0,99,101,110,116,101,114,0,97,110,103,108,101,0,114,111,116,97,116,101,100,82,101,99,116,80,111,105,110,116,115,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,50,102,0,75,101,121,80,111,105,110,116,0,99,108,97,115,115,95,105,100,0,111,99,116,97,118,101,0,112,116,0,114,101,115,112,111,110,115,101,0,83,99,97,108,97,114,0,77,105,110,77,97,120,76,111,99,0,109,105,110,86,97,108,0,109,97,120,86,97,108,0,109,105,110,76,111,99,0,109,97,120,76,111,99,0,67,105,114,99,108,101,0,114,97,100,105,117,115,0,77,111,109,101,110,116,115,0,109,48,48,0,109,49,48,0,109,48,49,0,109,50,48,0,109,49,49,0,109,48,50,0,109,51,48,0,109,50,49,0,109,49,50,0,109,48,51,0,109,117,50,48,0,109,117,49,49,0,109,117,48,50,0,109,117,51,48,0,109,117,50,49,0,109,117,49,50,0,109,117,48,51,0,110,117,50,48,0,110,117,49,49,0,110,117,48,50,0,110,117,51,48,0,110,117,50,49,0,110,117,49,50,0,110,117,48,51,0,69,120,99,101,112,116,105,111,110,0,99,111,100,101,0,109,115,103,0,101,120,99,101,112,116,105,111,110,70,114,111,109,80,116,114,0,109,111,114,112,104,111,108,111,103,121,68,101,102,97,117,108,116,66,111,114,100,101,114,86,97,108,117,101,0,67,86,95,77,65,84,95,68,69,80,84,72,0,67,97,109,83,104,105,102,116,0,103,101,116,66,117,105,108,100,73,110,102,111,114,109,97,116,105,111,110,0,67,86,95,56,85,67,49,0,67,86,95,56,85,67,50,0,67,86,95,56,85,67,51,0,67,86,95,56,85,67,52,0,67,86,95,56,83,67,49,0,67,86,95,56,83,67,50,0,67,86,95,56,83,67,51,0,67,86,95,56,83,67,52,0,67,86,95,49,54,85,67,49,0,67,86,95,49,54,85,67,50,0,67,86,95,49,54,85,67,51,0,67,86,95,49,54,85,67,52,0,67,86,95,49,54,83,67,49,0,67,86,95,49,54,83,67,50,0,67,86,95,49,54,83,67,51,0,67,86,95,49,54,83,67,52,0,67,86,95,51,50,83,67,50,0,67,86,95,51,50,83,67,51,0,67,86,95,51,50,83,67,52,0,67,86,95,51,50,70,67,50,0,67,86,95,51,50,70,67,51,0,67,86,95,51,50,70,67,52,0,67,86,95,54,52,70,67,49,0,67,86,95,54,52,70,67,50,0,67,86,95,54,52,70,67,51,0,67,86,95,54,52,70,67,52,0,73,78,84,95,77,73,78,0,73,78,84,95,77,65,88,0,67,97,110,110,121,49,0,71,97,117,115,115,105,97,110,66,108,117,114,0,72,111,117,103,104,76,105,110,101,115,0,72,111,117,103,104,76,105,110,101,115,80,0,76,97,112,108,97,99,105,97,110,0,83,99,104,97,114,114,0,83,111,98,101,108,0,97,98,115,100,105,102,102,0,97,100,100,87,101,105,103,104,116,101,100,0,98,105,116,119,105,115,101,95,97,110,100,0,98,105,116,119,105,115,101,95,110,111,116,0,98,105,116,119,105,115,101,95,111,114,0,98,105,116,119,105,115,101,95,120,111,114,0,98,108,117,114,0,98,111,117,110,100,105,110,103,82,101,99,116,0,98,111,120,70,105,108,116,101,114,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,70,97,114,110,101,98,97,99,107,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,80,121,114,76,75,0,99,111,114,110,101,114,72,97,114,114,105,115,0,99,111,114,110,101,114,77,105,110,69,105,103,101,110,86,97,108,0,100,105,108,97,116,101,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,87,105,116,104,76,97,98,101,108,115,0,100,105,118,105,100,101,0,100,105,118,105,100,101,49,0,101,108,108,105,112,115,101,49,0,101,108,108,105,112,115,101,50,80,111,108,121,0,101,114,111,100,101,0,102,105,108,116,101,114,50,68,0,103,101,116,79,112,116,105,109,97,108,68,70,84,83,105,122,101,0,103,101,116,82,111,116,97,116,105,111,110,77,97,116,114,105,120,50,68,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,49,0,105,110,116,101,103,114,97,108,50,0,109,105,110,0,109,105,110,65,114,101,97,82,101,99,116,0,109,117,108,116,105,112,108,121,0,110,111,114,109,49,0,112,117,116,84,101,120,116,0,114,97,110,100,110,0,114,97,110,100,117,0,114,101,99,116,97,110,103,108,101,49,0,115,101,116,82,78,71,83,101,101,100,0,115,113,114,116,0,115,117,98,116,114,97,99,116,0,98,108,111,98,70,114,111,109,73,109,97,103,101,0,114,101,97,100,78,101,116,49,0,114,101,97,100,78,101,116,70,114,111,109,67,97,102,102,101,0,114,101,97,100,78,101,116,70,114,111,109,67,97,102,102,101,49,0,114,101,97,100,78,101,116,70,114,111,109,68,97,114,107,110,101,116,49,0,114,101,97,100,78,101,116,70,114,111,109,79,78,78,88,0,114,101,97,100,78,101,116,70,114,111,109,84,101,110,115,111,114,102,108,111,119,0,114,101,97,100,78,101,116,70,114,111,109,84,101,110,115,111,114,102,108,111,119,49,0,114,101,97,100,78,101,116,70,114,111,109,84,111,114,99,104,0,72,79,71,68,101,115,99,114,105,112,116,111,114,0,108,111,97,100,0,103,101,116,68,101,102,97,117,108,116,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,103,101,116,68,97,105,109,108,101,114,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,115,118,109,68,101,116,101,99,116,111,114,0,100,110,110,95,78,101,116,0,102,111,114,119,97,114,100,49,0,102,111,114,119,97,114,100,50,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,0,75,65,90,69,0,115,101,116,69,120,116,101,110,100,101,100,0,115,101,116,78,79,99,116,97,118,101,76,97,121,101,114,115,0,103,101,116,78,79,99,116,97,118,101,115,0,103,101,116,78,79,99,116,97,118,101,76,97,121,101,114,115,0,115,101,116,78,79,99,116,97,118,101,115,0,103,101,116,85,112,114,105,103,104,116,0,103,101,116,69,120,116,101,110,100,101,100,0,115,101,116,85,112,114,105,103,104,116,0,115,101,116,68,105,102,102,117,115,105,118,105,116,121,0,103,101,116,84,104,114,101,115,104,111,108,100,0,103,101,116,68,101,102,97,117,108,116,78,97,109,101,0,103,101,116,68,105,102,102,117,115,105,118,105,116,121,0,115,101,116,84,104,114,101,115,104,111,108,100,0,80,116,114,60,75,65,90,69,62,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,0,80,116,114,60,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,62,0,67,76,65,72,69,0,115,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,99,111,108,108,101,99,116,71,97,114,98,97,103,101,0,115,101,116,67,108,105,112,76,105,109,105,116,0,103,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,103,101,116,67,108,105,112,76,105,109,105,116,0,80,116,114,60,67,76,65,72,69,62,0,66,70,77,97,116,99,104,101,114,0,80,116,114,60,66,70,77,97,116,99,104,101,114,62,0,65,108,103,111,114,105,116,104,109,0,100,101,116,101,99,116,49,0,99,111,109,112,117,116,101,49,0,100,101,102,97,117,108,116,78,111,114,109,0,100,101,115,99,114,105,112,116,111,114,83,105,122,101,0,100,101,115,99,114,105,112,116,111,114,84,121,112,101,0,71,70,84,84,68,101,116,101,99,116,111,114,0,103,101,116,66,108,111,99,107,83,105,122,101,0,103,101,116,75,0,115,101,116,72,97,114,114,105,115,68,101,116,101,99,116,111,114,0,115,101,116,66,108,111,99,107,83,105,122,101,0,115,101,116,81,117,97,108,105,116,121,76,101,118,101,108,0,115,101,116,77,97,120,70,101,97,116,117,114,101,115,0,115,101,116,75,0,103,101,116,77,97,120,70,101,97,116,117,114,101,115,0,115,101,116,77,105,110,68,105,115,116,97,110,99,101,0,103,101,116,77,105,110,68,105,115,116,97,110,99,101,0,103,101,116,81,117,97,108,105,116,121,76,101,118,101,108,0,103,101,116,72,97,114,114,105,115,68,101,116,101,99,116,111,114,0,80,116,114,60,71,70,84,84,68,101,116,101,99,116,111,114,62,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,0,114,97,100,105,117,115,77,97,116,99,104,49,0,107,110,110,77,97,116,99,104,49,0,109,97,116,99,104,0,109,97,116,99,104,49,0,105,115,77,97,115,107,83,117,112,112,111,114,116,101,100,0,80,116,114,60,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,62,0,77,83,69,82,0,103,101,116,80,97,115,115,50,79,110,108,121,0,115,101,116,77,105,110,65,114,101,97,0,103,101,116,68,101,108,116,97,0,103,101,116,77,97,120,65,114,101,97,0,115,101,116,77,97,120,65,114,101,97,0,115,101,116,80,97,115,115,50,79,110,108,121,0,103,101,116,77,105,110,65,114,101,97,0,115,101,116,68,101,108,116,97,0,80,116,114,60,77,83,69,82,62,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,103,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,103,101,116,84,121,112,101,0,115,101,116,78,111,110,109,97,120,83,117,112,112,114,101,115,115,105,111,110,0,115,101,116,84,121,112,101,0,80,116,114,60,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,62,0,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,50,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,51,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,80,116,114,60,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,62,0,65,75,65,90,69,0,115,101,116,68,101,115,99,114,105,112,116,111,114,84,121,112,101,0,103,101,116,68,101,115,99,114,105,112,116,111,114,84,121,112,101,0,115,101,116,68,101,115,99,114,105,112,116,111,114,67,104,97,110,110,101,108,115,0,103,101,116,68,101,115,99,114,105,112,116,111,114,67,104,97,110,110,101,108,115,0,115,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,80,116,114,60,65,75,65,90,69,62,0,79,82,66,0,115,101,116,69,100,103,101,84,104,114,101,115,104,111,108,100,0,103,101,116,70,97,115,116,84,104,114,101,115,104,111,108,100,0,115,101,116,78,76,101,118,101,108,115,0,115,101,116,80,97,116,99,104,83,105,122,101,0,115,101,116,87,84,65,95,75,0,115,101,116,83,99,97,108,101,70,97,99,116,111,114,0,115,101,116,83,99,111,114,101,84,121,112,101,0,80,116,114,60,79,82,66,62,0,66,82,73,83,75,0,80,116,114,60,66,82,73,83,75,62,0,65,67,67,69,83,83,95,70,65,83,84,0,65,67,67,69,83,83,95,77,65,83,75,0,65,67,67,69,83,83,95,82,69,65,68,0,65,67,67,69,83,83,95,82,87,0,65,67,67,69,83,83,95,87,82,73,84,69,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,71,65,85,83,83,73,65,78,95,67,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,77,69,65,78,95,67,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,75,65,90,69,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,75,65,90,69,95,85,80,82,73,71,72,84,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,77,76,68,66,0,65,75,65,90,69,95,68,69,83,67,82,73,80,84,79,82,95,77,76,68,66,95,85,80,82,73,71,72,84,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,53,95,56,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,55,95,49,50,100,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,65,71,65,83,84,95,55,95,49,50,115,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,78,79,78,77,65,88,95,83,85,80,80,82,69,83,83,73,79,78,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,79,65,83,84,95,57,95,49,54,0,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,72,82,69,83,72,79,76,68,0,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,66,79,82,68,69,82,95,73,83,79,76,65,84,69,68,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,49,48,49,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,95,49,48,49,0,66,79,82,68,69,82,95,82,69,80,76,73,67,65,84,69,0,66,79,82,68,69,82,95,84,82,65,78,83,80,65,82,69,78,84,0,66,79,82,68,69,82,95,87,82,65,80,0,67,65,83,67,65,68,69,95,68,79,95,67,65,78,78,89,95,80,82,85,78,73,78,71,0,67,65,83,67,65,68,69,95,68,79,95,82,79,85,71,72,95,83,69,65,82,67,72,0,67,65,83,67,65,68,69,95,70,73,78,68,95,66,73,71,71,69,83,84,95,79,66,74,69,67,84,0,67,65,83,67,65,68,69,95,83,67,65,76,69,95,73,77,65,71,69,0,67,67,76,95,68,69,70,65,85,76,84,0,67,67,76,95,71,82,65,78,65,0,67,67,76,95,87,85,0,67,67,95,83,84,65,84,95,65,82,69,65,0,67,67,95,83,84,65,84,95,72,69,73,71,72,84,0,67,67,95,83,84,65,84,95,76,69,70,84,0,67,67,95,83,84,65,84,95,77,65,88,0,67,67,95,83,84,65,84,95,84,79,80,0,67,67,95,83,84,65,84,95,87,73,68,84,72,0,67,72,65,73,78,95,65,80,80,82,79,88,95,78,79,78,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,83,73,77,80,76,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,75,67,79,83,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,76,49,0,67,77,80,95,69,81,0,67,77,80,95,71,69,0,67,77,80,95,71,84,0,67,77,80,95,76,69,0,67,77,80,95,76,84,0,67,77,80,95,78,69,0,67,79,76,79,82,77,65,80,95,65,85,84,85,77,78,0,67,79,76,79,82,77,65,80,95,66,79,78,69,0,67,79,76,79,82,77,65,80,95,67,79,79,76,0,67,79,76,79,82,77,65,80,95,72,79,84,0,67,79,76,79,82,77,65,80,95,72,83,86,0,67,79,76,79,82,77,65,80,95,74,69,84,0,67,79,76,79,82,77,65,80,95,79,67,69,65,78,0,67,79,76,79,82,77,65,80,95,80,65,82,85,76,65,0,67,79,76,79,82,77,65,80,95,80,73,78,75,0,67,79,76,79,82,77,65,80,95,82,65,73,78,66,79,87,0,67,79,76,79,82,77,65,80,95,83,80,82,73,78,71,0,67,79,76,79,82,77,65,80,95,83,85,77,77,69,82,0,67,79,76,79,82,77,65,80,95,87,73,78,84,69,82,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,50,72,76,83,0,67,79,76,79,82,95,66,71,82,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,72,83,86,0,67,79,76,79,82,95,66,71,82,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,76,97,98,0,67,79,76,79,82,95,66,71,82,50,76,117,118,0,67,79,76,79,82,95,66,71,82,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,50,88,89,90,0,67,79,76,79,82,95,66,71,82,50,89,67,114,67,98,0,67,79,76,79,82,95,66,71,82,50,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,53,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,65,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,67,79,76,79,82,67,86,84,95,77,65,88,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,53,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,54,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,65,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,65,0,67,79,76,79,82,95,72,76,83,50,66,71,82,0,67,79,76,79,82,95,72,76,83,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,76,83,50,82,71,66,0,67,79,76,79,82,95,72,76,83,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,66,71,82,0,67,79,76,79,82,95,72,83,86,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,82,71,66,0,67,79,76,79,82,95,72,83,86,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,76,66,71,82,50,76,97,98,0,67,79,76,79,82,95,76,66,71,82,50,76,117,118,0,67,79,76,79,82,95,76,82,71,66,50,76,97,98,0,67,79,76,79,82,95,76,82,71,66,50,76,117,118,0,67,79,76,79,82,95,76,97,98,50,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,82,71,66,0,67,79,76,79,82,95,76,97,98,50,82,71,66,0,67,79,76,79,82,95,76,117,118,50,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,82,71,66,0,67,79,76,79,82,95,76,117,118,50,82,71,66,0,67,79,76,79,82,95,82,71,66,50,66,71,82,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,50,72,76,83,0,67,79,76,79,82,95,82,71,66,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,72,83,86,0,67,79,76,79,82,95,82,71,66,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,76,97,98,0,67,79,76,79,82,95,82,71,66,50,76,117,118,0,67,79,76,79,82,95,82,71,66,50,82,71,66,65,0,67,79,76,79,82,95,82,71,66,50,88,89,90,0,67,79,76,79,82,95,82,71,66,50,89,67,114,67,98,0,67,79,76,79,82,95,82,71,66,50,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,65,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,65,50,82,71,66,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,109,82,71,66,65,0,67,79,76,79,82,95,88,89,90,50,66,71,82,0,67,79,76,79,82,95,88,89,90,50,82,71,66,0,67,79,76,79,82,95,89,67,114,67,98,50,66,71,82,0,67,79,76,79,82,95,89,67,114,67,98,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,66,71,82,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,65,0,67,79],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+194564);allocate([76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,65,0,67,79,76,79,82,95,109,82,71,66,65,50,82,71,66,65,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,49,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,50,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,51,0,67,79,86,65,82,95,67,79,76,83,0,67,79,86,65,82,95,78,79,82,77,65,76,0,67,79,86,65,82,95,82,79,87,83,0,67,79,86,65,82,95,83,67,65,76,69,0,67,79,86,65,82,95,83,67,82,65,77,66,76,69,68,0,67,79,86,65,82,95,85,83,69,95,65,86,71,0,68,67,84,95,73,78,86,69,82,83,69,0,68,67,84,95,82,79,87,83,0,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,68,69,67,79,77,80,95,69,73,71,0,68,69,67,79,77,80,95,76,85,0,68,69,67,79,77,80,95,78,79,82,77,65,76,0,68,69,67,79,77,80,95,81,82,0,68,69,67,79,77,80,95,83,86,68,0,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,0,68,70,84,95,67,79,77,80,76,69,88,95,79,85,84,80,85,84,0,68,70,84,95,73,78,86,69,82,83,69,0,68,70,84,95,82,69,65,76,95,79,85,84,80,85,84,0,68,70,84,95,82,79,87,83,0,68,70,84,95,83,67,65,76,69,0,68,73,83,79,112,116,105,99,97,108,70,108,111,119,95,80,82,69,83,69,84,95,70,65,83,84,0,68,73,83,79,112,116,105,99,97,108,70,108,111,119,95,80,82,69,83,69,84,95,77,69,68,73,85,77,0,68,73,83,79,112,116,105,99,97,108,70,108,111,119,95,80,82,69,83,69,84,95,85,76,84,82,65,70,65,83,84,0,68,73,83,84,95,67,0,68,73,83,84,95,70,65,73,82,0,68,73,83,84,95,72,85,66,69,82,0,68,73,83,84,95,76,49,0,68,73,83,84,95,76,49,50,0,68,73,83,84,95,76,50,0,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,0,68,73,83,84,95,77,65,83,75,95,51,0,68,73,83,84,95,77,65,83,75,95,53,0,68,73,83,84,95,77,65,83,75,95,80,82,69,67,73,83,69,0,68,73,83,84,95,85,83,69,82,0,68,73,83,84,95,87,69,76,83,67,72,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,72,65,77,77,73,78,71,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,72,65,77,77,73,78,71,76,85,84,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,76,49,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,66,82,85,84,69,70,79,82,67,69,95,83,76,50,0,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,95,70,76,65,78,78,66,65,83,69,68,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,69,70,65,85,76,84,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,82,65,87,95,79,86,69,82,95,79,85,84,73,77,71,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,68,82,65,87,95,82,73,67,72,95,75,69,89,80,79,73,78,84,83,0,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,95,78,79,84,95,68,82,65,87,95,83,73,78,71,76,69,95,80,79,73,78,84,83,0,70,73,76,76,69,68,0,70,73,76,84,69,82,95,83,67,72,65,82,82,0,70,76,79,79,68,70,73,76,76,95,70,73,88,69,68,95,82,65,78,71,69,0,70,76,79,79,68,70,73,76,76,95,77,65,83,75,95,79,78,76,89,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,95,83,77,65,76,76,0,70,79,78,84,95,72,69,82,83,72,69,89,95,68,85,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,80,76,65,73,78,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,84,82,73,80,76,69,88,0,70,79,78,84,95,73,84,65,76,73,67,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,70,65,83,84,95,78,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,78,79,78,77,65,88,95,83,85,80,80,82,69,83,83,73,79,78,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,72,82,69,83,72,79,76,68,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,53,95,56,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,55,95,49,50,0,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,84,89,80,69,95,57,95,49,54,0,70,105,108,101,78,111,100,101,95,69,77,80,84,89,0,70,105,108,101,78,111,100,101,95,70,76,79,65,84,0,70,105,108,101,78,111,100,101,95,70,76,79,87,0,70,105,108,101,78,111,100,101,95,73,78,84,0,70,105,108,101,78,111,100,101,95,77,65,80,0,70,105,108,101,78,111,100,101,95,78,65,77,69,68,0,70,105,108,101,78,111,100,101,95,78,79,78,69,0,70,105,108,101,78,111,100,101,95,82,69,65,76,0,70,105,108,101,78,111,100,101,95,83,69,81,0,70,105,108,101,78,111,100,101,95,83,84,82,0,70,105,108,101,78,111,100,101,95,83,84,82,73,78,71,0,70,105,108,101,78,111,100,101,95,84,89,80,69,95,77,65,83,75,0,70,105,108,101,78,111,100,101,95,85,78,73,70,79,82,77,0,70,105,108,101,83,116,111,114,97,103,101,95,65,80,80,69,78,68,0,70,105,108,101,83,116,111,114,97,103,101,95,66,65,83,69,54,52,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,65,85,84,79,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,74,83,79,78,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,77,65,83,75,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,88,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,89,65,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,73,78,83,73,68,69,95,77,65,80,0,70,105,108,101,83,116,111,114,97,103,101,95,77,69,77,79,82,89,0,70,105,108,101,83,116,111,114,97,103,101,95,78,65,77,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,82,69,65,68,0,70,105,108,101,83,116,111,114,97,103,101,95,85,78,68,69,70,73,78,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,86,65,76,85,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,95,66,65,83,69,54,52,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,83,86,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,68,69,70,65,85,76,84,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,77,65,84,76,65,66,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,78,85,77,80,89,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,80,89,84,72,79,78,0,71,67,95,66,71,68,0,71,67,95,69,86,65,76,0,71,67,95,69,86,65,76,95,70,82,69,69,90,69,95,77,79,68,69,76,0,71,67,95,70,71,68,0,71,67,95,73,78,73,84,95,87,73,84,72,95,77,65,83,75,0,71,67,95,73,78,73,84,95,87,73,84,72,95,82,69,67,84,0,71,67,95,80,82,95,66,71,68,0,71,67,95,80,82,95,70,71,68,0,71,69,77,77,95,49,95,84,0,71,69,77,77,95,50,95,84,0,71,69,77,77,95,51,95,84,0,72,73,83,84,67,77,80,95,66,72,65,84,84,65,67,72,65,82,89,89,65,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,95,65,76,84,0,72,73,83,84,67,77,80,95,67,79,82,82,69,76,0,72,73,83,84,67,77,80,95,72,69,76,76,73,78,71,69,82,0,72,73,83,84,67,77,80,95,73,78,84,69,82,83,69,67,84,0,72,73,83,84,67,77,80,95,75,76,95,68,73,86,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,68,69,70,65,85,76,84,95,78,76,69,86,69,76,83,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,68,69,83,67,82,95,70,79,82,77,65,84,95,67,79,76,95,66,89,95,67,79,76,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,68,69,83,67,82,95,70,79,82,77,65,84,95,82,79,87,95,66,89,95,82,79,87,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,76,50,72,121,115,0,72,79,85,71,72,95,71,82,65,68,73,69,78,84,0,72,79,85,71,72,95,77,85,76,84,73,95,83,67,65,76,69,0,72,79,85,71,72,95,80,82,79,66,65,66,73,76,73,83,84,73,67,0,72,79,85,71,72,95,83,84,65,78,68,65,82,68,0,73,78,84,69,82,83,69,67,84,95,70,85,76,76,0,73,78,84,69,82,83,69,67,84,95,78,79,78,69,0,73,78,84,69,82,83,69,67,84,95,80,65,82,84,73,65,76,0,73,78,84,69,82,95,65,82,69,65,0,73,78,84,69,82,95,66,73,84,83,0,73,78,84,69,82,95,66,73,84,83,50,0,73,78,84,69,82,95,67,85,66,73,67,0,73,78,84,69,82,95,76,65,78,67,90,79,83,52,0,73,78,84,69,82,95,76,73,78,69,65,82,0,73,78,84,69,82,95,76,73,78,69,65,82,95,69,88,65,67,84,0,73,78,84,69,82,95,77,65,88,0,73,78,84,69,82,95,78,69,65,82,69,83,84,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,50,0,75,65,90,69,95,68,73,70,70,95,67,72,65,82,66,79,78,78,73,69,82,0,75,65,90,69,95,68,73,70,70,95,80,77,95,71,49,0,75,65,90,69,95,68,73,70,70,95,80,77,95,71,50,0,75,65,90,69,95,68,73,70,70,95,87,69,73,67,75,69,82,84,0,75,77,69,65,78,83,95,80,80,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,82,65,78,68,79,77,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,85,83,69,95,73,78,73,84,73,65,76,95,76,65,66,69,76,83,0,76,73,78,69,95,52,0,76,73,78,69,95,56,0,76,73,78,69,95,65,65,0,76,83,68,95,82,69,70,73,78,69,95,65,68,86,0,76,83,68,95,82,69,70,73,78,69,95,78,79,78,69,0,76,83,68,95,82,69,70,73,78,69,95,83,84,68,0,77,65,82,75,69,82,95,67,82,79,83,83,0,77,65,82,75,69,82,95,68,73,65,77,79,78,68,0,77,65,82,75,69,82,95,83,81,85,65,82,69,0,77,65,82,75,69,82,95,83,84,65,82,0,77,65,82,75,69,82,95,84,73,76,84,69,68,95,67,82,79,83,83,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,68,79,87,78,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,85,80,0,77,79,82,80,72,95,66,76,65,67,75,72,65,84,0,77,79,82,80,72,95,67,76,79,83,69,0,77,79,82,80,72,95,67,82,79,83,83,0,77,79,82,80,72,95,68,73,76,65,84,69,0,77,79,82,80,72,95,69,76,76,73,80,83,69,0,77,79,82,80,72,95,69,82,79,68,69,0,77,79,82,80,72,95,71,82,65,68,73,69,78,84,0,77,79,82,80,72,95,72,73,84,77,73,83,83,0,77,79,82,80,72,95,79,80,69,78,0,77,79,82,80,72,95,82,69,67,84,0,77,79,82,80,72,95,84,79,80,72,65,84,0,77,79,84,73,79,78,95,65,70,70,73,78,69,0,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,0,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,77,97,116,95,65,85,84,79,95,83,84,69,80,0,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,86,65,76,0,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,77,97,116,95,84,89,80,69,95,77,65,83,75,0,78,79,82,77,95,72,65,77,77,73,78,71,0,78,79,82,77,95,72,65,77,77,73,78,71,50,0,78,79,82,77,95,73,78,70,0,78,79,82,77,95,76,49,0,78,79,82,77,95,76,50,0,78,79,82,77,95,76,50,83,81,82,0,78,79,82,77,95,77,73,78,77,65,88,0,78,79,82,77,95,82,69,76,65,84,73,86,69,0,78,79,82,77,95,84,89,80,69,95,77,65,83,75,0,79,80,84,70,76,79,87,95,70,65,82,78,69,66,65,67,75,95,71,65,85,83,83,73,65,78,0,79,80,84,70,76,79,87,95,76,75,95,71,69,84,95,77,73,78,95,69,73,71,69,78,86,65,76,83,0,79,80,84,70,76,79,87,95,85,83,69,95,73,78,73,84,73,65,76,95,70,76,79,87,0,79,82,66,95,70,65,83,84,95,83,67,79,82,69,0,79,82,66,95,72,65,82,82,73,83,95,83,67,79,82,69,0,80,67,65,95,68,65,84,65,95,65,83,95,67,79,76,0,80,67,65,95,68,65,84,65,95,65,83,95,82,79,87,0,80,67,65,95,85,83,69,95,65,86,71,0,80,97,114,97,109,95,65,76,71,79,82,73,84,72,77,0,80,97,114,97,109,95,66,79,79,76,69,65,78,0,80,97,114,97,109,95,70,76,79,65,84,0,80,97,114,97,109,95,73,78,84,0,80,97,114,97,109,95,77,65,84,0,80,97,114,97,109,95,77,65,84,95,86,69,67,84,79,82,0,80,97,114,97,109,95,82,69,65,76,0,80,97,114,97,109,95,83,67,65,76,65,82,0,80,97,114,97,109,95,83,84,82,73,78,71,0,80,97,114,97,109,95,85,67,72,65,82,0,80,97,114,97,109,95,85,73,78,84,54,52,0,80,97,114,97,109,95,85,78,83,73,71,78,69,68,95,73,78,84,0,82,69,68,85,67,69,95,65,86,71,0,82,69,68,85,67,69,95,77,65,88,0,82,69,68,85,67,69,95,77,73,78,0,82,69,68,85,67,69,95,83,85,77,0,82,69,84,82,95,67,67,79,77,80,0,82,69,84,82,95,69,88,84,69,82,78,65,76,0,82,69,84,82,95,70,76,79,79,68,70,73,76,76,0,82,69,84,82,95,76,73,83,84,0,82,69,84,82,95,84,82,69,69,0,82,78,71,95,78,79,82,77,65,76,0,82,78,71,95,85,78,73,70,79,82,77,0,82,79,84,65,84,69,95,49,56,48,0,82,79,84,65,84,69,95,57,48,95,67,76,79,67,75,87,73,83,69,0,82,79,84,65,84,69,95,57,48,95,67,79,85,78,84,69,82,67,76,79,67,75,87,73,83,69,0,83,79,76,86,69,76,80,95,77,85,76,84,73,0,83,79,76,86,69,76,80,95,83,73,78,71,76,69,0,83,79,76,86,69,76,80,95,85,78,66,79,85,78,68,69,68,0,83,79,76,86,69,76,80,95,85,78,70,69,65,83,73,66,76,69,0,83,79,82,84,95,65,83,67,69,78,68,73,78,71,0,83,79,82,84,95,68,69,83,67,69,78,68,73,78,71,0,83,79,82,84,95,69,86,69,82,89,95,67,79,76,85,77,78,0,83,79,82,84,95,69,86,69,82,89,95,82,79,87,0,83,86,68,95,70,85,76,76,95,85,86,0,83,86,68,95,77,79,68,73,70,89,95,65,0,83,86,68,95,78,79,95,85,86,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,66,73,84,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,83,67,65,76,69,0,83,112,97,114,115,101,77,97,116,95,77,65,71,73,67,95,86,65,76,0,83,112,97,114,115,101,77,97,116,95,77,65,88,95,68,73,77,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,69,82,82,79,82,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,73,78,83,73,68,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,78,95,69,68,71,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,85,84,83,73,68,69,95,82,69,67,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,86,69,82,84,69,88,0,84,72,82,69,83,72,95,66,73,78,65,82,89,0,84,72,82,69,83,72,95,66,73,78,65,82,89,95,73,78,86,0,84,72,82,69,83,72,95,77,65,83,75,0,84,72,82,69,83,72,95,79,84,83,85,0,84,72,82,69,83,72,95,84,79,90,69,82,79,0,84,72,82,69,83,72,95,84,79,90,69,82,79,95,73,78,86,0,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,0,84,72,82,69,83,72,95,84,82,85,78,67,0,84,77,95,67,67,79,69,70,70,0,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,84,77,95,67,67,79,82,82,0,84,77,95,67,67,79,82,82,95,78,79,82,77,69,68,0,84,77,95,83,81,68,73,70,70,0,84,77,95,83,81,68,73,70,70,95,78,79,82,77,69,68,0,84,101,114,109,67,114,105,116,101,114,105,97,95,67,79,85,78,84,0,84,101,114,109,67,114,105,116,101,114,105,97,95,69,80,83,0,84,101,114,109,67,114,105,116,101,114,105,97,95,77,65,88,95,73,84,69,82,0,85,77,97,116,68,97,116,97,95,65,83,89,78,67,95,67,76,69,65,78,85,80,0,85,77,97,116,68,97,116,97,95,67,79,80,89,95,79,78,95,77,65,80,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,77,69,77,95,77,65,80,80,69,68,0,85,77,97,116,68,97,116,97,95,72,79,83,84,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,67,79,80,73,69,68,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,85,83,69,82,95,65,76,76,79,67,65,84,69,68,0,85,77,97,116,95,65,85,84,79,95,83,84,69,80,0,85,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,85,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,86,65,76,0,85,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,85,77,97,116,95,84,89,80,69,95,77,65,83,75,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,68,69,86,73,67,69,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,72,79,83,84,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,83,72,65,82,69,68,95,77,69,77,79,82,89,0,85,83,65,71,69,95,68,69,70,65,85,76,84,0,87,65,82,80,95,70,73,76,76,95,79,85,84,76,73,69,82,83,0,87,65,82,80,95,73,78,86,69,82,83,69,95,77,65,80,0,87,65,82,80,95,80,79,76,65,82,95,76,73,78,69,65,82,0,87,65,82,80,95,80,79,76,65,82,95,76,79,71,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,72,79,83,84,95,77,69,77,0,95,73,110,112,117,116,65,114,114,97,121,95,69,88,80,82,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,83,73,90,69,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,84,89,80,69,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,77,65,83,75,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,83,72,73,70,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,88,0,95,73,110,112,117,116,65,114,114,97,121,95,78,79,78,69,0,95,73,110,112,117,116,65,114,114,97,121,95,79,80,69,78,71,76,95,66,85,70,70,69,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,66,79,79,76,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,85,77,65,84,0,95,95,85,77,65,84,95,85,83,65,71,69,95,70,76,65,71,83,95,51,50,66,73,84,0,66,97,100,65,108,105,103,110,0,66,97,100,65,108,112,104,97,67,104,97,110,110,101,108,0,66,97,100,67,79,73,0,66,97,100,67,97,108,108,66,97,99,107,0,66,97,100,68,97,116,97,80,116,114,0,66,97,100,68,101,112,116,104,0,66,97,100,73,109,97,103,101,83,105,122,101,0,66,97,100,77,111,100,101,108,79,114,67,104,83,101,113,0,66,97,100,78,117,109,67,104,97,110,110,101,108,49,85,0,66,97,100,78,117,109,67,104,97,110,110,101,108,115,0,66,97,100,79,102,102,115,101,116,0,66,97,100,79,114,100,101,114,0,66,97,100,79,114,105,103,105,110,0,66,97,100,82,79,73,83,105,122,101,0,66,97,100,83,116,101,112,0,66,97,100,84,105,108,101,83,105,122,101,0,71,112,117,65,112,105,67,97,108,108,69,114,114,111,114,0,71,112,117,78,111,116,83,117,112,112,111,114,116,101,100,0,72,101,97,100,101,114,73,115,78,117,108,108,0,77,97,115,107,73,115,84,105,108,101,100,0,79,112,101,110,67,76,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,67,76,68,111,117,98,108,101,78,111,116,83,117,112,112,111,114,116,101,100,0,79,112,101,110,67,76,73,110,105,116,69,114,114,111,114,0,79,112,101,110,67,76,78,111,65,77,68,66,108,97,115,70,102,116,0,79,112,101,110,71,108,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,71,108,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,65,115,115,101,114,116,0,83,116,115,65,117,116,111,84,114,97,99,101,0,83,116,115,66,97,99,107,84,114,97,99,101,0,83,116,115,66,97,100,65,114,103,0,83,116,115,66,97,100,70,108,97,103,0,83,116,115,66,97,100,70,117,110,99,0,83,116,115,66,97,100,77,97,115,107,0,83,116,115,66,97,100,77,101,109,66,108,111,99,107,0,83,116,115,66,97,100,80,111,105,110,116,0,83,116,115,66,97,100,83,105,122,101,0,83,116,115,68,105,118,66,121,90,101,114,111,0,83,116,115,69,114,114,111,114,0,83,116,115,70,105,108,116,101,114,79,102,102,115,101,116,69,114,114,0,83,116,115,70,105,108,116,101,114,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,73,110,112,108,97,99,101,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,73,110,116,101,114,110,97,108,0,83,116,115,75,101,114,110,101,108,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,78,111,67,111,110,118,0,83,116,115,78,111,77,101,109,0,83,116,115,78,111,116,73,109,112,108,101,109,101,110,116,101,100,0,83,116,115,78,117,108,108,80,116,114,0,83,116,115,79,98,106,101,99,116,78,111,116,70,111,117,110,100,0,83,116,115,79,107,0,83,116,115,79,117,116,79,102,82,97,110,103,101,0,83,116,115,80,97,114,115,101,69,114,114,111,114,0,83,116,115,85,110,109,97,116,99,104,101,100,70,111,114,109,97,116,115,0,83,116,115,85,110,109,97,116,99,104,101,100,83,105,122,101,115,0,83,116,115,85,110,115,117,112,112,111,114,116,101,100,70,111,114,109,97,116,0,83,116,115,86,101,99,76,101,110,103,116,104,69,114,114,0,84,69,83,84,95,67,85,83,84,79,77,0,84,69,83,84,95,69,81,0,84,69,83,84,95,71,69,0,84,69,83,84,95,71,84,0,84,69,83,84,95,76,69,0,84,69,83,84,95,76,84,0,84,69,83,84,95,78,69,0,68,78,78,95,66,65,67,75,69,78,68,95,68,69,70,65,85,76,84,0,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,0,68,78,78,95,66,65,67,75,69,78,68,95,73,78,70,69,82,69,78,67,69,95,69,78,71,73,78,69,0,68,78,78,95,66,65,67,75,69,78,68,95,79,80,69,78,67,86,0,68,78,78,95,66,65,67,75,69,78,68,95,86,75,67,79,77,0,68,78,78,95,84,65,82,71,69,84,95,67,80,85,0,68,78,78,95,84,65,82,71,69,84,95,77,89,82,73,65,68,0,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,0,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,95,70,80,49,54,0,68,78,78,95,84,65,82,71,69,84,95,86,85,76,75,65,78,0,70,76,65,71,83,95,69,88,80,65,78,68,95,83,65,77,69,95,78,65,77,69,83,0,70,76,65,71,83,95,77,65,80,80,73,78,71,0,70,76,65,71,83,95,78,79,78,69,0,73,77,80,76,95,73,80,80,0,73,77,80,76,95,79,80,69,78,67,76,0,73,77,80,76,95,80,76,65,73,78,0,84,89,80,69,95,70,85,78,0,84,89,80,69,95,71,69,78,69,82,65,76,0,84,89,80,69,95,77,65,82,75,69,82,0,84,89,80,69,95,87,82,65,80,80,69,82,0,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,0,78,50,99,118,49,49,82,111,116,97,116,101,100,82,101,99,116,69,0,78,50,99,118,53,82,101,99,116,95,73,105,69,69,0,112,117,115,104,95,98,97,99,107,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,118,101,99,116,111,114,95,98,97,115,101,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,105,105,0,118,0,118,105,0,118,105,105,105,0,118,105,105,105,105,0,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,0,105,105,105,105,0,105,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,118,105,105,102,0,118,105,105,105,102,0,105,105,105,105,102,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,118,105,105,100,0,118,105,105,105,100,0,105,105,105,105,100,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,51,77,97,116,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,56,75,101,121,80,111,105,110,116,69,0,80,78,50,99,118,51,77,97,116,69,0,80,75,78,50,99,118,51,77,97,116,69,0,78,50,99,118,53,83,105,122,101,95,73,105,69,69,0,78,50,99,118,55,83,99,97,108,97,114,95,73,100,69,69,0,78,50,99,118,51,86,101,99,73,100,76,105,52,69,69,69,0,78,50,99,118,52,77,97,116,120,73,100,76,105,52,69,76,105,49,69,69,69,0,105,105,105,105,105,105,0,105,105,105,105,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,104,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,99,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,116,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,115,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,105,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,102,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,100,69,69,0,118,105,105,105,105,100,100,0,118,105,105,105,105,100,0,118,105,105,105,105,105,0,78,50,99,118,53,82,97,110,103,101,69,0,100,105,105,105,0,102,105,105,105,0,102,105,105,105,105,0,102,105,105,105,105,105,0,100,105,105,105,105,105,0,100,105,105,105,105,0,105,0,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,69,0,100,105,105,0,78,50,99,118,53,83,105,122,101,95,73,102,69,69,0,102,105,105,0,78,50,99,118,53,82,101,99,116,95,73,102,69,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,57,77,105,110,77,97,120,76,111,99,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,54,67,105,114,99,108,101,69,0,78,50,99,118,55,77,111,109,101,110,116,115,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,50,49,95,95,98,97,115,105,99,95,115,116,114,105,110,103,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,108,101,110,103,116,104,0,78,50,99,118,54,68,77,97,116,99,104,69,0,118,105,105,105,100,100,105,105,0,118,105,105,105,100,100,105,0,118,105,105,105,100,100,0,118,105,105,105,105,100,100,105,0,118,105,105,105,105,100,100,100,100,105,105,0,118,105,105,105,105,100,100,100,100,105,0,118,105,105,105,105,100,100,100,100,0,118,105,105,105,105,100,100,100,0,118,105,105,105,100,100,105,100,100,100,100,0,118,105,105,105,100,100,105,100,100,100,0,118,105,105,105,100,100,105,100,100,0,118,105,105,105,100,100,105,100,0,118,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,100,100,0,118,105,105,105,105,105,100,0,118,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,0,118,105,105,105,100,105,105,105,100,0,118,105,105,100,105,100,100,105,105,0,118,105,105,100,105,100,100,105,0,118,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,0,118,105,105,105,105,100,105,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,0,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,100,105,0,118,105,105,105,105,100,105,0,118,105,100,105,105,105,0,118,105,100,105,105,0,78,50,99,118,49,54,68,114,97,119,77,97,116,99,104,101,115,70,108,97,103,115,69,0,118,105,105,105,105,100,100,100,105,105,105,105,0,118,105,105,105,105,100,100,100,105,105,105,0,118,105,105,105,105,100,100,100,105,105,0,118,105,105,105,105,100,100,100,105,0,118,105,105,105,105,105,105,100,105,0,100,105,105,105,105,105,105,105,0,100,105,105,105,105,105,105,0,118,105,105,105,100,105,100,105,105,0,118,105,105,105,100,105,100,105,0,105,105,105,100,100,0,118,105,105,105,105,100,100,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,0,118,105,105,105,105,100,100,105,105,0,118,105,105,105,105,100,100,105,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,105,0,100,105,105,105,105,105,105,105,105,0,100,105,105,105,105,100,0,118,105,105,105,100,100,105,105,105,0,118,105,105,100,105,0,118,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,0,118,105,105,105,105,105,105,105,100,105,0,118,105,105,0,100,105,105,105,100,100,105,0,105,105,105,100,105,105,105,105,105,0,105,105,105,100,105,105,105,105,0,105,105,105,100,105,105,105,0,105,105,105,100,105,105,0,105,105,105,100,105,0,105,105,105,100,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,78,101,116,69,0,80,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,80,75,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,49,55,72,105,115,116,111,103,114,97,109,78,111,114,109,84,121,112,101,69,0,105,105,105,105,105,105,105,105,100,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,100,100,105,0,118,105,105,105,105,105,100,105,105,100,100,0,118,105,105,105,105,105,100,105,105,100,0,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,78,101,116,69,0,80,75,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,78,101,116,69,0,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,75,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,78,50,99,118,52,75,65,90,69,69,0,80,75,78,50,99,118,52,75,65,90,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,52,75,65,90,69,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,52,75,65,90,69,69,69,69,0,78,50,99,118,52,75,65,90,69,49,53,68,105,102,102,117,115,105,118,105,116,121,84,121,112,101,69,0,105,105,105,105,102,105,105,105,0,105,105,105,105,102,105,105,0,105,105,105],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+204804);allocate([105,102,105,0,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,75,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,69,69,0,78,50,99,118,53,67,76,65,72,69,69,0,80,78,50,99,118,53,67,76,65,72,69,69,0,80,75,78,50,99,118,53,67,76,65,72,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,67,76,65,72,69,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,53,67,76,65,72,69,69,69,69,0,105,105,100,105,0,105,105,100,0,80,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,80,75,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,57,66,70,77,97,116,99,104,101,114,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,69,69,0,80,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,75,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,80,75,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,56,75,101,121,80,111,105,110,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,80,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,69,69,0,105,105,105,100,100,105,105,100,0,105,105,105,100,100,105,105,0,105,105,105,100,100,105,0,105,105,105,100,100,105,105,105,100,0,80,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,80,75,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,78,83,51,95,73,83,53,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,118,105,105,105,105,105,102,105,105,0,118,105,105,105,105,105,102,105,0,118,105,105,105,105,105,102,0,118,105,105,105,105,102,105,105,0,118,105,105,105,105,102,105,0,118,105,105,105,105,102,0,78,50,99,118,51,80,116,114,73,78,83,95,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,68,77,97,116,99,104,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,50,99,118,52,77,83,69,82,69,0,80,75,78,50,99,118,52,77,83,69,82,69,0,78,50,99,118,51,80,116,114,73,78,83,95,52,77,83,69,82,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,52,77,83,69,82,69,69,69,0,105,105,105,105,105,100,100,105,100,100,105,0,105,105,105,105,105,100,100,105,100,100,0,105,105,105,105,105,100,100,105,100,0,105,105,105,105,105,100,100,105,0,105,105,105,105,105,100,100,0,105,105,105,105,105,100,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,48,95,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,78,83,52,95,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,80,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,49,50,68,101,116,101,99,116,111,114,84,121,112,101,69,0,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,75,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,105,105,105,105,105,105,100,105,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,105,100,105,105,0,118,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,100,105,105,105,0,118,105,105,105,105,100,105,105,0,80,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,80,75,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,51,80,116,114,73,78,83,95,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,69,69,0,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,49,50,68,101,116,101,99,116,111,114,84,121,112,101,69,0,80,78,50,99,118,53,65,75,65,90,69,69,0,80,75,78,50,99,118,53,65,75,65,90,69,69,0,78,50,99,118,53,65,75,65,90,69,49,52,68,101,115,99,114,105,112,116,111,114,84,121,112,101,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,65,75,65,90,69,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,53,65,75,65,90,69,69,69,69,0,105,105,105,105,105,102,105,105,105,0,105,105,105,105,105,102,105,105,0,105,105,105,105,105,102,105,0,105,105,105,105,105,102,0,80,78,50,99,118,51,79,82,66,69,0,80,75,78,50,99,118,51,79,82,66,69,0,78,50,99,118,51,80,116,114,73,78,83,95,51,79,82,66,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,51,79,82,66,69,69,69,0,78,50,99,118,51,79,82,66,57,83,99,111,114,101,84,121,112,101,69,0,105,105,105,102,105,105,105,105,105,105,105,0,105,105,105,102,105,105,105,105,105,105,0,105,105,105,102,105,105,105,105,105,0,105,105,105,102,105,105,105,105,0,105,105,105,102,105,105,105,0,105,105,105,102,105,105,0,105,105,105,102,105,0,105,105,105,102,0,80,78,50,99,118,53,66,82,73,83,75,69,0,80,75,78,50,99,118,53,66,82,73,83,75,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,66,82,73,83,75,69,69,69,0,78,83,116,51,95,95,50,49,48,115,104,97,114,101,100,95,112,116,114,73,78,50,99,118,53,66,82,73,83,75,69,69,69,0,105,105,105,105,102,102,105,0,105,105,105,105,102,102,0,105,105,105,105,105,105,102,102,105,0,105,105,105,105,105,105,102,102,0,109,101,97,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,101,97,110,46,99,112,112,0,109,101,97,110,83,116,100,68,101,118,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,100,115,116,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,115,116,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,100,99,110,32,62,61,32,99,110,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,37,108,108,117,32,98,121,116,101,115,0,79,117,116,79,102,77,101,109,111,114,121,69,114,114,111,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,108,108,111,99,46,99,112,112,0,95,97,114,114,97,121,115,32,38,38,32,40,95,112,116,114,115,32,124,124,32,95,112,108,97,110,101,115,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,105,116,101,114,97,116,111,114,46,99,112,112,0,110,97,114,114,97,121,115,32,60,61,32,49,48,48,48,0,97,114,114,97,121,115,91,105,93,32,33,61,32,48,0,65,46,115,105,122,101,32,61,61,32,97,114,114,97,121,115,91,105,48,93,45,62,115,105,122,101,0,65,46,115,116,101,112,91,100,45,49,93,32,61,61,32,65,46,101,108,101,109,83,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,32,38,38,32,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,0,109,97,103,110,105,116,117,100,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,46,99,112,112,0,88,46,115,105,122,101,32,61,61,32,89,46,115,105,122,101,32,38,38,32,116,121,112,101,32,61,61,32,89,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,0,99,97,114,116,84,111,80,111,108,97,114,0,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,40,115,114,99,49,46,101,109,112,116,121,40,41,32,124,124,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,41,0,112,111,108,97,114,84,111,67,97,114,116,0,77,97,103,46,101,109,112,116,121,40,41,32,124,124,32,65,110,103,108,101,46,115,105,122,101,32,61,61,32,77,97,103,46,115,105,122,101,0,101,120,112,0,108,111,103,0,112,116,32,61,61,32,78,85,76,76,0,99,104,101,99,107,82,97,110,103,101,0,116,104,101,32,118,97,108,117,101,32,97,116,32,40,37,100,44,32,37,100,41,61,37,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,102,44,32,37,102,41,0,95,97,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,112,97,116,99,104,78,97,78,115,0,99,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,99,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,115,111,108,118,101,67,117,98,105,99,0,40,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,43,49,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,43,49,41,41,0,67,86,95,77,65,84,95,68,69,80,84,72,40,99,116,121,112,101,41,32,62,61,32,67,86,95,51,50,70,32,38,38,32,67,86,95,77,65,84,95,67,78,40,99,116,121,112,101,41,32,60,61,32,50,0,115,111,108,118,101,80,111,108,121,0,99,111,101,102,102,115,48,46,114,111,119,115,32,61,61,32,49,32,124,124,32,99,111,101,102,102,115,48,46,99,111,108,115,32,61,61,32,49,0,100,101,116,101,114,109,105,110,97,110,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,108,97,112,97,99,107,46,99,112,112,0,109,97,116,46,114,111,119,115,32,61,61,32,109,97,116,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,105,110,118,101,114,116,0,109,32,61,61,32,110,0,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,76,85,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,101,105,103,101,110,0,119,46,116,121,112,101,40,41,32,61,61,32,117,46,116,121,112,101,40,41,32,38,38,32,117,46,116,121,112,101,40,41,32,61,61,32,118,116,46,116,121,112,101,40,41,32,38,38,32,117,46,100,97,116,97,32,38,38,32,118,116,46,100,97,116,97,32,38,38,32,119,46,100,97,116,97,0,98,97,99,107,83,117,98,115,116,0,117,46,99,111,108,115,32,62,61,32,110,109,32,38,38,32,118,116,46,114,111,119,115,32,62,61,32,110,109,32,38,38,32,40,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,109,44,32,49,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,109,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,118,116,46,114,111,119,115,44,32,117,46,99,111,108,115,41,41,0,114,104,115,46,100,97,116,97,32,61,61,32,48,32,124,124,32,40,114,104,115,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,114,104,115,46,114,111,119,115,32,61,61,32,109,41,0,95,83,86,68,99,111,109,112,117,116,101,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,41,0,115,111,108,118,101,0,40,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,76,85,32,38,38,32,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,41,32,124,124,32,105,115,95,110,111,114,109,97,108,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,84,104,101,32,102,117,110,99,116,105,111,110,32,99,97,110,32,110,111,116,32,115,111,108,118,101,32,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,98,111,111,108,32,99,118,58,58,115,111,108,118,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,85,110,115,117,112,112,111,114,116,101,100,32,109,101,116,104,111,100,44,32,115,101,101,32,35,68,101,99,111,109,112,84,121,112,101,115,0,109,101,116,104,111,100,0,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,76,85,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,83,86,68,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,69,73,71,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,81,82,0,78,50,99,118,57,69,120,99,101,112,116,105,111,110,69,0,107,101,121,95,32,61,61,32,45,49,0,126,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,121,115,116,101,109,46,99,112,112,0,115,116,97,116,117,115,0,85,110,107,110,111,119,110,32,37,115,32,99,111,100,101,32,37,100,0,79,112,101,110,71,76,32,65,80,73,32,99,97,108,108,0,78,111,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,71,112,117,32,65,80,73,32,99,97,108,108,0,78,111,32,67,85,68,65,32,115,117,112,112,111,114,116,0,65,115,115,101,114,116,105,111,110,32,102,97,105,108,101,100,0,77,101,109,111,114,121,32,98,108,111,99,107,32,104,97,115,32,98,101,101,110,32,99,111,114,114,117,112,116,101,100,0,84,104,101,32,102,117,110,99,116,105,111,110,47,102,101,97,116,117,114,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,80,97,114,115,105,110,103,32,101,114,114,111,114,0,66,97,100,32,116,121,112,101,32,111,102,32,109,97,115,107,32,97,114,103,117,109,101,110,116,0,66,97,100,32,112,97,114,97,109,101,116,101,114,32,111,102,32,116,121,112,101,32,67,118,80,111,105,110,116,0,66,97,100,32,102,108,97,103,32,40,112,97,114,97,109,101,116,101,114,32,111,114,32,115,116,114,117,99,116,117,114,101,32,102,105,101,108,100,41,0,66,97,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,73,110,112,117,116,32,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,32,111,114,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,102,111,114,109,97,116,115,0,79,110,101,32,111,102,32,97,114,103,117,109,101,110,116,115,39,32,118,97,108,117,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,83,105,122,101,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,70,111,114,109,97,116,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,73,110,112,117,116,32,105,109,97,103,101,32,100,101,112,116,104,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,102,117,110,99,116,105,111,110,0,82,101,113,117,101,115,116,101,100,32,111,98,106,101,99,116,32,119,97,115,32,110,111,116,32,102,111,117,110,100,0,73,110,112,108,97,99,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,109,97,103,101,32,115,116,101,112,32,105,115,32,119,114,111,110,103,0,68,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,111,99,99,117,114,114,101,100,0,78,117,108,108,32,112,111,105,110,116,101,114,0,73,110,99,111,114,114,101,99,116,32,115,105,122,101,32,111,102,32,105,110,112,117,116,32,97,114,114,97,121,0,65,117,116,111,116,114,97,99,101,32,99,97,108,108,0,73,116,101,114,97,116,105,111,110,115,32,100,111,32,110,111,116,32,99,111,110,118,101,114,103,101,0,66,97,100,32,97,114,103,117,109,101,110,116,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,85,110,115,112,101,99,105,102,105,101,100,32,101,114,114,111,114,0,66,97,99,107,116,114,97,99,101,0,78,111,32,69,114,114,111,114,0,117,110,107,110,111,119,110,32,102,117,110,99,116,105,111,110,0,79,112,101,110,67,86,40,37,115,41,32,69,114,114,111,114,58,32,37,115,32,40,37,115,41,32,105,110,32,37,115,44,32,102,105,108,101,32,37,115,44,32,108,105,110,101,32,37,100,0,52,46,48,46,48,0,37,115,10,0,62,32,0,79,112,101,110,67,86,40,37,115,41,32,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,58,37,115,41,32,105,110,32,102,117,110,99,116,105,111,110,32,39,37,115,39,10,37,115,0,79,112,101,110,67,86,40,37,115,41,32,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,58,37,115,41,32,37,115,32,105,110,32,102,117,110,99,116,105,111,110,32,39,37,115,39,10,0,79,112,101,110,67,86,40,37,115,41,32,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,58,37,115,41,32,37,115,37,115,0,108,101,110,32,62,61,32,48,32,38,38,32,34,67,104,101,99,107,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,102,111,114,32,101,114,114,111,114,115,34,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,56,98,97,115,105,99,95,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,50,99,118,49,54,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,69,0,79,80,69,78,67,86,95,68,85,77,80,95,69,82,82,79,82,83,0,79,80,69,78,67,86,95,68,85,77,80,95,67,79,78,70,73,71,0,10,71,101,110,101,114,97,108,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,102,111,114,32,79,112,101,110,67,86,32,52,46,48,46,48,32,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,32,32,86,101,114,115,105,111,110,32,99,111,110,116,114,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,52,46,48,46,48,10,10,32,32,80,108,97,116,102,111,114,109,58,10,32,32,32,32,84,105,109,101,115,116,97,109,112,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,50,48,49,56,45,49,49,45,49,56,84,49,49,58,53,49,58,51,55,90,10,32,32,32,32,72,111,115,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,76,105,110,117,120,32,52,46,49,53,46,48,45,51,56,45,103,101,110,101,114,105,99,32,120,56,54,95,54,52,10,32,32,32,32,84,97,114,103,101,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,69,109,115,99,114,105,112,116,101,110,32,49,32,120,56,54,10,32,32,32,32,67,77,97,107,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,51,46,53,46,49,10,32,32,32,32,67,77,97,107,101,32,103,101,110,101,114,97,116,111,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,85,110,105,120,32,77,97,107,101,102,105,108,101,115,10,32,32,32,32,67,77,97,107,101,32,98,117,105,108,100,32,116,111,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,109,97,107,101,10,32,32,32,32,67,111,110,102,105,103,117,114,97,116,105,111,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,82,101,108,101,97,115,101,10,10,32,32,67,80,85,47,72,87,32,102,101,97,116,117,114,101,115,58,10,32,32,32,32,66,97,115,101,108,105,110,101,58,10,10,32,32,67,47,67,43,43,58,10,32,32,32,32,66,117,105,108,116,32,97,115,32,100,121,110,97,109,105,99,32,108,105,98,115,63,58,32,32,32,32,32,32,78,79,10,32,32,32,32,67,43,43,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,111,112,116,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,49,46,51,55,46,50,49,47,101,109,43,43,32,32,40,118,101,114,32,52,46,48,46,48,41,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,105,110,99,111,110,115,105,115,116,101,110,116,45,109,105,115,115,105,110,103,45,111,118,101,114,114,105,100,101,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,105,110,99,111,110,115,105,115,116,101,110,116,45,109,105,115,115,105,110,103,45,111,118,101,114,114,105,100,101,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,67,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,111,112,116,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,49,46,51,55,46,50,49,47,101,109,99,99,10,32,32,32,32,67,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,105,110,99,111,110,115,105,115,116,101,110,116,45,109,105,115,115,105,110,103,45,111,118,101,114,114,105,100,101,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,105,110,99,111,110,115,105,115,116,101,110,116,45,109,105,115,115,105,110,103,45,111,118,101,114,114,105,100,101,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,45,79,50,32,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,10,32,32,32,32,99,99,97,99,104,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,114,101,99,111,109,112,105,108,101,100,32,104,101,97,100,101,114,115,58,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,69,120,116,114,97,32,100,101,112,101,110,100,101,110,99,105,101,115,58,10,32,32,32,32,51,114,100,112,97,114,116,121,32,100,101,112,101,110,100,101,110,99,105,101,115,58,32,32,32,32,32,32,32,122,108,105,98,32,108,105,98,112,114,111,116,111,98,117,102,32,113,117,105,114,99,10,10,32,32,79,112,101,110,67,86,32,109,111,100,117,108,101,115,58,10,32,32,32,32,84,111,32,98,101,32,98,117,105,108,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,97,108,105,98,51,100,32,99,111,114,101,32,100,110,110,32,102,101,97,116,117,114,101,115,50,100,32,102,108,97,110,110,32,105,109,103,112,114,111,99,32,106,97,118,97,95,98,105,110,100,105,110,103,115,95,103,101,110,101,114,97,116,111,114,32,106,115,32,111,98,106,100,101,116,101,99,116,32,112,121,116,104,111,110,95,98,105,110,100,105,110,103,115,95,103,101,110,101,114,97,116,111,114,32,118,105,100,101,111,10,32,32,32,32,68,105,115,97,98,108,101,100,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,103,97,112,105,32,104,105,103,104,103,117,105,32,105,109,103,99,111,100,101,99,115,32,109,108,32,112,104,111,116,111,32,115,116,105,116,99,104,105,110,103,32,118,105,100,101,111,105,111,32,119,111,114,108,100,10,32,32,32,32,68,105,115,97,98,108,101,100,32,98,121,32,100,101,112,101,110,100,101,110,99,121,58,32,32,32,32,32,32,45,10,32,32,32,32,85,110,97,118,97,105,108,97,98,108,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,106,97,118,97,32,112,121,116,104,111,110,50,32,112,121,116,104,111,110,51,32,116,115,10,32,32,32,32,65,112,112,108,105,99,97,116,105,111,110,115,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,45,10,32,32,32,32,68,111,99,117,109,101,110,116,97,116,105,111,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,106,115,10,32,32,32,32,78,111,110,45,102,114,101,101,32,97,108,103,111,114,105,116,104,109,115,58,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,71,85,73,58,32,10,10,32,32,77,101,100,105,97,32,73,47,79,58,32,10,32,32,32,32,90,76,105,98,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,98,117,105,108,100,32,40,118,101,114,32,49,46,50,46,49,49,41,10,32,32,32,32,72,68,82,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,32,32,32,32,83,85,78,82,65,83,84,69,82,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,32,32,32,32,80,88,77,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,32,32,32,32,80,70,77,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,89,69,83,10,10,32,32,86,105,100,101,111,32,73,47,79,58,10,10,32,32,80,97,114,97,108,108,101,108,32,102,114,97,109,101,119,111,114,107,58,32,32,32,32,32,32,32,32,32,32,32,32,110,111,110,101,10,10,32,32,79,116,104,101,114,32,116,104,105,114,100,45,112,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+215044);allocate([114,116,121,32,108,105,98,114,97,114,105,101,115,58,10,32,32,32,32,67,117,115,116,111,109,32,72,65,76,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,114,111,116,111,98,117,102,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,98,117,105,108,100,32,40,51,46,53,46,49,41,10,10,32,32,80,121,116,104,111,110,32,40,102,111,114,32,98,117,105,108,100,41,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,112,121,116,104,111,110,50,46,55,10,10,32,32,73,110,115,116,97,108,108,32,116,111,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,98,117,105,108,100,47,106,115,47,105,110,115,116,97,108,108,10,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,10,0,10,79,112,101,110,67,86,32,98,117,105,108,100,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,105,115,58,10,37,115,10,0,77,77,88,0,83,83,69,0,83,83,69,50,0,83,83,69,51,0,83,83,83,69,51,0,83,83,69,52,46,49,0,83,83,69,52,46,50,0,80,79,80,67,78,84,0,70,80,49,54,0,65,86,88,0,65,86,88,50,0,70,77,65,51,0,65,86,88,53,49,50,70,0,65,86,88,53,49,50,66,87,0,65,86,88,53,49,50,67,68,0,65,86,88,53,49,50,68,81,0,65,86,88,53,49,50,69,82,0,65,86,88,53,49,50,73,70,77,65,0,65,86,88,53,49,50,80,70,0,65,86,88,53,49,50,86,66,77,73,0,65,86,88,53,49,50,86,76,0,78,69,79,78,0,86,83,88,0,65,86,88,53,49,50,45,83,75,88,0,79,80,69,78,67,86,95,67,80,85,95,68,73,83,65,66,76,69,0,102,101,97,116,117,114,101,46,115,105,122,101,40,41,32,62,32,48,0,114,101,97,100,83,101,116,116,105,110,103,115,0,85,110,107,110,111,119,110,32,102,101,97,116,117,114,101,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,98,97,115,101,108,105,110,101,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,32,84,104,105,115,32,104,97,115,32,118,101,114,121,32,108,105,109,105,116,101,100,32,101,102,102,101,99,116,44,32,98,101,99,97,117,115,101,32,99,111,100,101,32,111,112,116,105,109,105,122,97,116,105,111,110,115,32,102,111,114,32,116,104,105,115,32,102,101,97,116,117,114,101,32,97,114,101,32,101,120,101,99,117,116,101,100,32,117,110,99,111,110,100,105,116,105,111,110,97,108,108,121,32,105,110,32,116,104,101,32,109,111,115,116,32,99,97,115,101,115,46,10,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,97,118,97,105,108,97,98,108,101,32,67,80,85,32,102,101,97,116,117,114,101,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,58,32,39,37,115,39,46,10,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,107,110,111,119,110,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,10,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,112,97,114,97,109,101,116,101,114,32,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,50,99,118,49,48,80,97,114,115,101,69,114,114,111,114,69,0,49,0,84,82,85,69,0,70,65,76,83,69,0,107,101,121,95,32,33,61,32,45,49,32,38,38,32,34,67,97,110,39,116,32,102,101,116,99,104,32,100,97,116,97,32,102,114,111,109,32,116,101,114,109,105,110,97,116,101,100,32,84,76,83,32,99,111,110,116,97,105,110,101,114,46,34,0,103,101,116,68,97,116,97,0,116,108,115,83,108,111,116,115,83,105,122,101,32,62,32,115,108,111,116,73,100,120,0,115,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,115,101,116,115,112,101,99,105,102,105,99,40,116,108,115,75,101,121,44,32,112,68,97,116,97,41,32,61,61,32,48,0,83,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,107,101,121,95,99,114,101,97,116,101,40,38,116,108,115,75,101,121,44,32,78,85,76,76,41,32,61,61,32,48,0,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,112,116,104,114,101,97,100,95,107,101,121,95,100,101,108,101,116,101,40,116,108,115,75,101,121,41,32,61,61,32,48,0,126,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,116,108,115,83,108,111,116,115,83,105,122,101,32,61,61,32,116,108,115,83,108,111,116,115,46,115,105,122,101,40,41,0,114,101,108,101,97,115,101,83,108,111,116,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,49,67,111,114,101,84,76,83,68,97,116,97,69,69,69,0,114,101,115,101,114,118,101,83,108,111,116,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,56,84,104,114,101,97,100,73,68,69,69,69,0,77,66,0,77,98,0,109,98,0,75,66,0,75,98,0,107,98,0,109,118,32,38,38,32,110,32,62,32,48,0,109,101,114,103,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,101,114,103,101,46,99,112,112,0,109,118,91,105,93,46,115,105,122,101,32,61,61,32,109,118,91,48,93,46,115,105,122,101,32,38,38,32,109,118,91,105,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,48,32,60,32,99,110,32,38,38,32,99,110,32,60,61,32,67,86,95,67,78,95,77,65,88,0,0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,1,1,1,1,2,2,2,1,2,2,2,1,2,2,2,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,110,111,114,109,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,110,111,114,109,46,99,112,112,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,115,114,99,50,41,32,38,38,32,95,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,0,99,111,117,110,116,78,111,110,90,101,114,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,117,110,116,95,110,111,110,95,122,101,114,111,46,99,112,112,0,109,121,95,111,98,106,101,99,116,0,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,102,111,114,109,97,116,0,40,99,110,32,61,61,32,49,32,38,38,32,40,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,41,41,32,124,124,32,40,99,110,32,62,32,49,32,38,38,32,95,109,97,115,107,46,101,109,112,116,121,40,41,32,38,38,32,33,109,105,110,73,100,120,32,38,38,32,33,109,97,120,73,100,120,41,0,109,105,110,77,97,120,73,100,120,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,105,110,109,97,120,46,99,112,112,0,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,105,110,77,97,120,76,111,99,0,79,80,69,78,67,86,95,75,77,69,65,78,83,95,80,65,82,65,76,76,69,76,95,71,82,65,78,85,76,65,82,73,84,89,0,100,97,116,97,48,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,38,38,32,75,32,62,32,48,0,107,109,101,97,110,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,107,109,101,97,110,115,46,99,112,112,0,78,32,62,61,32,75,0,40,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,32,61,61,32,49,32,124,124,32,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,42,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,78,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,40,117,110,115,105,103,110,101,100,41,95,108,97,98,101,108,115,46,97,116,60,105,110,116,62,40,105,41,32,60,32,40,117,110,115,105,103,110,101,100,41,75,0,99,111,117,110,116,101,114,115,91,107,93,32,33,61,32,48,0,78,50,99,118,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,73,76,98,48,69,69,69,0,78,50,99,118,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,73,76,98,49,69,69,69,0,78,50,99,118,50,52,75,77,101,97,110,115,80,80,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,109,97,112,99,111,117,110,116,32,61,61,32,48,0,126,85,77,97,116,68,97,116,97,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,117,109,97,116,114,105,120,46,99,112,112,0,117,115,97,103,101,95,99,111,117,110,116,32,61,61,32,48,0,108,111,99,107,0,112,116,114,0,103,101,116,82,101,102,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,117,116,105,108,105,116,121,46,104,112,112,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,56,85,77,97,116,68,97,116,97,65,117,116,111,76,111,99,107,101,114,69,69,69,0,117,115,97,103,101,95,99,111,117,110,116,32,61,61,32,49,0,100,97,116,97,32,61,61,32,100,97,116,97,115,116,97,114,116,0,97,108,108,111,99,97,116,101,100,0,85,77,97,116,0,100,115,116,46,117,0,117,45,62,100,97,116,97,32,33,61,32,48,32,38,38,32,34,69,114,114,111,114,32,109,97,112,112,105,110,103,32,111,102,32,85,77,97,116,32,116,111,32,104,111,115,116,32,109,101,109,111,114,121,46,34,0,103,101,116,77,97,116,0,78,50,99,118,50,48,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,99,104,97,110,110,101,108,115,40,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,116,121,112,101,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,112,121,46,99,112,112,0,100,115,116,46,117,32,33,61,32,78,85,76,76,0,100,105,109,115,32,62,32,48,32,38,38,32,100,105,109,115,32,60,32,67,86,95,77,65,88,95,68,73,77,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,115,122,46,119,105,100,116,104,0,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,0,115,105,122,101,40,41,32,61,61,32,109,97,115,107,46,115,105,122,101,40,41,0,115,122,32,60,61,32,115,105,122,101,111,102,40,115,99,97,108,97,114,41,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,95,118,97,108,117,101,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,77,65,84,32,41,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,32,38,38,32,115,105,122,101,32,61,61,32,109,97,115,107,46,115,105,122,101,41,0,102,108,105,112,0,95,115,114,99,46,103,101,116,79,98,106,40,41,32,33,61,32,95,100,115,116,46,103,101,116,79,98,106,40,41,0,114,101,112,101,97,116,0,110,121,32,62,32,48,32,38,38,32,110,120,32,62,32,48,0,108,101,110,32,62,32,48,0,98,111,114,100,101,114,73,110,116,101,114,112,111,108,97,116,101,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,98,111,114,100,101,114,32,116,121,112,101,0,116,111,112,32,62,61,32,48,32,38,38,32,98,111,116,116,111,109,32,62,61,32,48,32,38,38,32,108,101,102,116,32,62,61,32,48,32,38,38,32,114,105,103,104,116,32,62,61,32,48,32,38,38,32,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,0,99,111,112,121,77,97,107,101,66,111,114,100,101,114,0,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,49,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,50,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,51,93,0,33,95,109,97,116,46,101,109,112,116,121,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,114,97,110,100,46,99,112,112,0,95,112,97,114,97,109,49,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,49,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,99,110,32,60,61,32,52,41,41,0,95,112,97,114,97,109,50,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,40,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,38,38,32,99,110,32,60,61,32,52,41,41,41,32,124,124,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,99,110,32,38,38,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,99,110,32,38,38,32,100,105,115,116,116,121,112,101,32,61,61,32,78,79,82,77,65,76,41,41,0,115,99,97,108,101,70,117,110,99,32,33,61,32,48,0,85,110,107,110,111,119,110,32,100,105,115,116,114,105,98,117,116,105,111,110,32,116,121,112,101,0,100,115,116,46,101,108,101,109,83,105,122,101,40,41,32,60,61,32,51,50,0,114,97,110,100,83,104,117,102,102,108,101,0,95,97,114,114,46,100,105,109,115,32,60,61,32,50,0,114,97,110,100,83,104,117,102,102,108,101,95,0,105,32,60,32,48,0,103,101,116,77,97,116,95,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,119,114,97,112,46,99,112,112,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,109,97,112,72,111,115,116,47,117,110,109,97,112,72,111,115,116,32,109,101,116,104,111,100,115,32,102,111,114,32,111,103,108,58,58,66,117,102,102,101,114,32,111,98,106,101,99,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,100,111,119,110,108,111,97,100,32,109,101,116,104,111,100,32,102,111,114,32,99,117,100,97,58,58,71,112,117,77,97,116,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,40,102,108,97,103,115,32,38,32,70,73,88,69,68,95,84,89,80,69,41,32,33,61,32,48,0,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,105,32,60,32,115,122,46,104,101,105,103,104,116,0,103,101,116,85,77,97,116,0,103,101,116,77,97,116,86,101,99,116,111,114,0,100,105,109,115,0,101,109,112,116,121,0,105,32,62,61,32,48,32,38,38,32,40,115,105,122,101,95,116,41,105,32,60,32,118,118,46,115,105,122,101,40,41,0,105,115,67,111,110,116,105,110,117,111,117,115,0,105,32,62,32,48,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,99,111,112,121,84,111,0,33,102,105,120,101,100,83,105,122,101,40,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,84,121,112,101,40,41,32,38,38,32,33,102,105,120,101,100,83,105,122,101,40,41,0,67,86,95,77,65,84,95,84,89,80,69,40,109,116,121,112,101,41,32,61,61,32,109,46,116,121,112,101,40,41,0,109,46,100,105,109,115,32,61,61,32,100,0,109,46,115,105,122,101,91,106,93,32,61,61,32,115,105,122,101,115,91,106,93,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,67,86,95,77,65,84,95,67,78,40,109,116,121,112,101,41,32,61,61,32,49,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,100,32,61,61,32,50,32,38,38,32,40,40,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,104,101,105,103,104,116,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,119,105,100,116,104,41,32,124,124,32,40,97,108,108,111,119,84,114,97,110,115,112,111,115,101,100,32,38,38,32,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,119,105,100,116,104,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,104,101,105,103,104,116,41,41,0,100,32,61,61,32,50,32,38,38,32,115,122,46,97,114,101,97,40,41,32,61,61,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,0,100,32,61,61,32,50,32,38,38,32,40,115,105,122,101,115,91,48,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,49,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,32,61,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,118,118,46,115,105,122,101,40,41,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,67,86,95,77,65,84,95,67,78,40,109,116,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,116,121,112,101,48,41,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,40,40,115,116,100,58,58,118,101,99,116,111,114,60,117,99,104,97,114,62,42,41,118,41,45,62,115,105,122,101,40,41,32,47,32,101,115,122,0,86,101,99,116,111,114,115,32,119,105,116,104,32,101,108,101,109,101,110,116,32,115,105,122,101,32,37,100,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,32,80,108,101,97,115,101,44,32,109,111,100,105,102,121,32,79,117,116,112,117,116,65,114,114,97,121,58,58,99,114,101,97,116,101,40,41,10,0,99,114,101,97,116,101,40,41,32,99,97,108,108,101,100,32,102,111,114,32,116,104,101,32,109,105,115,115,105,110,103,32,111,117,116,112,117,116,32,97,114,114,97,121,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,108,101,110,48,0,118,91,106,93,46,101,109,112,116,121,40,41,0,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,108,101,110,32,61,61,32,108,101,110,48,0,103,101,116,77,97,116,82,101,102,0,107,32,61,61,32,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,107,32,61,61,32,83,84,68,95,65,82,82,65,89,95,77,65,84,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,99,108,101,97,114,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,97,114,114,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,67,85,68,65,95,71,80,85,95,77,65,84,41,0,115,101,116,84,111,0,116,104,105,115,95,118,46,115,105,122,101,40,41,32,61,61,32,118,46,115,105,122,101,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,99,46,99,112,112,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,99,118,97,114,114,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,73,80,76,95,68,65,84,65,95,79,82,68,69,82,95,80,73,88,69,76,0,105,112,108,73,109,97,103,101,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,73,80,76,95,68,65,84,65,95,79,82,68,69,82,95,80,73,88,69,76,32,124,124,32,105,109,103,45,62,114,111,105,45,62,99,111,105,32,33,61,32,48,0,116,111,116,97,108,32,62,32,48,32,38,38,32,67,86,95,69,76,69,77,95,83,73,90,69,40,115,101,113,45,62,102,108,97,103,115,41,32,61,61,32,101,115,122,0,85,110,107,110,111,119,110,32,97,114,114,97,121,32,116,121,112,101,0,105,99,118,73,110,105,116,77,101,109,83,116,111,114,97,103,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,97,116,97,115,116,114,117,99,116,115,46,99,112,112,0,99,118,67,114,101,97,116,101,67,104,105,108,100,77,101,109,83,116,111,114,97,103,101,0,99,118,82,101,108,101,97,115,101,77,101,109,83,116,111,114,97,103,101,0,99,118,67,108,101,97,114,77,101,109,83,116,111,114,97,103,101,0,99,118,83,97,118,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,82,101,115,116,111,114,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,77,101,109,83,116,111,114,97,103,101,65,108,108,111,99,0,84,111,111,32,108,97,114,103,101,32,109,101,109,111,114,121,32,98,108,111,99,107,32,105,115,32,114,101,113,117,101,115,116,101,100,0,114,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,110,101,103,97,116,105,118,101,32,111,114,32,116,111,111,32,98,105,103,0,105,99,118,71,111,78,101,120,116,77,101,109,66,108,111,99,107,0,99,118,67,114,101,97,116,101,83,101,113,0,83,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,101,116,83,101,113,66,108,111,99,107,83,105,122,101,0,83,116,111,114,97,103,101,32,98,108,111,99,107,32,115,105,122,101,32,105,115,32,116,111,111,32,115,109,97,108,108,32,116,111,32,102,105,116,32,116,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,0,99,118,67,118,116,83,101,113,84,111,65,114,114,97,121,0,99,118,83,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,116,97,114,116,82,101,97,100,83,101,113,0,99,118,77,97,107,101,83,101,113,72,101,97,100,101,114,70,111,114,65,114,114,97,121,0,69,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,112,114,101,100,101,102,105,110,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,116,97,114,116,65,112,112,101,110,100,84,111,83,101,113,0,99,118,83,116,97,114,116,87,114,105,116,101,83,101,113,0,99,118,70,108,117,115,104,83,101,113,87,114,105,116,101,114,0,99,118,69,110,100,87,114,105,116,101,83,101,113,0,99,118,67,114,101,97,116,101,83,101,113,66,108,111,99,107,0,105,99,118,71,114,111,119,83,101,113,0,84,104,101,32,115,101,113,117,101,110,99,101,32,104,97,115,32,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,99,118,67,104,97,110,103,101,83,101,113,66,108,111,99,107,0,99,118,83,101,113,80,117,115,104,0,99,118,67,114,101,97,116,101,83,101,116,0,99,118,83,101,116,65,100,100,0,99,118,84,114,101,101,84,111,78,111,100,101,83,101,113,0,99,118,73,110,105,116,84,114,101,101,78,111,100,101,73,116,101,114,97,116,111,114,0,78,85,76,76,32,105,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,0,99,118,78,101,120,116,84,114,101,101,78,111,100,101,0,99,118,73,110,115,101,114,116,78,111,100,101,73,110,116,111,84,114,101,101,0,99,111,110,118,101,114,116,83,99,97,108,101,65,98,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,110,118,101,114,116,95,115,99,97,108,101,46,99,112,112,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,110,111,114,109,32,116,121,112,101,0,110,111,114,109,97,108,105,122,101,0,99,110,32,60,61,32,52,32,38,38,32,102,117,110,99,32,33,61,32,48,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,117,109,46,99,112,112,0,60,105,110,118,97,108,105,100,32,100,101,112,116,104,62,0,67,86,95,56,85,0,67,86,95,56,83,0,67,86,95,49,54,85,0,67,86,95,49,54,83,0,67,86,95,51,50,83,0,67,86,95,51,50,70,0,67,86,95,54,52,70,0,67,86,95,49,54,70,0,37,115,67,37,100,0,60,105,110,118,97,108,105,100,32,116,121,112,101,62,0,32,40,101,120,112,101,99,116,101,100,58,32,39,0,63,63,63,0,39,41,44,32,119,104,101,114,101,0,32,32,32,32,39,0,39,32,105,115,32,0,109,117,115,116,32,98,101,32,0,123,99,117,115,116,111,109,32,99,104,101,99,107,125,0,101,113,117,97,108,32,116,111,0,110,111,116,32,101,113,117,97,108,32,116,111,0,108,101,115,115,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,0,108,101,115,115,32,116,104,97,110,0,103,114,101,97,116,101,114,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,0,103,114,101,97,116,101,114,32,116,104,97,110,0,39,0,119,104,101,114,101,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,114,111,119,115,32,61,61,32,115,114,99,91,48,93,46,114,111,119,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,104,99,111,110,99,97,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,111,112,101,114,97,116,105,111,110,115,46,99,112,112,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,99,111,108,115,32,61,61,32,115,114,99,91,48,93,46,99,111,108,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,118,99,111,110,99,97,116,0,95,109,46,100,105,109,115,40,41,32,60,61,32,50,0,115,101,116,73,100,101,110,116,105,116,121,0,116,114,97,99,101,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,32,38,38,32,101,115,122,32,60,61,32,51,50,0,116,114,97,110,115,112,111,115,101,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,40,115,114,99,46,99,111,108,115,32,61,61,32,49,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,49,41,0,109,46,100,105,109,115,32,60,61,32,50,32,38,38,32,109,46,114,111,119,115,32,61,61,32,109,46,99,111,108,115,0,99,111,109,112,108,101,116,101,83,121,109,109,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,0,114,101,100,117,99,101,0,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,83,85,77,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,77,65,88,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,77,73,78,32,124,124,32,111,112,32,61,61,32,67,86,95,82,69,68,85,67,69,95,65,86,71,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,97,114,114,97,121,32,102,111,114,109,97,116,115,0,115,114,99,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,115,111,114,116,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+225284);allocate([32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,111,103,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,112,101,110,103,108,46,99,112,112,0,99,111,110,118,101,114,116,84,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,110,118,101,114,116,46,99,112,112,0,100,100,101,112,116,104,32,61,61,32,67,86,95,49,54,83,32,124,124,32,100,100,101,112,116,104,32,61,61,32,67,86,95,49,54,70,0,99,111,110,118,101,114,116,70,112,49,54,0,95,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,0,85,110,115,117,112,112,111,114,116,101,100,32,105,110,112,117,116,32,100,101,112,116,104,0,33,95,109,118,46,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,95,109,118,46,101,109,112,116,121,40,41,32,124,124,32,95,109,118,46,116,121,112,101,40,41,32,61,61,32,109,46,100,101,112,116,104,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,112,108,105,116,46,99,112,112,0,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,50,0,103,101,109,109,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,109,117,108,46,99,112,112,0,116,121,112,101,32,61,61,32,66,46,116,121,112,101,40,41,0,103,101,109,109,0,40,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,41,0,97,95,115,105,122,101,46,119,105,100,116,104,32,61,61,32,108,101,110,0,97,95,115,105,122,101,46,104,101,105,103,104,116,32,61,61,32,108,101,110,0,67,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,40,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,61,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,41,32,124,124,32,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,33,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,41,41,0,115,99,110,32,61,61,32,109,46,99,111,108,115,32,124,124,32,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,116,114,97,110,115,102,111,114,109,0,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,112,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,115,99,97,108,101,65,100,100,0,115,114,99,49,46,115,105,122,101,32,61,61,32,115,114,99,50,46,115,105,122,101,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,117,108,84,114,97,110,115,112,111,115,101,100,0,100,101,108,116,97,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,40,100,101,108,116,97,46,114,111,119,115,32,61,61,32,115,114,99,46,114,111,119,115,32,124,124,32,100,101,108,116,97,46,114,111,119,115,32,61,61,32,49,41,0,40,100,101,108,116,97,46,99,111,108,115,32,61,61,32,115,114,99,46,99,111,108,115,32,124,124,32,100,101,108,116,97,46,99,111,108,115,32,61,61,32,49,41,0,109,97,116,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,40,41,0,100,111,116,0,109,97,116,46,115,105,122,101,32,61,61,32,115,105,122,101,0,78,50,99,118,49,49,77,97,116,79,112,95,83,111,108,118,101,69,0,67,86,95,77,65,84,95,67,78,40,95,116,121,112,101,41,32,61,61,32,101,46,97,46,99,104,97,110,110,101,108,115,40,41,0,97,115,115,105,103,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,101,120,112,114,101,115,115,105,111,110,115,46,99,112,112,0,78,50,99,118,49,52,77,97,116,79,112,95,73,100,101,110,116,105,116,121,69,0,78,50,99,118,49,50,77,97,116,79,112,95,73,110,118,101,114,116,69,0,78,50,99,118,49,48,77,97,116,79,112,95,71,69,77,77,69,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,0,78,50,99,118,57,77,97,116,79,112,95,66,105,110,69,0,78,50,99,118,49,49,77,97,116,79,112,95,65,100,100,69,120,69,0,78,50,99,118,55,77,97,116,79,112,95,84,69,0,78,50,99,118,53,77,97,116,79,112,69,0,78,50,99,118,57,77,97,116,79,112,95,67,109,112,69,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,105,110,105,116,105,97,108,105,122,101,114,32,116,121,112,101,0,78,50,99,118,49,55,77,97,116,79,112,95,73,110,105,116,105,97,108,105,122,101,114,69,0,78,50,99,118,50,53,68,117,109,109,121,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,115,122,91,105,93,32,60,61,32,40,115,105,122,101,95,116,41,73,78,84,95,77,65,88,0,99,111,112,121,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,46,99,112,112,0,117,45,62,117,114,101,102,99,111,117,110,116,32,61,61,32,48,0,100,101,97,108,108,111,99,97,116,101,0,117,45,62,114,101,102,99,111,117,110,116,32,61,61,32,48,0,116,111,116,97,108,32,60,61,32,115,116,101,112,91,105,93,0,97,108,108,111,99,97,116,101,0,78,50,99,118,49,53,83,116,100,77,97,116,65,108,108,111,99,97,116,111,114,69,0,48,32,60,61,32,95,100,105,109,115,32,38,38,32,95,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,0,115,101,116,83,105,122,101,0,115,32,62,61,32,48,0,83,116,101,112,32,109,117,115,116,32,98,101,32,97,32,109,117,108,116,105,112,108,101,32,111,102,32,101,115,122,49,0,84,104,101,32,116,111,116,97,108,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,116,111,32,34,115,105,122,101,95,116,34,32,116,121,112,101,0,117,112,108,111,97,100,0,100,111,119,110,108,111,97,100,0,78,50,99,118,49,50,77,97,116,65,108,108,111,99,97,116,111,114,69,0,48,32,60,61,32,100,32,38,38,32,100,32,60,61,32,67,86,95,77,65,88,95,68,73,77,32,38,38,32,95,115,105,122,101,115,0,117,32,33,61,32,48,0,115,116,101,112,91,100,105,109,115,45,49,93,32,61,61,32,40,115,105,122,101,95,116,41,67,86,95,69,76,69,77,95,83,73,90,69,40,102,108,97,103,115,41,0,109,46,100,105,109,115,32,62,61,32,50,0,48,32,60,61,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,38,38,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,114,111,119,115,0,48,32,60,61,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,38,38,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,99,111,108,115,0,114,97,110,103,101,115,0,114,32,61,61,32,82,97,110,103,101,58,58,97,108,108,40,41,32,124,124,32,40,48,32,60,61,32,114,46,115,116,97,114,116,32,38,38,32,114,46,115,116,97,114,116,32,60,32,114,46,101,110,100,32,38,38,32,114,46,101,110,100,32,60,61,32,109,46,115,105,122,101,91,105,93,41,0,48,32,60,61,32,114,111,105,46,120,32,38,38,32,48,32,60,61,32,114,111,105,46,119,105,100,116,104,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,109,46,99,111,108,115,32,38,38,32,48,32,60,61,32,114,111,105,46,121,32,38,38,32,48,32,60,61,32,114,111,105,46,104,101,105,103,104,116,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,109,46,114,111,119,115,0,40,105,110,116,41,114,97,110,103,101,115,46,115,105,122,101,40,41,32,61,61,32,100,0,100,105,109,115,32,60,61,32,50,0,100,105,97,103,0,40,105,110,116,41,110,101,108,101,109,115,32,62,61,32,48,0,114,101,115,101,114,118,101,0,100,105,109,115,32,60,61,32,50,32,38,38,32,115,116,101,112,91,48,93,32,62,32,48,0,108,111,99,97,116,101,82,79,73,0,97,100,106,117,115,116,82,79,73,0,114,101,115,104,97,112,101,0,95,99,110,32,62,61,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,62,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,60,61,32,67,86,95,77,65,88,95,68,73,77,32,38,38,32,95,110,101,119,115,122,0,95,99,110,32,60,61,32,67,86,95,67,78,95,77,65,88,0,95,110,101,119,115,122,91,105,93,32,62,61,32,48,0,67,111,112,121,32,100,105,109,101,110,115,105,111,110,32,40,119,104,105,99,104,32,104,97,115,32,122,101,114,111,32,115,105,122,101,41,32,105,115,32,110,111,116,32,112,114,101,115,101,110,116,32,105,110,32,115,111,117,114,99,101,32,109,97,116,114,105,120,0,82,101,113,117,101,115,116,101,100,32,97,110,100,32,115,111,117,114,99,101,32,109,97,116,114,105,99,101,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,99,111,117,110,116,32,111,102,32,101,108,101,109,101,110,116,115,0,82,101,115,104,97,112,105,110,103,32,111,102,32,110,45,100,105,109,101,110,115,105,111,110,97,108,32,110,111,110,45,99,111,110,116,105,110,117,111,117,115,32,109,97,116,114,105,99,101,115,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,121,101,116,0,101,109,112,116,121,40,41,0,100,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,46,114,111,119,115,32,61,61,32,49,0,83,105,122,101,32,99,118,58,58,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,40,99,118,58,58,77,97,116,32,38,44,32,105,110,116,41,0,109,49,46,100,105,109,115,0,50,0,105,115,95,109,49,95,118,101,99,116,111,114,0,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,0,105,115,95,109,50,95,118,101,99,116,111,114,0,109,49,46,99,111,108,115,32,61,61,32,109,50,46,99,111,108,115,32,38,38,32,109,49,46,114,111,119,115,32,61,61,32,109,50,46,114,111,119,115,0,83,105,122,101,32,99,118,58,58,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,40,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,105,110,116,41,0,116,111,116,97,108,95,115,122,0,109,50,46,116,111,116,97,108,40,41,0,109,50,46,100,105,109,115,0,105,115,95,109,51,95,118,101,99,116,111,114,0,109,49,46,99,111,108,115,32,61,61,32,109,50,46,99,111,108,115,32,38,38,32,109,49,46,114,111,119,115,32,61,61,32,109,50,46,114,111,119,115,32,38,38,32,109,49,46,99,111,108,115,32,61,61,32,109,51,46,99,111,108,115,32,38,38,32,109,49,46,114,111,119,115,32,61,61,32,109,51,46,114,111,119,115,0,83,105,122,101,32,99,118,58,58,103,101,116,67,111,110,116,105,110,117,111,117,115,83,105,122,101,50,68,40,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,105,110,116,41,0,109,51,46,116,111,116,97,108,40,41,0,109,51,46,100,105,109,115,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,50,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,99,46,102,97,99,116,111,114,115,91,48,93,32,61,61,32,99,46,102,97,99,116,111,114,115,91,99,46,110,102,45,49,93,0,68,70,84,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,120,116,46,99,112,112,0,0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,79,207,47,175,111,239,31,159,95,223,63,191,127,255,78,50,99,118,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,49,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,49,68,69,0,84,104,105,115,32,109,111,100,101,32,40,117,115,105,110,103,32,110,111,110,122,101,114,111,95,114,111,119,115,32,119,105,116,104,32,97,32,115,105,110,103,108,101,45,99,111,108,117,109,110,32,109,97,116,114,105,120,41,32,98,114,101,97,107,115,32,116,104,101,32,102,117,110,99,116,105,111,110,39,115,32,108,111,103,105,99,44,32,115,111,32,105,116,32,105,115,32,112,114,111,104,105,98,105,116,101,100,46,10,70,111,114,32,102,97,115,116,32,99,111,110,118,111,108,117,116,105,111,110,47,99,111,114,114,101,108,97,116,105,111,110,32,117,115,101,32,50,45,99,111,108,117,109,110,32,109,97,116,114,105,120,32,111,114,32,115,105,110,103,108,101,45,114,111,119,32,109,97,116,114,105,120,32,105,110,115,116,101,97,100,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,49,48,79,99,118,68,102,116,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,49,48,79,99,118,68,102,116,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,50,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,48,79,99,118,68,102,116,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,50,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,50,68,69,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,49,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,54,52,70,67,50,0,100,102,116,0,33,40,40,102,108,97,103,115,32,38,32,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,41,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,33,61,32,50,41,0,116,121,112,101,32,61,61,32,115,114,99,66,46,116,121,112,101,40,41,32,38,38,32,115,114,99,65,46,115,105,122,101,40,41,32,61,61,32,115,114,99,66,46,115,105,122,101,40,41,0,109,117,108,83,112,101,99,116,114,117,109,115,0,115,114,99,32,38,38,32,110,115,114,99,115,32,62,32,48,32,38,38,32,100,115,116,32,38,38,32,110,100,115,116,115,32,62,32,48,32,38,38,32,102,114,111,109,84,111,32,38,38,32,110,112,97,105,114,115,32,62,32,48,0,109,105,120,67,104,97,110,110,101,108,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,104,97,110,110,101,108,115,46,99,112,112,0,106,32,60,32,110,115,114,99,115,32,38,38,32,115,114,99,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,105,49,32,62,61,32,48,32,38,38,32,106,32,60,32,110,100,115,116,115,32,38,38,32,100,115,116,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,102,114,111,109,84,111,46,115,105,122,101,40,41,37,50,32,61,61,32,48,32,38,38,32,110,115,114,99,32,62,32,48,32,38,38,32,110,100,115,116,32,62,32,48,0,48,32,60,61,32,99,111,105,32,38,38,32,99,111,105,32,60,32,99,110,0,101,120,116,114,97,99,116,67,104,97,110,110,101,108,0,99,111,110,118,101,114,116,65,110,100,85,110,114,111,108,108,83,99,97,108,97,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,105,116,104,109,46,99,112,112,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,98,105,110,97,114,121,95,111,112,0,112,115,114,99,49,45,62,115,97,109,101,83,105,122,101,40,42,112,115,114,99,50,41,32,38,38,32,116,121,112,101,49,32,61,61,32,116,121,112,101,50,0,40,109,116,121,112,101,32,61,61,32,67,86,95,56,85,32,124,124,32,109,116,121,112,101,32,61,61,32,67,86,95,56,83,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,97,114,105,116,104,109,95,111,112,0,116,121,112,101,50,32,61,61,32,67,86,95,54,52,70,32,38,38,32,40,115,122,50,46,104,101,105,103,104,116,32,61,61,32,49,32,124,124,32,115,122,50,46,104,101,105,103,104,116,32,61,61,32,52,41,0,87,104,101,110,32,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,105,110,32,97,100,100,47,115,117,98,116,114,97,99,116,47,109,117,108,116,105,112,108,121,47,100,105,118,105,100,101,32,102,117,110,99,116,105,111,110,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,44,32,116,104,101,32,111,117,116,112,117,116,32,97,114,114,97,121,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,120,112,108,105,99,105,116,108,121,32,115,112,101,99,105,102,105,101,100,0,40,109,116,121,112,101,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,109,116,121,112,101,32,61,61,32,67,86,95,56,83,67,49,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,111,112,32,61,61,32,67,77,80,95,76,84,32,124,124,32,111,112,32,61,61,32,67,77,80,95,76,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,69,81,32,124,124,32,111,112,32,61,61,32,67,77,80,95,78,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,84,0,99,111,109,112,97,114,101,0,95,115,114,99,49,46,101,109,112,116,121,40,41,32,61,61,32,95,115,114,99,50,46,101,109,112,116,121,40,41,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,33,32,95,115,114,99,46,101,109,112,116,121,40,41,0,105,110,82,97,110,103,101,0,84,104,101,32,108,111,119,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,84,104,101,32,117,112,112,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,108,98,83,99,97,108,97,114,32,61,61,32,117,98,83,99,97,108,97,114,0,108,98,46,116,121,112,101,40,41,32,61,61,32,117,98,46,116,121,112,101,40,41,0,78,50,99,118,57,70,111,114,109,97,116,116,101,100,69,0,78,50,99,118,57,70,111,114,109,97,116,116,101,114,69,0,0,0,59,0,0,109,46,100,105,109,115,32,60,61,32,50,0,70,111,114,109,97,116,116,101,100,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,117,116,46,99,112,112,0,37,37,46,37,100,103,0,37,51,100,0,10,40,58,44,32,58,44,32,37,100,41,32,61,32,10,0,40,58,44,32,58,44,32,37,100,41,32,61,32,10,0,78,50,99,118,49,51,70,111,114,109,97,116,116,101,100,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,51,70,111,114,109,97,116,116,101,100,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,53,77,97,116,108,97,98,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,49,51,70,111,114,109,97,116,116,101,114,66,97,115,101,69,0,78,50,99,118,49,50,67,83,86,70,111,114,109,97,116,116,101,114,69,0,91,93,44,91,93,78,50,99,118,49,53,80,121,116,104,111,110,70,111,114,109,97,116,116,101,114,69,0,93,44,32,100,116,121,112,101,61,39,37,115,39,41,0,97,114,114,97,121,40,91,0,117,105,110,116,56,0,105,110,116,56,0,117,105,110,116,49,54,0,105,110,116,49,54,0,102,108,111,97,116,51,50,0,102,108,111,97,116,54,52,0,102,108,111,97,116,49,54,0,78,50,99,118,49,52,78,117,109,112,121,70,111,114,109,97,116,116,101,114,69,0,0,0,44,0,0,123,0,78,50,99,118,49,48,67,70,111,114,109,97,116,116,101,114,69,0,78,50,99,118,49,54,68,101,102,97,117,108,116,70,111,114,109,97,116,116,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,53,77,97,116,108,97,98,70,111,114,109,97,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,83,86,70,111,114,109,97,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,53,80,121,116,104,111,110,70,111,114,109,97,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,78,117,109,112,121,70,111,114,109,97,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,48,67,70,111,114,109,97,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,68,101,102,97,117,108,116,70,111,114,109,97,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,67,85,68,65,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,99,117,100,97,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,114,105,118,97,116,101,46,99,117,100,97,46,104,112,112,0,78,50,99,118,49,54,80,97,114,97,108,108,101,108,76,111,111,112,66,111,100,121,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,114,97,121,46,99,112,112,0,99,118,73,110,105,116,77,97,116,72,101,97,100,101,114,0,78,111,110,45,112,111,115,105,116,105,118,101,32,99,111,108,115,32,111,114,32,114,111,119,115,0,78,85,76,76,32,97,114,114,97,121,32,112,111,105,110,116,101,114,32,105,115,32,112,97,115,115,101,100,0,84,104,101,32,109,97,116,114,105,120,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,73,110,112,117,116,32,97,114,114,97,121,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,99,118,71,101,116,77,97,116,0,84,104,101,32,105,109,97,103,101,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,67,79,73,32,115,101,108,101,99,116,101,100,0,84,104,101,32,105,109,97,103,101,32,105,115,32,105,110,116,101,114,108,101,97,118,101,100,32,97,110,100,32,104,97,115,32,111,118,101,114,32,67,86,95,67,78,95,77,65,88,32,99,104,97,110,110,101,108,115,0,80,105,120,101,108,32,111,114,100,101,114,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,99,111,105,32,61,61,32,48,0,79,110,108,121,32,99,111,110,116,105,110,117,111,117,115,32,110,68,32,97,114,114,97,121,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,104,101,114,101,0,84,104,101,32,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,99,118,82,101,115,104,97,112,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,84,104,101,32,109,97,116,114,105,120,32,105,115,32,110,111,116,32,99,111,110,116,105,110,117,111,117,115,44,32,116,104,117,115,32,105,116,115,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,99,97,110,32,110,111,116,32,98,101,32,99,104,97,110,103,101,100,0,66,97,100,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,84,104,101,32,116,111,116,97,108,32,119,105,100,116,104,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,99,110,32,60,61,32,52,0,115,99,97,108,97,114,84,111,82,97,119,68,97,116,97,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,119,114,105,116,101,95,109,111,100,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,46,99,112,112,0,33,119,114,105,116,101,95,115,116,97,99,107,46,101,109,112,116,121,40,41,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,102,105,108,101,110,97,109,101,0,111,112,101,110,0,70,105,108,101,83,116,111,114,97,103,101,58,58,65,80,80,69,78,68,32,97,110,100,32,70,105,108,101,83,116,111,114,97,103,101,58,58,77,69,77,79,82,89,32,97,114,101,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,99,111,109,112,97,116,105,98,108,101,0,65,112,112,101,110,100,105,110,103,32,100,97,116,97,32,116,111,32,99,111,109,112,114,101,115,115,101,100,32,102,105,108,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,97,43,116,0,119,116,0,114,116,0,46,103,122,0,46,120,109,108,0,46,120,109,108,46,103,122,0,46,106,115,111,110,0,46,106,115,111,110,46,103,122,0,85,84,70,45,49,54,0,85,84,70,45,49,54,32,88,77,76,32,101,110,99,111,100,105,110,103,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,33,32,85,115,101,32,56,45,98,105,116,32,101,110,99,111,100,105,110,103,10,0,115,116,114,108,101,110,40,101,110,99,111,100,105,110,103,41,32,60,32,49,48,48,48,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,32,101,110,99,111,100,105,110,103,61,34,37,115,34,63,62,10,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,114,43,116,0,102,105,108,101,32,33,61,32,48,0,32,60,33,45,45,32,114,101,115,117,109,101,100,32,45,45,62,0,37,89,65,77,76,58,49,46,48,10,45,45,45,10,0,46,46,46,10,45,45,45,10,0,102,109,116,32,61,61,32,70,105,108,101,83,116,111,114,97,103,101,58,58,70,79,82,77,65,84,95,74,83,79,78,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,39,125,39,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,73,110,112,117,116,32,102,105,108,101,32,105,115,32,101,109,112,116,121,0,85,110,115,117,112,112,111,114,116,101,100,32,102,105,108,101,32,115,116,111,114,97,103,101,32,102,111,114,109,97,116,0,33,102,115,95,100,97,116,97,95,112,116,114,115,46,101,109,112,116,121,40,41,0,111,102,115,32,61,61,32,102,115,95,100,97,116,97,95,98,108,107,115,122,91,98,108,111,99,107,73,100,120,93,0,110,111,114,109,97,108,105,122,101,78,111,100,101,79,102,115,0,116,112,32,61,61,32,83,84,82,73,78,71,32,124,124,32,116,112,32,61,61,32,83,69,81,32,124,124,32,116,112,32,61,61,32,77,65,80,0,114,97,119,83,105,122,101,0,98,108,111,99,107,73,100,120,32,60,32,102,115,95,100,97,116,97,95,112,116,114,115,46,115,105,122,101,40,41,0,103,101,116,78,111,100,101,80,116,114,0,111,102,115,32,60,32,102,115,95,100,97,116,97,95,98,108,107,115,122,91,98,108,111,99,107,73,100,120,93,0,98,108,111,99,107,73,100,120,32,61,61,32,102,115,95,100,97,116,97,95,112,116,114,115,46,115,105,122,101,40,41,45,49,0,114,101,115,101,114,118,101,78,111,100,101,83,112,97,99,101,0,111,102,115,32,60,61,32,102,115,95,100,97,116,97,95,98,108,107,115,122,91,98,108,111,99,107,73,100,120,93,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,83,95,54,118,101,99,116,111,114,73,104,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,78,83,50,95,73,83,52,95,69,69,69,69,0,106,32,60,32,109,97,120,67,111,117,110,116,32,45,32,49,32,38,38,32,34,79,112,101,110,67,86,32,112,101,114,115,105,115,116,101,110,99,101,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,118,101,114,121,32,108,111,110,103,32,108,105,110,101,115,34,0,103,101,116,115,0,115,122,32,60,32,40,115,105,122,101,95,116,41,40,109,97,120,67,111,117,110,116,32,45,32,49,41,32,38,38,32,34,79,112,101,110,67,86,32,112,101,114,115,105,115,116,101,110,99,101,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,118,101,114,121,32,108,111,110,103,32,108,105,110,101,115,34,0,84,104,101,32,115,116,111,114,97,103,101,32,105,115,32,110,111,116,32,111,112,101,110,101,100,0,78,50,99,118,49,49,70,105,108,101,83,116,111,114,97,103,101,69,0,78,50,99,118,49,53,70,105,108,101,83,116,111,114,97,103,101,95,65,80,73,69,0,37,100,46,48,0,37,100,46,0,37,46,49,54,101,0,46,78,97,110,0,45,46,73,110,102,0,46,73,110,102,0,37,46,52,101,0,37,46,56,101,0,117,99,119,115,105,102,100,104,0,73,110,118,97,108,105,100,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,100,101,99,111,100,101,70,111,114,109,97,116,0,115,121,109,98,111,108,84,111,84,121,112,101,0,84,111,111,32,108,111,110,103,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,37,115,40,37,100,41,58,32,37,115,0,33,98,97,115,101,54,52,100,101,99,111,100,101,114,46,101,110,100,79,102,83,116,114,101,97,109,40,41,0,112,97,114,115,101,66,97,115,101,54,52,0,111,102,115,32,60,61,32,115,122,0,114,101,97,100,77,111,114,101,0,33,112,97,114,115,101,114,46,101,109,112,116,121,40,41,32,38,38,32,112,116,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,63,52,53,54,55,56,57,58,59,60,61,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,0,0,0,0,0,0,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,66,97,100,32,102,111,114,109,97,116,32,111,102,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,99,111,110,115,116,97,110,116,0,112,114,111,99,101,115,115,83,112,101,99,105,97,108,68,111,117,98,108,101,0,77,97,112,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,104,97,118,101,32,97,32,110,97,109,101,0,83,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,110,111,116,32,104,97,118,101,32,110,97,109,101,32,40,117,115,101,32,60,95,62,60,47,95,62,41,0,97,100,100,78,111,100,101,0,112,32,33,61,32,48,0,115,101,116,86,97,108,117,101,0,99,117,114,114,101,110,116,95,116,121,112,101,32,61,61,32,78,79,78,69,32,124,124,32,99,117,114,114,101,110,116,95,116,121,112,101,32,61,61,32,116,121,112,101,0,79,110,108,121,32,115,99,97,108,97,114,32,116,121,112,101,115,32,99,97,110,32,98,101,32,100,121,110,97,109,105,99,97,108,108,121,32,97,115,115,105,103,110,101,100,32,116,111,32,97,32,102,105,108,101,32,110,111,100,101,0,116,121,112,101,32,61,61,32,70,105,108,101,78,111,100,101,58,58,83,69,81,32,124,124,32,116,121,112,101,32,61,61,32,70,105,108,101,78,111,100,101,58,58,77,65,80,0,99,111,110,118,101,114,116,84,111,67,111,108,108,101,99,116,105,111,110,0,116,121,112,101,32,61,61,32,70,105,108,101,78,111,100,101,58,58,83,69,81,0,84,104,101,32,110,111,100,101,32,111,102,32,116,121,112,101,32,37,100,32,99,97,110,110,111,116,32,98,101,32,99,111,110,118,101,114,116,101,100,32,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+235524);allocate([111,32,99,111,108,108,101,99,116,105,111,110,0,103,101,116,67,117,114,114,101,110,116,83,116,114,117,99,116,0,112,116,114,32,62,61,32,98,117,102,102,101,114,115,116,97,114,116,32,38,38,32,112,116,114,32,60,61,32,98,117,102,102,101,114,69,110,100,40,41,0,115,101,116,66,117,102,102,101,114,80,116,114,0,119,114,105,116,116,101,110,95,108,101,110,32,60,61,32,40,105,110,116,41,98,117,102,102,101,114,46,115,105,122,101,40,41,0,114,101,115,105,122,101,87,114,105,116,101,66,117,102,102,101,114,0,112,117,116,115,0,78,50,99,118,49,49,70,105,108,101,83,116,111,114,97,103,101,52,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,70,105,108,101,83,116,111,114,97,103,101,52,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,58,32,70,105,108,101,78,111,100,101,58,58,83,69,81,32,111,114,32,70,105,108,101,78,111,100,101,58,58,77,65,80,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,73,110,118,97,108,105,100,32,102,105,108,101,110,97,109,101,0,103,101,116,68,101,102,97,117,108,116,79,98,106,101,99,116,78,97,109,101,0,105,115,77,97,112,40,41,0,107,101,121,50,32,60,32,102,115,45,62,112,45,62,115,116,114,95,104,97,115,104,95,100,97,116,97,46,115,105,122,101,40,41,0,119,114,105,116,101,82,97,119,68,97,116,97,0,108,101,110,32,37,32,101,108,101,109,83,105,122,101,32,61,61,32,48,0,78,117,108,108,32,100,97,116,97,32,112,111,105,110,116,101,114,0,69,120,116,114,97,32,99,108,111,115,105,110,103,32,39,37,99,39,0,84,104,101,32,99,108,111,115,105,110,103,32,39,37,99,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,111,112,101,110,105,110,103,32,39,37,99,39,0,33,102,115,95,105,109,112,108,45,62,119,114,105,116,101,95,115,116,97,99,107,46,101,109,112,116,121,40,41,0,73,110,99,111,114,114,101,99,116,32,101,108,101,109,101,110,116,32,110,97,109,101,32,37,115,59,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,39,95,39,0,73,110,118,97,108,105,100,32,102,115,46,115,116,97,116,101,0,105,115,83,101,113,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,115,122,0,95,111,102,115,32,62,61,32,48,0,109,97,120,115,122,32,37,32,101,115,122,32,61,61,32,48,0,114,101,97,100,82,97,119,0,114,101,97,100,82,97,119,68,97,116,97,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,116,111,32,114,101,97,100,32,112,108,97,105,110,32,115,101,113,117,101,110,99,101,115,32,111,102,32,110,117,109,98,101,114,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,10,60,33,45,45,32,110,101,120,116,32,115,116,114,101,97,109,32,45,45,62,10,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,120,109,108,46,99,112,112,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,39,45,45,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,116,104,101,32,99,111,109,109,101,110,116,115,0,60,33,45,45,32,37,115,32,45,45,62,0,60,33,45,45,0,101,108,101,109,101,110,116,115,32,119,105,116,104,32,107,101,121,115,32,99,97,110,32,110,111,116,32,98,101,32,119,114,105,116,116,101,110,32,116,111,32,115,101,113,117,101,110,99,101,0,119,114,105,116,101,84,97,103,0,65,32,115,105,110,103,108,101,32,95,32,105,115,32,97,32,114,101,115,101,114,118,101,100,32,116,97,103,32,110,97,109,101,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,105,110,99,108,117,100,101,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,75,101,121,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,32,97,110,100,32,39,95,39,0,110,97,116,116,114,32,37,32,50,32,61,61,32,48,0,97,109,112,0,35,120,37,48,50,120,0,116,121,112,101,95,105,100,0,78,50,99,118,49,48,88,77,76,69,109,105,116,116,101,114,69,0,78,50,99,118,49,56,70,105,108,101,83,116,111,114,97,103,101,69,109,105,116,116,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,48,88,77,76,69,109,105,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,67,111,109,109,101,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,102,115,32,33,61,32,48,0,60,63,120,109,108,0,86,97,108,105,100,32,88,77,76,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,63,120,109,108,32,46,46,46,63,62,39,0,111,112,101,110,99,118,95,115,116,111,114,97,103,101,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,102,115,45,62,101,111,102,40,41,0,68,105,114,101,99,116,105,118,101,32,116,97,103,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,69,109,112,116,121,32,116,97,103,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,116,97,103,95,116,121,112,101,32,61,61,32,67,86,95,88,77,76,95,79,80,69,78,73,78,71,95,84,65,71,0,77,105,115,109,97,116,99,104,101,100,32,99,108,111,115,105,110,103,32,116,97,103,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,108,105,116,101,114,97,108,115,0,76,105,116,101,114,97,108,32,34,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,119,105,116,104,105,110,32,97,32,115,116,114,105,110,103,46,32,85,115,101,32,38,113,117,111,116,59,0,67,108,111,115,105,110,103,32,34,32,105,115,32,101,120,112,101,99,116,101,100,0,76,105,116,101,114,97,108,32,39,32,111,114,32,62,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,46,32,85,115,101,32,38,97,112,111,115,59,32,111,114,32,38,103,116,59,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,105,110,32,116,104,101,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,121,109,98,111,108,32,101,110,116,105,116,121,32,110,97,109,101,0,108,116,0,103,116,0,97,112,111,115,0,113,117,111,116,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,116,104,101,32,115,116,114,101,97,109,0,112,97,114,115,101,84,97,103,0,84,97,103,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,39,0,85,110,107,110,111,119,110,32,116,97,103,32,116,121,112,101,0,78,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,117,110,100,101,114,115,99,111,114,101,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,99,111,110,116,97,105,110,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,65,116,116,114,105,98,117,116,101,32,110,97,109,101,32,115,104,111,117,108,100,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,39,61,39,0,65,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,115,104,111,117,108,100,32,98,101,32,112,117,116,32,105,110,116,111,32,115,105,110,103,108,101,32,111,114,32,100,111,117,98,108,101,32,113,117,111,116,101,115,0,116,121,112,101,95,110,97,109,101,46,101,109,112,116,121,40,41,0,73,110,118,97,108,105,100,32,99,108,111,115,105,110,103,32,116,97,103,32,102,111,114,32,60,63,120,109,108,32,46,46,46,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,97,116,116,114,105,98,117,116,101,115,0,78,50,99,118,57,88,77,76,80,97,114,115,101,114,69,0,78,50,99,118,49,55,70,105,108,101,83,116,111,114,97,103,101,80,97,114,115,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,88,77,76,80,97,114,115,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,121,109,108,46,99,112,112,0,120,37,48,50,120,0,33,33,98,105,110,97,114,121,32,124,0,33,33,37,115,32,37,99,0,33,33,37,115,0,78,50,99,118,49,49,89,65,77,76,69,109,105,116,116,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,89,65,77,76,69,109,105,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,108,105,110,101,0,73,110,99,111,114,114,101,99,116,32,105,110,100,101,110,116,97,116,105,111,110,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,111,114,32,97,32,108,97,115,116,32,115,116,114,105,110,103,32,119,47,111,32,110,101,119,108,105,110,101,0,84,97,98,115,32,97,114,101,32,112,114,111,104,105,98,105,116,101,100,32,105,110,32,89,65,77,76,33,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,0,37,89,65,77,76,0,37,89,65,77,76,58,49,46,0,37,89,65,77,76,32,49,46,0,85,110,115,117,112,112,111,114,116,101,100,32,89,65,77,76,32,118,101,114,115,105,111,110,32,40,105,116,32,109,117,115,116,32,98,101,32,49,46,120,41,0,45,45,45,0,84,104,101,32,89,65,77,76,32,115,116,114,101,97,109,115,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,45,45,39,44,32,101,120,99,101,112,116,32,116,104,101,32,102,105,114,115,116,32,111,110,101,0,73,110,118,97,108,105,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,115,121,110,116,97,120,0,79,110,108,121,32,99,111,108,108,101,99,116,105,111,110,115,32,97,115,32,89,65,77,76,32,115,116,114,101,97,109,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,60,116,97,103,58,121,97,109,108,46,111,114,103,44,50,48,48,50,58,0,69,109,112,116,121,32,116,121,112,101,32,110,97,109,101,0,115,116,114,0,115,101,113,0,109,97,112,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,84,104,101,32,119,114,111,110,103,32,99,108,111,115,105,110,103,32,98,114,97,99,107,101,116,0,77,105,115,115,105,110,103,32,44,32,98,101,116,119,101,101,110,32,116,104,101,32,101,108,101,109,101,110,116,115,0,67,111,109,112,108,101,120,32,107,101,121,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,77,117,108,116,105,45,108,105,110,101,32,116,101,120,116,32,108,105,116,101,114,97,108,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,66,108,111,99,107,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,32,109,117,115,116,32,98,101,32,112,114,101,99,101,100,101,100,32,119,105,116,104,32,39,45,39,0,75,101,121,32,109,97,121,32,110,111,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,39,0,77,105,115,115,105,110,103,32,39,58,39,0,65,110,32,101,109,112,116,121,32,107,101,121,0,78,50,99,118,49,48,89,65,77,76,80,97,114,115,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,48,89,65,77,76,80,97,114,115,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,99,109,112,111,112,32,61,61,32,67,77,80,95,78,69,0,99,109,112,95,108,111,111,112,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,105,116,104,109,46,115,105,109,100,46,104,112,112,0,99,109,112,95,108,111,111,112,95,110,111,115,105,109,100,0,46,46,46,10,0,45,45,45,10,0,78,117,108,108,32,99,111,109,109,101,110,116,0,119,114,105,116,101,67,111,109,109,101,110,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,95,106,115,111,110,46,99,112,112,0,84,104,101,32,107,101,121,32,105,115,32,97,110,32,101,109,112,116,121,0,119,114,105,116,101,83,99,97,108,97,114,0,84,104,101,32,107,101,121,32,105,115,32,116,111,111,32,108,111,110,103,0,65,110,32,97,116,116,101,109,112,116,32,116,111,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,111,117,116,32,97,32,107,101,121,32,116,111,32,97,32,109,97,112,44,32,111,114,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,32,107,101,121,32,116,111,32,115,101,113,117,101,110,99,101,0,75,101,121,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,115,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,44,32,39,95,39,32,97,110,100,32,39,32,39,0,78,117,108,108,32,115,116,114,105,110,103,32,112,111,105,110,116,101,114,0,119,114,105,116,101,0,84,104,101,32,119,114,105,116,116,101,110,32,115,116,114,105,110,103,32,105,115,32,116,111,111,32,108,111,110,103,0,70,105,108,101,78,111,100,101,58,58,105,115,67,111,108,108,101,99,116,105,111,110,40,115,116,114,117,99,116,95,102,108,97,103,115,41,0,101,110,100,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,32,45,32,70,105,108,101,78,111,100,101,58,58,83,69,81,32,111,114,32,70,105,108,101,78,111,100,101,58,58,77,65,80,44,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,115,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,98,105,110,97,114,121,0,78,50,99,118,49,49,74,83,79,78,69,109,105,116,116,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,74,83,79,78,69,109,105,116,116,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,67,117,114,114,101,110,116,108,121,44,32,74,83,79,78,32,112,97,114,115,101,114,32,100,111,101,115,32,110,111,116,32,115,117,112,112,111,114,116,32,98,97,115,101,54,52,32,100,97,116,97,0,103,101,116,66,97,115,101,54,52,82,111,119,0,108,101,102,116,45,98,114,97,99,101,32,111,102,32,116,111,112,32,108,101,118,101,108,32,105,115,32,109,105,115,115,105,110,103,0,85,110,101,120,112,101,99,116,101,100,32,69,110,100,45,79,102,45,70,105,108,101,0,112,116,114,32,105,115,32,78,85,76,76,0,112,97,114,115,101,83,101,113,0,39,91,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,85,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,39,93,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,112,97,114,115,101,86,97,108,117,101,0,36,98,97,115,101,54,52,36,0,98,97,115,101,54,52,32,100,97,116,97,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,39,92,117,88,88,88,88,39,32,99,117,114,114,101,110,116,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,39,34,39,32,45,32,114,105,103,104,116,45,113,117,111,116,101,32,111,102,32,115,116,114,105,110,103,32,105,115,32,109,105,115,115,105,110,103,0,79,112,101,110,67,86,32,112,101,114,115,105,115,116,101,110,99,101,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,118,101,114,121,32,108,111,110,103,32,108,105,110,101,115,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,40,105,110,99,111,110,115,105,115,116,101,110,116,32,101,120,112,108,105,99,105,116,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,63,41,0,110,117,108,108,0,86,97,108,117,101,32,39,110,117,108,108,39,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,118,97,108,117,101,0,112,97,114,115,101,77,97,112,0,39,123,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111,102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,39,125,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,75,101,121,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,39,34,39,0,112,97,114,115,101,75,101,121,0,75,101,121,32,109,117,115,116,32,101,110,100,32,119,105,116,104,32,39,34,39,0,77,105,115,115,105,110,103,32,39,58,39,32,98,101,116,119,101,101,110,32,107,101,121,32,97,110,100,32,118,97,108,117,101,0,75,101,121,32,105,115,32,101,109,112,116,121,0,78,111,116,32,115,117,112,112,111,114,116,101,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,115,107,105,112,83,112,97,99,101,115,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,116,114,101,97,109,0,65,98,111,114,116,32,97,116,32,112,97,114,115,101,32,116,105,109,101,0,78,50,99,118,49,48,74,83,79,78,80,97,114,115,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,48,74,83,79,78,80,97,114,115,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,116,121,112,101,0,105,110,105,116,73,110,116,101,114,84,97,98,50,68,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,105,109,103,119,97,114,112,46,99,112,112,0,105,110,105,116,73,110,116,101,114,84,97,98,49,68,0,33,95,109,97,112,49,46,101,109,112,116,121,40,41,0,114,101,109,97,112,0,95,109,97,112,50,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,112,50,46,115,105,122,101,40,41,32,61,61,32,95,109,97,112,49,46,115,105,122,101,40,41,41,0,100,115,116,46,99,111,108,115,32,60,32,83,72,82,84,95,77,65,88,32,38,38,32,100,115,116,46,114,111,119,115,32,60,32,83,72,82,84,95,77,65,88,32,38,38,32,115,114,99,46,99,111,108,115,32,60,32,83,72,82,84,95,77,65,88,32,38,38,32,115,114,99,46,114,111,119,115,32,60,32,83,72,82,84,95,77,65,88,0,110,110,102,117,110,99,32,33,61,32,48,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,0,105,102,117,110,99,32,33,61,32,48,0,40,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,67,50,41,32,38,38,32,109,97,112,50,46,101,109,112,116,121,40,41,41,32,124,124,32,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,38,38,32,109,97,112,50,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,41,0,78,50,99,118,49,50,82,101,109,97,112,73,110,118,111,107,101,114,69,0,114,101,109,97,112,66,105,108,105,110,101,97,114,0,78,50,99,118,49,55,87,97,114,112,65,102,102,105,110,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,32,124,124,32,40,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,76,65,78,67,90,79,83,52,32,38,38,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,67,85,66,73,67,41,0,119,97,114,112,65,102,102,105,110,101,0,115,114,99,46,99,111,108,115,32,62,32,48,32,38,38,32,115,114,99,46,114,111,119,115,32,62,32,48,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,50,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,78,50,99,118,50,50,87,97,114,112,80,101,114,115,112,101,99,116,105,118,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,116,111,116,97,108,40,41,32,62,32,48,0,119,97,114,112,80,101,114,115,112,101,99,116,105,118,101,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,51,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,52,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,52,0,103,101,116,80,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,51,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,41,32,61,61,32,51,0,103,101,116,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,0,110,112,111,105,110,116,115,50,32,62,61,32,48,32,124,124,32,110,112,111,105,110,116,115,51,32,62,61,32,48,0,102,105,116,76,105,110,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,108,105,110,101,102,105,116,46,99,112,112,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,32,116,121,112,101,0,102,105,116,76,105,110,101,50,68,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,0,102,105,116,76,105,110,101,51,68,0,99,111,117,110,116,32,62,32,48,0,102,105,116,76,105,110,101,51,68,95,119,111,100,115,0,102,105,116,76,105,110,101,50,68,95,119,111,100,115,0,95,109,111,100,101,108,32,109,117,115,116,32,104,97,118,101,32,67,86,95,54,52,70,67,49,32,116,121,112,101,44,32,114,111,119,115,32,61,61,32,49,32,97,110,100,32,99,111,108,115,32,61,61,32,49,51,42,99,111,109,112,111,110,101,110,116,115,67,111,117,110,116,0,71,77,77,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,114,97,98,99,117,116,46,99,112,112,0,100,116,114,109,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,99,97,108,99,73,110,118,101,114,115,101,67,111,118,65,110,100,68,101,116,101,114,109,0,99,111,118,68,101,116,101,114,109,115,91,99,105,93,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,116,111,116,97,108,83,97,109,112,108,101,67,111,117,110,116,32,62,32,48,0,101,110,100,76,101,97,114,110,105,110,103,0,105,109,97,103,101,32,105,115,32,101,109,112,116,121,0,103,114,97,98,67,117,116,0,105,109,97,103,101,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,51,32,116,121,112,101,0,33,98,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,32,38,38,32,33,102,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,0,105,110,105,116,71,77,77,115,0,105,62,61,48,32,38,38,32,105,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,97,100,100,84,101,114,109,87,101,105,103,104,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,105,109,103,112,114,111,99,47,100,101,116,97,105,108,47,103,99,103,114,97,112,104,46,104,112,112,0,105,110,83,111,117,114,99,101,83,101,103,109,101,110,116,0,109,105,110,87,101,105,103,104,116,32,62,32,48,0,109,97,120,70,108,111,119,0,97,100,100,69,100,103,101,115,0,106,62,61,48,32,38,38,32,106,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,119,62,61,48,32,38,38,32,114,101,118,119,62,61,48,0,105,32,33,61,32,106,0,109,97,115,107,32,105,115,32,101,109,112,116,121,0,99,104,101,99,107,77,97,115,107,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,49,32,116,121,112,101,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,97,115,32,109,97,110,121,32,114,111,119,115,32,97,110,100,32,99,111,108,115,32,97,115,32,105,109,103,0,109,97,115,107,32,101,108,101,109,101,110,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,71,67,95,66,71,68,32,111,114,32,71,67,95,70,71,68,32,111,114,32,71,67,95,80,82,95,66,71,68,32,111,114,32,71,67,95,80,82,95,70,71,68,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,101,111,109,101,116,114,121,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,112,111,105,110,116,80,111,108,121,103,111,110,84,101,115,116,0,105,109,103,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,101,109,112,108,46,100,105,109,115,32,60,61,32,50,32,38,38,32,99,111,114,114,46,100,105,109,115,32,60,61,32,50,0,99,114,111,115,115,67,111,114,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,101,109,112,108,109,97,116,99,104,46,99,112,112,0,100,101,112,116,104,32,61,61,32,116,100,101,112,116,104,32,124,124,32,116,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,0,99,111,114,114,115,105,122,101,46,104,101,105,103,104,116,32,60,61,32,105,109,103,46,114,111,119,115,32,43,32,116,101,109,112,108,46,114,111,119,115,32,45,32,49,32,38,38,32,99,111,114,114,115,105,122,101,46,119,105,100,116,104,32,60,61,32,105,109,103,46,99,111,108,115,32,43,32,116,101,109,112,108,46,99,111,108,115,32,45,32,49,0,99,99,110,32,61,61,32,49,32,124,124,32,100,101,108,116,97,32,61,61,32,48,0,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,97,114,101,32,116,111,111,32,98,105,103,0,67,86,95,84,77,95,83,81,68,73,70,70,32,60,61,32,109,101,116,104,111,100,32,38,38,32,109,101,116,104,111,100,32,60,61,32,67,86,95,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,109,97,116,99,104,84,101,109,112,108,97,116,101,77,97,115,107,0,40,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,32,38,38,32,116,121,112,101,32,61,61,32,95,116,101,109,112,108,46,116,121,112,101,40,41,32,38,38,32,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,97,116,99,104,84,101,109,112,108,97,116,101,0,95,105,109,103,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,38,38,32,95,105,109,103,46,115,105,122,101,40,41,46,119,105,100,116,104,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,119,105,100,116,104,0,115,113,115,117,109,46,100,97,116,97,32,33,61,32,78,85,76,76,0,99,111,109,109,111,110,95,109,97,116,99,104,84,101,109,112,108,97,116,101,0,115,117,109,46,100,97,116,97,32,33,61,32,78,85,76,76,0,111,114,105,101,110,116,97,116,105,111,110,32,33,61,32,48,0,114,111,116,97,116,105,110,103,67,97,108,105,112,101,114,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,111,116,99,97,108,105,112,101,114,115,46,99,112,112,0,78,50,99,118,49,51,66,97,115,101,82,111,119,70,105,108,116,101,114,69,0,78,50,99,118,49,54,66,97,115,101,67,111,108,117,109,110,70,105,108,116,101,114,69,0,78,50,99,118,49,48,66,97,115,101,70,105,108,116,101,114,69,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,115,114,99,84,121,112,101,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,100,115,116,84,121,112,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,46,99,112,112,0,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,112,114,111,99,101,101,100,0,115,114,99,32,38,38,32,100,115,116,32,38,38,32,99,111,117,110,116,32,62,32,48,0,115,114,99,89,32,62,61,32,115,116,97,114,116,89,0,100,115,116,89,32,60,61,32,114,111,105,46,104,101,105,103,104,116,0,114,111,105,46,120,32,62,61,32,48,32,38,38,32,114,111,105,46,121,32,62,61,32,48,32,38,38,32,114,111,105,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,111,105,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,0,115,116,97,114,116,0,99,111,110,115,116,86,97,108,32,33,61,32,78,85,76,76,0,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,0,99,111,108,117,109,110,66,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,87,82,65,80,0,105,110,105,116,0,114,111,119,70,105,108,116,101,114,32,38,38,32,99,111,108,117,109,110,70,105,108,116,101,114,0,98,117,102,84,121,112,101,32,61,61,32,115,114,99,84,121,112,101,0,48,32,60,61,32,97,110,99,104,111,114,46,120,32,38,38,32,97,110,99,104,111,114,46,120,32,60,32,107,115,105,122,101,46,119,105,100,116,104,32,38,38,32,48,32,60,61,32,97,110,99,104,111,114,46,121,32,38,38,32,97,110,99,104,111,114,46,121,32,60,32,107,115,105,122,101,46,104,101,105,103,104,116,0,95,107,101,114,110,101,108,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,103,101,116,75,101,114,110,101,108,84,121,112,101,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,98,117,102,84,121,112,101,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,115,100,101,112,116,104,44,32,67,86,95,51,50,83,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,100,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,82,111,119,70,105,108,116,101,114,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,68,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,82,111,119,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+245764);allocate([104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,49,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,32,38,38,32,116,104,105,115,45,62,107,115,105,122,101,32,60,61,32,53,0,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,49,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,49,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,98,117,102,84,121,112,101,41,32,38,38,32,115,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,100,100,101,112,116,104,44,32,67,86,95,51,50,83,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,67,111,108,117,109,110,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,0,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,100,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,102,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,115,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,115,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,83,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,67,111,108,117,109,110,70,105,108,116,101,114,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,105,115,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,116,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,116,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,104,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,104,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,116,104,105,115,45,62,107,115,105,122,101,32,61,61,32,51,0,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,102,69,69,78,83,49,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,105,115,69,69,78,83,49,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,49,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,100,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,102,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,115,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,115,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,116,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,116,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,100,104,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,52,67,97,115,116,73,102,104,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,49,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,95,100,115,116,84,121,112,101,41,0,99,114,101,97,116,101,83,101,112,97,114,97,98,108,101,76,105,110,101,97,114,70,105,108,116,101,114,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,50,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,107,116,121,112,101,32,61,61,32,67,86,95,56,85,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,51,50,83,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,112,114,101,112,114,111,99,101,115,115,50,68,75,101,114,110,101,108,0,99,110,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,115,116,84,121,112,101,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,75,84,62,58,58,116,121,112,101,0,70,105,108,116,101,114,50,68,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,100,78,83,49,95,52,67,97,115,116,73,100,100,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,102,78,83,49,95,52,67,97,115,116,73,102,102,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,49,95,52,67,97,115,116,73,100,100,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,49,95,52,67,97,115,116,73,102,102,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,49,95,52,67,97,115,116,73,102,115,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,49,95,52,67,97,115,116,73,100,100,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,49,95,52,67,97,115,116,73,102,102,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,49,95,52,67,97,115,116,73,102,116,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,49,95,52,67,97,115,116,73,100,100,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,49,95,52,67,97,115,116,73,102,102,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,49,95,52,67,97,115,116,73,102,115,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,49,95,52,67,97,115,116,73,102,116,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,49,95,52,67,97,115,116,73,102,104,69,69,78,83,49,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,99,114,101,97,116,101,76,105,110,101,97,114,70,105,108,116,101,114,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,107,101,114,110,101,108,88,46,116,121,112,101,40,41,32,61,61,32,107,101,114,110,101,108,89,46,116,121,112,101,40,41,32,38,38,32,40,107,101,114,110,101,108,88,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,88,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,40,107,101,114,110,101,108,89,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,89,46,114,111,119,115,32,61,61,32,49,41,0,115,101,112,70,105,108,116,101,114,50,68,0,105,110,116,101,103,114,97,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,117,109,112,105,120,101,108,115,46,99,112,112,0,113,117,97,108,105,116,121,76,101,118,101,108,32,62,32,48,32,38,38,32,109,105,110,68,105,115,116,97,110,99,101,32,62,61,32,48,32,38,38,32,109,97,120,67,111,114,110,101,114,115,32,62,61,32,48,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,101,97,116,117,114,101,115,101,108,101,99,116,46,99,112,112,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,95,105,109,97,103,101,41,41,0,40,100,115,116,95,119,105,100,116,104,32,62,32,48,32,38,38,32,100,115,116,95,104,101,105,103,104,116,32,62,32,48,41,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,114,101,115,105,122,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,101,115,105,122,101,46,99,112,112,0,33,100,115,105,122,101,46,101,109,112,116,121,40,41,0,102,117,110,99,32,33,61,32,48,0,102,117,110,99,32,33,61,32,48,32,38,38,32,99,110,32,60,61,32,52,0,85,110,107,110,111,119,110,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,109,101,116,104,111,100,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,107,115,105,122,101,32,60,61,32,77,65,88,95,69,83,73,90,69,0,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,76,105,50,48,52,56,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+256004);allocate([111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,100,100,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,102,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,115,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,116,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,104,102,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,100,100,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,100,100,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,102,102,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,102,102,69,69,69,69,0,99,110,32,61,61,32,52,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,115,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,115,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,115,115,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,116,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,116,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,116,116,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,104,105,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,104,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,104,104,69,69,69,69,69,69,0,78,50,99,118,49,53,114,101,115,105,122,101,78,78,73,110,118,111,107,101,114,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,105,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,54,52,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,115,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,116,78,83,95,49,51,117,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,97,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,104,78,83,95,49,51,117,102,105,120,101,100,112,111,105,110,116,49,54,69,76,105,50,69,69,69,0,33,115,115,105,122,101,46,101,109,112,116,121,40,41,0,33,100,115,105,122,101,46,101,109,112,116,121,40,41,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,97,117,116,111,109,97,116,105,99,95,116,104,114,101,115,104,32,33,61,32,40,67,86,95,84,72,82,69,83,72,95,79,84,83,85,32,124,32,67,86,95,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,104,114,101,115,104,46,99,112,112,0,116,104,114,101,115,104,71,101,110,101,114,105,99,0,78,50,99,118,49,53,84,104,114,101,115,104,111,108,100,82,117,110,110,101,114,69,0,97,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,0,98,108,111,99,107,83,105,122,101,32,37,32,50,32,61,61,32,49,32,38,38,32,98,108,111,99,107,83,105,122,101,32,62,32,49,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,100,97,112,116,105,118,101,32,116,104,114,101,115,104,111,108,100,32,109,101,116,104,111,100,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,116,104,114,101,115,104,111,108,100,32,116,121,112,101,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,40,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,124,124,32,100,115,116,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,41,0,99,118,84,104,114,101,115,104,111,108,100,0,99,111,117,110,116,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,109,105,110,69,110,99,108,111,115,105,110,103,67,105,114,99,108,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,104,97,112,101,100,101,115,99,114,46,99,112,112,0,97,114,99,76,101,110,103,116,104,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,99,111,110,116,111,117,114,65,114,101,97,0,110,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,102,105,116,69,108,108,105,112,115,101,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,97,116,32,108,101,97,115,116,32,53,32,112,111,105,110,116,115,32,116,111,32,102,105,116,32,116,104,101,32,101,108,108,105,112,115,101,0,112,111,105,110,116,83,101,116,66,111,117,110,100,105,110,103,82,101,99,116,0,105,109,103,46,100,101,112,116,104,40,41,32,60,61,32,67,86,95,56,83,32,38,38,32,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,97,115,107,66,111,117,110,100,105,110,103,82,101,99,116,0,85,110,115,117,112,112,111,114,116,101,100,32,115,101,113,117,101,110,99,101,32,116,121,112,101,0,99,118,66,111,117,110,100,105,110,103,82,101,99,116,0,84,104,101,32,105,109,97,103,101,47,109,97,116,114,105,120,32,102,111,114,109,97,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,103,101,116,83,111,98,101,108,75,101,114,110,101,108,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,114,105,118,46,99,112,112,0,84,104,101,32,107,101,114,110,101,108,32,115,105,122,101,32,109,117,115,116,32,98,101,32,111,100,100,32,97,110,100,32,110,111,116,32,108,97,114,103,101,114,32,116,104,97,110,32,51,49,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,62,32,48,0,107,115,105,122,101,32,62,32,111,114,100,101,114,0,103,101,116,83,99,104,97,114,114,75,101,114,110,101,108,115,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,61,61,32,49,0,95,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,67,97,110,110,121,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,97,110,110,121,46,99,112,112,0,40,95,100,115,116,46,103,101,116,79,98,106,40,41,32,33,61,32,95,115,114,99,46,103,101,116,79,98,106,40,41,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,41,32,38,38,32,34,73,110,112,108,97,99,101,32,112,97,114,97,109,101,116,101,114,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,34,0,65,112,101,114,116,117,114,101,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,111,100,100,32,98,101,116,119,101,101,110,32,51,32,97,110,100,32,55,0,78,50,99,118,57,102,105,110,97,108,80,97,115,115,69,0,78,50,99,118,49,51,112,97,114,97,108,108,101,108,67,97,110,110,121,69,0,95,100,120,46,100,105,109,115,40,41,32,61,61,32,50,0,95,100,120,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,67,49,32,124,124,32,95,100,120,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,67,51,0,95,100,121,46,116,121,112,101,40,41,32,61,61,32,95,100,120,46,116,121,112,101,40,41,0,95,100,120,46,115,97,109,101,83,105,122,101,40,95,100,121,41,0,100,105,109,115,32,62,32,48,32,38,38,32,104,105,115,116,83,105,122,101,0,99,97,108,99,72,105,115,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,105,115,116,111,103,114,97,109,46,99,112,112,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,69,105,116,104,101,114,32,114,97,110,103,101,115,44,32,101,105,116,104,101,114,32,117,110,105,102,111,114,109,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,114,111,118,105,100,101,100,0,99,97,108,99,72,105,115,116,95,0,99,97,108,99,72,105,115,116,76,111,111,107,117,112,84,97,98,108,101,115,95,56,117,0,99,104,97,110,110,101,108,115,32,33,61,32,48,32,124,124,32,110,105,109,97,103,101,115,32,61,61,32,100,105,109,115,0,104,105,115,116,80,114,101,112,97,114,101,73,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,32,62,61,32,48,0,106,32,60,32,110,105,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,105,109,97,103,101,115,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,109,97,115,107,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,109,97,115,107,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,114,97,110,103,101,115,91,105,93,32,38,38,32,114,97,110,103,101,115,91,105,93,91,48,93,32,60,32,114,97,110,103,101,115,91,105,93,91,49,93,0,114,97,110,103,101,115,91,105,93,91,107,93,32,60,32,114,97,110,103,101,115,91,105,93,91,107,43,49,93,0,110,105,109,97,103,101,115,32,62,32,48,32,38,38,32,100,105,109,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,67,86,95,56,85,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,0,100,105,109,115,32,62,32,48,32,38,38,32,33,104,105,115,116,46,101,109,112,116,121,40,41,0,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,0,99,97,108,99,66,97,99,107,80,114,111,106,95,0,72,48,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,105,109,97,103,101,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,50,32,38,38,32,95,49,100,41,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,67,86,95,56,85,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,32,124,124,32,40,99,115,122,32,61,61,32,49,32,38,38,32,95,49,100,41,0,72,49,46,116,121,112,101,40,41,32,61,61,32,72,50,46,116,121,112,101,40,41,32,38,38,32,72,49,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,99,111,109,112,97,114,101,72,105,115,116,0,105,116,46,112,108,97,110,101,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,116,46,112,108,97,110,101,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,101,113,117,97,108,105,122,101,72,105,115,116,0,50,51,69,113,117,97,108,105,122,101,72,105,115,116,76,117,116,95,73,110,118,111,107,101,114,0,50,56,69,113,117,97,108,105,122,101,72,105,115,116,67,97,108,99,72,105,115,116,95,73,110,118,111,107,101,114,0,40,107,115,105,122,101,32,37,32,50,32,61,61,32,49,41,32,38,38,32,40,95,115,114,99,48,46,100,105,109,115,40,41,32,60,61,32,50,32,41,0,109,101,100,105,97,110,66,108,117,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,101,100,105,97,110,95,98,108,117,114,46,99,112,112,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,40,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,41,0,99,110,32,62,32,48,32,38,38,32,99,110,32,60,61,32,52,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,109,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,49,0,107,32,60,32,49,54,0,98,32,60,32,49,54,0,97,114,114,32,33,61,32,48,32,38,38,32,99,111,110,116,111,117,114,95,104,101,97,100,101,114,32,33,61,32,48,32,38,38,32,98,108,111,99,107,32,33,61,32,48,0,99,118,80,111,105,110,116,83,101,113,70,114,111,109,77,97,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,116,105,108,115,46,99,112,112,0,73,110,112,117,116,32,97,114,114,97,121,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,116,114,105,120,0,84,104,101,32,109,97,116,114,105,120,32,99,97,110,32,110,111,116,32,98,101,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,98,101,99,97,117,115,101,32,111,102,32,105,110,97,112,112,114,111,112,114,105,97,116,101,32,101,108,101,109,101,110,116,32,116,121,112,101,0,84,104,101,32,109,97,116,114,105,120,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,109,117,115,116,32,98,101,32,49,45,100,105,109,101,110,115,105,111,110,97,108,32,97,110,100,32,99,111,110,116,105,110,117,111,117,115,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,85,0,100,101,109,111,115,97,105,99,105,110,103,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,109,111,115,97,105,99,105,110,103,46,99,112,112,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,49,0,66,97,121,101,114,45,62,71,114,97,121,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,66,97,121,101,114,45,62,82,71,66,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,51,0,66,97,121,101,114,45,62,82,71,66,32,69,100,103,101,45,65,119,97,114,101,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,85,110,107,110,111,119,110,32,47,32,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,98,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,112,121,114,68,111,119,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,112,121,114,97,109,105,100,115,46,99,112,112,0,112,121,114,68,111,119,110,95,0,115,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,115,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,42,50,32,45,32,115,115,105,122,101,46,119,105,100,116,104,41,32,60,61,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,42,50,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,41,32,60,61,32,50,0,98,111,114,100,101,114,84,121,112,101,32,61,61,32,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,112,121,114,85,112,0,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,32,45,32,115,115,105,122,101,46,119,105,100,116,104,42,50,41,32,61,61,32,100,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,42,50,41,32,61,61,32,100,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,0,112,121,114,85,112,95,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,46,99,112,112,0,99,118,116,67,111,108,111,114,0,85,110,107,110,111,119,110,32,99,111,109,112,97,114,105,115,111,110,32,109,101,116,104,111,100,0,109,97,116,99,104,83,104,97,112,101,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,97,116,99,104,99,111,110,116,111,117,114,115,46,99,112,112,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,85,67,49,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,108,97,104,101,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,116,121,112,101,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,103,101,116,71,97,117,115,115,105,97,110,75,101,114,110,101,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,109,111,111,116,104,46,99,112,112,0,107,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,107,116,121,112,101,32,61,61,32,67,86,95,54,52,70,0,107,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,107,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,61,61,32,49,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,49,0,99,114,101,97,116,101,71,97,117,115,115,105,97,110,75,101,114,110,101,108,115,0,78,50,99,118,49,56,102,105,120,101,100,83,109,111,111,116,104,73,110,118,111,107,101,114,73,104,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,51,117,102,105,120,101,100,112,111,105,110,116,49,54,69,69,69,0,76,105,110,101,73,116,101,114,97,116,111,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,114,97,119,105,110,103,46,99,112,112,0,48,32,60,32,116,104,105,99,107,110,101,115,115,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,108,105,110,101,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,32,38,38,32,116,104,105,99,107,110,101,115,115,32,62,61,32,48,0,80,111,108,121,76,105,110,101,0,181,181,181,182,182,183,184,185,187,188,190,192,194,196,198,201,203,206,209,211,214,218,221,224,227,231,235,238,242,246,250,254,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,114,101,99,116,97,110,103,108,101,0,114,97,100,105,117,115,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,99,105,114,99,108,101,0,97,120,101,115,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,97,120,101,115,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,101,108,108,105,112,115,101,0,98,111,120,46,115,105,122,101,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,98,111,120,46,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,85,110,107,110,111,119,110,32,102,111,110,116,32,116,121,112,101,0,103,101,116,70,111,110,116,68,97,116,97,0,48,32,60,61,32,99,111,110,116,111,117,114,73,100,120,32,38,38,32,99,111,110,116,111,117,114,73,100,120,32,60,32,40,105,110,116,41,108,97,115,116,0,100,114,97,119,67,111,110,116,111,117,114,115,0,110,112,111,105,110,116,115,32,62,32,48,0,104,105,101,114,97,114,99,104,121,46,116,111,116,97,108,40,41,32,61,61,32,110,99,111,110,116,111,117,114,115,32,38,38,32,104,105,101,114,97,114,99,104,121,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,52,0,99,118,68,114,97,119,67,111,110,116,111,117,114,115,0,114,101,97,100,101,114,46,112,116,114,32,33,61,32,78,85,76,76,0,101,108,101,109,95,116,121,112,101,32,61,61,32,67,86,95,51,50,83,67,50,0,67,86,95,73,83,95,83,69,81,95,67,72,65,73,78,95,67,79,78,84,79,85,82,40,32,99,104,97,105,110,32,41,0,105,99,118,65,112,112,114,111,120,105,109,97,116,101,67,104,97,105,110,84,67,56,57,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,97,112,112,114,111,120,46,99,112,112,0,104,101,97,100,101,114,95,115,105,122,101,32,62,61,32,40,105,110,116,41,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,41,0,97,112,112,114,111,120,80,111,108,121,68,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,67,86,95,77,65,84,95,67,78,40,115,117,109,84,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,115,114,99,84,121,112,101,41,0,103,101,116,82,111,119,83,117,109,70,105,108,116,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,98,111,120,95,102,105,108,116,101,114,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,82,111,119,83,117,109,73,104,105,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,105,105,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,105,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,105,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,100,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,116,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,100,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,102,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,115,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,105,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,115,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,116,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,116,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,104,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,104,116,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,54,82,111,119,83,117,109,73,104,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,67,86,95,77,65,84,95,67,78,40,115,117,109,84,121,112,101,41,32,61,61,32,67,86,95,77,65,84,95,67,78,40,100,115,116,84,121,112,101,41,0,103,101,116,67,111,108,117,109,110,83,117,109,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,117,109,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,115,117,109,67,111,117,110,116,32,61,61,32,107,115,105,122,101,45,49,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+266244);allocate([112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,103,101,116,83,113,114,82,111,119,83,117,109,70,105,108,116,101,114,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,98,105,108,97,116,101,114,97,108,95,102,105,108,116,101,114,46,99,112,112,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,51,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,0,66,105,108,97,116,101,114,97,108,32,102,105,108,116,101,114,105,110,103,32,105,115,32,111,110,108,121,32,105,109,112,108,101,109,101,110,116,101,100,32,102,111,114,32,56,117,32,97,110,100,32,51,50,102,32,105,109,97,103,101,115,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,0,99,110,32,61,61,32,51,0,78,50,99,118,50,55,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,54,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,95,73,110,118,111,107,101,114,69,0,77,87,82,77,78,86,32,82,77,86,86,32,80,83,84,83,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,80,83,81,32,79,81,83,81,85,82,85,85,83,86,79,86,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,0,77,87,79,77,79,86,32,79,77,82,77,84,78,85,80,85,83,84,85,82,86,79,86,0,77,87,79,77,79,86,32,79,77,85,77,32,79,81,83,81,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,32,79,81,83,81,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,86,82,32,83,82,86,82,0,77,87,79,77,79,86,32,85,77,85,86,32,79,81,85,81,0,80,84,82,77,82,86,0,78,85,83,77,83,84,82,86,80,86,79,84,79,83,0,77,87,79,77,79,86,32,85,77,79,83,32,81,81,85,86,0,77,86,79,77,79,86,32,79,86,85,86,0,76,88,78,77,78,86,32,78,77,82,86,32,86,77,82,86,32,86,77,86,86,0,77,87,79,77,79,86,32,79,77,85,86,32,85,77,85,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,83,84,86,87,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,32,82,82,85,86,0,77,87,85,78,83,77,81,77,79,78,79,79,80,80,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,82,77,82,86,32,78,77,86,77,0,77,88,79,77,79,83,80,85,82,86,83,86,85,85,86,83,86,77,0,77,87,78,77,82,86,32,86,77,82,86,0,76,88,78,77,80,86,32,82,77,80,86,32,82,77,84,86,32,86,77,84,86,0,77,87,79,77,85,86,32,85,77,79,86,0,77,87,78,77,82,81,82,86,32,86,77,82,81,0,77,87,85,77,79,86,32,79,77,85,77,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,0,77,87,82,77,78,86,32,82,77,86,86,32,78,86,86,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,81,81,84,82,32,84,81,81,82,0,77,87,82,77,78,86,32,82,77,86,86,0,77,87,79,77,85,77,32,80,81,84,82,32,84,81,80,82,32,79,86,85,86,0,77,87,79,77,79,86,32,85,77,85,86,32,79,77,85,77,0,77,87,79,77,82,81,79,86,32,79,77,85,77,32,79,86,85,86,0,77,87,78,79,78,78,79,77,80,77,81,78,82,80,82,86,32,86,79,86,78,85,77,84,77,83,78,82,80,0,76,88,82,77,82,86,32,80,79,78,80,78,83,80,84,84,84,86,83,86,80,84,79,80,79,0,76,88,82,77,82,86,32,78,79,79,80,79,83,81,84,83,84,85,83,85,80,86,79,0,77,88,79,86,81,86,79,82,79,80,80,78,82,77,83,77,85,78,86,80,86,82,84,86,86,86,0,77,87,83,77,77,86,32,83,77,85,86,32,79,83,84,83,0,77,87,81,77,78,86,32,81,77,84,77,86,78,86,80,83,81,80,81,32,83,81,85,82,85,84,84,85,82,86,78,86,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,0,77,88,81,77,78,86,32,81,77,85,77,86,79,86,81,85,84,84,85,82,86,78,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,32,78,86,83,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,83,82,83,0,77,88,81,77,78,86,32,87,77,84,86,32,80,81,85,81,0,80,85,84,77,81,86,0,79,86,85,77,83,83,82,85,81,86,80,86,79,85,79,84,0,77,86,81,77,78,86,32,86,77,79,83,32,82,81,84,86,0,78,86,82,77,79,86,32,79,86,84,86,0,76,89,80,77,77,86,32,80,77,81,86,32,88,77,81,86,32,88,77,85,86,0,77,88,81,77,78,86,32,81,77,84,86,32,87,77,84,86,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,32,81,86,80,85,80,84,81,83,82,83,83,84,84,86,85,87,86,87,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,32,81,82,82,85,83,86,84,86,85,85,0,77,87,86,78,84,77,82,77,80,78,80,80,81,81,84,82,85,83,85,85,83,86,80,86,78,85,0,77,86,83,77,80,86,32,80,77,86,77,0,76,88,80,77,78,83,78,85,79,86,82,86,84,85,85,83,87,77,0,77,87,79,77,81,86,32,87,77,81,86,0,75,88,78,77,78,86,32,83,77,78,86,32,83,77,83,86,32,88,77,83,86,0,78,87,81,77,84,86,32,87,77,78,86,0,78,87,81,77,83,81,81,86,32,87,77,83,81,0,77,87,81,77,87,77,78,86,84,86,0,76,88,78,77,82,86,32,86,77,82,86,32,78,77,86,77,0,77,87,78,76,86,88,0,76,88,82,79,78,85,32,82,79,86,85,0,77,87,78,86,86,86,0,80,86,82,77,85,81,0,77,87,77,77,79,75,81,75,84,77,86,77,87,75,0,78,87,81,80,84,80,85,81,85,86,32,85,82,81,83,80,84,80,85,81,86,83,86,85,85,0,77,87,79,77,79,86,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,0,77,87,85,77,85,86,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,83,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,86,0,78,86,85,78,84,77,83,77,82,78,82,86,32,80,80,84,80,0,77,87,85,80,85,86,84,88,82,89,80,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,77,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,80,84,82,76,81,77,82,78,83,77,82,76,32,82,80,82,86,0,80,85,83,76,82,77,83,78,84,77,83,76,32,83,80,83,88,82,89,81,89,80,88,0,78,87,80,77,80,86,32,85,80,80,84,32,82,83,85,86,0,75,89,77,80,77,86,32,77,83,78,81,79,80,80,80,81,81,82,83,82,86,32,82,83,83,81,84,80,85,80,86,81,87,83,87,86,0,77,87,79,80,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,77,87,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,87,79,80,79,89,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,80,85,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,78,86,80,80,80,86,32,80,83,81,81,83,80,84,80,0,78,87,85,81,84,80,81,80,80,81,80,82,81,83,84,83,85,84,85,85,84,86,81,86,80,85,0,78,86,82,77,82,85,83,86,84,86,85,85,32,80,80,84,80,0,77,87,85,80,85,86,32,79,80,79,83,80,85,82,86,84,85,85,83,0,78,86,79,80,82,86,32,85,80,82,86,0,76,88,78,80,80,86,32,82,80,80,86,32,82,80,84,86,32,86,80,84,86,0,77,87,79,80,85,86,32,85,80,79,86,0,77,87,79,80,82,86,32,85,80,82,86,81,88,80,89,79,89,0,77,87,79,80,85,80,79,86,85,86,0,77,88,86,80,85,83,84,85,82,86,80,85,79,83,80,81,82,80,84,81,85,85,86,86,0,77,87,79,84,81,86,83,86,84,85,84,83,83,82,80,81,82,81,84,80,85,79,85,78,84,77,82,77,81,78,80,80,79,84,78,89,0,77,88,78,81,79,80,81,80,82,81,82,83,81,87,32,86,80,85,82,83,84,81,87,80,89,0,77,87,84,78,83,77,82,77,81,78,81,79,82,80,84,81,85,83,84,85,82,86,80,85,79,83,80,81,82,80,0,78,87,85,81,83,80,81,80,80,81,80,82,81,83,32,83,83,81,83,80,84,80,85,81,86,83,86,85,85,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,80,83,80,85,81,86,83,87,83,88,82,89,81,89,0,76,88,78,81,79,80,80,80,81,81,81,83,80,86,32,81,83,82,81,84,80,85,80,86,81,86,83,85,86,84,89,0,76,88,78,81,79,80,80,80,81,81,81,85,82,86,83,86,84,85,85,83,86,80,86,78,85,77,84,77,83,78,83,80,84,82,85,83,87,84,0,79,86,82,80,81,83,81,85,82,86,83,86,84,85,0,77,87,81,80,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,77,87,79,77,80,77,81,78,82,80,85,86,32,82,80,79,86,0,76,89,80,80,77,89,32,85,80,84,83,83,85,81,86,80,86,79,85,79,83,32,84,83,84,85,85,86,86,86,87,85,0,77,87,78,80,79,80,79,86,32,85,80,84,83,82,85,79,86,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,81,82,82,83,84,83,32,83,83,81,84,80,85,80,86,81,87,83,88,83,89,82,90,81,90,0,77,88,79,81,81,80,86,80,32,81,80,81,82,80,86,32,84,80,84,82,85,86,0,77,87,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,78,89,0,77,88,86,80,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,88,79,81,81,80,86,80,32,83,80,82,86,0,75,88,77,81,78,80,79,80,80,81,80,85,81,86,83,86,84,85,85,83,86,80,0,77,88,80,80,79,81,79,83,80,85,82,86,83,86,85,85,86,83,86,81,85,80,84,80,83,81,82,83,81,89,0,77,87,79,80,80,80,81,81,83,88,84,89,85,89,32,85,80,84,82,80,87,79,89,0,75,89,84,77,82,89,32,77,81,78,80,79,80,80,81,80,85,81,86,84,86,85,85,86,83,87,80,0,76,88,79,80,78,82,78,84,79,86,81,86,82,84,82,82,32,85,80,86,82,86,84,85,86,83,86,82,84,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,81,77,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,86,77,84,83,84,85,85,86,86,86,0,77,87,79,83,84,83,85,82,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,79,86,86,77,85,77,84,78,83,80,81,86,80,88,79,89,78,89,32,81,80,85,80,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,84,86,83,88,82,89,80,89,79,88,0,77,86,81,77,78,86,32,79,83,80,81,81,80,83,80,84,81,84,82,83,84,83,85,84,86,85,86,0,80,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,84,82,85,83,86,84,86,0,79,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,86,81,88,80,89,79,89,78,88,0,78,86,82,77,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,79,84,83,77,81,83,81,85,82,86,83,86,0,74,89,75,80,76,80,77,81,77,83,76,86,32,77,83,78,81,79,80,81,80,82,81,82,83,81,86,32,82,83,83,81,84,80,86,80,87,81,87,82,86,84,86,85,87,86,88,86,0,77,87,78,80,79,80,80,81,80,83,79,86,32,80,83,81,81,82,80,84,80,85,81,85,82,84,84,84,85,85,86,86,86,0,77,88,78,80,79,80,80,81,80,83,78,89,32,80,83,81,85,83,86,85,85,86,83,85,81,83,80,81,81,80,83,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,83,89,0,77,86,79,80,80,80,81,81,81,83,80,86,32,85,81,84,80,83,80,82,81,81,83,0,78,86,84,81,83,80,81,80,80,81,80,82,81,83,82,83,83,84,83,85,82,86,80,86,79,85,0,78,85,83,77,81,83,81,85,82,86,83,86,32,80,80,84,80,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,84,85,85,82,85,80,0,75,89,76,80,77,80,78,81,78,82,77,84,77,85,78,86,80,86,81,85,82,83,83,80,32,82,83,82,85,83,86,85,86,86,85,87,82,87,80,0,77,87,79,81,80,80,81,80,82,81,82,85,83,86,84,86,85,85,32,86,81,85,80,84,80,83,81,81,85,80,86,79,86,78,85,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,83,86,82,88,81,89,79,89,78,88,0,78,86,85,80,79,86,32,80,81,81,80,83,80,84,81,32,80,85,81,86,83,86,84,85,0,77,87,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,81,77,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,32,79,83,83,83,0,77,87,82,77,81,78,80,80,79,83,79,86,80,87,82,87,83,86,84,84,85,81,85,78,84,77,82,77,32,80,82,84,82,0,77,87,84,77,81,89,32,82,80,80,81,79,83,80,85,82,86,83,86,85,85,86,83,85,81,83,80,82,80,0,77,87,85,81,83,80,81,80,79,81,79,83,80,84,82,85,83,86,83,87,82,88,81,88,0,75,89,84,80,84,83,85,84,86,84,87,83,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,32,84,81,83,80,81,80,80,81,80,83,81,84,83,84,84,83,0,77,87,85,78,79,82,85,86,0,77,87,79,78,85,82,79,86,0,79,85,84,75,81,75,81,89,84,89,0,79,85,80,75,83,75,83,89,80,89,0,79,85,84,75,83,76,82,78,82,79,83,81,81,82,83,83,82,85,82,86,83,88,84,89,0,79,85,80,75,81,76,82,78,82,79,81,81,83,82,81,83,82,85,82,86,81,88,80,89,0,76,89,80,77,81,78,81,79,80,80,79,80,78,79,78,78,79,77,80,77,83,78,85,78,87,77,78,86,32,85,83,84,84,84,85,85,86,86,86,87,85,87,84,86,83,85,83,0,80,84,0,78,86,0,77,87,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,0,77,87,80,79,82,77,82,86,0,77,87,79,78,81,77,83,77,85,78,85,80,84,82,79,86,85,86,0,77,87,79,78,81,77,83,77,85,78,85,80,83,81,32,82,81,83,81,85,82,85,85,83,86,81,86,79,85,0,77,87,83,77,83,86,32,83,77,78,83,86,83,0,77,87,80,77,79,81,81,80,82,80,84,81,85,83,84,85,82,86,81,86,79,85,32,80,77,84,77,0,77,87,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,77,81,86,32,79,77,85,77,0,77,87,81,77,79,78,79,80,81,81,83,81,85,80,85,78,83,77,81,77,32,81,81,79,82,79,85,81,86,83,86,85,85,85,82,83,81,0,77,87,85,80,84,82,82,83,80,82,79,80,80,78,82,77,84,78,85,80,85,83,84,85,82,86,80,86,0,80,85,82,85,82,86,83,86,83,85,82,85,0,80,85,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,80,82,81,83,81,83,80,82,80,32,82,85,82,86,83,86,83,85,82,85,0,80,85,82,80,82,81,83,81,83,80,82,80,32,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,77,82,82,32,83,77,83,82,32,82,85,82,86,83,86,83,85,82,85,0,78,87,80,78,82,77,83,77,85,78,85,80,82,81,82,82,83,82,83,81,85,80,32,82,85,82,86,83,86,83,85,82,85,0,80,84,82,77,82,81,0,78,86,80,77,80,81,32,84,77,84,81,0,78,86,81,77,80,78,80,80,81,81,83,81,84,80,84,78,83,77,81,77,0,77,87,82,75,82,88,32,85,78,83,77,81,77,79,78,79,80,81,81,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,86,76,78,88,0,79,85,84,75,82,78,81,81,81,83,82,86,84,89,0,79,85,80,75,82,78,83,81,83,83,82,86,80,89,0,80,84,82,75,82,89,0,76,88,78,82,86,82,0,76,88,82,78,82,86,32,78,82,86,82,0,76,88,78,80,86,80,32,78,84,86,84,0,77,87,79,79,85,85,32,85,79,79,85,0,77,87,82,79,82,85,32,79,80,85,84,32,85,80,79,84,0,80,85,82,81,82,82,83,82,83,81,82,81,0,80,85,83,77,82,79,82,81,83,81,83,80,82,80,0,80,85,83,78,82,78,82,77,83,77,83,79,82,81,0,76,88,83,79,86,82,83,85,32,78,82,86,82,0,77,88,81,76,81,89,32,84,76,84,89,32,79,81,86,81,32,79,84,86,84,0,76,88,86,82,85,82,84,83,83,85,82,86,79,86,78,85,78,83,79,82,82,81,83,80,83,78,82,77,80,77,79,78,79,80,81,83,83,85,85,86,86,86,0,76,88,78,78,79,81,79,83,78,86,32,86,78,85,81,85,83,86,86,32,78,78,81,79,83,79,86,78,32,78,86,81,85,83,85,86,86,0,76,89,82,81,81,80,79,80,78,81,78,83,79,84,81,84,82,83,83,81,84,80,86,80,87,81,87,83,86,84,84,84,83,83,82,81,0,72,92,78,82,77,81,76,82,77,83,78,82,32,86,82,87,81,88,82,87,83,86,82,0,72,92,77,80,76,81,76,82,77,83,78,83,79,82,79,81,78,80,77,80,32,77,81,77,82,78,82,78,81,77,81,32,87,80,86,81,86,82,87,83,88,83,89,82,89,81,88,80,87,80,32,87,81,87,82,88,82,88,81,87,81,0,73,91,75,82,89,82,0,72,92,82,85,74,80,82,84,90,80,82,85,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,89,74,87,76,86,78,86,80,87,84,90,86,91,88,91,90,90,91,87,32,73,89,74,86,76,85,78,85,80,86,84,89,86,90,88,90,90,89,91,87,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,87,91,87,32,73,91,91,91,0,67,97,71,79,93,79,88,73,32,76,91,71,85,93,85,0,68,96,70,94,94,94,94,70,70,70,70,94,0,75,89,81,86,79,85,78,83,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,32,83,86,86,83,32,81,86,86,81,32,79,85,85,79,32,78,83,83,78,32,78,81,81,78,0,72,92,73,82,91,82,0,72,92,73,82,91,82,32,73,81,91,81,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,81,91,79,92,78,94,78,97,32,84,84,85,85,86,87,85,89,84,90,32,78,96,79,95,80,95,83,96,86,96,87,95,32,80,95,83,97,86,97,87,95,87,94,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,81,74,79,75,78,77,78,80,32,84,67,85,68,86,70,85,72,84,73,32,78,79,79,78,80,78,83,79,86,79,87,78,32,80,78,83,80,86,80,87,78,87,77,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,78,67,78,71,32,86,69,82,76,80,80,32,87,67,84,73,81,80,32,78,69,80,67,82,67,85,69,32,78,69,80,68,82,68,85,69,86,69,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,70,94,89,88,87,90,85,91,82,91,80,90,77,88,75,87,73,87,72,88,72,90,73,91,75,91,77,90,79,87,80,85,82,81,84,75,87,71,89,70,90,70,91,71,92,72,91,73,90,72,91,71,91,70,90,70,89,70,87,71,86,72,84,76,82,80,80,86,78,90,77,90,32,79,80,85,80,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,78,74,78,87,32,79,74,79,87,32,76,74,83,74,86,75,87,77,87,78,86,80,83,81,79,81,32,83,74,85,75,86,77,86,78,85,80,83,81,32,76,87,81,87,32,83,81,84,82,85,86,86,87,87,87,88,86,32,83,81,85,82,86,86,87,87,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,85,75,86,74,86,78,85,75,83,74,80,74,78,75,77,76,76,79,76,82,77,85,78,86,80,87,83,87,85,86,86,84,32,80,74,78,76,77,79,77,82,78,85,80,87,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,32,75,91,89,73,0,67,97,72,81,71,82,72,83,73,82,72,81,32,82,81,81,82,82,83,83,82,82,81,32,92,81,91,82,92,83,93,82,92,81,0,69,95,78,87,76,84,73,82,76,80,78,77,32,76,80,74,82,76,84,32,74,82,90,82,32,86,87,88,84,91,82,88,80,86,77,32,88,80,90,82,88,84,0,74,90,87,78,84,76,82,73,80,76,77,78,32,80,76,82,74,84,76,32,82,74,82,90,32,87,86,84,88,82,91,80,88,77,86,32,80,88,82,90,84,88,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,83,70,83,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,81,70,81,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,79,82,90,82,0,72,92,76,66,76,91,32,82,66,82,91,32,88,66,88,91,0,73,91,82,70,74,91,32,82,70,90,91,32,77,84,87,84,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,32,75,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,75,91,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,0,71,92,75,70,75,91,32,75,70,82,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,82,91,75,91,0,72,91,76,70,76,91,32,76,70,89,70,32,76,80,84,80,32,76,91,89,91,0,72,90,76,70,76,91,32,76,70,89,70,32,76,80,84,80,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,83,32,85,83,90,83,0,71,93,75,70,75,91,32,89,70,89,91,32,75,80,89,80,0,78,86,82,70,82,91,0,74,90,86,70,86,86,85,89,84,90,82,91,80,91,78,90,77,89,76,86,76,84,0,71,92,75,70,75,91,32,89,70,75,84,32,80,79,89,91,0,72,89,76,70,76,91,32,76,91,88,91,0,70,94,74,70,74,91,32,74,70,82,91,32,90,70,82,91,32,90,70,90,91,0,71,93,75,70,75,91,32,75,70,89,91,32,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,75,81,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,83,87,89,93,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,75,80,32,82,80,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,90,82,70,82,91,32,75,70,89,70,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,0,73,91,74,70,82,91,32,90,70,82,91,0,70,94,72,70,77,91,32,82,70,77,91,32,82,70,87,91,32,92,70,87,91,0,72,92,75,70,89,91,32,89,70,75,91,0,73,91,74,70,82,80,82,91,32,90,70,82,80,0,72,92,89,70,75,91,32,75,70,89,70,32,75,91,89,91,0,72,89,76,70,76,91,32,76,70,88,70,0,73,91,82,70,74,91,32,82,70,90,91,32,74,91,90,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,79,80,85,80,0,73,91,82,70,74,91,32,82,70,90,91,0,73,91,75,70,89,70,32,79,80,85,80,32,75,91,89,91,0,71,93,75,70,75,91,32,89,70,89,91,32,75,70,89,70,0,73,91,75,70,82,80,75,91,32,75,70,89,70,32,75,91,89,91,0,73,91,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,89,75,89,73,88,71,87,70,85,70,84,71,83,73,82,77,0,72,92,82,70,82,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,84,86,87,85,88,84,89,82,89,79,88,77,87,76,84,75,80,75,0,72,92,75,70,89,91,32,75,91,89,70,0,71,93,82,70,82,91,32,73,76,74,76,75,77,76,81,77,83,78,84,81,85,83,85,86,84,87,83,88,81,89,77,90,76,91,76,0,72,92,75,91,79,91,76,84,75,80,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,80,88,84,85,91,89,91,0,71,91,71,91,73,90,76,87,79,83,83,76,86,70,86,91,85,88,83,85,81,83,78,81,76,81,75,82,75,84,76,86,78,88,81,90,84,91,89,91,0,70,93,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,88,70,90,71,91,73,91,75,90,77,89,78,87,79,84,80,32,83,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,82,91,80,90,79,88,0,72,92,84,76,84,77,85,78,87,78,89,77,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,87,86,0,71,94,84,70,82,71,81,73,80,77,79,83,78,86,77,88,75,90,73,91,71,91,70,90,70,88,71,87,73,87,75,88,77,90,80,91,83,91,86,90,88,88,90,84,91,79,91,75,90,72,89,71,87,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,92,85,0,72,92,86,74,86,75,87,76,89,76,90,75,90,73,89,71,86,70,82,70,79,71,78,73,78,76,79,78,80,79,83,80,80,80,77,81,76,82,75,84,75,87,76,89,77,90,80,91,83,91,86,90,88,88,89,86,0,72,92,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,32,81,80,90,80,0,71,94,71,91,73,90,77,86,80,81,81,78,82,74,82,71,81,70,80,70,79,71,78,73,78,76,79,78,81,79,85,79,88,78,89,77,90,75,90,81,89,86,88,88,86,90,83,91,79,91,76,90,74,88,73,86,73,84,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,72,88,76,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,73,90,87,86,85,84,83,81,82,79,81,76,81,73,82,71,83,70,85,70,86,71,87,73,87,76,86,81,84,86,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,77,85,79,86,0,74,89,84,94,82,91,80,86,79,80,79,74,80,71,82,70,84,70,85,71,86,74,86,77,85,82,82,91,80,97,79,100,78,102,76,103,75,102,75,100,76,97,78,94,80,92,83,90,87,88,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,94,73,94,71,93,70,92,70,90,71,88,73,86,76,84,78,82,79,80,79,32,82,79,83,81,83,88,84,90,85,91,86,91,88,90,89,89,91,86,0,73,92,77,82,79,82,83,81,86,79,88,77,89,75,89,72,88,70,86,70,85,71,84,73,83,78,82,83,81,86,80,88,78,90,76,91,74,91,73,90,73,88,74,87,76,87,78,88,81,90,84,91,86,91,89,90,91,88,0,64,97,69,77,67,76,66,74,66,73,67,71,69,70,70,70,72,71,73,73,73,75,72,80,71,84,69,91,32,71,84,74,76,76,72,77,71,79,70,80,70,82,71,83,73,83,75,82,80,81,84,79,91,32,81,84,84,76,86,72,87,71,89,70,90,70,92,71,93,73,93,75,92,80,90,87,90,90,91,91,92,91,94,90,95,89,97,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,80,76,84,74,91,32,76,84,79,76,81,72,82,71,84,70,86,70,88,71,89,73,89,75,88,80,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,72,93,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,86,70,84,70,82,72,82,75,83,78,85,81,87,83,90,85,92,86,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,90,70,92,71,93,72,94,74,94,77,93,79,92,80,90,81,87,81,85,80,84,79,0,72,94,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,89],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+276484);allocate([90,91,88,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,89,70,91,71,92,72,93,74,93,77,92,79,91,80,89,81,86,81,83,80,84,81,85,83,85,88,86,90,88,91,90,90,91,89,93,86,0,72,92,72,91,74,90,76,88,79,84,81,81,83,77,84,74,84,71,83,70,82,70,81,71,80,73,80,75,81,77,83,79,86,81,88,83,89,85,89,87,88,89,87,90,84,91,80,91,77,90,75,88,74,86,74,84,0,72,91,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,79,76,82,75,86,75,88,76,90,78,91,80,91,82,90,83,89,85,85,88,77,90,70,32,88,77,87,81,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,89,77,91,79,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,75,87,78,89,80,91,81,0,67,95,72,77,70,76,69,74,69,73,70,71,72,70,73,70,75,71,76,73,76,76,75,91,32,85,70,75,91,32,85,70,83,91,32,97,70,95,71,92,74,89,78,86,84,83,91,0,70,94,78,76,76,76,75,75,75,73,76,71,78,70,80,70,82,71,83,73,83,76,81,85,81,88,82,90,84,91,86,91,88,90,89,88,89,86,88,85,86,85,32,93,73,93,71,92,70,90,70,88,71,86,73,84,76,80,85,78,88,76,90,74,91,72,91,71,90,71,88,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,88,77,90,78,91,80,91,82,90,84,88,86,85,87,83,89,77,32,91,70,89,77,86,87,84,93,82,98,80,102,78,103,77,102,77,100,78,97,80,94,83,91,86,89,91,86,0,72,93,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,84,84,87,80,90,78,91,75,91,74,90,74,88,75,87,78,87,80,88,81,89,82,91,82,94,81,97,80,99,78,102,76,103,75,102,75,100,76,97,78,94,81,91,84,89,90,86,0,73,91,74,70,82,91,32,90,70,82,91,32,74,70,90,70,0,71,93,73,76,91,98,0,69,95,82,74,73,90,32,82,74,91,90,0,73,91,74,91,90,91,0,73,91,74,91,90,91,90,90,74,90,74,91,0,73,92,88,77,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,72,91,76,70,76,91,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,88,70,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,77,89,87,70,85,70,83,71,82,74,82,91,32,79,77,86,77,0,73,92,88,77,88,93,87,96,86,97,84,98,81,98,79,97,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,78,86,81,70,82,71,83,70,82,69,81,70,32,82,77,82,91,0,77,87,82,70,83,71,84,70,83,69,82,70,32,83,77,83,94,82,97,80,98,78,98,0,73,90,77,70,77,91,32,87,77,77,87,32,81,83,88,91,0,67,97,71,77,71,91,32,71,81,74,78,76,77,79,77,81,78,82,81,82,91,32,82,81,85,78,87,77,90,77,92,78,93,81,93,91,0,73,92,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,0,72,91,76,77,76,98,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,92,88,77,88,98,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,75,88,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,89,82,70,82,87,83,90,85,91,87,91,32,79,77,86,77,0,73,92,77,77,77,87,78,90,80,91,83,91,85,90,88,87,32,88,77,88,91,0,74,90,76,77,82,91,32,88,77,82,91,0,71,93,74,77,78,91,32,82,77,78,91,32,82,77,86,91,32,90,77,86,91,0,74,91,77,77,88,91,32,88,77,77,91,0,74,90,76,77,82,91,32,88,77,82,91,80,95,78,97,76,98,75,98,0,74,91,88,77,77,91,32,77,77,88,77,32,77,91,88,91,0,72,93,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,83,77,84,78,85,80,87,88,88,90,89,91,90,91,0,73,92,85,70,83,71,81,73,79,77,78,80,77,84,76,90,75,98,32,85,70,87,70,89,72,89,75,88,77,87,78,85,79,82,79,32,82,79,84,80,86,82,87,84,87,87,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,73,92,74,80,76,78,78,77,79,77,81,78,82,79,83,82,83,86,82,91,32,90,77,89,80,88,82,82,91,80,95,79,98,0,73,91,84,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,84,77,82,75,81,73,81,71,82,70,84,70,86,71,88,73,0,74,90,87,79,86,78,84,77,81,77,79,78,79,80,80,82,83,83,32,83,83,79,84,77,86,77,88,78,90,80,91,83,91,85,90,87,88,0,74,89,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,88,75,84,77,81,79,78,82,77,85,77,87,78,89,80,91,83,93,84,95,84,97,83,98,81,98,80,96,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,78,84,76,91,32,78,84,80,80,82,78,84,77,86,77,88,79,88,82,87,87,84,98,0,71,92,72,81,73,79,75,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,74,87,71,85,70,83,70,82,72,82,74,83,77,85,80,87,82,90,84,0,76,87,82,77,80,84,79,88,79,90,80,91,82,91,84,89,85,87,0,73,91,79,77,75,91,32,89,78,88,77,87,77,85,78,81,82,79,83,78,83,32,78,83,80,84,81,85,83,90,84,91,85,91,86,90,0,74,90,75,70,77,70,79,71,80,72,88,91,32,82,77,76,91,0,72,93,79,77,73,98,32,78,81,77,86,77,89,79,91,81,91,83,90,85,88,87,84,32,89,77,87,84,86,88,86,90,87,91,89,91,91,89,92,87,0,73,91,76,77,79,77,78,83,77,88,76,91,32,89,77,88,80,87,82,85,85,82,88,79,90,76,91,0,74,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,82,76,80,77,79,79,79,81,81,83,84,84,86,84,32,84,84,80,85,78,86,77,88,77,90,79,92,83,94,84,95,84,97,82,98,80,98,0,74,91,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,0,71,93,80,77,76,91,32,85,77,86,83,87,88,88,91,32,73,80,75,78,78,77,91,77,0,73,91,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,80,78,78,80,77,83,73,98,0,73,93,91,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,85,78,83,77,0,72,92,83,77,80,91,32,74,80,76,78,79,77,90,77,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,77,86,77,89,79,91,81,91,84,90,86,88,88,84,89,80,89,77,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,0,73,91,75,77,77,77,79,79,85,96,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,86,70,78,98,32,71,81,72,79,74,77,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,84,90,86,88,88,85,90,80,91,77,0,70,93,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,32,82,83,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,84,78,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,89,87,91,86,0,77,88,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,90,70,32,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,78,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,85,78,88,79,90,81,91,83,91,85,90,86,89,88,86,0,79,87,79,86,83,81,85,78,86,76,87,73,87,71,86,70,84,71,83,73,81,81,78,90,75,97,74,100,74,102,75,103,77,102,78,99,79,90,80,91,82,91,84,90,85,89,87,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,32,86,82,84,89,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,77,92,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,80,88,80,90,81,91,82,91,84,90,85,89,87,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,76,100,75,102,73,103,72,102,72,100,73,97,76,94,79,92,81,91,84,89,87,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,84,86,81,86,32,81,86,83,87,84,90,85,91,86,91,88,90,89,89,91,86,0,79,87,79,86,81,83,84,78,85,76,86,73,86,71,85,70,83,71,82,73,81,77,80,84,80,90,81,91,82,91,84,90,85,89,87,86,0,69,94,69,86,71,83,73,82,74,83,74,84,73,88,72,91,32,73,88,74,86,76,83,78,82,80,82,81,83,81,84,80,88,79,91,32,80,88,81,86,83,83,85,82,87,82,88,83,88,85,87,88,87,90,88,91,89,91,91,90,92,89,94,86,0,74,92,74,86,76,83,78,82,79,83,79,84,78,88,77,91,32,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,76,90,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,87,88,89,87,90,86,0,75,90,75,86,77,83,78,81,77,85,71,103,32,77,85,78,83,80,82,82,82,84,83,85,85,85,87,84,89,83,90,81,91,32,77,90,79,91,82,91,85,90,87,89,90,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,86,82,85,85,83,90,80,97,79,100,79,102,80,103,82,102,83,99,83,92,85,91,88,89,91,86,0,77,90,77,86,79,83,80,81,80,83,83,83,84,84,84,86,83,89,83,90,84,91,85,91,87,90,88,89,90,86,0,78,89,78,86,80,83,81,81,81,83,83,86,84,88,84,90,82,91,32,78,90,80,91,84,91,86,90,87,89,89,86,0,79,88,79,86,81,83,83,79,32,86,70,80,88,80,90,81,91,83,91,85,90,86,89,88,86,32,80,78,87,78,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,84,88,84,90,85,91,86,91,88,90,89,89,91,86,0,76,91,76,86,78,82,77,87,77,90,78,91,79,91,82,90,84,88,85,85,85,82,32,85,82,86,86,87,87,89,87,91,86,0,73,94,76,82,74,84,73,87,73,89,74,91,76,91,78,90,80,88,32,82,82,80,88,80,90,81,91,83,91,85,90,87,88,88,85,88,82,32,88,82,89,86,90,87,92,87,94,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,90,82,91,85,91,88,89,90,86,32,87,83,86,82,84,82,83,83,79,90,78,91,76,91,75,90,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,76,90,76,86,78,83,80,82,82,82,84,84,84,86,83,88,81,90,78,91,80,92,81,94,81,97,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,87,89,90,86,0,74,92,75,91,78,90,81,88,83,86,85,83,87,79,88,75,88,73,87,71,85,70,83,71,82,72,81,74,80,79,80,84,81,88,82,90,84,91,86,91,88,90,89,89,0,73,91,87,85,87,82,86,79,85,78,83,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,88,80,88,75,87,72,86,71,84,70,82,70,80,71,78,73,0,74,90,87,78,85,77,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,84,91,86,90,32,77,84,85,84,0,74,91,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,84,70,32,78,80,87,80,0,72,92,86,70,78,98,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,82,88,80,86,78,83,77,81,77,0,73,91,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,84,92,84,94,83,95,81,95,0,68,97,87,78,86,76,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,86,85,87,83,32,87,75,87,83,88,85,89,86,91,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,0,70,94,90,73,74,82,90,91,0,70,94,74,73,90,82,74,91,0,75,89,79,66,79,98,32,79,66,86,66,32,79,98,86,98,0,75,89,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,75,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,0,75,89,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,0,74,90,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,0,72,92,78,74,80,73,83,70,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,75,91,89,91,0,72,92,77,70,88,70,82,78,85,78,87,79,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,85,70,75,84,90,84,32,85,70,85,91,0,72,92,87,70,77,70,76,79,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,0,72,92,89,70,79,91,32,75,70,89,70,0,72,92,80,70,77,71,76,73,76,75,77,77,79,78,83,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,81,79,85,78,87,77,88,75,88,73,87,71,84,70,80,70,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,0,77,87,82,89,81,90,82,91,83,90,82,89,0,77,87,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,89,81,90,82,91,83,90,82,89,0,77,87,82,77,81,78,82,79,83,78,82,77,32,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,82,84,32,82,89,81,90,82,91,83,90,82,89,0,73,91,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,82,77,0,74,90,78,70,78,77,32,86,70,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,0,72,92,80,66,80,95,32,84,66,84,95,32,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,71,93,91,66,73,98,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,0,78,86,82,66,82,98,0,69,95,73,82,91,82,0,69,95,82,73,82,91,32,73,82,91,82,0,69,95,73,79,91,79,32,73,85,91,85,0,71,93,75,75,89,89,32,89,75,75,89,0,74,90,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,77,87,82,81,81,82,82,83,83,82,82,81,0,77,87,83,70,82,71,81,73,81,75,82,76,83,75,82,74,0,77,87,82,72,81,71,82,70,83,71,83,73,82,75,81,76,0,69,95,85,77,88,80,91,82,88,84,85,87,32,73,82,91,82,0,71,93,79,70,79,98,32,85,70,85,98,32,74,81,90,81,32,74,87,90,87,0,69,95,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,89,72,87,72,85,73,83,74,82,81,78,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,89,91,91,91,92,90,92,89,0,71,93,73,73,74,75,75,79,75,85,74,89,73,91,32,91,73,90,75,89,79,89,85,90,89,91,91,32,73,73,75,74,79,75,85,75,89,74,91,73,32,73,91,75,90,79,89,85,89,89,90,91,91,0,70,95,92,81,91,79,89,78,87,78,85,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,85,85,87,86,89,86,91,85,92,83,92,81,0,75,89,79,66,79,91,32,85,66,85,91,0,70,94,82,66,82,91,32,73,91,91,91,0,70,94,91,66,73,91,91,91,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,89,72,90,73,91,74,90,73,89,32,91,89,90,90,91,91,92,90,91,89,0,70,94,82,72,78,76,75,80,74,83,74,85,75,87,77,88,79,88,81,87,82,85,32,82,72,86,76,89,80,90,83,90,85,89,87,87,88,85,88,83,87,82,85,32,82,85,81,89,80,92,32,82,85,83,89,84,92,32,80,92,84,92,0,70,94,82,78,81,75,80,73,78,72,77,72,75,73,74,75,74,79,75,82,76,84,78,87,82,92,32,82,78,83,75,84,73,86,72,87,72,89,73,90,75,90,79,89,82,88,84,86,87,82,92,0,70,94,82,71,80,74,76,79,73,82,32,82,71,84,74,88,79,91,82,32,73,82,76,85,80,90,82,93,32,91,82,88,85,84,90,82,93,0,70,94,82,84,84,87,86,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,83,81,32,83,81,85,79,86,77,86,75,85,73,83,72,81,72,79,73,78,75,78,77,79,79,81,81,32,81,81,78,80,76,80,74,81,73,83,73,85,74,87,76,88,78,88,80,87,82,84,32,82,84,81,89,80,92,32,82,84,83,89,84,92,32,80,92,84,92,0,70,94,82,82,82,91,81,92,32,82,86,81,92,32,82,73,81,72,79,72,78,73,78,75,79,78,82,82,32,82,73,83,72,85,72,86,73,86,75,85,78,82,82,32,82,82,78,79,76,78,74,78,73,79,73,81,74,82,32,82,82,86,79,88,78,90,78,91,79,91,81,90,82,32,82,82,78,85,76,86,74,86,73,85,73,83,74,82,32,82,82,86,85,88,86,90,86,91,85,91,83,90,82,0,70,94,73,83,74,83,76,84,77,86,77,88,76,90,32,73,83,73,82,74,81,76,81,77,82,78,84,78,87,77,89,76,90,32,82,71,80,73,79,76,79,79,81,85,81,88,80,90,82,92,32,82,71,84,73,85,76,85,79,83,85,83,88,84,90,82,92,32,91,83,91,82,90,81,88,81,87,82,86,84,86,87,87,89,88,90,32,91,83,90,83,88,84,87,86,87,88,88,90,32,75,86,89,86,0,80,83,83,82,82,83,81,83,80,82,80,81,81,80,82,80,83,81,83,83,82,85,81,86,32,81,81,81,82,82,82,82,81,81,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,78,86,80,79,84,85,32,84,79,80,85,32,78,82,86,82,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,32,82,77,79,81,32,82,77,85,81,32,82,79,80,81,32,82,79,84,81,32,81,81,83,81,32,77,82,87,82,0,77,87,77,82,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,82,32,80,78,84,78,32,79,79,85,79,32,78,80,86,80,32,78,81,86,81,32,77,82,87,82,0,76,82,76,70,76,82,82,82,76,70,32,76,73,80,81,32,76,76,79,82,32,76,79,77,81,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,0,77,87,87,82,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,82,0,71,93,93,82,93,80,92,77,90,74,87,72,84,71,80,71,77,72,74,74,72,77,71,80,71,82,0,77,87,77,82,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,82,0,76,88,76,80,78,82,81,83,83,83,86,82,88,80,0,82,85,82,85,84,84,85,82,84,80,82,79,0,82,86,82,82,85,80,86,78,86,76,85,75,84,75,0,78,82,82,82,79,80,78,78,78,76,79,75,80,75,0,77,87,87,72,86,71,84,70,81,70,79,71,78,72,77,74,77,76,78,78,79,79,85,83,86,84,87,86,87,88,86,90,85,91,83,92,80,92,78,91,77,90,0,71,93,73,87,72,86,71,84,71,81,72,79,73,78,75,77,77,77,79,78,80,79,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,80,92,78,91,77,0,71,93,82,82,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,81,92,79,91,78,89,77,87,77,85,78,84,79,80,85,79,86,77,87,75,87,73,86,72,85,71,83,71,81,72,79,73,78,75,77,77,77,79,78,80,79,82,82,0,72,92,75,70,75,91,32,72,70,91,70,81,80,91,90,32,90,86,91,89,92,91,32,90,86,90,89,32,87,89,90,89,32,87,89,90,90,92,91,0,75,89,85,65,82,66,80,67,78,69,76,72,75,76,75,82,76,85,78,87,81,88,83,88,86,87,88,85,89,82,32,75,80,76,77,78,75,81,74,83,74,86,75,88,77,89,80,89,86,88,90,86,93,84,95,82,96,79,97,0,62,102,62,82,102,82,0,68,96,68,96,96,68,0,82,82,82,62,82,102,0,68,96,68,68,96,96,0,68,96,68,82,96,82,0,70,94,70,89,94,75,0,75,89,75,94,89,70,0,75,89,75,70,89,94,0,70,94,70,75,94,89,0,75,89,75,82,89,82,0,77,87,77,87,87,77,0,77,87,77,77,87,87,0,68,96,68,79,71,81,75,83,80,84,84,84,89,83,93,81,96,79,0,80,85,85,68,83,71,81,75,80,80,80,84,81,89,83,93,85,96,0,79,84,79,68,81,71,83,75,84,80,84,84,83,89,81,93,79,96,0,68,96,68,85,71,83,75,81,80,80,84,80,89,81,93,83,96,85,0,75,89,82,74,89,78,75,86,82,90,0,74,90,74,82,78,75,86,89,90,82,0,75,89,75,86,75,78,89,86,89,78,0,74,90,76,88,74,80,90,84,88,76,0,74,90,74,93,76,93,79,92,81,91,84,88,85,86,86,83,86,79,85,76,84,74,83,73,81,73,80,74,79,76,78,79,78,83,79,86,80,88,83,91,85,92,88,93,90,93,0,73,93,93,90,93,88,92,85,91,83,88,80,86,79,83,78,79,78,76,79,74,80,73,81,73,83,74,84,76,85,79,86,83,86,86,85,88,84,91,81,92,79,93,76,93,74,0,74,90,90,71,88,71,85,72,83,73,80,76,79,78,78,81,78,85,79,88,80,90,81,91,83,91,84,90,85,88,86,85,86,81,85,78,84,76,81,73,79,72,76,71,74,71,0,71,91,71,74,71,76,72,79,73,81,76,84,78,85,81,86,85,86,88,85,90,84,91,83,91,81,90,80,88,79,85,78,81,78,78,79,76,80,73,83,72,85,71,88,71,90,0,69,91,69,80,70,82,72,84,74,85,77,86,81,86,85,85,88,83,90,80,91,78,90,76,87,76,83,77,81,78,78,80,76,83,75,86,75,89,76,92,77,94,0,69,89,69,84,72,86,75,87,80,87,83,86,86,84,88,81,89,78,89,76,88,75,86,75,83,76,80,78,78,81,77,84,77,89,78,92,80,95,0,79,85,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,68,96,68,82,74,82,32,79,82,85,82,32,90,82,96,82,0,68,96,68,85,68,79,96,79,96,85,0,74,90,82,68,74,82,32,82,68,90,82,0,68,96,68,82,96,82,32,74,89,90,89,32,80,96,84,96,0,68,96,68,82,96,82,32,68,82,82,98,32,96,82,82,98,0,75,89,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,76,88,76,76,76,88,88,88,88,76,76,76,0,75,89,82,74,75,86,89,86,82,74,0,76,88,82,72,76,82,82,92,88,82,82,72,0,74,90,82,73,80,79,74,79,79,83,77,89,82,85,87,89,85,83,90,79,84,79,82,73,0,75,89,82,75,82,89,32,75,82,89,82,0,77,87,77,77,87,87,32,87,77,77,87,0,77,87,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,32,79,81,79,83,32,80,80,80,84,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,80,84,84,32,85,81,85,83,0,78,86,78,78,78,86,86,86,86,78,78,78,32,79,79,79,85,32,80,79,80,85,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,79,84,85,32,85,79,85,85,0,77,87,82,76,77,85,87,85,82,76,32,82,79,79,84,32,82,79,85,84,32,82,82,81,84,32,82,82,83,84,0,76,85,76,82,85,87,85,77,76,82,32,79,82,84,85,32,79,82,84,79,32,82,82,84,83,32,82,82,84,81,0,77,87,82,88,87,79,77,79,82,88,32,82,85,85,80,32,82,85,79,80,32,82,82,83,80,32,82,82,81,80,0,79,88,88,82,79,77,79,87,88,82,32,85,82,80,79,32,85,82,80,85,32,82,82,80,81,32,82,82,80,83,0,76,88,82,76,78,87,88,80,76,80,86,87,82,76,32,82,82,82,76,32,82,82,76,80,32,82,82,78,87,32,82,82,86,87,32,82,82,88,80,0,77,87,82,76,82,88,32,79,79,85,79,32,77,85,79,87,81,88,83,88,85,87,87,85,0,76,88,82,76,82,88,32,76,81,77,79,87,79,88,81,32,80,87,84,87,0,75,89,77,78,87,88,32,87,78,77,88,32,79,76,76,79,75,81,32,85,76,88,79,89,81,0,73,91,78,73,73,91,32,86,73,91,91,32,77,77,91,91,32,87,77,73,91,32,78,73,86,73,32,77,77,87,77,0,73,91,82,71,82,86,32,77,74,87,80,32,87,74,77,80,32,73,86,76,92,32,91,86,88,92,32,73,86,91,86,32,76,92,88,92,0,71,91,77,74,83,86,32,75,80,83,76,32,71,92,91,92,91,82,71,92,0,76,88,80,76,80,80,76,80,76,84,80,84,80,88,84,88,84,84,88,84,88,80,84,80,84,76,80,76,0,75,89,89,80,88,78,86,76,83,75,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,84,32,89,80,87,78,85,77,83,77,81,78,80,79,79,81,79,83,80,85,81,86,83,87,85,87,87,86,89,84,0,75,89,82,74,75,86,89,86,82,74,32,82,90,89,78,75,78,82,90,0,71,93,80,73,80,71,81,70,83,70,84,71,84,73,32,71,90,72,88,74,86,75,84,76,80,76,75,77,74,79,73,85,73,87,74,88,75,88,80,89,84,90,86,92,88,93,90,32,71,90,93,90,32,81,90,80,91,81,92,83,92,84,91,83,90,0,74,90,82,77,82,83,32,82,83,81,92,32,82,83,83,92,32,81,92,83,92,32,82,77,81,74,80,72,78,71,32,81,74,78,71,32,82,77,83,74,84,72,86,71,32,83,74,86,71,32,82,77,78,75,76,75,74,77,32,80,76,76,76,74,77,32,82,77,86,75,88,75,90,77,32,84,76,88,76,90,77,32,82,77,80,78,79,79,79,82,32,82,77,80,79,79,82,32,82,77,84,78,85,79,85,82,32,82,77,84,79,85,82,0,74,90,82,73,82,75,32,82,78,82,80,32,82,83,82,85,32,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,71,81,73,80,74,32,82,71,83,73,84,74,32,80,74,82,73,84,74,32,82,75,80,78,78,79,77,78,32,82,75,84,78,86,79,87,78,32,78,79,80,79,82,78,84,79,86,79,32,82,80,80,83,78,84,76,84,75,82,75,83,76,84,32,82,80,84,83,86,84,88,84,89,82,89,83,88,84,32,78,84,80,84,82,83,84,84,86,84,32,82,85,80,88,79,89,77,90,76,90,75,89,74,87,74,89,76,90,32,82,85,84,88,85,89,87,90,88,90,89,89,90,87,90,89,88,90,32,77,90,79,90,82,89,85,90,87,90,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,85,90,88,90,90,88,90,85,89,84,87,84,89,82,90,79,89,77,87,76,85,77,86,74,85,72,83,71,81,71,79,72,78,74,79,77,77,76,75,77,74,79,75,82,77,84,75,84,74,85,74,88,76,90,79,90,82,89,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,86,88,86,86,88,85,88,82,90,81,90,76,89,73,88,72,86,72,84,71,80,71,78,72,76,72,75,73,74,76,74,81,76,82,76,85,78,86,78,88,82,89,0,73,91,73,80,75,82,32,76,75,78,80,32,82,71,82,79,32,88,75,86,80,32,91,80,89,82,0,81,83,82,81,81,82,82,83,83,82,82,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,77,87,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,0,71,93,80,71,77,72,74,74,72,77,71,80,71,84,72,87,74,90,77,92,80,93,84,93,87,92,90,90,92,87,93,84,93,80,92,77,90,74,87,72,84,71,80,71,0,65,99,80,65,76,66,74,67,71,69,69,71,67,74,66,76,65,80,65,84,66,88,67,90,69,93,71,95,74,97,76,98,80,99,84,99,88,98,90,97,93,95,95,93,97,90,98,88,99,84,99,80,98,76,97,74,95,71,93,69,90,67,88,66,84,65,80,65,0,60,104,80,60,75,61,71,63,68,65,65,68,63,71,61,75,60,80,60,84,61,89,63,93,65,96,68,99,71,101,75,103,80,104,84,104,89,103,93,101,96,99,99,96,101,93,103,89,104,84,104,80,103,75,101,71,99,68,96,65,93,63,89,61,84,60,80,60,0,41,123,79,41,73,42,69,43,64,45,59,48,55,51,51,55,48,59,45,64,43,69,42,73,41,79,41,85,42,91,43,95,45,100,48,105,51,109,55,113,59,116,64,119,69,121,73,122,79,123,85,123,91,122,95,121,100,119,105,116,109,113,113,109,116,105,119,100,121,95,122,91,123,85,123,79,122,73,121,69,119,64,116,59,113,55,109,51,105,48,100,45,95,43,91,42,85,41,79,41,0,62,102,82,65,80,67,77,68,74,68,71,67,69,65,62,72,64,74,65,77,65,90,66,93,68,95,71,96,77,96,80,97,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,102,72,100,74,99,77,99,90,98,93,96,95,93,96,87,96,84,97,82,99,0,65,99,82,65,80,67,77,68,74,68,71,67,69,65,66,71,65,75,65,80,66,84,68,88,71,92,76,96,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,98,71,99,75,99,80,98,84,96,88,93,92,88,96,82,99,32,66,72,98,72,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,76,98,88,70,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,79,84,84,84,32,75,88,80,88,32,84,88,89,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,86,80,83,81,32,83,75,85,76,86,78,85,80,83,81,32,79,81,83,81,86,82,87,84,87,85,86,87,83,88,76,88,32,83,81,85,82,86,84,86,85,85,87,83,88,0,75,89,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,85,32,81,75,79,77,78,80,78,83,79,86,81,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,77,88,80,88,83,87,86,86,87,83,88,76,88,32,83,75,85,76,86,77,87,80,87,83,86,86,85,87,83,88,0,74,89,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,86,88,86,84,85,88,0,74,88,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,81,88,0,75,91,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,85,87,86,85,32,86,83,86,88,32,87,83,87,88,32,84,83,89,83,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,81,75,32,84,75,89,75,32,79,81,86,81,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,85,75,32,80,88,85,88,0,76,88,83,75,83,85,82,87,81,88,32,84,75,84,85,83,87,81,88,80,88,78,87,77,85,78,84,79,85,78,86,32,81,75,86,75,0,74,90,78,75,78,88,32,79,75,79,88,32,87,75,79,83,32,81,81,86,88,32,82,81,87,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,82,75,32,77,88,87,88,87,84,86,88,0,73,92,77,75,77,88,32,78,78,82,88,32,78,75,82,85,32,87,75,82,88,32,87,75,87,88,32,88,75,88,88,32,75,75,78,75,32,87,75,90,75,32,75,88,79,88,32,85,88,90,88,0,74,90,78,75,78,88,32,79,77,86,88,32,79,75,86,86,32,86,75,86,88,32,76,75,79,75,32,84,75,88,75,32,76,88,80,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,80,87,80,85,81,84,83,84,84,85,85,90,86,91,87,91,88,90,32,84,85,85,88,86,90,87,91,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,32,83,82,84,83,85,87,86,88,87,88,88,87,32,83,82,85,83,86,87,87,88,0,75,90,86,77,87,75,87,79,86,77,85,76,83,75,81,75,79,76,78,77,78,79,79,80,81,81,84,82,86,83,87,84,32,78,78,79,79,81,80,84,81,86,82,87,83,87,86,86,87,84,88,82,88,80,87,79,86,78,84,78,88,79,86,0,75,90,82,75,82,88,32,83,75,83,88,32,78,75,77,79,77,75,88,75,88,79,87,75,32,80,88,85,88,0,74,91,78,75,78,85,79,87,81,88,84,88,86,87,87,85,87,75,32,79,75,79,85,80,87,81,88,32,76,75,81,75,32,85,75,89,75,0,75,89,77,75,82,88,32,78,75,82,85,32,87,75,82,88,32,75,75,80,75,32,84,75,89,75,0,73,91,76,75,79,88,32,77,75,79,84,32,82,75,79,88,32,82,75,85,88,32,83,75,85,84,32,88,75,85,88,32,74,75,79,75,32,86,75,90,75,0,75,90,78,75,86,88,32,79,75,87,88,32,87,75,78,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,76,89,78,75,82,82,82,88,32,79,75,83,82,32,87,75,83,82,83,88,32,76,75,81,75,32,84,75,89,75,32,80,88,85,88,0,76,89,86,75,78,88,32,87,75,79,88,32,79,75,78,79,78,75,87,75,32,78,88,87,88,87,84,86,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,87,75,87,79,86,75,32,77,88,82,88,0,75,89,82,75,76,88,32,82,77,87,88,32,82,75,88,88,32,77,87,86,87,32,76,88,88,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,81,79,81,84,32,84,79,84,84,32,81,81,84,81,32,81,82,84,82,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,75,88,80,88,32,84,88,89,88,0,74,90,77,74,76,77,32,88,74,87,77,32,80,80,79,83,32,85,80,84,83,32,77,86,76,89,32,88,86,87,89,32,77,75,87,75,32,77,76,87,76,32,80,81,84,81,32,80,82,84,82,32,77,87,87,87,32,77,88,87,88,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,91,77,75,82,81,32,78,75,83,81,77,88,32,77,75,87,75,88,79,86,75,32,78,87,87,87,32,77,88,87,88,88,84,86,88,0,75,90,77,79,78,76,79,75,80,75,81,76,82,79,82,88,32,88,79,87,76,86,75,85,75,84,76,83,79,83,88,32,77,79,78,77,79,76,80,76,81,77,82,79,32,88,79,87,77,86,76,85,76,84,77,83,79,32,80,88,85,88,0,75,90,82,75,82,88,32,83,75,83,88,32,81,78,78,79,77,81,77,82,78,84,81,85,84,85,87,84,88,82,88,81,87,79,84,78,81,78,32,81,78,79,79,78,81,78,82,79,84,81,85,32,84,85,86,84,87,82,87,81,86,79,84,78,32,80,75,85,75,32,80,88,85,88,0,74,91,82,75,82,88,32,83,75,83,88,32,76,80,77,79,78,79,79,83,81,85,32,84,85,86,83,87,79,88,79,89,80,32,77,79,78,82,79,84,81,85,84,85,86,84,87,82,88,79,32,80,75,85,75,32,80,88,85,88,0,75,90,77,86,78,88,81,88,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,84,88,87,88,88,86,32,79,85,78,82,78,79,79,77,81,75,32,84,75,86,77,87,79,87,82,86,85,32,78,87,80,87,32,85,87,87,87,0,75,89,84,75,75,88,32,83,77,84,88,32,84,75,85,88,32,78,84,84,84,32,73,88,78,88,32,82,88,87,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,87,78,86,80,83,81,32,85,75,86,76,86,78,85,80,83,81,32,79,81,82,81,84,82,85,83,85,85,84,87,81,88,74,88,32,82,81,84,83,84,85,83,87,81,88,0,75,88,86,76,87,76,88,75,87,78],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+286724);allocate([86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,82,75,80,77,79,79,78,82,78,86,80,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,84,75,86,76,87,78,87,81,86,84,85,86,84,87,81,88,74,88,32,84,75,85,76,86,78,86,81,85,84,84,86,83,87,81,88,0,74,89,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,84,88,85,85,83,88,0,74,88,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,79,88,0,75,89,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,83,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,83,32,83,83,88,83,0,74,91,80,75,76,88,32,81,75,77,88,32,88,75,84,88,32,89,75,85,88,32,78,75,83,75,32,86,75,91,75,32,79,81,86,81,32,74,88,79,88,32,82,88,87,88,0,78,87,84,75,80,88,32,85,75,81,88,32,82,75,87,75,32,78,88,83,88,0,76,88,85,75,82,85,81,87,80,88,32,86,75,83,85,82,87,80,88,79,88,77,87,76,85,77,84,78,85,77,86,32,83,75,88,75,0,74,90,80,75,76,88,32,81,75,77,88,32,89,75,79,82,32,82,80,84,88,32,83,80,85,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,75,88,81,75,77,88,32,82,75,78,88,32,79,75,84,75,32,75,88,85,88,86,85,84,88,0,73,92,79,75,75,88,32,79,77,80,88,32,80,75,81,86,32,89,75,80,88,32,89,75,85,88,32,90,75,86,88,32,77,75,80,75,32,89,75,92,75,32,73,88,77,88,32,83,88,88,88,0,74,90,80,75,76,88,32,80,75,84,88,32,81,75,84,85,32,88,75,84,88,32,78,75,81,75,32,86,75,90,75,32,74,88,78,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,74,88,79,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,32,79,87,79,86,80,85,81,85,82,86,82,90,83,91,84,91,85,90,32,82,86,83,90,84,91,0,74,90,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,83,82,84,87,85,88,86,88,87,87,32,83,82,84,83,85,87,86,88,32,74,88,79,88,0,75,90,87,76,88,76,89,75,88,78,87,76,85,75,82,75,80,76,79,77,79,79,80,80,85,83,86,84,32,79,78,80,79,85,82,86,83,86,86,85,87,83,88,80,88,78,87,77,85,76,88,77,87,78,87,0,75,90,84,75,80,88,32,85,75,81,88,32,80,75,78,78,79,75,90,75,89,78,89,75,32,78,88,83,88,0,74,91,80,75,77,85,77,87,79,88,83,88,85,87,86,85,89,75,32,81,75,78,85,78,87,79,88,32,78,75,83,75,32,87,75,91,75,0,75,89,79,75,80,88,32,80,75,81,86,32,89,75,80,88,32,77,75,82,75,32,86,75,91,75,0,73,91,78,75,77,88,32,79,75,78,86,32,84,75,77,88,32,84,75,83,88,32,85,75,84,86,32,90,75,83,88,32,76,75,81,75,32,88,75,92,75,0,75,90,80,75,84,88,32,81,75,85,88,32,89,75,76,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,76,89,80,75,82,81,80,88,32,81,75,83,81,32,89,75,83,81,81,88,32,78,75,83,75,32,86,75,91,75,32,78,88,83,88,0,76,89,88,75,76,88,32,89,75,77,88,32,81,75,79,78,80,75,89,75,32,76,88,85,88,86,85,84,88,0,75,90,77,72,88,92,0,74,90,82,77,76,87,32,82,77,88,87,0,76,90,81,79,80,80,80,81,79,81,79,80,81,79,84,79,86,81,86,87,87,88,88,88,32,84,79,85,81,85,87,87,88,32,85,82,82,83,80,84,79,85,79,87,80,88,83,88,84,87,85,85,32,82,83,80,85,80,87,81,88,0,74,89,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,75,79,75,0,76,88,86,81,85,81,85,82,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,91,86,75,86,88,32,87,75,87,88,32,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,85,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,75,87,75,32,86,88,89,88,0,76,88,79,83,86,83,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,85,83,85,81,83,79,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,87,84,75,85,76,85,77,86,77,86,76,84,75,82,75,80,77,80,88,32,82,75,81,77,81,88,32,78,79,83,79,32,78,88,83,88,0,76,89,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,79,80,81,80,83,81,85,32,83,85,84,83,84,81,83,79,32,84,80,85,79,86,79,32,80,84,79,85,79,88,80,89,84,89,86,90,32,79,87,80,88,84,88,86,89,86,91,84,92,80,92,78,91,78,89,80,88,0,74,91,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,75,79,75,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,76,83,76,83,75,82,75,32,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,78,87,83,75,83,76,84,76,84,75,83,75,32,83,79,83,90,82,92,32,84,79,84,90,82,92,80,92,79,91,79,90,80,90,80,91,79,91,32,81,79,84,79,0,74,90,78,75,78,88,32,79,75,79,88,32,87,79,79,85,32,82,83,86,88,32,83,83,87,88,32,76,75,79,75,32,84,79,89,79,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,83,75,32,80,88,85,88,0,70,95,74,79,74,88,32,75,79,75,88,32,75,82,76,80,78,79,80,79,82,80,83,82,83,88,32,80,79,81,80,82,82,82,88,32,83,82,84,80,86,79,88,79,90,80,91,82,91,88,32,88,79,89,80,90,82,90,88,32,72,79,75,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,74,91,78,79,78,88,32,79,79,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,79,79,79,32,76,88,81,88,32,84,88,89,88,0,76,89,81,79,79,80,78,82,78,85,79,87,81,88,84,88,86,87,87,85,87,82,86,80,84,79,81,79,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,88,85,87,86,85,86,82,85,80,84,79,0,74,89,78,79,78,92,32,79,79,79,92,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,79,79,79,32,76,92,81,92,0,75,89,85,79,85,92,32,86,79,86,92,32,85,82,84,80,82,79,80,79,78,80,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,80,79,79,80,78,82,78,85,79,87,80,88,32,83,92,88,92,0,75,88,79,79,79,88,32,80,79,80,88,32,80,82,81,80,83,79,85,79,86,80,86,81,85,81,85,80,86,80,32,77,79,80,79,32,77,88,82,88,0,76,89,84,79,85,80,85,81,86,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,79,86,80,86,80,87,81,88,0,76,87,80,75,80,86,82,88,84,88,85,87,85,86,32,81,75,81,86,82,88,32,78,79,84,79,0,74,91,78,79,78,85,79,87,81,88,83,88,85,87,86,85,32,79,79,79,85,80,87,81,88,32,86,79,86,88,32,87,79,87,88,32,76,79,79,79,32,84,79,87,79,32,86,88,89,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,32,76,79,81,79,32,84,79,88,79,0,73,91,76,79,79,88,32,77,79,79,85,32,82,79,79,88,32,82,79,85,88,32,83,79,85,85,32,88,79,85,88,32,74,79,79,79,32,86,79,90,79,0,75,89,78,79,85,88,32,79,79,86,88,32,86,79,78,88,32,76,79,81,79,32,84,79,88,79,32,76,88,80,88,32,83,88,88,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,80,91,78,92,77,92,76,91,76,90,77,90,77,91,76,91,32,76,79,81,79,32,84,79,88,79,0,76,88,85,79,78,88,32,86,79,79,88,32,79,79,78,81,78,79,86,79,32,78,88,86,88,86,86,85,88,0,75,91,81,79,79,80,78,81,77,83,77,85,78,87,80,88,81,88,83,87,85,85,87,82,88,79,32,81,79,79,81,78,83,78,85,79,87,80,88,32,81,79,83,79,85,80,87,87,88,88,32,83,79,84,80,86,87,88,88,89,88,0,75,88,82,75,80,77,79,79,77,85,75,92,32,81,76,80,78,78,84,76,92,32,82,75,84,75,86,76,86,78,85,80,82,81,32,84,75,85,76,85,78,84,80,82,81,32,82,81,84,82,85,84,85,86,84,87,82,88,81,88,79,87,78,84,32,82,81,83,82,84,84,84,86,82,88,0,75,89,76,81,78,79,80,79,82,80,83,83,83,88,82,92,32,76,81,78,80,80,80,82,81,83,83,32,87,79,86,82,83,88,81,92,0,75,89,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,82,78,81,76,81,75,82,74,84,74,85,75,86,77,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,32,81,76,82,75,84,75,86,77,0,76,88,86,80,84,79,81,79,79,80,79,81,80,82,82,83,32,81,79,80,80,80,81,82,83,32,82,83,79,84,78,85,78,87,80,88,83,88,85,87,32,82,83,80,84,79,85,79,87,80,88,0,76,87,82,75,81,76,81,77,83,78,86,78,86,77,83,78,80,79,79,80,78,82,78,84,79,86,80,87,82,88,83,89,83,91,82,92,80,92,79,91,32,83,78,81,79,80,80,79,82,79,84,80,86,82,88,0,73,89,74,82,75,80,76,79,78,79,79,80,79,81,77,88,32,77,79,78,80,78,81,76,88,32,79,81,80,80,82,79,84,79,86,80,86,82,83,92,32,84,79,85,80,85,82,82,92,0,73,89,74,83,75,81,76,80,78,80,79,81,79,86,80,88,32,77,80,78,81,78,85,79,87,80,88,81,88,83,87,84,86,85,84,86,81,86,78,85,76,84,75,82,75,81,76,81,78,82,80,85,82,87,83,32,81,88,83,86,84,84,85,81,85,78,84,75,0,78,87,82,79,80,86,80,87,81,88,83,88,85,87,86,85,32,83,79,81,86,81,87,82,88,0,75,89,79,79,76,88,32,80,79,77,88,32,85,79,86,80,87,80,86,79,84,79,82,81,79,82,32,79,82,80,83,82,87,84,88,86,87,87,85,32,79,82,81,83,83,87,84,88,0,76,88,76,75,78,75,80,76,87,88,32,78,75,79,76,86,88,32,82,80,77,88,32,82,80,78,88,0,75,90,79,79,75,92,32,80,79,76,92,32,78,85,78,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,74,89,78,79,77,88,32,79,79,78,85,77,88,32,86,82,86,79,87,79,86,82,84,85,81,87,78,88,77,88,32,76,79,79,79,0,77,88,82,75,81,76,81,77,83,78,86,78,32,84,78,81,79,80,80,80,82,82,83,85,83,32,84,78,82,79,81,80,81,82,82,83,32,83,83,80,84,79,85,79,87,81,88,83,89,84,90,84,91,83,92,81,92,32,83,83,81,84,80,85,80,87,81,88,0,75,88,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,83,79,81,79,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,73,90,80,80,77,88,32,80,80,78,88,32,84,80,83,88,32,84,80,84,88,32,75,81,77,79,88,79,32,75,81,77,80,88,80,0,74,88,83,79,81,79,79,80,78,81,77,83,74,92,32,81,79,79,81,78,83,75,92,32,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,32,83,79,85,81,85,84,84,86,82,88,0,75,91,89,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,89,80,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,75,90,83,80,81,88,32,83,80,82,88,32,77,81,79,79,88,79,32,77,81,79,80,88,80,0,74,88,75,82,76,80,77,79,79,79,80,80,80,82,79,85,79,87,80,88,32,78,79,79,80,79,82,78,85,78,87,80,88,81,88,83,87,85,85,86,82,86,79,85,79,86,80,0,75,90,79,80,78,81,77,83,77,85,78,87,80,88,82,88,85,87,87,85,88,82,88,80,87,79,85,79,84,80,83,82,82,85,79,92,32,77,85,78,86,80,87,82,87,85,86,87,84,88,82,32,88,81,87,80,85,80,83,82,32,82,85,81,88,80,92,0,75,88,77,79,78,79,80,80,83,91,84,92,32,78,79,79,80,82,91,84,92,85,92,32,86,79,84,82,78,89,76,92,0,73,91,84,75,81,92,32,85,75,80,92,32,74,82,75,80,76,79,78,79,79,80,79,86,80,87,83,87,85,86,87,84,32,77,79,78,80,78,84,79,87,80,88,83,88,85,87,87,84,88,82,89,79,0,74,90,78,80,80,80,80,79,78,80,77,81,76,83,76,85,77,87,78,88,80,88,81,87,82,85,83,82,32,76,85,78,87,80,87,82,85,32,82,82,82,87,83,88,85,88,87,86,88,84,88,82,87,80,86,79,86,80,87,80,32,82,85,83,87,85,87,87,86,0,75,90,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,74,88,79,75,77,82,32,80,75,78,82,78,86,80,88,32,78,82,79,80,81,79,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,77,82,32,83,79,85,81,85,84,84,86,82,88,32,77,75,80,75,0,75,88,85,80,85,81,86,81,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,85,75,88,75,0,75,87,78,85,82,84,84,83,85,82,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,77,88,87,75,88,76,88,75,86,75,84,76,83,78,80,89,79,91,78,92,32,86,75,85,76,84,78,81,89,80,91,78,92,76,92,76,91,77,92,32,80,79,86,79,0,75,89,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,80,75,76,88,32,81,75,77,88,32,79,81,80,80,82,79,84,79,86,80,86,82,85,85,85,87,86,88,32,84,79,85,80,85,82,84,85,84,87,85,88,87,88,88,87,89,85,32,78,75,81,75,0,77,87,83,75,83,76,84,76,84,75,83,75,32,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,77,87,84,75,84,76,85,76,85,75,84,75,32,79,82,80,80,81,79,83,79,84,80,84,82,82,89,81,91,79,92,77,92,77,91,78,92,32,82,79,83,80,83,82,81,89,80,91,79,92,0,75,88,80,75,76,88,32,81,75,77,88,32,86,80,85,81,86,81,86,80,85,79,84,79,82,81,80,82,79,82,32,79,82,80,83,81,87,82,88,84,88,85,87,86,85,32,79,82,81,83,82,87,83,88,32,78,75,81,75,0,78,86,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,81,75,84,75,0,70,94,71,82,72,80,73,79,75,79,76,80,76,81,74,88,32,74,79,75,80,75,81,73,88,32,76,81,77,80,79,79,81,79,83,80,83,81,81,88,32,81,79,82,80,82,81,80,88,32,83,81,84,80,86,79,88,79,90,80,90,82,89,85,89,87,90,88,32,88,79,89,80,89,82,88,85,88,87,89,88,91,88,92,87,93,85,0,74,91,75,82,76,80,77,79,79,79,80,80,80,81,78,88,32,78,79,79,80,79,81,77,88,32,80,81,81,80,83,79,85,79,87,80,87,82,86,85,86,87,87,88,32,85,79,86,80,86,82,85,85,85,87,86,88,88,88,89,87,90,85,0,74,89,75,82,76,80,77,79,79,79,80,80,80,81,77,92,32,78,79,79,80,79,81,76,92,32,80,81,82,79,84,79,86,80,87,82,87,84,86,86,85,87,83,88,81,88,79,86,79,84,32,84,79,86,81,86,84,85,86,83,88,32,74,92,79,92,0,75,89,86,79,82,92,32,87,79,83,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,80,92,85,92,0,76,88,77,82,78,80,79,79,81,79,82,80,82,81,80,88,32,80,79,81,80,81,81,79,88,32,82,81,83,80,85,79,86,79,87,80,87,81,86,81,87,80,0,76,89,86,80,86,81,87,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,78,86,79,86,79,87,0,78,87,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,80,79,85,79,0,73,90,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,72,92,73,82,74,80,75,79,77,79,78,80,78,82,77,85,77,87,78,88,32,76,79,77,80,77,82,76,85,76,87,78,88,79,88,81,87,82,86,32,84,79,82,86,82,87,84,88,32,85,79,83,86,83,87,84,88,85,88,87,87,89,85,90,82,90,79,89,79,90,80,0,74,90,77,82,78,80,80,79,82,79,83,80,83,82,32,81,79,82,80,82,82,81,85,80,87,78,88,77,88,76,87,76,86,77,86,76,87,32,88,80,87,81,88,81,88,80,87,79,86,79,84,80,83,82,82,85,82,87,83,88,32,81,85,81,87,82,88,84,88,86,87,87,85,0,73,89,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,0,75,89,87,79,87,80,86,81,78,86,77,87,77,88,32,78,81,79,79,82,79,85,81,32,79,80,82,80,85,81,86,81,32,78,86,79,86,82,87,85,87,32,79,86,82,88,85,88,86,86,0,72,91,82,75,83,76,83,77,84,77,84,76,82,75,79,75,77,76,76,78,76,88,32,79,75,78,76,77,78,77,88,32,88,75,89,76,89,77,90,77,90,76,88,75,86,75,84,77,84,88,32,86,75,85,77,85,88,32,74,79,87,79,32,74,88,79,88,32,82,88,87,88,0,74,91,85,75,86,76,87,76,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,86,79,86,88,32,87,79,87,88,32,76,79,87,79,32,76,88,81,88,32,84,88,89,88,0,74,91,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,85,75,86,76,86,88,32,87,75,87,88,32,76,79,86,79,32,76,88,81,88,32,84,88,89,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,89,75,90,76,91,76,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,90,79,90,88,32,91,79,91,88,32,72,79,91,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,89,75,90,76,90,88,32,91,75,91,88,32,72,79,90,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,78,87,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,76,88,86,80,84,79,82,79,80,80,79,81,78,83,78,85,79,87,81,88,83,88,85,87,32,82,79,80,81,79,83,79,86,81,88,32,79,83,83,83,0,76,89,83,75,81,76,80,77,79,79,78,82,78,85,79,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,85,75,83,75,32,83,75,81,77,80,79,79,83,79,86,80,88,32,82,88,84,86,85,84,86,80,86,77,85,75,32,79,81,86,81,0,75,90,84,75,81,92,32,85,75,80,92,32,81,79,78,80,77,82,77,85,78,87,81,88,84,88,87,87,88,85,88,82,87,80,84,79,81,79,32,81,79,79,80,78,82,78,85,79,87,81,88,32,84,88,86,87,87,85,87,82,86,80,84,79,0,76,88,85,80,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,84,79,86,82,88,32,81,79,79,81,79,84,80,86,82,88,83,89,83,91,82,92,80,92,0,73,91,86,75,87,76,88,76,86,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,90,75,91,76,91,75,89,75,87,76,86,78,83,89,82,91,81,92,32,89,75,88,76,87,78,84,89,83,91,81,92,79,92,79,91,80,92,32,76,79,89,79,0,73,90,86,75,87,76,88,76,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,76,79,87,79,0,73,90,86,75,87,76,32,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,76,79,86,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,92,76,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,90,79,88,86,88,87,89,88,91,88,92,87,93,85,32,91,79,89,86,89,87,90,88,32,73,79,91,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,32,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,91,75,88,86,88,87,89,88,91,88,92,87,93,85,32,92,75,89,86,89,87,90,88,32,73,79,90,79,0,77,87,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,79,85,0,76,88,0,76,89,81,75,79,76,78,79,78,84,79,87,81,88,84,88,86,87,87,84,87,79,86,76,84,75,81,75,32,81,75,80,76,79,79,79,84,80,87,81,88,32,84,88,85,87,86,84,86,79,85,76,84,75,0,76,89,80,78,83,75,83,88,32,82,76,82,88,32,79,88,86,88,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,81,82,79,83,78,85,78,88,32,84,75,85,76,86,78,85,80,84,81,32,78,87,79,86,80,86,83,87,86,87,87,86,32,80,86,83,88,86,88,87,86,87,85,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,32,84,75,85,76,86,78,85,80,84,81,32,82,81,84,81,86,82,87,84,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,81,85,82,86,84,86,85,85,87,84,88,0,76,89,83,77,83,88,32,84,75,84,88,32,84,75,77,84,88,84,32,81,88,86,88,0,76,89,79,75,78,81,32,79,75,86,75,32,79,76,83,76,86,75,32,78,81,79,80,81,79,84,79,86,80,87,82,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,79,85,80,86,82,86,85,85,87,84,88,0,76,89,86,77,86,78,87,78,87,77,86,76,84,75,82,75,80,76,79,77,78,80,78,85,79,87,81,88,84,88,86,87,87,85,87,83,86,81,84,80,81,80,78,82,32,82,75,80,77,79,80,79,85,80,87,81,88,32,84,88,85,87,86,85,86,83,85,81,84,80,0,76,89,78,75,78,79,32,86,77,82,84,80,88,32,87,75,84,81,81,88,32,78,77,80,75,82,75,85,77,32,78,77,80,76,82,76,85,77,86,77,0,76,89,81,75,79,76,78,78,79,80,81,81,84,81,86,80,87,78,86,76,84,75,81,75,32,81,75,80,76,79,78,80,80,81,81,32,84,81,85,80,86,78,85,76,84,75,32,81,81,79,82,78,84,78,85,79,87,81,88,84,88,86,87,87,85,87,84,86,82,84,81,32,81,81,80,82,79,84,79,85,80,87,81,88,32,84,88,85,87,86,85,86,84,85,82,84,81,0,76,89,79,86,79,85,78,85,78,86,79,87,81,88,83,88,85,87,86,86,87,83,87,78,86,76,84,75,81,75,79,76,78,78,78,80,79,82,81,83,84,83,87,81,32,83,88,85,86,86,83,86,78,85,76,84,75,32,81,75,80,76,79,78,79,80,80,82,81,83,0,78,86,82,86,81,87,82,88,83,87,82,86,0,78,86,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,79,81,80,82,81,83,80,82,79,32,82,86,81,87,82,88,83,87,82,86,0,78,86,82,79,81,80,82,81,83,80,82,79,32,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,75,81,76,82,83,83,76,82,75,32,82,76,82,79,32,82,86,81,87,82,88,83,87,82,86,0,76,89,78,78,79,78,79,79,78,79,78,78,79,76,81,75,84,75,86,76,87,78,87,79,86,81,83,82,82,83,82,84,83,84,32,84,75,86,77,86,80,85,81,83,82,32,82,87,82,88,83,88,83,87,82,87,0,79,86,82,75,82,80,32,83,75,82,80,0,76,88,79,75,79,80,32,80,75,79,80,32,85,75,85,80,32,86,75,85,80,0,77,87,81,75,80,76,80,78,81,79,83,79,84,78,84,76,83,75,81,75,0,77,87,82,74,82,80,32,79,75,85,79,32,85,75,79,79,0,75,90,88,72,77,92,0,77,87,85,72,83,74,81,77,80,80,80,84,81,87,83,90,85,92,32,83,74,82,76,81,80,81,84,82,88,83,90,0,77,87,79,72,81,74,83,77,84,80,84,84,83,87,81,90,79,92,32,81,74,82,76,83,80,83,84,82,88,81,90,0,77,87,80,72,80,92,32,81,72,81,92,32,80,72,85,72,32,80,92,85,92,0,77,87,83,72,83,92,32,84,72,84,92,32,79,72,84,72,32,79,92,84,92,0,76,87,83,72,82,73,81,75,81,77,82,79,82,80,80,82,82,84,82,85,81,87,81,89,82,91,83,92,32,82,73,81,77,32,81,75,82,79,32,82,85,81,89,32,81,87,82,91,0,77,88,81,72,82,73,83,75,83,77,82,79,82,80,84,82,82,84,82,85,83,87,83,89,82,91,81,92,32,82,73,83,77,32,83,75,82,79,32,82,85,83,89,32,83,87,82,91,0,77,87,84,72,80,82,84,92,0,77,87,80,72,84,82,80,92,0,79,85,82,72,82,92,0,77,87,80,72,80,92,32,84,72,84,92,0,73,91,76,82,88,82,0,73,91,82,76,82,88,32,76,82,88,82,0,74,90,82,77,82,88,32,77,82,87,82,32,77,88,87,88,0,74,90,82,77,82,88,32,77,77,87,77,32,77,82,87,82,0,74,90,77,77,87,87,32,87,77,77,87,0,78,86,82,81,81,82,82,83,83,82,82,81,0,73,91,82,76,81,77,82,78,83,77,82,76,32,76,82,88,82,32,82,86,81,87,82,88,83,87,82,86,0,73,91,76,80,88,80,32,76,84,88,84,0,73,91,87,76,77,88,32,76,80,88,80,32,76,84,88,84,0,73,91,76,78,88,78,32,76,82,88,82,32,76,86,88,86,0,74,90,87,76,77,82,87,88,0,74,90,77,76,87,82,77,88,0,74,90,87,75,77,79,87,83,32,77,84,87,84,32,77,88,87,88,0,74,90,77,75,87,79,77,83,32,77,84,87,84,32,77,88,87,88,0,72,91,89,85,87,85,85,84,84,83,82,80,81,79,79,78,78,78,76,79,75,81,75,82,76,84,78,85,79,85,81,84,82,83,84,80,85,79,87,78,89,78,0,74,90,76,84,76,82,77,80,79,80,85,83,87,83,88,82,32,76,82,77,81,79,81,85,84,87,84,88,82,88,80,0,74,90,77,83,82,80,87,83,32,77,83,82,81,87,83,0,78,86,83,75,80,79,32,83,75,84,76,80,79,0,78,86,81,75,84,79,32,81,75,80,76,84,79,0,76,88,78,75,79,77,81,78,83,78,85,77,86,75,32,78,75,79,78,81,79,83,79,85,78,86,75,0,78,86,83,76,82,77,81,76,82,75,83,76,83,78,81,80,0,78,86,83,75,81,77,81,79,82,80,83,79,82,78,81,79,0,78,86,81,76,82,77,83,76,82,75,81,76,81,78,83,80,0,78,86,81,75,83,77,83,79,82,80,81,79,82,78,83,79,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,0,74,90,77,77,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,77,0,74,90,77,77,83,77,85,78,86,79,87,81,87,83,86,85,85,86,83,87,77,87,0,74,90,77,87,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,87,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,32,77,82,85,82,0,73,91,84,79,85,80,88,82,85,84,84,85,32,85,80,87,82,85,84,32,76,82,87,82,0,77,87,82,77,82,88,32,79,80,80,79,82,76,84,79,85,80,32,80,79,82,77,84,79,0,73,91,80,79,79,80,76,82,79,84,80,85,32,79,80,77,82,79,84,32,77,82,88,82,0,77,87,82,76,82,87,32,79,84,80,85,82,88,84,85,85,84,32,80,85,82,87,84,85,0,75,89,86,83,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,81,75,80,76,81,76,82,75,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,86,81,86,78,85,76,84,75,0,74,90,76,75,82,88,32,77,75,82,86,32,88,75,82,88,32,76,75,88,75,32,78,76,87,76,0,71,91,73,79,76,79,82,87,32,75,79,82,88,32,91,70,82,88,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,32,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,72,92,90,82,89,84,87,85,86,85,84,84,83,83,81,80,80,79,78,78,77,78,75,79,74,81,74,82,75,84,77,85,78,85,80,84,81,83,83,80,84,79,86,78,87,78,89,79,90,81,90,82,0,74,90,88,75,76,88,32,79,75,80,76,80,78,79,79,77,79,76,78,76,76,77,75,79,75,83,76,86,76,88,75,32,85,84,84,85,84,87,85,88,87,88,88,87,88,85,87,84,85,84,0,74,91,89,80,88,80,88,81,89,81,89,80,88,79,87,79,86,80,85,84,84,86,83,87,81,88,79,88,77,87,76,86,76,84,77,83,79,82,82,80,83,78,83,76,82,75,80,75,79,76,79,78,80,81,85,87,87,88,88,88,89,87,32,79,88,77,86,77,84,79,82,32,79,78,80,80,86,87,87,88,0,74,91,85,80,83,79,81,79,80,81,80,82,81,84,83,84,85,83,32,85,79,85,83,86,84,88,84,89,82,89,81,88,78,86,76,83,75,82,75,79,76,77,78,76,81,76,82,77,85,79,87,82,88,83,88,86,87,0,75,90,81,72,81,92,32,84,72,84,92,32,87,76,86,76,86,77,87,77,87,76,85,75,80,75,78,76,78,78,79,80,86,83,87,84,32,78,78,79,79,86,82,87,84,87,86,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,78,86,0,75,89,80,75,80,91,32,84,75,84,91,32,77,81,87,81,32,77,85,87,85,0,76,88,84,76,83,76,83,77,84,77,84,76,83,75,81,75,80,76,80,78,81,80,84,82,85,83,32,80,78,81,79,84,81,85,83,85,85,83,87,32,81,80,79,82,79,84,80,86,83,88,84,89,32,79,84,80,85,83,87,84,89,84,91,83,92,81,92,80,91,80,90,81,90,81,91,80,91,0,76,88,82,75,81,76,82,77,83,76,82,75,32,82,77,82,81,32,82,81,81,83,82,86,83,83,82,81,32,82,86,82,92,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,0,76,88,82,77,83,76,82,75,81,76,82,77,82,81,81,82,83,85,82,86,32,82,81,83,82,81,85,82,86,82,90,81,91,82,92,83,91,82,90,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,32,80,88,79,87,78,88,79,89,80,88,84,88,85,87,86,88,85,89,84,88,0,76,89,86,75,86,88,32,78,75,86,75,32,81,81,86,81,32,78,88,86,88,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,81,81,82,82,83,83,82,82,81,0,76,89,81,75,80,76,80,77,81,78,32,84,75,85,76,85,77,84,78,32,82,78,80,79,79,81,79,82,80,84,82,85,83,85,85,84,86,82,86,81,85,79,83,78,82,78,32,82,85,82,89,32,83,85,83,89,32,79,87,86,87,0,76,89,82,75,80,76,79,78,79,79,80,81,82,82,83,82,85,81,86,79,86,78,85,76,83,75,82,75,32,82,82,82,88,32,83,82,83,88,32,79,85,86,85,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,75,82,89,32,75,82,89,82,0,74,89,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,87,77,82,82,32,82,77,87,77,87,82,32,82,77,86,78,87,82,0,74,90,76,76,77,75,79,75,81,76,82,78,82,80,81,82,80,83,78,84,32,79,75,80,76,81,78,81,81,80,83,32,86,75,85,88,32,87,75,84,88,32,78,84,88,84,0,74,89,78,75,78,85,32,79,75,78,82,32,78,82,79,80,81,79,83,79,85,80,86,81,86,84,84,86,84,88,85,89,86,89,87,88,32,83,79,85,81,85,84,84,86,32,76,75,79,75,0,76,89,79,78,82,75,82,81,32,86,78,83,75,83,81,32,82,81,80,82,79,84,79,85,80,87,82,88,83,88,85,87,86,85,86,84,85,82,83,81,32,82,84,82,85,83,85,83,84,82,84,0,74,90,82,75,82,89,32,77,75,77,80,78,82,80,83,84,83,86,82,87,80,87,75,32,76,77,77,75,78,77,32,81,77,82,75,83,77,32,86,77,87,75,88,77,32,79,86,85,86,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,86,88,86,85,85,88,0,76,89,87,75,84,75,81,76,79,78,78,81,78,83,79,86,81,88,84,89,87,89,32,87,75,84,76,82,78,81,81,81,83,82,86,84,88,87,89,0,74,90,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,83,76,81,81,32,87,77,82,82,32,88,81,83,83,0,75,89,80,77,84,87,32,84,77,80,87,32,77,80,87,84,32,87,80,77,84,0,74,91,79,85,77,85,76,86,76,88,77,89,79,89,80,88,80,86,78,84,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,87,84,85,86,85,88,86,89,88,89,89,88,89,86,88,85,86,85,32,78,77,80,76,85,76,87,77,0,74,91,79,79,77,79,76,78,76,76,77,75,79,75,80,76,80,78,78,80,77,82,77,85,78,87,79,88,81,89,84,89,86,88,87,87,88,85,88,82,87,80,85,78,85,76,86,75,88,75,89,76,89,78,88,79,86,79,32,78,87,80,88,85,88,87,87,0,70,94,75,72,75,92,32,76,72,76,92,32,88,72,88,92,32,89,72,89,92,32,72,72,92,72,32,72,92,79,92,32,85,92,92,92,0,72,93,75,72,82,81,74,92,32,74,72,81,81,32,74,72,89,72,90,77,88,72,32,75,91,88,91,32,74,92,89,92,90,87,88,92,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,32,84,68,82,72,81,75,80,80,80,84,81,89,82,92,84,96,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,32,80,68,82,72,83,75,84,80,84,84,83,89,82,92,80,96,0,75,89,79,66,79,98,32,80,66,80,98,32,79,66,86,66,32,79,98,86,98,0,75,89,84,66,84,98,32,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,74,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,32,82,68,81,71,81,75,82,78,32,82,86,81,89,81,93,82,96,0,75,90,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,32,82,68,83,71,83,75,82,78,32,82,86,83,89,83,93,82,96,0,75,89,85,64,82,67,80,70,79,73,79,76,80,79,83,86,84,89,84,92,83,95,82,97,32,82,67,81,69,80,72,80,75,81,78,84,85,85,88,85,91,84,94,82,97,79,100,0,75,89,79,64,82,67,84,70,85,73,85,76,84,79,81,86,80,89,80,92,81,95,82,97,32,82,67,83,69,84,72,84,75,83,78,80,85,79,88,79,91,80,94,82,97,85,100,0,65,88,67,82,71,82,82,96,32,71,83,82,97,32,70,83,82,98,32,88,58,82,98,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,71,92,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,0,71,92,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,89,91,89,85,88,91,0,71,91,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,80,91,0,71,94,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,32,88,83,88,91,32,89,83,89,91,32,85,83,92,83,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,76,80,88,80,32,72,91,79,91,32,85,91,92,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,79,91],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+296964);allocate([86,91,0,75,90,85,70,85,87,84,90,82,91,80,91,78,90,77,88,77,86,78,85,79,86,78,87,32,84,70,84,87,83,90,82,91,32,81,70,88,70,0,70,92,75,70,75,91,32,76,70,76,91,32,89,70,76,83,32,81,79,89,91,32,80,79,88,91,32,72,70,79,70,32,85,70,91,70,32,72,91,79,91,32,85,91,91,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,82,70,32,75,91,90,91,90,85,89,91,0,70,95,75,70,75,91,32,76,70,82,88,32,75,70,82,91,32,89,70,82,91,32,89,70,89,91,32,90,70,90,91,32,72,70,76,70,32,89,70,93,70,32,72,91,78,91,32,86,91,93,91,0,71,94,76,70,76,91,32,77,70,89,89,32,77,72,89,91,32,89,70,89,91,32,73,70,77,70,32,86,70,92,70,32,73,91,79,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,78,89,78,88,79,86,81,85,82,85,84,86,85,88,86,95,87,96,89,96,90,94,90,93,32,85,88,86,92,87,94,88,95,89,95,90,94,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,77,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,73,91,80,91,32,82,80,84,81,85,82,88,89,89,90,90,90,91,89,32,84,81,85,83,87,90,88,91,90,91,91,89,91,88,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,73,92,82,70,82,91,32,83,70,83,91,32,76,70,75,76,75,70,90,70,90,76,89,70,32,79,91,86,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,76,70,76,85,77,88,79,90,81,91,32,72,70,79,70,32,86,70,92,70,0,72,92,75,70,82,91,32,76,70,82,88,32,89,70,82,91,32,73,70,79,70,32,85,70,91,70,0,70,94,74,70,78,91,32,75,70,78,86,32,82,70,78,91,32,82,70,86,91,32,83,70,86,86,32,90,70,86,91,32,71,70,78,70,32,87,70,93,70,0,72,92,75,70,88,91,32,76,70,89,91,32,89,70,75,91,32,73,70,79,70,32,85,70,91,70,32,73,91,79,91,32,85,91,91,91,0,72,93,75,70,82,81,82,91,32,76,70,83,81,83,91,32,90,70,83,81,32,73,70,79,70,32,86,70,92,70,32,79,91,86,91,0,72,92,88,70,75,91,32,89,70,76,91,32,76,70,75,76,75,70,89,70,32,75,91,89,91,89,85,88,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,90,70,90,76,89,70,32,75,91,82,91,0,72,92,82,70,74,91,32,82,70,90,91,32,82,73,89,91,32,75,90,89,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,73,91,79,91,32,85,91,91,91,0,71,93,75,69,74,74,32,90,69,89,74,32,79,78,78,83,32,86,78,85,83,32,75,87,74,92,32,90,87,89,92,32,75,71,89,71,32,75,72,89,72,32,79,80,85,80,32,79,81,85,81,32,75,89,89,89,32,75,90,89,90,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,92,70,32,72,91,79,91,32,85,91,92,91,0,72,93,75,70,82,80,74,91,32,74,70,81,80,32,74,70,89,70,90,76,88,70,32,75,90,88,90,32,74,91,89,91,90,85,88,91,0,73,92,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,75,73,77,71,79,71,81,73,32,90,75,90,73,89,71,88,70,86,70,85,71,84,73,83,77,83,91,32,90,73,88,71,86,71,84,73,32,79,91,86,91,0,72,93,82,70,82,91,32,83,70,83,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,80,75,32,80,75,78,76,77,77,76,79,76,82,77,84,78,85,80,86,32,85,86,87,85,88,84,89,82,89,79,88,77,87,76,85,75,32,79,70,86,70,32,79,91,86,91,0,71,94,82,70,82,91,32,83,70,83,91,32,73,77,74,76,76,77,77,81,78,83,79,84,81,85,32,74,76,75,77,76,81,77,83,78,84,81,85,84,85,87,84,88,83,89,81,90,77,91,76,32,84,85,86,84,87,83,88,81,89,77,91,76,92,77,32,79,70,86,70,32,79,91,86,91,0,71,93,74,88,75,91,79,91,77,87,75,83,74,80,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,80,89,83,87,87,85,91,89,91,90,88,32,77,87,76,84,75,80,75,76,76,73,78,71,80,70,32,84,70,86,71,88,73,89,76,89,80,88,84,87,87,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,72,91,32,85,70,86,91,32,84,72,85,91,32,76,85,85,85,32,70,91,76,91,32,82,91,88,91,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,77,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,86,80,87,81,88,83,88,85,87,88,85,90,82,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,85,70,87,71,88,72,89,75,89,79,88,83,86,87,84,89,82,90,79,91,0,70,93,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,85,91,87,86,84,91,0,70,92,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,32,82,91,84,90,86,88,88,84,32,85,84,92,84,0,69,95,78,70,72,91,32,79,70,73,91,32,91,70,85,91,32,92,70,86,91,32,75,70,82,70,32,88,70,95,70,32,76,80,88,80,32,69,91,76,91,32,82,91,89,91,0,76,89,85,70,79,91,32,86,70,80,91,32,82,70,89,70,32,76,91,83,91,0,73,91,88,70,83,87,82,89,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,86,75,87,32,87,70,82,87,81,89,79,91,32,84,70,91,70,0,70,93,79,70,73,91,32,80,70,74,91,32,93,70,76,83,32,83,79,87,91,32,82,79,86,91,32,76,70,83,70,32,89,70,95,70,32,70,91,77,91,32,83,91,89,91,0,72,92,81,70,75,91,32,82,70,76,91,32,78,70,85,70,32,72,91,87,91,89,85,86,91,0,69,96,78,70,72,91,32,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,92,70,86,91,32,93,70,87,91,32,75,70,79,70,32,92,70,96,70,32,69,91,75,91,32,83,91,90,91,0,70,95,79,70,73,91,32,79,70,86,88,32,79,73,86,91,32,92,70,86,91,32,76,70,79,70,32,89,70,95,70,32,70,91,76,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,88,70,90,71,91,73,91,75,90,78,88,80,85,81,32,70,91,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,32,76,89,76,88,77,86,79,85,80,85,82,86,83,88,83,95,84,96,86,96,87,94,87,93,32,83,88,84,94,85,95,86,95,87,94,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,77,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,82,80,84,81,85,82,86,90,87,91,89,91,90,89,90,88,32,85,82,87,89,88,90,89,90,90,89,32,70,91,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,72,93,85,70,79,91,32,86,70,80,91,32,79,70,76,76,78,70,93,70,92,76,92,70,32,76,91,83,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,70,32,79,70,76,81,75,85,75,88,76,90,78,91,32,75,70,82,70,32,89,70,95,70,0,72,92,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,76,70,82,70,32,88,70,94,70,0,69,95,77,70,75,91,32,78,70,76,89,32,85,70,75,91,32,85,70,83,91,32,86,70,84,89,32,93,70,83,91,32,74,70,81,70,32,90,70,96,70,0,71,93,78,70,85,91,32,79,70,86,91,32,92,70,72,91,32,76,70,82,70,32,88,70,94,70,32,70,91,76,91,32,82,91,88,91,0,72,93,78,70,82,80,79,91,32,79,70,83,80,80,91,32,93,70,83,80,32,76,70,82,70,32,89,70,95,70,32,76,91,83,91,0,71,93,91,70,72,91,32,92,70,73,91,32,79,70,76,76,78,70,92,70,32,72,91,86,91,88,85,85,91,0,72,92,75,73,76,75,88,87,89,89,89,91,32,76,76,88,88,32,75,73,75,75,76,77,88,89,89,91,32,80,80,76,84,75,86,75,88,76,90,75,91,32,75,86,77,90,32,76,84,76,86,77,88,77,90,75,91,32,83,83,88,78,32,86,73,86,76,87,78,89,78,89,76,87,75,86,73,32,86,73,87,76,89,78,0,72,92,81,73,75,91,32,83,73,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,32,81,66,79,67,78,69,78,71,79,73,81,74,83,74,85,73,86,71,86,69,85,67,83,66,81,66,0,71,93,73,66,91,98,0,70,94,82,74,73,90,32,82,74,91,90,0,73,93,78,79,78,80,77,80,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,87,79,87,88,88,90,90,91,91,91,32,87,81,86,82,80,83,77,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,80,83,78,84,77,86,77,88,78,90,80,91,0,71,92,76,70,76,91,32,77,70,77,91,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,70,77,70,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,72,93,87,70,87,91,32,88,70,88,91,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,70,88,70,32,87,91,91,91,0,72,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,83,87,80,86,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,75,88,85,71,84,72,85,73,86,72,86,71,85,70,83,70,81,71,80,73,80,91,32,83,70,82,71,81,73,81,91,32,77,77,85,77,32,77,91,84,91,0,73,92,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,78,78,80,78,84,79,86,32,85,86,86,84,86,80,85,78,32,86,79,87,78,89,77,89,78,87,78,32,78,85,77,86,76,88,76,89,77,91,80,92,85,92,88,93,89,94,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,0,71,93,76,70,76,91,32,77,70,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,70,77,70,32,73,91,80,91,32,84,91,91,91,0,77,88,82,70,81,71,82,72,83,71,82,70,32,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,77,88,83,70,82,71,83,72,84,71,83,70,32,84,77,84,95,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,83,77,83,95,82,97,81,98,32,80,77,84,77,0,71,92,76,70,76,91,32,77,70,77,91,32,87,77,77,87,32,82,83,88,91,32,81,83,87,91,32,73,70,77,70,32,84,77,90,77,32,73,91,80,91,32,84,91,90,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,83,70,32,79,91,86,91,0,66,99,71,77,71,91,32,72,77,72,91,32,72,80,74,78,77,77,79,77,82,78,83,80,83,91,32,79,77,81,78,82,80,82,91,32,83,80,85,78,88,77,90,77,93,78,94,80,94,91,32,90,77,92,78,93,80,93,91,32,68,77,72,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,71,93,76,77,76,91,32,77,77,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,77,77,77,32,73,91,80,91,32,84,91,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,71,92,76,77,76,98,32,77,77,77,98,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,77,77,77,32,73,98,80,98,0,72,92,87,77,87,98,32,88,77,88,98,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,98,91,98,0,73,90,78,77,78,91,32,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,88,78,88,79,87,80,86,79,87,78,32,75,77,79,77,32,75,91,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,82,80,83,85,85,87,86,88,87,32,77,80,78,81,80,82,85,84,87,85,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,70,80,87,81,90,83,91,85,91,87,90,88,88,32,81,70,81,87,82,90,83,91,32,77,77,85,77,0,71,93,76,77,76,88,77,90,80,91,82,91,85,90,87,88,32,77,77,77,88,78,90,80,91,32,87,77,87,91,32,88,77,88,91,32,73,77,77,77,32,84,77,88,77,32,87,91,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,74,77,80,77,32,84,77,90,77,0,70,94,74,77,78,91,32,75,77,78,88,32,82,77,78,91,32,82,77,86,91,32,83,77,86,88,32,90,77,86,91,32,71,77,78,77,32,87,77,93,77,0,72,92,76,77,87,91,32,77,77,88,91,32,88,77,76,91,32,74,77,80,77,32,84,77,90,77,32,74,91,80,91,32,84,91,90,91,0,72,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,73,91,87,77,76,91,32,88,77,77,91,32,77,77,76,81,76,77,88,77,32,76,91,88,91,88,87,87,91,0,71,94,81,77,78,78,76,80,75,82,74,85,74,88,75,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,32,81,77,83,77,85,78,86,80,88,88,89,90,90,91,32,83,77,84,78,85,80,87,88,88,90,90,91,91,91,0,71,92,84,70,81,71,79,73,77,77,76,80,75,84,74,90,73,98,32,84,70,82,71,80,73,78,77,77,80,76,84,75,90,74,98,32,84,70,86,70,88,71,89,72,89,75,88,77,87,78,84,79,80,79,32,86,70,88,72,88,75,87,77,86,78,84,79,32,80,79,84,80,86,82,87,84,87,87,86,89,85,90,82,91,80,91,78,90,77,89,76,86,32,80,79,83,80,85,82,86,84,86,87,85,89,84,90,82,91,0,72,92,73,80,75,78,77,77,79,77,81,78,82,79,83,82,83,86,82,90,79,98,32,74,79,76,78,80,78,82,79,32,90,77,89,80,88,82,83,89,80,94,78,98,32,89,77,88,80,87,82,83,89,0,73,92,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,83,74,82,72,82,70,83,69,85,69,87,70,89,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,84,75,83,73,83,71,84,70,86,70,89,72,0,73,91,88,80,86,78,84,77,80,77,78,78,78,80,80,82,83,83,32,80,77,79,78,79,80,81,82,83,83,32,83,83,78,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,83,83,79,84,77,86,77,88,78,90,80,91,0,73,91,84,70,82,71,81,72,81,73,82,74,85,75,90,75,90,74,87,75,83,77,80,79,77,82,76,85,76,87,77,89,80,91,83,93,84,95,84,97,83,98,81,98,80,97,32,85,76,81,79,78,82,77,85,77,87,78,89,80,91,0,71,93,72,81,73,79,75,77,78,77,79,78,79,80,78,84,76,91,32,77,77,78,78,78,80,77,84,75,91,32,78,84,80,80,82,78,84,77,86,77,88,78,89,79,89,82,88,87,85,98,32,86,77,88,79,88,82,87,87,84,98,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,85,88,82,89,77,89,73,88,71,86,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,32,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,0,76,88,82,77,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,83,77,81,84,80,88,80,90,81,91,0,72,92,78,77,74,91,32,79,77,75,91,32,88,77,89,78,90,78,89,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,0,72,92,75,70,77,70,79,71,80,72,81,74,87,88,88,90,89,91,32,77,70,79,72,80,74,86,88,87,90,89,91,90,91,32,82,77,74,91,32,82,77,75,91,0,70,93,77,77,71,98,32,78,77,72,98,32,77,80,76,86,76,89,78,91,80,91,82,90,84,88,86,85,32,88,77,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,86,88,86,90,87,91,0,72,92,78,77,76,91,32,79,77,78,83,77,88,76,91,32,89,77,88,81,86,85,32,90,77,89,80,88,82,86,85,84,87,81,89,79,90,76,91,32,75,77,79,77,0,73,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,81,76,79,77,78,79,78,81,80,83,83,84,86,84,32,85,75,82,76,80,77,79,79,79,81,81,83,83,84,32,83,84,79,85,77,86,76,88,76,90,78,92,83,94,84,95,84,97,82,98,80,98,32,83,84,80,85,78,86,77,88,77,90,79,92,83,94,0,73,91,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,0,71,93,80,78,76,91,32,80,78,77,91,32,86,78,86,91,32,86,78,87,91,32,73,80,75,78,78,77,91,77,32,73,80,75,79,78,78,91,78,0,72,91,76,86,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,79,78,77,81,76,84,72,98,32,82,91,84,90,86,87,87,84,87,80,86,78,32,82,77,80,78,78,81,77,84,73,98,0,72,93,91,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,84,90,86,87,87,84,87,81,86,79,85,78,83,77,32,81,77,79,78,77,81,76,84,76,88,77,90,32,81,91,83,90,85,87,86,84,86,80,85,78,32,85,78,91,78,0,72,92,83,78,80,91,32,83,78,81,91,32,74,80,76,78,79,77,90,77,32,74,80,76,79,79,78,90,78,0,72,92,73,81,74,79,76,77,79,77,80,78,80,80,78,86,78,89,80,91,32,78,77,79,78,79,80,77,86,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,82,89,79,88,77,87,78,88,79,89,82,32,88,85,89,79,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,32,74,87,76,89,78,90,81,90,84,89,87,87,89,85,32,90,79,88,78,86,78,84,80,82,83,80,89,78,98,0,73,91,75,77,77,77,79,78,80,80,85,95,86,97,87,98,32,77,77,78,78,79,80,84,95,85,97,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,85,70,79,98,32,86,70,78,98,32,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,79,90,82,90,84,89,87,86,89,83,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,82,91,84,90,86,88,88,85,89,83,91,77,0,70,93,74,81,76,79,79,78,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,82,84,32,73,87,74,89,75,90,77,90,79,89,81,87,32,81,84,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,87,78,89,79,90,81,32,81,87,82,89,83,90,85,90,87,89,89,87,0,72,93,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,91,80,70,76,83,76,86,77,89,78,90,32,81,70,77,83,32,77,83,78,80,80,78,82,77,84,77,86,78,87,79,88,81,88,84,87,87,85,90,82,91,80,91,78,90,77,87,77,83,32,86,78,87,80,87,84,86,87,84,90,82,91,32,77,70,81,70,0,73,91,87,80,87,81,88,81,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,32,82,77,80,78,78,81,77,84,77,88,78,90,0,72,93,90,70,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,91,70,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,87,70,91,70,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,32,82,77,80,78,78,81,77,84,77,88,78,90,0,75,90,90,71,89,72,90,73,91,72,91,71,90,70,88,70,86,71,85,72,84,74,83,77,80,91,79,95,78,97,32,88,70,86,72,85,74,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,79,77,89,77,0,72,92,89,77,85,91,84,94,82,97,79,98,76,98,74,97,73,96,73,95,74,94,75,95,74,96,32,88,77,84,91,83,94,81,97,79,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,93,80,70,74,91,32,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,32,77,70,81,70,0,76,89,85,70,84,71,85,72,86,71,85,70,32,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,76,89,86,70,85,71,86,72,87,71,86,70,32,78,81,79,79,81,77,84,77,85,78,85,81,82,91,81,94,80,96,79,97,77,98,75,98,74,97,74,96,75,95,76,96,75,97,32,83,77,84,78,84,81,81,91,80,94,79,96,77,98,0,72,92,80,70,74,91,32,81,70,75,91,32,88,78,87,79,88,80,89,79,89,78,88,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,81,70,0,77,89,85,70,81,84,80,88,80,90,81,91,84,91,86,89,87,87,32,86,70,82,84,81,88,81,90,82,91,32,82,70,86,70,0,65,98,66,81,67,79,69,77,72,77,73,78,73,80,72,84,70,91,32,71,77,72,78,72,80,71,84,69,91,32,72,84,74,80,76,78,78,77,80,77,82,78,83,79,83,81,80,91,32,80,77,82,79,82,81,79,91,32,82,84,84,80,86,78,88,77,90,77,92,78,93,79,93,81,91,87,91,90,92,91,32,90,77,92,79,92,81,90,87,90,90,91,91,94,91,96,89,97,87,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,84,75,91,32,76,77,77,78,77,80,76,84,74,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,0,71,92,72,81,73,79,75,77,78,77,79,78,79,80,78,84,74,98,32,77,77,78,78,78,80,77,84,73,98,32,78,84,79,81,81,78,83,77,85,77,87,78,88,79,89,81,89,84,88,87,86,90,83,91,81,91,79,90,78,87,78,84,32,87,78,88,80,88,84,87,87,85,90,83,91,32,70,98,77,98,0,72,92,88,77,82,98,32,89,77,83,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,79,98,86,98,0,73,90,74,81,75,79,77,77,80,77,81,78,81,80,80,84,78,91,32,79,77,80,78,80,80,79,84,77,91,32,80,84,82,80,84,78,86,77,88,77,89,78,89,79,88,80,87,79,88,78,0,74,91,88,79,88,80,89,80,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,82,86,86,87,87,32,78,80,79,81,86,85,87,86,87,89,86,90,83,91,80,91,77,90,76,89,76,88,77,88,77,89,0,75,89,84,70,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,85,70,81,84,80,88,80,90,81,91,32,78,77,87,77,0,70,93,71,81,72,79,74,77,77,77,78,78,78,81,76,87,76,89,78,91,32,76,77,77,78,77,81,75,87,75,89,76,90,78,91,80,91,82,90,84,88,86,84,32,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,0,72,92,73,81,74,79,76,77,79,77,80,78,80,81,78,87,78,89,80,91,32,78,77,79,78,79,81,77,87,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,81,89,77,88,77,89,79,0,67,96,68,81,69,79,71,77,74,77,75,78,75,81,73,87,73,89,75,91,32,73,77,74,78,74,81,72,87,72,89,73,90,75,91,77,91,79,90,81,88,82,86,32,84,77,82,86,82,89,83,90,85,91,87,91,89,90,91,88,92,86,93,82,93,77,92,77,93,79,32,85,77,83,86,83,89,85,91,0,72,92,75,81,77,78,79,77,82,77,83,79,83,82,32,81,77,82,79,82,82,81,86,80,88,78,90,76,91,75,91,74,90,74,89,75,88,76,89,75,90,32,81,86,81,89,82,91,85,91,87,90,89,87,32,89,78,88,79,89,80,90,79,90,78,89,77,88,77,86,78,84,80,83,82,82,86,82,89,83,91,0,71,92,72,81,73,79,75,77,78,77,79,78,79,81,77,87,77,89,79,91,32,77,77,78,78,78,81,76,87,76,89,77,90,79,91,81,91,83,90,85,88,87,84,32,90,77,86,91,85,94,83,97,80,98,77,98,75,97,74,96,74,95,75,94,76,95,75,96,32,89,77,85,91,84,94,82,97,80,98,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,76,81,77,79,79,77,82,77,86,79,32,77,79,79,78,82,78,86,79,88,79,32,76,89,78,89,82,90,85,90,87,89,32,78,89,82,91,85,91,87,89,88,87,0,71,94,86,71,85,72,86,73,87,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,92,71,91,72,92,73,93,72,93,71,92,70,90,70,88,71,87,73,87,91,32,90,70,89,71,88,73,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,71,93,87,71,86,72,87,73,88,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,88,77,32,73,91,80,91,32,84,91,91,91,0,71,93,86,71,85,72,86,73,87,72,87,71,85,70,32,88,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,72,87,91,32,88,70,88,91,32,73,77,87,77,32,73,91,80,91,32,84,91,91,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,93,71,92,72,93,73,94,72,93,71,91,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,77,93,91,32,94,77,94,91,32,68,77,94,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,92,71,91,72,92,73,93,72,93,71,91,70,32,94,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,72,93,91,32,94,70,94,91,32,68,77,93,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,77,88,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,73,90,87,78,85,77,82,77,79,78,77,80,76,83,76,86,77,89,78,90,81,91,84,91,86,90,32,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,32,77,84,85,84,0,73,92,84,70,81,71,79,74,78,76,77,79,76,84,76,88,77,90,79,91,81,91,84,90,86,87,87,85,88,82,89,77,89,73,88,71,86,70,84,70,32,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,32,78,80,87,80,0,71,93,85,70,79,98,32,86,70,78,98,32,81,77,77,78,75,80,74,83,74,86,75,88,77,90,80,91,83,91,87,90,89,88,90,85,90,82,89,80,87,78,84,77,81,77,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,80,91,32,83,91,86,90,88,88,89,85,89,82,88,80,86,78,84,77,0,73,91,84,77,86,78,88,80,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,32,81,77,79,78,78,79,77,81,77,83,78,85,83,90,84,92,84,94,83,95,81,95,0,71,93,76,77,75,78,74,80,74,82,75,85,79,89,80,91,32,74,82,75,84,79,88,80,91,80,93,79,96,77,98,76,98,75,97,74,95,74,92,75,88,77,84,79,81,82,78,84,77,86,77,89,78,90,80,90,84,89,88,87,90,85,91,84,91,83,90,83,88,84,87,85,88,84,89,32,86,77,88,78,89,80,89,84,88,88,87,90,0,69,95,89,71,88,72,89,73,90,72,89,71,87,70,84,70,81,71,79,73,78,75,77,78,76,82,74,91,73,95,72,97,32,84,70,82,71,80,73,79,75,78,78,76,87,75,91,74,94,73,96,72,97,70,98,68,98,67,97,67,96,68,95,69,96,68,97,32,95,71,94,72,95,73,96,72,96,71,95,70,93,70,91,71,90,72,89,74,88,77,85,91,84,95,83,97,32,93,70,91,72,90,74,89,78,87,87,86,91,85,94,84,96,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,73,77,94,77,0,70,94,91,71,90,72,91,73,92,72,91,71,88,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,89,77,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,90,77,88,84,87,88,87,90,88,91,32,74,77,90,77,0,70,94,89,71,88,72,89,73,90,72,90,71,88,70,32,92,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,91,70,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,92,70,88,84,87,88,87,90,88,91,32,74,77,89,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,96,71,95,72,96,73,97,72,96,71,93,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,94,77,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,95,77,93,84,92,88,92,90,93,91,32,68,77,95,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,94,71,93,72,94,73,95,72,95,71,93,70,32,97,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,96,70,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,97,70,93,84,92,88,92,90,93,91,32,68,77,94,77,0,76,89,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,81,70,79,71,78,72,77,74,76,79,76,82,77,87,78,89,79,90,81,91,32,83,91,85,90,86,89,87,87,88,82,88,79,87,74,86,72,85,71,83,70,0,72,92,78,74,80,73,83,70,83,91,32,82,71,82,91,32,78,91,87,91,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,84,70,86,71,87,72,88,74,88,76,87,78,84,80,80,82,32,75,89,76,88,78,88,83,90,86,90,88,89,89,88,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,72,92,84,72,84,91,32,85,70,85,91,32,85,70,74,85,90,85,32,81,91,88,91,0,72,92,77,70,75,80,32,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,77,70,87,70,32,77,71,82,71,87,70,0,72,92,87,73,86,74,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,32,82,70,80,71,78,73,77,75,76,79,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,84,87,81,85,79,83,78,0,72,92,75,70,75,76,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,76,72,78,71,80,71,85,73,32,89,70,89,73,88,76,84,81,83,83,82,86,82,91,32,88,76,83,81,82,83,81,86,81,91,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,80,70,78,71,77,73,77,76,78,78,80,79,32,84,79,86,78,87,76,87,73,86,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,80,79,78,80,77,81,76,83,76,87,77,89,78,90,80,91,32,84,91,86,90,87,89,88,87,88,83,87,81,86,80,84,79,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,87,77,88,32,81,83,79,82,77,80,76,77,76,76,77,73,79,71,81,70,32,83,70,85,71,87,73,88,76,88,82,87,86,86,88,84,90,82,91,0,77,87,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,81,72,82,84,83,72,82,70,32,82,72,82,78,32,82,89,81,90,82,91,83,90,82,89,0,73,91,77,74,78,75,77,76,76,75,76,74,77,72,78,71,80,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,83,70,85,71,86,72,87,74,87,76,86,78,84,80,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,81,77,32,83,70,81,77,0,74,90,78,70,77,77,32,79,70,77,77,32,86,70,85,77,32,87,70,85,77,0,74,90,82,70,82,82,32,77,73,87,79,32,87,73,77,79,0,75,89,85,66,78,82,85,98,0,75,89,79,66,86,82,79,98,0,75,89,79,66,79,98,32,85,66,85,98,0,70,94,82,74,82,91,32,74,82,90,82,32,74,91,90,91,0,70,94,82,74,82,91,32,74,74,90,74,32,74,82,90,82,0,77,87,81,81,81,83,83,83,83,81,81,81,32,82,81,82,83,32,81,82,83,82,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,82,91,82,32,82,89,81,90,82,91,83,90,82,89,0,69,95,89,73,75,91,32,73,79,91,79,32,73,85,91,85,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,0,70,94,90,70,74,77,90,84,32,74,86,90,86,32,74,91,90,91,0,70,94,74,70,90,77,74,84,32,74,86,90,86,32,74,91,90,91,0,70,95,91,87,89,87,87,86,85,84,82,80,81,79,79,78,77,78,75,79,74,81,74,83,75,85,77,86,79,86,81,85,82,84,85,80,87,78,89,77,91,77,0,70,94,73,85,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,91,79,0,71,93,74],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+307204);allocate([84,82,79,90,84,32,74,84,82,80,90,84,0,76,88,84,70,79,76,32,84,70,85,71,79,76,0,76,88,80,70,85,76,32,80,70,79,71,85,76,0,72,92,75,70,76,72,78,74,81,75,83,75,86,74,88,72,89,70,32,75,70,76,73,78,75,81,76,83,76,86,75,88,73,89,70,0,77,87,82,72,83,71,82,70,81,71,81,73,82,75,83,76,0,77,87,81,70,82,71,83,73,83,75,82,76,81,75,82,74,0,69,91,72,77,76,77,82,89,32,75,77,82,91,32,91,66,82,91,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,0,70,94,74,74,74,81,75,85,76,87,78,89,81,90,83,90,86,89,88,87,89,85,90,81,90,74,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,0,70,94,74,90,74,83,75,79,76,77,78,75,81,74,83,74,86,75,88,77,89,79,90,83,90,90,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,74,82,86,82,0,69,95,88,80,91,82,88,84,32,85,77,90,82,85,87,32,73,82,90,82,0,74,90,80,76,82,73,84,76,32,77,79,82,74,87,79,32,82,74,82,91,0,69,95,76,80,73,82,76,84,32,79,77,74,82,79,87,32,74,82,91,82,0,74,90,80,88,82,91,84,88,32,77,85,82,90,87,85,32,82,73,82,90,0,73,92,88,82,87,79,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,88,85,89,80,89,75,88,72,87,71,85,70,82,70,80,71,79,72,79,73,80,73,80,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,88,87,85,88,80,88,75,87,72,85,70,0,72,92,74,70,82,91,32,75,70,82,89,32,90,70,82,91,32,74,70,90,70,32,75,71,89,71,0,65,98,68,77,73,77,82,89,32,72,78,82,91,32,98,58,82,91,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,32,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,70,95,92,83,91,85,89,86,87,86,85,85,84,84,81,80,80,79,78,78,76,78,74,79,73,81,73,83,74,85,76,86,78,86,80,85,81,84,84,80,85,79,87,78,89,78,91,79,92,81,92,83,0,70,94,91,70,73,91,32,78,70,80,72,80,74,79,76,77,77,75,77,73,75,73,73,74,71,76,70,78,70,80,71,83,72,86,72,89,71,91,70,32,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,87,84,0,70,95,91,78,90,79,91,80,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,77,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,90,91,91,91,92,90,92,89,32,77,91,75,90,74,88,74,85,75,83,77,81,32,77,75,78,77,86,88,88,90,90,91,0,69,96,87,78,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,85,80,86,83,86,85,85,86,83,32,81,75,79,77,78,80,78,83,79,85,80,86,32,87,75,86,83,86,85,88,86,90,86,92,84,93,81,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,90,88,32,88,75,87,83,87,85,88,86,0,72,92,80,66,80,95,32,84,66,84,95,32,88,73,87,74,88,75,89,74,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,80,91,77,90,75,88,75,87,76,86,77,87,76,88,0,74,90,85,73,84,74,85,75,86,74,86,73,85,71,83,70,81,70,79,71,78,73,78,75,79,77,81,79,86,82,32,79,77,84,80,86,82,87,84,87,86,86,88,84,90,32,80,78,78,80,77,82,77,84,78,86,80,88,85,91,32,78,86,83,89,85,91,86,93,86,95,85,97,83,98,81,98,79,97,78,95,78,94,79,93,80,94,79,95,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,98,32,82,81,81,84,82,98,83,84,82,81,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,84,32,82,80,81,82,83,86,82,88,81,86,83,82,82,80,32,82,84,82,98,32,82,94,81,96,82,98,83,96,82,94,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,32,76,91,78,92,80,91,78,90,76,91,32,76,91,88,91,32,84,91,86,92,88,91,86,90,84,91,0,73,92,88,70,88,91,32,75,70,88,70,32,80,80,88,80,32,75,91,88,91,0,69,96,81,70,78,71,75,73,73,76,72,79,72,82,73,85,75,88,78,90,81,91,84,91,87,90,90,88,92,85,93,82,93,79,92,76,90,73,87,71,84,70,81,70,32,82,79,81,80,81,81,82,82,83,82,84,81,84,80,83,79,82,79,32,82,80,82,81,83,81,83,80,82,80,0,74,91,80,70,78,71,79,73,81,74,32,80,70,79,71,79,73,32,85,70,87,71,86,73,84,74,32,85,70,86,71,86,73,32,81,74,79,75,78,76,77,78,77,81,78,83,79,84,81,85,84,85,86,84,87,83,88,81,88,78,87,76,86,75,84,74,81,74,32,82,85,82,91,32,83,85,83,91,32,78,88,87,88,0,73,92,82,70,79,71,77,73,76,76,76,77,77,80,79,82,82,83,83,83,86,82,88,80,89,77,89,76,88,73,86,71,83,70,82,70,32,82,83,82,91,32,83,83,83,91,32,78,87,87,87,0,68,96,80,70,77,71,74,73,72,76,71,79,71,83,72,86,74,89,77,91,80,92,84,92,87,91,90,89,92,86,93,83,93,79,92,76,90,73,87,71,84,70,80,70,32,82,70,82,92,32,71,81,93,81,0,71,96,80,77,77,78,75,80,74,83,74,84,75,87,77,89,80,90,81,90,84,89,86,87,87,84,87,83,86,80,84,78,81,77,80,77,32,93,71,87,71,91,72,85,78,32,93,71,93,77,92,73,86,79,32,92,72,86,78,0,70,92,73,73,74,71,76,70,79,70,81,71,82,73,82,76,81,79,80,81,78,83,75,85,32,79,70,80,71,81,73,81,77,80,80,78,83,32,86,70,84,91,32,87,70,83,91,32,75,85,89,85,0,73,92,77,70,77,85,32,78,70,77,81,32,77,81,78,79,79,78,81,77,84,77,87,78,88,80,88,82,87,84,85,86,32,84,77,86,78,87,80,87,82,84,88,84,90,85,91,87,91,89,89,32,75,70,78,70,0,73,92,82,78,79,79,77,81,76,84,76,85,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,32,82,72,78,74,82,70,82,78,32,83,72,87,74,83,70,83,78,32,82,83,81,84,81,85,82,86,83,86,84,85,84,84,83,83,82,83,32,82,84,82,85,83,85,83,84,82,84,0,71,94,81,72,82,70,82,91,32,84,72,83,70,83,91,32,74,72,75,70,75,77,76,80,78,82,81,83,82,83,32,77,72,76,70,76,78,77,81,32,91,72,90,70,90,77,89,80,87,82,84,83,83,83,32,88,72,89,70,89,78,88,81,32,78,87,87,87,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,89,91,89,86,88,91,0,72,91,89,71,85,71,81,72,78,74,76,77,75,80,75,83,76,86,78,89,81,91,85,92,89,92,32,89,71,86,72,83,74,81,77,80,80,80,83,81,86,83,89,86,91,89,92,0,70,95,79,81,77,81,75,82,74,83,73,85,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,85,82,83,81,82,79,81,32,83,72,80,81,32,90,74,82,82,32,92,81,83,84,0,72,92,79,75,85,89,32,85,75,79,89,32,75,79,89,85,32,89,79,75,85,0,70,94,78,86,76,85,75,85,73,86,72,88,72,89,73,91,75,92,76,92,78,91,79,89,79,88,78,86,75,82,74,79,74,77,75,74,77,72,80,71,84,71,87,72,89,74,90,77,90,79,89,82,86,86,85,88,85,89,86,91,88,92,89,92,91,91,92,89,92,88,91,86,89,85,88,85,86,86,32,74,77,75,75,77,73,80,72,84,72,87,73,89,75,90,77,0,70,94,78,77,76,78,75,78,73,77,72,75,72,74,73,72,75,71,76,71,78,72,79,74,79,75,78,77,75,81,74,84,74,86,75,89,77,91,80,92,84,92,87,91,89,89,90,86,90,84,89,81,86,77,85,75,85,74,86,72,88,71,89,71,91,72,92,74,92,75,91,77,89,78,88,78,86,77,32,74,86,75,88,77,90,80,91,84,91,87,90,89,88,90,86,0,73,91,75,89,89,75,32,81,76,85,76,89,75,88,79,88,83,32,85,76,88,76,88,79,0,73,91,89,75,75,89,32,76,81,76,85,75,89,79,88,83,88,32,76,85,76,88,79,88,0,73,91,89,89,75,75,32,83,76,79,76,75,75,76,79,76,83,32,79,76,76,76,76,79,0,73,91,75,75,89,89,32,81,88,85,88,89,89,88,85,88,81,32,85,88,88,88,88,85,0,70,95,74,77,73,76,73,74,74,72,76,71,78,71,80,72,81,73,82,75,83,80,32,73,74,75,72,77,72,79,73,80,74,81,76,82,80,82,91,32,91,77,92,76,92,74,91,72,89,71,87,71,85,72,84,73,83,75,82,80,32,92,74,90,72,88,72,86,73,85,74,84,76,83,80,83,91,0,70,94,73,71,74,75,75,77,77,79,80,80,84,80,87,79,89,77,90,75,91,71,32,73,71,74,74,75,76,77,78,80,79,84,79,87,78,89,76,90,74,91,71,32,80,79,78,80,77,81,76,83,76,86,77,88,79,90,81,91,83,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,32,80,80,78,81,77,83,77,86,78,89,32,86,89,87,86,87,83,86,81,84,80,0,70,94,77,74,77,86,32,78,75,78,85,32,86,75,86,85,32,87,74,87,86,32,73,71,75,73,77,74,80,75,84,75,87,74,89,73,91,71,32,73,89,75,87,77,86,80,85,84,85,87,86,89,87,91,89,0,70,94,91,73,76,73,74,74,73,76,73,78,74,80,76,81,78,81,80,80,81,78,81,76,80,74,91,74,32,73,77,74,79,75,80,77,81,32,81,77,80,75,79,74,77,73,32,73,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,84,81,83,83,83,85,84,87,73,87,32,91,84,90,82,89,81,87,80,32,83,84,84,86,85,87,87,88,0,70,93,79,85,77,84,76,84,74,85,73,87,73,88,74,90,76,91,77,91,79,90,80,88,80,87,79,85,74,80,73,78,73,75,74,73,76,72,79,71,83,71,87,72,89,74,90,76,90,79,89,82,86,85,85,87,85,89,86,91,88,91,89,90,90,88,32,77,83,75,80,74,78,74,75,75,73,76,72,32,83,71,86,72,88,74,89,76,89,79,88,82,86,85,0,71,95,72,75,75,72,77,75,77,86,32,74,73,76,76,76,86,32,77,75,80,72,82,75,82,85,32,79,73,81,76,81,85,32,82,75,85,72,87,75,87,91,32,84,73,86,76,86,91,32,87,75,90,72,91,74,92,77,92,80,91,83,90,85,88,87,85,89,80,91,32,89,73,90,74,91,77,91,80,90,83,89,85,87,87,84,89,80,91,0,70,94,73,83,77,83,76,82,75,79,75,77,76,74,78,72,81,71,83,71,86,72,88,74,89,77,89,79,88,82,87,83,91,83,32,73,84,79,84,77,82,76,79,76,77,77,74,79,72,81,71,32,83,71,85,72,87,74,88,77,88,79,87,82,85,84,91,84,32,75,88,89,88,32,75,89,89,89,0,70,95,71,76,74,73,77,76,77,88,32,73,74,76,77,76,88,32,77,76,80,73,83,76,83,88,32,79,74,82,77,82,88,32,83,76,86,73,89,76,89,87,91,89,32,85,74,88,77,88,88,90,90,93,87,0,71,93,90,73,74,89,32,90,73,87,74,81,74,32,88,75,85,75,81,74,32,90,73,89,76,89,82,32,88,75,88,78,89,82,32,81,82,74,82,32,80,83,77,83,74,82,32,81,82,81,89,32,80,83,80,86,81,89,0,70,94,72,79,74,75,79,85,32,74,77,79,87,82,80,87,80,90,79,91,77,91,75,90,73,88,72,87,72,85,73,84,75,84,77,85,80,86,82,87,85,87,88,85,90,32,87,72,86,73,85,75,85,77,87,81,88,84,88,87,87,89,85,90,0,70,94,73,79,76,76,80,78,32,75,77,79,79,82,76,85,78,32,81,77,84,79,87,76,89,78,32,86,77,88,79,91,76,32,73,85,76,82,80,84,32,75,83,79,85,82,82,85,84,32,81,83,84,85,87,82,89,84,32,86,83,88,85,91,82,0,70,94,74,72,78,74,80,76,81,79,81,82,80,85,78,87,74,89,32,74,72,77,73,79,74,81,76,82,79,32,82,82,81,85,79,87,77,88,74,89,32,90,72,87,73,85,74,83,76,82,79,32,82,82,83,85,85,87,87,88,90,89,32,90,72,86,74,84,76,83,79,83,82,84,85,86,87,90,89,32,73,80,91,80,32,73,81,91,81,0,78,86,81,81,81,83,83,83,83,81,81,81,32,81,81,83,83,32,83,81,81,83,0,74,90,77,80,81,82,84,84,86,86,87,89,87,91,86,93,85,94,32,77,81,83,84,32,77,82,80,83,84,85,86,87,87,89,0,74,90,87,75,86,77,84,79,80,81,77,82,32,83,80,77,83,32,85,70,86,71,87,73,87,75,86,78,84,80,81,82,77,84,0,72,92,83,77,79,78,76,80,75,82,75,84,76,86,78,87,81,87,85,86,88,84,89,82,89,80,88,78,86,77,83,77,32,88,78,83,77,32,86,77,81,78,76,80,32,79,78,75,82,32,76,86,81,87,32,78,87,83,86,88,84,32,85,86,89,82,0,74,91,83,77,80,78,78,80,77,82,77,84,78,86,80,87,82,87,85,86,87,84,88,82,88,80,87,78,85,77,83,77,32,79,80,85,77,32,78,82,86,78,32,77,84,87,79,32,78,85,88,80,32,79,86,87,82,32,80,87,86,84,0,74,90,79,71,79,94,32,85,70,85,93,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,0,74,90,78,70,78,88,32,86,76,86,94,32,78,78,86,76,32,78,79,86,77,32,78,87,86,85,32,78,88,86,86,0,74,90,78,66,78,87,32,78,78,81,76,84,76,86,77,87,79,87,81,86,83,83,85,81,86,78,87,32,78,78,81,77,84,77,86,78,32,85,77,86,79,86,81,85,83,83,85,0,69,95,72,73,72,76,32,92,73,92,76,32,72,73,92,73,32,72,74,92,74,32,72,75,92,75,32,72,76,92,76,0,74,90,77,78,77,81,32,87,78,87,81,32,77,78,87,78,32,77,79,87,79,32,77,80,87,80,32,77,81,87,81,0,74,90,77,76,87,88,32,77,76,79,78,81,79,84,79,86,78,87,77,87,75,85,75,85,77,84,79,32,79,78,84,79,32,81,79,87,77,32,86,75,86,78,32,85,76,87,76,32,87,88,85,86,83,85,80,85,78,86,77,87,77,89,79,89,79,87,80,85,32,85,86,80,85,32,83,85,77,87,32,78,86,78,89,32,77,88,79,88,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,87,89,0,65,94,71,102,72,102,73,101,73,100,72,99,71,99,70,100,70,102,71,104,73,105,75,105,78,104,80,102,81,100,82,96,82,85,81,59,81,52,82,47,83,45,85,44,86,44,88,45,89,47,89,51,88,54,87,56,85,59,80,63,74,67,72,69,70,72,69,74,68,78,68,82,69,86,71,89,74,91,78,92,82,92,86,91,88,90,90,87,91,84,91,80,90,77,89,75,87,73,84,72,80,72,77,73,75,75,74,78,74,82,75,85,77,87,32,71,100,71,101,72,101,72,100,71,100,32,85,59,81,63,76,67,73,70,71,73,70,75,69,78,69,82,70,86,71,88,74,91,32,82,92,85,91,87,90,89,87,90,84,90,80,89,77,88,75,86,73,84,72,0,69,102,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,79,79,78,80,77,83,77,86,78,89,80,91,83,92,86,92,89,91,91,89,92,87,93,84,93,80,92,77,90,74,88,73,85,72,82,72,79,73,77,74,75,76,73,79,72,83,72,88,73,93,75,97,77,99,80,101,84,102,89,102,93,101,96,99,98,97,32,75,76,74,78,73,82,73,88,74,92,76,96,78,98,81,100,85,101,89,101,93,100,95,99,98,97,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,97,76,97,78,99,78,99,76,97,76,32,98,76,98,78,32,97,77,99,77,32,97,86,97,88,99,88,99,86,97,86,32,98,86,98,88,32,97,87,99,87,0,68,96,72,64,72,100,32,77,64,77,100,32,87,64,87,100,32,92,64,92,100,32,77,77,87,75,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,32,77,89,87,87,0,72,92,80,77,77,78,76,79,75,81,75,83,76,85,77,86,80,87,84,87,87,86,88,85,89,83,89,81,88,79,87,78,84,77,80,77,32,77,78,76,80,76,83,77,85,78,86,80,87,32,87,86,88,84,88,81,87,79,86,78,84,77,0,74,90,81,67,86,77,82,84,82,85,32,85,76,81,83,32,84,73,84,75,80,82,82,85,85,89,32,87,92,85,89,83,88,81,88,79,89,78,91,78,93,79,95,82,97,32,87,92,85,90,83,89,79,89,79,93,80,95,82,97,32,83,88,80,90,78,93,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,83,89,0,73,106,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,79,85,78,84,77,81,77,78,78,75,80,73,83,72,87,72,91,73,94,75,96,78,97,82,97,87,96,91,95,93,93,96,90,99,86,102,81,105,77,107,32,87,72,90,73,93,75,95,78,96,82,96,87,95,91,94,93,92,96,89,99,84,103,81,105,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,101,76,101,78,103,78,103,76,101,76,32,102,76,102,78,32,101,77,103,77,32,101,86,101,88,103,88,103,86,101,86,32,102,86,102,88,32,101,87,103,87,0,68,96,72,62,72,102,32,73,62,73,102,32,77,62,77,102,32,81,66,83,66,83,68,81,68,81,65,82,63,84,62,87,62,89,63,91,65,92,68,92,73,91,76,89,78,87,79,85,79,83,78,82,76,81,78,79,81,78,82,79,83,81,86,82,88,83,86,85,85,87,85,89,86,91,88,92,91,92,96,91,99,89,101,87,102,84,102,82,101,81,99,81,96,83,96,83,98,81,98,32,82,66,82,68,32,81,67,83,67,32,89,63,90,65,91,68,91,73,90,76,89,78,32,82,76,82,78,80,81,78,82,80,83,82,86,82,88,32,89,86,90,88,91,91,91,96,90,99,89,101,32,82,96,82,98,32,81,97,83,97,0,65,99,72,66,72,98,32,73,66,73,98,32,91,66,91,98,32,92,66,92,98,32,68,66,96,66,32,68,98,77,98,32,87,98,96,98,0,66,97,71,66,81,80,70,98,32,70,66,80,80,32,69,66,80,81,32,69,66,92,66,94,73,91,66,32,71,97,92,97,32,70,98,92,98,94,91,91,98,0,73,91,88,43,85,49,82,56,80,61,79,65,78,70,77,78,77,86,78,94,79,99,80,103,82,108,85,115,88,121,32,85,49,83,54,81,60,80,64,79,70,78,78,78,86,79,94,80,100,81,104,83,110,85,115,0,73,91,76,43,79,49,82,56,84,61,85,65,86,70,87,78,87,86,86,94,85,99,84,103,82,108,79,115,76,121,32,79,49,81,54,83,60,84,64,85,70,86,78,86,86,85,94,84,100,83,104,81,110,79,115,0,73,91,77,43,77,82,77,121,32,78,43,78,82,78,121,32,77,43,88,43,32,77,121,88,121,0,73,91,86,43,86,82,86,121,32,87,43,87,82,87,121,32,76,43,87,43,32,76,121,87,121,0,72,91,86,43,82,49,80,53,79,58,79,62,80,66,84,74,84,76,83,78,82,79,77,82,82,85,83,86,84,88,84,90,80,98,79,102,79,106,80,111,82,115,86,121,32,84,46,82,50,81,53,80,58,80,62,81,67,82,70,32,82,94,81,97,80,102,80,106,81,111,82,114,84,118,0,73,92,78,43,82,49,84,53,85,58,85,62,84,66,80,74,80,76,81,78,82,79,87,82,82,85,81,86,80,88,80,90,84,98,85,102,85,106,84,111,82,115,78,121,32,80,46,82,50,83,53,84,58,84,62,83,67,82,70,32,82,94,83,97,84,102,84,106,83,111,82,114,80,118,0,73,91,86,46,83,49,81,52,79,56,78,61,78,67,79,73,80,77,83,88,84,92,85,98,85,103,84,108,83,111,81,115,32,83,49,81,53,80,56,79,61,79,66,80,72,81,76,84,87,85,91,86,97,86,103,85,108,83,112,81,115,78,118,0,73,91,78,46,81,49,83,52,85,56,86,61,86,67,85,73,84,77,81,88,80,92,79,98,79,103,80,108,81,111,83,115,32,81,49,83,53,84,56,85,61,85,66,84,72,83,76,80,87,79,91,78,97,78,103,79,108,81,112,83,115,86,118,0,55,90,58,82,65,82,82,111,32,64,82,81,111,32,63,82,82,114,32,90,34,86,74,82,114,0,67,97,93,46,92,46,91,47,91,48,92,49,93,49,94,48,94,46,93,44,91,43,89,43,87,44,85,46,84,48,83,51,82,58,81,74,81,106,80,115,79,118,32,92,47,92,48,93,48,93,47,92,47,32,82,58,82,106,32,85,46,84,49,83,58,83,90,82,106,81,113,80,116,79,118,77,120,75,121,73,121,71,120,70,118,70,116,71,115,72,115,73,116,73,117,72,118,71,118,32,71,116,71,117,72,117,72,116,71,116,0,72,92,82,70,74,91,32,82,73,75,91,74,91,32,82,73,89,91,90,91,32,82,70,90,91,32,77,85,87,85,32,76,86,88,86,0,72,92,76,70,76,91,32,77,71,77,90,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,32,77,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,76,91,32,77,81,84,81,87,82,88,84,88,87,87,89,84,90,77,90,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,77,75,76,78,76,83,77,86,79,89,81,90,85,90,87,89,88,88,89,86,90,86,0,72,93,76,70,76,91,32,77,71,77,90,32,76,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,76,91,32,77,71,83,71,86,72,87,73,88,75,89,78,89,83,88,86,87,88,86,89,83,90,77,90,0,73,92,77,70,77,91,32,78,71,78,90,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,32,78,90,89,90,89,91,32,77,91,89,91,0,73,91,77,70,77,91,32,78,71,78,91,77,91,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,82,85,82,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,78,73,77,75,76,78,76,83,77,86,78,88,79,89,81,90,85,90,87,89,88,88,89,86,89,83,85,83,85,82,0,71,93,75,70,75,91,32,75,70,76,70,76,91,75,91,32,89,70,88,70,88,91,89,91,32,89,70,89,91,32,76,80,88,80,32,76,81,88,81,0,78,87,82,70,82,91,83,91,32,82,70,83,70,83,91,0,74,91,86,70,86,86,85,89,83,90,81,90,79,89,78,86,77,86,32,86,70,87,70,87,86,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,72,93,76,70,76,91,77,91,32,76,70,77,70,77,91,32,90,70,89,70,77,82,32,90,70,77,83,32,80,79,89,91,90,91,32,81,79,90,91,0,73,90,77,70,77,91,32,77,70,78,70,78,90,32,78,90,89,90,89,91,32,77,91,89,91,0,70,94,74,70,74,91,32,75,75,75,91,74,91,32,75,75,82,91,32,74,70,82,88,32,90,70,82,88,32,89,75,82,91,32,89,75,89,91,90,91,32,90,70,90,91,0,71,93,75,70,75,91,32,76,73,76,91,75,91,32,76,73,89,91,32,75,70,88,88,32,88,70,88,88,32,88,70,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,77,81,32,77,71,85,71,87,72,88,74,88,77,87,79,85,80,77,80,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,32,83,88,88,93,89,93,32,83,88,84,88,89,93,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,77,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,77,80,32,82,81,88,91,89,91,32,83,81,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,84,81,86,82,87,83,88,85,88,88,87,89,84,90,80,90,78,89,77,88,75,88,32,89,73,87,73,86,72,84,71,80,71,77,72,76,73,76,75,77,77,79,78,84,80,86,81,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,91,82,71,82,91,32,83,71,83,91,82,91,32,76,70,89,70,89,71,32,76,70,76,71,89,71,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,75,70,76,70,76,85,77,88,78,89,81,90,83,90,86,89,87,88,88,85,88,70,89,70,0,72,92,74,70,82,91,32,74,70,75,70,82,88,32,90,70,89,70,82,88,32,90,70,82,91,0,69,95,71,70,77,91,32,71,70,72,70,77,88,32,82,70,77,88,32,82,73,77,91,32,82,73,87,91,32,82,70,87,88,32,93,70,92,70,87,88,32,93,70,87,91,0,72,92,75,70,88,91,89,91,32,75,70,76,70,89,91,32,89,70,88,70,75,91,32,89,70,76,91,75,91,0,73,92,75,70,82,80,82,91,83,91,32,75,70,76,70,83,80,32,90,70,89,70,82,80,32,90,70,83,80,83,91,0,72,92,88,70,75,91,32,89,70,76,91,32,75,70,89,70,32,75,70,75,71,88,71,32,76,90,89,90,89,91,32,75,91,89,91,0,69,92,88,70,86,72,84,75,81,80,79,83,76,87,73,90,71,91,69,91,68,90,68,88,69,87,70,88,69,89,32,88,70,87,74,85,84,84,91,32,88,70,85,91,32,84,91,84,89,83,86,82,84,80,82,78,81,76,81,75,82,75,84,76,87,79,90,82,91,86,91,88,90,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,88,70,90,71,91,73,91,75,90,77,88,78,84,79,82,79,32,88,70,89,71,90,73,90,75,89,77,88,78,32,84,79,87,80,88,81,89,83,89,86,88,89,87,90,85,91,83,91,82,90,82,88,83,85,32,84,79,86,80,87,81,88,83,88,86,87,89,85,91,0,72,93,75,72,74,74,74,76,75,78,78,79,81,79,85,78,87,77,89,75,90,73,90,71,89,70,87,70,84,71,81,74,79,77,77,81,76,85,76,88,77,90,80,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,87,70,85,71,82,74,80,77,78,81,77,85,77,88,78,90,80,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,74,87,76,88,78,90,80,91,83,91,85,90,87,88,89,84,90,79,90,76,89,73,87,71,85,70,80,70,77,71,75,73,74,75,74,77,75,78,77,78,78,77,79,75,0,73,92,87,73,86,74,86,76,87,77,89,77,90,75,90,73,89,71,87,70,84,70,82,71,81,72,80,74,80,76,81,78,83,79,32,84,70,82,72,81,74,81,77,83,79,32,83,79,81,79,78,80,76,82,75,84,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,81,79,79,80,77,82,76,84,76,88,77,90,0,71,92,87,72,86,74,84,79,82,85,81,87,79,90,77,91,32,81,76,80,78,78,79,76,79,75,77,75,75,76,73,78,71,81,70,91,70,88,71,87,72,86,75,84,83,83,86,82,88,80,90,77,91,75,91,73,90,72,89,72,88,73,87,74,88,73,89,32,83,70,87,71,88,71,32,79,83,80,82,82,81,86,81,88,80,90,77,88,84,0,71,93,74,73,73,75,73,77,74,79,76,80,79,80,82,79,84,78,87,75,88,72,88,71,87,70,86,70,84,71,82,73,81,75,80,78,80,81,81,83,83,84,85,84,87,83,89,81,90,79,32,87,70,85,71,83,73,82,75,81,78,81,82,83,84,32,90,79,89,83,87,87,85,89,83,90,79,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,32,89,83,87,86,85,88,82,90,79,91,0,70,94,76,76,75,75,75,73,76,71,79,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,74,84,75,83,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,71,88,74,87,76,85,82,84,86,84,89,86,91,87,91,89,90,91,88,32,92,70,90,72,88,76,86,82,85,86,85,89,86,91,0,73,89,87,72,85,75,83,80,81,85,80,87,78,90,76,91,32,89,76,87,78,84,79,81,79,79,78,78,76,78,74,79,72,81,71,85,70,89,70,87,72,86,74,84,80,82,86,81,88,79,90,76,91,74,91,73,90,73,88,74,87,75,88,74,89,0,73,90,89,70,87,72,85,75,83,80,80,89,78,93,32,89,77,87,79,84,80,81,80,79,79,78,77,78,75,79,73,81,71,85,70,89,70,87,73,86,75,83,84,81,88,80,90,78,93,77,94,75,95,74,94,74,92,75,90,77,88,79,87,82,86,86,85,0,70,94,76,76,75,75,75,73,77,71,80,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,90,71,87,75,85,77,83,78,80,79,32,93,71,92,72,93,73,94,72,94,71,93,70,92,70,90,71,87,76,86,77,84,78,80,79,32,80,79,83,80,84,82,85,89,86,91,32,80,79,82,80,83,82,84,89,86,91,87,91,89,90,91,88,0,73,91,77,73,76,75,76,77,77,79,79,80,82,80,85,79,87,78,90,75,91,72,91,71,90,70,89,70,87,71,86,72,84,75,80,85,79,87,77,90,75,91,32,86,72,84,76,82,83,81,86,80,88,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,82,91,85,91,87,90,89,88,0,68,96,82,70,78,79,75,85,73,88,71,90,69,91,67,91,66,90,66,88,67,87,68,88,67,89,32,82,70,80,77,79,81,78,86,78,90,80,91,32,82,70,81,74,80,79,79,86,79,90,80,91,32,91,70,87,79,82,88,80,91,32,91,70,89,77,88,81,87,86,87,90,89,91,90,91,92,90,94,88,32,91,70,90,74,89,79,88,86,88,90,89,91,0,71,94,82,70,81,74,79,80,77,85,76,87,74,90,72,91,70,91,69,90,69,88,70,87,71,88,70,89,32,82,70,82,75,83,86,84,91,32,82,70,83,75,84,86,84,91,32,96,71,95,72,96,73,97,72,97,71,96,70,94,70,92,71,90,74,89,76,87,81,85,87,84,91,0,72,93,83,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,87,71,85,72,83,74,81,78,80,83,80,86,32,81,71,79,74,77,78,76,82,76,86,77,89,79,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,86,70,89,71,90,72,91,74,91,77,90,79,89,80,86,81,84,81,82,80,32,86,70,88,71,89,72,90,74,90,77,89,79,88,80,86,81,0,72,93,85,74,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,88,90,90,88,32,87,70,88,71,89,73,89,77,88,80,86,83,83,86,79,89,75,91,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,87,70,90,71,91,73,91,75,90,77,89,78,86,79,82,79,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,82,79,85,80,86,82,87,89,88,91,32,82,79,84,80,85,82,86,89,88,91,89,91,91,90,93,88,0,72,92,78,73,77,75,77,77,78,79,80,80,83,80,86,79,88,78,91,75,92,72,92,71,91,70,90,70,88,71,87,72,86,74,85,77,83,84,82,87,80,90,78,91,32,86,74,85,78,84,85,83,88,81,90,78,91,75,91,73,90,72,88,72,87,73,86,74,87,73,88,0,73,91,89,72,88,74,86,79,84,85,83,87,81,90,79,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,92,70,90,71,89,72,88,75,86,83,85,86,84,88,82,90,79,91,77,91,75,90,74,89,74,88,75,87,76,88,75,89,32,85,70,89,71,90,71,0,71,93,72,74,74,71,76,70,77,70,79,72,79,75,78,78,75,86,75,89,76,91,32,77,70,78,72,78,75,75,83,74,86,74,89,76,91,78,91,80,90,83,87,85,84,86,82,32,90,70,86,82,85,86,85,89,87,91,88,91,90,90,92,88,32,91,70,87,82,86,86,86,89,87,91,0,71,92,72,74,74,71,76,70,77,70,79,72,79,75,78,79,76,86,76,89,77,91,32,77,70,78,72,78,75,76,82,75,86,75,89,77,91,78,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,76,87,78,89,80,91,81,93,81,0,70,93,73,76,72,76,71,75,71,73,72,71,74,70,78,70,77,72,76,76,75,85,74,91,32,76,76,76,85,75,91,32,86,70,84,72,82,76,79,85,77,89,75,91,32,86,70,85,72,84,76,83,85,82,91,32,84,76,84,85,83,91,32,96,70,94,71,92,73,90,76,87,85,85,89,83,91,0,72,92,80,75,79,76,77,76,76,75,76,73,77,71,79,70,81,70,83,71,84,73,84,76,83,80,81,85,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,81,70,82,71,83,73,83,76,82,80,80,85,78,88,76,90,74,91,32,93,71,92,72,93,73,94,72,94,71,93,70,91,70,89,71,87,73,85,76,83,80,82,85,82,88,83,90,84,91,85,91,87,90,89,88,0,71,93,74,74,76,71,78,70,79,70,81,71,81,73,79,79,79,82,80,84,32,79,70,80,71,80,73,78,79,78,82,80,84,82,84,85,83,87,81,89,78,90,76,32,92,70,90,76,87,84,85,88,32,93,70,91,76,89,81,87,85,85,88,83,90,80,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,0,71,92,90,72,89,74,87,79,86,82,85,84,83,87,81,89,79,90,76,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,93,70,91,71,90,72,89,75,88,79,86,85,84,88,81,90,76,91,72,91,71,90,71,88,72,87,74,87,76,88,79,90,81,91,84,91,87,90,89,88,32,86,70,90,71,91,71,0,72,92,87,77,87,91,88,91,32,87,77,88,77,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,88,80,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,72,92,87,70,87,91,88,91,32,87,70,88,70,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,73,91,77,84,88,84,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,77,83,87,83,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,76,90,87,70,85,70,83,71,82,74,82,91,83,91,32,87,70,87,71,85,71,83,72,32,84,71,83,74,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,88,77,87,77,87,92,86,95,85,96,83,97,81,97,79,96,78,95,76,95,32,88,77,88,92,87,95,85,97,83,98,80,98,78,97,76,95,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,91,83,91,32,82,77,83,77,83,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,98,83,98,32,82,77,83,77,83,98,0,72,91,76,70,76,91,77,91,32,76,70,77,70,77,91,32,88,77,87,77,77,87,32,88,77,77,88,32,80,84,86,91,88,91,32,81,83,88,91,0,67,98,71,77,71,91,72,91,32,71,77,72,77,72,91,32,72,81,75,78,77,77,80,77,82,78,83,81,83,91,32,72,81,75,79,77,78,79,78,81,79,82,81,82,91,83,91,32,83,81,86,78,88,77,91,77,93,78,94,81,94,91,32,83,81,86,79,88,78,90,78,92,79,93,81,93,91,94,91,0,72,92,76,77,76,91,77,91,32,76,77,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,32,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,88,88,85,88,83,87,80,86,79,84,78,81,78,0,72,92,76,77,76,98,77,98,32,76,77,77,77,77,98,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,72,92,87,77,87,98,88,98,32,87,77,88,77,88,98,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,75,89,79,77,79,91,80,91,32,79,77,80,77,80,91,32,80,83,81,80,83,78,85,77,88,77,32,80,83,81,81,83,79,85,78,88,78,88,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,85,87,86,32,86,85,87,87,87,88,86,90,32,87,89,84,90,81,90,78,89,32,79,90,78,88,77,88,32,88,80,87,80,86,78,32,87,79,84,78,81,78,78,79,32,79,78,78,80,79,82,32,78,81,80,82,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,88,82,70,82,91,83,91,32,82,70,83,70,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,76,77,76,87,77,90,79,91,82,91,84,90,87,87,32,76,77,77,77,77,87,78,89,80,90,82,90,84,89,87,87,32,87,77,87,91,88,91,32,87,77,88,77,88,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,32,88,77,82,91,0,70,94,73,77,78,91,32,73,77,74,77,78,88,32,82,77,78,88,32,82,80,78,91,32,82,80,86,91,32,82,77,86,88,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+317444);allocate([91,77,90,77,86,88,32,91,77,86,91,0,73,91,76,77,87,91,88,91,32,76,77,77,77,88,91,32,88,77,87,77,76,91,32,88,77,77,91,76,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,78,98,32,88,77,82,91,79,98,78,98,0,73,91,86,78,76,91,32,88,77,78,90,32,76,77,88,77,32,76,77,76,78,86,78,32,78,90,88,90,88,91,32,76,91,88,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,76,90,76,86,78,83,80,79,32,83,70,77,88,77,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,88,87,90,86,32,84,70,78,88,78,90,79,91,0,76,88,84,83,83,84,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,90,70,84,88,84,90,86,91,88,90,89,89,91,86,32,91,70,85,88,85,90,86,91,0,76,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,79,88,82,82,85,79,87,76,88,73,88,71,87,70,85,71,84,73,75,100,75,102,76,103,78,102,79,99,80,90,81,91,83,91,85,90,86,89,88,86,32,84,73,83,78,82,82,79,91,77,96,75,100,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,91,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,79,88,79,90,81,91,83,90,84,89,86,86,32,82,82,80,88,80,90,81,91,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,75,100,32,82,82,79,91,77,96,75,100,74,102,72,103,71,102,71,100,72,97,74,95,77,93,81,91,84,89,86,86,0,76,90,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,85,82,85,83,86,83,85,82,84,82,82,84,79,85,32,79,85,82,86,83,90,84,91,32,79,85,81,86,82,90,84,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,0,69,94,69,86,71,83,73,82,75,83,75,85,73,91,32,73,82,74,83,74,85,72,91,32,75,85,77,83,79,82,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,89,83,89,85,88,88,88,90,89,91,32,87,82,88,83,88,85,87,88,87,90,89,91,91,90,92,89,94,86,0,73,91,73,86,75,83,77,82,79,83,79,85,77,91,32,77,82,78,83,78,85,76,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,89,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,86,88,88,87,89,86,32,80,82,78,84,77,86,77,89,79,91,0,76,91,76,86,78,83,80,79,32,81,76,72,103,32,82,76,73,103,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,80,102,81,103,83,102,84,99,84,91,86,91,89,89,91,86,32,87,82,84,91,82,96,80,100,0,76,90,76,86,78,83,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,86,85,32,86,82,86,85,87,87,88,87,90,86,0,78,90,78,86,80,83,81,81,81,83,84,85,85,87,85,89,84,90,82,91,32,81,83,83,85,84,87,84,89,82,91,32,78,90,80,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,32,80,78,86,78,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,75,90,78,82,77,84,76,87,76,90,78,91,79,91,82,90,84,88,85,85,85,82,32,79,82,78,84,77,87,77,90,78,91,32,85,82,86,86,87,87,88,87,90,86,0,72,93,76,82,74,84,73,87,73,90,75,91,76,91,78,90,80,88,32,77,82,75,84,74,87,74,90,75,91,32,82,82,80,88,80,90,82,91,83,91,85,90,87,88,88,85,88,82,32,83,82,81,88,81,90,82,91,32,88,82,89,86,90,87,91,87,93,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,85,80,88,79,90,77,91,76,91,75,90,75,89,76,89,75,90,32,87,83,86,84,87,84,87,83,86,82,85,82,83,83,82,85,81,88,81,90,82,91,85,91,88,89,90,86,32,81,83,82,85,32,83,83,81,85,32,80,88,81,90,32,81,88,79,90,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,89,76,86,78,83,80,82,82,82,84,83,84,86,83,88,80,90,78,91,32,82,82,83,83,83,86,82,88,80,90,32,78,91,80,92,81,94,81,97,80,100,78,102,76,103,75,102,75,100,76,97,79,94,82,92,86,89,89,86,32,78,91,79,92,80,94,80,97,79,100,78,102,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,79,71,77,74,76,79,76,82,77,87,79,90,32,78,89,81,90,83,90,86,89,32,85,90,87,87,88,82,88,79,87,74,85,71,32,86,72,83,71,81,71,78,72,0,72,92,78,74,80,73,83,70,83,91,32,78,74,78,75,80,74,82,72,82,91,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,76,91,32,76,75,77,75,77,74,78,72,80,71,84,71,86,72,87,74,87,76,86,78,84,81,75,91,32,76,90,89,90,89,91,32,75,91,89,91,0,72,92,77,70,88,70,81,79,32,77,70,77,71,87,71,32,87,70,80,79,32,81,78,83,78,86,79,88,81,89,84,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,80,79,83,79,86,80,88,83,32,84,79,87,81,88,84,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,85,73,85,91,86,91,32,86,70,86,91,32,86,70,75,86,90,86,32,85,73,76,86,32,76,85,90,85,90,86,0,72,92,77,70,76,79,32,78,71,77,78,32,77,70,87,70,87,71,32,78,71,87,71,32,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,76,79,77,79,79,78,83,78,86,79,88,82,32,84,78,87,80,88,83,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,86,71,87,73,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,32,87,72,84,71,82,71,79,72,32,80,71,78,74,77,79,77,84,78,88,81,90,32,77,86,79,89,82,90,83,90,86,89,88,86,32,84,90,87,88,88,85,88,84,87,81,84,79,32,88,83,86,80,83,79,82,79,79,80,77,83,32,81,79,78,81,77,84,0,72,92,75,70,89,70,79,91,32,75,70,75,71,88,71,32,88,70,78,91,79,91,0,72,92,80,70,77,71,76,73,76,75,77,77,78,78,80,79,84,80,86,81,87,82,88,84,88,87,87,89,84,90,80,90,77,89,76,87,76,84,77,82,78,81,80,80,84,79,86,78,87,77,88,75,88,73,87,71,84,70,80,70,32,78,71,77,73,77,75,78,77,80,78,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,80,79,84,78,86,77,87,75,87,73,86,71,32,87,72,84,71,80,71,77,72,32,76,88,79,90,32,85,90,88,88,0,72,92,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,77,88,78,90,32,87,77,86,80,83,82,32,87,78,85,81,82,82,81,82,78,81,76,78,32,80,82,77,80,76,77,76,76,77,73,80,71,32,76,75,78,72,81,71,82,71,85,72,87,75,32,83,71,86,73,87,77,87,82,86,87,84,90,32,85,89,82,90,80,90,77,89,0,77,88,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,70,82,84,83,84,32,82,70,83,70,83,84,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,76,75,76,74,77,72,78,71,81,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,82,81,32,76,75,77,75,77,74,78,72,81,71,84,71,87,72,88,74,88,76,87,78,85,79,82,80,32,77,73,80,71,32,85,71,88,73,32,88,77,84,80,32,82,80,82,84,83,84,83,80,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,70,82,71,81,73,81,76,82,77,83,77,84,76,84,75,83,74,82,74,81,75,32,82,75,82,76,83,76,83,75,82,75,32,82,71,81,75,32,81,73,82,74,0,77,88,84,72,83,73,82,73,81,72,81,71,82,70,83,70,84,71,84,74,83,76,81,77,32,82,71,82,72,83,72,83,71,82,71,32,83,73,84,74,32,84,72,83,76,0,70,95,92,77,90,77,88,78,87,80,85,86,84,88,83,89,81,90,77,90,75,89,74,87,74,85,75,83,76,82,81,79,83,77,84,75,84,73,83,71,81,70,80,70,78,71,77,73,77,75,78,78,80,81,85,87,88,90,90,91,92,91,32,92,77,92,78,90,78,87,80,32,90,77,88,80,86,86,85,88,83,90,81,91,77,91,75,90,74,89,73,87,73,85,74,83,76,81,81,78,82,77,83,75,83,73,82,71,32,83,72,81,71,80,71,78,72,32,79,71,78,73,78,75,79,78,81,81,86,87,88,89,90,90,92,90,92,91,0,73,92,82,66,82,95,83,95,32,82,66,83,66,83,95,32,87,73,89,73,87,71,84,70,81,70,78,71,76,73,76,75,77,77,78,78,86,82,87,83,88,85,88,87,87,89,84,90,81,90,79,89,78,88,32,87,73,86,72,84,71,81,71,78,72,77,73,77,75,78,77,86,81,88,83,89,85,89,87,88,89,87,90,84,91,81,91,78,90,76,88,78,88,32,88,88,85,90,0,71,94,91,66,73,98,74,98,32,91,66,92,66,74,98,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,86,98,32,85,66,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,79,98,32,78,66,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,0,74,90,82,70,81,71,83,81,82,82,32,82,70,82,82,32,82,70,83,71,81,81,82,82,32,77,73,78,73,86,79,87,79,32,77,73,87,79,32,77,73,77,74,87,78,87,79,32,87,73,86,73,78,79,77,79,32,87,73,77,79,32,87,73,87,74,77,78,77,79,0,70,95,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,82,73,82,90,83,90,32,82,73,83,73,83,90,32,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,74,77,91,77,91,78,32,74,77,74,78,91,78,32,74,85,91,85,91,86,32,74,85,74,86,91,86,0,78,87,83,70,82,71,82,77,32,83,71,82,77,32,83,70,84,71,82,77,0,73,91,78,70,77,71,77,77,32,78,71,77,77,32,78,70,79,71,77,77,32,87,70,86,71,86,77,32,87,71,86,77,32,87,70,88,71,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,32,81,70,78,73,79,77,83,78,86,75,85,71,81,70,32,83,70,79,71,78,75,81,78,85,77,86,73,83,70,0,70,94,90,73,74,82,90,91,32,90,73,90,74,76,82,90,90,90,91,0,70,94,74,73,90,82,74,91,32,74,73,74,74,88,82,74,90,74,91,0,71,94,79,70,79,98,80,98,32,79,70,80,70,80,98,32,85,70,85,98,86,98,32,85,70,86,70,86,98,32,74,80,91,80,91,81,32,74,80,74,81,91,81,32,74,87,91,87,91,88,32,74,87,74,88,91,88,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,73,91,32,91,70,92,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,78,70,74,71,73,75,77,77,80,74,78,70,32,76,70,73,73,75,77,79,76,80,72,76,70,32,89,84,85,85,84,89,88,91,91,88,89,84,32,87,84,84,87,86,91,90,90,91,86,87,84,0,69,96,87,77,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,87,84,32,87,77,84,76,81,76,79,77,78,79,78,82,79,84,81,85,84,85,87,84,32,86,75,86,83,87,85,89,86,90,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,85,91,89,90,32,86,75,87,75,87,83,88,85,90,86,32,89,86,91,85,92,83,92,79,91,76,90,74,89,73,87,72,84,71,81,71,78,72,76,73,75,74,74,76,73,79,73,82,74,85,75,87,76,88,78,89,81,90,85,90,89,89,89,90,0,69,95,74,80,76,79,78,79,80,80,83,84,84,85,86,86,88,86,90,85,91,83,91,81,90,79,88,78,86,78,84,79,83,80,80,84,78,85,76,85,74,84,32,90,80,88,79,86,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,86,85,88,85,90,84,32,75,79,74,81,74,83,75,85,32,89,85,90,83,90,81,89,79,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,79,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,72,93,84,74,79,91,32,86,70,80,91,32,86,70,83,73,80,75,78,76,32,85,73,81,75,78,76,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,84,81,80,83,77,85,75,87,73,91,32,86,70,88,71,89,73,89,75,88,77,86,79,80,83,32,74,89,75,88,77,88,82,90,85,90,87,89,88,87,32,77,88,82,91,85,91,87,90,88,87,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,86,79,83,80,32,86,70,88,71,89,73,89,75,88,77,86,79,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,80,85,81,86,82,87,84,87,87,86,89,85,90,83,91,0,72,93,88,71,82,91,32,89,70,83,91,32,89,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,86,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,82,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,78,85,79,86,80,87,82,87,85,86,88,84,90,82,91,0,72,93,89,73,88,74,89,75,90,74,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,77,82,76,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,88,77,90,32,82,91,84,90,86,88,87,86,87,82,86,80,0,72,93,78,70,76,76,32,91,70,90,73,88,76,83,82,81,85,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,32,77,73,80,70,82,70,87,73,32,78,72,80,71,82,71,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,88,79,89,78,90,76,90,73,89,71,86,70,83,70,32,83,70,81,71,80,72,79,74,79,77,80,79,81,80,32,84,80,87,79,88,78,89,76,89,73,88,71,86,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,81,80,78,81,76,83,75,85,75,88,76,90,78,91,32,82,91,85,90,86,89,87,87,87,83,86,81,0,72,93,89,77,88,79,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,74,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,87,76,86,77,87,76,88,32,79,81,78,79,78,75,79,73,81,71,83,70,32,88,71,89,73,89,78,88,82,87,85,85,88,83,90,81,91,0,77,88,80,89,79,90,80,91,81,90,80,89,0,77,88,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,89,79,90,80,91,81,90,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,85,70,84,71,82,83,32,85,71,82,83,32,85,70,86,71,82,83,32,80,89,79,90,80,91,81,90,80,89,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,83,80,81,81,81,83,82,84,84,84,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,80,89,79,90,80,91,81,90,80,89,0,77,88,86,70,84,72,83,74,83,75,84,76,85,75,84,74,0,77,88,85,72,84,71,85,70,86,71,86,72,85,74,83,76,0,69,95,92,78,91,79,92,80,93,79,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,83,88,85,90,87,91,89,91,90,89,90,88,32,75,91,73,90,72,88,72,86,73,84,74,83,80,80,32,79,76,80,81,81,84,83,87,85,89,87,90,89,90,90,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,74,89,75,90,76,91,75,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,0,71,93,95,66,69,98,0,75,90,90,66,86,69,83,72,81,75,79,79,78,84,78,88,79,93,80,96,81,98,32,86,69,83,73,81,77,80,80,79,85,79,90,80,95,81,98,0,74,89,83,66,84,68,85,71,86,76,86,80,85,85,83,89,81,92,78,95,74,98,32,83,66,84,69,85,74,85,79,84,84,83,87,81,91,78,95,0,74,91,84,70,84,82,32,79,73,89,79,32,89,73,79,79,0,78,87,85,70,83,77,32,86,70,83,77,0,73,91,80,70,78,77,32,81,70,78,77,32,89,70,87,77,32,90,70,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,0,72,93,83,70,76,98,32,89,70,82,98,32,76,81,90,81,32,75,87,89,87,0,69,95,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,70,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,89,70,89,76,88,70,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,70,94,78,70,78,76,77,84,76,88,75,90,74,91,32,88,70,88,91,32,89,70,89,91,32,75,70,92,70,32,71,91,92,91,32,71,91,71,98,32,72,91,71,98,32,91,91,92,98,32,92,91,92,98,0,67,98,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,71,71,72,72,71,73,70,72,70,71,71,70,72,70,73,71,74,73,75,77,76,79,78,80,87,80,89,79,90,77,91,73,92,71,93,70,94,70,95,71,95,72,94,73,93,72,94,71,32,78,80,76,81,75,83,74,88,73,90,72,91,32,78,80,77,81,76,83,75,88,74,90,73,91,71,91,70,90,69,88,32,87,80,89,81,90,83,91,88,92,90,93,91,32,87,80,88,81,89,83,90,88,91,90,92,91,94,91,95,90,96,88,32,79,91,86,91,0,72,92,76,73,75,70,75,76,76,73,78,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,79,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,32,78,64,78,63,77,63,77,64,78,66,80,67,84,67,86,66,87,64,0,70,94,75,70,75,91,32,76,70,76,91,32,72,70,79,70,32,76,80,83,80,85,79,86,77,87,73,88,71,89,70,90,70,91,71,91,72,90,73,89,72,90,71,32,83,80,85,81,86,83,87,88,88,90,89,91,32,83,80,84,81,85,83,86,88,87,90,88,91,90,91,91,90,92,88,32,72,91,79,91,0,69,94,77,70,77,76,76,84,75,88,74,90,73,91,72,91,71,90,71,89,72,88,73,89,72,90,32,88,70,88,91,32,89,70,89,91,32,74,70,92,70,32,85,91,92,91,0,72,93,75,70,82,86,32,76,70,83,86,32,90,70,83,86,81,89,80,90,78,91,77,91,76,90,76,89,77,88,78,89,77,90,32,73,70,79,70,32,86,70,92,70,0,70,95,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,80,73,76,74,74,76,73,79,73,82,74,85,76,87,80,88,85,88,89,87,91,85,92,82,92,79,91,76,89,74,85,73,80,73,32,80,73,77,74,75,76,74,79,74,82,75,85,77,87,80,88,32,85,88,88,87,90,85,91,82,91,79,90,76,88,74,85,73,32,79,91,86,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,72,91,92,91,32,91,91,92,98,32,92,91,92,98,0,70,93,75,70,75,81,76,83,79,84,82,84,85,83,87,81,32,76,70,76,81,77,83,79,84,32,87,70,87,91,32,88,70,88,91,32,72,70,79,70,32,84,70,91,70,32,84,91,91,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,32,96,91,97,98,32,97,91,97,98,0,70,96,80,70,80,91,32,81,70,81,91,32,73,70,72,76,72,70,84,70,32,81,80,88,80,91,81,92,82,93,84,93,87,92,89,91,90,88,91,77,91,32,88,80,90,81,91,82,92,84,92,87,91,89,90,90,88,91,0,67,97,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,73,80,80,80,83,81,84,82,85,84,85,87,84,89,83,90,80,91,69,91,32,80,80,82,81,83,82,84,84,84,87,83,89,82,90,80,91,32,91,70,91,91,32,92,70,92,91,32,88,70,95,70,32,88,91,95,91,0,72,93,77,70,77,91,32,78,70,78,91,32,74,70,81,70,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,74,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,72,93,76,73,75,70,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,32,80,80,89,80,0,67,98,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,69,91,76,91,32,86,70,83,71,81,73,80,75,79,79,79,82,80,86,81,88,83,90,86,91,88,91,91,90,93,88,94,86,95,82,95,79,94,75,93,73,91,71,88,70,86,70,32,86,70,84,71,82,73,81,75,80,79,80,82,81,86,82,88,84,90,86,91,32,88,91,90,90,92,88,93,86,94,82,94,79,93,75,92,73,90,71,88,70,32,73,80,79,80,0,71,93,87,70,87,91,32,88,70,88,91,32,91,70,79,70,76,71,75,72,74,74,74,76,75,78,76,79,79,80,87,80,32,79,70,77,71,76,72,75,74,75,76,76,78,77,79,79,80,32,82,80,80,81,79,82,76,89,75,90,74,90,73,89,32,80,81,79,83,77,90,76,91,74,91,73,89,73,88,32,84,91,91,91,0,72,92,88,70,87,71,81,73,78,75,76,78,75,81,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,78,78,76,80,75,83,32,88,70,87,72,85,73,81,74,78,76,76,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,85,77,88,78,89,80,89,81,88,83,85,84,32,85,77,87,78,88,80,88,81,87,83,85,84,32,78,84,85,84,88,85,89,87,89,88,88,90,85,91,74,91,32,85,84,87,85,88,87,88,88,87,90,85,91,0,72,90,77,77,77,91,32,78,77,78,91,32,74,77,88,77,88,82,87,77,32,74,91,81,91,0,70,93,78,77,78,81,77,87,76,90,75,91,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,73,91,72,96,72,91,91,91,91,96,90,91,0,69,96,82,77,82,91,32,83,77,83,91,32,79,77,86,77,32,74,78,73,79,72,78,73,77,74,77,75,78,77,82,78,83,80,84,85,84,87,83,88,82,90,78,91,77,92,77,93,78,92,79,91,78,32,80,84,78,85,77,86,75,90,74,91,32,80,84,78,86,76,90,75,91,73,91,72,90,71,88,32,85,84,87,85,88,86,90,90,91,91,32,85,84,87,86,89,90,90,91,92,91,93,90,94,88,32,79,91,86,91,0,73,91,77,79,76,77,76,81,77,79,78,78,80,77,84,77,87,78,88,80,88,81,87,83,84,84,32,84,77,86,78,87,80,87,81,86,83,84,84,32,81,84,84,84,87,85,88,87,88,88,87,90,84,91,80,91,77,90,76,88,76,87,77,86,78,87,77,88,32,84,84,86,85,87,87,87,88,86,90,84,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,32,79,71,79,70,78,70,78,71,79,73,81,74,83,74,85,73,86,71,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,81,77,32,78,84,80,84,83,83,84,82,86,78,87,77,88,77,89,78,88,79,87,78,32,80,84,83,85,84,86,86,90,87,91,32,80,84,82,85,83,86,85,90,86,91,88,91,89,90,90,88,32,74,91,81,91,0,71,93,78,77,78,81,77,87,76,90,75,91,74,91,73,90,74,89,75,90,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,84,91,91,91,0,71,94,76,77,76,91,32,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,88,77,88,91,32,89,77,89,91,32,73,77,77,77,32,88,77,92,77,32,73,91,79,91,32,85,91,92,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,77,84,87,84,32,73,91,80,91,32,84,91,91,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,73,92,82,77,82,91,32,83,77,83,91,32,77,77,76,82,76,77,89,77,89,82,88,77,32,79,91,86,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,72,93,82,70,82,98,32,83,70,83,98,32,79,70,83,70,32,82,80,81,78,80,77,78,77,76,78,75,81,75,87,76,90,78,91,80,91,81,90,82,88,32,78,77,77,78,76,81,76,87,77,90,78,91,32,87,77,88,78,89,81,89,87,88,90,87,91,32,83,80,84,78,85,77,87,77,89,78,90,81,90,87,89,90,87,91,85,91,84,90,83,88,32,79,98,86,98,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,91,91,91,96,90,91,0,71,93,76,77,76,84,77,86,80,87,82,87,85,86,87,84,32,77,77,77,84,78,86,80,87,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,84,91,91,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,96,96,95,91,0,72,93,81,77,81,91,32,82,77,82,91,32,76,77,75,82,75,77,85,77,32,82,84,86,84,89,85,90,87,90,88,89,90,86,91,78,91,32,86,84,88,85,89,87,89,88,88,90,86,91,0,69,95,74,77,74,91,32,75,77,75,91,32,71,77,78,77,32,75,84,79,84,82,85,83,87,83,88,82,90,79,91,71,91,32,79,84,81,85,82,87,82,88,81,90,79,91,32,89,77,89,91,32,90,77,90,91,32,86,77,93,77,32,86,91,93,91,0,74,91,79,77,79,91,32,80,77,80,91,32,76,77,83,77,32,80,84,84,84,87,85,88,87,88,88,87,90,84,91,76,91,32,84,84,86,85,87,87,87,88,86,90,84,91,0,73,92,77,79,76,77,76,81,77,79,78,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,78,90,76,88,76,87,77,86,78,87,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,82,84,88,84,0,68,97,73,77,73,91,32,74,77,74,91,32,70,77,77,77,32,70,91,77,91,32,86,77,83,78,81,80,80,83,80,85,81,88,83,90,86,91,88,91,91,90,93,88,94,85,94,83,93,80,91,78,88,77,86,77,32,86,77,84,78,82,80,81,83,81,85,82,88,84,90,86,91,32,88,91,90,90,92,88,93,85,93,83,92,80,90,78,88,77,32,74,84,80,84,0,71,92,86,77,86,91,32,87,77,87,91,32,90,77,79,77,76,78,75,80,75,81,76,83,79,84,86,84,32,79,77,77,78,76,80,76,81,77,83,79,84,32,84,84,81,85,80,86,78,90,77,91,32,84,84,82,85,81,86,79,90,78,91,76,91,75,90,74,88,32,83,91,90,91,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,77,85,86,85,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,88,82,89,84,89,87,88,89,32,85,80,87,81,88,83,88,88,87,90,85,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,88,89,86,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,87,73,88,75,89,78,89,83,88,86,87,88,32,83,70,85,71,87,74,88,78,88,83,87,87,85,90,83,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,89,91,89,85,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,71,91,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,94,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,90,89,91,89,83,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,88,84,88,89,32,87,83,87,89,86,90,32,84,83,92,83,32,85,83,87,84,32,86,83,87,85,32,90,83,89,85,32,91,83,89,84,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,80,70,32,84,70,92,70,32,77,80,87,80,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,74,90,83,70,83,87,82,90,81,91,32,84,71,84,87,83,90,32,85,70,85,87,84,90,81,91,79,91,77,90,76,88,76,86,77,85,78,85,79,86,79,87,78,88,77,88,32,77,86,77,87,78,87,78,86,77,86,32,80,70,88,70,32,81,70,83,71,32,82,70,83,72,32,86,70,85,72,32,87,70,85,71,0,70,92,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,88,71,77,82,32,80,80,87,91,32,81,80,88,91,32,81,78,89,91,32,72,70,80,70,32,85,70,91,70,32,72,91,80,91,32,84,91,91,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,88,71,32,90,70,88,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,89,85,91,32,87,89,90,91,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,83,70,32,75,91,90,91,90,85,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,32,85,91,90,90,32,87,91,90,89,32,88,91,90,88,32,89,91,90,85,0,69,95,74,70,74,90,32,74,70,81,91,32,75,70,81,88,32,76,70,82,88,32,88,70,81,91,32,88,70,88,91,32,89,71,89,90,32,90,70,90,91,32,71,70,76,70,32,88,70,93,70,32,71,91,77,91,32,85,91,93,91,32,72,70,74,71,32,91,70,90,72,32,92,70,90,71,32,74,90,72,91,32,74,90,76,91,32,88,90,86,91,32,88,89,87,91,32,90,89,91,91,32,90,90,92,91,0,70,94,75,70,75,90,32,75,70,89,91,32,76,70,88,88,32,77,70,89,88,32,89,71,89,91,32,72,70,77,70,32,86,70,92,70,32,72,91,78,91,32,73,70,75,71,32,87,70,89,71,32,91,70,89,71,32,75,90,73,91,32,75,90,77,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,78,81,32,88,72,89,74,89,77,88,79,32,85,70,87,71,88,73,88,78,87,80,85,81,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,78,88,79,86,81,85,82,85,84,86,85,88,86,94,87,96,89,96,90,94,90,92,32,86,92,87,94,88,95,89,95,32,85,88,87,93,88,94,89,94,90,93,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,78,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,82,80,84,81,85,83,87,89,88,91,90,91,91,89,91,87,32,87,87,88,89,89,90,90,90,32,84,81,85,82,88,88,89,89,90,89,91,88,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+327684);allocate([90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,72,92,74,70,74,76,32,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,90,70,90,76,32,74,70,90,70,32,78,91,86,91,32,75,70,74,76,32,76,70,74,73,32,77,70,74,72,32,79,70,74,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,71,32,76,71,76,86,77,88,32,77,70,77,86,78,89,79,90,81,91,32,72,70,80,70,32,86,70,92,70,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,91,70,89,71,0,72,92,75,70,82,91,32,76,70,82,88,82,91,32,77,70,83,88,32,89,71,82,91,32,73,70,80,70,32,85,70,91,70,32,74,70,76,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,90,70,89,71,0,70,94,74,70,78,91,32,75,70,78,86,78,91,32,76,70,79,86,32,82,70,79,86,78,91,32,82,70,86,91,32,83,70,86,86,86,91,32,84,70,87,86,32,90,71,87,86,86,91,32,71,70,79,70,32,82,70,84,70,32,87,70,93,70,32,72,70,75,71,32,73,70,75,72,32,77,70,76,72,32,78,70,76,71,32,88,70,90,71,32,92,70,90,71,0,72,92,75,70,87,91,32,76,70,88,91,32,77,70,89,91,32,88,71,76,90,32,73,70,80,70,32,85,70,91,70,32,73,91,79,91,32,84,91,91,91,32,74,70,77,72,32,78,70,77,72,32,79,70,77,71,32,86,70,88,71,32,90,70,88,71,32,76,90,74,91,32,76,90,78,91,32,87,90,85,91,32,87,89,86,91,32,87,89,90,91,0,71,93,74,70,81,81,81,91,32,75,70,82,81,82,90,32,76,70,83,81,83,91,32,89,71,83,81,32,72,70,79,70,32,86,70,92,70,32,78,91,86,91,32,73,70,75,71,32,78,70,76,71,32,87,70,89,71,32,91,70,89,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,89,70,75,70,75,76,32,87,70,75,91,32,88,70,76,91,32,89,70,77,91,32,75,91,89,91,89,85,32,76,70,75,76,32,77,70,75,73,32,78,70,75,72,32,80,70,75,71,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,90,70,90,76,32,75,91,83,91,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,78,89,77,91,32,78,90,76,91,32,80,89,81,91,32,80,90,82,91,0,72,92,82,70,74,91,32,81,73,88,91,32,82,73,89,91,32,82,70,90,91,32,75,89,88,89,32,75,90,88,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,74,69,74,76,32,90,69,90,76,32,79,77,79,84,32,85,77,85,84,32,74,85,74,92,32,90,85,90,92,32,74,71,90,71,32,74,72,90,72,32,74,73,90,73,32,79,80,85,80,32,79,81,85,81,32,74,88,90,88,32,74,89,90,89,32,74,90,90,90,32,74,70,77,72,32,90,70,87,72,32,75,73,74,75,32,76,73,74,74,32,88,73,90,74,32,89,73,90,75,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,32,74,86,75,88,32,74,87,76,88,32,90,87,88,88,32,90,86,89,88,32,77,89,74,91,32,87,89,90,91,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,92,70,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,71,93,73,70,80,80,81,81,32,74,70,81,80,32,75,70,82,80,73,91,32,73,70,89,70,90,76,89,73,87,70,32,86,70,89,72,32,84,70,89,71,32,75,89,89,89,32,74,90,89,90,32,73,91,89,91,90,85,89,88,87,89,0,72,92,74,77,75,73,76,71,77,70,79,70,80,71,81,73,82,77,32,76,72,77,71,79,71,80,72,32,74,77,75,74,77,72,79,72,80,73,81,77,81,91,32,82,77,82,91,32,90,77,89,74,87,72,85,72,84,73,83,77,83,91,32,88,72,87,71,85,71,84,72,32,90,77,89,73,88,71,87,70,85,70,84,71,83,73,82,77,32,78,91,86,91,32,81,89,80,91,32,81,90,79,91,32,83,90,85,91,32,83,89,84,91,0,71,93,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,79,75,76,76,75,77,74,79,74,82,75,84,76,85,79,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,79,75,32,76,77,75,79,75,82,76,84,32,88,84,89,82,89,79,88,77,32,79,75,77,76,76,79,76,82,77,85,79,86,32,85,86,87,85,88,82,88,79,87,76,85,75,0,70,94,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,72,77,73,77,74,78,75,81,76,83,77,84,80,85,84,85,87,84,88,83,89,81,90,78,91,77,92,77,32,76,82,75,78,74,76,73,76,75,78,32,72,77,73,75,74,75,75,76,76,80,77,83,78,84,80,85,32,89,78,91,76,90,76,89,78,88,82,32,84,85,86,84,87,83,88,80,89,76,90,75,91,75,92,77,0,71,93,78,89,75,89,74,87,75,91,79,91,77,86,75,82,74,79,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,79,89,82,87,86,85,91,89,91,90,87,89,89,86,89,32,76,83,75,79,75,76,76,73,32,88,73,89,76,89,79,88,83,32,79,91,77,85,76,80,76,75,77,72,78,71,80,70,32,84,70,86,71,87,72,88,75,88,80,87,85,85,91,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,73,90,32,83,74,84,91,32,84,72,85,90,32,85,70,85,72,86,89,86,91,32,76,85,84,85,32,70,91,76,91,32,81,91,88,91,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,86,89,87,91,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,78,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,87,81,88,83,88,85,87,88,85,90,32,86,80,87,82,87,85,86,88,84,90,82,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,87,71,88,72,89,75,89,79,88,83,86,87,84,89,32,85,70,87,72,88,75,88,79,87,83,85,87,82,90,79,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,85,91,87,86,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,80,91,85,90,32,82,91,85,89,32,85,89,87,86,0,70,92,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,86,88,87,87,88,84,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,32,82,91,84,90,86,87,87,84,32,84,84,92,84,32,85,84,87,85,32,86,84,87,87,32,90,84,88,86,32,91,84,88,85,0,69,95,78,70,72,91,32,79,70,73,91,32,80,70,74,91,32,90,70,84,91,32,91,70,85,91,32,92,70,86,91,32,75,70,83,70,32,87,70,95,70,32,76,80,88,80,32,69,91,77,91,32,81,91,89,91,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,88,70,91,71,32,89,70,90,72,32,93,70,91,72,32,94,70,91,71,32,73,90,70,91,32,73,89,71,91,32,74,89,75,91,32,73,90,76,91,32,85,90,82,91,32,85,89,83,91,32,86,89,87,91,32,85,90,88,91,0,75,89,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,81,70,89,70,32,75,91,83,91,32,82,70,85,71,32,83,70,84,72,32,87,70,85,72,32,88,70,85,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,73,92,87,70,82,87,81,89,79,91,32,88,70,84,83,83,86,82,88,32,89,70,85,83,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,85,77,86,77,87,76,88,75,88,32,75,86,75,87,76,87,76,86,75,86,32,84,70,92,70,32,85,70,88,71,32,86,70,87,72,32,90,70,88,72,32,91,70,88,71,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,92,71,77,82,32,81,79,85,91,32,82,79,86,91,32,83,78,87,90,32,76,70,84,70,32,89,70,95,70,32,70,91,78,91,32,82,91,89,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,90,70,92,71,32,94,70,92,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,85,90,83,91,32,85,89,84,91,32,86,89,88,91,0,72,92,81,70,75,91,32,82,70,76,91,32,83,70,77,91,32,78,70,86,70,32,72,91,87,91,89,85,32,79,70,82,71,32,80,70,81,72,32,84,70,82,72,32,85,70,82,71,32,76,90,73,91,32,76,89,74,91,32,77,89,78,91,32,76,90,79,91,32,82,91,87,90,32,84,91,88,88,32,86,91,89,85,0,68,96,77,70,71,90,32,77,71,78,89,78,91,32,78,70,79,89,32,79,70,80,88,32,91,70,80,88,78,91,32,91,70,85,91,32,92,70,86,91,32,93,70,87,91,32,74,70,79,70,32,91,70,96,70,32,68,91,74,91,32,82,91,90,91,32,75,70,77,71,32,76,70,77,72,32,94,70,92,72,32,95,70,92,71,32,71,90,69,91,32,71,90,73,91,32,86,90,83,91,32,86,89,84,91,32,87,89,88,91,32,86,90,89,91,0,70,95,79,70,73,90,32,79,70,86,91,32,80,70,86,88,32,81,70,87,88,32,92,71,87,88,86,91,32,76,70,81,70,32,89,70,95,70,32,70,91,76,91,32,77,70,80,71,32,78,70,80,72,32,90,70,92,71,32,94,70,92,71,32,73,90,71,91,32,73,90,75,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,90,71,91,73,91,75,90,78,88,80,32,88,70,89,71,90,73,90,75,89,78,87,80,85,81,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,32,76,88,77,86,79,85,80,85,82,86,83,88,84,93,85,94,86,94,87,93,32,84,94,85,95,86,95,32,83,88,83,95,84,96,86,96,87,93,87,92,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,78,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,82,80,84,81,85,82,87,88,88,89,89,89,90,88,32,87,89,88,90,89,90,32,85,82,86,90,87,91,89,91,90,88,90,87,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,71,93,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,77,70,75,76,32,93,70,92,76,32,77,70,93,70,32,75,91,83,91,32,78,70,75,76,32,80,70,76,73,32,82,70,77,71,32,89,70,92,71,32,90,70,92,72,32,91,70,92,73,32,92,70,92,76,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,71,32,79,70,76,81,75,85,75,89,76,90,32,80,70,77,81,76,85,76,89,78,91,32,75,70,83,70,32,89,70,95,70,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,90,70,92,71,32,94,70,92,71,0,72,92,78,70,78,72,79,89,79,91,32,79,71,80,88,32,80,70,81,87,32,91,71,79,91,32,76,70,83,70,32,88,70,94,70,32,77,70,78,72,32,81,70,80,72,32,82,70,79,71,32,89,70,91,71,32,93,70,91,71,0,69,95,77,70,77,72,75,89,75,91,32,78,71,76,88,32,79,70,77,87,32,85,70,77,87,75,91,32,85,70,85,72,83,89,83,91,32,86,71,84,88,32,87,70,85,87,32,93,71,85,87,83,91,32,74,70,82,70,32,85,70,87,70,32,90,70,96,70,32,75,70,78,71,32,76,70,77,72,32,80,70,78,73,32,81,70,78,71,32,91,70,93,71,32,95,70,93,71,0,71,93,78,70,84,91,32,79,70,85,91,32,80,70,86,91,32,91,71,73,90,32,76,70,83,70,32,88,70,94,70,32,70,91,76,91,32,81,91,88,91,32,77,70,79,72,32,81,70,80,72,32,82,70,80,71,32,89,70,91,71,32,93,70,91,71,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,85,89,87,91,0,71,93,77,70,81,80,78,91,32,78,70,82,80,79,91,32,79,70,83,80,80,91,32,92,71,83,80,32,75,70,82,70,32,89,70,95,70,32,75,91,83,91,32,76,70,78,71,32,80,70,79,72,32,81,70,78,71,32,90,70,92,71,32,94,70,92,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,71,93,90,70,72,91,32,91,70,73,91,32,92,70,74,91,32,92,70,78,70,76,76,32,72,91,86,91,88,85,32,79,70,76,76,32,80,70,77,73,32,82,70,78,71,32,82,91,86,90,32,84,91,87,88,32,85,91,88,85,0,72,92,74,70,82,91,32,75,70,82,88,32,76,70,83,88,32,74,70,90,70,82,91,32,76,71,89,71,32,76,72,89,72,0,73,93,78,80,78,79,79,79,79,81,77,81,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,86,79,87,81,87,88,88,90,32,84,77,85,78,86,80,86,88,87,90,90,91,91,91,32,86,82,85,83,80,84,77,85,76,87,76,88,77,90,80,91,83,91,85,90,86,88,32,78,85,77,87,77,88,78,90,32,85,83,81,84,79,85,78,87,78,88,79,90,80,91,0,71,92,76,70,76,91,77,90,79,90,32,77,71,77,89,32,73,70,78,70,78,90,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,74,70,76,71,32,75,70,76,72,0,72,91,87,81,87,80,86,80,86,82,88,82,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,72,93,86,70,86,91,91,91,32,87,71,87,90,32,83,70,88,70,88,91,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,84,70,86,71,32,85,70,86,72,32,88,89,89,91,32,88,90,90,91,0,72,91,77,83,88,83,88,81,87,79,86,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,82,87,81,86,79,32,77,80,76,82,76,86,77,88,32,86,83,86,80,85,78,83,77,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,75,89,87,72,87,71,86,71,86,73,88,73,88,71,87,70,84,70,82,71,81,72,80,75,80,91,32,82,72,81,75,81,90,32,84,70,83,71,82,73,82,91,32,77,77,86,77,32,77,91,85,91,32,80,90,78,91,32,80,89,79,91,32,82,89,83,91,32,82,90,84,91,0,73,92,88,78,89,79,90,78,89,77,88,77,86,78,85,79,32,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,79,78,81,78,83,79,85,32,85,85,86,83,86,81,85,79,32,81,77,80,78,79,80,79,84,80,86,81,87,32,83,87,84,86,85,84,85,80,84,78,83,77,32,78,85,77,86,76,88,76,89,77,91,78,92,81,93,85,93,88,94,89,95,32,78,91,81,92,85,92,88,93,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,32,79,98,77,97,76,95,76,94,77,92,79,91,0,71,94,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,70,76,71,32,75,70,76,72,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,72,83,72,83,70,81,70,32,82,70,82,72,32,81,71,83,71,32,81,77,81,91,32,82,78,82,90,32,78,77,83,77,83,91,32,78,91,86,91,32,79,77,81,78,32,80,77,81,79,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,75,88,82,70,82,72,84,72,84,70,82,70,32,83,70,83,72,32,82,71,84,71,32,82,77,82,94,81,97,80,98,32,83,78,83,93,82,96,32,79,77,84,77,84,93,83,96,82,97,80,98,77,98,76,97,76,95,78,95,78,97,77,97,77,96,32,80,77,82,78,32,81,77,82,79,0,71,93,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,87,78,78,87,32,82,83,89,91,32,82,84,88,91,32,81,84,87,91,32,84,77,91,77,32,73,91,81,91,32,84,91,91,91,32,74,70,76,71,32,75,70,76,72,32,85,77,87,78,32,90,77,87,78,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,89,85,91,32,86,89,90,91,0,76,88,81,70,81,91,32,82,71,82,90,32,78,70,83,70,83,91,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,65,99,70,77,70,91,32,71,78,71,90,32,67,77,72,77,72,91,32,72,81,73,79,74,78,76,77,79,77,81,78,82,79,83,82,83,91,32,81,79,82,82,82,90,32,79,77,80,78,81,81,81,91,32,83,81,84,79,85,78,87,77,90,77,92,78,93,79,94,82,94,91,32,92,79,93,82,93,90,32,90,77,91,78,92,81,92,91,32,67,91,75,91,32,78,91,86,91,32,89,91,97,91,32,68,77,70,78,32,69,77,70,79,32,70,90,68,91,32,70,89,69,91,32,72,89,73,91,32,72,90,74,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,92,90,90,91,32,92,89,91,91,32,94,89,95,91,32,94,90,96,91,0,71,94,76,77,76,91,32,77,78,77,90,32,73,77,78,77,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,77,76,78,32,75,77,76,79,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,77,80,76,82,76,86,77,88,32,87,88,88,86,88,82,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,0,71,92,76,77,76,98,32,77,78,77,97,32,73,77,78,77,78,98,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,73,98,81,98,32,74,77,76,78,32,75,77,76,79,32,76,97,74,98,32,76,96,75,98,32,78,96,79,98,32,78,97,80,98,0,72,92,86,78,86,98,32,87,79,87,97,32,85,78,87,78,88,77,88,98,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,98,91,98,32,86,97,84,98,32,86,96,85,98,32,88,96,89,98,32,88,97,90,98,0,73,90,78,77,78,91,32,79,78,79,90,32,75,77,80,77,80,91,32,87,79,87,78,86,78,86,80,88,80,88,78,87,77,85,77,83,78,81,80,80,83,32,75,91,83,91,32,76,77,78,78,32,77,77,78,79,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,83,80,84,85,85,87,86,88,89,32,78,78,77,81,32,78,82,80,83,85,84,87,85,32,88,86,87,90,32,77,79,78,81,80,82,85,83,87,84,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,72,80,86,81,89,82,90,84,91,86,91,88,90,89,88,32,81,72,81,87,82,89,32,80,72,82,70,82,87,83,90,84,91,32,77,77,86,77,0,71,94,76,77,76,86,77,89,78,90,80,91,83,91,85,90,86,89,87,87,32,77,78,77,87,78,89,32,73,77,78,77,78,87,79,90,80,91,32,87,77,87,91,92,91,32,88,78,88,90,32,84,77,89,77,89,91,32,74,77,76,78,32,75,77,76,79,32,89,89,90,91,32,89,90,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,82,91,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,70,94,74,77,78,91,32,75,77,78,88,32,76,77,79,88,32,82,77,79,88,78,91,32,82,77,86,91,32,83,77,86,88,32,82,77,84,77,87,88,32,90,78,87,88,86,91,32,71,77,79,77,32,87,77,93,77,32,72,77,75,78,32,78,77,76,78,32,88,77,90,78,32,92,77,90,78,0,72,92,76,77,86,91,32,77,77,87,91,32,78,77,88,91,32,87,78,77,90,32,74,77,81,77,32,84,77,90,77,32,74,91,80,91,32,83,91,90,91,32,75,77,77,78,32,80,77,78,78,32,85,77,87,78,32,89,77,87,78,32,77,90,75,91,32,77,90,79,91,32,86,90,84,91,32,87,90,89,91,0,72,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,73,91,86,77,76,91,32,87,77,77,91,32,88,77,78,91,32,88,77,76,77,76,81,32,76,91,88,91,88,87,32,77,77,76,81,32,78,77,76,80,32,79,77,76,79,32,81,77,76,78,32,83,91,88,90,32,85,91,88,89,32,86,91,88,88,32,87,91,88,87,0,71,94,91,77,90,81,89,84,87,88,85,90,82,91,80,91,77,90,75,88,74,85,74,83,75,80,77,78,80,77,82,77,85,78,86,79,87,81,89,88,90,90,91,91,92,91,32,90,77,89,81,88,84,87,86,85,89,84,90,82,91,32,76,88,75,86,75,82,76,80,32,80,91,78,90,77,89,76,86,76,82,77,79,78,78,80,77,32,82,77,84,78,85,79,86,81,88,88,89,90,91,91,0,71,92,81,70,78,71,77,72,76,74,75,78,75,98,32,78,72,77,74,76,78,76,97,32,81,70,79,71,78,73,77,78,77,98,32,81,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,83,80,32,80,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,81,91,79,90,78,89,77,87,32,86,72,87,74,87,76,86,78,32,87,82,88,84,88,87,87,89,32,83,70,85,71,86,73,86,77,85,79,83,80,32,84,80,86,81,87,83,87,88,86,90,84,91,32,75,98,77,98,0,70,92,72,82,73,78,75,77,77,77,79,78,80,79,81,82,82,89,83,98,32,73,79,75,78,77,78,79,79,80,80,32,72,82,73,80,75,79,77,79,79,80,80,81,81,84,82,89,82,97,32,88,77,87,80,86,82,84,85,83,87,82,91,81,98,32,89,77,87,81,32,90,77,89,79,87,82,84,86,83,88,82,91,32,88,77,90,77,32,81,98,83,98,0,72,92,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,80,76,78,75,77,74,77,72,78,71,80,70,83,70,87,72,32,77,80,76,83,76,85,77,88,32,87,88,88,85,88,83,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,79,75,78,74,78,73,79,72,81,71,84,71,87,72,0,73,91,83,77,85,78,86,79,87,79,86,78,83,77,81,77,77,78,76,79,76,81,77,82,81,83,32,83,83,81,83,77,84,75,86,75,88,77,90,80,91,83,91,86,90,88,88,87,88,86,90,32,78,78,77,79,77,81,78,82,32,77,85,76,86,76,88,77,89,32,81,77,79,78,78,79,78,81,79,82,81,83,32,81,83,78,84,77,86,77,88,78,90,80,91,0,73,91,81,72,82,71,82,70,81,70,80,71,80,73,81,74,84,75,88,75,89,75,89,74,88,74,85,75,83,76,80,78,78,80,77,82,76,85,76,87,77,89,78,90,80,91,83,92,85,93,86,95,86,97,85,98,83,98,82,97,82,96,83,96,83,97,32,80,79,79,80,78,82,77,85,77,87,78,89,79,90,32,85,75,82,77,81,78,79,81,78,84,78,87,79,89,81,91,83,92,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,85,77,86,78,87,81,87,98,32,87,79,88,82,88,97,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,98,32,76,91,78,91,32,87,98,89,98,0,70,93,73,77,74,78,75,80,75,84,76,87,77,89,78,90,81,91,83,91,86,90,87,89,88,87,89,82,89,79,88,74,86,71,84,70,82,70,80,71,79,73,79,75,80,77,83,79,86,80,91,81,32,74,77,75,78,76,80,76,84,77,87,78,89,32,86,89,87,87,88,82,88,79,87,74,86,72,84,71,32,71,80,72,78,73,77,75,77,76,78,77,80,77,84,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,74,85,72,83,71,81,71,79,73,0,75,90,78,77,79,78,80,80,80,88,81,90,83,91,85,91,87,90,88,88,32,79,77,80,78,81,80,81,88,82,90,32,76,80,77,78,78,77,80,77,81,78,82,80,82,88,83,90,84,91,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,83,79,85,78,87,78,88,79,88,80,90,80,90,78,88,77,86,77,84,78,81,81,79,84,78,87,32,88,78,89,79,89,80,32,80,83,81,83,87,89,89,89,90,88,32,84,87,87,90,89,90,32,82,84,85,90,86,91,88,91,89,90,90,88,32,76,91,78,91,0,72,92,74,71,75,70,77,70,79,71,81,73,88,88,89,90,90,91,32,79,72,80,73,87,88,88,89,32,77,70,78,71,79,73,86,88,88,90,90,91,91,91,32,82,77,74,90,74,91,75,91,82,77,0,71,93,75,77,75,98,32,76,78,76,97,32,77,77,77,98,32,86,77,86,88,87,90,88,91,90,91,91,90,92,88,32,87,78,87,88,88,90,89,91,32,88,77,88,88,89,90,90,91,32,77,88,78,90,80,91,82,91,84,90,85,89,86,87,32,75,77,77,77,32,86,77,88,77,32,75,98,77,98,0,71,93,74,77,75,78,76,80,77,84,78,91,32,75,77,76,78,77,80,78,84,79,90,32,72,80,73,78,74,77,76,77,77,78,78,80,79,84,80,90,32,86,86,87,84,88,81,88,77,89,77,90,78,89,81,88,83,86,86,84,88,81,90,78,91,32,88,82,89,79,89,77,0,74,90,80,71,83,70,82,70,80,71,79,72,79,73,80,74,83,75,86,76,87,75,86,74,83,75,80,76,78,77,77,79,77,81,78,82,80,83,83,84,86,85,87,84,86,83,83,84,79,85,77,86,76,88,76,90,77,91,79,92,83,93,85,94,86,95,86,97,84,98,82,98,79,97,80,97,82,98,32,79,77,78,79,78,81,79,82,32,78,86,77,88,77,90,78,91,32,86,75,83,75,81,76,80,77,79,79,79,81,81,83,83,84,32,86,84,83,84,80,85,79,86,78,88,78,90,80,92,83,93,0,71,93,73,81,74,79,75,78,77,77,91,77,32,75,79,77,78,90,78,32,73,81,74,80,76,79,91,79,32,79,79,78,90,77,91,76,90,77,87,79,79,32,85,79,86,90,87,91,88,90,87,87,85,79,32,91,77,91,79,32,79,79,77,90,32,85,79,87,90,0,71,92,81,77,78,78,76,80,75,84,75,98,32,77,80,76,84,76,97,32,81,77,79,78,78,79,77,83,77,98,32,77,87,78,89,79,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,87,88,88,86,88,82,87,80,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,32,75,98,77,98,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,82,91,85,90,87,88,88,85,88,83,87,80,85,78,82,77,32,76,80,75,82,75,86,76,88,32,86,88,87,86,87,82,86,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,32,82,91,84,90,85,89,86,86,86,82,85,79,84,78,82,77,32,82,77,90,79,91,78,91,77,80,77,32,82,77,90,78,0,72,92,74,81,75,79,76,78,78,77,90,77,32,76,79,78,78,89,78,32,74,81,75,80,77,79,90,79,32,82,79,81,90,82,91,83,90,82,79,32,90,77,90,79,32,82,79,82,90,0,71,92,74,77,75,78,76,80,76,85,77,88,79,90,81,91,83,91,85,90,87,88,88,86,89,82,89,78,88,77,87,77,88,80,88,83,87,87,85,90,32,75,77,76,78,77,80,77,85,78,88,32,87,77,88,78,88,79,32,72,80,73,78,74,77,76,77,77,78,78,80,78,86,79,89,81,91,0,71,93,82,81,81,78,80,77,78,77,76,78,75,79,74,82,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,82,89,79,88,78,86,77,84,77,83,78,82,81,32,76,79,75,82,75,85,76,88,32,88,88,89,85,89,82,88,79,32,78,77,77,78,76,81,76,86,77,89,78,90,80,91,32,84,91,86,90,87,89,88,86,88,81,87,78,86,77,32,82,81,81,98,32,82,81,82,97,32,82,81,83,98,32,81,98,83,98,0,72,92,76,77,77,78,78,80,84,95,86,97,88,98,90,98,91,97,32,78,79,79,80,85,95,86,96,32,73,78,74,77,76,77,78,78,80,80,86,95,87,97,88,98,32,86,83,88,80,89,77,90,77,89,79,86,83,78,92,75,96,74,98,75,98,76,95,78,92,0,70,93,72,78,73,78,74,80,74,85,75,88,77,90,80,91,84,91,86,90,88,88,89,86,90,82,90,78,89,77,88,77,89,80,89,83,88,87,86,90,32,74,78,75,80,75,85,76,88,32,88,77,89,78,89,79,32,71,80,72,78,73,77,74,77,75,78,76,80,76,86,77,89,78,90,80,91,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,70,94,78,77,76,78,74,80,73,83,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,84,82,83,81,84,81,87,82,89,83,90,85,91,87,91,89,90,90,89,91,87,91,83,90,80,88,78,86,77,32,75,80,74,83,74,87,75,89,32,82,84,82,88,32,89,89,90,87,90,83,89,80,32,78,77,76,79,75,82,75,87,76,90,77,91,32,87,91,88,90,89,87,89,82,88,79,86,77,0,71,93,87,77,85,84,85,88,86,90,87,91,89,91,91,89,92,87,32,88,77,86,84,86,90,32,87,77,89,77,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,78,78,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,0,73,92,80,70,78,77,77,83,77,87,78,89,79,90,81,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,85,77,83,77,81,78,80,79,79,81,78,84,32,81,70,79,77,78,81,78,87,79,90,32,86,89,87,87,88,84,88,81,87,79,32,77,70,82,70,80,77,78,84,32,83,91,85,89,86,87,87,84,87,81,86,78,85,77,32,78,70,81,71,32,79,70,80,72,0,73,91,87,81,87,80,86,80,86,82,88,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,87,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,71,93,89,70,86,81,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,90,70,87,81,86,85,86,90,32,86,70,91,70,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,87,70,90,71,32,88,70,89,72,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,88,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,74,90,90,72,90,71,89,71,89,73,91,73,91,71,90,70,88,70,86,71,84,73,83,75,82,78,81,82,79,91,78,94,77,96,75,98,32,84,74,83,77,82,82,80,91,79,94,32,88,70,86,72,85,74,84,77,83,82,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,95,74,95,74,97,73,97,73,96,32,78,77,89,77,0,72,93,88,77,84,91,83,94,81,97,79,98,32,89,77,85,91,83,95,32,88,77,90,77,86,91,84,95,82,97,79,98,76,98,74,97,73,96,73,94,75,94,75,96,74,96,74,95,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,86,76,89,77,90,79,91,81,91,83,90,84,89,85,87,86,84,32,78,79,77,81,76,84,76,87,77,89,32,81,77,79,79,78,81,77,84,77,87,78,90,79,91,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,80,88,83,86,88,32,87,78,87,82,86,86,86,90,32,87,80,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,77,70,80,71,32,78,70,79,72,0,75,88,84,70,84,72,86,72,86,70,84,70,32,85,70,85,72,32,84,71,86,71,32,76,81,77,79,79,77,81,77,82,78,83,80,83,83,81,88,32,82,78,82,82,81,86,81,90,32,82,80,80,85,80,88,81,90,82,91,84,91,86,89,87,87,0,75,88,85,70,85,72,87,72,87,70,85,70,32,86,70,86,72,32,85,71,87,71,32,77,81,78,79,80,77,82,77,83,78,84,80,84,83,82,90,81,93,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,83,78,83,83,81,90,80,93,79,95,32,83,80,82,84,80,91,79,94,78,96,76,98,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,81,82,79,83,32,77,83,79,83,81,84,82,85,84,89,85,90,87,90,32,81,85,83,89,84,90,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,80,71,32,78,70,79,72,0,76,88,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,81,70,86,70,82,84,81,88,32,82,70,85,71,32,83,70,84,72,0,64,99,65,81,66,79,68,77,70,77,71,78,72,80,72,83,70,91,32,71,78,71,83,69,91,32,71,80,70,84,68,91,70,91,32,72,83,74,80,76,78,78,77,80,77,82,78,83,80,83,83,81,91,32,82,78,82,83,80,91,32,82,80,81,84,79,91,81,91,32,83,83,85,80,87,78,89,77,91,77,93,78,94,80,94,83,92,88,32,93,78,93,82,92,86,92,90,32,93,80,91,85,91,88,92,90,93,91,95,91,97,89,98,87,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,91,32,77,78,77,83,75,91,32,77,80,76,84,74,91,76,91,32,78,83,80,80,82,78,84,77,86,77,88,78,89,80,89,83,87,88,32,88,78,88,82,87,86,87,90,32,88,80,86,85,86,88,87,90,88,91,90,91,92,89,93,87,0,72,92,81,77,78,78,76,81,75,84,75,86,76,89,77,90,80,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,84,77,81,77,32,78,79,77,81,76,84,76,87,77,89,32,86,89,87,87,88,84,88,81,87,79,32,81],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+337924);allocate([77,79,79,78,81,77,84,77,87,78,90,80,91,32,83,91,85,89,86,87,87,84,87,81,86,78,84,77,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,78,87,75,98,32,78,78,78,83,77,87,74,98,32,78,80,77,84,73,98,32,79,84,80,81,81,79,82,78,84,77,86,77,88,78,89,79,90,82,90,84,89,87,87,90,84,91,82,91,80,90,79,87,79,84,32,88,79,89,81,89,84,88,87,87,89,32,86,77,87,78,88,81,88,84,87,87,86,89,84,91,32,70,98,78,98,32,74,97,71,98,32,74,96,72,98,32,75,96,76,98,32,74,97,77,98,0,71,92,87,77,81,98,32,88,77,82,98,32,87,77,89,77,83,98,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,78,98,86,98,32,82,97,79,98,32,82,96,80,98,32,83,96,84,98,32,82,97,85,98,0,73,91,74,81,75,79,77,77,79,77,80,78,81,80,81,84,79,91,32,80,78,80,84,78,91,32,80,80,79,84,77,91,79,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,83,80,81,84,0,74,91,88,80,88,79,87,79,87,81,89,81,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,83,81,84,84,85,86,86,87,88,32,79,78,78,81,32,79,82,81,83,84,84,86,85,32,87,86,86,90,32,78,79,79,81,81,82,84,83,86,84,87,86,87,88,86,90,83,91,80,91,77,90,76,89,76,87,78,87,78,89,77,89,77,88,0,75,89,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,84,70,86,70,82,84,81,88,32,78,77,88,77,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,88,32,77,78,77,82,76,86,76,90,32,77,80,75,85,75,88,76,90,78,91,80,91,82,90,84,88,86,85,32,88,77,86,85,86,88,87,90,88,91,90,91,92,89,93,87,32,89,77,87,85,87,90,32,88,77,90,77,88,84,87,88,0,72,92,73,81,74,79,76,77,78,77,79,78,80,80,80,83,78,88,32,79,78,79,82,78,86,78,90,32,79,80,77,85,77,88,78,90,80,91,82,91,84,90,86,88,88,85,89,81,89,77,88,77,88,78,89,80,0,67,97,68,81,69,79,71,77,73,77,74,78,75,80,75,83,73,88,32,74,78,74,82,73,86,73,90,32,74,80,72,85,72,88,73,90,75,91,77,91,79,90,81,88,82,85,32,84,77,82,85,82,88,83,90,85,91,87,91,89,90,91,88,93,85,94,81,94,77,93,77,93,78,94,80,32,85,77,83,85,83,90,32,84,77,86,77,84,84,83,88,0,71,93,74,81,76,78,78,77,80,77,82,78,83,80,83,82,32,80,77,81,78,81,82,80,86,79,88,77,90,75,91,73,91,72,90,72,88,74,88,74,90,73,90,73,89,32,82,79,82,82,81,86,81,89,32,90,79,90,78,89,78,89,80,91,80,91,78,90,77,88,77,86,78,84,80,83,82,82,86,82,90,83,91,32,80,86,80,88,81,90,83,91,85,91,87,90,89,87,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,77,88,32,78,78,78,82,77,86,77,90,32,78,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,84,32,89,77,85,91,84,94,82,97,80,98,32,90,77,86,91,84,95,32,89,77,91,77,87,91,85,95,83,97,80,98,77,98,75,97,74,96,74,94,76,94,76,96,75,96,75,95,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,88,79,79,79,77,80,76,82,32,86,79,82,78,79,78,78,79,32,86,79,82,77,79,77,77,79,76,82,32,76,89,85,89,87,88,88,86,32,78,89,82,90,85,90,86,89,32,78,89,82,91,85,91,87,89,88,86,0,72,92,87,81,86,79,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,87,89,88,87,89,83,89,78,88,74,87,72,86,71,83,70,81,70,78,71,77,72,78,72,79,71,81,70,32,77,80,76,82,76,86,77,88,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,88,87,84,87,77,86,73,85,71,83,70,0,73,91,85,77,87,78,88,79,89,79,88,78,85,77,82,77,79,78,77,80,76,83,76,85,77,88,79,90,82,91,85,91,88,90,89,89,88,89,87,90,85,91,32,78,80,77,83,77,85,78,88,32,82,77,80,78,79,79,78,82,78,86,79,89,80,90,82,91,32,78,84,84,85,85,84,84,83,78,84,32,78,84,84,84,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,32,76,80,88,81,32,76,81,88,80,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,83,89,80,87,78,84,77,80,77,32,76,80,75,83,75,85,76,88,32,88,88,89,85,89,83,88,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,84,91,86,90,87,89,88,86,88,82,87,79,86,78,84,77,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,72,92,84,77,86,78,88,80,89,80,89,79,87,78,84,77,80,77,77,78,76,79,75,81,75,83,76,85,78,87,80,88,82,89,83,90,84,92,84,94,83,95,81,95,79,94,80,94,81,95,32,77,79,76,81,76,83,77,85,79,87,32,80,77,78,78,77,80,77,83,78,85,82,89,32,89,80,88,79,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,0,72,92,81,72,81,91,32,82,72,82,90,32,83,70,83,91,32,83,70,80,73,78,74,32,77,91,87,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,87,72,88,74,88,76,87,78,32,84,70,86,71,87,74,87,76,86,78,84,80,80,82,32,75,89,76,88,78,88,83,89,87,89,89,88,32,78,88,83,90,87,90,88,89,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,32,86,71,87,73,87,76,86,78,32,83,70,85,71,86,73,86,76,85,78,83,79,32,81,79,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,82,88,84,88,87,87,89,32,83,79,85,80,86,81,87,84,87,87,86,90,84,91,32,76,86,76,87,77,87,77,86,76,86,0,72,92,83,73,83,91,32,84,72,84,90,32,85,70,85,91,32,85,70,74,85,90,85,32,80,91,88,91,32,83,90,81,91,32,83,89,82,91,32,85,89,86,91,32,85,90,87,91,0,72,92,77,70,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,76,86,76,87,77,87,77,86,76,86,32,77,70,87,70,32,77,71,85,71,32,77,72,81,72,85,71,87,70,0,72,92,86,73,86,74,87,74,87,73,86,73,32,87,72,86,72,85,73,85,74,86,75,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,81,78,79,79,78,80,77,82,32,78,73,77,75,76,79,76,85,77,88,78,89,32,87,88,88,86,88,83,87,81,32,82,70,80,71,79,72,78,74,77,78,77,85,78,88,79,90,81,91,32,83,91,85,90,86,89,87,86,87,83,86,80,85,79,83,78,0,72,92,75,70,75,76,32,89,70,89,73,88,76,84,81,83,83,82,87,82,91,32,83,82,82,84,81,87,81,91,32,88,76,83,81,81,84,80,87,80,91,82,91,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,77,72,78,71,80,71,82,72,32,75,74,76,73,78,72,80,72,85,73,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,78,71,77,73,77,76,78,78,32,86,78,87,76,87,73,86,71,32,80,70,79,71,78,73,78,76,79,78,80,79,32,84,79,85,78,86,76,86,73,85,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,77,81,76,83,76,87,77,89,32,87,89,88,87,88,83,87,81,32,80,79,78,80,77,83,77,87,78,90,80,91,32,84,91,86,90,87,87,87,83,86,80,84,79,0,72,92,77,87,77,88,78,88,78,87,77,87,32,87,79,86,81,85,82,83,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,86,79,87,79,88,78,89,77,89,32,77,80,76,78,76,75,77,73,32,86,72,87,73,88,76,88,82,87,86,86,88,32,81,83,79,82,78,81,77,78,77,75,78,72,79,71,81,70,32,83,70,85,71,86,73,87,76,87,83,86,87,85,89,84,90,82,91,0,77,88,82,70,81,71,81,73,82,81,32,82,70,82,84,83,84,32,82,70,83,70,83,84,32,83,70,84,71,84,73,83,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,77,75,77,74,78,74,78,76,76,76,76,74,77,72,78,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,83,81,32,87,72,88,73,88,77,87,78,32,84,70,86,71,87,73,87,77,86,79,85,80,32,82,81,82,84,83,84,83,81,82,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,69,95,91,79,91,78,90,78,90,80,92,80,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,76,78,79,80,82,84,87,87,90,89,91,91,91,92,89,92,88,32,75,90,74,88,74,85,75,83,76,82,32,82,77,83,73,32,83,75,82,71,32,78,71,77,75,32,78,78,80,81,84,86,87,89,89,90,32,78,91,76,90,75,88,75,85,76,83,80,79,32,77,73,78,77,81,81,85,86,88,89,90,90,91,90,92,89,0,72,92,80,66,80,95,32,84,66,84,95,32,88,75,88,74,87,74,87,76,89,76,89,74,88,72,87,71,84,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,85,77,85,77,87,76,87,76,86,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,32,81,72,80,75,79,79,79,85,80,89,81,92,32,83,68,82,70,81,73,80,79,80,85,81,91,82,94,83,96,0,75,89,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,32,83,72,84,75,85,79,85,85,84,89,83,92,32,81,68,82,70,83,73,84,79,84,85,83,91,82,94,81,96,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,32,91,70,73,91,32,91,70,74,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,79,71,76,70,73,73,74,76,77,77,80,74,79,71,32,78,70,74,71,73,75,32,75,77,79,76,80,72,32,90,85,87,84,84,87,85,90,88,91,91,88,90,85,32,89,84,85,85,84,89,32,86,91,90,90,91,86,32,72,91,74,91,0,69,96,86,78,85,76,83,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,83,86,85,85,86,83,32,79,77,78,79,78,82,79,84,32,81,75,80,76,79,79,79,82,80,85,81,86,32,86,75,86,83,87,85,89,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,76,87,83,88,85,32,86,75,88,75,88,83,89,85,90,86,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,89,86,87,87,85,88,82,89,78,89,74,88,72,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,72,93,84,74,79,91,81,91,32,87,70,85,74,80,91,32,87,70,81,91,32,87,70,84,73,81,75,79,76,32,84,74,82,75,79,76,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,77,85,75,87,73,91,32,88,71,89,73,89,75,88,77,86,79,83,81,32,86,70,87,71,88,73,88,75,87,77,85,79,77,85,32,74,89,75,88,77,88,82,89,87,89,88,88,32,77,88,82,90,87,90,32,77,88,82,91,85,91,87,90,88,88,88,87,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,88,78,86,79,83,80,32,88,71,89,73,89,75,88,77,87,78,32,86,70,87,71,88,73,88,75,87,77,85,79,83,80,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,85,90,82,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,82,87,84,87,87,86,89,32,83,80,85,81,86,83,86,87,85,89,84,90,82,91,0,72,93,87,74,82,91,84,91,32,90,70,88,74,83,91,32,90,70,84,91,32,90,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,89,71,32,80,72,85,72,89,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,81,91,78,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,80,87,82,87,85,86,88,84,90,32,83,78,85,79,86,81,86,85,85,88,83,90,81,91,0,72,93,89,74,89,73,88,73,88,75,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,78,81,77,83,32,80,73,78,76,77,79,76,83,76,87,77,89,32,86,88,87,86,87,83,86,81,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,82,91,84,90,85,89,86,86,86,82,85,80,84,79,0,72,93,78,70,76,76,32,91,70,90,73,88,76,84,81,82,84,81,87,80,91,32,82,83,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,80,91,32,77,73,80,70,82,70,87,73,32,79,71,82,71,87,73,32,77,73,79,72,82,72,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,87,79,89,78,90,76,90,73,89,71,87,70,83,70,32,85,70,80,71,32,80,72,79,74,79,78,80,79,32,79,79,82,80,32,83,80,87,79,32,88,78,89,76,89,73,88,71,32,89,71,85,70,32,83,70,81,72,80,74,80,78,81,80,32,84,80,86,79,87,78,88,76,88,72,87,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,82,80,77,81,32,78,81,76,83,75,85,75,88,76,90,32,75,90,80,91,86,90,32,86,89,87,87,87,84,86,82,32,86,81,83,80,32,81,80,79,81,77,83,76,85,76,88,77,90,78,91,32,82,91,84,90,85,89,86,87,86,83,85,81,84,80,0,72,93,88,78,87,80,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,75,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,86,77,86,77,88,76,88,76,87,32,79,80,78,78,78,75,79,73,32,88,72,89,74,89,78,88,82,87,85,85,88,32,81,82,80,81,79,79,79,75,80,72,81,71,83,70,32,86,70,87,71,88,73,88,78,87,82,86,85,85,87,83,90,81,91,0,77,88,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,86,70,85,70,84,71,82,84,32,86,71,85,71,82,84,32,86,71,86,72,82,84,32,86,70,87,71,87,72,82,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,87,79,83,80,81,81,81,83,83,84,84,84,32,85,70,90,71,32,89,71,90,73,90,75,89,77,88,78,86,79,32,87,70,88,71,89,73,89,75,88,77,87,78,83,80,82,81,82,83,83,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,87,70,85,71,84,72,83,74,83,76,84,77,85,77,86,76,86,75,85,74,84,74,32,85,71,84,73,84,74,32,84,75,84,76,85,76,85,75,84,75,0,77,88,86,73,85,73,84,72,84,71,85,70,86,70,87,71,87,73,86,75,85,76,83,77,32,85,71,85,72,86,72,86,71,85,71,32,86,73,86,74,85,76,0,69,95,92,79,92,78,91,78,91,80,93,80,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,82,87,84,90,86,91,88,91,89,89,89,88,32,76,91,72,90,32,73,90,72,88,72,86,73,84,74,83,76,82,32,80,80,81,83,84,89,86,90,32,75,91,74,90,73,88,73,86,74,84,75,83,77,82,82,79,32,79,76,80,79,81,82,83,86,85,89,87,90,88,90,89,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,75,90,74,89,74,89,76,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,0,71,94,95,66,69,98,70,98,32,95,66,96,66,70,98,0,74,90,90,66,88,67,85,69,82,72,80,75,78,79,77,83,77,88,78,92,79,95,81,98,32,83,72,81,75,79,79,78,84,78,92,32,90,66,87,68,84,71,82,74,81,76,80,79,79,83,78,92,32,78,84,79,93,80,96,81,98,0,74,90,83,66,85,69,86,72,87,76,87,81,86,85,84,89,82,92,79,95,76,97,74,98,32,86,72,86,80,85,85,83,89,81,92,32,83,66,84,68,85,71,86,80,32,86,72,85,81,84,85,83,88,82,90,80,93,77,96,74,98,0,74,91,84,70,83,71,85,81,84,82,32,84,70,84,82,32,84,70,85,71,83,81,84,82,32,79,73,80,73,88,79,89,79,32,79,73,89,79,32,79,73,79,74,89,78,89,79,32,89,73,88,73,80,79,79,79,32,89,73,79,79,32,89,73,89,74,79,78,79,79,0,77,87,85,70,84,71,82,77,32,85,71,82,77,32,85,70,86,71,82,77,0,72,92,80,70,79,71,77,77,32,80,71,77,77,32,80,70,81,71,77,77,32,90,70,89,71,87,77,32,90,71,87,77,32,90,70,91,71,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,32,83,70,80,73,81,77,85,78,88,75,87,71,83,70,32,85,70,81,71,80,75,83,78,87,77,88,73,85,70,0,71,94,83,70,75,98,76,98,32,83,70,84,70,76,98,32,89,70,81,98,82,98,32,89,70,90,70,82,98,32,75,80,92,80,92,81,32,75,80,75,81,92,81,32,73,87,90,87,90,88,32,73,87,73,88,90,88,0,69,94,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,69,91,32,94,70,70,91,32,94,70,71,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,32,80,71,77,70,74,73,75,76,78,77,81,74,80,71,32,79,70,75,71,74,75,32,76,77,80,76,81,72,32,89,85,86,84,83,87,84,90,87,91,90,88,89,85,32,88,84,84,85,83,89,32,85,91,89,90,90,86,32,69,91,71,91,0,69,96,85,81,85,78,84,76,82,75,80,75,78,76,77,77,76,80,76,83,77,85,79,86,81,86,83,85,84,84,85,81,32,79,76,78,77,77,80,77,83,78,85,32,82,75,80,76,79,77,78,80,78,83,79,85,80,86,32,86,75,85,81,85,83,86,85,88,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,75,86,81,86,83,87,85,32,86,75,88,75,87,81,87,83,88,85,90,86,0,95,112,111,105,110,116,115,46,103,101,116,79,98,106,40,41,32,33,61,32,95,104,117,108,108,46,103,101,116,79,98,106,40,41,0,99,111,110,118,101,120,72,117,108,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,118,104,117,108,108,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,83,41,0,112,111,105,110,116,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,112,111,105,110,116,115,32,62,61,32,48,0,99,111,110,118,101,120,105,116,121,68,101,102,101,99,116,115,0,104,112,111,105,110,116,115,32,62,32,48,0,48,32,60,61,32,104,99,117,114,114,32,38,38,32,104,99,117,114,114,32,60,32,110,112,111,105,110,116,115,0,48,32,60,61,32,104,110,101,120,116,32,38,38,32,104,110,101,120,116,32,60,32,110,112,111,105,110,116,115,0,105,115,67,111,110,116,111,117,114,67,111,110,118,101,120,0,116,104,101,32,116,121,112,101,32,111,102,32,108,97,98,101,108,115,32,109,117,115,116,32,98,101,32,49,54,117,32,111,114,32,51,50,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,46,99,112,112,0,76,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,73,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,95,115,117,98,49,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,32,124,124,32,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,52,0,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,71,82,65,78,65,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,87,85,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,68,69,70,65,85,76,84,0,105,68,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,105,68,101,112,116,104,32,61,61,32,67,86,95,56,83,0,117,110,115,117,112,112,111,114,116,101,100,32,108,97,98,101,108,47,105,109,97,103,101,32,116,121,112,101,0,105,109,103,46,114,111,119,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,114,111,119,115,0,105,109,103,46,99,111,108,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,99,111,108,115,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,105,109,103,76,97,98,101,108,115,46,114,111,119,115,32,61,61,32,105,109,103,46,114,111,119,115,0,105,109,103,76,97,98,101,108,115,46,99,111,108,115,32,61,61,32,105,109,103,46,99,111,108,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,87,105,116,104,83,116,97,116,115,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,32,124,124,32,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,70,0,99,111,110,116,111,117,114,77,111,109,101,110,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,109,101,110,116,115,46,99,112,112,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,116,121,112,101,32,40,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,41,0,109,111,109,101,110,116,115,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,102,69,69,69,69,0,115,114,99,99,110,32,61,61,32,51,32,124,124,32,115,114,99,99,110,32,61,61,32,52,0,82,71,66,50,82,71,66,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,114,103,98,46,99,112,112,0,100,115,116,99,110,32,61,61,32,51,32,124,124,32,100,115,116,99,110,32,61,61,32,52,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,50,82,71,66,53,120,53,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,53,120,53,50,82,71,66,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,53,120,53,50,71,114,97,121,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,71,114,97,121,50,82,71,66,53,120,53,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,65,50,109,82,71,66,65,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,109,82,71,66,65,50,82,71,66,65,73,104,69,69,69,69,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,50,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+348164);allocate([44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,52,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,119,97,116,101,114,115,104,101,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,101,103,109,101,110,116,97,116,105,111,110,46,99,112,112,0,111,112,32,61,61,32,77,79,82,80,72,95,69,82,79,68,69,32,124,124,32,111,112,32,61,61,32,77,79,82,80,72,95,68,73,76,65,84,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,82,111,119,70,105,108,116,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,114,112,104,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,100,97,116,97,32,116,121,112,101,32,40,61,37,100,41,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,100,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,102,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,115,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,116,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,104,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,100,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,102,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,115,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,116,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,104,69,69,78,83,49,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,100,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,102,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,115,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,116,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,104,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,100,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,102,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,115,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,116,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,104,69,69,78,83,49,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,97,110,99,104,111,114,46,105,110,115,105,100,101,40,82,101,99,116,40,48,44,32,48,44,32,107,115,105,122,101,46,119,105,100,116,104,44,32,107,115,105,122,101,46,104,101,105,103,104,116,41,41,0,110,111,114,109,97,108,105,122,101,65,110,99,104,111,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,101,110,103,105,110,101,46,104,112,112,0,103,101,116,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,0,77,111,114,112,104,70,105,108,116,101,114,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,100,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,102,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,115,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,116,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,97,120,79,112,73,104,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,100,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,102,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,115,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,116,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,49,95,53,77,105,110,79,112,73,104,69,69,78,83,49,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,54,95,69,69,69,69,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,85,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,49,54,83,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,101,112,116,104,32,61,61,32,67,86,95,54,52,70,0,99,114,101,97,116,101,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,82,69,67,84,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,67,82,79,83,83,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,69,76,76,73,80,83,69,0,103,101,116,83,116,114,117,99,116,117,114,105,110,103,69,108,101,109,101,110,116,0,109,111,114,112,104,111,108,111,103,121,69,120,0,117,110,107,110,111,119,110,32,109,111,114,112,104,111,108,111,103,105,99,97,108,32,111,112,101,114,97,116,105,111,110,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,99,111,114,110,101,114,69,105,103,101,110,86,97,108,115,86,101,99,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,114,110,101,114,46,99,112,112,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,49,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,50,93,41,32,60,32,115,111,102,116,102,108,111,97,116,40,49,46,53,102,41,0,82,71,66,50,76,117,118,102,108,111,97,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,108,97,98,46,99,112,112,0,119,104,105,116,101,80,116,91,49,93,32,61,61,32,115,111,102,116,100,111,117,98,108,101,58,58,111,110,101,40,41,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,102,69,69,69,0,99,91,48,93,32,62,61,32,48,32,38,38,32,99,91,49,93,32,62,61,32,48,32,38,38,32,99,91,50,93,32,62,61,32,48,32,38,38,32,99,91,48,93,32,43,32,99,91,49,93,32,43,32,99,91,50,93,32,60,32,115,111,102,116,102,108,111,97,116,40,40,105,110,116,41,76,65,66,95,67,66,82,84,95,84,65,66,95,83,73,90,69,41,0,82,71,66,50,76,97,98,95,102,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,60,32,50,42,40,49,32,60,60,32,108,97,98,95,115,104,105,102,116,41,0,82,71,66,50,76,97,98,95,98,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,98,69,69,69,0,76,117,118,50,82,71,66,102,108,111,97,116,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,98,69,69,69,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,53,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,50,44,32,53,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,78,79,78,69,93,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,72,111,117,103,104,76,105,110,101,115,83,68,105,118,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,111,117,103,104,46,99,112,112,0,108,105,110,101,115,77,97,120,32,62,32,48,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,83,68,105,118,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,102,108,111,97,116,44,32,102,108,111,97,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,50,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,51,0,72,111,117,103,104,76,105,110,101,115,83,116,97,110,100,97,114,100,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,83,116,97,110,100,97,114,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,102,108,111,97,116,44,32,102,108,111,97,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,109,97,120,95,116,104,101,116,97,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,109,105,110,95,116,104,101,116,97,0,109,97,120,95,116,104,101,116,97,0,109,105,110,95,116,104,101,116,97,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,87,114,111,110,103,32,116,121,112,101,32,111,102,32,111,117,116,112,117,116,32,108,105,110,101,115,0,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,72,111,117,103,104,76,105,110,101,115,80,114,111,98,97,98,105,108,105,115,116,105,99,0,33,95,105,109,97,103,101,46,101,109,112,116,121,40,41,32,38,38,32,95,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,40,95,105,109,97,103,101,46,105,115,77,97,116,40,41,32,124,124,32,95,105,109,97,103,101,46,105,115,85,77,97,116,40,41,41,0,72,111,117,103,104,67,105,114,99,108,101,115,0,95,99,105,114,99,108,101,115,46,105,115,77,97,116,40,41,32,124,124,32,95,99,105,114,99,108,101,115,46,105,115,86,101,99,116,111,114,40,41,0,100,112,44,32,109,105,110,95,100,105,115,116,44,32,99,97,110,110,121,95,116,104,114,101,115,104,111,108,100,32,97,110,100,32,97,99,99,95,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,97,108,108,32,112,111,115,105,116,105,118,101,32,110,117,109,98,101,114,115,0,107,101,114,110,101,108,83,105,122,101,32,61,61,32,45,49,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,51,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,53,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,55,0,72,111,117,103,104,67,105,114,99,108,101,115,71,114,97,100,105,101,110,116,0,72,111,117,103,104,67,105,114,99,108,101,69,115,116,105,109,97,116,101,82,97,100,105,117,115,73,110,118,111,107,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,109,101,116,104,111,100,32,105,100,46,32,65,99,116,117,97,108,108,121,32,111,110,108,121,32,67,86,95,72,79,85,71,72,95,71,82,65,68,73,69,78,84,32,105,115,32,115,117,112,112,111,114,116,101,100,46,0,78,50,99,118,51,50,72,111,117,103,104,67,105,114,99,108,101,69,115,116,105,109,97,116,101,82,97,100,105,117,115,73,110,118,111,107,101,114,73,78,83,95,49,48,78,90,80,111,105,110,116,83,101,116,69,69,69,0,78,50,99,118,51,50,72,111,117,103,104,67,105,114,99,108,101,69,115,116,105,109,97,116,101,82,97,100,105,117,115,73,110,118,111,107,101,114,73,78,83,95,49,49,78,90,80,111,105,110,116,76,105,115,116,69,69,69,0,78,50,99,118,51,48,72,111,117,103,104,67,105,114,99,108,101,115,70,105,110,100,67,101,110,116,101,114,115,73,110,118,111,107,101,114,69,0,78,50,99,118,50,52,72,111,117,103,104,67,105,114,99,108,101,115,65,99,99,117,109,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,67,105,114,99,108,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,87,114,111,110,103,32,116,121,112,101,32,111,102,32,111,117,116,112,117,116,32,99,105,114,99,108,101,115,0,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,51,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,51,50,70,67,52,0,99,118,83,116,97,114,116,82,101,97,100,67,104,97,105,110,80,111,105,110,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,116,111,117,114,115,46,99,112,112,0,99,118,83,116,97,114,116,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,91,83,116,97,114,116,93,70,105,110,100,67,111,110,116,111,117,114,115,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,67,86,95,56,85,67,49,32,105,109,97,103,101,115,32,119,104,101,110,32,109,111,100,101,32,33,61,32,67,86,95,82,69,84,82,95,70,76,79,79,68,70,73,76,76,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,111,114,116,115,32,67,86,95,51,50,83,67,49,32,105,109,97,103,101,115,32,111,110,108,121,0,115,116,101,112,32,62,61,32,48,0,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,49,0,99,118,70,105,110,100,78,101,120,116,67,111,110,116,111,117,114,0,115,99,97,110,110,101,114,45,62,105,109,103,95,115,116,101,112,32,62,61,32,48,0,112,116,114,32,33,61,32,78,85,76,76,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,95,51,50,115,0,105,52,32,33,61,32,78,85,76,76,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,0,112,97,114,95,105,110,102,111,32,33,61,32,48,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,0,108,95,99,105,110,102,111,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,95,51,50,115,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,0,99,118,69,110,100,70,105,110,100,67,111,110,116,111,117,114,115,0,78,85,76,76,32,100,111,117,98,108,101,32,67,118,83,101,113,32,112,111,105,110,116,101,114,0,99,118,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,78,111,110,122,101,114,111,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,67,86,95,76,73,78,75,95,82,85,78,83,32,121,101,116,0,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,105,99,118,70,105,110,100,67,111,110,116,111,117,114,115,73,110,73,110,116,101,114,118,97,108,0,67,111,110,116,111,117,114,32,104,101,97,100,101,114,32,115,105,122,101,32,109,117,115,116,32,98,101,32,62,61,32,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,73,110,112,117,116,32,97,114,114],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+358404);allocate([97,121,32,109,117,115,116,32,98,101,32,56,117,67,49,32,111,114,32,56,115,67,49,0,78,50,99,118,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,49,50,67,118,77,101,109,83,116,111,114,97,103,101,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,49,50,67,118,77,101,109,83,116,111,114,97,103,101,78,50,99,118,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,49,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,49,95,69,69,69,69,0,40,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,41,0,102,105,110,100,67,111,110,116,111,117,114,115,0,95,99,111,110,116,111,117,114,115,46,101,109,112,116,121,40,41,32,124,124,32,40,95,99,111,110,116,111,117,114,115,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,32,38,38,32,95,99,111,110,116,111,117,114,115,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,51,50,83,41,0,33,95,115,101,113,32,124,124,32,95,115,101,113,45,62,101,108,101,109,95,115,105,122,101,32,61,61,32,115,105,122,101,111,102,40,95,84,112,41,0,83,101,113,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,99,111,114,101,95,99,46,104,0,99,105,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,105,115,116,114,97,110,115,102,111,114,109,46,99,112,112,0,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,32,124,124,32,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,77,97,115,107,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,51,32,111,114,32,53,32,111,114,32,48,32,40,112,114,101,99,105,115,101,41,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,0,116,114,117,101,68,105,115,116,84,114,97,110,115,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,67,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,49,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,50,0,85,110,107,110,111,119,110,32,109,101,116,114,105,99,32,116,121,112,101,0,103,101,116,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,77,97,115,107,0,78,50,99,118,49,50,68,84,82,111,119,73,110,118,111,107,101,114,69,0,78,50,99,118,49,53,68,84,67,111,108,117,109,110,73,110,118,111,107,101,114,69,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,95,76,49,95,56,85,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,100,105,115,116,97,110,99,101,65,84,83,95,76,49,95,56,117,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,104,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,102,73,102,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,116,69,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,104,69,69,69,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,99,118,116,84,119,111,80,108,97,110,101,89,85,86,116,111,66,71,82,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,121,117,118,46,99,112,112,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,99,118,116,84,104,114,101,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,69,0,99,118,116,79,110,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,32,38,38,32,95,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,99,118,116,67,111,108,111,114,89,85,86,50,71,114,97,121,95,99,104,0,33,95,115,114,99,46,101,109,112,116,121,40,41,0,67,118,116,72,101,108,112,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,46,104,112,112,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,48,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,84,79,95,89,85,86,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,84,79,95,89,85,86,93,0,85,110,115,117,112,112,111,114,116,101,100,32,100,101,112,116,104,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,0,100,101,112,116,104,0,86,68,101,112,116,104,58,58,99,111,110,116,97,105,110,115,40,100,101,112,116,104,41,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,32,105,110,32,111,117,116,112,117,116,32,105,109,97,103,101,0,100,99,110,0,86,68,99,110,58,58,99,111,110,116,97,105,110,115,40,100,99,110,41,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,32,105,110,32,105,110,112,117,116,32,105,109,97,103,101,0,115,99,110,0,86,83,99,110,58,58,99,111,110,116,97,105,110,115,40,115,99,110,41,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,51,32,61,61,32,48,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,93,0,99,118,58,58,67,118,116,72,101,108,112,101,114,60,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,62,58,58,67,118,116,72,101,108,112,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,32,91,86,83,99,110,32,61,32,99,118,58,58,83,101,116,60,49,44,32,45,49,44,32,45,49,62,44,32,86,68,99,110,32,61,32,99,118,58,58,83,101,116,60,51,44,32,52,44,32,45,49,62,44,32,86,68,101,112,116,104,32,61,32,99,118,58,58,83,101,116,60,48,44,32,45,49,44,32,45,49,62,44,32,115,105,122,101,80,111,108,105,99,121,32,61,32,99,118,58,58,83,105,122,101,80,111,108,105,99,121,58,58,70,82,79,77,95,89,85,86,93,0,104,114,97,110,103,101,32,61,61,32,49,56,48,32,124,124,32,104,114,97,110,103,101,32,61,61,32,50,53,54,0,82,71,66,50,72,83,86,95,98,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,95,104,115,118,46,99,112,112,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,98,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,102,69,69,69,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,98,69,69,69,0,112,98,66,108,111,98,46,100,97,116,97,95,115,105,122,101,40,41,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,98,108,111,98,70,114,111,109,80,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,99,97,102,102,101,47,99,97,102,102,101,95,105,109,112,111,114,116,101,114,46,99,112,112,0,112,98,66,108,111,98,46,114,97,119,95,100,97,116,97,95,116,121,112,101,40,41,32,61,61,32,99,97,102,102,101,58,58,70,76,79,65,84,49,54,0,114,97,119,95,100,97,116,97,46,115,105,122,101,40,41,32,47,32,50,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,110,117,109,66,108,111,98,115,32,61,61,32,98,105,110,76,97,121,101,114,45,62,98,108,111,98,115,40,41,46,67,108,101,97,114,101,100,67,111,117,110,116,40,41,0,101,120,116,114,97,99,116,66,105,110,97,114,121,76,97,121,101,114,80,97,114,97,109,115,0,73,110,112,117,116,0,108,97,121,101,114,46,98,111,116,116,111,109,95,115,105,122,101,40,41,32,61,61,32,49,0,108,97,121,101,114,46,116,111,112,95,115,105,122,101,40,41,32,61,61,32,49,0,47,109,118,110,0,67,111,110,118,111,108,117,116,105,111,110,68,101,112,116,104,119,105,115,101,0,40,105,100,120,32,61,61,32,45,49,32,38,38,32,115,105,122,101,40,41,32,61,61,32,49,41,32,124,124,32,40,105,100,120,32,62,61,32,48,32,38,38,32,105,100,120,32,60,32,115,105,122,101,40,41,41,0,105,115,82,101,97,108,40,41,32,124,124,32,105,115,73,110,116,40,41,32,124,124,32,105,115,83,116,114,105,110,103,40,41,0,102,114,97,99,112,97,114,116,32,61,61,32,48,46,48,0,105,115,73,110,116,40,41,32,124,124,32,105,115,82,101,97,108,40,41,32,124,124,32,105,115,83,116,114,105,110,103,40,41,0,95,112,97,114,97,109,0,102,105,101,108,100,46,116,121,112,101,40,41,32,61,61,32,103,111,111,103,108,101,58,58,112,114,111,116,111,98,117,102,58,58,85,110,107,110,111,119,110,70,105,101,108,100,58,58,84,89,80,69,95,71,82,79,85,80,0,101,120,116,114,97,99,116,67,117,115,116,111,109,80,97,114,97,109,115,0,34,32,105,110,32,112,114,111,116,111,116,120,116,0,97,100,100,80,97,114,97,109,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,75,78,83,48,95,49,53,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,69,69,69,0,118,48,95,108,97,121,101,114,95,99,111,110,110,101,99,116,105,111,110,95,32,33,61,32,78,85,76,76,0,85,112,103,114,97,100,101,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,99,97,102,102,101,47,99,97,102,102,101,95,105,111,46,99,112,112,0,99,111,110,118,0,105,110,110,101,114,112,114,111,100,117,99,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,117,109,95,111,117,116,112,117,116,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,105,97,115,116,101,114,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,119,101,105,103,104,116,95,102,105,108,108,101,114,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,105,97,115,95,102,105,108,108,101,114,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,112,111,111,108,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,112,97,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,107,101,114,110,101,108,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,103,114,111,117,112,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,116,114,105,100,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,111,111,108,32,109,101,116,104,111,100,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,112,111,111,108,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,100,114,111,112,111,117,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,114,111,112,111,117,116,95,114,97,116,105,111,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,108,114,110,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,108,111,99,97,108,95,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,97,108,112,104,97,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,101,116,97,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,107,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,100,97,116,97,0,104,100,102,53,95,100,97,116,97,0,105,109,97,103,101,115,0,119,105,110,100,111,119,95,100,97,116,97,0,105,110,102,111,103,97,105,110,95,108,111,115,115,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,111,117,114,99,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,97,116,99,104,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,114,97,110,100,95,115,107,105,112,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,104,117,102,102,108,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,101,119,95,104,101,105,103,104,116,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,101,119,95,119,105,100,116,104,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,99,111,110,99,97,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,99,111,110,99,97,116,95,100,105,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,102,103,95,116,104,114,101,115,104,111,108,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,98,103,95,116,104,114,101,115,104,111,108,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,102,103,95,102,114,97,99,116,105,111,110,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,99,111,110,116,101,120,116,95,112,97,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,99,114,111,112,95,109,111,100,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,104,100,102,53,95,111,117,116,112,117,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,70,65,73,76,69,68,58,32,0,46,32,0,97,99,99,117,114,97,99,121,0,98,110,108,108,0,101,117,99,108,105,100,101,97,110,95,108,111,115,115,0,102,108,97,116,116,101,110,0,105,109,50,99,111,108,0,109,117,108,116,105,110,111,109,105,97,108,95,108,111,103,105,115,116,105,99,95,108,111,115,115,0,114,101,108,117,0,115,105,103,109,111,105,100,0,115,111,102,116,109,97,120,95,108,111,115,115,0,115,112,108,105,116,0,85,112,103,114,97,100,101,86,48,76,97,121,101,114,84,121,112,101,0,85,110,107,110,111,119,110,32,108,97,121,101,114,32,110,97,109,101,58,32,0,85,112,103,114,97,100,101,86,48,80,97,100,100,105,110,103,76,97,121,101,114,115,0,85,110,107,110,111,119,110,32,98,108,111,98,32,105,110,112,117,116,32,0,32,116,111,32,108,97,121,101,114,32,0,40,108,97,121,101,114,95,112,97,114,97,109,46,116,121,112,101,40,41,32,61,61,32,34,99,111,110,118,34,41,32,124,124,32,40,108,97,121,101,114,95,112,97,114,97,109,46,116,121,112,101,40,41,32,61,61,32,34,112,111,111,108,34,41,0,108,97,121,101,114,95,99,111,110,110,101,99,116,105,111,110,46,98,111,116,116,111,109,95,115,105,122,101,40,41,61,49,0,80,97,100,100,105,110,103,32,108,97,121,101,114,32,105,110,112,117,116,32,116,111,32,110,111,110,45,99,111,110,118,111,108,117,116,105,111,110,97,108,32,47,32,110,111,110,45,112,111,111,108,105,110,103,32,108,97,121,101,114,32,116,121,112,101,32,0,115,111,117,114,99,101,95,108,97,121,101,114,46,98,111,116,116,111,109,95,115,105,122,101,40,41,61,49,0,67,111,110,118,32,76,97,121,101,114,32,116,97,107,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,105,110,112,117,116,46,0,115,111,117,114,99,101,95,108,97,121,101,114,46,116,111,112,95,115,105,122,101,40,41,61,49,0,80,97,100,100,105,110,103,32,76,97,121,101,114,32,116,97,107,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,105,110,112,117,116,46,0,80,97,100,100,105,110,103,32,76,97,121,101,114,32,112,114,111,100,117,99,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,111,117,116,112,117,116,46,0,85,112,103,114,97,100,101,78,101,116,65,115,78,101,101,100,101,100,0,65,116,116,101,109,112,116,105,110,103,32,116,111,32,117,112,103,114,97,100,101,32,105,110,112,117,116,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,58,32,0,87,97,114,110,105,110,103,58,32,104,97,100,32,111,110,101,32,111,114,32,109,111,114,101,32,112,114,111,98,108,101,109,115,32,117,112,103,114,97,100,105,110,103,32,0,86,48,78,101,116,80,97,114,97,109,101,116,101,114,32,116,111,32,78,101,116,80,97,114,97,109,101,116,101,114,32,40,115,101,101,32,97,98,111,118,101,41,59,32,99,111,110,116,105,110,117,105,110,103,32,97,110,121,119,97,121,46,0,83,117,99,99,101,115,115,102,117,108,108,121,32,117,112,103,114,97,100,101,100,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,78,111,116,101,32,116,104,97,116,32,102,117,116,117,114,101,32,67,97,102,102,101,32,114,101,108,101,97,115,101,115,32,119,105,108,108,32,110,111,116,32,115,117,112,112,111,114,116,32,0,86,48,78,101,116,80,97,114,97,109,101,116,101,114,59,32,117,115,101,32,46,47,98,117,105,108,100,47,116,111,111,108,115,47,117,112,103,114,97,100,101,95,110,101,116,95,112,114,111,116,111,95,116,101,120,116,32,102,111,114,32,0,112,114,111,116,111,116,120,116,32,97,110,100,32,46,47,98,117,105,108,100,47,116,111,111,108,115,47,117,112,103,114,97,100,101,95,110,101,116,95,112,114,111,116,111,95,98,105,110,97,114,121,32,102,111,114,32,109,111,100,101,108,32,0,119,101,105,103,104,116,115,32,117,112,103,114,97,100,101,32,116,104,105,115,32,97,110,100,32,97,110,121,32,111,116,104,101,114,32,110,101,116,32,112,114,111,116,111,115,32,116,111,32,116,104,101,32,110,101,119,32,102,111,114,109,97,116,46,0,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,112,97,114,97,109,101,116,101,114,115,58,32,0,100,97,116,97,32,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,112,97,114,97,109,101,116,101,114,115,46,0,78,111,116,101,32,116,104,97,116,32,102,117,116,117,114,101,32,67,97,102,102,101,32,114,101,108,101,97,115,101,115,32,119,105,108,108,32,111,110,108,121,32,115,117,112,112,111,114,116,32,0,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,32,109,101,115,115,97,103,101,115,32,102,111,114,32,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,102,105,101,108,100,115,46,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,58,32,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,32,40,115,101,101,32,97,98,111,118,101,41,59,32,99,111,110,116,105,110,117,105,110,103,32,97,110,121,119,97,121,46,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,65,116,116,101,109,112,116,105,110,103,32,116,111,32,117,112,103,114,97,100,101,32,98,97,116,99,104,32,110,111,114,109,32,108,97,121,101,114,115,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,112,97,114,97,109,115,58,32,0,83,117,99,99,101,115,115,102,117,108,108,121,32,117,112,103,114,97,100,101,100,32,98,97,116,99,104,32,110,111,114,109,32,108,97,121,101,114,115,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,112,97,114,97,109,115,46,0,110,101,116,95,112,97,114,97,109,32,33,61,32,78,85,76,76,0,85,112,103,114,97,100,101,86,49,78,101,116,0,73,110,112,117,116,32,78,101,116,80,97,114,97,109,101,116,101,114,32,116,111,32,98,101,32,117,112,103,114,97,100,101,100,32,97,108,114,101,97,100,121,32,115,112,101,99,105,102,105,101,115,32,39,108,97,121,101,114,39,32,0,102,105,101,108,100,115,59,32,116,104,101,115,101,32,119,105,108,108,32,98,101,32,105,103,110,111,114,101,100,32,102,111,114,32,116,104,101,32,117,112,103,114,97,100,101,46,0,85,112,103,114,97,100,101,32,111,102,32,105,110,112,117,116,32,108,97,121,101,114,32,0,32,102,97,105,108,101,100,46,0,118,49,95,108,97,121,101,114,95,112,97,114,97,109,95,32,33,61,32,78,85,76,76,0,85,112,103,114,97,100,101,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,85,110,107,110,111,119,110,32,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,58,32,37,100,0,85,110,107,110,111,119,110,32,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,58,32,0,73,110,112,117,116,32,78,101,116,80,97,114,97,109,101,116,101,114,32,104,97,115,32,86,48,32,108,97,121,101,114,32,45,45,32,105,103,110,111,114,105,110,103,46,0,85,112,103,114,97,100,101,86,49,76,97,121,101,114,84,121,112,101,0,85,110,107,110,111,119,110,32,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,32,108,97,121,101,114,32,116,121,112,101,58,32,0,84,104,114,101,115,104,111,108,100,0,87,105,110,100,111,119,68,97,116,97,0,83,111,102,116,109,97,120,87,105,116,104,76,111,115,115,0,83,105,103,109,111,105,100,67,114,111,115,115,69,110,116,114,111,112,121,76,111,115,115,0,77,117,108,116,105,110,111,109,105,97,108,76,111,103,105,115,116,105,99,76,111,115,115,0,77,101,109,111,114,121,68,97,116,97,0,73,110,102,111,103,97,105,110,76,111,115,115,0,73,109,97,103,101,68,97,116,97,0,73,109,50,99,111,108,0,72,105,110,103,101,76,111,115,115,0,72,68,70,53,79,117,116,112,117,116,0,72,68,70,53,68,97,116,97,0,69,117,99,108,105,100,101,97,110,76,111,115,115,0,68,117,109,109,121,68,97,116,97,0,68,97,116,97,0,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,0,66,78,76,76,0,65,114,103,77,97,120,0,65,99,99,117,114,97,99,121,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,70,105,108,101,0,102,115,46,105,115,95,111,112,101,110,40,41,0,67,97,110,39,116,32,111,112,101,110,32,34,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,70,105,108,101,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,70,105,108,101,79,114,68,105,101,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,66,117,102,102,101,114,79,114,68,105,101,0,109,101,109,111,114,121,32,98,117,102,102,101,114,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,78,101,116,80,97,114,97,109,101,116,101,114,32,98,117,102,102,101,114,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,70,105,108,101,79,114,68,105,101,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,66,117,102,102,101,114,79,114,68,105,101,0,105,116,32,33,61,32,100,97,116,97,95,108,97,121,111,117,116,115,46,101,110,100,40,41,0,112,114,101,100,105,99,116,79,117,116,112,117,116,68,97,116,97,76,97,121,111,117,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,105,109,112,111,114,116,101,114,46,99,112,112,0,67,111,110,118,50,68,0,83,112,97,99,101,84,111,66,97,116,99,104,78,68,0,68,101,112,116,104,119,105,115,101,67,111,110,118,50,100,78,97,116,105,118,101,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,51,0,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,73,78,84,51,50,0,112,97,114,115,101,68,105,109,115,0,100,105,109,115,32,61,61,32,49,0,118,97,108,117,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,100,105,108,97,116,105,111,110,46,115,105,122,101,40,41,32,61,61,32,50,0,115,105,122,101,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,112,97,114,115,101,84,101,110,115,111,114,0,100,115,116,95,105,32,60,32,116,111,116,97,108,0,115,114,99,95,105,32,60,32,116,111,116,97,108,0,110,101,120,116,95,108,97,121,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,112,97,100,100,105,110,103,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,66,105,97,115,65,100,100,0,110,117,109,87,101,105,103,104,116,115,32,37,32,52,32,61,61,32,48,0,33,108,111,99,80,114,101,100,84,114,97,110,115,112,111,115,101,100,0,66,97,116,99,104,84,111,83,112,97,99,101,78,68,0,33,104,97,118,101,67,111,110,115,116,32,124,124,32,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,118,97,108,117,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,73,110,112,117,116,32,108,97,121,101,114,32,110,111,116,32,102,111,117,110,100,58,32,0,104,97,118,101,67,111,110,115,116,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,47,110,99,104,119,0,108,97,121,101,114,95,105,100,46,102,105,110,100,40,112,101,114,109,78,97,109,101,41,32,61,61,32,108,97,121,101,114,95,105,100,46,101,110,100,40,41,0,83,113,117,101,101,122,101,0,115,113,117,101,101,122,101,95,100,105,109,115,0,104,97,115,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,115,113,117,101,101,122,101,95,100,105,109,115,34,41,0,85,110,115,117,112,112,111,114,116,101,100,32,115,113,117,101,101,122,101,32,99,111,110,102,105,103,117,114,97,116,105,111,110,0,112,101,114,109,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,79,110,108,121,32,78,72,87,67,32,60,45,62,32,78,67,72,87,32,112,101,114,109,117,116,97,116,105,111,110,115,32,97,114,101,32,97,108,108,111,119,101,100,46,0,100,101,112,116,104,95,114,97,100,105,117,115,0,67,111,110,99,97,116,86,50,0,45,52,32,60,61,32,105,100,120,32,38,38,32,105,100,120,32,60,32,52,0,116,111,78,67,72,87,0,65,118,103,80,111,111,108,0,80,108,97,99,101,104,111,108,100,101,114,0,100,116,121,112,101,0,33,98,101,103,105,110,115,46,101,109,112,116,121,40,41,0,33,115,105,122,101,115,46,101,109,112,116,121,40,41,0,115,99,97,108,101,77,97,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,110,101,116,46,110,111,100,101,40,109,97,120,105,109,117,109,76,97,121,101,114,73,100,120,41,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,69,120,112,101,99,116,101,100,32,103,97,109,109,97,44,32,98,101,116,97,44,32,109,101,97,110,32,97,110,100,32,115,116,100,0,105,115,95,116,114,97,105,110,105,110,103,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,110,117,109,98,101,114,32,111,102,32,112,97,114,97,109,101,116,101,114,115,32,102,111,114,32,98,97,116,99,104,32,110,111,114,109,97,108,105,122,97,116,105,111,110,32,108,97,121,101,114,46,0,47,77,86,78,0,108,97,121,101,114,95,105,100,46,102,105,110,100,40,109,118,110,78,97,109,101,41,32,61,61,32,108,97,121,101,114,95,105,100,46,101,110,100,40,41,0,69,120,112,101,99,116,101,100,32,111,117,116,112,117,116,32,115,104,97,112,101,44,32,119,101,105,103,104,116,115,32,97,110,100,32,105,110,112,117,116,32,110,111,100,101,115,0,66,108,111,99,107,76,83,84,77,0,85,110,101,120,112,101,99,116,101,100,32,110,117,109,98,101,114,32,111,102,32,105,110,112,117,116,32,110,111,100,101,115,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,32,124,124,32,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,51,0,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,97,116,60,105,110,116,62,40,105,41,32,61,61,32,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+368644);allocate([115,46,97,116,60,105,110,116,62,40,105,32,45,32,49,41,32,43,32,49,0,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,97,116,60,105,110,116,62,40,105,41,32,42,32,114,101,100,117,99,116,105,111,110,73,110,100,105,99,101,115,46,97,116,60,105,110,116,62,40,105,32,45,32,49,41,32,62,61,32,48,0,80,114,105,111,114,66,111,120,0,115,99,97,108,101,115,0,77,101,97,110,0,105,110,100,105,99,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,85,110,115,117,112,112,111,114,116,101,100,32,109,111,100,101,32,111,102,32,114,101,100,117,99,101,95,109,101,97,110,32,111,112,101,114,97,116,105,111,110,46,0,107,101,101,112,95,100,105,109,115,0,47,102,108,97,116,116,101,110,0,108,97,121,101,114,95,105,100,46,102,105,110,100,40,102,108,97,116,116,101,110,78,97,109,101,41,32,61,61,32,108,97,121,101,114,95,105,100,46,101,110,100,40,41,0,67,108,105,112,66,121,86,97,108,117,101,0,65,98,115,0,82,101,108,117,0,69,108,117,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,84,70,73,109,112,111,114,116,101,114,58,58,112,111,112,117,108,97,116,101,78,101,116,40,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,78,101,116,41,0,109,97,120,86,97,108,117,101,46,116,121,112,101,40,41,0,109,97,120,86,97,108,117,101,46,116,111,116,97,108,40,41,0,109,105,110,86,97,108,117,101,46,116,121,112,101,40,41,0,109,105,110,86,97,108,117,101,46,116,111,116,97,108,40,41,0,99,114,111,112,83,105,122,101,46,116,111,116,97,108,40,41,0,99,114,111,112,83,105,122,101,46,116,121,112,101,40,41,0,102,97,99,116,111,114,87,105,100,116,104,46,116,111,116,97,108,40,41,0,102,97,99,116,111,114,87,105,100,116,104,46,116,121,112,101,40,41,0,102,97,99,116,111,114,72,101,105,103,104,116,46,116,111,116,97,108,40,41,0,102,97,99,116,111,114,72,101,105,103,104,116,46,116,121,112,101,40,41,0,111,117,116,83,105,122,101,46,116,111,116,97,108,40,41,0,111,117,116,83,105,122,101,46,116,121,112,101,40,41,0,105,115,83,116,114,105,110,103,40,41,0,103,101,116,0,40,105,100,120,32,61,61,32,45,49,32,38,38,32,112,115,45,62,115,105,122,101,40,41,32,61,61,32,49,41,32,124,124,32,40,105,100,120,32,62,61,32,48,32,38,38,32,105,100,120,32,60,32,40,105,110,116,41,112,115,45,62,115,105,122,101,40,41,41,0,82,101,113,117,105,114,101,100,32,97,114,103,117,109,101,110,116,32,34,0,34,32,110,111,116,32,102,111,117,110,100,32,105,110,116,111,32,100,105,99,116,105,111,110,97,114,121,0,115,105,122,101,115,46,116,121,112,101,40,41,0,98,101,103,105,110,115,46,116,121,112,101,40,41,0,107,115,105,122,101,0,85,110,115,117,112,112,111,114,116,101,100,32,107,115,105,122,101,0,115,101,116,75,83,105,122,101,0,85,110,115,117,112,112,111,114,116,101,100,32,115,116,114,105,100,101,115,0,115,101,116,83,116,114,105,100,101,115,0,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,70,76,79,65,84,32,124,124,32,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,72,65,76,70,0,107,101,114,110,101,108,70,114,111,109,84,101,110,115,111,114,0,100,105,109,115,32,61,61,32,52,0,98,108,111,98,70,114,111,109,84,101,110,115,111,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,116,32,33,61,32,101,110,100,40,41,58,32,0,107,101,121,32,110,111,116,32,102,111,117,110,100,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,77,97,112,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,56,73,110,110,101,114,77,97,112,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,52,104,97,115,104,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,105,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,85,110,107,110,111,119,110,32,115,104,97,112,101,32,111,102,32,105,110,112,117,116,32,116,101,110,115,111,114,0,98,108,111,98,83,104,97,112,101,70,114,111,109,84,101,110,115,111,114,0,77,111,114,101,32,116,104,97,110,32,111,110,101,32,105,110,112,117,116,32,105,115,32,67,111,110,115,116,32,111,112,0,103,101,116,67,111,110,115,116,66,108,111,98,0,67,111,110,115,116,32,105,110,112,117,116,32,98,108,111,98,32,102,111,114,32,119,101,105,103,104,116,115,32,110,111,116,32,102,111,117,110,100,0,73,110,112,117,116,32,91,0,93,32,102,111,114,32,110,111,100,101,32,91,0,93,32,110,111,116,32,102,111,117,110,100,0,85,110,115,117,112,112,111,114,116,101,100,32,107,101,114,110,101,108,32,105,110,112,117,116,0,109,97,112,58,58,97,116,58,32,32,107,101,121,32,110,111,116,32,102,111,117,110,100,0,110,111,100,101,73,100,120,32,60,32,110,101,116,84,120,116,46,110,111,100,101,95,115,105,122,101,40,41,0,110,101,116,84,120,116,46,110,111,100,101,40,110,111,100,101,73,100,120,41,46,110,97,109,101,40,41,32,61,61,32,107,101,114,110,101,108,95,105,110,112,46,110,97,109,101,0,100,97,116,97,95,102,111,114,109,97,116,0,78,72,87,67,0,99,104,97,110,110,101,108,115,95,108,97,115,116,0,78,67,72,87,0,99,104,97,110,110,101,108,115,95,102,105,114,115,116,0,85,110,107,110,111,119,110,32,100,97,116,97,95,102,111,114,109,97,116,32,118,97,108,117,101,58,32,0,103,101,116,68,97,116,97,76,97,121,111,117,116,0,68,101,113,117,97,110,116,105,122,101,0,97,100,100,67,111,110,115,116,78,111,100,101,115,0,99,111,110,115,116,95,108,97,121,101,114,115,46,102,105,110,100,40,108,97,121,101,114,46,105,110,112,117,116,40,105,41,41,32,33,61,32,99,111,110,115,116,95,108,97,121,101,114,115,46,101,110,100,40,41,0,77,73,78,95,70,73,82,83,84,0,104,97,115,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,109,111,100,101,34,41,32,38,38,32,103,101,116,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,109,111,100,101,34,41,46,115,40,41,32,61,61,32,34,77,73,78,95,70,73,82,83,84,34,0,116,101,110,115,111,114,45,62,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,81,85,73,78,84,56,0,113,77,105,110,46,116,111,116,97,108,40,41,32,61,61,32,49,0,113,77,105,110,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,113,77,97,120,46,116,111,116,97,108,40,41,32,61,61,32,49,0,113,77,97,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,114,97,110,103,101,83,99,97,108,101,32,62,61,32,48,0,99,111,110,115,116,95,108,97,121,101,114,115,46,105,110,115,101,114,116,40,115,116,100,58,58,109,97,107,101,95,112,97,105,114,40,110,97,109,101,44,32,116,101,110,115,111,114,73,100,41,41,46,115,101,99,111,110,100,0,99,111,110,115,116,95,108,97,121,101,114,115,46,105,110,115,101,114,116,40,115,116,100,58,58,109,97,107,101,95,112,97,105,114,40,110,97,109,101,44,32,108,105,41,41,46,115,101,99,111,110,100,0,110,111,100,101,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,105,110,112,73,110,100,105,99,101,115,46,115,105,122,101,40,41,0,114,101,112,108,97,99,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,103,114,97,112,104,95,115,105,109,112,108,105,102,105,101,114,46,99,112,112,0,33,105,110,112,78,97,109,101,46,101,109,112,116,121,40,41,0,105,110,112,73,100,32,60,32,110,111,100,101,46,105,110,112,117,116,95,115,105,122,101,40,41,0,103,101,116,73,110,112,117,116,78,111,100,101,0,73,110,112,117,116,32,110,111,100,101,32,119,105,116,104,32,110,97,109,101,32,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,50,82,101,115,104,97,112,101,65,115,83,104,97,112,101,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,50,82,101,115,104,97,112,101,65,115,83,104,97,112,101,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,83,104,97,112,101,0,67,111,110,115,116,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,56,83,117,98,103,114,97,112,104,69,0,110,111,100,101,73,110,112,117,116,115,91,105,93,32,60,32,40,105,110,116,41,110,111,100,101,115,46,115,105,122,101,40,41,0,115,101,116,70,117,115,101,100,78,111,100,101,0,105,110,112,117,116,115,95,91,105,93,32,60,32,40,105,110,116,41,110,111,100,101,115,46,115,105,122,101,40,41,0,97,100,100,78,111,100,101,84,111,77,97,116,99,104,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,50,82,101,115,104,97,112,101,65,115,83,104,97,112,101,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,51,85,112,115,97,109,112,108,105,110,103,75,101,114,97,115,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,51,85,112,115,97,109,112,108,105,110,103,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,83,116,114,105,100,101,100,83,108,105,99,101,0,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,0,47,102,97,99,116,111,114,95,121,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,85,112,115,97,109,112,108,105,110,103,75,101,114,97,115,83,117,98,103,114,97,112,104,58,58,102,105,110,97,108,105,122,101,40,116,101,110,115,111,114,102,108,111,119,58,58,71,114,97,112,104,68,101,102,32,38,44,32,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,62,32,38,41,0,102,97,99,116,111,114,115,77,97,116,46,116,121,112,101,40,41,0,67,86,95,51,50,83,67,49,0,102,97,99,116,111,114,115,77,97,116,46,116,111,116,97,108,40,41,0,40,115,105,122,101,95,116,41,50,0,103,101,116,84,101,110,115,111,114,67,111,110,116,101,110,116,0,33,99,111,110,116,101,110,116,46,101,109,112,116,121,40,41,0,84,101,110,115,111,114,39,115,32,100,97,116,97,32,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,51,85,112,115,97,109,112,108,105,110,103,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,50,82,101,115,105,122,101,66,105,108,105,110,101,97,114,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,50,82,101,115,105,122,101,66,105,108,105,110,101,97,114,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,82,101,115,105,122,101,66,105,108,105,110,101,97,114,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,50,82,101,115,105,122,101,66,105,108,105,110,101,97,114,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,48,68,101,99,111,110,118,111,108,117,116,105,111,110,83,97,109,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,48,68,101,99,111,110,118,111,108,117,116,105,111,110,83,97,109,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,67,111,110,118,50,68,66,97,99,107,112,114,111,112,73,110,112,117,116,0,112,97,100,77,111,100,101,32,61,61,32,34,83,65,77,69,34,0,115,116,114,105,100,101,115,46,105,95,115,105,122,101,40,41,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,48,68,101,99,111,110,118,111,108,117,116,105,111,110,83,97,109,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,49,68,101,99,111,110,118,111,108,117,116,105,111,110,86,97,108,105,100,75,101,114,97,115,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,49,68,101,99,111,110,118,111,108,117,116,105,111,110,86,97,108,105,100,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,112,97,100,77,111,100,101,32,61,61,32,34,86,65,76,73,68,34,0,107,101,114,110,101,108,83,104,97,112,101,46,100,105,109,95,115,105,122,101,40,41,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,49,68,101,99,111,110,118,111,108,117,116,105,111,110,86,97,108,105,100,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,57,76,50,78,111,114,109,97,108,105,122,101,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,57,76,50,78,111,114,109,97,108,105,122,101,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,77,97,120,105,109,117,109,0,82,115,113,114,116,0,76,50,78,111,114,109,97,108,105,122,101,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,57,76,50,78,111,114,109,97,108,105,122,101,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,82,101,115,104,97,112,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,82,101,115,104,97,112,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,82,101,115,104,97,112,101,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,56,82,101,76,85,54,75,101,114,97,115,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,56,82,101,76,85,54,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,77,105,110,105,109,117,109,0,82,101,108,117,54,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,56,82,101,76,85,54,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,83,111,102,116,77,97,120,75,101,114,97,115,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,83,111,102,116,77,97,120,75,101,114,97,115,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,77,97,120,0,69,120,112,0,82,101,97,108,68,105,118,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,83,111,102,116,77,97,120,75,101,114,97,115,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,70,108,97,116,116,101,110,83,104,97,112,101,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,70,108,97,116,116,101,110,83,104,97,112,101,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,70,108,97,116,116,101,110,83,104,97,112,101,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,53,70,108,97,116,116,101,110,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,53,70,108,97,116,116,101,110,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,53,70,108,97,116,116,101,110,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,52,66,97,116,99,104,78,111,114,109,78,111,71,97,109,109,97,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,52,66,97,116,99,104,78,111,114,109,78,111,71,97,109,109,97,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,70,117,115,101,100,66,97,116,99,104,78,111,114,109,0,47,103,97,109,109,97,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,66,97,116,99,104,78,111,114,109,78,111,71,97,109,109,97,83,117,98,103,114,97,112,104,58,58,102,105,110,97,108,105,122,101,40,116,101,110,115,111,114,102,108,111,119,58,58,71,114,97,112,104,68,101,102,32,38,44,32,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,62,32,38,41,0,101,112,115,77,97,116,46,116,121,112,101,40,41,0,101,112,115,77,97,116,46,116,111,116,97,108,40,41,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,52,66,97,116,99,104,78,111,114,109,78,111,71,97,109,109,97,83,117,98,103,114,97,112,104,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,55,66,97,116,99,104,78,111,114,109,83,117,98,103,114,97,112,104,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,55,66,97,116,99,104,78,111,114,109,83,117,98,103,114,97,112,104,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,66,97,116,99,104,78,111,114,109,83,117,98,103,114,97,112,104,58,58,102,105,110,97,108,105,122,101,40,116,101,110,115,111,114,102,108,111,119,58,58,71,114,97,112,104,68,101,102,32,38,44,32,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,116,101,110,115,111,114,102,108,111,119,58,58,78,111,100,101,68,101,102,32,42,62,32,38,41,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,55,66,97,116,99,104,78,111,114,109,83,117,98,103,114,97,112,104,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,111,114,99,104,47,116,111,114,99,104,95,105,109,112,111,114,116,101,114,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,76,117,97,32,116,121,112,101,0,114,101,97,100,79,98,106,101,99,116,0,84,101,110,115,111,114,0,116,111,114,99,104,46,0,83,116,111,114,97,103,101,0,116,111,114,99,104,95,105,110,100,101,120,0,83,101,113,117,101,110,116,105,97,108,0,80,97,114,97,108,108,101,108,0,67,111,110,99,97,116,84,97,98,108,101,0,74,111,105,110,84,97,98,108,101,0,68,101,112,116,104,67,111,110,99,97,116,0,73,110,99,101,112,116,105,111,110,0,105,110,112,117,116,68,105,109,101,110,115,105,111,110,0,111,117,116,112,117,116,68,105,109,101,110,115,105,111,110,0,100,105,109,101,110,115,105,111,110,0,83,112,97,116,105,97,108,67,111,110,118,111,108,117,116,105,111,110,0,83,112,97,116,105,97,108,67,111,110,118,111,108,117,116,105,111,110,77,77,0,119,101,105,103,104,116,0,116,101,110,115,111,114,80,97,114,97,109,115,46,99,111,117,110,116,40,34,119,101,105,103,104,116,34,41,0,114,101,97,100,84,111,114,99,104,79,98,106,101,99,116,0,110,79,117,116,112,117,116,80,108,97,110,101,0,108,97,121,101,114,80,97,114,97,109,115,46,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,50,0,83,112,97,116,105,97,108,76,80,80,111,111,108,105,110,103,0,83,112,97,116,105,97,108,77,97,120,80,111,111,108,105,110,103,0,83,112,97,116,105,97,108,65,118,101,114,97,103,101,80,111,111,108,105,110,103,0,105,110,100,105,99,101,115,95,98,108,111,98,95,105,100,0,105,110,100,105,99,101,115,0,99,111,117,110,116,95,105,110,99,108,117,100,101,95,112,97,100,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,99,101,105,108,95,109,111,100,101,34,41,0,76,105,110,101,97,114,0,86,105,101,119,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,0,98,97,116,99,104,77,111,100,101,0,84,97,110,104,0,83,112,97,116,105,97,108,66,97,116,99,104,78,111,114,109,97,108,105,122,97,116,105,111,110,0,73,110,115,116,97,110,99,101,78,111,114,109,97,108,105,122,97,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,101,112,115,34,41,0,114,117,110,110,105,110,103,95,109,101,97,110,0,110,79,117,116,112,117,116,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,34,41,0,114,117,110,110,105,110,103,95,118,97,114,0,114,117,110,110,105,110,103,95,115,116,100,0,116,101,110,115,111,114,80,97,114,97,109,115,91,34,119,101,105,103,104,116,34,93,46,115,101,99,111,110,100,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,67,104,97,110,110,101,108,115,0,116,101,110,115,111,114,80,97,114,97,109,115,91,34,119,101,105,103,104,116,34,93,46,115,101,99,111,110,100,46,116,111,116,97,108,40,41,32,61,61,32,49,0,83,112,97,116,105,97,108,68,114,111,112,111,117,116,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,34,41,0,84,111,116,97,108,86,97,114,105,97,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,109,34,41,0,105,110,100,101,120,0,80,97,100,100,105,110,103,32,119,105,116,104,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,110,73,110,112,117,116,68,105,109,0,67,65,100,100,84,97,98,108,101,0,83,112,97,116,105,97,108,68,105,108,97,116,101,100,67,111,110,118,111,108,117,116,105,111,110,0,100,105,108,97,116,105,111,110,87,0,100,105,108,97,116,105,111,110,72,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,87,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,108,97,116,105,111,110,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,108,97,116,105,111,110,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,80,108,97,110,101,34,41,0,83,112,97,116,105,97,108,70,117,108,108,67,111,110,118,111,108,117,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,87,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,100,106,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,100,106,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,80,108,97,110,101,34,41,0,83,112,97,116,105,97,108,77,97,120,85,110,112,111,111,108,105,110,103,0,116,101,110,115,111,114,80,97,114,97,109,115,46,99,111,117,110,116,40,34,105,110,100,105,99,101,115,34,41,0,83,111,102,116,77,97,120,0,76,111,103,83,111,102,116,77,97,120,0,83,112,97,116,105,97,108,67,114,111,115,115,77,97,112,76,82,78,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,108,112,104,97,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,98,101,116,97,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,34,41,0,83,113,117,97,114,101,0,83,113,114,116,0,112,111,119,0,77,117,108,67,111,110,115,116,97,110,116,0,99,111,110,115,116,97,110,116,95,115,99,97,108,97,114,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,99,111,110,115,116,97,110,116,95,115,99,97,108,97,114,34,41,0,83,112,97,116,105,97,108,90,101,114,111,80,97,100,100,105,110,103,0,83,112,97,116,105,97,108,82,101,102,108,101,99,116,105,111,110,80,97,100,100,105,110,103,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,108,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,114,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,116,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,98,34,41,0,83,112,97,116,105,97,108,90,101,114,111,80,97,100,100,105,110,103,32,105,110,32,99,114,111,112,112,105,110,103,32,109,111,100,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,83,104,97,118,101,73,109,97,103,101,0,83,112,97,116,105,97,108,85,112,83,97,109,112,108,105,110,103,78,101,97,114,101,115,116,0,115,99,97,108,101,95,102,97,99,116,111,114,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,115,99,97,108,101,95,102,97,99,116,111,114,34,41,0,85,110,115,117,112,112,111,114,116,101,100,32,84,111,114,99,104,32,99,108,97,115,115,32,34,0,108,117,97,84,121,112,101,32,61,61,32,84,89,80,69,95,84,65,66,76,69,32,38,38,32,114,101,97,100,101,100,73,110,100,101,120,101,115,46,99,111,117,110,116,40,105,110,100,101,120,41,32,61,61,32,48,0,114,101,97,100,84,111,114,99,104,84,97,98,108,101,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,51,84,111,114,99,104,73,109,112,111,114,116,101,114,54,77,111,100,117,108,101,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,51,84,111,114,99,104,73,109,112,111,114,116,101,114,54,77,111,100,117,108,101,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,110,110,46,0,99,117,110,110,46,0,99,117,100,110,110,46,0,102,98,99,117,110,110,46,0,114,101,97,100,84,111,114,99,104,83,116,111,114,97,103,101,0,116,121,112,101,105,100,120,32,61,61,32,84,89,80,69,95,84,79,82,67,72,32,124,124,32,40,116,121,112,101,105,100,120,32,61,61,32,84,89,80,69,95,78,73,76,32,38,38,32,110,100,105,109,115,32,61,61,32,48,41,0,114,101,97,100,84,111,114,99,104,84,101,110,115,111,114,0,116,121,112,101,83,116,111,114,97,103,101,32,62,61,32,48,32,38,38,32,116,121,112,101,84,101,110,115,111,114,32,61,61,32,116,121,112,101,83,116,111,114,97,103,101,0,83,116,111,114,97,103,101,32,104,97,115,32,105,110,115,117,102,102,105,99,105,101,110,116,32,110,117,109,98,101,114,32,111,102,32,101,108,101,109,101,110,116,115,32,102,111,114,32,114,101,113,117,101,115,116,101,100,32,84,101,110,115,111,114,0,68,111,117,98,108,101,0,70,108,111,97,116,0,67,117,100,97,0,66,121,116,101,0,67,104,97,114,0,83,104,111,114,116,0,73,110,116,0,76,111,110,103,0,85,110,107,110,111,119,110,32,116,121,112,101,32,34,0,34,32,111,102,32,116,111,114,99,104,32,99,108,97,115,115,32,34,0,112,97,114,115,101,84,111,114,99,104,84,121,112,101,0,86,32,0,102,105,108,101,32,38,38,32,84,72,70,105,108,101,95,105,115,79,112,101,110,101,100,40,102,105,108,101,41,0,84,111,114,99,104,73,109,112,111,114,116,101,114,0,80,70,118,80,78,50,84,72,56,84,72,70,105,108,101,95,95,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,84,72,56,84,72,70,105,108,101,95,95,69,80,70,118,83,51,95,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,114,111,111,116,77,111,100,117,108,101,32,61,61,32,78,85,76,76,0,116,111,114,99,104,77,101,114,103,101,0,116,111,114,99,104,83,112,108,105,116,0,116,111,114,99,104,82,101,115,104,97,112,101,0,33,110,117,109,85,110,99,111,110,110,101,99,116,101,100,76,97,121,101,114,115,46,101,109,112,116,121,40,41,0,102,105,108,108,0,110,117,109,73,110,112,117,116,115,32,60,61,32,105,100,115,46,115,105,122,101,40,41,0,116,111,114,99,104,67,65,100,100,84,97,98,108,101,0,109,111,100,117,108,101,45,62,112,97,114,97,109,115,46,104,97,115,40,34,105,110,100,105,99,101,115,95,98,108,111,98,95,105,100,34,41,0,116,111,114,99,104,77,97,120,85,110,112,111,111,108,105,110,103,0,112,111,111,108,105,110,103,76,97,121,101,114,46,102,105,114,115,116,32,33,61,32,45,49,0,85,110,101,120,112,101,99,116,101,100,32,116,111,114,99,104,32,99,111,110,116,97,105,110,101,114,58,32,0,95,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,51,84,111,114,99,104,73,109,112,111,114,116,101,114,54,77,111,100,117,108,101,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,100,102,115,101,108,102,45,62,104,97,110,100,108,101,32,33,61,32,48,76,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,111,114,99,104,47,84,72,68,105,115,107,70,105,108,101,46,99,112,112,0,84,72,68,105,115,107,70,105,108,101,95,109,111,100,101,40,109,111,100,101,44,32,38,105,115,82,101,97,100,97,98,108,101,44,32,38,105,115,87,114,105,116,97,98,108,101,41,0,84,72,68,105,115,107,70,105,108,101,95,110,101,119,0,105,115,82,101,97,100,97,98,108,101,32,38,38,32,33,105,115,87,114,105,116,97,98,108,101,0,99,97,110,110,111,116,32,111,112,101,110,32,60,37,115,62,32,105,110,32,109,111,100,101,32,37,99,37,99,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,115,101,108,102,0,84,72,68,105,115,107,70,105,108,101,95,99,108,111,115,101,0,84,72,68,105,115,107,70,105,108,101,95,112,111,115,105,116,105,111,110,0,117,110,97,98,108,101,32,116,111,32,111,98,116,97,105,110,32,100,105,115,107,32,102,105,108,101,32,111,102,102,115,101,116,32,40,109,97,121,98,101,32,97,32,108,111,110,103,32,111,118,101,114,102,108,111,119,32,111,99,99,117,114,114,101,100,41,0,84],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+378884);allocate([72,68,105,115,107,70,105,108,101,95,115,101,101,107,69,110,100,0,117,110,97,98,108,101,32,116,111,32,115,101,101,107,32,97,116,32,101,110,100,32,111,102,32,102,105,108,101,0,84,72,68,105,115,107,70,105,108,101,95,115,101,101,107,0,117,110,97,98,108,101,32,116,111,32,115,101,101,107,32,97,116,32,112,111,115,105,116,105,111,110,32,37,108,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,83,116,114,105,110,103,0,100,102,115,101,108,102,45,62,102,105,108,101,46,105,115,82,101,97,100,97,98,108,101,0,40,115,116,114,108,101,110,40,102,111,114,109,97,116,41,32,62,61,32,50,32,63,32,40,102,111,114,109,97,116,91,48,93,32,61,61,32,39,42,39,41,32,38,38,32,40,102,111,114,109,97,116,91,49,93,32,61,61,32,39,97,39,32,124,124,32,102,111,114,109,97,116,91,49,93,32,61,61,32,39,108,39,41,32,58,32,48,41,0,114,101,97,100,32,101,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,0,114,101,97,100,32,101,114,114,111,114,58,32,114,101,97,100,32,48,32,98,108,111,99,107,115,32,105,110,115,116,101,97,100,32,111,102,32,49,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,68,111,117,98,108,101,0,37,108,103,0,114,101,97,100,32,101,114,114,111,114,58,32,114,101,97,100,32,37,108,100,32,98,108,111,99,107,115,32,105,110,115,116,101,97,100,32,111,102,32,37,108,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,70,108,111,97,116,0,37,103,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,76,111,110,103,0,37,108,100,0,99,97,110,32,110,111,116,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,73,110,116,0,37,100,10,13,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,83,104,111,114,116,0,37,104,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,67,104,97,114,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,66,121,116,101,0,33,116,101,110,115,111,114,95,112,114,111,116,111,46,114,97,119,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,32,124,124,32,33,116,101,110,115,111,114,95,112,114,111,116,111,46,102,108,111,97,116,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,32,124,124,32,33,116,101,110,115,111,114,95,112,114,111,116,111,46,100,111,117,98,108,101,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,32,124,124,32,33,116,101,110,115,111,114,95,112,114,111,116,111,46,105,110,116,54,52,95,100,97,116,97,40,41,46,101,109,112,116,121,40,41,0,103,101,116,77,97,116,70,114,111,109,84,101,110,115,111,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,111,110,110,120,47,111,110,110,120,95,105,109,112,111,114,116,101,114,46,99,112,112,0,33,102,105,101,108,100,46,101,109,112,116,121,40,41,0,73,110,112,117,116,32,105,115,32,111,117,116,32,111,102,32,79,112,101,110,67,86,32,51,50,83,32,114,97,110,103,101,0,99,111,110,118,101,114,116,73,110,116,54,52,84,111,73,110,116,51,50,0,85,110,115,117,112,112,111,114,116,101,100,32,100,97,116,97,32,116,121,112,101,58,32,0,107,101,114,110,101,108,95,115,104,97,112,101,0,97,116,116,114,105,98,117,116,101,95,112,114,111,116,111,46,105,110,116,115,95,115,105,122,101,40,41,32,61,61,32,50,0,103,101,116,76,97,121,101,114,80,97,114,97,109,115,0,115,116,114,105,100,101,115,0,112,97,100,115,0,80,97,100,0,97,116,116,114,105,98,117,116,101,95,112,114,111,116,111,46,105,110,116,115,95,115,105,122,101,40,41,32,37,32,50,32,61,61,32,48,0,97,116,116,114,105,98,117,116,101,95,112,114,111,116,111,46,105,110,116,115,95,115,105,122,101,40,41,32,61,61,32,52,0,97,117,116,111,95,112,97,100,0,83,65,77,69,95,85,80,80,69,82,0,83,65,77,69,95,76,79,87,69,82,0,100,105,108,97,116,105,111,110,115,0,100,105,108,97,116,105,111,110,95,104,0,100,105,108,97,116,105,111,110,95,119,0,85,110,101,120,112,101,99,116,101,100,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,0,85,110,115,117,112,112,111,114,116,101,100,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,0,105,110,100,101,120,32,60,32,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,0,66,108,111,98,32,0,32,110,111,116,32,102,111,117,110,100,32,105,110,32,99,111,110,115,116,32,98,108,111,98,115,0,112,97,100,95,104,0,112,97,100,95,119,0,109,111,100,101,108,95,112,114,111,116,111,46,104,97,115,95,103,114,97,112,104,40,41,0,112,111,112,117,108,97,116,101,78,101,116,0,110,111,100,101,95,112,114,111,116,111,46,111,117,116,112,117,116,95,115,105,122,101,40,41,32,62,61,32,49,0,77,97,120,80,111,111,108,0,77,65,88,0,65,118,101,114,97,103,101,80,111,111,108,0,65,86,69,0,112,121,116,111,114,99,104,0,71,108,111,98,97,108,65,118,101,114,97,103,101,80,111,111,108,0,65,100,100,0,83,117,109,0,83,117,98,0,67,111,110,115,116,97,110,116,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,48,0,108,97,121,101,114,80,97,114,97,109,115,46,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,73,109,97,103,101,83,99,97,108,101,114,0,76,101,97,107,121,82,101,108,117,0,66,97,116,99,104,78,111,114,109,97,108,105,122,97,116,105,111,110,0,69,120,112,101,99,116,101,100,32,105,110,112,117,116,44,32,115,99,97,108,101,44,32,98,105,97,115,44,32,109,101,97,110,32,97,110,100,32,118,97,114,0,101,112,115,105,108,111,110,0,115,112,97,116,105,97,108,0,71,101,109,109,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,62,61,32,50,0,116,114,97,110,115,66,0,77,97,116,77,117,108,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,77,117,108,0,67,111,110,118,0,67,111,110,118,84,114,97,110,115,112,111,115,101,0,84,114,97,110,115,112,111,115,101,0,85,110,115,113,117,101,101,122,101,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,49,0,97,120,101,115,46,103,101,116,73,110,116,86,97,108,117,101,40,97,120,101,115,46,115,105,122,101,40,41,45,49,41,32,60,61,32,100,105,109,115,46,115,105,122,101,40,41,0,115,104,97,112,101,0,110,111,100,101,95,112,114,111,116,111,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,32,124,124,32,108,97,121,101,114,80,97,114,97,109,115,46,104,97,115,40,34,115,104,97,112,101,34,41,0,98,108,111,98,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,67,49,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,111,110,110,120,32,109,111,100,101,108,0,79,78,78,88,73,109,112,111,114,116,101,114,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,114,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,78,101,116,80,97,114,97,109,101,116,101,114,32,102,105,108,101,58,32,0,114,101,97,100,78,101,116,70,114,111,109,68,97,114,107,110,101,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,97,114,107,110,101,116,47,100,97,114,107,110,101,116,95,105,109,112,111,114,116,101,114,46,99,112,112,0,95,37,100,0,67,97,110,39,116,32,102,105,110,100,32,111,117,116,112,117,116,32,98,108,111,98,32,34,0,97,100,100,73,110,112,117,116,0,68,117,112,108,105,99,97,116,101,32,98,108,111,98,115,32,112,114,111,100,117,99,101,100,32,98,121,32,109,117,108,116,105,112,108,101,32,115,111,117,114,99,101,115,0,97,100,100,79,117,116,112,117,116,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,66,117,102,102,101,114,83,116,114,101,97,109,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,110,110,46,99,112,112,0,86,107,67,111,109,32,112,105,112,101,108,105,110,101,32,111,102,32,0,32,108,97,121,101,114,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,0,105,110,105,116,86,107,67,111,109,0,73,110,102,101,114,101,110,99,101,32,69,110,103,105,110,101,32,112,105,112,101,108,105,110,101,32,111,102,32,0,105,110,105,116,73,110,102,69,110,103,105,110,101,0,72,97,108,105,100,101,32,112,105,112,101,108,105,110,101,32,111,102,32,0,105,110,105,116,72,97,108,105,100,101,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,53,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,52,66,97,99,107,101,110,100,87,114,97,112,112,101,114,69,0,79,80,69,78,67,86,95,68,78,78,95,68,73,83,65,66,76,69,95,77,69,77,79,82,89,95,79,80,84,73,77,73,90,65,84,73,79,78,83,0,79,80,69,78,67,86,95,68,78,78,95,66,65,67,75,69,78,68,95,68,69,70,65,85,76,84,0,79,80,69,78,67,86,95,68,78,78,95,67,72,69,67,75,95,78,65,78,95,73,78,70,0,79,80,69,78,67,86,95,68,78,78,95,67,72,69,67,75,95,78,65,78,95,73,78,70,95,68,85,77,80,0,79,80,69,78,67,86,95,68,78,78,95,67,72,69,67,75,95,78,65,78,95,73,78,70,95,82,65,73,83,69,95,69,82,82,79,82,0,109,101,97,110,95,32,61,61,32,83,99,97,108,97,114,40,41,32,38,38,32,34,77,101,97,110,32,115,117,98,116,114,97,99,116,105,111,110,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,102,111,114,32,67,86,95,56,85,32,98,108,111,98,32,100,101,112,116,104,34,0,98,108,111,98,70,114,111,109,73,109,97,103,101,115,0,33,105,109,97,103,101,115,46,101,109,112,116,121,40,41,0,105,109,97,103,101,48,46,100,105,109,115,32,61,61,32,50,0,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,98,108,111,98,95,46,100,101,112,116,104,40,41,0,105,109,97,103,101,46,100,105,109,115,32,61,61,32,50,32,38,38,32,40,110,99,104,32,61,61,32,51,32,124,124,32,110,99,104,32,61,61,32,52,41,0,105,109,97,103,101,46,115,105,122,101,40,41,32,61,61,32,105,109,97,103,101,48,46,115,105,122,101,40,41,0,105,109,97,103,101,46,100,105,109,115,32,61,61,32,50,32,38,38,32,40,110,99,104,32,61,61,32,49,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,98,108,111,98,70,114,111,109,73,109,97,103,101,115,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,98,111,111,108,44,32,98,111,111,108,44,32,105,110,116,41,0,83,99,97,108,105,110,103,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,102,111,114,32,67,86,95,56,85,32,98,108,111,98,32,100,101,112,116,104,0,115,99,97,108,101,102,97,99,116,111,114,0,49,46,48,0,66,108,111,98,32,100,101,112,116,104,32,115,104,111,117,108,100,32,98,101,32,67,86,95,51,50,70,32,111,114,32,67,86,95,56,85,0,100,100,101,112,116,104,0,100,100,101,112,116,104,32,61,61,32,67,86,95,51,50,70,32,124,124,32,100,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,78,101,116,52,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,51,78,101,116,52,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,95,105,110,112,117,116,0,95,95,78,101,116,73,110,112,117,116,76,97,121,101,114,95,95,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,68,97,116,97,76,97,121,101,114,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,68,97,116,97,76,97,121,101,114,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,0,109,101,97,110,32,61,61,32,83,99,97,108,97,114,40,41,32,124,124,32,105,110,112,117,116,115,68,97,116,97,91,105,93,46,115,105,122,101,91,49,93,32,60,61,32,52,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,68,97,116,97,76,97,121,101,114,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,111,117,116,112,117,116,115,91,105,93,46,116,121,112,101,40,41,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,115,99,97,108,101,70,97,99,116,111,114,115,46,115,105,122,101,40,41,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,109,101,97,110,115,46,115,105,122,101,40,41,0,105,110,112,117,116,115,68,97,116,97,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,68,97,116,97,76,97,121,101,114,69,0,66,117,105,108,100,32,79,112,101,110,67,86,32,119,105,116,104,32,73,110,102,101,114,101,110,99,101,32,69,110,103,105,110,101,32,116,111,32,101,110,97,98,108,101,32,108,111,97,100,105,110,103,32,109,111,100,101,108,115,32,102,114,111,109,32,77,111,100,101,108,32,79,112,116,105,109,105,122,101,114,46,0,114,101,97,100,70,114,111,109,77,111,100,101,108,79,112,116,105,109,105,122,101,114,0,76,97,121,101,114,32,34,0,34,32,97,108,114,101,97,100,121,32,105,110,116,111,32,110,101,116,0,97,100,100,76,97,121,101,114,0,111,117,116,76,97,121,101,114,73,100,32,60,32,105,110,76,97,121,101,114,73,100,0,99,111,110,110,101,99,116,0,76,97,121,101,114,32,119,105,116,104,32,114,101,113,117,101,115,116,101,100,32,105,100,61,37,100,32,110,111,116,32,102,111,117,110,100,0,103,101,116,76,97,121,101,114,68,97,116,97,0,73,110,112,117,116,32,35,37,100,32,111,102,32,108,97,121,101,114,32,34,37,115,34,32,97,108,114,101,97,100,121,32,119,97,115,32,99,111,110,110,101,99,116,101,100,0,97,100,100,76,97,121,101,114,73,110,112,117,116,0,67,97,110,39,116,32,99,114,101,97,116,101,32,108,97,121,101,114,32,34,0,34,32,111,102,32,116,121,112,101,32,34,0,103,101,116,76,97,121,101,114,73,110,115,116,97,110,99,101,0,33,105,116,45,62,115,101,99,111,110,100,46,101,109,112,116,121,40,41,0,99,114,101,97,116,101,76,97,121,101,114,73,110,115,116,97,110,99,101,0,82,101,113,117,101,115,116,101,100,32,98,108,111,98,32,110,111,116,32,102,111,117,110,100,0,103,101,116,66,108,111,98,0,76,97,121,101,114,32,34,37,115,34,32,112,114,111,100,117,99,101,32,111,110,108,121,32,37,122,117,32,111,117,116,112,117,116,115,44,32,116,104,101,32,35,37,100,32,119,97,115,32,114,101,113,117,101,115,116,101,100,0,33,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,101,109,112,116,121,40,41,32,38,38,32,33,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,91,112,105,110,46,111,105,100,93,46,101,109,112,116,121,40,41,0,87,65,82,78,73,78,71,58,32,78,97,78,32,100,101,116,101,99,116,101,100,32,105,110,32,108,97,121,101,114,32,111,117,116,112,117,116,58,32,105,100,61,0,32,110,97,109,101,61,0,111,117,116,112,117,116,32,105,100,61,0,32,111,117,116,112,117,116,32,115,104,97,112,101,61,0,87,65,82,78,73,78,71,58,32,73,110,102,32,100,101,116,101,99,116,101,100,32,105,110,32,108,97,121,101,114,32,111,117,116,112,117,116,58,32,105,100,61,0,73,78,80,85,84,32,0,79,85,84,80,85,84,32,0,73,78,84,69,82,78,65,76,32,0,33,102,97,105,108,0,102,111,114,119,97,114,100,76,97,121,101,114,0,32,105,115,32,78,85,76,76,0,85,110,107,110,111,119,110,32,98,97,99,107,101,110,100,32,105,100,101,110,116,105,102,105,101,114,0,119,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,117,109,97,116,115,46,115,105,122,101,40,41,0,117,112,100,97,116,101,0,33,117,109,97,116,87,114,97,112,112,101,114,46,101,109,112,116,121,40,41,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,79,112,101,110,67,76,66,97,99,107,101,110,100,87,114,97,112,112,101,114,69,0,32,93,0,103,101,116,85,77,97,116,86,101,99,116,111,114,0,82,101,113,117,101,115,116,101,100,32,108,97,121,101,114,32,34,0,34,32,110,111,116,32,102,111,117,110,100,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,79,80,69,78,67,86,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,95,70,80,49,54,0,115,101,116,85,112,78,101,116,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,73,78,70,69,82,69,78,67,69,95,69,78,71,73,78,69,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,95,70,80,49,54,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,77,89,82,73,65,68,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,86,75,67,79,77,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,86,85,76,75,65,78,0,68,78,78,58,32,79,112,101,110,67,76,32,116,97,114,103,101,116,32,105,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,105,110,32,116,104,105,115,32,79,112,101,110,67,86,32,98,117,105,108,100,44,32,115,119,105,116,99,104,105,110,103,32,116,111,32,67,80,85,46,0,105,116,32,33,61,32,108,97,121,101,114,115,46,101,110,100,40,41,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,0,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,73,83,95,68,78,78,95,79,80,69,78,67,76,95,84,65,82,71,69,84,40,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,41,0,105,110,105,116,66,97,99,107,101,110,100,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,61,61,32,68,78,78,95,66,65,67,75,69,78,68,95,73,78,70,69,82,69,78,67,69,95,69,78,71,73,78,69,0,105,110,105,116,73,110,102,69,110,103,105,110,101,66,97,99,107,101,110,100,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,61,61,32,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,0,105,110,105,116,72,97,108,105,100,101,66,97,99,107,101,110,100,0,104,97,118,101,72,97,108,105,100,101,40,41,0,33,108,100,66,111,116,46,98,97,99,107,101,110,100,78,111,100,101,115,91,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,93,46,101,109,112,116,121,40,41,0,33,108,97,121,101,114,115,91,48,93,46,111,117,116,112,117,116,66,108,111,98,115,46,101,109,112,116,121,40,41,0,97,108,108,111,99,97,116,101,76,97,121,101,114,115,0,105,110,112,46,116,111,116,97,108,40,41,0,84,97,110,72,0,98,105,97,115,76,97,121,101,114,68,97,116,97,0,102,117,115,101,76,97,121,101,114,115,0,98,105,97,115,76,97,121,101,114,68,97,116,97,45,62,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,100,46,105,110,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,100,46,111,117,116,112,117,116,66,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,111,117,116,112,117,116,95,115,108,105,99,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,111,117,116,112,117,116,95,115,108,105,99,101,46,115,105,122,101,32,61,61,32,99,117,114,114,95,111,117,116,112,117,116,46,115,105,122,101,0,99,117,114,114,95,111,117,116,112,117,116,46,100,97,116,97,32,61,61,32,111,117,116,112,117,116,95,115,108,105,99,101,46,100,97,116,97,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,49,67,111,110,99,97,116,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,80,111,111,108,105,110,103,76,97,121,101,114,69,0,73,83,95,68,78,78,95,79,80,69,78,67,76,95,84,65,82,71,69,84,40,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,41,0,119,114,97,112,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,79,112,101,110,67,76,66,97,99,107,101,110,100,87,114,97,112,112,101,114,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,79,112,101,110,67,76,66,97,99,107,101,110,100,87,114,97,112,112,101,114,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,52,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,0,85,110,107,110,111,119,110,32,116,97,114,103,101,116,32,105,100,101,110,116,105,102,105,101,114,0,119,114,97,112,77,97,116,0,104,97,118,101,86,117,108,107,97,110,40,41,0,33,98,97,115,101,46,101,109,112,116,121,40,41,0,79,112,101,110,67,76,66,97,99,107,101,110,100,87,114,97,112,112,101,114,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,69,108,116,119,105,115,101,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,53,65,99,116,105,118,97,116,105,111,110,76,97,121,101,114,69,0,102,114,111,109,46,118,97,108,105,100,40,41,0,97,108,108,111,99,97,116,101,76,97,121,101,114,0,108,97,121,101,114,83,104,97,112,101,115,73,116,32,33,61,32,108,97,121,101,114,115,83,104,97,112,101,115,46,101,110,100,40,41,0,108,100,46,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,46,115,105,122,101,40,41,32,60,61,32,111,117,116,83,104,97,112,101,115,46,115,105,122,101,40,41,0,97,108,108,111,99,97,116,101,66,108,111,98,115,70,111,114,76,97,121,101,114,0,108,100,46,105,110,112,117,116,66,108,111,98,115,91,48,93,45,62,116,111,116,97,108,40,41,32,61,61,32,116,111,116,97,108,40,115,104,97,112,101,115,91,105,110,100,101,120,93,41,0,109,97,112,73,116,32,33,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,114,101,108,101,97,115,101,82,101,102,101,114,101,110,99,101,0,114,101,102,73,116,32,33,61,32,114,101,102,67,111,117,110,116,101,114,46,101,110,100,40,41,0,114,101,102,73,116,45,62,115,101,99,111,110,100,32,62,32,48,0,109,101,109,72,111,115,116,115,46,102,105,110,100,40,108,112,41,32,61,61,32,109,101,109,72,111,115,116,115,46,101,110,100,40,41,0,97,100,100,72,111,115,116,0,114,101,117,115,101,77,97,112,46,102,105,110,100,40,117,115,101,114,41,32,61,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,114,101,117,115,101,0,114,101,117,115,101,77,97,112,46,102,105,110,100,40,104,111,115,116,41,32,33,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,110,117,109,82,101,102,101,114,101,110,99,101,115,0,33,108,100,46,111,117,116,112,117,116,66,108,111,98,115,87,114,97,112,112,101,114,115,91,105,93,46,101,109,112,116,121,40,41,0,82,101,113,117,101,115,116,101,100,32,98,108,111,98,32,34,0,115,101,116,73,110,112,117,116,0,34,32,97,108,114,101,97,100,121,32,119,97,115,32,114,101,103,105,115,116,101,114,101,100,0,114,101,103,105,115,116,101,114,76,97,121,101,114,0,99,97,102,102,101,0,99,97,102,102,101,109,111,100,101,108,0,112,114,111,116,111,116,120,116,0,116,101,110,115,111,114,102,108,111,119,0,112,98,0,112,98,116,120,116,0,116,111,114,99,104,0,116,55,0,110,101,116,0,100,97,114,107,110,101,116,0,119,101,105,103,104,116,115,0,99,102,103,0,100,108,100,116,0,98,105,110,0,120,109,108,0,111,110,110,120,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,97,110,32,111,114,105,103,105,110,32,102,114,97,109,101,119,111,114,107,32,111,102,32,102,105,108,101,115,58,32,0,114,101,97,100,78,101,116,0,82,101,97,100,105,110,103,32,84,111,114,99,104,32,109,111,100,101,108,115,32,102,114,111,109,32,98,117,102,102,101,114,115,0,82,101,97,100,105,110,103,32,73,110,116,101,108,39,115,32,77,111,100,101,108,32,79,112,116,105,109,105,122,101,114,32,109,111,100,101,108,115,32,102,114,111,109,32,98,117,102,102,101,114,115,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,97,110,32,111,114,105,103,105,110,32,102,114,97,109,101,119,111,114,107,32,119,105,116,104,32,97,32,110,97,109,101,32,0,83,108,105,99,101,0,83,112,108,105,116,0,82,101,115,104,97,112,101,0,70,108,97,116,116,101,110,0,73,110,116,101,114,112,0,67,114,111,112,65,110,100,82,101,115,105,122,101,0,68,101,99,111,110,118,111,108,117,116,105,111,110,0,82,79,73,80,111,111,108,105,110,103,0,80,83,82,79,73,80,111,111,108,105,110,103,0,76,82,78,0,73,110,110,101,114,80,114,111,100,117,99,116,0,77,86,78,0,82,101,76,85,54,0,67,104,97,110,110,101,108,115,80,82,101,76,85,0,80,82,101,76,85,0,83,105,103,109,111,105,100,0,69,76,85,0,65,98,115,86,97,108,0,77,97,120,85,110,112,111,111,108,0,68,114,111,112,111,117,116,0,83,105,108,101,110,99,101,0,83,104,117,102,102,108,101,67,104,97,110,110,101,108,0,80,114,105,111,114,66,111,120,67,108,117,115,116,101,114,101,100,0,78,111,114,109,97,108,105,122,101,66,66,111,120,0,78,111,114,109,97,108,105,122,101,0,83,104,105,102,116,0,80,97,100,100,105,110,103,0,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,0,10,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,12,116,101,110,115,111,114,46,112,114,111,116,111,26,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,182,4,10,9,65,116,116,114,86,97,108,117,101,18,11,10,1,115,24,2,32,1,40,12,72,0,18,11,10,1,105,24,3,32,1,40,3,72,0,18,11,10,1,102,24,4,32,1,40,2,72,0,18,11,10,1,98,24,5,32,1,40,8,72,0,18,43,10,4,116,121,112,101,24,6,32,1,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,72,0,18,52,10,5,115,104,97,112,101,24,7,32,1,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,72,0,18,48,10,6,116,101,110,115,111,114,24,8,32,1,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,80,114,111,116,111,72,0,18,54,10,4,108,105,115,116,24,1,32,1,40,11,50,38,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,46,76,105,115,116,86,97,108,117,101,72,0,18,47,10,4,102,117,110,99,24,10,32,1,40,11,50,31,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,72,0,18,21,10,11,112,108,97,99,101,104,111,108,100,101,114,24,9,32,1,40,9,72,0,26,214,1,10,9,76,105,115,116,86,97,108,117,101,18,9,10,1,115,24,2,32,3,40,12,18,13,10,1,105,24,3,32,3,40,3,66,2,16,1,18,13,10,1,102,24,4,32,3,40,2,66,2,16,1,18,13,10,1,98,24,5,32,3,40,8,66,2,16,1,18,45,10,4,116,121,112,101,24,6,32,3,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,66,2,16,1,18,50,10,5,115,104,97,112,101,24,7,32,3,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,46,10,6,116,101,110,115,111,114,24,8,32,3,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,80,114,111,116,111,66,7,10,5,118,97,108,117,101,34,160,1,10,12,78,97,109,101,65,116,116,114,76,105,115,116,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,55,10,4,97,116,116,114,24,2,32,3,40,11,50,41,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,65,116,116,114,69,110,116,114,121,26,73,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,43,10,5,118,97,108,117,101,24,2,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,66,48,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,15,65,116,116,114,86,97,108,117,101,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,97,116,116,114,95,118,97,108,117,101,46,112,98,46,99,99,0,77,97,112,75,101,121,58,58,116,121,112,101,32,77,97,112,75,101,121,32,105,115,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,100,46,32,0,67,97,108,108,32,115,101,116,32,109,101,116,104,111,100,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,32,77,97,112,75,101,121,46,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,50,78,97,109,101,65,116,116,114,76,105,115,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,57,73,110,116,101,114,110,97,108,77,101,116,97,100,97,116,97,87,105,116,104,65,114,101,110,97,66,97,115,101,73,78,83,48,95,49,53,85,110,107,110,111,119,110,70,105,101,108,100,83,101,116,69,78,83,49,95,50,53,73,110,116,101,114,110,97,108,77,101,116,97,100,97,116,97,87,105,116,104,65,114,101,110,97,69,69,57,67,111,110,116,97,105,110,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,69,110,116,114,121,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,48,95,55,77,101,115,115,97,103,101,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,66,97,115,101,69,0,77,97,112,75,101,121,58,58,71,101,116,83,116,114,105,110,103,86,97,108,117,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,70,105,101,108,100,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,84,121,112,101,68,101,102,105,110,101,100,77,97,112,70,105,101,108,100,66,97,115,101,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,46,112,108,97,99,101,104,111,108,100,101,114,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,49,78,97,109,101,65,116,116,114,76,105,115,116,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,49,53,77,97,112,69,110,116,114,121,87,114,97,112,112,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+389124);allocate([115,111,114,102,108,111,119,49,57,65,116,116,114,86,97,108,117,101,95,76,105,115,116,86,97,108,117,101,69,0,10,11,116,121,112,101,115,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,42,156,5,10,8,68,97,116,97,84,121,112,101,18,14,10,10,68,84,95,73,78,86,65,76,73,68,16,0,18,12,10,8,68,84,95,70,76,79,65,84,16,1,18,13,10,9,68,84,95,68,79,85,66,76,69,16,2,18,12,10,8,68,84,95,73,78,84,51,50,16,3,18,12,10,8,68,84,95,85,73,78,84,56,16,4,18,12,10,8,68,84,95,73,78,84,49,54,16,5,18,11,10,7,68,84,95,73,78,84,56,16,6,18,13,10,9,68,84,95,83,84,82,73,78,71,16,7,18,16,10,12,68,84,95,67,79,77,80,76,69,88,54,52,16,8,18,12,10,8,68,84,95,73,78,84,54,52,16,9,18,11,10,7,68,84,95,66,79,79,76,16,10,18,12,10,8,68,84,95,81,73,78,84,56,16,11,18,13,10,9,68,84,95,81,85,73,78,84,56,16,12,18,13,10,9,68,84,95,81,73,78,84,51,50,16,13,18,15,10,11,68,84,95,66,70,76,79,65,84,49,54,16,14,18,13,10,9,68,84,95,81,73,78,84,49,54,16,15,18,14,10,10,68,84,95,81,85,73,78,84,49,54,16,16,18,13,10,9,68,84,95,85,73,78,84,49,54,16,17,18,17,10,13,68,84,95,67,79,77,80,76,69,88,49,50,56,16,18,18,11,10,7,68,84,95,72,65,76,70,16,19,18,16,10,12,68,84,95,70,76,79,65,84,95,82,69,70,16,101,18,17,10,13,68,84,95,68,79,85,66,76,69,95,82,69,70,16,102,18,16,10,12,68,84,95,73,78,84,51,50,95,82,69,70,16,103,18,16,10,12,68,84,95,85,73,78,84,56,95,82,69,70,16,104,18,16,10,12,68,84,95,73,78,84,49,54,95,82,69,70,16,105,18,15,10,11,68,84,95,73,78,84,56,95,82,69,70,16,106,18,17,10,13,68,84,95,83,84,82,73,78,71,95,82,69,70,16,107,18,20,10,16,68,84,95,67,79,77,80,76,69,88,54,52,95,82,69,70,16,108,18,16,10,12,68,84,95,73,78,84,54,52,95,82,69,70,16,109,18,15,10,11,68,84,95,66,79,79,76,95,82,69,70,16,110,18,16,10,12,68,84,95,81,73,78,84,56,95,82,69,70,16,111,18,17,10,13,68,84,95,81,85,73,78,84,56,95,82,69,70,16,112,18,17,10,13,68,84,95,81,73,78,84,51,50,95,82,69,70,16,113,18,19,10,15,68,84,95,66,70,76,79,65,84,49,54,95,82,69,70,16,114,18,17,10,13,68,84,95,81,73,78,84,49,54,95,82,69,70,16,115,18,18,10,14,68,84,95,81,85,73,78,84,49,54,95,82,69,70,16,116,18,17,10,13,68,84,95,85,73,78,84,49,54,95,82,69,70,16,117,18,21,10,17,68,84,95,67,79,77,80,76,69,88,49,50,56,95,82,69,70,16,118,18,15,10,11,68,84,95,72,65,76,70,95,82,69,70,16,119,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,84,121,112,101,115,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,116,121,112,101,115,46,112,114,111,116,111,0,116,101,110,115,111,114,46,112,114,111,116,111,0,10,12,116,101,110,115,111,114,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,243,2,10,11,84,101,110,115,111,114,80,114,111,116,111,18,42,10,5,100,116,121,112,101,24,1,32,1,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,18,57,10,12,116,101,110,115,111,114,95,115,104,97,112,101,24,2,32,1,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,22,10,14,118,101,114,115,105,111,110,95,110,117,109,98,101,114,24,3,32,1,40,5,18,22,10,14,116,101,110,115,111,114,95,99,111,110,116,101,110,116,24,4,32,1,40,12,18,20,10,8,104,97,108,102,95,118,97,108,24,13,32,3,40,5,66,2,16,1,18,21,10,9,102,108,111,97,116,95,118,97,108,24,5,32,3,40,2,66,2,16,1,18,22,10,10,100,111,117,98,108,101,95,118,97,108,24,6,32,3,40,1,66,2,16,1,18,19,10,7,105,110,116,95,118,97,108,24,7,32,3,40,5,66,2,16,1,18,18,10,10,115,116,114,105,110,103,95,118,97,108,24,8,32,3,40,12,18,24,10,12,115,99,111,109,112,108,101,120,95,118,97,108,24,9,32,3,40,2,66,2,16,1,18,21,10,9,105,110,116,54,52,95,118,97,108,24,10,32,3,40,3,66,2,16,1,18,20,10,8,98,111,111,108,95,118,97,108,24,11,32,3,40,8,66,2,16,1,18,24,10,12,100,99,111,109,112,108,101,120,95,118,97,108,24,12,32,3,40,1,66,2,16,1,66,45,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,12,84,101,110,115,111,114,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,116,101,110,115,111,114,46,112,98,46,99,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,49,84,101,110,115,111,114,80,114,111,116,111,69,0,103,114,97,112,104,46,112,114,111,116,111,0,10,11,103,114,97,112,104,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,14,102,117,110,99,116,105,111,110,46,112,114,111,116,111,26,14,118,101,114,115,105,111,110,115,46,112,114,111,116,111,34,178,1,10,8,71,114,97,112,104,68,101,102,18,40,10,4,110,111,100,101,24,1,32,3,40,11,50,26,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,18,47,10,8,118,101,114,115,105,111,110,115,24,4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,86,101,114,115,105,111,110,68,101,102,18,19,10,7,118,101,114,115,105,111,110,24,3,32,1,40,5,66,2,24,1,18,54,10,7,108,105,98,114,97,114,121,24,2,32,1,40,11,50,37,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,34,193,1,10,7,78,111,100,101,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,10,10,2,111,112,24,2,32,1,40,9,18,13,10,5,105,110,112,117,116,24,3,32,3,40,9,18,14,10,6,100,101,118,105,99,101,24,4,32,1,40,9,18,50,10,4,97,116,116,114,24,5,32,3,40,11,50,36,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,65,116,116,114,69,110,116,114,121,26,73,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,43,10,5,118,97,108,117,101,24,2,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,71,114,97,112,104,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,103,114,97,112,104,46,112,98,46,99,99,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,69,110,116,114,121,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,70,105,101,108,100,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,111,112,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,105,110,112,117,116,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,100,101,118,105,99,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,54,78,111,100,101,68,101,102,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,49,53,77,97,112,69,110,116,114,121,87,114,97,112,112,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,55,78,111,100,101,68,101,102,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,56,71,114,97,112,104,68,101,102,69,0,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,0,10,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,34,129,1,10,16,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,52,10,3,100,105,109,24,2,32,3,40,11,50,39,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,18,20,10,12,117,110,107,110,111,119,110,95,114,97,110,107,24,3,32,1,40,8,26,33,10,3,68,105,109,18,12,10,4,115,105,122,101,24,1,32,1,40,3,18,12,10,4,110,97,109,101,24,2,32,1,40,9,66,50,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,17,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,116,101,110,115,111,114,95,115,104,97,112,101,46,112,98,46,99,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,54,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,46,110,97,109,101,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,50,48,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,95,68,105,109,69,0,111,112,101,110,99,118,45,99,97,102,102,101,46,112,114,111,116,111,0,10,18,111,112,101,110,99,118,45,99,97,102,102,101,46,112,114,111,116,111,18,12,111,112,101,110,99,118,95,99,97,102,102,101,34,28,10,9,66,108,111,98,83,104,97,112,101,18,15,10,3,100,105,109,24,1,32,3,40,3,66,2,16,1,34,148,2,10,9,66,108,111,98,80,114,111,116,111,18,38,10,5,115,104,97,112,101,24,7,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,16,10,4,100,97,116,97,24,5,32,3,40,2,66,2,16,1,18,16,10,4,100,105,102,102,24,6,32,3,40,2,66,2,16,1,18,23,10,11,100,111,117,98,108,101,95,100,97,116,97,24,8,32,3,40,1,66,2,16,1,18,23,10,11,100,111,117,98,108,101,95,100,105,102,102,24,9,32,3,40,1,66,2,16,1,18,41,10,13,114,97,119,95,100,97,116,97,95,116,121,112,101,24,10,32,1,40,14,50,18,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,121,112,101,18,20,10,8,114,97,119,95,100,97,116,97,24,12,32,1,40,12,66,2,16,0,18,14,10,3,110,117,109,24,1,32,1,40,5,58,1,48,18,19,10,8,99,104,97,110,110,101,108,115,24,2,32,1,40,5,58,1,48,18,17,10,6,104,101,105,103,104,116,24,3,32,1,40,5,58,1,48,18,16,10,5,119,105,100,116,104,24,4,32,1,40,5,58,1,48,34,57,10,15,66,108,111,98,80,114,111,116,111,86,101,99,116,111,114,18,38,10,5,98,108,111,98,115,24,1,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,34,33,10,16,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,18,13,10,5,111,114,100,101,114,24,1,32,3,40,13,34,157,1,10,22,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,18,28,10,14,97,99,114,111,115,115,95,115,112,97,116,105,97,108,24,1,32,1,40,8,58,4,116,114,117,101,18,51,10,12,115,99,97,108,101,95,102,105,108,108,101,114,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,28,10,14,99,104,97,110,110,101,108,95,115,104,97,114,101,100,24,3,32,1,40,8,58,4,116,114,117,101,18,18,10,3,101,112,115,24,4,32,1,40,2,58,5,49,101,45,49,48,34,230,2,10,17,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,18,16,10,8,109,105,110,95,115,105,122,101,24,1,32,1,40,2,18,16,10,8,109,97,120,95,115,105,122,101,24,2,32,1,40,2,18,20,10,12,97,115,112,101,99,116,95,114,97,116,105,111,24,3,32,3,40,2,18,18,10,4,102,108,105,112,24,4,32,1,40,8,58,4,116,114,117,101,18,18,10,4,99,108,105,112,24,5,32,1,40,8,58,4,116,114,117,101,18,16,10,8,118,97,114,105,97,110,99,101,24,6,32,3,40,2,18,16,10,8,105,109,103,95,115,105,122,101,24,7,32,1,40,13,18,13,10,5,105,109,103,95,104,24,8,32,1,40,13,18,13,10,5,105,109,103,95,119,24,9,32,1,40,13,18,12,10,4,115,116,101,112,24,10,32,1,40,2,18,14,10,6,115,116,101,112,95,104,24,11,32,1,40,2,18,14,10,6,115,116,101,112,95,119,24,12,32,1,40,2,18,19,10,6,111,102,102,115,101,116,24,13,32,1,40,2,58,3,48,46,53,18,16,10,8,111,102,102,115,101,116,95,104,24,14,32,3,40,2,18,16,10,8,111,102,102,115,101,116,95,119,24,15,32,3,40,2,18,13,10,5,119,105,100,116,104,24,16,32,3,40,2,18,14,10,6,104,101,105,103,104,116,24,17,32,3,40,2,34,39,10,8,67,111,100,101,84,121,112,101,18,10,10,6,67,79,82,78,69,82,16,1,18,15,10,11,67,69,78,84,69,82,95,83,73,90,69,16,2,34,177,3,10,24,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,19,10,11,110,117,109,95,99,108,97,115,115,101,115,24,1,32,1,40,13,18,28,10,14,115,104,97,114,101,95,108,111,99,97,116,105,111,110,24,2,32,1,40,8,58,4,116,114,117,101,18,30,10,19,98,97,99,107,103,114,111,117,110,100,95,108,97,98,101,108,95,105,100,24,3,32,1,40,5,58,1,48,18,63,10,9,110,109,115,95,112,97,114,97,109,24,4,32,1,40,11,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,18,60,10,17,115,97,118,101,95,111,117,116,112,117,116,95,112,97,114,97,109,24,5,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,67,10,9,99,111,100,101,95,116,121,112,101,24,6,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,46,67,111,100,101,84,121,112,101,58,6,67,79,82,78,69,82,18,41,10,26,118,97,114,105,97,110,99,101,95,101,110,99,111,100,101,100,95,105,110,95,116,97,114,103,101,116,24,8,32,1,40,8,58,5,102,97,108,115,101,18,22,10,10,107,101,101,112,95,116,111,112,95,107,24,7,32,1,40,5,58,2,45,49,18,28,10,20,99,111,110,102,105,100,101,110,99,101,95,116,104,114,101,115,104,111,108,100,24,9,32,1,40,2,18,29,10,15,110,111,114,109,97,108,105,122,101,100,95,98,98,111,120,24,10,32,1,40,8,58,4,116,114,117,101,34,129,1,10,5,68,97,116,117,109,18,16,10,8,99,104,97,110,110,101,108,115,24,1,32,1,40,5,18,14,10,6,104,101,105,103,104,116,24,2,32,1,40,5,18,13,10,5,119,105,100,116,104,24,3,32,1,40,5,18,12,10,4,100,97,116,97,24,4,32,1,40,12,18,13,10,5,108,97,98,101,108,24,5,32,1,40,5,18,18,10,10,102,108,111,97,116,95,100,97,116,97,24,6,32,3,40,2,18,22,10,7,101,110,99,111,100,101,100,24,7,32,1,40,8,58,5,102,97,108,115,101,34,145,2,10,15,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,22,10,4,116,121,112,101,24,1,32,1,40,9,58,8,99,111,110,115,116,97,110,116,18,16,10,5,118,97,108,117,101,24,2,32,1,40,2,58,1,48,18,14,10,3,109,105,110,24,3,32,1,40,2,58,1,48,18,14,10,3,109,97,120,24,4,32,1,40,2,58,1,49,18,15,10,4,109,101,97,110,24,5,32,1,40,2,58,1,48,18,14,10,3,115,116,100,24,6,32,1,40,2,58,1,49,18,18,10,6,115,112,97,114,115,101,24,7,32,1,40,5,58,2,45,49,18,73,10,13,118,97,114,105,97,110,99,101,95,110,111,114,109,24,8,32,1,40,14,50,42,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,46,86,97,114,105,97,110,99,101,78,111,114,109,58,6,70,65,78,95,73,78,34,52,10,12,86,97,114,105,97,110,99,101,78,111,114,109,18,10,10,6,70,65,78,95,73,78,16,0,18,11,10,7,70,65,78,95,79,85,84,16,1,18,11,10,7,65,86,69,82,65,71,69,16,2,34,170,2,10,12,78,101,116,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,13,10,5,105,110,112,117,116,24,3,32,3,40,9,18,44,10,11,105,110,112,117,116,95,115,104,97,112,101,24,8,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,17,10,9,105,110,112,117,116,95,100,105,109,24,4,32,3,40,5,18,29,10,14,102,111,114,99,101,95,98,97,99,107,119,97,114,100,24,5,32,1,40,8,58,5,102,97,108,115,101,18,37,10,5,115,116,97,116,101,24,6,32,1,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,7,32,1,40,8,58,5,102,97,108,115,101,18,43,10,5,108,97,121,101,114,24,100,32,3,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,46,10,6,108,97,121,101,114,115,24,2,32,3,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,34,218,10,10,15,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,18,11,10,3,110,101,116,24,24,32,1,40,9,18,45,10,9,110,101,116,95,112,97,114,97,109,24,25,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,17,10,9,116,114,97,105,110,95,110,101,116,24,1,32,1,40,9,18,16,10,8,116,101,115,116,95,110,101,116,24,2,32,3,40,9,18,51,10,15,116,114,97,105,110,95,110,101,116,95,112,97,114,97,109,24,21,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,50,10,14,116,101,115,116,95,110,101,116,95,112,97,114,97,109,24,22,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,43,10,11,116,114,97,105,110,95,115,116,97,116,101,24,26,32,1,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,42,10,10,116,101,115,116,95,115,116,97,116,101,24,27,32,3,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,17,10,9,116,101,115,116,95,105,116,101,114,24,3,32,3,40,5,18,24,10,13,116,101,115,116,95,105,110,116,101,114,118,97,108,24,4,32,1,40,5,58,1,48,18,32,10,17,116,101,115,116,95,99,111,109,112,117,116,101,95,108,111,115,115,24,19,32,1,40,8,58,5,102,97,108,115,101,18,33,10,19,116,101,115,116,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,24,32,32,1,40,8,58,4,116,114,117,101,18,15,10,7,98,97,115,101,95,108,114,24,5,32,1,40,2,18,15,10,7,100,105,115,112,108,97,121,24,6,32,1,40,5,18,23,10,12,97,118,101,114,97,103,101,95,108,111,115,115,24,33,32,1,40,5,58,1,49,18,16,10,8,109,97,120,95,105,116,101,114,24,7,32,1,40,5,18,20,10,9,105,116,101,114,95,115,105,122,101,24,36,32,1,40,5,58,1,49,18,17,10,9,108,114,95,112,111,108,105,99,121,24,8,32,1,40,9,18,13,10,5,103,97,109,109,97,24,9,32,1,40,2,18,13,10,5,112,111,119,101,114,24,10,32,1,40,2,18,16,10,8,109,111,109,101,110,116,117,109,24,11,32,1,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,12,32,1,40,2,18,31,10,19,114,101,103,117,108,97,114,105,122,97,116,105,111,110,95,116,121,112,101,24,29,32,1,40,9,58,2,76,50,18,16,10,8,115,116,101,112,115,105,122,101,24,13,32,1,40,5,18,17,10,9,115,116,101,112,118,97,108,117,101,24,34,32,3,40,5,18,26,10,14,99,108,105,112,95,103,114,97,100,105,101,110,116,115,24,35,32,1,40,2,58,2,45,49,18,19,10,8,115,110,97,112,115,104,111,116,24,14,32,1,40,5,58,1,48,18,23,10,15,115,110,97,112,115,104,111,116,95,112,114,101,102,105,120,24,15,32,1,40,9,18,28,10,13,115,110,97,112,115,104,111,116,95,100,105,102,102,24,16,32,1,40,8,58,5,102,97,108,115,101,18,82,10,15,115,110,97,112,115,104,111,116,95,102,111,114,109,97,116,24,37,32,1,40,14,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,110,97,112,115,104,111,116,70,111,114,109,97,116,58,11,66,73,78,65,82,89,80,82,79,84,79,18,66,10,11,115,111,108,118,101,114,95,109,111,100,101,24,17,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,111,108,118,101,114,77,111,100,101,58,3,71,80,85,18,20,10,9,100,101,118,105,99,101,95,105,100,24,18,32,1,40,5,58,1,48,18,23,10,11,114,97,110,100,111,109,95,115,101,101,100,24,20,32,1,40,3,58,2,45,49,18,17,10,4,116,121,112,101,24,40,32,1,40,9,58,3,83,71,68,18,20,10,5,100,101,108,116,97,24,31,32,1,40,2,58,5,49,101,45,48,56,18,24,10,9,109,111,109,101,110,116,117,109,50,24,39,32,1,40,2,58,5,48,46,57,57,57,18,23,10,9,114,109,115,95,100,101,99,97,121,24,38,32,1,40,2,58,4,48,46,57,57,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,23,32,1,40,8,58,5,102,97,108,115,101,18,34,10,20,115,110,97,112,115,104,111,116,95,97,102,116,101,114,95,116,114,97,105,110,24,28,32,1,40,8,58,4,116,114,117,101,18,66,10,11,115,111,108,118,101,114,95,116,121,112,101,24,30,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,111,108,118,101,114,84,121,112,101,58,3,83,71,68,34,43,10,14,83,110,97,112,115,104,111,116,70,111,114,109,97,116,18,8,10,4,72,68,70,53,16,0,18,15,10,11,66,73,78,65,82,89,80,82,79,84,79,16,1,34,30,10,10,83,111,108,118,101,114,77,111,100,101,18,7,10,3,67,80,85,16,0,18,7,10,3,71,80,85,16,1,34,85,10,10,83,111,108,118,101,114,84,121,112,101,18,7,10,3,83,71,68,16,0,18,12,10,8,78,69,83,84,69,82,79,86,16,1,18,11,10,7,65,68,65,71,82,65,68,16,2,18,11,10,7,82,77,83,80,82,79,80,16,3,18,12,10,8,65,68,65,68,69,76,84,65,16,4,18,8,10,4,65,68,65,77,16,5,34,115,10,11,83,111,108,118,101,114,83,116,97,116,101,18,12,10,4,105,116,101,114,24,1,32,1,40,5,18,19,10,11,108,101,97,114,110,101,100,95,110,101,116,24,2,32,1,40,9,18,40,10,7,104,105,115,116,111,114,121,24,3,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,23,10,12,99,117,114,114,101,110,116,95,115,116,101,112,24,4,32,1,40,5,58,1,48,34,85,10,8,78,101,116,83,116,97,116,101,18,40,10,5,112,104,97,115,101,24,1,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,58,4,84,69,83,84,18,16,10,5,108,101,118,101,108,24,2,32,1,40,5,58,1,48,18,13,10,5,115,116,97,103,101,24,3,32,3,40,9,34,122,10,12,78,101,116,83,116,97,116,101,82,117,108,101,18,34,10,5,112,104,97,115,101,24,1,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,18,17,10,9,109,105,110,95,108,101,118,101,108,24,2,32,1,40,5,18,17,10,9,109,97,120,95,108,101,118,101,108,24,3,32,1,40,5,18,13,10,5,115,116,97,103,101,24,4,32,3,40,9,18,17,10,9,110,111,116,95,115,116,97,103,101,24,5,32,3,40,9,34,170,1,10,9,80,97,114,97,109,83,112,101,99,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,56,10,10,115,104,97,114,101,95,109,111,100,101,24,2,32,1,40,14,50,36,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,83,112,101,99,46,68,105,109,67,104,101,99,107,77,111,100,101,18,18,10,7,108,114,95,109,117,108,116,24,3,32,1,40,2,58,1,49,18,21,10,10,100,101,99,97,121,95,109,117,108,116,24,4,32,1,40,2,58,1,49,34,42,10,12,68,105,109,67,104,101,99,107,77,111,100,101,18,10,10,6,83,84,82,73,67,84,16,0,18,14,10,10,80,69,82,77,73,83,83,73,86,69,16,1,34,163,26,10,14,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,14,10,6,98,111,116,116,111,109,24,3,32,3,40,9,18,11,10,3,116,111,112,24,4,32,3,40,9,18,34,10,5,112,104,97,115,101,24,10,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,18,19,10,11,108,111,115,115,95,119,101,105,103,104,116,24,5,32,3,40,2,18,38,10,5,112,97,114,97,109,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,83,112,101,99,18,38,10,5,98,108,111,98,115,24,7,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,22,10,14,112,114,111,112,97,103,97,116,101,95,100,111,119,110,24,11,32,3,40,8,18,43,10,7,105,110,99,108,117,100,101,24,8,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,43,10,7,101,120,99,108,117,100,101,24,9,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,62,10,15,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,24,100,32,1,40,11,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,108,111,115,115,95,112,97,114,97,109,24,101,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,18,55,10,14,97,99,99,117,114,97,99,121,95,112,97,114,97,109,24,102,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,51,10,12,97,114,103,109,97,120,95,112,97,114,97,109,24,103,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,59,10,16,98,97,116,99,104,95,110,111,114,109,95,112,97,114,97,109,24,139,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,18,48,10,10,98,105,97,115,95,112,97,114,97,109,24,141,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,105,97,115,80,97,114,97,109,101,116,101,114,18,51,10,12,99,111,110,99,97,116,95,112,97,114,97,109,24,104,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,70,10,22,99,111,110,116,114,97,115,116,105,118,101,95,108,111,115,115,95,112,97,114,97,109,24,105,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,61,10,17,99,111,110,118,111,108,117,116,105,111,110,95,112,97,114,97,109,24,106,32,1,40,11,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,48,10,10,99,114,111,112,95,112,97,114,97,109,24,144,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,114,111,112,80,97,114,97,109,101,116,101,114,18,47,10,10,100,97,116,97,95,112,97,114,97,109,24,107,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,18,71,10,22,100,101,116,101,99,116,105,111,110,95,111,117,116,112,117,116,95,112,97,114,97,109,24,147,1,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,53,10,13,100,114,111,112,111,117,116,95,112,97,114,97,109,24,108,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,100,117,109,109,121,95,100,97,116,97,95,112,97,114,97,109,24,109,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,101,108,116,119,105,115,101,95,112,97,114,97,109,24,110,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,46,10,9,101,108,117,95,112,97,114,97,109,24,140,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,76,85,80,97,114,97,109,101,116,101,114,18,50,10,11,101,109,98,101,100,95,112,97,114,97,109,24,137,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,109,98,101,100,80,97,114,97,109,101,116,101,114,18,45,10,9,101,120,112,95,112,97,114,97,109,24,111,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,120,112,80,97,114,97,109,101,116,101,114,18,54,10,13,102,108,97,116,116,101,110,95,112,97,114,97,109,24,135,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,18,56,10,15,104,100,102,53,95,100,97,116,97,95,112,97,114,97,109,24,112,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,60,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,113,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,104,105,110,103,101,95,108,111,115,115,95,112,97,114,97,109,24,114,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,58,10,16,105,109,97,103,101,95,100,97,116,97,95,112,97,114,97,109,24,115,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,102,111,103,97,105,110,95,108,111,115,115,95,112,97,114,97,109,24,116,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,110,101,114,95,112,114,111,100,117,99,116,95,112,97,114,97,109,24,117,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,50,10,11,105,110,112,117,116,95,112,97,114,97,109,24,143,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,112,117,116,80,97,114,97,109,101,116,101,114,18,46,10,9,108,111,103,95,112,97,114,97,109,24,134,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,103,80,97,114,97,109,101,116,101,114,18,45,10,9,108,114,110,95,112,97,114,97,109,24,118,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,18,60,10,17,109,101,109,111,114,121,95,100,97,116,97,95,112,97,114,97,109,24,119,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,45,10,9,109,118,110,95,112,97,114,97,109,24,120,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,86,78,80,97,114,97,109,101,116,101,114,18,57,10,10,110,111,114,109,95,112,97,114,97,109,24,149,1,32,1,40,11,50,36,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,18,54,10,13,112,101,114,109,117,116,101,95,112,97,114,97,109,24,148,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,18,58,10,15,112,97,114,97,109,101,116,101,114,95,112,97,114,97,109,24,145,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,18,53,10,13,112,111,111,108,105,110,103,95,112,97,114,97,109,24,121,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,49,10,11,112,111,119,101,114,95,112,97,114,97,109,24,122,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,112,114,101,108,117,95,112,97,114,97,109,24,131,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,82,101,76,85,80,97,114,97,109,101,116,101,114,18,57,10,15,112,114,105,111,114,95,98,111,120,95,112,97,114,97,109,24,150,1,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,18,56,10,14,112,114,111,112,111,115,97,108,95,112,97,114,97,109,24,201,1,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,18,65,10,19,112,115,114,111,105,95,112,111,111,108,105,110,103,95,112,97,114,97,109,24,146,78,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,52,10,12,112,121,116,104,111,110,95,112,97,114,97,109,24,130,1,32,1,40,11,50,29,46,111,112,101,110,99],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+399364);allocate([118,95,99,97,102,102,101,46,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,18,58,10,15,114,101,99,117,114,114,101,110,116,95,112,97,114,97,109,24,146,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,18,58,10,15,114,101,100,117,99,116,105,111,110,95,112,97,114,97,109,24,136,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,114,101,108,117,95,112,97,114,97,109,24,123,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,18,54,10,13,114,101,115,104,97,112,101,95,112,97,114,97,109,24,133,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,18,63,10,17,114,111,105,95,112,111,111,108,105,110,103,95,112,97,114,97,109,24,215,199,248,3,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,50,10,11,115,99,97,108,101,95,112,97,114,97,109,24,142,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,99,97,108,101,80,97,114,97,109,101,116,101,114,18,53,10,13,115,105,103,109,111,105,100,95,112,97,114,97,109,24,124,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,53,10,13,115,111,102,116,109,97,120,95,112,97,114,97,109,24,125,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,46,10,9,115,112,112,95,112,97,114,97,109,24,132,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,18,49,10,11,115,108,105,99,101,95,112,97,114,97,109,24,126,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,47,10,10,116,97,110,104,95,112,97,114,97,109,24,127,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,18,58,10,15,116,104,114,101,115,104,111,108,100,95,112,97,114,97,109,24,128,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,48,10,10,116,105,108,101,95,112,97,114,97,109,24,138,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,105,108,101,80,97,114,97,109,101,116,101,114,18,61,10,17,119,105,110,100,111,119,95,100,97,116,97,95,112,97,114,97,109,24,129,1,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,34,182,1,10,23,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,16,10,5,115,99,97,108,101,24,1,32,1,40,2,58,1,49,18,21,10,6,109,105,114,114,111,114,24,2,32,1,40,8,58,5,102,97,108,115,101,18,20,10,9,99,114,111,112,95,115,105,122,101,24,3,32,1,40,13,58,1,48,18,17,10,9,109,101,97,110,95,102,105,108,101,24,4,32,1,40,9,18,18,10,10,109,101,97,110,95,118,97,108,117,101,24,5,32,3,40,2,18,26,10,11,102,111,114,99,101,95,99,111,108,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,102,111,114,99,101,95,103,114,97,121,24,7,32,1,40,8,58,5,102,97,108,115,101,34,201,1,10,13,76,111,115,115,80,97,114,97,109,101,116,101,114,18,20,10,12,105,103,110,111,114,101,95,108,97,98,101,108,24,1,32,1,40,5,18,75,10,13,110,111,114,109,97,108,105,122,97,116,105,111,110,24,3,32,1,40,14,50,45,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,46,78,111,114,109,97,108,105,122,97,116,105,111,110,77,111,100,101,58,5,86,65,76,73,68,18,17,10,9,110,111,114,109,97,108,105,122,101,24,2,32,1,40,8,34,66,10,17,78,111,114,109,97,108,105,122,97,116,105,111,110,77,111,100,101,18,8,10,4,70,85,76,76,16,0,18,9,10,5,86,65,76,73,68,16,1,18,14,10,10,66,65,84,67,72,95,83,73,90,69,16,2,18,8,10,4,78,79,78,69,16,3,34,76,10,17,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,16,10,5,116,111,112,95,107,24,1,32,1,40,13,58,1,49,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,18,20,10,12,105,103,110,111,114,101,95,108,97,98,101,108,24,3,32,1,40,5,34,77,10,15,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,26,10,11,111,117,116,95,109,97,120,95,118,97,108,24,1,32,1,40,8,58,5,102,97,108,115,101,18,16,10,5,116,111,112,95,107,24,2,32,1,40,13,58,1,49,18,12,10,4,97,120,105,115,24,3,32,1,40,5,34,57,10,15,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,18,21,10,10,99,111,110,99,97,116,95,100,105,109,24,1,32,1,40,13,58,1,49,34,133,1,10,18,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,18,24,10,16,117,115,101,95,103,108,111,98,97,108,95,115,116,97,116,115,24,1,32,1,40,8,18,38,10,23,109,111,118,105,110,103,95,97,118,101,114,97,103,101,95,102,114,97,99,116,105,111,110,24,2,32,1,40,2,58,5,48,46,57,57,57,18,18,10,3,101,112,115,24,3,32,1,40,2,58,5,49,101,45,48,53,18,25,10,10,115,99,97,108,101,95,98,105,97,115,24,7,32,1,40,8,58,5,102,97,108,115,101,34,100,10,13,66,105,97,115,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,19,10,8,110,117,109,95,97,120,101,115,24,2,32,1,40,5,58,1,49,18,45,10,6,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,76,10,24,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,17,10,6,109,97,114,103,105,110,24,1,32,1,40,2,58,1,49,18,29,10,14,108,101,103,97,99,121,95,118,101,114,115,105,111,110,24,2,32,1,40,8,58,5,102,97,108,115,101,34,145,4,10,20,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,2,32,1,40,8,58,4,116,114,117,101,18,11,10,3,112,97,100,24,3,32,3,40,13,18,19,10,11,107,101,114,110,101,108,95,115,105,122,101,24,4,32,3,40,13,18,14,10,6,115,116,114,105,100,101,24,6,32,3,40,13,18,16,10,8,100,105,108,97,116,105,111,110,24,18,32,3,40,13,18,16,10,5,112,97,100,95,104,24,9,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,119,24,10,32,1,40,13,58,1,48,18,16,10,8,107,101,114,110,101,108,95,104,24,11,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,119,24,12,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,104,24,13,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,119,24,14,32,1,40,13,18,16,10,5,103,114,111,117,112,24,5,32,1,40,13,58,1,49,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,7,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,8,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,66,10,6,101,110,103,105,110,101,24,15,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,15,10,4,97,120,105,115,24,16,32,1,40,5,58,1,49,18,30,10,15,102,111,114,99,101,95,110,100,95,105,109,50,99,111,108,24,17,32,1,40,8,58,5,102,97,108,115,101,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,48,10,13,67,114,111,112,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,50,18,14,10,6,111,102,102,115,101,116,24,2,32,3,40,13,34,171,2,10,13,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,18,20,10,9,114,97,110,100,95,115,107,105,112,24,7,32,1,40,13,58,1,48,18,56,10,7,98,97,99,107,101,110,100,24,8,32,1,40,14,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,46,68,66,58,7,76,69,86,69,76,68,66,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,34,10,19,102,111,114,99,101,95,101,110,99,111,100,101,100,95,99,111,108,111,114,24,9,32,1,40,8,58,5,102,97,108,115,101,18,19,10,8,112,114,101,102,101,116,99,104,24,10,32,1,40,13,58,1,52,34,27,10,2,68,66,18,11,10,7,76,69,86,69,76,68,66,16,0,18,8,10,4,76,77,68,66,16,1,34,91,10,30,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,18,26,10,13,110,109,115,95,116,104,114,101,115,104,111,108,100,24,1,32,1,40,2,58,3,48,46,51,18,13,10,5,116,111,112,95,107,24,2,32,1,40,5,18,14,10,3,101,116,97,24,3,32,1,40,2,58,1,49,34,170,1,10,19,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,24,10,16,111,117,116,112,117,116,95,100,105,114,101,99,116,111,114,121,24,1,32,1,40,9,18,26,10,18,111,117,116,112,117,116,95,110,97,109,101,95,112,114,101,102,105,120,24,2,32,1,40,9,18,21,10,13,111,117,116,112,117,116,95,102,111,114,109,97,116,24,3,32,1,40,9,18,22,10,14,108,97,98,101,108,95,109,97,112,95,102,105,108,101,24,4,32,1,40,9,18,22,10,14,110,97,109,101,95,115,105,122,101,95,102,105,108,101,24,5,32,1,40,9,18,22,10,14,110,117,109,95,116,101,115,116,95,105,109,97,103,101,24,6,32,1,40,13,34,73,10,16,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,26,10,13,100,114,111,112,111,117,116,95,114,97,116,105,111,24,1,32,1,40,2,58,3,48,46,53,18,25,10,11,115,99,97,108,101,95,116,114,97,105,110,24,2,32,1,40,8,58,4,116,114,117,101,34,174,1,10,18,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,50,10,11,100,97,116,97,95,102,105,108,108,101,114,24,1,32,3,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,11,10,3,110,117,109,24,2,32,3,40,13,18,16,10,8,99,104,97,110,110,101,108,115,24,3,32,3,40,13,18,14,10,6,104,101,105,103,104,116,24,4,32,3,40,13,18,13,10,5,119,105,100,116,104,24,5,32,3,40,13,34,172,1,10,16,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,64,10,9,111,112,101,114,97,116,105,111,110,24,1,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,46,69,108,116,119,105,115,101,79,112,58,3,83,85,77,18,13,10,5,99,111,101,102,102,24,2,32,3,40,2,18,30,10,16,115,116,97,98,108,101,95,112,114,111,100,95,103,114,97,100,24,3,32,1,40,8,58,4,116,114,117,101,34,39,10,9,69,108,116,119,105,115,101,79,112,18,8,10,4,80,82,79,68,16,0,18,7,10,3,83,85,77,16,1,18,7,10,3,77,65,88,16,2,34,32,10,12,69,76,85,80,97,114,97,109,101,116,101,114,18,16,10,5,97,108,112,104,97,24,1,32,1,40,2,58,1,49,34,186,1,10,14,69,109,98,101,100,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,17,10,9,105,110,112,117,116,95,100,105,109,24,2,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,3,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,68,10,12,69,120,112,80,97,114,97,109,101,116,101,114,18,16,10,4,98,97,115,101,24,1,32,1,40,2,58,2,45,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,57,10,16,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,20,10,8,101,110,100,95,97,120,105,115,24,2,32,1,40,5,58,2,45,49,34,79,10,17,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,2,32,1,40,13,18,22,10,7,115,104,117,102,102,108,101,24,3,32,1,40,8,58,5,102,97,108,115,101,34,40,10,19,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,17,10,9,102,105,108,101,95,110,97,109,101,24,1,32,1,40,9,34,101,10,18,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,55,10,4,110,111,114,109,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,46,78,111,114,109,58,2,76,49,34,22,10,4,78,111,114,109,18,6,10,2,76,49,16,1,18,6,10,2,76,50,16,2,34,151,2,10,18,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,21,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,58,1,49,18,20,10,9,114,97,110,100,95,115,107,105,112,24,7,32,1,40,13,58,1,48,18,22,10,7,115,104,117,102,102,108,101,24,8,32,1,40,8,58,5,102,97,108,115,101,18,21,10,10,110,101,119,95,104,101,105,103,104,116,24,9,32,1,40,13,58,1,48,18,20,10,9,110,101,119,95,119,105,100,116,104,24,10,32,1,40,13,58,1,48,18,22,10,8,105,115,95,99,111,108,111,114,24,11,32,1,40,8,58,4,116,114,117,101,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,21,10,11,114,111,111,116,95,102,111,108,100,101,114,24,12,32,1,40,9,58,0,34,39,10,21,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,34,217,1,10,21,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,2,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,5,32,1,40,5,58,1,49,18,24,10,9,116,114,97,110,115,112,111,115,101,24,6,32,1,40,8,58,5,102,97,108,115,101,34,56,10,14,73,110,112,117,116,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,34,68,10,12,76,111,103,80,97,114,97,109,101,116,101,114,18,16,10,4,98,97,115,101,24,1,32,1,40,2,58,2,45,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,198,2,10,12,76,82,78,80,97,114,97,109,101,116,101,114,18,21,10,10,108,111,99,97,108,95,115,105,122,101,24,1,32,1,40,13,58,1,53,18,16,10,5,97,108,112,104,97,24,2,32,1,40,2,58,1,49,18,18,10,4,98,101,116,97,24,3,32,1,40,2,58,4,48,46,55,53,18,75,10,11,110,111,114,109,95,114,101,103,105,111,110,24,4,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,46,78,111,114,109,82,101,103,105,111,110,58,15,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,18,12,10,1,107,24,5,32,1,40,2,58,1,49,18,58,10,6,101,110,103,105,110,101,24,6,32,1,40,14,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,53,10,10,78,111,114,109,82,101,103,105,111,110,18,19,10,15,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,16,0,18,18,10,14,87,73,84,72,73,78,95,67,72,65,78,78,69,76,16,1,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,90,10,19,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,1,32,1,40,13,18,16,10,8,99,104,97,110,110,101,108,115,24,2,32,1,40,13,18,14,10,6,104,101,105,103,104,116,24,3,32,1,40,13,18,13,10,5,119,105,100,116,104,24,4,32,1,40,13,34,100,10,12,77,86,78,80,97,114,97,109,101,116,101,114,18,32,10,18,110,111,114,109,97,108,105,122,101,95,118,97,114,105,97,110,99,101,24,1,32,1,40,8,58,4,116,114,117,101,18,30,10,15,97,99,114,111,115,115,95,99,104,97,110,110,101,108,115,24,2,32,1,40,8,58,5,102,97,108,115,101,18,18,10,3,101,112,115,24,3,32,1,40,2,58,5,49,101,45,48,57,34,60,10,18,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,34,201,3,10,16,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,60,10,4,112,111,111,108,24,1,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,14,10,3,112,97,100,24,4,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,104,24,9,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,119,24,10,32,1,40,13,58,1,48,18,19,10,11,107,101,114,110,101,108,95,115,105,122,101,24,2,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,104,24,5,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,119,24,6,32,1,40,13,18,17,10,6,115,116,114,105,100,101,24,3,32,1,40,13,58,1,49,18,16,10,8,115,116,114,105,100,101,95,104,24,7,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,119,24,8,32,1,40,13,18,62,10,6,101,110,103,105,110,101,24,11,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,29,10,14,103,108,111,98,97,108,95,112,111,111,108,105,110,103,24,12,32,1,40,8,58,5,102,97,108,115,101,18,23,10,9,99,101,105,108,95,109,111,100,101,24,13,32,1,40,8,58,4,116,114,117,101,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,70,10,14,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,16,10,5,112,111,119,101,114,24,1,32,1,40,2,58,1,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,103,10,15,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,18,14,10,6,109,111,100,117,108,101,24,1,32,1,40,9,18,13,10,5,108,97,121,101,114,24,2,32,1,40,9,18,19,10,9,112,97,114,97,109,95,115,116,114,24,3,32,1,40,9,58,0,18,32,10,17,115,104,97,114,101,95,105,110,95,112,97,114,97,108,108,101,108,24,4,32,1,40,8,58,5,102,97,108,115,101,34,206,1,10,18,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,18,21,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,58,1,48,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,4,32,1,40,8,58,5,102,97,108,115,101,18,28,10,13,101,120,112,111,115,101,95,104,105,100,100,101,110,24,5,32,1,40,8,58,5,102,97,108,115,101,34,180,1,10,18,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,18,68,10,9,111,112,101,114,97,116,105,111,110,24,1,32,1,40,14,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,46,82,101,100,117,99,116,105,111,110,79,112,58,3,83,85,77,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,48,18,16,10,5,99,111,101,102,102,24,3,32,1,40,2,58,1,49,34,53,10,11,82,101,100,117,99,116,105,111,110,79,112,18,7,10,3,83,85,77,16,1,18,8,10,4,65,83,85,77,16,2,18,9,10,5,83,85,77,83,81,16,3,18,8,10,4,77,69,65,78,16,4,34,148,1,10,13,82,101,76,85,80,97,114,97,109,101,116,101,114,18,25,10,14,110,101,103,97,116,105,118,101,95,115,108,111,112,101,24,1,32,1,40,2,58,1,48,18,59,10,6,101,110,103,105,110,101,24,2,32,1,40,14,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,97,10,16,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,48,18,20,10,8,110,117,109,95,97,120,101,115,24,3,32,1,40,5,58,2,45,49,34,179,1,10,14,83,99,97,108,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,19,10,8,110,117,109,95,97,120,101,115,24,2,32,1,40,5,58,1,49,18,45,10,6,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,24,10,9,98,105,97,115,95,116,101,114,109,24,4,32,1,40,8,58,5,102,97,108,115,101,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,127,10,16,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,62,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,76,10,14,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,3,32,1,40,5,58,1,49,18,19,10,11,115,108,105,99,101,95,112,111,105,110,116,24,2,32,3,40,13,18,20,10,9,115,108,105,99,101,95,100,105,109,24,1,32,1,40,13,58,1,49,34,144,1,10,16,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,62,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,121,10,13,84,97,110,72,80,97,114,97,109,101,116,101,114,18,59,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,47,10,13,84,105,108,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,13,10,5,116,105,108,101,115,24,2,32,1,40,5,34,42,10,18,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,20,10,9,116,104,114,101,115,104,111,108,100,24,1,32,1,40,2,58,1,48,34,193,2,10,19,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,25,10,12,102,103,95,116,104,114,101,115,104,111,108,100,24,7,32,1,40,2,58,3,48,46,53,18,25,10,12,98,103,95,116,104,114,101,115,104,111,108,100,24,8,32,1,40,2,58,3,48,46,53,18,25,10,11,102,103,95,102,114,97,99,116,105,111,110,24,9,32,1,40,2,58,4,48,46,50,53,18,22,10,11,99,111,110,116,101,120,116,95,112,97,100,24,10,32,1,40,13,58,1,48,18,23,10,9,99,114,111,112,95,109,111,100,101,24,11,32,1,40,9,58,4,119,97,114,112,18,27,10,12,99,97,99,104,101,95,105,109,97,103,101,115,24,12,32,1,40,8,58,5,102,97,108,115,101,18,21,10,11,114,111,111,116,95,102,111,108,100,101,114,24,13,32,1,40,9,58,0,34,249,1,10,12,83,80,80,80,97,114,97,109,101,116,101,114,18,22,10,14,112,121,114,97,109,105,100,95,104,101,105,103,104,116,24,1,32,1,40,13,18,56,10,4,112,111,111,108,24,2,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,58,10,6,101,110,103,105,110,101,24,6,32,1,40,14,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,220,21,10,16,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,14,10,6,98,111,116,116,111,109,24,2,32,3,40,9,18,11,10,3,116,111,112,24,3,32,3,40,9,18,12,10,4,110,97,109,101,24,4,32,1,40,9,18,43,10,7,105,110,99,108,117,100,101,24,32,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,43,10,7,101,120,99,108,117,100,101,24,33,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,54,10,4,116,121,112,101,24,5,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,76,97,121,101,114,84,121,112,101,18,38,10,5,98,108,111,98,115,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,14,10,5,112,97,114,97,109,24,233,7,32,3,40,9,18,69,10,15,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,24,234,7,32,3,40,14,50,43,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,68,105,109,67,104,101,99,107,77,111,100,101,18,16,10,8,98,108,111,98,115,95,108,114,24,7,32,3,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,8,32,3,40,2,18,19,10,11,108,111,115,115,95,119,101,105,103,104,116,24,35,32,3,40,2,18,55,10,14,97,99,99,117,114,97,99,121,95,112,97,114,97,109,24,27,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,51,10,12,97,114,103,109,97,120,95,112,97,114,97,109,24,23,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,51,10,12,99,111,110,99,97,116,95,112,97,114,97,109,24,9,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,70,10,22,99,111,110,116,114,97,115,116,105,118,101,95,108,111,115,115,95,112,97,114,97,109,24,40,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,61,10,17,99,111,110,118,111,108,117,116,105,111,110,95,112,97,114,97,109,24,10,32,1,40,11,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,100,97,116,97,95,112,97,114,97,109,24,11,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,100,114,111,112,111,117,116,95,112,97,114,97,109,24,12,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,100,117,109,109,121,95,100,97,116,97,95,112,97,114,97,109,24,26,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,101,108,116,119,105,115,101,95,112,97,114,97,109,24,24,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,45,10,9,101,120,112,95,112,97,114,97,109,24,41,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,120,112,80,97,114,97,109,101,116,101,114,18,56,10,15,104,100,102,53,95,100,97,116,97,95,112,97,114,97,109,24,13,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,60,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,14,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,104,105,110,103,101,95,108,111,115,115,95,112,97,114,97,109,24,29,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,58,10,16,105,109,97,103,101,95,100,97,116,97,95,112,97,114,97,109,24,15,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,102,111,103,97,105,110,95,108,111,115,115,95,112,97,114,97,109,24,16,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,110,101,114,95,112,114,111,100,117,99,116,95,112,97,114,97,109,24,17,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,45,10,9,108,114,110,95,112,97,114,97,109,24,18,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,18,60,10,17,109,101,109,111,114,121,95,100,97,116,97,95,112,97,114,97,109,24,22,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,45,10,9,109,118,110,95,112,97,114,97,109,24,34,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,86,78,80,97,114,97,109,101,116,101,114,18,53,10,13,112,111,111,108,105,110,103,95,112,97,114,97,109,24,19,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,49,10,11,112,111,119,101,114,95,112,97,114,97,109,24,21,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,47,10,10,114,101,108,117,95,112,97,114,97,109,24,30,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,18,53,10,13,115,105,103,109,111,105,100,95,112,97,114,97,109,24,38,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,53,10,13,115,111,102,116,109,97,120,95,112,97,114,97,109,24,39,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,49,10,11,115,108,105,99,101,95,112,97,114,97,109,24,31,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,47,10,10,116,97,110,104,95,112,97,114,97,109,24,37,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,18,57,10,15,116,104,114,101,115,104,111,108,100,95,112,97,114,97,109,24,25,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,60,10,17,119,105,110,100,111,119,95,100,97,116,97,95,112,97,114,97,109,24,20,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,18,62,10,15,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,24,36,32,1,40,11,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,108,111,115,115,95,112,97,114,97,109,24,42,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,18,45,10,5,108,97,121,101,114,24,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,34,216,4,10,9,76,97,121,101,114,84,121,112,101,18,8,10,4,78,79,78,69,16,0,18,10,10,6,65,66,83,86,65,76,16,35,18,12,10,8,65,67,67,85,82,65,67,89,16,1,18,10,10,6,65,82,71,77,65,88,16,30,18,8,10,4,66,78,76,76,16,2,18,10,10,6,67,79,78,67,65,84,16,3,18,20,10,16,67,79,78,84,82,65,83,84,73,86,69,95,76,79,83,83,16,37,18,15,10,11,67,79,78,86,79,76,85,84,73,79,78,16,4,18,8,10,4,68,65,84,65,16,5,18,17,10,13,68,69,67,79,78,86,79,76,85,84,73,79,78,16,39,18,11,10,7,68,82,79,80,79,85,84,16,6,18,14,10,10,68,85,77,77,89,95,68,65,84,65,16,32,18,18,10,14,69,85,67,76,73,68,69,65,78,95,76,79,83,83,16,7,18,11,10,7,69,76,84,87,73,83,69,16,25,18,7,10,3,69,88,80,16,38,18,11,10,7,70,76,65,84,84,69,78,16,8,18,13,10,9,72,68,70,53,95,68,65,84,65,16,9,18,15,10,11,72,68,70,53,95,79,85,84,80,85,84,16,10,18,14,10,10,72,73,78,71,69,95,76,79,83,83,16,28,18,10,10,6,73,77,50,67,79,76,16,11,18,14,10,10,73,77,65,71,69,95,68,65,84,65,16,12,18,17,10,13,73,78,70,79,71,65,73,78,95,76,79,83,83,16,13,18,17,10,13,73,78,78,69,82,95,80,82,79,68,85,67,84,16,14,18,7,10,3,76,82,78,16,15,18,15,10,11,77,69,77,79,82,89],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+409604);allocate([95,68,65,84,65,16,29,18,29,10,25,77,85,76,84,73,78,79,77,73,65,76,95,76,79,71,73,83,84,73,67,95,76,79,83,83,16,16,18,7,10,3,77,86,78,16,34,18,11,10,7,80,79,79,76,73,78,71,16,17,18,9,10,5,80,79,87,69,82,16,26,18,8,10,4,82,69,76,85,16,18,18,11,10,7,83,73,71,77,79,73,68,16,19,18,30,10,26,83,73,71,77,79,73,68,95,67,82,79,83,83,95,69,78,84,82,79,80,89,95,76,79,83,83,16,27,18,11,10,7,83,73,76,69,78,67,69,16,36,18,11,10,7,83,79,70,84,77,65,88,16,20,18,16,10,12,83,79,70,84,77,65,88,95,76,79,83,83,16,21,18,9,10,5,83,80,76,73,84,16,22,18,9,10,5,83,76,73,67,69,16,33,18,8,10,4,84,65,78,72,16,23,18,15,10,11,87,73,78,68,79,87,95,68,65,84,65,16,24,18,13,10,9,84,72,82,69,83,72,79,76,68,16,31,34,42,10,12,68,105,109,67,104,101,99,107,77,111,100,101,18,10,10,6,83,84,82,73,67,84,16,0,18,14,10,10,80,69,82,77,73,83,83,73,86,69,16,1,34,160,8,10,16,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,3,32,1,40,13,18,22,10,8,98,105,97,115,116,101,114,109,24,4,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,6,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,14,10,3,112,97,100,24,7,32,1,40,13,58,1,48,18,18,10,10,107,101,114,110,101,108,115,105,122,101,24,8,32,1,40,13,18,16,10,5,103,114,111,117,112,24,9,32,1,40,13,58,1,49,18,17,10,6,115,116,114,105,100,101,24,10,32,1,40,13,58,1,49,18,60,10,4,112,111,111,108,24,11,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,26,10,13,100,114,111,112,111,117,116,95,114,97,116,105,111,24,12,32,1,40,2,58,3,48,46,53,18,21,10,10,108,111,99,97,108,95,115,105,122,101,24,13,32,1,40,13,58,1,53,18,16,10,5,97,108,112,104,97,24,14,32,1,40,2,58,1,49,18,18,10,4,98,101,116,97,24,15,32,1,40,2,58,4,48,46,55,53,18,12,10,1,107,24,22,32,1,40,2,58,1,49,18,14,10,6,115,111,117,114,99,101,24,16,32,1,40,9,18,16,10,5,115,99,97,108,101,24,17,32,1,40,2,58,1,49,18,16,10,8,109,101,97,110,102,105,108,101,24,18,32,1,40,9,18,17,10,9,98,97,116,99,104,115,105,122,101,24,19,32,1,40,13,18,19,10,8,99,114,111,112,115,105,122,101,24,20,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,21,32,1,40,8,58,5,102,97,108,115,101,18,38,10,5,98,108,111,98,115,24,50,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,16,10,8,98,108,111,98,115,95,108,114,24,51,32,3,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,52,32,3,40,2,18,20,10,9,114,97,110,100,95,115,107,105,112,24,53,32,1,40,13,58,1,48,18,29,10,16,100,101,116,95,102,103,95,116,104,114,101,115,104,111,108,100,24,54,32,1,40,2,58,3,48,46,53,18,29,10,16,100,101,116,95,98,103,95,116,104,114,101,115,104,111,108,100,24,55,32,1,40,2,58,3,48,46,53,18,29,10,15,100,101,116,95,102,103,95,102,114,97,99,116,105,111,110,24,56,32,1,40,2,58,4,48,46,50,53,18,26,10,15,100,101,116,95,99,111,110,116,101,120,116,95,112,97,100,24,58,32,1,40,13,58,1,48,18,27,10,13,100,101,116,95,99,114,111,112,95,109,111,100,101,24,59,32,1,40,9,58,4,119,97,114,112,18,18,10,7,110,101,119,95,110,117,109,24,60,32,1,40,5,58,1,48,18,23,10,12,110,101,119,95,99,104,97,110,110,101,108,115,24,61,32,1,40,5,58,1,48,18,21,10,10,110,101,119,95,104,101,105,103,104,116,24,62,32,1,40,5,58,1,48,18,20,10,9,110,101,119,95,119,105,100,116,104,24,63,32,1,40,5,58,1,48,18,29,10,14,115,104,117,102,102,108,101,95,105,109,97,103,101,115,24,64,32,1,40,8,58,5,102,97,108,115,101,18,21,10,10,99,111,110,99,97,116,95,100,105,109,24,65,32,1,40,13,58,1,49,18,61,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,233,7,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,94,10,14,80,82,101,76,85,80,97,114,97,109,101,116,101,114,18,45,10,6,102,105,108,108,101,114,24,1,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,29,10,14,99,104,97,110,110,101,108,95,115,104,97,114,101,100,24,2,32,1,40,8,58,5,102,97,108,115,101,34,135,1,10,14,78,111,114,109,97,108,105,122,101,100,66,66,111,120,18,12,10,4,120,109,105,110,24,1,32,1,40,2,18,12,10,4,121,109,105,110,24,2,32,1,40,2,18,12,10,4,120,109,97,120,24,3,32,1,40,2,18,12,10,4,121,109,97,120,24,4,32,1,40,2,18,13,10,5,108,97,98,101,108,24,5,32,1,40,5,18,17,10,9,100,105,102,102,105,99,117,108,116,24,6,32,1,40,8,18,13,10,5,115,99,111,114,101,24,7,32,1,40,2,18,12,10,4,115,105,122,101,24,8,32,1,40,2,34,89,10,19,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,19,10,8,112,111,111,108,101,100,95,104,24,1,32,1,40,13,58,1,48,18,19,10,8,112,111,111,108,101,100,95,119,24,2,32,1,40,13,58,1,48,18,24,10,13,115,112,97,116,105,97,108,95,115,99,97,108,101,24,3,32,1,40,2,58,1,49,34,200,1,10,17,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,18,23,10,11,102,101,97,116,95,115,116,114,105,100,101,24,1,32,1,40,13,58,2,49,54,18,21,10,9,98,97,115,101,95,115,105,122,101,24,2,32,1,40,13,58,2,49,54,18,20,10,8,109,105,110,95,115,105,122,101,24,3,32,1,40,13,58,2,49,54,18,13,10,5,114,97,116,105,111,24,4,32,3,40,2,18,13,10,5,115,99,97,108,101,24,5,32,3,40,2,18,26,10,12,112,114,101,95,110,109,115,95,116,111,112,110,24,6,32,1,40,13,58,4,54,48,48,48,18,26,10,13,112,111,115,116,95,110,109,115,95,116,111,112,110,24,7,32,1,40,13,58,3,51,48,48,18,23,10,10,110,109,115,95,116,104,114,101,115,104,24,8,32,1,40,2,58,3,48,46,55,34,86,10,21,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,21,10,13,115,112,97,116,105,97,108,95,115,99,97,108,101,24,1,32,2,40,2,18,18,10,10,111,117,116,112,117,116,95,100,105,109,24,2,32,2,40,5,18,18,10,10,103,114,111,117,112,95,115,105,122,101,24,3,32,2,40,5,42,61,10,4,84,121,112,101,18,10,10,6,68,79,85,66,76,69,16,0,18,9,10,5,70,76,79,65,84,16,1,18,11,10,7,70,76,79,65,84,49,54,16,2,18,7,10,3,73,78,84,16,3,18,8,10,4,85,73,78,84,16,4,42,28,10,5,80,104,97,115,101,18,9,10,5,84,82,65,73,78,16,0,18,8,10,4,84,69,83,84,16,1,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,99,97,102,102,101,47,111,112,101,110,99,118,45,99,97,102,102,101,46,112,98,46,99,99,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,78,111,114,109,97,108,105,122,101,100,66,66,111,120,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,80,82,101,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,66,108,111,98,80,114,111,116,111,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,69,120,112,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,52,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,84,97,110,72,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,51,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,77,86,78,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,83,108,105,99,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,82,101,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,80,111,119,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,76,82,78,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,48,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,78,101,116,83,116,97,116,101,82,117,108,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,83,80,80,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,84,105,108,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,83,99,97,108,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,76,111,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,73,110,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,69,109,98,101,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,69,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,51,48,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,67,114,111,112,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,66,105,97,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,80,97,114,97,109,83,112,101,99,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,56,78,101,116,83,116,97,116,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,49,83,111,108,118,101,114,83,116,97,116,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,78,101,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,53,68,97,116,117,109,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,66,108,111,98,80,114,111,116,111,86,101,99,116,111,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,66,108,111,98,83,104,97,112,101,69,0,111,112,101,110,99,118,45,111,110,110,120,46,112,114,111,116,111,0,10,17,111,112,101,110,99,118,45,111,110,110,120,46,112,114,111,116,111,18,11,111,112,101,110,99,118,95,111,110,110,120,34,131,4,10,14,65,116,116,114,105,98,117,116,101,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,21,10,13,114,101,102,95,97,116,116,114,95,110,97,109,101,24,21,32,1,40,9,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,13,32,1,40,9,18,55,10,4,116,121,112,101,24,20,32,1,40,14,50,41,46,111,112,101,110,99,118,95,111,110,110,120,46,65,116,116,114,105,98,117,116,101,80,114,111,116,111,46,65,116,116,114,105,98,117,116,101,84,121,112,101,18,9,10,1,102,24,2,32,1,40,2,18,9,10,1,105,24,3,32,1,40,3,18,9,10,1,115,24,4,32,1,40,12,18,35,10,1,116,24,5,32,1,40,11,50,24,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,18,34,10,1,103,24,6,32,1,40,11,50,23,46,111,112,101,110,99,118,95,111,110,110,120,46,71,114,97,112,104,80,114,111,116,111,18,14,10,6,102,108,111,97,116,115,24,7,32,3,40,2,18,12,10,4,105,110,116,115,24,8,32,3,40,3,18,15,10,7,115,116,114,105,110,103,115,24,9,32,3,40,12,18,41,10,7,116,101,110,115,111,114,115,24,10,32,3,40,11,50,24,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,18,39,10,6,103,114,97,112,104,115,24,11,32,3,40,11,50,23,46,111,112,101,110,99,118,95,111,110,110,120,46,71,114,97,112,104,80,114,111,116,111,34,145,1,10,13,65,116,116,114,105,98,117,116,101,84,121,112,101,18,13,10,9,85,78,68,69,70,73,78,69,68,16,0,18,9,10,5,70,76,79,65,84,16,1,18,7,10,3,73,78,84,16,2,18,10,10,6,83,84,82,73,78,71,16,3,18,10,10,6,84,69,78,83,79,82,16,4,18,9,10,5,71,82,65,80,72,16,5,18,10,10,6,70,76,79,65,84,83,16,6,18,8,10,4,73,78,84,83,16,7,18,11,10,7,83,84,82,73,78,71,83,16,8,18,11,10,7,84,69,78,83,79,82,83,16,9,18,10,10,6,71,82,65,80,72,83,16,10,34,88,10,14,86,97,108,117,101,73,110,102,111,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,36,10,4,116,121,112,101,24,2,32,1,40,11,50,22,46,111,112,101,110,99,118,95,111,110,110,120,46,84,121,112,101,80,114,111,116,111,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,3,32,1,40,9,34,157,1,10,9,78,111,100,101,80,114,111,116,111,18,13,10,5,105,110,112,117,116,24,1,32,3,40,9,18,14,10,6,111,117,116,112,117,116,24,2,32,3,40,9,18,12,10,4,110,97,109,101,24,3,32,1,40,9,18,15,10,7,111,112,95,116,121,112,101,24,4,32,1,40,9,18,14,10,6,100,111,109,97,105,110,24,7,32,1,40,9,18,46,10,9,97,116,116,114,105,98,117,116,101,24,5,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,65,116,116,114,105,98,117,116,101,80,114,111,116,111,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,6,32,1,40,9,34,168,2,10,10,77,111,100,101,108,80,114,111,116,111,18,18,10,10,105,114,95,118,101,114,115,105,111,110,24,1,32,1,40,3,18,53,10,12,111,112,115,101,116,95,105,109,112,111,114,116,24,8,32,3,40,11,50,31,46,111,112,101,110,99,118,95,111,110,110,120,46,79,112,101,114,97,116,111,114,83,101,116,73,100,80,114,111,116,111,18,21,10,13,112,114,111,100,117,99,101,114,95,110,97,109,101,24,2,32,1,40,9,18,24,10,16,112,114,111,100,117,99,101,114,95,118,101,114,115,105,111,110,24,3,32,1,40,9,18,14,10,6,100,111,109,97,105,110,24,4,32,1,40,9,18,21,10,13,109,111,100,101,108,95,118,101,114,115,105,111,110,24,5,32,1,40,3,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,6,32,1,40,9,18,38,10,5,103,114,97,112,104,24,7,32,1,40,11,50,23,46,111,112,101,110,99,118,95,111,110,110,120,46,71,114,97,112,104,80,114,111,116,111,18,59,10,14,109,101,116,97,100,97,116,97,95,112,114,111,112,115,24,14,32,3,40,11,50,35,46,111,112,101,110,99,118,95,111,110,110,120,46,83,116,114,105,110,103,83,116,114,105,110,103,69,110,116,114,121,80,114,111,116,111,34,52,10,22,83,116,114,105,110,103,83,116,114,105,110,103,69,110,116,114,121,80,114,111,116,111,18,11,10,3,107,101,121,24,1,32,1,40,9,18,13,10,5,118,97,108,117,101,24,2,32,1,40,9,34,141,2,10,10,71,114,97,112,104,80,114,111,116,111,18,36,10,4,110,111,100,101,24,1,32,3,40,11,50,22,46,111,112,101,110,99,118,95,111,110,110,120,46,78,111,100,101,80,114,111,116,111,18,12,10,4,110,97,109,101,24,2,32,1,40,9,18,45,10,11,105,110,105,116,105,97,108,105,122,101,114,24,5,32,3,40,11,50,24,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,10,32,1,40,9,18,42,10,5,105,110,112,117,116,24,11,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,86,97,108,117,101,73,110,102,111,80,114,111,116,111,18,43,10,6,111,117,116,112,117,116,24,12,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,86,97,108,117,101,73,110,102,111,80,114,111,116,111,18,47,10,10,118,97,108,117,101,95,105,110,102,111,24,13,32,3,40,11,50,27,46,111,112,101,110,99,118,95,111,110,110,120,46,86,97,108,117,101,73,110,102,111,80,114,111,116,111,34,189,4,10,11,84,101,110,115,111,114,80,114,111,116,111,18,12,10,4,100,105,109,115,24,1,32,3,40,3,18,52,10,9,100,97,116,97,95,116,121,112,101,24,2,32,1,40,14,50,33,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,46,68,97,116,97,84,121,112,101,18,49,10,7,115,101,103,109,101,110,116,24,3,32,1,40,11,50,32,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,46,83,101,103,109,101,110,116,18,22,10,10,102,108,111,97,116,95,100,97,116,97,24,4,32,3,40,2,66,2,16,1,18,22,10,10,105,110,116,51,50,95,100,97,116,97,24,5,32,3,40,5,66,2,16,1,18,19,10,11,115,116,114,105,110,103,95,100,97,116,97,24,6,32,3,40,12,18,22,10,10,105,110,116,54,52,95,100,97,116,97,24,7,32,3,40,3,66,2,16,1,18,12,10,4,110,97,109,101,24,8,32,1,40,9,18,18,10,10,100,111,99,95,115,116,114,105,110,103,24,12,32,1,40,9,18,16,10,8,114,97,119,95,100,97,116,97,24,9,32,1,40,12,18,23,10,11,100,111,117,98,108,101,95,100,97,116,97,24,10,32,3,40,1,66,2,16,1,18,23,10,11,117,105,110,116,54,52,95,100,97,116,97,24,11,32,3,40,4,66,2,16,1,26,37,10,7,83,101,103,109,101,110,116,18,13,10,5,98,101,103,105,110,24,1,32,1,40,3,18,11,10,3,101,110,100,24,2,32,1,40,3,34,204,1,10,8,68,97,116,97,84,121,112,101,18,13,10,9,85,78,68,69,70,73,78,69,68,16,0,18,9,10,5,70,76,79,65,84,16,1,18,9,10,5,85,73,78,84,56,16,2,18,8,10,4,73,78,84,56,16,3,18,10,10,6,85,73,78,84,49,54,16,4,18,9,10,5,73,78,84,49,54,16,5,18,9,10,5,73,78,84,51,50,16,6,18,9,10,5,73,78,84,54,52,16,7,18,10,10,6,83,84,82,73,78,71,16,8,18,8,10,4,66,79,79,76,16,9,18,11,10,7,70,76,79,65,84,49,54,16,10,18,10,10,6,68,79,85,66,76,69,16,11,18,10,10,6,85,73,78,84,51,50,16,12,18,10,10,6,85,73,78,84,54,52,16,13,18,13,10,9,67,79,77,80,76,69,88,54,52,16,14,18,14,10,10,67,79,77,80,76,69,88,49,50,56,16,15,34,156,1,10,16,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,52,10,3,100,105,109,24,1,32,3,40,11,50,39,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,101,110,115,105,111,110,26,82,10,9,68,105,109,101,110,115,105,111,110,18,19,10,9,100,105,109,95,118,97,108,117,101,24,1,32,1,40,3,72,0,18,19,10,9,100,105,109,95,112,97,114,97,109,24,2,32,1,40,9,72,0,18,18,10,10,100,101,110,111,116,97,116,105,111,110,24,3,32,1,40,9,66,7,10,5,118,97,108,117,101,34,204,1,10,9,84,121,112,101,80,114,111,116,111,18,52,10,11,116,101,110,115,111,114,95,116,121,112,101,24,1,32,1,40,11,50,29,46,111,112,101,110,99,118,95,111,110,110,120,46,84,121,112,101,80,114,111,116,111,46,84,101,110,115,111,114,72,0,18,18,10,10,100,101,110,111,116,97,116,105,111,110,24,6,32,1,40,9,26,108,10,6,84,101,110,115,111,114,18,52,10,9,101,108,101,109,95,116,121,112,101,24,1,32,1,40,14,50,33,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,80,114,111,116,111,46,68,97,116,97,84,121,112,101,18,44,10,5,115,104,97,112,101,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,111,110,110,120,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,66,7,10,5,118,97,108,117,101,34,53,10,18,79,112,101,114,97,116,111,114,83,101,116,73,100,80,114,111,116,111,18,14,10,6,100,111,109,97,105,110,24,1,32,1,40,9,18,15,10,7,118,101,114,115,105,111,110,24,2,32,1,40,3,42,99,10,7,86,101,114,115,105,111,110,18,18,10,14,95,83,84,65,82,84,95,86,69,82,83,73,79,78,16,0,18,25,10,21,73,82,95,86,69,82,83,73,79,78,95,50,48,49,55,95,49,48,95,49,48,16,1,18,25,10,21,73,82,95,86,69,82,83,73,79,78,95,50,48,49,55,95,49,48,95,51,48,16,2,18,14,10,10,73,82,95,86,69,82,83,73,79,78,16,3,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,111,110,110,120,47,111,112,101,110,99,118,45,111,110,110,120,46,112,98,46,99,99,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,56,79,112,101,114,97,116,111,114,83,101,116,73,100,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,50,54,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,95,68,105,109,101,110,115,105,111,110,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,54,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,54,84,121,112,101,80,114,111,116,111,95,84,101,110,115,111,114,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,57,84,121,112,101,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,57,84,101,110,115,111,114,80,114,111,116,111,95,83,101,103,109,101,110,116,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,49,84,101,110,115,111,114,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,50,50,83,116,114,105,110,103,83,116,114,105,110,103,69,110,116,114,121,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,52,86,97,108,117,101,73,110,102,111,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,57,78,111,100,101,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,48,71,114,97,112,104,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,48,77,111,100,101,108,80,114,111,116,111,69,0,78,49,49,111,112,101,110,99,118,95,111,110,110,120,49,52,65,116,116,114,105,98,117,116,101,80,114,111,116,111,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,105,111,46,99,112,112,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,70,105,108,101,79,114,68,105,101,0,67,72,69,67,75,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,70,105,108,101,40,112,97,114,97,109,95,102,105,108,101,44,32,112,97,114,97,109,41,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,71,114,97,112,104,68,101,102,32,102,105,108,101,58,32,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,66,117,102,102,101,114,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,66,117,102,102,101,114,40,100,97,116,97,44,32,108,101,110,44,32,112,97,114,97,109,41,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,71,114,97,112,104,68,101,102,32,98,117,102,102,101,114,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,70,105,108,101,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,70,105,108,101,40,112,97,114,97,109,95,102,105,108,101,44,32,112,97,114,97,109,41,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,66,117,102,102,101,114,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,66,117,102,102,101,114,40,100,97,116,97,44,32,108,101,110,44,32,112,97,114,97,109,41,0,104,97,118,101,73,110,102,69,110,103,105,110,101,40,41,0,102,111,114,119,97,114,100,73,110,102,69,110,103,105,110,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,111,112,95,105,110,102,95,101,110,103,105,110,101,46,99,112,112,0,91,110,101,116,93,0,108,97,121,101,114,95,116,121,112,101,95,115,105,122,101,32,60,32,108,105,110,101,46,115,105,122,101,40,41,0,82,101,97,100,68,97,114,107,110,101,116,70,114,111,109,67,102,103,83,116,114,101,97,109,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,97,114,107,110,101,116,47,100,97,114,107,110,101,116,95,105,111,46,99,112,112,0,115,101,112,97,114,97,116,111,114,95,105,110,100,101,120,32,60,32,108,105,110,101,46,115,105,122,101,40,41,0,110,101,116,45,62,119,105,100,116,104,32,62,32,48,32,38,38,32,110,101,116,45,62,104,101,105,103,104,116,32,62,32,48,32,38,38,32,110,101,116,45,62,99,104,97,110,110,101,108,115,32,62,32,48,0,99,111,110,118,111,108,117,116,105,111,110,97,108,0,102,105,108,116,101,114,115,0,97,99,116,105,118,97,116,105,111,110,0,108,105,110,101,97,114,0,98,97,116,99,104,95,110,111,114,109,97,108,105,122,101,0,108,101,97,107,121,0,85,110,115,117,112,112,111,114,116,101,100,32,97,99,116,105,118,97,116,105,111,110,58,32,0,102,108,105,112,112,101,100,0,84,114,97,110,115,112,111,115,101,32,116,104,101,32,99,111,110,118,111,108,117,116,105,111,110,97,108,32,119,101,105,103,104,116,115,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,107,101,114,110,101,108,95,115,105,122,101,32,62,32,48,32,38,38,32,102,105,108,116,101,114,115,32,62,32,48,0,99,117,114,114,101,110,116,95,99,104,97,110,110,101,108,115,32,62,32,48,0,109,97,120,112,111,111,108,0,97,118,103,112,111,111,108,0,103,114,111,117,112,115,0,83,111,102,116,109,97,120,32,102,114,111,109,32,68,97,114,107,110,101,116,32,119,105,116,104,32,103,114,111,117,112,115,32,33,61,32,49,0,114,111,117,116,101,0,108,97,121,101,114,115,0,33,98,111,116,116,111,109,95,108,97,121,101,114,115,46,101,109,112,116,121,40,41,0,114,101,111,114,103,0,114,101,103,105,111,110,0,110,117,109,0,33,97,110,99,104,111,114,115,95,118,97,108,117,101,115,46,101,109,112,116,121,40,41,0,99,108,97,115,115,101,115,32,62,32,48,32,38,38,32,110,117,109,95,111,102,95,97,110,99,104,111,114,115,32,62,32,48,32,38,38,32,40,110,117,109,95,111,102,95,97,110,99,104,111,114,115,32,42,32,50,41,32,61,61,32,97,110,99,104,111,114,115,95,118,101,99,46,115,105,122,101,40,41,0,115,104,111,114,116,99,117,116,0,33,98,111,116,116,111,109,95,108,97,121,101,114,46,101,109,112,116,121,40,41,0,117,112,115,97,109,112,108,101,0,121,111,108,111,0,33,109,97,115,107,95,118,97,108,117,101,115,46,101,109,112,116,121,40,41,0,85,110,107,110,111,119,110,32,108,97,121,101,114,32,116,121,112,101,58,32,0,82,101,103,105,111,110,45,110,97,109,101,0,82,101,103,105,111,110,0,121,111,108,111,95,37,100,0,85,112,115,97,109,112,108,101,45,110,97,109,101,0,82,101,115,105,122,101,0,117,112,115,97,109,112,108,101,95,37,100,0,83,104,111,114,116,99,117,116,45,110,97,109,101,0,69,108,116,119,105,115,101,0,115,104,111,114,116,99,117,116,95,37,100,0,100,101,116,101,99,116,105,111,110,95,111,117,116,0,80,101,114,109,117,116,101,45,110,97,109,101,0,80,101,114,109,117,116,101,0,112,101,114,109,117,116,101,95,37,100,0,82,101,111,114,103,45,110,97,109,101,0,82,101,111,114,103,0,114,101,111,114,103,95,37,100,0,67,111,110,99,97,116,45,110,97,109,101,0,67,111,110,99,97,116,0,99,111,110,99,97,116,95,37,100,0,73,100,101,110,116,105,116,121,45,110,97,109,101,0,73,100,101,110,116,105,116,121,0,105,100,101,110,116,105,116,121,95,37,100,0,83,111,102,116,109,97,120,45,110,97,109,101,0,83,111,102,116,109,97,120,0,115,111,102,116,109,97,120,95,37,100,0,80,111,111,108,105,110,103,45,110,97,109,101,0,80,111,111,108,105,110,103,0,97,118,103,112,111,111,108,95,37,100,0,112,111,111,108,95,37,100,0,99,111,110,118,95,37,100,0,66,97,116,99,104,78,111,114,109,45,110,97,109,101,0,66,97,116,99,104,78,111,114,109,0,98,110,95,37,100,0,82,101,76,85,45,110,97,109,101,0,82,101,76,85,0,114,101,108,117,95,37,100,0,67,111,110,118,111,108,117,116,105,111,110,45,110,97,109,101,0,67,111,110,118,111,108,117,116,105,111,110,0,84,114,97,110,115,112,111,115,101,32,116,104,101,32,119,101,105,103,104,116,115,32,40,101,120,99,101,112,116,32,102,111,114,32,99,111,110,118,111,108,117,116,105,111,110,97,108,41,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,82,101,97,100,68,97,114,107,110,101,116,70,114,111,109,87,101,105,103,104,116,115,83,116,114,101,97,109,0,119,101,105,103,104,116,115,66,108,111,98,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,101,103,97,116,105,118,101,95,115,108,111,112,101,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,101,108,101,109,101,110,116,119,105,115,101,95,108,97,121,101,114,115,46,99,112,112,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,82,101,76,85,76,97,121,101,114,69,0,109,105,110,95,118,97,108,117,101,0,109,97,120,95,118,97,108,117,101,0,109,105,110,86,97,108,117,101,32,60,61,32,109,97,120,86,97,108,117,101,0,82,101,76,85,54,70,117,110,99,116,111,114,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+419844);allocate([108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,48,82,101,76,85,54,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,84,97,110,72,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,83,105,103,109,111,105,100,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,56,69,76,85,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,56,65,98,115,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,66,78,76,76,76,97,121,101,114,69,0,112,111,119,101,114,0,115,104,105,102,116,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,48,80,111,119,101,114,76,97,121,101,114,69,0,112,97,114,97,109,115,46,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,53,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,0,115,99,97,108,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,99,97,108,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,48,32,60,61,32,99,110,48,32,38,38,32,99,110,48,32,60,32,99,110,49,32,38,38,32,99,110,49,32,60,61,32,40,105,110,116,41,115,99,97,108,101,46,116,111,116,97,108,40,41,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,56,67,104,97,110,110,101,108,115,80,82,101,76,85,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,55,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,55,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,102,101,97,116,95,115,116,114,105,100,101,0,98,97,115,101,95,115,105,122,101,0,112,114,101,95,110,109,115,95,116,111,112,110,0,112,111,115,116,95,110,109,115,95,116,111,112,110,0,110,109,115,95,116,104,114,101,115,104,0,114,97,116,105,111,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,114,111,112,111,115,97,108,95,108,97,121,101,114,46,99,112,112,0,108,97,121,101,114,79,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,97,121,101,114,73,110,116,101,114,110,97,108,115,46,101,109,112,116,121,40,41,0,115,99,111,114,101,115,46,115,105,122,101,40,41,32,61,61,32,52,0,40,115,99,111,114,101,115,91,49,93,32,38,32,49,41,32,61,61,32,48,0,105,110,116,101,114,110,97,108,115,46,115,105,122,101,40,41,32,61,61,32,51,0,105,109,73,110,102,111,46,116,111,116,97,108,40,41,32,62,61,32,50,0,110,117,109,68,101,116,115,32,60,61,32,107,101,101,112,84,111,112,65,102,116,101,114,78,77,83,0,109,46,100,105,109,115,32,61,61,32,52,0,103,101,116,79,98,106,101,99,116,83,99,111,114,101,115,0,109,46,115,105,122,101,91,48,93,32,61,61,32,49,0,40,99,104,97,110,110,101,108,115,32,38,32,49,41,32,61,61,32,48,0,98,98,111,120,68,101,108,116,97,115,46,100,105,109,115,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,55,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,51,80,114,111,112,111,115,97,108,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,49,32,60,61,32,98,108,111,98,115,46,115,105,122,101,40,41,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,60,61,32,50,0,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,102,117,108,108,121,95,99,111,110,110,101,99,116,101,100,95,108,97,121,101,114,46,99,112,112,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,115,105,122,101,95,116,41,40,105,110,110,101,114,83,105,122,101,32,42,32,110,117,109,79,117,116,112,117,116,41,32,61,61,32,98,108,111,98,115,91,48,93,46,116,111,116,97,108,40,41,0,33,98,105,97,115,32,124,124,32,40,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,50,32,38,38,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,32,61,61,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,41,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,50,0,33,98,105,97,115,32,124,124,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,32,61,61,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,0,115,114,99,77,97,116,46,100,105,109,115,32,61,61,32,50,32,38,38,32,115,114,99,77,97,116,46,99,111,108,115,32,61,61,32,119,101,105,103,104,116,115,46,99,111,108,115,32,38,38,32,100,115,116,77,97,116,46,114,111,119,115,32,61,61,32,115,114,99,77,97,116,46,114,111,119,115,32,38,38,32,100,115,116,77,97,116,46,99,111,108,115,32,61,61,32,119,101,105,103,104,116,115,46,114,111,119,115,32,38,38,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,32,38,38,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,32,61,61,32,100,115,116,77,97,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,40,98,105,97,115,77,97,116,46,101,109,112,116,121,40,41,32,124,124,32,40,98,105,97,115,77,97,116,46,116,121,112,101,40,41,32,61,61,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,38,38,32,98,105,97,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,105,110,116,41,98,105,97,115,77,97,116,46,116,111,116,97,108,40,41,32,61,61,32,100,115,116,77,97,116,46,99,111,108,115,41,41,0,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,49,52,70,117,108,108,121,67,111,110,110,101,99,116,101,100,69,0,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,55,73,110,110,101,114,80,114,111,100,117,99,116,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,50,50,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,50,50,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,112,97,114,97,109,115,46,104,97,115,40,34,119,105,100,116,104,34,41,0,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,114,111,112,95,97,110,100,95,114,101,115,105,122,101,95,108,97,121,101,114,46,99,112,112,0,112,97,114,97,109,115,46,104,97,115,40,34,104,101,105,103,104,116,34,41,0,78,50,99,118,51,100,110,110,50,50,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,56,67,114,111,112,65,110,100,82,101,115,105,122,101,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,112,97,100,100,105,110,103,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,111,110,99,97,116,95,108,97,121,101,114,46,99,112,112,0,99,117,114,83,104,97,112,101,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,40,41,0,73,110,99,111,110,115,105,115,116,101,110,116,32,115,104,97,112,101,32,102,111,114,32,67,111,110,99,97,116,76,97,121,101,114,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,105,110,112,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,105,110,112,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,41,32,38,38,32,105,110,112,46,100,105,109,115,32,61,61,32,52,32,38,38,32,105,110,112,46,115,105,122,101,91,48,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,48,93,32,38,38,32,105,110,112,46,115,105,122,101,91,50,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,50,93,32,38,38,32,105,110,112,46,115,105,122,101,91,51,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,51,93,0,110,99,104,97,110,110,101,108,115,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,49,93,0,111,117,116,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,111,117,116,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,111,117,116,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,41,0,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,50,48,67,104,97,110,110,101,108,67,111,110,99,97,116,73,110,118,111,107,101,114,69,0,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,53,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,53,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,122,111,111,109,95,102,97,99,116,111,114,0,122,111,111,109,95,102,97,99,116,111,114,95,120,0,122,111,111,109,95,102,97,99,116,111,114,95,121,0,33,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,120,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,121,34,41,0,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,115,105,122,101,95,108,97,121,101,114,46,99,112,112,0,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,120,34,41,32,38,38,32,112,97,114,97,109,115,46,104,97,115,40,34,122,111,111,109,95,102,97,99,116,111,114,95,121,34,41,0,105,110,116,101,114,112,111,108,97,116,105,111,110,0,110,101,97,114,101,115,116,0,98,105,108,105,110,101,97,114,0,105,110,116,101,114,112,111,108,97,116,105,111,110,32,61,61,32,34,110,101,97,114,101,115,116,34,32,124,124,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,61,61,32,34,98,105,108,105,110,101,97,114,34,0,97,108,105,103,110,95,99,111,114,110,101,114,115,0,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,111,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,85,110,107,110,111,119,110,32,105,110,116,101,114,112,111,108,97,116,105,111,110,58,32,0,78,50,99,118,51,100,110,110,49,53,82,101,115,105,122,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,49,82,101,115,105,122,101,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,53,73,110,116,101,114,112,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,53,73,110,116,101,114,112,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,53,73,110,116,101,114,112,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,50,51,83,104,117,102,102,108,101,67,104,97,110,110,101,108,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,50,51,83,104,117,102,102,108,101,67,104,97,110,110,101,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,32,38,38,32,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,104,117,102,102,108,101,95,99,104,97,110,110,101,108,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,91,48,93,91,49,93,32,37,32,103,114,111,117,112,32,61,61,32,48,0,78,50,99,118,51,100,110,110,50,51,83,104,117,102,102,108,101,67,104,97,110,110,101,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,57,83,104,117,102,102,108,101,67,104,97,110,110,101,108,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,108,111,103,95,115,111,102,116,109,97,120,0,48,32,60,61,32,115,116,97,114,116,68,105,109,32,38,38,32,115,116,97,114,116,68,105,109,32,60,61,32,101,110,100,68,105,109,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,111,102,116,109,97,120,95,108,97,121,101,114,46,99,112,112,0,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,78,50,99,118,51,100,110,110,49,54,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,83,111,102,116,109,97,120,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,111,112,101,114,97,116,105,111,110,0,112,114,111,100,0,115,117,109,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,32,116,121,112,101,32,34,0,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,101,108,116,119,105,115,101,95,108,97,121,101,114,46,99,112,112,0,99,111,101,102,102,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,50,0,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,48,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,105,110,112,117,116,115,46,115,105,122,101,40,41,0,111,112,32,61,61,32,83,85,77,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,48,0,105,110,112,117,116,115,91,48,93,32,61,61,32,105,110,112,117,116,115,91,105,93,0,99,111,101,102,102,115,46,101,109,112,116,121,40,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,115,114,99,115,0,115,114,99,115,91,105,93,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,115,91,105,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,100,115,116,46,116,111,116,97,108,40,41,32,61,61,32,100,115,116,46,115,105,122,101,91,48,93,32,42,32,112,46,99,104,97,110,110,101,108,115,32,42,32,112,46,112,108,97,110,101,83,105,122,101,0,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,115,114,99,115,0,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,49,52,69,108,116,119,105,115,101,73,110,118,111,107,101,114,69,0,115,116,97,116,105,99,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,58,58,69,108,116,119,105,115,101,73,110,118,111,107,101,114,58,58,114,117,110,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,105,110,116,44,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,99,118,58,58,100,110,110,58,58,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,58,58,69,108,116,119,105,115,101,79,112,44,32,99,111,110,115,116,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,65,99,116,105,118,97,116,105,111,110,76,97,121,101,114,32,42,44,32,105,110,116,41,0,100,115,116,46,116,121,112,101,40,41,0,100,115,116,46,100,105,109,115,0,49,32,60,32,100,115,116,46,100,105,109,115,32,38,38,32,100,115,116,46,100,105,109,115,32,60,61,32,52,0,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,102,108,97,116,116,101,110,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,91,105,93,32,61,61,32,105,110,112,117,116,115,91,48,93,0,115,116,97,114,116,65,120,105,115,32,62,61,32,48,0,101,110,100,65,120,105,115,32,62,61,32,115,116,97,114,116,65,120,105,115,32,38,38,32,101,110,100,65,120,105,115,32,60,32,40,105,110,116,41,110,117,109,65,120,101,115,0,111,117,116,112,117,116,83,104,97,112,101,86,101,99,46,115,105,122,101,40,41,32,60,61,32,52,0,78,50,99,118,51,100,110,110,49,54,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,70,108,97,116,116,101,110,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,53,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,53,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,103,105,111,110,95,108,97,121,101,114,46,99,112,112,0,116,104,114,101,115,104,0,99,111,111,114,100,115,0,99,108,97,115,115,101,115,0,97,110,99,104,111,114,115,0,115,111,102,116,109,97,120,0,110,109,115,84,104,114,101,115,104,111,108,100,32,62,61,32,48,46,0,99,111,111,114,100,115,32,61,61,32,52,0,99,108,97,115,115,101,115,32,62,61,32,49,0,97,110,99,104,111,114,115,32,62,61,32,49,0,117,115,101,76,111,103,105,115,116,105,99,32,124,124,32,117,115,101,83,111,102,116,109,97,120,0,115,111,102,116,109,97,120,95,116,114,101,101,0,89,111,108,111,57,48,48,48,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,105,110,112,117,116,115,91,48,93,91,51,93,32,61,61,32,40,49,32,43,32,99,111,111,114,100,115,32,43,32,99,108,97,115,115,101,115,41,42,97,110,99,104,111,114,115,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,49,0,115,97,109,112,108,101,95,115,105,122,101,42,98,97,116,99,104,95,115,105,122,101,32,61,61,32,105,110,112,66,108,111,98,46,116,111,116,97,108,40,41,0,115,97,109,112,108,101,95,115,105,122,101,42,98,97,116,99,104,95,115,105,122,101,32,61,61,32,111,117,116,66,108,111,98,46,116,111,116,97,108,40,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,60,32,50,32,124,124,32,105,110,112,117,116,115,91,49,93,46,100,105,109,115,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,53,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,49,82,101,103,105,111,110,76,97,121,101,114,69,0,115,99,97,108,101,95,116,114,97,105,110,0,100,114,111,112,111,117,116,95,114,97,116,105,111,0,115,99,97,108,101,32,62,32,48,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,98,108,97,110,107,95,108,97,121,101,114,46,99,112,112,0,80,111,119,101,114,0,115,99,97,108,101,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,66,108,97,110,107,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,66,108,97,110,107,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,52,66,108,97,110,107,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,48,66,108,97,110,107,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,56,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,56,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,112,111,111,108,95,112,97,100,95,119,0,112,111,111,108,95,112,97,100,95,104,0,112,111,111,108,95,115,116,114,105,100,101,95,119,0,112,111,111,108,95,115,116,114,105,100,101,95,104,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,109,97,120,95,117,110,112,111,111,108,105,110,103,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,46,116,111,116,97,108,40,41,32,61,61,32,105,110,100,105,99,101,115,46,116,111,116,97,108,40,41,0,105,110,112,117,116,46,115,105,122,101,91,48,93,32,61,61,32,49,0,105,110,112,117,116,46,115,105,122,101,91,49,93,32,61,61,32,111,117,116,66,108,111,98,46,115,105,122,101,91,49,93,0,105,95,110,61,0,105,95,99,61,0,105,95,119,104,61,0,105,110,100,101,120,61,0,109,97,120,118,97,108,61,0,111,117,116,80,108,97,110,101,84,111,116,97,108,61,0,105,110,112,117,116,46,115,105,122,101,61,0,32,120,32,0,105,110,100,105,99,101,115,46,115,105,122,101,61,0,111,117,116,66,108,111,98,61,0,48,32,60,61,32,105,110,100,101,120,32,38,38,32,105,110,100,101,120,32,60,32,111,117,116,80,108,97,110,101,84,111,116,97,108,0,78,50,99,118,51,100,110,110,49,56,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,52,77,97,120,85,110,112,111,111,108,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,82,101,111,114,103,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+430084);allocate([82,101,111,114,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,114,101,111,114,103,95,115,116,114,105,100,101,0,114,101,111,114,103,83,116,114,105,100,101,32,62,32,48,0,82,101,111,114,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,111,114,103,95,108,97,121,101,114,46,99,112,112,0,111,117,116,112,117,116,115,91,48,93,91,48,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,49,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,50,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,51,93,32,62,32,48,0,116,111,116,97,108,40,111,117,116,112,117,116,115,91,48,93,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,41,0,78,50,99,118,51,100,110,110,49,52,82,101,111,114,103,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,48,82,101,111,114,103,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,110,117,109,65,120,101,115,32,62,61,32,45,49,0,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,115,104,97,112,101,95,108,97,121,101,114,46,99,112,112,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,82,101,115,104,97,112,101,76,97,121,101,114,69,0,116,111,116,97,108,40,115,114,99,83,104,97,112,101,44,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,44,32,115,114,99,82,97,110,103,101,46,101,110,100,41,32,61,61,32,109,97,115,107,84,111,116,97,108,0,99,111,109,112,117,116,101,83,104,97,112,101,66,121,82,101,115,104,97,112,101,77,97,115,107,0,48,32,60,61,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,115,114,99,82,97,110,103,101,46,101,110,100,32,38,38,32,115,114,99,82,97,110,103,101,46,101,110,100,32,60,61,32,115,114,99,83,104,97,112,101,83,105,122,101,0,67,111,112,121,32,100,105,109,91,37,100,93,32,40,119,104,105,99,104,32,104,97,115,32,122,101,114,111,32,115,105,122,101,41,32,105,115,32,111,117,116,32,111,102,32,116,104,101,32,115,111,117,114,99,101,32,115,104,97,112,101,32,98,111,117,110,100,115,0,68,117,112,108,105,99,97,116,101,32,111,102,32,105,110,102,101,114,114,101,100,32,100,105,109,32,40,119,104,105,99,104,32,105,115,32,100,101,110,111,116,101,100,32,98,121,32,45,49,41,0,109,97,115,107,83,104,97,112,101,91,105,93,32,62,61,32,45,49,0,67,97,110,39,116,32,105,110,102,101,114,32,97,32,100,105,109,32,100,101,110,111,116,101,100,32,98,121,32,45,49,0,115,114,99,84,111,116,97,108,32,61,61,32,100,115,116,84,111,116,97,108,0,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,49,93,41,0,78,50,99,118,51,100,110,110,49,54,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,110,111,114,109,95,114,101,103,105,111,110,0,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,0,87,73,84,72,73,78,95,67,72,65,78,78,69,76,0,85,110,107,110,111,119,110,32,114,101,103,105,111,110,32,116,121,112,101,32,34,0,76,82,78,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,108,114,110,95,108,97,121,101,114,46,99,112,112,0,108,111,99,97,108,95,115,105,122,101,0,76,82,78,32,108,97,121,101,114,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,112,111,115,105,116,105,118,101,32,111,100,100,32,118,97,108,117,101,115,32,102,111,114,32,108,111,99,97,108,95,115,105,122,101,0,97,108,112,104,97,0,110,111,114,109,95,98,121,95,115,105,122,101,0,105,110,112,117,116,115,95,97,114,114,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,95,97,114,114,46,116,111,116,97,108,40,41,0,105,110,112,117,116,115,91,105,93,46,100,105,109,115,32,61,61,32,52,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,109,111,100,101,32,111,102,32,76,82,78,32,108,97,121,101,114,0,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,49,48,67,104,97,110,110,101,108,76,82,78,69,0,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,56,76,82,78,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,55,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,55,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,95,109,97,120,83,105,122,101,32,62,32,95,109,105,110,83,105,122,101,0,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,114,105,111,114,95,98,111,120,95,108,97,121,101,114,46,99,112,112,0,119,105,100,116,104,115,46,115,105,122,101,40,41,32,61,61,32,104,101,105,103,104,116,115,46,115,105,122,101,40,41,0,95,97,115,112,101,99,116,82,97,116,105,111,115,46,101,109,112,116,121,40,41,0,33,112,97,114,97,109,115,46,104,97,115,40,34,109,105,110,95,115,105,122,101,34,41,0,33,112,97,114,97,109,115,46,104,97,115,40,34,109,97,120,95,115,105,122,101,34,41,0,95,109,105,110,83,105,122,101,32,62,32,48,0,95,98,111,120,87,105,100,116,104,115,46,115,105,122,101,40,41,32,61,61,32,95,98,111,120,72,101,105,103,104,116,115,46,115,105,122,101,40,41,0,115,116,101,112,95,104,0,115,116,101,112,95,119,0,33,112,97,114,97,109,115,46,104,97,115,40,34,115,116,101,112,34,41,0,95,115,116,101,112,89,32,62,32,48,46,0,95,115,116,101,112,88,32,62,32,48,46,0,33,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,34,41,0,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,95,104,34,41,0,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,95,119,34,41,0,95,111,102,102,115,101,116,115,88,46,115,105,122,101,40,41,32,61,61,32,95,111,102,102,115,101,116,115,89,46,115,105,122,101,40,41,0,118,97,114,105,97,110,99,101,80,97,114,97,109,101,116,101,114,82,101,116,114,105,101,118,101,100,0,103,101,116,86,97,114,105,97,110,99,101,0,118,97,114,105,97,110,99,101,83,105,122,101,32,61,61,32,52,0,118,97,114,105,97,110,99,101,32,62,32,48,0,97,115,112,101,99,116,95,114,97,116,105,111,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,58,58,102,105,110,97,108,105,122,101,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,91,49,93,46,100,105,109,115,0,52,0,105,110,112,117,116,115,91,48,93,46,100,105,109,115,0,105,110,112,117,116,115,46,115,105,122,101,40,41,0,40,115,105,122,101,95,116,41,49,0,78,50,99,118,51,100,110,110,49,55,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,51,80,114,105,111,114,66,111,120,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,50,77,86,78,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,50,77,86,78,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,110,111,114,109,97,108,105,122,101,95,118,97,114,105,97,110,99,101,0,97,99,114,111,115,115,95,99,104,97,110,110,101,108,115,0,78,50,99,118,51,100,110,110,49,50,77,86,78,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,56,77,86,78,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,109,97,120,0,97,118,101,0,115,116,111,99,104,97,115,116,105,99,0,85,110,107,110,111,119,110,32,112,111,111,108,105,110,103,32,116,121,112,101,32,34,0,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,111,111,108,105,110,103,95,108,97,121,101,114,46,99,112,112,0,111,117,116,112,117,116,95,100,105,109,0,103,114,111,117,112,95,115,105,122,101,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,112,111,111,108,105,110,103,32,116,121,112,101,0,99,101,105,108,95,109,111,100,101,0,115,112,97,116,105,97,108,95,115,99,97,108,101,0,97,118,101,95,112,111,111,108,95,112,97,100,100,101,100,95,97,114,101,97,0,40,111,117,116,46,104,101,105,103,104,116,32,45,32,49,41,32,42,32,115,116,114,105,100,101,46,104,101,105,103,104,116,32,60,32,105,110,46,104,101,105,103,104,116,32,43,32,112,97,100,95,98,0,40,111,117,116,46,119,105,100,116,104,32,45,32,49,41,32,42,32,115,116,114,105,100,101,46,119,105,100,116,104,32,60,32,105,110,46,119,105,100,116,104,32,43,32,112,97,100,95,114,0,112,115,82,111,105,79,117,116,67,104,97,110,110,101,108,115,32,42,32,112,111,111,108,101,100,83,105,122,101,46,119,105,100,116,104,32,42,32,112,111,111,108,101,100,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,105,110,112,117,116,115,91,48,93,91,49,93,0,110,117,109,79,117,116,112,117,116,115,32,61,61,32,49,32,124,124,32,40,110,117,109,79,117,116,112,117,116,115,32,61,61,32,50,32,38,38,32,116,121,112,101,32,61,61,32,77,65,88,41,0,33,99,111,109,112,117,116,101,77,97,120,73,100,120,32,124,124,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,78,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,53,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,0,115,114,99,46,100,105,109,115,32,61,61,32,52,0,100,115,116,46,100,105,109,115,32,61,61,32,52,0,40,40,40,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,82,79,73,32,124,124,32,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,80,83,82,79,73,41,32,38,38,32,100,115,116,46,115,105,122,101,91,48,93,32,61,61,32,114,111,105,115,46,115,105,122,101,91,48,93,41,32,124,124,32,115,114,99,46,115,105,122,101,91,48,93,32,61,61,32,100,115,116,46,115,105,122,101,91,48,93,41,0,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,80,83,82,79,73,32,124,124,32,115,114,99,46,115,105,122,101,91,49,93,32,61,61,32,100,115,116,46,115,105,122,101,91,49,93,0,40,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,115,114,99,46,116,121,112,101,40,41,32,38,38,32,109,97,115,107,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,41,41,0,114,111,105,115,68,97,116,97,91,48,93,32,60,32,115,114,99,45,62,115,105,122,101,91,48,93,0,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,49,52,80,111,111,108,105,110,103,73,110,118,111,107,101,114,69,0,33,105,110,112,117,116,115,46,101,109,112,116,121,40,41,0,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,56,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,56,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,50,0,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,98,97,116,99,104,95,110,111,114,109,95,108,97,121,101,114,46,99,112,112,0,104,97,115,95,119,101,105,103,104,116,0,117,115,101,95,103,108,111,98,97,108,95,115,116,97,116,115,0,115,99,97,108,101,95,98,105,97,115,0,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,110,32,38,38,32,98,108,111,98,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,108,111,98,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,108,111,98,115,91,48,93,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,98,108,111,98,115,91,49,93,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,51,0,40,115,105,122,101,95,116,41,119,101,105,103,104,116,115,66,108,111,98,73,110,100,101,120,32,60,32,98,108,111,98,115,46,115,105,122,101,40,41,0,119,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,119,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,119,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,0,40,115,105,122,101,95,116,41,98,105,97,115,66,108,111,98,73,110,100,101,120,32,60,32,98,108,111,98,115,46,115,105,122,101,40,41,0,98,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,98,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,0,99,118,58,58,100,110,110,58,58,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,58,58,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,40,99,111,110,115,116,32,99,118,58,58,100,110,110,58,58,100,110,110,52,95,118,50,48,49,56,48,57,49,55,58,58,76,97,121,101,114,80,97,114,97,109,115,32,38,41,0,98,108,111,98,115,91,50,93,46,116,121,112,101,40,41,0,66,97,116,99,104,32,110,111,114,109,97,108,105,122,97,116,105,111,110,32,105,110,32,116,114,97,105,110,105,110,103,32,109,111,100,101,32,119,105,116,104,32,98,97,116,99,104,32,115,105,122,101,32,62,32,49,0,105,110,112,66,108,111,98,46,100,105,109,115,32,61,61,32,50,32,124,124,32,105,110,112,66,108,111,98,46,100,105,109,115,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,56,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,52,66,97,116,99,104,78,111,114,109,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,97,99,114,111,115,115,95,115,112,97,116,105,97,108,0,115,116,97,114,116,95,97,120,105,115,0,33,112,97,114,97,109,115,46,104,97,115,40,34,97,99,114,111,115,115,95,115,112,97,116,105,97,108,34,41,32,124,124,32,33,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,95,97,120,105,115,34,41,0,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,110,111,114,109,97,108,105,122,101,95,98,98,111,120,95,108,97,121,101,114,46,99,112,112,0,112,110,111,114,109,32,62,32,48,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,32,38,38,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,105,110,112,117,116,115,91,48,93,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,116,111,116,97,108,40,41,0,110,117,109,32,42,32,110,117,109,80,108,97,110,101,115,32,33,61,32,48,0,115,99,97,108,101,46,116,111,116,97,108,40,41,32,61,61,32,110,117,109,80,108,97,110,101,115,0,78,50,99,118,51,100,110,110,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,56,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,83,99,97,108,101,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,83,99,97,108,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,98,105,97,115,95,116,101,114,109,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,99,97,108,101,95,108,97,121,101,114,46,99,112,112,0,33,98,108,111,98,115,46,101,109,112,116,121,40,41,32,124,124,32,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,110,117,109,87,101,105,103,104,116,115,32,33,61,32,48,0,116,111,116,97,108,40,105,110,112,83,104,97,112,101,44,32,97,120,105,115,44,32,101,110,100,65,120,105,115,41,32,61,61,32,110,117,109,87,101,105,103,104,116,115,0,33,104,97,115,66,105,97,115,32,124,124,32,110,117,109,87,101,105,103,104,116,115,32,61,61,32,98,105,97,115,46,116,111,116,97,108,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,99,97,108,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,111,117,116,66,108,111,98,46,116,121,112,101,40,41,0,67,86,95,51,50,70,67,49,0,105,110,112,66,108,111,98,46,116,121,112,101,40,41,0,73,110,99,111,109,112,97,116,105,98,108,101,32,119,101,105,103,104,116,115,47,98,105,97,115,32,98,108,111,98,115,0,119,101,105,103,104,116,115,46,116,111,116,97,108,40,41,0,98,105,97,115,46,116,111,116,97,108,40,41,0,40,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,32,38,38,32,98,108,111,98,115,46,101,109,112,116,121,40,41,41,32,124,124,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,40,105,110,116,41,104,97,115,87,101,105,103,104,116,115,32,43,32,40,105,110,116,41,104,97,115,66,105,97,115,0,78,50,99,118,51,100,110,110,49,52,83,99,97,108,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,48,83,99,97,108,101,76,97,121,101,114,69,0,83,99,97,108,101,0,107,101,114,110,101,108,0,107,101,114,110,101,108,95,115,105,122,101,0,107,101,114,110,101,108,95,115,105,122,101,32,40,111,114,32,107,101,114,110,101,108,95,104,32,97,110,100,32,107,101,114,110,101,108,95,119,41,32,110,111,116,32,115,112,101,99,105,102,105,101,100,0,103,101,116,75,101,114,110,101,108,83,105,122,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,108,97,121,101,114,115,95,99,111,109,109,111,110,46,99,112,112,0,107,101,114,110,101,108,72,32,62,32,48,32,38,38,32,107,101,114,110,101,108,87,32,62,32,48,0,112,97,100,95,108,0,112,97,100,95,116,0,112,97,100,95,114,0,112,97,100,95,98,0,112,97,100,0,115,116,114,105,100,101,0,112,97,100,84,32,62,61,32,48,32,38,38,32,112,97,100,76,32,62,61,32,48,32,38,38,32,112,97,100,66,32,62,61,32,48,32,38,38,32,112,97,100,82,32,62,61,32,48,32,38,38,32,115,116,114,105,100,101,72,32,62,32,48,32,38,38,32,115,116,114,105,100,101,87,32,62,32,48,0,103,101,116,83,116,114,105,100,101,65,110,100,80,97,100,100,105,110,103,0,103,108,111,98,97,108,95,112,111,111,108,105,110,103,0,73,110,32,103,108,111,98,97,108,95,112,111,111,108,105,110,103,32,109,111,100,101,44,32,107,101,114,110,101,108,95,115,105,122,101,32,40,111,114,32,107,101,114,110,101,108,95,104,32,97,110,100,32,107,101,114,110,101,108,95,119,41,32,99,97,110,110,111,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,103,101,116,80,111,111,108,105,110,103,75,101,114,110,101,108,80,97,114,97,109,115,0,73,110,32,103,108,111,98,97,108,95,112,111,111,108,105,110,103,32,109,111,100,101,44,32,112,97,100,115,32,109,117,115,116,32,98,101,32,61,32,48,44,32,97,110,100,32,115,116,114,105,100,101,95,104,32,97,110,100,32,115,116,114,105,100,101,95,119,32,109,117,115,116,32,98,101,32,61,32,49,0,100,105,108,97,116,105,111,110,72,32,62,32,48,32,38,38,32,100,105,108,97,116,105,111,110,87,32,62,32,48,0,103,101,116,67,111,110,118,111,108,117,116,105,111,110,75,101,114,110,101,108,80,97,114,97,109,115,0,85,110,115,117,112,112,111,114,116,101,100,32,112,97,100,100,105,110,103,32,109,111,100,101,0,103,101,116,67,111,110,118,80,111,111,108,79,117,116,80,97,114,97,109,115,0,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,110,117,109,95,99,108,97,115,115,101,115,0,115,104,97,114,101,95,108,111,99,97,116,105,111,110,0,98,97,99,107,103,114,111,117,110,100,95,108,97,98,101,108,95,105,100,0,118,97,114,105,97,110,99,101,95,101,110,99,111,100,101,100,95,105,110,95,116,97,114,103,101,116,0,107,101,101,112,95,116,111,112,95,107,0,99,111,110,102,105,100,101,110,99,101,95,116,104,114,101,115,104,111,108,100,0,116,111,112,95,107,0,108,111,99,95,112,114,101,100,95,116,114,97,110,115,112,111,115,101,100,0,110,111,114,109,97,108,105,122,101,100,95,98,98,111,120,0,103,114,111,117,112,95,98,121,95,99,108,97,115,115,101,115,0,110,109,115,95,116,104,114,101,115,104,111,108,100,0,95,110,109,115,84,104,114,101,115,104,111,108,100,32,62,32,48,46,0,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,100,101,116,101,99,116,105,111,110,95,111,117,116,112,117,116,95,108,97,121,101,114,46,99,112,112,0,99,111,100,101,95,116,121,112,101,0,99,101,110,116,101,114,95,115,105,122,101,0,67,69,78,84,69,82,95,83,73,90,69,0,67,79,82,78,69,82,0,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,0,32,112,97,114,97,109,101,116,101,114,46,0,103,101,116,80,97,114,97,109,101,116,101,114,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,51,0,105,110,112,117,116,115,91,48,93,91,48,93,32,61,61,32,105,110,112,117,116,115,91,49,93,91,48,93,0,40,110,117,109,80,114,105,111,114,115,32,42,32,95,110,117,109,76,111,99,67,108,97,115,115,101,115,32,42,32,52,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,44,32,49,41,0,105,110,116,40,110,117,109,80,114,105,111,114,115,32,42,32,95,110,117,109,67,108,97,115,115,101,115,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,49,93,44,32,49,41,0,105,110,112,117,116,115,91,50,93,91,49,93,32,61,61,32,49,32,43,32,40,105,110,116,41,40,33,95,118,97,114,105,97,110,99,101,69,110,99,111,100,101,100,73,110,84,97,114,103,101,116,41,0,95,98,98,111,120,101,115,78,111,114,109,97,108,105,122,101,100,32,124,124,32,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,52,0,105,110,112,117,116,115,91,51,93,46,100,105,109,115,32,61,61,32,52,0,99,111,117,110,116,32,61,61,32,110,117,109,75,101,112,116,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,99,111,110,102,105,100,101,110,99,101,32,112,114,101,100,105,99,116,105,111,110,115,32,102,111,114,32,108,97,98,101,108,32,37,100,0,111,117,116,112,117,116,68,101,116,101,99,116,105,111,110,115,95,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,108,111,99,97,116,105,111,110,32,112,114,101,100,105,99,116,105,111,110,115,32,102,111,114,32,108,97,98,101,108,32,37,100,0,112,114,111,99,101,115,115,68,101,116,101,99,116,105,111,110,115,95,0,78,77,83,70,97,115,116,95,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,46,46,47,110,109,115,46,105,110,108,46,104,112,112,0,105,100,120,32,60,32,115,99,111,114,101,115,46,115,105,122,101,40,41,0,97,108,108,95,108,111,99,95,112,114,101,100,115,46,115,105,122,101,40,41,32,61,61,32,110,117,109,0,68,101,99,111,100,101,66,66,111,120,101,115,65,108,108,0,112,114,105,111,114,95,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,112,114,105,111,114,95,118,97,114,105,97,110,99,101,115,46,115,105,122,101,40,41,0,68,101,99,111,100,101,66,66,111,120,101,115,0,112,114,105,111,114,95,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,98,98,111,120,101,115,46,115,105,122,101,40,41,0,110,117,109,95,98,98,111,120,101,115,32,61,61,32,48,32,124,124,32,112,114,105,111,114,95,118,97,114,105,97,110,99,101,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,112,114,105,111,114,95,119,105,100,116,104,32,62,32,48,0,68,101,99,111,100,101,66,66,111,120,0,112,114,105,111,114,95,104,101,105,103,104,116,32,62,32,48,0,85,110,107,110,111,119,110,32,116,121,112,101,46,0,110,117,109,76,111,99,67,108,97,115,115,101,115,32,61,61,32,49,0,71,101,116,76,111,99,80,114,101,100,105,99,116,105,111,110,115,0,78,50,99,118,51,100,110,110,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,83,108,105,99,101,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,83,108,105,99,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,115,108,105,99,101,95,112,111,105,110,116,0,98,101,103,105,110,0,101,110,100,0,33,112,97,114,97,109,115,46,104,97,115,40,34,98,101,103,105,110,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,34,41,0,83,108,105,99,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,108,105,99,101,95,108,97,121,101,114,46,99,112,112,0,112,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,32,94,32,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,34,41,0,98,101,103,105,110,115,46,115,105,122,101,40,41,32,61,61,32,115,105,122,101,115,79,114,69,110,100,115,46,115,105,122,101,40,41,0,115,116,97,114,116,32,62,61,32,48,0,115,105,122,101,32,61,61,32,45,49,32,124,124,32,115,105,122,101,32,62,32,48,0,101,110,100,32,60,32,48,32,124,124,32,101,110,100,32,62,32,115,116,97,114,116,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,48,83,108,105,99,101,76,97,121,101,114,69,0,115,108,105,99,101,82,97,110,103,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,0,48,32,60,61,32,97,120,105,115,32,38,38,32,97,120,105,115,32,60,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,0,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,32,62,32,48,32,38,38,32,105,110,112,83,104,97,112,101,91,97,120,105,115,93,32,37,32,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,32,61,61,32,48,0,99,108,97,109,112,101,100,46,115,116,97,114,116,32,60,32,99,108,97,109,112,101,100,46,101,110,100,0,99,108,97,109,112,0,99,108,97,109,112,101,100,46,101,110,100,32,60,61,32,97,120,105,115,83,105,122,101,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,115,108,105,99,101,82,97,110,103,101,115,46,115,105,122,101,40,41,0,115,108,105,99,101,82,97,110,103,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,105,110,112,83,104,97,112,101,46,100,105,109,115,40,41,0,78,50,99,118,51,100,110,110,49,52,83,108,105,99,101,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,105,110,112,117,116,95,100,105,109,115,0,112,97,114,97,109,115,46,104,97,115,40,34,112,97,100,100,105,110,103,115,34,41,0,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,97,100,100,105,110,103,95,108,97,121,101,114,46,99,112,112,0,40,112,97,100,100,105,110,103,115,80,97,114,97,109,46,115,105,122,101,40,41,32,38,32,49,41,32,61,61,32,48,0,112,97,100,100,105,110,103,115,91,105,93,46,102,105,114,115,116,32,62,61,32,48,0,112,97,100,100,105,110,103,115,91,105,93,46,115,101,99,111,110,100,32,62,61,32,48,0,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,62,61,32,112,97,100,100,105,110,103,115,46,115,105,122,101,40,41,0,105,110,112,117,116,68,105,109,115,32,61,61,32,45,49,32,124,124,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,61,61,32,105,110,112,117,116,68,105,109,115,32,124,124,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,62,32,112,97,100,100,105,110,103,115,46,115,105,122,101,40,41,0,99,111,110,115,116,97,110,116,0,114,101,102,108,101,99,116,0,105,110,112,117,116,115,91,48,93,46,100,105,109,115,32,61,61,32,52,0,111,117,116,112,117,116,115,91,48,93,46,100,105,109,115,32,61,61,32,52,0,79,110,108,121,32,115,112,97,116,105,97,108,32,114,101,102,108,101,99,116,105,111,110,32,112,97,100,100,105,110,103,32,105,115,32,115,117,112,112,111,114,116,101,100,46,0,109,46,100,105,109,115,32,62,32,50,0,103,101,116,80,108,97,110,101,0,85,110,107,110,111,119,110,32,112,97,100,100,105,110,103,32,116,121,112,101,58,32,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,112,97,100,82,105,103,104,116,0,105,110,112,87,105,100,116,104,0,112,97,100,76,101,102,116,0,112,97,100,66,111,116,116,111,109,0,105,110,112,72,101,105,103,104,116,0,112,97,100,84,111,112,0,78,50,99,118,51,100,110,110,49,54,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,80,97,100,100,105,110,103,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,111,114,100,101,114,0,79,114,100,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+440324);allocate([114,115,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,110,32,80,101,114,109,117,116,101,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,109,117,115,116,32,98,101,32,105,110,32,91,48,46,46,46,37,122,117,93,0,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,101,114,109,117,116,101,95,108,97,121,101,114,46,99,112,112,0,80,101,114,109,117,116,101,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,32,99,111,110,116,97,105,110,115,32,100,117,112,108,105,99,97,116,101,100,32,111,114,100,101,114,115,46,0,40,105,110,116,41,95,110,117,109,65,120,101,115,32,61,61,32,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,0,116,111,116,97,108,40,105,110,112,117,116,115,91,105,93,41,32,61,61,32,116,111,116,97,108,40,115,104,97,112,101,65,102,116,101,114,41,0,111,117,116,112,117,116,115,91,107,93,46,116,111,116,97,108,40,41,32,61,61,32,105,110,112,117,116,115,91,107,93,46,116,111,116,97,108,40,41,0,105,110,112,46,100,105,109,115,32,61,61,32,110,117,109,65,120,101,115,32,38,38,32,105,110,112,46,115,105,122,101,32,61,61,32,105,110,112,117,116,115,91,48,93,46,115,105,122,101,0,111,117,116,46,100,105,109,115,32,61,61,32,110,117,109,65,120,101,115,32,38,38,32,111,117,116,46,115,105,122,101,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,111,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,105,110,112,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,111,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,0,111,117,116,46,115,105,122,101,91,48,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,48,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,49,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,49,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,50,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,50,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,51,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,51,93,93,0,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,49,52,80,101,114,109,117,116,101,73,110,118,111,107,101,114,69,0,40,105,110,116,41,95,110,117,109,65,120,101,115,32,61,61,32,105,110,112,48,46,100,105,109,115,0,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,50,80,101,114,109,117,116,101,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,50,48,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,0,103,101,116,70,76,79,80,83,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,111,110,118,111,108,117,116,105,111,110,95,108,97,121,101,114,46,99,112,112,0,98,108,111,98,115,46,115,105,122,101,40,41,32,33,61,32,48,0,33,104,97,115,66,105,97,115,40,41,32,124,124,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,98,108,111,98,115,91,48,93,46,115,105,122,101,91,48,93,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,49,0,110,103,114,111,117,112,115,32,62,32,48,32,38,38,32,105,110,112,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,32,38,38,32,111,117,116,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,33,119,101,105,103,104,116,115,77,97,116,46,101,109,112,116,121,40,41,0,102,117,115,101,87,101,105,103,104,116,115,0,98,105,97,115,118,101,99,46,115,105,122,101,40,41,32,61,61,32,111,117,116,67,110,32,43,32,50,0,119,46,101,109,112,116,121,40,41,32,124,124,32,111,117,116,67,110,32,61,61,32,119,46,116,111,116,97,108,40,41,0,98,46,101,109,112,116,121,40,41,32,124,124,32,111,117,116,67,110,32,61,61,32,98,46,116,111,116,97,108,40,41,0,105,110,112,117,116,115,91,48,93,46,115,105,122,101,91,49,93,32,37,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,49,93,32,61,61,32,48,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,105,110,112,117,116,115,91,48,93,46,100,97,116,97,32,33,61,32,111,117,116,112,117,116,115,91,48,93,46,100,97,116,97,0,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,91,49,93,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,109,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,109,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,38,38,32,40,105,110,116,41,109,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,67,110,0,105,110,112,117,116,46,100,105,109,115,32,61,61,32,52,32,38,38,32,111,117,116,112,117,116,46,100,105,109,115,32,61,61,32,52,0,114,117,110,0,105,110,112,117,116,46,115,105,122,101,91,48,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,48,93,0,119,101,105,103,104,116,115,46,114,111,119,115,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,49,93,0,119,101,105,103,104,116,115,46,99,111,108,115,32,61,61,32,40,105,110,112,117,116,46,115,105,122,101,91,49,93,47,110,103,114,111,117,112,115,41,42,107,101,114,110,101,108,46,119,105,100,116,104,42,107,101,114,110,101,108,46,104,101,105,103,104,116,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,111,117,116,112,117,116,46,116,121,112,101,40,41,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,105,110,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,111,117,116,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,98,105,97,115,118,101,99,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,111,117,116,112,117,116,46,115,105,122,101,91,49,93,43,50,0,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,50,80,97,114,97,108,108,101,108,67,111,110,118,69,0,33,98,108,111,98,115,46,101,109,112,116,121,40,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,32,48,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,49,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,60,61,32,50,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,52,32,38,38,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,51,93,32,61,61,32,107,101,114,110,101,108,46,119,105,100,116,104,32,38,38,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,50,93,32,61,61,32,107,101,114,110,101,108,46,104,101,105,103,104,116,0,105,110,112,117,116,46,100,105,109,115,32,61,61,32,52,32,38,38,32,40,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,32,124,124,32,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,54,52,70,32,124,124,32,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,49,54,83,41,0,105,110,112,117,116,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,105,110,112,117,116,46,116,121,112,101,40,41,0,105,110,112,117,116,115,91,105,93,46,100,105,109,115,32,61,61,32,52,32,38,38,32,105,110,112,117,116,115,91,105,93,46,115,105,122,101,91,49,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,49,93,0,105,110,112,117,116,115,91,105,93,46,115,105,122,101,91,50,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,50,93,32,38,38,32,105,110,112,117,116,115,91,105,93,46,115,105,122,101,91,51,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,51,93,0,85,110,115,117,112,112,111,114,116,101,100,32,97,115,121,109,109,101,116,114,105,99,32,112,97,100,100,105,110,103,32,105,110,32,99,111,110,118,111,108,117,116,105,111,110,32,108,97,121,101,114,0,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,52,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,54,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,69,0,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,0,110,117,109,95,111,117,116,112,117,116,0,97,100,106,95,104,0,97,100,106,95,119,0,110,117,109,79,117,116,112,117,116,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,97,100,106,117,115,116,80,97,100,46,119,105,100,116,104,32,60,32,115,116,114,105,100,101,46,119,105,100,116,104,32,38,38,32,97,100,106,117,115,116,80,97,100,46,104,101,105,103,104,116,32,60,32,115,116,114,105,100,101,46,104,101,105,103,104,116,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,33,104,97,115,66,105,97,115,40,41,32,124,124,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,33,61,32,48,0,86,65,76,73,68,0,83,65,77,69,0,85,110,115,117,112,112,111,114,116,101,100,32,112,97,100,100,105,110,103,32,109,111,100,101,32,0,111,117,116,67,110,32,37,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,49,93,32,61,61,32,48,0,105,110,112,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,32,38,38,32,111,117,116,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,98,108,111,98,115,91,48,93,46,115,105,122,101,91,48,93,32,61,61,32,105,110,112,67,110,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,51,67,111,108,50,73,109,73,110,118,111,107,101,114,69,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,51,77,97,116,77,117,108,73,110,118,111,107,101,114,69,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,104,0,99,0,120,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,76,83,84,77,76,97,121,101,114,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,51,76,83,84,77,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,51,76,83,84,77,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,51,0,76,83,84,77,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,99,117,114,114,101,110,116,95,108,97,121,101,114,115,46,99,112,112,0,87,104,46,100,105,109,115,32,61,61,32,50,32,38,38,32,87,120,46,100,105,109,115,32,61,61,32,50,0,87,104,46,114,111,119,115,32,61,61,32,87,120,46,114,111,119,115,0,87,104,46,114,111,119,115,32,61,61,32,52,42,87,104,46,99,111,108,115,0,87,104,46,114,111,119,115,32,61,61,32,40,105,110,116,41,98,105,97,115,46,116,111,116,97,108,40,41,0,87,104,46,116,121,112,101,40,41,32,61,61,32,87,120,46,116,121,112,101,40,41,32,38,38,32,87,120,46,116,121,112,101,40,41,32,61,61,32,98,105,97,115,46,116,121,112,101,40,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,54,0,98,108,111,98,115,91,105,93,46,114,111,119,115,32,61,61,32,78,32,38,38,32,98,108,111,98,115,91,105,93,46,99,111,108,115,32,61,61,32,78,0,98,108,111,98,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,98,105,97,115,46,116,121,112,101,40,41,0,117,115,101,95,116,105,109,101,115,116,97,109,112,95,100,105,109,0,112,114,111,100,117,99,101,95,99,101,108,108,95,111,117,116,112,117,116,0,102,111,114,103,101,116,95,98,105,97,115,0,99,101,108,108,95,99,108,105,112,0,117,115,101,95,99,101,108,108,95,99,108,105,112,0,117,115,101,95,112,101,101,112,104,111,108,101,0,33,97,108,108,111,99,97,116,101,100,0,115,101,116,80,114,111,100,117,99,101,67,101,108,108,79,117,116,112,117,116,0,115,101,116,85,115,101,84,105,109,115,116,97,109,112,115,68,105,109,0,115,116,97,114,116,32,60,61,32,40,105,110,116,41,115,104,97,112,101,46,115,105,122,101,40,41,32,38,38,32,101,110,100,32,60,61,32,40,105,110,116,41,115,104,97,112,101,46,115,105,122,101,40,41,32,38,38,32,115,116,97,114,116,32,60,61,32,101,110,100,0,116,111,116,97,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,100,110,110,47,115,104,97,112,101,95,117,116,105,108,115,46,104,112,112,0,33,97,108,108,111,99,97,116,101,100,32,124,124,32,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,41,32,61,61,32,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,95,41,0,115,101,116,79,117,116,83,104,97,112,101,0,115,101,116,87,101,105,103,104,116,115,0,40,33,117,115,101,80,101,101,112,104,111,108,101,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,51,41,32,124,124,32,40,117,115,101,80,101,101,112,104,111,108,101,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,54,41,0,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,95,41,32,61,61,32,95,110,117,109,79,117,116,0,105,110,112,48,46,115,105,122,101,40,41,32,62,61,32,50,32,38,38,32,116,111,116,97,108,40,105,110,112,48,44,32,50,41,32,61,61,32,95,110,117,109,73,110,112,0,105,110,112,48,46,115,105,122,101,40,41,32,62,61,32,50,32,38,38,32,116,111,116,97,108,40,105,110,112,48,44,32,49,41,32,61,61,32,95,110,117,109,73,110,112,0,70,117,110,99,116,105,111,110,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,102,108,111,97,116,105,110,103,32,112,111,105,110,116,32,116,121,112,101,115,0,116,97,110,104,0,105,110,112,117,116,46,115,105,122,101,40,41,32,61,61,32,49,0,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,41,32,61,61,32,110,117,109,79,117,116,0,105,110,112,48,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,105,110,116,41,105,110,112,48,46,116,111,116,97,108,40,50,41,32,61,61,32,110,117,109,73,110,112,0,105,110,112,48,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,105,110,116,41,105,110,112,48,46,116,111,116,97,108,40,49,41,32,61,61,32,110,117,109,73,110,112,0,78,50,99,118,51,100,110,110,49,51,76,83,84,77,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,51,67,114,111,112,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,51,67,114,111,112,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,111,102,102,115,101,116,0,85,110,104,97,110,100,108,101,100,32,116,121,112,101,32,40,37,100,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,100,110,110,47,100,110,110,46,105,110,108,46,104,112,112,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,57,67,114,111,112,76,97,121,101,114,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,114,111,112,95,108,97,121,101,114,46,99,112,112,0,50,32,61,61,32,105,110,112,117,116,115,46,115,105,122,101,40,41,0,102,105,110,97,108,105,122,101,0,110,117,109,98,101,114,32,111,102,32,111,102,102,115,101,116,32,118,97,108,117,101,115,32,115,112,101,99,105,102,105,101,100,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,102,111,108,108,111,119,105,110,103,32,97,120,105,115,46,0,105,110,118,97,108,105,100,32,99,114,111,112,32,112,97,114,97,109,101,116,101,114,115,32,111,114,32,98,108,111,98,32,115,105,122,101,115,0,78,50,99,118,51,100,110,110,49,51,67,114,111,112,76,97,121,101,114,73,109,112,108,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,51,100,110,110,49,52,83,112,108,105,116,76,97,121,101,114,73,109,112,108,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,51,100,110,110,49,52,83,112,108,105,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,51,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,116,111,112,95,99,111,117,110,116,0,111,117,116,112,117,116,115,67,111,117,110,116,32,62,61,32,48,0,83,112,108,105,116,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,112,108,105,116,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,103,101,116,77,101,109,111,114,121,83,104,97,112,101,115,0,105,110,112,117,116,115,91,48,93,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,91,105,93,46,116,111,116,97,108,40,41,0,102,111,114,119,97,114,100,0,78,50,99,118,51,100,110,110,49,52,83,112,108,105,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,52,100,110,110,52,95,118,50,48,49,56,48,57,49,55,49,48,83,112,108,105,116,76,97,121,101,114,69,0,102,117,110,99,116,105,111,110,46,112,114,111,116,111,0,10,14,102,117,110,99,116,105,111,110,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,12,111,112,95,100,101,102,46,112,114,111,116,111,34,120,10,18,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,18,48,10,8,102,117,110,99,116,105,111,110,24,1,32,3,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,18,48,10,8,103,114,97,100,105,101,110,116,24,2,32,3,40,11,50,30,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,34,177,2,10,11,70,117,110,99,116,105,111,110,68,101,102,18,43,10,9,115,105,103,110,97,116,117,114,101,24,1,32,1,40,11,50,24,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,18,49,10,4,110,111,100,101,24,2,32,3,40,11,50,35,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,26,193,1,10,4,78,111,100,101,18,11,10,3,114,101,116,24,1,32,3,40,9,18,10,10,2,111,112,24,2,32,1,40,9,18,11,10,3,97,114,103,24,3,32,3,40,9,18,11,10,3,100,101,112,24,4,32,3,40,9,18,59,10,4,97,116,116,114,24,5,32,3,40,11,50,45,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,65,116,116,114,69,110,116,114,121,26,73,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,43,10,5,118,97,108,117,101,24,2,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,34,59,10,11,71,114,97,100,105,101,110,116,68,101,102,18,21,10,13,102,117,110,99,116,105,111,110,95,110,97,109,101,24,1,32,1,40,9,18,21,10,13,103,114,97,100,105,101,110,116,95,102,117,110,99,24,2,32,1,40,9,66,47,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,14,70,117,110,99,116,105,111,110,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,102,117,110,99,116,105,111,110,46,112,98,46,99,99,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,46,102,117,110,99,116,105,111,110,95,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,46,103,114,97,100,105,101,110,116,95,102,117,110,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,49,71,114,97,100,105,101,110,116,68,101,102,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,95,105,110,108,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,104,105,115,45,62,77,97,112,70,105,101,108,100,66,97,115,101,58,58,114,101,112,101,97,116,101,100,95,102,105,101,108,100,95,32,33,61,32,78,85,76,76,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,69,110,116,114,121,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,70,105,101,108,100,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,53,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,53,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,69,95,49,49,69,76,105,48,69,69,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,114,101,116,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,111,112,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,97,114,103,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,100,101,112,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,73,109,112,108,73,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,51,53,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,95,65,116,116,114,69,110,116,114,121,95,68,111,78,111,116,85,115,101,69,78,83,48,95,55,77,101,115,115,97,103,101,69,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,54,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,54,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,83,51,95,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,70,95,49,49,69,76,105,48,69,69,49,53,77,97,112,69,110,116,114,121,87,114,97,112,112,101,114,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,54,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,49,70,117,110,99,116,105,111,110,68,101,102,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,56,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,69,0,111,112,95,100,101,102,46,112,114,111,116,111,0,10,12,111,112,95,100,101,102,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,233,5,10,5,79,112,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,50,10,9,105,110,112,117,116,95,97,114,103,24,2,32,3,40,11,50,31,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,18,51,10,10,111,117,116,112,117,116,95,97,114,103,24,3,32,3,40,11,50,31,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,18,46,10,4,97,116,116,114,24,4,32,3,40,11,50,32,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,18,53,10,11,100,101,112,114,101,99,97,116,105,111,110,24,8,32,1,40,11,50,32,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,112,114,101,99,97,116,105,111,110,18,15,10,7,115,117,109,109,97,114,121,24,5,32,1,40,9,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,6,32,1,40,9,18,22,10,14,105,115,95,99,111,109,109,117,116,97,116,105,118,101,24,18,32,1,40,8,18,20,10,12,105,115,95,97,103,103,114,101,103,97,116,101,24,16,32,1,40,8,18,19,10,11,105,115,95,115,116,97,116,101,102,117,108,24,17,32,1,40,8,18,34,10,26,97,108,108,111,119,115,95,117,110,105,110,105,116,105,97,108,105,122,101,100,95,105,110,112,117,116,24,19,32,1,40,8,26,166,1,10,6,65,114,103,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,2,32,1,40,9,18,41,10,4,116,121,112,101,24,3,32,1,40,14,50,27,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,18,17,10,9,116,121,112,101,95,97,116,116,114,24,4,32,1,40,9,18,19,10,11,110,117,109,98,101,114,95,97,116,116,114,24,5,32,1,40,9,18,22,10,14,116,121,112,101,95,108,105,115,116,95,97,116,116,114,24,6,32,1,40,9,18,14,10,6,105,115,95,114,101,102,24,16,32,1,40,8,26,203,1,10,7,65,116,116,114,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,51,10,13,100,101,102,97,117,108,116,95,118,97,108,117,101,24,3,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,4,32,1,40,9,18,19,10,11,104,97,115,95,109,105,110,105,109,117,109,24,5,32,1,40,8,18,15,10,7,109,105,110,105,109,117,109,24,6,32,1,40,3,18,52,10,14,97,108,108,111,119,101,100,95,118,97,108,117,101,115,24,7,32,1,40,11,50,28,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,34,53,10,13,79,112,68,101,112,114,101,99,97,116,105,111,110,18,15,10,7,118,101,114,115,105,111,110,24,1,32,1,40,5,18,19,10,11,101,120,112,108,97,110,97,116,105,111,110,24,2,32,1,40,9,34,46,10,6,79,112,76,105,115,116,18,36,10,2,111,112,24,1,32,3,40,11,50,24,46,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,79,112,68,101,102,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,111,112,95,100,101,102,46,112,98,46,99,99,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,112,114,101,99,97,116,105,111,110,46,101,120,112,108,97,110,97,116,105,111,110,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,51,79,112,68,101,112,114,101,99,97,116,105,111,110,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,116,121,112,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,51,79,112,68,101,102,95,65,116,116,114,68,101,102,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,115,117,109,109,97,114,121,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,53,79,112,68,101,102,69,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,54,79,112,76,105,115,116,69,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,110,97,109,101,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,116,121,112,101,95,97,116,116,114,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,110,117,109,98,101,114,95,97,116,116,114,0,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,116,121,112,101,95,108,105,115,116,95,97,116,116,114,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,50,79,112,68,101,102,95,65,114,103,68,101,102,69,0,118,101,114,115,105,111,110,115,46,112,114,111,116,111,0,10,14,118,101,114,115,105,111,110,115,46,112,114,111,116,111,18,17,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,34,75,10,10,86,101,114,115,105,111,110,68,101,102,18,16,10,8,112,114,111,100,117,99,101,114,24,1,32,1,40,5,18,20,10,12,109,105,110,95,99,111,110,115,117,109,101,114,24,2,32,1,40,5,18,21,10,13,98,97,100,95,99,111,110,115,117,109,101,114,115,24,3,32,3,40,5,66,47,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,14,86,101,114,115,105,111,110,115,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,118,101,114,115,105,111,110,115,46,112,98,46,99,99,0,78,49,55,111,112,101,110,99,118,95,116,101,110,115,111,114,102,108,111,119,49,48,86,101,114,115,105,111,110,68,101,102,69,0,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,115,99,111,114,101,115,46,115,105,122,101,40,41,0,78,77,83,66,111,120,101,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,110,109,115,46,99,112,112,0,115,99,111,114,101,95,116,104,114,101,115,104,111,108,100,32,62,61,32,48,0,110,109,115,95,116,104,114,101,115,104,111,108,100,32,62,61,32,48,0,101,116,97,32,62,32,48,0,46,71,70,84,84,68,101,116,101,99,116,111,114,0,78,50,99,118,49,50,71,70,84,84,68,101,116,101,99,116,111,114,69,0,78,50,99,118,49,55,71,70,84,84,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,71,70,84,84,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,46,70,97,115,116,70,101,97,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+450564);allocate([117,114,101,68,101,116,101,99,116,111,114,0,78,50,99,118,49,57,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,50,52,70,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,73,110,99,111,114,114,101,99,116,32,116,121,112,101,32,111,102,32,105,110,112,117,116,32,105,109,97,103,101,46,10,0,100,114,97,119,75,101,121,112,111,105,110,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,100,114,97,119,46,99,112,112,0,33,111,117,116,73,109,97,103,101,46,101,109,112,116,121,40,41,0,95,100,114,97,119,75,101,121,112,111,105,110,116,0,109,97,116,99,104,101,115,77,97,115,107,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,115,32,109,97,116,99,104,101,115,49,116,111,50,0,100,114,97,119,77,97,116,99,104,101,115,0,105,49,32,62,61,32,48,32,38,38,32,105,49,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,49,46,115,105,122,101,40,41,41,0,105,50,32,62,61,32,48,32,38,38,32,105,50,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,107,101,121,112,111,105,110,116,115,50,46,115,105,122,101,40,41,41,0,111,117,116,73,109,103,32,104,97,115,32,115,105,122,101,32,108,101,115,115,32,116,104,97,110,32,110,101,101,100,32,116,111,32,100,114,97,119,32,105,109,103,49,32,97,110,100,32,105,109,103,50,32,116,111,103,101,116,104,101,114,0,95,112,114,101,112,97,114,101,73,109,103,65,110,100,68,114,97,119,75,101,121,112,111,105,110,116,115,0,46,75,65,90,69,0,78,50,99,118,52,75,65,90,69,69,0,33,32,105,109,103,49,95,51,50,46,101,109,112,116,121,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,46,99,112,112,0,40,33,100,101,115,99,46,114,111,119,115,32,124,124,32,100,101,115,99,46,99,111,108,115,32,61,61,32,100,101,115,99,114,105,112,116,111,114,83,105,122,101,40,41,41,0,40,33,100,101,115,99,46,114,111,119,115,32,124,124,32,40,100,101,115,99,46,116,121,112,101,40,41,32,61,61,32,100,101,115,99,114,105,112,116,111,114,84,121,112,101,40,41,41,41,0,101,120,116,101,110,100,101,100,0,117,112,114,105,103,104,116,0,78,50,99,118,57,75,65,90,69,95,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,75,65,90,69,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,105,116,101,114,45,62,105,32,60,32,112,111,105,110,116,115,95,32,38,38,32,105,116,101,114,45,62,106,32,60,32,112,111,105,110,116,115,95,0,99,111,109,112,117,116,101,68,101,115,99,114,105,112,116,111,114,115,65,110,100,79,114,79,114,105,101,110,116,97,116,105,111,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,98,114,105,115,107,46,99,112,112,0,115,99,97,108,105,110,103,50,32,33,61,32,48,0,115,109,111,111,116,104,101,100,73,110,116,101,110,115,105,116,121,0,108,97,121,101,114,32,43,32,49,32,60,32,108,97,121,101,114,115,95,0,103,101,116,83,99,111,114,101,77,97,120,65,98,111,118,101,0,108,97,121,101,114,32,62,32,48,0,103,101,116,83,99,111,114,101,77,97,120,66,101,108,111,119,0,33,109,97,116,46,101,109,112,116,121,40,41,0,40,115,114,99,105,109,103,46,99,111,108,115,32,47,32,51,41,32,42,32,50,32,61,61,32,100,115,116,105,109,103,46,99,111,108,115,0,116,119,111,116,104,105,114,100,115,97,109,112,108,101,0,40,115,114,99,105,109,103,46,114,111,119,115,32,47,32,51,41,32,42,32,50,32,61,61,32,100,115,116,105,109,103,46,114,111,119,115,0,115,114,99,105,109,103,46,99,111,108,115,32,47,32,50,32,61,61,32,100,115,116,105,109,103,46,99,111,108,115,0,104,97,108,102,115,97,109,112,108,101,0,115,114,99,105,109,103,46,114,111,119,115,32,47,32,50,32,61,61,32,100,115,116,105,109,103,46,114,111,119,115,0,46,66,82,73,83,75,0,78,50,99,118,49,48,66,82,73,83,75,95,73,109,112,108,69,0,78,50,99,118,53,66,82,73,83,75,69,0,114,97,100,105,117,115,76,105,115,116,46,115,105,122,101,40,41,32,33,61,32,48,32,38,38,32,114,97,100,105,117,115,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,110,117,109,98,101,114,76,105,115,116,46,115,105,122,101,40,41,0,103,101,110,101,114,97,116,101,75,101,114,110,101,108,0,110,111,83,104,111,114,116,80,97,105,114,115,95,32,60,32,105,110,100,83,105,122,101,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,48,66,82,73,83,75,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,46,79,82,66,0,78,50,99,118,51,79,82,66,69,0,102,105,114,115,116,76,101,118,101,108,95,32,62,61,32,48,0,115,101,116,70,105,114,115,116,76,101,118,101,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,111,114,98,46,99,112,112,0,112,97,116,99,104,83,105,122,101,32,62,61,32,50,0,108,101,118,101,108,32,62,61,32,48,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,32,38,38,32,98,108,111,99,107,83,105,122,101,42,98,108,111,99,107,83,105,122,101,32,60,61,32,50,48,52,56,0,72,97,114,114,105,115,82,101,115,112,111,110,115,101,115,0,48,32,60,61,32,108,101,118,101,108,0,119,116,97,95,107,32,61,61,32,50,32,124,124,32,119,116,97,95,107,32,61,61,32,51,32,124,124,32,119,116,97,95,107,32,61,61,32,52,0,87,114,111,110,103,32,119,116,97,95,107,46,32,73,116,32,99,97,110,32,98,101,32,111,110,108,121,32,50,44,32,51,32,111,114,32,52,46,0,99,111,109,112,117,116,101,79,114,98,68,101,115,99,114,105,112,116,111,114,115,0,78,50,99,118,56,79,82,66,95,73,109,112,108,69,0,102,105,114,115,116,76,101,118,101,108,32,62,61,32,48,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,56,79,82,66,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,46,65,75,65,90,69,0,78,50,99,118,53,65,75,65,90,69,69,0,33,32,105,109,97,103,101,46,101,109,112,116,121,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,97,107,97,122,101,46,99,112,112,0,40,100,101,115,99,114,105,112,116,111,114,115,46,101,109,112,116,121,40,41,32,124,124,32,100,101,115,99,114,105,112,116,111,114,115,46,99,111,108,115,40,41,32,61,61,32,100,101,115,99,114,105,112,116,111,114,83,105,122,101,40,41,41,0,40,100,101,115,99,114,105,112,116,111,114,115,46,101,109,112,116,121,40,41,32,124,124,32,40,100,101,115,99,114,105,112,116,111,114,115,46,116,121,112,101,40,41,32,61,61,32,100,101,115,99,114,105,112,116,111,114,84,121,112,101,40,41,41,41,0,100,101,115,99,114,105,112,116,111,114,0,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,0,100,101,115,99,114,105,112,116,111,114,95,115,105,122,101,0,111,99,116,97,118,101,115,0,115,117,98,108,101,118,101,108,115,0,100,105,102,102,117,115,105,118,105,116,121,0,78,50,99,118,49,48,65,75,65,90,69,95,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,48,65,75,65,90,69,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,109,97,107,101,79,102,102,115,101,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,97,115,116,95,115,99,111,114,101,46,99,112,112,0,101,118,111,108,117,116,105,111,110,95,46,115,105,122,101,40,41,32,62,32,48,0,67,114,101,97,116,101,95,78,111,110,108,105,110,101,97,114,95,83,99,97,108,101,95,83,112,97,99,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,47,75,65,90,69,70,101,97,116,117,114,101,115,46,99,112,112,0,78,50,99,118,51,50,77,117,108,116,105,115,99,97,108,101,68,101,114,105,118,97,116,105,118,101,115,75,65,90,69,73,110,118,111,107,101,114,69,0,78,50,99,118,50,51,70,105,110,100,69,120,116,114,101,109,117,109,75,65,90,69,73,110,118,111,107,101,114,69,0,70,101,97,116,117,114,101,95,68,101,115,99,114,105,112,116,105,111,110,0,78,50,99,118,50,51,75,65,90,69,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,110,98,105,116,115,32,60,61,32,115,115,122,32,38,38,32,34,68,101,115,99,114,105,112,116,111,114,32,115,105,122,101,32,99,97,110,39,116,32,98,101,32,98,105,103,103,101,114,32,116,104,97,110,32,102,117,108,108,32,100,101,115,99,114,105,112,116,111,114,32,40,52,56,54,32,61,32,49,54,50,42,51,32,45,32,51,32,99,104,97,110,110,101,108,115,41,34,0,103,101,110,101,114,97,116,101,68,101,115,99,114,105,112,116,111,114,83,117,98,115,97,109,112,108,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,107,97,122,101,47,65,75,65,90,69,70,101,97,116,117,114,101,115,46,99,112,112,0,68,97,116,97,84,121,112,101,60,95,84,112,62,58,58,99,104,97,110,110,101,108,115,32,61,61,32,109,46,99,104,97,110,110,101,108,115,40,41,32,124,124,32,109,46,101,109,112,116,121,40,41,0,101,118,111,108,117,116,105,111,110,46,115,105,122,101,40,41,32,62,32,48,0,99,114,101,97,116,101,95,110,111,110,108,105,110,101,97,114,95,115,99,97,108,101,95,115,112,97,99,101,0,110,98,105,110,115,32,62,32,50,0,99,111,109,112,117,116,101,95,107,99,111,110,116,114,97,115,116,0,33,76,120,95,46,101,109,112,116,121,40,41,0,68,105,102,102,117,115,105,118,105,116,121,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,58,32,37,100,0,99,111,109,112,117,116,101,95,100,105,102,102,117,115,105,118,105,116,121,0,78,50,99,118,50,56,78,111,110,76,105,110,101,97,114,83,99,97,108,97,114,68,105,102,102,117,115,105,111,110,83,116,101,112,69,0,78,50,99,118,50,54,68,101,116,101,114,109,105,110,97,110,116,72,101,115,115,105,97,110,82,101,115,112,111,110,115,101,73,78,83,95,51,77,97,116,69,69,69,0,107,32,60,32,49,48,57,0,103,116,97,98,108,101,0,120,48,32,45,32,54,32,42,32,115,99,97,108,101,32,62,61,32,48,32,38,38,32,120,48,32,43,32,54,32,42,32,115,99,97,108,101,32,60,32,76,120,46,99,111,108,115,0,83,97,109,112,108,101,95,68,101,114,105,118,97,116,105,118,101,95,82,101,115,112,111,110,115,101,95,82,97,100,105,117,115,54,0,121,48,32,45,32,54,32,42,32,115,99,97,108,101,32,62,61,32,48,32,38,38,32,121,48,32,43,32,54,32,42,32,115,99,97,108,101,32,60,32,76,120,46,114,111,119,115,0,99,117,109,91,110,107,101,121,115,93,32,61,61,32,110,0,113,117,97,110,116,105,122,101,100,95,99,111,117,110,116,105,110,103,95,115,111,114,116,0,78,50,99,118,50,54,67,111,109,112,117,116,101,75,101,121,112,111,105,110,116,79,114,105,101,110,116,97,116,105,111,110,69,0,78,50,99,118,50,50,70,105,110,100,75,101,121,112,111,105,110,116,115,83,97,109,101,83,99,97,108,101,69,0,48,32,60,61,32,107,112,116,115,91,105,93,46,99,108,97,115,115,95,105,100,32,38,38,32,107,112,116,115,91,105,93,46,99,108,97,115,115,95,105,100,32,60,32,115,116,97,116,105,99,95,99,97,115,116,60,105,110,116,62,40,101,118,111,108,117,116,105,111,110,95,46,115,105,122,101,40,41,41,0,67,111,109,112,117,116,101,95,68,101,115,99,114,105,112,116,111,114,115,0,99,104,97,110,110,101,108,115,32,60,61,32,109,97,120,95,99,104,97,110,110,101,108,115,0,71,101,116,95,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,0,40,112,97,116,116,101,114,110,95,115,105,122,101,32,38,32,49,41,32,61,61,32,48,0,99,111,111,114,100,115,91,48,93,32,62,61,32,48,32,38,38,32,99,111,111,114,100,115,91,48,93,32,60,32,51,0,100,105,118,85,112,40,100,101,115,99,114,105,112,116,111,114,66,105,116,115,95,46,114,111,119,115,44,32,56,41,32,61,61,32,100,101,115,99,95,115,105,122,101,0,78,50,99,118,51,48,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,95,73,110,118,111,107,101,114,69,0,111,112,116,105,111,110,115,95,45,62,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,32,60,61,32,109,97,120,95,99,104,97,110,110,101,108,115,0,71,101,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,0,100,112,111,115,32,61,61,32,52,56,54,0,100,105,118,85,112,40,100,112,111,115,44,32,56,41,32,61,61,32,100,101,115,99,95,115,105,122,101,0,115,105,122,101,32,61,61,32,76,120,46,115,105,122,101,40,41,0,77,76,68,66,95,70,105,108,108,95,86,97,108,117,101,115,0,115,105,122,101,32,61,61,32,76,121,46,115,105,122,101,40,41,0,78,50,99,118,50,56,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,71,101,116,95,85,112,114,105,103,104,116,95,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,0,78,50,99,118,51,56,85,112,114,105,103,104,116,95,77,76,68,66,95,68,101,115,99,114,105,112,116,111,114,95,83,117,98,115,101,116,95,73,110,118,111,107,101,114,69,0,111,112,116,105,111,110,115,46,100,101,115,99,114,105,112,116,111,114,95,99,104,97,110,110,101,108,115,32,60,61,32,109,97,120,95,99,104,97,110,110,101,108,115,0,71,101,116,95,85,112,114,105,103,104,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,0,100,99,111,117,110,116,49,32,60,61,32,100,101,115,99,95,115,105,122,101,42,56,0,100,105,118,85,112,40,100,99,111,117,110,116,49,44,32,56,41,32,61,61,32,100,101,115,99,95,115,105,122,101,0,78,50,99,118,51,54,85,112,114,105,103,104,116,95,77,76,68,66,95,70,117,108,108,95,68,101,115,99,114,105,112,116,111,114,95,73,110,118,111,107,101,114,69,0,100,101,115,99,95,115,105,122,101,32,61,61,32,100,115,105,122,101,0,71,101,116,95,77,83,85,82,70,95,68,101,115,99,114,105,112,116,111,114,95,54,52,0,78,50,99,118,50,55,77,83,85,82,70,95,68,101,115,99,114,105,112,116,111,114,95,54,52,95,73,110,118,111,107,101,114,69,0,71,101,116,95,77,83,85,82,70,95,85,112,114,105,103,104,116,95,68,101,115,99,114,105,112,116,111,114,95,54,52,0,78,50,99,118,51,53,77,83,85,82,70,95,85,112,114,105,103,104,116,95,68,101,115,99,114,105,112,116,111,114,95,54,52,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,51,78,108,100,95,83,116,101,112,95,83,99,97,108,97,114,95,73,110,118,111,107,101,114,69,0,46,77,83,69,82,0,78,50,99,118,52,77,83,69,82,69,0,73,110,112,117,116,32,105,109,97,103,101,32,105,115,32,116,111,111,32,115,109,97,108,108,46,32,69,120,112,101,99,116,101,100,32,97,116,32,108,101,97,115,116,32,51,120,51,0,100,101,116,101,99,116,82,101,103,105,111,110,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,109,115,101,114,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,52,0,112,116,114,111,102,115,32,33,61,32,48,0,112,97,115,115,0,104,32,33,61,32,78,85,76,76,0,103,114,111,119,72,105,115,116,111,114,121,0,78,50,99,118,57,77,83,69,82,95,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,77,83,69,82,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,50,48,68,101,115,99,114,105,112,116,111,114,67,111,108,108,101,99,116,105,111,110,69,0,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,85,77,97,116,86,101,99,116,111,114,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,40,41,32,124,124,32,95,100,101,115,99,114,105,112,116,111,114,115,46,105,115,77,97,116,86,101,99,116,111,114,40,41,0,97,100,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,109,97,116,99,104,101,114,115,46,99,112,112,0,78,50,99,118,49,55,68,101,115,99,114,105,112,116,111,114,77,97,116,99,104,101,114,69,0,95,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,46,116,121,112,101,40,41,32,61,61,32,116,114,97,105,110,68,101,115,99,84,121,112,101,0,114,97,100,105,117,115,77,97,116,99,104,73,109,112,108,0,107,110,110,77,97,116,99,104,73,109,112,108,0,40,105,110,116,54,52,41,105,109,103,67,111,117,110,116,42,73,77,71,73,68,88,95,79,78,69,32,60,32,73,78,84,95,77,65,88,0,116,114,97,105,110,68,101,115,99,67,111,108,108,101,99,116,105,111,110,91,105,73,100,120,93,46,114,111,119,115,32,60,32,73,77,71,73,68,88,95,79,78,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,57,66,70,77,97,116,99,104,101,114,69,0,40,103,108,111,98,97,108,68,101,115,99,73,100,120,62,61,48,41,32,38,38,32,40,103,108,111,98,97,108,68,101,115,99,73,100,120,32,60,32,115,105,122,101,40,41,41,0,103,101,116,76,111,99,97,108,73,100,120,0,100,101,101,112,32,99,108,111,110,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,44,32,98,101,99,97,117,115,101,32,70,108,97,110,110,58,58,73,110,100,101,120,32,104,97,115,32,110,111,116,32,99,111,112,121,32,99,111,110,115,116,114,117,99,116,111,114,32,111,114,32,99,108,111,110,101,32,109,101,116,104,111,100,32,0,99,108,111,110,101,0,95,105,110,100,101,120,80,97,114,97,109,115,0,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,0,95,115,101,97,114,99,104,80,97,114,97,109,115,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,55,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,116,114,97,105,110,68,101,115,99,67,111,108,108,101,99,116,105,111,110,46,115,105,122,101,40,41,32,61,61,32,48,0,116,114,97,105,110,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,53,102,108,97,110,110,53,73,110,100,101,120,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,105,109,97,103,101,67,111,117,110,116,32,62,32,48,0,115,101,116,0,100,105,109,32,62,32,48,0,100,101,115,99,114,105,112,116,111,114,115,91,105,93,46,99,111,108,115,32,61,61,32,100,105,109,32,38,38,32,100,101,115,99,114,105,112,116,111,114,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,105,110,100,101,120,80,97,114,97,109,115,0,105,112,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,83,69,81,0,105,112,91,105,93,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,77,65,80,0,116,121,112,101,0,115,101,97,114,99,104,80,97,114,97,109,115,0,115,112,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,83,69,81,0,115,112,91,105,93,46,116,121,112,101,40,41,32,61,61,32,70,105,108,101,78,111,100,101,58,58,77,65,80,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,58,58,114,101,97,100,40,99,111,110,115,116,32,99,118,58,58,70,105,108,101,78,111,100,101,32,38,41,0,40,105,110,116,41,116,121,112,101,0,40,105,110,116,41,76,65,83,84,95,86,65,76,85,69,95,70,76,65,78,78,95,73,78,68,69,88,95,84,89,80,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,53,102,108,97,110,110,49,50,83,101,97,114,99,104,80,97,114,97,109,115,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,53,102,108,97,110,110,49,49,73,110,100,101,120,80,97,114,97,109,115,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,49,55,70,108,97,110,110,66,97,115,101,100,77,97,116,99,104,101,114,69,0,107,110,110,77,97,116,99,104,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,49,0,99,111,110,118,101,114,116,77,97,116,99,104,101,115,0,109,97,115,107,115,46,115,105,122,101,40,41,32,61,61,32,105,109,97,103,101,67,111,117,110,116,0,99,104,101,99,107,77,97,115,107,115,0,109,97,115,107,115,91,105,93,46,114,111,119,115,32,61,61,32,113,117,101,114,121,68,101,115,99,114,105,112,116,111,114,115,67,111,117,110,116,32,38,38,32,109,97,115,107,115,91,105,93,46,99,111,108,115,32,61,61,32,114,111,119,115,32,38,38,32,109,97,115,107,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,49,0,107,110,110,32,62,32,48,0,107,110,110,77,97,116,99,104,0,109,97,120,68,105,115,116,97,110,99,101,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,102,108,111,97,116,62,58,58,101,112,115,105,108,111,110,40,41,0,114,97,100,105,117,115,77,97,116,99,104,0,70,108,97,110,110,66,97,115,101,100,0,66,114,117,116,101,70,111,114,99,101,0,66,114,117,116,101,70,111,114,99,101,45,83,76,50,0,66,114,117,116,101,70,111,114,99,101,45,76,49,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,76,85,84,0,66,114,117,116,101,70,111,114,99,101,45,72,97,109,109,105,110,103,40,50,41,0,85,110,107,110,111,119,110,32,109,97,116,99,104,101,114,32,110,97,109,101,0,99,114,101,97,116,101,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,53,102,108,97,110,110,49,55,75,68,84,114,101,101,73,110,100,101,120,80,97,114,97,109,115,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,46,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,0,78,50,99,118,50,48,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,69,0,78,50,99,118,50,53,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,50,53,65,103,97,115,116,70,101,97,116,117,114,101,68,101,116,101,99,116,111,114,95,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,100,101,116,101,99,116,65,110,100,67,111,109,112,117,116,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,102,101,97,116,117,114,101,50,100,46,99,112,112,0,107,101,121,112,111,105,110,116,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,105,109,97,103,101,115,0,99,111,109,112,117,116,101,0,100,101,115,99,114,105,112,116,111,114,115,32,109,117,115,116,32,98,101,32,118,101,99,116,111,114,60,77,97,116,62,32,111,114,32,118,101,99,116,111,114,60,85,77,97,116,62,0,109,97,115,107,115,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,105,109,97,103,101,115,0,70,101,97,116,117,114,101,50,68,0,78,50,99,118,57,70,101,97,116,117,114,101,50,68,69,0,112,105,120,101,108,32,38,38,32,111,102,102,115,101,116,115,0,109,97,107,101,65,103,97,115,116,79,102,102,115,101,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,101,97,116,117,114,101,115,50,100,47,115,114,99,47,97,103,97,115,116,95,115,99,111,114,101,46,99,112,112,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,57,83,99,97,108,101,68,97,116,97,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,78,50,99,118,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,69,0,115,113,115,117,109,46,117,32,61,61,32,117,32,38,38,32,115,113,115,117,109,46,115,105,122,101,40,41,32,61,61,32,115,46,115,122,105,32,38,38,32,115,113,115,117,109,46,116,121,112,101,40,41,61,61,67,86,95,51,50,83,0,99,111,109,112,117,116,101,67,104,97,110,110,101,108,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,99,112,112,0,48,32,60,61,32,115,99,97,108,101,73,100,120,32,38,38,32,115,99,97,108,101,73,100,120,32,60,32,40,105,110,116,41,115,99,97,108,101,68,97,116,97,45,62,115,105,122,101,40,41,0,103,101,116,83,99,97,108,101,68,97,116,97,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,104,112,112,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,110,32,62,32,48,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,0,115,101,116,87,105,110,100,111,119,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,83,95,54,118,101,99,116,111,114,73,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,52,95,69,69,69,69,78,83,53,95,73,83,55,95,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,114,101,99,116,0,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,95,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,0,110,111,100,101,115,91,114,111,111,116,93,91,80,65,82,69,78,84,93,32,60,32,48,0,112,97,114,116,105,116,105,111,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,111,112,101,114,97,116,105,111,110,115,46,104,112,112,0,33,99,97,115,99,97,100,101,46,100,97,116,97,46,115,116,117,109,112,115,46,101,109,112,116,121,40,41,0,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,83,116,117,109,112,0,112,114,101,100,105,99,116,79,114,100,101,114,101,100,83,116,117,109,112,0,78,50,99,118,50,52,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,110,118,111,107,101,114,69,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,0,102,101,97,116,117,114,101,115,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,50,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,112,111,105,110,116,101,114,73,80,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,100,101,102,97,117,108,116,95,100,101,108,101,116,101,73,83,50,95,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,72,65,65,82,0,76,66,80,0,72,79,71,0,72,79,71,32,99,97,115,99,97,100,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,51,46,48,0,111,114,105,103,87,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,111,114,105,103,87,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,48,0,78,50,99,118,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,0,78,50,99,118,50,49,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,97,45,62,115,105,122,101,40,41,32,61,61,32,110,0,99,108,105,112,79,98,106,101,99,116,115,0,98,45,62,115,105,122,101,40,41,32,61,61,32,110,0,78,50,99,118,56,72,79,71,67,97,99,104,101,69,0,78,50,99,118,49,52,72,79,71,67,111,110,102,73,110,118,111,107,101,114,69,0,112,116,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,66,108,111,99,107,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,111,103,46,99,112,112,0,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,32,37,32,99,101,108,108,83,105,122,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,32,37,32,99,101,108,108,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,40,119,105,110,83,105,122,101,46,119,105,100,116,104,32,45,32,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,40,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,45,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,33,105,109,103,46,101,109,112,116,121,40,41,0,99,111,109,112,117,116,101,71,114,97,100,105,101,110,116,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,32,124,124,32,105,109,103,46,116,121,112,101,40,41,32,61,61,32,67,86,95,56,85,67,51,0,116,111,116,97,108,40,41,32,61,61,32,48,32,124,124,32,100,97,116,97,32,33,61,32,78,85,76,76,0,77,97,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,109,97,116,46,105,110,108,46,104,112,112,0,40,117,110,115,105,103,110,101,100,41,104,105,100,120,32,60,32,40,117,110,115,105,103,110,101,100,41,110,98,105,110,115,0,114,101,99,116,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,115,105,122,101,40,41,0,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,0,78,50,99,118,49,48,72,79,71,73,110,118,111,107,101,114,69,0,112,116,48,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,48,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,100,101,116,101,99,116,0,123,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,119,105,110,83,105,122,101,0,98,108,111,99,107,83,105,122,101,0,98,108,111,99,107,83,116,114,105,100,101,0,110,98,105,110,115,0,100,101,114,105,118,65,112,101,114,116,117,114,101,0,104,105,115,116,111,103,114,97,109,78,111,114,109,84,121,112,101,0,76,50,72,121,115,84,104,114,101,115,104,111,108,100,0,103,97,109,109,97,67,111,114,114,101,99,116,105,111,110,0,110,108,101,118,101,108,115,0,115,105,103,110,101,100,71,114,97,100,105,101,110,116,0,83,86,77,68,101,116,101,99,116,111,114,0,33,111,98,106,91,34,119,105,110,83,105,122,101,34,93,46,101,109,112,116,121,40,41,0,99,101,108,108,83,105,122,101,0,119,105,110,83,105,103,109,97,0,99,104,101,99,107,68,101,116,101,99,116,111,114,83,105,122,101,40,41,0,115,101,116,83,86,77,68,101,116,101,99,116,111,114,0,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,115,105,122,101,0,115,116,97,103,101,115,0,115,116,97,103,101,95,116,104,114,101,115,104,111,108,100,0,102,101,97,116,117,114,101,0,116,105,108,116,101,100,0,114,101,99,116,115,0,116,104,114,101,115,104,111,108,100,0,108,101,102,116,95,118,97,108,0,108,101,102,116,95,110,111,100,101,0,114,105,103,104,116,95,118,97,108,0,114,105,103,104,116,95,110,111,100,101,0,99,97,115,99,97,100,101,0,123,58,111,112,101,110,99,118,45,99,97,115,99,97,100,101,45,99,108,97,115,115,105,102,105,101,114,0,115,116,97,103,101,84,121,112,101,0,66,79,79,83,84,0,102,101,97,116,117,114,101,84,121,112,101,0,104,101,105,103,104,116,0,119,105,100,116,104,0,115,116,97,103,101,80,97,114,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+460804);allocate([109,115,0,109,97,120,87,101,97,107,67,111,117,110,116,0,102,101,97,116,117,114,101,80,97,114,97,109,115,0,109,97,120,67,97,116,67,111,117,110,116,0,115,116,97,103,101,84,104,114,101,115,104,111,108,100,0,119,101,97,107,67,108,97,115,115,105,102,105,101,114,115,0,105,110,116,101,114,110,97,108,78,111,100,101,115,0,108,101,97,102,86,97,108,117,101,115,0,33,115,114,99,46,101,109,112,116,121,40,41,0,102,105,110,100,84,114,97,110,115,102,111,114,109,69,67,67,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,101,99,99,46,99,112,112,0,33,100,115,116,46,101,109,112,116,121,40,41,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,100,97,116,97,32,116,121,112,101,0,73,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,56,117,67,49,32,111,114,32,51,50,102,67,49,32,116,121,112,101,0,119,97,114,112,77,97,116,114,105,120,32,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,109,97,116,114,105,120,0,109,97,112,46,99,111,108,115,32,61,61,32,51,0,109,97,112,46,114,111,119,115,32,61,61,32,50,32,124,124,32,109,97,112,46,114,111,119,115,32,61,61,51,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,109,97,112,46,114,111,119,115,32,61,61,51,0,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,67,79,85,78,84,32,124,124,32,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,69,80,83,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,97,102,102,105,110,101,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,52,46,115,105,122,101,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,100,115,116,46,114,111,119,115,0,100,115,116,46,99,111,108,115,32,61,61,32,40,54,42,115,114,99,49,46,99,111,108,115,41,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,104,111,109,111,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,56,41,0,115,114,99,53,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,116,114,97,110,115,108,97,116,105,111,110,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,50,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,101,117,99,108,105,100,101,97,110,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,52,46,115,105,122,101,40,41,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,51,41,0,78,97,78,32,101,110,99,111,117,110,116,101,114,101,100,46,0,84,104,101,32,97,108,103,111,114,105,116,104,109,32,115,116,111,112,112,101,100,32,98,101,102,111,114,101,32,105,116,115,32,99,111,110,118,101,114,103,101,110,99,101,46,32,84,104,101,32,99,111,114,114,101,108,97,116,105,111,110,32,105,115,32,103,111,105,110,103,32,116,111,32,98,101,32,109,105,110,105,109,105,122,101,100,46,32,73,109,97,103,101,115,32,109,97,121,32,98,101,32,117,110,99,111,114,114,101,108,97,116,101,100,32,111,114,32,110,111,110,45,111,118,101,114,108,97,112,112,101,100,0,109,97,112,95,109,97,116,114,105,120,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,117,112,100,97,116,101,95,119,97,114,112,105,110,103,95,109,97,116,114,105,120,95,69,67,67,0,117,112,100,97,116,101,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,51,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,56,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,54,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,51,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,50,0,117,112,100,97,116,101,46,99,111,108,115,32,61,61,32,49,0,109,97,112,95,109,97,116,114,105,120,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,117,112,100,97,116,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,115,114,99,50,46,114,111,119,115,0,112,114,111,106,101,99,116,95,111,110,116,111,95,106,97,99,111,98,105,97,110,95,69,67,67,0,40,115,114,99,49,46,99,111,108,115,32,37,32,115,114,99,50,46,99,111,108,115,41,32,61,61,32,48,0,100,115,116,46,99,111,108,115,32,61,61,32,100,115,116,46,114,111,119,115,0,99,110,32,61,61,32,49,0,109,101,97,110,83,104,105,102,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,99,97,109,115,104,105,102,116,46,99,112,112,0,73,110,112,117,116,32,119,105,110,100,111,119,32,104,97,115,32,110,111,110,45,112,111,115,105,116,105,118,101,32,115,105,122,101,115,0,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,56,85,67,49,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,56,85,67,51,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,51,50,70,67,49,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,67,86,95,51,50,70,67,51,0,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,98,103,102,103,95,103,97,117,115,115,109,105,120,50,46,99,112,112,0,108,101,97,114,110,105,110,103,82,97,116,101,32,62,61,32,48,0,97,112,112,108,121,0,78,50,99,118,49,49,77,79,71,50,73,110,118,111,107,101,114,69,0,110,99,104,97,110,110,101,108,115,32,60,61,32,67,86,95,67,78,95,77,65,88,0,110,109,105,120,116,117,114,101,115,32,60,61,32,50,53,53,0,110,97,109,101,0,40,83,116,114,105,110,103,41,102,110,91,34,110,97,109,101,34,93,32,61,61,32,110,97,109,101,95,0,114,101,97,100,0,104,105,115,116,111,114,121,0,110,109,105,120,116,117,114,101,115,0,98,97,99,107,103,114,111,117,110,100,82,97,116,105,111,0,118,97,114,84,104,114,101,115,104,111,108,100,0,118,97,114,84,104,114,101,115,104,111,108,100,71,101,110,0,118,97,114,73,110,105,116,0,118,97,114,77,105,110,0,118,97,114,77,97,120,0,99,111,109,112,108,101,120,105,116,121,82,101,100,117,99,116,105,111,110,84,104,114,101,115,104,111,108,100,0,100,101,116,101,99,116,83,104,97,100,111,119,115,0,115,104,97,100,111,119,86,97,108,117,101,0,115,104,97,100,111,119,84,104,114,101,115,104,111,108,100,0,78,111,32,101,108,101,109,101,110,116,32,110,97,109,101,32,104,97,115,32,98,101,101,110,32,103,105,118,101,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,101,114,115,105,115,116,101,110,99,101,46,104,112,112,0,78,50,99,118,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,46,77,79,71,50,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,115,116,97,116,117,115,32,33,61,32,78,85,76,76,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,108,107,112,121,114,97,109,105,100,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,54,76,75,84,114,97,99,107,101,114,73,110,118,111,107,101,114,69,0,105,109,103,46,100,101,112,116,104,40,41,32,61,61,32,67,86,95,56,85,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,98,117,105,108,100,79,112,116,105,99,97,108,70,108,111,119,80,121,114,97,109,105,100,0,100,101,112,116,104,32,61,61,32,67,86,95,56,85,0,99,97,108,99,83,104,97,114,114,68,101,114,105,118,0,109,97,120,76,101,118,101,108,32,62,61,32,48,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,40,110,112,111,105,110,116,115,32,61,32,112,114,101,118,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,44,32,116,114,117,101,41,41,32,62,61,32,48,0,110,101,120,116,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,67,86,95,51,50,70,44,32,116,114,117,101,41,32,61,61,32,110,112,111,105,110,116,115,0,115,116,97,116,117,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,101,114,114,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,101,118,101,108,115,49,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,108,101,118,101,108,115,50,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,115,105,122,101,40,41,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,116,121,112,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,116,121,112,101,40,41,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,50,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,55,83,112,97,114,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,112,114,101,118,48,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,48,46,115,105,122,101,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,110,101,120,116,48,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,112,121,114,83,99,97,108,101,95,32,60,32,49,0,99,97,108,99,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,111,112,116,102,108,111,119,103,102,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,70,67,49,0,70,97,114,110,101,98,97,99,107,80,111,108,121,69,120,112,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,48,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,54,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,78,83,116,51,95,95,50,50,48,95,95,115,104,97,114,101,100,95,112,116,114,95,101,109,112,108,97,99,101,73,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,97,114,101,110,97,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,105,110,95,98,121,116,101,115,41,32,60,61,32,40,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,115,105,122,101,95,116,62,58,58,109,97,120,40,41,32,45,32,107,72,101,97,100,101,114,83,105,122,101,41,58,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,103,101,110,101,114,97,116,101,100,95,109,101,115,115,97,103,101,95,117,116,105,108,46,99,99,0,78,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,102,105,101,108,100,32,110,117,109,98,101,114,32,0,32,119,105,116,104,32,116,121,112,101,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,99,111,100,101,100,95,115,116,114,101,97,109,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,117,102,102,101,114,95,115,105,122,101,41,32,62,61,32,40,48,41,58,32,0,65,32,112,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,119,97,115,32,114,101,106,101,99,116,101,100,32,98,101,99,97,117,115,101,32,105,116,32,119,97,115,32,116,111,111,32,98,105,103,32,40,109,111,114,101,32,116,104,97,110,32,0,32,98,121,116,101,115,41,46,32,32,84,111,32,105,110,99,114,101,97,115,101,32,116,104,101,32,108,105,109,105,116,32,40,111,114,32,116,111,32,100,105,115,97,98,108,101,32,116,104,101,115,101,32,119,97,114,110,105,110,103,115,41,44,32,115,101,101,32,67,111,100,101,100,73,110,112,117,116,83,116,114,101,97,109,58,58,83,101,116,84,111,116,97,108,66,121,116,101,115,76,105,109,105,116,40,41,32,105,110,32,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,99,111,100,101,100,95,115,116,114,101,97,109,46,104,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,122,101,114,111,95,99,111,112,121,95,115,116,114,101,97,109,95,105,109,112,108,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,62,61,32,40,48,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,108,97,115,116,95,114,101,116,117,114,110,101,100,95,115,105,122,101,95,41,32,62,32,40,48,41,58,32,0,66,97,99,107,85,112,40,41,32,99,97,110,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,97,102,116,101,114,32,97,32,115,117,99,99,101,115,115,102,117,108,32,78,101,120,116,40,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,108,97,115,116,95,114,101,116,117,114,110,101,100,95,115,105,122,101,95,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,54,65,114,114,97,121,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,57,90,101,114,111,67,111,112,121,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,55,65,114,114,97,121,79,117,116,112,117,116,83,116,114,101,97,109,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,97,114,103,101,116,95,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,116,97,114,103,101,116,95,45,62,115,105,122,101,40,41,41,58,32,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,32,108,97,114,103,101,114,32,116,104,97,110,32,107,105,110,116,51,50,109,97,120,32,102,111,114,32,0,83,116,114,105,110,103,79,117,116,112,117,116,83,116,114,101,97,109,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,83,116,114,105,110,103,79,117,116,112,117,116,83,116,114,101,97,109,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,98,97,99,107,117,112,95,98,121,116,101,115,95,32,61,61,32,48,32,38,38,32,98,117,102,102,101,114,95,46,103,101,116,40,41,32,33,61,32,78,85,76,76,58,32,0,32,66,97,99,107,85,112,40,41,32,99,97,110,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,97,102,116,101,114,32,78,101,120,116,40,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,98,117,102,102,101,114,95,117,115,101,100,95,41,58,32,0,32,67,97,110,39,116,32,98,97,99,107,32,117,112,32,111,118,101,114,32,109,111,114,101,32,98,121,116,101,115,32,116,104,97,110,32,119,101,114,101,32,114,101,116,117,114,110,101,100,32,98,121,32,116,104,101,32,108,97,115,116,32,99,97,108,108,32,116,111,32,78,101,120,116,40,41,46,0,32,80,97,114,97,109,101,116,101,114,32,116,111,32,66,97,99,107,85,112,40,41,32,99,97,110,39,116,32,98,101,32,110,101,103,97,116,105,118,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,97,99,107,117,112,95,98,121,116,101,115,95,41,32,61,61,32,40,48,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,50,53,67,111,112,121,105,110,103,73,110,112,117,116,83,116,114,101,97,109,65,100,97,112,116,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,67,111,112,121,105,110,103,73,110,112,117,116,83,116,114,101,97,109,69,0,1,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,101,115,115,97,103,101,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,99,111,100,101,100,95,111,117,116,46,72,97,100,69,114,114,111,114,40,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,77,101,115,115,97,103,101,76,105,116,101,69,0,67,97,110,39,116,32,0,112,97,114,115,101,0,32,109,101,115,115,97,103,101,32,111,102,32,116,121,112,101,32,34,0,34,32,98,101,99,97,117,115,101,32,105,116,32,105,115,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,69,120,99,101,101,100,101,100,32,109,97,120,105,109,117,109,32,112,114,111,116,111,98,117,102,32,115,105,122,101,32,111,102,32,50,71,66,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,121,116,101,95,115,105,122,101,95,98,101,102,111,114,101,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,32,61,61,32,40,98,121,116,101,95,115,105,122,101,95,97,102,116,101,114,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,58,32,0,32,119,97,115,32,109,111,100,105,102,105,101,100,32,99,111,110,99,117,114,114,101,110,116,108,121,32,100,117,114,105,110,103,32,115,101,114,105,97,108,105,122,97,116,105,111,110,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,121,116,101,115,95,112,114,111,100,117,99,101,100,95,98,121,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,32,61,61,32,40,98,121,116,101,95,115,105,122,101,95,98,101,102,111,114,101,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,58,32,0,66,121,116,101,32,115,105,122,101,32,99,97,108,99,117,108,97,116,105,111,110,32,97,110,100,32,115,101,114,105,97,108,105,122,97,116,105,111,110,32,119,101,114,101,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,32,84,104,105,115,32,109,97,121,32,105,110,100,105,99,97,116,101,32,97,32,98,117,103,32,105,110,32,112,114,111,116,111,99,111,108,32,98,117,102,102,101,114,115,32,111,114,32,105,116,32,109,97,121,32,98,101,32,99,97,117,115,101,100,32,98,121,32,99,111,110,99,117,114,114,101,110,116,32,109,111,100,105,102,105,99,97,116,105,111,110,32,111,102,32,0,84,104,105,115,32,115,104,111,117,108,100,110,39,116,32,98,101,32,99,97,108,108,101,100,32,105,102,32,97,108,108,32,116,104,101,32,115,105,122,101,115,32,97,114,101,32,101,113,117,97,108,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,112,101,97,116,101,100,95,102,105,101,108,100,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,110,101,119,95,115,105,122,101,41,32,60,61,32,40,40,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,115,105,122,101,95,116,62,58,58,109,97,120,40,41,32,45,32,107,82,101,112,72,101,97,100,101,114,83,105,122,101,41,32,47,32,115,105,122,101,111,102,40,111,108,100,95,114,101,112,45,62,101,108,101,109,101,110,116,115,91,48,93,41,41,58,32,0,82,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,116,111,111,32,108,97,114,103,101,32,116,111,32,102,105,116,32,105,110,116,111,32,115,105,122,101,95,116,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,70,97,116,97,108,69,120,99,101,112,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,55,67,108,111,115,117,114,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,48,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,99,111,109,109,111,110,46,99,99,0,84,104,105,115,32,112,114,111,103,114,97,109,32,114,101,113,117,105,114,101,115,32,118,101,114,115,105,111,110,32,0,37,100,46,37,100,46,37,100,0,32,111,102,32,116,104,101,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,117,110,116,105,109,101,32,108,105,98,114,97,114,121,44,32,98,117,116,32,116,104,101,32,105,110,115,116,97,108,108,101,100,32,118,101,114,115,105,111,110,32,105,115,32,0,46,32,32,80,108,101,97,115,101,32,117,112,100,97,116,101,32,121,111,117,114,32,108,105,98,114,97,114,121,46,32,32,73,102,32,121,111,117,32,99,111,109,112,105,108,101,100,32,116,104,101,32,112,114,111,103,114,97,109,32,121,111,117,114,115,101,108,102,44,32,109,97,107,101,32,115,117,114,101,32,116,104,97,116,32,121,111,117,114,32,104,101,97,100,101,114,115,32,97,114,101,32,102,114,111,109,32,116,104,101,32,115,97,109,101,32,118,101,114,115,105,111,110,32,111,102,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,115,32,97,115,32,121,111,117,114,32,108,105,110,107,45,116,105,109,101,32,108,105,98,114,97,114,121,46,32,32,40,86,101,114,115,105,111,110,32,118,101,114,105,102,105,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,34,0,34,46,41,0,84,104,105,115,32,112,114,111,103,114,97,109,32,119,97,115,32,99,111,109,112,105,108,101,100,32,97,103,97,105,110,115,116,32,118,101,114,115,105,111,110,32,0,32,111,102,32,116,104,101,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,117,110,116,105,109,101,32,108,105,98,114,97,114,121,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,99,111,109,112,97,116,105,98,108,101,32,119,105,116,104,32,116,104,101,32,105,110,115,116,97,108,108,101,100,32,118,101,114,115,105,111,110,32,40,0,41,46,32,32,67,111,110,116,97,99,116,32,116,104,101,32,112,114,111,103,114,97,109,32,97,117,116,104,111,114,32,102,111,114,32,97,110,32,117,112,100,97,116,101,46,32,32,73,102,32,121,111,117,32,99,111,109,112,105,108,101,100,32,116,104,101,32,112,114,111,103,114,97,109,32,121,111,117,114,115,101,108,102,44,32,109,97,107,101,32,115,117,114,101,32,116,104,97,116,32,121,111,117,114,32,104,101,97,100,101,114,115,32,97,114,101,32,102,114,111,109,32,116,104,101,32,115,97,109,101,32,118,101,114,115,105,111,110,32,111,102,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,115,32,97,115,32,121,111,117,114,32,108,105,110,107,45,116,105,109,101,32,108,105,98,114,97,114,121,46,32,32,40,86,101,114,115,105,111,110,32,118,101,114,105,102,105,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,34,0,91,108,105,98,112,114,111,116,111,98,117,102,32,37,115,32,37,115,58,37,100,93,32,37,115,10,0,112,116,104,114,101,97,100,95,109,117,116,101,120,95,117,110,108,111,99,107,58,32,0,112,116,104,114,101,97,100,95,109,117,116,101,120,95,108,111,99,107,58,32,0,37,117,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,70,105,101,108,100,83,107,105,112,112,101,114,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,119,105,114,101,95,102,111,114,109,97,116,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,118,97,108,117,101,46,115,105,122,101,40,41,41,32,60,61,32,40,107,105,110,116,51,50,109,97,120,41,58,32,0,115,101,114,105,97,108,105,122,105,110,103,0,112,97,114,115,105,110,103,0,32,39,37,115,39,0,83,116,114,105,110,103,32,102,105,101,108,100,0,32,99,111,110,116,97,105,110,115,32,105,110,118,97,108,105,100,32,0,85,84,70,45,56,32,100,97,116,97,32,119,104,101,110,32,0,32,97,32,112,114,111,116,111,99,111,108,32,0,98,117,102,102,101,114,46,32,85,115,101,32,116,104,101,32,39,98,121,116,101,115,39,32,116,121,112,101,32,105,102,32,121,111,117,32,105,110,116,101,110,100,32,116,111,32,115,101,110,100,32,114,97,119,32,0,98,121,116,101,115,46,32,0,105,110,116,54,52,0,117,105,110,116,54,52,0,105,110,116,51,50,0,102,105,120,101,100,54,52,0,102,105,120,101,100,51,50,0,115,116,114,105,110,103,0,103,114,111,117,112,0,109,101,115,115,97,103,101,0,98,121,116,101,115,0,117,105,110,116,51,50,0,101,110,117,109,0,115,102,105,120,101,100,51,50,0,115,102,105,120,101,100,54,52,0,115,105,110,116,51,50,0,115,105,110,116,54,52,0,111,112,116,105,111,110,97,108,0,114,101,113,117,105,114,101,100,0,114,101,112,101,97,116,101,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,99,99,0,117,110,107,110,111,119,110,0,112,114,111,116,111,51,0,112,114,111,116,111,50,0,77,105,115,115,105,110,103,32,102,105,101,108,100,58,32,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,110,97,109,101,46,0,85,110,114,101,99,111,103,110,105,122,101,100,32,115,121,110,116,97,120,58,32,0,65,32,102,105,108,101,32,119,105,116,104,32,116,104,105,115,32,110,97,109,101,32,105,115,32,97,108,114,101,97,100,121,32,105,110,32,116,104,101,32,112,111,111,108,46,0,73,110,118,97,108,105,100,32,112,117,98,108,105,99,32,100,101,112,101,110,100,101,110,99,121,32,105,110,100,101,120,46,0,73,110,118,97,108,105,100,32,119,101,97,107,32,100,101,112,101,110,100,101,110,99,121,32,105,110,100,101,120,46,0,46,100,117,109,109,121,0,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,115,95,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,78,111,32,102,105,101,108,100,32,110,97,109,101,100,32,34,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,34,32,105,110,32,116,104,101,32,79,112,116,105,111,110,115,32,112,114,111,116,111,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,114,105,103,105,110,97,108,95,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,115,95,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,45,62,65,112,112,101,110,100,80,97,114,116,105,97,108,84,111,83,116,114,105,110,103,40,38,98,117,102,41,58,32,0,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,115,101,114,105,97,108,105,122,101,100,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,45,62,80,97,114,115,101,80,97,114,116,105,97,108,70,114,111,109,83,116,114,105,110,103,40,98,117,102,41,58,32,0,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,115,101,114,105,97,108,105,122,101,100,32,105,116,115,101,108,102,32,105,110,32,105,110,118,97,108,105,100,32,102,97,115,104,105,111,110,46,0,79,112,116,105,111,110,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,102,117,108,108,121,32,112,97,114,115,101,100,32,117,115,105,110,103,32,116,104,101,32,112,114,111,116,111,32,100,101,115,99,114,105,112,116,111,114,115,32,99,111,109,112,105,108,101,100,32,105,110,116,111,32,116,104,105,115,32,98,105,110,97,114,121,46,32,77,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,115,115,97,103,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,116,114,101,97,109,79,112,116,105,111,110,115,0,73,109,112,111,114,116,32,0,32,98,117,116,32,110,111,116,32,117,115,101,100,46,0,69,120,112,97,110,100,101,100,32,109,97,112,32,101,110,116,114,121,32,116,121,112,101,32,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,110,101,115,116,101,100,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,102,105,101,108,100,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,101,110,117,109,32,116,121,112,101,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,111,110,101,111,102,32,116,121,112,101,46,0,70,105,108,101,115,32,119,105,116,104,32,111,112,116,105,109,105,122,101,95,102,111,114,32,61,32,76,73,84,69,95,82,85,78,84,73,77,69,32,99,97,110,110,111,116,32,100,101,102,105,110,101,32,115,101,114,118,105,99,101,115,32,117,110,108,101,115,115,32,121,111,117,32,115,101,116,32,98,111,116,104,32,111,112,116,105,111,110,115,32,99,99,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,32,97,110,100,32,106,97,118,97,95,103,101,110,101,114,105,99,95,115,101,118,105,99,101,115,32,116,111,32,102,97,108,115,101,46,0,70,105,108,101,115,32,116,104,97,116,32,100,111,32,110,111,116,32,117,115,101,32,111,112,116,105,109,105,122,101,95,102,111,114,32,61,32,76,73,84,69,95,82,85,78,84,73,77,69,32,99,97,110,110,111,116,32,105,109,112,111,114,116,32,102,105,108,101,115,32,119,104,105,99,104,32,100,111,32,117,115,101,32,116,104,105,115,32,111,112,116,105,111,110,46,32,32,84,104,105,115,32,102,105,108,101,32,105,115,32,110,111,116,32,108,105,116,101,44,32,98,117,116,32,105,116,32,105,109,112,111,114,116,115,32,34,0,34,32,119,104,105,99,104,32,105,115,46,0,84,104,101,32,102,105,114,115,116,32,101,110,117,109,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,122,101,114,111,32,105,110,32,112,114,111,116,111,51,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,77,101,115,115,97,103,101,83,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,112,114,111,116,111,51,46,0,84,104,101,32,74,83,79,78,32,99,97,109,101,108,45,99,97,115,101,32,110,97,109,101,32,111,102,32,102,105,101,108,100,32,34,0,34,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,102,105,101,108,100,32,34,0,34,46,32,84,104,105,115,32,105,115,32,110,111,116,32,0,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,120,116,101,110,115,105,111,110,115,32,105,110,32,112,114,111,116,111,51,32,97,114,101,32,111,110,108,121,32,97,108,108,111,119,101,100,32,102,111,114,32,100,101,102,105,110,105,110,103,32,111,112,116,105,111,110,115,46,0,82,101,113,117,105,114,101,100,32,102,105,101,108,100,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,120,112,108,105,99,105,116,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,110,117,109,32,116,121,112,101,32,34,0,34,32,105,115,32,110,111,116,32,97,32,112,114,111,116,111,51,32,101,110,117,109,44,32,98,117,116,32,105,115,32,117,115,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+471044);allocate([100,32,105,110,32,34,0,34,32,119,104,105,99,104,32,105,115,32,97,32,112,114,111,116,111,51,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,71,114,111,117,112,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,112,114,111,116,111,51,32,115,121,110,116,97,120,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,40,41,45,62,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,32,61,61,32,116,114,117,101,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,101,110,117,109,95,116,121,112,101,95,45,62,118,97,108,117,101,95,99,111,117,110,116,40,41,58,32,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,0,112,114,111,116,111,0,50,46,0,70,105,108,101,79,112,116,105,111,110,115,0,77,101,115,115,97,103,101,79,112,116,105,111,110,115,0,70,105,101,108,100,79,112,116,105,111,110,115,0,69,110,117,109,79,112,116,105,111,110,115,0,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,0,83,101,114,118,105,99,101,79,112,116,105,111,110,115,0,77,101,116,104,111,100,79,112,116,105,111,110,115,0,79,110,101,111,102,79,112,116,105,111,110,115,0,91,108,97,122,121,32,61,32,116,114,117,101,93,32,99,97,110,32,111,110,108,121,32,98,101,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,115,117,98,109,101,115,115,97,103,101,32,102,105,101,108,100,115,46,0,91,112,97,99,107,101,100,32,61,32,116,114,117,101,93,32,99,97,110,32,111,110,108,121,32,98,101,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,114,101,112,101,97,116,101,100,32,112,114,105,109,105,116,105,118,101,32,102,105,101,108,100,115,46,0,77,101,115,115,97,103,101,83,101,116,115,32,99,97,110,110,111,116,32,104,97,118,101,32,102,105,101,108,100,115,44,32,111,110,108,121,32,101,120,116,101,110,115,105,111,110,115,46,0,69,120,116,101,110,115,105,111,110,115,32,116,111,32,110,111,110,45,108,105,116,101,32,116,121,112,101,115,32,99,97,110,32,111,110,108,121,32,98,101,32,100,101,99,108,97,114,101,100,32,105,110,32,110,111,110,45,108,105,116,101,32,102,105,108,101,115,46,32,32,78,111,116,101,32,116,104,97,116,32,121,111,117,32,99,97,110,110,111,116,32,101,120,116,101,110,100,32,97,32,110,111,110,45,108,105,116,101,32,116,121,112,101,32,116,111,32,99,111,110,116,97,105,110,32,97,32,108,105,116,101,32,116,121,112,101,44,32,98,117,116,32,116,104,101,32,114,101,118,101,114,115,101,32,105,115,32,97,108,108,111,119,101,100,46,0,109,97,112,95,101,110,116,114,121,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,115,101,116,32,101,120,112,108,105,99,105,116,108,121,46,32,85,115,101,32,109,97,112,60,75,101,121,84,121,112,101,44,32,86,97,108,117,101,84,121,112,101,62,32,105,110,115,116,101,97,100,46,0,73,108,108,101,103,97,108,32,106,115,116,121,112,101,32,102,111,114,32,105,110,116,54,52,44,32,117,105,110,116,54,52,44,32,115,105,110,116,54,52,44,32,102,105,120,101,100,54,52,32,111,114,32,115,102,105,120,101,100,54,52,32,102,105,101,108,100,58,32,0,106,115,116,121,112,101,32,105,115,32,111,110,108,121,32,97,108,108,111,119,101,100,32,111,110,32,105,110,116,54,52,44,32,117,105,110,116,54,52,44,32,115,105,110,116,54,52,44,32,102,105,120,101,100,54,52,32,111,114,32,115,102,105,120,101,100,54,52,32,102,105,101,108,100,115,46,0,69,110,116,114,121,0,75,101,121,32,105,110,32,109,97,112,32,102,105,101,108,100,115,32,99,97,110,110,111,116,32,98,101,32,101,110,117,109,32,116,121,112,101,115,46,0,75,101,121,32,105,110,32,109,97,112,32,102,105,101,108,100,115,32,99,97,110,110,111,116,32,98,101,32,102,108,111,97,116,47,100,111,117,98,108,101,44,32,98,121,116,101,115,32,111,114,32,109,101,115,115,97,103,101,32,116,121,112,101,115,46,0,69,110,117,109,32,118,97,108,117,101,32,105,110,32,109,97,112,32,109,117,115,116,32,100,101,102,105,110,101,32,48,32,97,115,32,116,104,101,32,102,105,114,115,116,32,118,97,108,117,101,46,0,34,32,117,115,101,115,32,116,104,101,32,115,97,109,101,32,101,110,117,109,32,118,97,108,117,101,32,97,115,32,34,0,34,46,32,73,102,32,116,104,105,115,32,105,115,32,105,110,116,101,110,100,101,100,44,32,115,101,116,32,39,111,112,116,105,111,110,32,97,108,108,111,119,95,97,108,105,97,115,32,61,32,116,114,117,101,59,39,32,116,111,32,116,104,101,32,101,110,117,109,32,100,101,102,105,110,105,116,105,111,110,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,115,32,99,97,110,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,36,48,46,0,79,112,116,105,111,110,32,109,117,115,116,32,104,97,118,101,32,97,32,110,97,109,101,46,0,79,112,116,105,111,110,32,109,117,115,116,32,110,111,116,32,117,115,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,32,34,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,34,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,95,100,101,115,99,114,105,112,116,111,114,58,32,0,79,112,116,105,111,110,32,34,0,34,32,105,115,32,114,101,115,111,108,118,101,100,32,116,111,32,34,40,0,41,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,32,84,104,101,32,105,110,110,101,114,109,111,115,116,32,115,99,111,112,101,32,105,115,32,115,101,97,114,99,104,101,100,32,102,105,114,115,116,32,105,110,32,110,97,109,101,32,114,101,115,111,108,117,116,105,111,110,46,32,67,111,110,115,105,100,101,114,32,117,115,105,110,103,32,97,32,108,101,97,100,105,110,103,32,39,46,39,40,105,46,101,46,44,32,34,40,46,0,34,41,32,116,111,32,115,116,97,114,116,32,102,114,111,109,32,116,104,101,32,111,117,116,101,114,109,111,115,116,32,115,99,111,112,101,46,0,34,32,117,110,107,110,111,119,110,46,0,79,112,116,105,111,110,32,102,105,101,108,100,32,34,0,34,32,105,115,32,110,111,116,32,97,32,102,105,101,108,100,32,111,114,32,101,120,116,101,110,115,105,111,110,32,111,102,32,109,101,115,115,97,103,101,32,34,0,34,32,105,115,32,97,110,32,97,116,111,109,105,99,32,116,121,112,101,44,32,110,111,116,32,97,32,109,101,115,115,97,103,101,46,0,34,32,105,115,32,97,32,114,101,112,101,97,116,101,100,32,109,101,115,115,97,103,101,46,32,82,101,112,101,97,116,101,100,32,109,101,115,115,97,103,101,32,111,112,116,105,111,110,115,32,109,117,115,116,32,98,101,32,105,110,105,116,105,97,108,105,122,101,100,32,117,115,105,110,103,32,97,110,32,97,103,103,114,101,103,97,116,101,32,118,97,108,117,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,111,117,116,46,72,97,100,69,114,114,111,114,40,41,58,32,0,85,110,101,120,112,101,99,116,101,100,32,102,97,105,108,117,114,101,32,119,104,105,108,101,32,115,101,114,105,97,108,105,122,105,110,103,32,111,112,116,105,111,110,32,115,117,98,109,101,115,115,97,103,101,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,58,32,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,102,111,114,32,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,102,111,114,32,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,117,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,32,102,111,114,32,117,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,32,102,111,114,32,117,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,117,109,98,101,114,32,102,111,114,32,102,108,111,97,116,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,117,109,98,101,114,32,102,111,114,32,100,111,117,98,108,101,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,32,98,111,111,108,101,97,110,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,34,116,114,117,101,34,32,111,114,32,34,102,97,108,115,101,34,32,102,111,114,32,98,111,111,108,101,97,110,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,32,101,110,117,109,45,118,97,108,117,101,100,32,111,112,116,105,111,110,32,34,0,34,32,104,97,115,32,110,111,32,118,97,108,117,101,32,110,97,109,101,100,32,34,0,34,32,102,111,114,32,111,112,116,105,111,110,32,34,0,34,46,32,84,104,105,115,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,97,32,118,97,108,117,101,32,102,114,111,109,32,97,32,115,105,98,108,105,110,103,32,116,121,112,101,46,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,113,117,111,116,101,100,32,115,116,114,105,110,103,32,102,111,114,32,115,116,114,105,110,103,32,111,112,116,105,111,110,32,34,0,34,32,105,115,32,97,32,109,101,115,115,97,103,101,46,32,84,111,32,115,101,116,32,116,104,101,32,101,110,116,105,114,101,32,109,101,115,115,97,103,101,44,32,117,115,101,32,115,121,110,116,97,120,32,108,105,107,101,32,34,0,32,61,32,123,32,60,112,114,111,116,111,32,116,101,120,116,32,102,111,114,109,97,116,62,32,125,34,46,32,84,111,32,115,101,116,32,102,105,101,108,100,115,32,119,105,116,104,105,110,32,105,116,44,32,117,115,101,32,115,121,110,116,97,120,32,108,105,107,101,32,34,0,46,102,111,111,32,61,32,118,97,108,117,101,34,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,100,121,110,97,109,105,99,46,103,101,116,40,41,32,33,61,32,78,85,76,76,58,32,0,67,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,97,110,32,105,110,115,116,97,110,99,101,32,111,102,32,0,69,114,114,111,114,32,119,104,105,108,101,32,112,97,114,115,105,110,103,32,111,112,116,105,111,110,32,118,97,108,117,101,32,102,111,114,32,34,0,34,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,111,112,116,105,111,110,95,102,105,101,108,100,45,62,116,121,112,101,40,41,41,32,61,61,32,40,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,84,89,80,69,95,71,82,79,85,80,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,68,101,115,99,114,105,112,116,111,114,66,117,105,108,100,101,114,49,55,79,112,116,105,111,110,73,110,116,101,114,112,114,101,116,101,114,50,49,65,103,103,114,101,103,97,116,101,79,112,116,105,111,110,70,105,110,100,101,114,69,0,59,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,51,65,103,103,114,101,103,97,116,101,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,101,120,116,101,110,100,32,46,36,48,32,123,10,0,109,97,112,60,36,48,44,32,36,49,62,0,36,48,36,49,36,50,32,36,51,32,61,32,36,52,0,32,91,100,101,102,97,117,108,116,32,61,32,36,48,0,106,115,111,110,95,110,97,109,101,32,61,32,34,0,32,123,32,46,46,46,32,125,59,10,0,59,10,0,36,48,47,47,32,36,49,10,0,36,48,109,101,115,115,97,103,101,32,36,49,0,36,48,32,32,101,120,116,101,110,115,105,111,110,115,32,36,49,32,116,111,32,36,50,59,10,0,36,48,32,32,125,10,0,36,48,32,32,101,120,116,101,110,100,32,46,36,49,32,123,10,0,36,48,32,32,114,101,115,101,114,118,101,100,32,0,36,48,44,32,0,36,48,32,116,111,32,36,49,44,32,0,34,36,48,34,44,32,0,36,48,125,10,0,36,48,111,110,101,111,102,32,36,49,32,123,0,32,46,46,46,32,125,10,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,108,111,103,103,105,110,103,46,104,0,39,111,117,116,95,108,111,99,97,116,105,111,110,39,32,109,117,115,116,32,110,111,116,32,98,101,32,78,85,76,76,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,78,83,116,51,95,95,50,52,112,97,105,114,73,80,75,78,83,48,95,50,48,70,105,108,101,68,101,115,99,114,105,112,116,111,114,84,97,98,108,101,115,69,80,75,78,83,48,95,49,52,83,111,117,114,99,101,67,111,100,101,73,110,102,111,69,69,69,69,69,0,36,48,101,110,117,109,32,36,49,32,123,10,0,36,48,36,49,32,61,32,36,50,0,32,91,36,48,93,0,36,48,111,112,116,105,111,110,32,36,49,59,10,0,70,111,117,110,100,32,105,110,118,97,108,105,100,32,112,114,111,116,111,32,111,112,116,105,111,110,32,100,97,116,97,32,102,111,114,58,32,0,123,10,0,40,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,104,97,115,95,100,101,102,97,117,108,116,95,118,97,108,117,101,40,41,58,32,0,78,111,32,100,101,102,97,117,108,116,32,118,97,108,117,101,0,77,101,115,115,97,103,101,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,33,0,67,97,110,39,116,32,103,101,116,32,104,101,114,101,58,32,102,97,105,108,101,100,32,116,111,32,103,101,116,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,97,115,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,85,73,78,84,54,52,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,85,73,78,84,51,50,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,73,78,84,54,52,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,73,78,84,51,50,58,32,0,34,32,119,97,115,32,97,108,114,101,97,100,121,32,115,101,116,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,46,112,108,97,99,101,104,111,108,100,101,114,46,112,114,111,116,111,0,80,76,65,67,69,72,79,76,68,69,82,95,86,65,76,85,69,0,46,80,76,65,67,69,72,79,76,68,69,82,95,86,65,76,85,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,98,117,105,108,100,101,114,95,58,32,0,34,32,105,115,32,110,111,116,32,97,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,110,97,109,101,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,111,110,99,101,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,102,105,108,101,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,100,101,115,99,114,105,112,116,111,114,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,32,38,38,32,102,105,108,101,45,62,112,111,111,108,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,45,62,112,111,111,108,95,45,62,108,97,122,105,108,121,95,98,117,105,108,100,95,100,101,112,101,110,100,101,110,99,105,101,115,95,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,102,105,108,101,45,62,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,58,32,0,34,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,0,34,32,115,101,101,109,115,32,116,111,32,98,101,32,100,101,102,105,110,101,100,32,105,110,32,34,0,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,105,109,112,111,114,116,101,100,32,98,121,32,34,0,34,46,32,32,84,111,32,117,115,101,32,105,116,32,104,101,114,101,44,32,112,108,101,97,115,101,32,97,100,100,32,116,104,101,32,110,101,99,101,115,115,97,114,121,32,105,109,112,111,114,116,46,0,34,32,105,115,32,114,101,115,111,108,118,101,100,32,116,111,32,34,0,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,32,84,104,101,32,105,110,110,101,114,109,111,115,116,32,115,99,111,112,101,32,105,115,32,115,101,97,114,99,104,101,100,32,102,105,114,115,116,32,105,110,32,110,97,109,101,32,114,101,115,111,108,117,116,105,111,110,46,32,67,111,110,115,105,100,101,114,32,117,115,105,110,103,32,97,32,108,101,97,100,105,110,103,32,39,46,39,40,105,46,101,46,44,32,34,46,0,34,36,48,34,32,100,111,101,115,32,110,111,116,32,100,101,99,108,97,114,101,32,36,49,32,97,115,32,97,110,32,101,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,46,0,70,105,101,108,100,115,32,111,102,32,111,110,101,111,102,115,32,109,117,115,116,32,116,104,101,109,115,101,108,118,101,115,32,104,97,118,101,32,108,97,98,101,108,32,76,65,66,69,76,95,79,80,84,73,79,78,65,76,46,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,109,112,116,121,0,34,32,105,115,32,110,111,116,32,97,32,116,121,112,101,46,0,77,101,115,115,97,103,101,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,46,0,34,32,105,115,32,110,111,116,32,97,110,32,101,110,117,109,32,116,121,112,101,46,0,68,101,102,97,117,108,116,32,118,97,108,117,101,32,102,111,114,32,97,110,32,101,110,117,109,32,102,105,101,108,100,32,109,117,115,116,32,98,101,32,97,110,32,105,100,101,110,116,105,102,105,101,114,46,0,70,105,101,108,100,32,119,105,116,104,32,112,114,105,109,105,116,105,118,101,32,116,121,112,101,32,104,97,115,32,116,121,112,101,95,110,97,109,101,46,0,70,105,101,108,100,32,119,105,116,104,32,109,101,115,115,97,103,101,32,111,114,32,101,110,117,109,32,116,121,112,101,32,109,105,115,115,105,110,103,32,116,121,112,101,95,110,97,109,101,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,101,120,116,101,110,115,105,111,110,32,34,36,50,34,46,0,70,105,101,108,100,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,102,105,101,108,100,32,34,36,50,34,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,101,120,116,101,110,115,105,111,110,32,34,36,50,34,32,100,101,102,105,110,101,100,32,105,110,32,36,51,46,0,70,105,101,108,100,115,32,105,110,32,116,104,101,32,115,97,109,101,32,111,110,101,111,102,32,109,117,115,116,32,98,101,32,100,101,102,105,110,101,100,32,99,111,110,115,101,99,117,116,105,118,101,108,121,46,32,34,36,48,34,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,98,101,102,111,114,101,32,116,104,101,32,99,111,109,112,108,101,116,105,111,110,32,111,102,32,116,104,101,32,34,36,49,34,32,111,110,101,111,102,32,100,101,102,105,110,105,116,105,111,110,46,0,79,110,101,111,102,32,109,117,115,116,32,104,97,118,101,32,97,116,32,108,101,97,115,116,32,111,110,101,32,102,105,101,108,100,46,0,77,101,115,115,97,103,101,32,101,120,116,101,110,115,105,111,110,115,32,99,97,110,110,111,116,32,104,97,118,101,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,46,0,82,101,112,101,97,116,101,100,32,102,105,101,108,100,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,46,0,66,111,111,108,101,97,110,32,100,101,102,97,117,108,116,32,109,117,115,116,32,98,101,32,116,114,117,101,32,111,114,32,102,97,108,115,101,46,0,67,111,117,108,100,110,39,116,32,112,97,114,115,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,34,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,99,97,110,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,36,48,46,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,36,48,32,116,104,114,111,117,103,104,32,36,49,32,97,114,101,32,114,101,115,101,114,118,101,100,32,102,111,114,32,116,104,101,32,112,114,111,116,111,99,111,108,32,98,117,102,102,101,114,32,108,105,98,114,97,114,121,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,101,120,116,101,110,100,101,101,32,110,111,116,32,115,101,116,32,102,111,114,32,101,120,116,101,110,115,105,111,110,32,102,105,101,108,100,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,111,110,101,111,102,95,105,110,100,101,120,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,115,101,116,32,102,111,114,32,101,120,116,101,110,115,105,111,110,115,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,101,120,116,101,110,100,101,101,32,115,101,116,32,102,111,114,32,110,111,110,45,101,120,116,101,110,115,105,111,110,32,102,105,101,108,100,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,111,110,101,111,102,95,105,110,100,101,120,32,36,48,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,116,121,112,101,32,34,36,49,34,46,0,34,32,110,111,116,32,112,114,101,118,105,111,117,115,108,121,32,100,101,102,105,110,101,100,32,105,110,32,115,121,109,98,111,108,115,95,98,121,95,110,97,109,101,95,44,32,98,117,116,32,119,97,115,32,100,101,102,105,110,101,100,32,105,110,32,115,121,109,98,111,108,115,95,98,121,95,112,97,114,101,110,116,95,59,32,116,104,105,115,32,115,104,111,117,108,100,110,39,116,32,98,101,32,112,111,115,115,105,98,108,101,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,34,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,102,105,108,101,32,34,0,77,105,115,115,105,110,103,32,110,97,109,101,46,0,34,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,105,100,101,110,116,105,102,105,101,114,46,0,69,110,117,109,115,32,109,117,115,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,111,110,101,32,118,97,108,117,101,46,0,82,101,115,101,114,118,101,100,32,114,97,110,103,101,32,101,110,100,32,110,117,109,98,101,114,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,115,116,97,114,116,32,110,117,109,98,101,114,46,0,82,101,115,101,114,118,101,100,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,97,108,114,101,97,100,121,45,100,101,102,105,110,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,69,110,117,109,32,118,97,108,117,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,110,117,109,32,118,97,108,117,101,32,34,36,48,34,32,117,115,101,115,32,114,101,115,101,114,118,101,100,32,110,117,109,98,101,114,32,36,49,46,0,69,110,117,109,32,118,97,108,117,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,46,0,87,104,101,110,32,101,110,117,109,32,110,97,109,101,32,105,115,32,115,116,114,105,112,112,101,100,32,97,110,100,32,108,97,98,101,108,32,105,115,32,80,97,115,99,97,108,67,97,115,101,100,32,40,0,41,44,32,116,104,105,115,32,118,97,108,117,101,32,108,97,98,101,108,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,0,46,32,84,104,105,115,32,119,105,108,108,32,109,97,107,101,32,116,104,101,32,112,114,111,116,111,32,102,97,105,108,32,116,111,32,99,111,109,112,105,108,101,32,102,111,114,32,115,111,109,101,32,108,97,110,103,117,97,103,101,115,44,32,115,117,99,104,32,97,115,32,67,35,46,0,116,104,101,32,103,108,111,98,97,108,32,115,99,111,112,101,0,78,111,116,101,32,116,104,97,116,32,101,110,117,109,32,118,97,108,117,101,115,32,117,115,101,32,67,43,43,32,115,99,111,112,105,110,103,32,114,117,108,101,115,44,32,109,101,97,110,105,110,103,32,116,104,97,116,32,101,110,117,109,32,118,97,108,117,101,115,32,97,114,101,32,115,105,98,108,105,110,103,115,32,111,102,32,116,104,101,105,114,32,116,121,112,101,44,32,110,111,116,32,99,104,105,108,100,114,101,110,32,111,102,32,105,116,46,32,32,84,104,101,114,101,102,111,114,101,44,32,34,0,34,32,109,117,115,116,32,98,101,32,117,110,105,113,117,101,32,119,105,116,104,105,110,32,0,44,32,110,111,116,32,106,117,115,116,32,119,105,116,104,105,110,32,34,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,101,110,100,32,110,117,109,98,101,114,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,115,116,97,114,116,32,110,117,109,98,101,114,46,0,82,101,115,101,114,118,101,100,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,70,105,101,108,100,32,110,97,109,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,105,110,99,108,117,100,101,115,32,102,105,101,108,100,32,34,36,50,34,32,40,36,51,41,46,0,70,105,101,108,100,32,34,36,48,34,32,117,115,101,115,32,114,101,115,101,114,118,101,100,32,110,117,109,98,101,114,32,36,49,46,0,70,105,101,108,100,32,110,97,109,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,114,101,115,101,114,118,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,97,108,114,101,97,100,121,45,100,101,102,105,110,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,32,61,61,32,116,114,117,101,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,75,78,83,48,95,49,52,70,105,108,101,68,101,115,99,114,105,112,116,111,114,69,69,69,0,73,109,112,111,114,116,32,34,0,34,32,104,97,115,32,110,111,116,32,98,101,101,110,32,108,111,97,100,101,100,46,0,34,32,119,97,115,32,110,111,116,32,102,111,117,110,100,32,111,114,32,104,97,100,32,101,114,114,111,114,115,46,0,34,32,119,97,115,32,108,105,115,116,101,100,32,116,119,105,99,101,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,40,97,115,32,115,111,109,101,116,104,105,110,103,32,111,116,104,101,114,32,116,104,97,110,32,97,32,112,97,99,107,97,103,101,41,32,105,110,32,102,105,108,101,32,34,0,73,110,118,97,108,105,100,32,112,114,111,116,111,32,100,101,115,99,114,105,112,116,111,114,32,102,111,114,32,102,105,108,101,32,34,0,34,58,0,32,32,0,70,105,108,101,32,114,101,99,117,114,115,105,118,101,108,121,32,105,109,112,111,114,116,115,32,105,116,115,101,108,102,58,32,0,32,45,62,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,95,45,62,102,105,110,105,115,104,101,100,95,98,117,105,108,100,105,110,103,95,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,78,83,49,95,49,52,76,97,122,121,68,101,115,99,114,105,112,116,111,114,69,69,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,103,101,110,101,114,97,116,101,100,95,100,97,116,97,98,97,115,101,95,45,62,65,100,100,40,101,110,99,111,100,101,100,95,102,105,108,101,95,100,101,115,99,114,105,112,116,111,114,44,32,115,105,122,101,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,75,78,83,48,95,50,48,70,105,108,101,68,101,115,99,114,105,112,116,111,114,84,97,98,108,101,115,69,69,69,0,85,78,75,78,79,87,78,95,69,78,85,77,95,86,65,76,85,69,95,37,115,95,37,100,0,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,114,111,116,111,0,10,32,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,114,111,116,111,18,15,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,34,71,10,17,70,105,108,101,68,101,115,99,114,105,112,116,111,114,83,101,116,18,50,10,4,102,105,108,101,24,1,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,34,219,3,10,19,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,15,10,7,112,97,99,107,97,103,101,24,2,32,1,40,9,18,18,10,10,100,101,112,101,110,100,101,110,99,121,24,3,32,3,40,9,18,25,10,17,112,117,98,108,105,99,95,100,101,112,101,110,100,101,110,99,121,24,10,32,3,40,5,18,23,10,15,119,101,97,107,95,100,101,112,101,110,100,101,110,99,121,24,11,32,3,40,5,18,54,10,12,109,101,115,115,97,103,101,95,116,121,112,101,24,4,32,3,40,11,50,32,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,55,10,9,101,110,117,109,95,116,121,112,101,24,5,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,7,115,101,114,118,105,99,101,24,6,32,3,40,11,50,39,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,9,101,120,116,101,110,115,105,111,110,24,7,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,45,10,7,111,112,116,105,111,110,115,24,8,32,1,40,11,50,28,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,18,57,10,16,115,111,117,114,99,101,95,99,111,100,101,95,105,110,102,111,24,9,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,111,117,114,99,101,67,111,100,101,73,110,102,111,18,14,10,6,115,121,110,116,97,120,24,12,32,1,40,9,34,169,5,10,15,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,52,10,5,102,105,101,108,100,24,2,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,9,101,120,116,101,110,115,105,111,110,24,6,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,53,10,11,110,101,115,116,101,100,95,116,121,112,101,24,3,32,3,40,11,50,32,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,55,10,9,101,110,117,109,95,116,121,112,101,24,4,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,72,10,15,101,120,116,101,110,115,105,111,110,95,114,97,110,103,101,24,5,32,3,40,11,50,47,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,69,120,116,101,110,115,105,111,110,82,97,110,103,101,18,57,10,10,111,110,101,111,102,95,100,101,99,108,24,8,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,48,10,7,111,112,116,105,111,110,115,24,7,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,115,115,97,103,101,79,112,116,105,111,110,115,18,70,10,14,114,101,115,101,114,118,101,100,95,114,97,110,103,101,24,9,32,3,40,11,50,46,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,82,101,115,101,114,118,101,100,82,97,110,103,101,18,21,10,13,114,101,115,101,114,118,101,100,95,110,97,109,101,24,10,32,3,40,9,26,101,10,14,69,120,116,101,110,115,105,111,110,82,97,110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,18,55,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,38,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,120,116,101,110,115,105,111,110,82,97,110,103,101,79,112,116,105,111,110,115,26,43,10,13,82,101,115,101,114,118,101,100,82,97,110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,34,103,10,21,69,120,116,101,110,115,105,111,110,82,97,110,103,101,79,112,116,105,111,110,115,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,188,5,10,20,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,14,10,6,110,117,109,98,101,114,24,3,32,1,40,5,18,58,10,5,108,97,98,101,108,24,4,32,1,40,14,50,43,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,76,97,98,101,108,18,56,10,4,116,121,112,101,24,5,32,1,40,14,50,42,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,84,121,112,101,18,17,10,9,116,121,112,101,95,110,97,109,101,24,6,32,1,40,9,18,16,10,8,101,120,116,101,110,100,101,101,24,2,32,1,40,9,18,21,10,13,100,101,102,97,117,108,116,95,118,97,108,117,101,24,7,32,1,40,9,18,19,10,11,111,110,101,111,102,95,105,110,100,101,120,24,9,32,1,40,5,18,17,10,9,106,115,111,110,95,110,97,109,101,24,10,32,1,40,9,18,46,10,7,111,112,116,105,111,110,115,24,8,32,1,40,11,50,29,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,34,182,2,10,4,84,121,112,101,18,15,10,11,84,89,80,69,95,68,79,85,66,76,69,16,1,18,14,10,10,84,89,80,69,95,70,76,79,65,84,16,2,18,14,10,10,84,89,80,69,95,73,78,84,54,52,16,3,18,15,10,11,84,89,80,69,95,85,73,78,84,54,52,16,4,18,14,10,10,84,89,80,69,95,73,78,84,51,50,16,5,18,16,10,12,84,89,80,69,95,70,73,88,69,68,54,52,16,6,18,16,10,12,84,89,80,69,95,70,73,88,69,68,51,50,16,7,18,13,10,9,84,89,80,69,95,66,79,79,76,16,8,18,15,10,11,84,89,80,69,95,83,84,82,73,78,71,16,9,18,14,10,10,84,89,80,69,95,71,82,79,85,80,16,10,18,16,10,12,84,89,80,69,95,77,69,83,83,65,71,69,16,11,18,14,10,10,84,89,80,69,95,66,89,84,69,83,16,12,18,15,10,11,84,89,80,69,95,85,73,78,84,51,50,16,13,18,13,10,9,84,89,80,69,95,69,78,85,77,16,14,18,17,10,13,84,89,80,69,95,83,70,73,88,69,68,51,50,16,15,18,17,10,13,84,89,80,69,95,83,70,73,88,69,68,54,52,16,16,18,15,10,11,84,89,80,69,95,83,73,78,84,51,50,16,17,18,15,10,11,84,89,80,69,95,83,73,78,84,54,52,16,18,34,67,10,5,76,97,98,101,108,18,18,10,14,76,65,66,69,76,95,79,80,84,73,79,78,65,76,16,1,18,18,10,14,76,65,66,69,76,95,82,69,81,85,73,82,69,68,16,2,18,18,10,14,76,65,66,69,76,95,82,69,80,69,65,84,69,68,16,3,34,84,10,20,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,46,10,7,111,112,116,105,111,110,115,24,2,32,1,40,11,50,29,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,79,110,101,111,102,79,112,116,105,111,110,115,34,164,2,10,19,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,56,10,5,118,97,108,117,101,24,2,32,3,40,11,50,41,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,45,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,28,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,79,112,116,105,111,110,115,18,78,10,14,114,101,115,101,114,118,101,100,95,114,97,110,103,101,24,4,32,3,40,11,50,54,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,69,110,117,109,82,101,115,101,114,118,101,100,82,97,110,103,101,18,21,10,13,114,101,115,101,114,118,101,100,95,110,97,109,101,24,5,32,3,40,9,26,47,10,17,69,110,117,109,82,101,115,101,114,118,101,100,82,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+481284);allocate([110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,34,108,10,24,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,14,10,6,110,117,109,98,101,114,24,2,32,1,40,5,18,50,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,33,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,34,144,1,10,22,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,54,10,6,109,101,116,104,111,100,24,2,32,3,40,11,50,38,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,48,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,79,112,116,105,111,110,115,34,193,1,10,21,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,18,10,10,105,110,112,117,116,95,116,121,112,101,24,2,32,1,40,9,18,19,10,11,111,117,116,112,117,116,95,116,121,112,101,24,3,32,1,40,9,18,47,10,7,111,112,116,105,111,110,115,24,4,32,1,40,11,50,30,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,18,31,10,16,99,108,105,101,110,116,95,115,116,114,101,97,109,105,110,103,24,5,32,1,40,8,58,5,102,97,108,115,101,18,31,10,16,115,101,114,118,101,114,95,115,116,114,101,97,109,105,110,103,24,6,32,1,40,8,58,5,102,97,108,115,101,34,240,5,10,11,70,105,108,101,79,112,116,105,111,110,115,18,20,10,12,106,97,118,97,95,112,97,99,107,97,103,101,24,1,32,1,40,9,18,28,10,20,106,97,118,97,95,111,117,116,101,114,95,99,108,97,115,115,110,97,109,101,24,8,32,1,40,9,18,34,10,19,106,97,118,97,95,109,117,108,116,105,112,108,101,95,102,105,108,101,115,24,10,32,1,40,8,58,5,102,97,108,115,101,18,41,10,29,106,97,118,97,95,103,101,110,101,114,97,116,101,95,101,113,117,97,108,115,95,97,110,100,95,104,97,115,104,24,20,32,1,40,8,66,2,24,1,18,37,10,22,106,97,118,97,95,115,116,114,105,110,103,95,99,104,101,99,107,95,117,116,102,56,24,27,32,1,40,8,58,5,102,97,108,115,101,18,70,10,12,111,112,116,105,109,105,122,101,95,102,111,114,24,9,32,1,40,14,50,41,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,46,79,112,116,105,109,105,122,101,77,111,100,101,58,5,83,80,69,69,68,18,18,10,10,103,111,95,112,97,99,107,97,103,101,24,11,32,1,40,9,18,34,10,19,99,99,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,16,32,1,40,8,58,5,102,97,108,115,101,18,36,10,21,106,97,118,97,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,17,32,1,40,8,58,5,102,97,108,115,101,18,34,10,19,112,121,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,18,32,1,40,8,58,5,102,97,108,115,101,18,35,10,20,112,104,112,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,42,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,23,32,1,40,8,58,5,102,97,108,115,101,18,31,10,16,99,99,95,101,110,97,98,108,101,95,97,114,101,110,97,115,24,31,32,1,40,8,58,5,102,97,108,115,101,18,25,10,17,111,98,106,99,95,99,108,97,115,115,95,112,114,101,102,105,120,24,36,32,1,40,9,18,24,10,16,99,115,104,97,114,112,95,110,97,109,101,115,112,97,99,101,24,37,32,1,40,9,18,20,10,12,115,119,105,102,116,95,112,114,101,102,105,120,24,39,32,1,40,9,18,24,10,16,112,104,112,95,99,108,97,115,115,95,112,114,101,102,105,120,24,40,32,1,40,9,18,21,10,13,112,104,112,95,110,97,109,101,115,112,97,99,101,24,41,32,1,40,9,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,58,10,12,79,112,116,105,109,105,122,101,77,111,100,101,18,9,10,5,83,80,69,69,68,16,1,18,13,10,9,67,79,68,69,95,83,73,90,69,16,2,18,16,10,12,76,73,84,69,95,82,85,78,84,73,77,69,16,3,42,9,8,232,7,16,128,128,128,128,2,74,4,8,38,16,39,34,242,1,10,14,77,101,115,115,97,103,101,79,112,116,105,111,110,115,18,38,10,23,109,101,115,115,97,103,101,95,115,101,116,95,119,105,114,101,95,102,111,114,109,97,116,24,1,32,1,40,8,58,5,102,97,108,115,101,18,46,10,31,110,111,95,115,116,97,110,100,97,114,100,95,100,101,115,99,114,105,112,116,111,114,95,97,99,99,101,115,115,111,114,24,2,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,17,10,9,109,97,112,95,101,110,116,114,121,24,7,32,1,40,8,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,74,4,8,8,16,9,74,4,8,9,16,10,34,158,3,10,12,70,105,101,108,100,79,112,116,105,111,110,115,18,58,10,5,99,116,121,112,101,24,1,32,1,40,14,50,35,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,46,67,84,121,112,101,58,6,83,84,82,73,78,71,18,14,10,6,112,97,99,107,101,100,24,2,32,1,40,8,18,63,10,6,106,115,116,121,112,101,24,6,32,1,40,14,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,46,74,83,84,121,112,101,58,9,74,83,95,78,79,82,77,65,76,18,19,10,4,108,97,122,121,24,5,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,19,10,4,119,101,97,107,24,10,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,47,10,5,67,84,121,112,101,18,10,10,6,83,84,82,73,78,71,16,0,18,8,10,4,67,79,82,68,16,1,18,16,10,12,83,84,82,73,78,71,95,80,73,69,67,69,16,2,34,53,10,6,74,83,84,121,112,101,18,13,10,9,74,83,95,78,79,82,77,65,76,16,0,18,13,10,9,74,83,95,83,84,82,73,78,71,16,1,18,13,10,9,74,83,95,78,85,77,66,69,82,16,2,42,9,8,232,7,16,128,128,128,128,2,74,4,8,4,16,5,34,94,10,12,79,110,101,111,102,79,112,116,105,111,110,115,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,147,1,10,11,69,110,117,109,79,112,116,105,111,110,115,18,19,10,11,97,108,108,111,119,95,97,108,105,97,115,24,2,32,1,40,8,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,74,4,8,5,16,6,34,125,10,16,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,1,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,123,10,14,83,101,114,118,105,99,101,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,33,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,173,2,10,13,77,101,116,104,111,100,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,33,32,1,40,8,58,5,102,97,108,115,101,18,95,10,17,105,100,101,109,112,111,116,101,110,99,121,95,108,101,118,101,108,24,34,32,1,40,14,50,47,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,46,73,100,101,109,112,111,116,101,110,99,121,76,101,118,101,108,58,19,73,68,69,77,80,79,84,69,78,67,89,95,85,78,75,78,79,87,78,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,80,10,16,73,100,101,109,112,111,116,101,110,99,121,76,101,118,101,108,18,23,10,19,73,68,69,77,80,79,84,69,78,67,89,95,85,78,75,78,79,87,78,16,0,18,19,10,15,78,79,95,83,73,68,69,95,69,70,70,69,67,84,83,16,1,18,14,10,10,73,68,69,77,80,79,84,69,78,84,16,2,42,9,8,232,7,16,128,128,128,128,2,34,158,2,10,19,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,18,59,10,4,110,97,109,101,24,2,32,3,40,11,50,45,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,46,78,97,109,101,80,97,114,116,18,24,10,16,105,100,101,110,116,105,102,105,101,114,95,118,97,108,117,101,24,3,32,1,40,9,18,26,10,18,112,111,115,105,116,105,118,101,95,105,110,116,95,118,97,108,117,101,24,4,32,1,40,4,18,26,10,18,110,101,103,97,116,105,118,101,95,105,110,116,95,118,97,108,117,101,24,5,32,1,40,3,18,20,10,12,100,111,117,98,108,101,95,118,97,108,117,101,24,6,32,1,40,1,18,20,10,12,115,116,114,105,110,103,95,118,97,108,117,101,24,7,32,1,40,12,18,23,10,15,97,103,103,114,101,103,97,116,101,95,118,97,108,117,101,24,8,32,1,40,9,26,51,10,8,78,97,109,101,80,97,114,116,18,17,10,9,110,97,109,101,95,112,97,114,116,24,1,32,2,40,9,18,20,10,12,105,115,95,101,120,116,101,110,115,105,111,110,24,2,32,2,40,8,34,213,1,10,14,83,111,117,114,99,101,67,111,100,101,73,110,102,111,18,58,10,8,108,111,99,97,116,105,111,110,24,1,32,3,40,11,50,40,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,111,117,114,99,101,67,111,100,101,73,110,102,111,46,76,111,99,97,116,105,111,110,26,134,1,10,8,76,111,99,97,116,105,111,110,18,16,10,4,112,97,116,104,24,1,32,3,40,5,66,2,16,1,18,16,10,4,115,112,97,110,24,2,32,3,40,5,66,2,16,1,18,24,10,16,108,101,97,100,105,110,103,95,99,111,109,109,101,110,116,115,24,3,32,1,40,9,18,25,10,17,116,114,97,105,108,105,110,103,95,99,111,109,109,101,110,116,115,24,4,32,1,40,9,18,33,10,25,108,101,97,100,105,110,103,95,100,101,116,97,99,104,101,100,95,99,111,109,109,101,110,116,115,24,6,32,3,40,9,34,167,1,10,17,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,18,65,10,10,97,110,110,111,116,97,116,105,111,110,24,1,32,3,40,11,50,45,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,46,65,110,110,111,116,97,116,105,111,110,26,79,10,10,65,110,110,111,116,97,116,105,111,110,18,16,10,4,112,97,116,104,24,1,32,3,40,5,66,2,16,1,18,19,10,11,115,111,117,114,99,101,95,102,105,108,101,24,2,32,1,40,9,18,13,10,5,98,101,103,105,110,24,3,32,1,40,5,18,11,10,3,101,110,100,24,4,32,1,40,5,66,143,1,10,19,99,111,109,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,66,16,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,115,72,1,90,62,103,105,116,104,117,98,46,99,111,109,47,103,111,108,97,110,103,47,112,114,111,116,111,98,117,102,47,112,114,111,116,111,99,45,103,101,110,45,103,111,47,100,101,115,99,114,105,112,116,111,114,59,100,101,115,99,114,105,112,116,111,114,248,1,1,162,2,3,71,80,66,170,2,26,71,111,111,103,108,101,46,80,114,111,116,111,98,117,102,46,82,101,102,108,101,99,116,105,111,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,98,46,99,99,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,56,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,95,65,110,110,111,116,97,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,51,83,111,117,114,99,101,67,111,100,101,73,110,102,111,95,76,111,99,97,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,83,111,117,114,99,101,67,111,100,101,73,110,102,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,56,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,95,78,97,109,101,80,97,114,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,77,101,116,104,111,100,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,83,101,114,118,105,99,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,69,110,117,109,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,79,110,101,111,102,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,70,105,101,108,100,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,77,101,115,115,97,103,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,70,105,108,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,50,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,52,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,55,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,69,110,117,109,82,101,115,101,114,118,101,100,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,48,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,48,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,69,120,116,101,110,115,105,111,110,82,97,110,103,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,57,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,82,101,115,101,114,118,101,100,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,48,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,69,120,116,101,110,115,105,111,110,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,53,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,70,105,108,101,68,101,115,99,114,105,112,116,111,114,83,101,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,56,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,53,69,110,99,111,100,101,100,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,95,100,97,116,97,98,97,115,101,46,99,99,0,70,105,108,101,32,97,108,114,101,97,100,121,32,101,120,105,115,116,115,32,105,110,32,100,97,116,97,98,97,115,101,58,32,0,69,120,116,101,110,115,105,111,110,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,101,120,116,101,110,115,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,100,97,116,97,98,97,115,101,58,32,101,120,116,101,110,100,32,0,32,61,32,0,32,125,0,73,110,118,97,108,105,100,32,115,121,109,98,111,108,32,110,97,109,101,58,32,0,83,121,109,98,111,108,32,110,97,109,101,32,34,0,34,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,116,104,101,32,101,120,105,115,116,105,110,103,32,115,121,109,98,111,108,32,34,0,73,110,118,97,108,105,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,100,97,116,97,32,112,97,115,115,101,100,32,116,111,32,69,110,99,111,100,101,100,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,58,58,65,100,100,40,41,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,121,110,97,109,105,99,95,109,101,115,115,97,103,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,115,95,112,114,111,116,111,116,121,112,101,40,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,68,121,110,97,109,105,99,77,101,115,115,97,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,68,121,110,97,109,105,99,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,101,120,116,101,110,115,105,111,110,95,115,101,116,95,104,101,97,118,121,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,117,116,112,117,116,45,62,109,101,115,115,97,103,101,95,112,114,111,116,111,116,121,112,101,32,33,61,32,78,85,76,76,58,32,0,69,120,116,101,110,115,105,111,110,32,102,97,99,116,111,114,121,39,115,32,71,101,116,80,114,111,116,111,116,121,112,101,40,41,32,114,101,116,117,114,110,101,100,32,78,85,76,76,32,102,111,114,32,101,120,116,101,110,115,105,111,110,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,57,68,101,115,99,114,105,112,116,111,114,80,111,111,108,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,48,95,49,49,77,101,115,115,97,103,101,76,105,116,101,69,69,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,112,114,111,116,111,116,121,112,101,32,33,61,32,78,85,76,76,58,32,0,34,71,101,116,77,97,112,68,97,116,97,34,0,70,105,101,108,100,32,105,115,32,110,111,116,32,97,32,109,97,112,32,102,105,101,108,100,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,103,101,110,101,114,97,116,101,100,95,109,101,115,115,97,103,101,95,114,101,102,108,101,99,116,105,111,110,46,99,99,0,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,101,102,108,101,99,116,105,111,110,32,117,115,97,103,101,32,101,114,114,111,114,58,10,32,32,77,101,116,104,111,100,32,32,32,32,32,32,58,32,103,111,111,103,108,101,58,58,112,114,111,116,111,98,117,102,58,58,82,101,102,108,101,99,116,105,111,110,58,58,0,10,32,32,77,101,115,115,97,103,101,32,116,121,112,101,58,32,0,10,32,32,70,105,101,108,100,32,32,32,32,32,32,32,58,32,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,0,34,77,97,112,83,105,122,101,34,0,34,77,97,112,69,110,100,34,0,34,77,97,112,66,101,103,105,110,34,0,34,68,101,108,101,116,101,77,97,112,86,97,108,117,101,34,0,34,73,110,115,101,114,116,79,114,76,111,111,107,117,112,77,97,112,86,97,108,117,101,34,0,34,76,111,111,107,117,112,77,97,112,86,97,108,117,101,34,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,45,62,99,112,112,95,116,121,112,101,40,41,32,61,61,32,99,112,112,95,116,121,112,101,32,124,124,32,40,102,105,101,108,100,45,62,99,112,112,95,116,121,112,101,40,41,32,61,61,32,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,67,80,80,84,89,80,69,95,69,78,85,77,32,38,38,32,99,112,112,95,116,121,112,101,32,61,61,32,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,67,80,80,84,89,80,69,95,73,78,84,51,50,41,58,32,0,84,104,101,32,116,121,112,101,32,112,97,114,97,109,101,116,101,114,32,84,32,105,110,32,82,101,112,101,97,116,101,100,70,105,101,108,100,82,101,102,60,84,62,32,65,80,73,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,0,116,104,101,32,97,99,116,117,97,108,32,102,105,101,108,100,32,116,121,112,101,32,40,102,111,114,32,101,110,117,109,115,32,84,32,115,104,111,117,108,100,32,98,101,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,101,110,117,109,32,0,116,121,112,101,32,111,114,32,105,110,116,51,50,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,95,116,121,112,101,41,32,61,61,32,40,102,105,101,108,100,45,62,109,101,115,115,97,103,101,95,116,121,112,101,40,41,41,58,32,0,34,71,101,116,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,34,0,70,105,101,108,100,32,105,115,32,115,105,110,103,117,108,97,114,59,32,116,104,101,32,109,101,116,104,111,100,32,114,101,113,117,105,114,101,115,32,97,32,114,101,112,101,97,116,101,100,32,102,105,101,108,100,46,0,71,101,116,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,105,101,108,100,45,62,111,112,116,105,111,110,115,40,41,46,99,116,121,112,101,40,41,41,32,61,61,32,40,99,116,121,112,101,41,58,32,0,115,117,98,116,121,112,101,32,109,105,115,109,97,116,99,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,105,101,108,100,45,62,109,101,115,115,97,103,101,95,116,121,112,101,40,41,41,32,61,61,32,40,100,101,115,99,41,58,32,0,119,114,111,110,103,32,115,117,98,109,101,115,115,97,103,101,32,116,121,112,101,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,70,105,101,108,100,32,105,115,32,110,111,116,32,116,104,101,32,114,105,103,104,116,32,116,121,112,101,32,102,111,114,32,116,104,105,115,32,109,101,115,115,97,103,101,58,10,32,32,32,32,69,120,112,101,99,116,101,100,32,32,58,32,0,10,32,32,32,32,70,105,101,108,100,32,116,121,112,101,58,32,0,73,78,86,65,76,73,68,95,67,80,80,84,89,80,69,0,67,80,80,84,89,80,69,95,73,78,84,51,50,0,67,80,80,84,89,80,69,95,73,78,84,54,52,0,67,80,80,84,89,80,69,95,85,73,78,84,51,50,0,67,80,80,84,89,80,69,95,85,73,78,84,54,52,0,67,80,80,84,89,80,69,95,68,79,85,66,76,69,0,67,80,80,84,89,80,69,95,70,76,79,65,84,0,67,80,80,84,89,80,69,95,66,79,79,76,0,67,80,80,84,89,80,69,95,69,78,85,77,0,67,80,80,84,89,80,69,95,83,84,82,73,78,71,0,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,0,34,77,117,116,97,98,108,101,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,34,0,77,117,116,97,98,108,101,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,0,65,100,100,65,108,108,111,99,97,116,101,100,77,101,115,115,97,103,101,0,70,105,101,108,100,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,65,100,100,77,101,115,115,97,103,101,0,65,100,100,69,110,117,109,0,65,100,100,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,118,97,108,117,101,32,0,32,117,110,101,120,112,101,99,116,101,100,32,102,111,114,32,102,105,101,108,100,32,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,69,110,117,109,32,118,97,108,117,101,32,100,105,100,32,110,111,116,32,109,97,116,99,104,32,102,105,101,108,100,32,116,121,112,101,58,10,32,32,32,32,69,120,112,101,99,116,101,100,32,32,58,32,0,10,32,32,32,32,65,99,116,117,97,108,32,32,32,32,58,32,0,65,100,100,83,116,114,105,110,103,0,65,100,100,66,111,111,108,0,65,100,100,68,111,117,98,108,101,0,65,100,100,70,108,111,97,116,0,65,100,100,85,73,110,116,54,52,0,65,100,100,85,73,110,116,51,50,0,65,100,100,73,110,116,54,52,0,65,100,100,73,110,116,51,50,0,77,117,116,97,98,108,101,82,101,112,101,97,116,101,100,77,101,115,115,97,103,101,0,83,101,116,82,101,112,101,97,116,101,100,69,110,117,109,0,83,101,116,82,101,112,101,97,116,101,100,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,0,118,97,108,117,101,32,0,83,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,0,83,101,116,82,101,112,101,97,116,101,100,66,111,111,108,0,83,101,116,82,101,112,101,97,116,101,100,68,111,117,98,108,101,0,83,101,116,82,101,112,101,97,116,101,100,70,108,111,97,116,0,83,101,116,82,101,112,101,97,116,101,100,85,73,110,116,54,52,0,83,101,116,82,101,112,101,97,116,101,100,85,73,110,116,51,50,0,83,101,116,82,101,112,101,97,116,101,100,73,110,116,54,52,0,83,101,116,82,101,112,101,97,116,101,100,73,110,116,51,50,0,71,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,82,101,102,101,114,101,110,99,101,0,71,101,116,82,101,112,101,97,116,101,100,77,101,115,115,97,103,101,0,71,101,116,82,101,112,101,97,116,101,100,69,110,117,109,86,97,108,117,101,0,71,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,0,71,101,116,82,101,112,101,97,116,101,100,66,111,111,108,0,71,101,116,82,101,112,101,97,116,101,100,68,111,117,98,108,101,0,71,101,116,82,101,112,101,97,116,101,100,70,108,111,97,116,0,71,101,116,82,101,112,101,97,116,101,100,85,73,110,116,54,52,0,71,101,116,82,101,112,101,97,116,101,100,85,73,110,116,51,50,0,71,101,116,82,101,112,101,97,116,101,100,73,110,116,54,52,0,71,101,116,82,101,112,101,97,116,101,100,73,110,116,51,50,0,82,101,108,101,97,115,101,77,101,115,115,97,103,101,0,70,105,101,108,100,32,105,115,32,114,101,112,101,97,116,101,100,59,32,116,104,101,32,109,101,116,104,111,100,32,114,101,113,117,105,114,101,115,32,97,32,115,105,110,103,117,108,97,114,32,102,105,101,108,100,46,0,83,101,116,65,108,108,111,99,97,116,101,100,77,101,115,115,97,103,101,0,77,117,116,97,98,108,101,77,101,115,115,97,103,101,0,83,101,116,69,110,117,109,86,97,108,117,101,0,83,101,116,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,118,97,108,117,101,32,0,83,101,116,69,110,117,109,0,83,101,116,83,116,114,105,110,103,0,83,101,116,66,111,111,108,0,83,101,116,68,111,117,98,108,101,0,83,101,116,70,108,111,97,116,0,83,101,116,85,73,110,116,54,52,0,83,101,116,85,73,110,116,51,50,0,83,101,116,73,110,116,54,52,0,83,101,116,73,110,116,51,50,0,71,101,116,83,116,114,105,110,103,82,101,102,101,114,101,110,99,101,0,71,101,116,77,101,115,115,97,103,101,0,71,101,116,69,110,117,109,86,97,108,117,101,0,71,101,116,83,116,114,105,110,103,0,71,101,116,66,111,111,108,0,71,101,116,68,111,117,98,108,101,0,71,101,116,70,108,111,97,116,0,71,101,116,85,73,110,116,54,52,0,71,101,116,85,73,110,116,51,50,0,71,101,116,73,110,116,54,52,0,71,101,116,73,110,116,51,50,0,82,101,97,99,104,101,100,32,105,109,112,111,115,115,105,98,108,101,32,99,97,115,101,32,105,110,32,72,97,115,66,105,116,40,41,46,0,83,119,97,112,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,49,45,62,71,101,116,82,101,102,108,101,99,116,105,111,110,40,41,41,32,61,61,32,40,116,104,105,115,41,58,32,0,70,105,114,115,116,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,70,105,101,108,100,115,40,41,32,40,111,102,32,116,121,112,101,32,34,0,34,41,32,105,115,32,110,111,116,32,99,111,109,112,97,116,105,98,108,101,32,119,105,116,104,32,116,104,105,115,32,114,101,102,108,101,99,116,105,111,110,32,111,98,106,101,99,116,32,40,119,104,105,99,104,32,105,115,32,102,111,114,32,116,121,112,101,32,34,0,34,41,46,32,32,78,111,116,101,32,116,104,97,116,32,116,104,101,32,101,120,97,99,116,32,115,97,109,101,32,99,108,97,115,115,32,105,115,32,114,101,113,117,105,114,101,100,59,32,110,111,116,32,106,117,115,116,32,116,104,101,32,115,97,109,101,32,100,101,115,99,114,105,112,116,111,114,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,50,45,62,71,101,116,82,101,102,108,101,99,116,105,111,110,40,41,41,32,61,61,32,40,116,104,105,115,41,58,32,0,83,101,99,111,110,100,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,70,105,101,108,100,115,40,41,32,40,111,102,32,116,121,112,101,32,34,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,116,121,112,101,58,32,0,70,105,114,115,116,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,40,41,32,40,111,102,32,116,121,112,101,32,34,0,83,101,99,111,110,100,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,40,41,32,40,111,102,32,116,121,112,101,32,34,0,82,101,108,101,97,115,101,76,97,115,116,0,82,101,109,111,118,101,76,97,115,116,0,67,108,101,97,114,70,105,101,108,100,0,70,105,101,108,100,83,105,122,101,0,72,97,115,70,105,101,108,100,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,54,71,101,110,101,114,97,116,101,100,77,101,115,115,97,103,101,82,101,102,108,101,99,116,105,111,110,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,32,33,61,32,78,85,76,76,58,32,0,37,46,49,102,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,115,116,114,116,111,100,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,101,109,112,91,48,93,41,32,61,61,32,40,39,49,39,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,101,109,112,91,115,105,122,101,45,49,93,41,32,61,61,32,40,39,53,39,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,115,105,122,101,41,32,60,61,32,40,54,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,52,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,115,116,114,105,110,103,46,0,83,116,114,105,110,103,32,108,105,116,101,114,97,108,115,32,99,97,110,110,111,116,32,99,114,111,115,115,32,108,105,110,101,32,98,111,117,110,100,97,114,105,101,115,46,0,69,120,112,101,99,116,101,100,32,104,101,120,32,100,105,103,105,116,115,32,102,111,114,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,46,0,69,120,112,101,99,116,101,100,32,102,111,117,114,32,104,101,120,32,100,105,103,105,116,115,32,102,111,114,32,92,117,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,46,0,69,120,112,101,99,116,101,100,32,101,105,103,104,116,32,104,101,120,32,100,105,103,105,116,115,32,117,112,32,116,111,32,49,48,102,102,102,102,32,102,111,114,32,92,85,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,32,105,110,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,46,0,34,48,120,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,104,101,120,32,100,105,103,105,116,115,46,0,78,117,109,98,101,114,115,32,115,116,97,114,116,105,110,103,32,119,105,116,104,32,108,101,97,100,105,110,103,32,122,101,114,111,32,109,117,115,116,32,98,101,32,105,110,32,111,99,116,97,108,46,0,34,101,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,101,120,112,111,110,101,110,116,46,0,78,101,101,100,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,110,117,109,98,101,114,32,97,110,100,32,105,100,101,110,116,105,102,105,101,114,46,0,65,108,114,101,97,100,121,32,115,97,119,32,100,101,99,105,109,97,108,32,112,111,105,110,116,32,111,114,32,101,120,112,111,110,101,110,116,59,32,99,97,110,39,116,32,104,97,118,101,32,97,110,111,116,104,101,114,32,111,110,101,46,0,72,101,120,32,97,110,100,32,111,99,116,97,108,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,115,46,0,34,47,42,34,32,105,110,115,105,100,101,32,98,108,111,99,107,32,99,111,109,109,101,110,116,46,32,32,66,108,111,99,107,32,99,111,109,109,101,110,116,115,32,99,97,110,110,111,116,32,98,101,32,110,101,115,116,101,100,46,0,69,110,100,45,111,102,45,102,105,108,101,32,105,110,115,105,100,101,32,98,108,111,99,107,32,99,111,109,109,101,110,116,46,0,32,32,67,111,109,109,101,110,116,32,115,116,97,114,116,101,100,32,104,101,114,101,46,0,73,110,118,97,108,105,100,32,99,111,110,116,114,111,108,32,99,104,97,114,97,99,116,101,114,115,32,101,110,99,111,117,110,116,101,114,101,100,32,105,110,32,116,101,120,116,46,0,78,101,101,100,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,105,100,101,110,116,105,102,105,101,114,32,97,110,100,32,100,101,99,105,109,97,108,32,112,111,105,110,116,46,0,73,110,116,101,114,112,114,101,116,105,110,103,32,110,111,110,32,97,115,99,105,105,32,99,111,100,101,112,111,105,110,116,32,37,100,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,116,111,107,101,110,105,122,101,114,46,99,99,0,32,84,111,107,101,110,105,122,101,114,58,58,80,97,114,115,101,70,108,111,97,116,40,41,32,112,97,115,115,101,100,32,116,101,120,116,32,116,104,97,116,32,99,111,117,108,100,32,110,111,116,32,104,97,118,101,32,98,101,101,110,32,116,111,107,101,110,105,122,101,100,32,97,115,32,97,32,102,108,111,97,116,58,32,0,32,84,111,107,101,110,105,122,101,114,58,58,80,97,114,115,101,83,116,114,105,110,103,65,112,112,101,110,100,40,41,32,112,97,115,115,101,100,32,116,101,120,116,32,116,104,97,116,32,99,111,117,108,100,32,110,111,116,32,104,97,118,101,32,98,101,101,110,32,116,111,107,101,110,105,122,101,100,32,97,115,32,97,32,115,116,114,105,110,103,58,32,0,92,85,37,48,56,120,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,50,53,67,111,112,121,105,110,103,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,70,105,101,108,100,66,97,115,101,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+491524);allocate([100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,46,104,0,85,110,115,117,112,112,111,114,116,101,100,58,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,109,97,112,32,117,115,97,103,101,32,101,114,114,111,114,58,10,0,77,97,112,75,101,121,58,58,71,101,116,66,111,111,108,86,97,108,117,101,0,32,116,121,112,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,10,0,32,32,69,120,112,101,99,116,101,100,32,58,32,0,32,32,65,99,116,117,97,108,32,32,32,58,32,0,77,97,112,75,101,121,58,58,71,101,116,85,73,110,116,51,50,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,85,73,110,116,54,52,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,73,110,116,51,50,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,73,110,116,54,52,86,97,108,117,101,0,107,101,121,0,118,97,108,117,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,46,99,99,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,77,101,115,115,97,103,101,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,116,121,112,101,32,77,97,112,86,97,108,117,101,82,101,102,32,105,115,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,100,46,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,69,110,117,109,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,70,108,111,97,116,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,68,111,117,98,108,101,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,66,111,111,108,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,85,73,110,116,51,50,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,85,73,110,116,54,52,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,73,110,116,51,50,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,73,110,116,54,52,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,83,116,114,105,110,103,86,97,108,117,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,53,68,121,110,97,109,105,99,77,97,112,70,105,101,108,100,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,84,121,112,101,68,101,102,105,110,101,100,77,97,112,70,105,101,108,100,66,97,115,101,73,78,83,48,95,54,77,97,112,75,101,121,69,78,83,48,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,77,97,112,73,78,83,48,95,54,77,97,112,75,101,121,69,78,83,48,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,56,73,110,110,101,114,77,97,112,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,52,104,97,115,104,73,78,83,48,95,54,77,97,112,75,101,121,69,69,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,101,115,115,97,103,101,46,99,99,0,77,101,115,115,97,103,101,32,99,108,97,115,115,32,34,0,34,32,105,109,112,108,101,109,101,110,116,115,32,110,101,105,116,104,101,114,32,83,101,116,67,97,99,104,101,100,83,105,122,101,40,41,32,110,111,114,32,66,121,116,101,83,105,122,101,40,41,46,32,32,77,117,115,116,32,105,109,112,108,101,109,101,110,116,32,111,110,101,32,111,114,32,116,104,101,32,111,116,104,101,114,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,114,111,109,46,71,101,116,68,101,115,99,114,105,112,116,111,114,40,41,41,32,61,61,32,40,100,101,115,99,114,105,112,116,111,114,41,58,32,0,58,32,84,114,105,101,100,32,116,111,32,109,101,114,103,101,32,102,114,111,109,32,97,32,109,101,115,115,97,103,101,32,119,105,116,104,32,97,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,46,32,32,116,111,58,32,0,44,32,102,114,111,109,58,32,0,58,32,84,114,105,101,100,32,116,111,32,99,111,112,121,32,102,114,111,109,32,97,32,109,101,115,115,97,103,101,32,119,105,116,104,32,97,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,46,32,116,111,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,55,77,101,115,115,97,103,101,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,45,62,105,115,95,114,101,112,101,97,116,101,100,40,41,58,32,0,83,104,111,117,108,100,32,110,111,116,32,114,101,97,99,104,32,104,101,114,101,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,102,108,101,99,116,105,111,110,95,105,110,116,101,114,110,97,108,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,104,105,115,32,61,61,32,111,116,104,101,114,95,109,117,116,97,116,111,114,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,49,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,77,101,115,115,97,103,101,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,87,114,97,112,112,101,114,73,78,83,48,95,55,77,101,115,115,97,103,101,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,51,82,97,110,100,111,109,65,99,99,101,115,115,82,101,112,101,97,116,101,100,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,49,82,101,112,101,97,116,101,100,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,77,97,112,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,83,116,114,105,110,103,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,87,114,97,112,112,101,114,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,82,101,102,108,101,99,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,70,105,108,101,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,105,110,32,103,101,110,101,114,97,116,101,100,32,112,111,111,108,32,98,117,116,32,119,97,115,110,39,116,32,114,101,103,105,115,116,101,114,101,100,58,32,0,84,121,112,101,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,105,110,32,103,101,110,101,114,97,116,101,100,32,112,111,111,108,32,98,117,116,32,119,97,115,110,39,116,32,0,114,101,103,105,115,116,101,114,101,100,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,51,71,101,110,101,114,97,116,101,100,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,70,105,108,101,32,105,115,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,58,32,0,84,121,112,101,32,105,115,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,58,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,102,108,101,99,116,105,111,110,95,111,112,115,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,38,102,114,111,109,41,32,33,61,32,40,116,111,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,111,45,62,71,101,116,68,101,115,99,114,105,112,116,111,114,40,41,41,32,61,61,32,40,100,101,115,99,114,105,112,116,111,114,41,58,32,0,84,114,105,101,100,32,116,111,32,109,101,114,103,101,32,109,101,115,115,97,103,101,115,32,111,102,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,32,0,40,109,101,114,103,101,32,0,32,116,111,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,115,117,98,115,116,105,116,117,116,101,46,99,99,0,115,116,114,105,110,103,115,58,58,83,117,98,115,116,105,116,117,116,101,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,105,110,118,97,108,105,100,58,32,97,115,107,101,100,32,102,111,114,32,34,36,0,34,44,32,98,117,116,32,111,110,108,121,32,0,32,97,114,103,115,32,119,101,114,101,32,103,105,118,101,110,46,32,32,70,117,108,108,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,119,97,115,58,32,34,0,73,110,118,97,108,105,100,32,115,116,114,105,110,103,115,58,58,83,117,98,115,116,105,116,117,116,101,40,41,32,102,111,114,109,97,116,32,115,116,114,105,110,103,58,32,34,0,125,32,0,125,10,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,49,55,66,97,115,101,84,101,120,116,71,101,110,101,114,97,116,111,114,69,0,32,123,32,0,32,123,10,0,91,0,34,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,50,49,70,97,115,116,70,105,101,108,100,86,97,108,117,101,80,114,105,110,116,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,54,70,105,110,100,101,114,69,0,10,0,58,32,48,120,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,116,101,120,116,95,102,111,114,109,97,116,46,99,99,0,32,79,117,116,100,101,110,116,40,41,32,119,105,116,104,111,117,116,32,109,97,116,99,104,105,110,103,32,73,110,100,101,110,116,40,41,46,0,58,32,34,0,34,32,0,34,10,0,46,46,46,60,116,114,117,110,99,97,116,101,100,62,46,46,46,0,37,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,121,110,97,109,105,99,95,109,101,115,115,97,103,101,46,104,0,58,32,91,0,93,10,0,80,114,111,116,111,32,116,121,112,101,32,0,32,110,111,116,32,102,111,117,110,100,0,58,32,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,99,111,110,116,101,110,116,115,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,55,80,114,105,110,116,101,114,49,51,84,101,120,116,71,101,110,101,114,97,116,111,114,69,0,77,101,115,115,97,103,101,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,69,114,114,111,114,32,112,97,114,115,105,110,103,32,116,101,120,116,45,102,111,114,109,97,116,32,0,58,0,78,111,110,45,114,101,112,101,97,116,101,100,32,65,110,121,32,115,112,101,99,105,102,105,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,120,116,101,110,115,105,111,110,32,34,0,34,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,32,111,114,32,105,115,32,110,111,116,32,97,110,32,101,120,116,101,110,115,105,111,110,32,111,102,32,34,0,34,46,0,77,101,115,115,97,103,101,32,116,121,112,101,32,34,0,34,32,104,97,115,32,110,111,32,102,105,101,108,100,32,110,97,109,101,100,32,34,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,97,108,108,111,119,95,117,110,107,110,111,119,110,95,102,105,101,108,100,95,32,124,124,32,114,101,115,101,114,118,101,100,95,102,105,101,108,100,58,32,0,78,111,110,45,114,101,112,101,97,116,101,100,32,102,105,101,108,100,32,34,0,34,32,105,115,32,115,112,101,99,105,102,105,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,70,105,101,108,100,32,34,0,34,32,105,115,32,115,112,101,99,105,102,105,101,100,32,97,108,111,110,103,32,119,105,116,104,32,102,105,101,108,100,32,34,0,34,44,32,97,110,111,116,104,101,114,32,109,101,109,98,101,114,32,111,102,32,111,110,101,111,102,32,34,0,116,101,120,116,32,102,111,114,109,97,116,32,99,111,110,116,97,105,110,115,32,100,101,112,114,101,99,97,116,101,100,32,102,105,101,108,100,32,34,0,84,114,117,101,0,116,0,70,97,108,115,101,0,102,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,98,111,111,108,101,97,110,32,102,105,101,108,100,32,34,0,34,46,32,86,97,108,117,101,58,32,34,0,69,120,112,101,99,116,101,100,32,105,110,116,101,103,101,114,32,111,114,32,105,100,101,110,116,105,102,105,101,114,44,32,103,111,116,58,32,0,85,110,107,110,111,119,110,32,101,110,117,109,101,114,97,116,105,111,110,32,118,97,108,117,101,32,111,102,32,34,0,34,32,102,111,114,32,102,105,101,108,100,32,34,0,82,101,97,99,104,101,100,32,97,110,32,117,110,105,110,116,101,110,100,101,100,32,115,116,97,116,101,58,32,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,0,69,120,112,101,99,116,101,100,32,100,111,117,98,108,101,44,32,103,111,116,58,32,0,69,120,112,101,99,116,101,100,32,105,110,116,101,103,101,114,44,32,103,111,116,58,32,0,69,120,112,101,99,116,32,97,32,100,101,99,105,109,97,108,32,110,117,109,98,101,114,44,32,103,111,116,58,32,0,73,110,116,101,103,101,114,32,111,117,116,32,111,102,32,114,97,110,103,101,32,40,0,125,0,69,120,112,101,99,116,101,100,32,115,116,114,105,110,103,44,32,103,111,116,58,32,0,73,110,118,97,108,105,100,32,102,108,111,97,116,32,110,117,109,98,101,114,58,32,0,69,120,112,101,99,116,101,100,32,105,100,101,110,116,105,102,105,101,114,44,32,103,111,116,58,32,0,87,97,114,110,105,110,103,32,112,97,114,115,105,110,103,32,116,101,120,116,45,102,111,114,109,97,116,32,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,116,121,112,101,32,34,0,34,32,115,116,111,114,101,100,32,105,110,32,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,46,0,86,97,108,117,101,32,111,102,32,116,121,112,101,32,34,0,34,32,115,116,111,114,101,100,32,105,110,32,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,32,104,97,115,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,0,69,120,112,101,99,116,101,100,32,34,0,34,44,32,102,111,117,110,100,32,34,0,84,101,120,116,70,111,114,109,97,116,58,58,80,97,114,115,101,114,32,102,111,114,32,65,110,121,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,116,121,112,101,46,103,111,111,103,108,101,97,112,105,115,46,99,111,109,32,97,110,100,32,116,121,112,101,46,103,111,111,103,108,101,112,114,111,100,46,99,111,109,44,32,98,117,116,32,102,111,117,110,100,32,34,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,54,80,97,114,115,101,114,49,48,80,97,114,115,101,114,73,109,112,108,50,48,80,97,114,115,101,114,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,55,85,110,107,110,111,119,110,70,105,101,108,100,83,101,116,70,105,101,108,100,83,107,105,112,112,101,114,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,119,105,114,101,95,102,111,114,109,97,116,46,99,99,0,69,120,116,101,110,115,105,111,110,115,32,111,102,32,77,101,115,115,97,103,101,83,101,116,115,32,109,117,115,116,32,98,101,32,111,112,116,105,111,110,97,108,32,109,101,115,115,97,103,101,115,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,111,117,116,112,117,116,45,62,66,121,116,101,67,111,117,110,116,40,41,41,32,61,61,32,40,101,120,112,101,99,116,101,100,95,101,110,100,112,111,105,110,116,41,58,32,0,58,32,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,115,101,114,105,97,108,105,122,101,100,32,116,111,32,97,32,115,105,122,101,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,119,104,97,116,32,119,97,115,32,111,114,105,103,105,110,97,108,108,121,32,101,120,112,101,99,116,101,100,46,32,32,80,101,114,104,97,112,115,32,105,116,32,119,97,115,32,109,111,100,105,102,105,101,100,32,98,121,32,97,110,111,116,104,101,114,32,116,104,114,101,97,100,32,100,117,114,105,110,103,32,115,101,114,105,97,108,105,122,97,116,105,111,110,63,0,85,110,115,117,112,112,111,114,116,101,100,0,67,97,110,110,111,116,32,103,101,116,32,104,101,114,101,0,73,110,118,97,108,105,100,32,107,101,121,32,102,111,114,32,109,97,112,32,102,105,101,108,100,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,53,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,52,71,101,110,101,114,97,116,101,100,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,101,120,116,101,110,115,105,111,110,95,115,101,116,46,99,99,0,67,97,110,39,116,32,103,101,116,32,104,101,114,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,116,101,114,32,33,61,32,101,120,116,101,110,115,105,111,110,115,95,46,101,110,100,40,41,58,32,0,73,110,100,101,120,32,111,117,116,45,111,102,45,98,111,117,110,100,115,32,40,102,105,101,108,100,32,105,115,32,101,109,112,116,121,41,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,99,97,110,39,116,32,114,101,97,99,104,32,104,101,114,101,46,0,78,111,110,45,112,114,105,109,105,116,105,118,101,32,116,121,112,101,115,32,99,97,110,39,116,32,98,101,32,112,97,99,107,101,100,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,122,101,114,111,95,99,111,112,121,95,115,116,114,101,97,109,46,99,99,0,84,104,105,115,32,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,97,108,105,97,115,105,110,103,46,32,82,101,97,99,104,105,110,103,32,104,101,114,101,32,117,115,117,97,108,108,121,32,109,101,97,110,115,32,97,32,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,32,98,117,103,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,50,48,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,3,3,3,3,3,3,3,3,3,3,3,3,7,3,3,4,5,5,5,6,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,4,4,4,4,4,4,4,4,2,2,4,4,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0,48,48,48,49,48,50,48,51,48,52,48,53,48,54,48,55,48,56,48,57,49,48,49,49,49,50,49,51,49,52,49,53,49,54,49,55,49,56,49,57,50,48,50,49,50,50,50,51,50,52,50,53,50,54,50,55,50,56,50,57,51,48,51,49,51,50,51,51,51,52,51,53,51,54,51,55,51,56,51,57,52,48,52,49,52,50,52,51,52,52,52,53,52,54,52,55,52,56,52,57,53,48,53,49,53,50,53,51,53,52,53,53,53,54,53,55,53,56,53,57,54,48,54,49,54,50,54,51,54,52,54,53,54,54,54,55,54,56,54,57,55,48,55,49,55,50,55,51,55,52,55,53,55,54,55,55,55,56,55,57,56,48,56,49,56,50,56,51,56,52,56,53,56,54,56,55,56,56,56,57,57,48,57,49,57,50,57,51,57,52,57,53,57,54,57,55,57,56,57,57,45,105,110,102,0,37,46,42,103,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,0,116,121,112,101,46,103,111,111,103,108,101,97,112,105,115,46,99,111,109,47,0,116,121,112,101,46,103,111,111,103,108,101,112,114,111,100,46,99,111,109,47,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,100,105,115,116,97,110,99,101,32,116,121,112,101,0,114,101,108,101,97,115,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,108,97,110,110,47,115,114,99,47,109,105,110,105,102,108,97,110,110,46,99,112,112,0,114,98,0,82,101,97,100,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,32,101,114,114,111,114,58,32,116,104,101,32,115,97,118,101,100,32,100,97,116,97,32,115,105,122,101,32,40,37,100,44,32,37,100,41,32,111,114,32,116,121,112,101,32,40,37,100,41,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,116,104,101,32,112,97,115,115,101,100,32,111,110,101,32,40,37,100,44,32,37,100,41,44,32,37,100,10,0,67,97,110,110,111,116,32,114,101,97,100,32,102,114,111,109,32,102,105,108,101,0,82,101,97,100,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,32,101,114,114,111,114,58,32,117,110,115,117,112,112,111,114,116,101,100,32,102,101,97,116,117,114,101,32,116,121,112,101,32,37,100,32,102,111,114,32,116,104,101,32,105,110,100,101,120,32,116,121,112,101,32,37,100,10,0,82,101,97,100,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,32,101,114,114,111,114,58,32,117,110,115,117,112,112,111,114,116,101,100,32,100,105,115,116,97,110,99,101,32,116,121,112,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+501764);allocate([32,37,100,10,0,68,97,116,97,84,121,112,101,60,69,108,101,109,101,110,116,84,121,112,101,62,58,58,116,121,112,101,32,61,61,32,100,97,116,97,46,116,121,112,101,40,41,32,38,38,32,100,97,116,97,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,111,97,100,73,110,100,101,120,95,0,97,108,103,111,114,105,116,104,109,0,85,110,107,110,111,119,110,32,105,110,100,101,120,32,116,121,112,101,0,116,97,98,108,101,95,110,117,109,98,101,114,0,109,117,108,116,105,95,112,114,111,98,101,95,108,101,118,101,108,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,50,98,97,100,95,97,110,121,95,99,97,115,116,69,0,76,83,72,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,32,102,111,114,32,116,104,97,116,32,116,121,112,101,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,106,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,106,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,53,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,69,0,73,32,99,97,110,32,111,110,108,121,32,115,101,97,114,99,104,32,111,110,101,32,102,101,97,116,117,114,101,32,97,116,32,97,32,116,105,109,101,32,102,111,114,32,114,97,110,103,101,32,115,101,97,114,99,104,10,0,115,111,114,116,101,100,0,78,55,99,118,102,108,97,110,110,49,53,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,57,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,50,49,82,97,100,105,117,115,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,49,56,75,78,78,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,97,108,108,111,99,97,116,111,114,60,84,62,58,58,97,108,108,111,99,97,116,101,40,115,105,122,101,95,116,32,110,41,32,39,110,39,32,101,120,99,101,101,100,115,32,109,97,120,105,109,117,109,32,115,117,112,112,111,114,116,101,100,32,115,105,122,101,0,78,55,99,118,102,108,97,110,110,56,76,115,104,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,55,78,78,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,98,114,97,110,99,104,105,110,103,0,99,101,110,116,101,114,115,95,105,110,105,116,0,78,55,99,118,102,108,97,110,110,50,48,102,108,97,110,110,95,99,101,110,116,101,114,115,95,105,110,105,116,95,116,69,0,116,114,101,101,115,0,108,101,97,102,95,115,105,122,101,0,85,110,107,110,111,119,110,32,97,108,103,111,114,105,116,104,109,32,102,111,114,32,99,104,111,111,115,105,110,103,32,105,110,105,116,105,97,108,32,99,101,110,116,101,114,115,46,0,99,104,101,99,107,115,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,50,48,102,108,97,110,110,95,99,101,110,116,101,114,115,95,105,110,105,116,95,116,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,50,48,102,108,97,110,110,95,99,101,110,116,101,114,115,95,105,110,105,116,95,116,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,105,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,105,69,69,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,46,10,0,66,114,97,110,99,104,105,110,103,32,102,97,99,116,111,114,32,109,117,115,116,32,98,101,32,97,116,32,108,101,97,115,116,32,50,0,78,55,99,118,102,108,97,110,110,50,55,72,105,101,114,97,114,99,104,105,99,97,108,67,108,117,115,116,101,114,105,110,103,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,116,97,114,103,101,116,95,112,114,101,99,105,115,105,111,110,0,98,117,105,108,100,95,119,101,105,103,104,116,0,109,101,109,111,114,121,95,119,101,105,103,104,116,0,115,97,109,112,108,101,95,102,114,97,99,116,105,111,110,0,101,112,115,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,98,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,98,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,102,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,102,69,69,0,77,105,115,115,105,110,103,32,112,97,114,97,109,101,116,101,114,32,39,0,39,32,105,110,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,32,103,105,118,101,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,108,97,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,102,108,97,110,110,47,103,101,110,101,114,97,108,46,104,0,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,0,65,117,116,111,116,117,110,101,100,32,112,97,114,97,109,101,116,101,114,115,58,10,0,83,101,97,114,99,104,32,112,97,114,97,109,101,116,101,114,115,58,10,0,67,111,109,112,117,116,105,110,103,32,103,114,111,117,110,100,32,116,114,117,116,104,10,0,69,115,116,105,109,97,116,105,110,103,32,110,117,109,98,101,114,32,111,102,32,99,104,101,99,107,115,10,0,75,77,101,97,110,115,32,97,108,103,111,114,105,116,104,109,44,32,101,115,116,105,109,97,116,105,110,103,32,99,108,117,115,116,101,114,32,98,111,114,100,101,114,32,102,97,99,116,111,114,10,0,79,112,116,105,109,117,109,32,99,98,95,105,110,100,101,120,58,32,37,103,10,0,82,101,113,117,105,114,101,100,32,110,117,109,98,101,114,32,111,102,32,99,104,101,99,107,115,58,32,37,100,32,10,0,32,32,78,111,100,101,115,32,32,80,114,101,99,105,115,105,111,110,40,37,41,32,32,32,84,105,109,101,40,115,41,32,32,32,84,105,109,101,47,118,101,99,40,109,115,41,32,32,77,101,97,110,32,100,105,115,116,10,0,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,0,71,111,116,32,97,115,32,99,108,111,115,101,32,97,115,32,73,32,99,97,110,10,0,83,116,97,114,116,32,108,105,110,101,97,114,32,101,115,116,105,109,97,116,105,111,110,10,0,78,111,32,110,101,101,100,32,102,111,114,32,108,105,110,101,97,114,32,101,115,116,105,109,97,116,105,111,110,10,0,109,97,116,99,104,101,115,46,99,111,108,115,61,37,100,44,32,110,110,61,37,100,10,0,71,114,111,117,110,100,32,116,114,117,116,104,32,105,115,32,110,111,116,32,99,111,109,112,117,116,101,100,32,102,111,114,32,97,115,32,109,97,110,121,32,110,101,105,103,104,98,111,114,115,32,97,115,32,114,101,113,117,101,115,116,101,100,0,37,56,100,32,37,49,48,46,52,103,32,37,49,48,46,53,103,32,37,49,48,46,53,103,32,37,49,48,46,53,103,10,0,78,55,99,118,102,108,97,110,110,49,50,75,78,78,82,101,115,117,108,116,83,101,116,73,102,69,69,0,32,58,32,0,69,110,116,101,114,105,110,103,32,97,117,116,111,116,117,110,105,110,103,44,32,100,97,116,97,115,101,116,32,115,105,122,101,58,32,37,100,44,32,115,97,109,112,108,101,83,105,122,101,58,32,37,100,44,32,116,101,115,116,83,97,109,112,108,101,83,105,122,101,58,32,37,100,44,32,116,97,114,103,101,116,32,112,114,101,99,105,115,105,111,110,58,32,37,103,10,0,67,104,111,111,115,105,110,103,32,108,105,110,101,97,114,44,32,100,97,116,97,115,101,116,32,116,111,111,32,115,109,97,108,108,10,0,67,111,109,112,117,116,105,110,103,32,103,114,111,117,110,100,32,116,114,117,116,104,46,46,46,32,10,0,65,117,116,111,116,117,110,105,110,103,32,112,97,114,97,109,101,116,101,114,115,46,46,46,10,0,75,68,45,84,82,69,69,44,32,83,116,101,112,32,49,58,32,69,120,112,108,111,114,105,110,103,32,112,97,114,97,109,101,116,101,114,32,115,112,97,99,101,10,0,75,68,84,114,101,101,32,117,115,105,110,103,32,112,97,114,97,109,115,58,32,116,114,101,101,115,61,37,100,10,0,75,68,84,114,101,101,32,98,117,105,108,100,84,105,109,101,61,37,103,44,32,115,101,97,114,99,104,84,105,109,101,61,37,103,10,0,73,116,32,100,111,101,115,110,39,116,32,109,97,107,101,32,97,110,121,32,115,101,110,115,101,32,116,111,32,117,115,101,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,116,114,101,101,32,102,111,114,32,101,120,97,99,116,32,115,101,97,114,99,104,0,80,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,0,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,52,78,111,100,101,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,75,77,69,65,78,83,44,32,83,116,101,112,32,49,58,32,69,120,112,108,111,114,105,110,103,32,112,97,114,97,109,101,116,101,114,32,115,112,97,99,101,10,0,105,116,101,114,97,116,105,111,110,115,0,75,77,101,97,110,115,84,114,101,101,32,117,115,105,110,103,32,112,97,114,97,109,115,58,32,109,97,120,95,105,116,101,114,97,116,105,111,110,115,61,37,100,44,32,98,114,97,110,99,104,105,110,103,61,37,100,10,0,75,77,101,97,110,115,84,114,101,101,32,98,117,105,108,100,84,105,109,101,61,37,103,44,32,115,101,97,114,99,104,84,105,109,101,61,37,103,44,32,98,117,105,108,100,95,119,101,105,103,104,116,61,37,103,10,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,78,55,99,118,102,108,97,110,110,49,52,65,117,116,111,116,117,110,101,100,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,66,117,105,108,100,105,110,103,32,107,109,101,97,110,115,32,116,114,101,101,46,46,46,10,0,66,117,105,108,100,105,110,103,32,107,100,116,114,101,101,32,116,114,101,101,46,46,46,10,0,78,55,99,118,102,108,97,110,110,49,52,67,111,109,112,111,115,105,116,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,100,105,109,0,108,101,97,102,95,109,97,120,95,115,105,122,101,0,114,101,111,114,100,101,114,0,78,55,99,118,102,108,97,110,110,49,56,75,78,78,83,105,109,112,108,101,82,101,115,117,108,116,83,101,116,73,102,69,69,0,78,55,99,118,102,108,97,110,110,49,55,75,68,84,114,101,101,83,105,110,103,108,101,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,76,105,110,101,97,114,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,68,97,116,97,116,121,112,101,32,111,102,32,115,97,118,101,100,32,105,110,100,101,120,32,105,115,32,100,105,102,102,101,114,101,110,116,32,116,104,97,110,32,111,102,32,116,104,101,32,111,110,101,32,116,111,32,98,101,32,99,114,101,97,116,101,100,46,0,84,104,101,32,105,110,100,101,120,32,115,97,118,101,100,32,98,101,108,111,110,103,115,32,116,111,32,97,32,100,105,102,102,101,114,101,110,116,32,100,97,116,97,115,101,116,0,78,55,99,118,102,108,97,110,110,49,55,102,108,97,110,110,95,97,108,103,111,114,105,116,104,109,95,116,69,0,78,55,99,118,102,108,97,110,110,53,73,110,100,101,120,73,78,83,95,50,76,49,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,49,55,102,108,97,110,110,95,97,108,103,111,114,105,116,104,109,95,116,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,83,95,49,55,102,108,97,110,110,95,97,108,103,111,114,105,116,104,109,95,116,69,69,69,0,91,101,109,112,116,121,95,97,110,121,93,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,57,101,109,112,116,121,95,97,110,121,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,83,48,95,57,101,109,112,116,121,95,97,110,121,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,83,48,95,57,101,109,112,116,121,95,97,110,121,69,69,69,0,78,55,99,118,102,108,97,110,110,56,76,115,104,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,55,78,78,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,50,55,72,105,101,114,97,114,99,104,105,99,97,108,67,108,117,115,116,101,114,105,110,103,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,80,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,0,80,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,54,115,109,97,108,108,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,80,80,78,83,95,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,52,78,111,100,101,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,68,84,114,101,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,75,77,101,97,110,115,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,78,55,99,118,102,108,97,110,110,49,52,65,117,116,111,116,117,110,101,100,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,52,67,111,109,112,111,115,105,116,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,55,75,68,84,114,101,101,83,105,110,103,108,101,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,76,105,110,101,97,114,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,78,55,99,118,102,108,97,110,110,53,73,110,100,101,120,73,78,83,95,50,76,50,73,102,69,69,69,69,0,0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8,78,55,99,118,102,108,97,110,110,49,53,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,105,69,69,0,78,55,99,118,102,108,97,110,110,57,82,101,115,117,108,116,83,101,116,73,105,69,69,0,78,55,99,118,102,108,97,110,110,50,49,82,97,100,105,117,115,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,105,69,69,0,78,55,99,118,102,108,97,110,110,49,56,75,78,78,85,110,105,113,117,101,82,101,115,117,108,116,83,101,116,73,105,69,69,0,73,110,118,97,108,105,100,32,107,101,121,95,115,105,122,101,32,40,61,37,100,41,46,32,86,97,108,105,100,32,118,97,108,117,101,115,32,102,111,114,32,121,111,117,114,32,115,121,115,116,101,109,32,97,114,101,32,37,100,32,60,61,32,107,101,121,95,115,105,122,101,32,60,32,37,100,46,0,105,110,105,116,105,97,108,105,122,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,102,108,97,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,102,108,97,110,110,47,108,115,104,95,116,97,98,108,101,46,104,0,78,55,99,118,102,108,97,110,110,56,76,115,104,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,55,78,78,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,50,55,72,105,101,114,97,114,99,104,105,99,97,108,67,108,117,115,116,101,114,105,110,103,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,49,49,76,105,110,101,97,114,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,53,73,110,100,101,120,73,78,83,95,49,48,72,97,109,109,105,110,103,76,85,84,69,69,69,0,78,55,99,118,102,108,97,110,110,49,52,70,76,65,78,78,69,120,99,101,112,116,105,111,110,69,0,73,110,118,97,108,105,100,32,105,110,100,101,120,32,102,105,108,101,44,32,99,97,110,110,111,116,32,114,101,97,100,0,70,76,65,78,78,95,73,78,68,69,88,0,73,110,118,97,108,105,100,32,105,110,100,101,120,32,102,105,108,101,44,32,119,114,111,110,103,32,115,105,103,110,97,116,117,114,101,0,119,98,0,67,97,110,32,110,111,116,32,111,112,101,110,32,102,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,32,70,76,65,78,78,32,105,110,100,101,120,10,0,115,97,118,101,0,49,46,54,46,49,48,0,109,97,120,82,101,115,117,108,116,115,32,62,32,48,0,114,97,100,105,117,115,83,101,97,114,99,104,0,76,83,72,32,105,110,100,101,120,32,100,111,101,115,32,110,111,116,32,115,117,112,112,111,114,116,32,114,97,100,105,117,115,83,101,97,114,99,104,32,111,112,101,114,97,116,105,111,110,0,113,117,101,114,121,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,105,110,100,105,99,101,115,46,116,121,112,101,40,41,32,61,61,32,67,86,95,51,50,83,32,38,38,32,100,105,115,116,115,46,116,121,112,101,40,41,32,61,61,32,100,116,121,112,101,0,114,117,110,82,97,100,105,117,115,83,101,97,114,99,104,95,0,113,117,101,114,121,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,110,100,105,99,101,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,105,115,116,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,107,110,110,83,101,97,114,99,104,0,40,115,105,122,101,95,116,41,107,110,110,32,60,61,32,105,110,100,101,120,95,45,62,115,105,122,101,40,41,0,114,117,110,75,110,110,83,101,97,114,99,104,95,0,98,117,105,108,100,0,116,121,112,101,61,37,100,10,0,98,117,105,108,100,73,110,100,101,120,95,0,79,110,108,121,32,99,111,110,116,105,110,117,111,117,115,32,97,114,114,97,121,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,53,102,108,97,110,110,53,73,110,100,101,120,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,100,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,100,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,49,52,98,105,103,95,97,110,121,95,112,111,108,105,99,121,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,78,55,99,118,102,108,97,110,110,55,97,110,121,105,109,112,108,50,49,116,121,112,101,100,95,98,97,115,101,95,97,110,121,95,112,111,108,105,99,121,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,115,114,99,49,46,99,111,108,115,32,61,61,32,115,114,99,50,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,67,86,95,51,50,70,32,124,124,32,116,121,112,101,32,61,61,32,67,86,95,56,85,41,0,98,97,116,99,104,68,105,115,116,97,110,99,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,98,97,116,99,104,95,100,105,115,116,97,110,99,101,46,99,112,112,0,95,110,105,100,120,46,110,101,101,100,101,100,40,41,32,61,61,32,40,75,32,62,32,48,41,0,40,116,121,112,101,32,61,61,32,67,86,95,56,85,32,38,38,32,100,116,121,112,101,32,61,61,32,67,86,95,51,50,83,41,32,124,124,32,100,116,121,112,101,32,61,61,32,67,86,95,51,50,70,0,75,32,61,61,32,49,32,38,38,32,117,112,100,97,116,101,32,61,61,32,48,32,38,38,32,109,97,115,107,46,101,109,112,116,121,40,41,0,33,110,105,100,120,46,101,109,112,116,121,40,41,0,84,104,101,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,116,121,112,101,61,37,100,44,32,100,116,121,112,101,61,37,100,32,97,110,100,32,110,111,114,109,84,121,112,101,61,37,100,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,50,99,118,49,54,66,97,116,99,104,68,105,115,116,73,110,118,111,107,101,114,69,0,8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,79,80,69,78,67,86,95,76,79,71,95,76,69,86,69,76,0,87,65,82,78,73,78,71,0,68,73,83,65,66,76,69,68,0,100,105,115,97,98,108,101,100,0,48,0,79,70,70,0,111,102,102,0,70,65,84,65,76,0,102,97,116,97,108,0,69,82,82,79,82,0,101,114,114,111,114,0,119,97,114,110,105,110,103,0,87,65,82,78,73,78,71,83,0,119,97,114,110,105,110,103,115,0,87,65,82,78,0,119,97,114,110,0,73,78,70,79,0,105,110,102,111,0,68,69,66,85,71,0,100,101,98,117,103,0,86,69,82,66,79,83,69,0,118,101,114,98,111,115,101,0,69,82,82,79,82,58,32,85,110,101,120,112,101,99,116,101,100,32,108,111,103,103,105,110,103,32,108,101,118,101,108,32,118,97,108,117,101,58,32,0,91,70,65,84,65,76,58,0,93,32,0,91,69,82,82,79,82,58,0,91,32,87,65,82,78,58,0,91,32,73,78,70,79,58,0,91,68,69,66,85,71,58,0,37,115,0,37,115,37,115,37,115,0,58,32,0,117,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,102,105,108,101,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,105,110,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,32,101,114,114,111,114,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,100,101,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,49,46,50,46,49,49,0,105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107,0,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0,105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0,117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0,104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0,105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0,105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0,116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0,105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0,105,110,118,97,108,105,100,32,99,111,100,101,32,45,45,32,109,105,115,115,105,110,103,32,101,110,100,45,111,102,45,98,108,111,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0,105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0,105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,110,101,101,100,32,100,105,99,116,105,111,110,97,114,121,0,115,116,114,101,97,109,32,101,110,100,0,102,105,108,101,32,101,114,114,111,114,0,115,116,114,101,97,109,32,101,114,114,111,114,0,100,97,116,97,32,101,114,114,111,114,0,105,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,98,117,102,102,101,114,32,101,114,114,111,114,0,105,110,99,111,109,112,97,116,105,98,108,101,32,118,101,114,115,105,111,110,0,0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0,0,16,17,18,18,19,19,20,20,20,20,21,21,21,21,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,0,1,2,3,4,5,6,7,8,8,9,9,10,10,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,115,116,100,58,58,119,115,116,114,105,110,103,0,101,109,115,99,114,105,112,116,101,110,58,58,118,97,108,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,102,108,111,97,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,100,111,117,98,108,101,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,32,100,111,117,98,108,101,62,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,101,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,109,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,108,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,106,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,97,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,104,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+512004);allocate([110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,76,67,95,65,76,76,0,76,67,95,67,84,89,80,69,0,0,0,0,76,67,95,78,85,77,69,82,73,67,0,0,76,67,95,84,73,77,69,0,0,0,0,0,76,67,95,67,79,76,76,65,84,69,0,0,76,67,95,77,79,78,69,84,65,82,89,0,76,67,95,77,69,83,83,65,71,69,83,0,76,65,78,71,0,67,46,85,84,70,45,56,0,80,79,83,73,88,0,77,85,83,76,95,76,79,67,80,65,84,72,0,114,119,97,0,105,110,102,105,110,105,116,121,0,110,97,110,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,52,98,97,115,105,99,95,105,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,37,112,0,67,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,37,112,0,0,0,0,76,0,37,0,0,0,0,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,37,72,58,37,77,58,37,83,0,37,109,47,37,100,47,37,121,0,37,73,58,37,77,58,37,83,32,37,112,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,65,77,0,80,77,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,37,72,58,37,77,58,37,83,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,78,83,116,51,95,95,50,49,57,95,95,115,104,97,114,101,100,95,119,101,97,107,95,99,111,117,110,116,69,0,47,111,112,116,47,98,117,105,108,100,45,119,111,114,107,101,114,47,101,109,115,100,107,47,101,109,115,99,114,105,112,116,101,110,47,49,46,51,55,46,50,49,47,115,121,115,116,101,109,47,108,105,98,47,108,105,98,99,120,120,47,109,117,116,101,120,46,99,112,112,0,117,110,108,111,99,107,0,114,101,99,117,114,115,105,118,101,95,109,117,116,101,120,32,99,111,110,115,116,114,117,99,116,111,114,32,102,97,105,108,101,100,0,101,32,61,61,32,48,0,126,114,101,99,117,114,115,105,118,101,95,109,117,116,101,120,0,114,101,99,117,114,115,105,118,101,95,109,117,116,101,120,32,108,111,99,107,32,102,97,105,108,101,100,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,116,101,114,109,105,110,97,116,105,110,103,0,117,110,99,97,117,103,104,116,0,83,116,57,101,120,99,101,112,116,105,111,110,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,83,116,56,98,97,100,95,99,97,115,116,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,57,95,95,112,111,105,110,116,101,114,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,112,98,97,115,101,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,51,95,95,102,117,110,100,97,109,101,110,116,97,108,95,116,121,112,101,95,105,110,102,111,69,0,118,0,68,110,0,98,0,80,75,99,0,97,0,115,0,105,0,106,0,109,0,100,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,101,110,117,109,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,32,99,111,110,115,116,0,32,118,111,108,97,116,105,108,101,0,32,114,101,115,116,114,105,99,116,0,32,99,111,109,112,108,101,120,0,32,105,109,97,103,105,110,97,114,121,0,32,91,0,32,40,0,41,0,40,0,38,38,0,111,98,106,99,95,111,98,106,101,99,116,60,0,42,0,38,0,111,98,106,99,112,114,111,116,111,0,32,0,60,0,62,0,32,118,101,99,116,111,114,91,0,93,0,112,105,120,101,108,32,118,101,99,116,111,114,91,0,38,61,0,61,0,44,0,126,0,58,58,0,100,101,108,101,116,101,91,93,32,0,100,101,108,101,116,101,32,0,47,0,47,61,0,94,0,94,61,0,61,61,0,62,61,0,41,91,0,60,61,0,60,60,0,60,60,61,0,45,0,45,61,0,42,61,0,45,45,0,41,45,45,0,33,61,0,33,0,124,124,0,124,0,124,61,0,45,62,42,0,43,0,43,61,0,43,43,0,41,43,43,0,41,32,63,32,40,0,41,32,58,32,40,0,37,0,37,61,0,62,62,0,62,62,61,0,116,104,114,111,119,0,116,104,114,111,119,32,0,116,121,112,101,105,100,40,0,115,105,122,101,111,102,46,46,46,40,0,44,32,0,115,105,122,101,111,102,32,40,0,115,116,97,116,105,99,95,99,97,115,116,60,0,62,40,0,114,101,105,110,116,101,114,112,114,101,116,95,99,97,115,116,60,0,45,62,0,110,111,101,120,99,101,112,116,32,40,0,91,93,32,0,41,32,0,46,0,46,42,0,115,116,100,58,58,0,111,112,101,114,97,116,111,114,38,38,0,111,112,101,114,97,116,111,114,38,0,111,112,101,114,97,116,111,114,38,61,0,111,112,101,114,97,116,111,114,61,0,111,112,101,114,97,116,111,114,40,41,0,111,112,101,114,97,116,111,114,44,0,111,112,101,114,97,116,111,114,126,0,111,112,101,114,97,116,111,114,32,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,91,93,0,111,112,101,114,97,116,111,114,42,0,111,112,101,114,97,116,111,114,47,0,111,112,101,114,97,116,111,114,47,61,0,111,112,101,114,97,116,111,114,94,0,111,112,101,114,97,116,111,114,94,61,0,111,112,101,114,97,116,111,114,61,61,0,111,112,101,114,97,116,111,114,62,61,0,111,112,101,114,97,116,111,114,62,0,111,112,101,114,97,116,111,114,91,93,0,111,112,101,114,97,116,111,114,60,61,0,111,112,101,114,97,116,111,114,34,34,32,0,111,112,101,114,97,116,111,114,60,60,0,111,112,101,114,97,116,111,114,60,60,61,0,111,112,101,114,97,116,111,114,60,0,111,112,101,114,97,116,111,114,45,0,111,112,101,114,97,116,111,114,45,61,0,111,112,101,114,97,116,111,114,42,61,0,111,112,101,114,97,116,111,114,45,45,0,111,112,101,114,97,116,111,114,32,110,101,119,91,93,0,111,112,101,114,97,116,111,114,33,61,0,111,112,101,114,97,116,111,114,33,0,111,112,101,114,97,116,111,114,32,110,101,119,0,111,112,101,114,97,116,111,114,124,124,0,111,112,101,114,97,116,111,114,124,0,111,112,101,114,97,116,111,114,124,61,0,111,112,101,114,97,116,111,114,45,62,42,0,111,112,101,114,97,116,111,114,43,0,111,112,101,114,97,116,111,114,43,61,0,111,112,101,114,97,116,111,114,43,43,0,111,112,101,114,97,116,111,114,45,62,0,111,112,101,114,97,116,111,114,63,0,111,112,101,114,97,116,111,114,37,0,111,112,101,114,97,116,111,114,37,61,0,111,112,101,114,97,116,111,114,62,62,0,111,112,101,114,97,116,111,114,62,62,61,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,0,39,117,110,110,97,109,101,100,0,39,108,97,109,98,100,97,39,40,0,115,116,100,58,58,115,116,114,105,110,103,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,44,32,115,116,100,58,58,97,108,108,111,99,97,116,111,114,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,115,116,114,105,110,103,0,115,116,100,58,58,105,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,115,116,114,101,97,109,0,115,116,100,58,58,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,111,115,116,114,101,97,109,0,115,116,100,58,58,105,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,111,115,116,114,101,97,109,0,100,121,110,97,109,105,99,95,99,97,115,116,60,0,41,40,0,99,111,110,115,116,95,99,97,115,116,60,0,97,108,105,103,110,111,102,32,40,0,102,112,0,119,99,104,97,114,95,116,0,102,97,108,115,101,0,116,114,117,101,0,99,104,97,114,0,115,105,103,110,101,100,32,99,104,97,114,0,117,110,115,105,103,110,101,100,32,99,104,97,114,0,115,104,111,114,116,0,117,110,115,105,103,110,101,100,32,115,104,111,114,116,0,117,0,108,0,117,108,0,108,108,0,117,108,108,0,95,95,105,110,116,49,50,56,0,117,110,115,105,103,110,101,100,32,95,95,105,110,116,49,50,56,0,37,76,97,76,0,37,97,0,37,97,102,0,100,101,99,108,116,121,112,101,40,0,115,116,100,58,58,97,108,108,111,99,97,116,111,114,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,0,58,58,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,115,116,100,0,95,71,76,79,66,65,76,95,95,78,0,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,0,32,62,0,84,95,0,105,100,0,58,58,42,0,32,38,0,32,38,38,0,32,91,93,0,118,111,105,100,0,98,111,111,108,0,105,110,116,0,117,110,115,105,103,110,101,100,32,105,110,116,0,108,111,110,103,0,117,110,115,105,103,110,101,100,32,108,111,110,103,0,108,111,110,103,32,108,111,110,103,0,102,108,111,97,116,0,108,111,110,103,32,100,111,117,98,108,101,0,95,95,102,108,111,97,116,49,50,56,0,46,46,46,0,100,101,99,105,109,97,108,54,52,0,100,101,99,105,109,97,108,49,50,56,0,100,101,99,105,109,97,108,51,50,0,100,101,99,105,109,97,108,49,54,0,99,104,97,114,51,50,95,116,0,99,104,97,114,49,54,95,116,0,97,117,116,111,0,115,116,100,58,58,110,117,108,108,112,116,114,95,116,0,100,111,117,98,108,101,0,117,110,115,105,103,110,101,100,32,108,111,110,103,32,108,111,110,103,0,95,98,108,111,99,107,95,105,110,118,111,107,101,0,105,110,118,111,99,97,116,105,111,110,32,102,117,110,99,116,105,111,110,32,102,111,114,32,98,108,111,99,107,32,105,110,32,0,118,116,97,98,108,101,32,102,111,114,32,0,86,84,84,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,110,97,109,101,32,102,111,114,32,0,99,111,118,97,114,105,97,110,116,32,114,101,116,117,114,110,32,116,104,117,110,107,32,116,111,32,0,99,111,110,115,116,114,117,99,116,105,111,110,32,118,116,97,98,108,101,32,102,111,114,32,0,45,105,110,45,0,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,110,111,110,45,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,103,117,97,114,100,32,118,97,114,105,97,98,108,101,32,102,111,114,32,0,114,101,102,101,114,101,110,99,101,32,116,101,109,112,111,114,97,114,121,32,102,111,114,32,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+522244);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _atexit(func,arg){__ATEXIT__.unshift({func:func,arg:arg})}function ___cxa_atexit(){return _atexit.apply(null,arguments)}var emval_symbols={};function embind_init_charCodes(){var codes=new Array(256);for(var i=0;i<256;++i){codes[i]=String.fromCharCode(i)}embind_charCodes=codes}var embind_charCodes=undefined;function readLatin1String(ptr){var ret="";var c=ptr;while(HEAPU8[c]){ret+=embind_charCodes[HEAPU8[c++]]}return ret}function getStringOrSymbol(address){var symbol=emval_symbols[address];if(symbol===undefined){return readLatin1String(address)}else{return symbol}}var emval_free_list=[];var emval_handle_array=[{},{value:undefined},{value:null},{value:true},{value:false}];function count_emval_handles(){var count=0;for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){++count}}return count}function get_first_emval(){for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){return emval_handle_array[i]}}return null}function init_emval(){OpenCVJSModule["count_emval_handles"]=count_emval_handles;OpenCVJSModule["get_first_emval"]=get_first_emval}function __emval_register(value){switch(value){case undefined:{return 1};case null:{return 2};case true:{return 3};case false:{return 4};default:{var handle=emval_free_list.length?emval_free_list.pop():emval_handle_array.length;emval_handle_array[handle]={refcount:1,value:value};return handle}}}function __emval_new_cstring(v){return __emval_register(getStringOrSymbol(v))}var emval_methodCallers=[];function __emval_addMethodCaller(caller){var id=emval_methodCallers.length;emval_methodCallers.push(caller);return id}var registeredTypes={};function getTypeName(type){var ptr=___getTypeName(type);var rv=readLatin1String(ptr);_free(ptr);return rv}var char_0=48;var char_9=57;function makeLegalFunctionName(name){if(undefined===name){return"_unknown"}name=name.replace(/[^a-zA-Z0-9_]/g,"$");var f=name.charCodeAt(0);if(f>=char_0&&f<=char_9){return"_"+name}else{return name}}function createNamedFunction(name,body){name=makeLegalFunctionName(name);return(new Function("body","return function "+name+"() {\n"+'    "use strict";'+"    return body.apply(this, arguments);\n"+"};\n"))(body)}function extendError(baseErrorType,errorName){var errorClass=createNamedFunction(errorName,(function(message){this.name=errorName;this.message=message;var stack=(new Error(message)).stack;if(stack!==undefined){this.stack=this.toString()+"\n"+stack.replace(/^Error(:[^\n]*)?\n/,"")}}));errorClass.prototype=Object.create(baseErrorType.prototype);errorClass.prototype.constructor=errorClass;errorClass.prototype.toString=(function(){if(this.message===undefined){return this.name}else{return this.name+": "+this.message}});return errorClass}var BindingError=undefined;function throwBindingError(message){throw new BindingError(message)}function requireRegisteredType(rawType,humanName){var impl=registeredTypes[rawType];if(undefined===impl){throwBindingError(humanName+" has unknown type "+getTypeName(rawType))}return impl}function __emval_lookupTypes(argCount,argTypes,argWireTypes){var a=new Array(argCount);for(var i=0;i<argCount;++i){a[i]=requireRegisteredType(HEAP32[(argTypes>>2)+i],"parameter "+i)}return a}function new_(constructor,argumentList){if(!(constructor instanceof Function)){throw new TypeError("new_ called with constructor type "+typeof constructor+" which is not a function")}var dummy=createNamedFunction(constructor.name||"unknownFunctionName",(function(){}));dummy.prototype=constructor.prototype;var obj=new dummy;var r=constructor.apply(obj,argumentList);return r instanceof Object?r:obj}function __emval_get_method_caller(argCount,argTypes){var types=__emval_lookupTypes(argCount,argTypes);var retType=types[0];var signatureName=retType.name+"_$"+types.slice(1).map((function(t){return t.name})).join("_")+"$";var params=["retType"];var args=[retType];var argsList="";for(var i=0;i<argCount-1;++i){argsList+=(i!==0?", ":"")+"arg"+i;params.push("argType"+i);args.push(types[1+i])}var functionName=makeLegalFunctionName("methodCaller_"+signatureName);var functionBody="return function "+functionName+"(handle, name, destructors, args) {\n";var offset=0;for(var i=0;i<argCount-1;++i){functionBody+="    var arg"+i+" = argType"+i+".readValueFromPointer(args"+(offset?"+"+offset:"")+");\n";offset+=types[i+1]["argPackAdvance"]}functionBody+="    var rv = handle[name]("+argsList+");\n";for(var i=0;i<argCount-1;++i){if(types[i+1]["deleteObject"]){functionBody+="    argType"+i+".deleteObject(arg"+i+");\n"}}if(!retType.isVoid){functionBody+="    return retType.toWireType(destructors, rv);\n"}functionBody+="};\n";params.push(functionBody);var invokerFunction=new_(Function,params).apply(null,args);return __emval_addMethodCaller(invokerFunction)}function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0&&!info.rethrown){if(info.destructor){OpenCVJSModule["dynCall_vi"](info.destructor,ptr)}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(Runtime.setTempRet0(0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(Runtime.setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=OpenCVJSModule["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&OpenCVJSModule["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(Runtime.setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(Runtime.setTempRet0(throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0,caught:false,rethrown:false};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}var awaitingDependencies={};var typeDependencies={};var InternalError=undefined;function throwInternalError(message){throw new InternalError(message)}function whenDependentTypesAreResolved(myTypes,dependentTypes,getTypeConverters){myTypes.forEach((function(type){typeDependencies[type]=dependentTypes}));function onComplete(typeConverters){var myTypeConverters=getTypeConverters(typeConverters);if(myTypeConverters.length!==myTypes.length){throwInternalError("Mismatched type converter count")}for(var i=0;i<myTypes.length;++i){registerType(myTypes[i],myTypeConverters[i])}}var typeConverters=new Array(dependentTypes.length);var unregisteredTypes=[];var registered=0;dependentTypes.forEach((function(dt,i){if(registeredTypes.hasOwnProperty(dt)){typeConverters[i]=registeredTypes[dt]}else{unregisteredTypes.push(dt);if(!awaitingDependencies.hasOwnProperty(dt)){awaitingDependencies[dt]=[]}awaitingDependencies[dt].push((function(){typeConverters[i]=registeredTypes[dt];++registered;if(registered===unregisteredTypes.length){onComplete(typeConverters)}}))}}));if(0===unregisteredTypes.length){onComplete(typeConverters)}}function registerType(rawType,registeredInstance,options){options=options||{};if(!("argPackAdvance"in registeredInstance)){throw new TypeError("registerType registeredInstance requires argPackAdvance")}var name=registeredInstance.name;if(!rawType){throwBindingError('type "'+name+'" must have a positive integer typeid pointer')}if(registeredTypes.hasOwnProperty(rawType)){if(options.ignoreDuplicateRegistrations){return}else{throwBindingError("Cannot register type '"+name+"' twice")}}registeredTypes[rawType]=registeredInstance;delete typeDependencies[rawType];if(awaitingDependencies.hasOwnProperty(rawType)){var callbacks=awaitingDependencies[rawType];delete awaitingDependencies[rawType];callbacks.forEach((function(cb){cb()}))}}function simpleReadValueFromPointer(pointer){return this["fromWireType"](HEAPU32[pointer>>2])}function __embind_register_std_string(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){var length=HEAPU32[value>>2];var a=new Array(length);for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAPU8[value+4+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){if(value instanceof ArrayBuffer){value=new Uint8Array(value)}function getTAElement(ta,index){return ta[index]}function getStringElement(string,index){return string.charCodeAt(index)}var getElement;if(value instanceof Uint8Array){getElement=getTAElement}else if(value instanceof Uint8ClampedArray){getElement=getTAElement}else if(value instanceof Int8Array){getElement=getTAElement}else if(typeof value==="string"){getElement=getStringElement}else{throwBindingError("Cannot pass non-string to std::string")}var length=value.length;var ptr=_malloc(4+length);HEAPU32[ptr>>2]=length;for(var i=0;i<length;++i){var charCode=getElement(value,i);if(charCode>255){_free(ptr);throwBindingError("String has UTF-16 code units that do not fit in 8 bits")}HEAPU8[ptr+4+i]=charCode}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function __embind_register_std_wstring(rawType,charSize,name){name=readLatin1String(name);var getHeap,shift;if(charSize===2){getHeap=(function(){return HEAPU16});shift=1}else if(charSize===4){getHeap=(function(){return HEAPU32});shift=2}registerType(rawType,{name:name,"fromWireType":(function(value){var HEAP=getHeap();var length=HEAPU32[value>>2];var a=new Array(length);var start=value+4>>shift;for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAP[start+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){var HEAP=getHeap();var length=value.length;var ptr=_malloc(4+length*charSize);HEAPU32[ptr>>2]=length;var start=ptr+4>>shift;for(var i=0;i<length;++i){HEAP[start+i]=value.charCodeAt(i)}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function _pthread_mutex_init(){}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);function __emval_decref(handle){if(handle>4&&0===--emval_handle_array[handle].refcount){emval_handle_array[handle]=undefined;emval_free_list.push(handle)}}function _embind_repr(v){if(v===null){return"null"}var t=typeof v;if(t==="object"||t==="array"||t==="function"){return v.toString()}else{return""+v}}function getShiftFromSize(size){switch(size){case 1:return 0;case 2:return 1;case 4:return 2;case 8:return 3;default:throw new TypeError("Unknown type size: "+size)}}function integerReadValueFromPointer(name,shift,signed){switch(shift){case 0:return signed?function readS8FromPointer(pointer){return HEAP8[pointer]}:function readU8FromPointer(pointer){return HEAPU8[pointer]};case 1:return signed?function readS16FromPointer(pointer){return HEAP16[pointer>>1]}:function readU16FromPointer(pointer){return HEAPU16[pointer>>1]};case 2:return signed?function readS32FromPointer(pointer){return HEAP32[pointer>>2]}:function readU32FromPointer(pointer){return HEAPU32[pointer>>2]};default:throw new TypeError("Unknown integer type: "+name)}}function __embind_register_integer(primitiveType,name,size,minRange,maxRange){name=readLatin1String(name);if(maxRange===-1){maxRange=4294967295}var shift=getShiftFromSize(size);var fromWireType=(function(value){return value});if(minRange===0){var bitshift=32-8*size;fromWireType=(function(value){return value<<bitshift>>>bitshift})}var isUnsignedType=name.indexOf("unsigned")!=-1;registerType(primitiveType,{name:name,"fromWireType":fromWireType,"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}if(value<minRange||value>maxRange){throw new TypeError('Passing a number "'+_embind_repr(value)+'" from JS side to C/C++ side to an argument of type "'+name+'", which is outside the valid range ['+minRange+", "+maxRange+"]!")}return isUnsignedType?value>>>0:value|0}),"argPackAdvance":8,"readValueFromPointer":integerReadValueFromPointer(name,shift,minRange!==0),destructorFunction:null})}var structRegistrations={};function runDestructors(destructors){while(destructors.length){var ptr=destructors.pop();var del=destructors.pop();del(ptr)}}function __embind_finalize_value_object(structType){var reg=structRegistrations[structType];delete structRegistrations[structType];var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;var fieldRecords=reg.fields;var fieldTypes=fieldRecords.map((function(field){return field.getterReturnType})).concat(fieldRecords.map((function(field){return field.setterArgumentType})));whenDependentTypesAreResolved([structType],fieldTypes,(function(fieldTypes){var fields={};fieldRecords.forEach((function(field,i){var fieldName=field.fieldName;var getterReturnType=fieldTypes[i];var getter=field.getter;var getterContext=field.getterContext;var setterArgumentType=fieldTypes[i+fieldRecords.length];var setter=field.setter;var setterContext=field.setterContext;fields[fieldName]={read:(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))}),write:(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}}));return[{name:reg.name,"fromWireType":(function(ptr){var rv={};for(var i in fields){rv[i]=fields[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){for(var fieldName in fields){if(!(fieldName in o)){throw new TypeError("Missing field")}}var ptr=rawConstructor();for(fieldName in fields){fields[fieldName].write(ptr,o[fieldName])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}var PTHREAD_SPECIFIC={};var PTHREAD_SPECIFIC_NEXT_KEY=1;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function __emval_take_value(type,argv){type=requireRegisteredType(type,"_emval_take_value");var v=type["readValueFromPointer"](argv);return __emval_register(v)}var _llvm_pow_f32=Math_pow;var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};function ___setErrNo(value){if(OpenCVJSModule["___errno_location"])HEAP32[OpenCVJSModule["___errno_location"]()>>2]=value;return value}var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up;up--){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var isPosixPlatform=process.platform!="win32";var fd=process.stdin.fd;if(isPosixPlatform){var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}}try{bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null)}catch(e){if(e.toString().indexOf("EOF")!=-1)bytesRead=0;else throw e}if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){OpenCVJSModule["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){OpenCVJSModule["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){OpenCVJSModule["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){OpenCVJSModule["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}if(!req){return callback("Unable to connect to IndexedDB")}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){flags&=~2097152;flags&=~2048;flags&=~32768;flags&=~524288;if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");if(!createdParents[curr]){createdParents[curr]=WORKERFS.createNode(parent,parts[i],WORKERFS.DIR_MODE,0)}parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])}));(mount.opts["packages"]||[]).forEach((function(pack){pack["metadata"].files.forEach((function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))}))}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};STATICTOP+=16;STATICTOP+=16;STATICTOP+=16;var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){console.log("warning: "+FS.syncFSRequests+" FS.syncfs operations in flight at once, probably just doing extra work")}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(err){assert(FS.syncFSRequests>0);FS.syncFSRequests--;return callback(err)}function done(err){if(err){if(!done.errored){done.errored=true;return doCallback(err)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdirTree:(function(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=ERRNO_CODES.EEXIST)throw e}}}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(OpenCVJSModule["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;OpenCVJSModule["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(OpenCVJSModule["stdin"]){FS.createDevice("/dev","stdin",OpenCVJSModule["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(OpenCVJSModule["stdout"]){FS.createDevice("/dev","stdout",null,OpenCVJSModule["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(OpenCVJSModule["stderr"]){FS.createDevice("/dev","stderr",null,OpenCVJSModule["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS,"IDBFS":IDBFS,"NODEFS":NODEFS,"WORKERFS":WORKERFS}}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();OpenCVJSModule["stdin"]=input||OpenCVJSModule["stdin"];OpenCVJSModule["stdout"]=output||OpenCVJSModule["stdout"];OpenCVJSModule["stderr"]=error||OpenCVJSModule["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=OpenCVJSModule["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(OpenCVJSModule["read"]){try{obj.contents=intArrayFromString(OpenCVJSModule["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;console.log("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})},chunkSize:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:(function(){return this.contents.length})}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;OpenCVJSModule["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.subarray(addr,addr+len));FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);var len=Math.min(bufsize,lengthBytesUTF8(ret));var endChar=HEAP8[buf+len];stringToUTF8(ret,buf,bufsize+1);HEAP8[buf+len]=endChar;return len}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall91(which,varargs){SYSCALLS.varargs=varargs;try{var addr=SYSCALLS.get(),len=SYSCALLS.get();var info=SYSCALLS.mappings[addr];if(!info)return 0;if(len===info.len){var stream=FS.getStream(info.fd);SYSCALLS.doMsync(addr,stream,len,info.flags);FS.munmap(stream);SYSCALLS.mappings[addr]=null;if(info.allocated){_free(info.malloc)}}return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_mutexattr_destroy(){}function _emscripten_set_main_loop_timing(mode,value){Browser.mainLoop.timingMode=mode;Browser.mainLoop.timingValue=value;if(!Browser.mainLoop.func){return 1}if(mode==0){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setTimeout(){var timeUntilNextTick=Math.max(0,Browser.mainLoop.tickStartTime+value-_emscripten_get_now())|0;setTimeout(Browser.mainLoop.runner,timeUntilNextTick)};Browser.mainLoop.method="timeout"}else if(mode==1){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_rAF(){Browser.requestAnimationFrame(Browser.mainLoop.runner)};Browser.mainLoop.method="rAF"}else if(mode==2){if(!window["setImmediate"]){var setImmediates=[];var emscriptenMainLoopMessageId="setimmediate";function Browser_setImmediate_messageHandler(event){if(event.source===window&&event.data===emscriptenMainLoopMessageId){event.stopPropagation();setImmediates.shift()()}}window.addEventListener("message",Browser_setImmediate_messageHandler,true);window["setImmediate"]=function Browser_emulated_setImmediate(func){setImmediates.push(func);if(ENVIRONMENT_IS_WORKER){if(OpenCVJSModule["setImmediates"]===undefined)OpenCVJSModule["setImmediates"]=[];OpenCVJSModule["setImmediates"].push(func);window.postMessage({target:emscriptenMainLoopMessageId})}else window.postMessage(emscriptenMainLoopMessageId,"*")}}Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setImmediate(){window["setImmediate"](Browser.mainLoop.runner)};Browser.mainLoop.method="immediate"}return 0}function _emscripten_get_now(){abort()}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg,noSetTiming){OpenCVJSModule["noExitRuntime"]=true;assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");Browser.mainLoop.func=func;Browser.mainLoop.arg=arg;var browserIterationFunc;if(typeof arg!=="undefined"){browserIterationFunc=(function(){OpenCVJSModule["dynCall_vi"](func,arg)})}else{browserIterationFunc=(function(){OpenCVJSModule["dynCall_v"](func)})}var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;Browser.mainLoop.runner=function Browser_mainLoop_runner(){if(ABORT)return;if(Browser.mainLoop.queue.length>0){var start=Date.now();var blocker=Browser.mainLoop.queue.shift();blocker.func(blocker.arg);if(Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers;var next=remaining%1==0?remaining-1:Math.floor(remaining);if(blocker.counted){Browser.mainLoop.remainingBlockers=next}else{next=next+.5;Browser.mainLoop.remainingBlockers=(8*remaining+next)/9}}console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms");Browser.mainLoop.updateStatus();if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;setTimeout(Browser.mainLoop.runner,0);return}if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0;if(Browser.mainLoop.timingMode==1&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0){Browser.mainLoop.scheduler();return}else if(Browser.mainLoop.timingMode==0){Browser.mainLoop.tickStartTime=_emscripten_get_now()}if(Browser.mainLoop.method==="timeout"&&OpenCVJSModule.ctx){OpenCVJSModule.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");Browser.mainLoop.method=""}Browser.mainLoop.runIter(browserIterationFunc);if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;if(typeof SDL==="object"&&SDL.audio&&SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();Browser.mainLoop.scheduler()};if(!noSetTiming){if(fps&&fps>0)_emscripten_set_main_loop_timing(0,1e3/fps);else _emscripten_set_main_loop_timing(1,1);Browser.mainLoop.scheduler()}if(simulateInfiniteLoop){throw"SimulateInfiniteLoop"}}var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:(function(){Browser.mainLoop.scheduler=null;Browser.mainLoop.currentlyRunningMainloop++}),resume:(function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode;var timingValue=Browser.mainLoop.timingValue;var func=Browser.mainLoop.func;Browser.mainLoop.func=null;_emscripten_set_main_loop(func,0,false,Browser.mainLoop.arg,true);_emscripten_set_main_loop_timing(timingMode,timingValue);Browser.mainLoop.scheduler()}),updateStatus:(function(){if(OpenCVJSModule["setStatus"]){var message=OpenCVJSModule["statusMessage"]||"Please wait...";var remaining=Browser.mainLoop.remainingBlockers;var expected=Browser.mainLoop.expectedBlockers;if(remaining){if(remaining<expected){OpenCVJSModule["setStatus"](message+" ("+(expected-remaining)+"/"+expected+")")}else{OpenCVJSModule["setStatus"](message)}}else{OpenCVJSModule["setStatus"]("")}}}),runIter:(function(func){if(ABORT)return;if(OpenCVJSModule["preMainLoop"]){var preRet=OpenCVJSModule["preMainLoop"]();if(preRet===false){return}}try{func()}catch(e){if(e instanceof ExitStatus){return}else{if(e&&typeof e==="object"&&e.stack)OpenCVJSModule.printErr("exception thrown: "+[e,e.stack]);throw e}}if(OpenCVJSModule["postMainLoop"])OpenCVJSModule["postMainLoop"]()})},isFullscreen:false,pointerLock:false,OpenCVJSModuleContextCreatedCallbacks:[],workers:[],init:(function(){if(!OpenCVJSModule["preloadPlugins"])OpenCVJSModule["preloadPlugins"]=[];if(Browser.initted)return;Browser.initted=true;try{new Blob;Browser.hasBlobConstructor=true}catch(e){Browser.hasBlobConstructor=false;console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder=typeof MozBlobBuilder!="undefined"?MozBlobBuilder:typeof WebKitBlobBuilder!="undefined"?WebKitBlobBuilder:!Browser.hasBlobConstructor?console.log("warning: no BlobBuilder"):null;Browser.URLObject=typeof window!="undefined"?window.URL?window.URL:window.webkitURL:undefined;if(!OpenCVJSModule.noImageDecoding&&typeof Browser.URLObject==="undefined"){console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");OpenCVJSModule.noImageDecoding=true}var imagePlugin={};imagePlugin["canHandle"]=function imagePlugin_canHandle(name){return!OpenCVJSModule.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)};imagePlugin["handle"]=function imagePlugin_handle(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor){try{b=new Blob([byteArray],{type:Browser.getMimetype(name)});if(b.size!==byteArray.length){b=new Blob([(new Uint8Array(byteArray)).buffer],{type:Browser.getMimetype(name)})}}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}}if(!b){var bb=new Browser.BlobBuilder;bb.append((new Uint8Array(byteArray)).buffer);b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b);var img=new Image;img.onload=function img_onload(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0);OpenCVJSModule["preloadedImages"][name]=canvas;Browser.URLObject.revokeObjectURL(url);if(onload)onload(byteArray)};img.onerror=function img_onerror(event){console.log("Image "+url+" could not be decoded");if(onerror)onerror()};img.src=url};OpenCVJSModule["preloadPlugins"].push(imagePlugin);var audioPlugin={};audioPlugin["canHandle"]=function audioPlugin_canHandle(name){return!OpenCVJSModule.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}};audioPlugin["handle"]=function audioPlugin_handle(byteArray,name,onload,onerror){var done=false;function finish(audio){if(done)return;done=true;OpenCVJSModule["preloadedAudios"][name]=audio;if(onload)onload(byteArray)}function fail(){if(done)return;done=true;OpenCVJSModule["preloadedAudios"][name]=new Audio;if(onerror)onerror()}if(Browser.hasBlobConstructor){try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b);var audio=new Audio;audio.addEventListener("canplaythrough",(function(){finish(audio)}),false);audio.onerror=function audio_onerror(event){if(done)return;console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach");function encode64(data){var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var PAD="=";var ret="";var leftchar=0;var leftbits=0;for(var i=0;i<data.length;i++){leftchar=leftchar<<8|data[i];leftbits+=8;while(leftbits>=6){var curr=leftchar>>leftbits-6&63;leftbits-=6;ret+=BASE[curr]}}if(leftbits==2){ret+=BASE[(leftchar&3)<<4];ret+=PAD+PAD}else if(leftbits==4){ret+=BASE[(leftchar&15)<<2];ret+=PAD}return ret}audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray);finish(audio)};audio.src=url;Browser.safeSetTimeout((function(){finish(audio)}),1e4)}else{return fail()}};OpenCVJSModule["preloadPlugins"].push(audioPlugin);function pointerLockChange(){Browser.pointerLock=document["pointerLockElement"]===OpenCVJSModule["canvas"]||document["mozPointerLockElement"]===OpenCVJSModule["canvas"]||document["webkitPointerLockElement"]===OpenCVJSModule["canvas"]||document["msPointerLockElement"]===OpenCVJSModule["canvas"]}var canvas=OpenCVJSModule["canvas"];if(canvas){canvas.requestPointerLock=canvas["requestPointerLock"]||canvas["mozRequestPointerLock"]||canvas["webkitRequestPointerLock"]||canvas["msRequestPointerLock"]||(function(){});canvas.exitPointerLock=document["exitPointerLock"]||document["mozExitPointerLock"]||document["webkitExitPointerLock"]||document["msExitPointerLock"]||(function(){});canvas.exitPointerLock=canvas.exitPointerLock.bind(document);document.addEventListener("pointerlockchange",pointerLockChange,false);document.addEventListener("mozpointerlockchange",pointerLockChange,false);document.addEventListener("webkitpointerlockchange",pointerLockChange,false);document.addEventListener("mspointerlockchange",pointerLockChange,false);if(OpenCVJSModule["elementPointerLock"]){canvas.addEventListener("click",(function(ev){if(!Browser.pointerLock&&OpenCVJSModule["canvas"].requestPointerLock){OpenCVJSModule["canvas"].requestPointerLock();ev.preventDefault()}}),false)}}}),createContext:(function(canvas,useWebGL,setInOpenCVJSModule,webGLContextAttributes){if(useWebGL&&OpenCVJSModule.ctx&&canvas==OpenCVJSModule.canvas)return OpenCVJSModule.ctx;var ctx;var contextHandle;if(useWebGL){var contextAttributes={antialias:false,alpha:false};if(webGLContextAttributes){for(var attribute in webGLContextAttributes){contextAttributes[attribute]=webGLContextAttributes[attribute]}}contextHandle=GL.createContext(canvas,contextAttributes);if(contextHandle){ctx=GL.getContext(contextHandle).GLctx}}else{ctx=canvas.getContext("2d")}if(!ctx)return null;if(setInOpenCVJSModule){if(!useWebGL)assert(typeof GLctx==="undefined","cannot set in OpenCVJSModule if GLctx is used, but we are a non-GL context that would replace it");OpenCVJSModule.ctx=ctx;if(useWebGL)GL.makeContextCurrent(contextHandle);OpenCVJSModule.useWebGL=useWebGL;Browser.OpenCVJSModuleContextCreatedCallbacks.forEach((function(callback){callback()}));Browser.init()}return ctx}),destroyContext:(function(canvas,useWebGL,setInOpenCVJSModule){}),fullscreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullscreen:(function(lockPointer,resizeCanvas,vrDevice){Browser.lockPointer=lockPointer;Browser.resizeCanvas=resizeCanvas;Browser.vrDevice=vrDevice;if(typeof Browser.lockPointer==="undefined")Browser.lockPointer=true;if(typeof Browser.resizeCanvas==="undefined")Browser.resizeCanvas=false;if(typeof Browser.vrDevice==="undefined")Browser.vrDevice=null;var canvas=OpenCVJSModule["canvas"];function fullscreenChange(){Browser.isFullscreen=false;var canvasContainer=canvas.parentNode;if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvasContainer){canvas.exitFullscreen=document["exitFullscreen"]||document["cancelFullScreen"]||document["mozCancelFullScreen"]||document["msExitFullscreen"]||document["webkitCancelFullScreen"]||(function(){});canvas.exitFullscreen=canvas.exitFullscreen.bind(document);if(Browser.lockPointer)canvas.requestPointerLock();Browser.isFullscreen=true;if(Browser.resizeCanvas)Browser.setFullscreenCanvasSize()}else{canvasContainer.parentNode.insertBefore(canvas,canvasContainer);canvasContainer.parentNode.removeChild(canvasContainer);if(Browser.resizeCanvas)Browser.setWindowedCanvasSize()}if(OpenCVJSModule["onFullScreen"])OpenCVJSModule["onFullScreen"](Browser.isFullscreen);if(OpenCVJSModule["onFullscreen"])OpenCVJSModule["onFullscreen"](Browser.isFullscreen);Browser.updateCanvasDimensions(canvas)}if(!Browser.fullscreenHandlersInstalled){Browser.fullscreenHandlersInstalled=true;document.addEventListener("fullscreenchange",fullscreenChange,false);document.addEventListener("mozfullscreenchange",fullscreenChange,false);document.addEventListener("webkitfullscreenchange",fullscreenChange,false);document.addEventListener("MSFullscreenChange",fullscreenChange,false)}var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas);canvasContainer.appendChild(canvas);canvasContainer.requestFullscreen=canvasContainer["requestFullscreen"]||canvasContainer["mozRequestFullScreen"]||canvasContainer["msRequestFullscreen"]||(canvasContainer["webkitRequestFullscreen"]?(function(){canvasContainer["webkitRequestFullscreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null)||(canvasContainer["webkitRequestFullScreen"]?(function(){canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null);if(vrDevice){canvasContainer.requestFullscreen({vrDisplay:vrDevice})}else{canvasContainer.requestFullscreen()}}),requestFullScreen:(function(lockPointer,resizeCanvas,vrDevice){OpenCVJSModule.printErr("Browser.requestFullScreen() is deprecated. Please call Browser.requestFullscreen instead.");Browser.requestFullScreen=(function(lockPointer,resizeCanvas,vrDevice){return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)});return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)}),nextRAF:0,fakeRequestAnimationFrame:(function(func){var now=Date.now();if(Browser.nextRAF===0){Browser.nextRAF=now+1e3/60}else{while(now+2>=Browser.nextRAF){Browser.nextRAF+=1e3/60}}var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)}),requestAnimationFrame:function requestAnimationFrame(func){if(typeof window==="undefined"){Browser.fakeRequestAnimationFrame(func)}else{if(!window.requestAnimationFrame){window.requestAnimationFrame=window["requestAnimationFrame"]||window["mozRequestAnimationFrame"]||window["webkitRequestAnimationFrame"]||window["msRequestAnimationFrame"]||window["oRequestAnimationFrame"]||Browser.fakeRequestAnimationFrame}window.requestAnimationFrame(func)}},safeCallback:(function(func){return(function(){if(!ABORT)return func.apply(null,arguments)})}),allowAsyncCallbacks:true,queuedAsyncCallbacks:[],pauseAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=false}),resumeAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=true;if(Browser.queuedAsyncCallbacks.length>0){var callbacks=Browser.queuedAsyncCallbacks;Browser.queuedAsyncCallbacks=[];callbacks.forEach((function(func){func()}))}}),safeRequestAnimationFrame:(function(func){return Browser.requestAnimationFrame((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}))}),safeSetTimeout:(function(func,timeout){OpenCVJSModule["noExitRuntime"]=true;return setTimeout((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}),timeout)}),safeSetInterval:(function(func,timeout){OpenCVJSModule["noExitRuntime"]=true;return setInterval((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}}),timeout)}),getMimetype:(function(name){return{"jpg":"image/jpeg","jpeg":"image/jpeg","png":"image/png","bmp":"image/bmp","ogg":"audio/ogg","wav":"audio/wav","mp3":"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]}),getUserMedia:(function(func){if(!window.getUserMedia){window.getUserMedia=navigator["getUserMedia"]||navigator["mozGetUserMedia"]}window.getUserMedia(func)}),getMovementX:(function(event){return event["movementX"]||event["mozMovementX"]||event["webkitMovementX"]||0}),getMovementY:(function(event){return event["movementY"]||event["mozMovementY"]||event["webkitMovementY"]||0}),getMouseWheelDelta:(function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event["deltaY"];break;default:throw"unrecognized mouse wheel event: "+event.type}return delta}),mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:(function(event){if(Browser.pointerLock){if(event.type!="mousemove"&&"mozMovementX"in event){Browser.mouseMovementX=Browser.mouseMovementY=0}else{Browser.mouseMovementX=Browser.getMovementX(event);Browser.mouseMovementY=Browser.getMovementY(event)}if(typeof SDL!="undefined"){Browser.mouseX=SDL.mouseX+Browser.mouseMovementX;Browser.mouseY=SDL.mouseY+Browser.mouseMovementY}else{Browser.mouseX+=Browser.mouseMovementX;Browser.mouseY+=Browser.mouseMovementY}}else{var rect=OpenCVJSModule["canvas"].getBoundingClientRect();var cw=OpenCVJSModule["canvas"].width;var ch=OpenCVJSModule["canvas"].height;var scrollX=typeof window.scrollX!=="undefined"?window.scrollX:window.pageXOffset;var scrollY=typeof window.scrollY!=="undefined"?window.scrollY:window.pageYOffset;if(event.type==="touchstart"||event.type==="touchend"||event.type==="touchmove"){var touch=event.touch;if(touch===undefined){return}var adjustedX=touch.pageX-(scrollX+rect.left);var adjustedY=touch.pageY-(scrollY+rect.top);adjustedX=adjustedX*(cw/rect.width);adjustedY=adjustedY*(ch/rect.height);var coords={x:adjustedX,y:adjustedY};if(event.type==="touchstart"){Browser.lastTouches[touch.identifier]=coords;Browser.touches[touch.identifier]=coords}else if(event.type==="touchend"||event.type==="touchmove"){var last=Browser.touches[touch.identifier];if(!last)last=coords;Browser.lastTouches[touch.identifier]=last;Browser.touches[touch.identifier]=coords}return}var x=event.pageX-(scrollX+rect.left);var y=event.pageY-(scrollY+rect.top);x=x*(cw/rect.width);y=y*(ch/rect.height);Browser.mouseMovementX=x-Browser.mouseX;Browser.mouseMovementY=y-Browser.mouseY;Browser.mouseX=x;Browser.mouseY=y}}),asyncLoad:(function(url,onload,onerror,noRunDep){var dep=!noRunDep?getUniqueRunDependency("al "+url):"";OpenCVJSModule["readAsync"](url,(function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).');onload(new Uint8Array(arrayBuffer));if(dep)removeRunDependency(dep)}),(function(event){if(onerror){onerror()}else{throw'Loading data file "'+url+'" failed.'}}));if(dep)addRunDependency(dep)}),resizeListeners:[],updateResizeListeners:(function(){var canvas=OpenCVJSModule["canvas"];Browser.resizeListeners.forEach((function(listener){listener(canvas.width,canvas.height)}))}),setCanvasSize:(function(width,height,noUpdates){var canvas=OpenCVJSModule["canvas"];Browser.updateCanvasDimensions(canvas,width,height);if(!noUpdates)Browser.updateResizeListeners()}),windowedWidth:0,windowedHeight:0,setFullscreenCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags|8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),setWindowedCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags&~8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),updateCanvasDimensions:(function(canvas,wNative,hNative){if(wNative&&hNative){canvas.widthNative=wNative;canvas.heightNative=hNative}else{wNative=canvas.widthNative;hNative=canvas.heightNative}var w=wNative;var h=hNative;if(OpenCVJSModule["forcedAspectRatio"]&&OpenCVJSModule["forcedAspectRatio"]>0){if(w/h<OpenCVJSModule["forcedAspectRatio"]){w=Math.round(h*OpenCVJSModule["forcedAspectRatio"])}else{h=Math.round(w/OpenCVJSModule["forcedAspectRatio"])}}if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvas.parentNode&&typeof screen!="undefined"){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor);h=Math.round(h*factor)}if(Browser.resizeCanvas){if(canvas.width!=w)canvas.width=w;if(canvas.height!=h)canvas.height=h;if(typeof canvas.style!="undefined"){canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}else{if(canvas.width!=wNative)canvas.width=wNative;if(canvas.height!=hNative)canvas.height=hNative;if(typeof canvas.style!="undefined"){if(w!=wNative||h!=hNative){canvas.style.setProperty("width",w+"px","important");canvas.style.setProperty("height",h+"px","important")}else{canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}}}),wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:(function(){var handle=Browser.nextWgetRequestHandle;Browser.nextWgetRequestHandle++;return handle})};function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};case 21523:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var tupleRegistrations={};function requireFunction(signature,rawFunction){signature=readLatin1String(signature);function makeDynCaller(dynCall){var args=[];for(var i=1;i<signature.length;++i){args.push("a"+i)}var name="dynCall_"+signature+"_"+rawFunction;var body="return function "+name+"("+args.join(", ")+") {\n";body+="    return dynCall(rawFunction"+(args.length?", ":"")+args.join(", ")+");\n";body+="};\n";return(new Function("dynCall","rawFunction",body))(dynCall,rawFunction)}var fp;if(OpenCVJSModule["FUNCTION_TABLE_"+signature]!==undefined){fp=OpenCVJSModule["FUNCTION_TABLE_"+signature][rawFunction]}else if(typeof FUNCTION_TABLE!=="undefined"){fp=FUNCTION_TABLE[rawFunction]}else{var dc=OpenCVJSModule["asm"]["dynCall_"+signature];if(dc===undefined){dc=OpenCVJSModule["asm"]["dynCall_"+signature.replace(/f/g,"d")];if(dc===undefined){throwBindingError("No dynCall invoker for signature: "+signature)}}fp=makeDynCaller(dc)}if(typeof fp!=="function"){throwBindingError("unknown function pointer with signature "+signature+": "+rawFunction)}return fp}function __embind_register_value_array(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){tupleRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),elements:[]}}function upcastPointer(ptr,ptrClass,desiredClass){while(ptrClass!==desiredClass){if(!ptrClass.upcast){throwBindingError("Expected null or instance of "+desiredClass.name+", got an instance of "+ptrClass.name)}ptr=ptrClass.upcast(ptr);ptrClass=ptrClass.baseClass}return ptr}function constNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function genericPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}if(this.isSmartPointer){var ptr=this.rawConstructor();if(destructors!==null){destructors.push(this.rawDestructor,ptr)}return ptr}else{return 0}}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(!this.isConst&&handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);if(this.isSmartPointer){if(undefined===handle.$$.smartPtr){throwBindingError("Passing raw pointer to smart pointer is illegal")}switch(this.sharingPolicy){case 0:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}break;case 1:ptr=handle.$$.smartPtr;break;case 2:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{var clonedHandle=handle["clone"]();ptr=this.rawShare(ptr,__emval_register((function(){clonedHandle["delete"]()})));if(destructors!==null){destructors.push(this.rawDestructor,ptr)}}break;default:throwBindingError("Unsupporting sharing policy")}}return ptr}function nonConstNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+handle.$$.ptrType.name+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function RegisteredPointer_getPointee(ptr){if(this.rawGetPointee){ptr=this.rawGetPointee(ptr)}return ptr}function RegisteredPointer_destructor(ptr){if(this.rawDestructor){this.rawDestructor(ptr)}}function RegisteredPointer_deleteObject(handle){if(handle!==null){handle["delete"]()}}function downcastPointer(ptr,ptrClass,desiredClass){if(ptrClass===desiredClass){return ptr}if(undefined===desiredClass.baseClass){return null}var rv=downcastPointer(ptr,ptrClass,desiredClass.baseClass);if(rv===null){return null}return desiredClass.downcast(rv)}var registeredPointers={};function getInheritedInstanceCount(){return Object.keys(registeredInstances).length}function getLiveInheritedInstances(){var rv=[];for(var k in registeredInstances){if(registeredInstances.hasOwnProperty(k)){rv.push(registeredInstances[k])}}return rv}var deletionQueue=[];function flushPendingDeletes(){while(deletionQueue.length){var obj=deletionQueue.pop();obj.$$.deleteScheduled=false;obj["delete"]()}}var delayFunction=undefined;function setDelayFunction(fn){delayFunction=fn;if(deletionQueue.length&&delayFunction){delayFunction(flushPendingDeletes)}}function init_embind(){OpenCVJSModule["getInheritedInstanceCount"]=getInheritedInstanceCount;OpenCVJSModule["getLiveInheritedInstances"]=getLiveInheritedInstances;OpenCVJSModule["flushPendingDeletes"]=flushPendingDeletes;OpenCVJSModule["setDelayFunction"]=setDelayFunction}var registeredInstances={};function getBasestPointer(class_,ptr){if(ptr===undefined){throwBindingError("ptr should not be undefined")}while(class_.baseClass){ptr=class_.upcast(ptr);class_=class_.baseClass}return ptr}function getInheritedInstance(class_,ptr){ptr=getBasestPointer(class_,ptr);return registeredInstances[ptr]}function makeClassHandle(prototype,record){if(!record.ptrType||!record.ptr){throwInternalError("makeClassHandle requires ptr and ptrType")}var hasSmartPtrType=!!record.smartPtrType;var hasSmartPtr=!!record.smartPtr;if(hasSmartPtrType!==hasSmartPtr){throwInternalError("Both smartPtrType and smartPtr must be specified")}record.count={value:1};return Object.create(prototype,{$$:{value:record}})}function RegisteredPointer_fromWireType(ptr){var rawPointer=this.getPointee(ptr);if(!rawPointer){this.destructor(ptr);return null}var registeredInstance=getInheritedInstance(this.registeredClass,rawPointer);if(undefined!==registeredInstance){if(0===registeredInstance.$$.count.value){registeredInstance.$$.ptr=rawPointer;registeredInstance.$$.smartPtr=ptr;return registeredInstance["clone"]()}else{var rv=registeredInstance["clone"]();this.destructor(ptr);return rv}}function makeDefaultHandle(){if(this.isSmartPointer){return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this.pointeeType,ptr:rawPointer,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this,ptr:ptr})}}var actualType=this.registeredClass.getActualType(rawPointer);var registeredPointerRecord=registeredPointers[actualType];if(!registeredPointerRecord){return makeDefaultHandle.call(this)}var toType;if(this.isConst){toType=registeredPointerRecord.constPointerType}else{toType=registeredPointerRecord.pointerType}var dp=downcastPointer(rawPointer,this.registeredClass,toType.registeredClass);if(dp===null){return makeDefaultHandle.call(this)}if(this.isSmartPointer){return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp})}}function init_RegisteredPointer(){RegisteredPointer.prototype.getPointee=RegisteredPointer_getPointee;RegisteredPointer.prototype.destructor=RegisteredPointer_destructor;RegisteredPointer.prototype["argPackAdvance"]=8;RegisteredPointer.prototype["readValueFromPointer"]=simpleReadValueFromPointer;RegisteredPointer.prototype["deleteObject"]=RegisteredPointer_deleteObject;RegisteredPointer.prototype["fromWireType"]=RegisteredPointer_fromWireType}function RegisteredPointer(name,registeredClass,isReference,isConst,isSmartPointer,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor){this.name=name;this.registeredClass=registeredClass;this.isReference=isReference;this.isConst=isConst;this.isSmartPointer=isSmartPointer;this.pointeeType=pointeeType;this.sharingPolicy=sharingPolicy;this.rawGetPointee=rawGetPointee;this.rawConstructor=rawConstructor;this.rawShare=rawShare;this.rawDestructor=rawDestructor;if(!isSmartPointer&&registeredClass.baseClass===undefined){if(isConst){this["toWireType"]=constNoSmartPtrRawPointerToWireType;this.destructorFunction=null}else{this["toWireType"]=nonConstNoSmartPtrRawPointerToWireType;this.destructorFunction=null}}else{this["toWireType"]=genericPointerToWireType}}function __embind_register_smart_ptr(rawType,rawPointeeType,name,sharingPolicy,getPointeeSignature,rawGetPointee,constructorSignature,rawConstructor,shareSignature,rawShare,destructorSignature,rawDestructor){name=readLatin1String(name);rawGetPointee=requireFunction(getPointeeSignature,rawGetPointee);rawConstructor=requireFunction(constructorSignature,rawConstructor);rawShare=requireFunction(shareSignature,rawShare);rawDestructor=requireFunction(destructorSignature,rawDestructor);whenDependentTypesAreResolved([rawType],[rawPointeeType],(function(pointeeType){pointeeType=pointeeType[0];var registeredPointer=new RegisteredPointer(name,pointeeType.registeredClass,false,false,true,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor);return[registeredPointer]}))}function _llvm_exp2_f32(x){return Math.pow(2,x)}function _llvm_exp2_f64(){return _llvm_exp2_f32.apply(null,arguments)}function _sched_yield(){return 0}function craftInvokerFunction(humanName,argTypes,classType,cppInvokerFunc,cppTargetFunc){var argCount=argTypes.length;if(argCount<2){throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!")}var isClassMethodFunc=argTypes[1]!==null&&classType!==null;var argsList="";var argsListWired="";for(var i=0;i<argCount-2;++i){argsList+=(i!==0?", ":"")+"arg"+i;argsListWired+=(i!==0?", ":"")+"arg"+i+"Wired"}var invokerFnBody="return function "+makeLegalFunctionName(humanName)+"("+argsList+") {\n"+"if (arguments.length !== "+(argCount-2)+") {\n"+"throwBindingError('function "+humanName+" called with ' + arguments.length + ' arguments, expected "+(argCount-2)+" args!');\n"+"}\n";var needsDestructorStack=false;for(var i=1;i<argTypes.length;++i){if(argTypes[i]!==null&&argTypes[i].destructorFunction===undefined){needsDestructorStack=true;break}}if(needsDestructorStack){invokerFnBody+="var destructors = [];\n"}var dtorStack=needsDestructorStack?"destructors":"null";var args1=["throwBindingError","invoker","fn","runDestructors","retType","classParam"];var args2=[throwBindingError,cppInvokerFunc,cppTargetFunc,runDestructors,argTypes[0],argTypes[1]];if(isClassMethodFunc){invokerFnBody+="var thisWired = classParam.toWireType("+dtorStack+", this);\n"}for(var i=0;i<argCount-2;++i){invokerFnBody+="var arg"+i+"Wired = argType"+i+".toWireType("+dtorStack+", arg"+i+"); // "+argTypes[i+2].name+"\n";args1.push("argType"+i);args2.push(argTypes[i+2])}if(isClassMethodFunc){argsListWired="thisWired"+(argsListWired.length>0?", ":"")+argsListWired}var returns=argTypes[0].name!=="void";invokerFnBody+=(returns?"var rv = ":"")+"invoker(fn"+(argsListWired.length>0?", ":"")+argsListWired+");\n";if(needsDestructorStack){invokerFnBody+="runDestructors(destructors);\n"}else{for(var i=isClassMethodFunc?1:2;i<argTypes.length;++i){var paramName=i===1?"thisWired":"arg"+(i-2)+"Wired";if(argTypes[i].destructorFunction!==null){invokerFnBody+=paramName+"_dtor("+paramName+"); // "+argTypes[i].name+"\n";args1.push(paramName+"_dtor");args2.push(argTypes[i].destructorFunction)}}}if(returns){invokerFnBody+="var ret = retType.fromWireType(rv);\n"+"return ret;\n"}else{}invokerFnBody+="}\n";args1.push(invokerFnBody);var invokerFunction=new_(Function,args1).apply(null,args2);return invokerFunction}function ensureOverloadTable(proto,methodName,humanName){if(undefined===proto[methodName].overloadTable){var prevFunc=proto[methodName];proto[methodName]=(function(){if(!proto[methodName].overloadTable.hasOwnProperty(arguments.length)){throwBindingError("Function '"+humanName+"' called with an invalid number of arguments ("+arguments.length+") - expects one of ("+proto[methodName].overloadTable+")!")}return proto[methodName].overloadTable[arguments.length].apply(this,arguments)});proto[methodName].overloadTable=[];proto[methodName].overloadTable[prevFunc.argCount]=prevFunc}}function heap32VectorToArray(count,firstElement){var array=[];for(var i=0;i<count;i++){array.push(HEAP32[(firstElement>>2)+i])}return array}var UnboundTypeError=undefined;function throwUnboundTypeError(message,types){var unboundTypes=[];var seen={};function visit(type){if(seen[type]){return}if(registeredTypes[type]){return}if(typeDependencies[type]){typeDependencies[type].forEach(visit);return}unboundTypes.push(type);seen[type]=true}types.forEach(visit);throw new UnboundTypeError(message+": "+unboundTypes.map(getTypeName).join([", "]))}function __embind_register_class_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,fn){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.constructor;if(undefined===proto[methodName]){unboundTypesHandler.argCount=argCount-1;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-1]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));var func=craftInvokerFunction(humanName,invokerArgsArray,null,rawInvoker,fn);if(undefined===proto[methodName].overloadTable){proto[methodName]=func}else{proto[methodName].overloadTable[argCount-1]=func}return[]}));return[]}))}var _environ=STATICTOP;STATICTOP+=16;function ___buildEnvironment(env){var MAX_ENV_VALUES=64;var TOTAL_ENV_SIZE=1024;var poolPtr;var envPtr;if(!___buildEnvironment.called){___buildEnvironment.called=true;ENV["USER"]=ENV["LOGNAME"]="web_user";ENV["PATH"]="/";ENV["PWD"]="/";ENV["HOME"]="/home/web_user";ENV["LANG"]="C";ENV["_"]=OpenCVJSModule["thisProgram"];poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC);envPtr=allocate(MAX_ENV_VALUES*4,"i8*",ALLOC_STATIC);HEAP32[envPtr>>2]=poolPtr;HEAP32[_environ>>2]=envPtr}else{envPtr=HEAP32[_environ>>2];poolPtr=HEAP32[envPtr>>2]}var strings=[];var totalSize=0;for(var key in env){if(typeof env[key]==="string"){var line=key+"="+env[key];strings.push(line);totalSize+=line.length}}if(totalSize>TOTAL_ENV_SIZE){throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")}var ptrSize=4;for(var i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr);HEAP32[envPtr+i*ptrSize>>2]=poolPtr;poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}var ENV={};function _getenv(name){if(name===0)return 0;name=Pointer_stringify(name);if(!ENV.hasOwnProperty(name))return 0;if(_getenv.ret)_free(_getenv.ret);_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL);return _getenv.ret}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function __emval_allocateDestructors(destructorsRef){var destructors=[];HEAP32[destructorsRef>>2]=__emval_register(destructors);return destructors}function requireHandle(handle){if(!handle){throwBindingError("Cannot use deleted val. handle = "+handle)}return emval_handle_array[handle].value}function __emval_call_void_method(caller,handle,methodName,args){caller=emval_methodCallers[caller];handle=requireHandle(handle);methodName=getStringOrSymbol(methodName);caller(handle,methodName,null,args)}function _gettimeofday(ptr){var now=Date.now();HEAP32[ptr>>2]=now/1e3|0;HEAP32[ptr+4>>2]=now%1e3*1e3|0;return 0}function ___map_file(pathname,size){___setErrNo(ERRNO_CODES.EPERM);return-1}function __emval_run_destructors(handle){var destructors=emval_handle_array[handle].value;runDestructors(destructors);__emval_decref(handle)}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}var _llvm_pow_f64=Math_pow;function __embind_finalize_value_array(rawTupleType){var reg=tupleRegistrations[rawTupleType];delete tupleRegistrations[rawTupleType];var elements=reg.elements;var elementsLength=elements.length;var elementTypes=elements.map((function(elt){return elt.getterReturnType})).concat(elements.map((function(elt){return elt.setterArgumentType})));var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;whenDependentTypesAreResolved([rawTupleType],elementTypes,(function(elementTypes){elements.forEach((function(elt,i){var getterReturnType=elementTypes[i];var getter=elt.getter;var getterContext=elt.getterContext;var setterArgumentType=elementTypes[i+elementsLength];var setter=elt.setter;var setterContext=elt.setterContext;elt.read=(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))});elt.write=(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}));return[{name:reg.name,"fromWireType":(function(ptr){var rv=new Array(elementsLength);for(var i=0;i<elementsLength;++i){rv[i]=elements[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){if(elementsLength!==o.length){throw new TypeError("Incorrect number of tuple elements for "+reg.name+": expected="+elementsLength+", actual="+o.length)}var ptr=rawConstructor();for(var i=0;i<elementsLength;++i){elements[i].write(ptr,o[i])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}function ___gxx_personality_v0(){}function _pthread_cond_wait(){return 0}function __embind_register_memory_view(rawType,dataTypeIndex,name){var typeMapping=[Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];var TA=typeMapping[dataTypeIndex];function decodeMemoryView(handle){handle=handle>>2;var heap=HEAPU32;var size=heap[handle];var data=heap[handle+1];return new TA(heap["buffer"],data,size)}name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":decodeMemoryView,"argPackAdvance":8,"readValueFromPointer":decodeMemoryView},{ignoreDuplicateRegistrations:true})}function validateThis(this_,classType,humanName){if(!(this_ instanceof Object)){throwBindingError(humanName+' with invalid "this": '+this_)}if(!(this_ instanceof classType.registeredClass.constructor)){throwBindingError(humanName+' incompatible with "this" of type '+this_.constructor.name)}if(!this_.$$.ptr){throwBindingError("cannot call emscripten binding method "+humanName+" on deleted object")}return upcastPointer(this_.$$.ptr,this_.$$.ptrType.registeredClass,classType.registeredClass)}function __embind_register_class_property(classType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){fieldName=readLatin1String(fieldName);getter=requireFunction(getterSignature,getter);whenDependentTypesAreResolved([],[classType],(function(classType){classType=classType[0];var humanName=classType.name+"."+fieldName;var desc={get:(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])}),enumerable:true,configurable:true};if(setter){desc.set=(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])})}else{desc.set=(function(v){throwBindingError(humanName+" is a read-only property")})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);whenDependentTypesAreResolved([],setter?[getterReturnType,setterArgumentType]:[getterReturnType],(function(types){var getterReturnType=types[0];var desc={get:(function(){var ptr=validateThis(this,classType,humanName+" getter");return getterReturnType["fromWireType"](getter(getterContext,ptr))}),enumerable:true};if(setter){setter=requireFunction(setterSignature,setter);var setterArgumentType=types[1];desc.set=(function(v){var ptr=validateThis(this,classType,humanName+" setter");var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,v));runDestructors(destructors)})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);return[]}));return[]}))}function __emval_incref(handle){if(handle>4){emval_handle_array[handle].refcount+=1}}function _pthread_mutexattr_settype(){}function __embind_register_value_object(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){structRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),fields:[]}}function __embind_register_bool(rawType,name,size,trueValue,falseValue){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(wt){return!!wt}),"toWireType":(function(destructors,o){return o?trueValue:falseValue}),"argPackAdvance":8,"readValueFromPointer":(function(pointer){var heap;if(size===1){heap=HEAP8}else if(size===2){heap=HEAP16}else if(size===4){heap=HEAP32}else{throw new TypeError("Unknown boolean type size: "+name)}return this["fromWireType"](heap[pointer>>shift])}),destructorFunction:null})}function ___assert_fail(condition,filename,line,func){ABORT=true;throw"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}function __embind_register_void(rawType,name){name=readLatin1String(name);registerType(rawType,{isVoid:true,name:name,"argPackAdvance":0,"fromWireType":(function(){return undefined}),"toWireType":(function(destructors,o){return undefined})})}function __emval_new_array(){return __emval_register([])}function _abort(){OpenCVJSModule["abort"]()}function __emval_as(handle,returnType,destructorsRef){handle=requireHandle(handle);returnType=requireRegisteredType(returnType,"emval::as");var destructors=[];var rd=__emval_register(destructors);HEAP32[destructorsRef>>2]=rd;return returnType["toWireType"](destructors,handle)}function _pthread_mutex_destroy(){}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;OpenCVJSModule["dynCall_v"](func);_pthread_once.seen[ptr]=1}function __embind_register_value_object_field(structType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){structRegistrations[structType].fields.push({fieldName:readLatin1String(fieldName),getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ClassHandle_isAliasOf(other){if(!(this instanceof ClassHandle)){return false}if(!(other instanceof ClassHandle)){return false}var leftClass=this.$$.ptrType.registeredClass;var left=this.$$.ptr;var rightClass=other.$$.ptrType.registeredClass;var right=other.$$.ptr;while(leftClass.baseClass){left=leftClass.upcast(left);leftClass=leftClass.baseClass}while(rightClass.baseClass){right=rightClass.upcast(right);rightClass=rightClass.baseClass}return leftClass===rightClass&&left===right}function shallowCopyInternalPointer(o){return{count:o.count,deleteScheduled:o.deleteScheduled,preservePointerOnDelete:o.preservePointerOnDelete,ptr:o.ptr,ptrType:o.ptrType,smartPtr:o.smartPtr,smartPtrType:o.smartPtrType}}function throwInstanceAlreadyDeleted(obj){function getInstanceTypeName(handle){return handle.$$.ptrType.registeredClass.name}throwBindingError(getInstanceTypeName(obj)+" instance already deleted")}function ClassHandle_clone(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.preservePointerOnDelete){this.$$.count.value+=1;return this}else{var clone=Object.create(Object.getPrototypeOf(this),{$$:{value:shallowCopyInternalPointer(this.$$)}});clone.$$.count.value+=1;clone.$$.deleteScheduled=false;return clone}}function runDestructor(handle){var $$=handle.$$;if($$.smartPtr){$$.smartPtrType.rawDestructor($$.smartPtr)}else{$$.ptrType.registeredClass.rawDestructor($$.ptr)}}function ClassHandle_delete(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}this.$$.count.value-=1;var toDelete=0===this.$$.count.value;if(toDelete){runDestructor(this)}if(!this.$$.preservePointerOnDelete){this.$$.smartPtr=undefined;this.$$.ptr=undefined}}function ClassHandle_isDeleted(){return!this.$$.ptr}function ClassHandle_deleteLater(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}deletionQueue.push(this);if(deletionQueue.length===1&&delayFunction){delayFunction(flushPendingDeletes)}this.$$.deleteScheduled=true;return this}function init_ClassHandle(){ClassHandle.prototype["isAliasOf"]=ClassHandle_isAliasOf;ClassHandle.prototype["clone"]=ClassHandle_clone;ClassHandle.prototype["delete"]=ClassHandle_delete;ClassHandle.prototype["isDeleted"]=ClassHandle_isDeleted;ClassHandle.prototype["deleteLater"]=ClassHandle_deleteLater}function ClassHandle(){}function exposePublicSymbol(name,value,numArguments){if(OpenCVJSModule.hasOwnProperty(name)){if(undefined===numArguments||undefined!==OpenCVJSModule[name].overloadTable&&undefined!==OpenCVJSModule[name].overloadTable[numArguments]){throwBindingError("Cannot register public name '"+name+"' twice")}ensureOverloadTable(OpenCVJSModule,name,name);if(OpenCVJSModule.hasOwnProperty(numArguments)){throwBindingError("Cannot register multiple overloads of a function with the same number of arguments ("+numArguments+")!")}OpenCVJSModule[name].overloadTable[numArguments]=value}else{OpenCVJSModule[name]=value;if(undefined!==numArguments){OpenCVJSModule[name].numArguments=numArguments}}}function RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast){this.name=name;this.constructor=constructor;this.instancePrototype=instancePrototype;this.rawDestructor=rawDestructor;this.baseClass=baseClass;this.getActualType=getActualType;this.upcast=upcast;this.downcast=downcast;this.pureVirtualFunctions=[]}function replacePublicSymbol(name,value,numArguments){if(!OpenCVJSModule.hasOwnProperty(name)){throwInternalError("Replacing nonexistant public symbol")}if(undefined!==OpenCVJSModule[name].overloadTable&&undefined!==numArguments){OpenCVJSModule[name].overloadTable[numArguments]=value}else{OpenCVJSModule[name]=value;OpenCVJSModule[name].argCount=numArguments}}function __embind_register_class(rawType,rawPointerType,rawConstPointerType,baseClassRawType,getActualTypeSignature,getActualType,upcastSignature,upcast,downcastSignature,downcast,name,destructorSignature,rawDestructor){name=readLatin1String(name);getActualType=requireFunction(getActualTypeSignature,getActualType);if(upcast){upcast=requireFunction(upcastSignature,upcast)}if(downcast){downcast=requireFunction(downcastSignature,downcast)}rawDestructor=requireFunction(destructorSignature,rawDestructor);var legalFunctionName=makeLegalFunctionName(name);exposePublicSymbol(legalFunctionName,(function(){throwUnboundTypeError("Cannot construct "+name+" due to unbound types",[baseClassRawType])}));whenDependentTypesAreResolved([rawType,rawPointerType,rawConstPointerType],baseClassRawType?[baseClassRawType]:[],(function(base){base=base[0];var baseClass;var basePrototype;if(baseClassRawType){baseClass=base.registeredClass;basePrototype=baseClass.instancePrototype}else{basePrototype=ClassHandle.prototype}var constructor=createNamedFunction(legalFunctionName,(function(){if(Object.getPrototypeOf(this)!==instancePrototype){throw new BindingError("Use 'new' to construct "+name)}if(undefined===registeredClass.constructor_body){throw new BindingError(name+" has no accessible constructor")}var body=registeredClass.constructor_body[arguments.length];if(undefined===body){throw new BindingError("Tried to invoke ctor of "+name+" with invalid number of parameters ("+arguments.length+") - expected ("+Object.keys(registeredClass.constructor_body).toString()+") parameters instead!")}return body.apply(this,arguments)}));var instancePrototype=Object.create(basePrototype,{constructor:{value:constructor}});constructor.prototype=instancePrototype;var registeredClass=new RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast);var referenceConverter=new RegisteredPointer(name,registeredClass,true,false,false);var pointerConverter=new RegisteredPointer(name+"*",registeredClass,false,false,false);var constPointerConverter=new RegisteredPointer(name+" const*",registeredClass,false,true,false);registeredPointers[rawType]={pointerType:pointerConverter,constPointerType:constPointerConverter};replacePublicSymbol(legalFunctionName,constructor);return[referenceConverter,pointerConverter,constPointerConverter]}))}function ___lock(){}function ___unlock(){}function _pthread_mutexattr_init(){}function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}function _pthread_key_delete(key){if(key in PTHREAD_SPECIFIC){delete PTHREAD_SPECIFIC[key];return 0}return ERRNO_CODES.EINVAL}function __emval_get_property(handle,key){handle=requireHandle(handle);key=requireHandle(key);return __emval_register(handle[key])}function __embind_register_emval(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(handle){var rv=emval_handle_array[handle].value;__emval_decref(handle);return rv}),"toWireType":(function(destructors,value){return __emval_register(value)}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:null})}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function __embind_register_value_array_element(rawTupleType,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){tupleRegistrations[rawTupleType].elements.push({getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ___cxa_allocate_exception(size){return _malloc(size)}function ___cxa_pure_virtual(){ABORT=true;throw"Pure virtual function called!"}function floatReadValueFromPointer(name,shift){switch(shift){case 2:return(function(pointer){return this["fromWireType"](HEAPF32[pointer>>2])});case 3:return(function(pointer){return this["fromWireType"](HEAPF64[pointer>>3])});default:throw new TypeError("Unknown float type: "+name)}}function __embind_register_float(rawType,name,size){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){return value}),"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}return value}),"argPackAdvance":8,"readValueFromPointer":floatReadValueFromPointer(name,shift),destructorFunction:null})}function __embind_register_function(name,argCount,rawArgTypesAddr,signature,rawInvoker,fn){var argTypes=heap32VectorToArray(argCount,rawArgTypesAddr);name=readLatin1String(name);rawInvoker=requireFunction(signature,rawInvoker);exposePublicSymbol(name,(function(){throwUnboundTypeError("Cannot call "+name+" due to unbound types",argTypes)}),argCount-1);whenDependentTypesAreResolved([],argTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));replacePublicSymbol(name,craftInvokerFunction(name,invokerArgsArray,null,rawInvoker,fn),argCount-1);return[]}))}function __embind_register_constant(name,type,value){name=readLatin1String(name);whenDependentTypesAreResolved([],[type],(function(type){type=type[0];OpenCVJSModule[name]=type["fromWireType"](value);return[]}))}function ___cxa_begin_catch(ptr){var info=EXCEPTIONS.infos[ptr];if(info&&!info.caught){info.caught=true;__ZSt18uncaught_exceptionv.uncaught_exception--}if(info)info.rethrown=false;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}function ___syscall3(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.read(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall4(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.write(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_constructor(rawClassType,argCount,rawArgTypesAddr,invokerSignature,invoker,rawConstructor){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);invoker=requireFunction(invokerSignature,invoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName="constructor "+classType.name;if(undefined===classType.registeredClass.constructor_body){classType.registeredClass.constructor_body=[]}if(undefined!==classType.registeredClass.constructor_body[argCount-1]){throw new BindingError("Cannot register multiple constructors with identical number of parameters ("+(argCount-1)+") for class '"+classType.name+"'! Overload resolution is currently only performed using the parameter count, not actual type info!")}classType.registeredClass.constructor_body[argCount-1]=function unboundTypeHandler(){throwUnboundTypeError("Cannot construct "+classType.name+" due to unbound types",rawArgTypes)};whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){classType.registeredClass.constructor_body[argCount-1]=function constructor_body(){if(arguments.length!==argCount-1){throwBindingError(humanName+" called with "+arguments.length+" arguments, expected "+(argCount-1))}var destructors=[];var args=new Array(argCount);args[0]=rawConstructor;for(var i=1;i<argCount;++i){args[i]=argTypes[i]["toWireType"](destructors,arguments[i-1])}var ptr=invoker.apply(null,args);runDestructors(destructors);return argTypes[0]["fromWireType"](ptr)};return[]}));return[]}))}function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,context,isPureVirtual){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;if(isPureVirtual){classType.registeredClass.pureVirtualFunctions.push(methodName)}function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.instancePrototype;var method=proto[methodName];if(undefined===method||undefined===method.overloadTable&&method.className!==classType.name&&method.argCount===argCount-2){unboundTypesHandler.argCount=argCount-2;unboundTypesHandler.className=classType.name;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-2]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var memberFunction=craftInvokerFunction(humanName,argTypes,classType,rawInvoker,context);if(undefined===proto[methodName].overloadTable){memberFunction.argCount=argCount-2;proto[methodName]=memberFunction}else{proto[methodName].overloadTable[argCount-2]=memberFunction}return[]}));return[]}))}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),cmd=SYSCALLS.get();switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-ERRNO_CODES.EINVAL}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd};case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0};case 12:case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0};case 13:case 14:case 13:case 14:return 0;case 16:case 8:return-ERRNO_CODES.EINVAL;case 9:___setErrNo(ERRNO_CODES.EINVAL);return-1;default:{return-ERRNO_CODES.EINVAL}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var ___dso_handle=STATICTOP;STATICTOP+=16;embind_init_charCodes();init_emval();BindingError=OpenCVJSModule["BindingError"]=extendError(Error,"BindingError");InternalError=OpenCVJSModule["InternalError"]=extendError(Error,"InternalError");FS.staticInit();__ATINIT__.unshift((function(){if(!OpenCVJSModule["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));OpenCVJSModule["FS_createFolder"]=FS.createFolder;OpenCVJSModule["FS_createPath"]=FS.createPath;OpenCVJSModule["FS_createDataFile"]=FS.createDataFile;OpenCVJSModule["FS_createPreloadedFile"]=FS.createPreloadedFile;OpenCVJSModule["FS_createLazyFile"]=FS.createLazyFile;OpenCVJSModule["FS_createLink"]=FS.createLink;OpenCVJSModule["FS_createDevice"]=FS.createDevice;OpenCVJSModule["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}OpenCVJSModule["requestFullScreen"]=function OpenCVJSModule_requestFullScreen(lockPointer,resizeCanvas,vrDevice){OpenCVJSModule.printErr("OpenCVJSModule.requestFullScreen is deprecated. Please call OpenCVJSModule.requestFullscreen instead.");OpenCVJSModule["requestFullScreen"]=OpenCVJSModule["requestFullscreen"];Browser.requestFullScreen(lockPointer,resizeCanvas,vrDevice)};OpenCVJSModule["requestFullscreen"]=function OpenCVJSModule_requestFullscreen(lockPointer,resizeCanvas,vrDevice){Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)};OpenCVJSModule["requestAnimationFrame"]=function OpenCVJSModule_requestAnimationFrame(func){Browser.requestAnimationFrame(func)};OpenCVJSModule["setCanvasSize"]=function OpenCVJSModule_setCanvasSize(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)};OpenCVJSModule["pauseMainLoop"]=function OpenCVJSModule_pauseMainLoop(){Browser.mainLoop.pause()};OpenCVJSModule["resumeMainLoop"]=function OpenCVJSModule_resumeMainLoop(){Browser.mainLoop.resume()};OpenCVJSModule["getUserMedia"]=function OpenCVJSModule_getUserMedia(){Browser.getUserMedia()};OpenCVJSModule["createContext"]=function OpenCVJSModule_createContext(canvas,useWebGL,setInOpenCVJSModule,webGLContextAttributes){return Browser.createContext(canvas,useWebGL,setInOpenCVJSModule,webGLContextAttributes)};if(ENVIRONMENT_IS_NODE){_emscripten_get_now=function _emscripten_get_now_actual(){var t=process["hrtime"]();return t[0]*1e3+t[1]/1e6}}else if(typeof dateNow!=="undefined"){_emscripten_get_now=dateNow}else if(typeof self==="object"&&self["performance"]&&typeof self["performance"]["now"]==="function"){_emscripten_get_now=(function(){return self["performance"]["now"]()})}else if(typeof performance==="object"&&typeof performance["now"]==="function"){_emscripten_get_now=(function(){return performance["now"]()})}else{_emscripten_get_now=Date.now}init_RegisteredPointer();init_embind();UnboundTypeError=OpenCVJSModule["UnboundTypeError"]=extendError(Error,"UnboundTypeError");___buildEnvironment(ENV);init_ClassHandle();DYNAMICTOP_PTR=allocate(1,"i32",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=Runtime.alignMemory(STACK_MAX);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;staticSealed=true;function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddd(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiiddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddi(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiiddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidiii(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidddd(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiidddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iidi(index,a1,a2,a3){try{return OpenCVJSModule["dynCall_iidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddidd(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiddidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vidi(index,a1,a2,a3){try{OpenCVJSModule["dynCall_vidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddii(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiddii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddid(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiddid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiidi(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_iiiidi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidi(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiiidi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiddii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiidd(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_iiiidd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidd(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiiidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiddiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_di(index,a1){try{return OpenCVJSModule["dynCall_di"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiddi(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vdii(index,a1,a2,a3){try{OpenCVJSModule["dynCall_vdii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_diiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiddiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return OpenCVJSModule["dynCall_iiiiiddiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_dii(index,a1,a2){try{return OpenCVJSModule["dynCall_dii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiddid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return OpenCVJSModule["dynCall_iiiiiddid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return OpenCVJSModule["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidddi(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiidddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiid(index,a1,a2,a3,a4){try{return OpenCVJSModule["dynCall_iiiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return OpenCVJSModule["dynCall_iiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiddi(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_iiiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddiii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiddiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddiid(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiddiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiiiididiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{return OpenCVJSModule["dynCall_iiiiiiiididiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidiiid(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viidiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{OpenCVJSModule["dynCall_viiiiiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiiddi(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_diiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiididii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiididii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return OpenCVJSModule["dynCall_diiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiidiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return OpenCVJSModule["dynCall_iiidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidd(index,a1,a2,a3,a4,a5){try{OpenCVJSModule["dynCall_viiidd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidi(index,a1,a2,a3,a4,a5){try{OpenCVJSModule["dynCall_viiidi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_iiidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return OpenCVJSModule["dynCall_iiiiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiddi(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_diiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiddi(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_iiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diii(index,a1,a2,a3){try{return OpenCVJSModule["dynCall_diii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddd(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiiddd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiddii(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiiddii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddi(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiid(index,a1,a2,a3,a4){try{OpenCVJSModule["dynCall_viiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_iiiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidii(index,a1,a2,a3,a4,a5){try{OpenCVJSModule["dynCall_viidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiidddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{OpenCVJSModule["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{OpenCVJSModule["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return OpenCVJSModule["dynCall_iiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viidiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vid(index,a1,a2){try{OpenCVJSModule["dynCall_vid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidi(index,a1,a2,a3,a4){try{return OpenCVJSModule["dynCall_iiidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidd(index,a1,a2,a3,a4){try{return OpenCVJSModule["dynCall_iiidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{OpenCVJSModule["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiid(index,a1,a2,a3,a4,a5){try{OpenCVJSModule["dynCall_viiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return OpenCVJSModule["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidd(index,a1,a2,a3,a4){try{OpenCVJSModule["dynCall_viidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidi(index,a1,a2,a3,a4){try{OpenCVJSModule["dynCall_viidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiidii(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiid(index,a1,a2,a3,a4){try{return OpenCVJSModule["dynCall_diiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiii(index,a1,a2,a3,a4){try{return OpenCVJSModule["dynCall_diiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{OpenCVJSModule["dynCall_viiiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iid(index,a1,a2){try{return OpenCVJSModule["dynCall_iid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddid(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiddid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viididdi(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viididdi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return OpenCVJSModule["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiddi(index,a1,a2,a3,a4,a5){try{OpenCVJSModule["dynCall_viiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiididi(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiididi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vdiii(index,a1,a2,a3,a4){try{OpenCVJSModule["dynCall_vdiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{OpenCVJSModule["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_v(index){try{OpenCVJSModule["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viid(index,a1,a2,a3){try{OpenCVJSModule["dynCall_viid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiddiid(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_iiiddiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vi(index,a1){try{OpenCVJSModule["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_ii(index,a1){try{return OpenCVJSModule["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{OpenCVJSModule["dynCall_viiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vididdi(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_vididdi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vidii(index,a1,a2,a3,a4){try{OpenCVJSModule["dynCall_vidii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_iiiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidi(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viidiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return OpenCVJSModule["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viididii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viididii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiddid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viiiiddid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiid(index,a1,a2,a3){try{return OpenCVJSModule["dynCall_iiid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{OpenCVJSModule["dynCall_viiiiiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_viiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiiii(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_diiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiiid(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_diiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{return OpenCVJSModule["dynCall_iiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiidd(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiiiidd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiidii(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidiii(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_iiidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{return OpenCVJSModule["dynCall_iiidiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_i(index){try{return OpenCVJSModule["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidii(index,a1,a2,a3,a4,a5){try{return OpenCVJSModule["dynCall_iiidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_diiiiii(index,a1,a2,a3,a4,a5,a6){try{return OpenCVJSModule["dynCall_diiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return OpenCVJSModule["dynCall_iiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vididdii(index,a1,a2,a3,a4,a5,a6,a7){try{OpenCVJSModule["dynCall_vididdii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{OpenCVJSModule["dynCall_viiiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiidd(index,a1,a2,a3,a4,a5,a6,a7){try{return OpenCVJSModule["dynCall_iiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viididi(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viididi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return OpenCVJSModule["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viididdii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{OpenCVJSModule["dynCall_viididdii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{OpenCVJSModule["dynCall_viiiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_viiiidd(index,a1,a2,a3,a4,a5,a6){try{OpenCVJSModule["dynCall_viiiidd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}function invoke_vidiii(index,a1,a2,a3,a4,a5){try{OpenCVJSModule["dynCall_vidiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;OpenCVJSModule["setThrew"](1,0)}}OpenCVJSModule.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity,"byteLength":byteLength};OpenCVJSModule.asmLibraryArg={"abort":abort,"assert":assert,"enlargeMemory":enlargeMemory,"getTotalMemory":getTotalMemory,"abortOnCannotGrowMemory":abortOnCannotGrowMemory,"invoke_iiiiiid":invoke_iiiiiid,"invoke_viiiiddd":invoke_viiiiddd,"invoke_viiiidiii":invoke_viiiidiii,"invoke_viiiiiddi":invoke_viiiiiddi,"invoke_viiidiii":invoke_viiidiii,"invoke_viiiidiid":invoke_viiiidiid,"invoke_iiiiiii":invoke_iiiiiii,"invoke_viiiidddiiii":invoke_viiiidddiiii,"invoke_viiiiddi":invoke_viiiiddi,"invoke_viiiddddi":invoke_viiiddddi,"invoke_viidiii":invoke_viidiii,"invoke_viiiiiiiiiii":invoke_viiiiiiiiiii,"invoke_viiiiiiiiiid":invoke_viiiiiiiiiid,"invoke_viiidddd":invoke_viiidddd,"invoke_iidi":invoke_iidi,"invoke_viiddidd":invoke_viiddidd,"invoke_vidi":invoke_vidi,"invoke_viiddii":invoke_viiddii,"invoke_viiddid":invoke_viiddid,"invoke_iiiidi":invoke_iiiidi,"invoke_viiiiidi":invoke_viiiiidi,"invoke_viiddidddd":invoke_viiddidddd,"invoke_viiiiddiiii":invoke_viiiiddiiii,"invoke_viiiiiiidd":invoke_viiiiiiidd,"invoke_viiiiddiiid":invoke_viiiiddiiid,"invoke_viiiiiiidi":invoke_viiiiiiidi,"invoke_viiiddii":invoke_viiiddii,"invoke_iiiidd":invoke_iiiidd,"invoke_viiiiidd":invoke_viiiiidd,"invoke_viiiiddiddi":invoke_viiiiddiddi,"invoke_di":invoke_di,"invoke_viiiiiidiiii":invoke_viiiiiidiiii,"invoke_iiiiddi":invoke_iiiiddi,"invoke_viiiidiiddi":invoke_viiiidiiddi,"invoke_viiiiddiiiid":invoke_viiiiddiiiid,"invoke_viiiiddiii":invoke_viiiiddiii,"invoke_vdii":invoke_vdii,"invoke_diiiiiii":invoke_diiiiiii,"invoke_iiiiiddiddi":invoke_iiiiiddiddi,"invoke_dii":invoke_dii,"invoke_viiiddiiii":invoke_viiiddiiii,"invoke_viiiddiiid":invoke_viiiddiiid,"invoke_viiiidiidd":invoke_viiiidiidd,"invoke_iiiiiddid":invoke_iiiiiddid,"invoke_iiiii":invoke_iiiii,"invoke_viiiiidiiiii":invoke_viiiiidiiiii,"invoke_viiidddi":invoke_viiidddi,"invoke_viiiiidiidd":invoke_viiiiidiidd,"invoke_iiiid":invoke_iiiid,"invoke_iiiddiiid":invoke_iiiddiiid,"invoke_iiiiiiii":invoke_iiiiiiii,"invoke_iiiddi":invoke_iiiddi,"invoke_viiddiii":invoke_viiddiii,"invoke_viiddiid":invoke_viiddiid,"invoke_iiiiiiiididiii":invoke_iiiiiiiididiii,"invoke_viiidddiii":invoke_viiidddiii,"invoke_viidiiid":invoke_viidiiid,"invoke_viiiidiiii":invoke_viiiidiiii,"invoke_viidiiii":invoke_viidiiii,"invoke_viiiiiiiiiiddi":invoke_viiiiiiiiiiddi,"invoke_diiiddi":invoke_diiiddi,"invoke_viiididii":invoke_viiididii,"invoke_diiiiiiii":invoke_diiiiiiii,"invoke_viiidiiid":invoke_viiidiiid,"invoke_viiiddddii":invoke_viiiddddii,"invoke_iiidiiiiiii":invoke_iiidiiiiiii,"invoke_viiiiid":invoke_viiiiid,"invoke_viiiiddddii":invoke_viiiiddddii,"invoke_viiiiii":invoke_viiiiii,"invoke_viiidiiii":invoke_viiidiiii,"invoke_viiiiiidi":invoke_viiiiiidi,"invoke_viiiiiidiii":invoke_viiiiiidiii,"invoke_viiiidddii":invoke_viiiidddii,"invoke_viiidd":invoke_viiidd,"invoke_viiidi":invoke_viiidi,"invoke_iiidiiii":invoke_iiidiiii,"invoke_viiddiddd":invoke_viiddiddd,"invoke_viiiiiiiiii":invoke_viiiiiiiiii,"invoke_iiiiiddidd":invoke_iiiiiddidd,"invoke_diiddi":invoke_diiddi,"invoke_iiiiiddi":invoke_iiiiiddi,"invoke_diii":invoke_diii,"invoke_viiiddd":invoke_viiiddd,"invoke_viidiiiii":invoke_viidiiiii,"invoke_iiiddii":invoke_iiiddii,"invoke_viiiddidd":invoke_viiiddidd,"invoke_viiidiiiidi":invoke_viiidiiiidi,"invoke_viiiddiiiid":invoke_viiiddiiiid,"invoke_viiiddi":invoke_viiiddi,"invoke_iiiiii":invoke_iiiiii,"invoke_viiid":invoke_viiid,"invoke_iiiiidii":invoke_iiiiidii,"invoke_viidii":invoke_viidii,"invoke_iiiiid":invoke_iiiiid,"invoke_viiiidddi":invoke_viiiidddi,"invoke_viiii":invoke_viiii,"invoke_viiddiiid":invoke_viiddiiid,"invoke_viiiii":invoke_viiiii,"invoke_iiiiiiddi":invoke_iiiiiiddi,"invoke_viidiiiiiii":invoke_viidiiiiiii,"invoke_vid":invoke_vid,"invoke_iiidi":invoke_iiidi,"invoke_iiidd":invoke_iiidd,"invoke_vii":invoke_vii,"invoke_viiiid":invoke_viiiid,"invoke_viiiiddddi":invoke_viiiiddddi,"invoke_iiiiidiii":invoke_iiiiidiii,"invoke_viidd":invoke_viidd,"invoke_viidi":invoke_viidi,"invoke_viiidiiddi":invoke_viiidiiddi,"invoke_iiiidii":invoke_iiiidii,"invoke_diiid":invoke_diiid,"invoke_viiidddii":invoke_viiidddii,"invoke_viiiiiiii":invoke_viiiiiiii,"invoke_viiidddiiii":invoke_viiidddiiii,"invoke_viiiiiiid":invoke_viiiiiiid,"invoke_viiiiiiddi":invoke_viiiiiiddi,"invoke_diiii":invoke_diiii,"invoke_viiiiidiiddi":invoke_viiiiidiiddi,"invoke_viiiddidddd":invoke_viiiddidddd,"invoke_viiiiiiiiiiid":invoke_viiiiiiiiiiid,"invoke_viiiiidii":invoke_viiiiidii,"invoke_viiiddiddd":invoke_viiiddiddd,"invoke_iid":invoke_iid,"invoke_viiiddid":invoke_viiiddid,"invoke_viiiiiii":invoke_viiiiiii,"invoke_viididdi":invoke_viididdi,"invoke_viiiiiid":invoke_viiiiiid,"invoke_viiiiiiiii":invoke_viiiiiiiii,"invoke_iii":invoke_iii,"invoke_viiddi":invoke_viiddi,"invoke_viiididi":invoke_viiididi,"invoke_vdiii":invoke_vdiii,"invoke_viiiiiidii":invoke_viiiiiidii,"invoke_viiiiddidd":invoke_viiiiddidd,"invoke_viiiidddiii":invoke_viiiidddiii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_viid":invoke_viid,"invoke_iiiddiid":invoke_iiiddiid,"invoke_viiiiidiiii":invoke_viiiiidiiii,"invoke_vi":invoke_vi,"invoke_viiiidiiiidi":invoke_viiiidiiiidi,"invoke_ii":invoke_ii,"invoke_viiiiiiiddi":invoke_viiiiiiiddi,"invoke_vididdi":invoke_vididdi,"invoke_viiiiiidd":invoke_viiiiiidd,"invoke_vidii":invoke_vidii,"invoke_iiiidiii":invoke_iiiidiii,"invoke_viiiidi":invoke_viiiidi,"invoke_viiiddiii":invoke_viiiddiii,"invoke_viidiiiiii":invoke_viidiiiiii,"invoke_iiii":invoke_iiii,"invoke_viididii":invoke_viididii,"invoke_viiiidddd":invoke_viiiidddd,"invoke_viiiiddii":invoke_viiiiddii,"invoke_viiiiddid":invoke_viiiiddid,"invoke_iiid":invoke_iiid,"invoke_viiiiiiiiidd":invoke_viiiiiiiiidd,"invoke_viiiidii":invoke_viiiidii,"invoke_diiiii":invoke_diiiii,"invoke_diiiid":invoke_diiiid,"invoke_iiiiiiiiiiiii":invoke_iiiiiiiiiiiii,"invoke_iiiiidd":invoke_iiiiidd,"invoke_viiidii":invoke_viiidii,"invoke_iiiiidi":invoke_iiiiidi,"invoke_iiidiii":invoke_iiidiii,"invoke_iiidiiiiii":invoke_iiidiiiiii,"invoke_i":invoke_i,"invoke_iiidii":invoke_iiidii,"invoke_diiiiii":invoke_diiiiii,"invoke_iiidiiiii":invoke_iiidiiiii,"invoke_vididdii":invoke_vididdii,"invoke_viiiiiidiiiii":invoke_viiiiiidiiiii,"invoke_iiiiiidd":invoke_iiiiiidd,"invoke_viiiiidiii":invoke_viiiiidiii,"invoke_viididi":invoke_viididi,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_viididdii":invoke_viididdii,"invoke_viiiiidiid":invoke_viiiiidiid,"invoke_viiiidd":invoke_viiiidd,"invoke_vidiii":invoke_vidiii,"___syscall221":___syscall221,"floatReadValueFromPointer":floatReadValueFromPointer,"simpleReadValueFromPointer":simpleReadValueFromPointer,"__emval_call_void_method":__emval_call_void_method,"throwInternalError":throwInternalError,"get_first_emval":get_first_emval,"whenDependentTypesAreResolved":whenDependentTypesAreResolved,"constNoSmartPtrRawPointerToWireType":constNoSmartPtrRawPointerToWireType,"getLiveInheritedInstances":getLiveInheritedInstances,"___assert_fail":___assert_fail,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"ClassHandle":ClassHandle,"getShiftFromSize":getShiftFromSize,"__emval_get_property":__emval_get_property,"_llvm_exp2_f64":_llvm_exp2_f64,"__addDays":__addDays,"_emscripten_set_main_loop_timing":_emscripten_set_main_loop_timing,"_pthread_key_delete":_pthread_key_delete,"___cxa_begin_catch":___cxa_begin_catch,"_emscripten_memcpy_big":_emscripten_memcpy_big,"runDestructor":runDestructor,"throwInstanceAlreadyDeleted":throwInstanceAlreadyDeleted,"__embind_register_std_string":__embind_register_std_string,"init_RegisteredPointer":init_RegisteredPointer,"getStringOrSymbol":getStringOrSymbol,"flushPendingDeletes":flushPendingDeletes,"_pthread_mutexattr_settype":_pthread_mutexattr_settype,"makeClassHandle":makeClassHandle,"__isLeapYear":__isLeapYear,"__embind_register_class_constructor":__embind_register_class_constructor,"___cxa_atexit":___cxa_atexit,"__embind_finalize_value_array":__embind_finalize_value_array,"__emval_allocateDestructors":__emval_allocateDestructors,"init_ClassHandle":init_ClassHandle,"__embind_register_constant":__embind_register_constant,"___syscall140":___syscall140,"ClassHandle_clone":ClassHandle_clone,"___syscall145":___syscall145,"___syscall146":___syscall146,"throwBindingError":throwBindingError,"__emval_incref":__emval_incref,"___cxa_find_matching_catch":___cxa_find_matching_catch,"__embind_register_value_object_field":__embind_register_value_object_field,"embind_init_charCodes":embind_init_charCodes,"__emval_as":__emval_as,"___setErrNo":___setErrNo,"readLatin1String":readLatin1String,"_llvm_pow_f32":_llvm_pow_f32,"__embind_register_bool":__embind_register_bool,"___resumeException":___resumeException,"createNamedFunction":createNamedFunction,"__embind_register_class_property":__embind_register_class_property,"__embind_register_emval":__embind_register_emval,"___buildEnvironment":___buildEnvironment,"__embind_finalize_value_object":__embind_finalize_value_object,"__emval_decref":__emval_decref,"_pthread_once":_pthread_once,"__embind_register_class":__embind_register_class,"___syscall91":___syscall91,"__emval_addMethodCaller":__emval_addMethodCaller,"heap32VectorToArray":heap32VectorToArray,"__emval_lookupTypes":__emval_lookupTypes,"_emscripten_get_now":_emscripten_get_now,"__emval_run_destructors":__emval_run_destructors,"ClassHandle_delete":ClassHandle_delete,"___syscall3":___syscall3,"RegisteredPointer_destructor":RegisteredPointer_destructor,"_llvm_exp2_f32":_llvm_exp2_f32,"___syscall6":___syscall6,"___syscall5":___syscall5,"ensureOverloadTable":ensureOverloadTable,"_gettimeofday":_gettimeofday,"new_":new_,"downcastPointer":downcastPointer,"replacePublicSymbol":replacePublicSymbol,"init_embind":init_embind,"_llvm_pow_f64":_llvm_pow_f64,"ClassHandle_deleteLater":ClassHandle_deleteLater,"___syscall54":___syscall54,"_sched_yield":_sched_yield,"RegisteredPointer_deleteObject":RegisteredPointer_deleteObject,"ClassHandle_isDeleted":ClassHandle_isDeleted,"__embind_register_integer":__embind_register_integer,"___cxa_allocate_exception":___cxa_allocate_exception,"__emval_take_value":__emval_take_value,"__embind_register_value_object":__embind_register_value_object,"getTypeName":getTypeName,"_strftime":_strftime,"__embind_register_class_function":__embind_register_class_function,"RegisteredPointer":RegisteredPointer,"craftInvokerFunction":craftInvokerFunction,"_getenv":_getenv,"runDestructors":runDestructors,"requireRegisteredType":requireRegisteredType,"makeLegalFunctionName":makeLegalFunctionName,"_pthread_key_create":_pthread_key_create,"upcastPointer":upcastPointer,"init_emval":init_emval,"shallowCopyInternalPointer":shallowCopyInternalPointer,"nonConstNoSmartPtrRawPointerToWireType":nonConstNoSmartPtrRawPointerToWireType,"__embind_register_value_array":__embind_register_value_array,"_abort":_abort,"requireHandle":requireHandle,"_embind_repr":_embind_repr,"validateThis":validateThis,"exposePublicSymbol":exposePublicSymbol,"RegisteredPointer_fromWireType":RegisteredPointer_fromWireType,"___cxa_pure_virtual":___cxa_pure_virtual,"__emval_get_method_caller":__emval_get_method_caller,"_pthread_getspecific":_pthread_getspecific,"_pthread_cond_wait":_pthread_cond_wait,"___lock":___lock,"RegisteredClass":RegisteredClass,"__embind_register_memory_view":__embind_register_memory_view,"getInheritedInstance":getInheritedInstance,"setDelayFunction":setDelayFunction,"___gxx_personality_v0":___gxx_personality_v0,"extendError":extendError,"___syscall4":___syscall4,"__embind_register_value_array_element":__embind_register_value_array_element,"__emval_new_array":__emval_new_array,"__embind_register_void":__embind_register_void,"__embind_register_smart_ptr":__embind_register_smart_ptr,"__embind_register_function":__embind_register_function,"_pthread_mutexattr_destroy":_pthread_mutexattr_destroy,"_strftime_l":_strftime_l,"RegisteredPointer_getPointee":RegisteredPointer_getPointee,"__emval_register":__emval_register,"__embind_register_std_wstring":__embind_register_std_wstring,"ClassHandle_isAliasOf":ClassHandle_isAliasOf,"throwUnboundTypeError":throwUnboundTypeError,"__arraySum":__arraySum,"__embind_register_class_class_function":__embind_register_class_class_function,"_pthread_mutex_destroy":_pthread_mutex_destroy,"getBasestPointer":getBasestPointer,"getInheritedInstanceCount":getInheritedInstanceCount,"__embind_register_float":__embind_register_float,"integerReadValueFromPointer":integerReadValueFromPointer,"___unlock":___unlock,"_emscripten_set_main_loop":_emscripten_set_main_loop,"_pthread_mutexattr_init":_pthread_mutexattr_init,"_pthread_setspecific":_pthread_setspecific,"genericPointerToWireType":genericPointerToWireType,"registerType":registerType,"___cxa_throw":___cxa_throw,"__emval_new_cstring":__emval_new_cstring,"count_emval_handles":count_emval_handles,"requireFunction":requireFunction,"_atexit":_atexit,"_pthread_mutex_init":_pthread_mutex_init,"___map_file":___map_file,"DYNAMICTOP_PTR":DYNAMICTOP_PTR,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"cttz_i8":cttz_i8,"___dso_handle":___dso_handle};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"almost asm";var a=global.Int8Array;var b=new a(buffer);var c=global.Int16Array;var d=new c(buffer);var e=global.Int32Array;var f=new e(buffer);var g=global.Uint8Array;var h=new g(buffer);var i=global.Uint16Array;var j=new i(buffer);var k=global.Uint32Array;var l=new k(buffer);var m=global.Float32Array;var n=new m(buffer);var o=global.Float64Array;var p=new o(buffer);var q=global.byteLength;var r=env.DYNAMICTOP_PTR|0;var s=env.tempDoublePtr|0;var t=env.ABORT|0;var u=env.STACKTOP|0;var v=env.STACK_MAX|0;var w=env.cttz_i8|0;var x=env.___dso_handle|0;var y=0;var z=0;var A=0;var B=0;var C=global.NaN,D=global.Infinity;var E=0,F=0,G=0,H=0,I=0.0;var J=0;var K=global.Math.floor;var L=global.Math.abs;var M=global.Math.sqrt;var N=global.Math.pow;var O=global.Math.cos;var P=global.Math.sin;var Q=global.Math.tan;var R=global.Math.acos;var S=global.Math.asin;var T=global.Math.atan;var U=global.Math.atan2;var V=global.Math.exp;var W=global.Math.log;var X=global.Math.ceil;var Y=global.Math.imul;var Z=global.Math.min;var _=global.Math.max;var $=global.Math.clz32;var aa=env.abort;var ba=env.assert;var ca=env.enlargeMemory;var da=env.getTotalMemory;var ea=env.abortOnCannotGrowMemory;var fa=env.invoke_iiiiiid;var ga=env.invoke_viiiiddd;var ha=env.invoke_viiiidiii;var ia=env.invoke_viiiiiddi;var ja=env.invoke_viiidiii;var ka=env.invoke_viiiidiid;var la=env.invoke_iiiiiii;var ma=env.invoke_viiiidddiiii;var na=env.invoke_viiiiddi;var oa=env.invoke_viiiddddi;var pa=env.invoke_viidiii;var qa=env.invoke_viiiiiiiiiii;var ra=env.invoke_viiiiiiiiiid;var sa=env.invoke_viiidddd;var ta=env.invoke_iidi;var ua=env.invoke_viiddidd;var va=env.invoke_vidi;var wa=env.invoke_viiddii;var xa=env.invoke_viiddid;var ya=env.invoke_iiiidi;var za=env.invoke_viiiiidi;var Aa=env.invoke_viiddidddd;var Ba=env.invoke_viiiiddiiii;var Ca=env.invoke_viiiiiiidd;var Da=env.invoke_viiiiddiiid;var Ea=env.invoke_viiiiiiidi;var Fa=env.invoke_viiiddii;var Ga=env.invoke_iiiidd;var Ha=env.invoke_viiiiidd;var Ia=env.invoke_viiiiddiddi;var Ja=env.invoke_di;var Ka=env.invoke_viiiiiidiiii;var La=env.invoke_iiiiddi;var Ma=env.invoke_viiiidiiddi;var Na=env.invoke_viiiiddiiiid;var Oa=env.invoke_viiiiddiii;var Pa=env.invoke_vdii;var Qa=env.invoke_diiiiiii;var Ra=env.invoke_iiiiiddiddi;var Sa=env.invoke_dii;var Ta=env.invoke_viiiddiiii;var Ua=env.invoke_viiiddiiid;var Va=env.invoke_viiiidiidd;var Wa=env.invoke_iiiiiddid;var Xa=env.invoke_iiiii;var Ya=env.invoke_viiiiidiiiii;var Za=env.invoke_viiidddi;var _a=env.invoke_viiiiidiidd;var $a=env.invoke_iiiid;var ab=env.invoke_iiiddiiid;var bb=env.invoke_iiiiiiii;var cb=env.invoke_iiiddi;var db=env.invoke_viiddiii;var eb=env.invoke_viiddiid;var fb=env.invoke_iiiiiiiididiii;var gb=env.invoke_viiidddiii;var hb=env.invoke_viidiiid;var ib=env.invoke_viiiidiiii;var jb=env.invoke_viidiiii;var kb=env.invoke_viiiiiiiiiiddi;var lb=env.invoke_diiiddi;var mb=env.invoke_viiididii;var nb=env.invoke_diiiiiiii;var ob=env.invoke_viiidiiid;var pb=env.invoke_viiiddddii;var qb=env.invoke_iiidiiiiiii;var rb=env.invoke_viiiiid;var sb=env.invoke_viiiiddddii;var tb=env.invoke_viiiiii;var ub=env.invoke_viiidiiii;var vb=env.invoke_viiiiiidi;var wb=env.invoke_viiiiiidiii;var xb=env.invoke_viiiidddii;var yb=env.invoke_viiidd;var zb=env.invoke_viiidi;var Ab=env.invoke_iiidiiii;var Bb=env.invoke_viiddiddd;var Cb=env.invoke_viiiiiiiiii;var Db=env.invoke_iiiiiddidd;var Eb=env.invoke_diiddi;var Fb=env.invoke_iiiiiddi;var Gb=env.invoke_diii;var Hb=env.invoke_viiiddd;var Ib=env.invoke_viidiiiii;var Jb=env.invoke_iiiddii;var Kb=env.invoke_viiiddidd;var Lb=env.invoke_viiidiiiidi;var Mb=env.invoke_viiiddiiiid;var Nb=env.invoke_viiiddi;var Ob=env.invoke_iiiiii;var Pb=env.invoke_viiid;var Qb=env.invoke_iiiiidii;var Rb=env.invoke_viidii;var Sb=env.invoke_iiiiid;var Tb=env.invoke_viiiidddi;var Ub=env.invoke_viiii;var Vb=env.invoke_viiddiiid;var Wb=env.invoke_viiiii;var Xb=env.invoke_iiiiiiddi;var Yb=env.invoke_viidiiiiiii;var Zb=env.invoke_vid;var _b=env.invoke_iiidi;var $b=env.invoke_iiidd;var ac=env.invoke_vii;var bc=env.invoke_viiiid;var cc=env.invoke_viiiiddddi;var dc=env.invoke_iiiiidiii;var ec=env.invoke_viidd;var fc=env.invoke_viidi;var gc=env.invoke_viiidiiddi;var hc=env.invoke_iiiidii;var ic=env.invoke_diiid;var jc=env.invoke_viiidddii;var kc=env.invoke_viiiiiiii;var lc=env.invoke_viiidddiiii;var mc=env.invoke_viiiiiiid;var nc=env.invoke_viiiiiiddi;var oc=env.invoke_diiii;var pc=env.invoke_viiiiidiiddi;var qc=env.invoke_viiiddidddd;var rc=env.invoke_viiiiiiiiiiid;var sc=env.invoke_viiiiidii;var tc=env.invoke_viiiddiddd;var uc=env.invoke_iid;var vc=env.invoke_viiiddid;var wc=env.invoke_viiiiiii;var xc=env.invoke_viididdi;var yc=env.invoke_viiiiiid;var zc=env.invoke_viiiiiiiii;var Ac=env.invoke_iii;var Bc=env.invoke_viiddi;var Cc=env.invoke_viiididi;var Dc=env.invoke_vdiii;var Ec=env.invoke_viiiiiidii;var Fc=env.invoke_viiiiddidd;var Gc=env.invoke_viiiidddiii;var Hc=env.invoke_viii;var Ic=env.invoke_v;var Jc=env.invoke_viid;var Kc=env.invoke_iiiddiid;var Lc=env.invoke_viiiiidiiii;var Mc=env.invoke_vi;var Nc=env.invoke_viiiidiiiidi;var Oc=env.invoke_ii;var Pc=env.invoke_viiiiiiiddi;var Qc=env.invoke_vididdi;var Rc=env.invoke_viiiiiidd;var Sc=env.invoke_vidii;var Tc=env.invoke_iiiidiii;var Uc=env.invoke_viiiidi;var Vc=env.invoke_viiiddiii;var Wc=env.invoke_viidiiiiii;var Xc=env.invoke_iiii;var Yc=env.invoke_viididii;var Zc=env.invoke_viiiidddd;var _c=env.invoke_viiiiddii;var $c=env.invoke_viiiiddid;var ad=env.invoke_iiid;var bd=env.invoke_viiiiiiiiidd;var cd=env.invoke_viiiidii;var dd=env.invoke_diiiii;var ed=env.invoke_diiiid;var fd=env.invoke_iiiiiiiiiiiii;var gd=env.invoke_iiiiidd;var hd=env.invoke_viiidii;var id=env.invoke_iiiiidi;var jd=env.invoke_iiidiii;var kd=env.invoke_iiidiiiiii;var ld=env.invoke_i;var md=env.invoke_iiidii;var nd=env.invoke_diiiiii;var od=env.invoke_iiidiiiii;var pd=env.invoke_vididdii;var qd=env.invoke_viiiiiidiiiii;var rd=env.invoke_iiiiiidd;var sd=env.invoke_viiiiidiii;var td=env.invoke_viididi;var ud=env.invoke_iiiiiiiii;var vd=env.invoke_viididdii;var wd=env.invoke_viiiiidiid;var xd=env.invoke_viiiidd;var yd=env.invoke_vidiii;var zd=env.___syscall221;var Ad=env.floatReadValueFromPointer;var Bd=env.simpleReadValueFromPointer;var Cd=env.__emval_call_void_method;var Dd=env.throwInternalError;var Ed=env.get_first_emval;var Fd=env.whenDependentTypesAreResolved;var Gd=env.constNoSmartPtrRawPointerToWireType;var Hd=env.getLiveInheritedInstances;var Id=env.___assert_fail;var Jd=env.__ZSt18uncaught_exceptionv;var Kd=env.ClassHandle;var Ld=env.getShiftFromSize;var Md=env.__emval_get_property;var Nd=env._llvm_exp2_f64;var Od=env.__addDays;var Pd=env._emscripten_set_main_loop_timing;var Qd=env._pthread_key_delete;var Rd=env.___cxa_begin_catch;var Sd=env._emscripten_memcpy_big;var Td=env.runDestructor;var Ud=env.throwInstanceAlreadyDeleted;var Vd=env.__embind_register_std_string;var Wd=env.init_RegisteredPointer;var Xd=env.getStringOrSymbol;var Yd=env.flushPendingDeletes;var Zd=env._pthread_mutexattr_settype;var _d=env.makeClassHandle;var $d=env.__isLeapYear;var ae=env.__embind_register_class_constructor;var be=env.___cxa_atexit;var ce=env.__embind_finalize_value_array;var de=env.__emval_allocateDestructors;var ee=env.init_ClassHandle;var fe=env.__embind_register_constant;var ge=env.___syscall140;var he=env.ClassHandle_clone;var ie=env.___syscall145;var je=env.___syscall146;var ke=env.throwBindingError;var le=env.__emval_incref;var me=env.___cxa_find_matching_catch;var ne=env.__embind_register_value_object_field;var oe=env.embind_init_charCodes;var pe=env.__emval_as;var qe=env.___setErrNo;var re=env.readLatin1String;var se=env._llvm_pow_f32;var te=env.__embind_register_bool;var ue=env.___resumeException;var ve=env.createNamedFunction;var we=env.__embind_register_class_property;var xe=env.__embind_register_emval;var ye=env.___buildEnvironment;var ze=env.__embind_finalize_value_object;var Ae=env.__emval_decref;var Be=env._pthread_once;var Ce=env.__embind_register_class;var De=env.___syscall91;var Ee=env.__emval_addMethodCaller;var Fe=env.heap32VectorToArray;var Ge=env.__emval_lookupTypes;var He=env._emscripten_get_now;var Ie=env.__emval_run_destructors;var Je=env.ClassHandle_delete;var Ke=env.___syscall3;var Le=env.RegisteredPointer_destructor;var Me=env._llvm_exp2_f32;var Ne=env.___syscall6;var Oe=env.___syscall5;var Pe=env.ensureOverloadTable;var Qe=env._gettimeofday;var Re=env.new_;var Se=env.downcastPointer;var Te=env.replacePublicSymbol;var Ue=env.init_embind;var Ve=env._llvm_pow_f64;var We=env.ClassHandle_deleteLater;var Xe=env.___syscall54;var Ye=env._sched_yield;var Ze=env.RegisteredPointer_deleteObject;var _e=env.ClassHandle_isDeleted;var $e=env.__embind_register_integer;var af=env.___cxa_allocate_exception;var bf=env.__emval_take_value;var cf=env.__embind_register_value_object;var df=env.getTypeName;var ef=env._strftime;var ff=env.__embind_register_class_function;var gf=env.RegisteredPointer;var hf=env.craftInvokerFunction;var jf=env._getenv;var kf=env.runDestructors;var lf=env.requireRegisteredType;var mf=env.makeLegalFunctionName;var nf=env._pthread_key_create;var of=env.upcastPointer;var pf=env.init_emval;var qf=env.shallowCopyInternalPointer;var rf=env.nonConstNoSmartPtrRawPointerToWireType;var sf=env.__embind_register_value_array;var tf=env._abort;var uf=env.requireHandle;var vf=env._embind_repr;var wf=env.validateThis;var xf=env.exposePublicSymbol;var yf=env.RegisteredPointer_fromWireType;var zf=env.___cxa_pure_virtual;var Af=env.__emval_get_method_caller;var Bf=env._pthread_getspecific;var Cf=env._pthread_cond_wait;var Df=env.___lock;var Ef=env.RegisteredClass;var Ff=env.__embind_register_memory_view;var Gf=env.getInheritedInstance;var Hf=env.setDelayFunction;var If=env.___gxx_personality_v0;var Jf=env.extendError;var Kf=env.___syscall4;var Lf=env.__embind_register_value_array_element;var Mf=env.__emval_new_array;var Nf=env.__embind_register_void;var Of=env.__embind_register_smart_ptr;var Pf=env.__embind_register_function;var Qf=env._pthread_mutexattr_destroy;var Rf=env._strftime_l;var Sf=env.RegisteredPointer_getPointee;var Tf=env.__emval_register;var Uf=env.__embind_register_std_wstring;var Vf=env.ClassHandle_isAliasOf;var Wf=env.throwUnboundTypeError;var Xf=env.__arraySum;var Yf=env.__embind_register_class_class_function;var Zf=env._pthread_mutex_destroy;var _f=env.getBasestPointer;var $f=env.getInheritedInstanceCount;var ag=env.__embind_register_float;var bg=env.integerReadValueFromPointer;var cg=env.___unlock;var dg=env._emscripten_set_main_loop;var eg=env._pthread_mutexattr_init;var fg=env._pthread_setspecific;var gg=env.genericPointerToWireType;var hg=env.registerType;var ig=env.___cxa_throw;var jg=env.__emval_new_cstring;var kg=env.count_emval_handles;var lg=env.requireFunction;var mg=env._atexit;var ng=env._pthread_mutex_init;var og=env.___map_file;var pg=0.0;function qg(newBuffer){if(q(newBuffer)&16777215||q(newBuffer)<=16777215||q(newBuffer)>2147483648)return false;b=new a(newBuffer);d=new c(newBuffer);f=new e(newBuffer);h=new g(newBuffer);j=new i(newBuffer);l=new k(newBuffer);n=new m(newBuffer);p=new o(newBuffer);buffer=newBuffer;return true}
// EMSCRIPTEN_START_FUNCS
function Lj(a){a=a|0;var b=0;b=u;u=u+a|0;u=u+15&-16;return b|0}function Mj(){return u|0}function Nj(a){a=a|0;u=a}function Oj(a,b){a=a|0;b=b|0;u=a;v=b}function Pj(a,b){a=a|0;b=b|0;if(!y){y=a;z=b}}function Qj(a){a=a|0;J=a}function Rj(){return J|0}function Sj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=$Xc(56)|0;Tj(f,a,b,c,d,e);return f|0}function Tj(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+16|0;j=i;f[a>>2]=e&4095|1124007936;f[a+4>>2]=2;k=a+8|0;f[k>>2]=c;f[a+12>>2]=d;f[a+16>>2]=g;f[a+20>>2]=g;l=a+24|0;m=a+28|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[a+40>>2]=k;k=a+48|0;f[a+44>>2]=k;f[a+52>>2]=0;f[k>>2]=0;if((Y(d,c)|0)!=0&(g|0)==0){n=$Xc(32)|0;f[j>>2]=n;f[j+8>>2]=-2147483616;f[j+4>>2]=28;o=n;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+28>>0]=0;vM(-215,j,470343,470347,548)}n=675553809>>>(e<<2&28)&15;r=Y(n,(e>>>3&511)+1|0)|0;e=Y(r,d)|0;if(!h){s=e;f[k>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(s,c)|0;w=g+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+e|0;f[l>>2]=z;R$(a);u=i;return}if(!((h>>>0)%(n>>>0)|0)){s=h;f[k>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(s,c)|0;w=g+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+e|0;f[l>>2]=z;R$(a);u=i;return}else{i=$Xc(32)|0;f[j>>2]=i;f[j+8>>2]=-2147483616;f[j+4>>2]=31;o=i;p=237472;q=o+31|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[i+31>>0]=0;vM(-13,j,470343,470347,561)}}function Uj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;dY(a,h,c,d,e);u=g;return}function Vj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;dY(a,e,c,1.0,0.0);u=d;return}function Wj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;dY(a,g,c,d,0.0);u=e;return}function Xj(a,b){a=a|0;b=b|0;var c=0;c=f[b+40>>2]|0;b=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=b;return}function Yj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;p$(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;ei[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);Zj(g);u=e;return}function Zj(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+120|0;c=a+156|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+136|0;b=a+124|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+160>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+164>>2]|0;if((b|0)!=(a+168|0))wL(b);b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))wL(b);b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;wL(b);return}function _j(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];r$(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Zj(e);u=d;return}function $j(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;s$(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;ei[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);Zj(g);u=e;return}function ak(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];t$(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Zj(e);u=d;return}function bk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;e=+nZ(a,d);u=c;return +e}function ck(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+240|0;g=e;h=e+224|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;o$(g,b,h,d);f[a>>2]=1124007936;h=a+8|0;b=a+40|0;c=a+4|0;i=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(i|0));f[b>>2]=h;h=a+48|0;f[a+44>>2]=h;f[h>>2]=0;f[a+52>>2]=0;h=f[g>>2]|0;ei[f[(f[h>>2]|0)+12>>2]&511](h,g,a,-1);Zj(g);u=e;return}function dk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+224|0;d=c;m$(d,b);f[a>>2]=1124007936;b=a+8|0;e=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;b=f[d>>2]|0;ei[f[(f[b>>2]|0)+12>>2]&511](b,d,a,-1);Zj(d);u=c;return}function ek(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+224|0;e=d;n$(e,b,c);f[a>>2]=1124007936;c=a+8|0;b=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[b>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Zj(e);u=d;return}function fk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;jR(a,d);u=c;return}function gk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;kR(a,e,g);u=d;return}function hk(a,b,c){a=a|0;b=b|0;c=c|0;b0(a,b,c);return}function ik(a,b){a=a|0;b=b|0;b0(a,b,0);return}function jk(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=-1056833530;f[d+4>>2]=b;f[d+8>>2]=1;f[d+12>>2]=4;mR(a,d,fT()|0)|0;u=c;return}function kk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e>>2]=-1056833530;f[e+4>>2]=b;f[e+8>>2]=1;f[e+12>>2]=4;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;mR(a,e,g)|0;u=d;return}function lk(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;jL(b,d);b=Mf()|0;f[a>>2]=b;Lv(b,197030,d);Lv(b,197030,d+8|0);Lv(b,197030,d+16|0);Lv(b,197030,d+24|0);u=c;return}function mk(a,b){a=a|0;b=b|0;kL(a,b);return}function nk(a,b){a=a|0;b=b|0;lL(a,b);return}function ok(a){a=a|0;return a&7|0}function pk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;SP(e,a,a+8|0,a+16|0,a+24|0,g);u=d;return}function qk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;SP(d,a,a+8|0,a+16|0,a+24|0,fT()|0);u=c;return}function rk(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;n[a>>2]=0.0;n[a+4>>2]=0.0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;foa(d,a,a+8|0);u=c;return}function sk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+64|0;g=e;h=e+32|0;i=e+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];aWb(h,i,c,g);g=Mf()|0;f[a>>2]=g;Mv(g,197030,h);Nv(g,197030,c);u=e;return}function tk(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=g+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];e=$Vb(i,d,h)|0;i=Mf()|0;f[a>>2]=i;if((b[529976]|0)==0?X0c(529976)|0:0){c=Af(2,25632)|0;f[135045]=c}c=f[135045]|0;f[h>>2]=e;Cd(c|0,i|0,197030,h|0);Nv(f[a>>2]|0,197030,d);u=g;return}function uk(a,b){a=a|0;b=b|0;lYc(a,b+4|0);return}function vk(a,b){a=a|0;b=b|0;oYc(a+4|0,b)|0;return}function wk(a,b){a=a|0;b=b|0;xk(a,b);return}function xk(a,b){a=a|0;b=b|0;f[a>>2]=35808;lYc(a+4|0,b+4|0);f[a+16>>2]=f[b+16>>2];lYc(a+20|0,b+20|0);lYc(a+32|0,b+32|0);lYc(a+44|0,b+44|0);f[a+56>>2]=f[b+56>>2];return}function yk(a){a=a|0;lYc(a,zN()|0);return}function zk(a){a=a|0;var b=0;Ak(197035);Bk(197045);Ck(197057);Dk(197070);Ek(197082);Fk(197092);Gk(197103);Ce(4608,4784,4800,0,211997,945,212e3,0,212e3,0,470343,212002,2150);ae(4608,1,26116,211997,946,1);ae(4608,2,26120,212016,510,947);ae(4608,3,26128,212039,250,511);ae(4608,4,26140,212044,47,251);ae(4608,5,26156,213373,95,48);ae(4608,6,26176,213380,70,96);Yf(4608,197118,3,26200,212039,252,260);Yf(4608,197118,4,26212,212044,49,194);Yf(4608,197122,3,26200,212039,252,261);Yf(4608,197122,4,26212,212044,49,195);Yf(4608,197127,3,26200,212039,252,262);Yf(4608,197127,4,26212,212044,49,196);a=$Xc(4)|0;f[a>>2]=8;b=$Xc(4)|0;f[b>>2]=8;we(4608,197133,25512,212016,512,a|0,25512,212005,263,b|0);b=$Xc(4)|0;f[b>>2]=12;a=$Xc(4)|0;f[a>>2]=12;we(4608,197138,25512,212016,512,b|0,25512,212005,263,a|0);a=$Xc(4)|0;f[a>>2]=1114;we(4608,197143,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1115;we(4608,197151,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1116;we(4608,374427,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1117;we(4608,197156,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1118;we(4608,197163,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1119;we(4608,197171,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1120;we(4608,197179,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1121;we(4608,197187,4272,212016,513,a|0,0,0,0,0);a=$Xc(4)|0;f[a>>2]=1122;we(4608,197195,4272,212016,513,a|0,0,0,0,0);a=$Xc(8)|0;f[a>>2]=948;f[a+4>>2]=0;ff(4608,197203,2,26228,212016,514,a|0,0);a=$Xc(8)|0;f[a>>2]=949;f[a+4>>2]=0;ff(4608,197212,2,26228,212016,514,a|0,0);a=$Xc(8)|0;f[a>>2]=950;f[a+4>>2]=0;ff(4608,197222,2,26236,212016,515,a|0,0);a=$Xc(4)|0;f[a>>2]=1;ff(4608,235629,6,26244,213605,1,a|0,0);a=$Xc(4)|0;f[a>>2]=264;ff(4608,235629,4,26268,212010,197,a|0,0);a=$Xc(4)|0;f[a>>2]=6;ff(4608,235629,5,26284,213613,5,a|0,0);a=$Xc(8)|0;f[a>>2]=951;f[a+4>>2]=0;ff(4608,454614,2,26228,212016,514,a|0,0);a=$Xc(8)|0;f[a>>2]=265;f[a+4>>2]=0;ff(4608,197231,3,26304,212039,253,a|0,0);a=$Xc(8)|0;f[a>>2]=198;f[a+4>>2]=0;ff(4608,467262,5,26316,213620,82,a|0,0);a=$Xc(8)|0;f[a>>2]=266;f[a+4>>2]=0;ff(4608,467262,4,26336,212010,199,a|0,0);a=$Xc(8)|0;f[a>>2]=200;f[a+4>>2]=0;ff(4608,197235,4,26352,212044,50,a|0,0);a=$Xc(8)|0;f[a>>2]=267;f[a+4>>2]=0;ff(4608,197235,3,26368,212039,254,a|0,0);a=$Xc(4)|0;f[a>>2]=1123;ff(4608,231275,3,26380,212005,268,a|0,0);a=$Xc(4)|0;f[a>>2]=269;ff(4608,231275,4,26392,212010,201,a|0,0);a=$Xc(8)|0;f[a>>2]=952;f[a+4>>2]=0;ff(4608,466514,2,26236,212016,515,a|0,0);a=$Xc(8)|0;f[a>>2]=953;f[a+4>>2]=0;ff(4608,231201,2,26408,212016,516,a|0,0);a=$Xc(8)|0;f[a>>2]=202;f[a+4>>2]=0;ff(4608,197244,4,26352,212044,50,a|0,0);a=$Xc(8)|0;f[a>>2]=270;f[a+4>>2]=0;ff(4608,197244,3,26368,212039,254,a|0,0);a=$Xc(8)|0;f[a>>2]=517;f[a+4>>2]=0;ff(4608,197253,3,26416,212039,255,a|0,0);a=$Xc(8)|0;f[a>>2]=1124;f[a+4>>2]=0;ff(4608,466124,2,26428,212016,518,a|0,0);a=$Xc(8)|0;f[a>>2]=954;f[a+4>>2]=0;ff(4608,371760,2,26236,212016,515,a|0,0);a=$Xc(8)|0;f[a>>2]=271;f[a+4>>2]=0;ff(4608,197259,3,26304,212039,253,a|0,0);a=$Xc(4)|0;f[a>>2]=5;ff(4608,236823,3,26436,213639,11,a|0,0);a=$Xc(4)|0;f[a>>2]=7;ff(4608,197263,4,26448,212388,1,a|0,0);a=$Xc(4)|0;f[a>>2]=272;ff(4608,197267,3,26464,212039,256,a|0,0);a=$Xc(4)|0;f[a>>2]=1125;ff(4608,506366,2,26476,212016,519,a|0,0);a=$Xc(8)|0;f[a>>2]=273;f[a+4>>2]=0;ff(4608,197271,3,26484,212039,257,a|0,0);a=$Xc(4)|0;f[a>>2]=274;ff(4608,238102,3,26464,212039,256,a|0,0);a=$Xc(4)|0;f[a>>2]=1126;ff(4608,238102,2,26476,212016,519,a|0,0);a=$Xc(8)|0;f[a>>2]=955;f[a+4>>2]=0;ff(4608,231239,2,26408,212016,516,a|0,0);a=$Xc(4)|0;f[a>>2]=1127;ff(4608,233087,3,26496,212005,275,a|0,0);a=$Xc(4)|0;f[a>>2]=276;ff(4608,233087,4,26508,212010,203,a|0,0);a=$Xc(4)|0;f[a>>2]=1128;ff(4608,470867,2,26524,212016,520,a|0,0);a=$Xc(4)|0;f[a>>2]=277;ff(4608,229084,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=204;ff(4608,229084,4,26544,212044,51,a|0,0);a=$Xc(4)|0;f[a>>2]=277;ff(4608,197275,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=204;ff(4608,197275,4,26544,212044,51,a|0,0);a=$Xc(4)|0;f[a>>2]=278;ff(4608,197284,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=205;ff(4608,197284,4,26544,212044,51,a|0,0);a=$Xc(4)|0;f[a>>2]=279;ff(4608,197292,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=206;ff(4608,197292,4,26544,212044,51,a|0,0);a=$Xc(4)|0;f[a>>2]=280;ff(4608,197301,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=207;ff(4608,197301,4,26544,212044,51,a|0,0);a=$Xc(4)|0;f[a>>2]=281;ff(4608,197311,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=208;ff(4608,197311,4,26544,212044,51,a|0,0);a=$Xc(4)|0;f[a>>2]=282;ff(4608,197318,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=209;ff(4608,197318,4,26544,212044,51,a|0,0);a=$Xc(4)|0;f[a>>2]=283;ff(4608,197327,3,26532,212039,258,a|0,0);a=$Xc(4)|0;f[a>>2]=210;ff(4608,197327,4,26544,212044,51,a|0,0);a=$Xc(8)|0;f[a>>2]=521;f[a+4>>2]=0;ff(4608,197337,3,26560,212039,259,a|0,0);a=$Xc(8)|0;f[a>>2]=260;f[a+4>>2]=0;ff(4608,197337,4,26572,212044,52,a|0,0);a=$Xc(8)|0;f[a>>2]=53;f[a+4>>2]=0;ff(4608,197337,5,26588,213373,97,a|0,0);a=$Xc(8)|0;f[a>>2]=522;f[a+4>>2]=0;ff(4608,197344,3,26608,212039,261,a|0,0);a=$Xc(8)|0;f[a>>2]=262;f[a+4>>2]=0;ff(4608,197344,4,26620,212044,54,a|0,0);a=$Xc(8)|0;f[a>>2]=55;f[a+4>>2]=0;ff(4608,197344,5,26636,213373,98,a|0,0);a=$Xc(8)|0;f[a>>2]=523;f[a+4>>2]=0;ff(4608,197352,3,26656,212039,263,a|0,0);a=$Xc(8)|0;f[a>>2]=264;f[a+4>>2]=0;ff(4608,197352,4,26668,212044,56,a|0,0);a=$Xc(8)|0;f[a>>2]=57;f[a+4>>2]=0;ff(4608,197352,5,26684,213373,99,a|0,0);a=$Xc(8)|0;f[a>>2]=524;f[a+4>>2]=0;ff(4608,197360,3,26704,212039,265,a|0,0);a=$Xc(8)|0;f[a>>2]=266;f[a+4>>2]=0;ff(4608,197360,4,26716,212044,58,a|0,0);a=$Xc(8)|0;f[a>>2]=59;f[a+4>>2]=0;ff(4608,197360,5,26732,213373,100,a|0,0);a=$Xc(8)|0;f[a>>2]=525;f[a+4>>2]=0;ff(4608,197369,3,26752,212039,267,a|0,0);a=$Xc(8)|0;f[a>>2]=268;f[a+4>>2]=0;ff(4608,197369,4,26764,212044,60,a|0,0);a=$Xc(8)|0;f[a>>2]=61;f[a+4>>2]=0;ff(4608,197369,5,26780,213373,101,a|0,0);a=$Xc(8)|0;f[a>>2]=526;f[a+4>>2]=0;ff(4608,197375,3,26800,213644,12,a|0,0);a=$Xc(8)|0;f[a>>2]=269;f[a+4>>2]=0;ff(4608,197375,4,26812,213649,3,a|0,0);a=$Xc(8)|0;f[a>>2]=62;f[a+4>>2]=0;ff(4608,197375,5,26828,213655,1,a|0,0);a=$Xc(8)|0;f[a>>2]=63;f[a+4>>2]=0;ff(4608,197383,5,26848,213662,2,a|0,0);a=$Xc(8)|0;f[a>>2]=527;f[a+4>>2]=0;ff(4608,197383,3,26868,213639,13,a|0,0);a=$Xc(8)|0;f[a>>2]=270;f[a+4>>2]=0;ff(4608,197383,4,26880,213669,4,a|0,0);cf(4920,197392,213675,2,212002,2151);a=$Xc(4)|0;f[a>>2]=0;b=$Xc(4)|0;f[b>>2]=0;ne(4920,254933,25512,212016,528,a|0,25512,212005,284,b|0);b=$Xc(4)|0;f[b>>2]=4;a=$Xc(4)|0;f[a>>2]=4;ne(4920,448901,25512,212016,528,b|0,25512,212005,284,a|0);ze(4920);cf(4928,197398,213675,3,212002,2152);a=$Xc(4)|0;f[a>>2]=0;b=$Xc(4)|0;f[b>>2]=0;ne(4928,466514,25512,212016,529,a|0,25512,212005,285,b|0);b=$Xc(4)|0;f[b>>2]=4;a=$Xc(4)|0;f[a>>2]=4;ne(4928,197411,25512,212016,529,b|0,25512,212005,285,a|0);a=$Xc(4)|0;f[a>>2]=8;b=$Xc(4)|0;f[b>>2]=8;ne(4928,390628,25552,213697,6,a|0,25552,212377,14,b|0);ze(4928);cf(4816,197420,213675,4,212002,2153);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4816,471037,25512,212016,530,b|0,25512,212005,286,a|0);a=$Xc(4)|0;f[a>>2]=4;b=$Xc(4)|0;f[b>>2]=4;ne(4816,471030,25512,212016,530,a|0,25512,212005,286,b|0);ze(4816);cf(4936,197420,213675,5,212002,2154);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4936,471037,25544,213716,7,b|0,25544,212205,15,a|0);a=$Xc(4)|0;f[a>>2]=4;b=$Xc(4)|0;f[b>>2]=4;ne(4936,471030,25544,213716,7,a|0,25544,212205,15,b|0);ze(4936);cf(4520,197420,213675,6,212002,2155);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4520,453859,25512,212016,531,b|0,25512,212005,287,a|0);a=$Xc(4)|0;f[a>>2]=4;b=$Xc(4)|0;f[b>>2]=4;ne(4520,197426,25512,212016,531,a|0,25512,212005,287,b|0);ze(4520);cf(4160,197420,213675,7,212002,2156);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4160,453859,25544,213716,8,b|0,25544,212205,16,a|0);a=$Xc(4)|0;f[a>>2]=4;b=$Xc(4)|0;f[b>>2]=4;ne(4160,197426,25544,213716,8,a|0,25544,212205,16,b|0);ze(4160);cf(4176,197428,213675,8,212002,2157);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4176,453859,25512,212016,532,b|0,25512,212005,288,a|0);a=$Xc(4)|0;f[a>>2]=4;b=$Xc(4)|0;f[b>>2]=4;ne(4176,197426,25512,212016,532,a|0,25512,212005,288,b|0);b=$Xc(4)|0;f[b>>2]=8;a=$Xc(4)|0;f[a>>2]=8;ne(4176,471037,25512,212016,532,b|0,25512,212005,288,a|0);a=$Xc(4)|0;f[a>>2]=12;b=$Xc(4)|0;f[b>>2]=12;ne(4176,471030,25512,212016,532,a|0,25512,212005,288,b|0);ze(4176);cf(4944,197433,213675,9,212002,2158);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4944,453859,25544,213716,9,b|0,25544,212205,17,a|0);a=$Xc(4)|0;f[a>>2]=4;b=$Xc(4)|0;f[b>>2]=4;ne(4944,197426,25544,213716,9,a|0,25544,212205,17,b|0);b=$Xc(4)|0;f[b>>2]=8;a=$Xc(4)|0;f[a>>2]=8;ne(4944,471037,25544,213716,9,b|0,25544,212205,17,a|0);a=$Xc(4)|0;f[a>>2]=12;b=$Xc(4)|0;f[b>>2]=12;ne(4944,471030,25544,213716,9,a|0,25544,212205,17,b|0);ze(4944);cf(4168,197440,213675,10,212002,2159);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4168,197452,4160,212016,533,b|0,4160,212005,289,a|0);a=$Xc(4)|0;f[a>>2]=8;b=$Xc(4)|0;f[b>>2]=8;ne(4168,470867,4936,212016,534,a|0,4936,212005,290,b|0);b=$Xc(4)|0;f[b>>2]=16;a=$Xc(4)|0;f[a>>2]=16;ne(4168,197459,25544,213716,10,b|0,25544,212205,18,a|0);ze(4168);Pf(197465,2,26896,212016,535,1129);Pf(197483,2,26904,212016,536,1130);Pf(197507,2,26912,212016,537,1131);cf(4776,197533,213675,11,212002,2160);a=$Xc(4)|0;f[a>>2]=12;b=$Xc(4)|0;f[b>>2]=12;ne(4776,197459,25544,213716,11,a|0,25544,212205,19,b|0);b=$Xc(4)|0;f[b>>2]=24;a=$Xc(4)|0;f[a>>2]=24;ne(4776,197542,25512,212016,538,b|0,25512,212005,291,a|0);a=$Xc(4)|0;f[a>>2]=20;b=$Xc(4)|0;f[b>>2]=20;ne(4776,197551,25512,212016,538,a|0,25512,212005,291,b|0);b=$Xc(4)|0;f[b>>2]=0;a=$Xc(4)|0;f[a>>2]=0;ne(4776,197558,4160,212016,539,b|0,4160,212005,292,a|0);a=$Xc(4)|0;f[a>>2]=16;b=$Xc(4)|0;f[b>>2]=16;ne(4776,197561,25544,213716,11,a|0,25544,212205,19,b|0);b=$Xc(4)|0;f[b>>2]=8;a=$Xc(4)|0;f[a>>2]=8;ne(4776,470867,25544,213716,11,b|0,25544,212205,19,a|0);ze(4776);sf(4848,197570,213675,12,212002,2161);Lf(4848,25552,213697,12,0,25552,212377,20,0);Lf(4848,25552,213697,12,1,25552,212377,20,1);Lf(4848,25552,213697,12,2,25552,212377,20,2);Lf(4848,25552,213697,12,3,25552,212377,20,3);ce(4848);cf(4952,197577,213675,13,212002,2162);a=$Xc(4)|0;f[a>>2]=0;b=$Xc(4)|0;f[b>>2]=0;ne(4952,197587,25552,213697,13,a|0,25552,212377,21,b|0);b=$Xc(4)|0;f[b>>2]=8;a=$Xc(4)|0;f[a>>2]=8;ne(4952,197594,25552,213697,13,b|0,25552,212377,21,a|0);a=$Xc(4)|0;f[a>>2]=16;b=$Xc(4)|0;f[b>>2]=16;ne(4952,197601,4520,212016,540,a|0,4520,212005,293,b|0);b=$Xc(4)|0;f[b>>2]=24;a=$Xc(4)|0;f[a>>2]=24;ne(4952,197608,4520,212016,540,b|0,4520,212005,293,a|0);ze(4952);cf(4960,197615,213675,14,212002,2163);a=$Xc(4)|0;f[a>>2]=0;b=$Xc(4)|0;f[b>>2]=0;ne(4960,197452,4160,212016,541,a|0,4160,212005,294,b|0);b=$Xc(4)|0;f[b>>2]=8;a=$Xc(4)|0;f[a>>2]=8;ne(4960,197622,25544,213716,14,b|0,25544,212205,22,a|0);ze(4960);cf(4968,197629,213675,15,212002,2164);a=$Xc(4)|0;f[a>>2]=0;b=$Xc(4)|0;f[b>>2]=0;ne(4968,197637,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=8;a=$Xc(4)|0;f[a>>2]=8;ne(4968,197641,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=16;b=$Xc(4)|0;f[b>>2]=16;ne(4968,197645,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=24;a=$Xc(4)|0;f[a>>2]=24;ne(4968,197649,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=32;b=$Xc(4)|0;f[b>>2]=32;ne(4968,197653,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=40;a=$Xc(4)|0;f[a>>2]=40;ne(4968,197657,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=48;b=$Xc(4)|0;f[b>>2]=48;ne(4968,197661,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=56;a=$Xc(4)|0;f[a>>2]=56;ne(4968,197665,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=64;b=$Xc(4)|0;f[b>>2]=64;ne(4968,197669,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=72;a=$Xc(4)|0;f[a>>2]=72;ne(4968,197673,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=80;b=$Xc(4)|0;f[b>>2]=80;ne(4968,197677,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=88;a=$Xc(4)|0;f[a>>2]=88;ne(4968,197682,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=96;b=$Xc(4)|0;f[b>>2]=96;ne(4968,197687,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=104;a=$Xc(4)|0;f[a>>2]=104;ne(4968,197692,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=112;b=$Xc(4)|0;f[b>>2]=112;ne(4968,197697,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=120;a=$Xc(4)|0;f[a>>2]=120;ne(4968,197702,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=128;b=$Xc(4)|0;f[b>>2]=128;ne(4968,197707,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=136;a=$Xc(4)|0;f[a>>2]=136;ne(4968,197712,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=144;b=$Xc(4)|0;f[b>>2]=144;ne(4968,197717,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=152;a=$Xc(4)|0;f[a>>2]=152;ne(4968,197722,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=160;b=$Xc(4)|0;f[b>>2]=160;ne(4968,197727,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=168;a=$Xc(4)|0;f[a>>2]=168;ne(4968,197732,25552,213697,15,b|0,25552,212377,23,a|0);a=$Xc(4)|0;f[a>>2]=176;b=$Xc(4)|0;f[b>>2]=176;ne(4968,197737,25552,213697,15,a|0,25552,212377,23,b|0);b=$Xc(4)|0;f[b>>2]=184;a=$Xc(4)|0;f[a>>2]=184;ne(4968,197742,25552,213697,15,b|0,25552,212377,23,a|0);ze(4968);cf(6704,197747,213675,16,212002,2165);a=$Xc(4)|0;f[a>>2]=16;b=$Xc(4)|0;f[b>>2]=16;ne(6704,197757,25512,212016,542,a|0,25512,212005,295,b|0);b=$Xc(4)|0;f[b>>2]=1132;a=$Xc(4)|0;f[a>>2]=1133;ne(6704,197762,4984,212016,543,b|0,4984,212005,296,a|0);ze(6704);Pf(197766,2,26920,212016,544,1134);Pf(267923,2,26928,212016,545,1135);Pf(228482,3,26936,212039,271,297);Pf(228482,2,26948,212016,546,1136);Pf(197783,1,26956,211997,956,2166);Pf(197812,2,26960,212016,547,957);Pf(197825,4,26968,212044,64,211);Pf(472797,4,26968,212044,64,212);Pf(197834,1,26984,211997,958,2167);fe(197854,25512,0);fe(197862,25512,8);fe(197870,25512,16);fe(197878,25512,24);fe(197886,25512,1);fe(197894,25512,9);fe(197902,25512,17);fe(197910,25512,25);fe(197918,25512,2);fe(197927,25512,10);fe(197936,25512,18);fe(197945,25512,26);fe(197954,25512,3);fe(197963,25512,11);fe(197972,25512,19);fe(197981,25512,27);fe(382147,25512,4);fe(197990,25512,12);fe(197999,25512,20);fe(198008,25512,28);fe(446348,25512,5);fe(198017,25512,13);fe(198026,25512,21);fe(198035,25512,29);fe(198044,25512,6);fe(198053,25512,14);fe(198062,25512,22);fe(198071,25512,30);fe(234613,25512,0);fe(234619,25512,1);fe(234625,25512,2);fe(234632,25512,3);fe(234639,25512,4);fe(234646,25512,5);fe(234653,25512,6);fe(198080,25512,-2147483648);fe(198088,25512,2147483647);return}function Ak(a){a=a|0;Ce(4216,4240,4256,0,211997,959,212e3,0,212e3,0,a|0,212002,2168);ae(4216,1,25640,211997,960,17);a=$Xc(8)|0;f[a>>2]=1137;f[a+4>>2]=0;ff(4216,211795,3,25644,212005,298,a|0,0);a=$Xc(8)|0;f[a>>2]=299;f[a+4>>2]=0;ff(4216,264464,4,25656,212010,213,a|0,0);a=$Xc(8)|0;f[a>>2]=961;f[a+4>>2]=0;ff(4216,470867,2,25672,212016,548,a|0,0);a=$Xc(4)|0;f[a>>2]=300;ff(4216,379488,3,25680,212039,272,a|0,0);a=$Xc(4)|0;f[a>>2]=273;ff(4216,466373,4,25692,212044,65,a|0,0);return}function Bk(a){a=a|0;Ce(4304,4328,4344,0,211997,962,212e3,0,212e3,0,a|0,212002,2169);ae(4304,1,25708,211997,963,18);a=$Xc(8)|0;f[a>>2]=1138;f[a+4>>2]=0;ff(4304,211795,3,25712,212205,24,a|0,0);a=$Xc(8)|0;f[a>>2]=301;f[a+4>>2]=0;ff(4304,264464,4,25724,212210,8,a|0,0);a=$Xc(8)|0;f[a>>2]=964;f[a+4>>2]=0;ff(4304,470867,2,25740,212016,549,a|0,0);a=$Xc(4)|0;f[a>>2]=302;ff(4304,379488,3,25748,212039,274,a|0,0);a=$Xc(4)|0;f[a>>2]=275;ff(4304,466373,4,25760,212216,2,a|0,0);return}function Ck(a){a=a|0;Ce(4384,4408,4424,0,211997,965,212e3,0,212e3,0,a|0,212002,2170);ae(4384,1,25776,211997,966,19);a=$Xc(8)|0;f[a>>2]=1139;f[a+4>>2]=0;ff(4384,211795,3,25780,212377,25,a|0,0);a=$Xc(8)|0;f[a>>2]=303;f[a+4>>2]=0;ff(4384,264464,4,25792,212382,9,a|0,0);a=$Xc(8)|0;f[a>>2]=967;f[a+4>>2]=0;ff(4384,470867,2,25808,212016,550,a|0,0);a=$Xc(4)|0;f[a>>2]=304;ff(4384,379488,3,25816,212039,276,a|0,0);a=$Xc(4)|0;f[a>>2]=277;ff(4384,466373,4,25828,212388,3,a|0,0);return}function Dk(a){a=a|0;Ce(4464,4488,4504,0,211997,968,212e3,0,212e3,0,a|0,212002,2171);ae(4464,1,25844,211997,969,20);a=$Xc(8)|0;f[a>>2]=1140;f[a+4>>2]=0;ff(4464,211795,3,25848,212005,305,a|0,0);a=$Xc(8)|0;f[a>>2]=306;f[a+4>>2]=0;ff(4464,264464,4,25860,212010,214,a|0,0);a=$Xc(8)|0;f[a>>2]=970;f[a+4>>2]=0;ff(4464,470867,2,25876,212016,551,a|0,0);a=$Xc(4)|0;f[a>>2]=307;ff(4464,379488,3,25884,212039,278,a|0,0);a=$Xc(4)|0;f[a>>2]=279;ff(4464,466373,4,25896,212044,66,a|0,0);return}function Ek(a){a=a|0;Ce(4552,4576,4592,0,211997,971,212e3,0,212e3,0,a|0,212002,2172);ae(4552,1,25912,211997,972,21);a=$Xc(8)|0;f[a>>2]=1141;f[a+4>>2]=0;ff(4552,211795,3,25916,212005,308,a|0,0);a=$Xc(8)|0;f[a>>2]=309;f[a+4>>2]=0;ff(4552,264464,4,25928,212010,215,a|0,0);a=$Xc(8)|0;f[a>>2]=973;f[a+4>>2]=0;ff(4552,470867,2,25944,212016,552,a|0,0);a=$Xc(4)|0;f[a>>2]=310;ff(4552,379488,3,25952,212039,280,a|0,0);a=$Xc(4)|0;f[a>>2]=281;ff(4552,466373,4,25964,212044,67,a|0,0);return}function Fk(a){a=a|0;Ce(4640,4664,4680,0,211997,974,212e3,0,212e3,0,a|0,212002,2173);ae(4640,1,25980,211997,975,22);a=$Xc(8)|0;f[a>>2]=1142;f[a+4>>2]=0;ff(4640,211795,3,25984,212005,311,a|0,0);a=$Xc(8)|0;f[a>>2]=312;f[a+4>>2]=0;ff(4640,264464,4,25996,212010,216,a|0,0);a=$Xc(8)|0;f[a>>2]=976;f[a+4>>2]=0;ff(4640,470867,2,26012,212016,553,a|0,0);a=$Xc(4)|0;f[a>>2]=313;ff(4640,379488,3,26020,212039,282,a|0,0);a=$Xc(4)|0;f[a>>2]=283;ff(4640,466373,4,26032,212044,68,a|0,0);return}function Gk(a){a=a|0;Ce(4720,4744,4760,0,211997,977,212e3,0,212e3,0,a|0,212002,2174);ae(4720,1,26048,211997,978,23);a=$Xc(8)|0;f[a>>2]=1143;f[a+4>>2]=0;ff(4720,211795,3,26052,212005,314,a|0,0);a=$Xc(8)|0;f[a>>2]=315;f[a+4>>2]=0;ff(4720,264464,4,26064,212010,217,a|0,0);a=$Xc(8)|0;f[a>>2]=979;f[a+4>>2]=0;ff(4720,470867,2,26080,212016,554,a|0,0);a=$Xc(4)|0;f[a>>2]=316;ff(4720,379488,3,26088,212039,284,a|0,0);a=$Xc(4)|0;f[a>>2]=285;ff(4720,466373,4,26100,212044,69,a|0,0);return}function Hk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];v$(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;ei[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Zj(e);u=d;return}function Ik(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;u$(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;ei[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);Zj(g);u=e;return}function Jk(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=Mf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+40|0;c=0;j=g;while(1){g=(f[i>>2]|0)+(c<<2)|0;if((b[529936]|0)==0?X0c(529936)|0:0){k=Af(2,25592)|0;f[135040]=k}k=f[135040]|0;f[e>>2]=f[g>>2];Cd(k|0,j|0,197030,e|0);k=c+1|0;if((k|0)>=(f[h>>2]|0))break;c=k;j=f[a>>2]|0}u=d;return}function Kk(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=Mf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+44|0;c=0;j=g;while(1){g=(f[i>>2]|0)+(c<<2)|0;if((b[529944]|0)==0?X0c(529944)|0:0){k=Af(2,25600)|0;f[135041]=k}k=f[135041]|0;f[e>>2]=f[g>>2];Cd(k|0,j|0,197030,e|0);k=c+1|0;if((k|0)>=(f[h>>2]|0))break;c=k;j=f[a>>2]|0}u=d;return}function Lk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4864,d|0)|0;f[a>>2]=g;u=c;return}function Mk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4872,d|0)|0;f[a>>2]=g;u=c;return}function Nk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4880,d|0)|0;f[a>>2]=g;u=c;return}function Ok(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4888,d|0)|0;f[a>>2]=g;u=c;return}function Pk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4896,d|0)|0;f[a>>2]=g;u=c;return}function Qk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4904,d|0)|0;f[a>>2]=g;u=c;return}function Rk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>3;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=bf(4912,d|0)|0;f[a>>2]=g;u=c;return}function Sk(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if((b|0)<=0){c=0;return c|0}c=f[(f[a+44>>2]|0)+(b+-1<<2)>>2]|0;return c|0}function Tk(a){a=a|0;return 675553809>>>(f[a>>2]<<2&28)&15|0}function Uk(a){a=a|0;return ((f[a>>2]|0)>>>3&511)+1|0}function Vk(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;return c|0}d=f[a+40>>2]|0;a=0;e=1;while(1){g=Y(f[d+(a<<2)>>2]|0,e)|0;a=a+1|0;if((a|0)>=(b|0)){c=g;break}else e=g}return c|0}function Wk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=c;f[e+4>>2]=c+1;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;W$(a,b,e,g);u=d;return}function Xk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=d&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(b|0):0)?(f[a+12>>2]|0)==(c|0):0)?(f[a>>2]&4095|0)==(h|0):0)?f[a+16>>2]|0:0){u=e;return}f[g>>2]=b;f[g+4>>2]=c;S$(a,2,g,h);u=e;return}function Yk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b+4>>2]|0;h=f[b>>2]|0;b=c&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(g|0):0)?(f[a+12>>2]|0)==(h|0):0)?(f[a>>2]&4095|0)==(b|0):0)?f[a+16>>2]|0:0){u=d;return}f[e>>2]=g;f[e+4>>2]=h;S$(a,2,e,b);u=d;return}function Zk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=c;f[g+4>>2]=d;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(a,b,g,h);u=e;return}function _k(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;W$(a,b,c,e);u=d;return}function $k(a){a=a|0;return f[a>>2]&4095|0}function al(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+16>>2]|0))return 1;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}h=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[h+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(b|0)){c=j;break}else i=j}d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}function bl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=c;f[h+4>>2]=d;W$(a,b,g,h);u=e;return}function cl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;W$(a,b,e,c);u=d;return}function dl(a,b){a=a|0;b=b|0;return ((f[(f[a+44>>2]|0)+(b<<2)>>2]|0)>>>0)/((675553809>>>(f[a>>2]<<2&28)&15)>>>0)|0|0}function el(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=1124007936;e=a+8|0;g=a+40|0;h=a+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+48|0;f[a+44>>2]=e;f[e>>2]=0;f[a+52>>2]=0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=a;jR(b,d);u=c;return}function fl(a){a=a|0;return f[a>>2]&7|0}function gl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=c;f[g+4>>2]=c+1;W$(a,b,e,g);u=d;return}function hl(a,b,c){a=a|0;b=b|0;c=c|0;Z$(a,b,c);return}function il(a){a=a|0;return (f[a>>2]&16384|0)!=0|0}function jl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4864,e|0)|0;f[a>>2]=h;u=d;return}function kl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4864,g|0)|0;f[a>>2]=j;u=e;return}function ll(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4872,e|0)|0;f[a>>2]=h;u=d;return}function ml(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4872,g|0)|0;f[a>>2]=j;u=e;return}function nl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4888,e|0)|0;f[a>>2]=h;u=d;return}function ol(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4888,g|0)|0;f[a>>2]=j;u=e;return}function pl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4880,e|0)|0;f[a>>2]=h;u=d;return}function ql(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4880,g|0)|0;f[a>>2]=j;u=e;return}function rl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4896,e|0)|0;f[a>>2]=h;u=d;return}function sl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4896,g|0)|0;f[a>>2]=j;u=e;return}function tl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4904,e|0)|0;f[a>>2]=h;u=d;return}function ul(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4904,g|0)|0;f[a>>2]=j;u=e;return}function vl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=bf(4912,e|0)|0;f[a>>2]=h;u=d;return}function wl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((675553809>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=bf(4912,g|0)|0;f[a>>2]=j;u=e;return}function xl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function yl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function zl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Al(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function Bl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function Cl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Dl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function El(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Fl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Gl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function Hl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Il(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Jl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Kl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Ll(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Ml(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Nl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Ol(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Pl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Ql(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<3)|0;return g|0}}g=c+(b<<3)|0;return g|0}function Rl(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<3)|0}function Sl(a){a=a|0;p[a>>3]=1797693134862315708145274.0e284;p[a+8>>3]=1797693134862315708145274.0e284;p[a+16>>3]=1797693134862315708145274.0e284;p[a+24>>3]=1797693134862315708145274.0e284;return}function Tl(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;voa(i,j,c,d,e,g);u=h;return}function Ul(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;voa(h,i,c,d,e,0);u=g;return}function Vl(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;voa(g,h,c,d,3,0);u=e;return}function Wl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;Qoa(i,j,k,d,e,g);u=h;return}function Xl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;Qoa(h,i,j,d,e,0);u=g;return}function Yl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Jqa(i,j,k,d,e,g);u=h;return}function Zl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Jqa(h,i,j,d,e,4);u=g;return}function _l(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Jqa(g,h,i,d,0.0,4);u=e;return}function $l(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;JDa(l,m,c,d,e,g,h,i,j);u=k;return}function am(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;JDa(k,l,c,d,e,g,h,i,0);u=j;return}function bm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;JDa(j,k,c,d,e,g,h,0,0);u=i;return}function cm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;JDa(i,j,c,d,e,g,100.0,0,0);u=h;return}function dm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;JDa(h,i,c,d,e,100.0,100.0,0,0);u=g;return}function em(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;j=+j;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;wDa(l,m,c,d,e,g,h,i,j);u=k;return}function fm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;wDa(k,l,c,d,e,g,h,i,3.141592653589793);u=j;return}function gm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;wDa(j,k,c,d,e,g,h,0.0,3.141592653589793);u=i;return}function hm(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;wDa(i,j,c,d,e,g,0.0,0.0,3.141592653589793);u=h;return}function im(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;wDa(h,i,c,d,e,0.0,0.0,0.0,3.141592653589793);u=g;return}function jm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;GDa(j,k,c,d,e,g,h);u=i;return}function km(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;GDa(i,j,c,d,e,g,0.0);u=h;return}function lm(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;GDa(h,i,c,d,e,0.0,0.0);u=g;return}function mm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;uoa(j,k,c,d,e,g,h);u=i;return}function nm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;uoa(i,j,c,d,e,g,4);u=h;return}function om(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;uoa(h,i,c,d,e,0.0,4);u=g;return}function pm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;uoa(g,h,c,d,1.0,0.0,4);u=e;return}function qm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;uoa(e,g,c,1,1.0,0.0,4);u=d;return}function rm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;toa(k,l,c,d,e,g,h,i);u=j;return}function sm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;toa(j,k,c,d,e,g,h,4);u=i;return}function tm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;toa(i,j,c,d,e,g,0.0,4);u=h;return}function um(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;toa(h,i,c,d,e,1.0,0.0,4);u=g;return}function vm(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;soa(l,m,c,d,e,g,h,i,j);u=k;return}function wm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;soa(k,l,c,d,e,g,h,i,4);u=j;return}function xm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;soa(j,k,c,d,e,g,h,0.0,4);u=i;return}function ym(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;soa(i,j,c,d,e,g,1.0,0.0,4);u=h;return}function zm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;soa(h,i,c,d,e,3,1.0,0.0,4);u=g;return}function Am(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;H1(e,g,h);u=d;return}function Bm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;doa(j,k,c,d,e,g,h);u=i;return}function Cm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;E1(h,i,j,k,e);u=g;return}function Dm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;E1(g,h,i,j,-1);u=e;return}function Em(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;E1(e,g,h,fT()|0,-1);u=d;return}function Fm(a,b,c,d,e,g,h){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;L1(j,b,k,d,e,l,h);u=i;return}function Gm(a,b,c,d,e,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=g;L1(i,b,j,d,e,k,-1);u=h;return}function Hm(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Sra(g,h,c,d);u=e;return}function Im(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+ioa(d,b);u=c;return +e}function Jm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;zva(i,j,c,d,e,g);u=h;return}function Km(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;zva(h,i,c,d,e,4);u=g;return}function Lm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;v1(g,h,i,j);u=e;return}function Mm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;v1(e,g,h,fT()|0);u=d;return}function Nm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;z1(e,g,h);u=d;return}function Om(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;z1(d,e,fT()|0);u=c;return}function Pm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;x1(g,h,i,j);u=e;return}function Qm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;x1(e,g,h,fT()|0);u=d;return}function Rm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;y1(g,h,i,j);u=e;return}function Sm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;y1(e,g,h,fT()|0);u=d;return}function Tm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Vua(h,i,j,k,e);u=g;return}function Um(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];Vua(g,h,i,j,4);u=e;return}function Vm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+8|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=-1;f[i+4>>2]=-1;Vua(e,g,h,i,4);u=d;return}function Wm(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;loa(a,d);u=c;return}function Xm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];Uua(j,k,c,l,m,g,h);u=i;return}function Ym(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];Uua(i,j,c,k,l,g,4);u=h;return}function Zm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Uua(h,i,c,j,k,1,4);u=g;return}function _m(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=-1;f[j+4>>2]=-1;Uua(g,h,c,i,j,1,4);u=e;return}function $m(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+32|0;l=h+40|0;m=h+16|0;n=h+4|0;o=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;le(a|0);an(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;le(d|0);bn(n,o);Yoa(i,j,l,m,n,g);m=f[n>>2]|0;if(m|0){l=n+4|0;n=f[l>>2]|0;if((n|0)!=(m|0))f[l>>2]=n+(~((n+-4-m|0)>>>2)<<2);cYc(m)}Ae(f[o>>2]|0);o=f[j>>2]|0;if(!o){p=f[k>>2]|0;Ae(p|0);u=h;return}m=j+4|0;j=f[m>>2]|0;if((j|0)!=(o|0))f[m>>2]=j+(~((j+-4-o|0)>>>2)<<2);cYc(o);p=f[k>>2]|0;Ae(p|0);u=h;return}function an(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(213903)|0;i=Md(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,25520,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=bf(25520,d|0)|0;n=Md(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,25512,d|0);Ie(f[d>>2]|0);m=~~j;f[e>>2]=m;l=f[i>>2]|0;if(l>>>0<(f[g>>2]|0)>>>0){f[l>>2]=m;f[i>>2]=l+4}else LA(a,e);Ae(n|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function bn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0.0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(213903)|0;i=Md(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,25520,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=bf(25520,d|0)|0;o=Md(l|0,m|0)|0;Ae(m|0);j=+pe(o|0,25544,d|0);Ie(f[d>>2]|0);p=j;n[e>>2]=p;m=f[i>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n[m>>2]=p;f[i>>2]=m+4}else MA(a,e);Ae(o|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function cn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+112|0;j=i+88|0;k=i+72|0;l=i+48|0;m=i+56|0;n=i+32|0;o=i+20|0;p=i+4|0;q=i+8|0;r=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=a;a=f[b>>2]|0;f[l>>2]=a;le(a|0);an(k,l);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=d;d=f[e>>2]|0;f[p>>2]=d;le(d|0);an(o,p);d=f[g>>2]|0;f[r>>2]=d;le(d|0);bn(q,r);Woa(j,k,m,n,o,q,h);h=f[q>>2]|0;if(h|0){n=q+4|0;q=f[n>>2]|0;if((q|0)!=(h|0))f[n>>2]=q+(~((q+-4-h|0)>>>2)<<2);cYc(h)}Ae(f[r>>2]|0);r=f[o>>2]|0;if(r|0){h=o+4|0;o=f[h>>2]|0;if((o|0)!=(r|0))f[h>>2]=o+(~((o+-4-r|0)>>>2)<<2);cYc(r)}Ae(f[p>>2]|0);p=f[k>>2]|0;if(!p){s=f[l>>2]|0;Ae(s|0);u=i;return}r=k+4|0;k=f[r>>2]|0;if((k|0)!=(p|0))f[r>>2]=k+(~((k+-4-p|0)>>>2)<<2);cYc(p);s=f[l>>2]|0;Ae(s|0);u=i;return}function dn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+112|0;i=h+88|0;j=h+72|0;k=h+48|0;l=h+56|0;m=h+32|0;n=h+20|0;o=h+4|0;p=h+8|0;q=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;le(a|0);an(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;le(d|0);an(n,o);d=f[g>>2]|0;f[q>>2]=d;le(d|0);bn(p,q);Woa(i,j,l,m,n,p,0);m=f[p>>2]|0;if(m|0){l=p+4|0;p=f[l>>2]|0;if((p|0)!=(m|0))f[l>>2]=p+(~((p+-4-m|0)>>>2)<<2);cYc(m)}Ae(f[q>>2]|0);q=f[n>>2]|0;if(q|0){m=n+4|0;n=f[m>>2]|0;if((n|0)!=(q|0))f[m>>2]=n+(~((n+-4-q|0)>>>2)<<2);cYc(q)}Ae(f[o>>2]|0);o=f[j>>2]|0;if(!o){r=f[k>>2]|0;Ae(r|0);u=h;return}q=j+4|0;j=f[q>>2]|0;if((j|0)!=(o|0))f[q>>2]=j+(~((j+-4-o|0)>>>2)<<2);cYc(o);r=f[k>>2]|0;Ae(r|0);u=h;return}function en(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;b=o+8|0;f[b>>2]=0;f[b+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=c;lXb(m,n,o,d,e,g,h,i,j,k);u=l;return}function fn(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;m=u;u=u+128|0;n=m;o=m+104|0;p=m+88|0;q=m+72|0;r=m+56|0;s=m+40|0;t=m+24|0;v=m+16|0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=a;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=b;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=c;c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=50397184;f[r+4>>2]=d;d=s+8|0;f[d>>2]=0;f[d+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=e;e=t+8|0;f[e>>2]=0;f[e+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=g;f[v>>2]=f[h>>2];f[v+4>>2]=f[h+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[n+8>>2]=f[j+8>>2];f[n+12>>2]=f[j+12>>2];kXb(o,p,q,r,s,t,v,i,n,k,l);u=m;return}function gn(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=u;u=u+128|0;m=l;n=l+104|0;o=l+88|0;p=l+72|0;q=l+56|0;r=l+40|0;s=l+24|0;t=l+16|0;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=a;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=b;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=c;c=q+8|0;f[c>>2]=0;f[c+4>>2]=0;f[q>>2]=50397184;f[q+4>>2]=d;d=r+8|0;f[d>>2]=0;f[d+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=e;e=s+8|0;f[e>>2]=0;f[e+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=g;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];kXb(n,o,p,q,r,s,t,i,m,k,.0001);u=l;return}function hn(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=u;u=u+128|0;l=k;m=k+104|0;n=k+88|0;o=k+72|0;p=k+56|0;q=k+40|0;r=k+24|0;s=k+16|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=c;c=p+8|0;f[c>>2]=0;f[c+4>>2]=0;f[p>>2]=50397184;f[p+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];f[l+12>>2]=f[j+12>>2];kXb(m,n,o,p,q,r,s,i,l,0,.0001);u=k;return}function jn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+144|0;k=j+16|0;l=j+120|0;m=j+104|0;n=j+88|0;o=j+72|0;q=j+56|0;r=j+40|0;s=j+32|0;t=j;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=c;c=o+8|0;f[c>>2]=0;f[c+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[t>>2]=3;f[t+4>>2]=30;p[t+8>>3]=.01;f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];kXb(l,m,n,o,q,r,s,i,k,0,.0001);u=j;return}function kn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;i=u;u=u+144|0;j=i+16|0;k=i+120|0;l=i+104|0;m=i+88|0;n=i+72|0;o=i+56|0;q=i+40|0;r=i+32|0;s=i;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=d;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=e;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=g;f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[s>>2]=3;f[s+4>>2]=30;p[s+8>>3]=.01;f[j>>2]=f[s>>2];f[j+4>>2]=f[s+4>>2];f[j+8>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];kXb(k,l,m,n,o,q,r,3,j,0,.0001);u=i;return}function ln(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+144|0;i=h+16|0;j=h+120|0;k=h+104|0;l=h+88|0;m=h+72|0;n=h+56|0;o=h+40|0;q=h+32|0;r=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=e;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=g;f[q>>2]=21;f[q+4>>2]=21;f[r>>2]=3;f[r+4>>2]=30;p[r+8>>3]=.01;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];kXb(j,k,l,m,n,o,q,3,i,0,.0001);u=h;return}function mn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;ML(h,i,j,k,e);u=g;return}function nn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;ML(g,h,i,j,0);u=e;return}function on(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+8|0;k=i;l=j+8|0;f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];Gra(j,k,c,d,e,g,h);u=i;return}function pn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];Gra(i,j,c,d,e,g,0);u=h;return}function qn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+8|0;i=g;j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];Gra(h,i,c,d,e,8,0);u=g;return}function rn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+8|0;h=e;i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];Gra(g,h,c,d,1,8,0);u=e;return}function sn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;M1(g,h,i,d);u=e;return}function tn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+Zoa(e,g,c);u=d;return +h}function un(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=Uva(g,h,c,d)|0;u=e;return b|0}function vn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=Uva(e,g,c,4)|0;u=d;return b|0}function wn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=Uva(d,e,8,4)|0;u=c;return b|0}function xn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=d;d=nwa(i,j,k,l,e,g)|0;u=h;return d|0}function yn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;d=nwa(h,i,j,k,e,4)|0;u=g;return d|0}function zn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;d=nwa(g,h,i,j,8,4)|0;u=e;return d|0}function An(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+joa(d,b);u=c;return +e}function Bn(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+joa(c,0);u=b;return +d}function Cn(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;TU(g,h,c,d);u=e;return}function Dn(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;TU(e,g,c,0.0);u=d;return}function En(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;TU(d,e,1.0,0.0);u=c;return}function Fn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Eva(g,h,c,d);u=e;return}function Gn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Eva(e,g,c,1);u=d;return}function Hn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;Eva(d,e,0,1);u=c;return}function In(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;Rva(e,g,h);u=d;return}function Jn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;rR(k,l,c,d,e,g,h,i);u=j;return}function Kn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;rR(j,k,c,d,e,g,h,l);u=i;return}function Ln(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;$Ba(i,j,c,d,e,g);u=h;return}function Mn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;$Ba(h,i,c,d,e,4);u=g;return}function Nn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;ZBa(h,i,c,d,e);u=g;return}function On(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;ZBa(g,h,c,d,4);u=e;return}function Pn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;ZBa(e,g,c,3,4);u=d;return}function Qn(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=jP(c)|0;u=b;return a|0}function Rn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Spa(g,h,c,d);u=e;return}function Sn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Spa(e,g,c,0);u=d;return}function Tn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;gpa(g,h,c,d);u=e;return}function Un(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;gpa(e,g,c,0);u=d;return}function Vn(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+fM(c);u=b;return +d}function Wn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;a1(g,h,c,d);u=e;return}function Xn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;a1(e,g,c,0);u=d;return}function Yn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;a1(d,e,0,0);u=c;return}function Zn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];XBa(j,k,l,m,e,g,h);u=i;return}function _n(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;XBa(i,j,k,l,e,g,m);u=h;return}function $n(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;XBa(h,i,j,k,e,0,l);u=g;return}function ao(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;XBa(g,h,i,j,1,0,k);u=e;return}function bo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;XBa(e,g,h,i,1,0,j);u=d;return}function co(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;xEa(h,i,c,d,e);u=g;return}function eo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;xEa(g,h,c,d,5);u=e;return}function fo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;sEa(i,j,k,d,e,g);u=h;return}function go(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;sEa(h,i,j,d,e,0);u=g;return}function ho(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;J1(h,i,j,d,e);u=g;return}function io(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;J1(g,h,i,d,-1);u=e;return}function jo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;J1(e,g,h,1.0,-1);u=d;return}function ko(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;K1(a,g,h,d);u=e;return}function lo(a,b,c){a=+a;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;K1(a,e,g,-1);u=d;return}function mo(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+64|0;l=k+40|0;m=k+24|0;n=k+8|0;o=k;p=l+8|0;f[p>>2]=0;f[p+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=17104896;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=h;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];Mra(l,m,c,d,e,g,n,i,o);u=k;return}function no(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;o=k+8|0;f[o>>2]=0;f[o+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=17104896;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=h;f[n>>2]=0;f[n+4>>2]=0;Mra(k,l,c,d,e,g,m,i,n);u=j;return}function oo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;n=j+8|0;f[n>>2]=0;f[n+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m>>2]=0;f[m+4>>2]=0;Mra(j,k,c,d,e,g,l,2147483647,m);u=i;return}function po(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=b;b=fT()|0;f[k>>2]=0;f[k+4>>2]=0;Mra(i,j,c,d,e,g,b,2147483647,k);u=h;return}function qo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=b;b=fT()|0;f[j>>2]=0;f[j+4>>2]=0;Mra(h,i,c,d,e,8,b,2147483647,j);u=g;return}function ro(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=b;b=fT()|0;f[i>>2]=0;f[i+4>>2]=0;Mra(g,h,c,d,1,8,b,2147483647,i);u=e;return}function so(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;l=u;u=u+128|0;m=l+104|0;n=l+88|0;o=l+64|0;p=l+72|0;q=l+52|0;r=l+20|0;s=l+40|0;t=l+4|0;v=l+24|0;w=l+8|0;x=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;a=f[b>>2]|0;f[o>>2]=a;le(a|0);to(n,o);f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=c;c=f[d>>2]|0;f[r>>2]=c;le(c|0);to(q,r);c=f[e>>2]|0;f[t>>2]=c;le(c|0);uo(s,t);c=v+8|0;f[c>>2]=0;f[c+4>>2]=0;f[v>>2]=50397184;f[v+4>>2]=g;g=f[j>>2]|0;f[x>>2]=g;le(g|0);vo(w,x);ELb(m,n,p,q,s,v,h,i,w,k);k=f[w>>2]|0;if(k|0){i=w+4|0;if((f[i>>2]|0)!=(k|0))f[i>>2]=k;cYc(k)}Ae(f[x>>2]|0);x=f[s>>2]|0;if(x|0){k=s+4|0;s=f[k>>2]|0;if((s|0)!=(x|0))f[k>>2]=s+(~((s+-16-x|0)>>>4)<<4);cYc(x)}Ae(f[t>>2]|0);t=f[q>>2]|0;if(t|0){x=q+4|0;q=f[x>>2]|0;if((q|0)!=(t|0))f[x>>2]=q+(~(((q+-28-t|0)>>>0)/28|0)*28|0);cYc(t)}Ae(f[r>>2]|0);r=f[n>>2]|0;if(!r){y=f[o>>2]|0;Ae(y|0);u=l;return}t=n+4|0;n=f[t>>2]|0;if((n|0)!=(r|0))f[t>>2]=n+(~(((n+-28-r|0)>>>0)/28|0)*28|0);cYc(r);y=f[o>>2]|0;Ae(y|0);u=l;return}function to(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+48|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(213903)|0;i=Md(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,25520,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=e+4|0;k=e+8|0;l=a+8|0;m=0;do{n=f[b>>2]|0;f[d>>2]=m;o=bf(25520,d|0)|0;p=Md(n|0,o|0)|0;Ae(o|0);j=+pe(p|0,4776,d|0);o=f[d>>2]|0;n=~~j>>>0;q=n;f[e>>2]=f[n>>2];f[g>>2]=f[q+4>>2];n=q+8|0;f[k>>2]=f[n>>2];f[k+4>>2]=f[n+4>>2];f[k+8>>2]=f[n+8>>2];f[k+12>>2]=f[n+12>>2];f[k+16>>2]=f[n+16>>2];Ie(o|0);o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[o>>2]=f[e>>2];f[o+4>>2]=f[g>>2];n=o+8|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];f[n+12>>2]=f[k+12>>2];f[n+16>>2]=f[k+16>>2];f[i>>2]=(f[i>>2]|0)+28}else NA(a,e);Ae(p|0);m=m+1|0}while(m>>>0<h>>>0);u=c;return}function uo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;d=c;e=c+8|0;g=f[b>>2]|0;h=jg(213903)|0;i=Md(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,25520,d|0);Ie(f[d>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=bf(25520,d|0)|0;n=Md(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,5008,d|0);m=f[d>>2]|0;l=~~j>>>0;f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];Ie(m|0);m=f[i>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];f[i>>2]=(f[i>>2]|0)+16}else OA(a,e);Ae(n|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function vo(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=jg(213903)|0;i=Md(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,25520,e|0);Ie(f[e>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=d;return}g=a+8|0;k=0;while(1){l=f[c>>2]|0;f[e>>2]=k;m=bf(25520,e|0)|0;n=Md(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,25456,e|0);Ie(f[e>>2]|0);m=~~j;l=f[i>>2]|0;o=f[g>>2]|0;p=o;if(l>>>0>=o>>>0){o=f[a>>2]|0;q=l-o|0;r=q+1|0;s=o;if((r|0)<0){t=7;break}v=p-o|0;p=v<<1;w=v>>>0<1073741823?(p>>>0<r>>>0?r:p):2147483647;if(!w)x=0;else x=$Xc(w)|0;p=x+q|0;b[p>>0]=m;r=p+(0-q)|0;if((q|0)>0)o1c(r|0,s|0,q|0)|0;f[a>>2]=r;f[i>>2]=p+1;f[g>>2]=x+w;if(o|0)cYc(s)}else{b[l>>0]=m;f[i>>2]=(f[i>>2]|0)+1}Ae(n|0);k=k+1|0;if(k>>>0>=h>>>0){t=3;break}}if((t|0)==3){u=d;return}else if((t|0)==7)kWc(a)}function wo(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;k=u;u=u+128|0;l=k+104|0;m=k+88|0;n=k+64|0;o=k+72|0;p=k+52|0;q=k+20|0;r=k+40|0;s=k+4|0;t=k+24|0;v=k+8|0;w=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=f[b>>2]|0;f[n>>2]=a;le(a|0);to(m,n);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=c;c=f[d>>2]|0;f[q>>2]=c;le(c|0);to(p,q);c=f[e>>2]|0;f[s>>2]=c;le(c|0);uo(r,s);c=t+8|0;f[c>>2]=0;f[c+4>>2]=0;f[t>>2]=50397184;f[t+4>>2]=g;g=f[j>>2]|0;f[w>>2]=g;le(g|0);vo(v,w);ELb(l,m,o,p,r,t,h,i,v,0);i=f[v>>2]|0;if(i|0){h=v+4|0;if((f[h>>2]|0)!=(i|0))f[h>>2]=i;cYc(i)}Ae(f[w>>2]|0);w=f[r>>2]|0;if(w|0){i=r+4|0;r=f[i>>2]|0;if((r|0)!=(w|0))f[i>>2]=r+(~((r+-16-w|0)>>>4)<<4);cYc(w)}Ae(f[s>>2]|0);s=f[p>>2]|0;if(s|0){w=p+4|0;p=f[w>>2]|0;if((p|0)!=(s|0))f[w>>2]=p+(~(((p+-28-s|0)>>>0)/28|0)*28|0);cYc(s)}Ae(f[q>>2]|0);q=f[m>>2]|0;if(!q){x=f[n>>2]|0;Ae(x|0);u=k;return}s=m+4|0;m=f[s>>2]|0;if((m|0)!=(q|0))f[s>>2]=m+(~(((m+-28-q|0)>>>0)/28|0)*28|0);cYc(q);x=f[n>>2]|0;Ae(x|0);u=k;return}function xo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;j=u;u=u+128|0;k=j+104|0;l=j+88|0;m=j+64|0;n=j+72|0;o=j+52|0;p=j+16|0;q=j+40|0;r=j;s=j+24|0;t=j+4|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=f[b>>2]|0;f[m>>2]=a;le(a|0);to(l,m);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=c;c=f[d>>2]|0;f[p>>2]=c;le(c|0);to(o,p);c=f[e>>2]|0;f[r>>2]=c;le(c|0);uo(q,r);c=s+8|0;f[c>>2]=0;f[c+4>>2]=0;f[s>>2]=50397184;f[s+4>>2]=g;f[t>>2]=0;g=t+4|0;f[g>>2]=0;f[t+8>>2]=0;ELb(k,l,n,o,q,s,h,i,t,0);i=f[t>>2]|0;if(i|0){if((f[g>>2]|0)!=(i|0))f[g>>2]=i;cYc(i)}i=f[q>>2]|0;if(i|0){g=q+4|0;q=f[g>>2]|0;if((q|0)!=(i|0))f[g>>2]=q+(~((q+-16-i|0)>>>4)<<4);cYc(i)}Ae(f[r>>2]|0);r=f[o>>2]|0;if(r|0){i=o+4|0;o=f[i>>2]|0;if((o|0)!=(r|0))f[i>>2]=o+(~(((o+-28-r|0)>>>0)/28|0)*28|0);cYc(r)}Ae(f[p>>2]|0);p=f[l>>2]|0;if(!p){v=f[m>>2]|0;Ae(v|0);u=j;return}r=l+4|0;l=f[r>>2]|0;if((l|0)!=(p|0))f[r>>2]=l+(~(((l+-28-p|0)>>>0)/28|0)*28|0);cYc(p);v=f[m>>2]|0;Ae(v|0);u=j;return}function yo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+160|0;j=i+136|0;k=i+120|0;l=i+96|0;m=i+104|0;n=i+84|0;o=i+48|0;q=i+72|0;r=i+32|0;s=i+56|0;t=i;v=i+36|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=f[b>>2]|0;f[l>>2]=a;le(a|0);to(k,l);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=f[d>>2]|0;f[o>>2]=c;le(c|0);to(n,o);c=f[e>>2]|0;f[r>>2]=c;le(c|0);uo(q,r);c=s+8|0;f[c>>2]=0;f[c+4>>2]=0;f[s>>2]=50397184;f[s+4>>2]=g;p[t>>3]=-1.0;p[t+8>>3]=-1.0;p[t+16>>3]=-1.0;p[t+24>>3]=-1.0;f[v>>2]=0;g=v+4|0;f[g>>2]=0;f[v+8>>2]=0;ELb(j,k,m,n,q,s,h,t,v,0);t=f[v>>2]|0;if(t|0){if((f[g>>2]|0)!=(t|0))f[g>>2]=t;cYc(t)}t=f[q>>2]|0;if(t|0){g=q+4|0;q=f[g>>2]|0;if((q|0)!=(t|0))f[g>>2]=q+(~((q+-16-t|0)>>>4)<<4);cYc(t)}Ae(f[r>>2]|0);r=f[n>>2]|0;if(r|0){t=n+4|0;n=f[t>>2]|0;if((n|0)!=(r|0))f[t>>2]=n+(~(((n+-28-r|0)>>>0)/28|0)*28|0);cYc(r)}Ae(f[o>>2]|0);o=f[k>>2]|0;if(!o){w=f[l>>2]|0;Ae(w|0);u=i;return}r=k+4|0;k=f[r>>2]|0;if((k|0)!=(o|0))f[r>>2]=k+(~(((k+-28-o|0)>>>0)/28|0)*28|0);cYc(o);w=f[l>>2]|0;Ae(w|0);u=i;return}function zo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+192|0;i=h+168|0;j=h+152|0;k=h+128|0;l=h+136|0;m=h+116|0;n=h+80|0;o=h+104|0;q=h+76|0;r=h+88|0;s=h+32|0;t=h;v=h+64|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;le(a|0);to(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=f[d>>2]|0;f[n>>2]=c;le(c|0);to(m,n);c=f[e>>2]|0;f[q>>2]=c;le(c|0);uo(o,q);c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=50397184;f[r+4>>2]=g;p[s>>3]=-1.0;p[s+8>>3]=-1.0;p[s+16>>3]=-1.0;p[s+24>>3]=-1.0;p[t>>3]=-1.0;p[t+8>>3]=-1.0;p[t+16>>3]=-1.0;p[t+24>>3]=-1.0;f[v>>2]=0;g=v+4|0;f[g>>2]=0;f[v+8>>2]=0;ELb(i,j,l,m,o,r,s,t,v,0);t=f[v>>2]|0;if(t|0){if((f[g>>2]|0)!=(t|0))f[g>>2]=t;cYc(t)}t=f[o>>2]|0;if(t|0){g=o+4|0;o=f[g>>2]|0;if((o|0)!=(t|0))f[g>>2]=o+(~((o+-16-t|0)>>>4)<<4);cYc(t)}Ae(f[q>>2]|0);q=f[m>>2]|0;if(q|0){t=m+4|0;m=f[t>>2]|0;if((m|0)!=(q|0))f[t>>2]=m+(~(((m+-28-q|0)>>>0)/28|0)*28|0);cYc(q)}Ae(f[n>>2]|0);n=f[j>>2]|0;if(!n){w=f[k>>2]|0;Ae(w|0);u=h;return}q=j+4|0;j=f[q>>2]|0;if((j|0)!=(n|0))f[q>>2]=j+(~(((j+-28-n|0)>>>0)/28|0)*28|0);cYc(n);w=f[k>>2]|0;Ae(w|0);u=h;return}function Ao(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=jM(e,g,h)|0;u=d;return c|0}function Bo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=jM(d,e,fT()|0)|0;u=c;return b|0}function Co(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=m+8|0;f[p>>2]=0;f[p+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a;f[n>>2]=f[b>>2];f[n+4>>2]=f[b+4>>2];f[o>>2]=f[c>>2];f[o+4>>2]=f[c+4>>2];Hra(m,n,o,d,e,g,h,i,j,k);u=l;return}function Do(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=l+8|0;f[o>>2]=0;f[o+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];Hra(l,m,n,d,e,g,h,i,j,0);u=k;return}function Eo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=k+8|0;f[n>>2]=0;f[n+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=f[b>>2];f[l+4>>2]=f[b+4>>2];f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];Hra(k,l,m,d,e,g,h,i,8,0);u=j;return}function Fo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Hra(j,k,l,d,e,g,h,1,8,0);u=i;return}function Go(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;Ira(h,b,c,d,e);u=g;return}function Ho(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;Ira(g,b,c,d,8);u=e;return}function Io(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;Ira(e,b,c,1,8);u=d;return}function Jo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[a>>2];f[j+4>>2]=f[a+4>>2];f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];fra(j,k,c,d,e,g,h);u=i;return}function Ko(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;_oa(d,e);u=c;return}function Lo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];VBa(j,k,l,m,e,g,h);u=i;return}function Mo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;VBa(i,j,k,l,e,g,m);u=h;return}function No(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;VBa(h,i,j,k,e,0,l);u=g;return}function Oo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;VBa(g,h,i,j,1,0,k);u=e;return}function Po(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;VBa(e,g,h,i,1,0,j);u=d;return}function Qo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;OL(d,e);u=c;return}function Ro(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];zja(j,k,c,l,m,g,h);u=i;return}function So(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];zja(i,j,c,k,l,g,4);u=h;return}function To(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];zja(h,i,c,j,k,0.0,4);u=g;return}function Uo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;zja(g,h,c,i,j,0.0,4);u=e;return}function Vo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33882112;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];rEa(i,j,k,d,e,l);u=h;return}function Wo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k>>2]=0;f[k+4>>2]=0;rEa(h,i,j,d,e,k);u=g;return}function Xo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+48|0;l=h+32|0;m=h+16|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;b=l+8|0;f[b>>2]=0;f[b+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];n=+ZVb(j,k,l,d,i,m);u=h;return +n}function Yo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0;g=u;u=u+80|0;h=g+16|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];e=fT()|0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];m=+ZVb(i,j,k,d,h,e);u=g;return +m}function Zo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0;e=u;u=u+80|0;g=e+16|0;h=e+64|0;i=e+48|0;j=e+32|0;k=e;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=c;f[k>>2]=3;f[k+4>>2]=50;p[k+8>>3]=.001;c=fT()|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];l=+ZVb(h,i,j,d,g,c);u=e;return +l}function _o(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0;d=u;u=u+80|0;e=d+16|0;g=d+64|0;h=d+48|0;i=d+32|0;j=d;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=c;f[j>>2]=3;f[j+4>>2]=50;p[j+8>>3]=.001;c=fT()|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];k=+ZVb(g,h,i,2,e,c);u=d;return +k}function $o(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;koa(a,d);u=c;return}function ap(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;gba(i,j,c,d,e,g);u=h;return}function bp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;nR(e,g,c);u=d;return}function cp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=g;AY(j,k,c,l,e,m,h);u=i;return}function dp(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;d=l+8|0;f[d>>2]=0;f[d+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;AY(i,j,c,k,e,l,0);u=h;return}function ep(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;fba(a,e,g);u=d;return}function fp(a){a=a|0;return c1(a)|0}function gp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;eba(a,g,h,d);u=e;return}function hp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;eba(a,e,g,0);u=d;return}function ip(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];bba(a,g,c,d);u=e;return}function jp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];TBa(a,b,g,h);u=e;return}function kp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[g>>2]=-1;f[g+4>>2]=-1;TBa(a,b,e,g);u=d;return}function lp(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;_ja(l,m,c,d,e,n,h,i,j);u=k;return}function mp(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;_ja(k,l,c,d,e,m,h,i,.04);u=j;return}function np(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;_ja(j,k,c,d,e,l,h,0,.04);u=i;return}function op(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;_ja(i,j,c,d,e,k,3,0,.04);u=h;return}function pp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;_ja(h,i,c,d,e,fT()|0,3,0,.04);u=g;return}function qp(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;a=n+8|0;f[a>>2]=0;f[a+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=g;Rja(m,n,c,d,e,o,h,i,j,k);u=l;return}function rp(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;Rja(l,m,c,d,e,n,h,i,j,.04);u=k;return}function sp(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;Rja(k,l,c,d,e,m,h,i,0,.04);u=j;return}function tp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+64|0;k=i+48|0;l=i+16|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=e;sba(j,k,l,m,n,g,h);u=i;return}function up(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+64|0;j=h+48|0;k=h+16|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[k+8>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=e;sba(i,j,k,l,m,g,2);u=h;return}function vp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;IUb(a,b,c,d);return}function wp(a,b,c){a=a|0;b=b|0;c=c|0;IUb(a,b,c,.2);return}function xp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;vV(d,e);u=c;return}function yp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;N1(g,h,i,j);u=e;return}function zp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Pja(e,g,c);u=d;return}function Ap(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;Pja(d,e,-1);u=c;return}function Bp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;Qja(h,i,j,d,e);u=g;return}function Cp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;Qja(g,h,i,d,-1);u=e;return}function Dp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;Qja(e,g,h,-1,-1);u=d;return}function Ep(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+gM(e,g,c);u=d;return +h}function Fp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+gM(d,e,0);u=c;return +g}function Gp(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=Tva(c)|0;u=b;return a|0}function Hp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+32|0;m=i+16|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=h;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];n=+hQ(k,b,l,j,e,g,m);u=i;return +n}function Ip(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0;h=u;u=u+64|0;i=h+16|0;j=h+48|0;k=h+32|0;l=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[l+8>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];d=fT()|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];m=+hQ(j,b,k,i,e,g,d);u=h;return +m}function Jp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];kra(j,k,l,d,e,g,h);u=i;return}function Kp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];kra(i,j,k,d,e,g,0);u=h;return}function Lp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];kra(h,i,j,d,e,8,0);u=g;return}function Mp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];kra(g,h,i,d,1,8,0);u=e;return}function Np(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;PL(d,e);u=c;return}function Op(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;LL(e,g,h);u=d;return}function Pp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0.0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;i=+Tpa(g,h,c,d);u=e;return +i}function Qp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;Fba(h,i,j,d,k);u=g;return}function Rp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;Fba(g,h,i,d,fT()|0);u=e;return}function Sp(a,b,c){a=a|0;b=b|0;c=c|0;C1(a,b,c);return}function Tp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;mL(a,e,g);u=d;return}function Up(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;mL(a,d,fT()|0);u=c;return}function Vp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;nL(g,h,i,j);u=e;return}function Wp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;nL(e,g,h,fT()|0);u=d;return}function Xp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;dpa(e,g,c);u=d;return}function Yp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;TN(d,e);u=c;return}function Zp(a,b,c){a=a|0;b=b|0;c=c|0;D1(a,b,c);return}function _p(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Gba(a,d);u=c;return}function $p(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+4|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50659328;f[g+4>>2]=b;b=f[c>>2]|0;f[i>>2]=b;le(b|0);an(h,i);k1(e,g,h);g=f[h>>2]|0;if(!g){j=f[i>>2]|0;Ae(j|0);u=d;return}e=h+4|0;h=f[e>>2]|0;if((h|0)!=(g|0))f[e>>2]=h+(~((h+-4-g|0)>>>2)<<2);cYc(g);j=f[i>>2]|0;Ae(j|0);u=d;return}function aq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;Nwa(a,e,c);u=d;return}function bq(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Nwa(a,d,0);u=c;return}function cq(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];YBa(k,l,c,m,n,g,h,i);u=j;return}function dq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+96|0;j=i+72|0;k=i+56|0;l=i+40|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=1797693134862315708145274.0e284;p[n+8>>3]=1797693134862315708145274.0e284;p[n+16>>3]=1797693134862315708145274.0e284;p[n+24>>3]=1797693134862315708145274.0e284;YBa(j,k,c,l,m,g,h,n);u=i;return}function eq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;YBa(i,j,c,k,l,g,0,m);u=h;return}function fq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;YBa(h,i,c,j,k,1,0,l);u=g;return}function gq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;YBa(g,h,c,i,j,1,0,k);u=e;return}function hq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;I1(h,i,j,d,e);u=g;return}function iq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;I1(g,h,i,d,-1);u=e;return}function jq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;I1(e,g,h,1.0,-1);u=d;return}function kq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;h=+XN(e,b,g);u=d;return +h}function lq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+XN(d,b,fT()|0);u=c;return +e}function mq(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+XN(c,4,fT()|0);u=b;return +d}function nq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;j=+BO(g,h,c,i);u=e;return +j}function oq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+BO(e,g,c,fT()|0);u=d;return +h}function pq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;g=+BO(d,e,4,fT()|0);u=c;return +g}function qq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;$U(j,k,c,d,e,g,l);u=i;return}function rq(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;$U(i,j,c,d,e,g,fT()|0);u=h;return}function sq(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=b;$U(h,i,c,d,e,-1,fT()|0);u=g;return}function tq(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=b;$U(g,h,c,d,4,-1,fT()|0);u=e;return}function uq(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=b;$U(e,g,c,0.0,4,-1,fT()|0);u=d;return}function vq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;$U(d,e,1.0,0.0,4,-1,fT()|0);u=c;return}function wq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;QY(e,g,h);u=d;return}function xq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+8|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];h=+Dba(e,g,c);u=d;return +h}function yq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;NL(h,i,j,k,e);u=g;return}function zq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;NL(g,h,i,j,0);u=e;return}function Aq(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;QL(e,b,g);u=d;return}function Bq(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+64|0;l=k+40|0;m=k+32|0;n=k;o=l+8|0;f[o>>2]=0;f[o+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];p[n>>3]=+p[g>>3];p[n+8>>3]=+p[g+8>>3];p[n+16>>3]=+p[g+16>>3];p[n+24>>3]=+p[g+24>>3];Jra(l,b,m,d,e,n,h,i,j);u=k;return}function Cq(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+64|0;k=j+40|0;l=j+32|0;m=j;n=k+8|0;f[n>>2]=0;f[n+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];p[m>>3]=+p[g>>3];p[m+8>>3]=+p[g+8>>3];p[m+16>>3]=+p[g+16>>3];p[m+24>>3]=+p[g+24>>3];Jra(k,b,l,d,e,m,h,i,0);u=j;return}function Dq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+32|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];p[l>>3]=+p[g>>3];p[l+8>>3]=+p[g+8>>3];p[l+16>>3]=+p[g+16>>3];p[l+24>>3]=+p[g+24>>3];Jra(j,b,k,d,e,l,h,8,0);u=i;return}function Eq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+40|0;j=h+32|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];p[k>>3]=+p[g>>3];p[k+8>>3]=+p[g+8>>3];p[k+16>>3]=+p[g+16>>3];p[k+24>>3]=+p[g+24>>3];Jra(i,b,j,d,e,k,1,8,0);u=h;return}function Fq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Gpa(g,h,c,d);u=e;return}function Gq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Gpa(e,g,c,4);u=d;return}function Hq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;Gpa(d,e,g,4);u=c;return}function Iq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Mpa(g,h,c,d);u=e;return}function Jq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Mpa(e,g,c,4);u=d;return}function Kq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;Mpa(d,e,g,4);u=c;return}function Lq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;RR(e,g,h);u=d;return}function Mq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;QR(e,g,h);u=d;return}function Nq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Era(j,k,l,d,e,g,h);u=i;return}function Oq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Era(i,j,k,d,e,g,0);u=h;return}function Pq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Era(h,i,j,d,e,8,0);u=g;return}function Qq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Era(g,h,i,d,1,8,0);u=e;return}function Rq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[j+8>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];Fra(i,j,c,d,e,g);u=h;return}function Sq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g;j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];Fra(h,i,c,d,e,0);u=g;return}function Tq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[h+8>>2]=f[b+8>>2];f[h+12>>2]=f[b+12>>2];Fra(g,h,c,d,8,0);u=e;return}function Uq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];Fra(e,g,c,1,8,0);u=d;return}function Vq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;WV(h,i,c,d,e);u=g;return}function Wq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;WV(g,h,c,d,-1);u=e;return}function Xq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;saa(j,k,l,m,e,g,h);u=i;return}function Yq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+80|0;j=h+64|0;k=h+48|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;saa(i,j,k,l,e,g,m);u=h;return}function Zq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+80|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;saa(h,i,j,k,e,0,l);u=g;return}function _q(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;pR(g,b,c,h);u=e;return}function $q(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Zna(i,j,k,d,e,g);u=h;return}function ar(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Zna(h,i,j,d,e,1);u=g;return}function br(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Zna(g,h,i,d,0.0,1);u=e;return}function cr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];Zna(e,g,h,0.0,0.0,1);u=d;return}function dr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+80|0;k=j+56|0;l=j+40|0;m=j+24|0;n=j+8|0;o=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=e;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];Aja(k,l,c,m,n,o,h,i);u=j;return}function er(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+56|0;k=i+40|0;l=i+24|0;m=i+8|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=e;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];Aja(j,k,c,l,m,n,h,4);u=i;return}function fr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+56|0;j=h+40|0;k=h+24|0;l=h+8|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=e;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];Aja(i,j,c,k,l,m,0.0,4);u=h;return}function gr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+56|0;i=g+40|0;j=g+24|0;k=g+8|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;f[l>>2]=-1;f[l+4>>2]=-1;Aja(h,i,c,j,k,l,0.0,4);u=g;return}function hr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=50397184;f[d+4>>2]=a;yV(d,b);u=c;return}function ir(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+48|0;c=b+32|0;d=b;e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=50397184;f[c+4>>2]=a;p[d>>3]=1.0;a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;yV(c,d);u=b;return}function jr(a){a=a|0;PR(a);return}function kr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=pM(g,h,i,d)|0;u=e;return c|0}function lr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=pM(e,g,h,0)|0;u=d;return c|0}function mr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+bM(e,g,c);u=d;return +h}function nr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+bM(d,e,300);u=c;return +g}function or(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=b;kY(d,e);u=c;return}function pr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;YL(d,e);u=c;return}function qr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;G1(h,i,j,k,e);u=g;return}function rr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;G1(g,h,i,j,-1);u=e;return}function sr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;G1(e,g,h,fT()|0,-1);u=d;return}function tr(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0,j=0.0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;j=+_na(h,i,c,d,e);u=g;return +j}function ur(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;zV(a,d);u=c;return}function vr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;BY(e,g,h);u=d;return}function wr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;AV(d,e);u=c;return}function xr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;xV(d,e);u=c;return}function yr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Waa(j,k,l,m,e,g,h);u=i;return}function zr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Waa(i,j,k,l,e,g,m);u=h;return}function Ar(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Waa(h,i,j,k,e,0,l);u=g;return}function Br(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Waa(g,h,i,j,1,0,k);u=e;return}function Cr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];aba(j,k,l,m,e,g,h);u=i;return}function Dr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;aba(i,j,k,l,e,g,m);u=h;return}function Er(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;aba(h,i,j,k,e,0,l);u=g;return}function Fr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;aba(g,h,i,j,1,0,k);u=e;return}function Gr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;bya(d,e);u=c;return}function Hr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;jOa(a,k,c,d,e,g,h,i);u=j;return}function Ir(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;jOa(a,j,c,d,e,g,h,5);u=i;return}function Jr(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;jOa(a,i,c,d,e,g,0,5);u=h;return}function Kr(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;jOa(a,h,c,d,e,0,0,5);u=g;return}function Lr(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0;e=u;u=u+48|0;g=e+32|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;jOa(a,g,c,d,h,0,0,5);u=e;return}function Mr(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;d=u;u=u+64|0;e=d+40|0;g=d+32|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;jOa(a,e,c,g,h,0,0,5);u=d;return}function Nr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+64|0;d=c+40|0;e=c+32|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;jOa(a,d,1.0,e,g,0,0,5);u=c;return}function Or(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wQa(a,b,c,d);return}function Pr(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;wQa(a,c,d,g);if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function Qr(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+12|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;wQa(a,c,e,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function Rr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+20|0;h=e+4|0;i=e+8|0;j=e;k=f[c>>2]|0;f[h>>2]=k;le(k|0);Sr(g,h);k=f[d>>2]|0;f[j>>2]=k;le(k|0);Sr(i,j);xQa(a,b,g,i);b=f[i>>2]|0;if(b|0){a=i+4|0;if((f[a>>2]|0)!=(b|0))f[a>>2]=b;cYc(b)}Ae(f[j>>2]|0);j=f[g>>2]|0;if(!j){l=f[h>>2]|0;Ae(l|0);u=e;return}b=g+4|0;if((f[b>>2]|0)!=(j|0))f[b>>2]=j;cYc(j);l=f[h>>2]|0;Ae(l|0);u=e;return}function Sr(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=jg(213903)|0;i=Md(g|0,h|0)|0;Ae(h|0);j=+pe(i|0,25520,e|0);Ie(f[e>>2]|0);h=~~j>>>0;Ae(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=d;return}g=a+8|0;k=0;while(1){l=f[c>>2]|0;f[e>>2]=k;m=bf(25520,e|0)|0;n=Md(l|0,m|0)|0;Ae(m|0);j=+pe(n|0,25480,e|0);Ie(f[e>>2]|0);m=~~j&255;l=f[i>>2]|0;o=f[g>>2]|0;p=o;if(l>>>0>=o>>>0){o=f[a>>2]|0;q=l-o|0;r=q+1|0;s=o;if((r|0)<0){t=7;break}v=p-o|0;p=v<<1;w=v>>>0<1073741823?(p>>>0<r>>>0?r:p):2147483647;if(!w)x=0;else x=$Xc(w)|0;p=x+q|0;b[p>>0]=m;r=p+(0-q)|0;if((q|0)>0)o1c(r|0,s|0,q|0)|0;f[a>>2]=r;f[i>>2]=p+1;f[g>>2]=x+w;if(o|0)cYc(s)}else{b[l>>0]=m;f[i>>2]=(f[i>>2]|0)+1}Ae(n|0);k=k+1|0;if(k>>>0>=h>>>0){t=3;break}}if((t|0)==3){u=d;return}else if((t|0)==7)kWc(a)}function Tr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d+16|0;g=d;h=d+4|0;i=f[c>>2]|0;f[g>>2]=i;le(i|0);Sr(e,g);f[h>>2]=0;i=h+4|0;f[i>>2]=0;f[h+8>>2]=0;xQa(a,b,e,h);b=f[h>>2]|0;if(b|0){if((f[i>>2]|0)!=(b|0))f[i>>2]=b;cYc(b)}b=f[e>>2]|0;if(!b){j=f[g>>2]|0;Ae(j|0);u=d;return}i=e+4|0;if((f[i>>2]|0)!=(b|0))f[i>>2]=b;cYc(b);j=f[g>>2]|0;Ae(j|0);u=d;return}function Ur(a,b,c){a=a|0;b=b|0;c=c|0;DGa(a,b,c);return}function Vr(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;DGa(a,c,e);if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function Wr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+20|0;g=d+4|0;h=d+8|0;i=d;j=f[b>>2]|0;f[g>>2]=j;le(j|0);Sr(e,g);j=f[c>>2]|0;f[i>>2]=j;le(j|0);Sr(h,i);jHa(a,e,h);a=f[h>>2]|0;if(a|0){j=h+4|0;if((f[j>>2]|0)!=(a|0))f[j>>2]=a;cYc(a)}Ae(f[i>>2]|0);i=f[e>>2]|0;if(!i){k=f[g>>2]|0;Ae(k|0);u=d;return}a=e+4|0;if((f[a>>2]|0)!=(i|0))f[a>>2]=i;cYc(i);k=f[g>>2]|0;Ae(k|0);u=d;return}function Xr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=c+4|0;h=f[b>>2]|0;f[e>>2]=h;le(h|0);Sr(d,e);f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;jHa(a,d,g);a=f[g>>2]|0;if(a|0){if((f[h>>2]|0)!=(a|0))f[h>>2]=a;cYc(a)}a=f[d>>2]|0;if(!a){i=f[e>>2]|0;Ae(i|0);u=c;return}h=d+4|0;if((f[h>>2]|0)!=(a|0))f[h>>2]=a;cYc(a);i=f[e>>2]|0;Ae(i|0);u=c;return}function Yr(a,b,c){a=a|0;b=b|0;c=c|0;xNa(a,b,c);return}function Zr(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;xNa(a,c,e);if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function _r(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+20|0;g=d+4|0;h=d+8|0;i=d;j=f[b>>2]|0;f[g>>2]=j;le(j|0);Sr(e,g);j=f[c>>2]|0;f[i>>2]=j;le(j|0);Sr(h,i);LNa(a,e,h);a=f[h>>2]|0;if(a|0){j=h+4|0;if((f[j>>2]|0)!=(a|0))f[j>>2]=a;cYc(a)}Ae(f[i>>2]|0);i=f[e>>2]|0;if(!i){k=f[g>>2]|0;Ae(k|0);u=d;return}a=e+4|0;if((f[a>>2]|0)!=(i|0))f[a>>2]=i;cYc(i);k=f[g>>2]|0;Ae(k|0);u=d;return}function $r(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=c+4|0;h=f[b>>2]|0;f[e>>2]=h;le(h|0);Sr(d,e);f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;LNa(a,d,g);a=f[g>>2]|0;if(a|0){if((f[h>>2]|0)!=(a|0))f[h>>2]=a;cYc(a)}a=f[d>>2]|0;if(!a){i=f[e>>2]|0;Ae(i|0);u=c;return}h=d+4|0;if((f[h>>2]|0)!=(a|0))f[h>>2]=a;cYc(a);i=f[e>>2]|0;Ae(i|0);u=c;return}function as(a,b){a=a|0;b=b|0;pNa(a,b);return}function bs(a,b,c){a=a|0;b=b|0;c=c|0;lIa(a,b,c);return}function cs(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;lIa(a,c,e);if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function ds(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+20|0;g=d+4|0;h=d+8|0;i=d;j=f[b>>2]|0;f[g>>2]=j;le(j|0);Sr(e,g);j=f[c>>2]|0;f[i>>2]=j;le(j|0);Sr(h,i);BJa(a,e,h);a=f[h>>2]|0;if(a|0){j=h+4|0;if((f[j>>2]|0)!=(a|0))f[j>>2]=a;cYc(a)}Ae(f[i>>2]|0);i=f[e>>2]|0;if(!i){k=f[g>>2]|0;Ae(k|0);u=d;return}a=e+4|0;if((f[a>>2]|0)!=(i|0))f[a>>2]=i;cYc(i);k=f[g>>2]|0;Ae(k|0);u=d;return}function es(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=c+4|0;h=f[b>>2]|0;f[e>>2]=h;le(h|0);Sr(d,e);f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;BJa(a,d,g);a=f[g>>2]|0;if(a|0){if((f[h>>2]|0)!=(a|0))f[h>>2]=a;cYc(a)}a=f[d>>2]|0;if(!a){i=f[e>>2]|0;Ae(i|0);u=c;return}h=d+4|0;if((f[h>>2]|0)!=(a|0))f[h>>2]=a;cYc(a);i=f[e>>2]|0;Ae(i|0);u=c;return}function fs(a,b,c){a=a|0;b=b|0;c=c|0;iMa(a,b,c);return}function gs(a,b){a=a|0;b=b|0;iMa(a,b,1);return}function hs(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+20>>2]&511](a,b,c)|0}function is(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[(f[a>>2]|0)+20>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=hj[g&511](a,c,e)|0;if((b[e+11>>0]|0)>=0){u=d;return h|0}cYc(f[e>>2]|0);u=d;return h|0}function js(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+8>>2]|0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;mi[e&2047](a,d);u=c;return}function ks(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=f[(f[a>>2]|0)+44>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];Yg[p&3](a,m,c,d,e,n,o,i,j,k);u=l;return}function ls(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=f[(f[a>>2]|0)+44>>2]|0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];Yg[o&3](a,l,c,d,e,m,n,i,j,0);u=k;return}function ms(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=f[(f[a>>2]|0)+44>>2]|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];Yg[n&3](a,k,c,d,e,l,m,i,2.0,0);u=j;return}function ns(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=f[(f[a>>2]|0)+44>>2]|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];Yg[m&3](a,j,c,d,e,k,l,1.05,2.0,0);u=i;return}function os(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=f[(f[a>>2]|0)+44>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[k>>2]=0;f[k+4>>2]=0;Yg[l&3](a,i,c,d,e,j,k,1.05,2.0,0);u=h;return}function ps(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=f[(f[a>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Yg[k&3](a,h,c,d,e,i,j,1.05,2.0,0);u=g;return}function qs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=f[(f[a>>2]|0)+44>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;Yg[j&3](a,g,c,d,0.0,h,i,1.05,2.0,0);u=e;return}function rs(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;nQa(a,h,c,d,e);u=g;return}function ss(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+48|0;g=e+32|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;nQa(a,g,c,d,h);u=e;return}function ts(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+48|0;e=d+32|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;nQa(a,e,c,1.0,g);u=d;return}function us(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=c;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;nQa(a,e,g,1.0,h);if((b[g+11>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function vs(a,b,c){a=a|0;b=b|0;c=c|0;fPa(a,b,c);return}function ws(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;fPa(a,c,e);if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function xs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=b;jQa(a,e,c);u=d;return}function ys(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=c;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;jQa(a,e,g);if((b[g+11>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function zs(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e+16|0;h=e+4|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33882112;f[g+4>>2]=c;c=f[d>>2]|0;f[i>>2]=c;le(c|0);As(h,i);kQa(a,g,h);g=f[h>>2]|0;if(!g){k=f[i>>2]|0;Ae(k|0);u=e;return}a=h+4|0;c=f[a>>2]|0;if((c|0)==(g|0))l=g;else{d=c;while(1){c=d+-12|0;f[a>>2]=c;if((b[c+11>>0]|0)<0){cYc(f[c>>2]|0);m=f[a>>2]|0}else m=c;if((m|0)==(g|0))break;else d=m}l=f[h>>2]|0}cYc(l);k=f[i>>2]|0;Ae(k|0);u=e;return}function As(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+32|0;e=d;g=d+12|0;h=d+8|0;i=f[c>>2]|0;j=jg(213903)|0;k=Md(i|0,j|0)|0;Ae(j|0);l=+pe(k|0,25520,e|0);Ie(f[e>>2]|0);j=~~l>>>0;Ae(k|0);f[a>>2]=0;k=a+4|0;f[k>>2]=0;f[a+8>>2]=0;if(!j){u=d;return}i=a+8|0;m=g+11|0;n=0;do{o=f[c>>2]|0;f[e>>2]=n;p=bf(25520,e|0)|0;q=Md(o|0,p|0)|0;f[h>>2]=q;Ae(p|0);PA(g,h);p=f[k>>2]|0;if(p>>>0>=(f[i>>2]|0)>>>0){QA(a,g);if((b[m>>0]|0)<0)cYc(f[g>>2]|0)}else{f[p>>2]=f[g>>2];f[p+4>>2]=f[g+4>>2];f[p+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[k>>2]=(f[k>>2]|0)+12}Ae(f[h>>2]|0);n=n+1|0}while(n>>>0<j>>>0);u=d;return}function Bs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;$h[i&63](a,g,h,d);u=e;return}function Cs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;$h[h&63](a,e,g,-1.0);u=d;return}function Ds(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+36>>2]|0;g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;mi[e&2047](a,d);u=c;return}function Es(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function Fs(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function Gs(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return}function Hs(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;ILb(a,b,c,d,e,f,g);return}function Is(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ILb(a,b,c,d,e,f,1);return}function Js(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ILb(a,b,c,d,e,4,1);return}function Ks(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;ILb(a,b,c,d,4,4,1);return}function Ls(a,b,c){a=a|0;b=b|0;c=c|0;ILb(a,b,c,1.0000000474974513e-03,4,4,1);return}function Ms(a,b){a=a|0;b=b|0;ILb(a,b,0,1.0000000474974513e-03,4,4,1);return}function Ns(a){a=a|0;ILb(a,0,0,1.0000000474974513e-03,4,4,1);return}function Os(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function Ps(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+104>>2]&2047](a,b);return}function Qs(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function Rs(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+80>>2]&31](a,b);return}function Ss(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;MWb(a,b,c,d);return}function Ts(a,b,c){a=a|0;b=b|0;c=+c;MWb(a,b,c,1);return}function Us(a,b){a=a|0;b=b|0;MWb(a,b,16.0,1);return}function Vs(a){a=a|0;MWb(a,500,16.0,1);return}function Ws(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;$h[i&63](a,g,h,d);u=e;return}function Xs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;$h[h&63](a,e,g,-1.0);u=d;return}function Ys(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+44>>2]|0;f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];mi[e&2047](a,d);u=c;return}function Zs(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];Upa(a,b,e);u=d;return}function _s(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=8;f[d+4>>2]=8;Upa(a,b,d);u=c;return}function $s(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=8;f[c+4>>2]=8;Upa(a,40.0,c);u=b;return}function at(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+36>>2]&31](a,b);return}function bt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;Ti[h&511](a,e,g);u=d;return}function ct(a,b,c){a=a|0;b=b|0;c=c|0;yRb(a,b,c);return}function dt(a,b){a=a|0;b=b|0;yRb(a,b,0);return}function et(a){a=a|0;yRb(a,4,0);return}function ft(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function gt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function ht(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=fT()|0;ei[g&511](a,e,c,b);u=d;return}function it(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+36>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=17104896;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function jt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[(f[a>>2]|0)+36>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=b;b=fT()|0;ei[g&511](a,e,c,b);u=d;return}function kt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+40>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function lt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+44>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=17104896;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33882112;f[h+4>>2]=d;ei[i&511](a,g,c,h);u=e;return}function mt(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;l=f[(f[a>>2]|0)+48>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=e;Fh[l&255](a,i,j,d,k,g);u=h;return}function nt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;k=f[(f[a>>2]|0)+48>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=e;Fh[k&255](a,h,i,d,j,0);u=g;return}function ot(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function pt(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function qt(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return}function rt(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;jLb(a,b,c,d,e,f,g);return}function st(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;jLb(a,b,c,d,e,f,.04);return}function tt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;jLb(a,b,c,d,e,0,.04);return}function ut(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;jLb(a,b,c,d,3,0,.04);return}function vt(a,b,c){a=a|0;b=b|0;c=+c;jLb(a,b,c,1.0,3,0,.04);return}function wt(a,b){a=a|0;b=b|0;jLb(a,b,.01,1.0,3,0,.04);return}function xt(a){a=a|0;jLb(a,1e3,.01,1.0,3,0,.04);return}function yt(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;h=+h;SKb(a,b,c,d,e,f,g,h);return}function zt(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+72>>2]&31](a,b);return}function At(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function Bt(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+104>>2]&31](a,b);return}function Ct(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+80>>2]&31](a,b);return}function Dt(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;wRb(a,j,k,d,e,l,h);u=i;return}function Et(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;wRb(a,i,j,d,e,k,0);u=h;return}function Ft(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;wRb(a,h,i,d,e,fT()|0,0);u=g;return}function Gt(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=e;xRb(a,i,c,d,j,g);u=h;return}function Ht(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=e;xRb(a,h,c,d,i,0);u=g;return}function It(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;xRb(a,g,c,d,fT()|0,0);u=e;return}function Jt(a,b){a=a|0;b=b|0;zRb(a,b);return}function Kt(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;uRb(a,j,k,d,e,l,h);u=i;return}function Lt(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;uRb(a,i,j,d,e,k,0);u=h;return}function Mt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;uRb(a,h,i,d,e,fT()|0,0);u=g;return}function Nt(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=e;vRb(a,i,c,d,j,g);u=h;return}function Ot(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=e;vRb(a,h,c,d,i,0);u=g;return}function Pt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;vRb(a,g,c,d,fT()|0,0);u=e;return}function Qt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+32>>2]|0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=b;mi[e&2047](a,d);u=c;return}function Rt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=e;rRb(a,h,i,d,j);u=g;return}function St(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;rRb(a,g,h,d,fT()|0);u=e;return}function Tt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=d;sRb(a,g,c,h);u=e;return}function Ut(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;sRb(a,e,c,fT()|0);u=d;return}function Vt(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function Wt(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Xt(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;bQb(a,b,c,d,e,f,g,h,i,j);return}function Yt(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;bQb(a,b,c,d,e,f,g,h,i,5);return}function Zt(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;bQb(a,b,c,d,e,f,g,h,.003,5);return}function _t(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;bQb(a,b,c,d,e,f,g,1.01,.003,5);return}function $t(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;bQb(a,b,c,d,e,f,200,1.01,.003,5);return}function au(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;bQb(a,b,c,d,e,.2,200,1.01,.003,5);return}function bu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bQb(a,b,c,d,.25,.2,200,1.01,.003,5);return}function cu(a,b,c){a=a|0;b=b|0;c=c|0;bQb(a,b,c,14400,.25,.2,200,1.01,.003,5);return}function du(a,b){a=a|0;b=b|0;bQb(a,b,60,14400,.25,.2,200,1.01,.003,5);return}function eu(a){a=a|0;bQb(a,5,60,14400,.25,.2,200,1.01,.003,5);return}function fu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+84>>2]&2047](a,b);return}function gu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+92>>2]&2047](a,b);return}function hu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[(f[a>>2]|0)+64>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;ei[h&511](a,g,c,d);u=e;return}function iu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+68>>2]&2047](a,b);return}function ju(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function ku(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;JRb(a,b,c,d);return}function lu(a,b,c){a=a|0;b=b|0;c=c|0;JRb(a,b,c,3);return}function mu(a,b){a=a|0;b=b|0;JRb(a,b,1,3);return}function nu(a){a=a|0;JRb(a,10,1,3);return}function ou(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function pu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function qu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function ru(a,b){a=a|0;b=b|0;return VUb(a,b)|0}function su(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];cVb(a,l,c,d,e,g,h,m,n);u=k;return}function tu(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=0;f[m+4>>2]=0;cVb(a,k,c,d,e,g,h,l,m);u=j;return}function uu(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;cVb(a,j,c,d,e,g,h,k,l);u=i;return}function vu(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;cVb(a,i,c,d,e,g,0,j,k);u=h;return}function wu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;cVb(a,h,c,d,e,3,0,i,j);u=g;return}function xu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;cVb(a,g,c,d,1.1,3,0,h,i);u=e;return}function yu(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+32|0;n=m+16|0;o=m+8|0;p=m;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];dVb(a,n,c,d,e,g,h,i,o,p,l);u=m;return}function zu(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];dVb(a,m,c,d,e,g,h,i,n,o,0);u=l;return}function Au(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=0;f[n+4>>2]=0;dVb(a,l,c,d,e,g,h,i,m,n,0);u=k;return}function Bu(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[m>>2]=0;f[m+4>>2]=0;dVb(a,k,c,d,e,g,h,i,l,m,0);u=j;return}function Cu(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;dVb(a,j,c,d,e,g,h,0,k,l,0);u=i;return}function Du(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;dVb(a,i,c,d,e,g,3,0,j,k,0);u=h;return}function Eu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;dVb(a,h,c,d,e,1.1,3,0,i,j,0);u=g;return}function Fu(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];bVb(a,k,c,d,e,g,l,m);u=j;return}function Gu(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=0;f[l+4>>2]=0;bVb(a,j,c,d,e,g,k,l);u=i;return}function Hu(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;bVb(a,i,c,d,e,g,j,k);u=h;return}function Iu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;bVb(a,h,c,d,e,0,i,j);u=g;return}function Ju(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;bVb(a,g,c,d,3,0,h,i);u=e;return}function Ku(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;bVb(a,e,c,1.1,3,0,g,h);u=d;return}function Lu(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function Mu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pLb(a,b,c,d);return}function Nu(a,b,c){a=a|0;b=b|0;c=c|0;pLb(a,b,c,2);return}function Ou(a,b){a=a|0;b=b|0;pLb(a,b,1,2);return}function Pu(a){a=a|0;pLb(a,10,1,2);return}function Qu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function Ru(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function Su(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function Tu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+104>>2]&2047](a,b);return}function Uu(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function Vu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function Wu(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function Xu(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;yNb(a,b,c,d,e,f,g,h);return}function Yu(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;yNb(a,b,c,d,e,f,g,1);return}function Zu(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;yNb(a,b,c,d,e,f,4,1);return}function _u(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;yNb(a,b,c,d,e,4,4,1);return}function $u(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yNb(a,b,c,d,1.0000000474974513e-03,4,4,1);return}function av(a,b,c){a=a|0;b=b|0;c=c|0;yNb(a,b,c,3,1.0000000474974513e-03,4,4,1);return}function bv(a,b){a=a|0;b=b|0;yNb(a,b,0,3,1.0000000474974513e-03,4,4,1);return}function cv(a){a=a|0;yNb(a,5,0,3,1.0000000474974513e-03,4,4,1);return}function dv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function ev(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+88>>2]&31](a,b);return}function fv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function gv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+112>>2]&2047](a,b);return}function hv(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function iv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return}function jv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+96>>2]&2047](a,b);return}function kv(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;sNb(a,b,c,d,e,f,g,h,i,j);return}function lv(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sNb(a,b,c,d,e,f,g,h,i,20);return}function mv(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;sNb(a,b,c,d,e,f,g,h,31,20);return}function nv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;sNb(a,b,c,d,e,f,g,0,31,20);return}function ov(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;sNb(a,b,c,d,e,f,2,0,31,20);return}function pv(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;sNb(a,b,c,d,e,0,2,0,31,20);return}function qv(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;sNb(a,b,c,d,31,0,2,0,31,20);return}function rv(a,b,c){a=a|0;b=b|0;c=+c;sNb(a,b,c,8,31,0,2,0,31,20);return}function sv(a,b){a=a|0;b=b|0;sNb(a,b,1.2000000476837158,8,31,0,2,0,31,20);return}function tv(a){a=a|0;sNb(a,500,1.2000000476837158,8,31,0,2,0,31,20);return}function uv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+64>>2]&2047](a,b);return}function vv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+80>>2]&2047](a,b);return}function wv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+120>>2]&2047](a,b);return}function xv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+104>>2]&2047](a,b);return}function yv(a,b){a=a|0;b=+b;ji[f[(f[a>>2]|0)+72>>2]&31](a,b);return}function zv(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+112>>2]&2047](a,b);return}function Av(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+28>>2]&2047](a,b);return}function Bv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;LMb(a,b,c,d);return}function Cv(a,b,c){a=a|0;b=b|0;c=c|0;LMb(a,b,c,1.0);return}function Dv(a,b){a=a|0;b=b|0;LMb(a,b,3,1.0);return}function Ev(a){a=a|0;LMb(a,30,3,1.0);return}function Fv(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+48|0;i=h+36|0;j=h+20|0;k=h+24|0;l=h+4|0;m=h+8|0;n=h;o=f[b>>2]|0;f[j>>2]=o;le(o|0);bn(i,j);o=f[c>>2]|0;f[l>>2]=o;le(o|0);an(k,l);o=f[g>>2]|0;f[n>>2]=o;le(o|0);an(m,n);QMb(a,i,k,d,e,m);a=f[m>>2]|0;if(a|0){o=m+4|0;m=f[o>>2]|0;if((m|0)!=(a|0))f[o>>2]=m+(~((m+-4-a|0)>>>2)<<2);cYc(a)}Ae(f[n>>2]|0);n=f[k>>2]|0;if(n|0){a=k+4|0;k=f[a>>2]|0;if((k|0)!=(n|0))f[a>>2]=k+(~((k+-4-n|0)>>>2)<<2);cYc(n)}Ae(f[l>>2]|0);l=f[i>>2]|0;if(!l){p=f[j>>2]|0;Ae(p|0);u=h;return}n=i+4|0;i=f[n>>2]|0;if((i|0)!=(l|0))f[n>>2]=i+(~((i+-4-l|0)>>>2)<<2);cYc(l);p=f[j>>2]|0;Ae(p|0);u=h;return}function Gv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+20|0;k=g;l=g+4|0;m=f[b>>2]|0;f[i>>2]=m;le(m|0);bn(h,i);m=f[c>>2]|0;f[k>>2]=m;le(m|0);an(j,k);f[l>>2]=0;m=l+4|0;f[m>>2]=0;f[l+8>>2]=0;QMb(a,h,j,d,e,l);a=f[l>>2]|0;if(a|0){l=f[m>>2]|0;if((l|0)!=(a|0))f[m>>2]=l+(~((l+-4-a|0)>>>2)<<2);cYc(a)}a=f[j>>2]|0;if(a|0){l=j+4|0;j=f[l>>2]|0;if((j|0)!=(a|0))f[l>>2]=j+(~((j+-4-a|0)>>>2)<<2);cYc(a)}Ae(f[k>>2]|0);k=f[h>>2]|0;if(!k){n=f[i>>2]|0;Ae(n|0);u=g;return}a=h+4|0;h=f[a>>2]|0;if((h|0)!=(k|0))f[a>>2]=h+(~((h+-4-k|0)>>>2)<<2);cYc(k);n=f[i>>2]|0;Ae(n|0);u=g;return}function Hv(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+48|0;k=j+36|0;l=j+20|0;m=j+24|0;n=j+4|0;o=j+8|0;p=j;q=f[d>>2]|0;f[l>>2]=q;le(q|0);bn(k,l);q=f[e>>2]|0;f[n>>2]=q;le(q|0);an(m,n);q=f[i>>2]|0;f[p>>2]=q;le(q|0);an(o,p);SMb(a,b,c,k,m,g,h,o);c=f[o>>2]|0;if(c|0){b=o+4|0;o=f[b>>2]|0;if((o|0)!=(c|0))f[b>>2]=o+(~((o+-4-c|0)>>>2)<<2);cYc(c)}Ae(f[p>>2]|0);p=f[m>>2]|0;if(p|0){c=m+4|0;m=f[c>>2]|0;if((m|0)!=(p|0))f[c>>2]=m+(~((m+-4-p|0)>>>2)<<2);cYc(p)}Ae(f[n>>2]|0);n=f[k>>2]|0;if(!n){r=f[l>>2]|0;Ae(r|0);u=j;return}p=k+4|0;k=f[p>>2]|0;if((k|0)!=(n|0))f[p>>2]=k+(~((k+-4-n|0)>>>2)<<2);cYc(n);r=f[l>>2]|0;Ae(r|0);u=j;return}function Iv(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+20|0;m=i;n=i+4|0;o=f[d>>2]|0;f[k>>2]=o;le(o|0);bn(j,k);o=f[e>>2]|0;f[m>>2]=o;le(o|0);an(l,m);f[n>>2]=0;o=n+4|0;f[o>>2]=0;f[n+8>>2]=0;SMb(a,b,c,j,l,g,h,n);c=f[n>>2]|0;if(c|0){n=f[o>>2]|0;if((n|0)!=(c|0))f[o>>2]=n+(~((n+-4-c|0)>>>2)<<2);cYc(c)}c=f[l>>2]|0;if(c|0){n=l+4|0;l=f[n>>2]|0;if((l|0)!=(c|0))f[n>>2]=l+(~((l+-4-c|0)>>>2)<<2);cYc(c)}Ae(f[m>>2]|0);m=f[j>>2]|0;if(!m){p=f[k>>2]|0;Ae(p|0);u=i;return}c=j+4|0;j=f[c>>2]|0;if((j|0)!=(m|0))f[c>>2]=j+(~((j+-4-m|0)>>>2)<<2);cYc(m);p=f[k>>2]|0;Ae(p|0);u=i;return}function Jv(a){a=a|0;var b=0;Pf(268638,7,26988,213923,1,1);Pf(268638,6,27016,213932,1,1);Pf(268638,5,27040,213940,2,1);Pf(198096,7,27060,213947,1,2);Pf(198096,6,27088,213605,2,3);Pf(198103,7,27112,213947,2,3);Pf(198103,6,27140,213605,3,4);Pf(198103,5,27164,213613,6,10);Pf(367297,10,27184,213956,1,1);Pf(367297,9,27224,213968,1,1);Pf(367297,8,27260,213979,1,1);Pf(367297,7,27292,213989,1,1);Pf(367297,6,26244,213605,4,5);Pf(198116,10,27320,213998,1,1);Pf(198116,9,27360,214010,1,1);Pf(198116,8,27396,214021,1,1);Pf(198116,7,27428,214031,1,1);Pf(198116,6,27016,213932,1,2);Pf(198127,8,27396,214021,1,2);Pf(198127,7,27428,214031,1,2);Pf(198127,6,27016,213932,1,3);Pf(198139,8,27456,214040,1,3);Pf(198139,7,27488,214050,1,5);Pf(198139,6,27516,214059,1,7);Pf(198139,5,27540,213620,83,218);Pf(198139,4,26268,212010,219,317);Pf(198149,9,27560,214067,1,2);Pf(198149,8,27596,214078,1,2);Pf(198149,7,27628,214088,1,2);Pf(198149,6,27656,214097,123,84);Pf(198156,10,27680,214105,1,2);Pf(198156,9,27720,214117,1,2);Pf(198156,8,27756,214128,1,2);Pf(198156,7,27788,214138,64,124);Pf(198156,6,27656,214097,123,85);Pf(198162,4,27816,212010,220,318);Pf(267612,8,27832,214147,1,1);Pf(465617,6,27864,214097,125,86);Pf(465617,5,27888,213620,87,221);Pf(465617,4,27816,212010,220,319);Pf(198170,8,27908,214157,1,1);Pf(198170,7,27940,214167,1,1);Pf(274191,5,27968,214176,1,7);Pf(268017,3,27988,213639,14,16);Pf(278077,7,28e3,213947,4,4);Pf(278077,6,26244,213605,4,6);Pf(198182,5,27888,213620,87,222);Pf(198182,4,27816,212010,220,320);Pf(198194,4,26392,212010,223,321);Pf(198194,3,26380,212005,322,1144);Pf(198206,5,27888,213620,87,224);Pf(198206,4,27816,212010,220,323);Pf(198217,5,27888,213620,87,225);Pf(198217,4,27816,212010,220,324);Pf(198229,6,28028,214097,126,88);Pf(198229,5,28052,213620,89,226);Pf(198229,4,28072,212010,227,325);Pf(198234,2,28088,212016,555,1145);Pf(198247,8,28096,214183,151,65);Pf(198247,7,28128,214138,66,127);Pf(198247,6,28156,214097,128,90);Pf(198247,5,28180,213620,91,228);Pf(269637,7,28200,214088,3,3);Pf(269025,8,28228,214183,152,67);Pf(269025,7,28260,214138,68,129);Pf(198257,11,28288,214193,1,1);Pf(198282,12,28332,214206,1,1);Pf(198282,11,28380,214220,1,2);Pf(198282,10,28424,214233,3,93);Pf(198282,9,28464,214245,94,153);Pf(198282,8,28500,214183,154,69);Pf(198282,7,28532,214138,70,130);Pf(218275,6,28560,214097,131,92);Pf(218275,5,28584,213620,93,229);Pf(273566,8,28604,214183,155,71);Pf(273566,7,28636,214138,72,132);Pf(273566,6,28664,214097,133,94);Pf(273566,5,28688,213620,95,230);Pf(241245,5,28708,213620,96,231);Pf(269866,4,28728,213669,5,15);Pf(354201,5,28744,213373,102,70);Pf(354201,4,28764,212044,71,286);Pf(354201,3,28780,212039,287,556);Pf(355059,7,28792,214256,7,71);Pf(355059,6,28820,213380,72,103);Pf(355059,5,28844,213373,104,72);Pf(268080,3,27988,213639,14,17);Pf(268080,2,28864,213697,18,23);Pf(234380,5,27040,213940,2,2);Pf(234380,4,28872,212382,11,26);Pf(234380,3,26380,212005,322,1146);Pf(353888,5,28888,213620,97,232);Pf(353888,4,28908,212010,233,326);Pf(353888,3,26380,212005,322,1147);Pf(354058,4,27816,212010,220,327);Pf(229988,9,28924,214245,95,156);Pf(229988,8,28960,214183,157,73);Pf(198303,7,28992,214265,1,2);Pf(198303,6,27516,214059,1,8);Pf(198316,6,27656,214097,123,98);Pf(198316,5,27540,213620,83,234);Pf(198316,4,26268,212010,219,328);Pf(228160,2,29020,212016,557,980);Pf(271925,5,27540,213620,83,235);Pf(271925,4,26268,212010,219,329);Pf(270646,5,27540,213620,83,236);Pf(270646,4,26268,212010,219,330);Pf(218807,2,28864,213697,18,24);Pf(239965,5,27540,213620,83,237);Pf(239965,4,26268,212010,219,331);Pf(239965,3,26380,212005,322,1148);Pf(198334,8,29028,214183,158,74);Pf(198334,7,29060,214138,75,134);Pf(198334,6,29088,214097,135,99);Pf(198334,5,29112,213620,100,238);Pf(198334,4,26392,212010,223,332);Pf(369223,6,27656,214097,123,101);Pf(369223,5,27540,213620,83,239);Pf(198341,7,29132,214138,76,136);Pf(198341,6,29160,214097,137,102);Pf(198369,6,29184,214274,3,2);Pf(198369,5,29208,213613,9,12);Pf(198369,4,27816,212010,220,333);Pf(198376,5,29228,214282,1,1);Pf(198376,4,29248,214289,4,1);Pf(273828,10,29264,214233,4,96);Pf(273828,9,29304,214245,97,159);Pf(273828,8,29340,214183,160,77);Pf(273828,7,29372,214138,78,138);Pf(273828,6,29400,214097,139,103);Pf(273828,5,29424,213620,104,240);Pf(461167,11,29444,214220,2,5);Pf(461167,10,29488,214233,6,98);Pf(461167,9,29528,214245,99,161);Pf(461167,8,29564,214183,162,79);Pf(461167,7,29596,214138,80,140);Pf(219063,4,29624,212044,73,288);Pf(219063,3,29640,212039,289,558);Pf(273674,11,29652,214319,1,1);Pf(273674,10,29696,214332,1,1);Pf(273674,9,29736,214344,1,1);Pf(273674,8,29772,214355,1,1);Pf(198384,6,29804,214097,141,105);Pf(198384,5,29828,213620,106,241);Pf(198384,4,29848,212010,242,334);Pf(198393,8,29864,214183,163,81);Pf(269960,3,26380,212005,322,1149);Pf(198406,8,29028,214183,158,82);Pf(198406,7,29060,214138,75,142);Pf(198406,6,29088,214097,135,107);Pf(198406,5,29112,213620,100,243);Pf(198406,4,26392,212010,223,335);Pf(218415,3,26380,212005,322,1150);Pf(198412,8,29896,214365,1,2);Pf(198412,7,29928,214088,4,4);Pf(198412,6,29956,214097,143,108);Pf(198412,5,29980,213620,109,244);Pf(368963,7,3e4,214138,83,144);Pf(368963,6,30028,214097,145,110);Pf(471163,7,30052,214375,1,1);Pf(471163,6,30080,214384,2,3);Pf(471163,5,30104,213662,4,6);Pf(471163,4,30124,213669,7,16);Pf(268139,2,30140,212016,559,1151);Pf(252617,7,27292,213989,1,2);Pf(229799,4,26268,212010,219,336);Pf(236053,8,30148,214392,1,1);Pf(236053,7,30180,214402,1,1);Pf(252567,3,30208,212039,290,337);Pf(198421,2,26960,212016,547,981);Pf(252476,4,30220,212044,74,245);Pf(252476,3,30208,212039,290,338);Pf(198439,4,30236,214411,1,3);Pf(364209,4,30252,212044,75,246);Pf(364209,3,30268,212039,291,339);Pf(264223,10,30280,214417,1,1);Pf(264223,9,30320,214429,1,1);Pf(264223,8,30356,214440,1,2);Pf(264223,7,30388,213947,5,5);Pf(264223,6,26244,213605,4,7);Pf(198459,11,30416,214450,1,1);Pf(198459,10,30460,214463,1,1);Pf(198459,9,30500,214429,2,2);Pf(253119,8,30536,214183,164,84);Pf(253119,7,30568,214138,85,146);Pf(470500,5,30596,213613,10,13);Pf(470500,4,30616,212010,247,340);Pf(234933,3,30632,212005,341,1152);Pf(241439,5,30644,213620,111,248);Pf(264084,4,26268,212010,219,342);Pf(264084,3,26380,212005,322,1153);Pf(198480,6,29160,214097,137,112);Pf(198480,5,30664,213620,113,249);Pf(198480,4,30684,212010,250,343);Pf(218979,4,30700,213669,8,17);Pf(218979,3,30716,213639,18,19);Pf(354147,2,30728,212016,560,982);Pf(228570,8,30736,214475,1,2);Pf(228570,7,30768,214375,3,3);Pf(273324,8,30796,214183,165,86);Pf(273324,7,30828,214138,87,147);Pf(273324,6,30856,214097,148,114);Pf(273324,5,30880,213620,115,251);Pf(218419,3,26380,212005,322,1154);Pf(218117,4,27816,212010,220,344);Pf(271960,5,30900,214485,1,1);Pf(254230,6,30920,214097,149,116);Pf(254230,5,28708,213620,96,252);Pf(443327,4,27816,212010,220,345);Pf(217505,3,30944,212039,292,346);Pf(217505,2,30956,212016,561,1155);Pf(217576,5,30964,213620,117,253);Pf(217576,4,30684,212010,250,347);Pf(270071,4,26268,212010,219,348);Pf(226724,3,30632,212005,341,1156);Pf(198490,4,27816,212010,220,349);Pf(198494,2,30140,212016,559,1157);Pf(240147,4,30984,212010,254,350);Pf(355692,3,31e3,212039,293,351);Pf(355692,2,31012,212016,562,1158);Pf(364231,9,31020,214245,100,166);Pf(364231,8,31056,214183,167,88);Pf(364231,7,31088,214138,89,150);Pf(364231,6,29956,214097,143,118);Pf(364231,5,29980,213620,109,255);Pf(198506,6,29184,214274,3,3);Pf(198506,5,29208,213613,9,14);Pf(198506,4,27816,212010,220,352);Pf(227820,4,31116,213669,9,19);Pf(227820,3,31132,213639,20,20);Pf(227820,2,28864,213697,18,25);Pf(198515,5,31144,213662,5,10);Pf(198515,4,28728,213669,5,21);Pf(198515,3,26436,213639,22,21);Pf(234501,8,31164,214492,3,1);Pf(234501,7,31196,213923,3,2);Pf(234501,6,27016,213932,1,4);Pf(234501,5,27040,213940,2,4);Pf(234501,4,28872,212382,11,27);Pf(234501,3,26380,212005,322,1159);Pf(236549,4,26392,212010,223,353);Pf(253742,4,31224,213669,11,23);Pf(218365,6,28560,214097,131,119);Pf(218365,5,28584,213620,93,256);Pf(387326,4,31240,214502,8,7);Pf(198521,10,31256,214508,1,2);Pf(198521,9,31296,214520,1,2);Pf(198521,8,31332,214531,2,1);Pf(198521,7,31364,214265,3,4);Pf(271473,5,31392,213620,120,257);Pf(271473,4,31412,212010,258,354);Pf(271473,3,26380,212005,322,1160);Pf(271722,5,31392,213620,120,259);Pf(271722,4,31412,212010,258,355);Pf(271722,3,26380,212005,322,1161);Pf(198529,4,31428,212010,260,356);Pf(198535,4,31428,212010,260,357);Pf(273479,8,30796,214183,165,90);Pf(273479,7,30828,214138,87,151);Pf(273479,6,30856,214097,148,121);Pf(273479,5,30880,213620,115,261);Pf(198541,7,31444,214138,91,152);Pf(198541,6,31472,214097,153,122);Pf(198541,5,31496,213620,123,262);Pf(198541,4,31516,212010,263,358);Pf(235305,6,27656,214097,123,124);Pf(235305,5,27540,213620,83,264);Pf(251689,8,31532,214183,168,92);Pf(251689,7,31564,214138,93,154);Pf(251689,6,31592,214097,155,125);Pf(229835,5,31616,213620,126,265);Pf(264464,7,27112,213947,2,6);Pf(264464,6,27140,213605,3,8);Pf(264464,5,27164,213613,6,15);Pf(264464,4,28072,212010,227,359);Pf(264072,9,31636,214541,1,2);Pf(264072,8,31672,214128,2,5);Pf(264072,7,31704,214138,94,156);Pf(264072,6,31732,214097,157,127);Pf(235124,3,26496,212005,360,1162);Pf(235124,2,31756,214552,1163,2175);Pf(198552,2,31764,214552,1164,2176);Pf(219405,5,31772,213373,105,76);Pf(219405,4,31792,212044,77,294);Pf(218758,4,30700,213669,8,24);Pf(218758,3,30716,213639,18,22);Pf(375209,3,31808,212005,361,1165);Pf(198563,3,26380,212005,322,1166);Pf(198568,6,27864,214097,125,128);Pf(198568,5,27888,213620,87,266);Pf(198568,4,27816,212010,220,362);Pf(470916,6,31820,214556,1,1);Pf(235136,2,30956,212016,561,1167);Pf(236521,4,26392,212010,223,363);Pf(235172,3,26380,212005,322,1168);Pf(235101,3,30632,212005,341,1169);Pf(252152,8,31844,214183,169,95);Pf(252152,7,31876,214138,96,158);Pf(252152,6,31904,214097,159,129);Pf(252152,5,31928,213620,130,267);Pf(252316,8,31844,214183,169,97);Pf(252316,7,31876,214138,96,160);Pf(252316,6,31904,214097,159,131);Pf(252316,5,31928,213620,130,268);Pf(358599,3,26380,212005,322,1170);Pf(198577,8,31948,214564,1,1);Pf(198577,7,31980,214574,1,1);Pf(198577,6,32008,214583,1,1);Pf(198577,5,32032,214591,1,1);Pf(198577,4,32052,214598,1,9);Pf(198577,3,32068,214604,1,28);Pf(198577,2,26476,212016,563,1171);Pf(396343,4,32080,212044,78,269);Pf(396343,3,32096,212039,295,364);Pf(396343,2,32108,212016,564,1172);Pf(198591,4,32116,212044,79,270);Pf(198591,3,32132,212039,296,365);Pf(198600,3,32096,212039,295,366);Pf(198600,2,32108,212016,564,1173);Pf(198617,3,32144,212039,297,367);Pf(198617,2,32156,212016,565,1174);Pf(391052,3,32096,212039,295,368);Pf(391052,2,32108,212016,564,1175);Pf(198635,3,32144,212039,297,369);Pf(198635,2,32156,212016,565,1176);Pf(198655,2,32108,212016,564,1177);Pf(198671,3,32096,212039,295,370);Pf(198671,2,32108,212016,564,1178);Pf(198693,3,32144,212039,297,371);Pf(198693,2,32156,212016,565,1179);Pf(198716,3,32164,212039,298,372);Pf(198716,2,32108,212016,564,1180);Ce(20440,5032,5048,0,211997,983,212e3,0,212e3,0,198733,212002,2177);a=$Xc(4)|0;f[a>>2]=299;ff(20440,198747,4,32176,212044,80,a|0,0);a=$Xc(4)|0;f[a>>2]=566;ff(20440,198747,3,32192,212039,300,a|0,0);ae(20440,1,32204,211997,984,24);ae(20440,13,32208,214724,1,1);ae(20440,2,32260,212016,567,985);Yf(20440,198752,1,32268,211997,986,2178);Yf(20440,198777,1,32268,211997,986,2179);a=$Xc(4)|0;f[a>>2]=1181;ff(20440,470831,3,32272,212005,373,a|0,0);a=$Xc(4)|0;f[a>>2]=2;ff(20440,468976,11,32284,214739,1,a|0,0);a=$Xc(4)|0;f[a>>2]=1;ff(20440,468976,10,32328,214752,1,a|0,0);a=$Xc(4)|0;f[a>>2]=1;ff(20440,468976,9,32368,214764,1,a|0,0);a=$Xc(4)|0;f[a>>2]=2;ff(20440,468976,8,32404,214531,3,a|0,0);a=$Xc(4)|0;f[a>>2]=5;ff(20440,468976,7,32436,214265,4,a|0,0);a=$Xc(4)|0;f[a>>2]=11;ff(20440,468976,6,32464,214059,5,a|0,0);a=$Xc(4)|0;f[a>>2]=271;ff(20440,468976,5,32488,213620,132,a|0,0);a=$Xc(4)|0;f[a>>2]=4;b=$Xc(4)|0;f[b>>2]=4;we(20440,470635,4816,212016,568,a|0,4816,212005,374,b|0);b=$Xc(4)|0;f[b>>2]=12;a=$Xc(4)|0;f[a>>2]=12;we(20440,470643,4816,212016,568,b|0,4816,212005,374,a|0);a=$Xc(4)|0;f[a>>2]=20;b=$Xc(4)|0;f[b>>2]=20;we(20440,470653,4816,212016,568,a|0,4816,212005,374,b|0);b=$Xc(4)|0;f[b>>2]=28;a=$Xc(4)|0;f[a>>2]=28;we(20440,470793,4816,212016,568,b|0,4816,212005,374,a|0);a=$Xc(4)|0;f[a>>2]=36;b=$Xc(4)|0;f[b>>2]=36;we(20440,470665,25512,212016,569,a|0,25512,212005,375,b|0);b=$Xc(4)|0;f[b>>2]=40;a=$Xc(4)|0;f[a>>2]=40;we(20440,470671,25512,212016,569,b|0,25512,212005,375,a|0);a=$Xc(4)|0;f[a>>2]=48;b=$Xc(4)|0;f[b>>2]=48;we(20440,470802,25552,213697,23,a|0,25552,212377,29,b|0);b=$Xc(4)|0;f[b>>2]=56;a=$Xc(4)|0;f[a>>2]=56;we(20440,470685,25520,212016,570,b|0,25520,212005,376,a|0);a=$Xc(4)|0;f[a>>2]=64;b=$Xc(4)|0;f[b>>2]=64;we(20440,470703,25552,213697,23,a|0,25552,212377,29,b|0);b=$Xc(4)|0;f[b>>2]=72;a=$Xc(4)|0;f[a>>2]=72;we(20440,470718,25448,212016,571,b|0,25448,212005,377,a|0);a=$Xc(4)|0;f[a>>2]=76;b=$Xc(4)|0;f[b>>2]=76;we(20440,198802,4304,212016,572,a|0,4304,212005,378,b|0);b=$Xc(4)|0;f[b>>2]=140;a=$Xc(4)|0;f[a>>2]=140;we(20440,470734,25512,212016,569,b|0,25512,212005,375,a|0);a=$Xc(4)|0;f[a>>2]=144;b=$Xc(4)|0;f[b>>2]=144;we(20440,470742,25448,212016,571,a|0,25448,212005,377,b|0);Ce(5024,5072,5088,0,211997,987,212e3,0,212e3,0,198814,212002,2180);b=$Xc(4)|0;f[b>>2]=4;ff(5024,396150,6,32508,214274,6,b|0,0);b=$Xc(4)|0;f[b>>2]=16;ff(5024,396150,5,32532,213613,12,b|0,0);b=$Xc(4)|0;f[b>>2]=379;ff(5024,396150,4,32552,212010,272,b|0,0);b=$Xc(4)|0;f[b>>2]=1182;ff(5024,396150,3,32568,212005,380,b|0,0);b=$Xc(4)|0;f[b>>2]=381;ff(5024,456135,3,32580,212039,301,b|0,0);b=$Xc(4)|0;f[b>>2]=1183;ff(5024,456135,2,32592,212016,573,b|0,0);b=$Xc(4)|0;f[b>>2]=382;ff(5024,198822,4,32600,212010,273,b|0,0);b=$Xc(4)|0;f[b>>2]=1184;ff(5024,198822,3,32616,212005,383,b|0,0);b=$Xc(4)|0;f[b>>2]=384;ff(5024,198831,4,32628,212010,274,b|0,0);Ce(5104,5120,5136,6976,211997,988,211997,989,211997,990,198840,212002,2181);b=$Xc(4)|0;f[b>>2]=17;ff(5104,473123,5,32644,213613,13,b|0,0);b=$Xc(4)|0;f[b>>2]=385;ff(5104,473123,4,32664,212010,275,b|0,0);b=$Xc(4)|0;f[b>>2]=1185;ff(5104,473009,3,32680,212005,386,b|0,0);Ce(19504,5152,5168,20168,211997,991,211997,992,211997,993,198861,212002,2182);b=$Xc(4)|0;f[b>>2]=1186;ff(19504,198866,3,32692,212005,387,b|0,0);b=$Xc(4)|0;f[b>>2]=1187;ff(19504,198878,3,32704,212005,388,b|0,0);b=$Xc(8)|0;f[b>>2]=92;f[b+4>>2]=1;ff(19504,198895,2,32716,212016,574,b|0,1);b=$Xc(8)|0;f[b>>2]=100;f[b+4>>2]=1;ff(19504,198907,2,32716,212016,574,b|0,1);b=$Xc(4)|0;f[b>>2]=1188;ff(19504,198924,3,32704,212005,388,b|0,0);b=$Xc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19504,198936,2,32724,212016,575,b|0,1);ae(19504,7,32732,215032,1,2);ae(19504,6,32760,215041,1,3);ae(19504,5,32784,215049,1,5);ae(19504,4,32804,212216,4,18);ae(19504,3,32820,212039,302,389);ae(19504,2,32832,212016,576,1189);ae(19504,1,32840,211997,994,2183);b=$Xc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19504,198947,2,32724,212016,575,b|0,1);b=$Xc(4)|0;f[b>>2]=1190;ff(19504,198959,3,32692,212005,387,b|0,0);b=$Xc(4)|0;f[b>>2]=1191;ff(19504,198970,3,32844,212005,390,b|0,0);b=$Xc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19504,198985,2,32856,213697,24,b|0,1);b=$Xc(4)|0;f[b>>2]=1192;ff(19504,198998,2,32864,212016,577,b|0,0);b=$Xc(8)|0;f[b>>2]=108;f[b+4>>2]=1;ff(19504,199013,2,32872,212016,578,b|0,1);b=$Xc(4)|0;f[b>>2]=19;ff(19504,199028,3,32880,212377,30,b|0,0);Of(5192,19504,199041,0,211997,995,213675,25,211997,996,212002,2184);Ce(5216,5232,5248,5104,211997,997,211997,998,211997,999,199051,212002,2185);ae(5216,4,32892,214598,2,10);ae(5216,3,32908,214604,2,31);ae(5216,2,32920,212016,579,1193);ae(5216,1,32928,211997,1e3,2186);b=$Xc(4)|0;f[b>>2]=19;ff(5216,473123,5,32932,213613,14,b|0,0);b=$Xc(4)|0;f[b>>2]=391;ff(5216,473123,4,32952,212010,276,b|0,0);Of(5272,5216,199076,0,211997,1001,213675,26,211997,1002,212002,2187);Ce(5288,5304,5320,6976,211997,1003,211997,1004,211997,1005,199106,212002,2188);b=$Xc(4)|0;f[b>>2]=1194;ff(5288,199112,3,32968,212005,392,b|0,0);ae(5288,3,32980,215346,1,8);ae(5288,2,32992,215351,1,20);ae(5288,1,33e3,211997,1006,2189);b=$Xc(8)|0;f[b>>2]=52;f[b+4>>2]=1;ff(5288,199129,2,33004,214552,1195,b|0,1);b=$Xc(4)|0;f[b>>2]=21;ff(5288,199144,3,33012,212377,32,b|0,0);b=$Xc(8)|0;f[b>>2]=48;f[b+4>>2]=1;ff(5288,199157,2,33024,212016,580,b|0,1);b=$Xc(8)|0;f[b>>2]=40;f[b+4>>2]=1;ff(5288,199174,2,33032,213697,25,b|0,1);b=$Xc(4)|0;f[b>>2]=393;ff(5288,473123,4,33040,212010,277,b|0,0);Of(5344,5288,199187,0,211997,1007,213675,27,211997,1008,212002,2190);Ce(19992,5360,5376,19976,211997,1009,211997,1010,211997,1011,199198,212002,2191);ae(19992,3,33056,212039,303,394);ae(19992,2,33068,212016,581,1196);ae(19992,1,33076,211997,1012,2192);Of(5400,19992,199208,0,211997,1013,213675,28,211997,1014,212002,2193);Ce(6976,5416,5432,0,211997,1015,212e3,0,212e3,0,199223,212002,2194);Ce(20168,5448,5464,6976,211997,1016,211997,1017,211997,1018,467737,212002,2195);b=$Xc(4)|0;f[b>>2]=1197;ff(20168,198998,2,33080,212016,582,b|0,0);b=$Xc(4)|0;f[b>>2]=278;ff(20168,470600,5,33088,213620,133,b|0,0);b=$Xc(4)|0;f[b>>2]=395;ff(20168,470600,4,33108,212010,279,b|0,0);b=$Xc(4)|0;f[b>>2]=280;ff(20168,199233,5,33124,213620,134,b|0,0);b=$Xc(4)|0;f[b>>2]=396;ff(20168,199233,4,33144,212010,281,b|0,0);b=$Xc(4)|0;f[b>>2]=282;ff(20168,467648,5,33160,213620,135,b|0,0);b=$Xc(4)|0;f[b>>2]=283;ff(20168,199241,5,33180,213620,136,b|0,0);b=$Xc(8)|0;f[b>>2]=60;f[b+4>>2]=1;ff(20168,199250,2,33200,212016,583,b|0,0);b=$Xc(4)|0;f[b>>2]=161;ff(20168,467518,7,33208,214138,98,b|0,0);b=$Xc(4)|0;f[b>>2]=137;ff(20168,467518,6,33236,214097,162,b|0,0);b=$Xc(8)|0;f[b>>2]=52;f[b+4>>2]=1;ff(20168,199262,2,33200,212016,583,b|0,0);b=$Xc(8)|0;f[b>>2]=56;f[b+4>>2]=1;ff(20168,199277,2,33200,212016,583,b|0,0);b=$Xc(8)|0;f[b>>2]=20;f[b+4>>2]=1;ff(20168,231201,2,33260,212016,584,b|0,0);Ce(19408,5528,5544,20168,211997,1019,211997,1020,211997,1021,199292,212002,2196);b=$Xc(8)|0;f[b>>2]=92;f[b+4>>2]=1;ff(19408,199305,2,33268,212016,585,b|0,1);b=$Xc(4)|0;f[b>>2]=1198;ff(19408,198998,2,33276,212016,586,b|0,0);b=$Xc(8)|0;f[b>>2]=108;f[b+4>>2]=1;ff(19408,199318,2,33284,213697,26,b|0,1);b=$Xc(4)|0;f[b>>2]=1199;ff(19408,199323,3,33292,212005,397,b|0,0);b=$Xc(4)|0;f[b>>2]=1200;ff(19408,199341,3,33304,212005,398,b|0,0);ae(19408,7,33316,215789,1,1);ae(19408,6,33344,215798,1,3);ae(19408,5,33368,215806,1,5);ae(19408,4,33388,214411,2,5);ae(19408,3,33404,214604,3,33);ae(19408,2,33416,212016,587,1201);ae(19408,1,33424,211997,1022,2197);ae(19408,8,33428,215813,1,1);b=$Xc(4)|0;f[b>>2]=22;ff(19408,199354,3,33460,212377,34,b|0,0);b=$Xc(4)|0;f[b>>2]=1202;ff(19408,199370,3,33304,212005,398,b|0,0);b=$Xc(4)|0;f[b>>2]=23;ff(19408,199385,3,33460,212377,34,b|0,0);b=$Xc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19408,199390,2,33268,212016,585,b|0,1);b=$Xc(4)|0;f[b>>2]=24;ff(19408,199405,3,33460,212377,34,b|0,0);b=$Xc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19408,199420,2,33284,213697,26,b|0,1);b=$Xc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19408,199435,2,33284,213697,26,b|0,1);b=$Xc(8)|0;f[b>>2]=100;f[b+4>>2]=1;ff(19408,199451,2,33472,212016,588,b|0,1);Of(5568,19408,199469,0,211997,1023,213675,29,211997,1024,212002,2198);Ce(19976,5584,5600,6976,211997,1025,211997,1026,211997,1027,199487,212002,2199);b=$Xc(4)|0;f[b>>2]=3;ff(19976,467115,8,33480,216022,4,b|0,0);b=$Xc(4)|0;f[b>>2]=7;ff(19976,467115,7,33512,216032,5,b|0,0);b=$Xc(4)|0;f[b>>2]=15;ff(19976,467115,6,33540,216041,6,b|0,0);b=$Xc(4)|0;f[b>>2]=4;ff(19976,199505,7,33564,216049,4,b|0,0);b=$Xc(4)|0;f[b>>2]=6;ff(19976,199505,6,33592,216058,8,b|0,0);b=$Xc(4)|0;f[b>>2]=20;ff(19976,199505,5,33616,216066,16,b|0,0);ae(19976,2,33636,212016,589,1203);b=$Xc(8)|0;f[b>>2]=8;f[b+4>>2]=1;ff(19976,233015,2,33644,214552,1204,b|0,0);b=$Xc(4)|0;f[b>>2]=99;ff(19976,467054,8,33652,214183,170,b|0,0);b=$Xc(4)|0;f[b>>2]=163;ff(19976,467054,7,33684,214138,100,b|0,0);b=$Xc(4)|0;f[b>>2]=138;ff(19976,467054,6,33712,214097,164,b|0,0);b=$Xc(4)|0;f[b>>2]=165;ff(19976,199518,7,33736,214138,101,b|0,0);b=$Xc(4)|0;f[b>>2]=139;ff(19976,199518,6,33764,214097,166,b|0,0);b=$Xc(4)|0;f[b>>2]=284;ff(19976,199518,5,33788,213620,140,b|0,0);b=$Xc(4)|0;f[b>>2]=1205;ff(19976,465617,3,33808,212005,399,b|0,0);b=$Xc(8)|0;f[b>>2]=40;f[b+4>>2]=1;ff(19976,466283,2,33644,214552,1204,b|0,0);b=$Xc(4)|0;f[b>>2]=141;ff(19976,199528,6,33820,214097,167,b|0,0);b=$Xc(4)|0;f[b>>2]=285;ff(19976,199528,5,33844,213620,142,b|0,0);b=$Xc(4)|0;f[b>>2]=286;ff(19976,199534,5,33864,213620,143,b|0,0);b=$Xc(4)|0;f[b>>2]=400;ff(19976,199534,4,33884,212010,287,b|0,0);b=$Xc(8)|0;f[b>>2]=36;f[b+4>>2]=1;ff(19976,199541,2,33900,212016,590,b|0,1);b=$Xc(8)|0;f[b>>2]=20;f[b+4>>2]=1;ff(19976,231201,2,33900,212016,590,b|0,0);Of(5672,19976,199557,0,211997,1028,213675,30,211997,1029,212002,2200);Ce(19920,5736,5752,20168,211997,1030,211997,1031,211997,1032,199580,212002,2201);b=$Xc(4)|0;f[b>>2]=1206;ff(19920,198998,2,33908,212016,591,b|0,0);b=$Xc(8)|0;f[b>>2]=96;f[b+4>>2]=1;ff(19920,199585,2,33916,212016,592,b|0,1);b=$Xc(4)|0;f[b>>2]=1207;ff(19920,199598,3,33924,212005,401,b|0,0);b=$Xc(8)|0;f[b>>2]=72;f[b+4>>2]=1;ff(19920,199609,2,33936,212016,593,b|0,1);ae(19920,10,33944,216340,1,1);ae(19920,9,33984,216352,1,1);ae(19920,8,34020,216363,1,1);ae(19920,7,34052,216373,1,6);ae(19920,6,34080,216382,1,6);ae(19920,5,34104,216390,5,17);ae(19920,4,34124,212044,81,288);ae(19920,3,34140,212039,304,402);ae(19920,2,34152,212016,594,1208);ae(19920,1,34160,211997,1033,2202);b=$Xc(8)|0;f[b>>2]=88;f[b+4>>2]=1;ff(19920,199618,2,33936,212016,593,b|0,1);b=$Xc(4)|0;f[b>>2]=1209;ff(19920,199629,3,33924,212005,401,b|0,0);b=$Xc(4)|0;f[b>>2]=1210;ff(19920,199640,3,34164,212005,403,b|0,0);b=$Xc(8)|0;f[b>>2]=80;f[b+4>>2]=1;ff(19920,199653,2,33936,212016,593,b|0,1);b=$Xc(4)|0;f[b>>2]=289;ff(19920,465208,5,34176,213620,144,b|0,0);b=$Xc(4)|0;f[b>>2]=1211;ff(19920,199664,3,33924,212005,401,b|0,0);Of(5776,19920,199673,0,211997,1034,213675,31,211997,1035,212002,2203);Ce(20120,5840,5856,20168,211997,1036,211997,1037,211997,1038,199683,212002,2204);b=$Xc(4)|0;f[b>>2]=1212;ff(20120,198998,2,34196,212016,595,b|0,0);b=$Xc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(20120,199704,2,34204,212016,596,b|0,1);b=$Xc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(20120,198985,2,34212,212016,597,b|0,1);ae(20120,4,34220,212044,82,290);ae(20120,3,34236,212039,305,404);ae(20120,2,34248,212016,598,1213);ae(20120,1,34256,211997,1039,2205);b=$Xc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(20120,199725,2,34260,212016,599,b|0,1);b=$Xc(4)|0;f[b>>2]=1214;ff(20120,199733,3,34268,212005,405,b|0,0);b=$Xc(4)|0;f[b>>2]=1215;ff(20120,199028,3,34280,212005,406,b|0,0);b=$Xc(4)|0;f[b>>2]=1216;ff(20120,199754,3,34292,212005,407,b|0,0);Of(5880,20120,199762,0,211997,1040,213675,32,211997,1041,212002,2206);Ce(5904,5912,5928,0,211997,1042,212e3,0,212e3,0,199788,212002,2207);b=$Xc(4)|0;f[b>>2]=600;ff(5904,198747,3,34304,212039,306,b|0,0);b=$Xc(4)|0;f[b>>2]=3;ff(5904,199806,10,34316,214508,2,b|0,0);b=$Xc(4)|0;f[b>>2]=3;ff(5904,199806,9,34356,214520,2,b|0,0);b=$Xc(4)|0;f[b>>2]=5;ff(5904,199806,8,34392,214531,5,b|0,0);b=$Xc(4)|0;f[b>>2]=9;ff(5904,199806,7,34424,214265,6,b|0,0);b=$Xc(4)|0;f[b>>2]=18;ff(5904,199806,6,34452,214059,7,b|0,0);b=$Xc(4)|0;f[b>>2]=291;ff(5904,199806,5,34476,213620,145,b|0,0);ae(5904,1,34496,211997,1043,33);ae(5904,2,34500,212016,601,1044);b=$Xc(4)|0;f[b>>2]=2;ff(5904,199824,12,34508,216816,1,b|0,0);b=$Xc(4)|0;f[b>>2]=3;ff(5904,199824,11,34556,216830,1,b|0,0);b=$Xc(4)|0;f[b>>2]=3;ff(5904,199824,10,34600,216843,1,b|0,0);b=$Xc(4)|0;f[b>>2]=6;ff(5904,199824,9,34640,216855,1,b|0,0);b=$Xc(4)|0;f[b>>2]=7;ff(5904,199824,8,34676,214365,3,b|0,0);b=$Xc(4)|0;f[b>>2]=8;ff(5904,199824,7,34708,214088,6,b|0,0);b=$Xc(4)|0;f[b>>2]=146;ff(5904,199824,6,34736,214097,168,b|0,0);b=$Xc(8)|0;f[b>>2]=1045;f[b+4>>2]=0;ff(5904,231201,2,34760,212016,602,b|0,0);b=$Xc(4)|0;f[b>>2]=2;ff(5904,468976,9,34768,216866,4,b|0,0);b=$Xc(4)|0;f[b>>2]=3;ff(5904,468976,8,34804,216877,4,b|0,0);b=$Xc(4)|0;f[b>>2]=5;ff(5904,468976,7,34836,216887,6,b|0,0);b=$Xc(4)|0;f[b>>2]=7;ff(5904,468976,6,34864,214274,10,b|0,0);b=$Xc(4)|0;f[b>>2]=21;ff(5904,468976,5,34888,213613,19,b|0,0);b=$Xc(4)|0;f[b>>2]=408;ff(5904,468976,4,34908,212010,292,b|0,0);Ce(19456,5944,5960,20168,211997,1046,211997,1047,211997,1048,199842,212002,2208);b=$Xc(4)|0;f[b>>2]=1217;ff(19456,198998,2,34924,212016,603,b|0,0);b=$Xc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19456,199704,2,34932,212016,604,b|0,1);b=$Xc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19456,198985,2,34940,212016,605,b|0,1);ae(19456,4,34948,212044,83,293);ae(19456,3,34964,212039,307,409);ae(19456,2,34976,212016,606,1218);ae(19456,1,34984,211997,1049,2209);b=$Xc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19456,199725,2,34988,212016,607,b|0,1);b=$Xc(4)|0;f[b>>2]=1219;ff(19456,199733,3,34996,212005,410,b|0,0);b=$Xc(4)|0;f[b>>2]=1220;ff(19456,199028,3,35008,212005,411,b|0,0);b=$Xc(4)|0;f[b>>2]=1221;ff(19456,199754,3,35020,212005,412,b|0,0);Of(5984,19456,199862,0,211997,1050,213675,34,211997,1051,212002,2210);Ce(19648,6008,6024,20168,211997,1052,211997,1053,211997,1054,199887,212002,2211);b=$Xc(4)|0;f[b>>2]=1222;ff(19648,198878,3,35032,212005,413,b|0,0);b=$Xc(4)|0;f[b>>2]=1223;ff(19648,198998,2,35044,212016,608,b|0,0);b=$Xc(4)|0;f[b>>2]=1224;ff(19648,199893,3,35052,212005,414,b|0,0);b=$Xc(8)|0;f[b>>2]=108;f[b+4>>2]=1;ff(19648,198907,2,35064,212016,609,b|0,1);b=$Xc(4)|0;f[b>>2]=1225;ff(19648,198924,3,35032,212005,413,b|0,0);b=$Xc(8)|0;f[b>>2]=68;f[b+4>>2]=1;ff(19648,199911,2,35072,212016,610,b|0,1);b=$Xc(8)|0;f[b>>2]=92;f[b+4>>2]=1;ff(19648,198985,2,35080,213697,27,b|0,1);ae(19648,8,35088,217191,1,5);ae(19648,7,35120,217201,2,7);ae(19648,6,35148,217210,7,11);ae(19648,5,35172,217218,6,20);ae(19648,4,35192,212044,84,294);ae(19648,3,35208,212039,308,415);ae(19648,2,35220,212016,611,1226);ae(19648,1,35228,211997,1055,2212);b=$Xc(8)|0;f[b>>2]=100;f[b+4>>2]=1;ff(19648,198895,2,35064,212016,609,b|0,1);b=$Xc(4)|0;f[b>>2]=1227;ff(19648,199929,3,35032,212005,413,b|0,0);b=$Xc(4)|0;f[b>>2]=25;ff(19648,199028,3,35232,212377,35,b|0,0);b=$Xc(8)|0;f[b>>2]=84;f[b+4>>2]=1;ff(19648,199951,2,35064,212016,609,b|0,1);b=$Xc(4)|0;f[b>>2]=1228;ff(19648,199973,3,35032,212005,413,b|0,0);b=$Xc(4)|0;f[b>>2]=1229;ff(19648,198970,3,35244,212005,416,b|0,0);b=$Xc(8)|0;f[b>>2]=116;f[b+4>>2]=1;ff(19648,199013,2,35256,212016,612,b|0,1);b=$Xc(8)|0;f[b>>2]=76;f[b+4>>2]=1;ff(19648,470098,2,35064,212016,609,b|0,1);Of(6056,19648,199991,0,211997,1056,213675,35,211997,1057,212002,2213);Ce(19600,6072,6088,20168,211997,1058,211997,1059,211997,1060,200002,212002,2214);b=$Xc(4)|0;f[b>>2]=1230;ff(19600,198998,2,35264,212016,613,b|0,0);b=$Xc(4)|0;f[b>>2]=1231;ff(19600,200006,3,35272,212005,417,b|0,0);b=$Xc(4)|0;f[b>>2]=1232;ff(19600,462336,3,35272,212005,417,b|0,0);ae(19600,10,35284,217320,1,1);ae(19600,9,35324,217332,1,1);ae(19600,8,35360,217343,2,2);ae(19600,7,35392,217353,2,2);ae(19600,6,35420,217362,2,2);ae(19600,5,35444,217370,2,2);ae(19600,4,35464,217377,3,11);ae(19600,3,35480,217383,4,36);ae(19600,2,35492,212016,614,1233);ae(19600,1,35500,211997,1061,2215);b=$Xc(8)|0;f[b>>2]=132;f[b+4>>2]=1;ff(19600,200023,2,35504,212016,615,b|0,1);b=$Xc(4)|0;f[b>>2]=1234;ff(19600,199370,3,35272,212005,417,b|0,0);b=$Xc(4)|0;f[b>>2]=1235;ff(19600,200040,3,35272,212005,417,b|0,0);b=$Xc(4)|0;f[b>>2]=1236;ff(19600,200051,3,35272,212005,417,b|0,0);b=$Xc(4)|0;f[b>>2]=1237;ff(19600,200064,3,35272,212005,417,b|0,0);b=$Xc(4)|0;f[b>>2]=26;ff(19600,200073,3,35512,212377,37,b|0,0);b=$Xc(4)|0;f[b>>2]=1238;ff(19600,200088,3,35524,212005,418,b|0,0);Of(6112,19600,200101,0,211997,1062,213675,36,211997,1063,212002,2216);Ce(19568,6136,6152,20168,211997,1064,211997,1065,211997,1066,200110,212002,2217);b=$Xc(4)|0;f[b>>2]=1239;ff(19568,198998,2,35536,212016,616,b|0,0);ae(19568,4,35544,212216,5,22);ae(19568,3,35560,212039,309,419);ae(19568,2,35572,212016,617,1240);ae(19568,1,35580,211997,1067,2218);ae(19568,6,35584,217471,1,7);ae(19568,5,35608,217479,1,9);ae(19568,8,35628,217486,1,3);ae(19568,7,35660,217496,1,3);Of(6176,19568,200116,0,211997,1068,213675,37,211997,1069,212002,2219);fe(200127,25528,67108864);fe(200139,25528,50331648);fe(200151,25528,16777216);fe(200163,25528,50331648);fe(200173,25528,33554432);fe(200186,25528,1);fe(200213,25528,0);fe(200236,25528,3);fe(200258,25528,2);fe(200288,25528,5);fe(200310,25528,4);fe(200340,25528,0);fe(200371,25528,1);fe(200404,25528,2);fe(200437,25528,10001);fe(200477,25528,3);fe(200508,25528,1e4);fe(200539,25528,0);fe(200555,25528,4);fe(200570,25528,16);fe(200586,25528,2);fe(200601,25528,4);fe(200619,25528,4);fe(200638,25528,1);fe(200655,25528,5);fe(200674,25528,3);fe(200686,25528,1);fe(200711,25528,8);fe(200735,25528,4);fe(200763,25528,2);fe(200783,25528,-1);fe(200795,25528,1);fe(200805,25528,0);fe(200812,25528,4);fe(200825,25528,3);fe(200840,25528,0);fe(200853,25528,5);fe(200865,25528,1);fe(200877,25528,2);fe(200891,25528,1);fe(200909,25528,2);fe(200929,25528,4);fe(200952,25528,3);fe(200973,25528,0);fe(200980,25528,2);fe(200987,25528,1);fe(200994,25528,4);fe(201001,25528,3);fe(201008,25528,5);fe(201015,25528,0);fe(201031,25528,1);fe(201045,25528,8);fe(201059,25528,11);fe(201072,25528,9);fe(201085,25528,2);fe(201098,25528,5);fe(201113,25528,12);fe(201129,25528,10);fe(201143,25528,4);fe(201160,25528,7);fe(201176,25528,6);fe(201192,25528,3);fe(201208,25528,22);fe(201225,25528,12);fe(201242,25528,0);fe(201257,25528,6);fe(201272,25528,52);fe(201286,25528,68);fe(201305,25528,40);fe(201319,25528,66);fe(201338,25528,44);fe(201352,25528,50);fe(201366,25528,4);fe(201380,25528,2);fe(201395,25528,32);fe(201409,25528,36);fe(201425,25528,82);fe(201439,25528,128);fe(201458,25528,128);fe(201477,25528,132);fe(201496,25528,24);fe(201513,25528,28);fe(201531,25528,31);fe(201549,25528,25);fe(201566,25528,29);fe(201584,25528,14);fe(201601,25528,18);fe(201619,25528,21);fe(201637,25528,15);fe(201654,25528,19);fe(201672,25528,1);fe(201687,25528,26);fe(201705,25528,16);fe(201723,25528,10);fe(201739,25528,3);fe(201754,25528,5);fe(201770,25528,130);fe(201790,25528,130);fe(201810,25528,134);fe(201830,25528,46);fe(201848,25528,139);fe(201867,25528,135);fe(201888,25528,62);fe(201910,25528,86);fe(201929,25528,48);fe(201947,25528,141);fe(201966,25528,137);fe(201987,25528,64);fe(202009,25528,47);fe(202027,25528,140);fe(202046,25528,136);fe(202067,25528,63);fe(202089,25528,87);fe(202108,25528,49);fe(202126,25528,142);fe(202145,25528,138);fe(202166,25528,65);fe(202188,25528,49);fe(202206,25528,142);fe(202225,25528,138);fe(202246,25528,65);fe(202268,25528,89);fe(202287,25528,47);fe(202305,25528,140);fe(202324,25528,136);fe(202345,25528,63);fe(202367,25528,48);fe(202385,25528,141);fe(202404,25528,137);fe(202425,25528,64);fe(202447,25528,88);fe(202466,25528,46);fe(202484,25528,139);fe(202503,25528,135);fe(202524,25528,62);fe(202546,25528,143);fe(202565,25528,8);fe(202580,25528,30);fe(202598,25528,20);fe(202616,25528,9);fe(202632,25528,8);fe(202647,25528,9);fe(202663,25528,60);fe(202677,25528,72);fe(202696,25528,61);fe(202710,25528,73);fe(202729,25528,54);fe(202743,25528,70);fe(202762,25528,55);fe(202776,25528,71);fe(202795,25528,74);fe(202810,25528,76);fe(202825,25528,75);fe(202840,25528,77);fe(202855,25528,56);fe(202869,25528,78);fe(202884,25528,79);fe(202899,25528,57);fe(202913,25528,58);fe(202927,25528,80);fe(202942,25528,81);fe(202957,25528,59);fe(202971,25528,4);fe(202985,25528,23);fe(203002,25528,13);fe(203019,25528,2);fe(203034,25528,7);fe(203049,25528,53);fe(203063,25528,69);fe(203082,25528,41);fe(203096,25528,67);fe(203115,25528,45);fe(203129,25528,51);fe(203143,25528,0);fe(203158,25528,33);fe(203172,25528,37);fe(203188,25528,83);fe(203202,25528,127);fe(203221,25528,127);fe(203240,25528,131);fe(203259,25528,3);fe(203274,25528,27);fe(203292,25528,17);fe(203310,25528,5);fe(203326,25528,11);fe(203342,25528,1);fe(203357,25528,129);fe(203377,25528,129);fe(203397,25528,133);fe(203417,25528,125);fe(203434,25528,34);fe(203448,25528,35);fe(203462,25528,38);fe(203478,25528,39);fe(203494,25528,84);fe(203508,25528,105);fe(203528,25528,105);fe(203548,25528,95);fe(203568,25528,97);fe(203588,25528,112);fe(203608,25528,112);fe(203628,25528,112);fe(203648,25528,120);fe(203668,25528,120);fe(203688,25528,120);fe(203708,25528,103);fe(203728,25528,122);fe(203748,25528,101);fe(203767,25528,101);fe(203786,25528,91);fe(203805,25528,93);fe(203824,25528,108);fe(203843,25528,108);fe(203862,25528,108);fe(203881,25528,116);fe(203900,25528,116);fe(203919,25528,116);fe(203938,25528,99);fe(203957,25528,118);fe(203976,25528,106);fe(203995,25528,106);fe(204015,25528,106);fe(204035,25528,106);fe(204055,25528,106);fe(204075,25528,123);fe(204095,25528,123);fe(204115,25528,123);fe(204135,25528,124);fe(204155,25528,124);fe(204175,25528,124);fe(204195,25528,106);fe(204215,25528,124);fe(204235,25528,85);fe(204249,25528,104);fe(204269,25528,104);fe(204289,25528,94);fe(204309,25528,96);fe(204329,25528,111);fe(204349,25528,111);fe(204369,25528,111);fe(204389,25528,119);fe(204409,25528,119);fe(204429,25528,119);fe(204449,25528,102);fe(204469,25528,121);fe(204489,25528,100);fe(204508,25528,100);fe(204527,25528,90);fe(204546,25528,92);fe(204565,25528,107);fe(204584,25528,107);fe(204603,25528,107);fe(204622,25528,115);fe(204641,25528,115);fe(204660,25528,115);fe(204679,25528,98);fe(204698,25528,117);fe(204717,25528,99);fe(204735,25528,103);fe(204754,25528,106);fe(204773,25528,98);fe(204791,25528,102);fe(204810,25528,93);fe(204829,25528,97);fe(204849,25528,106);fe(204869,25528,92);fe(204888,25528,96);fe(204908,25528,126);fe(204925,25528,1);fe(204943,25528,2);fe(204961,25528,3);fe(204979,25528,16);fe(204990,25528,1);fe(205003,25528,8);fe(205014,25528,4);fe(205026,25528,0);fe(205042,25528,2);fe(205056,25528,1);fe(205068,25528,4);fe(205077,25528,3);fe(205093,25528,2);fe(205104,25528,0);fe(205114,25528,16);fe(205128,25528,4);fe(205138,25528,1);fe(205149,25528,64);fe(205167,25528,16);fe(205186,25528,1);fe(205198,25528,32);fe(205214,25528,4);fe(205223,25528,2);fe(205233,25528,1);fe(205260,25528,2);fe(205289,25528,0);fe(205321,25528,3);fe(205328,25528,5);fe(205338,25528,7);fe(205349,25528,1);fe(205357,25528,4);fe(205366,25528,2);fe(205374,25528,0);fe(205391,25528,1);fe(205408,25528,3);fe(205420,25528,5);fe(205432,25528,0);fe(205450,25528,-1);fe(205460,25528,6);fe(205472,25528,2);fe(205501,25528,4);fe(205538,25528,5);fe(205578,25528,3);fe(205610,25528,6);fe(205643,25528,1);fe(205672,25528,0);fe(205697,25528,1);fe(205731,25528,4);fe(205768,25528,2);fe(205808,25528,-1);fe(205815,25528,-1);fe(205829,25528,65536);fe(205851,25528,131072);fe(205871,25528,3);fe(205892,25528,5);fe(205919,25528,2);fe(205939,25528,1);fe(205958,25528,7);fe(205986,25528,6);fe(206014,25528,0);fe(206035,25528,4);fe(206056,25528,16);fe(206068,25528,10002);fe(206095,25528,10001);fe(206134,25528,1e4);fe(206164,25528,0);fe(206193,25528,1);fe(206223,25528,2);fe(206253,25528,16);fe(206268,25528,2);fe(206283,25528,8);fe(206297,25528,1);fe(206310,25528,5);fe(206323,25528,32);fe(206338,25528,0);fe(206352,25528,2);fe(206366,25528,4);fe(206379,25528,3);fe(206392,25528,3);fe(206408,25528,7);fe(206427,25528,8);fe(206444,25528,2);fe(206463,25528,64);fe(206482,25528,0);fe(206506,25528,24);fe(206530,25528,56);fe(206554,25528,8);fe(206577,25528,16);fe(206601,25528,4);fe(206624,25528,4);fe(206643,25528,2);fe(206669,25528,0);fe(206686,25528,0);fe(206708,25528,1);fe(206735,25528,1);fe(206753,25528,65);fe(206778,25528,5);fe(206794,25528,2);fe(206812,25528,0);fe(206834,25528,1);fe(206855,25528,4);fe(206875,25528,3);fe(206896,25528,0);fe(206903,25528,2);fe(206911,25528,3);fe(206932,25528,1);fe(206939,25528,1);fe(206957,25528,0);fe(206975,25528,2);fe(206985,25528,3);fe(206995,25528,1);fe(207004,25528,2);fe(207013,25528,4);fe(207022,25528,3);fe(207044,25528,1);fe(207059,25528,4);fe(207078,25528,0);fe(207093,25528,3);fe(207111,25528,2);fe(207129,25528,5);fe(207144,25528,64);fe(207174,25528,0);fe(207212,25528,1);fe(207250,25528,0);fe(207270,25528,3);fe(207285,25528,2);fe(207303,25528,1);fe(207323,25528,0);fe(207338,25528,2);fe(207353,25528,0);fe(207368,25528,1);fe(207386,25528,3);fe(207397,25528,5);fe(207408,25528,10);fe(207420,25528,2);fe(207432,25528,4);fe(207447,25528,1);fe(207460,25528,5);fe(207479,25528,7);fe(207489,25528,0);fe(207503,25528,32);fe(207518,25528,1024);fe(207534,25528,3);fe(207556,25528,0);fe(207572,25528,1);fe(207588,25528,2);fe(207607,25528,2);fe(207625,25528,0);fe(207647,25528,1);fe(207673,25528,4);fe(207680,25528,8);fe(207687,25528,16);fe(207695,25528,2);fe(207710,25528,0);fe(207726,25528,1);fe(207741,25528,0);fe(207754,25528,3);fe(207769,25528,4);fe(207783,25528,2);fe(207795,25528,1);fe(207815,25528,6);fe(207836,25528,5);fe(207855,25528,6);fe(207870,25528,3);fe(207882,25528,1);fe(207894,25528,1);fe(207907,25528,2);fe(207921,25528,0);fe(207933,25528,4);fe(207948,25528,7);fe(207962,25528,2);fe(207973,25528,0);fe(207984,25528,5);fe(207997,25528,2);fe(208011,25528,1);fe(208028,25528,3);fe(208046,25528,0);fe(208065,25528,0);fe(208079,25528,16384);fe(208099,25528,7);fe(208114,25528,-65536);fe(208129,25528,1124007936);fe(208143,25528,32768);fe(208162,25528,4095);fe(208176,25528,6);fe(208189,25528,7);fe(208203,25528,1);fe(208212,25528,2);fe(208220,25528,4);fe(208228,25528,5);fe(208239,25528,32);fe(208251,25528,8);fe(208265,25528,7);fe(208280,25528,256);fe(208307,25528,8);fe(208336,25528,4);fe(208361,25528,1);fe(208376,25528,0);fe(208393,25528,1);fe(208409,25528,0);fe(208425,25528,2);fe(208437,25528,6);fe(208453,25528,1);fe(208467,25528,7);fe(208479,25528,0);fe(208489,25528,4);fe(208499,25528,5);fe(208516,25528,2);fe(208527,25528,12);fe(208540,25528,3);fe(208553,25528,11);fe(208565,25528,9);fe(208578,25528,8);fe(208597,25528,1);fe(208608,25528,2);fe(208619,25528,3);fe(208630,25528,0);fe(208641,25528,2);fe(208652,25528,0);fe(208666,25528,4);fe(208681,25528,1);fe(208691,25528,3);fe(208701,25528,1);fe(208712,25528,0);fe(208724,25528,1);fe(208735,25528,0);fe(208755,25528,2);fe(208782,25528,1);fe(208796,25528,0);fe(208811,25528,-2);fe(208829,25528,-1);fe(208848,25528,0);fe(208863,25528,16);fe(208879,25528,1);fe(208897,25528,0);fe(208912,25528,4);fe(208924,25528,1);fe(208937,25528,2);fe(208947,25528,-2147483648);fe(208966,25528,1540483477);fe(208987,25528,1123876864);fe(209007,25528,32);fe(209025,25528,34);fe(209050,25528,19);fe(209076,25528,0);fe(209101,25528,49);fe(209128,25528,51);fe(209153,25528,32);fe(209179,25528,17);fe(209204,25528,2);fe(209231,25528,-2);fe(209252,25528,0);fe(209274,25528,2);fe(209297,25528,-1);fe(209325,25528,1);fe(209347,25528,0);fe(209361,25528,1);fe(209379,25528,7);fe(209391,25528,8);fe(209403,25528,3);fe(209417,25528,4);fe(209435,25528,16);fe(209451,25528,2);fe(209464,25528,4);fe(209474,25528,5);fe(209491,25528,2);fe(209500,25528,3);fe(209516,25528,0);fe(209526,25528,1);fe(209543,25528,1);fe(209562,25528,2);fe(209579,25528,1);fe(209601,25528,128);fe(209624,25528,1);fe(209645,25528,4);fe(209675,25528,64);fe(209702,25528,2);fe(209730,25528,24);fe(209756,25528,8);fe(209775,25528,32);fe(209799,25528,0);fe(209814,25528,16384);fe(209835,25528,7);fe(209851,25528,-65536);fe(209867,25528,1124007936);fe(209882,25528,32768);fe(209902,25528,4095);fe(209917,25528,2);fe(209946,25528,1);fe(209973,25528,4);fe(210002,25528,0);fe(210016,25528,8);fe(210035,25528,16);fe(210052,25528,0);fe(210070,25528,256);fe(210085,25528,589824);fe(210110,25528,524288);fe(210136,25528,393216);fe(210153,25528,1073741824);fe(210176,25528,-2147483648);fe(210199,25528,2031616);fe(210221,25528,16);fe(210244,25528,65536);fe(210260,25528,131072);fe(210277,25528,0);fe(210294,25528,458752);fe(210320,25528,917504);fe(210342,25528,983040);fe(210368,25528,786432);fe(210396,25528,196608);fe(210419,25528,851968);fe(210455,25528,327680);fe(210482,25528,720896);fe(210510,25528,262144);fe(210540,25528,655360);fe(210557,25528,2147483647);fe(210582,25528,-21);fe(210591,25528,-18);fe(210607,25528,-24);fe(210614,25528,-22);fe(210626,25528,-12);fe(210637,25528,-17);fe(210646,25528,-10);fe(210659,25528,-14);fe(210675,25528,-16);fe(210691,25528,-15);fe(210706,25528,-11);fe(210716,25528,-19);fe(210725,25528,-20);fe(210735,25528,-25);fe(210746,25528,-13);fe(210754,25528,-23);fe(210766,25528,-217);fe(210782,25528,-216);fe(210798,25528,-9);fe(210811,25528,-26);fe(210823,25528,-220);fe(210842,25528,-221);fe(210867,25528,-222);fe(210883,25528,-223);fe(210902,25528,-219);fe(210921,25528,-218);fe(210940,25528,-215);fe(210950,25528,-8);fe(210963,25528,-1);fe(210976,25528,-5);fe(210986,25528,-206);fe(210997,25528,-6);fe(211008,25528,-208);fe(211019,25528,-214);fe(211034,25528,-207);fe(211046,25528,-201);fe(211057,25528,-202);fe(211070,25528,-2);fe(211079,25528,-31);fe(211098,25528,-29);fe(211124,25528,-203);fe(211147,25528,-3);fe(211159,25528,-30);fe(211185,25528,-7);fe(211195,25528,-4);fe(211204,25528,-213);fe(211222,25528,-27);fe(211233,25528,-204);fe(211251,25528,0);fe(211257,25528,-211);fe(211271,25528,-212);fe(211285,25528,-205);fe(211305,25528,-209);fe(211323,25528,-210);fe(211344,25528,-28);fe(211360,25528,0);fe(211372,25528,1);fe(211380,25528,5);fe(211388,25528,6);fe(211396,25528,3);fe(211404,25528,4);fe(211412,25528,2);fe(211420,25528,0);fe(211440,25528,1);fe(211459,25528,2);fe(211488,25528,3);fe(211507,25528,4);fe(211525,25528,0);fe(211540,25528,3);fe(211558,25528,1);fe(211576,25528,2);fe(211599,25528,4);fe(211617,25528,2);fe(211641,25528,1);fe(211655,25528,0);fe(211666,25528,1);fe(211675,25528,2);fe(211687,25528,0);fe(211698,25528,3);fe(211707,25528,0);fe(211720,25528,1);fe(211732,25528,2);return}function Kv(a){a=a|0;Rd(a|0)|0;sZc()}function Lv(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[529952]|0)==0?X0c(529952)|0:0){h=Af(2,25608)|0;f[135042]=h}h=f[135042]|0;i=$Xc(8)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[g>>2]=i;Cd(h|0,a|0,c|0,g|0);u=e;return}function Mv(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[529960]|0)==0?X0c(529960)|0:0){h=Af(2,25616)|0;f[135043]=h}h=f[135043]|0;i=$Xc(20)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[g>>2]=i;Cd(h|0,a|0,c|0,g|0);u=e;return}function Nv(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[529968]|0)==0?X0c(529968)|0:0){h=Af(2,25624)|0;f[135044]=h}h=f[135044]|0;i=$Xc(16)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[g>>2]=i;Cd(h|0,a|0,c|0,g|0);u=e;return}function Ov(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Tv(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function Pv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){Uv(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function Qv(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function Rv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=bf(25512,e|0)|0;f[a>>2]=h;u=d;return}function Sv(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function Tv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function Uv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>2>>>0>=b>>>0){j=b;k=i;while(1){f[k>>2]=f[c>>2];j=j+-1|0;if(!j)break;else k=k+4|0}f[g>>2]=i+(b<<2);return}i=f[a>>2]|0;k=h-i|0;h=k>>2;j=h+b|0;if(j>>>0>1073741823)kWc(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<j>>>0?j:e):1073741823;do if(m)if(m>>>0>1073741823){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{n=$Xc(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;j=n+(m<<2)|0;m=b;n=e;while(1){f[n>>2]=f[c>>2];m=m+-1|0;if(!m)break;else n=n+4|0}n=e+(0-h<<2)|0;if((k|0)>0)o1c(n|0,i|0,k|0)|0;f[a>>2]=n;f[g>>2]=e+(b<<2);f[d>>2]=j;if(!i)return;cYc(i);return}function Vv(a){a=a|0;return 4216}function Wv(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}cYc(a);return}function Xv(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Yv(a){a=a|0;return xj[a&63]()|0}function Zv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;f[e>>2]=c;mi[i&2047](a,e);u=d;return}function _v(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=d;Ti[j&511](a,c,g);u=e;return}function $v(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function aw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function bw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;f[g>>2]=d;d=hj[h&511](b,c,g)|0;u=e;return d|0}function cw(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){hw(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function dw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){iw(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function ew(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function fw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=bf(25544,e|0)|0;f[a>>2]=h;u=d;return}function gw(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function hw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function iw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=h+(b<<2)|0;j=b;k=h;while(1){f[k>>2]=f[c>>2];j=j+-1|0;if(!j)break;else k=k+4|0}f[g>>2]=i;return}i=f[a>>2]|0;k=h-i|0;h=k>>2;j=h+b|0;if(j>>>0>1073741823)kWc(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<j>>>0?j:e):1073741823;do if(m)if(m>>>0>1073741823){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{n=$Xc(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;l=n+(m<<2)|0;m=b;b=e;while(1){f[b>>2]=f[c>>2];m=m+-1|0;if(!m)break;else b=b+4|0}b=e+(0-h<<2)|0;if((k|0)>0)o1c(b|0,i|0,k|0)|0;f[a>>2]=b;f[g>>2]=n+(j<<2);f[d>>2]=l;if(!i)return;cYc(i);return}function jw(a){a=a|0;return 4304}function kw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}cYc(a);return}function lw(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function mw(a){a=a|0;return xj[a&63]()|0}function nw(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;n[e>>2]=c;mi[i&2047](a,e);u=d;return}function ow(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;n[g>>2]=d;Ti[j&511](a,c,g);u=e;return}function pw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function qw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function rw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;n[g>>2]=d;a=hj[h&511](b,c,g)|0;u=e;return a|0}function sw(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){xw(a,b);return}else{p[d>>3]=+p[b>>3];f[c>>2]=d+8;return}}function tw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){yw(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function uw(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function vw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}p[e>>3]=+p[g+(c<<3)>>3];h=bf(25552,e|0)|0;f[a>>2]=h;u=d;return}function ww(a,b,c){a=a|0;b=b|0;c=c|0;p[(f[a>>2]|0)+(b<<3)>>3]=+p[c>>3];return 1}function xw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function yw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=b;k=i;while(1){p[k>>3]=+p[c>>3];j=j+-1|0;if(!j)break;else k=k+8|0}f[g>>2]=i+(b<<3);return}i=f[a>>2]|0;k=h-i|0;h=k>>3;j=h+b|0;if(j>>>0>536870911)kWc(a);l=e-i|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<j>>>0?j:e):536870911;do if(m)if(m>>>0>536870911){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);e=n+(h<<3)|0;j=n+(m<<3)|0;m=b;n=e;while(1){p[n>>3]=+p[c>>3];m=m+-1|0;if(!m)break;else n=n+8|0}n=e+(0-h<<3)|0;if((k|0)>0)o1c(n|0,i|0,k|0)|0;f[a>>2]=n;f[g>>2]=e+(b<<3);f[d>>2]=j;if(!i)return;cYc(i);return}function zw(a){a=a|0;return 4384}function Aw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b)}cYc(a);return}function Bw(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Cw(a){a=a|0;return xj[a&63]()|0}function Dw(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;p[e>>3]=c;mi[i&2047](a,e);u=d;return}function Ew(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;p[g>>3]=d;Ti[j&511](a,c,g);u=e;return}function Fw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function Gw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Hw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;p[g>>3]=d;a=hj[h&511](b,c,g)|0;u=e;return a|0}function Iw(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Nw(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[c>>2]=d+8;return}}function Jw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){Ow(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function Kw(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function Lw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=$Xc(8)|0;f[g>>2]=f[h+(c<<3)>>2];f[g+4>>2]=f[h+(c<<3)+4>>2];f[e>>2]=g;i=bf(4520,e|0)|0;f[a>>2]=i;u=d;return}function Mw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<3)>>2]=f[c>>2];f[d+(b<<3)+4>>2]=f[c+4>>2];return 1}function Nw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;while(1){m=n;n=n+-8|0;f[j+-8>>2]=f[n>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function Ow(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=c+4|0;k=b;l=i;while(1){f[l>>2]=f[c>>2];f[l+4>>2]=f[j>>2];k=k+-1|0;if(!k)break;else l=l+8|0}f[g>>2]=i+(b<<3);return}l=f[a>>2]|0;k=h-l>>3;h=k+b|0;j=l;if(h>>>0>536870911)kWc(a);m=e-l|0;e=m>>2;n=m>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(n)if(n>>>0>536870911){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{o=$Xc(n<<3)|0;break}else o=0;while(0);e=o+(k<<3)|0;k=o+(n<<3)|0;n=c+4|0;o=b;h=e;while(1){f[h>>2]=f[c>>2];f[h+4>>2]=f[n>>2];o=o+-1|0;if(!o)break;else h=h+8|0}h=k;k=e+(b<<3)|0;if((i|0)==(j|0)){p=e;q=l}else{b=i+-8-l|0;l=i;i=e;while(1){o=l;l=l+-8|0;f[i+-8>>2]=f[l>>2];f[i+-4>>2]=f[o+-4>>2];if((l|0)==(j|0))break;else i=i+-8|0}p=e+(~(b>>>3)<<3)|0;q=f[a>>2]|0}f[a>>2]=p;f[g>>2]=k;f[d>>2]=h;if(!q)return;cYc(q);return}function Pw(a){a=a|0;return 4464}function Qw(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b)}cYc(a);return}function Rw(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Sw(a){a=a|0;return xj[a&63]()|0}function Tw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function Uw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function Vw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function Ww(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Xw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function Yw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){bx(a,b);return}f[d>>2]=f[b>>2];a=d+4|0;e=b+4|0;f[a>>2]=f[e>>2];g=d+8|0;f[g>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[d+16>>2]=f[b+16>>2];f[d+20>>2]=f[b+20>>2];f[d+24>>2]=f[b+24>>2];f[d+28>>2]=f[b+28>>2];f[d+32>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[d+36>>2]=h;f[d+40>>2]=g;g=d+48|0;i=d+44|0;f[i>>2]=g;f[g>>2]=0;f[d+52>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[a>>2]=0;U$(d,b)}f[c>>2]=(f[c>>2]|0)+56;return}function Zw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/56|0;i=e;if(h>>>0<b>>>0){ex(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*56|0)|0;if((i|0)==(h|0))return;else j=i;do{i=j+-56|0;f[d>>2]=i;b=j+-20|0;g=f[b>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)V$(i);f[b>>2]=0;b=j+-40|0;i=j+-52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[j+-16>>2]|0;g=0;do{f[b+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[j+-12>>2]|0;if((i|0)!=(j+-8|0))wL(i);j=f[d>>2]|0}while((j|0)!=(h|0));return}function _w(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/56|0|0}function $w(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((((f[b+4>>2]|0)-g|0)/56|0)>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}b=ox(g+(c*56|0)|0)|0;f[e>>2]=b;h=bf(4608,e|0)|0;f[a>>2]=h;u=d;return}function ax(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[a>>2]|0;a=d+(b*56|0)|0;if((a|0)==(c|0))return 1;e=c+36|0;g=f[e>>2]|0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}h=d+(b*56|0)+36|0;g=f[h>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)V$(a);f[h>>2]=0;g=d+(b*56|0)+16|0;i=d+(b*56|0)+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){j=f[d+(b*56|0)+40>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;l=f[i>>2]|0}while((k|0)<(l|0));f[a>>2]=f[c>>2];if((l|0)<3)m=12;else m=14}else{f[a>>2]=f[c>>2];m=12}if((m|0)==12){l=f[c+4>>2]|0;if((l|0)<3){f[i>>2]=l;f[d+(b*56|0)+8>>2]=f[c+8>>2];f[d+(b*56|0)+12>>2]=f[c+12>>2];l=f[c+44>>2]|0;i=f[d+(b*56|0)+44>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2]}else m=14}if((m|0)==14)U$(a,c);f[g>>2]=f[c+16>>2];f[d+(b*56|0)+20>>2]=f[c+20>>2];f[d+(b*56|0)+24>>2]=f[c+24>>2];f[d+(b*56|0)+28>>2]=f[c+28>>2];f[d+(b*56|0)+32>>2]=f[c+32>>2];f[h>>2]=f[e>>2];return 1}function bx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)kWc(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{k=$Xc(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=k+(g*56|0)+4|0;i=b+4|0;l=f[i>>2]|0;f[j>>2]=l;m=k+(g*56|0)+8|0;f[m>>2]=f[b+8>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];n=f[b+36>>2]|0;f[k+(g*56|0)+36>>2]=n;f[k+(g*56|0)+40>>2]=m;m=k+(g*56|0)+48|0;o=k+(g*56|0)+44|0;f[o>>2]=m;f[m>>2]=0;f[k+(g*56|0)+52>>2]=0;if(!n)p=l;else{l=n+12|0;f[l>>2]=(f[l>>2]|0)+1;p=f[i>>2]|0}if((p|0)<3){p=f[b+44>>2]|0;i=f[o>>2]|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;cx(a,d);dx(d);u=c;return}else{f[j>>2]=0;U$(e,b);q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;cx(a,d);dx(d);u=c;return}}function cx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;if((e|0)==(c|0)){h=g;i=a;j=f[g>>2]|0;k=c;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}t=e;e=f[g>>2]|0;do{u=e+-56|0;v=t;t=t+-56|0;f[u>>2]=f[t>>2];w=e+-52|0;x=v+-52|0;f[w>>2]=f[x>>2];y=e+-48|0;f[y>>2]=f[v+-48>>2];f[e+-44>>2]=f[v+-44>>2];f[e+-40>>2]=f[v+-40>>2];f[e+-36>>2]=f[v+-36>>2];f[e+-32>>2]=f[v+-32>>2];f[e+-28>>2]=f[v+-28>>2];f[e+-24>>2]=f[v+-24>>2];z=f[v+-20>>2]|0;f[e+-20>>2]=z;f[e+-16>>2]=y;y=e+-8|0;A=e+-12|0;f[A>>2]=y;f[y>>2]=0;f[e+-4>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+-12>>2]|0;v=f[A>>2]|0;f[v>>2]=f[x>>2];f[v+4>>2]=f[x+4>>2]}else{f[w>>2]=0;U$(u,t)}e=(f[g>>2]|0)+-56|0;f[g>>2]=e}while((t|0)!=(c|0));h=g;i=a;j=e;k=f[a>>2]|0;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}function dx(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;c=a+8|0;d=f[c>>2]|0;if((d|0)!=(b|0)){e=d;do{d=e+-56|0;f[c>>2]=d;g=e+-20|0;h=f[g>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)V$(d);f[g>>2]=0;g=e+-40|0;d=e+-52|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[e+-16>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[d>>2]|0))}d=f[e+-12>>2]|0;if((d|0)!=(e+-8|0))wL(d);e=f[c>>2]|0}while((e|0)!=(b|0))}b=f[a>>2]|0;if(!b)return;cYc(b);return}function ex(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d;g=f[a+8>>2]|0;h=a+4|0;i=f[h>>2]|0;if(((g-i|0)/56|0)>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=c+16|0;n=c+20|0;o=c+24|0;p=c+28|0;q=c+32|0;r=c+36|0;s=c+44|0;t=b;v=i;do{f[v>>2]=f[c>>2];w=v+4|0;f[w>>2]=f[j>>2];x=v+8|0;f[x>>2]=f[k>>2];f[v+12>>2]=f[l>>2];f[v+16>>2]=f[m>>2];f[v+20>>2]=f[n>>2];f[v+24>>2]=f[o>>2];f[v+28>>2]=f[p>>2];f[v+32>>2]=f[q>>2];y=f[r>>2]|0;f[v+36>>2]=y;f[v+40>>2]=x;x=v+48|0;z=v+44|0;f[z>>2]=x;f[x>>2]=0;f[v+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[j>>2]|0)<3){x=f[s>>2]|0;y=f[z>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2]}else{f[w>>2]=0;U$(v,c)}v=(f[h>>2]|0)+56|0;f[h>>2]=v;t=t+-1|0}while((t|0)!=0);u=d;return}t=f[a>>2]|0;v=(i-t|0)/56|0;i=v+b|0;if(i>>>0>76695844)kWc(a);h=(g-t|0)/56|0;t=h<<1;g=h>>>0<38347922?(t>>>0<i>>>0?i:t):76695844;f[e+12>>2]=0;f[e+16>>2]=a+8;do if(g)if(g>>>0>76695844){t=af(8)|0;hYc(t,512536);f[t>>2]=192348;ig(t|0,25336,2140)}else{A=$Xc(g*56|0)|0;break}else A=0;while(0);f[e>>2]=A;t=A+(v*56|0)|0;v=e+8|0;f[v>>2]=t;f[e+4>>2]=t;f[e+12>>2]=A+(g*56|0);g=c+4|0;A=c+8|0;i=c+12|0;h=c+16|0;s=c+20|0;j=c+24|0;r=c+28|0;q=c+32|0;p=c+36|0;o=c+44|0;n=b;b=t;do{f[b>>2]=f[c>>2];t=b+4|0;f[t>>2]=f[g>>2];m=b+8|0;f[m>>2]=f[A>>2];f[b+12>>2]=f[i>>2];f[b+16>>2]=f[h>>2];f[b+20>>2]=f[s>>2];f[b+24>>2]=f[j>>2];f[b+28>>2]=f[r>>2];f[b+32>>2]=f[q>>2];l=f[p>>2]|0;f[b+36>>2]=l;f[b+40>>2]=m;m=b+48|0;k=b+44|0;f[k>>2]=m;f[m>>2]=0;f[b+52>>2]=0;if(l|0){m=l+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){m=f[o>>2]|0;l=f[k>>2]|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2]}else{f[t>>2]=0;U$(b,c)}b=(f[v>>2]|0)+56|0;f[v>>2]=b;n=n+-1|0}while((n|0)!=0);cx(a,e);dx(e);u=d;return}function fx(a){a=a|0;return 4552}function gx(a){a=a|0;if(!a)return;hx(a);cYc(a);return}function hx(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;do{d=g+-56|0;f[c>>2]=d;h=g+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)V$(d);f[h>>2]=0;h=g+-40|0;d=g+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[d>>2]|0)>0){h=f[g+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+-12>>2]|0;if((d|0)!=(g+-8|0))wL(d);g=f[c>>2]|0}while((g|0)!=(b|0));e=f[a>>2]|0}cYc(e);return}function ix(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function jx(a){a=a|0;return xj[a&63]()|0}function kx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function lx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function mx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function nx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function ox(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=$Xc(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;U$(b,a);return b|0}return 0}function px(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function qx(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){vx(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[c>>2]=d+16;return}}function rx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>4;i=e;if(h>>>0<b>>>0){wx(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<4)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-16-h|0)>>>4)<<4);return}function sx(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>4|0}function tx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>4>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=$Xc(16)|0;f[g>>2]=f[h+(c<<4)>>2];f[g+4>>2]=f[h+(c<<4)+4>>2];f[g+8>>2]=f[h+(c<<4)+8>>2];f[g+12>>2]=f[h+(c<<4)+12>>2];f[e>>2]=g;i=bf(4176,e|0)|0;f[a>>2]=i;u=d;return}function ux(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<4)>>2]=f[c>>2];f[d+(b<<4)+4>>2]=f[c+4>>2];f[d+(b<<4)+8>>2]=f[c+8>>2];f[d+(b<<4)+12>>2]=f[c+12>>2];return 1}function vx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function wx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>4>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=b;n=i;while(1){f[n>>2]=f[c>>2];f[n+4>>2]=f[j>>2];f[n+8>>2]=f[k>>2];f[n+12>>2]=f[l>>2];m=m+-1|0;if(!m)break;else n=n+16|0}f[g>>2]=i+(b<<4);return}n=f[a>>2]|0;m=h-n>>4;h=m+b|0;l=n;if(h>>>0>268435455)kWc(a);k=e-n|0;e=k>>3;j=k>>4>>>0<134217727?(e>>>0<h>>>0?h:e):268435455;do if(j)if(j>>>0>268435455){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{o=$Xc(j<<4)|0;break}else o=0;while(0);e=o+(m<<4)|0;m=o+(j<<4)|0;j=c+4|0;o=c+8|0;h=c+12|0;k=b;p=e;while(1){f[p>>2]=f[c>>2];f[p+4>>2]=f[j>>2];f[p+8>>2]=f[o>>2];f[p+12>>2]=f[h>>2];k=k+-1|0;if(!k)break;else p=p+16|0}p=m;m=e+(b<<4)|0;if((i|0)==(l|0)){q=e;r=n}else{b=i+-16-n|0;n=i;i=e;while(1){k=n;n=n+-16|0;f[i+-16>>2]=f[n>>2];f[i+-12>>2]=f[k+-12>>2];f[i+-8>>2]=f[k+-8>>2];f[i+-4>>2]=f[k+-4>>2];if((n|0)==(l|0))break;else i=i+-16|0}q=e+(~(b>>>4)<<4)|0;r=f[a>>2]|0}f[a>>2]=q;f[g>>2]=m;f[d>>2]=p;if(!r)return;cYc(r);return}function xx(a){a=a|0;return 4640}function yx(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);cYc(b)}cYc(a);return}function zx(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Ax(a){a=a|0;return xj[a&63]()|0}function Bx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function Cx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function Dx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function Ex(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Fx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function Gx(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Lx(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];a=d+8|0;d=b+8|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[c>>2]=(f[c>>2]|0)+28;return}}function Hx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/28|0;i=e;if(h>>>0<b>>>0){Mx(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*28|0)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~(((i+-28-h|0)>>>0)/28|0)*28|0);return}function Ix(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/28|0|0}function Jx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((((f[b+4>>2]|0)-g|0)/28|0)>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=$Xc(28)|0;f[g>>2]=f[h+(c*28|0)>>2];f[g+4>>2]=f[h+(c*28|0)+4>>2];b=g+8|0;j=h+(c*28|0)+8|0;f[b>>2]=f[j>>2];f[b+4>>2]=f[j+4>>2];f[b+8>>2]=f[j+8>>2];f[b+12>>2]=f[j+12>>2];f[b+16>>2]=f[j+16>>2];f[e>>2]=g;i=bf(4776,e|0)|0;f[a>>2]=i;u=d;return}function Kx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b*28|0)>>2]=f[c>>2];f[d+(b*28|0)+4>>2]=f[c+4>>2];a=d+(b*28|0)+8|0;b=c+8|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];return 1}function Lx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/28|0;h=g+1|0;i=e;j=d;if(h>>>0>153391689)kWc(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/28|0;e=l<<1;m=l>>>0<76695844?(e>>>0<h>>>0?h:e):153391689;do if(m)if(m>>>0>153391689){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{n=$Xc(m*28|0)|0;break}else n=0;while(0);e=n+(g*28|0)|0;h=e;l=n+(m*28|0)|0;f[e>>2]=f[b>>2];f[n+(g*28|0)+4>>2]=f[b+4>>2];m=n+(g*28|0)+8|0;g=b+8|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];g=e+28|0;if((j|0)==(i|0)){o=h;p=d}else{d=j;j=h;h=e;do{e=d;d=d+-28|0;f[h+-28>>2]=f[d>>2];f[h+-24>>2]=f[e+-24>>2];m=h+-20|0;b=e+-20|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];f[m+16>>2]=f[b+16>>2];h=j+-28|0;j=h}while((d|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!p)return;cYc(p);return}function Mx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/28|0)>>>0>=b>>>0){i=c+4|0;j=c+8|0;k=b;l=h;do{f[l>>2]=f[c>>2];f[l+4>>2]=f[i>>2];m=l+8|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];f[m+16>>2]=f[j+16>>2];l=(f[g>>2]|0)+28|0;f[g>>2]=l;k=k+-1|0}while((k|0)!=0);return}k=f[a>>2]|0;l=(h-k|0)/28|0;h=l+b|0;if(h>>>0>153391689)kWc(a);j=(e-k|0)/28|0;k=j<<1;e=j>>>0<76695844?(k>>>0<h>>>0?h:k):153391689;do if(e)if(e>>>0>153391689){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{n=$Xc(e*28|0)|0;break}else n=0;while(0);k=n+(l*28|0)|0;l=k;h=n+(e*28|0)|0;e=c+4|0;n=c+8|0;j=b;b=l;i=k;do{f[i>>2]=f[c>>2];f[i+4>>2]=f[e>>2];m=i+8|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[m+16>>2]=f[n+16>>2];i=b+28|0;b=i;j=j+-1|0}while((j|0)!=0);j=h;h=f[a>>2]|0;i=f[g>>2]|0;if((i|0)==(h|0)){o=l;p=h}else{n=i;i=l;l=k;do{k=n;n=n+-28|0;f[l+-28>>2]=f[n>>2];f[l+-24>>2]=f[k+-24>>2];e=l+-20|0;c=k+-20|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[e+12>>2]=f[c+12>>2];f[e+16>>2]=f[c+16>>2];l=i+-28|0;i=l}while((n|0)!=(h|0));o=i;p=f[a>>2]|0}f[a>>2]=o;f[g>>2]=b;f[d>>2]=j;if(!p)return;cYc(p);return}function Nx(a){a=a|0;return 4720}function Ox(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~(((d+-28-b|0)>>>0)/28|0)*28|0);cYc(b)}cYc(a);return}function Px(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Qx(a){a=a|0;return xj[a&63]()|0}function Rx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;mi[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;mi[g&2047](a,c);return}}function Sx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;Ti[h&511](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;Ti[h&511](a,c,d);return}}function Tx(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function Ux(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Vx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[a>>2]&511](b,c,d)|0}function Wx(a){a=a|0;return 4608}function Xx(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=a+36|0;c=f[b>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;c=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[a+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+44>>2]|0;if((c|0)!=(a+48|0))wL(c);cYc(a);return}function Yx(){var a=0,b=0,c=0,d=0,e=0;a=$Xc(56)|0;f[a>>2]=1124007936;b=a+8|0;c=a+40|0;d=a+4|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;return a|0}function Zx(a){a=a|0;return xj[a&63]()|0}function _x(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=$Xc(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;U$(b,a);return b|0}return 0}function $x(a,b){a=a|0;b=b|0;return _i[a&2047](b)|0}function ay(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=$Xc(56)|0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=f[b>>2]|0;f[e>>2]=1124007936;b=e+8|0;i=e+40|0;j=e+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=b;b=e+48|0;f[e+44>>2]=b;f[b>>2]=0;f[e+52>>2]=0;f[d>>2]=h;f[d+4>>2]=g;S$(e,2,d,a&4095);u=c;return e|0}function by(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[g>>2]=c;c=Mi[a&1023](e,g)|0;u=d;return c|0}function cy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=$Xc(56)|0;h=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[g>>2]=1124007936;c=g+8|0;i=g+40|0;j=g+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=c;c=g+48|0;f[g+44>>2]=c;f[c>>2]=0;f[g+52>>2]=0;f[e>>2]=h;f[e+4>>2]=a;S$(g,2,e,b&4095);u=d;return g|0}function dy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e+8|0;h=e+4|0;i=e;f[g>>2]=b;f[h>>2]=c;f[i>>2]=d;d=hj[a&511](g,h,i)|0;u=e;return d|0}function ey(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=$Xc(56)|0;i=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[h>>2]=1124007936;c=h+8|0;j=h+40|0;k=h+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=c;c=h+48|0;f[h+44>>2]=c;f[c>>2]=0;f[h+52>>2]=0;f[g>>2]=i;f[g+4>>2]=a;S$(h,2,g,b&4095);lR(h,d)|0;u=e;return h|0}function fy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;f[h>>2]=b;f[i>>2]=c;f[j>>2]=d;d=hh[a&127](h,i,j,e)|0;u=g;return d|0}function gy(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _h[a&127](b,c,d,e,f)|0}function hy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];Ti[a&511](e,g,c);c=$Xc(56)|0;f[c>>2]=f[e>>2];g=e+4|0;a=f[g>>2]|0;f[c+4>>2]=a;b=c+8|0;h=e+8|0;f[b>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=b;b=c+44|0;l=c+48|0;f[b>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[b>>2]=f[n>>2];b=e+40|0;f[k>>2]=f[b>>2];k=e+48|0;f[n>>2]=k;f[b>>2]=h;o=k}f[e>>2]=1124007936;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}wL(o);u=d;return c|0}function iy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;ei[a&511](g,b,c,d);d=$Xc(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}wL(o);u=e;return d|0}function jy(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function ky(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function ly(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[f[a>>2]&2047](d,b);le(f[d>>2]|0);b=f[d>>2]|0;Ae(b|0);u=c;return b|0}function my(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function ny(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function oy(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;Kh[f[a>>2]&15](b,c,d,e,g);return}function py(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function qy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function ry(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;Ti[i&511](e,a,c);c=$Xc(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}wL(o);u=d;return c|0}function sy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1)){i=g;ei[i&511](a,c,d,e);return}else{i=f[(f[a>>2]|0)+g>>2]|0;ei[i&511](a,c,d,e);return}}function ty(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];Ti[j&511](a,g,d);u=e;return}function uy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;ei[j&511](g,a,c,d);d=$Xc(56)|0;f[d>>2]=f[g>>2];c=g+4|0;a=f[c>>2]|0;f[d+4>>2]=a;j=d+8|0;h=g+8|0;f[j>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];b=g+36|0;f[d+36>>2]=f[b>>2];k=d+40|0;f[k>>2]=j;j=d+44|0;l=d+48|0;f[j>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[j>>2]=f[n>>2];j=g+40|0;f[k>>2]=f[j>>2];k=g+48|0;f[n>>2]=k;f[j>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[b>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}wL(o);u=e;return d|0}function vy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;Ti[i&511](e,a,c);c=$Xc(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}wL(o);u=d;return c|0}function wy(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function xy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function yy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function zy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;return Mi[g&1023](a,c)|0}function Ay(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;mi[h&2047](d,a);a=$Xc(56)|0;f[a>>2]=f[d>>2];h=d+4|0;e=f[h>>2]|0;f[a+4>>2]=e;g=a+8|0;b=d+8|0;f[g>>2]=f[b>>2];f[a+12>>2]=f[d+12>>2];i=d+16|0;f[a+16>>2]=f[i>>2];f[a+20>>2]=f[d+20>>2];f[a+24>>2]=f[d+24>>2];f[a+28>>2]=f[d+28>>2];f[a+32>>2]=f[d+32>>2];j=d+36|0;f[a+36>>2]=f[j>>2];k=a+40|0;f[k>>2]=g;g=a+44|0;l=a+48|0;f[g>>2]=l;m=a+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=b;o=k}f[d>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return a|0}wL(o);u=c;return a|0}function By(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[f[a>>2]&31](b,c))}function Cy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e;$h[f[a>>2]&63](g,b,c,d);c=$Xc(56)|0;f[c>>2]=f[g>>2];b=g+4|0;a=f[b>>2]|0;f[c+4>>2]=a;h=c+8|0;i=g+8|0;f[h>>2]=f[i>>2];f[c+12>>2]=f[g+12>>2];j=g+16|0;f[c+16>>2]=f[j>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];k=g+36|0;f[c+36>>2]=f[k>>2];l=c+40|0;f[l>>2]=h;h=c+44|0;m=c+48|0;f[h>>2]=m;n=c+52|0;f[n>>2]=0;f[m>>2]=0;o=g+44|0;if((a|0)<3){a=f[o>>2]|0;f[m>>2]=f[a>>2];f[n>>2]=f[a+4>>2];p=a}else{f[h>>2]=f[o>>2];h=g+40|0;f[l>>2]=f[h>>2];l=g+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[g>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(g+48|0)){u=e;return c|0}wL(p);u=e;return c|0}function Dy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;Ti[f[a>>2]&511](e,b,c);c=$Xc(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}wL(o);u=d;return c|0}function Ey(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;mi[f[a>>2]&2047](d,b);b=$Xc(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}wL(o);u=c;return b|0}function Fy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;Ti[i&511](e,a,c);c=$Xc(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}wL(o);u=d;return c|0}function Gy(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function Hy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function Iy(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[f[a>>2]&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function Jy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[f[a>>2]&511](e,b,c);le(f[e>>2]|0);c=f[e>>2]|0;Ae(c|0);u=d;return c|0}function Ky(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[f[a>>2]&511](g,b,c,d);le(f[g>>2]|0);d=f[g>>2]|0;Ae(d|0);u=e;return d|0}function Ly(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,d)|0;return b[e>>0]|0}function My(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,d,e)|0;return b[g>>0]|0}function Ny(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,d,e,g)|0;return b[h>>0]|0}function Oy(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,d)|0;return b[e>>0]|0}function Py(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,d,e)|0;return b[g>>0]|0}function Qy(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,d,e,g)|0;return b[h>>0]|0}function Ry(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,c)|0;return d[e>>1]|0}function Sy(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,c,e)|0;return d[g>>1]|0}function Ty(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,c,e,g)|0;return d[h>>1]|0}function Uy(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Mi[h&1023](a,c)|0;return d[e>>1]|0}function Vy(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hj[i&511](a,c,e)|0;return d[g>>1]|0}function Wy(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=hh[j&127](a,c,e,g)|0;return d[h>>1]|0}function Xy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Mi[g&1023](a,c)|0;return f[d>>2]|0}function Yy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=hj[h&511](a,c,d)|0;return f[e>>2]|0}function Zy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hh[i&127](a,c,d,e)|0;return f[g>>2]|0}function _y(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Mi[g&1023](a,c)|0;return +(+n[d>>2])}function $y(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=hj[h&511](a,c,d)|0;return +(+n[e>>2])}function az(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hh[i&127](a,c,d,e)|0;return +(+n[g>>2])}function bz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=hh[i&127](a,c,d,e)|0;return +(+p[g>>3])}function cz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Mi[g&1023](a,c)|0;return +(+p[d>>3])}function dz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=hj[h&511](a,c,d)|0;return +(+p[e>>3])}function ez(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function fz(a){a=a|0;if(!a)return;cYc(a);return}function gz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function hz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function iz(){var a=0;a=$Xc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function jz(a){a=a|0;if(!a)return;cYc(a);return}function kz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function lz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function mz(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function nz(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function oz(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function pz(a){a=a|0;if(!a)return;cYc(a);return}function qz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function rz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function sz(){var a=0;a=$Xc(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function tz(a){a=a|0;if(!a)return;cYc(a);return}function uz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function vz(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function wz(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function xz(a){a=a|0;if(!a)return;cYc(a);return}function yz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function zz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Az(){var a=0;a=$Xc(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function Bz(a){a=a|0;if(!a)return;cYc(a);return}function Cz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Dz(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Ez(){var a=0;a=$Xc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function Fz(a){a=a|0;if(!a)return;cYc(a);return}function Gz(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Hz(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Iz(){var a=0;a=$Xc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function Jz(a){a=a|0;if(!a)return;cYc(a);return}function Kz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Lz(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Mz(){var a=0;a=$Xc(20)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;return a|0}function Nz(a){a=a|0;if(!a)return;cYc(a);return}function Oz(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Pz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Qz(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Rz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Sz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Tz(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Uz(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);le(f[d>>2]|0);b=f[d>>2]|0;Ae(b|0);u=c;return b|0}function Vz(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function Wz(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function Xz(){var a=0;a=$Xc(28)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;n[a+8>>2]=0.0;n[a+12>>2]=-1.0;n[a+16>>2]=0.0;f[a+20>>2]=0;f[a+24>>2]=-1;return a|0}function Yz(a){a=a|0;if(!a)return;cYc(a);return}function Zz(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function _z(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function $z(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function aA(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function bA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function cA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function dA(){var a=0;a=$Xc(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function eA(a){a=a|0;if(!a)return;cYc(a);return}function fA(a,b){a=a|0;b=b|0;return +(+p[b+(a<<3)>>3])}function gA(a,b,c){a=a|0;b=b|0;c=+c;p[b+(a<<3)>>3]=c;return}function hA(){var a=0;a=$Xc(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function iA(a){a=a|0;if(!a)return;cYc(a);return}function jA(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function kA(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function lA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function mA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function nA(){var a=0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function oA(a){a=a|0;if(!a)return;cYc(a);return}function pA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function qA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function rA(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function sA(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function tA(){var a=0;a=$Xc(192)|0;Mwa(a);return a|0}function uA(a){a=a|0;if(!a)return;cYc(a);return}function vA(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function wA(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function xA(){var a=0;a=$Xc(60)|0;eN(a);return a|0}function yA(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function zA(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function AA(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function BA(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function CA(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)jYc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=$Xc(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){o1c(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;mi[h&2047](c,g);if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function DA(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+64|0;d=c;mi[a&2047](d,b);b=$Xc(60)|0;xk(b,d);qM(d);u=c;return b|0}function EA(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(12)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];u=c;return b|0}function FA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;Ti[a&511](e,b,c);c=$Xc(32)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];u=d;return c|0}function GA(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;mi[a&2047](d,b);b=$Xc(32)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];u=c;return b|0}function HA(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;Yi[a&4095](c);a=$Xc(32)|0;p[a>>3]=+p[c>>3];p[a+8>>3]=+p[c+8>>3];p[a+16>>3]=+p[c+16>>3];p[a+24>>3]=+p[c+24>>3];u=b;return a|0}function IA(a,b){a=a|0;b=b|0;return _i[a&2047](b)|0}function JA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;h=e+16|0;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];ei[a&511](h,b,c,g);le(f[h>>2]|0);g=f[h>>2]|0;Ae(g|0);u=e;return g|0}function KA(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;Yi[a&4095](d);a=b[d+11>>0]|0;e=a<<24>>24<0;g=e?f[d+4>>2]|0:a&255;a=jIc(g+4|0)|0;f[a>>2]=g;h=f[d>>2]|0;o1c(a+4|0,(e?h:d)|0,g|0)|0;if(!e){u=c;return a|0}cYc(h);u=c;return a|0}function LA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function MA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function NA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/28|0;h=g+1|0;i=e;j=d;if(h>>>0>153391689)kWc(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/28|0;e=l<<1;m=l>>>0<76695844?(e>>>0<h>>>0?h:e):153391689;do if(m)if(m>>>0>153391689){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{n=$Xc(m*28|0)|0;break}else n=0;while(0);e=n+(g*28|0)|0;h=e;l=n+(m*28|0)|0;f[e>>2]=f[b>>2];f[n+(g*28|0)+4>>2]=f[b+4>>2];m=n+(g*28|0)+8|0;g=b+8|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];g=e+28|0;if((j|0)==(i|0)){o=h;p=d}else{d=j;j=h;h=e;do{e=d;d=d+-28|0;f[h+-28>>2]=f[d>>2];f[h+-24>>2]=f[e+-24>>2];m=h+-20|0;b=e+-20|0;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[m+8>>2]=f[b+8>>2];f[m+12>>2]=f[b+12>>2];f[m+16>>2]=f[b+16>>2];h=j+-28|0;j=h}while((d|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=g;f[k>>2]=l;if(!p)return;cYc(p);return}function OA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;cYc(d);return}function PA(a,c){a=a|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=+pe(f[c>>2]|0,4984,e|0);c=f[e>>2]|0;e=~~g>>>0;h=e+4|0;i=f[e>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(i>>>0>4294967279)jYc(a);if(i>>>0<11){b[a+11>>0]=i;if(!i){j=a;k=j+i|0;b[k>>0]=0;Ie(c|0);u=d;return}else l=a}else{e=i+16&-16;m=$Xc(e)|0;f[a>>2]=m;f[a+8>>2]=e|-2147483648;f[a+4>>2]=i;l=m}o1c(l|0,h|0,i|0)|0;j=l;k=j+i|0;b[k>>0]=0;Ie(c|0);u=d;return}function QA(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[a>>2]|0;g=((f[d>>2]|0)-e|0)/12|0;h=g+1|0;if(h>>>0>357913941)kWc(a);i=a+8|0;j=((f[i>>2]|0)-e|0)/12|0;e=j<<1;k=j>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(k)if(k>>>0>357913941){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{l=$Xc(k*12|0)|0;break}else l=0;while(0);e=l+(g*12|0)|0;g=e;h=l+(k*12|0)|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=e+12|0;k=f[a>>2]|0;l=f[d>>2]|0;if((l|0)==(k|0)){m=g;n=k;o=k}else{j=l;l=g;g=e;do{e=g+-12|0;j=j+-12|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;g=l+-12|0;l=g}while((j|0)!=(k|0));m=l;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=h;h=n;if((o|0)!=(h|0)){i=o;do{i=i+-12|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}while((i|0)!=(h|0))}if(!n)return;cYc(n);return}function RA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;Ig[a&3](b,c,d,e,f,g);return}function SA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;Ni[a&7](b,c,d,e,f);return}function TA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;qi[a&7](b,c,d,e);return}function UA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b,c,d,e,f,g);return}function VA(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Kh[a&15](b,c,d,e,f);return}function WA(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];Zh[a&7](b,c,j,e,g,h);u=i;return}function XA(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];Kh[a&15](b,c,i,e,g);u=h;return}function YA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];$h[a&63](b,c,h,e);u=g;return}function ZA(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Bh[a&1](b,c,d,e,f,g,h,i,j);return}function _A(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;Ag[a&1](b,c,d,e,f,g,h,i);return}function $A(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;Eg[a&1](b,c,d,e,f,g,h);return}function aB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Th[a&3](b,c,d,e,f,g);return}function bB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Kh[a&15](b,c,d,e,f);return}function cB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;Mg[a&1](b,c,d,e,f,g,h,i,j);return}function dB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;Nh[a&1](b,c,d,e,f,g,h,i);return}function eB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;Gg[a&3](b,c,d,e,f,g,h);return}function fB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;Jg[a&3](b,c,d,e,f,g);return}function gB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;zg[a&7](b,c,d,e,f,g,h);return}function hB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Jj[a&7](b,c,d,e,f,g);return}function iB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ni[a&31](b,c,d,e,f);return}function jB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function kB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function lB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;ug[a&3](b,c,d,e,f,g,h,i);return}function mB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;Tg[a&3](b,c,d,e,f,g,h);return}function nB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Dh[a&15](b,c,d,e,f,g);return}function oB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function pB(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;zi[a&3](b,c,d,e,f,g,h,i,j);return}function qB(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;bj[a&3](b,c,d,e,f,g,h,i);return}function rB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Ki[a&7](b,c,d,e,f,g,h);return}function sB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function tB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function uB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;th[a&1](b,c,d,e,f,g,h);return}function vB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function wB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function xB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Bj[a&1](b,c,d,e,f,g,h);return}function yB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aj[a&1](b,c,d,e,f,g);return}function zB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ri[a&15](b,c,d,e);return}function AB(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function BB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b,c,d,e,f,g);return}function CB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function DB(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function EB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];gi[a&255](b,c,i,j,g);u=h;return}function FB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];ei[a&511](b,c,h,i);u=g;return}function GB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];Ti[a&511](b,c,g);u=e;return}function HB(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function IB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Ii[a&127](b,c,d,k,l,h,i);u=j;return}function JB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Fh[a&255](b,c,d,j,k,h);u=i;return}function KB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];gi[a&255](b,c,d,i,j);u=h;return}function LB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];ei[a&511](b,c,d,h);u=g;return}function MB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+4|0;k=i;f[j>>2]=c;f[k>>2]=g;Dh[a&15](b,j,d,e,k,h);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=i;return}function NB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j+4|0;m=j;f[k>>2]=c;f[l>>2]=g;f[m>>2]=h;Ii[a&127](b,k,d,e,l,m,i);Ae(f[m>>2]|0);Ae(f[l>>2]|0);Ae(f[k>>2]|0);u=j;return}function OB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i+4|0;l=i;f[j>>2]=c;f[k>>2]=g;f[l>>2]=h;Fh[a&255](b,j,d,e,k,l);Ae(f[l>>2]|0);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=i;return}function PB(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;Xh[a&1](b,c,d,e,f,g,h,i,j,k);return}function QB(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;var n=0,o=0,p=0;n=u;u=u+32|0;o=n;p=n+16|0;f[p>>2]=f[i>>2];f[p+4>>2]=f[i+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];Dg[a&1](b,c,d,e,g,h,p,j,o,l,m);u=n;return}function RB(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+32|0;n=m;o=m+16|0;f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];f[n+12>>2]=f[k+12>>2];Oh[a&7](b,c,d,e,g,h,o,j,n,l);u=m;return}function SB(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+32|0;m=l;n=l+16|0;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];f[m+8>>2]=f[k+8>>2];f[m+12>>2]=f[k+12>>2];Li[a&127](b,c,d,e,g,h,n,j,m);u=l;return}function TB(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];wi[a&255](b,c,d,e,g,h,l,j);u=k;return}function UB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];Ii[a&127](b,c,d,e,g,h,k);u=j;return}function VB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function WB(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function XB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function YB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Ii[a&127](b,k,d,e,g,h,i);u=j;return}function ZB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Fh[a&255](b,j,d,e,g,h);u=i;return}function _B(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];gi[a&255](b,i,d,e,g);u=h;return}function $B(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];ei[a&511](b,h,d,e);u=g;return}function aC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function bC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function cC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b,c,d,e)|0}function dC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b,c,d)|0}function eC(a,b,c){a=a|0;b=b|0;c=c|0;return Mi[a&1023](b,c)|0}function fC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xg[a&127](b,c,d,e,f,g)|0}function gC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _h[a&127](b,c,d,e,f)|0}function hC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b,c,d,e)|0}function iC(a,b){a=a|0;b=b|0;return +(+Vg[a&31](b))}function jC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;Vi[a&63](b,c,d);return}function kC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function lC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function mC(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wi[a&255](b,c,d,e,f,g,h,i);return}function nC(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b,c,d,e,f,g,h);return}function oC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ej[a&15](b,c,d,e,f,g);return}function pC(a,b){a=a|0;b=b|0;return _i[a&2047](b)|0}function qC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Ii[a&127](b,c,d,k,g,h,i);u=j;return}function rC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];Fh[a&255](b,c,d,j,g,h);u=i;return}function sC(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];gi[a&255](b,c,d,i,g);u=h;return}function tC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];ei[a&511](b,c,d,h);u=g;return}function uC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function vC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function wC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;Lh[a&7](b,c,d,e,f);return}function xC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[a&63](b,c,d,e);return}function yC(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Pi[a&1](b,c,d,e);return}function zC(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;$g[a&1](b,c,d);return}function AC(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];Li[a&127](b,c,d,e,g,h,i,j,m);u=l;return}function BC(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wi[a&255](b,c,d,e,f,g,h,i);return}function CC(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b,c,d,e,f,g,h);return}function DC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function EC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function FC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function GC(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0;m=u;u=u+16|0;n=m+12|0;o=m+8|0;p=m+4|0;q=m;f[n>>2]=c;f[o>>2]=e;f[p>>2]=g;f[q>>2]=k;Oh[a&7](b,n,d,o,p,h,i,j,q,l);Ae(f[q>>2]|0);Ae(f[p>>2]|0);Ae(f[o>>2]|0);Ae(f[n>>2]|0);u=m;return}function HC(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;f[m>>2]=c;f[n>>2]=e;f[o>>2]=g;f[p>>2]=k;Li[a&127](b,m,d,n,o,h,i,j,p);Ae(f[p>>2]|0);Ae(f[o>>2]|0);Ae(f[n>>2]|0);Ae(f[m>>2]|0);u=l;return}function IC(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k+4|0;n=k;f[l>>2]=c;f[m>>2]=e;f[n>>2]=g;wi[a&255](b,l,d,m,n,h,i,j);Ae(f[n>>2]|0);Ae(f[m>>2]|0);Ae(f[l>>2]|0);u=k;return}function JC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j+4|0;m=j;f[k>>2]=c;f[l>>2]=e;f[m>>2]=g;Ii[a&127](b,k,d,l,m,h,i);Ae(f[m>>2]|0);Ae(f[l>>2]|0);Ae(f[k>>2]|0);u=j;return}function KC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i+4|0;l=i;f[j>>2]=c;f[k>>2]=e;f[l>>2]=g;Fh[a&255](b,j,d,k,l,h);Ae(f[l>>2]|0);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=i;return}function LC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b,c,d)|0}function MC(a,b,c){a=a|0;b=b|0;c=c|0;return Mi[a&1023](b,c)|0}function NC(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+16|0;n=m+8|0;o=m;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];xi[a&1](b,n,o,e,g,h,i,j,k,l);u=m;return}function OC(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l+8|0;n=l;f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];sh[a&1](b,m,n,e,g,h,i,j,k);u=l;return}function PC(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k+8|0;m=k;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];vi[a&1](b,l,m,e,g,h,i,j);u=k;return}function QC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];jh[a&1](b,k,l,e,g,h,i);u=j;return}function RC(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function SC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function TC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function UC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Ii[a&127](k,l,d,e,g,h,i);u=j;return}function VC(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Lg[a&7](b,c,d,e,k,h,i);u=j;return}function WC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];Dh[a&15](b,c,d,e,j,h);u=i;return}function XC(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];gi[a&255](b,c,d,e,i);u=h;return}function YC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function ZC(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];Fh[a&255](b,c,d,e,g,j);u=i;return}function _C(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function $C(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];k=+zj[a&3](b,c,d,e,j,h);u=i;return +k}function aD(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];j=+pj[a&7](b,c,d,e,i);u=h;return +j}function bD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Ai[a&15](b,c,d,e))}function cD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function dD(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;mi[a&2047](d,b);b=$Xc(20)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];u=c;return b|0}function eD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;ij[a&1](b,c,d,e,f,g,h);return}function fD(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Fj[a&1](b,c,d,e,f,g);return}function gD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;Ti[a&511](e,b,c);c=$Xc(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}wL(o);u=d;return c|0}function hD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;ei[a&511](g,b,c,d);d=$Xc(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}wL(o);u=e;return d|0}function iD(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+8|0;h=e;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];qi[a&7](g,h,c,d);h=$Xc(56)|0;f[h>>2]=f[g>>2];a=g+4|0;b=f[a>>2]|0;f[h+4>>2]=b;i=h+8|0;j=g+8|0;f[i>>2]=f[j>>2];f[h+12>>2]=f[g+12>>2];k=g+16|0;f[h+16>>2]=f[k>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];l=g+36|0;f[h+36>>2]=f[l>>2];m=h+40|0;f[m>>2]=i;i=h+44|0;n=h+48|0;f[i>>2]=n;o=h+52|0;f[o>>2]=0;f[n>>2]=0;p=g+44|0;if((b|0)<3){b=f[p>>2]|0;f[n>>2]=f[b>>2];f[o>>2]=f[b+4>>2];q=b}else{f[i>>2]=f[p>>2];i=g+40|0;f[m>>2]=f[i>>2];m=g+48|0;f[p>>2]=m;f[i>>2]=j;q=m}f[g>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[l>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((q|0)==(g+48|0)){u=e;return h|0}wL(q);u=e;return h|0}function jD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+80|0;g=e+16|0;h=e+8|0;i=e;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];ei[a&511](g,b,h,i);i=$Xc(56)|0;f[i>>2]=f[g>>2];h=g+4|0;b=f[h>>2]|0;f[i+4>>2]=b;a=i+8|0;d=g+8|0;f[a>>2]=f[d>>2];f[i+12>>2]=f[g+12>>2];c=g+16|0;f[i+16>>2]=f[c>>2];f[i+20>>2]=f[g+20>>2];f[i+24>>2]=f[g+24>>2];f[i+28>>2]=f[g+28>>2];f[i+32>>2]=f[g+32>>2];j=g+36|0;f[i+36>>2]=f[j>>2];k=i+40|0;f[k>>2]=a;a=i+44|0;l=i+48|0;f[a>>2]=l;m=i+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=d;o=k}f[g>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((o|0)==(g+48|0)){u=e;return i|0}wL(o);u=e;return i|0}function kD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];Ti[a&511](e,b,g);g=$Xc(56)|0;f[g>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[g+4>>2]=a;c=g+8|0;h=e+8|0;f[c>>2]=f[h>>2];f[g+12>>2]=f[e+12>>2];i=e+16|0;f[g+16>>2]=f[i>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];f[g+28>>2]=f[e+28>>2];f[g+32>>2]=f[e+32>>2];j=e+36|0;f[g+36>>2]=f[j>>2];k=g+40|0;f[k>>2]=c;c=g+44|0;l=g+48|0;f[c>>2]=l;m=g+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[c>>2]=f[n>>2];c=e+40|0;f[k>>2]=f[c>>2];k=e+48|0;f[n>>2]=k;f[c>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return g|0}wL(o);u=d;return g|0}function lD(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;eh[a&1](b,c,d,e,f,g,h,i,j);return}function mD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;fj[a&3](b,c,d,e,f,g,h,i);return}function nD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Rg[a&3](b,c,d,e,f,g,h);return}function oD(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b,c,d,e,f,g);return}function pD(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;Yh[a&1](b,c,d,e,f,g,h,i,j,k);return}function qD(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;dh[a&1](b,c,d,e,f,g,h,i,j);return}function rD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;fj[a&3](b,c,d,e,f,g,h,i);return}function sD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[k+8>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];Ii[a&127](b,c,k,e,g,h,i);u=j;return}function tD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];Fh[a&255](b,c,j,e,g,h);u=i;return}function uD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[a&63](b,c,d,e);return}function vD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function wD(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function xD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function yD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function zD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function AD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function BD(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function CD(a,b){a=a|0;b=b|0;return _i[a&2047](b)|0}function DD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[k+8>>2]=f[e+8>>2];f[k+12>>2]=f[e+12>>2];l=+ah[a&3](b,c,d,k,g,h,i);u=j;return +l}function ED(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];k=+zj[a&3](b,c,d,j,g,h);u=i;return +k}function FD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];Ii[a&127](b,k,l,e,g,h,i);u=j;return}function GD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Fh[a&255](b,j,k,e,g,h);u=i;return}function HD(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];gi[a&255](b,i,j,e,g);u=h;return}function ID(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];ei[a&511](b,h,i,e);u=g;return}function JD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +(+ui[a&1](b,c,d,e))}function KD(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function LD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;Ti[a&511](e,b,c);c=$Xc(32)|0;p[c>>3]=+p[e>>3];p[c+8>>3]=+p[e+8>>3];p[c+16>>3]=+p[e+16>>3];p[c+24>>3]=+p[e+24>>3];u=d;return c|0}function MD(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;mi[a&2047](d,b);b=$Xc(32)|0;p[b>>3]=+p[d>>3];p[b+8>>3]=+p[d+8>>3];p[b+16>>3]=+p[d+16>>3];p[b+24>>3]=+p[d+24>>3];u=c;return b|0}function ND(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function OD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;Ti[a&511](b,c,g);Ae(f[g>>2]|0);u=e;return}function PD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+192|0;e=d;Ti[a&511](e,b,c);c=$Xc(192)|0;o1c(c|0,e|0,192)|0;u=d;return c|0}function QD(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+192|0;d=c;mi[a&2047](d,b);b=$Xc(192)|0;o1c(b|0,d|0,192)|0;u=c;return b|0}function RD(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];wi[a&255](b,c,d,e,l,h,i,j);u=k;return}function SD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Ii[a&127](b,c,d,e,k,h,i);u=j;return}function TD(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];Fh[a&255](b,c,d,e,j,h);u=i;return}function UD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+Sh[a&31](b,c,d))}function VD(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function WD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Ai[a&15](b,c,d,e))}function XD(a,b,c){a=a|0;b=b|0;c=c|0;return +(+ch[a&31](b,c))}function YD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;ph[a&1](b,c,d,e,f,g,h);return}function ZD(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;Ig[a&3](b,c,d,e,f,g);return}function _D(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0;e=u;u=u+16|0;g=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];h=+Sh[a&31](b,g,d);u=e;return +h}function $D(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;Hg[a&15](b,c,d);return}function aE(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;m=u;u=u+64|0;n=m+40|0;o=m+32|0;q=m;r=d+4|0;s=f[d>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;if(s>>>0>4294967279)jYc(n);if(s>>>0<11){b[n+11>>0]=s;if(!s)t=n;else{v=n;w=6}}else{d=s+16&-16;x=$Xc(d)|0;f[n>>2]=x;f[n+8>>2]=d|-2147483648;f[n+4>>2]=s;v=x;w=6}if((w|0)==6){o1c(v|0,r|0,s|0)|0;t=v}b[t+s>>0]=0;f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];p[q>>3]=+p[i>>3];p[q+8>>3]=+p[i+8>>3];p[q+16>>3]=+p[i+16>>3];p[q+24>>3]=+p[i+24>>3];uh[a&7](c,n,o,g,h,q,j,k,l);if((b[n+11>>0]|0)>=0){u=m;return}cYc(f[n>>2]|0);u=m;return}function bE(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;l=u;u=u+64|0;m=l+40|0;n=l+32|0;o=l;q=d+4|0;r=f[d>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(r>>>0>4294967279)jYc(m);if(r>>>0<11){b[m+11>>0]=r;if(!r)s=m;else{t=m;v=6}}else{d=r+16&-16;w=$Xc(d)|0;f[m>>2]=w;f[m+8>>2]=d|-2147483648;f[m+4>>2]=r;t=w;v=6}if((v|0)==6){o1c(t|0,q|0,r|0)|0;s=t}b[s+r>>0]=0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];p[o>>3]=+p[i>>3];p[o+8>>3]=+p[i+8>>3];p[o+16>>3]=+p[i+16>>3];p[o+24>>3]=+p[i+24>>3];tg[a&7](c,m,n,g,h,o,j,k);if((b[m+11>>0]|0)>=0){u=l;return}cYc(f[m>>2]|0);u=l;return}function cE(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0;k=u;u=u+64|0;l=k+40|0;m=k+32|0;n=k;o=d+4|0;q=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if(q>>>0>4294967279)jYc(l);if(q>>>0<11){b[l+11>>0]=q;if(!q)r=l;else{s=l;t=6}}else{d=q+16&-16;v=$Xc(d)|0;f[l>>2]=v;f[l+8>>2]=d|-2147483648;f[l+4>>2]=q;s=v;t=6}if((t|0)==6){o1c(s|0,o|0,q|0)|0;r=s}b[r+q>>0]=0;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=+p[i>>3];p[n+8>>3]=+p[i+8>>3];p[n+16>>3]=+p[i+16>>3];p[n+24>>3]=+p[i+24>>3];oj[a&7](c,l,m,g,h,n,j);if((b[l+11>>0]|0)>=0){u=k;return}cYc(f[l>>2]|0);u=k;return}function dE(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+64|0;k=j+40|0;l=j+32|0;m=j;n=d+4|0;o=f[d>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(o>>>0>4294967279)jYc(k);if(o>>>0<11){b[k+11>>0]=o;if(!o)q=k;else{r=k;s=6}}else{d=o+16&-16;t=$Xc(d)|0;f[k>>2]=t;f[k+8>>2]=d|-2147483648;f[k+4>>2]=o;r=t;s=6}if((s|0)==6){o1c(r|0,n|0,o|0)|0;q=r}b[q+o>>0]=0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=+p[i>>3];p[m+8>>3]=+p[i+8>>3];p[m+16>>3]=+p[i+16>>3];p[m+24>>3]=+p[i+24>>3];ej[a&15](c,k,l,g,h,m);if((b[k+11>>0]|0)>=0){u=j;return}cYc(f[k>>2]|0);u=j;return}function eE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function fE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function gE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b,c,d);return}function hE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];f[j+12>>2]=f[c+12>>2];Fh[a&255](b,j,d,e,g,h);u=i;return}function iE(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];gi[a&255](b,i,d,e,g);u=h;return}function jE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[h+8>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];ei[a&511](b,h,d,e);u=g;return}function kE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];Ti[a&511](b,g,d);u=e;return}function lE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b,c,d,e,f,g,h);return}function mE(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b,c,d,e,f,g);return}function nE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function oE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b,c,d,e);return}function pE(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];Hh[a&3](b,c,d,e,g,l,i,j);u=k;return}function qE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];Ki[a&7](b,c,d,e,g,k,i);u=j;return}function rE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];Fh[a&255](b,c,d,e,g,j);u=i;return}function sE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b,c,d,e,f);return}function tE(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function uE(a,b){a=a|0;b=b|0;Yi[a&4095](b);return}function vE(a,b){a=a|0;b=b|0;Yi[a&4095](b);return}function wE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b,c,d,e)|0}function xE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b,c,d)|0}function yE(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b,c);return}function zE(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +(+Qh[a&1](b,c,d,e,f))}function AE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Ii[a&127](b,c,d,k,g,h,i);u=j;return}function BE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];Fh[a&255](b,c,d,j,g,h);u=i;return}function CE(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];gi[a&255](b,c,d,i,g);u=h;return}function DE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];ei[a&511](b,c,d,h);u=g;return}function EE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=u;u=u+64|0;k=j;Uh[a&3](k,b,c,d,e,g,h,i);i=$Xc(56)|0;f[i>>2]=f[k>>2];h=k+4|0;g=f[h>>2]|0;f[i+4>>2]=g;e=i+8|0;d=k+8|0;f[e>>2]=f[d>>2];f[i+12>>2]=f[k+12>>2];b=k+16|0;f[i+16>>2]=f[b>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[i+32>>2]=f[k+32>>2];a=k+36|0;f[i+36>>2]=f[a>>2];l=i+40|0;f[l>>2]=e;e=i+44|0;m=i+48|0;f[e>>2]=m;n=i+52|0;f[n>>2]=0;f[m>>2]=0;o=k+44|0;if((g|0)<3){g=f[o>>2]|0;f[m>>2]=f[g>>2];f[n>>2]=f[g+4>>2];p=g}else{f[e>>2]=f[o>>2];e=k+40|0;f[l>>2]=f[e>>2];l=k+48|0;f[o>>2]=l;f[e>>2]=d;p=l}f[k>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((p|0)==(k+48|0)){u=j;return i|0}wL(p);u=j;return i|0}function FE(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+64|0;j=i;vh[a&3](j,b,c,d,e,g,h);h=$Xc(56)|0;f[h>>2]=f[j>>2];g=j+4|0;e=f[g>>2]|0;f[h+4>>2]=e;d=h+8|0;b=j+8|0;f[d>>2]=f[b>>2];f[h+12>>2]=f[j+12>>2];a=j+16|0;f[h+16>>2]=f[a>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];k=j+36|0;f[h+36>>2]=f[k>>2];l=h+40|0;f[l>>2]=d;d=h+44|0;m=h+48|0;f[d>>2]=m;n=h+52|0;f[n>>2]=0;f[m>>2]=0;o=j+44|0;if((e|0)<3){e=f[o>>2]|0;f[m>>2]=f[e>>2];f[n>>2]=f[e+4>>2];p=e}else{f[d>>2]=f[o>>2];d=j+40|0;f[l>>2]=f[d>>2];l=j+48|0;f[o>>2]=l;f[d>>2]=b;p=l}f[j>>2]=1124007936;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[k>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((p|0)==(j+48|0)){u=i;return h|0}wL(p);u=i;return h|0}function GE(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+64|0;i=h;Bg[a&3](i,b,c,d,e,g);g=$Xc(56)|0;f[g>>2]=f[i>>2];e=i+4|0;d=f[e>>2]|0;f[g+4>>2]=d;b=g+8|0;a=i+8|0;f[b>>2]=f[a>>2];f[g+12>>2]=f[i+12>>2];j=i+16|0;f[g+16>>2]=f[j>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];k=i+36|0;f[g+36>>2]=f[k>>2];l=g+40|0;f[l>>2]=b;b=g+44|0;m=g+48|0;f[b>>2]=m;n=g+52|0;f[n>>2]=0;f[m>>2]=0;o=i+44|0;if((d|0)<3){d=f[o>>2]|0;f[m>>2]=f[d>>2];f[n>>2]=f[d+4>>2];p=d}else{f[b>>2]=f[o>>2];b=i+40|0;f[l>>2]=f[b>>2];l=i+48|0;f[o>>2]=l;f[b>>2]=a;p=l}f[i>>2]=1124007936;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(i+48|0)){u=h;return g|0}wL(p);u=h;return g|0}function HE(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+64|0;h=g;bi[a&3](h,b,c,d,e);e=$Xc(56)|0;f[e>>2]=f[h>>2];d=h+4|0;b=f[d>>2]|0;f[e+4>>2]=b;a=e+8|0;i=h+8|0;f[a>>2]=f[i>>2];f[e+12>>2]=f[h+12>>2];j=h+16|0;f[e+16>>2]=f[j>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];k=h+36|0;f[e+36>>2]=f[k>>2];l=e+40|0;f[l>>2]=a;a=e+44|0;m=e+48|0;f[a>>2]=m;n=e+52|0;f[n>>2]=0;f[m>>2]=0;o=h+44|0;if((b|0)<3){b=f[o>>2]|0;f[m>>2]=f[b>>2];f[n>>2]=f[b+4>>2];p=b}else{f[a>>2]=f[o>>2];a=h+40|0;f[l>>2]=f[a>>2];l=h+48|0;f[o>>2]=l;f[a>>2]=i;p=l}f[h>>2]=1124007936;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(h+48|0)){u=g;return e|0}wL(p);u=g;return e|0}function IE(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e;ri[a&15](g,b,c,d);d=$Xc(56)|0;f[d>>2]=f[g>>2];b=g+4|0;a=f[b>>2]|0;f[d+4>>2]=a;h=d+8|0;i=g+8|0;f[h>>2]=f[i>>2];f[d+12>>2]=f[g+12>>2];j=g+16|0;f[d+16>>2]=f[j>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=g+36|0;f[d+36>>2]=f[k>>2];l=d+40|0;f[l>>2]=h;h=d+44|0;m=d+48|0;f[h>>2]=m;n=d+52|0;f[n>>2]=0;f[m>>2]=0;o=g+44|0;if((a|0)<3){a=f[o>>2]|0;f[m>>2]=f[a>>2];f[n>>2]=f[a+4>>2];p=a}else{f[h>>2]=f[o>>2];h=g+40|0;f[l>>2]=f[h>>2];l=g+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[g>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(g+48|0)){u=e;return d|0}wL(p);u=e;return d|0}function JE(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d;Vi[a&63](e,b,c);b=$Xc(56)|0;f[b>>2]=f[e>>2];a=e+4|0;g=f[a>>2]|0;f[b+4>>2]=g;h=b+8|0;i=e+8|0;f[h>>2]=f[i>>2];f[b+12>>2]=f[e+12>>2];j=e+16|0;f[b+16>>2]=f[j>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];f[b+28>>2]=f[e+28>>2];f[b+32>>2]=f[e+32>>2];k=e+36|0;f[b+36>>2]=f[k>>2];l=b+40|0;f[l>>2]=h;h=b+44|0;m=b+48|0;f[h>>2]=m;n=b+52|0;f[n>>2]=0;f[m>>2]=0;o=e+44|0;if((g|0)<3){g=f[o>>2]|0;f[m>>2]=f[g>>2];f[n>>2]=f[g+4>>2];p=g}else{f[h>>2]=f[o>>2];h=e+40|0;f[l>>2]=f[h>>2];l=e+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(e+48|0)){u=d;return b|0}wL(p);u=d;return b|0}function KE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;mi[a&2047](d,b);b=$Xc(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}wL(o);u=c;return b|0}function LE(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+40|0;i=g+24|0;j=g+12|0;k=g;l=c+4|0;m=f[c>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)jYc(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)n=i;else{o=i;p=6}}else{c=m+16&-16;q=$Xc(c)|0;f[i>>2]=q;f[i+8>>2]=c|-2147483648;f[i+4>>2]=m;o=q;p=6}if((p|0)==6){o1c(o|0,l|0,m|0)|0;n=o}b[n+m>>0]=0;m=d+4|0;n=f[d>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)jYc(j);if(n>>>0<11){b[j+11>>0]=n;if(!n)r=j;else{s=j;p=12}}else{d=n+16&-16;o=$Xc(d)|0;f[j>>2]=o;f[j+8>>2]=d|-2147483648;f[j+4>>2]=n;s=o;p=12}if((p|0)==12){o1c(s|0,m|0,n|0)|0;r=s}b[r+n>>0]=0;n=e+4|0;r=f[e>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(r>>>0>4294967279)jYc(k);if(r>>>0<11){b[k+11>>0]=r;if(!r)t=k;else{v=k;p=18}}else{e=r+16&-16;s=$Xc(e)|0;f[k>>2]=s;f[k+8>>2]=e|-2147483648;f[k+4>>2]=r;v=s;p=18}if((p|0)==18){o1c(v|0,n|0,r|0)|0;t=v}b[t+r>>0]=0;ei[a&511](h,i,j,k);a=$Xc(8)|0;f[a>>2]=f[h>>2];r=f[h+4>>2]|0;f[a+4>>2]=r;if(r|0)TXc(r);ROa(h);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[i+11>>0]|0)>=0){u=g;return a|0}cYc(f[i>>2]|0);u=g;return a|0}function ME(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+32|0;g=e+24|0;h=e+12|0;i=e;j=c+4|0;k=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)jYc(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{c=k+16&-16;o=$Xc(c)|0;f[h>>2]=o;f[h+8>>2]=c|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){o1c(m|0,j|0,k|0)|0;l=m}b[l+k>>0]=0;k=d+4|0;l=f[d>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)jYc(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)p=i;else{q=i;n=12}}else{d=l+16&-16;m=$Xc(d)|0;f[i>>2]=m;f[i+8>>2]=d|-2147483648;f[i+4>>2]=l;q=m;n=12}if((n|0)==12){o1c(q|0,k|0,l|0)|0;p=q}b[p+l>>0]=0;Ti[a&511](g,h,i);a=$Xc(8)|0;f[a>>2]=f[g>>2];l=f[g+4>>2]|0;f[a+4>>2]=l;if(l|0)TXc(l);ROa(g);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return a|0}cYc(f[h>>2]|0);u=e;return a|0}function NE(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+16|0;g=d;h=c+4|0;i=f[c>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)jYc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{c=i+16&-16;m=$Xc(c)|0;f[g>>2]=m;f[g+8>>2]=c|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){o1c(k|0,h|0,i|0)|0;j=k}b[j+i>>0]=0;mi[a&2047](e,g);a=$Xc(8)|0;f[a>>2]=f[e>>2];i=f[e+4>>2]|0;f[a+4>>2]=i;if(i|0)TXc(i);ROa(e);if((b[g+11>>0]|0)>=0){u=d;return a|0}cYc(f[g>>2]|0);u=d;return a|0}function OE(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+24|0;i=g+8|0;j=g+4|0;k=g;l=c+4|0;m=f[c>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)jYc(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)n=i;else{o=i;p=6}}else{c=m+16&-16;q=$Xc(c)|0;f[i>>2]=q;f[i+8>>2]=c|-2147483648;f[i+4>>2]=m;o=q;p=6}if((p|0)==6){o1c(o|0,l|0,m|0)|0;n=o}b[n+m>>0]=0;f[j>>2]=d;f[k>>2]=e;ei[a&511](h,i,j,k);a=$Xc(8)|0;f[a>>2]=f[h>>2];e=f[h+4>>2]|0;f[a+4>>2]=e;if(e|0)TXc(e);ROa(h);Ae(f[k>>2]|0);Ae(f[j>>2]|0);if((b[i+11>>0]|0)>=0){u=g;return a|0}cYc(f[i>>2]|0);u=g;return a|0}function PE(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e+16|0;h=e+4|0;i=e;j=c+4|0;k=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)jYc(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{c=k+16&-16;o=$Xc(c)|0;f[h>>2]=o;f[h+8>>2]=c|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){o1c(m|0,j|0,k|0)|0;l=m}b[l+k>>0]=0;f[i>>2]=d;Ti[a&511](g,h,i);a=$Xc(8)|0;f[a>>2]=f[g>>2];d=f[g+4>>2]|0;f[a+4>>2]=d;if(d|0)TXc(d);ROa(g);Ae(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return a|0}cYc(f[h>>2]|0);u=e;return a|0}function QE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;f[g>>2]=b;f[h>>2]=c;Ti[a&511](e,g,h);a=$Xc(8)|0;f[a>>2]=f[e>>2];c=f[e+4>>2]|0;f[a+4>>2]=c;if(c|0)TXc(c);ROa(e);Ae(f[h>>2]|0);Ae(f[g>>2]|0);u=d;return a|0}function RE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c+8|0;e=c;f[e>>2]=b;mi[a&2047](d,e);a=$Xc(8)|0;f[a>>2]=f[d>>2];b=f[d+4>>2]|0;f[a+4>>2]=b;if(b|0)TXc(b);ROa(d);Ae(f[e>>2]|0);u=c;return a|0}function SE(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;i=c+4|0;j=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)jYc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{c=j+16&-16;n=$Xc(c)|0;f[h>>2]=n;f[h+8>>2]=c|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){o1c(l|0,i|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[a&511](g,h,d);d=$Xc(8)|0;f[d>>2]=f[g>>2];a=f[g+4>>2]|0;f[d+4>>2]=a;if(a|0)TXc(a);ROa(g);if((b[h+11>>0]|0)>=0){u=e;return d|0}cYc(f[h>>2]|0);u=e;return d|0}function TE(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function UE(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function VE(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+12|0;i=g;j=f[a>>2]|0;a=d+4|0;k=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)jYc(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{d=k+16&-16;o=$Xc(d)|0;f[h>>2]=o;f[h+8>>2]=d|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){o1c(m|0,a|0,k|0)|0;l=m}b[l+k>>0]=0;k=e+4|0;l=f[e>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)jYc(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)p=i;else{q=i;n=12}}else{e=l+16&-16;m=$Xc(e)|0;f[i>>2]=m;f[i+8>>2]=e|-2147483648;f[i+4>>2]=l;q=m;n=12}if((n|0)==12){o1c(q|0,k|0,l|0)|0;p=q}b[p+l>>0]=0;l=hj[j&511](c,h,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=g;return l|0}cYc(f[h>>2]|0);u=g;return l|0}function WE(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)jYc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=$Xc(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){o1c(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=Mi[h&1023](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}cYc(f[g>>2]|0);u=e;return i|0}function XE(){var a=0,c=0;a=$Xc(152)|0;f[a>>2]=141652;f[a+4>>2]=64;f[a+8>>2]=128;f[a+12>>2]=16;f[a+16>>2]=16;f[a+20>>2]=8;f[a+24>>2]=8;f[a+28>>2]=8;f[a+32>>2]=8;f[a+36>>2]=9;f[a+40>>2]=1;p[a+48>>3]=-1.0;f[a+56>>2]=0;p[a+64>>3]=.2;b[a+72>>0]=1;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+88>>2]=1124007936;c=a+92|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[a+120>>2]=a+96;c=a+128|0;f[a+124>>2]=c;f[a+132>>2]=0;f[c>>2]=0;n[a+136>>2]=-1.0;f[a+140>>2]=64;b[a+144>>0]=0;return a|0}function YE(a){a=a|0;return xj[a&63]()|0}function ZE(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0;q=$Xc(152)|0;r=f[a>>2]|0;s=f[a+4>>2]|0;a=f[c>>2]|0;t=f[c+4>>2]|0;c=f[d>>2]|0;u=f[d+4>>2]|0;d=f[e>>2]|0;v=f[e+4>>2]|0;e=f[g>>2]|0;g=f[h>>2]|0;w=+p[i>>3];i=f[j>>2]|0;x=+p[k>>3];k=b[l>>0]|0;l=f[m>>2]|0;m=b[o>>0]|0;f[q>>2]=141652;f[q+4>>2]=r;f[q+8>>2]=s;f[q+12>>2]=a;f[q+16>>2]=t;f[q+20>>2]=c;f[q+24>>2]=u;f[q+28>>2]=d;f[q+32>>2]=v;f[q+36>>2]=e;f[q+40>>2]=g;p[q+48>>3]=w;f[q+56>>2]=i;p[q+64>>3]=x;b[q+72>>0]=k;f[q+76>>2]=0;f[q+80>>2]=0;f[q+84>>2]=0;f[q+88>>2]=1124007936;k=q+92|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[q+120>>2]=q+96;k=q+128|0;f[q+124>>2]=k;f[q+132>>2]=0;f[k>>2]=0;n[q+136>>2]=-1.0;f[q+140>>2]=l;b[q+144>>0]=m;return q|0}function _E(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;l=+l;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;q=u;u=u+80|0;r=q+56|0;s=q+48|0;t=q+40|0;v=q+32|0;w=q+28|0;x=q+24|0;y=q+8|0;z=q+20|0;A=q;B=q+65|0;C=q+16|0;D=q+64|0;f[r>>2]=f[c>>2];f[r+4>>2]=f[c+4>>2];f[s>>2]=f[d>>2];f[s+4>>2]=f[d+4>>2];f[t>>2]=f[e>>2];f[t+4>>2]=f[e+4>>2];f[v>>2]=f[g>>2];f[v+4>>2]=f[g+4>>2];f[w>>2]=h;f[x>>2]=i;p[y>>3]=j;f[z>>2]=k;p[A>>3]=l;b[B>>0]=m&1;f[C>>2]=n;b[D>>0]=o&1;o=rj[a&1](r,s,t,v,w,x,y,z,A,B,C,D)|0;u=q;return o|0}function $E(a){a=a|0;var b=0;b=$Xc(152)|0;bF(b,a);return b|0}function aF(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=c+4|0;h=f[c>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(h>>>0>4294967279)jYc(e);if(h>>>0<11){b[e+11>>0]=h;if(!h)i=e;else{j=e;k=6}}else{c=h+16&-16;l=$Xc(c)|0;f[e>>2]=l;f[e+8>>2]=c|-2147483648;f[e+4>>2]=h;j=l;k=6}if((k|0)==6){o1c(j|0,g|0,h|0)|0;i=j}b[i+h>>0]=0;h=_i[a&2047](e)|0;if((b[e+11>>0]|0)>=0){u=d;return h|0}cYc(f[e>>2]|0);u=d;return h|0}function bF(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=141652;g=a+4|0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[a+88>>2]=1124007936;g=a+92|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[a+120>>2]=a+96;g=a+128|0;f[a+124>>2]=g;f[a+132>>2]=0;f[g>>2]=0;g=f[35418]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;hj[g&511](a,c,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function cF(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(12)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];u=b;return a|0}function dF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function eF(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];Yg[p&3](b,c,d,e,g,n,o,j,k,l);u=m;return}function fF(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];fh[o&1](b,c,d,e,g,m,n,j,k);u=l;return}function gF(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];wg[n&1](b,c,d,e,g,l,m,j);u=k;return}function hF(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j;m=f[a>>2]|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];oj[m&7](b,c,d,e,g,k,l);u=j;return}function iF(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];ej[k&15](b,c,d,e,g,j);u=i;return}function jF(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;ni[f[a>>2]&31](b,c,d,e,g);return}function kF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function lF(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function mF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function nF(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function oF(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function pF(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function qF(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function rF(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function sF(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function tF(a,c){a=a|0;c=c|0;return (b[c+(f[a>>2]|0)>>0]|0)!=0|0}function uF(a,c,d){a=a|0;c=c|0;d=d|0;b[c+(f[a>>2]|0)>>0]=d&1;return}function vF(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=$Xc(12)|0;xF(a,c);return a|0}function wF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;if((d|0)==(c|0))return;yF(d,f[c>>2]|0,f[c+4>>2]|0);return}function xF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;o1c(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function yF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)q1c(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;o1c(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);cYc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)kWc(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)kWc(a);j=$Xc(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;o1c(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function zF(a){a=a|0;return 5024}function AF(a){a=a|0;if(!a)return;ROa(a);cYc(a);return}function BF(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;a=e+4|0;l=f[e>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(l>>>0>4294967279)jYc(j);if(l>>>0<11){b[j+11>>0]=l;if(!l)m=j;else{n=j;o=6}}else{e=l+16&-16;p=$Xc(e)|0;f[j>>2]=p;f[j+8>>2]=e|-2147483648;f[j+4>>2]=l;n=p;o=6}if((o|0)==6){o1c(n|0,a|0,l|0)|0;m=n}b[m+l>>0]=0;Lh[k&7](c,d,j,g,h);if((b[j+11>>0]|0)>=0){u=i;return}cYc(f[j>>2]|0);u=i;return}function CF(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;j=f[a>>2]|0;a=e+4|0;k=f[e>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(k>>>0>4294967279)jYc(i);if(k>>>0<11){b[i+11>>0]=k;if(!k)l=i;else{m=i;n=6}}else{e=k+16&-16;o=$Xc(e)|0;f[i>>2]=o;f[i+8>>2]=e|-2147483648;f[i+4>>2]=k;m=o;n=6}if((n|0)==6){o1c(m|0,a|0,k|0)|0;l=m}b[l+k>>0]=0;$h[j&63](c,d,i,g);if((b[i+11>>0]|0)>=0){u=h;return}cYc(f[i>>2]|0);u=h;return}function DF(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;a=e+4|0;j=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)jYc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{e=j+16&-16;n=$Xc(e)|0;f[h>>2]=n;f[h+8>>2]=e|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){o1c(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[i&511](c,d,h);if((b[h+11>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function EF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function FF(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+80|0;g=e+16|0;h=e;i=f[a>>2]|0;a=d+4|0;j=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)jYc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{d=j+16&-16;n=$Xc(d)|0;f[h>>2]=n;f[h+8>>2]=d|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){o1c(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[i&511](g,c,h);c=$Xc(56)|0;f[c>>2]=f[g>>2];i=g+4|0;j=f[i>>2]|0;f[c+4>>2]=j;k=c+8|0;l=g+8|0;f[k>>2]=f[l>>2];f[c+12>>2]=f[g+12>>2];a=g+16|0;f[c+16>>2]=f[a>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];m=g+36|0;f[c+36>>2]=f[m>>2];n=c+40|0;f[n>>2]=k;k=c+44|0;d=c+48|0;f[k>>2]=d;o=c+52|0;f[o>>2]=0;f[d>>2]=0;p=g+44|0;if((j|0)<3){j=f[p>>2]|0;f[d>>2]=f[j>>2];f[o>>2]=f[j+4>>2];q=j}else{f[k>>2]=f[p>>2];k=g+40|0;f[n>>2]=f[k>>2];n=g+48|0;f[p>>2]=n;f[k>>2]=l;q=n}f[g>>2]=1124007936;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[m>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((q|0)!=(g+48|0))wL(q);if((b[h+11>>0]|0)>=0){u=e;return c|0}cYc(f[h>>2]|0);u=e;return c|0}function GF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;mi[f[a>>2]&2047](d,b);b=$Xc(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}wL(o);u=c;return b|0}function HF(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;a=e+4|0;j=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)jYc(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{e=j+16&-16;n=$Xc(e)|0;f[h>>2]=n;f[h+8>>2]=e|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){o1c(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;Ti[i&511](c,d,h);if((b[h+11>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function IF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function JF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;f[g>>2]=d;Ti[h&511](b,c,g);Ae(f[g>>2]|0);u=e;return}function KF(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function LF(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function MF(a){a=a|0;return a|0}function NF(a){a=a|0;return a|0}function OF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function PF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function QF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function RF(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function SF(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function TF(a){a=a|0;return a|0}function UF(a){a=a|0;return a|0}function VF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function WF(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function XF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function YF(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function ZF(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;vg[a&3](j,b,c,d,e,g,h);h=$Xc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function _F(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;tj[a&7](i,b,c,d,e,g);g=$Xc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function $F(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;Lh[a&7](h,b,c,d,e);e=$Xc(8)|0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];u=g;return e|0}function aG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;$h[a&63](g,b,c,d);c=$Xc(8)|0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];u=e;return c|0}function bG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=$Xc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function cG(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function dG(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function eG(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function fG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function gG(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function hG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function iG(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function jG(a){a=a|0;return f[a>>2]|0}function kG(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function lG(a){a=a|0;return 0}function mG(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function nG(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function oG(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function pG(a){a=a|0;return a|0}function qG(a){a=a|0;return a|0}function rG(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ri[a&15](g,b,c,d);d=$Xc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function sG(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;Vi[a&63](e,b,c);b=$Xc(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function tG(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function uG(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function vG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function wG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function xG(a){a=a|0;return f[a>>2]|0}function yG(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function zG(a){a=a|0;return 0}function AG(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function BG(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function CG(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function DG(a){a=a|0;return a|0}function EG(a){a=a|0;return a|0}function FG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];mi[g&2047](b,e);u=d;return}function GG(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];Hg[a&15](e,b,g);g=$Xc(8)|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];u=d;return g|0}function HG(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;ji[a&31](d,b);a=$Xc(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function IG(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function JG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;Yi[e&4095](a);return}else{e=f[(f[a>>2]|0)+c>>2]|0;Yi[e&4095](a);return}}function KG(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function LG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;mi[h&2047](d,a);a=$Xc(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function MG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function NG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function OG(a){a=a|0;return f[a>>2]|0}function PG(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function QG(a){a=a|0;return 0}function RG(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function SG(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function TG(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function UG(a){a=a|0;return a|0}function VG(a){a=a|0;return a|0}function WG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=$Xc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function XG(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function YG(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function ZG(a){a=a|0;return f[a>>2]|0}function _G(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function $G(a){a=a|0;return 0}function aH(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function bH(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function cH(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function dH(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function eH(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function fH(a){a=a|0;return a|0}function gH(a){a=a|0;return a|0}function hH(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function iH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function jH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function kH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function lH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function mH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function nH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function oH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function pH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;Fh[f[a>>2]&255](b,c,d,e,g,h);return}function qH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function rH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function sH(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function tH(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function uH(a){a=a|0;return a|0}function vH(a){a=a|0;return a|0}function wH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function xH(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function yH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function zH(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function AH(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function BH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=+h;var i=0,j=0;i=u;u=u+16|0;j=i;qh[a&1](j,b,c,d,e,g,h);g=$Xc(8)|0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];u=i;return g|0}function CH(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Ig[a&3](i,b,c,d,e,g);g=$Xc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function DH(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;Ni[a&7](h,b,c,d,e);e=$Xc(8)|0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];u=g;return e|0}function EH(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;qi[a&7](g,b,c,d);b=$Xc(8)|0;f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];u=e;return b|0}function FH(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;Vi[a&63](e,b,c);b=$Xc(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function GH(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function HH(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function IH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;fi[a&1](k,b,c,d,e,g,h,i);h=$Xc(8)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];u=j;return h|0}function JH(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function KH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function LH(a){a=a|0;return f[a>>2]|0}function MH(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function NH(a){a=a|0;return 0}function OH(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function PH(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function QH(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function RH(a){a=a|0;return a|0}function SH(a){a=a|0;return a|0}function TH(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;oj[f[a>>2]&7](b,c,d,e,g,h,i);return}function UH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;ej[f[a>>2]&15](b,c,d,e,g,h);return}function VH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;ni[f[a>>2]&31](b,c,d,e,g);return}function WH(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;tj[f[a>>2]&7](b,c,d,e,g,h);return}function XH(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;Lh[f[a>>2]&7](b,c,d,e,g);return}function YH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function ZH(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+16|0;g=d;h=c+4|0;i=f[c>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)jYc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{c=i+16&-16;m=$Xc(c)|0;f[g>>2]=m;f[g+8>>2]=c|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){o1c(k|0,h|0,i|0)|0;j=k}b[j+i>>0]=0;mi[a&2047](e,g);a=$Xc(8)|0;f[a>>2]=f[e>>2];i=e+4|0;f[a+4>>2]=f[i>>2];f[e>>2]=0;f[i>>2]=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}cYc(f[g>>2]|0);u=d;return a|0}function _H(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;Yi[e&4095](a);return}else{e=f[(f[a>>2]|0)+c>>2]|0;Yi[e&4095](a);return}}function $H(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;Ii[f[a>>2]&127](b,c,d,e,g,h,i);return}function aI(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;Fh[f[a>>2]&255](b,c,d,e,g,h);return}function bI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function cI(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;Fh[f[a>>2]&255](b,c,d,e,g,h);return}function dI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function eI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function fI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function gI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function hI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function iI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function jI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function kI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function lI(a){a=a|0;return f[a>>2]|0}function mI(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function nI(a){a=a|0;return 0}function oI(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function pI(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function qI(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function rI(a){a=a|0;return a|0}function sI(a){a=a|0;return a|0}function tI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function uI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function vI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function wI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function xI(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;Ug[a&1](m,b,c,d,e,g,h,i,j,k);k=$Xc(8)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];u=l;return k|0}function yI(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=+i;j=+j;var k=0,l=0;k=u;u=u+16|0;l=k;Ri[a&1](l,b,c,d,e,g,h,i,j);h=$Xc(8)|0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];u=k;return h|0}function zI(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;lj[a&1](k,b,c,d,e,g,h,i);h=$Xc(8)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];u=j;return h|0}function AI(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;zg[a&7](j,b,c,d,e,g,h);h=$Xc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function BI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0;h=u;u=u+16|0;i=h;Jj[a&7](i,b,c,d,e,g);d=$Xc(8)|0;f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];u=h;return d|0}function CI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;ni[a&31](h,b,c,d,e);d=$Xc(8)|0;f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];u=g;return d|0}function DI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=$Xc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function EI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=$Xc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function FI(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function GI(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function HI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function II(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function JI(a){a=a|0;return f[a>>2]|0}function KI(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function LI(a){a=a|0;return 0}function MI(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function NI(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function OI(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function PI(a){a=a|0;return a|0}function QI(a){a=a|0;return a|0}function RI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function SI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function TI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function UI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=$Xc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function VI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=$Xc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function WI(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function XI(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function YI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function ZI(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function _I(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function $I(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function aJ(a){a=a|0;return f[a>>2]|0}function bJ(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function cJ(a){a=a|0;return 0}function dJ(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function eJ(a){a=a|0;return 5904}function fJ(a){a=a|0;if(!a)return;_Ub(a);cYc(a);return}function gJ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)jYc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=$Xc(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){o1c(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=Mi[h&1023](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}cYc(f[g>>2]|0);u=e;return i|0}function hJ(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];uh[o&7](b,c,d,e,g,h,i,m,n);u=l;return}function iJ(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=f[a>>2]|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];tg[m&7](b,c,d,e,g,h,i,l);u=k;return}function jJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;oj[f[a>>2]&7](b,c,d,e,g,h,i);return}function kJ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;ej[f[a>>2]&15](b,c,d,e,g,h);return}function lJ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;ni[f[a>>2]&31](b,c,d,e,g);return}function mJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[f[a>>2]&511](b,c,d,e);return}function nJ(){var a=0;a=$Xc(8)|0;TUb(a);return a|0}function oJ(a){a=a|0;return xj[a&63]()|0}function pJ(a){a=a|0;var b=0;b=$Xc(8)|0;UUb(b,a);return b|0}function qJ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=c+4|0;h=f[c>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(h>>>0>4294967279)jYc(e);if(h>>>0<11){b[e+11>>0]=h;if(!h)i=e;else{j=e;k=6}}else{c=h+16&-16;l=$Xc(c)|0;f[e>>2]=l;f[e+8>>2]=c|-2147483648;f[e+4>>2]=h;j=l;k=6}if((k|0)==6){o1c(j|0,g|0,h|0)|0;i=j}b[i+h>>0]=0;h=_i[a&2047](e)|0;if((b[e+11>>0]|0)>=0){u=d;return h|0}cYc(f[e>>2]|0);u=d;return h|0}function rJ(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0;n=u;u=u+16|0;o=n+8|0;p=n;q=f[a>>2]|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];ih[q&3](b,c,d,e,g,h,i,j,o,p,m);u=n;return}function sJ(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];Xi[p&3](b,c,d,e,g,h,i,j,n,o);u=m;return}function tJ(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l;n=f[a>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];Ej[n&3](b,c,d,e,g,h,i,j,m);u=l;return}function uJ(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;Ei[f[a>>2]&7](b,c,d,e,g,h,i,j);return}function vJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;Lg[f[a>>2]&7](b,c,d,e,g,h,i);return}function wJ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;Dh[f[a>>2]&15](b,c,d,e,g,h);return}function xJ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;gi[f[a>>2]&255](b,c,d,e,g);return}function yJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function zJ(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];Gh[n&3](b,c,d,e,g,h,l,m);u=k;return}function AJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];vg[l&3](b,c,d,e,g,h,k);u=j;return}function BJ(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;tj[f[a>>2]&7](b,c,d,e,g,h);return}function CJ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;Lh[f[a>>2]&7](b,c,d,e,g);return}function DJ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[f[a>>2]&63](b,c,d,e);return}function EJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[a>>2]&511](b,c,d);return}function FJ(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function GJ(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function HJ(a){a=a|0;return a|0}function IJ(a){a=a|0;return a|0}function JJ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function KJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function LJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function MJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=$Xc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function NJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=$Xc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function OJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function PJ(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function QJ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function RJ(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function SJ(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function TJ(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function UJ(a){a=a|0;return f[a>>2]|0}function VJ(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function WJ(a){a=a|0;return 0}function XJ(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function YJ(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function ZJ(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function _J(a){a=a|0;return a|0}function $J(a){a=a|0;return a|0}function aK(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function bK(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function cK(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function dK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function eK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function fK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+Vg[e&31](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+Vg[e&31](a);return +g}return +(0.0)}function gK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;tg[a&7](k,b,c,d,e,g,h,i);i=$Xc(8)|0;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];u=j;return i|0}function hK(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;oj[a&7](j,b,c,d,e,g,h);h=$Xc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function iK(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;ej[a&15](i,b,c,d,e,g);g=$Xc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function jK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;ni[a&31](h,b,c,d,e);d=$Xc(8)|0;f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];u=g;return d|0}function kK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ei[a&511](g,b,c,d);d=$Xc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function lK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=$Xc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function mK(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function nK(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function oK(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function pK(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function qK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function rK(a){a=a|0;return f[a>>2]|0}function sK(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function tK(a){a=a|0;return 0}function uK(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function vK(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function wK(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function xK(a){a=a|0;return a|0}function yK(a){a=a|0;return a|0}function zK(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function AK(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function BK(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;ii[a&1](m,b,c,d,e,g,h,i,j,k);k=$Xc(8)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];u=l;return k|0}function CK(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;gj[a&1](l,b,c,d,e,g,h,i,j);j=$Xc(8)|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];u=k;return j|0}function DK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Uh[a&3](k,b,c,d,e,g,h,i);i=$Xc(8)|0;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];u=j;return i|0}function EK(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;vh[a&3](j,b,c,d,e,g,h);h=$Xc(8)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];u=i;return h|0}function FK(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Bg[a&3](i,b,c,d,e,g);g=$Xc(8)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];u=h;return g|0}function GK(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;bi[a&3](h,b,c,d,e);e=$Xc(8)|0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];u=g;return e|0}function HK(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ri[a&15](g,b,c,d);d=$Xc(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function IK(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;Vi[a&63](e,b,c);b=$Xc(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function JK(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function KK(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function LK(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return _i[e&2047](a)|0}function MK(a,b,c){a=a|0;b=b|0;c=+c;ji[f[a>>2]&31](b,c);return}function NK(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[a>>2]&2047](b,c);return}function OK(a){a=a|0;return f[a>>2]|0}function PK(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function QK(a){a=a|0;return 0}function RK(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function SK(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function TK(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function UK(a){a=a|0;return a|0}function VK(a){a=a|0;return a|0}function WK(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;mi[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=jIc(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;o1c(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}cYc(h);u=d;return c|0}function XK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;$h[a&63](g,b,c,d);c=$Xc(8)|0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];u=e;return c|0}function YK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;Ti[a&511](e,b,c);c=$Xc(8)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];u=d;return c|0}function ZK(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[a&2047](d,b);b=$Xc(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function _K(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;Yi[a&4095](c);a=$Xc(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function $K(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h+4|0;l=h;f[j>>2]=b;f[k>>2]=c;f[l>>2]=g;Zh[a&7](i,j,k,d,e,l);a=$Xc(8)|0;f[a>>2]=f[i>>2];g=i+4|0;f[a+4>>2]=f[g>>2];f[i>>2]=0;f[g>>2]=0;Ae(f[l>>2]|0);Ae(f[k>>2]|0);Ae(f[j>>2]|0);u=h;return a|0}function aL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;f[i>>2]=b;f[j>>2]=c;Kh[a&15](h,i,j,d,e);a=$Xc(8)|0;f[a>>2]=f[h>>2];c=h+4|0;f[a+4>>2]=f[c>>2];f[h>>2]=0;f[c>>2]=0;Ae(f[j>>2]|0);Ae(f[i>>2]|0);u=g;return a|0}function bL(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j+4|0;n=j;f[l>>2]=d;f[m>>2]=e;f[n>>2]=i;ug[a&3](k,b,c,l,m,g,h,n);c=$Xc(8)|0;f[c>>2]=f[k>>2];b=k+4|0;f[c+4>>2]=f[b>>2];f[k>>2]=0;f[b>>2]=0;Ae(f[n>>2]|0);Ae(f[m>>2]|0);Ae(f[l>>2]|0);u=j;return c|0}function cL(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i+4|0;l=i;f[k>>2]=d;f[l>>2]=e;Tg[a&3](j,b,c,k,l,g,h);c=$Xc(8)|0;f[c>>2]=f[j>>2];b=j+4|0;f[c+4>>2]=f[b>>2];f[j>>2]=0;f[b>>2]=0;Ae(f[l>>2]|0);Ae(f[k>>2]|0);u=i;return c|0}function dL(a){a=a|0;return f[a>>2]|0}function eL(){var a=0;a=$Xc(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function fL(a){a=a|0;return 0}function gL(a){a=a|0;var b=0;if(!a)return;b=f[a+4>>2]|0;if(b|0)UXc(b);cYc(a);return}function hL(){zk(0);Jv(0);return}function iL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/28|0)>>>0>=b>>>0){i=b;j=h;while(1){n[j>>2]=0.0;n[j+4>>2]=0.0;n[j+8>>2]=0.0;n[j+12>>2]=-1.0;n[j+16>>2]=0.0;f[j+20>>2]=0;f[j+24>>2]=-1;i=i+-1|0;if(!i)break;else j=j+28|0}f[e>>2]=h+(b*28|0);return}j=f[a>>2]|0;i=(g-j|0)/28|0;k=i+b|0;l=j;if(k>>>0>153391689)kWc(a);m=(d-j|0)/28|0;j=m<<1;d=m>>>0<76695844?(j>>>0<k>>>0?k:j):153391689;do if(d)if(d>>>0>153391689){j=af(8)|0;hYc(j,512536);f[j>>2]=192348;ig(j|0,25336,2140)}else{o=$Xc(d*28|0)|0;break}else o=0;while(0);j=o+(i*28|0)|0;i=o+(d*28|0)|0;d=b;o=j;while(1){n[o>>2]=0.0;n[o+4>>2]=0.0;n[o+8>>2]=0.0;n[o+12>>2]=-1.0;n[o+16>>2]=0.0;f[o+20>>2]=0;f[o+24>>2]=-1;d=d+-1|0;if(!d)break;else o=o+28|0}o=j;d=i;i=j+(b*28|0)|0;if((h|0)==(l|0)){p=o;q=g}else{g=h;h=o;o=j;do{j=g;g=g+-28|0;f[o+-28>>2]=f[g>>2];f[o+-24>>2]=f[j+-24>>2];b=o+-20|0;k=j+-20|0;f[b>>2]=f[k>>2];f[b+4>>2]=f[k+4>>2];f[b+8>>2]=f[k+8>>2];f[b+12>>2]=f[k+12>>2];f[b+16>>2]=f[k+16>>2];o=h+-28|0;h=o}while((g|0)!=(l|0));p=h;q=f[a>>2]|0}f[a>>2]=p;f[e>>2]=i;f[c>>2]=d;if(!q)return;cYc(q);return}function jL(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0,k=0.0;c=+n[a+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[a+12>>2];f=e*c;g=+n[a+8>>2];h=d*g;i=+n[a>>2]-f-h;n[b>>2]=i;j=a+4|0;k=d*c;c=e*g;g=k+ +n[j>>2]-c;n[b+4>>2]=g;e=f+ +n[a>>2]-h;n[b+8>>2]=e;h=+n[j>>2]-k-c;n[b+12>>2]=h;n[b+16>>2]=+n[a>>2]*2.0-i;n[b+20>>2]=+n[j>>2]*2.0-g;n[b+24>>2]=+n[a>>2]*2.0-e;n[b+28>>2]=+n[j>>2]*2.0-h;return}function kL(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0;c=+n[b+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[b>>2];g=+n[b+12>>2];h=e*g;i=+n[b+8>>2];j=d*i;k=c-h-j;l=+n[b+4>>2];m=d*g;g=e*i;i=m+l-g;e=h+c-j;j=l-m-g;g=c*2.0;c=g-k;m=l*2.0;l=m-i;h=g-e;g=m-j;m=e<k?e:k;d=c<m?c:m;m=h<d?h:d;b=~~m;o=b-(+(b|0)>m&1)|0;m=j<i?j:i;d=l<m?l:m;m=g<d?g:d;b=~~m;p=b-(+(b|0)>m&1)|0;m=k<e?e:k;k=m<c?c:m;m=k<h?h:k;b=~~m;k=i<j?j:i;i=k<l?l:k;k=i<g?g:i;q=~~k;f[a>>2]=o;f[a+4>>2]=p;f[a+8>>2]=(+(b|0)<m&1)+b+1-o;f[a+12>>2]=1-p+((+(q|0)<k&1)+q);return}function lL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+16|0;e=c+12|0;g=c+8|0;h=c+4|0;i=c;j=+n[b+16>>2]*3.141592653589793/180.0;k=+O(+j)*.5;l=+P(+j)*.5;j=+n[b>>2];m=+n[b+12>>2];o=l*m;p=+n[b+8>>2];q=k*p;r=j-o-q;n[d>>2]=r;t=+n[b+4>>2];v=k*m;m=l*p;p=v+t-m;b=d+4|0;n[b>>2]=p;l=o+j-q;w=d+8|0;n[w>>2]=l;q=t-v-m;x=d+12|0;n[x>>2]=q;m=j*2.0;j=m-r;y=d+16|0;n[y>>2]=j;v=t*2.0;t=v-p;z=d+20|0;n[z>>2]=t;o=m-l;A=d+24|0;n[A>>2]=o;m=v-q;B=d+28|0;n[B>>2]=m;C=l<r?w:d;D=j<+n[C>>2]?y:C;C=f[(o<+n[D>>2]?A:D)>>2]|0;D=q<p?x:b;E=t<+n[D>>2]?z:D;D=f[(m<+n[E>>2]?B:E)>>2]|0;f[e>>2]=C;f[g>>2]=D;E=r<l?w:d;d=+n[E>>2]<j?y:E;E=f[(+n[d>>2]<o?A:d)>>2]|0;d=p<q?x:b;b=+n[d>>2]<t?z:d;d=f[(+n[b>>2]<m?B:b)>>2]|0;f[h>>2]=E;f[i>>2]=d;m=(f[s>>2]=E,+n[s>>2]);t=(f[s>>2]=C,+n[s>>2]);C=f[(m<t?h:e)>>2]|0;f[a>>2]=C;q=(f[s>>2]=d,+n[s>>2]);p=(f[s>>2]=D,+n[s>>2]);D=f[(q<p?i:g)>>2]|0;f[a+4>>2]=D;n[a+8>>2]=(t<m?m:t)-(f[s>>2]=C,+n[s>>2]);n[a+12>>2]=(p<q?q:p)-(f[s>>2]=D,+n[s>>2]);u=c;return}function mL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0;e=u;u=u+1264|0;g=e+1208|0;h=e+1152|0;i=e+8|0;j=e+1136|0;k=e;l=e+1104|0;m=e+40|0;do if((eS(c)|0)==65536){n=f[c+4>>2]|0;f[g>>2]=f[n>>2];o=g+4|0;q=n+4|0;f[o>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[n+8>>2];f[g+12>>2]=f[n+12>>2];f[g+16>>2]=f[n+16>>2];f[g+20>>2]=f[n+20>>2];f[g+24>>2]=f[n+24>>2];f[g+28>>2]=f[n+28>>2];f[g+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[g+36>>2]=s;f[g+40>>2]=r;r=g+48|0;t=g+44|0;f[t>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[n+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[o>>2]=0;U$(g,n);break}}else bS(g,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];n=h+4|0;o=c+4|0;f[n>>2]=f[o>>2];q=h+8|0;f[q>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];r=h+16|0;f[r>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=q;q=h+48|0;s=h+44|0;f[s>>2]=q;f[q>>2]=0;f[h+52>>2]=0;if(t|0){q=t+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[o>>2]|0)<3){o=f[c+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];v=r;break}else{f[n>>2]=0;U$(h,c);v=r;break}}else{bS(h,d,-1);v=h+16|0}while(0);if(f[v>>2]|0){d=f[h+4>>2]|0;if((d|0)<3)w=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{r=f[h+40>>2]|0;c=0;n=1;while(1){o=Y(f[r+(c<<2)>>2]|0,n)|0;c=c+1|0;if((c|0)==(d|0)){w=o;break}else n=o}}if(!((d|0)==0|(w|0)==0)?f[h>>2]&4095|0:0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(48)|0;f[i>>2]=w;f[i+8>>2]=-2147483600;f[i+4>>2]=36;x=w;y=227891;z=x+36|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[w+36>>0]=0;vM(-215,i,217505,217510,118)}}w=f[g>>2]|0;d=w>>>3&511;n=d+1|0;c=w&7;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;w=aV(c)|0;if(!(n>>>0<5&(w|0)!=0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(32)|0;f[j>>2]=r;f[j+8>>2]=-2147483616;f[j+4>>2]=20;x=r;y=234511;z=x+20|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[r+20>>0]=0;vM(-215,j,217505,217510,127)}f[j>>2]=g;f[j+4>>2]=h;f[j+8>>2]=0;r=k;f[r>>2]=0;f[r+4>>2]=0;BL(l,j,k,-1);j=f[l+20>>2]|0;r=m+8|0;f[m>>2]=r;y=m+4|0;f[y>>2]=264;x=c>>>0<4;if(x){z=c>>>0<2?8388608:32768;c=(z|0)<(j|0)?z:j;f[y>>2]=n;g1c(r|0,0,(d<<2)+4|0)|0;d=f[g+4>>2]|0;if((d|0)>0){A=f[(f[g+44>>2]|0)+(d+-1<<2)>>2]|0;B=r;C=c;D=z}else{A=0;B=r;C=c;D=z}}else{A=0;B=i;C=j;D=0}z=l+16|0;c=(j|0)>0;d=k+4|0;o=0;q=0;s=0;while(1){if(q>>>0>=(f[z>>2]|0)>>>0)break;t=q+1|0;a:do if(c){E=f[k>>2]|0;F=f[d>>2]|0;if(x){G=0;H=s;I=o;J=E;K=F}else{L=0;M=s;N=o;O=E;E=F;while(1){F=j-L|0;P=(C|0)<(F|0)?C:F;F=_h[w&127](O,E,B,P,n)|0;Q=F+N|0;R=F+M|0;F=Y(P,A)|0;O=(f[k>>2]|0)+F|0;f[k>>2]=O;F=f[d>>2]|0;if(!F)S=0;else{T=F+P|0;f[d>>2]=T;S=T}L=L+C|0;if((j|0)<=(L|0)){U=R;V=Q;break a}else{M=R;N=Q;E=S}}}while(1){E=j-G|0;N=(C|0)<(E|0)?C:E;E=_h[w&127](J,K,B,N,n)|0;M=E+I|0;L=E+H|0;if((M+C|0)<(D|0)?((N+G|0)<(j|0)?1:t>>>0<(f[z>>2]|0)>>>0):0)W=M;else{X=0;Z=34}if((Z|0)==34)while(1){Z=0;M=B+(X<<2)|0;E=i+(X<<3)|0;p[E>>3]=+p[E>>3]+ +(f[M>>2]|0);f[M>>2]=0;X=X+1|0;if((X|0)==(n|0)){W=0;break}else Z=34}M=Y(N,A)|0;J=(f[k>>2]|0)+M|0;f[k>>2]=J;M=f[d>>2]|0;if(!M)_=0;else{E=M+N|0;f[d>>2]=E;_=E}G=G+C|0;if((j|0)<=(G|0)){U=L;V=W;break}else{H=L;I=W;K=_}}}else{U=s;V=o}while(0);CL(l)|0;o=V;q=t;s=U}$=(s|0)==0?0.0:1.0/+(s>>>0);aa=$*+p[i+8>>3];ba=$*+p[i+16>>3];ca=$*+p[i+24>>3];p[a>>3]=$*+p[i>>3];p[a+8>>3]=aa;p[a+16>>3]=ba;p[a+24>>3]=ca;a=f[m>>2]|0;if((a|0)!=(r|0)){if(a|0)dYc(a);f[m>>2]=r;f[y>>2]=264}y=h+36|0;r=f[y>>2]|0;if(r|0?(m=r+12|0,r=f[m>>2]|0,f[m>>2]=r+-1,(r|0)==1):0)V$(h);f[y>>2]=0;y=h+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[y>>2]|0)>0){v=f[h+40>>2]|0;r=0;do{f[v+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)!=(h+48|0))wL(y);y=g+36|0;h=f[y>>2]|0;if(h|0?(r=h+12|0,h=f[r>>2]|0,f[r>>2]=h+-1,(h|0)==1):0)V$(g);f[y>>2]=0;y=g+16|0;h=g+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[h>>2]|0)>0){y=f[g+40>>2]|0;r=0;do{f[y+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}wL(h);u=e;return}function nL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0;g=u;u=u+1360|0;h=g+1296|0;i=g+1240|0;j=g+1224|0;k=g+1112|0;l=g+1192|0;m=g+16|0;n=g;o=g+1136|0;q=g+1120|0;if(sS(a)|0){r=$Xc(16)|0;f[h>>2]=r;f[h+8>>2]=-2147483632;f[h+4>>2]=13;s=r;t=371335;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+13>>0]=0;vM(-215,h,217576,217510,813)}if(!(sS(e)|0)?dS(e,-1)|0:0){r=$Xc(48)|0;f[h>>2]=r;f[h+8>>2]=-2147483600;f[h+4>>2]=40;s=r;t=217587;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+40>>0]=0;vM(-215,h,217576,217510,814)}do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[h>>2]=f[r>>2];w=h+4|0;x=r+4|0;f[w>>2]=f[x>>2];y=h+8|0;f[y>>2]=f[r+8>>2];f[h+12>>2]=f[r+12>>2];f[h+16>>2]=f[r+16>>2];f[h+20>>2]=f[r+20>>2];f[h+24>>2]=f[r+24>>2];f[h+28>>2]=f[r+28>>2];f[h+32>>2]=f[r+32>>2];z=f[r+36>>2]|0;f[h+36>>2]=z;f[h+40>>2]=y;y=h+48|0;A=h+44|0;f[A>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[r+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;U$(h,r);break}}else bS(h,a,-1);while(0);do if((eS(e)|0)==65536){a=f[e+4>>2]|0;f[i>>2]=f[a>>2];r=i+4|0;w=a+4|0;f[r>>2]=f[w>>2];x=i+8|0;f[x>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[i+36>>2]=y;f[i+40>>2]=x;x=i+48|0;A=i+44|0;f[A>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[r>>2]=0;U$(i,a);break}}else bS(i,e,-1);while(0);e=f[h>>2]|0;a=e>>>3;r=a&511;w=r+1|0;x=e&7;e=f[35688+(x<<2)>>2]|0;if((x|0)==7){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=9;s=j;t=264557;v=s+9|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[j+9>>0]=0;vM(-215,j,217576,217510,830)}f[j>>2]=h;f[j+4>>2]=i;f[j+8>>2]=0;A=k;f[A>>2]=0;f[A+4>>2]=0;BL(l,j,k,-1);j=f[l+20>>2]|0;A=m+8|0;f[m>>2]=A;y=m+4|0;f[y>>2]=w<<2;if(w>>>0>34){z=bYc(w<<5)|0;f[m>>2]=z;B=z}else B=A;z=B+(w<<3)|0;C=x>>>0<4;D=0;do{p[z+(D<<3)>>3]=0.0;p[B+(D<<3)>>3]=0.0;D=D+1|0}while((D|0)!=(w|0));D=x>>>0<2;if(C){x=(j|0)<32768;E=z+(w<<3)|0;F=D?E+(w<<2)|0:z;G=0;do{f[F+(G<<2)>>2]=0;f[E+(G<<2)>>2]=0;G=G+1|0}while((G|0)!=(w|0));G=x?j:32768;x=f[h+4>>2]|0;if((x|0)>0){H=f[(f[h+44>>2]|0)+(x+-1<<2)>>2]|0;I=E;J=G;K=32768;L=F}else{H=0;I=E;J=G;K=32768;L=F}}else{H=0;I=B;J=j;K=0;L=z}F=l+16|0;G=(j|0)>0;E=k+4|0;x=0;N=0;O=0;while(1){if(O>>>0>=(f[F>>2]|0)>>>0)break;P=O+1|0;a:do if(G){Q=f[k>>2]|0;R=f[E>>2]|0;if(C){S=0;T=x;U=N;V=Q;W=R}else{X=0;Z=x;_=N;$=Q;Q=R;while(1){R=j-X|0;aa=(J|0)<(R|0)?J:R;R=xg[e&127]($,Q,I,L,aa,w)|0;ba=R+Z|0;ca=R+_|0;R=Y(aa,H)|0;$=(f[k>>2]|0)+R|0;f[k>>2]=$;R=f[E>>2]|0;if(!R)da=0;else{ea=R+aa|0;f[E>>2]=ea;da=ea}X=X+J|0;if((j|0)<=(X|0)){fa=ba;ga=ca;break a}else{Z=ba;_=ca;Q=da}}}while(1){Q=j-S|0;_=(J|0)<(Q|0)?J:Q;Q=xg[e&127](V,W,I,L,_,w)|0;Z=Q+T|0;X=Q+U|0;if((Z+J|0)<(K|0)?((_+S|0)<(j|0)?1:P>>>0<(f[F>>2]|0)>>>0):0)ha=Z;else{ia=0;ja=37}if((ja|0)==37){while(1){ja=0;Z=I+(ia<<2)|0;Q=B+(ia<<3)|0;p[Q>>3]=+p[Q>>3]+ +(f[Z>>2]|0);f[Z>>2]=0;ia=ia+1|0;if((ia|0)==(w|0))break;else ja=37}if(D){Z=0;do{Q=L+(Z<<2)|0;$=z+(Z<<3)|0;p[$>>3]=+p[$>>3]+ +(f[Q>>2]|0);f[Q>>2]=0;Z=Z+1|0}while((Z|0)!=(w|0));ha=0}else ha=0}Z=Y(_,H)|0;V=(f[k>>2]|0)+Z|0;f[k>>2]=V;Z=f[E>>2]|0;if(!Z)ka=0;else{Q=Z+_|0;f[E>>2]=Q;ka=Q}S=S+J|0;if((j|0)<=(S|0)){fa=ha;ga=X;break}else{T=ha;U=X;W=ka}}}else{fa=x;ga=N}while(0);CL(l)|0;x=fa;N=ga;O=P}la=(N|0)==0?0.0:1.0/+(N|0);N=0;do{O=B+(N<<3)|0;ma=la*+p[O>>3];p[O>>3]=ma;O=z+(N<<3)|0;na=la*+p[O>>3]-ma*ma;ma=+M(+(na<0.0?0.0:na));p[O>>3]=ma;N=N+1|0}while((N|0)!=(w|0));N=n+8|0;O=n+12|0;ga=n+4|0;fa=o+4|0;x=o+8|0;l=o+12|0;ka=o+16|0;W=o+20|0;U=o+24|0;ha=o+28|0;T=o+32|0;S=o+36|0;j=o+40|0;J=o+48|0;E=o+44|0;V=o+52|0;k=(a|536870400)^511;a=0;while(1){H=(a|0)==0;L=H?B:z;D=H?c:d;H=D;ia=f[H+4>>2]|0;I=n;f[I>>2]=f[H>>2];f[I+4>>2]=ia;f[N>>2]=f[D+8>>2];f[O>>2]=f[D+12>>2];if(aT(n)|0){if(!(XS(n)|0))ZS(n,w,1,6,-1,1,0);do if((eS(n)|0)==65536){D=f[ga>>2]|0;f[o>>2]=f[D>>2];ia=D+4|0;f[fa>>2]=f[ia>>2];f[x>>2]=f[D+8>>2];f[l>>2]=f[D+12>>2];f[ka>>2]=f[D+16>>2];f[W>>2]=f[D+20>>2];f[U>>2]=f[D+24>>2];f[ha>>2]=f[D+28>>2];f[T>>2]=f[D+32>>2];I=f[D+36>>2]|0;f[S>>2]=I;f[j>>2]=x;f[E>>2]=J;f[J>>2]=0;f[V>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[D+44>>2]|0;H=f[E>>2]|0;f[H>>2]=f[ia>>2];f[H+4>>2]=f[ia+4>>2];break}else{f[fa>>2]=0;U$(o,D);break}}else bS(o,n,-1);while(0);P=f[fa>>2]|0;if((P|0)<3)oa=Y(f[l>>2]|0,f[x>>2]|0)|0;else{D=f[j>>2]|0;ia=0;H=1;while(1){I=Y(f[D+(ia<<2)>>2]|0,H)|0;ia=ia+1|0;if((ia|0)==(P|0)){oa=I;break}else H=I}}if((f[o>>2]&20479|0)!=16390){ja=68;break}if((f[l>>2]|0)==1){if((oa|0)<=(r|0)){ja=68;break}}else if((oa|0)<=(r|0)|(f[x>>2]|0)!=1){ja=68;break}H=f[ka>>2]|0;P=0;do{p[H+(P<<3)>>3]=+p[L+(P<<3)>>3];P=P+1|0}while((P|0)!=(w|0));if((w|0)<(oa|0))g1c(H+(w<<3)|0,0,k+oa<<3|0)|0;P=f[S>>2]|0;if(P|0?(L=P+12|0,P=f[L>>2]|0,f[L>>2]=P+-1,(P|0)==1):0)V$(o);f[S>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[fa>>2]|0)>0){P=f[j>>2]|0;L=0;do{f[P+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[fa>>2]|0))}L=f[E>>2]|0;if((L|0)!=(J|0))wL(L)}a=a+1|0;if((a|0)>=2){ja=83;break}}if((ja|0)==68){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;a=$Xc(96)|0;f[q>>2]=a;f[q+8>>2]=-2147483552;f[q+4>>2]=91;s=a;t=217628;v=s+91|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[a+91>>0]=0;vM(-215,q,217576,217510,908)}else if((ja|0)==83){ja=f[m>>2]|0;if((ja|0)!=(A|0)){if(ja|0)dYc(ja);f[m>>2]=A;f[y>>2]=136}y=i+36|0;A=f[y>>2]|0;if(A|0?(m=A+12|0,A=f[m>>2]|0,f[m>>2]=A+-1,(A|0)==1):0)V$(i);f[y>>2]=0;y=i+16|0;A=i+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[A>>2]|0)>0){y=f[i+40>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)!=(i+48|0))wL(A);A=h+36|0;i=f[A>>2]|0;if(i|0?(m=i+12|0,i=f[m>>2]|0,f[m>>2]=i+-1,(i|0)==1):0)V$(h);f[A>>2]=0;A=h+16|0;i=h+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[i>>2]|0)>0){A=f[h+40>>2]|0;m=0;do{f[A+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=g;return}wL(i);u=g;return}}function oL(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[d>>2]|0;l=f[e>>2]|0;if((g|0)>0){m=a;n=k;o=l;p=0;while(1){q=h[m>>0]|0;r=q+n|0;s=(Y(q,q)|0)+o|0;p=p+1|0;if((p|0)==(g|0)){t=r;u=s;break}else{m=m+i|0;n=r;o=s}}}else{t=k;u=l}f[d>>2]=t;f[e>>2]=u;break}case 2:{u=f[d>>2]|0;t=d+4|0;l=f[t>>2]|0;k=f[e>>2]|0;o=e+4|0;n=f[o>>2]|0;if((g|0)>0){m=u;p=l;s=k;r=n;q=0;v=a;while(1){w=h[v>>0]|0;x=w+m|0;y=(Y(w,w)|0)+s|0;w=h[v+1>>0]|0;z=w+p|0;A=(Y(w,w)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){B=x;C=z;D=y;E=A;break}else{m=x;p=z;s=y;r=A;v=v+i|0}}}else{B=u;C=l;D=k;E=n}f[d>>2]=B;f[t>>2]=C;f[e>>2]=D;f[o>>2]=E;break}case 3:{E=f[d>>2]|0;o=d+4|0;D=f[o>>2]|0;C=d+8|0;t=f[C>>2]|0;B=f[e>>2]|0;n=e+4|0;k=f[n>>2]|0;l=e+8|0;u=f[l>>2]|0;if((g|0)>0){v=E;r=0;s=u;p=k;m=B;q=t;A=D;y=a;while(1){z=h[y>>0]|0;x=z+v|0;w=(Y(z,z)|0)+m|0;z=h[y+1>>0]|0;F=z+A|0;G=(Y(z,z)|0)+p|0;z=h[y+2>>0]|0;H=z+q|0;I=(Y(z,z)|0)+s|0;r=r+1|0;if((r|0)==(g|0)){J=x;K=I;L=G;M=w;N=H;O=F;break}else{v=x;s=I;p=G;m=w;q=H;A=F;y=y+i|0}}}else{J=E;K=u;L=k;M=B;N=t;O=D}f[d>>2]=J;f[o>>2]=O;f[C>>2]=N;f[e>>2]=M;f[n>>2]=L;f[l>>2]=K;break}default:{}}if((j|0)<(i|0)&(g|0)>0)P=j;else{Q=g;return Q|0}do{j=d+(P<<2)|0;K=P+1|0;l=d+(K<<2)|0;L=P+2|0;n=d+(L<<2)|0;M=P+3|0;N=d+(M<<2)|0;C=e+(P<<2)|0;O=e+(K<<2)|0;K=e+(L<<2)|0;L=e+(M<<2)|0;M=0;o=f[L>>2]|0;J=f[K>>2]|0;D=f[O>>2]|0;t=f[C>>2]|0;B=f[N>>2]|0;k=f[n>>2]|0;u=f[l>>2]|0;E=f[j>>2]|0;y=a+P|0;while(1){A=h[y>>0]|0;E=A+E|0;t=(Y(A,A)|0)+t|0;A=h[y+1>>0]|0;u=A+u|0;D=(Y(A,A)|0)+D|0;A=h[y+2>>0]|0;k=A+k|0;J=(Y(A,A)|0)+J|0;A=h[y+3>>0]|0;B=A+B|0;o=(Y(A,A)|0)+o|0;M=M+1|0;if((M|0)==(g|0))break;else y=y+i|0}f[j>>2]=E;f[l>>2]=u;f[n>>2]=k;f[N>>2]=B;f[C>>2]=t;f[O>>2]=D;f[K>>2]=J;f[L>>2]=o;P=P+4|0}while((P|0)<(i|0));Q=g;return Q|0}switch(i|0){case 1:{P=f[d>>2]|0;y=f[e>>2]|0;if((g|0)>0){M=y;A=P;q=0;m=0;while(1){if(!(b[c+m>>0]|0)){R=M;S=A;T=q}else{p=h[a+m>>0]|0;R=(Y(p,p)|0)+M|0;S=p+A|0;T=q+1|0}m=m+1|0;if((m|0)==(g|0)){U=R;V=S;W=T;break}else{M=R;A=S;q=T}}}else{U=y;V=P;W=0}f[d>>2]=V;f[e>>2]=U;Q=W;return Q|0}case 3:{W=f[d>>2]|0;U=d+4|0;V=f[U>>2]|0;P=d+8|0;y=f[P>>2]|0;T=f[e>>2]|0;q=e+4|0;S=f[q>>2]|0;A=e+8|0;R=f[A>>2]|0;if((g|0)>0){M=R;m=S;p=T;s=y;v=V;r=W;F=0;H=0;w=a;while(1){if(!(b[c+F>>0]|0)){X=M;Z=m;_=p;$=s;aa=v;ba=r;ca=H}else{G=h[w>>0]|0;I=h[w+1>>0]|0;x=h[w+2>>0]|0;X=(Y(x,x)|0)+M|0;Z=(Y(I,I)|0)+m|0;_=(Y(G,G)|0)+p|0;$=x+s|0;aa=I+v|0;ba=G+r|0;ca=H+1|0}F=F+1|0;if((F|0)==(g|0)){da=X;ea=Z;fa=_;ga=$;ha=aa;ia=ba;ja=ca;break}else{M=X;m=Z;p=_;s=$;v=aa;r=ba;H=ca;w=w+3|0}}}else{da=R;ea=S;fa=T;ga=y;ha=V;ia=W;ja=0}f[d>>2]=ia;f[U>>2]=ha;f[P>>2]=ga;f[e>>2]=fa;f[q>>2]=ea;f[A>>2]=da;Q=ja;return Q|0}default:{if((g|0)<=0){Q=0;return Q|0}if((i|0)>0){ka=0;la=0;ma=a}else{a=0;ja=0;while(1){da=((b[c+a>>0]|0)!=0&1)+ja|0;a=a+1|0;if((a|0)==(g|0)){Q=da;break}else ja=da}return Q|0}while(1){if(!(b[c+ka>>0]|0))na=la;else{ja=0;do{a=d+(ja<<2)|0;da=h[ma+ja>>0]|0;A=e+(ja<<2)|0;ea=(f[A>>2]|0)+(Y(da,da)|0)|0;f[a>>2]=(f[a>>2]|0)+da;f[A>>2]=ea;ja=ja+1|0}while((ja|0)!=(i|0));na=la+1|0}ka=ka+1|0;if((ka|0)==(g|0)){Q=na;break}else{la=na;ma=ma+i|0}}return Q|0}}return 0}function pL(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=f[e>>2]|0;if((g|0)>0){l=a;m=j;n=k;o=0;while(1){p=b[l>>0]|0;q=p+m|0;r=(Y(p,p)|0)+n|0;o=o+1|0;if((o|0)==(g|0)){s=q;t=r;break}else{l=l+h|0;m=q;n=r}}}else{s=j;t=k}f[d>>2]=s;f[e>>2]=t;break}case 2:{t=f[d>>2]|0;s=d+4|0;k=f[s>>2]|0;j=f[e>>2]|0;n=e+4|0;m=f[n>>2]|0;if((g|0)>0){l=t;o=k;r=j;q=m;p=0;u=a;while(1){v=b[u>>0]|0;w=v+l|0;x=(Y(v,v)|0)+r|0;v=b[u+1>>0]|0;y=v+o|0;z=(Y(v,v)|0)+q|0;p=p+1|0;if((p|0)==(g|0)){A=w;B=y;C=x;D=z;break}else{l=w;o=y;r=x;q=z;u=u+h|0}}}else{A=t;B=k;C=j;D=m}f[d>>2]=A;f[s>>2]=B;f[e>>2]=C;f[n>>2]=D;break}case 3:{D=f[d>>2]|0;n=d+4|0;C=f[n>>2]|0;B=d+8|0;s=f[B>>2]|0;A=f[e>>2]|0;m=e+4|0;j=f[m>>2]|0;k=e+8|0;t=f[k>>2]|0;if((g|0)>0){u=D;q=0;r=t;o=j;l=A;p=s;z=C;x=a;while(1){y=b[x>>0]|0;w=y+u|0;v=(Y(y,y)|0)+l|0;y=b[x+1>>0]|0;E=y+z|0;F=(Y(y,y)|0)+o|0;y=b[x+2>>0]|0;G=y+p|0;H=(Y(y,y)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){I=w;J=H;K=F;L=v;M=G;N=E;break}else{u=w;r=H;o=F;l=v;p=G;z=E;x=x+h|0}}}else{I=D;J=t;K=j;L=A;M=s;N=C}f[d>>2]=I;f[n>>2]=N;f[B>>2]=M;f[e>>2]=L;f[m>>2]=K;f[k>>2]=J;break}default:{}}if((i|0)<(h|0)&(g|0)>0)O=i;else{P=g;return P|0}do{i=d+(O<<2)|0;J=O+1|0;k=d+(J<<2)|0;K=O+2|0;m=d+(K<<2)|0;L=O+3|0;M=d+(L<<2)|0;B=e+(O<<2)|0;N=e+(J<<2)|0;J=e+(K<<2)|0;K=e+(L<<2)|0;L=0;n=f[K>>2]|0;I=f[J>>2]|0;C=f[N>>2]|0;s=f[B>>2]|0;A=f[M>>2]|0;j=f[m>>2]|0;t=f[k>>2]|0;D=f[i>>2]|0;x=a+O|0;while(1){z=b[x>>0]|0;D=z+D|0;s=(Y(z,z)|0)+s|0;z=b[x+1>>0]|0;t=z+t|0;C=(Y(z,z)|0)+C|0;z=b[x+2>>0]|0;j=z+j|0;I=(Y(z,z)|0)+I|0;z=b[x+3>>0]|0;A=z+A|0;n=(Y(z,z)|0)+n|0;L=L+1|0;if((L|0)==(g|0))break;else x=x+h|0}f[i>>2]=D;f[k>>2]=t;f[m>>2]=j;f[M>>2]=A;f[B>>2]=s;f[N>>2]=C;f[J>>2]=I;f[K>>2]=n;O=O+4|0}while((O|0)<(h|0));P=g;return P|0}switch(h|0){case 1:{O=f[d>>2]|0;x=f[e>>2]|0;if((g|0)>0){L=x;z=O;p=0;l=0;while(1){if(!(b[c+l>>0]|0)){Q=L;R=z;S=p}else{o=b[a+l>>0]|0;Q=(Y(o,o)|0)+L|0;R=o+z|0;S=p+1|0}l=l+1|0;if((l|0)==(g|0)){T=Q;U=R;V=S;break}else{L=Q;z=R;p=S}}}else{T=x;U=O;V=0}f[d>>2]=U;f[e>>2]=T;P=V;return P|0}case 3:{V=f[d>>2]|0;T=d+4|0;U=f[T>>2]|0;O=d+8|0;x=f[O>>2]|0;S=f[e>>2]|0;p=e+4|0;R=f[p>>2]|0;z=e+8|0;Q=f[z>>2]|0;if((g|0)>0){L=Q;l=R;o=S;r=x;u=U;q=V;E=0;G=0;v=a;while(1){if(!(b[c+E>>0]|0)){W=L;X=l;Z=o;_=r;$=u;aa=q;ba=G}else{F=b[v>>0]|0;H=b[v+1>>0]|0;w=b[v+2>>0]|0;W=(Y(w,w)|0)+L|0;X=(Y(H,H)|0)+l|0;Z=(Y(F,F)|0)+o|0;_=w+r|0;$=H+u|0;aa=F+q|0;ba=G+1|0}E=E+1|0;if((E|0)==(g|0)){ca=W;da=X;ea=Z;fa=_;ga=$;ha=aa;ia=ba;break}else{L=W;l=X;o=Z;r=_;u=$;q=aa;G=ba;v=v+3|0}}}else{ca=Q;da=R;ea=S;fa=x;ga=U;ha=V;ia=0}f[d>>2]=ha;f[T>>2]=ga;f[O>>2]=fa;f[e>>2]=ea;f[p>>2]=da;f[z>>2]=ca;P=ia;return P|0}default:{if((g|0)<=0){P=0;return P|0}if((h|0)>0){ja=0;ka=0;la=a}else{a=0;ia=0;while(1){ca=((b[c+a>>0]|0)!=0&1)+ia|0;a=a+1|0;if((a|0)==(g|0)){P=ca;break}else ia=ca}return P|0}while(1){if(!(b[c+ja>>0]|0))ma=ka;else{ia=0;do{a=d+(ia<<2)|0;ca=b[la+ia>>0]|0;z=e+(ia<<2)|0;da=(f[z>>2]|0)+(Y(ca,ca)|0)|0;f[a>>2]=(f[a>>2]|0)+ca;f[z>>2]=da;ia=ia+1|0}while((ia|0)!=(h|0));ma=ka+1|0}ja=ja+1|0;if((ja|0)==(g|0)){P=ma;break}else{ka=ma;la=la+h|0}}return P|0}}return 0}function qL(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=a;n=k;o=l;q=0;while(1){r=d[m>>1]|0;s=(r&65535)+n|0;t=+(r&65535);u=o+t*t;q=q+1|0;if((q|0)==(h|0)){v=s;w=u;break}else{m=m+(i<<1)|0;n=s;o=u}}}else{v=k;w=l}f[e>>2]=v;p[g>>3]=w;break}case 2:{v=f[e>>2]|0;k=e+4|0;n=f[k>>2]|0;w=+p[g>>3];m=g+8|0;l=+p[m>>3];if((h|0)>0){q=v;s=n;o=w;u=l;r=0;x=a;while(1){y=d[x>>1]|0;z=d[x+2>>1]|0;A=(y&65535)+q|0;t=+(y&65535);B=o+t*t;y=(z&65535)+s|0;t=+(z&65535);C=u+t*t;r=r+1|0;if((r|0)==(h|0)){D=A;E=y;F=B;G=C;break}else{q=A;s=y;o=B;u=C;x=x+(i<<1)|0}}}else{D=v;E=n;F=w;G=l}f[e>>2]=D;f[k>>2]=E;p[g>>3]=F;p[m>>3]=G;break}case 3:{m=f[e>>2]|0;E=e+4|0;k=f[E>>2]|0;D=e+8|0;n=f[D>>2]|0;G=+p[g>>3];v=g+8|0;F=+p[v>>3];x=g+16|0;l=+p[x>>3];if((h|0)>0){s=m;q=0;w=l;u=F;o=G;r=n;y=k;A=a;while(1){z=d[A>>1]|0;H=d[A+2>>1]|0;I=d[A+4>>1]|0;J=(z&65535)+s|0;C=+(z&65535);B=o+C*C;z=(H&65535)+y|0;C=+(H&65535);t=u+C*C;H=(I&65535)+r|0;C=+(I&65535);K=w+C*C;q=q+1|0;if((q|0)==(h|0)){L=J;M=K;N=t;O=B;P=H;Q=z;break}else{s=J;w=K;u=t;o=B;r=H;y=z;A=A+(i<<1)|0}}}else{L=m;M=l;N=F;O=G;P=n;Q=k}f[e>>2]=L;f[E>>2]=Q;f[D>>2]=P;p[g>>3]=O;p[v>>3]=N;p[x>>3]=M;break}default:{}}if((j|0)<(i|0)&(h|0)>0)R=j;else{S=h;return S|0}do{j=e+(R<<2)|0;x=R+1|0;v=e+(x<<2)|0;P=R+2|0;D=e+(P<<2)|0;Q=R+3|0;E=e+(Q<<2)|0;L=g+(R<<3)|0;k=g+(x<<3)|0;x=g+(P<<3)|0;P=g+(Q<<3)|0;Q=0;M=+p[P>>3];N=+p[x>>3];O=+p[k>>3];G=+p[L>>3];n=f[E>>2]|0;m=f[D>>2]|0;A=f[v>>2]|0;y=f[j>>2]|0;r=a+(R<<1)|0;while(1){s=d[r>>1]|0;q=d[r+2>>1]|0;y=(s&65535)+y|0;F=+(s&65535);G=G+F*F;A=(q&65535)+A|0;F=+(q&65535);O=O+F*F;q=d[r+4>>1]|0;s=d[r+6>>1]|0;m=(q&65535)+m|0;F=+(q&65535);N=N+F*F;n=(s&65535)+n|0;F=+(s&65535);M=M+F*F;Q=Q+1|0;if((Q|0)==(h|0))break;else r=r+(i<<1)|0}f[j>>2]=y;f[v>>2]=A;f[D>>2]=m;f[E>>2]=n;p[L>>3]=G;p[k>>3]=O;p[x>>3]=N;p[P>>3]=M;R=R+4|0}while((R|0)<(i|0));S=h;return S|0}switch(i|0){case 1:{R=f[e>>2]|0;F=+p[g>>3];if((h|0)>0){l=F;r=R;Q=0;s=0;while(1){if(!(b[c+s>>0]|0)){T=l;U=r;V=Q}else{q=d[a+(s<<1)>>1]|0;o=+(q&65535);T=l+o*o;U=(q&65535)+r|0;V=Q+1|0}s=s+1|0;if((s|0)==(h|0)){W=T;X=U;Y=V;break}else{l=T;r=U;Q=V}}}else{W=F;X=R;Y=0}f[e>>2]=X;p[g>>3]=W;S=Y;return S|0}case 3:{Y=f[e>>2]|0;X=e+4|0;R=f[X>>2]|0;V=e+8|0;Q=f[V>>2]|0;W=+p[g>>3];U=g+8|0;F=+p[U>>3];r=g+16|0;T=+p[r>>3];if((h|0)>0){l=T;o=F;u=W;s=Q;q=R;z=Y;H=0;J=0;I=a;while(1){if(!(b[c+H>>0]|0)){Z=l;_=o;$=u;aa=s;ba=q;ca=z;da=J}else{ea=d[I>>1]|0;fa=d[I+2>>1]|0;ga=d[I+4>>1]|0;w=+(ea&65535);B=+(fa&65535);t=+(ga&65535);Z=l+t*t;_=o+B*B;$=u+w*w;aa=(ga&65535)+s|0;ba=(fa&65535)+q|0;ca=(ea&65535)+z|0;da=J+1|0}H=H+1|0;if((H|0)==(h|0)){ha=Z;ia=_;ja=$;ka=aa;la=ba;ma=ca;na=da;break}else{l=Z;o=_;u=$;s=aa;q=ba;z=ca;J=da;I=I+6|0}}}else{ha=T;ia=F;ja=W;ka=Q;la=R;ma=Y;na=0}f[e>>2]=ma;f[X>>2]=la;f[V>>2]=ka;p[g>>3]=ja;p[U>>3]=ia;p[r>>3]=ha;S=na;return S|0}default:{if((h|0)<=0){S=0;return S|0}if((i|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){r=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(h|0)){S=r;break}else na=r}return S|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d[qa+(na<<1)>>1]|0;r=e+(na<<2)|0;U=g+(na<<3)|0;ha=+(a&65535);ia=+p[U>>3]+ha*ha;f[r>>2]=(f[r>>2]|0)+(a&65535);p[U>>3]=ia;na=na+1|0}while((na|0)!=(i|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(h|0)){S=ra;break}else{pa=ra;qa=qa+(i<<1)|0}}return S|0}}return 0}function rL(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=a;n=k;o=l;q=0;while(1){r=d[m>>1]|0;s=(r<<16>>16)+n|0;t=+(r<<16>>16);u=o+t*t;q=q+1|0;if((q|0)==(h|0)){v=s;w=u;break}else{m=m+(i<<1)|0;n=s;o=u}}}else{v=k;w=l}f[e>>2]=v;p[g>>3]=w;break}case 2:{v=f[e>>2]|0;k=e+4|0;n=f[k>>2]|0;w=+p[g>>3];m=g+8|0;l=+p[m>>3];if((h|0)>0){q=v;s=n;o=w;u=l;r=0;x=a;while(1){y=d[x>>1]|0;z=d[x+2>>1]|0;A=(y<<16>>16)+q|0;t=+(y<<16>>16);B=o+t*t;y=(z<<16>>16)+s|0;t=+(z<<16>>16);C=u+t*t;r=r+1|0;if((r|0)==(h|0)){D=A;E=y;F=B;G=C;break}else{q=A;s=y;o=B;u=C;x=x+(i<<1)|0}}}else{D=v;E=n;F=w;G=l}f[e>>2]=D;f[k>>2]=E;p[g>>3]=F;p[m>>3]=G;break}case 3:{m=f[e>>2]|0;E=e+4|0;k=f[E>>2]|0;D=e+8|0;n=f[D>>2]|0;G=+p[g>>3];v=g+8|0;F=+p[v>>3];x=g+16|0;l=+p[x>>3];if((h|0)>0){s=m;q=0;w=l;u=F;o=G;r=n;y=k;A=a;while(1){z=d[A>>1]|0;H=d[A+2>>1]|0;I=d[A+4>>1]|0;J=(z<<16>>16)+s|0;C=+(z<<16>>16);B=o+C*C;z=(H<<16>>16)+y|0;C=+(H<<16>>16);t=u+C*C;H=(I<<16>>16)+r|0;C=+(I<<16>>16);K=w+C*C;q=q+1|0;if((q|0)==(h|0)){L=J;M=K;N=t;O=B;P=H;Q=z;break}else{s=J;w=K;u=t;o=B;r=H;y=z;A=A+(i<<1)|0}}}else{L=m;M=l;N=F;O=G;P=n;Q=k}f[e>>2]=L;f[E>>2]=Q;f[D>>2]=P;p[g>>3]=O;p[v>>3]=N;p[x>>3]=M;break}default:{}}if((j|0)<(i|0)&(h|0)>0)R=j;else{S=h;return S|0}do{j=e+(R<<2)|0;x=R+1|0;v=e+(x<<2)|0;P=R+2|0;D=e+(P<<2)|0;Q=R+3|0;E=e+(Q<<2)|0;L=g+(R<<3)|0;k=g+(x<<3)|0;x=g+(P<<3)|0;P=g+(Q<<3)|0;Q=0;M=+p[P>>3];N=+p[x>>3];O=+p[k>>3];G=+p[L>>3];n=f[E>>2]|0;m=f[D>>2]|0;A=f[v>>2]|0;y=f[j>>2]|0;r=a+(R<<1)|0;while(1){s=d[r>>1]|0;q=d[r+2>>1]|0;y=(s<<16>>16)+y|0;F=+(s<<16>>16);G=G+F*F;A=(q<<16>>16)+A|0;F=+(q<<16>>16);O=O+F*F;q=d[r+4>>1]|0;s=d[r+6>>1]|0;m=(q<<16>>16)+m|0;F=+(q<<16>>16);N=N+F*F;n=(s<<16>>16)+n|0;F=+(s<<16>>16);M=M+F*F;Q=Q+1|0;if((Q|0)==(h|0))break;else r=r+(i<<1)|0}f[j>>2]=y;f[v>>2]=A;f[D>>2]=m;f[E>>2]=n;p[L>>3]=G;p[k>>3]=O;p[x>>3]=N;p[P>>3]=M;R=R+4|0}while((R|0)<(i|0));S=h;return S|0}switch(i|0){case 1:{R=f[e>>2]|0;F=+p[g>>3];if((h|0)>0){l=F;r=R;Q=0;s=0;while(1){if(!(b[c+s>>0]|0)){T=l;U=r;V=Q}else{q=d[a+(s<<1)>>1]|0;o=+(q<<16>>16);T=l+o*o;U=(q<<16>>16)+r|0;V=Q+1|0}s=s+1|0;if((s|0)==(h|0)){W=T;X=U;Y=V;break}else{l=T;r=U;Q=V}}}else{W=F;X=R;Y=0}f[e>>2]=X;p[g>>3]=W;S=Y;return S|0}case 3:{Y=f[e>>2]|0;X=e+4|0;R=f[X>>2]|0;V=e+8|0;Q=f[V>>2]|0;W=+p[g>>3];U=g+8|0;F=+p[U>>3];r=g+16|0;T=+p[r>>3];if((h|0)>0){l=T;o=F;u=W;s=Q;q=R;z=Y;H=0;J=0;I=a;while(1){if(!(b[c+H>>0]|0)){Z=l;_=o;$=u;aa=s;ba=q;ca=z;da=J}else{ea=d[I>>1]|0;fa=d[I+2>>1]|0;ga=d[I+4>>1]|0;w=+(ea<<16>>16);B=+(fa<<16>>16);t=+(ga<<16>>16);Z=l+t*t;_=o+B*B;$=u+w*w;aa=(ga<<16>>16)+s|0;ba=(fa<<16>>16)+q|0;ca=(ea<<16>>16)+z|0;da=J+1|0}H=H+1|0;if((H|0)==(h|0)){ha=Z;ia=_;ja=$;ka=aa;la=ba;ma=ca;na=da;break}else{l=Z;o=_;u=$;s=aa;q=ba;z=ca;J=da;I=I+6|0}}}else{ha=T;ia=F;ja=W;ka=Q;la=R;ma=Y;na=0}f[e>>2]=ma;f[X>>2]=la;f[V>>2]=ka;p[g>>3]=ja;p[U>>3]=ia;p[r>>3]=ha;S=na;return S|0}default:{if((h|0)<=0){S=0;return S|0}if((i|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){r=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(h|0)){S=r;break}else na=r}return S|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d[qa+(na<<1)>>1]|0;r=e+(na<<2)|0;U=g+(na<<3)|0;ha=+(a<<16>>16);ia=+p[U>>3]+ha*ha;f[r>>2]=(f[r>>2]|0)+(a<<16>>16);p[U>>3]=ia;na=na+1|0}while((na|0)!=(i|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(h|0)){S=ra;break}else{pa=ra;qa=qa+(i<<1)|0}}return S|0}}return 0}function sL(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=+p[d>>3];k=+p[e>>3];if((g|0)>0){l=a;m=j;n=k;o=0;while(1){q=+(f[l>>2]|0);r=m+q;s=n+q*q;o=o+1|0;if((o|0)==(g|0)){t=r;u=s;break}else{l=l+(h<<2)|0;m=r;n=s}}}else{t=j;u=k}p[d>>3]=t;p[e>>3]=u;break}case 2:{u=+p[d>>3];l=d+8|0;t=+p[l>>3];k=+p[e>>3];o=e+8|0;j=+p[o>>3];if((g|0)>0){n=u;m=t;s=k;r=j;v=0;w=a;while(1){q=+(f[w>>2]|0);x=n+q;y=s+q*q;q=+(f[w+4>>2]|0);z=m+q;A=r+q*q;v=v+1|0;if((v|0)==(g|0)){B=x;C=z;D=y;E=A;break}else{n=x;m=z;s=y;r=A;w=w+(h<<2)|0}}}else{B=u;C=t;D=k;E=j}p[d>>3]=B;p[l>>3]=C;p[e>>3]=D;p[o>>3]=E;break}case 3:{E=+p[d>>3];o=d+8|0;D=+p[o>>3];l=d+16|0;C=+p[l>>3];B=+p[e>>3];w=e+8|0;j=+p[w>>3];v=e+16|0;k=+p[v>>3];if((g|0)>0){t=E;F=0;u=k;r=j;s=B;m=C;n=D;G=a;while(1){A=+(f[G>>2]|0);y=t+A;z=s+A*A;A=+(f[G+4>>2]|0);x=n+A;q=r+A*A;A=+(f[G+8>>2]|0);H=m+A;I=u+A*A;F=F+1|0;if((F|0)==(g|0)){J=y;K=I;L=q;M=z;N=H;O=x;break}else{t=y;u=I;r=q;s=z;m=H;n=x;G=G+(h<<2)|0}}}else{J=E;K=k;L=j;M=B;N=C;O=D}p[d>>3]=J;p[o>>3]=O;p[l>>3]=N;p[e>>3]=M;p[w>>3]=L;p[v>>3]=K;break}default:{}}if((i|0)<(h|0)&(g|0)>0)P=i;else{Q=g;return Q|0}do{i=d+(P<<3)|0;v=P+1|0;w=d+(v<<3)|0;l=P+2|0;o=d+(l<<3)|0;G=P+3|0;F=d+(G<<3)|0;R=e+(P<<3)|0;S=e+(v<<3)|0;v=e+(l<<3)|0;l=e+(G<<3)|0;G=0;K=+p[l>>3];L=+p[v>>3];M=+p[S>>3];N=+p[R>>3];O=+p[F>>3];J=+p[o>>3];D=+p[w>>3];C=+p[i>>3];T=a+(P<<2)|0;while(1){B=+(f[T>>2]|0);C=C+B;N=N+B*B;B=+(f[T+4>>2]|0);D=D+B;M=M+B*B;B=+(f[T+8>>2]|0);J=J+B;L=L+B*B;B=+(f[T+12>>2]|0);O=O+B;K=K+B*B;G=G+1|0;if((G|0)==(g|0))break;else T=T+(h<<2)|0}p[i>>3]=C;p[w>>3]=D;p[o>>3]=J;p[F>>3]=O;p[R>>3]=N;p[S>>3]=M;p[v>>3]=L;p[l>>3]=K;P=P+4|0}while((P|0)<(h|0));Q=g;return Q|0}switch(h|0){case 1:{B=+p[d>>3];j=+p[e>>3];if((g|0)>0){k=j;E=B;P=0;T=0;while(1){if(!(b[c+T>>0]|0)){U=k;V=E;W=P}else{n=+(f[a+(T<<2)>>2]|0);U=k+n*n;V=E+n;W=P+1|0}T=T+1|0;if((T|0)==(g|0)){X=U;Y=V;Z=W;break}else{k=U;E=V;P=W}}}else{X=j;Y=B;Z=0}p[d>>3]=Y;p[e>>3]=X;Q=Z;return Q|0}case 3:{X=+p[d>>3];Z=d+8|0;Y=+p[Z>>3];W=d+16|0;B=+p[W>>3];j=+p[e>>3];P=e+8|0;V=+p[P>>3];T=e+16|0;E=+p[T>>3];if((g|0)>0){U=E;k=V;n=j;m=B;s=Y;r=X;G=0;_=0;$=a;while(1){if(!(b[c+G>>0]|0)){aa=U;ba=k;ca=n;da=m;ea=s;fa=r;ga=_}else{u=+(f[$>>2]|0);t=+(f[$+4>>2]|0);x=+(f[$+8>>2]|0);aa=U+x*x;ba=k+t*t;ca=n+u*u;da=m+x;ea=s+t;fa=r+u;ga=_+1|0}G=G+1|0;if((G|0)==(g|0)){ha=aa;ia=ba;ja=ca;ka=da;la=ea;ma=fa;na=ga;break}else{U=aa;k=ba;n=ca;m=da;s=ea;r=fa;_=ga;$=$+12|0}}}else{ha=E;ia=V;ja=j;ka=B;la=Y;ma=X;na=0}p[d>>3]=ma;p[Z>>3]=la;p[W>>3]=ka;p[e>>3]=ja;p[P>>3]=ia;p[T>>3]=ha;Q=na;return Q|0}default:{if((g|0)<=0){Q=0;return Q|0}if((h|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){T=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(g|0)){Q=T;break}else na=T}return Q|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d+(na<<3)|0;ha=+(f[qa+(na<<2)>>2]|0);T=e+(na<<3)|0;ia=+p[T>>3]+ha*ha;p[a>>3]=+p[a>>3]+ha;p[T>>3]=ia;na=na+1|0}while((na|0)!=(h|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(g|0)){Q=ra;break}else{pa=ra;qa=qa+(h<<2)|0}}return Q|0}}return 0}function tL(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=a;l=i;m=j;o=0;while(1){q=+n[k>>2];r=l+q;s=m+q*q;o=o+1|0;if((o|0)==(f|0)){t=r;u=s;break}else{k=k+(g<<2)|0;l=r;m=s}}}else{t=i;u=j}p[d>>3]=t;p[e>>3]=u;break}case 2:{u=+p[d>>3];k=d+8|0;t=+p[k>>3];j=+p[e>>3];o=e+8|0;i=+p[o>>3];if((f|0)>0){m=u;l=t;s=j;r=i;v=0;w=a;while(1){q=+n[w>>2];x=m+q;y=s+q*q;q=+n[w+4>>2];z=l+q;A=r+q*q;v=v+1|0;if((v|0)==(f|0)){B=x;C=z;D=y;E=A;break}else{m=x;l=z;s=y;r=A;w=w+(g<<2)|0}}}else{B=u;C=t;D=j;E=i}p[d>>3]=B;p[k>>3]=C;p[e>>3]=D;p[o>>3]=E;break}case 3:{E=+p[d>>3];o=d+8|0;D=+p[o>>3];k=d+16|0;C=+p[k>>3];B=+p[e>>3];w=e+8|0;i=+p[w>>3];v=e+16|0;j=+p[v>>3];if((f|0)>0){t=E;F=0;u=j;r=i;s=B;l=C;m=D;G=a;while(1){A=+n[G>>2];y=t+A;z=s+A*A;A=+n[G+4>>2];x=m+A;q=r+A*A;A=+n[G+8>>2];H=l+A;I=u+A*A;F=F+1|0;if((F|0)==(f|0)){J=y;K=I;L=q;M=z;N=H;O=x;break}else{t=y;u=I;r=q;s=z;l=H;m=x;G=G+(g<<2)|0}}}else{J=E;K=j;L=i;M=B;N=C;O=D}p[d>>3]=J;p[o>>3]=O;p[k>>3]=N;p[e>>3]=M;p[w>>3]=L;p[v>>3]=K;break}default:{}}if((h|0)<(g|0)&(f|0)>0)P=h;else{Q=f;return Q|0}do{h=d+(P<<3)|0;v=P+1|0;w=d+(v<<3)|0;k=P+2|0;o=d+(k<<3)|0;G=P+3|0;F=d+(G<<3)|0;R=e+(P<<3)|0;S=e+(v<<3)|0;v=e+(k<<3)|0;k=e+(G<<3)|0;G=0;K=+p[k>>3];L=+p[v>>3];M=+p[S>>3];N=+p[R>>3];O=+p[F>>3];J=+p[o>>3];D=+p[w>>3];C=+p[h>>3];T=a+(P<<2)|0;while(1){B=+n[T>>2];C=C+B;N=N+B*B;B=+n[T+4>>2];D=D+B;M=M+B*B;B=+n[T+8>>2];J=J+B;L=L+B*B;B=+n[T+12>>2];O=O+B;K=K+B*B;G=G+1|0;if((G|0)==(f|0))break;else T=T+(g<<2)|0}p[h>>3]=C;p[w>>3]=D;p[o>>3]=J;p[F>>3]=O;p[R>>3]=N;p[S>>3]=M;p[v>>3]=L;p[k>>3]=K;P=P+4|0}while((P|0)<(g|0));Q=f;return Q|0}switch(g|0){case 1:{B=+p[d>>3];i=+p[e>>3];if((f|0)>0){j=i;E=B;P=0;T=0;while(1){if(!(b[c+T>>0]|0)){U=j;V=E;W=P}else{m=+n[a+(T<<2)>>2];U=j+m*m;V=E+m;W=P+1|0}T=T+1|0;if((T|0)==(f|0)){X=U;Y=V;Z=W;break}else{j=U;E=V;P=W}}}else{X=i;Y=B;Z=0}p[d>>3]=Y;p[e>>3]=X;Q=Z;return Q|0}case 3:{X=+p[d>>3];Z=d+8|0;Y=+p[Z>>3];W=d+16|0;B=+p[W>>3];i=+p[e>>3];P=e+8|0;V=+p[P>>3];T=e+16|0;E=+p[T>>3];if((f|0)>0){U=E;j=V;m=i;l=B;s=Y;r=X;G=0;_=0;$=a;while(1){if(!(b[c+G>>0]|0)){aa=U;ba=j;ca=m;da=l;ea=s;fa=r;ga=_}else{u=+n[$>>2];t=+n[$+4>>2];x=+n[$+8>>2];aa=U+x*x;ba=j+t*t;ca=m+u*u;da=l+x;ea=s+t;fa=r+u;ga=_+1|0}G=G+1|0;if((G|0)==(f|0)){ha=aa;ia=ba;ja=ca;ka=da;la=ea;ma=fa;na=ga;break}else{U=aa;j=ba;m=ca;l=da;s=ea;r=fa;_=ga;$=$+12|0}}}else{ha=E;ia=V;ja=i;ka=B;la=Y;ma=X;na=0}p[d>>3]=ma;p[Z>>3]=la;p[W>>3]=ka;p[e>>3]=ja;p[P>>3]=ia;p[T>>3]=ha;Q=na;return Q|0}default:{if((f|0)<=0){Q=0;return Q|0}if((g|0)>0){oa=0;pa=0;qa=a}else{a=0;na=0;while(1){T=((b[c+a>>0]|0)!=0&1)+na|0;a=a+1|0;if((a|0)==(f|0)){Q=T;break}else na=T}return Q|0}while(1){if(!(b[c+oa>>0]|0))ra=pa;else{na=0;do{a=d+(na<<3)|0;ha=+n[qa+(na<<2)>>2];T=e+(na<<3)|0;ia=+p[T>>3]+ha*ha;p[a>>3]=+p[a>>3]+ha;p[T>>3]=ia;na=na+1|0}while((na|0)!=(g|0));ra=pa+1|0}oa=oa+1|0;if((oa|0)==(f|0)){Q=ra;break}else{pa=ra;qa=qa+(g<<2)|0}}return Q|0}}return 0}function uL(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0.0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=a;l=i;m=j;n=0;while(1){o=+p[k>>3];q=l+o;r=m+o*o;n=n+1|0;if((n|0)==(f|0)){s=q;t=r;break}else{k=k+(g<<3)|0;l=q;m=r}}}else{s=i;t=j}p[d>>3]=s;p[e>>3]=t;break}case 2:{t=+p[d>>3];k=d+8|0;s=+p[k>>3];j=+p[e>>3];n=e+8|0;i=+p[n>>3];if((f|0)>0){m=t;l=s;r=j;q=i;u=0;v=a;while(1){o=+p[v>>3];w=+p[v+8>>3];x=m+o;y=r+o*o;o=l+w;z=q+w*w;u=u+1|0;if((u|0)==(f|0)){A=x;B=o;C=y;D=z;break}else{m=x;l=o;r=y;q=z;v=v+(g<<3)|0}}}else{A=t;B=s;C=j;D=i}p[d>>3]=A;p[k>>3]=B;p[e>>3]=C;p[n>>3]=D;break}case 3:{D=+p[d>>3];n=d+8|0;C=+p[n>>3];k=d+16|0;B=+p[k>>3];A=+p[e>>3];v=e+8|0;i=+p[v>>3];u=e+16|0;j=+p[u>>3];if((f|0)>0){s=D;E=0;t=j;q=i;r=A;l=B;m=C;F=a;while(1){z=+p[F>>3];y=+p[F+8>>3];o=+p[F+16>>3];x=s+z;w=r+z*z;z=m+y;G=q+y*y;y=l+o;H=t+o*o;E=E+1|0;if((E|0)==(f|0)){I=x;J=H;K=G;L=w;M=y;N=z;break}else{s=x;t=H;q=G;r=w;l=y;m=z;F=F+(g<<3)|0}}}else{I=D;J=j;K=i;L=A;M=B;N=C}p[d>>3]=I;p[n>>3]=N;p[k>>3]=M;p[e>>3]=L;p[v>>3]=K;p[u>>3]=J;break}default:{}}if((h|0)<(g|0)&(f|0)>0)O=h;else{P=f;return P|0}do{h=d+(O<<3)|0;u=O+1|0;v=d+(u<<3)|0;k=O+2|0;n=d+(k<<3)|0;F=O+3|0;E=d+(F<<3)|0;Q=e+(O<<3)|0;R=e+(u<<3)|0;u=e+(k<<3)|0;k=e+(F<<3)|0;F=0;J=+p[k>>3];K=+p[u>>3];L=+p[R>>3];M=+p[Q>>3];N=+p[E>>3];I=+p[n>>3];C=+p[v>>3];B=+p[h>>3];S=a+(O<<3)|0;while(1){A=+p[S>>3];i=+p[S+8>>3];B=B+A;M=M+A*A;C=C+i;L=L+i*i;i=+p[S+16>>3];A=+p[S+24>>3];I=I+i;K=K+i*i;N=N+A;J=J+A*A;F=F+1|0;if((F|0)==(f|0))break;else S=S+(g<<3)|0}p[h>>3]=B;p[v>>3]=C;p[n>>3]=I;p[E>>3]=N;p[Q>>3]=M;p[R>>3]=L;p[u>>3]=K;p[k>>3]=J;O=O+4|0}while((O|0)<(g|0));P=f;return P|0}switch(g|0){case 1:{A=+p[d>>3];i=+p[e>>3];if((f|0)>0){j=i;D=A;O=0;S=0;while(1){if(!(b[c+S>>0]|0)){T=j;U=D;V=O}else{m=+p[a+(S<<3)>>3];T=j+m*m;U=D+m;V=O+1|0}S=S+1|0;if((S|0)==(f|0)){W=T;X=U;Y=V;break}else{j=T;D=U;O=V}}}else{W=i;X=A;Y=0}p[d>>3]=X;p[e>>3]=W;P=Y;return P|0}case 3:{W=+p[d>>3];Y=d+8|0;X=+p[Y>>3];V=d+16|0;A=+p[V>>3];i=+p[e>>3];O=e+8|0;U=+p[O>>3];S=e+16|0;D=+p[S>>3];if((f|0)>0){T=D;j=U;m=i;l=A;r=X;q=W;F=0;Z=0;_=a;while(1){if(!(b[c+F>>0]|0)){$=T;aa=j;ba=m;ca=l;da=r;ea=q;fa=Z}else{t=+p[_>>3];s=+p[_+8>>3];z=+p[_+16>>3];$=T+z*z;aa=j+s*s;ba=m+t*t;ca=l+z;da=r+s;ea=q+t;fa=Z+1|0}F=F+1|0;if((F|0)==(f|0)){ga=$;ha=aa;ia=ba;ja=ca;ka=da;la=ea;ma=fa;break}else{T=$;j=aa;m=ba;l=ca;r=da;q=ea;Z=fa;_=_+24|0}}}else{ga=D;ha=U;ia=i;ja=A;ka=X;la=W;ma=0}p[d>>3]=la;p[Y>>3]=ka;p[V>>3]=ja;p[e>>3]=ia;p[O>>3]=ha;p[S>>3]=ga;P=ma;return P|0}default:{if((f|0)<=0){P=0;return P|0}if((g|0)>0){na=0;oa=0;pa=a}else{a=0;ma=0;while(1){S=((b[c+a>>0]|0)!=0&1)+ma|0;a=a+1|0;if((a|0)==(f|0)){P=S;break}else ma=S}return P|0}while(1){if(!(b[c+na>>0]|0))qa=oa;else{ma=0;do{ga=+p[pa+(ma<<3)>>3];a=d+(ma<<3)|0;S=e+(ma<<3)|0;ha=ga*ga+ +p[S>>3];p[a>>3]=ga+ +p[a>>3];p[S>>3]=ha;ma=ma+1|0}while((ma|0)!=(g|0));qa=oa+1|0}na=na+1|0;if((na|0)==(f|0)){P=qa;break}else{oa=qa;pa=pa+(g<<3)|0}}return P|0}}return 0}function vL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;d=b+12|0;e=b+8|0;f[e>>2]=0;if(!(pIc(e,64,a)|0)){g=f[e>>2]|0;if(g|0){u=b;return g|0}}else f[e>>2]=0;e=c;f[e>>2]=a;f[e+4>>2]=0;DM(d,217720,c);vM(-4,d,217750,217767,55);return 0}function wL(a){a=a|0;kIc(a);return}function xL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;d=b+12|0;e=b+8|0;f[e>>2]=0;if(!(pIc(e,64,a)|0)){g=f[e>>2]|0;if(g|0){u=b;return g|0}}else f[e>>2]=0;e=c;f[e>>2]=a;f[e+4>>2]=0;DM(d,217720,c);vM(-4,d,217750,217767,55);return 0}function yL(a){a=a|0;kIc(a);return}function zL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;AL(a,b,c,0,d);return}function AL(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=u;u=u+64|0;i=h;if(!c){j=$Xc(32)|0;f[i>>2]=j;k=i+8|0;f[k>>2]=-2147483616;l=i+4|0;f[l>>2]=29;m=j;n=217834;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+29|0;b[p>>0]=0;vM(-215,i,255008,217864,30)}if(!((d|0)!=0|(e|0)!=0)){j=$Xc(32)|0;f[i>>2]=j;k=i+8|0;f[k>>2]=-2147483616;l=i+4|0;f[l>>2]=29;m=j;n=217834;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+29|0;b[p>>0]=0;vM(-215,i,255008,217864,30)}f[a>>2]=c;p=a+8|0;f[p>>2]=e;e=a+4|0;f[e>>2]=d;d=a+12|0;f[d>>2]=g;j=a+16|0;f[j>>2]=0;l=a+20|0;f[l>>2]=0;if((g|0)<0){k=0;while(1)if(!(f[c+(k<<2)>>2]|0))break;else k=k+1|0;f[d>>2]=k;if((k|0)<1001)q=k;else{k=$Xc(16)|0;f[i>>2]=k;f[i+8>>2]=-2147483632;f[i+4>>2]=15;m=k;n=217941;o=m+15|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[k+15>>0]=0;vM(-215,i,255008,217864,45)}}else q=g;g=a+24|0;f[g>>2]=0;k=(q|0)>0;do if(k){r=f[c>>2]|0;if(!r){s=$Xc(16)|0;f[i>>2]=s;t=i+8|0;f[t>>2]=-2147483632;v=i+4|0;f[v>>2]=14;m=s;n=217957;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));w=s+14|0;b[w>>0]=0;vM(-215,i,255008,217864,52)}else{x=-1;y=-1;z=0;A=0;B=0;C=r}a:while(1){D=f[p>>2]|0;if(!D)E=C+16|0;else{F=C+16|0;f[D+(A<<2)>>2]=f[F>>2];E=F}if(f[E>>2]|0){b:do if((y|0)<0){F=f[C+4>>2]|0;if((F|0)>0){D=f[C+40>>2]|0;G=0;while(1){if((f[D+(G<<2)>>2]|0)>1){H=F;I=A;K=G;break b}L=G+1|0;if((L|0)<(F|0))G=L;else{H=F;I=A;K=L;break}}}else{H=F;I=A;K=0}}else{G=f[C+40>>2]|0;D=f[G+-4>>2]|0;L=f[(f[(f[a>>2]|0)+(y<<2)>>2]|0)+40>>2]|0;if((D|0)!=(f[L+-4>>2]|0)){M=27;break a}if((D|0)==2){if((f[G>>2]|0)!=(f[L>>2]|0)){M=27;break a}if((f[G+4>>2]|0)==(f[L+4>>2]|0)){H=x;I=y;K=z;break}else{M=27;break a}}if((D|0)>0){N=0;while(1){if((f[G+(N<<2)>>2]|0)!=(f[L+(N<<2)>>2]|0)){M=27;break a}N=N+1|0;if((N|0)>=(D|0)){H=x;I=y;K=z;break}}}else{H=x;I=y;K=z}}while(0);if(!(f[C>>2]&16384)){D=H+-1|0;N=f[C+44>>2]|0;L=f[N+(D<<2)>>2]|0;G=f[C+4>>2]|0;if((G|0)>0)O=f[N+(G+-1<<2)>>2]|0;else O=0;if((L|0)!=(O|0)){M=33;break}G=C+40|0;F=L;L=D;while(1){if((L|0)<=(K|0))break;D=Y(f[(f[G>>2]|0)+(L<<2)>>2]|0,F)|0;P=L+-1|0;F=f[N+(P<<2)>>2]|0;if(D>>>0<F>>>0)break;else L=P}F=(B|0)<(L|0)?L:B;f[g>>2]=F;Q=H;R=I;S=K;T=F}else{Q=H;R=I;S=K;T=B}}else{Q=x;R=y;S=z;T=B}A=A+1|0;if((A|0)>=(q|0)){M=39;break}C=f[(f[a>>2]|0)+(A<<2)>>2]|0;if(!C){M=10;break}else{x=Q;y=R;z=S;B=T}}if((M|0)==10){s=$Xc(16)|0;f[i>>2]=s;t=i+8|0;f[t>>2]=-2147483632;v=i+4|0;f[v>>2]=14;m=s;n=217957;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));w=s+14|0;b[w>>0]=0;vM(-215,i,255008,217864,52)}else if((M|0)==27){r=$Xc(32)|0;f[i>>2]=r;f[i+8>>2]=-2147483616;f[i+4>>2]=26;m=r;n=217972;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[r+26>>0]=0;vM(-215,i,255008,217864,72)}else if((M|0)==33){F=$Xc(32)|0;f[i>>2]=F;f[i+8>>2]=-2147483616;f[i+4>>2]=27;m=F;n=217999;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[F+27>>0]=0;vM(-215,i,255008,217864,76)}else if((M|0)==39){if((R|0)<=-1){M=45;break}r=Q+-1|0;N=f[(f[(f[a>>2]|0)+(R<<2)>>2]|0)+40>>2]|0;G=f[N+(r<<2)>>2]|0;P=r;while(1){f[l>>2]=G;if((P|0)<=(T|0))break;r=P+-1|0;D=f[N+(r<<2)>>2]|0;G=x1c(D|0,((D|0)<0)<<31>>31|0,G|0,0)|0;if(!((G|0)==(G|0)&(J|0)==(((G|0)<0)<<31>>31|0)))break;else P=r}G=(P|0)==(S|0)?0:P;f[g>>2]=G;f[j>>2]=1;if((G|0)>0){U=1;V=G}else break;do{G=V;V=V+-1|0;U=Y(U,f[N+(V<<2)>>2]|0)|0;f[j>>2]=U}while((G|0)>1)}}else M=45;while(0);if((M|0)==45)f[g>>2]=0;f[a+28>>2]=0;if((f[e>>2]|0)==0|k^1){u=h;return}k=i+4|0;g=i+8|0;U=i+40|0;j=i+48|0;V=i+44|0;S=i+52|0;T=i+36|0;R=i+16|0;Q=i+12|0;w=i+20|0;s=i+24|0;v=i+28|0;t=i+32|0;B=i+44|0;z=i+36|0;y=i+16|0;x=i+4|0;C=i+40|0;A=i+44|0;q=i+48|0;K=i+8|0;I=i+12|0;H=i+20|0;O=i+24|0;E=i+28|0;p=i+32|0;c=i+44|0;N=0;while(1){P=f[(f[a>>2]|0)+(N<<2)>>2]|0;if(!P){M=49;break}G=f[P+16>>2]|0;if(!G){f[i>>2]=1124007936;m=k;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[U>>2]=g;f[V>>2]=j;f[j>>2]=0;f[S>>2]=0;F=f[e>>2]|0;r=F+(N*56|0)|0;if((r|0)!=(i|0)){D=F+(N*56|0)+36|0;W=f[D>>2]|0;if(W|0?(X=W+12|0,W=f[X>>2]|0,f[X>>2]=W+-1,(W|0)==1):0)V$(r);f[D>>2]=0;W=F+(N*56|0)+16|0;X=F+(N*56|0)+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[X>>2]|0)>0){Z=f[F+(N*56|0)+40>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[X>>2]|0))}f[r>>2]=f[i>>2];f[X>>2]=f[k>>2];_=F+(N*56|0)+8|0;f[_>>2]=f[g>>2];f[F+(N*56|0)+12>>2]=f[Q>>2];f[W>>2]=f[R>>2];f[F+(N*56|0)+20>>2]=f[w>>2];f[F+(N*56|0)+24>>2]=f[s>>2];f[F+(N*56|0)+28>>2]=f[v>>2];f[F+(N*56|0)+32>>2]=f[t>>2];f[D>>2]=f[T>>2];Z=F+(N*56|0)+44|0;$=f[Z>>2]|0;aa=F+(N*56|0)+48|0;if(($|0)==(aa|0))ba=$;else{wL($);f[Z>>2]=aa;f[F+(N*56|0)+40>>2]=_;ba=aa}if((f[k>>2]|0)<3){aa=f[B>>2]|0;f[ba>>2]=f[aa>>2];f[ba+4>>2]=f[aa+4>>2];ca=aa}else{f[Z>>2]=f[B>>2];f[F+(N*56|0)+40>>2]=f[U>>2];f[B>>2]=j;f[U>>2]=g;ca=j}f[i>>2]=1124007936;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[T>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((ca|0)!=(j|0))wL(ca)}else{f[T>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0}}else{Tj(i,1,f[l>>2]|0,f[P>>2]&4095,G,0);Z=f[e>>2]|0;aa=Z+(N*56|0)|0;if((aa|0)==(i|0)){_=f[z>>2]|0;if(_|0?($=_+12|0,_=f[$>>2]|0,f[$>>2]=_+-1,(_|0)==1):0)V$(i)}else{_=Z+(N*56|0)+36|0;$=f[_>>2]|0;if($|0?(da=$+12|0,$=f[da>>2]|0,f[da>>2]=$+-1,($|0)==1):0)V$(aa);f[_>>2]=0;$=Z+(N*56|0)+16|0;da=Z+(N*56|0)+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[da>>2]|0)>0){ea=f[Z+(N*56|0)+40>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[da>>2]|0))}f[aa>>2]=f[i>>2];f[da>>2]=f[x>>2];fa=Z+(N*56|0)+8|0;f[fa>>2]=f[K>>2];f[Z+(N*56|0)+12>>2]=f[I>>2];f[$>>2]=f[y>>2];f[Z+(N*56|0)+20>>2]=f[H>>2];f[Z+(N*56|0)+24>>2]=f[O>>2];f[Z+(N*56|0)+28>>2]=f[E>>2];f[Z+(N*56|0)+32>>2]=f[p>>2];f[_>>2]=f[z>>2];ea=Z+(N*56|0)+44|0;G=f[ea>>2]|0;P=Z+(N*56|0)+48|0;if((G|0)==(P|0))ga=G;else{wL(G);f[ea>>2]=P;f[Z+(N*56|0)+40>>2]=fa;ga=P}if((f[x>>2]|0)<3){P=f[c>>2]|0;f[ga>>2]=f[P>>2];f[ga+4>>2]=f[P+4>>2]}else{f[ea>>2]=f[c>>2];f[Z+(N*56|0)+40>>2]=f[C>>2];f[c>>2]=q;f[C>>2]=K}f[i>>2]=1124007936;m=x;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0))}f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[x>>2]|0)>0){Z=f[C>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[x>>2]|0))}_=f[A>>2]|0;if((_|0)!=(q|0))wL(_)}N=N+1|0;if((N|0)>=(f[d>>2]|0)){M=90;break}}if((M|0)==49){d=$Xc(16)|0;f[i>>2]=d;f[i+8>>2]=-2147483632;f[i+4>>2]=14;m=d;n=217957;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[d+14>>0]=0;vM(-215,i,255008,217864,113)}else if((M|0)==90){u=h;return}}function BL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;AL(a,b,0,c,d);return}function CL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=a+28|0;c=f[b>>2]|0;if(c>>>0>=((f[a+16>>2]|0)+-1|0)>>>0)return a|0;d=c+1|0;f[b>>2]=d;b=f[a+24>>2]|0;if((b|0)!=1){c=f[a+12>>2]|0;if((c|0)<=0)return a|0;e=a+8|0;g=a+4|0;h=(d|0)>0&(b|0)>0;i=0;do{j=f[(f[a>>2]|0)+(i<<2)>>2]|0;k=f[j+16>>2]|0;if(k|0){if(h){l=f[j+40>>2]|0;m=f[j+44>>2]|0;j=b;n=k;o=d;while(1){p=j;j=j+-1|0;q=f[l+(j<<2)>>2]|0;r=o;o=(o|0)/(q|0)|0;s=r-(Y(o,q)|0)|0;q=n+(Y(s,f[m+(j<<2)>>2]|0)|0)|0;if(!((o|0)>0&(p|0)>1)){t=q;break}else n=q}}else t=k;n=f[e>>2]|0;if(n|0)f[n+(i<<2)>>2]=t;n=f[g>>2]|0;if(n|0)f[n+(i*56|0)+16>>2]=t}i=i+1|0}while((i|0)<(c|0));return a|0}c=a+8|0;i=f[c>>2]|0;a:do if(i|0?(t=f[a+12>>2]|0,(t|0)>0):0){g=0;e=i;while(1){b=e+(g<<2)|0;if(f[b>>2]|0){h=f[(f[a>>2]|0)+(g<<2)>>2]|0;n=(f[h+16>>2]|0)+(Y(d,f[f[h+44>>2]>>2]|0)|0)|0;f[b>>2]=n}n=g+1|0;if((n|0)>=(t|0))break a;g=n;e=f[c>>2]|0}}while(0);c=f[a+4>>2]|0;if(!c)return a|0;i=f[a+12>>2]|0;if((i|0)<=0)return a|0;e=0;do{g=c+(e*56|0)+16|0;if(f[g>>2]|0){t=f[(f[a>>2]|0)+(e<<2)>>2]|0;k=(f[t+16>>2]|0)+(Y(d,f[f[t+44>>2]>>2]|0)|0)|0;f[g>>2]=k}e=e+1|0}while((e|0)<(i|0));return a|0}function DL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=f[a>>2]|0;if(f[d>>2]&16384|0){e=a+12|0;g=a+8|0;h=(f[(c?g:e)>>2]|0)+(Y(f[a+4>>2]|0,b)|0)|0;f[g>>2]=h;i=f[e>>2]|0;if(h>>>0<i>>>0){f[g>>2]=i;return}i=f[a+16>>2]|0;if(h>>>0<=i>>>0)return;f[g>>2]=i;return}i=f[d+4>>2]|0;if((i|0)==2){if(c){g=f[d+16>>2]|0;h=(f[a+8>>2]|0)-g|0;e=f[f[d+44>>2]>>2]|0;j=(h>>>0)/(e>>>0)|0;k=f[d+12>>2]|0;l=Y(k,j)|0;m=h-(Y(j,e)|0)|0;j=a+4|0;h=f[j>>2]|0;n=l+b+((m>>>0)/(h>>>0)|0)|0;o=j;p=k;q=e;r=g;s=h}else{h=a+4|0;n=b;o=h;p=f[d+12>>2]|0;q=f[f[d+44>>2]>>2]|0;r=f[d+16>>2]|0;s=f[h>>2]|0}h=(n|0)/(p|0)|0;g=(h|0)<0;e=f[d+8>>2]|0;k=e+-1|0;j=g?0:h;m=r+(Y(q,(k|0)<(j|0)?k:j)|0)|0;f[a+12>>2]=m;j=m+(Y(s,p)|0)|0;f[a+16>>2]=j;if(!g)if((h|0)<(e|0)){e=n-(Y(p,h)|0)|0;t=m+(Y(e,f[o>>2]|0)|0)|0}else t=j;else t=m;f[a+8>>2]=t;return}if(c){if((i|0)>0){c=f[d+44>>2]|0;t=f[d+40>>2]|0;m=(f[a+8>>2]|0)-(f[d+16>>2]|0)|0;j=0;o=0;while(1){e=f[c+(o<<2)>>2]|0;h=(m>>>0)/(e>>>0)|0;m=m-(Y(h,e)|0)|0;e=(Y(f[t+(o<<2)>>2]|0,j)|0)+h|0;o=o+1|0;if((o|0)==(i|0)){u=e;break}else j=e}}else u=0;v=u+b|0}else v=b;b=(v|0)>0?v:0;v=f[d+40>>2]|0;u=f[v+(i+-1<<2)>>2]|0;j=(b|0)/(u|0)|0;o=b-(Y(j,u)|0)|0;b=f[d+16>>2]|0;t=f[a+4>>2]|0;m=Y(o,t)|0;o=a+8|0;f[o>>2]=b+m;c=a+12|0;f[c>>2]=b;e=i+-2|0;if((e|0)>-1){i=f[d+44>>2]|0;d=e;e=j;h=b;while(1){p=f[v+(d<<2)>>2]|0;n=e;e=(e|0)/(p|0)|0;g=n-(Y(e,p)|0)|0;h=h+(Y(g,f[i+(d<<2)>>2]|0)|0)|0;if((d|0)<=0)break;else d=d+-1|0}f[c>>2]=h;w=e;x=h}else{w=j;x=b}b=x+(Y(t,u)|0)|0;f[a+16>>2]=b;f[o>>2]=(w|0)>0?b:x+m|0;return}function EL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[a>>2]|0;e=f[d+4>>2]|0;do if(b){if((e|0)==2){g=Y(f[(f[d+40>>2]|0)+4>>2]|0,f[b>>2]|0)|0;h=g+(f[b+4>>2]|0)|0;break}if((e|0)>0){g=f[d+40>>2]|0;i=0;j=0;while(1){k=Y(f[g+(j<<2)>>2]|0,i)|0;l=k+(f[b+(j<<2)>>2]|0)|0;j=j+1|0;if((j|0)==(e|0)){h=l;break}else i=l}}else h=0}else h=0;while(0);DL(a,h,c);return}function FL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e;if((c|0)<0&(d|0)>255){i=1;u=e;return i|0}if((d|0)<(c|0)|((c|0)>255|(d|0)<0)){f[b>>2]=0;f[b+4>>2]=0;i=0;u=e;return i|0}g0(g,a,1,0);j=f[g+8>>2]|0;a:do if((j|0)>0?(k=f[g+12>>2]|0,l=f[g+16>>2]|0,(k|0)>0):0){m=f[f[g+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=h[o+p>>0]|0;if((q|0)<(c|0)|(q|0)>(d|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(j|0))n=o;else{r=1;break a}}f[b+4>>2]=n;f[b>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=g+36|0;p=f[a>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)V$(g);f[a>>2]=0;a=g+16|0;p=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[g+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[p>>2]|0))}p=f[g+44>>2]|0;if((p|0)!=(g+48|0))wL(p);i=r;u=e;return i|0}function GL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+64|0;h=g;if((d|0)<-128&(e|0)>127){i=1;u=g;return i|0}if((e|0)<(d|0)|((d|0)>127|(e|0)<-128)){f[c>>2]=0;f[c+4>>2]=0;i=0;u=g;return i|0}g0(h,a,1,0);j=f[h+8>>2]|0;a:do if((j|0)>0?(k=f[h+12>>2]|0,l=f[h+16>>2]|0,(k|0)>0):0){m=f[f[h+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=b[o+p>>0]|0;if((q|0)<(d|0)|(q|0)>(e|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(j|0))n=o;else{r=1;break a}}f[c+4>>2]=n;f[c>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=h+36|0;p=f[a>>2]|0;if(p|0?(c=p+12|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)V$(h);f[a>>2]=0;a=h+16|0;p=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[h+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[p>>2]|0))}p=f[h+44>>2]|0;if((p|0)!=(h+48|0))wL(p);i=r;u=g;return i|0}function HL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e;if((c|0)<0&(d|0)>65535){h=1;u=e;return h|0}if((d|0)<(c|0)|((c|0)>65535|(d|0)<0)){f[b>>2]=0;f[b+4>>2]=0;h=0;u=e;return h|0}g0(g,a,1,0);i=f[g+8>>2]|0;a:do if((i|0)>0?(k=f[g+12>>2]|0,l=f[g+16>>2]|0,(k|0)>0):0){m=f[f[g+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=j[o+(p<<1)>>1]|0;if((q|0)<(c|0)|(q|0)>(d|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(i|0))n=o;else{r=1;break a}}f[b+4>>2]=n;f[b>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=g+36|0;p=f[a>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)V$(g);f[a>>2]=0;a=g+16|0;p=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[g+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[p>>2]|0))}p=f[g+44>>2]|0;if((p|0)!=(g+48|0))wL(p);h=r;u=e;return h|0}function IL(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+64|0;h=g;if((c|0)<-32768&(e|0)>32767){i=1;u=g;return i|0}if((e|0)<(c|0)|((c|0)>32767|(e|0)<-32768)){f[b>>2]=0;f[b+4>>2]=0;i=0;u=g;return i|0}g0(h,a,1,0);j=f[h+8>>2]|0;a:do if((j|0)>0?(k=f[h+12>>2]|0,l=f[h+16>>2]|0,(k|0)>0):0){m=f[f[h+44>>2]>>2]|0;n=0;b:while(1){o=l+(Y(m,n)|0)|0;p=0;while(1){q=d[o+(p<<1)>>1]|0;if((q|0)<(c|0)|(q|0)>(e|0))break b;q=p+1|0;if((q|0)<(k|0))p=q;else break}o=n+1|0;if((o|0)<(j|0))n=o;else{r=1;break a}}f[b+4>>2]=n;f[b>>2]=(p|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;r=0}else r=1;while(0);a=h+36|0;p=f[a>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)V$(h);f[a>>2]=0;a=h+16|0;p=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[p>>2]|0)>0){a=f[h+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[p>>2]|0))}p=f[h+44>>2]|0;if((p|0)!=(h+48|0))wL(p);i=r;u=g;return i|0}function JL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e;if((d|0)<(c|0)){f[b>>2]=0;f[b+4>>2]=0;h=0;u=e;return h|0}g0(g,a,1,0);i=f[g+8>>2]|0;a:do if((i|0)>0?(j=f[g+12>>2]|0,k=f[g+16>>2]|0,(j|0)>0):0){l=f[f[g+44>>2]>>2]|0;m=0;b:while(1){n=k+(Y(l,m)|0)|0;o=0;while(1){p=f[n+(o<<2)>>2]|0;if((p|0)<(c|0)|(p|0)>(d|0))break b;p=o+1|0;if((p|0)<(j|0))o=p;else break}n=m+1|0;if((n|0)<(i|0))m=n;else{q=1;break a}}f[b+4>>2]=m;f[b>>2]=(o|0)/(((f[a>>2]|0)>>>3&511)+1|0)|0;q=0}else q=1;while(0);a=g+36|0;o=f[a>>2]|0;if(o|0?(b=o+12|0,o=f[b>>2]|0,f[b>>2]=o+-1,(o|0)==1):0)V$(g);f[a>>2]=0;a=g+16|0;o=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[o>>2]|0)>0){a=f[g+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[o>>2]|0))}o=f[g+44>>2]|0;if((o|0)!=(g+48|0))wL(o);h=q;u=e;return h|0}function KL(a){a=+a;var b=0,c=0,d=0,e=0;b=(n[s>>2]=a,f[s>>2]|0);c=(b>>>23&255)+-127|0;d=(c|0)%3|0;e=d+-3-(d>>31&-3)|0;a=(f[s>>2]=(e<<23)+1065353216|b&8388607,+n[s>>2]);return +(b|0?(f[s>>2]=(((c-e|0)/3|0)<<23)+(b&-2147483648)+(n[s>>2]=(a*(a*(a*(a*45.2548339756803+192.2798368355061)+119.16548242855816)+13.432501390862399)+.16361612265857542)/(a*(a*(a*(a*14.808840932191346+151.97140510444356)+168.52544141015682)+33.99059413502156)+1.0),f[s>>2]|0),+n[s>>2]):0.0)}function LL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+240|0;g=e+176|0;h=e+120|0;i=e+64|0;j=e+48|0;k=e+32|0;l=e;m=dS(a,-1)|0;n=qS(a,-1)|0;o=rS(a,-1)|0;cS(g,a,-1);cS(h,c,-1);if(!((f[g>>2]|0)==(f[h>>2]|0)?(f[g+4>>2]|0)==(f[h+4>>2]|0):0)){p=$Xc(96)|0;f[g>>2]=p;q=g+8|0;f[q>>2]=-2147483552;r=g+4|0;f[r>>2]=89;s=p;t=218027;v=s+89|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+89|0;b[w>>0]=0;vM(-215,g,218117,218127,151)}if((m|0)!=(dS(c,-1)|0)){p=$Xc(96)|0;f[g>>2]=p;q=g+8|0;f[q>>2]=-2147483552;r=g+4|0;f[r>>2]=89;s=p;t=218027;v=s+89|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+89|0;b[w>>0]=0;vM(-215,g,218117,218127,151)}if((n+-5|0)>>>0>=2){p=$Xc(96)|0;f[g>>2]=p;q=g+8|0;f[q>>2]=-2147483552;r=g+4|0;f[r>>2]=89;s=p;t=218027;v=s+89|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+89|0;b[w>>0]=0;vM(-215,g,218117,218127,151)}do if((eS(a)|0)==65536){w=f[a+4>>2]|0;f[g>>2]=f[w>>2];p=g+4|0;t=w+4|0;f[p>>2]=f[t>>2];s=g+8|0;f[s>>2]=f[w+8>>2];f[g+12>>2]=f[w+12>>2];f[g+16>>2]=f[w+16>>2];f[g+20>>2]=f[w+20>>2];f[g+24>>2]=f[w+24>>2];f[g+28>>2]=f[w+28>>2];f[g+32>>2]=f[w+32>>2];v=f[w+36>>2]|0;f[g+36>>2]=v;f[g+40>>2]=s;s=g+48|0;r=g+44|0;f[r>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(v|0){s=v+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[t>>2]|0)<3){t=f[w+44>>2]|0;s=f[r>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];break}else{f[p>>2]=0;U$(g,w);break}}else bS(g,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];w=h+4|0;p=a+4|0;f[w>>2]=f[p>>2];t=h+8|0;f[t>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=t;t=h+48|0;r=h+44|0;f[r>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[p>>2]|0)<3){p=f[a+44>>2]|0;t=f[r>>2]|0;f[t>>2]=f[p>>2];f[t+4>>2]=f[p+4>>2];break}else{f[w>>2]=0;U$(h,a);break}}else bS(h,c,-1);while(0);c=g+4|0;a=g+40|0;xS(d,f[c>>2]|0,f[a>>2]|0,f[g>>2]&4095,-1,0,0);do if((eS(d)|0)==65536){w=f[d+4>>2]|0;f[i>>2]=f[w>>2];p=i+4|0;t=w+4|0;f[p>>2]=f[t>>2];r=i+8|0;f[r>>2]=f[w+8>>2];f[i+12>>2]=f[w+12>>2];f[i+16>>2]=f[w+16>>2];f[i+20>>2]=f[w+20>>2];f[i+24>>2]=f[w+24>>2];f[i+28>>2]=f[w+28>>2];f[i+32>>2]=f[w+32>>2];s=f[w+36>>2]|0;f[i+36>>2]=s;f[i+40>>2]=r;r=i+48|0;v=i+44|0;f[v>>2]=r;f[r>>2]=0;f[i+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[t>>2]|0)<3){t=f[w+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2];break}else{f[p>>2]=0;U$(i,w);break}}else bS(i,d,-1);while(0);f[j>>2]=g;f[j+4>>2]=h;f[j+8>>2]=i;f[j+12>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;BL(l,j,k,-1);j=Y(f[l+20>>2]|0,o)|0;o=l+16|0;d=k+4|0;w=k+8|0;a:do if((n|0)==5){p=0;while(1){if(p>>>0>=(f[o>>2]|0)>>>0)break a;XP(f[k>>2]|0,f[d>>2]|0,f[w>>2]|0,j);CL(l)|0;p=p+1|0}}else{p=0;while(1){if(p>>>0>=(f[o>>2]|0)>>>0)break a;YP(f[k>>2]|0,f[d>>2]|0,f[w>>2]|0,j);CL(l)|0;p=p+1|0}}while(0);l=i+36|0;j=f[l>>2]|0;if(j|0?(w=j+12|0,j=f[w>>2]|0,f[w>>2]=j+-1,(j|0)==1):0)V$(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[i+40>>2]|0;w=0;do{f[l+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))wL(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(w=i+12|0,i=f[w>>2]|0,f[w>>2]=i+-1,(i|0)==1):0)V$(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[h+40>>2]|0;w=0;do{f[j+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))wL(i);i=g+36|0;h=f[i>>2]|0;if(h|0?(w=h+12|0,h=f[w>>2]|0,f[w>>2]=h+-1,(h|0)==1):0)V$(g);f[i>>2]=0;i=g+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[c>>2]|0)>0){i=f[a>>2]|0;a=0;do{f[i+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)==(g+48|0)){u=e;return}wL(c);u=e;return}function ML(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+304|0;i=h+240|0;j=h+184|0;k=h+128|0;l=h+72|0;m=h+48|0;n=h+32|0;o=h;do if((eS(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;U$(i,p);break}}else bS(i,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[j+36>>2]=s;v=j+40|0;f[v>>2]=r;r=j+48|0;t=j+44|0;f[t>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=v;break}else{f[p>>2]=0;U$(j,a);w=v;break}}else{bS(j,c,-1);w=j+40|0}while(0);c=f[i>>2]|0;v=c&4095;a=c&7;p=c>>>3&511;c=p+1|0;q=i+40|0;r=f[q>>2]|0;t=f[r+-4>>2]|0;s=f[w>>2]|0;if((t|0)!=(f[s+-4>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;x=$Xc(80)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483568;z=k+4|0;f[z>>2]=76;A=x;B=218198;C=A+76|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+76|0;b[D>>0]=0;vM(-215,k,218275,218127,277)}a:do if((t|0)==2){if((f[r>>2]|0)!=(f[s>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;x=$Xc(80)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483568;z=k+4|0;f[z>>2]=76;A=x;B=218198;C=A+76|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+76|0;b[D>>0]=0;vM(-215,k,218275,218127,277)}if((f[r+4>>2]|0)!=(f[s+4>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;x=$Xc(80)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483568;z=k+4|0;f[z>>2]=76;A=x;B=218198;C=A+76|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+76|0;b[D>>0]=0;vM(-215,k,218275,218127,277)}}else if((t|0)>0){E=0;while(1){if((f[r+(E<<2)>>2]|0)!=(f[s+(E<<2)>>2]|0))break;E=E+1|0;if((E|0)>=(t|0))break a}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;x=$Xc(80)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483568;z=k+4|0;f[z>>2]=76;A=x;B=218198;C=A+76|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+76|0;b[D>>0]=0;vM(-215,k,218275,218127,277)}while(0);if((v|0)!=(f[j>>2]&4095|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;x=$Xc(80)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483568;z=k+4|0;f[z>>2]=76;A=x;B=218198;C=A+76|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+76|0;b[D>>0]=0;vM(-215,k,218275,218127,277)}t=(a|0)==5;if((a+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;x=$Xc(80)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483568;z=k+4|0;f[z>>2]=76;A=x;B=218198;C=A+76|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+76|0;b[D>>0]=0;vM(-215,k,218275,218127,277)}D=i+4|0;xS(d,f[D>>2]|0,r,v,-1,0,0);xS(e,f[D>>2]|0,f[q>>2]|0,v,-1,0,0);do if((eS(d)|0)==65536){v=f[d+4>>2]|0;f[k>>2]=f[v>>2];r=k+4|0;x=v+4|0;f[r>>2]=f[x>>2];B=k+8|0;f[B>>2]=f[v+8>>2];f[k+12>>2]=f[v+12>>2];f[k+16>>2]=f[v+16>>2];f[k+20>>2]=f[v+20>>2];f[k+24>>2]=f[v+24>>2];f[k+28>>2]=f[v+28>>2];f[k+32>>2]=f[v+32>>2];A=f[v+36>>2]|0;f[k+36>>2]=A;f[k+40>>2]=B;B=k+48|0;C=k+44|0;f[C>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(A|0){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;B=f[C>>2]|0;f[B>>2]=f[x>>2];f[B+4>>2]=f[x+4>>2];break}else{f[r>>2]=0;U$(k,v);break}}else bS(k,d,-1);while(0);do if((eS(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];v=l+4|0;r=d+4|0;f[v>>2]=f[r>>2];x=l+8|0;f[x>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];B=f[d+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=x;x=l+48|0;C=l+44|0;f[C>>2]=x;f[x>>2]=0;f[l+52>>2]=0;if(B|0){x=B+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;x=f[C>>2]|0;f[x>>2]=f[r>>2];f[x+4>>2]=f[r+4>>2];break}else{f[v>>2]=0;U$(l,d);break}}else bS(l,e,-1);while(0);f[m>>2]=i;f[m+4>>2]=j;f[m+8>>2]=k;f[m+12>>2]=l;f[m+16>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;BL(o,m,n,-1);m=Y(f[o+20>>2]|0,c)|0;e=p|1024;p=e-((e>>>0)%(c>>>0)|0)|0;c=(p|0)<(m|0)?p:m;p=675553809>>>(f[i>>2]<<2&28)&15;e=o+16|0;d=(m|0)>0;v=n+4|0;r=n+8|0;x=n+12|0;C=0;while(1){if(C>>>0>=(f[e>>2]|0)>>>0)break;if(d)if(t){B=0;A=f[n>>2]|0;z=f[v>>2]|0;y=f[r>>2]|0;a=f[x>>2]|0;do{s=m-B|0;E=(c|0)<(s|0)?c:s;XP(A,z,y,E);UP(z,A,a,E,g);s=Y(E,p)|0;A=(f[n>>2]|0)+s|0;f[n>>2]=A;z=(f[v>>2]|0)+s|0;f[v>>2]=z;y=(f[r>>2]|0)+s|0;f[r>>2]=y;a=(f[x>>2]|0)+s|0;f[x>>2]=a;B=B+c|0}while((m|0)>(B|0))}else{B=0;a=f[n>>2]|0;y=f[v>>2]|0;z=f[r>>2]|0;A=f[x>>2]|0;do{s=m-B|0;E=(c|0)<(s|0)?c:s;YP(a,y,z,E);VP(y,a,A,E,g);s=Y(E,p)|0;a=(f[n>>2]|0)+s|0;f[n>>2]=a;y=(f[v>>2]|0)+s|0;f[v>>2]=y;z=(f[r>>2]|0)+s|0;f[r>>2]=z;A=(f[x>>2]|0)+s|0;f[x>>2]=A;B=B+c|0}while((m|0)>(B|0))}CL(o)|0;C=C+1|0}C=l+36|0;o=f[C>>2]|0;if(o|0?(m=o+12|0,o=f[m>>2]|0,f[m>>2]=o+-1,(o|0)==1):0)V$(l);f[C>>2]=0;C=l+16|0;o=l+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[o>>2]|0)>0){C=f[l+40>>2]|0;m=0;do{f[C+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))wL(o);o=k+36|0;l=f[o>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)V$(k);f[o>>2]=0;o=k+16|0;l=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){o=f[k+40>>2]|0;m=0;do{f[o+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))wL(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)V$(j);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[w>>2]|0;w=0;do{f[l+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(w=j+12|0,j=f[w>>2]|0,f[w>>2]=j+-1,(j|0)==1):0)V$(i);f[k>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[D>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[D>>2]|0))}D=f[i+44>>2]|0;if((D|0)==(i+48|0)){u=h;return}wL(D);u=h;return}function NL(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0;h=u;u=u+1360|0;i=h+1304|0;j=h+1248|0;k=h+1192|0;l=h+1136|0;m=h+1112|0;o=h+1096|0;q=h+1064|0;r=h;s=dS(c,-1)|0;t=s&7;v=s>>>3&511;w=v+1|0;x=(t|0)==5;y=(t|0)==6;if((t+-5|0)>>>0>=2){z=$Xc(80)|0;f[i>>2]=z;A=i+8|0;f[A>>2]=-2147483568;B=i+4|0;f[B>>2]=77;C=z;D=218287;E=C+77|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+77|0;b[F>>0]=0;vM(-215,i,218365,218127,567)}if(!(sS(a)|0)?(dS(a,-1)|0)!=(s|0):0){z=$Xc(80)|0;f[i>>2]=z;A=i+8|0;f[A>>2]=-2147483568;B=i+4|0;f[B>>2]=77;C=z;D=218287;E=C+77|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+77|0;b[F>>0]=0;vM(-215,i,218365,218127,567)}do if((eS(a)|0)==65536){F=f[a+4>>2]|0;f[i>>2]=f[F>>2];z=i+4|0;B=F+4|0;f[z>>2]=f[B>>2];A=i+8|0;f[A>>2]=f[F+8>>2];f[i+12>>2]=f[F+12>>2];f[i+16>>2]=f[F+16>>2];f[i+20>>2]=f[F+20>>2];f[i+24>>2]=f[F+24>>2];f[i+28>>2]=f[F+28>>2];f[i+32>>2]=f[F+32>>2];t=f[F+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=A;A=i+48|0;G=i+44|0;f[G>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(t|0){A=t+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[B>>2]|0)<3){B=f[F+44>>2]|0;A=f[G>>2]|0;f[A>>2]=f[B>>2];f[A+4>>2]=f[B+4>>2];break}else{f[z>>2]=0;U$(i,F);break}}else bS(i,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];F=j+4|0;z=a+4|0;f[F>>2]=f[z>>2];B=j+8|0;f[B>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[j+36>>2]=A;f[j+40>>2]=B;B=j+48|0;G=j+44|0;f[G>>2]=B;f[B>>2]=0;f[j+52>>2]=0;if(A|0){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;B=f[G>>2]|0;f[B>>2]=f[z>>2];f[B+4>>2]=f[z+4>>2];break}else{f[F>>2]=0;U$(j,a);break}}else bS(j,c,-1);while(0);c=i+16|0;a:do if(f[c>>2]|0){a=f[i+4>>2]|0;if((a|0)<3)H=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{F=f[i+40>>2]|0;z=0;B=1;while(1){G=Y(f[F+(z<<2)>>2]|0,B)|0;z=z+1|0;if((z|0)==(a|0)){H=G;break}else B=G}}if(!((a|0)==0|(H|0)==0)){B=f[j+40>>2]|0;z=f[B+-4>>2]|0;F=f[i+40>>2]|0;if((z|0)!=(f[F+-4>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(48)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483600;K=k+4|0;f[K>>2]=37;C=I;D=218377;E=C+37|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));L=I+37|0;b[L>>0]=0;vM(-215,k,218365,218127,573)}if((z|0)==2){if((f[B>>2]|0)!=(f[F>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(48)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483600;K=k+4|0;f[K>>2]=37;C=I;D=218377;E=C+37|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));L=I+37|0;b[L>>0]=0;vM(-215,k,218365,218127,573)}if((f[B+4>>2]|0)==(f[F+4>>2]|0))break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(48)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483600;K=k+4|0;f[K>>2]=37;C=I;D=218377;E=C+37|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));L=I+37|0;b[L>>0]=0;vM(-215,k,218365,218127,573)}else{if((z|0)>0)M=0;else break;while(1){if((f[B+(M<<2)>>2]|0)!=(f[F+(M<<2)>>2]|0))break;M=M+1|0;if((M|0)>=(z|0))break a}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(48)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483600;K=k+4|0;f[K>>2]=37;C=I;D=218377;E=C+37|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));L=I+37|0;b[L>>0]=0;vM(-215,k,218365,218127,573)}}}while(0);L=j+4|0;I=j+40|0;xS(d,f[L>>2]|0,f[I>>2]|0,s,-1,0,0);xS(e,f[L>>2]|0,f[I>>2]|0,s,-1,0,0);do if((eS(d)|0)==65536){s=f[d+4>>2]|0;f[k>>2]=f[s>>2];D=k+4|0;C=s+4|0;f[D>>2]=f[C>>2];E=k+8|0;f[E>>2]=f[s+8>>2];f[k+12>>2]=f[s+12>>2];f[k+16>>2]=f[s+16>>2];f[k+20>>2]=f[s+20>>2];f[k+24>>2]=f[s+24>>2];f[k+28>>2]=f[s+28>>2];f[k+32>>2]=f[s+32>>2];K=f[s+36>>2]|0;f[k+36>>2]=K;f[k+40>>2]=E;E=k+48|0;J=k+44|0;f[J>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(K|0){E=K+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[C>>2]|0)<3){C=f[s+44>>2]|0;E=f[J>>2]|0;f[E>>2]=f[C>>2];f[E+4>>2]=f[C+4>>2];break}else{f[D>>2]=0;U$(k,s);break}}else bS(k,d,-1);while(0);do if((eS(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];s=l+4|0;D=d+4|0;f[s>>2]=f[D>>2];C=l+8|0;f[C>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];E=f[d+36>>2]|0;f[l+36>>2]=E;f[l+40>>2]=C;C=l+48|0;J=l+44|0;f[J>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[D>>2]|0)<3){D=f[d+44>>2]|0;C=f[J>>2]|0;f[C>>2]=f[D>>2];f[C+4>>2]=f[D+4>>2];break}else{f[s>>2]=0;U$(l,d);break}}else bS(l,e,-1);while(0);f[m>>2]=i;f[m+4>>2]=j;f[m+8>>2]=k;f[m+12>>2]=l;f[m+16>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;BL(q,m,o,-1);m=r+8|0;f[r>>2]=m;e=r+4|0;f[e>>2]=264;d=Y(f[q+20>>2]|0,w)|0;s=v|1024;v=s-((s>>>0)%(w>>>0)|0)|0;w=(v|0)<(d|0)?v:d;v=675553809>>>(f[j>>2]<<2&28)&15;if(y){y=w<<1;f[e>>2]=y;if(y>>>0>264){s=bYc(y>>>0>1073741823?-1:y<<2)|0;f[r>>2]=s;N=s}else N=m;O=N;P=N+(w<<2)|0}else{O=0;P=0}N=q+16|0;s=(d|0)>0;y=o+4|0;D=o+8|0;C=o+12|0;Q=g?.17777777777777778:10.185916357881302;g=0;while(1){if(g>>>0>=(f[N>>2]|0)>>>0)break;if(s){J=0;do{E=d-J|0;K=(w|0)<(E|0)?w:E;do if(x){E=f[o>>2]|0;M=f[y>>2]|0;H=f[D>>2]|0;z=f[C>>2]|0;F=(K|0)>0;if(F){B=0;do{R=Q*+n[M+(B<<2)>>2];a=zLc(R)|0;S=R-+(a|0);R=S*(S*(S*-1.5767166072981726e-04)+.09817477042468103);T=S*(S*-.004817389940423465)+1.0;S=+p[6192+((a&63)<<3)>>3];U=+p[6192+((16-a&63)<<3)>>3];n[z+(B<<2)>>2]=S*T+U*R;n[H+(B<<2)>>2]=U*T-S*R;B=B+1|0}while((B|0)!=(K|0));if((E|0)!=0&F){B=0;do{R=+n[E+(B<<2)>>2];M=H+(B<<2)|0;n[M>>2]=R*+n[M>>2];M=z+(B<<2)|0;n[M>>2]=R*+n[M>>2];B=B+1|0}while((B|0)<(K|0));V=E;W=104}else{X=E;W=105}}else{X=E;W=105}}else{B=f[o>>2]|0;z=f[y>>2]|0;H=f[D>>2]|0;F=f[C>>2]|0;M=(K|0)>0;if(M){a=0;do{n[O+(a<<2)>>2]=+p[z+(a<<3)>>3];a=a+1|0}while((a|0)<(K|0));if(M){a=0;do{z=O+(a<<2)|0;R=Q*+n[z>>2];E=zLc(R)|0;S=R-+(E|0);R=S*(S*(S*-1.5767166072981726e-04)+.09817477042468103);T=S*(S*-.004817389940423465)+1.0;S=+p[6192+((E&63)<<3)>>3];U=+p[6192+((16-E&63)<<3)>>3];n[P+(a<<2)>>2]=S*T+U*R;n[z>>2]=U*T-S*R;a=a+1|0}while((a|0)!=(K|0))}}if(!B){a=K<<2;o1c(H|0,O|0,a|0)|0;o1c(F|0,P|0,a|0)|0;X=f[o>>2]|0;W=105;break}if(M){a=0;do{R=+p[B+(a<<3)>>3];p[H+(a<<3)>>3]=R*+n[O+(a<<2)>>2];p[F+(a<<3)>>3]=R*+n[P+(a<<2)>>2];a=a+1|0}while((a|0)<(K|0));V=B;W=104}else{X=B;W=105}}while(0);if((W|0)==104){W=0;Z=V;_=Y(K,v)|0;W=106}else if((W|0)==105){W=0;a=Y(K,v)|0;if(!X)$=a;else{Z=X;_=a;W=106}}if((W|0)==106){W=0;f[o>>2]=Z+_;$=_}f[y>>2]=(f[y>>2]|0)+$;f[D>>2]=(f[D>>2]|0)+$;f[C>>2]=(f[C>>2]|0)+$;J=J+w|0}while((d|0)>(J|0))}CL(q)|0;g=g+1|0}g=f[r>>2]|0;if((g|0)!=(m|0)){if(g|0)dYc(g);f[r>>2]=m;f[e>>2]=264}e=l+36|0;m=f[e>>2]|0;if(m|0?(r=m+12|0,m=f[r>>2]|0,f[r>>2]=m+-1,(m|0)==1):0)V$(l);f[e>>2]=0;e=l+16|0;m=l+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[l+40>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))wL(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(r=l+12|0,l=f[r>>2]|0,f[r>>2]=l+-1,(l|0)==1):0)V$(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[k+40>>2]|0;r=0;do{f[m+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))wL(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(r=k+12|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)V$(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[L>>2]|0)>0){l=f[I>>2]|0;I=0;do{f[l+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[L>>2]|0))}L=f[j+44>>2]|0;if((L|0)!=(j+48|0))wL(L);L=i+36|0;j=f[L>>2]|0;do if(j|0){I=j+12|0;l=f[I>>2]|0;f[I>>2]=l+-1;if((l|0)!=1)break;V$(i)}while(0);f[L>>2]=0;L=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[L>>2]|0)>0){c=f[i+40>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[L>>2]|0))}L=f[i+44>>2]|0;if((L|0)==(i+48|0)){u=h;return}wL(L);u=h;return}function OL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+176|0;e=d+112|0;g=d+56|0;h=d+40|0;i=d;j=d+8|0;k=dS(a,-1)|0;l=qS(a,-1)|0;m=rS(a,-1)|0;n=(l|0)==5;if((l+-5|0)>>>0>=2){l=$Xc(48)|0;f[e>>2]=l;f[e+8>>2]=-2147483600;f[e+4>>2]=34;o=l;p=236570;q=o+34|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+34>>0]=0;vM(-215,e,218415,218127,668)}do if((eS(a)|0)==65536){l=f[a+4>>2]|0;f[e>>2]=f[l>>2];p=e+4|0;o=l+4|0;f[p>>2]=f[o>>2];q=e+8|0;f[q>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[e+16>>2]=f[l+16>>2];f[e+20>>2]=f[l+20>>2];f[e+24>>2]=f[l+24>>2];f[e+28>>2]=f[l+28>>2];f[e+32>>2]=f[l+32>>2];r=f[l+36>>2]|0;f[e+36>>2]=r;s=e+40|0;f[s>>2]=q;q=e+48|0;t=e+44|0;f[t>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[o>>2]|0)<3){o=f[l+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];v=s;w=p;break}else{f[p>>2]=0;U$(e,l);v=s;w=p;break}}else{bS(e,a,-1);v=e+40|0;w=e+4|0}while(0);xS(c,f[w>>2]|0,f[v>>2]|0,k,-1,0,0);do if((eS(c)|0)==65536){k=f[c+4>>2]|0;f[g>>2]=f[k>>2];a=g+4|0;p=k+4|0;f[a>>2]=f[p>>2];s=g+8|0;f[s>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];l=f[k+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=s;s=g+48|0;o=g+44|0;f[o>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(l|0){s=l+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[p>>2]|0)<3){p=f[k+44>>2]|0;s=f[o>>2]|0;f[s>>2]=f[p>>2];f[s+4>>2]=f[p+4>>2];break}else{f[a>>2]=0;U$(g,k);break}}else bS(g,c,-1);while(0);f[h>>2]=e;f[h+4>>2]=g;f[h+8>>2]=0;c=i;f[c>>2]=0;f[c+4>>2]=0;BL(j,h,i,-1);h=Y(f[j+20>>2]|0,m)|0;m=j+16|0;c=i+4|0;a:do if(n){k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;bQ(f[i>>2]|0,f[c>>2]|0,h);CL(j)|0;k=k+1|0}}else{k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;cQ(f[i>>2]|0,f[c>>2]|0,h);CL(j)|0;k=k+1|0}}while(0);j=g+36|0;h=f[j>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)V$(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))wL(h);h=e+36|0;g=f[h>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)V$(e);f[h>>2]=0;h=e+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[w>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[e+44>>2]|0;if((w|0)==(e+48|0)){u=d;return}wL(w);u=d;return}function PL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+176|0;e=d+112|0;g=d+56|0;h=d+40|0;i=d;j=d+8|0;k=dS(a,-1)|0;l=qS(a,-1)|0;m=rS(a,-1)|0;n=(l|0)==5;if((l+-5|0)>>>0>=2){l=$Xc(48)|0;f[e>>2]=l;f[e+8>>2]=-2147483600;f[e+4>>2]=34;o=l;p=236570;q=o+34|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+34>>0]=0;vM(-215,e,218419,218127,701)}do if((eS(a)|0)==65536){l=f[a+4>>2]|0;f[e>>2]=f[l>>2];p=e+4|0;o=l+4|0;f[p>>2]=f[o>>2];q=e+8|0;f[q>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[e+16>>2]=f[l+16>>2];f[e+20>>2]=f[l+20>>2];f[e+24>>2]=f[l+24>>2];f[e+28>>2]=f[l+28>>2];f[e+32>>2]=f[l+32>>2];r=f[l+36>>2]|0;f[e+36>>2]=r;s=e+40|0;f[s>>2]=q;q=e+48|0;t=e+44|0;f[t>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[o>>2]|0)<3){o=f[l+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];v=s;w=p;break}else{f[p>>2]=0;U$(e,l);v=s;w=p;break}}else{bS(e,a,-1);v=e+40|0;w=e+4|0}while(0);xS(c,f[w>>2]|0,f[v>>2]|0,k,-1,0,0);do if((eS(c)|0)==65536){k=f[c+4>>2]|0;f[g>>2]=f[k>>2];a=g+4|0;p=k+4|0;f[a>>2]=f[p>>2];s=g+8|0;f[s>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];l=f[k+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=s;s=g+48|0;o=g+44|0;f[o>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(l|0){s=l+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[p>>2]|0)<3){p=f[k+44>>2]|0;s=f[o>>2]|0;f[s>>2]=f[p>>2];f[s+4>>2]=f[p+4>>2];break}else{f[a>>2]=0;U$(g,k);break}}else bS(g,c,-1);while(0);f[h>>2]=e;f[h+4>>2]=g;f[h+8>>2]=0;c=i;f[c>>2]=0;f[c+4>>2]=0;BL(j,h,i,-1);h=Y(f[j+20>>2]|0,m)|0;m=j+16|0;c=i+4|0;a:do if(n){k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;dQ(f[i>>2]|0,f[c>>2]|0,h);CL(j)|0;k=k+1|0}}else{k=0;while(1){if(k>>>0>=(f[m>>2]|0)>>>0)break a;eQ(f[i>>2]|0,f[c>>2]|0,h);CL(j)|0;k=k+1|0}}while(0);j=g+36|0;h=f[j>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)V$(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))wL(h);h=e+36|0;g=f[h>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)V$(e);f[h>>2]=0;h=e+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[w>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[e+44>>2]|0;if((w|0)==(e+48|0)){u=d;return}wL(w);u=d;return}function QL(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0;e=u;u=u+1216|0;g=e+1152|0;h=e+8|0;i=e+1136|0;j=e;k=e+1104|0;l=e+64|0;m=dS(a,-1)|0;o=m&7;q=m>>>3&511;r=q+1|0;s=zLc(c)|0;t=+L(+(+(s|0)-c))<2.220446049250313e-16;a:do if(!t){if((o+-5|0)>>>0>=2){v=$Xc(48)|0;f[g>>2]=v;f[g+8>>2]=-2147483600;f[g+4>>2]=34;w=v;x=236570;y=w+34|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[v+34>>0]=0;vM(-215,g,387326,218127,1241)}}else switch(s|0){case 0:{_S(d,a,m);p[h>>3]=1.0;p[h+8>>3]=1.0;p[h+16>>3]=1.0;p[h+24>>3]=1.0;f[g>>2]=-1056833530;f[g+4>>2]=h;f[g+8>>2]=1;f[g+12>>2]=4;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;bT(d,g,i);u=e;return}case 1:{uS(a,d);u=e;return}case 2:{I1(a,a,d,1.0,-1);u=e;return}default:break a}while(0);do if((eS(a)|0)==65536){z=f[a+4>>2]|0;f[g>>2]=f[z>>2];A=g+4|0;B=z+4|0;f[A>>2]=f[B>>2];E=g+8|0;f[E>>2]=f[z+8>>2];f[g+12>>2]=f[z+12>>2];f[g+16>>2]=f[z+16>>2];f[g+20>>2]=f[z+20>>2];f[g+24>>2]=f[z+24>>2];f[g+28>>2]=f[z+28>>2];f[g+32>>2]=f[z+32>>2];F=f[z+36>>2]|0;f[g+36>>2]=F;G=g+40|0;f[G>>2]=E;E=g+48|0;H=g+44|0;f[H>>2]=E;f[E>>2]=0;f[g+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[B>>2];f[E+4>>2]=f[B+4>>2];I=G;J=A;break}else{f[A>>2]=0;U$(g,z);I=G;J=A;break}}else{bS(g,a,-1);I=g+40|0;J=g+4|0}while(0);xS(d,f[J>>2]|0,f[I>>2]|0,m,-1,0,0);do if((eS(d)|0)==65536){m=f[d+4>>2]|0;f[h>>2]=f[m>>2];a=h+4|0;A=m+4|0;f[a>>2]=f[A>>2];G=h+8|0;f[G>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];z=f[m+36>>2]|0;f[h+36>>2]=z;f[h+40>>2]=G;G=h+48|0;B=h+44|0;f[B>>2]=G;f[G>>2]=0;f[h+52>>2]=0;if(z|0){G=z+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[A>>2]|0)<3){A=f[m+44>>2]|0;G=f[B>>2]|0;f[G>>2]=f[A>>2];f[G+4>>2]=f[A+4>>2];break}else{f[a>>2]=0;U$(h,m);break}}else bS(h,d,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;d=j;f[d>>2]=0;f[d+4>>2]=0;BL(k,i,j,-1);i=Y(f[k+20>>2]|0,r)|0;b:do if(!t){if(+L(+(+L(+c)+-.5))<2.220446049250313e-16){d=(o|0)==5;m=c<0.0?(d?421:420):d?423:422;d=k+16|0;a=j+4|0;A=0;while(1){if(A>>>0>=(f[d>>2]|0)>>>0)break b;Ti[m&511](f[j>>2]|0,f[a>>2]|0,i);CL(k)|0;A=A+1|0}}A=q|1024;a=A-((A>>>0)%(r>>>0)|0)|0;A=(a|0)<(i|0)?a:i;a=675553809>>>(f[g>>2]<<2&28)&15;m=l+8|0;f[l>>2]=m;d=l+4|0;f[d>>2]=1032;if((f[g+16>>2]|0)==(f[h+16>>2]|0)){v=Y(a,A)|0;f[d>>2]=v;if(v>>>0>1032){G=bYc(v)|0;f[l>>2]=G;K=G}else K=m;M=K;N=K}else{M=0;N=0}G=k+16|0;v=(i|0)>0;B=(o|0)==5;z=(N|0)!=0;E=j+4|0;H=c<0.0;F=(M|0)!=0;O=0;while(1){if(O>>>0>=(f[G>>2]|0)>>>0)break;if(v){P=0;Q=f[j>>2]|0;do{R=i-P|0;S=(A|0)<(R|0)?A:R;do if(B){R=z?N:Q;T=f[E>>2]|0;if((R|0)!=(Q|0))o1c(R|0,Q|0,Y(S,a)|0)|0;dQ(R,T,S);R=(S|0)>0;if(R)U=0;else{bQ(T,T,S);break}do{V=T+(U<<2)|0;n[V>>2]=+n[V>>2]*c;U=U+1|0}while((U|0)<(S|0));bQ(T,T,S);if(R)if(H){V=0;do{W=+n[Q+(V<<2)>>2];if(W<=0.0)n[T+(V<<2)>>2]=W==0.0?D:C;V=V+1|0}while((V|0)<(S|0))}else{V=0;do{if(+n[Q+(V<<2)>>2]<0.0)n[T+(V<<2)>>2]=C;V=V+1|0}while((V|0)<(S|0))}}else{V=F?M:Q;T=f[E>>2]|0;if((V|0)!=(Q|0))o1c(V|0,Q|0,Y(S,a)|0)|0;eQ(V,T,S);V=(S|0)>0;if(V)X=0;else{cQ(T,T,S);break}do{R=T+(X<<3)|0;p[R>>3]=+p[R>>3]*c;X=X+1|0}while((X|0)<(S|0));cQ(T,T,S);if(V)if(H){R=0;do{W=+p[Q+(R<<3)>>3];if(W<=0.0)p[T+(R<<3)>>3]=W==0.0?D:C;R=R+1|0}while((R|0)<(S|0))}else{R=0;do{if(+p[Q+(R<<3)>>3]<0.0)p[T+(R<<3)>>3]=C;R=R+1|0}while((R|0)<(S|0))}}while(0);R=Y(S,a)|0;Q=(f[j>>2]|0)+R|0;f[j>>2]=Q;f[E>>2]=(f[E>>2]|0)+R;P=P+A|0}while((i|0)>(P|0))}CL(k)|0;O=O+1|0}O=f[l>>2]|0;if((O|0)!=(m|0)){if(O|0)dYc(O);f[l>>2]=m;f[d>>2]=1032}}else{O=f[35740+(o<<2)>>2]|0;if((o|0)==7){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+11>>0]=9;w=l;x=264557;y=w+9|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[l+9>>0]=0;vM(-215,l,387326,218127,1257)}d=k+16|0;m=j+4|0;A=0;while(1){if(A>>>0>=(f[d>>2]|0)>>>0)break b;ei[O&511](f[j>>2]|0,f[m>>2]|0,i,s);CL(k)|0;A=A+1|0}}while(0);k=h+36|0;s=f[k>>2]|0;if(s|0?(i=s+12|0,s=f[i>>2]|0,f[i>>2]=s+-1,(s|0)==1):0)V$(h);f[k>>2]=0;k=h+16|0;s=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[h+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[s>>2]|0))}s=f[h+44>>2]|0;if((s|0)!=(h+48|0))wL(s);s=g+36|0;h=f[s>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)V$(g);f[s>>2]=0;s=g+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[J>>2]|0)>0){s=f[I>>2]|0;I=0;do{f[s+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[J>>2]|0))}J=f[g+44>>2]|0;if((J|0)!=(g+48|0))wL(J);u=e;return}function RL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){b[g>>0]=0;i=e<<1&2;j=(i^2)+-1|0;b[g+1>>0]=j>>>0<256?j:(i|0)==0?255:0;b[g+2>>0]=-1;b[g+3>>0]=1;b[g+4>>0]=(e|0)==-1&1;if((d|0)>0){i=0;do{j=b[a+i>>0]|0;if((j&255)<3)k=b[g+((j&255)+2)>>0]|0;else k=0;b[c+i>>0]=k;i=i+1|0}while((i|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{i=0;do{b[c+i>>0]=b[a+i>>0]|0;i=i+1|0}while((i|0)!=(d|0));u=f;return}do{i=h[a+l>>0]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:i,k)|0;i=Y(i,i)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,i)|0;b[c+l>>0]=g>>>0<255?g:255;l=l+1|0}while((l|0)!=(d|0));u=f;return}function SL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;b[g>>0]=((h<<31>>31)+128|0)>>>0<256?h<<31>>31:-128;b[g+1>>0]=(e<<1&2^2)+255;b[g+2>>0]=127;b[g+3>>0]=1;b[g+4>>0]=h&1;if((d|0)>0){h=0;do{i=b[a+h>>0]|0;j=i<<24>>24;if(((i<<24>>24>-1?j:0-j|0)|0)<3)k=b[g+(j+2)>>0]|0;else k=0;b[c+h>>0]=k;h=h+1|0}while((h|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=b[a+h>>0]|0;g=k<<24>>24;b[c+h>>0]=(g+128|0)>>>0<256?g:k<<24>>24>0?127:128;h=h+1|0}while((h|0)!=(d|0));u=f;return}do{h=b[a+l>>0]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;b[c+l>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;l=l+1|0}while((l|0)!=(d|0));u=f;return}function TL(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){d[g>>1]=0;h=e<<1&2;i=(h^2)+-1|0;d[g+2>>1]=i>>>0<65536?i:(h|0)==0?65535:0;d[g+4>>1]=-1;d[g+6>>1]=1;d[g+8>>1]=(e|0)==-1&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;if((i&65535)<3)k=d[g+((i&65535)+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{d[b+(h<<1)>>1]=d[a+(h<<1)>>1]|0;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=j[a+(l<<1)>>1]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;d[b+(l<<1)>>1]=g>>>0<65535?g:65535;l=l+1|0}while((l|0)!=(c|0));u=f;return}function UL(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;d[g>>1]=((h<<31>>31)+32768|0)>>>0<65536?h<<31>>31:-32768;d[g+2>>1]=(e<<1&2^2)+65535;d[g+4>>1]=32767;d[g+6>>1]=1;d[g+8>>1]=h&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;j=i<<16>>16;if(((i<<16>>16>-1?j:0-j|0)|0)<3)k=d[g+(j+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=d[a+(h<<1)>>1]|0;g=k<<16>>16;d[b+(h<<1)>>1]=(g+32768|0)>>>0<65536?g:k<<16>>16>0?32767:32768;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=d[a+(l<<1)>>1]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;d[b+(l<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;l=l+1|0}while((l|0)!=(c|0));u=f;return}function VL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e;if((d|0)<0){h=(d|0)==-1;f[g>>2]=h<<31>>31;f[g+4>>2]=(d<<1&2^2)+-1;f[g+8>>2]=2147483647;f[g+12>>2]=1;f[g+16>>2]=h&1;if((c|0)>0){h=0;do{i=f[a+(h<<2)>>2]|0;if((((i|0)>-1?i:0-i|0)|0)<3)j=f[g+(i+2<<2)>>2]|0;else j=0;f[b+(h<<2)>>2]=j;h=h+1|0}while((h|0)!=(c|0))}u=e;return}if((c|0)<=0){u=e;return}if((d|0)>1)k=0;else{h=0;do{f[b+(h<<2)>>2]=f[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(c|0));u=e;return}do{h=f[a+(k<<2)>>2]|0;j=1;g=d;while(1){j=Y((g&1|0)==0?1:h,j)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(j,h)|0;f[b+(k<<2)>>2]=g;k=k+1|0}while((k|0)!=(c|0));u=e;return}function WL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0.0,j=0.0,k=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;g=(d|0)<0;if((e|0)<=1)if(g){d=0;do{n[b+(d<<2)>>2]=1.0/+n[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{f[b+(d<<2)>>2]=f[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}if(g){g=0;do{h=1.0/+n[a+(g<<2)>>2];i=1.0;d=e;while(1){i=(d&1|0)==0?i:h*i;h=h*h;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=h*i;g=g+1|0}while((g|0)!=(c|0));return}else{g=0;do{j=+n[a+(g<<2)>>2];k=1.0;d=e;while(1){k=(d&1|0)==0?k:j*k;j=j*j;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=j*k;g=g+1|0}while((g|0)!=(c|0));return}}function XL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;f=(d|0)<0;if((e|0)<=1)if(f){d=0;do{p[b+(d<<3)>>3]=1.0/+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{p[b+(d<<3)>>3]=+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}if(f){f=0;do{g=1.0/+p[a+(f<<3)>>3];h=1.0;d=e;while(1){h=(d&1|0)==0?h:g*h;g=g*g;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=g*h;f=f+1|0}while((f|0)!=(c|0));return}else{f=0;do{i=+p[a+(f<<3)>>3];j=1.0;d=e;while(1){j=(d&1|0)==0?j:i*j;i=i*i;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=i*j;f=f+1|0}while((f|0)!=(c|0));return}}function YL(a,b){a=a|0;b=b|0;QL(a,.5,b);return}function ZL(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;h=u;u=u+336|0;i=h+72|0;j=h+56|0;k=h;l=h+304|0;m=h+192|0;o=h+176|0;q=h+248|0;r=h+160|0;t=h+104|0;p[s>>3]=e;v=f[s>>2]|0;w=f[s+4>>2]|0;p[s>>3]=g;x=f[s>>2]|0;y=f[s+4>>2]|0;do if((eS(a)|0)==65536){z=f[a+4>>2]|0;f[m>>2]=f[z>>2];A=m+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=m+8|0;f[C>>2]=f[z+8>>2];f[m+12>>2]=f[z+12>>2];f[m+16>>2]=f[z+16>>2];f[m+20>>2]=f[z+20>>2];f[m+24>>2]=f[z+24>>2];f[m+28>>2]=f[z+28>>2];f[m+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[m+36>>2]=D;f[m+40>>2]=C;C=m+48|0;E=m+44|0;f[E>>2]=C;f[C>>2]=0;f[m+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];F=A;break}else{f[A>>2]=0;U$(m,z);F=A;break}}else{bS(m,a,-1);F=m+4|0}while(0);a=f[F>>2]|0;if((a|0)>2){if(d|0){b[j+11>>0]=10;G=j;A=218423;H=G+10|0;do{b[G>>0]=b[A>>0]|0;G=G+1|0;A=A+1|0}while((G|0)<(H|0));b[j+10>>0]=0;vM(-215,j,218434,218127,1462)}f[j>>2]=m;f[j+4>>2]=0;A=k+40|0;z=k+48|0;B=k+44|0;C=k+52|0;E=k+8|0;G=k+4|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[A>>2]=E;f[B>>2]=z;f[z>>2]=0;f[C>>2]=0;f[k>>2]=1124007936;zL(l,j,k,-1);C=l+16|0;z=l+4|0;B=o+8|0;E=o+12|0;A=o+4|0;G=0;while(1){if(G>>>0>=(f[C>>2]|0)>>>0){I=1;break}H=f[z>>2]|0;f[B>>2]=0;f[E>>2]=0;f[o>>2]=16842752;f[A>>2]=H;if(!(ZL(o,c,0,e,g)|0)){I=0;break}CL(l)|0;G=G+1|0}G=k+36|0;A=f[G>>2]|0;if(A|0?(E=A+12|0,A=f[E>>2]|0,f[E>>2]=A+-1,(A|0)==1):0)V$(k);f[G>>2]=0;G=k+16|0;A=k+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){G=f[k+40>>2]|0;E=0;do{f[G+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[A>>2]|0))}A=f[k+44>>2]|0;if((A|0)!=(k+48|0))wL(A);K=I}else{I=f[m>>2]|0;A=I&7;f[o>>2]=-1;E=o+4|0;f[E>>2]=-1;if(A>>>0<5){G=~~e;B=!(e<=-2147483648.0)?G-(+(G|0)>e&1)|0:-2147483648;G=~~g;z=g>2147483647.0?2147483647:G+-1+(+(G|0)<g&1)|0;G=f[35720+(A<<2)>>2]|0;f[q>>2]=I;C=q+4|0;f[C>>2]=a;a=q+8|0;f[a>>2]=f[m+8>>2];f[q+12>>2]=f[m+12>>2];H=q+16|0;f[H>>2]=f[m+16>>2];f[q+20>>2]=f[m+20>>2];f[q+24>>2]=f[m+24>>2];f[q+28>>2]=f[m+28>>2];f[q+32>>2]=f[m+32>>2];D=q+36|0;L=f[m+36>>2]|0;f[D>>2]=L;M=q+40|0;f[M>>2]=a;a=q+48|0;N=q+44|0;f[N>>2]=a;f[a>>2]=0;f[q+52>>2]=0;if((L|0)!=0?(O=L+12|0,f[O>>2]=(f[O>>2]|0)+1,(f[F>>2]|0)>=3):0){f[C>>2]=0;U$(q,m)}else{O=f[m+44>>2]|0;L=f[N>>2]|0;f[L>>2]=f[O>>2];f[L+4>>2]=f[O+4>>2]}hh[G&127](q,o,B,z)|0;z=f[D>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)V$(q);f[D>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[C>>2]|0)>0){H=f[M>>2]|0;M=0;do{f[H+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[C>>2]|0))}C=f[N>>2]|0;if((C|0)!=(a|0))wL(C)}else{C=(I>>>3&511)+1|0;l0(j,m,C);I=f[m+16>>2]|0;a=f[m+48>>2]|0;a:do if((A|0)==5){N=a>>>2;M=(n[s>>2]=e<-3402823466385288598117041.0e14?-3402823466385288598117041.0e14:e,f[s>>2]|0);H=(n[s>>2]=g>3402823466385288598117041.0e14?3402823466385288598117041.0e14:g,f[s>>2]|0);D=M>>31&2147483647^M;M=H>>31&2147483647^H;H=j+4|0;q=f[o>>2]|0;if((q|0)<0){z=m+12|0;B=0;G=I;O=q;q=f[H>>2]|0;b:while(1){L=f[j>>2]|0;P=(L|0)>0;Q=q+-1|0;if(!q){R=Q;break}else{S=B;T=G;U=Q}while(1){if(P)break;Q=U+-1|0;if(!U){R=Q;break b}else{S=L+S|0;T=T+(N<<2)|0;U=Q}}f[H>>2]=U;P=0;while(1){Q=f[T+(P<<2)>>2]|0;V=Q>>31&2147483647^Q;if(!((V|0)>=(D|0)&(V|0)<(M|0))){W=45;break}V=P+1|0;if((V|0)<(L|0))P=V;else{X=O;break}}if((W|0)==45){W=0;V=(P+S|0)/(C|0)|0;Q=f[z>>2]|0;Y=(V|0)%(Q|0)|0;f[o>>2]=Y;f[E>>2]=(V|0)/(Q|0)|0;X=Y}if((X|0)<0){B=L+S|0;G=T+(N<<2)|0;O=X;q=U}else break a}f[H>>2]=R}}else{q=a>>>3;O=k1c(v|0,w|0,63)|0;N=O^v;O=J&2147483647^w;G=k1c(x|0,y|0,63)|0;B=G^x;G=J&2147483647^y;z=j+4|0;M=f[o>>2]|0;if((M|0)<0){D=f[j>>2]|0;Y=f[m+12>>2]|0;Q=f[z>>2]|0;c:do if((D|0)>0){V=I;Z=0;_=Q;$=M;while(1){aa=_+-1|0;if(!_){ba=aa;break c}else ca=0;while(1){da=V+(ca<<3)|0;ea=f[da>>2]|0;fa=f[da+4>>2]|0;da=k1c(ea|0,fa|0,63)|0;ga=da^ea;ea=J&2147483647^fa;if(!(((ea|0)>(O|0)|(ea|0)==(O|0)&ga>>>0>=N>>>0)&((ea|0)<(G|0)|(ea|0)==(G|0)&ga>>>0<B>>>0))){W=53;break}ga=ca+1|0;if((ga|0)<(D|0))ca=ga;else{ha=$;break}}if((W|0)==53){W=0;ga=(ca+Z|0)/(C|0)|0;ea=(ga|0)%(Y|0)|0;f[o>>2]=ea;f[E>>2]=(ga|0)/(Y|0)|0;ha=ea}if((ha|0)<0){V=V+(q<<3)|0;Z=D+Z|0;_=aa;$=ha}else{ba=aa;break}}}else{$=Q;while(1){_=$+-1|0;if(!$){ba=_;break}else $=_}}while(0);f[z>>2]=ba}}while(0)}ba=f[o>>2]|0;if((ba|0)>-1){if(d|0){f[d>>2]=ba;f[d+4>>2]=f[E>>2]}if(c)ia=0;else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;c=f[E>>2]|0;f[j>>2]=ba;f[j+4>>2]=ba+1;f[k>>2]=c;f[k+4>>2]=c+1;W$(t,m,k,j);W1(l,0);c=f[l>>2]|0;Ti[f[(f[c>>2]|0)+8>>2]&511](k,c,t);c=f[k>>2]|0;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[k>>2]|0;ba=_i[f[f[c>>2]>>2]&2047](c)|0;d:do if(ba|0){c=j+11|0;d=j+4|0;ha=j+8|0;C=ba;while(1){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;ca=dJc(C)|0;if(ca>>>0>4294967279)break;if(ca>>>0<11){b[c>>0]=ca;if(!ca)ja=j;else{ka=j;W=71}}else{I=ca+16&-16;y=$Xc(I)|0;f[j>>2]=y;f[ha>>2]=I|-2147483648;f[d>>2]=ca;ka=y;W=71}if((W|0)==71){W=0;o1c(ka|0,C|0,ca|0)|0;ja=ka}b[ja+ca>>0]=0;ca=b[c>>0]|0;y=ca<<24>>24<0;zYc(r,y?f[j>>2]|0:j,y?f[d>>2]|0:ca&255)|0;if((b[c>>0]|0)<0)cYc(f[j>>2]|0);ca=f[k>>2]|0;C=_i[f[f[ca>>2]>>2]&2047](ca)|0;if(!C)break d}jYc(j)}while(0);ja=f[k+4>>2]|0;if(ja|0)UXc(ja);ja=f[l+4>>2]|0;if(ja|0)UXc(ja);ja=t+36|0;l=f[ja>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)V$(t);f[ja>>2]=0;ja=t+16|0;l=t+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[l>>2]|0)>0){ja=f[t+40>>2]|0;k=0;do{f[ja+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[l>>2]|0))}l=f[t+44>>2]|0;if((l|0)==(t+48|0)){la=f[o>>2]|0;ma=f[E>>2]|0;na=r+11|0;oa=b[na>>0]|0;pa=oa<<24>>24<0;qa=f[r>>2]|0;ra=pa?qa:r;f[i>>2]=la;sa=i+4|0;f[sa>>2]=ma;ta=i+8|0;f[ta>>2]=ra;ua=i+16|0;p[ua>>3]=e;va=i+24|0;p[va>>3]=g;DM(j,218445,i);vM(-211,j,218434,218127,1563)}wL(l);la=f[o>>2]|0;ma=f[E>>2]|0;na=r+11|0;oa=b[na>>0]|0;pa=oa<<24>>24<0;qa=f[r>>2]|0;ra=pa?qa:r;f[i>>2]=la;sa=i+4|0;f[sa>>2]=ma;ta=i+8|0;f[ta>>2]=ra;ua=i+16|0;p[ua>>3]=e;va=i+24|0;p[va>>3]=g;DM(j,218445,i);vM(-211,j,218434,218127,1563)}}else ia=1;K=ia}ia=m+36|0;j=f[ia>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)V$(m);f[ia>>2]=0;ia=m+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[F>>2]|0)>0){ia=f[m+40>>2]|0;j=0;do{f[ia+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[F>>2]|0))}F=f[m+44>>2]|0;if((F|0)==(m+48|0)){u=h;return K|0}wL(F);u=h;return K|0}function _L(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;d=u;u=u+112|0;e=d+48|0;g=d+40|0;h=d+32|0;i=d;if((qS(a,-1)|0)!=5){j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=20;k=j;l=218495;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+20>>0]=0;vM(-215,e,218516,218127,1597)}do if((eS(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];l=e+4|0;k=j+4|0;f[l>>2]=f[k>>2];m=e+8|0;f[m>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[e+16>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=m;m=e+48|0;p=e+44|0;f[p>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[k>>2]|0)<3){k=f[j+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];break}else{f[l>>2]=0;U$(e,j);break}}else bS(e,a,-1);while(0);f[g>>2]=e;f[g+4>>2]=0;f[h>>2]=0;BL(i,g,h,-1);g=Y(((f[e>>2]|0)>>>3&511)+1|0,f[i+20>>2]|0)|0;q=c;a=i+16|0;a:do if(!g){j=0;while(1){if(j>>>0>=(f[a>>2]|0)>>>0)break a;CL(i)|0;j=j+1|0}}else{j=0;while(1){if(j>>>0>=(f[a>>2]|0)>>>0)break a;l=f[h>>2]|0;k=0;do{m=l+(k<<2)|0;if((f[m>>2]&2147483647)>>>0>2139095040)n[m>>2]=q;k=k+1|0}while((k|0)!=(g|0));CL(i)|0;j=j+1|0}}while(0);i=e+36|0;g=f[i>>2]|0;if(g|0?(h=g+12|0,g=f[h>>2]|0,f[h>>2]=g+-1,(g|0)==1):0)V$(e);f[i>>2]=0;i=e+16|0;g=e+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[g>>2]|0)>0){i=f[e+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)==(e+48|0)){u=d;return}wL(g);u=d;return}function $L(a,b){a=+a;b=+b;return +(+fQ(a,b))}function aM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,P=0,Q=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0;d=u;u=u+112|0;e=d+56|0;g=d;do if((eS(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=e;break}else{f[i>>2]=0;U$(e,h);o=e;break}}else{bS(e,a,-1);o=e}while(0);a=f[o>>2]&4095;h=(a|0)==5;if((a+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=$Xc(48)|0;f[g>>2]=i;f[g+8>>2]=-2147483600;f[g+4>>2]=34;j=i;k=218526;m=j+34|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(m|0));b[i+34>>0]=0;vM(-215,g,218561,218127,1756)}i=e+40|0;k=f[i>>2]|0;j=f[k+4>>2]|0;m=f[k>>2]|0;if(!((j+-3|0)>>>0<2&(m|0)==1)?!((j|0)==1&(m+-3|0)>>>0<2):0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=$Xc(144)|0;f[g>>2]=m;f[g+8>>2]=-2147483504;f[g+4>>2]=130;o1c(m|0,218572,130)|0;b[m+130>>0]=0;vM(-215,g,218561,218127,1760)}ZS(c,3,1,a,-1,1,96);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[g>>2]=f[a>>2];m=g+4|0;j=a+4|0;f[m>>2]=f[j>>2];k=g+8|0;f[k>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[g+16>>2]=f[a+16>>2];f[g+20>>2]=f[a+20>>2];f[g+24>>2]=f[a+24>>2];f[g+28>>2]=f[a+28>>2];f[g+32>>2]=f[a+32>>2];l=f[a+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=k;k=g+48|0;q=g+44|0;f[q>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[a+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[m>>2]=0;U$(g,a);break}}else bS(g,c,-1);while(0);c=f[e+12>>2]|0;a=(c+(f[e+8>>2]|0)|0)==5;m=e+16|0;if(h){if(a){h=f[m>>2]|0;r=0;s=+n[h>>2];t=h;v=h}else{h=f[m>>2]|0;r=-1;s=1.0;t=h;v=h}h=r+1|0;do if(!(f[o>>2]&16384)){j=f[i>>2]|0;do if((f[j>>2]|0)!=1){k=f[f[e+44>>2]>>2]|0;if((f[j+4>>2]|0)==1){w=t+(Y(k,h)|0)|0;break}else{q=(h|0)/(c|0)|0;w=t+(Y(q,k)|0)+(h-(Y(q,c)|0)<<2)|0;break}}else w=t+(h<<2)|0;while(0);x=+n[w>>2];j=r+2|0;q=f[i>>2]|0;do if((f[q>>2]|0)!=1){k=f[f[e+44>>2]>>2]|0;if((f[q+4>>2]|0)==1){y=t+(Y(k,j)|0)|0;break}else{l=(j|0)/(c|0)|0;y=t+(Y(l,k)|0)+(j-(Y(l,c)|0)<<2)|0;break}}else y=t+(j<<2)|0;while(0);z=+n[y>>2];j=r+3|0;q=f[i>>2]|0;if((f[q>>2]|0)!=1){l=f[f[e+44>>2]>>2]|0;if((f[q+4>>2]|0)==1){A=t+(Y(l,j)|0)|0;B=z;C=x;break}else{q=(j|0)/(c|0)|0;A=t+(Y(q,l)|0)+(j-(Y(q,c)|0)<<2)|0;B=z;C=x;break}}else{D=j;E=z;F=x;G=37}}else{D=r+3|0;E=+n[t+(r+2<<2)>>2];F=+n[v+(h<<2)>>2];G=37}while(0);if((G|0)==37){A=t+(D<<2)|0;B=E;C=F}H=+n[A>>2];I=B;J=C;K=s}else{if(a){a=f[m>>2]|0;P=0;Q=+p[a>>3];S=a;T=a}else{a=f[m>>2]|0;P=-1;Q=1.0;S=a;T=a}a=P+1|0;do if(!(f[o>>2]&16384)){m=f[i>>2]|0;do if((f[m>>2]|0)!=1){A=f[f[e+44>>2]>>2]|0;if((f[m+4>>2]|0)==1){U=S+(Y(A,a)|0)|0;break}else{D=(a|0)/(c|0)|0;U=S+(Y(D,A)|0)+(a-(Y(D,c)|0)<<3)|0;break}}else U=S+(a<<3)|0;while(0);x=+p[U>>3];m=P+2|0;D=f[i>>2]|0;do if((f[D>>2]|0)!=1){A=f[f[e+44>>2]>>2]|0;if((f[D+4>>2]|0)==1){V=S+(Y(A,m)|0)|0;break}else{t=(m|0)/(c|0)|0;V=S+(Y(t,A)|0)+(m-(Y(t,c)|0)<<3)|0;break}}else V=S+(m<<3)|0;while(0);s=+p[V>>3];m=P+3|0;D=f[i>>2]|0;if((f[D>>2]|0)!=1){t=f[f[e+44>>2]>>2]|0;if((f[D+4>>2]|0)==1){W=S+(Y(t,m)|0)|0;X=s;Z=x;break}else{D=(m|0)/(c|0)|0;W=S+(Y(D,t)|0)+(m-(Y(D,c)|0)<<3)|0;X=s;Z=x;break}}else{_=m;$=s;aa=x;G=58}}else{_=P+3|0;$=+p[S+(P+2<<3)>>3];aa=+p[T+(a<<3)>>3];G=58}while(0);if((G|0)==58){W=S+(_<<3)|0;X=$;Z=aa}H=+p[W>>3];I=X;J=Z;K=Q}do if(K==0.0){if(!(J==0.0)){Q=I*I-J*4.0*H;if(!(Q>=0.0)){ba=0.0;ca=0;da=0.0;ea=0.0;break}Z=+M(+Q);Q=(Z-I)*.5;X=(I+Z)*-.5;W=+L(+Q)>+L(+X);aa=W?Q:X;ba=0.0;ca=Z>0.0?2:1;da=H/aa;ea=aa/J;break}if(I==0.0){ba=0.0;ca=(H==0.0)<<31>>31;da=0.0;ea=0.0;break}else{ba=0.0;ca=1;da=0.0;ea=-H/I;break}}else{aa=1.0/K;Z=J*aa;X=I*aa;Q=(Z*Z-X*3.0)*.1111111111111111;$=(H*aa*27.0+(Z*(Z*(Z*2.0))-X*(Z*9.0)))*.018518518518518517;X=Q*(Q*Q);aa=X-$*$;if(aa>0.0){s=+M(+Q)*-2.0;C=+R(+($/+M(+X)))*.3333333333333333;X=Z*.3333333333333333;ba=s*+O(+(C+4.1887902047863905))-X;ca=3;da=s*+O(+(C+2.0943951023931953))-X;ea=s*+O(+C)-X;break}if(!(aa==0.0)){X=+N(+(+M(+-aa)+ +L(+$)),.3333333333333333);aa=$>0.0?-X:X;ba=0.0;ca=1;da=0.0;ea=aa+Q/aa-Z*.3333333333333333;break}aa=Z/3.0;if(!($>=0.0)){Z=+N(+-$,.3333333333333333);fa=Z*2.0;ga=-Z}else{Z=+N(+$,.3333333333333333);fa=Z*-2.0;ga=Z}Z=ga-aa;$=fa-aa;W=$==Z;ba=0.0;ca=W?1:2;da=W?0.0:Z;ea=$}while(0);W=f[g>>2]|0;_=g+16|0;S=f[_>>2]|0;if((W&4095|0)==5){n[S>>2]=ea;do if(!(W&16384)){a=f[g+40>>2]|0;do if((f[a>>2]|0)!=1){T=f[f[g+44>>2]>>2]|0;if((f[a+4>>2]|0)==1){ha=S+T|0;break}else{P=f[g+12>>2]|0;c=(P+1|0)>>>0<3?P:0;ha=S+(Y(c,T)|0)+(1-(Y(c,P)|0)<<2)|0;break}}else ha=S+4|0;while(0);n[ha>>2]=da;a=f[g+40>>2]|0;if((f[a>>2]|0)!=1){P=f[f[g+44>>2]>>2]|0;if((f[a+4>>2]|0)==1){ia=S+(P<<1)|0;break}else{a=f[g+12>>2]|0;c=2/(a|0)|0;ia=S+(Y(c,P)|0)+(2-(Y(c,a)|0)<<2)|0;break}}else G=87}else{n[S+4>>2]=da;G=87}while(0);if((G|0)==87)ia=S+8|0;n[ia>>2]=ba}else{p[S>>3]=ea;do if(!(W&16384)){ia=f[g+40>>2]|0;do if((f[ia>>2]|0)!=1){ha=f[f[g+44>>2]>>2]|0;if((f[ia+4>>2]|0)==1){ja=S+ha|0;break}else{a=f[g+12>>2]|0;c=(a+1|0)>>>0<3?a:0;ja=S+(Y(c,ha)|0)+(1-(Y(c,a)|0)<<3)|0;break}}else ja=S+8|0;while(0);p[ja>>3]=da;ia=f[g+40>>2]|0;if((f[ia>>2]|0)!=1){a=f[f[g+44>>2]>>2]|0;if((f[ia+4>>2]|0)==1){ka=S+(a<<1)|0;break}else{ia=f[g+12>>2]|0;c=2/(ia|0)|0;ka=S+(Y(c,a)|0)+(2-(Y(c,ia)|0)<<3)|0;break}}else G=100}else{p[S+8>>3]=da;G=100}while(0);if((G|0)==100)ka=S+16|0;p[ka>>3]=ba}ka=g+36|0;S=f[ka>>2]|0;if(S|0?(G=S+12|0,S=f[G>>2]|0,f[G>>2]=S+-1,(S|0)==1):0)V$(g);f[ka>>2]=0;ka=g+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[ka>>2]|0)>0){_=f[g+40>>2]|0;S=0;do{f[_+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[ka>>2]|0))}ka=f[g+44>>2]|0;if((ka|0)!=(g+48|0))wL(ka);ka=e+36|0;g=f[ka>>2]|0;if(g|0?(S=g+12|0,g=f[S>>2]|0,f[S>>2]=g+-1,(g|0)==1):0)V$(e);f[ka>>2]=0;ka=e+16|0;g=e+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[g>>2]|0)>0){ka=f[i>>2]|0;i=0;do{f[ka+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)==(e+48|0)){u=d;return ca|0}wL(g);u=d;return ca|0}function bM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0;e=u;u=u+1520|0;g=e+1464|0;h=e+1408|0;i=e+1352|0;j=e;k=e+1288|0;l=e+1344|0;m=e+1232|0;n=e+1176|0;o=e+1160|0;do if((eS(a)|0)==65536){q=f[a+4>>2]|0;f[h>>2]=f[q>>2];r=h+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=h+8|0;f[t>>2]=f[q+8>>2];f[h+12>>2]=f[q+12>>2];f[h+16>>2]=f[q+16>>2];f[h+20>>2]=f[q+20>>2];f[h+24>>2]=f[q+24>>2];f[h+28>>2]=f[q+28>>2];f[h+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[h+36>>2]=v;f[h+40>>2]=t;t=h+48|0;w=h+44|0;f[w>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;U$(h,q);break}}else bS(h,a,-1);while(0);q=dS(a,-1)|0;a=q&7;if(a>>>0<=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;x=$Xc(64)|0;f[g>>2]=x;y=g+8|0;f[y>>2]=-2147483584;z=g+4|0;f[z>>2]=54;A=x;B=218703;C=A+54|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+54|0;b[D>>0]=0;vM(-215,g,218758,218127,1907)}if(((q>>>3&511)+1|0)>>>0>=3){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;x=$Xc(64)|0;f[g>>2]=x;y=g+8|0;f[y>>2]=-2147483584;z=g+4|0;f[z>>2]=54;A=x;B=218703;C=A+54|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+54|0;b[D>>0]=0;vM(-215,g,218758,218127,1907)}D=f[h+8>>2]|0;x=f[h+12>>2]|0;if(!((D|0)==1|(x|0)==1)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(48)|0;f[g>>2]=z;f[g+8>>2]=-2147483600;f[g+4>>2]=38;A=z;B=218768;C=A+38|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[z+38>>0]=0;vM(-215,g,218758,218127,1908)}z=D+-2+x|0;ZS(c,z,1,a|8,-1,1,96);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];B=i+4|0;y=a+4|0;f[B>>2]=f[y>>2];q=i+8|0;f[q>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];r=f[a+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[y>>2];f[q+4>>2]=f[y+4>>2];break}else{f[B>>2]=0;U$(i,a);break}}else bS(i,c,-1);while(0);c=(z<<1)+2|0;a=j+8|0;g1c(a|0,0,1152)|0;f[j>>2]=a;B=j+4|0;f[B>>2]=c;if(c>>>0>72){y=bYc(c>>>0>268435455?-1:c<<4)|0;g1c(y|0,0,c<<4|0)|0;f[j>>2]=y;E=y}else E=a;y=E+(z<<4)+16|0;c=h+40|0;q=f[c>>2]|0;s=f[q>>2]|0;f[l>>2]=f[q+4>>2];f[l+4>>2]=s;s=((f[h>>2]|0)>>>3&511)+1|0;cM(k,l,(s<<3)+-2|0,(s|0)==2?E:y,0);s=g+8|0;f[s>>2]=0;f[s+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;dY(h,g,f[k>>2]&4095,1.0,0.0);if(!(f[h>>2]&4088))if((z|0)<0){F=z;G=0}else{s=D+x+-1|0;x=0;do{p[E+(x<<4)>>3]=+p[y+(x<<3)>>3];p[E+(x<<4)+8>>3]=0.0;x=x+1|0}while((x|0)!=(s|0));H=25}else H=25;do if((H|0)==25){if((z|0)<=1)if((z|0)==1){I=1;J=1}else{F=z;G=0;break}else{s=z;while(1){K=+L(+(+p[E+(s<<4)>>3]));if(K+ +L(+(+p[E+(s<<4)+8>>3]))>2.220446049250313e-16){O=s;break}s=s+-1|0;if((s|0)<=1){O=1;break}}I=O;J=(O|0)>0}s=0;K=1.0;P=0.0;while(1){x=y+(s<<4)|0;p[x>>3]=K;p[x+8>>3]=P;Q=K+P;s=s+1|0;if((s|0)==(I|0)){F=I;G=J;break}else{K=K-P;P=Q}}}while(0);J=(d|0)<1?1e3:d;a:do if((J|0)>0){d=E+(F<<4)|0;I=E+(F<<4)+8|0;O=m+4|0;s=m+8|0;x=m+40|0;D=m+48|0;l=m+44|0;q=m+52|0;r=g+4|0;t=n+4|0;w=n+8|0;v=n+40|0;R=n+48|0;S=n+44|0;T=n+52|0;U=m+16|0;V=m+12|0;W=g+8|0;X=g+12|0;Z=g+4|0;_=o+8|0;$=o+4|0;aa=n+16|0;ba=n+36|0;ca=m+36|0;da=0;while(1){if(G){ea=0.0;fa=0}else{ga=0.0;break a}do{ha=y+(fa<<4)|0;P=+p[ha>>3];ia=ha+8|0;K=+p[ia>>3];Q=+p[d>>3];ja=+p[I>>3];ka=0;la=1;ma=Q;na=Q;Q=ja;oa=ja;while(1){pa=F-ka+-1|0;ja=na;na=P*na-K*Q+ +p[E+(pa<<4)>>3];Q=K*ja+P*Q+ +p[E+(pa<<4)+8>>3];do if((ka|0)!=(fa|0)){pa=y+(ka<<4)|0;ja=P-+p[pa>>3];qa=K-+p[pa+8>>3];if(ja!=0.0|qa!=0.0){ra=la;sa=ma*ja-oa*qa;ta=oa*ja+ma*qa;break}else{ra=la+1|0;sa=ma;ta=oa;break}}else{ra=la;sa=ma;ta=oa}while(0);ka=ka+1|0;if((ka|0)==(F|0))break;else{la=ra;ma=sa;oa=ta}}oa=1.0/(sa*sa+ta*ta);ma=oa*(sa*na+ta*Q);qa=oa*(sa*Q-ta*na);if((ra|0)>1){if(((ra<<31>>31)+(ra>>>1)|0)>0){oa=ma+ +M(+(ma*ma+qa*qa));ja=+M(+(oa*.5));ua=+M(+((oa-ma)*.5));va=ja;wa=ma<0.0?-ua:ua}else{va=ma;wa=qa}if(!(ra&1)){xa=va;ya=wa}else{f[m>>2]=1124007936;A=O;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[x>>2]=s;f[l>>2]=D;f[D>>2]=0;f[q>>2]=0;f[g>>2]=4;f[r>>2]=1;S$(m,2,g,6);f[n>>2]=1124007936;A=t;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[v>>2]=w;f[S>>2]=R;f[R>>2]=0;f[T>>2]=0;f[g>>2]=3;f[r>>2]=1;S$(n,2,g,14);na=-+N(+ma,3.0);la=(f[m>>2]&16384|0)==0;ka=f[U>>2]|0;do if(la?(pa=f[x>>2]|0,(f[pa>>2]|0)!=1):0){za=f[f[l>>2]>>2]|0;if((f[pa+4>>2]|0)==1){Aa=ka+(za*3|0)|0;break}else{pa=f[V>>2]|0;Ba=3/(pa|0)|0;Aa=ka+(Y(Ba,za)|0)+(3-(Y(Ba,pa)|0)<<3)|0;break}}else H=48;while(0);if((H|0)==48){H=0;Aa=ka+24|0}p[Aa>>3]=na;Q=-(ma*ma*15.0+qa*qa*27.0);do if(la){pa=f[x>>2]|0;do if((f[pa>>2]|0)!=1){Ba=f[f[l>>2]>>2]|0;if((f[pa+4>>2]|0)==1){Ca=ka+(Ba<<1)|0;break}else{za=f[V>>2]|0;Da=2/(za|0)|0;Ca=ka+(Y(Da,Ba)|0)+(2-(Y(Da,za)|0)<<3)|0;break}}else Ca=ka+16|0;while(0);p[Ca>>3]=Q;ua=ma*-48.0;pa=f[x>>2]|0;if((f[pa>>2]|0)==1){Ea=ua;H=60;break}za=f[f[l>>2]>>2]|0;if((f[pa+4>>2]|0)==1){Fa=ka+za|0;Ga=ua;break}else{pa=f[V>>2]|0;Da=(pa+1|0)>>>0<3?pa:0;Fa=ka+(Y(Da,za)|0)+(1-(Y(Da,pa)|0)<<3)|0;Ga=ua;break}}else{p[ka+16>>3]=Q;Ea=ma*-48.0;H=60}while(0);if((H|0)==60){H=0;Fa=ka+8|0;Ga=Ea}p[Fa>>3]=Ga;p[ka>>3]=64.0;f[W>>2]=0;f[X>>2]=0;f[g>>2]=16842752;f[Z>>2]=m;la=_;f[la>>2]=0;f[la+4>>2]=0;f[o>>2]=33619968;f[$>>2]=n;aM(g,o)|0;Q=+p[f[aa>>2]>>3];if(!(Q>=0.0))Ha=-+N(+-Q,.3333333333333333);else Ha=+N(+Q,.3333333333333333);Q=+M(+(Ha*Ha/3.0-ma/(Ha*3.0)));la=f[ba>>2]|0;do if(la|0){pa=la+12|0;Da=f[pa>>2]|0;f[pa>>2]=Da+-1;if((Da|0)!=1)break;V$(n)}while(0);f[ba>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[t>>2]|0)>0){la=f[v>>2]|0;ka=0;do{f[la+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[t>>2]|0))}ka=f[S>>2]|0;if((ka|0)!=(R|0))wL(ka);ka=f[ca>>2]|0;do if(ka|0){la=ka+12|0;Da=f[la>>2]|0;f[la>>2]=Da+-1;if((Da|0)!=1)break;V$(m)}while(0);f[ca>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[O>>2]|0)>0){ka=f[x>>2]|0;Da=0;do{f[ka+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[O>>2]|0))}Da=f[l>>2]|0;if((Da|0)!=(D|0))wL(Da);xa=Ha;ya=Q}}else{xa=ma;ya=qa}p[ha>>3]=P-xa;p[ia>>3]=K-ya;na=+M(+(xa*xa+ya*ya));ea=ea<na?na:ea;fa=fa+1|0}while((fa|0)<(F|0));da=da+1|0;if(!(!(ea<=0.0)&(da|0)<(J|0))){Ia=ea;H=86;break}}}else{Ia=0.0;H=86}while(0);if((H|0)==86)if((f[h>>2]&4088|0)==0&G){G=0;do{H=y+(G<<4)+8|0;if(+L(+(+p[H>>3]))<1.0e-100)p[H>>3]=0.0;G=G+1|0}while((G|0)!=(F|0));ga=Ia}else ga=Ia;if((F|0)<(z|0)){G=F;do{F=y+(G<<4)|0;G=G+1|0;H=y+(G<<4)|0;f[H>>2]=f[F>>2];f[H+4>>2]=f[F+4>>2];f[H+8>>2]=f[F+8>>2];f[H+12>>2]=f[F+12>>2]}while((G|0)!=(z|0))}z=i+40|0;G=f[z>>2]|0;F=f[G+4>>2]|0;H=f[G>>2]|0;f[g>>2]=1124007950;G=g+4|0;f[G>>2]=2;J=g+8|0;f[J>>2]=H;f[g+12>>2]=F;fa=g+16|0;f[fa>>2]=y;f[g+20>>2]=y;n=g+24|0;o=g+40|0;Fa=n+8|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[o>>2]=J;J=g+48|0;Fa=g+44|0;f[Fa>>2]=J;Ca=F<<4;f[J>>2]=Ca;f[g+52>>2]=16;F=y+(Y(H,Ca)|0)|0;f[g+28>>2]=F;f[n>>2]=F+(0-Ca)+Ca;R$(g);Ca=m+8|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=i;dY(g,m,f[i>>2]&4095,1.0,0.0);m=g+36|0;Ca=f[m>>2]|0;if(Ca|0?(F=Ca+12|0,Ca=f[F>>2]|0,f[F>>2]=Ca+-1,(Ca|0)==1):0)V$(g);f[m>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[G>>2]|0)>0){fa=f[o>>2]|0;o=0;do{f[fa+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[G>>2]|0))}G=f[Fa>>2]|0;if((G|0)!=(J|0))wL(G);G=k+36|0;J=f[G>>2]|0;if(J|0?(Fa=J+12|0,J=f[Fa>>2]|0,f[Fa>>2]=J+-1,(J|0)==1):0)V$(k);f[G>>2]=0;G=k+16|0;J=k+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[J>>2]|0)>0){G=f[k+40>>2]|0;Fa=0;do{f[G+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[J>>2]|0))}J=f[k+44>>2]|0;if((J|0)!=(k+48|0))wL(J);J=f[j>>2]|0;if((J|0)!=(a|0)){if(J|0)dYc(J);f[j>>2]=a;f[B>>2]=72}B=i+36|0;a=f[B>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)V$(i);f[B>>2]=0;B=i+16|0;a=i+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){B=f[z>>2]|0;z=0;do{f[B+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))wL(a);a=h+36|0;i=f[a>>2]|0;do if(i|0){z=i+12|0;B=f[z>>2]|0;f[z>>2]=B+-1;if((B|0)!=1)break;V$(h)}while(0);f[a>>2]=0;a=h+16|0;i=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return +ga}wL(i);u=e;return +ga}function cM(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;i=h;f[a>>2]=d&4095|1124007936;f[a+4>>2]=2;j=a+8|0;k=f[c+4>>2]|0;f[j>>2]=k;l=f[c>>2]|0;f[a+12>>2]=l;f[a+16>>2]=e;f[a+20>>2]=e;c=a+24|0;m=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[a+40>>2]=j;j=a+48|0;f[a+44>>2]=j;f[a+52>>2]=0;f[j>>2]=0;if((Y(l,k)|0)!=0&(e|0)==0){n=$Xc(32)|0;f[i>>2]=n;f[i+8>>2]=-2147483616;f[i+4>>2]=28;o=n;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+28>>0]=0;vM(-215,i,470343,470347,577)}n=675553809>>>(d<<2&28)&15;r=Y(n,(d>>>3&511)+1|0)|0;d=Y(l,r)|0;if(!g){s=d;f[j>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(k,s)|0;w=e+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+d|0;f[c>>2]=z;R$(a);u=h;return}if(!((g>>>0)%(n>>>0)|0)){s=g;f[j>>2]=s;t=a+52|0;f[t>>2]=r;v=Y(k,s)|0;w=e+v|0;f[m>>2]=w;x=0-s|0;y=w+x|0;z=y+d|0;f[c>>2]=z;R$(a);u=h;return}else{h=$Xc(32)|0;f[i>>2]=h;f[i+8>>2]=-2147483616;f[i+4>>2]=31;o=h;p=237472;q=o+31|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[h+31>>0]=0;vM(-13,i,470343,470347,591)}}function dM(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0.0,ya=0,za=0.0;l=u;u=u+1104|0;m=l;o=m+8|0;f[m>>2]=o;q=m+4|0;f[q>>2]=h;if(h>>>0>136){r=bYc(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=r;s=r}else s=o;r=(g|0)>30?g:30;t=b>>>2;b=e>>>2;e=(h|0)>0;a:do if(e){v=(d|0)==0;w=h<<2;if((g|0)>0)x=0;else{y=0;while(1){z=Y(b,y)|0;p[s+(y<<3)>>3]=0.0;if(!v){g1c(d+(z<<2)|0,0,w|0)|0;n[d+(z+y<<2)>>2]=1.0}y=y+1|0;if((y|0)==(h|0))break a}}do{y=Y(b,x)|0;z=d+(y<<2)|0;A=Y(x,t)|0;B=0;C=0.0;do{D=+n[a+(B+A<<2)>>2];C=C+D*D;B=B+1|0}while((B|0)!=(g|0));p[s+(x<<3)>>3]=C;if(!v){g1c(z|0,0,w|0)|0;n[d+(y+x<<2)>>2]=1.0}x=x+1|0}while((x|0)!=(h|0))}while(0);b:do if((r|0)>0){x=h+-1|0;w=(h|0)>1;v=(g|0)>0;D=k;B=(d|0)==0;A=0;do{if(w){E=0;F=0}else break b;while(1){G=F;F=F+1|0;if((F|0)<(h|0)){H=a+((Y(G,t)|0)<<2)|0;I=s+(G<<3)|0;K=d+((Y(G,b)|0)<<2)|0;G=F;N=E;while(1){O=a+((Y(G,t)|0)<<2)|0;P=+p[I>>3];Q=s+(G<<3)|0;R=+p[Q>>3];if(v){S=0.0;T=0;while(1){U=S+ +n[H+(T<<2)>>2]*+n[O+(T<<2)>>2];T=T+1|0;if((T|0)==(g|0)){V=U;break}else S=U}}else V=0.0;if(!(+L(+V)<=D*+M(+(P*R)))){S=V*2.0;U=P-R;W=+L(+S);X=+L(+U);if(!(W>X))if(U!=U|0.0!=0.0|U==0.0)Z=0.0;else{_=W/X;$=X;aa=_*_;ba=32}else{_=X/W;$=W;aa=_*_;ba=32}if((ba|0)==32){ba=0;Z=$*+M(+(aa+1.0))}if(U<0.0){_=+M(+((Z-U)*.5/Z));ca=S/(Z*_*2.0);da=_}else{_=+M(+((U+Z)/(Z*2.0)));ca=_;da=S/(Z*_*2.0)}if(v){_=0.0;S=0.0;T=0;while(1){ea=H+(T<<2)|0;U=+n[ea>>2];fa=O+(T<<2)|0;W=+n[fa>>2];X=ca*U+da*W;ga=ca*W-da*U;n[ea>>2]=X;n[fa>>2]=ga;U=X;X=_+U*U;U=ga;ga=S+U*U;T=T+1|0;if((T|0)==(g|0)){ha=X;ia=ga;break}else{_=X;S=ga}}}else{ha=0.0;ia=0.0}p[I>>3]=ha;p[Q>>3]=ia;if(!B?(T=d+((Y(G,b)|0)<<2)|0,e):0){O=0;do{fa=K+(O<<2)|0;S=+n[fa>>2];ea=T+(O<<2)|0;_=+n[ea>>2];n[fa>>2]=ca*S+da*_;n[ea>>2]=ca*_-da*S;O=O+1|0}while((O|0)!=(h|0));ja=1}else ja=1}else ja=N;G=G+1|0;if((G|0)==(h|0)){ka=ja;break}else N=ja}}else ka=E;if((F|0)==(x|0))break;else E=ka}A=A+1|0}while(ka&(A|0)<(r|0))}while(0);if(e){if((g|0)>0){r=0;do{ka=Y(r,t)|0;da=0.0;E=0;do{ca=+n[a+(E+ka<<2)>>2];da=da+ca*ca;E=E+1|0}while((E|0)!=(g|0));ca=+M(+da);p[s+(r<<3)>>3]=ca;r=r+1|0}while((r|0)!=(h|0))}else g1c(s|0,0,h<<3|0)|0;r=h+-1|0;c:do if((h|0)>1){E=(g|0)>0;if(!d){ka=0;while(1){F=ka;ka=ka+1|0;if((ka|0)<(h|0)){ja=F;ba=ka;while(1){A=+p[s+(ja<<3)>>3]<+p[s+(ba<<3)>>3]?ba:ja;ba=ba+1|0;if((ba|0)==(h|0)){la=A;break}else ja=A}}else la=F;if((F|0)!=(la|0)){ja=s+(F<<3)|0;ba=s+(la<<3)|0;ca=+p[ja>>3];p[ja>>3]=+p[ba>>3];p[ba>>3]=ca}if((ka|0)==(r|0))break c}}else ma=0;do{ka=ma;ma=ma+1|0;if((ma|0)<(h|0)){ba=ka;ja=ma;while(1){A=+p[s+(ba<<3)>>3]<+p[s+(ja<<3)>>3]?ja:ba;ja=ja+1|0;if((ja|0)==(h|0)){na=A;break}else ba=A}}else na=ka;if((ka|0)!=(na|0)){ba=s+(ka<<3)|0;ja=s+(na<<3)|0;da=+p[ba>>3];p[ba>>3]=+p[ja>>3];p[ja>>3]=da;if(E){ja=Y(ka,t)|0;ba=Y(na,t)|0;F=0;do{A=a+(F+ja<<2)|0;x=a+(F+ba<<2)|0;B=f[A>>2]|0;f[A>>2]=f[x>>2];f[x>>2]=B;F=F+1|0}while((F|0)!=(g|0))}F=Y(ka,b)|0;ba=Y(na,b)|0;ja=0;do{B=d+(ja+F<<2)|0;x=d+(ja+ba<<2)|0;A=f[B>>2]|0;f[B>>2]=f[x>>2];f[x>>2]=A;ja=ja+1|0}while((ja|0)!=(h|0))}}while((ma|0)!=(r|0))}while(0);if(e){e=0;do{n[c+(e<<2)>>2]=+p[s+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;da=1.0/+(g|0);ca=-da;ia=k*100.0;e=305419896;c=0;r=0;while(1){if((r|0)<(h|0))oa=+p[s+(r<<3)>>3];else oa=0.0;if(!(oa<=j)){pa=oa;qa=e;ra=c}else{ma=Y(r,t)|0;b=(r|0)>0;na=0;la=e;E=c;while(1){if(d){ja=0;ba=la;F=E;while(1){ka=x1c(ba|0,0,-130063606,0)|0;A=d1c(ka|0,J|0,F|0,0)|0;ka=J;n[a+(ja+ma<<2)>>2]=(A&256|0)!=0|0!=0?da:ca;ja=ja+1|0;if((ja|0)==(g|0)){sa=A;ta=ka;break}else{ba=A;F=ka}}}else{sa=la;ta=E}d:do if(b){if(d){F=0;do{ba=Y(F,t)|0;ja=0;k=0.0;do{k=k+ +n[a+(ja+ma<<2)>>2]*+n[a+(ja+ba<<2)>>2];ja=ja+1|0}while((ja|0)!=(g|0));ua=0.0;va=0;do{ja=a+(va+ma<<2)|0;ha=+n[ja>>2]-k*+n[a+(va+ba<<2)>>2];n[ja>>2]=ha;ua=ua+ +L(+ha);va=va+1|0}while((va|0)!=(g|0));k=ua>ia?1.0/ua:0.0;ba=0;do{ja=a+(ba+ma<<2)|0;n[ja>>2]=k*+n[ja>>2];ba=ba+1|0}while((ba|0)!=(g|0));F=F+1|0}while((F|0)!=(r|0))}else{F=0;do F=F+1|0;while((F|0)!=(r|0))}if(b){if(d)wa=0;else{F=0;while(1){F=F+1|0;if((F|0)==(r|0))break d}}do{F=Y(wa,t)|0;ba=0;k=0.0;do{k=k+ +n[a+(ba+ma<<2)>>2]*+n[a+(ba+F<<2)>>2];ba=ba+1|0}while((ba|0)!=(g|0));xa=0.0;ya=0;do{ba=a+(ya+ma<<2)|0;ha=+n[ba>>2]-k*+n[a+(ya+F<<2)>>2];n[ba>>2]=ha;xa=xa+ +L(+ha);ya=ya+1|0}while((ya|0)!=(g|0));k=xa>ia?1.0/xa:0.0;F=0;do{ba=a+(F+ma<<2)|0;n[ba>>2]=k*+n[ba>>2];F=F+1|0}while((F|0)!=(g|0));wa=wa+1|0}while((wa|0)!=(r|0))}}while(0);if(d){F=0;k=0.0;while(1){ha=+n[a+(F+ma<<2)>>2];Z=k+ha*ha;F=F+1|0;if((F|0)==(g|0)){za=Z;break}else k=Z}}else za=0.0;k=+M(+za);if(!(k<=j)|(na|0)>98){pa=k;qa=sa;ra=ta;break}else{na=na+1|0;la=sa;E=ta}}}k=pa>j?1.0/pa:0.0;if(d){E=Y(r,t)|0;la=0;do{na=a+(la+E<<2)|0;n[na>>2]=k*+n[na>>2];la=la+1|0}while((la|0)!=(g|0))}r=r+1|0;if((r|0)==(i|0))break;else{e=qa;c=ra}}}ra=f[m>>2]|0;if((ra|0)==(o|0)){u=l;return}if(ra|0)dYc(ra);f[m>>2]=o;f[q>>2]=136;u=l;return}function eM(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0;l=u;u=u+1104|0;m=l;n=m+8|0;f[m>>2]=n;o=m+4|0;f[o>>2]=h;if(h>>>0>136){q=bYc(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=q;r=q}else r=n;q=(g|0)>30?g:30;s=b>>>3;b=e>>>3;e=(h|0)>0;a:do if(e){t=(d|0)==0;v=h<<3;if((g|0)<=0)if(t){g1c(r|0,0,v|0)|0;break}else{w=0;while(1){x=Y(b,w)|0;p[r+(w<<3)>>3]=0.0;g1c(d+(x<<3)|0,0,v|0)|0;p[d+(x+w<<3)>>3]=1.0;w=w+1|0;if((w|0)==(h|0))break a}}else y=0;do{w=Y(b,y)|0;x=d+(w<<3)|0;z=Y(y,s)|0;A=0;B=0.0;do{C=+p[a+(A+z<<3)>>3];B=B+C*C;A=A+1|0}while((A|0)!=(g|0));p[r+(y<<3)>>3]=B;if(!t){g1c(x|0,0,v|0)|0;p[d+(w+y<<3)>>3]=1.0}y=y+1|0}while((y|0)!=(h|0))}while(0);b:do if((q|0)>0){y=h+-1|0;v=(h|0)>1;t=(g|0)>0;A=(d|0)==0;z=0;do{if(v){D=0;E=0}else break b;while(1){F=E;E=E+1|0;if((E|0)<(h|0)){G=a+((Y(F,s)|0)<<3)|0;H=r+(F<<3)|0;I=d+((Y(F,b)|0)<<3)|0;F=E;K=D;while(1){N=a+((Y(F,s)|0)<<3)|0;C=+p[H>>3];O=r+(F<<3)|0;P=+p[O>>3];if(t){Q=0.0;R=0;while(1){S=Q+ +p[G+(R<<3)>>3]*+p[N+(R<<3)>>3];R=R+1|0;if((R|0)==(g|0)){T=S;break}else Q=S}}else T=0.0;if(!(+L(+T)<=+M(+(C*P))*k)){Q=T*2.0;S=C-P;U=+L(+Q);V=+L(+S);if(!(U>V))if(S!=S|0.0!=0.0|S==0.0)W=0.0;else{X=U/V;Z=V;_=X*X;$=32}else{X=V/U;Z=U;_=X*X;$=32}if(($|0)==32){$=0;W=Z*+M(+(_+1.0))}if(S<0.0){X=+M(+((W-S)*.5/W));aa=Q/(W*X*2.0);ba=X}else{X=+M(+((S+W)/(W*2.0)));aa=X;ba=Q/(W*X*2.0)}if(t){X=0.0;Q=0.0;R=0;while(1){ca=G+(R<<3)|0;S=+p[ca>>3];da=N+(R<<3)|0;U=+p[da>>3];V=aa*S+ba*U;ea=aa*U-ba*S;p[ca>>3]=V;p[da>>3]=ea;S=X+V*V;V=Q+ea*ea;R=R+1|0;if((R|0)==(g|0)){fa=S;ga=V;break}else{X=S;Q=V}}}else{fa=0.0;ga=0.0}p[H>>3]=fa;p[O>>3]=ga;if(!A?(R=d+((Y(F,b)|0)<<3)|0,e):0){N=0;do{da=I+(N<<3)|0;Q=+p[da>>3];ca=R+(N<<3)|0;X=+p[ca>>3];p[da>>3]=aa*Q+ba*X;p[ca>>3]=aa*X-ba*Q;N=N+1|0}while((N|0)!=(h|0));ha=1}else ha=1}else ha=K;F=F+1|0;if((F|0)==(h|0)){ia=ha;break}else K=ha}}else ia=D;if((E|0)==(y|0))break;else D=ia}z=z+1|0}while(ia&(z|0)<(q|0))}while(0);if(e){if((g|0)>0){q=0;do{ia=Y(q,s)|0;ba=0.0;D=0;do{aa=+p[a+(D+ia<<3)>>3];ba=ba+aa*aa;D=D+1|0}while((D|0)!=(g|0));aa=+M(+ba);p[r+(q<<3)>>3]=aa;q=q+1|0}while((q|0)!=(h|0))}else g1c(r|0,0,h<<3|0)|0;q=h+-1|0;c:do if((h|0)>1){D=(g|0)>0;if(!d){ia=0;while(1){E=ia;ia=ia+1|0;if((ia|0)<(h|0)){ha=E;$=ia;while(1){z=+p[r+(ha<<3)>>3]<+p[r+($<<3)>>3]?$:ha;$=$+1|0;if(($|0)==(h|0)){ja=z;break}else ha=z}}else ja=E;if((E|0)!=(ja|0)){ha=r+(E<<3)|0;$=r+(ja<<3)|0;aa=+p[ha>>3];p[ha>>3]=+p[$>>3];p[$>>3]=aa}if((ia|0)==(q|0))break c}}else ka=0;do{ia=ka;ka=ka+1|0;if((ka|0)<(h|0)){$=ia;ha=ka;while(1){z=+p[r+($<<3)>>3]<+p[r+(ha<<3)>>3]?ha:$;ha=ha+1|0;if((ha|0)==(h|0)){la=z;break}else $=z}}else la=ia;if((ia|0)!=(la|0)){$=r+(ia<<3)|0;ha=r+(la<<3)|0;ba=+p[$>>3];p[$>>3]=+p[ha>>3];p[ha>>3]=ba;if(D){ha=Y(ia,s)|0;$=Y(la,s)|0;E=0;do{z=a+(E+ha<<3)|0;y=a+(E+$<<3)|0;ba=+p[z>>3];p[z>>3]=+p[y>>3];p[y>>3]=ba;E=E+1|0}while((E|0)!=(g|0))}E=Y(ia,b)|0;$=Y(la,b)|0;ha=0;do{y=d+(ha+E<<3)|0;z=d+(ha+$<<3)|0;ba=+p[y>>3];p[y>>3]=+p[z>>3];p[z>>3]=ba;ha=ha+1|0}while((ha|0)!=(h|0))}}while((ka|0)!=(q|0))}while(0);if(e){e=0;do{p[c+(e<<3)>>3]=+p[r+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;ba=1.0/+(g|0);aa=-ba;ga=k*100.0;e=305419896;c=0;q=0;while(1){if((q|0)<(h|0))ma=+p[r+(q<<3)>>3];else ma=0.0;if(!(ma<=j)){na=ma;oa=e;pa=c}else{ka=Y(q,s)|0;b=(q|0)>0;la=0;ja=e;D=c;while(1){if(d){ha=0;$=ja;E=D;while(1){ia=x1c($|0,0,-130063606,0)|0;z=d1c(ia|0,J|0,E|0,0)|0;ia=J;p[a+(ha+ka<<3)>>3]=(z&256|0)!=0|0!=0?ba:aa;ha=ha+1|0;if((ha|0)==(g|0)){qa=z;ra=ia;break}else{$=z;E=ia}}}else{qa=ja;ra=D}d:do if(b){if(d){E=0;do{$=Y(E,s)|0;ha=0;k=0.0;do{k=k+ +p[a+(ha+ka<<3)>>3]*+p[a+(ha+$<<3)>>3];ha=ha+1|0}while((ha|0)!=(g|0));sa=0.0;ta=0;do{ha=a+(ta+ka<<3)|0;fa=+p[ha>>3]-k*+p[a+(ta+$<<3)>>3];p[ha>>3]=fa;sa=sa+ +L(+fa);ta=ta+1|0}while((ta|0)!=(g|0));k=sa>ga?1.0/sa:0.0;$=0;do{ha=a+($+ka<<3)|0;p[ha>>3]=k*+p[ha>>3];$=$+1|0}while(($|0)!=(g|0));E=E+1|0}while((E|0)!=(q|0))}else{E=0;do E=E+1|0;while((E|0)!=(q|0))}if(b){if(d)ua=0;else{E=0;while(1){E=E+1|0;if((E|0)==(q|0))break d}}do{E=Y(ua,s)|0;$=0;k=0.0;do{k=k+ +p[a+($+ka<<3)>>3]*+p[a+($+E<<3)>>3];$=$+1|0}while(($|0)!=(g|0));va=0.0;wa=0;do{$=a+(wa+ka<<3)|0;fa=+p[$>>3]-k*+p[a+(wa+E<<3)>>3];p[$>>3]=fa;va=va+ +L(+fa);wa=wa+1|0}while((wa|0)!=(g|0));k=va>ga?1.0/va:0.0;E=0;do{$=a+(E+ka<<3)|0;p[$>>3]=k*+p[$>>3];E=E+1|0}while((E|0)!=(g|0));ua=ua+1|0}while((ua|0)!=(q|0))}}while(0);if(d){E=0;k=0.0;while(1){fa=+p[a+(E+ka<<3)>>3];W=k+fa*fa;E=E+1|0;if((E|0)==(g|0)){xa=W;break}else k=W}}else xa=0.0;k=+M(+xa);if(!(k<=j)|(la|0)>98){na=k;oa=qa;pa=ra;break}else{la=la+1|0;ja=qa;D=ra}}}k=na>j?1.0/na:0.0;if(d){D=Y(q,s)|0;ja=0;do{la=a+(ja+D<<3)|0;p[la>>3]=k*+p[la>>3];ja=ja+1|0}while((ja|0)!=(g|0))}q=q+1|0;if((q|0)==(i|0))break;else{e=oa;c=pa}}}pa=f[m>>2]|0;if((pa|0)==(n|0)){u=l;return}if(pa|0)dYc(pa);f[m>>2]=n;f[o>>2]=136;u=l;return}function fM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0,S=0.0;c=u;u=u+1168|0;d=c+1112|0;e=c+72|0;g=c+16|0;h=c;do if((eS(a)|0)==65536){i=f[a+4>>2]|0;f[d>>2]=f[i>>2];j=d+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=d+8|0;f[l>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];m=d+16|0;f[m>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];f[d+28>>2]=f[i+28>>2];f[d+32>>2]=f[i+32>>2];o=f[i+36>>2]|0;f[d+36>>2]=o;f[d+40>>2]=l;q=d+48|0;r=d+44|0;f[r>>2]=q;f[q>>2]=0;f[d+52>>2]=0;if(o|0){s=o+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;s=f[r>>2]|0;f[s>>2]=f[k>>2];f[s+4>>2]=f[k+4>>2];t=l;v=q;w=m;x=r;y=d;break}else{f[j>>2]=0;U$(d,i);t=l;v=q;w=m;x=r;y=d;break}}else{bS(d,a,-1);t=d+8|0;v=d+48|0;w=d+16|0;x=d+44|0;y=d}while(0);a=f[y>>2]&4095;y=f[t>>2]|0;t=f[v>>2]|0;r=f[w>>2]|0;if(!r){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=$Xc(16)|0;f[e>>2]=z;A=e+8|0;f[A>>2]=-2147483632;B=e+4|0;f[B>>2]=12;C=z;D=461919;E=C+12|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+12|0;b[F>>0]=0;vM(-215,e,218807,218819,777)}m=d+4|0;q=f[m>>2]|0;if((q|0)<3)G=Y(f[d+12>>2]|0,y)|0;else{l=f[d+40>>2]|0;i=0;j=1;while(1){k=Y(f[l+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(q|0)){G=k;break}else j=k}}if((q|0)==0|(G|0)==0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=$Xc(16)|0;f[e>>2]=z;A=e+8|0;f[A>>2]=-2147483632;B=e+4|0;f[B>>2]=12;C=z;D=461919;E=C+12|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+12|0;b[F>>0]=0;vM(-215,e,218807,218819,777)}if(!((a+-5|0)>>>0<2?(y|0)==(f[d+12>>2]|0):0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;F=$Xc(64)|0;f[e>>2]=F;f[e+8>>2]=-2147483584;f[e+4>>2]=58;C=F;D=218887;E=C+58|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[F+58>>0]=0;vM(-215,e,218807,218819,778)}F=(y|0)==2;a:do if((a|0)==5){if(F){D=r+t|0;H=+n[r>>2]*+n[D+4>>2]-+n[r+4>>2]*+n[D>>2];break}switch(y|0){case 3:{D=r+t|0;I=+n[D+4>>2];C=r+(t<<1)|0;J=+n[C+8>>2];K=+n[D+8>>2];L=+n[C+4>>2];M=+n[D>>2];N=+n[C>>2];H=+n[r+8>>2]*(L*M-I*N)+(+n[r>>2]*(I*J-K*L)-+n[r+4>>2]*(J*M-K*N));break a;break}case 1:{H=+n[r>>2];break a;break}default:{C=(Y(y,y)|0)<<2;D=e+8|0;f[e>>2]=D;E=e+4|0;f[E>>2]=C;if(C>>>0>1032){z=bYc(C)|0;f[e>>2]=z;O=z}else O=D;f[g>>2]=1124007941;z=g+4|0;f[z>>2]=2;C=g+8|0;f[C>>2]=y;f[g+12>>2]=y;B=g+16|0;f[B>>2]=O;f[g+20>>2]=O;A=g+24|0;G=g+40|0;q=A+8|0;f[q>>2]=0;f[q+4>>2]=0;f[G>>2]=C;C=g+48|0;q=g+44|0;f[q>>2]=C;j=y<<2;f[C>>2]=j;f[g+52>>2]=4;i=O+(Y(j,y)|0)|0;f[g+28>>2]=i;f[A>>2]=i+(0-j)+j;R$(g);j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;jR(d,h);j=AP(f[B>>2]|0,f[C>>2]|0,y,0,0,0)|0;N=+(j|0);if((j|0)!=0&(y|0)>0){j=f[B>>2]|0;i=f[f[q>>2]>>2]|0;K=N;A=0;while(1){l=j+(Y(i,A)|0)+(A<<2)|0;M=K*+n[l>>2];A=A+1|0;if((A|0)==(y|0)){P=M;break}else K=M}}else P=N;A=g+36|0;i=f[A>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)V$(g);f[A>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[z>>2]|0)>0){A=f[G>>2]|0;i=0;do{f[A+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[z>>2]|0))}z=f[q>>2]|0;if((z|0)!=(C|0))wL(z);z=f[e>>2]|0;if((z|0)!=(D|0)){if(z|0)dYc(z);f[e>>2]=D;f[E>>2]=1032}H=P;break a}}}else{if(F){z=r+t|0;H=+p[r>>3]*+p[z+8>>3]-+p[r+8>>3]*+p[z>>3];break}switch(y|0){case 3:{z=r+t|0;N=+p[z+8>>3];i=r+(t<<1)|0;K=+p[i+16>>3];M=+p[z+16>>3];J=+p[i+8>>3];L=+p[z>>3];I=+p[i>>3];H=+p[r+16>>3]*(J*L-N*I)+(+p[r>>3]*(N*K-M*J)-+p[r+8>>3]*(K*L-M*I));break a;break}case 1:{H=+p[r>>3];break a;break}default:{i=(Y(y,y)|0)<<3;z=e+8|0;f[e>>2]=z;A=e+4|0;f[A>>2]=i;if(i>>>0>1032){G=bYc(i)|0;f[e>>2]=G;Q=G}else Q=z;f[g>>2]=1124007942;G=g+4|0;f[G>>2]=2;i=g+8|0;f[i>>2]=y;f[g+12>>2]=y;B=g+16|0;f[B>>2]=Q;f[g+20>>2]=Q;j=g+24|0;l=g+40|0;k=j+8|0;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=i;i=g+48|0;k=g+44|0;f[k>>2]=i;s=y<<3;f[i>>2]=s;f[g+52>>2]=8;o=Q+(Y(s,y)|0)|0;f[g+28>>2]=o;f[j>>2]=o+(0-s)+s;R$(g);s=h+8|0;f[s>>2]=0;f[s+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;jR(d,h);s=CP(f[B>>2]|0,f[i>>2]|0,y,0,0,0)|0;I=+(s|0);if((s|0)!=0&(y|0)>0){s=f[B>>2]|0;o=f[f[k>>2]>>2]|0;j=0;M=I;while(1){R=s+(Y(o,j)|0)+(j<<3)|0;L=M*+p[R>>3];j=j+1|0;if((j|0)==(y|0)){S=L;break}else M=L}}else S=I;j=g+36|0;o=f[j>>2]|0;if(o|0?(s=o+12|0,o=f[s>>2]|0,f[s>>2]=o+-1,(o|0)==1):0)V$(g);f[j>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[G>>2]|0)>0){j=f[l>>2]|0;o=0;do{f[j+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[G>>2]|0))}G=f[k>>2]|0;if((G|0)!=(i|0))wL(G);G=f[e>>2]|0;if((G|0)!=(z|0)){if(G|0)dYc(G);f[e>>2]=z;f[A>>2]=1032}H=S;break a}}}while(0);e=d+36|0;g=f[e>>2]|0;if(g|0?(y=g+12|0,g=f[y>>2]|0,f[y>>2]=g+-1,(g|0)==1):0)V$(d);f[e>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){w=f[d+40>>2]|0;d=0;do{f[w+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[m>>2]|0))}m=f[x>>2]|0;if((m|0)==(v|0)){u=c;return +H}wL(m);u=c;return +H}function gM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0;e=u;u=u+2384|0;g=e+2328|0;h=e+1288|0;i=e+88|0;j=e+1232|0;k=e+32|0;l=e;m=e+1216|0;o=e+1200|0;q=e+1184|0;r=e+1128|0;do if((eS(a)|0)==65536){s=f[a+4>>2]|0;f[g>>2]=f[s>>2];t=g+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=g+8|0;f[w>>2]=f[s+8>>2];f[g+12>>2]=f[s+12>>2];f[g+16>>2]=f[s+16>>2];f[g+20>>2]=f[s+20>>2];f[g+24>>2]=f[s+24>>2];f[g+28>>2]=f[s+28>>2];f[g+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[g+36>>2]=x;f[g+40>>2]=w;w=g+48|0;y=g+44|0;f[y>>2]=w;f[w>>2]=0;f[g+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];z=g;break}else{f[t>>2]=0;U$(g,s);z=g;break}}else{bS(g,a,-1);z=g}while(0);a=f[z>>2]|0;z=a&4095;s=(z|0)==5;t=(z|0)==6;if((z+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=32;A=v;B=218946;C=A+32|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[v+32>>0]=0;vM(-215,h,218979,218819,853)}v=Y(675553809>>>(z<<2&28)&15,(a>>>3&511)+1|0)|0;a=f[g+8>>2]|0;w=f[g+12>>2]|0;do if((d|0)==1){y=(w|0)<(a|0)?w:a;x=Y(y,a)|0;D=(Y(x+y+(Y(y,w)|0)|0,v)|0)+8|0;E=h+8|0;f[h>>2]=E;F=h+4|0;f[F>>2]=D;if(D>>>0>1032){G=bYc(D)|0;f[h>>2]=G;H=G}else H=E;Tj(i,a,y,z,v+-1+H&0-v,0);G=i+16|0;D=i+44|0;Tj(j,y,1,z,(f[G>>2]|0)+(Y(x,v)|0)|0,0);x=j+16|0;I=j+44|0;Tj(k,y,w,z,(f[x>>2]|0)+(Y(y,v)|0)|0,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;y=m+8|0;f[y>>2]=0;f[y+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;y=o+8|0;f[y>>2]=0;f[y+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;y=q+8|0;f[y>>2]=0;f[y+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=k;hM(l,m,o,q,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[r>>2]=1124007936;y=r+4|0;J=r+8|0;K=r+40|0;A=y;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[K>>2]=J;L=r+48|0;M=r+44|0;f[M>>2]=L;f[L>>2]=0;f[r+52>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=r;iM(l,m,o,q,c);N=r+36|0;O=f[N>>2]|0;if(O|0?(P=O+12|0,O=f[P>>2]|0,f[P>>2]=O+-1,(O|0)==1):0)V$(r);f[N>>2]=0;N=r+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[y>>2]|0)>0){N=f[K>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[y>>2]|0))}y=f[M>>2]|0;if((y|0)!=(L|0))wL(y);y=f[x>>2]|0;if(s){Q=+n[y>>2];if(!(Q>=1.1920928955078125e-07))R=0.0;else R=+n[y+(w+-1<<2)>>2]/Q}else{Q=+p[y>>3];if(!(Q>=2.220446049250313e-16))R=0.0;else R=+p[y+(w+-1<<3)>>3]/Q}y=k+36|0;O=f[y>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)V$(k);f[y>>2]=0;y=k+16|0;O=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[O>>2]|0)>0){y=f[k+40>>2]|0;N=0;do{f[y+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[k+44>>2]|0;if((O|0)!=(k+48|0))wL(O);O=j+36|0;N=f[O>>2]|0;if(N|0?(y=N+12|0,N=f[y>>2]|0,f[y>>2]=N+-1,(N|0)==1):0)V$(j);f[O>>2]=0;O=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[O>>2]|0)>0){N=f[j+40>>2]|0;y=0;do{f[N+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[O>>2]|0))}O=f[I>>2]|0;if((O|0)!=(j+48|0))wL(O);O=i+36|0;y=f[O>>2]|0;if(y|0?(N=y+12|0,y=f[N>>2]|0,f[N>>2]=y+-1,(y|0)==1):0)V$(i);f[O>>2]=0;O=i+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[O>>2]|0)>0){y=f[i+40>>2]|0;N=0;do{f[y+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[D>>2]|0;if((O|0)!=(i+48|0))wL(O);O=f[h>>2]|0;if((O|0)!=(E|0)){if(O|0)dYc(O);f[h>>2]=E;f[F>>2]=1032}S=R}else{if((a|0)!=(w|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=6;b[h>>0]=b[218986]|0;b[h+1>>0]=b[218987]|0;b[h+2>>0]=b[218988]|0;b[h+3>>0]=b[218989]|0;b[h+4>>0]=b[218990]|0;b[h+5>>0]=b[218991]|0;b[h+6>>0]=0;vM(-215,h,218979,218819,877)}if((d|0)==2){O=Y(a,a)|0;N=(Y((O<<1)+a|0,v)|0)+8|0;y=h+8|0;f[h>>2]=y;G=h+4|0;f[G>>2]=N;if(N>>>0>1032){I=bYc(N)|0;f[h>>2]=I;T=I}else T=y;Tj(i,a,a,z,v+-1+T&0-v,0);I=i+16|0;N=i+44|0;Tj(j,a,1,z,(f[I>>2]|0)+(Y(O,v)|0)|0,0);O=j+16|0;x=j+44|0;Tj(k,a,a,z,(f[O>>2]|0)+(Y(a,v)|0)|0,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;L=m+8|0;f[L>>2]=0;f[L+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;L=o+8|0;f[L>>2]=0;f[L+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;jM(l,m,o)|0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;L=m+8|0;f[L>>2]=0;f[L+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=i;AV(l,m);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[r>>2]=1124007936;L=r+4|0;M=r+8|0;K=r+40|0;A=L;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[K>>2]=M;F=r+48|0;E=r+44|0;f[E>>2]=F;f[F>>2]=0;f[r+52>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=r;iM(l,m,o,q,c);D=r+36|0;J=f[D>>2]|0;if(J|0?(P=J+12|0,J=f[P>>2]|0,f[P>>2]=J+-1,(J|0)==1):0)V$(r);f[D>>2]=0;D=r+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[L>>2]|0)>0){D=f[K>>2]|0;J=0;do{f[D+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[L>>2]|0))}L=f[E>>2]|0;if((L|0)!=(F|0))wL(L);L=f[O>>2]|0;if(s){Q=+n[L>>2];if(!(Q>=1.1920928955078125e-07))U=0.0;else U=+n[L+(a+-1<<2)>>2]/Q}else{Q=+p[L>>3];if(!(Q>=2.220446049250313e-16))U=0.0;else U=+p[L+(a+-1<<3)>>3]/Q}L=k+36|0;J=f[L>>2]|0;if(J|0?(D=J+12|0,J=f[D>>2]|0,f[D>>2]=J+-1,(J|0)==1):0)V$(k);f[L>>2]=0;L=k+16|0;J=k+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[J>>2]|0)>0){L=f[k+40>>2]|0;D=0;do{f[L+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[J>>2]|0))}J=f[k+44>>2]|0;if((J|0)!=(k+48|0))wL(J);J=j+36|0;D=f[J>>2]|0;if(D|0?(L=D+12|0,D=f[L>>2]|0,f[L>>2]=D+-1,(D|0)==1):0)V$(j);f[J>>2]=0;J=j+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[J>>2]|0)>0){D=f[j+40>>2]|0;L=0;do{f[D+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[J>>2]|0))}J=f[x>>2]|0;if((J|0)!=(j+48|0))wL(J);J=i+36|0;L=f[J>>2]|0;do if(L|0){D=L+12|0;O=f[D>>2]|0;f[D>>2]=O+-1;if((O|0)!=1)break;V$(i)}while(0);f[J>>2]=0;L=i+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[L>>2]|0)>0){x=f[i+40>>2]|0;O=0;do{f[x+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[N>>2]|0;if((L|0)!=(i+48|0))wL(L);L=f[h>>2]|0;if((L|0)!=(y|0)){if(L|0)dYc(L);f[h>>2]=y;f[G>>2]=1032}S=U;break}L=(d|0)==0;O=(d|0)==3;switch(d|0){case 0:case 3:break;default:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(64)|0;f[h>>2]=x;f[h+8>>2]=-2147483584;f[h+4>>2]=48;A=x;B=218993;C=A+48|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[x+48>>0]=0;vM(-215,h,218979,218819,897)}}ZS(c,a,a,z,-1,0,0);do if((eS(c)|0)==65536){G=f[c+4>>2]|0;f[h>>2]=f[G>>2];y=h+4|0;N=G+4|0;f[y>>2]=f[N>>2];I=h+8|0;f[I>>2]=f[G+8>>2];f[h+12>>2]=f[G+12>>2];f[h+16>>2]=f[G+16>>2];f[h+20>>2]=f[G+20>>2];f[h+24>>2]=f[G+24>>2];f[h+28>>2]=f[G+28>>2];f[h+32>>2]=f[G+32>>2];J=f[G+36>>2]|0;f[h+36>>2]=J;f[h+40>>2]=I;I=h+48|0;D=h+44|0;f[D>>2]=I;f[I>>2]=0;f[h+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[N>>2]|0)<3){N=f[G+44>>2]|0;I=f[D>>2]|0;f[I>>2]=f[N>>2];f[I+4>>2]=f[N+4>>2];break}else{f[y>>2]=0;U$(h,G);break}}else bS(h,c,-1);while(0);a:do if((a|0)<4){x=f[g+16>>2]|0;G=f[h+16>>2]|0;y=f[g+48>>2]|0;N=f[h+48>>2]|0;b:do switch(a|0){case 2:{if(s){Q=+n[x>>2];I=x+y|0;V=+n[I+4>>2];D=x+4|0;W=Q*V-+n[D>>2]*+n[I>>2];if(!(W!=0.0))break b;X=1.0/W;J=G+N|0;n[J+4>>2]=Q*X;n[G>>2]=V*X;V=X*-+n[I>>2];n[G+4>>2]=X*-+n[D>>2];n[J>>2]=V;Z=1;break a}else{V=+p[x>>3];J=x+y|0;X=+p[J+8>>3];D=x+8|0;Q=V*X-+p[D>>3]*+p[J>>3];if(!(Q!=0.0))break b;W=1.0/Q;I=G+N|0;p[I+8>>3]=V*W;p[G>>3]=X*W;X=-(W*+p[J>>3]);p[G+8>>3]=-(W*+p[D>>3]);p[I>>3]=X;Z=1;break a}break}case 3:{I=y<<1;if(s){X=+n[x>>2];D=x+y|0;W=+n[D+4>>2];J=x+I|0;V=+n[J+8>>2];Q=+n[D+8>>2];_=+n[J+4>>2];$=W*V-Q*_;aa=+n[x+4>>2];ba=+n[D>>2];ca=V*ba;da=+n[J>>2];ea=Q*da;fa=+n[x+8>>2];ga=_*ba-W*da;ha=fa*ga+(X*$-aa*(ca-ea));if(!(ha!=0.0))break b;ia=1.0/ha;n[G>>2]=$*ia;n[G+4>>2]=(_*fa-V*aa)*ia;n[G+8>>2]=(Q*aa-W*fa)*ia;J=G+N|0;n[J>>2]=(ea-ca)*ia;n[J+4>>2]=(X*V-da*fa)*ia;n[J+8>>2]=(ba*fa-X*Q)*ia;J=G+(N<<1)|0;n[J>>2]=ga*ia;n[J+4>>2]=(aa*da-X*_)*ia;n[J+8>>2]=(X*W-aa*ba)*ia;Z=1;break a}else{ia=+p[x>>3];J=x+y|0;ba=+p[J+8>>3];D=x+I|0;aa=+p[D+16>>3];W=+p[J+16>>3];X=+p[D+8>>3];_=ba*aa-W*X;da=+p[x+8>>3];ga=+p[J>>3];Q=aa*ga;fa=+p[D>>3];V=W*fa;ca=+p[x+16>>3];ea=X*ga-ba*fa;$=ca*ea+(ia*_-da*(Q-V));if(!($!=0.0))break b;ha=1.0/$;p[G>>3]=_*ha;p[G+8>>3]=(X*ca-aa*da)*ha;p[G+16>>3]=(W*da-ba*ca)*ha;D=G+N|0;p[D>>3]=(V-Q)*ha;p[D+8>>3]=(ia*aa-fa*ca)*ha;p[D+16>>3]=(ga*ca-ia*W)*ha;D=G+(N<<1)|0;p[D>>3]=ea*ha;p[D+8>>3]=(da*fa-ia*X)*ha;p[D+16>>3]=(ia*ba-da*ga)*ha;Z=1;break a}break}default:if(s){ha=+n[x>>2];if(!(ha!=0.0))break b;n[G>>2]=1.0/ha;Z=1;break a}else{ha=+p[x>>3];if(!(ha!=0.0))break b;p[G>>3]=1.0/ha;Z=1;break a}}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;lR(h,i)|0;Z=0}else{G=Y(Y(a,v)|0,a)|0;x=i+8|0;f[i>>2]=x;N=i+4|0;f[N>>2]=G;if(G>>>0>1032){y=bYc(G)|0;f[i>>2]=y;ja=y}else ja=x;Tj(j,a,a,z,ja,0);y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;jR(g,k);y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=h;p[l>>3]=1.0;y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;yV(k,l);do if(L&s)if(!(AP(f[j+16>>2]|0,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0))ka=139;else la=1;else{if(L&t)if(!(CP(f[j+16>>2]|0,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0)){ka=139;break}else{la=1;break}y=f[j+16>>2]|0;if(O&s)ma=EP(y,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0;else ma=GP(y,f[j+48>>2]|0,a,f[h+16>>2]|0,f[h+48>>2]|0,a)|0;if(ma)la=1;else ka=139}while(0);if((ka|0)==139){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;lR(h,k)|0;la=0}y=j+36|0;G=f[y>>2]|0;if(G|0?(D=G+12|0,G=f[D>>2]|0,f[D>>2]=G+-1,(G|0)==1):0)V$(j);f[y>>2]=0;y=j+16|0;G=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[G>>2]|0)>0){y=f[j+40>>2]|0;D=0;do{f[y+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[G>>2]|0))}G=f[j+44>>2]|0;if((G|0)!=(j+48|0))wL(G);G=f[i>>2]|0;if((G|0)!=(x|0)){if(G|0)dYc(G);f[i>>2]=x;f[N>>2]=1032}Z=la}while(0);ha=+(Z&1);O=h+36|0;L=f[O>>2]|0;if(L|0?(G=L+12|0,L=f[G>>2]|0,f[G>>2]=L+-1,(L|0)==1):0)V$(h);f[O>>2]=0;O=h+16|0;L=h+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[L>>2]|0)>0){O=f[h+40>>2]|0;G=0;do{f[O+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[L>>2]|0))}L=f[h+44>>2]|0;if((L|0)!=(h+48|0))wL(L);S=ha}while(0);h=g+36|0;Z=f[h>>2]|0;if(Z|0?(la=Z+12|0,Z=f[la>>2]|0,f[la>>2]=Z+-1,(Z|0)==1):0)V$(g);f[h>>2]=0;h=g+16|0;Z=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[Z>>2]|0)>0){h=f[g+40>>2]|0;la=0;do{f[h+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Z>>2]|0))}Z=f[g+44>>2]|0;if((Z|0)==(g+48|0)){u=e;return +S}wL(Z);u=e;return +S}function hM(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+1392|0;i=h+1336|0;j=h+296|0;k=h+240|0;l=h+184|0;m=h+128|0;n=h+72|0;o=h;p=h+56|0;do if((eS(a)|0)==65536){q=f[a+4>>2]|0;f[i>>2]=f[q>>2];r=i+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=i+8|0;f[t>>2]=f[q+8>>2];v=i+12|0;f[v>>2]=f[q+12>>2];f[i+16>>2]=f[q+16>>2];f[i+20>>2]=f[q+20>>2];f[i+24>>2]=f[q+24>>2];f[i+28>>2]=f[q+28>>2];f[i+32>>2]=f[q+32>>2];w=f[q+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=t;x=i+48|0;y=i+44|0;f[y>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(w|0){x=w+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;x=f[y>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];z=v;A=i;B=t;break}else{f[r>>2]=0;U$(i,q);z=v;A=i;B=t;break}}else{bS(i,a,-1);z=i+12|0;A=i;B=i+8|0}while(0);a=f[B>>2]|0;B=f[z>>2]|0;z=f[A>>2]&4095;if(aT(d)|0)C=1;else C=aT(e)|0;A=(z|0)==5;if((z+-5|0)>>>0>=2){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=$Xc(48)|0;f[j>>2]=t;f[j+8>>2]=-2147483600;f[j+4>>2]=32;D=t;v=218946;E=D+32|0;do{b[D>>0]=b[v>>0]|0;D=D+1|0;v=v+1|0}while((D|0)<(E|0));b[t+32>>0]=0;vM(-215,j,219334,218819,1462)}if(!(g&2)){t=(a|0)<(B|0);v=t?B:a;q=t?a:B;F=C;G=q;H=v;I=t;J=g&4|0?v:q}else{vS(d);vS(e);q=(a|0)<(B|0);v=q?a:B;F=0;G=v;H=q?B:a;I=q;J=v}v=i+4|0;q=f[v>>2]|0;if((q|0)>0)K=f[(f[i+44>>2]|0)+(q+-1<<2)>>2]|0;else K=0;q=(Y(K,H)|0)+15&-16;a=Y(K,G)|0;K=a+15&-16;B=Y(q,J)|0;g=a+32+(Y(K,G)|0)+B|0;t=j+8|0;f[j>>2]=t;C=j+4|0;f[C>>2]=g;if(g>>>0>1032){r=bYc(g)|0;f[j>>2]=r;L=r}else L=t;r=L+15&-16;Tj(k,G,H,z,r,q);L=r+B|0;Tj(l,G,1,z,L,0);Tj(m,J,H,z,r,q);f[n>>2]=1124007936;q=n+4|0;r=n+8|0;B=n+40|0;D=q;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[B>>2]=r;D=n+48|0;E=n+44|0;f[E>>2]=D;f[D>>2]=0;f[n+52>>2]=0;if(F){Tj(o,G,G,z,L+a+15&-16,K);K=n+36|0;a=f[K>>2]|0;if(a|0?(L=a+12|0,a=f[L>>2]|0,f[L>>2]=a+-1,(a|0)==1):0)V$(n);f[K>>2]=0;a=n+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){L=f[B>>2]|0;z=0;do{f[L+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[q>>2]|0))}f[n>>2]=f[o>>2];z=o+4|0;L=f[z>>2]|0;f[q>>2]=L;g=o+8|0;f[r>>2]=f[g>>2];f[n+12>>2]=f[o+12>>2];s=o+16|0;f[a>>2]=f[s>>2];f[n+20>>2]=f[o+20>>2];f[n+24>>2]=f[o+24>>2];f[n+28>>2]=f[o+28>>2];f[n+32>>2]=f[o+32>>2];a=o+36|0;f[K>>2]=f[a>>2];K=n+44|0;x=f[K>>2]|0;if((x|0)==(D|0))M=L;else{wL(x);f[K>>2]=D;f[B>>2]=r;M=f[z>>2]|0}r=o+44|0;if((M|0)<3){M=f[r>>2]|0;f[D>>2]=f[M>>2];f[n+52>>2]=f[M+4>>2];N=M}else{f[K>>2]=f[r>>2];K=o+40|0;f[n+40>>2]=f[K>>2];M=o+48|0;f[r>>2]=M;f[K>>2]=g;N=M}f[o>>2]=1124007936;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[a>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((N|0)!=(o+48|0))wL(N)}if((J|0)>(G|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;lR(m,o)|0}if(I){N=o+8|0;f[N>>2]=0;f[N+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;jR(i,o)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=i;N=p+8|0;f[N>>2]=0;f[N+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=k;AV(o,p)}p=k+16|0;N=f[p>>2]|0;if(A){A=f[n+16>>2]|0;s=F?J:0;dM(N,f[m+48>>2]|0,f[l+16>>2]|0,A,f[D>>2]|0,H,G,(A|0)==0?0:(s|0)<0?G:s,1.1754943508222875e-38,2.384185791015625e-07)}else{s=f[n+16>>2]|0;A=F?J:0;eM(N,f[m+48>>2]|0,f[l+16>>2]|0,s,f[D>>2]|0,H,G,(s|0)==0?0:(A|0)<0?G:A,2.2250738585072014e-308,2.220446049250313e-15)}jR(l,c);do if(F){c=aT(d)|0;if(I){if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=n;AV(o,d)}if(!(aT(e)|0))break;jR(m,e);break}else{if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=m;AV(o,d)}if(!(aT(e)|0))break;jR(n,e);break}}while(0);e=n+36|0;d=f[e>>2]|0;if(d|0?(o=d+12|0,d=f[o>>2]|0,f[o>>2]=d+-1,(d|0)==1):0)V$(n);f[e>>2]=0;e=n+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){e=f[B>>2]|0;B=0;do{f[e+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[q>>2]|0))}q=f[E>>2]|0;if((q|0)!=(D|0))wL(q);q=m+36|0;D=f[q>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)V$(m);f[q>>2]=0;q=m+16|0;D=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[D>>2]|0)>0){q=f[m+40>>2]|0;E=0;do{f[q+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[D>>2]|0))}D=f[m+44>>2]|0;if((D|0)!=(m+48|0))wL(D);D=l+36|0;m=f[D>>2]|0;if(m|0?(E=m+12|0,m=f[E>>2]|0,f[E>>2]=m+-1,(m|0)==1):0)V$(l);f[D>>2]=0;D=l+16|0;m=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){D=f[l+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))wL(m);m=k+36|0;l=f[m>>2]|0;do if(l|0){E=l+12|0;D=f[E>>2]|0;f[E>>2]=D+-1;if((D|0)!=1)break;V$(k)}while(0);f[m>>2]=0;m=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[k+40>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))wL(m);m=f[j>>2]|0;if((m|0)!=(t|0)){if(m|0)dYc(m);f[j>>2]=t;f[C>>2]=1032}C=i+36|0;t=f[C>>2]|0;do if(t|0){j=t+12|0;m=f[j>>2]|0;f[j>>2]=m+-1;if((m|0)!=1)break;V$(i)}while(0);f[C>>2]=0;C=i+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[i+40>>2]|0;t=0;do{f[C+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[i+44>>2]|0;if((v|0)==(i+48|0)){u=h;return}wL(v);u=h;return}function iM(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=u;u=u+1344|0;i=h+1280|0;j=h+1224|0;k=h+1168|0;l=h+1112|0;m=h+72|0;n=h+16|0;o=h;do if((eS(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;U$(i,p);break}}else bS(i,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;v=j+44|0;f[v>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(j,a);break}}else bS(j,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[k>>2]=f[c>>2];a=k+4|0;p=c+4|0;f[a>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];r=f[c+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;v=k+44|0;f[v>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[c+44>>2]|0;q=f[v>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[a>>2]=0;U$(k,c);break}}else bS(k,d,-1);while(0);do if((eS(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];c=l+4|0;a=d+4|0;f[c>>2]=f[a>>2];p=l+8|0;f[p>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;v=l+44|0;f[v>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;p=f[v>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;U$(l,d);break}}else bS(l,e,-1);while(0);e=f[i>>2]|0;d=e&4095;c=i+4|0;a=f[c>>2]|0;if((a|0)>0)w=f[(f[i+44>>2]|0)+(a+-1<<2)>>2]|0;else w=0;a=f[j+8>>2]|0;p=f[k+12>>2]|0;v=l+16|0;q=f[v>>2]|0;r=q|0?f[l+12>>2]|0:a;s=(p|0)<(a|0)?p:a;if((f[i+8>>2]|0)==1)x=w;else x=((f[i+12>>2]|0)==1?0:w)+(f[i+48>>2]|0)|0;w=(r<<3)+16|0;t=m+8|0;f[m>>2]=t;y=m+4|0;f[y>>2]=w;if(w>>>0>1032){z=bYc(w)|0;f[m>>2]=z}if((d|0)!=(f[j>>2]&4095|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;A=$Xc(80)|0;f[n>>2]=A;B=n+8|0;f[B>>2]=-2147483568;C=n+4|0;f[C>>2]=76;D=A;E=219069;F=D+76|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));G=A+76|0;b[G>>0]=0;vM(-215,n,219146,218819,1550)}if((d|0)!=(f[k>>2]&4095|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;A=$Xc(80)|0;f[n>>2]=A;B=n+8|0;f[B>>2]=-2147483568;C=n+4|0;f[C>>2]=76;D=A;E=219069;F=D+76|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));G=A+76|0;b[G>>0]=0;vM(-215,n,219146,218819,1550)}z=j+16|0;if(!(f[z>>2]|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;A=$Xc(80)|0;f[n>>2]=A;B=n+8|0;f[B>>2]=-2147483568;C=n+4|0;f[C>>2]=76;D=A;E=219069;F=D+76|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));G=A+76|0;b[G>>0]=0;vM(-215,n,219146,218819,1550)}w=k+16|0;if(!(f[w>>2]|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;A=$Xc(80)|0;f[n>>2]=A;B=n+8|0;f[B>>2]=-2147483568;C=n+4|0;f[C>>2]=76;D=A;E=219069;F=D+76|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));G=A+76|0;b[G>>0]=0;vM(-215,n,219146,218819,1550)}H=i+16|0;if(!(f[H>>2]|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;A=$Xc(80)|0;f[n>>2]=A;B=n+8|0;f[B>>2]=-2147483568;C=n+4|0;f[C>>2]=76;D=A;E=219069;F=D+76|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));G=A+76|0;b[G>>0]=0;vM(-215,n,219146,218819,1550)}G=f[j+12>>2]|0;if((G|0)<(s|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;I=$Xc(128)|0;f[n>>2]=I;J=n+8|0;f[J>>2]=-2147483520;K=n+4|0;f[K>>2]=122;D=I;E=219156;F=D+122|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));L=I+122|0;b[L>>0]=0;vM(-215,n,219146,218819,1552)}A=f[k+8>>2]|0;if((A|0)<(s|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;I=$Xc(128)|0;f[n>>2]=I;J=n+8|0;f[J>>2]=-2147483520;K=n+4|0;f[K>>2]=122;D=I;E=219156;F=D+122|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));L=I+122|0;b[L>>0]=0;vM(-215,n,219146,218819,1552)}C=i+40|0;B=f[C>>2]|0;M=f[B+4>>2]|0;N=f[B>>2]|0;if((!((M|0)==(s|0)&(N|0)==1)?!((M|0)==1&(N|0)==(s|0)):0)?!((M|0)==(A|0)&(N|0)==(G|0)):0){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;I=$Xc(128)|0;f[n>>2]=I;J=n+8|0;f[J>>2]=-2147483520;K=n+4|0;f[K>>2]=122;D=I;E=219156;F=D+122|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));L=I+122|0;b[L>>0]=0;vM(-215,n,219146,218819,1552)}if(q|0){if((f[l>>2]&4095|0)!=(d|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;O=$Xc(64)|0;f[n>>2]=O;P=n+8|0;f[P>>2]=-2147483584;Q=n+4|0;f[Q>>2]=54;D=O;E=219279;F=D+54|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));R=O+54|0;b[R>>0]=0;vM(-215,n,219146,218819,1553)}if((f[l+8>>2]|0)!=(a|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;O=$Xc(64)|0;f[n>>2]=O;P=n+8|0;f[P>>2]=-2147483584;Q=n+4|0;f[Q>>2]=54;D=O;E=219279;F=D+54|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));R=O+54|0;b[R>>0]=0;vM(-215,n,219146,218819,1553)}}ZS(g,p,r,d,-1,0,0);do if((eS(g)|0)==65536){d=f[g+4>>2]|0;f[n>>2]=f[d>>2];R=n+4|0;O=d+4|0;f[R>>2]=f[O>>2];E=n+8|0;f[E>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];D=f[d+36>>2]|0;f[n+36>>2]=D;f[n+40>>2]=E;E=n+48|0;F=n+44|0;f[F>>2]=E;f[E>>2]=0;f[n+52>>2]=0;if(D|0){E=D+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[O>>2]|0)<3){O=f[d+44>>2]|0;E=f[F>>2]|0;f[E>>2]=f[O>>2];f[E+4>>2]=f[O+4>>2];break}else{f[R>>2]=0;U$(n,d);break}}else bS(n,g,-1);while(0);switch(e&4095){case 5:{mM(a,p,f[H>>2]|0,x,f[z>>2]|0,f[j+48>>2]|0,0,f[w>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,r,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}case 6:{nM(a,p,f[H>>2]|0,x,f[z>>2]|0,f[j+48>>2]|0,0,f[w>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,r,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}default:{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;vM(-210,o,219146,218819,1566)}}o=n+36|0;r=f[o>>2]|0;if(r|0?(x=r+12|0,r=f[x>>2]|0,f[x>>2]=r+-1,(r|0)==1):0)V$(n);f[o>>2]=0;o=n+16|0;r=n+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[r>>2]|0)>0){o=f[n+40>>2]|0;x=0;do{f[o+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[r>>2]|0))}r=f[n+44>>2]|0;if((r|0)!=(n+48|0))wL(r);r=f[m>>2]|0;if((r|0)!=(t|0)){if(r|0)dYc(r);f[m>>2]=t;f[y>>2]=1032}y=l+36|0;t=f[y>>2]|0;do if(t|0){m=t+12|0;r=f[m>>2]|0;f[m>>2]=r+-1;if((r|0)!=1)break;V$(l)}while(0);f[y>>2]=0;y=l+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[y>>2]|0)>0){v=f[l+40>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[y>>2]|0))}y=f[l+44>>2]|0;if((y|0)!=(l+48|0))wL(y);y=k+36|0;l=f[y>>2]|0;do if(l|0){t=l+12|0;v=f[t>>2]|0;f[t>>2]=v+-1;if((v|0)!=1)break;V$(k)}while(0);f[y>>2]=0;y=k+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[y>>2]|0)>0){w=f[k+40>>2]|0;l=0;do{f[w+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[y>>2]|0))}y=f[k+44>>2]|0;if((y|0)!=(k+48|0))wL(y);y=j+36|0;k=f[y>>2]|0;do if(k|0){l=k+12|0;w=f[l>>2]|0;f[l>>2]=w+-1;if((w|0)!=1)break;V$(j)}while(0);f[y>>2]=0;y=j+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[j+40>>2]|0;k=0;do{f[z+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[y>>2]|0))}y=f[j+44>>2]|0;if((y|0)!=(j+48|0))wL(y);y=i+36|0;j=f[y>>2]|0;do if(j|0){k=j+12|0;z=f[k>>2]|0;f[k>>2]=z+-1;if((z|0)!=1)break;V$(i)}while(0);f[y>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[c>>2]|0)>0){H=f[C>>2]|0;C=0;do{f[H+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)==(i+48|0)){u=h;return}wL(c);u=h;return}function jM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+1280|0;g=e+1224|0;h=e+1168|0;i=e+128|0;j=e+72|0;k=e+16|0;l=e;do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[g>>2]=f[m>>2];n=g+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=g+8|0;f[p>>2]=f[m+8>>2];q=g+12|0;f[q>>2]=f[m+12>>2];f[g+16>>2]=f[m+16>>2];f[g+20>>2]=f[m+20>>2];f[g+24>>2]=f[m+24>>2];f[g+28>>2]=f[m+28>>2];f[g+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=p;s=g+48|0;t=g+44|0;f[t>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];v=p;w=q;x=g;break}else{f[n>>2]=0;U$(g,m);v=p;w=q;x=g;break}}else{bS(g,a,-1);v=g+8|0;w=g+12|0;x=g}while(0);a=f[x>>2]&4095;x=f[v>>2]|0;if((x|0)!=(f[w>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(32)|0;f[h>>2]=w;f[h+8>>2]=-2147483616;f[h+4>>2]=20;y=w;z=219042;A=y+20|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[w+20>>0]=0;vM(-215,h,219063,218819,1384)}w=(a|0)==5;if((a+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=32;y=v;z=218946;A=y+32|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[v+32>>0]=0;vM(-215,h,219063,218819,1385)}f[h>>2]=1124007936;v=h+4|0;z=h+8|0;q=h+40|0;y=v;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[q>>2]=z;y=h+48|0;A=h+44|0;f[A>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(aT(d)|0){ZS(d,x,x,a,-1,0,0);do if((eS(d)|0)==65536){p=f[d+4>>2]|0;f[i>>2]=f[p>>2];m=i+4|0;n=p+4|0;f[m>>2]=f[n>>2];o=i+8|0;f[o>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];s=f[p+36>>2]|0;f[i+36>>2]=s;f[i+40>>2]=o;o=i+48|0;t=i+44|0;f[t>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(s|0){o=s+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[p+44>>2]|0;o=f[t>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;U$(i,p);break}}else bS(i,d,-1);while(0);d=h+36|0;p=f[d>>2]|0;if(p|0?(m=p+12|0,p=f[m>>2]|0,f[m>>2]=p+-1,(p|0)==1):0)V$(h);f[d>>2]=0;p=h+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[v>>2]|0)>0){m=f[q>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[v>>2]|0))}f[h>>2]=f[i>>2];n=i+4|0;m=f[n>>2]|0;f[v>>2]=m;o=i+8|0;f[z>>2]=f[o>>2];f[h+12>>2]=f[i+12>>2];t=i+16|0;f[p>>2]=f[t>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];p=i+36|0;f[d>>2]=f[p>>2];d=h+44|0;s=f[d>>2]|0;if((s|0)==(y|0))B=m;else{wL(s);f[d>>2]=y;f[q>>2]=z;B=f[n>>2]|0}z=i+44|0;if((B|0)<3){B=f[z>>2]|0;f[y>>2]=f[B>>2];f[h+52>>2]=f[B+4>>2];C=B}else{f[d>>2]=f[z>>2];d=i+40|0;f[h+40>>2]=f[d>>2];B=i+48|0;f[z>>2]=B;f[d>>2]=o;C=B}f[i>>2]=1124007936;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[n+28>>2]=0;f[p>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((C|0)!=(i+48|0))wL(C)}C=g+4|0;t=f[C>>2]|0;if((t|0)>0)D=f[(f[g+44>>2]|0)+(t+-1<<2)>>2]|0;else D=0;t=Y(D,x)|0;p=t+15&-16;n=Y(p,x)|0;B=(Y(x*5|0,D)|0)+32+n|0;D=i+8|0;f[i>>2]=D;o=i+4|0;f[o>>2]=B;if(B>>>0>1032){d=bYc(B)|0;f[i>>2]=d;E=d}else E=D;d=E+15&-16;Tj(j,x,x,a,d,p);Tj(k,x,1,a,d+n|0,0);a=d+(n+t)|0;t=l+8|0;f[t>>2]=0;f[t+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;jR(g,l);l=j+16|0;t=f[l>>2]|0;if(w)F=kM(t,f[j+48>>2]|0,f[k+16>>2]|0,f[h+16>>2]|0,f[y>>2]|0,x,a)|0;else F=lM(t,f[j+48>>2]|0,f[k+16>>2]|0,f[h+16>>2]|0,f[y>>2]|0,x,a)|0;jR(k,c);c=k+36|0;a=f[c>>2]|0;if(a|0?(x=a+12|0,a=f[x>>2]|0,f[x>>2]=a+-1,(a|0)==1):0)V$(k);f[c>>2]=0;c=k+16|0;a=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[k+40>>2]|0;x=0;do{f[c+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[k+44>>2]|0;if((a|0)!=(k+48|0))wL(a);a=j+36|0;k=f[a>>2]|0;if(k|0?(x=k+12|0,k=f[x>>2]|0,f[x>>2]=k+-1,(k|0)==1):0)V$(j);f[a>>2]=0;a=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[a>>2]|0)>0){l=f[j+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)!=(j+48|0))wL(a);a=f[i>>2]|0;if((a|0)!=(D|0)){if(a|0)dYc(a);f[i>>2]=D;f[o>>2]=1032}o=h+36|0;D=f[o>>2]|0;if(D|0?(i=D+12|0,D=f[i>>2]|0,f[i>>2]=D+-1,(D|0)==1):0)V$(h);f[o>>2]=0;o=h+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[v>>2]|0)>0){o=f[q>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[v>>2]|0))}v=f[A>>2]|0;if((v|0)!=(y|0))wL(v);v=g+36|0;y=f[v>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)V$(g);f[v>>2]=0;v=g+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[C>>2]|0)>0){v=f[g+40>>2]|0;y=0;do{f[v+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[C>>2]|0))}C=f[g+44>>2]|0;if((C|0)==(g+48|0)){u=e;return F|0}wL(C);u=e;return F|0}function kM(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>2;b=(d|0)!=0;if(b){j=e>>>2;if((g|0)>0){k=g<<2;l=0;do{m=Y(j,l)|0;g1c(d+(m<<2)|0,0,k|0)|0;n[d+(m+l<<2)>>2]=1.0;l=l+1|0}while((l|0)!=(g|0));o=j}else o=j}else o=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{p=a+((Y(m,l)|0)<<2)|0;f[c+(m<<2)>>2]=f[p>>2];if((m|0)<(k|0)){p=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=p;t=+L(+(+n[a+(q+p<<2)>>2]));u=r;while(1){v=+L(+(+n[a+(u+q<<2)>>2]));r=t<v;w=r?u:s;u=u+1|0;if((u|0)==(g|0)){x=w;break}else{s=w;t=r?v:t}}}else x=p;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{s=0;t=+L(+(+n[a+(m<<2)>>2]));u=1;while(1){q=a+((Y(u,i)|0)+m<<2)|0;v=+L(+(+n[q>>2]));q=t<v;r=q?u:s;u=u+1|0;if((u|0)>=(m|0)){y=r;break}else{s=r;t=q?v:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+n[a+(s<<2)>>2]));if(x){u=0;p=1;v=t;do{q=Y(p,i)|0;z=+L(+(+n[a+((f[j+(p<<2)>>2]|0)+q<<2)>>2]));q=v<z;v=q?z:v;u=q?p:u;p=p+1|0}while((p|0)!=(y|0));A=f[j+(u<<2)>>2]|0;B=u;C=1;D=v}else{A=s;B=0;C=1;D=t}while(1){p=f[h+(C<<2)>>2]|0;q=a+((Y(p,i)|0)+C<<2)|0;z=+L(+(+n[q>>2]));q=D<z;A=q?C:A;B=q?p:B;C=C+1|0;if((C|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;u=a+(s+A<<2)|0;t=+n[u>>2];v=+L(+t);if(v<=1.1920928955078125e-07)break;q=c+(A<<2)|0;p=c+(B<<2)|0;z=(+n[q>>2]-+n[p>>2])*.5;E=+L(+z);if(!(v>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=v/E;H=E;I=G*G;J=38}else{G=E/v;H=v;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(v>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=v/E;O=E;P=N*N;J=43}else{N=E/v;O=v;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;v=t/K;E=t*(t/G);r=z<0.0;z=r?-E:E;E=r?-v:v;n[u>>2]=0.0;n[p>>2]=+n[p>>2]-z;n[q>>2]=z+ +n[q>>2];q=(B|0)>0;if(q){p=0;do{u=Y(p,i)|0;r=a+(u+B<<2)|0;z=+n[r>>2];w=a+(u+A<<2)|0;v=+n[w>>2];n[r>>2]=N*z-E*v;n[w>>2]=E*z+N*v;p=p+1|0}while((p|0)!=(B|0))}p=B+1|0;if((p|0)<(A|0)){w=p;do{r=a+(w+s<<2)|0;v=+n[r>>2];u=a+((Y(w,i)|0)+A<<2)|0;z=+n[u>>2];n[r>>2]=N*v-E*z;n[u>>2]=E*v+N*z;w=w+1|0}while((w|0)!=(A|0))}w=A+1|0;if((w|0)<(g|0)){u=Y(A,i)|0;r=w;do{Q=a+(r+s<<2)|0;z=+n[Q>>2];R=a+(r+u<<2)|0;v=+n[R>>2];n[Q>>2]=N*z-E*v;n[R>>2]=E*z+N*v;r=r+1|0}while((r|0)!=(g|0))}if(!k){r=Y(B,o)|0;u=Y(A,o)|0;R=0;do{Q=d+(R+r<<2)|0;v=+n[Q>>2];S=d+(R+u<<2)|0;z=+n[S>>2];n[Q>>2]=N*v-E*z;n[S>>2]=E*v+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){u=p;N=+L(+(+n[a+(s+p<<2)>>2]));r=R;while(1){E=+L(+(+n[a+(r+s<<2)>>2]));R=N<E;S=R?r:u;r=r+1|0;if((r|0)==(g|0)){T=S;break}else{u=S;N=R?E:N}}}else T=p;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{N=+L(+(+n[a+(B<<2)>>2]));u=1;r=0;while(1){s=a+((Y(u,i)|0)+B<<2)|0;E=+L(+(+n[s>>2]));s=N<E;R=s?u:r;u=u+1|0;if((u|0)>=(B|0)){U=R;break}else{N=s?E:N;r=R}}}f[h+(B<<2)>>2]=U}if((A|0)<(y|0)){r=Y(A,i)|0;u=A+2|0;if((u|0)<(g|0)){q=w;N=+L(+(+n[a+(r+w<<2)>>2]));p=u;while(1){E=+L(+(+n[a+(p+r<<2)>>2]));u=N<E;R=u?p:q;p=p+1|0;if((p|0)==(g|0)){V=R;break}else{q=R;N=u?E:N}}}else V=w;f[j+(A<<2)>>2]=V}if((A|0)>0){if((A|0)==1)W=0;else{N=+L(+(+n[a+(A<<2)>>2]));q=1;p=0;while(1){r=a+((Y(q,i)|0)+A<<2)|0;E=+L(+(+n[r>>2]));r=N<E;u=r?q:p;q=q+1|0;if((q|0)>=(A|0)){W=u;break}else{N=r?E:N;p=u}}}f[h+(A<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+n[c+(l<<2)>>2]<+n[c+(e<<2)>>2]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<2)|0;e=c+(m<<2)|0;W=f[l>>2]|0;f[l>>2]=f[e>>2];f[e>>2]=W}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;W=b;while(1){e=+n[c+(W<<2)>>2]<+n[c+(Z<<2)>>2]?Z:W;Z=Z+1|0;if((Z|0)==(g|0)){_=e;break}else W=e}}else _=b;if((b|0)!=(_|0)){W=c+(_<<2)|0;Z=c+(b<<2)|0;m=f[W>>2]|0;f[W>>2]=f[Z>>2];f[Z>>2]=m;m=Y(_,o)|0;Z=Y(b,o)|0;W=0;do{e=d+(W+m<<2)|0;l=d+(W+Z<<2)|0;A=f[e>>2]|0;f[e>>2]=f[l>>2];f[l>>2]=A;W=W+1|0}while((W|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function lM(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>3;b=(d|0)!=0;if(b){j=e>>>3;if((g|0)>0){k=g<<3;l=0;do{m=Y(j,l)|0;g1c(d+(m<<3)|0,0,k|0)|0;p[d+(m+l<<3)>>3]=1.0;l=l+1|0}while((l|0)!=(g|0));n=j}else n=j}else n=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{o=a+((Y(m,l)|0)<<3)|0;p[c+(m<<3)>>3]=+p[o>>3];if((m|0)<(k|0)){o=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=o;t=+L(+(+p[a+(q+o<<3)>>3]));u=r;while(1){v=+L(+(+p[a+(u+q<<3)>>3]));r=t<v;w=r?u:s;u=u+1|0;if((u|0)==(g|0)){x=w;break}else{s=w;t=r?v:t}}}else x=o;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{s=0;t=+L(+(+p[a+(m<<3)>>3]));u=1;while(1){q=a+((Y(u,i)|0)+m<<3)|0;v=+L(+(+p[q>>3]));q=t<v;r=q?u:s;u=u+1|0;if((u|0)>=(m|0)){y=r;break}else{s=r;t=q?v:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+p[a+(s<<3)>>3]));if(x){u=0;o=1;v=t;do{q=Y(o,i)|0;z=+L(+(+p[a+((f[j+(o<<2)>>2]|0)+q<<3)>>3]));q=v<z;v=q?z:v;u=q?o:u;o=o+1|0}while((o|0)!=(y|0));A=f[j+(u<<2)>>2]|0;B=u;C=1;D=v}else{A=s;B=0;C=1;D=t}while(1){o=f[h+(C<<2)>>2]|0;q=a+((Y(o,i)|0)+C<<3)|0;z=+L(+(+p[q>>3]));q=D<z;A=q?C:A;B=q?o:B;C=C+1|0;if((C|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;u=a+(s+A<<3)|0;t=+p[u>>3];v=+L(+t);if(v<=2.220446049250313e-16)break;q=c+(A<<3)|0;o=c+(B<<3)|0;z=(+p[q>>3]-+p[o>>3])*.5;E=+L(+z);if(!(v>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=v/E;H=E;I=G*G;J=38}else{G=E/v;H=v;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(v>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=v/E;O=E;P=N*N;J=43}else{N=E/v;O=v;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;v=t/K;E=t*(t/G);r=z<0.0;z=r?-E:E;E=r?-v:v;p[u>>3]=0.0;p[o>>3]=+p[o>>3]-z;p[q>>3]=z+ +p[q>>3];q=(B|0)>0;if(q){o=0;do{u=Y(o,i)|0;r=a+(u+B<<3)|0;z=+p[r>>3];w=a+(u+A<<3)|0;v=+p[w>>3];p[r>>3]=N*z-E*v;p[w>>3]=E*z+N*v;o=o+1|0}while((o|0)!=(B|0))}o=B+1|0;if((o|0)<(A|0)){w=o;do{r=a+(w+s<<3)|0;v=+p[r>>3];u=a+((Y(w,i)|0)+A<<3)|0;z=+p[u>>3];p[r>>3]=N*v-E*z;p[u>>3]=E*v+N*z;w=w+1|0}while((w|0)!=(A|0))}w=A+1|0;if((w|0)<(g|0)){u=Y(A,i)|0;r=w;do{Q=a+(r+s<<3)|0;z=+p[Q>>3];R=a+(r+u<<3)|0;v=+p[R>>3];p[Q>>3]=N*z-E*v;p[R>>3]=E*z+N*v;r=r+1|0}while((r|0)!=(g|0))}if(!k){r=Y(B,n)|0;u=Y(A,n)|0;R=0;do{Q=d+(R+r<<3)|0;v=+p[Q>>3];S=d+(R+u<<3)|0;z=+p[S>>3];p[Q>>3]=N*v-E*z;p[S>>3]=E*v+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){u=o;N=+L(+(+p[a+(s+o<<3)>>3]));r=R;while(1){E=+L(+(+p[a+(r+s<<3)>>3]));R=N<E;S=R?r:u;r=r+1|0;if((r|0)==(g|0)){T=S;break}else{u=S;N=R?E:N}}}else T=o;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{N=+L(+(+p[a+(B<<3)>>3]));u=1;r=0;while(1){s=a+((Y(u,i)|0)+B<<3)|0;E=+L(+(+p[s>>3]));s=N<E;R=s?u:r;u=u+1|0;if((u|0)>=(B|0)){U=R;break}else{N=s?E:N;r=R}}}f[h+(B<<2)>>2]=U}if((A|0)<(y|0)){r=Y(A,i)|0;u=A+2|0;if((u|0)<(g|0)){q=w;N=+L(+(+p[a+(r+w<<3)>>3]));o=u;while(1){E=+L(+(+p[a+(o+r<<3)>>3]));u=N<E;R=u?o:q;o=o+1|0;if((o|0)==(g|0)){V=R;break}else{q=R;N=u?E:N}}}else V=w;f[j+(A<<2)>>2]=V}if((A|0)>0){if((A|0)==1)W=0;else{N=+L(+(+p[a+(A<<3)>>3]));q=1;o=0;while(1){r=a+((Y(q,i)|0)+A<<3)|0;E=+L(+(+p[r>>3]));r=N<E;u=r?q:o;q=q+1|0;if((q|0)>=(A|0)){W=u;break}else{N=r?E:N;o=u}}}f[h+(A<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+p[c+(l<<3)>>3]<+p[c+(e<<3)>>3]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<3)|0;e=c+(m<<3)|0;K=+p[l>>3];p[l>>3]=+p[e>>3];p[e>>3]=K}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;e=b;while(1){l=+p[c+(e<<3)>>3]<+p[c+(Z<<3)>>3]?Z:e;Z=Z+1|0;if((Z|0)==(g|0)){_=l;break}else e=l}}else _=b;if((b|0)!=(_|0)){e=c+(_<<3)|0;Z=c+(b<<3)|0;K=+p[e>>3];p[e>>3]=+p[Z>>3];p[Z>>3]=K;Z=Y(_,n)|0;e=Y(b,n)|0;m=0;do{l=d+(m+Z<<3)|0;W=d+(m+e<<3)|0;K=+p[l>>3];p[l>>3]=+p[W>>3];p[W>>3]=K;m=m+1|0}while((m|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function mM(a,b,c,d,e,f,g,h,i,j,k,l,m,o,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;r=(d|0)==0?1:d>>>2;d=f>>>2;f=i>>>2;i=k>>>2;k=o>>>2;o=q+7&-8;q=o;s=o;o=g?d:1;t=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;u=g?l:a;l=(b|0)>0;v=(u|0)>0;if(l&v){w=u<<2;x=0;do{g1c(m+((Y(x,k)|0)<<2)|0,0,w|0)|0;x=x+1|0}while((x|0)!=(b|0))}if((d|0)>0){y=0.0;z=0}else return;do{x=c+((Y(z,r)|0)<<2)|0;y=y+ +n[x>>2];z=z+1|0}while((z|0)<(d|0));A=y*4.440892098500626e-16;z=(u|0)==1;x=(a|0)>0;w=u+-4|0;B=(u|0)<4;C=u&-4;D=(C|0)<(u|0);E=u<<3;F=e;e=h;h=0;while(1){G=c+((Y(h,r)|0)<<2)|0;y=+n[G>>2];a:do if(!(+L(+y)<=A)){H=1.0/y;if(z){if(g)if(x){I=0.0;G=0;while(1){J=F+((Y(G,t)|0)<<2)|0;K=j+((Y(G,i)|0)<<2)|0;M=I+ +n[J>>2]*+n[K>>2];G=G+1|0;if((G|0)==(a|0)){N=M;break}else I=M}}else N=0.0;else N=+n[F>>2];I=H*N;if(l)O=0;else break;while(1){G=m+((Y(O,k)|0)<<2)|0;n[G>>2]=+n[G>>2]+I*+n[e+(O<<2)>>2];O=O+1|0;if((O|0)==(b|0))break a}}b:do if(g){if(v)g1c(q|0,0,E|0)|0;c:do if(x){if(B){if(v){P=j;Q=0}else break b;while(1){G=F+((Y(Q,t)|0)<<2)|0;I=+n[G>>2];G=0;do{K=s+(G<<3)|0;p[K>>3]=+p[K>>3]+I*+n[P+(G<<2)>>2];G=G+1|0}while((G|0)!=(u|0));Q=Q+1|0;if((Q|0)==(a|0))break c;else P=P+(i<<2)|0}}if(D){R=j;S=0}else{G=j;K=0;while(1){J=F+((Y(K,t)|0)<<2)|0;I=+n[J>>2];J=0;do{T=s+(J<<3)|0;U=J|1;V=s+(U<<3)|0;M=+p[V>>3]+I*+n[G+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[G+(J<<2)>>2];p[V>>3]=M;V=J|2;T=s+(V<<3)|0;U=J|3;W=s+(U<<3)|0;M=+p[W>>3]+I*+n[G+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[G+(V<<2)>>2];p[W>>3]=M;J=J+4|0}while((J|0)<=(w|0));K=K+1|0;if((K|0)==(a|0))break c;else G=G+(i<<2)|0}}while(1){G=F+((Y(S,t)|0)<<2)|0;I=+n[G>>2];G=0;do{K=s+(G<<3)|0;J=G|1;W=s+(J<<3)|0;M=+p[W>>3]+I*+n[R+(J<<2)>>2];p[K>>3]=+p[K>>3]+I*+n[R+(G<<2)>>2];p[W>>3]=M;W=G|2;K=s+(W<<3)|0;J=G|3;V=s+(J<<3)|0;M=+p[V>>3]+I*+n[R+(J<<2)>>2];p[K>>3]=+p[K>>3]+I*+n[R+(W<<2)>>2];p[V>>3]=M;G=G+4|0}while((G|0)<=(w|0));X=C;do{G=s+(X<<3)|0;p[G>>3]=+p[G>>3]+I*+n[R+(X<<2)>>2];X=X+1|0}while((X|0)!=(u|0));S=S+1|0;if((S|0)==(a|0))break;else R=R+(i<<2)|0}}while(0);if(v){G=0;do{V=s+(G<<3)|0;p[V>>3]=H*+p[V>>3];G=G+1|0}while((G|0)!=(u|0))}}else if(v){G=0;do{V=F+((Y(G,t)|0)<<2)|0;p[s+(G<<3)>>3]=H*+n[V>>2];G=G+1|0}while((G|0)!=(u|0))}while(0);if(l){if(B){if(v){Z=m;_=0}else break;while(1){H=+n[e+(_<<2)>>2];G=0;do{V=Z+(G<<2)|0;n[V>>2]=+n[V>>2]+H*+p[s+(G<<3)>>3];G=G+1|0}while((G|0)!=(u|0));_=_+1|0;if((_|0)==(b|0))break a;else Z=Z+(k<<2)|0}}if(D){$=m;aa=0}else{G=m;V=0;while(1){H=+n[e+(V<<2)>>2];W=0;do{K=G+(W<<2)|0;J=W|1;T=G+(J<<2)|0;I=+n[T>>2]+H*+p[s+(J<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(W<<3)>>3];n[T>>2]=I;T=W|2;K=G+(T<<2)|0;J=W|3;U=G+(J<<2)|0;I=+n[U>>2]+H*+p[s+(J<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(T<<3)>>3];n[U>>2]=I;W=W+4|0}while((W|0)<=(w|0));V=V+1|0;if((V|0)==(b|0))break a;else G=G+(k<<2)|0}}while(1){H=+n[e+(aa<<2)>>2];G=0;do{V=$+(G<<2)|0;W=G|1;U=$+(W<<2)|0;I=+n[U>>2]+H*+p[s+(W<<3)>>3];n[V>>2]=+n[V>>2]+H*+p[s+(G<<3)>>3];n[U>>2]=I;U=G|2;V=$+(U<<2)|0;W=G|3;T=$+(W<<2)|0;I=+n[T>>2]+H*+p[s+(W<<3)>>3];n[V>>2]=+n[V>>2]+H*+p[s+(U<<3)>>3];n[T>>2]=I;G=G+4|0}while((G|0)<=(w|0));ba=C;do{G=$+(ba<<2)|0;n[G>>2]=+n[G>>2]+H*+p[s+(ba<<3)>>3];ba=ba+1|0}while((ba|0)!=(u|0));aa=aa+1|0;if((aa|0)==(b|0))break;else $=$+(k<<2)|0}}}while(0);h=h+1|0;if((h|0)>=(d|0))break;else{F=F+(o<<2)|0;e=e+(f<<2)|0}}return}function nM(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0;q=(d|0)==0?1:d>>>3;d=f>>>3;f=i>>>3;i=k>>>3;k=n>>>3;n=o+7&-8;o=n;r=n;n=g?d:1;s=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;t=g?l:a;l=(b|0)>0;u=(t|0)>0;if(l&u){v=t<<3;w=0;do{g1c(m+((Y(w,k)|0)<<3)|0,0,v|0)|0;w=w+1|0}while((w|0)!=(b|0))}if((d|0)>0){x=0.0;y=0}else return;do{w=c+((Y(y,q)|0)<<3)|0;x=x+ +p[w>>3];y=y+1|0}while((y|0)<(d|0));z=x*4.440892098500626e-16;y=(t|0)==1;w=(a|0)>0;v=t<<3;A=e;e=h;h=0;while(1){B=c+((Y(h,q)|0)<<3)|0;x=+p[B>>3];a:do if(!(+L(+x)<=z)){C=1.0/x;if(y){if(g)if(w){D=0.0;B=0;while(1){E=A+((Y(B,s)|0)<<3)|0;F=j+((Y(B,i)|0)<<3)|0;G=D+ +p[E>>3]*+p[F>>3];B=B+1|0;if((B|0)==(a|0)){H=G;break}else D=G}}else H=0.0;else H=+p[A>>3];D=C*H;if(l)I=0;else break;while(1){B=m+((Y(I,k)|0)<<3)|0;p[B>>3]=+p[B>>3]+D*+p[e+(I<<3)>>3];I=I+1|0;if((I|0)==(b|0))break a}}do if(!g){if(u){B=0;do{F=A+((Y(B,s)|0)<<3)|0;p[r+(B<<3)>>3]=C*+p[F>>3];B=B+1|0}while((B|0)!=(t|0))}}else{if(!u){oM(a,t,j,i,A,s,r,0);break}g1c(o|0,0,v|0)|0;oM(a,t,j,i,A,s,r,0);B=0;do{F=r+(B<<3)|0;p[F>>3]=C*+p[F>>3];B=B+1|0}while((B|0)!=(t|0))}while(0);oM(b,t,r,0,e,1,m,k)}while(0);h=h+1|0;if((h|0)>=(d|0))break;else{A=A+(n<<3)|0;e=e+(f<<3)|0}}return}function oM(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0.0,t=0;if((a|0)<=0)return;i=b+-4|0;if((b|0)<4){j=(b|0)>0;k=g;l=0;m=c;while(1){n=e+((Y(l,f)|0)<<3)|0;o=+p[n>>3];if(j){n=0;do{q=k+(n<<3)|0;p[q>>3]=+p[q>>3]+o*+p[m+(n<<3)>>3];n=n+1|0}while((n|0)!=(b|0))}l=l+1|0;if((l|0)==(a|0))break;else{k=k+(h<<3)|0;m=m+(d<<3)|0}}return}m=b&-4;k=(m|0)<(b|0);l=g;g=0;j=c;while(1){c=e+((Y(g,f)|0)<<3)|0;o=+p[c>>3];c=0;do{n=l+(c<<3)|0;q=c|1;r=l+(q<<3)|0;s=+p[r>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(c<<3)>>3];p[r>>3]=s;r=c|2;n=l+(r<<3)|0;q=c|3;t=l+(q<<3)|0;s=+p[t>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(r<<3)>>3];p[t>>3]=s;c=c+4|0}while((c|0)<=(i|0));if(k){c=m;do{t=l+(c<<3)|0;p[t>>3]=+p[t>>3]+o*+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(b|0))}g=g+1|0;if((g|0)==(a|0))break;else{l=l+(h<<3)|0;j=j+(d<<3)|0}}return}function pM(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;g=u;u=u+1616|0;h=g;i=g+1560|0;j=g+1504|0;k=g+1448|0;l=g+408|0;m=g+352|0;o=g+296|0;q=g+240|0;r=g+184|0;s=g+128|0;t=g+72|0;v=g+56|0;do if((eS(a)|0)==65536){w=f[a+4>>2]|0;f[j>>2]=f[w>>2];x=j+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=j+8|0;f[z>>2]=f[w+8>>2];f[j+12>>2]=f[w+12>>2];f[j+16>>2]=f[w+16>>2];f[j+20>>2]=f[w+20>>2];f[j+24>>2]=f[w+24>>2];f[j+28>>2]=f[w+28>>2];f[j+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[j+36>>2]=A;f[j+40>>2]=z;z=j+48|0;B=j+44|0;f[B>>2]=z;f[z>>2]=0;f[j+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(j,w);break}}else bS(j,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];w=k+4|0;x=a+4|0;f[w>>2]=f[x>>2];y=k+8|0;f[y>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[k+36>>2]=z;f[k+40>>2]=y;y=k+48|0;B=k+44|0;f[B>>2]=y;f[y>>2]=0;f[k+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[a+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];C=k;break}else{f[w>>2]=0;U$(k,a);C=k;break}}else{bS(k,c,-1);C=k}while(0);c=f[j>>2]|0;a=c&4095;w=(e&16|0)!=0;x=f[C>>2]|0;if((a|0)!=(x&4095|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;D=$Xc(64)|0;f[h>>2]=D;E=h+8|0;f[E>>2]=-2147483584;F=h+4|0;f[F>>2]=58;G=D;H=219346;I=G+58|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));J=D+58|0;b[J>>0]=0;vM(-215,h,219405,218819,1086)}C=(a|0)==5;if((a+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;D=$Xc(64)|0;f[h>>2]=D;E=h+8|0;f[E>>2]=-2147483584;F=h+4|0;f[F>>2]=58;G=D;H=219346;I=G+58|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));J=D+58|0;b[J>>0]=0;vM(-215,h,219405,218819,1086)}J=e&-17;if(J>>>0>=5)sV(J,35772);a:do switch(e|0){case 0:case 3:case 16:case 19:{if(!w?(f[j+8>>2]|0)!=(f[j+12>>2]|0):0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;D=$Xc(96)|0;f[h>>2]=D;f[h+8>>2]=-2147483552;f[h+4>>2]=87;G=D;H=219411;I=G+87|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[D+87>>0]=0;vM(-215,h,219405,218819,1093)}switch(e|0){case 0:case 3:case 16:case 19:break;default:{K=61;break a}}if(((!w?(F=j+8|0,E=f[F>>2]|0,(E|0)<4):0)?(E|0)==(f[j+12>>2]|0):0)?(f[k+12>>2]|0)==1:0){ZS(d,E,1,a,-1,0,0);do if((eS(d)|0)==65536){E=f[d+4>>2]|0;f[h>>2]=f[E>>2];y=h+4|0;B=E+4|0;f[y>>2]=f[B>>2];z=h+8|0;f[z>>2]=f[E+8>>2];f[h+12>>2]=f[E+12>>2];A=h+16|0;f[A>>2]=f[E+16>>2];f[h+20>>2]=f[E+20>>2];f[h+24>>2]=f[E+24>>2];f[h+28>>2]=f[E+28>>2];f[h+32>>2]=f[E+32>>2];L=f[E+36>>2]|0;f[h+36>>2]=L;f[h+40>>2]=z;z=h+48|0;M=h+44|0;f[M>>2]=z;f[z>>2]=0;f[h+52>>2]=0;if(L|0){N=L+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[B>>2]|0)<3){B=f[E+44>>2]|0;N=f[M>>2]|0;f[N>>2]=f[B>>2];f[N+4>>2]=f[B+4>>2];O=A;P=M;Q=z;break}else{f[y>>2]=0;U$(h,E);O=A;P=M;Q=z;break}}else{bS(h,d,-1);O=h+16|0;P=h+44|0;Q=h+48|0}while(0);D=f[j+16>>2]|0;z=f[k+16>>2]|0;M=f[O>>2]|0;A=f[j+48>>2]|0;E=f[k+48>>2]|0;y=f[Q>>2]|0;b:do switch(f[F>>2]|0){case 2:{if(C){R=+n[D>>2];B=D+A|0;S=+n[B+4>>2];T=+n[D+4>>2];U=+n[B>>2];V=R*S-T*U;if(!(V!=0.0)){W=0;break b}X=1.0/V;V=+n[z>>2];Z=+n[z+E>>2];n[M+y>>2]=X*(R*Z-U*V);n[M>>2]=X*(S*V-T*Z);W=1;break b}else{Z=+p[D>>3];B=D+A|0;T=+p[B+8>>3];V=+p[D+8>>3];S=+p[B>>3];X=Z*T-V*S;if(!(X!=0.0)){W=0;break b}U=1.0/X;X=+p[z>>3];R=+p[z+E>>3];p[M+y>>3]=U*(Z*R-S*X);p[M>>3]=U*(T*X-V*R);W=1;break b}break}case 3:{B=A<<1;if(C){R=+n[D>>2];N=D+A|0;V=+n[N+4>>2];L=D+B|0;X=+n[L+8>>2];T=X;U=+n[N+8>>2];S=+n[L+4>>2];Z=V*T-U*S;_=+n[D+4>>2];$=+n[N>>2];aa=+n[L>>2];ba=T*$-U*aa;ca=+n[D+8>>2];da=S*$-V*aa;ea=ca*da+(R*Z-_*ba);if(!(ea!=0.0)){W=0;break b}fa=1.0/ea;ea=+n[z>>2];ga=+n[z+E>>2];ha=ga;ia=+n[z+(E<<1)>>2];ja=U*ia;U=S*ha;S=V*ia;V=$*ia-aa*ha;n[M>>2]=fa*(ca*(U-S)+(Z*ea-_*(T*ha-ja)));n[M+y>>2]=fa*(ca*V+(R*(X*ga-ja)-ba*ea));n[M+(y<<1)>>2]=fa*(da*ea+(R*(S-U)-_*V));W=1;break b}else{V=+p[D>>3];L=D+A|0;_=+p[L+8>>3];N=D+B|0;U=+p[N+16>>3];S=+p[L+16>>3];R=+p[N+8>>3];ea=_*U-S*R;da=+p[D+8>>3];fa=+p[L>>3];ba=U*fa;ja=+p[N>>3];ga=S*ja;X=+p[D+16>>3];ca=R*fa-_*ja;ha=X*ca+(V*ea-da*(ba-ga));if(!(ha!=0.0)){W=0;break b}T=1.0/ha;ha=+p[z>>3];Z=+p[z+E>>3];aa=+p[z+(E<<1)>>3];p[M>>3]=T*(ea*ha+(R*X-U*da)*Z+(S*da-_*X)*aa);p[M+y>>3]=T*((ga-ba)*ha+(V*U-ja*X)*Z+(fa*X-V*S)*aa);p[M+(y<<1)>>3]=T*(ca*ha+(da*ja-V*R)*Z+(V*_-da*fa)*aa);W=1;break b}break}default:if(C){aa=+n[D>>2];if(!(aa!=0.0)){W=0;break b}n[M>>2]=+n[z>>2]/aa;W=1;break b}else{aa=+p[D>>3];if(!(aa!=0.0)){W=0;break b}p[M>>3]=+p[z>>3]/aa;W=1;break b}}while(0);z=h+36|0;M=f[z>>2]|0;if(M|0?(D=M+12|0,M=f[D>>2]|0,f[D>>2]=M+-1,(M|0)==1):0)V$(h);f[z>>2]=0;z=h+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[z>>2]|0)>0){M=f[h+40>>2]|0;D=0;do{f[M+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[z>>2]|0))}z=f[P>>2]|0;if((z|0)!=(Q|0))wL(z);ka=W;la=k+36|0}else K=61;break}default:K=61}while(0);if((K|0)==61){W=f[j+8>>2]|0;Q=j+12|0;P=f[Q>>2]|0;O=f[k+12>>2]|0;z=Y(675553809>>>(a<<2&28)&15,(c>>>3&511)+1|0)|0;c=Y(P,z)|0;D=c+15&-16;M=(Y(W,z)|0)+15&-16;y=(e|0)!=1?D:M;M=l+8|0;f[l>>2]=M;E=l+4|0;f[E>>2]=1032;f[m>>2]=x;x=m+4|0;A=k+4|0;F=f[A>>2]|0;f[x>>2]=F;N=m+8|0;f[N>>2]=f[k+8>>2];L=m+12|0;f[L>>2]=O;B=m+16|0;f[B>>2]=f[k+16>>2];ma=m+20|0;f[ma>>2]=f[k+20>>2];na=m+24|0;f[na>>2]=f[k+24>>2];oa=m+28|0;f[oa>>2]=f[k+28>>2];pa=m+32|0;f[pa>>2]=f[k+32>>2];qa=m+36|0;ra=k+36|0;sa=f[ra>>2]|0;f[qa>>2]=sa;ta=m+40|0;f[ta>>2]=N;ua=m+48|0;va=m+44|0;f[va>>2]=ua;f[ua>>2]=0;f[m+52>>2]=0;if(!sa)wa=F;else{F=sa+12|0;f[F>>2]=(f[F>>2]|0)+1;wa=f[A>>2]|0}if((wa|0)<3){wa=f[k+44>>2]|0;A=f[va>>2]|0;f[A>>2]=f[wa>>2];f[A+4>>2]=f[wa+4>>2]}else{f[x>>2]=0;U$(m,k)}ZS(d,f[Q>>2]|0,f[L>>2]|0,f[j>>2]&4095,-1,0,0);do if((eS(d)|0)==65536){Q=f[d+4>>2]|0;f[o>>2]=f[Q>>2];wa=o+4|0;A=Q+4|0;f[wa>>2]=f[A>>2];F=o+8|0;f[F>>2]=f[Q+8>>2];f[o+12>>2]=f[Q+12>>2];f[o+16>>2]=f[Q+16>>2];f[o+20>>2]=f[Q+20>>2];f[o+24>>2]=f[Q+24>>2];f[o+28>>2]=f[Q+28>>2];f[o+32>>2]=f[Q+32>>2];sa=f[Q+36>>2]|0;f[o+36>>2]=sa;f[o+40>>2]=F;F=o+48|0;xa=o+44|0;f[xa>>2]=F;f[F>>2]=0;f[o+52>>2]=0;if(sa|0){F=sa+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[A>>2]|0)<3){A=f[Q+44>>2]|0;F=f[xa>>2]|0;f[F>>2]=f[A>>2];f[F+4>>2]=f[A+4>>2];break}else{f[wa>>2]=0;U$(o,Q);break}}else bS(o,d,-1);while(0);if((W|0)<(P|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(64)|0;f[h>>2]=d;f[h+8>>2]=-2147483584;f[h+4>>2]=58;G=d;H=219499;I=G+58|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[d+58>>0]=0;vM(-5,h,219405,218819,1239)}d=(W|0)==(P|0);if(d){ya=J;za=0;Aa=W}else{ya=(e|0)==17?2:J;za=w;Aa=w?P:W}w=(ya|0)==1;J=Y(za|w?P:W,y)|0;e=Y(c,O)|0;c=(za?e+32|0:32)+J|0;H=(ya|0)==2;if((ya+-1|0)>>>0<2)Ba=(O<<3)+32+(Y(D+(z*5|0)|0,P)|0)+c|0;else Ba=c;if((f[E>>2]|0)>>>0<Ba>>>0){c=f[l>>2]|0;if((c|0)==(M|0))Ca=c;else{if(c|0)dYc(c);f[l>>2]=M;f[E>>2]=1032;Ca=M}f[E>>2]=Ba;if(Ba>>>0>1032){c=bYc(Ba)|0;f[l>>2]=c;Da=c}else Da=Ca}else{f[E>>2]=Ba;Da=f[l>>2]|0}Ba=Da+15&-16;Tj(q,Aa,P,a,Ba,y);c:do if(za){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;Da=i+8|0;f[Da>>2]=0;f[Da+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;WY(h,i,1,fT()|0,1.0,-1);Da=Ba+J|0;switch(ya|0){case 0:case 3:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;f[s>>2]=1124007936;Ca=s+4|0;c=s+8|0;Q=s+40|0;G=Ca;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Q>>2]=c;wa=s+48|0;A=s+44|0;f[A>>2]=wa;f[wa>>2]=0;f[s+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=s;F=t+8|0;f[F>>2]=0;f[F+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=o;AY(h,i,1.0,r,0.0,t,1);F=s+36|0;xa=f[F>>2]|0;if(xa|0?(sa=xa+12|0,xa=f[sa>>2]|0,f[sa>>2]=xa+-1,(xa|0)==1):0)V$(s);f[F>>2]=0;F=s+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[Ca>>2]|0)>0){F=f[Q>>2]|0;xa=0;do{f[F+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[Ca>>2]|0))}Ca=f[A>>2]|0;if((Ca|0)!=(wa|0))wL(Ca);Ea=Da;break c;break}default:{}}Tj(h,P,O,a,Da,0);Ca=Ba+J+e|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=j;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;f[t>>2]=1124007936;xa=t+4|0;F=t+8|0;Q=t+40|0;G=xa;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Q>>2]=F;Da=t+48|0;wa=t+44|0;f[wa>>2]=Da;f[Da>>2]=0;f[t+52>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=t;A=v+8|0;f[A>>2]=0;f[A+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=h;AY(i,r,1.0,s,0.0,v,1);A=t+36|0;c=f[A>>2]|0;if(c|0?(sa=c+12|0,c=f[sa>>2]|0,f[sa>>2]=c+-1,(c|0)==1):0)V$(t);f[A>>2]=0;A=t+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[xa>>2]|0)>0){A=f[Q>>2]|0;c=0;do{f[A+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[xa>>2]|0))}xa=f[wa>>2]|0;if((xa|0)!=(Da|0))wL(xa);xa=h+36|0;c=f[xa>>2]|0;if(c|0){A=c+12|0;f[A>>2]=(f[A>>2]|0)+1}A=f[qa>>2]|0;do if(A|0){c=A+12|0;Q=f[c>>2]|0;f[c>>2]=Q+-1;if((Q|0)!=1)break;V$(m)}while(0);f[qa>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[x>>2]|0)>0){A=f[ta>>2]|0;Da=0;do{f[A+(Da<<2)>>2]=0;Da=Da+1|0;Fa=f[x>>2]|0}while((Da|0)<(Fa|0));f[m>>2]=f[h>>2];if((Fa|0)<3)K=134;else K=136}else{f[m>>2]=f[h>>2];K=134}do if((K|0)==134){Da=f[h+4>>2]|0;if((Da|0)>=3){K=136;break}f[x>>2]=Da;f[N>>2]=f[h+8>>2];f[L>>2]=f[h+12>>2];Da=f[h+44>>2]|0;A=f[va>>2]|0;f[A>>2]=f[Da>>2];f[A+4>>2]=f[Da+4>>2]}while(0);if((K|0)==136)U$(m,h);Da=h+16|0;f[B>>2]=f[Da>>2];f[ma>>2]=f[h+20>>2];f[na>>2]=f[h+24>>2];f[oa>>2]=f[h+28>>2];f[pa>>2]=f[h+32>>2];A=f[xa>>2]|0;f[qa>>2]=A;do if(A|0){wa=A+12|0;Q=f[wa>>2]|0;f[wa>>2]=Q+-1;if((Q|0)!=1)break;V$(h)}while(0);f[xa>>2]=0;A=h+4|0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[A>>2]|0)>0){Q=f[h+40>>2]|0;wa=0;do{f[Q+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[A>>2]|0))}A=f[h+44>>2]|0;if((A|0)!=(h+48|0))wL(A);Ea=Ca}else{if(w){Tj(h,P,Aa,a,Ba,y);A=q+36|0;wa=f[A>>2]|0;if(wa|0?(Q=wa+12|0,wa=f[Q>>2]|0,f[Q>>2]=wa+-1,(wa|0)==1):0)V$(q);f[A>>2]=0;wa=q+16|0;Q=q+4|0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[Q>>2]|0)>0){Da=f[q+40>>2]|0;xa=0;do{f[Da+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[Q>>2]|0))}f[q>>2]=f[h>>2];xa=h+4|0;Da=f[xa>>2]|0;f[Q>>2]=Da;Ca=h+8|0;c=q+8|0;f[c>>2]=f[Ca>>2];f[q+12>>2]=f[h+12>>2];F=h+16|0;f[wa>>2]=f[F>>2];f[q+20>>2]=f[h+20>>2];f[q+24>>2]=f[h+24>>2];f[q+28>>2]=f[h+28>>2];f[q+32>>2]=f[h+32>>2];sa=h+36|0;f[A>>2]=f[sa>>2];Ga=q+44|0;Ha=f[Ga>>2]|0;Ia=q+48|0;if((Ha|0)==(Ia|0)){Ja=Da;Ka=Ha}else{wL(Ha);f[Ga>>2]=Ia;f[q+40>>2]=c;Ja=f[xa>>2]|0;Ka=Ia}Ia=h+44|0;if((Ja|0)<3){c=f[Ia>>2]|0;f[Ka>>2]=f[c>>2];f[Ka+4>>2]=f[c+4>>2];La=c}else{f[Ga>>2]=f[Ia>>2];Ga=h+40|0;f[q+40>>2]=f[Ga>>2];c=h+48|0;f[Ia>>2]=c;f[Ga>>2]=Ca;La=c}f[h>>2]=1124007936;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;f[xa+16>>2]=0;f[xa+20>>2]=0;f[xa+24>>2]=0;f[xa+28>>2]=0;f[sa>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((La|0)!=(h+48|0))wL(La);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;F=i+8|0;f[F>>2]=0;f[F+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;AV(h,i)}else{F=h+8|0;f[F>>2]=0;f[F+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;jR(j,h)}F=Ba+J|0;switch(ya|0){case 0:case 3:break;default:{Ea=F;break c}}sa=h+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=o;jR(m,h);Ea=F}while(0);d:do switch(ya|0){case 0:{J=f[q+16>>2]|0;if(C)if(!(AP(J,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0)){K=266;break d}else{Ma=1;break d}else if(!(CP(J,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0)){K=266;break d}else{Ma=1;break d}break}case 3:{J=f[q+16>>2]|0;if(C)Na=EP(J,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0;else Na=GP(J,f[q+48>>2]|0,P,f[o+16>>2]|0,f[o+48>>2]|0,O)|0;if(Na)Ma=1;else K=266;break}case 4:{f[r>>2]=1124007936;J=r+4|0;Ba=r+8|0;La=r+40|0;G=J;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[La>>2]=Ba;A=r+48|0;wa=r+44|0;f[wa>>2]=A;f[A>>2]=0;f[r+52>>2]=0;if(d|za){Q=h+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=o;jR(m,h);Q=o+36|0;Ka=f[Q>>2]|0;if(Ka|0){Ja=Ka+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}Ja=r+36|0;Ka=f[Ja>>2]|0;do if(Ka|0){y=Ka+12|0;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break;V$(r)}while(0);f[Ja>>2]=0;Ka=r+16|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[J>>2]|0)>0){w=f[La>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0;Oa=f[J>>2]|0}while((y|0)<(Oa|0));f[r>>2]=f[o>>2];if((Oa|0)<3)K=164;else K=166}else{f[r>>2]=f[o>>2];K=164}do if((K|0)==164){y=f[o+4>>2]|0;if((y|0)>=3){K=166;break}f[J>>2]=y;f[Ba>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];y=f[o+44>>2]|0;w=f[wa>>2]|0;f[w>>2]=f[y>>2];f[w+4>>2]=f[y+4>>2]}while(0);if((K|0)==166)U$(r,o);f[Ka>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];f[r+24>>2]=f[o+24>>2];f[r+28>>2]=f[o+28>>2];f[r+32>>2]=f[o+32>>2];f[Ja>>2]=f[Q>>2]}else{f[i>>2]=1124007936;y=i+4|0;w=i+8|0;pa=i+40|0;G=y;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[pa>>2]=w;Q=i+48|0;f[i+44>>2]=Q;f[Q>>2]=0;f[i+52>>2]=0;f[h>>2]=W;f[h+4>>2]=O;S$(i,2,h,a);Ja=r+36|0;Ka=f[Ja>>2]|0;if(Ka|0?(oa=Ka+12|0,Ka=f[oa>>2]|0,f[oa>>2]=Ka+-1,(Ka|0)==1):0)V$(r);f[Ja>>2]=0;Ka=r+16|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[J>>2]|0)>0){oa=f[La>>2]|0;na=0;do{f[oa+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[J>>2]|0))}f[r>>2]=f[i>>2];na=f[y>>2]|0;f[J>>2]=na;f[Ba>>2]=f[w>>2];f[r+12>>2]=f[i+12>>2];oa=i+16|0;f[Ka>>2]=f[oa>>2];f[r+20>>2]=f[i+20>>2];f[r+24>>2]=f[i+24>>2];f[r+28>>2]=f[i+28>>2];f[r+32>>2]=f[i+32>>2];ma=i+36|0;f[Ja>>2]=f[ma>>2];L=r+44|0;N=f[L>>2]|0;if((N|0)==(A|0))Pa=na;else{wL(N);f[L>>2]=A;f[La>>2]=Ba;Pa=f[y>>2]|0}N=i+44|0;if((Pa|0)<3){na=f[N>>2]|0;f[A>>2]=f[na>>2];f[r+52>>2]=f[na+4>>2];Qa=na}else{f[L>>2]=f[N>>2];f[r+40>>2]=f[pa>>2];f[N>>2]=Q;f[pa>>2]=w;Qa=Q}f[i>>2]=1124007936;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[y+24>>2]=0;f[y+28>>2]=0;f[ma>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((Qa|0)!=(Q|0))wL(Qa);oa=h+8|0;f[oa>>2]=0;f[oa+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=r;jR(m,h)}oa=f[q+16>>2]|0;if(C)Ra=IP(oa,f[q+48>>2]|0,f[q+8>>2]|0,f[q+12>>2]|0,f[r+12>>2]|0,f[r+16>>2]|0,f[A>>2]|0,0)|0;else Ra=JP(oa,f[q+48>>2]|0,f[q+8>>2]|0,f[q+12>>2]|0,f[r+12>>2]|0,f[r+16>>2]|0,f[A>>2]|0,0)|0;oa=(Ra|0)==0;ma=f[o+8>>2]|0;if((f[Ba>>2]|0)!=(ma|0)){f[h>>2]=0;f[h+4>>2]=ma;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;W$(s,r,h,i);ma=h+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=o;jR(s,h);ma=s+36|0;N=f[ma>>2]|0;do if(N|0){L=N+12|0;na=f[L>>2]|0;f[L>>2]=na+-1;if((na|0)!=1)break;V$(s)}while(0);f[ma>>2]=0;N=s+16|0;Ba=s+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Ba>>2]|0)>0){N=f[s+40>>2]|0;Q=0;do{f[N+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[Ba>>2]|0))}Ba=f[s+44>>2]|0;if((Ba|0)!=(s+48|0))wL(Ba)}Ba=r+36|0;Q=f[Ba>>2]|0;do if(Q|0){N=Q+12|0;ma=f[N>>2]|0;f[N>>2]=ma+-1;if((ma|0)!=1)break;V$(r)}while(0);f[Ba>>2]=0;Q=r+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[J>>2]|0)>0){Q=f[La>>2]|0;ma=0;do{f[Q+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[J>>2]|0))}J=f[wa>>2]|0;if((J|0)!=(A|0))wL(J);if(oa)K=266;else Ma=1;break}default:{J=Ea+15&-16;Tj(h,P,P,a,J,D);Tj(i,P,1,a,J+(Y(D,P)|0)|0,0);f[r>>2]=1124007936;ma=r+4|0;Q=r+8|0;La=r+40|0;G=ma;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[La>>2]=Q;oa=r+48|0;A=r+44|0;f[A>>2]=oa;f[oa>>2]=0;f[r+52>>2]=0;wa=J+(Y(D+z|0,P)|0)|0;Ba=f[q+16>>2]|0;e:do if(H){if(C)kM(Ba,f[q+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,P,wa)|0;else lM(Ba,f[q+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,P,wa)|0;N=h+36|0;y=f[N>>2]|0;if(y|0){w=y+12|0;f[w>>2]=(f[w>>2]|0)+1}w=r+36|0;y=f[w>>2]|0;do if(y|0){pa=y+12|0;Ja=f[pa>>2]|0;f[pa>>2]=Ja+-1;if((Ja|0)!=1)break;V$(r)}while(0);f[w>>2]=0;y=r+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[ma>>2]|0)>0){Ja=f[La>>2]|0;pa=0;do{f[Ja+(pa<<2)>>2]=0;pa=pa+1|0;Sa=f[ma>>2]|0}while((pa|0)<(Sa|0));f[r>>2]=f[h>>2];if((Sa|0)<3)K=218}else{f[r>>2]=f[h>>2];K=218}do if((K|0)==218){pa=f[h+4>>2]|0;if((pa|0)>=3)break;f[ma>>2]=pa;f[Q>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];pa=f[h+44>>2]|0;Ja=f[A>>2]|0;f[Ja>>2]=f[pa>>2];f[Ja+4>>2]=f[pa+4>>2];Ta=N;Ua=w;Va=y;Wa=h;break e}while(0);U$(r,h);Ta=N;Ua=w;Va=y;Wa=h}else{if(C){pa=f[h+16>>2]|0;dM(Ba,f[q+48>>2]|0,f[i+16>>2]|0,pa,f[h+48>>2]|0,Aa,P,(pa|0)==0?0:P,1.1754943508222875e-38,2.384185791015625e-07)}else{pa=f[h+16>>2]|0;eM(Ba,f[q+48>>2]|0,f[i+16>>2]|0,pa,f[h+48>>2]|0,Aa,P,(pa|0)==0?0:P,2.2250738585072014e-308,2.220446049250313e-15)}pa=q+36|0;Ja=f[pa>>2]|0;if(Ja|0){Ka=Ja+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}Ka=r+36|0;Ja=f[Ka>>2]|0;do if(Ja|0){na=Ja+12|0;L=f[na>>2]|0;f[na>>2]=L+-1;if((L|0)!=1)break;V$(r)}while(0);f[Ka>>2]=0;Ja=r+16|0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[ma>>2]|0)>0){y=f[La>>2]|0;w=0;do{f[y+(w<<2)>>2]=0;w=w+1|0;Xa=f[ma>>2]|0}while((w|0)<(Xa|0));f[r>>2]=f[q>>2];if((Xa|0)<3)K=234}else{f[r>>2]=f[q>>2];K=234}do if((K|0)==234){w=f[q+4>>2]|0;if((w|0)>=3)break;f[ma>>2]=w;f[Q>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];w=f[q+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[w>>2];f[y+4>>2]=f[w+4>>2];Ta=pa;Ua=Ka;Va=Ja;Wa=q;break e}while(0);U$(r,q);Ta=pa;Ua=Ka;Va=Ja;Wa=q}while(0);f[Va>>2]=f[Wa+16>>2];f[r+20>>2]=f[Wa+20>>2];f[r+24>>2]=f[Wa+24>>2];f[r+28>>2]=f[Wa+28>>2];f[r+32>>2]=f[Wa+32>>2];f[Ua>>2]=f[Ta>>2];Q=i+16|0;Ba=f[Q>>2]|0;if(C)mM(Aa,P,Ba,0,f[r+16>>2]|0,f[oa>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[B>>2]|0,f[ua>>2]|0,O,f[o+16>>2]|0,f[o+48>>2]|0,wa);else nM(Aa,P,Ba,0,f[r+16>>2]|0,f[oa>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[B>>2]|0,f[ua>>2]|0,O,f[o+16>>2]|0,f[o+48>>2]|0,wa);Ba=r+36|0;J=f[Ba>>2]|0;if(J|0?(w=J+12|0,J=f[w>>2]|0,f[w>>2]=J+-1,(J|0)==1):0)V$(r);f[Ba>>2]=0;Ba=r+16|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;if((f[ma>>2]|0)>0){Ba=f[La>>2]|0;J=0;do{f[Ba+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[ma>>2]|0))}ma=f[A>>2]|0;if((ma|0)!=(oa|0))wL(ma);ma=i+36|0;J=f[ma>>2]|0;do if(J|0){Ba=J+12|0;La=f[Ba>>2]|0;f[Ba>>2]=La+-1;if((La|0)!=1)break;V$(i)}while(0);f[ma>>2]=0;J=i+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[J>>2]|0)>0){oa=f[i+40>>2]|0;A=0;do{f[oa+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[J>>2]|0))}J=f[i+44>>2]|0;if((J|0)!=(i+48|0))wL(J);J=h+36|0;A=f[J>>2]|0;do if(A|0){oa=A+12|0;Q=f[oa>>2]|0;f[oa>>2]=Q+-1;if((Q|0)!=1)break;V$(h)}while(0);f[J>>2]=0;A=h+16|0;Q=h+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[Q>>2]|0)>0){A=f[h+40>>2]|0;oa=0;do{f[A+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[Q>>2]|0))}Q=f[h+44>>2]|0;if((Q|0)!=(h+48|0))wL(Q);Ma=1}}while(0);if((K|0)==266){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;lR(o,h)|0;Ma=0}h=q+36|0;K=f[h>>2]|0;if(K|0?(i=K+12|0,K=f[i>>2]|0,f[i>>2]=K+-1,(K|0)==1):0)V$(q);f[h>>2]=0;h=q+16|0;K=q+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[K>>2]|0)>0){h=f[q+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[K>>2]|0))}K=f[q+44>>2]|0;if((K|0)!=(q+48|0))wL(K);K=o+36|0;q=f[K>>2]|0;if(q|0?(i=q+12|0,q=f[i>>2]|0,f[i>>2]=q+-1,(q|0)==1):0)V$(o);f[K>>2]=0;K=o+16|0;q=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[q>>2]|0)>0){K=f[o+40>>2]|0;i=0;do{f[K+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)!=(o+48|0))wL(q);q=f[qa>>2]|0;do if(q|0){o=q+12|0;i=f[o>>2]|0;f[o>>2]=i+-1;if((i|0)!=1)break;V$(m)}while(0);f[qa>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[x>>2]|0)>0){B=f[ta>>2]|0;ta=0;do{f[B+(ta<<2)>>2]=0;ta=ta+1|0}while((ta|0)<(f[x>>2]|0))}x=f[va>>2]|0;if((x|0)!=(ua|0))wL(x);x=f[l>>2]|0;if((x|0)!=(M|0)){if(x|0)dYc(x);f[l>>2]=M;f[E>>2]=1032}ka=Ma;la=ra}ra=f[la>>2]|0;if(ra|0?(Ma=ra+12|0,ra=f[Ma>>2]|0,f[Ma>>2]=ra+-1,(ra|0)==1):0)V$(k);f[la>>2]=0;la=k+16|0;ra=k+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[ra>>2]|0)>0){la=f[k+40>>2]|0;Ma=0;do{f[la+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[ra>>2]|0))}ra=f[k+44>>2]|0;if((ra|0)!=(k+48|0))wL(ra);ra=j+36|0;k=f[ra>>2]|0;if(k|0?(Ma=k+12|0,k=f[Ma>>2]|0,f[Ma>>2]=k+-1,(k|0)==1):0)V$(j);f[ra>>2]=0;ra=j+16|0;k=j+4|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[k>>2]|0)>0){ra=f[j+40>>2]|0;Ma=0;do{f[ra+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=g;return ka|0}wL(k);u=g;return ka|0}function qM(a){a=a|0;var c=0;f[a>>2]=35808;c=a+44|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+32|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+20|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+4|0;if((b[c+11>>0]|0)>=0)return;cYc(f[c>>2]|0);return}function rM(a){a=a|0;var c=0;f[a>>2]=35808;c=a+44|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+32|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+20|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+4|0;if((b[c+11>>0]|0)>=0){cYc(a);return}cYc(f[c>>2]|0);cYc(a);return}function sM(a){a=a|0;var c=0,d=0;c=a+4|0;if((b[c+11>>0]|0)<0){d=f[c>>2]|0;return d|0}else{d=c;return d|0}return 0}function tM(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=35828;if((f[a+4>>2]|0)==-1){u=c;return}else{b[d+11>>0]=10;c=d;a=219795;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));b[d+10>>0]=0;vM(-215,d,219806,219824,1504)}}function uM(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=35828;if((f[a+4>>2]|0)==-1){cYc(a);u=c;return}else{b[d+11>>0]=10;c=d;a=219795;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));b[d+10>>0]=0;vM(-215,d,219806,219824,1504)}}function vM(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+96|0;i=h+24|0;j=h+12|0;k=h;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;h=dJc(d)|0;if(h>>>0>4294967279)jYc(j);if(h>>>0<11){b[j+11>>0]=h;if(!h)l=j;else{m=j;n=6}}else{o=h+16&-16;p=$Xc(o)|0;f[j>>2]=p;f[j+8>>2]=o|-2147483648;f[j+4>>2]=h;m=p;n=6}if((n|0)==6){o1c(m|0,d|0,h|0)|0;l=m}b[l+h>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;h=dJc(e)|0;if(h>>>0>4294967279)jYc(k);if(h>>>0<11){b[k+11>>0]=h;if(!h){q=k;r=q+h|0;b[r>>0]=0;wM(i,a,c,j,k,g);xM(i)}else s=k}else{l=h+16&-16;m=$Xc(l)|0;f[k>>2]=m;f[k+8>>2]=l|-2147483648;f[k+4>>2]=h;s=m}o1c(s|0,e|0,h|0)|0;q=s;r=q+h|0;b[r>>0]=0;wM(i,a,c,j,k,g);xM(i)}function wM(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;f[a>>2]=35808;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[a+16>>2]=b;lYc(a+20|0,c);lYc(a+32|0,d);lYc(a+44|0,e);f[a+56>>2]=g;zM(a);return}function xM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+4144|0;d=c+32|0;e=c+8|0;g=c;h=c+40|0;c=f[135047]|0;if(!c){if(b[1160165]|0){i=f[a+16>>2]|0;do switch(i|0){case 0:{j=220699;break}case -1:{j=220689;break}case -2:{j=220671;break}case -3:{j=366811;break}case -4:{j=220651;break}case -5:{j=220638;break}case -7:{j=220611;break}case -8:{j=220596;break}case -201:{j=220566;break}case -27:{j=220553;break}case -202:{j=220527;break}case -13:{j=220507;break}case -203:{j=220472;break}case -204:{j=220441;break}case -17:{j=220394;break}case -205:{j=220354;break}case -209:{j=220316;break}case -211:{j=220275;break}case -210:{j=220230;break}case -24:{j=220203;break}case -15:{j=220180;break}case -206:{j=220140;break}case -207:{j=220110;break}case -208:{j=220084;break}case -212:{j=220070;break}case -213:{j=220030;break}case -214:{j=219998;break}case -215:{j=219981;break}case -216:{j=219965;break}case -217:{j=219952;break}case -218:{j=219934;break}case -219:{j=219918;break}default:{f[g>>2]=(i|0)>-1?219892:518812;f[g+4>>2]=i;cLc(1160166,219899,g)|0;j=1160166}}while(0);g=a+20|0;i=(b[g+11>>0]|0)<0?f[g>>2]|0:g;g=a+32|0;k=b[g+11>>0]|0;l=k<<24>>24<0;do if((l?f[a+36>>2]|0:k&255)|0)if(l){m=f[g>>2]|0;break}else{m=g;break}else m=220708;while(0);g=a+44|0;l=(b[g+11>>0]|0)<0?f[g>>2]|0:g;g=f[a+56>>2]|0;f[e>>2]=220775;f[e+4>>2]=j;f[e+8>>2]=i;f[e+12>>2]=m;f[e+16>>2]=l;f[e+20>>2]=g;yM(h,4096,220725,e)|0;pKc(f[46123]|0)|0;e=f[46249]|0;pKc(e)|0;f[d>>2]=h;OKc(e,220781,d)|0;pKc(e)|0}}else{e=a+32|0;d=a+20|0;h=a+44|0;xg[c&127](f[a+16>>2]|0,(b[e+11>>0]|0)<0?f[e>>2]|0:e,(b[d+11>>0]|0)<0?f[d>>2]|0:d,(b[h+11>>0]|0)<0?f[h>>2]|0:h,f[a+56>>2]|0,f[135048]|0)|0}if(!(b[1160422]|0)){n=af(60)|0;xk(n,a);ig(n|0,6704,1)}f[0]=0;aa();n=af(60)|0;xk(n,a);ig(n|0,6704,1)}function yM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=pJc(a,b,c,g)|0;u=e;return d|0}function zM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=u;u=u+288|0;d=c+88|0;e=c+80|0;g=c+48|0;h=c+40|0;i=c+8|0;j=c;k=c+272|0;l=c+128|0;m=c+116|0;n=a+20|0;o=JYc(n,10,0)|0;p=(o|0)!=-1;if(p){q=l+64|0;r=l+8|0;f[r>>2]=35876;s=l+12|0;f[l>>2]=6740;f[q>>2]=6760;f[l+4>>2]=0;XNc(l+64|0,s);f[l+136>>2]=0;f[l+140>>2]=-1;f[l>>2]=35856;f[q>>2]=35896;f[r>>2]=35876;aOc(s);f[s>>2]=35912;r=l+44|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[l+60>>2]=24;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;AM(s,k);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);t=l+8|0;v=m+11|0;w=0;x=o;do{o=BM(t,220785,2)|0;mYc(m,n,w,x-w|0,n);y=(b[v>>0]|0)<0?f[m>>2]|0:m;z=BM(o,y,dJc(y)|0)|0;ZNc(k,z+(f[(f[z>>2]|0)+-12>>2]|0)|0);y=DPc(k,896088)|0;o=Mi[f[(f[y>>2]|0)+28>>2]&1023](y,10)|0;EPc(k);sOc(z,o)|0;dOc(z)|0;if((b[v>>0]|0)<0)cYc(f[m>>2]|0);w=x+1|0;x=JYc(n,10,w)|0}while((x|0)!=-1);x=BM(t,220785,2)|0;mYc(k,n,w,-1,n);w=k+11|0;m=(b[w>>0]|0)<0?f[k>>2]|0:k;BM(x,m,dJc(m)|0)|0;if((b[w>>0]|0)<0)cYc(f[k>>2]|0);w=n+11|0;m=b[w>>0]|0;if(m<<24>>24<0){A=f[a+24>>2]|0;B=f[n>>2]|0}else{A=m&255;B=n}if((b[B+(A+-1)>>0]|0)!=10){ZNc(k,t+(f[(f[t>>2]|0)+-12>>2]|0)|0);A=DPc(k,896088)|0;B=Mi[f[(f[A>>2]|0)+28>>2]&1023](A,10)|0;EPc(k);sOc(t,B)|0;dOc(t)|0}CM(k,s);if((b[w>>0]|0)<0){b[f[n>>2]>>0]=0;f[a+24>>2]=0}else{b[n>>0]=0;b[w>>0]=0}sYc(n,0);f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];w=b[r+11>>0]|0;f[l>>2]=35856;f[q>>2]=35896;f[t>>2]=35876;f[s>>2]=35912;if(w<<24>>24<0)cYc(f[r>>2]|0);LMc(s);TNc(l,35972);GMc(q)}q=a+32|0;l=q+11|0;s=b[l>>0]|0;if(s<<24>>24<0)C=f[a+36>>2]|0;else C=s&255;if(!C){C=a+44|0;if((b[C+11>>0]|0)<0)D=f[C>>2]|0;else D=C;C=f[a+56>>2]|0;r=f[a+16>>2]|0;do switch(r|0){case 0:{E=220699;break}case -1:{E=220689;break}case -2:{E=220671;break}case -3:{E=366811;break}case -4:{E=220651;break}case -5:{E=220638;break}case -7:{E=220611;break}case -8:{E=220596;break}case -201:{E=220566;break}case -27:{E=220553;break}case -202:{E=220527;break}case -13:{E=220507;break}case -203:{E=220472;break}case -204:{E=220441;break}case -17:{E=220394;break}case -205:{E=220354;break}case -209:{E=220316;break}case -211:{E=220275;break}case -210:{E=220230;break}case -24:{E=220203;break}case -15:{E=220180;break}case -206:{E=220140;break}case -207:{E=220110;break}case -208:{E=220084;break}case -212:{E=220070;break}case -213:{E=220030;break}case -214:{E=219998;break}case -215:{E=219981;break}case -216:{E=219965;break}case -217:{E=219952;break}case -218:{E=219934;break}case -219:{E=219918;break}default:{f[e>>2]=(r|0)>-1?219892:518812;f[e+4>>2]=r;cLc(1160166,219899,e)|0;E=1160166}}while(0);if((b[n+11>>0]|0)<0)F=f[n>>2]|0;else F=n;f[d>>2]=220775;f[d+4>>2]=D;f[d+8>>2]=C;f[d+12>>2]=r;f[d+16>>2]=E;f[d+20>>2]=F;f[d+24>>2]=p?1165591:505563;DM(k,220895,d);d=a+4|0;F=d+11|0;if((b[F>>0]|0)<0){b[f[d>>2]>>0]=0;f[a+8>>2]=0}else{b[d>>0]=0;b[F>>0]=0}sYc(d,0);f[d>>2]=f[k>>2];f[d+4>>2]=f[k+4>>2];f[d+8>>2]=f[k+8>>2];u=c;return}if(p){p=a+44|0;if((b[p+11>>0]|0)<0)G=f[p>>2]|0;else G=p;p=f[a+56>>2]|0;d=f[a+16>>2]|0;do switch(d|0){case 0:{H=220699;I=s;break}case -1:{H=220689;I=s;break}case -2:{H=220671;I=s;break}case -3:{H=366811;I=s;break}case -4:{H=220651;I=s;break}case -5:{H=220638;I=s;break}case -7:{H=220611;I=s;break}case -8:{H=220596;I=s;break}case -201:{H=220566;I=s;break}case -27:{H=220553;I=s;break}case -202:{H=220527;I=s;break}case -13:{H=220507;I=s;break}case -203:{H=220472;I=s;break}case -204:{H=220441;I=s;break}case -17:{H=220394;I=s;break}case -205:{H=220354;I=s;break}case -209:{H=220316;I=s;break}case -211:{H=220275;I=s;break}case -210:{H=220230;I=s;break}case -24:{H=220203;I=s;break}case -15:{H=220180;I=s;break}case -206:{H=220140;I=s;break}case -207:{H=220110;I=s;break}case -208:{H=220084;I=s;break}case -212:{H=220070;I=s;break}case -213:{H=220030;I=s;break}case -214:{H=219998;I=s;break}case -215:{H=219981;I=s;break}case -216:{H=219965;I=s;break}case -217:{H=219952;I=s;break}case -218:{H=219934;I=s;break}case -219:{H=219918;I=s;break}default:{f[j>>2]=(d|0)>-1?219892:518812;f[j+4>>2]=d;cLc(1160166,219899,j)|0;H=1160166;I=b[l>>0]|0}}while(0);if(I<<24>>24<0)J=f[q>>2]|0;else J=q;if((b[n+11>>0]|0)<0)K=f[n>>2]|0;else K=n;f[i>>2]=220775;f[i+4>>2]=G;f[i+8>>2]=p;f[i+12>>2]=d;f[i+16>>2]=H;f[i+20>>2]=J;f[i+24>>2]=K;DM(k,220788,i);i=a+4|0;K=i+11|0;if((b[K>>0]|0)<0){b[f[i>>2]>>0]=0;f[a+8>>2]=0}else{b[i>>0]=0;b[K>>0]=0}sYc(i,0);f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];f[i+8>>2]=f[k+8>>2];u=c;return}else{i=a+44|0;if((b[i+11>>0]|0)<0)L=f[i>>2]|0;else L=i;i=f[a+56>>2]|0;K=f[a+16>>2]|0;do switch(K|0){case 0:{M=220699;break}case -1:{M=220689;break}case -2:{M=220671;break}case -3:{M=366811;break}case -4:{M=220651;break}case -5:{M=220638;break}case -7:{M=220611;break}case -8:{M=220596;break}case -201:{M=220566;break}case -27:{M=220553;break}case -202:{M=220527;break}case -13:{M=220507;break}case -203:{M=220472;break}case -204:{M=220441;break}case -17:{M=220394;break}case -205:{M=220354;break}case -209:{M=220316;break}case -211:{M=220275;break}case -210:{M=220230;break}case -24:{M=220203;break}case -15:{M=220180;break}case -206:{M=220140;break}case -207:{M=220110;break}case -208:{M=220084;break}case -212:{M=220070;break}case -213:{M=220030;break}case -214:{M=219998;break}case -215:{M=219981;break}case -216:{M=219965;break}case -217:{M=219952;break}case -218:{M=219934;break}case -219:{M=219918;break}default:{f[h>>2]=(K|0)>-1?219892:518812;f[h+4>>2]=K;cLc(1160166,219899,h)|0;M=1160166}}while(0);if((b[n+11>>0]|0)<0)N=f[n>>2]|0;else N=n;if((b[l>>0]|0)<0)O=f[q>>2]|0;else O=q;f[g>>2]=220775;f[g+4>>2]=L;f[g+8>>2]=i;f[g+12>>2]=K;f[g+16>>2]=M;f[g+20>>2]=N;f[g+24>>2]=O;DM(k,220841,g);g=a+4|0;O=g+11|0;if((b[O>>0]|0)<0){b[f[g>>2]>>0]=0;f[a+8>>2]=0}else{b[g>>0]=0;b[O>>0]=0}sYc(g,0);f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];u=c;return}}function AM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+32|0;oYc(d,c)|0;c=a+44|0;f[c>>2]=0;e=a+48|0;g=f[e>>2]|0;if(g&8|0){h=b[d+11>>0]|0;if(h<<24>>24<0){i=f[d>>2]|0;j=i;k=i;l=i+(f[a+36>>2]|0)|0}else{j=d;k=d;l=d+(h&255)|0}f[c>>2]=l;f[a+8>>2]=j;f[a+12>>2]=k;f[a+16>>2]=l}if(!(g&16))return;g=d+11|0;l=b[g>>0]|0;if(l<<24>>24<0){k=f[a+36>>2]|0;f[c>>2]=(f[d>>2]|0)+k;m=(f[a+40>>2]&2147483647)+-1|0;n=k}else{k=l&255;f[c>>2]=d+k;m=10;n=k}uYc(d,m,0);m=b[g>>0]|0;if(m<<24>>24<0){g=f[d>>2]|0;o=g;p=f[a+36>>2]|0;q=g}else{o=d;p=m&255;q=d}d=a+24|0;f[d>>2]=q;f[a+20>>2]=q;f[a+28>>2]=o+p;if(!(f[e>>2]&3))return;f[d>>2]=q+n;return}function BM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e+12|0;h=e;i=e+8|0;eOc(h,a);if(!(b[h>>0]|0)){fOc(h);u=e;return a|0}j=(f[a>>2]|0)+-12|0;f[i>>2]=f[a+(f[j>>2]|0)+24>>2];k=a+(f[j>>2]|0)|0;j=f[k+4>>2]|0;l=c+d|0;d=k+76|0;m=f[d>>2]|0;if((m|0)==-1){ZNc(g,k);n=DPc(g,896088)|0;o=Mi[f[(f[n>>2]|0)+28>>2]&1023](n,32)|0;EPc(g);n=o<<24>>24;f[d>>2]=n;p=n}else p=m;f[g>>2]=f[i>>2];if(EM(g,c,(j&176|0)==32?l:c,l,k,p&255)|0){fOc(h);u=e;return a|0}p=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(p,f[p+16>>2]|5);fOc(h);u=e;return a|0}function CM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=f[c+48>>2]|0;if(d&16|0){e=c+44|0;g=f[e>>2]|0;h=f[c+24>>2]|0;if(g>>>0<h>>>0){f[e>>2]=h;i=h}else i=g;g=f[c+20>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=i-g|0;if(h>>>0>4294967279)jYc(a);if(h>>>0<11){b[a+11>>0]=h;j=a}else{e=h+16&-16;k=$Xc(e)|0;f[a>>2]=k;f[a+8>>2]=e|-2147483648;f[a+4>>2]=h;j=k}if((g|0)==(i|0))l=j;else{k=j;e=g;while(1){b[k>>0]=b[e>>0]|0;e=e+1|0;if((e|0)==(i|0))break;else k=k+1|0}l=j+h|0}b[l>>0]=0;return}if(!(d&8)){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}d=f[c+8>>2]|0;l=f[c+16>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=l-d|0;if(c>>>0>4294967279)jYc(a);if(c>>>0<11){b[a+11>>0]=c;m=a}else{h=c+16&-16;j=$Xc(h)|0;f[a>>2]=j;f[a+8>>2]=h|-2147483648;f[a+4>>2]=c;m=j}if((d|0)==(l|0))n=m;else{j=m;a=d;while(1){b[j>>0]=b[a>>0]|0;a=a+1|0;if((a|0)==(l|0))break;else j=j+1|0}n=m+c|0}b[n>>0]=0;return}function DM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+1072|0;g=e+32|0;h=e+16|0;i=e;j=g+8|0;f[g>>2]=j;k=g+4|0;f[k>>2]=1024;f[h>>2]=d;l=f[k>>2]|0;m=pJc(f[g>>2]|0,l,c,h)|0;a:do if((m|0)>-1){n=m;o=l;while(1){if((n|0)<(o|0))break;p=n+1|0;q=f[k>>2]|0;if(q>>>0<p>>>0){r=f[g>>2]|0;if(p>>>0>1024)s=bYc(p)|0;else s=j;f[g>>2]=s;f[k>>2]=p;if((q|0)!=0&(s|0)!=(r|0)){b[s>>0]=b[r>>0]|0;if((q|0)!=1){b[s+1>>0]=b[r+1>>0]|0;if((q|0)==2)t=q;else{v=2;do{b[(f[g>>2]|0)+v>>0]=b[r+v>>0]|0;v=v+1|0}while((v|0)!=(q|0));t=q}}else t=1}else t=q;do{b[(f[g>>2]|0)+t>>0]=0;t=t+1|0}while((t|0)!=(p|0));if(!((r|0)==(j|0)|(r|0)==0))dYc(r)}else f[k>>2]=p;f[h>>2]=d;q=f[k>>2]|0;v=pJc(f[g>>2]|0,q,c,h)|0;if((v|0)>-1){n=v;o=q}else break a}b[(f[g>>2]|0)+(o+-1)>>0]=0;q=f[g>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(n>>>0<11){b[a+11>>0]=n;if(!n)w=a;else{x=a;y=19}}else{v=n+16&-16;z=$Xc(v)|0;f[a>>2]=z;f[a+8>>2]=v|-2147483648;f[a+4>>2]=n;x=z;y=19}if((y|0)==19){o1c(x|0,q|0,n|0)|0;w=x}b[w+n>>0]=0;q=f[g>>2]|0;if((q|0)==(j|0)){u=e;return}if(q|0)dYc(q);f[g>>2]=j;f[k>>2]=1024;u=e;return}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;e=$Xc(48)|0;f[i>>2]=e;f[i+8>>2]=-2147483600;f[i+4>>2]=44;k=e;j=220933;g=k+44|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(g|0));b[e+44>>0]=0;vM(-215,i,228275,219824,834)}function EM(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;if(!k){l=0;u=i;return l|0}m=e;e=c;n=m-e|0;o=g+12|0;g=f[o>>2]|0;p=(g|0)>(n|0)?g-n|0:0;n=d;g=n-e|0;if((g|0)>0?(hj[f[(f[k>>2]|0)+48>>2]&511](k,c,g)|0)!=(g|0):0){f[a>>2]=0;l=0;u=i;return l|0}do if((p|0)>0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(p>>>0<11){g=j+11|0;b[g>>0]=p;q=j;r=g;s=j}else{g=p+16&-16;c=$Xc(g)|0;f[j>>2]=c;f[j+8>>2]=g|-2147483648;f[j+4>>2]=p;q=c;r=j+11|0;s=j}g1c(q|0,h|0,p|0)|0;b[q+p>>0]=0;if((hj[f[(f[k>>2]|0)+48>>2]&511](k,(b[r>>0]|0)<0?f[s>>2]|0:j,p)|0)==(p|0)){if((b[r>>0]|0)<0)cYc(f[s>>2]|0);break}f[a>>2]=0;if((b[r>>0]|0)<0)cYc(f[s>>2]|0);l=0;u=i;return l|0}while(0);s=m-n|0;if((s|0)>0?(hj[f[(f[k>>2]|0)+48>>2]&511](k,d,s)|0)!=(s|0):0){f[a>>2]=0;l=0;u=i;return l|0}f[o>>2]=0;l=k;u=i;return l|0}function FM(a){a=a|0;var c=0;f[a>>2]=35912;c=a+32|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);LMc(a);return}function GM(a){a=a|0;var c=0;f[a>>2]=35912;c=a+32|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);LMc(a);cYc(a);return}function HM(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+44|0;j=f[i>>2]|0;k=c+24|0;l=f[k>>2]|0;m=l;if(j>>>0<l>>>0){f[i>>2]=l;n=m}else n=j;j=h&24;a:do if((j|0)!=0?!((g|0)==1&(j|0)==24):0){b:do switch(g|0){case 0:{o=0;p=0;break}case 1:{if(!(h&8)){i=m-(f[c+20>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}else{i=(f[c+12>>2]|0)-(f[c+8>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}break}case 2:{i=c+32|0;if((b[i+11>>0]|0)<0)q=f[i>>2]|0;else q=i;i=n-q|0;o=i;p=((i|0)<0)<<31>>31;break}default:{r=-1;s=-1;break a}}while(0);i=d1c(o|0,p|0,d|0,e|0)|0;t=J;if((t|0)>=0){u=c+32|0;if((b[u+11>>0]|0)<0)v=f[u>>2]|0;else v=u;u=n-v|0;w=((u|0)<0)<<31>>31;if(!((w|0)<(t|0)|(w|0)==(t|0)&u>>>0<i>>>0)){u=h&8;if(!((i|0)==0&(t|0)==0)){if(u|0?(f[c+12>>2]|0)==0:0){r=-1;s=-1;break}if((h&16|0)!=0&(l|0)==0){r=-1;s=-1;break}}if(u|0){f[c+12>>2]=(f[c+8>>2]|0)+i;f[c+16>>2]=n}if(!(h&16)){r=i;s=t}else{f[k>>2]=(f[c+20>>2]|0)+i;r=i;s=t}}else{r=-1;s=-1}}else{r=-1;s=-1}}else{r=-1;s=-1}while(0);c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=r;f[c+4>>2]=s;return}function IM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=c+8|0;Fh[f[(f[b>>2]|0)+16>>2]&255](a,b,f[e>>2]|0,f[e+4>>2]|0,0,d);return}function JM(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,i=0;b=a+44|0;c=f[b>>2]|0;d=f[a+24>>2]|0;if(c>>>0<d>>>0){f[b>>2]=d;e=d}else e=c;if(!(f[a+48>>2]&8)){g=-1;return g|0}c=a+16|0;d=f[c>>2]|0;if(d>>>0<e>>>0){f[c>>2]=e;i=e}else i=d;d=f[a+12>>2]|0;if(d>>>0>=i>>>0){g=-1;return g|0}g=h[d>>0]|0;return g|0}function KM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+44|0;e=f[d>>2]|0;g=f[a+24>>2]|0;if(e>>>0<g>>>0){f[d>>2]=g;h=g}else h=e;e=h;h=a+12|0;g=f[h>>2]|0;if((f[a+8>>2]|0)>>>0>=g>>>0){i=-1;return i|0}if((c|0)==-1){f[h>>2]=g+-1;f[a+16>>2]=e;i=0;return i|0}if(!(f[a+48>>2]&16)){d=c&255;j=g+-1|0;if(d<<24>>24==(b[j>>0]|0)){k=d;l=j}else{i=-1;return i|0}}else{k=c&255;l=g+-1|0}f[h>>2]=l;f[a+16>>2]=e;b[l>>0]=k;i=c;return i|0}function LM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;if((c|0)==-1){g=0;u=d;return g|0}h=a+12|0;i=a+8|0;j=(f[h>>2]|0)-(f[i>>2]|0)|0;k=a+24|0;l=f[k>>2]|0;m=a+28|0;n=f[m>>2]|0;if((l|0)==(n|0)){o=a+48|0;if(!(f[o>>2]&16)){g=-1;u=d;return g|0}p=a+20|0;q=f[p>>2]|0;r=a+44|0;s=(f[r>>2]|0)-q|0;t=a+32|0;BYc(t,0);v=t+11|0;if((b[v>>0]|0)<0)w=(f[a+40>>2]&2147483647)+-1|0;else w=10;uYc(t,w,0);w=b[v>>0]|0;if(w<<24>>24<0){x=f[t>>2]|0;y=f[a+36>>2]|0}else{x=t;y=w&255}w=x+y|0;f[p>>2]=x;f[m>>2]=w;m=x+(l-q)|0;f[k>>2]=m;q=x+s|0;f[r>>2]=q;z=r;A=o;B=r;C=m;D=q;E=w}else{w=a+44|0;z=w;A=a+48|0;B=w;C=l;D=f[w>>2]|0;E=n}n=C+1|0;f[e>>2]=n;w=f[(n>>>0<D>>>0?B:e)>>2]|0;f[z>>2]=w;if(f[A>>2]&8|0){A=a+32|0;if((b[A+11>>0]|0)<0)F=f[A>>2]|0;else F=A;f[i>>2]=F;f[h>>2]=F+j;f[a+16>>2]=w}if((C|0)==(E|0)){g=Mi[f[(f[a>>2]|0)+52>>2]&1023](a,c&255)|0;u=d;return g|0}else{f[k>>2]=n;b[C>>0]=c;g=c&255;u=d;return g|0}return 0}function MM(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=35856;c=a+64|0;f[c>>2]=35896;f[a+8>>2]=35876;d=a+12|0;f[d>>2]=35912;e=a+44|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);TNc(a,35972);GMc(c);return}function NM(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=35856;c=a+64|0;f[c>>2]=35896;f[a+8>>2]=35876;d=a+12|0;f[d>>2]=35912;e=a+44|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);TNc(a,35972);GMc(c);cYc(a);return}function OM(a){a=a|0;var c=0,d=0,e=0;c=a+-8|0;f[c>>2]=35856;a=c+64|0;f[a>>2]=35896;f[c+8>>2]=35876;d=c+12|0;f[d>>2]=35912;e=c+44|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);TNc(c,35972);GMc(a);return}function PM(a){a=a|0;var c=0,d=0,e=0;c=a+-8|0;f[c>>2]=35856;a=c+64|0;f[a>>2]=35896;f[c+8>>2]=35876;d=c+12|0;f[d>>2]=35912;e=c+44|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);TNc(c,35972);GMc(a);cYc(c);return}function QM(a){a=a|0;var c=0,d=0,e=0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[c>>2]=35856;a=c+64|0;f[a>>2]=35896;f[c+8>>2]=35876;d=c+12|0;f[d>>2]=35912;e=c+44|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);TNc(c,35972);GMc(a);return}function RM(a){a=a|0;var c=0,d=0,e=0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[c>>2]=35856;a=c+64|0;f[a>>2]=35896;f[c+8>>2]=35876;d=c+12|0;f[d>>2]=35912;e=c+44|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);TNc(c,35972);GMc(a);cYc(c);return}function SM(){var a=0,c=0,d=0;a=f[135049]|0;if(!a){c=$Xc(28)|0;WXc(c);f[135049]=c;d=c}else d=a;f[135046]=d;d=(TM(221137,0)|0)&1;b[1160165]=d;g1c(1160423,0,512)|0;UM(1160423);g1c(1160936,0,512)|0;return}function TM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d+12|0;g=d;b[e>>0]=c&1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=dJc(a)|0;if(c>>>0>4294967279)jYc(g);if(c>>>0<11){b[g+11>>0]=c;if(!c)h=g;else{i=g;j=6}}else{k=c+16&-16;l=$Xc(k)|0;f[g>>2]=l;f[g+8>>2]=k|-2147483648;f[g+4>>2]=c;i=l;j=6}if((j|0)==6){o1c(i|0,a|0,c|0)|0;h=i}b[h+c>>0]=0;c=WM(g,e)|0;if((b[g+11>>0]|0)>=0){u=d;return c|0}cYc(f[g>>2]|0);u=d;return c|0}function UM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=c+4|0;if(jf(221156)|0){g=f[46249]|0;if((b[529984]|0)==0?X0c(529984)|0:0){f[135050]=0;f[135051]=0;f[135052]=0;h=$Xc(4432)|0;f[135050]=h;f[135052]=-2147479216;f[135051]=4419;o1c(h|0,221175,4419)|0;b[h+4419>>0]=0;be(2220,540200,x|0)|0}f[d>>2]=(b[540211]|0)<0?f[135050]|0:540200;OKc(g,225595,d)|0}g1c(540212,0,2048)|0;f[135054]=225631;f[135055]=225635;f[135056]=225639;f[135057]=225644;f[135058]=225649;f[135059]=225655;f[135060]=225662;f[135061]=225669;f[135062]=225676;f[135063]=225681;f[135064]=225685;f[135065]=225690;f[135066]=225695;f[135067]=225703;f[135068]=225712;f[135069]=225721;f[135070]=225730;f[135071]=225739;f[135072]=225750;f[135073]=225759;f[135074]=225770;f[135153]=225779;f[135253]=225784;f[135309]=225788;b[a+200>>0]=0;f[e>>2]=0;VM(a,e,1);u=c;return}function VM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+32|0;k=e+20|0;l=jf(225799)|0;if(!l){u=e;return}if(!(b[l>>0]|0)){u=e;return}m=j+11|0;n=j+4|0;o=f[46249]|0;p=(d|0)>0;q=j+8|0;r=l;a:while(1){l=r;b:while(1){s=b[l>>0]|0;switch(s<<24>>24){case 0:{t=34;break a;break}case 44:case 59:break;default:{v=l;w=s;break b}}l=l+1|0}while(1){if(!(w<<24>>24==44^w<<24>>24!=59)){x=v;break}s=v+1|0;w=b[s>>0]|0;if(!(w<<24>>24)){x=s;break}else v=s}if((x|0)==(l|0)){r=l;continue};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;s=x-l|0;if(s>>>0>4294967279){t=11;break}if(s>>>0<11){b[m>>0]=s;y=j}else{z=s+16&-16;A=$Xc(z)|0;f[j>>2]=A;f[q>>2]=z|-2147483648;f[n>>2]=s;y=A}A=y;z=l;while(1){b[A>>0]=b[z>>0]|0;z=z+1|0;if((z|0)==(x|0))break;else A=A+1|0}b[y+s>>0]=0;A=b[m>>0]|0;if(!((A<<24>>24<0?f[n>>2]|0:A&255)|0)){t=18;break}else B=0;while(1){C=540212+(B<<2)|0;A=f[C>>2]|0;if((A|0?(z=dJc(A)|0,l=b[m>>0]|0,(z|0)==((l<<24>>24<0?f[n>>2]|0:l&255)|0)):0)?(MYc(j,A)|0)==0:0){t=22;break}A=B+1|0;if((A|0)<512)B=A;else{t=30;break}}if((t|0)==22){t=0;c:do if(p){s=0;while(1){if((f[c+(s<<2)>>2]|0)==(B|0))break;s=s+1|0;if((s|0)>=(d|0))break c}s=f[C>>2]|0;f[i>>2]=s|0?s:225850;OKc(o,225866,i)|0}while(0);s=a+B|0;if(!(b[s>>0]|0)){A=f[C>>2]|0;f[h>>2]=A|0?A:225850;OKc(o,226043,h)|0}b[s>>0]=0}else if((t|0)==30){t=0;f[g>>2]=(b[m>>0]|0)<0?f[j>>2]|0:j;OKc(o,226125,g)|0}if((b[m>>0]|0)<0)cYc(f[j>>2]|0);r=x}if((t|0)==11)jYc(j);else if((t|0)==18){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(32)|0;f[k>>2]=j;f[k+8>>2]=-2147483616;f[k+4>>2]=18;x=j;r=225818;m=x+18|0;do{b[x>>0]=b[r>>0]|0;x=x+1|0;r=r+1|0}while((x|0)<(m|0));b[j+18>>0]=0;vM(-215,k,225837,219824,601)}else if((t|0)==34){u=e;return}}function WM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=jf(((b[a+11>>0]|0)<0?f[a>>2]|0:a)|0)|0;if(!g){h=(b[c>>0]|0)!=0;u=d;return h|0};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=dJc(g)|0;if(c>>>0>4294967279)jYc(e);if(c>>>0<11){b[e+11>>0]=c;if(!c)i=e;else{j=e;k=7}}else{a=c+16&-16;l=$Xc(a)|0;f[e>>2]=l;f[e+8>>2]=a|-2147483648;f[e+4>>2]=c;j=l;k=7}if((k|0)==7){o1c(j|0,g|0,c|0)|0;i=j}b[i+c>>0]=0;c=XM(e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=c;u=d;return h|0}function XM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+16|0;d=c;e=a+11|0;g=b[e>>0]|0;h=a+4|0;i=f[h>>2]|0;do if(((g<<24>>24<0?i:g&255)|0)==1)if(!(LYc(a,0,-1,226296,1)|0)){j=1;u=c;return j|0}else{k=b[e>>0]|0;l=f[h>>2]|0;break}else{k=g;l=i}while(0);do if(((k<<24>>24<0?l:k&255)|0)==4)if(!(LYc(a,0,-1,506361,4)|0)){j=1;u=c;return j|0}else{m=b[e>>0]|0;n=f[h>>2]|0;break}else{m=k;n=l}while(0);do if(((m<<24>>24<0?n:m&255)|0)==4)if(!(LYc(a,0,-1,529255,4)|0)){j=1;u=c;return j|0}else{o=b[e>>0]|0;p=f[h>>2]|0;break}else{o=m;p=n}while(0);do if(((o<<24>>24<0?p:o&255)|0)==4)if(!(LYc(a,0,-1,226298,4)|0)){j=1;u=c;return j|0}else{q=b[e>>0]|0;r=f[h>>2]|0;break}else{q=o;r=p}while(0);do if(((q<<24>>24<0?r:q&255)|0)==1)if(!(LYc(a,0,-1,518784,1)|0)){j=0;u=c;return j|0}else{s=b[e>>0]|0;t=f[h>>2]|0;break}else{s=q;t=r}while(0);do if(((s<<24>>24<0?t:s&255)|0)==5)if(!(LYc(a,0,-1,506368,5)|0)){j=0;u=c;return j|0}else{v=b[e>>0]|0;w=f[h>>2]|0;break}else{v=s;w=t}while(0);do if(((v<<24>>24<0?w:v&255)|0)==5)if(!(LYc(a,0,-1,529249,5)|0)){j=0;u=c;return j|0}else{x=b[e>>0]|0;y=f[h>>2]|0;break}else{x=v;y=w}while(0);if(((x<<24>>24<0?y:x&255)|0)!=5){z=af(12)|0;lYc(d,a);lYc(z,d);ig(z|0,6864,2221)}if(!(LYc(a,0,-1,226303,5)|0)){j=0;u=c;return j|0}else{z=af(12)|0;lYc(d,a);lYc(z,d);ig(z|0,6864,2221)}return 0}function YM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+160|0;g=e+136|0;h=e;i=h+56|0;j=h+4|0;f[h>>2]=6884;f[i>>2]=6904;XNc(h+56|0,j);f[h+128>>2]=0;f[h+132>>2]=-1;f[h>>2]=36020;f[i>>2]=36040;aOc(j);f[j>>2]=35912;k=h+36|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[h+52>>2]=16;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(j,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);g=BM(h,226179,28)|0;l=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=BM(BM(g,l,dJc(l)|0)|0,518985,2)|0;l=(b[c+11>>0]|0)<0?f[c>>2]|0:c;BM(d,l,dJc(l)|0)|0;CM(a,j);f[h>>2]=36020;f[i>>2]=36040;f[j>>2]=35912;if((b[k+11>>0]|0)>=0){LMc(j);HNc(h,36052);GMc(i);u=e;return}cYc(f[k>>2]|0);LMc(j);HNc(h,36052);GMc(i);u=e;return}function ZM(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=36020;c=a+56|0;f[c>>2]=36040;d=a+4|0;f[d>>2]=35912;e=a+36|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);HNc(a,36052);GMc(c);return}function _M(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=36020;c=a+56|0;f[c>>2]=36040;d=a+4|0;f[d>>2]=35912;e=a+36|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);HNc(a,36052);GMc(c);cYc(a);return}function $M(a){a=a|0;var c=0,d=0,e=0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[c>>2]=36020;a=c+56|0;f[a>>2]=36040;d=c+4|0;f[d>>2]=35912;e=c+36|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);HNc(c,36052);GMc(a);return}function aN(a){a=a|0;var c=0,d=0,e=0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[c>>2]=36020;a=c+56|0;f[a>>2]=36040;d=c+4|0;f[d>>2]=35912;e=c+36|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);HNc(c,36052);GMc(a);cYc(c);return}function bN(a){a=a|0;if((b[a+11>>0]|0)>=0)return;cYc(f[a>>2]|0);return}function cN(){var a=0,b=0;a=f[135049]|0;if(a|0){b=a;return b|0}a=$Xc(28)|0;WXc(a);f[135049]=a;b=a;return b|0}function dN(a){a=a|0;return vL(a)|0}function eN(a){a=a|0;var b=0;f[a>>2]=35808;b=a+4|0;a=b+56|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function fN(a){a=a|0;return (b[(f[9016]|0)+a>>0]|0)!=0|0}function gN(){var a=0,b=0,c=0,d=0;if(f[135566]|0){a=f[135566]|0;return a|0}b=f[135049]|0;if(!b){c=$Xc(28)|0;WXc(c);f[135049]=c;d=c}else d=b;YXc(d);if(!(f[135566]|0)){b=$Xc(8)|0;f[b>>2]=35828;c=pN(iN()|0)|0;f[b+4>>2]=c;f[b>>2]=36076;f[135566]=b}ZXc(d);a=f[135566]|0;return a|0}function hN(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=a+4|0;if((f[e>>2]|0)==-1){g=$Xc(64)|0;f[d>>2]=g;f[d+8>>2]=-2147483584;f[d+4>>2]=63;h=g;i=226309;j=h+63|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+63>>0]=0;vM(-215,d,226373,219824,1533)}d=iN()|0;g=jN(d,f[e>>2]|0)|0;if(g|0){k=g;u=c;return k|0}g=_i[f[(f[a>>2]|0)+8>>2]&2047](a)|0;a=iN()|0;kN(a,f[e>>2]|0,g);k=g;u=c;return k|0}function iN(){var a=0,b=0,c=0,d=0;if(f[135565]|0){a=f[135565]|0;return a|0}b=f[135049]|0;if(!b){c=$Xc(28)|0;WXc(c);f[135049]=c;d=c}else d=b;YXc(d);if(!(f[135565]|0)){b=$Xc(60)|0;nN(b);f[135565]=b}ZXc(d);a=f[135565]|0;return a|0}function jN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;if((f[a+32>>2]|0)>>>0<=c>>>0){g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=22;h=g;i=226381;j=h+22|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+22>>0]=0;vM(-215,e,226373,219824,1426)}e=Bf(f[a>>2]|0)|0;if(!e){k=0;u=d;return k|0}a=f[e>>2]|0;if((f[e+4>>2]|0)-a>>2>>>0<=c>>>0){k=0;u=d;return k|0}k=f[a+(c<<2)>>2]|0;u=d;return k|0}function kN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e+4|0;h=e;if((f[a+32>>2]|0)>>>0<=c>>>0){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=22;j=i;k=226381;l=j+22|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+22>>0]=0;vM(-215,g,226404,219824,1458)}i=Bf(f[a>>2]|0)|0;f[h>>2]=i;if(!i){m=$Xc(16)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;n=$Xc(128)|0;o=n;f[m>>2]=o;f[m+4>>2]=o;f[m+8>>2]=n+128;f[h>>2]=m;n=m;if(fg(f[a>>2]|0,m|0)|0){o=$Xc(48)|0;f[g>>2]=o;f[g+8>>2]=-2147483600;f[g+4>>2]=39;j=o;k=226412;l=j+39|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+39>>0]=0;vM(-215,g,226452,219824,1314)}o=a+4|0;YXc(o);k=a+48|0;j=a+52|0;l=f[j>>2]|0;f[m+12>>2]=l-(f[k>>2]|0)>>2;if((l|0)==(f[a+56>>2]|0))lN(k,h);else{f[l>>2]=n;f[j>>2]=(f[j>>2]|0)+4}ZXc(o);p=f[h>>2]|0}else p=i;if((f[p+4>>2]|0)-(f[p>>2]|0)>>2>>>0>c>>>0){q=p;r=f[q>>2]|0;s=r+(c<<2)|0;f[s>>2]=d;u=e;return}p=a+4|0;YXc(p);a=f[h>>2]|0;i=c+1|0;f[g>>2]=0;o=a+4|0;j=f[o>>2]|0;n=f[a>>2]|0;l=j-n>>2;k=n;n=j;if(i>>>0<=l>>>0){if(i>>>0<l>>>0?(j=k+(i<<2)|0,(n|0)!=(j|0)):0)f[o>>2]=n+(~((n+-4-j|0)>>>2)<<2)}else mN(a,i-l|0,g);ZXc(p);q=f[h>>2]|0;r=f[q>>2]|0;s=r+(c<<2)|0;f[s>>2]=d;u=e;return}function lN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function mN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=f[c>>2];j=(f[g>>2]|0)+4|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>2;h=j+b|0;if(h>>>0>1073741823)kWc(a);k=e-i|0;i=k>>1;e=k>>2>>>0<536870911?(i>>>0<h>>>0?h:i):1073741823;do if(e)if(e>>>0>1073741823){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e<<2)|0;break}else l=0;while(0);i=l+(j<<2)|0;j=l+(e<<2)|0;e=b;b=i;l=i;do{f[b>>2]=f[c>>2];b=l+4|0;l=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>2)<<2)|0;if((b|0)>0)o1c(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=l;f[d>>2]=j;if(!e)return;cYc(e);return}function nN(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!(nf(a|0,0)|0)){WXc(a+4|0);e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;e=$Xc(128)|0;g=e;f[a+36>>2]=g;f[a+40>>2]=g;f[a+44>>2]=e+128;e=$Xc(128)|0;g=e;f[a+48>>2]=g;f[a+52>>2]=g;f[a+56>>2]=e+128;u=c;return}else{c=$Xc(48)|0;f[d>>2]=c;f[d+8>>2]=-2147483600;f[d+4>>2]=38;e=c;a=226460;g=e+38|0;do{b[e>>0]=b[a>>0]|0;e=e+1|0;a=a+1|0}while((e|0)<(g|0));b[c+38>>0]=0;vM(-215,d,226499,219824,1302)}}function oN(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!(Qd(f[a>>2]|0)|0)){u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=31;a=c;e=226514;g=a+31|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));b[c+31>>0]=0;vM(-215,d,226546,219824,1306)}}function pN(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c;e=a+4|0;YXc(e);g=a+32|0;h=f[g>>2]|0;i=a+36|0;j=a+40|0;k=f[j>>2]|0;l=f[i>>2]|0;m=l;n=k;if((h|0)!=(k-l>>2|0)){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;l=$Xc(32)|0;f[d>>2]=l;f[d+8>>2]=-2147483616;f[d+4>>2]=31;k=l;o=226562;p=k+31|0;do{b[k>>0]=b[o>>0]|0;k=k+1|0;o=o+1|0}while((k|0)<(p|0));b[l+31>>0]=0;vM(-215,d,226639,219824,1381)}a:do if(h|0){l=0;while(1){q=m+(l<<2)|0;if(!(f[q>>2]|0))break;o=l+1|0;if(o>>>0<h>>>0)l=o;else break a}f[q>>2]=1;r=l;ZXc(e);u=c;return r|0}while(0);f[d>>2]=1;if(n>>>0<(f[a+44>>2]|0)>>>0){f[n>>2]=1;f[j>>2]=n+4}else LA(i,d);d=f[g>>2]|0;f[g>>2]=d+1;r=d;ZXc(e);u=c;return r|0}function qN(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=36076;uN(a);f[a>>2]=35828;if((f[a+4>>2]|0)==-1){u=c;return}else{b[d+11>>0]=10;c=d;a=219795;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));b[d+10>>0]=0;vM(-215,d,219806,219824,1504)}}function rN(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=36076;uN(a);f[a>>2]=35828;if((f[a+4>>2]|0)==-1){cYc(a);u=c;return}else{b[d+11>>0]=10;c=d;a=219795;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));b[d+10>>0]=0;vM(-215,d,219806,219824,1504)}}function sN(a){a=a|0;var b=0;a=$Xc(32)|0;b=a;f[b>>2]=-1;f[b+4>>2]=0;f[a+8>>2]=0;WQ(a+12|0);f[a+16>>2]=-1;f[a+20>>2]=-1;f[a+24>>2]=-1;return a|0}function tN(a,b){a=a|0;b=b|0;if(!b)return;XQ(b+12|0);cYc(b);return}function uN(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+16|0;c=b;f[c>>2]=0;d=c+4|0;f[d>>2]=0;f[c+8>>2]=0;e=$Xc(128)|0;g=e;f[c>>2]=g;f[d>>2]=g;f[c+8>>2]=e+128;e=iN()|0;g=a+4|0;vN(e,f[g>>2]|0,c,0);f[g>>2]=-1;g=f[d>>2]|0;e=f[c>>2]|0;h=e;if((g|0)==(e|0)){i=g;j=h}else{g=0;e=h;while(1){mi[f[(f[a>>2]|0)+12>>2]&2047](a,f[e+(g<<2)>>2]|0);g=g+1|0;h=f[d>>2]|0;k=f[c>>2]|0;l=k;if(g>>>0>=h-k>>2>>>0){i=h;j=l;break}else e=l}}e=i;if(!j){u=b;return}if((e|0)!=(j|0))f[d>>2]=e+(~((e+-4-j|0)>>>2)<<2);cYc(j);u=b;return}function vN(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;h=g;i=a+4|0;YXc(i);j=f[a+32>>2]|0;k=a+36|0;if((j|0)!=((f[a+40>>2]|0)-(f[k>>2]|0)>>2|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=$Xc(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=31;m=l;n=226562;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+31>>0]=0;vM(-215,h,226594,219824,1402)}if(j>>>0<=c>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=22;m=j;n=226381;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[j+22>>0]=0;vM(-215,h,226594,219824,1403)}h=a+48|0;j=a+52|0;a=f[j>>2]|0;n=f[h>>2]|0;if((a|0)!=(n|0)){m=d+4|0;o=d+8|0;l=0;p=n;n=a;while(1){a=f[p+(l<<2)>>2]|0;if(((a|0)!=0?(q=f[a>>2]|0,(f[a+4>>2]|0)-q>>2>>>0>c>>>0):0)?(r=q+(c<<2)|0,q=f[r>>2]|0,s=q,(q|0)!=0):0){q=f[m>>2]|0;if((q|0)==(f[o>>2]|0))wN(d,r);else{f[q>>2]=s;f[m>>2]=(f[m>>2]|0)+4}f[(f[a>>2]|0)+(c<<2)>>2]=0;t=f[h>>2]|0;v=f[j>>2]|0}else{t=p;v=n}l=l+1|0;if(l>>>0>=v-t>>2>>>0)break;else{p=t;n=v}}}if(e){ZXc(i);u=g;return}f[(f[k>>2]|0)+(c<<2)>>2]=0;ZXc(i);u=g;return}function wN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function xN(){var a=0,b=0,c=0,d=0;a=u;u=u+16|0;b=a+8|0;Qe(b|0,a|0)|0;c=f[b>>2]|0;d=x1c(c|0,((c|0)<0)<<31>>31|0,1e6,0)|0;c=f[b+4>>2]|0;b=d1c(d|0,J|0,c|0,((c|0)<0)<<31>>31|0)|0;u=a;return b|0}function yN(){return 1.0e6}function zN(){var a=0;if(b[529984]|0)return 540200;if(!(X0c(529984)|0))return 540200;f[135050]=0;f[135051]=0;f[135052]=0;a=$Xc(4432)|0;f[135050]=a;f[135052]=-2147479216;f[135051]=4419;o1c(a|0,221175,4419)|0;b[a+4419>>0]=0;be(2220,540200,x|0)|0;return 540200}function AN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=dJc(d)|0;i=g?f[c>>2]|0:c;c=h+e|0;if(c>>>0>4294967279)jYc(a);if(c>>>0<11){b[a+11>>0]=h;j=a}else{g=c+16&-16;c=$Xc(g)|0;f[a>>2]=c;f[a+8>>2]=g|-2147483648;f[a+4>>2]=h;j=c}if(!h){k=j+h|0;b[k>>0]=0;zYc(a,d,e)|0;return}o1c(j|0,i|0,h|0)|0;k=j+h|0;b[k>>0]=0;zYc(a,d,e)|0;return}function BN(a){a=a|0;var b=0;f[a>>2]=35828;b=pN(iN()|0)|0;f[a+4>>2]=b;return}function CN(){var a=0,b=0,c=0,d=0,e=0,g=0;if(f[135567]|0){a=f[135567]|0;b=hN(a)|0;c=f[b>>2]|0;return c|0}d=f[135049]|0;if(!d){e=$Xc(28)|0;WXc(e);f[135049]=e;g=e}else g=d;YXc(g);if(!(f[135567]|0)){d=$Xc(8)|0;f[d>>2]=35828;e=pN(iN()|0)|0;f[d+4>>2]=e;f[d>>2]=36100;f[135567]=d}ZXc(g);a=f[135567]|0;b=hN(a)|0;c=f[b>>2]|0;return c|0}function DN(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=36100;uN(a);f[a>>2]=35828;if((f[a+4>>2]|0)==-1){u=c;return}else{b[d+11>>0]=10;c=d;a=219795;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));b[d+10>>0]=0;vM(-215,d,219806,219824,1504)}}function EN(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=36100;uN(a);f[a>>2]=35828;if((f[a+4>>2]|0)==-1){cYc(a);u=c;return}else{b[d+11>>0]=10;c=d;a=219795;e=c+10|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(e|0));b[d+10>>0]=0;vM(-215,d,219806,219824,1504)}}function FN(a){a=a|0;var b=0;a=$Xc(4)|0;b=f[135568]|0;f[135568]=b+1;f[a>>2]=b;return a|0}function GN(a,b){a=a|0;b=b|0;if(!b)return;cYc(b);return}function HN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=d+4|0;f[e>>2]=c;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=dJc(a)|0;if(c>>>0>4294967279)jYc(g);if(c>>>0<11){b[g+11>>0]=c;if(!c)h=g;else{i=g;j=6}}else{k=c+16&-16;l=$Xc(k)|0;f[g>>2]=l;f[g+8>>2]=k|-2147483648;f[g+4>>2]=c;i=l;j=6}if((j|0)==6){o1c(i|0,a|0,c|0)|0;h=i}b[h+c>>0]=0;c=IN(g,e)|0;if((b[g+11>>0]|0)>=0){u=d;return c|0}cYc(f[g>>2]|0);u=d;return c|0}function IN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=jf(((b[a+11>>0]|0)<0?f[a>>2]|0:a)|0)|0;if(!g){h=f[c>>2]|0;u=d;return h|0};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=dJc(g)|0;if(c>>>0>4294967279)jYc(e);if(c>>>0<11){b[e+11>>0]=c;if(!c)i=e;else{j=e;k=7}}else{a=c+16&-16;l=$Xc(a)|0;f[e>>2]=l;f[e+8>>2]=a|-2147483648;f[e+4>>2]=c;j=l;k=7}if((k|0)==7){o1c(j|0,g|0,c|0)|0;i=j}b[i+c>>0]=0;c=JN(e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=c;u=d;return h|0}function JN(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;k=a+4|0;l=j?f[k>>2]|0:i&255;a:do if(!l)m=0;else{i=j?f[a>>2]|0:a;n=0;while(1){if(((b[i+n>>0]|0)+-48|0)>>>0>=10){m=n;break a}o=n+1|0;if(o>>>0<l>>>0)n=o;else{m=o;break}}}while(0);mYc(d,a,0,m,a);l=b[h>>0]|0;mYc(e,a,m,(l<<24>>24<0?f[k>>2]|0:l&255)-m|0,a);m=d+11|0;l=jLc((b[m>>0]|0)<0?f[d>>2]|0:d)|0;k=e+11|0;h=b[k>>0]|0;j=e+4|0;n=f[j>>2]|0;switch((h<<24>>24<0?n:h&255)|0){case 0:{p=l;break}case 2:{if(!(LYc(e,0,-1,226694,2)|0))q=14;else{r=b[k>>0]|0;s=f[j>>2]|0;q=8}break}default:{r=h;s=n;q=8}}do if((q|0)==8){if(((r<<24>>24<0?s:r&255)|0)==2){if(!(LYc(e,0,-1,226697,2)|0)){q=14;break}t=b[k>>0]|0;v=f[j>>2]|0}else{t=r;v=s}if(((t<<24>>24<0?v:t&255)|0)==2){if(!(LYc(e,0,-1,226700,2)|0)){q=14;break}w=b[k>>0]|0;x=f[j>>2]|0}else{w=t;x=v}if(((w<<24>>24<0?x:w&255)|0)==2){if(LYc(e,0,-1,226703,2)|0){y=b[k>>0]|0;z=f[j>>2]|0;q=18}}else{y=w;z=x;q=18}do if((q|0)==18){if(((y<<24>>24<0?z:y&255)|0)==2){if(!(LYc(e,0,-1,226706,2)|0))break;A=b[k>>0]|0;B=f[j>>2]|0}else{A=y;B=z}if(((A<<24>>24<0?B:A&255)|0)!=2){C=af(12)|0;lYc(g,a);lYc(C,g);ig(C|0,6864,2221)}if(LYc(e,0,-1,226709,2)|0){C=af(12)|0;lYc(g,a);lYc(C,g);ig(C|0,6864,2221)}}while(0);p=l<<10}while(0);if((q|0)==14)p=l<<20;if((b[k>>0]|0)<0)cYc(f[e>>2]|0);if((b[m>>0]|0)>=0){u=c;return p|0}cYc(f[d>>2]|0);u=c;return p|0}function KN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+32|0;g=e+12|0;h=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=dJc(c)|0;if(i>>>0>4294967279)jYc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{m=i+16&-16;n=$Xc(m)|0;f[g>>2]=n;f[g+8>>2]=m|-2147483648;f[g+4>>2]=i;k=n;l=6}if((l|0)==6){o1c(k|0,c|0,i|0)|0;j=k}b[j+i>>0]=0;if(!d){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=dJc(d)|0;if(i>>>0>4294967279)jYc(h);if(i>>>0<11){b[h+11>>0]=i;if(!i)o=h;else{p=h;l=13}}else{j=i+16&-16;k=$Xc(j)|0;f[h>>2]=k;f[h+8>>2]=j|-2147483648;f[h+4>>2]=i;p=k;l=13}if((l|0)==13){o1c(p|0,d|0,i|0)|0;o=p}b[o+i>>0]=0}LN(a,g,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function LN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=jf(((b[c+11>>0]|0)<0?f[c>>2]|0:c)|0)|0;if(!h){lYc(a,d);u=e;return};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=dJc(h)|0;if(d>>>0>4294967279)jYc(g);if(d>>>0<11){b[g+11>>0]=d;if(!d)i=g;else{j=g;k=7}}else{c=d+16&-16;l=$Xc(c)|0;f[g>>2]=l;f[g+8>>2]=c|-2147483648;f[g+4>>2]=d;j=l;k=7}if((k|0)==7){o1c(j|0,h|0,d|0)|0;i=j}b[i+d>>0]=0;lYc(a,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);u=e;return}function MN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/12|0;if(!e)return;if(g>>>0>357913941)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*12|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{lYc(g,d);d=d+12|0;g=(f[c>>2]|0)+12|0;f[c>>2]=g}while((d|0)!=(b|0));return}function NN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[a>>2]|0;g=((f[d>>2]|0)-e|0)/12|0;h=g+1|0;if(h>>>0>357913941)kWc(a);i=a+8|0;j=((f[i>>2]|0)-e|0)/12|0;e=j<<1;k=j>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(k)if(k>>>0>357913941){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{l=$Xc(k*12|0)|0;break}else l=0;while(0);e=l+(g*12|0)|0;g=e;h=l+(k*12|0)|0;lYc(e,c);c=e+12|0;k=f[a>>2]|0;l=f[d>>2]|0;if((l|0)==(k|0)){m=g;n=k;o=k}else{j=l;l=g;g=e;do{e=g+-12|0;j=j+-12|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;g=l+-12|0;l=g}while((j|0)!=(k|0));m=l;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=h;h=n;if((o|0)!=(h|0)){i=o;do{i=i+-12|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}while((i|0)!=(h|0))}if(!n)return;cYc(n);return}function ON(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((d|0)>0){i=0;j=0;while(1){b[c+j>>0]=b[g+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((d|0)>0){i=0;k=0;while(1){b[c+i>>0]=b[g+k>>0]|0;b[c+(i+1)>>0]=b[j+k>>0]|0;k=k+1|0;if((k|0)==(d|0))break a;else i=i+e|0}}else return;i=f[a+8>>2]|0;if((h|0)==3)if((d|0)>0){k=0;l=0;while(1){b[c+k>>0]=b[g+l>>0]|0;b[c+(k+1)>>0]=b[j+l>>0]|0;b[c+(k+2)>>0]=b[i+l>>0]|0;l=l+1|0;if((l|0)==(d|0))break;else k=k+e|0}}else return;else{k=f[a+12>>2]|0;if((d|0)>0){l=0;m=0;while(1){b[c+l>>0]=b[g+m>>0]|0;b[c+(l+1)>>0]=b[j+m>>0]|0;b[c+(l+2)>>0]=b[i+m>>0]|0;b[c+(l+3)>>0]=b[k+m>>0]|0;m=m+1|0;if((m|0)==(d|0))break;else l=l+e|0}}else return}}while(0);if((d|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;l=f[a+(n+2<<2)>>2]|0;m=f[a+(n+3<<2)>>2]|0;k=n;i=0;while(1){b[c+k>>0]=b[h+i>>0]|0;b[c+(k+1)>>0]=b[g+i>>0]|0;b[c+(k+2)>>0]=b[l+i>>0]|0;b[c+(k+3)>>0]=b[m+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function PN(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((c|0)>0){i=0;j=0;while(1){d[b+(j<<1)>>1]=d[g+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((c|0)>0){i=0;k=0;while(1){d[b+(i<<1)>>1]=d[g+(k<<1)>>1]|0;d[b+(i+1<<1)>>1]=d[j+(k<<1)>>1]|0;k=k+1|0;if((k|0)==(c|0))break a;else i=i+e|0}}else return;i=f[a+8>>2]|0;if((h|0)==3)if((c|0)>0){k=0;l=0;while(1){d[b+(k<<1)>>1]=d[g+(l<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[j+(l<<1)>>1]|0;d[b+(k+2<<1)>>1]=d[i+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0))break;else k=k+e|0}}else return;else{k=f[a+12>>2]|0;if((c|0)>0){l=0;m=0;while(1){d[b+(l<<1)>>1]=d[g+(m<<1)>>1]|0;d[b+(l+1<<1)>>1]=d[j+(m<<1)>>1]|0;d[b+(l+2<<1)>>1]=d[i+(m<<1)>>1]|0;d[b+(l+3<<1)>>1]=d[k+(m<<1)>>1]|0;m=m+1|0;if((m|0)==(c|0))break;else l=l+e|0}}else return}}while(0);if((c|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;l=f[a+(n+2<<2)>>2]|0;m=f[a+(n+3<<2)>>2]|0;k=n;i=0;while(1){d[b+(k<<1)>>1]=d[h+(i<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[g+(i<<1)>>1]|0;d[b+(k+2<<1)>>1]=d[l+(i<<1)>>1]|0;d[b+(k+3<<1)>>1]=d[m+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function QN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){f[b+(i<<2)>>2]=f[e+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;j=0;while(1){f[b+(h<<2)>>2]=f[e+(j<<2)>>2];f[b+(h+1<<2)>>2]=f[i+(j<<2)>>2];j=j+1|0;if((j|0)==(c|0))break a;else h=h+d|0}}else return;h=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){j=0;k=0;while(1){f[b+(j<<2)>>2]=f[e+(k<<2)>>2];f[b+(j+1<<2)>>2]=f[i+(k<<2)>>2];f[b+(j+2<<2)>>2]=f[h+(k<<2)>>2];k=k+1|0;if((k|0)==(c|0))break;else j=j+d|0}}else return;else{j=f[a+12>>2]|0;if((c|0)>0){k=0;l=0;while(1){f[b+(k<<2)>>2]=f[e+(l<<2)>>2];f[b+(k+1<<2)>>2]=f[i+(l<<2)>>2];f[b+(k+2<<2)>>2]=f[h+(l<<2)>>2];f[b+(k+3<<2)>>2]=f[j+(l<<2)>>2];l=l+1|0;if((l|0)==(c|0))break;else k=k+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))m=g;else return;do{g=f[a+(m<<2)>>2]|0;e=f[a+(m+1<<2)>>2]|0;k=f[a+(m+2<<2)>>2]|0;l=f[a+(m+3<<2)>>2]|0;j=m;h=0;while(1){f[b+(j<<2)>>2]=f[g+(h<<2)>>2];f[b+(j+1<<2)>>2]=f[e+(h<<2)>>2];f[b+(j+2<<2)>>2]=f[k+(h<<2)>>2];f[b+(j+3<<2)>>2]=f[l+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else j=j+d|0}m=m+4|0}while((m|0)<(d|0));return}function RN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){j=e+(h<<3)|0;k=f[j+4>>2]|0;l=b+(i<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=k;h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;k=0;while(1){l=e+(k<<3)|0;j=f[l+4>>2]|0;m=b+(h<<3)|0;f[m>>2]=f[l>>2];f[m+4>>2]=j;j=i+(k<<3)|0;m=f[j+4>>2]|0;l=b+(h+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=m;k=k+1|0;if((k|0)==(c|0))break a;else h=h+d|0}}else return;h=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){k=0;m=0;while(1){l=e+(m<<3)|0;j=f[l+4>>2]|0;n=b+(k<<3)|0;f[n>>2]=f[l>>2];f[n+4>>2]=j;j=i+(m<<3)|0;n=f[j+4>>2]|0;l=b+(k+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=n;n=h+(m<<3)|0;l=f[n+4>>2]|0;j=b+(k+2<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=l;m=m+1|0;if((m|0)==(c|0))break;else k=k+d|0}}else return;else{k=f[a+12>>2]|0;if((c|0)>0){m=0;l=0;while(1){j=e+(l<<3)|0;n=f[j+4>>2]|0;o=b+(m<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;n=i+(l<<3)|0;o=f[n+4>>2]|0;j=b+(m+1<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=o;o=h+(l<<3)|0;j=f[o+4>>2]|0;n=b+(m+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=j;j=k+(l<<3)|0;n=f[j+4>>2]|0;o=b+(m+3<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;l=l+1|0;if((l|0)==(c|0))break;else m=m+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))p=g;else return;do{g=f[a+(p<<2)>>2]|0;e=f[a+(p+1<<2)>>2]|0;m=f[a+(p+2<<2)>>2]|0;l=f[a+(p+3<<2)>>2]|0;k=p;h=0;while(1){i=g+(h<<3)|0;n=f[i+4>>2]|0;o=b+(k<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;n=e+(h<<3)|0;o=f[n+4>>2]|0;i=b+(k+1<<3)|0;f[i>>2]=f[n>>2];f[i+4>>2]=o;o=m+(h<<3)|0;i=f[o+4>>2]|0;n=b+(k+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=i;i=l+(h<<3)|0;n=f[i+4>>2]|0;o=b+(k+3<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;h=h+1|0;if((h|0)==(c|0))break;else k=k+d|0}p=p+4|0}while((p|0)<(d|0));return}function SN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+2208|0;g=e+2144|0;h=e+1080|0;i=e+40|0;j=e+8|0;k=e;if(!((a|0)!=0&(c|0)!=0)){l=$Xc(16)|0;f[g>>2]=l;f[g+8>>2]=-2147483632;f[g+4>>2]=11;m=l;n=226712;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+11>>0]=0;vM(-215,g,226724,226730,286)}l=f[a>>2]&7;p=f[a+40>>2]|0;q=f[p+-4>>2]|0;r=p+4|0;s=(q|0)==2;t=(q|0)>0;v=1;w=0;x=0;y=p;a:while(1){if(s){if((f[y>>2]|0)!=(f[p>>2]|0)){z=11;break}if((f[y+4>>2]|0)!=(f[r>>2]|0)){z=11;break}}else if(t){A=0;do{if((f[y+(A<<2)>>2]|0)!=(f[p+(A<<2)>>2]|0)){z=11;break a}A=A+1|0}while((A|0)<(q|0))}A=f[a+(x*56|0)>>2]|0;if((A&7|0)!=(l|0)){z=11;break}v=v&(A&4088|0)==0;B=A>>>3&511;C=w+1+B|0;x=x+1|0;if(x>>>0>=c>>>0){z=14;break}y=f[a+(x*56|0)+40>>2]|0;if((f[y+-4>>2]|0)!=(q|0)){z=11;break}else w=C}if((z|0)==11){q=$Xc(64)|0;f[g>>2]=q;f[g+8>>2]=-2147483584;f[g+4>>2]=50;m=q;n=226797;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[q+50>>0]=0;vM(-215,g,226724,226730,295)}else if((z|0)==14){if((w+B|0)>>>0>=512){B=$Xc(32)|0;f[g>>2]=B;f[g+8>>2]=-2147483616;f[g+4>>2]=25;m=B;n=226848;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[B+25>>0]=0;vM(-215,g,226724,226730,300)}xS(d,f[a+4>>2]|0,f[a+40>>2]|0,(C<<3)+-8|l,-1,0,0);do if((eS(d)|0)==65536){B=f[d+4>>2]|0;f[g>>2]=f[B>>2];n=g+4|0;m=B+4|0;f[n>>2]=f[m>>2];o=g+8|0;f[o>>2]=f[B+8>>2];f[g+12>>2]=f[B+12>>2];f[g+16>>2]=f[B+16>>2];f[g+20>>2]=f[B+20>>2];f[g+24>>2]=f[B+24>>2];f[g+28>>2]=f[B+28>>2];f[g+32>>2]=f[B+32>>2];w=f[B+36>>2]|0;f[g+36>>2]=w;f[g+40>>2]=o;o=g+48|0;z=g+44|0;f[z>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(w|0){o=w+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[B+44>>2]|0;o=f[z>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[n>>2]=0;U$(g,B);break}}else bS(g,d,-1);while(0);do if((c|0)!=1){if(!v){d=C<<1;B=h+8|0;f[h>>2]=B;n=h+4|0;f[n>>2]=d;if(d>>>0>264){m=bYc(d>>>0>1073741823?-1:d<<2)|0;f[h>>2]=m;D=m}else D=B;m=0;d=0;while(1){o=(f[a+(d*56|0)>>2]|0)>>>3&511;z=0;while(1){w=z+m|0;q=w<<1;f[D+(q<<2)>>2]=w;f[D+((q|1)<<2)>>2]=w;if((z|0)==(o|0))break;else z=z+1|0}d=d+1|0;if((d|0)==(c|0))break;else m=m+1+o|0}d1(a,c,g,1,D,C);m=f[h>>2]|0;if((m|0)!=(B|0)){if(m|0)dYc(m);f[h>>2]=B;f[n>>2]=264}break}m=f[36116+(l<<2)>>2]|0;d=f[g+4>>2]|0;if((d|0)>0)E=f[(f[g+44>>2]|0)+(d+-1<<2)>>2]|0;else E=0;d=675553809>>>(f[g>>2]<<2&28)&15;f[h>>2]=((E+1023|0)>>>0)/(E>>>0)|0;z=C+1|0;w=(z<<3)+16|0;q=i+8|0;f[i>>2]=q;y=i+4|0;f[y>>2]=w;if(w>>>0>1032){x=bYc(w)|0;f[i>>2]=x;F=x}else F=q;x=F+(C<<2)+4+15&-16;w=x;p=x;f[F>>2]=g;x=0;do{t=x;x=x+1|0;f[F+(x<<2)>>2]=a+(t*56|0)}while((x|0)!=(C|0));BL(j,F,p,z);x=f[j+20>>2]|0;f[k>>2]=x;n=536870911/(C|0)|0;if((C|0)<5)G=x;else{B=f[h>>2]|0;G=B>>>0<x>>>0?B:f[k>>2]|0}B=G>>>0<n>>>0?G:n;n=j+16|0;t=w+4|0;r=x;s=x;x=0;while(1){if(x>>>0>=(f[n>>2]|0)>>>0)break;if(!r){H=0;I=s}else{A=r;J=s;K=0;while(1){L=A-K|0;M=B>>>0<L>>>0?B:L;ei[m&511](t,f[p>>2]|0,M,C);K=K+B|0;if(K>>>0<J>>>0){L=Y(E,M)|0;f[p>>2]=(f[p>>2]|0)+L;L=Y(d,M)|0;M=0;do{M=M+1|0;N=w+(M<<2)|0;f[N>>2]=(f[N>>2]|0)+L}while((M|0)!=(C|0));O=f[k>>2]|0}else O=J;if(O>>>0<=K>>>0){H=O;I=O;break}else{A=O;J=O}}}CL(j)|0;r=H;s=I;x=x+1|0}x=f[i>>2]|0;if((x|0)!=(q|0)){if(x|0)dYc(x);f[i>>2]=q;f[y>>2]=1032}}else{x=h+8|0;f[x>>2]=0;f[x+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;jR(a,h)}while(0);h=g+36|0;a=f[h>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)V$(g);f[h>>2]=0;h=g+16|0;a=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[a>>2]|0)>0){h=f[g+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}wL(a);u=e;return}}function TN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;gS(a,d);a=f[d>>2]|0;g=f[e>>2]|0;SN((a|0)==(g|0)?0:a,(g-a|0)/56|0,b);hx(d);u=c;return}function UN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0;switch(c|0){case 1:{d=q1(a,b)|0;return d|0}case 2:{e=227386;break}case 4:{e=227130;break}default:{d=-1;return d|0}}c=b+-4|0;if((b|0)<4){f=0;g=0}else{i=0;j=0;do{j=(h[e+(h[a+i>>0]|0)>>0]|0)+j+(h[e+(h[a+(i|1)>>0]|0)>>0]|0)+(h[e+(h[a+(i|2)>>0]|0)>>0]|0)+(h[e+(h[a+(i|3)>>0]|0)>>0]|0)|0;i=i+4|0}while((i|0)<=(c|0));f=j;g=b&-4}if((g|0)<(b|0)){k=g;l=f}else{d=f;return d|0}while(1){f=(h[e+(h[a+k>>0]|0)>>0]|0)+l|0;k=k+1|0;if((k|0)==(b|0)){d=f;break}else l=f}return d|0}function VN(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;switch(e|0){case 1:{f=r1(a,c,d)|0;return f|0}case 2:{g=227386;break}case 4:{g=227130;break}default:{f=-1;return f|0}}e=d+-4|0;if((d|0)<4){i=0;j=0}else{k=0;l=0;do{m=k|1;n=k|2;o=k|3;l=(h[g+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+l+(h[g+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)+(h[g+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+(h[g+((b[c+o>>0]^b[a+o>>0])&255)>>0]|0)|0;k=k+4|0}while((k|0)<=(e|0));i=l;j=d&-4}if((j|0)<(d|0)){p=j;q=i}else{f=i;return f|0}while(1){i=(h[g+((b[c+p>>0]^b[a+p>>0])&255)>>0]|0)+q|0;p=p+1|0;if((p|0)==(d|0)){f=i;break}else q=i}return f|0}function WN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0;d=c+-4|0;if((c|0)<4){e=0;f=0.0}else{g=0.0;h=0;do{i=+n[a+(h<<2)>>2]-+n[b+(h<<2)>>2];j=h|1;k=+n[a+(j<<2)>>2]-+n[b+(j<<2)>>2];j=h|2;l=+n[a+(j<<2)>>2]-+n[b+(j<<2)>>2];j=h|3;m=+n[a+(j<<2)>>2]-+n[b+(j<<2)>>2];g=g+(i*i+k*k+l*l+m*m);h=h+4|0}while((h|0)<=(d|0));e=c&-4;f=g}if((e|0)<(c|0)){o=f;p=e}else{q=f;return +q}while(1){f=+n[a+(p<<2)>>2]-+n[b+(p<<2)>>2];g=o+f*f;p=p+1|0;if((p|0)==(c|0)){q=g;break}else o=g}return +q}function XN(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+1328|0;g=e+1264|0;i=e+1208|0;j=e+1152|0;k=e+32|0;l=e;m=e+1120|0;o=e+1112|0;q=e+48|0;r=c&7;t=(r|0)==1;v=(r|0)==2;w=(r|0)==4;x=(r|0)==5;y=c&255;switch(y&7){case 1:case 2:case 4:case 5:break;default:{if((r|1|0)!=7){z=$Xc(192)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483456;B=g+4|0;f[B>>2]=177;o1c(z|0,227642,177)|0;C=z+177|0;b[C>>0]=0;vM(-215,g,227820,227825,633)}if(dS(a,-1)|0){z=$Xc(192)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483456;B=g+4|0;f[B>>2]=177;o1c(z|0,227642,177)|0;C=z+177|0;b[C>>0]=0;vM(-215,g,227820,227825,633)}}}do if((eS(a)|0)==65536){C=f[a+4>>2]|0;f[g>>2]=f[C>>2];z=g+4|0;B=C+4|0;f[z>>2]=f[B>>2];A=g+8|0;f[A>>2]=f[C+8>>2];f[g+12>>2]=f[C+12>>2];f[g+16>>2]=f[C+16>>2];f[g+20>>2]=f[C+20>>2];f[g+24>>2]=f[C+24>>2];f[g+28>>2]=f[C+28>>2];f[g+32>>2]=f[C+32>>2];c=f[C+36>>2]|0;f[g+36>>2]=c;f[g+40>>2]=A;A=g+48|0;D=g+44|0;f[D>>2]=A;f[A>>2]=0;f[g+52>>2]=0;if(c|0){A=c+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[B>>2]|0)<3){B=f[C+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[B>>2];f[A+4>>2]=f[B+4>>2];break}else{f[z>>2]=0;U$(g,C);break}}else bS(g,a,-1);while(0);do if((eS(d)|0)==65536){a=f[d+4>>2]|0;f[i>>2]=f[a>>2];C=i+4|0;z=a+4|0;f[C>>2]=f[z>>2];B=i+8|0;f[B>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[i+36>>2]=A;f[i+40>>2]=B;B=i+48|0;D=i+44|0;f[D>>2]=B;f[B>>2]=0;f[i+52>>2]=0;if(A|0){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[z>>2];f[B+4>>2]=f[z+4>>2];break}else{f[C>>2]=0;U$(i,a);break}}else bS(i,d,-1);while(0);d=f[g>>2]|0;a=d&7;C=(d>>>3&511)+1|0;z=f[i+16>>2]|0;a:do if(!(d&16384))E=64;else{if(z|0){B=f[i+4>>2]|0;if((B|0)<3)F=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{D=f[i+40>>2]|0;A=0;c=1;while(1){G=Y(f[D+(A<<2)>>2]|0,c)|0;A=A+1|0;if((A|0)==(B|0)){F=G;break}else c=G}}if(!((B|0)==0|(F|0)==0)){E=64;break}}c=f[g+4>>2]|0;if((c|0)<3)H=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{A=f[g+40>>2]|0;D=0;G=1;while(1){I=Y(f[A+(D<<2)>>2]|0,G)|0;D=D+1|0;if((D|0)==(c|0)){H=I;break}else G=I}}G=Y(H,C)|0;switch(d&7){case 5:break;case 0:{c=f[g+16>>2]|0;switch(y&7){case 6:{J=+(q1(c,G)|0);break a;break}case 7:break;default:{E=64;break a}}D=G+-4|0;if((G|0)<4){K=0;N=0}else{A=0;B=0;do{B=(h[227386+(h[c+A>>0]|0)>>0]|0)+B+(h[227386+(h[c+(A|1)>>0]|0)>>0]|0)+(h[227386+(h[c+(A|2)>>0]|0)>>0]|0)+(h[227386+(h[c+(A|3)>>0]|0)>>0]|0)|0;A=A+4|0}while((A|0)<=(D|0));K=B;N=G&-4}if((N|0)<(G|0)){D=N;A=K;while(1){I=(h[227386+(h[c+D>>0]|0)>>0]|0)+A|0;D=D+1|0;if((D|0)==(G|0)){O=I;break}else A=I}}else O=K;J=+(O|0);break a;break}default:{E=64;break a}}A=f[g+16>>2]|0;if(w){D=G+-4|0;if((G|0)<4){P=0.0;Q=0}else{c=0;R=0.0;do{S=+n[A+(c<<2)>>2];T=+n[A+((c|1)<<2)>>2];U=+n[A+((c|2)<<2)>>2];V=+n[A+((c|3)<<2)>>2];R=R+(S*S+T*T+U*U+V*V);c=c+4|0}while((c|0)<=(D|0));P=R;Q=G&-4}if((Q|0)<(G|0)){D=Q;V=P;while(1){U=+n[A+(D<<2)>>2];T=V+U*U;D=D+1|0;if((D|0)==(G|0)){W=T;break}else V=T}}else W=P;J=+M(+(W+0.0));break}if(x){D=G+-4|0;if((G|0)<4){X=0.0;Z=0}else{c=0;V=0.0;do{R=+n[A+(c<<2)>>2];T=+n[A+((c|1)<<2)>>2];U=+n[A+((c|2)<<2)>>2];S=+n[A+((c|3)<<2)>>2];V=V+(R*R+T*T+U*U+S*S);c=c+4|0}while((c|0)<=(D|0));X=V;Z=G&-4}if((Z|0)<(G|0)){D=Z;S=X;while(1){U=+n[A+(D<<2)>>2];T=S+U*U;D=D+1|0;if((D|0)==(G|0)){_=T;break}else S=T}}else _=X;J=_+0.0;break}if(!v){if(!t){E=64;break}if((G|0)>0){D=0;S=0.0;while(1){V=+L(+(+n[A+(D<<2)>>2]));T=S<V?V:S;D=D+1|0;if((D|0)==(G|0)){$=T;break}else S=T}}else $=0.0;J=$>0.0?$:0.0;break}D=G+-4|0;if((G|0)<4){aa=0;ba=0.0}else{S=0.0;c=0;do{T=+L(+(+n[A+(c<<2)>>2]));V=T+ +L(+(+n[A+((c|1)<<2)>>2]));T=V+ +L(+(+n[A+((c|2)<<2)>>2]));S=S+(T+ +L(+(+n[A+((c|3)<<2)>>2])));c=c+4|0}while((c|0)<=(D|0));aa=G&-4;ba=S}if((aa|0)<(G|0)){T=ba;D=aa;while(1){V=T+ +L(+(+n[A+(D<<2)>>2]));D=D+1|0;if((D|0)==(G|0)){ca=V;break}else T=V}}else ca=ba;J=ca+0.0}while(0);do if((E|0)==64){aa=(z|0)==0;if(!aa){Z=f[i+4>>2]|0;if((Z|0)<3)da=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{x=f[i+40>>2]|0;Q=0;O=1;while(1){K=Y(f[x+(Q<<2)>>2]|0,O)|0;Q=Q+1|0;if((Q|0)==(Z|0)){da=K;break}else O=K}}if(!((Z|0)==0|(da|0)==0)?f[i>>2]&4095|0:0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;O=$Xc(48)|0;f[j>>2]=O;f[j+8>>2]=-2147483600;f[j+4>>2]=36;ea=O;fa=227891;ga=ea+36|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[O+36>>0]=0;vM(-215,j,227820,227825,700)}}Z=(r|0)==6;Q=r|1;if((Q|0)==7){if(!aa){x=f[i+4>>2]|0;if((x|0)<3)ha=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{K=f[i+40>>2]|0;N=0;y=1;while(1){d=Y(f[K+(N<<2)>>2]|0,y)|0;N=N+1|0;if((N|0)==(x|0)){ha=d;break}else y=d}}if(!((x|0)==0|(ha|0)==0)){f[j>>2]=1124007936;y=j+4|0;N=j+8|0;K=j+40|0;ea=y;ga=ea+36|0;do{f[ea>>2]=0;ea=ea+4|0}while((ea|0)<(ga|0));f[K>>2]=N;x=j+48|0;aa=j+44|0;f[aa>>2]=x;f[x>>2]=0;f[j+52>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;O=m+8|0;f[O>>2]=0;f[O+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;v1(k,l,m,fT()|0);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;ca=+XN(k,r,fT()|0);O=j+36|0;d=f[O>>2]|0;if(d|0?(H=d+12|0,d=f[H>>2]|0,f[H>>2]=d+-1,(d|0)==1):0)V$(j);f[O>>2]=0;O=j+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[y>>2]|0)>0){O=f[K>>2]|0;d=0;do{f[O+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[y>>2]|0))}y=f[aa>>2]|0;if((y|0)!=(x|0))wL(y);J=ca;break}}y=Z?1:2;f[j>>2]=g;f[j+4>>2]=0;f[k>>2]=0;BL(l,j,k,-1);d=f[l+20>>2]|0;O=l+16|0;K=0;N=0;while(1){if(K>>>0>=(f[O>>2]|0)>>>0)break;H=(UN(f[k>>2]|0,d,y)|0)+N|0;CL(l)|0;K=K+1|0;N=H}J=+(N|0);break}K=(a|0)==7;y=f[36148+(r>>>1<<5)+((K?5:a)<<2)>>2]|0;if(!y){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=9;ea=j;fa=264557;ga=ea+9|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[j+9>>0]=0;vM(-215,j,227820,227825,727)}f[j>>2]=g;f[j+4>>2]=i;f[j+8>>2]=0;N=k;f[N>>2]=0;f[N+4>>2]=0;p[l>>3]=0.0;BL(m,j,k,-1);N=f[m+20>>2]|0;d=a>>>0<2;O=(Q|0)==5&d|(K|v&a>>>0<4);f[o>>2]=0;Z=q+8|0;f[q>>2]=Z;x=q+4|0;f[x>>2]=264;do if(O){aa=f[g+4>>2]|0;if((aa|0)>0)ia=f[(f[g+44>>2]|0)+(aa+-1<<2)>>2]|0;else ia=0;if(!K){aa=((v&d?8388608:32768)>>>0)/(C>>>0)|0;ja=ia;ka=0;la=o;ma=(aa|0)<(N|0)?aa:N;na=0;break}aa=(N|0)<1024?N:1024;f[x>>2]=aa;if(aa>>>0>264){H=bYc(aa>>>0>1073741823?-1:aa<<2)|0;f[q>>2]=H;oa=H}else oa=Z;ja=ia;ka=oa;la=l;ma=aa;na=oa}else{ja=0;ka=0;la=l;ma=N;na=0}while(0);d=m+16|0;Q=(N|0)>0;aa=k+4|0;H=(a|0)!=7&O;F=0;while(1){if(F>>>0>=(f[d>>2]|0)>>>0)break;b:do if(Q){if(K){G=0;D=f[k>>2]|0;while(1){A=N-G|0;c=(ma|0)<(A|0)?ma:A;UW(D,ka,c);_h[y&127](na,f[aa>>2]|0,la,c,C)|0;if(H){p[l>>3]=+p[l>>3]+ +(f[o>>2]|0);f[o>>2]=0}A=Y(c,ja)|0;D=(f[k>>2]|0)+A|0;f[k>>2]=D;A=f[aa>>2]|0;if(A|0)f[aa>>2]=A+c;G=G+ma|0;if((N|0)<=(G|0))break b}}G=f[k>>2]|0;D=f[aa>>2]|0;if(H){c=0;A=G;B=D;while(1){I=N-c|0;pa=(ma|0)<(I|0)?ma:I;_h[y&127](A,B,la,pa,C)|0;p[l>>3]=+p[l>>3]+ +(f[o>>2]|0);f[o>>2]=0;I=Y(pa,ja)|0;A=(f[k>>2]|0)+I|0;f[k>>2]=A;I=f[aa>>2]|0;if(!I)qa=0;else{ra=I+pa|0;f[aa>>2]=ra;qa=ra}c=c+ma|0;if((N|0)<=(c|0))break;else B=qa}}else{B=0;c=G;A=D;while(1){ra=N-B|0;pa=(ma|0)<(ra|0)?ma:ra;_h[y&127](c,A,la,pa,C)|0;ra=Y(pa,ja)|0;c=(f[k>>2]|0)+ra|0;f[k>>2]=c;ra=f[aa>>2]|0;if(!ra)sa=0;else{I=ra+pa|0;f[aa>>2]=I;sa=I}B=B+ma|0;if((N|0)<=(B|0))break;else A=sa}}}while(0);CL(m)|0;F=F+1|0}if(t){if((a|0)!=6){F=f[l>>2]|0;p[l>>3]=(a|0)==5?(f[s>>2]=F,+n[s>>2]):+(F|0)}}else if(w){ca=+M(+(+p[l>>3]));p[l>>3]=ca}ca=+p[l>>3];F=f[q>>2]|0;if((F|0)!=(Z|0)){if(F|0)dYc(F);f[q>>2]=Z;f[x>>2]=264}J=ca}while(0);q=i+36|0;l=f[q>>2]|0;if(l|0?(w=l+12|0,l=f[w>>2]|0,f[w>>2]=l+-1,(l|0)==1):0)V$(i);f[q>>2]=0;q=i+16|0;l=i+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[l>>2]|0)>0){q=f[i+40>>2]|0;w=0;do{f[q+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[l>>2]|0))}l=f[i+44>>2]|0;if((l|0)!=(i+48|0))wL(l);l=g+36|0;i=f[l>>2]|0;if(i|0?(w=i+12|0,i=f[w>>2]|0,f[w>>2]=i+-1,(i|0)==1):0)V$(g);f[l>>2]=0;l=g+16|0;i=g+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[i>>2]|0)>0){l=f[g+40>>2]|0;w=0;do{f[l+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[g+44>>2]|0;if((i|0)==(g+48|0)){u=e;return +J}wL(i);u=e;return +J}function YN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0;while(1){m=h[a+l>>0]|0;n=(k|0)<(m|0)?m:k;l=l+1|0;if((l|0)==(j|0)){o=n;break}else k=n}}else o=0;p=(i|0)<(o|0)?o:i;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=i}else{p=i;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{i=0;a=s;while(1){o=h[r+i>>0]|0;k=(a|0)<(o|0)?o:a;i=i+1|0;if((i|0)==(g|0)){t=k;break}else a=k}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+g|0;s=t}}f[d>>2]=p;return 0}function ZN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=b[a+k>>0]|0;m=l<<24>>24;n=l<<24>>24>-1?m:0-m|0;m=(j|0)<(n|0)?n:j;k=k+1|0;if((k|0)==(i|0)){o=m;break}else j=m}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=h}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{h=0;a=s;while(1){o=b[r+h>>0]|0;j=o<<24>>24;i=o<<24>>24>-1?j:0-j|0;j=(a|0)<(i|0)?i:a;h=h+1|0;if((h|0)==(g|0)){t=j;break}else a=j}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+g|0;s=t}}f[d>>2]=p;return 0}function _N(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){k=0;l=0;while(1){m=j[a+(l<<1)>>1]|0;n=(k|0)<(m|0)?m:k;l=l+1|0;if((l|0)==(i|0)){o=n;break}else k=n}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=h}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{h=0;a=s;while(1){o=j[r+(h<<1)>>1]|0;k=(a|0)<(o|0)?o:a;h=h+1|0;if((h|0)==(g|0)){t=k;break}else a=k}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+(g<<1)|0;s=t}}f[d>>2]=p;return 0}function $N(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!c){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=d[a+(l<<1)>>1]|0;n=m<<16>>16;o=m<<16>>16>-1?n:0-n|0;n=(k|0)<(o|0)?o:k;l=l+1|0;if((l|0)==(j|0)){p=n;break}else k=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=a;t=i}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0))u=t;else{i=0;a=t;while(1){p=d[s+(i<<1)>>1]|0;k=p<<16>>16;j=p<<16>>16>-1?k:0-k|0;k=(a|0)<(j|0)?j:a;i=i+1|0;if((i|0)==(h|0)){u=k;break}else a=k}}r=r+1|0;if((r|0)==(g|0)){q=u;break}else{s=s+(h<<1)|0;t=u}}f[e>>2]=q;return 0}function aO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=f[a+(k<<2)>>2]|0;m=(l|0)>-1?l:0-l|0;l=(j|0)<(m|0)?m:j;k=k+1|0;if((k|0)==(i|0)){n=l;break}else j=l}}else n=0;o=(h|0)<(n|0)?n:h;f[d>>2]=o;return 0}if((e|0)>0&(g|0)>0){p=0;q=a;r=h}else{o=h;f[d>>2]=o;return 0}while(1){if(!(b[c+p>>0]|0))s=r;else{h=0;a=r;while(1){n=f[q+(h<<2)>>2]|0;j=(n|0)>-1?n:0-n|0;n=(a|0)<(j|0)?j:a;h=h+1|0;if((h|0)==(g|0)){s=n;break}else a=n}}p=p+1|0;if((p|0)==(e|0)){o=s;break}else{q=q+(g<<2)|0;r=s}}f[d>>2]=o;return 0}function bO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0,u=0.0,v=0,w=0.0,x=0;h=f[d>>2]|0;i=(f[s>>2]=h,+n[s>>2]);if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0.0;while(1){m=+L(+(+n[a+(k<<2)>>2]));o=l<m?m:l;k=k+1|0;if((k|0)==(j|0)){p=o;break}else l=o}}else p=0.0;q=(n[s>>2]=i<p?p:i,f[s>>2]|0);f[d>>2]=q;return 0}if((e|0)>0&(g|0)>0){r=0;t=a;u=i;v=h}else{q=h;f[d>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0)){w=u;x=v}else{h=0;i=u;do{p=+L(+(+n[t+(h<<2)>>2]));i=i<p?p:i;h=h+1|0}while((h|0)!=(g|0));w=i;x=(n[s>>2]=i,f[s>>2]|0)}r=r+1|0;if((r|0)==(e|0)){q=x;break}else{t=t+(g<<2)|0;u=w;v=x}}f[d>>2]=q;return 0}function cO(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0,r=0.0,s=0.0;g=+p[d>>3];if(!c){h=Y(f,e)|0;if((h|0)>0){i=0.0;j=0;while(1){k=+L(+(+p[a+(j<<3)>>3]));l=i<k?k:i;j=j+1|0;if((j|0)==(h|0)){m=l;break}else i=l}}else m=0.0;n=g<m?m:g;p[d>>3]=n;return 0}if((e|0)>0&(f|0)>0){o=0;q=a;r=g}else{n=g;p[d>>3]=n;return 0}while(1){if(!(b[c+o>>0]|0))s=r;else{a=0;g=r;while(1){m=+L(+(+p[q+(a<<3)>>3]));i=g<m?m:g;a=a+1|0;if((a|0)==(f|0)){s=i;break}else g=i}}o=o+1|0;if((o|0)==(e|0)){n=s;break}else{q=q+(f<<3)|0;r=s}}p[d>>3]=n;return 0}function dO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=(h[l+o>>0]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{g=(h[a+n>>0]|0)+g+(h[a+(n|1)>>0]|0)+(h[a+(n|2)>>0]|0)+(h[a+(n|3)>>0]|0)|0;n=n+4|0}while((n|0)<=(e|0));r=l&-4;s=g}if((r|0)<(l|0)){g=s;e=r;while(1){r=(h[a+e>>0]|0)+g|0;e=e+1|0;if((e|0)==(l|0)){t=r;break}else g=r}}else t=s;m=t+i|0;f[d>>2]=m;return 0}function eO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return AO(a,b,c,d,e)|0}function fO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;k=h;l=a}else{m=h;f[d>>2]=m;return 0}while(1){if(!(b[c+i>>0]|0))n=k;else{o=0;p=k;while(1){q=(j[l+(o<<1)>>1]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}i=i+1|0;if((i|0)==(e|0)){m=n;break}else{k=n;l=l+(g<<1)|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{g=(j[a+(n<<1)>>1]|0)+g+(j[a+((n|1)<<1)>>1]|0)+(j[a+((n|2)<<1)>>1]|0)+(j[a+((n|3)<<1)>>1]|0)|0;n=n+4|0}while((n|0)<=(e|0));r=l&-4;s=g}if((r|0)<(l|0)){g=s;e=r;while(1){r=(j[a+(e<<1)>>1]|0)+g|0;e=e+1|0;if((e|0)==(l|0)){t=r;break}else g=r}}else t=s;m=t+h|0;f[d>>2]=m;return 0}function gO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return zO(a,b,c,d,e)|0}function hO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return yO(a,b,c,d,e)|0}function iO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return xO(a,b,c,d,e)|0}function jO(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=n+ +L(+(+p[j+(m<<3)>>3]));m=m+1|0;if((m|0)==(f|0)){l=o;break}else n=o}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){q=0;r=0.0}else{l=0.0;f=0;do{i=+L(+(+p[a+(f<<3)>>3]));n=i+ +L(+(+p[a+((f|1)<<3)>>3]));i=n+ +L(+(+p[a+((f|2)<<3)>>3]));l=l+(i+ +L(+(+p[a+((f|3)<<3)>>3])));f=f+4|0}while((f|0)<=(e|0));q=j&-4;r=l}if((q|0)<(j|0)){l=r;e=q;while(1){i=l+ +L(+(+p[a+(e<<3)>>3]));e=e+1|0;if((e|0)==(j|0)){s=i;break}else l=i}}else s=r;k=g+s;p[d>>3]=k;return 0}function kO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return wO(a,b,c,d,e)|0}function lO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return vO(a,b,c,d,e)|0}function mO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return uO(a,b,c,d,e)|0}function nO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return tO(a,b,c,d,e)|0}function oO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return sO(a,b,c,d,e)|0}function pO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rO(a,b,c,d,e)|0}function qO(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=+p[j+(m<<3)>>3];q=n+o*o;m=m+1|0;if((m|0)==(f|0)){l=q;break}else n=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0.0;s=0}else{f=0;l=0.0;do{i=+p[a+(f<<3)>>3];n=+p[a+((f|1)<<3)>>3];q=+p[a+((f|2)<<3)>>3];o=+p[a+((f|3)<<3)>>3];l=l+(i*i+n*n+q*q+o*o);f=f+4|0}while((f|0)<=(e|0));r=l;s=j&-4}if((s|0)<(j|0)){e=s;l=r;while(1){o=+p[a+(e<<3)>>3];q=l+o*o;e=e+1|0;if((e|0)==(j|0)){t=q;break}else l=q}}else t=r;k=g+t;p[d>>3]=k;return 0}function rO(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=+n[j+(m<<2)>>2];r=o+q*q;m=m+1|0;if((m|0)==(f|0)){l=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){s=0.0;t=0}else{f=0;l=0.0;do{i=+n[a+(f<<2)>>2];o=+n[a+((f|1)<<2)>>2];r=+n[a+((f|2)<<2)>>2];q=+n[a+((f|3)<<2)>>2];l=l+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=l;t=j&-4}if((t|0)<(j|0)){e=t;l=s;while(1){q=+n[a+(e<<2)>>2];r=l+q*q;e=e+1|0;if((e|0)==(j|0)){u=r;break}else l=r}}else u=s;k=g+u;p[d>>3]=k;return 0}function sO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(f[k+(n<<2)>>2]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0.0;t=0}else{g=0;m=0.0;do{j=+(f[a+(g<<2)>>2]|0);o=+(f[a+((g|1)<<2)>>2]|0);r=+(f[a+((g|2)<<2)>>2]|0);q=+(f[a+((g|3)<<2)>>2]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(e|0));s=m;t=k&-4}if((t|0)<(k|0)){e=t;m=s;while(1){q=+(f[a+(e<<2)>>2]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=s;l=h+u;p[d>>3]=l;return 0}function tO(a,c,e,f,g){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[e>>3];if(c|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[e>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(d[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(f|0)){l=m;break}else{j=m;k=k+(g<<1)|0}}p[e>>3]=l;return 0}k=Y(g,f)|0;f=k+-4|0;if((k|0)<4){s=0.0;t=0}else{g=0;m=0.0;do{j=+(d[a+(g<<1)>>1]|0);o=+(d[a+((g|1)<<1)>>1]|0);r=+(d[a+((g|2)<<1)>>1]|0);q=+(d[a+((g|3)<<1)>>1]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(f|0));s=m;t=k&-4}if((t|0)<(k|0)){f=t;m=s;while(1){q=+(d[a+(f<<1)>>1]|0);r=m+q*q;f=f+1|0;if((f|0)==(k|0)){u=r;break}else m=r}}else u=s;l=h+u;p[e>>3]=l;return 0}function uO(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;k=a}else{l=g;p[d>>3]=l;return 0}while(1){if(!(b[c+h>>0]|0))m=i;else{n=0;o=i;while(1){q=+(j[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(f|0)){m=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){l=m;break}else{i=m;k=k+(f<<1)|0}}p[d>>3]=l;return 0}k=Y(f,e)|0;e=k+-4|0;if((k|0)<4){s=0.0;t=0}else{f=0;m=0.0;do{i=+(j[a+(f<<1)>>1]|0);o=+(j[a+((f|1)<<1)>>1]|0);r=+(j[a+((f|2)<<1)>>1]|0);q=+(j[a+((f|3)<<1)>>1]|0);m=m+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=m;t=k&-4}if((t|0)<(k|0)){e=t;m=s;while(1){q=+(j[a+(e<<1)>>1]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=s;l=g+u;p[d>>3]=l;return 0}function vO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=(Y(p,p)|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=q;break}else o=q}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){r=0;s=0}else{g=0;m=0;do{j=b[a+g>>0]|0;i=b[a+(g|1)>>0]|0;c=b[a+(g|2)>>0]|0;o=b[a+(g|3)>>0]|0;m=(Y(j,j)|0)+m+(Y(i,i)|0)+(Y(c,c)|0)+(Y(o,o)|0)|0;g=g+4|0}while((g|0)<=(e|0));r=m;s=k&-4}if((s|0)<(k|0)){m=s;s=r;while(1){e=b[a+m>>0]|0;g=(Y(e,e)|0)+s|0;m=m+1|0;if((m|0)==(k|0)){t=g;break}else s=g}}else t=r;l=t+h|0;f[d>>2]=l;return 0}function wO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=h[l+o>>0]|0;r=(Y(q,q)|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=r;break}else p=r}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){s=0;t=0}else{g=0;n=0;do{k=h[a+g>>0]|0;j=h[a+(g|1)>>0]|0;c=h[a+(g|2)>>0]|0;p=h[a+(g|3)>>0]|0;n=(Y(k,k)|0)+n+(Y(j,j)|0)+(Y(c,c)|0)+(Y(p,p)|0)|0;g=g+4|0}while((g|0)<=(e|0));s=n;t=l&-4}if((t|0)<(l|0)){n=t;t=s;while(1){e=h[a+n>>0]|0;g=(Y(e,e)|0)+t|0;n=n+1|0;if((n|0)==(l|0)){u=g;break}else t=g}}else u=s;m=u+i|0;f[d>>2]=m;return 0}function xO(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0.0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=o+ +L(+(+n[j+(m<<2)>>2]));m=m+1|0;if((m|0)==(f|0)){l=q;break}else o=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0;s=0.0}else{l=0.0;f=0;do{i=+L(+(+n[a+(f<<2)>>2]));o=i+ +L(+(+n[a+((f|1)<<2)>>2]));i=o+ +L(+(+n[a+((f|2)<<2)>>2]));l=l+(i+ +L(+(+n[a+((f|3)<<2)>>2])));f=f+4|0}while((f|0)<=(e|0));r=j&-4;s=l}if((r|0)<(j|0)){l=s;e=r;while(1){i=l+ +L(+(+n[a+(e<<2)>>2]));e=e+1|0;if((e|0)==(j|0)){t=i;break}else l=i}}else t=s;k=g+t;p[d>>3]=k;return 0}function yO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=f[k+(n<<2)>>2]|0;r=o+ +(((q|0)>-1?q:0-q|0)|0);n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0.0}else{m=0.0;g=0;do{i=f[a+(g<<2)>>2]|0;c=f[a+((g|1)<<2)>>2]|0;n=f[a+((g|2)<<2)>>2]|0;q=f[a+((g|3)<<2)>>2]|0;m=m+(+(((i|0)>-1?i:0-i|0)|0)+ +(((c|0)>-1?c:0-c|0)|0)+ +(((n|0)>-1?n:0-n|0)|0)+ +(((q|0)>-1?q:0-q|0)|0));g=g+4|0}while((g|0)<=(e|0));s=k&-4;t=m}if((s|0)<(k|0)){m=t;e=s;while(1){s=f[a+(e<<2)>>2]|0;j=m+ +(((s|0)>-1?s:0-s|0)|0);e=e+1|0;if((e|0)==(k|0)){u=j;break}else m=j}}else u=t;l=h+u;p[d>>3]=l;return 0}function zO(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(c|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a}else{m=i;f[e>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=d[l+(o<<1)>>1]|0;r=q<<16>>16;s=(q<<16>>16>-1?r:0-r|0)+p|0;o=o+1|0;if((o|0)==(h|0)){n=s;break}else p=s}}j=j+1|0;if((j|0)==(g|0)){m=n;break}else{k=n;l=l+(h<<1)|0}}f[e>>2]=m;return 0}l=Y(h,g)|0;g=l+-4|0;if((l|0)<4){t=0;u=0}else{h=0;n=0;do{k=d[a+(n<<1)>>1]|0;j=k<<16>>16;c=d[a+((n|1)<<1)>>1]|0;p=c<<16>>16;o=d[a+((n|2)<<1)>>1]|0;s=o<<16>>16;r=d[a+((n|3)<<1)>>1]|0;q=r<<16>>16;h=(k<<16>>16>-1?j:0-j|0)+h+(c<<16>>16>-1?p:0-p|0)+(o<<16>>16>-1?s:0-s|0)+(r<<16>>16>-1?q:0-q|0)|0;n=n+4|0}while((n|0)<=(g|0));t=l&-4;u=h}if((t|0)<(l|0)){h=u;g=t;while(1){t=d[a+(g<<1)>>1]|0;n=t<<16>>16;q=(t<<16>>16>-1?n:0-n|0)+h|0;g=g+1|0;if((g|0)==(l|0)){v=q;break}else h=q}}else v=u;m=v+i|0;f[e>>2]=m;return 0}function AO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=p<<24>>24;r=(p<<24>>24>-1?q:0-q|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0}else{g=0;m=0;do{j=b[a+m>>0]|0;i=j<<24>>24;c=b[a+(m|1)>>0]|0;o=c<<24>>24;n=b[a+(m|2)>>0]|0;r=n<<24>>24;q=b[a+(m|3)>>0]|0;p=q<<24>>24;g=(j<<24>>24>-1?i:0-i|0)+g+(c<<24>>24>-1?o:0-o|0)+(n<<24>>24>-1?r:0-r|0)+(q<<24>>24>-1?p:0-p|0)|0;m=m+4|0}while((m|0)<=(e|0));s=k&-4;t=g}if((s|0)<(k|0)){g=t;e=s;while(1){s=b[a+e>>0]|0;m=s<<24>>24;p=(s<<24>>24>-1?m:0-m|0)+g|0;e=e+1|0;if((e|0)==(k|0)){u=p;break}else g=p}}else u=t;l=u+h|0;f[d>>2]=l;return 0}function BO(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;g=u;u=u+1376|0;h=g+1320|0;i=g+1264|0;j=g+1208|0;k=g+1152|0;l=g+32|0;m=g;o=g+1120|0;q=g+1112|0;r=g+48|0;if(!(nS(a,c)|0)){t=$Xc(64)|0;f[h>>2]=t;v=h+8|0;f[v>>2]=-2147483584;w=h+4|0;f[w>>2]=53;x=t;y=227928;z=x+53|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));A=t+53|0;b[A>>0]=0;vM(-215,h,227820,227825,1108)}B=dS(a,-1)|0;if((B|0)!=(dS(c,-1)|0)){t=$Xc(64)|0;f[h>>2]=t;v=h+8|0;f[v>>2]=-2147483584;w=h+4|0;f[w>>2]=53;x=t;y=227928;z=x+53|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));A=t+53|0;b[A>>0]=0;vM(-215,h,227820,227825,1108)}if(d&8|0){C=+BO(a,c,d&-9,e);D=C/(+XN(c,d,e)+2.220446049250313e-16);u=g;return +D}do if((eS(a)|0)==65536){A=f[a+4>>2]|0;f[h>>2]=f[A>>2];t=h+4|0;w=A+4|0;f[t>>2]=f[w>>2];v=h+8|0;f[v>>2]=f[A+8>>2];f[h+12>>2]=f[A+12>>2];f[h+16>>2]=f[A+16>>2];f[h+20>>2]=f[A+20>>2];f[h+24>>2]=f[A+24>>2];f[h+28>>2]=f[A+28>>2];f[h+32>>2]=f[A+32>>2];B=f[A+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=v;v=h+48|0;E=h+44|0;f[E>>2]=v;f[v>>2]=0;f[h+52>>2]=0;if(B|0){v=B+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[w>>2]|0)<3){w=f[A+44>>2]|0;v=f[E>>2]|0;f[v>>2]=f[w>>2];f[v+4>>2]=f[w+4>>2];break}else{f[t>>2]=0;U$(h,A);break}}else bS(h,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];A=i+4|0;t=a+4|0;f[A>>2]=f[t>>2];w=i+8|0;f[w>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[i+36>>2]=v;f[i+40>>2]=w;w=i+48|0;E=i+44|0;f[E>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(v|0){w=v+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;w=f[E>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2];break}else{f[A>>2]=0;U$(i,a);break}}else bS(i,c,-1);while(0);do if((eS(e)|0)==65536){c=f[e+4>>2]|0;f[j>>2]=f[c>>2];a=j+4|0;A=c+4|0;f[a>>2]=f[A>>2];t=j+8|0;f[t>>2]=f[c+8>>2];f[j+12>>2]=f[c+12>>2];f[j+16>>2]=f[c+16>>2];f[j+20>>2]=f[c+20>>2];f[j+24>>2]=f[c+24>>2];f[j+28>>2]=f[c+28>>2];f[j+32>>2]=f[c+32>>2];w=f[c+36>>2]|0;f[j+36>>2]=w;f[j+40>>2]=t;t=j+48|0;E=j+44|0;f[E>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[A>>2]|0)<3){A=f[c+44>>2]|0;t=f[E>>2]|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];break}else{f[a>>2]=0;U$(j,c);break}}else bS(j,e,-1);while(0);e=f[h>>2]|0;c=e&7;a=(e>>>3&511)+1|0;A=d&7;t=(A|0)==1;E=(A|0)==2;w=(A|0)==4;v=(A|0)==5;switch(d&7){case 1:case 2:case 4:case 5:break;default:if(!((A|1|0)==7&(e&4095|0)==0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;d=$Xc(192)|0;f[k>>2]=d;f[k+8>>2]=-2147483456;f[k+4>>2]=177;o1c(d|0,227982,177)|0;b[d+177>>0]=0;vM(-215,k,227820,227825,1133)}}do if((e&16384|0)!=0?(f[i>>2]&16384|0)!=0:0){if(f[j+16>>2]|0){d=f[j+4>>2]|0;if((d|0)<3)F=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{B=f[j+40>>2]|0;G=0;H=1;while(1){I=Y(f[B+(G<<2)>>2]|0,H)|0;G=G+1|0;if((G|0)==(d|0)){F=I;break}else H=I}}if(!((d|0)==0|(F|0)==0)){J=68;break}}H=f[h+4>>2]|0;if((H|0)<3)K=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{G=f[h+40>>2]|0;B=0;I=1;while(1){N=Y(f[G+(B<<2)>>2]|0,I)|0;B=B+1|0;if((B|0)==(H|0)){K=N;break}else I=N}}I=Y(a,K)|0;if((c|0)==5){H=f[h+16>>2]|0;B=f[i+16>>2]|0;if(w){G=I+-4|0;if((I|0)<4){O=0.0;P=0}else{d=0;C=0.0;do{Q=+n[H+(d<<2)>>2]-+n[B+(d<<2)>>2];N=d|1;R=+n[H+(N<<2)>>2]-+n[B+(N<<2)>>2];N=d|2;S=+n[H+(N<<2)>>2]-+n[B+(N<<2)>>2];N=d|3;T=+n[H+(N<<2)>>2]-+n[B+(N<<2)>>2];C=C+(Q*Q+R*R+S*S+T*T);d=d+4|0}while((d|0)<=(G|0));O=C;P=I&-4}if((P|0)<(I|0)){G=P;T=O;while(1){S=+n[H+(G<<2)>>2]-+n[B+(G<<2)>>2];R=T+S*S;G=G+1|0;if((G|0)==(I|0)){U=R;break}else T=R}}else U=O;V=+M(+(U+0.0));break}if(v){G=I+-4|0;if((I|0)<4){W=0.0;X=0}else{d=0;T=0.0;do{C=+n[H+(d<<2)>>2]-+n[B+(d<<2)>>2];N=d|1;R=+n[H+(N<<2)>>2]-+n[B+(N<<2)>>2];N=d|2;S=+n[H+(N<<2)>>2]-+n[B+(N<<2)>>2];N=d|3;Q=+n[H+(N<<2)>>2]-+n[B+(N<<2)>>2];T=T+(C*C+R*R+S*S+Q*Q);d=d+4|0}while((d|0)<=(G|0));W=T;X=I&-4}if((X|0)<(I|0)){G=X;Q=W;while(1){S=+n[H+(G<<2)>>2]-+n[B+(G<<2)>>2];R=Q+S*S;G=G+1|0;if((G|0)==(I|0)){Z=R;break}else Q=R}}else Z=W;V=Z+0.0;break}if(!E){if(!t){J=68;break}if((I|0)>0){G=0;Q=0.0;while(1){T=+L(+(+n[H+(G<<2)>>2]-+n[B+(G<<2)>>2]));R=Q<T?T:Q;G=G+1|0;if((G|0)==(I|0)){_=R;break}else Q=R}}else _=0.0;V=_>0.0?_:0.0;break}G=I+-4|0;if((I|0)<4){$=0.0;aa=0}else{d=0;Q=0.0;do{N=d|1;ba=d|2;ca=d|3;Q=Q+(+L(+(+n[H+(d<<2)>>2]-+n[B+(d<<2)>>2]))+ +L(+(+n[H+(N<<2)>>2]-+n[B+(N<<2)>>2]))+ +L(+(+n[H+(ba<<2)>>2]-+n[B+(ba<<2)>>2]))+ +L(+(+n[H+(ca<<2)>>2]-+n[B+(ca<<2)>>2])));d=d+4|0}while((d|0)<=(G|0));$=Q;aa=I&-4}if((aa|0)<(I|0)){G=aa;R=$;while(1){T=R+ +L(+(+n[H+(G<<2)>>2]-+n[B+(G<<2)>>2]));G=G+1|0;if((G|0)==(I|0)){da=T;break}else R=T}}else da=$;V=da+0.0}else J=68}else J=68;while(0);do if((J|0)==68){aa=(f[j+16>>2]|0)==0;if(!aa){X=f[j+4>>2]|0;if((X|0)<3)ea=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{v=f[j+40>>2]|0;P=0;K=1;while(1){F=Y(f[v+(P<<2)>>2]|0,K)|0;P=P+1|0;if((P|0)==(X|0)){ea=F;break}else K=F}}if(!((X|0)==0|(ea|0)==0)?f[j>>2]&4095|0:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;K=$Xc(48)|0;f[k>>2]=K;f[k+8>>2]=-2147483600;f[k+4>>2]=36;x=K;y=227891;z=x+36|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[K+36>>0]=0;vM(-215,k,227820,227825,1173)}}X=(A|0)==6;P=A|1;if((P|0)==7){if(!aa){v=f[j+4>>2]|0;if((v|0)<3)fa=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{F=f[j+40>>2]|0;e=0;I=1;while(1){G=Y(f[F+(e<<2)>>2]|0,I)|0;e=e+1|0;if((e|0)==(v|0)){fa=G;break}else I=G}}if(!((v|0)==0|(fa|0)==0)){f[k>>2]=1124007936;I=k+4|0;e=k+8|0;F=k+40|0;x=I;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[F>>2]=e;v=k+48|0;aa=k+44|0;f[aa>>2]=v;f[v>>2]=0;f[k+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;K=o+8|0;f[K>>2]=0;f[K+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;y1(l,m,o,fT()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=j;K=o+8|0;f[K>>2]=0;f[K+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;v1(l,m,o,fT()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;da=+XN(l,A,fT()|0);K=k+36|0;G=f[K>>2]|0;if(G|0?(B=G+12|0,G=f[B>>2]|0,f[B>>2]=G+-1,(G|0)==1):0)V$(k);f[K>>2]=0;K=k+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[F>>2]|0;G=0;do{f[K+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[I>>2]|0))}I=f[aa>>2]|0;if((I|0)!=(v|0))wL(I);V=da;break}}I=X?1:2;f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=0;G=l;f[G>>2]=0;f[G+4>>2]=0;BL(m,k,l,-1);G=f[m+20>>2]|0;K=m+16|0;F=l+4|0;e=0;B=0;while(1){if(e>>>0>=(f[K>>2]|0)>>>0)break;H=(VN(f[l>>2]|0,f[F>>2]|0,G,I)|0)+B|0;CL(m)|0;e=e+1|0;B=H}V=+(B|0);break}e=(c|0)==7;I=f[36244+(A>>>1<<5)+((e?5:c)<<2)>>2]|0;if(!I){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=9;x=k;y=264557;z=x+9|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[k+9>>0]=0;vM(-215,k,227820,227825,1201)}f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=j;f[k+12>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;p[m>>3]=0.0;BL(o,k,l,-1);B=f[o+20>>2]|0;G=c>>>0<2;F=(P|0)==5&G|(e|E&c>>>0<4);f[q>>2]=0;K=r+8|0;f[r>>2]=K;X=r+4|0;f[X>>2]=264;do if(F){v=f[h+4>>2]|0;if((v|0)>0)ga=f[(f[h+44>>2]|0)+(v+-1<<2)>>2]|0;else ga=0;if(!e){v=((E&G?8388608:32768)>>>0)/(a>>>0)|0;ha=ga;ia=0;ja=q;ka=(v|0)<(B|0)?v:B;la=0;break}v=(B|0)<1024?B:1024;aa=v<<1;f[X>>2]=aa;if(aa>>>0>264){H=bYc(aa>>>0>1073741823?-1:aa<<2)|0;f[r>>2]=H;ma=H}else ma=K;ha=ga;ia=ma;ja=m;ka=v;la=ma}else{ha=0;ia=0;ja=m;ka=B;la=0}while(0);G=o+16|0;P=(B|0)>0;v=l+4|0;H=l+8|0;aa=(c|0)!=7&F;d=0;while(1){if(d>>>0>=(f[G>>2]|0)>>>0)break;a:do if(P){if(e){ca=0;ba=f[l>>2]|0;while(1){N=B-ca|0;na=(ka|0)<(N|0)?ka:N;UW(ba,ia,na);N=ia+(na<<2)|0;UW(f[v>>2]|0,N,na);xg[I&127](la,N,f[H>>2]|0,ja,na,a)|0;if(aa){p[m>>3]=+p[m>>3]+ +((f[q>>2]|0)>>>0);f[q>>2]=0}N=Y(na,ha)|0;ba=(f[l>>2]|0)+N|0;f[l>>2]=ba;f[v>>2]=(f[v>>2]|0)+N;N=f[H>>2]|0;if(N|0)f[H>>2]=N+na;ca=ca+ka|0;if((B|0)<=(ca|0))break a}}ca=f[l>>2]|0;ba=f[v>>2]|0;na=f[H>>2]|0;if(aa){N=0;oa=ca;pa=ba;qa=na;while(1){ra=B-N|0;sa=(ka|0)<(ra|0)?ka:ra;xg[I&127](oa,pa,qa,ja,sa,a)|0;p[m>>3]=+p[m>>3]+ +((f[q>>2]|0)>>>0);f[q>>2]=0;ra=Y(sa,ha)|0;oa=(f[l>>2]|0)+ra|0;f[l>>2]=oa;pa=(f[v>>2]|0)+ra|0;f[v>>2]=pa;ra=f[H>>2]|0;if(!ra)ta=0;else{ua=ra+sa|0;f[H>>2]=ua;ta=ua}N=N+ka|0;if((B|0)<=(N|0))break;else qa=ta}}else{qa=0;N=ca;pa=ba;oa=na;while(1){ua=B-qa|0;sa=(ka|0)<(ua|0)?ka:ua;xg[I&127](N,pa,oa,ja,sa,a)|0;ua=Y(sa,ha)|0;N=(f[l>>2]|0)+ua|0;f[l>>2]=N;pa=(f[v>>2]|0)+ua|0;f[v>>2]=pa;ua=f[H>>2]|0;if(!ua)va=0;else{ra=ua+sa|0;f[H>>2]=ra;va=ra}qa=qa+ka|0;if((B|0)<=(qa|0))break;else oa=va}}}while(0);CL(o)|0;d=d+1|0}if(t){if((c|0)!=6){d=f[m>>2]|0;p[m>>3]=(c|0)==5?(f[s>>2]=d,+n[s>>2]):+(d>>>0)}}else if(w){da=+M(+(+p[m>>3]));p[m>>3]=da}da=+p[m>>3];d=f[r>>2]|0;if((d|0)!=(K|0)){if(d|0)dYc(d);f[r>>2]=K;f[X>>2]=264}V=da}while(0);r=j+36|0;m=f[r>>2]|0;if(m|0?(w=m+12|0,m=f[w>>2]|0,f[w>>2]=m+-1,(m|0)==1):0)V$(j);f[r>>2]=0;r=j+16|0;m=j+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[m>>2]|0)>0){r=f[j+40>>2]|0;w=0;do{f[r+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[m>>2]|0))}m=f[j+44>>2]|0;if((m|0)!=(j+48|0))wL(m);m=i+36|0;j=f[m>>2]|0;if(j|0?(w=j+12|0,j=f[w>>2]|0,f[w>>2]=j+-1,(j|0)==1):0)V$(i);f[m>>2]=0;m=i+16|0;j=i+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){m=f[i+40>>2]|0;w=0;do{f[m+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))wL(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(w=i+12|0,i=f[w>>2]|0,f[w>>2]=i+-1,(i|0)==1):0)V$(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[h+40>>2]|0;w=0;do{f[j+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))wL(i);D=V;u=g;return +D}function CO(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[e>>2]|0;if(!d){k=Y(i,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(j|0)<(p|0)?p:j;f[e>>2]=q;return 0}if((g|0)>0&(i|0)>0){r=0;s=a;t=c;u=j}else{q=j;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=u;else{j=0;c=u;while(1){a=(h[s+j>>0]|0)-(h[t+j>>0]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=s+i|0;t=t+i|0;u=v}}f[e>>2]=q;return 0}function DO(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;n=(m|0)>-1?m:0-m|0;m=(k|0)<(n|0)?n:k;l=l+1|0;if((l|0)==(j|0)){o=m;break}else k=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=a;s=c;t=i}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{i=0;c=t;while(1){a=(b[r+i>>0]|0)-(b[s+i>>0]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=r+h|0;s=s+h|0;t=u}}f[e>>2]=p;return 0}function EO(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(j[a+(m<<1)>>1]|0)-(j[c+(m<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=a;t=c;u=i}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=u;else{i=0;c=u;while(1){a=(j[s+(i<<1)>>1]|0)-(j[t+(i<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;i=i+1|0;if((i|0)==(h|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=s+(h<<1)|0;t=t+(h<<1)|0;u=v}}f[e>>2]=q;return 0}function FO(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[g>>2]|0;if(!e){k=Y(i,h)|0;if((k|0)>0){l=0;m=0;while(1){n=(d[a+(m<<1)>>1]|0)-(d[c+(m<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(j|0)<(p|0)?p:j;f[g>>2]=q;return 0}if((h|0)>0&(i|0)>0){r=0;s=a;t=c;u=j}else{q=j;f[g>>2]=q;return 0}while(1){if(!(b[e+r>>0]|0))v=u;else{j=0;c=u;while(1){a=(d[s+(j<<1)>>1]|0)-(d[t+(j<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(h|0)){q=v;break}else{s=s+(i<<1)|0;t=t+(i<<1)|0;u=v}}f[g>>2]=q;return 0}function GO(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0;n=(m|0)>-1?m:0-m|0;m=(k|0)<(n|0)?n:k;l=l+1|0;if((l|0)==(j|0)){o=m;break}else k=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=a;s=c;t=i}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{i=0;c=t;while(1){a=(f[r+(i<<2)>>2]|0)-(f[s+(i<<2)>>2]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=r+(h<<2)|0;s=s+(h<<2)|0;t=u}}f[e>>2]=p;return 0}function HO(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0;i=f[e>>2]|0;j=(f[s>>2]=i,+n[s>>2]);if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0.0;while(1){o=+L(+(+n[a+(l<<2)>>2]-+n[c+(l<<2)>>2]));p=m<o?o:m;l=l+1|0;if((l|0)==(k|0)){q=p;break}else m=p}}else q=0.0;r=(n[s>>2]=j<q?q:j,f[s>>2]|0);f[e>>2]=r;return 0}if((g|0)>0&(h|0)>0){t=0;u=a;v=c;w=j;x=i}else{r=i;f[e>>2]=r;return 0}while(1){if(!(b[d+t>>0]|0)){y=w;z=x}else{i=0;j=w;do{q=+L(+(+n[u+(i<<2)>>2]-+n[v+(i<<2)>>2]));j=j<q?q:j;i=i+1|0}while((i|0)!=(h|0));y=j;z=(n[s>>2]=j,f[s>>2]|0)}t=t+1|0;if((t|0)==(g|0)){r=z;break}else{u=u+(h<<2)|0;v=v+(h<<2)|0;w=y;x=z}}f[e>>2]=r;return 0}function IO(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0;h=+p[e>>3];if(!d){i=Y(g,f)|0;if((i|0)>0){j=0.0;k=0;while(1){l=+L(+(+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3]));m=j<l?l:j;k=k+1|0;if((k|0)==(i|0)){n=m;break}else j=m}}else n=0.0;o=h<n?n:h;p[e>>3]=o;return 0}if((f|0)>0&(g|0)>0){q=0;r=a;s=c;t=h}else{o=h;p[e>>3]=o;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{c=0;h=t;while(1){n=+L(+(+p[r+(c<<3)>>3]-+p[s+(c<<3)>>3]));j=h<n?n:h;c=c+1|0;if((c|0)==(g|0)){u=j;break}else h=j}}q=q+1|0;if((q|0)==(f|0)){o=u;break}else{r=r+(g<<3)|0;s=s+(g<<3)|0;t=u}}p[e>>3]=o;return 0}function JO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return iP(a,b,c,d,e,f)|0}function KO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return hP(a,b,c,d,e,f)|0}function LO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return gP(a,b,c,d,e,f)|0}function MO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return fP(a,b,c,d,e,f)|0}function NO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return eP(a,b,c,d,e,f)|0}function OO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dP(a,b,c,d,e,f)|0}function PO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cP(a,b,c,d,e,f)|0}function QO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bP(a,b,c,d,e,f)|0}function RO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return aP(a,b,c,d,e,f)|0}function SO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $O(a,b,c,d,e,f)|0}function TO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _O(a,b,c,d,e,f)|0}function UO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ZO(a,b,c,d,e,f)|0}function VO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return YO(a,b,c,d,e,f)|0}function WO(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return XO(a,b,c,d,e,f)|0}function XO(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=c;l=a}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=+p[l+(o<<3)>>3]-+p[k+(o<<3)>>3];s=q+r*r;o=o+1|0;if((o|0)==(g|0)){n=s;break}else q=s}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0.0;u=0}else{g=0;n=0.0;do{j=+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3];k=g|1;q=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|2;s=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|3;r=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];n=n+(j*j+q*q+s*s+r*r);g=g+4|0}while((g|0)<=(f|0));t=n;u=l&-4}if((u|0)<(l|0)){f=u;n=t;while(1){r=+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3];s=n+r*r;f=f+1|0;if((f|0)==(l|0)){v=s;break}else n=s}}else v=t;m=h+v;p[e>>3]=m;return 0}function YO(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=c;l=a}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=+n[l+(q<<2)>>2]-+n[k+(q<<2)>>2];t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){u=0.0;v=0}else{g=0;o=0.0;do{j=+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2];k=g|1;r=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|2;t=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|3;s=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];o=o+(j*j+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=o;v=l&-4}if((v|0)<(l|0)){f=v;o=u;while(1){s=+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2];t=o+s*s;f=f+1|0;if((f|0)==(l|0)){w=t;break}else o=t}}else w=u;m=h+w;p[e>>3]=m;return 0}function ZO(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((f[m+(q<<2)>>2]|0)-(f[l+(q<<2)>>2]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{k=+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0);l=h|1;r=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|2;t=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|3;s=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){s=+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=u;n=i+w;p[e>>3]=n;return 0}function _O(a,c,e,f,g,h){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;i=+p[f>>3];if(e|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;p[f>>3]=n;return 0}while(1){if(!(b[e+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((d[m+(q<<1)>>1]|0)-(d[l+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<1)|0;m=m+(h<<1)|0}}p[f>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{k=+((d[a+(h<<1)>>1]|0)-(d[c+(h<<1)>>1]|0)|0);l=h|1;r=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|2;t=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|3;s=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){s=+((d[a+(g<<1)>>1]|0)-(d[c+(g<<1)>>1]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=u;n=i+w;p[f>>3]=n;return 0}function $O(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;k=h;l=c;m=a}else{n=h;p[e>>3]=n;return 0}while(1){if(!(b[d+i>>0]|0))o=k;else{q=0;r=k;while(1){s=+((j[m+(q<<1)>>1]|0)-(j[l+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){n=o;break}else{k=o;l=l+(g<<1)|0;m=m+(g<<1)|0}}p[e>>3]=n;return 0}m=Y(g,f)|0;f=m+-4|0;if((m|0)<4){u=0.0;v=0}else{g=0;o=0.0;do{k=+((j[a+(g<<1)>>1]|0)-(j[c+(g<<1)>>1]|0)|0);l=g|1;r=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|2;t=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|3;s=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=o;v=m&-4}if((v|0)<(m|0)){f=v;o=u;while(1){s=+((j[a+(f<<1)>>1]|0)-(j[c+(f<<1)>>1]|0)|0);t=o+s*s;f=f+1|0;if((f|0)==(m|0)){w=t;break}else o=t}}else w=u;n=h+w;p[e>>3]=n;return 0}function aP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[m+p>>0]|0)-(b[l+p>>0]|0)|0;s=(Y(r,r)|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=(Y(o,o)|0)+l+(Y(j,j)|0)+(Y(d,d)|0)+(Y(q,q)|0)|0;h=h+4|0}while((h|0)<=(g|0));t=l;u=m&-4}if((u|0)<(m|0)){l=u;u=t;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=(Y(g,g)|0)+u|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else u=h}}else v=t;n=v+i|0;f[e>>2]=n;return 0}function bP(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=c;n=a}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[n+q>>0]|0)-(h[m+q>>0]|0)|0;t=(Y(s,s)|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=(Y(p,p)|0)+m+(Y(k,k)|0)+(Y(d,d)|0)+(Y(r,r)|0)|0;i=i+4|0}while((i|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=(Y(g,g)|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[e>>2]=o;return 0}function cP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=q+ +L(+(+p[k+(o<<3)>>3]-+p[l+(o<<3)>>3]));o=o+1|0;if((o|0)==(g|0)){n=r;break}else q=r}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){s=0.0;t=0}else{g=0;n=0.0;do{k=g|1;i=g|2;d=g|3;n=n+(+L(+(+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3]))+ +L(+(+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3]))+ +L(+(+p[a+(i<<3)>>3]-+p[c+(i<<3)>>3]))+ +L(+(+p[a+(d<<3)>>3]-+p[c+(d<<3)>>3])));g=g+4|0}while((g|0)<=(f|0));s=n;t=l&-4}if((t|0)<(l|0)){f=t;n=s;while(1){j=n+ +L(+(+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3]));f=f+1|0;if((f|0)==(l|0)){u=j;break}else n=j}}else u=s;m=h+u;p[e>>3]=m;return 0}function dP(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=r+ +L(+(+n[k+(q<<2)>>2]-+n[l+(q<<2)>>2]));q=q+1|0;if((q|0)==(g|0)){o=s;break}else r=s}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0.0;u=0}else{g=0;o=0.0;do{k=g|1;i=g|2;d=g|3;o=o+(+L(+(+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2]))+ +L(+(+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2]))+ +L(+(+n[a+(i<<2)>>2]-+n[c+(i<<2)>>2]))+ +L(+(+n[a+(d<<2)>>2]-+n[c+(d<<2)>>2])));g=g+4|0}while((g|0)<=(f|0));t=o;u=l&-4}if((u|0)<(l|0)){f=u;o=t;while(1){j=o+ +L(+(+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2]));f=f+1|0;if((f|0)==(l|0)){v=j;break}else o=j}}else v=t;m=h+v;p[e>>3]=m;return 0}function eP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=(f[l+(q<<2)>>2]|0)-(f[m+(q<<2)>>2]|0)|0;t=r+ +(((s|0)>-1?s:0-s|0)|0);q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{l=h|1;j=h|2;d=h|3;o=o+(+L(+(+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0)))+ +L(+(+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0)))+ +L(+(+((f[a+(j<<2)>>2]|0)-(f[c+(j<<2)>>2]|0)|0)))+ +L(+(+((f[a+(d<<2)>>2]|0)-(f[c+(d<<2)>>2]|0)|0))));h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){k=o+ +L(+(+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0)));g=g+1|0;if((g|0)==(m|0)){w=k;break}else o=k}}else w=u;n=i+w;p[e>>3]=n;return 0}function fP(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[g>>2]|0;if(e|0){if((h|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[g>>2]=o;return 0}while(1){if(!(b[e+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(d[m+(q<<1)>>1]|0)-(d[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(h|0)){o=p;break}else{l=p;m=m+(i<<1)|0;n=n+(i<<1)|0}}f[g>>2]=o;return 0}n=Y(i,h)|0;h=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(d[a+(i<<1)>>1]|0)-(d[c+(i<<1)>>1]|0)|0;l=i|1;k=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|2;e=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|3;r=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((e|0)>-1?e:0-e|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(h|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){h=(d[a+(m<<1)>>1]|0)-(d[c+(m<<1)>>1]|0)|0;i=((h|0)>-1?h:0-h|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[g>>2]=o;return 0}function gP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){k=0;l=i;m=a;n=c}else{o=i;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(j[m+(q<<1)>>1]|0)-(j[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(h|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+(h<<1)|0;n=n+(h<<1)|0}}f[e>>2]=o;return 0}n=Y(h,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{h=0;m=0;do{p=(j[a+(h<<1)>>1]|0)-(j[c+(h<<1)>>1]|0)|0;l=h|1;k=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|2;d=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|3;r=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;h=h+4|0}while((h|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(j[a+(m<<1)>>1]|0)-(j[c+(m<<1)>>1]|0)|0;h=((g|0)>-1?g:0-g|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=h;break}else v=h}}else w=u;o=w+i|0;f[e>>2]=o;return 0}function hP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[l+p>>0]|0)-(b[m+p>>0]|0)|0;s=((r|0)>-1?r:0-r|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=((o|0)>-1?o:0-o|0)+l+((j|0)>-1?j:0-j|0)+((d|0)>-1?d:0-d|0)+((q|0)>-1?q:0-q|0)|0;h=h+4|0}while((h|0)<=(g|0));t=l;u=m&-4}if((u|0)<(m|0)){l=u;u=t;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=((g|0)>-1?g:0-g|0)+u|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else u=h}}else v=t;n=v+i|0;f[e>>2]=n;return 0}function iP(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[m+q>>0]|0)-(h[n+q>>0]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=((g|0)>-1?g:0-g|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[e>>2]=o;return 0}function jP(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+112|0;d=c+48|0;e=c+36|0;g=c+32|0;h=c;if((dS(a,-1)|0)&4088|0){f[d+8>>2]=0;b[d+11>>0]=7;b[d>>0]=b[472789]|0;b[d+1>>0]=b[472790]|0;b[d+2>>0]=b[472791]|0;b[d+3>>0]=b[472792]|0;b[d+4>>0]=b[472793]|0;b[d+5>>0]=b[472794]|0;b[d+6>>0]=b[472795]|0;b[d+7>>0]=0;vM(-215,d,228160,228173,298)}do if((eS(a)|0)==65536){i=f[a+4>>2]|0;f[d>>2]=f[i>>2];j=d+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=d+8|0;f[l>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];f[d+16>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];f[d+28>>2]=f[i+28>>2];f[d+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[d+36>>2]=m;f[d+40>>2]=l;l=d+48|0;n=d+44|0;f[n>>2]=l;f[l>>2]=0;f[d+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];o=d;break}else{f[j>>2]=0;U$(d,i);o=d;break}}else{bS(d,a,-1);o=d}while(0);a=f[o>>2]&7;o=f[36340+(a<<2)>>2]|0;if((a|0)==7){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=9;a=e;i=264557;j=a+9|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(j|0));b[e+9>>0]=0;vM(-215,e,228160,228173,314)}f[e>>2]=d;f[e+4>>2]=0;f[g>>2]=0;BL(h,e,g,-1);e=f[h+20>>2]|0;i=h+16|0;a=0;j=0;while(1){if(a>>>0>=(f[i>>2]|0)>>>0)break;k=(Mi[o&1023](f[g>>2]|0,e)|0)+j|0;CL(h)|0;a=a+1|0;j=k}a=d+36|0;h=f[a>>2]|0;if(h|0?(e=h+12|0,h=f[e>>2]|0,f[e>>2]=h+-1,(h|0)==1):0)V$(d);f[a>>2]=0;a=d+16|0;h=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[d+40>>2]|0;e=0;do{f[a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[h>>2]|0))}h=f[d+44>>2]|0;if((h|0)==(d+48|0)){u=c;return j|0}wL(h);u=c;return j|0}function kP(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;if((c|0)>0){d=0;e=0}else{f=0;return f|0}while(1){g=((b[a+e>>0]|0)!=0&1)+d|0;e=e+1|0;if((e|0)==(c|0)){f=g;break}else d=g}return f|0}function lP(a,b){a=a|0;b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){e=0;f=0}else{g=0;h=0;do{h=((d[a+(g<<1)>>1]|0)!=0&1)+h+((d[a+((g|1)<<1)>>1]|0)!=0&1)+((d[a+((g|2)<<1)>>1]|0)!=0&1)+((d[a+((g|3)<<1)>>1]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));e=h;f=b&-4}if((f|0)<(b|0)){i=f;j=e}else{k=e;return k|0}while(1){e=((d[a+(i<<1)>>1]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=e;break}else j=e}return k|0}function mP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{g=0;h=0;do{h=((f[a+(g<<2)>>2]|0)!=0&1)+h+((f[a+((g|1)<<2)>>2]|0)!=0&1)+((f[a+((g|2)<<2)>>2]|0)!=0&1)+((f[a+((g|3)<<2)>>2]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));d=h;e=b&-4}if((e|0)<(b|0)){i=e;j=d}else{k=d;return k|0}while(1){d=((f[a+(i<<2)>>2]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=d;break}else j=d}return k|0}function nP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+n[a+(f<<2)>>2]!=0.0&1)+g+(+n[a+((f|1)<<2)>>2]!=0.0&1)+(+n[a+((f|2)<<2)>>2]!=0.0&1)+(+n[a+((f|3)<<2)>>2]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){h=e;i=d}else{j=d;return j|0}while(1){d=(+n[a+(h<<2)>>2]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=d;break}else i=d}return j|0}function oP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+p[a+(f<<3)>>3]!=0.0&1)+g+(+p[a+((f|1)<<3)>>3]!=0.0&1)+(+p[a+((f|2)<<3)>>3]!=0.0&1)+(+p[a+((f|3)<<3)>>3]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){h=e;i=d}else{j=d;return j|0}while(1){d=(+p[a+(h<<3)>>3]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=d;break}else i=d}return j|0}function pP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){g1c(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)kWc(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=n+(m<<3)|0;g1c(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=d;p=i}else{b=h+-8-i|0;i=h;h=d;while(1){n=i;i=i+-8|0;f[h+-8>>2]=f[i>>2];f[h+-4>>2]=f[n+-4>>2];if((i|0)==(k|0))break;else h=h+-8|0}o=d+(~(b>>>3)<<3)|0;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;cYc(p);return}function qP(a){a=a|0;f[a>>2]=36380;return}function rP(a){a=a|0;cYc(a);return}function sP(a){a=a|0;return}function tP(a,b){a=a|0;b=b|0;return}function uP(a,b){a=a|0;b=b|0;return}function vP(a){a=a|0;return 0}function wP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+64|0;e=d+40|0;g=d+12|0;h=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$4(g,c,1,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);mi[f[(f[a>>2]|0)+28>>2]&2047](h,a);c=s5(g,h)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=1;b[e>>0]=123;b[e+1>>0]=0;s5(c,e)|0;if((b[i>>0]|0)<0)cYc(f[e>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);mi[f[(f[a>>2]|0)+12>>2]&2047](a,g);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=e+11|0;b[a>>0]=1;b[e>>0]=125;b[e+1>>0]=0;s5(g,e)|0;if((b[a>>0]|0)>=0){r3(g);u=d;return}cYc(f[e>>2]|0);r3(g);u=d;return}function xP(a,c){a=a|0;c=c|0;var d=0,e=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=9;c=a;d=228249;e=c+9|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b[a+9>>0]=0;return}function yP(a){a=a|0;f[a>>2]=36380;return}function zP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;a=u;u=u+16|0;d=a;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=6;b[d>>0]=b[228275]|0;b[d+1>>0]=b[228276]|0;b[d+2>>0]=b[228277]|0;b[d+3>>0]=b[228278]|0;b[d+4>>0]=b[228279]|0;b[d+5>>0]=b[228280]|0;b[d+6>>0]=0;g=s5(c,d)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);if(!(_i[f[(f[g>>2]|0)+12>>2]&2047](g)|0)){u=a;return}e=g+4|0;if((f[e>>2]|0)==6){c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=30;h=c;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[c+30>>0]=0;vM(-2,d,528568,473413,1207)}o5(g,g+8|0,3);if(!(f[e>>2]&4)){u=a;return}f[e>>2]=6;u=a;return}function AP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return BP(a,b,c,d,e,f)|0}function BP(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0;h=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){i=(d|0)==0;j=i|(g|0)<1;k=i|(g|0)<1;i=1;l=0;while(1){m=l;l=l+1|0;o=(l|0)<(c|0);if(o){p=m;q=l;while(1){r=a+((Y(q,h)|0)+m<<2)|0;s=+L(+(+n[r>>2]));r=a+((Y(p,h)|0)+m<<2)|0;t=s>+L(+(+n[r>>2]));r=t?q:p;q=q+1|0;if((q|0)==(c|0)){u=r;break}else p=r}}else u=m;p=Y(u,h)|0;if(+L(+(+n[a+(p+m<<2)>>2]))<1.1920928955078125e-06){v=0;break}if((u|0)==(m|0))w=i;else{q=Y(m,h)|0;r=m;do{t=a+(r+q<<2)|0;x=a+(r+p<<2)|0;y=f[t>>2]|0;f[t>>2]=f[x>>2];f[x>>2]=y;r=r+1|0}while((r|0)!=(c|0));if(!k){r=Y(m,b)|0;p=Y(u,b)|0;q=0;do{y=d+(q+r<<2)|0;x=d+(q+p<<2)|0;t=f[y>>2]|0;f[y>>2]=f[x>>2];f[x>>2]=t;q=q+1|0}while((q|0)!=(g|0))}w=0-i|0}q=Y(m,h)|0;s=-1.0/+n[a+(q+m<<2)>>2];if(!o){z=w;break a}p=Y(m,b)|0;r=l;do{t=Y(r,h)|0;A=s*+n[a+(t+m<<2)>>2];x=l;do{y=a+(x+t<<2)|0;n[y>>2]=+n[y>>2]+A*+n[a+(x+q<<2)>>2];x=x+1|0}while((x|0)!=(c|0));if(!j){x=Y(r,b)|0;t=0;do{y=d+(t+x<<2)|0;n[y>>2]=+n[y>>2]+A*+n[d+(t+p<<2)>>2];t=t+1|0}while((t|0)!=(g|0))}r=r+1|0}while((r|0)!=(c|0));if(!o){z=w;break a}else i=w}return v|0}else z=1;while(0);if(e&(d|0)!=0&(g|0)>0)B=c;else{v=z;return v|0}do{e=B;B=B+-1|0;w=Y(B,b)|0;u=Y(B,h)|0;i=a+(u+B<<2)|0;if((e|0)<(c|0)){j=0;do{l=d+(j+w<<2)|0;s=+n[l>>2];k=e;do{r=d+((Y(k,b)|0)+j<<2)|0;s=s-+n[a+(k+u<<2)>>2]*+n[r>>2];k=k+1|0}while((k|0)!=(c|0));n[l>>2]=s/+n[i>>2];j=j+1|0}while((j|0)!=(g|0))}else{j=0;do{u=d+(j+w<<2)|0;n[u>>2]=+n[u>>2]/+n[i>>2];j=j+1|0}while((j|0)!=(g|0))}}while((e|0)>1);v=z;return v|0}function CP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return DP(a,b,c,d,e,f)|0}function DP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=(d|0)==0;i=h|(f|0)<1;j=h|(f|0)<1;h=1;k=0;while(1){l=k;k=k+1|0;m=(k|0)<(c|0);if(m){n=l;o=k;while(1){q=a+((Y(o,g)|0)+l<<3)|0;r=+L(+(+p[q>>3]));q=a+((Y(n,g)|0)+l<<3)|0;s=r>+L(+(+p[q>>3]));q=s?o:n;o=o+1|0;if((o|0)==(c|0)){t=q;break}else n=q}}else t=l;n=Y(t,g)|0;if(+L(+(+p[a+(n+l<<3)>>3]))<2.220446049250313e-14){u=0;break}if((t|0)==(l|0))v=h;else{o=Y(l,g)|0;q=l;do{s=a+(q+o<<3)|0;w=a+(q+n<<3)|0;r=+p[s>>3];p[s>>3]=+p[w>>3];p[w>>3]=r;q=q+1|0}while((q|0)!=(c|0));if(!j){q=Y(l,b)|0;n=Y(t,b)|0;o=0;do{w=d+(o+q<<3)|0;s=d+(o+n<<3)|0;r=+p[w>>3];p[w>>3]=+p[s>>3];p[s>>3]=r;o=o+1|0}while((o|0)!=(f|0))}v=0-h|0}o=Y(l,g)|0;r=-1.0/+p[a+(o+l<<3)>>3];if(!m){x=v;break a}n=Y(l,b)|0;q=k;do{s=Y(q,g)|0;y=r*+p[a+(s+l<<3)>>3];w=k;do{z=a+(w+s<<3)|0;p[z>>3]=+p[z>>3]+y*+p[a+(w+o<<3)>>3];w=w+1|0}while((w|0)!=(c|0));if(!i){w=Y(q,b)|0;s=0;do{z=d+(s+w<<3)|0;p[z>>3]=+p[z>>3]+y*+p[d+(s+n<<3)>>3];s=s+1|0}while((s|0)!=(f|0))}q=q+1|0}while((q|0)!=(c|0));if(!m){x=v;break a}else h=v}return u|0}else x=1;while(0);if(e&(d|0)!=0&(f|0)>0)A=c;else{u=x;return u|0}do{e=A;A=A+-1|0;v=Y(A,b)|0;t=Y(A,g)|0;h=a+(t+A<<3)|0;if((e|0)<(c|0)){i=0;do{k=d+(i+v<<3)|0;r=+p[k>>3];j=e;do{q=d+((Y(j,b)|0)+i<<3)|0;r=r-+p[a+(j+t<<3)>>3]*+p[q>>3];j=j+1|0}while((j|0)!=(c|0));p[k>>3]=r/+p[h>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{t=d+(i+v<<3)|0;p[t>>3]=+p[t>>3]/+p[h>>3];i=i+1|0}while((i|0)!=(f|0))}}while((e|0)>1);u=x;return u|0}function EP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return FP(a,b,c,d,e,f)|0}function FP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<2)|0;m=+n[l>>2];o=Y(k,g)|0;if((k|0)>0){p=m;q=0;while(1){r=p-+n[a+(q+j<<2)>>2]*+n[a+(q+o<<2)>>2];q=q+1|0;if((q|0)==(k|0)){s=r;break}else p=r}}else s=m;n[l>>2]=s*+n[a+(o+k<<2)>>2];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<2)|0;p=+n[k>>2];if(i){q=0;r=p;while(1){t=+n[a+(q+j<<2)>>2];u=r-t*t;q=q+1|0;if((q|0)==(h|0)){v=u;w=k;break}else r=u}}else{v=p;w=k}}else{q=a+(j+h<<2)|0;v=+n[q>>2];w=q}if(v<1.1920928955078125e-07){x=0;break}r=1.0/+M(+v);n[w>>2]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{w=a+((Y(y,g)|0)+y<<2)|0;n[w>>2]=1.0/+n[w>>2];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{w=Y(y,b)|0;h=Y(y,g)|0;q=a+(h+y<<2)|0;if((y|0)>0){i=0;do{z=d+(i+w<<2)|0;A=0;v=+n[z>>2];do{B=d+((Y(A,b)|0)+i<<2)|0;v=v-+n[a+(A+h<<2)>>2]*+n[B>>2];A=A+1|0}while((A|0)!=(y|0));n[z>>2]=v*+n[q>>2];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+w<<2)|0;n[h>>2]=+n[h>>2]*+n[q>>2];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){q=Y(i,b)|0;w=a+((Y(i,g)|0)+i<<2)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+q<<2)|0;j=y;p=+n[A>>2];do{k=a+((Y(j,g)|0)+i<<2)|0;B=d+((Y(j,b)|0)+h<<2)|0;p=p-+n[k>>2]*+n[B>>2];j=j+-1|0}while((j|0)>(i|0));n[A>>2]=p*+n[w>>2];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+q<<2)|0;n[j>>2]=+n[j>>2]*+n[w>>2];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<2)|0;n[e>>2]=1.0/+n[e>>2];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function GP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return HP(a,b,c,d,e,f)|0}function HP(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<3)|0;m=+p[l>>3];n=Y(k,g)|0;if((k|0)>0){o=m;q=0;while(1){r=o-+p[a+(q+j<<3)>>3]*+p[a+(q+n<<3)>>3];q=q+1|0;if((q|0)==(k|0)){s=r;break}else o=r}}else s=m;p[l>>3]=s*+p[a+(n+k<<3)>>3];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<3)|0;o=+p[k>>3];if(i){q=0;r=o;while(1){t=+p[a+(q+j<<3)>>3];u=r-t*t;q=q+1|0;if((q|0)==(h|0)){v=u;w=k;break}else r=u}}else{v=o;w=k}}else{q=a+(j+h<<3)|0;v=+p[q>>3];w=q}if(v<2.220446049250313e-16){x=0;break}r=1.0/+M(+v);p[w>>3]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{w=a+((Y(y,g)|0)+y<<3)|0;p[w>>3]=1.0/+p[w>>3];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{w=Y(y,b)|0;h=Y(y,g)|0;q=a+(h+y<<3)|0;if((y|0)>0){i=0;do{z=d+(i+w<<3)|0;A=0;v=+p[z>>3];do{B=d+((Y(A,b)|0)+i<<3)|0;v=v-+p[a+(A+h<<3)>>3]*+p[B>>3];A=A+1|0}while((A|0)!=(y|0));p[z>>3]=v*+p[q>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+w<<3)|0;p[h>>3]=+p[h>>3]*+p[q>>3];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){q=Y(i,b)|0;w=a+((Y(i,g)|0)+i<<3)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+q<<3)|0;j=y;o=+p[A>>3];do{k=a+((Y(j,g)|0)+i<<3)|0;B=d+((Y(j,b)|0)+h<<3)|0;o=o-+p[k>>3]*+p[B>>3];j=j+-1|0}while((j|0)>(i|0));p[A>>3]=o*+p[w>>3];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+q<<3)|0;p[j>>3]=+p[j>>3]*+p[w>>3];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<3)|0;p[e>>3]=1.0/+p[e>>3];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function IP(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+1072|0;k=j;l=b>>>2;b=h>>>2;h=k+8|0;f[k>>2]=h;m=k+4|0;o=(c|0)==0?(i|0)!=0&1:d+c|0;f[m>>2]=o;if(o>>>0>264){p=bYc(o>>>0>1073741823?-1:o<<2)|0;f[k>>2]=p;q=p}else q=h;p=(i|0)==0?q+(c<<2)|0:i;a:do if((d|0)>0){i=0;o=c;while(1){r=c-i|0;s=(r|0)>0;if(s){t=0;v=0.0;while(1){w=a+((Y(t+i|0,l)|0)+i<<2)|0;x=+n[w>>2];n[q+(t<<2)>>2]=x;y=v+x*x;t=t+1|0;if((t|0)==(o|0)){z=y;break}else v=y}}else z=0.0;v=+n[q>>2];y=v+ +M(+z)*(!(v>=0.0)?-1.0:1.0);n[q>>2]=y;x=+M(+(z+y*y-v*v));if(s?(n[q>>2]=y/x,(o|0)!=1):0){t=1;do{w=q+(t<<2)|0;n[w>>2]=+n[w>>2]/x;t=t+1|0}while((t|0)!=(o|0))}if((i|0)<(c|0)){t=i;do{s=i;x=0.0;do{w=a+((Y(s,l)|0)+t<<2)|0;x=x+ +n[q+(s-i<<2)>>2]*+n[w>>2];s=s+1|0}while((s|0)!=(c|0));A=i;do{s=a+((Y(A,l)|0)+t<<2)|0;n[s>>2]=+n[s>>2]-x*(+n[q+(A-i<<2)>>2]*2.0);A=A+1|0}while((A|0)!=(c|0));t=t+1|0}while((t|0)!=(d|0))}x=+n[q>>2];n[p+(i<<2)>>2]=x*x;if((r|0)>1){x=+n[q>>2];t=1;do{s=a+((Y(t+i|0,l)|0)+i<<2)|0;n[s>>2]=+n[q+(t<<2)>>2]/x;t=t+1|0}while((t|0)!=(o|0))}i=i+1|0;if((i|0)==(d|0))break;else o=o+-1|0}if(g){o=(e|0)>0;if(o){i=0;t=c;while(1){n[q>>2]=1.0;if((c-i|0)>1){r=1;do{s=a+((Y(r+i|0,l)|0)+i<<2)|0;f[q+(r<<2)>>2]=f[s>>2];r=r+1|0}while((r|0)!=(t|0))}r=p+(i<<2)|0;if((i|0)<(c|0)){s=0;do{w=i;x=0.0;do{B=g+((Y(w,b)|0)+s<<2)|0;x=x+ +n[q+(w-i<<2)>>2]*+n[B>>2];w=w+1|0}while((w|0)!=(c|0));C=i;do{w=g+((Y(C,b)|0)+s<<2)|0;n[w>>2]=+n[w>>2]-+n[r>>2]*(x*(+n[q+(C-i<<2)>>2]*2.0));C=C+1|0}while((C|0)!=(c|0));s=s+1|0}while((s|0)!=(e|0))}i=i+1|0;if((i|0)==(d|0))break;else t=t+-1|0}}else{t=0;i=c;while(1){n[q>>2]=1.0;if((c-t|0)>1){s=1;do{r=a+((Y(s+t|0,l)|0)+t<<2)|0;f[q+(s<<2)>>2]=f[r>>2];s=s+1|0}while((s|0)!=(i|0))}t=t+1|0;if((t|0)==(d|0))break;else i=i+-1|0}}i=d+-1|0;if(!o){t=i;while(1){s=a+((Y(t,l)|0)+t<<2)|0;if(+L(+(+n[s>>2]))<1.1920928955078125e-06){D=0;break a}if((t|0)>0)t=t+-1|0;else{D=1;break a}}}if((e|0)==1){t=i;while(1){o=Y(t,l)|0;if((i|0)>(t|0)){s=g+((Y(t,b)|0)<<2)|0;r=i;do{w=g+((Y(r,b)|0)<<2)|0;n[s>>2]=+n[s>>2]-+n[w>>2]*+n[a+(r+o<<2)>>2];r=r+-1|0}while((r|0)>(t|0))}x=+n[a+(o+t<<2)>>2];if(+L(+x)<1.1920928955078125e-06){D=0;break a}r=g+((Y(t,b)|0)<<2)|0;n[r>>2]=+n[r>>2]/x;if((t|0)>0)t=t+-1|0;else{D=1;break a}}}else E=i;while(1){t=Y(E,l)|0;if((i|0)>(E|0)){r=Y(E,b)|0;s=i;do{w=Y(s,b)|0;B=a+(s+t<<2)|0;F=0;do{G=g+(F+r<<2)|0;n[G>>2]=+n[G>>2]-+n[g+(F+w<<2)>>2]*+n[B>>2];F=F+1|0}while((F|0)!=(e|0));s=s+-1|0}while((s|0)>(E|0))}s=a+(t+E<<2)|0;x=+n[s>>2];if(+L(+x)<1.1920928955078125e-06){D=0;break a}r=Y(E,b)|0;o=g+(r<<2)|0;n[o>>2]=+n[o>>2]/x;o=1;do{F=g+(o+r<<2)|0;n[F>>2]=+n[F>>2]/+n[s>>2];o=o+1|0}while((o|0)!=(e|0));if((E|0)>0)E=E+-1|0;else{D=1;break}}}else D=1}else D=1;while(0);if((q|0)==(h|0)){u=j;return D|0}dYc(q);f[k>>2]=h;f[m>>2]=264;u=j;return D|0}function JP(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+1104|0;k=j;l=b>>>3;b=h>>>3;h=k+8|0;f[k>>2]=h;m=k+4|0;n=(c|0)==0?(i|0)!=0&1:d+c|0;f[m>>2]=n;if(n>>>0>136){o=bYc(n>>>0>536870911?-1:n<<3)|0;f[k>>2]=o;q=o}else q=h;o=(i|0)==0?q+(c<<3)|0:i;a:do if((d|0)>0){i=0;n=c;while(1){r=c-i|0;s=(r|0)>0;if(s){t=0;v=0.0;while(1){w=a+((Y(t+i|0,l)|0)+i<<3)|0;x=+p[w>>3];p[q+(t<<3)>>3]=x;y=v+x*x;t=t+1|0;if((t|0)==(n|0)){z=y;break}else v=y}}else z=0.0;v=+p[q>>3];y=v+ +M(+z)*(!(v>=0.0)?-1.0:1.0);p[q>>3]=y;x=+M(+(z+y*y-v*v));if(s?(p[q>>3]=y/x,(n|0)!=1):0){t=1;do{w=q+(t<<3)|0;p[w>>3]=+p[w>>3]/x;t=t+1|0}while((t|0)!=(n|0))}if((i|0)<(c|0)){t=i;do{s=i;x=0.0;do{w=a+((Y(s,l)|0)+t<<3)|0;x=x+ +p[q+(s-i<<3)>>3]*+p[w>>3];s=s+1|0}while((s|0)!=(c|0));A=i;do{s=a+((Y(A,l)|0)+t<<3)|0;p[s>>3]=+p[s>>3]-x*(+p[q+(A-i<<3)>>3]*2.0);A=A+1|0}while((A|0)!=(c|0));t=t+1|0}while((t|0)!=(d|0))}x=+p[q>>3];p[o+(i<<3)>>3]=x*x;if((r|0)>1){x=+p[q>>3];t=1;do{s=a+((Y(t+i|0,l)|0)+i<<3)|0;p[s>>3]=+p[q+(t<<3)>>3]/x;t=t+1|0}while((t|0)!=(n|0))}i=i+1|0;if((i|0)==(d|0))break;else n=n+-1|0}if(g){n=(e|0)>0;if(n){i=0;t=c;while(1){p[q>>3]=1.0;if((c-i|0)>1){r=1;do{s=a+((Y(r+i|0,l)|0)+i<<3)|0;p[q+(r<<3)>>3]=+p[s>>3];r=r+1|0}while((r|0)!=(t|0))}r=o+(i<<3)|0;if((i|0)<(c|0)){s=0;do{w=i;x=0.0;do{B=g+((Y(w,b)|0)+s<<3)|0;x=x+ +p[q+(w-i<<3)>>3]*+p[B>>3];w=w+1|0}while((w|0)!=(c|0));C=i;do{w=g+((Y(C,b)|0)+s<<3)|0;p[w>>3]=+p[w>>3]-+p[r>>3]*(x*(+p[q+(C-i<<3)>>3]*2.0));C=C+1|0}while((C|0)!=(c|0));s=s+1|0}while((s|0)!=(e|0))}i=i+1|0;if((i|0)==(d|0))break;else t=t+-1|0}}else{t=0;i=c;while(1){p[q>>3]=1.0;if((c-t|0)>1){s=1;do{r=a+((Y(s+t|0,l)|0)+t<<3)|0;p[q+(s<<3)>>3]=+p[r>>3];s=s+1|0}while((s|0)!=(i|0))}t=t+1|0;if((t|0)==(d|0))break;else i=i+-1|0}}i=d+-1|0;if(!n){t=i;while(1){s=a+((Y(t,l)|0)+t<<3)|0;if(+L(+(+p[s>>3]))<2.220446049250313e-14){D=0;break a}if((t|0)>0)t=t+-1|0;else{D=1;break a}}}if((e|0)==1){t=i;while(1){n=Y(t,l)|0;if((i|0)>(t|0)){s=g+((Y(t,b)|0)<<3)|0;r=i;do{w=g+((Y(r,b)|0)<<3)|0;p[s>>3]=+p[s>>3]-+p[w>>3]*+p[a+(r+n<<3)>>3];r=r+-1|0}while((r|0)>(t|0))}x=+p[a+(n+t<<3)>>3];if(+L(+x)<2.220446049250313e-14){D=0;break a}r=g+((Y(t,b)|0)<<3)|0;p[r>>3]=+p[r>>3]/x;if((t|0)>0)t=t+-1|0;else{D=1;break a}}}else E=i;while(1){t=Y(E,l)|0;if((i|0)>(E|0)){r=Y(E,b)|0;s=i;do{w=Y(s,b)|0;B=a+(s+t<<3)|0;F=0;do{G=g+(F+r<<3)|0;p[G>>3]=+p[G>>3]-+p[g+(F+w<<3)>>3]*+p[B>>3];F=F+1|0}while((F|0)!=(e|0));s=s+-1|0}while((s|0)>(E|0))}s=a+(t+E<<3)|0;x=+p[s>>3];if(+L(+x)<2.220446049250313e-14){D=0;break a}r=Y(E,b)|0;n=g+(r<<3)|0;p[n>>3]=+p[n>>3]/x;n=1;do{F=g+(n+r<<3)|0;p[F>>3]=+p[F>>3]/+p[s>>3];n=n+1|0}while((n|0)!=(e|0));if((E|0)>0)E=E+-1|0;else{D=1;break}}}else D=1}else D=1;while(0);if((q|0)==(h|0)){u=j;return D|0}dYc(q);f[k>>2]=h;f[m>>2]=136;u=j;return D|0}function KP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;i=u;u=u+208|0;j=i+152|0;k=i+96|0;l=i+80|0;m=i+16|0;o=i+48|0;q=i+44|0;r=i+40|0;s=i+36|0;t=i+32|0;v=i+28|0;w=i+24|0;x=i+8|0;y=i;z=dS(a,-1)|0;A=z&7;B=z>>>3&511;z=B+1|0;C=sS(h)|0;if(!B){if(!C?dS(h,-1)|0:0){E=$Xc(112)|0;f[j>>2]=E;F=j+8|0;f[F>>2]=-2147483536;G=j+4|0;f[G>>2]=104;H=E;I=228282;J=H+104|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));K=E+104|0;b[K>>0]=0;vM(-215,j,228387,228397,765)}}else if((g|0)!=0|((e|0)!=0|C^1)){E=$Xc(112)|0;f[j>>2]=E;F=j+8|0;f[F>>2]=-2147483536;G=j+4|0;f[G>>2]=104;H=E;I=228282;J=H+104|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));K=E+104|0;b[K>>0]=0;vM(-215,j,228387,228397,765)}do if((eS(a)|0)==65536){K=f[a+4>>2]|0;f[j>>2]=f[K>>2];E=j+4|0;G=K+4|0;f[E>>2]=f[G>>2];F=j+8|0;f[F>>2]=f[K+8>>2];f[j+12>>2]=f[K+12>>2];f[j+16>>2]=f[K+16>>2];f[j+20>>2]=f[K+20>>2];f[j+24>>2]=f[K+24>>2];f[j+28>>2]=f[K+28>>2];f[j+32>>2]=f[K+32>>2];C=f[K+36>>2]|0;f[j+36>>2]=C;f[j+40>>2]=F;F=j+48|0;B=j+44|0;f[B>>2]=F;f[F>>2]=0;f[j+52>>2]=0;if(C|0){F=C+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[G>>2]|0)<3){G=f[K+44>>2]|0;F=f[B>>2]|0;f[F>>2]=f[G>>2];f[F+4>>2]=f[G+4>>2];break}else{f[E>>2]=0;U$(j,K);break}}else bS(j,a,-1);while(0);do if((eS(h)|0)==65536){a=f[h+4>>2]|0;f[k>>2]=f[a>>2];K=k+4|0;E=a+4|0;f[K>>2]=f[E>>2];G=k+8|0;f[G>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];F=f[a+36>>2]|0;f[k+36>>2]=F;f[k+40>>2]=G;G=k+48|0;B=k+44|0;f[B>>2]=G;f[G>>2]=0;f[k+52>>2]=0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[E>>2]|0)<3){E=f[a+44>>2]|0;G=f[B>>2]|0;f[G>>2]=f[E>>2];f[G+4>>2]=f[E+4>>2];break}else{f[K>>2]=0;U$(k,a);break}}else bS(k,h,-1);while(0);h=j+4|0;a=f[36412+(A<<2)>>2]|0;if((A|0)==7){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+11>>0]=9;H=l;I=264557;J=H+9|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[l+9>>0]=0;vM(-215,l,228387,228397,782)}f[l>>2]=j;f[l+4>>2]=k;f[l+8>>2]=0;I=m;f[I>>2]=0;f[I+4>>2]=0;BL(o,l,m,-1);f[q>>2]=0;f[r>>2]=0;f[s>>2]=2147483647;f[t>>2]=-2147483648;n[v>>2]=D;n[w>>2]=-D;p[x>>3]=D;p[y>>3]=-D;l=Y(f[o+20>>2]|0,z)|0;z=(A|0)==5;if(!z)if((A|0)==6){L=y;M=x}else{L=t;M=s}else{L=w;M=v}I=o+16|0;if(f[I>>2]|0){H=m+4|0;J=0;K=1;while(1){wi[a&255](f[m>>2]|0,f[H>>2]|0,M,L,q,r,l,K);CL(o)|0;J=J+1|0;if(J>>>0>=(f[I>>2]|0)>>>0)break;else K=K+l|0}}l=j+16|0;do if(f[l>>2]|0){K=f[h>>2]|0;if((K|0)<3)N=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{I=f[j+40>>2]|0;J=0;o=1;while(1){L=Y(f[I+(J<<2)>>2]|0,o)|0;J=J+1|0;if((J|0)==(K|0)){N=L;break}else o=L}}if(!((K|0)==0|(N|0)==0)){if(f[k+16>>2]|0){o=f[k+4>>2]|0;if((o|0)<3)O=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{J=f[k+40>>2]|0;I=0;L=1;while(1){M=Y(f[J+(I<<2)>>2]|0,L)|0;I=I+1|0;if((I|0)==(o|0)){O=M;break}else L=M}}if(!((o|0)==0|(O|0)==0))break}if(!(f[q>>2]|0))f[q>>2]=1;if(!(f[r>>2]|0))f[r>>2]=1}}while(0);O=f[q>>2]|0;q=(O|0)==0;do if(!q){if(z){p[x>>3]=+n[v>>2];p[y>>3]=+n[w>>2];break}if(A>>>0<5){p[x>>3]=+(f[s>>2]|0);p[y>>3]=+(f[t>>2]|0)}}else{p[y>>3]=0.0;p[x>>3]=0.0}while(0);if(c|0)p[c>>3]=+p[x>>3];if(d|0)p[d>>3]=+p[y>>3];do if(e|0){y=f[h>>2]|0;d=(y|0)>0;if(q){if(!d)break;g1c(e|0,-1,y<<2|0)|0;break}if(d){d=f[j+40>>2]|0;x=y;y=O+-1|0;while(1){c=x;x=x+-1|0;t=f[d+(x<<2)>>2]|0;f[e+(x<<2)>>2]=(y>>>0)%(t>>>0)|0;if((c|0)<=1)break;else y=(y>>>0)/(t>>>0)|0}}}while(0);do if(g|0){e=f[r>>2]|0;O=f[h>>2]|0;q=(O|0)>0;if(!e){if(!q)break;g1c(g|0,-1,O<<2|0)|0;break}if(q){q=f[j+40>>2]|0;y=O;O=e+-1|0;while(1){e=y;y=y+-1|0;x=f[q+(y<<2)>>2]|0;f[g+(y<<2)>>2]=(O>>>0)%(x>>>0)|0;if((e|0)<=1)break;else O=(O>>>0)/(x>>>0)|0}}}while(0);g=k+36|0;r=f[g>>2]|0;if(r|0?(O=r+12|0,r=f[O>>2]|0,f[O>>2]=r+-1,(r|0)==1):0)V$(k);f[g>>2]=0;g=k+16|0;r=k+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){g=f[k+40>>2]|0;O=0;do{f[g+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[r>>2]|0))}r=f[k+44>>2]|0;if((r|0)!=(k+48|0))wL(r);r=j+36|0;k=f[r>>2]|0;if(k|0?(O=k+12|0,k=f[O>>2]|0,f[O>>2]=k+-1,(k|0)==1):0)V$(j);f[r>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[h>>2]|0)>0){l=f[j+40>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[h>>2]|0))}h=f[j+44>>2]|0;if((h|0)==(j+48|0)){u=i;return}wL(h);u=i;return}function LP(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=h[a+r>>0]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(j|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=m;t=o;s=n;q=l;while(1){r=(b[c+p>>0]|0)!=0;z=h[a+p>>0]|0;y=p+k|0;A=r&(z|0)<(q|0);x=A?z:q;v=A?y:s;A=r&(z|0)>(u|0);r=A?y:t;y=A?z:u;p=p+1|0;if((p|0)==(j|0)){B=x;C=y;D=r;E=v;break}else{u=y;t=r;s=v;q=x}}}else{B=l;C=m;D=o;E=n}f[g>>2]=E;f[i>>2]=D;f[d>>2]=B;f[e>>2]=C;return}function MP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=l;q=0;r=n;s=m;t=k;while(1){u=b[a+q>>0]|0;v=(u|0)<(t|0);w=q+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(p|0);z=v?w:r;w=v?u:p;q=q+1|0;if((q|0)==(i|0)){A=y;B=w;C=z;D=x;break}else{p=w;r=z;s=x;t=y}}}else{A=k;B=l;C=n;D=m}else if(o){o=0;t=l;s=n;r=m;p=k;while(1){q=(b[c+o>>0]|0)!=0;y=b[a+o>>0]|0;x=o+j|0;z=q&(y|0)<(p|0);w=z?y:p;u=z?x:r;z=q&(y|0)>(t|0);q=z?x:s;x=z?y:t;o=o+1|0;if((o|0)==(i|0)){A=w;B=x;C=q;D=u;break}else{t=x;s=q;r=u;p=w}}}else{A=k;B=l;C=n;D=m}f[g>>2]=D;f[h>>2]=C;f[d>>2]=A;f[e>>2]=B;return}function NP(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=j[a+(r<<1)>>1]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(i|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=l;t=m;s=o;q=n;while(1){r=(b[c+p>>0]|0)!=0;z=j[a+(p<<1)>>1]|0;y=p+k|0;A=r&(z|0)<(u|0);x=A?z:u;v=A?y:q;A=r&(z|0)>(t|0);r=A?y:s;y=A?z:t;p=p+1|0;if((p|0)==(i|0)){B=x;C=y;D=r;E=v;break}else{u=x;t=y;s=r;q=v}}}else{B=l;C=m;D=o;E=n}f[g>>2]=E;f[h>>2]=D;f[d>>2]=B;f[e>>2]=C;return}function OP(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=d[a+(r<<1)>>1]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(j|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=l;t=m;s=o;q=n;while(1){r=(b[c+p>>0]|0)!=0;z=d[a+(p<<1)>>1]|0;y=p+k|0;A=r&(z|0)<(u|0);x=A?z:u;v=A?y:q;A=r&(z|0)>(t|0);r=A?y:s;y=A?z:t;p=p+1|0;if((p|0)==(j|0)){B=x;C=y;D=r;E=v;break}else{u=x;t=y;s=r;q=v}}}else{B=l;C=m;D=o;E=n}f[h>>2]=E;f[i>>2]=D;f[e>>2]=B;f[g>>2]=C;return}function PP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=l;q=0;r=n;s=m;t=k;while(1){u=f[a+(q<<2)>>2]|0;v=(u|0)<(t|0);w=q+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(p|0);z=v?w:r;w=v?u:p;q=q+1|0;if((q|0)==(i|0)){A=y;B=w;C=z;D=x;break}else{p=w;r=z;s=x;t=y}}}else{A=k;B=l;C=n;D=m}else if(o){o=0;t=l;s=n;r=m;p=k;while(1){q=f[a+(o<<2)>>2]|0;y=(b[c+o>>0]|0)!=0;x=(q|0)<(p|0)&y;z=o+j|0;w=x?z:r;u=x?q:p;x=(q|0)>(t|0)&y;y=x?z:s;z=x?q:t;o=o+1|0;if((o|0)==(i|0)){A=u;B=z;C=y;D=w;break}else{t=z;s=y;r=w;p=u}}}else{A=k;B=l;C=n;D=m}f[g>>2]=D;f[h>>2]=C;f[d>>2]=A;f[e>>2]=B;return}function QP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;k=+n[d>>2];l=+n[e>>2];m=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=l;r=0;s=o;t=m;u=k;while(1){v=+n[a+(r<<2)>>2];w=v<u;x=r+j|0;y=w?x:t;z=w?v:u;w=v>q;A=w?x:s;B=w?v:q;r=r+1|0;if((r|0)==(i|0)){C=z;D=B;E=A;F=y;break}else{q=B;s=A;t=y;u=z}}}else{C=k;D=l;E=o;F=m}else if(p){p=0;u=l;t=o;s=m;q=k;while(1){z=+n[a+(p<<2)>>2];r=(b[c+p>>0]|0)!=0;y=z<q&r;A=p+j|0;w=y?A:s;B=y?z:q;y=z>u&r;r=y?A:t;v=y?z:u;p=p+1|0;if((p|0)==(i|0)){C=B;D=v;E=r;F=w;break}else{u=v;t=r;s=w;q=B}}}else{C=k;D=l;E=o;F=m}f[g>>2]=F;f[h>>2]=E;n[d>>2]=C;n[e>>2]=D;return}function RP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;k=+p[d>>3];l=+p[e>>3];m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){q=l;r=0;s=n;t=m;u=k;while(1){v=+p[a+(r<<3)>>3];w=v<u;x=r+j|0;y=w?x:t;z=w?v:u;w=v>q;A=w?x:s;B=w?v:q;r=r+1|0;if((r|0)==(i|0)){C=z;D=B;E=A;F=y;break}else{q=B;s=A;t=y;u=z}}}else{C=k;D=l;E=n;F=m}else if(o){o=0;u=l;t=n;s=m;q=k;while(1){z=+p[a+(o<<3)>>3];r=(b[c+o>>0]|0)!=0;y=z<q&r;A=o+j|0;w=y?A:s;B=y?z:q;y=z>u&r;r=y?A:t;v=y?z:u;o=o+1|0;if((o|0)==(i|0)){C=B;D=v;E=r;F=w;break}else{u=v;t=r;s=w;q=B}}}else{C=k;D=l;E=n;F=m}f[g>>2]=F;f[h>>2]=E;p[d>>3]=C;p[e>>3]=D;return}function SP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+16|0;j=i;if((oS(a,-1)|0)>=3){k=$Xc(32)|0;f[j>>2]=k;f[j+8>>2]=-2147483616;f[j+4>>2]=16;l=k;m=228465;n=l+16|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+16>>0]=0;vM(-215,j,228482,228397,835)}KP(a,c,d,e,g,h);if(e|0){h=e+4|0;d=f[e>>2]|0;f[e>>2]=f[h>>2];f[h>>2]=d}if(!g){u=i;return}d=g+4|0;h=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=h;u=i;return}function TP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,q=0.0,r=0.0;f=u;u=u+1536|0;g=f+1024|0;h=f+512|0;i=f;if((d|0)<=0){u=f;return}j=e?1.0:.01745329238474369;e=0;do{k=d-e|0;l=(k|0)<128?k:128;m=(k|0)>0;if(m){k=0;do{o=k+e|0;n[g+(k<<2)>>2]=+p[a+(o<<3)>>3];n[h+(k<<2)>>2]=+p[b+(o<<3)>>3];k=k+1|0}while((k|0)<(l|0));if(m){k=0;do{q=+U(+(+n[g+(k<<2)>>2]),+(+n[h+(k<<2)>>2]))*180.0/3.141592653589793;r=q<0.0?q+360.0:q;n[i+(k<<2)>>2]=j*(!(r>=360.0)?r:r+-360.0);k=k+1|0}while((k|0)!=(l|0));if(m){k=0;do{p[c+(k+e<<3)>>3]=+n[i+(k<<2)>>2];k=k+1|0}while((k|0)<(l|0))}}}e=e+128|0}while((e|0)<(d|0));u=f;return}function UP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0;f=e?1.0:.01745329238474369;if((d|0)>0)g=0;else return;do{h=+U(+(+n[a+(g<<2)>>2]),+(+n[b+(g<<2)>>2]))*180.0/3.141592653589793;i=h<0.0?h+360.0:h;n[c+(g<<2)>>2]=f*(!(i>=360.0)?i:i+-360.0);g=g+1|0}while((g|0)!=(d|0));return}function VP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;TP(a,b,c,d,e);return}function WP(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0,h=0.0,i=0.0;f=e?1.0:.01745329238474369;if((d|0)>0)g=0;else return;do{h=+U(+(+n[a+(g<<2)>>2]),+(+n[b+(g<<2)>>2]))*180.0/3.141592653589793;i=h<0.0?h+360.0:h;n[c+(g<<2)>>2]=f*(!(i>=360.0)?i:i+-360.0);g=g+1|0}while((g|0)!=(d|0));return}function XP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0.0;if((d|0)>0)e=0;else return;do{f=+n[a+(e<<2)>>2];g=+n[b+(e<<2)>>2];h=+M(+(f*f+g*g));n[c+(e<<2)>>2]=h;e=e+1|0}while((e|0)!=(d|0));return}function YP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,h=0.0;if((d|0)>0)e=0;else return;do{f=+p[a+(e<<3)>>3];g=+p[b+(e<<3)>>3];h=+M(+(f*f+g*g));p[c+(e<<3)>>3]=h;e=e+1|0}while((e|0)!=(d|0));return}function ZP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=1.0/+M(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function _P(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=1.0/+M(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function $P(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+M(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function aQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+M(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function bQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+V(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function cQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+V(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function dQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+W(+(+n[a+(d<<2)>>2]));n[b+(d<<2)>>2]=e;d=d+1|0}while((d|0)!=(c|0));return}function eQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((c|0)>0)d=0;else return;do{e=+W(+(+p[a+(d<<3)>>3]));p[b+(d<<3)>>3]=e;d=d+1|0}while((d|0)!=(c|0));return}function fQ(a,b){a=+a;b=+b;var c=0.0;c=+U(+a,+b)*180.0/3.141592653589793;b=c<0.0?c+360.0:c;return +(!(b>=360.0)?b:b+-360.0)}function gQ(){var a=0;a=HN(228492,1e3)|0;f[135569]=a;return}function hQ(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0,vb=0,wb=0,xb=0,yb=0.0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0.0,Mb=0.0,Nb=0,Ob=0.0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0.0,Yb=0,Zb=0.0,_b=0.0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0.0,uc=0,vc=0,wc=0,xc=0.0,yc=0,zc=0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0,Fc=0.0,Gc=0.0,Hc=0.0,Ic=0,Jc=0.0,Kc=0,Lc=0,Mc=0.0,Nc=0.0,Oc=0.0;j=u;u=u+2096|0;k=j+552|0;l=j+2072|0;m=j+2016|0;o=j+1992|0;q=j+1936|0;r=j+1880|0;t=j+1824|0;v=j+1768|0;w=j+1712|0;x=j+1656|0;y=j+1600|0;z=j+1336|0;A=j;B=j+816|0;C=j+520|0;do if((eS(a)|0)==65536){D=f[a+4>>2]|0;f[q>>2]=f[D>>2];E=q+4|0;F=D+4|0;f[E>>2]=f[F>>2];G=q+8|0;f[G>>2]=f[D+8>>2];H=q+12|0;f[H>>2]=f[D+12>>2];f[q+16>>2]=f[D+16>>2];f[q+20>>2]=f[D+20>>2];f[q+24>>2]=f[D+24>>2];f[q+28>>2]=f[D+28>>2];f[q+32>>2]=f[D+32>>2];I=f[D+36>>2]|0;f[q+36>>2]=I;f[q+40>>2]=G;K=q+48|0;L=q+44|0;f[L>>2]=K;f[K>>2]=0;f[q+52>>2]=0;if(I|0){K=I+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[F>>2]|0)<3){F=f[D+44>>2]|0;K=f[L>>2]|0;f[K>>2]=f[F>>2];f[K+4>>2]=f[F+4>>2];M=H;N=q;O=E;P=G;break}else{f[E>>2]=0;U$(q,D);M=H;N=q;O=E;P=G;break}}else{bS(q,a,-1);M=q+12|0;N=q;O=q+4|0;P=q+8|0}while(0);a=f[P>>2]|0;P=(a|0)==1;G=f[M>>2]|0;M=P?G:a;a=f[N>>2]|0;N=Y((a>>>3&511)+1|0,P?1:G)|0;G=(g|0)>1?g:1;if(!((c|0)>0&((f[O>>2]|0)<3&(a&7|0)==5))){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;a=$Xc(48)|0;f[k>>2]=a;f[k+8>>2]=-2147483600;f[k+4>>2]=42;Q=a;R=228527;S=Q+42|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[a+42>>0]=0;vM(-215,k,228570,228577,240)}if((M|0)<(c|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=6;b[k>>0]=b[228645]|0;b[k+1>>0]=b[228646]|0;b[k+2>>0]=b[228647]|0;b[k+3>>0]=b[228648]|0;b[k+4>>0]=b[228649]|0;b[k+5>>0]=b[228650]|0;b[k+6>>0]=0;vM(-215,k,228570,228577,241)}a=q+16|0;g=q+44|0;E=q+48|0;Tj(r,M,N,5,f[a>>2]|0,P?N<<2:f[E>>2]|0);ZS(d,M,1,4,-1,1,0);f[t>>2]=1124007936;P=t+4|0;H=t+8|0;D=t+40|0;Q=P;S=Q+36|0;do{f[Q>>2]=0;Q=Q+4|0}while((Q|0)<(S|0));f[D>>2]=H;F=t+48|0;K=t+44|0;f[K>>2]=F;f[F>>2]=0;f[t+52>>2]=0;do if((eS(d)|0)==65536){L=f[d+4>>2]|0;f[v>>2]=f[L>>2];I=v+4|0;T=L+4|0;f[I>>2]=f[T>>2];U=v+8|0;f[U>>2]=f[L+8>>2];V=v+12|0;f[V>>2]=f[L+12>>2];f[v+16>>2]=f[L+16>>2];f[v+20>>2]=f[L+20>>2];f[v+24>>2]=f[L+24>>2];f[v+28>>2]=f[L+28>>2];f[v+32>>2]=f[L+32>>2];W=f[L+36>>2]|0;f[v+36>>2]=W;f[v+40>>2]=U;X=v+48|0;Z=v+44|0;f[Z>>2]=X;f[X>>2]=0;f[v+52>>2]=0;if(W|0){X=W+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[T>>2]|0)<3){T=f[L+44>>2]|0;X=f[Z>>2]|0;f[X>>2]=f[T>>2];f[X+4>>2]=f[T+4>>2];_=V;$=U;break}else{f[I>>2]=0;U$(v,L);_=V;$=U;break}}else{bS(v,d,-1);_=v+12|0;$=v+8|0}while(0);U=(h&1|0)!=0;V=f[_>>2]|0;L=f[$>>2]|0;I=((V|0)==1|(L|0)==1)&(Y(L,V)|0)==(M|0);a:do if(U){if(!I){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;aa=$Xc(160)|0;f[k>>2]=aa;ba=k+8|0;f[ba>>2]=-2147483488;ca=k+4|0;f[ca>>2]=152;o1c(aa|0,228652,152)|0;da=aa+152|0;b[da>>0]=0;vM(-215,k,228570,228577,253)}if((f[v>>2]&20479|0)!=16388){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;aa=$Xc(160)|0;f[k>>2]=aa;ba=k+8|0;f[ba>>2]=-2147483488;ca=k+4|0;f[ca>>2]=152;o1c(aa|0,228652,152)|0;da=aa+152|0;b[da>>0]=0;vM(-215,k,228570,228577,253)}g0(k,v,1,M);V=l+8|0;f[V>>2]=0;f[V+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=t;jR(k,l);V=k+36|0;L=f[V>>2]|0;if(L|0?(T=L+12|0,L=f[T>>2]|0,f[T>>2]=L+-1,(L|0)==1):0)V$(k);f[V>>2]=0;V=k+16|0;L=k+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[L>>2]|0)>0){V=f[k+40>>2]|0;T=0;do{f[V+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[L>>2]|0))}L=f[k+44>>2]|0;if((L|0)!=(k+48|0))wL(L);if((M|0)>0){L=f[t+16>>2]|0;T=f[D>>2]|0;V=T+4|0;X=f[K>>2]|0;Z=f[t+12>>2]|0;if(f[t>>2]&16384|0){W=0;while(1){if((f[L+(W<<2)>>2]|0)>>>0>=c>>>0)break;W=W+1|0;if((W|0)>=(M|0))break a}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;ea=$Xc(48)|0;f[k>>2]=ea;fa=k+8|0;f[fa>>2]=-2147483600;ga=k+4|0;f[ga>>2]=42;Q=ea;R=228805;S=Q+42|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));ha=ea+42|0;b[ha>>0]=0;vM(-215,k,228570,228577,257)}W=(f[T>>2]|0)==1;ia=0;while(1){do if(!W){ja=f[X>>2]|0;if((f[V>>2]|0)==1){ka=L+(Y(ja,ia)|0)|0;break}else{la=(ia|0)/(Z|0)|0;ka=L+(Y(la,ja)|0)+(ia-(Y(la,Z)|0)<<2)|0;break}}else ka=L+(ia<<2)|0;while(0);ia=ia+1|0;if((f[ka>>2]|0)>>>0>=c>>>0)break;if((ia|0)>=(M|0))break a}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;ea=$Xc(48)|0;f[k>>2]=ea;fa=k+8|0;f[fa>>2]=-2147483600;ga=k+4|0;f[ga>>2]=42;Q=ea;R=228805;S=Q+42|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));ha=ea+42|0;b[ha>>0]=0;vM(-215,k,228570,228577,257)}}else{if(I?(ia=f[v>>2]|0,(ia&20479|0)==16388):0)ma=ia;else{ZS(d,M,1,4,-1,0,0);do if((eS(d)|0)==65536){ia=f[d+4>>2]|0;f[k>>2]=f[ia>>2];L=k+4|0;Z=ia+4|0;f[L>>2]=f[Z>>2];V=k+8|0;f[V>>2]=f[ia+8>>2];f[k+12>>2]=f[ia+12>>2];f[k+16>>2]=f[ia+16>>2];f[k+20>>2]=f[ia+20>>2];f[k+24>>2]=f[ia+24>>2];f[k+28>>2]=f[ia+28>>2];f[k+32>>2]=f[ia+32>>2];X=f[ia+36>>2]|0;f[k+36>>2]=X;f[k+40>>2]=V;V=k+48|0;W=k+44|0;f[W>>2]=V;f[V>>2]=0;f[k+52>>2]=0;if(X|0){V=X+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[Z>>2]|0)<3){Z=f[ia+44>>2]|0;V=f[W>>2]|0;f[V>>2]=f[Z>>2];f[V+4>>2]=f[Z+4>>2];break}else{f[L>>2]=0;U$(k,ia);break}}else bS(k,d,-1);while(0);ia=v+36|0;L=f[ia>>2]|0;if(L|0?(Z=L+12|0,L=f[Z>>2]|0,f[Z>>2]=L+-1,(L|0)==1):0)V$(v);f[ia>>2]=0;L=v+16|0;Z=v+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[Z>>2]|0)>0){V=f[v+40>>2]|0;W=0;do{f[V+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[Z>>2]|0))}f[v>>2]=f[k>>2];W=k+4|0;V=f[W>>2]|0;f[Z>>2]=V;X=k+8|0;f[$>>2]=f[X>>2];f[_>>2]=f[k+12>>2];T=k+16|0;f[L>>2]=f[T>>2];f[v+20>>2]=f[k+20>>2];f[v+24>>2]=f[k+24>>2];f[v+28>>2]=f[k+28>>2];f[v+32>>2]=f[k+32>>2];la=k+36|0;f[ia>>2]=f[la>>2];ja=v+44|0;na=f[ja>>2]|0;oa=v+48|0;if((na|0)==(oa|0))pa=V;else{wL(na);f[ja>>2]=oa;f[v+40>>2]=$;pa=f[W>>2]|0}na=k+44|0;if((pa|0)<3){V=f[na>>2]|0;f[oa>>2]=f[V>>2];f[v+52>>2]=f[V+4>>2];qa=V}else{f[ja>>2]=f[na>>2];ja=k+40|0;f[v+40>>2]=f[ja>>2];V=k+48|0;f[na>>2]=V;f[ja>>2]=X;qa=V}f[k>>2]=1124007936;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;f[W+16>>2]=0;f[W+20>>2]=0;f[W+24>>2]=0;f[W+28>>2]=0;f[la>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((qa|0)!=(k+48|0))wL(qa);ma=f[v>>2]|0}T=f[v+40>>2]|0;la=f[T+4>>2]|0;W=f[T>>2]|0;T=ma&4095;if(((((f[P>>2]|0)<3?(f[H>>2]|0)==(W|0):0)?(f[t+12>>2]|0)==(la|0):0)?(f[t>>2]&4095|0)==(T|0):0)?f[t+16>>2]|0:0)break;f[k>>2]=W;f[k+4>>2]=la;S$(t,2,k,T)}while(0);H=t+16|0;ma=f[H>>2]|0;f[w>>2]=1124007936;qa=w+4|0;pa=w+8|0;$=w+40|0;Q=qa;S=Q+36|0;do{f[Q>>2]=0;Q=Q+4|0}while((Q|0)<(S|0));f[$>>2]=pa;pa=w+48|0;_=w+44|0;f[_>>2]=pa;f[pa>>2]=0;f[w+52>>2]=0;f[k>>2]=c;d=k+4|0;f[d>>2]=N;S$(w,2,k,5);f[x>>2]=1124007936;I=x+4|0;ha=x+8|0;ea=x+40|0;Q=I;S=Q+36|0;do{f[Q>>2]=0;Q=Q+4|0}while((Q|0)<(S|0));f[ea>>2]=ha;ha=x+48|0;ga=x+44|0;f[ga>>2]=ha;f[ha>>2]=0;f[x+52>>2]=0;f[k>>2]=c;f[d>>2]=N;S$(x,2,k,5);f[y>>2]=1124007936;fa=y+4|0;ka=y+8|0;da=y+40|0;Q=fa;S=Q+36|0;do{f[Q>>2]=0;Q=Q+4|0}while((Q|0)<(S|0));f[da>>2]=ka;ka=y+48|0;aa=y+44|0;f[aa>>2]=ka;f[ka>>2]=0;f[y+52>>2]=0;f[k>>2]=1;f[d>>2]=N;S$(y,2,k,5);d=z+8|0;f[z>>2]=d;ca=z+4|0;ba=c>>>0>64;f[ca>>2]=c;if(ba){T=bYc(c>>>0>1073741823?-1:c<<2)|0;f[z>>2]=T}T=A+8|0;f[A>>2]=T;la=A+4|0;f[la>>2]=M;if(M>>>0>64){W=bYc(M>>>0>536870911?-1:M<<3)|0;f[A>>2]=W}W=OR()|0;V=f[e>>2]|0;X=e+8|0;if(!(V&2))ra=1.1920928955078125e-07;else{sa=+p[X>>3];ra=sa<0.0?0.0:sa}p[X>>3]=ra*ra;ja=e+4|0;if(!(V&1))ta=100;else{V=f[ja>>2]|0;e=(V|0)>2?V:2;ta=(e|0)<100?e:100}e=(c|0)==1;V=e?1:G;f[ja>>2]=e?2:ta;ta=B+8|0;g1c(ta|0,0,512)|0;f[B>>2]=ta;e=B+4|0;f[e>>2]=N;if(N>>>0>64){G=bYc(N>>>0>536870911?-1:N<<3)|0;g1c(G|0,0,N<<3|0)|0;f[B>>2]=G;ua=G}else ua=ta;G=(h&2|0)!=0;if(!G){h=r+16|0;na=f[h>>2]|0;oa=r+44|0;va=(N|0)>0;if(va?(wa=f[na>>2]|0,f[ua>>2]=wa,f[ua+4>>2]=wa,(N|0)!=1):0){wa=1;do{ua=f[B>>2]|0;xa=f[na+(wa<<2)>>2]|0;f[ua+(wa<<3)>>2]=xa;f[ua+(wa<<3)+4>>2]=xa;wa=wa+1|0}while((wa|0)!=(N|0))}if((M|0)>1?(wa=f[h>>2]|0,h=f[f[oa>>2]>>2]|0,oa=f[B>>2]|0,va):0){va=1;do{na=wa+(Y(h,va)|0)|0;xa=0;do{ua=f[na+(xa<<2)>>2]|0;f[k>>2]=ua;ya=oa+(xa<<3)|0;ra=(f[s>>2]=ua,+n[s>>2]);f[ya>>2]=f[(ra<+n[ya>>2]?k:ya)>>2];ya=oa+(xa<<3)+4|0;f[ya>>2]=f[(+n[ya>>2]<ra?k:ya)>>2];xa=xa+1|0}while((xa|0)!=(N|0));va=va+1|0}while((va|0)!=(M|0))}}b:do if((V|0)>0){va=r+12|0;oa=r+8|0;h=k+8|0;wa=k+4|0;xa=c>>>0>1073741823?-1:c<<2;na=l+8|0;ia=l+4|0;L=r+16|0;Z=r+44|0;ya=(c|0)>1;ua=m+4|0;za=o+4|0;Aa=o+8|0;Ba=o+12|0;Ca=o+16|0;Da=w+16|0;ra=1.0/+(N|0);Ea=(N|0)>0;sa=ra*2.0+1.0;Fa=k+4|0;Ga=l+4|0;Ha=l+8|0;Ia=l+12|0;Ja=l+16|0;Ka=(Y(Y(M,c)|0,N)|0)+-1|0;La=(M|0)>0;Ma=y+16|0;Na=x+16|0;Oa=k+4|0;Pa=l+4|0;Qa=l+8|0;Ra=l+12|0;Sa=l+16|0;Ta=(Y(N,M)|0)+-1|0;Ua=m+4|0;Va=m+8|0;Wa=m+12|0;Xa=m+16|0;Ya=m+20|0;Za=m+24|0;_a=m+40|0;$a=m+48|0;ab=m+44|0;bb=m+52|0;cb=(M|0)!=0;db=m+28|0;eb=M<<3;fb=0-eb|0;gb=l+8|0;hb=l+12|0;ib=l+4|0;jb=m+36|0;kb=k+36|0;lb=k+16|0;mb=k+4|0;nb=k+40|0;ob=k+44|0;pb=k+48|0;qb=k+8|0;rb=k+4|0;sb=c<<2;tb=1797693134862315708145274.0e284;ub=0;c:while(1){vb=U&(ub|0)<1;wb=0;while(1){xb=(wb|0)==0;yb=xb?1797693134862315708145274.0e284:0.0;tV(w,x);d:do if(vb|xb^1){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;lR(w,k)|0;g1c(f[z>>2]|0,0,sb|0)|0;e:do if(La){zb=f[L>>2]|0;Ab=f[Z>>2]|0;Bb=f[Da>>2]|0;Cb=f[_>>2]|0;Db=f[z>>2]|0;if(Ea)Eb=0;else{Fb=0;while(1){Gb=Db+(f[ma+(Fb<<2)>>2]<<2)|0;f[Gb>>2]=(f[Gb>>2]|0)+1;Fb=Fb+1|0;if((Fb|0)==(M|0))break e}}do{Fb=zb+(Y(f[Ab>>2]|0,Eb)|0)|0;Gb=f[ma+(Eb<<2)>>2]|0;Hb=Bb+(Y(f[Cb>>2]|0,Gb)|0)|0;Ib=0;do{Jb=Hb+(Ib<<2)|0;n[Jb>>2]=+n[Fb+(Ib<<2)>>2]+ +n[Jb>>2];Ib=Ib+1|0}while((Ib|0)!=(N|0));Ib=Db+(Gb<<2)|0;f[Ib>>2]=(f[Ib>>2]|0)+1;Eb=Eb+1|0}while((Eb|0)!=(M|0))}while(0);Db=0;Cb=f[z>>2]|0;while(1){do if(!(f[Cb+(Db<<2)>>2]|0)){if(ya){Bb=1;Ab=0;while(1){zb=(f[Cb+(Ab<<2)>>2]|0)<(f[Cb+(Bb<<2)>>2]|0)?Bb:Ab;Bb=Bb+1|0;if((Bb|0)==(c|0)){Kb=zb;break}else Ab=zb}}else Kb=0;Ab=f[Da>>2]|0;Bb=f[_>>2]|0;Gb=Ab+(Y(f[Bb>>2]|0,Kb)|0)|0;zb=f[Ma>>2]|0;Ib=f[Cb+(Kb<<2)>>2]|0;Lb=1.0/+(Ib|0);if(Ea){Fb=0;do{n[zb+(Fb<<2)>>2]=Lb*+n[Gb+(Fb<<2)>>2];Fb=Fb+1|0}while((Fb|0)!=(N|0))}if(La){Fb=0;Hb=-1;Lb=0.0;while(1){if((f[ma+(Fb<<2)>>2]|0)==(Kb|0)){Mb=+WN((f[L>>2]|0)+(Y(f[f[Z>>2]>>2]|0,Fb)|0)|0,zb,N);Jb=!(Lb<=Mb);Nb=Jb?Hb:Fb;Ob=Jb?Lb:Mb}else{Nb=Hb;Ob=Lb}Fb=Fb+1|0;if((Fb|0)>=(M|0))break;else{Hb=Nb;Lb=Ob}}Hb=f[z>>2]|0;Pb=Nb;Qb=Hb;Rb=f[Hb+(Kb<<2)>>2]|0;Sb=f[_>>2]|0;Tb=f[Da>>2]|0}else{Pb=-1;Qb=Cb;Rb=Ib;Sb=Bb;Tb=Ab}f[Qb+(Kb<<2)>>2]=Rb+-1;Hb=Qb+(Db<<2)|0;f[Hb>>2]=(f[Hb>>2]|0)+1;f[ma+(Pb<<2)>>2]=Db;Hb=(f[L>>2]|0)+(Y(f[f[Z>>2]>>2]|0,Pb)|0)|0;Fb=Tb+(Y(f[Sb>>2]|0,Db)|0)|0;if(Ea)Ub=0;else{Vb=Qb;break}do{zb=Hb+(Ub<<2)|0;Jb=Gb+(Ub<<2)|0;n[Jb>>2]=+n[Jb>>2]-+n[zb>>2];Jb=Fb+(Ub<<2)|0;n[Jb>>2]=+n[zb>>2]+ +n[Jb>>2];Ub=Ub+1|0}while((Ub|0)!=(N|0));Vb=Qb}else Vb=Cb;while(0);Db=Db+1|0;if((Db|0)>=(c|0))break;else Cb=Vb}Cb=f[Da>>2]|0;Db=f[f[_>>2]>>2]|0;Fb=f[z>>2]|0;Gb=(wb|0)>0;Hb=f[Na>>2]|0;Ab=f[ga>>2]|0;if(Ea){Wb=0;Xb=yb}else{Bb=0;Lb=yb;while(1){if(!(f[Fb+(Bb<<2)>>2]|0)){Yb=245;break c}Mb=Gb&Lb<0.0?0.0:Lb;Bb=Bb+1|0;if((Bb|0)>=(c|0)){Zb=Mb;break d}else Lb=Mb}}while(1){Bb=Cb+(Y(Db,Wb)|0)|0;Ib=f[Fb+(Wb<<2)>>2]|0;if(!Ib){Yb=245;break c}Lb=1.0/+(Ib|0);Ib=0;do{Jb=Bb+(Ib<<2)|0;n[Jb>>2]=Lb*+n[Jb>>2];Ib=Ib+1|0}while((Ib|0)!=(N|0));if(Gb){Ib=Hb+(Y(f[Ab>>2]|0,Wb)|0)|0;Jb=0;Lb=0.0;do{Mb=+n[Bb+(Jb<<2)>>2]-+n[Ib+(Jb<<2)>>2];Lb=Lb+Mb*Mb;Jb=Jb+1|0}while((Jb|0)!=(N|0));_b=Xb<Lb?Lb:Xb}else _b=Xb;Wb=Wb+1|0;if((Wb|0)>=(c|0)){Zb=_b;break}else Xb=_b}}else{if(!G){Ab=f[B>>2]|0;Hb=f[Da>>2]|0;Gb=f[f[_>>2]>>2]|0;if(!Ea){Zb=yb;break}Fb=W;Db=0;Cb=f[Fb>>2]|0;Jb=f[Fb+4>>2]|0;while(1){Fb=Hb+(Y(Gb,Db)|0)|0;Ib=0;$b=Cb;ac=Jb;do{Bb=x1c($b|0,0,-130063606,0)|0;$b=d1c(Bb|0,J|0,ac|0,0)|0;ac=J;Mb=+n[Ab+(Ib<<3)>>2];n[Fb+(Ib<<2)>>2]=Mb+(+n[Ab+(Ib<<3)+4>>2]-Mb)*(sa*(+($b>>>0)*2.3283064365386963e-10)-ra);Ib=Ib+1|0}while((Ib|0)!=(N|0));Db=Db+1|0;if((Db|0)==(c|0))break;else{Cb=$b;Jb=ac}}Jb=W;f[Jb>>2]=$b;f[Jb+4>>2]=ac;Zb=yb;break}Jb=f[va>>2]|0;Cb=f[oa>>2]|0;f[k>>2]=h;f[wa>>2]=c;if(ba){Db=bYc(xa)|0;f[k>>2]=Db;bc=Db}else bc=h;Db=Cb*3|0;f[l>>2]=na;f[ia>>2]=0;if(!Cb){f[ia>>2]=0;cc=na}else{f[ia>>2]=Db;Ab=bYc(Db>>>0>1073741823?-1:Db<<2)|0;f[l>>2]=Ab;cc=Ab}Ab=cc;Db=cc+(Cb<<2)|0;Gb=Db;Hb=Db+(Cb<<2)|0;Db=W;Ib=f[Db+4>>2]|0;Fb=x1c(f[Db>>2]|0,0,-130063606,0)|0;Db=d1c(Fb|0,J|0,Ib|0,0)|0;Ib=W;f[Ib>>2]=Db;f[Ib+4>>2]=J;Ib=(Db>>>0)%(Cb>>>0)|0;f[bc>>2]=Ib;Db=(Cb|0)>0;f:do if(Db){Fb=0;Lb=0.0;Bb=Ib;while(1){zb=f[L>>2]|0;dc=f[f[Z>>2]>>2]|0;Mb=+WN(zb+(Y(dc,Fb)|0)|0,zb+(Y(dc,Bb)|0)|0,Jb);n[cc+(Fb<<2)>>2]=Mb;ec=Lb+Mb;dc=Fb+1|0;if((dc|0)>=(Cb|0)){fc=ec;break f}Fb=dc;Lb=ec;Bb=f[bc>>2]|0}}else fc=0.0;while(0);if(ya){Ib=Cb+-1|0;Bb=(Cb|0)>1;Fb=(Y(Cb,Jb)|0)+-1|0;dc=1;Lb=fc;zb=Hb;gc=Ab;hc=Gb;while(1){ic=gc;do if(Bb){jc=0;kc=-1;ec=1797693134862315708145274.0e284;lc=zb;mc=hc;while(1){nc=W;oc=f[nc+4>>2]|0;pc=x1c(f[nc>>2]|0,0,-130063606,0)|0;nc=d1c(pc|0,J|0,oc|0,0)|0;oc=J;pc=x1c(nc|0,0,-130063606,0)|0;qc=d1c(pc|0,J|0,oc|0,0)|0;oc=W;f[oc>>2]=qc;f[oc+4>>2]=J;oc=0;Mb=Lb*((+(qc>>>0)+4294967296.0*+(nc>>>0))*5.421010862427522e-20);while(1){Mb=Mb-+n[ic+(oc<<2)>>2];if(Mb<=0.0){rc=oc;break}nc=oc+1|0;if((nc|0)>=(Ib|0)){rc=nc;break}else oc=nc}f[m>>2]=0;f[ua>>2]=Cb;oc=lc;f[o>>2]=36452;f[za>>2]=oc;f[Aa>>2]=r;f[Ba>>2]=ic;f[Ca>>2]=rc;nc=f[135569]|0;h3(m,o,+((((nc+Fb|0)>>>0)/(nc>>>0)|0)>>>0));nc=0;Mb=0.0;do{Mb=Mb+ +n[oc+(nc<<2)>>2];nc=nc+1|0}while((nc|0)!=(Cb|0));if(Mb<ec){sc=rc;tc=Mb;uc=mc;vc=lc}else{sc=kc;tc=ec;uc=lc;vc=mc}jc=jc+1|0;if((jc|0)>=3){wc=sc;xc=tc;yc=uc;zc=vc;break}else{kc=sc;ec=tc;lc=uc;mc=vc}}}else{mc=W;lc=f[mc+4>>2]|0;kc=x1c(f[mc>>2]|0,0,-130063606,0)|0;mc=d1c(kc|0,J|0,lc|0,0)|0;lc=J;kc=x1c(mc|0,0,-130063606,0)|0;mc=d1c(kc|0,J|0,lc|0,0)|0;lc=W;f[lc>>2]=mc;f[lc+4>>2]=J;f[m>>2]=0;f[ua>>2]=Cb;lc=zb;f[o>>2]=36452;f[za>>2]=lc;f[Aa>>2]=r;f[Ba>>2]=ic;f[Ca>>2]=0;mc=f[135569]|0;h3(m,o,+((((mc+Fb|0)>>>0)/(mc>>>0)|0)>>>0));if(Db){mc=0;ec=0.0;do{ec=ec+ +n[lc+(mc<<2)>>2];mc=mc+1|0}while((mc|0)!=(Cb|0));if(ec<1797693134862315708145274.0e284){Ac=ec;Yb=197}else{Bc=-1;Cc=1797693134862315708145274.0e284;Dc=zb;Ec=hc}}else{Ac=0.0;Yb=197}if((Yb|0)==197){Yb=0;Bc=0;Cc=Ac;Dc=hc;Ec=zb}mc=W;lc=f[mc+4>>2]|0;kc=x1c(f[mc>>2]|0,0,-130063606,0)|0;mc=d1c(kc|0,J|0,lc|0,0)|0;lc=J;kc=x1c(mc|0,0,-130063606,0)|0;mc=d1c(kc|0,J|0,lc|0,0)|0;lc=W;f[lc>>2]=mc;f[lc+4>>2]=J;f[m>>2]=0;f[ua>>2]=Cb;lc=Dc;f[o>>2]=36452;f[za>>2]=lc;f[Aa>>2]=r;f[Ba>>2]=ic;f[Ca>>2]=0;mc=f[135569]|0;h3(m,o,+((((mc+Fb|0)>>>0)/(mc>>>0)|0)>>>0));if(Db){mc=0;Fc=0.0;while(1){Gc=Fc+ +n[lc+(mc<<2)>>2];mc=mc+1|0;if((mc|0)==(Cb|0)){Hc=Gc;break}else Fc=Gc}}else Hc=0.0;if(Hc<Cc){Ic=0;Jc=Hc;Kc=Ec;Lc=Dc}else{Ic=Bc;Jc=Cc;Kc=Dc;Lc=Ec}mc=W;lc=f[mc+4>>2]|0;kc=x1c(f[mc>>2]|0,0,-130063606,0)|0;mc=d1c(kc|0,J|0,lc|0,0)|0;lc=J;kc=x1c(mc|0,0,-130063606,0)|0;mc=d1c(kc|0,J|0,lc|0,0)|0;lc=W;f[lc>>2]=mc;f[lc+4>>2]=J;f[m>>2]=0;f[ua>>2]=Cb;lc=Kc;f[o>>2]=36452;f[za>>2]=lc;f[Aa>>2]=r;f[Ba>>2]=ic;f[Ca>>2]=0;mc=f[135569]|0;h3(m,o,+((((mc+Fb|0)>>>0)/(mc>>>0)|0)>>>0));if(Db){mc=0;Fc=0.0;while(1){ec=Fc+ +n[lc+(mc<<2)>>2];mc=mc+1|0;if((mc|0)==(Cb|0)){Mc=ec;break}else Fc=ec}}else Mc=0.0;if(!(Mc<Jc)){wc=Ic;xc=Jc;yc=Kc;zc=Lc;break}wc=0;xc=Mc;yc=Lc;zc=Kc}while(0);f[bc+(dc<<2)>>2]=wc;dc=dc+1|0;if((dc|0)>=(c|0))break;else{ic=gc;Lb=xc;zb=yc;gc=zc;hc=ic}}}hc=f[L>>2]|0;gc=f[f[Z>>2]>>2]|0;zb=f[Da>>2]|0;dc=f[f[_>>2]>>2]|0;if((Jb|0)>0){Cb=0;do{Db=hc+(Y(f[bc+(Cb<<2)>>2]|0,gc)|0)|0;Fb=zb+(Y(Cb,dc)|0)|0;Ib=0;do{f[Fb+(Ib<<2)>>2]=f[Db+(Ib<<2)>>2];Ib=Ib+1|0}while((Ib|0)!=(Jb|0));Cb=Cb+1|0}while((Cb|0)!=(c|0))}Cb=f[l>>2]|0;if((Cb|0)!=(na|0)){if(Cb|0)dYc(Cb);f[l>>2]=na;f[ia>>2]=0}Cb=f[k>>2]|0;if((Cb|0)!=(h|0)){if(Cb|0)dYc(Cb);f[k>>2]=h;f[wa>>2]=64}Zb=yb}while(0);xb=wb+1|0;Cb=f[ja>>2]|0;if((xb|0)==(((Cb|0)>2?Cb:2)|0))break;if(Zb<=+p[X>>3])break;f[k>>2]=0;f[Fa>>2]=M;Cb=f[A>>2]|0;f[l>>2]=36492;f[Ga>>2]=Cb;f[Ha>>2]=ma;f[Ia>>2]=r;f[Ja>>2]=w;Cb=f[135569]|0;h3(k,l,+((((Ka+Cb|0)>>>0)/(Cb>>>0)|0)>>>0));wb=xb}f[k>>2]=0;f[Oa>>2]=M;wb=f[A>>2]|0;f[l>>2]=36472;f[Pa>>2]=wb;f[Qa>>2]=ma;f[Ra>>2]=r;f[Sa>>2]=w;wb=f[135569]|0;h3(k,l,+((((Ta+wb|0)>>>0)/(wb>>>0)|0)>>>0));wb=f[A>>2]|0;f[m>>2]=1124007942;f[Ua>>2]=2;f[Va>>2]=1;f[Wa>>2]=M;f[Xa>>2]=wb;f[Ya>>2]=wb;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;f[_a>>2]=Va;f[ab>>2]=$a;f[bb>>2]=0;f[$a>>2]=0;if(cb&(wb|0)==0){Yb=251;break}f[$a>>2]=eb;f[bb>>2]=8;vb=wb+eb|0;f[db>>2]=vb;f[Za>>2]=vb+fb+eb;R$(m);f[gb>>2]=0;f[hb>>2]=0;f[l>>2]=16842752;f[ib>>2]=m;iV(C,l);yb=+p[C>>3];vb=f[jb>>2]|0;if(vb|0?(wb=vb+12|0,vb=f[wb>>2]|0,f[wb>>2]=vb+-1,(vb|0)==1):0)V$(m);f[jb>>2]=0;f[Xa>>2]=0;f[Xa+4>>2]=0;f[Xa+8>>2]=0;f[Xa+12>>2]=0;if((f[Ua>>2]|0)>0){vb=f[_a>>2]|0;wb=0;do{f[vb+(wb<<2)>>2]=0;wb=wb+1|0}while((wb|0)<(f[Ua>>2]|0))}wb=f[ab>>2]|0;if((wb|0)!=($a|0))wL(wb);if(yb<tb){g:do if(aT(i)|0){do if(YS(i)|0){if((rS(i,-1)|0)!=(N|0))break;g0(k,w,N,0);jR(k,i);wb=f[kb>>2]|0;do if(wb|0){vb=wb+12|0;xb=f[vb>>2]|0;f[vb>>2]=xb+-1;if((xb|0)!=1)break;V$(k)}while(0);f[kb>>2]=0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[mb>>2]|0)>0){wb=f[nb>>2]|0;xb=0;do{f[wb+(xb<<2)>>2]=0;xb=xb+1|0}while((xb|0)<(f[mb>>2]|0))}xb=f[ob>>2]|0;if((xb|0)!=(pb|0))wL(xb);break g}while(0);jR(w,i)}while(0);xb=qb;f[xb>>2]=0;f[xb+4>>2]=0;f[k>>2]=33619968;f[rb>>2]=v;jR(t,k);Nc=yb}else Nc=tb;ub=ub+1|0;if((ub|0)>=(V|0)){Oc=Nc;break b}else tb=Nc}if((Yb|0)==245){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;ub=$Xc(32)|0;f[k>>2]=ub;f[k+8>>2]=-2147483616;f[k+4>>2]=16;Q=ub;R=228848;S=Q+16|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[ub+16>>0]=0;vM(-215,k,228570,228577,408)}else if((Yb|0)==251){rb=$Xc(32)|0;f[k>>2]=rb;f[k+8>>2]=-2147483616;f[k+4>>2]=28;Q=rb;R=470314;S=Q+28|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[rb+28>>0]=0;vM(-215,k,470343,470347,577)}}else Oc=1797693134862315708145274.0e284;while(0);k=f[B>>2]|0;if((k|0)!=(ta|0)){if(k|0)dYc(k);f[B>>2]=ta;f[e>>2]=64}e=f[A>>2]|0;if((e|0)!=(T|0)){if(e|0)dYc(e);f[A>>2]=T;f[la>>2]=64}la=f[z>>2]|0;if((la|0)!=(d|0)){if(la|0)dYc(la);f[z>>2]=d;f[ca>>2]=64}ca=y+36|0;d=f[ca>>2]|0;if(d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)V$(y);f[ca>>2]=0;ca=y+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[fa>>2]|0)>0){ca=f[da>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[fa>>2]|0))}fa=f[aa>>2]|0;if((fa|0)!=(ka|0))wL(fa);fa=x+36|0;ka=f[fa>>2]|0;do if(ka|0){aa=ka+12|0;da=f[aa>>2]|0;f[aa>>2]=da+-1;if((da|0)!=1)break;V$(x)}while(0);f[fa>>2]=0;fa=x+16|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[I>>2]|0)>0){fa=f[ea>>2]|0;ea=0;do{f[fa+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[I>>2]|0))}I=f[ga>>2]|0;if((I|0)!=(ha|0))wL(I);I=w+36|0;ha=f[I>>2]|0;do if(ha|0){ga=ha+12|0;ea=f[ga>>2]|0;f[ga>>2]=ea+-1;if((ea|0)!=1)break;V$(w)}while(0);f[I>>2]=0;I=w+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[qa>>2]|0)>0){I=f[$>>2]|0;$=0;do{f[I+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[qa>>2]|0))}qa=f[_>>2]|0;if((qa|0)!=(pa|0))wL(qa);qa=v+36|0;pa=f[qa>>2]|0;do if(pa|0){_=pa+12|0;$=f[_>>2]|0;f[_>>2]=$+-1;if(($|0)!=1)break;V$(v)}while(0);f[qa>>2]=0;qa=v+16|0;pa=v+4|0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[pa>>2]|0)>0){qa=f[v+40>>2]|0;$=0;do{f[qa+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[pa>>2]|0))}pa=f[v+44>>2]|0;if((pa|0)!=(v+48|0))wL(pa);pa=t+36|0;v=f[pa>>2]|0;do if(v|0){$=v+12|0;qa=f[$>>2]|0;f[$>>2]=qa+-1;if((qa|0)!=1)break;V$(t)}while(0);f[pa>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[P>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[P>>2]|0))}P=f[K>>2]|0;if((P|0)!=(F|0))wL(P);P=r+36|0;F=f[P>>2]|0;do if(F|0){K=F+12|0;D=f[K>>2]|0;f[K>>2]=D+-1;if((D|0)!=1)break;V$(r)}while(0);f[P>>2]=0;P=r+16|0;F=r+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[F>>2]|0)>0){P=f[r+40>>2]|0;D=0;do{f[P+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[F>>2]|0))}F=f[r+44>>2]|0;if((F|0)!=(r+48|0))wL(F);F=q+36|0;r=f[F>>2]|0;do if(r|0){D=r+12|0;P=f[D>>2]|0;f[D>>2]=P+-1;if((P|0)!=1)break;V$(q)}while(0);f[F>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[O>>2]|0)>0){a=f[q+40>>2]|0;q=0;do{f[a+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[O>>2]|0))}O=f[g>>2]|0;if((O|0)==(E|0)){u=j;return +Oc}wL(O);u=j;return +Oc}function iQ(a){a=a|0;cYc(a);return}function jQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=a+16|0;e=f[b>>2]|0;g=f[e+8>>2]|0;h=f[e+12>>2]|0;if((c|0)>=(d|0))return;e=a+12|0;i=a+4|0;j=a+8|0;if((g|0)>0)k=c;else{a=f[i>>2]|0;l=f[j>>2]|0;m=c;do{p[a+(m<<3)>>3]=1797693134862315708145274.0e284;f[l+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(d|0));return}do{m=f[e>>2]|0;l=(f[m+16>>2]|0)+(Y(f[f[m+44>>2]>>2]|0,k)|0)|0;m=0;n=1797693134862315708145274.0e284;a=0;do{c=f[b>>2]|0;o=+WN(l,(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,m)|0)|0,h);c=n>o;a=c?m:a;n=c?o:n;m=m+1|0}while((m|0)!=(g|0));p[(f[i>>2]|0)+(k<<3)>>3]=n;f[(f[j>>2]|0)+(k<<2)>>2]=a;k=k+1|0}while((k|0)!=(d|0));return}function kQ(a){a=a|0;cYc(a);return}function lQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=a+16|0;e=f[b>>2]|0;g=f[e+12>>2]|0;if((c|0)>=(d|0))return;h=a+12|0;i=a+8|0;j=a+4|0;a=c;c=e;while(1){e=f[h>>2]|0;k=(f[e+16>>2]|0)+(Y(f[f[e+44>>2]>>2]|0,a)|0)|0;l=+WN(k,(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,f[(f[i>>2]|0)+(a<<2)>>2]|0)|0)|0,g);p[(f[j>>2]|0)+(a<<3)>>3]=l;k=a+1|0;if((k|0)==(d|0))break;a=k;c=f[b>>2]|0}return}function mQ(a){a=a|0;cYc(a);return}function nQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0;c=u;u=u+16|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;b=a+8|0;h=f[b>>2]|0;i=f[h+12>>2]|0;if((e|0)>=(g|0)){u=c;return}j=a+16|0;k=a+12|0;l=a+4|0;a=e;e=h;while(1){h=f[e+16>>2]|0;m=f[f[e+44>>2]>>2]|0;o=h+(Y(m,a)|0)|0;p=+WN(o,h+(Y(f[j>>2]|0,m)|0)|0,i);n[d>>2]=p;m=(f[k>>2]|0)+(a<<2)|0;f[(f[l>>2]|0)+(a<<2)>>2]=f[(+n[m>>2]<p?m:d)>>2];m=a+1|0;if((m|0)==(g|0))break;a=m;e=f[b>>2]|0}u=c;return}function oQ(){var a=0;a=0;do{WXc(542280+(a*28|0)|0);a=a+1|0}while((a*28|0)!=868);be(2222,0,x|0)|0;return}function pQ(a){a=a|0;XXc(543120);XXc(543092);XXc(543064);XXc(543036);XXc(543008);XXc(542980);XXc(542952);XXc(542924);XXc(542896);XXc(542868);XXc(542840);XXc(542812);XXc(542784);XXc(542756);XXc(542728);XXc(542700);XXc(542672);XXc(542644);XXc(542616);XXc(542588);XXc(542560);XXc(542532);XXc(542504);XXc(542476);XXc(542448);XXc(542420);XXc(542392);XXc(542364);XXc(542336);XXc(542308);XXc(542280);return}function qQ(a,b){a=a|0;b=b|0;f[a+4>>2]=b;f[a>>2]=b;b=a+8|0;a=b+44|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function rQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if(f[a+44>>2]|0){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=13;g=e;h=228969;i=g+13|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+13>>0]=0;vM(-215,d,228983,228993,78)}d=a+16|0;e=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;d=f[e>>2]|0;if(!d){u=c;return}a=d+12|0;h=f[a>>2]|0;f[a>>2]=h+-1;if((h|0)==1){if(f[d+44>>2]|0){h=f[d+4>>2]|0;if(!h)j=L$()|0;else j=h;mi[f[(f[j>>2]|0)+24>>2]&2047](j,d)}j=d+8|0;h=f[j>>2]|0;f[j>>2]=h+-1;if((h|0)==1){h=f[d+4>>2]|0;mi[f[(f[h>>2]|0)+16>>2]&2047](h,d)}}else{h=d+8|0;f[h>>2]=(f[h>>2]|0)+-1}f[e>>2]=0;u=c;return}function sQ(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;if(!(f[135787]|0)){d=cN()|0;YXc(d);if(!(f[135787]|0)){e=$Xc(8)|0;BN(e);f[e>>2]=36512;f[135787]=e}ZXc(d)}d=hN(f[135787]|0)|0;if(!d){e=c+4|0;f[e>>2]=0;f[e+4>>2]=0;b[c+11>>0]=3;b[c>>0]=b[229084]|0;b[c+1>>0]=b[229085]|0;b[c+2>>0]=b[229086]|0;b[c+3>>0]=0;vM(-215,c,229088,229095,730)}else{u=a;return d|0}return 0}function tQ(a){a=a|0;f[a>>2]=36512;uN(a);tM(a);return}function uQ(a){a=a|0;f[a>>2]=36512;uN(a);tM(a);cYc(a);return}function vQ(a){a=a|0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function wQ(a,b){a=a|0;b=b|0;if(!b)return;cYc(b);return}function xQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=(c|0)==0;i=(d|0)==0;if(h&i){u=e;return}if((f[a>>2]|0)!=1){j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=16;k=j;l=229221;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+16>>0]=0;vM(-215,g,511661,228993,195)}f[a>>2]=0;if(!h)ZXc(542280+(((c>>>0)%31|0)*28|0)|0);if(!i)ZXc(542280+(((d>>>0)%31|0)*28|0)|0);f[a+4>>2]=0;f[a+8>>2]=0;u=e;return}function yQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){j=$Xc(48)|0;f[i>>2]=j;f[i+8>>2]=-2147483600;f[i+4>>2]=33;k=j;l=237423;m=k+33|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+33>>0]=0;vM(-215,i,237457,228993,270)}j=a+4|0;if((f[j>>2]|0)!=(c|0)){n=a+36|0;o=f[n>>2]|0;p=a+40|0;if((o|0)!=(p|0)){wL(o);f[n>>2]=p;f[a+32>>2]=a+8}if((c|0)>2){p=vL(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+32>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[j>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=Y(675553809>>>(n<<2&28)&15,(n>>>3&511)+1|0)|0;n=c+-1|0;if((c|0)<=0){u=h;return}o=f[a+32>>2]|0;q=f[a+36>>2]|0;a:do if(!e){if(g){r=n;s=p}else{t=n;while(1){v=f[d+(t<<2)>>2]|0;if((v|0)<=-1){w=18;break a}f[o+(t<<2)>>2]=v;if((t|0)>0)t=t+-1|0;else break a}}while(1){t=f[d+(r<<2)>>2]|0;if((t|0)<=-1){w=18;break a}f[o+(r<<2)>>2]=t;f[q+(r<<2)>>2]=s;s=x1c(t|0,((t|0)<0)<<31>>31|0,s|0,0)|0;if(!((s|0)==(s|0)&(J|0)==0))break;if((r|0)<=0)break a;else r=r+-1|0}t=$Xc(64)|0;f[i>>2]=t;f[i+8>>2]=-2147483584;f[i+4>>2]=51;k=t;l=237504;m=k+51|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[t+51>>0]=0;vM(-211,i,237457,228993,307)}else{v=n;while(1){x=f[d+(v<<2)>>2]|0;if((x|0)<=-1){w=18;break a}f[o+(v<<2)>>2]=x;if((v|0)<(n|0))y=f[e+(v<<2)>>2]|0;else y=p;f[q+(v<<2)>>2]=y;if((v|0)>0)v=v+-1|0;else break}}while(0);if((w|0)==18){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=6;b[i>>0]=b[237465]|0;b[i+1>>0]=b[237466]|0;b[i+2>>0]=b[237467]|0;b[i+3>>0]=b[237468]|0;b[i+4>>0]=b[237469]|0;b[i+5>>0]=b[237470]|0;b[i+6>>0]=0;vM(-215,i,237457,228993,297)}if((c|0)!=1){u=h;return}f[j>>2]=2;f[a+12>>2]=1;f[(f[a+36>>2]|0)+4>>2]=p;u=h;return}function zQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+192|0;h=g+144|0;i=g+128|0;j=g+120|0;k=g+64|0;l=g;m=g+48|0;f[h>>2]=1124007936;n=h+4|0;o=h+8|0;p=h+20|0;q=h+24|0;r=h+28|0;s=h+32|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[s>>2]=o;t=h+40|0;v=h+36|0;f[v>>2]=t;f[h+44>>2]=0;f[t>>2]=0;w=c+16|0;x=f[w>>2]|0;a:do if(!x){f[a>>2]=1124007936;y=a+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[y+24>>2]=0;f[a+32>>2]=a+8;y=a+40|0;f[a+36>>2]=y;f[y>>2]=0;f[a+44>>2]=0;f[h>>2]=1124007936;f[q>>2]=0;f[r>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0}else{y=c+20|0;do if((x|0)!=(f[y>>2]|0)){f[i>>2]=0;z=i+4|0;f[z>>2]=0;f[j>>2]=0;A=j+4|0;f[A>>2]=0;e0(c,i,j);B=f[c+12>>2]|0;C=f[c+8>>2]|0;if(!(f[A>>2]|f[j>>2])){if((f[w>>2]|0)==(f[y>>2]|0))break;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;D=$Xc(32)|0;f[i>>2]=D;f[i+8>>2]=-2147483616;f[i+4>>2]=17;E=D;F=229238;G=E+17|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[D+17>>0]=0;vM(-215,i,231175,228993,358)}f[k>>2]=f[c>>2];H=k+4|0;I=c+4|0;J=f[I>>2]|0;f[H>>2]=J;K=k+8|0;f[K>>2]=C;L=k+12|0;f[L>>2]=B;M=k+16|0;f[M>>2]=f[w>>2];f[k+20>>2]=f[y>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];N=k+36|0;O=f[c+36>>2]|0;f[N>>2]=O;P=k+40|0;f[P>>2]=K;Q=k+48|0;R=k+44|0;f[R>>2]=Q;f[Q>>2]=0;f[k+52>>2]=0;if(!O)S=J;else{J=O+12|0;f[J>>2]=(f[J>>2]|0)+1;S=f[I>>2]|0}if((S|0)<3){I=f[c+44>>2]|0;J=f[R>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2]}else{f[H>>2]=0;U$(k,c)}I=f[A>>2]|0;J=f[j>>2]|0;f0(k,I,(f[z>>2]|0)-I-(f[K>>2]|0)|0,J,(f[i>>2]|0)-J-(f[L>>2]|0)|0)|0;zQ(l,k,d,e);L=f[A>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=L;f[m+8>>2]=B;f[m+12>>2]=C;AQ(a,l,m);L=l+24|0;J=f[L>>2]|0;if(J|0?(K=J+8|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0){J=f[L>>2]|0;f[L>>2]=0;K=f[J+4>>2]|0;mi[f[(f[K>>2]|0)+16>>2]&2047](K,J)}J=l+4|0;if((f[J>>2]|0)>0){K=f[l+32>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[J>>2]|0))}f[L>>2]=0;J=f[l+36>>2]|0;if((J|0)!=(l+40|0))wL(J);J=f[N>>2]|0;if(J|0?(I=J+12|0,J=f[I>>2]|0,f[I>>2]=J+-1,(J|0)==1):0)V$(k);f[N>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[H>>2]|0)>0){J=f[P>>2]|0;I=0;do{f[J+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[R>>2]|0;if((H|0)!=(Q|0))wL(H);H=f[q>>2]|0;if(!H)break a;I=H+8|0;H=f[I>>2]|0;f[I>>2]=H+-1;if((H|0)!=1)break a;H=f[q>>2]|0;f[q>>2]=0;I=f[H+4>>2]|0;mi[f[(f[I>>2]|0)+16>>2]&2047](I,H);break a}while(0);y=d|50331648;H=f[c+32>>2]|0;I=L$()|0;J=(H|0)==0?I:H;H=c+4|0;I=c+40|0;P=c+44|0;M=Gj[f[(f[J>>2]|0)+8>>2]&15](J,f[H>>2]|0,f[I>>2]|0,f[c>>2]&4095,f[w>>2]|0,f[P>>2]|0,y,e)|0;J=c+36|0;f[M+48>>2]=f[J>>2];N=L$()|0;if(!(hh[f[(f[N>>2]|0)+12>>2]&127](N,M,y,e)|0)?(N=L$()|0,!(hh[f[(f[N>>2]|0)+12>>2]&127](N,M,y,e)|0)):0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=9;E=i;F=229256;G=E+9|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[i+9>>0]=0;vM(-215,i,231175,228993,381)}y=f[J>>2]|0;if(y|0){N=y+12|0;f[N>>2]=(f[N>>2]|0)+1;N=(f[J>>2]|0)+8|0;f[N>>2]=(f[N>>2]|0)+1}f[h>>2]=f[c>>2];yQ(h,f[H>>2]|0,f[I>>2]|0,f[P>>2]|0,0);N=Q$(f[h>>2]|0,f[n>>2]|0,f[s>>2]|0,f[v>>2]|0)|0;f[h>>2]=N;y=f[n>>2]|0;if((y|0)>2){f[h+12>>2]=-1;f[o>>2]=-1}f[q>>2]=M;f[r>>2]=0;if(!M){T=N;U=y;V=M;W=0}else{y=M+8|0;f[y>>2]=(f[y>>2]|0)+1;T=f[h>>2]|0;U=f[n>>2]|0;V=f[q>>2]|0;W=f[r>>2]|0}f[a>>2]=T;f[a+4>>2]=U;y=a+8|0;f[y>>2]=f[o>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=f[h+16>>2];f[a+20>>2]=f[p>>2];f[a+24>>2]=V;f[a+28>>2]=W;N=a+32|0;f[N>>2]=y;y=a+36|0;L=a+40|0;f[y>>2]=L;K=a+44|0;f[K>>2]=0;f[L>>2]=0;C=h+36|0;if((U|0)<3){B=f[C>>2]|0;f[L>>2]=f[B>>2];f[K>>2]=f[B+4>>2]}else{f[y>>2]=f[C>>2];f[N>>2]=f[s>>2];f[C>>2]=t;f[s>>2]=o}f[h>>2]=1124007936;f[q>>2]=0;f[r>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0}while(0);if((f[n>>2]|0)>0){r=f[s>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[n>>2]|0))}f[q>>2]=0;q=f[v>>2]|0;if((q|0)==(t|0)){u=g;return}wL(q);u=g;return}function AQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];n=a+24|0;o=f[c+24>>2]|0;f[n>>2]=o;p=a+28|0;q=d+4|0;r=c+36|0;s=(Y(f[f[r>>2]>>2]|0,f[q>>2]|0)|0)+(f[c+28>>2]|0)|0;f[p>>2]=s;t=a+32|0;f[t>>2]=j;v=a+40|0;w=a+36|0;f[w>>2]=v;f[a+44>>2]=0;f[v>>2]=0;v=o;if((f[c+4>>2]|0)>=3){x=$Xc(16)|0;f[g>>2]=x;f[g+8>>2]=-2147483632;f[g+4>>2]=11;y=x;z=241710;A=y+11|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[x+11>>0]=0;vM(-215,g,229266,228993,540)}x=Y(675553809>>>(h<<2&28)&15,(h>>>3&511)+1|0)|0;h=f[d>>2]|0;d=(Y(x,h)|0)+s|0;f[p>>2]=d;if((((((h|0)>-1?(d=f[m>>2]|0,(d|0)>-1):0)?(p=c+12|0,s=f[p>>2]|0,(d+h|0)<=(s|0)):0)?(h=f[q>>2]|0,(h|0)>-1):0)?(q=f[k>>2]|0,(q|0)>-1):0)?(B=c+8|0,(q+h|0)<=(f[B>>2]|0)):0){if(!o){C=d;D=s}else{s=v+8|0;f[s>>2]=(f[s>>2]|0)+1;C=f[m>>2]|0;D=f[p>>2]|0}if(!((C|0)>=(D|0)?(f[k>>2]|0)>=(f[B>>2]|0):0))f[a>>2]=f[a>>2]|32768;B=f[w>>2]|0;f[B>>2]=f[f[r>>2]>>2];f[B+4>>2]=x;x=Q$(f[a>>2]|0,f[i>>2]|0,f[t>>2]|0,B)|0;f[a>>2]=x;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}x=f[n>>2]|0;if(x|0?(a=x+8|0,x=f[a>>2]|0,f[a>>2]=x+-1,(x|0)==1):0){x=f[n>>2]|0;f[n>>2]=0;a=f[x+4>>2]|0;mi[f[(f[a>>2]|0)+16>>2]&2047](a,x)}if((f[i>>2]|0)>0){x=f[t>>2]|0;t=0;do{f[x+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}f[n>>2]=0;f[l>>2]=0;f[j>>2]=0;u=e;return}e=$Xc(128)|0;f[g>>2]=e;f[g+8>>2]=-2147483520;f[g+4>>2]=124;y=e;z=237943;A=y+124|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[e+124>>0]=0;vM(-215,g,229266,228993,545)}function BQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+144|0;i=h+16|0;j=h;k=a+20|0;f[k>>2]=g;if(!(c>>>0<33&(d|0)!=0)){g=$Xc(48)|0;f[i>>2]=g;f[i+8>>2]=-2147483600;f[i+4>>2]=35;l=g;m=237592;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[g+35>>0]=0;vM(-215,i,467262,228993,408)}g=e&4095;e=a+24|0;o=f[e>>2]|0;p=(o|0)==0;do if(!p){q=f[a+4>>2]|0;if((q|0)!=(c|0)?!((c|0)==1&(q|0)<3):0)break;if((g|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=h;return}else r=11;else if((c|0)>0)r=11;else s=0;a:do if((r|0)==11){q=f[a+32>>2]|0;t=0;while(1){if((f[q+(t<<2)>>2]|0)!=(f[d+(t<<2)>>2]|0)){s=t;break a}v=t+1|0;if((v|0)<(c|0))t=v;else{s=v;break}}}while(0);if((s|0)==(c|0)){if((c|0)>1){u=h;return}if((f[(f[a+32>>2]|0)+4>>2]|0)==1){u=h;return}}}}while(0);s=a+32|0;if((f[s>>2]|0)==(d|0)){if((c|0)>0)o1c(i|0,d|0,c<<2|0)|0;w=i}else w=d;if(!p?(p=o+8|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0){o=f[e>>2]|0;f[e>>2]=0;p=f[o+4>>2]|0;mi[f[(f[p>>2]|0)+16>>2]&2047](p,o)}o=a+4|0;if((f[o>>2]|0)>0){p=f[s>>2]|0;d=0;do{f[p+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[o>>2]|0))}f[e>>2]=0;if(c|0){f[a>>2]=g|1124007936;yQ(a,c,w,0,1);f[a+28>>2]=0;w=f[o>>2]|0;if((w|0)<3)x=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[s>>2]|0;d=0;p=1;while(1){i=Y(f[c+(d<<2)>>2]|0,p)|0;d=d+1|0;if((d|0)==(w|0)){x=i;break}else p=i}}if(x){x=f[a+16>>2]|0;p=L$()|0;if(!x){L$()|0;y=p}else y=x;x=a+36|0;p=Gj[f[(f[y>>2]|0)+8>>2]&15](y,f[o>>2]|0,f[s>>2]|0,g,0,f[x>>2]|0,50331648,f[k>>2]|0)|0;f[e>>2]=p;if(!p){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=6;b[j>>0]=b[237628]|0;b[j+1>>0]=b[237629]|0;b[j+2>>0]=b[237630]|0;b[j+3>>0]=b[237631]|0;b[j+4>>0]=b[237632]|0;b[j+5>>0]=b[237633]|0;b[j+6>>0]=0;vM(-215,j,467262,228993,448)}p=f[o>>2]|0;k=f[x>>2]|0;x=f[a>>2]|0;if((f[k+(p+-1<<2)>>2]|0)==(Y(675553809>>>(x<<2&28)&15,(x>>>3&511)+1|0)|0)){z=x;A=p;B=k}else{k=$Xc(48)|0;f[j>>2]=k;f[j+8>>2]=-2147483600;f[j+4>>2]=43;l=k;m=237635;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+43>>0]=0;vM(-215,j,467262,228993,456)}}else{z=f[a>>2]|0;A=w;B=f[a+36>>2]|0}w=Q$(z,A,f[s>>2]|0,B)|0;f[a>>2]=w;if((f[o>>2]|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}a=f[e>>2]|0;if(a|0){e=a+8|0;f[e>>2]=(f[e>>2]|0)+1}}u=h;return}function CQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[b>>2]|0;BQ(a,(f[b+4>>2]|0)-e>>2,e,c,d);return}function DQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;yQ(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+32>>2]|0;e=f[a+32>>2]|0;g=f[b+36>>2]|0;b=f[a+36>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function EQ(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=f[b>>2]|0;if(c|0?(d=c+8|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0){c=f[b>>2]|0;f[b>>2]=0;d=f[c+4>>2]|0;mi[f[(f[d>>2]|0)+16>>2]&2047](d,c)}c=a+4|0;if((f[c>>2]|0)>0){d=f[a+32>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}f[b>>2]=0;b=f[a+36>>2]|0;if((b|0)==(a+40|0))return;wL(b);return}function FQ(a){a=a|0;var b=0;b=a+24|0;a=f[b>>2]|0;f[b>>2]=0;b=f[a+4>>2]|0;mi[f[(f[b>>2]|0)+16>>2]&2047](b,a);return}function GQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+1152|0;h=g+48|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+32|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[q>>2]=k;r=a+36|0;s=a+40|0;f[r>>2]=s;f[a+44>>2]=0;f[s>>2]=0;t=c+4|0;v=f[t>>2]|0;if((v|0)<=1){w=$Xc(16)|0;f[h>>2]=w;f[h+8>>2]=-2147483632;f[h+4>>2]=11;x=w;y=237679;z=x+11|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[w+11>>0]=0;vM(-215,h,229266,228993,497)}if((v|0)==2){IQ(a,c)|0;w=f[d>>2]|0;A=f[d+4>>2]|0;do if((w|0)!=-2147483648|(A|0)!=2147483647?(w|0?1:(A|0)!=(f[k>>2]|0)):0){if((w|0)<0|(A|0)<(w|0)){B=$Xc(96)|0;f[h>>2]=B;C=h+8|0;f[C>>2]=-2147483552;D=h+4|0;f[D>>2]=83;x=B;y=237691;z=x+83|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));E=B+83|0;b[E>>0]=0;vM(-215,h,229266,228993,512)}if((A|0)>(f[c+8>>2]|0)){B=$Xc(96)|0;f[h>>2]=B;C=h+8|0;f[C>>2]=-2147483552;D=h+4|0;f[D>>2]=83;x=B;y=237691;z=x+83|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));E=B+83|0;b[E>>0]=0;vM(-215,h,229266,228993,512)}else{f[k>>2]=A-w;F=Y(w,f[s>>2]|0)|0;f[p>>2]=(f[p>>2]|0)+F;f[a>>2]=f[a>>2]|32768;break}}while(0);w=f[e>>2]|0;A=f[e+4>>2]|0;if((w|0)!=-2147483648|(A|0)!=2147483647?(w|0?1:(A|0)!=(f[l>>2]|0)):0){if((w|0)<0|(A|0)<(w|0)){G=$Xc(96)|0;f[h>>2]=G;H=h+8|0;f[H>>2]=-2147483552;I=h+4|0;f[I>>2]=83;x=G;y=237775;z=x+83|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));J=G+83|0;b[J>>0]=0;vM(-215,h,229266,228993,520)}if((A|0)>(f[c+12>>2]|0)){G=$Xc(96)|0;f[h>>2]=G;H=h+8|0;f[H>>2]=-2147483552;I=h+4|0;f[I>>2]=83;x=G;y=237775;z=x+83|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));J=G+83|0;b[J>>0]=0;vM(-215,h,229266,228993,520)}f[l>>2]=A-w;A=f[j>>2]|0;if((A|0)>0)K=f[(f[a+36>>2]|0)+(A+-1<<2)>>2]|0;else K=0;A=Y(K,w)|0;f[p>>2]=(f[p>>2]|0)+A;f[a>>2]=f[a>>2]|32768}A=a+32|0;w=Q$(f[a>>2]|0,f[j>>2]|0,f[A>>2]|0,f[a+36>>2]|0)|0;f[a>>2]=w;if((f[k>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=g;return}w=f[o>>2]|0;if(w|0?(K=w+8|0,w=f[K>>2]|0,f[K>>2]=w+-1,(w|0)==1):0){w=f[o>>2]|0;f[o>>2]=0;K=f[w+4>>2]|0;mi[f[(f[K>>2]|0)+16>>2]&2047](K,w)}if((f[j>>2]|0)>0){w=f[A>>2]|0;A=0;do{f[w+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[j>>2]|0))}f[o>>2]=0;f[l>>2]=0;f[k>>2]=0;u=g;return}A=h+8|0;g1c(A|0,0,1088)|0;f[h>>2]=A;w=h+4|0;f[w>>2]=v;if(v>>>0>136){K=bYc(v>>>0>536870911?-1:v<<3)|0;g1c(K|0,0,v<<3|0)|0;f[h>>2]=K;L=K}else L=A;K=d;d=f[K+4>>2]|0;v=L;f[v>>2]=f[K>>2];f[v+4>>2]=d;d=f[h>>2]|0;v=e;e=f[v+4>>2]|0;K=d+8|0;f[K>>2]=f[v>>2];f[K+4>>2]=e;if((f[t>>2]|0)>2){e=2;K=d;while(1){v=K+(e<<3)|0;f[v>>2]=-2147483648;f[v+4>>2]=2147483647;e=e+1|0;v=f[h>>2]|0;if((e|0)>=(f[t>>2]|0)){M=v;break}else K=v}}else M=d;HQ(i,c,M);M=f[o>>2]|0;if((i|0)==(a|0)){c=i+24|0;if((M|0)!=0?(d=M+8|0,K=f[d>>2]|0,f[d>>2]=K+-1,(K|0)==1):0){K=f[c>>2]|0;f[c>>2]=0;d=f[K+4>>2]|0;mi[f[(f[d>>2]|0)+16>>2]&2047](d,K);N=c}else N=c}else{if(M|0?(c=M+8|0,M=f[c>>2]|0,f[c>>2]=M+-1,(M|0)==1):0){M=f[o>>2]|0;f[o>>2]=0;c=f[M+4>>2]|0;mi[f[(f[c>>2]|0)+16>>2]&2047](c,M)}if((f[j>>2]|0)>0){M=f[a+32>>2]|0;c=0;do{f[M+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}f[a>>2]=f[i>>2];c=i+4|0;M=f[c>>2]|0;f[j>>2]=M;j=i+8|0;f[k>>2]=f[j>>2];f[l>>2]=f[i+12>>2];f[m>>2]=f[i+16>>2];f[n>>2]=f[i+20>>2];n=i+24|0;f[o>>2]=f[n>>2];o=i+28|0;f[p>>2]=f[o>>2];p=f[r>>2]|0;if((p|0)==(s|0))O=M;else{wL(p);f[r>>2]=s;f[a+32>>2]=k;O=f[c>>2]|0}k=i+36|0;if((O|0)<3){O=f[k>>2]|0;f[s>>2]=f[O>>2];f[a+44>>2]=f[O+4>>2]}else{f[r>>2]=f[k>>2];r=i+32|0;f[q>>2]=f[r>>2];f[k>>2]=i+40;f[r>>2]=j}f[i>>2]=1124007936;f[n>>2]=0;f[o>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;N=n}n=i+4|0;if((f[n>>2]|0)>0){c=f[i+32>>2]|0;o=0;do{f[c+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}f[N>>2]=0;N=f[i+36>>2]|0;if((N|0)!=(i+40|0))wL(N);N=f[h>>2]|0;if((N|0)!=(A|0)){if(N|0)dYc(N);f[h>>2]=A;f[w>>2]=136}u=g;return}function HQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+28|0;j=a+32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[j>>2]=a+8;k=a+40|0;l=a+36|0;f[l>>2]=k;f[a+44>>2]=0;f[k>>2]=0;k=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=6;b[g>>0]=b[237859]|0;b[g+1>>0]=b[237860]|0;b[g+2>>0]=b[237861]|0;b[g+3>>0]=b[237862]|0;b[g+4>>0]=b[237863]|0;b[g+5>>0]=b[237864]|0;b[g+6>>0]=0;vM(-215,g,229266,228993,567)}m=(k|0)>0;if(!m){IQ(a,c)|0;n=f[a>>2]|0;o=f[h>>2]|0;p=f[j>>2]|0;q=f[l>>2]|0;r=Q$(n,o,p,q)|0;f[a>>2]=r;u=e;return}s=f[c+32>>2]|0;t=0;while(1){v=d+(t<<3)|0;w=f[v>>2]|0;x=f[v+4>>2]|0;if(!((w|0)==-2147483648&(x|0)==2147483647)){if(!((w|0)>-1&(w|0)<(x|0))){y=9;break}if((x|0)>(f[s+(t<<2)>>2]|0)){y=9;break}}t=t+1|0;if((t|0)>=(k|0)){y=11;break}}if((y|0)==9){t=$Xc(80)|0;f[g>>2]=t;f[g+8>>2]=-2147483568;f[g+4>>2]=76;s=t;x=237866;w=s+76|0;do{b[s>>0]=b[x>>0]|0;s=s+1|0;x=x+1|0}while((s|0)<(w|0));b[t+76>>0]=0;vM(-215,g,229266,228993,571)}else if((y|0)==11){IQ(a,c)|0;if(m)z=0;else{n=f[a>>2]|0;o=f[h>>2]|0;p=f[j>>2]|0;q=f[l>>2]|0;r=Q$(n,o,p,q)|0;f[a>>2]=r;u=e;return}do{m=d+(z<<3)|0;c=f[m>>2]|0;y=f[m+4>>2]|0;if((c|0)!=-2147483648|(y|0)!=2147483647?(m=(f[j>>2]|0)+(z<<2)|0,c|0?1:(y|0)!=(f[m>>2]|0)):0){f[m>>2]=y-c;y=Y(f[(f[l>>2]|0)+(z<<2)>>2]|0,c)|0;f[i>>2]=(f[i>>2]|0)+y;f[a>>2]=f[a>>2]|32768}z=z+1|0}while((z|0)!=(k|0));n=f[a>>2]|0;o=f[h>>2]|0;p=f[j>>2]|0;q=f[l>>2]|0;r=Q$(n,o,p,q)|0;f[a>>2]=r;u=e;return}}function IQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)==(b|0))return a|0;c=b+24|0;d=f[c>>2]|0;if(d|0){e=d+8|0;f[e>>2]=(f[e>>2]|0)+1}e=a+24|0;d=f[e>>2]|0;if(d|0?(g=d+8|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0){d=f[e>>2]|0;f[e>>2]=0;g=f[d+4>>2]|0;mi[f[(f[g>>2]|0)+16>>2]&2047](g,d)}d=a+4|0;if((f[d>>2]|0)>0){g=f[a+32>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;i=f[d>>2]|0}while((h|0)<(i|0));f[e>>2]=0;f[a>>2]=f[b>>2];if((i|0)<3)j=13;else{k=f[b+4>>2]|0;j=15}}else{f[e>>2]=0;f[a>>2]=f[b>>2];j=13}if((j|0)==13){i=f[b+4>>2]|0;if((i|0)<3){f[d>>2]=i;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+36>>2]|0;g=f[a+36>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{k=i;j=15}}if((j|0)==15?(yQ(a,k,0,0,0),(f[d>>2]|0)>0):0){k=f[b+32>>2]|0;j=f[a+32>>2]|0;i=f[b+36>>2]|0;h=f[a+36>>2]|0;g=0;do{f[j+(g<<2)>>2]=f[k+(g<<2)>>2];f[h+(g<<2)>>2]=f[i+(g<<2)>>2];g=g+1|0}while((g|0)<(f[d>>2]|0))}f[a+16>>2]=f[b+16>>2];d=a+20|0;if(!(f[d>>2]|0))f[d>>2]=f[b+20>>2];f[e>>2]=f[c>>2];f[a+28>>2]=f[b+28>>2];return a|0}function JQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=f[c>>2]|0;j=(i>>>3&511)+1|0;f[a>>2]=i;i=a+4|0;k=c+4|0;l=f[k>>2]|0;f[i>>2]=l;m=a+8|0;n=c+8|0;f[m>>2]=f[n>>2];o=a+12|0;p=c+12|0;f[o>>2]=f[p>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];q=f[c+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[c+28>>2];r=a+32|0;f[r>>2]=m;s=a+40|0;t=a+36|0;f[t>>2]=s;f[a+44>>2]=0;f[s>>2]=0;if(!q)v=l;else{l=q+8|0;f[l>>2]=(f[l>>2]|0)+1;v=f[k>>2]|0}if((v|0)>=3){f[i>>2]=0;yQ(a,v,0,0,0);if((f[i>>2]|0)>0){v=f[c+32>>2]|0;l=f[r>>2]|0;q=f[c+36>>2]|0;s=f[t>>2]|0;w=0;do{f[l+(w<<2)>>2]=f[v+(w<<2)>>2];f[s+(w<<2)>>2]=f[q+(w<<2)>>2];w=w+1|0}while((w|0)<(f[i>>2]|0))}}else{i=f[c+36>>2]|0;w=f[t>>2]|0;f[w>>2]=f[i>>2];f[w+4>>2]=f[i+4>>2]}i=f[k>>2]|0;w=(e|0)==0;if((d|0)!=0&(w&(i|0)>2)){q=i+-1|0;if((Y(f[(f[c+32>>2]|0)+(q<<2)>>2]|0,j)|0)%(d|0)|0|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=h+11|0;b[x>>0]=9;y=h;z=238092;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));B=h+9|0;b[B>>0]=0;vM(-215,h,238177,228993,699)}s=f[a>>2]|0;v=(d<<3)+-8|0;f[a>>2]=s&-4089|v;l=Y(675553809>>>(s<<2&28)&15,(v>>>3&511)+1|0)|0;f[(f[t>>2]|0)+(q<<2)>>2]=l;l=(f[r>>2]|0)+((f[k>>2]|0)+-1<<2)|0;k=(Y(f[l>>2]|0,j)|0)/(d|0)|0;f[l>>2]=k;u=g;return}if((i|0)>=3){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=h+11|0;b[x>>0]=9;y=h;z=238092;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));B=h+9|0;b[B>>0]=0;vM(-215,h,238177,228993,699)}B=(d|0)==0?j:d;d=Y(f[p>>2]|0,j)|0;if((B|0)>(d|0))if(w)C=16;else{D=e;C=18}else if(w&((d|0)%(B|0)|0|0)!=0)C=16;else{E=e;C=17}if((C|0)==16){E=(Y(f[n>>2]|0,d)|0)/(B|0)|0;C=17}if((C|0)==17)if(!E)F=d;else{D=E;C=18}do if((C|0)==18){E=f[n>>2]|0;if((D|0)!=(E|0)){e=Y(E,d)|0;E=f[c>>2]|0;if(!(E&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(80)|0;f[h>>2]=w;f[h+8>>2]=-2147483568;f[h+4>>2]=72;y=w;z=243382;A=y+72|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[w+72>>0]=0;vM(-13,h,238177,228993,714)}if(D>>>0>e>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=22;y=j;z=243455;A=y+22|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[j+22>>0]=0;vM(-211,h,238177,228993,717)}w=(e|0)/(D|0)|0;if((Y(w,D)|0)==(e|0)){f[m>>2]=D;p=Y(675553809>>>(E<<2&28)&15,w)|0;f[f[t>>2]>>2]=p;F=w;break}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(80)|0;f[h>>2]=w;f[h+8>>2]=-2147483568;f[h+4>>2]=78;y=w;z=243272;A=y+78|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[w+78>>0]=0;vM(-5,h,238177,228993,723)}}else F=d}while(0);d=(F|0)/(B|0)|0;if((Y(d,B)|0)!=(F|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;F=$Xc(64)|0;f[h>>2]=F;f[h+8>>2]=-2147483584;f[h+4>>2]=62;y=F;z=243478;A=y+62|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[F+62>>0]=0;vM(-15,h,238177,228993,733)}f[o>>2]=d;d=f[a>>2]|0;o=(B<<3)+-8|0;f[a>>2]=d&-4089|o;a=Y(675553809>>>(d<<2&28)&15,(o>>>3&511)+1|0)|0;f[(f[t>>2]|0)+4>>2]=a;u=g;return}function KQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+64|0;e=d;g=sS(c)|0;NQ(e,a,g?33554432:50331648);mR(e,b,c)|0;c=e+36|0;b=f[c>>2]|0;if(b|0?(g=b+12|0,b=f[g>>2]|0,f[g>>2]=b+-1,(b|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;b=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[e+40>>2]|0;g=0;do{f[c+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[b>>2]|0))}b=f[e+44>>2]|0;if((b|0)==(e+48|0)){u=d;return a|0}wL(b);u=d;return a|0}function LQ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+464|0;e=d+328|0;g=d+200|0;h=d+72|0;i=d+16|0;j=d;k=dS(c,-1)|0;if(YS(c)|0?(l=f[a>>2]|0,(k|0)!=(l&4095|0)):0){if((l^k)&4088|0){l=$Xc(32)|0;f[e>>2]=l;f[e+8>>2]=-2147483616;f[e+4>>2]=30;m=l;n=229368;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+30>>0]=0;vM(-215,e,231275,228993,888)}MQ(a,c,k,1.0,0.0);u=d;return}k=a+24|0;if(f[k>>2]|0){l=a+4|0;n=f[l>>2]|0;if((n|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[a+32>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(n|0)){p=t;break}else s=t}}if(!((n|0)==0|(p|0)==0)){m=e;o=m+128|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));m=(n|0)>0;if(m)v=f[(f[a+36>>2]|0)+(n+-1<<2)>>2]|0;else v=0;o=f[a+32>>2]|0;p=0;do{f[e+(p<<2)>>2]=f[o+(p<<2)>>2];p=p+1|0}while(p>>>0<n>>>0);p=n+-1|0;o=e+(p<<2)|0;s=Y(f[o>>2]|0,v)|0;f[o>>2]=s;if(m){m=f[a+36>>2]|0;s=0;o=f[a+28>>2]|0;do{r=f[m+(s<<2)>>2]|0;q=(o>>>0)/(r>>>0)|0;f[g+(s<<2)>>2]=q;o=o-(Y(q,r)|0)|0;s=s+1|0}while((s|0)<(n|0))}s=g+(p<<2)|0;p=Y(f[s>>2]|0,v)|0;f[s>>2]=p;xS(c,n,f[a+32>>2]|0,f[a>>2]&4095,-1,0,0);do if((eS(c)|0)==655360){fS(i,c,-1);n=i+24|0;p=f[n>>2]|0;if(!p){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=5;b[j>>0]=b[229271]|0;b[j+1>>0]=b[229272]|0;b[j+2>>0]=b[229273]|0;b[j+3>>0]=b[229274]|0;b[j+4>>0]=b[229275]|0;b[j+5>>0]=0;vM(-215,j,231275,228993,910)}s=f[k>>2]|0;if((s|0)==(p|0)?(f[i+28>>2]|0)==(f[a+28>>2]|0):0){o=p+8|0;m=f[o>>2]|0;f[o>>2]=m+-1;if((m|0)==1){m=f[n>>2]|0;f[n>>2]=0;o=f[m+4>>2]|0;mi[f[(f[o>>2]|0)+16>>2]&2047](o,m)}m=i+4|0;if((f[m>>2]|0)>0){o=f[i+32>>2]|0;r=0;do{f[o+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[m>>2]|0))}f[n>>2]=0;m=f[i+36>>2]|0;if((m|0)!=(i+40|0))wL(m);break}m=f[s+4>>2]|0;if((m|0)!=(f[p+4>>2]|0)){r=p+8|0;o=f[r>>2]|0;f[r>>2]=o+-1;if((o|0)==1){o=f[n>>2]|0;f[n>>2]=0;r=f[o+4>>2]|0;mi[f[(f[r>>2]|0)+16>>2]&2047](r,o)}o=i+4|0;if((f[o>>2]|0)>0){r=f[i+32>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}f[n>>2]=0;o=f[i+36>>2]|0;if((o|0)!=(i+40|0))wL(o);w=39;break}o=i+4|0;q=f[o>>2]|0;if((q|0)>0){r=i+36|0;t=f[r>>2]|0;x=0;y=f[i+28>>2]|0;do{z=f[t+(x<<2)>>2]|0;A=(y>>>0)/(z>>>0)|0;f[h+(x<<2)>>2]=A;y=y-(Y(A,z)|0)|0;x=x+1|0}while((x|0)<(q|0));B=r;C=t}else{t=i+36|0;B=t;C=f[t>>2]|0}t=f[l>>2]|0;r=h+(t+-1<<2)|0;q=Y(f[r>>2]|0,v)|0;f[r>>2]=q;Oh[f[(f[m>>2]|0)+36>>2]&7](m,s,p,t,e,g,f[a+36>>2]|0,h,C,0);t=f[n>>2]|0;if(t|0?(q=t+8|0,t=f[q>>2]|0,f[q>>2]=t+-1,(t|0)==1):0){t=f[n>>2]|0;f[n>>2]=0;q=f[t+4>>2]|0;mi[f[(f[q>>2]|0)+16>>2]&2047](q,t)}if((f[o>>2]|0)>0){t=f[i+32>>2]|0;q=0;do{f[t+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}f[n>>2]=0;o=f[B>>2]|0;if((o|0)!=(i+40|0))wL(o)}else w=39;while(0);if((w|0)==39){do if((eS(c)|0)==65536){w=f[c+4>>2]|0;f[i>>2]=f[w>>2];B=i+4|0;C=w+4|0;f[B>>2]=f[C>>2];h=i+8|0;f[h>>2]=f[w+8>>2];f[i+12>>2]=f[w+12>>2];v=i+16|0;f[v>>2]=f[w+16>>2];f[i+20>>2]=f[w+20>>2];f[i+24>>2]=f[w+24>>2];f[i+28>>2]=f[w+28>>2];f[i+32>>2]=f[w+32>>2];j=f[w+36>>2]|0;f[i+36>>2]=j;f[i+40>>2]=h;h=i+48|0;o=i+44|0;f[o>>2]=h;f[h>>2]=0;f[i+52>>2]=0;if(j|0){h=j+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[C>>2]|0)<3){C=f[w+44>>2]|0;h=f[o>>2]|0;f[h>>2]=f[C>>2];f[h+4>>2]=f[C+4>>2];D=v;E=o;break}else{f[B>>2]=0;U$(i,w);D=v;E=o;break}}else{bS(i,c,-1);D=i+16|0;E=i+44|0}while(0);o=f[k>>2]|0;k=f[o+4>>2]|0;wi[f[(f[k>>2]|0)+28>>2]&255](k,o,f[D>>2]|0,f[l>>2]|0,e,g,f[a+36>>2]|0,f[E>>2]|0);a=i+36|0;g=f[a>>2]|0;if(g|0?(e=g+12|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)V$(i);f[a>>2]=0;a=i+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[a>>2]|0)>0){D=f[i+40>>2]|0;g=0;do{f[D+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[a>>2]|0))}a=f[E>>2]|0;if((a|0)!=(i+48|0))wL(a)}u=d;return}}vS(c);u=d;return}function MQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+112|0;h=g+56|0;i=g;if(+L(+(d+-1.0))<2.220446049250313e-16)j=+L(+e)<2.220446049250313e-16;else j=0;k=f[a>>2]|0;if((c|0)<0)if(YS(b)|0)l=dS(b,-1)|0;else l=k&4095;else l=k&4088|c&7;if(!(((l^k)&7|0)!=0|j^1)){LQ(a,b);u=g;return}f[h>>2]=f[a>>2];j=h+4|0;k=a+4|0;c=f[k>>2]|0;f[j>>2]=c;m=h+8|0;f[m>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];n=h+24|0;o=f[a+24>>2]|0;f[n>>2]=o;f[h+28>>2]=f[a+28>>2];p=h+32|0;f[p>>2]=m;m=h+40|0;q=h+36|0;f[q>>2]=m;f[h+44>>2]=0;f[m>>2]=0;if(!o)r=c;else{c=o+8|0;f[c>>2]=(f[c>>2]|0)+1;r=f[k>>2]|0}if((r|0)>=3){f[j>>2]=0;yQ(h,r,0,0,0);if((f[j>>2]|0)>0){r=f[a+32>>2]|0;h=f[p>>2]|0;k=f[a+36>>2]|0;c=f[q>>2]|0;o=0;do{f[h+(o<<2)>>2]=f[r+(o<<2)>>2];f[c+(o<<2)>>2]=f[k+(o<<2)>>2];o=o+1|0}while((o|0)<(f[j>>2]|0))}}else{o=f[a+36>>2]|0;k=f[q>>2]|0;f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2]}NQ(i,a,16777216);dY(i,b,l,d,e);l=i+36|0;b=f[l>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)V$(i);f[l>>2]=0;l=i+16|0;b=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[b>>2]|0)>0){l=f[i+40>>2]|0;a=0;do{f[l+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[i+44>>2]|0;if((b|0)!=(i+48|0))wL(b);b=f[n>>2]|0;if(b|0?(i=b+8|0,b=f[i>>2]|0,f[i>>2]=b+-1,(b|0)==1):0){b=f[n>>2]|0;f[n>>2]=0;i=f[b+4>>2]|0;mi[f[(f[i>>2]|0)+16>>2]&2047](i,b)}if((f[j>>2]|0)>0){b=f[p>>2]|0;p=0;do{f[b+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}f[n>>2]=0;n=f[q>>2]|0;if((n|0)!=(m|0))wL(n);u=g;return}function NQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e;h=c+24|0;i=f[h>>2]|0;if(!i){f[a>>2]=1124007936;j=a+8|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;u=e;return}j=d|50331648;d=i;k=sQ()|0;n=k+4|0;do if((i|0)!=(f[n>>2]|0)?(i|0)!=(f[k+8>>2]|0):0)if(!(f[k>>2]|0)){f[k>>2]=1;f[n>>2]=i;YXc(542280+(((d>>>0)%31|0)*28|0)|0);o=i;break}else{p=$Xc(32)|0;f[g>>2]=p;f[g+8>>2]=-2147483616;f[g+4>>2]=16;l=p;q=229062;m=l+16|0;do{b[l>>0]=b[q>>0]|0;l=l+1|0;q=q+1|0}while((l|0)<(m|0));b[p+16>>0]=0;vM(-215,g,229079,228993,167)}else o=0;while(0);i=(f[h>>2]|0)+12|0;d=f[i>>2]|0;f[i>>2]=d+1;if(!d){d=f[h>>2]|0;i=f[d+4>>2]|0;Ti[f[(f[i>>2]|0)+20>>2]&511](i,d,j)}j=f[h>>2]|0;d=f[j+16>>2]|0;do if(!d){i=j+12|0;f[i>>2]=(f[i>>2]|0)+-1;if(!(f[(f[h>>2]|0)+16>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=$Xc(64)|0;f[g>>2]=i;f[g+8>>2]=-2147483584;f[g+4>>2]=55;l=i;q=229277;m=l+55|0;do{b[l>>0]=b[q>>0]|0;l=l+1|0;q=q+1|0}while((l|0)<(m|0));b[i+55>>0]=0;vM(-215,g,229333,228993,838)}else{f[a>>2]=1124007936;p=a+8|0;n=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[n>>2]=p;i=a+48|0;f[a+44>>2]=i;f[i>>2]=0;f[a+52>>2]=0;break}}else{i=c+28|0;_$(a,f[c+4>>2]|0,f[c+32>>2]|0,f[c>>2]&4095,d+(f[i>>2]|0)|0,f[c+36>>2]|0);f[a>>2]=f[c>>2];k=f[h>>2]|0;f[a+36>>2]=k;r=f[k+16>>2]|0;f[a+20>>2]=r;f[a+16>>2]=r+(f[i>>2]|0);i=r+(f[k+24>>2]|0)|0;f[a+24>>2]=i;f[a+28>>2]=i}while(0);xQ(sQ()|0,o,0);u=e;return}function OQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+48|0;i=h+16|0;j=h;k=c+4|0;l=f[k>>2]|0;if((l|0)==(e|0)){if(!g){JQ(a,c,d,0);u=h;return}if((e|0)==2){JQ(a,c,d,f[g>>2]|0);u=h;return}}m=f[c>>2]|0;if(!(m&16384)){n=$Xc(80)|0;f[i>>2]=n;f[i+8>>2]=-2147483568;f[i+4>>2]=71;o=n;p=238412;q=o+71|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+71>>0]=0;vM(-213,i,238177,228993,813)}if(!((g|0)!=0&((d|0)>-1&(e+-1|0)>>>0<32))){n=$Xc(64)|0;f[i>>2]=n;f[i+8>>2]=-2147483584;f[i+4>>2]=62;o=n;p=238185;q=o+62|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+62>>0]=0;vM(-215,i,238177,228993,777)}if(d)if((d|0)<513)r=d;else{d=$Xc(32)|0;f[i>>2]=d;f[i+8>>2]=-2147483616;f[i+4>>2]=16;o=d;p=238248;q=o+16|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+16>>0]=0;vM(-215,i,238177,228993,782)}else r=(m>>>3&511)+1|0;if((l|0)<3)s=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{d=f[c+32>>2]|0;n=0;t=1;while(1){v=Y(f[d+(n<<2)>>2]|0,t)|0;n=n+1|0;if((n|0)==(l|0)){s=v;break}else t=v}}t=Y((m>>>3&511)+1|0,s)|0;s=i+8|0;f[i>>2]=s;m=i+4|0;f[m>>2]=e;if(e>>>0>4){l=bYc(e>>>0>1073741823?-1:e<<2)|0;f[i>>2]=l;w=l}else w=s;a:do if((e|0)>0){l=c+32|0;n=r;d=0;while(1){v=f[g+(d<<2)>>2]|0;if((v|0)<=-1){x=23;break}if(!v){if((d|0)>=(f[k>>2]|0)){x=27;break}y=f[(f[l>>2]|0)+(d<<2)>>2]|0}else y=v;f[w+(d<<2)>>2]=y;v=Y(y,n)|0;d=d+1|0;if((d|0)>=(e|0)){z=v;break a}else n=v}if((x|0)==23){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;n=$Xc(16)|0;f[j>>2]=n;f[j+8>>2]=-2147483632;f[j+4>>2]=14;o=n;p=238265;q=o+14|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+14>>0]=0;vM(-215,j,238177,228993,791)}else if((x|0)==27){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=$Xc(80)|0;f[j>>2]=d;f[j+8>>2]=-2147483568;f[j+4>>2]=68;o=d;p=238280;q=o+68|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+68>>0]=0;vM(-211,j,238177,228993,798)}}else z=r;while(0);if((z|0)!=(t|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=$Xc(64)|0;f[j>>2]=t;f[j+8>>2]=-2147483584;f[j+4>>2]=62;o=t;p=238349;q=o+62|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+62>>0]=0;vM(-209,j,238177,228993,804)}f[a>>2]=f[c>>2];j=a+4|0;t=f[k>>2]|0;f[j>>2]=t;p=a+8|0;f[p>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];o=f[c+24>>2]|0;f[a+24>>2]=o;f[a+28>>2]=f[c+28>>2];q=a+32|0;f[q>>2]=p;p=a+40|0;z=a+36|0;f[z>>2]=p;f[a+44>>2]=0;f[p>>2]=0;if(!o)A=t;else{t=o+8|0;f[t>>2]=(f[t>>2]|0)+1;A=f[k>>2]|0}if((A|0)>=3){f[j>>2]=0;yQ(a,A,0,0,0);if((f[j>>2]|0)>0){A=f[c+32>>2]|0;k=f[q>>2]|0;q=f[c+36>>2]|0;t=f[z>>2]|0;o=0;do{f[k+(o<<2)>>2]=f[A+(o<<2)>>2];f[t+(o<<2)>>2]=f[q+(o<<2)>>2];o=o+1|0}while((o|0)<(f[j>>2]|0))}}else{j=f[c+36>>2]|0;c=f[z>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2]}f[a>>2]=f[a>>2]&-4089|(r<<3)+-8;yQ(a,e,f[i>>2]|0,0,1);e=f[i>>2]|0;if((e|0)!=(s|0)){if(e|0)dYc(e);f[i>>2]=s;f[m>>2]=4}u=h;return}function PQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[a+36>>2]|0;e=0;g=f[a+28>>2]|0;do{a=f[d+(e<<2)>>2]|0;h=(g>>>0)/(a>>>0)|0;f[b+(e<<2)>>2]=h;g=g-(Y(h,a)|0)|0;e=e+1|0}while((e|0)<(f[c>>2]|0));return}function QQ(){var a=0,b=0,c=0,d=0;a=(hN(gN()|0)|0)+16|0;b=f[a>>2]|0;if((b|0)>=0){c=b;d=(c|0)>0;return d|0}f[a>>2]=0;c=0;d=(c|0)>0;return d|0}function RQ(a,c){a=a|0;c=c|0;if(!c)return;RQ(a,f[c>>2]|0);RQ(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function SQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=TQ(c,h,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}d=$Xc(28)|0;lYc(d+16|0,e);e=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=e;f[i>>2]=d;e=f[f[c>>2]>>2]|0;if(!e)n=d;else{f[c>>2]=e;n=f[i>>2]|0}UQ(f[c+4>>2]|0,n);n=c+8|0;f[n>>2]=(f[n>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}function TQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function UQ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c|0)==(a|0);b[c+12>>0]=d&1;if(d)return;else e=c;while(1){g=f[e+8>>2]|0;c=g+12|0;if(b[c>>0]|0){h=23;break}i=g+8|0;j=f[i>>2]|0;d=f[j>>2]|0;if((d|0)==(g|0)){k=f[j+4>>2]|0;if(!k){h=7;break}l=k+12|0;if(!(b[l>>0]|0))m=l;else{h=7;break}}else{if(!d){h=16;break}l=d+12|0;if(!(b[l>>0]|0))m=l;else{h=16;break}}b[c>>0]=1;c=(j|0)==(a|0);b[j+12>>0]=c&1;b[m>>0]=1;if(c){h=23;break}else e=j}if((h|0)==7){if((f[g>>2]|0)==(e|0)){n=g;o=j}else{m=g+4|0;a=f[m>>2]|0;c=f[a>>2]|0;f[m>>2]=c;if(!c)p=j;else{f[c+8>>2]=g;p=f[i>>2]|0}f[a+8>>2]=p;p=f[i>>2]|0;f[((f[p>>2]|0)==(g|0)?p:p+4|0)>>2]=a;f[a>>2]=g;f[i>>2]=a;n=a;o=f[a+8>>2]|0}b[n+12>>0]=1;b[o+12>>0]=0;n=f[o>>2]|0;a=n+4|0;p=f[a>>2]|0;f[o>>2]=p;if(p|0)f[p+8>>2]=o;p=o+8|0;f[n+8>>2]=f[p>>2];c=f[p>>2]|0;f[((f[c>>2]|0)==(o|0)?c:c+4|0)>>2]=n;f[a>>2]=o;f[p>>2]=n;return}else if((h|0)==16){if((f[g>>2]|0)==(e|0)){e=f[g>>2]|0;n=e+4|0;p=f[n>>2]|0;f[g>>2]=p;if(!p)q=j;else{f[p+8>>2]=g;q=f[i>>2]|0}f[e+8>>2]=q;q=f[i>>2]|0;f[((f[q>>2]|0)==(g|0)?q:q+4|0)>>2]=e;f[n>>2]=g;f[i>>2]=e;r=e;s=f[e+8>>2]|0}else{r=g;s=j}b[r+12>>0]=1;b[s+12>>0]=0;r=s+4|0;j=f[r>>2]|0;g=f[j>>2]|0;f[r>>2]=g;if(g|0)f[g+8>>2]=s;g=s+8|0;f[j+8>>2]=f[g>>2];r=f[g>>2]|0;f[((f[r>>2]|0)==(s|0)?r:r+4|0)>>2]=j;f[j>>2]=s;f[g>>2]=j;return}else if((h|0)==23)return}function VQ(a){a=a|0;var c=0;c=f[a>>2]|0;f[a>>2]=c+-1;if((c|0)!=1)return;if((a|0)==0|(b[1160164]|0)!=0)return;c=a+4|0;if(f[c>>2]|0)f[c>>2]=0;c=f[a+12>>2]|0;if(c|0)VQ(c);cYc(a);return}function WQ(a){a=a|0;f[a>>2]=0;return}function XQ(a){a=a|0;var b=0;b=f[a>>2]|0;if(!b)return;VQ(b);return}function YQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function ZQ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((k|0)!=0&(j|0)>0){l=a;m=d;n=g;o=k}else return;while(1){k=0;do{if(b[m+k>>0]|0)b[n+k>>0]=b[l+k>>0]|0;k=k+1|0}while((k|0)!=(j|0));o=o+-1|0;if(!o)break;else{l=l+c|0;m=m+e|0;n=n+h|0}}return}function _Q(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if((l|0)!=0&(k|0)>0){m=a;n=e;o=h;p=l}else return;while(1){l=0;do{if(b[n+l>>0]|0)d[o+(l<<1)>>1]=d[m+(l<<1)>>1]|0;l=l+1|0}while((l|0)!=(k|0));p=p+-1|0;if(!p)break;else{m=m+c|0;n=n+g|0;o=o+i|0}}return}function $Q(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*3|0)|0;s=m+(q*3|0)|0;b[r>>0]=b[s>>0]|0;b[r+1>>0]=b[s+1>>0]|0;b[r+2>>0]=b[s+2>>0]|0}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*3|0)|0;l=m+(k*3|0)|0;b[p>>0]=b[l>>0]|0;b[p+1>>0]=b[l+1>>0]|0;b[p+2>>0]=b[l+2>>0]|0}l=k|1;if(b[a+l>>0]|0){p=d+(l*3|0)|0;q=m+(l*3|0)|0;b[p>>0]=b[q>>0]|0;b[p+1>>0]=b[q+1>>0]|0;b[p+2>>0]=b[q+2>>0]|0}q=k|2;if(b[a+q>>0]|0){p=d+(q*3|0)|0;l=m+(q*3|0)|0;b[p>>0]=b[l>>0]|0;b[p+1>>0]=b[l+1>>0]|0;b[p+2>>0]=b[l+2>>0]|0}l=k|3;if(b[a+l>>0]|0){p=d+(l*3|0)|0;q=m+(l*3|0)|0;b[p>>0]=b[q>>0]|0;b[p+1>>0]=b[q+1>>0]|0;b[p+2>>0]=b[q+2>>0]|0}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*3|0)|0;p=m+(k*3|0)|0;b[q>>0]=b[p>>0]|0;b[q+1>>0]=b[p+1>>0]|0;b[q+2>>0]=b[p+2>>0]|0}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function aR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0)f[o+(q<<2)>>2]=f[m+(q<<2)>>2];q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0)f[d+(k<<2)>>2]=f[m+(k<<2)>>2];p=k|1;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];p=k|2;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];p=k|3;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0)f[d+(k<<2)>>2]=f[m+(k<<2)>>2];k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function bR(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if(!l)return;j=k+-4|0;if((k|0)<4){m=(k|0)>0;n=a;o=e;p=h;q=l;while(1){q=q+-1|0;if(m){r=0;do{if(b[o+r>>0]|0){s=p+(r*6|0)|0;t=n+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0}r=r+1|0}while((r|0)!=(k|0))}if(!q)break;else{n=n+c|0;o=o+g|0;p=p+i|0}}return}p=k&-4;o=(p|0)<(k|0);n=a;a=e;e=h;h=l;while(1){l=0;do{if(b[a+l>>0]|0){q=e+(l*6|0)|0;m=n+(l*6|0)|0;d[q>>1]=d[m>>1]|0;d[q+2>>1]=d[m+2>>1]|0;d[q+4>>1]=d[m+4>>1]|0}m=l|1;if(b[a+m>>0]|0){q=e+(m*6|0)|0;r=n+(m*6|0)|0;d[q>>1]=d[r>>1]|0;d[q+2>>1]=d[r+2>>1]|0;d[q+4>>1]=d[r+4>>1]|0}r=l|2;if(b[a+r>>0]|0){q=e+(r*6|0)|0;m=n+(r*6|0)|0;d[q>>1]=d[m>>1]|0;d[q+2>>1]=d[m+2>>1]|0;d[q+4>>1]=d[m+4>>1]|0}m=l|3;if(b[a+m>>0]|0){q=e+(m*6|0)|0;r=n+(m*6|0)|0;d[q>>1]=d[r>>1]|0;d[q+2>>1]=d[r+2>>1]|0;d[q+4>>1]=d[r+4>>1]|0}l=l+4|0}while((l|0)<=(j|0));h=h+-1|0;if(o){l=p;do{if(b[a+l>>0]|0){r=e+(l*6|0)|0;q=n+(l*6|0)|0;d[r>>1]=d[q>>1]|0;d[r+2>>1]=d[q+2>>1]|0;d[r+4>>1]=d[q+4>>1]|0}l=l+1|0}while((l|0)!=(k|0))}if(!h)break;else{n=n+c|0;a=a+g|0;e=e+i|0}}return}function cR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=m+(q<<3)|0;s=f[r+4>>2]|0;t=o+(q<<3)|0;f[t>>2]=f[r>>2];f[t+4>>2]=s}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=m+(k<<3)|0;l=f[p+4>>2]|0;q=d+(k<<3)|0;f[q>>2]=f[p>>2];f[q+4>>2]=l}l=k|1;if(b[a+l>>0]|0){q=m+(l<<3)|0;p=f[q+4>>2]|0;s=d+(l<<3)|0;f[s>>2]=f[q>>2];f[s+4>>2]=p}p=k|2;if(b[a+p>>0]|0){s=m+(p<<3)|0;q=f[s+4>>2]|0;l=d+(p<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=q}q=k|3;if(b[a+q>>0]|0){l=m+(q<<3)|0;s=f[l+4>>2]|0;p=d+(q<<3)|0;f[p>>2]=f[l>>2];f[p+4>>2]=s}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){s=m+(k<<3)|0;p=f[s+4>>2]|0;l=d+(k<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=p}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function dR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*12|0)|0;s=m+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*12|0)|0;l=m+(k*12|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l*12|0)|0;q=m+(l*12|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q*12|0)|0;l=m+(q*12|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l*12|0)|0;q=m+(l*12|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*12|0)|0;p=m+(k*12|0)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function eR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q<<4)|0;s=m+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k<<4)|0;l=m+(k<<4)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l<<4)|0;q=m+(l<<4)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q<<4)|0;l=m+(q<<4)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l<<4)|0;q=m+(l<<4)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k<<4)|0;p=m+(k<<4)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function fR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*24|0)|0;s=m+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*24|0)|0;l=m+(k*24|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l*24|0)|0;q=m+(l*24|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q*24|0)|0;l=m+(q*24|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l*24|0)|0;q=m+(l*24|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*24|0)|0;p=m+(k*24|0)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function gR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q<<5)|0;s=m+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k<<5)|0;l=m+(k<<5)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l<<5)|0;q=m+(l<<5)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q<<5)|0;l=m+(q<<5)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l<<5)|0;q=m+(l<<5)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k<<5)|0;p=m+(k<<5)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2];f[q+24>>2]=f[p+24>>2];f[q+28>>2]=f[p+28>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function hR(a){a=a|0;var b=0;if(a>>>0<33){b=f[36528+(a<<2)>>2]|0;return ((b|0)==0?171:b)|0}else return 171;return 0}function iR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=f[j>>2]|0;j=i+4|0;l=f[j>>2]|0;m=l+-1|0;f[j>>2]=m;if(!l)return;l=f[i>>2]|0;if(!k){n=(l|0)>0;o=m;do{if(n){p=0;do p=p+1|0;while((p|0)<(l|0))}p=o;o=o+-1|0}while((p|0)!=0);f[j>>2]=o;return}else{q=a;r=d;s=g;t=l;u=m}while(1){if((t|0)>0){m=s;l=q;g=0;d=t;while(1){if(!(b[r+g>>0]|0))v=d;else{a=0;do{b[m+a>>0]=b[l+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));v=f[i>>2]|0}g=g+1|0;if((g|0)>=(v|0))break;else{m=m+k|0;l=l+k|0;d=v}}w=f[j>>2]|0;x=v}else{w=u;x=t}u=w+-1|0;f[j>>2]=u;if(!w)break;else{q=q+c|0;r=r+e|0;s=s+h|0;t=x}}return}function jR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+352|0;e=d+288|0;g=d+160|0;h=d;i=d+128|0;j=dS(c,-1)|0;if(YS(c)|0?(k=f[a>>2]|0,(j|0)!=(k&4095|0)):0){if((k^j)&4088|0){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=229368;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+30>>0]=0;vM(-215,e,231275,229399,254)}dY(a,c,j,1.0,0.0);u=d;return}j=a+16|0;if(f[j>>2]|0){k=a+4|0;o=f[k>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[a+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if(!((o|0)==0|(p|0)==0)){p=(eS(c)|0)==655360;o=f[k>>2]|0;if(p){p=a+40|0;xS(c,o,f[p>>2]|0,f[a>>2]&4095,-1,0,0);fS(e,c,-1);s=e+24|0;if(!(f[s>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;r=$Xc(16)|0;f[g>>2]=r;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=r;m=229465;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[r+13>>0]=0;vM(-215,g,231275,229399,269)}l=g;n=l+128|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));r=f[k>>2]|0;if((r|0)<=0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;v=$Xc(32)|0;f[i>>2]=v;w=i+8|0;f[w>>2]=-2147483616;x=i+4|0;f[x>>2]=29;l=v;m=229479;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));y=v+29|0;b[y>>0]=0;vM(-215,i,231275,229399,271)}q=r+-1|0;t=f[(f[a+44>>2]|0)+(q<<2)>>2]|0;if(q>>>0>=31){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;v=$Xc(32)|0;f[i>>2]=v;w=i+8|0;f[w>>2]=-2147483616;x=i+4|0;f[x>>2]=29;l=v;m=229479;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));y=v+29|0;b[y>>0]=0;vM(-215,i,231275,229399,271)}y=f[p>>2]|0;p=0;do{f[g+(p<<2)>>2]=f[y+(p<<2)>>2];p=p+1|0}while(p>>>0<r>>>0);p=g+(r+-1<<2)|0;r=Y(f[p>>2]|0,t)|0;f[p>>2]=r;PQ(e,h);r=f[k>>2]|0;p=h+(r+-1<<2)|0;y=Y(f[p>>2]|0,t)|0;f[p>>2]=y;y=f[s>>2]|0;s=f[y+4>>2]|0;wi[f[(f[s>>2]|0)+32>>2]&255](s,y,f[j>>2]|0,r,g,h,f[e+36>>2]|0,f[a+44>>2]|0);EQ(e);u=d;return}if((o|0)>=3){r=a+40|0;xS(c,o,f[r>>2]|0,f[a>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){o=f[c+4>>2]|0;f[e>>2]=f[o>>2];y=e+4|0;s=o+4|0;f[y>>2]=f[s>>2];p=e+8|0;f[p>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];t=e+16|0;f[t>>2]=f[o+16>>2];f[e+20>>2]=f[o+20>>2];f[e+24>>2]=f[o+24>>2];f[e+28>>2]=f[o+28>>2];f[e+32>>2]=f[o+32>>2];v=f[o+36>>2]|0;f[e+36>>2]=v;f[e+40>>2]=p;p=e+48|0;m=e+44|0;f[m>>2]=p;f[p>>2]=0;f[e+52>>2]=0;if(v|0){p=v+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[s>>2]|0)<3){s=f[o+44>>2]|0;p=f[m>>2]|0;f[p>>2]=f[s>>2];f[p+4>>2]=f[s+4>>2];z=t;break}else{f[y>>2]=0;U$(e,o);z=t;break}}else{bS(e,c,-1);z=e+16|0}while(0);if((f[j>>2]|0)!=(f[z>>2]|0)){t=f[k>>2]|0;if((t|0)<3)A=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{o=f[r>>2]|0;r=0;y=1;while(1){s=Y(f[o+(r<<2)>>2]|0,y)|0;r=r+1|0;if((r|0)==(t|0)){A=s;break}else y=s}}if(A|0){f[g>>2]=a;f[g+4>>2]=e;A=h;f[A>>2]=0;f[A+4>>2]=0;BL(i,g,h,2);A=f[k>>2]|0;if((A|0)>0)B=f[(f[a+44>>2]|0)+(A+-1<<2)>>2]|0;else B=0;A=Y(B,f[i+20>>2]|0)|0;B=i+16|0;y=h+4|0;t=0;while(1){if(t>>>0>=(f[B>>2]|0)>>>0)break;o1c(f[y>>2]|0,f[h>>2]|0,A|0)|0;CL(i)|0;t=t+1|0}}}t=e+36|0;i=f[t>>2]|0;if(i|0?(A=i+12|0,i=f[A>>2]|0,f[A>>2]=i+-1,(i|0)==1):0)V$(e);f[t>>2]=0;t=e+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[t>>2]|0)>0){z=f[e+40>>2]|0;i=0;do{f[z+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[t>>2]|0))}t=f[e+44>>2]|0;if((t|0)!=(e+48|0))wL(t);u=d;return}t=a+8|0;i=a+12|0;ZS(c,f[t>>2]|0,f[i>>2]|0,f[a>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){z=f[c+4>>2]|0;f[e>>2]=f[z>>2];A=e+4|0;y=z+4|0;f[A>>2]=f[y>>2];B=e+8|0;f[B>>2]=f[z+8>>2];f[e+12>>2]=f[z+12>>2];r=e+16|0;f[r>>2]=f[z+16>>2];f[e+20>>2]=f[z+20>>2];f[e+24>>2]=f[z+24>>2];f[e+28>>2]=f[z+28>>2];f[e+32>>2]=f[z+32>>2];o=f[z+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=B;B=e+48|0;s=e+44|0;f[s>>2]=B;f[B>>2]=0;f[e+52>>2]=0;if(o|0){B=o+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[y>>2]|0)<3){y=f[z+44>>2]|0;B=f[s>>2]|0;f[B>>2]=f[y>>2];f[B+4>>2]=f[y+4>>2];C=r;break}else{f[A>>2]=0;U$(e,z);C=r;break}}else{bS(e,c,-1);C=e+16|0}while(0);r=f[j>>2]|0;j=r;if(((r|0)!=(f[C>>2]|0)?(r=f[t>>2]|0,(r|0)>0):0)?(t=f[i>>2]|0,(t|0)>0):0){f[g>>2]=f[a>>2];i=g+4|0;z=f[k>>2]|0;f[i>>2]=z;A=g+8|0;f[A>>2]=r;f[g+12>>2]=t;t=g+16|0;f[t>>2]=j;f[g+20>>2]=f[a+20>>2];f[g+24>>2]=f[a+24>>2];f[g+28>>2]=f[a+28>>2];f[g+32>>2]=f[a+32>>2];j=g+36|0;r=f[a+36>>2]|0;f[j>>2]=r;y=g+40|0;f[y>>2]=A;A=g+48|0;B=g+44|0;f[B>>2]=A;f[A>>2]=0;f[g+52>>2]=0;if(!r)D=z;else{z=r+12|0;f[z>>2]=(f[z>>2]|0)+1;D=f[k>>2]|0}if((D|0)<3){D=f[a+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[D>>2];f[z+4>>2]=f[D+4>>2]}else{f[i>>2]=0;U$(g,a)}D=f[k>>2]|0;if((D|0)>0)E=f[(f[a+44>>2]|0)+(D+-1<<2)>>2]|0;else E=0;m0(h,g,e,E);E=f[h>>2]|0;if((E|0)<=-1)mV(E,0,36660);D=f[t>>2]|0;a=f[C>>2]|0;k=h+4|0;z=f[k>>2]|0;f[k>>2]=z+-1;if(z|0?(z=e+48|0,o1c(a|0,D|0,E|0)|0,E=f[A>>2]|0,r=f[z>>2]|0,s=f[k>>2]|0,f[k>>2]=s+-1,s|0):0){s=a;a=D;D=r;r=E;do{s=s+D|0;a=a+r|0;o1c(s|0,a|0,f[h>>2]|0)|0;r=f[A>>2]|0;D=f[z>>2]|0;E=f[k>>2]|0;f[k>>2]=E+-1}while((E|0)!=0)}k=f[j>>2]|0;if(k|0?(z=k+12|0,k=f[z>>2]|0,f[z>>2]=k+-1,(k|0)==1):0)V$(g);f[j>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[i>>2]|0)>0){t=f[y>>2]|0;y=0;do{f[t+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[i>>2]|0))}i=f[B>>2]|0;if((i|0)!=(A|0))wL(i)}i=e+36|0;A=f[i>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)V$(e);f[i>>2]=0;i=e+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[i>>2]|0)>0){C=f[e+40>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))wL(i);u=d;return}}vS(c);u=d;return}function kR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+288|0;g=e+232|0;h=e+176|0;i=e+120|0;j=e;k=e+88|0;l=e+112|0;m=e+56|0;n=e+104|0;do if((eS(d)|0)==65536){o=f[d+4>>2]|0;f[g>>2]=f[o>>2];p=g+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];s=g+16|0;f[s>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[g+36>>2]=t;f[g+40>>2]=r;r=g+48|0;v=g+44|0;f[v>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(t|0){r=t+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=s;break}else{f[p>>2]=0;U$(g,o);w=s;break}}else{bS(g,d,-1);w=g+16|0}while(0);if(f[w>>2]|0){d=f[g>>2]|0;s=d>>>3&511;o=s+1|0;if(d&7|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(64)|0;f[h>>2]=x;y=h+8|0;f[y>>2]=-2147483584;z=h+4|0;f[z>>2]=48;A=x;B=229558;C=A+48|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+48|0;b[D>>0]=0;vM(-215,h,231275,229399,372)}d=(s|0)==0;if(!(d|(s|0)==((f[a>>2]|0)>>>3&511|0))){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(64)|0;f[h>>2]=x;y=h+8|0;f[y>>2]=-2147483584;z=h+4|0;f[z>>2]=48;A=x;B=229558;C=A+48|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+48|0;b[D>>0]=0;vM(-215,h,231275,229399,372)}D=a+4|0;if((f[D>>2]|0)<3?(x=f[a+40>>2]|0,z=f[g+40>>2]|0,!((f[x>>2]|0)==(f[z>>2]|0)?(f[x+4>>2]|0)==(f[z+4>>2]|0):0)):0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=$Xc(32)|0;f[h>>2]=z;f[h+8>>2]=-2147483616;f[h+4>>2]=21;A=z;B=229607;C=A+21|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[z+21>>0]=0;vM(-215,h,231275,229399,376)}f[h>>2]=1124007936;z=h+4|0;B=h+8|0;x=h+40|0;A=z;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[x>>2]=B;A=h+48|0;C=h+44|0;f[C>>2]=A;f[A>>2]=0;f[h+52>>2]=0;do if((eS(c)|0)==65536){y=f[c+4>>2]|0;f[i>>2]=f[y>>2];s=i+4|0;p=y+4|0;f[s>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[y+8>>2];f[i+12>>2]=f[y+12>>2];f[i+16>>2]=f[y+16>>2];f[i+20>>2]=f[y+20>>2];f[i+24>>2]=f[y+24>>2];f[i+28>>2]=f[y+28>>2];f[i+32>>2]=f[y+32>>2];r=f[y+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;v=i+44|0;f[v>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[y+44>>2]|0;q=f[v>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[s>>2]=0;U$(i,y);break}}else bS(i,c,-1);while(0);xS(c,f[D>>2]|0,f[a+40>>2]|0,f[a>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){y=f[c+4>>2]|0;f[j>>2]=f[y>>2];s=j+4|0;p=y+4|0;f[s>>2]=f[p>>2];q=j+8|0;f[q>>2]=f[y+8>>2];f[j+12>>2]=f[y+12>>2];f[j+16>>2]=f[y+16>>2];f[j+20>>2]=f[y+20>>2];f[j+24>>2]=f[y+24>>2];f[j+28>>2]=f[y+28>>2];f[j+32>>2]=f[y+32>>2];v=f[y+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=q;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;if(v|0){q=v+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[y+44>>2]|0;q=f[r>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[s>>2]=0;U$(j,y);break}}else bS(j,c,-1);while(0);y=h+36|0;s=f[y>>2]|0;if(s|0?(p=s+12|0,s=f[p>>2]|0,f[p>>2]=s+-1,(s|0)==1):0)V$(h);f[y>>2]=0;s=h+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[z>>2]|0)>0){p=f[x>>2]|0;q=0;do{f[p+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[z>>2]|0))}f[h>>2]=f[j>>2];q=j+4|0;p=f[q>>2]|0;f[z>>2]=p;r=j+8|0;f[B>>2]=f[r>>2];f[h+12>>2]=f[j+12>>2];v=j+16|0;f[s>>2]=f[v>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];t=j+36|0;f[y>>2]=f[t>>2];E=h+44|0;F=f[E>>2]|0;if((F|0)==(A|0))G=p;else{wL(F);f[E>>2]=A;f[x>>2]=B;G=f[q>>2]|0}B=j+44|0;if((G|0)<3){G=f[B>>2]|0;f[A>>2]=f[G>>2];f[h+52>>2]=f[G+4>>2];H=G}else{f[E>>2]=f[B>>2];E=j+40|0;f[h+40>>2]=f[E>>2];G=j+48|0;f[B>>2]=G;f[E>>2]=r;H=G}f[j>>2]=1124007936;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[q+28>>2]=0;f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((H|0)!=(j+48|0))wL(H);H=i+16|0;if((f[s>>2]|0)!=(f[H>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;lR(h,j)|0}v=i+36|0;t=f[v>>2]|0;if(t|0?(q=t+12|0,t=f[q>>2]|0,f[q>>2]=t+-1,(t|0)==1):0)V$(i);f[v>>2]=0;v=i+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[v>>2]|0)>0){H=f[i+40>>2]|0;t=0;do{f[H+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[i+44>>2]|0;if((v|0)!=(i+48|0))wL(v);if(d){d=f[D>>2]|0;if((d|0)>0){v=f[(f[a+44>>2]|0)+(d+-1<<2)>>2]|0;f[i>>2]=v;if(v>>>0<33){I=v;J=d;K=58}else{L=d;M=171}}else{N=0;O=d;K=56}}else{N=675553809>>>(f[a>>2]<<2&28)&15;O=f[D>>2]|0;K=56}if((K|0)==56){f[i>>2]=N;I=N;J=O;K=58}if((K|0)==58){O=f[36528+(I<<2)>>2]|0;L=J;M=(O|0)==0?171:O}if((L|0)<3){f[j>>2]=f[a>>2];O=j+4|0;f[O>>2]=L;L=j+8|0;f[L>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];J=j+16|0;f[J>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];I=j+36|0;N=f[a+36>>2]|0;f[I>>2]=N;d=j+40|0;f[d>>2]=L;L=j+48|0;v=j+44|0;f[v>>2]=L;f[L>>2]=0;f[j+52>>2]=0;do if(!N)K=62;else{t=N+12|0;f[t>>2]=(f[t>>2]|0)+1;if((f[D>>2]|0)<3){K=62;break}f[O>>2]=0;U$(j,a)}while(0);if((K|0)==62){K=f[a+44>>2]|0;D=f[v>>2]|0;f[D>>2]=f[K>>2];f[D+4>>2]=f[K+4>>2]}n0(k,j,h,g,o);K=f[J>>2]|0;D=f[L>>2]|0;N=f[w>>2]|0;t=f[g+48>>2]|0;H=f[s>>2]|0;q=f[A>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];wi[M&255](K,D,N,t,H,q,l,i);l=f[I>>2]|0;do if(l|0){q=l+12|0;H=f[q>>2]|0;f[q>>2]=H+-1;if((H|0)!=1)break;V$(j)}while(0);f[I>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[O>>2]|0)>0){J=f[d>>2]|0;d=0;do{f[J+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[O>>2]|0))}O=f[v>>2]|0;if((O|0)!=(L|0))wL(O)}else{f[j>>2]=a;f[j+4>>2]=h;f[j+8>>2]=g;f[j+12>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;BL(m,j,k,-1);j=Y(f[m+20>>2]|0,o)|0;o=m+16|0;O=k+8|0;L=k+4|0;v=n+4|0;d=0;while(1){if(d>>>0>=(f[o>>2]|0)>>>0)break;J=f[k>>2]|0;I=f[O>>2]|0;l=f[L>>2]|0;f[n>>2]=j;f[v>>2]=1;wi[M&255](J,0,I,0,l,0,n,i);CL(m)|0;d=d+1|0}}d=f[y>>2]|0;do if(d|0){m=d+12|0;i=f[m>>2]|0;f[m>>2]=i+-1;if((i|0)!=1)break;V$(h)}while(0);f[y>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[z>>2]|0)>0){s=f[x>>2]|0;x=0;do{f[s+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[z>>2]|0))}z=f[C>>2]|0;if((z|0)!=(A|0))wL(z)}else jR(a,c);c=g+36|0;a=f[c>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)V$(g);f[c>>2]=0;c=g+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[c>>2]|0)>0){w=f[g+40>>2]|0;a=0;do{f[w+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)==(g+48|0)){u=e;return}wL(c);u=e;return}function lR(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+160|0;e=d+148|0;g=d+144|0;h=d+112|0;i=d;j=d+96|0;k=a+16|0;if(!(f[k>>2]|0)){u=d;return a|0}l=a+4|0;m=f[l>>2]|0;if((m|0)<3)n=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{o=f[a+40>>2]|0;p=0;q=1;while(1){r=Y(f[o+(p<<2)>>2]|0,q)|0;p=p+1|0;if((p|0)==(m|0)){n=r;break}else q=r}}if((m|0)==0|(n|0)==0){u=d;return a|0}f[e>>2]=a;BL(h,e,g,1);e=f[l>>2]|0;if((e|0)>0)s=f[(f[a+44>>2]|0)+(e+-1<<2)>>2]|0;else s=0;e=Y(s,f[h+20>>2]|0)|0;s=c;if((((f[s>>2]|0)==0&(f[s+4>>2]|0)==0?(s=c+8|0,(f[s>>2]|0)==0&(f[s+4>>2]|0)==0):0)?(s=c+16|0,(f[s>>2]|0)==0&(f[s+4>>2]|0)==0):0)?(s=c+24|0,(f[s>>2]|0)==0&(f[s+4>>2]|0)==0):0){s=h+16|0;if(f[s>>2]|0){l=0;do{g1c(f[g>>2]|0,0,e|0)|0;l=l+1|0;CL(h)|0}while(l>>>0<(f[s>>2]|0)>>>0)}}else t=15;if((t|0)==15?(t=h+16|0,f[t>>2]|0):0){q3(c,i,f[a>>2]&4095,12);c=(675553809>>>(f[a>>2]<<2&28)&15)*12|0;a:do if(e|0){s=0;while(1){l=e-s|0;n=c>>>0>l>>>0?l:c;if(n>>>0>=97)break;o1c((f[g>>2]|0)+s|0,i|0,n|0)|0;s=s+c|0;if(e>>>0<=s>>>0)break a}s=$Xc(32)|0;f[j>>2]=s;f[j+8>>2]=-2147483616;f[j+4>>2]=20;n=s;l=229629;m=n+20|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(m|0));b[s+20>>0]=0;vM(-215,j,528381,229399,446)}while(0);if((f[t>>2]|0)>>>0>1){j=1;do{CL(h)|0;o1c(f[g>>2]|0,f[k>>2]|0,e|0)|0;j=j+1|0}while(j>>>0<(f[t>>2]|0)>>>0)}}u=d;return a|0}function mR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=u;u=u+1232|0;g=e+1168|0;h=e+1112|0;i=e+1100|0;j=e+1088|0;k=e;l=e+1048|0;m=e+8|0;n=e+1080|0;if(!(f[a+16>>2]|0)){u=e;return a|0}o=a+4|0;p=f[o>>2]|0;if((p|0)<3)q=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{r=f[a+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(p|0)){q=v;break}else t=v}}if((p|0)==0|(q|0)==0){u=e;return a|0}do if((eS(c)|0)==65536){q=f[c+4>>2]|0;f[g>>2]=f[q>>2];p=g+4|0;t=q+4|0;f[p>>2]=f[t>>2];s=g+8|0;f[s>>2]=f[q+8>>2];f[g+12>>2]=f[q+12>>2];f[g+16>>2]=f[q+16>>2];f[g+20>>2]=f[q+20>>2];f[g+24>>2]=f[q+24>>2];f[g+28>>2]=f[q+28>>2];f[g+32>>2]=f[q+32>>2];r=f[q+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=s;s=g+48|0;v=g+44|0;f[v>>2]=s;f[s>>2]=0;f[g+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[t>>2]|0)<3){t=f[q+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];break}else{f[p>>2]=0;U$(g,q);break}}else bS(g,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];q=h+4|0;p=c+4|0;f[q>>2]=f[p>>2];t=h+8|0;f[t>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];s=f[c+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=t;t=h+48|0;v=h+44|0;f[v>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[p>>2]|0)<3){p=f[c+44>>2]|0;t=f[v>>2]|0;f[t>>2]=f[p>>2];f[t+4>>2]=f[p+4>>2];break}else{f[q>>2]=0;U$(h,c);break}}else bS(h,d,-1);while(0);d=f[a>>2]|0;c=g+4|0;if((f[c>>2]|0)>2){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(64)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483584;y=i+4|0;f[y>>2]=60;z=w;A=229650;B=z+60|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+60|0;b[C>>0]=0;vM(-215,i,233087,229399,528)}q=f[g>>2]|0;if(!(q&16384)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(64)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483584;y=i+4|0;f[y>>2]=60;z=w;A=229650;B=z+60|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+60|0;b[C>>0]=0;vM(-215,i,233087,229399,528)}p=g+40|0;t=f[p>>2]|0;v=f[t+4>>2]|0;s=f[t>>2]|0;t=(v|0)==1;r=(s|0)==1;if(!(t|r)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(64)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483584;y=i+4|0;f[y>>2]=60;z=w;A=229650;B=z+60|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+60|0;b[C>>0]=0;vM(-215,i,233087,229399,528)}D=(d>>>3&511)+1|0;if(!((v|0)==(D|0)&r|t&(r|(s|0)==(D|0)))?D>>>0>4|(q&4095|0)!=6|t&(s|0)==4^1:0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(64)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483584;y=i+4|0;f[y>>2]=60;z=w;A=229650;B=z+60|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+60|0;b[C>>0]=0;vM(-215,i,233087,229399,528)}C=f[a>>2]|0;w=C>>>3&511;y=f[h>>2]|0;x=y>>>3&511;s=x+1|0;t=h+16|0;q=(f[t>>2]|0)==0;a:do if(!q){D=f[h+4>>2]|0;if((D|0)<3)E=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{r=f[h+40>>2]|0;v=0;d=1;while(1){F=Y(f[r+(v<<2)>>2]|0,d)|0;v=v+1|0;if((v|0)==(D|0)){E=F;break}else d=F}}if(!((D|0)==0|(E|0)==0)){b:do if(((y&7|0)==0?(x|0)==0|(x|0)==(w|0):0)?(d=f[a+40>>2]|0,v=f[d+-4>>2]|0,r=f[h+40>>2]|0,(v|0)==(f[r+-4>>2]|0)):0){if((v|0)==2){if((f[d>>2]|0)!=(f[r>>2]|0))break;if((f[d+4>>2]|0)==(f[r+4>>2]|0))break a;else break}if((v|0)>0)G=0;else break a;while(1){if((f[d+(G<<2)>>2]|0)!=(f[r+(G<<2)>>2]|0))break b;G=G+1|0;if((G|0)>=(v|0))break a}}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;D=$Xc(96)|0;f[i>>2]=D;f[i+8>>2]=-2147483552;f[i+4>>2]=87;z=D;A=229711;B=z+87|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[D+87>>0]=0;vM(-215,i,233087,229399,530)}}while(0);if(!x){x=f[o>>2]|0;if((x|0)>0){o=f[(f[a+44>>2]|0)+(x+-1<<2)>>2]|0;f[i>>2]=o;if(o>>>0<33){H=o;I=48}else J=171}else{K=0;I=46}}else{K=675553809>>>(C<<2&28)&15;I=46}if((I|0)==46){f[i>>2]=K;H=K;I=48}if((I|0)==48){K=f[36528+(H<<2)>>2]|0;J=(K|0)==0?171:K}f[j>>2]=a;if(!q){q=f[h+4>>2]|0;if((q|0)<3)L=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{K=f[h+40>>2]|0;H=0;C=1;while(1){o=Y(f[K+(H<<2)>>2]|0,C)|0;H=H+1|0;if((H|0)==(q|0)){L=o;break}else C=o}}C=j+4|0;if((q|0)==0|(L|0)==0){M=C;I=56}else{N=h;O=C}}else{M=j+4|0;I=56}if((I|0)==56){N=0;O=M}f[O>>2]=N;f[j+8>>2]=0;N=k;f[N>>2]=0;f[N+4>>2]=0;BL(l,j,k,-1);j=Y(f[l+20>>2]|0,s)|0;N=f[i>>2]|0;O=((N+1023|0)>>>0)/(N>>>0)|0;M=(O|0)<(j|0)?O:j;O=M-((M|0)%(s|0)|0)|0;I=(Y(O,N)|0)+32|0;N=m+8|0;f[m>>2]=N;C=m+4|0;f[C>>2]=I;if(I>>>0>1032){L=bYc(I)|0;f[m>>2]=L;P=L}else P=N;L=P+7&-8;u1(g,f[a>>2]&4095,L,(M|0)/(s|0)|0);s=l+16|0;M=k+4|0;P=n+4|0;c:do if((j|0)>0){I=0;while(1){if(I>>>0>=(f[s>>2]|0)>>>0)break c;q=0;H=f[k>>2]|0;do{K=j-q|0;o=(K|0)<(O|0)?K:O;K=Y(f[i>>2]|0,o)|0;x=f[M>>2]|0;if(!x)o1c(H|0,L|0,K|0)|0;else{f[n>>2]=o;f[P>>2]=1;wi[J&255](L,0,x,0,H,0,n,i);f[M>>2]=(f[M>>2]|0)+o}H=(f[k>>2]|0)+K|0;f[k>>2]=H;q=q+O|0}while((j|0)>(q|0));CL(l)|0;I=I+1|0}}else{I=0;while(1){if(I>>>0>=(f[s>>2]|0)>>>0)break c;CL(l)|0;I=I+1|0}}while(0);l=f[m>>2]|0;if((l|0)!=(N|0)){if(l|0)dYc(l);f[m>>2]=N;f[C>>2]=1032}C=h+36|0;N=f[C>>2]|0;if(N|0?(m=N+12|0,N=f[m>>2]|0,f[m>>2]=N+-1,(N|0)==1):0)V$(h);f[C>>2]=0;C=h+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[C>>2]|0)>0){t=f[h+40>>2]|0;N=0;do{f[t+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)!=(h+48|0))wL(C);C=g+36|0;h=f[C>>2]|0;do if(h|0){N=h+12|0;t=f[N>>2]|0;f[N>>2]=t+-1;if((t|0)!=1)break;V$(g)}while(0);f[C>>2]=0;C=g+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[c>>2]|0)>0){C=f[p>>2]|0;p=0;do{f[C+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))wL(c);u=e;return a|0}function nR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+160|0;g=e+136|0;h=e+72|0;i=e+128|0;j=e+16|0;k=e+8|0;l=e;if((oS(a,-1)|0)>=3){m=$Xc(32)|0;f[g>>2]=m;f[g+8>>2]=-2147483616;f[g+4>>2]=16;n=m;o=235288;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+16>>0]=0;vM(-215,g,229799,229399,747)}cS(g,a,-1);m=f[g>>2]|0;if((d|0)<0)q=(f[g+4>>2]|0)==1?1:(m|0)==1?0:d;else q=d;d=(m|0)==1;if((!((q|0)>0&d)?(m=g+4|0,o=(f[m>>2]|0)==1,!((q|0)==0&o)):0)?(n=(q|0)<0,!(n&d&o)):0){do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[h>>2]=f[o>>2];d=h+4|0;p=o+4|0;f[d>>2]=f[p>>2];r=h+8|0;f[r>>2]=f[o+8>>2];f[h+12>>2]=f[o+12>>2];f[h+16>>2]=f[o+16>>2];f[h+20>>2]=f[o+20>>2];f[h+24>>2]=f[o+24>>2];f[h+28>>2]=f[o+28>>2];f[h+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=r;r=h+48|0;t=h+44|0;f[t>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[p>>2]|0)<3){p=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2];v=h;break}else{f[d>>2]=0;U$(h,o);v=h;break}}else{bS(h,a,-1);v=h}while(0);o=f[v>>2]|0;v=o&4095;f[i>>2]=f[g>>2];f[i+4>>2]=f[m>>2];wS(c,i,v,-1,0,0);do if((eS(c)|0)==65536){i=f[c+4>>2]|0;f[j>>2]=f[i>>2];m=j+4|0;g=i+4|0;f[m>>2]=f[g>>2];d=j+8|0;f[d>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];p=j+16|0;f[p>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];r=f[i+36>>2]|0;f[j+36>>2]=r;f[j+40>>2]=d;d=j+48|0;t=j+44|0;f[t>>2]=d;f[d>>2]=0;f[j+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[g>>2]|0)<3){g=f[i+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[g>>2];f[s+4>>2]=f[g+4>>2];w=p;x=t;y=d;break}else{f[m>>2]=0;U$(j,i);w=p;x=t;y=d;break}}else{bS(j,c,-1);w=j+16|0;x=j+44|0;y=j+48|0}while(0);d=Y(675553809>>>(v<<2&28)&15,(o>>>3&511)+1|0)|0;o=h+16|0;v=f[o>>2]|0;t=h+44|0;p=h+48|0;i=f[p>>2]|0;m=f[w>>2]|0;g=f[y>>2]|0;s=h+40|0;r=f[s>>2]|0;z=f[r+4>>2]|0;A=f[r>>2]|0;a:do if((q|0)<1){r=A+-1|0;B=Y(z,d)|0;if((A|0)>0){C=m+(Y(r,g)|0)|0;D=v+(Y(r,i)|0)|0;r=0-i|0;E=0-g|0;F=B+-4|0;G=B+-16|0;H=(A+1|0)/2|0;if((B|0)<16){I=B&-4;J=(B|0)<4;K=D;L=C;M=0;N=v;O=m;while(1){if(((O|N|K|L)&3|0)!=0|J)P=0;else{Q=0;do{R=f[N+Q>>2]|0;f[O+Q>>2]=f[K+Q>>2];f[L+Q>>2]=R;Q=Q+4|0}while((Q|0)<=(F|0));P=I}if((P|0)<(B|0)){Q=P;do{R=b[N+Q>>0]|0;b[O+Q>>0]=b[K+Q>>0]|0;b[L+Q>>0]=R;Q=Q+1|0}while((Q|0)!=(B|0))}M=M+1|0;if((M|0)>=(H|0))break a;else{K=K+r|0;L=L+E|0;N=N+i|0;O=O+g|0}}}O=B&-16;N=(O|0)>(F|0);L=D;K=C;M=0;I=v;J=m;while(1){if(!((J|I|L|K)&3)){Q=0;do{R=I+Q|0;S=f[R>>2]|0;T=L+Q|0;U=J+Q|0;f[U>>2]=f[T>>2];V=K+Q|0;f[V>>2]=S;S=f[R+4>>2]|0;f[U+4>>2]=f[T+4>>2];f[V+4>>2]=S;S=f[R+8>>2]|0;f[U+8>>2]=f[T+8>>2];f[V+8>>2]=S;S=f[R+12>>2]|0;f[U+12>>2]=f[T+12>>2];f[V+12>>2]=S;Q=Q+16|0}while((Q|0)<=(G|0));if(N)W=O;else{Q=O;while(1){S=f[I+Q>>2]|0;f[J+Q>>2]=f[L+Q>>2];f[K+Q>>2]=S;S=Q+4|0;if((S|0)>(F|0)){W=S;break}else Q=S}}}else W=0;if((W|0)<(B|0)){Q=W;do{S=b[I+Q>>0]|0;b[J+Q>>0]=b[L+Q>>0]|0;b[K+Q>>0]=S;Q=Q+1|0}while((Q|0)!=(B|0))}M=M+1|0;if((M|0)>=(H|0))break;else{L=L+r|0;K=K+E|0;I=I+i|0;J=J+g|0}}}}else{f[k>>2]=z;f[k+4>>2]=A;oR(v,i,m,g,k,d)}while(0);if(n){n=f[w>>2]|0;k=f[y>>2]|0;g=f[j+40>>2]|0;m=f[g>>2]|0;f[l>>2]=f[g+4>>2];f[l+4>>2]=m;oR(n,k,n,k,l,d)}d=j+36|0;l=f[d>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)V$(j);f[d>>2]=0;d=j+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){w=f[j+40>>2]|0;j=0;do{f[w+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[d>>2]|0))}d=f[x>>2]|0;if((d|0)!=(y|0))wL(d);d=h+36|0;y=f[d>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)V$(h);f[d>>2]=0;d=h+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[d>>2]|0)>0){o=f[s>>2]|0;s=0;do{f[o+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[d>>2]|0))}d=f[t>>2]|0;if((d|0)!=(p|0))wL(d);u=e;return}uS(a,c);u=e;return}function oR(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+1072|0;j=i;k=f[g>>2]|0;l=Y((k+1|0)/2|0,h)|0;m=Y(k,h)|0;n=j+8|0;f[j>>2]=n;o=j+4|0;f[o>>2]=m;if(m>>>0>264){p=bYc(m>>>0>1073741823?-1:m<<2)|0;f[j>>2]=p;q=p}else q=n;a:do if((k|0)>0){if(!h){p=0;while(1){p=p+1|0;if((p|0)>=(k|0))break a}}p=f[g>>2]|0;m=(h|0)==1;r=0;s=k;while(1){t=~r;v=Y(r,h)|0;w=Y(s+t|0,h)|0;f[q+(v<<2)>>2]=w;if(!m){w=Y((f[g>>2]|0)+t|0,h)|0;t=1;do{f[q+(t+v<<2)>>2]=w+t;t=t+1|0}while((t|0)!=(h|0))}t=r+1|0;if((t|0)<(p|0)){r=t;s=p}else break}}while(0);h=g+4|0;g=f[h>>2]|0;k=g+-1|0;f[h>>2]=k;do if(!g)x=q;else{if((l|0)>0){y=d;z=a}else{p=k;do{s=p;p=p+-1|0}while((s|0)!=0);f[h>>2]=p;x=q;break}while(1){s=0;do{r=f[q+(s<<2)>>2]|0;m=b[z+s>>0]|0;b[y+s>>0]=b[z+r>>0]|0;b[y+r>>0]=m;s=s+1|0}while((s|0)!=(l|0));s=f[h>>2]|0;f[h>>2]=s+-1;if(!s)break;else{y=y+e|0;z=z+c|0}}x=f[j>>2]|0}while(0);if((x|0)==(n|0)){u=i;return}if(x|0)dYc(x);f[j>>2]=n;f[o>>2]=264;u=i;return}function pR(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;k=a+4|0;l=e+4|0;if((f[k>>2]|0)==(f[l>>2]|0)){m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=30;n=m;o=229804;p=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+30>>0]=0;vM(-215,h,229835,229399,867)}if((oS(a,-1)|0)>=3){m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=16;n=m;o=235288;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+16>>0]=0;vM(-215,h,229835,229399,868)}if(!((c|0)>0&(d|0)>0)){m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=16;n=m;o=229842;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+16>>0]=0;vM(-215,h,229835,229399,869)}cS(h,a,-1);m=h+4|0;o=Y(f[m>>2]|0,c)|0;c=Y(f[h>>2]|0,d)|0;ZS(e,o,c,dS(a,-1)|0,-1,0,0);do if((eS(a)|0)==65536){c=f[k>>2]|0;f[i>>2]=f[c>>2];o=i+4|0;d=c+4|0;f[o>>2]=f[d>>2];n=i+8|0;f[n>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];p=f[c+36>>2]|0;f[i+36>>2]=p;f[i+40>>2]=n;n=i+48|0;q=i+44|0;f[q>>2]=n;f[n>>2]=0;f[i+52>>2]=0;if(p|0){n=p+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[d>>2]|0)<3){d=f[c+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];break}else{f[o>>2]=0;U$(i,c);break}}else bS(i,a,-1);while(0);do if((eS(e)|0)==65536){a=f[l>>2]|0;f[j>>2]=f[a>>2];k=j+4|0;c=a+4|0;f[k>>2]=f[c>>2];o=j+8|0;f[o>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];d=f[a+36>>2]|0;f[j+36>>2]=d;n=j+40|0;f[n>>2]=o;o=j+48|0;q=j+44|0;f[q>>2]=o;f[o>>2]=0;f[j+52>>2]=0;if(d|0){o=d+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[c>>2]|0)<3){c=f[a+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[c>>2];f[o+4>>2]=f[c+4>>2];r=n;break}else{f[k>>2]=0;U$(j,a);r=n;break}}else{bS(j,e,-1);r=j+40|0}while(0);e=f[r>>2]|0;l=f[e+4>>2]|0;n=f[e>>2]|0;e=i+4|0;a=f[e>>2]|0;if((a|0)>0)s=f[(f[i+44>>2]|0)+(a+-1<<2)>>2]|0;else s=0;a=Y(f[h>>2]|0,s)|0;f[h>>2]=a;k=Y(s,l)|0;l=f[m>>2]|0;a:do if((l|0)>0){s=j+16|0;c=j+44|0;o=i+16|0;q=i+44|0;if((k|0)>0){t=0;v=a}else{d=0;while(1){p=d+1|0;if((p|0)<(l|0))d=p;else{w=p;x=l;break a}}}while(1){d=0;p=v;do{y=(f[s>>2]|0)+(Y(f[f[c>>2]>>2]|0,t)|0)+d|0;o1c(y|0,(f[o>>2]|0)+(Y(f[f[q>>2]>>2]|0,t)|0)|0,p|0)|0;p=f[h>>2]|0;d=p+d|0}while((d|0)<(k|0));d=t+1|0;y=f[m>>2]|0;if((d|0)<(y|0)){t=d;v=p}else{w=d;x=y;break}}}else{w=0;x=l}while(0);if((w|0)<(n|0)?(l=j+16|0,v=j+44|0,t=f[l>>2]|0,h=f[f[v>>2]>>2]|0,o1c(t+(Y(h,w)|0)|0,t+(Y(w-x|0,h)|0)|0,k|0)|0,h=w+1|0,(h|0)!=(n|0)):0){w=h;do{h=f[l>>2]|0;x=f[f[v>>2]>>2]|0;o1c(h+(Y(x,w)|0)|0,h+(Y(w-(f[m>>2]|0)|0,x)|0)|0,k|0)|0;w=w+1|0}while((w|0)!=(n|0))}n=j+36|0;w=f[n>>2]|0;if(w|0?(k=w+12|0,w=f[k>>2]|0,f[k>>2]=w+-1,(w|0)==1):0)V$(j);f[n>>2]=0;n=j+16|0;w=j+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[w>>2]|0)>0){n=f[r>>2]|0;r=0;do{f[n+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)!=(j+48|0))wL(w);w=i+36|0;j=f[w>>2]|0;if(j|0?(r=j+12|0,j=f[r>>2]|0,f[r>>2]=j+-1,(j|0)==1):0)V$(i);f[w>>2]=0;w=i+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[e>>2]|0)>0){w=f[i+40>>2]|0;j=0;do{f[w+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[i+44>>2]|0;if((e|0)==(i+48|0)){u=g;return}wL(e);u=g;return}function qR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if(a>>>0<c>>>0){h=a;u=e;return h|0}switch(d|0){case 1:{h=(a|0)<0?0:c+-1|0;u=e;return h|0}case 2:case 4:{i=(d|0)==4;d=i&1;if((c|0)==1){h=0;u=e;return h|0}j=(c<<1)+-1+(i<<31>>31)|0;i=a;while(1){k=(i|0)<0?d+~i|0:j-i|0;if(k>>>0<c>>>0){h=k;break}else i=k}u=e;return h|0}case 3:{if((c|0)<=0){f[g+8>>2]=0;b[g+11>>0]=7;b[g>>0]=b[229859]|0;b[g+1>>0]=b[229860]|0;b[g+2>>0]=b[229861]|0;b[g+3>>0]=b[229862]|0;b[g+4>>0]=b[229863]|0;b[g+5>>0]=b[229864]|0;b[g+6>>0]=b[229865]|0;b[g+7>>0]=0;vM(-215,g,229867,229399,941)}i=a-c|0;if((a|0)<0)l=~i+a+((i+1|0)%(c|0)|0)|0;else l=a;if((l|0)<(c|0)){h=l;u=e;return h|0}h=(l|0)%(c|0)|0;u=e;return h|0}case 0:{h=-1;u=e;return h|0}default:{h=$Xc(32)|0;f[g>>2]=h;f[g+8>>2]=-2147483616;f[g+4>>2]=31;e=h;c=229885;l=e+31|0;do{b[e>>0]=b[c>>0]|0;e=e+1|0;c=c+1|0}while((e|0)<(l|0));b[h+31>>0]=0;vM(-5,g,229867,229399,950)}}return 0}function rR(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;k=u;u=u+2272|0;l=k+1208|0;m=k+1152|0;n=k+1096|0;o=k;if((e|d|g|h|0)<=-1){q=$Xc(80)|0;f[l>>2]=q;r=l+8|0;f[r>>2]=-2147483568;s=l+4|0;f[s>>2]=70;t=q;v=229917;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+70|0;b[x>>0]=0;vM(-215,l,229988,229399,1186)}if((oS(a,-1)|0)>=3){q=$Xc(80)|0;f[l>>2]=q;r=l+8|0;f[r>>2]=-2147483568;s=l+4|0;f[s>>2]=70;t=q;v=229917;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+70|0;b[x>>0]=0;vM(-215,l,229988,229399,1186)}do if((eS(a)|0)==65536){x=f[a+4>>2]|0;f[m>>2]=f[x>>2];q=m+4|0;s=x+4|0;f[q>>2]=f[s>>2];r=m+8|0;f[r>>2]=f[x+8>>2];f[m+12>>2]=f[x+12>>2];f[m+16>>2]=f[x+16>>2];f[m+20>>2]=f[x+20>>2];f[m+24>>2]=f[x+24>>2];f[m+28>>2]=f[x+28>>2];f[m+32>>2]=f[x+32>>2];y=f[x+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=r;r=m+48|0;z=m+44|0;f[z>>2]=r;f[r>>2]=0;f[m+52>>2]=0;if(y|0){r=y+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[s>>2]|0)<3){s=f[x+44>>2]|0;r=f[z>>2]|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];A=m;break}else{f[q>>2]=0;U$(m,x);A=m;break}}else{bS(m,a,-1);A=m}while(0);a=f[A>>2]|0;if((i&16|0)==0&(a&32768|0)!=0){f[l>>2]=0;x=l+4|0;f[x>>2]=0;f[n>>2]=0;q=n+4|0;f[q>>2]=0;e0(m,l,n);s=f[q>>2]|0;q=(s|0)>(d|0)?d:s;r=m+8|0;z=(f[x>>2]|0)-(f[r>>2]|0)-s|0;s=(z|0)>(e|0)?e:z;z=f[n>>2]|0;x=(z|0)>(g|0)?g:z;y=m+12|0;B=(f[l>>2]|0)-(f[y>>2]|0)-z|0;z=(B|0)>(h|0)?h:B;f0(m,q,s,x,z)|0;C=d-q|0;D=e-s|0;E=g-x|0;F=h-z|0;G=r;H=y}else{C=d;D=e;E=g;F=h;G=m+8|0;H=m+12|0}ZS(c,C+D+(f[G>>2]|0)|0,E+F+(f[H>>2]|0)|0,a&4095,-1,0,0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[n>>2]=f[a>>2];H=n+4|0;G=a+4|0;f[H>>2]=f[G>>2];h=n+8|0;f[h>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];g=f[a+36>>2]|0;f[n+36>>2]=g;f[n+40>>2]=h;h=n+48|0;e=n+44|0;f[e>>2]=h;f[h>>2]=0;f[n+52>>2]=0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[G>>2]|0)<3){G=f[a+44>>2]|0;h=f[e>>2]|0;f[h>>2]=f[G>>2];f[h+4>>2]=f[G+4>>2];break}else{f[H>>2]=0;U$(n,a);break}}else bS(n,c,-1);while(0);do if(E|F|D|C){c=i&-17;if(!c){a=f[A>>2]|0;H=(a>>>3&511)+1|0;G=o+8|0;f[o>>2]=G;h=o+4|0;f[h>>2]=H;if(H>>>0<=136)if(H>>>0>4){I=G;J=88}else{K=H;L=G}else{e=bYc(H<<3)|0;f[o>>2]=e;I=e;J=88}if((J|0)==88){M=+p[j>>3];if(!(M==+p[j+8>>3])){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;N=$Xc(80)|0;f[l>>2]=N;O=l+8|0;f[O>>2]=-2147483568;P=l+4|0;f[P>>2]=68;t=N;v=230003;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Q=N+68|0;b[Q>>0]=0;vM(-215,l,229988,229399,1234)}if(!(M==+p[j+16>>3])){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;N=$Xc(80)|0;f[l>>2]=N;O=l+8|0;f[O>>2]=-2147483568;P=l+4|0;f[P>>2]=68;t=N;v=230003;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Q=N+68|0;b[Q>>0]=0;vM(-215,l,229988,229399,1234)}if(M==+p[j+24>>3]){K=1;L=I}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;N=$Xc(80)|0;f[l>>2]=N;O=l+8|0;f[O>>2]=-2147483568;P=l+4|0;f[P>>2]=68;t=N;v=230003;w=t+68|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Q=N+68|0;b[Q>>0]=0;vM(-215,l,229988,229399,1234)}}q3(j,L,a&7|(K<<3)+-8,H);e=f[m+16>>2]|0;g=f[m+48>>2]|0;d=f[m+40>>2]|0;y=f[d+4>>2]|0;r=f[d>>2]|0;d=f[n+16>>2]|0;z=f[n+48>>2]|0;x=f[n+40>>2]|0;s=f[x+4>>2]|0;q=f[x>>2]|0;x=f[m+4>>2]|0;if((x|0)>0)R=f[(f[m+44>>2]|0)+(x+-1<<2)>>2]|0;else R=0;x=f[o>>2]|0;B=Y(R,s)|0;S=l+8|0;f[l>>2]=S;T=l+4|0;f[T>>2]=B;if(B>>>0>1032){U=bYc(B)|0;f[l>>2]=U;V=U}else V=S;U=s-(y+E)|0;W=q-C-r|0;if((s|0)>0&(R|0)>0){q=0;do{X=Y(q,R)|0;Z=0;do{b[V+(Z+X)>>0]=b[x+Z>>0]|0;Z=Z+1|0}while((Z|0)!=(R|0));q=q+1|0}while((q|0)!=(s|0))}s=Y(R,y)|0;q=Y(R,E)|0;x=Y(R,U)|0;H=d+(Y(z,C)|0)|0;if((r|0)>0){a=0-q|0;Z=e;X=H+q|0;_=0;while(1){if((X|0)!=(Z|0))o1c(X|0,Z|0,s|0)|0;o1c(X+a|0,V|0,q|0)|0;o1c(X+s|0,V|0,x|0)|0;_=_+1|0;if((_|0)==(r|0))break;else{Z=Z+g|0;X=X+z|0}}}if((C|0)>0){X=0;do{o1c(H+(Y(X-C|0,z)|0)|0,V|0,B|0)|0;X=X+1|0}while((X|0)!=(C|0))}if((W|0)>0){X=0;do{o1c(H+(Y(X+r|0,z)|0)|0,V|0,B|0)|0;X=X+1|0}while((X|0)!=(W|0))}W=f[l>>2]|0;if((W|0)!=(S|0)){if(W|0)dYc(W);f[l>>2]=S;f[T>>2]=1032}W=f[o>>2]|0;if((W|0)!=(G|0)){if(W|0)dYc(W);f[o>>2]=G;f[h>>2]=136}break}W=f[m+16>>2]|0;X=f[m+48>>2]|0;B=f[m+40>>2]|0;z=f[B+4>>2]|0;r=f[B>>2]|0;B=f[n+16>>2]|0;H=f[n+48>>2]|0;g=f[n+40>>2]|0;Z=f[g+4>>2]|0;_=f[g>>2]|0;g=f[m+4>>2]|0;if((g|0)>0)$=f[(f[m+44>>2]|0)+(g+-1<<2)>>2]|0;else $=0;g=((W|X|H|B|$)&3|0)==0;x=g?4:1;s=g?($|0)/4|0:$;q=Z-z|0;a=Y(s,q)|0;e=l+8|0;f[l>>2]=e;d=l+4|0;f[d>>2]=a;if(a>>>0>264){U=bYc(a>>>0>1073741823?-1:a<<2)|0;f[l>>2]=U;aa=U}else aa=e;U=q-E|0;q=_-C-r|0;a:do if((E|0)>0){if((s|0)>0)ba=0;else{_=0;while(1){qR(_-E|0,z,c)|0;_=_+1|0;if((_|0)>=(E|0))break a}}do{_=Y(qR(ba-E|0,z,c)|0,s)|0;a=Y(ba,s)|0;y=0;do{f[aa+(y+a<<2)>>2]=y+_;y=y+1|0}while((y|0)!=(s|0));ba=ba+1|0}while((ba|0)<(E|0))}while(0);b:do if((U|0)>0){if((s|0)>0)ca=0;else{h=0;while(1){qR(h+z|0,z,c)|0;h=h+1|0;if((h|0)>=(U|0))break b}}do{h=Y(qR(ca+z|0,z,c)|0,s)|0;G=Y(ca+E|0,s)|0;T=0;do{f[aa+(T+G<<2)>>2]=T+h;T=T+1|0}while((T|0)!=(s|0));ca=ca+1|0}while((ca|0)<(U|0))}while(0);T=Y(s,z)|0;h=Y(s,Z)|0;G=Y(s,E)|0;S=Y(s,U)|0;y=B+(Y(H,C)|0)|0;_=y+(Y(G,x)|0)|0;c:do if((r|0)>0){a=(G|0)>0;da=(S|0)>0;ea=Y(T,x)|0;if(!g){if(a){fa=_;ga=W;ha=0;while(1){if((fa|0)==(ga|0))ia=0;else{o1c(fa|0,ga|0,ea|0)|0;ia=0}do{b[fa+(ia-G)>>0]=b[ga+(f[aa+(ia<<2)>>2]|0)>>0]|0;ia=ia+1|0}while((ia|0)!=(G|0));if(da){ja=0;do{b[fa+(ja+T)>>0]=b[ga+(f[aa+(ja+G<<2)>>2]|0)>>0]|0;ja=ja+1|0}while((ja|0)!=(S|0))}ha=ha+1|0;if((ha|0)==(r|0))break c;else{fa=fa+H|0;ga=ga+X|0}}}if(da){ka=_;la=W;ma=0}else{ga=_;fa=W;ha=0;while(1){if((ga|0)!=(fa|0))o1c(ga|0,fa|0,ea|0)|0;ha=ha+1|0;if((ha|0)==(r|0))break c;else{ga=ga+H|0;fa=fa+X|0}}}while(1){if((ka|0)==(la|0))na=0;else{o1c(ka|0,la|0,ea|0)|0;na=0}do{b[ka+(na+T)>>0]=b[la+(f[aa+(na+G<<2)>>2]|0)>>0]|0;na=na+1|0}while((na|0)!=(S|0));ma=ma+1|0;if((ma|0)==(r|0))break c;else{ka=ka+H|0;la=la+X|0}}}if(a){fa=_;ga=W;ha=0;while(1){if((fa|0)!=(ga|0))o1c(fa|0,ga|0,ea|0)|0;ja=0;do{f[fa+(ja-G<<2)>>2]=f[ga+(f[aa+(ja<<2)>>2]<<2)>>2];ja=ja+1|0}while((ja|0)!=(G|0));if(da){ja=0;do{f[fa+(ja+T<<2)>>2]=f[ga+(f[aa+(ja+G<<2)>>2]<<2)>>2];ja=ja+1|0}while((ja|0)!=(S|0))}ha=ha+1|0;if((ha|0)==(r|0))break c;else{fa=fa+H|0;ga=ga+X|0}}}if(da){oa=_;pa=W;qa=0}else{ga=_;fa=W;ha=0;while(1){if((ga|0)!=(fa|0))o1c(ga|0,fa|0,ea|0)|0;ha=ha+1|0;if((ha|0)==(r|0))break c;else{ga=ga+H|0;fa=fa+X|0}}}while(1){if((oa|0)!=(pa|0))o1c(oa|0,pa|0,ea|0)|0;fa=0;do{f[oa+(fa+T<<2)>>2]=f[pa+(f[aa+(fa+G<<2)>>2]<<2)>>2];fa=fa+1|0}while((fa|0)!=(S|0));qa=qa+1|0;if((qa|0)==(r|0))break;else{oa=oa+H|0;pa=pa+X|0}}}while(0);X=Y(h,x)|0;if((C|0)>0){S=0;do{G=S-C|0;o1c(y+(Y(G,H)|0)|0,y+(Y(qR(G,r,c)|0,H)|0)|0,X|0)|0;S=S+1|0}while((S|0)<(C|0))}if((q|0)>0){S=0;do{x=S+r|0;o1c(y+(Y(x,H)|0)|0,y+(Y(qR(x,r,c)|0,H)|0)|0,X|0)|0;S=S+1|0}while((S|0)<(q|0))}q=f[l>>2]|0;if((q|0)!=(e|0)){if(q|0)dYc(q);f[l>>2]=e;f[d>>2]=264}}else{if((f[m+16>>2]|0)==(f[n+16>>2]|0)?(f[m+48>>2]|0)==(f[n+48>>2]|0):0)break;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;jR(m,l)}while(0);l=n+36|0;C=f[l>>2]|0;if(C|0?(pa=C+12|0,C=f[pa>>2]|0,f[pa>>2]=C+-1,(C|0)==1):0)V$(n);f[l>>2]=0;l=n+16|0;C=n+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[C>>2]|0)>0){l=f[n+40>>2]|0;pa=0;do{f[l+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[C>>2]|0))}C=f[n+44>>2]|0;if((C|0)!=(n+48|0))wL(C);C=m+36|0;n=f[C>>2]|0;if(n|0?(pa=n+12|0,n=f[pa>>2]|0,f[pa>>2]=n+-1,(n|0)==1):0)V$(m);f[C>>2]=0;C=m+16|0;n=m+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[n>>2]|0)>0){C=f[m+40>>2]|0;pa=0;do{f[C+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)==(m+48|0)){u=k;return}wL(n);u=k;return}function sR(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;if(!(b[1161449]|0)){f[135788]=1991057938;f[135789]=0;n[135916]=1.7290404663583558e-09;n[136043]=1.6030947680434338e-09;n[136044]=1.0;n[136171]=2.6696291752159595e-03;e=126;i=3.442619855899;while(1){j=i;i=+M(+(+W(+(.00991256303526217/i+ +V(+(i*(i*-.5)))))*-2.0));f[543152+(e+1<<2)>>2]=~~(i/j*2147483648.0)>>>0;j=+V(+(i*(i*-.5)));n[544176+(e<<2)>>2]=j;n[543664+(e<<2)>>2]=i*4.656612873077393e-10;if((e|0)<=1)break;else e=e+-1|0}b[1161449]=1}if((c|0)>0){k=0;l=g;m=h}else{o=g;p=h;q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}while(1){h=l;g=m;while(1){e=x1c(h|0,0,-130063606,0)|0;u=d1c(e|0,J|0,g|0,0)|0;e=J;v=h&127;i=+n[543664+(v<<2)>>2]*+(h|0);if(((h|0)>-1?h:0-h|0)>>>0<(f[543152+(v<<2)>>2]|0)>>>0){w=i;x=u;y=e;break}if(!v){z=u;A=e;B=9;break}C=x1c(u|0,0,-130063606,0)|0;D=d1c(C|0,J|0,e|0,0)|0;e=J;j=+n[544176+(v<<2)>>2];E=i;if(!(j+ +(u>>>0)*2.3283064365386963e-10*(+n[544176+(v+-1<<2)>>2]-j)<+V(+(E*(E*-.5))))){h=D;g=e}else{w=i;x=D;y=e;break}}if((B|0)==9){while(1){B=0;g=x1c(z|0,0,-130063606,0)|0;e=d1c(g|0,J|0,A|0,0)|0;g=J;D=x1c(e|0,0,-130063606,0)|0;v=z;z=d1c(D|0,J|0,g|0,0)|0;A=J;F=-+W(+(+(v>>>0)*2.3283064365386963e-10+1.1754943508222875e-38))*.2904764;i=+W(+(+(e>>>0)*2.3283064365386963e-10+1.1754943508222875e-38));if(!(-i-i<F*F))break;else B=9}w=(h|0)>0?F+3.442620038986206:-3.442620038986206-F;x=z;y=A}n[a+(k<<2)>>2]=w;k=k+1|0;if((k|0)==(c|0)){o=x;p=y;break}else{l=x;m=y}}q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function tR(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;i=u;u=u+2480|0;j=i+2424|0;k=i+2368|0;l=i+2312|0;m=i+1096|0;o=i+2256|0;q=i+2224|0;r=i+2248|0;t=i+2240|0;v=i+2192|0;w=i;if(sS(c)|0){x=$Xc(16)|0;f[j>>2]=x;f[j+8>>2]=-2147483632;f[j+4>>2]=13;y=x;z=230072;A=y+13|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[x+13>>0]=0;vM(-215,j,388523,230086,394)}do if((eS(c)|0)==65536){x=f[c+4>>2]|0;f[j>>2]=f[x>>2];B=j+4|0;C=x+4|0;f[B>>2]=f[C>>2];D=j+8|0;f[D>>2]=f[x+8>>2];f[j+12>>2]=f[x+12>>2];f[j+16>>2]=f[x+16>>2];f[j+20>>2]=f[x+20>>2];f[j+24>>2]=f[x+24>>2];f[j+28>>2]=f[x+28>>2];f[j+32>>2]=f[x+32>>2];E=f[x+36>>2]|0;f[j+36>>2]=E;f[j+40>>2]=D;D=j+48|0;F=j+44|0;f[F>>2]=D;f[D>>2]=0;f[j+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[x+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;U$(j,x);break}}else bS(j,c,-1);while(0);do if((eS(e)|0)==65536){c=f[e+4>>2]|0;f[k>>2]=f[c>>2];x=k+4|0;B=c+4|0;f[x>>2]=f[B>>2];C=k+8|0;f[C>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];D=f[c+36>>2]|0;f[k+36>>2]=D;f[k+40>>2]=C;C=k+48|0;F=k+44|0;f[F>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[c+44>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[x>>2]=0;U$(k,c);break}}else bS(k,e,-1);while(0);do if((eS(g)|0)==65536){e=f[g+4>>2]|0;f[l>>2]=f[e>>2];c=l+4|0;x=e+4|0;f[c>>2]=f[x>>2];B=l+8|0;f[B>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];f[l+16>>2]=f[e+16>>2];f[l+20>>2]=f[e+20>>2];f[l+24>>2]=f[e+24>>2];f[l+28>>2]=f[e+28>>2];f[l+32>>2]=f[e+32>>2];C=f[e+36>>2]|0;f[l+36>>2]=C;f[l+40>>2]=B;B=l+48|0;F=l+44|0;f[F>>2]=B;f[B>>2]=0;f[l+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[x>>2]|0)<3){x=f[e+44>>2]|0;B=f[F>>2]|0;f[B>>2]=f[x>>2];f[B+4>>2]=f[x+4>>2];break}else{f[c>>2]=0;U$(l,e);break}}else bS(l,g,-1);while(0);g=f[j>>2]|0;e=g&7;c=g>>>3&511;x=c+1|0;B=m+8|0;f[m>>2]=B;F=m+4|0;f[F>>2]=136;C=f[k>>2]|0;if(C&4088|0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;G=$Xc(224)|0;f[o>>2]=G;H=o+8|0;f[H>>2]=-2147483424;I=o+4|0;f[I>>2]=223;o1c(G|0,230152,223)|0;K=G+223|0;b[K>>0]=0;vM(-215,o,388523,230086,407)}D=f[k+8>>2]|0;E=f[k+12>>2]|0;if(!((D|0)==1|(E|0)==1)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;G=$Xc(224)|0;f[o>>2]=G;H=o+8|0;f[H>>2]=-2147483424;I=o+4|0;f[I>>2]=223;o1c(G|0,230152,223)|0;K=G+223|0;b[K>>0]=0;vM(-215,o,388523,230086,407)}L=D+-1+E|0;if(!((L|0)==(x|0)|(L|0)==1)?(L=f[k+40>>2]|0,x>>>0>4|(C&4095|0)!=6|((f[L>>2]|0)!=4?1:(f[L+4>>2]|0)!=1)):0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;G=$Xc(224)|0;f[o>>2]=G;H=o+8|0;f[H>>2]=-2147483424;I=o+4|0;f[I>>2]=223;o1c(G|0,230152,223)|0;K=G+223|0;b[K>>0]=0;vM(-215,o,388523,230086,407)}K=f[l>>2]|0;if(K&4088|0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;M=$Xc(304)|0;f[o>>2]=M;N=o+8|0;f[N>>2]=-2147483344;O=o+4|0;f[O>>2]=295;o1c(M|0,230376,295)|0;P=M+295|0;b[P>>0]=0;vM(-215,o,388523,230086,412)}G=l+8|0;I=f[G>>2]|0;H=f[l+12>>2]|0;if((I|0)!=1)if((H|0)==1){Q=1;R=32}else{S=H;R=35}else{Q=H;R=32}if((R|0)==32){H=I+-1+Q|0;if(!((H|0)==(x|0)|(H|0)==1)){H=f[k+40>>2]|0;if(((f[H>>2]|0)==4?(f[H+4>>2]|0)==1:0)?x>>>0<5&(C&4095|0)==6:0)T=Q;else{S=Q;R=35}}else T=Q}if((R|0)==35){if((I|0)!=(x|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;M=$Xc(304)|0;f[o>>2]=M;N=o+8|0;f[N>>2]=-2147483344;O=o+4|0;f[O>>2]=295;o1c(M|0,230376,295)|0;P=M+295|0;b[P>>0]=0;vM(-215,o,388523,230086,412)}if((d|0)==1&(S|0)==(x|0))T=x;else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;M=$Xc(304)|0;f[o>>2]=M;N=o+8|0;f[N>>2]=-2147483344;O=o+4|0;f[O>>2]=295;o1c(M|0,230376,295)|0;P=M+295|0;b[P>>0]=0;vM(-215,o,388523,230086,412)}}P=k+4|0;M=f[P>>2]|0;if((M|0)<3)U=Y(E,D)|0;else{D=f[k+40>>2]|0;E=0;O=1;while(1){N=Y(f[D+(E<<2)>>2]|0,O)|0;E=E+1|0;if((E|0)==(M|0)){U=N;break}else O=N}}O=l+4|0;M=f[O>>2]|0;if((M|0)<3)V=Y(T,I)|0;else{I=f[l+40>>2]|0;T=0;E=1;while(1){D=Y(f[I+(T<<2)>>2]|0,E)|0;T=T+1|0;if((T|0)==(M|0)){V=D;break}else E=D}}E=(d|0)==0;do if(E){M=U+(x<<3)+V|0;f[F>>2]=M;if(M>>>0>136){T=bYc(M>>>0>536870911?-1:M<<3)|0;f[m>>2]=T;W=T}else W=B;T=f[l+16>>2]|0;if((C&16384|0)!=0?(U|0)==(x|0)&(C&4095|0)==6:0){X=f[k+16>>2]|0;Z=K}else{M=f[k+40>>2]|0;I=f[M+4>>2]|0;D=f[M>>2]|0;f[o>>2]=1124007942;M=o+4|0;f[M>>2]=2;N=o+8|0;f[N>>2]=D;f[o+12>>2]=I;S=o+16|0;f[S>>2]=W;f[o+20>>2]=W;Q=o+24|0;H=o+40|0;L=Q+8|0;f[L>>2]=0;f[L+4>>2]=0;f[H>>2]=N;N=o+48|0;L=o+44|0;f[L>>2]=N;_=I<<3;f[N>>2]=_;f[o+52>>2]=8;I=W+(Y(D,_)|0)|0;f[o+28>>2]=I;f[Q>>2]=I+(0-_)+_;R$(o);_=q+8|0;f[_>>2]=0;f[_+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;dY(k,q,6,1.0,0.0);if((U|0)<=(c|0)){_=U;while(1){p[W+(_<<3)>>3]=+p[W+(_-U<<3)>>3];if((_|0)<(c|0))_=_+1|0;else break}}_=o+36|0;I=f[_>>2]|0;if(I|0?(Q=I+12|0,I=f[Q>>2]|0,f[Q>>2]=I+-1,(I|0)==1):0)V$(o);f[_>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[M>>2]|0)>0){_=f[H>>2]|0;I=0;do{f[_+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[M>>2]|0))}M=f[L>>2]|0;if((M|0)!=(N|0))wL(M);X=W;Z=f[l>>2]|0}if((Z&16384|0)!=0?(V|0)==(x|0)&(Z&4095|0)==6:0)$=T;else{M=f[l+40>>2]|0;I=f[M+4>>2]|0;_=f[M>>2]|0;M=W+(x<<3)|0;f[o>>2]=1124007942;H=o+4|0;f[H>>2]=2;S=o+8|0;f[S>>2]=_;f[o+12>>2]=I;Q=o+16|0;f[Q>>2]=M;f[o+20>>2]=M;D=o+24|0;aa=o+40|0;ba=D+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[aa>>2]=S;S=o+48|0;ba=o+44|0;f[ba>>2]=S;ca=I<<3;f[S>>2]=ca;f[o+52>>2]=8;I=M+(Y(_,ca)|0)|0;f[o+28>>2]=I;f[D>>2]=I+(0-ca)+ca;R$(o);ca=q+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;dY(l,q,6,1.0,0.0);if((V|0)<=(c|0)){ca=V;while(1){p[M+(ca<<3)>>3]=+p[M+(ca-V<<3)>>3];if((ca|0)<(c|0))ca=ca+1|0;else break}}ca=o+36|0;T=f[ca>>2]|0;do if(T|0){N=T+12|0;L=f[N>>2]|0;f[N>>2]=L+-1;if((L|0)!=1)break;V$(o)}while(0);f[ca>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[H>>2]|0)>0){T=f[aa>>2]|0;L=0;do{f[T+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[H>>2]|0))}H=f[ba>>2]|0;if((H|0)!=(S|0))wL(H);$=M}do if(e>>>0>=5){H=(e|0)==6;da=H?5.421010862427522e-20:2.3283064365386963e-10;ea=h?3402823466385288598117041.0e14:1797693134862315708145274.0e284;L=W+(x<<1<<3)|0;if(H){H=0;do{T=$+(H<<3)|0;aa=X+(H<<3)|0;fa=+p[T>>3]-+p[aa>>3];p[L+(H<<4)>>3]=da*(fa<1797693134862315708145274.0e284?fa:1797693134862315708145274.0e284);p[L+(H<<4)+8>>3]=(+p[T>>3]+ +p[aa>>3])*.5;H=H+1|0}while((H|0)!=(x|0));ga=0;ha=0;ia=L;ja=0;ka=0;la=1;ma=0}else{H=0;do{fa=+p[$+(H<<3)>>3];na=+p[X+(H<<3)>>3];oa=fa-na;aa=L+(H<<3)|0;n[aa>>2]=da*(oa<ea?oa:ea);n[aa+4>>2]=(fa+na)*.5;H=H+1|0}while((H|0)!=(x|0));ga=0;ha=0;ia=0;ja=L;ka=0;la=1;ma=0;break}}else{H=W+(x<<1<<3)|0;aa=(e|2|0)==2;T=g&255;Q=(e|0)==3;ea=Q?32768.0:2147483647.0;if(h){ca=aa|(e|0)!=1;da=aa?0.0:Q?-32768.0:-2147483648.0;Q=1;aa=1;N=0;while(1){na=+p[$+(N<<3)>>3];fa=+p[X+(N<<3)>>3];oa=na<fa?na:fa;pa=fa<na?na:fa;a:do if(ca){fa=oa<da?da:oa;switch(T&7){case 0:{qa=fa;ra=256.0;break a;break}case 1:{sa=fa;R=81;break a;break}case 2:{qa=fa;ra=65536.0;break a;break}default:{qa=fa;ra=ea;break a}}}else{sa=oa<-128.0?-128.0:oa;R=81}while(0);if((R|0)==81){R=0;qa=sa;ra=128.0}oa=ra<pa?ra:pa;I=~~qa;D=(+(I|0)<qa&1)+I|0;I=H+(N<<3)|0;_=I+4|0;f[_>>2]=D;ta=~~oa;ua=ta-(+(ta|0)>oa&1)-D|0;D=(ua|0)<1?0:ua+-1|0;f[I>>2]=D;fa=oa-qa;ua=(D+1&D|0)==0;do if(Q<<24>>24!=0&fa<=4294967296.0){ta=ua&1;if(!ua){va=ta;R=86;break}wa=(aa&1)!=0&(D|0)<256&1;xa=ta}else{va=0;R=86}while(0);do if((R|0)==86){R=0;if(fa>2147483647.0)f[I>>2]=2147483647;if(!(qa<-1073741824.0)){wa=aa;xa=va;break}f[_>>2]=-1073741824;wa=aa;xa=va}while(0);N=N+1|0;if((N|0)==(x|0)){ya=xa;za=wa;break}else{Q=xa;aa=wa}}}else{aa=1;Q=1;N=0;while(1){ea=+p[$+(N<<3)>>3];da=+p[X+(N<<3)>>3];fa=ea<da?ea:da;pa=da<ea?ea:da;T=~~fa;ca=(+(T|0)<fa&1)+T|0;T=H+(N<<3)|0;L=T+4|0;f[L>>2]=ca;_=~~pa;I=_-(+(_|0)>pa&1)-ca|0;ca=(I|0)<1?0:I+-1|0;f[T>>2]=ca;da=pa-fa;I=(ca+1&ca|0)==0;do if(aa<<24>>24!=0&da<=4294967296.0){_=I&1;if(!I){Aa=_;R=95;break}Ba=(Q&1)!=0&(ca|0)<256&1;Ca=_}else{Aa=0;R=95}while(0);do if((R|0)==95){R=0;if(da>2147483647.0)f[T>>2]=2147483647;if(!(fa<-1073741824.0)){Ba=Q;Ca=Aa;break}f[L>>2]=-1073741824;Ba=Q;Ca=Aa}while(0);N=N+1|0;if((N|0)==(x|0)){ya=Ca;za=Ba;break}else{aa=Ca;Q=Ba}}}if(!(ya<<24>>24)){Q=H+(x<<3)|0;aa=0;do{N=H+(aa<<3)|0;f[Q+(aa*20|0)+16>>2]=f[N+4>>2];L=(f[N>>2]|0)+1|0;f[Q+(aa*20|0)>>2]=L;N=0;while(1){Da=u1c(1,0,N|0)|0;Ea=J;if(Ea>>>0<0|(Ea|0)==0&Da>>>0<L>>>0)N=N+1|0;else break}T=c1c(Da|0,Ea|0,L|0,0)|0;ca=n1c(0,T|0,L|0,0)|0;f[Q+(aa*20|0)+4>>2]=ca+1;f[Q+(aa*20|0)+8>>2]=(N|0)<1?N:1;ca=N+-1|0;f[Q+(aa*20|0)+12>>2]=(ca|0)>0?ca:0;aa=aa+1|0}while((aa|0)!=(x|0));Fa=Q}else Fa=0;ga=H;ha=ya;ia=0;ja=0;ka=Fa;la=za;ma=ya&255}while(0);M=f[36688+(ma<<5)+(e<<2)>>2]|0;if(!M){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=9;y=o;z=264557;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[o+9>>0]=0;vM(-215,o,388523,230086,536)}else{Ga=0;Ha=0;Ia=M;Ja=ga;Ka=0;La=0;Ma=(ha&1)!=0;Na=ia;Oa=ja;Pa=ka;Qa=(la&1)!=0;break}}else{if((d|0)!=1){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;S=$Xc(32)|0;f[o>>2]=S;f[o+8>>2]=-2147483616;f[o+4>>2]=25;y=S;z=230687;A=y+25|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[S+25>>0]=0;vM(-5,o,388523,230086,577)}M=(U|0)<=(c|0);ba=M?x:U;Q=(V|0)<=(c|0);aa=(Q?x:V)+ba|0;f[F>>2]=aa;if(aa>>>0>136){ca=bYc(aa>>>0>536870911?-1:aa<<3)|0;f[m>>2]=ca;Ra=ca}else Ra=B;ca=(e|0)==6?6:5;aa=675553809>>>(ca<<2)&15;if((C&16384|0)!=0?!(M|(C&4095|0)!=(ca|0)):0)Sa=f[k+16>>2]|0;else{T=f[k+40>>2]|0;I=f[T>>2]|0;f[r>>2]=f[T+4>>2];f[r+4>>2]=I;cM(o,r,ca,Ra,0);I=q+8|0;f[I>>2]=0;f[I+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;dY(k,q,ca,1.0,0.0);I=o+36|0;T=f[I>>2]|0;if(T|0?(_=T+12|0,T=f[_>>2]|0,f[_>>2]=T+-1,(T|0)==1):0)V$(o);f[I>>2]=0;I=o+16|0;T=o+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[T>>2]|0)>0){I=f[o+40>>2]|0;_=0;do{f[I+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[T>>2]|0))}T=f[o+44>>2]|0;if((T|0)!=(o+48|0))wL(T);Sa=Ra}if(M?(T=Y(U,aa)|0,_=Y(aa,x)|0,(T|0)<(_|0)):0){I=T;do{b[Sa+I>>0]=b[Sa+(I-T)>>0]|0;I=I+1|0}while((I|0)!=(_|0))}_=f[l>>2]|0;if((_&16384|0)!=0?!(Q|(_&4095|0)!=(ca|0)):0)Ta=f[l+16>>2]|0;else{_=f[l+40>>2]|0;I=f[_>>2]|0;f[t>>2]=f[_+4>>2];f[t+4>>2]=I;I=Ra+(ba<<3)|0;cM(o,t,ca,I,0);_=q+8|0;f[_>>2]=0;f[_+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;dY(l,q,ca,1.0,0.0);_=o+36|0;T=f[_>>2]|0;do if(T|0){M=T+12|0;S=f[M>>2]|0;f[M>>2]=S+-1;if((S|0)!=1)break;V$(o)}while(0);f[_>>2]=0;T=o+16|0;ca=o+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[ca>>2]|0)>0){T=f[o+40>>2]|0;ba=0;do{f[T+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[ca>>2]|0))}ca=f[o+44>>2]|0;if((ca|0)!=(o+48|0))wL(ca);Ta=I}do if(Q){ca=Y(V,aa)|0;ba=Y(aa,x)|0;if((ca|0)<(ba|0))Ua=ca;else break;do{b[Ta+Ua>>0]=b[Ta+(Ua-ca)>>0]|0;Ua=Ua+1|0}while((Ua|0)!=(ba|0))}while(0);if((e|0)==7){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;aa=$Xc(16)|0;f[o>>2]=aa;f[o+8>>2]=-2147483632;f[o+4>>2]=14;y=aa;z=230672;A=y+14|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[aa+14>>0]=0;vM(-215,o,388523,230086,574)}else{Ga=f[36752+(e<<2)>>2]|0;Ha=(f[G>>2]|0)==(x|0)?(f[l+12>>2]|0)==(x|0):0;Ia=0;Ja=0;Ka=Ta;La=Sa;Ma=0;Na=0;Oa=0;Pa=0;Qa=1;break}}while(0);f[o>>2]=j;f[o+4>>2]=0;BL(v,o,q,1);o=f[v+20>>2]|0;Sa=((c|1024)>>>0)/(x>>>0)|0;c=(o|0)<(Sa|0)?o:Sa;Sa=j+4|0;Ta=f[Sa>>2]|0;if((Ta|0)>0)Va=f[(f[j+44>>2]|0)+(Ta+-1<<2)>>2]|0;else Va=0;Ta=w+8|0;f[w>>2]=Ta;G=w+4|0;f[G>>2]=136;z=Y(c,x)|0;b:do if(!E){y=(z+1|0)/2|0;f[G>>2]=y;if(y>>>0>136){A=bYc(y>>>0>536870911?-1:y<<3)|0;f[w>>2]=A;Wa=A;Xa=0;Ya=0}else{Wa=Ta;Xa=0;Ya=0}}else{A=z<<2;f[G>>2]=A;if(A>>>0>136){y=bYc(A>>>0>536870911?-1:A<<3)|0;f[w>>2]=y;Za=y}else Za=Ta;if(e>>>0<5)if(Ma){if((z|0)>0)_a=0;else{Wa=0;Xa=Za;Ya=0;break}while(1){y=0;do{A=Ja+(y<<3)|0;Ua=Za+(y+_a<<3)|0;f[s>>2]=f[A>>2];f[s+4>>2]=f[A+4>>2];p[s>>3]=+p[s>>3];f[Ua>>2]=f[s>>2];f[Ua+4>>2]=f[s+4>>2];y=y+1|0}while((y|0)!=(x|0));_a=_a+x|0;if((_a|0)>=(z|0)){Wa=0;Xa=Za;Ya=0;break b}}}else{if((z|0)>0)$a=0;else{Wa=0;Xa=Za;Ya=0;break}while(1){aa=0;do{y=Pa+(aa*20|0)|0;Ua=Za+((aa+$a|0)*20|0)|0;f[Ua>>2]=f[y>>2];f[Ua+4>>2]=f[y+4>>2];f[Ua+8>>2]=f[y+8>>2];f[Ua+12>>2]=f[y+12>>2];f[Ua+16>>2]=f[y+16>>2];aa=aa+1|0}while((aa|0)!=(x|0));$a=$a+x|0;if(($a|0)>=(z|0)){Wa=0;Xa=Za;Ya=0;break b}}}if((e|0)==6){if((z|0)>0)ab=0;else{Wa=0;Xa=Za;Ya=0;break}while(1){aa=0;do{y=Na+(aa<<4)|0;Ua=Za+(aa+ab<<4)|0;f[Ua>>2]=f[y>>2];f[Ua+4>>2]=f[y+4>>2];f[Ua+8>>2]=f[y+8>>2];f[Ua+12>>2]=f[y+12>>2];aa=aa+1|0}while((aa|0)!=(x|0));ab=ab+x|0;if((ab|0)>=(z|0)){Wa=0;Xa=Za;Ya=0;break b}}}if((z|0)>0){aa=0;do{y=0;do{Ua=Oa+(y<<3)|0;A=Za+(y+aa<<3)|0;f[s>>2]=f[Ua>>2];f[s+4>>2]=f[Ua+4>>2];p[s>>3]=+p[s>>3];f[A>>2]=f[s>>2];f[A+4>>2]=f[s+4>>2];y=y+1|0}while((y|0)!=(x|0));aa=aa+x|0}while((aa|0)<(z|0))}Wa=0;Xa=Za;Ya=(e|0)==7?Za+(z<<3)|0:0}while(0);z=v+16|0;c:do if((o|0)>0){Za=0;while(1){if(Za>>>0>=(f[z>>2]|0)>>>0)break c;if(E){e=0;Oa=f[q>>2]|0;do{ab=o-e|0;Na=(c|0)<(ab|0)?c:ab;ab=Y(Na,x)|0;Fh[Ia&255](Oa,ab,a,Xa,Ya,Qa);ab=Y(Na,Va)|0;Oa=(f[q>>2]|0)+ab|0;f[q>>2]=Oa;e=e+c|0}while((o|0)>(e|0))}else{e=0;do{Oa=o-e|0;ab=(c|0)<(Oa|0)?c:Oa;sR(Wa,Y(ab,x)|0,a);Ii[Ga&127](Wa,f[q>>2]|0,ab,x,La,Ka,Ha);Oa=Y(ab,Va)|0;f[q>>2]=(f[q>>2]|0)+Oa;e=e+c|0}while((o|0)>(e|0))}CL(v)|0;Za=Za+1|0}}else{Za=0;while(1){if(Za>>>0>=(f[z>>2]|0)>>>0)break c;CL(v)|0;Za=Za+1|0}}while(0);v=f[w>>2]|0;if((v|0)!=(Ta|0)){if(v|0)dYc(v);f[w>>2]=Ta;f[G>>2]=136}G=f[m>>2]|0;if((G|0)!=(B|0)){if(G|0)dYc(G);f[m>>2]=B;f[F>>2]=136}F=l+36|0;B=f[F>>2]|0;if(B|0?(m=B+12|0,B=f[m>>2]|0,f[m>>2]=B+-1,(B|0)==1):0)V$(l);f[F>>2]=0;F=l+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[O>>2]|0)>0){F=f[l+40>>2]|0;B=0;do{f[F+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[O>>2]|0))}O=f[l+44>>2]|0;if((O|0)!=(l+48|0))wL(O);O=k+36|0;l=f[O>>2]|0;do if(l|0){B=l+12|0;F=f[B>>2]|0;f[B>>2]=F+-1;if((F|0)!=1)break;V$(k)}while(0);f[O>>2]=0;O=k+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[P>>2]|0)>0){O=f[k+40>>2]|0;l=0;do{f[O+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[P>>2]|0))}P=f[k+44>>2]|0;if((P|0)!=(k+48|0))wL(P);P=j+36|0;k=f[P>>2]|0;do if(k|0){l=k+12|0;O=f[l>>2]|0;f[l>>2]=O+-1;if((O|0)!=1)break;V$(j)}while(0);f[P>>2]=0;P=j+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[Sa>>2]|0)>0){P=f[j+40>>2]|0;k=0;do{f[P+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[Sa>>2]|0))}Sa=f[j+44>>2]|0;if((Sa|0)==(j+48|0)){u=i;return}wL(Sa);u=i;return}function uR(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=ALc(m)|0;b[i+h>>0]=o>>>0<256?o:(o|0)>0?255:0;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(d|0))break;else{i=i+e|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{j=ALc(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=j>>>0<256?j:(j|0)>0?255:0;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=a;t=c;u=0}else return;while(1){c=0;do{a=ALc(+n[s+(c<<2)>>2]*+n[g+(c<<2)>>2]+ +n[f+(c<<2)>>2])|0;b[t+c>>0]=a>>>0<256?a:(a|0)>0?255:0;c=c+1|0}while((c|0)!=(e|0));u=u+1|0;if((u|0)==(d|0))break;else{s=s+(e<<2)|0;t=t+e|0}}return}function vR(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=ALc(m)|0;b[i+h>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(d|0))break;else{i=i+e|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{j=ALc(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=a;t=c;u=0}else return;while(1){c=0;do{a=ALc(+n[s+(c<<2)>>2]*+n[g+(c<<2)>>2]+ +n[f+(c<<2)>>2])|0;b[t+c>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;c=c+1|0}while((c|0)!=(e|0));u=u+1|0;if((u|0)==(d|0))break;else{s=s+(e<<2)|0;t=t+e|0}}return}function wR(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=ALc(m)|0;d[i+(h<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(e<<1)|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=ALc(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=ALc(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[f+(b<<2)>>2])|0;d[t+(b<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;b=b+1|0}while((b|0)!=(e|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(e<<2)|0;t=t+(e<<1)|0}}return}function xR(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=ALc(m)|0;d[i+(h<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(e<<1)|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=ALc(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=ALc(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[f+(b<<2)>>2])|0;d[t+(b<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;b=b+1|0}while((b|0)!=(e|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(e<<2)|0;t=t+(e<<1)|0}}return}function yR(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(d|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,d)|0;m=+n[e+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(d|0));o=ALc(m)|0;f[i+(h<<2)>>2]=o;h=h+1|0}while((h|0)!=(d|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(d<<2)|0;j=j+(d<<2)|0}}return}if((d|0)==1){p=+n[e>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=ALc(p+q*+n[a+(r<<2)>>2])|0;f[b+(r<<2)>>2]=j;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=ALc(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[e+(b<<2)>>2])|0;f[t+(b<<2)>>2]=a;b=b+1|0}while((b|0)!=(d|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(d<<2)|0;t=t+(d<<2)|0}}return}function zR(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=a;j=0}else return;while(1){g=0;do{k=Y(g,d)|0;l=+n[e+(g<<2)>>2];m=0;do{l=l+ +n[i+(m<<2)>>2]*+n[f+(m+k<<2)>>2];m=m+1|0}while((m|0)!=(d|0));n[h+(g<<2)>>2]=l;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{h=h+(d<<2)|0;i=i+(d<<2)|0}}return}if((d|0)==1){o=+n[e>>2];p=+n[f>>2];if((c|0)>0)q=0;else return;do{n[b+(q<<2)>>2]=o+p*+n[a+(q<<2)>>2];q=q+1|0}while((q|0)!=(c|0));return}if((c|0)>0&(d|0)>0){r=a;s=b;t=0}else return;while(1){b=0;do{n[s+(b<<2)>>2]=+n[r+(b<<2)>>2]*+n[f+(b<<2)>>2]+ +n[e+(b<<2)>>2];b=b+1|0}while((b|0)!=(d|0));t=t+1|0;if((t|0)==(c|0))break;else{r=r+(d<<2)|0;s=s+(d<<2)|0}}return}function AR(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=a;j=0}else return;while(1){g=0;do{k=Y(g,d)|0;l=+p[e+(g<<3)>>3];m=0;do{l=l+ +n[i+(m<<2)>>2]*+p[f+(m+k<<3)>>3];m=m+1|0}while((m|0)!=(d|0));p[h+(g<<3)>>3]=l;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{h=h+(d<<3)|0;i=i+(d<<2)|0}}return}if((d|0)==1){o=+p[e>>3];q=+p[f>>3];if((c|0)>0)r=0;else return;do{p[b+(r<<3)>>3]=o+q*+n[a+(r<<2)>>2];r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{p[t+(b<<3)>>3]=+n[s+(b<<2)>>2]*+p[f+(b<<3)>>3]+ +p[e+(b<<3)>>3];b=b+1|0}while((b|0)!=(d|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(d<<2)|0;t=t+(d<<3)|0}}return}function BR(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=d;g=f[h>>2]|0;i=f[h+4>>2]|0;if((c|0)>0){j=0;k=g;l=i}else{m=g;n=i;o=d;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}while(1){i=x1c(k|0,0,-130063606,0)|0;g=d1c(i|0,J|0,l|0,0)|0;i=J;x1c(g|0,0,f[e+(j*20|0)+4>>2]|0,0)|0;h=J;s=g-(Y((((g-h|0)>>>(f[e+(j*20|0)+8>>2]|0))+h|0)>>>(f[e+(j*20|0)+12>>2]|0),f[e+(j*20|0)>>2]|0)|0)|0;h=s+(f[e+(j*20|0)+16>>2]|0)|0;b[a+j>>0]=h>>>0<256?h:(h|0)>0?255:0;j=j+1|0;if((j|0)==(c|0)){m=g;n=i;break}else{k=g;l=i}}o=d;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}function CR(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=d;g=f[h>>2]|0;i=f[h+4>>2]|0;if((c|0)>0){j=0;k=g;l=i}else{m=g;n=i;o=d;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}while(1){i=x1c(k|0,0,-130063606,0)|0;g=d1c(i|0,J|0,l|0,0)|0;i=J;x1c(g|0,0,f[e+(j*20|0)+4>>2]|0,0)|0;h=J;s=g-(Y((((g-h|0)>>>(f[e+(j*20|0)+8>>2]|0))+h|0)>>>(f[e+(j*20|0)+12>>2]|0),f[e+(j*20|0)>>2]|0)|0)|0;h=s+(f[e+(j*20|0)+16>>2]|0)|0;b[a+j>>0]=(h+128|0)>>>0<256?h:(h|0)>0?127:128;j=j+1|0;if((j|0)==(c|0)){m=g;n=i;break}else{k=g;l=i}}o=d;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}function DR(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=c;g=f[h>>2]|0;i=f[h+4>>2]|0;if((b|0)>0){j=0;k=g;l=i}else{m=g;n=i;o=c;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}while(1){i=x1c(k|0,0,-130063606,0)|0;g=d1c(i|0,J|0,l|0,0)|0;i=J;x1c(g|0,0,f[e+(j*20|0)+4>>2]|0,0)|0;h=J;s=g-(Y((((g-h|0)>>>(f[e+(j*20|0)+8>>2]|0))+h|0)>>>(f[e+(j*20|0)+12>>2]|0),f[e+(j*20|0)>>2]|0)|0)|0;h=s+(f[e+(j*20|0)+16>>2]|0)|0;d[a+(j<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;j=j+1|0;if((j|0)==(b|0)){m=g;n=i;break}else{k=g;l=i}}o=c;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}function ER(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=c;g=f[h>>2]|0;i=f[h+4>>2]|0;if((b|0)>0){j=0;k=g;l=i}else{m=g;n=i;o=c;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}while(1){i=x1c(k|0,0,-130063606,0)|0;g=d1c(i|0,J|0,l|0,0)|0;i=J;x1c(g|0,0,f[e+(j*20|0)+4>>2]|0,0)|0;h=J;s=g-(Y((((g-h|0)>>>(f[e+(j*20|0)+8>>2]|0))+h|0)>>>(f[e+(j*20|0)+12>>2]|0),f[e+(j*20|0)>>2]|0)|0)|0;h=s+(f[e+(j*20|0)+16>>2]|0)|0;d[a+(j<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;j=j+1|0;if((j|0)==(b|0)){m=g;n=i;break}else{k=g;l=i}}o=c;p=o;f[p>>2]=m;q=o+4|0;r=q;f[r>>2]=n;return}function FR(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=c;e=f[g>>2]|0;h=f[g+4>>2]|0;if((b|0)>0){i=0;j=e;k=h}else{l=e;m=h;n=c;o=n;f[o>>2]=l;p=n+4|0;q=p;f[q>>2]=m;return}while(1){h=x1c(j|0,0,-130063606,0)|0;e=d1c(h|0,J|0,k|0,0)|0;h=J;x1c(e|0,0,f[d+(i*20|0)+4>>2]|0,0)|0;g=J;r=Y((((e-g|0)>>>(f[d+(i*20|0)+8>>2]|0))+g|0)>>>(f[d+(i*20|0)+12>>2]|0),f[d+(i*20|0)>>2]|0)|0;f[a+(i<<2)>>2]=(f[d+(i*20|0)+16>>2]|0)+e-r;i=i+1|0;if((i|0)==(b|0)){l=e;m=h;break}else{j=e;k=h}}n=c;o=n;f[o>>2]=l;p=n+4|0;q=p;f[q>>2]=m;return}function GR(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0;g=c;e=f[g>>2]|0;h=f[g+4>>2]|0;if((b|0)>0){g=0;i=e;j=h;while(1){k=x1c(i|0,0,-130063606,0)|0;l=d1c(k|0,J|0,j|0,0)|0;k=J;n[a+(g<<2)>>2]=+(l|0)*+n[d+(g<<3)>>2];g=g+1|0;if((g|0)==(b|0)){m=l;o=k;break}else{i=l;j=k}}}else{m=e;o=h}h=c;f[h>>2]=m;f[h+4>>2]=o;WW(a,d,b);return}function HR(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=c;e=f[g>>2]|0;h=f[g+4>>2]|0;if((b|0)>0){g=0;i=e;j=h;while(1){k=x1c(i|0,0,-130063606,0)|0;l=d1c(k|0,J|0,j|0,0)|0;k=J;p[a+(g<<3)>>3]=(+(k>>>0)+4294967296.0*+(l|0))*+p[d+(g<<4)>>3];g=g+1|0;if((g|0)==(b|0)){m=l;n=k;break}else{i=l;j=k}}}else{m=e;n=h}h=c;f[h>>2]=m;f[h+4>>2]=n;XW(a,d,b);return}function IR(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;if((b|0)>0){g=0;j=h;k=i;while(1){l=x1c(j|0,0,-130063606,0)|0;m=d1c(l|0,J|0,k|0,0)|0;l=J;n[e+(g<<2)>>2]=+(m|0)*+n[d+(g<<3)>>2];g=g+1|0;if((g|0)==(b|0)){o=m;p=l;break}else{j=m;k=l}}}else{o=h;p=i}i=c;f[i>>2]=o;f[i+4>>2]=p;WW(e,d,b);VW(e,a,b);return}function JR(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;i=f[g>>2]|0;j=f[g+4>>2]|0;g=c+-4|0;k=(c|0)<4;if(h)if(k){l=0;m=i;n=j}else{h=0;o=i;p=j;do{q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(h<<3)>>2])+(f[e+(h<<3)+4>>2]|0)|0;r=h|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+h>>0]=q>>>0<256?q:(q|0)>0?255:0;b[a+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=h|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=h|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;h=h+4|0}while((h|0)<=(g|0));l=c&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=x1c(p|0,0,-130063606,0)|0;o=d1c(j|0,J|0,i|0,0)|0;j=J;h=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=x1c(o|0,0,-130063606,0)|0;o=d1c(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+k>>0]=h>>>0<256?h:(h|0)>0?255:0;b[a+t>>0]=q>>>0<256?q:(q|0)>0?255:0;q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;h=x1c(o|0,0,-130063606,0)|0;p=d1c(h|0,J|0,j|0,0)|0;i=J;j=k|3;h=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;b[a+j>>0]=h>>>0<256?h:(h|0)>0?255:0;k=k+4|0}while((k|0)<=(g|0));l=c&-4;m=p;n=i}if((l|0)<(c|0)){u=l;v=m;w=n}else{x=m;y=n;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=x1c(v|0,0,-130063606,0)|0;m=d1c(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;b[a+u>>0]=l>>>0<256?l:(l|0)>0?255:0;u=u+1|0;if((u|0)==(c|0)){x=m;y=n;break}else{v=m;w=n}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function KR(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;i=f[g>>2]|0;j=f[g+4>>2]|0;g=c+-4|0;k=(c|0)<4;if(h)if(k){l=0;m=i;n=j}else{h=0;o=i;p=j;do{q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(h<<3)>>2])+(f[e+(h<<3)+4>>2]|0)|0;r=h|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+h>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[a+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=h|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=h|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;h=h+4|0}while((h|0)<=(g|0));l=c&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=x1c(p|0,0,-130063606,0)|0;o=d1c(j|0,J|0,i|0,0)|0;j=J;h=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=x1c(o|0,0,-130063606,0)|0;o=d1c(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+k>>0]=(h+128|0)>>>0<256?h:(h|0)>0?127:128;b[a+t>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;h=x1c(o|0,0,-130063606,0)|0;p=d1c(h|0,J|0,j|0,0)|0;i=J;j=k|3;h=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;b[a+j>>0]=(h+128|0)>>>0<256?h:(h|0)>0?127:128;k=k+4|0}while((k|0)<=(g|0));l=c&-4;m=p;n=i}if((l|0)<(c|0)){u=l;v=m;w=n}else{x=m;y=n;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=x1c(v|0,0,-130063606,0)|0;m=d1c(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;b[a+u>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;u=u+1|0;if((u|0)==(c|0)){x=m;y=n;break}else{v=m;w=n}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function LR(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;i=f[g>>2]|0;j=f[g+4>>2]|0;g=b+-4|0;k=(b|0)<4;if(h)if(k){l=0;m=i;n=j}else{h=0;o=i;p=j;do{q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(h<<3)>>2])+(f[e+(h<<3)+4>>2]|0)|0;r=h|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(h<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[a+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=h|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=h|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;h=h+4|0}while((h|0)<=(g|0));l=b&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=x1c(p|0,0,-130063606,0)|0;o=d1c(j|0,J|0,i|0,0)|0;j=J;h=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=x1c(o|0,0,-130063606,0)|0;o=d1c(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(k<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;d[a+(t<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;h=x1c(o|0,0,-130063606,0)|0;p=d1c(h|0,J|0,j|0,0)|0;i=J;j=k|3;h=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[a+(j<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;k=k+4|0}while((k|0)<=(g|0));l=b&-4;m=p;n=i}if((l|0)<(b|0)){u=l;v=m;w=n}else{x=m;y=n;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=x1c(v|0,0,-130063606,0)|0;m=d1c(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;d[a+(u<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;u=u+1|0;if((u|0)==(b|0)){x=m;y=n;break}else{v=m;w=n}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function MR(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;i=f[g>>2]|0;j=f[g+4>>2]|0;g=b+-4|0;k=(b|0)<4;if(h)if(k){l=0;m=i;n=j}else{h=0;o=i;p=j;do{q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(h<<3)>>2])+(f[e+(h<<3)+4>>2]|0)|0;r=h|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(h<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[a+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=h|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=h|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;h=h+4|0}while((h|0)<=(g|0));l=b&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=x1c(p|0,0,-130063606,0)|0;o=d1c(j|0,J|0,i|0,0)|0;j=J;h=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=x1c(o|0,0,-130063606,0)|0;o=d1c(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(k<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;d[a+(t<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;q=x1c(o|0,0,-130063606,0)|0;o=d1c(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;h=x1c(o|0,0,-130063606,0)|0;p=d1c(h|0,J|0,j|0,0)|0;i=J;j=k|3;h=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[a+(j<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;k=k+4|0}while((k|0)<=(g|0));l=b&-4;m=p;n=i}if((l|0)<(b|0)){u=l;v=m;w=n}else{x=m;y=n;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=x1c(v|0,0,-130063606,0)|0;m=d1c(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;d[a+(u<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;u=u+1|0;if((u|0)==(b|0)){x=m;y=n;break}else{v=m;w=n}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function NR(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=c;h=f[e>>2]|0;i=f[e+4>>2]|0;e=b+-4|0;j=(b|0)<4;if(g)if(j){k=0;l=h;m=i}else{g=0;n=h;o=i;do{p=x1c(n|0,0,-130063606,0)|0;n=d1c(p|0,J|0,o|0,0)|0;o=J;p=g|1;q=(n>>8&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;f[a+(g<<2)>>2]=(n&f[d+(g<<3)>>2])+(f[d+(g<<3)+4>>2]|0);f[a+(p<<2)>>2]=q;q=g|2;p=g|3;r=(f[d+(p<<3)>>2]&n>>24)+(f[d+(p<<3)+4>>2]|0)|0;f[a+(q<<2)>>2]=(f[d+(q<<3)>>2]&n>>16)+(f[d+(q<<3)+4>>2]|0);f[a+(p<<2)>>2]=r;g=g+4|0}while((g|0)<=(e|0));k=b&-4;l=n;m=o}else if(j){k=0;l=h;m=i}else{j=0;o=h;h=i;do{i=x1c(o|0,0,-130063606,0)|0;n=d1c(i|0,J|0,h|0,0)|0;i=J;g=(n&f[d+(j<<3)>>2])+(f[d+(j<<3)+4>>2]|0)|0;r=x1c(n|0,0,-130063606,0)|0;n=d1c(r|0,J|0,i|0,0)|0;i=J;r=j|1;p=(n&f[d+(r<<3)>>2])+(f[d+(r<<3)+4>>2]|0)|0;f[a+(j<<2)>>2]=g;f[a+(r<<2)>>2]=p;p=x1c(n|0,0,-130063606,0)|0;n=d1c(p|0,J|0,i|0,0)|0;i=J;p=j|2;r=(n&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;g=x1c(n|0,0,-130063606,0)|0;o=d1c(g|0,J|0,i|0,0)|0;h=J;i=j|3;g=(o&f[d+(i<<3)>>2])+(f[d+(i<<3)+4>>2]|0)|0;f[a+(p<<2)>>2]=r;f[a+(i<<2)>>2]=g;j=j+4|0}while((j|0)<=(e|0));k=b&-4;l=o;m=h}if((k|0)<(b|0)){s=k;t=l;u=m}else{v=l;w=m;x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}while(1){m=x1c(t|0,0,-130063606,0)|0;l=d1c(m|0,J|0,u|0,0)|0;m=J;f[a+(s<<2)>>2]=(l&f[d+(s<<3)>>2])+(f[d+(s<<3)+4>>2]|0);s=s+1|0;if((s|0)==(b|0)){v=l;w=m;break}else{t=l;u=m}}x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}function OR(){return hN(gN()|0)|0}function PR(a){a=a|0;var b=0,c=0;b=(a|0)!=0;c=hN(gN()|0)|0;f[c>>2]=b?a:-1;f[c+4>>2]=b?((a|0)<0)<<31>>31:0;return}function QR(a,b,c){a=a|0;b=b|0;c=c|0;tR(hN(gN()|0)|0,a,0,b,c,0);return}function RR(a,b,c){a=a|0;b=b|0;c=c|0;tR(hN(gN()|0)|0,a,1,b,c,0);return}function SR(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+80|0;g=e+16|0;h=e;do if((eS(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;n=g+44|0;f[n>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;U$(g,i);break}}else bS(g,a,-1);while(0);if(!d)o=hN(gN()|0)|0;else o=d;d=g+4|0;a=f[d>>2]|0;if((a|0)>0){i=f[(f[g+44>>2]|0)+(a+-1<<2)>>2]|0;if(i>>>0<33)p=i;else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=$Xc(32)|0;f[h>>2]=i;f[h+8>>2]=-2147483616;f[h+4>>2]=20;q=i;r=230713;s=q+20|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[i+20>>0]=0;vM(-215,h,230734,230086,747)}}else p=0;i=f[36784+(p<<2)>>2]|0;if(!i){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=9;q=h;r=264557;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[h+9>>0]=0;vM(-215,h,230734,230086,749)}Vi[i&63](g,o,c);o=g+36|0;i=f[o>>2]|0;if(i|0?(h=i+12|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)V$(g);f[o>>2]=0;o=g+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[d>>2]|0)>0){o=f[g+40>>2]|0;i=0;do{f[o+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+44>>2]|0;if((d|0)==(g+48|0)){u=e;return}wL(d);u=e;return}function TR(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=0;do{l=c;k=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,k|0,0)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=m+((l>>>0)%(j>>>0)|0)|0;l=m+h|0;n=b[k>>0]|0;b[k>>0]=b[l>>0]|0;b[l>>0]=n;h=h+1|0}while((h|0)!=(j|0));u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;h=i;m=230746;n=h+14|0;do{b[h>>0]=b[m>>0]|0;h=h+1|0;m=m+1|0}while((h|0)<(n|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=a+16|0;i=f[g>>2]|0;m=a+44|0;h=f[a+48>>2]|0;n=f[a+8>>2]|0;l=f[a+12>>2]|0;if((n|0)<=0){u=e;return}if((l|0)>0){o=0;p=i}else{u=e;return}while(1){a=p+(Y(f[f[m>>2]>>2]|0,o)|0)|0;k=0;do{q=c;r=f[q+4>>2]|0;s=x1c(f[q>>2]|0,0,-130063606,0)|0;q=d1c(s|0,J|0,r|0,0)|0;r=c;f[r>>2]=q;f[r+4>>2]=J;r=(q>>>0)%(j>>>0)|0;q=(r>>>0)/(l>>>0)|0;s=a+k|0;t=i+(Y(q,h)|0)+(r-(Y(q,l)|0))|0;q=b[s>>0]|0;b[s>>0]=b[t>>0]|0;b[t>>0]=q;k=k+1|0}while((k|0)!=(l|0));k=o+1|0;if((k|0)==(n|0))break;o=k;p=f[g>>2]|0}u=e;return}function UR(a,c,e){a=a|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+16|0;h=g;i=f[a+4>>2]|0;j=(i|0)<3;if(j)k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{l=f[a+40>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(i|0)){k=o;break}else n=o}}if(f[a>>2]&16384|0){n=f[a+16>>2]|0;if(!k){u=g;return}i=c;m=0;l=f[i>>2]|0;o=f[i+4>>2]|0;do{i=x1c(l|0,0,-130063606,0)|0;l=d1c(i|0,J|0,o|0,0)|0;o=J;i=n+(((l>>>0)%(k>>>0)|0)<<1)|0;p=n+(m<<1)|0;q=d[i>>1]|0;d[i>>1]=d[p>>1]|0;d[p>>1]=q;m=m+1|0}while((m|0)!=(k|0));m=c;f[m>>2]=l;f[m+4>>2]=o;u=g;return}if(!j){j=$Xc(16)|0;f[h>>2]=j;f[h+8>>2]=-2147483632;f[h+4>>2]=14;o=j;m=230746;l=o+14|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(l|0));b[j+14>>0]=0;vM(-215,h,230761,230086,697)}h=f[a+16>>2]|0;j=f[a+48>>2]|0;m=f[a+8>>2]|0;o=f[a+12>>2]|0;if((m|0)<=0){u=g;return}l=f[f[a+44>>2]>>2]|0;if((o|0)<=0){u=g;return}a=c;n=0;q=f[a>>2]|0;p=f[a+4>>2]|0;while(1){a=h+(Y(l,n)|0)|0;i=0;r=q;s=p;do{t=x1c(r|0,0,-130063606,0)|0;r=d1c(t|0,J|0,s|0,0)|0;s=J;t=(r>>>0)%(k>>>0)|0;v=(t>>>0)/(o>>>0)|0;w=a+(i<<1)|0;x=h+(Y(v,j)|0)+(t-(Y(v,o)|0)<<1)|0;v=d[w>>1]|0;d[w>>1]=d[x>>1]|0;d[x>>1]=v;i=i+1|0}while((i|0)!=(o|0));n=n+1|0;if((n|0)==(m|0))break;else{q=r;p=s}}p=c;f[p>>2]=r;f[p+4>>2]=s;u=g;return}function VR(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=0;do{l=c;k=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,k|0,0)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=(l>>>0)%(j>>>0)|0;l=m+(k*3|0)|0;n=b[l>>0]|0;o=b[m+(k*3|0)+1>>0]|0;p=b[m+(k*3|0)+2>>0]|0;k=m+(h*3|0)|0;b[l>>0]=b[k>>0]|0;b[l+1>>0]=b[k+1>>0]|0;b[l+2>>0]=b[k+2>>0]|0;b[k>>0]=n;b[m+(h*3|0)+1>>0]=o;b[m+(h*3|0)+2>>0]=p;h=h+1|0}while((h|0)!=(j|0));u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;h=i;m=230746;p=h+14|0;do{b[h>>0]=b[m>>0]|0;h=h+1|0;m=m+1|0}while((h|0)<(p|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=a+16|0;i=f[g>>2]|0;m=a+44|0;h=f[a+48>>2]|0;p=f[a+8>>2]|0;o=f[a+12>>2]|0;if((p|0)<=0){u=e;return}if((o|0)>0){q=0;r=i}else{u=e;return}while(1){a=r+(Y(f[f[m>>2]>>2]|0,q)|0)|0;n=0;do{k=c;l=f[k+4>>2]|0;s=x1c(f[k>>2]|0,0,-130063606,0)|0;k=d1c(s|0,J|0,l|0,0)|0;l=c;f[l>>2]=k;f[l+4>>2]=J;l=(k>>>0)%(j>>>0)|0;k=(l>>>0)/(o>>>0)|0;s=l-(Y(k,o)|0)|0;l=i+(Y(k,h)|0)|0;k=a+(n*3|0)|0;t=b[k>>0]|0;v=b[a+(n*3|0)+1>>0]|0;w=b[a+(n*3|0)+2>>0]|0;x=l+(s*3|0)|0;b[k>>0]=b[x>>0]|0;b[k+1>>0]=b[x+1>>0]|0;b[k+2>>0]=b[x+2>>0]|0;b[x>>0]=t;b[l+(s*3|0)+1>>0]=v;b[l+(s*3|0)+2>>0]=w;n=n+1|0}while((n|0)!=(o|0));n=q+1|0;if((n|0)==(p|0))break;q=n;r=f[g>>2]|0}u=e;return}function WR(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=c;l=0;k=f[h>>2]|0;n=f[h+4>>2]|0;do{h=x1c(k|0,0,-130063606,0)|0;k=d1c(h|0,J|0,n|0,0)|0;n=J;h=m+(((k>>>0)%(j>>>0)|0)<<2)|0;o=m+(l<<2)|0;p=f[h>>2]|0;f[h>>2]=f[o>>2];f[o>>2]=p;l=l+1|0}while((l|0)!=(j|0));l=c;f[l>>2]=k;f[l+4>>2]=n;u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;n=i;l=230746;k=n+14|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(k|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=f[a+16>>2]|0;i=f[a+48>>2]|0;l=f[a+8>>2]|0;n=f[a+12>>2]|0;if((l|0)<=0){u=e;return}k=f[a+44>>2]|0;if((n|0)<=0){u=e;return}a=c;m=0;p=f[a>>2]|0;o=f[a+4>>2]|0;while(1){a=g+(Y(f[k>>2]|0,m)|0)|0;h=0;q=p;r=o;do{s=x1c(q|0,0,-130063606,0)|0;q=d1c(s|0,J|0,r|0,0)|0;r=J;s=(q>>>0)%(j>>>0)|0;t=(s>>>0)/(n>>>0)|0;v=a+(h<<2)|0;w=g+(Y(t,i)|0)+(s-(Y(t,n)|0)<<2)|0;t=f[v>>2]|0;f[v>>2]=f[w>>2];f[w>>2]=t;h=h+1|0}while((h|0)!=(n|0));m=m+1|0;if((m|0)==(l|0))break;else{p=q;o=r}}o=c;f[o>>2]=q;f[o+4>>2]=r;u=e;return}function XR(a,c,e){a=a|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g;i=f[a+4>>2]|0;j=(i|0)<3;if(j)k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{l=f[a+40>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(i|0)){k=o;break}else n=o}}if(f[a>>2]&16384|0){n=f[a+16>>2]|0;if(!k){u=g;return}i=0;do{m=c;l=f[m+4>>2]|0;o=x1c(f[m>>2]|0,0,-130063606,0)|0;m=d1c(o|0,J|0,l|0,0)|0;l=c;f[l>>2]=m;f[l+4>>2]=J;l=(m>>>0)%(k>>>0)|0;m=n+(l*6|0)|0;o=n+(i*6|0)|0;p=d[m>>1]|0;q=d[n+(l*6|0)+2>>1]|0;r=d[n+(l*6|0)+4>>1]|0;d[m>>1]=d[o>>1]|0;d[m+2>>1]=d[o+2>>1]|0;d[m+4>>1]=d[o+4>>1]|0;d[o>>1]=p;d[n+(i*6|0)+2>>1]=q;d[n+(i*6|0)+4>>1]=r;i=i+1|0}while((i|0)!=(k|0));u=g;return}if(!j){j=$Xc(16)|0;f[h>>2]=j;f[h+8>>2]=-2147483632;f[h+4>>2]=14;i=j;n=230746;r=i+14|0;do{b[i>>0]=b[n>>0]|0;i=i+1|0;n=n+1|0}while((i|0)<(r|0));b[j+14>>0]=0;vM(-215,h,230761,230086,697)}h=a+16|0;j=f[h>>2]|0;n=a+44|0;i=f[a+48>>2]|0;r=f[a+8>>2]|0;q=f[a+12>>2]|0;if((r|0)<=0){u=g;return}if((q|0)>0){s=0;t=j}else{u=g;return}while(1){a=t+(Y(f[f[n>>2]>>2]|0,s)|0)|0;p=0;do{o=c;m=f[o+4>>2]|0;l=x1c(f[o>>2]|0,0,-130063606,0)|0;o=d1c(l|0,J|0,m|0,0)|0;m=c;f[m>>2]=o;f[m+4>>2]=J;m=(o>>>0)%(k>>>0)|0;o=(m>>>0)/(q>>>0)|0;l=m-(Y(o,q)|0)|0;m=a+(p*6|0)|0;v=j+(Y(o,i)|0)|0;o=v+(l*6|0)|0;w=d[m>>1]|0;x=d[a+(p*6|0)+2>>1]|0;y=d[a+(p*6|0)+4>>1]|0;d[m>>1]=d[o>>1]|0;d[m+2>>1]=d[o+2>>1]|0;d[m+4>>1]=d[o+4>>1]|0;d[o>>1]=w;d[v+(l*6|0)+2>>1]=x;d[v+(l*6|0)+4>>1]=y;p=p+1|0}while((p|0)!=(q|0));p=s+1|0;if((p|0)==(r|0))break;s=p;t=f[h>>2]|0}u=g;return}function YR(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=0;do{l=c;k=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,k|0,0)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=(l>>>0)%(j>>>0)|0;l=m+(k<<3)|0;n=m+(h<<3)|0;o=f[l>>2]|0;p=f[m+(k<<3)+4>>2]|0;k=n;q=f[k+4>>2]|0;r=l;f[r>>2]=f[k>>2];f[r+4>>2]=q;q=n;f[q>>2]=o;f[q+4>>2]=p;h=h+1|0}while((h|0)!=(j|0));u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;h=i;m=230746;p=h+14|0;do{b[h>>0]=b[m>>0]|0;h=h+1|0;m=m+1|0}while((h|0)<(p|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=a+16|0;i=f[g>>2]|0;m=a+44|0;h=f[a+48>>2]|0;p=f[a+8>>2]|0;q=f[a+12>>2]|0;if((p|0)<=0){u=e;return}if((q|0)>0){s=0;t=i}else{u=e;return}while(1){a=t+(Y(f[f[m>>2]>>2]|0,s)|0)|0;o=0;do{n=c;r=f[n+4>>2]|0;k=x1c(f[n>>2]|0,0,-130063606,0)|0;n=d1c(k|0,J|0,r|0,0)|0;r=c;f[r>>2]=n;f[r+4>>2]=J;r=(n>>>0)%(j>>>0)|0;n=(r>>>0)/(q>>>0)|0;k=a+(o<<3)|0;l=i+(Y(n,h)|0)+(r-(Y(n,q)|0)<<3)|0;n=f[k>>2]|0;r=f[a+(o<<3)+4>>2]|0;v=l;w=f[v+4>>2]|0;x=k;f[x>>2]=f[v>>2];f[x+4>>2]=w;w=l;f[w>>2]=n;f[w+4>>2]=r;o=o+1|0}while((o|0)!=(q|0));o=s+1|0;if((o|0)==(p|0))break;s=o;t=f[g>>2]|0}u=e;return}function ZR(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=0;do{l=c;k=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,k|0,0)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=(l>>>0)%(j>>>0)|0;l=m+(k*12|0)|0;n=m+(h*12|0)|0;o=f[l>>2]|0;p=f[m+(k*12|0)+4>>2]|0;q=f[m+(k*12|0)+8>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2];f[l+8>>2]=f[n+8>>2];f[n>>2]=o;f[m+(h*12|0)+4>>2]=p;f[m+(h*12|0)+8>>2]=q;h=h+1|0}while((h|0)!=(j|0));u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;h=i;m=230746;q=h+14|0;do{b[h>>0]=b[m>>0]|0;h=h+1|0;m=m+1|0}while((h|0)<(q|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=a+16|0;i=f[g>>2]|0;m=a+44|0;h=f[a+48>>2]|0;q=f[a+8>>2]|0;p=f[a+12>>2]|0;if((q|0)<=0){u=e;return}if((p|0)>0){r=0;s=i}else{u=e;return}while(1){a=s+(Y(f[f[m>>2]>>2]|0,r)|0)|0;o=0;do{n=c;l=f[n+4>>2]|0;k=x1c(f[n>>2]|0,0,-130063606,0)|0;n=d1c(k|0,J|0,l|0,0)|0;l=c;f[l>>2]=n;f[l+4>>2]=J;l=(n>>>0)%(j>>>0)|0;n=(l>>>0)/(p>>>0)|0;k=l-(Y(n,p)|0)|0;l=a+(o*12|0)|0;t=i+(Y(n,h)|0)|0;n=t+(k*12|0)|0;v=f[l>>2]|0;w=f[a+(o*12|0)+4>>2]|0;x=f[a+(o*12|0)+8>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2];f[l+8>>2]=f[n+8>>2];f[n>>2]=v;f[t+(k*12|0)+4>>2]=w;f[t+(k*12|0)+8>>2]=x;o=o+1|0}while((o|0)!=(p|0));o=r+1|0;if((o|0)==(q|0))break;r=o;s=f[g>>2]|0}u=e;return}function _R(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=0;do{l=c;k=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,k|0,0)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=(l>>>0)%(j>>>0)|0;l=m+(k<<4)|0;n=m+(h<<4)|0;o=f[l>>2]|0;p=f[m+(k<<4)+4>>2]|0;q=f[m+(k<<4)+8>>2]|0;r=f[m+(k<<4)+12>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2];f[l+8>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];f[n>>2]=o;f[m+(h<<4)+4>>2]=p;f[m+(h<<4)+8>>2]=q;f[m+(h<<4)+12>>2]=r;h=h+1|0}while((h|0)!=(j|0));u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;h=i;m=230746;r=h+14|0;do{b[h>>0]=b[m>>0]|0;h=h+1|0;m=m+1|0}while((h|0)<(r|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=a+16|0;i=f[g>>2]|0;m=a+44|0;h=f[a+48>>2]|0;r=f[a+8>>2]|0;q=f[a+12>>2]|0;if((r|0)<=0){u=e;return}if((q|0)>0){s=0;t=i}else{u=e;return}while(1){a=t+(Y(f[f[m>>2]>>2]|0,s)|0)|0;p=0;do{o=c;n=f[o+4>>2]|0;l=x1c(f[o>>2]|0,0,-130063606,0)|0;o=d1c(l|0,J|0,n|0,0)|0;n=c;f[n>>2]=o;f[n+4>>2]=J;n=(o>>>0)%(j>>>0)|0;o=(n>>>0)/(q>>>0)|0;l=n-(Y(o,q)|0)|0;n=a+(p<<4)|0;k=i+(Y(o,h)|0)|0;o=k+(l<<4)|0;v=f[n>>2]|0;w=f[a+(p<<4)+4>>2]|0;x=f[a+(p<<4)+8>>2]|0;y=f[a+(p<<4)+12>>2]|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];f[o>>2]=v;f[k+(l<<4)+4>>2]=w;f[k+(l<<4)+8>>2]=x;f[k+(l<<4)+12>>2]=y;p=p+1|0}while((p|0)!=(q|0));p=s+1|0;if((p|0)==(r|0))break;s=p;t=f[g>>2]|0}u=e;return}function $R(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=0;do{l=c;k=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,k|0,0)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=(l>>>0)%(j>>>0)|0;l=m+(k*24|0)|0;n=m+(h*24|0)|0;o=f[l>>2]|0;p=f[m+(k*24|0)+4>>2]|0;q=f[m+(k*24|0)+8>>2]|0;r=f[m+(k*24|0)+12>>2]|0;s=f[m+(k*24|0)+16>>2]|0;t=f[m+(k*24|0)+20>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2];f[l+8>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];f[l+16>>2]=f[n+16>>2];f[l+20>>2]=f[n+20>>2];f[n>>2]=o;f[m+(h*24|0)+4>>2]=p;f[m+(h*24|0)+8>>2]=q;f[m+(h*24|0)+12>>2]=r;f[m+(h*24|0)+16>>2]=s;f[m+(h*24|0)+20>>2]=t;h=h+1|0}while((h|0)!=(j|0));u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;h=i;m=230746;t=h+14|0;do{b[h>>0]=b[m>>0]|0;h=h+1|0;m=m+1|0}while((h|0)<(t|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=a+16|0;i=f[g>>2]|0;m=a+44|0;h=f[a+48>>2]|0;t=f[a+8>>2]|0;s=f[a+12>>2]|0;if((t|0)<=0){u=e;return}if((s|0)>0){v=0;w=i}else{u=e;return}while(1){a=w+(Y(f[f[m>>2]>>2]|0,v)|0)|0;r=0;do{q=c;p=f[q+4>>2]|0;o=x1c(f[q>>2]|0,0,-130063606,0)|0;q=d1c(o|0,J|0,p|0,0)|0;p=c;f[p>>2]=q;f[p+4>>2]=J;p=(q>>>0)%(j>>>0)|0;q=(p>>>0)/(s>>>0)|0;o=p-(Y(q,s)|0)|0;p=a+(r*24|0)|0;n=i+(Y(q,h)|0)|0;q=n+(o*24|0)|0;l=f[p>>2]|0;k=f[a+(r*24|0)+4>>2]|0;x=f[a+(r*24|0)+8>>2]|0;y=f[a+(r*24|0)+12>>2]|0;z=f[a+(r*24|0)+16>>2]|0;A=f[a+(r*24|0)+20>>2]|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2];f[q>>2]=l;f[n+(o*24|0)+4>>2]=k;f[n+(o*24|0)+8>>2]=x;f[n+(o*24|0)+12>>2]=y;f[n+(o*24|0)+16>>2]=z;f[n+(o*24|0)+20>>2]=A;r=r+1|0}while((r|0)!=(s|0));r=v+1|0;if((r|0)==(t|0))break;v=r;w=f[g>>2]|0}u=e;return}function aS(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=(h|0)<3;if(i)j=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{k=f[a+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(h|0)){j=n;break}else m=n}}if(f[a>>2]&16384|0){m=f[a+16>>2]|0;if(!j){u=e;return}h=0;do{l=c;k=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,k|0,0)|0;k=c;f[k>>2]=l;f[k+4>>2]=J;k=(l>>>0)%(j>>>0)|0;l=m+(k<<5)|0;n=m+(h<<5)|0;o=f[l>>2]|0;p=f[m+(k<<5)+4>>2]|0;q=f[m+(k<<5)+8>>2]|0;r=f[m+(k<<5)+12>>2]|0;s=f[m+(k<<5)+16>>2]|0;t=f[m+(k<<5)+20>>2]|0;v=f[m+(k<<5)+24>>2]|0;w=f[m+(k<<5)+28>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2];f[l+8>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];f[l+16>>2]=f[n+16>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[n>>2]=o;f[m+(h<<5)+4>>2]=p;f[m+(h<<5)+8>>2]=q;f[m+(h<<5)+12>>2]=r;f[m+(h<<5)+16>>2]=s;f[m+(h<<5)+20>>2]=t;f[m+(h<<5)+24>>2]=v;f[m+(h<<5)+28>>2]=w;h=h+1|0}while((h|0)!=(j|0));u=e;return}if(!i){i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=14;h=i;m=230746;w=h+14|0;do{b[h>>0]=b[m>>0]|0;h=h+1|0;m=m+1|0}while((h|0)<(w|0));b[i+14>>0]=0;vM(-215,g,230761,230086,697)}g=a+16|0;i=f[g>>2]|0;m=a+44|0;h=f[a+48>>2]|0;w=f[a+8>>2]|0;v=f[a+12>>2]|0;if((w|0)<=0){u=e;return}if((v|0)>0){x=0;y=i}else{u=e;return}while(1){a=y+(Y(f[f[m>>2]>>2]|0,x)|0)|0;t=0;do{s=c;r=f[s+4>>2]|0;q=x1c(f[s>>2]|0,0,-130063606,0)|0;s=d1c(q|0,J|0,r|0,0)|0;r=c;f[r>>2]=s;f[r+4>>2]=J;r=(s>>>0)%(j>>>0)|0;s=(r>>>0)/(v>>>0)|0;q=r-(Y(s,v)|0)|0;r=a+(t<<5)|0;p=i+(Y(s,h)|0)|0;s=p+(q<<5)|0;o=f[r>>2]|0;n=f[a+(t<<5)+4>>2]|0;l=f[a+(t<<5)+8>>2]|0;k=f[a+(t<<5)+12>>2]|0;z=f[a+(t<<5)+16>>2]|0;A=f[a+(t<<5)+20>>2]|0;B=f[a+(t<<5)+24>>2]|0;C=f[a+(t<<5)+28>>2]|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2];f[s>>2]=o;f[p+(q<<5)+4>>2]=n;f[p+(q<<5)+8>>2]=l;f[p+(q<<5)+12>>2]=k;f[p+(q<<5)+16>>2]=z;f[p+(q<<5)+20>>2]=A;f[p+(q<<5)+24>>2]=B;f[p+(q<<5)+28>>2]=C;t=t+1|0}while((t|0)!=(v|0));t=x+1|0;if((t|0)==(w|0))break;x=t;y=f[g>>2]|0}u=e;return}function bS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+160|0;g=e+136|0;h=e+56|0;i=e;j=e+128|0;k=e+120|0;l=e+112|0;m=f[c>>2]|0;n=m&50331648;do switch(m>>>16&31){case 1:{o=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(a,o,g,h);u=e;return}f[a>>2]=f[o>>2];p=a+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=a+8|0;f[r>>2]=f[o+8>>2];f[a+12>>2]=f[o+12>>2];f[a+16>>2]=f[o+16>>2];f[a+20>>2]=f[o+20>>2];f[a+24>>2]=f[o+24>>2];f[a+28>>2]=f[o+28>>2];f[a+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[a+36>>2]=s;f[a+40>>2]=r;r=a+48|0;t=a+44|0;f[t>>2]=r;f[r>>2]=0;f[a+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];u=e;return}else{f[p>>2]=0;U$(a,o);u=e;return}break}case 10:{o=f[c+4>>2]|0;if((d|0)<0){NQ(a,o,n);u=e;return}NQ(i,o,n);f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(a,i,g,h);o=i+36|0;p=f[o>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)V$(i);f[o>>2]=0;o=i+16|0;p=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[p>>2]|0)>0){o=f[i+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[p>>2]|0))}p=f[i+44>>2]|0;if((p|0)!=(i+48|0))wL(p);u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,230780,230788,38)}p=f[c+4>>2]|0;f[a>>2]=1124007936;q=a+8|0;o=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[o>>2]=q;r=a+48|0;f[a+44>>2]=r;f[r>>2]=0;f[a+52>>2]=0;r=f[p>>2]|0;ei[f[(f[r>>2]|0)+12>>2]&511](r,p,a,-1);u=e;return}case 2:case 14:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,230780,230788,44)}f[j>>2]=f[c+8>>2];f[j+4>>2]=f[c+12>>2];cM(a,j,m,f[c+4>>2]|0,0);u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,230780,230788,50)}r=f[c+4>>2]|0;if((f[r>>2]|0)==(f[r+4>>2]|0)){f[a>>2]=1124007936;t=a+8|0;s=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[s>>2]=t;p=a+48|0;f[a+44>>2]=p;f[p>>2]=0;f[a+52>>2]=0;u=e;return}p=m&4095;cS(k,c,-1);q=f[r>>2]|0;f[a>>2]=p|1124007936;f[a+4>>2]=2;o=a+8|0;x=f[k+4>>2]|0;f[o>>2]=x;y=f[k>>2]|0;f[a+12>>2]=y;f[a+16>>2]=q;f[a+20>>2]=q;z=a+24|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[a+40>>2]=o;o=a+48|0;f[a+44>>2]=o;A=a+52|0;f[A>>2]=0;f[o>>2]=0;if((q|0)==0&(Y(y,x)|0)!=0){B=$Xc(32)|0;f[g>>2]=B;f[g+8>>2]=-2147483616;f[g+4>>2]=28;v=B;C=470314;w=v+28|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));b[B+28>>0]=0;vM(-215,g,470343,470347,577)}r=Y(675553809>>>(p<<2&28)&15,(m>>>3&511)+1|0)|0;t=Y(y,r)|0;f[o>>2]=t;f[A>>2]=r;r=q+(Y(t,x)|0)|0;f[a+28>>2]=r;f[z>>2]=r+(0-t)+t;R$(a);u=e;return}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,230780,230788,59)}t=f[c+4>>2]|0;r=f[t+4>>2]|0;if(!r){f[a>>2]=1124007936;s=a+8|0;D=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[D>>2]=s;z=a+48|0;f[a+44>>2]=z;f[z>>2]=0;f[a+52>>2]=0;u=e;return}f[h>>2]=1124007936;z=h+4|0;x=h+8|0;q=h+40|0;v=z;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[q>>2]=x;s=h+48|0;f[h+44>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[g>>2]=1;f[g+4>>2]=r;S$(h,2,g,0);D=h+16|0;A=f[D>>2]|0;if((r|0)>0){o=0;do{b[A+o>>0]=(f[(f[t>>2]|0)+(o>>>5<<2)>>2]&1<<(o&31)|0)!=0&1;o=o+1|0}while((o|0)!=(r|0));E=f[D>>2]|0}else E=A;f[a>>2]=f[h>>2];r=f[z>>2]|0;f[a+4>>2]=r;o=a+8|0;f[o>>2]=f[x>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=E;f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];t=h+36|0;f[a+36>>2]=f[t>>2];y=a+40|0;f[y>>2]=o;o=a+44|0;p=a+48|0;f[o>>2]=p;B=a+52|0;f[B>>2]=0;f[p>>2]=0;F=h+44|0;if((r|0)<3){r=f[F>>2]|0;f[p>>2]=f[r>>2];f[B>>2]=f[r+4>>2];G=r}else{f[o>>2]=f[F>>2];f[y>>2]=f[q>>2];f[F>>2]=s;f[q>>2]=x;G=s}f[h>>2]=1124007936;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[t>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((G|0)!=(s|0))wL(G);u=e;return}case 0:{f[a>>2]=1124007936;t=a+8|0;F=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[F>>2]=t;s=a+48|0;f[a+44>>2]=s;f[s>>2]=0;f[a+52>>2]=0;u=e;return}case 4:{s=dS(c,d)|0;D=f[c+4>>2]|0;if((d|0)<=-1){H=$Xc(32)|0;f[g>>2]=H;I=g+8|0;f[I>>2]=-2147483616;J=g+4|0;f[J>>2]=28;v=H;C=230861;w=v+28|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));K=H+28|0;b[K>>0]=0;vM(-215,g,230780,230788,79)}t=f[D>>2]|0;F=t;if((((f[D+4>>2]|0)-t|0)/12|0|0)<=(d|0)){H=$Xc(32)|0;f[g>>2]=H;I=g+8|0;f[I>>2]=-2147483616;J=g+4|0;f[J>>2]=28;v=H;C=230861;w=v+28|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));K=H+28|0;b[K>>0]=0;vM(-215,g,230780,230788,79)}D=F+(d*12|0)|0;if((f[D>>2]|0)==(f[F+(d*12|0)+4>>2]|0)){f[a>>2]=1124007936;t=a+8|0;z=a+40|0;v=a+4|0;w=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(w|0));f[z>>2]=t;F=a+48|0;f[a+44>>2]=F;f[F>>2]=0;f[a+52>>2]=0;u=e;return}cS(l,c,d);F=f[D>>2]|0;f[a>>2]=s&4095|1124007936;f[a+4>>2]=2;x=a+8|0;q=f[l+4>>2]|0;f[x>>2]=q;A=f[l>>2]|0;f[a+12>>2]=A;f[a+16>>2]=F;f[a+20>>2]=F;y=a+24|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[a+40>>2]=x;x=a+48|0;f[a+44>>2]=x;o=a+52|0;f[o>>2]=0;f[x>>2]=0;if((F|0)==0&(Y(A,q)|0)!=0){r=$Xc(32)|0;f[g>>2]=r;f[g+8>>2]=-2147483616;f[g+4>>2]=28;v=r;C=470314;w=v+28|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));b[r+28>>0]=0;vM(-215,g,470343,470347,577)}D=Y(675553809>>>(s<<2&28)&15,(s>>>3&511)+1|0)|0;t=Y(A,D)|0;f[x>>2]=t;f[o>>2]=D;D=F+(Y(t,q)|0)|0;f[a+28>>2]=D;f[y>>2]=D+(0-t)+t;R$(a);u=e;return}case 5:{t=f[c+4>>2]|0;if((d|0)<=-1){L=$Xc(32)|0;f[g>>2]=L;M=g+8|0;f[M>>2]=-2147483616;N=g+4|0;f[N>>2]=27;v=L;C=230890;w=v+27|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));O=L+27|0;b[O>>0]=0;vM(-215,g,230780,230788,88)}y=f[t>>2]|0;q=y;if((((f[t+4>>2]|0)-y|0)/56|0|0)<=(d|0)){L=$Xc(32)|0;f[g>>2]=L;M=g+8|0;f[M>>2]=-2147483616;N=g+4|0;f[N>>2]=27;v=L;C=230890;w=v+27|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));O=L+27|0;b[O>>0]=0;vM(-215,g,230780,230788,88)}t=q+(d*56|0)|0;f[a>>2]=f[t>>2];y=a+4|0;F=q+(d*56|0)+4|0;f[y>>2]=f[F>>2];o=a+8|0;f[o>>2]=f[q+(d*56|0)+8>>2];f[a+12>>2]=f[q+(d*56|0)+12>>2];f[a+16>>2]=f[q+(d*56|0)+16>>2];f[a+20>>2]=f[q+(d*56|0)+20>>2];f[a+24>>2]=f[q+(d*56|0)+24>>2];f[a+28>>2]=f[q+(d*56|0)+28>>2];f[a+32>>2]=f[q+(d*56|0)+32>>2];x=f[q+(d*56|0)+36>>2]|0;f[a+36>>2]=x;f[a+40>>2]=o;o=a+48|0;A=a+44|0;f[A>>2]=o;f[o>>2]=0;f[a+52>>2]=0;if(x|0){o=x+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[F>>2]|0)<3){F=f[q+(d*56|0)+44>>2]|0;o=f[A>>2]|0;f[o>>2]=f[F>>2];f[o+4>>2]=f[F+4>>2];u=e;return}else{f[y>>2]=0;U$(a,t);u=e;return}break}case 15:{t=f[c+4>>2]|0;if((d|0)<=-1){P=$Xc(32)|0;f[g>>2]=P;Q=g+8|0;f[Q>>2]=-2147483616;R=g+4|0;f[R>>2]=23;v=P;C=230918;w=v+23|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));S=P+23|0;b[S>>0]=0;vM(-215,g,230780,230788,96)}if((f[c+12>>2]|0)<=(d|0)){P=$Xc(32)|0;f[g>>2]=P;Q=g+8|0;f[Q>>2]=-2147483616;R=g+4|0;f[R>>2]=23;v=P;C=230918;w=v+23|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));S=P+23|0;b[S>>0]=0;vM(-215,g,230780,230788,96)}q=t+(d*56|0)|0;f[a>>2]=f[q>>2];y=a+4|0;F=t+(d*56|0)+4|0;f[y>>2]=f[F>>2];o=a+8|0;f[o>>2]=f[t+(d*56|0)+8>>2];f[a+12>>2]=f[t+(d*56|0)+12>>2];f[a+16>>2]=f[t+(d*56|0)+16>>2];f[a+20>>2]=f[t+(d*56|0)+20>>2];f[a+24>>2]=f[t+(d*56|0)+24>>2];f[a+28>>2]=f[t+(d*56|0)+28>>2];f[a+32>>2]=f[t+(d*56|0)+32>>2];A=f[t+(d*56|0)+36>>2]|0;f[a+36>>2]=A;f[a+40>>2]=o;o=a+48|0;x=a+44|0;f[x>>2]=o;f[o>>2]=0;f[a+52>>2]=0;if(A|0){o=A+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[F>>2]|0)<3){F=f[t+(d*56|0)+44>>2]|0;o=f[x>>2]|0;f[o>>2]=f[F>>2];f[o+4>>2]=f[F+4>>2];u=e;return}else{f[y>>2]=0;U$(a,q);u=e;return}break}case 11:{q=f[c+4>>2]|0;if((d|0)<=-1){T=$Xc(32)|0;f[g>>2]=T;U=g+8|0;f[U>>2]=-2147483616;V=g+4|0;f[V>>2]=27;v=T;C=230890;w=v+27|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));W=T+27|0;b[W>>0]=0;vM(-215,g,230780,230788,104)}t=f[q>>2]|0;if((((f[q+4>>2]|0)-t|0)/48|0|0)<=(d|0)){T=$Xc(32)|0;f[g>>2]=T;U=g+8|0;f[U>>2]=-2147483616;V=g+4|0;f[V>>2]=27;v=T;C=230890;w=v+27|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));W=T+27|0;b[W>>0]=0;vM(-215,g,230780,230788,104)}NQ(a,t+(d*48|0)|0,n);u=e;return}case 7:{if((d|0)<0){q=$Xc(80)|0;f[g>>2]=q;f[g+8>>2]=-2147483568;f[g+4>>2]=75;v=q;C=230942;w=v+75|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));b[q+75>>0]=0;vM(-213,g,230780,230788,112)}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,230780,230788,111)}break}case 9:{if((d|0)<0){t=$Xc(80)|0;f[g>>2]=t;f[g+8>>2]=-2147483568;f[g+4>>2]=66;v=t;C=231018;w=v+66|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));b[t+66>>0]=0;vM(-213,g,230780,230788,118)}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,230780,230788,117)}break}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,230780,230788,123)}q=f[c+4>>2]|0;y=f[q+4>>2]|0;f[g>>2]=f[q+8>>2];f[g+4>>2]=y;cM(a,g,f[q>>2]&4095,f[q+16>>2]|0,f[q+12>>2]|0);u=e;return}default:{q=$Xc(32)|0;f[g>>2]=q;f[g+8>>2]=-2147483616;f[g+4>>2]=30;v=q;C=231085;w=v+30|0;do{b[v>>0]=b[C>>0]|0;v=v+1|0;C=C+1|0}while((v|0)<(w|0));b[q+30>>0]=0;vM(-213,g,230780,230788,130)}}while(0)}function cS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;do switch(h>>>16&31){case 1:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,400)}i=f[(f[c+4>>2]|0)+40>>2]|0;j=f[i>>2]|0;f[a>>2]=f[i+4>>2];f[a+4>>2]=j;u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,406)}k$(a,f[c+4>>2]|0);u=e;return}case 10:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,412)}j=f[(f[c+4>>2]|0)+32>>2]|0;i=f[j>>2]|0;f[a>>2]=f[j+4>>2];f[a+4>>2]=i;u=e;return}case 2:case 14:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,418)}f[a>>2]=f[c+8>>2];f[a+4>>2]=f[c+12>>2];u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,424)}i=f[c+4>>2]|0;j=(f[i+4>>2]|0)-(f[i>>2]|0)|0;if((j|0)==(j>>2|0)){f[a>>2]=j;f[a+4>>2]=1;u=e;return}else{i=(j>>>0)/((Y(675553809>>>(h<<2&28)&15,(h>>>3&511)+1|0)|0)>>>0)|0;f[a>>2]=i;f[a+4>>2]=1;u=e;return}break}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,433)}f[a>>2]=f[(f[c+4>>2]|0)+4>>2];f[a+4>>2]=1;u=e;return}case 0:{f[a>>2]=0;f[a+4>>2]=0;u=e;return}case 4:{i=f[c+4>>2]|0;if((d|0)<0){j=f[i>>2]|0;k=f[i+4>>2]|0;if((j|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-j|0)/12|0;f[a+4>>2]=1;u=e;return}}j=f[i>>2]|0;k=j;if((((f[i+4>>2]|0)-j|0)/12|0|0)<=(d|0)){j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=18;l=j;m=231142;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+18>>0]=0;vM(-215,g,470867,230788,446)}o=(f[k+(d*12|0)+4>>2]|0)-(f[k+(d*12|0)>>2]|0)|0;p=f[i>>2]|0;if((o|0)==((f[p+(d*12|0)+4>>2]|0)-(f[p+(d*12|0)>>2]|0)>>2|0)){f[a>>2]=o;f[a+4>>2]=1;u=e;return}else{p=(o>>>0)/((Y(675553809>>>(h<<2&28)&15,(h>>>3&511)+1|0)|0)>>>0)|0;f[a>>2]=p;f[a+4>>2]=1;u=e;return}break}case 5:{p=f[c+4>>2]|0;if((d|0)>=0){o=f[p>>2]|0;if((((f[p+4>>2]|0)-o|0)/56|0|0)<=(d|0)){q=$Xc(32)|0;f[g>>2]=q;f[g+8>>2]=-2147483616;f[g+4>>2]=18;l=q;m=231142;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[q+18>>0]=0;vM(-215,g,470867,230788,458)}i=f[o+(d*56|0)+40>>2]|0;k=f[i>>2]|0;f[a>>2]=f[i+4>>2];f[a+4>>2]=k;u=e;return}k=f[p>>2]|0;i=f[p+4>>2]|0;if((k|0)==(i|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(i-k|0)/56|0;f[a+4>>2]=1;u=e;return}break}case 15:{k=f[c+4>>2]|0;i=f[c+12>>2]|0;if((d|0)>=0){if((i|0)<=(d|0)){j=$Xc(16)|0;f[g>>2]=j;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=j;m=231161;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+13>>0]=0;vM(-215,g,470867,230788,468)}p=f[k+(d*56|0)+40>>2]|0;o=f[p>>2]|0;f[a>>2]=f[p+4>>2];f[a+4>>2]=o;u=e;return}if(!i){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=i;f[a+4>>2]=1;u=e;return}break}case 13:{o=f[c+4>>2]|0;if((d|0)>=0){p=f[o>>2]|0;q=p;if((((f[o+4>>2]|0)-p|0)/36|0|0)<=(d|0)){p=$Xc(32)|0;f[g>>2]=p;f[g+8>>2]=-2147483616;f[g+4>>2]=18;l=p;m=231142;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[p+18>>0]=0;vM(-215,g,470867,230788,478)}i=f[q+(d*36|0)+4>>2]|0;f[a>>2]=f[q+(d*36|0)+8>>2];f[a+4>>2]=i;u=e;return}i=f[o>>2]|0;k=f[o+4>>2]|0;if((i|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-i|0)/36|0;f[a+4>>2]=1;u=e;return}break}case 11:{i=f[c+4>>2]|0;if((d|0)>=0){k=f[i>>2]|0;if((((f[i+4>>2]|0)-k|0)/48|0|0)<=(d|0)){j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=18;l=j;m=231142;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+18>>0]=0;vM(-215,g,470867,230788,487)}o=f[k+(d*48|0)+32>>2]|0;q=f[o>>2]|0;f[a>>2]=f[o+4>>2];f[a+4>>2]=q;u=e;return}q=f[i>>2]|0;o=f[i+4>>2]|0;if((q|0)==(o|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(o-q|0)/48|0;f[a+4>>2]=1;u=e;return}break}case 7:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,494)}q=f[c+4>>2]|0;o=f[q+8>>2]|0;f[a>>2]=f[q+12>>2];f[a+4>>2]=o;u=e;return}case 9:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,501)}o=f[c+4>>2]|0;q=f[o+4>>2]|0;f[a>>2]=f[o+8>>2];f[a+4>>2]=q;u=e;return}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[230774]|0;b[g+1>>0]=b[230775]|0;b[g+2>>0]=b[230776]|0;b[g+3>>0]=b[230777]|0;b[g+4>>0]=b[230778]|0;b[g+5>>0]=0;vM(-215,g,470867,230788,508)}q=f[c+4>>2]|0;o=f[q+4>>2]|0;f[a>>2]=f[q+8>>2];f[a+4>>2]=o;u=e;return}default:{o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=30;l=o;m=231085;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+30>>0]=0;vM(-213,g,470867,230788,513)}}while(0)}function dS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;do switch(g>>>16&31){case 1:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 10:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 6:{h=l$(f[a+4>>2]|0)|0;u=d;return h|0}case 2:case 3:case 4:case 12:case 14:{h=g&4095;u=d;return h|0}case 11:{i=f[a+4>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((j|0)==(k|0)){if((g|0)>=0){i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=25;l=i;m=231116;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[i+25>>0]=0;vM(-215,e,466514,230788,789)}h=g&4095;u=d;return h|0}else{if(((k-j|0)/48|0|0)<=(c|0)){o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=18;l=o;m=231142;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+18>>0]=0;vM(-215,e,466514,230788,792)}h=f[j+(((c|0)>0?c:0)*48|0)>>2]&4095;u=d;return h|0}break}case 5:{k=f[a+4>>2]|0;i=f[k>>2]|0;p=f[k+4>>2]|0;if((i|0)==(p|0)){if((g|0)>=0){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=25;l=k;m=231116;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+25>>0]=0;vM(-215,e,466514,230788,801)}h=g&4095;u=d;return h|0}else{if(((p-i|0)/56|0|0)<=(c|0)){j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=18;l=j;m=231142;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+18>>0]=0;vM(-215,e,466514,230788,804)}h=f[i+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 15:{p=f[a+4>>2]|0;k=f[a+12>>2]|0;if(!k){if((g|0)>=0){o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=25;l=o;m=231116;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+25>>0]=0;vM(-215,e,466514,230788,813)}h=g&4095;u=d;return h|0}else{if((k|0)<=(c|0)){i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=i;m=231161;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[i+13>>0]=0;vM(-215,e,466514,230788,816)}h=f[p+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 13:{k=f[a+4>>2]|0;o=f[k>>2]|0;j=f[k+4>>2]|0;if((o|0)==(j|0)){if((g|0)>=0){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=25;l=k;m=231116;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+25>>0]=0;vM(-215,e,466514,230788,825)}h=g&4095;u=d;return h|0}else{if(((j-o|0)/36|0|0)<=(c|0)){p=$Xc(32)|0;f[e>>2]=p;f[e+8>>2]=-2147483616;f[e+4>>2]=18;l=p;m=231142;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[p+18>>0]=0;vM(-215,e,466514,230788,828)}h=f[o+(((c|0)>0?c:0)*36|0)>>2]&4095;u=d;return h|0}break}case 7:{h=f[(f[a+4>>2]|0)+16>>2]|0;u=d;return h|0}case 9:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 8:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 0:{h=-1;u=d;return h|0}default:{j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=j;m=231085;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+30>>0]=0;vM(-213,e,466514,230788,841)}}while(0);return 0}function eS(a){a=a|0;return f[a>>2]&2031616|0}function fS(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+128|0;g=e+64|0;h=e+56|0;i=e;j=f[c>>2]|0;k=j&2031616;l=j&50331648;j=k&2097151;a:do if((j|0)>=655360){if((j|0)<720896){switch(j|0){case 655360:break;default:break a}m=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;GQ(a,m,g,h);u=e;return}f[a>>2]=f[m>>2];n=a+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=a+8|0;f[p>>2]=f[m+8>>2];f[a+12>>2]=f[m+12>>2];f[a+16>>2]=f[m+16>>2];f[a+20>>2]=f[m+20>>2];q=f[m+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[m+28>>2];f[a+32>>2]=p;p=a+40|0;r=a+36|0;f[r>>2]=p;f[a+44>>2]=0;f[p>>2]=0;if(q|0){p=q+8|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+36>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];u=e;return}else{f[n>>2]=0;DQ(a,m);u=e;return}}switch(j|0){case 720896:break;default:break a}m=f[c+4>>2]|0;if((d|0)<=-1){s=$Xc(32)|0;f[g>>2]=s;t=g+8|0;f[t>>2]=-2147483616;v=g+4|0;f[v>>2]=27;w=s;x=230890;y=w+27|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+27|0;b[z>>0]=0;vM(-215,g,231175,230788,149)}n=f[m>>2]|0;o=n;if((((f[m+4>>2]|0)-n|0)/48|0|0)<=(d|0)){s=$Xc(32)|0;f[g>>2]=s;t=g+8|0;f[t>>2]=-2147483616;v=g+4|0;f[v>>2]=27;w=s;x=230890;y=w+27|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+27|0;b[z>>0]=0;vM(-215,g,231175,230788,149)}m=o+(d*48|0)|0;f[a>>2]=f[m>>2];n=a+4|0;p=o+(d*48|0)+4|0;f[n>>2]=f[p>>2];r=a+8|0;f[r>>2]=f[o+(d*48|0)+8>>2];f[a+12>>2]=f[o+(d*48|0)+12>>2];f[a+16>>2]=f[o+(d*48|0)+16>>2];f[a+20>>2]=f[o+(d*48|0)+20>>2];q=f[o+(d*48|0)+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[o+(d*48|0)+28>>2];f[a+32>>2]=r;r=a+40|0;A=a+36|0;f[A>>2]=r;f[a+44>>2]=0;f[r>>2]=0;if(q|0){r=q+8|0;f[r>>2]=(f[r>>2]|0)+1}if((f[p>>2]|0)<3){p=f[o+(d*48|0)+36>>2]|0;r=f[A>>2]|0;f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2];u=e;return}else{f[n>>2]=0;DQ(a,m);u=e;return}}else{switch(j|0){case 65536:break;default:break a}m=f[c+4>>2]|0;if((d|0)<0){zQ(a,m,l,0);u=e;return}f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(i,m,g,h);zQ(a,i,l,0);m=i+36|0;n=f[m>>2]|0;if(n|0?(p=n+12|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)V$(i);f[m>>2]=0;m=i+16|0;n=i+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){m=f[i+40>>2]|0;p=0;do{f[m+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[n>>2]|0))}n=f[i+44>>2]|0;if((n|0)!=(i+48|0))wL(n);u=e;return}while(0);do if((d|0)<0&(k|0)==65536){i=f[c+4>>2]|0;f[g>>2]=f[i>>2];h=g+4|0;j=i+4|0;f[h>>2]=f[j>>2];z=g+8|0;f[z>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];s=f[i+36>>2]|0;f[g+36>>2]=s;f[g+40>>2]=z;z=g+48|0;x=g+44|0;f[x>>2]=z;f[z>>2]=0;f[g+52>>2]=0;if(s|0){z=s+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[j>>2]|0)<3){j=f[i+44>>2]|0;z=f[x>>2]|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];break}else{f[h>>2]=0;U$(g,i);break}}else bS(g,c,d);while(0);zQ(a,g,l,0);l=g+36|0;a=f[l>>2]|0;if(a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)V$(g);f[l>>2]=0;l=g+16|0;a=g+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[a>>2]|0)>0){l=f[g+40>>2]|0;d=0;do{f[l+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))wL(a);u=e;return}function gS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;d=u;u=u+240|0;e=d+176|0;g=d+120|0;h=d+56|0;i=d;j=d+112|0;k=f[a>>2]|0;l=k&50331648;do switch(k>>>16&31){case 1:{m=f[a+4>>2]|0;n=m+40|0;o=f[f[n>>2]>>2]|0;hS(c,o);if((o|0)<=0){u=d;return}p=m+4|0;q=m+12|0;r=m+16|0;s=m+44|0;t=e+36|0;v=e+16|0;w=e+4|0;x=e+40|0;y=e+44|0;z=e+48|0;A=e+8|0;B=e+12|0;C=e+20|0;D=e+24|0;E=e+28|0;F=e+32|0;G=e+44|0;H=0;do{I=f[p>>2]|0;if((I|0)==2)Tj(e,1,f[q>>2]|0,f[m>>2]&4095,(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,H)|0)|0,0);else{J=f[s>>2]|0;_$(e,I+-1|0,(f[n>>2]|0)+4|0,f[m>>2]&4095,(f[r>>2]|0)+(Y(f[J>>2]|0,H)|0)|0,J+4|0)}J=f[c>>2]|0;I=J+(H*56|0)|0;if((I|0)==(e|0)){K=f[t>>2]|0;if(K|0?(L=K+12|0,K=f[L>>2]|0,f[L>>2]=K+-1,(K|0)==1):0)V$(e)}else{K=J+(H*56|0)+36|0;L=f[K>>2]|0;if(L|0?(M=L+12|0,L=f[M>>2]|0,f[M>>2]=L+-1,(L|0)==1):0)V$(I);f[K>>2]=0;L=J+(H*56|0)+16|0;M=J+(H*56|0)+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){N=f[J+(H*56|0)+40>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}f[I>>2]=f[e>>2];f[M>>2]=f[w>>2];O=J+(H*56|0)+8|0;f[O>>2]=f[A>>2];f[J+(H*56|0)+12>>2]=f[B>>2];f[L>>2]=f[v>>2];f[J+(H*56|0)+20>>2]=f[C>>2];f[J+(H*56|0)+24>>2]=f[D>>2];f[J+(H*56|0)+28>>2]=f[E>>2];f[J+(H*56|0)+32>>2]=f[F>>2];f[K>>2]=f[t>>2];N=J+(H*56|0)+44|0;P=f[N>>2]|0;Q=J+(H*56|0)+48|0;if((P|0)==(Q|0))R=P;else{wL(P);f[N>>2]=Q;f[J+(H*56|0)+40>>2]=O;R=Q}if((f[w>>2]|0)<3){Q=f[G>>2]|0;f[R>>2]=f[Q>>2];f[R+4>>2]=f[Q+4>>2]}else{f[N>>2]=f[G>>2];f[J+(H*56|0)+40>>2]=f[x>>2];f[G>>2]=z;f[x>>2]=A}f[e>>2]=1124007936;S=w;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0))}f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){J=f[x>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[w>>2]|0))}K=f[y>>2]|0;if((K|0)!=(z|0))wL(K);H=H+1|0}while((H|0)<(o|0));u=d;return}case 6:{o=f[a+4>>2]|0;f[h>>2]=1124007936;H=h+4|0;z=h+8|0;y=h+40|0;S=H;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0));f[y>>2]=z;w=h+48|0;x=h+44|0;f[x>>2]=w;f[w>>2]=0;f[h+52>>2]=0;v=f[o>>2]|0;ei[f[(f[v>>2]|0)+12>>2]&511](v,o,h,-1);v=f[f[y>>2]>>2]|0;hS(c,v);if((v|0)>0){t=e+4|0;A=g+4|0;G=i+36|0;F=i+16|0;E=i+4|0;D=i+40|0;C=i+44|0;B=i+48|0;r=i+8|0;m=i+12|0;n=i+20|0;s=i+24|0;q=i+28|0;p=i+32|0;K=i+44|0;J=0;do{L=J;J=J+1|0;f[e>>2]=L;f[t>>2]=J;f[g>>2]=-2147483648;f[A>>2]=2147483647;W$(i,h,e,g);M=f[c>>2]|0;I=M+(L*56|0)|0;if((I|0)==(i|0)){N=f[G>>2]|0;if(N|0?(Q=N+12|0,N=f[Q>>2]|0,f[Q>>2]=N+-1,(N|0)==1):0)V$(i)}else{N=M+(L*56|0)+36|0;Q=f[N>>2]|0;if(Q|0?(O=Q+12|0,Q=f[O>>2]|0,f[O>>2]=Q+-1,(Q|0)==1):0)V$(I);f[N>>2]=0;Q=M+(L*56|0)+16|0;O=M+(L*56|0)+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[O>>2]|0)>0){P=f[M+(L*56|0)+40>>2]|0;U=0;do{f[P+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[O>>2]|0))}f[I>>2]=f[i>>2];f[O>>2]=f[E>>2];U=M+(L*56|0)+8|0;f[U>>2]=f[r>>2];f[M+(L*56|0)+12>>2]=f[m>>2];f[Q>>2]=f[F>>2];f[M+(L*56|0)+20>>2]=f[n>>2];f[M+(L*56|0)+24>>2]=f[s>>2];f[M+(L*56|0)+28>>2]=f[q>>2];f[M+(L*56|0)+32>>2]=f[p>>2];f[N>>2]=f[G>>2];P=M+(L*56|0)+44|0;V=f[P>>2]|0;W=M+(L*56|0)+48|0;if((V|0)==(W|0))X=V;else{wL(V);f[P>>2]=W;f[M+(L*56|0)+40>>2]=U;X=W}if((f[E>>2]|0)<3){W=f[K>>2]|0;f[X>>2]=f[W>>2];f[X+4>>2]=f[W+4>>2]}else{f[P>>2]=f[K>>2];f[M+(L*56|0)+40>>2]=f[D>>2];f[K>>2]=B;f[D>>2]=r}f[i>>2]=1124007936;S=E;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0))}f[G>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[E>>2]|0)>0){L=f[D>>2]|0;M=0;do{f[L+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[E>>2]|0))}M=f[C>>2]|0;if((M|0)!=(B|0))wL(M)}while((J|0)<(v|0))}v=h+36|0;J=f[v>>2]|0;if(J|0?(B=J+12|0,J=f[B>>2]|0,f[B>>2]=J+-1,(J|0)==1):0)V$(h);f[v>>2]=0;v=h+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[H>>2]|0)>0){v=f[y>>2]|0;J=0;do{f[v+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[x>>2]|0;if((H|0)!=(w|0))wL(H);u=d;return}case 2:case 14:{H=f[a+12>>2]|0;J=Y(675553809>>>(k<<2&28)&15,(k>>>3&511)+1|0)|0;hS(c,H);if(!H){u=d;return}v=a+8|0;y=a+4|0;B=e+36|0;C=e+16|0;E=e+4|0;D=e+40|0;F=e+44|0;G=e+48|0;r=e+8|0;K=e+12|0;p=e+20|0;q=e+24|0;s=e+28|0;n=e+32|0;m=e+44|0;A=0;do{t=f[v>>2]|0;Tj(e,1,t,f[a>>2]&4095,(f[y>>2]|0)+(Y(Y(J,A)|0,t)|0)|0,0);t=f[c>>2]|0;o=t+(A*56|0)|0;if((o|0)==(e|0)){z=f[B>>2]|0;if(z|0?(M=z+12|0,z=f[M>>2]|0,f[M>>2]=z+-1,(z|0)==1):0)V$(e)}else{z=t+(A*56|0)+36|0;M=f[z>>2]|0;if(M|0?(L=M+12|0,M=f[L>>2]|0,f[L>>2]=M+-1,(M|0)==1):0)V$(o);f[z>>2]=0;M=t+(A*56|0)+16|0;L=t+(A*56|0)+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[L>>2]|0)>0){N=f[t+(A*56|0)+40>>2]|0;Q=0;do{f[N+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[L>>2]|0))}f[o>>2]=f[e>>2];f[L>>2]=f[E>>2];Q=t+(A*56|0)+8|0;f[Q>>2]=f[r>>2];f[t+(A*56|0)+12>>2]=f[K>>2];f[M>>2]=f[C>>2];f[t+(A*56|0)+20>>2]=f[p>>2];f[t+(A*56|0)+24>>2]=f[q>>2];f[t+(A*56|0)+28>>2]=f[s>>2];f[t+(A*56|0)+32>>2]=f[n>>2];f[z>>2]=f[B>>2];N=t+(A*56|0)+44|0;O=f[N>>2]|0;I=t+(A*56|0)+48|0;if((O|0)==(I|0))Z=O;else{wL(O);f[N>>2]=I;f[t+(A*56|0)+40>>2]=Q;Z=I}if((f[E>>2]|0)<3){I=f[m>>2]|0;f[Z>>2]=f[I>>2];f[Z+4>>2]=f[I+4>>2]}else{f[N>>2]=f[m>>2];f[t+(A*56|0)+40>>2]=f[D>>2];f[m>>2]=G;f[D>>2]=r}f[e>>2]=1124007936;S=E;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0))}f[B>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[E>>2]|0)>0){t=f[D>>2]|0;z=0;do{f[t+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[E>>2]|0))}z=f[F>>2]|0;if((z|0)!=(G|0))wL(z);A=A+1|0}while(A>>>0<H>>>0);u=d;return}case 3:{H=f[a+4>>2]|0;cS(e,a,-1);A=f[e>>2]|0;G=f[a>>2]|0;F=(G>>>3&511)+1|0;E=G&7;G=Y(675553809>>>(E<<2)&15,F)|0;hS(c,A);if(!A){u=d;return}D=e+36|0;C=e+16|0;B=e+4|0;r=e+40|0;m=e+44|0;n=e+48|0;s=e+8|0;q=e+12|0;p=e+20|0;K=e+24|0;J=e+28|0;y=e+32|0;v=e+44|0;w=0;do{Tj(e,1,F,E,(f[H>>2]|0)+(Y(G,w)|0)|0,0);x=f[c>>2]|0;z=x+(w*56|0)|0;if((z|0)==(e|0)){t=f[D>>2]|0;if(t|0?(M=t+12|0,t=f[M>>2]|0,f[M>>2]=t+-1,(t|0)==1):0)V$(e)}else{t=x+(w*56|0)+36|0;M=f[t>>2]|0;if(M|0?(L=M+12|0,M=f[L>>2]|0,f[L>>2]=M+-1,(M|0)==1):0)V$(z);f[t>>2]=0;M=x+(w*56|0)+16|0;L=x+(w*56|0)+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[L>>2]|0)>0){o=f[x+(w*56|0)+40>>2]|0;N=0;do{f[o+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[L>>2]|0))}f[z>>2]=f[e>>2];f[L>>2]=f[B>>2];N=x+(w*56|0)+8|0;f[N>>2]=f[s>>2];f[x+(w*56|0)+12>>2]=f[q>>2];f[M>>2]=f[C>>2];f[x+(w*56|0)+20>>2]=f[p>>2];f[x+(w*56|0)+24>>2]=f[K>>2];f[x+(w*56|0)+28>>2]=f[J>>2];f[x+(w*56|0)+32>>2]=f[y>>2];f[t>>2]=f[D>>2];o=x+(w*56|0)+44|0;I=f[o>>2]|0;Q=x+(w*56|0)+48|0;if((I|0)==(Q|0))_=I;else{wL(I);f[o>>2]=Q;f[x+(w*56|0)+40>>2]=N;_=Q}if((f[B>>2]|0)<3){Q=f[v>>2]|0;f[_>>2]=f[Q>>2];f[_+4>>2]=f[Q+4>>2]}else{f[o>>2]=f[v>>2];f[x+(w*56|0)+40>>2]=f[r>>2];f[v>>2]=n;f[r>>2]=s}f[e>>2]=1124007936;S=B;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0))}f[D>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){x=f[r>>2]|0;t=0;do{f[x+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[B>>2]|0))}t=f[m>>2]|0;if((t|0)!=(n|0))wL(t);w=w+1|0}while(w>>>0<A>>>0);u=d;return}case 0:{A=f[c>>2]|0;w=c+4|0;n=f[w>>2]|0;if((n|0)==(A|0)){u=d;return}else $=n;do{n=$+-56|0;f[w>>2]=n;m=$+-20|0;B=f[m>>2]|0;if(B|0?(r=B+12|0,B=f[r>>2]|0,f[r>>2]=B+-1,(B|0)==1):0)V$(n);f[m>>2]=0;m=$+-40|0;n=$+-52|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){m=f[$+-16>>2]|0;B=0;do{f[m+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[n>>2]|0))}n=f[$+-12>>2]|0;if((n|0)!=($+-8|0))wL(n);$=f[w>>2]|0}while(($|0)!=(A|0));u=d;return}case 4:{A=f[a+4>>2]|0;w=(f[A+4>>2]|0)-(f[A>>2]|0)|0;n=(w|0)/12|0;B=k&4095;hS(c,n);if((w|0)<=0){u=d;return}w=B|1124007936;m=g+4|0;r=g+8|0;C=j+4|0;D=g+12|0;s=g+16|0;v=g+20|0;y=g+24|0;J=g+28|0;K=g+40|0;p=g+48|0;q=g+44|0;G=g+52|0;H=Y(675553809>>>(B<<2&28)&15,(k>>>3&511)+1|0)|0;B=g+36|0;E=g+32|0;F=g+44|0;t=0;while(1){x=f[A>>2]|0;cS(j,a,t);M=f[x+(t*12|0)>>2]|0;f[g>>2]=w;f[m>>2]=2;x=f[C>>2]|0;f[r>>2]=x;L=f[j>>2]|0;f[D>>2]=L;f[s>>2]=M;f[v>>2]=M;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[K>>2]=r;f[q>>2]=p;f[G>>2]=0;f[p>>2]=0;if((M|0)==0&(Y(L,x)|0)!=0){aa=123;break}z=Y(L,H)|0;f[p>>2]=z;f[G>>2]=H;L=M+(Y(z,x)|0)|0;f[J>>2]=L;f[y>>2]=L+(0-z)+z;R$(g);z=f[c>>2]|0;L=z+(t*56|0)|0;if((L|0)==(g|0)){x=f[B>>2]|0;if(x|0?(M=x+12|0,x=f[M>>2]|0,f[M>>2]=x+-1,(x|0)==1):0)V$(g)}else{x=z+(t*56|0)+36|0;M=f[x>>2]|0;if(M|0?(o=M+12|0,M=f[o>>2]|0,f[o>>2]=M+-1,(M|0)==1):0)V$(L);f[x>>2]=0;M=z+(t*56|0)+16|0;o=z+(t*56|0)+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[o>>2]|0)>0){Q=f[z+(t*56|0)+40>>2]|0;N=0;do{f[Q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[o>>2]|0))}f[L>>2]=f[g>>2];f[o>>2]=f[m>>2];N=z+(t*56|0)+8|0;f[N>>2]=f[r>>2];f[z+(t*56|0)+12>>2]=f[D>>2];f[M>>2]=f[s>>2];f[z+(t*56|0)+20>>2]=f[v>>2];f[z+(t*56|0)+24>>2]=f[y>>2];f[z+(t*56|0)+28>>2]=f[J>>2];f[z+(t*56|0)+32>>2]=f[E>>2];f[x>>2]=f[B>>2];Q=z+(t*56|0)+44|0;I=f[Q>>2]|0;O=z+(t*56|0)+48|0;if((I|0)==(O|0))ba=I;else{wL(I);f[Q>>2]=O;f[z+(t*56|0)+40>>2]=N;ba=O}if((f[m>>2]|0)<3){O=f[F>>2]|0;f[ba>>2]=f[O>>2];f[ba+4>>2]=f[O+4>>2]}else{f[Q>>2]=f[F>>2];f[z+(t*56|0)+40>>2]=f[K>>2];f[F>>2]=p;f[K>>2]=r}f[g>>2]=1124007936;S=m;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0))}f[B>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[m>>2]|0)>0){z=f[K>>2]|0;x=0;do{f[z+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[m>>2]|0))}x=f[q>>2]|0;if((x|0)!=(p|0))wL(x);t=t+1|0;if((t|0)>=(n|0)){aa=207;break}}if((aa|0)==123){n=$Xc(32)|0;f[e>>2]=n;f[e+8>>2]=-2147483616;f[e+4>>2]=28;S=n;ca=470314;T=S+28|0;do{b[S>>0]=b[ca>>0]|0;S=S+1|0;ca=ca+1|0}while((S|0)<(T|0));b[n+28>>0]=0;vM(-215,e,470343,470347,577)}else if((aa|0)==207){u=d;return}break}case 5:{t=f[a+4>>2]|0;p=(f[t+4>>2]|0)-(f[t>>2]|0)|0;q=(p|0)/56|0;hS(c,q);if(!p){u=d;return}p=0;do{m=f[t>>2]|0;K=m+(p*56|0)|0;s=f[c>>2]|0;B=s+(p*56|0)|0;if((s|0)!=(m|0)){r=m+(p*56|0)+36|0;F=f[r>>2]|0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}E=s+(p*56|0)+36|0;F=f[E>>2]|0;if(F|0?(J=F+12|0,F=f[J>>2]|0,f[J>>2]=F+-1,(F|0)==1):0)V$(B);f[E>>2]=0;F=s+(p*56|0)+16|0;J=s+(p*56|0)+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[J>>2]|0)>0){y=f[s+(p*56|0)+40>>2]|0;v=0;do{f[y+(v<<2)>>2]=0;v=v+1|0;da=f[J>>2]|0}while((v|0)<(da|0));f[B>>2]=f[K>>2];if((da|0)<3)aa=159;else aa=161}else{f[B>>2]=f[K>>2];aa=159}if((aa|0)==159){aa=0;v=f[m+(p*56|0)+4>>2]|0;if((v|0)<3){f[J>>2]=v;f[s+(p*56|0)+8>>2]=f[m+(p*56|0)+8>>2];f[s+(p*56|0)+12>>2]=f[m+(p*56|0)+12>>2];v=f[m+(p*56|0)+44>>2]|0;y=f[s+(p*56|0)+44>>2]|0;f[y>>2]=f[v>>2];f[y+4>>2]=f[v+4>>2]}else aa=161}if((aa|0)==161){aa=0;U$(B,K)}f[F>>2]=f[m+(p*56|0)+16>>2];f[s+(p*56|0)+20>>2]=f[m+(p*56|0)+20>>2];f[s+(p*56|0)+24>>2]=f[m+(p*56|0)+24>>2];f[s+(p*56|0)+28>>2]=f[m+(p*56|0)+28>>2];f[s+(p*56|0)+32>>2]=f[m+(p*56|0)+32>>2];f[E>>2]=f[r>>2]}p=p+1|0}while(p>>>0<q>>>0);u=d;return}case 15:{q=f[a+4>>2]|0;p=f[a+12>>2]|0;hS(c,p);if(!p){u=d;return}t=0;do{n=q+(t*56|0)|0;v=f[c>>2]|0;y=v+(t*56|0)|0;if((v|0)!=(q|0)){D=q+(t*56|0)+36|0;H=f[D>>2]|0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}G=v+(t*56|0)+36|0;H=f[G>>2]|0;if(H|0?(C=H+12|0,H=f[C>>2]|0,f[C>>2]=H+-1,(H|0)==1):0)V$(y);f[G>>2]=0;H=v+(t*56|0)+16|0;C=v+(t*56|0)+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[C>>2]|0)>0){w=f[v+(t*56|0)+40>>2]|0;A=0;do{f[w+(A<<2)>>2]=0;A=A+1|0;ea=f[C>>2]|0}while((A|0)<(ea|0));f[y>>2]=f[n>>2];if((ea|0)<3)aa=177;else aa=179}else{f[y>>2]=f[n>>2];aa=177}if((aa|0)==177){aa=0;A=f[q+(t*56|0)+4>>2]|0;if((A|0)<3){f[C>>2]=A;f[v+(t*56|0)+8>>2]=f[q+(t*56|0)+8>>2];f[v+(t*56|0)+12>>2]=f[q+(t*56|0)+12>>2];A=f[q+(t*56|0)+44>>2]|0;w=f[v+(t*56|0)+44>>2]|0;f[w>>2]=f[A>>2];f[w+4>>2]=f[A+4>>2]}else aa=179}if((aa|0)==179){aa=0;U$(y,n)}f[H>>2]=f[q+(t*56|0)+16>>2];f[v+(t*56|0)+20>>2]=f[q+(t*56|0)+20>>2];f[v+(t*56|0)+24>>2]=f[q+(t*56|0)+24>>2];f[v+(t*56|0)+28>>2]=f[q+(t*56|0)+28>>2];f[v+(t*56|0)+32>>2]=f[q+(t*56|0)+32>>2];f[G>>2]=f[D>>2]}t=t+1|0}while((t|0)!=(p|0));u=d;return}case 11:{p=f[a+4>>2]|0;t=(f[p+4>>2]|0)-(f[p>>2]|0)|0;q=(t|0)/48|0;hS(c,q);if(!t){u=d;return}t=e+36|0;A=e+16|0;w=e+4|0;r=e+40|0;E=e+44|0;m=e+48|0;s=e+8|0;F=e+12|0;K=e+20|0;B=e+24|0;J=e+28|0;x=e+32|0;z=e+44|0;M=0;do{NQ(e,(f[p>>2]|0)+(M*48|0)|0,l);o=f[c>>2]|0;L=o+(M*56|0)|0;if((L|0)==(e|0)){Q=f[t>>2]|0;if(Q|0?(O=Q+12|0,Q=f[O>>2]|0,f[O>>2]=Q+-1,(Q|0)==1):0)V$(e)}else{Q=o+(M*56|0)+36|0;O=f[Q>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)V$(L);f[Q>>2]=0;O=o+(M*56|0)+16|0;N=o+(M*56|0)+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[N>>2]|0)>0){I=f[o+(M*56|0)+40>>2]|0;P=0;do{f[I+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[N>>2]|0))}f[L>>2]=f[e>>2];f[N>>2]=f[w>>2];P=o+(M*56|0)+8|0;f[P>>2]=f[s>>2];f[o+(M*56|0)+12>>2]=f[F>>2];f[O>>2]=f[A>>2];f[o+(M*56|0)+20>>2]=f[K>>2];f[o+(M*56|0)+24>>2]=f[B>>2];f[o+(M*56|0)+28>>2]=f[J>>2];f[o+(M*56|0)+32>>2]=f[x>>2];f[Q>>2]=f[t>>2];I=o+(M*56|0)+44|0;D=f[I>>2]|0;G=o+(M*56|0)+48|0;if((D|0)==(G|0))fa=D;else{wL(D);f[I>>2]=G;f[o+(M*56|0)+40>>2]=P;fa=G}if((f[w>>2]|0)<3){G=f[z>>2]|0;f[fa>>2]=f[G>>2];f[fa+4>>2]=f[G+4>>2]}else{f[I>>2]=f[z>>2];f[o+(M*56|0)+40>>2]=f[r>>2];f[z>>2]=m;f[r>>2]=s}f[e>>2]=1124007936;S=w;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0))}f[t>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[w>>2]|0)>0){o=f[r>>2]|0;Q=0;do{f[o+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[w>>2]|0))}Q=f[E>>2]|0;if((Q|0)!=(m|0))wL(Q);M=M+1|0}while(M>>>0<q>>>0);u=d;return}default:{q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=30;S=q;ca=231085;T=S+30|0;do{b[S>>0]=b[ca>>0]|0;S=S+1|0;ca=ca+1|0}while((S|0)<(T|0));b[q+30>>0]=0;vM(-213,e,231183,230788,270)}}while(0)}function hS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/56|0;h=d;if(g>>>0<b>>>0){iS(a,b-g|0);return}if(g>>>0<=b>>>0)return;g=e+(b*56|0)|0;if((h|0)==(g|0))return;else i=h;do{h=i+-56|0;f[c>>2]=h;b=i+-20|0;e=f[b>>2]|0;if(e|0?(a=e+12|0,e=f[a>>2]|0,f[a>>2]=e+-1,(e|0)==1):0)V$(h);f[b>>2]=0;b=i+-40|0;h=i+-52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[h>>2]|0)>0){b=f[i+-16>>2]|0;e=0;do{f[b+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[h>>2]|0))}h=f[i+-12>>2]|0;if((h|0)!=(i+-8|0))wL(h);i=f[c>>2]|0}while((i|0)!=(g|0));return}function iS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/56|0)>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=1124007936;k=j+8|0;l=j+40|0;m=j+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=j+48|0;f[j+44>>2]=o;f[o>>2]=0;f[j+52>>2]=0;j=(f[g>>2]|0)+56|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);u=c;return}i=f[a>>2]|0;j=(h-i|0)/56|0;h=j+b|0;if(h>>>0>76695844)kWc(a);g=(e-i|0)/56|0;i=g<<1;e=g>>>0<38347922?(i>>>0<h>>>0?h:i):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>76695844){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{p=$Xc(e*56|0)|0;break}else p=0;while(0);f[d>>2]=p;i=p+(j*56|0)|0;j=d+8|0;f[j>>2]=i;f[d+4>>2]=i;f[d+12>>2]=p+(e*56|0);e=b;b=i;while(1){f[b>>2]=1124007936;i=b+8|0;g=b+40|0;m=b+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[g>>2]=i;k=b+48|0;f[b+44>>2]=k;f[k>>2]=0;f[b+52>>2]=0;e=e+-1|0;if(!e)break;else b=b+56|0}f[j>>2]=p+(h*56|0);cx(a,d);dx(d);u=c;return}function jS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+48|0;e=d;g=f[a>>2]|0;h=g&50331648;i=g&2031616;if((i|0)<655360){if((i|0)<65536){switch(i|0){case 0:break;default:{j=$Xc(32)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483616;l=e+4|0;f[l>>2]=30;m=j;n=231085;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+30|0;b[p>>0]=0;vM(-213,e,393821,230788,332)}}g=f[c>>2]|0;q=c+4|0;r=f[q>>2]|0;if((r|0)==(g|0)){u=d;return}else s=r;do{r=s+-48|0;f[q>>2]=r;EQ(r);s=f[q>>2]|0}while((s|0)!=(g|0));u=d;return}if((i|0)<327680){switch(i|0){case 65536:break;default:{j=$Xc(32)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483616;l=e+4|0;f[l>>2]=30;m=j;n=231085;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+30|0;b[p>>0]=0;vM(-213,e,393821,230788,332)}}g=f[a+4>>2]|0;s=c+4|0;q=f[s>>2]|0;r=f[c>>2]|0;t=q-r|0;v=(t|0)/48|0;w=r;r=q;if(t){if(v>>>0>1?(t=w+48|0,(r|0)!=(t|0)):0){w=r;do{r=w+-48|0;f[s>>2]=r;EQ(r);w=f[s>>2]|0}while((w|0)!=(t|0))}}else kS(c,1-v|0);zQ(e,g,h,0);g=f[c>>2]|0;if((g|0)!=(e|0)){v=g+24|0;t=f[v>>2]|0;if(t|0?(w=t+8|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)FQ(g);t=g+4|0;if((f[t>>2]|0)>0){w=f[g+32>>2]|0;s=0;do{f[w+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[t>>2]|0))}f[v>>2]=0;f[g>>2]=f[e>>2];s=e+4|0;f[t>>2]=f[s>>2];t=e+8|0;w=g+8|0;f[w>>2]=f[t>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2];r=e+24|0;f[v>>2]=f[r>>2];v=e+28|0;f[g+28>>2]=f[v>>2];q=g+36|0;x=f[q>>2]|0;y=g+40|0;if((x|0)==(y|0))z=x;else{wL(x);f[q>>2]=y;f[g+32>>2]=w;z=y}y=e+36|0;if((f[s>>2]|0)<3){w=f[y>>2]|0;f[z>>2]=f[w>>2];f[z+4>>2]=f[w+4>>2]}else{f[q>>2]=f[y>>2];q=e+32|0;f[g+32>>2]=f[q>>2];f[y>>2]=e+40;f[q>>2]=t}f[e>>2]=1124007936;f[r>>2]=0;f[v>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0}EQ(e);u=d;return}switch(i|0){case 327680:break;default:{j=$Xc(32)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483616;l=e+4|0;f[l>>2]=30;m=j;n=231085;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+30|0;b[p>>0]=0;vM(-213,e,393821,230788,332)}}s=f[a+4>>2]|0;v=(f[s+4>>2]|0)-(f[s>>2]|0)|0;r=(v|0)/56|0;t=c+4|0;q=f[t>>2]|0;y=f[c>>2]|0;g=(q-y|0)/48|0;w=y;y=q;if(r>>>0<=g>>>0){if(r>>>0<g>>>0?(q=w+(r*48|0)|0,(y|0)!=(q|0)):0){w=y;do{y=w+-48|0;f[t>>2]=y;EQ(y);w=f[t>>2]|0}while((w|0)!=(q|0))}}else kS(c,r-g|0);if(!v){u=d;return}v=e+4|0;g=e+8|0;q=e+12|0;w=e+16|0;t=e+20|0;y=e+24|0;z=e+28|0;x=e+36|0;A=e+32|0;B=e+40|0;C=0;do{zQ(e,(f[s>>2]|0)+(C*56|0)|0,h,0);D=f[c>>2]|0;E=D+(C*48|0)|0;if((E|0)!=(e|0)){F=D+(C*48|0)+24|0;G=f[F>>2]|0;if(G|0?(H=G+8|0,G=f[H>>2]|0,f[H>>2]=G+-1,(G|0)==1):0)FQ(E);G=D+(C*48|0)+4|0;if((f[G>>2]|0)>0){H=f[D+(C*48|0)+32>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[G>>2]|0))}f[F>>2]=0;f[E>>2]=f[e>>2];f[G>>2]=f[v>>2];I=D+(C*48|0)+8|0;f[I>>2]=f[g>>2];f[D+(C*48|0)+12>>2]=f[q>>2];f[D+(C*48|0)+16>>2]=f[w>>2];f[D+(C*48|0)+20>>2]=f[t>>2];f[F>>2]=f[y>>2];f[D+(C*48|0)+28>>2]=f[z>>2];H=D+(C*48|0)+36|0;J=f[H>>2]|0;K=D+(C*48|0)+40|0;if((J|0)==(K|0))L=J;else{wL(J);f[H>>2]=K;f[D+(C*48|0)+32>>2]=I;L=K}if((f[v>>2]|0)<3){K=f[x>>2]|0;f[L>>2]=f[K>>2];f[L+4>>2]=f[K+4>>2]}else{f[H>>2]=f[x>>2];f[D+(C*48|0)+32>>2]=f[A>>2];f[x>>2]=B;f[A>>2]=g}f[e>>2]=1124007936;f[y>>2]=0;f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0}EQ(e);C=C+1|0}while(C>>>0<r>>>0);u=d;return}if((i|0)<720896){switch(i|0){case 655360:break;default:{j=$Xc(32)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483616;l=e+4|0;f[l>>2]=30;m=j;n=231085;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+30|0;b[p>>0]=0;vM(-213,e,393821,230788,332)}}r=f[a+4>>2]|0;C=c+4|0;v=f[C>>2]|0;z=f[c>>2]|0;y=v-z|0;g=(y|0)/48|0;A=z;z=v;if(y){if(g>>>0>1?(y=A+48|0,(z|0)!=(y|0)):0){A=z;do{z=A+-48|0;f[C>>2]=z;EQ(z);A=f[C>>2]|0}while((A|0)!=(y|0))}}else kS(c,1-g|0);g=f[c>>2]|0;if((g|0)==(r|0)){u=d;return}y=r+24|0;A=f[y>>2]|0;if(A|0){C=A+8|0;f[C>>2]=(f[C>>2]|0)+1}C=g+24|0;A=f[C>>2]|0;if(A|0?(z=A+8|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)FQ(g);A=g+4|0;if((f[A>>2]|0)>0){z=f[g+32>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0;M=f[A>>2]|0}while((v|0)<(M|0));f[C>>2]=0;f[g>>2]=f[r>>2];if((M|0)<3)N=87;else N=89}else{f[C>>2]=0;f[g>>2]=f[r>>2];N=87}if((N|0)==87){M=f[r+4>>2]|0;if((M|0)<3){f[A>>2]=M;f[g+8>>2]=f[r+8>>2];f[g+12>>2]=f[r+12>>2];M=f[r+36>>2]|0;A=f[g+36>>2]|0;f[A>>2]=f[M>>2];f[A+4>>2]=f[M+4>>2]}else N=89}if((N|0)==89)DQ(g,r);f[g+16>>2]=f[r+16>>2];M=g+20|0;if(!(f[M>>2]|0))f[M>>2]=f[r+20>>2];f[C>>2]=f[y>>2];f[g+28>>2]=f[r+28>>2];u=d;return}if((i|0)>=983040){switch(i|0){case 983040:break;default:{j=$Xc(32)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483616;l=e+4|0;f[l>>2]=30;m=j;n=231085;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+30|0;b[p>>0]=0;vM(-213,e,393821,230788,332)}}r=f[a+4>>2]|0;g=f[a+12>>2]|0;y=c+4|0;C=f[y>>2]|0;M=f[c>>2]|0;A=(C-M|0)/48|0;v=M;M=C;if(g>>>0<=A>>>0){if(g>>>0<A>>>0?(C=v+(g*48|0)|0,(M|0)!=(C|0)):0){v=M;do{M=v+-48|0;f[y>>2]=M;EQ(M);v=f[y>>2]|0}while((v|0)!=(C|0))}if(!g){u=d;return}}else kS(c,g-A|0);A=e+4|0;C=e+8|0;v=e+12|0;y=e+16|0;M=e+20|0;z=e+24|0;B=e+28|0;x=e+36|0;L=e+32|0;t=e+40|0;w=0;do{zQ(e,r+(w*56|0)|0,h,0);q=f[c>>2]|0;s=q+(w*48|0)|0;if((s|0)!=(e|0)){H=q+(w*48|0)+24|0;K=f[H>>2]|0;if(K|0?(I=K+8|0,K=f[I>>2]|0,f[I>>2]=K+-1,(K|0)==1):0)FQ(s);K=q+(w*48|0)+4|0;if((f[K>>2]|0)>0){I=f[q+(w*48|0)+32>>2]|0;J=0;do{f[I+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[K>>2]|0))}f[H>>2]=0;f[s>>2]=f[e>>2];f[K>>2]=f[A>>2];J=q+(w*48|0)+8|0;f[J>>2]=f[C>>2];f[q+(w*48|0)+12>>2]=f[v>>2];f[q+(w*48|0)+16>>2]=f[y>>2];f[q+(w*48|0)+20>>2]=f[M>>2];f[H>>2]=f[z>>2];f[q+(w*48|0)+28>>2]=f[B>>2];I=q+(w*48|0)+36|0;D=f[I>>2]|0;F=q+(w*48|0)+40|0;if((D|0)==(F|0))O=D;else{wL(D);f[I>>2]=F;f[q+(w*48|0)+32>>2]=J;O=F}if((f[A>>2]|0)<3){F=f[x>>2]|0;f[O>>2]=f[F>>2];f[O+4>>2]=f[F+4>>2]}else{f[I>>2]=f[x>>2];f[q+(w*48|0)+32>>2]=f[L>>2];f[x>>2]=t;f[L>>2]=C}f[e>>2]=1124007936;f[z>>2]=0;f[B>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0}EQ(e);w=w+1|0}while(w>>>0<g>>>0);u=d;return}switch(i|0){case 720896:break;default:{j=$Xc(32)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483616;l=e+4|0;f[l>>2]=30;m=j;n=231085;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+30|0;b[p>>0]=0;vM(-213,e,393821,230788,332)}}e=f[a+4>>2]|0;a=(f[e+4>>2]|0)-(f[e>>2]|0)|0;p=(a|0)/48|0;j=c+4|0;n=f[j>>2]|0;m=f[c>>2]|0;o=(n-m|0)/48|0;l=m;m=n;if(p>>>0<=o>>>0){if(p>>>0<o>>>0?(n=l+(p*48|0)|0,(m|0)!=(n|0)):0){l=m;do{m=l+-48|0;f[j>>2]=m;EQ(m);l=f[j>>2]|0}while((l|0)!=(n|0))}}else kS(c,p-o|0);if(!a){u=d;return}a=0;do{o=f[e>>2]|0;n=o+(a*48|0)|0;l=f[c>>2]|0;j=l+(a*48|0)|0;if((l|0)!=(o|0)){m=o+(a*48|0)+24|0;k=f[m>>2]|0;if(k|0){i=k+8|0;f[i>>2]=(f[i>>2]|0)+1}i=l+(a*48|0)+24|0;k=f[i>>2]|0;if(k|0?(g=k+8|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)FQ(j);k=l+(a*48|0)+4|0;if((f[k>>2]|0)>0){g=f[l+(a*48|0)+32>>2]|0;w=0;do{f[g+(w<<2)>>2]=0;w=w+1|0;P=f[k>>2]|0}while((w|0)<(P|0));f[i>>2]=0;f[j>>2]=f[n>>2];if((P|0)<3)N=64;else N=66}else{f[i>>2]=0;f[j>>2]=f[n>>2];N=64}if((N|0)==64){N=0;w=f[o+(a*48|0)+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l+(a*48|0)+8>>2]=f[o+(a*48|0)+8>>2];f[l+(a*48|0)+12>>2]=f[o+(a*48|0)+12>>2];w=f[o+(a*48|0)+36>>2]|0;g=f[l+(a*48|0)+36>>2]|0;f[g>>2]=f[w>>2];f[g+4>>2]=f[w+4>>2]}else N=66}if((N|0)==66){N=0;DQ(j,n)}f[l+(a*48|0)+16>>2]=f[o+(a*48|0)+16>>2];w=l+(a*48|0)+20|0;if(!(f[w>>2]|0))f[w>>2]=f[o+(a*48|0)+20>>2];f[i>>2]=f[m>>2];f[l+(a*48|0)+28>>2]=f[o+(a*48|0)+28>>2]}a=a+1|0}while(a>>>0<p>>>0);u=d;return}function kS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=1124007936;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[i+32>>2]=i+8;j=i+40|0;f[i+36>>2]=j;f[i+44>>2]=0;f[j>>2]=0;i=(f[e>>2]|0)+48|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/48|0;g=i+b|0;if(g>>>0>89478485)kWc(a);j=(d-h|0)/48|0;h=j<<1;d=j>>>0<44739242?(h>>>0<g>>>0?g:h):89478485;do if(d)if(d>>>0>89478485){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*48|0)|0;break}else k=0;while(0);h=k+(i*48|0)|0;i=h;g=k+(d*48|0)|0;d=b;b=i;k=h;do{f[k>>2]=1124007936;j=k+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[k+32>>2]=k+8;j=k+40|0;f[k+36>>2]=j;f[k+44>>2]=0;f[j>>2]=0;k=b+48|0;b=k;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;k=f[e>>2]|0;if((k|0)==(g|0)){l=i;m=g;n=g}else{j=k;k=i;i=h;do{h=i+-48|0;o=j;j=j+-48|0;f[h>>2]=f[j>>2];p=i+-44|0;q=o+-44|0;f[p>>2]=f[q>>2];r=i+-40|0;f[r>>2]=f[o+-40>>2];f[i+-36>>2]=f[o+-36>>2];f[i+-32>>2]=f[o+-32>>2];f[i+-28>>2]=f[o+-28>>2];s=f[o+-24>>2]|0;f[i+-24>>2]=s;f[i+-20>>2]=f[o+-20>>2];f[i+-16>>2]=r;r=i+-8|0;t=i+-12|0;f[t>>2]=r;f[i+-4>>2]=0;f[r>>2]=0;if(s|0){r=s+8|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+-12>>2]|0;o=f[t>>2]|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2]}else{f[p>>2]=0;DQ(h,j)}i=k+-48|0;k=i}while((j|0)!=(g|0));l=k;m=f[a>>2]|0;n=f[e>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=d;d=m;if((n|0)!=(d|0)){c=n;do{c=c+-48|0;EQ(c)}while((c|0)!=(d|0))}if(!m)return;cYc(m);return}function lS(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;cS(d,a,b);u=c;return f[d+4>>2]|0}function mS(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;cS(d,a,b);u=c;return f[d>>2]|0}function nS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;e=f[b>>2]&2031616;g=f[a>>2]&2031616;a:do if((g|0)<655360){switch(g|0){case 65536:break;default:{h=36;break a}}i=f[a+4>>2]|0;j=e&2097151;b:do if((j|0)<655360){switch(j|0){case 65536:break;default:break b}k=f[i+40>>2]|0;l=f[k+-4>>2]|0;m=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[m+-4>>2]|0)){n=0;break a}if((l|0)==2){if((f[k>>2]|0)!=(f[m>>2]|0)){n=0;break a}n=(f[k+4>>2]|0)==(f[m+4>>2]|0);break a}if((l|0)>0)o=0;else{n=1;break a}while(1){if((f[k+(o<<2)>>2]|0)!=(f[m+(o<<2)>>2]|0)){n=0;break a}o=o+1|0;if((o|0)>=(l|0)){n=1;break a}}}else{switch(j|0){case 655360:break;default:break b}l=f[i+40>>2]|0;m=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((m|0)!=(f[k+-4>>2]|0)){n=0;break a}if((m|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;break a}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);break a}if((m|0)>0)p=0;else{n=1;break a}while(1){if((f[l+(p<<2)>>2]|0)!=(f[k+(p<<2)>>2]|0)){n=0;break a}p=p+1|0;if((p|0)>=(m|0)){n=1;break a}}}while(0);if((f[i+4>>2]|0)>2)n=0;else{j=f[i+40>>2]|0;q=f[j+4>>2]|0;r=f[j>>2]|0;h=37}}else{switch(g|0){case 655360:break;default:{h=36;break a}}j=f[a+4>>2]|0;m=e&2097151;c:do if((m|0)<655360){switch(m|0){case 65536:break;default:break c}k=f[j+32>>2]|0;l=f[k+-4>>2]|0;s=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[s+-4>>2]|0)){n=0;break a}if((l|0)==2){if((f[k>>2]|0)!=(f[s>>2]|0)){n=0;break a}n=(f[k+4>>2]|0)==(f[s+4>>2]|0);break a}if((l|0)>0)t=0;else{n=1;break a}while(1){if((f[k+(t<<2)>>2]|0)!=(f[s+(t<<2)>>2]|0)){n=0;break a}t=t+1|0;if((t|0)>=(l|0)){n=1;break a}}}else{switch(m|0){case 655360:break;default:break c}l=f[j+32>>2]|0;s=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((s|0)!=(f[k+-4>>2]|0)){n=0;break a}if((s|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;break a}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);break a}if((s|0)>0)v=0;else{n=1;break a}while(1){if((f[l+(v<<2)>>2]|0)!=(f[k+(v<<2)>>2]|0)){n=0;break a}v=v+1|0;if((v|0)>=(s|0)){n=1;break a}}}while(0);if((f[j+4>>2]|0)>2)n=0;else{m=f[j+32>>2]|0;q=f[m+4>>2]|0;r=f[m>>2]|0;h=37}}while(0);if((h|0)==36){cS(d,a,-1);q=f[d>>2]|0;r=f[d+4>>2]|0;h=37}if((h|0)==37)if((oS(b,-1)|0)>2)n=0;else{cS(d,b,-1);n=(f[d>>2]|0)==(q|0)?(f[d+4>>2]|0)==(r|0):0}u=c;return n|0}function oS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;do switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,625)}g=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return g|0}case 6:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,631)}g=f[(f[a+4>>2]|0)+12>>2]|0;u=d;return g|0}case 10:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,637)}g=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return g|0}case 2:case 14:{if((c|0)<0){g=2;u=d;return g|0}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,643)}break}case 3:case 12:{if((c|0)<0){g=2;u=d;return g|0}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,649)}break}case 4:{if((c|0)<0){g=1;u=d;return g|0}h=f[a+4>>2]|0;if((((f[h+4>>2]|0)-(f[h>>2]|0)|0)/12|0|0)>(c|0)){g=2;u=d;return g|0}else{h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=18;i=h;j=231142;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+18>>0]=0;vM(-215,e,231196,230788,661)}break}case 5:{l=f[a+4>>2]|0;if((c|0)<0){g=1;u=d;return g|0}m=f[l>>2]|0;if((((f[l+4>>2]|0)-m|0)/56|0|0)<=(c|0)){l=$Xc(32)|0;f[e>>2]=l;f[e+8>>2]=-2147483616;f[e+4>>2]=18;i=l;j=231142;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[l+18>>0]=0;vM(-215,e,231196,230788,670)}g=f[m+(c*56|0)+4>>2]|0;u=d;return g|0}case 15:{h=f[a+4>>2]|0;if((c|0)<0){g=1;u=d;return g|0}if((f[a+12>>2]|0)<=(c|0)){n=$Xc(16)|0;f[e>>2]=n;f[e+8>>2]=-2147483632;f[e+4>>2]=13;i=n;j=231161;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[n+13>>0]=0;vM(-215,e,231196,230788,680)}g=f[h+(c*56|0)+4>>2]|0;u=d;return g|0}case 11:{m=f[a+4>>2]|0;if((c|0)<0){g=1;u=d;return g|0}l=f[m>>2]|0;if((((f[m+4>>2]|0)-l|0)/48|0|0)<=(c|0)){m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=18;i=m;j=231142;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[m+18>>0]=0;vM(-215,e,231196,230788,690)}g=f[l+(c*48|0)+4>>2]|0;u=d;return g|0}case 7:{if((c|0)<0){g=2;u=d;return g|0}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,697)}break}case 9:{if((c|0)<0){g=2;u=d;return g|0}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,703)}break}case 8:{if((c|0)<0){g=2;u=d;return g|0}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,231196,230788,709)}break}case 0:{g=0;u=d;return g|0}default:{h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=30;i=h;j=231085;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+30>>0]=0;vM(-213,e,231196,230788,713)}}while(0);return 0}function pS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;a:do if((g|0)>=655360){if((g|0)<720896){switch(g|0){case 655360:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,454614,230788,728)}h=f[a+4>>2]|0;i=f[h+4>>2]|0;if((i|0)<3){j=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;u=d;return j|0}k=f[h+32>>2]|0;h=0;l=1;while(1){m=Y(f[k+(h<<2)>>2]|0,l)|0;h=h+1|0;if((h|0)==(i|0)){j=m;break}else l=m}u=d;return j|0}if((g|0)<983040){switch(g|0){case 720896:break;default:break a}l=f[a+4>>2]|0;i=f[l>>2]|0;h=((f[l+4>>2]|0)-i|0)/48|0;l=i;if((c|0)<0){j=h;u=d;return j|0}if((h|0)<=(c|0)){h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=18;n=h;o=231142;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+18>>0]=0;vM(-215,e,454614,230788,758)}i=f[l+(c*48|0)+4>>2]|0;if((i|0)<3){j=Y(f[l+(c*48|0)+12>>2]|0,f[l+(c*48|0)+8>>2]|0)|0;u=d;return j|0}k=f[l+(c*48|0)+32>>2]|0;m=0;q=1;while(1){r=Y(f[k+(m<<2)>>2]|0,q)|0;m=m+1|0;if((m|0)==(i|0)){j=r;break}else q=r}u=d;return j|0}else{switch(g|0){case 983040:break;default:break a}q=f[a+4>>2]|0;i=f[a+12>>2]|0;if((c|0)<0){j=i;u=d;return j|0}if((i|0)<=(c|0)){i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=13;n=i;o=231161;p=n+13|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[i+13>>0]=0;vM(-215,e,454614,230788,748)}m=f[q+(c*56|0)+4>>2]|0;if((m|0)<3){j=Y(f[q+(c*56|0)+12>>2]|0,f[q+(c*56|0)+8>>2]|0)|0;u=d;return j|0}k=f[q+(c*56|0)+40>>2]|0;l=0;h=1;while(1){r=Y(f[k+(l<<2)>>2]|0,h)|0;l=l+1|0;if((l|0)==(m|0)){j=r;break}else h=r}u=d;return j|0}}else{if((g|0)<327680){switch(g|0){case 65536:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[230774]|0;b[e+1>>0]=b[230775]|0;b[e+2>>0]=b[230776]|0;b[e+3>>0]=b[230777]|0;b[e+4>>0]=b[230778]|0;b[e+5>>0]=0;vM(-215,e,454614,230788,722)}h=f[a+4>>2]|0;m=f[h+4>>2]|0;if((m|0)<3){j=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;u=d;return j|0}l=f[h+40>>2]|0;h=0;k=1;while(1){q=Y(f[l+(h<<2)>>2]|0,k)|0;h=h+1|0;if((h|0)==(m|0)){j=q;break}else k=q}u=d;return j|0}switch(g|0){case 327680:break;default:break a}k=f[a+4>>2]|0;m=f[k>>2]|0;h=((f[k+4>>2]|0)-m|0)/56|0;k=m;if((c|0)<0){j=h;u=d;return j|0}if((h|0)<=(c|0)){h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=18;n=h;o=231142;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+18>>0]=0;vM(-215,e,454614,230788,738)}m=f[k+(c*56|0)+4>>2]|0;if((m|0)<3){j=Y(f[k+(c*56|0)+12>>2]|0,f[k+(c*56|0)+8>>2]|0)|0;u=d;return j|0}l=f[k+(c*56|0)+40>>2]|0;q=0;i=1;while(1){r=Y(f[l+(q<<2)>>2]|0,i)|0;q=q+1|0;if((q|0)==(m|0)){j=r;break}else i=r}u=d;return j|0}while(0);cS(e,a,c);j=Y(f[e+4>>2]|0,f[e>>2]|0)|0;u=d;return j|0}function qS(a,b){a=a|0;b=b|0;return (dS(a,b)|0)&7|0}function rS(a,b){a=a|0;b=b|0;return ((dS(a,b)|0)>>>3&511)+1|0}function sS(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;do switch((f[a>>2]|0)>>>16&31){case 1:{e=f[a+4>>2]|0;if(!(f[e+16>>2]|0)){g=1;u=c;return g|0}h=f[e+4>>2]|0;if((h|0)<3)i=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{j=f[e+40>>2]|0;e=0;k=1;while(1){l=Y(f[j+(e<<2)>>2]|0,k)|0;e=e+1|0;if((e|0)==(h|0)){i=l;break}else k=l}}g=(h|0)==0|(i|0)==0;u=c;return g|0}case 10:{k=f[a+4>>2]|0;if(!(f[k+24>>2]|0)){g=1;u=c;return g|0}e=f[k+4>>2]|0;if((e|0)<3)m=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{j=f[k+32>>2]|0;k=0;l=1;while(1){n=Y(f[j+(k<<2)>>2]|0,l)|0;k=k+1|0;if((k|0)==(e|0)){m=n;break}else l=n}}g=(e|0)==0|(m|0)==0;u=c;return g|0}case 3:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 12:{g=(f[(f[a+4>>2]|0)+4>>2]|0)==0;u=c;return g|0}case 0:{g=1;u=c;return g|0}case 4:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 5:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 15:{g=(f[a+12>>2]|0)==0;u=c;return g|0}case 11:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 7:{l=f[a+4>>2]|0;if(!(f[l+8>>2]|0)){g=1;u=c;return g|0}g=(f[l+12>>2]|0)==0;u=c;return g|0}case 9:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 13:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 8:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 2:case 14:case 6:{g=0;u=c;return g|0}default:{l=$Xc(32)|0;f[d>>2]=l;f[d+8>>2]=-2147483616;f[d+4>>2]=30;k=l;j=231085;h=k+30|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));b[l+30>>0]=0;vM(-213,d,231201,230788,923)}}while(0);return 0}function tS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 10:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 5:{h=f[a+4>>2]|0;if((c|0)<=-1){i=$Xc(32)|0;f[e>>2]=i;j=e+8|0;f[j>>2]=-2147483616;k=e+4|0;f[k>>2]=31;l=i;m=231207;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));o=i+31|0;b[o>>0]=0;vM(-215,e,231239,230788,943)}p=f[h>>2]|0;if((((f[h+4>>2]|0)-p|0)/56|0)>>>0<=c>>>0){i=$Xc(32)|0;f[e>>2]=i;j=e+8|0;f[j>>2]=-2147483616;k=e+4|0;f[k>>2]=31;l=i;m=231207;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));o=i+31|0;b[o>>0]=0;vM(-215,e,231239,230788,943)}g=(f[p+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 15:{p=f[a+4>>2]|0;if((c|0)<=0){q=$Xc(32)|0;f[e>>2]=q;r=e+8|0;f[r>>2]=-2147483616;s=e+4|0;f[s>>2]=22;l=q;m=231252;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t=q+22|0;b[t>>0]=0;vM(-215,e,231239,230788,950)}if((f[a+12>>2]|0)<=(c|0)){q=$Xc(32)|0;f[e>>2]=q;r=e+8|0;f[r>>2]=-2147483616;s=e+4|0;f[s>>2]=22;l=q;m=231252;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));t=q+22|0;b[t>>0]=0;vM(-215,e,231239,230788,950)}g=(f[p+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 11:{p=f[a+4>>2]|0;if((c|0)<=-1){v=$Xc(32)|0;f[e>>2]=v;w=e+8|0;f[w>>2]=-2147483616;x=e+4|0;f[x>>2]=31;l=v;m=231207;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));y=v+31|0;b[y>>0]=0;vM(-215,e,231239,230788,957)}t=f[p>>2]|0;if((((f[p+4>>2]|0)-t|0)/48|0)>>>0<=c>>>0){v=$Xc(32)|0;f[e>>2]=v;w=e+8|0;f[w>>2]=-2147483616;x=e+4|0;f[x>>2]=31;l=v;m=231207;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));y=v+31|0;b[y>>0]=0;vM(-215,e,231239,230788,957)}g=(f[t+(c*48|0)>>2]&16384|0)!=0;u=d;return g|0}case 9:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 0:case 2:case 3:case 4:case 6:case 12:case 14:{g=1;u=d;return g|0}default:{g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=g;m=231085;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[g+30>>0]=0;vM(-213,e,231239,230788,964)}}return 0}function uS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c;e=f[a>>2]|0;switch(e>>>16&31){case 0:{vS(b);u=c;return}case 1:case 2:case 3:case 12:case 14:{do if((e&2031616|0)==65536){g=f[a+4>>2]|0;f[d>>2]=f[g>>2];h=d+4|0;i=g+4|0;f[h>>2]=f[i>>2];j=d+8|0;f[j>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[d+36>>2]=k;f[d+40>>2]=j;j=d+48|0;l=d+44|0;f[l>>2]=j;f[j>>2]=0;f[d+52>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[g+44>>2]|0;j=f[l>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];break}else{f[h>>2]=0;U$(d,g);break}}else bS(d,a,-1);while(0);jR(d,b);e=d+36|0;g=f[e>>2]|0;if(g|0?(h=g+12|0,g=f[h>>2]|0,f[h>>2]=g+-1,(g|0)==1):0)V$(d);f[e>>2]=0;e=d+16|0;g=d+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[d+40>>2]|0;h=0;do{f[e+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[g>>2]|0))}g=f[d+44>>2]|0;if((g|0)!=(d+48|0))wL(g);u=c;return}case 6:{g=f[a+4>>2]|0;if((f[b>>2]&2031616|0)==65536){h=f[g>>2]|0;ei[f[(f[h>>2]|0)+12>>2]&511](h,g,f[b+4>>2]|0,-1);u=c;return}f[d>>2]=1124007936;h=d+4|0;e=d+8|0;i=d+40|0;j=h;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[i>>2]=e;e=d+48|0;j=d+44|0;f[j>>2]=e;f[e>>2]=0;f[d+52>>2]=0;l=f[g>>2]|0;ei[f[(f[l>>2]|0)+12>>2]&511](l,g,d,-1);jR(d,b);g=d+36|0;l=f[g>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)V$(d);f[g>>2]=0;g=d+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[i>>2]|0;i=0;do{f[g+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)!=(e|0))wL(h);u=c;return}case 10:{LQ(f[a+4>>2]|0,b);u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-213,d,231275,230788,1155)}}}function vS(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+32|0;d=c+8|0;e=c;g=f[a>>2]|0;if(g&1073741824|0){h=$Xc(16)|0;f[d>>2]=h;f[d+8>>2]=-2147483632;f[d+4>>2]=12;i=h;j=231282;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+12>>0]=0;vM(-215,d,511661,230788,1669)}do switch(g>>>16&31){case 1:{h=f[a+4>>2]|0;l=h+36|0;m=f[l>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(h);f[l>>2]=0;l=h+16|0;m=h+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)<=0){u=c;return}l=f[h+40>>2]|0;h=0;do{f[l+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[m>>2]|0));u=c;return}case 10:{m=f[a+4>>2]|0;h=m+24|0;l=f[h>>2]|0;if(l|0?(n=l+8|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)FQ(m);l=m+4|0;if((f[l>>2]|0)>0){n=f[m+32>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}f[h>>2]=0;u=c;return}case 9:{u=c;return}case 8:{u=c;return}case 7:{TW(f[a+4>>2]|0);u=c;return}case 3:{f[e>>2]=0;f[e+4>>2]=0;wS(a,e,g&4095,-1,0,0);u=c;return}case 4:{l=f[a+4>>2]|0;m=f[l>>2]|0;n=l+4|0;l=f[n>>2]|0;if((l|0)==(m|0)){u=c;return}else o=l;while(1){l=o+-12|0;f[n>>2]=l;p=f[l>>2]|0;if(!p)q=l;else{l=o+-8|0;if((f[l>>2]|0)!=(p|0))f[l>>2]=p;cYc(p);q=f[n>>2]|0}if((q|0)==(m|0))break;else o=q}u=c;return}case 5:{m=f[a+4>>2]|0;n=f[m>>2]|0;h=m+4|0;m=f[h>>2]|0;if((m|0)==(n|0)){u=c;return}else r=m;do{m=r+-56|0;f[h>>2]=m;p=r+-20|0;l=f[p>>2]|0;if(l|0?(s=l+12|0,l=f[s>>2]|0,f[s>>2]=l+-1,(l|0)==1):0)V$(m);f[p>>2]=0;p=r+-40|0;m=r+-52|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[r+-16>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[r+-12>>2]|0;if((m|0)!=(r+-8|0))wL(m);r=f[h>>2]|0}while((r|0)!=(n|0));u=c;return}case 11:{n=f[a+4>>2]|0;h=f[n>>2]|0;m=n+4|0;n=f[m>>2]|0;if((n|0)==(h|0)){u=c;return}else t=n;do{n=t+-48|0;f[m>>2]=n;EQ(n);t=f[m>>2]|0}while((t|0)!=(h|0));u=c;return}case 13:{h=f[a+4>>2]|0;m=f[h>>2]|0;n=h+4|0;while(1){h=f[n>>2]|0;if((h|0)==(m|0))break;f[n>>2]=h+-36}u=c;return}case 0:{u=c;return}default:{n=$Xc(32)|0;f[d>>2]=n;f[d+8>>2]=-2147483616;f[d+4>>2]=30;i=n;j=231085;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[n+30>>0]=0;vM(-213,d,511661,230788,1734)}}while(0)}function wS(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;l=k&2031616;m=(e|0)<0;do if(m&(l|0)==65536){if((h|0)==0&(g^1)){if(k&1073741824|0?(n=f[(f[a+4>>2]|0)+40>>2]|0,!((f[c>>2]|0)==(f[n+4>>2]|0)?(f[c+4>>2]|0)==(f[n>>2]|0):0)):0){n=$Xc(64)|0;f[j>>2]=n;f[j+8>>2]=-2147483584;f[j+4>>2]=53;o=n;p=231295;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+53>>0]=0;vM(-215,j,467262,230788,1194)}r=f[a+4>>2]|0;if((k|0)<0?(f[r>>2]&4095|0)!=(d|0):0){s=$Xc(48)|0;f[j>>2]=s;f[j+8>>2]=-2147483600;f[j+4>>2]=44;o=s;p=231349;q=o+44|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[s+44>>0]=0;vM(-215,j,467262,230788,1195)}n=f[c>>2]|0;t=f[c+4>>2]|0;v=d&4095;if(((((f[r+4>>2]|0)<3?(f[r+8>>2]|0)==(t|0):0)?(f[r+12>>2]|0)==(n|0):0)?(f[r>>2]&4095|0)==(v|0):0)?f[r+16>>2]|0:0){u=i;return}f[j>>2]=t;f[j+4>>2]=n;S$(r,2,j,v);u=i;return}}else{if(m&(l|0)==655360){if(!((h|0)==0&(g^1)))break;if(k&1073741824|0?(v=f[(f[a+4>>2]|0)+32>>2]|0,!((f[c>>2]|0)==(f[v+4>>2]|0)?(f[c+4>>2]|0)==(f[v>>2]|0):0)):0){v=$Xc(64)|0;f[j>>2]=v;f[j+8>>2]=-2147483584;f[j+4>>2]=54;o=v;p=231394;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[v+54>>0]=0;vM(-215,j,467262,230788,1201)}r=f[a+4>>2]|0;if((k|0)<0?(f[r>>2]&4095|0)!=(d|0):0){s=$Xc(48)|0;f[j>>2]=s;f[j+8>>2]=-2147483600;f[j+4>>2]=45;o=s;p=231449;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[s+45>>0]=0;vM(-215,j,467262,230788,1202)}v=f[c>>2]|0;n=f[c+4>>2]|0;t=d&4095;if(((((f[r+4>>2]|0)<3?(f[r+8>>2]|0)==(n|0):0)?(f[r+12>>2]|0)==(v|0):0)?(f[r>>2]&4095|0)==(t|0):0)?f[r+24>>2]|0:0){u=i;return}f[j>>2]=n;f[j+4>>2]=v;BQ(r,2,j,t,0);u=i;return}if(m&(l|0)==589824){if(!((h|0)==0&(g^1)))break;if(k&1073741824|0?(t=f[a+4>>2]|0,!((f[c>>2]|0)==(f[t+8>>2]|0)?(f[c+4>>2]|0)==(f[t+4>>2]|0):0)):0){t=$Xc(64)|0;f[j>>2]=t;f[j+8>>2]=-2147483584;f[j+4>>2]=51;o=t;p=231495;q=o+51|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+51>>0]=0;vM(-215,j,467262,230788,1208)}r=f[a+4>>2]|0;if((k|0)>=0){w=f[c>>2]|0;x=c+4|0;y=f[x>>2]|0;d3(r,y,w,d)}if((f[r>>2]&4095|0)==(d|0)){w=f[c>>2]|0;x=c+4|0;y=f[x>>2]|0;d3(r,y,w,d)}else{r=$Xc(64)|0;f[j>>2]=r;f[j+8>>2]=-2147483584;f[j+4>>2]=53;o=r;p=231547;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[r+53>>0]=0;vM(-215,j,467262,230788,1209)}}if(m&(l|0)==458752){if(!((h|0)==0&(g^1)))break;if(k&1073741824|0?(t=f[a+4>>2]|0,!((f[c>>2]|0)==(f[t+12>>2]|0)?(f[c+4>>2]|0)==(f[t+8>>2]|0):0)):0){t=$Xc(64)|0;f[j>>2]=t;f[j+8>>2]=-2147483584;f[j+4>>2]=50;o=t;p=231601;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+50>>0]=0;vM(-215,j,467262,230788,1215)}r=f[a+4>>2]|0;if((k|0)<0?(f[r+16>>2]|0)!=(d|0):0){s=$Xc(64)|0;f[j>>2]=s;f[j+8>>2]=-2147483584;f[j+4>>2]=52;o=s;p=231652;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[s+52>>0]=0;vM(-215,j,467262,230788,1216)}SW(r,f[c+4>>2]|0,f[c>>2]|0,d,34962,0);u=i;return}if(m&(l|0)==524288?(h|0)==0&(g^1):0){if(k&1073741824|0?(t=f[a+4>>2]|0,!((f[c>>2]|0)==(f[t+8>>2]|0)?(f[c+4>>2]|0)==(f[t+4>>2]|0):0)):0){t=$Xc(64)|0;f[j>>2]=t;f[j+8>>2]=-2147483584;f[j+4>>2]=52;o=t;p=231705;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+52>>0]=0;vM(-215,j,467262,230788,1222)}r=f[a+4>>2]|0;if((k|0)>=0){z=f[c>>2]|0;A=c+4|0;B=f[A>>2]|0;n1(r,B,z,d)}if((f[r>>2]&4095|0)==(d|0)){z=f[c>>2]|0;A=c+4|0;B=f[A>>2]|0;n1(r,B,z,d)}else{r=$Xc(64)|0;f[j>>2]=r;f[j+8>>2]=-2147483584;f[j+4>>2]=54;o=r;p=231758;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[r+54>>0]=0;vM(-215,j,467262,230788,1223)}}}while(0);f[j>>2]=f[c+4>>2];f[j+4>>2]=f[c>>2];xS(a,2,j,d,e,g,h);u=i;return}function xS(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;j=u;u=u+32|0;k=j;l=j+16|0;m=j+4|0;if((c|0)==1){f[l>>2]=f[d>>2];f[l+4>>2]=1;n=2;o=l}else{n=c;o=d}d=f[a>>2]|0;c=d&2031616;l=e&4095;p=c&2097151;a:do if((p|0)<655360){if((p|0)>=131072){switch(p|0){case 131072:break;default:break a}if((g|0)>=0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=5;b[m>>0]=b[230774]|0;b[m+1>>0]=b[230775]|0;b[m+2>>0]=b[230776]|0;b[m+3>>0]=b[230777]|0;b[m+4>>0]=b[230778]|0;b[m+5>>0]=0;vM(-215,m,467262,230788,1357)}q=d&4095;if((l|0)!=(q|0)){if(e&4088|0){r=$Xc(96)|0;f[m>>2]=r;s=m+8|0;f[s>>2]=-2147483552;t=m+4|0;f[t>>2]=81;v=r;w=231907;x=v+81|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+81|0;b[y>>0]=0;vM(-215,m,467262,230788,1359)}if(!(1<<q&i)){r=$Xc(96)|0;f[m>>2]=r;s=m+8|0;f[s>>2]=-2147483552;t=m+4|0;f[t>>2]=81;v=r;w=231907;x=v+81|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+81|0;b[y>>0]=0;vM(-215,m,467262,230788,1359)}}if((n|0)!=2){z=$Xc(144)|0;f[m>>2]=z;A=m+8|0;f[A>>2]=-2147483504;B=m+4|0;f[B>>2]=129;o1c(z|0,231989,129)|0;C=z+129|0;b[C>>0]=0;vM(-215,m,467262,230788,1361)}q=f[o>>2]|0;D=a+8|0;E=f[a+12>>2]|0;if((q|0)==(E|0)?(f[o+4>>2]|0)==(f[D>>2]|0):0){u=j;return}if(!h){z=$Xc(144)|0;f[m>>2]=z;A=m+8|0;f[A>>2]=-2147483504;B=m+4|0;f[B>>2]=129;o1c(z|0,231989,129)|0;C=z+129|0;b[C>>0]=0;vM(-215,m,467262,230788,1361)}if((q|0)!=(f[D>>2]|0)){z=$Xc(144)|0;f[m>>2]=z;A=m+8|0;f[A>>2]=-2147483504;B=m+4|0;f[B>>2]=129;o1c(z|0,231989,129)|0;C=z+129|0;b[C>>0]=0;vM(-215,m,467262,230788,1361)}if((f[o+4>>2]|0)==(E|0)){u=j;return}else{z=$Xc(144)|0;f[m>>2]=z;A=m+8|0;f[A>>2]=-2147483504;B=m+4|0;f[B>>2]=129;o1c(z|0,231989,129)|0;C=z+129|0;b[C>>0]=0;vM(-215,m,467262,230788,1361)}}switch(p|0){case 65536:break;default:break a}if((g|0)>=0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=5;b[m>>0]=b[230774]|0;b[m+1>>0]=b[230775]|0;b[m+2>>0]=b[230776]|0;b[m+3>>0]=b[230777]|0;b[m+4>>0]=b[230778]|0;b[m+5>>0]=0;vM(-215,m,467262,230788,1289)}E=f[a+4>>2]|0;if(h){if(!(f[E>>2]&16384)){if(d>>>0>1073741823){D=$Xc(32)|0;f[m>>2]=D;f[m+8>>2]=-2147483616;f[m+4>>2]=28;v=D;w=231813;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[D+28>>0]=0;vM(-215,m,467262,230788,1295)}q=E+36|0;F=f[q>>2]|0;if(F|0?(G=F+12|0,F=f[G>>2]|0,f[G>>2]=F+-1,(F|0)==1):0)V$(E);f[q>>2]=0;q=E+16|0;F=E+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[F>>2]|0)>0){q=f[E+40>>2]|0;G=0;do{f[q+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[F>>2]|0))}}if((((((n|0)==2?(f[E+4>>2]|0)==2:0)?f[E+16>>2]|0:0)?(f[E>>2]&4095|0)==(l|0):0)?(f[E+8>>2]|0)==(f[o+4>>2]|0):0)?(f[E+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}F=f[a>>2]|0;do if((F|0)<0){G=f[E>>2]|0;if(((G^e)&4088|0)==0?1<<(F&4095)&i|0:0){H=G&4095;break}if((l|0)!=(G&4095|0)){G=$Xc(32)|0;f[m>>2]=G;f[m+8>>2]=-2147483616;f[m+4>>2]=30;v=G;w=231842;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[G+30>>0]=0;vM(-215,m,467262,230788,1309)}else H=l}else H=l;while(0);b:do if(F&1073741824|0){if((f[E+4>>2]|0)!=(n|0)){q=$Xc(16)|0;f[m>>2]=q;f[m+8>>2]=-2147483632;f[m+4>>2]=11;v=q;w=231873;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[q+11>>0]=0;vM(-215,m,467262,230788,1313)}if((n|0)>0){G=f[E+40>>2]|0;D=0;while(1){if((f[G+(D<<2)>>2]|0)!=(f[o+(D<<2)>>2]|0))break;D=D+1|0;if((D|0)>=(n|0))break b}D=$Xc(32)|0;f[m>>2]=D;f[m+8>>2]=-2147483616;f[m+4>>2]=21;v=D;w=231885;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[D+21>>0]=0;vM(-215,m,467262,230788,1315)}}while(0);S$(E,n,o,H);u=j;return}else{if((p|0)>=917504){switch(p|0){case 917504:break;default:break a}F=d&4095;if((l|0)!=(F|0)){if(e&4088|0){I=$Xc(96)|0;f[m>>2]=I;J=m+8|0;f[J>>2]=-2147483552;K=m+4|0;f[K>>2]=81;v=I;w=231907;x=v+81|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));L=I+81|0;b[L>>0]=0;vM(-215,m,467262,230788,1368)}if(!(1<<F&i)){I=$Xc(96)|0;f[m>>2]=I;J=m+8|0;f[J>>2]=-2147483552;K=m+4|0;f[K>>2]=81;v=I;w=231907;x=v+81|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));L=I+81|0;b[L>>0]=0;vM(-215,m,467262,230788,1368)}}if((n|0)!=2){M=$Xc(48)|0;f[m>>2]=M;N=m+8|0;f[N>>2]=-2147483600;O=m+4|0;f[O>>2]=40;v=M;w=232119;x=v+40|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));P=M+40|0;b[P>>0]=0;vM(-215,m,467262,230788,1369)}F=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;if((F|0)==(Y(f[o+4>>2]|0,f[o>>2]|0)|0)){u=j;return}else{M=$Xc(48)|0;f[m>>2]=M;N=m+8|0;f[N>>2]=-2147483600;O=m+4|0;f[O>>2]=40;v=M;w=232119;x=v+40|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));P=M+40|0;b[P>>0]=0;vM(-215,m,467262,230788,1369)}}switch(p|0){case 655360:break;default:break a}if((g|0)>=0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=5;b[m>>0]=b[230774]|0;b[m+1>>0]=b[230775]|0;b[m+2>>0]=b[230776]|0;b[m+3>>0]=b[230777]|0;b[m+4>>0]=b[230778]|0;b[m+5>>0]=0;vM(-215,m,467262,230788,1323)}F=f[a+4>>2]|0;if(h){if(!(f[F>>2]&16384)){if(d>>>0>1073741823){E=$Xc(32)|0;f[m>>2]=E;f[m+8>>2]=-2147483616;f[m+4>>2]=28;v=E;w=231813;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[E+28>>0]=0;vM(-215,m,467262,230788,1329)}G=F+24|0;q=f[G>>2]|0;if(q|0?(Q=q+8|0,q=f[Q>>2]|0,f[Q>>2]=q+-1,(q|0)==1):0)FQ(F);q=F+4|0;if((f[q>>2]|0)>0){Q=f[F+32>>2]|0;R=0;do{f[Q+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[q>>2]|0))}f[G>>2]=0}if(((((((n|0)==2?(f[F+4>>2]|0)==2:0)?f[F+24>>2]|0:0)?(q=f[F+8>>2]|0,R=f[F+12>>2]|0,Y(R,q)|0):0)?(f[F>>2]&4095|0)==(l|0):0)?(q|0)==(f[o+4>>2]|0):0)?(R|0)==(f[o>>2]|0):0){u=j;return}}R=f[a>>2]|0;do if((R|0)<0){q=f[F>>2]|0;if(((q^e)&4088|0)==0?1<<(R&4095)&i|0:0){S=q&4095;break}if((l|0)!=(q&4095|0)){q=$Xc(32)|0;f[m>>2]=q;f[m+8>>2]=-2147483616;f[m+4>>2]=30;v=q;w=231842;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[q+30>>0]=0;vM(-215,m,467262,230788,1343)}else S=l}else S=l;while(0);c:do if(R&1073741824|0){if((f[F+4>>2]|0)!=(n|0)){G=$Xc(16)|0;f[m>>2]=G;f[m+8>>2]=-2147483632;f[m+4>>2]=11;v=G;w=231873;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[G+11>>0]=0;vM(-215,m,467262,230788,1347)}if((n|0)>0){q=f[F+32>>2]|0;D=0;while(1){if((f[q+(D<<2)>>2]|0)!=(f[o+(D<<2)>>2]|0))break;D=D+1|0;if((D|0)>=(n|0))break c}D=$Xc(32)|0;f[m>>2]=D;f[m+8>>2]=-2147483616;f[m+4>>2]=21;v=D;w=231885;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[D+21>>0]=0;vM(-215,m,467262,230788,1349)}}while(0);BQ(F,n,o,S,0);u=j;return}while(0);S=(c|0)==262144;p=c&2097151;if((p|0)>=327680){if((p|0)<720896){switch(p|0){case 327680:break;default:{T=$Xc(32)|0;f[m>>2]=T;U=m+8|0;f[U>>2]=-2147483616;V=m+4|0;f[V>>2]=30;v=T;w=231085;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));W=T+30|0;b[W>>0]=0;vM(-213,m,467262,230788,1658)}}c=f[a+4>>2]|0;if((g|0)<0){if((n|0)!=2){X=$Xc(80)|0;f[m>>2]=X;Z=m+8|0;f[Z>>2]=-2147483568;_=m+4|0;f[_>>2]=68;v=X;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));$=X+68|0;b[$>>0]=0;vM(-215,m,467262,230788,1487)}P=f[o>>2]|0;M=f[o+4>>2]|0;O=Y(M,P)|0;if(!((P|0)==1|(M|0)==1|(O|0)==0)){X=$Xc(80)|0;f[m>>2]=X;Z=m+8|0;f[Z>>2]=-2147483568;_=m+4|0;f[_>>2]=68;v=X;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));$=X+68|0;b[$>>0]=0;vM(-215,m,467262,230788,1487)}$=(O|0)>0?P+-1+M|0:0;M=((f[c+4>>2]|0)-(f[c>>2]|0)|0)/56|0;if(!((d&1073741824|0)==0|($|0)==(M|0))){P=$Xc(32)|0;f[m>>2]=P;f[m+8>>2]=-2147483616;f[m+4>>2]=27;v=P;w=232552;x=v+27|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[P+27>>0]=0;vM(-215,m,467262,230788,1490)}hS(c,$);P=f[a>>2]|0;if((P|0)>=0){u=j;return}O=P&4095;if(M>>>0>=$>>>0){u=j;return}P=f[c>>2]|0;X=M;while(1){M=P+(X*56|0)|0;_=f[M>>2]|0;if((_&4095|0)!=(O|0)){if(f[P+(X*56|0)+16>>2]|0){Z=f[P+(X*56|0)+4>>2]|0;if((Z|0)<3)aa=Y(f[P+(X*56|0)+12>>2]|0,f[P+(X*56|0)+8>>2]|0)|0;else{N=f[P+(X*56|0)+40>>2]|0;L=0;I=1;while(1){K=Y(f[N+(L<<2)>>2]|0,I)|0;L=L+1|0;if((L|0)==(Z|0)){aa=K;break}else I=K}}if(!((Z|0)==0|(aa|0)==0)){ba=256;break}}f[M>>2]=_&-4096|O}X=X+1|0;if(X>>>0>=$>>>0){ba=390;break}}if((ba|0)==256){$=$Xc(16)|0;f[m>>2]=$;f[m+8>>2]=-2147483632;f[m+4>>2]=12;v=$;w=232580;x=v+12|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[$+12>>0]=0;vM(-215,m,467262,230788,1499)}else if((ba|0)==390){u=j;return}}$=f[c>>2]|0;X=$;if((((f[c+4>>2]|0)-$|0)/56|0|0)<=(g|0)){$=$Xc(32)|0;f[m>>2]=$;f[m+8>>2]=-2147483616;f[m+4>>2]=17;v=$;w=232593;x=v+17|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[$+17>>0]=0;vM(-215,m,467262,230788,1506)}$=X+(g*56|0)|0;if(h){if(!(f[$>>2]&16384)){if(d>>>0>1073741823){c=$Xc(32)|0;f[m>>2]=c;f[m+8>>2]=-2147483616;f[m+4>>2]=28;v=c;w=231813;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[c+28>>0]=0;vM(-215,m,467262,230788,1513)}c=X+(g*56|0)+36|0;O=f[c>>2]|0;if(O|0?(aa=O+12|0,O=f[aa>>2]|0,f[aa>>2]=O+-1,(O|0)==1):0)V$($);f[c>>2]=0;c=X+(g*56|0)+16|0;O=X+(g*56|0)+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[O>>2]|0)>0){c=f[X+(g*56|0)+40>>2]|0;aa=0;do{f[c+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[O>>2]|0))}}if((((((n|0)==2?(f[X+(g*56|0)+4>>2]|0)==2:0)?f[X+(g*56|0)+16>>2]|0:0)?(f[$>>2]&4095|0)==(l|0):0)?(f[X+(g*56|0)+8>>2]|0)==(f[o+4>>2]|0):0)?(f[X+(g*56|0)+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}O=f[a>>2]|0;do if((O|0)<0){aa=f[$>>2]|0;if(((aa^e)&4088|0)==0?1<<(O&4095)&i|0:0){ca=aa&4095;break}if((l|0)!=(aa&4095|0)){aa=$Xc(32)|0;f[m>>2]=aa;f[m+8>>2]=-2147483616;f[m+4>>2]=30;v=aa;w=231842;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[aa+30>>0]=0;vM(-215,m,467262,230788,1527)}else ca=l}else ca=l;while(0);d:do if(O&1073741824|0){if((f[X+(g*56|0)+4>>2]|0)!=(n|0)){_=$Xc(16)|0;f[m>>2]=_;f[m+8>>2]=-2147483632;f[m+4>>2]=11;v=_;w=231873;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[_+11>>0]=0;vM(-215,m,467262,230788,1531)}if((n|0)>0){aa=f[X+(g*56|0)+40>>2]|0;M=0;while(1){if((f[aa+(M<<2)>>2]|0)!=(f[o+(M<<2)>>2]|0))break;M=M+1|0;if((M|0)>=(n|0))break d}M=$Xc(32)|0;f[m>>2]=M;f[m+8>>2]=-2147483616;f[m+4>>2]=21;v=M;w=231885;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[M+21>>0]=0;vM(-215,m,467262,230788,1533)}}while(0);S$($,n,o,ca);u=j;return}if((p|0)>=983040){switch(p|0){case 983040:break;default:{T=$Xc(32)|0;f[m>>2]=T;U=m+8|0;f[U>>2]=-2147483616;V=m+4|0;f[V>>2]=30;v=T;w=231085;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));W=T+30|0;b[W>>0]=0;vM(-213,m,467262,230788,1658)}}ca=f[a+4>>2]|0;if((g|0)<0){if((n|0)!=2){da=$Xc(80)|0;f[m>>2]=da;ea=m+8|0;f[ea>>2]=-2147483568;fa=m+4|0;f[fa>>2]=68;v=da;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));ga=da+68|0;b[ga>>0]=0;vM(-215,m,467262,230788,1546)}$=f[o>>2]|0;X=f[o+4>>2]|0;O=Y(X,$)|0;if(!(($|0)==1|(X|0)==1|(O|0)==0)){da=$Xc(80)|0;f[m>>2]=da;ea=m+8|0;f[ea>>2]=-2147483568;fa=m+4|0;f[fa>>2]=68;v=da;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));ga=da+68|0;b[ga>>0]=0;vM(-215,m,467262,230788,1546)}if((((O|0)>0?$+-1+X|0:0)|0)==(f[a+12>>2]|0)){u=j;return}else{X=$Xc(16)|0;f[m>>2]=X;f[m+8>>2]=-2147483632;f[m+4>>2]=11;v=X;w=232611;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[X+11>>0]=0;vM(-215,m,467262,230788,1549)}}if((f[a+12>>2]|0)<=(g|0)){X=$Xc(16)|0;f[m>>2]=X;f[m+8>>2]=-2147483632;f[m+4>>2]=13;v=X;w=231161;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[X+13>>0]=0;vM(-215,m,467262,230788,1564)}X=ca+(g*56|0)|0;if(h){if(!(f[X>>2]&16384)){if(d>>>0>1073741823){$=$Xc(32)|0;f[m>>2]=$;f[m+8>>2]=-2147483616;f[m+4>>2]=28;v=$;w=231813;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[$+28>>0]=0;vM(-215,m,467262,230788,1571)}$=ca+(g*56|0)+36|0;O=f[$>>2]|0;if(O|0?(ga=O+12|0,O=f[ga>>2]|0,f[ga>>2]=O+-1,(O|0)==1):0)V$(X);f[$>>2]=0;$=ca+(g*56|0)+16|0;O=ca+(g*56|0)+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[O>>2]|0)>0){$=f[ca+(g*56|0)+40>>2]|0;ga=0;do{f[$+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[O>>2]|0))}}if((((((n|0)==2?(f[ca+(g*56|0)+4>>2]|0)==2:0)?f[ca+(g*56|0)+16>>2]|0:0)?(f[X>>2]&4095|0)==(l|0):0)?(f[ca+(g*56|0)+8>>2]|0)==(f[o+4>>2]|0):0)?(f[ca+(g*56|0)+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}O=f[a>>2]|0;do if((O|0)<0){ga=f[X>>2]|0;if(((ga^e)&4088|0)==0?1<<(O&4095)&i|0:0){ha=ga&4095;break}if((l|0)!=(ga&4095|0)){ga=$Xc(32)|0;f[m>>2]=ga;f[m+8>>2]=-2147483616;f[m+4>>2]=30;v=ga;w=231842;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[ga+30>>0]=0;vM(-215,m,467262,230788,1585)}else ha=l}else ha=l;while(0);e:do if(O&1073741824|0){if((f[ca+(g*56|0)+4>>2]|0)!=(n|0)){M=$Xc(16)|0;f[m>>2]=M;f[m+8>>2]=-2147483632;f[m+4>>2]=11;v=M;w=231873;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[M+11>>0]=0;vM(-215,m,467262,230788,1590)}if((n|0)>0){ga=f[ca+(g*56|0)+40>>2]|0;$=0;while(1){if((f[ga+($<<2)>>2]|0)!=(f[o+($<<2)>>2]|0))break;$=$+1|0;if(($|0)>=(n|0))break e}$=$Xc(32)|0;f[m>>2]=$;f[m+8>>2]=-2147483616;f[m+4>>2]=21;v=$;w=231885;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[$+21>>0]=0;vM(-215,m,467262,230788,1592)}}while(0);S$(X,n,o,ha);u=j;return}switch(p|0){case 720896:break;default:{T=$Xc(32)|0;f[m>>2]=T;U=m+8|0;f[U>>2]=-2147483616;V=m+4|0;f[V>>2]=30;v=T;w=231085;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));W=T+30|0;b[W>>0]=0;vM(-213,m,467262,230788,1658)}}ha=f[a+4>>2]|0;if((g|0)<0){if((n|0)!=2){ia=$Xc(80)|0;f[m>>2]=ia;ja=m+8|0;f[ja>>2]=-2147483568;ka=m+4|0;f[ka>>2]=68;v=ia;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));la=ia+68|0;b[la>>0]=0;vM(-215,m,467262,230788,1605)}X=f[o>>2]|0;ca=f[o+4>>2]|0;O=Y(ca,X)|0;if(!((X|0)==1|(ca|0)==1|(O|0)==0)){ia=$Xc(80)|0;f[m>>2]=ia;ja=m+8|0;f[ja>>2]=-2147483568;ka=m+4|0;f[ka>>2]=68;v=ia;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));la=ia+68|0;b[la>>0]=0;vM(-215,m,467262,230788,1605)}la=(O|0)>0?X+-1+ca|0:0;ca=ha+4|0;X=f[ca>>2]|0;O=f[ha>>2]|0;ia=(X-O|0)/48|0;if(!((d&1073741824|0)==0|(la|0)==(ia|0))){ka=$Xc(32)|0;f[m>>2]=ka;f[m+8>>2]=-2147483616;f[m+4>>2]=27;v=ka;w=232552;x=v+27|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[ka+27>>0]=0;vM(-215,m,467262,230788,1608)}ka=la>>>0>ia>>>0;ja=O;O=X;if(!ka){if(la>>>0<ia>>>0?(X=ja+(la*48|0)|0,(O|0)!=(X|0)):0){ja=O;do{O=ja+-48|0;f[ca>>2]=O;EQ(O);ja=f[ca>>2]|0}while((ja|0)!=(X|0))}}else kS(ha,la-ia|0);X=f[a>>2]|0;if((X|0)>=0){u=j;return}ja=X&4095;if(!ka){u=j;return}ka=f[ha>>2]|0;X=ia;while(1){ia=ka+(X*48|0)|0;ca=f[ia>>2]|0;if((ca&4095|0)!=(ja|0)){if(f[ka+(X*48|0)+24>>2]|0){O=f[ka+(X*48|0)+4>>2]|0;if((O|0)<3)ma=Y(f[ka+(X*48|0)+12>>2]|0,f[ka+(X*48|0)+8>>2]|0)|0;else{ga=f[ka+(X*48|0)+32>>2]|0;M=0;da=1;while(1){fa=Y(f[ga+(M<<2)>>2]|0,da)|0;M=M+1|0;if((M|0)==(O|0)){ma=fa;break}else da=fa}}if(!((O|0)==0|(ma|0)==0)){ba=352;break}}f[ia>>2]=ca&-4096|ja}X=X+1|0;if(X>>>0>=la>>>0){ba=390;break}}if((ba|0)==352){la=$Xc(16)|0;f[m>>2]=la;f[m+8>>2]=-2147483632;f[m+4>>2]=12;v=la;w=232580;x=v+12|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[la+12>>0]=0;vM(-215,m,467262,230788,1617)}else if((ba|0)==390){u=j;return}}ba=f[ha>>2]|0;la=ba;if((((f[ha+4>>2]|0)-ba|0)/48|0|0)<=(g|0)){ba=$Xc(32)|0;f[m>>2]=ba;f[m+8>>2]=-2147483616;f[m+4>>2]=17;v=ba;w=232593;x=v+17|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[ba+17>>0]=0;vM(-215,m,467262,230788,1624)}ba=la+(g*48|0)|0;if(h){if(!(f[ba>>2]&16384)){if(d>>>0>1073741823){h=$Xc(32)|0;f[m>>2]=h;f[m+8>>2]=-2147483616;f[m+4>>2]=28;v=h;w=231813;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[h+28>>0]=0;vM(-215,m,467262,230788,1631)}h=la+(g*48|0)+24|0;ha=f[h>>2]|0;if(ha|0?(X=ha+8|0,ha=f[X>>2]|0,f[X>>2]=ha+-1,(ha|0)==1):0)FQ(ba);ha=la+(g*48|0)+4|0;if((f[ha>>2]|0)>0){X=f[la+(g*48|0)+32>>2]|0;ja=0;do{f[X+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[ha>>2]|0))}f[h>>2]=0}if((((((n|0)==2?(f[la+(g*48|0)+4>>2]|0)==2:0)?f[la+(g*48|0)+24>>2]|0:0)?(f[ba>>2]&4095|0)==(l|0):0)?(f[la+(g*48|0)+8>>2]|0)==(f[o+4>>2]|0):0)?(f[la+(g*48|0)+12>>2]|0)==(f[o>>2]|0):0){u=j;return}}h=f[a>>2]|0;do if((h|0)<0){ha=f[ba>>2]|0;if(((ha^e)&4088|0)==0?1<<(h&4095)&i|0:0){na=ha&4095;break}if((l|0)!=(ha&4095|0)){ha=$Xc(32)|0;f[m>>2]=ha;f[m+8>>2]=-2147483616;f[m+4>>2]=30;v=ha;w=231842;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[ha+30>>0]=0;vM(-215,m,467262,230788,1645)}else na=l}else na=l;while(0);f:do if(h&1073741824|0){if((f[la+(g*48|0)+4>>2]|0)!=(n|0)){ca=$Xc(16)|0;f[m>>2]=ca;f[m+8>>2]=-2147483632;f[m+4>>2]=11;v=ca;w=231873;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[ca+11>>0]=0;vM(-215,m,467262,230788,1649)}if((n|0)>0){ha=f[la+(g*48|0)+32>>2]|0;ia=0;while(1){if((f[ha+(ia<<2)>>2]|0)!=(f[o+(ia<<2)>>2]|0))break;ia=ia+1|0;if((ia|0)>=(n|0))break f}ia=$Xc(32)|0;f[m>>2]=ia;f[m+8>>2]=-2147483616;f[m+4>>2]=21;v=ia;w=231885;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[ia+21>>0]=0;vM(-215,m,467262,230788,1651)}}while(0);BQ(ba,n,o,na,0);u=j;return}if((p|0)<196608)switch(p|0){case 0:{na=$Xc(48)|0;f[m>>2]=na;f[m+8>>2]=-2147483600;f[m+4>>2]=44;v=na;w=232507;x=v+44|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[na+44>>0]=0;vM(-27,m,467262,230788,1478);break}default:{T=$Xc(32)|0;f[m>>2]=T;U=m+8|0;f[U>>2]=-2147483616;V=m+4|0;f[V>>2]=30;v=T;w=231085;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));W=T+30|0;b[W>>0]=0;vM(-213,m,467262,230788,1658)}}g:do if((p|0)<262144){switch(p|0){case 196608:{break g;break}default:{}}T=$Xc(32)|0;f[m>>2]=T;U=m+8|0;f[U>>2]=-2147483616;V=m+4|0;f[V>>2]=30;v=T;w=231085;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));W=T+30|0;b[W>>0]=0;vM(-213,m,467262,230788,1658)}else{switch(p|0){case 262144:{break g;break}default:{}}T=$Xc(32)|0;f[m>>2]=T;U=m+8|0;f[U>>2]=-2147483616;V=m+4|0;f[V>>2]=30;v=T;w=231085;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));W=T+30|0;b[W>>0]=0;vM(-213,m,467262,230788,1658)}while(0);if((n|0)!=2){oa=$Xc(80)|0;f[m>>2]=oa;pa=m+8|0;f[pa>>2]=-2147483568;qa=m+4|0;f[qa>>2]=68;v=oa;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));ra=oa+68|0;b[ra>>0]=0;vM(-215,m,467262,230788,1375)}n=f[o>>2]|0;W=f[o+4>>2]|0;o=Y(W,n)|0;if(!((n|0)==1|(W|0)==1|(o|0)==0)){oa=$Xc(80)|0;f[m>>2]=oa;pa=m+8|0;f[pa>>2]=-2147483568;qa=m+4|0;f[qa>>2]=68;v=oa;w=232160;x=v+68|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));ra=oa+68|0;b[ra>>0]=0;vM(-215,m,467262,230788,1375)}ra=(o|0)>0?n+-1+W|0:0;W=f[a+4>>2]|0;a=(g|0)<0;do if(!S)if(a)sa=W;else{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=5;b[m>>0]=b[230774]|0;b[m+1>>0]=b[230775]|0;b[m+2>>0]=b[230776]|0;b[m+3>>0]=b[230777]|0;b[m+4>>0]=b[230778]|0;b[m+5>>0]=0;vM(-215,m,467262,230788,1392)}else{if(!a){n=f[W>>2]|0;if((((f[W+4>>2]|0)-n|0)/12|0|0)>(g|0)){sa=n+(g*12|0)|0;break}else{n=$Xc(32)|0;f[m>>2]=n;f[m+8>>2]=-2147483616;f[m+4>>2]=18;v=n;w=231142;x=v+18|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[n+18>>0]=0;vM(-215,m,467262,230788,1388)}}o=W+4|0;oa=f[o>>2]|0;qa=f[W>>2]|0;if(d&1073741824|0?(ra|0)!=((oa-qa|0)/12|0|0):0){pa=$Xc(48)|0;f[m>>2]=pa;f[m+8>>2]=-2147483600;f[m+4>>2]=32;v=pa;w=232229;x=v+32|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[pa+32>>0]=0;vM(-215,m,467262,230788,1384)}n=(oa-qa|0)/12|0;T=oa;if(ra>>>0>n>>>0){yS(W,ra-n|0);u=j;return}if(ra>>>0>=n>>>0){u=j;return}n=qa+(ra*12|0)|0;if((T|0)==(n|0)){u=j;return}else ta=T;while(1){T=ta+-12|0;f[o>>2]=T;V=f[T>>2]|0;if(!V)ua=T;else{T=ta+-8|0;if((f[T>>2]|0)!=(V|0))f[T>>2]=V;cYc(V);ua=f[o>>2]|0}if((ua|0)==(n|0))break;else ta=ua}u=j;return}while(0);ua=d&4095;ta=d>>>3&511;W=ta+1|0;if((l|0)!=(ua|0)){if((e>>>3&511|0)!=(ta|0)){va=$Xc(112)|0;f[m>>2]=va;wa=m+8|0;f[wa>>2]=-2147483536;xa=m+4|0;f[xa>>2]=96;v=va;w=232262;x=v+96|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));ya=va+96|0;b[ya>>0]=0;vM(-215,m,467262,230788,1395)}if(!(1<<ua&i)){va=$Xc(112)|0;f[m>>2]=va;wa=m+8|0;f[wa>>2]=-2147483536;xa=m+4|0;f[xa>>2]=96;v=va;w=232262;x=v+96|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));ya=va+96|0;b[ya>>0]=0;vM(-215,m,467262,230788,1395)}}ya=Y(675553809>>>(d<<2&28)&15,W)|0;if(d&1073741824|0?(ra|0)!=((((f[sa+4>>2]|0)-(f[sa>>2]|0)|0)>>>0)/(ya>>>0)|0|0):0){d=$Xc(64)|0;f[m>>2]=d;f[m+8>>2]=-2147483584;f[m+4>>2]=61;v=d;w=232359;x=v+61|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[d+61>>0]=0;vM(-215,m,467262,230788,1398)}do switch(ya&16383){case 1:{d=sa+4|0;w=f[d>>2]|0;v=f[sa>>2]|0;x=w-v|0;if(ra>>>0>x>>>0){zS(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=v+ra|0;if((w|0)==(x|0)){u=j;return}f[d>>2]=x;u=j;return}case 2:{x=sa+4|0;d=f[x>>2]|0;w=f[sa>>2]|0;v=d-w>>1;W=d;if(ra>>>0>v>>>0){AS(sa,ra-v|0);u=j;return}if(ra>>>0>=v>>>0){u=j;return}v=w+(ra<<1)|0;if((W|0)==(v|0)){u=j;return}f[x>>2]=W+(~((0-v+(W+-2)|0)>>>1)<<1);u=j;return}case 3:{W=sa+4|0;v=f[W>>2]|0;x=f[sa>>2]|0;w=(v-x|0)/3|0;d=v;if(ra>>>0>w>>>0){BS(sa,ra-w|0);u=j;return}if(ra>>>0>=w>>>0){u=j;return}w=x+(ra*3|0)|0;if((d|0)==(w|0)){u=j;return}f[W>>2]=d+(~(((0-w+(d+-3)|0)>>>0)/3|0)*3|0);u=j;return}case 4:{d=sa+4|0;w=f[d>>2]|0;W=f[sa>>2]|0;x=w-W>>2;v=w;if(ra>>>0>x>>>0){CS(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=W+(ra<<2)|0;if((v|0)==(x|0)){u=j;return}f[d>>2]=v+(~((v+-4-x|0)>>>2)<<2);u=j;return}case 6:{x=sa+4|0;v=f[x>>2]|0;d=f[sa>>2]|0;W=(v-d|0)/6|0;w=v;if(ra>>>0>W>>>0){DS(sa,ra-W|0);u=j;return}if(ra>>>0>=W>>>0){u=j;return}W=d+(ra*6|0)|0;if((w|0)==(W|0)){u=j;return}f[x>>2]=w+(~(((w+-6-W|0)>>>0)/6|0)*6|0);u=j;return}case 8:{W=sa+4|0;w=f[W>>2]|0;x=f[sa>>2]|0;d=w-x>>3;v=w;if(ra>>>0>d>>>0){ES(sa,ra-d|0);u=j;return}if(ra>>>0>=d>>>0){u=j;return}d=x+(ra<<3)|0;if((v|0)==(d|0)){u=j;return}f[W>>2]=v+(~((v+-8-d|0)>>>3)<<3);u=j;return}case 12:{d=sa+4|0;v=f[d>>2]|0;W=f[sa>>2]|0;x=(v-W|0)/12|0;w=v;if(ra>>>0>x>>>0){FS(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=W+(ra*12|0)|0;if((w|0)==(x|0)){u=j;return}f[d>>2]=w+(~(((w+-12-x|0)>>>0)/12|0)*12|0);u=j;return}case 16:{x=sa+4|0;w=f[x>>2]|0;d=f[sa>>2]|0;W=w-d>>4;v=w;if(ra>>>0>W>>>0){GS(sa,ra-W|0);u=j;return}if(ra>>>0>=W>>>0){u=j;return}W=d+(ra<<4)|0;if((v|0)==(W|0)){u=j;return}f[x>>2]=v+(~((v+-16-W|0)>>>4)<<4);u=j;return}case 20:{W=sa+4|0;v=f[W>>2]|0;x=f[sa>>2]|0;d=(v-x|0)/20|0;w=v;if(ra>>>0>d>>>0){HS(sa,ra-d|0);u=j;return}if(ra>>>0>=d>>>0){u=j;return}d=x+(ra*20|0)|0;if((w|0)==(d|0)){u=j;return}f[W>>2]=w+(~(((w+-20-d|0)>>>0)/20|0)*20|0);u=j;return}case 24:{d=sa+4|0;w=f[d>>2]|0;W=f[sa>>2]|0;x=(w-W|0)/24|0;v=w;if(ra>>>0>x>>>0){IS(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=W+(ra*24|0)|0;if((v|0)==(x|0)){u=j;return}f[d>>2]=v+(~(((v+-24-x|0)>>>0)/24|0)*24|0);u=j;return}case 28:{x=sa+4|0;v=f[x>>2]|0;d=f[sa>>2]|0;W=(v-d|0)/28|0;w=v;if(ra>>>0>W>>>0){JS(sa,ra-W|0);u=j;return}if(ra>>>0>=W>>>0){u=j;return}W=d+(ra*28|0)|0;if((w|0)==(W|0)){u=j;return}f[x>>2]=w+(~(((w+-28-W|0)>>>0)/28|0)*28|0);u=j;return}case 32:{W=sa+4|0;w=f[W>>2]|0;x=f[sa>>2]|0;d=w-x>>5;v=w;if(ra>>>0>d>>>0){KS(sa,ra-d|0);u=j;return}if(ra>>>0>=d>>>0){u=j;return}d=x+(ra<<5)|0;if((v|0)==(d|0)){u=j;return}f[W>>2]=v+(~((v+-32-d|0)>>>5)<<5);u=j;return}case 36:{d=sa+4|0;v=f[d>>2]|0;W=f[sa>>2]|0;x=(v-W|0)/36|0;w=v;if(ra>>>0>x>>>0){LS(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=W+(ra*36|0)|0;if((w|0)==(x|0)){u=j;return}f[d>>2]=w+(~(((w+-36-x|0)>>>0)/36|0)*36|0);u=j;return}case 40:{x=sa+4|0;w=f[x>>2]|0;d=f[sa>>2]|0;W=(w-d|0)/40|0;v=w;if(ra>>>0>W>>>0){MS(sa,ra-W|0);u=j;return}if(ra>>>0>=W>>>0){u=j;return}W=d+(ra*40|0)|0;if((v|0)==(W|0)){u=j;return}f[x>>2]=v+(~(((v+-40-W|0)>>>0)/40|0)*40|0);u=j;return}case 44:{W=sa+4|0;v=f[W>>2]|0;x=f[sa>>2]|0;d=(v-x|0)/44|0;w=v;if(ra>>>0>d>>>0){NS(sa,ra-d|0);u=j;return}if(ra>>>0>=d>>>0){u=j;return}d=x+(ra*44|0)|0;if((w|0)==(d|0)){u=j;return}f[W>>2]=w+(~(((w+-44-d|0)>>>0)/44|0)*44|0);u=j;return}case 48:{d=sa+4|0;w=f[d>>2]|0;W=f[sa>>2]|0;x=(w-W|0)/48|0;v=w;if(ra>>>0>x>>>0){OS(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=W+(ra*48|0)|0;if((v|0)==(x|0)){u=j;return}f[d>>2]=v+(~(((v+-48-x|0)>>>0)/48|0)*48|0);u=j;return}case 52:{x=sa+4|0;v=f[x>>2]|0;d=f[sa>>2]|0;W=(v-d|0)/52|0;w=v;if(ra>>>0>W>>>0){PS(sa,ra-W|0);u=j;return}if(ra>>>0>=W>>>0){u=j;return}W=d+(ra*52|0)|0;if((w|0)==(W|0)){u=j;return}f[x>>2]=w+(~(((w+-52-W|0)>>>0)/52|0)*52|0);u=j;return}case 56:{W=sa+4|0;w=f[W>>2]|0;x=f[sa>>2]|0;d=(w-x|0)/56|0;v=w;if(ra>>>0>d>>>0){QS(sa,ra-d|0);u=j;return}if(ra>>>0>=d>>>0){u=j;return}d=x+(ra*56|0)|0;if((v|0)==(d|0)){u=j;return}f[W>>2]=v+(~(((v+-56-d|0)>>>0)/56|0)*56|0);u=j;return}case 60:{d=sa+4|0;v=f[d>>2]|0;W=f[sa>>2]|0;x=(v-W|0)/60|0;w=v;if(ra>>>0>x>>>0){RS(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=W+(ra*60|0)|0;if((w|0)==(x|0)){u=j;return}f[d>>2]=w+(~(((w+-60-x|0)>>>0)/60|0)*60|0);u=j;return}case 64:{x=sa+4|0;w=f[x>>2]|0;d=f[sa>>2]|0;W=w-d>>6;v=w;if(ra>>>0>W>>>0){SS(sa,ra-W|0);u=j;return}if(ra>>>0>=W>>>0){u=j;return}W=d+(ra<<6)|0;if((v|0)==(W|0)){u=j;return}f[x>>2]=v+(~((v+-64-W|0)>>>6)<<6);u=j;return}case 128:{W=sa+4|0;v=f[W>>2]|0;x=f[sa>>2]|0;d=v-x>>7;w=v;if(ra>>>0>d>>>0){TS(sa,ra-d|0);u=j;return}if(ra>>>0>=d>>>0){u=j;return}d=x+(ra<<7)|0;if((w|0)==(d|0)){u=j;return}f[W>>2]=w+(~((w+-128-d|0)>>>7)<<7);u=j;return}case 256:{d=sa+4|0;w=f[d>>2]|0;W=f[sa>>2]|0;x=w-W>>8;v=w;if(ra>>>0>x>>>0){US(sa,ra-x|0);u=j;return}if(ra>>>0>=x>>>0){u=j;return}x=W+(ra<<8)|0;if((v|0)==(x|0)){u=j;return}f[d>>2]=v+(~((v+-256-x|0)>>>8)<<8);u=j;return}case 512:{x=sa+4|0;v=f[x>>2]|0;d=f[sa>>2]|0;W=v-d>>9;w=v;if(ra>>>0>W>>>0){VS(sa,ra-W|0);u=j;return}if(ra>>>0>=W>>>0){u=j;return}W=d+(ra<<9)|0;if((w|0)==(W|0)){u=j;return}f[x>>2]=w+(~((w+-512-W|0)>>>9)<<9);u=j;return}default:{f[k>>2]=ya;DM(m,232421,k);vM(-5,m,467262,230788,1471)}}while(0)}function yS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=d;g=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=j+-12|0;b=i;i=i+-12|0;f[d>>2]=0;n=j+-8|0;f[n>>2]=0;f[j+-4>>2]=0;f[d>>2]=f[i>>2];d=b+-8|0;f[n>>2]=f[d>>2];n=b+-4|0;f[j+-4>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[i>>2]=0;j=h+-12|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=c;c=c+-12|0;m=f[c>>2]|0;if(m|0){e=q+-8|0;if((f[e>>2]|0)!=(m|0))f[e>>2]=m;cYc(m)}}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function zS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if((e-h|0)>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;j=(f[g>>2]|0)+1|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i|0;h=j+c|0;if((h|0)<0)kWc(a);k=e-i|0;i=k<<1;e=k>>>0<1073741823?(i>>>0<h>>>0?h:i):2147483647;if(!e)l=0;else l=$Xc(e)|0;i=l+j|0;j=l+e|0;e=c;c=i;l=i;do{b[l>>0]=0;l=c+1|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(0-l)|0;if((l|0)>0)o1c(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;cYc(e);return}function AS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>1>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;b[j+1>>0]=0;j=(f[g>>2]|0)+2|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>1;h=j+c|0;if((h|0)<0)kWc(a);k=e-i|0;i=k>>1>>>0<1073741823?(k>>>0<h>>>0?h:k):2147483647;do if(i)if((i|0)<0){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{l=$Xc(i<<1)|0;break}else l=0;while(0);k=l+(j<<1)|0;j=k;h=l+(i<<1)|0;i=c;c=k;l=j;do{b[c>>0]=0;b[c+1>>0]=0;c=l+2|0;l=c;i=i+-1|0}while((i|0)!=0);i=h;h=f[a>>2]|0;c=f[g>>2]|0;if((c|0)==(h|0)){m=j;n=h}else{e=c;c=j;j=k;do{k=e;e=e+-2|0;b[j+-2>>0]=b[e>>0]|0;b[j+-1>>0]=b[k+-1>>0]|0;j=c+-2|0;c=j}while((e|0)!=(h|0));m=c;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=l;f[d>>2]=i;if(!n)return;cYc(n);return}function BS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/3|0)>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;b[j+1>>0]=0;b[j+2>>0]=0;j=(f[g>>2]|0)+3|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/3|0;h=j+c|0;if(h>>>0>1431655765)kWc(a);k=(e-i|0)/3|0;i=k<<1;e=k>>>0<715827882?(i>>>0<h>>>0?h:i):1431655765;do if(e)if(e>>>0>1431655765){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e*3|0)|0;break}else l=0;while(0);i=l+(j*3|0)|0;j=i;h=l+(e*3|0)|0;e=c;c=j;l=i;do{b[l>>0]=0;b[l+1>>0]=0;b[l+2>>0]=0;l=c+3|0;c=l;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(h|0)){m=j;n=h}else{k=l;l=j;j=i;do{i=k;k=k+-3|0;b[j+-3>>0]=b[k>>0]|0;b[j+-2>>0]=b[i+-2>>0]|0;b[j+-1>>0]=b[i+-1>>0]|0;j=l+-3|0;l=j}while((k|0)!=(h|0));m=l;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=c;f[d>>2]=e;if(!n)return;cYc(n);return}function CS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){g1c(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)kWc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;g1c(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;cYc(h);return}function DS(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;e=f[c>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/6|0)>>>0>=b>>>0){i=b;j=h;do{d[j>>1]=0;d[j+2>>1]=0;d[j+4>>1]=0;j=(f[g>>2]|0)+6|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/6|0;h=j+b|0;if(h>>>0>715827882)kWc(a);k=(e-i|0)/6|0;i=k<<1;e=k>>>0<357913941?(i>>>0<h>>>0?h:i):715827882;do if(e)if(e>>>0>715827882){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e*6|0)|0;break}else l=0;while(0);i=l+(j*6|0)|0;j=i;h=l+(e*6|0)|0;e=b;b=i;l=j;do{d[b>>1]=0;d[b+2>>1]=0;d[b+4>>1]=0;b=l+6|0;l=b;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;b=f[g>>2]|0;if((b|0)==(h|0)){m=j;n=h}else{j=b;b=i;do{i=j;j=j+-6|0;d[b+-6>>1]=d[j>>1]|0;d[b+-4>>1]=d[i+-4>>1]|0;d[b+-2>>1]=d[i+-2>>1]|0;b=b+-6|0}while((j|0)!=(h|0));m=b;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=l;f[c>>2]=e;if(!n)return;cYc(n);return}function ES(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){h=b;i=g;do{j=i;f[j>>2]=0;f[j+4>>2]=0;i=(f[e>>2]|0)+8|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>3;g=i+b|0;if(g>>>0>536870911)kWc(a);j=d-h|0;h=j>>2;d=j>>3>>>0<268435455?(h>>>0<g>>>0?g:h):536870911;do if(d)if(d>>>0>536870911){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<3)|0;break}else k=0;while(0);h=k+(i<<3)|0;i=h;g=k+(d<<3)|0;d=b;b=h;k=i;do{j=b;f[j>>2]=0;f[j+4>>2]=0;b=k+8|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-8-j|0;j=b;b=h;while(1){n=j;j=j+-8|0;f[b+-8>>2]=f[j>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-8|0}l=h+(~(i>>>3)<<3)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function FS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)kWc(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=h;g=k+(d*12|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-12|0;f[b+-12>>2]=f[i>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-12|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function GS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)kWc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function HS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)kWc(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=h;g=k+(d*20|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-20|0;f[b+-20>>2]=f[i>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-20|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function IS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=(f[e>>2]|0)+24|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/24|0;g=i+b|0;if(g>>>0>178956970)kWc(a);j=(d-h|0)/24|0;h=j<<1;d=j>>>0<89478485?(h>>>0<g>>>0?g:h):178956970;do if(d)if(d>>>0>178956970){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*24|0)|0;break}else k=0;while(0);h=k+(i*24|0)|0;i=h;g=k+(d*24|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;b=k+24|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-24|0;f[b+-24>>2]=f[i>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-24|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function JS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/28|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;i=(f[e>>2]|0)+28|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/28|0;g=i+b|0;if(g>>>0>153391689)kWc(a);j=(d-h|0)/28|0;h=j<<1;d=j>>>0<76695844?(h>>>0<g>>>0?g:h):153391689;do if(d)if(d>>>0>153391689){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*28|0)|0;break}else k=0;while(0);h=k+(i*28|0)|0;i=h;g=k+(d*28|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;b=k+28|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-28|0;f[b+-28>>2]=f[i>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-28|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function KS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>5>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;i=(f[e>>2]|0)+32|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>5;g=i+b|0;if(g>>>0>134217727)kWc(a);j=d-h|0;h=j>>4;d=j>>5>>>0<67108863?(h>>>0<g>>>0?g:h):134217727;do if(d)if(d>>>0>134217727){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<5)|0;break}else k=0;while(0);h=k+(i<<5)|0;i=h;g=k+(d<<5)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;b=k+32|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-32-j|0;j=b;b=h;while(1){n=j;j=j+-32|0;f[b+-32>>2]=f[j>>2];f[b+-28>>2]=f[n+-28>>2];f[b+-24>>2]=f[n+-24>>2];f[b+-20>>2]=f[n+-20>>2];f[b+-16>>2]=f[n+-16>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-32|0}l=h+(~(i>>>5)<<5)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function LS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/36|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+36|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/36|0;g=i+b|0;if(g>>>0>119304647)kWc(a);l=(d-h|0)/36|0;h=l<<1;d=l>>>0<59652323?(h>>>0<g>>>0?g:h):119304647;do if(d)if(d>>>0>119304647){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*36|0)|0;break}else m=0;while(0);h=m+(i*36|0)|0;i=h;g=m+(d*36|0)|0;d=b;b=h;m=i;do{j=b;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+36|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-36|0;f[b+-36>>2]=f[i>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-36|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function MS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/40|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+40|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+40|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/40|0;g=i+b|0;if(g>>>0>107374182)kWc(a);l=(d-h|0)/40|0;h=l<<1;d=l>>>0<53687091?(h>>>0<g>>>0?g:h):107374182;do if(d)if(d>>>0>107374182){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*40|0)|0;break}else m=0;while(0);h=m+(i*40|0)|0;i=h;g=m+(d*40|0)|0;d=b;b=h;m=i;do{j=b;k=j+40|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+40|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-40|0;f[b+-40>>2]=f[i>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-40|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function NS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/44|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+44|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/44|0;g=i+b|0;if(g>>>0>97612893)kWc(a);l=(d-h|0)/44|0;h=l<<1;d=l>>>0<48806446?(h>>>0<g>>>0?g:h):97612893;do if(d)if(d>>>0>97612893){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*44|0)|0;break}else m=0;while(0);h=m+(i*44|0)|0;i=h;g=m+(d*44|0)|0;d=b;b=h;m=i;do{j=b;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+44|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-44|0;f[b+-44>>2]=f[i>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-44|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function OS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+48|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/48|0;g=i+b|0;if(g>>>0>89478485)kWc(a);l=(d-h|0)/48|0;h=l<<1;d=l>>>0<44739242?(h>>>0<g>>>0?g:h):89478485;do if(d)if(d>>>0>89478485){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*48|0)|0;break}else m=0;while(0);h=m+(i*48|0)|0;i=h;g=m+(d*48|0)|0;d=b;b=h;m=i;do{j=b;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+48|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-48|0;f[b+-48>>2]=f[i>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-48|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function PS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/52|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+52|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+52|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/52|0;g=i+b|0;if(g>>>0>82595524)kWc(a);l=(d-h|0)/52|0;h=l<<1;d=l>>>0<41297762?(h>>>0<g>>>0?g:h):82595524;do if(d)if(d>>>0>82595524){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*52|0)|0;break}else m=0;while(0);h=m+(i*52|0)|0;i=h;g=m+(d*52|0)|0;d=b;b=h;m=i;do{j=b;k=j+52|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+52|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-52|0;f[b+-52>>2]=f[i>>2];f[b+-48>>2]=f[h+-48>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-52|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function QS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/56|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+56|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/56|0;g=i+b|0;if(g>>>0>76695844)kWc(a);l=(d-h|0)/56|0;h=l<<1;d=l>>>0<38347922?(h>>>0<g>>>0?g:h):76695844;do if(d)if(d>>>0>76695844){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*56|0)|0;break}else m=0;while(0);h=m+(i*56|0)|0;i=h;g=m+(d*56|0)|0;d=b;b=h;m=i;do{j=b;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+56|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-56|0;f[b+-56>>2]=f[i>>2];f[b+-52>>2]=f[h+-52>>2];f[b+-48>>2]=f[h+-48>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-56|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function RS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/60|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+60|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/60|0;g=i+b|0;if(g>>>0>71582788)kWc(a);l=(d-h|0)/60|0;h=l<<1;d=l>>>0<35791394?(h>>>0<g>>>0?g:h):71582788;do if(d)if(d>>>0>71582788){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*60|0)|0;break}else m=0;while(0);h=m+(i*60|0)|0;i=h;g=m+(d*60|0)|0;d=b;b=h;m=i;do{j=b;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+60|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-60|0;f[b+-60>>2]=f[i>>2];f[b+-56>>2]=f[h+-56>>2];f[b+-52>>2]=f[h+-52>>2];f[b+-48>>2]=f[h+-48>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-60|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function SS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)kWc(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=h;g=m+(d<<6)|0;d=b;b=h;m=i;do{j=b;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){n=i;o=j}else{i=b+-64-j|0;j=b;b=h;while(1){k=j;j=j+-64|0;f[b+-64>>2]=f[j>>2];f[b+-60>>2]=f[k+-60>>2];f[b+-56>>2]=f[k+-56>>2];f[b+-52>>2]=f[k+-52>>2];f[b+-48>>2]=f[k+-48>>2];f[b+-44>>2]=f[k+-44>>2];f[b+-40>>2]=f[k+-40>>2];f[b+-36>>2]=f[k+-36>>2];f[b+-32>>2]=f[k+-32>>2];f[b+-28>>2]=f[k+-28>>2];f[b+-24>>2]=f[k+-24>>2];f[b+-20>>2]=f[k+-20>>2];f[b+-16>>2]=f[k+-16>>2];f[b+-12>>2]=f[k+-12>>2];f[b+-8>>2]=f[k+-8>>2];f[b+-4>>2]=f[k+-4>>2];if((j|0)==(g|0))break;else b=b+-64|0}n=h+(~(i>>>6)<<6)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function TS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>7>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+128|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>7;g=i+b|0;if(g>>>0>33554431)kWc(a);l=d-h|0;h=l>>6;d=l>>7>>>0<16777215?(h>>>0<g>>>0?g:h):33554431;do if(d)if(d>>>0>33554431){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d<<7)|0;break}else m=0;while(0);h=m+(i<<7)|0;i=h;g=m+(d<<7)|0;d=b;b=h;m=i;do{j=b;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+128|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){n=i;o=j}else{i=b+-128-j|0;j=b;b=h;while(1){k=0;do{f[b+-128+(k<<2)>>2]=f[j+-128+(k<<2)>>2];k=k+1|0}while((k|0)!=32);j=j+-128|0;if((j|0)==(g|0))break;else b=b+-128|0}n=h+(~(i>>>7)<<7)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;cYc(o);return}function US(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>8>>>0>=b>>>0){h=b;i=g;do{g1c(i|0,0,256)|0;i=(f[e>>2]|0)+256|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>8;g=i+b|0;if(g>>>0>16777215)kWc(a);j=d-h|0;h=j>>7;d=j>>8>>>0<8388607?(h>>>0<g>>>0?g:h):16777215;do if(d)if(d>>>0>16777215){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<8)|0;break}else k=0;while(0);h=k+(i<<8)|0;i=h;g=k+(d<<8)|0;d=b;b=h;k=i;do{g1c(b|0,0,256)|0;b=k+256|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-256-j|0;j=b;b=h;while(1){n=0;do{f[b+-256+(n<<2)>>2]=f[j+-256+(n<<2)>>2];n=n+1|0}while((n|0)!=64);j=j+-256|0;if((j|0)==(g|0))break;else b=b+-256|0}l=h+(~(i>>>8)<<8)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function VS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>9>>>0>=b>>>0){h=b;i=g;do{g1c(i|0,0,512)|0;i=(f[e>>2]|0)+512|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>9;g=i+b|0;if(g>>>0>8388607)kWc(a);j=d-h|0;h=j>>8;d=j>>9>>>0<4194303?(h>>>0<g>>>0?g:h):8388607;do if(d)if(d>>>0>8388607){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<9)|0;break}else k=0;while(0);h=k+(i<<9)|0;i=h;g=k+(d<<9)|0;d=b;b=h;k=i;do{g1c(b|0,0,512)|0;b=k+512|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-512-j|0;j=b;b=h;while(1){n=0;do{f[b+-512+(n<<2)>>2]=f[j+-512+(n<<2)>>2];n=n+1|0}while((n|0)!=128);j=j+-512|0;if((j|0)==(g|0))break;else b=b+-512|0}l=h+(~(i>>>9)<<9)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function WS(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((c|0)<0){if((g|0)!=65536){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=8;h=e;f[h>>2]=1027416171;f[h+4>>2]=1413565728;b[e+8>>0]=0;vM(-215,e,232623,230788,1761)}i=f[a+4>>2]|0;u=d;return i|0}h=g&2097151;a:do if((h|0)<983040){switch(h|0){case 327680:{break a;break}default:{}}j=$Xc(48)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483600;l=e+4|0;f[l>>2]=41;m=j;n=232633;o=m+41|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+41|0;b[p>>0]=0;vM(-215,e,232623,230788,1765)}else{switch(h|0){case 983040:{break a;break}default:{}}j=$Xc(48)|0;f[e>>2]=j;k=e+8|0;f[k>>2]=-2147483600;l=e+4|0;f[l>>2]=41;m=j;n=232633;o=m+41|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+41|0;b[p>>0]=0;vM(-215,e,232623,230788,1765)}while(0);p=f[a+4>>2]|0;if((g|0)==327680){g=f[p>>2]|0;if((((f[p+4>>2]|0)-g|0)/56|0|0)<=(c|0)){j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=17;m=j;n=232593;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[j+17>>0]=0;vM(-215,e,232623,230788,1770)}i=g+(c*56|0)|0;u=d;return i|0}else{if((f[a+12>>2]|0)<=(c|0)){a=$Xc(32)|0;f[e>>2]=a;f[e+8>>2]=-2147483616;f[e+4>>2]=23;m=a;n=230918;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[a+23>>0]=0;vM(-215,e,232623,230788,1776)}i=p+(c*56|0)|0;u=d;return i|0}return 0}function XS(a){a=a|0;return (f[a>>2]&1073741824|0)!=0|0}function YS(a){a=a|0;return (f[a>>2]|0)<0|0}function ZS(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;m=l&2031616;n=(g|0)<0;do if(n&(m|0)==65536){if((i|0)==0&(h^1)){if(l&1073741824|0?(o=f[(f[a+4>>2]|0)+40>>2]|0,!((f[o>>2]|0)==(c|0)?(f[o+4>>2]|0)==(d|0):0)):0){o=$Xc(80)|0;f[k>>2]=o;f[k+8>>2]=-2147483568;f[k+4>>2]=68;p=o;q=232675;r=p+68|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+68>>0]=0;vM(-215,k,467262,230788,1236)}s=f[a+4>>2]|0;if((l|0)<0?(f[s>>2]&4095|0)!=(e|0):0){t=$Xc(48)|0;f[k>>2]=t;f[k+8>>2]=-2147483600;f[k+4>>2]=44;p=t;q=231349;r=p+44|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[t+44>>0]=0;vM(-215,k,467262,230788,1237)}o=e&4095;if(((((f[s+4>>2]|0)<3?(f[s+8>>2]|0)==(c|0):0)?(f[s+12>>2]|0)==(d|0):0)?(f[s>>2]&4095|0)==(o|0):0)?f[s+16>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;S$(s,2,k,o);u=j;return}}else{if(n&(m|0)==655360){if(!((i|0)==0&(h^1)))break;if(l&1073741824|0?(o=f[(f[a+4>>2]|0)+32>>2]|0,!((f[o>>2]|0)==(c|0)?(f[o+4>>2]|0)==(d|0):0)):0){o=$Xc(80)|0;f[k>>2]=o;f[k+8>>2]=-2147483568;f[k+4>>2]=69;p=o;q=232744;r=p+69|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+69>>0]=0;vM(-215,k,467262,230788,1243)}s=f[a+4>>2]|0;if((l|0)<0?(f[s>>2]&4095|0)!=(e|0):0){t=$Xc(48)|0;f[k>>2]=t;f[k+8>>2]=-2147483600;f[k+4>>2]=45;p=t;q=231449;r=p+45|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[t+45>>0]=0;vM(-215,k,467262,230788,1244)}o=e&4095;if(((((f[s+4>>2]|0)<3?(f[s+8>>2]|0)==(c|0):0)?(f[s+12>>2]|0)==(d|0):0)?(f[s>>2]&4095|0)==(o|0):0)?f[s+24>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;BQ(s,2,k,o,0);u=j;return}if(n&(m|0)==589824){if(!((i|0)==0&(h^1)))break;if(l&1073741824|0?(o=f[a+4>>2]|0,!((f[o+8>>2]|0)==(d|0)?(f[o+4>>2]|0)==(c|0):0)):0){o=$Xc(80)|0;f[k>>2]=o;f[k+8>>2]=-2147483568;f[k+4>>2]=66;p=o;q=232814;r=p+66|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+66>>0]=0;vM(-215,k,467262,230788,1250)}s=f[a+4>>2]|0;if((l|0)>=0)d3(s,c,d,e);if((f[s>>2]&4095|0)==(e|0))d3(s,c,d,e);else{s=$Xc(64)|0;f[k>>2]=s;f[k+8>>2]=-2147483584;f[k+4>>2]=53;p=s;q=231547;r=p+53|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[s+53>>0]=0;vM(-215,k,467262,230788,1251)}}if(n&(m|0)==458752){if(!((i|0)==0&(h^1)))break;if(l&1073741824|0?(o=f[a+4>>2]|0,!((f[o+12>>2]|0)==(d|0)?(f[o+8>>2]|0)==(c|0):0)):0){o=$Xc(80)|0;f[k>>2]=o;f[k+8>>2]=-2147483568;f[k+4>>2]=65;p=o;q=232881;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+65>>0]=0;vM(-215,k,467262,230788,1257)}s=f[a+4>>2]|0;if((l|0)<0?(f[s+16>>2]|0)!=(e|0):0){t=$Xc(64)|0;f[k>>2]=t;f[k+8>>2]=-2147483584;f[k+4>>2]=52;p=t;q=231652;r=p+52|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[t+52>>0]=0;vM(-215,k,467262,230788,1258)}SW(s,c,d,e,34962,0);u=j;return}if(n&(m|0)==524288?(i|0)==0&(h^1):0){if(l&1073741824|0?(o=f[a+4>>2]|0,!((f[o+8>>2]|0)==(d|0)?(f[o+4>>2]|0)==(c|0):0)):0){o=$Xc(80)|0;f[k>>2]=o;f[k+8>>2]=-2147483568;f[k+4>>2]=67;p=o;q=232947;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+67>>0]=0;vM(-215,k,467262,230788,1264)}s=f[a+4>>2]|0;if((l|0)>=0)n1(s,c,d,e);if((f[s>>2]&4095|0)==(e|0))n1(s,c,d,e);else{s=$Xc(64)|0;f[k>>2]=s;f[k+8>>2]=-2147483584;f[k+4>>2]=54;p=s;q=231758;r=p+54|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[s+54>>0]=0;vM(-215,k,467262,230788,1265)}}}while(0);f[k>>2]=c;f[k+4>>2]=d;xS(a,2,k,e,g,h,i);u=j;return}function _S(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+144|0;e=d+128|0;g=d;h=f[b>>2]&2031616;a:do if((h|0)>=65536)if((h|0)<655360){switch(h|0){case 65536:break;default:{i=8;break a}}j=f[b+4>>2]|0;k=f[j+4>>2]|0;if((k|0)<=0){l=k;break}m=f[j+40>>2]|0;j=0;do{f[g+(j<<2)>>2]=f[m+(j<<2)>>2];j=j+1|0}while((j|0)!=(k|0));l=k}else{switch(h|0){case 655360:break;default:{i=8;break a}}k=f[b+4>>2]|0;j=f[k+4>>2]|0;if((j|0)<=0){l=j;break}m=f[k+32>>2]|0;k=0;do{f[g+(k<<2)>>2]=f[m+(k<<2)>>2];k=k+1|0}while((k|0)!=(j|0));l=j}else switch(h|0){case 0:{l=0;break}default:i=8}while(0);if((i|0)==8){cS(e,b,-1);f[g>>2]=f[e+4>>2];f[g+4>>2]=f[e>>2];l=2}xS(a,l,g,c,-1,0,0);u=d;return}function $S(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;if((e&2031616|0)!=65536){vS(a);u=c;return}if(e&1073741824|0){e=$Xc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=e;h=231282;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+12>>0]=0;vM(-215,d,233015,230788,1743)}d0(f[a+4>>2]|0,0);u=c;return}function aT(a){a=a|0;return (f[a>>2]&2031616|0)!=0|0}function bT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0;e=u;u=u+112|0;g=e;h=e+56|0;i=f[a>>2]|0;switch(i>>>16&31){case 1:case 2:case 3:case 14:{do if((i&2031616|0)==65536){j=f[a+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;U$(g,j);break}}else bS(g,a,-1);while(0);mR(g,c,d)|0;i=g+36|0;j=f[i>>2]|0;if(j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)V$(g);f[i>>2]=0;i=g+16|0;j=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){i=f[g+40>>2]|0;k=0;do{f[i+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))wL(j);u=e;return}case 10:{KQ(f[a+4>>2]|0,c,d)|0;u=e;return}case 9:{do if((f[c>>2]&2031616|0)==65536){j=f[c+4>>2]|0;f[h>>2]=f[j>>2];k=h+4|0;i=j+4|0;f[k>>2]=f[i>>2];l=h+8|0;f[l>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];m=f[j+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[i>>2]|0)<3){i=f[j+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];break}else{f[k>>2]=0;U$(h,j);break}}else bS(h,c,-1);while(0);c=dS(a,-1)|0;if(((f[h+4>>2]|0)<=2?(j=f[h>>2]|0,j&16384|0):0)?(k=f[h+40>>2]|0,i=f[k+4>>2]|0,l=f[k>>2]|0,k=(i|0)==1,o=(l|0)==1,k|o):0){m=(c>>>3&511)+1|0;if((m|0)==(i|0)&o|k&(o|(m|0)==(l|0))){q=a+4|0;r=f[q>>2]|0;s=h+16|0;t=f[s>>2]|0;v=+p[t>>3];w=t+8|0;x=+p[w>>3];y=t+16|0;z=+p[y>>3];A=t+24|0;B=+p[A>>3];p[g>>3]=v;C=g+8|0;p[C>>3]=x;D=g+16|0;p[D>>3]=z;E=g+24|0;p[E>>3]=B;F=t1()|0;f3(r,g,d,F)|0}if(!(m>>>0>4|(j&4095|0)!=6|k&(l|0)==4^1)){q=a+4|0;r=f[q>>2]|0;s=h+16|0;t=f[s>>2]|0;v=+p[t>>3];w=t+8|0;x=+p[w>>3];y=t+16|0;z=+p[y>>3];A=t+24|0;B=+p[A>>3];p[g>>3]=v;C=g+8|0;p[C>>3]=x;D=g+16|0;p[D>>3]=z;E=g+24|0;p[E>>3]=B;F=t1()|0;f3(r,g,d,F)|0}};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;F=$Xc(80)|0;f[g>>2]=F;f[g+8>>2]=-2147483568;f[g+4>>2]=65;d=F;r=233021;E=d+65|0;do{b[d>>0]=b[r>>0]|0;d=d+1|0;r=r+1|0}while((d|0)<(E|0));b[F+65>>0]=0;vM(-215,g,233087,230788,1841);break}case 0:{u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-213,g,233087,230788,1845)}}}function cT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+80|0;d=c+56|0;e=c;g=f[a>>2]&2031616;h=g&2097151;if((h|0)<131072){switch(h|0){case 65536:break;default:{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-213,d,236898,230788,1888)}}i=f[a+4>>2]|0;if((i|0)==(b|0)){u=c;return}j=b+36|0;k=f[j>>2]|0;if(k|0){l=k+12|0;f[l>>2]=(f[l>>2]|0)+1}l=i+36|0;k=f[l>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)V$(i);f[l>>2]=0;k=i+16|0;m=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[m>>2]|0)>0){n=f[i+40>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0;p=f[m>>2]|0}while((o|0)<(p|0));f[i>>2]=f[b>>2];if((p|0)<3)q=14;else q=16}else{f[i>>2]=f[b>>2];q=14}if((q|0)==14){p=f[b+4>>2]|0;if((p|0)<3){f[m>>2]=p;f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];p=f[b+44>>2]|0;m=f[i+44>>2]|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2]}else q=16}if((q|0)==16)U$(i,b);f[k>>2]=f[b+16>>2];f[i+20>>2]=f[b+20>>2];f[i+24>>2]=f[b+24>>2];f[i+28>>2]=f[b+28>>2];f[i+32>>2]=f[b+32>>2];f[l>>2]=f[j>>2];u=c;return}if((h|0)>=655360){switch(h|0){case 655360:break;default:{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-213,d,236898,230788,1888)}}j=f[a+4>>2]|0;l=d+8|0;f[l>>2]=0;f[l+4>>2]=0;f[d>>2]=34209792;f[d+4>>2]=j;jR(b,d);u=c;return}switch(h|0){case 131072:break;default:{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-213,d,236898,230788,1888)}}do if((g|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];j=e+4|0;l=h+4|0;f[j>>2]=f[l>>2];i=e+8|0;f[i>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];k=f[h+36>>2]|0;f[e+36>>2]=k;f[e+40>>2]=i;i=e+48|0;q=e+44|0;f[q>>2]=i;f[i>>2]=0;f[e+52>>2]=0;if(k|0){i=k+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[l>>2]|0)<3){l=f[h+44>>2]|0;i=f[q>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];break}else{f[j>>2]=0;U$(e,h);break}}else bS(e,a,-1);while(0);a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[d>>2]=-1040121856;f[d+4>>2]=e;jR(b,d);d=e+36|0;b=f[d>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)V$(e);f[d>>2]=0;d=e+16|0;b=e+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[e+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[e+44>>2]|0;if((b|0)!=(e+48|0))wL(b);u=c;return}function dT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((g|0)<720896){switch(g|0){case 327680:break;default:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-213,e,236898,230788,1926)}}h=f[a+4>>2]|0;i=f[h>>2]|0;j=c+4|0;k=f[j>>2]|0;l=f[c>>2]|0;m=i;if((((f[h+4>>2]|0)-i|0)/56|0|0)!=((k-l|0)/48|0|0)){i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=25;n=i;o=233093;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[i+25>>0]=0;vM(-215,e,236898,230788,1913)}if((k|0)==(l|0)){u=d;return}i=e+8|0;q=e+4|0;r=0;s=l;l=m;m=k;while(1){k=s;t=k+(r*48|0)|0;v=l+(r*56|0)|0;w=f[l+(r*56|0)+36>>2]|0;if((w|0)!=0?(w|0)==(f[k+(r*48|0)+24>>2]|0):0){x=s;y=m}else{k=i;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=33619968;f[q>>2]=v;LQ(t,e);x=f[c>>2]|0;y=f[j>>2]|0}t=r+1|0;if(t>>>0>=((y-x|0)/48|0)>>>0)break;r=t;s=x;l=f[h>>2]|0;m=y}u=d;return}else{switch(g|0){case 720896:break;default:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-213,e,236898,230788,1926)}}g=f[a+4>>2]|0;a=f[g>>2]|0;y=c+4|0;m=f[y>>2]|0;h=f[c>>2]|0;l=a;if(((f[g+4>>2]|0)-a|0)!=(m-h|0)){a=$Xc(32)|0;f[e>>2]=a;f[e+8>>2]=-2147483616;f[e+4>>2]=25;n=a;o=233093;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[a+25>>0]=0;vM(-215,e,236898,230788,1899)}if((m|0)==(h|0)){u=d;return}a=e+8|0;o=e+4|0;n=0;p=h;h=l;l=m;while(1){m=p;x=m+(n*48|0)|0;s=h+(n*48|0)|0;r=f[h+(n*48|0)+24>>2]|0;if((r|0)!=0?(r|0)==(f[m+(n*48|0)+24>>2]|0):0){z=p;A=l}else{m=a;f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=34209792;f[o>>2]=s;LQ(x,e);z=f[c>>2]|0;A=f[y>>2]|0}x=n+1|0;if(x>>>0>=((A-z|0)/48|0)>>>0)break;n=x;p=z;h=f[g>>2]|0;l=A}u=d;return}}function eT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((g|0)<720896){switch(g|0){case 327680:break;default:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-213,e,236898,230788,1964)}}h=f[a+4>>2]|0;i=f[h>>2]|0;j=c+4|0;k=f[j>>2]|0;l=f[c>>2]|0;m=i;if(((f[h+4>>2]|0)-i|0)!=(k-l|0)){i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=25;n=i;o=233093;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[i+25>>0]=0;vM(-215,e,236898,230788,1951)}if((k|0)==(l|0)){u=d;return}i=e+8|0;q=e+4|0;r=0;s=l;l=m;m=k;while(1){k=s;t=k+(r*56|0)|0;v=l+(r*56|0)|0;w=f[l+(r*56|0)+36>>2]|0;if((w|0)!=0?(w|0)==(f[k+(r*56|0)+36>>2]|0):0){x=s;y=m}else{k=i;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=33619968;f[q>>2]=v;jR(t,e);x=f[c>>2]|0;y=f[j>>2]|0}t=r+1|0;if(t>>>0>=((y-x|0)/56|0)>>>0)break;r=t;s=x;l=f[h>>2]|0;m=y}u=d;return}else{switch(g|0){case 720896:break;default:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-213,e,236898,230788,1964)}}g=f[a+4>>2]|0;a=f[g>>2]|0;y=c+4|0;m=f[y>>2]|0;h=f[c>>2]|0;l=a;if((((f[g+4>>2]|0)-a|0)/48|0|0)!=((m-h|0)/56|0|0)){a=$Xc(32)|0;f[e>>2]=a;f[e+8>>2]=-2147483616;f[e+4>>2]=25;n=a;o=233093;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[a+25>>0]=0;vM(-215,e,236898,230788,1937)}if((m|0)==(h|0)){u=d;return}a=e+8|0;o=e+4|0;n=0;p=h;h=l;l=m;while(1){m=p;x=m+(n*56|0)|0;s=h+(n*48|0)|0;r=f[h+(n*48|0)+24>>2]|0;if((r|0)!=0?(r|0)==(f[m+(n*56|0)+36>>2]|0):0){z=p;A=l}else{m=a;f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=34209792;f[o>>2]=s;jR(x,e);z=f[c>>2]|0;A=f[y>>2]|0}x=n+1|0;if(x>>>0>=((A-z|0)/56|0)>>>0)break;n=x;p=z;h=f[g>>2]|0;l=A}u=d;return}}function fT(){return 36916}function gT(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=u;u=u+352|0;i=e+216|0;j=e+72|0;k=e+16|0;l=e;m=e+208|0;n=e+200|0;if(!c){f[a>>2]=1124007936;o=a+8|0;p=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}o=f[c>>2]|0;p=o&-65536;if((p|0)==1111621632){s=f[c+24>>2]|0;if((s|0)>-1?(t=f[c+20>>2]|0,(t|0)>-1):0){f[a>>2]=1124007936;v=a+4|0;w=a+8|0;x=a+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=w;x=a+48|0;f[a+44>>2]=x;f[x>>2]=0;y=a+52|0;f[y>>2]=0;if(!d){f[a>>2]=o&20479|1124007936;f[v>>2]=2;f[w>>2]=t;f[a+12>>2]=s;w=f[c+16>>2]|0;f[a+16>>2]=w;f[a+20>>2]=w;v=Y(675553809>>>(o<<2&28)&15,(o>>>3&511)+1|0)|0;z=Y(s,v)|0;A=f[c+4>>2]|0;B=(A|0)==0?z:A;A=w+(Y(B,t)|0)|0;f[a+28>>2]=A;f[a+24>>2]=A+(0-B)+z;f[x>>2]=B;f[y>>2]=v;u=e;return}f[a+16>>2]=0;f[a+24>>2]=0;f[a+20>>2]=0;Tj(i,t,s,o,f[c+16>>2]|0,f[c+4>>2]|0);s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=a;jR(i,j);s=i+36|0;t=f[s>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)V$(i);f[s>>2]=0;s=i+16|0;t=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[i+40>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[t>>2]|0))}t=f[i+44>>2]|0;if((t|0)!=(i+48|0))wL(t);u=e;return}}else if((p|0)==1111687168?(t=f[c+16>>2]|0,v=t,t|0):0){t=a+4|0;s=a+8|0;y=a+40|0;q=t;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[y>>2]=s;B=a+48|0;x=a+44|0;f[x>>2]=B;f[B>>2]=0;f[a+52>>2]=0;B=a+16|0;f[B>>2]=v;z=a+20|0;f[z>>2]=v;f[a>>2]=o&4095|1124007936;v=f[c+4>>2]|0;if((v|0)>0){A=0;do{f[i+(A<<2)>>2]=f[c+20+(A<<3)>>2];f[j+(A<<2)>>2]=f[c+20+(A<<3)+4>>2];A=A+1|0}while((A|0)!=(v|0))}J$(a,v,i,j,0);K$(a);if(d){f[k>>2]=f[a>>2];v=k+4|0;A=f[t>>2]|0;f[v>>2]=A;w=k+8|0;f[w>>2]=f[s>>2];f[k+12>>2]=f[a+12>>2];s=k+16|0;f[s>>2]=f[B>>2];f[k+20>>2]=f[z>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];z=k+36|0;C=a+36|0;D=f[C>>2]|0;f[z>>2]=D;E=k+40|0;f[E>>2]=w;w=k+48|0;F=k+44|0;f[F>>2]=w;f[w>>2]=0;f[k+52>>2]=0;if(!D)G=A;else{A=D+12|0;f[A>>2]=(f[A>>2]|0)+1;G=f[t>>2]|0}if((G|0)<3){G=f[x>>2]|0;x=f[F>>2]|0;f[x>>2]=f[G>>2];f[x+4>>2]=f[G+4>>2]}else{f[v>>2]=0;U$(k,a)}G=f[C>>2]|0;if(G|0?(x=G+12|0,G=f[x>>2]|0,f[x>>2]=G+-1,(G|0)==1):0)V$(a);f[C>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[t>>2]|0)>0){B=f[y>>2]|0;y=0;do{f[B+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[t>>2]|0))}t=l+8|0;f[t>>2]=0;f[t+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=a;jR(k,l);l=f[z>>2]|0;if(l|0?(t=l+12|0,l=f[t>>2]|0,f[t>>2]=l+-1,(l|0)==1):0)V$(k);f[z>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[v>>2]|0)>0){s=f[E>>2]|0;E=0;do{f[s+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[v>>2]|0))}v=f[F>>2]|0;if((v|0)!=(w|0))wL(v)}u=e;return}if((o|0)==112?(v=f[c+68>>2]|0,w=v,v|0):0){F=c+48|0;E=f[F>>2]|0;if(!g)if(E)if((f[E>>2]|0)>0){g=$Xc(48)|0;f[i>>2]=g;f[i+8>>2]=-2147483600;f[i+4>>2]=36;q=g;H=233189;r=q+36|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));b[g+36>>0]=0;vM(-24,i,233226,233119,161)}else I=E;else I=0;else I=E;f[a>>2]=1124007936;E=a+4|0;g=a+8|0;s=a+40|0;z=E+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[s>>2]=g;z=a+48|0;l=a+44|0;f[l>>2]=z;t=a+52|0;f[t>>2]=0;f[E>>2]=2;y=f[c+16>>2]|0;B=1125516576>>>((y>>>2&60)+(y>>31&20)|0);y=f[c+72>>2]|0;f[z>>2]=y;z=c+28|0;C=f[z>>2]|0;G=(C|0)==0;do if(!I)if(G){x=((f[c+8>>2]<<3)+-8|B&7)+1124007936|0;f[a>>2]=x;A=f[c+44>>2]|0;f[g>>2]=A;D=f[c+40>>2]|0;J=a+12|0;f[J>>2]=D;f[a+16>>2]=w;K=a+20|0;f[K>>2]=w;L=Y(675553809>>>(x<<2&28)&15,(x>>>3&511)+1|0)|0;M=K;N=J;O=A;P=v;Q=D;break}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;D=$Xc(48)|0;f[i>>2]=D;f[i+8>>2]=-2147483600;f[i+4>>2]=38;q=D;H=233237;r=q+38|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));b[D+38>>0]=0;vM(-215,i,233276,233119,106)}else{A=f[I>>2]|0;do if(!G)if(A){J=B&7;if((C|0)==1){R=J;S=0;T=1;break}else{U=J;V=58;break}}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;J=$Xc(64)|0;f[i>>2]=J;f[i+8>>2]=-2147483584;f[i+4>>2]=60;q=J;H=233290;r=q+60|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));b[J+60>>0]=0;vM(-215,i,233276,233119,115)}else{U=B&7;V=58}while(0);if((V|0)==58){R=U;S=(f[c+8>>2]<<3)+-8|0;T=0}D=R+1124007936+S|0;f[a>>2]=D;K=f[I+16>>2]|0;f[g>>2]=K;x=f[I+12>>2]|0;W=a+12|0;f[W>>2]=x;X=Y(675553809>>>(D<<2&28)&15,(D>>>3&511)+1|0)|0;if(T){D=Y(A+-1|0,y)|0;Z=Y(D,f[c+44>>2]|0)|0}else Z=0;D=v+Z+(Y(f[I+8>>2]|0,y)|0)|0;_=D+(Y(f[I+4>>2]|0,X)|0)|0;f[a+16>>2]=_;D=a+20|0;f[D>>2]=_;L=X;M=D;N=W;O=K;P=_;Q=x}while(0);I=P+(Y(O,y)|0)|0;Z=a+28|0;f[Z>>2]=I;I=P+(Y(O+-1|0,y)|0)+(Y(L,Q)|0)|0;Q=a+24|0;f[Q>>2]=I;f[t>>2]=L;R$(a);if(!d){u=e;return}f[j>>2]=f[a>>2];L=j+4|0;t=f[E>>2]|0;f[L>>2]=t;I=j+8|0;f[I>>2]=f[g>>2];g=j+12|0;f[g>>2]=f[N>>2];N=j+16|0;y=a+16|0;f[N>>2]=f[y>>2];f[j+20>>2]=f[M>>2];f[j+24>>2]=f[Q>>2];f[j+28>>2]=f[Z>>2];f[j+32>>2]=f[a+32>>2];Z=j+36|0;Q=a+36|0;M=f[Q>>2]|0;f[Z>>2]=M;O=j+40|0;f[O>>2]=I;P=j+48|0;v=j+44|0;f[v>>2]=P;f[P>>2]=0;f[j+52>>2]=0;if(!M)$=t;else{t=M+12|0;f[t>>2]=(f[t>>2]|0)+1;$=f[E>>2]|0}if(($|0)<3){$=f[l>>2]|0;l=f[v>>2]|0;f[l>>2]=f[$>>2];f[l+4>>2]=f[$+4>>2]}else{f[L>>2]=0;U$(j,a)}$=f[Q>>2]|0;if($|0?(l=$+12|0,$=f[l>>2]|0,f[l>>2]=$+-1,($|0)==1):0)V$(a);f[Q>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[E>>2]|0)>0){y=f[s>>2]|0;s=0;do{f[y+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[E>>2]|0))}E=f[F>>2]|0;if(((E|0)!=0?(F=f[E>>2]|0,(F|0)!=0):0)?(f[z>>2]|0)!=1:0){f[k>>2]=F+-1;f[k+4>>2]=0;F=f[g>>2]|0;g=f[j>>2]&4095;f[i>>2]=f[I>>2];f[i+4>>2]=F;S$(a,2,i,g);d1(j,1,a,1,k,1)}else{k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;jR(j,i)}k=f[Z>>2]|0;if(k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)V$(j);f[Z>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[L>>2]|0)>0){N=f[O>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[v>>2]|0;if((L|0)!=(P|0))wL(L);u=e;return}if((p|0)!=1117323264){p=$Xc(32)|0;f[i>>2]=p;f[i+8>>2]=-2147483616;f[i+4>>2]=18;q=p;H=233396;r=q+18|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));b[p+18>>0]=0;vM(-5,i,233226,233119,185)}p=f[c+24>>2]|0;L=o&4095;P=f[c+28>>2]|0;if(!p){f[a>>2]=1124007936;v=a+8|0;O=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[O>>2]=v;v=a+48|0;f[a+44>>2]=v;f[v>>2]=0;f[a+52>>2]=0;u=e;return}if((p|0)<=0){aa=$Xc(48)|0;f[i>>2]=aa;ba=i+8|0;f[ba>>2]=-2147483600;ca=i+4|0;f[ca>>2]=44;q=aa;H=233351;r=q+44|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));da=aa+44|0;b[da>>0]=0;vM(-215,i,233226,233119,170)}if((Y(675553809>>>(o<<2&28)&15,(o>>>3&511)+1|0)|0)!=(P|0)){aa=$Xc(48)|0;f[i>>2]=aa;ba=i+8|0;f[ba>>2]=-2147483600;ca=i+4|0;f[ca>>2]=44;q=aa;H=233351;r=q+44|0;do{b[q>>0]=b[H>>0]|0;q=q+1|0;H=H+1|0}while((q|0)<(r|0));da=aa+44|0;b[da>>0]=0;vM(-215,i,233226,233119,170)}if(!d?(d=f[c+52>>2]|0,(f[d+4>>2]|0)==(d|0)):0){Tj(a,p,1,L,f[d+16>>2]|0,0);u=e;return}if(!h){f[j>>2]=1124007936;d=j+4|0;da=j+8|0;aa=j+40|0;q=d;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[aa>>2]=da;q=j+48|0;f[j+44>>2]=q;f[q>>2]=0;f[j+52>>2]=0;f[i>>2]=p;f[i+4>>2]=1;S$(j,2,i,L);r=j+16|0;H=f[r>>2]|0;f[n>>2]=0;f[n+4>>2]=1073741823;f[i>>2]=f[n>>2];f[i+4>>2]=f[n+4>>2];rT(c,H,i)|0;f[a>>2]=f[j>>2];H=f[d>>2]|0;f[a+4>>2]=H;n=a+8|0;f[n>>2]=f[da>>2];f[a+12>>2]=f[j+12>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];ca=j+36|0;f[a+36>>2]=f[ca>>2];ba=a+40|0;f[ba>>2]=n;n=a+44|0;o=a+48|0;f[n>>2]=o;v=a+52|0;f[v>>2]=0;f[o>>2]=0;O=j+44|0;if((H|0)<3){H=f[O>>2]|0;f[o>>2]=f[H>>2];f[v>>2]=f[H+4>>2];ea=H}else{f[n>>2]=f[O>>2];f[ba>>2]=f[aa>>2];f[O>>2]=q;f[aa>>2]=da;ea=q}f[j>>2]=1124007936;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[ca>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((ea|0)!=(q|0))wL(ea);u=e;return}ea=(Y(P,p)|0)+7|0;P=ea>>>3;q=h+4|0;do if((f[q>>2]|0)>>>0<P>>>0){r=f[h>>2]|0;ca=h+8|0;if((r|0)==(ca|0))fa=r;else{if(r|0)dYc(r);f[h>>2]=ca;f[q>>2]=136;fa=ca}f[q>>2]=P;if(ea>>>0>1095){ca=bYc(P<<3)|0;f[h>>2]=ca;ga=ca;break}else{ga=fa;break}}else{f[q>>2]=P;ga=f[h>>2]|0}while(0);f[m>>2]=0;f[m+4>>2]=1073741823;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];rT(c,ga,i)|0;Tj(a,p,1,L,ga,0);u=e;return}function hT(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=xL(24)|0;if(!d){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,233415,233433,92)}else{c=d+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[d>>2]=1116274688;f[d+16>>2]=(a|0)<1?65408:a+7&-8;u=b;return d|0}return 0}function iT(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,233506,233433,121)}d=f[a+16>>2]|0;e=xL(24)|0;if(!e){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,233415,233433,92)}else{c=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[e>>2]=1116274688;f[e+16>>2]=(d|0)<1?65408:d+7&-8;f[e+12>>2]=a;u=b;return e|0}return 0}function jT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,233530,233433,183)}c=f[a>>2]|0;f[a>>2]=0;if(!c){u=b;return}a=c+12|0;d=f[a>>2]|0;if(!d)e=0;else e=f[d+8>>2]|0;g=c+4|0;h=f[g>>2]|0;a:do if(!h)i=c+20|0;else{j=c+16|0;k=c+20|0;l=e;m=h;n=d;while(1){o=m+4|0;p=f[o>>2]|0;if(!n){q=m;r=p;while(1){yL(q);if(!r){i=k;break a}s=f[a>>2]|0;t=r+4|0;v=f[t>>2]|0;if(!s){w=r;r=v;q=w}else{x=r;y=v;z=t;A=s;break}}}else{x=m;y=p;z=o;A=n}if(!l){f[A+8>>2]=x;f[A+4>>2]=x;f[z>>2]=0;f[x>>2]=0;f[k>>2]=(f[j>>2]|0)+-8}else{f[x>>2]=l;r=l+4|0;q=f[r>>2]|0;f[z>>2]=q;if(q|0)f[q>>2]=x;f[r>>2]=x}if(!y){i=k;break}else{l=x;m=y;n=A}}}while(0);f[g>>2]=0;f[c+8>>2]=0;f[i>>2]=0;yL(c);u=b;return}function kT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,233550,233433,200)}c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;if(!c){f[a+8>>2]=e;if(!e)g=0;else g=(f[a+16>>2]|0)+-8|0;f[a+20>>2]=g;u=b;return}if(!e)h=a+20|0;else{g=a+16|0;i=a+20|0;j=c+8|0;k=c+4|0;l=f[c+8>>2]|0;c=e;while(1){e=c+4|0;m=f[e>>2]|0;if(!l){f[j>>2]=c;f[k>>2]=c;f[e>>2]=0;f[c>>2]=0;f[i>>2]=(f[g>>2]|0)+-8}else{f[c>>2]=l;n=l+4|0;o=f[n>>2]|0;f[e>>2]=o;if(o|0)f[o>>2]=c;f[n>>2]=c}if(!m){h=i;break}else{n=c;c=m;l=n}}}f[d>>2]=0;f[a+8>>2]=0;f[h>>2]=0;u=b;return}function lT(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;if((a|0)!=0&(b|0)!=0){f[b>>2]=f[a+8>>2];f[b+4>>2]=f[a+20>>2];u=c;return}else{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-27,d,233568,233433,276)}}function mT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-27,d,233588,233433,288)}e=f[b+4>>2]|0;g=f[a+16>>2]|0;if((e|0)>(g|0)){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-201,d,233588,233433,290)}d=f[b>>2]|0;b=a+8|0;f[b>>2]=d;h=a+20|0;f[h>>2]=e;if(d|0){u=c;return}d=f[a+4>>2]|0;f[b>>2]=d;f[h>>2]=(d|0)==0?0:g+-8|0;u=c;return}function nT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=20;h=g;i=368547;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+20>>0]=0;vM(-27,e,233611,233433,327)}if((c|0)<0){g=$Xc(48)|0;f[e>>2]=g;f[e+8>>2]=-2147483600;f[e+4>>2]=35;h=g;i=233629;j=h+35|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+35>>0]=0;vM(-211,e,233611,233433,330)}g=a+20|0;k=f[g>>2]|0;l=a+16|0;if(k>>>0>=c>>>0){m=k;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[g>>2]=v;u=d;return s|0}if(((f[l>>2]|0)+-8&-8)>>>0<c>>>0){k=$Xc(48)|0;f[e>>2]=k;f[e+8>>2]=-2147483600;f[e+4>>2]=37;h=k;i=233665;j=h+37|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[k+37>>0]=0;vM(-211,e,233611,233433,338)}oT(a);m=f[g>>2]|0;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[g>>2]=v;u=d;return s|0}function oT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,233703,233433,218)}d=a+8|0;e=f[d>>2]|0;if((e|0)!=0?(g=f[e+4>>2]|0,(g|0)!=0):0)h=g;else{g=f[a+12>>2]|0;do if(g){e=g+8|0;i=f[e>>2]|0;j=g+20|0;k=f[j>>2]|0;oT(g);l=f[e>>2]|0;m=f[g+16>>2]|0;if((k|0)>(m|0)){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-201,c,233588,233433,290)}f[e>>2]=i;f[j>>2]=k;if(!i){k=f[g+4>>2]|0;f[e>>2]=k;f[j>>2]=(k|0)==0?0:m+-8|0;n=k;o=k}else{n=i;o=i}if((l|0)==(n|0)){f[g+4>>2]=0;f[e>>2]=0;f[j>>2]=0;p=l;break}j=l+4|0;f[n+4>>2]=f[j>>2];e=f[j>>2]|0;if(!e)p=l;else{f[e>>2]=o;p=l}}else p=xL(f[a+16>>2]|0)|0;while(0);f[p+4>>2]=0;o=f[d>>2]|0;f[p>>2]=o;if(!o){f[a+4>>2]=p;q=d}else q=o+4|0;f[q>>2]=p;p=f[(f[d>>2]|0)+4>>2]|0;if(!p){r=a+16|0;s=f[r>>2]|0;t=s+-8|0;v=a+20|0;f[v>>2]=t;u=b;return}else h=p}f[d>>2]=h;r=a+16|0;s=f[r>>2]|0;t=s+-8|0;v=a+20|0;f[v>>2]=t;u=b;return}function pT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;if(!e){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;vM(-27,h,233721,233433,377)}if(c>>>0<56|(d|0)==0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;vM(-201,h,233721,233433,379)}i=nT(e,c)|0;g1c(i|0,0,c|0)|0;f[i+4>>2]=c;f[i>>2]=a&65535|1117323264;c=Y(675553809>>>(a<<2&28)&15,(a>>>3&511)+1|0)|0;a:do if(c|0){switch(a&4095){case 0:case 56:{break a;break}default:{}}if((c|0)!=(d|0)){j=$Xc(112)|0;f[h>>2]=j;f[h+8>>2]=-2147483536;f[h+4>>2]=110;k=j;l=233733;m=k+110|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+110>>0]=0;vM(-201,h,233721,233433,395)}}while(0);f[i+28>>2]=d;f[i+44>>2]=e;qT(i,1024/(d>>>0)|0);u=g;return i|0}function qT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,233844,233433,415)}g=f[a+44>>2]|0;if(!g){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,233844,233433,415)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-211,e,233844,233433,417)}h=(f[g+16>>2]|0)+-28&-8;g=f[a+28>>2]|0;if(!c){i=1024/(g|0)|0;j=(i|0)>1?i:1}else j=c;if((Y(j,g)|0)<=(h|0)){k=j;l=a+40|0;f[l>>2]=k;u=d;return}j=(h|0)/(g|0)|0;if(!j){g=$Xc(64)|0;f[e>>2]=g;f[e+8>>2]=-2147483584;f[e+4>>2]=60;h=g;c=233862;i=h+60|0;do{b[h>>0]=b[c>>0]|0;h=h+1|0;c=c+1|0}while((h|0)<(i|0));b[g+60>>0]=0;vM(-211,e,233844,233433,433)}else{k=j;l=a+40|0;f[l>>2]=k;u=d;return}}function rT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+48|0;e=d+16|0;g=d;if(!((a|0)!=0&(b|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-27,g,233923,233433,551)}g=f[a+28>>2]|0;h=c;c=f[h>>2]|0;i=f[h+4>>2]|0;h=f[a+24>>2]|0;if((i|0)==(c|0))j=0;else j=i-c+((c|0)<0?0-h|0:0)+((i|0)<1?h:0)|0;while(1)if((j|0)<0)j=j+h|0;else break;i=Y((j|0)>(h|0)?h:j,g)|0;if(!i){k=0;u=d;return k|0}j=e+4|0;h=e+8|0;l=e+20|0;m=e+12|0;n=j+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[e>>2]=32;f[j>>2]=a;j=f[a+52>>2]|0;if(!j){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0}else{a=f[j>>2]|0;n=f[j+16>>2]|0;f[m>>2]=n;o=(f[a+16>>2]|0)+(Y((f[a+12>>2]|0)+-1|0,g)|0)|0;f[e+28>>2]=o;f[e+24>>2]=f[j+8>>2];o=n;f[h>>2]=j;f[e+16>>2]=o;n=o+(Y(f[j+12>>2]|0,g)|0)|0;f[l>>2]=n}sT(e,c,0);c=i;i=b;e=f[m>>2]|0;n=f[l>>2]|0;while(1){j=n-e|0;o=(j|0)>(c|0)?c:j;o1c(i|0,e|0,o|0)|0;j=f[(f[h>>2]|0)+4>>2]|0;f[h>>2]=j;e=f[j+16>>2]|0;f[m>>2]=e;n=e+(Y(f[j+12>>2]|0,g)|0)|0;f[l>>2]=n;c=c-o|0;if((c|0)<=0){k=b;break}else i=i+o|0}u=d;return k|0}function sT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,233939,233433,1045)}g=f[a+4>>2]|0;if(!g){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,233939,233433,1045)}h=f[g+24>>2]|0;i=f[g+28>>2]|0;if(c|0){c=a+12|0;j=f[c>>2]|0;k=Y(i,b)|0;l=a+8|0;m=f[l>>2]|0;n=j+k|0;if((k|0)>0){o=a+20|0;p=f[o>>2]|0;if(n>>>0<p>>>0)q=n;else{r=j;s=m;t=k;v=p;do{t=t+r-v|0;s=f[s+4>>2]|0;r=f[s+16>>2]|0;p=Y(f[s+12>>2]|0,i)|0;v=r+p|0}while((t|0)>=(p|0));f[l>>2]=s;f[a+16>>2]=r;f[o>>2]=v;q=r+t|0}}else{t=a+16|0;r=f[t>>2]|0;if(n>>>0<r>>>0){v=j;j=m;m=k;k=r;do{m=m+v-k|0;j=f[j>>2]|0;k=f[j+16>>2]|0;v=k+(Y(f[j+12>>2]|0,i)|0)|0;w=v+m|0}while(w>>>0<k>>>0);f[l>>2]=j;f[t>>2]=k;f[a+20>>2]=v;q=w}else q=n}f[c>>2]=q;u=d;return}do if((b|0)<0)if((b|0)<(0-h|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-211,e,233939,233433,1055)}else{x=h+b|0;break}else if((h|0)<=(b|0)){q=b-h|0;if((q|0)<(h|0))x=q;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-211,e,233939,233433,1062)}}else x=b;while(0);b=f[g+52>>2]|0;g=f[b+12>>2]|0;a:do if((x|0)<(g|0)){y=x;z=b;A=g}else{if((x<<1|0)>(h|0)){B=h;C=b}else{e=b;q=g;c=x;while(1){n=f[e+4>>2]|0;w=c-q|0;v=f[n+12>>2]|0;if((w|0)<(v|0)){y=w;z=n;A=v;break a}else{e=n;q=v;c=w}}}do{C=f[C>>2]|0;D=f[C+12>>2]|0;B=B-D|0}while((x|0)<(B|0));y=x-B|0;z=C;A=D}while(0);D=f[z+16>>2]|0;C=D+(Y(y,i)|0)|0;f[a+12>>2]=C;C=a+8|0;if((f[C>>2]|0)==(z|0)){u=d;return}f[C>>2]=z;f[a+16>>2]=D;z=D+(Y(A,i)|0)|0;f[a+20>>2]=z;u=d;return}function tT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;if(!b){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,233957,233433,945)}g=b+4|0;h=b+8|0;i=b+12|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;if(!a){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,233957,233433,945)}f[b>>2]=32;f[g>>2]=a;g=f[a+52>>2]|0;if(!g){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;u=d;return}e=f[g>>2]|0;j=f[g+16>>2]|0;f[i>>2]=j;k=f[e+16>>2]|0;l=f[a+28>>2]|0;a=k+(Y((f[e+12>>2]|0)+-1|0,l)|0)|0;m=b+28|0;f[m>>2]=a;f[b+24>>2]=f[g+8>>2];if(!c){n=g;o=j}else{f[i>>2]=a;f[m>>2]=j;n=e;o=k}f[h>>2]=n;f[b+16>>2]=o;h=o+(Y(f[n+12>>2]|0,l)|0)|0;f[b+20>>2]=h;u=d;return}function uT(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+16|0;k=j;if((c|0)<56|(d|0)<1|(g|0)<0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;vM(-201,k,233972,233433,590)}if(!h){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;vM(-27,k,233972,233433,593)}l=(g|0)>0;if(l&((e|0)==0|(i|0)==0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;vM(-27,k,233972,233433,593)}g1c(h|0,0,c|0)|0;f[h+4>>2]=c;f[h>>2]=a&65535|1117323264;c=Y(675553809>>>(a<<2&28)&15,(a>>>3&511)+1|0)|0;if(!((c|0)==(d|0)|((a&4095|0)==0|(c|0)==0))){c=$Xc(112)|0;f[k>>2]=c;f[k+8>>2]=-2147483536;f[k+4>>2]=106;a=c;m=233996;n=a+106|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(n|0));b[c+106>>0]=0;vM(-201,k,233972,233433,607)}f[h+28>>2]=d;f[h+24>>2]=g;k=e+(Y(g,d)|0)|0;f[h+36>>2]=k;f[h+32>>2]=k;if(!l){u=j;return h|0}f[h+52>>2]=i;f[i+4>>2]=i;f[i>>2]=i;f[i+8>>2]=0;f[i+12>>2]=g;f[i+16>>2]=e;u=j;return h|0}function vT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-27,d,234103,233433,820)}d=b+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[b>>2]=24;f[b+4>>2]=a;d=f[a+52>>2]|0;if(!d)e=0;else e=f[d>>2]|0;f[b+8>>2]=e;f[b+12>>2]=f[a+36>>2];f[b+20>>2]=f[a+32>>2];u=c;return}function wT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;if(!((d|0)!=0&(e|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;vM(-27,h,234122,233433,838)}i=pT(a,b,c,d)|0;if(!i){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;vM(-27,h,234103,233433,820)}h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e>>2]=24;f[e+4>>2]=i;d=f[i+52>>2]|0;if(!d)j=0;else j=f[d>>2]|0;f[h>>2]=j;f[e+12>>2]=f[i+36>>2];f[e+20>>2]=f[i+32>>2];u=g;return}function xT(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,234138,233433,850)}c=f[a+4>>2]|0;d=f[a+12>>2]|0;f[c+36>>2]=d;e=f[a+8>>2]|0;if(!e){u=b;return}a=f[c+52>>2]|0;f[e+12>>2]=(d-(f[e+16>>2]|0)|0)/(f[c+28>>2]|0)|0;e=a;d=0;do{d=(f[e+12>>2]|0)+d|0;e=f[e+4>>2]|0}while((e|0)!=(a|0));f[c+24>>2]=d;u=b;return}function yT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,234155,233433,881)}c=f[a+4>>2]|0;d=a+12|0;e=f[d>>2]|0;f[c+36>>2]=e;g=f[a+8>>2]|0;a=e;if(!g){f[d>>2]=0;u=b;return c|0}e=f[c+52>>2]|0;f[g+12>>2]=(a-(f[g+16>>2]|0)|0)/(f[c+28>>2]|0)|0;g=e;h=0;do{h=(f[g+12>>2]|0)+h|0;g=f[g+4>>2]|0}while((g|0)!=(e|0));f[c+24>>2]=h;h=f[c+44>>2]|0;if(!h){f[d>>2]=0;u=b;return c|0}e=(f[h+8>>2]|0)+(f[h+16>>2]|0)|0;g=h+20|0;h=c+32|0;if((e+(0-(f[g>>2]|0))-(f[h>>2]|0)|0)>>>0>=8){f[d>>2]=0;u=b;return c|0}f[g>>2]=e-a&-8;f[h>>2]=a;f[d>>2]=0;u=b;return c|0}function zT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,234169,233433,912)}d=f[a+4>>2]|0;if(!d){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,234169,233433,912)}c=a+12|0;e=f[c>>2]|0;g=d+36|0;f[g>>2]=e;h=a+8|0;i=f[h>>2]|0;j=d+52|0;if(i|0){k=f[j>>2]|0;f[i+12>>2]=(e-(f[i+16>>2]|0)|0)/(f[d+28>>2]|0)|0;i=k;e=0;do{e=(f[i+12>>2]|0)+e|0;i=f[i+4>>2]|0}while((i|0)!=(k|0));f[d+24>>2]=e}AT(d,0);f[h>>2]=f[f[j>>2]>>2];f[c>>2]=f[g>>2];f[a+20>>2]=f[d+32>>2];u=b;return}function AT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,234186,233433,637)}g=a+48|0;h=f[g>>2]|0;if(!h){i=a+28|0;j=f[i>>2]|0;k=f[a+40>>2]|0;l=f[a+44>>2]|0;if((f[a+24>>2]|0)>=(k<<2|0))qT(a,k<<1);if(!l){m=$Xc(48)|0;f[e>>2]=m;f[e+8>>2]=-2147483600;f[e+4>>2]=37;n=m;o=234197;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+37>>0]=0;vM(-27,e,234186,233433,650)}e=(f[l+8>>2]|0)+(f[l+16>>2]|0)|0;m=l+20|0;o=f[m>>2]|0;n=a+32|0;p=f[n>>2]|0;if((e+(0-o)-p|0)>>>0<8?!(c|0?1:(o|0)<(f[i>>2]|0)):0){q=(o|0)/(j|0)|0;r=p+(Y((q|0)>(k|0)?k:q,j)|0)|0;f[n>>2]=r;f[m>>2]=e-r&-8;u=d;return}r=(Y(k,j)|0)+24|0;do if((o|0)<(r|0))if((o|0)<((Y((k|0)>5?(k|0)/3|0:1,j)|0)+32|0)){oT(l);s=r;break}else{s=o-((o+-24|0)%(f[i>>2]|0)|0)|0;break}else s=r;while(0);r=nT(l,s)|0;f[r+16>>2]=r+20+7&-8;f[r+12>>2]=s+-24;f[r+4>>2]=0;f[r>>2]=0;t=r}else{f[g>>2]=f[h+4>>2];t=h}h=a+52|0;g=f[h>>2]|0;if(!g){f[h>>2]=t;v=t;w=t;x=t}else{f[t>>2]=f[g>>2];f[g>>2]=t;v=g;w=t;x=(f[t>>2]|0)+4|0}f[t+4>>2]=v;f[x>>2]=t;x=f[t+12>>2]|0;v=t+16|0;g=f[v>>2]|0;r=f[w>>2]|0;if(c){c=(x|0)/(f[a+28>>2]|0)|0;w=g+x|0;f[v>>2]=w;if((t|0)==(r|0)){f[a+36>>2]=w;f[a+32>>2]=w;y=f[h>>2]|0}else{f[h>>2]=t;y=t}f[t+8>>2]=c;h=f[t+4>>2]|0;if((h|0)==(y|0))z=y;else{w=h;do{f[w+8>>2]=(f[w+8>>2]|0)+c;w=f[w+4>>2]|0}while((w|0)!=(y|0));z=y}}else{f[a+36>>2]=g;f[a+32>>2]=g+x;if((t|0)==(r|0))A=0;else A=(f[r+12>>2]|0)+(f[r+8>>2]|0)|0;f[t+8>>2]=A;z=t}f[z+12>>2]=0;u=d;return}function BT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-27,d,234235,233433,995)}d=a+8|0;e=f[d>>2]|0;g=f[(f[a+4>>2]|0)+28>>2]|0;if((b|0)>0){b=f[e+4>>2]|0;f[d>>2]=b;h=f[b+16>>2]|0;i=h;j=h;k=f[b+12>>2]|0}else{b=f[e>>2]|0;f[d>>2]=b;d=f[b+16>>2]|0;e=f[b+12>>2]|0;i=d+(Y(e+-1|0,g)|0)|0;j=d;k=e}f[a+12>>2]=i;f[a+16>>2]=j;i=j+(Y(k,g)|0)|0;f[a+20>>2]=i;u=c;return}function CT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;if(!d){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-27,g,234262,233433,2486)}if((b|0)>63&(c|0)>7&(c&3|0)==0){h=pT(a,b,c,d)|0;f[h>>2]=f[h>>2]&65535|1117257728;u=e;return h|0}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-201,g,234262,233433,2490)}return 0}function DT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,234274,233433,2507)}e=a+56|0;g=f[e>>2]|0;if(!g){h=a+24|0;i=f[h>>2]|0;j=f[a+28>>2]|0;AT(a,0);k=a+36|0;l=f[k>>2]|0;f[e>>2]=l;m=l+j|0;n=f[a+32>>2]|0;if(m>>>0>n>>>0){o=l;p=i}else{q=i;i=l;r=m;while(1){f[i>>2]=q|-2147483648;f[i+4>>2]=r;m=q+1|0;s=r+j|0;if(s>>>0>n>>>0){o=r;p=m;break}else{t=r;q=m;r=s;i=t}}}f[o+(0-j)+4>>2]=0;j=(f[f[a+52>>2]>>2]|0)+12|0;f[j>>2]=p-(f[h>>2]|0)+(f[j>>2]|0);f[h>>2]=p;f[k>>2]=n;v=l}else v=g;f[e>>2]=f[v+4>>2];e=f[v>>2]&67108863;if(b|0)o1c(v|0,b|0,f[a+28>>2]|0)|0;f[v>>2]=e;b=a+60|0;f[b>>2]=(f[b>>2]|0)+1;if(!c){u=d;return e|0}f[c>>2]=v;u=d;return e|0}function ET(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e+4|0;h=e;if(!d){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=20;j=i;k=368547;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+20>>0]=0;vM(-27,g,234283,233433,3346)}if(c>>>0<56){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-201,g,233721,233433,379)}i=nT(d,c)|0;g1c(i|0,0,c|0)|0;f[i+4>>2]=c;f[i>>2]=1117323264;c=i+28|0;f[c>>2]=4;f[i+44>>2]=d;qT(i,256);if(!a){u=e;return i|0}d=i+36|0;k=i+32|0;j=i+52|0;l=i+24|0;if(!i){f[h>>2]=a;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-27,g,234252,233433,1138)}g=a;m=0;n=a;while(1){a=f[g+20>>2]|0;if(a){o=m+1|0;if((o|0)==2147483647){p=n;q=2147483646;r=11}else{s=o;t=a}}else{p=n;q=m;r=11}a:do if((r|0)==11){while(1){r=0;v=f[p+12>>2]|0;if(v|0)break;a=q+-1|0;if((q|0)<1){s=a;t=0;break a}else{p=f[p+16>>2]|0;q=a;r=11}}s=q;t=(p|0)==0?0:v}while(0);f[h>>2]=g;a=f[c>>2]|0;o=f[d>>2]|0;if(o>>>0<(f[k>>2]|0)>>>0)w=o;else{AT(i,0);w=f[d>>2]|0}o1c(w|0,h|0,a|0)|0;o=(f[f[j>>2]>>2]|0)+12|0;f[o>>2]=(f[o>>2]|0)+1;f[l>>2]=(f[l>>2]|0)+1;f[d>>2]=w+a;if(!t)break;else{g=t;m=s;n=t}}u=e;return i|0}function FT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,234299,233433,3443)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-211,e,234299,233433,3446)}else{f[a>>2]=b;f[a+4>>2]=0;f[a+8>>2]=c;u=d;return}}function GT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if(!a){e=$Xc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=21;g=e;h=234322;i=g+21|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+21>>0]=0;vM(-27,d,234344,233433,3462)}d=f[a>>2]|0;e=a+4|0;h=f[e>>2]|0;a:do if(d){g=f[d+20>>2]|0;if((g|0)!=0?(i=h+1|0,(i|0)<(f[a+8>>2]|0)):0){j=g;k=i;break}else{l=d;m=h}while(1){n=f[l+12>>2]|0;if(n|0)break;i=m+-1|0;if((m|0)<1){j=0;k=i;break a}else{l=f[l+16>>2]|0;m=i}}if(!l){j=0;k=m}else{j=(f[a+8>>2]|0)==0?0:n;k=m}}else{j=d;k=h}while(0);f[a>>2]=j;f[e>>2]=k;u=c;return d|0}function HT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,234359,233433,3392)}f[a+16>>2]=(b|0)!=(c|0)?b:0;c=b+20|0;b=f[c>>2]|0;f[a+12>>2]=b;if(!b){f[c>>2]=a;u=d;return}f[b+8>>2]=a;f[c>>2]=a;u=d;return}function IT(a,b){a=a|0;b=b|0;return f[36932+((b&7)<<5)+((a&7)<<2)>>2]|0}function JT(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(h[o+g>>0]|0))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+c|0;q=q+i|0}}return}function KT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(b[n+g>>0]|0))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+h|0}}return}function LT(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(j[o+(g<<1)>>1]|0))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+(k<<1)|0;q=q+h|0}}return}function MT(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=ALc(m+l*+(d[o+(h<<1)>>1]|0))|0;b[q+h>>0]=a>>>0<256?a:(a|0)>0?255:0;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+(k<<1)|0;q=q+i|0}}return}function NT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(f[n+(g<<2)>>2]|0))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(j<<2)|0;o=o+h|0}}return}function OT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(l+k*+n[o+(g<<2)>>2])|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+(j<<2)|0;q=q+h|0}}return}function PT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if((d|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=zLc(l+k*+p[n+(g<<3)>>3])|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(i<<3)|0;o=o+h|0}}return}function QT(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0,u=0,v=0,w=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){o=0;q=a;r=g}else return;while(1){g=0;do{a=j[q+(g<<1)>>1]|0;c=a<<13;i=c&268427264;t=i+939524096|0;u=a<<16&-2147483648;v=a&31744;a:do if(v<<16>>16<31744){switch(v<<16>>16){case 0:break;default:{w=t;break a}}w=(n[s>>2]=(f[s>>2]=i+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(v<<16>>16){case 31744:break;default:{w=t;break a}}w=c|1879048192}while(0);c=ALc(m+l*(f[s>>2]=w|u,+n[s>>2]))|0;b[r+g>>0]=c>>>0<256?c:(c|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));o=o+1|0;if((o|0)==(d|0))break;else{q=q+(k<<1)|0;r=r+h|0}}return}function RT(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(h[o+g>>0]|0))|0;b[q+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+c|0;q=q+i|0}}return}function ST(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(b[n+g>>0]|0))|0;b[o+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+h|0}}return}function TT(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(j[o+(g<<1)>>1]|0))|0;b[q+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+(k<<1)|0;q=q+h|0}}return}function UT(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=ALc(m+l*+(d[o+(h<<1)>>1]|0))|0;b[q+h>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+(k<<1)|0;q=q+i|0}}return}function VT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(f[n+(g<<2)>>2]|0))|0;b[o+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(j<<2)|0;o=o+h|0}}return}function WT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(l+k*+n[o+(g<<2)>>2])|0;b[q+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+(j<<2)|0;q=q+h|0}}return}function XT(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if((d|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=zLc(l+k*+p[n+(g<<3)>>3])|0;b[o+g>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(i<<3)|0;o=o+h|0}}return}function YT(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0,u=0,v=0,w=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){o=0;q=a;r=g}else return;while(1){g=0;do{a=j[q+(g<<1)>>1]|0;c=a<<13;i=c&268427264;t=i+939524096|0;u=a<<16&-2147483648;v=a&31744;a:do if(v<<16>>16<31744){switch(v<<16>>16){case 0:break;default:{w=t;break a}}w=(n[s>>2]=(f[s>>2]=i+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(v<<16>>16){case 31744:break;default:{w=t;break a}}w=c|1879048192}while(0);c=ALc(m+l*(f[s>>2]=w|u,+n[s>>2]))|0;b[r+g>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;g=g+1|0}while((g|0)!=(e|0));o=o+1|0;if((o|0)==(d|0))break;else{q=q+(k<<1)|0;r=r+h|0}}return}function ZT(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((c|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(h[o+g>>0]|0))|0;d[q+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+b|0;q=q+(k<<1)|0}}return}function _T(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=ALc(m+l*+(b[o+h>>0]|0))|0;d[q+(h<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+c|0;q=q+(k<<1)|0}}return}function $T(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(j[o+(g<<1)>>1]|0))|0;d[q+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+(k<<1)|0;q=q+(b<<1)|0}}return}function aU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(d[n+(g<<1)>>1]|0))|0;d[o+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<1)|0}}return}function bU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(f[n+(g<<2)>>2]|0))|0;d[o+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<2)|0;o=o+(b<<1)|0}}return}function cU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(l+k*+n[o+(g<<2)>>2])|0;d[q+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(j<<2)|0;q=q+(b<<1)|0}}return}function dU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((c|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=zLc(l+k*+p[n+(g<<3)>>3])|0;d[o+(g<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<3)|0;o=o+(b<<1)|0}}return}function eU(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0,u=0,v=0,w=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){o=0;q=a;r=g}else return;while(1){g=0;do{a=j[q+(g<<1)>>1]|0;h=a<<13;i=h&268427264;t=i+939524096|0;u=a<<16&-2147483648;v=a&31744;a:do if(v<<16>>16<31744){switch(v<<16>>16){case 0:break;default:{w=t;break a}}w=(n[s>>2]=(f[s>>2]=i+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(v<<16>>16){case 31744:break;default:{w=t;break a}}w=h|1879048192}while(0);h=ALc(m+l*(f[s>>2]=w|u,+n[s>>2]))|0;d[r+(g<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;g=g+1|0}while((g|0)!=(e|0));o=o+1|0;if((o|0)==(c|0))break;else{q=q+(k<<1)|0;r=r+(b<<1)|0}}return}function fU(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((c|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(h[o+g>>0]|0))|0;d[q+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+b|0;q=q+(k<<1)|0}}return}function gU(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=ALc(m+l*+(b[o+h>>0]|0))|0;d[q+(h<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+c|0;q=q+(k<<1)|0}}return}function hU(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(m+l*+(j[o+(g<<1)>>1]|0))|0;d[q+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(c|0))break;else{o=o+(k<<1)|0;q=q+(b<<1)|0}}return}function iU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(d[n+(g<<1)>>1]|0))|0;d[o+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<1)|0}}return}function jU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(f[n+(g<<2)>>2]|0))|0;d[o+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<2)|0;o=o+(b<<1)|0}}return}function kU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((e|0)>0&(c|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(l+k*+n[o+(g<<2)>>2])|0;d[q+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(j<<2)|0;q=q+(b<<1)|0}}return}function lU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((c|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=zLc(l+k*+p[n+(g<<3)>>3])|0;d[o+(g<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<3)|0;o=o+(b<<1)|0}}return}function mU(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0,u=0,v=0,w=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((e|0)>0&(c|0)>0){o=0;q=a;r=g}else return;while(1){g=0;do{a=j[q+(g<<1)>>1]|0;h=a<<13;i=h&268427264;t=i+939524096|0;u=a<<16&-2147483648;v=a&31744;a:do if(v<<16>>16<31744){switch(v<<16>>16){case 0:break;default:{w=t;break a}}w=(n[s>>2]=(f[s>>2]=i+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(v<<16>>16){case 31744:break;default:{w=t;break a}}w=h|1879048192}while(0);h=ALc(m+l*(f[s>>2]=w|u,+n[s>>2]))|0;d[r+(g<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;g=g+1|0}while((g|0)!=(e|0));o=o+1|0;if((o|0)==(c|0))break;else{q=q+(k<<1)|0;r=r+(b<<1)|0}}return}function nU(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if((c|0)>0&(d|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{a=ALc(l+k*+(h[n+e>>0]|0))|0;f[o+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+b|0;o=o+(j<<2)|0}}return}function oU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(b[n+g>>0]|0))|0;f[o+(g<<2)>>2]=a;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+(j<<2)|0}}return}function pU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if((c|0)>0&(d|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{a=ALc(l+k*+(j[n+(e<<1)>>1]|0))|0;f[o+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<1)|0;o=o+(b<<2)|0}}return}function qU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;if((c|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(l+k*+(d[n+(g<<1)>>1]|0))|0;f[o+(g<<2)>>2]=a;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<2)|0}}return}function rU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((c|0)>0&(d|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{a=zLc(k+j*+(f[m+(e<<2)>>2]|0))|0;f[n+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;n=n+(b<<2)|0}}return}function sU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((c|0)>0&(d|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{a=ALc(k+j*+n[m+(e<<2)>>2])|0;f[o+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<2)|0}}return}function tU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;if((c|0)>0&(d|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{a=zLc(k+j*+p[m+(e<<3)>>3])|0;f[n+(e<<2)>>2]=a;e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<3)|0;n=n+(b<<2)|0}}return}function uU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,t=0,u=0,v=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if((c|0)>0&(d|0)>0){m=0;o=a;q=e}else return;while(1){e=0;do{a=j[o+(e<<1)>>1]|0;g=a<<13;h=g&268427264;r=h+939524096|0;t=a<<16&-2147483648;u=a&31744;a:do if(u<<16>>16<31744){switch(u<<16>>16){case 0:break;default:{v=r;break a}}v=(n[s>>2]=(f[s>>2]=h+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(u<<16>>16){case 31744:break;default:{v=r;break a}}v=g|1879048192}while(0);g=ALc(l+k*(f[s>>2]=v|t,+n[s>>2]))|0;f[q+(e<<2)>>2]=g;e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(i<<1)|0;q=q+(b<<2)|0}}return}function vU(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if((c|0)>0&(d|0)>0){m=0;o=a;q=e}else return;while(1){e=0;do{n[q+(e<<2)>>2]=l+k*+(h[o+e>>0]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+b|0;q=q+(j<<2)|0}}return}function wU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{n[q+(g<<2)>>2]=l+k*+(b[o+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+c|0;q=q+(j<<2)|0}}return}function xU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,o=0,q=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if((d|0)>0&(c|0)>0){m=0;o=a;q=e}else return;while(1){e=0;do{n[q+(e<<2)>>2]=l+k*+(j[o+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(i<<1)|0;q=q+(b<<2)|0}}return}function yU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;if((e|0)>0&(c|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{n[q+(g<<2)>>2]=l+k*+(d[o+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(j<<1)|0;q=q+(b<<2)|0}}return}function zU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{n[o+(e<<2)>>2]=k+j*+(f[m+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<2)|0}}return}function AU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{n[o+(e<<2)>>2]=k+j*+n[m+(e<<2)>>2];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<2)|0}}return}function BU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{n[o+(e<<2)>>2]=k+j*+p[m+(e<<3)>>3];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<3)|0;o=o+(b<<2)|0}}return}function CU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,t=0,u=0,v=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if((d|0)>0&(c|0)>0){m=0;o=a;q=e}else return;while(1){e=0;do{a=j[o+(e<<1)>>1]|0;g=a<<13;h=g&268427264;r=h+939524096|0;t=a<<16&-2147483648;u=a&31744;a:do if(u<<16>>16<31744){switch(u<<16>>16){case 0:break;default:{v=r;break a}}v=(n[s>>2]=(f[s>>2]=h+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(u<<16>>16){case 31744:break;default:{v=r;break a}}v=g|1879048192}while(0);n[q+(e<<2)>>2]=l+k*(f[s>>2]=v|t,+n[s>>2]);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(i<<1)|0;q=q+(b<<2)|0}}return}function DU(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>3;if((c|0)>0&(d|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{p[o+(e<<3)>>3]=l+k*+(h[n+e>>0]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+b|0;o=o+(j<<3)|0}}return}function EU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>3;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{p[o+(g<<3)>>3]=l+k*+(b[n+g>>0]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+(j<<3)|0}}return}function FU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>3;if((d|0)>0&(c|0)>0){m=0;n=a;o=e}else return;while(1){e=0;do{p[o+(e<<3)>>3]=l+k*+(j[n+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(i<<1)|0;o=o+(b<<3)|0}}return}function GU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>3;if((e|0)>0&(c|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{p[o+(g<<3)>>3]=l+k*+(d[n+(g<<1)>>1]|0);g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{n=n+(j<<1)|0;o=o+(b<<3)|0}}return}function HU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;if((d|0)>0&(c|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{p[n+(e<<3)>>3]=k+j*+(f[m+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;n=n+(b<<3)|0}}return}function IU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;if((d|0)>0&(c|0)>0){l=0;m=a;o=e}else return;while(1){e=0;do{p[o+(e<<3)>>3]=k+j*+n[m+(e<<2)>>2];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<2)|0;o=o+(b<<3)|0}}return}function JU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>3;if((d|0)>0&(c|0)>0){l=0;m=a;n=e}else return;while(1){e=0;do{p[n+(e<<3)>>3]=k+j*+p[m+(e<<3)>>3];e=e+1|0}while((e|0)!=(d|0));l=l+1|0;if((l|0)==(c|0))break;else{m=m+(i<<3)|0;n=n+(b<<3)|0}}return}function KU(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,t=0,u=0,v=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>3;if((d|0)>0&(c|0)>0){m=0;o=a;q=e}else return;while(1){e=0;do{a=j[o+(e<<1)>>1]|0;g=a<<13;h=g&268427264;r=h+939524096|0;t=a<<16&-2147483648;u=a&31744;a:do if(u<<16>>16<31744){switch(u<<16>>16){case 0:break;default:{v=r;break a}}v=(n[s>>2]=(f[s>>2]=h+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(u<<16>>16){case 31744:break;default:{v=r;break a}}v=g|1879048192}while(0);p[q+(e<<3)>>3]=l+k*(f[s>>2]=v|t,+n[s>>2]);e=e+1|0}while((e|0)!=(d|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(i<<1)|0;q=q+(b<<3)|0}}return}function LU(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((c|0)>0&(e|0)>0){o=0;q=g;r=a}else return;while(1){a=0;do{g=(n[s>>2]=m+l*+(h[r+a>>0]|0),f[s>>2]|0);i=g&-2147483648;j=i^g;do if(j>>>0<=1199570943)if(j>>>0<947912704){t=(n[s>>2]=(f[s>>2]=j,+n[s>>2])+.5,f[s>>2]|0);break}else{t=(g+134221823+(g>>>13&1)|0)>>>13;break}else t=j>>>0>2139095040?32256:31744;while(0);d[q+(a<<1)>>1]=t|i>>>16;a=a+1|0}while((a|0)!=(e|0));o=o+1|0;if((o|0)==(c|0))break;else{q=q+(k<<1)|0;r=r+b|0}}return}function MU(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if((e|0)>0&(g|0)>0){o=0;q=h;r=a}else return;while(1){a=0;do{h=(n[s>>2]=m+l*+(b[r+a>>0]|0),f[s>>2]|0);i=h&-2147483648;j=i^h;do if(j>>>0<=1199570943)if(j>>>0<947912704){t=(n[s>>2]=(f[s>>2]=j,+n[s>>2])+.5,f[s>>2]|0);break}else{t=(h+134221823+(h>>>13&1)|0)>>>13;break}else t=j>>>0>2139095040?32256:31744;while(0);d[q+(a<<1)>>1]=t|i>>>16;a=a+1|0}while((a|0)!=(g|0));o=o+1|0;if((o|0)==(e|0))break;else{q=q+(k<<1)|0;r=r+c|0}}return}function NU(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((c|0)>0&(e|0)>0){o=0;q=g;r=a}else return;while(1){a=0;do{g=(n[s>>2]=m+l*+(j[r+(a<<1)>>1]|0),f[s>>2]|0);h=g&-2147483648;i=h^g;do if(i>>>0<=1199570943)if(i>>>0<947912704){t=(n[s>>2]=(f[s>>2]=i,+n[s>>2])+.5,f[s>>2]|0);break}else{t=(g+134221823+(g>>>13&1)|0)>>>13;break}else t=i>>>0>2139095040?32256:31744;while(0);d[q+(a<<1)>>1]=t|h>>>16;a=a+1|0}while((a|0)!=(e|0));o=o+1|0;if((o|0)==(c|0))break;else{q=q+(b<<1)|0;r=r+(k<<1)|0}}return}function OU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;if((c|0)>0&(e|0)>0){m=0;o=g;q=a}else return;while(1){a=0;do{g=(n[s>>2]=l+k*+(d[q+(a<<1)>>1]|0),f[s>>2]|0);h=g&-2147483648;i=h^g;do if(i>>>0<=1199570943)if(i>>>0<947912704){r=(n[s>>2]=(f[s>>2]=i,+n[s>>2])+.5,f[s>>2]|0);break}else{r=(g+134221823+(g>>>13&1)|0)>>>13;break}else r=i>>>0>2139095040?32256:31744;while(0);d[o+(a<<1)>>1]=r|h>>>16;a=a+1|0}while((a|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(b<<1)|0;q=q+(j<<1)|0}}return}function PU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((c|0)>0&(e|0)>0){m=0;o=g;q=a}else return;while(1){a=0;do{g=(n[s>>2]=l+k*+(f[q+(a<<2)>>2]|0),f[s>>2]|0);h=g&-2147483648;i=h^g;do if(i>>>0<=1199570943)if(i>>>0<947912704){r=(n[s>>2]=(f[s>>2]=i,+n[s>>2])+.5,f[s>>2]|0);break}else{r=(g+134221823+(g>>>13&1)|0)>>>13;break}else r=i>>>0>2139095040?32256:31744;while(0);d[o+(a<<1)>>1]=r|h>>>16;a=a+1|0}while((a|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(b<<1)|0;q=q+(j<<2)|0}}return}function QU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if((c|0)>0&(e|0)>0){m=0;o=g;q=a}else return;while(1){a=0;do{g=(n[s>>2]=l+k*+n[q+(a<<2)>>2],f[s>>2]|0);h=g&-2147483648;i=h^g;do if(i>>>0<=1199570943)if(i>>>0<947912704){r=(n[s>>2]=(f[s>>2]=i,+n[s>>2])+.5,f[s>>2]|0);break}else{r=(g+134221823+(g>>>13&1)|0)>>>13;break}else r=i>>>0>2139095040?32256:31744;while(0);d[o+(a<<1)>>1]=r|h>>>16;a=a+1|0}while((a|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(b<<1)|0;q=q+(j<<2)|0}}return}function RU(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>3;b=h>>>1;if((c|0)>0&(e|0)>0){m=0;o=g;q=a}else return;while(1){a=0;do{g=(n[s>>2]=l+k*+p[q+(a<<3)>>3],f[s>>2]|0);h=g&-2147483648;i=h^g;do if(i>>>0<=1199570943)if(i>>>0<947912704){r=(n[s>>2]=(f[s>>2]=i,+n[s>>2])+.5,f[s>>2]|0);break}else{r=(g+134221823+(g>>>13&1)|0)>>>13;break}else r=i>>>0>2139095040?32256:31744;while(0);d[o+(a<<1)>>1]=r|h>>>16;a=a+1|0}while((a|0)!=(e|0));m=m+1|0;if((m|0)==(c|0))break;else{o=o+(b<<1)|0;q=q+(j<<3)|0}}return}function SU(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;if((c|0)>0&(e|0)>0){o=0;q=g;r=a}else return;while(1){a=0;do{g=j[r+(a<<1)>>1]|0;h=g<<13;i=h&268427264;t=i+939524096|0;u=g<<16&-2147483648;v=g&31744;a:do if(v<<16>>16<31744){switch(v<<16>>16){case 0:break;default:{w=t;break a}}w=(n[s>>2]=(f[s>>2]=i+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(v<<16>>16){case 31744:break;default:{w=t;break a}}w=h|1879048192}while(0);h=(n[s>>2]=m+l*(f[s>>2]=w|u,+n[s>>2]),f[s>>2]|0);t=h&-2147483648;v=t^h;do if(v>>>0<=1199570943)if(v>>>0<947912704){x=(n[s>>2]=(f[s>>2]=v,+n[s>>2])+.5,f[s>>2]|0);break}else{x=(h+134221823+(h>>>13&1)|0)>>>13;break}else x=v>>>0>2139095040?32256:31744;while(0);d[q+(a<<1)>>1]=x|t>>>16;a=a+1|0}while((a|0)!=(e|0));o=o+1|0;if((o|0)==(c|0))break;else{q=q+(b<<1)|0;r=r+(k<<1)|0}}return}function TU(a,c,d,e){a=a|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+208|0;h=g+144|0;i=g+8|0;j=g+88|0;k=g+72|0;l=g+64|0;m=g;n=g+24|0;o=g+56|0;do if((eS(a)|0)==65536){q=f[a+4>>2]|0;f[h>>2]=f[q>>2];r=h+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=h+8|0;f[t>>2]=f[q+8>>2];f[h+12>>2]=f[q+12>>2];f[h+16>>2]=f[q+16>>2];f[h+20>>2]=f[q+20>>2];f[h+24>>2]=f[q+24>>2];f[h+28>>2]=f[q+28>>2];f[h+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[h+36>>2]=v;w=h+40|0;f[w>>2]=t;t=h+48|0;x=h+44|0;f[x>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];y=r;z=w;A=h;break}else{f[r>>2]=0;U$(h,q);y=r;z=w;A=h;break}}else{bS(h,a,-1);y=h+4|0;z=h+40|0;A=h}while(0);a=((f[A>>2]|0)>>>3&511)+1|0;p[i>>3]=d;p[i+8>>3]=e;xS(c,f[y>>2]|0,f[z>>2]|0,(a<<3)+-8|0,-1,0,0);do if((eS(c)|0)==65536){w=f[c+4>>2]|0;f[j>>2]=f[w>>2];r=j+4|0;q=w+4|0;f[r>>2]=f[q>>2];s=j+8|0;f[s>>2]=f[w+8>>2];f[j+12>>2]=f[w+12>>2];f[j+16>>2]=f[w+16>>2];f[j+20>>2]=f[w+20>>2];f[j+24>>2]=f[w+24>>2];f[j+28>>2]=f[w+28>>2];f[j+32>>2]=f[w+32>>2];t=f[w+36>>2]|0;f[j+36>>2]=t;f[j+40>>2]=s;s=j+48|0;x=j+44|0;f[x>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[q>>2]|0)<3){q=f[w+44>>2]|0;s=f[x>>2]|0;f[s>>2]=f[q>>2];f[s+4>>2]=f[q+4>>2];break}else{f[r>>2]=0;U$(j,w);break}}else bS(j,c,-1);while(0);c=f[A>>2]&7;A=f[37188+(c<<2)>>2]|0;if((c|0)==7){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=9;c=k;w=264557;r=c+9|0;do{b[c>>0]=b[w>>0]|0;c=c+1|0;w=w+1|0}while((c|0)<(r|0));b[k+9>>0]=0;vM(-215,k,234380,234396,425)}if((f[y>>2]|0)<3){m0(k,h,j,a);w=f[h+16>>2]|0;c=f[h+48>>2]|0;r=f[j+16>>2]|0;q=f[j+48>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];wi[A&255](w,c,0,0,r,q,l,i)}else{f[k>>2]=h;f[k+4>>2]=j;f[k+8>>2]=0;l=m;f[l>>2]=0;f[l+4>>2]=0;BL(n,k,m,-1);k=Y(f[n+20>>2]|0,a)|0;a=n+16|0;l=m+4|0;q=o+4|0;r=0;while(1){if(r>>>0>=(f[a>>2]|0)>>>0)break;c=f[m>>2]|0;w=f[l>>2]|0;f[o>>2]=k;f[q>>2]=1;wi[A&255](c,0,0,0,w,0,o,i);CL(n)|0;r=r+1|0}}r=j+36|0;n=f[r>>2]|0;if(n|0?(i=n+12|0,n=f[i>>2]|0,f[i>>2]=n+-1,(n|0)==1):0)V$(j);f[r>>2]=0;r=j+16|0;n=j+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[n>>2]|0)>0){r=f[j+40>>2]|0;i=0;do{f[r+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[n>>2]|0))}n=f[j+44>>2]|0;if((n|0)!=(j+48|0))wL(n);n=h+36|0;j=f[n>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)V$(h);f[n>>2]=0;n=h+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[y>>2]|0)>0){n=f[z>>2]|0;z=0;do{f[n+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)==(h+48|0)){u=g;return}wL(y);u=g;return}function UU(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(+L(+(m+l*+(h[o+g>>0]|0))))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+c|0;q=q+i|0}}return}function VU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(+L(+(l+k*+(b[n+g>>0]|0))))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+c|0;o=o+h|0}}return}function WU(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((d|0)>0&(e|0)>0){n=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(+L(+(m+l*+(j[o+(g<<1)>>1]|0))))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));n=n+1|0;if((n|0)==(d|0))break;else{o=o+(k<<1)|0;q=q+h|0}}return}function XU(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if((e|0)>0&(g|0)>0){n=0;o=a;q=h}else return;while(1){h=0;do{a=ALc(+L(+(m+l*+(d[o+(h<<1)>>1]|0))))|0;b[q+h>>0]=a>>>0<256?a:(a|0)>0?255:0;h=h+1|0}while((h|0)!=(g|0));n=n+1|0;if((n|0)==(e|0))break;else{o=o+(k<<1)|0;q=q+i|0}}return}function YU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=ALc(+L(+(l+k*+(f[n+(g<<2)>>2]|0))))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(j<<2)|0;o=o+h|0}}return}function ZU(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if((d|0)>0&(e|0)>0){m=0;o=a;q=g}else return;while(1){g=0;do{a=ALc(+L(+(l+k*+n[o+(g<<2)>>2])))|0;b[q+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{o=o+(j<<2)|0;q=q+h|0}}return}function _U(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if((d|0)<=0)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)>0){m=0;n=a;o=g}else return;while(1){g=0;do{a=zLc(+L(+(l+k*+p[n+(g<<3)>>3])))|0;b[o+g>>0]=a>>>0<256?a:(a|0)>0?255:0;g=g+1|0}while((g|0)!=(e|0));m=m+1|0;if((m|0)==(d|0))break;else{n=n+(i<<3)|0;o=o+h|0}}return}function $U(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0;j=u;u=u+128|0;k=j+56|0;l=j;m=j+112|0;n=dS(a,-1)|0;if((h|0)<0)if(YS(c)|0)o=qS(c,-1)|0;else o=n&7;else o=h;switch(g|0){case 32:{p[k>>3]=0.0;p[l>>3]=0.0;q=d>e?e:d;KP(a,k,l,0,0,i);r=+p[k>>3];s=+p[l>>3]-r;t=((d<e?e:d)-q)*(s>2.220446049250313e-16?1.0/s:0.0);if((o|0)==5){s=t;v=s;w=q-r*s}else{v=t;w=q-r*t}x=v;y=w;break}case 1:case 2:case 4:{w=+XN(a,g,i);x=w>2.220446049250313e-16?d/w:0.0;y=0.0;break}default:{g=$Xc(32)|0;f[k>>2]=g;f[k+8>>2]=-2147483616;f[k+4>>2]=29;z=g;h=234471;A=z+29|0;do{b[z>>0]=b[h>>0]|0;z=z+1|0;h=h+1|0}while((z|0)<(A|0));b[g+29>>0]=0;vM(-5,k,234501,234396,571)}}do if((eS(a)|0)==65536){g=f[a+4>>2]|0;f[k>>2]=f[g>>2];h=k+4|0;n=g+4|0;f[h>>2]=f[n>>2];B=k+8|0;f[B>>2]=f[g+8>>2];f[k+12>>2]=f[g+12>>2];f[k+16>>2]=f[g+16>>2];f[k+20>>2]=f[g+20>>2];f[k+24>>2]=f[g+24>>2];f[k+28>>2]=f[g+28>>2];f[k+32>>2]=f[g+32>>2];C=f[g+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=B;B=k+48|0;D=k+44|0;f[D>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[n>>2]|0)<3){n=f[g+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[n>>2];f[B+4>>2]=f[n+4>>2];break}else{f[h>>2]=0;U$(k,g);break}}else bS(k,a,-1);while(0);if(!(sS(i)|0)){f[l>>2]=1124007936;a=l+4|0;g=l+8|0;h=l+40|0;z=a;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[h>>2]=g;g=l+48|0;z=l+44|0;f[z>>2]=g;f[g>>2]=0;f[l+52>>2]=0;A=m+8|0;f[A>>2]=0;f[A+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;dY(k,m,o,x,y);kR(l,c,i);i=l+36|0;m=f[i>>2]|0;if(m|0?(A=m+12|0,m=f[A>>2]|0,f[A>>2]=m+-1,(m|0)==1):0)V$(l);f[i>>2]=0;i=l+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[h>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[z>>2]|0;if((a|0)!=(g|0))wL(a)}else dY(k,c,o,x,y);o=k+36|0;c=f[o>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)V$(k);f[o>>2]=0;o=k+16|0;c=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[c>>2]|0)>0){o=f[k+40>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[k+44>>2]|0;if((c|0)==(k+48|0)){u=j;return}wL(c);u=j;return}function aV(a){a=a|0;return f[37220+(a<<2)>>2]|0}function bV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;if(!c){i=(g|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=a;m=j;n=0}else{o=g<<1;p=g*3|0;q=g<<2;r=e&-4;s=a;t=j;j=0;while(1){t=(h[s>>0]|0)+t+(h[s+g>>0]|0)+(h[s+o>>0]|0)+(h[s+p>>0]|0)|0;j=j+4|0;if((j|0)>(k|0))break;else s=s+q|0}l=a+(Y(r,g)|0)|0;m=t;n=r}if((n|0)<(e|0)){r=m;t=n;q=l;while(1){l=(h[q>>0]|0)+r|0;t=t+1|0;if((t|0)==(e|0)){u=l;v=e;break}else{r=l;q=q+g|0}}}else{u=m;v=n}f[d>>2]=u;w=v;break}case 2:{v=f[d>>2]|0;u=d+4|0;n=f[u>>2]|0;if((e|0)>0){m=n;q=v;r=0;t=a;while(1){l=(h[t>>0]|0)+q|0;s=(h[t+1>>0]|0)+m|0;r=r+1|0;if((r|0)==(e|0)){x=s;y=l;z=e;break}else{m=s;q=l;t=t+g|0}}}else{x=n;y=v;z=0}f[d>>2]=y;f[u>>2]=x;w=z;break}case 3:{z=f[d>>2]|0;x=d+4|0;u=f[x>>2]|0;y=d+8|0;v=f[y>>2]|0;if((e|0)>0){n=v;t=u;q=z;m=0;r=a;while(1){l=(h[r>>0]|0)+q|0;s=(h[r+1>>0]|0)+t|0;k=(h[r+2>>0]|0)+n|0;m=m+1|0;if((m|0)==(e|0)){A=k;B=s;C=l;D=e;break}else{n=k;t=s;q=l;r=r+g|0}}}else{A=v;B=u;C=z;D=0}f[d>>2]=C;f[x>>2]=B;f[y>>2]=A;w=D;break}default:w=0}if((i|0)<(g|0)){E=i;F=w}else{G=e;return G|0}while(1){w=d+(E<<2)|0;i=f[w>>2]|0;D=d+(E+1<<2)|0;A=f[D>>2]|0;y=d+(E+2<<2)|0;B=f[y>>2]|0;x=d+(E+3<<2)|0;C=f[x>>2]|0;if((F|0)<(e|0)){z=C;u=B;v=A;r=i;q=a+(Y(F,g)|0)+E|0;t=F;while(1){n=(h[q>>0]|0)+r|0;m=(h[q+1>>0]|0)+v|0;l=(h[q+2>>0]|0)+u|0;s=(h[q+3>>0]|0)+z|0;t=t+1|0;if((t|0)==(e|0)){H=s;I=l;J=m;K=n;L=e;break}else{z=s;u=l;v=m;r=n;q=q+g|0}}}else{H=C;I=B;J=A;K=i;L=F}f[w>>2]=K;f[D>>2]=J;f[y>>2]=I;f[x>>2]=H;E=E+4|0;if((E|0)>=(g|0)){G=e;break}else F=L}return G|0}switch(g|0){case 1:{L=f[d>>2]|0;if((e|0)>0){F=L;E=0;H=0;while(1){if(!(b[c+H>>0]|0)){M=F;N=E}else{M=(h[a+H>>0]|0)+F|0;N=E+1|0}H=H+1|0;if((H|0)==(e|0)){O=M;P=N;break}else{F=M;E=N}}}else{O=L;P=0}f[d>>2]=O;G=P;return G|0}case 3:{P=f[d>>2]|0;O=d+4|0;L=f[O>>2]|0;N=d+8|0;E=f[N>>2]|0;if((e|0)>0){M=E;F=L;H=P;I=0;J=0;K=a;while(1){if(!(b[c+I>>0]|0)){Q=M;R=F;S=H;T=J}else{Q=(h[K+2>>0]|0)+M|0;R=(h[K+1>>0]|0)+F|0;S=(h[K>>0]|0)+H|0;T=J+1|0}I=I+1|0;if((I|0)==(e|0)){U=Q;V=R;W=S;X=T;break}else{M=Q;F=R;H=S;J=T;K=K+3|0}}}else{U=E;V=L;W=P;X=0}f[d>>2]=W;f[O>>2]=V;f[N>>2]=U;G=X;return G|0}default:{if((e|0)<=0){G=0;return G|0}X=g+-4|0;if((g|0)<4){if((g|0)>0){Z=0;_=0;$=a}else{U=0;N=0;while(1){V=N+((b[c+U>>0]|0)!=0&1)|0;U=U+1|0;if((U|0)==(e|0)){G=V;break}else N=V}return G|0}while(1){if(!(b[c+Z>>0]|0))aa=_;else{N=0;do{U=d+(N<<2)|0;f[U>>2]=(f[U>>2]|0)+(h[$+N>>0]|0);N=N+1|0}while((N|0)!=(g|0));aa=_+1|0}Z=Z+1|0;if((Z|0)==(e|0)){G=aa;break}else{_=aa;$=$+g|0}}return G|0}$=g&-4;if(($|0)<(g|0)){ba=0;ca=0;da=a}else{aa=0;_=0;Z=a;while(1){if(!(b[c+aa>>0]|0))ea=_;else{a=0;do{N=d+(a<<2)|0;x=a|1;y=d+(x<<2)|0;D=(h[Z+x>>0]|0)+(f[y>>2]|0)|0;f[N>>2]=(h[Z+a>>0]|0)+(f[N>>2]|0);f[y>>2]=D;D=a|2;y=d+(D<<2)|0;N=a|3;x=d+(N<<2)|0;w=(h[Z+N>>0]|0)+(f[x>>2]|0)|0;f[y>>2]=(h[Z+D>>0]|0)+(f[y>>2]|0);f[x>>2]=w;a=a+4|0}while((a|0)<=(X|0));ea=_+1|0}aa=aa+1|0;if((aa|0)==(e|0)){G=ea;break}else{_=ea;Z=Z+g|0}}return G|0}while(1){if(!(b[c+ba>>0]|0))fa=ca;else{Z=0;do{ea=d+(Z<<2)|0;_=Z|1;aa=d+(_<<2)|0;a=(h[da+_>>0]|0)+(f[aa>>2]|0)|0;f[ea>>2]=(h[da+Z>>0]|0)+(f[ea>>2]|0);f[aa>>2]=a;a=Z|2;aa=d+(a<<2)|0;ea=Z|3;_=d+(ea<<2)|0;w=(h[da+ea>>0]|0)+(f[_>>2]|0)|0;f[aa>>2]=(h[da+a>>0]|0)+(f[aa>>2]|0);f[_>>2]=w;Z=Z+4|0}while((Z|0)<=(X|0));ga=$;do{Z=d+(ga<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(h[da+ga>>0]|0);ga=ga+1|0}while((ga|0)!=(g|0));fa=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){G=fa;break}else{ca=fa;da=da+g|0}}return G|0}}return 0}function cV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;j=e+-4|0;if((e|0)<4){k=a;l=i;m=0}else{n=g<<1;o=g*3|0;p=g<<2;q=e&-4;r=a;s=i;i=0;while(1){s=(b[r>>0]|0)+s+(b[r+g>>0]|0)+(b[r+n>>0]|0)+(b[r+o>>0]|0)|0;i=i+4|0;if((i|0)>(j|0))break;else r=r+p|0}k=a+(Y(q,g)|0)|0;l=s;m=q}if((m|0)<(e|0)){q=l;s=m;p=k;while(1){k=(b[p>>0]|0)+q|0;s=s+1|0;if((s|0)==(e|0)){t=k;u=e;break}else{q=k;p=p+g|0}}}else{t=l;u=m}f[d>>2]=t;v=u;break}case 2:{u=f[d>>2]|0;t=d+4|0;m=f[t>>2]|0;if((e|0)>0){l=m;p=u;q=0;s=a;while(1){k=(b[s>>0]|0)+p|0;r=(b[s+1>>0]|0)+l|0;q=q+1|0;if((q|0)==(e|0)){w=r;x=k;y=e;break}else{l=r;p=k;s=s+g|0}}}else{w=m;x=u;y=0}f[d>>2]=x;f[t>>2]=w;v=y;break}case 3:{y=f[d>>2]|0;w=d+4|0;t=f[w>>2]|0;x=d+8|0;u=f[x>>2]|0;if((e|0)>0){m=u;s=t;p=y;l=0;q=a;while(1){k=(b[q>>0]|0)+p|0;r=(b[q+1>>0]|0)+s|0;j=(b[q+2>>0]|0)+m|0;l=l+1|0;if((l|0)==(e|0)){z=j;A=r;B=k;C=e;break}else{m=j;s=r;p=k;q=q+g|0}}}else{z=u;A=t;B=y;C=0}f[d>>2]=B;f[w>>2]=A;f[x>>2]=z;v=C;break}default:v=0}if((h|0)<(g|0)){D=h;E=v}else{F=e;return F|0}while(1){v=d+(D<<2)|0;h=f[v>>2]|0;C=d+(D+1<<2)|0;z=f[C>>2]|0;x=d+(D+2<<2)|0;A=f[x>>2]|0;w=d+(D+3<<2)|0;B=f[w>>2]|0;if((E|0)<(e|0)){y=B;t=A;u=z;q=h;p=a+(Y(E,g)|0)+D|0;s=E;while(1){m=(b[p>>0]|0)+q|0;l=(b[p+1>>0]|0)+u|0;k=(b[p+2>>0]|0)+t|0;r=(b[p+3>>0]|0)+y|0;s=s+1|0;if((s|0)==(e|0)){G=r;H=k;I=l;J=m;K=e;break}else{y=r;t=k;u=l;q=m;p=p+g|0}}}else{G=B;H=A;I=z;J=h;K=E}f[v>>2]=J;f[C>>2]=I;f[x>>2]=H;f[w>>2]=G;D=D+4|0;if((D|0)>=(g|0)){F=e;break}else E=K}return F|0}switch(g|0){case 1:{K=f[d>>2]|0;if((e|0)>0){E=K;D=0;G=0;while(1){if(!(b[c+G>>0]|0)){L=E;M=D}else{L=(b[a+G>>0]|0)+E|0;M=D+1|0}G=G+1|0;if((G|0)==(e|0)){N=L;O=M;break}else{E=L;D=M}}}else{N=K;O=0}f[d>>2]=N;F=O;return F|0}case 3:{O=f[d>>2]|0;N=d+4|0;K=f[N>>2]|0;M=d+8|0;D=f[M>>2]|0;if((e|0)>0){L=D;E=K;G=O;H=0;I=0;J=a;while(1){if(!(b[c+H>>0]|0)){P=L;Q=E;R=G;S=I}else{P=(b[J+2>>0]|0)+L|0;Q=(b[J+1>>0]|0)+E|0;R=(b[J>>0]|0)+G|0;S=I+1|0}H=H+1|0;if((H|0)==(e|0)){T=P;U=Q;V=R;W=S;break}else{L=P;E=Q;G=R;I=S;J=J+3|0}}}else{T=D;U=K;V=O;W=0}f[d>>2]=V;f[N>>2]=U;f[M>>2]=T;F=W;return F|0}default:{if((e|0)<=0){F=0;return F|0}W=g+-4|0;if((g|0)<4){if((g|0)>0){X=0;Z=0;_=a}else{T=0;M=0;while(1){U=M+((b[c+T>>0]|0)!=0&1)|0;T=T+1|0;if((T|0)==(e|0)){F=U;break}else M=U}return F|0}while(1){if(!(b[c+X>>0]|0))$=Z;else{M=0;do{T=d+(M<<2)|0;f[T>>2]=(f[T>>2]|0)+(b[_+M>>0]|0);M=M+1|0}while((M|0)!=(g|0));$=Z+1|0}X=X+1|0;if((X|0)==(e|0)){F=$;break}else{Z=$;_=_+g|0}}return F|0}_=g&-4;if((_|0)<(g|0)){aa=0;ba=0;ca=a}else{$=0;Z=0;X=a;while(1){if(!(b[c+$>>0]|0))da=Z;else{a=0;do{M=d+(a<<2)|0;w=a|1;x=d+(w<<2)|0;C=(b[X+w>>0]|0)+(f[x>>2]|0)|0;f[M>>2]=(b[X+a>>0]|0)+(f[M>>2]|0);f[x>>2]=C;C=a|2;x=d+(C<<2)|0;M=a|3;w=d+(M<<2)|0;v=(b[X+M>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(b[X+C>>0]|0)+(f[x>>2]|0);f[w>>2]=v;a=a+4|0}while((a|0)<=(W|0));da=Z+1|0}$=$+1|0;if(($|0)==(e|0)){F=da;break}else{Z=da;X=X+g|0}}return F|0}while(1){if(!(b[c+aa>>0]|0))ea=ba;else{X=0;do{da=d+(X<<2)|0;Z=X|1;$=d+(Z<<2)|0;a=(b[ca+Z>>0]|0)+(f[$>>2]|0)|0;f[da>>2]=(b[ca+X>>0]|0)+(f[da>>2]|0);f[$>>2]=a;a=X|2;$=d+(a<<2)|0;da=X|3;Z=d+(da<<2)|0;v=(b[ca+da>>0]|0)+(f[Z>>2]|0)|0;f[$>>2]=(b[ca+a>>0]|0)+(f[$>>2]|0);f[Z>>2]=v;X=X+4|0}while((X|0)<=(W|0));fa=_;do{X=d+(fa<<2)|0;f[X>>2]=(f[X>>2]|0)+(b[ca+fa>>0]|0);fa=fa+1|0}while((fa|0)!=(g|0));ea=ba+1|0}aa=aa+1|0;if((aa|0)==(e|0)){F=ea;break}else{ba=ea;ca=ca+g|0}}return F|0}}return 0}function dV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=a;m=i;n=0}else{o=g<<1;p=g*3|0;q=g<<2;r=k>>>2;s=Y((r<<3)+8|0,g)|0;t=a;u=i;i=0;while(1){u=(j[t>>1]|0)+u+(j[t+(g<<1)>>1]|0)+(j[t+(o<<1)>>1]|0)+(j[t+(p<<1)>>1]|0)|0;i=i+4|0;if((i|0)>(k|0))break;else t=t+(q<<1)|0}l=a+s|0;m=u;n=(r<<2)+4|0}if((n|0)<(e|0)){r=m;u=n;s=l;while(1){l=(j[s>>1]|0)+r|0;u=u+1|0;if((u|0)==(e|0)){v=l;w=e;break}else{r=l;s=s+(g<<1)|0}}}else{v=m;w=n}f[d>>2]=v;x=w;break}case 2:{w=f[d>>2]|0;v=d+4|0;n=f[v>>2]|0;if((e|0)>0){m=n;s=w;r=0;u=a;while(1){l=(j[u>>1]|0)+s|0;q=(j[u+2>>1]|0)+m|0;r=r+1|0;if((r|0)==(e|0)){y=q;z=l;A=e;break}else{m=q;s=l;u=u+(g<<1)|0}}}else{y=n;z=w;A=0}f[d>>2]=z;f[v>>2]=y;x=A;break}case 3:{A=f[d>>2]|0;y=d+4|0;v=f[y>>2]|0;z=d+8|0;w=f[z>>2]|0;if((e|0)>0){n=w;u=v;s=A;m=0;r=a;while(1){l=(j[r>>1]|0)+s|0;q=(j[r+2>>1]|0)+u|0;t=(j[r+4>>1]|0)+n|0;m=m+1|0;if((m|0)==(e|0)){B=t;C=q;D=l;E=e;break}else{n=t;u=q;s=l;r=r+(g<<1)|0}}}else{B=w;C=v;D=A;E=0}f[d>>2]=D;f[y>>2]=C;f[z>>2]=B;x=E;break}default:x=0}if((h|0)<(g|0)){F=h;G=x}else{H=e;return H|0}while(1){x=d+(F<<2)|0;h=f[x>>2]|0;E=d+(F+1<<2)|0;B=f[E>>2]|0;z=d+(F+2<<2)|0;C=f[z>>2]|0;y=d+(F+3<<2)|0;D=f[y>>2]|0;if((G|0)<(e|0)){A=D;v=C;w=B;r=h;s=a+((Y(G,g)|0)<<1)+(F<<1)|0;u=G;while(1){n=(j[s>>1]|0)+r|0;m=(j[s+2>>1]|0)+w|0;l=(j[s+4>>1]|0)+v|0;q=(j[s+6>>1]|0)+A|0;u=u+1|0;if((u|0)==(e|0)){I=q;J=l;K=m;L=n;M=e;break}else{A=q;v=l;w=m;r=n;s=s+(g<<1)|0}}}else{I=D;J=C;K=B;L=h;M=G}f[x>>2]=L;f[E>>2]=K;f[z>>2]=J;f[y>>2]=I;F=F+4|0;if((F|0)>=(g|0)){H=e;break}else G=M}return H|0}switch(g|0){case 1:{M=f[d>>2]|0;if((e|0)>0){G=M;F=0;I=0;while(1){if(!(b[c+I>>0]|0)){N=G;O=F}else{N=(j[a+(I<<1)>>1]|0)+G|0;O=F+1|0}I=I+1|0;if((I|0)==(e|0)){P=N;Q=O;break}else{G=N;F=O}}}else{P=M;Q=0}f[d>>2]=P;H=Q;return H|0}case 3:{Q=f[d>>2]|0;P=d+4|0;M=f[P>>2]|0;O=d+8|0;F=f[O>>2]|0;if((e|0)>0){N=F;G=M;I=Q;J=0;K=0;L=a;while(1){if(!(b[c+J>>0]|0)){R=N;S=G;T=I;U=K}else{R=(j[L+4>>1]|0)+N|0;S=(j[L+2>>1]|0)+G|0;T=(j[L>>1]|0)+I|0;U=K+1|0}J=J+1|0;if((J|0)==(e|0)){V=R;W=S;X=T;Z=U;break}else{N=R;G=S;I=T;K=U;L=L+6|0}}}else{V=F;W=M;X=Q;Z=0}f[d>>2]=X;f[P>>2]=W;f[O>>2]=V;H=Z;return H|0}default:{if((e|0)<=0){H=0;return H|0}Z=g+-4|0;if((g|0)<4){if((g|0)>0){_=0;$=0;aa=a}else{V=0;O=0;while(1){W=O+((b[c+V>>0]|0)!=0&1)|0;V=V+1|0;if((V|0)==(e|0)){H=W;break}else O=W}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{V=d+(O<<2)|0;f[V>>2]=(f[V>>2]|0)+(j[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(g|0));ba=$+1|0}_=_+1|0;if((_|0)==(e|0)){H=ba;break}else{$=ba;aa=aa+(g<<1)|0}}return H|0}aa=g&-4;if((aa|0)<(g|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=d+(a<<2)|0;y=a|1;z=d+(y<<2)|0;E=(j[_+(y<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(j[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=E;E=a|2;z=d+(E<<2)|0;O=a|3;y=d+(O<<2)|0;x=(j[_+(O<<1)>>1]|0)+(f[y>>2]|0)|0;f[z>>2]=(j[_+(E<<1)>>1]|0)+(f[z>>2]|0);f[y>>2]=x;a=a+4|0}while((a|0)<=(Z|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(e|0)){H=fa;break}else{$=fa;_=_+(g<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=d+(_<<2)|0;$=_|1;ba=d+($<<2)|0;a=(j[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(j[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=d+(a<<2)|0;fa=_|3;$=d+(fa<<2)|0;x=(j[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(j[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=x;_=_+4|0}while((_|0)<=(Z|0));ha=aa;do{_=d+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(j[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(g|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){H=ga;break}else{da=ga;ea=ea+(g<<1)|0}}return H|0}}return 0}function eV(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[e>>2]|0;k=g+-4|0;if((g|0)<4){l=a;m=j;n=0}else{o=h<<1;p=h*3|0;q=h<<2;r=k>>>2;s=Y((r<<3)+8|0,h)|0;t=a;u=j;j=0;while(1){u=(d[t>>1]|0)+u+(d[t+(h<<1)>>1]|0)+(d[t+(o<<1)>>1]|0)+(d[t+(p<<1)>>1]|0)|0;j=j+4|0;if((j|0)>(k|0))break;else t=t+(q<<1)|0}l=a+s|0;m=u;n=(r<<2)+4|0}if((n|0)<(g|0)){r=m;u=n;s=l;while(1){l=(d[s>>1]|0)+r|0;u=u+1|0;if((u|0)==(g|0)){v=l;w=g;break}else{r=l;s=s+(h<<1)|0}}}else{v=m;w=n}f[e>>2]=v;x=w;break}case 2:{w=f[e>>2]|0;v=e+4|0;n=f[v>>2]|0;if((g|0)>0){m=n;s=w;r=0;u=a;while(1){l=(d[u>>1]|0)+s|0;q=(d[u+2>>1]|0)+m|0;r=r+1|0;if((r|0)==(g|0)){y=q;z=l;A=g;break}else{m=q;s=l;u=u+(h<<1)|0}}}else{y=n;z=w;A=0}f[e>>2]=z;f[v>>2]=y;x=A;break}case 3:{A=f[e>>2]|0;y=e+4|0;v=f[y>>2]|0;z=e+8|0;w=f[z>>2]|0;if((g|0)>0){n=w;u=v;s=A;m=0;r=a;while(1){l=(d[r>>1]|0)+s|0;q=(d[r+2>>1]|0)+u|0;t=(d[r+4>>1]|0)+n|0;m=m+1|0;if((m|0)==(g|0)){B=t;C=q;D=l;E=g;break}else{n=t;u=q;s=l;r=r+(h<<1)|0}}}else{B=w;C=v;D=A;E=0}f[e>>2]=D;f[y>>2]=C;f[z>>2]=B;x=E;break}default:x=0}if((i|0)<(h|0)){F=i;G=x}else{H=g;return H|0}while(1){x=e+(F<<2)|0;i=f[x>>2]|0;E=e+(F+1<<2)|0;B=f[E>>2]|0;z=e+(F+2<<2)|0;C=f[z>>2]|0;y=e+(F+3<<2)|0;D=f[y>>2]|0;if((G|0)<(g|0)){A=D;v=C;w=B;r=i;s=a+((Y(G,h)|0)<<1)+(F<<1)|0;u=G;while(1){n=(d[s>>1]|0)+r|0;m=(d[s+2>>1]|0)+w|0;l=(d[s+4>>1]|0)+v|0;q=(d[s+6>>1]|0)+A|0;u=u+1|0;if((u|0)==(g|0)){I=q;J=l;K=m;L=n;M=g;break}else{A=q;v=l;w=m;r=n;s=s+(h<<1)|0}}}else{I=D;J=C;K=B;L=i;M=G}f[x>>2]=L;f[E>>2]=K;f[z>>2]=J;f[y>>2]=I;F=F+4|0;if((F|0)>=(h|0)){H=g;break}else G=M}return H|0}switch(h|0){case 1:{M=f[e>>2]|0;if((g|0)>0){G=M;F=0;I=0;while(1){if(!(b[c+I>>0]|0)){N=G;O=F}else{N=(d[a+(I<<1)>>1]|0)+G|0;O=F+1|0}I=I+1|0;if((I|0)==(g|0)){P=N;Q=O;break}else{G=N;F=O}}}else{P=M;Q=0}f[e>>2]=P;H=Q;return H|0}case 3:{Q=f[e>>2]|0;P=e+4|0;M=f[P>>2]|0;O=e+8|0;F=f[O>>2]|0;if((g|0)>0){N=F;G=M;I=Q;J=0;K=0;L=a;while(1){if(!(b[c+J>>0]|0)){R=N;S=G;T=I;U=K}else{R=(d[L+4>>1]|0)+N|0;S=(d[L+2>>1]|0)+G|0;T=(d[L>>1]|0)+I|0;U=K+1|0}J=J+1|0;if((J|0)==(g|0)){V=R;W=S;X=T;Z=U;break}else{N=R;G=S;I=T;K=U;L=L+6|0}}}else{V=F;W=M;X=Q;Z=0}f[e>>2]=X;f[P>>2]=W;f[O>>2]=V;H=Z;return H|0}default:{if((g|0)<=0){H=0;return H|0}Z=h+-4|0;if((h|0)<4){if((h|0)>0){_=0;$=0;aa=a}else{V=0;O=0;while(1){W=O+((b[c+V>>0]|0)!=0&1)|0;V=V+1|0;if((V|0)==(g|0)){H=W;break}else O=W}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{V=e+(O<<2)|0;f[V>>2]=(f[V>>2]|0)+(d[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(h|0));ba=$+1|0}_=_+1|0;if((_|0)==(g|0)){H=ba;break}else{$=ba;aa=aa+(h<<1)|0}}return H|0}aa=h&-4;if((aa|0)<(h|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=e+(a<<2)|0;y=a|1;z=e+(y<<2)|0;E=(d[_+(y<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(d[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=E;E=a|2;z=e+(E<<2)|0;O=a|3;y=e+(O<<2)|0;x=(d[_+(O<<1)>>1]|0)+(f[y>>2]|0)|0;f[z>>2]=(d[_+(E<<1)>>1]|0)+(f[z>>2]|0);f[y>>2]=x;a=a+4|0}while((a|0)<=(Z|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(g|0)){H=fa;break}else{$=fa;_=_+(h<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=e+(_<<2)|0;$=_|1;ba=e+($<<2)|0;a=(d[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(d[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=e+(a<<2)|0;fa=_|3;$=e+(fa<<2)|0;x=(d[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(d[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=x;_=_+4|0}while((_|0)<=(Z|0));ha=aa;do{_=e+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(d[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(h|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(g|0)){H=ga;break}else{da=ga;ea=ea+(h<<1)|0}}return H|0}}return 0}function fV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=e+-4|0;if((e|0)<4){k=a;l=i;m=0}else{n=g<<1;o=g*3|0;q=g<<2;r=j>>>2;s=Y((r<<4)+16|0,g)|0;t=a;u=i;v=0;while(1){u=u+ +((f[t+(g<<2)>>2]|0)+(f[t>>2]|0)+(f[t+(n<<2)>>2]|0)+(f[t+(o<<2)>>2]|0)|0);v=v+4|0;if((v|0)>(j|0))break;else t=t+(q<<2)|0}k=a+s|0;l=u;m=(r<<2)+4|0}if((m|0)<(e|0)){u=l;r=m;s=k;while(1){i=u+ +(f[s>>2]|0);r=r+1|0;if((r|0)==(e|0)){w=i;x=e;break}else{u=i;s=s+(g<<2)|0}}}else{w=l;x=m}p[d>>3]=w;y=x;break}case 2:{w=+p[d>>3];x=d+8|0;l=+p[x>>3];if((e|0)>0){u=l;i=w;m=0;s=a;while(1){z=i+ +(f[s>>2]|0);A=u+ +(f[s+4>>2]|0);m=m+1|0;if((m|0)==(e|0)){B=A;C=z;D=e;break}else{u=A;i=z;s=s+(g<<2)|0}}}else{B=l;C=w;D=0}p[d>>3]=C;p[x>>3]=B;y=D;break}case 3:{B=+p[d>>3];D=d+8|0;C=+p[D>>3];x=d+16|0;w=+p[x>>3];if((e|0)>0){l=w;i=C;u=B;s=0;m=a;while(1){z=u+ +(f[m>>2]|0);A=i+ +(f[m+4>>2]|0);E=l+ +(f[m+8>>2]|0);s=s+1|0;if((s|0)==(e|0)){F=E;G=A;H=z;I=e;break}else{l=E;i=A;u=z;m=m+(g<<2)|0}}}else{F=w;G=C;H=B;I=0}p[d>>3]=H;p[D>>3]=G;p[x>>3]=F;y=I;break}default:y=0}if((h|0)<(g|0)){J=h;K=y}else{L=e;return L|0}while(1){y=d+(J<<3)|0;F=+p[y>>3];h=d+(J+1<<3)|0;G=+p[h>>3];I=d+(J+2<<3)|0;H=+p[I>>3];x=d+(J+3<<3)|0;B=+p[x>>3];if((K|0)<(e|0)){C=B;w=H;u=G;i=F;D=a+((Y(K,g)|0)<<2)+(J<<2)|0;m=K;while(1){l=i+ +(f[D>>2]|0);z=u+ +(f[D+4>>2]|0);A=w+ +(f[D+8>>2]|0);E=C+ +(f[D+12>>2]|0);m=m+1|0;if((m|0)==(e|0)){M=E;N=A;O=z;P=l;Q=e;break}else{C=E;w=A;u=z;i=l;D=D+(g<<2)|0}}}else{M=B;N=H;O=G;P=F;Q=K}p[y>>3]=P;p[h>>3]=O;p[I>>3]=N;p[x>>3]=M;J=J+4|0;if((J|0)>=(g|0)){L=e;break}else K=Q}return L|0}switch(g|0){case 1:{M=+p[d>>3];if((e|0)>0){N=M;Q=0;K=0;while(1){if(!(b[c+K>>0]|0)){R=N;S=Q}else{R=N+ +(f[a+(K<<2)>>2]|0);S=Q+1|0}K=K+1|0;if((K|0)==(e|0)){T=R;U=S;break}else{N=R;Q=S}}}else{T=M;U=0}p[d>>3]=T;L=U;return L|0}case 3:{T=+p[d>>3];U=d+8|0;M=+p[U>>3];S=d+16|0;R=+p[S>>3];if((e|0)>0){N=R;O=M;P=T;Q=0;K=0;J=a;while(1){if(!(b[c+Q>>0]|0)){V=N;W=O;X=P;Z=K}else{V=N+ +(f[J+8>>2]|0);W=O+ +(f[J+4>>2]|0);X=P+ +(f[J>>2]|0);Z=K+1|0}Q=Q+1|0;if((Q|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{N=V;O=W;P=X;K=Z;J=J+12|0}}}else{_=R;$=M;aa=T;ba=0}p[d>>3]=aa;p[U>>3]=$;p[S>>3]=_;L=ba;return L|0}default:{if((e|0)<=0){L=0;return L|0}ba=g+-4|0;if((g|0)<4){if((g|0)>0){ca=0;da=0;ea=a}else{S=0;U=0;while(1){J=U+((b[c+S>>0]|0)!=0&1)|0;S=S+1|0;if((S|0)==(e|0)){L=J;break}else U=J}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{U=0;do{S=d+(U<<3)|0;p[S>>3]=+p[S>>3]+ +(f[ea+(U<<2)>>2]|0);U=U+1|0}while((U|0)!=(g|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(g<<2)|0}}return L|0}ea=g&-4;if((ea|0)<(g|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{U=d+(a<<3)|0;x=a|1;I=d+(x<<3)|0;F=+p[I>>3]+ +(f[ca+(x<<2)>>2]|0);p[U>>3]=+p[U>>3]+ +(f[ca+(a<<2)>>2]|0);p[I>>3]=F;I=a|2;U=d+(I<<3)|0;x=a|3;h=d+(x<<3)|0;F=+p[h>>3]+ +(f[ca+(x<<2)>>2]|0);p[U>>3]=+p[U>>3]+ +(f[ca+(I<<2)>>2]|0);p[h>>3]=F;a=a+4|0}while((a|0)<=(ba|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(g<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;F=+p[fa>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(ca<<2)>>2]|0);p[fa>>3]=F;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;F=+p[a>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(fa<<2)>>2]|0);p[a>>3]=F;ca=ca+4|0}while((ca|0)<=(ba|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +(f[ia+(la<<2)>>2]|0);la=la+1|0}while((la|0)!=(g|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(g<<2)|0}}return L|0}}return 0}function gV(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=a;k=h;l=0}else{m=f<<1;o=f*3|0;q=f<<2;r=i>>>2;s=Y((r<<4)+16|0,f)|0;t=a;u=h;v=0;while(1){u=u+(+n[t>>2]+ +n[t+(f<<2)>>2]+ +n[t+(m<<2)>>2]+ +n[t+(o<<2)>>2]);v=v+4|0;if((v|0)>(i|0))break;else t=t+(q<<2)|0}j=a+s|0;k=u;l=(r<<2)+4|0}if((l|0)<(e|0)){u=k;r=l;s=j;while(1){h=u+ +n[s>>2];r=r+1|0;if((r|0)==(e|0)){w=h;x=e;break}else{u=h;s=s+(f<<2)|0}}}else{w=k;x=l}p[d>>3]=w;y=x;break}case 2:{w=+p[d>>3];x=d+8|0;k=+p[x>>3];if((e|0)>0){u=k;h=w;l=0;s=a;while(1){z=h+ +n[s>>2];A=u+ +n[s+4>>2];l=l+1|0;if((l|0)==(e|0)){B=A;C=z;D=e;break}else{u=A;h=z;s=s+(f<<2)|0}}}else{B=k;C=w;D=0}p[d>>3]=C;p[x>>3]=B;y=D;break}case 3:{B=+p[d>>3];D=d+8|0;C=+p[D>>3];x=d+16|0;w=+p[x>>3];if((e|0)>0){k=w;h=C;u=B;s=0;l=a;while(1){z=u+ +n[l>>2];A=h+ +n[l+4>>2];E=k+ +n[l+8>>2];s=s+1|0;if((s|0)==(e|0)){F=E;G=A;H=z;I=e;break}else{k=E;h=A;u=z;l=l+(f<<2)|0}}}else{F=w;G=C;H=B;I=0}p[d>>3]=H;p[D>>3]=G;p[x>>3]=F;y=I;break}default:y=0}if((g|0)<(f|0)){J=g;K=y}else{L=e;return L|0}while(1){y=d+(J<<3)|0;F=+p[y>>3];g=d+(J+1<<3)|0;G=+p[g>>3];I=d+(J+2<<3)|0;H=+p[I>>3];x=d+(J+3<<3)|0;B=+p[x>>3];if((K|0)<(e|0)){C=B;w=H;u=G;h=F;D=a+((Y(K,f)|0)<<2)+(J<<2)|0;l=K;while(1){k=h+ +n[D>>2];z=u+ +n[D+4>>2];A=w+ +n[D+8>>2];E=C+ +n[D+12>>2];l=l+1|0;if((l|0)==(e|0)){M=E;N=A;O=z;P=k;Q=e;break}else{C=E;w=A;u=z;h=k;D=D+(f<<2)|0}}}else{M=B;N=H;O=G;P=F;Q=K}p[y>>3]=P;p[g>>3]=O;p[I>>3]=N;p[x>>3]=M;J=J+4|0;if((J|0)>=(f|0)){L=e;break}else K=Q}return L|0}switch(f|0){case 1:{M=+p[d>>3];if((e|0)>0){N=M;Q=0;K=0;while(1){if(!(b[c+K>>0]|0)){R=N;S=Q}else{R=N+ +n[a+(K<<2)>>2];S=Q+1|0}K=K+1|0;if((K|0)==(e|0)){T=R;U=S;break}else{N=R;Q=S}}}else{T=M;U=0}p[d>>3]=T;L=U;return L|0}case 3:{T=+p[d>>3];U=d+8|0;M=+p[U>>3];S=d+16|0;R=+p[S>>3];if((e|0)>0){N=R;O=M;P=T;Q=0;K=0;J=a;while(1){if(!(b[c+Q>>0]|0)){V=N;W=O;X=P;Z=K}else{V=N+ +n[J+8>>2];W=O+ +n[J+4>>2];X=P+ +n[J>>2];Z=K+1|0}Q=Q+1|0;if((Q|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{N=V;O=W;P=X;K=Z;J=J+12|0}}}else{_=R;$=M;aa=T;ba=0}p[d>>3]=aa;p[U>>3]=$;p[S>>3]=_;L=ba;return L|0}default:{if((e|0)<=0){L=0;return L|0}ba=f+-4|0;if((f|0)<4){if((f|0)>0){ca=0;da=0;ea=a}else{S=0;U=0;while(1){J=U+((b[c+S>>0]|0)!=0&1)|0;S=S+1|0;if((S|0)==(e|0)){L=J;break}else U=J}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{U=0;do{S=d+(U<<3)|0;p[S>>3]=+p[S>>3]+ +n[ea+(U<<2)>>2];U=U+1|0}while((U|0)!=(f|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(f<<2)|0}}return L|0}ea=f&-4;if((ea|0)<(f|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{U=d+(a<<3)|0;x=a|1;I=d+(x<<3)|0;F=+p[I>>3]+ +n[ca+(x<<2)>>2];p[U>>3]=+p[U>>3]+ +n[ca+(a<<2)>>2];p[I>>3]=F;I=a|2;U=d+(I<<3)|0;x=a|3;g=d+(x<<3)|0;F=+p[g>>3]+ +n[ca+(x<<2)>>2];p[U>>3]=+p[U>>3]+ +n[ca+(I<<2)>>2];p[g>>3]=F;a=a+4|0}while((a|0)<=(ba|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(f<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;F=+p[fa>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(ca<<2)>>2];p[fa>>3]=F;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;F=+p[a>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(fa<<2)>>2];p[a>>3]=F;ca=ca+4|0}while((ca|0)<=(ba|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +n[ia+(la<<2)>>2];la=la+1|0}while((la|0)!=(f|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(f<<2)|0}}return L|0}}return 0}function hV(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=a;k=h;l=0}else{m=f<<1;n=f*3|0;o=f<<2;q=i>>>2;r=Y((q<<5)+32|0,f)|0;s=a;t=h;u=0;while(1){t=t+(+p[s>>3]+ +p[s+(f<<3)>>3]+ +p[s+(m<<3)>>3]+ +p[s+(n<<3)>>3]);u=u+4|0;if((u|0)>(i|0))break;else s=s+(o<<3)|0}j=a+r|0;k=t;l=(q<<2)+4|0}if((l|0)<(e|0)){t=k;q=l;r=j;while(1){h=t+ +p[r>>3];q=q+1|0;if((q|0)==(e|0)){v=h;w=e;break}else{t=h;r=r+(f<<3)|0}}}else{v=k;w=l}p[d>>3]=v;x=w;break}case 2:{v=+p[d>>3];w=d+8|0;k=+p[w>>3];if((e|0)>0){t=k;h=v;l=0;r=a;while(1){y=h+ +p[r>>3];z=t+ +p[r+8>>3];l=l+1|0;if((l|0)==(e|0)){A=z;B=y;C=e;break}else{t=z;h=y;r=r+(f<<3)|0}}}else{A=k;B=v;C=0}p[d>>3]=B;p[w>>3]=A;x=C;break}case 3:{A=+p[d>>3];C=d+8|0;B=+p[C>>3];w=d+16|0;v=+p[w>>3];if((e|0)>0){k=v;h=B;t=A;r=0;l=a;while(1){y=t+ +p[l>>3];z=h+ +p[l+8>>3];D=k+ +p[l+16>>3];r=r+1|0;if((r|0)==(e|0)){E=D;F=z;G=y;H=e;break}else{k=D;h=z;t=y;l=l+(f<<3)|0}}}else{E=v;F=B;G=A;H=0}p[d>>3]=G;p[C>>3]=F;p[w>>3]=E;x=H;break}default:x=0}if((g|0)<(f|0)){I=g;J=x}else{K=e;return K|0}while(1){x=d+(I<<3)|0;E=+p[x>>3];g=d+(I+1<<3)|0;F=+p[g>>3];H=d+(I+2<<3)|0;G=+p[H>>3];w=d+(I+3<<3)|0;A=+p[w>>3];if((J|0)<(e|0)){B=A;v=G;t=F;h=E;C=a+((Y(J,f)|0)<<3)+(I<<3)|0;l=J;while(1){k=h+ +p[C>>3];y=t+ +p[C+8>>3];z=v+ +p[C+16>>3];D=B+ +p[C+24>>3];l=l+1|0;if((l|0)==(e|0)){L=D;M=z;N=y;O=k;P=e;break}else{B=D;v=z;t=y;h=k;C=C+(f<<3)|0}}}else{L=A;M=G;N=F;O=E;P=J}p[x>>3]=O;p[g>>3]=N;p[H>>3]=M;p[w>>3]=L;I=I+4|0;if((I|0)>=(f|0)){K=e;break}else J=P}return K|0}switch(f|0){case 1:{L=+p[d>>3];if((e|0)>0){M=L;P=0;J=0;while(1){if(!(b[c+J>>0]|0)){Q=M;R=P}else{Q=M+ +p[a+(J<<3)>>3];R=P+1|0}J=J+1|0;if((J|0)==(e|0)){S=Q;T=R;break}else{M=Q;P=R}}}else{S=L;T=0}p[d>>3]=S;K=T;return K|0}case 3:{S=+p[d>>3];T=d+8|0;L=+p[T>>3];R=d+16|0;Q=+p[R>>3];if((e|0)>0){M=Q;N=L;O=S;P=0;J=0;I=a;while(1){if(!(b[c+P>>0]|0)){U=M;V=N;W=O;X=J}else{U=M+ +p[I+16>>3];V=N+ +p[I+8>>3];W=O+ +p[I>>3];X=J+1|0}P=P+1|0;if((P|0)==(e|0)){Z=U;_=V;$=W;aa=X;break}else{M=U;N=V;O=W;J=X;I=I+24|0}}}else{Z=Q;_=L;$=S;aa=0}p[d>>3]=$;p[T>>3]=_;p[R>>3]=Z;K=aa;return K|0}default:{if((e|0)<=0){K=0;return K|0}aa=f+-4|0;if((f|0)<4){if((f|0)>0){ba=0;ca=0;da=a}else{R=0;T=0;while(1){I=T+((b[c+R>>0]|0)!=0&1)|0;R=R+1|0;if((R|0)==(e|0)){K=I;break}else T=I}return K|0}while(1){if(!(b[c+ba>>0]|0))ea=ca;else{T=0;do{R=d+(T<<3)|0;p[R>>3]=+p[da+(T<<3)>>3]+ +p[R>>3];T=T+1|0}while((T|0)!=(f|0));ea=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){K=ea;break}else{ca=ea;da=da+(f<<3)|0}}return K|0}da=f&-4;if((da|0)<(f|0)){fa=0;ga=0;ha=a}else{ea=0;ca=0;ba=a;while(1){if(!(b[c+ea>>0]|0))ia=ca;else{a=0;do{T=d+(a<<3)|0;w=a|1;H=d+(w<<3)|0;E=+p[H>>3]+ +p[ba+(w<<3)>>3];p[T>>3]=+p[T>>3]+ +p[ba+(a<<3)>>3];p[H>>3]=E;H=a|2;T=d+(H<<3)|0;w=a|3;g=d+(w<<3)|0;E=+p[g>>3]+ +p[ba+(w<<3)>>3];p[T>>3]=+p[T>>3]+ +p[ba+(H<<3)>>3];p[g>>3]=E;a=a+4|0}while((a|0)<=(aa|0));ia=ca+1|0}ea=ea+1|0;if((ea|0)==(e|0)){K=ia;break}else{ca=ia;ba=ba+(f<<3)|0}}return K|0}while(1){if(!(b[c+fa>>0]|0))ja=ga;else{ba=0;do{ia=d+(ba<<3)|0;ca=ba|1;ea=d+(ca<<3)|0;E=+p[ea>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ba<<3)>>3];p[ea>>3]=E;ea=ba|2;ia=d+(ea<<3)|0;ca=ba|3;a=d+(ca<<3)|0;E=+p[a>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ea<<3)>>3];p[a>>3]=E;ba=ba+4|0}while((ba|0)<=(aa|0));ka=da;do{ba=d+(ka<<3)|0;p[ba>>3]=+p[ha+(ka<<3)>>3]+ +p[ba>>3];ka=ka+1|0}while((ka|0)!=(f|0));ja=ga+1|0}fa=fa+1|0;if((fa|0)==(e|0)){K=ja;break}else{ga=ja;ha=ha+(f<<3)|0}}return K|0}}return 0}function iV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+1168|0;e=d+1112|0;g=d+1100|0;h=d+1096|0;i=d+1064|0;j=d;do if((eS(c)|0)==65536){k=f[c+4>>2]|0;f[e>>2]=f[k>>2];l=e+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=e+8|0;f[n>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[e+20>>2]=f[k+20>>2];f[e+24>>2]=f[k+24>>2];f[e+28>>2]=f[k+28>>2];f[e+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=n;n=e+48|0;q=e+44|0;f[q>>2]=n;f[n>>2]=0;f[e+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];r=e;break}else{f[l>>2]=0;U$(e,k);r=e;break}}else{bS(e,c,-1);r=e}while(0);c=f[r>>2]|0;r=c>>>3&511;k=r+1|0;l=c&7;c=f[37220+(l<<2)>>2]|0;if(!((l|0)!=7&k>>>0<5)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=$Xc(32)|0;f[g>>2]=m;f[g+8>>2]=-2147483616;f[g+4>>2]=20;n=m;q=234511;o=n+20|0;do{b[n>>0]=b[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(o|0));b[m+20>>0]=0;vM(-215,g,437393,234532,623)}f[g>>2]=e;f[g+4>>2]=0;f[h>>2]=0;BL(i,g,h,-1);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;g=f[i+20>>2]|0;m=j+8|0;f[j>>2]=m;q=j+4|0;f[q>>2]=264;n=l>>>0<4;if(n){o=l>>>0<2?8388608:32768;l=(o|0)<(g|0)?o:g;f[q>>2]=k;g1c(m|0,0,(r<<2)+4|0)|0;r=f[e+4>>2]|0;if((r|0)>0){s=l;t=o;v=f[(f[e+44>>2]|0)+(r+-1<<2)>>2]|0;w=m}else{s=l;t=o;v=0;w=m}}else{s=g;t=0;v=0;w=a}o=i+16|0;a:do if((g|0)>0){l=0;r=0;while(1){if(l>>>0>=(f[o>>2]|0)>>>0)break a;x=l+1|0;y=f[h>>2]|0;if(n){z=0;A=r;B=y;while(1){C=g-z|0;D=(s|0)<(C|0)?s:C;_h[c&127](B,0,w,D,k)|0;C=D+A|0;if((C+s|0)<(t|0)?((D+z|0)<(g|0)?1:x>>>0<(f[o>>2]|0)>>>0):0)E=C;else{F=0;G=21}if((G|0)==21)while(1){G=0;C=w+(F<<2)|0;H=a+(F<<3)|0;p[H>>3]=+p[H>>3]+ +(f[C>>2]|0);f[C>>2]=0;F=F+1|0;if((F|0)==(k|0)){E=0;break}else G=21}C=Y(D,v)|0;B=(f[h>>2]|0)+C|0;f[h>>2]=B;z=z+s|0;if((g|0)<=(z|0)){I=E;break}else A=E}}else{A=0;z=r;B=y;while(1){C=g-A|0;H=(s|0)<(C|0)?s:C;_h[c&127](B,0,w,H,k)|0;C=H+z|0;J=Y(H,v)|0;B=(f[h>>2]|0)+J|0;f[h>>2]=B;A=A+s|0;if((g|0)<=(A|0)){I=C;break}else z=C}}CL(i)|0;l=x;r=I}}else{r=0;while(1){if(r>>>0>=(f[o>>2]|0)>>>0)break a;CL(i)|0;r=r+1|0}}while(0);i=f[j>>2]|0;if((i|0)!=(m|0)){if(i|0)dYc(i);f[j>>2]=m;f[q>>2]=264}q=e+36|0;m=f[q>>2]|0;if(m|0?(j=m+12|0,m=f[j>>2]|0,f[j>>2]=m+-1,(m|0)==1):0)V$(e);f[q>>2]=0;q=e+16|0;m=e+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[m>>2]|0)>0){q=f[e+40>>2]|0;j=0;do{f[q+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[m>>2]|0))}m=f[e+44>>2]|0;if((m|0)==(e+48|0)){u=d;return}wL(m);u=d;return}function jV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d;g=d+8|0;f[e>>2]=f[37252+((c&7)<<2)>>2];f[e+4>>2]=(c>>>3&511)+1;DM(g,234667,e);e=g+11|0;c=b[e>>0]|0;if((c<<24>>24<0?f[g+4>>2]|0:c&255)|0){f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;u=d;return}if((b[529992]|0)==0?X0c(529992)|0:0){f[136172]=0;f[136173]=0;f[136174]=0;c=$Xc(16)|0;f[136172]=c;f[136174]=-2147483632;f[136173]=14;h=c;i=234673;j=h+14|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[c+14>>0]=0;be(2220,544688,x|0)|0}lYc(a,544688);if((b[e>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function kV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+176|0;g=e+160|0;h=e+16|0;i=e;e=h+64|0;j=h+8|0;f[j>>2]=35876;k=h+12|0;f[h>>2]=6740;f[e>>2]=6760;f[h+4>>2]=0;XNc(h+64|0,k);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=35856;f[e>>2]=35896;f[j>>2]=35876;aOc(k);f[k>>2]=35912;j=h+44|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(k,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);j=h+8|0;h=f[d+16>>2]|0;e=BM(BM(j,h,dJc(h)|0)|0,234688,13)|0;h=d+20|0;l=f[h>>2]|0;m=BM(BM(e,l,dJc(l)|0)|0,528081,1)|0;l=d+12|0;e=f[l>>2]|0;if(e>>>0<7)n=f[37284+(e<<2)>>2]|0;else n=234702;e=BM(BM(m,n,dJc(n)|0)|0,528081,1)|0;n=d+24|0;m=f[n>>2]|0;o=BM(BM(e,m,dJc(m)|0)|0,234706,9)|0;ZNc(g,o+(f[(f[o>>2]|0)+-12>>2]|0)|0);m=DPc(g,896088)|0;e=Mi[f[(f[m>>2]|0)+28>>2]&1023](m,10)|0;EPc(g);sOc(o,e)|0;dOc(o)|0;e=BM(o,234716,5)|0;o=f[h>>2]|0;h=BM(nOc(BM(BM(e,o,dJc(o)|0)|0,234722,5)|0,a)|0,528044,2)|0;jV(i,a);a=i+11|0;o=(b[a>>0]|0)<0?f[i>>2]|0:i;e=BM(BM(h,o,dJc(o)|0)|0,528047,1)|0;ZNc(g,e+(f[(f[e>>2]|0)+-12>>2]|0)|0);o=DPc(g,896088)|0;h=Mi[f[(f[o>>2]|0)+28>>2]&1023](o,10)|0;EPc(g);sOc(e,h)|0;dOc(e)|0;if((b[a>>0]|0)<0)cYc(f[i>>2]|0);i=f[l>>2]|0;if((i|0)!=0&(i|0)<7){i=BM(j,234728,8)|0;a=f[l>>2]|0;if(a>>>0<7)p=f[37312+(a<<2)>>2]|0;else p=234702;a=BM(i,p,dJc(p)|0)|0;ZNc(g,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);p=DPc(g,896088)|0;i=Mi[f[(f[p>>2]|0)+28>>2]&1023](p,10)|0;EPc(g);sOc(a,i)|0;dOc(a)|0}a=BM(j,234716,5)|0;j=f[n>>2]|0;n=BM(nOc(BM(BM(a,j,dJc(j)|0)|0,234722,5)|0,c)|0,528044,2)|0;jV(g,c);c=g+11|0;j=(b[c>>0]|0)<0?f[g>>2]|0:g;BM(BM(n,j,dJc(j)|0)|0,528047,1)|0;if((b[c>>0]|0)>=0){CM(g,k);q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;vM(-2,g,q,s,v)}cYc(f[g>>2]|0);CM(g,k);q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;t=d+8|0;v=f[t>>2]|0;vM(-2,g,q,s,v)}function lV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+160|0;g=e+144|0;h=e;e=h+64|0;i=h+8|0;f[i>>2]=35876;j=h+12|0;f[h>>2]=6740;f[e>>2]=6760;f[h+4>>2]=0;XNc(h+64|0,j);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=35856;f[e>>2]=35896;f[i>>2]=35876;aOc(j);f[j>>2]=35912;i=h+44|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(j,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);i=h+8|0;h=f[d+16>>2]|0;e=BM(BM(i,h,dJc(h)|0)|0,234688,13)|0;h=d+20|0;k=f[h>>2]|0;l=BM(BM(e,k,dJc(k)|0)|0,528081,1)|0;k=d+12|0;e=f[k>>2]|0;if(e>>>0<7)m=f[37284+(e<<2)>>2]|0;else m=234702;e=BM(BM(l,m,dJc(m)|0)|0,528081,1)|0;m=d+24|0;l=f[m>>2]|0;n=BM(BM(e,l,dJc(l)|0)|0,234706,9)|0;ZNc(g,n+(f[(f[n>>2]|0)+-12>>2]|0)|0);l=DPc(g,896088)|0;e=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,10)|0;EPc(g);sOc(n,e)|0;dOc(n)|0;e=BM(n,234716,5)|0;n=f[h>>2]|0;h=BM(BM(e,n,dJc(n)|0)|0,234722,5)|0;n=nOc(h,f[a>>2]|0)|0;ZNc(g,n+(f[(f[n>>2]|0)+-12>>2]|0)|0);a=DPc(g,896088)|0;h=Mi[f[(f[a>>2]|0)+28>>2]&1023](a,10)|0;EPc(g);sOc(n,h)|0;dOc(n)|0;n=f[k>>2]|0;if(!((n|0)!=0&(n|0)<7)){o=BM(i,234716,5)|0;p=f[m>>2]|0;q=dJc(p)|0;r=BM(o,p,q)|0;s=BM(r,234722,5)|0;t=f[c>>2]|0;nOc(s,t)|0;CM(g,j);v=f[d>>2]|0;w=d+4|0;x=f[w>>2]|0;y=d+8|0;z=f[y>>2]|0;vM(-2,g,v,x,z)}n=BM(i,234728,8)|0;h=f[k>>2]|0;if(h>>>0<7)A=f[37312+(h<<2)>>2]|0;else A=234702;h=BM(n,A,dJc(A)|0)|0;ZNc(g,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);A=DPc(g,896088)|0;n=Mi[f[(f[A>>2]|0)+28>>2]&1023](A,10)|0;EPc(g);sOc(h,n)|0;dOc(h)|0;o=BM(i,234716,5)|0;p=f[m>>2]|0;q=dJc(p)|0;r=BM(o,p,q)|0;s=BM(r,234722,5)|0;t=f[c>>2]|0;nOc(s,t)|0;CM(g,j);v=f[d>>2]|0;w=d+4|0;x=f[w>>2]|0;y=d+8|0;z=f[y>>2]|0;vM(-2,g,v,x,z)}function mV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+4|0;g=d;f[e>>2]=a;f[g>>2]=b;lV(e,g,c)}function nV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+160|0;g=e+144|0;h=e;e=h+64|0;i=h+8|0;f[i>>2]=35876;j=h+12|0;f[h>>2]=6740;f[e>>2]=6760;f[h+4>>2]=0;XNc(h+64|0,j);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=35856;f[e>>2]=35896;f[i>>2]=35876;aOc(j);f[j>>2]=35912;i=h+44|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(j,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);i=h+8|0;h=f[d+16>>2]|0;e=BM(BM(i,h,dJc(h)|0)|0,234688,13)|0;h=d+20|0;k=f[h>>2]|0;l=BM(BM(e,k,dJc(k)|0)|0,528081,1)|0;k=d+12|0;e=f[k>>2]|0;if(e>>>0<7)m=f[37284+(e<<2)>>2]|0;else m=234702;e=BM(BM(l,m,dJc(m)|0)|0,528081,1)|0;m=d+24|0;l=f[m>>2]|0;n=BM(BM(e,l,dJc(l)|0)|0,234706,9)|0;ZNc(g,n+(f[(f[n>>2]|0)+-12>>2]|0)|0);l=DPc(g,896088)|0;e=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,10)|0;EPc(g);sOc(n,e)|0;dOc(n)|0;e=BM(n,234716,5)|0;n=f[h>>2]|0;h=oOc(BM(BM(e,n,dJc(n)|0)|0,234722,5)|0,a)|0;ZNc(g,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);a=DPc(g,896088)|0;n=Mi[f[(f[a>>2]|0)+28>>2]&1023](a,10)|0;EPc(g);sOc(h,n)|0;dOc(h)|0;h=f[k>>2]|0;if(!((h|0)!=0&(h|0)<7)){o=BM(i,234716,5)|0;p=f[m>>2]|0;q=dJc(p)|0;r=BM(o,p,q)|0;s=BM(r,234722,5)|0;oOc(s,c)|0;CM(g,j);t=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;x=d+8|0;y=f[x>>2]|0;vM(-2,g,t,w,y)}h=BM(i,234728,8)|0;n=f[k>>2]|0;if(n>>>0<7)z=f[37312+(n<<2)>>2]|0;else z=234702;n=BM(h,z,dJc(z)|0)|0;ZNc(g,n+(f[(f[n>>2]|0)+-12>>2]|0)|0);z=DPc(g,896088)|0;h=Mi[f[(f[z>>2]|0)+28>>2]&1023](z,10)|0;EPc(g);sOc(n,h)|0;dOc(n)|0;o=BM(i,234716,5)|0;p=f[m>>2]|0;q=dJc(p)|0;r=BM(o,p,q)|0;s=BM(r,234722,5)|0;oOc(s,c)|0;CM(g,j);t=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;x=d+8|0;y=f[x>>2]|0;vM(-2,g,t,w,y)}function oV(a,c,d){a=+a;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+160|0;g=e+144|0;h=e;e=h+64|0;i=h+8|0;f[i>>2]=35876;j=h+12|0;f[h>>2]=6740;f[e>>2]=6760;f[h+4>>2]=0;XNc(h+64|0,j);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=35856;f[e>>2]=35896;f[i>>2]=35876;aOc(j);f[j>>2]=35912;i=h+44|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[h+60>>2]=24;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(j,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);i=h+8|0;h=f[d+16>>2]|0;e=BM(BM(i,h,dJc(h)|0)|0,234688,13)|0;h=d+20|0;k=f[h>>2]|0;l=BM(BM(e,k,dJc(k)|0)|0,528081,1)|0;k=d+12|0;e=f[k>>2]|0;if(e>>>0<7)m=f[37284+(e<<2)>>2]|0;else m=234702;e=BM(BM(l,m,dJc(m)|0)|0,528081,1)|0;m=d+24|0;l=f[m>>2]|0;n=BM(BM(e,l,dJc(l)|0)|0,234706,9)|0;ZNc(g,n+(f[(f[n>>2]|0)+-12>>2]|0)|0);l=DPc(g,896088)|0;e=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,10)|0;EPc(g);sOc(n,e)|0;dOc(n)|0;e=BM(n,234716,5)|0;n=f[h>>2]|0;h=qOc(BM(BM(e,n,dJc(n)|0)|0,234722,5)|0,a)|0;ZNc(g,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);n=DPc(g,896088)|0;e=Mi[f[(f[n>>2]|0)+28>>2]&1023](n,10)|0;EPc(g);sOc(h,e)|0;dOc(h)|0;h=f[k>>2]|0;if(!((h|0)!=0&(h|0)<7)){o=BM(i,234716,5)|0;p=f[m>>2]|0;q=dJc(p)|0;r=BM(o,p,q)|0;s=BM(r,234722,5)|0;qOc(s,c)|0;CM(g,j);t=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;x=d+8|0;y=f[x>>2]|0;vM(-2,g,t,w,y)}h=BM(i,234728,8)|0;e=f[k>>2]|0;if(e>>>0<7)z=f[37312+(e<<2)>>2]|0;else z=234702;e=BM(h,z,dJc(z)|0)|0;ZNc(g,e+(f[(f[e>>2]|0)+-12>>2]|0)|0);z=DPc(g,896088)|0;h=Mi[f[(f[z>>2]|0)+28>>2]&1023](z,10)|0;EPc(g);sOc(e,h)|0;dOc(e)|0;o=BM(i,234716,5)|0;p=f[m>>2]|0;q=dJc(p)|0;r=BM(o,p,q)|0;s=BM(r,234722,5)|0;qOc(s,c)|0;CM(g,j);t=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;x=d+8|0;y=f[x>>2]|0;vM(-2,g,t,w,y)}function pV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+160|0;e=d+144|0;g=d;d=g+64|0;h=g+8|0;f[h>>2]=35876;i=g+12|0;f[g>>2]=6740;f[d>>2]=6760;f[g+4>>2]=0;XNc(g+64|0,i);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=35856;f[d>>2]=35896;f[h>>2]=35876;aOc(i);f[i>>2]=35912;h=g+44|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;AM(i,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=f[c+16>>2]|0;d=BM(BM(g+8|0,h,dJc(h)|0)|0,506e3,1)|0;ZNc(e,d+(f[(f[d>>2]|0)+-12>>2]|0)|0);h=DPc(e,896088)|0;g=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;EPc(e);sOc(d,g)|0;dOc(d)|0;g=BM(d,234716,5)|0;d=f[c+24>>2]|0;h=BM(BM(g,d,dJc(d)|0)|0,234844,1)|0;ZNc(e,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);d=DPc(e,896088)|0;g=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;EPc(e);sOc(h,g)|0;dOc(h)|0;g=BM(h,234846,5)|0;ZNc(e,g+(f[(f[g>>2]|0)+-12>>2]|0)|0);h=DPc(e,896088)|0;d=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;EPc(e);sOc(g,d)|0;dOc(g)|0;d=BM(g,234716,5)|0;g=f[c+20>>2]|0;h=BM(nOc(BM(BM(d,g,dJc(g)|0)|0,234722,5)|0,a)|0,528044,2)|0;if(a>>>0>=8){j=0;k=(j|0)!=0;l=k?j:234597;m=dJc(l)|0;n=BM(h,l,m)|0;BM(n,528047,1)|0;CM(e,i);o=f[c>>2]|0;p=c+4|0;q=f[p>>2]|0;r=c+8|0;s=f[r>>2]|0;vM(-2,e,o,q,s)}j=f[37252+(a<<2)>>2]|0;k=(j|0)!=0;l=k?j:234597;m=dJc(l)|0;n=BM(h,l,m)|0;BM(n,528047,1)|0;CM(e,i);o=f[c>>2]|0;p=c+4|0;q=f[p>>2]|0;r=c+8|0;s=f[r>>2]|0;vM(-2,e,o,q,s)}function qV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+160|0;e=d+144|0;g=d;d=g+64|0;h=g+8|0;f[h>>2]=35876;i=g+12|0;f[g>>2]=6740;f[d>>2]=6760;f[g+4>>2]=0;XNc(g+64|0,i);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=35856;f[d>>2]=35896;f[h>>2]=35876;aOc(i);f[i>>2]=35912;h=g+44|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;AM(i,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=f[c+16>>2]|0;d=BM(BM(g+8|0,h,dJc(h)|0)|0,506e3,1)|0;ZNc(e,d+(f[(f[d>>2]|0)+-12>>2]|0)|0);h=DPc(e,896088)|0;g=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;EPc(e);sOc(d,g)|0;dOc(d)|0;g=BM(d,234716,5)|0;d=f[c+24>>2]|0;h=BM(BM(g,d,dJc(d)|0)|0,234844,1)|0;ZNc(e,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);d=DPc(e,896088)|0;g=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;EPc(e);sOc(h,g)|0;dOc(h)|0;g=BM(h,234846,5)|0;ZNc(e,g+(f[(f[g>>2]|0)+-12>>2]|0)|0);h=DPc(e,896088)|0;d=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;EPc(e);sOc(g,d)|0;dOc(g)|0;d=BM(g,234716,5)|0;g=f[c+20>>2]|0;h=BM(nOc(BM(BM(d,g,dJc(g)|0)|0,234722,5)|0,a)|0,528044,2)|0;jV(e,a);a=e+11|0;g=(b[a>>0]|0)<0?f[e>>2]|0:e;BM(BM(h,g,dJc(g)|0)|0,528047,1)|0;if((b[a>>0]|0)>=0){CM(e,i);j=f[c>>2]|0;k=c+4|0;l=f[k>>2]|0;m=c+8|0;n=f[m>>2]|0;vM(-2,e,j,l,n)}cYc(f[e>>2]|0);CM(e,i);j=f[c>>2]|0;k=c+4|0;l=f[k>>2]|0;m=c+8|0;n=f[m>>2]|0;vM(-2,e,j,l,n)}function rV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+160|0;e=d+144|0;g=d;d=g+64|0;h=g+8|0;f[h>>2]=35876;i=g+12|0;f[g>>2]=6740;f[d>>2]=6760;f[g+4>>2]=0;XNc(g+64|0,i);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=35856;f[d>>2]=35896;f[h>>2]=35876;aOc(i);f[i>>2]=35912;h=g+44|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;AM(i,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=f[c+16>>2]|0;d=BM(BM(g+8|0,h,dJc(h)|0)|0,506e3,1)|0;ZNc(e,d+(f[(f[d>>2]|0)+-12>>2]|0)|0);h=DPc(e,896088)|0;g=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;EPc(e);sOc(d,g)|0;dOc(d)|0;g=BM(d,234716,5)|0;d=f[c+24>>2]|0;h=BM(BM(g,d,dJc(d)|0)|0,234844,1)|0;ZNc(e,h+(f[(f[h>>2]|0)+-12>>2]|0)|0);d=DPc(e,896088)|0;g=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;EPc(e);sOc(h,g)|0;dOc(h)|0;g=BM(h,234846,5)|0;ZNc(e,g+(f[(f[g>>2]|0)+-12>>2]|0)|0);h=DPc(e,896088)|0;d=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;EPc(e);sOc(g,d)|0;dOc(g)|0;d=BM(g,234716,5)|0;g=f[c+20>>2]|0;h=BM(BM(d,g,dJc(g)|0)|0,234722,5)|0;nOc(h,f[a>>2]|0)|0;CM(e,i);vM(-2,e,f[c>>2]|0,f[c+4>>2]|0,f[c+8>>2]|0)}function sV(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=a;rV(d,b)}function tV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=c;c=a+4|0;d=b+4|0;e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=a+8|0;d=b+8|0;c=f[e>>2]|0;f[e>>2]=f[d>>2];f[d>>2]=c;c=a+12|0;g=b+12|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+16|0;g=b+16|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+20|0;g=b+20|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+24|0;g=b+24|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+28|0;g=b+28|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+32|0;g=b+32|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+36|0;g=b+36|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+40|0;g=b+40|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+44|0;i=b+44|0;j=f[c>>2]|0;f[c>>2]=f[i>>2];f[i>>2]=j;k=a+48|0;l=b+48|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;m=a+52|0;a=b+52|0;b=f[m>>2]|0;f[m>>2]=f[a>>2];f[a>>2]=b;if((f[c>>2]|0)==(l|0)){f[c>>2]=k;f[h>>2]=e;n=f[i>>2]|0}else n=j;if((n|0)!=(k|0))return;f[i>>2]=l;f[g>>2]=d;return}function uV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;if(!((a|0)!=0&(c|0)!=0)){vS(d);u=e;return}j=a+8|0;k=0;l=0;while(1){if((f[a+(k*56|0)+4>>2]|0)>=3){m=15;break}n=f[a+(k*56|0)+8>>2]|0;if((n|0)!=(f[j>>2]|0)){m=15;break}o=f[a>>2]|0;if((o^f[a+(k*56|0)>>2])&4095|0){m=15;break}l=(f[a+(k*56|0)+12>>2]|0)+l|0;k=k+1|0;if(k>>>0>=c>>>0){m=4;break}}if((m|0)==4){ZS(d,n,l,o&4095,-1,0,0);do if((eS(d)|0)==65536){o=f[d+4>>2]|0;f[g>>2]=f[o>>2];l=g+4|0;n=o+4|0;f[l>>2]=f[n>>2];k=g+8|0;f[k>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];j=f[o+36>>2]|0;f[g+36>>2]=j;f[g+40>>2]=k;k=g+48|0;p=g+44|0;f[p>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(j|0){k=j+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[n>>2]|0)<3){n=f[o+44>>2]|0;k=f[p>>2]|0;f[k>>2]=f[n>>2];f[k+4>>2]=f[n+4>>2];break}else{f[l>>2]=0;U$(g,o);break}}else bS(g,d,-1);while(0);d=i+4|0;o=i+8|0;l=i+12|0;n=i+8|0;k=i+4|0;p=h+36|0;j=h+16|0;q=h+4|0;r=h+40|0;s=h+44|0;t=h+48|0;v=0;w=0;do{x=a+(w*56|0)+12|0;y=f[x>>2]|0;z=f[a+(w*56|0)+8>>2]|0;f[i>>2]=v;f[d>>2]=0;f[o>>2]=y;f[l>>2]=z;Z$(h,g,i);z=n;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[k>>2]=h;jR(a+(w*56|0)|0,i);v=(f[x>>2]|0)+v|0;x=f[p>>2]|0;if(x|0?(z=x+12|0,x=f[z>>2]|0,f[z>>2]=x+-1,(x|0)==1):0)V$(h);f[p>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){x=f[r>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[q>>2]|0))}z=f[s>>2]|0;if((z|0)!=(t|0))wL(z);w=w+1|0}while(w>>>0<c>>>0);c=g+36|0;w=f[c>>2]|0;if(w|0?(t=w+12|0,w=f[t>>2]|0,f[t>>2]=w+-1,(w|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;w=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[w>>2]|0)>0){c=f[g+40>>2]|0;t=0;do{f[c+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[w>>2]|0))}w=f[g+44>>2]|0;if((w|0)!=(g+48|0))wL(w);u=e;return}else if((m|0)==15){m=$Xc(96)|0;f[g>>2]=m;f[g+8>>2]=-2147483552;f[g+4>>2]=80;e=m;w=234852;t=e+80|0;do{b[e>>0]=b[w>>0]|0;e=e+1|0;w=w+1|0}while((e|0)<(t|0));b[m+80>>0]=0;vM(-215,g,234933,234941,68)}}function vV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;gS(a,d);a=f[d>>2]|0;g=f[e>>2]|0;uV((a|0)==(g|0)?0:a,(g-a|0)/56|0,b);hx(d);u=c;return}function wV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;if(!((a|0)!=0&(c|0)!=0)){vS(d);u=e;return}j=a+12|0;k=0;l=0;while(1){if((f[a+(k*56|0)+4>>2]|0)>=3){m=15;break}n=f[a+(k*56|0)+12>>2]|0;if((n|0)!=(f[j>>2]|0)){m=15;break}o=f[a>>2]|0;if((o^f[a+(k*56|0)>>2])&4095|0){m=15;break}l=(f[a+(k*56|0)+8>>2]|0)+l|0;k=k+1|0;if(k>>>0>=c>>>0){m=4;break}}if((m|0)==4){ZS(d,l,n,o&4095,-1,0,0);do if((eS(d)|0)==65536){o=f[d+4>>2]|0;f[g>>2]=f[o>>2];n=g+4|0;l=o+4|0;f[n>>2]=f[l>>2];k=g+8|0;f[k>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];j=f[o+36>>2]|0;f[g+36>>2]=j;f[g+40>>2]=k;k=g+48|0;p=g+44|0;f[p>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(j|0){k=j+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[l>>2]|0)<3){l=f[o+44>>2]|0;k=f[p>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];break}else{f[n>>2]=0;U$(g,o);break}}else bS(g,d,-1);while(0);d=i+4|0;o=i+8|0;n=i+12|0;l=i+8|0;k=i+4|0;p=h+36|0;j=h+16|0;q=h+4|0;r=h+40|0;s=h+44|0;t=h+48|0;v=0;w=0;do{x=f[a+(w*56|0)+12>>2]|0;y=a+(w*56|0)+8|0;z=f[y>>2]|0;f[i>>2]=0;f[d>>2]=v;f[o>>2]=x;f[n>>2]=z;Z$(h,g,i);z=l;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[k>>2]=h;jR(a+(w*56|0)|0,i);v=(f[y>>2]|0)+v|0;y=f[p>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)V$(h);f[p>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){y=f[r>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[q>>2]|0))}z=f[s>>2]|0;if((z|0)!=(t|0))wL(z);w=w+1|0}while(w>>>0<c>>>0);c=g+36|0;w=f[c>>2]|0;if(w|0?(t=w+12|0,w=f[t>>2]|0,f[t>>2]=w+-1,(w|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;w=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[w>>2]|0)>0){c=f[g+40>>2]|0;t=0;do{f[c+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[w>>2]|0))}w=f[g+44>>2]|0;if((w|0)!=(g+48|0))wL(w);u=e;return}else if((m|0)==15){m=$Xc(96)|0;f[g>>2]=m;f[g+8>>2]=-2147483552;f[g+4>>2]=80;e=m;w=235020;t=e+80|0;do{b[e>>0]=b[w>>0]|0;e=e+1|0;w=w+1|0}while((e|0)<(t|0));b[m+80>>0]=0;vM(-215,g,235101,234941,113)}}function xV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;gS(a,d);a=f[d>>2]|0;g=f[e>>2]|0;wV((a|0)==(g|0)?0:a,(g-a|0)/56|0,b);hx(d);u=c;return}
function VDb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;e=c;g=f[d>>2]|0;d=Y(f[b+48>>2]|0,f[(f[(f[b+4>>2]|0)+40>>2]|0)+4>>2]|0)|0;h=Y(d,f[b+44>>2]|0)|0;b=Y(f[g+8>>2]|0,f[g+12>>2]|0)|0;f[e>>2]=b;f[e+4>>2]=h;f[e+8>>2]=-1;f[e+12>>2]=-1;f[a>>2]=0;h=a+4|0;f[h>>2]=0;f[a+8>>2]=0;gOa(a,e,e+16|0);e=f[a>>2]|0;a=f[h>>2]|0;a:do if((e|0)==(a|0))i=e;else{b=e;do{if((f[b>>2]|0)<0){i=b;break a}b=b+4|0}while((b|0)!=(a|0));u=c;return}while(0);if((i|0)==(a|0)){u=c;return}e=i+4|0;if((e|0)==(a|0)){j=a;k=i}else{b=e;e=i;while(1){i=f[b>>2]|0;if((i|0)<0)l=e;else{f[e>>2]=i;l=e+4|0}b=b+4|0;if((b|0)==(a|0))break;else e=l}j=f[h>>2]|0;k=l}if((k|0)==(j|0)){u=c;return}f[h>>2]=j+(~((j+-4-k|0)>>>2)<<2);u=c;return}function WDb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=u;u=u+384|0;g=e+360|0;h=e;i=e+304|0;j=e+248|0;k=e+192|0;l=e+176|0;m=e+120|0;o=e+104|0;q=e+88|0;r=e+32|0;s=a+100|0;t=a+140|0;v=f[f[t>>2]>>2]|0;w=c+4|0;x=f[w>>2]|0;if((x|0)<3)y=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{z=f[c+40>>2]|0;A=0;B=1;while(1){C=Y(f[z+(A<<2)>>2]|0,B)|0;A=A+1|0;if((A|0)==(x|0)){y=C;break}else B=C}}do if((y|0)!=1){f[i>>2]=f[c>>2];B=i+4|0;f[B>>2]=x;A=i+8|0;f[A>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];z=f[c+36>>2]|0;f[i+36>>2]=z;f[i+40>>2]=A;A=i+48|0;C=i+44|0;f[C>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(!z)D=x;else{A=z+12|0;f[A>>2]=(f[A>>2]|0)+1;D=f[w>>2]|0}if((D|0)<3){A=f[c+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];break}else{f[B>>2]=0;U$(i,c);break}}else{p[h>>3]=+n[f[c+16>>2]>>2];B=h+8|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;f[i>>2]=1124007936;B=i+8|0;A=i+40|0;E=i+4|0;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[A>>2]=B;z=i+48|0;f[i+44>>2]=z;f[z>>2]=0;f[i+52>>2]=0;f[g>>2]=1;f[g+4>>2]=v;S$(i,2,g,5);lR(i,h)|0}while(0);c=d+4|0;D=f[c>>2]|0;if((D|0)<3)G=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{w=f[d+40>>2]|0;x=0;y=1;while(1){z=Y(f[w+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(D|0)){G=z;break}else y=z}}do if((G|0)!=1){f[j>>2]=f[d>>2];y=j+4|0;f[y>>2]=D;x=j+8|0;f[x>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];w=f[d+36>>2]|0;f[j+36>>2]=w;f[j+40>>2]=x;x=j+48|0;z=j+44|0;f[z>>2]=x;f[x>>2]=0;f[j+52>>2]=0;if(!w)H=D;else{x=w+12|0;f[x>>2]=(f[x>>2]|0)+1;H=f[c>>2]|0}if((H|0)<3){x=f[d+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2];break}else{f[y>>2]=0;U$(j,d);break}}else{p[h>>3]=+n[f[d+16>>2]>>2];y=h+8|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[j>>2]=1124007936;y=j+8|0;x=j+40|0;E=j+4|0;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[x>>2]=y;B=j+48|0;f[j+44>>2]=B;f[B>>2]=0;f[j+52>>2]=0;f[g>>2]=1;f[g+4>>2]=v;S$(j,2,g,5);lR(j,h)|0}while(0);if(!(f[a+116>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;I=$Xc(32)|0;f[g>>2]=I;J=g+8|0;f[J>>2]=-2147483616;K=g+4|0;f[K>>2]=19;E=I;L=451874;F=E+19|0;do{b[E>>0]=b[L>>0]|0;E=E+1|0;L=L+1|0}while((E|0)<(F|0));M=I+19|0;b[M>>0]=0;vM(-215,g,451894,451625,365)}d=f[a+104>>2]|0;if((d|0)<3)N=Y(f[a+112>>2]|0,f[a+108>>2]|0)|0;else{H=f[t>>2]|0;t=0;c=1;while(1){D=Y(f[H+(t<<2)>>2]|0,c)|0;t=t+1|0;if((t|0)==(d|0)){N=D;break}else c=D}}if((d|0)==0|(N|0)==0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;I=$Xc(32)|0;f[g>>2]=I;J=g+8|0;f[J>>2]=-2147483616;K=g+4|0;f[K>>2]=19;E=I;L=451874;F=E+19|0;do{b[E>>0]=b[L>>0]|0;E=E+1|0;L=L+1|0}while((E|0)<(F|0));M=I+19|0;b[M>>0]=0;vM(-215,g,451894,451625,365)}M=a+168|0;if(((f[a+172>>2]|0)-(f[M>>2]|0)>>2|0)!=(v+2|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;I=$Xc(32)|0;f[g>>2]=I;f[g+8>>2]=-2147483616;f[g+4>>2]=27;E=I;L=451906;F=E+27|0;do{b[E>>0]=b[L>>0]|0;E=E+1|0;L=L+1|0}while((E|0)<(F|0));b[I+27>>0]=0;vM(-215,g,451894,451625,365)}I=i+16|0;K=(f[I>>2]|0)==0;if(!K){J=f[i+4>>2]|0;N=(J|0)<3;if(N)O=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{d=f[i+40>>2]|0;c=0;t=1;while(1){H=Y(f[d+(c<<2)>>2]|0,t)|0;c=c+1|0;if((c|0)==(J|0)){O=H;break}else t=H}}if(!((J|0)==0|(O|0)==0)){if(N)P=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{N=f[i+40>>2]|0;O=0;t=1;while(1){c=Y(f[N+(O<<2)>>2]|0,t)|0;O=O+1|0;if((O|0)==(J|0)){P=c;break}else t=c}}if((v|0)!=(P|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P=$Xc(32)|0;f[g>>2]=P;f[g+8>>2]=-2147483616;f[g+4>>2]=31;E=P;L=451934;F=E+31|0;do{b[E>>0]=b[L>>0]|0;E=E+1|0;L=L+1|0}while((E|0)<(F|0));b[P+31>>0]=0;vM(-215,g,451894,451625,365)}}}P=j+16|0;t=f[P>>2]|0;if(t|0){J=f[j+4>>2]|0;O=(J|0)<3;if(O)Q=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{N=f[j+40>>2]|0;c=0;d=1;while(1){H=Y(f[N+(c<<2)>>2]|0,d)|0;c=c+1|0;if((c|0)==(J|0)){Q=H;break}else d=H}}if(!((J|0)==0|(Q|0)==0)){if(O)R=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{O=f[j+40>>2]|0;Q=0;d=1;while(1){c=Y(f[O+(Q<<2)>>2]|0,d)|0;Q=Q+1|0;if((Q|0)==(J|0)){R=c;break}else d=c}}if((v|0)!=(R|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;R=$Xc(32)|0;f[g>>2]=R;f[g+8>>2]=-2147483616;f[g+4>>2]=31;E=R;L=451966;F=E+31|0;do{b[E>>0]=b[L>>0]|0;E=E+1|0;L=L+1|0}while((E|0)<(F|0));b[R+31>>0]=0;vM(-215,g,451894,451625,365)}}}if(!K){K=f[i+4>>2]|0;if((K|0)<3)S=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{R=f[i+40>>2]|0;L=0;E=1;while(1){F=Y(f[R+(L<<2)>>2]|0,E)|0;L=L+1|0;if((L|0)==(K|0)){S=F;break}else E=F}}if(!((K|0)==0|(S|0)==0)){g0(k,f[a+4>>2]|0,1,v);if((v|0)>0){S=i+40|0;K=i+44|0;E=i+12|0;L=a+156|0;R=g+4|0;F=h+4|0;d=l+8|0;J=l+12|0;Q=l+4|0;O=o+8|0;c=o+12|0;N=o+4|0;H=g+4|0;D=h+4|0;G=q+8|0;B=q+4|0;A=r+36|0;w=r+16|0;z=r+4|0;C=r+40|0;T=r+44|0;U=r+48|0;V=m+36|0;W=m+16|0;X=m+4|0;Z=m+40|0;_=m+44|0;$=m+48|0;aa=0;do{ba=f[I>>2]|0;do if((f[i>>2]&16384|0)==0?(ca=f[S>>2]|0,(f[ca>>2]|0)!=1):0){da=f[f[K>>2]>>2]|0;if((f[ca+4>>2]|0)==1){ea=ba+(Y(da,aa)|0)|0;break}else{ca=f[E>>2]|0;fa=(aa|0)/(ca|0)|0;ea=ba+(Y(fa,da)|0)+(aa-(Y(fa,ca)|0)<<2)|0;break}}else ga=75;while(0);if((ga|0)==75){ga=0;ea=ba+(aa<<2)|0}ha=+n[ea>>2];y=(f[L>>2]|0)+(aa<<3)|0;p[y>>3]=ha*+p[y>>3];y=aa;aa=aa+1|0;f[g>>2]=y;f[R>>2]=aa;f[h>>2]=-2147483648;f[F>>2]=2147483647;W$(m,k,g,h);f[d>>2]=0;f[J>>2]=0;f[l>>2]=16842752;f[Q>>2]=m;x=(f[L>>2]|0)+(y<<3)|0;f[o>>2]=-1056833530;f[N>>2]=x;f[O>>2]=1;f[c>>2]=1;f[g>>2]=y;f[H>>2]=aa;f[h>>2]=-2147483648;f[D>>2]=2147483647;W$(r,s,g,h);x=G;f[x>>2]=0;f[x+4>>2]=0;f[q>>2]=-1040121856;f[B>>2]=r;I1(l,o,q,1.0,-1);x=f[A>>2]|0;do if(x|0){ca=x+12|0;fa=f[ca>>2]|0;f[ca>>2]=fa+-1;if((fa|0)!=1)break;V$(r)}while(0);f[A>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[z>>2]|0)>0){x=f[C>>2]|0;ba=0;do{f[x+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[z>>2]|0))}ba=f[T>>2]|0;if((ba|0)!=(U|0))wL(ba);ba=f[V>>2]|0;do if(ba|0){x=ba+12|0;fa=f[x>>2]|0;f[x>>2]=fa+-1;if((fa|0)!=1)break;V$(m)}while(0);f[V>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[X>>2]|0)>0){ba=f[Z>>2]|0;fa=0;do{f[ba+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[X>>2]|0))}fa=f[_>>2]|0;if((fa|0)!=($|0))wL(fa);fa=(f[M>>2]|0)+(y<<2)|0;n[fa>>2]=ha*+n[fa>>2]}while((aa|0)<(v|0))}aa=k+36|0;$=f[aa>>2]|0;if($|0?(_=$+12|0,$=f[_>>2]|0,f[_>>2]=$+-1,($|0)==1):0)V$(k);f[aa>>2]=0;aa=k+16|0;$=k+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[k+40>>2]|0;_=0;do{f[aa+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[$>>2]|0))}$=f[k+44>>2]|0;if(($|0)!=(k+48|0))wL($);ia=f[P>>2]|0}else ia=t}else ia=t;t=(ia|0)==0;a:do if(!t){$=f[j+4>>2]|0;if(($|0)<3)ja=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{k=f[j+40>>2]|0;_=0;aa=1;while(1){X=Y(f[k+(_<<2)>>2]|0,aa)|0;_=_+1|0;if((_|0)==($|0)){ja=X;break}else aa=X}}if((ja|0)!=0&($|0)!=0&(v|0)>0){aa=f[j+40>>2]|0;_=aa+4|0;k=f[j+44>>2]|0;y=f[j+12>>2]|0;X=f[M>>2]|0;if(f[j>>2]&16384|0){Z=0;while(1){W=X+(Z<<2)|0;n[W>>2]=+n[ia+(Z<<2)>>2]+ +n[W>>2];Z=Z+1|0;if((Z|0)==(v|0))break a}}Z=(f[aa>>2]|0)==1;$=0;do{do if(!Z){W=f[k>>2]|0;if((f[_>>2]|0)==1){ka=ia+(Y(W,$)|0)|0;break}else{V=($|0)/(y|0)|0;ka=ia+(Y(V,W)|0)+($-(Y(V,y)|0)<<2)|0;break}}else ka=ia+($<<2)|0;while(0);V=X+($<<2)|0;n[V>>2]=+n[ka>>2]+ +n[V>>2];$=$+1|0}while(($|0)!=(v|0))}}while(0);if(!(f[I>>2]|0))if(t)la=0;else ga=118;else{ka=f[i+4>>2]|0;if((ka|0)<3)ma=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{ia=f[i+40>>2]|0;ja=0;$=1;while(1){X=Y(f[ia+(ja<<2)>>2]|0,$)|0;ja=ja+1|0;if((ja|0)==(ka|0)){ma=X;break}else $=X}}$=(ma|0)!=0&(ka|0)!=0;if($|t)la=$;else ga=118}if((ga|0)==118){ga=f[j+4>>2]|0;if((ga|0)<3)na=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{$=f[j+40>>2]|0;ka=0;ma=1;while(1){ja=Y(f[$+(ka<<2)>>2]|0,ma)|0;ka=ka+1|0;if((ka|0)==(ga|0)){na=ja;break}else ma=ja}}la=(ga|0)!=0&(na|0)!=0}b[a+200>>0]=la&1;la=(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/56|0)>>>0>1;if(la|t)oa=la;else{la=f[j+4>>2]|0;if((la|0)<3)pa=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{t=f[j+40>>2]|0;na=0;ga=1;while(1){ma=Y(f[t+(na<<2)>>2]|0,ga)|0;na=na+1|0;if((na|0)==(la|0)){pa=ma;break}else ga=ma}}oa=(la|0)!=0&(pa|0)!=0}b[a+201>>0]=oa&1;oa=f[M>>2]|0;M=f[oa+(v+-1<<2)>>2]|0;f[oa+(v+1<<2)>>2]=M;f[oa+(v<<2)>>2]=M;M=j+36|0;v=f[M>>2]|0;if(v|0?(oa=v+12|0,v=f[oa>>2]|0,f[oa>>2]=v+-1,(v|0)==1):0)V$(j);f[M>>2]=0;M=j+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[M>>2]|0)>0){P=f[j+40>>2]|0;v=0;do{f[P+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[M>>2]|0))}M=f[j+44>>2]|0;if((M|0)!=(j+48|0))wL(M);M=i+36|0;j=f[M>>2]|0;if(j|0?(v=j+12|0,j=f[v>>2]|0,f[v>>2]=j+-1,(j|0)==1):0)V$(i);f[M>>2]=0;M=i+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[M>>2]|0)>0){I=f[i+40>>2]|0;j=0;do{f[I+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[M>>2]|0))}M=f[i+44>>2]|0;if((M|0)==(i+48|0)){u=e;return}wL(M);u=e;return}function XDb(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;o=u;u=u+112|0;p=o+8|0;q=o;if((f[a+4>>2]|0)!=4){r=$Xc(48)|0;f[p>>2]=r;s=p+8|0;f[s>>2]=-2147483600;t=p+4|0;f[t>>2]=35;v=r;w=452194;x=v+35|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+35|0;b[y>>0]=0;vM(-215,p,452230,451625,623)}if((f[c+4>>2]|0)!=4){r=$Xc(48)|0;f[p>>2]=r;s=p+8|0;f[s>>2]=-2147483600;t=p+4|0;f[t>>2]=35;v=r;w=452194;x=v+35|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+35|0;b[y>>0]=0;vM(-215,p,452230,451625,623)}y=f[a+40>>2]|0;r=f[c+40>>2]|0;if((f[y>>2]|0)!=(f[r>>2]|0)){t=$Xc(32)|0;f[p>>2]=t;f[p+8>>2]=-2147483616;f[p+4>>2]=31;v=t;w=452234;x=v+31|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+31>>0]=0;vM(-215,p,452230,451625,623)}t=f[d+8>>2]|0;s=r+4|0;if((t|0)!=(f[s>>2]|0)){z=$Xc(32)|0;f[p>>2]=z;f[p+8>>2]=-2147483616;f[p+4>>2]=30;v=z;w=452266;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[z+30>>0]=0;vM(-215,p,452230,451625,623)}z=y+4|0;A=f[h>>2]|0;B=Y(A,(f[z>>2]|0)/(m|0)|0)|0;C=h+4|0;D=f[C>>2]|0;if((f[d+12>>2]|0)!=(Y(B,D)|0)){B=$Xc(80)|0;f[p>>2]=B;f[p+8>>2]=-2147483568;f[p+4>>2]=66;v=B;w=452297;x=v+66|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[B+66>>0]=0;vM(-215,p,452230,451625,623)}B=f[a>>2]|0;E=B&4095;F=f[c>>2]|0;if((E|0)!=(F&4095|0)){G=$Xc(32)|0;f[p>>2]=G;f[p+8>>2]=-2147483616;f[p+4>>2]=29;v=G;w=452364;x=v+29|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[G+29>>0]=0;vM(-215,p,452230,451625,623)}if((E|0)!=(f[d>>2]&4095|0)){G=$Xc(32)|0;f[p>>2]=G;f[p+8>>2]=-2147483616;f[p+4>>2]=30;v=G;w=452394;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[G+30>>0]=0;vM(-215,p,452230,451625,623)}if((E|0)!=5){E=$Xc(64)|0;f[p>>2]=E;f[p+8>>2]=-2147483584;f[p+4>>2]=57;v=E;w=452425;x=v+57|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[E+57>>0]=0;vM(-215,p,452230,451625,623)}if(!(B&16384)){B=$Xc(32)|0;f[p>>2]=B;f[p+8>>2]=-2147483616;f[p+4>>2]=20;v=B;w=452483;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[B+20>>0]=0;vM(-215,p,452230,451625,623)}if(!(F&16384)){F=$Xc(32)|0;f[p>>2]=F;f[p+8>>2]=-2147483616;f[p+4>>2]=21;v=F;w=452504;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[F+21>>0]=0;vM(-215,p,452230,451625,623)}if(((f[e+4>>2]|0)-(f[e>>2]|0)>>2|0)!=(t+2|0)){t=$Xc(48)|0;f[p>>2]=t;f[p+8>>2]=-2147483600;f[p+4>>2]=42;v=t;w=452526;x=v+42|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+42>>0]=0;vM(-215,p,452230,451625,623)}f[p>>2]=107904;t=p+4|0;w=p+8|0;F=p+12|0;B=p+32|0;v=B;x=v+68|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[t>>2]=a;f[w>>2]=d;f[F>>2]=c;f[p+16>>2]=f[r>>2];c=f[s>>2]|0;s=p+20|0;f[s>>2]=c;f[p+24>>2]=f[r+8>>2];f[p+28>>2]=f[r+12>>2];f[s>>2]=(c|0)/(m|0)|0;f[B>>2]=A;f[p+36>>2]=D;B=f[i>>2]|0;f[p+40>>2]=B;c=f[i+4>>2]|0;f[p+44>>2]=c;f[p+48>>2]=f[j>>2];f[p+52>>2]=f[j+4>>2];f[p+56>>2]=f[k>>2];j=k+4|0;f[p+60>>2]=f[j>>2];f[p+64>>2]=m;f[p+68>>2]=n;i=f[y+12>>2]|0;s=f[y+8>>2]|0;y=(f[z>>2]|0)/(m|0)|0;b[p+96>>0]=(D|A|(c|B)|0)==0&1;B=(fN(10)|0)&1;b[p+97>>0]=B;B=(fN(11)|0)&1;b[p+98>>0]=B;b[p+99>>0]=0;B=(y|0)<64?y:64;c=p+72|0;A=Y(Y(f[h>>2]|0,B)|0,f[C>>2]|0)|0;D=p+76|0;m=f[D>>2]|0;z=f[c>>2]|0;r=m-z>>2;F=z;z=m;if(A>>>0<=r>>>0)if(A>>>0<r>>>0?(m=F+(A<<2)|0,(z|0)!=(m|0)):0){f[D>>2]=z+(~((z+-4-m|0)>>>2)<<2);H=F}else H=F;else{CS(c,A-r|0);H=f[c>>2]|0}if((y|0)>0){y=0;c=f[C>>2]|0;while(1){if((c|0)>0){r=Y(y,s)|0;A=0;F=f[h>>2]|0;m=c;while(1){if((F|0)>0){z=0;d=m;w=F;while(1){a=Y((Y(f[j>>2]|0,A)|0)+r|0,i)|0;t=a+(Y(f[k>>2]|0,z)|0)|0;a=H+((Y((Y(d,y)|0)+A|0,w)|0)+z<<2)|0;f[a>>2]=t;z=z+1|0;t=f[h>>2]|0;a=f[C>>2]|0;if((z|0)>=(t|0)){I=a;J=t;break}else{d=a;w=t}}}else{I=m;J=F}A=A+1|0;if((A|0)>=(I|0)){K=I;break}else{F=J;m=I}}}else K=c;y=y+1|0;if((y|0)>=(B|0))break;else c=K}}f[p+84>>2]=e;f[p+88>>2]=g;f[p+92>>2]=(f[g>>2]|0)==(f[g+4>>2]|0)?l:0;f[q>>2]=0;f[q+4>>2]=n;h3(q,p,+(n|0));f[p>>2]=107904;n=f[p+72>>2]|0;if(!n){u=o;return}p=f[D>>2]|0;if((p|0)!=(n|0))f[D>>2]=p+(~((p+-4-n|0)>>>2)<<2);cYc(n);u=o;return}function YDb(a){a=a|0;var b=0,c=0;f[a>>2]=107904;b=f[a+72>>2]|0;if(!b)return;c=a+76|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function ZDb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=107904;b=f[a+72>>2]|0;if(!b){cYc(a);return}c=a+76|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function _Db(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0;d=u;u=u+1072|0;e=d+1068|0;g=d+1064|0;h=d;i=f[a+64>>2]|0;j=f[a+4>>2]|0;k=f[j+40>>2]|0;l=Y(f[k>>2]|0,i)|0;m=f[a+12>>2]|0;o=f[m+40>>2]|0;p=f[o+12>>2]|0;q=(f[o+4>>2]|0)/(i|0)|0;r=f[k+12>>2]|0;s=f[k+8>>2]|0;t=(f[k+4>>2]|0)/(i|0)|0;k=f[a+68>>2]|0;v=f[a+32>>2]|0;w=f[a+36>>2]|0;x=f[a+40>>2]|0;y=f[a+44>>2]|0;z=f[a+48>>2]|0;A=f[a+52>>2]|0;B=f[a+56>>2]|0;C=f[a+60>>2]|0;D=Y(w,v)|0;E=Y(s,r)|0;F=Y(f[o+8>>2]|0,p)|0;f[e>>2]=F;o=(b[a+96>>0]|0)==0;G=f[c>>2]|0;H=f[c+4>>2]|0;if((k|0)<(l<<1|0)){c=(l+-1+k|0)/(k|0)|0;I=(c|0)>1?c:1;J=1;K=Y(I,G)|0;L=Y(I,H)|0;M=F}else{I=(k|0)/(l|0)|0;k=(((I+-1+F|0)>>>0)/(I>>>0)|0)+7&-8;f[g>>2]=k;J=I;K=G;L=H;M=F>>>0<k>>>0?f[e>>2]|0:k}f[g>>2]=M;M=f[j+16>>2]|0;j=f[a+72>>2]|0;k=f[a+8>>2]|0;F=f[k+16>>2]|0;H=((f[f[k+44>>2]>>2]|0)>>>0)/((675553809>>>(f[k>>2]<<2&28)&15)>>>0)|0;k=f[a+84>>2]|0;G=f[k>>2]|0;if((f[k+4>>2]|0)==(G|0))lWc(k);k=G;G=f[a+88>>2]|0;I=f[G>>2]|0;c=(I|0)==(f[G+4>>2]|0)?0:I;I=f[m+16>>2]|0;m=D<<11|8;G=h+8|0;f[h>>2]=G;N=h+4|0;f[N>>2]=m;if(m>>>0>264){O=bYc(m>>>0>1073741823?-1:m<<2)|0;f[h>>2]=O;P=O}else P=G;O=P+31&-32;P=O;g1c(O|0,0,D<<13|0)|0;a:do if((K|0)<(L|0)){O=Y(t,E)|0;m=(t|0)>0;Q=a+92|0;R=(c|0)!=0;S=s-(Y(C,w+-1|0)|0)|0;T=C+-1|0;U=s+-1+C|0;V=z<<1;W=r-(Y(B,v+-1|0)|0)|0;X=B+-1|0;Z=r+-1+B|0;_=Y(C,r)|0;$=(q|0)>0;aa=~t;ba=~p;ca=K;da=K;do{ca=ca+1|0;ea=(da|0)/(J|0)|0;if((ea|0)>=(l|0))break a;fa=Y(ea,J)|0;ga=f[g>>2]|0;ha=Y(ga,da-fa|0)|0;ia=ha+ga|0;ja=f[e>>2]|0;ka=ja>>>0<ia>>>0?ja:ia;ia=M+((Y(O,ea)|0)<<2)|0;la=I+((Y(Y(ea,q)|0,ja)|0)<<2)|0;ma=Y((ea|0)%(i|0)|0,q)|0;ea=F+((Y(ma,H)|0)<<2)|0;na=k+(ma<<2)|0;if(m){oa=c+(ma<<2)|0;pa=(ka|0)>(ha|0);qa=Y(ga,ca-fa|0)|0;fa=~(ja>>>0>qa>>>0?qa:ja);ja=-33-ha|0;qa=0;ga=-1;ra=-65;while(1){sa=((Y(D,ga-((ra|0)>(aa|0)?ra:aa)|0)|0)+7|0)>>>3;ta=qa;qa=qa+64|0;ua=((t|0)<(qa|0)?t:qa)-ta|0;va=Y(ua,D)|0;wa=va+7&-8;xa=ea+((Y(ta,D)|0)<<2)|0;ya=R&(t|0)<=(qa|0)?oa:0;if(pa){za=Y(ta,s)|0;Aa=(va|0)>0;Ba=va<<2;Ca=(ua|0)>0;Da=(ya|0)!=0;Ea=(ta|0)==0;ta=ha;Fa=ja;while(1){Ga=(Fa|0)<(fa|0)?fa:Fa;Ha=ta;ta=ta+32|0;Ia=(ka|0)<(ta|0)?ka:ta;Ja=(Ha|0)/(p|0)|0;if((Ia|0)>(Ha|0)){Ka=Ha;La=Ja;Ma=Ha-(Y(Ja,p)|0)|0;Ja=P;while(1){Na=Ia-Ka|0;Oa=p-Ma|0;Pa=(Oa|0)<(Na|0)?Oa:Na;Na=Pa+Ma|0;Oa=(Y(La,A)|0)-y|0;Qa=(Y(Ma,z)|0)-x|0;Ra=ia+((Y(Oa+za|0,r)|0)<<2)+(Qa<<2)|0;do if(o){Sa=(Oa|0)>-1&(Oa|0)<(S|0);Ta=(T-Oa|0)/(C|0)|0;Ua=(Ta|0)>0?Ta:0;Ta=(U-Oa|0)/(C|0)|0;Va=(Ta|0)<(w|0)?Ta:w;if((Pa|0)>0){Ta=(Ua|0)<(Va|0);Wa=Ra;Xa=Ma;Ya=Ja;Za=Qa;while(1){do if(Sa){if((Xa+2|0)>(Na|0)|(Za|0)<0|(Za+V|0)>(W|0)){_a=34;break}if(Aa){$a=0;do{ab=f[j+($a<<2)>>2]|0;bb=f[Wa+(ab+z<<2)>>2]|0;f[Ya+($a<<2)>>2]=f[Wa+(ab<<2)>>2];f[Ya+($a+wa<<2)>>2]=bb;$a=$a+1|0}while(($a|0)<(va|0))}cb=Za+z|0;db=Wa+(z<<2)|0;eb=Xa+1|0;fb=Ya+(wa<<2)|0}else _a=34;while(0);do if((_a|0)==34){_a=0;$a=(X-Za|0)/(B|0)|0;bb=($a|0)>0?$a:0;$a=(Z-Za|0)/(B|0)|0;ab=($a|0)<(v|0)?$a:v;g1c(Ya|0,0,Ba|0)|0;if(!Ca){cb=Za;db=Wa;eb=Xa;fb=Ya;break}$a=(bb|0)<(ab|0);if(Ta)gb=0;else{cb=Za;db=Wa;eb=Xa;fb=Ya;break}do{hb=Y(gb,E)|0;ib=Y(gb,w)|0;if($a){jb=Ua;do{kb=(Y(_,jb)|0)+hb|0;lb=Y(jb+ib|0,v)|0;mb=bb;do{nb=Wa+(kb+(Y(mb,B)|0)<<2)|0;f[Ya+(mb+lb<<2)>>2]=f[nb>>2];mb=mb+1|0}while((mb|0)<(ab|0));jb=jb+1|0}while((jb|0)<(Va|0))}gb=gb+1|0}while((gb|0)<(ua|0));cb=Za;db=Wa;eb=Xa;fb=Ya}while(0);Xa=eb+1|0;ab=fb+(wa<<2)|0;if((Xa|0)>=(Na|0)){ob=ab;break}else{Wa=db+(z<<2)|0;Ya=ab;Za=cb+z|0}}}else ob=Ja}else if((Pa|0)>0){if(Aa){pb=Ra;qb=Ma;rb=Ja}else{Za=Ma+ba|0;Ya=Ga+Ka|0;Wa=Ma+-1-((Za|0)>(Ya|0)?Za:Ya)|0;Ya=Ma+1|0;ob=Ja+(Y(sa,((Wa|0)>(Ya|0)?Wa:Ya)-Ma<<5)|0)|0;break}while(1){Ya=0;do{Wa=pb+((Y(Ya,E)|0)<<2)|0;f[rb+(Ya<<2)>>2]=f[Wa>>2];Ya=Ya+1|0}while((Ya|0)<(va|0));qb=qb+1|0;Ya=rb+(wa<<2)|0;if((qb|0)>=(Na|0)){ob=Ya;break}else{pb=pb+(z<<2)|0;rb=Ya}}}else ob=Ja;while(0);Ka=Pa+Ka|0;if((Ia|0)<=(Ka|0))break;else{La=La+1|0;Ma=0;Ja=ob}}}Ja=Ia-Ha|0;if($){Ma=la+(Ha<<2)|0;La=(Ja|0)>0;Ka=0;do{Ga=xa+((Y(Ka,H)|0)<<2)|0;Na=f[e>>2]|0;Ra=Ma+((Y(Na,Ka)|0)<<2)|0;sb=+n[na+(Ka<<2)>>2];Qa=Ka|1;Oa=(Qa|0)>=(q|0);Ya=Oa?Ga:Ga+(H<<2)|0;Wa=Oa?Ra:Ra+(Na<<2)|0;tb=Oa?sb:+n[na+(Qa<<2)>>2];if(Da){ub=+n[ya+(Ka<<2)>>2];vb=Oa?ub:+n[ya+(Qa<<2)>>2];wb=ub}else{vb=1.0;wb=1.0}if(La)if(Ea){Qa=0;do{Oa=P+((Y(Qa,wa)|0)<<2)|0;if(Aa){ub=sb;xb=tb;Na=0;while(1){yb=+n[Oa+(Na<<2)>>2];zb=ub+yb*+n[Ga+(Na<<2)>>2];Ab=xb+yb*+n[Ya+(Na<<2)>>2];Na=Na+1|0;if((Na|0)>=(va|0)){Bb=Ab;Cb=zb;break}else{ub=zb;xb=Ab}}}else{Bb=tb;Cb=sb}n[Ra+(Qa<<2)>>2]=Da?(Cb>0.0?Cb:wb*Cb):Cb;n[Wa+(Qa<<2)>>2]=Da?(Bb>0.0?Bb:vb*Bb):Bb;Qa=Qa+1|0}while((Qa|0)<(Ja|0))}else{Qa=0;do{Pa=P+((Y(Qa,wa)|0)<<2)|0;Na=Wa+(Qa<<2)|0;Oa=Ra+(Qa<<2)|0;sb=+n[Oa>>2];tb=+n[Na>>2];if(Aa){xb=sb;ub=tb;Za=0;while(1){Ab=+n[Pa+(Za<<2)>>2];zb=xb+Ab*+n[Ga+(Za<<2)>>2];yb=ub+Ab*+n[Ya+(Za<<2)>>2];Za=Za+1|0;if((Za|0)>=(va|0)){Db=yb;Eb=zb;break}else{xb=zb;ub=yb}}}else{Db=tb;Eb=sb}n[Oa>>2]=Da?(Eb>0.0?Eb:wb*Eb):Eb;n[Na>>2]=Da?(Db>0.0?Db:vb*Db):Db;Qa=Qa+1|0}while((Qa|0)<(Ja|0))}Ka=Ka+2|0}while((Ka|0)<(q|0))}if((ta|0)>=(ka|0))break;else Fa=Fa+-32|0}}if((qa|0)>=(t|0))break;else{ga=ga+-64|0;ra=ra+-64|0}}}ra=f[Q>>2]|0;if(ra|0){ga=la+(ha<<2)|0;Ii[f[(f[ra>>2]|0)+104>>2]&127](ra,ga,ga,ka-ha|0,f[e>>2]|0,ma,ma+q|0)}da=da+1|0}while((da|0)<(L|0))}while(0);L=f[h>>2]|0;if((L|0)==(G|0)){u=d;return}if(L|0)dYc(L);f[h>>2]=G;f[N>>2]=264;u=d;return}function $Db(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+64|0;g=e+52|0;h=e+40|0;i=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e;f[g>>2]=0;o=g+4|0;f[o>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=f[o>>2]|0;o=f[g>>2]|0;c=o;if((d|0)==(o|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=$Xc(32)|0;f[i>>2]=p;f[i+8>>2]=-2147483616;f[i+4>>2]=17;q=p;r=452630;s=q+17|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[p+17>>0]=0;vM(-215,i,455619,451625,96)}p=f[a+4>>2]|0;t=(f[a+8>>2]|0)-p|0;v=p;if(!((t|0)!=0&((t|0)/56|0)>>>0<3)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;t=$Xc(48)|0;f[i>>2]=t;f[i+8>>2]=-2147483600;f[i+4>>2]=38;q=t;r=452648;s=q+38|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[t+38>>0]=0;vM(-215,i,455619,451625,98)}if((f[v+4>>2]|0)!=4){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(96)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483552;y=i+4|0;f[y>>2]=91;q=w;r=452687;s=q+91|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z=w+91|0;b[z>>0]=0;vM(-215,i,455619,451625,99)}t=f[v+40>>2]|0;v=a+44|0;if((f[t+12>>2]|0)!=(f[v>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(96)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483552;y=i+4|0;f[y>>2]=91;q=w;r=452687;s=q+91|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z=w+91|0;b[z>>0]=0;vM(-215,i,455619,451625,99)}if((f[t+8>>2]|0)!=(f[a+48>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(96)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483552;y=i+4|0;f[y>>2]=91;q=w;r=452687;s=q+91|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));z=w+91|0;b[z>>0]=0;vM(-215,i,455619,451625,99)}if((f[c+4>>2]|0)!=4){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;A=$Xc(96)|0;f[i>>2]=A;B=i+8|0;f[B>>2]=-2147483552;C=i+4|0;f[C>>2]=95;q=A;r=452779;s=q+95|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));D=A+95|0;b[D>>0]=0;vM(-215,i,455619,451625,102)}z=f[c>>2]|0;switch(z&4095){case 3:case 6:case 5:break;default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;A=$Xc(96)|0;f[i>>2]=A;B=i+8|0;f[B>>2]=-2147483552;C=i+4|0;f[C>>2]=95;q=A;r=452779;s=q+95|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));D=A+95|0;b[D>>0]=0;vM(-215,i,455619,451625,102)}}D=c+40|0;A=(d-o|0)/56|0;o=0;while(1){if((f[c+(o*56|0)+4>>2]|0)!=4){E=19;break}d=f[c+(o*56|0)+40>>2]|0;C=f[D>>2]|0;if((f[d+4>>2]|0)!=(f[C+4>>2]|0)){E=19;break}F=f[d+8>>2]|0;if((F|0)!=(f[C+8>>2]|0)){E=22;break}G=f[d+12>>2]|0;o=o+1|0;if((G|0)!=(f[C+12>>2]|0)){E=22;break}if(o>>>0>=A>>>0){E=15;break}if((z^f[c+(o*56|0)>>2])&4095|0){E=16;break}}if((E|0)==15){o=f[(f[h>>2]|0)+40>>2]|0;c=f[o+8>>2]|0;f[i>>2]=f[o+12>>2];f[i+4>>2]=c;c=a+64|0;o=f[c>>2]|0;f[j>>2]=o;z=a+60|0;A=f[z>>2]|0;f[k>>2]=A;f[l>>2]=o;f[m>>2]=A;f[n>>2]=G;f[n+4>>2]=F;uBb(n,i,v,a+52|0,a+84|0,a+68|0,j,k,l,m);a=f[j>>2]|0;if((a|0)!=(f[l>>2]|0)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;H=$Xc(64)|0;f[n>>2]=H;I=n+8|0;f[I>>2]=-2147483584;J=n+4|0;f[J>>2]=51;q=H;r=453039;s=q+51|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));K=H+51|0;b[K>>0]=0;vM(-213,n,455619,451625,119)}l=f[k>>2]|0;if((l|0)==(f[m>>2]|0)){f[z>>2]=l;f[c>>2]=a;hx(h);hx(g);u=e;return}else{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;H=$Xc(64)|0;f[n>>2]=H;I=n+8|0;f[I>>2]=-2147483584;J=n+4|0;f[J>>2]=51;q=H;r=453039;s=q+51|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));K=H+51|0;b[K>>0]=0;vM(-213,n,455619,451625,119)}}else if((E|0)==16){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=$Xc(48)|0;f[i>>2]=n;f[i+8>>2]=-2147483600;f[i+4>>2]=32;q=n;r=452875;s=q+32|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[n+32>>0]=0;vM(-215,i,455619,451625,105)}else if((E|0)==19){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=$Xc(64)|0;f[i>>2]=n;f[i+8>>2]=-2147483584;f[i+4>>2]=57;q=n;r=452908;s=q+57|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[n+57>>0]=0;vM(-215,i,455619,451625,106)}else if((E|0)==22){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;E=$Xc(80)|0;f[i>>2]=E;f[i+8>>2]=-2147483568;f[i+4>>2]=72;q=E;r=452966;s=q+72|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[E+72>>0]=0;vM(-215,i,455619,451625,107)}}function aEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>3>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>3;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=m;m=h;while(1){p[m>>3]=+p[c>>3];j=j+-1|0;if(!j)break;else m=m+8|0}}if(!l){m=h+(b<<3)|0;if((n|0)==(m|0))return;else{o=i;q=n+(~((n+-8-m|0)>>>3)<<3)|0;break}}else{m=b-k|0;j=m;r=n;while(1){p[r>>3]=+p[c>>3];j=j+-1|0;if(!j)break;else r=r+8|0}o=i;q=n+(m<<3)|0;break}}else{r=g;if(!g)s=e;else{j=a+4|0;k=f[j>>2]|0;if((k|0)!=(h|0))f[j>>2]=k+(~((k+-8-g|0)>>>3)<<3);cYc(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;s=0}if(b>>>0>536870911)kWc(a);j=s>>2;r=s>>3>>>0<268435455?(j>>>0<b>>>0?b:j):536870911;if(r>>>0>536870911)kWc(a);j=$Xc(r<<3)|0;k=a+4|0;f[k>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<3);r=b;l=j;while(1){p[l>>3]=+p[c>>3];r=r+-1|0;if(!r)break;else l=l+8|0}o=k;q=j+(b<<3)|0}while(0);f[o>>2]=q;return}function bEb(a){a=a|0;var c=0;f[a>>2]=107764;c=a+84|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);cYc(a);return}function cEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=$Xc(308)|0;BDb(c,b);f[c>>2]=108040;f[c+100>>2]=1124007936;b=c+108|0;d=c+140|0;e=c+104|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=b;b=c+148|0;f[c+144>>2]=b;f[b>>2]=0;f[c+152>>2]=0;f[c+156>>2]=1124007936;b=c+164|0;d=c+196|0;e=c+160|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=b;b=c+204|0;f[c+200>>2]=b;f[b>>2]=0;f[c+208>>2]=0;f[c+212>>2]=1124007936;b=c+216|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[c+244>>2]=c+220;b=c+252|0;f[c+248>>2]=b;f[c+256>>2]=0;f[b>>2]=0;f[c+260>>2]=1124007936;b=c+264|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[c+292>>2]=c+268;b=c+300|0;f[c+296>>2]=b;f[c+304>>2]=0;f[b>>2]=0;f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=108156;f[b+12>>2]=c;f[a+4>>2]=b;return}function dEb(a){a=a|0;NXc(a);cYc(a);return}function eEb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function fEb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==453343?a+12|0:0)|0}function gEb(a){a=a|0;cYc(a);return}function hEb(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=108040;EQ(a+260|0);EQ(a+212|0);c=a+156|0;d=a+192|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[d>>2]=0;d=a+172|0;c=a+160|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[a+196>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+200>>2]|0;if((c|0)!=(a+204|0))wL(c);c=a+100|0;e=a+136|0;d=f[e>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)V$(c);f[e>>2]=0;e=a+116|0;c=a+104|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[c>>2]|0)>0){e=f[a+140>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+144>>2]|0;if((c|0)!=(a+148|0))wL(c);f[a>>2]=107764;c=a+84|0;if((b[c+11>>0]|0)>=0){MNa(a);return}cYc(f[c>>2]|0);MNa(a);return}function iEb(a){a=a|0;hEb(a);cYc(a);return}function jEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e+48|0;h=e+36|0;i=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+8|0;n=e;$Db(a,c,d);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=a+64|0;c=f[d>>2]|0;f[i>>2]=c;o=a+60|0;p=f[o>>2]|0;f[j>>2]=p;f[k>>2]=c;f[l>>2]=p;p=f[(f[h>>2]|0)+40>>2]|0;c=f[p+8>>2]|0;f[m>>2]=f[p+12>>2];f[m+4>>2]=c;c=f[(f[g>>2]|0)+40>>2]|0;p=f[c+8>>2]|0;f[n>>2]=f[c+12>>2];f[n+4>>2]=p;uBb(m,n,a+44|0,a+52|0,a+84|0,a+68|0,i,j,k,l);a=f[i>>2]|0;if((a|0)==(f[k>>2]|0)?(k=f[j>>2]|0,(k|0)==(f[l>>2]|0)):0){f[o>>2]=k;f[d>>2]=a;hx(h);hx(g);u=e;return};f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=$Xc(64)|0;f[m>>2]=e;f[m+8>>2]=-2147483584;f[m+4>>2]=51;g=e;h=453039;a=g+51|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(a|0));b[e+51>>0]=0;vM(-213,m,455619,451625,1272)}function kEb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;g=u;u=u+752|0;h=g+680|0;i=g+624|0;j=g+608|0;k=g+596|0;l=g+584|0;m=g+528|0;n=g;o=g+472|0;p=g+416|0;q=g+360|0;r=g+304|0;s=g+248|0;t=g+224|0;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;gS(c,j);gS(d,k);gS(e,l);e=f[a+96>>2]|0;d=f[(f[(f[j>>2]|0)+40>>2]|0)+4>>2]|0;c=a+48|0;if(((((f[c>>2]|0)==1?(f[a+44>>2]|0)==1:0)?(f[a+56>>2]|0)==1:0)?(f[a+52>>2]|0)==1:0)?(f[a+72>>2]|0)==1:0)w=(f[a+68>>2]|0)==1;else w=0;x=i3()|0;y=a+100|0;if(f[a+116>>2]|0){z=f[a+104>>2]|0;if((z|0)<3)A=Y(f[a+112>>2]|0,f[a+108>>2]|0)|0;else{B=f[a+140>>2]|0;C=0;D=1;while(1){E=Y(f[B+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(z|0)){A=E;break}else D=E}}if((z|0)==0|(A|0)==0)F=17}else F=17;if((F|0)==17){g0(i,f[a+4>>2]|0,1,d);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=i;F=m+8|0;f[F>>2]=0;f[F+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=y;AV(h,m);F=i+36|0;A=f[F>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)V$(i);f[F>>2]=0;F=i+16|0;A=i+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[A>>2]|0)>0){F=f[i+40>>2]|0;z=0;do{f[F+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)!=(i+48|0))wL(A);A=f[a+4>>2]|0;if((((f[a+8>>2]|0)-A|0)/56|0)>>>0>1){g0(h,A+56|0,1,e);G=0}else{p$(n,e,1,5);f[h>>2]=1124007936;A=h+8|0;z=h+40|0;H=h+4|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[z>>2]=A;A=h+48|0;f[h+44>>2]=A;f[A>>2]=0;f[h+52>>2]=0;A=f[n>>2]|0;ei[f[(f[A>>2]|0)+12>>2]&511](A,n,h,-1);G=1}A=a+156|0;if((A|0)==(h|0)){z=h+36|0;F=f[z>>2]|0;if((F|0)!=0?(D=F+12|0,F=f[D>>2]|0,f[D>>2]=F+-1,(F|0)==1):0){V$(h);J=z}else J=z}else{z=a+192|0;F=f[z>>2]|0;if(F|0?(D=F+12|0,F=f[D>>2]|0,f[D>>2]=F+-1,(F|0)==1):0)V$(A);f[z>>2]=0;F=a+172|0;D=a+160|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[D>>2]|0)>0){C=f[a+196>>2]|0;B=0;do{f[C+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[D>>2]|0))}f[A>>2]=f[h>>2];A=h+4|0;B=f[A>>2]|0;f[D>>2]=B;D=h+8|0;C=a+164|0;f[C>>2]=f[D>>2];f[a+168>>2]=f[h+12>>2];f[F>>2]=f[h+16>>2];f[a+176>>2]=f[h+20>>2];f[a+180>>2]=f[h+24>>2];f[a+184>>2]=f[h+28>>2];f[a+188>>2]=f[h+32>>2];F=h+36|0;f[z>>2]=f[F>>2];z=a+200|0;E=f[z>>2]|0;K=a+204|0;if((E|0)==(K|0)){L=B;M=E}else{wL(E);f[z>>2]=K;f[a+196>>2]=C;L=f[A>>2]|0;M=K}K=h+44|0;if((L|0)<3){L=f[K>>2]|0;f[M>>2]=f[L>>2];f[M+4>>2]=f[L+4>>2]}else{f[z>>2]=f[K>>2];z=h+40|0;f[a+196>>2]=f[z>>2];f[K>>2]=h+48;f[z>>2]=D}f[h>>2]=1124007936;H=A;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));J=F}f[J>>2]=0;J=h+16|0;F=h+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[F>>2]|0)>0){J=f[h+40>>2]|0;H=0;do{f[J+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[F>>2]|0))}F=f[h+44>>2]|0;if((F|0)!=(h+48|0))wL(F);if(G)Zj(n)}if((f[v>>2]|0)!=(f[k>>2]|0)){n=a+4|0;G=o+36|0;F=o+16|0;H=o+4|0;J=o+40|0;I=o+44|0;A=o+48|0;D=m+36|0;z=m+16|0;K=m+4|0;L=m+40|0;M=m+44|0;C=m+48|0;E=i+4|0;B=h+4|0;N=i+4|0;O=h+4|0;P=i+4|0;Q=h+4|0;R=a+156|0;S=i+4|0;T=h+4|0;U=t+4|0;V=t+8|0;W=t+12|0;X=t+16|0;Z=t+20|0;_=t+21|0;$=t+22|0;aa=h+4|0;ba=+(x|0);ca=a+44|0;da=a+64|0;ea=a+60|0;fa=a+56|0;ga=a+52|0;a=p+16|0;ha=p+44|0;ia=s+16|0;ja=s+44|0;ka=w&1;la=h+4|0;ma=h+48|0;na=h+12|0;oa=h+16|0;pa=h+20|0;qa=h+24|0;ra=h+28|0;sa=h+32|0;ta=h+36|0;ua=h+40|0;va=h+44|0;wa=h+52|0;xa=h+56|0;ya=h+60|0;za=h+64|0;Aa=h+8|0;Ba=i+4|0;Ca=s+36|0;Da=s+4|0;Ea=s+40|0;Fa=s+48|0;Ga=r+36|0;Ha=r+16|0;Ia=r+4|0;Ja=r+40|0;Ka=r+44|0;La=r+48|0;Ma=q+36|0;Na=q+16|0;Oa=q+4|0;Pa=q+40|0;Qa=q+44|0;Ra=q+48|0;Sa=p+36|0;Ta=p+4|0;Ua=p+40|0;Va=p+48|0;Wa=0;Xa=f[k>>2]|0;do{Ya=f[(f[(f[n>>2]|0)+40>>2]|0)+4>>2]|0;Za=(e|0)/(Ya|0)|0;_a=(d|0)/(Za|0)|0;$a=f[j>>2]|0;ab=f[$a+(Wa*56|0)+40>>2]|0;bb=f[ab>>2]|0;cb=f[ab+8>>2]|0;db=f[ab+12>>2]|0;ab=f[Xa+(Wa*56|0)+40>>2]|0;eb=f[ab+8>>2]|0;fb=f[ab+12>>2]|0;g0(m,$a+(Wa*56|0)|0,1,Y(bb,d)|0);g0(o,Xa+(Wa*56|0)|0,1,Y(bb,e)|0);if((bb|0)>0){$a=(Za|0)>0;ab=0;do{if($a){gb=Y(ab,Za)|0;hb=0;do{ib=hb+gb|0;jb=Y(ib,Ya)|0;f[i>>2]=jb;f[E>>2]=jb+Ya;f[h>>2]=-2147483648;f[B>>2]=2147483647;W$(p,o,i,h);jb=w?p:f[l>>2]|0;kb=Y(ib,_a)|0;f[i>>2]=kb;f[N>>2]=kb+_a;f[h>>2]=-2147483648;f[O>>2]=2147483647;W$(q,m,i,h);kb=Y(hb,_a)|0;f[i>>2]=kb;f[P>>2]=kb+_a;f[h>>2]=-2147483648;f[Q>>2]=2147483647;W$(r,y,h,i);kb=Y(hb,Ya)|0;f[i>>2]=kb;f[S>>2]=kb+Ya;f[h>>2]=-2147483648;f[T>>2]=2147483647;W$(s,R,i,h);f[t>>2]=108184;f[U>>2]=r;f[V>>2]=q;f[W>>2]=jb;f[X>>2]=x;kb=(fN(10)|0)&1;b[Z>>0]=kb;kb=(fN(11)|0)&1;b[_>>0]=kb;b[$>>0]=0;f[h>>2]=0;f[aa>>2]=x;h3(h,t,ba);kb=f[jb+16>>2]|0;jb=f[c>>2]|0;ib=f[ca>>2]|0;lb=f[da>>2]|0;mb=f[ea>>2]|0;nb=f[fa>>2]|0;ob=f[ga>>2]|0;pb=f[a>>2]|0;qb=f[ia>>2]|0;rb=i3()|0;f[h>>2]=108204;f[la>>2]=kb;f[ma>>2]=pb;f[na>>2]=Ya;f[oa>>2]=eb;f[pa>>2]=fb;f[qa>>2]=jb;f[ra>>2]=ib;f[sa>>2]=lb;f[ta>>2]=mb;f[ua>>2]=nb;f[va>>2]=ob;f[wa>>2]=cb;f[xa>>2]=db;f[ya>>2]=rb;b[za>>0]=ka;f[Aa>>2]=qb;f[i>>2]=0;f[Ba>>2]=rb;h3(i,h,+(rb|0));rb=f[Ca>>2]|0;if(rb|0?(qb=rb+12|0,rb=f[qb>>2]|0,f[qb>>2]=rb+-1,(rb|0)==1):0)V$(s);f[Ca>>2]=0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[Da>>2]|0)>0){rb=f[Ea>>2]|0;qb=0;do{f[rb+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[Da>>2]|0))}qb=f[ja>>2]|0;if((qb|0)!=(Fa|0))wL(qb);qb=f[Ga>>2]|0;if(qb|0?(rb=qb+12|0,qb=f[rb>>2]|0,f[rb>>2]=qb+-1,(qb|0)==1):0)V$(r);f[Ga>>2]=0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((f[Ia>>2]|0)>0){qb=f[Ja>>2]|0;rb=0;do{f[qb+(rb<<2)>>2]=0;rb=rb+1|0}while((rb|0)<(f[Ia>>2]|0))}rb=f[Ka>>2]|0;if((rb|0)!=(La|0))wL(rb);rb=f[Ma>>2]|0;do if(rb|0){qb=rb+12|0;ob=f[qb>>2]|0;f[qb>>2]=ob+-1;if((ob|0)!=1)break;V$(q)}while(0);f[Ma>>2]=0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[Oa>>2]|0)>0){rb=f[Pa>>2]|0;ob=0;do{f[rb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[Oa>>2]|0))}ob=f[Qa>>2]|0;if((ob|0)!=(Ra|0))wL(ob);ob=f[Sa>>2]|0;do if(ob|0){rb=ob+12|0;qb=f[rb>>2]|0;f[rb>>2]=qb+-1;if((qb|0)!=1)break;V$(p)}while(0);f[Sa>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[Ta>>2]|0)>0){ob=f[Ua>>2]|0;qb=0;do{f[ob+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[Ta>>2]|0))}qb=f[ha>>2]|0;if((qb|0)!=(Va|0))wL(qb);hb=hb+1|0}while((hb|0)<(Za|0))}ab=ab+1|0}while((ab|0)<(bb|0))}bb=f[G>>2]|0;if(bb|0?(ab=bb+12|0,bb=f[ab>>2]|0,f[ab>>2]=bb+-1,(bb|0)==1):0)V$(o);f[G>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[H>>2]|0)>0){bb=f[J>>2]|0;ab=0;do{f[bb+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[H>>2]|0))}ab=f[I>>2]|0;if((ab|0)!=(A|0))wL(ab);ab=f[D>>2]|0;if(ab|0?(bb=ab+12|0,ab=f[bb>>2]|0,f[bb>>2]=ab+-1,(ab|0)==1):0)V$(m);f[D>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[K>>2]|0)>0){ab=f[L>>2]|0;bb=0;do{f[ab+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[K>>2]|0))}bb=f[M>>2]|0;if((bb|0)!=(C|0))wL(bb);Wa=Wa+1|0;Xa=f[k>>2]|0}while(Wa>>>0<(((f[v>>2]|0)-Xa|0)/56|0)>>>0)}hx(l);hx(k);hx(j);u=g;return}function lEb(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function mEb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function nEb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function oEb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=u;u=u+48|0;h=d+32|0;i=d+16|0;j=d;k=a+4|0;l=a+8|0;m=f[k>>2]|0;n=m;if((((f[l>>2]|0)-m|0)/56|0)>>>0>1){m=f[n+60>>2]|0;if((m|0)<3)o=Y(f[n+68>>2]|0,f[n+64>>2]|0)|0;else{p=f[n+96>>2]|0;n=0;q=1;while(1){r=Y(f[p+(n<<2)>>2]|0,q)|0;n=n+1|0;if((n|0)==(m|0)){o=r;break}else q=r}}if((o|0)!=(f[a+96>>2]|0)){o=$Xc(64)|0;f[h>>2]=o;f[h+8>>2]=-2147483584;f[h+4>>2]=51;s=o;t=453514;v=s+51|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[o+51>>0]=0;vM(-215,h,456079,451625,1211)}}o=c+4|0;q=f[c>>2]|0;if((f[o>>2]|0)==(q|0)){m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=18;s=m;t=453566;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[m+18>>0]=0;vM(-215,h,456079,451625,1212)}m=f[q>>2]|0;q=f[m+4>>2]|0;n=f[m+8>>2]|0;p=f[m+12>>2]|0;m=a+84|0;r=m+11|0;w=b[r>>0]|0;x=w<<24>>24<0;if(x)y=f[a+88>>2]|0;else y=w&255;a:do if(y){z=a+88|0;A=f[z>>2]|0;do if(((x?A:w&255)|0)==5)if(!(LYc(m,0,-1,453585,5)|0)){B=Y(f[a+56>>2]|0,n+-1|0)|0;C=Y(f[a+52>>2]|0,p+-1|0)|0;D=B+(f[a+48>>2]|0)+(f[a+80>>2]|0)|0;E=C+(f[a+44>>2]|0)|0;break a}else{F=b[r>>0]|0;G=f[z>>2]|0;break}else{F=w;G=A}while(0);if(((F<<24>>24<0?G:F&255)|0)!=4){SGa(h,453596,m);vM(-2,h,456079,451625,1235)}if(!(LYc(m,0,-1,453591,4)|0)){A=(Y(f[a+56>>2]|0,n+-1|0)|0)+1|0;D=A+(f[a+80>>2]|0)|0;E=(Y(f[a+52>>2]|0,p+-1|0)|0)+1|0;break}else{SGa(h,453596,m);vM(-2,h,456079,451625,1235)}}else{A=Y(f[a+56>>2]|0,n+-1|0)|0;z=Y(f[a+52>>2]|0,p+-1|0)|0;D=A+(f[a+48>>2]|0)-(f[a+64>>2]<<1)+(f[a+80>>2]|0)|0;E=z+(f[a+44>>2]|0)-(f[a+60>>2]<<1)|0}while(0);p=(f[a+76>>2]|0)+E|0;E=f[a+96>>2]|0;n=a+4|0;m=f[(f[n>>2]|0)+40>>2]|0;F=f[m+4>>2]|0;if((E|0)%(F|0)|0|0){G=$Xc(32)|0;f[h>>2]=G;f[h+8>>2]=-2147483616;f[h+4>>2]=29;s=G;t=453622;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[G+29>>0]=0;vM(-215,h,456079,451625,1239)}G=(E|0)/(F|0)|0;if((q|0)%(G|0)|0|0){H=$Xc(48)|0;f[h>>2]=H;I=h+8|0;f[I>>2]=-2147483600;J=h+4|0;f[J>>2]=44;s=H;t=453652;v=s+44|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));K=H+44|0;b[K>>0]=0;vM(-215,h,456079,451625,1242)}if((E|0)%(G|0)|0|0){H=$Xc(48)|0;f[h>>2]=H;I=h+8|0;f[I>>2]=-2147483600;J=h+4|0;f[J>>2]=44;s=H;t=453652;v=s+44|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));K=H+44|0;b[K>>0]=0;vM(-215,h,456079,451625,1242)}if((f[m>>2]|0)!=(q|0)){q=$Xc(32)|0;f[h>>2]=q;f[h+8>>2]=-2147483616;f[h+4>>2]=25;s=q;t=453697;v=s+25|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[q+25>>0]=0;vM(-215,h,456079,451625,1243)}q=f[c>>2]|0;f[i>>2]=f[f[q>>2]>>2];f[i+4>>2]=E;f[i+8>>2]=D;f[i+12>>2]=p;E=((f[o>>2]|0)-q|0)/12|0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;gOa(h,i,i+16|0);i=e+4|0;o=f[i>>2]|0;t=f[e>>2]|0;s=(o-t|0)/12|0;v=t;t=o;if(E>>>0<=s>>>0){if(E>>>0<s>>>0?(o=v+(E*12|0)|0,(t|0)!=(o|0)):0){v=t;while(1){t=v+-12|0;f[i>>2]=t;m=f[t>>2]|0;if(!m)L=t;else{t=v+-8|0;K=f[t>>2]|0;if((K|0)!=(m|0))f[t>>2]=K+(~((K+-4-m|0)>>>2)<<2);cYc(m);L=f[i>>2]|0}if((L|0)==(o|0))break;else v=L}}}else Nvb(e,E-s|0,h);s=f[h>>2]|0;if(s|0){E=f[q>>2]|0;if((E|0)!=(s|0))f[q>>2]=E+(~((E+-4-s|0)>>>2)<<2);cYc(s)}f[h>>2]=0;s=h+4|0;f[s>>2]=0;f[h+8>>2]=0;E=g+4|0;q=f[E>>2]|0;L=g+8|0;if(q>>>0>=(f[L>>2]|0)>>>0){BPa(g,h);v=f[h>>2]|0;if(v|0){o=f[s>>2]|0;if((o|0)!=(v|0))f[s>>2]=o+(~((o+-4-v|0)>>>2)<<2);cYc(v)}}else{f[q>>2]=0;v=q+4|0;f[v>>2]=0;f[q+8>>2]=0;f[q>>2]=f[h>>2];f[v>>2]=f[s>>2];v=h+8|0;f[q+8>>2]=f[v>>2];f[v>>2]=0;f[s>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+12}s=f[a+48>>2]|0;v=f[a+44>>2]|0;if((s|0)==1&(v|0)==1){if(!((((f[a+56>>2]|0)==1?(f[a+52>>2]|0)==1:0)?(f[a+72>>2]|0)==1:0)?(f[a+68>>2]|0)==1:0)){M=1;N=54}}else{M=v;N=54}if((N|0)==54){v=f[f[c>>2]>>2]|0;c=Y(Y(s,(f[(f[f[e>>2]>>2]|0)+4>>2]|0)/((f[v+4>>2]|0)/(f[f[(f[n>>2]|0)+40>>2]>>2]|0)|0|0)|0)|0,M)|0;M=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;f[h>>2]=c;f[h+4>>2]=M;f[h+8>>2]=-1;f[h+12>>2]=-1;f[j>>2]=0;M=j+4|0;f[M>>2]=0;f[j+8>>2]=0;gOa(j,h,h+16|0);c=f[j>>2]|0;v=f[M>>2]|0;n=c;e=v;b:do if((c|0)==(v|0)){O=c;N=57}else{s=c;while(1){if((f[s>>2]|0)<0){O=s;N=57;break b}s=s+4|0;if((s|0)==(v|0)){P=e;break}}}while(0);if((N|0)==57)if((O|0)!=(v|0)){c=O+4|0;if((c|0)==(v|0)){Q=v;R=O;S=e}else{s=c;c=O;while(1){O=f[s>>2]|0;if((O|0)<0)T=c;else{f[c>>2]=O;T=c+4|0}s=s+4|0;if((s|0)==(v|0))break;else c=T}c=f[M>>2]|0;Q=c;R=T;S=c}if((R|0)==(Q|0))P=S;else{S=Q+(~((Q+-4-R|0)>>>2)<<2)|0;f[M>>2]=S;P=S}}else P=e;e=f[g>>2]|0;S=f[e>>2]|0;R=e+4|0;if(!S){U=e+8|0;V=n;W=P}else{P=f[R>>2]|0;if((P|0)!=(S|0))f[R>>2]=P+(~((P+-4-S|0)>>>2)<<2);cYc(S);S=e+8|0;f[S>>2]=0;f[R>>2]=0;f[e>>2]=0;U=S;V=f[j>>2]|0;W=f[M>>2]|0}f[e>>2]=V;f[R>>2]=W;f[U>>2]=f[j+8>>2]}if((((f[l>>2]|0)-(f[k>>2]|0)|0)/56|0)>>>0<=1){u=d;return 0}k=Y(p,D)|0;f[h>>2]=1;f[h+4>>2]=k;f[h+8>>2]=-1;f[h+12>>2]=-1;f[j>>2]=0;k=j+4|0;f[k>>2]=0;f[j+8>>2]=0;gOa(j,h,h+16|0);h=f[j>>2]|0;D=f[k>>2]|0;c:do if((h|0)==(D|0)){X=h;N=75}else{p=h;do{if((f[p>>2]|0)<0){X=p;N=75;break c}p=p+4|0}while((p|0)!=(D|0))}while(0);if((N|0)==75?(X|0)!=(D|0):0){N=X+4|0;if((N|0)==(D|0)){Z=D;_=X}else{h=N;N=X;while(1){X=f[h>>2]|0;if((X|0)<0)$=N;else{f[N>>2]=X;$=N+4|0}h=h+4|0;if((h|0)==(D|0))break;else N=$}Z=f[k>>2]|0;_=$}if((_|0)!=(Z|0))f[k>>2]=Z+(~((Z+-4-_|0)>>>2)<<2)}_=f[E>>2]|0;if(_>>>0>=(f[L>>2]|0)>>>0){BPa(g,j);g=f[j>>2]|0;if(g|0){L=f[k>>2]|0;if((L|0)!=(g|0))f[k>>2]=L+(~((L+-4-g|0)>>>2)<<2);cYc(g)}}else{f[_>>2]=0;g=_+4|0;f[g>>2]=0;f[_+8>>2]=0;f[_>>2]=f[j>>2];f[g>>2]=f[k>>2];g=j+8|0;f[_+8>>2]=f[g>>2];f[g>>2]=0;f[k>>2]=0;f[j>>2]=0;f[E>>2]=(f[E>>2]|0)+12}u=d;return 0}function pEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;h=f[c+4>>2]|0;i=f[c>>2]|0;c=h-i|0;j=i;if((c|0)!=((f[d+4>>2]|0)-(f[d>>2]|0)|0)){d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=31;k=d;l=451584;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[d+31>>0]=0;vM(-215,g,451616,451625,1788)}if((h|0)==(i|0)){n=0;o=0;J=n;u=e;return o|0}i=f[f[(f[a+4>>2]|0)+40>>2]>>2]|0;h=u1c(i|0,((i|0)<0)<<31>>31|0,1)|0;i=Y(f[a+48>>2]|0,f[a+44>>2]|0)|0;a=x1c(h|0,J|0,i|0,((i|0)<0)<<31>>31|0)|0;i=J;h=(c|0)/12|0;p=0.0;c=0;do{d=f[j+(c*12|0)+4>>2]|0;q=f[j+(c*12|0)>>2]|0;r=d-q|0;s=r>>2;t=q;if((t|0)!=(d|0)){if((r|0)<=-4){v=10;break}if((r|0)>0){r=0;d=1;while(1){q=Y(f[t+(r<<2)>>2]|0,d)|0;r=r+1|0;if((r|0)>=(s|0)){w=q;break}else d=q}}else w=1}else w=0;d=x1c(a|0,i|0,w|0,((w|0)<0)<<31>>31|0)|0;p=p+(+(d>>>0)+4294967296.0*+(J|0));c=c+1|0}while(c>>>0<h>>>0);if((v|0)==10){v=$Xc(80)|0;f[g>>2]=v;f[g+8>>2]=-2147483568;f[g+4>>2]=70;k=v;l=454543;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[v+70>>0]=0;vM(-215,g,454614,454620,161)}n=+L(p)>=1.0?(p>0.0?~~+Z(+K(p/4294967296.0),4294967295.0)>>>0:~~+X((p-+(~~p>>>0))/4294967296.0)>>>0):0;o=~~p>>>0;J=n;u=e;return o|0}function qEb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[c>>2]|0;c=Y(f[b+48>>2]|0,(f[(f[d>>2]|0)+4>>2]|0)/((f[e+4>>2]|0)/(f[f[(f[b+4>>2]|0)+40>>2]>>2]|0)|0|0)|0)|0;rEb(a,Y(c,f[b+44>>2]|0)|0,Y(f[e+12>>2]|0,f[e+8>>2]|0)|0);return}function rEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[e>>2]=b;f[e+4>>2]=c;f[e+8>>2]=-1;f[e+12>>2]=-1;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;gOa(a,e,e+16|0);e=f[a>>2]|0;a=f[c>>2]|0;a:do if((e|0)==(a|0))g=e;else{b=e;do{if((f[b>>2]|0)<0){g=b;break a}b=b+4|0}while((b|0)!=(a|0));u=d;return}while(0);if((g|0)==(a|0)){u=d;return}e=g+4|0;if((e|0)==(a|0)){h=a;i=g}else{b=e;e=g;while(1){g=f[b>>2]|0;if((g|0)<0)j=e;else{f[e>>2]=g;j=e+4|0}b=b+4|0;if((b|0)==(a|0))break;else e=j}h=f[c>>2]|0;i=j}if((i|0)==(h|0)){u=d;return}f[c>>2]=h+(~((h+-4-i|0)>>>2)<<2);u=d;return}function sEb(a){a=a|0;cYc(a);return}function tEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=f[a+4>>2]|0;e=f[a+48>>2]|0;g=f[a+40>>2]|0;h=f[a+28>>2]|0;i=Y(h,g)|0;j=f[a+52>>2]|0;k=1-(Y(i,j)|0)|0;i=f[a+56>>2]|0;l=Y(k,i)|0;k=f[a+44>>2]|0;m=Y(i,j)|0;o=1-(Y(m,k)|0)|0;p=f[a+16>>2]|0;q=Y(p,f[a+12>>2]|0)|0;r=f[a+20>>2]|0;s=Y(q,r)|0;q=f[a+60>>2]|0;t=((q+-1+s|0)>>>0)/(q>>>0)|0;q=Y(f[c>>2]|0,t)|0;u=Y(f[c+4>>2]|0,t)|0;t=s>>>0<u>>>0?s:u;u=f[a+36>>2]|0;s=u+((q>>>0)%(r>>>0)|0)|0;c=f[a+32>>2]|0;v=c+((((q>>>0)/(r>>>0)|0)>>>0)%(p>>>0)|0)|0;w=Y(r,p)|0;x=(q>>>0)/(w>>>0)|0;y=f[a+24>>2]|0;if((v|0)<(y|0))z=0;else z=((v-y|0)/(g|0)|0)+1|0;A=((v|0)/(g|0)|0)+1|0;B=(b[a+64>>0]|0)==0;C=f[a+8>>2]|0;if(q>>>0>=t>>>0)return;a=Y((Y((Y(y,x)|0)+v|0,h)|0)+s|0,m)|0;v=u+r|0;D=s;s=q;q=x;x=z;z=a;a=(j|0)<(A|0)?j:A;while(1){if((D|0)<(h|0))E=0;else E=((D-h|0)/(k|0)|0)+1|0;A=((D|0)/(k|0)|0)+1|0;F=(i|0)<(A|0)?i:A;if(B)if((x|0)<(a|0)&(E|0)<(F|0)){A=x;G=0.0;while(1){H=(Y(l,A)|0)+z|0;I=E;J=G;do{K=d+(H+(Y(I,o)|0)<<2)|0;J=J+ +n[K>>2];I=I+1|0}while((I|0)<(F|0));A=A+1|0;if((A|0)==(a|0)){L=J;break}else G=J}}else L=0.0;else L=+n[e+(s<<2)>>2];n[e+(s<<2)>>2]=L+ +n[C+(q<<2)>>2];A=D+1|0;if((A|0)<(v|0)){M=A;N=q;O=x;P=z+m|0;Q=a;R=s+1|0}else{A=s+1|0;F=((A>>>0)%(r>>>0)|0)+u|0;I=c+((((A>>>0)/(r>>>0)|0)>>>0)%(p>>>0)|0)|0;H=(A>>>0)/(w>>>0)|0;if((I|0)<(y|0))S=0;else S=((I-y|0)/(g|0)|0)+1|0;K=((I|0)/(g|0)|0)+1|0;M=F;N=H;O=S;P=Y((Y((Y(y,H)|0)+I|0,h)|0)+F|0,m)|0;Q=(j|0)<(K|0)?j:K;R=A}if(R>>>0<t>>>0){D=M;s=R;q=N;x=O;z=P;a=Q}else break}return}function uEb(a){a=a|0;cYc(a);return}function vEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;c=f[a+8>>2]|0;d=f[c+12>>2]|0;e=f[a+16>>2]|0;g=((d+-1+e|0)/(e|0)|0)+15&-16;e=Y(g,f[b>>2]|0)|0;h=Y(f[b+4>>2]|0,g)|0;g=f[a+4>>2]|0;b=f[g+8>>2]|0;i=((d|0)<(h|0)?d:h)-e|0;h=f[g+12>>2]|0;d=f[g+16>>2]|0;j=(f[c+16>>2]|0)+(e<<2)|0;k=f[a+12>>2]|0;a=(f[k+16>>2]|0)+(e<<2)|0;e=((f[f[g+44>>2]>>2]|0)>>>0)/((675553809>>>(f[g>>2]<<2&28)&15)>>>0)|0;g=((f[f[c+44>>2]>>2]|0)>>>0)/((675553809>>>(f[c>>2]<<2&28)&15)>>>0)|0;c=((f[f[k+44>>2]>>2]|0)>>>0)/((675553809>>>(f[k>>2]<<2&28)&15)>>>0)|0;if((b|0)<=0)return;k=b+-1|0;b=(i|0)>0;l=k>>>1;m=(h|0)<1|b^1;o=0;p=0;while(1){q=a+((Y(o,c)|0)<<2)|0;r=o|1;s=(k|0)<(r|0)?k:r;r=a+((Y(s,c)|0)<<2)|0;t=d+((Y(o,e)|0)<<2)|0;u=d+((Y(s,e)|0)<<2)|0;if(b){s=0;do{n[q+(s<<2)>>2]=0.0;n[r+(s<<2)>>2]=0.0;s=s+1|0}while((s|0)<(i|0))}if(!m){s=0;do{v=+n[t+(s<<2)>>2];w=+n[u+(s<<2)>>2];x=j+((Y(s,g)|0)<<2)|0;y=s|1;if((y|0)<(h|0)){z=+n[t+(y<<2)>>2];A=+n[u+(y<<2)>>2];y=x+(g<<2)|0;B=s|2;if((B|0)<(h|0)){C=+n[t+(B<<2)>>2];D=+n[u+(B<<2)>>2];B=y+(g<<2)|0;E=s|3;if((E|0)<(h|0)){F=z;G=A;H=C;I=B+(g<<2)|0;J=B;K=y;L=D;M=+n[u+(E<<2)>>2];N=+n[t+(E<<2)>>2]}else{F=z;G=A;H=C;I=x;J=B;K=y;L=D;M=0.0;N=0.0}}else{F=z;G=A;H=0.0;I=x;J=x;K=y;L=0.0;M=0.0;N=0.0}}else{F=0.0;G=0.0;H=0.0;I=x;J=x;K=x;L=0.0;M=0.0;N=0.0}y=0;do{A=+n[x+(y<<2)>>2];z=+n[K+(y<<2)>>2];D=+n[J+(y<<2)>>2];C=+n[I+(y<<2)>>2];B=q+(y<<2)|0;E=r+(y<<2)|0;O=M*C+(L*D+(G*z+(w*A+ +n[E>>2])));n[B>>2]=N*C+(H*D+(F*z+(v*A+ +n[B>>2])));n[E>>2]=O;y=y+1|0}while((y|0)<(i|0));s=s+4|0}while((s|0)<(h|0))}if((p|0)==(l|0))break;else{o=o+2|0;p=p+1|0}}return}function wEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=u;u=u+16|0;d=a;lYc(d,c);c=d+11|0;e=b[c>>0]|0;g=e<<24>>24<0;h=f[d>>2]|0;i=d+4|0;j=f[i>>2]|0;k=g?h+j|0:d+(e&255)|0;l=g?h:d;if((l|0)==(k|0)){m=e;n=j}else{j=l;do{l=(OIc(b[j>>0]|0)|0)&255;b[j>>0]=l;j=j+1|0}while((j|0)!=(k|0));m=b[c>>0]|0;n=f[i>>2]|0}if(((m<<24>>24<0?n:m&255)|0)==1){n=(LYc(d,0,-1,453859,1)|0)!=0;o=n;p=b[c>>0]|0}else{o=1;p=m}if(p<<24>>24>=0){q=o<<31>>31;u=a;return q|0}cYc(f[d>>2]|0);q=o<<31>>31;u=a;return q|0}function xEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;a=u;u=u+16|0;d=a;lYc(d,c);e=d+11|0;g=b[e>>0]|0;h=g<<24>>24<0;i=f[d>>2]|0;j=d+4|0;k=f[j>>2]|0;l=h?i+k|0:d+(g&255)|0;m=h?i:d;if((m|0)==(l|0)){n=g;o=k}else{k=m;do{m=(OIc(b[k>>0]|0)|0)&255;b[k>>0]=m;k=k+1|0}while((k|0)!=(l|0));n=b[e>>0]|0;o=f[j>>2]|0}if(((n<<24>>24<0?o:n&255)|0)==1){o=(LYc(d,0,-1,453855,1)|0)==0;p=o;q=b[e>>0]|0}else{p=0;q=n}if(q<<24>>24<0)cYc(f[d>>2]|0);if(p){r=0;u=a;return r|0}lYc(d,c);c=d+11|0;p=b[c>>0]|0;q=p<<24>>24<0;n=f[d>>2]|0;e=d+4|0;o=f[e>>2]|0;j=q?n+o|0:d+(p&255)|0;l=q?n:d;if((l|0)==(j|0)){s=p;t=o}else{o=l;do{l=(OIc(b[o>>0]|0)|0)&255;b[o>>0]=l;o=o+1|0}while((o|0)!=(j|0));s=b[c>>0]|0;t=f[e>>2]|0}if(((s<<24>>24<0?t:s&255)|0)==1){t=(LYc(d,0,-1,453857,1)|0)==0;v=t?1:-1;w=b[c>>0]|0}else{v=-1;w=s}if(w<<24>>24<0)cYc(f[d>>2]|0);r=v;u=a;return r|0}function yEb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(96)|0;zEb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=108224;f[b+12>>2]=c;f[a+4>>2]=b;return}function zEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;d=u;u=u+64|0;e=d;qQa(a);f[a>>2]=108252;f[a+44>>2]=0;f[a+48>>2]=0;g=a+56|0;h=a+60|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;rQa(a,c);i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;do if((j|0)!=(l|0)){if(((l-j|0)/56|0)>>>0<=2){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=17;o=m;p=454050;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+17>>0]=0;vM(-215,e,454068,454082,105)}g0(e,j+112|0,1,1);r=f[i>>2]|0;s=r+112|0;if((s|0)==(e|0)){t=e+36|0;v=f[t>>2]|0;if((v|0)!=0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0){V$(e);x=t}else x=t}else{t=r+148|0;v=f[t>>2]|0;if(v|0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0)V$(s);f[t>>2]=0;v=r+128|0;w=r+116|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){y=f[r+152>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[w>>2]|0))}f[s>>2]=f[e>>2];z=e+4|0;y=f[z>>2]|0;f[w>>2]=y;m=e+8|0;A=r+120|0;f[A>>2]=f[m>>2];f[r+124>>2]=f[e+12>>2];f[v>>2]=f[e+16>>2];f[r+132>>2]=f[e+20>>2];f[r+136>>2]=f[e+24>>2];f[r+140>>2]=f[e+28>>2];f[r+144>>2]=f[e+32>>2];B=e+36|0;f[t>>2]=f[B>>2];C=r+156|0;D=f[C>>2]|0;E=r+160|0;if((D|0)==(E|0)){F=y;G=D}else{wL(D);f[C>>2]=E;f[r+152>>2]=A;F=f[z>>2]|0;G=E}E=e+44|0;if((F|0)<3){A=f[E>>2]|0;f[G>>2]=f[A>>2];f[G+4>>2]=f[A+4>>2]}else{f[C>>2]=f[E>>2];C=e+40|0;f[r+152>>2]=f[C>>2];f[E>>2]=e+48;f[C>>2]=m}f[e>>2]=1124007936;o=z;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));x=B}f[x>>2]=0;r=e+16|0;t=e+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[t>>2]|0)>0){r=f[e+40>>2]|0;v=0;do{f[r+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[t>>2]|0))}t=f[e+44>>2]|0;if((t|0)!=(e+48|0))wL(t);t=f[i>>2]|0;v=t;if((f[t+4>>2]|0)!=2){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;H=$Xc(32)|0;f[e>>2]=H;I=e+8|0;f[I>>2]=-2147483616;K=e+4|0;f[K>>2]=28;o=H;p=454166;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));L=H+28|0;b[L>>0]=0;vM(-215,e,454068,454082,112)}if((f[t+60>>2]|0)!=2){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;H=$Xc(32)|0;f[e>>2]=H;I=e+8|0;f[I>>2]=-2147483616;K=e+4|0;f[K>>2]=28;o=H;p=454166;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));L=H+28|0;b[L>>0]=0;vM(-215,e,454068,454082,112)}r=f[t+8>>2]|0;if((r|0)!=(f[t+64>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;B=$Xc(32)|0;f[e>>2]=B;f[e+8>>2]=-2147483616;f[e+4>>2]=18;o=B;p=454195;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[B+18>>0]=0;vM(-215,e,454068,454082,113)}w=f[t+12>>2]|0;if((r|0)!=(w<<2|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;s=$Xc(32)|0;f[e>>2]=s;f[e+8>>2]=-2147483616;f[e+4>>2]=20;o=s;p=454214;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[s+20>>0]=0;vM(-215,e,454068,454082,114)}B=f[t+116>>2]|0;if((B|0)<3)M=Y(f[t+124>>2]|0,f[t+120>>2]|0)|0;else{z=f[t+152>>2]|0;m=0;C=1;while(1){E=Y(f[z+(m<<2)>>2]|0,C)|0;m=m+1|0;if((m|0)==(B|0)){M=E;break}else C=E}}if((r|0)!=(M|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;C=$Xc(32)|0;f[e>>2]=C;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=C;p=454235;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[C+28>>0]=0;vM(-215,e,454068,454082,115)}r=f[t>>2]&4095;if((r|0)!=(f[t+56>>2]&4095|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;N=$Xc(64)|0;f[e>>2]=N;O=e+8|0;f[O>>2]=-2147483584;P=e+4|0;f[P>>2]=50;o=N;p=454264;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Q=N+50|0;b[Q>>0]=0;vM(-215,e,454068,454082,116)}C=f[t+112>>2]|0;if((r|0)!=(C&4095|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;N=$Xc(64)|0;f[e>>2]=N;O=e+8|0;f[O>>2]=-2147483584;P=e+4|0;f[P>>2]=50;o=N;p=454264;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Q=N+50|0;b[Q>>0]=0;vM(-215,e,454068,454082,116)}r=(f[k>>2]|0)-v|0;if(((r|0)/56|0)>>>0>3){if((r|0)!=336){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=$Xc(32)|0;f[e>>2]=r;f[e+8>>2]=-2147483616;f[e+4>>2]=17;o=r;p=454315;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[r+17>>0]=0;vM(-215,e,454068,454082,121)}if((f[t+176>>2]|0)!=(w|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(48)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483600;T=e+4|0;f[T>>2]=40;o=R;p=454333;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));U=R+40|0;b[U>>0]=0;vM(-215,e,454068,454082,125)}if((f[t+180>>2]|0)!=(w|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(48)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483600;T=e+4|0;f[T>>2]=40;o=R;p=454333;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));U=R+40|0;b[U>>0]=0;vM(-215,e,454068,454082,125)}if((C^f[t+168>>2])&4095|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;V=$Xc(32)|0;f[e>>2]=V;W=e+8|0;f[W>>2]=-2147483616;X=e+4|0;f[X>>2]=30;o=V;p=454374;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Z=V+30|0;b[Z>>0]=0;vM(-215,e,454068,454082,126)}if((f[t+232>>2]|0)!=(w|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(48)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483600;T=e+4|0;f[T>>2]=40;o=R;p=454333;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));U=R+40|0;b[U>>0]=0;vM(-215,e,454068,454082,125)}if((f[t+236>>2]|0)!=(w|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(48)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483600;T=e+4|0;f[T>>2]=40;o=R;p=454333;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));U=R+40|0;b[U>>0]=0;vM(-215,e,454068,454082,125)}if((C^f[t+224>>2])&4095|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;V=$Xc(32)|0;f[e>>2]=V;W=e+8|0;f[W>>2]=-2147483616;X=e+4|0;f[X>>2]=30;o=V;p=454374;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Z=V+30|0;b[Z>>0]=0;vM(-215,e,454068,454082,126)}if((f[t+288>>2]|0)!=(w|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(48)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483600;T=e+4|0;f[T>>2]=40;o=R;p=454333;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));U=R+40|0;b[U>>0]=0;vM(-215,e,454068,454082,125)}if((f[t+292>>2]|0)!=(w|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(48)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483600;T=e+4|0;f[T>>2]=40;o=R;p=454333;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));U=R+40|0;b[U>>0]=0;vM(-215,e,454068,454082,125)}if(!((C^f[t+280>>2])&4095))break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;V=$Xc(32)|0;f[e>>2]=V;W=e+8|0;f[W>>2]=-2147483616;X=e+4|0;f[X>>2]=30;o=V;p=454374;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));Z=V+30|0;b[Z>>0]=0;vM(-215,e,454068,454082,126)}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Z=$Xc(32)|0;f[e>>2]=Z;f[e+8>>2]=-2147483616;f[e+4>>2]=17;o=Z;p=454405;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[Z+17>>0]=0;Z=LGa(c,e)|0;V=c+4|0;if((Z|0)==(V|0))_=1;else{X=MGa(Z+28|0,-1)|0;_=(X|0)!=0|(J|0)!=0}b[a+80>>0]=_&1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;_=$Xc(32)|0;f[e>>2]=_;f[e+8>>2]=-2147483616;f[e+4>>2]=19;o=_;p=454423;q=o+19|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[_+19>>0]=0;_=LGa(c,e)|0;if((_|0)==(V|0))$=0;else{X=MGa(_+28|0,-1)|0;$=(X|0)!=0|(J|0)!=0}b[a+81>>0]=$&1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(16)|0;f[e>>2]=$;f[e+8>>2]=-2147483632;f[e+4>>2]=11;o=$;p=454443;q=o+11|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[$+11>>0]=0;$=LGa(c,e)|0;if(($|0)==(V|0))aa=0.0;else aa=+NGa($+28|0,-1);n[a+84>>2]=aa;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=e+11|0;b[$>>0]=9;o=e;p=454455;q=o+9|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[e+9>>0]=0;X=LGa(c,e)|0;if((X|0)==(V|0))ba=0.0;else ba=+NGa(X+28|0,-1);n[a+88>>2]=ba;if((b[$>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(16)|0;f[e>>2]=$;f[e+8>>2]=-2147483632;f[e+4>>2]=13;o=$;p=454465;q=o+13|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[$+13>>0]=0;$=LGa(c,e)|0;if(($|0)==(V|0))ca=0;else{X=MGa($+28|0,-1)|0;ca=((X|0)!=0|(J|0)!=0)&1}b[a+92>>0]=ca;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ca=$Xc(16)|0;f[e>>2]=ca;f[e+8>>2]=-2147483632;f[e+4>>2]=12;o=ca;p=454479;q=o+12|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[ca+12>>0]=0;ca=LGa(c,e)|0;if((ca|0)==(V|0))da=0;else{V=MGa(ca+28|0,-1)|0;da=((V|0)!=0|(J|0)!=0)&1}b[a+93>>0]=da;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);b[a+52>>0]=0;a=f[g>>2]|0;g=f[h>>2]|0;if((g|0)==(a|0)){u=d;return}f[h>>2]=g+(~((g+-4-a|0)>>>2)<<2);u=d;return}function AEb(a){a=a|0;NXc(a);cYc(a);return}function BEb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function CEb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==453897?a+12|0:0)|0}function DEb(a){a=a|0;cYc(a);return}function EEb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=108252;b=f[a+68>>2]|0;if(b|0){c=a+72|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+56>>2]|0;if(!b){MNa(a);return}d=a+60|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b);MNa(a);return}function FEb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=108252;b=f[a+68>>2]|0;if(b|0){c=a+72|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+56>>2]|0;if(!b){MNa(a);cYc(a);return}d=a+60|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b);MNa(a);cYc(a);return}function GEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=u;u=u+48|0;e=d+36|0;g=d+32|0;h=d+28|0;i=d+16|0;j=d;k=d+12|0;l=d+8|0;m=d+4|0;f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;gS(c,i);if(!(b[a+93>>0]|0)){c=f[a+4>>2]|0;if(((f[a+8>>2]|0)-c|0)==168)o=c;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=$Xc(80)|0;f[e>>2]=p;q=e+8|0;f[q>>2]=-2147483568;r=e+4|0;f[r>>2]=73;s=p;t=454789;v=s+73|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+73|0;b[w>>0]=0;vM(-215,e,455619,454082,224)}}else{c=f[a+4>>2]|0;if(((f[a+8>>2]|0)-c|0)==336)o=c;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=$Xc(80)|0;f[e>>2]=p;q=e+8|0;f[q>>2]=-2147483568;r=e+4|0;f[r>>2]=73;s=p;t=454789;v=s+73|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+73|0;b[w>>0]=0;vM(-215,e,455619,454082,224)}}w=o;o=f[i>>2]|0;p=o;if(((f[n>>2]|0)-o|0)!=56){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=17;s=o;t=455036;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[o+17>>0]=0;vM(-215,e,455619,454082,225)}o=f[(f[w+40>>2]|0)+4>>2]|0;f[j>>2]=o;n=f[(f[w+96>>2]|0)+4>>2]|0;w=a+56|0;r=f[w>>2]|0;q=a+60|0;c=f[q>>2]|0;if((r|0)!=(c|0)){x=c-r|0;c=x>>2;if((x|0)<0){y=$Xc(80)|0;f[e>>2]=y;f[e+8>>2]=-2147483568;f[e+4>>2]=70;s=y;t=454543;v=s+70|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[y+70>>0]=0;vM(-215,e,454614,454620,161)}if(!x)z=1;else{x=0;y=1;while(1){A=Y(f[r+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(c|0)){z=A;break}else y=A}}if((z|0)!=(o|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=29;s=o;t=455054;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[o+29>>0]=0;vM(-215,e,455619,454082,233)}}else YMa(w,1,j);j=f[p+4>>2]|0;o=(j|0)>1;do if(!(b[a+80>>0]|0)){if(!o){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;B=$Xc(48)|0;f[e>>2]=B;C=e+8|0;f[C>>2]=-2147483600;D=e+4|0;f[D>>2]=46;s=B;t=455131;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));E=B+46|0;b[E>>0]=0;vM(-215,e,455619,454082,245)}z=f[p+40>>2]|0;y=1;c=1;do{y=Y(f[z+(c<<2)>>2]|0,y)|0;c=c+1|0}while((c|0)!=(j|0));if((y|0)==(n|0)){F=1;G=0;H=z}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;B=$Xc(48)|0;f[e>>2]=B;C=e+8|0;f[C>>2]=-2147483600;D=e+4|0;f[D>>2]=46;s=B;t=455131;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));E=B+46|0;b[E>>0]=0;vM(-215,e,455619,454082,245)}}else{if(!o){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;I=$Xc(48)|0;f[e>>2]=I;J=e+8|0;f[J>>2]=-2147483600;K=e+4|0;f[K>>2]=46;s=I;t=455084;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));L=I+46|0;b[L>>0]=0;vM(-215,e,455619,454082,239)}if((j|0)==2)M=1;else{z=f[p+40>>2]|0;y=1;c=2;while(1){x=Y(f[z+(c<<2)>>2]|0,y)|0;c=c+1|0;if((c|0)>=(j|0)){M=x;break}else y=x}}if((M|0)==(n|0)){y=f[p+40>>2]|0;F=f[y>>2]|0;G=1;H=y;break}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;I=$Xc(48)|0;f[e>>2]=I;J=e+8|0;f[J>>2]=-2147483600;K=e+4|0;f[K>>2]=46;s=I;t=455084;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));L=I+46|0;b[L>>0]=0;vM(-215,e,455619,454082,239)}}while(0);f[a+44>>2]=F;F=f[H+(G<<2)>>2]|0;G=a+48|0;f[G>>2]=F;H=a+68|0;L=f[H>>2]|0;I=a+72|0;t=f[I>>2]|0;if((t|0)==(L|0))N=L;else{s=t+(~((t+-4-L|0)>>>2)<<2)|0;f[I>>2]=s;N=s}if((N|0)==(f[a+76>>2]|0)){Tv(H,G);O=f[I>>2]|0;f[k>>2]=O;P=f[w>>2]|0;f[l>>2]=P;Q=f[q>>2]|0;f[m>>2]=Q;f[h>>2]=f[k>>2];f[g>>2]=f[l>>2];f[e>>2]=f[m>>2];fEa(H,h,g,e)|0;R=a+52|0;b[R>>0]=1;hx(i);u=d;return}else{f[N>>2]=F;F=N+4|0;f[I>>2]=F;O=F;f[k>>2]=O;P=f[w>>2]|0;f[l>>2]=P;Q=f[q>>2]|0;f[m>>2]=Q;f[h>>2]=f[k>>2];f[g>>2]=f[l>>2];f[e>>2]=f[m>>2];fEa(H,h,g,e)|0;R=a+52|0;b[R>>0]=1;hx(i);u=d;return}}function HEb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0.0;g=u;u=u+848|0;h=g+824|0;i=g+56|0;j=g+808|0;k=g+796|0;l=g+784|0;m=g+728|0;o=g+672|0;q=g+616|0;r=g+560|0;s=g+504|0;t=g+448|0;v=g+392|0;w=g+384|0;x=g+328|0;y=g+272|0;z=g+216|0;A=g+160|0;B=g+104|0;C=g;D=g+88|0;E=g+72|0;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;gS(c,j);gS(d,k);gS(e,l);e=a+4|0;d=f[e>>2]|0;c=d+56|0;F=d+112|0;G=f[(f[d+40>>2]|0)+4>>2]|0;H=f[l>>2]|0;f[m>>2]=f[H>>2];I=m+4|0;J=H+4|0;f[I>>2]=f[J>>2];K=m+8|0;f[K>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];L=m+16|0;f[L>>2]=f[H+16>>2];f[m+20>>2]=f[H+20>>2];f[m+24>>2]=f[H+24>>2];f[m+28>>2]=f[H+28>>2];f[m+32>>2]=f[H+32>>2];M=m+36|0;N=f[H+36>>2]|0;f[M>>2]=N;O=m+40|0;f[O>>2]=K;K=m+48|0;P=m+44|0;f[P>>2]=K;f[K>>2]=0;f[m+52>>2]=0;if(N|0){Q=N+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[J>>2]|0)<3){J=f[H+44>>2]|0;Q=f[P>>2]|0;f[Q>>2]=f[J>>2];f[Q+4>>2]=f[J+4>>2]}else{f[I>>2]=0;U$(m,H)}H=f[l>>2]|0;J=H+56|0;f[o>>2]=f[J>>2];Q=o+4|0;N=H+60|0;R=f[N>>2]|0;f[Q>>2]=R;S=o+8|0;f[S>>2]=f[H+64>>2];f[o+12>>2]=f[H+68>>2];T=o+16|0;f[T>>2]=f[H+72>>2];f[o+20>>2]=f[H+76>>2];f[o+24>>2]=f[H+80>>2];f[o+28>>2]=f[H+84>>2];f[o+32>>2]=f[H+88>>2];U=o+36|0;V=f[H+92>>2]|0;f[U>>2]=V;W=o+40|0;f[W>>2]=S;S=o+48|0;X=o+44|0;f[X>>2]=S;f[S>>2]=0;f[o+52>>2]=0;if(!V)Z=R;else{R=V+12|0;f[R>>2]=(f[R>>2]|0)+1;Z=f[N>>2]|0}if((Z|0)<3){Z=f[H+100>>2]|0;H=f[X>>2]|0;f[H>>2]=f[Z>>2];f[H+4>>2]=f[Z+4>>2]}else{f[Q>>2]=0;U$(o,J)}J=f[l>>2]|0;Z=J+112|0;f[q>>2]=f[Z>>2];H=q+4|0;N=J+116|0;R=f[N>>2]|0;f[H>>2]=R;V=q+8|0;f[V>>2]=f[J+120>>2];f[q+12>>2]=f[J+124>>2];_=q+16|0;f[_>>2]=f[J+128>>2];f[q+20>>2]=f[J+132>>2];f[q+24>>2]=f[J+136>>2];f[q+28>>2]=f[J+140>>2];f[q+32>>2]=f[J+144>>2];$=q+36|0;aa=f[J+148>>2]|0;f[$>>2]=aa;ba=q+40|0;f[ba>>2]=V;V=q+48|0;ca=q+44|0;f[ca>>2]=V;f[V>>2]=0;f[q+52>>2]=0;if(!aa)da=R;else{R=aa+12|0;f[R>>2]=(f[R>>2]|0)+1;da=f[N>>2]|0}if((da|0)<3){da=f[J+156>>2]|0;J=f[ca>>2]|0;f[J>>2]=f[da>>2];f[J+4>>2]=f[da+4>>2]}else{f[H>>2]=0;U$(q,Z)}Z=f[l>>2]|0;da=Z+168|0;f[r>>2]=f[da>>2];J=r+4|0;N=Z+172|0;R=f[N>>2]|0;f[J>>2]=R;aa=r+8|0;f[aa>>2]=f[Z+176>>2];f[r+12>>2]=f[Z+180>>2];ea=r+16|0;f[ea>>2]=f[Z+184>>2];f[r+20>>2]=f[Z+188>>2];f[r+24>>2]=f[Z+192>>2];f[r+28>>2]=f[Z+196>>2];f[r+32>>2]=f[Z+200>>2];fa=r+36|0;ga=f[Z+204>>2]|0;f[fa>>2]=ga;ha=r+40|0;f[ha>>2]=aa;aa=r+48|0;ia=r+44|0;f[ia>>2]=aa;f[aa>>2]=0;f[r+52>>2]=0;if(!ga)ja=R;else{R=ga+12|0;f[R>>2]=(f[R>>2]|0)+1;ja=f[N>>2]|0}if((ja|0)<3){ja=f[Z+212>>2]|0;Z=f[ia>>2]|0;f[Z>>2]=f[ja>>2];f[Z+4>>2]=f[ja+4>>2]}else{f[J>>2]=0;U$(r,da)}p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;mR(m,h,fT()|0)|0;p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;mR(o,h,fT()|0)|0;p[i>>3]=1.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;mR(q,h,fT()|0)|0;da=a+44|0;ja=a+48|0;Z=Y(f[ja>>2]|0,f[da>>2]|0)|0;g0(s,f[j>>2]|0,1,Z);g0(t,f[k>>2]|0,1,Z);N=a+81|0;if(!(b[N>>0]|0)){f[v>>2]=1124007936;R=v+8|0;ga=v+40|0;ka=v+4|0;la=ka+36|0;do{f[ka>>2]=0;ka=ka+4|0}while((ka|0)<(la|0));f[ga>>2]=R;R=v+48|0;f[v+44>>2]=R;f[R>>2]=0;f[v+52>>2]=0}else g0(v,(f[k>>2]|0)+56|0,1,Z);if((f[da>>2]|0)>0){Z=w+4|0;R=h+4|0;ga=h+8|0;ka=h+12|0;la=h+4|0;ma=i+8|0;na=i+12|0;oa=i+4|0;pa=y+8|0;qa=y+12|0;ra=y+4|0;sa=z+8|0;ta=z+4|0;ua=h+8|0;va=h+12|0;wa=h+4|0;xa=i+8|0;ya=i+12|0;za=i+4|0;Aa=y+8|0;Ba=y+12|0;Ca=y+4|0;Da=z+8|0;Ea=z+4|0;Fa=h+8|0;Ga=h+12|0;Ha=h+4|0;Ia=i+8|0;Ja=i+12|0;Ka=i+4|0;La=y+8|0;Ma=y+12|0;Na=y+4|0;Oa=z+8|0;Pa=z+4|0;Qa=h+4|0;Ra=i+4|0;Sa=G<<1;Ta=h+4|0;Ua=i+4|0;Va=G*3|0;Wa=h+4|0;Xa=i+4|0;Ya=G<<2;Za=h+4|0;_a=i+4|0;$a=a+84|0;ab=h+8|0;bb=h+12|0;cb=h+4|0;db=i+8|0;eb=i+12|0;fb=i+4|0;gb=D+8|0;hb=D+4|0;ib=a+93|0;jb=h+4|0;kb=i+4|0;lb=C+36|0;mb=C+16|0;nb=C+4|0;ob=C+40|0;pb=C+44|0;qb=C+48|0;rb=h+8|0;sb=h+12|0;tb=h+4|0;ub=i+8|0;vb=i+12|0;wb=i+4|0;xb=C+8|0;yb=C+4|0;zb=h+8|0;Ab=h+12|0;Bb=h+4|0;Cb=i+8|0;Db=i+12|0;Eb=i+4|0;Fb=C+8|0;Gb=C+4|0;Hb=h+8|0;Ib=h+12|0;Jb=h+4|0;Kb=i+8|0;Lb=i+12|0;Mb=i+4|0;Nb=C+8|0;Ob=C+4|0;Pb=a+92|0;Qb=h+8|0;Rb=h+12|0;Sb=h+4|0;Tb=i+8|0;Ub=i+12|0;Vb=i+4|0;Wb=C+8|0;Xb=C+4|0;Yb=h+4|0;Zb=i+8|0;_b=i+4|0;$b=C+36|0;ac=C+16|0;bc=C+4|0;cc=C+40|0;dc=C+44|0;ec=C+48|0;fc=B+36|0;gc=B+16|0;hc=B+4|0;ic=B+40|0;jc=B+44|0;kc=B+48|0;lc=A+36|0;mc=A+16|0;nc=A+4|0;oc=A+40|0;pc=A+44|0;qc=A+48|0;rc=z+36|0;sc=z+16|0;tc=z+4|0;uc=z+40|0;vc=z+44|0;wc=z+48|0;xc=y+36|0;yc=y+16|0;zc=y+4|0;Ac=y+40|0;Bc=y+44|0;Cc=y+48|0;Dc=x+36|0;Ec=x+16|0;Fc=x+4|0;Gc=x+40|0;Hc=x+44|0;Ic=x+48|0;Jc=h+4|0;Kc=i+8|0;Lc=i+4|0;Mc=C+36|0;Nc=C+16|0;Oc=C+4|0;Pc=C+40|0;Qc=C+44|0;Rc=C+48|0;Sc=h+8|0;Tc=h+12|0;Uc=h+4|0;Vc=i+8|0;Wc=i+12|0;Xc=i+4|0;Yc=C+8|0;Zc=C+12|0;_c=C+4|0;$c=D+8|0;ad=D+4|0;bd=h+8|0;cd=h+12|0;dd=h+4|0;ed=a+88|0;a=i+8|0;fd=i+12|0;gd=i+4|0;hd=D+8|0;id=D+4|0;jd=h+8|0;kd=h+12|0;ld=h+4|0;md=i+8|0;nd=i+12|0;od=i+4|0;pd=D+8|0;qd=D+4|0;rd=h+4|0;sd=i+4|0;td=h+8|0;ud=h+12|0;vd=h+4|0;wd=i+8|0;xd=i+12|0;yd=i+4|0;zd=D+8|0;Ad=D+12|0;Bd=D+4|0;Cd=E+8|0;Dd=E+4|0;Ed=h+8|0;Fd=h+12|0;Gd=h+4|0;Hd=i+8|0;Id=i+12|0;Jd=i+4|0;Kd=D+8|0;Ld=D+12|0;Md=D+4|0;Nd=E+8|0;Od=E+4|0;Pd=C+36|0;Qd=C+16|0;Rd=C+4|0;Sd=C+40|0;Td=C+44|0;Ud=C+48|0;Vd=0;do{Wd=f[ja>>2]|0;Xd=Y(Wd,Vd)|0;Vd=Vd+1|0;Yd=Y(Wd,Vd)|0;f[w>>2]=Xd;f[Z>>2]=Yd;f[h>>2]=-2147483648;f[R>>2]=2147483647;W$(x,s,w,h);f[ga>>2]=0;f[ka>>2]=0;f[h>>2]=16842752;f[la>>2]=x;f[ma>>2]=0;f[na>>2]=0;f[i>>2]=16842752;f[oa>>2]=c;f[pa>>2]=0;f[qa>>2]=0;f[y>>2]=16842752;f[ra>>2]=r;Yd=sa;f[Yd>>2]=0;f[Yd+4>>2]=0;f[z>>2]=33619968;f[ta>>2]=r;AY(h,i,1.0,y,0.0,z,2);f[ua>>2]=0;f[va>>2]=0;f[h>>2]=16842752;f[wa>>2]=m;f[xa>>2]=0;f[ya>>2]=0;f[i>>2]=16842752;f[za>>2]=d;f[Aa>>2]=0;f[Ba>>2]=0;f[y>>2]=16842752;f[Ca>>2]=r;Yd=Da;f[Yd>>2]=0;f[Yd+4>>2]=0;f[z>>2]=33619968;f[Ea>>2]=r;AY(h,i,1.0,y,1.0,z,2);f[Fa>>2]=0;f[Ga>>2]=0;f[h>>2]=16842752;f[Ha>>2]=q;f[Ia>>2]=0;f[Ja>>2]=0;f[i>>2]=16842752;f[Ka>>2]=F;f[La>>2]=0;f[Ma>>2]=0;f[y>>2]=16842752;f[Na>>2]=r;Yd=Oa;f[Yd>>2]=0;f[Yd+4>>2]=0;f[z>>2]=33619968;f[Pa>>2]=r;AY(h,i,1.0,y,1.0,z,0);f[h>>2]=-2147483648;f[Qa>>2]=2147483647;f[i>>2]=0;f[Ra>>2]=G;W$(y,r,h,i);f[h>>2]=-2147483648;f[Ta>>2]=2147483647;f[i>>2]=G;f[Ua>>2]=Sa;W$(z,r,h,i);f[h>>2]=-2147483648;f[Wa>>2]=2147483647;f[i>>2]=Sa;f[Xa>>2]=Va;W$(A,r,h,i);f[h>>2]=-2147483648;f[Za>>2]=2147483647;f[i>>2]=Va;f[_a>>2]=Ya;W$(B,r,h,i);Zd=+n[$a>>2];if(Zd!=0.0){f[ab>>2]=0;f[bb>>2]=0;f[h>>2]=16842752;f[cb>>2]=z;p[C>>3]=Zd;f[i>>2]=-1056833530;f[fb>>2]=C;f[db>>2]=1;f[eb>>2]=1;Yd=gb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[hb>>2]=z;E1(h,i,D,fT()|0,-1)}if(!(b[ib>>0]|0)){f[h>>2]=-2147483648;f[jb>>2]=2147483647;f[i>>2]=0;f[kb>>2]=Va;W$(C,r,h,i);NEb(C,C);Yd=f[lb>>2]|0;if(Yd|0?(Xd=Yd+12|0,Yd=f[Xd>>2]|0,f[Xd>>2]=Yd+-1,(Yd|0)==1):0)V$(C);f[lb>>2]=0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[nb>>2]|0)>0){Yd=f[ob>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[nb>>2]|0))}Xd=f[pb>>2]|0;if((Xd|0)!=(qb|0))wL(Xd)}else{f[h>>2]=-2147483648;f[rd>>2]=2147483647;f[i>>2]=0;f[sd>>2]=Sa;W$(C,r,h,i);f[td>>2]=0;f[ud>>2]=0;f[h>>2]=16842752;f[vd>>2]=o;Xd=(f[e>>2]|0)+168|0;f[wd>>2]=0;f[xd>>2]=0;f[i>>2]=16842752;f[yd>>2]=Xd;f[zd>>2]=0;f[Ad>>2]=0;f[D>>2]=16842752;f[Bd>>2]=y;Xd=Cd;f[Xd>>2]=0;f[Xd+4>>2]=0;f[E>>2]=33619968;f[Dd>>2]=y;AY(h,i,1.0,D,1.0,E,0);f[Ed>>2]=0;f[Fd>>2]=0;f[h>>2]=16842752;f[Gd>>2]=o;Xd=(f[e>>2]|0)+224|0;f[Hd>>2]=0;f[Id>>2]=0;f[i>>2]=16842752;f[Jd>>2]=Xd;f[Kd>>2]=0;f[Ld>>2]=0;f[D>>2]=16842752;f[Md>>2]=z;Xd=Nd;f[Xd>>2]=0;f[Xd+4>>2]=0;f[E>>2]=33619968;f[Od>>2]=z;AY(h,i,1.0,D,1.0,E,0);NEb(C,C);Xd=f[Pd>>2]|0;if(Xd|0?(Yd=Xd+12|0,Xd=f[Yd>>2]|0,f[Yd>>2]=Xd+-1,(Xd|0)==1):0)V$(C);f[Pd>>2]=0;f[Qd>>2]=0;f[Qd+4>>2]=0;f[Qd+8>>2]=0;f[Qd+12>>2]=0;if((f[Rd>>2]|0)>0){Xd=f[Sd>>2]|0;Yd=0;do{f[Xd+(Yd<<2)>>2]=0;Yd=Yd+1|0}while((Yd|0)<(f[Rd>>2]|0))}Yd=f[Td>>2]|0;if((Yd|0)!=(Ud|0))wL(Yd)}OEb(B,B);f[rb>>2]=0;f[sb>>2]=0;f[h>>2]=16842752;f[tb>>2]=z;f[ub>>2]=0;f[vb>>2]=0;f[i>>2]=16842752;f[wb>>2]=o;Yd=xb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[yb>>2]=z;I1(h,i,C,1.0,-1);f[zb>>2]=0;f[Ab>>2]=0;f[h>>2]=16842752;f[Bb>>2]=y;f[Cb>>2]=0;f[Db>>2]=0;f[i>>2]=16842752;f[Eb>>2]=B;Yd=Fb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[Gb>>2]=y;I1(h,i,C,1.0,-1);f[Hb>>2]=0;f[Ib>>2]=0;f[h>>2]=16842752;f[Jb>>2]=z;f[Kb>>2]=0;f[Lb>>2]=0;f[i>>2]=16842752;f[Mb>>2]=y;Yd=Nb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[Ob>>2]=o;E1(h,i,C,fT()|0,-1);if(b[Pb>>0]|0){f[bd>>2]=0;f[cd>>2]=0;f[h>>2]=16842752;f[dd>>2]=o;p[C>>3]=+n[ed>>2];f[i>>2]=-1056833530;f[gd>>2]=C;f[a>>2]=1;f[fd>>2]=1;Yd=hd;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[id>>2]=o;B1(h,i,D);f[jd>>2]=0;f[kd>>2]=0;f[h>>2]=16842752;f[ld>>2]=o;p[C>>3]=-+n[ed>>2];f[i>>2]=-1056833530;f[od>>2]=C;f[md>>2]=1;f[nd>>2]=1;Yd=pd;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[qd>>2]=o;A1(h,i,D)}if(b[ib>>0]|0){f[Sc>>2]=0;f[Tc>>2]=0;f[h>>2]=16842752;f[Uc>>2]=o;Yd=(f[e>>2]|0)+280|0;f[Vc>>2]=0;f[Wc>>2]=0;f[i>>2]=16842752;f[Xc>>2]=Yd;f[Yc>>2]=0;f[Zc>>2]=0;f[C>>2]=16842752;f[_c>>2]=A;Yd=$c;f[Yd>>2]=0;f[Yd+4>>2]=0;f[D>>2]=33619968;f[ad>>2]=A;AY(h,i,1.0,C,1.0,D,0);NEb(A,A)}OEb(o,m);f[Qb>>2]=0;f[Rb>>2]=0;f[h>>2]=16842752;f[Sb>>2]=A;f[Tb>>2]=0;f[Ub>>2]=0;f[i>>2]=16842752;f[Vb>>2]=m;Yd=Wb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[C>>2]=33619968;f[Xb>>2]=m;I1(h,i,C,1.0,-1);f[h>>2]=-2147483648;f[Yb>>2]=2147483647;W$(C,t,w,h);Yd=Zb;f[Yd>>2]=0;f[Yd+4>>2]=0;f[i>>2]=-1040121856;f[_b>>2]=C;jR(m,i);Yd=f[$b>>2]|0;if(Yd|0?(Xd=Yd+12|0,Yd=f[Xd>>2]|0,f[Xd>>2]=Yd+-1,(Yd|0)==1):0)V$(C);f[$b>>2]=0;f[ac>>2]=0;f[ac+4>>2]=0;f[ac+8>>2]=0;f[ac+12>>2]=0;if((f[bc>>2]|0)>0){Yd=f[cc>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[bc>>2]|0))}Xd=f[dc>>2]|0;if((Xd|0)!=(ec|0))wL(Xd);if(b[N>>0]|0){f[h>>2]=-2147483648;f[Jc>>2]=2147483647;W$(C,v,w,h);Xd=Kc;f[Xd>>2]=0;f[Xd+4>>2]=0;f[i>>2]=-1040121856;f[Lc>>2]=C;jR(o,i);Xd=f[Mc>>2]|0;do if(Xd|0){Yd=Xd+12|0;Wd=f[Yd>>2]|0;f[Yd>>2]=Wd+-1;if((Wd|0)!=1)break;V$(C)}while(0);f[Mc>>2]=0;f[Nc>>2]=0;f[Nc+4>>2]=0;f[Nc+8>>2]=0;f[Nc+12>>2]=0;if((f[Oc>>2]|0)>0){Xd=f[Pc>>2]|0;Wd=0;do{f[Xd+(Wd<<2)>>2]=0;Wd=Wd+1|0}while((Wd|0)<(f[Oc>>2]|0))}Wd=f[Qc>>2]|0;if((Wd|0)!=(Rc|0))wL(Wd)}Wd=f[fc>>2]|0;do if(Wd|0){Xd=Wd+12|0;Yd=f[Xd>>2]|0;f[Xd>>2]=Yd+-1;if((Yd|0)!=1)break;V$(B)}while(0);f[fc>>2]=0;f[gc>>2]=0;f[gc+4>>2]=0;f[gc+8>>2]=0;f[gc+12>>2]=0;if((f[hc>>2]|0)>0){Wd=f[ic>>2]|0;Yd=0;do{f[Wd+(Yd<<2)>>2]=0;Yd=Yd+1|0}while((Yd|0)<(f[hc>>2]|0))}Yd=f[jc>>2]|0;if((Yd|0)!=(kc|0))wL(Yd);Yd=f[lc>>2]|0;do if(Yd|0){Wd=Yd+12|0;Xd=f[Wd>>2]|0;f[Wd>>2]=Xd+-1;if((Xd|0)!=1)break;V$(A)}while(0);f[lc>>2]=0;f[mc>>2]=0;f[mc+4>>2]=0;f[mc+8>>2]=0;f[mc+12>>2]=0;if((f[nc>>2]|0)>0){Yd=f[oc>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[nc>>2]|0))}Xd=f[pc>>2]|0;if((Xd|0)!=(qc|0))wL(Xd);Xd=f[rc>>2]|0;do if(Xd|0){Yd=Xd+12|0;Wd=f[Yd>>2]|0;f[Yd>>2]=Wd+-1;if((Wd|0)!=1)break;V$(z)}while(0);f[rc>>2]=0;f[sc>>2]=0;f[sc+4>>2]=0;f[sc+8>>2]=0;f[sc+12>>2]=0;if((f[tc>>2]|0)>0){Xd=f[uc>>2]|0;Wd=0;do{f[Xd+(Wd<<2)>>2]=0;Wd=Wd+1|0}while((Wd|0)<(f[tc>>2]|0))}Wd=f[vc>>2]|0;if((Wd|0)!=(wc|0))wL(Wd);Wd=f[xc>>2]|0;do if(Wd|0){Xd=Wd+12|0;Yd=f[Xd>>2]|0;f[Xd>>2]=Yd+-1;if((Yd|0)!=1)break;V$(y)}while(0);f[xc>>2]=0;f[yc>>2]=0;f[yc+4>>2]=0;f[yc+8>>2]=0;f[yc+12>>2]=0;if((f[zc>>2]|0)>0){Wd=f[Ac>>2]|0;Yd=0;do{f[Wd+(Yd<<2)>>2]=0;Yd=Yd+1|0}while((Yd|0)<(f[zc>>2]|0))}Yd=f[Bc>>2]|0;if((Yd|0)!=(Cc|0))wL(Yd);Yd=f[Dc>>2]|0;do if(Yd|0){Wd=Yd+12|0;Xd=f[Wd>>2]|0;f[Wd>>2]=Xd+-1;if((Xd|0)!=1)break;V$(x)}while(0);f[Dc>>2]=0;f[Ec>>2]=0;f[Ec+4>>2]=0;f[Ec+8>>2]=0;f[Ec+12>>2]=0;if((f[Fc>>2]|0)>0){Yd=f[Gc>>2]|0;Xd=0;do{f[Yd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[Fc>>2]|0))}Xd=f[Hc>>2]|0;if((Xd|0)!=(Ic|0))wL(Xd)}while((Vd|0)<(f[da>>2]|0))}da=v+36|0;Vd=f[da>>2]|0;if(Vd|0?(Ic=Vd+12|0,Vd=f[Ic>>2]|0,f[Ic>>2]=Vd+-1,(Vd|0)==1):0)V$(v);f[da>>2]=0;da=v+16|0;Vd=v+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[Vd>>2]|0)>0){da=f[v+40>>2]|0;Ic=0;do{f[da+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[Vd>>2]|0))}Vd=f[v+44>>2]|0;if((Vd|0)!=(v+48|0))wL(Vd);Vd=t+36|0;v=f[Vd>>2]|0;if(v|0?(Ic=v+12|0,v=f[Ic>>2]|0,f[Ic>>2]=v+-1,(v|0)==1):0)V$(t);f[Vd>>2]=0;Vd=t+16|0;v=t+4|0;f[Vd>>2]=0;f[Vd+4>>2]=0;f[Vd+8>>2]=0;f[Vd+12>>2]=0;if((f[v>>2]|0)>0){Vd=f[t+40>>2]|0;Ic=0;do{f[Vd+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))wL(v);v=s+36|0;t=f[v>>2]|0;if(t|0?(Ic=t+12|0,t=f[Ic>>2]|0,f[Ic>>2]=t+-1,(t|0)==1):0)V$(s);f[v>>2]=0;v=s+16|0;t=s+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[s+40>>2]|0;Ic=0;do{f[v+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))wL(t);t=f[fa>>2]|0;do if(t|0){s=t+12|0;Ic=f[s>>2]|0;f[s>>2]=Ic+-1;if((Ic|0)!=1)break;V$(r)}while(0);f[fa>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[J>>2]|0)>0){ea=f[ha>>2]|0;ha=0;do{f[ea+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[J>>2]|0))}J=f[ia>>2]|0;if((J|0)!=(aa|0))wL(J);J=f[$>>2]|0;do if(J|0){aa=J+12|0;ia=f[aa>>2]|0;f[aa>>2]=ia+-1;if((ia|0)!=1)break;V$(q)}while(0);f[$>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[H>>2]|0)>0){_=f[ba>>2]|0;ba=0;do{f[_+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[H>>2]|0))}H=f[ca>>2]|0;if((H|0)!=(V|0))wL(H);H=f[U>>2]|0;do if(H|0){V=H+12|0;ca=f[V>>2]|0;f[V>>2]=ca+-1;if((ca|0)!=1)break;V$(o)}while(0);f[U>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[Q>>2]|0)>0){T=f[W>>2]|0;W=0;do{f[T+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[Q>>2]|0))}Q=f[X>>2]|0;if((Q|0)!=(S|0))wL(Q);Q=f[M>>2]|0;do if(Q|0){S=Q+12|0;X=f[S>>2]|0;f[S>>2]=X+-1;if((X|0)!=1)break;V$(m)}while(0);f[M>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[I>>2]|0)>0){L=f[O>>2]|0;O=0;do{f[L+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[I>>2]|0))}I=f[P>>2]|0;if((I|0)!=(K|0))wL(I);hx(l);hx(k);hx(j);u=g;return}function IEb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+80|0;h=d+64|0;i=d+48|0;j=d+44|0;k=d+28|0;l=d+16|0;m=d+4|0;n=d;o=d+40|0;p=d+36|0;q=d+32|0;if(!(b[a+93>>0]|0)){r=f[a+4>>2]|0;if(((f[a+8>>2]|0)-r|0)==168)s=r;else{t=$Xc(80)|0;f[h>>2]=t;v=h+8|0;f[v>>2]=-2147483568;w=h+4|0;f[w>>2]=73;x=t;y=454789;z=x+73|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));A=t+73|0;b[A>>0]=0;vM(-215,h,456079,454082,178)}}else{r=f[a+4>>2]|0;if(((f[a+8>>2]|0)-r|0)==336)s=r;else{t=$Xc(80)|0;f[h>>2]=t;v=h+8|0;f[v>>2]=-2147483568;w=h+4|0;f[w>>2]=73;x=t;y=454789;z=x+73|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));A=t+73|0;b[A>>0]=0;vM(-215,h,456079,454082,178)}}A=s;s=f[c>>2]|0;t=s;if(((f[c+4>>2]|0)-s|0)!=12){c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=18;x=c;y=456060;z=x+18|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[c+18>>0]=0;vM(-215,h,456079,454082,179)}f[k>>2]=f[(f[A+40>>2]|0)+4>>2];c=f[(f[A+96>>2]|0)+4>>2]|0;eKa(l,a+56|0);f[m>>2]=0;A=m+4|0;f[A>>2]=0;f[m+8>>2]=0;w=f[l>>2]|0;v=l+4|0;r=f[v>>2]|0;if((w|0)!=(r|0)){B=r-w|0;r=B>>2;if((B|0)<0){C=$Xc(80)|0;f[h>>2]=C;f[h+8>>2]=-2147483568;f[h+4>>2]=70;x=C;y=454543;z=x+70|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[C+70>>0]=0;vM(-215,h,454614,454620,161)}if(!B)D=1;else{B=0;C=1;while(1){E=Y(f[w+(B<<2)>>2]|0,C)|0;B=B+1|0;if((B|0)==(r|0)){D=E;break}else C=E}}if((D|0)!=(f[k>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;D=$Xc(32)|0;f[h>>2]=D;f[h+8>>2]=-2147483616;f[h+4>>2]=31;x=D;y=454863;z=x+31|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[D+31>>0]=0;vM(-215,h,456079,454082,188)}}else YMa(l,1,k);D=f[t+4>>2]|0;t=f[s>>2]|0;s=D-t|0;C=s>>2;r=C>>>0>1;B=t;do if(!(b[a+80>>0]|0)){if(!r){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;F=$Xc(48)|0;f[h>>2]=F;G=h+8|0;f[G>>2]=-2147483600;H=h+4|0;f[H>>2]=45;x=F;y=454941;z=x+45|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));I=F+45|0;b[I>>0]=0;vM(-215,h,456079,454082,201)}if((B|0)!=(D|0)){if((s|0)<4){t=$Xc(80)|0;f[h>>2]=t;f[h+8>>2]=-2147483568;f[h+4>>2]=70;x=t;y=454543;z=x+70|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[t+70>>0]=0;vM(-215,h,454614,454620,161)}if((s|0)==4)J=1;else{w=1;E=1;while(1){K=Y(f[B+(w<<2)>>2]|0,E)|0;w=w+1|0;if((w|0)==(C|0)){J=K;break}else E=K}}}else J=0;if((J|0)==(c|0)){f[n>>2]=f[B>>2];L=m+8|0;break}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;F=$Xc(48)|0;f[h>>2]=F;G=h+8|0;f[G>>2]=-2147483600;H=h+4|0;f[H>>2]=45;x=F;y=454941;z=x+45|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));I=F+45|0;b[I>>0]=0;vM(-215,h,456079,454082,201)}}else{if(!r){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(48)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483600;O=h+4|0;f[O>>2]=45;x=M;y=454895;z=x+45|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));P=M+45|0;b[P>>0]=0;vM(-215,h,456079,454082,195)}if((B|0)!=(D|0)){if((s|0)<8){E=$Xc(80)|0;f[h>>2]=E;f[h+8>>2]=-2147483568;f[h+4>>2]=70;x=E;y=454543;z=x+70|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[E+70>>0]=0;vM(-215,h,454614,454620,161)}if((s|0)==8)Q=1;else{w=2;t=1;while(1){K=Y(f[B+(w<<2)>>2]|0,t)|0;w=w+1|0;if((w|0)==(C|0)){Q=K;break}else t=K}}}else Q=0;if((Q|0)!=(c|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(48)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483600;O=h+4|0;f[O>>2]=45;x=M;y=454895;z=x+45|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));P=M+45|0;b[P>>0]=0;vM(-215,h,456079,454082,195)}f[n>>2]=f[B+4>>2];t=f[A>>2]|0;w=m+8|0;if((t|0)==(f[w>>2]|0)){Tv(m,B);L=w;break}else{f[t>>2]=f[B>>2];f[A>>2]=t+4;L=w;break}}while(0);B=f[A>>2]|0;if((B|0)==(f[L>>2]|0)){Tv(m,n);R=f[A>>2]|0}else{f[B>>2]=f[n>>2];L=B+4|0;f[A>>2]=L;R=L}f[o>>2]=R;f[p>>2]=f[l>>2];f[q>>2]=f[v>>2];f[j>>2]=f[o>>2];f[i>>2]=f[p>>2];f[h>>2]=f[q>>2];fEa(m,j,i,h)|0;eOa(e,b[a+81>>0]|0?2:1,m);a=f[k>>2]|0;f[h>>2]=f[n>>2];e=h+4|0;f[e>>2]=a;a=h+8|0;f[a>>2]=-1;j=h+12|0;f[j>>2]=-1;f[i>>2]=0;q=i+4|0;f[q>>2]=0;f[i+8>>2]=0;p=h+16|0;gOa(i,h,p);o=f[i>>2]|0;R=f[q>>2]|0;a:do if((o|0)==(R|0)){S=o;T=42}else{L=o;do{if((f[L>>2]|0)<0){S=L;T=42;break a}L=L+4|0}while((L|0)!=(R|0))}while(0);if((T|0)==42?(S|0)!=(R|0):0){o=S+4|0;if((o|0)==(R|0)){U=R;V=S}else{L=o;o=S;while(1){S=f[L>>2]|0;if((S|0)<0)W=o;else{f[o>>2]=S;W=o+4|0}L=L+4|0;if((L|0)==(R|0))break;else o=W}U=f[q>>2]|0;V=W}if((V|0)!=(U|0))f[q>>2]=U+(~((U+-4-V|0)>>>2)<<2)}eOa(g,1,i);V=f[i>>2]|0;if(V|0){U=f[q>>2]|0;if((U|0)!=(V|0))f[q>>2]=U+(~((U+-4-V|0)>>>2)<<2);cYc(V)}V=f[k>>2]|0;f[h>>2]=f[n>>2];f[e>>2]=V;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;V=i+4|0;f[V>>2]=0;f[i+8>>2]=0;gOa(i,h,p);U=f[i>>2]|0;q=f[V>>2]|0;b:do if((U|0)==(q|0)){X=U;T=57}else{W=U;do{if((f[W>>2]|0)<0){X=W;T=57;break b}W=W+4|0}while((W|0)!=(q|0))}while(0);if((T|0)==57?(X|0)!=(q|0):0){U=X+4|0;if((U|0)==(q|0)){Z=q;_=X}else{W=U;U=X;while(1){X=f[W>>2]|0;if((X|0)<0)$=U;else{f[U>>2]=X;$=U+4|0}W=W+4|0;if((W|0)==(q|0))break;else U=$}Z=f[V>>2]|0;_=$}if((_|0)!=(Z|0))f[V>>2]=Z+(~((Z+-4-_|0)>>>2)<<2)}_=g+4|0;Z=f[_>>2]|0;$=g+8|0;if(Z>>>0>=(f[$>>2]|0)>>>0){BPa(g,i);U=f[i>>2]|0;if(U|0){q=f[V>>2]|0;if((q|0)!=(U|0))f[V>>2]=q+(~((q+-4-U|0)>>>2)<<2);cYc(U)}}else{f[Z>>2]=0;U=Z+4|0;f[U>>2]=0;f[Z+8>>2]=0;f[Z>>2]=f[i>>2];f[U>>2]=f[V>>2];U=i+8|0;f[Z+8>>2]=f[U>>2];f[U>>2]=0;f[V>>2]=0;f[i>>2]=0;f[_>>2]=(f[_>>2]|0)+12}f[h>>2]=f[n>>2];f[e>>2]=1;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;V=i+4|0;f[V>>2]=0;f[i+8>>2]=0;gOa(i,h,p);U=f[i>>2]|0;Z=f[V>>2]|0;c:do if((U|0)==(Z|0)){aa=U;T=74}else{q=U;do{if((f[q>>2]|0)<0){aa=q;T=74;break c}q=q+4|0}while((q|0)!=(Z|0))}while(0);if((T|0)==74?(aa|0)!=(Z|0):0){U=aa+4|0;if((U|0)==(Z|0)){ba=Z;ca=aa}else{q=U;U=aa;while(1){aa=f[q>>2]|0;if((aa|0)<0)da=U;else{f[U>>2]=aa;da=U+4|0}q=q+4|0;if((q|0)==(Z|0))break;else U=da}ba=f[V>>2]|0;ca=da}if((ca|0)!=(ba|0))f[V>>2]=ba+(~((ba+-4-ca|0)>>>2)<<2)}ca=f[_>>2]|0;if(ca>>>0>=(f[$>>2]|0)>>>0){BPa(g,i);ba=f[i>>2]|0;if(ba|0){da=f[V>>2]|0;if((da|0)!=(ba|0))f[V>>2]=da+(~((da+-4-ba|0)>>>2)<<2);cYc(ba)}}else{f[ca>>2]=0;ba=ca+4|0;f[ba>>2]=0;f[ca+8>>2]=0;f[ca>>2]=f[i>>2];f[ba>>2]=f[V>>2];ba=i+8|0;f[ca+8>>2]=f[ba>>2];f[ba>>2]=0;f[V>>2]=0;f[i>>2]=0;f[_>>2]=(f[_>>2]|0)+12}V=f[k>>2]<<2;f[h>>2]=f[n>>2];f[e>>2]=V;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;gOa(i,h,p);p=f[i>>2]|0;h=f[j>>2]|0;d:do if((p|0)==(h|0)){ea=p;T=91}else{a=p;do{if((f[a>>2]|0)<0){ea=a;T=91;break d}a=a+4|0}while((a|0)!=(h|0))}while(0);if((T|0)==91?(ea|0)!=(h|0):0){T=ea+4|0;if((T|0)==(h|0)){fa=h;ga=ea}else{p=T;T=ea;while(1){ea=f[p>>2]|0;if((ea|0)<0)ha=T;else{f[T>>2]=ea;ha=T+4|0}p=p+4|0;if((p|0)==(h|0))break;else T=ha}fa=f[j>>2]|0;ga=ha}if((ga|0)!=(fa|0))f[j>>2]=fa+(~((fa+-4-ga|0)>>>2)<<2)}ga=f[_>>2]|0;if(ga>>>0>=(f[$>>2]|0)>>>0){BPa(g,i);g=f[i>>2]|0;if(g|0){$=f[j>>2]|0;if(($|0)!=(g|0))f[j>>2]=$+(~(($+-4-g|0)>>>2)<<2);cYc(g)}}else{f[ga>>2]=0;g=ga+4|0;f[g>>2]=0;f[ga+8>>2]=0;f[ga>>2]=f[i>>2];f[g>>2]=f[j>>2];g=i+8|0;f[ga+8>>2]=f[g>>2];f[g>>2]=0;f[j>>2]=0;f[i>>2]=0;f[_>>2]=(f[_>>2]|0)+12}_=f[m>>2]|0;if(_|0){m=f[A>>2]|0;if((m|0)!=(_|0))f[A>>2]=m+(~((m+-4-_|0)>>>2)<<2);cYc(_)}_=f[l>>2]|0;if(!_){u=d;return 0}l=f[v>>2]|0;if((l|0)!=(_|0))f[v>>2]=l+(~((l+-4-_|0)>>>2)<<2);cYc(_);u=d;return 0}function JEb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;if((f[c+4>>2]|0)!=2){k=$Xc(32)|0;f[h>>2]=k;l=h+8|0;f[l>>2]=-2147483616;m=h+4|0;f[m>>2]=28;n=k;o=454166;p=n+28|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+28|0;b[q>>0]=0;vM(-215,h,454778,454082,161)}if((f[d+4>>2]|0)!=2){k=$Xc(32)|0;f[h>>2]=k;l=h+8|0;f[l>>2]=-2147483616;m=h+4|0;f[m>>2]=28;n=k;o=454166;p=n+28|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+28|0;b[q>>0]=0;vM(-215,h,454778,454082,161)}q=f[c+8>>2]|0;if((q|0)!=(f[d+8>>2]|0)){k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=18;n=k;o=454195;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[k+18>>0]=0;vM(-215,h,454778,454082,162)}if((q|0)!=(f[c+12>>2]<<2|0)){k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=20;n=k;o=454214;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[k+20>>0]=0;vM(-215,h,454778,454082,163)}k=f[e+4>>2]|0;if((k|0)<3)r=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{m=f[e+40>>2]|0;l=0;s=1;while(1){t=Y(f[m+(l<<2)>>2]|0,s)|0;l=l+1|0;if((l|0)==(k|0)){r=t;break}else s=t}}if((q|0)!=(r|0)){r=$Xc(32)|0;f[h>>2]=r;f[h+8>>2]=-2147483616;f[h+4>>2]=28;n=r;o=454235;p=n+28|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[r+28>>0]=0;vM(-215,h,454778,454082,164)}r=f[c>>2]&4095;if((r|0)!=(f[d>>2]&4095|0)){v=$Xc(64)|0;f[h>>2]=v;w=h+8|0;f[w>>2]=-2147483584;x=h+4|0;f[x>>2]=50;n=v;o=454264;p=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));y=v+50|0;b[y>>0]=0;vM(-215,h,454778,454082,165)}if((r|0)!=(f[e>>2]&4095|0)){v=$Xc(64)|0;f[h>>2]=v;w=h+8|0;f[w>>2]=-2147483584;x=h+4|0;f[x>>2]=50;n=v;o=454264;p=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));y=v+50|0;b[y>>0]=0;vM(-215,h,454778,454082,165)}y=a+4|0;hS(y,3);f[i>>2]=1124007936;a=i+4|0;v=i+8|0;o=i+40|0;n=a;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[o>>2]=v;x=i+48|0;w=i+44|0;f[w>>2]=x;f[x>>2]=0;f[i+52>>2]=0;r=h+8|0;f[r>>2]=0;f[r+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=i;jR(c,h);c=f[y>>2]|0;if((c|0)==(i|0)){r=i+36|0;q=f[r>>2]|0;if((q|0)!=0?(s=q+12|0,q=f[s>>2]|0,f[s>>2]=q+-1,(q|0)==1):0){V$(i);z=r}else z=r}else{r=c+36|0;q=f[r>>2]|0;if(q|0?(s=q+12|0,q=f[s>>2]|0,f[s>>2]=q+-1,(q|0)==1):0)V$(c);f[r>>2]=0;q=c+16|0;s=c+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[s>>2]|0)>0){k=f[c+40>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[s>>2]|0))}f[c>>2]=f[i>>2];f[s>>2]=f[a>>2];s=c+8|0;f[s>>2]=f[v>>2];f[c+12>>2]=f[i+12>>2];f[q>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[c+28>>2]=f[i+28>>2];f[c+32>>2]=f[i+32>>2];q=i+36|0;f[r>>2]=f[q>>2];r=c+44|0;l=f[r>>2]|0;k=c+48|0;if((l|0)==(k|0))A=l;else{wL(l);f[r>>2]=k;f[c+40>>2]=s;A=k}k=i+44|0;if((f[a>>2]|0)<3){s=f[k>>2]|0;f[A>>2]=f[s>>2];f[A+4>>2]=f[s+4>>2]}else{f[r>>2]=f[k>>2];f[c+40>>2]=f[o>>2];f[k>>2]=x;f[o>>2]=v}f[i>>2]=1124007936;n=a;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));z=q}f[z>>2]=0;z=i+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[a>>2]|0)>0){z=f[o>>2]|0;o=0;do{f[z+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[w>>2]|0;if((a|0)!=(x|0))wL(a);f[i>>2]=1124007936;a=i+4|0;x=i+8|0;w=i+40|0;n=a;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[w>>2]=x;o=i+48|0;z=i+44|0;f[z>>2]=o;f[o>>2]=0;f[i+52>>2]=0;q=h+8|0;f[q>>2]=0;f[q+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=i;jR(d,h);d=f[y>>2]|0;q=d+56|0;if((q|0)==(i|0)){v=i+36|0;k=f[v>>2]|0;if((k|0)!=0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0){V$(i);B=v}else B=v}else{v=d+92|0;k=f[v>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)V$(q);f[v>>2]=0;k=d+72|0;c=d+60|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[c>>2]|0)>0){r=f[d+96>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[c>>2]|0))}f[q>>2]=f[i>>2];q=f[a>>2]|0;f[c>>2]=q;c=d+64|0;f[c>>2]=f[x>>2];f[d+68>>2]=f[i+12>>2];f[k>>2]=f[i+16>>2];f[d+76>>2]=f[i+20>>2];f[d+80>>2]=f[i+24>>2];f[d+84>>2]=f[i+28>>2];f[d+88>>2]=f[i+32>>2];k=i+36|0;f[v>>2]=f[k>>2];v=d+100|0;s=f[v>>2]|0;r=d+104|0;if((s|0)==(r|0)){C=q;D=s}else{wL(s);f[v>>2]=r;f[d+96>>2]=c;C=f[a>>2]|0;D=r}r=i+44|0;if((C|0)<3){C=f[r>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2]}else{f[v>>2]=f[r>>2];f[d+96>>2]=f[w>>2];f[r>>2]=o;f[w>>2]=x}f[i>>2]=1124007936;n=a;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));B=k}f[B>>2]=0;B=i+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){B=f[w>>2]|0;w=0;do{f[B+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[z>>2]|0;if((a|0)!=(o|0))wL(a);f[j>>2]=1124007936;a=j+4|0;o=j+8|0;z=j+40|0;n=a;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[z>>2]=o;o=j+48|0;w=j+44|0;f[w>>2]=o;f[o>>2]=0;f[j+52>>2]=0;B=h+8|0;f[B>>2]=0;f[B+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=j;jR(e,h);g0(i,j,1,1);h=f[y>>2]|0;y=h+112|0;if((y|0)==(i|0)){e=i+36|0;B=f[e>>2]|0;if((B|0)!=0?(k=B+12|0,B=f[k>>2]|0,f[k>>2]=B+-1,(B|0)==1):0){V$(i);E=e}else E=e}else{e=h+148|0;B=f[e>>2]|0;if(B|0?(k=B+12|0,B=f[k>>2]|0,f[k>>2]=B+-1,(B|0)==1):0)V$(y);f[e>>2]=0;B=h+128|0;k=h+116|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[k>>2]|0)>0){x=f[h+152>>2]|0;r=0;do{f[x+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[k>>2]|0))}f[y>>2]=f[i>>2];y=i+4|0;r=f[y>>2]|0;f[k>>2]=r;k=i+8|0;x=h+120|0;f[x>>2]=f[k>>2];f[h+124>>2]=f[i+12>>2];f[B>>2]=f[i+16>>2];f[h+132>>2]=f[i+20>>2];f[h+136>>2]=f[i+24>>2];f[h+140>>2]=f[i+28>>2];f[h+144>>2]=f[i+32>>2];B=i+36|0;f[e>>2]=f[B>>2];e=h+156|0;d=f[e>>2]|0;v=h+160|0;if((d|0)==(v|0)){F=r;G=d}else{wL(d);f[e>>2]=v;f[h+152>>2]=x;F=f[y>>2]|0;G=v}v=i+44|0;if((F|0)<3){F=f[v>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2]}else{f[e>>2]=f[v>>2];e=i+40|0;f[h+152>>2]=f[e>>2];f[v>>2]=i+48;f[e>>2]=k}f[i>>2]=1124007936;n=y;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));E=B}f[E>>2]=0;E=i+16|0;B=i+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[B>>2]|0)>0){E=f[i+40>>2]|0;n=0;do{f[E+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[B>>2]|0))}B=f[i+44>>2]|0;if((B|0)!=(i+48|0))wL(B);B=j+36|0;i=f[B>>2]|0;if(i|0?(n=i+12|0,i=f[n>>2]|0,f[n>>2]=i+-1,(i|0)==1):0)V$(j);f[B>>2]=0;B=j+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){B=f[z>>2]|0;z=0;do{f[B+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[a>>2]|0))}a=f[w>>2]|0;if((a|0)==(o|0)){u=g;return}wL(a);u=g;return}function KEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=a+56|0;if(b[a+52>>0]|0){h=f[a+60>>2]|0;a=f[g>>2]|0;i=h-a|0;j=i>>2;k=a;if((k|0)!=(h|0)){if((i|0)<0){h=$Xc(80)|0;f[e>>2]=h;f[e+8>>2]=-2147483568;f[e+4>>2]=70;l=h;m=454543;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+70>>0]=0;vM(-215,e,454614,454620,161)}if(!i)o=1;else{i=0;h=1;while(1){a=Y(f[k+(i<<2)>>2]|0,h)|0;i=i+1|0;if((i|0)==(j|0)){o=a;break}else h=a}}}else o=0;h=f[c+4>>2]|0;j=f[c>>2]|0;i=h-j|0;k=i>>2;a=j;if((a|0)!=(h|0)){if((i|0)<0){h=$Xc(80)|0;f[e>>2]=h;f[e+8>>2]=-2147483568;f[e+4>>2]=70;l=h;m=454543;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+70>>0]=0;vM(-215,e,454614,454620,161)}if(!i)p=1;else{i=0;h=1;while(1){j=Y(f[a+(i<<2)>>2]|0,h)|0;i=i+1|0;if((i|0)==(k|0)){p=j;break}else h=j}}}else p=0;if((o|0)!=(p|0)){p=$Xc(64)|0;f[e>>2]=p;f[e+8>>2]=-2147483584;f[e+4>>2]=57;l=p;m=454708;n=l+57|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[p+57>>0]=0;vM(-215,e,454766,454082,155)}}if((g|0)==(c|0)){u=d;return}eEa(g,f[c>>2]|0,f[c+4>>2]|0);u=d;return}function LEb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!(b[a+52>>0]|0)){b[a+80>>0]=c&1;u=d;return}else{b[e+11>>0]=10;d=e;c=454492;a=d+10|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(a|0));b[e+10>>0]=0;vM(-215,e,454524,454082,143)}}function MEb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!(b[a+52>>0]|0)){b[a+81>>0]=c&1;u=d;return}else{b[e+11>>0]=10;d=e;c=454492;a=d+10|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(a|0));b[e+10>>0]=0;vM(-215,e,454503,454082,149)}}function NEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+288|0;d=c+272|0;e=c+32|0;g=c;h=c+256|0;$_(e,a);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=-1056571392;f[d+4>>2]=e;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;OL(d,g);Zj(e);p[g>>3]=1.0;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;T_(e,g,b);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=-1056571392;f[d+4>>2]=e;g=h+8|0;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;QL(d,-1.0,h);Zj(e);u=c;return}function OEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;d=u;u=u+64|0;e=d+40|0;g=d+20|0;h=d;i=a+4|0;j=a+40|0;S$(c,f[i>>2]|0,f[j>>2]|0,f[a>>2]&4095);k=f[a>>2]|0;switch(k&4095){case 5:{f[e>>2]=a;l=e+4|0;m=f[i>>2]|0;if((m|0)>0)o=f[(f[a+44>>2]|0)+(m+-1<<2)>>2]|0;else o=0;f[l>>2]=o;q=e+8|0;f[q>>2]=0;r=e+12|0;f[r>>2]=0;s=e+16|0;f[s>>2]=0;if(k&16384|0){t=f[a+16>>2]|0;f[r>>2]=t;if((m|0)<3)v=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{r=f[j>>2]|0;w=0;x=1;while(1){y=Y(f[r+(w<<2)>>2]|0,x)|0;w=w+1|0;if((w|0)==(m|0)){v=y;break}else x=y}}x=t+(Y(v,o)|0)|0;f[s>>2]=x}EL(e,0,0);f[g>>2]=c;x=g+4|0;o=f[c+4>>2]|0;if((o|0)>0)z=f[(f[c+44>>2]|0)+(o+-1<<2)>>2]|0;else z=0;f[x>>2]=z;v=g+8|0;f[v>>2]=0;t=g+12|0;f[t>>2]=0;m=g+16|0;f[m>>2]=0;if(f[c>>2]&16384|0){w=f[c+16>>2]|0;f[t>>2]=w;if((o|0)<3)A=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{t=f[c+40>>2]|0;r=0;y=1;while(1){B=Y(f[t+(r<<2)>>2]|0,y)|0;r=r+1|0;if((r|0)==(o|0)){A=B;break}else y=B}}y=w+(Y(A,z)|0)|0;f[m>>2]=y}EL(g,0,0);PEb(h,a);y=f[e>>2]|0;z=f[q>>2]|0;A=h+8|0;if((y|0)!=(f[h>>2]|0)?1:(z|0)!=(f[A>>2]|0)){w=y;y=z;do{C=+CLc(+n[y>>2]);n[f[v>>2]>>2]=C;z=f[l>>2]|0;if(w|0?(o=f[s>>2]|0,r=y+z|0,f[q>>2]=r,r>>>0>=o>>>0):0){f[q>>2]=r+(0-z);DL(e,1,1)}z=f[x>>2]|0;if(f[g>>2]|0?(r=f[m>>2]|0,o=(f[v>>2]|0)+z|0,f[v>>2]=o,o>>>0>=r>>>0):0){f[v>>2]=o+(0-z);DL(g,1,1)}PEb(h,a);w=f[e>>2]|0;y=f[q>>2]|0}while((w|0)!=(f[h>>2]|0)?1:(y|0)!=(f[A>>2]|0))}u=d;return}case 6:{f[e>>2]=a;A=e+4|0;y=f[i>>2]|0;if((y|0)>0)D=f[(f[a+44>>2]|0)+(y+-1<<2)>>2]|0;else D=0;f[A>>2]=D;i=e+8|0;f[i>>2]=0;w=e+12|0;f[w>>2]=0;q=e+16|0;f[q>>2]=0;if(k&16384|0){k=f[a+16>>2]|0;f[w>>2]=k;if((y|0)<3)E=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{w=f[j>>2]|0;j=0;v=1;while(1){m=Y(f[w+(j<<2)>>2]|0,v)|0;j=j+1|0;if((j|0)==(y|0)){E=m;break}else v=m}}v=k+(Y(E,D)|0)|0;f[q>>2]=v}EL(e,0,0);f[g>>2]=c;v=g+4|0;D=f[c+4>>2]|0;if((D|0)>0)F=f[(f[c+44>>2]|0)+(D+-1<<2)>>2]|0;else F=0;f[v>>2]=F;E=g+8|0;f[E>>2]=0;k=g+12|0;f[k>>2]=0;y=g+16|0;f[y>>2]=0;if(f[c>>2]&16384|0){j=f[c+16>>2]|0;f[k>>2]=j;if((D|0)<3)G=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{k=f[c+40>>2]|0;c=0;w=1;while(1){m=Y(f[k+(c<<2)>>2]|0,w)|0;c=c+1|0;if((c|0)==(D|0)){G=m;break}else w=m}}w=j+(Y(G,F)|0)|0;f[y>>2]=w}EL(g,0,0);QEb(h,a);w=f[e>>2]|0;F=f[i>>2]|0;G=h+8|0;if((w|0)!=(f[h>>2]|0)?1:(F|0)!=(f[G>>2]|0)){j=w;w=F;do{C=+xLc(+p[w>>3]);p[f[E>>2]>>3]=C;F=f[A>>2]|0;if(j|0?(D=f[q>>2]|0,c=w+F|0,f[i>>2]=c,c>>>0>=D>>>0):0){f[i>>2]=c+(0-F);DL(e,1,1)}F=f[v>>2]|0;if(f[g>>2]|0?(c=f[y>>2]|0,D=(f[E>>2]|0)+F|0,f[E>>2]=D,D>>>0>=c>>>0):0){f[E>>2]=D+(0-F);DL(g,1,1)}QEb(h,a);j=f[e>>2]|0;w=f[i>>2]|0}while((j|0)!=(f[h>>2]|0)?1:(w|0)!=(f[G>>2]|0))}u=d;return}default:{d=$Xc(48)|0;f[e>>2]=d;f[e+8>>2]=-2147483600;f[e+4>>2]=43;G=d;w=454987;h=G+43|0;do{b[G>>0]=b[w>>0]|0;G=G+1|0;w=w+1|0}while((G|0)<(h|0));b[d+43>>0]=0;vM(-210,e,455031,454082,74)}}}function PEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=b;c=a+4|0;d=b+4|0;e=f[d>>2]|0;if((e|0)>0)g=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else g=0;f[c>>2]=g;h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;j=a+16|0;f[j>>2]=0;if(f[b>>2]&16384|0){k=f[b+16>>2]|0;f[i>>2]=k;if((e|0)<3)l=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{m=f[b+40>>2]|0;n=0;o=1;while(1){p=Y(f[m+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)==(e|0)){l=p;break}else o=p}}o=k+(Y(l,g)|0)|0;f[j>>2]=o}EL(a,0,0);o=f[d>>2]|0;if((o|0)<3)q=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{d=f[b+40>>2]|0;b=0;g=1;while(1){l=Y(f[d+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(o|0)){q=l;break}else g=l}}if((q|0)==0|(f[a>>2]|0)==0)return;g=Y(f[c>>2]|0,q)|0;c=(f[h>>2]|0)+g|0;f[h>>2]=c;if(c>>>0>=(f[i>>2]|0)>>>0?(f[j>>2]|0)>>>0>c>>>0:0)return;f[h>>2]=c+(0-g);DL(a,q,1);return}function QEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=b;c=a+4|0;d=b+4|0;e=f[d>>2]|0;if((e|0)>0)g=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else g=0;f[c>>2]=g;h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;j=a+16|0;f[j>>2]=0;if(f[b>>2]&16384|0){k=f[b+16>>2]|0;f[i>>2]=k;if((e|0)<3)l=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{m=f[b+40>>2]|0;n=0;o=1;while(1){p=Y(f[m+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)==(e|0)){l=p;break}else o=p}}o=k+(Y(l,g)|0)|0;f[j>>2]=o}EL(a,0,0);o=f[d>>2]|0;if((o|0)<3)q=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{d=f[b+40>>2]|0;b=0;g=1;while(1){l=Y(f[d+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(o|0)){q=l;break}else g=l}}if((q|0)==0|(f[a>>2]|0)==0)return;g=Y(f[c>>2]|0,q)|0;c=(f[h>>2]|0)+g|0;f[h>>2]=c;if(c>>>0>=(f[i>>2]|0)>>>0?(f[j>>2]|0)>>>0>c>>>0:0)return;f[h>>2]=c+(0-g);DL(a,q,1);return}function REb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(72)|0;SEb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=108380;f[b+12>>2]=c;f[a+4>>2]=b;return}function SEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=d+4|0;qQa(a);f[a+48>>2]=0;h=a+52|0;f[h>>2]=0;f[a+56>>2]=0;f[a>>2]=108408;f[a+60>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;rQa(a,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=g+11|0;b[i>>0]=4;f[g>>2]=1936291937;b[g+4>>0]=0;j=LGa(c,g)|0;k=c+4|0;if((j|0)==(k|0))l=2;else{m=MGa(j+28|0,-1)|0;l=m}f[a+44>>2]=l;if((b[i>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=g+11|0;b[i>>0]=6;b[g>>0]=b[455356]|0;b[g+1>>0]=b[455357]|0;b[g+2>>0]=b[455358]|0;b[g+3>>0]=b[455359]|0;b[g+4>>0]=b[455360]|0;b[g+5>>0]=b[455361]|0;b[g+6>>0]=0;l=LGa(c,g)|0;c=(l|0)==(k|0)?0:l+28|0;if((b[i>>0]|0)<0)cYc(f[g>>2]|0);if(!c){u=d;return}i=c+4|0;l=a+56|0;k=a+48|0;a=c+4|0;m=0;a:while(1){n=f[c>>2]|0;switch(n|0){case 0:{o=(f[i>>2]|0)+4|0;break}case 3:{o=(f[a>>2]|0)+4|0;break}case 2:{o=(f[a>>2]|0)+4|0;break}default:{p=13;break a}}if((m|0)>=(f[o>>2]|0)){p=19;break}j=MGa(c,m)|0;f[g>>2]=j;q=f[h>>2]|0;if(q>>>0<(f[l>>2]|0)>>>0){f[q>>2]=j;f[h>>2]=q+4}else LA(k,g);m=m+1|0}if((p|0)==13){f[e>>2]=n;DM(g,455363,e);vM(-3,g,470867,455383,297)}else if((p|0)==19){u=d;return}}function TEb(a){a=a|0;NXc(a);cYc(a);return}function UEb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function VEb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==455203?a+12|0:0)|0}function WEb(a){a=a|0;cYc(a);return}function XEb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=108520;b=f[a+48>>2]|0;if(!b){MNa(a);return}c=a+52|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);return}function YEb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=108520;b=f[a+48>>2]|0;if(!b){MNa(a);cYc(a);return}c=a+52|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);cYc(a);return}function ZEb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=108408;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b)}f[a>>2]=108520;b=f[a+48>>2]|0;if(!b){MNa(a);return}d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b);MNa(a);return}function _Eb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=108408;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b)}f[a>>2]=108520;b=f[a+48>>2]|0;if(!b){MNa(a);cYc(a);return}d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b);MNa(a);cYc(a);return}function $Eb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;gS(c,e);c=f[e>>2]|0;j=c;if(((f[i>>2]|0)-c|0)!=112){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=$Xc(32)|0;f[g>>2]=c;f[g+8>>2]=-2147483616;f[g+4>>2]=18;k=c;l=455600;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[c+18>>0]=0;vM(-215,g,455619,455522,97)}c=f[j+4>>2]|0;i=f[a+44>>2]|0;n=((i|0)<0?c:0)+i|0;f[g>>2]=0;i=g+4|0;f[i>>2]=0;f[g+8>>2]=0;do if(c)if(c>>>0>1073741823)kWc(g);else{o=c<<2;p=$Xc(o)|0;f[g>>2]=p;q=p+(c<<2)|0;f[g+8>>2]=q;g1c(p|0,0,o|0)|0;f[i>>2]=q;r=p;break}else r=0;while(0);p=f[a+48>>2]|0;q=(f[a+52>>2]|0)-p>>2;o=p;switch(q|0){case 1:{if((c|0)>(n|0)){p=n;do{f[r+(p<<2)>>2]=f[o>>2];p=p+1|0}while((p|0)!=(c|0))}break}case 0:break;default:{if((q|0)!=(c-n|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=$Xc(96)|0;f[h>>2]=q;f[h+8>>2]=-2147483552;f[h+4>>2]=91;k=q;l=455628;m=k+91|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[q+91>>0]=0;vM(-5,h,455619,455522,115)}if((c|0)>(n|0)){q=n;do{f[r+(q<<2)>>2]=f[o+(q-n<<2)>>2];q=q+1|0}while((q|0)!=(c|0))}}}q=a+60|0;o=a+64|0;a=f[o>>2]|0;r=f[q>>2]|0;p=a-r>>3;s=r;r=a;if(c>>>0<=p>>>0){if(c>>>0<p>>>0?(a=s+(c<<3)|0,(r|0)!=(a|0)):0)f[o>>2]=r+(~((r+-8-a|0)>>>3)<<3)}else fDb(q,c-p|0);if((n|0)>0){p=j+40|0;a=0;do{r=f[(f[p>>2]|0)+(a<<2)>>2]|0;o=(f[q>>2]|0)+(a<<3)|0;f[o>>2]=0;f[o+4>>2]=r;a=a+1|0}while((a|0)!=(n|0))}a:do if((c|0)>(n|0)){a=j+96|0;p=j+40|0;r=n;while(1){o=f[(f[g>>2]|0)+(r<<2)>>2]|0;if((o|0)<0){t=31;break}s=(f[(f[a>>2]|0)+(r<<2)>>2]|0)+o|0;if((s|0)>(f[(f[p>>2]|0)+(r<<2)>>2]|0)){t=31;break}v=(f[q>>2]|0)+(r<<3)|0;f[v>>2]=o;f[v+4>>2]=s;r=r+1|0;if((r|0)>=(c|0))break a}if((t|0)==31){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=$Xc(48)|0;f[h>>2]=r;f[h+8>>2]=-2147483600;f[h+4>>2]=37;k=r;l=455720;m=k+37|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[r+37>>0]=0;vM(-5,h,455619,455522,129)}}while(0);h=f[g>>2]|0;if(!h){hx(e);u=d;return}g=f[i>>2]|0;if((g|0)!=(h|0))f[i>>2]=g+(~((g+-4-h|0)>>>2)<<2);cYc(h);hx(e);u=d;return}function aFb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;d=u;u=u+96|0;e=d+84|0;g=d+72|0;h=d+16|0;i=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;gS(b,e);gS(c,g);X$(h,f[e>>2]|0,f[a+60>>2]|0);a=f[g>>2]|0;c=i+8|0;f[c>>2]=0;f[c+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;jR(h,i);i=h+36|0;a=f[i>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)V$(h);f[i>>2]=0;i=h+16|0;a=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[h+40>>2]|0;c=0;do{f[i+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)==(h+48|0)){hx(g);hx(e);u=d;return}wL(a);hx(g);hx(e);u=d;return}function bFb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=((f[a+64>>2]|0)-(f[a+60>>2]|0)|0)==32;break}default:c=0}return c|0}function cFb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function dFb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)!=24){i=$Xc(32)|0;f[d>>2]=i;f[d+8>>2]=-2147483616;f[d+4>>2]=18;j=i;k=455503;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+18>>0]=0;vM(-215,d,456079,455522,79)}eKa(d,h);h=f[a+44>>2]|0;a=d+4|0;i=f[d>>2]|0;k=(f[a>>2]|0)-i>>2;j=((h|0)<0?k:0)+h|0;h=i;if(j>>>0<k>>>0){i=f[(f[c>>2]|0)+12>>2]|0;c=j;do{f[h+(c<<2)>>2]=f[i+(c<<2)>>2];c=c+1|0}while(c>>>0<k>>>0)}k=e+4|0;c=f[k>>2]|0;i=f[e>>2]|0;h=c-i|0;j=(h|0)/12|0;l=i;i=c;if(h){if(j>>>0>1?(h=l+12|0,(i|0)!=(h|0)):0){l=i;while(1){i=l+-12|0;f[k>>2]=i;c=f[i>>2]|0;if(!c)m=i;else{i=l+-8|0;n=f[i>>2]|0;if((n|0)!=(c|0))f[i>>2]=n+(~((n+-4-c|0)>>>2)<<2);cYc(c);m=f[k>>2]|0}if((m|0)==(h|0))break;else l=m}}}else Nvb(e,1-j|0,d);j=f[d>>2]|0;if(!j){u=g;return 0}d=f[a>>2]|0;if((d|0)!=(j|0))f[a>>2]=d+(~((d+-4-j|0)>>>2)<<2);cYc(j);u=g;return 0}function eFb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(48)|0;fFb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=108632;f[b+12>>2]=c;f[a+4>>2]=b;return}function fFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=108660;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=9;h=e;i=455938;j=h+9|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+9>>0]=0;k=(HIa(c,e)|0)==0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);if(k){f[a+44>>2]=-1;u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=e+11|0;b[k>>0]=9;h=e;i=455938;j=h+9|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+9>>0]=0;g=MGa(NIa(c,e)|0,-1)|0;c=a+44|0;f[c>>2]=g;if((b[k>>0]|0)<0){cYc(f[e>>2]|0);l=f[c>>2]|0}else l=g;if((l|0)>-1){u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=17;h=d;i=455948;j=h+17|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[d+17>>0]=0;vM(-215,e,455966,455981,61)}}function gFb(a){a=a|0;NXc(a);cYc(a);return}function hFb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function iFb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==455783?a+12|0:0)|0}function jFb(a){a=a|0;cYc(a);return}function kFb(a){a=a|0;MNa(a);cYc(a);return}function lFb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+48|0;a=e+28|0;g=e+16|0;h=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[g>>2]=0;i=g+4|0;f[i>>2]=0;f[g+8>>2]=0;gS(c,a);gS(d,g);d=f[g>>2]|0;if((f[i>>2]|0)==(d|0)){hx(g);hx(a);u=e;return}c=h+8|0;j=h+4|0;k=0;l=d;while(1){d=l;m=f[a>>2]|0;n=f[m+4>>2]|0;if((n|0)<3)o=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{p=f[m+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}r=f[d+(k*56|0)+4>>2]|0;if((r|0)<3)t=Y(f[d+(k*56|0)+12>>2]|0,f[d+(k*56|0)+8>>2]|0)|0;else{n=f[d+(k*56|0)+40>>2]|0;q=0;p=1;while(1){s=Y(f[n+(q<<2)>>2]|0,p)|0;q=q+1|0;if((q|0)==(r|0)){t=s;break}else p=s}}if((o|0)!=(t|0)){v=13;break}p=c;f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=33619968;f[j>>2]=d+(k*56|0);jR(m,h);k=k+1|0;l=f[g>>2]|0;if(k>>>0>=(((f[i>>2]|0)-l|0)/56|0)>>>0){v=3;break}}if((v|0)==3){hx(g);hx(a);u=e;return}else if((v|0)==13){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=39;e=v;a=456095;g=e+39|0;do{b[e>>0]=b[a>>0]|0;e=e+1|0;a=a+1|0}while((e|0)<(g|0));b[v+39>>0]=0;vM(-215,h,456135,455981,91)}}function mFb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h;if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)==12){j=f[a+44>>2]|0;k=(j|0)>-1?j:d;cOa(a,c,(k|0)>1?k:1,e,g)|0;u=h;return 0}else{h=$Xc(32)|0;f[i>>2]=h;f[i+8>>2]=-2147483616;f[i+4>>2]=18;g=h;e=456060;k=g+18|0;do{b[g>>0]=b[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(k|0));b[h+18>>0]=0;vM(-215,i,456079,455981,74)}return 0}function nFb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=108932;b=a+36|0;c=f[b>>2]|0;if(c|0?(f[a+24>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h|0?(f[a+8>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;cYc(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[b>>2]=0;return}function oFb(a){a=a|0;nFb(a);cYc(a);return}function pFb(a){a=a|0;a=$Xc(44)|0;SHb(a);return a|0}function qFb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(44)|0;SHb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19168,48);a=QXb(b,48)|0;THb(a,b);c=a;return c|0}function rFb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function sFb(a){a=a|0;return f[a+4>>2]|0}function tFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;RHb(a+8|0);c=a+28|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+36>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+4|0;j=f[h+8>>2]|0;do if((j|0)!=537368){k=j+11|0;if((b[k>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[k>>0]=0;break}}while(0);j=f[h+12>>2]|0;do if((j|0)!=537368){k=j+11|0;if((b[k>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[k>>0]=0;break}}while(0);j=f[i>>2]|0;if(j&1|0?(h=j&-2,f[h>>2]|0):0)sqc(h)}while((g|0)!=(d|0));f[c>>2]=0}c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function uFb(a){a=a|0;return 1}function vFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+24|0;n=a+36|0;o=a+32|0;p=a+28|0;q=e+4|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=ZYb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}t=f[i>>2]|0;do if(t){a=f[k>>2]|0;s=f[t>>2]|0;if((a|0)>=(s|0))if((s|0)==(f[j>>2]|0)){z=s;w=13;break}else{A=s;B=t;w=14;break}else{f[k>>2]=a+1;C=f[t+4+(a<<2)>>2]|0;break}}else{z=f[j>>2]|0;w=13}while(0);if((w|0)==13){w=0;XZb(h,z+1|0);t=f[i>>2]|0;A=f[t>>2]|0;B=t;w=14}if((w|0)==14){w=0;f[B>>2]=A+1;t=f[h>>2]|0;if(!t){a=$Xc(32)|0;LHb(a);D=a}else{if(f[t+64>>2]|0)SXb(t,19200,32);a=QXb(t,32)|0;MHb(a,t);D=a}a=f[i>>2]|0;t=f[k>>2]|0;f[k>>2]=t+1;f[a+4+(t<<2)>>2]=D;C=D}t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(a=b[t>>0]|0,a<<24>>24>-1):0){f[c>>2]=t+1;E=a&255}else{a=YYb(c)|0;if((a|0)>-1)E=a;else{F=0;w=54;break a}}JYb(e,c,E);if((f[l>>2]|0)<0){w=26;break a}if(!(Mi[f[(f[C>>2]|0)+44>>2]&1023](C,c)|0)){w=26;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{F=0;w=54;break a}break}case 2:{if((v&255|0)!=18){y=v;break b}a=f[n>>2]|0;do if(a){t=f[p>>2]|0;s=f[a>>2]|0;if((t|0)>=(s|0))if((s|0)==(f[o>>2]|0)){G=s;w=34;break}else{H=s;I=a;w=35;break}else{f[p>>2]=t+1;J=f[a+4+(t<<2)>>2]|0;break}}else{G=f[o>>2]|0;w=34}while(0);if((w|0)==34){w=0;XZb(m,G+1|0);a=f[n>>2]|0;H=f[a>>2]|0;I=a;w=35}if((w|0)==35){w=0;f[I>>2]=H+1;a=f[m>>2]|0;if(!a){t=$Xc(20)|0;dGb(t);K=t}else{if(f[a+64>>2]|0)SXb(a,19184,24);t=QXb(a,24)|0;eGb(t,a);K=t}t=f[n>>2]|0;a=f[p>>2]|0;f[p>>2]=a+1;f[t+4+(a<<2)>>2]=K;J=K}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(t=b[a>>0]|0,t<<24>>24>-1):0){f[c>>2]=a+1;L=t&255}else{t=YYb(c)|0;if((t|0)>-1)L=t;else{F=0;w=54;break a}}JYb(e,c,L);if((f[q>>2]|0)<0){w=47;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){w=47;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{F=0;w=54;break a}break}default:{y=v;break b}}}while(0);if(!y){F=1;w=54;break}t=f[r>>2]|0;if(!(t&1))M=lSa(r)|0;else M=t&-2;if(!(Lqc(c,y,M)|0)){F=0;w=54;break}}if((w|0)==26){F=0;u=d;return F|0}else if((w|0)==47){F=0;u=d;return F|0}else if((w|0)==54){u=d;return F|0}return 0}function wFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+28>>2]|0;c=i+g|0;if(!i){k=c;l=a+40|0;f[l>>2]=k;return k|0}g=a+36|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}l=a+40|0;f[l>>2]=k;return k|0}function xFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{k$b(1,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+28>>2]|0;if(d|0){g=a+36|0;e=0;do{k$b(2,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function yFb(a){a=a|0;return f[a+40>>2]|0}function zFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+28>>2]|0;if(!j)s=g;else{e=a+36|0;i=0;q=g;while(1){g=f[(f[e>>2]|0)+4+(i<<2)>>2]|0;b[q>>0]=18;r=q+1|0;h=_i[f[(f[g>>2]|0)+60>>2]&2047](g)|0;if(h>>>0>127){n=h;m=r;while(1){b[m>>0]=n|128;o=n>>>7;p=m+1|0;if(n>>>0>16383){n=o;m=p}else{t=p;u=o;break}}}else{t=r;u=h}b[t>>0]=u;m=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,t+1|0)|0;i=i+1|0;if((i|0)==(j|0)){s=m;break}else q=m}}q=f[a+4>>2]|0;if(!((q&1|0)!=0&(b[476924]|0)!=0)){v=s;return v|0}v=Pqc(q&-2,s)|0;return v|0}function AFb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;tFb(a);BFb(a,b);return}function BFb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,19168,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}NHb(a+8|0,c+8|0);OHb(a+24|0,c+24|0);return}function CFb(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function DFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223166]|0)!=2){f[d>>2]=165456;f[d+4>>2]=107;b[d+8>>0]=0;J_b(892664,d);a_b(d)}d=536984;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function EFb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223167]|0)!=2){f[c>>2]=165456;f[c+4>>2]=108;b[c+8>>0]=0;J_b(892668,c);a_b(c)}d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=14;e=d;g=456207;h=e+14|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+14>>0]=0;ejc(c,109032,109092,108764,0,536984,0,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function FFb(){GFb();n3b(456222,615);Boc(456207,2266);iUa();nKb();return}function GFb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223168]|0)!=2){f[c>>2]=165456;f[c+4>>2]=109;b[c+8>>0]=0;J_b(892672,c);a_b(c)}if((f[223169]|0)!=2){f[c>>2]=165456;f[c+4>>2]=110;b[c+8>>0]=0;J_b(892676,c);a_b(c)}if((f[223170]|0)!=2){f[c>>2]=165456;f[c+4>>2]=111;b[c+8>>0]=0;J_b(892680,c);a_b(c)}if((f[223171]|0)!=2){f[c>>2]=165456;f[c+4>>2]=112;b[c+8>>0]=0;J_b(892684,c);a_b(c)}if((f[223172]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=113;b[c+8>>0]=0;J_b(892688,c);a_b(c);u=a;return}function HFb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223166]|0)!=2){f[c>>2]=165456;f[c+4>>2]=107;b[c+8>>0]=0;J_b(892664,c);a_b(c)}jjc(536984,5);u=a;return}function IFb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,456838);WXb();if((f[223171]|0)!=2){f[c>>2]=165456;f[c+4>>2]=112;b[c+8>>0]=0;J_b(892684,c);a_b(c)}if((f[223172]|0)!=2){f[c>>2]=165456;f[c+4>>2]=113;b[c+8>>0]=0;J_b(892688,c);a_b(c)}f[134188]=108932;c=536756;d=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[134198]=0;C_b(536752);u=a;return}function JFb(){d_b(3005001,3005e3,456838);WXb();hUa();f[134203]=0;f[134201]=537368;f[134204]=0;f[134205]=0;f[134200]=109528;f[134202]=530680;return}function KFb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,456838);WXb();if((f[223169]|0)!=2){f[c>>2]=165456;f[c+4>>2]=110;b[c+8>>0]=0;J_b(892676,c);a_b(c)}zGb(536824);C_b(536824);u=a;return}function LFb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,456838);WXb();mKb();if((f[223170]|0)!=2){f[c>>2]=165456;f[c+4>>2]=111;b[c+8>>0]=0;J_b(892680,c);a_b(c)}f[134232]=109228;f[134233]=0;f[134234]=0;f[134235]=0;f[134236]=0;f[134237]=0;f[134238]=0;f[134239]=0;C_b(536928);f[134238]=537112;u=a;return}function MFb(){d_b(3005001,3005e3,456838);WXb();f[134240]=109120;f[134241]=0;f[134242]=537368;f[134243]=537368;f[134244]=0;C_b(536960);return}function NFb(a){a=a|0;var c=0,d=0;f[a>>2]=109120;c=f[a+8>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+12>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function OFb(a){a=a|0;NFb(a);cYc(a);return}function PFb(a){a=a|0;a=$Xc(20)|0;dGb(a);return a|0}function QFb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(20)|0;dGb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19184,24);a=QXb(b,24)|0;eGb(a,b);c=a;return c|0}function RFb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function SFb(a){a=a|0;return f[a+4>>2]|0}function TFb(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+12>>2]|0;do if((d|0)!=537368){a=d+11|0;if((b[a>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[a>>0]=0;break}}while(0);d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;sqc(c);return}function UFb(a){a=a|0;return 1}function VFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=c+4|0;e=a+8|0;g=a+4|0;h=a+8|0;i=a+12|0;j=a+12|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=ZYb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}b:do if((n|0)==6){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)!=10){p=m;break b}l=f[g>>2]|0;a=l&-2;if(!(l&1))q=a;else q=f[a+4>>2]|0;a=f[e>>2]|0;if((a|0)==537368){xJa(e,q,537368);r=f[e>>2]|0}else r=a;if(!(l$b(c,r)|0)){s=0;n=34;break a}a=f[h>>2]|0;l=b[a+11>>0]|0;if(l<<24>>24<0){t=f[a>>2]|0;u=f[a+4>>2]|0}else{t=a;u=l&255}if(m$b(t,u,0,456921)|0)continue a;else{s=0;n=34;break a}break}case 2:{if((m&255|0)!=18){p=m;break b}l=f[g>>2]|0;a=l&-2;if(!(l&1))v=a;else v=f[a+4>>2]|0;a=f[i>>2]|0;if((a|0)==537368){xJa(i,v,537368);w=f[i>>2]|0}else w=a;if(!(l$b(c,w)|0)){s=0;n=34;break a}a=f[j>>2]|0;l=b[a+11>>0]|0;if(l<<24>>24<0){x=f[a>>2]|0;y=f[a+4>>2]|0}else{x=a;y=l&255}if(m$b(x,y,0,456965)|0)continue a;else{s=0;n=34;break a}break}default:{p=m;break b}}}while(0);if(!p){s=1;n=34;break}l=f[g>>2]|0;if(!(l&1))z=lSa(g)|0;else z=l&-2;if(!(Lqc(c,p,z)|0)){s=0;n=34;break}}if((n|0)==34)return s|0;return 0}function WFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;d=b[h+11>>0]|0;e=d<<24>>24<0;if(e)j=f[h+4>>2]|0;else j=d&255;if(!j){k=i;l=a+16|0;f[l>>2]=k;return k|0}j=e?f[h+4>>2]|0:d&255;k=i+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=a+16|0;f[l>>2]=k;return k|0}function XFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}m$b(j,k,1,456921)|0;f$b(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}m$b(m,n,1,456965)|0;f$b(2,f[d>>2]|0,c)}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function YFb(a){a=a|0;return f[a+16>>2]|0}function ZFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}m$b(k,l,1,456921)|0;l=f[c>>2]|0;b[d>>0]=10;j=gZb(l,d+1|0)|0}d=a+12|0;l=f[d>>2]|0;c=b[l+11>>0]|0;k=c<<24>>24<0;if(k)m=f[l+4>>2]|0;else m=c&255;if(!m)n=j;else{if(k){o=f[l>>2]|0;p=f[l+4>>2]|0}else{o=l;p=c&255}m$b(o,p,1,456965)|0;p=f[d>>2]|0;b[j>>0]=18;n=gZb(p,j+1|0)|0}j=f[a+4>>2]|0;if(!((j&1|0)!=0&(b[476924]|0)!=0)){q=n;return q|0}q=Pqc(j&-2,n)|0;return q|0}function _Fb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+4|0;e=f[a+8>>2]|0;do if((e|0)!=537368){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);e=f[a+12>>2]|0;do if((e|0)!=537368){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);e=f[d>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d);d=kZc(c,21568,19184,0)|0;if(!d){Ooc(c,a);return}else{cGb(a,d);return}}function $Fb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,19184,0)|0;if(!c){Ooc(b,a);return}else{cGb(a,c);return}}function aGb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function bGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223166]|0)!=2){f[d>>2]=165456;f[d+4>>2]=107;b[d+8>>0]=0;J_b(892664,d);a_b(d)}d=537016;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function cGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)l=f[e+4>>2]|0;else l=c&255;if(!l)return;l=a+12|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))m=d;else m=f[d+4>>2]|0;d=f[l>>2]|0;if((d|0)==537368){xJa(l,m,e);return}else{oYc(d,e)|0;return}}function dGb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=109120;f[a+4>>2]=0;if((a|0)!=536960?(f[223172]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=113;b[d+8>>0]=0;J_b(892688,d);a_b(d)}f[a+8>>2]=537368;f[a+12>>2]=537368;f[a+16>>2]=0;u=c;return}function eGb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=109120;f[a+4>>2]=c;if((f[223172]|0)!=2){f[e>>2]=165456;f[e+4>>2]=113;b[e+8>>0]=0;J_b(892688,e);a_b(e)}f[a+8>>2]=537368;f[a+12>>2]=537368;f[a+16>>2]=0;u=d;return}function fGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=109228;if((a|0)!=536928?(b=f[a+24>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function gGb(a){a=a|0;fGb(a);cYc(a);return}function hGb(a){a=a|0;a=$Xc(32)|0;LHb(a);return a|0}function iGb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(32)|0;LHb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19200,32);a=QXb(b,32)|0;MHb(a,b);c=a;return c|0}function jGb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function kGb(a){a=a|0;return f[a+4>>2]|0}function lGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{sHb(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}b=a+4|0;c=f[b>>2]|0;e=c&-2;if(!(c&1))g=e;else g=f[e+4>>2]|0;e=a+24|0;if((g|0)==0?(g=f[e>>2]|0,(g|0)!=0):0){Yi[f[(f[g>>2]|0)+4>>2]&4095](g);h=f[b>>2]|0}else h=c;f[e>>2]=0;if(!(h&1))return;e=h&-2;if(!(f[e>>2]|0))return;sqc(e);return}function mGb(a){a=a|0;return 1}function nGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+24|0;i=e+4|0;j=a+8|0;k=a+20|0;l=a+16|0;m=a+12|0;n=e+4|0;o=a+4|0;a:while(1){p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=p+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=ZYb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=10){w=s;break b}r=f[h>>2]|0;if(!r){yGb(a);x=f[h>>2]|0}else x=r;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(p=b[r>>0]|0,p<<24>>24>-1):0){f[c>>2]=r+1;y=p&255}else{p=YYb(c)|0;if((p|0)>-1)y=p;else{z=0;t=44;break a}}JYb(e,c,y);if((f[i>>2]|0)<0){t=16;break a}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){t=16;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{z=0;t=44;break a}break}case 2:break;default:{w=s;break b}}if((s&255|0)==18){p=f[k>>2]|0;do if(p){r=f[m>>2]|0;q=f[p>>2]|0;if((r|0)>=(q|0))if((q|0)==(f[l>>2]|0)){A=q;t=24;break}else{B=q;C=p;t=25;break}else{f[m>>2]=r+1;D=f[p+4+(r<<2)>>2]|0;break}}else{A=f[l>>2]|0;t=24}while(0);if((t|0)==24){t=0;XZb(j,A+1|0);p=f[k>>2]|0;B=f[p>>2]|0;C=p;t=25}if((t|0)==25){t=0;f[C>>2]=B+1;p=f[j>>2]|0;if(!p){r=$Xc(100)|0;zGb(r);E=r}else{if(f[p+64>>2]|0)SXb(p,19216,104);r=QXb(p,104)|0;BGb(r,p);E=r}r=f[k>>2]|0;p=f[m>>2]|0;f[m>>2]=p+1;f[r+4+(p<<2)>>2]=E;D=E}p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(r=b[p>>0]|0,r<<24>>24>-1):0){f[c>>2]=p+1;F=r&255}else{r=YYb(c)|0;if((r|0)>-1)F=r;else{z=0;t=44;break a}}JYb(e,c,F);if((f[n>>2]|0)<0){t=37;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){t=37;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{z=0;t=44;break a}}else w=s}while(0);if(!w){z=1;t=44;break}r=f[o>>2]|0;if(!(r&1))G=lSa(o)|0;else G=r&-2;if(!(Lqc(c,w,G)|0)){z=0;t=44;break}}if((t|0)==16){z=0;u=d;return z|0}else if((t|0)==37){z=0;u=d;return z|0}else if((t|0)==44){u=d;return z|0}return 0}function oGb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}if((a|0)==536928){k=g;l=a+28|0;f[l>>2]=k;return k|0}i=f[a+24>>2]|0;if(!i){k=g;l=a+28|0;f[l>>2]=k;return k|0}c=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;k=g+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=a+28|0;f[l>>2]=k;return k|0}function pGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)!=536928?(d=f[a+24>>2]|0,d|0):0)k$b(1,d,c);d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{k$b(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function qGb(a){a=a|0;return f[a+28>>2]|0}function rGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((a|0)!=536928?(e=f[a+24>>2]|0,(e|0)!=0):0){b[d>>0]=10;g=d+1|0;h=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(h>>>0>127){i=h;j=g;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=g;n=h}b[m>>0]=n;o=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,m+1|0)|0}else o=d;d=f[a+12>>2]|0;if(!d)p=o;else{m=a+20|0;e=0;n=o;while(1){o=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;b[n>>0]=18;h=n+1|0;g=_i[f[(f[o>>2]|0)+60>>2]&2047](o)|0;if(g>>>0>127){j=g;i=h;while(1){b[i>>0]=j|128;k=j>>>7;l=i+1|0;if(j>>>0>16383){j=k;i=l}else{q=l;r=k;break}}}else{q=h;r=g}b[q>>0]=r;i=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,q+1|0)|0;e=e+1|0;if((e|0)==(d|0)){p=i;break}else n=i}}n=f[a+4>>2]|0;if(!((n&1|0)!=0&(b[476924]|0)!=0)){s=p;return s|0}s=Pqc(n&-2,p)|0;return s|0}function sGb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((a|0)==(b|0))return;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{sHb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+4|0;d=f[c>>2]|0;g=d&-2;if(!(d&1))h=g;else h=f[g+4>>2]|0;g=a+24|0;if((h|0)==0?(h=f[g>>2]|0,(h|0)!=0):0){Yi[f[(f[h>>2]|0)+4>>2]&4095](h);i=f[c>>2]|0}else i=d;f[g>>2]=0;if(i&1|0?(g=i&-2,f[g>>2]|0):0)sqc(g);g=kZc(b,21568,19200,0)|0;if(!g){Ooc(b,a);return}else{wGb(a,g);return}}function tGb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,19200,0)|0;if(!c){Ooc(b,a);return}else{wGb(a,c);return}}function uGb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function vGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223166]|0)!=2){f[d>>2]=165456;f[d+4>>2]=107;b[d+8>>0]=0;J_b(892664,d);a_b(d)}d=537008;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function wGb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}xGb(a+8|0,b+8|0);if((b|0)==536928)return;d=b+24|0;b=f[d>>2]|0;if(!b)return;g=a+24|0;e=f[g>>2]|0;if(!e){yGb(a);h=f[d>>2]|0;i=f[g>>2]|0}else{h=b;i=e}gJb(i,h|0?h:537112);return}function xGb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{AGb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(100)|0;zGb(l);AGb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,19216,104);l=QXb(i,104)|0;BGb(l,i);AGb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function yGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(80)|0;OIb(c);e=c;g=a+24|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,19344,80);c=QXb(d,80)|0;QIb(c,d);e=c;g=a+24|0;f[g>>2]=e;return}function zGb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=109336;e=a+56|0;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=171580;f[a+60>>2]=0;f[a+64>>2]=0;w_b(a+68|0);f[a+72>>2]=0;f[e>>2]=109444;f[a+76>>2]=0;e=a+80|0;f[e>>2]=0;g=a+84|0;f[g>>2]=0;aJa(e);f[g>>2]=0;if((a|0)!=536824?(f[223170]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=111;b[d+8>>0]=0;J_b(892680,d);a_b(d)}f[a+92>>2]=537368;f[a+96>>2]=0;u=c;return}function AGb(a,b){a=a|0;b=b|0;DHb(b,a);return}function BGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=109336;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=c;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=c;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;g=a+56|0;f[g>>2]=171580;f[a+60>>2]=c;f[a+64>>2]=0;h=a+68|0;w_b(h);f[a+72>>2]=0;tSa(c,h);f[g>>2]=109444;f[a+76>>2]=c;g=a+80|0;f[g>>2]=c;c=a+84|0;f[c>>2]=0;aJa(g);f[c>>2]=0;if((f[223170]|0)==2){i=a+92|0;f[i>>2]=537368;j=a+96|0;f[j>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=111;b[e+8>>0]=0;J_b(892680,e);a_b(e);i=a+92|0;f[i>>2]=537368;j=a+96|0;f[j>>2]=0;u=d;return}function CGb(a){a=a|0;f[a>>2]=109444;zIa(a+24|0);Ljc(a);return}function DGb(a){a=a|0;f[a>>2]=109444;zIa(a+24|0);Ljc(a);cYc(a);return}function EGb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;lYc(g,OSa(c)|0);yIa(e,f[a+32>>2]|0,g,0);a=(f[e>>2]|0)!=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}cYc(f[g>>2]|0);u=d;return a|0}function FGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e+16|0;h=e;i=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;lYc(h,OSa(c)|0);yIa(g,f[i+8>>2]|0,h,0);c=f[g>>2]|0;if(!c){j=1;k=bJa(i,h)|0}else{j=0;k=(f[c+12>>2]|0)+16|0}f[d>>2]=k;if((b[h+11>>0]|0)>=0){u=e;return j|0}cYc(f[h>>2]|0);u=e;return j|0}function GGb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;lYc(e,OSa(c)|0);c=(PSa(_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0,e)|0)!=0;if((b[e+11>>0]|0)>=0){u=d;return c|0}cYc(f[e>>2]|0);u=d;return c|0}function HGb(a){a=a|0;elc(a);return f[f[a+32>>2]>>2]|0}function IGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;d=f[a+8>>2]|0;if(!d)e=12;else{g=f[d+8>>2]<<2;h=d+12|0;d=f[h>>2]|0;if(!d)i=g;else{if((f[d>>2]|0)>0){j=0;k=g;l=d;while(1){d=f[l+4+(j<<2)>>2]|0;m=(_i[f[(f[d>>2]|0)+84>>2]&2047](d)|0)+k|0;j=j+1|0;l=f[h>>2]|0;if((j|0)>=(f[l>>2]|0)){n=m;break}else k=m}}else n=g;i=n+4|0}e=i+12|0}i=f[a+32>>2]|0;a=f[i+12>>2]|0;n=f[i+4>>2]|0;a:do if(n>>>0>a>>>0){g=f[i+16>>2]|0;k=a;while(1){o=f[g+(k<<2)>>2]|0;if(o|0)break;l=k+1|0;if(l>>>0<n>>>0)k=l;else{p=0;q=l;break a}}if((o|0)==(f[g+((k^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=k;break}else{p=o;q=k;break}}else{p=0;q=a}while(0);f[c>>2]=p;f[c+4>>2]=i;f[c+8>>2]=q;if(!p){r=e;u=b;return r|0}q=e;e=p;while(1){p=(f[e+12>>2]|0)+16|0;i=q+12+(_i[f[(f[p>>2]|0)+84>>2]&2047](p)|0)|0;UIa(c)|0;e=f[c>>2]|0;if(!e){r=i;break}else q=i}u=b;return r|0}function JGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;b=u;u=u+16|0;c=b;d=a+8|0;e=f[d>>2]|0;if(!e){g=f[a+4>>2]|0;if(!g){h=$Xc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}else{if(f[g+64>>2]|0)SXb(g,15384,16);h=RXb(g,16,2244)|0;f[h>>2]=g;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}f[d>>2]=i;j=i}else j=e;e=j+4|0;i=f[e>>2]|0;if((i|0)>0){d=f[j+12>>2]|0;h=0;do{g=f[d+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[g>>2]|0)+28>>2]&4095](g)}while((h|0)!=(i|0));f[e>>2]=0}i=f[a+32>>2]|0;h=f[i+12>>2]|0;d=f[i+4>>2]|0;a:do if(d>>>0>h>>>0){g=f[i+16>>2]|0;k=h;while(1){l=f[g+(k<<2)>>2]|0;if(l|0)break;m=k+1|0;if(m>>>0<d>>>0)k=m;else{n=0;o=m;break a}}if((l|0)==(f[g+((k^1)<<2)>>2]|0)){n=f[(f[l>>2]|0)+16>>2]|0;o=k;break}else{n=l;o=k;break}}else{n=0;o=h}while(0);f[c>>2]=n;f[c+4>>2]=i;f[c+8>>2]=o;if(!n){u=b;return}n=a+4|0;a=j+12|0;o=j+8|0;do{i=Mi[f[(f[134200]|0)+16>>2]&1023](536800,f[n>>2]|0)|0;h=i+12|0;l=f[h>>2]|0;d=f[j>>2]|0;if(((d|0)==(l|0)?(m=f[a>>2]|0,(m|0)!=0):0)?(p=f[m>>2]|0,(p|0)<(f[o>>2]|0)):0){q=f[e>>2]|0;if((q|0)<(p|0)){r=m+4+(q<<2)|0;f[m+4+(p<<2)>>2]=f[r>>2];s=r}else s=m+4+(q<<2)|0;f[s>>2]=i;f[e>>2]=q+1;q=f[a>>2]|0;f[q>>2]=(f[q>>2]|0)+1}else OGb(j,i,l,d);d=f[(f[c>>2]|0)+12>>2]|0;l=i+16|0;f[l>>2]=f[l>>2]|1;q=i+4|0;m=f[q>>2]|0;if((m|0)==537368){xJa(q,f[h>>2]|0,537368);t=f[q>>2]|0}else t=m;oYc(t,d)|0;d=(f[(f[c>>2]|0)+12>>2]|0)+16|0;f[l>>2]=f[l>>2]|2;l=i+8|0;i=f[h>>2]|0;h=f[l>>2]|0;if(!h){if(!i){m=$Xc(24)|0;ISa(m);v=m}else{if(f[i+64>>2]|0)SXb(i,15400,24);m=QXb(i,24)|0;JSa(m,i);v=m}f[l>>2]=v;w=v}else w=h;kUa(w,d);RIa(c)|0}while((f[c>>2]|0)!=0);u=b;return}function KGb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=a+24|0;e=f[a+8>>2]|0;if(!e){u_b(c,3,457044,306);r_b(b+24|0,p_b(c,457138)|0);v_b(c)}iSa(d);c=e+12|0;a=f[c>>2]|0;g=e+4|0;if(!(f[g>>2]|0)){u=b;return}e=(a|0)==0?0:a+4|0;do{a=f[e>>2]|0;h=_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0;a=f[e>>2]|0;kUa(bJa(d,_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0)|0,h);e=e+4|0;h=f[c>>2]|0}while((e|0)!=(((h|0)==0?0:h+4|0)+(f[g>>2]<<2)|0));u=b;return}function LGb(a){a=a|0;elc(a);return a+24|0}function MGb(a){a=a|0;elc(a);dlc(a);return a+24|0}function NGb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=b+8|0;d=a+12|0;a=f[d>>2]|0;e=b+16|0;if((f[e>>2]|0)==9)g=f[c>>2]|0;else{f[e>>2]=9;e=$Xc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[c>>2]=e;g=e}oYc(g,a)|0;f[b+24>>2]=(f[d>>2]|0)+16;return}function OGb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){if(!d){e=$Xc(24)|0;f[e+12>>2]=0;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)SXb(d,19248,24);e=QXb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=109528;QGb(b,g);if((b|0)==0|(c|0)!=0)i=g;else{Yi[f[(f[b>>2]|0)+4>>2]&4095](b);i=g}}else i=b;else{PGb(d,b);i=b}b=a+12|0;d=f[b>>2]|0;g=f[a+8>>2]|0;c=a+4|0;if(d|0?(e=f[c>>2]|0,(e|0)!=(g|0)):0){h=f[d>>2]|0;if((h|0)==(g|0)){j=f[d+4+(e<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}Yi[f[(f[j>>2]|0)+4>>2]&4095](j);k=f[b>>2]|0;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}else{if((e|0)<(h|0)){f[d+4+(h<<2)>>2]=f[d+4+(e<<2)>>2];e=f[b>>2]|0;o=e;p=f[e>>2]|0}else{o=d;p=h}f[o>>2]=p+1;k=o;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}}XZb(a,g+1|0);g=f[b>>2]|0;f[g>>2]=(f[g>>2]|0)+1;k=g;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}function PGb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function QGb(a,b){a=a|0;b=b|0;RGb(b,a);return}function RGb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+16|0;d=f[c>>2]|0;if(!d)return;if(!(d&1))e=d;else{d=a+4|0;g=a+12|0;if((f[d>>2]|0)==537368)xJa(d,f[g>>2]|0,537368);h=_i[f[(f[b>>2]|0)+100>>2]&2047](b)|0;i=f[d>>2]|0;if((i|0)==537368)xJa(d,f[g>>2]|0,h);else oYc(i,h)|0;h=a+16|0;f[h>>2]=f[h>>2]|1;e=f[c>>2]|0}if(!(e&2))return;e=a+8|0;c=f[a+12>>2]|0;if(!(f[e>>2]|0)){if(!c){h=$Xc(24)|0;ISa(h);j=h}else{if(f[c+64>>2]|0)SXb(c,15400,24);h=QXb(c,24)|0;JSa(h,c);j=h}f[e>>2]=j}j=_i[f[(f[b>>2]|0)+104>>2]&2047](b)|0;kSa(f[e>>2]|0,j);j=a+16|0;f[j>>2]=f[j>>2]|2;return}function SGb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=109644;c=a+20|0;d=f[c>>2]|0;if(d&1|0?(e=d&-2,d=e,!((e|0)==0|(f[d+4>>2]|0)!=0)):0){if(f[d>>2]|0)sqc(d);cYc(e)}f[c>>2]=0;f[a>>2]=109760;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function TGb(a){a=a|0;SGb(a);cYc(a);return}function UGb(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function VGb(a){a=a|0;a=$Xc(24)|0;f[a+12>>2]=0;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a>>2]=109528;return a|0}function WGb(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=$Xc(24)|0;f[a+12>>2]=0;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;c=a;f[c>>2]=109528;return c|0}if(f[b+64>>2]|0)SXb(b,19248,24);a=QXb(b,24)|0;d=b;f[a+12>>2]=d;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=d;c=a;f[c>>2]=109528;return c|0}function XGb(a){a=a|0;return f[a+12>>2]|0}function YGb(a){a=a|0;var c=0,d=0;c=f[a+4>>2]|0;do if((c|0)!=537368){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+8>>2]|0;if(c|0)WTa(c);c=a+16|0;f[c>>2]=f[c>>2]&-4;return}function ZGb(a){a=a|0;return XTa(f[a+8>>2]|0)|0}function _Gb(a,b){a=a|0;b=b|0;RGb(a,b);return}function $Gb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+4|0;j=a+12|0;k=a+8|0;a=e+4|0;l=c+32|0;m=c+12|0;n=c+28|0;a:while(1){o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;r=q}else{s=q;t=5}}else{s=0;t=5}if((t|0)==5){t=0;r=ZYb(c,s)|0}switch(r|0){case 0:{v=1;t=35;break a;break}case 10:{f[h>>2]=f[h>>2]|1;q=f[i>>2]|0;if((q|0)==537368){xJa(i,f[j>>2]|0,537368);w=f[i>>2]|0}else w=q;if(!(l$b(c,w)|0)){v=0;t=35;break a}q=f[h>>2]|1;f[h>>2]=q;o=f[c>>2]|0;if(o>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[o>>0]|0)!=18)continue a;f[c>>2]=o+1;x=q;break}case 18:{x=f[h>>2]|0;break}default:{if((r&7|0)==4){v=1;t=35;break a}if(O_b(c,r)|0)continue a;else{v=0;t=35;break a}}}f[h>>2]=x|2;q=f[j>>2]|0;o=f[k>>2]|0;if(!o){if(!q){p=$Xc(24)|0;ISa(p);y=p}else{if(f[q+64>>2]|0)SXb(q,15400,24);p=QXb(q,24)|0;JSa(p,q);y=p}f[k>>2]=y;z=y}else z=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(p=b[o>>0]|0,p<<24>>24>-1):0){f[c>>2]=o+1;A=p&255}else{p=YYb(c)|0;if((p|0)>-1)A=p;else{v=0;t=35;break}}JYb(e,c,A);if((f[a>>2]|0)<0){t=27;break}if(!(BTa(z,c)|0)){t=27;break}if(!(OYb(c,f[e>>2]|0)|0)){v=0;t=35;break}f[h>>2]=f[h>>2]|2;if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[l>>2]|0){t=32;break}if((f[m>>2]|0)==(f[n>>2]|0)){t=32;break}}if((t|0)==27){v=0;u=d;return v|0}else if((t|0)==32){f[c+20>>2]=0;b[c+24>>0]=1;v=1;u=d;return v|0}else if((t|0)==35){u=d;return v|0}return 0}function aHb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=ATa(_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0)|0;j=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function bHb(a,b){a=a|0;b=b|0;e$b(1,_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0,b);k$b(2,_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0,b);return}function cHb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=(_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0)+16|0;a=f[e>>2]|0;j=a+1+((((($(a|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function dHb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;b[d>>0]=10;g=gZb(e,d+1|0)|0;d=_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0;b[g>>0]=18;a=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(g>>>0>127){e=g;h=a;while(1){b[h>>0]=e|128;i=e>>>7;j=h+1|0;if(e>>>0>16383){e=i;h=j}else{k=j;l=i;break}}}else{k=a;l=g}b[k>>0]=l;return hj[f[(f[d>>2]|0)+64>>2]&511](d,c,k+1|0)|0}function eHb(a,b){a=a|0;b=b|0;rlc(a,b);return}function fHb(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+84>>2]&2047](b)|0)+28|0}function gHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223166]|0)!=2){f[d>>2]=165456;f[d+4>>2]=107;b[d+8>>0]=0;J_b(892664,d);a_b(d)}d=536992;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function hHb(a){a=a|0;return f[a+4>>2]|0}function iHb(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (b|0?b:f[134202]|0)|0}function jHb(a){a=a|0;var c=0;f[a>>2]=109760;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function kHb(a){a=a|0;var c=0;f[a>>2]=109760;if(f[a+12>>2]|0){cYc(a);return}c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c){cYc(a);return}Yi[f[(f[c>>2]|0)+4>>2]&4095](c);cYc(a);return}function lHb(a){a=a|0;SGb(a);cYc(a);return}function mHb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=109336;c=f[a+92>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+56|0;f[c>>2]=109444;zIa(a+80|0);Ljc(c);c=a+52|0;d=f[c>>2]|0;if(d|0?(f[a+40>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+36|0;i=f[c>>2]|0;if(i|0?(f[a+24>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);cYc(g)}e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+20|0;j=f[c>>2]|0;if(j|0?(f[a+8>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(k);f[c>>2]=0;return}function nHb(a){a=a|0;mHb(a);cYc(a);return}function oHb(a){a=a|0;a=$Xc(100)|0;zGb(a);return a|0}function pHb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(100)|0;zGb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19216,104);a=QXb(b,104)|0;BGb(a,b);c=a;return c|0}function qHb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function rHb(a){a=a|0;return f[a+4>>2]|0}function sHb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+28|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+36>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+44|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+52>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+56|0;elc(c);iSa(a+80|0);dlc(c);c=a+4|0;d=f[a+92>>2]|0;do if((d|0)!=537368){a=d+11|0;if((b[a>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[a>>0]=0;break}}while(0);d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;sqc(c);return}function tHb(a){a=a|0;return 1}function uHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=a+8|0;j=a+12|0;k=a+20|0;l=a+92|0;m=a+4|0;n=a+92|0;o=a+24|0;p=a+28|0;q=a+36|0;r=a+40|0;s=a+44|0;t=a+52|0;v=a+56|0;a=g+4|0;w=g+8|0;x=g+24|0;y=e+4|0;z=w+11|0;A=g+12|0;a:while(1){B=f[c>>2]|0;if(B>>>0<(f[h>>2]|0)>>>0){C=b[B>>0]|0;D=C&255;if(C<<24>>24>0){f[c>>2]=B+1;E=D;F=6}else{G=D;F=5}}else{G=0;F=5}if((F|0)==5){F=0;D=ZYb(c,G)|0;if((D+-1|0)>>>0<127){E=D;F=6}else H=D}b:do if((F|0)==6){F=0;switch(E>>>3&536870911|0){case 1:{if((E&255|0)!=10){H=E;break b}if(!(l$b(c,pHa(i)|0)|0)){I=0;F=57;break a}D=f[(f[k>>2]|0)+4+((f[j>>2]|0)+-1<<2)>>2]|0;B=b[D+11>>0]|0;if(B<<24>>24<0){J=f[D>>2]|0;K=f[D+4>>2]|0}else{J=D;K=B&255}if(m$b(J,K,0,457938)|0)continue a;else{I=0;F=57;break a}break}case 2:{if((E&255|0)!=18){H=E;break b}B=f[m>>2]|0;D=B&-2;if(!(B&1))L=D;else L=f[D+4>>2]|0;D=f[l>>2]|0;if((D|0)==537368){xJa(l,L,537368);M=f[l>>2]|0}else M=D;if(!(l$b(c,M)|0)){I=0;F=57;break a}D=f[n>>2]|0;B=b[D+11>>0]|0;if(B<<24>>24<0){N=f[D>>2]|0;O=f[D+4>>2]|0}else{N=D;O=B&255}if(m$b(N,O,0,457977)|0)continue a;else{I=0;F=57;break a}break}case 3:{if((E&255|0)!=26){H=E;break b}if(!(l$b(c,pHa(o)|0)|0)){I=0;F=57;break a}B=f[(f[q>>2]|0)+4+((f[p>>2]|0)+-1<<2)>>2]|0;D=b[B+11>>0]|0;if(D<<24>>24<0){P=f[B>>2]|0;Q=f[B+4>>2]|0}else{P=B;Q=D&255}if(m$b(P,Q,0,458015)|0)continue a;else{I=0;F=57;break a}break}case 4:{if((E&255|0)!=34){H=E;break b}if(!(l$b(c,pHa(r)|0)|0)){I=0;F=57;break a}D=f[(f[t>>2]|0)+4+((f[s>>2]|0)+-1<<2)>>2]|0;B=b[D+11>>0]|0;if(B<<24>>24<0){R=f[D>>2]|0;S=f[D+4>>2]|0}else{R=D;S=B&255}if(m$b(R,S,0,458054)|0)continue a;else{I=0;F=57;break a}break}case 5:{if((E&255|0)!=42){H=E;break b}f[g>>2]=v;B=_i[f[(f[v>>2]|0)+68>>2]&2047](v)|0;f[a>>2]=B;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[x>>2]=0;B=f[c>>2]|0;if(B>>>0<(f[h>>2]|0)>>>0?(D=b[B>>0]|0,D<<24>>24>-1):0){f[c>>2]=B+1;T=D&255;F=41}else{D=YYb(c)|0;if((D|0)>-1){T=D;F=41}else U=6}do if((F|0)==41){F=0;JYb(e,c,T);if((f[y>>2]|0)>=0?IHb(g,c)|0:0){if(!(OYb(c,f[e>>2]|0)|0)){U=6;break}D=b[z>>0]|0;B=D<<24>>24<0;C=m$b(B?f[w>>2]|0:w,B?f[A>>2]|0:D&255,0,458093)|0;U=C?0:6;break}U=6}while(0);C=f[x>>2]|0;if(C|0)Yi[f[(f[C>>2]|0)+4>>2]&4095](C);if((b[z>>0]|0)<0)cYc(f[w>>2]|0);switch(U&7){case 0:{continue a;break}case 6:{I=0;F=57;break a;break}default:{F=56;break a}}break}default:{H=E;break b}}}while(0);if(!H){F=56;break}C=f[m>>2]|0;if(!(C&1))V=lSa(m)|0;else V=C&-2;if(!(Lqc(c,H,V)|0)){I=0;F=57;break}}if((F|0)==56){I=1;u=d;return I|0}else if((F|0)==57){u=d;return I|0}return 0}function vHb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;if((e&1|0)!=0&(b[476924]|0)!=0)g=Rqc(e&-2)|0;else g=0;e=f[a+12>>2]|0;h=e+g|0;if((e|0)>0){g=f[a+20>>2]|0;i=0;j=h;while(1){k=f[g+4+(i<<2)>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0?f[k+4>>2]|0:l&255;l=m+j+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(e|0)){n=l;break}else j=l}}else n=h;h=f[a+28>>2]|0;j=h+n|0;if((h|0)>0){n=f[a+36>>2]|0;e=0;i=j;while(1){g=f[n+4+(e<<2)>>2]|0;l=b[g+11>>0]|0;m=l<<24>>24<0?f[g+4>>2]|0:l&255;l=m+i+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){o=l;break}else i=l}}else o=j;j=f[a+44>>2]|0;i=j+o|0;if((j|0)>0){o=f[a+52>>2]|0;h=0;e=i;while(1){n=f[o+4+(h<<2)>>2]|0;l=b[n+11>>0]|0;m=l<<24>>24<0?f[n+4>>2]|0:l&255;l=m+e+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(j|0)){p=l;break}else e=l}}else p=i;i=a+56|0;elc(i);e=a+88|0;j=f[f[e>>2]>>2]|0;elc(i);h=j+p|0;p=f[e>>2]|0;e=f[p+12>>2]|0;j=f[p+4>>2]|0;a:do if(j>>>0>e>>>0){o=f[p+16>>2]|0;l=e;while(1){q=f[o+(l<<2)>>2]|0;if(q|0)break;m=l+1|0;if(m>>>0<j>>>0)l=m;else{r=0;s=m;break a}}if((q|0)==(f[o+((l^1)<<2)>>2]|0)){r=f[(f[q>>2]|0)+16>>2]|0;s=l;break}else{r=q;s=l;break}}else{r=0;s=e}while(0);f[d>>2]=r;f[d+4>>2]=p;f[d+8>>2]=s;s=a+76|0;p=h;h=0;while(1){elc(i);r=f[d>>2]|0;if(!r)break;if(!h){t=0;v=r}else{r=(_i[f[(f[h>>2]|0)+20>>2]&2047](h)|0)==0;t=r?h:0;v=f[d>>2]|0}r=f[v+12>>2]|0;e=r+16|0;q=f[s>>2]|0;if(!q){j=$Xc(32)|0;f[j+12>>2]=0;f[j+4>>2]=537368;f[j+8>>2]=0;f[j+20>>2]=0;w=j}else{if(f[q+64>>2]|0)SXb(q,19296,32);j=QXb(q,32)|0;m=q;f[j+12>>2]=m;f[j+4>>2]=537368;f[j+8>>2]=0;f[j+20>>2]=m;w=j}f[w>>2]=109876;f[w+24>>2]=r;f[w+28>>2]=e;f[w+16>>2]=3;if((t|0)!=(w|0))if(!t)x=w;else{Yi[f[(f[t>>2]|0)+4>>2]&4095](t);x=w}else x=t;e=x+16|0;r=f[e>>2]|0;if(!(r&1)){y=r;z=0}else{r=_i[f[(f[x>>2]|0)+100>>2]&2047](x)|0;j=b[r+11>>0]|0;m=j<<24>>24<0?f[r+4>>2]|0:j&255;j=m+1+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;y=f[e>>2]|0;z=j}if(!(y&2))A=0;else{j=ATa(_i[f[(f[x>>2]|0)+104>>2]&2047](x)|0)|0;A=j+1+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=A+z|0;e=j+p+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;RIa(d)|0;p=e;h=x}if(h|0?(_i[f[(f[h>>2]|0)+20>>2]&2047](h)|0)==0:0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);h=f[a+92>>2]|0;x=b[h+11>>0]|0;d=x<<24>>24<0;if(d)B=f[h+4>>2]|0;else B=x&255;if(!B){C=p;D=a+96|0;f[D>>2]=C;u=c;return C|0}B=d?f[h+4>>2]|0:x&255;C=p+1+B+((((($(B|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=a+96|0;f[D>>2]=C;u=c;return C|0}function wHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=f[a+12>>2]|0;if((g|0)>0){h=a+20|0;i=0;do{j=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j>>2]|0;m=f[j+4>>2]|0}else{l=j;m=k&255}m$b(l,m,1,457938)|0;e$b(1,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}g=a+92|0;i=f[g>>2]|0;h=b[i+11>>0]|0;m=h<<24>>24<0;if(m)n=f[i+4>>2]|0;else n=h&255;if(n|0){if(m){o=f[i>>2]|0;p=f[i+4>>2]|0}else{o=i;p=h&255}m$b(o,p,1,457977)|0;f$b(2,f[g>>2]|0,c)}g=f[a+28>>2]|0;if((g|0)>0){p=a+36|0;o=0;do{h=f[(f[p>>2]|0)+4+(o<<2)>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){q=f[h>>2]|0;r=f[h+4>>2]|0}else{q=h;r=i&255}m$b(q,r,1,458015)|0;e$b(3,f[(f[p>>2]|0)+4+(o<<2)>>2]|0,c);o=o+1|0}while((o|0)!=(g|0))}g=f[a+44>>2]|0;if((g|0)>0){o=a+52|0;p=0;do{r=f[(f[o>>2]|0)+4+(p<<2)>>2]|0;q=b[r+11>>0]|0;if(q<<24>>24<0){s=f[r>>2]|0;t=f[r+4>>2]|0}else{s=r;t=q&255}m$b(s,t,1,458054)|0;e$b(4,f[(f[o>>2]|0)+4+(p<<2)>>2]|0,c);p=p+1|0}while((p|0)!=(g|0))}g=a+56|0;elc(g);p=a+88|0;do if(f[f[p>>2]>>2]|0){if(!(b[c+18>>0]|0)){if(f[223514]|0)v=31}else if(b[c+19>>0]|0)v=31;if((v|0)==31?(elc(g),(f[f[p>>2]>>2]|0)>>>0>1):0){elc(g);o=f[f[p>>2]>>2]|0;t=bYc(o>>>0>1073741823?-1:o<<2)|0;elc(g);o=f[p>>2]|0;s=f[o+12>>2]|0;q=f[o+4>>2]|0;a:do if(q>>>0>s>>>0){r=f[o+16>>2]|0;i=s;while(1){w=f[r+(i<<2)>>2]|0;if(w|0)break;h=i+1|0;if(h>>>0<q>>>0)i=h;else{x=0;y=h;break a}}if((w|0)==(f[r+((i^1)<<2)>>2]|0)){x=f[(f[w>>2]|0)+16>>2]|0;y=i;break}else{x=w;y=i;break}}else{x=0;y=s}while(0);f[e>>2]=x;f[e+4>>2]=o;f[e+8>>2]=y;s=0;while(1){elc(g);q=f[e>>2]|0;if(!q)break;f[t+(s<<2)>>2]=f[q+12>>2];RIa(e)|0;s=s+1|0}fTa(t,t+(s<<2)|0,e);if(s|0){o=a+76|0;q=0;h=0;do{m=t+(q<<2)|0;n=f[m>>2]|0;l=n+16|0;k=f[o>>2]|0;if(!k){j=$Xc(32)|0;f[j+12>>2]=0;f[j+4>>2]=537368;f[j+8>>2]=0;f[j+20>>2]=0;z=j}else{if(f[k+64>>2]|0)SXb(k,19296,32);j=QXb(k,32)|0;A=k;f[j+12>>2]=A;f[j+4>>2]=537368;f[j+8>>2]=0;f[j+20>>2]=A;z=j}f[z>>2]=109876;f[z+24>>2]=n;f[z+28>>2]=l;f[z+16>>2]=3;if((h|0)!=(z|0))if(!h)B=z;else{Yi[f[(f[h>>2]|0)+4>>2]&4095](h);B=z}else B=h;k$b(5,B,c);l=(_i[f[(f[B>>2]|0)+20>>2]&2047](B)|0)==0;h=l?B:0;l=f[m>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){C=f[l>>2]|0;D=f[l+4>>2]|0}else{C=l;D=m&255}m$b(C,D,1,458093)|0;q=q+1|0}while(q>>>0<s>>>0);if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h)}dYc(t);break}elc(g);s=f[p>>2]|0;q=f[s+12>>2]|0;o=f[s+4>>2]|0;b:do if(o>>>0>q>>>0){m=f[s+16>>2]|0;l=q;while(1){E=f[m+(l<<2)>>2]|0;if(E|0)break;n=l+1|0;if(n>>>0<o>>>0)l=n;else{F=0;G=n;break b}}if((E|0)==(f[m+((l^1)<<2)>>2]|0)){F=f[(f[E>>2]|0)+16>>2]|0;G=l;break}else{F=E;G=l;break}}else{F=0;G=q}while(0);f[e>>2]=F;f[e+4>>2]=s;f[e+8>>2]=G;q=a+76|0;o=0;while(1){elc(g);t=f[e>>2]|0;if(!t)break;h=f[t+12>>2]|0;t=h+16|0;i=f[q>>2]|0;if(!i){r=$Xc(32)|0;f[r+12>>2]=0;f[r+4>>2]=537368;f[r+8>>2]=0;f[r+20>>2]=0;H=r}else{if(f[i+64>>2]|0)SXb(i,19296,32);r=QXb(i,32)|0;n=i;f[r+12>>2]=n;f[r+4>>2]=537368;f[r+8>>2]=0;f[r+20>>2]=n;H=r}f[H>>2]=109876;f[H+24>>2]=h;f[H+28>>2]=t;f[H+16>>2]=3;if((o|0)!=(H|0))if(!o)I=H;else{Yi[f[(f[o>>2]|0)+4>>2]&4095](o);I=H}else I=o;k$b(5,I,c);t=(_i[f[(f[I>>2]|0)+20>>2]&2047](I)|0)==0;h=f[(f[e>>2]|0)+12>>2]|0;r=b[h+11>>0]|0;if(r<<24>>24<0){J=f[h>>2]|0;K=f[h+4>>2]|0}else{J=h;K=r&255}m$b(J,K,1,458093)|0;RIa(e)|0;o=t?I:0}if(o|0)Yi[f[(f[o>>2]|0)+4>>2]&4095](o)}while(0);I=f[a+4>>2]|0;if(!((I&1|0)!=0&(b[476924]|0)!=0)){u=d;return}Oqc(I&-2,c);u=d;return}function xHb(a){a=a|0;return f[a+96>>2]|0}function yHb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+16|0;g=e;h=f[a+12>>2]|0;if((h|0)>0){i=a+20|0;j=d;k=0;while(1){l=f[(f[i>>2]|0)+4+(k<<2)>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){n=f[l>>2]|0;o=f[l+4>>2]|0}else{n=l;o=m&255}m$b(n,o,1,457938)|0;m=f[(f[i>>2]|0)+4+(k<<2)>>2]|0;b[j>>0]=10;l=gZb(m,j+1|0)|0;k=k+1|0;if((k|0)==(h|0)){p=l;break}else j=l}}else p=d;d=a+92|0;j=f[d>>2]|0;h=b[j+11>>0]|0;k=h<<24>>24<0;if(k)q=f[j+4>>2]|0;else q=h&255;if(!q)r=p;else{if(k){s=f[j>>2]|0;t=f[j+4>>2]|0}else{s=j;t=h&255}m$b(s,t,1,457977)|0;t=f[d>>2]|0;b[p>>0]=18;r=gZb(t,p+1|0)|0}p=f[a+28>>2]|0;if((p|0)>0){t=a+36|0;d=0;s=r;while(1){h=f[(f[t>>2]|0)+4+(d<<2)>>2]|0;j=b[h+11>>0]|0;if(j<<24>>24<0){v=f[h>>2]|0;w=f[h+4>>2]|0}else{v=h;w=j&255}m$b(v,w,1,458015)|0;j=f[(f[t>>2]|0)+4+(d<<2)>>2]|0;b[s>>0]=26;h=gZb(j,s+1|0)|0;d=d+1|0;if((d|0)==(p|0)){x=h;break}else s=h}}else x=r;r=f[a+44>>2]|0;if((r|0)>0){s=a+52|0;p=0;d=x;while(1){t=f[(f[s>>2]|0)+4+(p<<2)>>2]|0;w=b[t+11>>0]|0;if(w<<24>>24<0){y=f[t>>2]|0;z=f[t+4>>2]|0}else{y=t;z=w&255}m$b(y,z,1,458054)|0;w=f[(f[s>>2]|0)+4+(p<<2)>>2]|0;b[d>>0]=34;t=gZb(w,d+1|0)|0;p=p+1|0;if((p|0)==(r|0)){A=t;break}else d=t}}else A=x;x=a+56|0;elc(x);d=a+88|0;do if(f[f[d>>2]>>2]|0){if(c?(elc(x),(f[f[d>>2]>>2]|0)>>>0>1):0){elc(x);r=f[f[d>>2]>>2]|0;p=bYc(r>>>0>1073741823?-1:r<<2)|0;elc(x);r=f[d>>2]|0;s=f[r+12>>2]|0;z=f[r+4>>2]|0;a:do if(z>>>0>s>>>0){y=f[r+16>>2]|0;t=s;while(1){B=f[y+(t<<2)>>2]|0;if(B|0)break;w=t+1|0;if(w>>>0<z>>>0)t=w;else{C=0;D=w;break a}}if((B|0)==(f[y+((t^1)<<2)>>2]|0)){C=f[(f[B>>2]|0)+16>>2]|0;D=t;break}else{C=B;D=t;break}}else{C=0;D=s}while(0);f[g>>2]=C;f[g+4>>2]=r;f[g+8>>2]=D;s=0;while(1){elc(x);z=f[g>>2]|0;if(!z)break;f[p+(s<<2)>>2]=f[z+12>>2];RIa(g)|0;s=s+1|0}fTa(p,p+(s<<2)|0,g);if(s){r=a+76|0;z=0;w=A;v=0;do{h=p+(z<<2)|0;j=f[h>>2]|0;k=j+16|0;q=f[r>>2]|0;if(!q){i=$Xc(32)|0;f[i+12>>2]=0;f[i+4>>2]=537368;f[i+8>>2]=0;f[i+20>>2]=0;E=i}else{if(f[q+64>>2]|0)SXb(q,19296,32);i=QXb(q,32)|0;o=q;f[i+12>>2]=o;f[i+4>>2]=537368;f[i+8>>2]=0;f[i+20>>2]=o;E=i}f[E>>2]=109876;f[E+24>>2]=j;f[E+28>>2]=k;f[E+16>>2]=3;if((v|0)!=(E|0))if(!v)F=E;else{Yi[f[(f[v>>2]|0)+4>>2]&4095](v);F=E}else F=v;b[w>>0]=42;k=w+1|0;j=F+16|0;i=f[j>>2]|0;if(!(i&1)){G=i;H=0}else{i=_i[f[(f[F>>2]|0)+100>>2]&2047](F)|0;o=b[i+11>>0]|0;q=o<<24>>24<0?f[i+4>>2]|0:o&255;o=q+1+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;G=f[j>>2]|0;H=o}if(!(G&2))I=0;else{o=(_i[f[(f[F>>2]|0)+104>>2]&2047](F)|0)+16|0;j=f[o>>2]|0;I=j+1+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=I+H|0;if(j>>>0>127){o=j;q=k;while(1){b[q>>0]=o|128;i=o>>>7;n=q+1|0;if(o>>>0>16383){o=i;q=n}else{J=n;K=i;break}}}else{J=k;K=j}b[J>>0]=K;q=_i[f[(f[F>>2]|0)+100>>2]&2047](F)|0;b[J+1>>0]=10;o=gZb(q,J+2|0)|0;q=_i[f[(f[F>>2]|0)+104>>2]&2047](F)|0;b[o>>0]=18;t=o+1|0;o=_i[f[(f[q>>2]|0)+60>>2]&2047](q)|0;if(o>>>0>127){y=o;i=t;while(1){b[i>>0]=y|128;n=y>>>7;l=i+1|0;if(y>>>0>16383){y=n;i=l}else{L=l;M=n;break}}}else{L=t;M=o}b[L>>0]=M;w=hj[f[(f[q>>2]|0)+64>>2]&511](q,1,L+1|0)|0;i=(_i[f[(f[F>>2]|0)+20>>2]&2047](F)|0)==0;v=i?F:0;i=f[h>>2]|0;y=b[i+11>>0]|0;if(y<<24>>24<0){N=f[i>>2]|0;O=f[i+4>>2]|0}else{N=i;O=y&255}m$b(N,O,1,458093)|0;z=z+1|0}while(z>>>0<s>>>0);if(!v)P=w;else{Yi[f[(f[v>>2]|0)+4>>2]&4095](v);P=w}}else P=A;dYc(p);Q=P;break}elc(x);s=f[d>>2]|0;z=f[s+12>>2]|0;r=f[s+4>>2]|0;b:do if(r>>>0>z>>>0){y=f[s+16>>2]|0;i=z;while(1){R=f[y+(i<<2)>>2]|0;if(R|0)break;j=i+1|0;if(j>>>0<r>>>0)i=j;else{S=0;T=j;break b}}if((R|0)==(f[y+((i^1)<<2)>>2]|0)){S=f[(f[R>>2]|0)+16>>2]|0;T=i;break}else{S=R;T=i;break}}else{S=0;T=z}while(0);f[g>>2]=S;f[g+4>>2]=s;f[g+8>>2]=T;z=a+76|0;r=A;p=0;while(1){elc(x);w=f[g>>2]|0;if(!w)break;v=f[w+12>>2]|0;w=v+16|0;h=f[z>>2]|0;if(!h){q=$Xc(32)|0;f[q+12>>2]=0;f[q+4>>2]=537368;f[q+8>>2]=0;f[q+20>>2]=0;U=q}else{if(f[h+64>>2]|0)SXb(h,19296,32);q=QXb(h,32)|0;o=h;f[q+12>>2]=o;f[q+4>>2]=537368;f[q+8>>2]=0;f[q+20>>2]=o;U=q}f[U>>2]=109876;f[U+24>>2]=v;f[U+28>>2]=w;f[U+16>>2]=3;if((p|0)!=(U|0))if(!p)V=U;else{Yi[f[(f[p>>2]|0)+4>>2]&4095](p);V=U}else V=p;b[r>>0]=42;w=r+1|0;v=V+16|0;q=f[v>>2]|0;if(!(q&1)){W=q;X=0}else{q=_i[f[(f[V>>2]|0)+100>>2]&2047](V)|0;o=b[q+11>>0]|0;h=o<<24>>24<0?f[q+4>>2]|0:o&255;o=h+1+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;W=f[v>>2]|0;X=o}if(!(W&2))Y=0;else{o=(_i[f[(f[V>>2]|0)+104>>2]&2047](V)|0)+16|0;v=f[o>>2]|0;Y=v+1+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0}v=Y+X|0;if(v>>>0>127){o=v;h=w;while(1){b[h>>0]=o|128;q=o>>>7;t=h+1|0;if(o>>>0>16383){o=q;h=t}else{Z=t;_=q;break}}}else{Z=w;_=v}b[Z>>0]=_;h=_i[f[(f[V>>2]|0)+100>>2]&2047](V)|0;b[Z+1>>0]=10;o=gZb(h,Z+2|0)|0;h=_i[f[(f[V>>2]|0)+104>>2]&2047](V)|0;b[o>>0]=18;i=o+1|0;o=_i[f[(f[h>>2]|0)+60>>2]&2047](h)|0;if(o>>>0>127){y=o;q=i;while(1){b[q>>0]=y|128;t=y>>>7;j=q+1|0;if(y>>>0>16383){y=t;q=j}else{aa=j;ba=t;break}}}else{aa=i;ba=o}b[aa>>0]=ba;q=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,aa+1|0)|0;y=(_i[f[(f[V>>2]|0)+20>>2]&2047](V)|0)==0;v=f[(f[g>>2]|0)+12>>2]|0;w=b[v+11>>0]|0;if(w<<24>>24<0){ca=f[v>>2]|0;da=f[v+4>>2]|0}else{ca=v;da=w&255}m$b(ca,da,1,458093)|0;RIa(g)|0;r=q;p=y?V:0}if(!p)Q=r;else{Yi[f[(f[p>>2]|0)+4>>2]&4095](p);Q=r}}else Q=A;while(0);A=f[a+4>>2]|0;if(!((A&1|0)!=0&(b[476924]|0)!=0)){ea=Q;u=e;return ea|0}ea=Pqc(A&-2,Q)|0;u=e;return ea|0}function zHb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;sHb(a);c=kZc(b,21568,19216,0)|0;if(!c){Ooc(b,a);return}else{DHb(a,c);return}}function AHb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,19216,0)|0;if(!c){Ooc(b,a);return}else{DHb(a,c);return}}function BHb(a,b){a=a|0;b=b|0;f[a+96>>2]=b;return}function CHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223166]|0)!=2){f[d>>2]=165456;f[d+4>>2]=107;b[d+8>>0]=0;J_b(892664,d);a_b(d)}d=537e3;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function DHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}vSa(a+8|0,c+8|0);vSa(a+24|0,c+24|0);vSa(a+40|0,c+40|0);EHb(a+56|0,c+56|0);e=f[c+92>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)i=f[e+4>>2]|0;else i=c&255;if(!i)return;i=a+92|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))j=d;else j=f[d+4>>2]|0;d=f[i>>2]|0;if((d|0)==537368){xJa(i,j,e);return}else{oYc(d,e)|0;return}}function EHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;elc(a);elc(b);e=f[b+32>>2]|0;b=f[e+12>>2]|0;g=f[e+4>>2]|0;a:do if(g>>>0>b>>>0){h=f[e+16>>2]|0;i=b;while(1){j=f[h+(i<<2)>>2]|0;if(j|0)break;k=i+1|0;if(k>>>0<g>>>0)i=k;else{l=0;m=k;break a}}if((j|0)==(f[h+((i^1)<<2)>>2]|0)){l=f[(f[j>>2]|0)+16>>2]|0;m=i;break}else{l=j;m=i;break}}else{l=0;m=b}while(0);f[d>>2]=l;f[d+4>>2]=e;f[d+8>>2]=m;if(!l){dlc(a);u=c;return}m=a+24|0;e=l;do{l=f[e+12>>2]|0;kUa(bJa(m,l)|0,l+16|0);RIa(d)|0;e=f[d>>2]|0}while((e|0)!=0);dlc(a);u=c;return}function FHb(a){a=a|0;SGb(a);cYc(a);return}function GHb(a){a=a|0;return f[a+24>>2]|0}function HHb(a){a=a|0;return f[a+28>>2]|0}function IHb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;i=c+4|0;if(h>>>0<(f[i>>2]|0)>>>0?(b[h>>0]|0)==10:0){f[c>>2]=h+1;h=a+8|0;if(!(l$b(c,h)|0)){j=0;u=e;return j|0}k=f[c>>2]|0;if((((f[i>>2]|0)-k|0)>0?(b[k>>0]|0)==18:0)?(k=a+4|0,l=f[k>>2]|0,m=f[f[l+8>>2]>>2]|0,n=bJa(l,h)|0,l=a+20|0,f[l>>2]=n,(m|0)!=(f[f[(f[k>>2]|0)+8>>2]>>2]|0)):0){m=f[i>>2]|0;o=f[c>>2]|0;p=m-o|0;if((p|0)<1){SYb(c,1,p)|0;q=f[c>>2]|0;r=f[i>>2]|0;s=f[l>>2]|0}else{l=o+1|0;f[c>>2]=l;q=l;r=m;s=n}if(q>>>0<r>>>0?(r=b[q>>0]|0,r<<24>>24>-1):0){f[c>>2]=q+1;t=r&255;v=14}else v=13;if((v|0)==13?(r=YYb(c)|0,(r|0)>-1):0){t=r;v=14}do if(((v|0)==14?(JYb(g,c,t),(f[g+4>>2]|0)>=0):0)?BTa(s,c)|0:0){if(!(OYb(c,f[g>>2]|0)|0))break;do if((f[c>>2]|0)==(f[i>>2]|0)){if((f[c+32>>2]|0)==0?(f[c+12>>2]|0)!=(f[c+28>>2]|0):0)break;f[c+20>>2]=0;b[c+24>>0]=1;j=1;u=e;return j|0}while(0);j=JHb(a,c)|0;u=e;return j|0}while(0);PSa(f[k>>2]|0,h)|0;j=0;u=e;return j|0}}else{f[g>>2]=0;d[g+4>>1]=0;b[g+6>>0]=0;h=a+8|0;k=h+11|0;if((b[k>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+12>>2]=0}else{b[h>>0]=0;b[k>>0]=0}sYc(h,0);f[a+8>>2]=0;h=a+12|0;f[h>>2]=f[g>>2];d[h+4>>1]=d[g+4>>1]|0;b[h+6>>0]=b[g+6>>0]|0;b[a+19>>0]=0}g=f[(f[a>>2]|0)+20>>2]|0;if(!g){h=$Xc(24)|0;f[h+12>>2]=0;f[h+4>>2]=537368;f[h+8>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;w=h}else{if(f[g+64>>2]|0)SXb(g,19248,24);h=QXb(g,24)|0;k=g;f[h+12>>2]=k;f[h+4>>2]=537368;f[h+8>>2]=0;f[h+16>>2]=0;f[h+20>>2]=k;w=h}f[w>>2]=109528;h=a+24|0;k=f[h>>2]|0;if((k|0)==(w|0))x=w;else{if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&4095](k);f[h>>2]=w;x=w}w=x+16|0;f[w>>2]=f[w>>2]|1;w=x+4|0;k=f[w>>2]|0;if((k|0)==537368){xJa(w,f[x+12>>2]|0,537368);y=f[w>>2]|0}else y=k;oYc(y,a+8|0)|0;y=f[h>>2]|0;k=Mi[f[(f[y>>2]|0)+44>>2]&1023](y,c)|0;if(k)KHb(a);a=f[h>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0)){j=k;u=e;return j|0}f[h>>2]=0;j=k;u=e;return j|0}function JHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[(f[a>>2]|0)+20>>2]|0;if(!d){e=$Xc(24)|0;f[e+12>>2]=0;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)SXb(d,19248,24);e=QXb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=109528;e=a+24|0;h=f[e>>2]|0;if((h|0)==(g|0))i=g;else{if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);f[e>>2]=g;i=g}g=f[a+20>>2]|0;h=i+16|0;f[h>>2]=f[h>>2]|2;h=i+8|0;d=f[i+12>>2]|0;i=f[h>>2]|0;if(!i){if(!d){j=$Xc(24)|0;ISa(j);k=j}else{if(f[d+64>>2]|0)SXb(d,15400,24);j=QXb(d,24)|0;JSa(j,d);k=j}f[h>>2]=k;l=k}else l=i;PTa(l,g);g=a+8|0;PSa(f[a+4>>2]|0,g)|0;l=f[e>>2]|0;i=l+16|0;f[i>>2]=f[i>>2]|1;i=l+4|0;k=f[i>>2]|0;if((k|0)==537368){xJa(i,f[l+12>>2]|0,537368);m=f[i>>2]|0}else m=k;k=m+11|0;if((b[k>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0}else{b[m>>0]=0;b[k>>0]=0}sYc(m,0);f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=f[e>>2]|0;m=Mi[f[(f[g>>2]|0)+44>>2]&1023](g,c)|0;if(m)KHb(a);a=f[e>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0))return m|0;f[e>>2]=0;return m|0}function KHb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+24|0;c=f[b>>2]|0;d=a+8|0;oYc(d,_i[f[(f[c>>2]|0)+100>>2]&2047](c)|0)|0;c=bJa(f[a+4>>2]|0,d)|0;d=a+20|0;f[d>>2]=c;a=f[b>>2]|0;b=a+16|0;f[b>>2]=f[b>>2]|2;b=a+8|0;e=f[a+12>>2]|0;a=f[b>>2]|0;if(a|0){g=c;h=a;PTa(g,h);return}if(!e){a=$Xc(24)|0;ISa(a);i=a}else{if(f[e+64>>2]|0)SXb(e,15400,24);a=QXb(e,24)|0;JSa(a,e);i=a}f[b>>2]=i;g=f[d>>2]|0;h=i;PTa(g,h);return}function LHb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=109228;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=536928?(f[223171]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=112;b[d+8>>0]=0;J_b(892684,d);a_b(d)}f[a+24>>2]=0;f[a+28>>2]=0;u=c;return}function MHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=109228;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[223171]|0)==2){g=a+24|0;f[g>>2]=0;h=a+28|0;f[h>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=112;b[e+8>>0]=0;J_b(892684,e);a_b(e);g=a+24|0;f[g>>2]=0;h=a+28|0;f[h>>2]=0;u=d;return}function NHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{QHb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(32)|0;LHb(l);QHb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,19200,32);l=QXb(i,32)|0;MHb(l,i);QHb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function OHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{PHb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(20)|0;dGb(l);PHb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,19184,24);l=QXb(i,24)|0;eGb(l,i);PHb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function PHb(a,b){a=a|0;b=b|0;cGb(b,a);return}function QHb(a,b){a=a|0;b=b|0;wGb(b,a);return}function RHb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=a+4|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a+12>>2]|0;a=0;do{e=f[d+4+(a<<2)>>2]|0;a=a+1|0;g=e+12|0;h=f[g>>2]|0;if((h|0)>0){i=f[e+20>>2]|0;j=0;do{sHb(f[i+4+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=(h|0));f[g>>2]=0}h=e+4|0;j=f[h>>2]|0;i=j&-2;if(!(j&1))k=i;else k=f[i+4>>2]|0;i=e+24|0;if((k|0)==0?(l=f[i>>2]|0,(l|0)!=0):0){Yi[f[(f[l>>2]|0)+4>>2]&4095](l);m=f[h>>2]|0}else m=j;f[i>>2]=0;if(m&1|0?(i=m&-2,f[i>>2]|0):0)sqc(i)}while((a|0)!=(c|0));f[b>>2]=0;return}function SHb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=108932;e=(a|0)==536752;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223168]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=109;b[d+8>>0]=0;J_b(892672,d);a_b(d)}f[a+40>>2]=0;u=c;return}function THb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=108932;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=c;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;if((f[223168]|0)==2){g=a+40|0;f[g>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=109;b[e+8>>0]=0;J_b(892672,e);a_b(e);g=a+40|0;f[g>>2]=0;u=d;return}function UHb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223167]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=108;b[c+8>>0]=0;J_b(892668,c);a_b(c);u=a;return}function VHb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223168]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=109;b[c+8>>0]=0;J_b(892672,c);a_b(c);u=a;return}function WHb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223167]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=108;b[c+8>>0]=0;J_b(892668,c);a_b(c);u=a;return}function XHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}NHb(a+8|0,b+8|0);OHb(a+24|0,b+24|0);return}function YHb(a){a=a|0;var b=0,c=0;f[a>>2]=110204;kKb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function ZHb(a){a=a|0;YHb(a);cYc(a);return}function _Hb(a){a=a|0;a=$Xc(40)|0;aKb(a);return a|0}function $Hb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(40)|0;aKb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19312,40);a=QXb(b,40)|0;cKb(a,b);c=a;return c|0}function aIb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function bIb(a){a=a|0;return f[a+4>>2]|0}function cIb(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+12>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+16>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+20>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+24>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=a+28|0;f[d>>2]=0;b[d+4>>0]=0;d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;sqc(c);return}function dIb(a){a=a|0;return 1}function eIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+4|0;k=a+8|0;l=a+12|0;m=a+12|0;n=a+28|0;o=a+16|0;p=a+16|0;q=a+20|0;r=a+20|0;s=a+24|0;t=a+24|0;v=a+32|0;a=e+8|0;a:while(1){w=f[c>>2]|0;x=f[g>>2]|0;do if(w>>>0<x>>>0){y=b[w>>0]|0;z=y&255;A=w+1|0;if(y<<24>>24>0){B=A;C=z}else{if(A>>>0>=x>>>0){D=z;E=7;break}y=h[A>>0]|0;if(((y^128)&z)>>>0<=127){D=z;E=7;break}B=w+2|0;C=z+-128+(y<<7)|0}f[c>>2]=B;F=C;E=9}else{D=0;E=7}while(0);if((E|0)==7){E=0;w=ZYb(c,D)|0;if((w+-1|0)>>>0<16383){F=w;E=9}else G=w}b:do if((E|0)==9){E=0;switch(F>>>3&536870911|0){case 1:{if((F&255|0)!=10){G=F;break b}w=f[j>>2]|0;x=w&-2;if(!(w&1))H=x;else H=f[x+4>>2]|0;x=f[i>>2]|0;if((x|0)==537368){xJa(i,H,537368);I=f[i>>2]|0}else I=x;if(!(l$b(c,I)|0)){K=0;E=82;break a}x=f[k>>2]|0;w=b[x+11>>0]|0;if(w<<24>>24<0){L=f[x>>2]|0;M=f[x+4>>2]|0}else{L=x;M=w&255}if(m$b(L,M,0,459969)|0)continue a;else{K=0;E=82;break a}break}case 2:{if((F&255|0)!=18){G=F;break b}w=f[j>>2]|0;x=w&-2;if(!(w&1))N=x;else N=f[x+4>>2]|0;x=f[l>>2]|0;if((x|0)==537368){xJa(l,N,537368);O=f[l>>2]|0}else O=x;if(!(l$b(c,O)|0)){K=0;E=82;break a}x=f[m>>2]|0;w=b[x+11>>0]|0;if(w<<24>>24<0){P=f[x>>2]|0;Q=f[x+4>>2]|0}else{P=x;Q=w&255}if(m$b(P,Q,0,460005)|0)continue a;else{K=0;E=82;break a}break}case 3:{if((F&255|0)!=24){G=F;break b}w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){x=b[w>>0]|0;y=x&255;if(x<<24>>24>-1){f[c>>2]=w+1;R=y}else{S=y;E=36}}else{S=0;E=36}if((E|0)==36){E=0;y=KYb(c,S)|0;w=J;if((w|0)>-1|(w|0)==-1&y>>>0>4294967295)R=y;else{K=0;E=82;break a}}f[n>>2]=R;continue a;break}case 4:{if((F&255|0)!=34){G=F;break b}y=f[j>>2]|0;w=y&-2;if(!(y&1))T=w;else T=f[w+4>>2]|0;w=f[o>>2]|0;if((w|0)==537368){xJa(o,T,537368);U=f[o>>2]|0}else U=w;if(!(l$b(c,U)|0)){K=0;E=82;break a}w=f[p>>2]|0;y=b[w+11>>0]|0;if(y<<24>>24<0){V=f[w>>2]|0;W=f[w+4>>2]|0}else{V=w;W=y&255}if(m$b(V,W,0,460048)|0)continue a;else{K=0;E=82;break a}break}case 5:{if((F&255|0)!=42){G=F;break b}y=f[j>>2]|0;w=y&-2;if(!(y&1))X=w;else X=f[w+4>>2]|0;w=f[q>>2]|0;if((w|0)==537368){xJa(q,X,537368);Y=f[q>>2]|0}else Y=w;if(!(l$b(c,Y)|0)){K=0;E=82;break a}w=f[r>>2]|0;y=b[w+11>>0]|0;if(y<<24>>24<0){Z=f[w>>2]|0;_=f[w+4>>2]|0}else{Z=w;_=y&255}if(m$b(Z,_,0,460089)|0)continue a;else{K=0;E=82;break a}break}case 6:{if((F&255|0)!=50){G=F;break b}y=f[j>>2]|0;w=y&-2;if(!(y&1))$=w;else $=f[w+4>>2]|0;w=f[s>>2]|0;if((w|0)==537368){xJa(s,$,537368);aa=f[s>>2]|0}else aa=w;if(!(l$b(c,aa)|0)){K=0;E=82;break a}w=f[t>>2]|0;y=b[w+11>>0]|0;if(y<<24>>24<0){ba=f[w>>2]|0;ca=f[w+4>>2]|0}else{ba=w;ca=y&255}if(m$b(ba,ca,0,460132)|0)continue a;else{K=0;E=82;break a}break}case 16:{if((F&255|0)!=128){G=F;break b}y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[c>>2]=y+1;da=w<<24>>24!=0}else{LYb(e,c);w=e;if(!(b[a>>0]|0)){K=0;E=82;break a}else da=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0}b[v>>0]=da&1;continue a;break}default:{G=F;break b}}}while(0);if(!G){K=1;E=82;break}w=f[j>>2]|0;if(!(w&1))ea=lSa(j)|0;else ea=w&-2;if(!(Lqc(c,G,ea)|0)){K=0;E=82;break}}if((E|0)==82){u=d;return K|0}return 0}function fIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;d=b[h+11>>0]|0;e=d<<24>>24<0;if(e)j=f[h+4>>2]|0;else j=d&255;if(!j)k=i;else{j=e?f[h+4>>2]|0:d&255;k=i+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=f[a+16>>2]|0;i=b[j+11>>0]|0;d=i<<24>>24<0;if(d)l=f[j+4>>2]|0;else l=i&255;if(!l)m=k;else{l=d?f[j+4>>2]|0:i&255;m=k+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}l=f[a+20>>2]|0;k=b[l+11>>0]|0;i=k<<24>>24<0;if(i)n=f[l+4>>2]|0;else n=k&255;if(!n)o=m;else{n=i?f[l+4>>2]|0:k&255;o=m+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}n=f[a+24>>2]|0;m=b[n+11>>0]|0;k=m<<24>>24<0;if(k)p=f[n+4>>2]|0;else p=m&255;if(!p)q=o;else{p=k?f[n+4>>2]|0:m&255;q=o+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}p=f[a+28>>2]|0;if(!p){r=q;s=a+32|0;t=b[s>>0]|0;u=t<<24>>24!=0;v=r+3|0;w=u?v:r;x=a+36|0;f[x>>2]=w;return w|0}if((p|0)<0)y=11;else y=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=y+q|0;s=a+32|0;t=b[s>>0]|0;u=t<<24>>24!=0;v=r+3|0;w=u?v:r;x=a+36|0;f[x>>2]=w;return w|0}function gIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}m$b(j,k,1,459969)|0;f$b(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}m$b(m,n,1,460005)|0;f$b(2,f[d>>2]|0,c)}d=f[a+28>>2]|0;if(d|0)d$b(3,d,c);d=a+16|0;n=f[d>>2]|0;m=b[n+11>>0]|0;j=m<<24>>24<0;if(j)o=f[n+4>>2]|0;else o=m&255;if(o|0){if(j){p=f[n>>2]|0;q=f[n+4>>2]|0}else{p=n;q=m&255}m$b(p,q,1,460048)|0;f$b(4,f[d>>2]|0,c)}d=a+20|0;q=f[d>>2]|0;p=b[q+11>>0]|0;m=p<<24>>24<0;if(m)r=f[q+4>>2]|0;else r=p&255;if(r|0){if(m){s=f[q>>2]|0;t=f[q+4>>2]|0}else{s=q;t=p&255}m$b(s,t,1,460089)|0;f$b(5,f[d>>2]|0,c)}d=a+24|0;t=f[d>>2]|0;s=b[t+11>>0]|0;p=s<<24>>24<0;if(p)u=f[t+4>>2]|0;else u=s&255;if(u|0){if(p){v=f[t>>2]|0;w=f[t+4>>2]|0}else{v=t;w=s&255}m$b(v,w,1,460132)|0;f$b(6,f[d>>2]|0,c)}if(b[a+32>>0]|0)c$b(16,1,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function hIb(a){a=a|0;return f[a+36>>2]|0}function iIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=a+8|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}m$b(k,l,1,459969)|0;l=f[c>>2]|0;b[d>>0]=10;j=gZb(l,d+1|0)|0}d=a+12|0;l=f[d>>2]|0;c=b[l+11>>0]|0;k=c<<24>>24<0;if(k)m=f[l+4>>2]|0;else m=c&255;if(!m)n=j;else{if(k){o=f[l>>2]|0;p=f[l+4>>2]|0}else{o=l;p=c&255}m$b(o,p,1,460005)|0;p=f[d>>2]|0;b[j>>0]=18;n=gZb(p,j+1|0)|0}j=f[a+28>>2]|0;if(!j)q=n;else{b[n>>0]=24;p=n+1|0;n=j&255;if(j>>>0>127){d=p;o=n;c=j;l=((j|0)<0)<<31>>31;while(1){b[d>>0]=o|-128;j=c;c=l1c(c|0,l|0,7)|0;k=d+1|0;m=c&255;if(!(l>>>0>0|(l|0)==0&j>>>0>16383)){r=k;s=m;break}else{d=k;o=m;l=J}}}else{r=p;s=n}b[r>>0]=s;q=r+1|0}r=a+16|0;s=f[r>>2]|0;n=b[s+11>>0]|0;p=n<<24>>24<0;if(p)t=f[s+4>>2]|0;else t=n&255;if(!t)u=q;else{if(p){v=f[s>>2]|0;w=f[s+4>>2]|0}else{v=s;w=n&255}m$b(v,w,1,460048)|0;w=f[r>>2]|0;b[q>>0]=34;u=gZb(w,q+1|0)|0}q=a+20|0;w=f[q>>2]|0;r=b[w+11>>0]|0;v=r<<24>>24<0;if(v)x=f[w+4>>2]|0;else x=r&255;if(!x)y=u;else{if(v){z=f[w>>2]|0;A=f[w+4>>2]|0}else{z=w;A=r&255}m$b(z,A,1,460089)|0;A=f[q>>2]|0;b[u>>0]=42;y=gZb(A,u+1|0)|0}u=a+24|0;A=f[u>>2]|0;q=b[A+11>>0]|0;z=q<<24>>24<0;if(z)B=f[A+4>>2]|0;else B=q&255;if(!B)C=y;else{if(z){D=f[A>>2]|0;E=f[A+4>>2]|0}else{D=A;E=q&255}m$b(D,E,1,460132)|0;E=f[u>>2]|0;b[y>>0]=50;C=gZb(E,y+1|0)|0}if(!(b[a+32>>0]|0))F=C;else{b[C>>0]=-128;b[C+1>>0]=1;b[C+2>>0]=1;F=C+3|0}C=f[a+4>>2]|0;if(!((C&1|0)!=0&(b[476924]|0)!=0)){G=F;return G|0}G=Pqc(C&-2,F)|0;return G|0}function jIb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;cIb(a);c=kZc(b,21568,19312,0)|0;if(!c){Ooc(b,a);return}else{dKb(a,c);return}}function kIb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,19312,0)|0;if(!c){Ooc(b,a);return}else{dKb(a,c);return}}function lIb(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function mIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223173]|0)!=2){f[d>>2]=165456;f[d+4>>2]=114;b[d+8>>0]=0;J_b(892692,d);a_b(d)}d=537248;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function nIb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223174]|0)!=2){f[c>>2]=165456;f[c+4>>2]=115;b[c+8>>0]=0;J_b(892696,c);a_b(c)}d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=12;e=d;g=458515;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+12>>0]=0;ejc(c,110304,110364,109984,0,537248,0,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function oIb(){pIb();n3b(458528,969);Boc(458515,2267);iUa();pUa();return}function pIb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223175]|0)!=2){f[c>>2]=165456;f[c+4>>2]=116;b[c+8>>0]=0;J_b(892700,c);a_b(c)}if((f[223176]|0)!=2){f[c>>2]=165456;f[c+4>>2]=117;b[c+8>>0]=0;J_b(892704,c);a_b(c)}if((f[223177]|0)!=2){f[c>>2]=165456;f[c+4>>2]=118;b[c+8>>0]=0;J_b(892708,c);a_b(c)}if((f[223178]|0)!=2){f[c>>2]=165456;f[c+4>>2]=119;b[c+8>>0]=0;J_b(892712,c);a_b(c)}if((f[223179]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=120;b[c+8>>0]=0;J_b(892716,c);a_b(c);u=a;return}function qIb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223173]|0)!=2){f[c>>2]=165456;f[c+4>>2]=114;b[c+8>>0]=0;J_b(892692,c);a_b(c)}jjc(537248,5);u=a;return}function rIb(){d_b(3005001,3005e3,459498);WXb();f[134256]=110204;f[134257]=0;f[134258]=537368;f[134259]=537368;f[134260]=537368;f[134261]=537368;f[134262]=537368;f[134263]=0;b[537056]=0;f[134265]=0;C_b(537024);return}function sIb(){d_b(3005001,3005e3,459498);WXb();hUa();f[134266]=110716;f[134267]=0;f[134268]=537368;f[134269]=537368;f[134270]=537368;f[134271]=0;f[134272]=0;f[134273]=0;f[134274]=0;f[134275]=0;b[537104]=0;f[134277]=0;C_b(537064);f[134271]=530680;f[134272]=530680;return}function tIb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,459498);WXb();if((f[223175]|0)!=2){f[c>>2]=165456;f[c+4>>2]=116;b[c+8>>0]=0;J_b(892700,c);a_b(c)}if((f[223176]|0)!=2){f[c>>2]=165456;f[c+4>>2]=117;b[c+8>>0]=0;J_b(892704,c);a_b(c)}if((f[223178]|0)!=2){f[c>>2]=165456;f[c+4>>2]=119;b[c+8>>0]=0;J_b(892712,c);a_b(c)}f[134278]=110500;c=537116;d=c+52|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[134292]=537368;f[134293]=537368;f[134294]=537368;c=537180;f[c>>2]=0;f[c+4>>2]=0;f[134297]=0;C_b(537112);f[134295]=537192;u=a;return}function uIb(){d_b(3005001,3005e3,459498);WXb();f[134298]=110608;f[134299]=0;f[134300]=537368;f[134301]=0;f[134302]=0;C_b(537192);return}function vIb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,459498);WXb();if((f[223177]|0)!=2){f[c>>2]=165456;f[c+4>>2]=118;b[c+8>>0]=0;J_b(892708,c);a_b(c)}f[134304]=110392;f[134305]=0;f[134306]=0;f[134307]=0;f[134308]=0;f[134309]=0;f[134310]=0;C_b(537216);u=a;return}function wIb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=110392;b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function xIb(a){a=a|0;wIb(a);cYc(a);return}function yIb(a){a=a|0;a=$Xc(28)|0;iKb(a);return a|0}function zIb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(28)|0;iKb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19328,32);a=QXb(b,32)|0;jKb(a,b);c=a;return c|0}function AIb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function BIb(a){a=a|0;return f[a+4>>2]|0}function CIb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{XIb(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function DIb(a){a=a|0;return 1}function EIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;XZb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=$Xc(80)|0;OIb(a);y=a}else{if(f[o+64>>2]|0)SXb(o,19344,80);a=QXb(o,80)|0;QIb(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=YYb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}JYb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(OYb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=lSa(m)|0;else B=a&-2;if(!(Lqc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function FIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c){g=e;h=a+24|0;f[h>>2]=g;return g|0}d=a+20|0;i=0;j=e;while(1){e=f[(f[d>>2]|0)+4+(i<<2)>>2]|0;k=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=k+j+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(c|0)){g=e;break}else j=e}h=a+24|0;f[h>>2]=g;return g|0}function GIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{k$b(1,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function HIb(a){a=a|0;return f[a+24>>2]|0}function IIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!((j&1|0)!=0&(b[476924]|0)!=0)){s=g;return s|0}s=Pqc(j&-2,g)|0;return s|0}function JIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))return;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{XIb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+4|0;d=f[c>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(b,21568,19328,0)|0;if(!g){Ooc(b,a);return}b=f[g+4>>2]|0;if(b&1|0){d=f[c>>2]|0;if(!(d&1))h=lSa(c)|0;else h=d&-2;vqc(h,b&-2)}NIb(a+8|0,g+8|0);return}function KIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,19328,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}NIb(a+8|0,c+8|0);return}function LIb(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function MIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223173]|0)!=2){f[d>>2]=165456;f[d+4>>2]=114;b[d+8>>0]=0;J_b(892692,d);a_b(d)}d=537280;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function NIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{PIb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(80)|0;OIb(l);PIb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,19344,80);l=QXb(i,80)|0;QIb(l,i);PIb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function OIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=110500;e=(a|0)==537112;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223177]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=118;b[d+8>>0]=0;J_b(892708,d);a_b(d)}f[a+56>>2]=537368;f[a+60>>2]=537368;f[a+64>>2]=537368;d=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[a+76>>2]=0;u=c;return}function PIb(a,b){a=a|0;b=b|0;gJb(b,a);return}function QIb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=110500;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=c;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=c;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;if((f[223177]|0)!=2){f[e>>2]=165456;f[e+4>>2]=118;b[e+8>>0]=0;J_b(892708,e);a_b(e)}f[a+56>>2]=537368;f[a+60>>2]=537368;f[a+64>>2]=537368;e=a+68|0;f[e>>2]=0;f[e+4>>2]=0;f[a+76>>2]=0;u=d;return}function RIb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=110500;fKb(a);b=a+52|0;c=f[b>>2]|0;if(c|0?(f[a+40>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+36|0;h=f[b>>2]|0;if(h|0?(f[a+24>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;cYc(i)}f[b>>2]=0;b=a+20|0;i=f[b>>2]|0;if(i|0?(f[a+8>>2]|0)==0:0){h=f[i>>2]|0;if((h|0)>0){c=0;do{d=f[i+4+(c<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);c=c+1|0}while((c|0)!=(h|0));j=f[b>>2]|0}else j=i;cYc(j)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}j=a&-2;a=j;if((j|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(j);f[b>>2]=0;return}function SIb(a){a=a|0;RIb(a);cYc(a);return}function TIb(a){a=a|0;a=$Xc(80)|0;OIb(a);return a|0}function UIb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(80)|0;OIb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19344,80);a=QXb(b,80)|0;QIb(a,b);c=a;return c|0}function VIb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function WIb(a){a=a|0;return f[a+4>>2]|0}function XIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{cIb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+28|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+36>>2]|0;e=0;do{cIb(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+44|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+52>>2]|0;g=0;do{NJb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+4|0;d=f[a+56>>2]|0;do if((d|0)!=537368){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[a+60>>2]|0;do if((d|0)!=537368){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[a+64>>2]|0;do if((d|0)!=537368){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[c>>2]|0;g=d&-2;if(!(d&1))h=g;else h=f[g+4>>2]|0;g=a+68|0;if((h|0)==0?(h=f[g>>2]|0,(h|0)!=0):0){Yi[f[(f[h>>2]|0)+4>>2]&4095](h);i=f[c>>2]|0}else i=d;f[g>>2]=0;f[a+72>>2]=0;if(!(i&1))return;a=i&-2;if(!(f[a>>2]|0))return;sqc(a);return}function YIb(a){a=a|0;return 1}function ZIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+56|0;j=a+4|0;k=a+56|0;l=a+8|0;m=e+4|0;n=a+24|0;o=e+4|0;p=a+40|0;q=a+52|0;r=a+48|0;s=a+44|0;t=e+4|0;v=a+60|0;w=a+60|0;x=a+64|0;y=a+64|0;z=a+68|0;A=e+4|0;B=a+73|0;C=e+8|0;D=a+74|0;E=e+8|0;F=a+72|0;G=e+8|0;H=a+75|0;I=e+8|0;a:while(1){J=f[c>>2]|0;K=f[g>>2]|0;do if(J>>>0<K>>>0){L=b[J>>0]|0;M=L&255;N=J+1|0;if(L<<24>>24>0){O=N;P=M}else{if(N>>>0>=K>>>0){Q=M;R=7;break}L=h[N>>0]|0;if(((L^128)&M)>>>0<=127){Q=M;R=7;break}O=J+2|0;P=M+-128+(L<<7)|0}f[c>>2]=O;S=P;R=9}else{Q=0;R=7}while(0);if((R|0)==7){R=0;J=ZYb(c,Q)|0;if((J+-1|0)>>>0<16383){S=J;R=9}else T=J}b:do if((R|0)==9){R=0;do switch(S>>>3&536870911|0){case 1:{if((S&255|0)!=10){T=S;break b}J=f[j>>2]|0;K=J&-2;if(!(J&1))U=K;else U=f[K+4>>2]|0;K=f[i>>2]|0;if((K|0)==537368){xJa(i,U,537368);V=f[i>>2]|0}else V=K;if(!(l$b(c,V)|0)){W=0;R=122;break a}K=f[k>>2]|0;J=b[K+11>>0]|0;if(J<<24>>24<0){X=f[K>>2]|0;Y=f[K+4>>2]|0}else{X=K;Y=J&255}if(m$b(X,Y,0,459815)|0)continue a;else{W=0;R=122;break a}break}case 2:{if((S&255|0)!=18){T=S;break b}J=eKb(l)|0;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(L=b[K>>0]|0,L<<24>>24>-1):0){f[c>>2]=K+1;Z=L&255}else{L=YYb(c)|0;if((L|0)>-1)Z=L;else{W=0;R=122;break a}}JYb(e,c,Z);if((f[m>>2]|0)<0){R=28;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){R=28;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 3:{if((S&255|0)!=26){T=S;break b}J=eKb(n)|0;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;_=K&255}else{K=YYb(c)|0;if((K|0)>-1)_=K;else{W=0;R=122;break a}}JYb(e,c,_);if((f[o>>2]|0)<0){R=37;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){R=37;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 4:{if((S&255|0)!=34){T=S;break b}J=f[q>>2]|0;do if(J){K=f[s>>2]|0;L=f[J>>2]|0;if((K|0)>=(L|0))if((L|0)==(f[r>>2]|0)){$=L;R=45;break}else{aa=L;ba=J;R=46;break}else{f[s>>2]=K+1;ca=f[J+4+(K<<2)>>2]|0;break}}else{$=f[r>>2]|0;R=45}while(0);if((R|0)==45){R=0;XZb(p,$+1|0);J=f[q>>2]|0;aa=f[J>>2]|0;ba=J;R=46}if((R|0)==46){R=0;f[ba>>2]=aa+1;J=f[p>>2]|0;if(!J){K=$Xc(48)|0;EJb(K);da=K}else{if(f[J+64>>2]|0)SXb(J,19376,48);K=QXb(J,48)|0;GJb(K,J);da=K}K=f[q>>2]|0;J=f[s>>2]|0;f[s>>2]=J+1;f[K+4+(J<<2)>>2]=da;ca=da}J=f[c>>2]|0;if(J>>>0<(f[g>>2]|0)>>>0?(K=b[J>>0]|0,K<<24>>24>-1):0){f[c>>2]=J+1;ea=K&255}else{K=YYb(c)|0;if((K|0)>-1)ea=K;else{W=0;R=122;break a}}JYb(e,c,ea);if((f[t>>2]|0)<0){R=58;break a}if(!(Mi[f[(f[ca>>2]|0)+44>>2]&1023](ca,c)|0)){R=58;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 5:{if((S&255|0)!=42){T=S;break b}K=f[j>>2]|0;J=K&-2;if(!(K&1))fa=J;else fa=f[J+4>>2]|0;J=f[v>>2]|0;if((J|0)==537368){xJa(v,fa,537368);ga=f[v>>2]|0}else ga=J;if(!(l$b(c,ga)|0)){W=0;R=122;break a}J=f[w>>2]|0;K=b[J+11>>0]|0;if(K<<24>>24<0){ha=f[J>>2]|0;ia=f[J+4>>2]|0}else{ha=J;ia=K&255}if(m$b(ha,ia,0,459844)|0)continue a;else{W=0;R=122;break a}break}case 6:{if((S&255|0)!=50){T=S;break b}K=f[j>>2]|0;J=K&-2;if(!(K&1))ja=J;else ja=f[J+4>>2]|0;J=f[x>>2]|0;if((J|0)==537368){xJa(x,ja,537368);ka=f[x>>2]|0}else ka=J;if(!(l$b(c,ka)|0)){W=0;R=122;break a}J=f[y>>2]|0;K=b[J+11>>0]|0;if(K<<24>>24<0){la=f[J>>2]|0;ma=f[J+4>>2]|0}else{la=J;ma=K&255}if(m$b(la,ma,0,459876)|0)continue a;else{W=0;R=122;break a}break}case 8:{if((S&255|0)!=66){T=S;break b}K=f[z>>2]|0;if(!K){jJb(a);na=f[z>>2]|0}else na=K;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(J=b[K>>0]|0,J<<24>>24>-1):0){f[c>>2]=K+1;oa=J&255}else{J=YYb(c)|0;if((J|0)>-1)oa=J;else{W=0;R=122;break a}}JYb(e,c,oa);if((f[A>>2]|0)<0){R=91;break a}if(!(Mi[f[(f[na>>2]|0)+44>>2]&1023](na,c)|0)){R=91;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{W=0;R=122;break a}break}case 16:{if((S&255|0)!=128){T=S;break b}J=f[c>>2]|0;if(J>>>0<(f[g>>2]|0)>>>0?(K=b[J>>0]|0,K<<24>>24>-1):0){f[c>>2]=J+1;pa=K<<24>>24!=0}else{LYb(e,c);K=e;if(!(b[C>>0]|0)){W=0;R=122;break a}else pa=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[B>>0]=pa&1;continue a;break}case 17:{if((S&255|0)!=136){T=S;break b}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(J=b[K>>0]|0,J<<24>>24>-1):0){f[c>>2]=K+1;qa=J<<24>>24!=0}else{LYb(e,c);J=e;if(!(b[E>>0]|0)){W=0;R=122;break a}else qa=(f[J>>2]|0)!=0|(f[J+4>>2]|0)!=0}b[D>>0]=qa&1;continue a;break}case 18:{if((S&255|0)!=144){T=S;break b}J=f[c>>2]|0;if(J>>>0<(f[g>>2]|0)>>>0?(K=b[J>>0]|0,K<<24>>24>-1):0){f[c>>2]=J+1;ra=K<<24>>24!=0}else{LYb(e,c);K=e;if(!(b[G>>0]|0)){W=0;R=122;break a}else ra=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[F>>0]=ra&1;continue a;break}case 19:{if((S&255|0)!=152){T=S;break b}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(J=b[K>>0]|0,J<<24>>24>-1):0){f[c>>2]=K+1;sa=J<<24>>24!=0}else{LYb(e,c);J=e;if(!(b[I>>0]|0)){W=0;R=122;break a}else sa=(f[J>>2]|0)!=0|(f[J+4>>2]|0)!=0}b[H>>0]=sa&1;continue a;break}default:{T=S;break b}}while(0)}while(0);if(!T){W=1;R=122;break}J=f[j>>2]|0;if(!(J&1))ta=lSa(j)|0;else ta=J&-2;if(!(Lqc(c,T,ta)|0)){W=0;R=122;break}}if((R|0)==28){W=0;u=d;return W|0}else if((R|0)==37){W=0;u=d;return W|0}else if((R|0)==58){W=0;u=d;return W|0}else if((R|0)==91){W=0;u=d;return W|0}else if((R|0)==122){u=d;return W|0}return 0}function _Ib(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+28>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+36|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+44>>2]|0;i=d+k|0;if(!d)l=i;else{k=a+52|0;h=0;g=i;while(1){i=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;c=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=c+g+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=i;break}else g=i}}g=f[a+56>>2]|0;d=b[g+11>>0]|0;h=d<<24>>24<0;if(h)m=f[g+4>>2]|0;else m=d&255;if(!m)n=l;else{m=h?f[g+4>>2]|0:d&255;n=l+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}m=f[a+60>>2]|0;l=b[m+11>>0]|0;d=l<<24>>24<0;if(d)o=f[m+4>>2]|0;else o=l&255;if(!o)p=n;else{o=d?f[m+4>>2]|0:l&255;p=n+1+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}o=f[a+64>>2]|0;n=b[o+11>>0]|0;l=n<<24>>24<0;if(l)q=f[o+4>>2]|0;else q=n&255;if(!q)r=p;else{q=l?f[o+4>>2]|0:n&255;r=p+1+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((a|0)!=537112?(q=f[a+68>>2]|0,(q|0)!=0):0){p=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;s=r+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else s=r;r=b[a+72>>0]|0?s+3|0:s;s=b[a+73>>0]|0?r+3|0:r;r=b[a+74>>0]|0?s+3|0:s;s=b[a+75>>0]|0?r+3|0:r;f[a+76>>2]=s;return s|0}function $Ib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+56|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}m$b(j,k,1,459815)|0;f$b(1,f[d>>2]|0,c)}d=f[a+12>>2]|0;if(d|0){k=a+20|0;j=0;do{k$b(2,f[(f[k>>2]|0)+4+(j<<2)>>2]|0,c);j=j+1|0}while((j|0)!=(d|0))}d=f[a+28>>2]|0;if(d|0){j=a+36|0;k=0;do{k$b(3,f[(f[j>>2]|0)+4+(k<<2)>>2]|0,c);k=k+1|0}while((k|0)!=(d|0))}d=f[a+44>>2]|0;if(d|0){k=a+52|0;j=0;do{k$b(4,f[(f[k>>2]|0)+4+(j<<2)>>2]|0,c);j=j+1|0}while((j|0)!=(d|0))}d=a+60|0;j=f[d>>2]|0;k=b[j+11>>0]|0;g=k<<24>>24<0;if(g)l=f[j+4>>2]|0;else l=k&255;if(l|0){if(g){m=f[j>>2]|0;n=f[j+4>>2]|0}else{m=j;n=k&255}m$b(m,n,1,459844)|0;f$b(5,f[d>>2]|0,c)}d=a+64|0;n=f[d>>2]|0;m=b[n+11>>0]|0;k=m<<24>>24<0;if(k)o=f[n+4>>2]|0;else o=m&255;if(o|0){if(k){p=f[n>>2]|0;q=f[n+4>>2]|0}else{p=n;q=m&255}m$b(p,q,1,459876)|0;f$b(6,f[d>>2]|0,c)}if((a|0)!=537112?(d=f[a+68>>2]|0,d|0):0)k$b(8,d,c);if(b[a+73>>0]|0)c$b(16,1,c);if(b[a+74>>0]|0)c$b(17,1,c);if(b[a+72>>0]|0)c$b(18,1,c);if(b[a+75>>0]|0)c$b(19,1,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function aJb(a){a=a|0;return f[a+76>>2]|0}function bJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=a+56|0;g=f[e>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0;if(i)j=f[g+4>>2]|0;else j=h&255;if(!j)k=d;else{if(i){l=f[g>>2]|0;m=f[g+4>>2]|0}else{l=g;m=h&255}m$b(l,m,1,459815)|0;m=f[e>>2]|0;b[d>>0]=10;k=gZb(m,d+1|0)|0}d=f[a+12>>2]|0;if(!d)n=k;else{m=a+20|0;e=0;l=k;while(1){k=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;b[l>>0]=18;h=l+1|0;g=_i[f[(f[k>>2]|0)+60>>2]&2047](k)|0;if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;o=i>>>7;p=j+1|0;if(i>>>0>16383){i=o;j=p}else{q=p;r=o;break}}}else{q=h;r=g}b[q>>0]=r;j=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,q+1|0)|0;e=e+1|0;if((e|0)==(d|0)){n=j;break}else l=j}}l=f[a+28>>2]|0;if(!l)s=n;else{d=a+36|0;e=0;q=n;while(1){n=f[(f[d>>2]|0)+4+(e<<2)>>2]|0;b[q>>0]=26;r=q+1|0;m=_i[f[(f[n>>2]|0)+60>>2]&2047](n)|0;if(m>>>0>127){j=m;i=r;while(1){b[i>>0]=j|128;o=j>>>7;p=i+1|0;if(j>>>0>16383){j=o;i=p}else{t=p;u=o;break}}}else{t=r;u=m}b[t>>0]=u;i=hj[f[(f[n>>2]|0)+64>>2]&511](n,c,t+1|0)|0;e=e+1|0;if((e|0)==(l|0)){s=i;break}else q=i}}q=f[a+44>>2]|0;if(!q)v=s;else{l=a+52|0;e=0;t=s;while(1){s=f[(f[l>>2]|0)+4+(e<<2)>>2]|0;b[t>>0]=34;u=t+1|0;d=_i[f[(f[s>>2]|0)+60>>2]&2047](s)|0;if(d>>>0>127){i=d;j=u;while(1){b[j>>0]=i|128;k=i>>>7;g=j+1|0;if(i>>>0>16383){i=k;j=g}else{w=g;x=k;break}}}else{w=u;x=d}b[w>>0]=x;j=hj[f[(f[s>>2]|0)+64>>2]&511](s,c,w+1|0)|0;e=e+1|0;if((e|0)==(q|0)){v=j;break}else t=j}}t=a+60|0;q=f[t>>2]|0;e=b[q+11>>0]|0;w=e<<24>>24<0;if(w)y=f[q+4>>2]|0;else y=e&255;if(!y)z=v;else{if(w){A=f[q>>2]|0;B=f[q+4>>2]|0}else{A=q;B=e&255}m$b(A,B,1,459844)|0;B=f[t>>2]|0;b[v>>0]=42;z=gZb(B,v+1|0)|0}v=a+64|0;B=f[v>>2]|0;t=b[B+11>>0]|0;A=t<<24>>24<0;if(A)C=f[B+4>>2]|0;else C=t&255;if(!C)D=z;else{if(A){E=f[B>>2]|0;F=f[B+4>>2]|0}else{E=B;F=t&255}m$b(E,F,1,459876)|0;F=f[v>>2]|0;b[z>>0]=50;D=gZb(F,z+1|0)|0}if((a|0)!=537112?(z=f[a+68>>2]|0,(z|0)!=0):0){b[D>>0]=66;F=D+1|0;v=_i[f[(f[z>>2]|0)+60>>2]&2047](z)|0;if(v>>>0>127){E=v;t=F;while(1){b[t>>0]=E|128;B=E>>>7;A=t+1|0;if(E>>>0>16383){E=B;t=A}else{G=A;H=B;break}}}else{G=F;H=v}b[G>>0]=H;I=hj[f[(f[z>>2]|0)+64>>2]&511](z,c,G+1|0)|0}else I=D;if(!(b[a+73>>0]|0))J=I;else{b[I>>0]=-128;b[I+1>>0]=1;b[I+2>>0]=1;J=I+3|0}if(!(b[a+74>>0]|0))K=J;else{b[J>>0]=-120;b[J+1>>0]=1;b[J+2>>0]=1;K=J+3|0}if(!(b[a+72>>0]|0))L=K;else{b[K>>0]=-112;b[K+1>>0]=1;b[K+2>>0]=1;L=K+3|0}if(!(b[a+75>>0]|0))M=L;else{b[L>>0]=-104;b[L+1>>0]=1;b[L+2>>0]=1;M=L+3|0}L=f[a+4>>2]|0;if(!((L&1|0)!=0&(b[476924]|0)!=0)){N=M;return N|0}N=Pqc(L&-2,M)|0;return N|0}function cJb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;XIb(a);c=kZc(b,21568,19344,0)|0;if(!c){Ooc(b,a);return}else{gJb(a,c);return}}function dJb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,19344,0)|0;if(!c){Ooc(b,a);return}else{gJb(a,c);return}}function eJb(a,b){a=a|0;b=b|0;f[a+76>>2]=b;return}function fJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223173]|0)!=2){f[d>>2]=165456;f[d+4>>2]=114;b[d+8>>0]=0;J_b(892692,d);a_b(d)}d=537264;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function gJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}hJb(a+8|0,c+8|0);hJb(a+24|0,c+24|0);iJb(a+40|0,c+40|0);e=f[c+56>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+56|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+60>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+60|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==537368){xJa(k,m,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+64>>2]|0;m=b[e+11>>0]|0;if(m<<24>>24<0)n=f[e+4>>2]|0;else n=m&255;do if(n|0){m=a+64|0;l=f[d>>2]|0;j=l&-2;if(!(l&1))o=j;else o=f[j+4>>2]|0;j=f[m>>2]|0;if((j|0)==537368){xJa(m,o,e);break}else{oYc(j,e)|0;break}}while(0);if((c|0)!=537112?(e=c+68|0,o=f[e>>2]|0,o|0):0){d=a+68|0;n=f[d>>2]|0;if(!n){jJb(a);p=f[e>>2]|0;q=f[d>>2]|0}else{p=o;q=n}kJb(q,p|0?p:537192)}if(b[c+72>>0]|0)b[a+72>>0]=1;if(b[c+73>>0]|0)b[a+73>>0]=1;if(b[c+74>>0]|0)b[a+74>>0]=1;if(!(b[c+75>>0]|0))return;b[a+75>>0]=1;return}function hJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{bKb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(40)|0;aKb(l);bKb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,19312,40);l=QXb(i,40)|0;cKb(l,i);bKb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function iJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{FJb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(48)|0;EJb(l);FJb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,19376,48);l=QXb(i,48)|0;GJb(l,i);FJb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function jJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(20)|0;lJb(c);e=c;g=a+68|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,19360,24);c=QXb(d,24)|0;mJb(c,d);e=c;g=a+68|0;f[g>>2]=e;return}function kJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;if(!e)return;f[a+12>>2]=e;return}function lJb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=110608;f[a+4>>2]=0;if((a|0)!=537192?(f[223178]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=119;b[d+8>>0]=0;J_b(892712,d);a_b(d)}f[a+8>>2]=537368;f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function mJb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=110608;f[a+4>>2]=c;if((f[223178]|0)!=2){f[e>>2]=165456;f[e+4>>2]=119;b[e+8>>0]=0;J_b(892712,e);a_b(e)}f[a+8>>2]=537368;f[a+12>>2]=0;f[a+16>>2]=0;u=d;return}function nJb(a){a=a|0;var c=0,d=0;f[a>>2]=110608;c=f[a+8>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function oJb(a){a=a|0;nJb(a);cYc(a);return}function pJb(a){a=a|0;a=$Xc(20)|0;lJb(a);return a|0}function qJb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(20)|0;lJb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19360,24);a=QXb(b,24)|0;mJb(a,b);c=a;return c|0}function rJb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function sJb(a){a=a|0;return f[a+4>>2]|0}function tJb(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[a+12>>2]=0;a=f[c>>2]|0;if(!(a&1))return;c=a&-2;if(!(f[c>>2]|0))return;sqc(c);return}function uJb(a){a=a|0;return 1}function vJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+12|0;g=a+8|0;h=a+4|0;i=a+8|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=KYb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=29;break a}}f[e>>2]=p;continue a;break}case 2:break;default:{o=l;break b}}if((l&255|0)==18){j=f[h>>2]|0;k=j&-2;if(!(j&1))s=k;else s=f[k+4>>2]|0;k=f[g>>2]|0;if((k|0)==537368){xJa(g,s,537368);t=f[g>>2]|0}else t=k;if(!(l$b(c,t)|0)){r=0;m=29;break a}k=f[i>>2]|0;j=b[k+11>>0]|0;if(j<<24>>24<0){u=f[k>>2]|0;v=f[k+4>>2]|0}else{u=k;v=j&255}if(m$b(u,v,0,459579)|0)continue a;else{r=0;m=29;break a}}else o=l}while(0);if(!o){r=1;m=29;break}j=f[h>>2]|0;if(!(j&1))w=lSa(h)|0;else w=j&-2;if(!(Lqc(c,o,w)|0)){r=0;m=29;break}}if((m|0)==29)return r|0;return 0}function wJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;if(!h){j=i;k=a+16|0;f[k>>2]=j;return j|0}if((h|0)<0)l=11;else l=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=l+i|0;k=a+16|0;f[k>>2]=j;return j|0}function xJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=f[a+12>>2]|0;if(d|0)S_b(1,d,c);d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}m$b(j,k,1,459579)|0;f$b(2,f[d>>2]|0,c)}d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function yJb(a){a=a|0;return f[a+16>>2]|0}function zJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+12>>2]|0;if(!c)e=d;else{b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=l1c(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=a+8|0;o=f[n>>2]|0;d=b[o+11>>0]|0;g=d<<24>>24<0;if(g)p=f[o+4>>2]|0;else p=d&255;if(!p)q=e;else{if(g){r=f[o>>2]|0;s=f[o+4>>2]|0}else{r=o;s=d&255}m$b(r,s,1,459579)|0;s=f[n>>2]|0;b[e>>0]=18;q=gZb(s,e+1|0)|0}e=f[a+4>>2]|0;if(!((e&1|0)!=0&(b[476924]|0)!=0)){t=q;return t|0}t=Pqc(e&-2,q)|0;return t|0}function AJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+4|0;e=f[a+8>>2]|0;do if((e|0)!=537368){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[a+12>>2]=0;e=f[d>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d);d=kZc(c,21568,19360,0)|0;if(!d){Ooc(c,a);return}else{kJb(a,d);return}}function BJb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,19360,0)|0;if(!c){Ooc(b,a);return}else{kJb(a,c);return}}function CJb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function DJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223173]|0)!=2){f[d>>2]=165456;f[d+4>>2]=114;b[d+8>>0]=0;J_b(892692,d);a_b(d)}d=537272;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function EJb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=110716;f[a+4>>2]=0;if((a|0)!=537064?(f[223176]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=117;b[d+8>>0]=0;J_b(892704,d);a_b(d)}f[a+8>>2]=537368;f[a+12>>2]=537368;f[a+16>>2]=537368;d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;b[d+20>>0]=0;f[a+44>>2]=0;u=c;return}function FJb(a,b){a=a|0;b=b|0;YJb(b,a);return}function GJb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=110716;f[a+4>>2]=c;if((f[223176]|0)!=2){f[e>>2]=165456;f[e+4>>2]=117;b[e+8>>0]=0;J_b(892704,e);a_b(e)}f[a+8>>2]=537368;f[a+12>>2]=537368;f[a+16>>2]=537368;e=a+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;b[e+20>>0]=0;f[a+44>>2]=0;u=d;return}function HJb(a){a=a|0;var b=0,c=0;f[a>>2]=110716;$Jb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function IJb(a){a=a|0;HJb(a);cYc(a);return}function JJb(a){a=a|0;a=$Xc(48)|0;EJb(a);return a|0}function KJb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(48)|0;EJb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19376,48);a=QXb(b,48)|0;GJb(a,b);c=a;return c|0}function LJb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function MJb(a){a=a|0;return f[a+4>>2]|0}function NJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+12>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+16>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;e=a+20|0;if((g|0)==0?(g=f[e>>2]|0,(g|0)!=0):0){Yi[f[(f[g>>2]|0)+4>>2]&4095](g);h=f[c>>2]|0}else h=d;f[e>>2]=0;e=h&-2;if(!(h&1))i=e;else i=f[e+4>>2]|0;e=a+24|0;if((i|0)==0?(i=f[e>>2]|0,(i|0)!=0):0){Yi[f[(f[i>>2]|0)+4>>2]&4095](i);j=f[c>>2]|0}else j=h;f[e>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;b[e+8>>0]=0;if(!(j&1))return;e=j&-2;if(!(f[e>>2]|0))return;sqc(e);return}function OJb(a){a=a|0;return 1}function PJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+4|0;j=a+8|0;k=a+12|0;l=a+12|0;m=a+20|0;n=e+4|0;o=a+16|0;p=a+16|0;q=a+40|0;r=e+8|0;s=a+32|0;t=e+8|0;v=a+24|0;w=e+4|0;a:while(1){x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;z=y&255;if(y<<24>>24>0){f[c>>2]=x+1;A=z;B=6}else{C=z;B=5}}else{C=0;B=5}if((B|0)==5){B=0;z=ZYb(c,C)|0;if((z+-1|0)>>>0<127){A=z;B=6}else D=z}b:do if((B|0)==6){B=0;switch(A>>>3&536870911|0){case 1:{if((A&255|0)!=10){D=A;break b}z=f[i>>2]|0;x=z&-2;if(!(z&1))E=x;else E=f[x+4>>2]|0;x=f[h>>2]|0;if((x|0)==537368){xJa(h,E,537368);F=f[h>>2]|0}else F=x;if(!(l$b(c,F)|0)){G=0;B=79;break a}x=f[j>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0){H=f[x>>2]|0;I=f[x+4>>2]|0}else{H=x;I=z&255}if(m$b(H,I,0,459660)|0)continue a;else{G=0;B=79;break a}break}case 2:{if((A&255|0)!=18){D=A;break b}z=f[i>>2]|0;x=z&-2;if(!(z&1))J=x;else J=f[x+4>>2]|0;x=f[k>>2]|0;if((x|0)==537368){xJa(k,J,537368);K=f[k>>2]|0}else K=x;if(!(l$b(c,K)|0)){G=0;B=79;break a}x=f[l>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0){L=f[x>>2]|0;M=f[x+4>>2]|0}else{L=x;M=z&255}if(m$b(L,M,0,459697)|0)continue a;else{G=0;B=79;break a}break}case 3:{if((A&255|0)!=26){D=A;break b}z=f[m>>2]|0;if(!z){ZJb(a);N=f[m>>2]|0}else N=z;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(x=b[z>>0]|0,x<<24>>24>-1):0){f[c>>2]=z+1;O=x&255}else{x=YYb(c)|0;if((x|0)>-1)O=x;else{G=0;B=79;break a}}JYb(e,c,O);if((f[n>>2]|0)<0){B=38;break a}if(!(Mi[f[(f[N>>2]|0)+44>>2]&1023](N,c)|0)){B=38;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{G=0;B=79;break a}break}case 4:{if((A&255|0)!=34){D=A;break b}x=f[i>>2]|0;z=x&-2;if(!(x&1))P=z;else P=f[z+4>>2]|0;z=f[o>>2]|0;if((z|0)==537368){xJa(o,P,537368);Q=f[o>>2]|0}else Q=z;if(!(l$b(c,Q)|0)){G=0;B=79;break a}z=f[p>>2]|0;x=b[z+11>>0]|0;if(x<<24>>24<0){R=f[z>>2]|0;S=f[z+4>>2]|0}else{R=z;S=x&255}if(m$b(R,S,0,459734)|0)continue a;else{G=0;B=79;break a}break}case 5:{if((A&255|0)!=40){D=A;break b}x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(z=b[x>>0]|0,z<<24>>24>-1):0){f[c>>2]=x+1;T=z<<24>>24!=0}else{LYb(e,c);z=e;if(!(b[r>>0]|0)){G=0;B=79;break a}else T=(f[z>>2]|0)!=0|(f[z+4>>2]|0)!=0}b[q>>0]=T&1;continue a;break}case 6:{if((A&255|0)!=48){D=A;break b}z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(x=b[z>>0]|0,x<<24>>24>-1):0){f[c>>2]=z+1;U=x&255;V=0}else{LYb(e,c);x=e;if(!(b[t>>0]|0)){G=0;B=79;break a}else{U=f[x>>2]|0;V=f[x+4>>2]|0}}x=s;f[x>>2]=U;f[x+4>>2]=V;continue a;break}case 7:{if((A&255|0)!=58){D=A;break b}x=f[v>>2]|0;if(!x){_Jb(a);W=f[v>>2]|0}else W=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(z=b[x>>0]|0,z<<24>>24>-1):0){f[c>>2]=x+1;X=z&255}else{z=YYb(c)|0;if((z|0)>-1)X=z;else{G=0;B=79;break a}}JYb(e,c,X);if((f[w>>2]|0)<0){B=72;break a}if(!(Mi[f[(f[W>>2]|0)+44>>2]&1023](W,c)|0)){B=72;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{G=0;B=79;break a}break}default:{D=A;break b}}}while(0);if(!D){G=1;B=79;break}z=f[i>>2]|0;if(!(z&1))Y=lSa(i)|0;else Y=z&-2;if(!(Lqc(c,D,Y)|0)){G=0;B=79;break}}if((B|0)==38){G=0;u=d;return G|0}else if((B|0)==72){G=0;u=d;return G|0}else if((B|0)==79){u=d;return G|0}return 0}function QJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=f[a+12>>2]|0;d=b[h+11>>0]|0;e=d<<24>>24<0;if(e)j=f[h+4>>2]|0;else j=d&255;if(!j)k=i;else{j=e?f[h+4>>2]|0:d&255;k=i+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}j=f[a+16>>2]|0;i=b[j+11>>0]|0;d=i<<24>>24<0;if(d)l=f[j+4>>2]|0;else l=i&255;if(!l)m=k;else{l=d?f[j+4>>2]|0:i&255;m=k+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((a|0)!=537064){l=f[a+20>>2]|0;if(!l)n=m;else{k=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;n=m+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}k=f[a+24>>2]|0;if(!k)o=n;else{l=_i[f[(f[k>>2]|0)+48>>2]&2047](k)|0;o=n+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}}else o=m;m=a+32|0;l=f[m>>2]|0;n=f[m+4>>2]|0;if((l|0)==0&(n|0)==0){p=o;q=a+40|0;r=b[q>>0]|0;s=r<<24>>24!=0;t=p+2|0;u=s?t:p;v=a+44|0;f[v>>2]=u;return u|0}m=t1c(l|1|0,n|0,1)|0;p=o+1+((((m^63)*9|0)+73|0)>>>6)|0;q=a+40|0;r=b[q>>0]|0;s=r<<24>>24!=0;t=p+2|0;u=s?t:p;v=a+44|0;f[v>>2]=u;return u|0}function RJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}m$b(j,k,1,459660)|0;f$b(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}m$b(m,n,1,459697)|0;f$b(2,f[d>>2]|0,c)}d=(a|0)==537064;if(!d?(n=f[a+20>>2]|0,n|0):0)k$b(3,n,c);n=a+16|0;m=f[n>>2]|0;j=b[m+11>>0]|0;k=j<<24>>24<0;if(k)o=f[m+4>>2]|0;else o=j&255;if(o|0){if(k){p=f[m>>2]|0;q=f[m+4>>2]|0}else{p=m;q=j&255}m$b(p,q,1,459734)|0;f$b(4,f[n>>2]|0,c)}if(b[a+40>>0]|0)c$b(5,1,c);n=a+32|0;q=f[n>>2]|0;p=f[n+4>>2]|0;if(!((q|0)==0&(p|0)==0))T_b(6,q,p,c);if(!d?(d=f[a+24>>2]|0,d|0):0)k$b(7,d,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function SJb(a){a=a|0;return f[a+44>>2]|0}function TJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=a+8|0;g=f[e>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0;if(i)j=f[g+4>>2]|0;else j=h&255;if(!j)k=d;else{if(i){l=f[g>>2]|0;m=f[g+4>>2]|0}else{l=g;m=h&255}m$b(l,m,1,459660)|0;m=f[e>>2]|0;b[d>>0]=10;k=gZb(m,d+1|0)|0}d=a+12|0;m=f[d>>2]|0;e=b[m+11>>0]|0;l=e<<24>>24<0;if(l)n=f[m+4>>2]|0;else n=e&255;if(!n)o=k;else{if(l){p=f[m>>2]|0;q=f[m+4>>2]|0}else{p=m;q=e&255}m$b(p,q,1,459697)|0;q=f[d>>2]|0;b[k>>0]=18;o=gZb(q,k+1|0)|0}k=(a|0)==537064;if(!k?(q=f[a+20>>2]|0,(q|0)!=0):0){b[o>>0]=26;d=o+1|0;p=_i[f[(f[q>>2]|0)+60>>2]&2047](q)|0;if(p>>>0>127){e=p;m=d;while(1){b[m>>0]=e|128;l=e>>>7;n=m+1|0;if(e>>>0>16383){e=l;m=n}else{r=n;s=l;break}}}else{r=d;s=p}b[r>>0]=s;t=hj[f[(f[q>>2]|0)+64>>2]&511](q,c,r+1|0)|0}else t=o;o=a+16|0;r=f[o>>2]|0;q=b[r+11>>0]|0;s=q<<24>>24<0;if(s)u=f[r+4>>2]|0;else u=q&255;if(!u)v=t;else{if(s){w=f[r>>2]|0;x=f[r+4>>2]|0}else{w=r;x=q&255}m$b(w,x,1,459734)|0;x=f[o>>2]|0;b[t>>0]=34;v=gZb(x,t+1|0)|0}if(!(b[a+40>>0]|0))y=v;else{b[v>>0]=40;b[v+1>>0]=1;y=v+2|0}v=a+32|0;t=f[v>>2]|0;x=f[v+4>>2]|0;if((t|0)==0&(x|0)==0)z=y;else{b[y>>0]=48;v=y+1|0;y=t&255;if(x>>>0>0|(x|0)==0&t>>>0>127){o=v;w=y;q=t;t=x;while(1){b[o>>0]=w|-128;x=q;q=l1c(q|0,t|0,7)|0;r=o+1|0;s=q&255;if(!(t>>>0>0|(t|0)==0&x>>>0>16383)){A=r;B=s;break}else{o=r;w=s;t=J}}}else{A=v;B=y}b[A>>0]=B;z=A+1|0}if(!k?(k=f[a+24>>2]|0,(k|0)!=0):0){b[z>>0]=58;A=z+1|0;B=_i[f[(f[k>>2]|0)+60>>2]&2047](k)|0;if(B>>>0>127){y=B;v=A;while(1){b[v>>0]=y|128;t=y>>>7;w=v+1|0;if(y>>>0>16383){y=t;v=w}else{C=w;D=t;break}}}else{C=A;D=B}b[C>>0]=D;E=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,C+1|0)|0}else E=z;z=f[a+4>>2]|0;if(!((z&1|0)!=0&(b[476924]|0)!=0)){F=E;return F|0}F=Pqc(z&-2,E)|0;return F|0}function UJb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;NJb(a);c=kZc(b,21568,19376,0)|0;if(!c){Ooc(b,a);return}else{YJb(a,c);return}}function VJb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,19376,0)|0;if(!c){Ooc(b,a);return}else{YJb(a,c);return}}function WJb(a,b){a=a|0;b=b|0;f[a+44>>2]=b;return}function XJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223173]|0)!=2){f[d>>2]=165456;f[d+4>>2]=114;b[d+8>>0]=0;J_b(892692,d);a_b(d)}d=537256;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function YJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+12|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==537368){xJa(k,m,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+16>>2]|0;m=b[e+11>>0]|0;if(m<<24>>24<0)n=f[e+4>>2]|0;else n=m&255;do if(n|0){m=a+16|0;l=f[d>>2]|0;j=l&-2;if(!(l&1))o=j;else o=f[j+4>>2]|0;j=f[m>>2]|0;if((j|0)==537368){xJa(m,o,e);break}else{oYc(j,e)|0;break}}while(0);if((c|0)!=537064){e=c+20|0;o=f[e>>2]|0;if(o|0){d=a+20|0;n=f[d>>2]|0;if(!n){ZJb(a);p=f[e>>2]|0;q=f[d>>2]|0}else{p=o;q=n}kSa(q,p|0?p:530680)}p=c+24|0;q=f[p>>2]|0;if(q|0){n=a+24|0;o=f[n>>2]|0;if(!o){_Jb(a);r=f[p>>2]|0;s=f[n>>2]|0}else{r=q;s=o}kSa(s,r|0?r:530680)}}r=c+32|0;s=f[r>>2]|0;o=f[r+4>>2]|0;if(!((s|0)==0&(o|0)==0)){r=a+32|0;f[r>>2]=s;f[r+4>>2]=o}if(!(b[c+40>>0]|0))return;b[a+40>>0]=1;return}function ZJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(24)|0;ISa(c);e=c;g=a+20|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,15400,24);c=QXb(d,24)|0;JSa(c,d);e=c;g=a+20|0;f[g>>2]=e;return}function _Jb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(24)|0;ISa(c);e=c;g=a+24|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,15400,24);c=QXb(d,24)|0;JSa(c,d);e=c;g=a+24|0;f[g>>2]=e;return}function $Jb(a){a=a|0;var c=0;c=f[a+8>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+12>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==537064)return;c=f[a+20>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+24>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function aKb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=110204;f[a+4>>2]=0;if((a|0)!=537024?(f[223175]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=116;b[d+8>>0]=0;J_b(892700,d);a_b(d)}f[a+8>>2]=537368;f[a+12>>2]=537368;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;d=a+28|0;f[d>>2]=0;b[d+4>>0]=0;f[a+36>>2]=0;u=c;return}function bKb(a,b){a=a|0;b=b|0;dKb(b,a);return}function cKb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=110204;f[a+4>>2]=c;if((f[223175]|0)!=2){f[e>>2]=165456;f[e+4>>2]=116;b[e+8>>0]=0;J_b(892700,e);a_b(e)}f[a+8>>2]=537368;f[a+12>>2]=537368;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;e=a+28|0;f[e>>2]=0;b[e+4>>0]=0;f[a+36>>2]=0;u=d;return}function dKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+12>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+12|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==537368){xJa(k,m,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+16>>2]|0;m=b[e+11>>0]|0;if(m<<24>>24<0)n=f[e+4>>2]|0;else n=m&255;do if(n|0){m=a+16|0;l=f[d>>2]|0;j=l&-2;if(!(l&1))o=j;else o=f[j+4>>2]|0;j=f[m>>2]|0;if((j|0)==537368){xJa(m,o,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+20>>2]|0;o=b[e+11>>0]|0;if(o<<24>>24<0)p=f[e+4>>2]|0;else p=o&255;do if(p|0){o=a+20|0;n=f[d>>2]|0;j=n&-2;if(!(n&1))q=j;else q=f[j+4>>2]|0;j=f[o>>2]|0;if((j|0)==537368){xJa(o,q,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+24>>2]|0;q=b[e+11>>0]|0;if(q<<24>>24<0)r=f[e+4>>2]|0;else r=q&255;do if(r|0){q=a+24|0;p=f[d>>2]|0;j=p&-2;if(!(p&1))s=j;else s=f[j+4>>2]|0;j=f[q>>2]|0;if((j|0)==537368){xJa(q,s,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+28>>2]|0;if(e|0)f[a+28>>2]=e;if(!(b[c+32>>0]|0))return;b[a+32>>0]=1;return}function eKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(40)|0;aKb(a);o=a}else{if(f[l+64>>2]|0)SXb(l,19312,40);a=QXb(l,40)|0;cKb(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function fKb(a){a=a|0;var c=0;c=f[a+56>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+60>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+64>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==537112)return;c=f[a+68>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function gKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function hKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function iKb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=110392;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=537216?(f[223179]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=120;b[d+8>>0]=0;J_b(892716,d);a_b(d)}f[a+24>>2]=0;u=c;return}function jKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=110392;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[223179]|0)==2){g=a+24|0;f[g>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=120;b[e+8>>0]=0;J_b(892716,e);a_b(e);g=a+24|0;f[g>>2]=0;u=d;return}function kKb(a){a=a|0;var c=0;c=f[a+8>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+12>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function lKb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223174]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=115;b[c+8>>0]=0;J_b(892696,c);a_b(c);u=a;return}function mKb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223177]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=118;b[c+8>>0]=0;J_b(892708,c);a_b(c);u=a;return}function nKb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223174]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=115;b[c+8>>0]=0;J_b(892696,c);a_b(c);u=a;return}function oKb(a){a=a|0;var b=0,c=0;f[a>>2]=110856;b=f[a+16>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function pKb(a){a=a|0;var b=0,c=0;f[a>>2]=110856;b=f[a+16>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function qKb(a){a=a|0;a=$Xc(36)|0;JKb(a);return a|0}function rKb(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(36)|0;JKb(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,19392,40);a=QXb(b,40)|0;KKb(a,b);c=a;return c|0}function sKb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function tKb(a){a=a|0;return f[a+4>>2]|0}function uKb(a){a=a|0;var b=0;f[a+8>>2]=0;b=a+24|0;f[b>>2]=0;f[b+4>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function vKb(a){a=a|0;return 1}function wKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=c+4|0;e=a+24|0;g=a+28|0;h=a+8|0;i=a+12|0;j=a+16|0;k=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=ZYb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}b:do if((o|0)==6){o=0;switch(n>>>3&536870911|0){case 1:{if((n&255|0)!=8){q=n;break b}m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[c>>2]=m+1;r=l}else{s=l;o=11}}else{s=0;o=11}if((o|0)==11){o=0;l=KYb(c,s)|0;m=J;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)r=l;else{t=0;o=39;break a}}f[e>>2]=r;continue a;break}case 2:{if((n&255|0)!=16){q=n;break b}l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){m=b[l>>0]|0;a=m&255;if(m<<24>>24>-1){f[c>>2]=l+1;u=a}else{v=a;o=17}}else{v=0;o=17}if((o|0)==17){o=0;a=KYb(c,v)|0;l=J;if((l|0)>-1|(l|0)==-1&a>>>0>4294967295)u=a;else{t=0;o=39;break a}}f[g>>2]=u;continue a;break}case 3:{switch((n&255)<<24>>24){case 26:break;case 24:{if(OUa(1,26,c,h)|0)continue a;else{t=0;o=39;break a}break}default:{q=n;break b}}a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0?(l=b[a>>0]|0,l<<24>>24>-1):0){f[c>>2]=a+1;w=l&255}else{l=YYb(c)|0;if((l|0)>-1)w=l;else{t=0;o=39;break a}}l=HYb(c,w)|0;if((PYb(c)|0)>0)do{a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;x=m&255;if(m<<24>>24>-1){f[c>>2]=a+1;y=x}else{z=x;o=28}}else{z=0;o=28}if((o|0)==28){o=0;x=KYb(c,z)|0;a=J;if((a|0)>-1|(a|0)==-1&x>>>0>4294967295)y=x;else{t=0;o=39;break a}}x=f[h>>2]|0;if((x|0)==(f[i>>2]|0)){qHa(h,x+1|0);A=f[h>>2]|0}else A=x;x=f[j>>2]|0;f[h>>2]=A+1;f[x+4+(A<<2)>>2]=y}while((PYb(c)|0)>0);IYb(c,l);continue a;break}default:{q=n;break b}}}while(0);if(!q){t=1;o=39;break}x=f[k>>2]|0;if(!(x&1))B=lSa(k)|0;else B=x&-2;if(!(Lqc(c,q,B)|0)){t=0;o=39;break}}if((o|0)==39)return t|0;return 0}function xKb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=n$b(a+8|0)|0;if(!c)e=d;else{if((c|0)<0)g=11;else g=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=g+d|0}f[a+20>>2]=c;d=e+c|0;c=f[a+24>>2]|0;if(!c)h=d;else{if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+d|0}d=f[a+28>>2]|0;if(!d){j=h;k=a+32|0;f[k>>2]=j;return j|0}if((d|0)<0)l=11;else l=((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=l+h|0;k=a+32|0;f[k>>2]=j;return j|0}function yKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[a+24>>2]|0;if(d|0)S_b(1,d,c);d=f[a+28>>2]|0;if(d|0)S_b(2,d,c);d=a+8|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=26;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{eZb(c,26);h=f[e>>2]|0}g=f[a+20>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else eZb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+16|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;n=((i|0)<0)<<31>>31;if((f[o>>2]|0)>9){k=f[e>>2]|0;j=i&255;if(i>>>0>127){l=k;m=j;p=i;q=n;while(1){b[l>>0]=m|-128;r=p;p=l1c(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=k;v=j}b[u>>0]=v;q=u+1-k|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else fZb(c,i,n);h=h+1|0}while((h|0)!=(g|0))}}g=f[a+4>>2]|0;if(!((g&1|0)!=0&(b[476924]|0)!=0))return;Oqc(g&-2,c);return}function zKb(a){a=a|0;return f[a+32>>2]|0}function AKb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=f[a+24>>2]|0;if(!c)e=d;else{b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=l1c(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+28>>2]|0;if(!n)p=e;else{b[e>>0]=16;o=e+1|0;e=n&255;if(n>>>0>127){d=o;g=e;k=n;i=((n|0)<0)<<31>>31;while(1){b[d>>0]=g|-128;n=k;k=l1c(k|0,i|0,7)|0;h=d+1|0;j=k&255;if(!(i>>>0>0|(i|0)==0&n>>>0>16383)){q=h;r=j;break}else{d=h;g=j;i=J}}}else{q=o;r=e}b[q>>0]=r;p=q+1|0}q=a+8|0;if((f[q>>2]|0)>0){b[p>>0]=26;r=p+1|0;e=f[a+20>>2]|0;if(e>>>0>127){o=e;i=r;while(1){b[i>>0]=o|128;g=o>>>7;d=i+1|0;if(o>>>0>16383){o=g;i=d}else{s=d;t=g;break}}}else{s=r;t=e}b[s>>0]=t;t=f[q>>2]|0;q=f[a+16>>2]|0;e=0;r=s+1|0;while(1){s=f[q+4+(e<<2)>>2]|0;i=s&255;if(s>>>0>127){o=r;g=i;d=s;k=((s|0)<0)<<31>>31;while(1){b[o>>0]=g|-128;s=d;d=l1c(d|0,k|0,7)|0;j=o+1|0;h=d&255;if(!(k>>>0>0|(k|0)==0&s>>>0>16383)){u=j;v=h;break}else{o=j;g=h;k=J}}}else{u=r;v=i}b[u>>0]=v;k=u+1|0;e=e+1|0;if((e|0)>=(t|0)){w=k;break}else r=k}}else w=p;p=f[a+4>>2]|0;if(!((p&1|0)!=0&(b[476924]|0)!=0)){x=w;return x|0}x=Pqc(p&-2,w)|0;return x|0}function BKb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;f[a+8>>2]=0;c=a+24|0;f[c>>2]=0;f[c+4>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);CKb(a,b);return}function CKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,19392,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=a+8|0;g=c+8|0;e=f[g>>2]|0;if(e|0){qHa(d,(f[d>>2]|0)+e|0);o1c((f[a+16>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+16>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[c+24>>2]|0;if(g|0)f[a+24>>2]=g;g=f[c+28>>2]|0;if(!g)return;f[a+28>>2]=g;return}function DKb(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function EKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223180]|0)!=2){f[d>>2]=165456;f[d+4>>2]=121;b[d+8>>0]=0;J_b(892720,d);a_b(d)}d=537328;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function FKb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223181]|0)!=2){f[c>>2]=165456;f[c+4>>2]=122;b[c+8>>0]=0;J_b(892724,c);a_b(c)}d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=14;e=d;g=460214;h=e+14|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+14>>0]=0;ejc(c,110956,110968,110816,0,537328,0,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function GKb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223182]|0)!=2){f[c>>2]=165456;f[c+4>>2]=123;b[c+8>>0]=0;J_b(892728,c);a_b(c)}n3b(460229,169);Boc(460214,2268);u=a;return}function HKb(){var a=0;d_b(3005001,3005e3,460399);WXb();f[134322]=110856;f[134323]=0;f[134324]=0;f[134325]=0;f[134326]=0;a=537312;f[a>>2]=0;f[a+4>>2]=0;f[134330]=0;C_b(537288);return}function IKb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223180]|0)!=2){f[c>>2]=165456;f[c+4>>2]=121;b[c+8>>0]=0;J_b(892720,c);a_b(c)}jjc(537328,1);u=a;return}function JKb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=110856;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=537288?(f[223182]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=123;b[d+8>>0]=0;J_b(892728,d);a_b(d)}d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[a+32>>2]=0;u=c;return}function KKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;f[a>>2]=110856;f[a+4>>2]=c;f[a+8>>2]=0;f[a+12>>2]=0;g=a+16|0;f[g>>2]=0;if(c|0){if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[223182]|0)==2){i=a+24|0;j=i;k=j;f[k>>2]=0;l=j+4|0;m=l;f[m>>2]=0;n=a+32|0;f[n>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=123;b[e+8>>0]=0;J_b(892728,e);a_b(e);i=a+24|0;j=i;k=j;f[k>>2]=0;l=j+4|0;m=l;f[m>>2]=0;n=a+32|0;f[n>>2]=0;u=d;return}function LKb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223181]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=122;b[c+8>>0]=0;J_b(892724,c);a_b(c);u=a;return}function MKb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223182]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=123;b[c+8>>0]=0;J_b(892728,c);a_b(c);u=a;return}function NKb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223181]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=122;b[c+8>>0]=0;J_b(892724,c);a_b(c);u=a;return}function OKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+8|0;g=b+8|0;e=f[g>>2]|0;if(e|0){qHa(d,(f[d>>2]|0)+e|0);o1c((f[a+16>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+16>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[b+24>>2]|0;if(g|0)f[a+24>>2]=g;g=f[b+28>>2]|0;if(!g)return;f[a+28>>2]=g;return}function PKb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0;j=u;u=u+48|0;k=j;l=j+36|0;m=j+32|0;if(((f[a+4>>2]|0)-(f[a>>2]|0)>>5|0)!=((f[c+4>>2]|0)-(f[c>>2]|0)>>2|0)){n=$Xc(32)|0;f[k>>2]=n;f[k+8>>2]=-2147483616;f[k+4>>2]=30;o=n;q=460516;r=o+30|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[n+30>>0]=0;vM(-215,k,460547,460556,36)}if(!(d>=0.0)){n=$Xc(32)|0;f[k>>2]=n;f[k+8>>2]=-2147483616;f[k+4>>2]=20;o=n;q=460620;r=o+20|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[n+20>>0]=0;vM(-215,k,460547,460556,36)}if(!(e>=0.0)){n=$Xc(32)|0;f[k>>2]=n;f[k+8>>2]=-2147483616;f[k+4>>2]=18;o=n;q=460641;r=o+18|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[n+18>>0]=0;vM(-215,k,460547,460556,36)}if(!(h>0.0)){f[k+8>>2]=0;b[k+11>>0]=7;b[k>>0]=b[460660]|0;b[k+1>>0]=b[460661]|0;b[k+2>>0]=b[460662]|0;b[k+3>>0]=b[460663]|0;b[k+4>>0]=b[460664]|0;b[k+5>>0]=b[460665]|0;b[k+6>>0]=b[460666]|0;b[k+7>>0]=0;vM(-215,k,460547,460556,36)}f[l>>2]=0;n=l+4|0;f[n>>2]=0;f[l+8>>2]=0;$Bb(c,d,i,l);i=f[g>>2]|0;c=g+4|0;q=f[c>>2]|0;o=i;r=q+(~((q+-4-o|0)>>>2)<<2)|0;if((q|0)==(i|0)){s=q;t=i}else{f[c>>2]=r;s=r;t=r}r=s;s=t;q=f[n>>2]|0;v=f[l>>2]|0;w=v;a:do if((q|0)!=(v|0)){x=g+8|0;if(h<1.0){y=k+8|0;z=k+16|0;A=k+24|0;B=0;d=e;C=r;D=t;E=i;F=w;G=o;H=s;while(1){I=f[F+(B<<3)+4>>2]|0;f[m>>2]=I;if((H-G|0)>0){J=0;K=G;L=C;M=E;N=I;while(1){I=f[M+(J<<2)>>2]|0;O=f[a>>2]|0;P=+p[O+(N<<5)+16>>3];Q=+p[O+(N<<5)+24>>3];R=P*Q+ +p[O+(I<<5)+16>>3]*+p[O+(I<<5)+24>>3];if(!(R<=2.220446049250313e-16)){p[k>>3]=+p[O+(N<<5)>>3];p[y>>3]=+p[O+(N<<5)+8>>3];p[z>>3]=P;p[A>>3]=Q;QKb(k,O+(I<<5)|0)|0;Q=+p[k+16>>3]*+p[k+24>>3];S=1.0-Q/(R-Q);T=f[g>>2]|0;U=f[c>>2]|0}else{S=0.0;T=K;U=L}V=1.0-S<=d;I=J+1|0;if(!(V&(I|0)<(U-T>>2|0)))break;J=I;K=T;L=U;M=T;N=f[m>>2]|0}if(V){W=U;X=17}else Y=0}else{W=D;X=17}do if((X|0)==17){X=0;if((W|0)==(f[x>>2]|0)){Tv(g,m);Y=1;break}else{f[W>>2]=f[m>>2];f[c>>2]=W+4;Y=1;break}}while(0);N=B+1|0;M=f[n>>2]|0;L=f[l>>2]|0;K=L;if(N>>>0>=M-L>>3>>>0){Z=M;_=K;break a}M=f[c>>2]|0;L=f[g>>2]|0;B=N;d=d>.5&Y?d*h:d;C=M;D=M;E=L;F=K;G=L;H=M}}else{H=k+8|0;G=k+16|0;F=k+24|0;E=0;D=w;C=o;B=s;A=r;z=t;y=i;while(1){M=f[D+(E<<3)+4>>2]|0;f[m>>2]=M;if((B-C|0)>0){L=0;K=y;N=M;M=C;J=A;while(1){I=f[K+(L<<2)>>2]|0;O=f[a>>2]|0;d=+p[O+(N<<5)+16>>3];Q=+p[O+(N<<5)+24>>3];R=d*Q+ +p[O+(I<<5)+16>>3]*+p[O+(I<<5)+24>>3];if(!(R<=2.220446049250313e-16)){p[k>>3]=+p[O+(N<<5)>>3];p[H>>3]=+p[O+(N<<5)+8>>3];p[G>>3]=d;p[F>>3]=Q;QKb(k,O+(I<<5)|0)|0;Q=+p[k+16>>3]*+p[k+24>>3];$=1.0-Q/(R-Q);aa=f[c>>2]|0;ba=f[g>>2]|0}else{$=0.0;aa=J;ba=M}ca=1.0-$<=e;I=L+1|0;if(!(ca&(I|0)<(aa-ba>>2|0)))break;L=I;K=ba;N=f[m>>2]|0;M=ba;J=aa}if(ca){da=aa;X=36}}else{da=z;X=36}do if((X|0)==36){X=0;if((da|0)==(f[x>>2]|0)){Tv(g,m);break}else{f[da>>2]=f[m>>2];f[c>>2]=da+4;break}}while(0);J=E+1|0;M=f[n>>2]|0;N=f[l>>2]|0;K=N;if(J>>>0>=M-N>>3>>>0){Z=M;_=K;break a}M=f[c>>2]|0;N=f[g>>2]|0;E=J;D=K;C=N;B=M;A=M;z=M;y=N}}}else{Z=q;_=w}while(0);w=Z;if(!_){u=j;return}if((w|0)!=(_|0))f[n>>2]=w+(~((w+-8-_|0)>>>3)<<3);cYc(_);u=j;return}function QKb(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,g=0,h=0.0,i=0.0,j=0.0,k=0,l=0.0;c=+p[a>>3];d=+p[b>>3];e=c<d?d:c;g=a+8|0;h=+p[g>>3];i=+p[b+8>>3];j=h<i?i:h;k=a+16|0;l=c+ +p[k>>3];c=d+ +p[b+16>>3];d=(c<l?c:l)-e;p[k>>3]=d;k=a+24|0;l=h+ +p[k>>3];h=i+ +p[b+24>>3];i=(h<l?h:l)-j;p[k>>3]=i;p[a>>3]=e;p[g>>3]=j;if(!(d<=0.0)&!(i<=0.0))return a|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function RKb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,460668)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function SKb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=+j;var k=0,l=0;k=$Xc(64)|0;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=110980;l=k+16|0;yP(l);f[l>>2]=111008;f[k+20>>2]=c;p[k+24>>3]=d;p[k+32>>3]=e;f[k+40>>2]=g;f[k+44>>2]=h;b[k+48>>0]=i&1;p[k+56>>3]=j;f[a>>2]=l;f[a+4>>2]=k;return}function TKb(a){a=a|0;WRb(a);cYc(a);return}function UKb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0;g=u;u=u+160|0;h=g+144|0;i=g+88|0;j=g+32|0;k=g+16|0;l=g;if(sS(c)|0){m=f[d>>2]|0;o=d+4|0;q=f[o>>2]|0;if((q|0)==(m|0)){u=g;return}f[o>>2]=q+(~(((q+-28-m|0)>>>0)/28|0)*28|0);u=g;return}f[h>>2]=0;m=h+4|0;f[m>>2]=0;f[h+8>>2]=0;if((eS(c)|0)!=655360){do if((eS(c)|0)==65536){q=f[c+4>>2]|0;f[i>>2]=f[q>>2];o=i+4|0;r=q+4|0;f[o>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[q+8>>2];t=i+12|0;f[t>>2]=f[q+12>>2];v=i+16|0;f[v>>2]=f[q+16>>2];w=i+20|0;f[w>>2]=f[q+20>>2];x=i+24|0;f[x>>2]=f[q+24>>2];y=i+28|0;f[y>>2]=f[q+28>>2];z=i+32|0;f[z>>2]=f[q+32>>2];A=i+36|0;B=f[q+36>>2]|0;f[A>>2]=B;f[i+40>>2]=s;C=i+48|0;D=i+44|0;f[D>>2]=C;f[C>>2]=0;f[i+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[r>>2]|0)<3){r=f[q+44>>2]|0;C=f[D>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2];E=o;F=s;G=t;H=v;I=v;J=w;K=x;L=y;M=z;N=A;O=A;P=i;break}else{f[o>>2]=0;U$(i,q);E=o;F=s;G=t;H=v;I=v;J=w;K=x;L=y;M=z;N=A;O=A;P=i;break}}else{bS(i,c,-1);A=i+16|0;z=i+36|0;E=i+4|0;F=i+8|0;G=i+12|0;H=A;I=A;J=i+20|0;K=i+24|0;L=i+28|0;M=i+32|0;N=z;O=z;P=i}while(0);f[j>>2]=f[P>>2];z=j+4|0;A=f[E>>2]|0;f[z>>2]=A;y=j+8|0;f[y>>2]=f[F>>2];f[j+12>>2]=f[G>>2];G=j+16|0;f[G>>2]=f[I>>2];f[j+20>>2]=f[J>>2];f[j+24>>2]=f[K>>2];f[j+28>>2]=f[L>>2];f[j+32>>2]=f[M>>2];M=j+36|0;L=f[O>>2]|0;f[M>>2]=L;O=j+40|0;f[O>>2]=y;y=j+48|0;K=j+44|0;f[K>>2]=y;f[y>>2]=0;f[j+52>>2]=0;if(!L)Q=A;else{A=L+12|0;f[A>>2]=(f[A>>2]|0)+1;Q=f[E>>2]|0}if((Q|0)<3){Q=f[i+44>>2]|0;A=f[K>>2]|0;f[A>>2]=f[Q>>2];f[A+4>>2]=f[Q+4>>2]}else{f[z>>2]=0;U$(j,i)}if(f[P>>2]&4095|0){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=i;P=l+8|0;f[P>>2]=0;f[P+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;Spa(k,l,6,0)}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;P=l+8|0;f[P>>2]=0;f[P+4>>2]=0;f[l>>2]=-2113732595;f[l+4>>2]=h;Rja(k,l,f[a+4>>2]|0,+p[a+8>>3],+p[a+16>>3],e,f[a+24>>2]|0,f[a+28>>2]|0,(b[a+32>>0]|0)!=0,+p[a+40>>3]);l=f[M>>2]|0;if(l|0?(P=l+12|0,l=f[P>>2]|0,f[P>>2]=l+-1,(l|0)==1):0)V$(j);f[M>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[z>>2]|0)>0){G=f[O>>2]|0;O=0;do{f[G+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[z>>2]|0))}z=f[K>>2]|0;if((z|0)!=(y|0))wL(z);z=f[N>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)V$(i);f[N>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[E>>2]|0)>0){H=f[i+40>>2]|0;N=0;do{f[H+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[E>>2]|0))}E=f[i+44>>2]|0;if((E|0)!=(i+48|0))wL(E)}else{f[i>>2]=1124007936;E=i+4|0;N=i+8|0;H=i+20|0;z=i+24|0;y=i+28|0;K=i+32|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[K>>2]=N;O=i+40|0;f[i+36>>2]=O;f[i+44>>2]=0;f[O>>2]=0;if(!(dS(c,-1)|0)){fS(j,c,-1);G=f[z>>2]|0;if(G|0?(M=G+8|0,G=f[M>>2]|0,f[M>>2]=G+-1,(G|0)==1):0)FQ(i);if((f[E>>2]|0)>0){G=f[K>>2]|0;M=0;do{f[G+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[E>>2]|0))}f[i>>2]=f[j>>2];M=j+4|0;G=f[M>>2]|0;f[E>>2]=G;E=j+8|0;f[N>>2]=f[E>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[H>>2]=f[j+20>>2];H=j+24|0;f[z>>2]=f[H>>2];z=j+28|0;f[y>>2]=f[z>>2];y=i+36|0;l=f[y>>2]|0;if((l|0)==(O|0))R=G;else{wL(l);f[y>>2]=O;f[K>>2]=N;R=f[M>>2]|0}N=j+36|0;if((R|0)<3){R=f[N>>2]|0;f[O>>2]=f[R>>2];f[i+44>>2]=f[R+4>>2]}else{f[y>>2]=f[N>>2];y=j+32|0;f[i+32>>2]=f[y>>2];f[N>>2]=j+40;f[y>>2]=E}f[j>>2]=1124007936;f[H>>2]=0;f[z>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;EQ(j)}else{M=j+8|0;f[M>>2]=0;f[M+4>>2]=0;f[j>>2]=34209792;f[j+4>>2]=i;Spa(c,j,6,0)}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17432576;f[j+4>>2]=i;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=-2113732595;f[k+4>>2]=h;Rja(j,k,f[a+4>>2]|0,+p[a+8>>3],+p[a+16>>3],e,f[a+24>>2]|0,f[a+28>>2]|0,(b[a+32>>0]|0)!=0,+p[a+40>>3]);EQ(i)}i=f[m>>2]|0;e=f[h>>2]|0;k=i-e>>3;j=d+4|0;c=f[j>>2]|0;M=f[d>>2]|0;z=(c-M|0)/28|0;H=M;M=c;c=i;i=e;if(k>>>0<=z>>>0)if(k>>>0<z>>>0?(E=H+(k*28|0)|0,(M|0)!=(E|0)):0){y=M+(~(((M+-28-E|0)>>>0)/28|0)*28|0)|0;f[j>>2]=y;S=e;T=c;U=H;V=y;W=i}else{S=e;T=c;U=H;V=M;W=i}else{iL(d,k-z|0);z=f[h>>2]|0;S=z;T=f[m>>2]|0;U=f[d>>2]|0;V=f[j>>2]|0;W=z}z=S;if((z|0)!=(T|0)&(U|0)!=(V|0)){V=a+24|0;a=U;U=S;S=z;while(1){z=f[S+4>>2]|0;X=+(f[V>>2]|0);f[a>>2]=f[U>>2];f[a+4>>2]=z;n[a+8>>2]=X;n[a+12>>2]=-1.0;n[a+16>>2]=0.0;f[a+20>>2]=0;f[a+24>>2]=-1;z=S+8|0;d=a+28|0;if((z|0)!=(T|0)?(d|0)!=(f[j>>2]|0):0){a=d;U=z;S=z}else break}}if(W|0){if((T|0)!=(W|0))f[m>>2]=T+(~((T+-8-W|0)>>>3)<<3);cYc(W)}u=g;return}function VKb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function WKb(a){a=a|0;return f[a+4>>2]|0}function XKb(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function YKb(a){a=a|0;return +(+p[a+8>>3])}function ZKb(a,b){a=a|0;b=+b;p[a+16>>3]=b;return}function _Kb(a){a=a|0;return +(+p[a+16>>3])}function $Kb(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function aLb(a){a=a|0;return f[a+24>>2]|0}function bLb(a,c){a=a|0;c=c|0;b[a+32>>0]=c&1;return}function cLb(a){a=a|0;return (b[a+32>>0]|0)!=0|0}function dLb(a,b){a=a|0;b=+b;p[a+40>>3]=b;return}function eLb(a){a=a|0;return +(+p[a+40>>3])}function fLb(a){a=a|0;f[a>>2]=110980;WRb(a+16|0);NXc(a);return}function gLb(a){a=a|0;f[a>>2]=110980;WRb(a+16|0);NXc(a);cYc(a);return}function hLb(a){a=a|0;WRb(a+16|0);return}function iLb(a){a=a|0;cYc(a);return}function jLb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=+i;var j=0,k=0;j=$Xc(64)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=110980;k=j+16|0;yP(k);f[k>>2]=111008;f[j+20>>2]=c;p[j+24>>3]=d;p[j+32>>3]=e;f[j+40>>2]=g;f[j+44>>2]=3;b[j+48>>0]=h&1;p[j+56>>3]=i;f[a>>2]=k;f[a+4>>2]=j;return}function kLb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,460803)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function lLb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;do if((eS(a)|0)==65536){k=f[a+4>>2]|0;f[j>>2]=f[k>>2];l=j+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=j+8|0;f[n>>2]=f[k+8>>2];f[j+12>>2]=f[k+12>>2];f[j+16>>2]=f[k+16>>2];f[j+20>>2]=f[k+20>>2];f[j+24>>2]=f[k+24>>2];f[j+28>>2]=f[k+28>>2];f[j+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=n;n=j+48|0;p=j+44|0;f[p>>2]=n;f[n>>2]=0;f[j+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;U$(j,k);break}}else bS(j,a,-1);while(0);if((c|0)<=20){k=f[j+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[j>>2]&4095;f[i>>2]=1124007936;n=i+4|0;p=i+8|0;o=i+40|0;q=n;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=p;p=i+48|0;q=i+44|0;f[q>>2]=p;f[p>>2]=0;f[i+52>>2]=0;f[h>>2]=m;f[h+4>>2]=l;S$(i,2,h,k);k=i+16|0;h=i+36|0;l=f[h>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)V$(i);f[h>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[n>>2]|0)>0){k=f[o>>2]|0;o=0;do{f[k+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[q>>2]|0;if((n|0)!=(p|0))wL(n)}switch(e|0){case 0:{mLb(a,b,c,d);break}case 1:{nLb(a,b,c,d);break}case 2:{oLb(a,b,c,d);break}default:{}}d=j+36|0;c=f[d>>2]|0;if(c|0?(b=c+12|0,c=f[b>>2]|0,f[b>>2]=c+-1,(c|0)==1):0)V$(j);f[d>>2]=0;d=j+16|0;c=j+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[j+40>>2]|0;b=0;do{f[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)==(j+48|0)){u=g;return}wL(c);u=g;return}function mLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0.0,Ra=0.0,Sa=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((eS(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;U$(j,d);y=t;break}}else{bS(j,a,-1);y=j+48|0}while(0);_Nb(k,f[y>>2]|0,8);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=bYc(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;g1c(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=3;X=i;while(1){i=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(W+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;g1c($|0,0,X|0)|0;if((W|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=i+(Y(Z,W)|0)+3|0;Z=0;while(1){i=h[ba>>0]|0;ca=l+(0-i)+255|0;da=h[ba+(f[k>>2]|0)>>0]|0;ea=h[ba+(f[A>>2]|0)>>0]|0;fa=b[ca+ea>>0]|b[ca+da>>0];a:do if(fa<<24>>24!=0?(ga=h[ba+(f[B>>2]|0)>>0]|0,ha=h[ba+(f[C>>2]|0)>>0]|0,ia=h[ba+(f[D>>2]|0)>>0]|0,ja=h[ba+(f[E>>2]|0)>>0]|0,ka=h[ba+(f[F>>2]|0)>>0]|0,la=(b[ca+ha>>0]|b[ca+ga>>0])&fa&(b[ca+ja>>0]|b[ca+ia>>0])&(b[ca+(h[ba+(f[G>>2]|0)>>0]|0)>>0]|b[ca+ka>>0]),la<<24>>24!=0):0){ma=h[ba+(f[H>>2]|0)>>0]|0;na=h[ba+(f[I>>2]|0)>>0]|0;oa=h[ba+(f[J>>2]|0)>>0]|0;pa=h[ba+(f[K>>2]|0)>>0]|0;qa=h[ba+(f[L>>2]|0)>>0]|0;ra=h[ba+(f[N>>2]|0)>>0]|0;sa=(b[ca+na>>0]|b[ca+ma>>0])&la&(b[ca+pa>>0]|b[ca+oa>>0])&(b[ca+(h[ba+(f[M>>2]|0)>>0]|0)>>0]|b[ca+qa>>0])&(b[ca+(h[ba+(f[O>>2]|0)>>0]|0)>>0]|b[ca+ra>>0])&255;b:do if(sa&1){la=i-a|0;ta=(oa|0)<(la|0)?((ga|0)<(la|0)?((ma|0)<(la|0)?((da|0)<(la|0)?4:3):2):1):0;if((ia|0)<(la|0)){if(ta>>>0<=3){ua=ta+1|0;va=67}}else{ua=0;va=67}do if((va|0)==67){va=0;if((qa|0)<(la|0))if((ua|0)>3)break;else wa=ua+1|0;else wa=0;if((ka|0)<(la|0))if((wa|0)>3)break;else xa=wa+1|0;else xa=0;if((ra|0)<(la|0))if((xa|0)>3)break;else ya=xa+1|0;else ya=0;if((ea|0)<(la|0))if((ya|0)>3)break;else za=ya+1|0;else za=0;if((na|0)<(la|0))if((za|0)>3)break;else Aa=za+1|0;else Aa=0;if((ha|0)<(la|0))if((Aa|0)>3)break;else Ba=Aa+1|0;else Ba=0;if((pa|0)<(la|0))if((Ba|0)>3)break;else Ca=Ba+1|0;else Ca=0;if(!((ja|0)<(la|0)&(Ca|0)>3)){Da=Z;break b}}while(0);la=Z+1|0;f[aa+(Z<<2)>>2]=_;if(e){ta=(bOb(ba,k,a)|0)&255;b[$+_>>0]=ta;Da=la}else Da=la}else Da=Z;while(0);if(sa&2){ja=a+i|0;pa=(h[ba+(f[J>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ba+(f[B>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ba+(f[H>>2]|0)>>0]|0)>>>0>ja>>>0?((h[ba+(f[k>>2]|0)>>0]|0)>>>0>ja>>>0?4:3):2):1):0;if((h[ba+(f[D>>2]|0)>>0]|0)>>>0>ja>>>0){if(pa>>>0<=3){Ea=pa+1|0;va=83}}else{Ea=0;va=83}do if((va|0)==83){va=0;if((h[ba+(f[L>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ea|0)>3)break;else Fa=Ea+1|0;else Fa=0;if((h[ba+(f[F>>2]|0)>>0]|0)>>>0>ja>>>0)if((Fa|0)>3)break;else Ga=Fa+1|0;else Ga=0;if((h[ba+(f[N>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ga|0)>3)break;else Ha=Ga+1|0;else Ha=0;if((h[ba+(f[A>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ha|0)>3)break;else Ia=Ha+1|0;else Ia=0;if((h[ba+(f[I>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ia|0)>3)break;else Ja=Ia+1|0;else Ja=0;if((h[ba+(f[C>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ja|0)>3)break;else Ka=Ja+1|0;else Ka=0;if((h[ba+(f[K>>2]|0)>>0]|0)>>>0>ja>>>0)if((Ka|0)>3)break;else La=Ka+1|0;else La=0;if(!((La|0)>3?(h[ba+(f[E>>2]|0)>>0]|0)>>>0>ja>>>0:0)){Ma=Da;break a}}while(0);ja=Da+1|0;f[aa+(Da<<2)>>2]=_;if(e){sa=(bOb(ba,k,a)|0)&255;b[$+_>>0]=sa;Ma=ja}else Ma=ja}else Ma=Da}else Ma=Z;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){Na=Ma;break}else{ba=ba+1|0;Z=Ma}}}else Na=0;f[aa+-4>>2]=Na;c:do if((W|0)!=3?(Z=W+-1|0,ba=(Z|0)%3|0,_=f[o+(ba<<2)>>2]|0,i=f[o+(((W+-2|0)%3|0)<<2)>>2]|0,ea=f[p+(ba<<2)>>2]|0,ba=f[ea+-4>>2]|0,(ba|0)>0):0){Oa=+(Z|0);if(e)Pa=0;else{Z=0;while(1){da=f[ea+(Z<<2)>>2]|0;Qa=+(da|0);Ra=+(h[_+da>>0]|0);n[q>>2]=Qa;n[P>>2]=Oa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=Ra;f[T>>2]=0;f[U>>2]=-1;da=f[t>>2]|0;if(da>>>0<(f[V>>2]|0)>>>0){n[da>>2]=Qa;f[da+4>>2]=f[P>>2];ca=da+8|0;f[ca>>2]=f[Q>>2];f[ca+4>>2]=f[Q+4>>2];f[ca+8>>2]=f[Q+8>>2];f[ca+12>>2]=f[Q+12>>2];f[ca+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}else NA(c,q);Z=Z+1|0;if((Z|0)>=(ba|0))break c}}do{Z=f[ea+(Pa<<2)>>2]|0;ca=b[_+Z>>0]|0;da=Z+1|0;do if(((((((ca&255)>(h[_+da>>0]|0)?(fa=Z+-1|0,(ca&255)>(h[_+fa>>0]|0)):0)?(ca&255)>(h[i+fa>>0]|0):0)?(ca&255)>(h[i+Z>>0]|0):0)?(ca&255)>(h[i+da>>0]|0):0)?(ca&255)>(h[$+fa>>0]|0):0)?(ca&255)>(h[$+Z>>0]|0):0){if((ca&255)<=(h[$+da>>0]|0))break;Qa=+(Z|0);n[q>>2]=Qa;n[P>>2]=Oa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ca&255);f[T>>2]=0;f[U>>2]=-1;fa=f[t>>2]|0;if(fa>>>0<(f[V>>2]|0)>>>0){n[fa>>2]=Qa;f[fa+4>>2]=f[P>>2];ja=fa+8|0;f[ja>>2]=f[Q>>2];f[ja+4>>2]=f[Q+4>>2];f[ja+8>>2]=f[Q+8>>2];f[ja+12>>2]=f[Q+12>>2];f[ja+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}else NA(c,q)}while(0);Pa=Pa+1|0}while((Pa|0)<(ba|0))}while(0);$=W+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=$;X=f[d>>2]|0}Sa=f[m>>2]|0}else Sa=z;if((Sa|0)!=(s|0)){if(Sa|0)dYc(Sa);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)V$(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}wL(s);u=g;return}function nLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((eS(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;U$(j,d);y=t;break}}else{bS(j,a,-1);y=j+48|0}while(0);_Nb(k,f[y>>2]|0,12);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=bYc(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;g1c(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=3;X=i;while(1){i=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(W+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;g1c($|0,0,X|0)|0;if((W|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=i+(Y(Z,W)|0)+3|0;Z=0;while(1){i=h[ba>>0]|0;ca=l+(0-i)+255|0;da=b[ba+(f[k>>2]|0)>>0]|0;ea=b[ca+(h[ba+(f[A>>2]|0)>>0]|0)>>0]|b[ca+(da&255)>>0];a:do if(ea<<24>>24!=0?(fa=(b[ca+(h[ba+(f[C>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[B>>2]|0)>>0]|0)>>0])&ea&(b[ca+(h[ba+(f[E>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[D>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[G>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[F>>2]|0)>>0]|0)>>0]),fa<<24>>24!=0):0){ga=(b[ca+(h[ba+(f[I>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[H>>2]|0)>>0]|0)>>0])&fa&(b[ca+(h[ba+(f[K>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[J>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[M>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[L>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[O>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[N>>2]|0)>>0]|0)>>0])&255;b:do if(ga&1){fa=i-a|0;ha=0;ia=0;ja=da;while(1){if((ja&255|0)<(fa|0))if((ia|0)>5)break;else ka=ia+1|0;else ka=0;la=ha+1|0;if((la|0)>=19){ma=Z;break b}ha=la;ia=ka;ja=b[ba+(f[k+(la<<2)>>2]|0)>>0]|0}ja=Z+1|0;f[aa+(Z<<2)>>2]=_;if(e){ia=(aOb(ba,k,a)|0)&255;b[$+_>>0]=ia;ma=ja}else ma=ja}else ma=Z;while(0);if(ga&2){ja=a+i|0;ia=0;ha=0;while(1){if((h[ba+(f[k+(ha<<2)>>2]|0)>>0]|0)>>>0>ja>>>0)if((ia|0)>5)break;else na=ia+1|0;else na=0;ha=ha+1|0;if((ha|0)>=19){oa=ma;break a}else ia=na}ia=ma+1|0;f[aa+(ma<<2)>>2]=_;if(e){ha=(aOb(ba,k,a)|0)&255;b[$+_>>0]=ha;oa=ia}else oa=ia}else oa=ma}else oa=Z;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){pa=oa;break}else{ba=ba+1|0;Z=oa}}}else pa=0;f[aa+-4>>2]=pa;c:do if((W|0)!=3?(Z=W+-1|0,ba=(Z|0)%3|0,_=f[o+(ba<<2)>>2]|0,i=f[o+(((W+-2|0)%3|0)<<2)>>2]|0,da=f[p+(ba<<2)>>2]|0,ba=f[da+-4>>2]|0,(ba|0)>0):0){qa=+(Z|0);if(e)ra=0;else{Z=0;while(1){ca=f[da+(Z<<2)>>2]|0;sa=+(ca|0);ta=+(h[_+ca>>0]|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=ta;f[T>>2]=0;f[U>>2]=-1;ca=f[t>>2]|0;if(ca>>>0<(f[V>>2]|0)>>>0){n[ca>>2]=sa;f[ca+4>>2]=f[P>>2];ea=ca+8|0;f[ea>>2]=f[Q>>2];f[ea+4>>2]=f[Q+4>>2];f[ea+8>>2]=f[Q+8>>2];f[ea+12>>2]=f[Q+12>>2];f[ea+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}else NA(c,q);Z=Z+1|0;if((Z|0)>=(ba|0))break c}}do{Z=f[da+(ra<<2)>>2]|0;ea=b[_+Z>>0]|0;ca=Z+1|0;do if(((((((ea&255)>(h[_+ca>>0]|0)?(ia=Z+-1|0,(ea&255)>(h[_+ia>>0]|0)):0)?(ea&255)>(h[i+ia>>0]|0):0)?(ea&255)>(h[i+Z>>0]|0):0)?(ea&255)>(h[i+ca>>0]|0):0)?(ea&255)>(h[$+ia>>0]|0):0)?(ea&255)>(h[$+Z>>0]|0):0){if((ea&255)<=(h[$+ca>>0]|0))break;sa=+(Z|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ea&255);f[T>>2]=0;f[U>>2]=-1;ia=f[t>>2]|0;if(ia>>>0<(f[V>>2]|0)>>>0){n[ia>>2]=sa;f[ia+4>>2]=f[P>>2];ha=ia+8|0;f[ha>>2]=f[Q>>2];f[ha+4>>2]=f[Q+4>>2];f[ha+8>>2]=f[Q+8>>2];f[ha+12>>2]=f[Q+12>>2];f[ha+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}else NA(c,q)}while(0);ra=ra+1|0}while((ra|0)<(ba|0))}while(0);$=W+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=$;X=f[d>>2]|0}ua=f[m>>2]|0}else ua=z;if((ua|0)!=(s|0)){if(ua|0)dYc(ua);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)V$(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}wL(s);u=g;return}function oLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0;g=u;u=u+1776|0;i=g+1196|0;j=g+1200|0;k=g+1096|0;l=g+1256|0;m=g+56|0;o=g+40|0;p=g+28|0;q=g;f[i>>2]=d;do if((eS(a)|0)==65536){d=f[a+4>>2]|0;f[j>>2]=f[d>>2];r=j+4|0;s=d+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[d+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;U$(j,d);y=t;break}}else{bS(j,a,-1);y=j+48|0}while(0);_Nb(k,f[y>>2]|0,16);a=f[c>>2]|0;t=c+4|0;d=f[t>>2]|0;if((d|0)!=(a|0))f[t>>2]=d+(~(((d+-28-a|0)>>>0)/28|0)*28|0);a=f[i>>2]|0;d=(a|0)>0?a:0;a=(d|0)<255?d:255;f[i>>2]=a;i=0-a|0;d=-255;do{b[l+(d+255)>>0]=(d|0)<(i|0)?1:(d|0)>(a|0)?2:0;d=d+1|0}while((d|0)!=256);d=j+12|0;i=f[d>>2]|0;r=(i*15|0)+368|0;s=m+8|0;f[m>>2]=s;x=m+4|0;f[x>>2]=r;if(r>>>0>1032){w=bYc(r)|0;f[m>>2]=w;z=w}else z=s;f[o>>2]=z;w=z+i|0;f[o+4>>2]=w;r=w+i|0;f[o+8>>2]=r;w=(r+i+3&-4)+4|0;f[p>>2]=w;r=w+(i<<2)+4|0;f[p+4>>2]=r;f[p+8>>2]=r+(i<<2)+4;g1c(z|0,0,i*3|0)|0;r=j+8|0;if(((f[r>>2]|0)+-2|0)>3){w=j+16|0;v=j+44|0;A=k+32|0;B=k+8|0;C=k+40|0;D=k+16|0;E=k+48|0;F=k+24|0;G=k+56|0;H=k+4|0;I=k+36|0;J=k+12|0;K=k+44|0;L=k+20|0;M=k+52|0;N=k+28|0;O=k+60|0;P=q+4|0;Q=q+8|0;R=q+12|0;S=q+16|0;T=q+20|0;U=q+24|0;V=c+8|0;W=3;X=i;while(1){i=f[w>>2]|0;Z=f[f[v>>2]>>2]|0;_=(W+-3|0)%3|0;$=f[o+(_<<2)>>2]|0;aa=f[p+(_<<2)>>2]|0;g1c($|0,0,X|0)|0;if((W|0)<((f[r>>2]|0)+-3|0)?((f[d>>2]|0)+-3|0)>3:0){_=3;ba=i+(Y(Z,W)|0)+3|0;Z=0;while(1){i=h[ba>>0]|0;ca=l+(0-i)+255|0;da=b[ba+(f[k>>2]|0)>>0]|0;ea=b[ca+(h[ba+(f[A>>2]|0)>>0]|0)>>0]|b[ca+(da&255)>>0];a:do if(ea<<24>>24!=0?(fa=(b[ca+(h[ba+(f[C>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[B>>2]|0)>>0]|0)>>0])&ea&(b[ca+(h[ba+(f[E>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[D>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[G>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[F>>2]|0)>>0]|0)>>0]),fa<<24>>24!=0):0){ga=(b[ca+(h[ba+(f[I>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[H>>2]|0)>>0]|0)>>0])&fa&(b[ca+(h[ba+(f[K>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[J>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[M>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[L>>2]|0)>>0]|0)>>0])&(b[ca+(h[ba+(f[O>>2]|0)>>0]|0)>>0]|b[ca+(h[ba+(f[N>>2]|0)>>0]|0)>>0])&255;b:do if(ga&1){fa=i-a|0;ha=0;ia=0;ja=da;while(1){if((ja&255|0)<(fa|0))if((ia|0)>7)break;else ka=ia+1|0;else ka=0;la=ha+1|0;if((la|0)>=25){ma=Z;break b}ha=la;ia=ka;ja=b[ba+(f[k+(la<<2)>>2]|0)>>0]|0}ja=Z+1|0;f[aa+(Z<<2)>>2]=_;if(e){ia=($Nb(ba,k,a)|0)&255;b[$+_>>0]=ia;ma=ja}else ma=ja}else ma=Z;while(0);if(ga&2){ja=a+i|0;ia=0;ha=0;while(1){if((h[ba+(f[k+(ha<<2)>>2]|0)>>0]|0)>>>0>ja>>>0)if((ia|0)>7)break;else na=ia+1|0;else na=0;ha=ha+1|0;if((ha|0)>=25){oa=ma;break a}else ia=na}ia=ma+1|0;f[aa+(ma<<2)>>2]=_;if(e){ha=($Nb(ba,k,a)|0)&255;b[$+_>>0]=ha;oa=ia}else oa=ia}else oa=ma}else oa=Z;while(0);_=_+1|0;if((_|0)>=((f[d>>2]|0)+-3|0)){pa=oa;break}else{ba=ba+1|0;Z=oa}}}else pa=0;f[aa+-4>>2]=pa;c:do if((W|0)!=3?(Z=W+-1|0,ba=(Z|0)%3|0,_=f[o+(ba<<2)>>2]|0,i=f[o+(((W+-2|0)%3|0)<<2)>>2]|0,da=f[p+(ba<<2)>>2]|0,ba=f[da+-4>>2]|0,(ba|0)>0):0){qa=+(Z|0);if(e)ra=0;else{Z=0;while(1){ca=f[da+(Z<<2)>>2]|0;sa=+(ca|0);ta=+(h[_+ca>>0]|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=ta;f[T>>2]=0;f[U>>2]=-1;ca=f[t>>2]|0;if(ca>>>0<(f[V>>2]|0)>>>0){n[ca>>2]=sa;f[ca+4>>2]=f[P>>2];ea=ca+8|0;f[ea>>2]=f[Q>>2];f[ea+4>>2]=f[Q+4>>2];f[ea+8>>2]=f[Q+8>>2];f[ea+12>>2]=f[Q+12>>2];f[ea+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}else NA(c,q);Z=Z+1|0;if((Z|0)>=(ba|0))break c}}do{Z=f[da+(ra<<2)>>2]|0;ea=b[_+Z>>0]|0;ca=Z+1|0;do if(((((((ea&255)>(h[_+ca>>0]|0)?(ia=Z+-1|0,(ea&255)>(h[_+ia>>0]|0)):0)?(ea&255)>(h[i+ia>>0]|0):0)?(ea&255)>(h[i+Z>>0]|0):0)?(ea&255)>(h[i+ca>>0]|0):0)?(ea&255)>(h[$+ia>>0]|0):0)?(ea&255)>(h[$+Z>>0]|0):0){if((ea&255)<=(h[$+ca>>0]|0))break;sa=+(Z|0);n[q>>2]=sa;n[P>>2]=qa;n[Q>>2]=7.0;n[R>>2]=-1.0;n[S>>2]=+(ea&255);f[T>>2]=0;f[U>>2]=-1;ia=f[t>>2]|0;if(ia>>>0<(f[V>>2]|0)>>>0){n[ia>>2]=sa;f[ia+4>>2]=f[P>>2];ha=ia+8|0;f[ha>>2]=f[Q>>2];f[ha+4>>2]=f[Q+4>>2];f[ha+8>>2]=f[Q+8>>2];f[ha+12>>2]=f[Q+12>>2];f[ha+16>>2]=f[Q+16>>2];f[t>>2]=(f[t>>2]|0)+28}else NA(c,q)}while(0);ra=ra+1|0}while((ra|0)<(ba|0))}while(0);$=W+1|0;if(($|0)>=((f[r>>2]|0)+-2|0))break;W=$;X=f[d>>2]|0}ua=f[m>>2]|0}else ua=z;if((ua|0)!=(s|0)){if(ua|0)dYc(ua);f[m>>2]=s;f[x>>2]=1032}x=j+36|0;s=f[x>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)V$(j);f[x>>2]=0;x=j+16|0;s=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[j+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(y|0)){u=g;return}wL(s);u=g;return}function pLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=$Xc(28)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=111128;h=g+12|0;yP(h);f[h>>2]=111156;f[g+16>>2]=c;b[g+20>>0]=d&1;f[g+24>>2]=e;f[a>>2]=h;f[a+4>>2]=g;return}function qLb(a){a=a|0;WRb(a);cYc(a);return}function rLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+192|0;h=g+136|0;i=g+80|0;j=g+32|0;k=g+16|0;l=g;if(sS(c)|0){m=f[d>>2]|0;n=d+4|0;o=f[n>>2]|0;if((o|0)==(m|0)){u=g;return}f[n>>2]=o+(~(((o+-28-m|0)>>>0)/28|0)*28|0);u=g;return}do if((eS(e)|0)==65536){m=f[e+4>>2]|0;f[h>>2]=f[m>>2];o=h+4|0;n=m+4|0;f[o>>2]=f[n>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[n>>2]|0)<3){n=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[n>>2];f[p+4>>2]=f[n+4>>2];break}else{f[o>>2]=0;U$(h,m);break}}else bS(h,e,-1);while(0);f[i>>2]=1124007936;e=i+4|0;m=i+8|0;o=i+40|0;n=e;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[o>>2]=m;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;p=j+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[j+32>>2]=j+8;p=j+40|0;f[j+36>>2]=p;f[j+44>>2]=0;f[p>>2]=0;p=c;r=f[p+4>>2]|0;q=k;f[q>>2]=f[p>>2];f[q+4>>2]=r;r=k+8|0;f[r>>2]=f[c+8>>2];q=k+12|0;f[q>>2]=f[c+12>>2];if(dS(c,-1)|0){p=(eS(c)|0)==655360;s=l+8|0;f[s>>2]=0;f[s+4>>2]=0;if(p){f[l>>2]=34209792;f[l+4>>2]=j}else{f[l>>2]=33619968;f[l+4>>2]=i}Spa(c,l,6,0);c=l;p=f[c+4>>2]|0;s=k;f[s>>2]=f[c>>2];f[s+4>>2]=p;f[r>>2]=f[l+8>>2];f[q>>2]=f[l+12>>2]}lLb(k,d,f[a+4>>2]|0,(b[a+8>>0]|0)!=0,f[a+12>>2]|0);mSb(d,h);EQ(j);j=i+36|0;d=f[j>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)V$(i);f[j>>2]=0;j=i+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[e>>2]|0)>0){j=f[o>>2]|0;o=0;do{f[j+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[e>>2]|0))}e=f[n>>2]|0;if((e|0)!=(m|0))wL(e);e=h+36|0;m=f[e>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(h);f[e>>2]=0;e=h+16|0;m=h+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[h+40>>2]|0;n=0;do{f[e+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[h+44>>2]|0;if((m|0)!=(h+48|0))wL(m);u=g;return}function sLb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function tLb(a){a=a|0;return f[a+4>>2]|0}function uLb(a,c){a=a|0;c=c|0;b[a+8>>0]=c&1;return}function vLb(a){a=a|0;return (b[a+8>>0]|0)!=0|0}function wLb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function xLb(a){a=a|0;return f[a+12>>2]|0}function yLb(a){a=a|0;f[a>>2]=111128;WRb(a+12|0);NXc(a);return}function zLb(a){a=a|0;f[a>>2]=111128;WRb(a+12|0);NXc(a);cYc(a);return}function ALb(a){a=a|0;WRb(a+12|0);return}function BLb(a){a=a|0;cYc(a);return}function CLb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+32|0;i=h;do if(!(g&1)){if((dS(a,-1)|0)==16){uS(a,d);break}if(!(dS(a,-1)|0)){Spa(a,d,8,0);break}else{j=$Xc(32)|0;f[i>>2]=j;f[i+8>>2]=-2147483616;f[i+4>>2]=31;k=j;l=460966;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+31>>0]=0;vM(-5,i,460998,461012,108)}}while(0);a=OR()|0;if((+p[e>>3]==-1.0?+p[e+8>>3]==-1.0:0)?+p[e+16>>3]==-1.0:0)n=+p[e+24>>3]==-1.0;else n=0;if(sS(d)|0){o=$Xc(32)|0;f[i>>2]=o;f[i+8>>2]=-2147483616;f[i+4>>2]=17;k=o;l=461084;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[o+17>>0]=0;vM(-215,i,460998,461012,115)}o=f[c>>2]|0;l=f[c+4>>2]|0;if((o|0)==(l|0)){u=h;return}c=i+8|0;k=i+16|0;m=i+24|0;q=e+8|0;r=e+16|0;s=e+24|0;if(n){n=o;do{t=a;v=f[t+4>>2]|0;w=x1c(f[t>>2]|0,0,-130063606,0)|0;t=d1c(w|0,J|0,v|0,0)|0;v=J;w=x1c(t|0,0,-130063606,0)|0;x=d1c(w|0,J|0,v|0,0)|0;v=J;w=x1c(x|0,0,-130063606,0)|0;y=d1c(w|0,J|0,v|0,0)|0;v=a;f[v>>2]=y;f[v+4>>2]=J;p[i>>3]=+((t&255)>>>0);p[c>>3]=+((x&255)>>>0);p[k>>3]=+((y&255)>>>0);p[m>>3]=0.0;DLb(d,n,i,g);n=n+28|0}while((n|0)!=(l|0));u=h;return}else{n=o;do{p[i>>3]=+p[e>>3];p[c>>3]=+p[q>>3];p[k>>3]=+p[r>>3];p[m>>3]=+p[s>>3];DLb(d,n,i,g);n=n+28|0}while((n|0)!=(l|0));u=h;return}}function DLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;g=u;u=u+48|0;h=g+32|0;i=g+24|0;j=g+16|0;k=g+8|0;l=g;if(sS(a)|0){m=$Xc(16)|0;f[h>>2]=m;f[h+8>>2]=-2147483632;f[h+4>>2]=12;o=m;p=470240;q=o+12|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+12>>0]=0;vM(-215,h,461102,461012,55)}h=ALc(+n[c>>2]*16.0)|0;m=ALc(+n[c+4>>2]*16.0)|0;if(!(e&4)){f[l>>2]=h;f[l+4>>2]=m;Gra(a,l,48,d,1,16,4);u=g;return}l=ALc(+n[c+8>>2]*.5*16.0)|0;f[i>>2]=h;f[i+4>>2]=m;Gra(a,i,l,d,1,16,4);r=+n[c+12>>2];if(!(r!=-1.0)){u=g;return}s=r*3.1415927410125732/180.0;r=+(l|0);l=ALc(r*+O(+s))|0;c=ALc(r*+P(+s))|0;f[j>>2]=h;f[j+4>>2]=m;f[k>>2]=l+h;f[k+4>>2]=c+m;kra(a,j,k,d,1,16,4);u=g;return}function ELb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;m=u;u=u+144|0;n=m+88|0;o=m+32|0;p=m+16|0;q=m;r=f[k>>2]|0;s=k+4|0;t=f[s>>2]|0;if((r|0)!=(t|0)?(t-r|0)!=((f[g+4>>2]|0)-(f[g>>2]|0)>>4|0):0){r=$Xc(64)|0;f[n>>2]=r;f[n+8>>2]=-2147483584;f[n+4>>2]=50;v=r;w=461116;x=v+50|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[r+50>>0]=0;vM(-201,n,461167,461012,198)}f[n>>2]=1124007936;r=n+4|0;t=n+8|0;y=n+40|0;v=r;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[y>>2]=t;t=n+48|0;z=n+44|0;f[z>>2]=t;f[t>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;A=o+4|0;B=o+8|0;C=o+40|0;v=A;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[C>>2]=B;B=o+48|0;D=o+44|0;f[D>>2]=B;f[B>>2]=0;f[o+52>>2]=0;FLb(a,c,d,e,h,n,o,j,l);j=g+4|0;d=f[j>>2]|0;a=f[g>>2]|0;a:do if((d|0)!=(a|0)){E=c+4|0;F=e+4|0;G=p+8|0;H=p+4|0;I=q+8|0;J=q+4|0;K=0;L=d;M=a;while(1){N=M;O=f[k>>2]|0;if((O|0)!=(f[s>>2]|0)?(b[O+K>>0]|0)==0:0){P=M;Q=L}else{O=f[N+(K<<4)>>2]|0;R=f[N+(K<<4)+4>>2]|0;if((O|0)<=-1){S=27;break}N=f[c>>2]|0;if((O|0)>=(((f[E>>2]|0)-N|0)/28|0|0)){S=27;break}if((R|0)<=-1){S=30;break}T=f[e>>2]|0;if((R|0)>=(((f[F>>2]|0)-T|0)/28|0|0)){S=30;break}U=G;f[U>>2]=0;f[U+4>>2]=0;f[p>>2]=50397184;f[H>>2]=n;U=I;f[U>>2]=0;f[U+4>>2]=0;f[q>>2]=50397184;f[J>>2]=o;GLb(h,p,q,N+(O*28|0)|0,T+(R*28|0)|0,i,l);P=f[g>>2]|0;Q=f[j>>2]|0}K=K+1|0;if(K>>>0>=Q-P>>4>>>0)break a;else{L=Q;M=P}}if((S|0)==27){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;M=$Xc(64)|0;f[p>>2]=M;f[p+8>>2]=-2147483584;f[p+4>>2]=51;v=M;w=461179;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[M+51>>0]=0;vM(-215,p,461167,461012,211)}else if((S|0)==30){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;L=$Xc(64)|0;f[p>>2]=L;f[p+8>>2]=-2147483584;f[p+4>>2]=51;v=L;w=461231;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[L+51>>0]=0;vM(-215,p,461167,461012,212)}}while(0);p=o+36|0;w=f[p>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)V$(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[A>>2]|0)>0){p=f[C>>2]|0;C=0;do{f[p+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[D>>2]|0;if((A|0)!=(B|0))wL(A);A=n+36|0;B=f[A>>2]|0;if(B|0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0)V$(n);f[A>>2]=0;A=n+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[r>>2]|0)>0){A=f[y>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[r>>2]|0))}r=f[z>>2]|0;if((r|0)==(t|0)){u=m;return}wL(r);u=m;return}function FLb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;l=u;u=u+224|0;m=l+168|0;n=l+160|0;o=l+152|0;p=l;q=l+88|0;r=l+144|0;s=l+72|0;t=l+56|0;f[m>>2]=1124007936;v=m+4|0;w=m+8|0;x=m+40|0;y=v;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=w;A=m+48|0;B=m+44|0;f[B>>2]=A;f[A>>2]=0;f[m+52>>2]=0;cS(n,a,-1);cS(o,d,-1);C=(f[o>>2]|0)+(f[n>>2]|0)|0;D=n+4|0;E=o+4|0;F=f[((f[D>>2]|0)<(f[E>>2]|0)?o:n)+4>>2]|0;do if(!(k&1)){f[r>>2]=C;f[r+4>>2]=F;wS(g,r,(qS(a,-1)|0)&7|16,-1,0,0);do if((eS(g)|0)==65536){G=f[g+4>>2]|0;f[p>>2]=f[G>>2];H=p+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=p+8|0;f[J>>2]=f[G+8>>2];f[p+12>>2]=f[G+12>>2];f[p+16>>2]=f[G+16>>2];f[p+20>>2]=f[G+20>>2];f[p+24>>2]=f[G+24>>2];f[p+28>>2]=f[G+28>>2];f[p+32>>2]=f[G+32>>2];K=f[G+36>>2]|0;f[p+36>>2]=K;f[p+40>>2]=J;J=p+48|0;L=p+44|0;f[L>>2]=J;f[J>>2]=0;f[p+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;U$(p,G);break}}else bS(p,g,-1);while(0);G=m+36|0;H=f[G>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)V$(m);f[G>>2]=0;H=m+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[v>>2]|0)>0){I=f[x>>2]|0;J=0;do{f[I+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[v>>2]|0))}f[m>>2]=f[p>>2];J=p+4|0;I=f[J>>2]|0;f[v>>2]=I;L=p+8|0;f[w>>2]=f[L>>2];f[m+12>>2]=f[p+12>>2];K=p+16|0;f[H>>2]=f[K>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];M=p+36|0;f[G>>2]=f[M>>2];N=m+44|0;O=f[N>>2]|0;if((O|0)==(A|0))P=I;else{wL(O);f[N>>2]=A;f[x>>2]=w;P=f[J>>2]|0}O=p+44|0;if((P|0)<3){I=f[O>>2]|0;f[A>>2]=f[I>>2];f[m+52>>2]=f[I+4>>2];Q=I}else{f[N>>2]=f[O>>2];N=p+40|0;f[m+40>>2]=f[N>>2];I=p+48|0;f[O>>2]=I;f[N>>2]=L;Q=I}f[p>>2]=1124007936;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;f[J+16>>2]=0;f[J+20>>2]=0;f[J+24>>2]=0;f[J+28>>2]=0;f[M>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((Q|0)!=(p+48|0))wL(Q);f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;lR(m,p)|0;K=f[n>>2]|0;M=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=K;f[q+12>>2]=M;Z$(p,m,q);M=h+36|0;K=f[M>>2]|0;if((p|0)==(h|0)){J=p+36|0;if((K|0)!=0?(I=K+12|0,L=f[I>>2]|0,f[I>>2]=L+-1,(L|0)==1):0){V$(p);R=J}else R=J}else{if(K|0?(J=K+12|0,K=f[J>>2]|0,f[J>>2]=K+-1,(K|0)==1):0)V$(h);f[M>>2]=0;K=h+16|0;J=h+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[J>>2]|0)>0){L=f[h+40>>2]|0;I=0;do{f[L+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[J>>2]|0))}f[h>>2]=f[p>>2];I=p+4|0;L=f[I>>2]|0;f[J>>2]=L;G=p+8|0;H=h+8|0;f[H>>2]=f[G>>2];f[h+12>>2]=f[p+12>>2];f[K>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];N=p+36|0;f[M>>2]=f[N>>2];O=h+44|0;S=f[O>>2]|0;T=h+48|0;if((S|0)==(T|0))U=L;else{wL(S);f[O>>2]=T;f[h+40>>2]=H;U=f[I>>2]|0}H=p+44|0;if((U|0)<3){S=f[H>>2]|0;f[T>>2]=f[S>>2];f[h+52>>2]=f[S+4>>2]}else{f[O>>2]=f[H>>2];O=p+40|0;f[h+40>>2]=f[O>>2];f[H>>2]=p+48;f[O>>2]=G}f[p>>2]=1124007936;y=I;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));R=N}f[R>>2]=0;M=p+16|0;K=p+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[K>>2]|0)>0){M=f[p+40>>2]|0;J=0;do{f[M+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[K>>2]|0))}K=f[p+44>>2]|0;if((K|0)!=(p+48|0))wL(K);K=f[o>>2]|0;J=f[E>>2]|0;f[q>>2]=f[n>>2];f[q+4>>2]=0;f[q+8>>2]=K;f[q+12>>2]=J;Z$(p,m,q);J=i+36|0;K=f[J>>2]|0;if((p|0)==(i|0)){M=p+36|0;if((K|0)!=0?(N=K+12|0,I=f[N>>2]|0,f[N>>2]=I+-1,(I|0)==1):0){V$(p);V=M}else V=M}else{if(K|0?(M=K+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0)V$(i);f[J>>2]=0;K=i+16|0;M=i+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[M>>2]|0)>0){I=f[i+40>>2]|0;N=0;do{f[I+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[M>>2]|0))}f[i>>2]=f[p>>2];N=p+4|0;I=f[N>>2]|0;f[M>>2]=I;G=p+8|0;O=i+8|0;f[O>>2]=f[G>>2];f[i+12>>2]=f[p+12>>2];f[K>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];H=p+36|0;f[J>>2]=f[H>>2];S=i+44|0;T=f[S>>2]|0;L=i+48|0;if((T|0)==(L|0))W=I;else{wL(T);f[S>>2]=L;f[i+40>>2]=O;W=f[N>>2]|0}O=p+44|0;if((W|0)<3){T=f[O>>2]|0;f[L>>2]=f[T>>2];f[i+52>>2]=f[T+4>>2]}else{f[S>>2]=f[O>>2];S=p+40|0;f[i+40>>2]=f[S>>2];f[O>>2]=p+48;f[S>>2]=G}f[p>>2]=1124007936;y=N;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));V=H}f[V>>2]=0;J=p+16|0;K=p+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[K>>2]|0)>0){J=f[p+40>>2]|0;M=0;do{f[J+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[K>>2]|0))}K=f[p+44>>2]|0;if((K|0)!=(p+48|0))wL(K);if(!(dS(a,-1)|0)){K=p+8|0;f[K>>2]=0;f[K+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;Spa(a,p,8,0)}else{K=p+8|0;f[K>>2]=0;f[K+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;uS(a,p)}if(!(dS(d,-1)|0)){K=p+8|0;f[K>>2]=0;f[K+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;Spa(d,p,8,0);break}else{K=p+8|0;f[K>>2]=0;f[K+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;uS(d,p);break}}else{do if((eS(g)|0)==65536){K=f[g+4>>2]|0;f[p>>2]=f[K>>2];M=p+4|0;J=K+4|0;f[M>>2]=f[J>>2];H=p+8|0;f[H>>2]=f[K+8>>2];f[p+12>>2]=f[K+12>>2];f[p+16>>2]=f[K+16>>2];f[p+20>>2]=f[K+20>>2];f[p+24>>2]=f[K+24>>2];f[p+28>>2]=f[K+28>>2];f[p+32>>2]=f[K+32>>2];N=f[K+36>>2]|0;f[p+36>>2]=N;f[p+40>>2]=H;H=p+48|0;G=p+44|0;f[G>>2]=H;f[H>>2]=0;f[p+52>>2]=0;if(N|0){H=N+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[J>>2]|0)<3){J=f[K+44>>2]|0;H=f[G>>2]|0;f[H>>2]=f[J>>2];f[H+4>>2]=f[J+4>>2];break}else{f[M>>2]=0;U$(p,K);break}}else bS(p,g,-1);while(0);K=m+36|0;M=f[K>>2]|0;if(M|0?(J=M+12|0,M=f[J>>2]|0,f[J>>2]=M+-1,(M|0)==1):0)V$(m);f[K>>2]=0;M=m+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[v>>2]|0)>0){J=f[x>>2]|0;H=0;do{f[J+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[v>>2]|0))}f[m>>2]=f[p>>2];H=p+4|0;J=f[H>>2]|0;f[v>>2]=J;G=p+8|0;f[w>>2]=f[G>>2];N=m+12|0;f[N>>2]=f[p+12>>2];S=p+16|0;f[M>>2]=f[S>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];O=p+36|0;f[K>>2]=f[O>>2];T=m+44|0;L=f[T>>2]|0;if((L|0)==(A|0))X=J;else{wL(L);f[T>>2]=A;f[x>>2]=w;X=f[H>>2]|0}L=p+44|0;if((X|0)<3){J=f[L>>2]|0;f[A>>2]=f[J>>2];f[m+52>>2]=f[J+4>>2];Y=J}else{f[T>>2]=f[L>>2];T=p+40|0;f[m+40>>2]=f[T>>2];J=p+48|0;f[L>>2]=J;f[T>>2]=G;Y=J}f[p>>2]=1124007936;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;f[H+16>>2]=0;f[H+20>>2]=0;f[H+24>>2]=0;f[H+28>>2]=0;f[O>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((Y|0)!=(p+48|0))wL(Y);if((C|0)>(f[N>>2]|0)?1:(F|0)>(f[w>>2]|0)){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;N=$Xc(64)|0;f[p>>2]=N;f[p+8>>2]=-2147483584;f[p+4>>2]=61;y=N;S=461283;z=y+61|0;do{b[y>>0]=b[S>>0]|0;y=y+1|0;S=S+1|0}while((y|0)<(z|0));b[N+61>>0]=0;vM(-201,p,461345,461012,137)}S=f[n>>2]|0;K=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=S;f[q+12>>2]=K;Z$(p,m,q);K=h+36|0;S=f[K>>2]|0;if((p|0)==(h|0)){M=p+36|0;if((S|0)!=0?(O=S+12|0,H=f[O>>2]|0,f[O>>2]=H+-1,(H|0)==1):0){V$(p);Z=M}else Z=M}else{if(S|0?(M=S+12|0,S=f[M>>2]|0,f[M>>2]=S+-1,(S|0)==1):0)V$(h);f[K>>2]=0;S=h+16|0;M=h+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[M>>2]|0)>0){H=f[h+40>>2]|0;O=0;do{f[H+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}f[h>>2]=f[p>>2];O=p+4|0;H=f[O>>2]|0;f[M>>2]=H;N=p+8|0;J=h+8|0;f[J>>2]=f[N>>2];f[h+12>>2]=f[p+12>>2];f[S>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];G=p+36|0;f[K>>2]=f[G>>2];T=h+44|0;L=f[T>>2]|0;I=h+48|0;if((L|0)==(I|0)){_=H;$=L}else{wL(L);f[T>>2]=I;f[h+40>>2]=J;_=f[O>>2]|0;$=I}I=p+44|0;if((_|0)<3){J=f[I>>2]|0;f[$>>2]=f[J>>2];f[$+4>>2]=f[J+4>>2]}else{f[T>>2]=f[I>>2];T=p+40|0;f[h+40>>2]=f[T>>2];f[I>>2]=p+48;f[T>>2]=N}f[p>>2]=1124007936;y=O;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));Z=G}f[Z>>2]=0;K=p+16|0;S=p+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[S>>2]|0)>0){K=f[p+40>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[S>>2]|0))}S=f[p+44>>2]|0;if((S|0)!=(p+48|0))wL(S);S=f[o>>2]|0;M=f[E>>2]|0;f[q>>2]=f[n>>2];f[q+4>>2]=0;f[q+8>>2]=S;f[q+12>>2]=M;Z$(p,m,q);M=i+36|0;S=f[M>>2]|0;if((p|0)==(i|0)){K=p+36|0;if((S|0)!=0?(G=S+12|0,O=f[G>>2]|0,f[G>>2]=O+-1,(O|0)==1):0){V$(p);aa=K}else aa=K}else{if(S|0?(K=S+12|0,S=f[K>>2]|0,f[K>>2]=S+-1,(S|0)==1):0)V$(i);f[M>>2]=0;S=i+16|0;K=i+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[K>>2]|0)>0){O=f[i+40>>2]|0;G=0;do{f[O+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[K>>2]|0))}f[i>>2]=f[p>>2];G=p+4|0;O=f[G>>2]|0;f[K>>2]=O;N=p+8|0;T=i+8|0;f[T>>2]=f[N>>2];f[i+12>>2]=f[p+12>>2];f[S>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];I=p+36|0;f[M>>2]=f[I>>2];J=i+44|0;L=f[J>>2]|0;H=i+48|0;if((L|0)==(H|0)){ba=O;ca=L}else{wL(L);f[J>>2]=H;f[i+40>>2]=T;ba=f[G>>2]|0;ca=H}H=p+44|0;if((ba|0)<3){T=f[H>>2]|0;f[ca>>2]=f[T>>2];f[ca+4>>2]=f[T+4>>2]}else{f[J>>2]=f[H>>2];J=p+40|0;f[i+40>>2]=f[J>>2];f[H>>2]=p+48;f[J>>2]=N}f[p>>2]=1124007936;y=G;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));aa=I}f[aa>>2]=0;M=p+16|0;S=p+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[S>>2]|0)>0){M=f[p+40>>2]|0;K=0;do{f[M+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[S>>2]|0))}S=f[p+44>>2]|0;if((S|0)!=(p+48|0))wL(S)}while(0);if(!(k&2)){aa=f[n>>2]|0;y=f[D>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=aa;f[q+12>>2]=y;Z$(p,m,q);f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=p;y=s+8|0;f[y>>2]=0;f[y+4>>2]=0;f[s>>2]=50397184;f[s+4>>2]=p;y=k|1;CLb(q,c,s,j,y);c=f[o>>2]|0;o=f[E>>2]|0;f[s>>2]=f[n>>2];f[s+4>>2]=0;f[s+8>>2]=c;f[s+12>>2]=o;Z$(q,m,s);f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=q;o=t+8|0;f[o>>2]=0;f[o+4>>2]=0;f[t>>2]=50397184;f[t+4>>2]=q;CLb(s,e,t,j,y);y=q+36|0;j=f[y>>2]|0;if(j|0?(t=j+12|0,j=f[t>>2]|0,f[t>>2]=j+-1,(j|0)==1):0)V$(q);f[y>>2]=0;y=q+16|0;j=q+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){y=f[q+40>>2]|0;t=0;do{f[y+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[q+44>>2]|0;if((j|0)!=(q+48|0))wL(j);j=p+36|0;q=f[j>>2]|0;if(q|0?(t=q+12|0,q=f[t>>2]|0,f[t>>2]=q+-1,(q|0)==1):0)V$(p);f[j>>2]=0;j=p+16|0;q=p+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){j=f[p+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[q>>2]|0))}q=f[p+44>>2]|0;if((q|0)!=(p+48|0))wL(q)}q=m+36|0;p=f[q>>2]|0;if(p|0?(t=p+12|0,p=f[t>>2]|0,f[t>>2]=p+-1,(p|0)==1):0)V$(m);f[q>>2]=0;q=m+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[v>>2]|0)>0){q=f[x>>2]|0;x=0;do{f[q+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)==(A|0)){u=l;return}wL(v);u=l;return}function GLb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0;i=u;u=u+64|0;j=i;k=i+56|0;l=i+48|0;m=i+40|0;o=i+32|0;q=OR()|0;r=+p[g>>3];s=+p[g+8>>3];if(r==-1.0&s==-1.0)if(+p[g+16>>3]==-1.0){t=+p[g+24>>3];if(t==-1.0){v=q;w=f[v+4>>2]|0;x=x1c(f[v>>2]|0,0,-130063606,0)|0;v=d1c(x|0,J|0,w|0,0)|0;w=J;x=x1c(v|0,0,-130063606,0)|0;y=d1c(x|0,J|0,w|0,0)|0;w=J;x=x1c(y|0,0,-130063606,0)|0;z=d1c(x|0,J|0,w|0,0)|0;w=q;f[w>>2]=z;f[w+4>>2]=J;A=0.0;B=+((z&255)>>>0);C=+((y&255)>>>0);D=+((v&255)>>>0);E=j}else{A=t;B=-1.0;C=-1.0;D=r;E=j}}else{F=-1.0;G=3}else{F=s;G=3}if((G|0)==3){A=+p[g+24>>3];B=+p[g+16>>3];C=F;D=r;E=j}p[j>>3]=D;p[j+8>>3]=C;p[j+16>>3]=B;p[j+24>>3]=A;DLb(b,d,j,h);DLb(c,e,j,h);A=+n[d>>2];B=+n[d+4>>2];C=+n[e>>2];D=+n[e+4>>2];cS(k,b,-1);r=C+ +(f[k>>2]|0);cS(l,a,-1);C=+((f[l>>2]|0)+-1|0);l=ALc(A*16.0)|0;k=ALc(B*16.0)|0;f[m>>2]=l;f[m+4>>2]=k;k=ALc((C<r?C:r)*16.0)|0;l=ALc(D*16.0)|0;f[o>>2]=k;f[o+4>>2]=l;kra(a,m,o,j,1,16,4);u=i;return}function HLb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,461373)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function ILb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=$Xc(36)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=111252;k=j+12|0;yP(k);f[k>>2]=111280;b[j+16>>0]=c&1;b[j+17>>0]=d&1;n[j+20>>2]=e;f[j+24>>2]=g;f[j+28>>2]=h;f[j+32>>2]=i;f[a>>2]=k;f[a+4>>2]=j;return}function JLb(a){a=a|0;WRb(a);cYc(a);return}function KLb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0;d=u;u=u+16|0;e=d;zP(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=8;i=e;f[i>>2]=1702131813;f[i+4>>2]=1684366446;b[e+8>>0]=0;i=s5(c,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=h[a+4>>0]|0;if(_i[f[(f[i>>2]|0)+12>>2]&2047](i)|0){j=i+4|0;if((f[j>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(i,i+8|0,g);if(f[j>>2]&4|0)f[j>>2]=6}f[e+8>>2]=0;j=e+11|0;b[j>>0]=7;b[e>>0]=b[461585]|0;b[e+1>>0]=b[461586]|0;b[e+2>>0]=b[461587]|0;b[e+3>>0]=b[461588]|0;b[e+4>>0]=b[461589]|0;b[e+5>>0]=b[461590]|0;b[e+6>>0]=b[461591]|0;b[e+7>>0]=0;g=s5(c,e)|0;if((b[j>>0]|0)<0)cYc(f[e>>2]|0);j=h[a+5>>0]|0;if(_i[f[(f[g>>2]|0)+12>>2]&2047](g)|0){i=g+4|0;if((f[i>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(g,g+8|0,j);if(f[i>>2]&4|0)f[i>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=9;l=e;m=470916;o=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[e+9>>0]=0;j=s5(c,e)|0;if((b[i>>0]|0)<0)cYc(f[e>>2]|0);i=a+8|0;if(_i[f[(f[j>>2]|0)+12>>2]&2047](j)|0){g=j+4|0;if((f[g>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(j,j+8|0,+n[i>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e+8>>2]=0;g=e+11|0;b[g>>0]=7;b[e>>0]=b[463009]|0;b[e+1>>0]=b[463010]|0;b[e+2>>0]=b[463011]|0;b[e+3>>0]=b[463012]|0;b[e+4>>0]=b[463013]|0;b[e+5>>0]=b[463014]|0;b[e+6>>0]=b[463015]|0;b[e+7>>0]=0;i=s5(c,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=a+12|0;if(_i[f[(f[i>>2]|0)+12>>2]&2047](i)|0){j=i+4|0;if((f[j>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(i,i+8|0,f[g>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=9;l=e;m=463017;o=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[e+9>>0]=0;g=s5(c,e)|0;if((b[j>>0]|0)<0)cYc(f[e>>2]|0);j=a+16|0;if(_i[f[(f[g>>2]|0)+12>>2]&2047](g)|0){i=g+4|0;if((f[i>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(g,g+8|0,f[j>>2]|0);if(f[i>>2]&4|0)f[i>>2]=6}i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=11;l=i;m=463027;o=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[i+11>>0]=0;i=s5(c,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);c=a+20|0;if(!(_i[f[(f[i>>2]|0)+12>>2]&2047](i)|0)){u=d;return}a=i+4|0;if((f[a>>2]|0)==6){j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=j;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[j+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(i,i+8|0,f[c>>2]|0);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function LLb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0;d=u;u=u+80|0;e=d+60|0;g=d+48|0;h=d+36|0;i=d+24|0;j=d+12|0;k=d;i5(e,c,461576);l=(H5(e)|0)!=0&1;b[a+4>>0]=l;i5(g,c,461585);l=(H5(g)|0)!=0&1;b[a+5>>0]=l;i5(h,c,470916);m=+I5(h);n[a+8>>2]=m;i5(i,c,463009);h=H5(i)|0;f[a+12>>2]=h;i5(j,c,463017);h=H5(j)|0;f[a+16>>2]=h;i5(k,c,463027);c=H5(k)|0;f[a+20>>2]=c;u=d;return}function MLb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+336|0;j=i+280|0;k=i+224|0;l=i+176|0;m=i+72|0;o=i+16|0;p=i;do if((eS(c)|0)==65536){q=f[c+4>>2]|0;f[j>>2]=f[q>>2];r=j+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];x=j;break}else{f[r>>2]=0;U$(j,q);x=j;break}}else{bS(j,c,-1);x=j}while(0);q=f[x>>2]|0;if(!(q&4088))y=q;else{q=k+8|0;f[q>>2]=0;f[q+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;Spa(c,k,6,0);y=f[x>>2]|0}f[k>>2]=1124007936;c=k+4|0;q=k+8|0;r=k+40|0;s=c;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;w=k+48|0;v=k+44|0;f[v>>2]=w;f[w>>2]=0;f[k+52>>2]=0;switch(y&7){case 5:{y=j+36|0;z=f[y>>2]|0;if(z){A=z+12|0;f[A>>2]=(f[A>>2]|0)+1;A=k+36|0;z=f[A>>2]|0;if((z|0)!=0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0){V$(k);C=A}else C=A}else C=k+36|0;f[C>>2]=0;A=k+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[c>>2]|0)>0){z=f[r>>2]|0;B=0;do{f[z+(B<<2)>>2]=0;B=B+1|0;D=f[c>>2]|0}while((B|0)<(D|0));f[k>>2]=f[x>>2];if((D|0)<3)E=21;else E=23}else{f[k>>2]=f[x>>2];E=21}if((E|0)==21){x=f[j+4>>2]|0;if((x|0)<3){f[c>>2]=x;f[q>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];x=f[j+44>>2]|0;D=f[v>>2]|0;f[D>>2]=f[x>>2];f[D+4>>2]=f[x+4>>2]}else E=23}if((E|0)==23)U$(k,j);f[A>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];f[C>>2]=f[y>>2];break}case 0:{y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;dY(j,l,5,.00392156862745098,0.0);break}case 2:{y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;dY(j,l,5,1.5259021896696422e-05,0.0);break}default:{}}y=k+16|0;if(!(f[y>>2]|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;F=$Xc(32)|0;f[l>>2]=F;G=l+8|0;f[G>>2]=-2147483616;H=l+4|0;f[H>>2]=17;s=F;I=461390;t=s+17|0;do{b[s>>0]=b[I>>0]|0;s=s+1|0;I=I+1|0}while((s|0)<(t|0));J=F+17|0;b[J>>0]=0;vM(-215,l,467518,461408,127)}C=f[c>>2]|0;if((C|0)<3)K=Y(f[k+12>>2]|0,f[q>>2]|0)|0;else{q=f[r>>2]|0;A=0;E=1;while(1){x=Y(f[q+(A<<2)>>2]|0,E)|0;A=A+1|0;if((A|0)==(C|0)){K=x;break}else E=x}}if((C|0)==0|(K|0)==0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;F=$Xc(32)|0;f[l>>2]=F;G=l+8|0;f[G>>2]=-2147483616;H=l+4|0;f[H>>2]=17;s=F;I=461390;t=s+17|0;do{b[s>>0]=b[I>>0]|0;s=s+1|0;I=I+1|0}while((s|0)<(t|0));J=F+17|0;b[J>>0]=0;vM(-215,l,467518,461408,127)}n[l+4>>2]=1.600000023841858;n[l+24>>2]=1.0;n[l+32>>2]=.009999999776482582;n[l+36>>2]=.699999988079071;f[l+40>>2]=300;f[l+16>>2]=f[j+12>>2];f[l+20>>2]=f[j+8>>2];J=a+4|0;b[l+45>>0]=b[J>>0]|0;b[l+44>>0]=b[a+5>>0]|0;f[l+28>>2]=f[a+8>>2];f[l+8>>2]=f[a+12>>2];f[l+12>>2]=f[a+16>>2];f[l>>2]=f[a+20>>2];cOb(m,l);hOb(m,k)|0;if(!h)lOb(m,e);if(!(sS(d)|0)){do if((eS(d)|0)==65536){h=f[d+4>>2]|0;f[o>>2]=f[h>>2];l=o+4|0;a=h+4|0;f[l>>2]=f[a>>2];F=o+8|0;f[F>>2]=f[h+8>>2];f[o+12>>2]=f[h+12>>2];f[o+16>>2]=f[h+16>>2];f[o+20>>2]=f[h+20>>2];f[o+24>>2]=f[h+24>>2];f[o+28>>2]=f[h+28>>2];f[o+32>>2]=f[h+32>>2];H=f[h+36>>2]|0;f[o+36>>2]=H;f[o+40>>2]=F;F=o+48|0;G=o+44|0;f[G>>2]=F;f[F>>2]=0;f[o+52>>2]=0;if(H|0){F=H+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[a>>2]|0)<3){a=f[h+44>>2]|0;F=f[G>>2]|0;f[F>>2]=f[a>>2];f[F+4>>2]=f[a+4>>2];break}else{f[l>>2]=0;U$(o,h);break}}else bS(o,d,-1);while(0);mSb(e,o);d=o+36|0;h=f[d>>2]|0;if(h|0?(l=h+12|0,h=f[l>>2]|0,f[l>>2]=h+-1,(h|0)==1):0)V$(o);f[d>>2]=0;d=o+16|0;h=o+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[h>>2]|0)>0){d=f[o+40>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[o+44>>2]|0;if((h|0)!=(o+48|0))wL(h)}if(aT(g)|0){f[o>>2]=1124007936;h=o+4|0;l=o+8|0;d=o+40|0;s=h;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[d>>2]=l;a=o+48|0;F=o+44|0;f[F>>2]=a;f[a>>2]=0;f[o+52>>2]=0;sOb(m,e,o);jR(o,g);if(f[l>>2]|0){if((f[o+12>>2]|0)!=((b[J>>0]|0?128:64)|0)){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;J=$Xc(48)|0;f[p>>2]=J;f[p+8>>2]=-2147483600;f[p+4>>2]=45;s=J;I=461480;t=s+45|0;do{b[s>>0]=b[I>>0]|0;s=s+1|0;I=I+1|0}while((s|0)<(t|0));b[J+45>>0]=0;vM(-215,p,467518,461408,158)}if((f[o>>2]&4095|0)!=5){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;J=$Xc(64)|0;f[p>>2]=J;f[p+8>>2]=-2147483584;f[p+4>>2]=49;s=J;I=461526;t=s+49|0;do{b[s>>0]=b[I>>0]|0;s=s+1|0;I=I+1|0}while((s|0)<(t|0));b[J+49>>0]=0;vM(-215,p,467518,461408,159)}}p=o+36|0;J=f[p>>2]|0;if(J|0?(I=J+12|0,J=f[I>>2]|0,f[I>>2]=J+-1,(J|0)==1):0)V$(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[h>>2]|0)>0){p=f[d>>2]|0;d=0;do{f[p+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[h>>2]|0))}h=f[F>>2]|0;if((h|0)!=(a|0))wL(h)}aMb(m);m=k+36|0;h=f[m>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)V$(k);f[m>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[r>>2]|0;r=0;do{f[y+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[c>>2]|0))}c=f[v>>2]|0;if((c|0)!=(w|0))wL(c);c=j+36|0;w=f[c>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)V$(j);f[c>>2]=0;c=j+16|0;w=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[w>>2]|0)>0){c=f[j+40>>2]|0;v=0;do{f[c+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)==(j+48|0)){u=i;return}wL(w);u=i;return}function NLb(a){a=a|0;return (b[a+4>>0]|0?128:64)|0}function OLb(a){a=a|0;return 5}function PLb(a){a=a|0;return 4}function QLb(a,c){a=a|0;c=c|0;b[a+4>>0]=c&1;return}function RLb(a){a=a|0;return (b[a+4>>0]|0)!=0|0}function SLb(a,c){a=a|0;c=c|0;b[a+5>>0]=c&1;return}function TLb(a){a=a|0;return (b[a+5>>0]|0)!=0|0}function ULb(a,b){a=a|0;b=+b;n[a+8>>2]=b;return}function VLb(a){a=a|0;return +(+n[a+8>>2])}function WLb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function XLb(a){a=a|0;return f[a+12>>2]|0}function YLb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function ZLb(a){a=a|0;return f[a+16>>2]|0}function _Lb(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function $Lb(a){a=a|0;return f[a+20>>2]|0}function aMb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+92>>2]|0;if(b|0){c=a+96|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=a+80|0;d=f[b>>2]|0;if(d|0){c=a+84|0;e=f[c>>2]|0;if((e|0)==(d|0))g=d;else{h=e;while(1){e=h+-12|0;f[c>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-4-i|0)>>>2)<<2);cYc(i);j=f[c>>2]|0}if((j|0)==(d|0))break;else h=j}g=f[b>>2]|0}cYc(g)}g=a+60|0;b=f[g>>2]|0;if(b|0){j=a+64|0;h=f[j>>2]|0;if((h|0)==(b|0))l=b;else{d=h;while(1){h=d+-12|0;f[j>>2]=h;c=f[h>>2]|0;if(!c)m=h;else{h=d+-8|0;i=f[h>>2]|0;if((i|0)!=(c|0))f[h>>2]=i+(~(((i+-28-c|0)>>>0)/28|0)*28|0);cYc(c);m=f[j>>2]|0}if((m|0)==(b|0))break;else d=m}l=f[g>>2]|0}cYc(l)}l=a+48|0;g=f[l>>2]|0;if(!g)return;m=a+52|0;a=f[m>>2]|0;if((a|0)==(g|0))n=g;else{d=a;do{a=d+-468|0;f[m>>2]=a;bMb(a);d=f[m>>2]|0}while((d|0)!=(g|0));n=f[l>>2]|0}cYc(n);return}function bMb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+392|0;c=a+428|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+408|0;b=a+396|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+432>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+436>>2]|0;if((b|0)!=(a+440|0))wL(b);b=a+336|0;d=a+372|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+352|0;b=a+340|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+376>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+380>>2]|0;if((b|0)!=(a+384|0))wL(b);b=a+280|0;c=a+316|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+296|0;b=a+284|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+320>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+324>>2]|0;if((b|0)!=(a+328|0))wL(b);b=a+224|0;d=a+260|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+240|0;b=a+228|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+264>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+268>>2]|0;if((b|0)!=(a+272|0))wL(b);b=a+168|0;c=a+204|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+184|0;b=a+172|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+208>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+212>>2]|0;if((b|0)!=(a+216|0))wL(b);b=a+112|0;d=a+148|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+128|0;b=a+116|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+152>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+156>>2]|0;if((b|0)!=(a+160|0))wL(b);b=a+56|0;c=a+92|0;d=f[c>>2]|0;do if(d|0){e=d+12|0;g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)!=1)break;V$(b)}while(0);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;do if(d|0){c=d+12|0;g=f[c>>2]|0;f[c>>2]=g+-1;if((g|0)!=1)break;V$(a)}while(0);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;g=0;do{f[b+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function cMb(a){a=a|0;f[a>>2]=111252;WRb(a+12|0);NXc(a);return}function dMb(a){a=a|0;f[a>>2]=111252;WRb(a+12|0);NXc(a);cYc(a);return}function eMb(a){a=a|0;WRb(a+12|0);return}function fMb(a){a=a|0;cYc(a);return}function gMb(a){a=a|0;var b=0;f[a>>2]=111400;b=f[a+12>>2]|0;if(b|0)dYc(b);b=f[a+40>>2]|0;if(b|0)dYc(b);b=f[a+44>>2]|0;if(b|0)dYc(b);b=f[a+20>>2]|0;if(b|0)dYc(b);b=f[a+24>>2]|0;if(!b){WRb(a);return}dYc(b);WRb(a);return}function hMb(a){a=a|0;gMb(a);cYc(a);return}function iMb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,462094)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function jMb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nMb(a,b,c,d,e,aT(e)|0,1,f);return}function kMb(a){a=a|0;return f[a+28>>2]|0}function lMb(a){a=a|0;return 0}function mMb(a){a=a|0;return 6}function nMb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0;k=u;u=u+304|0;l=k+248|0;m=k+192|0;o=k+176|0;q=k+120|0;r=k+64|0;s=k+8|0;t=k;do if((eS(c)|0)==65536){v=f[c+4>>2]|0;f[l>>2]=f[v>>2];w=l+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[v+8>>2];f[l+12>>2]=f[v+12>>2];f[l+16>>2]=f[v+16>>2];f[l+20>>2]=f[v+20>>2];f[l+24>>2]=f[v+24>>2];f[l+28>>2]=f[v+28>>2];f[l+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;A=l+44|0;f[A>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;U$(l,v);break}}else bS(l,c,-1);while(0);do if((eS(d)|0)==65536){v=f[d+4>>2]|0;f[m>>2]=f[v>>2];w=m+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[v+8>>2];f[m+12>>2]=f[v+12>>2];f[m+16>>2]=f[v+16>>2];f[m+20>>2]=f[v+20>>2];f[m+24>>2]=f[v+24>>2];f[m+28>>2]=f[v+28>>2];f[m+32>>2]=f[v+32>>2];A=f[v+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=y;y=m+48|0;z=m+44|0;f[z>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(A|0){y=A+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[z>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;U$(m,v);break}}else bS(m,d,-1);while(0);if(f[l>>2]&4095|0){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;v=q+8|0;f[v>>2]=0;f[v+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;Spa(o,q,6,0)}if(j)B=i;else{oMb(a,c,d,e);B=1}d=e+4|0;c=(f[d>>2]|0)-(f[e>>2]|0)|0;i=(c|0)/28|0;f[o>>2]=0;j=o+4|0;f[j>>2]=0;f[o+8>>2]=0;if(c|0)CS(o,i);if((b[537336]|0)==0?X0c(537336)|0:0)n[223183]=4.906890869140625;if(!c)C=i;else{c=f[o>>2]|0;v=f[e>>2]|0;w=a+24|0;x=l+12|0;y=l+8|0;z=i;i=0;A=c;D=v;E=v;v=c;while(1){c=~~(64.0/+n[223183]*(+W(+(+n[E+(i*28|0)+8>>2]/7.200000286102295))/.6931471824645996)+.5);F=(c|0)>0?c:0;c=F>>>0<63?F:63;f[v+(i<<2)>>2]=c;F=f[(f[w>>2]|0)+(c<<2)>>2]|0;G=+(F|0);H=+n[E+(i*28|0)>>2];if((H<G?0:!(H>=+((f[x>>2]|0)-F|0)))?(H=+n[E+(i*28|0)+4>>2],!(H<G?1:H>=+((f[y>>2]|0)-F|0))):0){I=z;J=i;K=A;L=D;M=v;N=E}else{F=D+(i*28|0)|0;c=F+28|0;O=f[d>>2]|0;if((c|0)!=(O|0)){P=c;Q=F;do{f[Q>>2]=f[P>>2];f[Q+4>>2]=f[P+4>>2];R=Q+8|0;S=P+8|0;f[R>>2]=f[S>>2];f[R+4>>2]=f[S+4>>2];f[R+8>>2]=f[S+8>>2];f[R+12>>2]=f[S+12>>2];f[R+16>>2]=f[S+16>>2];P=P+28|0;Q=Q+28|0}while((P|0)!=(O|0));O=f[d>>2]|0;if((O|0)!=(Q|0)){T=Q;V=O;X=31}}else{T=F;V=c;X=31}if((X|0)==31){X=0;f[d>>2]=V+(~(((V+-28-T|0)>>>0)/28|0)*28|0)}O=A+(i<<2)|0;P=O+4|0;S=f[j>>2]|0;R=S-P|0;Z=R>>2;if(!Z)_=S;else{q1c(O|0,P|0,R|0)|0;_=f[j>>2]|0}R=O+(Z<<2)|0;if((_|0)!=(R|0))f[j>>2]=_+(~((_+-4-R|0)>>>2)<<2);R=(i|0)==0;Z=f[e>>2]|0;O=f[o>>2]|0;I=z+-1|0;J=i+-1|0;K=R?O:A;L=R?Z:D;M=O;N=Z}i=J+1|0;if(i>>>0>=I>>>0){C=I;break}else{z=I;A=K;D=L;E=N;v=M}}}f[q>>2]=1124007936;M=q+4|0;v=q+8|0;N=q+40|0;E=M;L=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(L|0));f[N>>2]=v;v=q+48|0;D=q+44|0;f[D>>2]=v;f[v>>2]=0;f[q+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=l;K=s+8|0;f[K>>2]=0;f[K+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=q;Pja(r,s,-1);K=a+16|0;A=f[K>>2]|0;I=bYc(A>>>0>1073741823?-1:A<<2)|0;f[r>>2]=1124007936;A=r+4|0;z=r+8|0;i=r+40|0;E=A;L=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(L|0));f[i>>2]=z;J=r+48|0;_=r+44|0;f[_>>2]=J;f[J>>2]=0;f[r+52>>2]=0;if(h){ZS(g,C,f[a+28>>2]|0,0,-1,0,0);do if((eS(g)|0)==65536){T=f[g+4>>2]|0;f[s>>2]=f[T>>2];V=s+4|0;d=T+4|0;f[V>>2]=f[d>>2];y=s+8|0;f[y>>2]=f[T+8>>2];f[s+12>>2]=f[T+12>>2];f[s+16>>2]=f[T+16>>2];f[s+20>>2]=f[T+20>>2];f[s+24>>2]=f[T+24>>2];f[s+28>>2]=f[T+28>>2];f[s+32>>2]=f[T+32>>2];x=f[T+36>>2]|0;f[s+36>>2]=x;f[s+40>>2]=y;y=s+48|0;w=s+44|0;f[w>>2]=y;f[y>>2]=0;f[s+52>>2]=0;if(x|0){y=x+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[d>>2]|0)<3){d=f[T+44>>2]|0;y=f[w>>2]|0;f[y>>2]=f[d>>2];f[y+4>>2]=f[d+4>>2];break}else{f[V>>2]=0;U$(s,T);break}}else bS(s,g,-1);while(0);g=r+36|0;T=f[g>>2]|0;if(T|0?(V=T+12|0,T=f[V>>2]|0,f[V>>2]=T+-1,(T|0)==1):0)V$(r);f[g>>2]=0;T=r+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[A>>2]|0)>0){V=f[i>>2]|0;d=0;do{f[V+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[A>>2]|0))}f[r>>2]=f[s>>2];d=s+4|0;V=f[d>>2]|0;f[A>>2]=V;y=s+8|0;f[z>>2]=f[y>>2];f[r+12>>2]=f[s+12>>2];w=s+16|0;f[T>>2]=f[w>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2];f[r+32>>2]=f[s+32>>2];x=s+36|0;f[g>>2]=f[x>>2];g=r+44|0;Z=f[g>>2]|0;if((Z|0)==(J|0))$=V;else{wL(Z);f[g>>2]=J;f[i>>2]=z;$=f[d>>2]|0}z=s+44|0;if(($|0)<3){$=f[z>>2]|0;f[J>>2]=f[$>>2];f[r+52>>2]=f[$+4>>2];aa=$}else{f[g>>2]=f[z>>2];g=s+40|0;f[r+40>>2]=f[g>>2];$=s+48|0;f[z>>2]=$;f[g>>2]=y;aa=$}f[s>>2]=1124007936;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((aa|0)!=(s+48|0))wL(aa);p[t>>3]=0.0;f[s>>2]=-1056833530;f[s+4>>2]=t;f[s+8>>2]=1;f[s+12>>2]=1;mR(r,s,fT()|0)|0;ba=T}else ba=r+16|0;a:do if(C|0){T=a+40|0;t=a+48|0;aa=a+28|0;w=a+44|0;x=a+52|0;d=h^1;$=f[ba>>2]|0;y=0;b:while(1){g=f[e>>2]|0;z=(f[o>>2]|0)+(y<<2)|0;Z=g+(y*28|0)|0;V=g+(y*28|0)+4|0;if(B){if(!(f[K>>2]|0))ca=0;else{O=0;do{R=pMb(a,l,q,+n[Z>>2],+n[V>>2],f[z>>2]|0,0,O)|0;f[I+(O<<2)>>2]=R;O=O+1|0;R=f[K>>2]|0}while(O>>>0<R>>>0);ca=R}O=f[w>>2]|0;R=f[x>>2]|0;P=O+(R<<4)|0;if((R|0)>0){R=O;O=0;S=0;while(1){da=f[R>>2]|0;if(da>>>0>=ca>>>0){X=70;break b}ea=f[R+4>>2]|0;if(ea>>>0>=ca>>>0){X=70;break b}fa=(f[I+(da<<2)>>2]|0)-(f[I+(ea<<2)>>2]|0)|0;ea=(Y(fa,f[R+8>>2]|0)|0)/1024|0;da=ea+S|0;ea=((Y(f[R+12>>2]|0,fa)|0)/1024|0)+O|0;R=R+16|0;if(R>>>0>=P>>>0){ga=ea;ha=da;break}else{O=ea;S=da}}}else{ga=0;ha=0}H=+U(+(+(ga|0)),+(+(ha|0)))/3.141592653589793*180.0;S=g+(y*28|0)+12|0;n[S>>2]=H;if(H<0.0&d)n[S>>2]=H+360.0}if(h){S=g+(y*28|0)+12|0;H=+n[S>>2];if(!(H==-1.0)){O=~~(H/360.0*1024.0+.5);P=(O|0)<0?O+1024|0:O;O=(P|0)>1023?P+-1024|0:P;if(H<0.0){ia=O;ja=H;X=76}else ka=O}else{ia=0;ja=-1.0;X=76}if((X|0)==76){X=0;n[S>>2]=ja+360.0;ka=ia}if(!(f[K>>2]|0))la=0;else{S=0;do{O=pMb(a,l,q,+n[Z>>2],+n[V>>2],f[z>>2]|0,ka,S)|0;f[I+(S<<2)>>2]=O;S=S+1|0;O=f[K>>2]|0}while(S>>>0<O>>>0);la=O}S=f[T>>2]|0;z=f[t>>2]|0;V=S+(z<<3)|0;c:do if((z|0)>0){Z=f[S>>2]|0;if(Z>>>0>=la>>>0){X=84;break b}g=$;O=0;P=S;R=la;da=Z;while(1){Z=f[P+4>>2]|0;if(Z>>>0>=R>>>0){X=84;break b}if((f[I+(da<<2)>>2]|0)>(f[I+(Z<<2)>>2]|0))f[g>>2]=f[g>>2]|1<<O;Z=O+1|0;ea=(Z|0)==32;P=P+8|0;if(P>>>0>=V>>>0)break c;R=f[K>>2]|0;da=f[P>>2]|0;if(da>>>0>=R>>>0){X=84;break b}else{g=ea?g+4|0:g;O=ea?0:Z}}}while(0);ma=$+(f[aa>>2]|0)|0}else ma=$;y=y+1|0;if(y>>>0>=C>>>0)break a;else $=ma}if((X|0)==70){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;$=$Xc(48)|0;f[s>>2]=$;f[s+8>>2]=-2147483600;f[s+4>>2]=38;E=$;na=461676;L=E+38|0;do{b[E>>0]=b[na>>0]|0;E=E+1|0;na=na+1|0}while((E|0)<(L|0));b[$+38>>0]=0;vM(-215,s,461715,461750,744)}else if((X|0)==84){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;y=$Xc(48)|0;f[s>>2]=y;f[s+8>>2]=-2147483600;f[s+4>>2]=38;E=y;na=461676;L=E+38|0;do{b[E>>0]=b[na>>0]|0;E=E+1|0;na=na+1|0}while((E|0)<(L|0));b[y+38>>0]=0;vM(-215,s,461715,461750,800)}}while(0);dYc(I);I=r+36|0;s=f[I>>2]|0;if(s|0?(na=s+12|0,s=f[na>>2]|0,f[na>>2]=s+-1,(s|0)==1):0)V$(r);f[I>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[A>>2]|0)>0){ba=f[i>>2]|0;i=0;do{f[ba+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[A>>2]|0))}A=f[_>>2]|0;if((A|0)!=(J|0))wL(A);A=q+36|0;J=f[A>>2]|0;if(J|0?(_=J+12|0,J=f[_>>2]|0,f[_>>2]=J+-1,(J|0)==1):0)V$(q);f[A>>2]=0;A=q+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[M>>2]|0)>0){A=f[N>>2]|0;N=0;do{f[A+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[M>>2]|0))}M=f[D>>2]|0;if((M|0)!=(v|0))wL(M);M=f[o>>2]|0;if(M|0){o=f[j>>2]|0;if((o|0)!=(M|0))f[j>>2]=o+(~((o+-4-M|0)>>>2)<<2);cYc(M)}M=m+36|0;o=f[M>>2]|0;if(o|0?(j=o+12|0,o=f[j>>2]|0,f[j>>2]=o+-1,(o|0)==1):0)V$(m);f[M>>2]=0;M=m+16|0;o=m+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[o>>2]|0)>0){M=f[m+40>>2]|0;j=0;do{f[M+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))wL(o);o=l+36|0;m=f[o>>2]|0;do if(m|0){j=m+12|0;M=f[j>>2]|0;f[j>>2]=M+-1;if((M|0)!=1)break;V$(l)}while(0);f[o>>2]=0;o=l+16|0;m=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[l+40>>2]|0;M=0;do{f[o+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=k;return}wL(m);u=k;return}function oMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;do if((eS(b)|0)==65536){j=f[b+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;U$(g,j);break}}else bS(g,b,-1);while(0);do if((eS(c)|0)==65536){j=f[c+4>>2]|0;f[h>>2]=f[j>>2];k=h+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=h+8|0;f[m>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=m;m=h+48|0;n=h+44|0;f[n>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[n>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;U$(h,j);break}}else bS(h,c,-1);while(0);if(f[g>>2]&4095|0){c=i+8|0;f[c>>2]=0;f[c+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=g;Spa(b,i,6,0)}b=f[a+8>>2]|0;f[i+4>>2]=0;c=i+8|0;f[c>>2]=0;f[i+12>>2]=0;f[i>>2]=(b|0)==0?1:b<<1;qMb(i,g);rMb(i,f[a+4>>2]|0,d);mSb(d,h);d=i+4|0;i=f[d>>2]|0;if(i|0){a=f[c>>2]|0;if((a|0)==(i|0))p=i;else{b=a;do{a=b+-328|0;f[c>>2]=a;sMb(a);b=f[c>>2]|0}while((b|0)!=(i|0));p=f[d>>2]|0}cYc(p)}p=h+36|0;d=f[p>>2]|0;if(d|0?(i=d+12|0,d=f[i>>2]|0,f[i>>2]=d+-1,(d|0)==1):0)V$(h);f[p>>2]=0;p=h+16|0;d=h+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[d>>2]|0)>0){p=f[h+40>>2]|0;i=0;do{f[p+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[h+44>>2]|0;if((d|0)!=(h+48|0))wL(d);d=g+36|0;h=f[d>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)V$(g);f[d>>2]=0;d=g+16|0;h=g+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[h>>2]|0)>0){d=f[g+40>>2]|0;i=0;do{f[d+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}wL(h);u=e;return}function pMb(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=+e;g=+g;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;l=u;u=u+16|0;m=l;o=f[a+12>>2]|0;p=(Y(f[a+16>>2]|0,(i<<10)+j|0)|0)+k|0;q=+n[o+(p*12|0)>>2]+e;e=+n[o+(p*12|0)+4>>2]+g;k=~~q;j=~~e;i=c+12|0;g=+n[o+(p*12|0)+8>>2];r=g*(g*4.0);if(g<.5){p=~~((q-+(k|0))*1024.0);o=~~((e-+(j|0))*1024.0);a=1024-p|0;s=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,j)|0)+k|0;k=f[c+48>>2]|0;j=Y(h[s>>0]|0,a)|0;t=Y(h[s+1>>0]|0,p)|0;v=Y(h[s+k>>0]|0,p)|0;w=(Y(t+j|0,1024-o|0)|0)+512+(Y((Y(h[s+(k+1)>>0]|0,a)|0)+v|0,o)|0)|0;x=1024;y=(w|0)/(x|0)|0;u=l;return y|0}o=~~(4194304.0/r);z=+(o|0);v=~~(r*z*.0009765625);if(!v){a=$Xc(16)|0;f[m>>2]=a;f[m+8>>2]=-2147483632;f[m+4>>2]=13;k=a;s=461823;j=k+13|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(j|0));b[a+13>>0]=0;vM(-215,m,461837,461750,509)}m=f[i>>2]|0;i=m+1|0;r=q-g;A=q+g;q=e-g;B=e+g;a=~~(r+.5);s=~~(q+.5);k=~~(A+.5);j=~~(B+.5);g=+(a|0)-r+.5;r=+(s|0)-q+.5;q=A-+(k|0)+.5;A=B-+(j|0)+.5;t=k-a|0;k=t+-1|0;p=1-t|0;C=j-s+-1|0;j=~~(z*(q*r));D=~~(z*(q*A));E=~~(z*(g*A));F=~~(z*g);G=~~(z*r);H=~~(z*q);I=~~(z*A);J=(f[c+16>>2]|0)+a+(Y(m,s)|0)|0;c=Y(h[J>>0]|0,~~(z*(g*r)))|0;if((k+C|0)>2){K=J+t|0;L=(Y(h[K>>0]|0,j)|0)+c|0;M=K+((Y(m,C)|0)+1)|0;K=L+(Y(h[M>>0]|0,D)|0)|0;L=K+(Y(h[M+(0-t)>>0]|0,E)|0)|0;M=(f[d+16>>2]|0)+(a<<2)+((Y(i,s)|0)<<2)+4|0;s=M+(k<<2)|0;k=s+(i<<2)|0;a=f[k>>2]|0;d=k+4|0;k=Y(i,C)|0;K=d+(k<<2)|0;N=K+-4|0;O=f[N>>2]|0;P=N+(i<<2)|0;i=P+(p<<2)|0;N=i+(~m<<2)|0;Q=f[N>>2]|0;R=N+-4|0;N=R+(0-k<<2)|0;k=f[N+4>>2]|0;S=L+(Y(a-(f[d>>2]|0)+(f[K>>2]|0)-O|0,H)|0)+(Y((f[P>>2]|0)-O-(f[i>>2]|0)+Q|0,I)|0)+(Y((f[M>>2]|0)-(f[s>>2]|0)+a-k|0,G)|0)+(Y(O-a-Q+k|0,o)|0)+(Y(Q-(f[R>>2]|0)+(f[N>>2]|0)-k|0,F)|0)|0}else{k=J+1|0;N=J+t|0;R=(t|0)>1;Q=h[k>>0]|0;if(R){a=c;O=k;k=Q;while(1){s=(Y(k,G)|0)+a|0;M=O+1|0;i=h[M>>0]|0;if(M>>>0<N>>>0){a=s;O=M;k=i}else{T=s;U=i;V=O;break}}}else{T=c;U=Q;V=J}J=(Y(U,j)|0)+T|0;T=p+-1+m|0;p=V+1+T|0;V=Y(m,C)|0;C=p+V|0;m=h[p>>0]|0;if((V|0)>0){V=J;j=p;U=m;while(1){Q=(Y(U,F)|0)+V|0;c=j+1|0;O=j+t|0;k=h[c>>0]|0;if(R){a=c;c=Q;N=k;while(1){G=(Y(N,o)|0)+c|0;i=a+1|0;s=h[i>>0]|0;if(i>>>0<O>>>0){a=i;c=G;N=s}else{W=G;X=s;Z=a;break}}}else{W=Q;X=k;Z=j}a=(Y(X,H)|0)+W|0;N=Z+1+T|0;c=h[N>>0]|0;if(N>>>0<C>>>0){V=a;j=N;U=c}else{_=a;$=N;aa=c;break}}}else{_=J;$=p;aa=m}m=(Y(aa,E)|0)+_|0;_=$+1|0;E=$+t|0;t=h[_>>0]|0;if(R){R=_;_=m;$=t;while(1){aa=(Y($,I)|0)+_|0;R=R+1|0;p=h[R>>0]|0;if(R>>>0>=E>>>0){ba=aa;ca=p;break}else{_=aa;$=p}}}else{ba=m;ca=t}S=(Y(ca,D)|0)+ba|0}w=S+((v|0)/2|0)|0;x=v;y=(w|0)/(x|0)|0;u=l;return y|0}function qMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+720|0;d=c+384|0;e=c+56|0;g=c;h=a+4|0;i=f[h>>2]|0;j=a+8|0;k=f[j>>2]|0;if((k|0)!=(i|0)){l=k;do{k=l+-328|0;f[j>>2]=k;sMb(k);l=f[j>>2]|0}while((l|0)!=(i|0))}f[g>>2]=1124007936;i=g+4|0;l=g+8|0;k=g+40|0;m=i;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[k>>2]=l;l=g+48|0;m=g+44|0;f[m>>2]=l;f[l>>2]=0;f[g+52>>2]=0;n=d+8|0;f[n>>2]=0;f[n+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=g;jR(b,d);CMb(e,g,1.0,0.0);b=f[j>>2]|0;n=a+12|0;if(b>>>0<(f[n>>2]|0)>>>0){DMb(b,e);f[j>>2]=(f[j>>2]|0)+328}else EMb(h,e);sMb(e);e=g+36|0;b=f[e>>2]|0;if(b|0?(o=b+12|0,b=f[o>>2]|0,f[o>>2]=b+-1,(b|0)==1):0)V$(g);f[e>>2]=0;e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[i>>2]|0)>0){e=f[k>>2]|0;k=0;do{f[e+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[m>>2]|0;if((i|0)!=(l|0))wL(i);if((f[a>>2]|0)<=1){u=c;return}FMb(d,(f[j>>2]|0)+-328|0,1);i=f[j>>2]|0;if(i>>>0<(f[n>>2]|0)>>>0){DMb(i,d);f[j>>2]=(f[j>>2]|0)+328}else EMb(h,d);sMb(d);i=f[a>>2]|0;if((i|0)<=2){u=c;return}a=2;do{FMb(d,(f[h>>2]|0)+((a+-2|0)*328|0)|0,0);l=f[j>>2]|0;if(l>>>0<(f[n>>2]|0)>>>0){DMb(l,d);f[j>>2]=(f[j>>2]|0)+328}else EMb(h,d);sMb(d);FMb(d,(f[h>>2]|0)+((a+-1|0)*328|0)|0,0);l=f[j>>2]|0;if(l>>>0<(f[n>>2]|0)>>>0){DMb(l,d);f[j>>2]=(f[j>>2]|0)+328}else EMb(h,d);sMb(d);a=a+2&255}while((a|0)<(i|0));u=c;return}function rMb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0;e=u;u=u+128|0;g=e+104|0;h=e+100|0;i=e+96|0;j=e+68|0;k=e+116|0;l=e+40|0;m=e+36|0;o=e+32|0;p=e+28|0;q=e;r=d+4|0;s=f[r>>2]|0;t=f[d>>2]|0;v=s;w=t;if((s|0)==(t|0)|(v|0)==(w|0))x=s;else{s=v+(~(((v+-28-t|0)>>>0)/28|0)*28|0)|0;f[r>>2]=s;x=s}s=d+8|0;if((((f[s>>2]|0)-t|0)/28|0)>>>0<2e3){v=$Xc(56e3)|0;y=v+(((x-t|0)/28|0)*28|0)|0;t=y;z=v+56e3|0;v=x;if((v|0)==(w|0)){A=t;B=x}else{x=v;v=t;C=y;do{y=x;x=x+-28|0;f[C+-28>>2]=f[x>>2];f[C+-24>>2]=f[y+-24>>2];D=C+-20|0;E=y+-20|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2];f[D+8>>2]=f[E+8>>2];f[D+12>>2]=f[E+12>>2];f[D+16>>2]=f[E+16>>2];C=v+-28|0;v=C}while((x|0)!=(w|0));A=v;B=f[d>>2]|0}f[d>>2]=A;f[r>>2]=t;f[s>>2]=z;if(B|0)cYc(B)}F=+(c|0);c=~~F;f[g>>2]=0;B=g+4|0;f[B>>2]=0;f[g+8>>2]=0;z=f[a>>2]|0;a:do if(z){tMb(g,z);t=f[a>>2]|0;if((t|0)>0){A=a+4|0;v=0;do{uMb((f[A>>2]|0)+(v*328|0)|0,c,(f[g>>2]|0)+(v*12|0)|0);v=v+1|0;G=f[a>>2]|0}while((v|0)<(G|0));if((G|0)==1){v=f[g>>2]|0;A=(f[v+4>>2]|0)-(f[v>>2]|0)|0;w=(A|0)/28|0;if(A|0){A=v;v=a+4|0;x=j+4|0;C=j+8|0;E=j+12|0;D=j+16|0;y=j+20|0;H=j+24|0;if((f[B>>2]|0)==(A|0))lWc(g);else{I=0;J=A}do{A=f[J>>2]|0;K=A+(I*28|0)|0;L=A+(I*28|0)+4|0;if(vMb(a,0,~~+n[K>>2],~~+n[L>>2])|0){A=f[v>>2]|0;M=wMb(A,+n[K>>2]+-1.0,+n[L>>2]+-1.0,1,1.0)|0;N=wMb(A,+n[K>>2],+n[L>>2]+-1.0,1,1.0)|0;O=wMb(A,+n[K>>2]+1.0,+n[L>>2]+-1.0,1,1.0)|0;P=wMb(A,+n[K>>2]+1.0,+n[L>>2],1,1.0)|0;Q=wMb(A,+n[K>>2],+n[L>>2],1,1.0)|0;R=wMb(A,+n[K>>2]+-1.0,+n[L>>2],1,1.0)|0;S=wMb(A,+n[K>>2]+-1.0,+n[L>>2]+1.0,1,1.0)|0;T=wMb(A,+n[K>>2],+n[L>>2]+1.0,1,1.0)|0;U=+xMb(a,M,R,S,N,Q,T,O,P,wMb(A,+n[K>>2]+1.0,+n[L>>2]+1.0,1,1.0)|0,h,i);V=+n[K>>2]+ +n[h>>2];W=+n[L>>2]+ +n[i>>2];n[j>>2]=V;n[x>>2]=W;n[C>>2]=12.0;n[E>>2]=-1.0;n[D>>2]=U;f[y>>2]=0;f[H>>2]=-1;L=f[r>>2]|0;if(L>>>0<(f[s>>2]|0)>>>0){n[L>>2]=V;f[L+4>>2]=f[x>>2];K=L+8|0;f[K>>2]=f[C>>2];f[K+4>>2]=f[C+4>>2];f[K+8>>2]=f[C+8>>2];f[K+12>>2]=f[C+12>>2];f[K+16>>2]=f[C+16>>2];f[r>>2]=(f[r>>2]|0)+28}else NA(d,j)}I=I+1|0;if(I>>>0>=w>>>0)break a;J=f[g>>2]|0}while((f[B>>2]|0)!=(J|0));lWc(g)}}else{X=G;Y=24}}else{X=t;Y=24}}else{X=0;Y=24}while(0);if((Y|0)==24)b:do if((X|0)>0){G=a+4|0;J=q+4|0;I=q+8|0;z=q+12|0;w=q+16|0;C=q+20|0;x=q+24|0;H=l+4|0;y=l+8|0;D=l+12|0;E=l+16|0;v=l+20|0;K=l+24|0;L=0;A=X;c:while(1){P=f[G>>2]|0;O=P+(L*328|0)|0;T=f[g>>2]|0;Q=(f[T+(L*12|0)+4>>2]|0)-(f[T+(L*12|0)>>2]|0)|0;N=(Q|0)/28|0;S=(Q|0)!=0;Q=T;d:do if((L|0)==(A+-1|0)){if(S){T=P+(L*328|0)+112|0;R=P+(L*328|0)+116|0;if((((f[B>>2]|0)-Q|0)/12|0)>>>0>L>>>0){Z=0;_=Q}else{Y=32;break c}while(1){M=f[_+(L*12|0)>>2]|0;$=M+(Z*28|0)|0;aa=M+(Z*28|0)+4|0;if(vMb(a,L,~~+n[$>>2],~~+n[aa>>2])|0?(V=+n[$>>2],U=+n[aa>>2],+yMb(a,L,~~V,~~U,wMb(O,V,U,c,1.0)|0,k,l,m),b[k>>0]|0):0){M=wMb(O,+n[$>>2]+-1.0,+n[aa>>2]+-1.0,1,1.0)|0;ba=wMb(O,+n[$>>2],+n[aa>>2]+-1.0,1,1.0)|0;ca=wMb(O,+n[$>>2]+1.0,+n[aa>>2]+-1.0,1,1.0)|0;da=wMb(O,+n[$>>2]+1.0,+n[aa>>2],1,1.0)|0;ea=wMb(O,+n[$>>2],+n[aa>>2],1,1.0)|0;fa=wMb(O,+n[$>>2]+-1.0,+n[aa>>2],1,1.0)|0;ga=wMb(O,+n[$>>2]+-1.0,+n[aa>>2]+1.0,1,1.0)|0;ha=wMb(O,+n[$>>2],+n[aa>>2]+1.0,1,1.0)|0;U=+xMb(a,M,fa,ga,ba,ea,ha,ca,da,wMb(O,+n[$>>2]+1.0,+n[aa>>2]+1.0,1,1.0)|0,o,p);V=+n[T>>2];W=+n[R>>2];ia=(+n[$>>2]+ +n[o>>2])*V+W;ja=W+V*(+n[aa>>2]+ +n[p>>2]);n[q>>2]=ia;n[J>>2]=ja;n[I>>2]=V*12.0;n[z>>2]=-1.0;n[w>>2]=U;f[C>>2]=L;f[x>>2]=-1;aa=f[r>>2]|0;if(aa>>>0<(f[s>>2]|0)>>>0){n[aa>>2]=ia;f[aa+4>>2]=f[J>>2];$=aa+8|0;f[$>>2]=f[I>>2];f[$+4>>2]=f[I+4>>2];f[$+8>>2]=f[I+8>>2];f[$+12>>2]=f[I+12>>2];f[$+16>>2]=f[I+16>>2];f[r>>2]=(f[r>>2]|0)+28}else NA(d,q)}Z=Z+1|0;if(Z>>>0>=N>>>0)break d;_=f[g>>2]|0;if((((f[B>>2]|0)-_|0)/12|0)>>>0<=L>>>0){Y=32;break c}}}}else if(S){if((((f[B>>2]|0)-Q|0)/12|0)>>>0>L>>>0){ka=0;la=Q}else{Y=42;break c}while(1){R=f[la+(L*12|0)>>2]|0;T=R+(ka*28|0)|0;$=R+(ka*28|0)+4|0;if(vMb(a,L,~~+n[T>>2],~~+n[$>>2])|0?(b[k>>0]=0,ia=+zMb(a,L,~~+n[T>>2],~~+n[$>>2],h,i,j,k),ia>F&(b[k>>0]|0)!=0):0){$=f[h>>2]|0;T=f[i>>2]|0;U=+n[j>>2]*12.0;f[l>>2]=$;f[H>>2]=T;n[y>>2]=U;n[D>>2]=-1.0;n[E>>2]=ia;f[v>>2]=L;f[K>>2]=-1;T=f[r>>2]|0;if(T>>>0<(f[s>>2]|0)>>>0){f[T>>2]=$;f[T+4>>2]=f[H>>2];$=T+8|0;f[$>>2]=f[y>>2];f[$+4>>2]=f[y+4>>2];f[$+8>>2]=f[y+8>>2];f[$+12>>2]=f[y+12>>2];f[$+16>>2]=f[y+16>>2];f[r>>2]=(f[r>>2]|0)+28}else NA(d,l)}ka=ka+1|0;if(ka>>>0>=N>>>0)break d;la=f[g>>2]|0;if((((f[B>>2]|0)-la|0)/12|0)>>>0<=L>>>0){Y=42;break c}}}while(0);L=L+1|0;A=f[a>>2]|0;if((L|0)>=(A|0))break b}if((Y|0)==32)lWc(g);else if((Y|0)==42)lWc(g)}while(0);Y=f[g>>2]|0;if(!Y){u=e;return}a=f[B>>2]|0;if((a|0)==(Y|0))ma=Y;else{la=a;while(1){a=la+-12|0;f[B>>2]=a;ka=f[a>>2]|0;if(!ka)na=a;else{a=la+-8|0;l=f[a>>2]|0;if((l|0)!=(ka|0))f[a>>2]=l+(~(((l+-28-ka|0)>>>0)/28|0)*28|0);cYc(ka);na=f[B>>2]|0}if((na|0)==(Y|0))break;else la=na}ma=f[g>>2]|0}cYc(ma);u=e;return}function sMb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+124>>2]|0;if(b|0)UXc(b);b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function tMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=d;g=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=j+-12|0;b=i;i=i+-12|0;f[d>>2]=0;n=j+-8|0;f[n>>2]=0;f[j+-4>>2]=0;f[d>>2]=f[i>>2];d=b+-8|0;f[n>>2]=f[d>>2];n=b+-4|0;f[j+-4>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[i>>2]=0;j=h+-12|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=c;c=c+-12|0;m=f[c>>2]|0;if(m|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(m|0))f[e>>2]=q+(~(((q+-28-m|0)>>>0)/28|0)*28|0);cYc(m)}}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function uMb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=a+120|0;i=f[h>>2]|0;mi[f[(f[i>>2]|0)+64>>2]&2047](i,c);c=f[h>>2]|0;h=f[(f[c>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;i=fT()|0;ei[h&511](c,g,d,i);i=f[d>>2]|0;g=(f[d+4>>2]|0)-i|0;c=(g|0)/28|0;if(!g){u=e;return}g=a+72|0;h=a+100|0;a=0;j=i;while(1){i=ALc(+n[j+(a*28|0)+16>>2])|0;k=(f[g>>2]|0)+(Y(f[f[h>>2]>>2]|0,~~+n[j+(a*28|0)+4>>2])|0)+~~+n[j+(a*28|0)>>2]|0;b[k>>0]=i>>>0<256?i:(i|0)>0?255:0;i=a+1|0;if(i>>>0>=c>>>0)break;a=i;j=f[d>>2]|0}u=e;return}function vMb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;g=u;u=u+16|0;i=g+4|0;j=g;k=f[a+4>>2]|0;a=f[k+(c*328|0)+68>>2]|0;l=k+(c*328|0)+72|0;c=(f[l>>2]|0)+(Y(a,e)|0)+d|0;k=b[c>>0]|0;m=c+-1|0;c=b[m>>0]|0;n=k&255;o=c&255;if((k&255)<(c&255)){p=0;u=g;return p|0}q=m+2|0;m=b[q>>0]|0;r=m&255;if((k&255)<(m&255)){p=0;u=g;return p|0}s=q+~a|0;q=b[s>>0]|0;t=q&255;if((k&255)<(q&255)){p=0;u=g;return p|0}v=a<<1;w=s+v|0;s=b[w>>0]|0;x=s&255;if((k&255)<(s&255)){p=0;u=g;return p|0}y=w+-1|0;w=b[y>>0]|0;z=w&255;if((k&255)<(w&255)){p=0;u=g;return p|0}A=y+2|0;y=b[A>>0]|0;B=y&255;if((k&255)<(y&255)){p=0;u=g;return p|0}C=A+(0-v)|0;v=b[C>>0]|0;A=v&255;if((k&255)<(v&255)){p=0;u=g;return p|0}D=b[C+-2>>0]|0;C=D&255;if((k&255)<(D&255)){p=0;u=g;return p|0}f[i>>2]=0;E=i+4|0;f[E>>2]=0;f[i+8>>2]=0;if(k<<24>>24==D<<24>>24){f[j>>2]=-1;LA(i,j);D=f[E>>2]|0;F=f[i+8>>2]|0;f[j>>2]=-1;if(D>>>0<F>>>0){f[D>>2]=-1;f[E>>2]=D+4}else LA(i,j)}if(k<<24>>24==q<<24>>24){f[j>>2]=0;q=f[E>>2]|0;D=i+8|0;F=f[D>>2]|0;if(q>>>0<F>>>0){f[q>>2]=0;G=q+4|0;f[E>>2]=G;H=G;I=F}else{LA(i,j);H=f[E>>2]|0;I=f[D>>2]|0}f[j>>2]=-1;if(H>>>0<I>>>0){f[H>>2]=-1;f[E>>2]=H+4}else LA(i,j)}if(k<<24>>24==v<<24>>24){f[j>>2]=1;v=f[E>>2]|0;H=i+8|0;I=f[H>>2]|0;if(v>>>0<I>>>0){f[v>>2]=1;D=v+4|0;f[E>>2]=D;J=D;K=I}else{LA(i,j);J=f[E>>2]|0;K=f[H>>2]|0}f[j>>2]=-1;if(J>>>0<K>>>0){f[J>>2]=-1;f[E>>2]=J+4}else LA(i,j)}if(k<<24>>24==c<<24>>24){f[j>>2]=-1;c=f[E>>2]|0;J=i+8|0;K=f[J>>2]|0;if(c>>>0<K>>>0){f[c>>2]=-1;H=c+4|0;f[E>>2]=H;L=H;M=K}else{LA(i,j);L=f[E>>2]|0;M=f[J>>2]|0}f[j>>2]=0;if(L>>>0<M>>>0){f[L>>2]=0;f[E>>2]=L+4}else LA(i,j)}if(k<<24>>24==m<<24>>24){f[j>>2]=1;m=f[E>>2]|0;L=i+8|0;M=f[L>>2]|0;if(m>>>0<M>>>0){f[m>>2]=1;J=m+4|0;f[E>>2]=J;N=J;O=M}else{LA(i,j);N=f[E>>2]|0;O=f[L>>2]|0}f[j>>2]=0;if(N>>>0<O>>>0){f[N>>2]=0;f[E>>2]=N+4}else LA(i,j)}if(k<<24>>24==w<<24>>24){f[j>>2]=-1;w=f[E>>2]|0;N=i+8|0;O=f[N>>2]|0;if(w>>>0<O>>>0){f[w>>2]=-1;L=w+4|0;f[E>>2]=L;P=L;Q=O}else{LA(i,j);P=f[E>>2]|0;Q=f[N>>2]|0}f[j>>2]=1;if(P>>>0<Q>>>0){f[P>>2]=1;f[E>>2]=P+4}else LA(i,j)}if(k<<24>>24==s<<24>>24){f[j>>2]=0;s=f[E>>2]|0;P=i+8|0;Q=f[P>>2]|0;if(s>>>0<Q>>>0){f[s>>2]=0;N=s+4|0;f[E>>2]=N;R=N;S=Q}else{LA(i,j);R=f[E>>2]|0;S=f[P>>2]|0}f[j>>2]=1;if(R>>>0<S>>>0){f[R>>2]=1;f[E>>2]=R+4}else LA(i,j)}if(k<<24>>24==y<<24>>24){f[j>>2]=1;y=f[E>>2]|0;k=i+8|0;R=f[k>>2]|0;if(y>>>0<R>>>0){f[y>>2]=1;S=y+4|0;f[E>>2]=S;T=S;U=R}else{LA(i,j);T=f[E>>2]|0;U=f[k>>2]|0}f[j>>2]=1;if(T>>>0<U>>>0){f[T>>2]=1;f[E>>2]=T+4}else LA(i,j)}j=f[E>>2]|0;T=f[i>>2]|0;i=j-T>>2;U=T;k=j;a:do if(!i)V=1;else{j=(r+o+t+x<<1)+(n<<2)+z+B+A+C|0;R=f[l>>2]|0;S=e+-1|0;y=0;while(1){P=R+(Y(S+(f[U+((y|1)<<2)>>2]|0)|0,a)|0)+d|0;Q=P+(f[U+(y<<2)>>2]|0)+-1|0;P=Q+1|0;N=P+1|0;s=N+a|0;O=s+-1|0;L=O+-1|0;w=L+a|0;M=w+1|0;y=y+2|0;if(((h[N>>0]|0)+(h[Q>>0]|0)+((h[O>>0]|0)<<2)+(h[w>>0]|0)+(h[M+1>>0]|0)+((h[s>>0]|0)+(h[P>>0]|0)+(h[L>>0]|0)+(h[M>>0]|0)<<1)|0)>(j|0)){V=0;break a}if(y>>>0>=i>>>0){V=1;break}}}while(0);i=T;if(T|0){if((k|0)!=(U|0))f[E>>2]=k+(~((k+-4-T|0)>>>2)<<2);cYc(i)}p=V;u=g;return p|0}function wMb(a,c,d,e,g){a=a|0;c=+c;d=+d;e=e|0;g=+g;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0,I=0.0;if(!(g<=1.0)){i=g*.5;j=~~(c-i);k=~~(i+c+1.0);if((j|0)<=(k|0)?(l=~~(d-i),m=~~(i+d+1.0),n=a+12|0,o=a+8|0,p=a+72|0,q=a+100|0,r=a+16|0,s=a+44|0,t=a+228|0,u=e+-1|0,(l|0)<=(m|0)):0){v=j;while(1){if((v|0)>=3){j=l;while(1){if((((j|0)>=3?((f[n>>2]|0)+-3|0)>(v|0):0)?((f[o>>2]|0)+-3|0)>(j|0):0)?(w=(f[p>>2]|0)+(Y(f[f[q>>2]>>2]|0,j)|0)+v|0,(h[w>>0]|0)<=2):0){x=sSb((f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,j)|0)+v|0,t,u)|0;b[w>>0]=(x&255|0)<(e|0)?0:x&255}if((j|0)<(m|0))j=j+1|0;else break}}if((v|0)<(k|0))v=v+1|0;else break}}y=BMb(a,a+56|0,c,d,g)|0;return y|0}v=~~c;g=c-+(v|0);c=1.0-g;k=~~d;i=d-+(k|0);d=1.0-i;z=c*d;m=(v|0)<3;u=(k|0)<3;if((!(m|u)?((f[a+12>>2]|0)+-3|0)>(v|0):0)?((f[a+8>>2]|0)+-3|0)>(k|0):0){t=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,k)|0)+v|0;s=b[t>>0]|0;if((s&255)>2)A=s;else{s=sSb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,k)|0)+v|0,a+228|0,e+-1|0)|0;r=(s&255|0)<(e|0)?0:s&255;b[t>>0]=r;A=r}B=+(A&255)}else B=0.0;C=z*B;B=g*d;A=v+1|0;r=(A|0)<3;if((!(r|u)?((f[a+12>>2]|0)+-3|0)>(A|0):0)?((f[a+8>>2]|0)+-3|0)>(k|0):0){u=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,k)|0)+A|0;t=b[u>>0]|0;if((t&255)>2)D=t;else{t=sSb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,k)|0)+A|0,a+228|0,e+-1|0)|0;s=(t&255|0)<(e|0)?0:t&255;b[u>>0]=s;D=s}E=+(D&255)}else E=0.0;d=C+B*E;E=c*i;D=k+1|0;k=(D|0)<3;if((!(m|k)?((f[a+12>>2]|0)+-3|0)>(v|0):0)?((f[a+8>>2]|0)+-3|0)>(D|0):0){m=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,D)|0)+v|0;s=b[m>>0]|0;if((s&255)>2)F=s;else{s=sSb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,D)|0)+v|0,a+228|0,e+-1|0)|0;v=(s&255|0)<(e|0)?0:s&255;b[m>>0]=v;F=v}G=+(F&255)}else G=0.0;c=d+E*G;G=g*i;if((!(r|k)?((f[a+12>>2]|0)+-3|0)>(A|0):0)?((f[a+8>>2]|0)+-3|0)>(D|0):0){k=(f[a+72>>2]|0)+(Y(f[f[a+100>>2]>>2]|0,D)|0)+A|0;r=b[k>>0]|0;if((r&255)>2)H=r;else{r=sSb((f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,D)|0)+A|0,a+228|0,e+-1|0)|0;a=(r&255|0)<(e|0)?0:r&255;b[k>>0]=a;H=a}I=+(H&255)}else I=0.0;y=~~(c+G*I)&255;return y|0}function xMb(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;a=d+b|0;m=a-(f<<1)+h+j|0;o=g+e|0;p=c-(o<<1)+i+m|0;q=p*3|0;r=o-(i+c<<1)+m|0;m=r*3|0;o=d-h|0;s=o+b-j|0;t=Y(c-i+s|0,-3)|0;u=Y(e-g-(o<<1)+s|0,-3)|0;s=b-d-h+j<<2;d=0-((Y(f,-5)|0)+(a-(e+c+g+i<<1))+h+j)<<1;j=(Y(p*12|0,m)|0)-(Y(s,s)|0)|0;if(!j){n[k>>2]=0.0;n[l>>2]=0.0;v=+(d|0)/18.0;return +v}if(!((p|0)<0&(j|0)>0)){h=t+s+u|0;n[k>>2]=1.0;n[l>>2]=1.0;i=u-t-s|0;if((i|0)>(h|0)){n[k>>2]=-1.0;n[l>>2]=1.0;w=i}else w=h;h=t-u-s|0;if((h|0)>(w|0)){n[k>>2]=1.0;n[l>>2]=-1.0;x=h}else x=w;w=s-t-u|0;if((w|0)>(x|0)){n[k>>2]=-1.0;n[l>>2]=-1.0;y=w}else y=x;v=+(m+q+d+y|0)/18.0;return +v}y=r*6|0;z=+(0-j|0);A=+((Y(y,t)|0)-(Y(u,s)|0)|0)/z;n[k>>2]=A;j=p*6|0;A=+((Y(j,u)|0)-(Y(t,s)|0)|0)/z;n[l>>2]=A;z=+n[k>>2];do if(z>1.0){p=A>1.0;r=A<-1.0;B=-+(u+s|0)/+(y|0);if(!(B>1.0))if(B<-1.0)if(p){C=-1.0;D=1.0;E=21}else{F=-1.0;G=1.0;H=r;E=24}else{I=B;J=1.0;K=p;L=r;E=20}else{I=1.0;J=1.0;K=p;L=r;E=20}}else{r=A>1.0;p=A<-1.0;if(z<-1.0){B=-+(u-s|0)/+(y|0);if(B>1.0){I=1.0;J=-1.0;K=r;L=p;E=20;break}if(!(B<-1.0)){I=B;J=-1.0;K=r;L=p;E=20;break}if(r){C=-1.0;D=-1.0;E=21;break}else{F=-1.0;G=-1.0;H=p;E=24;break}}else{if(p|r){I=0.0;J=0.0;K=r;L=p;E=20;break}v=(+(d|0)+(A*(+(s|0)*z)+(+(u|0)*A+(+(t|0)*z+(A*(+(m|0)*A)+z*(+(q|0)*z))))))/18.0;return +v}}while(0);if((E|0)==20)if(K){C=I;D=J;E=21}else{F=I;G=J;H=L;E=24}if((E|0)==21){J=-+(t+s|0)/+(j|0);if(!(J>1.0))if(J<-1.0){M=1.0;N=C;O=-1.0;P=D}else{M=1.0;N=C;O=J;P=D}else{M=1.0;N=C;O=1.0;P=D}}else if((E|0)==24)if(H){D=-+(t-s|0)/+(j|0);if(!(D>1.0))if(D<-1.0){M=-1.0;N=F;O=-1.0;P=G}else{M=-1.0;N=F;O=D;P=G}else{M=-1.0;N=F;O=1.0;P=G}}else{M=0.0;N=F;O=0.0;P=G}G=+(q|0);F=+(m|0);D=+(t|0);C=+(u|0);J=+(s|0);I=+(d|0);z=(I+(J*P*N+(C*N+(D*P+(P*(G*P)+N*(F*N))))))/18.0;A=(I+(J*O*M+(C*M+(D*O+(O*(G*O)+M*(F*M))))))/18.0;d=z>A;n[k>>2]=d?P:O;n[l>>2]=d?N:M;v=d?z:A;return +v}function yMb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0.0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0,vb=0.0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0,Cb=0.0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0,Ib=0,Jb=0.0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0.0,dc=0.0,ec=0,fc=0.0,gc=0.0;k=u;u=u+32|0;l=k+12|0;m=k+8|0;o=k+4|0;p=k;b[h>>0]=0;q=(c&1|0)==0;if(q){r=d<<3;s=e<<3;t=+((r|1)+-4|0)/6.0;v=+(r|5|0)/6.0;w=+((s|1)+-4|0)/6.0;x=+(s|5|0)/6.0}else{s=d*6|1;r=e*6|1;t=+(s+-3|0)*.25;v=+(s+3|0)*.25;w=+(r+-3|0)*.25;x=+(r+3|0)*.25}if((c|0)<=0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+11>>0]=9;r=l;s=461892;y=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(y|0));b[l+9>>0]=0;vM(-215,l,461902,461750,1634)}s=c+-1|0;c=f[a+4>>2]|0;r=c+(s*328|0)|0;y=~~t;z=y+1|0;A=~~w;B=A+1|0;C=+(wMb(r,t,w,1,1.0)|0);n[l>>2]=C;D=+(g|0);if(C>D){E=0.0;u=k;return +E}g=~~v;F=(y|0)<(g|0);do if(F){G=C;y=z;H=z;I=+n[l>>2];while(1){J=+(wMb(r,+(H|0),w,1,1.0)|0);if(J>D)break;K=J>G;L=K?J:I;G=K?J:G;y=K?H:y;if((H|0)>=(g|0)){M=11;break}else{H=H+1|0;I=L}}if((M|0)==11){n[l>>2]=L;N=G;O=y;break}n[l>>2]=I;E=0.0;u=k;return +E}else{N=C;O=z}while(0);C=+(wMb(r,v,w,1,1.0)|0);if(C>D){E=0.0;u=k;return +E}if(C>N){n[l>>2]=C;P=C;Q=g}else{P=N;Q=O}O=~~x;do if((A|0)<(O|0)){H=~~(t+1.0);K=c+(s*328|0)+12|0;R=c+(s*328|0)+8|0;S=c+(s*328|0)+72|0;T=c+(s*328|0)+100|0;U=c+(s*328|0)+16|0;V=c+(s*328|0)+44|0;W=c+(s*328|0)+228|0;N=P;X=B;Z=B;_=Q;C=+n[l>>2];a:while(1){w=+(Z|0);L=+(wMb(r,t,w,1,1.0)|0);if(L>D){$=C;M=213;break}if(L>N){aa=L;ba=Z;ca=H;da=L}else{aa=N;ba=X;ca=_;da=C}if(F){ea=(Z|0)<3;fa=Z+1|0;ga=(fa|0)<3;ha=Z+-1|0;ia=(Z|0)<4;L=aa;ja=z;ka=ba;la=ca;ma=da;while(1){na=(ja|0)<3;if((!(ea|na)?((f[K>>2]|0)+-3|0)>(ja|0):0)?((f[R>>2]|0)+-3|0)>(Z|0):0){oa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Z)|0)+ja|0;pa=b[oa>>0]|0;if((pa&255)>2)qa=pa;else{pa=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Z)|0)+ja|0,W,0)|0;ra=(pa&255|0)==0?0:pa&255;b[oa>>0]=ra;qa=ra}sa=qa&255}else sa=0;J=+(sa|0);if(J>D){M=212;break a}if(J==L){ra=ja+-1|0;oa=(ja|0)<4;do if(ea|oa)ta=0;else{if(((f[K>>2]|0)+-3|0)<(ja|0)){ta=0;break}if(((f[R>>2]|0)+-3|0)<=(Z|0)){ta=0;break}pa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Z)|0)+ra|0;ua=b[pa>>0]|0;if((ua&255)>2)va=ua;else{ua=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Z)|0)+ra|0,W,0)|0;wa=(ua&255|0)==0?0:ua&255;b[pa>>0]=wa;va=wa}ta=va&255}while(0);wa=ja+1|0;pa=(wa|0)<3;do if(ea|pa)xa=0;else{if(((f[K>>2]|0)+-3|0)<=(wa|0)){xa=0;break}if(((f[R>>2]|0)+-3|0)<=(Z|0)){xa=0;break}ua=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Z)|0)+wa|0;ya=b[ua>>0]|0;if((ya&255)>2)za=ya;else{ya=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Z)|0)+wa|0,W,0)|0;Aa=(ya&255|0)==0?0:ya&255;b[ua>>0]=Aa;za=Aa}xa=za&255}while(0);Aa=xa+ta|0;do if(ga|na)Ba=0;else{if(((f[K>>2]|0)+-3|0)<=(ja|0)){Ba=0;break}if(((f[R>>2]|0)+-3|0)<=(fa|0)){Ba=0;break}ua=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,fa)|0)+ja|0;ya=b[ua>>0]|0;if((ya&255)>2)Ca=ya;else{ya=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,fa)|0)+ja|0,W,0)|0;Da=(ya&255|0)==0?0:ya&255;b[ua>>0]=Da;Ca=Da}Ba=Ca&255}while(0);Da=Aa+Ba|0;do if(ia|na)Ea=0;else{if(((f[K>>2]|0)+-3|0)<=(ja|0)){Ea=0;break}if(((f[R>>2]|0)+-3|0)<(Z|0)){Ea=0;break}ua=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ha)|0)+ja|0;ya=b[ua>>0]|0;if((ya&255)>2)Fa=ya;else{ya=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ha)|0)+ja|0,W,0)|0;Ga=(ya&255|0)==0?0:ya&255;b[ua>>0]=Ga;Fa=Ga}Ea=Fa&255}while(0);na=Da+Ea<<1;do if(ga|pa)Ha=0;else{if(((f[K>>2]|0)+-3|0)<=(wa|0)){Ha=0;break}if(((f[R>>2]|0)+-3|0)<=(fa|0)){Ha=0;break}Aa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,fa)|0)+wa|0;Ga=b[Aa>>0]|0;if((Ga&255)>2)Ia=Ga;else{Ga=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,fa)|0)+wa|0,W,0)|0;ua=(Ga&255|0)==0?0:Ga&255;b[Aa>>0]=ua;Ia=ua}Ha=Ia&255}while(0);do if(ga|oa)Ja=0;else{if(((f[K>>2]|0)+-3|0)<(ja|0)){Ja=0;break}if(((f[R>>2]|0)+-3|0)<=(fa|0)){Ja=0;break}Da=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,fa)|0)+ra|0;ua=b[Da>>0]|0;if((ua&255)>2)Ka=ua;else{ua=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,fa)|0)+ra|0,W,0)|0;Aa=(ua&255|0)==0?0:ua&255;b[Da>>0]=Aa;Ka=Aa}Ja=Ka&255}while(0);do if(ia|pa)La=0;else{if(((f[K>>2]|0)+-3|0)<=(wa|0)){La=0;break}if(((f[R>>2]|0)+-3|0)<(Z|0)){La=0;break}Aa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ha)|0)+wa|0;Da=b[Aa>>0]|0;if((Da&255)>2)Ma=Da;else{Da=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ha)|0)+wa|0,W,0)|0;ua=(Da&255|0)==0?0:Da&255;b[Aa>>0]=ua;Ma=ua}La=Ma&255}while(0);do if(ia|oa)Na=0;else{if(((f[K>>2]|0)+-3|0)<(ja|0)){Na=0;break}if(((f[R>>2]|0)+-3|0)<(Z|0)){Na=0;break}wa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ha)|0)+ra|0;pa=b[wa>>0]|0;if((pa&255)>2)Oa=pa;else{pa=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ha)|0)+ra|0,W,0)|0;ua=(pa&255|0)==0?0:pa&255;b[wa>>0]=ua;Oa=ua}Na=Oa&255}while(0);ra=Ha+na+Ja+La+Na|0;oa=la+-1|0;ua=(la|0)<4;wa=(ka|0)<3;do if(wa|ua)Pa=0;else{if(((f[K>>2]|0)+-3|0)<(la|0)){Pa=0;break}if(((f[R>>2]|0)+-3|0)<=(ka|0)){Pa=0;break}pa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ka)|0)+oa|0;Aa=b[pa>>0]|0;if((Aa&255)>2)Qa=Aa;else{Aa=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ka)|0)+oa|0,W,0)|0;Da=(Aa&255|0)==0?0:Aa&255;b[pa>>0]=Da;Qa=Da}Pa=Qa&255}while(0);na=la+1|0;Da=(na|0)<3;do if(wa|Da)Ra=0;else{if(((f[K>>2]|0)+-3|0)<=(na|0)){Ra=0;break}if(((f[R>>2]|0)+-3|0)<=(ka|0)){Ra=0;break}pa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ka)|0)+na|0;Aa=b[pa>>0]|0;if((Aa&255)>2)Sa=Aa;else{Aa=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ka)|0)+na|0,W,0)|0;Ga=(Aa&255|0)==0?0:Aa&255;b[pa>>0]=Ga;Sa=Ga}Ra=Sa&255}while(0);wa=Ra+Pa|0;Ga=ka+1|0;pa=(la|0)<3;Aa=(Ga|0)<3;do if(pa|Aa)Ta=0;else{if(((f[K>>2]|0)+-3|0)<=(la|0)){Ta=0;break}if(((f[R>>2]|0)+-3|0)<=(Ga|0)){Ta=0;break}ya=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Ga)|0)+la|0;Ua=b[ya>>0]|0;if((Ua&255)>2)Va=Ua;else{Ua=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Ga)|0)+la|0,W,0)|0;Wa=(Ua&255|0)==0?0:Ua&255;b[ya>>0]=Wa;Va=Wa}Ta=Va&255}while(0);Wa=wa+Ta|0;ya=ka+-1|0;Ua=(ka|0)<4;do if(Ua|pa)Xa=0;else{if(((f[K>>2]|0)+-3|0)<=(la|0)){Xa=0;break}if(((f[R>>2]|0)+-3|0)<(ka|0)){Xa=0;break}Ya=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ya)|0)+la|0;Za=b[Ya>>0]|0;if((Za&255)>2)_a=Za;else{Za=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ya)|0)+la|0,W,0)|0;$a=(Za&255|0)==0?0:Za&255;b[Ya>>0]=$a;_a=$a}Xa=_a&255}while(0);pa=Wa+Xa<<1;do if(Aa|Da)ab=0;else{if(((f[K>>2]|0)+-3|0)<=(na|0)){ab=0;break}if(((f[R>>2]|0)+-3|0)<=(Ga|0)){ab=0;break}wa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Ga)|0)+na|0;$a=b[wa>>0]|0;if(($a&255)>2)bb=$a;else{$a=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Ga)|0)+na|0,W,0)|0;Ya=($a&255|0)==0?0:$a&255;b[wa>>0]=Ya;bb=Ya}ab=bb&255}while(0);do if(ua|Aa)cb=0;else{if(((f[K>>2]|0)+-3|0)<(la|0)){cb=0;break}if(((f[R>>2]|0)+-3|0)<=(Ga|0)){cb=0;break}Wa=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,Ga)|0)+oa|0;Ya=b[Wa>>0]|0;if((Ya&255)>2)db=Ya;else{Ya=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,Ga)|0)+oa|0,W,0)|0;wa=(Ya&255|0)==0?0:Ya&255;b[Wa>>0]=wa;db=wa}cb=db&255}while(0);do if(Ua|Da)eb=0;else{if(((f[K>>2]|0)+-3|0)<=(na|0)){eb=0;break}if(((f[R>>2]|0)+-3|0)<(ka|0)){eb=0;break}Ga=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ya)|0)+na|0;Aa=b[Ga>>0]|0;if((Aa&255)>2)fb=Aa;else{Aa=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ya)|0)+na|0,W,0)|0;wa=(Aa&255|0)==0?0:Aa&255;b[Ga>>0]=wa;fb=wa}eb=fb&255}while(0);do if(Ua|ua)gb=0;else{if(((f[K>>2]|0)+-3|0)<(la|0)){gb=0;break}if(((f[R>>2]|0)+-3|0)<(ka|0)){gb=0;break}na=(f[S>>2]|0)+(Y(f[f[T>>2]>>2]|0,ya)|0)+oa|0;Da=b[na>>0]|0;if((Da&255)>2)hb=Da;else{Da=sSb((f[U>>2]|0)+(Y(f[f[V>>2]>>2]|0,ya)|0)+oa|0,W,0)|0;wa=(Da&255|0)==0?0:Da&255;b[na>>0]=wa;hb=wa}gb=hb&255}while(0);oa=(ra|0)>(ab+pa+cb+eb+gb|0);ib=oa?Z:ka;jb=oa?ja:la}else{ib=ka;jb=la}if(J>L){kb=J;lb=Z;mb=ja;nb=J}else{kb=L;lb=ib;mb=jb;nb=ma}if((ja|0)<(g|0)){L=kb;ja=ja+1|0;ka=lb;la=mb;ma=nb}else{ob=kb;pb=lb;qb=mb;rb=nb;break}}}else{ob=aa;pb=ba;qb=ca;rb=da}L=+(wMb(r,v,w,1,1.0)|0);if(L>D){$=rb;M=213;break}if(L>ob){sb=L;tb=Z;ub=g;vb=L}else{sb=ob;tb=pb;ub=qb;vb=rb}if((Z|0)<(O|0)){N=sb;X=tb;Z=Z+1|0;_=ub;C=vb}else{M=134;break}}if((M|0)==134){n[l>>2]=vb;wb=sb;xb=tb;yb=ub;break}else if((M|0)==212){n[l>>2]=ma;E=0.0;u=k;return +E}else if((M|0)==213){n[l>>2]=$;E=0.0;u=k;return +E}}else{wb=P;xb=B;yb=Q}while(0);P=+(wMb(r,t,x,1,1.0)|0);if(P>wb){n[l>>2]=P;zb=P;Ab=~~(t+1.0);Bb=O}else{zb=wb;Ab=yb;Bb=xb}if(F){wb=zb;F=z;z=Ab;xb=Bb;t=+n[l>>2];while(1){P=+(wMb(r,+(F|0),x,1,1.0)|0);if(P>wb){Cb=P;Db=O;Eb=F;Fb=P}else{Cb=wb;Db=xb;Eb=z;Fb=t}if((F|0)<(g|0)){wb=Cb;F=F+1|0;z=Eb;xb=Db;t=Fb}else break}n[l>>2]=Fb;Gb=Cb;Hb=Eb;Ib=Db}else{Gb=zb;Hb=Ab;Ib=Bb}zb=+(wMb(r,v,x,1,1.0)|0);if(zb>Gb){n[l>>2]=zb;Jb=zb;Kb=O;Lb=g}else{Jb=Gb;Kb=Ib;Lb=Hb}Hb=Lb+-1|0;Ib=Kb+-1|0;g=(Lb|0)<4;O=(Kb|0)<4;if((!(O|g)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>=(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>=(Kb|0):0){r=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Ib)|0)+Hb|0;Bb=b[r>>0]|0;if((Bb&255)>2)Mb=Bb;else{Bb=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Ib)|0)+Hb|0,c+(s*328|0)+228|0,0)|0;Ab=(Bb&255|0)==0?0:Bb&255;b[r>>0]=Ab;Mb=Ab}Nb=Mb&255}else Nb=0;Mb=(Lb|0)<3;if((!(O|Mb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>=(Kb|0):0){Ab=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Ib)|0)+Lb|0;r=b[Ab>>0]|0;if((r&255)>2)Ob=r;else{r=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Ib)|0)+Lb|0,c+(s*328|0)+228|0,0)|0;Bb=(r&255|0)==0?0:r&255;b[Ab>>0]=Bb;Ob=Bb}Pb=Ob&255}else Pb=0;Ob=Lb+1|0;Bb=(Ob|0)<3;if((!(O|Bb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Ob|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>=(Kb|0):0){O=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Ib)|0)+Ob|0;Ab=b[O>>0]|0;if((Ab&255)>2)Qb=Ab;else{Ab=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Ib)|0)+Ob|0,c+(s*328|0)+228|0,0)|0;Ib=(Ab&255|0)==0?0:Ab&255;b[O>>0]=Ib;Qb=Ib}Rb=Qb&255}else Rb=0;Qb=(Kb|0)<3;if((!(Qb|Bb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Ob|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Kb|0):0){Ib=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Kb)|0)+Ob|0;O=b[Ib>>0]|0;if((O&255)>2)Sb=O;else{O=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Kb)|0)+Ob|0,c+(s*328|0)+228|0,0)|0;Ab=(O&255|0)==0?0:O&255;b[Ib>>0]=Ab;Sb=Ab}Tb=Sb&255}else Tb=0;if((!(Qb|Mb)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Kb|0):0){Sb=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Kb)|0)+Lb|0;Ab=b[Sb>>0]|0;if((Ab&255)>2)Ub=Ab;else{Ab=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Kb)|0)+Lb|0,c+(s*328|0)+228|0,0)|0;Ib=(Ab&255|0)==0?0:Ab&255;b[Sb>>0]=Ib;Ub=Ib}Vb=Ub&255}else Vb=0;if((!(Qb|g)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>=(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Kb|0):0){Qb=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Kb)|0)+Hb|0;Ub=b[Qb>>0]|0;if((Ub&255)>2)Wb=Ub;else{Ub=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Kb)|0)+Hb|0,c+(s*328|0)+228|0,0)|0;Ib=(Ub&255|0)==0?0:Ub&255;b[Qb>>0]=Ib;Wb=Ib}Xb=Wb&255}else Xb=0;Wb=Kb+1|0;Ib=(Wb|0)<3;if((!(g|Ib)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>=(Lb|0):0)?((f[c+(s*328|0)+8>>2]|0)+-3|0)>(Wb|0):0){g=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Wb)|0)+Hb|0;Qb=b[g>>0]|0;if((Qb&255)>2)Yb=Qb;else{Qb=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Wb)|0)+Hb|0,c+(s*328|0)+228|0,0)|0;Hb=(Qb&255|0)==0?0:Qb&255;b[g>>0]=Hb;Yb=Hb}Zb=Yb&255}else Zb=0;do if(!(Mb|Ib)?((f[c+(s*328|0)+12>>2]|0)+-3|0)>(Lb|0):0){if(((f[c+(s*328|0)+8>>2]|0)+-3|0)<=(Wb|0)){_b=0;break}Yb=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Wb)|0)+Lb|0;Hb=b[Yb>>0]|0;if((Hb&255)>2)$b=Hb;else{Hb=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Wb)|0)+Lb|0,c+(s*328|0)+228|0,0)|0;g=(Hb&255|0)==0?0:Hb&255;b[Yb>>0]=g;$b=g}_b=$b&255}else _b=0;while(0);do if(Ib|Bb)ac=0;else{if(((f[c+(s*328|0)+12>>2]|0)+-3|0)<=(Ob|0)){ac=0;break}if(((f[c+(s*328|0)+8>>2]|0)+-3|0)<=(Wb|0)){ac=0;break}$b=(f[c+(s*328|0)+72>>2]|0)+(Y(f[f[c+(s*328|0)+100>>2]>>2]|0,Wb)|0)+Ob|0;Mb=b[$b>>0]|0;if((Mb&255)>2)bc=Mb;else{Mb=sSb((f[c+(s*328|0)+16>>2]|0)+(Y(f[f[c+(s*328|0)+44>>2]>>2]|0,Wb)|0)+Ob|0,c+(s*328|0)+228|0,0)|0;g=(Mb&255|0)==0?0:Mb&255;b[$b>>0]=g;bc=g}ac=bc&255}while(0);Gb=+xMb(a,Nb,Xb,Zb,Pb,Vb,_b,Rb,Tb,ac,m,o);n[p>>2]=Gb;zb=+(Lb|0)+ +n[m>>2];x=+(d|0);v=+(Kb|0)+ +n[o>>2];if(q){n[i>>2]=(zb*6.0+1.0)*.125-x;cc=(v*6.0+1.0)*.125}else{n[i>>2]=(zb*4.0+-1.0)/6.0-x;cc=(v*4.0+-1.0)/6.0}v=cc-+(e|0);n[j>>2]=v;cc=+n[i>>2];if(!(cc>1.0))if(cc<-1.0){dc=-1.0;M=204}else{ec=1;fc=v}else{dc=1.0;M=204}if((M|0)==204){n[i>>2]=dc;ec=0;fc=+n[j>>2]}do if(fc>1.0){n[j>>2]=1.0;b[h>>0]=1;gc=Jb}else{if(fc<-1.0){n[j>>2]=-1.0;b[h>>0]=1;gc=Jb;break}b[h>>0]=1;if(!ec){gc=Jb;break}gc=Gb<Jb?+n[l>>2]:+n[p>>2]}while(0);E=gc;u=k;return +E}function zMb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0;k=u;u=u+32|0;l=k+20|0;m=k+16|0;o=k+12|0;p=k+8|0;q=k+4|0;r=k;b[j>>0]=1;s=a+4|0;t=f[s>>2]|0;v=(d|0)<3;w=(e|0)<3;x=v|w;if((!x?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){y=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+d|0;z=b[y>>0]|0;if((z&255)>2)A=z;else{z=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+d|0,t+(c*328|0)+228|0,0)|0;B=(z&255|0)==0?0:z&255;b[y>>0]=B;A=B}C=A&255}else C=0;n[l>>2]=0.0;n[m>>2]=0.0;D=+AMb(a,c,d,e,C,j,l,m);if(!(b[j>>0]|0)){E=0.0;u=k;return +E}if(!(c&1)){A=(c|0)==0;do if(A){B=f[s>>2]|0;y=d+-1|0;z=e+-1|0;if((!x?((f[B+12>>2]|0)+-2|0)>=(d|0):0)?((f[B+8>>2]|0)+-2|0)>=(e|0):0){F=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,z)|0)+y|0,B+128|0,0)|0;G=(F|0)>0?F:0}else G=0;F=(d|0)<2;if((!(F|w)?((f[B+12>>2]|0)+-2|0)>(d|0):0)?((f[B+8>>2]|0)+-2|0)>=(e|0):0){H=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,z)|0)+d|0,B+128|0,0)|0;I=(H|0)>0?H:0}else I=0;H=I>>>0<G>>>0?G:I;J=d+1|0;K=(J|0)<2;if((!(K|w)?((f[B+12>>2]|0)+-2|0)>(J|0):0)?((f[B+8>>2]|0)+-2|0)>=(e|0):0){L=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,z)|0)+J|0,B+128|0,0)|0;M=(L|0)>0?L:0}else M=0;L=(M|0)<(H|0)?H:M;H=(e|0)<2;if((!(K|H)?((f[B+12>>2]|0)+-2|0)>(J|0):0)?((f[B+8>>2]|0)+-2|0)>(e|0):0){N=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,e)|0)+J|0,B+128|0,0)|0;O=(N|0)>0?N:0}else O=0;N=(O|0)<(L|0)?L:O;if((!(F|H)?((f[B+12>>2]|0)+-2|0)>(d|0):0)?((f[B+8>>2]|0)+-2|0)>(e|0):0){L=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,e)|0)+d|0,B+128|0,0)|0;P=(L|0)>0?L:0}else P=0;L=(P|0)<(N|0)?N:P;if((!(v|H)?((f[B+12>>2]|0)+-2|0)>=(d|0):0)?((f[B+8>>2]|0)+-2|0)>(e|0):0){H=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,e)|0)+y|0,B+128|0,0)|0;Q=(H|0)>0?H:0}else Q=0;H=(Q|0)<(L|0)?L:Q;L=e+1|0;N=(L|0)<2;if((!(v|N)?((f[B+12>>2]|0)+-2|0)>=(d|0):0)?((f[B+8>>2]|0)+-2|0)>(L|0):0){R=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,L)|0)+y|0,B+128|0,0)|0;S=(R|0)>0?R:0}else S=0;R=(S|0)<(H|0)?H:S;if((!(F|N)?((f[B+12>>2]|0)+-2|0)>(d|0):0)?((f[B+8>>2]|0)+-2|0)>(L|0):0){F=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,L)|0)+d|0,B+128|0,0)|0;T=(F|0)>0?F:0}else T=0;F=(T|0)<(R|0)?R:T;if((!(K|N)?((f[B+12>>2]|0)+-2|0)>(J|0):0)?((f[B+8>>2]|0)+-2|0)>(L|0):0){N=pSb((f[B+16>>2]|0)+(Y(f[f[B+44>>2]>>2]|0,L)|0)+J|0,B+128|0,0)|0;U=(N|0)>0?N:0}else U=0;+xMb(a,G,Q,S,I,P,T,M,O,U,o,p);V=+(((U|0)<(F|0)?F:U)|0);W=y;X=z}else{Z=+yMb(a,c,d,e,C,j,o,p);if(b[j>>0]|0){V=Z;W=d+-1|0;X=e+-1|0;break}E=0.0;u=k;return +E}while(0);U=(d|0)<4;O=(e|0)<4;if((!(U|O)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){M=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,X)|0)+W|0;T=b[M>>0]|0;if((T&255)>2)_=T;else{T=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,X)|0)+W|0,t+(c*328|0)+228|0,0)|0;P=(T&255|0)==0?0:T&255;b[M>>0]=P;_=P}$=_&255}else $=0;if((!(v|O)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){_=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,X)|0)+d|0;P=b[_>>0]|0;if((P&255)>2)aa=P;else{P=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,X)|0)+d|0,t+(c*328|0)+228|0,0)|0;M=(P&255|0)==0?0:P&255;b[_>>0]=M;aa=M}ba=aa&255}else ba=0;aa=d+1|0;M=(aa|0)<3;if((!(M|O)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(aa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){O=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,X)|0)+aa|0;_=b[O>>0]|0;if((_&255)>2)ca=_;else{_=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,X)|0)+aa|0,t+(c*328|0)+228|0,0)|0;X=(_&255|0)==0?0:_&255;b[O>>0]=X;ca=X}da=ca&255}else da=0;if((!(M|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(aa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){ca=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+aa|0;X=b[ca>>0]|0;if((X&255)>2)ea=X;else{X=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+aa|0,t+(c*328|0)+228|0,0)|0;O=(X&255|0)==0?0:X&255;b[ca>>0]=O;ea=O}fa=ea&255}else fa=0;if((!x?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){ea=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+d|0;O=b[ea>>0]|0;if((O&255)>2)ga=O;else{O=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+d|0,t+(c*328|0)+228|0,0)|0;ca=(O&255|0)==0?0:O&255;b[ea>>0]=ca;ga=ca}ha=ga&255}else ha=0;if((!(U|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){ga=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+W|0;ca=b[ga>>0]|0;if((ca&255)>2)ia=ca;else{ca=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+W|0,t+(c*328|0)+228|0,0)|0;ea=(ca&255|0)==0?0:ca&255;b[ga>>0]=ea;ia=ea}ja=ia&255}else ja=0;ia=e+1|0;ea=(ia|0)<3;if((!(U|ea)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(ia|0):0){U=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,ia)|0)+W|0;ga=b[U>>0]|0;if((ga&255)>2)ka=ga;else{ga=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,ia)|0)+W|0,t+(c*328|0)+228|0,0)|0;W=(ga&255|0)==0?0:ga&255;b[U>>0]=W;ka=W}la=ka&255}else la=0;if((!(v|ea)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(ia|0):0){ka=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,ia)|0)+d|0;W=b[ka>>0]|0;if((W&255)>2)ma=W;else{W=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,ia)|0)+d|0,t+(c*328|0)+228|0,0)|0;U=(W&255|0)==0?0:W&255;b[ka>>0]=U;ma=U}na=ma&255}else na=0;if((!(M|ea)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(aa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(ia|0):0){ea=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,ia)|0)+aa|0;M=b[ea>>0]|0;if((M&255)>2)oa=M;else{M=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,ia)|0)+aa|0,t+(c*328|0)+228|0,0)|0;aa=(M&255|0)==0?0:M&255;b[ea>>0]=aa;oa=aa}pa=oa&255}else pa=0;Z=+xMb(a,$,ja,la,ba,ha,na,da,fa,pa,q,r);qa=+(C|0);ra=qa<Z?Z:qa;pa=~~(V*1024.0+.5);fa=~~(ra*1024.0+.5);da=~~(D*1024.0+.5);do if(A){na=(pa<<1)-(fa<<2)+(da<<1)|0;if((na|0)>-1){if(!(!(ra>=V)|!(ra>=D))){sa=1.0;ta=ra;ua=120;break}if(!(!(V>=D)|!(V>=ra))){sa=.699999988079071;ta=V;ua=120;break}if(!(!(D>=V)|!(D>=ra))){ua=121;break}}qa=+((Y(pa,-5)|0)+(Y(da,-3)|0)+(fa<<3)|0);Z=-qa/+(na<<1|0);if(!(Z<.699999988079071))if(Z>1.5)va=1.5;else va=Z;else va=.699999988079071;wa=(qa*va+(+(((pa-fa|0)*3|0)+da|0)+va*(+(na|0)*va)))*.0009765625;xa=va;ua=122}else{na=(pa<<4)+(da<<3)+(Y(fa,-24)|0)|0;if((na|0)>-1){if(!(!(ra>=V)|!(ra>=D))){sa=1.0;ta=ra;ua=120;break}if(!(!(V>=D)|!(V>=ra))){sa=.75;ta=V;ua=120;break}if(!(!(D>=V)|!(D>=ra))){ua=121;break}}qa=+((Y(pa,-40)|0)+(Y(da,-14)|0)+(fa*54|0)|0);Z=-qa/+(na<<1|0);if(!(Z<.75))if(Z>1.5)ya=1.5;else ya=Z;else ya=.75;wa=(qa*ya+(+((pa*24|0)+(da*6|0)+(Y(fa,-27)|0)|0)+ya*(+(na|0)*ya)))/3072.0;xa=ya;ua=122}while(0);if((ua|0)==120){n[i>>2]=sa;za=sa;Aa=ta;Ba=+n[q>>2];Ca=+(d|0);ua=124}else if((ua|0)==121){n[i>>2]=1.5;Da=1.5;Ea=D;Fa=+n[q>>2];Ga=+(d|0);ua=123}else if((ua|0)==122){n[i>>2]=xa;ta=+(d|0);sa=+n[q>>2];if(xa>1.0){Da=xa;Ea=wa;Fa=sa;Ga=ta;ua=123}else{za=xa;Aa=wa;Ba=sa;Ca=ta;ua=124}}do if((ua|0)==123){ta=(1.5-Da)*2.0;sa=1.0-ta;fa=t+(c*328|0)+112|0;da=t+(c*328|0)+116|0;n[g>>2]=+n[da>>2]+ +n[fa>>2]*(Ga+(ta*Fa+sa*+n[l>>2]));Ha=Ea;Ia=fa;Ja=+n[da>>2]+ +n[fa>>2]*(+(e|0)+(ta*+n[r>>2]+sa*+n[m>>2]))}else if((ua|0)==124){sa=+n[o>>2];if(A){ta=(za+-.5)*2.0;wa=1.0-ta;n[g>>2]=Ca+(ta*Ba+wa*sa);Ha=Aa;Ia=t+(c*328|0)+112|0;Ja=+(e|0)+(ta*+n[r>>2]+wa*+n[p>>2]);break}else{wa=(za+-.75)*4.0;ta=1.0-wa;fa=t+(c*328|0)+112|0;da=t+(c*328|0)+116|0;n[g>>2]=(Ca+(wa*Ba+ta*sa))*+n[fa>>2]+ +n[da>>2];Ha=Aa;Ia=fa;Ja=+n[da>>2]+ +n[fa>>2]*(+(e|0)+(wa*+n[r>>2]+ta*+n[p>>2]));break}}while(0);n[h>>2]=Ja;Ka=Ha;La=Ia}else{Ha=+yMb(a,c,d,e,C,j,o,p);if(!(b[j>>0]|0)){E=0.0;u=k;return +E}j=d+-1|0;Ia=e+-1|0;A=(d|0)<4;fa=(e|0)<4;if((!(A|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){da=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Ia)|0)+j|0;pa=b[da>>0]|0;if((pa&255)>2)Ma=pa;else{pa=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Ia)|0)+j|0,t+(c*328|0)+228|0,0)|0;na=(pa&255|0)==0?0:pa&255;b[da>>0]=na;Ma=na}Na=Ma&255}else Na=0;if((!(v|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){Ma=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Ia)|0)+d|0;na=b[Ma>>0]|0;if((na&255)>2)Oa=na;else{na=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Ia)|0)+d|0,t+(c*328|0)+228|0,0)|0;da=(na&255|0)==0?0:na&255;b[Ma>>0]=da;Oa=da}Pa=Oa&255}else Pa=0;Oa=d+1|0;da=(Oa|0)<3;if((!(da|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(Oa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>=(e|0):0){fa=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Ia)|0)+Oa|0;Ma=b[fa>>0]|0;if((Ma&255)>2)Qa=Ma;else{Ma=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Ia)|0)+Oa|0,t+(c*328|0)+228|0,0)|0;Ia=(Ma&255|0)==0?0:Ma&255;b[fa>>0]=Ia;Qa=Ia}Ra=Qa&255}else Ra=0;if((!(da|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(Oa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){Qa=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+Oa|0;Ia=b[Qa>>0]|0;if((Ia&255)>2)Sa=Ia;else{Ia=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+Oa|0,t+(c*328|0)+228|0,0)|0;fa=(Ia&255|0)==0?0:Ia&255;b[Qa>>0]=fa;Sa=fa}Ta=Sa&255}else Ta=0;if((!x?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){x=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+d|0;Sa=b[x>>0]|0;if((Sa&255)>2)Ua=Sa;else{Sa=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+d|0,t+(c*328|0)+228|0,0)|0;fa=(Sa&255|0)==0?0:Sa&255;b[x>>0]=fa;Ua=fa}Va=Ua&255}else Va=0;if((!(A|w)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(e|0):0){w=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,e)|0)+j|0;Ua=b[w>>0]|0;if((Ua&255)>2)Wa=Ua;else{Ua=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,e)|0)+j|0,t+(c*328|0)+228|0,0)|0;fa=(Ua&255|0)==0?0:Ua&255;b[w>>0]=fa;Wa=fa}Xa=Wa&255}else Xa=0;Wa=e+1|0;fa=(Wa|0)<3;if((!(A|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>=(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(Wa|0):0){A=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Wa)|0)+j|0;w=b[A>>0]|0;if((w&255)>2)Ya=w;else{w=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Wa)|0)+j|0,t+(c*328|0)+228|0,0)|0;j=(w&255|0)==0?0:w&255;b[A>>0]=j;Ya=j}Za=Ya&255}else Za=0;if((!(v|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(d|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(Wa|0):0){v=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Wa)|0)+d|0;Ya=b[v>>0]|0;if((Ya&255)>2)_a=Ya;else{Ya=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Wa)|0)+d|0,t+(c*328|0)+228|0,0)|0;j=(Ya&255|0)==0?0:Ya&255;b[v>>0]=j;_a=j}$a=_a&255}else $a=0;if((!(da|fa)?((f[t+(c*328|0)+12>>2]|0)+-3|0)>(Oa|0):0)?((f[t+(c*328|0)+8>>2]|0)+-3|0)>(Wa|0):0){fa=(f[t+(c*328|0)+72>>2]|0)+(Y(f[f[t+(c*328|0)+100>>2]>>2]|0,Wa)|0)+Oa|0;da=b[fa>>0]|0;if((da&255)>2)ab=da;else{da=sSb((f[t+(c*328|0)+16>>2]|0)+(Y(f[f[t+(c*328|0)+44>>2]>>2]|0,Wa)|0)+Oa|0,t+(c*328|0)+228|0,0)|0;Oa=(da&255|0)==0?0:da&255;b[fa>>0]=Oa;ab=Oa}bb=ab&255}else bb=0;Ja=+xMb(a,Na,Xa,Za,Pa,Va,$a,Ra,Ta,bb,q,r);Aa=+(C|0);Ba=Aa<Ja?Ja:Aa;C=~~(Ha*1024.0+.5);bb=~~(Ba*1024.0+.5);Ta=~~(D*1024.0+.5);Ra=(Y(bb,-18)|0)+((C+Ta|0)*9|0)|0;do if((Ra|0)>-1){if(!(Ba>=Ha)|!(Ba>=D))if(!(Ha>=D)|!(Ha>=Ba)){if(!(D>=Ha)|!(D>=Ba)){ua=189;break}n[i>>2]=1.3333333730697632;cb=D;db=4.0;eb=+n[q>>2];fb=+(d|0);ua=194;break}else{gb=.6666666865348816;hb=Ha}else{gb=1.0;hb=Ba}n[i>>2]=gb;ib=hb;jb=gb*3.0;kb=+n[q>>2];lb=+(d|0);ua=195}else ua=189;while(0);if((ua|0)==189){gb=+((Y(C,-21)|0)+(Y(Ta,-15)|0)+(bb*36|0)|0);hb=-gb/+(Ra<<1|0);if(!(hb<.6666666865348816))if(hb>1.3333333730697632)mb=1.3333333730697632;else mb=hb;else mb=.6666666865348816;hb=(gb*mb+(+((C*12|0)+(Ta*6|0)-(bb<<4)|0)+mb*(+(Ra|0)*mb)))*.00048828125;n[i>>2]=mb;gb=mb*3.0;Ba=+(d|0);Ha=+n[q>>2];if(mb>1.0){cb=hb;db=gb;eb=Ha;fb=Ba;ua=194}else{ib=hb;jb=gb;kb=Ha;lb=Ba;ua=195}}if((ua|0)==194){Ba=4.0-db;db=1.0-Ba;q=t+(c*328|0)+112|0;d=t+(c*328|0)+116|0;n[g>>2]=+n[d>>2]+ +n[q>>2]*(fb+(eb*Ba+db*+n[l>>2]));nb=q;ob=d;pb=cb;qb=Ba*+n[r>>2];rb=db*+n[m>>2]}else if((ua|0)==195){db=jb+-2.0;jb=1.0-db;ua=t+(c*328|0)+112|0;m=t+(c*328|0)+116|0;n[g>>2]=+n[m>>2]+ +n[ua>>2]*(lb+(kb*db+jb*+n[o>>2]));nb=ua;ob=m;pb=ib;qb=db*+n[r>>2];rb=jb*+n[p>>2]}n[h>>2]=+n[ob>>2]+ +n[nb>>2]*(+(e|0)+(rb+qb));Ka=pb;La=nb}n[i>>2]=+n[La>>2]*+n[i>>2];E=Ka;u=k;return +E}function AMb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0,ea=0,fa=0.0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0,Oa=0,Pa=0.0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0.0,jb=0.0,kb=0,lb=0.0,mb=0.0;k=u;u=u+32|0;l=k+12|0;m=k+8|0;o=k+4|0;p=k;b[h>>0]=0;q=c+1|0;if((q|0)>=(f[a>>2]|0)){r=$Xc(32)|0;f[l>>2]=r;f[l+8>>2]=-2147483616;f[l+4>>2]=19;s=r;t=461855;v=s+19|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+19>>0]=0;vM(-215,l,461875,461750,1438)}r=f[a+4>>2]|0;t=r+(q*328|0)|0;s=(c&1|0)==0;if(s){c=d<<2;v=e<<2;w=+(c+-3|0)/6.0;x=+(c|1|0)/6.0;y=+(v+-3|0)/6.0;z=+(v|1|0)/6.0}else{v=d*6|0;c=e*6|0;w=+(v+-4|0)*.125;x=+(v+2|0)*.125;y=+(c+-4|0)*.125;z=+(c+2|0)*.125}c=~~w;v=c+1|0;A=~~y;B=A+1|0;C=+(wMb(t,w,y,1,1.0)|0);n[l>>2]=C;D=+(g|0);if(C>D){E=0.0;u=k;return +E}F=~~x;G=(c|0)<(F|0);do if(G){H=C;c=v;I=v;J=+n[l>>2];while(1){K=+(wMb(t,+(I|0),y,1,1.0)|0);if(K>D)break;L=K>H;M=L?K:J;H=L?K:H;c=L?I:c;if((I|0)>=(F|0)){N=11;break}else{I=I+1|0;J=M}}if((N|0)==11){n[l>>2]=M;O=H;P=c;break}n[l>>2]=J;E=0.0;u=k;return +E}else{O=C;P=v}while(0);C=+(wMb(t,x,y,1,1.0)|0);if(C>D){E=0.0;u=k;return +E}if(C>O){n[l>>2]=C;Q=C;R=F}else{Q=O;R=P}P=~~z;do if((A|0)<(P|0)){I=~~(w+1.0);L=r+(q*328|0)+12|0;S=r+(q*328|0)+8|0;T=r+(q*328|0)+72|0;U=r+(q*328|0)+100|0;V=r+(q*328|0)+16|0;W=r+(q*328|0)+44|0;X=r+(q*328|0)+228|0;Z=(g|0)<0;O=Q;_=B;$=B;aa=R;C=+n[l>>2];a:while(1){y=+($|0);M=+(wMb(t,w,y,1,1.0)|0);if(M>D){ba=C;N=118;break}if(M>O){ca=M;da=$;ea=I;fa=M}else{ca=O;da=_;ea=aa;fa=C}b:do if(G){if(($|0)<3){M=ca;ga=v;ha=da;ia=ea;ja=fa;while(1){if(Z){N=116;break a}if(M<0.0){ka=0.0;la=$;ma=ga;na=0.0}else{ka=M;la=ha;ma=ia;na=ja}if((ga|0)<(F|0)){M=ka;ga=ga+1|0;ha=la;ia=ma;ja=na}else{oa=ka;pa=la;qa=ma;ra=na;break b}}}else{sa=fa;ta=v;ua=da;va=ea}while(1){if(((ta|0)>=3?((f[L>>2]|0)+-3|0)>(ta|0):0)?((f[S>>2]|0)+-3|0)>($|0):0){ia=(f[T>>2]|0)+(Y(f[f[U>>2]>>2]|0,$)|0)+ta|0;ha=b[ia>>0]|0;if((ha&255)>2)wa=ha;else{ha=sSb((f[V>>2]|0)+(Y(f[f[W>>2]>>2]|0,$)|0)+ta|0,X,0)|0;ga=(ha&255|0)==0?0:ha&255;b[ia>>0]=ga;wa=ga}xa=wa&255}else xa=0;M=+(xa|0);if(M>D){N=117;break a}ga=M>sa;K=ga?M:sa;ia=ga?$:ua;ha=ga?ta:va;if((ta|0)<(F|0)){sa=K;ta=ta+1|0;ua=ia;va=ha}else{oa=K;pa=ia;qa=ha;ra=K;break}}}else{oa=ca;pa=da;qa=ea;ra=fa}while(0);K=+(wMb(t,x,y,1,1.0)|0);if(K>D){ba=ra;N=118;break}if(K>oa){ya=K;za=$;Aa=F;Ba=K}else{ya=oa;za=pa;Aa=qa;Ba=ra}if(($|0)<(P|0)){O=ya;_=za;$=$+1|0;aa=Aa;C=Ba}else{N=38;break}}if((N|0)==38){n[l>>2]=Ba;Ca=ya;Da=za;Ea=Aa;break}else if((N|0)==116){n[l>>2]=ja;E=0.0;u=k;return +E}else if((N|0)==117){n[l>>2]=sa;E=0.0;u=k;return +E}else if((N|0)==118){n[l>>2]=ba;E=0.0;u=k;return +E}}else{Ca=Q;Da=B;Ea=R}while(0);Q=+(wMb(t,w,z,1,1.0)|0);if(Q>Ca){n[l>>2]=Q;Fa=Q;Ga=~~(w+1.0);Ha=P}else{Fa=Ca;Ga=Ea;Ha=Da}if(G){Ca=Fa;G=v;v=Ga;Da=Ha;w=+n[l>>2];while(1){Q=+(wMb(t,+(G|0),z,1,1.0)|0);if(Q>Ca){Ia=Q;Ja=G;Ka=P;La=Q}else{Ia=Ca;Ja=v;Ka=Da;La=w}if((G|0)<(F|0)){Ca=Ia;G=G+1|0;v=Ja;Da=Ka;w=La}else break}n[l>>2]=La;Ma=Ia;Na=Ja;Oa=Ka}else{Ma=Fa;Na=Ga;Oa=Ha}Fa=+(wMb(t,x,z,1,1.0)|0);if(Fa>Ma){n[l>>2]=Fa;Pa=Fa;Qa=F;Ra=P}else{Pa=Ma;Qa=Na;Ra=Oa}Oa=Qa+-1|0;Na=Ra+-1|0;P=(Qa|0)<4;F=(Ra|0)<4;if((!(F|P)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>=(Qa|0):0)?((f[r+(q*328|0)+8>>2]|0)+-3|0)>=(Ra|0):0){t=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,Na)|0)+Oa|0;Ha=b[t>>0]|0;if((Ha&255)>2)Sa=Ha;else{Ha=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,Na)|0)+Oa|0,r+(q*328|0)+228|0,0)|0;Ga=(Ha&255|0)==0?0:Ha&255;b[t>>0]=Ga;Sa=Ga}Ta=Sa&255}else Ta=0;Sa=(Qa|0)<3;if((!(F|Sa)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>(Qa|0):0)?((f[r+(q*328|0)+8>>2]|0)+-3|0)>=(Ra|0):0){Ga=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,Na)|0)+Qa|0;t=b[Ga>>0]|0;if((t&255)>2)Ua=t;else{t=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,Na)|0)+Qa|0,r+(q*328|0)+228|0,0)|0;Ha=(t&255|0)==0?0:t&255;b[Ga>>0]=Ha;Ua=Ha}Va=Ua&255}else Va=0;Ua=Qa+1|0;Ha=(Ua|0)<3;if((!(F|Ha)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>(Ua|0):0)?((f[r+(q*328|0)+8>>2]|0)+-3|0)>=(Ra|0):0){F=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,Na)|0)+Ua|0;Ga=b[F>>0]|0;if((Ga&255)>2)Wa=Ga;else{Ga=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,Na)|0)+Ua|0,r+(q*328|0)+228|0,0)|0;Na=(Ga&255|0)==0?0:Ga&255;b[F>>0]=Na;Wa=Na}Xa=Wa&255}else Xa=0;Wa=(Ra|0)<3;if((!(Wa|Ha)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>(Ua|0):0)?((f[r+(q*328|0)+8>>2]|0)+-3|0)>(Ra|0):0){Na=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,Ra)|0)+Ua|0;F=b[Na>>0]|0;if((F&255)>2)Ya=F;else{F=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,Ra)|0)+Ua|0,r+(q*328|0)+228|0,0)|0;Ga=(F&255|0)==0?0:F&255;b[Na>>0]=Ga;Ya=Ga}Za=Ya&255}else Za=0;if((!(Wa|Sa)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>(Qa|0):0)?((f[r+(q*328|0)+8>>2]|0)+-3|0)>(Ra|0):0){Ya=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,Ra)|0)+Qa|0;Ga=b[Ya>>0]|0;if((Ga&255)>2)_a=Ga;else{Ga=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,Ra)|0)+Qa|0,r+(q*328|0)+228|0,0)|0;Na=(Ga&255|0)==0?0:Ga&255;b[Ya>>0]=Na;_a=Na}$a=_a&255}else $a=0;if((!(Wa|P)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>=(Qa|0):0)?((f[r+(q*328|0)+8>>2]|0)+-3|0)>(Ra|0):0){Wa=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,Ra)|0)+Oa|0;_a=b[Wa>>0]|0;if((_a&255)>2)ab=_a;else{_a=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,Ra)|0)+Oa|0,r+(q*328|0)+228|0,0)|0;Na=(_a&255|0)==0?0:_a&255;b[Wa>>0]=Na;ab=Na}bb=ab&255}else bb=0;ab=Ra+1|0;Na=(ab|0)<3;if((!(P|Na)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>=(Qa|0):0)?((f[r+(q*328|0)+8>>2]|0)+-3|0)>(ab|0):0){P=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,ab)|0)+Oa|0;Wa=b[P>>0]|0;if((Wa&255)>2)cb=Wa;else{Wa=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,ab)|0)+Oa|0,r+(q*328|0)+228|0,0)|0;Oa=(Wa&255|0)==0?0:Wa&255;b[P>>0]=Oa;cb=Oa}db=cb&255}else db=0;do if(!(Sa|Na)?((f[r+(q*328|0)+12>>2]|0)+-3|0)>(Qa|0):0){if(((f[r+(q*328|0)+8>>2]|0)+-3|0)<=(ab|0)){eb=0;break}cb=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,ab)|0)+Qa|0;Oa=b[cb>>0]|0;if((Oa&255)>2)fb=Oa;else{Oa=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,ab)|0)+Qa|0,r+(q*328|0)+228|0,0)|0;P=(Oa&255|0)==0?0:Oa&255;b[cb>>0]=P;fb=P}eb=fb&255}else eb=0;while(0);do if(Na|Ha)gb=0;else{if(((f[r+(q*328|0)+12>>2]|0)+-3|0)<=(Ua|0)){gb=0;break}if(((f[r+(q*328|0)+8>>2]|0)+-3|0)<=(ab|0)){gb=0;break}fb=(f[r+(q*328|0)+72>>2]|0)+(Y(f[f[r+(q*328|0)+100>>2]>>2]|0,ab)|0)+Ua|0;Sa=b[fb>>0]|0;if((Sa&255)>2)hb=Sa;else{Sa=sSb((f[r+(q*328|0)+16>>2]|0)+(Y(f[f[r+(q*328|0)+44>>2]>>2]|0,ab)|0)+Ua|0,r+(q*328|0)+228|0,0)|0;P=(Sa&255|0)==0?0:Sa&255;b[fb>>0]=P;hb=P}gb=hb&255}while(0);Ma=+xMb(a,Ta,bb,db,Va,$a,eb,Xa,Za,gb,m,o);n[p>>2]=Ma;Fa=+(Qa|0)+ +n[m>>2];z=+(Ra|0)+ +n[o>>2];x=+(d|0);if(s){n[i>>2]=(Fa*6.0+1.0)*.25-x;ib=(z*6.0+1.0)*.25}else{n[i>>2]=(Fa*8.0+1.0)/6.0-x;ib=(z*8.0+1.0)/6.0}z=ib-+(e|0);n[j>>2]=z;ib=+n[i>>2];if(!(ib>1.0))if(ib<-1.0){jb=-1.0;N=108}else{kb=1;lb=z}else{jb=1.0;N=108}if((N|0)==108){n[i>>2]=jb;kb=0;lb=+n[j>>2]}do if(lb>1.0){n[j>>2]=1.0;b[h>>0]=1;mb=Pa}else{if(lb<-1.0){n[j>>2]=-1.0;b[h>>0]=1;mb=Pa;break}b[h>>0]=1;if(!kb){mb=Pa;break}mb=Ma<Pa?+n[l>>2]:+n[p>>2]}while(0);E=mb;u=k;return +E}function BMb(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=+g;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;a=u;u=u+16|0;i=a;j=f[c+16>>2]|0;if(!j){k=$Xc(16)|0;f[i>>2]=k;l=i+8|0;f[l>>2]=-2147483632;m=i+4|0;f[m>>2]=12;n=k;o=461919;p=n+12|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+12|0;b[q>>0]=0;vM(-215,i,502066,461750,2204)}r=f[c+4>>2]|0;if((r|0)<3)s=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{t=f[c+40>>2]|0;v=0;w=1;while(1){x=Y(f[t+(v<<2)>>2]|0,w)|0;v=v+1|0;if((v|0)==(r|0)){s=x;break}else w=x}}if((r|0)==0|(s|0)==0){k=$Xc(16)|0;f[i>>2]=k;l=i+8|0;f[l>>2]=-2147483632;m=i+4|0;f[m>>2]=12;n=k;o=461919;p=n+12|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+12|0;b[q>>0]=0;vM(-215,i,502066,461750,2204)}q=~~d;k=q-(+(q|0)>d&1)|0;q=~~e;m=q-(+(q|0)>e&1)|0;q=c+12|0;y=g*.5;g=y*(y*4.0);if(y<.5){c=~~((d-+(k|0))*1024.0);l=~~((e-+(m|0))*1024.0);s=1024-c|0;r=f[q>>2]|0;w=j+k+(Y(r,m)|0)|0;m=Y(h[w>>0]|0,s)|0;k=w+1|0;w=Y(h[k>>0]|0,c)|0;v=k+r|0;r=Y(h[v>>0]|0,c)|0;z=((Y(w+m|0,1024-l|0)|0)+512+(Y((Y(h[v+-1>>0]|0,s)|0)+r|0,l)|0)|0)/1048576|0;A=z&255;u=a;return A|0}l=~~(4194304.0/g);B=+(l|0);r=~~(g*B*.0009765625);if(!r){s=$Xc(16)|0;f[i>>2]=s;f[i+8>>2]=-2147483632;f[i+4>>2]=13;n=s;o=461823;p=n+13|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[s+13>>0]=0;vM(-215,i,502066,461750,2240)}g=d-y;C=y+d;d=e-y;D=y+e;i=~~(g+.5);s=~~(d+.5);o=~~(C+.5);n=~~(D+.5);e=+(i|0)-g+.5;g=+(s|0)-d+.5;d=C-+(o|0)+.5;C=D-+(n|0)+.5;p=o-i|0;o=1-p|0;v=n+~s|0;n=~~(B*(d*g));m=~~(B*(d*C));w=~~(B*(e*C));c=~~(B*e);k=~~(B*g);t=~~(B*d);x=~~(B*C);E=f[q>>2]|0;q=j+i+(Y(E,s)|0)|0;s=Y(h[q>>0]|0,~~(B*(e*g)))|0;i=q+1|0;j=q+p|0;F=(p|0)>1;G=h[i>>0]|0;if(F){H=s;I=i;i=G;while(1){J=(Y(i,k)|0)+H|0;K=I+1|0;L=h[K>>0]|0;if(K>>>0<j>>>0){H=J;I=K;i=L}else{M=J;N=L;O=I;break}}}else{M=s;N=G;O=q}q=(Y(N,n)|0)+M|0;M=o+-1+E|0;o=O+1+M|0;O=Y(E,v)|0;v=o+O|0;E=h[o>>0]|0;if((O|0)>0){O=o;n=q;N=E;while(1){G=(Y(N,c)|0)+n|0;s=O+1|0;I=O+p|0;i=h[s>>0]|0;if(F){H=s;s=G;j=i;while(1){k=(Y(j,l)|0)+s|0;L=H+1|0;J=h[L>>0]|0;if(L>>>0<I>>>0){H=L;s=k;j=J}else{P=k;Q=J;R=H;break}}}else{P=G;Q=i;R=O}H=(Y(Q,t)|0)+P|0;j=R+1+M|0;s=h[j>>0]|0;if(j>>>0<v>>>0){O=j;n=H;N=s}else{S=H;T=j;U=s;break}}}else{S=q;T=o;U=E}E=(Y(U,w)|0)+S|0;S=T+1|0;w=T+p|0;p=h[S>>0]|0;if(F){F=S;S=E;T=p;while(1){U=(Y(T,x)|0)+S|0;F=F+1|0;o=h[F>>0]|0;if(F>>>0>=w>>>0){V=U;W=o;break}else{S=U;T=o}}}else{V=E;W=p}z=((V+((r|0)/2|0)+(Y(W,m)|0)|0)/(r|0)|0|0)/1024|0;A=z&255;u=a;return A|0}function CMb(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+224|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=a+48|0;o=a+44|0;f[o>>2]=m;f[m>>2]=0;f[a+52>>2]=0;p=a+56|0;q=a+64|0;r=a+96|0;k=a+60|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[r>>2]=q;q=a+104|0;f[a+100>>2]=q;f[q>>2]=0;f[a+108>>2]=0;f[p>>2]=1124007936;q=a+120|0;f[q>>2]=0;r=a+124|0;f[r>>2]=0;if((a|0)!=(b|0)){k=b+36|0;l=f[k>>2]|0;if(l){s=l+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+36|0;l=f[s>>2]|0;if((l|0)!=0?(t=l+12|0,l=f[t>>2]|0,f[t>>2]=l+-1,(l|0)==1):0){V$(a);v=s}else v=s}else v=a+36|0;f[v>>2]=0;s=a+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[h>>2]|0)>0){l=f[j>>2]|0;j=0;do{f[l+(j<<2)>>2]=0;j=j+1|0;w=f[h>>2]|0}while((j|0)<(w|0));f[a>>2]=f[b>>2];if((w|0)<3)x=12;else x=14}else{f[a>>2]=f[b>>2];x=12}if((x|0)==12){w=f[b+4>>2]|0;if((w|0)<3){f[h>>2]=w;f[i>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];i=f[b+44>>2]|0;w=f[o>>2]|0;f[w>>2]=f[i>>2];f[w+4>>2]=f[i+4>>2]}else x=14}if((x|0)==14)U$(a,b);f[s>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[v>>2]=f[k>>2]}p$(g,f[b+8>>2]|0,f[b+12>>2]|0,0);b=f[g>>2]|0;ei[f[(f[b>>2]|0)+12>>2]&511](b,g,p,0);Zj(g);n[a+112>>2]=c;n[a+116>>2]=d;JRb(g,1,0,3);p=f[g>>2]|0;b=g+4|0;g=f[b>>2]|0;if(g|0)TXc(g);f[q>>2]=p;p=f[r>>2]|0;f[r>>2]=g;if(p|0)UXc(p);p=f[b>>2]|0;if(!p){y=a+128|0;z=f[m>>2]|0;nSb(y,z,0);A=a+228|0;B=f[m>>2]|0;nSb(A,B,3);u=e;return}UXc(p);y=a+128|0;z=f[m>>2]|0;nSb(y,z,0);A=a+228|0;B=f[m>>2]|0;nSb(A,B,3);u=e;return}function DMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f[a>>2]=f[b>>2];c=b+4|0;f[a+4>>2]=f[c>>2];d=a+8|0;e=b+8|0;f[d>>2]=f[e>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];g=a+40|0;f[g>>2]=d;d=a+44|0;h=a+48|0;f[d>>2]=h;i=a+52|0;f[i>>2]=0;f[h>>2]=0;j=b+44|0;if((f[c>>2]|0)<3){k=f[j>>2]|0;f[h>>2]=f[k>>2];f[i>>2]=f[k+4>>2]}else{f[d>>2]=f[j>>2];d=b+40|0;f[g>>2]=f[d>>2];f[j>>2]=b+48;f[d>>2]=e}f[b>>2]=1124007936;e=c;c=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(c|0));e=a+56|0;c=b+56|0;f[e>>2]=f[c>>2];d=a+60|0;j=b+60|0;f[d>>2]=f[j>>2];g=a+64|0;f[g>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[a+80>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];k=f[b+92>>2]|0;f[a+92>>2]=k;f[a+96>>2]=g;g=a+104|0;i=a+100|0;f[i>>2]=g;f[g>>2]=0;f[a+108>>2]=0;if(k|0){g=k+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+100>>2]|0;g=f[i>>2]|0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];l=a+112|0;m=b+112|0;n=m;o=n;p=f[o>>2]|0;q=n+4|0;r=q;s=f[r>>2]|0;t=l;u=t;f[u>>2]=p;v=t+4|0;w=v;f[w>>2]=s;x=a+120|0;y=b+120|0;z=f[y>>2]|0;f[x>>2]=z;A=a+124|0;B=b+124|0;C=f[B>>2]|0;f[A>>2]=C;f[y>>2]=0;f[B>>2]=0;D=a+128|0;E=b+128|0;o1c(D|0,E|0,200)|0;return}else{f[d>>2]=0;U$(e,c);l=a+112|0;m=b+112|0;n=m;o=n;p=f[o>>2]|0;q=n+4|0;r=q;s=f[r>>2]|0;t=l;u=t;f[u>>2]=p;v=t+4|0;w=v;f[w>>2]=s;x=a+120|0;y=b+120|0;z=f[y>>2]|0;f[x>>2]=z;A=a+124|0;B=b+124|0;C=f[B>>2]|0;f[A>>2]=C;f[y>>2]=0;f[B>>2]=0;D=a+128|0;E=b+128|0;o1c(D|0,E|0,200)|0;return}}function EMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/328|0;g=e+1|0;if(g>>>0>13094412)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/328|0;d=i<<1;j=i>>>0<6547206?(d>>>0<g>>>0?g:d):13094412;do if(j)if(j>>>0>13094412){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*328|0)|0;break}else k=0;while(0);d=k+(e*328|0)|0;e=d;g=k+(j*328|0)|0;DMb(d,b);b=d+328|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-328|0;IMb(e+-328|0,i);e=k+-328|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{h=h+-328|0;sMb(h)}while((h|0)!=(g|0))}if(!m)return;cYc(m);return}function FMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;d=u;u=u+224|0;e=d;f[a>>2]=1124007936;g=a+8|0;h=a+40|0;i=a+4|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;h=a+48|0;f[a+44>>2]=h;f[h>>2]=0;f[a+52>>2]=0;k=a+56|0;l=a+64|0;m=a+96|0;i=a+60|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[m>>2]=l;l=a+104|0;f[a+100>>2]=l;f[l>>2]=0;f[a+108>>2]=0;f[k>>2]=1124007936;l=a+120|0;f[l>>2]=0;m=a+124|0;f[m>>2]=0;i=f[b+8>>2]|0;if(!c){c=(f[b+12>>2]|0)/2|0;f[e>>2]=(i|0)/2|0;f[e+4>>2]=c;S$(a,2,e,0);GMb(b,a);o=2.0}else{c=((f[b+12>>2]|0)/3|0)<<1;f[e>>2]=((i|0)/3|0)<<1;f[e+4>>2]=c;S$(a,2,e,0);HMb(b,a);o=1.5}p=o*+n[b+112>>2];n[a+112>>2]=p;n[a+116>>2]=p*.5+-.5;p$(e,f[g>>2]|0,f[a+12>>2]|0,0);g=f[e>>2]|0;ei[f[(f[g>>2]|0)+12>>2]&511](g,e,k,0);Zj(e);JRb(e,1,0,3);k=f[e>>2]|0;g=e+4|0;e=f[g>>2]|0;if(e|0)TXc(e);f[l>>2]=k;k=f[m>>2]|0;f[m>>2]=e;if(k|0)UXc(k);k=f[g>>2]|0;if(!k){q=a+128|0;r=f[h>>2]|0;nSb(q,r,0);s=a+228|0;t=f[h>>2]|0;nSb(s,t,3);u=d;return}UXc(k);q=a+128|0;r=f[h>>2]|0;nSb(q,r,0);s=a+228|0;t=f[h>>2]|0;nSb(s,t,3);u=d;return}function GMb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+24|0;g=d;h=d+16|0;if(((f[a+12>>2]|0)/2|0|0)!=(f[c+12>>2]|0)){i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=30;j=i;k=462021;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+30>>0]=0;vM(-215,e,462052,461750,2312)}if(((f[a+8>>2]|0)/2|0|0)==(f[c+8>>2]|0)){f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;a=f[c+40>>2]|0;c=f[a>>2]|0;f[h>>2]=f[a+4>>2];f[h+4>>2]=c;Zna(e,g,h,0.0,0.0,3);u=d;return}else{d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=30;j=d;k=462063;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+30>>0]=0;vM(-215,e,462052,461750,2313)}}function HMb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+24|0;g=d;h=d+16|0;if((((f[a+12>>2]|0)/3|0)<<1|0)!=(f[c+12>>2]|0)){i=$Xc(48)|0;f[e>>2]=i;f[e+8>>2]=-2147483600;f[e+4>>2]=36;j=i;k=461932;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+36>>0]=0;vM(-215,e,461969,461750,2323)}if((((f[a+8>>2]|0)/3|0)<<1|0)==(f[c+8>>2]|0)){f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;a=f[c+40>>2]|0;c=f[a>>2]|0;f[h>>2]=f[a+4>>2];f[h+4>>2]=c;Zna(e,g,h,0.0,0.0,3);u=d;return}else{d=$Xc(48)|0;f[e>>2]=d;f[e+8>>2]=-2147483600;f[e+4>>2]=36;j=d;k=461984;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+36>>0]=0;vM(-215,e,461969,461750,2324)}}function IMb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=f[b>>2];c=a+4|0;d=b+4|0;f[c>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];g=f[b+36>>2]|0;f[a+36>>2]=g;f[a+40>>2]=e;e=a+48|0;h=a+44|0;f[h>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){d=f[b+44>>2]|0;e=f[h>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2]}else{f[c>>2]=0;U$(a,b)}c=a+56|0;d=b+56|0;f[c>>2]=f[d>>2];e=a+60|0;h=b+60|0;f[e>>2]=f[h>>2];g=a+64|0;f[g>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[a+80>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];i=f[b+92>>2]|0;f[a+92>>2]=i;f[a+96>>2]=g;g=a+104|0;j=a+100|0;f[j>>2]=g;f[g>>2]=0;f[a+108>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+100>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(c,d)}d=b+112|0;c=f[d+4>>2]|0;e=a+112|0;f[e>>2]=f[d>>2];f[e+4>>2]=c;f[a+120>>2]=f[b+120>>2];c=f[b+124>>2]|0;f[a+124>>2]=c;if(!c){k=a+128|0;l=b+128|0;o1c(k|0,l|0,200)|0;return}TXc(c);k=a+128|0;l=b+128|0;o1c(k|0,l|0,200)|0;return}function JMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;yP(a);f[a>>2]=111400;f[a+4>>2]=b;f[a+8>>2]=c;f[g>>2]=0;c=g+4|0;f[c>>2]=0;f[g+8>>2]=0;f[h>>2]=0;b=h+4|0;f[b>>2]=0;f[h+8>>2]=0;qxb(g,5);j=f[b>>2]|0;k=f[h>>2]|0;l=k;m=j-k>>2;o=k;k=j;if(m>>>0>=5)if((m|0)!=5?(j=o+20|0,(k|0)!=(j|0)):0){f[b>>2]=k+(~((k+-4-j|0)>>>2)<<2);p=l}else p=l;else{CS(h,5-m|0);p=f[h>>2]|0}q=d;d=q*.85;m=f[g>>2]|0;n[m>>2]=d*0.0;n[m+4>>2]=d*2.9;n[m+8>>2]=d*4.9;n[m+12>>2]=d*7.4;n[m+16>>2]=d*10.8;f[p>>2]=1;f[p+4>>2]=10;f[p+8>>2]=14;f[p+12>>2]=15;f[p+16>>2]=20;f[i>>2]=0;p=i+4|0;f[p>>2]=0;f[i+8>>2]=0;KMb(a,g,h,q*5.85,q*8.2,i);a=f[i>>2]|0;if(a|0){i=f[p>>2]|0;if((i|0)!=(a|0))f[p>>2]=i+(~((i+-4-a|0)>>>2)<<2);cYc(a)}a=f[h>>2]|0;if(a|0){h=f[b>>2]|0;if((h|0)!=(a|0))f[b>>2]=h+(~((h+-4-a|0)>>>2)<<2);cYc(a)}a=f[g>>2]|0;if(!a){u=e;return}g=f[c>>2]|0;if((g|0)!=(a|0))f[c>>2]=g+(~((g+-4-a|0)>>>2)<<2);cYc(a);u=e;return}function KMb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0.0,R=0,S=0,T=0.0,U=0.0,V=0,W=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;i=u;u=u+32|0;j=i+12|0;k=i;eKa(j,h);h=a+32|0;n[h>>2]=e;l=a+36|0;n[l>>2]=g;m=(f[c+4>>2]|0)-(f[c>>2]|0)|0;o=m>>2;if(!o){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=$Xc(80)|0;f[k>>2]=p;q=k+8|0;f[q>>2]=-2147483568;r=k+4|0;f[r>>2]=64;s=p;t=462131;v=s+64|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+64|0;b[w>>0]=0;vM(-215,k,462196,461750,354)}x=f[d>>2]|0;y=x;if((o|0)!=((f[d+4>>2]|0)-x>>2|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=$Xc(80)|0;f[k>>2]=p;q=k+8|0;f[q>>2]=-2147483568;r=k+4|0;f[r>>2]=64;s=p;t=462131;v=s+64|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+64|0;b[w>>0]=0;vM(-215,k,462196,461750,354)}w=a+16|0;f[w>>2]=0;p=(m|0)>0;if(p){m=0;r=0;while(1){q=r+(f[y+(m<<2)>>2]|0)|0;f[w>>2]=q;m=m+1|0;if((m|0)>=(o|0)){z=q;break}else r=q}}else z=0;r=z<<16;z=bYc(r>>>0>357913941?-1:r*12|0)|0;r=a+12|0;f[r>>2]=z;if((b[537344]|0)==0?X0c(537344)|0:0)n[223184]=4.906890869140625;if((b[537352]|0)==0?X0c(537352)|0:0)n[223185]=+n[223184]*.015625;m=bYc(256)|0;f[a+20>>2]=m;y=bYc(256)|0;f[a+24>>2]=y;q=z;z=0;while(1){g=+Nd(+(+(z>>>0)*+n[223185]));x=m+(z<<2)|0;n[x>>2]=g;f[y+(z<<2)>>2]=0;A=f[d>>2]|0;B=f[c>>2]|0;C=m+(z<<2)|0;D=y+(z<<2)|0;E=0;F=q;while(1){g=+(E>>>0)*2.0*3.141592653589793*.0009765625;if(p){G=0;H=F;while(1){I=A+(G<<2)|0;J=f[I>>2]|0;if((J|0)>0){K=B+(G<<2)|0;e=+n[K>>2];L=f[D>>2]|0;if(!G){M=0;N=H;Q=e;R=L;S=J;while(1){T=g+ +(M|0)*2.0*3.141592653589793/+(S|0);U=+O(+T)*(+n[C>>2]*Q);n[N>>2]=U;U=+P(+T)*(+n[C>>2]*+n[K>>2]);n[N+4>>2]=U;U=+n[C>>2]*1.2999999523162842*.5;n[N+8>>2]=U;Q=+n[K>>2];T=U+ +n[x>>2]*Q;V=~~T;W=V+1+(+(V|0)<T&1)|0;if(R>>>0<W>>>0){f[D>>2]=W;Z=f[I>>2]|0;_=W}else{Z=S;_=R}W=N+12|0;M=M+1|0;if((M|0)>=(Z|0)){$=W;break}else{N=W;R=_;S=Z}}}else{S=0;R=H;N=J;Q=e;M=L;while(1){T=+(N|0);U=g+ +(S|0)*2.0*3.141592653589793/T;aa=+O(+U)*(+n[C>>2]*Q);n[R>>2]=aa;aa=+P(+U)*(+n[C>>2]*+n[K>>2]);n[R+4>>2]=aa;aa=+n[C>>2]*1.2999999523162842*+n[K>>2]*+P(+(3.141592653589793/T));n[R+8>>2]=aa;Q=+n[K>>2];T=aa+ +n[x>>2]*Q;W=~~T;V=W+1+(+(W|0)<T&1)|0;if(M>>>0<V>>>0){f[D>>2]=V;ba=f[I>>2]|0;ca=V}else{ba=N;ca=M}V=R+12|0;S=S+1|0;if((S|0)>=(ba|0)){$=V;break}else{R=V;N=ba;M=ca}}}}else $=H;G=G+1|0;if((G|0)>=(o|0)){da=$;break}else H=$}}else da=F;E=E+1|0;if((E|0)==1024)break;else F=da}z=z+1|0;if((z|0)==64)break;else q=da}da=f[w>>2]|0;q=(Y(da+-1|0,da)|0)>>>1;da=bYc(q>>>0>536870911?-1:q<<3)|0;z=a+40|0;f[z>>2]=da;da=bYc(q>>>0>268435455?-1:q<<4)|0;$=a+44|0;f[$>>2]=da;da=a+48|0;f[da>>2]=0;o=a+52|0;f[o>>2]=0;ca=j+4|0;ba=f[ca>>2]|0;Z=f[j>>2]|0;_=ba-Z>>2;p=Z;y=ba;if(!_){if(!q){ea=Z;fa=ba;ga=p;ha=y}else{CS(j,q);q=f[ca>>2]|0;ba=f[j>>2]|0;ea=ba;fa=q;ga=ba;ha=q}q=fa-ea>>2;if(!q){ia=0;ja=ha;ka=ga}else{ea=0;do{f[ga+(ea<<2)>>2]=ea;ea=ea+1|0}while((ea|0)!=(q|0));ia=q;ja=ha;ka=ga}}else{ia=_;ja=y;ka=p}g=+n[l>>2];Q=g*g;g=+n[h>>2];e=g*g;h=f[w>>2]|0;a:do if(h>>>0>1){l=f[j>>2]|0;p=1;y=h;b:while(1){if(!p)la=y;else{_=0;do{ga=f[r>>2]|0;g=+n[ga+(_*12|0)>>2]-+n[ga+(p*12|0)>>2];T=+n[ga+(_*12|0)+4>>2]-+n[ga+(p*12|0)+4>>2];aa=g*g+T*T;if(!(aa>Q)){if(aa<e){ga=f[da>>2]|0;if(ga>>>0>=ia>>>0)break b;ha=f[z>>2]|0;q=f[l+(ga<<2)>>2]|0;f[ha+(q<<3)+4>>2]=_;f[ha+(q<<3)>>2]=p;ma=da;na=ga;oa=47}}else{ga=f[$>>2]|0;q=f[o>>2]|0;f[ga+(q<<4)+8>>2]=~~(g/aa*2048.0+.5);f[ga+(q<<4)+12>>2]=~~(T/aa*2048.0+.5);f[ga+(q<<4)>>2]=p;f[ga+(q<<4)+4>>2]=_;ma=o;na=q;oa=47}if((oa|0)==47){oa=0;f[ma>>2]=na+1}_=_+1|0}while(_>>>0<p>>>0);la=f[w>>2]|0}p=p+1|0;if(p>>>0>=la>>>0){pa=l;break a}else y=la}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;y=$Xc(32)|0;f[k>>2]=y;f[k+8>>2]=-2147483616;f[k+4>>2]=23;s=y;t=462211;v=s+23|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[y+23>>0]=0;vM(-215,k,462196,461750,454)}else pa=ka;while(0);ka=~~+X(+(+((f[da>>2]|0)>>>0)*.0078125))<<4;f[a+28>>2]=ka;if(!pa){u=i;return}if((ja|0)!=(pa|0))f[ca>>2]=ja+(~((ja+-4-pa|0)>>>2)<<2);cYc(pa);u=i;return}function LMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=$Xc(68)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=111472;g=e+12|0;JMb(g,b,c,d);f[a>>2]=g;f[a+4>>2]=e;return}function MMb(a){a=a|0;f[a>>2]=111472;gMb(a+12|0);NXc(a);return}function NMb(a){a=a|0;f[a>>2]=111472;gMb(a+12|0);NXc(a);cYc(a);return}function OMb(a){a=a|0;gMb(a+12|0);return}function PMb(a){a=a|0;cYc(a);return}function QMb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+8|0;j=h+4|0;k=h;n[j>>2]=d;n[k>>2]=e;RMb(i,b,c,j,k,g);g=f[i+4>>2]|0;f[a>>2]=f[i>>2];f[a+4>>2]=g;u=h;return}function RMb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0;h=u;u=u+16|0;i=h;j=$Xc(68)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=111472;k=j+12|0;l=+n[d>>2];m=+n[e>>2];eKa(i,g);yP(k);f[k>>2]=111400;KMb(k,b,c,l,m,i);f[j+16>>2]=20;f[j+20>>2]=3;c=f[i>>2]|0;if(!c){o=a+4|0;f[a>>2]=k;f[o>>2]=j;u=h;return}b=i+4|0;i=f[b>>2]|0;if((i|0)!=(c|0))f[b>>2]=i+(~((i+-4-c|0)>>>2)<<2);cYc(c);o=a+4|0;f[a>>2]=k;f[o>>2]=j;u=h;return}function SMb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0;j=u;u=u+32|0;k=j+16|0;l=j+12|0;m=j+8|0;o=j+4|0;p=j;f[l>>2]=b;f[m>>2]=c;n[o>>2]=g;n[p>>2]=h;TMb(k,l,m,d,e,o,p,i);i=f[k+4>>2]|0;f[a>>2]=f[k>>2];f[a+4>>2]=i;u=j;return}function TMb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0;j=u;u=u+16|0;k=j;l=$Xc(68)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=111472;m=l+12|0;o=f[b>>2]|0;b=f[c>>2]|0;p=+n[g>>2];q=+n[h>>2];eKa(k,i);yP(m);f[m>>2]=111400;KMb(m,d,e,p,q,k);f[l+16>>2]=o;f[l+20>>2]=b;b=f[k>>2]|0;if(!b){r=a+4|0;f[a>>2]=m;f[r>>2]=l;u=j;return}o=k+4|0;k=f[o>>2]|0;if((k|0)!=(b|0))f[o>>2]=k+(~((k+-4-b|0)>>>2)<<2);cYc(b);r=a+4|0;f[a>>2]=m;f[r>>2]=l;u=j;return}function UMb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,462304)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function VMb(a){a=a|0;WRb(a);cYc(a);return}function WMb(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0.0,Od=0.0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0;j=u;u=u+6016|0;k=j+4944|0;l=j+4888|0;m=j+792|0;o=j+736|0;q=j+680|0;r=j+624|0;s=j+576|0;t=j;v=j+560|0;w=j+552|0;x=j+496|0;y=j+440|0;z=j+400|0;A=j+380|0;B=j+368|0;C=j+312|0;D=j+256|0;E=j+208|0;F=j+160|0;G=j+104|0;H=j+48|0;I=j+432|0;K=j+424|0;L=j+416|0;Q=j+392|0;R=a+36|0;if((f[R>>2]|0)<=1){S=$Xc(16)|0;f[k>>2]=S;f[k+8>>2]=-2147483632;f[k+4>>2]=14;T=S;U=462421;V=T+14|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));b[S+14>>0]=0;vM(-215,k,467518,462350,971)}S=aT(g)|0;if(!(S|i^1)){u=j;return}if(sS(c)|0){u=j;return}W=+((f[R>>2]|0)/2|0|0)*1.4142135623730951;X=~~W;Z=(+(X|0)<W&1)+X|0;X=a+20|0;_=f[X>>2]|0;$=(Z|0)>4?Z:4;Z=((_|0)<($|0)?$:_)+1|0;do if((eS(c)|0)==65536){_=f[c+4>>2]|0;f[x>>2]=f[_>>2];$=x+4|0;aa=_+4|0;f[$>>2]=f[aa>>2];ba=x+8|0;f[ba>>2]=f[_+8>>2];f[x+12>>2]=f[_+12>>2];f[x+16>>2]=f[_+16>>2];f[x+20>>2]=f[_+20>>2];f[x+24>>2]=f[_+24>>2];f[x+28>>2]=f[_+28>>2];f[x+32>>2]=f[_+32>>2];ca=f[_+36>>2]|0;f[x+36>>2]=ca;f[x+40>>2]=ba;ba=x+48|0;da=x+44|0;f[da>>2]=ba;f[ba>>2]=0;f[x+52>>2]=0;if(ca|0){ba=ca+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[_+44>>2]|0;ba=f[da>>2]|0;f[ba>>2]=f[aa>>2];f[ba+4>>2]=f[aa+4>>2];break}else{f[$>>2]=0;U$(x,_);break}}else bS(x,c,-1);while(0);do if((eS(d)|0)==65536){_=f[d+4>>2]|0;f[y>>2]=f[_>>2];$=y+4|0;aa=_+4|0;f[$>>2]=f[aa>>2];ba=y+8|0;f[ba>>2]=f[_+8>>2];f[y+12>>2]=f[_+12>>2];f[y+16>>2]=f[_+16>>2];f[y+20>>2]=f[_+20>>2];f[y+24>>2]=f[_+24>>2];f[y+28>>2]=f[_+28>>2];f[y+32>>2]=f[_+32>>2];da=f[_+36>>2]|0;f[y+36>>2]=da;f[y+40>>2]=ba;ba=y+48|0;ca=y+44|0;f[ca>>2]=ba;f[ba>>2]=0;f[y+52>>2]=0;if(da|0){ba=da+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[_+44>>2]|0;ba=f[ca>>2]|0;f[ba>>2]=f[aa>>2];f[ba+4>>2]=f[aa+4>>2];break}else{f[$>>2]=0;U$(y,_);break}}else bS(y,d,-1);while(0);if(f[x>>2]&4095|0){d=k+8|0;f[d>>2]=0;f[d+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=x;Spa(c,k,6,0)}c=f[a+16>>2]|0;d=e+4|0;_=f[e>>2]|0;$=(f[d>>2]|0)-_|0;aa=($|0)/28|0;ba=_;if(i){a:do if(($|0)>0){_=0;ca=1;da=0;while(1){ea=f[ba+(_*28|0)+20>>2]|0;if((ea|0)<=-1)break;if((_|0)>0)fa=ca&(ea|0)>=(f[ba+((_+-1|0)*28|0)+20>>2]|0);else fa=ca;ga=(da|0)<(ea|0)?ea:da;_=_+1|0;if((_|0)>=(aa|0)){ha=fa;ia=ga;break a}else{ca=fa;da=ga}}b[k+11>>0]=10;T=k;U=462436;V=T+10|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));b[k+10>>0]=0;vM(-215,k,467518,462350,1010)}else{ha=1;ia=0}while(0);ja=ia+1|0;ka=ha}else{ja=c;ka=1}f[z>>2]=0;c=z+4|0;f[c>>2]=0;f[z+8>>2]=0;ha=(ja|0)==0;do if(!ha)if(ja>>>0>268435455)kWc(z);else{ia=ja<<4;fa=$Xc(ia)|0;f[z>>2]=fa;f[z+8>>2]=fa+(ja<<4);g1c(fa|0,0,ia|0)|0;f[c>>2]=fa+ia;la=fa;break}else la=0;while(0);f[A>>2]=0;fa=A+4|0;f[fa>>2]=0;f[A+8>>2]=0;if(ha)ma=0;else{ia=ja<<2;aa=$Xc(ia)|0;f[A>>2]=aa;ba=aa+(ja<<2)|0;f[A+8>>2]=ba;g1c(aa|0,0,ia|0)|0;f[fa>>2]=ba;ma=aa}f[B>>2]=0;aa=B+4|0;f[aa>>2]=0;f[B+8>>2]=0;if(ha)na=0;else{ha=ja<<2;ba=$Xc(ha)|0;f[B>>2]=ba;ia=ba+(ja<<2)|0;f[B+8>>2]=ia;g1c(ba|0,0,ha|0)|0;f[aa>>2]=ia;na=ba}f[C>>2]=1124007936;ba=C+4|0;ia=C+8|0;ha=C+40|0;T=ba;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[ha>>2]=ia;ia=C+48|0;$=C+44|0;f[$>>2]=ia;f[ia>>2]=0;f[C+52>>2]=0;f[D>>2]=1124007936;da=D+4|0;ca=D+8|0;_=D+40|0;T=da;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[_>>2]=ca;ga=D+48|0;ea=D+44|0;f[ea>>2]=ga;f[ga>>2]=0;f[D+52>>2]=0;f[E>>2]=1124007936;oa=E+4|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;f[oa+16>>2]=0;f[oa+20>>2]=0;f[oa+24>>2]=0;f[E+32>>2]=E+8;oa=E+40|0;f[E+36>>2]=oa;f[E+44>>2]=0;f[oa>>2]=0;f[F>>2]=1124007936;oa=F+4|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;f[oa+16>>2]=0;f[oa+20>>2]=0;f[oa+24>>2]=0;f[F+32>>2]=F+8;oa=F+40|0;f[F+36>>2]=oa;f[F+44>>2]=0;f[oa>>2]=0;oa=x+8|0;pa=f[oa>>2]|0;qa=Z<<1;ra=pa+qa|0;sa=x+12|0;ta=f[sa>>2]|0;ua=a+24|0;va=f[ua>>2]|0;wa=a+8|0;W=+p[wa>>3];xa=qa+15+(ALc(+(ta|0)/+N(+W,+(+(0-va|0))))|0)&-16;ya=(ja|0)>0;b:do if(ya){za=f[sa>>2]|0;Aa=f[oa>>2]|0;Ba=ra;Ca=0;Da=0;Ea=va;Fa=ta;Ga=pa;Ha=0;while(1){Ia=+N(+W,+(+(Ha-Ea|0)));n[na+(Ha<<2)>>2]=Ia;Ja=ALc(+(Fa|0)/Ia)|0;Ka=ALc(+(Ga|0)/Ia)|0;La=Ja+qa|0;Ma=(La+Ca|0)>(xa|0);Na=Ma?0:Ca;Oa=(Ma?Ba:0)+Da|0;Pa=Ma?Ka+qa|0:Ba;Ma=Na+Z|0;Qa=Oa+Z|0;f[la+(Ha<<4)>>2]=Ma;f[la+(Ha<<4)+4>>2]=Qa;f[la+(Ha<<4)+8>>2]=Ja;f[la+(Ha<<4)+12>>2]=Ka;Ka=(Y(Qa,xa)|0)+Ma|0;f[ma+(Ha<<2)>>2]=Ka;Ka=Ha+1|0;if((Ka|0)==(ja|0)){Ra=Pa;Sa=Oa;break b}Ba=Pa;Ca=Na+La|0;Da=Oa;Ea=f[ua>>2]|0;Fa=za;Ga=Aa;Ha=Ka}}else{Ra=ra;Sa=0}while(0);ra=Ra+Sa|0;f[k>>2]=ra;f[k+4>>2]=xa;S$(C,2,k,0);Sa=y+16|0;do if(f[Sa>>2]|0){Ra=f[y+4>>2]|0;if((Ra|0)<3)Ta=Y(f[y+12>>2]|0,f[y+8>>2]|0)|0;else{ma=f[y+40>>2]|0;la=0;na=1;while(1){pa=Y(f[ma+(la<<2)>>2]|0,na)|0;la=la+1|0;if((la|0)==(Ra|0)){Ta=pa;break}else na=pa}}if(!((Ra|0)==0|(Ta|0)==0)){if(((((f[da>>2]|0)<3?(f[ca>>2]|0)==(ra|0):0)?(f[D+12>>2]|0)==(xa|0):0)?(f[D>>2]&4095|0)==0:0)?f[D+16>>2]|0:0)break;f[k>>2]=ra;f[k+4>>2]=xa;S$(D,2,k,0)}}while(0);f[G>>2]=f[x>>2];xa=G+4|0;ra=x+4|0;Ta=f[ra>>2]|0;f[xa>>2]=Ta;na=G+8|0;f[na>>2]=f[oa>>2];oa=G+12|0;f[oa>>2]=f[sa>>2];sa=G+16|0;la=x+16|0;f[sa>>2]=f[la>>2];ma=G+20|0;f[ma>>2]=f[x+20>>2];pa=G+24|0;f[pa>>2]=f[x+24>>2];ta=G+28|0;f[ta>>2]=f[x+28>>2];va=G+32|0;f[va>>2]=f[x+32>>2];Ha=G+36|0;Aa=x+36|0;Ga=f[Aa>>2]|0;f[Ha>>2]=Ga;za=G+40|0;f[za>>2]=na;Fa=G+48|0;Ea=G+44|0;f[Ea>>2]=Fa;f[Fa>>2]=0;f[G+52>>2]=0;if(!Ga)Ua=Ta;else{Ta=Ga+12|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ua=f[ra>>2]|0}if((Ua|0)<3){Ua=f[x+44>>2]|0;Ta=f[Ea>>2]|0;f[Ta>>2]=f[Ua>>2];f[Ta+4>>2]=f[Ua+4>>2]}else{f[xa>>2]=0;U$(G,x)}f[H>>2]=f[y>>2];Ua=H+4|0;Ta=y+4|0;Ga=f[Ta>>2]|0;f[Ua>>2]=Ga;Da=H+8|0;Ca=y+8|0;f[Da>>2]=f[Ca>>2];Ba=H+12|0;Ka=y+12|0;f[Ba>>2]=f[Ka>>2];Oa=H+16|0;f[Oa>>2]=f[Sa>>2];La=H+20|0;f[La>>2]=f[y+20>>2];Na=H+24|0;f[Na>>2]=f[y+24>>2];Pa=H+28|0;f[Pa>>2]=f[y+28>>2];Ma=H+32|0;f[Ma>>2]=f[y+32>>2];Qa=H+36|0;Ja=y+36|0;Va=f[Ja>>2]|0;f[Qa>>2]=Va;Wa=H+40|0;f[Wa>>2]=Da;Xa=H+48|0;Ya=H+44|0;f[Ya>>2]=Xa;f[Xa>>2]=0;f[H+52>>2]=0;if(!Va)Za=Ga;else{Ga=Va+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Za=f[Ta>>2]|0}if((Za|0)<3){Za=f[y+44>>2]|0;Ga=f[Ya>>2]|0;f[Ga>>2]=f[Za>>2];f[Ga+4>>2]=f[Za+4>>2]}else{f[Ua>>2]=0;U$(H,y)}if(ya){Za=k+4|0;Ga=k+8|0;Va=k+12|0;_a=m+4|0;$a=m+8|0;ab=m+40|0;bb=m+48|0;cb=m+44|0;db=m+52|0;eb=q+4|0;fb=q+8|0;gb=q+12|0;hb=q+4|0;ib=q+8|0;jb=q+40|0;kb=q+48|0;lb=q+44|0;mb=q+52|0;nb=r+8|0;ob=r+12|0;pb=r+4|0;qb=s+8|0;rb=s+4|0;sb=r+8|0;tb=r+12|0;ub=r+4|0;vb=s+8|0;wb=s+4|0;xb=y+40|0;yb=o+36|0;zb=o+4|0;Ab=o+8|0;Bb=o+12|0;Cb=o+44|0;Db=o+16|0;Eb=o+20|0;Fb=o+24|0;Gb=o+28|0;Hb=o+32|0;Ib=q+36|0;Jb=q+12|0;Kb=q+16|0;Lb=q+20|0;Mb=q+24|0;Nb=q+28|0;Ob=q+32|0;Pb=o+40|0;Qb=o+48|0;Rb=m+36|0;Sb=m+16|0;Tb=l+36|0;Ub=l+16|0;Vb=l+4|0;Wb=l+40|0;Xb=l+44|0;Yb=l+48|0;Zb=r+8|0;_b=r+12|0;$b=r+4|0;ac=s+8|0;bc=s+4|0;cc=I+4|0;dc=r+8|0;ec=r+12|0;fc=r+4|0;gc=s+8|0;hc=s+4|0;ic=r+8|0;jc=r+12|0;kc=r+4|0;lc=s+8|0;mc=s+4|0;nc=r+8|0;oc=r+12|0;pc=r+4|0;qc=s+8|0;rc=s+4|0;sc=K+4|0;tc=r+8|0;uc=r+12|0;vc=r+4|0;wc=s+8|0;xc=s+4|0;yc=r+4|0;zc=r+8|0;Ac=r+12|0;Bc=m+12|0;Cc=r+16|0;Dc=r+20|0;Ec=m+20|0;Fc=r+24|0;Gc=m+24|0;Hc=r+28|0;Ic=m+28|0;Jc=r+32|0;Kc=m+32|0;Lc=r+36|0;Mc=m+44|0;Nc=r+44|0;Oc=r+40|0;Pc=r+48|0;Qc=s+4|0;Rc=s+8|0;Sc=s+12|0;Tc=r+4|0;Uc=r+8|0;Vc=r+12|0;Wc=r+16|0;Xc=r+20|0;Yc=r+24|0;Zc=r+28|0;_c=r+32|0;$c=r+36|0;ad=q+44|0;bd=r+44|0;cd=r+40|0;dd=r+48|0;ed=q+40|0;fd=m+40|0;gd=m+52|0;hd=q+52|0;id=0;do{jd=f[z>>2]|0;kd=f[jd+(id<<4)+8>>2]|0;ld=f[jd+(id<<4)+12>>2]|0;md=(f[jd+(id<<4)+4>>2]|0)-Z|0;f[k>>2]=(f[jd+(id<<4)>>2]|0)-Z;f[Za>>2]=md;f[Ga>>2]=kd+qa;f[Va>>2]=ld+qa;Z$(l,C,k);f[m>>2]=1124007936;T=_a;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[ab>>2]=$a;f[cb>>2]=bb;f[bb>>2]=0;f[db>>2]=0;f[q>>2]=Z;f[eb>>2]=Z;f[fb>>2]=kd;f[gb>>2]=ld;Z$(o,l,q);f[q>>2]=1124007936;T=hb;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[jb>>2]=ib;f[lb>>2]=kb;f[kb>>2]=0;f[mb>>2]=0;do if(f[Sa>>2]|0){Ra=f[Ta>>2]|0;if((Ra|0)<3)nd=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{md=f[xb>>2]|0;jd=0;od=1;while(1){pd=Y(f[md+(jd<<2)>>2]|0,od)|0;jd=jd+1|0;if((jd|0)==(Ra|0)){nd=pd;break}else od=pd}}if((Ra|0)==0|(nd|0)==0)break;Z$(r,D,k);od=f[Rb>>2]|0;do if(od|0){jd=od+12|0;md=f[jd>>2]|0;f[jd>>2]=md+-1;if((md|0)!=1)break;V$(m)}while(0);f[Rb>>2]=0;f[Sb>>2]=0;f[Sb+4>>2]=0;f[Sb+8>>2]=0;f[Sb+12>>2]=0;if((f[_a>>2]|0)>0){od=f[ab>>2]|0;Ra=0;do{f[od+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[_a>>2]|0))}f[m>>2]=f[r>>2];Ra=f[yc>>2]|0;f[_a>>2]=Ra;f[$a>>2]=f[zc>>2];f[Bc>>2]=f[Ac>>2];f[Sb>>2]=f[Cc>>2];f[Ec>>2]=f[Dc>>2];f[Gc>>2]=f[Fc>>2];f[Ic>>2]=f[Hc>>2];f[Kc>>2]=f[Jc>>2];f[Rb>>2]=f[Lc>>2];od=f[Mc>>2]|0;if((od|0)==(bb|0))qd=Ra;else{wL(od);f[Mc>>2]=bb;f[ab>>2]=$a;qd=f[yc>>2]|0}if((qd|0)<3){od=f[Nc>>2]|0;f[bb>>2]=f[od>>2];f[gd>>2]=f[od+4>>2];rd=od}else{f[Mc>>2]=f[Nc>>2];f[fd>>2]=f[Oc>>2];f[Nc>>2]=Pc;f[Oc>>2]=zc;rd=Pc}f[r>>2]=1124007936;f[yc>>2]=0;f[yc+4>>2]=0;f[yc+8>>2]=0;f[yc+12>>2]=0;f[yc+16>>2]=0;f[yc+20>>2]=0;f[yc+24>>2]=0;f[yc+28>>2]=0;f[Lc>>2]=0;f[Cc>>2]=0;f[Cc+4>>2]=0;f[Cc+8>>2]=0;f[Cc+12>>2]=0;if((rd|0)!=(Pc|0))wL(rd);f[s>>2]=Z;f[Qc>>2]=Z;f[Rc>>2]=kd;f[Sc>>2]=ld;Z$(r,m,s);od=f[Ib>>2]|0;do if(od|0){Ra=od+12|0;md=f[Ra>>2]|0;f[Ra>>2]=md+-1;if((md|0)!=1)break;V$(q)}while(0);f[Ib>>2]=0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[Kb+8>>2]=0;f[Kb+12>>2]=0;if((f[hb>>2]|0)>0){od=f[jb>>2]|0;md=0;do{f[od+(md<<2)>>2]=0;md=md+1|0}while((md|0)<(f[hb>>2]|0))}f[q>>2]=f[r>>2];md=f[Tc>>2]|0;f[hb>>2]=md;f[ib>>2]=f[Uc>>2];f[Jb>>2]=f[Vc>>2];f[Kb>>2]=f[Wc>>2];f[Lb>>2]=f[Xc>>2];f[Mb>>2]=f[Yc>>2];f[Nb>>2]=f[Zc>>2];f[Ob>>2]=f[_c>>2];f[Ib>>2]=f[$c>>2];od=f[ad>>2]|0;if((od|0)==(kb|0))sd=md;else{wL(od);f[ad>>2]=kb;f[jb>>2]=ib;sd=f[Tc>>2]|0}if((sd|0)<3){od=f[bd>>2]|0;f[kb>>2]=f[od>>2];f[hd>>2]=f[od+4>>2];td=od}else{f[ad>>2]=f[bd>>2];f[ed>>2]=f[cd>>2];f[bd>>2]=dd;f[cd>>2]=Uc;td=dd}f[r>>2]=1124007936;f[Tc>>2]=0;f[Tc+4>>2]=0;f[Tc+8>>2]=0;f[Tc+12>>2]=0;f[Tc+16>>2]=0;f[Tc+20>>2]=0;f[Tc+24>>2]=0;f[Tc+28>>2]=0;f[$c>>2]=0;f[Wc>>2]=0;f[Wc+4>>2]=0;f[Wc+8>>2]=0;f[Wc+12>>2]=0;if((td|0)!=(dd|0))wL(td)}while(0);do if((id|0)==(f[ua>>2]|0)){f[nb>>2]=0;f[ob>>2]=0;f[r>>2]=16842752;f[pb>>2]=x;od=qb;f[od>>2]=0;f[od+4>>2]=0;f[s>>2]=33619968;f[rb>>2]=l;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;rR(r,s,Z,Z,Z,Z,4,t);if(!(f[Sa>>2]|0))break;od=f[Ta>>2]|0;if((od|0)<3)ud=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{md=f[xb>>2]|0;Ra=0;jd=1;while(1){pd=Y(f[md+(Ra<<2)>>2]|0,jd)|0;Ra=Ra+1|0;if((Ra|0)==(od|0)){ud=pd;break}else jd=pd}}if((od|0)==0|(ud|0)==0)break;f[sb>>2]=0;f[tb>>2]=0;f[r>>2]=16842752;f[ub>>2]=y;jd=vb;f[jd>>2]=0;f[jd+4>>2]=0;f[s>>2]=33619968;f[wb>>2]=m;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;rR(r,s,Z,Z,Z,Z,16,t)}else{f[Zb>>2]=0;f[_b>>2]=0;f[r>>2]=16842752;f[$b>>2]=G;jd=ac;f[jd>>2]=0;f[jd+4>>2]=0;f[s>>2]=33619968;f[bc>>2]=o;f[I>>2]=kd;f[cc>>2]=ld;Zna(r,s,I,0.0,0.0,5);do if(f[Sa>>2]|0){jd=f[Ta>>2]|0;if((jd|0)<3)vd=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{Ra=f[xb>>2]|0;md=0;pd=1;while(1){wd=Y(f[Ra+(md<<2)>>2]|0,pd)|0;md=md+1|0;if((md|0)==(jd|0)){vd=wd;break}else pd=wd}}if((jd|0)==0|(vd|0)==0)break;f[nc>>2]=0;f[oc>>2]=0;f[r>>2]=16842752;f[pc>>2]=H;pd=qc;f[pd>>2]=0;f[pd+4>>2]=0;f[s>>2]=33619968;f[rc>>2]=q;f[K>>2]=kd;f[sc>>2]=ld;Zna(r,s,K,0.0,0.0,5);if((id|0)<=(f[ua>>2]|0))break;f[tc>>2]=0;f[uc>>2]=0;f[r>>2]=16842752;f[vc>>2]=q;pd=wc;f[pd>>2]=0;f[pd+4>>2]=0;f[s>>2]=33619968;f[xc>>2]=q;+_na(r,s,254.0,0.0,3)}while(0);f[dc>>2]=0;f[ec>>2]=0;f[r>>2]=16842752;f[fc>>2]=o;od=gc;f[od>>2]=0;f[od+4>>2]=0;f[s>>2]=33619968;f[hc>>2]=l;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;rR(r,s,Z,Z,Z,Z,20,t);if(!(f[Sa>>2]|0))break;od=f[Ta>>2]|0;if((od|0)<3)xd=Y(f[Ka>>2]|0,f[Ca>>2]|0)|0;else{pd=f[xb>>2]|0;md=0;Ra=1;while(1){wd=Y(f[pd+(md<<2)>>2]|0,Ra)|0;md=md+1|0;if((md|0)==(od|0)){xd=wd;break}else Ra=wd}}if((od|0)==0|(xd|0)==0)break;f[ic>>2]=0;f[jc>>2]=0;f[r>>2]=16842752;f[kc>>2]=q;Ra=lc;f[Ra>>2]=0;f[Ra+4>>2]=0;f[s>>2]=33619968;f[mc>>2]=m;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;rR(r,s,Z,Z,Z,Z,16,t)}while(0);if((id|0)>(f[ua>>2]|0)){ld=f[yb>>2]|0;if(ld|0){kd=ld+12|0;f[kd>>2]=(f[kd>>2]|0)+1}kd=f[Ha>>2]|0;do if(kd|0){ld=kd+12|0;Ra=f[ld>>2]|0;f[ld>>2]=Ra+-1;if((Ra|0)!=1)break;V$(G)}while(0);f[Ha>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[xa>>2]|0)>0){kd=f[za>>2]|0;Ra=0;do{f[kd+(Ra<<2)>>2]=0;Ra=Ra+1|0;yd=f[xa>>2]|0}while((Ra|0)<(yd|0));f[G>>2]=f[o>>2];if((yd|0)<3)zd=132;else zd=134}else{f[G>>2]=f[o>>2];zd=132}do if((zd|0)==132){zd=0;Ra=f[zb>>2]|0;if((Ra|0)>=3){zd=134;break}f[xa>>2]=Ra;f[na>>2]=f[Ab>>2];f[oa>>2]=f[Bb>>2];Ra=f[Cb>>2]|0;kd=f[Ea>>2]|0;f[kd>>2]=f[Ra>>2];f[kd+4>>2]=f[Ra+4>>2]}while(0);if((zd|0)==134){zd=0;U$(G,o)}f[sa>>2]=f[Db>>2];f[ma>>2]=f[Eb>>2];f[pa>>2]=f[Fb>>2];f[ta>>2]=f[Gb>>2];f[va>>2]=f[Hb>>2];f[Ha>>2]=f[yb>>2];Ra=f[Ib>>2]|0;if(Ra|0){kd=Ra+12|0;f[kd>>2]=(f[kd>>2]|0)+1}kd=f[Qa>>2]|0;do if(kd|0){Ra=kd+12|0;ld=f[Ra>>2]|0;f[Ra>>2]=ld+-1;if((ld|0)!=1)break;V$(H)}while(0);f[Qa>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Ua>>2]|0)>0){kd=f[Wa>>2]|0;ld=0;do{f[kd+(ld<<2)>>2]=0;ld=ld+1|0;Ad=f[Ua>>2]|0}while((ld|0)<(Ad|0));f[H>>2]=f[q>>2];if((Ad|0)<3)zd=145;else zd=147}else{f[H>>2]=f[q>>2];zd=145}do if((zd|0)==145){zd=0;ld=f[hb>>2]|0;if((ld|0)>=3){zd=147;break}f[Ua>>2]=ld;f[Da>>2]=f[ib>>2];f[Ba>>2]=f[Jb>>2];ld=f[lb>>2]|0;kd=f[Ya>>2]|0;f[kd>>2]=f[ld>>2];f[kd+4>>2]=f[ld+4>>2]}while(0);if((zd|0)==147){zd=0;U$(H,q)}f[Oa>>2]=f[Kb>>2];f[La>>2]=f[Lb>>2];f[Na>>2]=f[Mb>>2];f[Pa>>2]=f[Nb>>2];f[Ma>>2]=f[Ob>>2];ld=f[Ib>>2]|0;f[Qa>>2]=ld;Bd=ld}else Bd=f[Ib>>2]|0;do if(Bd|0){ld=Bd+12|0;kd=f[ld>>2]|0;f[ld>>2]=kd+-1;if((kd|0)!=1)break;V$(q)}while(0);f[Ib>>2]=0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[Kb+8>>2]=0;f[Kb+12>>2]=0;if((f[hb>>2]|0)>0){kd=f[jb>>2]|0;ld=0;do{f[kd+(ld<<2)>>2]=0;ld=ld+1|0}while((ld|0)<(f[hb>>2]|0))}ld=f[lb>>2]|0;if((ld|0)!=(kb|0))wL(ld);ld=f[yb>>2]|0;do if(ld|0){kd=ld+12|0;Ra=f[kd>>2]|0;f[kd>>2]=Ra+-1;if((Ra|0)!=1)break;V$(o)}while(0);f[yb>>2]=0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;if((f[zb>>2]|0)>0){ld=f[Pb>>2]|0;Ra=0;do{f[ld+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[zb>>2]|0))}Ra=f[Cb>>2]|0;if((Ra|0)!=(Qb|0))wL(Ra);Ra=f[Rb>>2]|0;do if(Ra|0){ld=Ra+12|0;kd=f[ld>>2]|0;f[ld>>2]=kd+-1;if((kd|0)!=1)break;V$(m)}while(0);f[Rb>>2]=0;f[Sb>>2]=0;f[Sb+4>>2]=0;f[Sb+8>>2]=0;f[Sb+12>>2]=0;if((f[_a>>2]|0)>0){Ra=f[ab>>2]|0;kd=0;do{f[Ra+(kd<<2)>>2]=0;kd=kd+1|0}while((kd|0)<(f[_a>>2]|0))}kd=f[cb>>2]|0;if((kd|0)!=(bb|0))wL(kd);kd=f[Tb>>2]|0;do if(kd|0){Ra=kd+12|0;ld=f[Ra>>2]|0;f[Ra>>2]=ld+-1;if((ld|0)!=1)break;V$(l)}while(0);f[Tb>>2]=0;f[Ub>>2]=0;f[Ub+4>>2]=0;f[Ub+8>>2]=0;f[Ub+12>>2]=0;if((f[Vb>>2]|0)>0){kd=f[Wb>>2]|0;ld=0;do{f[kd+(ld<<2)>>2]=0;ld=ld+1|0}while((ld|0)<(f[Vb>>2]|0))}ld=f[Xb>>2]|0;if((ld|0)!=(Yb|0))wL(ld);id=id+1|0}while((id|0)<(ja|0))}if(i){i=f[x+40>>2]|0;id=f[i>>2]|0;f[L>>2]=f[i+4>>2];f[L+4>>2]=id;kSb(e,L,f[X>>2]|0);if(!ka){rNb(k,ja);ka=f[d>>2]|0;L=f[e>>2]|0;id=ka-L|0;i=(id|0)/28|0;Yb=L;L=ka;do if((id|0)>0){ka=0;Xb=Yb;while(1){Vb=Xb+(ka*28|0)|0;Wb=f[Xb+(ka*28|0)+20>>2]|0;if((Wb|0)<=-1){zd=337;break}Ub=f[k>>2]|0;Tb=Ub+(Wb*12|0)+4|0;bb=f[Tb>>2]|0;if((bb|0)==(f[Ub+(Wb*12|0)+8>>2]|0))Lx(Ub+(Wb*12|0)|0,Vb);else{f[bb>>2]=f[Vb>>2];f[bb+4>>2]=f[Xb+(ka*28|0)+4>>2];Vb=bb+8|0;bb=Xb+(ka*28|0)+8|0;f[Vb>>2]=f[bb>>2];f[Vb+4>>2]=f[bb+4>>2];f[Vb+8>>2]=f[bb+8>>2];f[Vb+12>>2]=f[bb+12>>2];f[Vb+16>>2]=f[bb+16>>2];f[Tb>>2]=(f[Tb>>2]|0)+28}ka=ka+1|0;Xb=f[e>>2]|0;if((ka|0)>=(i|0)){zd=342;break}}if((zd|0)==337){b[l+11>>0]=10;T=l;U=462516;V=T+10|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));b[l+10>>0]=0;vM(-215,l,467518,462350,1125)}else if((zd|0)==342){Cd=Xb;Dd=f[d>>2]|0;break}}else{Cd=Yb;Dd=L}while(0);if((Dd|0)!=(Cd|0))f[d>>2]=Dd+(~(((Dd+-28-Cd|0)>>>0)/28|0)*28|0);Cd=f[k>>2]|0;if(ya){Dd=e+8|0;L=Cd;Yb=0;while(1){i=f[L+(Yb*12|0)>>2]|0;id=f[L+(Yb*12|0)+4>>2]|0;if((i|0)==(id|0))Ed=L;else{ka=i;do{i=f[d>>2]|0;if((i|0)==(f[Dd>>2]|0))Lx(e,ka);else{f[i>>2]=f[ka>>2];f[i+4>>2]=f[ka+4>>2];Tb=i+8|0;i=ka+8|0;f[Tb>>2]=f[i>>2];f[Tb+4>>2]=f[i+4>>2];f[Tb+8>>2]=f[i+8>>2];f[Tb+12>>2]=f[i+12>>2];f[Tb+16>>2]=f[i+16>>2];f[d>>2]=(f[d>>2]|0)+28}ka=ka+28|0}while((ka|0)!=(id|0));Ed=f[k>>2]|0}Yb=Yb+1|0;if((Yb|0)>=(ja|0)){Fd=Ed;break}else L=Ed}}else Fd=Cd;if(Fd|0){Cd=k+4|0;Ed=f[Cd>>2]|0;if((Ed|0)==(Fd|0))Gd=Fd;else{L=Ed;while(1){Ed=L+-12|0;f[Cd>>2]=Ed;Yb=f[Ed>>2]|0;if(!Yb)Hd=Ed;else{Ed=L+-8|0;Dd=f[Ed>>2]|0;if((Dd|0)!=(Yb|0))f[Ed>>2]=Dd+(~(((Dd+-28-Yb|0)>>>0)/28|0)*28|0);cYc(Yb);Hd=f[Cd>>2]|0}if((Hd|0)==(Fd|0))break;else L=Hd}Gd=f[k>>2]|0}cYc(Gd)}}}else{Gd=f[a+4>>2]|0;W=+p[wa>>3];wa=f[X>>2]|0;X=f[R>>2]|0;Hd=f[a+32>>2]|0;L=f[a+40>>2]|0;Fd=(f[c>>2]|0)-(f[z>>2]|0)|0;Cd=Fd>>4;f[l>>2]=0;Yb=l+4|0;f[Yb>>2]=0;f[l+8>>2]=0;Dd=(Cd|0)==0;do if(!Dd)if(Cd>>>0>1073741823)kWc(l);else{Ed=Fd>>2;id=$Xc(Ed)|0;f[l>>2]=id;ka=id+(Cd<<2)|0;f[l+8>>2]=ka;g1c(id|0,0,Ed|0)|0;f[Yb>>2]=ka;Id=id;break}else Id=0;while(0);Ia=1.0/W;id=Cd+-1|0;if((Fd|0)>16){ka=0;W=+(Gd|0)*(1.0-Ia)/(1.0-+N(+Ia,+(+(Cd|0))));Ed=0;while(1){Xb=ALc(W)|0;f[Id+(ka<<2)>>2]=Xb;i=Xb+Ed|0;ka=ka+1|0;if((ka|0)>=(id|0)){Jd=i;break}else{W=Ia*W;Ed=i}}}else Jd=0;Ed=Gd-Jd|0;f[Id+(id<<2)>>2]=(Ed|0)>0?Ed:0;Ed=(X|0)/2|0;id=Ed+2|0;f[m>>2]=0;Jd=m+4|0;f[Jd>>2]=0;f[m+8>>2]=0;do if(id)if(id>>>0>1073741823)kWc(m);else{Gd=id<<2;ka=$Xc(Gd)|0;f[m>>2]=ka;i=ka+(id<<2)|0;f[m+8>>2]=i;g1c(ka|0,0,Gd|0)|0;f[Jd>>2]=i;Kd=ka;break}else Kd=0;while(0);W=+(Ed|0)*1.4142135381698608*.5;Ia=W+1.0;id=~~Ia;ka=+(id|0)>Ia;i=~~W;Gd=(+(i|0)<W&1)+i|0;if((id|0)>=(ka&1|0)){W=+(Ed|0);Ia=W*W;i=id+1+(ka<<31>>31)|0;ka=0;do{id=zLc(+M(+(Ia-+(Y(ka,ka)|0))))|0;f[Kd+(ka<<2)>>2]=id;ka=ka+1|0}while((ka|0)!=(i|0))}if((Ed|0)>=(Gd|0)){i=0;ka=Ed;while(1){id=f[Kd+(i<<2)>>2]|0;Xb=i;while(1){Ld=Xb+1|0;if((id|0)==(f[Kd+(Ld<<2)>>2]|0))Xb=Ld;else break}f[Kd+(ka<<2)>>2]=Xb;if((ka|0)>(Gd|0)){i=Ld;ka=ka+-1|0}else break}}ka=f[e>>2]|0;Ld=f[d>>2]|0;if((Ld|0)!=(ka|0))f[d>>2]=Ld+(~(((Ld+-28-ka|0)>>>0)/28|0)*28|0);f[o>>2]=0;ka=o+4|0;f[ka>>2]=0;f[o+8>>2]=0;f[q>>2]=0;Ld=q+4|0;f[Ld>>2]=0;f[q+8>>2]=0;do if(!Dd)if(Cd>>>0>1073741823)kWc(q);else{i=Fd>>2;Gd=$Xc(i)|0;f[q>>2]=Gd;Kd=Gd+(Cd<<2)|0;f[q+8>>2]=Kd;g1c(Gd|0,0,i|0)|0;f[Ld>>2]=Kd;break}while(0);qNb(o,f[Id>>2]<<1);Id=(Fd|0)>0;if(Id){Fd=D+16|0;Dd=r+4|0;Kd=r+8|0;i=r+40|0;Gd=r+48|0;id=r+44|0;Tb=r+52|0;bb=t+8|0;Vb=t+12|0;Wb=t+4|0;Ub=v+8|0;cb=v+12|0;_a=v+4|0;ab=s+4|0;Sb=k+40|0;Rb=w+4|0;Qb=(Hd|0)==0&1;Cb=r+36|0;zb=r+16|0;Pb=k+36|0;Db=k+16|0;yb=k+4|0;kb=k+44|0;lb=k+48|0;hb=e+8|0;Ia=+(X|0);jb=D+12|0;Kb=0;do{Ib=f[(f[l>>2]|0)+(Kb<<2)>>2]|0;Z$(k,C,(f[z>>2]|0)+(Kb<<4)|0);do if(!(f[Fd>>2]|0))zd=215;else{Bd=f[da>>2]|0;if((Bd|0)<3)Md=Y(f[jb>>2]|0,f[ca>>2]|0)|0;else{Ob=f[_>>2]|0;Ma=0;Nb=1;while(1){Pa=Y(f[Ob+(Ma<<2)>>2]|0,Nb)|0;Ma=Ma+1|0;if((Ma|0)==(Bd|0)){Md=Pa;break}else Nb=Pa}}if((Bd|0)==0|(Md|0)==0){zd=215;break}Z$(r,D,(f[z>>2]|0)+(Kb<<4)|0)}while(0);if((zd|0)==215){zd=0;f[r>>2]=1124007936;T=Dd;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[i>>2]=Kd;f[id>>2]=Gd;f[Gd>>2]=0;f[Tb>>2]=0}pLb(s,L,1,2);Xb=f[s>>2]|0;Nb=f[(f[Xb>>2]|0)+32>>2]|0;f[bb>>2]=0;f[Vb>>2]=0;f[t>>2]=16842752;f[Wb>>2]=k;f[Ub>>2]=0;f[cb>>2]=0;f[v>>2]=16842752;f[_a>>2]=r;ei[Nb&511](Xb,t,o,v);Xb=f[ab>>2]|0;if(Xb|0)UXc(Xb);Xb=f[Sb>>2]|0;Nb=f[Xb>>2]|0;f[w>>2]=f[Xb+4>>2];f[Rb>>2]=Nb;kSb(o,w,wa);hSb(o,Ib<<Qb);Nb=f[ka>>2]|0;Xb=f[o>>2]|0;Ma=Nb-Xb|0;Ob=(Ma|0)/28|0;f[(f[q>>2]|0)+(Kb<<2)>>2]=Ob;od=Xb;Xb=Nb;if((Ma|0)>0){W=Ia*+n[(f[B>>2]|0)+(Kb<<2)>>2];Ma=0;do{f[od+(Ma*28|0)+20>>2]=Kb;n[od+(Ma*28|0)+8>>2]=W;Ma=Ma+1|0}while((Ma|0)<(Ob|0))}if((od|0)!=(Xb|0)){Ob=od;do{Ma=f[d>>2]|0;if((Ma|0)==(f[hb>>2]|0))Lx(e,Ob);else{f[Ma>>2]=f[Ob>>2];f[Ma+4>>2]=f[Ob+4>>2];Ib=Ma+8|0;Ma=Ob+8|0;f[Ib>>2]=f[Ma>>2];f[Ib+4>>2]=f[Ma+4>>2];f[Ib+8>>2]=f[Ma+8>>2];f[Ib+12>>2]=f[Ma+12>>2];f[Ib+16>>2]=f[Ma+16>>2];f[d>>2]=(f[d>>2]|0)+28}Ob=Ob+28|0}while((Ob|0)!=(Xb|0))}Xb=f[Cb>>2]|0;do if(Xb|0){Ob=Xb+12|0;od=f[Ob>>2]|0;f[Ob>>2]=od+-1;if((od|0)!=1)break;V$(r)}while(0);f[Cb>>2]=0;f[zb>>2]=0;f[zb+4>>2]=0;f[zb+8>>2]=0;f[zb+12>>2]=0;if((f[Dd>>2]|0)>0){Xb=f[i>>2]|0;od=0;do{f[Xb+(od<<2)>>2]=0;od=od+1|0}while((od|0)<(f[Dd>>2]|0))}od=f[id>>2]|0;if((od|0)!=(Gd|0))wL(od);od=f[Pb>>2]|0;do if(od|0){Xb=od+12|0;Ob=f[Xb>>2]|0;f[Xb>>2]=Ob+-1;if((Ob|0)!=1)break;V$(k)}while(0);f[Pb>>2]=0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;if((f[yb>>2]|0)>0){od=f[Sb>>2]|0;Ob=0;do{f[od+(Ob<<2)>>2]=0;Ob=Ob+1|0}while((Ob|0)<(f[yb>>2]|0))}Ob=f[kb>>2]|0;if((Ob|0)!=(lb|0))wL(Ob);Kb=Kb+1|0}while((Kb|0)<(Cd|0))}Kb=(f[d>>2]|0)-(f[e>>2]|0)|0;if(Kb|0){lb=(Kb|0)/28|0;f[r>>2]=1124007936;Kb=r+4|0;kb=r+8|0;yb=r+40|0;T=Kb;V=T+36|0;do{f[T>>2]=0;T=T+4|0}while((T|0)<(V|0));f[yb>>2]=kb;kb=r+48|0;Sb=r+44|0;f[Sb>>2]=kb;f[kb>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;Db=s+4|0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;f[Db+16>>2]=0;f[Db+20>>2]=0;f[Db+24>>2]=0;f[s+32>>2]=s+8;Db=s+40|0;f[s+36>>2]=Db;f[s+44>>2]=0;f[Db>>2]=0;f[t>>2]=1124007936;Db=t+4|0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;f[Db+16>>2]=0;f[Db+20>>2]=0;f[Db+24>>2]=0;f[t+32>>2]=t+8;Db=t+40|0;f[t+36>>2]=Db;f[t+44>>2]=0;f[Db>>2]=0;f[k>>2]=1;f[k+4>>2]=lb;BQ(t,2,k,5,0);if(!Hd){Hd=f[z>>2]|0;lb=f[C>>2]|0;if(lb&4095|0){Db=$Xc(64)|0;f[k>>2]=Db;f[k+8>>2]=-2147483584;f[k+4>>2]=52;T=Db;U=462447;V=T+52|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));b[Db+52>>0]=0;vM(-215,k,462500,462350,134)}Db=(f[d>>2]|0)-(f[e>>2]|0)|0;Pb=f[C+16>>2]|0;Gd=((f[ia>>2]|0)>>>0)/((675553809>>>(lb<<2&28)&15)>>>0)|0;lb=k+8|0;f[k>>2]=lb;id=k+4|0;f[id>>2]=49;f[lb>>2]=0;f[k+12>>2]=1;f[k+16>>2]=2;f[k+20>>2]=3;f[k+24>>2]=4;f[k+28>>2]=5;f[k+32>>2]=6;f[k+36>>2]=Gd;Dd=Gd+1|0;f[k+40>>2]=Dd;f[k+44>>2]=Gd+2;f[k+48>>2]=Gd+3;f[k+52>>2]=Gd+4;f[k+56>>2]=Gd+5;f[k+60>>2]=Gd+6;i=Gd<<1;f[k+64>>2]=i;f[k+68>>2]=i|1;f[k+72>>2]=i+2;f[k+76>>2]=i+3;f[k+80>>2]=i+4;f[k+84>>2]=i+5;f[k+88>>2]=i+6;i=Gd*3|0;f[k+92>>2]=i;f[k+96>>2]=i+1;f[k+100>>2]=i+2;f[k+104>>2]=i+3;f[k+108>>2]=i+4;f[k+112>>2]=i+5;f[k+116>>2]=i+6;i=Gd<<2;f[k+120>>2]=i;f[k+124>>2]=i|1;f[k+128>>2]=i|2;f[k+132>>2]=i|3;f[k+136>>2]=i+4;f[k+140>>2]=i+5;f[k+144>>2]=i+6;i=Gd*5|0;f[k+148>>2]=i;f[k+152>>2]=i+1;f[k+156>>2]=i+2;f[k+160>>2]=i+3;f[k+164>>2]=i+4;f[k+168>>2]=i+5;f[k+172>>2]=i+6;i=Gd*6|0;f[k+176>>2]=i;f[k+180>>2]=i|1;f[k+184>>2]=i+2;f[k+188>>2]=i+3;f[k+192>>2]=i+4;f[k+196>>2]=i+5;f[k+200>>2]=i+6;i=(Db|0)/28|0;if(Db|0){Db=0-Gd|0;zb=1-Gd|0;Cb=~Gd;hb=Gd+-1|0;Qb=f[e>>2]|0;wa=0;do{w=ALc(+n[Qb+(wa*28|0)>>2])|0;Rb=ALc(+n[Qb+(wa*28|0)+4>>2])|0;ab=f[Qb+(wa*28|0)+20>>2]|0;v=Pb+(Y(Rb+-3+(f[Hd+(ab<<4)+4>>2]|0)|0,Gd)|0)+w+-3|0;w=v+(f[Hd+(ab<<4)>>2]|0)|0;ab=0;v=0;Rb=0;_a=0;do{cb=w+(f[k+8+(ab<<2)>>2]|0)|0;Ub=h[cb+zb>>0]|0;Wb=h[cb+Cb>>0]|0;Vb=h[cb+Dd>>0]|0;bb=h[cb+hb>>0]|0;L=Ub-Wb+((h[cb+1>>0]|0)-(h[cb+-1>>0]|0)<<1)+(Vb-bb)|0;Tb=Vb-(Wb+Ub)+bb+((h[cb+Gd>>0]|0)-(h[cb+Db>>0]|0)<<1)|0;_a=(Y(L,L)|0)+_a|0;Rb=(Y(Tb,Tb)|0)+Rb|0;v=(Y(Tb,L)|0)+v|0;ab=ab+1|0}while((ab|0)!=49);Ia=+(_a|0);W=+(Rb|0);Nd=+(v|0);Od=Ia+W;n[Qb+(wa*28|0)+16>>2]=(Ia*W-Nd*Nd-Od*(Od*.03999999910593033))*3.847753306718862e-16;wa=wa+1|0}while(wa>>>0<i>>>0)}i=f[k>>2]|0;if((i|0)!=(lb|0)){if(i|0)dYc(i);f[k>>2]=lb;f[id>>2]=264}f[k>>2]=0;id=k+4|0;f[id>>2]=0;f[k+8>>2]=0;qNb(k,Y(f[f[l>>2]>>2]|0,Cd)|0);if(Id){Id=k+8|0;lb=0;i=0;do{wa=f[(f[l>>2]|0)+(i<<2)>>2]|0;Qb=f[(f[q>>2]|0)+(i<<2)>>2]|0;Db=f[ka>>2]|0;Gd=f[o>>2]|0;hb=(Db-Gd|0)/28|0;Dd=Gd;Gd=Db;if(Qb>>>0<=hb>>>0){do if(Qb>>>0<hb>>>0){Db=Dd+(Qb*28|0)|0;if((Gd|0)==(Db|0))break;f[ka>>2]=Gd+(~(((Gd+-28-Db|0)>>>0)/28|0)*28|0)}while(0);if(Qb|0){Pd=Dd;zd=266}}else{iL(o,Qb-hb|0);Pd=f[o>>2]|0;zd=266}if((zd|0)==266){zd=0;Gd=(f[e>>2]|0)+(lb*28|0)|0;v=Gd+(Qb*28|0)|0;Rb=Gd;Gd=Pd;while(1){f[Gd>>2]=f[Rb>>2];f[Gd+4>>2]=f[Rb+4>>2];_a=Gd+8|0;Db=Rb+8|0;f[_a>>2]=f[Db>>2];f[_a+4>>2]=f[Db+4>>2];f[_a+8>>2]=f[Db+8>>2];f[_a+12>>2]=f[Db+12>>2];f[_a+16>>2]=f[Db+16>>2];Rb=Rb+28|0;if((Rb|0)==(v|0))break;else Gd=Gd+28|0}}lb=Qb+lb|0;hSb(o,wa);Gd=f[o>>2]|0;v=f[ka>>2]|0;if((Gd|0)!=(v|0)){Rb=Gd;do{Gd=f[id>>2]|0;if((Gd|0)==(f[Id>>2]|0))Lx(k,Rb);else{f[Gd>>2]=f[Rb>>2];f[Gd+4>>2]=f[Rb+4>>2];hb=Gd+8|0;Dd=Rb+8|0;f[hb>>2]=f[Dd>>2];f[hb+4>>2]=f[Dd+4>>2];f[hb+8>>2]=f[Dd+8>>2];f[hb+12>>2]=f[Dd+12>>2];f[hb+16>>2]=f[Dd+16>>2];f[id>>2]=Gd+28}Rb=Rb+28|0}while((Rb|0)!=(v|0))}i=i+1|0}while((i|0)<(Cd|0));Qd=Id}else Qd=k+8|0;Id=f[e>>2]|0;f[e>>2]=f[k>>2];f[k>>2]=Id;Cd=f[d>>2]|0;f[d>>2]=f[id>>2];f[id>>2]=Cd;i=e+8|0;lb=f[i>>2]|0;f[i>>2]=f[Qd>>2];f[Qd>>2]=lb;lb=Id;Qd=Cd;if(Id|0){if((Qd|0)!=(Id|0))f[id>>2]=Qd+(~(((Qd+-28-Id|0)>>>0)/28|0)*28|0);cYc(lb)}}lb=f[e>>2]|0;Id=(f[d>>2]|0)-lb|0;Qd=(Id|0)/28|0;id=f[f[$>>2]>>2]|0;Cd=(id>>>0)/((675553809>>>(f[C>>2]<<2&28)&15)>>>0)|0;i=lb;do if(Id|0){lb=C+16|0;Pd=0-Ed|0;zd=(X|0)<2;c:do if((Ed|0)<(Pd|0)){if(zd){v=0;while(1){Od=+fQ(0.0,0.0);Rb=f[e>>2]|0;n[Rb+(v*28|0)+12>>2]=Od;v=v+1|0;if(v>>>0>=Qd>>>0){Rd=Rb;break c}}}else{Sd=0;Td=i;Ud=id}while(1){v=f[Td+(Sd*28|0)+20>>2]|0;Bd=f[z>>2]|0;Rb=ALc(+n[Td+(Sd*28|0)+4>>2])|0;wa=(f[Bd+(v<<4)+4>>2]|0)+Rb|0;Rb=ALc(+n[Td+(Sd*28|0)>>2])|0;Qb=(f[lb>>2]|0)+(Y(wa,Ud)|0)+((f[Bd+(v<<4)>>2]|0)+Rb)|0;Rb=f[m>>2]|0;v=0;Bd=1;wa=0;while(1){Gd=f[Rb+(Bd<<2)>>2]|0;Dd=0-Gd|0;if((Gd|0)<(Dd|0)){Vd=0;Wd=wa}else{hb=Y(Bd,Cd)|0;Db=Dd;Dd=0;_a=wa;while(1){Cb=h[Qb+(Db+hb)>>0]|0;zb=h[Qb+(Db-hb)>>0]|0;Hd=Cb+Dd-zb|0;Pb=(Y(zb+Cb|0,Db)|0)+_a|0;if((Db|0)<(Gd|0)){Db=Db+1|0;Dd=Hd;_a=Pb}else{Vd=Hd;Wd=Pb;break}}}v=(Y(Vd,Bd)|0)+v|0;if((Bd|0)==(Ed|0))break;else{Bd=Bd+1|0;wa=Wd}}Od=+fQ(+(v|0),+(Wd|0));wa=f[e>>2]|0;n[wa+(Sd*28|0)+12>>2]=Od;Bd=Sd+1|0;if(Bd>>>0>=Qd>>>0){Rd=wa;break c}Sd=Bd;Td=wa;Ud=f[f[$>>2]>>2]|0}}else{if(zd){wa=0;Bd=i;Qb=id;while(1){Rb=f[Bd+(wa*28|0)+20>>2]|0;jd=f[z>>2]|0;_a=ALc(+n[Bd+(wa*28|0)+4>>2])|0;Dd=(f[jd+(Rb<<4)+4>>2]|0)+_a|0;_a=ALc(+n[Bd+(wa*28|0)>>2])|0;Db=(f[lb>>2]|0)+(Y(Dd,Qb)|0)+((f[jd+(Rb<<4)>>2]|0)+_a)|0;_a=0;Rb=Pd;while(1){_a=(Y(h[Db+Rb>>0]|0,Rb)|0)+_a|0;if((Rb|0)>=(Ed|0))break;else Rb=Rb+1|0}Od=+fQ(0.0,+(_a|0));Rb=f[e>>2]|0;n[Rb+(wa*28|0)+12>>2]=Od;Db=wa+1|0;if(Db>>>0>=Qd>>>0){Rd=Rb;break c}wa=Db;Bd=Rb;Qb=f[f[$>>2]>>2]|0}}else{Xd=0;Yd=i;Zd=id}while(1){Qb=f[Yd+(Xd*28|0)+20>>2]|0;Bd=f[z>>2]|0;wa=ALc(+n[Yd+(Xd*28|0)+4>>2])|0;Rb=(f[Bd+(Qb<<4)+4>>2]|0)+wa|0;wa=ALc(+n[Yd+(Xd*28|0)>>2])|0;Db=(f[lb>>2]|0)+(Y(Rb,Zd)|0)+((f[Bd+(Qb<<4)>>2]|0)+wa)|0;wa=0;Qb=Pd;while(1){wa=(Y(h[Db+Qb>>0]|0,Qb)|0)+wa|0;if((Qb|0)>=(Ed|0))break;else Qb=Qb+1|0}Qb=f[m>>2]|0;_a=0;Bd=1;Rb=wa;while(1){v=f[Qb+(Bd<<2)>>2]|0;jd=0-v|0;if((v|0)<(jd|0)){_d=0;$d=Rb}else{Dd=Y(Bd,Cd)|0;Gd=jd;jd=0;hb=Rb;while(1){Pb=h[Db+(Gd+Dd)>>0]|0;Hd=h[Db+(Gd-Dd)>>0]|0;Cb=Pb+jd-Hd|0;zb=(Y(Hd+Pb|0,Gd)|0)+hb|0;if((Gd|0)<(v|0)){Gd=Gd+1|0;jd=Cb;hb=zb}else{_d=Cb;$d=zb;break}}}_a=(Y(_d,Bd)|0)+_a|0;if((Bd|0)==(Ed|0))break;else{Bd=Bd+1|0;Rb=$d}}Od=+fQ(+(_a|0),+($d|0));Rb=f[e>>2]|0;n[Rb+(Xd*28|0)+12>>2]=Od;Bd=Xd+1|0;if(Bd>>>0>=Qd>>>0){Rd=Rb;break c}Xd=Bd;Yd=Rb;Zd=f[f[$>>2]>>2]|0}}while(0);if((Id|0)<=0)break;Pd=f[B>>2]|0;lb=0;do{Od=+n[Pd+(f[Rd+(lb*28|0)+20>>2]<<2)>>2];zd=Rd+(lb*28|0)|0;n[zd>>2]=Od*+n[zd>>2];zd=Rd+(lb*28|0)+4|0;n[zd>>2]=Od*+n[zd>>2];lb=lb+1|0}while((lb|0)<(Qd|0))}while(0);EQ(t);EQ(s);s=r+36|0;t=f[s>>2]|0;do if(t|0){Qd=t+12|0;Rd=f[Qd>>2]|0;f[Qd>>2]=Rd+-1;if((Rd|0)!=1)break;V$(r)}while(0);f[s>>2]=0;s=r+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[Kb>>2]|0)>0){s=f[yb>>2]|0;yb=0;do{f[s+(yb<<2)>>2]=0;yb=yb+1|0}while((yb|0)<(f[Kb>>2]|0))}Kb=f[Sb>>2]|0;if((Kb|0)!=(kb|0))wL(Kb)}Kb=f[q>>2]|0;if(Kb|0){kb=f[Ld>>2]|0;if((kb|0)!=(Kb|0))f[Ld>>2]=kb+(~((kb+-4-Kb|0)>>>2)<<2);cYc(Kb)}Kb=f[o>>2]|0;if(Kb|0){kb=f[ka>>2]|0;if((kb|0)!=(Kb|0))f[ka>>2]=kb+(~(((kb+-28-Kb|0)>>>0)/28|0)*28|0);cYc(Kb)}Kb=f[m>>2]|0;if(Kb|0){kb=f[Jd>>2]|0;if((kb|0)!=(Kb|0))f[Jd>>2]=kb+(~((kb+-4-Kb|0)>>>2)<<2);cYc(Kb)}Kb=f[l>>2]|0;if(Kb|0){kb=f[Yb>>2]|0;if((kb|0)!=(Kb|0))f[Yb>>2]=kb+(~((kb+-4-Kb|0)>>>2)<<2);cYc(Kb)}}do if(S){Kb=(f[d>>2]|0)-(f[e>>2]|0)|0;if(!Kb){vS(g);break}ZS(g,(Kb|0)/28|0,32,0,-1,0,0);f[l>>2]=0;Kb=l+4|0;f[Kb>>2]=0;f[l+8>>2]=0;g1c(m|0,0,4096)|0;kb=f[R>>2]|0;if((kb|0)!=31){Yb=(kb|0)/-2|0;Jd=((kb|0)/2|0)+1|0;kb=Jd-Yb|0;if((Jd|0)==(Yb|0)){Jd=0;do{f[m+(Jd<<3)>>2]=Yb;f[m+(Jd<<3)+4>>2]=Yb;Jd=Jd+1|0}while((Jd|0)!=512);ae=m}else{Jd=0;ka=882399033;Ld=0;while(1){Sb=x1c(ka|0,0,-130063606,0)|0;yb=d1c(Sb|0,J|0,Ld|0,0)|0;Sb=J;f[m+(Jd<<3)>>2]=((yb>>>0)%(kb>>>0)|0)+Yb;s=x1c(yb|0,0,-130063606,0)|0;ka=d1c(s|0,J|0,Sb|0,0)|0;f[m+(Jd<<3)+4>>2]=((ka>>>0)%(kb>>>0)|0)+Yb;Jd=Jd+1|0;if((Jd|0)==512){ae=m;break}else Ld=J}}}else ae=111636;Ld=a+28|0;Jd=f[Ld>>2]|0;d:do switch(Jd|0){case 2:{Yb=l+8|0;kb=0;ka=0;Sb=0;while(1){s=ae+(kb<<3)|0;if((ka|0)==(Sb|0))Nw(l,s);else{f[ka>>2]=f[s>>2];f[ka+4>>2]=f[ae+(kb<<3)+4>>2];f[Kb>>2]=ka+8}s=kb+1|0;if((s|0)==512)break d;kb=s;ka=f[Kb>>2]|0;Sb=f[Yb>>2]|0}break}case 4:case 3:{pP(l,Jd<<7);Yb=0;Sb=305419896;ka=0;e:while(1){kb=Y(Yb,Jd)|0;s=0;yb=Sb;r=ka;while(1){t=f[l>>2]|0;if((s|0)>0){Rd=yb;Qd=r;while(1){Id=x1c(Rd|0,0,-130063606,0)|0;Zd=d1c(Id|0,J|0,Qd|0,0)|0;Id=J;Yd=Zd&511;Xd=f[ae+(Yd<<3)>>2]|0;$d=f[ae+(Yd<<3)+4>>2]|0;Yd=0;while(1){Ed=Yd+kb|0;if((f[t+(Ed<<3)>>2]|0)==(Xd|0)?(f[t+(Ed<<3)+4>>2]|0)==($d|0):0){be=Yd;break}Ed=Yd+1|0;if((Ed|0)<(s|0))Yd=Ed;else{be=Ed;break}}if((be|0)==(s|0)){ce=$d;de=Xd;ee=Zd;fe=Id;break}else{Rd=Zd;Qd=Id}}}else{if(s|0)break e;Qd=x1c(yb|0,0,-130063606,0)|0;Rd=d1c(Qd|0,J|0,r|0,0)|0;Qd=Rd&511;ce=f[ae+(Qd<<3)+4>>2]|0;de=f[ae+(Qd<<3)>>2]|0;ee=Rd;fe=J}Rd=s+kb|0;f[t+(Rd<<3)>>2]=de;f[t+(Rd<<3)+4>>2]=ce;s=s+1|0;if((s|0)==(Jd|0))break;else{yb=ee;r=fe}}Yb=Yb+1|0;if((Yb|0)==128)break d;else{Sb=ee;ka=fe}}while(1){}break}default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;ka=$Xc(48)|0;f[k>>2]=ka;f[k+8>>2]=-2147483600;f[k+4>>2]=38;T=ka;U=462527;V=T+38|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));b[ka+38>>0]=0;vM(-215,k,467518,462350,1158)}}while(0);if(ya){Jd=o+8|0;Sb=o+12|0;Yb=o+4|0;r=q+8|0;yb=q+4|0;s=Q+4|0;kb=k+36|0;_a=k+16|0;Rd=k+4|0;Qd=k+40|0;Yd=k+44|0;Ed=k+48|0;_d=0;do{Z$(k,C,(f[z>>2]|0)+(_d<<4)|0);f[Jd>>2]=0;f[Sb>>2]=0;f[o>>2]=16842752;f[Yb>>2]=k;Cd=r;f[Cd>>2]=0;f[Cd+4>>2]=0;f[q>>2]=33619968;f[yb>>2]=k;f[Q>>2]=7;f[s>>2]=7;Jqa(o,q,Q,2.0,2.0,4);Cd=f[kb>>2]|0;do if(Cd|0){id=Cd+12|0;i=f[id>>2]|0;f[id>>2]=i+-1;if((i|0)!=1)break;V$(k)}while(0);f[kb>>2]=0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[Rd>>2]|0)>0){Cd=f[Qd>>2]|0;ka=0;do{f[Cd+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[Rd>>2]|0))}ka=f[Yd>>2]|0;if((ka|0)!=(Ed|0))wL(ka);_d=_d+1|0}while((_d|0)<(ja|0))}do if((eS(g)|0)==65536){_d=f[g+4>>2]|0;f[o>>2]=f[_d>>2];Ed=o+4|0;Yd=_d+4|0;f[Ed>>2]=f[Yd>>2];Rd=o+8|0;f[Rd>>2]=f[_d+8>>2];f[o+12>>2]=f[_d+12>>2];f[o+16>>2]=f[_d+16>>2];f[o+20>>2]=f[_d+20>>2];f[o+24>>2]=f[_d+24>>2];f[o+28>>2]=f[_d+28>>2];f[o+32>>2]=f[_d+32>>2];Qd=f[_d+36>>2]|0;f[o+36>>2]=Qd;f[o+40>>2]=Rd;Rd=o+48|0;_a=o+44|0;f[_a>>2]=Rd;f[Rd>>2]=0;f[o+52>>2]=0;if(Qd|0){Rd=Qd+12|0;f[Rd>>2]=(f[Rd>>2]|0)+1}if((f[Yd>>2]|0)<3){Yd=f[_d+44>>2]|0;Rd=f[_a>>2]|0;f[Rd>>2]=f[Yd>>2];f[Rd+4>>2]=f[Yd+4>>2];break}else{f[Ed>>2]=0;U$(o,_d);break}}else bS(o,g,-1);while(0);_d=f[Ld>>2]|0;Ed=f[ia>>2]|0;Yd=f[e>>2]|0;Rd=(f[d>>2]|0)-Yd|0;_a=(Rd|0)/28|0;f:do if((Rd|0)>0){Qd=C+16|0;kb=o+16|0;s=o+44|0;yb=f[B>>2]|0;r=0;Yb=Yd;g:while(1){Sb=f[Yb+(r*28|0)+20>>2]|0;Jd=f[z>>2]|0;Od=1.0/+n[yb+(Sb<<2)>>2];Nd=+n[Yb+(r*28|0)+12>>2]*.01745329238474369;W=+O(+Nd);Ia=+P(+Nd);ka=ALc(Od*+n[Yb+(r*28|0)+4>>2])|0;Cd=(f[Jd+(Sb<<4)+4>>2]|0)+ka|0;ka=ALc(Od*+n[Yb+(r*28|0)>>2])|0;i=(f[Qd>>2]|0)+(Y(f[f[$>>2]>>2]|0,Cd)|0)+((f[Jd+(Sb<<4)>>2]|0)+ka)|0;ka=f[l>>2]|0;Sb=(f[kb>>2]|0)+(Y(f[f[s>>2]>>2]|0,r)|0)|0;switch(_d|0){case 2:{Jd=0;Cd=ka;while(1){Od=+(f[Cd>>2]|0);Nd=+(f[Cd+4>>2]|0);id=ALc(W*Od-Ia*Nd)|0;Ud=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+id|0;id=b[Ud>>0]|0;Nd=+(f[Cd+8>>2]|0);Od=+(f[Cd+12>>2]|0);Ud=ALc(W*Nd-Ia*Od)|0;Td=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Ud|0;Ud=(id&255)<(h[Td>>0]|0)&1;Od=+(f[Cd+16>>2]|0);Nd=+(f[Cd+20>>2]|0);Td=ALc(W*Od-Ia*Nd)|0;id=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Td|0;Td=b[id>>0]|0;Nd=+(f[Cd+24>>2]|0);Od=+(f[Cd+28>>2]|0);id=ALc(W*Nd-Ia*Od)|0;Sd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+id|0;id=((Td&255)<(h[Sd>>0]|0)&1)<<1|Ud;Od=+(f[Cd+32>>2]|0);Nd=+(f[Cd+36>>2]|0);Ud=ALc(W*Od-Ia*Nd)|0;Sd=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Ud|0;Ud=b[Sd>>0]|0;Nd=+(f[Cd+40>>2]|0);Od=+(f[Cd+44>>2]|0);Sd=ALc(W*Nd-Ia*Od)|0;Td=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Sd|0;Sd=id|((Ud&255)<(h[Td>>0]|0)&1)<<2;Od=+(f[Cd+48>>2]|0);Nd=+(f[Cd+52>>2]|0);Td=ALc(W*Od-Ia*Nd)|0;Ud=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Td|0;Td=b[Ud>>0]|0;Nd=+(f[Cd+56>>2]|0);Od=+(f[Cd+60>>2]|0);Ud=ALc(W*Nd-Ia*Od)|0;id=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Ud|0;Ud=Sd|((Td&255)<(h[id>>0]|0)&1)<<3;Od=+(f[Cd+64>>2]|0);Nd=+(f[Cd+68>>2]|0);id=ALc(W*Od-Ia*Nd)|0;Td=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+id|0;id=b[Td>>0]|0;Nd=+(f[Cd+72>>2]|0);Od=+(f[Cd+76>>2]|0);Td=ALc(W*Nd-Ia*Od)|0;Sd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Td|0;Td=Ud|((id&255)<(h[Sd>>0]|0)&1)<<4;Od=+(f[Cd+80>>2]|0);Nd=+(f[Cd+84>>2]|0);Sd=ALc(W*Od-Ia*Nd)|0;id=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Sd|0;Sd=b[id>>0]|0;Nd=+(f[Cd+88>>2]|0);Od=+(f[Cd+92>>2]|0);id=ALc(W*Nd-Ia*Od)|0;Ud=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+id|0;id=Td|((Sd&255)<(h[Ud>>0]|0)&1)<<5;Od=+(f[Cd+96>>2]|0);Nd=+(f[Cd+100>>2]|0);Ud=ALc(W*Od-Ia*Nd)|0;Sd=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Ud|0;Ud=b[Sd>>0]|0;Nd=+(f[Cd+104>>2]|0);Od=+(f[Cd+108>>2]|0);Sd=ALc(W*Nd-Ia*Od)|0;Td=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Sd|0;Sd=id|((Ud&255)<(h[Td>>0]|0)&1)<<6;Od=+(f[Cd+112>>2]|0);Nd=+(f[Cd+116>>2]|0);Td=ALc(W*Od-Ia*Nd)|0;Ud=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Td|0;Td=b[Ud>>0]|0;Nd=+(f[Cd+120>>2]|0);Od=+(f[Cd+124>>2]|0);Ud=ALc(W*Nd-Ia*Od)|0;id=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Ud|0;b[Sb+Jd>>0]=Sd|((Td&255)<(h[id>>0]|0)&1)<<7;Jd=Jd+1|0;if((Jd|0)==32)break;else Cd=Cd+128|0}break}case 3:{Cd=0;Jd=ka;while(1){Od=+(f[Jd>>2]|0);Nd=+(f[Jd+4>>2]|0);id=ALc(W*Od-Ia*Nd)|0;Td=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+id|0;id=b[Td>>0]|0;Nd=+(f[Jd+8>>2]|0);Od=+(f[Jd+12>>2]|0);Td=ALc(W*Nd-Ia*Od)|0;Sd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Td|0;Td=b[Sd>>0]|0;Od=+(f[Jd+16>>2]|0);Nd=+(f[Jd+20>>2]|0);Sd=ALc(W*Od-Ia*Nd)|0;Ud=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Sd|0;Sd=b[Ud>>0]|0;Nd=+(f[Jd+24>>2]|0);Od=+(f[Jd+28>>2]|0);Ud=ALc(W*Nd-Ia*Od)|0;Wd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Ud|0;Ud=b[Wd>>0]|0;Od=+(f[Jd+32>>2]|0);Nd=+(f[Jd+36>>2]|0);Wd=ALc(W*Od-Ia*Nd)|0;Vd=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Wd|0;Wd=b[Vd>>0]|0;Nd=+(f[Jd+40>>2]|0);Od=+(f[Jd+44>>2]|0);Vd=ALc(W*Nd-Ia*Od)|0;X=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Vd|0;Vd=b[X>>0]|0;Od=+(f[Jd+48>>2]|0);Nd=+(f[Jd+52>>2]|0);X=ALc(W*Od-Ia*Nd)|0;lb=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+X|0;X=b[lb>>0]|0;Nd=+(f[Jd+56>>2]|0);Od=+(f[Jd+60>>2]|0);lb=ALc(W*Nd-Ia*Od)|0;Pd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+lb|0;lb=b[Pd>>0]|0;Od=+(f[Jd+64>>2]|0);Nd=+(f[Jd+68>>2]|0);Pd=ALc(W*Od-Ia*Nd)|0;zd=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Pd|0;Pd=b[zd>>0]|0;Nd=+(f[Jd+72>>2]|0);Od=+(f[Jd+76>>2]|0);zd=ALc(W*Nd-Ia*Od)|0;Rb=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+zd|0;zd=b[Rb>>0]|0;Od=+(f[Jd+80>>2]|0);Nd=+(f[Jd+84>>2]|0);Rb=ALc(W*Od-Ia*Nd)|0;Bd=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Rb|0;Rb=b[Bd>>0]|0;Nd=+(f[Jd+88>>2]|0);Od=+(f[Jd+92>>2]|0);Bd=ALc(W*Nd-Ia*Od)|0;Db=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Bd|0;Bd=b[Db>>0]|0;b[Sb+Cd>>0]=((Vd&255)>(Wd&255)?((Vd&255)>(Ud&255)?2:0):(Wd&255)>(Ud&255)&1)<<2|((Sd&255)>(Td&255)?((Sd&255)>(id&255)?2:0):(Td&255)>(id&255)&1)|((Pd&255)>(lb&255)?((Pd&255)>(X&255)?2:0):(lb&255)>(X&255)&1)<<4|((Bd&255)>(Rb&255)?((Bd&255)>(zd&255)?2:0):(Rb&255)>(zd&255)&1)<<6;Cd=Cd+1|0;if((Cd|0)==32)break;else Jd=Jd+96|0}break}case 4:{Jd=0;Cd=ka;while(1){Od=+(f[Cd>>2]|0);Nd=+(f[Cd+4>>2]|0);zd=ALc(W*Od-Ia*Nd)|0;Rb=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+zd|0;zd=b[Rb>>0]|0;Nd=+(f[Cd+8>>2]|0);Od=+(f[Cd+12>>2]|0);Rb=ALc(W*Nd-Ia*Od)|0;Bd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Rb|0;Rb=b[Bd>>0]|0;Od=+(f[Cd+16>>2]|0);Nd=+(f[Cd+20>>2]|0);Bd=ALc(W*Od-Ia*Nd)|0;X=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Bd|0;Bd=b[X>>0]|0;Nd=+(f[Cd+24>>2]|0);Od=+(f[Cd+28>>2]|0);X=ALc(W*Nd-Ia*Od)|0;lb=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+X|0;X=b[lb>>0]|0;lb=(Rb&255)>(zd&255);Pd=(X&255)>(Bd&255);Od=+(f[Cd+32>>2]|0);Nd=+(f[Cd+36>>2]|0);id=ALc(W*Od-Ia*Nd)|0;Td=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+id|0;id=b[Td>>0]|0;Nd=+(f[Cd+40>>2]|0);Od=+(f[Cd+44>>2]|0);Td=ALc(W*Nd-Ia*Od)|0;Sd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Td|0;Td=b[Sd>>0]|0;Od=+(f[Cd+48>>2]|0);Nd=+(f[Cd+52>>2]|0);Sd=ALc(W*Od-Ia*Nd)|0;Ud=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Sd|0;Sd=b[Ud>>0]|0;Nd=+(f[Cd+56>>2]|0);Od=+(f[Cd+60>>2]|0);Ud=ALc(W*Nd-Ia*Od)|0;Wd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Ud|0;Ud=b[Wd>>0]|0;Wd=(Td&255)>(id&255);Vd=(Ud&255)>(Sd&255);Od=+(f[Cd+64>>2]|0);Nd=+(f[Cd+68>>2]|0);Db=ALc(W*Od-Ia*Nd)|0;Qb=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+Db|0;Db=b[Qb>>0]|0;Nd=+(f[Cd+72>>2]|0);Od=+(f[Cd+76>>2]|0);Qb=ALc(W*Nd-Ia*Od)|0;wa=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Qb|0;Qb=b[wa>>0]|0;Od=+(f[Cd+80>>2]|0);Nd=+(f[Cd+84>>2]|0);wa=ALc(W*Od-Ia*Nd)|0;hb=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+wa|0;wa=b[hb>>0]|0;Nd=+(f[Cd+88>>2]|0);Od=+(f[Cd+92>>2]|0);hb=ALc(W*Nd-Ia*Od)|0;jd=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+hb|0;hb=b[jd>>0]|0;jd=(Qb&255)>(Db&255);Gd=(hb&255)>(wa&255);Od=+(f[Cd+96>>2]|0);Nd=+(f[Cd+100>>2]|0);v=ALc(W*Od-Ia*Nd)|0;Dd=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+v|0;v=b[Dd>>0]|0;Nd=+(f[Cd+104>>2]|0);Od=+(f[Cd+108>>2]|0);Dd=ALc(W*Nd-Ia*Od)|0;zb=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Dd|0;Dd=b[zb>>0]|0;Od=+(f[Cd+112>>2]|0);Nd=+(f[Cd+116>>2]|0);zb=ALc(W*Od-Ia*Nd)|0;Cb=i+(Y(ALc(Ia*Od+W*Nd)|0,Ed)|0)+zb|0;zb=b[Cb>>0]|0;Nd=+(f[Cd+120>>2]|0);Od=+(f[Cd+124>>2]|0);Cb=ALc(W*Nd-Ia*Od)|0;Pb=i+(Y(ALc(Ia*Nd+W*Od)|0,Ed)|0)+Cb|0;Cb=b[Pb>>0]|0;Pb=(Dd&255)>(v&255);Hd=(Cb&255)>(zb&255);b[Sb+Jd>>0]=(((Wd?Td:id)&255)>((Vd?Ud:Sd)&255)?(Wd?4:0):Vd?12:8)|(((lb?Rb:zd)&255)>((Pd?X:Bd)&255)?lb&1:Pd?3:2)|(((jd?Qb:Db)&255)>((Gd?hb:wa)&255)?(jd?16:0):Gd?48:32)|(((Pb?Dd:v)&255)>((Hd?Cb:zb)&255)?(Pb?64:0):Hd?192:128);Jd=Jd+1|0;if((Jd|0)==32)break;else Cd=Cd+128|0}break}default:break g}Cd=r+1|0;if((Cd|0)>=(_a|0))break f;r=Cd;Yb=f[e>>2]|0}Yb=$Xc(48)|0;f[k>>2]=Yb;f[k+8>>2]=-2147483600;f[k+4>>2]=38;T=Yb;U=462566;V=T+38|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));b[Yb+38>>0]=0;vM(-201,k,462605,462350,342)}while(0);_a=o+36|0;Ed=f[_a>>2]|0;do if(Ed|0){_d=Ed+12|0;Yd=f[_d>>2]|0;f[_d>>2]=Yd+-1;if((Yd|0)!=1)break;V$(o)}while(0);f[_a>>2]=0;Ed=o+16|0;Yd=o+4|0;f[Ed>>2]=0;f[Ed+4>>2]=0;f[Ed+8>>2]=0;f[Ed+12>>2]=0;if((f[Yd>>2]|0)>0){Ed=f[o+40>>2]|0;_d=0;do{f[Ed+(_d<<2)>>2]=0;_d=_d+1|0}while((_d|0)<(f[Yd>>2]|0))}Yd=f[o+44>>2]|0;if((Yd|0)!=(o+48|0))wL(Yd);Yd=f[l>>2]|0;if(Yd|0){_d=f[Kb>>2]|0;if((_d|0)!=(Yd|0))f[Kb>>2]=_d+(~((_d+-8-Yd|0)>>>3)<<3);cYc(Yd)}}while(0);l=f[Qa>>2]|0;do if(l|0){o=l+12|0;k=f[o>>2]|0;f[o>>2]=k+-1;if((k|0)!=1)break;V$(H)}while(0);f[Qa>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Ua>>2]|0)>0){Oa=f[Wa>>2]|0;Wa=0;do{f[Oa+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[Ua>>2]|0))}Ua=f[Ya>>2]|0;if((Ua|0)!=(Xa|0))wL(Ua);Ua=f[Ha>>2]|0;do if(Ua|0){Xa=Ua+12|0;Ya=f[Xa>>2]|0;f[Xa>>2]=Ya+-1;if((Ya|0)!=1)break;V$(G)}while(0);f[Ha>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[xa>>2]|0)>0){sa=f[za>>2]|0;za=0;do{f[sa+(za<<2)>>2]=0;za=za+1|0}while((za|0)<(f[xa>>2]|0))}xa=f[Ea>>2]|0;if((xa|0)!=(Fa|0))wL(xa);EQ(F);EQ(E);E=D+36|0;F=f[E>>2]|0;do if(F|0){xa=F+12|0;Fa=f[xa>>2]|0;f[xa>>2]=Fa+-1;if((Fa|0)!=1)break;V$(D)}while(0);f[E>>2]=0;E=D+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[da>>2]|0)>0){E=f[_>>2]|0;_=0;do{f[E+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[da>>2]|0))}da=f[ea>>2]|0;if((da|0)!=(ga|0))wL(da);da=C+36|0;ga=f[da>>2]|0;do if(ga|0){ea=ga+12|0;_=f[ea>>2]|0;f[ea>>2]=_+-1;if((_|0)!=1)break;V$(C)}while(0);f[da>>2]=0;da=C+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ba>>2]|0)>0){da=f[ha>>2]|0;ha=0;do{f[da+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ba>>2]|0))}ba=f[$>>2]|0;if((ba|0)!=(ia|0))wL(ba);ba=f[B>>2]|0;if(ba|0){B=f[aa>>2]|0;if((B|0)!=(ba|0))f[aa>>2]=B+(~((B+-4-ba|0)>>>2)<<2);cYc(ba)}ba=f[A>>2]|0;if(ba|0){A=f[fa>>2]|0;if((A|0)!=(ba|0))f[fa>>2]=A+(~((A+-4-ba|0)>>>2)<<2);cYc(ba)}ba=f[z>>2]|0;if(ba|0){z=f[c>>2]|0;if((z|0)!=(ba|0))f[c>>2]=z+(~((z+-16-ba|0)>>>4)<<4);cYc(ba)}ba=f[Ja>>2]|0;do if(ba|0){z=ba+12|0;c=f[z>>2]|0;f[z>>2]=c+-1;if((c|0)!=1)break;V$(y)}while(0);f[Ja>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[Ta>>2]|0)>0){Sa=f[y+40>>2]|0;Ja=0;do{f[Sa+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[Ta>>2]|0))}Ta=f[y+44>>2]|0;if((Ta|0)!=(y+48|0))wL(Ta);Ta=f[Aa>>2]|0;do if(Ta|0){y=Ta+12|0;Ja=f[y>>2]|0;f[y>>2]=Ja+-1;if((Ja|0)!=1)break;V$(x)}while(0);f[Aa>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[ra>>2]|0)>0){la=f[x+40>>2]|0;Aa=0;do{f[la+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[ra>>2]|0))}ra=f[x+44>>2]|0;if((ra|0)!=(x+48|0))wL(ra);u=j;return}function XMb(a){a=a|0;return 32}function YMb(a){a=a|0;return 0}function ZMb(a){a=a|0;var b=0;switch(f[a+28>>2]|0){case 2:{b=6;break}case 4:case 3:{b=7;break}default:b=-1}return b|0}function _Mb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function $Mb(a){a=a|0;return f[a+4>>2]|0}function aNb(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function bNb(a){a=a|0;return +(+p[a+8>>3])}function cNb(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function dNb(a){a=a|0;return f[a+16>>2]|0}function eNb(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function fNb(a){a=a|0;return f[a+20>>2]|0}function gNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if((c|0)>-1){f[a+24>>2]=c;u=d;return}else{d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=16;c=d;a=462319;g=c+16|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));b[d+16>>0]=0;vM(-215,e,462336,462350,676)}}function hNb(a){a=a|0;return f[a+24>>2]|0}function iNb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function jNb(a){a=a|0;return f[a+28>>2]|0}function kNb(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function lNb(a){a=a|0;return f[a+32>>2]|0}function mNb(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function nNb(a){a=a|0;return f[a+36>>2]|0}function oNb(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function pNb(a){a=a|0;return f[a+40>>2]|0}function qNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/28|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>153391689){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}h=f[g>>2]|0;i=$Xc(b*28|0)|0;j=i+(((h-d|0)/28|0)*28|0)|0;d=j;k=i+(b*28|0)|0;b=h;if((b|0)==(e|0)){l=d;m=h}else{h=b;b=d;i=j;do{j=h;h=h+-28|0;f[i+-28>>2]=f[h>>2];f[i+-24>>2]=f[j+-24>>2];n=i+-20|0;o=j+-20|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];f[n+16>>2]=f[o+16>>2];i=b+-28|0;b=i}while((h|0)!=(e|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;if(!m)return;cYc(m);return}function rNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)kWc(a);d=b*12|0;e=$Xc(d)|0;f[a>>2]=e;g=e+(b*12|0)|0;f[a+8>>2]=g;g1c(e|0,0,d|0)|0;f[c>>2]=g;return}function sNb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0;m=u;u=u+16|0;n=m;if((h|0)>-1){o=$Xc(64)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=115740;q=o+16|0;yP(q);f[q>>2]=111500;f[o+20>>2]=c;p[o+24>>3]=d;f[o+32>>2]=e;f[o+36>>2]=g;f[o+40>>2]=h;f[o+44>>2]=i;f[o+48>>2]=j;f[o+52>>2]=k;f[o+56>>2]=l;f[a>>2]=q;f[a+4>>2]=o;u=m;return}else{m=$Xc(16)|0;f[n>>2]=m;f[n+8>>2]=-2147483632;f[n+4>>2]=15;o=m;a=462642;q=o+15|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));b[m+15>>0]=0;vM(-215,n,467262,462350,1209)}}function tNb(a){a=a|0;f[a>>2]=115740;WRb(a+16|0);NXc(a);return}function uNb(a){a=a|0;f[a>>2]=115740;WRb(a+16|0);NXc(a);cYc(a);return}function vNb(a){a=a|0;WRb(a+16|0);return}function wNb(a){a=a|0;cYc(a);return}function xNb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,462724)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function yNb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=$Xc(44)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=115768;k=j+12|0;yP(k);f[k>>2]=115796;f[j+16>>2]=b;f[j+20>>2]=d;f[j+24>>2]=c;n[j+28>>2]=e;f[j+32>>2]=g;f[j+36>>2]=h;f[j+40>>2]=i;f[a>>2]=k;f[a+4>>2]=j;return}function zNb(a){a=a|0;WRb(a);cYc(a);return}function ANb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;zP(a,c);g=e+11|0;b[g>>0]=10;h=e;i=462962;j=h+10|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+10>>0]=0;k=s5(c,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=a+4|0;if(_i[f[(f[k>>2]|0)+12>>2]&2047](k)|0){l=k+4|0;if((f[l>>2]|0)==6){m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=30;h=m;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[m+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(k,k+8|0,f[g>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}l=$Xc(32)|0;f[e>>2]=l;f[e+8>>2]=-2147483616;f[e+4>>2]=19;h=l;i=462973;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[l+19>>0]=0;l=s5(c,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);g=a+8|0;if(_i[f[(f[l>>2]|0)+12>>2]&2047](l)|0){k=l+4|0;if((f[k>>2]|0)==6){m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=30;h=m;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[m+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(l,l+8|0,f[g>>2]|0);if(f[k>>2]&4|0)f[k>>2]=6}k=$Xc(16)|0;f[e>>2]=k;f[e+8>>2]=-2147483632;f[e+4>>2]=15;h=k;i=462993;j=h+15|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[k+15>>0]=0;k=s5(c,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);g=a+12|0;if(_i[f[(f[k>>2]|0)+12>>2]&2047](k)|0){l=k+4|0;if((f[l>>2]|0)==6){m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=30;h=m;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[m+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(k,k+8|0,f[g>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=e+11|0;b[l>>0]=9;h=e;i=470916;j=h+9|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+9>>0]=0;g=s5(c,e)|0;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);l=a+16|0;if(_i[f[(f[g>>2]|0)+12>>2]&2047](g)|0){k=g+4|0;if((f[k>>2]|0)==6){m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=30;h=m;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[m+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(g,g+8|0,+n[l>>2]);if(f[k>>2]&4|0)f[k>>2]=6}f[e+8>>2]=0;k=e+11|0;b[k>>0]=7;b[e>>0]=b[463009]|0;b[e+1>>0]=b[463010]|0;b[e+2>>0]=b[463011]|0;b[e+3>>0]=b[463012]|0;b[e+4>>0]=b[463013]|0;b[e+5>>0]=b[463014]|0;b[e+6>>0]=b[463015]|0;b[e+7>>0]=0;l=s5(c,e)|0;if((b[k>>0]|0)<0)cYc(f[e>>2]|0);k=a+20|0;if(_i[f[(f[l>>2]|0)+12>>2]&2047](l)|0){g=l+4|0;if((f[g>>2]|0)==6){m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=30;h=m;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[m+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(l,l+8|0,f[k>>2]|0);if(f[g>>2]&4|0)f[g>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=9;h=e;i=463017;j=h+9|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+9>>0]=0;k=s5(c,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=a+24|0;if(_i[f[(f[k>>2]|0)+12>>2]&2047](k)|0){l=k+4|0;if((f[l>>2]|0)==6){m=$Xc(32)|0;f[e>>2]=m;f[e+8>>2]=-2147483616;f[e+4>>2]=30;h=m;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[m+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(k,k+8|0,f[g>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}l=$Xc(16)|0;f[e>>2]=l;f[e+8>>2]=-2147483632;f[e+4>>2]=11;h=l;i=463027;j=h+11|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[l+11>>0]=0;l=s5(c,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);c=a+28|0;if(!(_i[f[(f[l>>2]|0)+12>>2]&2047](l)|0)){u=d;return}a=l+4|0;if((f[a>>2]|0)==6){g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=30;h=g;i=473382;j=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(l,l+8|0,f[c>>2]|0);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function BNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0;c=u;u=u+96|0;d=c+72|0;e=c+60|0;g=c+48|0;h=c+36|0;i=c+24|0;j=c+12|0;k=c;i5(d,b,462962);l=H5(d)|0;f[a+4>>2]=l;i5(e,b,462973);l=H5(e)|0;f[a+8>>2]=l;i5(g,b,462993);l=H5(g)|0;f[a+12>>2]=l;i5(h,b,470916);m=+I5(h);n[a+16>>2]=m;i5(i,b,463009);h=H5(i)|0;f[a+20>>2]=h;i5(j,b,463017);h=H5(j)|0;f[a+24>>2]=h;i5(k,b,463027);b=H5(k)|0;f[a+28>>2]=b;u=c;return}function CNb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+416|0;j=i+336|0;k=i+56|0;l=i;if(sS(c)|0){m=$Xc(16)|0;f[j>>2]=m;f[j+8>>2]=-2147483632;f[j+4>>2]=15;o=m;p=462743;q=o+15|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+15>>0]=0;vM(-215,j,467518,462759,172)}n[j+16>>2]=1.600000023841858;n[j+20>>2]=1.5;n[j+24>>2]=1.0;n[j+36>>2]=9.999999747378752e-06;f[j+52>>2]=10;n[j+56>>2]=1.0000000474974513e-03;n[j+60>>2]=.699999988079071;f[j+64>>2]=300;f[j+40>>2]=f[a+4>>2];f[j+48>>2]=f[a+8>>2];f[j+44>>2]=f[a+12>>2];m=mS(c,-1)|0;f[j+8>>2]=m;m=lS(c,-1)|0;f[j+12>>2]=m;f[j+32>>2]=f[a+16>>2];f[j>>2]=f[a+20>>2];f[j+4>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];COb(k,j);KOb(k,c);if(!h)POb(k,e);if(!(sS(d)|0)){do if((eS(d)|0)==65536){h=f[d+4>>2]|0;f[l>>2]=f[h>>2];c=l+4|0;j=h+4|0;f[c>>2]=f[j>>2];m=l+8|0;f[m>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];r=f[h+36>>2]|0;f[l+36>>2]=r;f[l+40>>2]=m;m=l+48|0;s=l+44|0;f[s>>2]=m;f[m>>2]=0;f[l+52>>2]=0;if(r|0){m=r+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;m=f[s>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];break}else{f[c>>2]=0;U$(l,h);break}}else bS(l,d,-1);while(0);mSb(e,l);d=l+36|0;h=f[d>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)V$(l);f[d>>2]=0;d=l+16|0;h=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[h>>2]|0)>0){d=f[l+40>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[h>>2]|0))}h=f[l+44>>2]|0;if((h|0)!=(l+48|0))wL(h)}if(!(aT(g)|0)){UNb(k);u=i;return}WOb(k,e,g);if(!(sS(g)|0)?(e=mS(g,-1)|0,(e|0)!=(_i[f[(f[a>>2]|0)+52>>2]&2047](a)|0)):0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=$Xc(64)|0;f[l>>2]=e;f[l+8>>2]=-2147483584;f[l+4>>2]=63;o=e;p=462832;q=o+63|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[e+63>>0]=0;vM(-215,l,467518,462759,202)}if(sS(g)|0){UNb(k);u=i;return}e=dS(g,-1)|0;if((e|0)==(_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0)){UNb(k);u=i;return}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;i=$Xc(80)|0;f[l>>2]=i;f[l+8>>2]=-2147483568;f[l+4>>2]=65;o=i;p=462896;q=o+65|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[i+65>>0]=0;vM(-215,l,467518,462759,203)}}function DNb(a){a=a|0;var b=0,c=0;switch(f[a+4>>2]|0){case 4:case 5:{b=f[a+12>>2]|0;if(!b){c=(((f[a+8>>2]|0)*162|0)+7|0)>>>3;return c|0}else{c=(b+7|0)>>>3;return c|0}break}case 2:case 3:{c=64;return c|0}default:{c=-1;return c|0}}return 0}function ENb(a){a=a|0;var b=0;switch(f[a+4>>2]|0){case 2:case 3:{b=5;break}case 4:case 5:{b=0;break}default:b=-1}return b|0}function FNb(a){a=a|0;var b=0;switch(f[a+4>>2]|0){case 2:case 3:{b=4;break}case 4:case 5:{b=6;break}default:b=-1}return b|0}function GNb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function HNb(a){a=a|0;return f[a+4>>2]|0}function INb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function JNb(a){a=a|0;return f[a+12>>2]|0}function KNb(a,b){a=a|0;b=b|0;f[a+8>>2]=b;return}function LNb(a){a=a|0;return f[a+8>>2]|0}function MNb(a,b){a=a|0;b=+b;n[a+16>>2]=b;return}function NNb(a){a=a|0;return +(+n[a+16>>2])}function ONb(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function PNb(a){a=a|0;return f[a+20>>2]|0}function QNb(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function RNb(a){a=a|0;return f[a+24>>2]|0}function SNb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function TNb(a){a=a|0;return f[a+28>>2]|0}function UNb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+224|0;c=a+260|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+240|0;b=a+228|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+264>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+268>>2]|0;if((b|0)!=(a+272|0))wL(b);b=a+168|0;d=a+204|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+184|0;b=a+172|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+208>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+212>>2]|0;if((b|0)!=(a+216|0))wL(b);b=a+112|0;c=a+148|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+128|0;b=a+116|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+152>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+156>>2]|0;if((b|0)!=(a+160|0))wL(b);b=f[a+100>>2]|0;if(b|0){d=a+104|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=a+88|0;c=f[b>>2]|0;if(c|0){d=a+92|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-4-i|0)>>>2)<<2);cYc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}cYc(g)}g=a+68|0;b=f[g>>2]|0;if(!b)return;j=a+72|0;a=f[j>>2]|0;if((a|0)==(b|0))l=b;else{h=a;do{a=h+-316|0;f[j>>2]=a;VNb(a);h=f[j>>2]|0}while((h|0)!=(b|0));l=f[g>>2]|0}cYc(l);return}function VNb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+224|0;c=a+260|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+240|0;b=a+228|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+264>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+268>>2]|0;if((b|0)!=(a+272|0))wL(b);b=a+168|0;d=a+204|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+184|0;b=a+172|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+208>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+212>>2]|0;if((b|0)!=(a+216|0))wL(b);b=a+112|0;c=a+148|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+128|0;b=a+116|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+152>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+156>>2]|0;if((b|0)!=(a+160|0))wL(b);b=a+56|0;d=a+92|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+72|0;b=a+60|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+96>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;c=f[b>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;c=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[a+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+44>>2]|0;if((c|0)==(a+48|0))return;wL(c);return}function WNb(a){a=a|0;f[a>>2]=115768;WRb(a+12|0);NXc(a);return}function XNb(a){a=a|0;f[a>>2]=115768;WRb(a+12|0);NXc(a);cYc(a);return}function YNb(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function ZNb(a){a=a|0;cYc(a);return}function _Nb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;switch(d|0){case 16:{h=115980;break}case 12:{h=116108;break}default:h=(d|0)==8?115916:0}if(!((a|0)!=0&(h|0)!=0)){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=16;j=i;k=467763;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+16>>0]=0;vM(-215,g,463126,463138,74)}if((d|0)>0){g=0;do{i=(Y(f[h+(g<<3)+4>>2]|0,c)|0)+(f[h+(g<<3)>>2]|0)|0;f[a+(g<<2)>>2]=i;g=g+1|0}while((g|0)!=(d|0));if((d|0)<25)m=d;else{u=e;return}}else m=0;do{f[a+(m<<2)>>2]=f[a+(m-d<<2)>>2];m=m+1|0}while((m|0)!=25);u=e;return}function $Nb(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e;i=h[a>>0]|0;j=0;do{d[g+(j<<1)>>1]=i-(h[a+(f[b+(j<<2)>>2]|0)>>0]|0);j=j+1|0}while((j|0)!=25);k=c;l=0;while(1){c=d[g+((l|1)<<1)>>1]|0;j=l;l=l+2|0;b=d[g+(l<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?c:a;if((b|0)>(k|0)){a=d[g+(j+4<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+5<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j+7<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+8<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j<<1)>>1]|0;b=(c|0)<(a|0)?c:a;c=(k|0)<(b|0)?b:k;b=d[g+(j+9<<1)>>1]|0;j=(b|0)<(a|0)?b:a;m=(c|0)<(j|0)?j:c}else m=k;if((l|0)>=16)break;else k=m}k=0-m|0;m=0;l=d[g+4>>1]|0;c=d[g+6>>1]|0;while(1){j=d[g+((m|1)<<1)>>1]|0;a=m;m=m+2|0;b=l<<16>>16;i=(j|0)<(b|0)?b:j;j=c<<16>>16;b=(i|0)<(j|0)?j:i;l=d[g+(a+4<<1)>>1]|0;i=l<<16>>16;j=(b|0)<(i|0)?i:b;c=d[g+(a+5<<1)>>1]|0;b=c<<16>>16;i=(j|0)<(b|0)?b:j;if((i|0)<(k|0)){j=d[g+(a+6<<1)>>1]|0;b=(i|0)<(j|0)?j:i;i=d[g+(a+7<<1)>>1]|0;j=(b|0)<(i|0)?i:b;b=d[g+(a+8<<1)>>1]|0;i=(j|0)<(b|0)?b:j;j=d[g+(a<<1)>>1]|0;b=(i|0)<(j|0)?j:i;j=(b|0)<(k|0)?b:k;b=d[g+(a+9<<1)>>1]|0;a=(i|0)<(b|0)?b:i;n=(a|0)<(j|0)?a:j}else n=k;if((m|0)>=16)break;else k=n}u=e;return ~n|0}function aOb(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e;i=h[a>>0]|0;j=0;do{d[g+(j<<1)>>1]=i-(h[a+(f[b+(j<<2)>>2]|0)>>0]|0);j=j+1|0}while((j|0)!=19);k=c;l=0;while(1){c=d[g+((l|1)<<1)>>1]|0;j=l;l=l+2|0;b=d[g+(l<<1)>>1]|0;a=(b|0)<(c|0)?b:c;if((a|0)>(k|0)){c=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j+4<<1)>>1]|0;c=(a|0)<(b|0)?a:b;b=d[g+(j+5<<1)>>1]|0;a=(b|0)<(c|0)?b:c;c=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?c:a;a=d[g+(j<<1)>>1]|0;c=(a|0)<(b|0)?a:b;a=(k|0)<(c|0)?c:k;c=d[g+(j+7<<1)>>1]|0;j=(c|0)<(b|0)?c:b;m=(a|0)<(j|0)?j:a}else m=k;if((l|0)>=12)break;else k=m}k=0-m|0;m=0;l=d[g+4>>1]|0;while(1){a=d[g+((m|1)<<1)>>1]|0;j=m;m=m+2|0;b=l<<16>>16;c=(a|0)<(b|0)?b:a;a=d[g+(j+3<<1)>>1]|0;b=(c|0)<(a|0)?a:c;l=d[g+(j+4<<1)>>1]|0;c=l<<16>>16;a=(b|0)<(c|0)?c:b;if((a|0)<(k|0)){b=d[g+(j+5<<1)>>1]|0;c=(a|0)<(b|0)?b:a;a=d[g+(j+6<<1)>>1]|0;b=(c|0)<(a|0)?a:c;c=d[g+(j<<1)>>1]|0;a=(b|0)<(c|0)?c:b;c=(a|0)<(k|0)?a:k;a=d[g+(j+7<<1)>>1]|0;j=(b|0)<(a|0)?a:b;n=(j|0)<(c|0)?j:c}else n=k;if((m|0)>=12)break;else k=n}u=e;return ~n|0}function bOb(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;i=h[a>>0]|0;d[g>>1]=i-(h[a+(f[b>>2]|0)>>0]|0);d[g+2>>1]=i-(h[a+(f[b+4>>2]|0)>>0]|0);d[g+4>>1]=i-(h[a+(f[b+8>>2]|0)>>0]|0);d[g+6>>1]=i-(h[a+(f[b+12>>2]|0)>>0]|0);d[g+8>>1]=i-(h[a+(f[b+16>>2]|0)>>0]|0);d[g+10>>1]=i-(h[a+(f[b+20>>2]|0)>>0]|0);d[g+12>>1]=i-(h[a+(f[b+24>>2]|0)>>0]|0);d[g+14>>1]=i-(h[a+(f[b+28>>2]|0)>>0]|0);d[g+16>>1]=i-(h[a+(f[b+32>>2]|0)>>0]|0);d[g+18>>1]=i-(h[a+(f[b+36>>2]|0)>>0]|0);d[g+20>>1]=i-(h[a+(f[b+40>>2]|0)>>0]|0);d[g+22>>1]=i-(h[a+(f[b+44>>2]|0)>>0]|0);d[g+24>>1]=i-(h[a+(f[b+48>>2]|0)>>0]|0);b=d[g+2>>1]|0;a=d[g+4>>1]|0;i=(a|0)<(b|0)?a:b;if((i|0)>(c|0)){b=d[g+6>>1]|0;a=(b|0)<(i|0)?b:i;i=d[g+8>>1]|0;b=(i|0)<(a|0)?i:a;a=d[g>>1]|0;i=(a|0)<(b|0)?a:b;a=(i|0)>(c|0)?i:c;i=d[g+10>>1]|0;j=(i|0)<(b|0)?i:b;k=(a|0)<(j|0)?j:a}else k=c;c=d[g+6>>1]|0;a=d[g+8>>1]|0;j=(a|0)<(c|0)?a:c;if((j|0)>(k|0)){c=d[g+10>>1]|0;a=(c|0)<(j|0)?c:j;j=d[g+12>>1]|0;c=(j|0)<(a|0)?j:a;a=d[g+4>>1]|0;j=(a|0)<(c|0)?a:c;a=(k|0)<(j|0)?j:k;j=d[g+14>>1]|0;b=(j|0)<(c|0)?j:c;l=(a|0)<(b|0)?b:a}else l=k;k=d[g+10>>1]|0;a=d[g+12>>1]|0;b=(a|0)<(k|0)?a:k;if((b|0)>(l|0)){k=d[g+14>>1]|0;a=(k|0)<(b|0)?k:b;b=d[g+16>>1]|0;k=(b|0)<(a|0)?b:a;a=d[g+8>>1]|0;b=(a|0)<(k|0)?a:k;a=(l|0)<(b|0)?b:l;b=d[g+18>>1]|0;c=(b|0)<(k|0)?b:k;m=(a|0)<(c|0)?c:a}else m=l;l=d[g+14>>1]|0;a=d[g+16>>1]|0;c=(a|0)<(l|0)?a:l;if((c|0)>(m|0)){l=d[g+18>>1]|0;a=(l|0)<(c|0)?l:c;c=d[g+20>>1]|0;l=(c|0)<(a|0)?c:a;a=d[g+12>>1]|0;c=(a|0)<(l|0)?a:l;a=(m|0)<(c|0)?c:m;c=d[g+22>>1]|0;k=(c|0)<(l|0)?c:l;n=(a|0)<(k|0)?k:a}else n=m;m=0-n|0;n=d[g+2>>1]|0;a=d[g+4>>1]|0;k=(n|0)<(a|0)?a:n;n=d[g+6>>1]|0;a=(k|0)<(n|0)?n:k;if((a|0)<(m|0)){k=d[g+8>>1]|0;n=(a|0)<(k|0)?k:a;a=d[g>>1]|0;k=(n|0)<(a|0)?a:n;a=(k|0)<(m|0)?k:m;k=d[g+10>>1]|0;l=(n|0)<(k|0)?k:n;o=(l|0)<(a|0)?l:a}else o=m;m=d[g+6>>1]|0;a=d[g+8>>1]|0;l=(m|0)<(a|0)?a:m;m=d[g+10>>1]|0;a=(l|0)<(m|0)?m:l;if((a|0)<(o|0)){l=d[g+12>>1]|0;m=(a|0)<(l|0)?l:a;a=d[g+4>>1]|0;l=(m|0)<(a|0)?a:m;a=(l|0)<(o|0)?l:o;l=d[g+14>>1]|0;n=(m|0)<(l|0)?l:m;p=(n|0)<(a|0)?n:a}else p=o;o=d[g+10>>1]|0;a=d[g+12>>1]|0;n=(o|0)<(a|0)?a:o;o=d[g+14>>1]|0;a=(n|0)<(o|0)?o:n;if((a|0)<(p|0)){n=d[g+16>>1]|0;o=(a|0)<(n|0)?n:a;a=d[g+8>>1]|0;n=(o|0)<(a|0)?a:o;a=(n|0)<(p|0)?n:p;n=d[g+18>>1]|0;m=(o|0)<(n|0)?n:o;q=(m|0)<(a|0)?m:a}else q=p;p=d[g+14>>1]|0;a=d[g+16>>1]|0;m=(p|0)<(a|0)?a:p;p=d[g+18>>1]|0;a=(m|0)<(p|0)?p:m;if((a|0)>=(q|0)){r=q;s=~r;u=e;return s|0}m=d[g+20>>1]|0;p=(a|0)<(m|0)?m:a;a=d[g+12>>1]|0;m=(p|0)<(a|0)?a:p;a=(m|0)<(q|0)?m:q;q=d[g+22>>1]|0;g=(p|0)<(q|0)?q:p;r=(g|0)<(a|0)?g:a;s=~r;u=e;return s|0}function cOb(a,c){a=a|0;c=c|0;var d=0,e=0;d=a;e=c;c=d+48|0;do{f[d>>2]=f[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(c|0));e=a+48|0;d=a+80|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;b[a+76>>0]=1;dOb(a);return}function dOb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;b=u;u=u+704|0;c=b+236|0;d=b;e=b+232|0;g=b+228|0;h=b+224|0;i=a+8|0;if((f[i>>2]|0)>0){j=a+12|0;k=c+4|0;l=c+8|0;m=c+40|0;o=c+48|0;p=c+44|0;q=c+52|0;r=c+56|0;s=c+60|0;t=c+64|0;v=c+96|0;w=c+104|0;x=c+100|0;y=c+108|0;z=c+112|0;A=c+116|0;B=c+120|0;C=c+152|0;D=c+160|0;E=c+156|0;F=c+164|0;G=c+168|0;H=c+172|0;I=c+176|0;J=c+208|0;K=c+216|0;L=c+212|0;M=c+220|0;N=c+224|0;O=c+228|0;P=c+232|0;Q=c+264|0;R=c+272|0;S=c+268|0;T=c+276|0;U=c+280|0;V=c+284|0;W=c+288|0;X=c+320|0;Y=c+328|0;Z=c+324|0;_=c+332|0;$=c+336|0;aa=c+340|0;ba=c+344|0;ca=c+376|0;da=c+384|0;ea=c+380|0;fa=c+388|0;ga=c+392|0;ha=c+396|0;ia=c+400|0;ja=c+432|0;ka=c+440|0;la=c+436|0;ma=a+20|0;na=a+16|0;oa=c+56|0;pa=c+112|0;qa=c+168|0;ra=c+224|0;sa=c+280|0;ta=c+336|0;ua=c+392|0;va=a+4|0;wa=c+452|0;xa=c+448|0;ya=c+464|0;za=c+456|0;Aa=c+460|0;Ba=a+52|0;Ca=a+56|0;Da=a+48|0;Ea=0;Fa=f[j>>2]|0;while(1){if((Fa|0)>0){Ga=+(Ea|0);Ha=0;do{f[c>>2]=1124007936;Ia=k;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[m>>2]=l;f[p>>2]=o;f[o>>2]=0;f[q>>2]=0;f[r>>2]=1124007936;Ia=s;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[v>>2]=t;f[x>>2]=w;f[w>>2]=0;f[y>>2]=0;f[z>>2]=1124007936;Ia=A;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[C>>2]=B;f[E>>2]=D;f[D>>2]=0;f[F>>2]=0;f[G>>2]=1124007936;Ia=H;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[J>>2]=I;f[L>>2]=K;f[K>>2]=0;f[M>>2]=0;f[N>>2]=1124007936;Ia=O;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[Q>>2]=P;f[S>>2]=R;f[R>>2]=0;f[T>>2]=0;f[U>>2]=1124007936;Ia=V;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[X>>2]=W;f[Z>>2]=Y;f[Y>>2]=0;f[_>>2]=0;f[$>>2]=1124007936;Ia=aa;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[ca>>2]=ba;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;f[ga>>2]=1124007936;Ia=ha;Ja=Ia+36|0;do{f[Ia>>2]=0;Ia=Ia+4|0}while((Ia|0)<(Ja|0));f[ja>>2]=ia;f[la>>2]=ka;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;f[ka+16>>2]=0;f[ka+20>>2]=0;f[ka+24>>2]=0;p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,c,-1);Zj(d);p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,oa,-1);Zj(d);p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,pa,-1);Zj(d);p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,qa,-1);Zj(d);p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,ra,-1);Zj(d);p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,sa,-1);Zj(d);p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,ta,-1);Zj(d);p$(d,f[ma>>2]|0,f[na>>2]|0,5);Ia=f[d>>2]|0;ei[f[(f[Ia>>2]|0)+12>>2]&511](Ia,d,ua,-1);Zj(d);Ka=+n[va>>2];La=Ka*+Me(+(Ga+ +(Ha|0)/+(f[j>>2]|0)));n[wa>>2]=La;n[xa>>2]=La*La*.5;Ia=ALc(La)|0;f[ya>>2]=Ia;f[za>>2]=Ea;f[Aa>>2]=Ha;Ia=f[Ba>>2]|0;if((Ia|0)==(f[Ca>>2]|0))fOb(Da,c);else{eOb(Ia,c);f[Ba>>2]=(f[Ba>>2]|0)+468}bMb(c);Ha=Ha+1|0;Ia=f[j>>2]|0}while((Ha|0)<(Ia|0));Ma=Ia}else Ma=Fa;Ea=Ea+1|0;if((Ea|0)>=(f[i>>2]|0)){Na=Ba;Oa=Da;break}else Fa=Ma}}else{Na=a+52|0;Oa=a+48|0}Ma=f[Oa>>2]|0;if((((f[Na>>2]|0)-Ma|0)/468|0)>>>0<=1){u=b;return}Fa=d+4|0;Da=d+8|0;Ba=a+76|0;i=a+96|0;Ea=a+100|0;j=a+92|0;Ca=a+84|0;Aa=a+88|0;za=a+80|0;ya=a+72|0;a=1;xa=Ma;while(1){Ma=xa;f[c>>2]=0;f[d>>2]=0;f[Fa>>2]=0;f[Da>>2]=0;n[e>>2]=+n[Ma+(a*468|0)+448>>2]-+n[Ma+((a+-1|0)*468|0)+448>>2];f[g>>2]=1;n[h>>2]=.25;Ma=AOb(e,g,h,Ba,d)|0;f[c>>2]=Ma;wa=f[i>>2]|0;if((wa|0)==(f[Ea>>2]|0))Tv(j,c);else{f[wa>>2]=Ma;f[i>>2]=wa+4}Pa=f[Ca>>2]|0;if((Pa|0)==(f[Aa>>2]|0)){gOb(za,d);Qa=f[d>>2]|0}else{f[Pa>>2]=0;wa=Pa+4|0;f[wa>>2]=0;f[Pa+8>>2]=0;Ma=f[d>>2]|0;va=(f[Fa>>2]|0)-Ma|0;ua=va>>2;if(ua){if(ua>>>0>1073741823){Ra=20;break}na=$Xc(va)|0;f[wa>>2]=na;f[Pa>>2]=na;f[Pa+8>>2]=na+(ua<<2);ua=f[d>>2]|0;va=(f[Fa>>2]|0)-ua|0;if((va|0)>0){o1c(na|0,ua|0,va|0)|0;f[wa>>2]=na+(va>>>2<<2);Sa=ua}else Sa=ua}else Sa=Ma;f[Ca>>2]=(f[Ca>>2]|0)+12;Qa=Sa}f[ya>>2]=(f[ya>>2]|0)+1;if(Qa|0){Ma=f[Fa>>2]|0;if((Ma|0)!=(Qa|0))f[Fa>>2]=Ma+(~((Ma+-4-Qa|0)>>>2)<<2);cYc(Qa)}a=a+1|0;xa=f[Oa>>2]|0;if(a>>>0>=(((f[Na>>2]|0)-xa|0)/468|0)>>>0){Ra=13;break}}if((Ra|0)==13){u=b;return}else if((Ra|0)==20)kWc(Pa)}function eOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=f[b>>2];c=a+4|0;d=b+4|0;f[c>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];g=f[b+36>>2]|0;f[a+36>>2]=g;f[a+40>>2]=e;e=a+48|0;h=a+44|0;f[h>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){d=f[b+44>>2]|0;e=f[h>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2]}else{f[c>>2]=0;U$(a,b)}c=a+56|0;d=b+56|0;f[c>>2]=f[d>>2];e=a+60|0;h=b+60|0;f[e>>2]=f[h>>2];g=a+64|0;f[g>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[a+80>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];i=f[b+92>>2]|0;f[a+92>>2]=i;f[a+96>>2]=g;g=a+104|0;j=a+100|0;f[j>>2]=g;f[g>>2]=0;f[a+108>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+100>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(c,d)}d=a+112|0;c=b+112|0;f[d>>2]=f[c>>2];e=a+116|0;h=b+116|0;f[e>>2]=f[h>>2];g=a+120|0;f[g>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[a+136>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];j=f[b+148>>2]|0;f[a+148>>2]=j;f[a+152>>2]=g;g=a+160|0;i=a+156|0;f[i>>2]=g;f[g>>2]=0;f[a+164>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+156>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(d,c)}c=a+168|0;d=b+168|0;f[c>>2]=f[d>>2];e=a+172|0;h=b+172|0;f[e>>2]=f[h>>2];g=a+176|0;f[g>>2]=f[b+176>>2];f[a+180>>2]=f[b+180>>2];f[a+184>>2]=f[b+184>>2];f[a+188>>2]=f[b+188>>2];f[a+192>>2]=f[b+192>>2];f[a+196>>2]=f[b+196>>2];f[a+200>>2]=f[b+200>>2];i=f[b+204>>2]|0;f[a+204>>2]=i;f[a+208>>2]=g;g=a+216|0;j=a+212|0;f[j>>2]=g;f[g>>2]=0;f[a+220>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+212>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(c,d)}d=a+224|0;c=b+224|0;f[d>>2]=f[c>>2];e=a+228|0;h=b+228|0;f[e>>2]=f[h>>2];g=a+232|0;f[g>>2]=f[b+232>>2];f[a+236>>2]=f[b+236>>2];f[a+240>>2]=f[b+240>>2];f[a+244>>2]=f[b+244>>2];f[a+248>>2]=f[b+248>>2];f[a+252>>2]=f[b+252>>2];f[a+256>>2]=f[b+256>>2];j=f[b+260>>2]|0;f[a+260>>2]=j;f[a+264>>2]=g;g=a+272|0;i=a+268|0;f[i>>2]=g;f[g>>2]=0;f[a+276>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+268>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(d,c)}c=a+280|0;d=b+280|0;f[c>>2]=f[d>>2];e=a+284|0;h=b+284|0;f[e>>2]=f[h>>2];g=a+288|0;f[g>>2]=f[b+288>>2];f[a+292>>2]=f[b+292>>2];f[a+296>>2]=f[b+296>>2];f[a+300>>2]=f[b+300>>2];f[a+304>>2]=f[b+304>>2];f[a+308>>2]=f[b+308>>2];f[a+312>>2]=f[b+312>>2];i=f[b+316>>2]|0;f[a+316>>2]=i;f[a+320>>2]=g;g=a+328|0;j=a+324|0;f[j>>2]=g;f[g>>2]=0;f[a+332>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+324>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(c,d)}d=a+336|0;c=b+336|0;f[d>>2]=f[c>>2];e=a+340|0;h=b+340|0;f[e>>2]=f[h>>2];g=a+344|0;f[g>>2]=f[b+344>>2];f[a+348>>2]=f[b+348>>2];f[a+352>>2]=f[b+352>>2];f[a+356>>2]=f[b+356>>2];f[a+360>>2]=f[b+360>>2];f[a+364>>2]=f[b+364>>2];f[a+368>>2]=f[b+368>>2];j=f[b+372>>2]|0;f[a+372>>2]=j;f[a+376>>2]=g;g=a+384|0;i=a+380|0;f[i>>2]=g;f[g>>2]=0;f[a+388>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+380>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(d,c)}c=a+392|0;d=b+392|0;f[c>>2]=f[d>>2];e=a+396|0;h=b+396|0;f[e>>2]=f[h>>2];g=a+400|0;f[g>>2]=f[b+400>>2];f[a+404>>2]=f[b+404>>2];f[a+408>>2]=f[b+408>>2];f[a+412>>2]=f[b+412>>2];f[a+416>>2]=f[b+416>>2];f[a+420>>2]=f[b+420>>2];f[a+424>>2]=f[b+424>>2];i=f[b+428>>2]|0;f[a+428>>2]=i;f[a+432>>2]=g;g=a+440|0;j=a+436|0;f[j>>2]=g;f[g>>2]=0;f[a+444>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+436>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];k=a+448|0;l=b+448|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];return}else{f[e>>2]=0;U$(c,d);k=a+448|0;l=b+448|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];return}}function fOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/468|0;g=e+1|0;if(g>>>0>9177280)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/468|0;d=i<<1;j=i>>>0<4588640?(d>>>0<g>>>0?g:d):9177280;do if(j)if(j>>>0>9177280){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*468|0)|0;break}else k=0;while(0);d=k+(e*468|0)|0;e=d;g=k+(j*468|0)|0;eOb(d,b);b=d+468|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-468|0;eOb(e+-468|0,i);e=k+-468|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{h=h+-468|0;bMb(h)}while((h|0)!=(g|0))}if(!m)return;cYc(m);return}function gOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;xF(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{d=e+-12|0;o=i;i=i+-12|0;f[d>>2]=0;p=e+-8|0;f[p>>2]=0;f[e+-4>>2]=0;f[d>>2]=f[i>>2];d=o+-8|0;f[p>>2]=f[d>>2];p=o+-4|0;f[e+-4>>2]=f[p>>2];f[p>>2]=0;f[d>>2]=0;f[i>>2]=0;e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-4-b|0)>>>2)<<2);cYc(b)}}while((h|0)!=(g|0))}if(!m)return;cYc(m);return}function hOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;d=u;u=u+608|0;e=d+552|0;g=d+224|0;h=d+496|0;i=d;j=d+480|0;k=d+464|0;l=d+448|0;m=a+48|0;o=a+52|0;p=f[m>>2]|0;if((f[o>>2]|0)==(p|0)){q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=21;r=q;s=463216;t=r+21|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[q+21>>0]=0;vM(-215,e,463238,463267,100)}q=e+8|0;f[q>>2]=0;f[q+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=p+280;jR(c,e);c=(f[m>>2]|0)+280|0;qPb(c,c,0,0,+n[a+4>>2]);c=f[m>>2]|0;p=a+24|0;qPb(c+280|0,c+336|0,0,0,+n[p>>2]);v=+vPb((f[m>>2]|0)+280|0,+n[a+36>>2],+n[p>>2],f[a+40>>2]|0,0,0);c=a+32|0;n[c>>2]=v;q=f[m>>2]|0;p$(g,f[q+288>>2]|0,f[q+292>>2]|0,5);f[e>>2]=1124007936;q=e+4|0;s=e+8|0;w=e+40|0;r=q;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));f[w>>2]=s;s=e+48|0;x=e+44|0;f[x>>2]=s;f[s>>2]=0;f[e+52>>2]=0;y=f[g>>2]|0;ei[f[(f[y>>2]|0)+12>>2]&511](y,g,e,-1);Zj(g);g=f[m>>2]|0;p$(i,f[g+288>>2]|0,f[g+292>>2]|0,5);f[h>>2]=1124007936;g=h+4|0;y=h+8|0;z=h+40|0;r=g;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));f[z>>2]=y;y=h+48|0;r=h+44|0;f[r>>2]=y;f[y>>2]=0;f[h+52>>2]=0;t=f[i>>2]|0;ei[f[(f[t>>2]|0)+12>>2]&511](t,i,h,-1);Zj(i);i=f[m>>2]|0;a:do if((((f[o>>2]|0)-i|0)/468|0)>>>0>1){t=j+8|0;A=j+4|0;B=j+8|0;C=j+12|0;D=j+4|0;E=k+8|0;F=k+4|0;G=j+8|0;H=j+12|0;I=j+4|0;J=k+8|0;K=k+4|0;L=j+8|0;M=j+12|0;N=j+4|0;O=k+8|0;P=k+12|0;Q=k+4|0;R=l+8|0;S=l+4|0;T=j+8|0;U=j+12|0;V=j+4|0;W=k+8|0;X=k+12|0;Y=k+4|0;Z=l+8|0;_=l+4|0;$=j+8|0;aa=j+12|0;ba=j+4|0;ca=k+8|0;da=k+12|0;ea=k+4|0;fa=l+8|0;ga=l+4|0;ha=a+92|0;ia=a+80|0;ja=1;ka=i;while(1){la=ka;ma=ja+-1|0;na=t;f[na>>2]=0;f[na+4>>2]=0;f[j>>2]=33619968;f[A>>2]=la+(ja*468|0)+280;jR(la+(ma*468|0)+280|0,j);la=f[m>>2]|0;qPb(la+(ma*468|0)+280|0,la+(ja*468|0)+336|0,0,0,+n[p>>2]);la=f[m>>2]|0;f[B>>2]=0;f[C>>2]=0;f[j>>2]=16842752;f[D>>2]=la+(ja*468|0)+336;na=E;f[na>>2]=0;f[na+4>>2]=0;f[k>>2]=33619968;f[F>>2]=la+(ja*468|0);toa(j,k,5,1,0,1.0,0.0,4);la=f[m>>2]|0;f[G>>2]=0;f[H>>2]=0;f[j>>2]=16842752;f[I>>2]=la+(ja*468|0)+336;na=J;f[na>>2]=0;f[na+4>>2]=0;f[k>>2]=33619968;f[K>>2]=la+(ja*468|0)+56;toa(j,k,5,0,1,1.0,0.0,4);switch(f[a>>2]|0){case 0:{la=f[m>>2]|0;f[L>>2]=0;f[M>>2]=0;f[j>>2]=16842752;f[N>>2]=la+(ja*468|0);f[O>>2]=0;f[P>>2]=0;f[k>>2]=16842752;f[Q>>2]=la+(ja*468|0)+56;la=R;f[la>>2]=0;f[la+4>>2]=0;f[l>>2]=33619968;f[S>>2]=e;rPb(j,k,l,+n[c>>2]);break}case 1:{la=f[m>>2]|0;f[T>>2]=0;f[U>>2]=0;f[j>>2]=16842752;f[V>>2]=la+(ja*468|0);f[W>>2]=0;f[X>>2]=0;f[k>>2]=16842752;f[Y>>2]=la+(ja*468|0)+56;la=Z;f[la>>2]=0;f[la+4>>2]=0;f[l>>2]=33619968;f[_>>2]=e;sPb(j,k,l,+n[c>>2]);break}case 2:{la=f[m>>2]|0;f[$>>2]=0;f[aa>>2]=0;f[j>>2]=16842752;f[ba>>2]=la+(ja*468|0);f[ca>>2]=0;f[da>>2]=0;f[k>>2]=16842752;f[ea>>2]=la+(ja*468|0)+56;la=fa;f[la>>2]=0;f[la+4>>2]=0;f[l>>2]=33619968;f[ga>>2]=e;tPb(j,k,l,+n[c>>2]);break}default:{}}if((f[(f[ha>>2]|0)+(ma<<2)>>2]|0)>0){la=0;do{yPb((f[m>>2]|0)+(ja*468|0)+280|0,e,h,+n[(f[(f[ia>>2]|0)+(ma*12|0)>>2]|0)+(la<<2)>>2]);la=la+1|0}while((la|0)<(f[(f[ha>>2]|0)+(ma<<2)>>2]|0))}ja=ja+1|0;ka=f[m>>2]|0;if(ja>>>0>=(((f[o>>2]|0)-ka|0)/468|0)>>>0)break a}}while(0);o=h+36|0;m=f[o>>2]|0;if(m|0?(c=m+12|0,m=f[c>>2]|0,f[c>>2]=m+-1,(m|0)==1):0)V$(h);f[o>>2]=0;o=h+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[g>>2]|0)>0){o=f[z>>2]|0;z=0;do{f[o+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[g>>2]|0))}g=f[r>>2]|0;if((g|0)!=(y|0))wL(g);g=e+36|0;y=f[g>>2]|0;if(y|0?(r=y+12|0,y=f[r>>2]|0,f[r>>2]=y+-1,(y|0)==1):0)V$(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[w>>2]|0;w=0;do{f[g+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[q>>2]|0))}q=f[x>>2]|0;if((q|0)==(s|0)){u=d;return 0}wL(q);u=d;return 0}function iOb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+48|0;g=a+52|0;h=((f[g>>2]|0)-(f[e>>2]|0)|0)/468|0;f[c>>2]=0;f[c+4>>2]=h;f[d>>2]=116212;f[d+4>>2]=e;h3(c,d,-1.0);d=f[g>>2]|0;g=f[e>>2]|0;e=g;if((d|0)==(g|0)){u=b;return}c=f[a+20>>2]|0;h=(c|0)>0;i=a+16|0;a=(d-g|0)/468|0;g=0;do{if(h?(d=f[i>>2]|0,(d|0)>0):0){j=f[e+(g*468|0)+128>>2]|0;k=f[f[e+(g*468|0)+156>>2]>>2]|0;l=f[e+(g*468|0)+184>>2]|0;m=f[f[e+(g*468|0)+212>>2]>>2]|0;o=f[e+(g*468|0)+240>>2]|0;p=f[f[e+(g*468|0)+268>>2]>>2]|0;q=f[e+(g*468|0)+408>>2]|0;r=f[f[e+(g*468|0)+436>>2]>>2]|0;s=0;do{t=j+(Y(k,s)|0)|0;v=l+(Y(m,s)|0)|0;w=o+(Y(p,s)|0)|0;x=q+(Y(r,s)|0)|0;y=0;do{z=+n[v+(y<<2)>>2];n[x+(y<<2)>>2]=+n[t+(y<<2)>>2]*+n[w+(y<<2)>>2]-z*z;y=y+1|0}while((y|0)<(d|0));s=s+1|0}while((s|0)<(c|0))}g=g+1|0}while(g>>>0<a>>>0);u=b;return}function jOb(a){a=a|0;cYc(a);return}function kOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+224|0;d=c;e=f[b>>2]|0;g=b+4|0;if((e|0)>=(f[g>>2]|0)){u=c;return}b=f[a+4>>2]|0;a=e;do{e=f[b>>2]|0;wPb(e+(a*468|0)+336|0,e+(a*468|0)|0,1,0,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;wPb(e+(a*468|0)+336|0,e+(a*468|0)+56|0,0,1,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;wPb(e+(a*468|0)|0,e+(a*468|0)+112|0,1,0,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;wPb(e+(a*468|0)+56|0,e+(a*468|0)+224|0,0,1,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;wPb(e+(a*468|0)|0,e+(a*468|0)+168|0,0,1,f[e+(a*468|0)+464>>2]|0);e=f[b>>2]|0;c$(d,e+(a*468|0)|0,+(f[e+(a*468|0)+464>>2]|0));e=f[d>>2]|0;ei[f[(f[e>>2]|0)+12>>2]&511](e,d,(f[b>>2]|0)+(a*468|0)|0,-1);Zj(d);e=f[b>>2]|0;c$(d,e+(a*468|0)+56|0,+(f[e+(a*468|0)+464>>2]|0));e=f[d>>2]|0;ei[f[(f[e>>2]|0)+12>>2]&511](e,d,(f[b>>2]|0)+(a*468|0)+56|0,-1);Zj(d);e=f[b>>2]|0;h=f[e+(a*468|0)+464>>2]|0;c$(d,e+(a*468|0)+112|0,+(Y(h,h)|0));h=f[d>>2]|0;ei[f[(f[h>>2]|0)+12>>2]&511](h,d,(f[b>>2]|0)+(a*468|0)+112|0,-1);Zj(d);h=f[b>>2]|0;e=f[h+(a*468|0)+464>>2]|0;c$(d,h+(a*468|0)+168|0,+(Y(e,e)|0));e=f[d>>2]|0;ei[f[(f[e>>2]|0)+12>>2]&511](e,d,(f[b>>2]|0)+(a*468|0)+168|0,-1);Zj(d);e=f[b>>2]|0;h=f[e+(a*468|0)+464>>2]|0;c$(d,e+(a*468|0)+224|0,+(Y(h,h)|0));h=f[d>>2]|0;ei[f[(f[h>>2]|0)+12>>2]&511](h,d,(f[b>>2]|0)+(a*468|0)+224|0,-1);Zj(d);a=a+1|0}while((a|0)<(f[g>>2]|0));u=c;return}function lOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~(((e+-28-c|0)>>>0)/28|0)*28|0);iOb(a);mOb(a,b);nOb(a,b);return}function mOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0;c=u;u=u+96|0;d=c+72|0;e=c+64|0;g=c;h=a+60|0;i=a+64|0;j=f[i>>2]|0;k=f[h>>2]|0;l=k;if((j|0)==(k|0)){m=l;o=j}else{j=0;k=l;while(1){l=k+(j*12|0)|0;p=f[l>>2]|0;f[l>>2]=0;f[k+(j*12|0)+4>>2]=0;f[k+(j*12|0)+8>>2]=0;if(p|0)cYc(p);j=j+1|0;p=f[i>>2]|0;l=f[h>>2]|0;q=l;if(j>>>0>=((p-l|0)/12|0)>>>0){m=q;o=p;break}else k=q}}k=o;if((k|0)==(m|0))r=k;else{o=k;while(1){k=o+-12|0;f[i>>2]=k;j=f[k>>2]|0;if(!j)s=k;else{k=o+-8|0;q=f[k>>2]|0;if((q|0)!=(j|0))f[k>>2]=q+(~(((q+-28-j|0)>>>0)/28|0)*28|0);cYc(j);s=f[i>>2]|0}if((s|0)==(m|0)){r=m;break}else o=s}}f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;o=a+48|0;m=a+52|0;j=f[m>>2]|0;q=f[o>>2]|0;a:do if((((j-q|0)/468|0)+-1|0)>>>0>1){k=a+68|0;p=1;l=r;while(1){if((l|0)==(f[k>>2]|0))pOb(h,d);else{oOb(l,d);f[i>>2]=(f[i>>2]|0)+12}t=p+1|0;v=f[m>>2]|0;w=f[o>>2]|0;if(t>>>0>=(((v-w|0)/468|0)+-1|0)>>>0){x=w;y=v;break a}p=t;l=f[i>>2]|0}}else{x=q;y=j}while(0);f[e>>2]=1;f[e+4>>2]=((y-x|0)/468|0)+-1;f[g>>2]=116232;f[g+4>>2]=o;f[g+8>>2]=h;x=g+12|0;y=a;a=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(a|0));h3(e,g,-1.0);g=f[i>>2]|0;e=f[h>>2]|0;if((g-e|0)>0){y=b+4|0;x=b+8|0;a=0;j=0;q=g;g=e;while(1){e=g;m=a;a=a+1|0;if(((f[e+(m*12|0)+4>>2]|0)-(f[e+(m*12|0)>>2]|0)|0)>0){r=m+2|0;l=0;p=j;k=e;while(1){e=f[y>>2]|0;t=f[b>>2]|0;v=e-t|0;w=t;t=e;b:do if((v|0)>0){z=(v>>>0)/28|0;A=k+(m*12|0)|0;B=0;while(1){C=f[w+(B*28|0)+24>>2]|0;if((C|0)==(m|0)|((C|0)==(a|0)|(C|0)==(r|0))?(D=f[A>>2]|0,E=+n[D+(l*28|0)>>2]-+n[w+(B*28|0)>>2],F=+n[D+(l*28|0)+4>>2]-+n[w+(B*28|0)+4>>2],C=f[(f[o>>2]|0)+(a*468|0)+464>>2]|0,E*E+F*F<+(Y(C,C)|0)):0)break;C=B+1|0;if((C|0)<(z|0))B=C;else{G=0;H=p;I=35;break b}}z=+n[D+(l*28|0)+16>>2]>+n[w+(B*28|0)+16>>2];if(z){G=z&1;H=B;I=35}else J=p}else{G=0;H=p;I=35}while(0);do if((I|0)==35){I=0;v=f[k+(m*12|0)>>2]|0;z=v+(l*28|0)|0;F=+n[z>>2];A=v+(l*28|0)+8|0;E=+n[A>>2]*3.0;C=ALc(F-E)|0;K=+n[v+(l*28|0)+4>>2];v=ALc(E+K)|0;if(((C|0)>=0?(C=ALc(K-E)|0,L=ALc(F+E)|0,M=f[o>>2]|0,!((C|0)<0?1:(L|0)>=(f[M+(a*468|0)+404>>2]|0))):0)?(v|0)<(f[M+(a*468|0)+400>>2]|0):0){if(G|0){n[w+(H*28|0)>>2]=F;n[w+(H*28|0)+4>>2]=K;M=w+(H*28|0)+8|0;f[M>>2]=f[A>>2];f[M+4>>2]=f[A+4>>2];f[M+8>>2]=f[A+8>>2];f[M+12>>2]=f[A+12>>2];f[M+16>>2]=f[A+16>>2];J=H;break}if((t|0)==(f[x>>2]|0)){Lx(b,z);J=H;break}else{n[e>>2]=F;n[t+4>>2]=K;z=t+8|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[y>>2]=(f[y>>2]|0)+28;J=H;break}}else J=H}while(0);l=l+1|0;k=f[h>>2]|0;if((l|0)>=(((f[k+(m*12|0)+4>>2]|0)-(f[k+(m*12|0)>>2]|0)|0)/28|0|0))break;else p=J}N=J;O=k;P=f[i>>2]|0}else{N=j;O=g;P=q}if((a|0)>=((P-O|0)/12|0|0))break;else{j=N;q=P;g=O}}}O=f[d>>2]|0;if(!O){u=c;return}d=f[s>>2]|0;if((d|0)!=(O|0))f[s>>2]=d+(~(((d+-28-O|0)>>>0)/28|0)*28|0);cYc(O);u=c;return}function nOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;c=u;u=u+912|0;d=c+848|0;e=c+448|0;g=c+792|0;h=c+224|0;i=c+736|0;j=c;k=c+720|0;l=c+704|0;m=c+688|0;o=c+672|0;p$(e,3,3,5);f[d>>2]=1124007936;p=d+4|0;q=d+8|0;r=d+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=d+48|0;v=d+44|0;f[v>>2]=q;f[q>>2]=0;f[d+52>>2]=0;w=f[e>>2]|0;ei[f[(f[w>>2]|0)+12>>2]&511](w,e,d,-1);Zj(e);p$(h,3,1,5);f[g>>2]=1124007936;e=g+4|0;w=g+8|0;x=g+40|0;s=e;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[x>>2]=w;w=g+48|0;y=g+44|0;f[y>>2]=w;f[w>>2]=0;f[g+52>>2]=0;z=f[h>>2]|0;ei[f[(f[z>>2]|0)+12>>2]&511](z,h,g,-1);Zj(h);p$(j,3,1,5);f[i>>2]=1124007936;h=i+4|0;z=i+8|0;A=i+40|0;s=h;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[A>>2]=z;z=i+48|0;s=i+44|0;f[s>>2]=z;f[z>>2]=0;f[i+52>>2]=0;t=f[j>>2]|0;ei[f[(f[t>>2]|0)+12>>2]&511](t,j,i,-1);Zj(j);oOb(k,b);j=k+4|0;t=f[j>>2]|0;B=f[k>>2]|0;if((t|0)==(B|0)){C=t;D=t}else{t=a+48|0;E=d+16|0;F=g+16|0;G=l+8|0;H=l+12|0;I=l+4|0;J=m+8|0;K=m+12|0;M=m+4|0;N=o+8|0;O=o+4|0;P=i+16|0;Q=a+12|0;R=a+4|0;a=0;S=B;while(1){B=S;T=~~+n[B+(a*28|0)>>2];U=~~+n[B+(a*28|0)+4>>2];V=f[B+(a*28|0)+24>>2]|0;B=f[t>>2]|0;W=f[B+(V*468|0)+408>>2]|0;X=f[f[B+(V*468|0)+436>>2]>>2]|0;Z=W+(Y(X,U)|0)+(T<<2)|0;_=+n[Z+4>>2];$=+n[Z+-4>>2];aa=U+1|0;ba=W+(Y(X,aa)|0)+(T<<2)|0;ca=+n[ba>>2];da=U+-1|0;ea=W+(Y(X,da)|0)+(T<<2)|0;fa=+n[ea>>2];X=V+1|0;W=f[B+(X*468|0)+408>>2]|0;ga=f[f[B+(X*468|0)+436>>2]>>2]|0;X=W+(Y(ga,U)|0)+(T<<2)|0;ha=+n[X>>2];ia=V+-1|0;V=f[B+(ia*468|0)+408>>2]|0;ja=f[f[B+(ia*468|0)+436>>2]>>2]|0;ia=V+(Y(ja,U)|0)+(T<<2)|0;ka=+n[ia>>2];la=+n[Z>>2]*2.0;ma=(+n[ba+4>>2]+ +n[ea+-4>>2])*.25-(+n[ea+4>>2]+ +n[ba+-4>>2])*.25;na=(+n[X+4>>2]+ +n[ia+-4>>2])*.25-(+n[X+-4>>2]+ +n[ia+4>>2])*.25;ia=W+(Y(ga,aa)|0)+(T<<2)|0;X=V+(Y(ja,da)|0)+(T<<2)|0;ba=W+(Y(ga,da)|0)+(T<<2)|0;da=V+(Y(ja,aa)|0)+(T<<2)|0;oa=(+n[ia>>2]+ +n[X>>2])*.25-(+n[ba>>2]+ +n[da>>2])*.25;da=f[E>>2]|0;n[da>>2]=_+$-la;ba=f[f[v>>2]>>2]|0;X=da+ba|0;n[X+4>>2]=ca+fa-la;ia=da+(ba<<1)|0;n[ia+8>>2]=ha+ka-la;n[X>>2]=ma;n[da+4>>2]=ma;n[ia>>2]=na;n[da+8>>2]=na;n[ia+4>>2]=oa;n[X+8>>2]=oa;X=f[F>>2]|0;n[X>>2]=-((_-$)*.5);ia=f[f[y>>2]>>2]|0;n[X+ia>>2]=-((ca-fa)*.5);n[X+(ia<<1)>>2]=-((ha-ka)*.5);f[G>>2]=0;f[H>>2]=0;f[l>>2]=16842752;f[I>>2]=d;f[J>>2]=0;f[K>>2]=0;f[m>>2]=16842752;f[M>>2]=g;ia=N;f[ia>>2]=0;f[ia+4>>2]=0;f[o>>2]=33619968;f[O>>2]=i;pM(l,m,o,0)|0;ia=f[P>>2]|0;ka=+n[ia>>2];if((+L(+ka)<=1.0?(X=f[f[s>>2]>>2]|0,da=ia+X|0,+L(+(+n[da>>2]))<=1.0):0)?(ba=ia+(X<<1)|0,+L(+(+n[ba>>2]))<=1.0):0){X=f[k>>2]|0;ia=X+(a*28|0)|0;n[ia>>2]=ka+ +n[ia>>2];ia=X+(a*28|0)+4|0;n[ia>>2]=+n[da>>2]+ +n[ia>>2];ia=X+(a*28|0)+12|0;ka=+n[R>>2]*2.0;ha=ka*+Me(+(+(f[X+(a*28|0)+20>>2]|0)+(+n[ia>>2]+ +n[ba>>2])/+(f[Q>>2]|0)));n[X+(a*28|0)+8>>2]=ha;n[ia>>2]=0.0;pa=X}else{X=f[k>>2]|0;n[X+(a*28|0)+16>>2]=-1.0;pa=X}X=pa;a=a+1|0;ia=f[j>>2]|0;if(a>>>0>=((ia-X|0)/28|0)>>>0){C=ia;D=X;break}else S=X}}S=C;a=f[b>>2]|0;pa=b+4|0;Q=f[pa>>2]|0;if((Q|0)!=(a|0))f[pa>>2]=Q+(~(((Q+-28-a|0)>>>0)/28|0)*28|0);a=D;if((C|0)==(D|0)){qa=a;ra=S}else{Q=b+8|0;R=0;P=a;a=S;S=D;D=C;while(1){C=P+(R*28|0)|0;do if(+n[P+(R*28|0)+16>>2]!=-1.0){o=f[pa>>2]|0;if((o|0)==(f[Q>>2]|0)){Lx(b,C);m=f[j>>2]|0;sa=f[k>>2]|0;ta=m;ua=m;break}else{f[o>>2]=f[C>>2];f[o+4>>2]=f[P+(R*28|0)+4>>2];m=o+8|0;o=P+(R*28|0)+8|0;f[m>>2]=f[o>>2];f[m+4>>2]=f[o+4>>2];f[m+8>>2]=f[o+8>>2];f[m+12>>2]=f[o+12>>2];f[m+16>>2]=f[o+16>>2];f[pa>>2]=(f[pa>>2]|0)+28;sa=S;ta=D;ua=a;break}}else{sa=S;ta=D;ua=a}while(0);R=R+1|0;C=sa;if(R>>>0>=((ta-sa|0)/28|0)>>>0){qa=C;ra=ua;break}else{P=C;a=ua;S=sa;D=ta}}}if(qa|0){if((ra|0)!=(qa|0))f[j>>2]=ra+(~(((ra+-28-qa|0)>>>0)/28|0)*28|0);cYc(qa)}qa=i+36|0;ra=f[qa>>2]|0;if(ra|0?(j=ra+12|0,ra=f[j>>2]|0,f[j>>2]=ra+-1,(ra|0)==1):0)V$(i);f[qa>>2]=0;qa=i+16|0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[h>>2]|0)>0){qa=f[A>>2]|0;A=0;do{f[qa+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[h>>2]|0))}h=f[s>>2]|0;if((h|0)!=(z|0))wL(h);h=g+36|0;z=f[h>>2]|0;if(z|0?(s=z+12|0,z=f[s>>2]|0,f[s>>2]=z+-1,(z|0)==1):0)V$(g);f[h>>2]=0;h=g+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[e>>2]|0)>0){h=f[x>>2]|0;x=0;do{f[h+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[e>>2]|0))}e=f[y>>2]|0;if((e|0)!=(w|0))wL(e);e=d+36|0;w=f[e>>2]|0;if(w|0?(y=w+12|0,w=f[y>>2]|0,f[y>>2]=w+-1,(w|0)==1):0)V$(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[v>>2]|0;if((p|0)==(q|0)){u=c;return}wL(p);u=c;return}function oOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/28|0;if(!e)return;if(g>>>0>153391689)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*28|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];h=g+8|0;a=d+8|0;f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];d=d+28|0;g=(f[c>>2]|0)+28|0;f[c>>2]=g}while((d|0)!=(b|0));return}function pOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;oOb(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{d=e+-12|0;o=i;i=i+-12|0;f[d>>2]=0;p=e+-8|0;f[p>>2]=0;f[e+-4>>2]=0;f[d>>2]=f[i>>2];d=o+-8|0;f[p>>2]=f[d>>2];p=o+-4|0;f[e+-4>>2]=f[p>>2];f[p>>2]=0;f[d>>2]=0;f[i>>2]=0;e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~(((n+-28-b|0)>>>0)/28|0)*28|0);cYc(b)}}while((h|0)!=(g|0))}if(!m)return;cYc(m);return}function qOb(a){a=a|0;cYc(a);return}function rOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0;c=u;u=u+32|0;d=c;e=f[b>>2]|0;g=b+4|0;if((e|0)>=(f[g>>2]|0)){u=c;return}b=f[a+8>>2]|0;h=f[a+4>>2]|0;i=a+32|0;j=a+28|0;k=a+40|0;a=d+4|0;l=d+8|0;m=d+12|0;o=d+16|0;p=d+20|0;q=d+24|0;r=e;e=f[i>>2]|0;while(1){if((e+-1|0)>1){s=r+-1|0;t=r+1|0;v=1;w=f[j>>2]|0;while(1){if((w+-1|0)>1){x=+(v|0);y=1;do{z=f[h>>2]|0;A=z+(r*468|0)+392|0;B=(f[z+(r*468|0)+408>>2]|0)+(Y(f[f[z+(r*468|0)+436>>2]>>2]|0,v)|0)+(y<<2)|0;C=+n[B>>2];if((((C>+n[k>>2]?C>=+n[B+-4>>2]:0)?BPb(A,1,C,v,y,1)|0:0)?BPb((f[h>>2]|0)+(s*468|0)+392|0,1,C,v,y,0)|0:0)?BPb((f[h>>2]|0)+(t*468|0)+392|0,1,C,v,y,0)|0:0){D=+(y|0);n[d>>2]=D;n[a>>2]=x;E=+L(+C);n[o>>2]=E;A=f[h>>2]|0;f[l>>2]=f[A+(r*468|0)+452>>2];f[p>>2]=f[A+(r*468|0)+456>>2];f[q>>2]=r;n[m>>2]=+(f[A+(r*468|0)+460>>2]|0);A=f[b>>2]|0;B=A+(s*12|0)+4|0;z=f[B>>2]|0;if((z|0)==(f[A+(s*12|0)+8>>2]|0))Lx(A+(s*12|0)|0,d);else{n[z>>2]=D;n[z+4>>2]=x;A=z+8|0;f[A>>2]=f[l>>2];f[A+4>>2]=f[l+4>>2];f[A+8>>2]=f[l+8>>2];f[A+12>>2]=f[l+12>>2];f[A+16>>2]=f[l+16>>2];f[B>>2]=(f[B>>2]|0)+28}}y=y+1|0;B=f[j>>2]|0}while((y|0)<(B+-1|0));F=B}else F=w;v=v+1|0;y=f[i>>2]|0;if((v|0)>=(y+-1|0)){G=t;H=y;break}else w=F}}else{G=r+1|0;H=e}if((G|0)<(f[g>>2]|0)){r=G;e=H}else break}u=c;return}function sOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+288|0;g=e;h=e+224|0;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=k;a:do if((j|0)!=(k|0)){m=a+48|0;n=a+52|0;o=(j-k|0)/28|0;p=0;while(1){q=f[l+(p*28|0)+24>>2]|0;if((q|0)<=-1)break;p=p+1|0;if((q|0)>=(((f[n>>2]|0)-(f[m>>2]|0)|0)/468|0|0))break;if(p>>>0>=o>>>0)break a}o=$Xc(80)|0;f[g>>2]=o;f[g+8>>2]=-2147483568;f[g+4>>2]=79;r=o;s=464213;t=r+79|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[o+79>>0]=0;vM(-215,g,463423,463267,554)}while(0);if(!(b[a+45>>0]|0)){p$(g,(j-k|0)/28|0,64,5);l=f[g>>2]|0;ei[f[(f[l>>2]|0)+12>>2]&511](l,g,d,-1);Zj(g)}else{p$(g,(j-k|0)/28|0,128,5);k=f[g>>2]|0;ei[f[(f[k>>2]|0)+12>>2]&511](k,g,d,-1);Zj(g)}k=((f[i>>2]|0)-(f[c>>2]|0)|0)/28|0;f[g>>2]=0;f[g+4>>2]=k;f[h>>2]=116252;f[h+4>>2]=c;f[h+8>>2]=d;f[h+12>>2]=a+48;r=h+16|0;s=a;t=r+48|0;do{f[r>>2]=f[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));h3(g,h,-1.0);u=e;return}function tOb(a){a=a|0;cYc(a);return}function uOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;d=f[a+8>>2]|0;e=f[a+12>>2]|0;g=f[c>>2]|0;h=c+4|0;if((g|0)>=(f[h>>2]|0))return;c=f[a+4>>2]|0;i=a+60|0;j=a+16|0;k=a+61|0;l=d+16|0;m=d+44|0;d=g;do{g=f[c>>2]|0;o=g+(d*28|0)+12|0;n[o>>2]=0.0;do if(!(b[i>>0]|0)){xOb(g+(d*28|0)|0,e,j);p=(f[c>>2]|0)+(d*28|0)|0;q=(f[l>>2]|0)+(Y(f[f[m>>2]>>2]|0,d)|0)|0;if(!(b[k>>0]|0)){zOb(a,p,q);break}else{yOb(a,p,q);break}}else{n[o>>2]=0.0;q=g+(d*28|0)|0;p=(f[l>>2]|0)+(Y(f[f[m>>2]>>2]|0,d)|0)|0;if(!(b[k>>0]|0)){wOb(a,q,p);break}else{vOb(a,q,p);break}}while(0);d=d+1|0}while((d|0)<(f[h>>2]|0));return}function vOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=ALc(+n[b+8>>2]*.5)|0;i=f[b+24>>2]|0;j=+(h|0)*2.5;k=j*(j*2.0);b=f[a+32>>2]|0;l=f[a+36>>2]|0;a=b+-1|0;m=l+-1|0;o=f[d>>2]|0;d=f[o+(i*468|0)+16>>2]|0;p=f[f[o+(i*468|0)+44>>2]>>2]|0;q=f[o+(i*468|0)+72>>2]|0;r=f[f[o+(i*468|0)+100>>2]>>2]|0;j=-.5;i=0;o=-8;s=0.0;while(1){t=o+-4|0;j=j+1.0;u=e+ +(Y(o+1|0,h)|0);v=j+-2.0;w=v*v;x=o+4|0;v=-.5;y=-8;z=i;A=s;while(1){B=y+-4|0;C=g+ +(Y(y+1|0,h)|0);y=y+5|0;D=t;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0;N=0.0;while(1){O=e+ +(Y(D,h)|0);P=u-O;Q=P*P;R=~~(O+-.5);S=(R|0)<0;T=S?0:R;R=(T|0)<(l|0)?T:m;T=~~(O+.5);U=(T|0)>0?T:0;T=(U|0)<(l|0)?U:m;P=O-+(R|0);U=d+(Y(p,R)|0)|0;W=d+(Y(p,T)|0)|0;O=1.0-P;X=q+(Y(r,R)|0)|0;R=q+(Y(r,T)|0)|0;if(S){S=B;Z=F;_=G;$=H;aa=I;ba=J;ca=K;da=N;ea=E;while(1){fa=g+ +(Y(S,h)|0);ga=C-fa;ha=+V(+(-(Q+ga*ga)/k));T=~~(fa+-.5);ia=(T|0)>0?T:0;T=(ia|0)<(b|0)?ia:a;ia=~~(fa+.5);ja=(ia|0)>0?ia:0;ia=(ja|0)<(b|0)?ja:a;ga=fa-+(T|0);fa=1.0-ga;ka=fa*O;la=ga*O;ma=fa*P;fa=ga*P;ga=ha*(ka*+n[U+(T<<2)>>2]+la*+n[U+(ia<<2)>>2]+ma*+n[W+(T<<2)>>2]+fa*+n[W+(ia<<2)>>2]);na=ha*(ka*+n[X+(T<<2)>>2]+la*+n[X+(ia<<2)>>2]+ma*+n[R+(T<<2)>>2]+fa*+n[R+(ia<<2)>>2]);if(!(na>=0.0)){oa=Z+ +L(+ga);pa=$+ga;qa=ba;ra=da}else{oa=Z;pa=$;qa=ba+ +L(+ga);ra=da+ga}if(!(ga>=0.0)){sa=ea+ +L(+na);ta=_+na;ua=aa;va=ca}else{sa=ea;ta=_;ua=aa+ +L(+na);va=ca+na}S=S+1|0;if((S|0)>=(y|0)){wa=sa;xa=oa;ya=ta;za=pa;Aa=ua;Ba=qa;Ca=va;Da=ra;break}else{Z=oa;_=ta;$=pa;aa=ua;ba=qa;ca=va;da=ra;ea=sa}}}else{S=B;ea=F;da=G;ca=H;ba=I;aa=J;$=K;_=N;Z=E;while(1){na=g+ +(Y(S,h)|0);ga=C-na;fa=+V(+(-(Q+ga*ga)/k));ia=~~(na+-.5);T=(ia|0)>0?ia:0;ia=(T|0)<(b|0)?T:a;T=~~(na+.5);ja=(T|0)>0?T:0;T=(ja|0)<(b|0)?ja:a;ga=na-+(ia|0);na=1.0-ga;ma=na*O;la=ga*O;ka=na*P;na=ga*P;ga=fa*(ma*+n[U+(ia<<2)>>2]+la*+n[U+(T<<2)>>2]+ka*+n[W+(ia<<2)>>2]+na*+n[W+(T<<2)>>2]);ha=fa*(ma*+n[X+(ia<<2)>>2]+la*+n[X+(T<<2)>>2]+ka*+n[R+(ia<<2)>>2]+na*+n[R+(T<<2)>>2]);if(!(ha>=0.0)){Ea=ea+ +L(+ga);Fa=ca+ga;Ga=aa;Ha=_}else{Ea=ea;Fa=ca;Ga=aa+ +L(+ga);Ha=_+ga}if(!(ga>=0.0)){Ia=Z+ +L(+ha);Ja=da+ha;Ka=ba;La=$}else{Ia=Z;Ja=da;Ka=ba+ +L(+ha);La=$+ha}S=S+1|0;if((S|0)>=(y|0)){wa=Ia;xa=Ea;ya=Ja;za=Fa;Aa=Ka;Ba=Ga;Ca=La;Da=Ha;break}else{ea=Ea;da=Ja;ca=Fa;ba=Ka;aa=Ga;$=La;_=Ha;Z=Ia}}}if((D|0)<(x|0)){D=D+1|0;E=wa;F=xa;G=ya;H=za;I=Aa;J=Ba;K=Ca;N=Da}else break}v=v+1.0;N=v+-2.0;K=+V(+(-(w+N*N)/4.5));n[c+(z<<2)>>2]=Da*K;n[c+((z|1)<<2)>>2]=za*K;n[c+((z|2)<<2)>>2]=Ba*K;n[c+((z|3)<<2)>>2]=xa*K;n[c+((z|4)<<2)>>2]=Ca*K;n[c+((z|5)<<2)>>2]=ya*K;n[c+((z|6)<<2)>>2]=Aa*K;n[c+((z|7)<<2)>>2]=wa*K;A=A+K*((wa*wa+(Aa*Aa+(ya*ya+(Ca*Ca+(Ba*Ba+(Da*Da+za*za)+xa*xa)))))*K);if((y|0)>=12)break;else z=z+8|0}o=o+5|0;if((o|0)>=12)break;else{i=i+32|0;s=A}}s=+M(+A);i=0;do{o=c+(i<<2)|0;n[o>>2]=+n[o>>2]/s;i=i+1|0}while((i|0)!=128);return}function wOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=ALc(+n[b+8>>2]*.5)|0;i=f[b+24>>2]|0;j=+(h|0)*2.5;k=j*(j*2.0);b=f[a+32>>2]|0;l=f[a+36>>2]|0;a=b+-1|0;m=l+-1|0;o=f[d>>2]|0;d=f[o+(i*468|0)+16>>2]|0;p=f[f[o+(i*468|0)+44>>2]>>2]|0;q=f[o+(i*468|0)+72>>2]|0;r=f[f[o+(i*468|0)+100>>2]>>2]|0;j=-.5;i=0;o=-8;s=0.0;while(1){t=o+-4|0;j=j+1.0;u=e+ +(Y(o+1|0,h)|0);v=j+-2.0;w=v*v;x=o+4|0;v=-.5;y=-8;z=i;A=s;while(1){B=y+-4|0;C=g+ +(Y(y+1|0,h)|0);y=y+5|0;D=t;E=0.0;F=0.0;G=0.0;H=0.0;while(1){I=e+ +(Y(D,h)|0);J=u-I;K=J*J;N=~~(I+-.5);O=(N|0)<0;P=O?0:N;N=(P|0)<(l|0)?P:m;P=~~(I+.5);Q=(P|0)>0?P:0;P=(Q|0)<(l|0)?Q:m;J=I-+(N|0);Q=d+(Y(p,N)|0)|0;R=d+(Y(p,P)|0)|0;I=1.0-J;S=q+(Y(r,N)|0)|0;N=q+(Y(r,P)|0)|0;if(O){O=B;T=F;U=G;W=H;X=E;while(1){Z=g+ +(Y(O,h)|0);_=C-Z;$=+V(+(-(K+_*_)/k));P=~~(Z+-.5);aa=(P|0)>0?P:0;P=(aa|0)<(b|0)?aa:a;aa=~~(Z+.5);ba=(aa|0)>0?aa:0;aa=(ba|0)<(b|0)?ba:a;_=Z-+(P|0);Z=1.0-_;ca=Z*I;da=_*I;ea=Z*J;Z=_*J;_=$*(ca*+n[Q+(P<<2)>>2]+da*+n[Q+(aa<<2)>>2]+ea*+n[R+(P<<2)>>2]+Z*+n[R+(aa<<2)>>2]);fa=$*(ca*+n[S+(P<<2)>>2]+da*+n[S+(aa<<2)>>2]+ea*+n[N+(P<<2)>>2]+Z*+n[N+(aa<<2)>>2]);Z=X+_;ea=W+fa;da=U+ +L(+_);_=T+ +L(+fa);O=O+1|0;if((O|0)>=(y|0)){ga=Z;ha=_;ia=da;ja=ea;break}else{T=_;U=da;W=ea;X=Z}}}else{O=B;X=F;W=G;U=H;T=E;while(1){Z=g+ +(Y(O,h)|0);ea=C-Z;da=+V(+(-(K+ea*ea)/k));aa=~~(Z+-.5);P=(aa|0)>0?aa:0;aa=(P|0)<(b|0)?P:a;P=~~(Z+.5);ba=(P|0)>0?P:0;P=(ba|0)<(b|0)?ba:a;ea=Z-+(aa|0);Z=1.0-ea;_=Z*I;fa=ea*I;ca=Z*J;Z=ea*J;ea=da*(_*+n[Q+(aa<<2)>>2]+fa*+n[Q+(P<<2)>>2]+ca*+n[R+(aa<<2)>>2]+Z*+n[R+(P<<2)>>2]);$=da*(_*+n[S+(aa<<2)>>2]+fa*+n[S+(P<<2)>>2]+ca*+n[N+(aa<<2)>>2]+Z*+n[N+(P<<2)>>2]);Z=T+ea;ca=U+$;fa=W+ +L(+ea);ea=X+ +L(+$);O=O+1|0;if((O|0)>=(y|0)){ga=Z;ha=ea;ia=fa;ja=ca;break}else{X=ea;W=fa;U=ca;T=Z}}}if((D|0)<(x|0)){D=D+1|0;E=ga;F=ha;G=ia;H=ja}else break}v=v+1.0;H=v+-2.0;G=+V(+(-(w+H*H)/4.5));n[c+(z<<2)>>2]=ga*G;n[c+((z|1)<<2)>>2]=ja*G;n[c+((z|2)<<2)>>2]=ia*G;n[c+((z|3)<<2)>>2]=ha*G;A=A+G*((ha*ha+(ia*ia+(ja*ja+ga*ga)))*G);if((y|0)>=12)break;else z=z+4|0}o=o+5|0;if((o|0)>=12)break;else{i=i+16|0;s=A}}s=+M(+A);i=0;do{o=c+(i<<2)|0;n[o>>2]=+n[o>>2]/s;i=i+1|0}while((i|0)!=64);return}function xOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=$Xc(436)|0;g1c(d|0,0,436)|0;e=$Xc(436)|0;g1c(e|0,0,436)|0;g=$Xc(436)|0;g1c(g|0,0,436)|0;h=+n[a>>2];i=+n[a+4>>2];j=f[a+24>>2]|0;k=ALc(+n[a+8>>2]*.5)|0;l=c+20|0;m=c+16|0;o=+(k|0)*2.5;p=o*(o*2.0);c=-6;q=0;while(1){r=Y(c,c)|0;o=h+ +(Y(c,k)|0);s=-6;t=q;while(1){if(((Y(s,s)|0)+r|0)>>>0<36){u=ALc(i+ +(Y(s,k)|0))|0;v=ALc(o)|0;if(((u|0)>-1?((v|0)>-1?(u|0)<(f[l>>2]|0):0):0)?(v|0)<(f[m>>2]|0):0){w=+(u|0)-i;x=+(v|0)-h;y=+V(+(-(w*w+x*x)/p));z=f[b>>2]|0;A=(f[z+(j*468|0)+16>>2]|0)+(Y(f[f[z+(j*468|0)+44>>2]>>2]|0,u)|0)+(v<<2)|0;x=y*+n[A>>2];n[d+(t<<2)>>2]=x;A=(f[z+(j*468|0)+72>>2]|0)+(Y(f[f[z+(j*468|0)+100>>2]>>2]|0,u)|0)+(v<<2)|0;B=y*+n[A>>2];C=x}else{n[d+(t<<2)>>2]=0.0;B=0.0;C=0.0}n[e+(t<<2)>>2]=B;x=+fQ(B,C)*.01745329238474369;n[g+(t<<2)>>2]=x;D=t+1|0}else D=t;s=s+1|0;if((s|0)>=7)break;else t=D}c=c+1|0;if((c|0)>=7)break;else q=D}D=a+12|0;C=0.0;B=0.0;while(1){p=C+1.0471975803375244;h=p>6.2831854820251465?C+-5.235987663269043:p;a=h<C;if(!(C<h))if(a){p=0.0;i=0.0;q=0;while(1){o=+n[g+(q<<2)>>2];if(!(o>0.0&o<h)?!(o>C&o<6.2831854820251465):0){E=p;F=i}else{E=p+ +n[e+(q<<2)>>2];F=i+ +n[d+(q<<2)>>2]}q=q+1|0;if((q|0)==109){G=E;H=F;break}else{p=E;i=F}}}else{G=0.0;H=0.0}else{i=0.0;p=0.0;q=0;while(1){o=+n[g+(q<<2)>>2];c=C<o;j=o<h;if(!(c&j))if(a?o>0.0&j|c&o<6.2831854820251465:0){I=i+ +n[e+(q<<2)>>2];J=p+ +n[d+(q<<2)>>2]}else{I=i;J=p}else{I=i+ +n[e+(q<<2)>>2];J=p+ +n[d+(q<<2)>>2]}q=q+1|0;if((q|0)==109){G=I;H=J;break}else{i=I;p=J}}}p=H*H+G*G;if(p>B){i=+fQ(G,H);n[D>>2]=i;K=p}else K=B;C=C+.15000000596046448;if(!(C<6.283185307179586))break;else B=K}cYc(g);cYc(e);cYc(d);return}function yOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0.0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=ALc(+n[b+8>>2]*.5)|0;i=+n[b+12>>2]*.01745329238474369;j=f[b+24>>2]|0;k=+O(+i);l=+P(+i);b=0-h|0;i=+(h|0)*2.5;m=i*(i*2.0);o=f[a+32>>2]|0;p=f[a+36>>2]|0;a=o+-1|0;q=p+-1|0;r=f[d>>2]|0;d=f[r+(j*468|0)+16>>2]|0;s=f[f[r+(j*468|0)+44>>2]>>2]|0;t=f[r+(j*468|0)+72>>2]|0;u=f[f[r+(j*468|0)+100>>2]>>2]|0;i=-.5;j=0;r=-8;v=0.0;while(1){w=r+-4|0;i=i+1.0;x=+(Y(r+1|0,h)|0);y=k*x;z=l*x;x=i+-2.0;A=x*x;B=r+4|0;x=-.5;C=-8;D=v;E=j;while(1){F=C+-4|0;G=g+(y+l*+(Y(h,~C)|0));H=e+(z+k*+(Y(C+1|0,h)|0));I=C+4|0;J=w;K=0.0;N=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;W=0.0;while(1){X=+(Y(J,h)|0);Z=l*X;_=k*X;$=F;X=K;aa=N;ba=Q;ca=R;da=S;ea=T;fa=U;ga=W;while(1){ha=e+(Z+k*+(Y($,h)|0));ia=g+(_+l*+(Y($,b)|0));ja=G-ia;ka=H-ha;la=+V(+(-(ja*ja+ka*ka)/m));ma=~~ha;na=ma-(+(ma|0)>ha&1)|0;ma=~~ia;oa=ma-(+(ma|0)>ia&1)|0;ma=(oa|0)>0?oa:0;oa=(na|0)>0?na:0;na=(ma|0)<(o|0)?ma:a;ma=(oa|0)<(p|0)?oa:q;oa=(na|0)<-1?0:na+1|0;pa=(ma|0)<-1?0:ma+1|0;qa=(oa|0)<(o|0)?oa:a;oa=(pa|0)<(p|0)?pa:q;ka=ia-+(na|0);ia=ha-+(ma|0);pa=d+(Y(s,ma)|0)|0;ra=d+(Y(s,oa)|0)|0;ha=1.0-ka;ja=1.0-ia;sa=ha*ja;ta=ka*ja;ja=ha*ia;ha=ka*ia;ia=sa*+n[pa+(na<<2)>>2]+ta*+n[pa+(qa<<2)>>2]+ja*+n[ra+(na<<2)>>2]+ha*+n[ra+(qa<<2)>>2];ra=t+(Y(u,ma)|0)|0;ma=t+(Y(u,oa)|0)|0;ka=sa*+n[ra+(na<<2)>>2]+ta*+n[ra+(qa<<2)>>2]+ja*+n[ma+(na<<2)>>2]+ha*+n[ma+(qa<<2)>>2];ha=la*(k*ia+l*ka);ja=la*(k*ka-l*ia);if(!(ha>=0.0)){ua=aa+ +L(+ja);va=ca+ja;wa=ea;xa=ga}else{ua=aa;va=ca;wa=ea+ +L(+ja);xa=ga+ja}if(!(ja>=0.0)){ya=X+ +L(+ha);za=ba+ha;Aa=da;Ba=fa}else{ya=X;za=ba;Aa=da+ +L(+ha);Ba=fa+ha}if(($|0)<(I|0)){$=$+1|0;X=ya;aa=ua;ba=za;ca=va;da=Aa;ea=wa;fa=Ba;ga=xa}else break}if((J|0)<(B|0)){J=J+1|0;K=ya;N=ua;Q=za;R=va;S=Aa;T=wa;U=Ba;W=xa}else break}x=x+1.0;W=x+-2.0;U=+V(+(-(A+W*W)/4.5));n[c+(E<<2)>>2]=xa*U;n[c+((E|1)<<2)>>2]=va*U;n[c+((E|2)<<2)>>2]=wa*U;n[c+((E|3)<<2)>>2]=ua*U;n[c+((E|4)<<2)>>2]=Ba*U;n[c+((E|5)<<2)>>2]=za*U;n[c+((E|6)<<2)>>2]=Aa*U;n[c+((E|7)<<2)>>2]=ya*U;D=D+U*((ya*ya+(Aa*Aa+(za*za+(Ba*Ba+(wa*wa+(xa*xa+va*va)+ua*ua)))))*U);C=C+5|0;if((C|0)>=12)break;else E=E+8|0}r=r+5|0;if((r|0)>=12)break;else{j=j+32|0;v=D}}v=+M(+D);j=0;do{r=c+(j<<2)|0;n[r>>2]=+n[r>>2]/v;j=j+1|0}while((j|0)!=128);return}function zOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0,J=0,K=0.0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0;d=f[a+12>>2]|0;e=+n[b+4>>2];g=+n[b>>2];h=ALc(+n[b+8>>2]*.5)|0;i=+n[b+12>>2]*.01745329238474369;j=f[b+24>>2]|0;k=+O(+i);l=+P(+i);b=0-h|0;i=+(h|0)*2.5;m=i*(i*2.0);o=f[a+32>>2]|0;p=f[a+36>>2]|0;a=o+-1|0;q=p+-1|0;r=f[d>>2]|0;d=f[r+(j*468|0)+16>>2]|0;s=f[f[r+(j*468|0)+44>>2]>>2]|0;t=f[r+(j*468|0)+72>>2]|0;u=f[f[r+(j*468|0)+100>>2]>>2]|0;i=-.5;j=0;r=-8;v=0.0;while(1){w=r+-4|0;i=i+1.0;x=+(Y(r+1|0,h)|0);y=k*x;z=l*x;x=i+-2.0;A=x*x;B=r+4|0;x=-.5;C=-8;D=j;E=v;while(1){F=C+-4|0;G=g+(y+l*+(Y(h,~C)|0));H=e+(z+k*+(Y(C+1|0,h)|0));I=C+4|0;J=w;K=0.0;N=0.0;Q=0.0;R=0.0;while(1){S=+(Y(J,h)|0);T=l*S;U=k*S;W=F;X=N;Z=Q;_=R;$=K;while(1){S=e+(T+k*+(Y(W,h)|0));aa=g+(U+l*+(Y(W,b)|0));ba=G-aa;ca=H-S;da=+V(+(-(ba*ba+ca*ca)/m));ea=~~S;fa=ea-(+(ea|0)>S&1)|0;ea=~~aa;ga=ea-(+(ea|0)>aa&1)|0;ea=(ga|0)>0?ga:0;ga=(fa|0)>0?fa:0;fa=(ea|0)<(o|0)?ea:a;ea=(ga|0)<(p|0)?ga:q;ga=(fa|0)<-1?0:fa+1|0;ha=(ea|0)<-1?0:ea+1|0;ia=(ga|0)<(o|0)?ga:a;ga=(ha|0)<(p|0)?ha:q;ca=aa-+(fa|0);aa=S-+(ea|0);ha=d+(Y(s,ea)|0)|0;ja=d+(Y(s,ga)|0)|0;S=1.0-ca;ba=1.0-aa;ka=S*ba;la=ca*ba;ba=S*aa;S=ca*aa;aa=ka*+n[ha+(fa<<2)>>2]+la*+n[ha+(ia<<2)>>2]+ba*+n[ja+(fa<<2)>>2]+S*+n[ja+(ia<<2)>>2];ja=t+(Y(u,ea)|0)|0;ea=t+(Y(u,ga)|0)|0;ca=ka*+n[ja+(fa<<2)>>2]+la*+n[ja+(ia<<2)>>2]+ba*+n[ea+(fa<<2)>>2]+S*+n[ea+(ia<<2)>>2];S=da*(k*aa+l*ca);ba=da*(k*ca-l*aa);$=$+ba;X=X+S;_=_+ +L(+ba);Z=Z+ +L(+S);if((W|0)>=(I|0))break;else W=W+1|0}if((J|0)<(B|0)){J=J+1|0;K=$;N=X;Q=Z;R=_}else break}x=x+1.0;R=x+-2.0;Q=+V(+(-(A+R*R)/4.5));n[c+(D<<2)>>2]=$*Q;n[c+((D|1)<<2)>>2]=X*Q;n[c+((D|2)<<2)>>2]=_*Q;n[c+((D|3)<<2)>>2]=Z*Q;E=E+Q*((Z*Z+(_*_+(X*X+$*$)))*Q);C=C+5|0;if((C|0)>=12)break;else D=D+4|0}r=r+5|0;if((r|0)>=12)break;else{j=j+16|0;v=E}}v=+M(+E);j=0;do{r=c+(j<<2)|0;n[r>>2]=+n[r>>2]/v;j=j+1|0}while((j|0)!=64);return}function AOb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;g=u;u=u+16|0;h=g+4|0;i=g;j=+n[a>>2]/+(f[b>>2]|0)*3.0;k=+n[c>>2];l=+M(+(j/k+.25))+-.5+-9.99999993922529e-09;b=~~l;a=(+(b|0)<l&1)+b|0;f[h>>2]=a;l=j/(k*+(Y(a+1|0,a)|0));n[i>>2]=l;a=BOb(h,i,c,d,e)|0;u=g;return a|0}function BOb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0;h=u;u=u+16|0;i=h+12|0;j=h;f[i>>2]=0;k=f[a>>2]|0;if((k|0)<1){l=0;u=h;return l|0}f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;if(k>>>0>1073741823)kWc(j);o=k<<2;p=$Xc(o)|0;f[j>>2]=p;q=p+(k<<2)|0;f[j+8>>2]=q;g1c(p|0,0,o|0)|0;f[m>>2]=q;m=p;o=q;q=f[g>>2]|0;k=g+4|0;if(!q)r=g+8|0;else{s=f[k>>2]|0;if((s|0)!=(q|0))f[k>>2]=s+(~((s+-4-q|0)>>>2)<<2);cYc(q);q=g+8|0;f[q>>2]=0;f[k>>2]=0;f[g>>2]=0;r=q}f[g>>2]=m;f[k>>2]=o;f[r>>2]=o;o=b[e>>0]|0;if(!(o<<24>>24)){t=0;v=0;w=f[a>>2]|0;x=0}else{e=f[a>>2]|0;f[j>>2]=0;a=j+4|0;f[a>>2]=0;f[j+8>>2]=0;do if(e)if(e>>>0>1073741823)kWc(j);else{r=e<<2;k=$Xc(r)|0;f[j>>2]=k;m=k+(e<<2)|0;f[j+8>>2]=m;g1c(k|0,0,r|0)|0;f[a>>2]=m;y=k;break}else y=0;while(0);f[i>>2]=y;t=y;v=y;w=e;x=o}z=1.0/(+(w|0)*4.0+2.0);A=+n[c>>2]*+n[d>>2]*.5;d=(w|0)>0;if(d){c=f[(x<<24>>24==0?g:i)>>2]|0;g=0;do{B=+O(+(z*((+(g|0)*2.0+1.0)*3.1415927410125732)));n[c+(g<<2)>>2]=A/(B*B);g=g+1|0}while((g|0)<(w|0))}if(x<<24>>24){x=(w|0)/2|0;g=w;while(1){c=g;g=g+1|0;if((g|0)<2){g=g;continue}o=c+-1|0;if(o>>>0<6?43>>>(o&255)&1:0)break;if(((g>>>0)%7|0|0)==0|(((g>>>0)%5|0|0)==0|((g&1|0)==0|((g>>>0)%3|0|0)==0))){g=g;continue}o=~~+M(+(+(g|0)+1.0));if((o|0)<11)break;else{C=1;D=11}do{C=C&((g|0)%(D|0)|0|0)!=0;D=D+2|0}while((D|0)<=(o|0));if(C)break}if(d){d=0;C=0;while(1){D=C;do{D=D+1|0;E=(Y(D,x)|0)%(g|0)|0}while((E|0)>(w|0));f[p+(d<<2)>>2]=f[v+(E+-1<<2)>>2];d=d+1|0;if((d|0)>=(w|0))break;else C=D}F=f[i>>2]|0}else F=t}else F=t;if(!F){l=w;u=h;return l|0}cYc(F);l=w;u=h;return l|0}function COb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a;e=c;c=d+68|0;do{f[d>>2]=f[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(c|0));f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;e=a+88|0;g=a+112|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[g>>2]=1124007936;e=a+120|0;h=a+152|0;d=a+116|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[h>>2]=e;e=a+160|0;f[a+156>>2]=e;f[e>>2]=0;f[a+164>>2]=0;e=a+168|0;f[e>>2]=1124007936;h=a+176|0;i=a+208|0;d=a+172|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[i>>2]=h;h=a+216|0;f[a+212>>2]=h;f[h>>2]=0;f[a+220>>2]=0;f[a+224>>2]=1124007936;h=a+232|0;i=a+264|0;d=a+228|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[i>>2]=h;h=a+272|0;f[a+268>>2]=h;f[h>>2]=0;f[a+276>>2]=0;f[a+80>>2]=0;b[a+84>>0]=1;h=f[a+44>>2]|0;if((h|0)<=0){EOb(a);return}if((f[a+40>>2]|0)<=3){EOb(a);return}DOb(g,e,h,f[a+52>>2]|0,f[a+48>>2]|0);EOb(a);return}function DOb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;h=u;u=u+384|0;i=h;j=h+368|0;k=h+312|0;l=h+256|0;m=h+200|0;n=h+144|0;o=h+88|0;q=h+32|0;if((g*162|0)<(d|0)){r=$Xc(112)|0;f[i>>2]=r;f[i+8>>2]=-2147483536;f[i+4>>2]=97;s=r;t=463474;v=s+97|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+97>>0]=0;vM(-215,i,463572,463600,2224)}f[k>>2]=1124007936;r=k+4|0;t=k+8|0;w=k+40|0;s=r;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[w>>2]=t;x=k+48|0;y=k+44|0;f[y>>2]=x;f[x>>2]=0;f[k+52>>2]=0;f[i>>2]=162;z=i+4|0;f[z>>2]=5;S$(k,2,i,4);A=(e<<1)+-1|0;B=k+16|0;C=f[B>>2]|0;D=f[y>>2]|0;E=0;F=0;G=5;H=3;I=4;while(1){K=F+2|0;L=Y(K,K)|0;M=((A+K|0)>>>0)/(K>>>0)|0;a:do if(!L)N=E;else{O=0;P=E;Q=H;while(1){R=O;O=O+1|0;S=(O|0)<(L|0);if(!S){N=P;break a}T=(Y((R|0)%(K|0)|0,M)|0)-e|0;U=(Y((R|0)/(K|0)|0,M)|0)-e|0;R=O;V=P;while(1){W=C+(Y(f[D>>2]|0,V)|0)|0;f[W>>2]=F;W=C+(Y(f[D>>2]|0,V)|0)+4|0;f[W>>2]=T;W=C+(Y(f[D>>2]|0,V)|0)+8|0;f[W>>2]=U;W=(Y((R|0)%(K|0)|0,M)|0)-e|0;X=C+(Y(f[D>>2]|0,V)|0)+12|0;f[X>>2]=W;W=(Y((R|0)/(K|0)|0,M)|0)-e|0;X=C+(Y(f[D>>2]|0,V)|0)+16|0;f[X>>2]=W;R=R+1|0;if((R|0)==(I|0))break;else V=V+1|0}V=P+Q|0;if(!S){N=V;break}else{P=V;Q=Q+-1|0}}}while(0);F=F+1|0;H=H+G|0;I=I+G|0;if((F|0)==3)break;else{E=N;G=G+2|0}}G=((d+-1+g|0)>>>0)/(g>>>0)|0;N=Y(G,g)|0;f[l>>2]=1124007936;E=l+4|0;F=l+8|0;I=l+40|0;s=E;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[I>>2]=F;F=l+48|0;H=l+44|0;f[H>>2]=F;f[F>>2]=0;f[l+52>>2]=0;f[i>>2]=N;f[z>>2]=2;S$(l,2,i,4);p[i>>3]=1.0e3;N=i+8|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;f[N+16>>2]=0;f[N+20>>2]=0;lR(l,i)|0;f[m>>2]=1124007936;N=m+4|0;D=m+8|0;C=m+40|0;s=N;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[C>>2]=D;D=m+48|0;e=m+44|0;f[e>>2]=D;f[D>>2]=0;f[m+52>>2]=0;f[i>>2]=29;f[z>>2]=3;S$(m,2,i,4);HOb(n,k);p[i>>3]=-1.0;z=i+8|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;lR(m,i)|0;if((G|0)>0){z=i+4|0;A=j+4|0;M=o+4|0;K=q+4|0;L=o+8|0;Q=q+8|0;P=o+12|0;O=q+12|0;V=o+16|0;R=q+16|0;U=o+20|0;T=q+20|0;W=o+24|0;X=q+24|0;Z=o+28|0;_=q+28|0;$=o+32|0;aa=q+32|0;ba=o+36|0;ca=q+36|0;da=o+40|0;ea=o+44|0;fa=o+48|0;ga=o+52|0;ha=q+44|0;ia=q+40|0;ja=q+48|0;ka=n+8|0;la=i+4|0;ma=j+4|0;na=i+8|0;oa=i+4|0;pa=q+36|0;qa=q+16|0;ra=q+4|0;sa=q+40|0;ta=q+44|0;ua=q+48|0;va=o+40|0;wa=o+44|0;xa=n+16|0;ya=n+44|0;za=m+16|0;Aa=l+16|0;Ba=0;Ca=0;Da=1024;Ea=0;while(1){Fa=(f[t>>2]|0)-Ba|0;Ga=x1c(Da|0,0,-130063606,0)|0;Ha=d1c(Ga|0,J|0,Ea|0,0)|0;if(!Fa){Ia=0;Ja=Da;Ka=Ea}else{Ia=(Ha>>>0)%(Fa>>>0)|0;Ja=Ha;Ka=J}Ha=(Ba|0)<6?Ba:Ia;b:do if((Ca|0)>0){Fa=f[za>>2]|0;Ga=f[e>>2]|0;La=f[Ga>>2]|0;Ma=f[xa>>2]|0;Na=f[ya>>2]|0;Oa=f[Na>>2]|0;Pa=Ma+(Y(Oa,Ha)|0)|0;Qa=f[Pa>>2]|0;Ra=Pa+4|0;Sa=Pa+8|0;Pa=0;while(1){Ta=Fa+(Y(La,Pa)|0)|0;if(((f[Ta>>2]|0)==(Qa|0)?(f[Ta+4>>2]|0)==(f[Ra>>2]|0):0)?(f[Ta+8>>2]|0)==(f[Sa>>2]|0):0)break;Ta=Pa+1|0;if((Ta|0)<(Ca|0))Pa=Ta;else{Ua=Oa;Va=Ma;Wa=La;Xa=Fa;Ya=Na;Za=Ga;_a=23;break b}}La=Y(Pa,g)|0;Oa=Y(Ba,g)|0;Sa=f[Aa>>2]|0;Ra=f[H>>2]|0;Qa=Sa+(Y(f[Ra>>2]|0,Oa)|0)|0;f[Qa>>2]=La;Qa=Sa+(Y(f[Ra>>2]|0,Oa+1|0)|0)|0;f[Qa>>2]=La+1;Qa=Sa+(Y(f[Ra>>2]|0,Oa+2|0)|0)|0;f[Qa>>2]=La+2;$a=Ca;ab=Na;bb=Ga;cb=Ma;db=Fa;eb=Ra;fb=Sa}else{Sa=f[ya>>2]|0;Ra=f[e>>2]|0;Ua=f[Sa>>2]|0;Va=f[xa>>2]|0;Wa=f[Ra>>2]|0;Xa=f[za>>2]|0;Ya=Sa;Za=Ra;_a=23}while(0);if((_a|0)==23){_a=0;Ra=Va+(Y(Ua,Ha)|0)|0;Sa=Xa+(Y(Wa,Ca)|0)|0;f[Sa>>2]=f[Ra>>2];Ra=Va+(Y(f[Ya>>2]|0,Ha)|0)+4|0;Sa=Xa+(Y(f[Za>>2]|0,Ca)|0)+4|0;f[Sa>>2]=f[Ra>>2];Ra=Va+(Y(f[Ya>>2]|0,Ha)|0)+8|0;Sa=Xa+(Y(f[Za>>2]|0,Ca)|0)+8|0;f[Sa>>2]=f[Ra>>2];Ra=Y(Ca,g)|0;Sa=Y(Ba,g)|0;La=f[Aa>>2]|0;Qa=f[H>>2]|0;Oa=La+(Y(f[Qa>>2]|0,Sa)|0)|0;f[Oa>>2]=Ra;Oa=La+(Y(f[Qa>>2]|0,Sa+1|0)|0)|0;f[Oa>>2]=Ra+1;Oa=La+(Y(f[Qa>>2]|0,Sa+2|0)|0)|0;f[Oa>>2]=Ra+2;$a=Ca+1|0;ab=Ya;bb=Za;cb=Va;db=Xa;eb=Qa;fb=La}c:do if(($a|0)>0){La=f[bb>>2]|0;Qa=f[ab>>2]|0;Ra=cb+(Y(Qa,Ha)|0)|0;Oa=f[Ra>>2]|0;Sa=Ra+12|0;Ta=Ra+16|0;Ra=0;while(1){gb=db+(Y(La,Ra)|0)|0;if(((f[gb>>2]|0)==(Oa|0)?(f[gb+4>>2]|0)==(f[Sa>>2]|0):0)?(f[gb+8>>2]|0)==(f[Ta>>2]|0):0)break;gb=Ra+1|0;if((gb|0)<($a|0))Ra=gb;else{hb=Qa;ib=La;_a=32;break c}}La=Y(Ra,g)|0;Qa=Y(Ba,g)|0;Ta=fb+(Y(f[eb>>2]|0,Qa)|0)+4|0;f[Ta>>2]=La;Ta=fb+(Y(f[eb>>2]|0,Qa+1|0)|0)+4|0;f[Ta>>2]=La+1;Ta=fb+(Y(f[eb>>2]|0,Qa+2|0)|0)+4|0;f[Ta>>2]=La+2;jb=$a}else{hb=f[ab>>2]|0;ib=f[bb>>2]|0;_a=32}while(0);if((_a|0)==32){_a=0;La=cb+(Y(hb,Ha)|0)|0;Ta=db+(Y(ib,$a)|0)|0;f[Ta>>2]=f[La>>2];La=cb+(Y(f[ab>>2]|0,Ha)|0)+12|0;Ta=db+(Y(f[bb>>2]|0,$a)|0)+4|0;f[Ta>>2]=f[La>>2];La=cb+(Y(f[ab>>2]|0,Ha)|0)+16|0;Ta=db+(Y(f[bb>>2]|0,$a)|0)+8|0;f[Ta>>2]=f[La>>2];La=Y($a,g)|0;Ta=Y(Ba,g)|0;Qa=fb+(Y(f[eb>>2]|0,Ta)|0)+4|0;f[Qa>>2]=La;Qa=fb+(Y(f[eb>>2]|0,Ta+1|0)|0)+4|0;f[Qa>>2]=La+1;Qa=fb+(Y(f[eb>>2]|0,Ta+2|0)|0)+4|0;f[Qa>>2]=La+2;jb=$a+1|0}f[i>>2]=Ha;f[z>>2]=Ha+1;f[j>>2]=-2147483648;f[A>>2]=2147483647;W$(q,n,i,j);f[o>>2]=f[q>>2];La=f[K>>2]|0;f[M>>2]=La;f[L>>2]=f[Q>>2];f[P>>2]=f[O>>2];f[V>>2]=f[R>>2];f[U>>2]=f[T>>2];f[W>>2]=f[X>>2];f[Z>>2]=f[_>>2];f[$>>2]=f[aa>>2];f[ba>>2]=f[ca>>2];f[da>>2]=L;f[ea>>2]=fa;f[ga>>2]=0;f[fa>>2]=0;if((La|0)<3){La=f[ha>>2]|0;f[fa>>2]=f[La>>2];f[ga>>2]=f[La+4>>2];kb=La}else{f[ea>>2]=f[ha>>2];f[da>>2]=f[ia>>2];f[ha>>2]=ja;f[ia>>2]=Q;kb=ja}f[q>>2]=1124007936;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[K+16>>2]=0;f[K+20>>2]=0;f[K+24>>2]=0;f[K+28>>2]=0;f[ca>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((kb|0)!=(ja|0))wL(kb);La=(f[ka>>2]|0)-Ba|0;f[i>>2]=La+-1;f[la>>2]=La;f[j>>2]=-2147483648;f[ma>>2]=2147483647;W$(q,n,i,j);La=na;f[La>>2]=0;f[La+4>>2]=0;f[i>>2]=33619968;f[oa>>2]=o;jR(q,i);La=f[pa>>2]|0;if(La|0?(Qa=La+12|0,La=f[Qa>>2]|0,f[Qa>>2]=La+-1,(La|0)==1):0)V$(q);f[pa>>2]=0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[ra>>2]|0)>0){La=f[sa>>2]|0;Qa=0;do{f[La+(Qa<<2)>>2]=0;Qa=Qa+1|0}while((Qa|0)<(f[ra>>2]|0))}Qa=f[ta>>2]|0;if((Qa|0)!=(ua|0))wL(Qa);Qa=f[ba>>2]|0;if(Qa|0?(La=Qa+12|0,Qa=f[La>>2]|0,f[La>>2]=Qa+-1,(Qa|0)==1):0)V$(o);f[ba>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[M>>2]|0)>0){Qa=f[va>>2]|0;La=0;do{f[Qa+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[M>>2]|0))}La=f[wa>>2]|0;if((La|0)!=(fa|0))wL(La);Ba=Ba+1|0;if((Ba|0)>=(G|0)){lb=jb;break}else{Ca=jb;Da=Ja;Ea=Ka}}}else lb=0;f[i>>2]=0;f[i+4>>2]=lb;f[j>>2]=-2147483648;f[j+4>>2]=2147483647;W$(q,m,i,j);f[o>>2]=1124007936;lb=o+4|0;Ka=o+8|0;Ea=o+40|0;s=lb;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[Ea>>2]=Ka;Ja=o+48|0;Da=o+44|0;f[Da>>2]=Ja;f[Ja>>2]=0;f[o+52>>2]=0;jb=i+8|0;f[jb>>2]=0;f[jb+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jR(q,i);jb=a+36|0;Ca=f[jb>>2]|0;if((o|0)==(a|0)){G=o+36|0;if((Ca|0)!=0?(Ba=Ca+12|0,fa=f[Ba>>2]|0,f[Ba>>2]=fa+-1,(fa|0)==1):0){V$(o);mb=G}else mb=G}else{if(Ca|0?(G=Ca+12|0,Ca=f[G>>2]|0,f[G>>2]=Ca+-1,(Ca|0)==1):0)V$(a);f[jb>>2]=0;Ca=a+16|0;G=a+4|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[G>>2]|0)>0){fa=f[a+40>>2]|0;Ba=0;do{f[fa+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[G>>2]|0))}f[a>>2]=f[o>>2];Ba=f[lb>>2]|0;f[G>>2]=Ba;G=a+8|0;f[G>>2]=f[Ka>>2];f[a+12>>2]=f[o+12>>2];f[Ca>>2]=f[o+16>>2];f[a+20>>2]=f[o+20>>2];f[a+24>>2]=f[o+24>>2];f[a+28>>2]=f[o+28>>2];f[a+32>>2]=f[o+32>>2];Ca=o+36|0;f[jb>>2]=f[Ca>>2];jb=a+44|0;fa=f[jb>>2]|0;wa=a+48|0;if((fa|0)==(wa|0)){nb=Ba;ob=fa}else{wL(fa);f[jb>>2]=wa;f[a+40>>2]=G;nb=f[lb>>2]|0;ob=wa}wa=o+44|0;if((nb|0)<3){nb=f[wa>>2]|0;f[ob>>2]=f[nb>>2];f[ob+4>>2]=f[nb+4>>2]}else{f[jb>>2]=f[wa>>2];f[a+40>>2]=f[Ea>>2];f[wa>>2]=Ja;f[Ea>>2]=Ka}f[o>>2]=1124007936;s=lb;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));mb=Ca}f[mb>>2]=0;mb=o+16|0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[lb>>2]|0)>0){mb=f[Ea>>2]|0;Ea=0;do{f[mb+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[lb>>2]|0))}lb=f[Da>>2]|0;if((lb|0)!=(Ja|0))wL(lb);lb=q+36|0;Ja=f[lb>>2]|0;if(Ja|0?(Da=Ja+12|0,Ja=f[Da>>2]|0,f[Da>>2]=Ja+-1,(Ja|0)==1):0)V$(q);f[lb>>2]=0;lb=q+16|0;Ja=q+4|0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[Ja>>2]|0)>0){lb=f[q+40>>2]|0;Da=0;do{f[lb+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[Ja>>2]|0))}Ja=f[q+44>>2]|0;if((Ja|0)!=(q+48|0))wL(Ja);f[i>>2]=0;f[i+4>>2]=d;f[j>>2]=-2147483648;f[j+4>>2]=2147483647;W$(q,l,i,j);f[o>>2]=1124007936;j=o+4|0;d=o+8|0;Ja=o+40|0;s=j;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[Ja>>2]=d;Da=o+48|0;lb=o+44|0;f[lb>>2]=Da;f[Da>>2]=0;f[o+52>>2]=0;Ea=i+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jR(q,i);i=c+36|0;Ea=f[i>>2]|0;if((o|0)==(c|0)){mb=o+36|0;if((Ea|0)!=0?(Ca=Ea+12|0,Ka=f[Ca>>2]|0,f[Ca>>2]=Ka+-1,(Ka|0)==1):0){V$(o);pb=mb}else pb=mb}else{if(Ea|0?(mb=Ea+12|0,Ea=f[mb>>2]|0,f[mb>>2]=Ea+-1,(Ea|0)==1):0)V$(c);f[i>>2]=0;Ea=c+16|0;mb=c+4|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[mb>>2]|0)>0){Ka=f[c+40>>2]|0;Ca=0;do{f[Ka+(Ca<<2)>>2]=0;Ca=Ca+1|0}while((Ca|0)<(f[mb>>2]|0))}f[c>>2]=f[o>>2];Ca=f[j>>2]|0;f[mb>>2]=Ca;mb=c+8|0;f[mb>>2]=f[d>>2];f[c+12>>2]=f[o+12>>2];f[Ea>>2]=f[o+16>>2];f[c+20>>2]=f[o+20>>2];f[c+24>>2]=f[o+24>>2];f[c+28>>2]=f[o+28>>2];f[c+32>>2]=f[o+32>>2];Ea=o+36|0;f[i>>2]=f[Ea>>2];i=c+44|0;Ka=f[i>>2]|0;wa=c+48|0;if((Ka|0)==(wa|0)){qb=Ca;rb=Ka}else{wL(Ka);f[i>>2]=wa;f[c+40>>2]=mb;qb=f[j>>2]|0;rb=wa}wa=o+44|0;if((qb|0)<3){qb=f[wa>>2]|0;f[rb>>2]=f[qb>>2];f[rb+4>>2]=f[qb+4>>2]}else{f[i>>2]=f[wa>>2];f[c+40>>2]=f[Ja>>2];f[wa>>2]=Da;f[Ja>>2]=d}f[o>>2]=1124007936;s=j;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));pb=Ea}f[pb>>2]=0;pb=o+16|0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[j>>2]|0)>0){pb=f[Ja>>2]|0;Ja=0;do{f[pb+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[j>>2]|0))}j=f[lb>>2]|0;if((j|0)!=(Da|0))wL(j);j=q+36|0;Da=f[j>>2]|0;if(Da|0?(lb=Da+12|0,Da=f[lb>>2]|0,f[lb>>2]=Da+-1,(Da|0)==1):0)V$(q);f[j>>2]=0;j=q+16|0;Da=q+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[Da>>2]|0)>0){j=f[q+40>>2]|0;lb=0;do{f[j+(lb<<2)>>2]=0;lb=lb+1|0}while((lb|0)<(f[Da>>2]|0))}Da=f[q+44>>2]|0;if((Da|0)!=(q+48|0))wL(Da);Da=n+36|0;q=f[Da>>2]|0;if(q|0?(lb=q+12|0,q=f[lb>>2]|0,f[lb>>2]=q+-1,(q|0)==1):0)V$(n);f[Da>>2]=0;Da=n+16|0;q=n+4|0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[q>>2]|0)>0){Da=f[n+40>>2]|0;lb=0;do{f[Da+(lb<<2)>>2]=0;lb=lb+1|0}while((lb|0)<(f[q>>2]|0))}q=f[n+44>>2]|0;if((q|0)!=(n+48|0))wL(q);q=m+36|0;n=f[q>>2]|0;if(n|0?(lb=n+12|0,n=f[lb>>2]|0,f[lb>>2]=n+-1,(n|0)==1):0)V$(m);f[q>>2]=0;q=m+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[N>>2]|0)>0){q=f[C>>2]|0;C=0;do{f[q+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[N>>2]|0))}N=f[e>>2]|0;if((N|0)!=(D|0))wL(N);N=l+36|0;D=f[N>>2]|0;do if(D|0){e=D+12|0;C=f[e>>2]|0;f[e>>2]=C+-1;if((C|0)!=1)break;V$(l)}while(0);f[N>>2]=0;N=l+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[E>>2]|0)>0){N=f[I>>2]|0;I=0;do{f[N+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[E>>2]|0))}E=f[H>>2]|0;if((E|0)!=(F|0))wL(E);E=k+36|0;F=f[E>>2]|0;do if(F|0){H=F+12|0;I=f[H>>2]|0;f[H>>2]=I+-1;if((I|0)!=1)break;V$(k)}while(0);f[E>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[r>>2]|0)>0){B=f[w>>2]|0;w=0;do{f[B+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[r>>2]|0))}r=f[y>>2]|0;if((r|0)==(x|0)){u=h;return}wL(r);u=h;return}function EOb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;b=u;u=u+352|0;c=b+24|0;d=b+12|0;e=b+8|0;g=b+4|0;h=b;switch(f[a+40>>2]|0){case 5:case 4:{i=14.142135620117188;break}case 3:case 2:{i=16.970561981201172;break}default:i=0.0}j=f[a>>2]|0;a:do if((j|0)>0){k=a+12|0;l=a+8|0;m=a+4|0;o=c+4|0;p=c+8|0;q=c+40|0;r=c+48|0;s=c+44|0;t=c+52|0;v=c+56|0;w=c+60|0;x=c+64|0;y=c+96|0;z=c+104|0;A=c+100|0;B=c+108|0;C=c+112|0;D=c+116|0;E=c+120|0;F=c+152|0;G=c+160|0;H=c+156|0;I=c+164|0;J=c+168|0;K=c+172|0;L=c+176|0;M=c+208|0;N=c+216|0;O=c+212|0;P=c+220|0;Q=c+224|0;R=c+228|0;S=c+232|0;T=c+264|0;U=c+272|0;V=c+268|0;W=c+280|0;X=c+284|0;Y=a+16|0;Z=c+292|0;_=a+20|0;$=c+304|0;aa=c+288|0;ba=c+296|0;ca=c+300|0;da=c+308|0;ea=c+312|0;fa=a+72|0;ga=a+76|0;ha=a+68|0;ia=1;ja=0;ka=j;while(1){la=+(ia|0);ma=1.0/la;na=~~(ma*+(f[k>>2]|0));oa=~~(ma*+(f[l>>2]|0));if((ja|0)!=0&((na|0)<40|(oa|0)<80))break;pa=f[m>>2]|0;if((pa|0)>0){ma=+(ja|0);qa=0;ra=pa;do{f[c>>2]=1124007936;pa=o;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[q>>2]=p;f[s>>2]=r;f[r>>2]=0;f[t>>2]=0;f[v>>2]=1124007936;pa=w;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[y>>2]=x;f[A>>2]=z;f[z>>2]=0;f[B>>2]=0;f[C>>2]=1124007936;pa=D;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[F>>2]=E;f[H>>2]=G;f[G>>2]=0;f[I>>2]=0;f[J>>2]=1124007936;pa=K;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[M>>2]=L;f[O>>2]=N;f[N>>2]=0;f[P>>2]=0;f[Q>>2]=1124007936;pa=R;sa=pa+36|0;do{f[pa>>2]=0;pa=pa+4|0}while((pa|0)<(sa|0));f[T>>2]=S;f[V>>2]=U;pa=U;f[pa>>2]=0;f[pa+4>>2]=0;f[W>>2]=oa;f[X>>2]=na;ta=+n[Y>>2];ua=ta*+Me(+(ma+ +(qa|0)/+(ra|0)));n[Z>>2]=ua;pa=ALc(ua*+n[_>>2]/la)|0;f[$>>2]=pa;n[aa>>2]=ua*ua*.5;f[ba>>2]=ja;f[ca>>2]=qa;n[da>>2]=la;sa=(ALc(i*+(pa|0))|0)+1|0;f[ea>>2]=sa;sa=f[fa>>2]|0;if((sa|0)==(f[ga>>2]|0))GOb(ha,c);else{FOb(sa,c);f[fa>>2]=(f[fa>>2]|0)+316}VNb(c);qa=qa+1|0;ra=f[m>>2]|0}while((qa|0)<(ra|0));va=f[a>>2]|0}else va=ka;ra=ja+1|0;if((ra|0)<(va|0)){ia=ia<<1;ja=ra;ka=va}else{wa=fa;xa=ha;break a}}f[a>>2]=ja;wa=fa;xa=ha}else{wa=a+72|0;xa=a+68|0}while(0);va=f[xa>>2]|0;if((((f[wa>>2]|0)-va|0)/316|0)>>>0<=1){u=b;return}j=d+4|0;ka=d+8|0;ia=a+84|0;m=a+104|0;ga=a+108|0;ea=a+100|0;da=a+92|0;ca=a+96|0;ba=a+88|0;aa=a+80|0;a=1;$=va;while(1){va=$;f[c>>2]=0;f[d>>2]=0;f[j>>2]=0;f[ka>>2]=0;n[e>>2]=+n[va+(a*316|0)+288>>2]-+n[va+((a+-1|0)*316|0)+288>>2];f[g>>2]=1;n[h>>2]=.25;va=AOb(e,g,h,ia,d)|0;f[c>>2]=va;_=f[m>>2]|0;if((_|0)==(f[ga>>2]|0))Tv(ea,c);else{f[_>>2]=va;f[m>>2]=_+4}ya=f[da>>2]|0;if((ya|0)==(f[ca>>2]|0)){gOb(ba,d);za=f[d>>2]|0}else{f[ya>>2]=0;_=ya+4|0;f[_>>2]=0;f[ya+8>>2]=0;va=f[d>>2]|0;Z=(f[j>>2]|0)-va|0;Y=Z>>2;if(Y){if(Y>>>0>1073741823){Aa=26;break}X=$Xc(Z)|0;f[_>>2]=X;f[ya>>2]=X;f[ya+8>>2]=X+(Y<<2);Y=f[d>>2]|0;Z=(f[j>>2]|0)-Y|0;if((Z|0)>0){o1c(X|0,Y|0,Z|0)|0;f[_>>2]=X+(Z>>>2<<2);Ba=Y}else Ba=Y}else Ba=va;f[da>>2]=(f[da>>2]|0)+12;za=Ba}f[aa>>2]=(f[aa>>2]|0)+1;if(za|0){va=f[j>>2]|0;if((va|0)!=(za|0))f[j>>2]=va+(~((va+-4-za|0)>>>2)<<2);cYc(za)}a=a+1|0;$=f[xa>>2]|0;if(a>>>0>=(((f[wa>>2]|0)-$|0)/316|0)>>>0){Aa=19;break}}if((Aa|0)==19){u=b;return}else if((Aa|0)==26)kWc(ya)}function FOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=f[b>>2];c=a+4|0;d=b+4|0;f[c>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];g=f[b+36>>2]|0;f[a+36>>2]=g;f[a+40>>2]=e;e=a+48|0;h=a+44|0;f[h>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){d=f[b+44>>2]|0;e=f[h>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2]}else{f[c>>2]=0;U$(a,b)}c=a+56|0;d=b+56|0;f[c>>2]=f[d>>2];e=a+60|0;h=b+60|0;f[e>>2]=f[h>>2];g=a+64|0;f[g>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[a+80>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];i=f[b+92>>2]|0;f[a+92>>2]=i;f[a+96>>2]=g;g=a+104|0;j=a+100|0;f[j>>2]=g;f[g>>2]=0;f[a+108>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+100>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(c,d)}d=a+112|0;c=b+112|0;f[d>>2]=f[c>>2];e=a+116|0;h=b+116|0;f[e>>2]=f[h>>2];g=a+120|0;f[g>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[a+136>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];j=f[b+148>>2]|0;f[a+148>>2]=j;f[a+152>>2]=g;g=a+160|0;i=a+156|0;f[i>>2]=g;f[g>>2]=0;f[a+164>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+156>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(d,c)}c=a+168|0;d=b+168|0;f[c>>2]=f[d>>2];e=a+172|0;h=b+172|0;f[e>>2]=f[h>>2];g=a+176|0;f[g>>2]=f[b+176>>2];f[a+180>>2]=f[b+180>>2];f[a+184>>2]=f[b+184>>2];f[a+188>>2]=f[b+188>>2];f[a+192>>2]=f[b+192>>2];f[a+196>>2]=f[b+196>>2];f[a+200>>2]=f[b+200>>2];i=f[b+204>>2]|0;f[a+204>>2]=i;f[a+208>>2]=g;g=a+216|0;j=a+212|0;f[j>>2]=g;f[g>>2]=0;f[a+220>>2]=0;if(i|0){g=i+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+212>>2]|0;g=f[j>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{f[e>>2]=0;U$(c,d)}d=a+224|0;c=b+224|0;f[d>>2]=f[c>>2];e=a+228|0;h=b+228|0;f[e>>2]=f[h>>2];g=a+232|0;f[g>>2]=f[b+232>>2];f[a+236>>2]=f[b+236>>2];f[a+240>>2]=f[b+240>>2];f[a+244>>2]=f[b+244>>2];f[a+248>>2]=f[b+248>>2];f[a+252>>2]=f[b+252>>2];f[a+256>>2]=f[b+256>>2];j=f[b+260>>2]|0;f[a+260>>2]=j;f[a+264>>2]=g;g=a+272|0;i=a+268|0;f[i>>2]=g;f[g>>2]=0;f[a+276>>2]=0;if(j|0){g=j+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+268>>2]|0;g=f[i>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];k=a+280|0;l=b+280|0;m=f[l>>2]|0;f[k>>2]=m;n=a+284|0;o=b+284|0;p=f[o>>2]|0;f[n>>2]=p;q=a+288|0;r=b+288|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];f[q+20>>2]=f[r+20>>2];f[q+24>>2]=f[r+24>>2];return}else{f[e>>2]=0;U$(d,c);k=a+280|0;l=b+280|0;m=f[l>>2]|0;f[k>>2]=m;n=a+284|0;o=b+284|0;p=f[o>>2]|0;f[n>>2]=p;q=a+288|0;r=b+288|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];f[q+20>>2]=f[r+20>>2];f[q+24>>2]=f[r+24>>2];return}}function GOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/316|0;g=e+1|0;if(g>>>0>13591668)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/316|0;d=i<<1;j=i>>>0<6795834?(d>>>0<g>>>0?g:d):13591668;do if(j)if(j>>>0>13591668){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*316|0)|0;break}else k=0;while(0);d=k+(e*316|0)|0;e=d;g=k+(j*316|0)|0;FOb(d,b);b=d+316|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-316|0;FOb(e+-316|0,i);e=k+-316|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{h=h+-316|0;VNb(h)}while((h|0)!=(g|0))}if(!m)return;cYc(m);return}function HOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+80|0;d=c+56|0;e=c;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;l=e+44|0;f[l>>2]=h;f[h>>2]=0;f[e+52>>2]=0;m=d+8|0;f[m>>2]=0;f[m+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=e;jR(b,d);d=a+8|0;b=a+40|0;j=a+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[b>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007940;IOb(a,e)|0;a=e+36|0;d=f[a>>2]|0;if(d|0?(b=d+12|0,d=f[b>>2]|0,f[b>>2]=d+-1,(d|0)==1):0)V$(e);f[a>>2]=0;a=e+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[i>>2]|0;i=0;do{f[a+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[l>>2]|0;if((g|0)==(h|0)){u=c;return}wL(g);u=c;return}function IOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d;g=f[c>>2]|0;if((g&4095|0)==4){if((a|0)==(c|0)){h=a;u=d;return h|0}i=c+36|0;j=f[i>>2]|0;if(j|0){k=j+12|0;f[k>>2]=(f[k>>2]|0)+1}k=a+36|0;j=f[k>>2]|0;if(j|0?(l=j+12|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)V$(a);f[k>>2]=0;j=a+16|0;l=a+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[l>>2]|0)>0){m=f[a+40>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0;o=f[l>>2]|0}while((n|0)<(o|0));f[a>>2]=f[c>>2];if((o|0)<3)p=13;else p=15}else{f[a>>2]=f[c>>2];p=13}if((p|0)==13){o=f[c+4>>2]|0;if((o|0)<3){f[l>>2]=o;f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];o=f[c+44>>2]|0;l=f[a+44>>2]|0;f[l>>2]=f[o>>2];f[l+4>>2]=f[o+4>>2]}else p=15}if((p|0)==15)U$(a,c);f[j>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[k>>2]=f[i>>2];h=a;u=d;return h|0}if((g&7|0)==4){h0(e,c,1,f[c+4>>2]|0,0);i=JOb(a,e)|0;k=e+36|0;j=f[k>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)V$(e);f[k>>2]=0;k=e+16|0;j=e+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[e+40>>2]|0;p=0;do{f[k+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}j=f[e+44>>2]|0;if((j|0)!=(e+48|0))wL(j);h=i;u=d;return h|0}else{if(g&4088|0?f[c+16>>2]|0:0){g=f[c+4>>2]|0;if((g|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{i=f[c+40>>2]|0;j=0;p=1;while(1){k=Y(f[i+(j<<2)>>2]|0,p)|0;j=j+1|0;if((j|0)==(g|0)){q=k;break}else p=k}}if(!((g|0)==0|(q|0)==0)){q=$Xc(64)|0;f[e>>2]=q;f[e+8>>2]=-2147483584;f[e+4>>2]=52;g=q;p=463686;j=g+52|0;do{b[g>>0]=b[p>>0]|0;g=g+1|0;p=p+1|0}while((g|0)<(j|0));b[q+52>>0]=0;vM(-215,e,528381,470347,1711)}}q=e+8|0;f[q>>2]=0;f[q+4>>2]=0;f[e>>2]=-2113863676;f[e+4>>2]=a;dY(c,e,4,1.0,0.0);h=a;u=d;return h|0}return 0}function JOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;e=f[b>>2]|0;if((e&4095|0)==4){nOa(a,b)|0;u=c;return a|0}if((e&7|0)!=4){e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=-2113863676;f[d+4>>2]=a;dY(b,d,4,1.0,0.0);u=c;return a|0}h0(d,b,1,f[b+4>>2]|0,0);if((a|0)==(d|0)){b=d+36|0;e=f[b>>2]|0;if((e|0)!=0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0){V$(d);h=b}else h=b}else{b=a+36|0;e=f[b>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(a);f[b>>2]=0;e=a+16|0;g=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){i=f[a+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[a>>2]=f[d>>2];j=d+4|0;i=f[j>>2]|0;f[g>>2]=i;g=d+8|0;k=a+8|0;f[k>>2]=f[g>>2];f[a+12>>2]=f[d+12>>2];f[e>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];f[a+24>>2]=f[d+24>>2];f[a+28>>2]=f[d+28>>2];f[a+32>>2]=f[d+32>>2];e=d+36|0;f[b>>2]=f[e>>2];b=a+44|0;l=f[b>>2]|0;m=a+48|0;if((l|0)==(m|0)){n=i;o=l}else{wL(l);f[b>>2]=m;f[a+40>>2]=k;n=f[j>>2]|0;o=m}m=d+44|0;if((n|0)<3){n=f[m>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2]}else{f[b>>2]=f[m>>2];b=d+40|0;f[a+40>>2]=f[b>>2];f[m>>2]=d+48;f[b>>2]=g}f[d>>2]=1124007936;g=j;j=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(j|0));h=e}f[h>>2]=0;h=d+16|0;e=d+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[e>>2]|0)>0){h=f[d+40>>2]|0;g=0;do{f[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[e>>2]|0))}e=f[d+44>>2]|0;if((e|0)!=(d+48|0))wL(e);u=c;return a|0}function KOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0.0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0;d=u;u=u+688|0;e=d;g=d+632|0;h=d+576|0;i=d+520|0;j=d+464|0;k=d+448|0;l=d+424|0;m=d+368|0;o=d+360|0;p=d+304|0;q=d+248|0;r=d+192|0;s=d+136|0;t=d+80|0;v=d+72|0;w=d+64|0;x=d+56|0;y=d+40|0;z=d+24|0;A=d+8|0;B=a+68|0;C=a+72|0;if((f[C>>2]|0)==(f[B>>2]|0)){D=$Xc(32)|0;f[g>>2]=D;f[g+8>>2]=-2147483616;f[g+4>>2]=20;E=D;F=463739;G=E+20|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[D+20>>0]=0;vM(-215,g,463760,463600,436)}f[m>>2]=1124007936;D=m+4|0;H=m+8|0;I=m+40|0;E=D;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[I>>2]=H;H=m+48|0;J=m+44|0;f[J>>2]=H;f[H>>2]=0;f[m+52>>2]=0;K=i+8|0;f[K>>2]=0;f[K+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;do if((eS(c)|0)==65536){K=f[c+4>>2]|0;f[g>>2]=f[K>>2];L=g+4|0;N=K+4|0;f[L>>2]=f[N>>2];O=g+8|0;f[O>>2]=f[K+8>>2];f[g+12>>2]=f[K+12>>2];f[g+16>>2]=f[K+16>>2];f[g+20>>2]=f[K+20>>2];f[g+24>>2]=f[K+24>>2];f[g+28>>2]=f[K+28>>2];f[g+32>>2]=f[K+32>>2];P=f[K+36>>2]|0;f[g+36>>2]=P;f[g+40>>2]=O;O=g+48|0;Q=g+44|0;f[Q>>2]=O;f[O>>2]=0;f[g+52>>2]=0;if(P|0){O=P+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[N>>2]|0)<3){N=f[K+44>>2]|0;O=f[Q>>2]|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2];R=g;break}else{f[L>>2]=0;U$(g,K);R=g;break}}else{bS(g,c,-1);R=g}while(0);K=f[R>>2]|0;if(!(K&4088))S=K;else{K=h+8|0;f[K>>2]=0;f[K+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;Spa(c,h,6,0);S=f[R>>2]|0}switch(S&7){case 5:{cT(i,g);break}case 0:{dY(g,i,5,.00392156862745098,0.0);break}case 2:{dY(g,i,5,1.5259021896696422e-05,0.0);break}default:{}}S=g+36|0;R=f[S>>2]|0;if(R|0?(c=R+12|0,R=f[c>>2]|0,f[c>>2]=R+-1,(R|0)==1):0)V$(g);f[S>>2]=0;S=g+16|0;R=g+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[R>>2]|0)>0){S=f[g+40>>2]|0;c=0;do{f[S+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[R>>2]|0))}R=f[g+44>>2]|0;if((R|0)!=(g+48|0))wL(R);T=+n[a+16>>2];U=((T+-.800000011920929)/.30000001192092896+1.0)*2.0;R=~~U;c=(+(R|0)<U&1)+R|1;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=m;R=(f[B>>2]|0)+168|0;S=h+8|0;f[S>>2]=0;f[S+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=R;f[o>>2]=c;f[o+4>>2]=c;U=T;Jqa(g,h,o,U,U,1);o=f[B>>2]|0;c=g+8|0;f[c>>2]=0;f[c+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o+112;jR(o+168|0,g);if(((f[C>>2]|0)-(f[B>>2]|0)|0)!=316){f[p>>2]=1124007936;o=p+4|0;c=p+8|0;R=p+40|0;E=o;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[R>>2]=c;c=p+48|0;S=p+44|0;f[S>>2]=c;f[c>>2]=0;f[p+52>>2]=0;f[q>>2]=1124007936;K=q+4|0;L=q+8|0;N=q+40|0;E=K;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[N>>2]=L;L=q+48|0;O=q+44|0;f[O>>2]=L;f[L>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;Q=r+4|0;P=r+8|0;V=r+40|0;E=Q;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[V>>2]=P;P=r+48|0;W=r+44|0;f[W>>2]=P;f[P>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;X=s+4|0;Z=s+8|0;_=s+40|0;E=X;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[_>>2]=Z;Z=s+48|0;$=s+44|0;f[$>>2]=Z;f[Z>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;aa=t+4|0;ba=t+8|0;ca=t+40|0;E=aa;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[ca>>2]=ba;ba=t+48|0;da=t+44|0;f[da>>2]=ba;f[ba>>2]=0;f[t+52>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=m;ea=h+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=r;f[v>>2]=5;f[v+4>>2]=5;Jqa(g,h,v,1.0,1.0,1);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=r;v=h+8|0;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=p;toa(g,h,5,1,0,1.0,0.0,4);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=r;v=h+8|0;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;toa(g,h,5,0,1,1.0,0.0,4);v=r+36|0;ea=f[v>>2]|0;if(ea|0?(fa=ea+12|0,ea=f[fa>>2]|0,f[fa>>2]=ea+-1,(ea|0)==1):0)V$(r);f[v>>2]=0;ea=r+16|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[Q>>2]|0)>0){fa=f[V>>2]|0;ga=0;do{f[fa+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[Q>>2]|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;ga=k+4|0;f[ga>>2]=p;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;fa=l+4|0;f[fa>>2]=q;U=+n[a+60>>2];ha=f[a+64>>2]|0;if((ha|0)<=2){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=9;E=g;F=463789;G=E+9|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[g+9>>0]=0;vM(-215,g,463799,463600,307)}if(sS(k)|0){ia=$Xc(16)|0;f[g>>2]=ia;f[g+8>>2]=-2147483632;f[g+4>>2]=12;E=ia;F=463817;G=E+12|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[ia+12>>0]=0;vM(-215,g,463799,463600,308)}do if((eS(k)|0)==65536){ia=f[ga>>2]|0;f[h>>2]=f[ia>>2];F=h+4|0;ja=ia+4|0;f[F>>2]=f[ja>>2];ka=h+8|0;f[ka>>2]=f[ia+8>>2];f[h+12>>2]=f[ia+12>>2];f[h+16>>2]=f[ia+16>>2];f[h+20>>2]=f[ia+20>>2];f[h+24>>2]=f[ia+24>>2];f[h+28>>2]=f[ia+28>>2];f[h+32>>2]=f[ia+32>>2];la=f[ia+36>>2]|0;f[h+36>>2]=la;f[h+40>>2]=ka;ka=h+48|0;ma=h+44|0;f[ma>>2]=ka;f[ka>>2]=0;f[h+52>>2]=0;if(la|0){ka=la+12|0;f[ka>>2]=(f[ka>>2]|0)+1}if((f[ja>>2]|0)<3){ja=f[ia+44>>2]|0;ka=f[ma>>2]|0;f[ka>>2]=f[ja>>2];f[ka+4>>2]=f[ja+4>>2];break}else{f[F>>2]=0;U$(h,ia);break}}else bS(h,k,-1);while(0);do if((eS(l)|0)==65536){ga=f[fa>>2]|0;f[i>>2]=f[ga>>2];ia=i+4|0;F=ga+4|0;f[ia>>2]=f[F>>2];ja=i+8|0;f[ja>>2]=f[ga+8>>2];f[i+12>>2]=f[ga+12>>2];f[i+16>>2]=f[ga+16>>2];f[i+20>>2]=f[ga+20>>2];f[i+24>>2]=f[ga+24>>2];f[i+28>>2]=f[ga+28>>2];f[i+32>>2]=f[ga+32>>2];ka=f[ga+36>>2]|0;f[i+36>>2]=ka;f[i+40>>2]=ja;ja=i+48|0;ma=i+44|0;f[ma>>2]=ja;f[ja>>2]=0;f[i+52>>2]=0;if(ka|0){ja=ka+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[F>>2]|0)<3){F=f[ga+44>>2]|0;ja=f[ma>>2]|0;f[ja>>2]=f[F>>2];f[ja+4>>2]=f[F+4>>2];break}else{f[ia>>2]=0;U$(i,ga);break}}else bS(i,l,-1);while(0);fa=h+8|0;ga=(f[fa>>2]|0)+-2|0;ia=h+12|0;F=(f[ia>>2]|0)+-2|0;f[j>>2]=1124007936;ja=j+4|0;ma=j+8|0;ka=j+40|0;E=ja;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[ka>>2]=ma;E=j+48|0;G=j+44|0;f[G>>2]=E;f[E>>2]=0;f[j+52>>2]=0;f[g>>2]=ga;f[g+4>>2]=F;S$(j,2,g,5);F=Y(f[ma>>2]|0,f[j+12>>2]|0)|0;ma=j+16|0;ga=f[ma>>2]|0;la=(f[fa>>2]|0)+-1|0;if((la|0)>1?(fa=f[h+16>>2]|0,na=f[f[h+44>>2]>>2]|0,oa=f[i+16>>2]|0,pa=f[f[i+44>>2]>>2]|0,qa=f[ia>>2]|0,ia=qa+-2|0,(qa|0)>2):0){qa=ga;ra=1;T=0.0;while(1){sa=fa+(Y(ra,na)|0)+4|0;ta=oa+(Y(ra,pa)|0)+4|0;ua=0;va=qa;wa=T;while(1){xa=+n[sa+(ua<<2)>>2];ya=+n[ta+(ua<<2)>>2];za=+M(+(xa*xa+ya*ya));n[va>>2]=za;wa=wa<za?za:wa;ua=ua+1|0;if((ua|0)==(ia|0))break;else va=va+4|0}ra=ra+1|0;if((ra|0)==(la|0))break;else{qa=qa+(ia<<2)|0;T=wa}}if(!(wa==0.0)){ia=g+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;dY(j,g,-1,+(ha+-1|0)/wa,0.0);f[g>>2]=0;ia=g+4|0;f[ia>>2]=0;f[g+8>>2]=0;do if(ha)if(ha>>>0>1073741823)kWc(g);else{qa=ha<<2;la=$Xc(qa)|0;f[g>>2]=la;ra=la+(ha<<2)|0;f[g+8>>2]=ra;g1c(la|0,0,qa|0)|0;f[ia>>2]=ra;Aa=la;Ba=ra;Ca=la;break}else{Aa=0;Ba=0;Ca=0}while(0);if((F|0)>0){la=0;do{ra=Aa+(~~+n[ga+(la<<2)>>2]<<2)|0;f[ra>>2]=(f[ra>>2]|0)+1;la=la+1|0}while((la|0)!=(F|0))}la=~~(U*+(F-(f[Aa>>2]|0)|0));a:do if((ha|0)>1){F=1;ga=0;while(1){if((ga|0)>=(la|0))break;ga=(f[Aa+(F<<2)>>2]|0)+ga|0;ra=F+1|0;if((ra|0)>=(ha|0)){Da=.029999999329447746;break a}else F=ra}Da=wa*+(F|0)/+(ha|0)}else Da=.029999999329447746;while(0);if((Ba|0)!=(Aa|0))f[ia>>2]=Ba+(~((Ba+-4-Aa|0)>>>2)<<2);cYc(Ca);Ea=Da}else Ea=.029999999329447746}else Ea=.029999999329447746;Ca=j+36|0;Aa=f[Ca>>2]|0;if(Aa|0?(Ba=Aa+12|0,Aa=f[Ba>>2]|0,f[Ba>>2]=Aa+-1,(Aa|0)==1):0)V$(j);f[Ca>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ja>>2]|0)>0){ma=f[ka>>2]|0;ka=0;do{f[ma+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[ja>>2]|0))}ja=f[G>>2]|0;if((ja|0)!=(E|0))wL(ja);ja=i+36|0;E=f[ja>>2]|0;do if(E|0){G=E+12|0;ka=f[G>>2]|0;f[G>>2]=ka+-1;if((ka|0)!=1)break;V$(i)}while(0);f[ja>>2]=0;ja=i+16|0;E=i+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[E>>2]|0)>0){ja=f[i+40>>2]|0;ka=0;do{f[ja+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[E>>2]|0))}E=f[i+44>>2]|0;if((E|0)!=(i+48|0))wL(E);E=h+36|0;ka=f[E>>2]|0;do if(ka|0){ja=ka+12|0;G=f[ja>>2]|0;f[ja>>2]=G+-1;if((G|0)!=1)break;V$(h)}while(0);f[E>>2]=0;E=h+16|0;ka=h+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[ka>>2]|0)>0){E=f[h+40>>2]|0;G=0;do{f[E+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[ka>>2]|0))}ka=f[h+44>>2]|0;if((ka|0)!=(h+48|0))wL(ka);ka=f[C>>2]|0;G=f[B>>2]|0;b:do if(((ka-G|0)/316|0)>>>0>1){E=g+8|0;ja=g+12|0;ma=g+4|0;Ca=h+8|0;Aa=h+4|0;Ba=w+4|0;ia=g+8|0;ha=g+12|0;la=g+4|0;ga=h+8|0;ra=h+4|0;qa=x+4|0;pa=g+8|0;oa=g+12|0;na=g+4|0;fa=h+8|0;va=h+4|0;ua=g+8|0;ta=g+12|0;sa=g+4|0;Fa=h+8|0;Ga=h+4|0;Ha=i+8|0;Ia=i+12|0;Ja=i+4|0;Ka=j+8|0;La=j+12|0;Ma=j+4|0;Na=k+8|0;Oa=k+4|0;Pa=a+28|0;Qa=a+88|0;Ra=y+8|0;Sa=y+12|0;Ta=y+4|0;Ua=z+8|0;Va=z+12|0;Wa=z+4|0;Xa=A+8|0;Ya=A+4|0;Za=h+4|0;_a=h+8|0;$a=h+12|0;ab=h+16|0;bb=h+20|0;cb=h+24|0;db=h+28|0;eb=h+32|0;fb=h+36|0;gb=h+40|0;hb=h+48|0;ib=h+44|0;jb=h+52|0;kb=i+4|0;lb=i+8|0;mb=i+12|0;nb=i+16|0;ob=i+20|0;pb=i+24|0;qb=i+28|0;rb=i+32|0;sb=i+36|0;tb=i+40|0;ub=i+48|0;vb=i+44|0;wb=i+52|0;xb=j+4|0;yb=j+8|0;zb=j+12|0;Ab=j+16|0;Bb=j+20|0;Cb=j+24|0;Db=j+28|0;Eb=j+32|0;Fb=j+36|0;Gb=j+40|0;Hb=j+48|0;Ib=j+44|0;Jb=j+52|0;Kb=k+4|0;Lb=l+4|0;Mb=l+8|0;Nb=l+12|0;Ob=l+16|0;Pb=g+8|0;Qb=g+12|0;Rb=g+4|0;Sb=h+8|0;Tb=h+12|0;Ub=h+4|0;Vb=i+8|0;Wb=i+4|0;Xb=g+8|0;Yb=g+4|0;Zb=1;Da=Ea;_b=f[B>>2]|0;c:while(1){$b=Zb+-1|0;if((f[_b+(Zb*316|0)+296>>2]|0)>(f[_b+($b*316|0)+296>>2]|0)){f[E>>2]=0;f[ja>>2]=0;f[g>>2]=16842752;f[ma>>2]=_b+($b*316|0)+112;ac=_b+(Zb*316|0)+112|0;bc=Ca;f[bc>>2]=0;f[bc+4>>2]=0;f[h>>2]=33619968;f[Aa>>2]=ac;f[w>>2]=f[_b+(Zb*316|0)+280>>2];f[Ba>>2]=f[_b+(Zb*316|0)+284>>2];Zna(g,h,w,0.0,0.0,3);cc=Da*.75;dc=ac}else{ac=_b+(Zb*316|0)+112|0;bc=Xb;f[bc>>2]=0;f[bc+4>>2]=0;f[g>>2]=33619968;f[Yb>>2]=ac;jR(_b+($b*316|0)+112|0,g);cc=Da;dc=ac}f[ia>>2]=0;f[ha>>2]=0;f[g>>2]=16842752;f[la>>2]=dc;ac=_b+(Zb*316|0)+168|0;bc=ga;f[bc>>2]=0;f[bc+4>>2]=0;f[h>>2]=33619968;f[ra>>2]=ac;f[x>>2]=5;f[qa>>2]=5;Jqa(g,h,x,1.0,1.0,1);f[pa>>2]=0;f[oa>>2]=0;f[g>>2]=16842752;f[na>>2]=ac;bc=fa;f[bc>>2]=0;f[bc+4>>2]=0;f[h>>2]=33619968;f[va>>2]=p;toa(g,h,5,1,0,1.0,0.0,4);f[ua>>2]=0;f[ta>>2]=0;f[g>>2]=16842752;f[sa>>2]=ac;ac=Fa;f[ac>>2]=0;f[ac+4>>2]=0;f[h>>2]=33619968;f[Ga>>2]=q;toa(g,h,5,0,1,1.0,0.0,4);f[Ha>>2]=0;f[Ia>>2]=0;f[i>>2]=16842752;f[Ja>>2]=p;f[Ka>>2]=0;f[La>>2]=0;f[j>>2]=16842752;f[Ma>>2]=q;ac=Na;f[ac>>2]=0;f[ac+4>>2]=0;f[k>>2]=33619968;f[Oa>>2]=s;ec=f[Pa>>2]|0;cS(g,i,-1);wS(k,g,dS(i,-1)|0,-1,0,0);switch(ec|0){case 0:{rPb(i,j,k,cc);break}case 1:{sPb(i,j,k,cc);break}case 2:{tPb(i,j,k,cc);break}case 3:{uPb(i,j,k,cc);break}default:break c}ac=f[Qa>>2]|0;bc=ac+($b*12|0)|0;fc=ac+($b*12|0)+4|0;$b=f[bc>>2]|0;if((f[fc>>2]|0)!=($b|0)){ac=0;gc=$b;do{wa=+n[gc+(ac<<2)>>2]*.5;f[Ra>>2]=0;f[Sa>>2]=0;f[y>>2]=16842752;f[Ta>>2]=dc;f[Ua>>2]=0;f[Va>>2]=0;f[z>>2]=16842752;f[Wa>>2]=s;$b=Xa;f[$b>>2]=0;f[$b+4>>2]=0;f[A>>2]=33619968;f[Ya>>2]=t;cS(g,y,-1);wS(A,g,dS(y,-1)|0,-1,0,0);do if((eS(y)|0)==65536){$b=f[Ta>>2]|0;f[h>>2]=f[$b>>2];hc=$b+4|0;f[Za>>2]=f[hc>>2];f[_a>>2]=f[$b+8>>2];f[$a>>2]=f[$b+12>>2];f[ab>>2]=f[$b+16>>2];f[bb>>2]=f[$b+20>>2];f[cb>>2]=f[$b+24>>2];f[db>>2]=f[$b+28>>2];f[eb>>2]=f[$b+32>>2];ic=f[$b+36>>2]|0;f[fb>>2]=ic;f[gb>>2]=_a;f[ib>>2]=hb;f[hb>>2]=0;f[jb>>2]=0;if(ic|0){jc=ic+12|0;f[jc>>2]=(f[jc>>2]|0)+1}if((f[hc>>2]|0)<3){hc=f[$b+44>>2]|0;jc=f[ib>>2]|0;f[jc>>2]=f[hc>>2];f[jc+4>>2]=f[hc+4>>2];break}else{f[Za>>2]=0;U$(h,$b);break}}else bS(h,y,-1);while(0);do if((eS(z)|0)==65536){$b=f[Wa>>2]|0;f[i>>2]=f[$b>>2];hc=$b+4|0;f[kb>>2]=f[hc>>2];f[lb>>2]=f[$b+8>>2];f[mb>>2]=f[$b+12>>2];f[nb>>2]=f[$b+16>>2];f[ob>>2]=f[$b+20>>2];f[pb>>2]=f[$b+24>>2];f[qb>>2]=f[$b+28>>2];f[rb>>2]=f[$b+32>>2];jc=f[$b+36>>2]|0;f[sb>>2]=jc;f[tb>>2]=lb;f[vb>>2]=ub;f[ub>>2]=0;f[wb>>2]=0;if(jc|0){ic=jc+12|0;f[ic>>2]=(f[ic>>2]|0)+1}if((f[hc>>2]|0)<3){hc=f[$b+44>>2]|0;ic=f[vb>>2]|0;f[ic>>2]=f[hc>>2];f[ic+4>>2]=f[hc+4>>2];break}else{f[kb>>2]=0;U$(i,$b);break}}else bS(i,z,-1);while(0);do if((eS(A)|0)==65536){$b=f[Ya>>2]|0;f[j>>2]=f[$b>>2];hc=$b+4|0;f[xb>>2]=f[hc>>2];f[yb>>2]=f[$b+8>>2];f[zb>>2]=f[$b+12>>2];f[Ab>>2]=f[$b+16>>2];f[Bb>>2]=f[$b+20>>2];f[Cb>>2]=f[$b+24>>2];f[Db>>2]=f[$b+28>>2];f[Eb>>2]=f[$b+32>>2];ic=f[$b+36>>2]|0;f[Fb>>2]=ic;f[Gb>>2]=yb;f[Ib>>2]=Hb;f[Hb>>2]=0;f[Jb>>2]=0;if(ic|0){jc=ic+12|0;f[jc>>2]=(f[jc>>2]|0)+1}if((f[hc>>2]|0)<3){hc=f[$b+44>>2]|0;jc=f[Ib>>2]|0;f[jc>>2]=f[hc>>2];f[jc+4>>2]=f[hc+4>>2];break}else{f[xb>>2]=0;U$(j,$b);break}}else bS(j,A,-1);while(0);$b=f[_a>>2]|0;f[k>>2]=0;f[Kb>>2]=$b;f[l>>2]=116292;f[Lb>>2]=h;f[Mb>>2]=i;f[Nb>>2]=j;n[Ob>>2]=wa;h3(k,l,-1.0);$b=f[Fb>>2]|0;do if($b|0){hc=$b+12|0;jc=f[hc>>2]|0;f[hc>>2]=jc+-1;if((jc|0)!=1)break;V$(j)}while(0);f[Fb>>2]=0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[xb>>2]|0)>0){$b=f[Gb>>2]|0;jc=0;do{f[$b+(jc<<2)>>2]=0;jc=jc+1|0}while((jc|0)<(f[xb>>2]|0))}jc=f[Ib>>2]|0;if((jc|0)!=(Hb|0))wL(jc);jc=f[sb>>2]|0;do if(jc|0){$b=jc+12|0;hc=f[$b>>2]|0;f[$b>>2]=hc+-1;if((hc|0)!=1)break;V$(i)}while(0);f[sb>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[kb>>2]|0)>0){jc=f[tb>>2]|0;hc=0;do{f[jc+(hc<<2)>>2]=0;hc=hc+1|0}while((hc|0)<(f[kb>>2]|0))}hc=f[vb>>2]|0;if((hc|0)!=(ub|0))wL(hc);hc=f[fb>>2]|0;do if(hc|0){jc=hc+12|0;$b=f[jc>>2]|0;f[jc>>2]=$b+-1;if(($b|0)!=1)break;V$(h)}while(0);f[fb>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[Za>>2]|0)>0){hc=f[gb>>2]|0;$b=0;do{f[hc+($b<<2)>>2]=0;$b=$b+1|0}while(($b|0)<(f[Za>>2]|0))}$b=f[ib>>2]|0;if(($b|0)!=(hb|0))wL($b);f[Pb>>2]=0;f[Qb>>2]=0;f[g>>2]=16842752;f[Rb>>2]=dc;f[Sb>>2]=0;f[Tb>>2]=0;f[h>>2]=16842752;f[Ub>>2]=t;$b=Vb;f[$b>>2]=0;f[$b+4>>2]=0;f[i>>2]=33619968;f[Wb>>2]=dc;E1(g,h,i,fT()|0,-1);ac=ac+1|0;gc=f[bc>>2]|0}while(ac>>>0<(f[fc>>2]|0)-gc>>2>>>0)}Zb=Zb+1|0;gc=f[C>>2]|0;fc=f[B>>2]|0;if(Zb>>>0>=((gc-fc|0)/316|0)>>>0){kc=fc;lc=gc;break b}else{Da=cc;_b=fc}}f[e>>2]=ec;DM(h,463830,e);vM(-2,h,463863,463600,401)}else{kc=G;lc=ka}while(0);f[g>>2]=0;f[g+4>>2]=(lc-kc|0)/316|0;f[h>>2]=116272;f[h+4>>2]=B;h3(g,h,-1.0);kc=t+36|0;lc=f[kc>>2]|0;do if(lc|0){ka=lc+12|0;G=f[ka>>2]|0;f[ka>>2]=G+-1;if((G|0)!=1)break;V$(t)}while(0);f[kc>>2]=0;kc=t+16|0;f[kc>>2]=0;f[kc+4>>2]=0;f[kc+8>>2]=0;f[kc+12>>2]=0;if((f[aa>>2]|0)>0){kc=f[ca>>2]|0;ca=0;do{f[kc+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[aa>>2]|0))}aa=f[da>>2]|0;if((aa|0)!=(ba|0))wL(aa);aa=s+36|0;ba=f[aa>>2]|0;do if(ba|0){da=ba+12|0;ca=f[da>>2]|0;f[da>>2]=ca+-1;if((ca|0)!=1)break;V$(s)}while(0);f[aa>>2]=0;aa=s+16|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[X>>2]|0)>0){aa=f[_>>2]|0;_=0;do{f[aa+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[X>>2]|0))}X=f[$>>2]|0;if((X|0)!=(Z|0))wL(X);X=f[v>>2]|0;do if(X|0){Z=X+12|0;$=f[Z>>2]|0;f[Z>>2]=$+-1;if(($|0)!=1)break;V$(r)}while(0);f[v>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[Q>>2]|0)>0){ea=f[V>>2]|0;V=0;do{f[ea+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[Q>>2]|0))}Q=f[W>>2]|0;if((Q|0)!=(P|0))wL(Q);Q=q+36|0;P=f[Q>>2]|0;do if(P|0){W=P+12|0;V=f[W>>2]|0;f[W>>2]=V+-1;if((V|0)!=1)break;V$(q)}while(0);f[Q>>2]=0;Q=q+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[K>>2]|0)>0){Q=f[N>>2]|0;N=0;do{f[Q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[O>>2]|0;if((K|0)!=(L|0))wL(K);K=p+36|0;L=f[K>>2]|0;do if(L|0){O=L+12|0;N=f[O>>2]|0;f[O>>2]=N+-1;if((N|0)!=1)break;V$(p)}while(0);f[K>>2]=0;K=p+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[o>>2]|0)>0){K=f[R>>2]|0;R=0;do{f[K+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[o>>2]|0))}o=f[S>>2]|0;if((o|0)!=(c|0))wL(o)}else{f[g>>2]=0;f[g+4>>2]=1;f[h>>2]=116272;f[h+4>>2]=B;h3(g,h,-1.0)}h=m+36|0;g=f[h>>2]|0;if(g|0?(B=g+12|0,g=f[B>>2]|0,f[B>>2]=g+-1,(g|0)==1):0)V$(m);f[h>>2]=0;h=m+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[D>>2]|0)>0){h=f[I>>2]|0;I=0;do{f[h+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[D>>2]|0))}D=f[J>>2]|0;if((D|0)==(H|0)){u=d;return}wL(D);u=d;return}function LOb(a){a=a|0;cYc(a);return}function MOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;g=f[a+8>>2]|0;h=f[a+12>>2]|0;i=+n[a+16>>2];a=f[b>>2]|0;j=f[b+4>>2]|0;b=f[e+40>>2]|0;k=f[b+4>>2]|0;l=f[b>>2]|0;b=f[e>>2]&4095;if(!(((((f[h+4>>2]|0)<3?(f[h+8>>2]|0)==(l|0):0)?(f[h+12>>2]|0)==(k|0):0)?(f[h>>2]&4095|0)==(b|0):0)?(f[h+16>>2]|0)!=0:0)){f[d>>2]=l;f[d+4>>2]=k;S$(h,2,d,b)}b=f[e+12>>2]|0;d=b+-2|0;if(!a){k=f[e+16>>2]|0;l=k+4|0;m=f[g+16>>2]|0;o=m+4|0;p=k+(f[f[e+44>>2]>>2]|0)+4|0;k=m+(f[f[g+44>>2]>>2]|0)+4|0;m=f[h+16>>2]|0;n[m>>2]=0.0;q=m+4|0;if((b|0)>2){m=0;do{r=+n[o+(m<<2)>>2];s=m;m=m+1|0;t=+n[l+(s<<2)>>2];v=s+-1|0;n[q+(s<<2)>>2]=i*((r+ +n[o+(m<<2)>>2])*(+n[l+(m<<2)>>2]-t)+(r+ +n[o+(v<<2)>>2])*(+n[l+(v<<2)>>2]-t)+(r+ +n[k+(s<<2)>>2])*(+n[p+(s<<2)>>2]-t))}while((m|0)!=(d|0))}n[q+(d<<2)>>2]=0.0;w=1}else w=a;a=f[e+8>>2]|0;q=a+-1|0;m=(q|0)>(j|0)?j:q;if((w|0)<(m|0)){q=f[e+16>>2]|0;p=f[f[e+44>>2]>>2]|0;k=f[g+16>>2]|0;l=f[f[g+44>>2]>>2]|0;o=f[h+16>>2]|0;s=f[f[h+44>>2]>>2]|0;v=(b|0)>2;x=b+-3|0;y=w;do{z=y+-1|0;A=q+(Y(z,p)|0)|0;B=k+(Y(z,l)|0)|0;z=q+(Y(y,p)|0)|0;C=k+(Y(y,l)|0)|0;D=y;y=y+1|0;E=q+(Y(y,p)|0)|0;F=k+(Y(y,l)|0)|0;G=o+(Y(D,s)|0)|0;t=+n[C>>2];D=C+4|0;C=z+4|0;r=+n[z>>2];n[G>>2]=i*((t+ +n[D>>2])*(+n[C>>2]-r)+(t+ +n[F>>2])*(+n[E>>2]-r)+(t+ +n[B>>2])*(+n[A>>2]-r));z=A+4|0;A=E+4|0;E=B+4|0;B=F+4|0;F=G+4|0;if(v){G=0;do{r=+n[D+(G<<2)>>2];H=G;G=G+1|0;t=+n[C+(H<<2)>>2];I=H+-1|0;n[F+(H<<2)>>2]=i*((r+ +n[D+(G<<2)>>2])*(+n[C+(G<<2)>>2]-t)+(r+ +n[D+(I<<2)>>2])*(+n[C+(I<<2)>>2]-t)+(r+ +n[B+(H<<2)>>2])*(+n[A+(H<<2)>>2]-t)+(r+ +n[E+(H<<2)>>2])*(+n[z+(H<<2)>>2]-t))}while((G|0)!=(d|0))}t=+n[D+(d<<2)>>2];r=+n[C+(d<<2)>>2];n[F+(d<<2)>>2]=i*((t+ +n[D+(x<<2)>>2])*(+n[C+(x<<2)>>2]-r)+(t+ +n[B+(d<<2)>>2])*(+n[A+(d<<2)>>2]-r)+(t+ +n[E+(d<<2)>>2])*(+n[z+(d<<2)>>2]-r))}while((y|0)<(m|0));J=m}else J=w;if((a|0)!=(j|0)){u=c;return}j=J+-1|0;a=f[e+16>>2]|0;w=f[f[e+44>>2]>>2]|0;e=a+(Y(w,j)|0)+4|0;m=f[g+16>>2]|0;y=f[f[g+44>>2]>>2]|0;g=m+(Y(y,j)|0)+4|0;j=a+(Y(w,J)|0)+4|0;w=m+(Y(y,J)|0)+4|0;y=(f[h+16>>2]|0)+(Y(f[f[h+44>>2]>>2]|0,J)|0)|0;n[y>>2]=0.0;J=y+4|0;if((b|0)>2){b=0;do{r=+n[w+(b<<2)>>2];y=b;b=b+1|0;t=+n[j+(y<<2)>>2];h=y+-1|0;n[J+(y<<2)>>2]=i*((r+ +n[w+(b<<2)>>2])*(+n[j+(b<<2)>>2]-t)+(r+ +n[w+(h<<2)>>2])*(+n[j+(h<<2)>>2]-t)+(r+ +n[g+(y<<2)>>2])*(+n[e+(y<<2)>>2]-t))}while((b|0)!=(d|0))}n[J+(d<<2)>>2]=0.0;u=c;return}function NOb(a){a=a|0;cYc(a);return}function OOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0.0,Zc=0.0,_c=0;c=u;u=u+736|0;d=c+720|0;e=c+664|0;g=c+608|0;h=c+552|0;i=c+496|0;j=c+440|0;k=c+384|0;l=c+328|0;m=c+272|0;o=c+216|0;p=c+160|0;q=c+104|0;r=c+96|0;s=c+88|0;t=c+80|0;v=c+72|0;w=c+64|0;x=c+48|0;y=c+32|0;z=c+16|0;A=c;f[j>>2]=1124007936;B=j+4|0;C=j+8|0;D=j+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=j+48|0;G=j+44|0;f[G>>2]=C;f[C>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;H=k+4|0;I=k+8|0;J=k+40|0;E=H;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[J>>2]=I;I=k+48|0;K=k+44|0;f[K>>2]=I;f[I>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;L=l+4|0;M=l+8|0;N=l+40|0;E=L;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[N>>2]=M;M=l+48|0;O=l+44|0;f[O>>2]=M;f[M>>2]=0;f[l+52>>2]=0;P=f[b>>2]|0;Q=b+4|0;if((P|0)<(f[Q>>2]|0)){b=a+4|0;a=m+4|0;R=m+8|0;S=m+40|0;T=m+48|0;U=m+44|0;V=m+52|0;W=o+4|0;X=o+8|0;Z=o+40|0;_=o+48|0;$=o+44|0;aa=o+52|0;ba=p+4|0;ca=p+8|0;da=p+40|0;ea=p+48|0;fa=p+44|0;ga=p+52|0;ha=q+4|0;ia=q+8|0;ja=q+40|0;ka=q+48|0;la=q+44|0;ma=q+52|0;na=d+8|0;oa=d+4|0;pa=e+8|0;qa=e+4|0;ra=d+8|0;sa=d+4|0;ta=e+8|0;ua=e+4|0;va=d+8|0;wa=d+12|0;xa=d+4|0;ya=e+8|0;za=e+4|0;Aa=g+8|0;Ba=g+12|0;Ca=g+4|0;Da=h+8|0;Ea=h+12|0;Fa=h+4|0;Ga=r+4|0;Ha=d+8|0;Ia=d+12|0;Ja=d+4|0;Ka=e+8|0;La=e+4|0;Ma=g+8|0;Na=g+12|0;Oa=g+4|0;Pa=h+8|0;Qa=h+12|0;Ra=h+4|0;Sa=s+4|0;Ta=d+8|0;Ua=d+12|0;Va=d+4|0;Wa=e+8|0;Xa=e+4|0;Ya=g+8|0;Za=g+12|0;_a=g+4|0;$a=h+8|0;ab=h+12|0;bb=h+4|0;cb=t+4|0;db=d+8|0;eb=d+12|0;fb=d+4|0;gb=e+8|0;hb=e+4|0;ib=g+8|0;jb=g+12|0;kb=g+4|0;lb=h+8|0;mb=h+12|0;nb=h+4|0;ob=v+4|0;pb=d+8|0;qb=d+12|0;rb=d+4|0;sb=e+8|0;tb=e+4|0;ub=g+8|0;vb=g+12|0;wb=g+4|0;xb=h+8|0;yb=h+12|0;zb=h+4|0;Ab=w+4|0;Bb=x+8|0;Cb=x+12|0;Db=x+4|0;Eb=y+8|0;Fb=y+12|0;Gb=y+4|0;Hb=z+8|0;Ib=z+12|0;Jb=z+4|0;Kb=A+8|0;Lb=A+4|0;Mb=e+4|0;Nb=e+8|0;Ob=e+12|0;Pb=e+16|0;Qb=e+20|0;Rb=e+24|0;Sb=e+28|0;Tb=e+32|0;Ub=e+36|0;Vb=e+40|0;Wb=e+48|0;Xb=e+44|0;Yb=e+52|0;Zb=g+4|0;_b=g+8|0;$b=g+12|0;ac=g+16|0;bc=g+20|0;cc=g+24|0;dc=g+28|0;ec=g+32|0;fc=g+36|0;gc=g+40|0;hc=g+48|0;ic=g+44|0;jc=g+52|0;kc=h+4|0;lc=h+8|0;mc=h+12|0;nc=h+16|0;oc=h+20|0;pc=h+24|0;qc=h+28|0;rc=h+32|0;sc=h+36|0;tc=h+40|0;uc=h+48|0;vc=h+44|0;wc=h+52|0;xc=i+4|0;yc=i+8|0;zc=i+12|0;Ac=i+16|0;Bc=i+20|0;Cc=i+24|0;Dc=i+28|0;Ec=i+32|0;Fc=i+36|0;Gc=i+40|0;Hc=i+48|0;Ic=i+44|0;Jc=i+52|0;Kc=q+36|0;Lc=q+16|0;Mc=p+36|0;Nc=p+16|0;Oc=o+36|0;Pc=o+16|0;Qc=m+36|0;Rc=m+16|0;Sc=P;do{P=f[f[b>>2]>>2]|0;f[m>>2]=1124007936;E=a;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[S>>2]=R;f[U>>2]=T;f[T>>2]=0;f[V>>2]=0;f[o>>2]=1124007936;E=W;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[Z>>2]=X;f[$>>2]=_;f[_>>2]=0;f[aa>>2]=0;f[p>>2]=1124007936;E=ba;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[da>>2]=ca;f[fa>>2]=ea;f[ea>>2]=0;f[ga>>2]=0;f[q>>2]=1124007936;E=ha;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[ja>>2]=ia;f[la>>2]=ka;f[ka>>2]=0;f[ma>>2]=0;Tc=na;f[Tc>>2]=0;f[Tc+4>>2]=0;f[d>>2]=33619968;f[oa>>2]=m;Tc=pa;f[Tc>>2]=0;f[Tc+4>>2]=0;f[e>>2]=33619968;f[qa>>2]=o;Tc=P+(Sc*316|0)+304|0;xPb(d,e,1,0,f[Tc>>2]|0);Uc=ra;f[Uc>>2]=0;f[Uc+4>>2]=0;f[d>>2]=33619968;f[sa>>2]=p;Uc=ta;f[Uc>>2]=0;f[Uc+4>>2]=0;f[e>>2]=33619968;f[ua>>2]=q;xPb(d,e,0,1,f[Tc>>2]|0);Uc=P+(Sc*316|0)+168|0;f[va>>2]=0;f[wa>>2]=0;f[d>>2]=16842752;f[xa>>2]=Uc;Vc=P+(Sc*316|0)|0;Wc=ya;f[Wc>>2]=0;f[Wc+4>>2]=0;f[e>>2]=33619968;f[za>>2]=Vc;f[Aa>>2]=0;f[Ba>>2]=0;f[g>>2]=16842752;f[Ca>>2]=m;f[Da>>2]=0;f[Ea>>2]=0;f[h>>2]=16842752;f[Fa>>2]=o;f[r>>2]=-1;f[Ga>>2]=-1;Aja(d,e,5,g,h,r,0.0,4);f[Ha>>2]=0;f[Ia>>2]=0;f[d>>2]=16842752;f[Ja>>2]=Vc;Wc=Ka;f[Wc>>2]=0;f[Wc+4>>2]=0;f[e>>2]=33619968;f[La>>2]=j;f[Ma>>2]=0;f[Na>>2]=0;f[g>>2]=16842752;f[Oa>>2]=m;f[Pa>>2]=0;f[Qa>>2]=0;f[h>>2]=16842752;f[Ra>>2]=o;f[s>>2]=-1;f[Sa>>2]=-1;Aja(d,e,5,g,h,s,0.0,4);f[Ta>>2]=0;f[Ua>>2]=0;f[d>>2]=16842752;f[Va>>2]=Vc;Vc=Wa;f[Vc>>2]=0;f[Vc+4>>2]=0;f[e>>2]=33619968;f[Xa>>2]=k;f[Ya>>2]=0;f[Za>>2]=0;f[g>>2]=16842752;f[_a>>2]=p;f[$a>>2]=0;f[ab>>2]=0;f[h>>2]=16842752;f[bb>>2]=q;f[t>>2]=-1;f[cb>>2]=-1;Aja(d,e,5,g,h,t,0.0,4);f[db>>2]=0;f[eb>>2]=0;f[d>>2]=16842752;f[fb>>2]=Uc;Vc=P+(Sc*316|0)+56|0;Wc=gb;f[Wc>>2]=0;f[Wc+4>>2]=0;f[e>>2]=33619968;f[hb>>2]=Vc;f[ib>>2]=0;f[jb>>2]=0;f[g>>2]=16842752;f[kb>>2]=p;f[lb>>2]=0;f[mb>>2]=0;f[h>>2]=16842752;f[nb>>2]=q;f[v>>2]=-1;f[ob>>2]=-1;Aja(d,e,5,g,h,v,0.0,4);f[pb>>2]=0;f[qb>>2]=0;f[d>>2]=16842752;f[rb>>2]=Vc;Vc=sb;f[Vc>>2]=0;f[Vc+4>>2]=0;f[e>>2]=33619968;f[tb>>2]=l;f[ub>>2]=0;f[vb>>2]=0;f[g>>2]=16842752;f[wb>>2]=p;f[xb>>2]=0;f[yb>>2]=0;f[h>>2]=16842752;f[zb>>2]=q;f[w>>2]=-1;f[Ab>>2]=-1;Aja(d,e,5,g,h,w,0.0,4);Vc=P+(Sc*316|0)+204|0;Wc=f[Vc>>2]|0;if(Wc|0?(Xc=Wc+12|0,Wc=f[Xc>>2]|0,f[Xc>>2]=Wc+-1,(Wc|0)==1):0)V$(Uc);f[Vc>>2]=0;Vc=P+(Sc*316|0)+184|0;Uc=P+(Sc*316|0)+172|0;f[Vc>>2]=0;f[Vc+4>>2]=0;f[Vc+8>>2]=0;f[Vc+12>>2]=0;if((f[Uc>>2]|0)>0){Vc=f[P+(Sc*316|0)+208>>2]|0;Wc=0;do{f[Vc+(Wc<<2)>>2]=0;Wc=Wc+1|0}while((Wc|0)<(f[Uc>>2]|0))}Uc=f[Tc>>2]|0;Wc=Y(Uc,Uc)|0;Yc=+(Y(Wc,Wc)|0);f[Bb>>2]=0;f[Cb>>2]=0;f[x>>2]=16842752;f[Db>>2]=j;f[Eb>>2]=0;f[Fb>>2]=0;f[y>>2]=16842752;f[Gb>>2]=k;f[Hb>>2]=0;f[Ib>>2]=0;f[z>>2]=16842752;f[Jb>>2]=l;Wc=Kb;f[Wc>>2]=0;f[Wc+4>>2]=0;f[A>>2]=33619968;f[Lb>>2]=P+(Sc*316|0)+224;cS(d,x,-1);wS(A,d,dS(x,-1)|0,-1,0,0);do if((eS(x)|0)==65536){Wc=f[Db>>2]|0;f[e>>2]=f[Wc>>2];Uc=Wc+4|0;f[Mb>>2]=f[Uc>>2];f[Nb>>2]=f[Wc+8>>2];f[Ob>>2]=f[Wc+12>>2];f[Pb>>2]=f[Wc+16>>2];f[Qb>>2]=f[Wc+20>>2];f[Rb>>2]=f[Wc+24>>2];f[Sb>>2]=f[Wc+28>>2];f[Tb>>2]=f[Wc+32>>2];Vc=f[Wc+36>>2]|0;f[Ub>>2]=Vc;f[Vb>>2]=Nb;f[Xb>>2]=Wb;f[Wb>>2]=0;f[Yb>>2]=0;if(Vc|0){Xc=Vc+12|0;f[Xc>>2]=(f[Xc>>2]|0)+1}if((f[Uc>>2]|0)<3){Uc=f[Wc+44>>2]|0;Xc=f[Xb>>2]|0;f[Xc>>2]=f[Uc>>2];f[Xc+4>>2]=f[Uc+4>>2];break}else{f[Mb>>2]=0;U$(e,Wc);break}}else bS(e,x,-1);while(0);do if((eS(y)|0)==65536){P=f[Gb>>2]|0;f[g>>2]=f[P>>2];Tc=P+4|0;f[Zb>>2]=f[Tc>>2];f[_b>>2]=f[P+8>>2];f[$b>>2]=f[P+12>>2];f[ac>>2]=f[P+16>>2];f[bc>>2]=f[P+20>>2];f[cc>>2]=f[P+24>>2];f[dc>>2]=f[P+28>>2];f[ec>>2]=f[P+32>>2];Wc=f[P+36>>2]|0;f[fc>>2]=Wc;f[gc>>2]=_b;f[ic>>2]=hc;f[hc>>2]=0;f[jc>>2]=0;if(Wc|0){Uc=Wc+12|0;f[Uc>>2]=(f[Uc>>2]|0)+1}if((f[Tc>>2]|0)<3){Tc=f[P+44>>2]|0;Uc=f[ic>>2]|0;f[Uc>>2]=f[Tc>>2];f[Uc+4>>2]=f[Tc+4>>2];break}else{f[Zb>>2]=0;U$(g,P);break}}else bS(g,y,-1);while(0);do if((eS(z)|0)==65536){P=f[Jb>>2]|0;f[h>>2]=f[P>>2];Tc=P+4|0;f[kc>>2]=f[Tc>>2];f[lc>>2]=f[P+8>>2];f[mc>>2]=f[P+12>>2];f[nc>>2]=f[P+16>>2];f[oc>>2]=f[P+20>>2];f[pc>>2]=f[P+24>>2];f[qc>>2]=f[P+28>>2];f[rc>>2]=f[P+32>>2];Uc=f[P+36>>2]|0;f[sc>>2]=Uc;f[tc>>2]=lc;f[vc>>2]=uc;f[uc>>2]=0;f[wc>>2]=0;if(Uc|0){Wc=Uc+12|0;f[Wc>>2]=(f[Wc>>2]|0)+1}if((f[Tc>>2]|0)<3){Tc=f[P+44>>2]|0;Wc=f[vc>>2]|0;f[Wc>>2]=f[Tc>>2];f[Wc+4>>2]=f[Tc+4>>2];break}else{f[kc>>2]=0;U$(h,P);break}}else bS(h,z,-1);while(0);do if((eS(A)|0)==65536){P=f[Lb>>2]|0;f[i>>2]=f[P>>2];Tc=P+4|0;f[xc>>2]=f[Tc>>2];f[yc>>2]=f[P+8>>2];f[zc>>2]=f[P+12>>2];f[Ac>>2]=f[P+16>>2];f[Bc>>2]=f[P+20>>2];f[Cc>>2]=f[P+24>>2];f[Dc>>2]=f[P+28>>2];f[Ec>>2]=f[P+32>>2];Wc=f[P+36>>2]|0;f[Fc>>2]=Wc;f[Gc>>2]=yc;f[Ic>>2]=Hc;f[Hc>>2]=0;f[Jc>>2]=0;if(Wc|0){Uc=Wc+12|0;f[Uc>>2]=(f[Uc>>2]|0)+1}if((f[Tc>>2]|0)<3){Tc=f[P+44>>2]|0;Uc=f[Ic>>2]|0;f[Uc>>2]=f[Tc>>2];f[Uc+4>>2]=f[Tc+4>>2];break}else{f[xc>>2]=0;U$(i,P);break}}else bS(i,A,-1);while(0);P=f[Pb>>2]|0;Tc=f[ac>>2]|0;Uc=f[nc>>2]|0;Wc=f[Ac>>2]|0;Xc=Y(f[Nb>>2]|0,f[Ob>>2]|0)|0;if((Xc|0)>0){Vc=0;do{Zc=+n[Tc+(Vc<<2)>>2];n[Wc+(Vc<<2)>>2]=Yc*(+n[P+(Vc<<2)>>2]*+n[Uc+(Vc<<2)>>2]-Zc*Zc);Vc=Vc+1|0}while((Vc|0)!=(Xc|0))}Xc=f[Fc>>2]|0;if(Xc|0?(Vc=Xc+12|0,Xc=f[Vc>>2]|0,f[Vc>>2]=Xc+-1,(Xc|0)==1):0)V$(i);f[Fc>>2]=0;f[Ac>>2]=0;f[Ac+4>>2]=0;f[Ac+8>>2]=0;f[Ac+12>>2]=0;if((f[xc>>2]|0)>0){Xc=f[Gc>>2]|0;Vc=0;do{f[Xc+(Vc<<2)>>2]=0;Vc=Vc+1|0}while((Vc|0)<(f[xc>>2]|0))}Vc=f[Ic>>2]|0;if((Vc|0)!=(Hc|0))wL(Vc);Vc=f[sc>>2]|0;if(Vc|0?(Xc=Vc+12|0,Vc=f[Xc>>2]|0,f[Xc>>2]=Vc+-1,(Vc|0)==1):0)V$(h);f[sc>>2]=0;f[nc>>2]=0;f[nc+4>>2]=0;f[nc+8>>2]=0;f[nc+12>>2]=0;if((f[kc>>2]|0)>0){Vc=f[tc>>2]|0;Xc=0;do{f[Vc+(Xc<<2)>>2]=0;Xc=Xc+1|0}while((Xc|0)<(f[kc>>2]|0))}Xc=f[vc>>2]|0;if((Xc|0)!=(uc|0))wL(Xc);Xc=f[fc>>2]|0;if(Xc|0?(Vc=Xc+12|0,Xc=f[Vc>>2]|0,f[Vc>>2]=Xc+-1,(Xc|0)==1):0)V$(g);f[fc>>2]=0;f[ac>>2]=0;f[ac+4>>2]=0;f[ac+8>>2]=0;f[ac+12>>2]=0;if((f[Zb>>2]|0)>0){Xc=f[gc>>2]|0;Vc=0;do{f[Xc+(Vc<<2)>>2]=0;Vc=Vc+1|0}while((Vc|0)<(f[Zb>>2]|0))}Vc=f[ic>>2]|0;if((Vc|0)!=(hc|0))wL(Vc);Vc=f[Ub>>2]|0;do if(Vc|0){Xc=Vc+12|0;Uc=f[Xc>>2]|0;f[Xc>>2]=Uc+-1;if((Uc|0)!=1)break;V$(e)}while(0);f[Ub>>2]=0;f[Pb>>2]=0;f[Pb+4>>2]=0;f[Pb+8>>2]=0;f[Pb+12>>2]=0;if((f[Mb>>2]|0)>0){Vc=f[Vb>>2]|0;Uc=0;do{f[Vc+(Uc<<2)>>2]=0;Uc=Uc+1|0}while((Uc|0)<(f[Mb>>2]|0))}Uc=f[Xb>>2]|0;if((Uc|0)!=(Wb|0))wL(Uc);Uc=f[Kc>>2]|0;do if(Uc|0){Vc=Uc+12|0;Xc=f[Vc>>2]|0;f[Vc>>2]=Xc+-1;if((Xc|0)!=1)break;V$(q)}while(0);f[Kc>>2]=0;f[Lc>>2]=0;f[Lc+4>>2]=0;f[Lc+8>>2]=0;f[Lc+12>>2]=0;if((f[ha>>2]|0)>0){Uc=f[ja>>2]|0;Xc=0;do{f[Uc+(Xc<<2)>>2]=0;Xc=Xc+1|0}while((Xc|0)<(f[ha>>2]|0))}Xc=f[la>>2]|0;if((Xc|0)!=(ka|0))wL(Xc);Xc=f[Mc>>2]|0;do if(Xc|0){Uc=Xc+12|0;Vc=f[Uc>>2]|0;f[Uc>>2]=Vc+-1;if((Vc|0)!=1)break;V$(p)}while(0);f[Mc>>2]=0;f[Nc>>2]=0;f[Nc+4>>2]=0;f[Nc+8>>2]=0;f[Nc+12>>2]=0;if((f[ba>>2]|0)>0){Xc=f[da>>2]|0;Vc=0;do{f[Xc+(Vc<<2)>>2]=0;Vc=Vc+1|0}while((Vc|0)<(f[ba>>2]|0))}Vc=f[fa>>2]|0;if((Vc|0)!=(ea|0))wL(Vc);Vc=f[Oc>>2]|0;do if(Vc|0){Xc=Vc+12|0;Uc=f[Xc>>2]|0;f[Xc>>2]=Uc+-1;if((Uc|0)!=1)break;V$(o)}while(0);f[Oc>>2]=0;f[Pc>>2]=0;f[Pc+4>>2]=0;f[Pc+8>>2]=0;f[Pc+12>>2]=0;if((f[W>>2]|0)>0){Vc=f[Z>>2]|0;Uc=0;do{f[Vc+(Uc<<2)>>2]=0;Uc=Uc+1|0}while((Uc|0)<(f[W>>2]|0))}Uc=f[$>>2]|0;if((Uc|0)!=(_|0))wL(Uc);Uc=f[Qc>>2]|0;do if(Uc|0){Vc=Uc+12|0;Xc=f[Vc>>2]|0;f[Vc>>2]=Xc+-1;if((Xc|0)!=1)break;V$(m)}while(0);f[Qc>>2]=0;f[Rc>>2]=0;f[Rc+4>>2]=0;f[Rc+8>>2]=0;f[Rc+12>>2]=0;if((f[a>>2]|0)>0){Uc=f[S>>2]|0;Xc=0;do{f[Uc+(Xc<<2)>>2]=0;Xc=Xc+1|0}while((Xc|0)<(f[a>>2]|0))}Xc=f[U>>2]|0;if((Xc|0)!=(T|0))wL(Xc);Sc=Sc+1|0}while((Sc|0)<(f[Q>>2]|0));Q=l+36|0;Sc=f[Q>>2]|0;if((Sc|0)!=0?(T=Sc+12|0,Sc=f[T>>2]|0,f[T>>2]=Sc+-1,(Sc|0)==1):0){V$(l);_c=Q}else _c=Q}else _c=l+36|0;f[_c>>2]=0;_c=l+16|0;f[_c>>2]=0;f[_c+4>>2]=0;f[_c+8>>2]=0;f[_c+12>>2]=0;if((f[L>>2]|0)>0){_c=f[N>>2]|0;N=0;do{f[_c+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[L>>2]|0))}L=f[O>>2]|0;if((L|0)!=(M|0))wL(L);L=k+36|0;M=f[L>>2]|0;if(M|0?(O=M+12|0,M=f[O>>2]|0,f[O>>2]=M+-1,(M|0)==1):0)V$(k);f[L>>2]=0;L=k+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[H>>2]|0)>0){L=f[J>>2]|0;J=0;do{f[L+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[K>>2]|0;if((H|0)!=(I|0))wL(H);H=j+36|0;I=f[H>>2]|0;if(I|0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0)V$(j);f[H>>2]=0;H=j+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[B>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[G>>2]|0;if((B|0)==(C|0)){u=c;return}wL(B);u=c;return}function POb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+24|0;e=c+12|0;g=c;h=f[b>>2]|0;i=b+4|0;j=f[i>>2]|0;if((j|0)!=(h|0))f[i>>2]=j+(~(((j+-28-h|0)>>>0)/28|0)*28|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;QOb(a,g);ROb(a,g,b);h=((f[i>>2]|0)-(f[b>>2]|0)|0)/28|0;f[d>>2]=0;f[d+4>>2]=h;f[e>>2]=116312;f[e+4>>2]=b;f[e+8>>2]=a+68;h3(d,e,-1.0);hx(g);u=c;return}function QOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a+68|0;i=a+72|0;hS(c,((f[i>>2]|0)-(f[h>>2]|0)|0)/316|0);j=((f[i>>2]|0)-(f[h>>2]|0)|0)/316|0;f[e>>2]=0;f[e+4>>2]=j;j=f[a+32>>2]|0;f[g>>2]=116528;f[g+4>>2]=h;f[g+8>>2]=c;f[g+12>>2]=j;h3(e,g,-1.0);g=c+4|0;e=f[c>>2]|0;j=((f[g>>2]|0)-e|0)/56|0;a=e;if(j>>>0>1){e=1;i=a;while(1){k=f[i+(e*56|0)+16>>2]|0;l=e+-1|0;m=f[i+(l*56|0)+16>>2]|0;o=f[h>>2]|0;p=f[o+(e*316|0)+240>>2]|0;q=f[o+(l*316|0)+240>>2]|0;r=(~~+n[o+(e*316|0)+308>>2]|0)/(~~+n[o+(l*316|0)+308>>2]|0)|0;s=Y(f[o+(e*316|0)+304>>2]|0,r)|0;o=i+(e*56|0)+8|0;if((f[o>>2]|0)>0){t=i+(e*56|0)+12|0;v=Y(s,s)|0;w=f[t>>2]|0;x=0;y=0;z=w;A=w;while(1){a:do if((A|0)>0){w=Y(y,r)|0;B=w-s|0;C=w+s|0;if((B|0)<(C|0)){D=0;E=x;F=z}else{G=0;H=x;while(1){G=G+1|0;I=H+1|0;if((G|0)>=(A|0)){J=I;K=z;L=A;break a}else H=I}}while(1){b:do if((b[k+E>>0]|0)!=0?(H=Y(D,r)|0,G=f[c>>2]|0,I=f[G+(l*56|0)+12>>2]|0,M=f[G+(l*56|0)+16>>2]|0,N=f[f[G+(l*56|0)+44>>2]>>2]|0,G=H-s|0,O=H+s|0,(G|0)<(O|0)):0){P=B;c:while(1){Q=M+(Y(P,N)|0)|0;R=P-w|0;S=Y(R,R)|0;T=G;while(1){if(b[Q+T>>0]|0?(R=T-H|0,((Y(R,R)|0)+S|0)>>>0<=v>>>0):0)break c;R=T+1|0;if((R|0)<(O|0))T=R;else break}S=P+1|0;if((S|0)<(C|0))P=S;else{U=F;break b}}O=T+(Y(P,I)|0)|0;if(+n[p+(E<<2)>>2]>+n[q+(O<<2)>>2]){b[m+O>>0]=0;U=f[t>>2]|0}else U=F}else U=F;while(0);D=D+1|0;O=E+1|0;if((D|0)>=(U|0)){J=O;K=U;L=U;break}else{E=O;F=U}}}else{J=x;K=z;L=A}while(0);y=y+1|0;if((y|0)>=(f[o>>2]|0))break;else{x=J;z=K;A=L}}}e=e+1|0;A=f[c>>2]|0;z=((f[g>>2]|0)-A|0)/56|0;x=A;if(e>>>0>=z>>>0){V=z;W=x;break}else i=x}}else{V=j;W=a}a=V+-2|0;if((a|0)<=-1){u=d;return}V=a;a=W;while(1){W=f[a+(V*56|0)+16>>2]|0;j=V+1|0;i=f[a+(j*56|0)+16>>2]|0;e=f[h>>2]|0;g=f[e+(V*316|0)+240>>2]|0;L=f[e+(j*316|0)+240>>2]|0;K=(~~+n[e+(j*316|0)+308>>2]|0)/(~~+n[e+(V*316|0)+308>>2]|0)|0;J=f[e+(j*316|0)+304>>2]|0;e=a+(V*56|0)+8|0;if((f[e>>2]|0)>0){U=a+(V*56|0)+12|0;F=Y(J,J)|0;E=0;D=0;T=f[U>>2]|0;while(1){if((T|0)>0){x=0;z=D;A=T;while(1){d:do if(((b[W+z>>0]|0)!=0?(o=(x|0)/(K|0)|0,y=(E|0)/(K|0)|0,t=f[c>>2]|0,m=f[t+(j*56|0)+12>>2]|0,q=f[t+(j*56|0)+16>>2]|0,p=y-J|0,v=y+J|0,(p|0)<(v|0)):0)?(s=f[f[t+(j*56|0)+44>>2]>>2]|0,t=o-J|0,l=o+J|0,(t|0)<(l|0)):0){r=p;e:while(1){p=q+(Y(r,s)|0)|0;k=r-y|0;C=Y(k,k)|0;X=t;while(1){if(b[p+X>>0]|0?(k=X-o|0,((Y(k,k)|0)+C|0)>>>0<=F>>>0):0)break e;k=X+1|0;if((k|0)<(l|0))X=k;else break}C=r+1|0;if((C|0)<(v|0))r=C;else{Z=A;break d}}v=X+(Y(r,m)|0)|0;if(+n[g+(z<<2)>>2]>+n[L+(v<<2)>>2]){b[i+v>>0]=0;Z=f[U>>2]|0}else Z=A}else Z=A;while(0);x=x+1|0;v=z+1|0;if((x|0)>=(Z|0)){_=v;$=Z;break}else{z=v;A=Z}}}else{_=D;$=T}E=E+1|0;if((E|0)>=(f[e>>2]|0))break;else{D=_;T=$}}}if((V|0)<=0)break;V=V+-1|0;a=f[c>>2]|0}u=d;return}function ROb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;e=u;u=u+112|0;g=e+80|0;h=e+64|0;i=e+56|0;j=e+48|0;k=e+32|0;l=e+16|0;m=e;o=c+4|0;p=f[o>>2]|0;q=f[c>>2]|0;if((p|0)==(q|0)){u=e;return}r=a+68|0;s=g+4|0;t=g+8|0;v=g+12|0;w=g+16|0;x=g+20|0;y=g+24|0;z=a+20|0;a=h+4|0;A=h+8|0;B=h+12|0;C=i+4|0;D=j+4|0;E=k+8|0;F=k+12|0;G=k+4|0;H=l+8|0;I=l+12|0;J=l+4|0;K=m+4|0;M=m+8|0;N=m+12|0;O=d+4|0;P=d+8|0;Q=0;R=p;p=q;while(1){q=p;S=f[r>>2]|0;T=f[S+(Q*316|0)+240>>2]|0;U=S+(Q*316|0)+308|0;V=+n[U>>2];W=f[S+(Q*316|0)+236>>2]|0;X=f[q+(Q*56|0)+16>>2]|0;Z=q+(Q*56|0)+8|0;_=f[Z>>2]|0;if((_|0)>0){$=q+(Q*56|0)+12|0;q=S+(Q*316|0)+292|0;aa=S+(Q*316|0)+296|0;ba=(V+-1.0)*.5;S=0;ca=0;da=_;_=f[$>>2]|0;while(1){if((_|0)>0){ea=+(ca|0);fa=Y(ca,W)|0;ga=ca+1|0;ha=Y(ga,W)|0;ia=Y(ca+-1|0,W)|0;ja=0;ka=S;la=_;while(1){if(!(b[X+ka>>0]|0))ma=la;else{n[w>>2]=0.0;na=+n[U>>2];n[g>>2]=+(ja|0)*na;n[s>>2]=ea*na;n[t>>2]=+n[q>>2]*+n[z>>2];n[v>>2]=-1.0;f[w>>2]=f[T+(ka<<2)>>2];f[x>>2]=f[aa>>2];f[y>>2]=Q;oa=ja+fa|0;na=+n[T+(oa+1<<2)>>2];pa=+n[T+(oa+-1<<2)>>2];qa=ja+ha|0;ra=+n[T+(qa<<2)>>2];sa=ja+ia|0;ta=+n[T+(sa<<2)>>2];ua=+n[T+(oa<<2)>>2]*2.0;va=(+n[T+(qa+1<<2)>>2]+ +n[T+(sa+-1<<2)>>2]-+n[T+(sa+1<<2)>>2]-+n[T+(qa+-1<<2)>>2])*.25;n[h>>2]=na+pa-ua;n[a>>2]=va;n[A>>2]=va;n[B>>2]=ra+ta-ua;n[i>>2]=-((na-pa)*.5);n[C>>2]=-((ra-ta)*.5);n[j>>2]=0.0;n[D>>2]=0.0;f[k>>2]=-1056833531;f[G>>2]=h;f[E>>2]=2;f[F>>2]=2;f[l>>2]=-1056833531;f[J>>2]=i;f[H>>2]=1;f[I>>2]=2;f[m>>2]=-1040056315;f[K>>2]=j;f[M>>2]=1;f[N>>2]=2;pM(k,l,m,0)|0;ta=+n[j>>2];ra=+n[D>>2];do if(!(+L(+ta)>1.0)?!(+L(+ra)>1.0):0){pa=ba+V*ta+ +n[g>>2];n[g>>2]=pa;na=ba+V*ra+ +n[s>>2];n[s>>2]=na;n[v>>2]=0.0;n[t>>2]=+n[t>>2]*2.0;qa=f[O>>2]|0;if((qa|0)==(f[P>>2]|0)){Lx(d,g);break}else{n[qa>>2]=pa;n[qa+4>>2]=na;sa=qa+8|0;f[sa>>2]=f[t>>2];f[sa+4>>2]=f[t+4>>2];f[sa+8>>2]=f[t+8>>2];f[sa+12>>2]=f[t+12>>2];f[sa+16>>2]=f[t+16>>2];f[O>>2]=(f[O>>2]|0)+28;break}}while(0);ma=f[$>>2]|0}ja=ja+1|0;ka=ka+1|0;if((ja|0)>=(ma|0))break;else la=ma}wa=ka;xa=ga;ya=ma;za=f[Z>>2]|0}else{wa=S;xa=ca+1|0;ya=_;za=da}if((xa|0)<(za|0)){S=wa;ca=xa;da=za;_=ya}else break}Aa=f[c>>2]|0;Ba=f[o>>2]|0}else{Aa=p;Ba=R}Q=Q+1|0;if(Q>>>0>=((Ba-Aa|0)/56|0)>>>0)break;else{R=Ba;p=Aa}}u=e;return}function SOb(a){a=a|0;cYc(a);return}function TOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0;d=u;u=u+1936|0;e=d+1916|0;g=d+1480|0;h=d+1044|0;i=d+608|0;j=d+436|0;k=d;l=f[c>>2]|0;m=c+4|0;if((l|0)>=(f[m>>2]|0)){u=d;return}c=a+4|0;o=a+8|0;a=j+168|0;p=j+28|0;q=j+140|0;r=l;a:while(1){l=f[f[c>>2]>>2]|0;s=f[f[o>>2]>>2]|0;t=f[l+(r*28|0)+24>>2]|0;v=+n[s+(t*316|0)+308>>2];w=ALc(+n[l+(r*28|0)+8>>2]*.5/v)|0;x=ALc(+n[l+(r*28|0)>>2]/v)|0;y=ALc(+n[l+(r*28|0)+4>>2]/v)|0;if((b[537360]|0)==0?X0c(537360)|0:0){z=-6;A=0;while(1){B=Y(z,z)|0;C=(z|0)>-1?z:0-z|0;D=-6;E=A;while(1){if(((Y(D,D)|0)+B|0)>>>0<36){if((E|0)>=109){F=10;break a}f[892744+(E<<2)>>2]=f[116324+(C*28|0)+(((D|0)>-1?D:0-D|0)<<2)>>2];f[893616+(E<<2)>>2]=z;f[893180+(E<<2)>>2]=D;G=E+1|0}else G=E;D=D+1|0;if((D|0)>=7)break;else E=G}z=z+1|0;if((z|0)>=7)break;else A=G}}A=w*6|0;if((A|0)>(x|0)){F=16;break}if((x+A|0)>=(f[s+(t*316|0)+12>>2]|0)){F=16;break}if((A|0)>(y|0)){F=20;break}if((y+A|0)>=(f[s+(t*316|0)+8>>2]|0)){F=20;break}A=f[s+(t*316|0)+16>>2]|0;z=f[f[s+(t*316|0)+44>>2]>>2]|0;E=f[s+(t*316|0)+72>>2]|0;D=f[f[s+(t*316|0)+100>>2]>>2]|0;C=0;do{B=(Y(f[893616+(C<<2)>>2]|0,w)|0)+y|0;H=(Y(f[893180+(C<<2)>>2]|0,w)|0)+x|0;v=+n[892744+(C<<2)>>2];I=A+(Y(B,z)|0)+(H<<2)|0;n[g+(C<<2)>>2]=v*+n[I>>2];I=E+(Y(B,D)|0)+(H<<2)|0;n[h+(C<<2)>>2]=v*+n[I>>2];C=C+1|0}while((C|0)!=109);WP(h,g,i,109,0);g1c(j|0,0,172)|0;C=0;do{D=~~(+n[i+(C<<2)>>2]/.14959965646266937);E=j+((D>>>0>41?0:D)<<2)|0;f[E>>2]=(f[E>>2]|0)+1;C=C+1|0}while((C|0)!=109);C=1;E=f[j>>2]|0;do{D=j+(C<<2)|0;E=(f[D>>2]|0)+E|0;f[D>>2]=E;C=C+1|0}while((C|0)!=43);if((f[a>>2]|0)==109)J=0;else{F=27;break}do{C=~~(+n[i+(J<<2)>>2]/.14959965646266937);E=j+((C>>>0>41?0:C)<<2)|0;C=(f[E>>2]|0)+-1|0;f[E>>2]=C;f[k+(C<<2)>>2]=J;J=J+1|0}while((J|0)!=109);C=f[j>>2]|0;E=f[p>>2]|0;if((C|0)<(E|0)){v=0.0;D=C;K=0.0;while(1){z=f[k+(D<<2)>>2]|0;L=K+ +n[g+(z<<2)>>2];M=v+ +n[h+(z<<2)>>2];D=D+1|0;if((D|0)==(E|0)){N=L;O=M;break}else{v=M;K=L}}}else{N=0.0;O=0.0}K=O*O+N*N;D=1;v=O;L=N;z=C;A=E;while(1){x=z;z=f[j+(D<<2)>>2]|0;w=f[j+(D+7<<2)>>2]|0;if((z|0)==(x|0)&(w|0)==(A|0)){P=K;Q=L;R=v;S=A}else{if((z|0)<(w|0)){x=z;M=0.0;T=0.0;while(1){y=f[k+(x<<2)>>2]|0;U=T+ +n[g+(y<<2)>>2];V=M+ +n[h+(y<<2)>>2];x=x+1|0;if((x|0)==(w|0)){W=V;X=U;break}else{M=V;T=U}}}else{W=0.0;X=0.0}T=X*X+W*W;x=T>K;P=x?T:K;Q=x?X:L;R=x?W:v;S=w}D=D+1|0;if((D|0)==36)break;else{K=P;v=R;L=Q;A=S}}A=f[a>>2]|0;D=36;L=P;v=R;K=Q;z=f[q>>2]|0;E=C;while(1){x=D+-35|0;y=z;z=f[j+(D<<2)>>2]|0;if((z|0)==(y|0)?(f[j+(x<<2)>>2]|0)==(E|0):0){Z=L;_=K;$=v;aa=E}else{if((z|0)<(A|0)){y=z;T=0.0;M=0.0;while(1){t=f[k+(y<<2)>>2]|0;U=M+ +n[g+(t<<2)>>2];V=T+ +n[h+(t<<2)>>2];y=y+1|0;if((y|0)==(A|0)){ba=V;ca=U;break}else{T=V;M=U}}}else{ba=0.0;ca=0.0}y=f[j+(x<<2)>>2]|0;if((C|0)<(y|0)){w=C;M=ba;T=ca;while(1){t=f[k+(w<<2)>>2]|0;U=T+ +n[g+(t<<2)>>2];V=M+ +n[h+(t<<2)>>2];w=w+1|0;if((w|0)==(y|0)){da=V;ea=U;break}else{M=V;T=U}}}else{da=ba;ea=ca}T=ea*ea+da*da;w=T>L;Z=w?T:L;_=w?ea:K;$=w?da:v;aa=y}D=D+1|0;if((D|0)==42)break;else{L=Z;v=$;K=_;E=aa}}K=+fQ($,_);n[l+(r*28|0)+12>>2]=K;r=r+1|0;if((r|0)>=(f[m>>2]|0)){F=3;break}}if((F|0)==3){u=d;return}else if((F|0)==10){f[e+8>>2]=0;b[e+11>>0]=7;b[e>>0]=b[463963]|0;b[e+1>>0]=b[463964]|0;b[e+2>>0]=b[463965]|0;b[e+3>>0]=b[463966]|0;b[e+4>>0]=b[463967]|0;b[e+5>>0]=b[463968]|0;b[e+6>>0]=b[463969]|0;b[e+7>>0]=0;vM(-215,e,463971,463600,1283)}else if((F|0)==16){d=$Xc(48)|0;f[e>>2]=d;f[e+8>>2]=-2147483600;f[e+4>>2]=47;fa=d;ga=463978;ha=fa+47|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));b[d+47>>0]=0;vM(-215,e,464026,463600,1294)}else if((F|0)==20){d=$Xc(48)|0;f[e>>2]=d;f[e+8>>2]=-2147483600;f[e+4>>2]=47;fa=d;ga=464061;ha=fa+47|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));b[d+47>>0]=0;vM(-215,e,464026,463600,1295)}else if((F|0)==27){F=$Xc(16)|0;f[e>>2]=F;f[e+8>>2]=-2147483632;f[e+4>>2]=15;fa=F;ga=464109;ha=fa+15|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));b[F+15>>0]=0;vM(-215,e,464125,463600,1342)}}function UOb(a){a=a|0;cYc(a);return}function VOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=u;u=u+240|0;e=d;g=d+224|0;h=f[c>>2]|0;i=c+4|0;if((h|0)>=(f[i>>2]|0)){u=d;return}c=a+4|0;j=a+8|0;k=g+4|0;l=a+12|0;a=h;do{h=f[f[c>>2]>>2]|0;m=f[f[j>>2]>>2]|0;o=f[h+(a*316|0)+264>>2]|0;p=f[o>>2]|0;f[g>>2]=f[o+4>>2];f[k>>2]=p;r$(e,g,0);p=f[e>>2]|0;ei[f[(f[p>>2]|0)+12>>2]&511](p,e,m+(a*56|0)|0,-1);Zj(e);p=h+(a*316|0)+312|0;o=f[p>>2]|0;q=o+1|0;r=h+(a*316|0)+232|0;s=f[r>>2]|0;if((q|0)<(s|0)?(t=f[h+(a*316|0)+240>>2]|0,v=f[f[h+(a*316|0)+268>>2]>>2]|0,w=m+(a*56|0)+16|0,x=f[w>>2]|0,y=m+(a*56|0)+44|0,z=f[h+(a*316|0)+304>>2]|0,(o|0)<(s-o|0)):0){s=t+(Y(v,q)|0)|0;q=t+(Y(v,o)|0)|0;A=t+(Y(v,o+-1|0)|0)|0;v=h+(a*316|0)+236|0;h=m+(a*56|0)+12|0;m=Y(z,z)|0;B=o;C=A;A=q;q=s;s=o;o=f[v>>2]|0;while(1){a:do if((s|0)<(o-s|0)){D=B-z|0;E=B+z|0;if((D|0)<(E|0)){F=s;G=s;H=o}else{I=s;J=s;K=o;while(1){L=+n[A+(I<<2)>>2];do if(((((((!(L<=+n[l>>2])?(M=I+-1|0,!(L<=+n[A+(M<<2)>>2])):0)?(N=I+1|0,!(L<=+n[A+(N<<2)>>2])):0)?!(L<=+n[C+(M<<2)>>2]):0)?!(L<=+n[C+(I<<2)>>2]):0)?!(L<=+n[C+(N<<2)>>2]):0)?!(L<=+n[q+(M<<2)>>2]):0)?!(L<=+n[q+(I<<2)>>2]):0){if(L<=+n[q+(N<<2)>>2]){O=J;P=K;break}N=(f[w>>2]|0)+(Y(f[f[y>>2]>>2]|0,B)|0)+I|0;b[N>>0]=1;O=f[p>>2]|0;P=f[v>>2]|0}else{O=J;P=K}while(0);I=I+1|0;if((I|0)>=(P-O|0)){Q=P;R=O;break a}else{J=O;K=P}}}while(1){L=+n[A+(F<<2)>>2];b:do if((((((((!(L<=+n[l>>2])?(K=F+-1|0,!(L<=+n[A+(K<<2)>>2])):0)?(J=F+1|0,!(L<=+n[A+(J<<2)>>2])):0)?!(L<=+n[C+(K<<2)>>2]):0)?!(L<=+n[C+(F<<2)>>2]):0)?!(L<=+n[C+(J<<2)>>2]):0)?!(L<=+n[q+(K<<2)>>2]):0)?!(L<=+n[q+(F<<2)>>2]):0)?!(L<=+n[q+(J<<2)>>2]):0){J=f[h>>2]|0;K=f[w>>2]|0;I=f[f[y>>2]>>2]|0;N=F-z|0;M=F+z|0;c:do if((N|0)<(M|0)){S=D;d:while(1){T=K+(Y(S,I)|0)|0;U=S-B|0;V=Y(U,U)|0;W=N;while(1){if(b[T+W>>0]|0?(U=W-F|0,((Y(U,U)|0)+V|0)>>>0<=m>>>0):0)break d;U=W+1|0;if((U|0)<(M|0))W=U;else break}V=S+1|0;if((V|0)<(E|0))S=V;else{X=I;Z=K;break c}}V=W+(Y(S,J)|0)|0;if(!(L>+n[t+(V<<2)>>2])){_=G;$=H;break b}b[x+V>>0]=0;X=f[f[y>>2]>>2]|0;Z=f[w>>2]|0}else{X=I;Z=K}while(0);K=Z+(Y(X,B)|0)+F|0;b[K>>0]=1;_=f[p>>2]|0;$=f[v>>2]|0}else{_=G;$=H}while(0);F=F+1|0;if((F|0)>=($-_|0)){Q=$;R=_;break}else{G=_;H=$}}}else{Q=o;R=s}while(0);B=B+1|0;if((B|0)>=((f[r>>2]|0)-R|0))break;else{E=q;D=A;q=q+(Q<<2)|0;s=R;o=Q;A=E;C=D}}}a=a+1|0}while((a|0)<(f[i>>2]|0));u=d;return}function WOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=u;u=u+432|0;g=e+368|0;h=e+360|0;i=e+168|0;j=e+304|0;k=e+112|0;l=e+56|0;m=e;n=c+4|0;o=f[n>>2]|0;p=f[c>>2]|0;q=p;a:do if((o|0)!=(p|0)){r=a+68|0;s=a+72|0;t=(o-p|0)/28|0;v=0;while(1){w=f[q+(v*28|0)+24>>2]|0;if((w|0)<=-1){x=7;break}v=v+1|0;if((w|0)>=(((f[s>>2]|0)-(f[r>>2]|0)|0)/316|0|0)){x=7;break}if(v>>>0>=t>>>0)break a}if((x|0)==7){t=$Xc(80)|0;f[g>>2]=t;f[g+8>>2]=-2147483568;f[g+4>>2]=79;v=t;r=464213;s=v+79|0;do{b[v>>0]=b[r>>0]|0;v=v+1|0;r=r+1|0}while((v|0)<(s|0));b[t+79>>0]=0;vM(-215,g,464293,463600,1192)}}while(0);x=a+40|0;if((f[x>>2]|0)>3){q=f[a+44>>2]|0;if(!q)y=(f[a+48>>2]|0)*162|0;else y=q;z=0;A=(y+7|0)>>>3}else{z=5;A=64}ZS(d,(o-p|0)/28|0,A,z,-1,0,0);do if((eS(d)|0)==65536){z=f[d+4>>2]|0;f[g>>2]=f[z>>2];A=g+4|0;p=z+4|0;f[A>>2]=f[p>>2];o=g+8|0;f[o>>2]=f[z+8>>2];f[g+12>>2]=f[z+12>>2];f[g+16>>2]=f[z+16>>2];f[g+20>>2]=f[z+20>>2];f[g+24>>2]=f[z+24>>2];f[g+28>>2]=f[z+28>>2];f[g+32>>2]=f[z+32>>2];y=f[z+36>>2]|0;f[g+36>>2]=y;f[g+40>>2]=o;o=g+48|0;q=g+44|0;f[q>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(y|0){o=y+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[p>>2]|0)<3){p=f[z+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[p>>2];f[o+4>>2]=f[p+4>>2];break}else{f[A>>2]=0;U$(g,z);break}}else bS(g,d,-1);while(0);b:do switch(f[x>>2]|0){case 2:{d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;f[i>>2]=116548;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;h3(h,i,-1.0);break}case 3:{d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;f[i>>2]=116568;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;h3(h,i,-1.0);break}case 4:{if(!(f[a+44>>2]|0)){d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;f[i>>2]=116588;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;f[i+16>>2]=a;h3(h,i,-1.0);break b}d=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=d;d=a+112|0;f[j>>2]=f[d>>2];z=j+4|0;A=a+116|0;p=f[A>>2]|0;f[z>>2]=p;o=j+8|0;f[o>>2]=f[a+120>>2];q=j+12|0;f[q>>2]=f[a+124>>2];y=j+16|0;f[y>>2]=f[a+128>>2];r=j+20|0;f[r>>2]=f[a+132>>2];v=j+24|0;f[v>>2]=f[a+136>>2];s=j+28|0;f[s>>2]=f[a+140>>2];w=j+32|0;f[w>>2]=f[a+144>>2];B=j+36|0;C=f[a+148>>2]|0;f[B>>2]=C;D=j+40|0;f[D>>2]=o;E=j+48|0;F=j+44|0;f[F>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(!C)G=p;else{p=C+12|0;f[p>>2]=(f[p>>2]|0)+1;G=f[A>>2]|0}if((G|0)<3){A=f[a+156>>2]|0;p=f[F>>2]|0;f[p>>2]=f[A>>2];f[p+4>>2]=f[A+4>>2]}else{f[z>>2]=0;U$(j,d)}d=a+168|0;f[k>>2]=f[d>>2];A=k+4|0;p=a+172|0;C=f[p>>2]|0;f[A>>2]=C;H=k+8|0;f[H>>2]=f[a+176>>2];I=k+12|0;f[I>>2]=f[a+180>>2];J=k+16|0;f[J>>2]=f[a+184>>2];K=k+20|0;f[K>>2]=f[a+188>>2];L=k+24|0;f[L>>2]=f[a+192>>2];M=k+28|0;f[M>>2]=f[a+196>>2];N=k+32|0;f[N>>2]=f[a+200>>2];O=k+36|0;P=f[a+204>>2]|0;f[O>>2]=P;Q=k+40|0;f[Q>>2]=H;R=k+48|0;S=k+44|0;f[S>>2]=R;f[R>>2]=0;f[k+52>>2]=0;if(!P)T=C;else{C=P+12|0;f[C>>2]=(f[C>>2]|0)+1;T=f[p>>2]|0}if((T|0)<3){p=f[a+212>>2]|0;C=f[S>>2]|0;f[C>>2]=f[p>>2];f[C+4>>2]=f[p+4>>2]}else{f[A>>2]=0;U$(k,d)}f[i>>2]=116608;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;f[i+16>>2]=a;d=i+20|0;f[d>>2]=f[j>>2];p=i+24|0;C=f[z>>2]|0;f[p>>2]=C;P=i+28|0;f[P>>2]=f[o>>2];f[i+32>>2]=f[q>>2];f[i+36>>2]=f[y>>2];f[i+40>>2]=f[r>>2];f[i+44>>2]=f[v>>2];f[i+48>>2]=f[s>>2];f[i+52>>2]=f[w>>2];w=f[B>>2]|0;f[i+56>>2]=w;f[i+60>>2]=P;P=i+68|0;s=i+64|0;f[s>>2]=P;f[P>>2]=0;f[i+72>>2]=0;if(!w)U=C;else{C=w+12|0;f[C>>2]=(f[C>>2]|0)+1;U=f[z>>2]|0}if((U|0)<3){C=f[F>>2]|0;w=f[s>>2]|0;f[w>>2]=f[C>>2];f[w+4>>2]=f[C+4>>2]}else{f[p>>2]=0;U$(d,j)}d=i+76|0;f[d>>2]=f[k>>2];p=i+80|0;C=f[A>>2]|0;f[p>>2]=C;w=i+84|0;f[w>>2]=f[H>>2];f[i+88>>2]=f[I>>2];f[i+92>>2]=f[J>>2];f[i+96>>2]=f[K>>2];f[i+100>>2]=f[L>>2];f[i+104>>2]=f[M>>2];f[i+108>>2]=f[N>>2];N=f[O>>2]|0;f[i+112>>2]=N;f[i+116>>2]=w;w=i+124|0;M=i+120|0;f[M>>2]=w;f[w>>2]=0;f[i+128>>2]=0;if(!N)V=C;else{C=N+12|0;f[C>>2]=(f[C>>2]|0)+1;V=f[A>>2]|0}if((V|0)<3){C=f[S>>2]|0;N=f[M>>2]|0;f[N>>2]=f[C>>2];f[N+4>>2]=f[C+4>>2]}else{f[p>>2]=0;U$(d,k)}h3(h,i,-1.0);XOb(i);d=f[O>>2]|0;if(d|0?(p=d+12|0,d=f[p>>2]|0,f[p>>2]=d+-1,(d|0)==1):0)V$(k);f[O>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[A>>2]|0)>0){J=f[Q>>2]|0;Q=0;do{f[J+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[A>>2]|0))}A=f[S>>2]|0;if((A|0)!=(R|0))wL(A);A=f[B>>2]|0;if(A|0?(Q=A+12|0,A=f[Q>>2]|0,f[Q>>2]=A+-1,(A|0)==1):0)V$(j);f[B>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[z>>2]|0)>0){A=f[D>>2]|0;Q=0;do{f[A+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[z>>2]|0))}z=f[F>>2]|0;if((z|0)!=(E|0))wL(z);break}case 5:{if(!(f[a+44>>2]|0)){z=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=z;f[i>>2]=116628;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;f[i+16>>2]=a;h3(h,i,-1.0);break b}z=((f[n>>2]|0)-(f[c>>2]|0)|0)/28|0;f[h>>2]=0;f[h+4>>2]=z;z=a+112|0;f[l>>2]=f[z>>2];Q=l+4|0;A=a+116|0;D=f[A>>2]|0;f[Q>>2]=D;y=l+8|0;f[y>>2]=f[a+120>>2];B=l+12|0;f[B>>2]=f[a+124>>2];R=l+16|0;f[R>>2]=f[a+128>>2];S=l+20|0;f[S>>2]=f[a+132>>2];J=l+24|0;f[J>>2]=f[a+136>>2];t=l+28|0;f[t>>2]=f[a+140>>2];O=l+32|0;f[O>>2]=f[a+144>>2];d=l+36|0;p=f[a+148>>2]|0;f[d>>2]=p;C=l+40|0;f[C>>2]=y;N=l+48|0;M=l+44|0;f[M>>2]=N;f[N>>2]=0;f[l+52>>2]=0;if(!p)W=D;else{D=p+12|0;f[D>>2]=(f[D>>2]|0)+1;W=f[A>>2]|0}if((W|0)<3){A=f[a+156>>2]|0;D=f[M>>2]|0;f[D>>2]=f[A>>2];f[D+4>>2]=f[A+4>>2]}else{f[Q>>2]=0;U$(l,z)}z=a+168|0;f[m>>2]=f[z>>2];A=m+4|0;D=a+172|0;p=f[D>>2]|0;f[A>>2]=p;w=m+8|0;f[w>>2]=f[a+176>>2];L=m+12|0;f[L>>2]=f[a+180>>2];K=m+16|0;f[K>>2]=f[a+184>>2];I=m+20|0;f[I>>2]=f[a+188>>2];H=m+24|0;f[H>>2]=f[a+192>>2];s=m+28|0;f[s>>2]=f[a+196>>2];P=m+32|0;f[P>>2]=f[a+200>>2];v=m+36|0;r=f[a+204>>2]|0;f[v>>2]=r;q=m+40|0;f[q>>2]=w;o=m+48|0;X=m+44|0;f[X>>2]=o;f[o>>2]=0;f[m+52>>2]=0;if(!r)Y=p;else{p=r+12|0;f[p>>2]=(f[p>>2]|0)+1;Y=f[D>>2]|0}if((Y|0)<3){D=f[a+212>>2]|0;p=f[X>>2]|0;f[p>>2]=f[D>>2];f[p+4>>2]=f[D+4>>2]}else{f[A>>2]=0;U$(m,z)}f[i>>2]=116648;f[i+4>>2]=c;f[i+8>>2]=g;f[i+12>>2]=a+68;f[i+16>>2]=a;z=i+20|0;f[z>>2]=f[l>>2];D=i+24|0;p=f[Q>>2]|0;f[D>>2]=p;r=i+28|0;f[r>>2]=f[y>>2];f[i+32>>2]=f[B>>2];f[i+36>>2]=f[R>>2];f[i+40>>2]=f[S>>2];f[i+44>>2]=f[J>>2];f[i+48>>2]=f[t>>2];f[i+52>>2]=f[O>>2];O=f[d>>2]|0;f[i+56>>2]=O;f[i+60>>2]=r;r=i+68|0;t=i+64|0;f[t>>2]=r;f[r>>2]=0;f[i+72>>2]=0;if(!O)Z=p;else{p=O+12|0;f[p>>2]=(f[p>>2]|0)+1;Z=f[Q>>2]|0}if((Z|0)<3){p=f[M>>2]|0;O=f[t>>2]|0;f[O>>2]=f[p>>2];f[O+4>>2]=f[p+4>>2]}else{f[D>>2]=0;U$(z,l)}z=i+76|0;f[z>>2]=f[m>>2];D=i+80|0;p=f[A>>2]|0;f[D>>2]=p;O=i+84|0;f[O>>2]=f[w>>2];f[i+88>>2]=f[L>>2];f[i+92>>2]=f[K>>2];f[i+96>>2]=f[I>>2];f[i+100>>2]=f[H>>2];f[i+104>>2]=f[s>>2];f[i+108>>2]=f[P>>2];P=f[v>>2]|0;f[i+112>>2]=P;f[i+116>>2]=O;O=i+124|0;s=i+120|0;f[s>>2]=O;f[O>>2]=0;f[i+128>>2]=0;if(!P)_=p;else{p=P+12|0;f[p>>2]=(f[p>>2]|0)+1;_=f[A>>2]|0}if((_|0)<3){p=f[X>>2]|0;P=f[s>>2]|0;f[P>>2]=f[p>>2];f[P+4>>2]=f[p+4>>2]}else{f[D>>2]=0;U$(z,m)}h3(h,i,-1.0);YOb(i);z=f[v>>2]|0;if(z|0?(D=z+12|0,z=f[D>>2]|0,f[D>>2]=z+-1,(z|0)==1):0)V$(m);f[v>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[A>>2]|0)>0){K=f[q>>2]|0;q=0;do{f[K+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[A>>2]|0))}A=f[X>>2]|0;if((A|0)!=(o|0))wL(A);A=f[d>>2]|0;if(A|0?(q=A+12|0,A=f[q>>2]|0,f[q>>2]=A+-1,(A|0)==1):0)V$(l);f[d>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Q>>2]|0)>0){A=f[C>>2]|0;q=0;do{f[A+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[Q>>2]|0))}Q=f[M>>2]|0;if((Q|0)!=(N|0))wL(Q);break}default:{}}while(0);l=g+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)V$(g);f[l>>2]=0;l=g+16|0;m=g+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[g+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[g+44>>2]|0;if((m|0)==(g+48|0)){u=e;return}wL(m);u=e;return}function XOb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=116608;b=a+76|0;c=a+112|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+92|0;b=a+80|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+116>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+120>>2]|0;if((b|0)!=(a+124|0))wL(b);b=a+20|0;d=a+56|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+36|0;b=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+60>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+64>>2]|0;if((b|0)==(a+68|0))return;wL(b);return}function YOb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=116648;b=a+76|0;c=a+112|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+92|0;b=a+80|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+116>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+120>>2]|0;if((b|0)!=(a+124|0))wL(b);b=a+20|0;d=a+56|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+36|0;b=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+60>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+64>>2]|0;if((b|0)==(a+68|0))return;wL(b);return}function ZOb(a){a=a|0;YOb(a);cYc(a);return}function _Ob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;$Ob(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function $Ob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0;g=u;u=u+544|0;i=g+488|0;j=g+432|0;k=g+376|0;l=g+24|0;m=g+12|0;o=g;p=f[a+16>>2]|0;q=f[a+12>>2]|0;r=+(1<<f[c+20>>2]|0);s=ALc(+n[c+8>>2]*.5/r)|0;t=+n[c+12>>2]*.01745329238474369;v=f[c+24>>2]|0;w=f[q>>2]|0;x=w+(v*316|0)|0;f[i>>2]=f[x>>2];y=i+4|0;z=w+(v*316|0)+4|0;f[y>>2]=f[z>>2];A=i+8|0;f[A>>2]=f[w+(v*316|0)+8>>2];f[i+12>>2]=f[w+(v*316|0)+12>>2];B=i+16|0;f[B>>2]=f[w+(v*316|0)+16>>2];f[i+20>>2]=f[w+(v*316|0)+20>>2];f[i+24>>2]=f[w+(v*316|0)+24>>2];f[i+28>>2]=f[w+(v*316|0)+28>>2];f[i+32>>2]=f[w+(v*316|0)+32>>2];C=i+36|0;D=f[w+(v*316|0)+36>>2]|0;f[C>>2]=D;E=i+40|0;f[E>>2]=A;A=i+48|0;F=i+44|0;f[F>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(D|0){G=D+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[z>>2]|0)<3){z=f[w+(v*316|0)+44>>2]|0;w=f[F>>2]|0;f[w>>2]=f[z>>2];f[w+4>>2]=f[z+4>>2]}else{f[y>>2]=0;U$(i,x)}x=f[q>>2]|0;z=x+(v*316|0)+56|0;f[j>>2]=f[z>>2];w=j+4|0;G=x+(v*316|0)+60|0;D=f[G>>2]|0;f[w>>2]=D;H=j+8|0;f[H>>2]=f[x+(v*316|0)+64>>2];f[j+12>>2]=f[x+(v*316|0)+68>>2];I=j+16|0;f[I>>2]=f[x+(v*316|0)+72>>2];f[j+20>>2]=f[x+(v*316|0)+76>>2];f[j+24>>2]=f[x+(v*316|0)+80>>2];f[j+28>>2]=f[x+(v*316|0)+84>>2];f[j+32>>2]=f[x+(v*316|0)+88>>2];J=j+36|0;K=f[x+(v*316|0)+92>>2]|0;f[J>>2]=K;L=j+40|0;f[L>>2]=H;H=j+48|0;N=j+44|0;f[N>>2]=H;f[H>>2]=0;f[j+52>>2]=0;if(!K)Q=D;else{D=K+12|0;f[D>>2]=(f[D>>2]|0)+1;Q=f[G>>2]|0}if((Q|0)<3){Q=f[x+(v*316|0)+100>>2]|0;x=f[N>>2]|0;f[x>>2]=f[Q>>2];f[x+4>>2]=f[Q+4>>2]}else{f[w>>2]=0;U$(j,z)}z=f[q>>2]|0;q=z+(v*316|0)+112|0;f[k>>2]=f[q>>2];Q=k+4|0;x=z+(v*316|0)+116|0;G=f[x>>2]|0;f[Q>>2]=G;D=k+8|0;f[D>>2]=f[z+(v*316|0)+120>>2];K=k+12|0;f[K>>2]=f[z+(v*316|0)+124>>2];R=k+16|0;f[R>>2]=f[z+(v*316|0)+128>>2];f[k+20>>2]=f[z+(v*316|0)+132>>2];f[k+24>>2]=f[z+(v*316|0)+136>>2];f[k+28>>2]=f[z+(v*316|0)+140>>2];f[k+32>>2]=f[z+(v*316|0)+144>>2];S=k+36|0;T=f[z+(v*316|0)+148>>2]|0;f[S>>2]=T;U=k+40|0;f[U>>2]=D;V=k+48|0;W=k+44|0;f[W>>2]=V;f[V>>2]=0;f[k+52>>2]=0;if(!T)X=G;else{G=T+12|0;f[G>>2]=(f[G>>2]|0)+1;X=f[x>>2]|0}if((X|0)<3){X=f[z+(v*316|0)+156>>2]|0;v=f[W>>2]|0;f[v>>2]=f[X>>2];f[v+4>>2]=f[X+4>>2]}else{f[Q>>2]=0;U$(k,q)}Z=+n[c+4>>2]/r;_=+n[c>>2]/r;r=+O(+t);$=+P(+t);c=f[p+48>>2]|0;if((c|0)>=4){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=$Xc(32)|0;f[l>>2]=q;f[l+8>>2]=-2147483616;f[l+4>>2]=24;aa=q;ba=464313;ca=aa+24|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));b[q+24>>0]=0;vM(-215,l,464338,463600,2022)}g1c(l|0,0,348)|0;q=f[p+52>>2]|0;if(q&1|0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=$Xc(32)|0;f[m>>2]=p;f[m+8>>2]=-2147483616;f[m+4>>2]=23;aa=p;ba=464365;ca=aa+23|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));b[p+23>>0]=0;vM(-215,m,464338,463600,2027)}f[m>>2]=q;f[m+4>>2]=(((q<<1)+2|0)>>>0)/3|0;f[m+8>>2]=(q+1|0)>>>1;q=f[a+28>>2]|0;a:do if((q|0)>0){p=f[a+36>>2]|0;X=f[f[a+64>>2]>>2]|0;v=0-s|0;z=f[K>>2]|0;x=f[D>>2]|0;G=f[R>>2]|0;T=f[W>>2]|0;da=f[B>>2]|0;ea=f[F>>2]|0;fa=f[I>>2]|0;ga=f[N>>2]|0;ha=0;ia=c;while(1){ja=p+(Y(X,ha)|0)|0;ka=f[ja>>2]|0;if(ka>>>0>=3)break;la=f[m+(ka<<2)>>2]|0;if((la|0)>0){ka=f[ja+4>>2]|0;ma=f[ja+8>>2]|0;ja=ka+la|0;na=ma+la|0;la=ka;t=0.0;oa=0.0;pa=0.0;ka=ia;while(1){qa=+(Y(la,s)|0);ra=$*qa;sa=r*qa;ta=ma;qa=oa;ua=pa;va=t;wa=ka;while(1){xa=_+(sa+$*+(Y(ta,v)|0));ya=ALc(Z+(ra+r*+(Y(ta,s)|0)))|0;za=ALc(xa)|0;b:do if((za|ya|0)>-1&(za|0)<(z|0)&(ya|0)<(x|0)){Aa=G+(Y(f[T>>2]|0,ya)|0)+(za<<2)|0;xa=ua+ +n[Aa>>2];if((wa|0)>1){Aa=da+(Y(f[ea>>2]|0,ya)|0)+(za<<2)|0;Ba=+n[Aa>>2];Aa=fa+(Y(f[ga>>2]|0,ya)|0)+(za<<2)|0;Ca=+n[Aa>>2];switch(wa|0){case 2:{Da=xa;Ea=va;Fa=qa+ +M(+(Ba*Ba+Ca*Ca));Ga=2;break b;break}case 3:{Da=xa;Ea=va+(r*Ca-$*Ba);Fa=qa+(r*Ba+$*Ca);Ga=3;break b;break}default:{Da=xa;Ea=va;Fa=qa;Ga=wa;break b}}}else{Da=xa;Ea=va;Fa=qa;Ga=wa}}else{Da=ua;Ea=va;Fa=qa;Ga=wa}while(0);ta=ta+1|0;if((ta|0)>=(na|0))break;else{qa=Fa;ua=Da;va=Ea;wa=Ga}}la=la+1|0;if((la|0)>=(ja|0)){Ha=Ea;Ia=Fa;Ja=Da;Ka=Ga;break}else{t=Ea;oa=Fa;pa=Da;ka=Ga}}}else{Ha=0.0;Ia=0.0;Ja=0.0;Ka=ia}ka=l+((Y(ha,c)|0)<<2)|0;n[ka>>2]=Ja;switch(c|0){case 2:{La=Ia;Ma=1;Na=37;break}case 3:{n[ka+4>>2]=Ia;La=Ha;Ma=2;Na=37;break}default:{}}if((Na|0)==37){Na=0;n[ka+(Ma<<2)>>2]=La}ha=ha+1|0;if((ha|0)>=(q|0))break a;else ia=Ka}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;ia=$Xc(32)|0;f[o>>2]=ia;f[o+8>>2]=-2147483616;f[o+4>>2]=31;aa=ia;ba=464389;ca=aa+31|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));b[ia+31>>0]=0;vM(-215,o,464338,463600,2036)}while(0);Ka=f[a+92>>2]|0;q=a+84|0;if((((f[q>>2]|0)+7|0)>>>3|0)!=(e|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;a=$Xc(48)|0;f[o>>2]=a;f[o+8>>2]=-2147483600;f[o+4>>2]=43;aa=a;ba=464421;ca=aa+43|0;do{b[aa>>0]=b[ba>>0]|0;aa=aa+1|0;ba=ba+1|0}while((aa|0)<(ca|0));b[a+43>>0]=0;vM(-215,o,464338,463600,2086)}g1c(d|0,0,e|0)|0;e=f[q>>2]|0;if((e|0)>0){o=0;a=e;while(1){e=o<<1;if(+n[l+(f[Ka+(e<<2)>>2]<<2)>>2]>+n[l+(f[Ka+((e|1)<<2)>>2]<<2)>>2]){e=d+((o|0)/8|0)|0;b[e>>0]=h[e>>0]|0|1<<(o&7);Oa=f[q>>2]|0}else Oa=a;o=o+1|0;if((o|0)>=(Oa|0))break;else a=Oa}}Oa=f[S>>2]|0;if(Oa|0?(a=Oa+12|0,Oa=f[a>>2]|0,f[a>>2]=Oa+-1,(Oa|0)==1):0)V$(k);f[S>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Q>>2]|0)>0){R=f[U>>2]|0;U=0;do{f[R+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[Q>>2]|0))}Q=f[W>>2]|0;if((Q|0)!=(V|0))wL(Q);Q=f[J>>2]|0;if(Q|0?(V=Q+12|0,Q=f[V>>2]|0,f[V>>2]=Q+-1,(Q|0)==1):0)V$(j);f[J>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[w>>2]|0)>0){I=f[L>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[w>>2]|0))}w=f[N>>2]|0;if((w|0)!=(H|0))wL(w);w=f[C>>2]|0;if(w|0?(H=w+12|0,w=f[H>>2]|0,f[H>>2]=w+-1,(w|0)==1):0)V$(i);f[C>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[y>>2]|0)>0){B=f[E>>2]|0;E=0;do{f[B+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[y>>2]|0))}y=f[F>>2]|0;if((y|0)==(A|0)){u=g;return}wL(y);u=g;return}function aPb(a){a=a|0;cYc(a);return}function bPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;cPb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function cPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0;g=u;u=u+224|0;i=g+24|0;j=g+12|0;k=g;l=a+16|0;m=f[l>>2]|0;if((f[m+48>>2]|0)>=4){o=$Xc(48)|0;f[i>>2]=o;f[i+8>>2]=-2147483600;f[i+4>>2]=45;p=o;q=464503;r=p+45|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+45>>0]=0;vM(-215,i,464549,463600,1955)}o=f[m+52>>2]|0;if(o&1|0){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=23;p=m;q=464365;r=p+23|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[m+23>>0]=0;vM(-215,j,464549,463600,1959)}f[j>>2]=o;f[j+4>>2]=(((o<<1)+2|0)>>>0)/3|0;f[j+8>>2]=(o+1|0)>>>1;s=+(1<<f[c+20>>2]|0);t=+(ALc(+n[c+8>>2]*.5/s)|0);v=+n[c>>2]/s;w=+n[c+4>>2]/s;s=+n[c+12>>2]*.01745329238474369;x=+O(+s);y=+P(+s);g1c(d|0,0,e|0)|0;m=c+24|0;c=0;z=0;A=o;o=5;B=3;while(1){C=c+2|0;D=Y(C,C)|0;dPb(a,i,A,f[m>>2]|0,v,w,x,y,t);C=f[(f[l>>2]|0)+48>>2]|0;E=Y(C,D)|0;if((E|0)>0){F=0;do{G=i+(F<<2)|0;H=f[G>>2]|0;f[G>>2]=H>>31&2147483647^H;F=F+1|0}while((F|0)!=(E|0))}if((D|0)!=0&(C|0)>0){E=0;F=z;while(1){H=0;G=F;I=B;while(1){J=i+((Y(H,C)|0)+E<<2)|0;K=f[J>>2]|0;H=H+1|0;if((H|0)<(D|0)){J=H;L=G;while(1){M=i+((Y(J,C)|0)+E<<2)|0;if((K|0)>(f[M>>2]|0)){M=d+(L>>3)|0;b[M>>0]=h[M>>0]|0|1<<(L&7)}J=J+1|0;if((J|0)==(D|0))break;else L=L+1|0}N=G+I|0}else N=G;if((H|0)==(D|0))break;else{G=N;I=I+-1|0}}E=E+1|0;if((E|0)==(C|0)){Q=N;break}else F=N}}else Q=z;F=c+1|0;if((F|0)==3)break;C=B+o|0;c=F;z=Q;A=f[j+(F<<2)>>2]|0;o=o+2|0;B=C}if((Q|0)!=486){Q=$Xc(16)|0;f[k>>2]=Q;f[k+8>>2]=-2147483632;f[k+4>>2]=11;p=Q;q=464574;r=p+11|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[Q+11>>0]=0;vM(-215,k,464549,463600,1985)}if((e|0)==61){u=g;return}else{g=$Xc(32)|0;f[k>>2]=g;f[k+8>>2]=-2147483616;f[k+4>>2]=27;p=g;q=464586;r=p+27|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[g+27>>0]=0;vM(-215,k,464549,463600,1986)}}function dPb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=+i;j=+j;k=+k;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0;l=u;u=u+192|0;m=l+128|0;o=l+72|0;p=l+16|0;q=l;r=f[a+12>>2]|0;s=f[a+16>>2]|0;a=f[s+52>>2]|0;t=f[s+48>>2]|0;s=f[r>>2]|0;v=s+(e*316|0)|0;f[m>>2]=f[v>>2];w=m+4|0;x=s+(e*316|0)+4|0;f[w>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[s+(e*316|0)+8>>2];f[m+12>>2]=f[s+(e*316|0)+12>>2];z=m+16|0;f[z>>2]=f[s+(e*316|0)+16>>2];f[m+20>>2]=f[s+(e*316|0)+20>>2];f[m+24>>2]=f[s+(e*316|0)+24>>2];f[m+28>>2]=f[s+(e*316|0)+28>>2];f[m+32>>2]=f[s+(e*316|0)+32>>2];A=m+36|0;B=f[s+(e*316|0)+36>>2]|0;f[A>>2]=B;C=m+40|0;f[C>>2]=y;y=m+48|0;D=m+44|0;f[D>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(B|0){E=B+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[x>>2]|0)<3){x=f[s+(e*316|0)+44>>2]|0;s=f[D>>2]|0;f[s>>2]=f[x>>2];f[s+4>>2]=f[x+4>>2]}else{f[w>>2]=0;U$(m,v)}v=f[r>>2]|0;x=v+(e*316|0)+56|0;f[o>>2]=f[x>>2];s=o+4|0;E=v+(e*316|0)+60|0;B=f[E>>2]|0;f[s>>2]=B;F=o+8|0;f[F>>2]=f[v+(e*316|0)+64>>2];f[o+12>>2]=f[v+(e*316|0)+68>>2];G=o+16|0;f[G>>2]=f[v+(e*316|0)+72>>2];f[o+20>>2]=f[v+(e*316|0)+76>>2];f[o+24>>2]=f[v+(e*316|0)+80>>2];f[o+28>>2]=f[v+(e*316|0)+84>>2];f[o+32>>2]=f[v+(e*316|0)+88>>2];H=o+36|0;I=f[v+(e*316|0)+92>>2]|0;f[H>>2]=I;J=o+40|0;f[J>>2]=F;F=o+48|0;K=o+44|0;f[K>>2]=F;f[F>>2]=0;f[o+52>>2]=0;if(!I)L=B;else{B=I+12|0;f[B>>2]=(f[B>>2]|0)+1;L=f[E>>2]|0}if((L|0)<3){L=f[v+(e*316|0)+100>>2]|0;v=f[K>>2]|0;f[v>>2]=f[L>>2];f[v+4>>2]=f[L+4>>2]}else{f[s>>2]=0;U$(o,x)}x=f[r>>2]|0;r=x+(e*316|0)+112|0;f[p>>2]=f[r>>2];L=p+4|0;v=x+(e*316|0)+116|0;E=f[v>>2]|0;f[L>>2]=E;B=p+8|0;f[B>>2]=f[x+(e*316|0)+120>>2];I=p+12|0;f[I>>2]=f[x+(e*316|0)+124>>2];N=p+16|0;f[N>>2]=f[x+(e*316|0)+128>>2];f[p+20>>2]=f[x+(e*316|0)+132>>2];f[p+24>>2]=f[x+(e*316|0)+136>>2];f[p+28>>2]=f[x+(e*316|0)+140>>2];f[p+32>>2]=f[x+(e*316|0)+144>>2];O=p+36|0;P=f[x+(e*316|0)+148>>2]|0;f[O>>2]=P;Q=p+40|0;f[Q>>2]=B;R=p+48|0;S=p+44|0;f[S>>2]=R;f[R>>2]=0;f[p+52>>2]=0;if(!P)T=E;else{E=P+12|0;f[E>>2]=(f[E>>2]|0)+1;T=f[v>>2]|0}if((T|0)<3){T=f[x+(e*316|0)+156>>2]|0;e=f[S>>2]|0;f[e>>2]=f[T>>2];f[e+4>>2]=f[T+4>>2]}else{f[L>>2]=0;U$(p,r)}r=f[Q>>2]|0;T=f[r+4>>2]|0;e=f[r>>2]|0;r=f[C>>2]|0;if(!((e|0)==(f[r>>2]|0)?(T|0)==(f[r+4>>2]|0):0)){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;r=$Xc(32)|0;f[q>>2]=r;f[q+8>>2]=-2147483616;f[q+4>>2]=17;U=r;V=464614;W=U+17|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[r+17>>0]=0;vM(-215,q,464632,463600,1864)}r=f[J>>2]|0;if(!((e|0)==(f[r>>2]|0)?(T|0)==(f[r+4>>2]|0):0)){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;r=$Xc(32)|0;f[q>>2]=r;f[q+8>>2]=-2147483616;f[q+4>>2]=17;U=r;V=464649;W=U+17|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[r+17>>0]=0;vM(-215,q,464632,463600,1865)}q=0-a|0;if((a|0)>(q|0)){r=(t|0)>1;V=(t|0)==2;U=f[N>>2]|0;W=f[S>>2]|0;T=f[z>>2]|0;e=f[D>>2]|0;x=f[G>>2]|0;v=f[K>>2]|0;E=(d|0)>0;P=0;X=q;while(1){Z=X;X=X+d|0;_=q;$=P;do{if(E){aa=_+d|0;ba=f[B>>2]|0;ca=f[I>>2]|0;da=0.0;ea=0.0;fa=0.0;ga=0;ha=Z;while(1){ia=+(ha|0);ja=ia*j*k;ka=ia*i*k;if(r){la=_;ia=da;ma=ea;na=fa;oa=ga;while(1){pa=ALc(ja+ +(la|0)*i*k+h)|0;qa=ALc(ka+ +(0-la|0)*j*k+g)|0;do if((pa|0)<0){ra=ia;sa=oa;ta=ma;ua=na}else{if(!((qa|0)>-1&(pa|0)<(ba|0)&(qa|0)<(ca|0))){ra=ia;sa=oa;ta=ma;ua=na;break}va=U+(Y(f[W>>2]|0,pa)|0)+(qa<<2)|0;wa=T+(Y(f[e>>2]|0,pa)|0)+(qa<<2)|0;xa=+n[wa>>2];wa=x+(Y(f[v>>2]|0,pa)|0)+(qa<<2)|0;ya=+n[wa>>2];if(V){za=na;Aa=+M(+(xa*xa+ya*ya))}else{za=na+(xa*i+ya*j);Aa=ya*i-xa*j}ra=ia+ +n[va>>2];sa=oa+1|0;ta=ma+Aa;ua=za}while(0);la=la+1|0;if((la|0)>=(aa|0)){Ba=ra;Ca=ta;Da=ua;Ea=sa;break}else{ia=ra;ma=ta;na=ua;oa=sa}}}else{oa=_;na=da;la=ga;while(1){qa=ALc(ja+ +(oa|0)*i*k+h)|0;pa=ALc(ka+ +(0-oa|0)*j*k+g)|0;do if((qa|0)<0){Fa=na;Ga=la}else{if(!((pa|0)>-1&(qa|0)<(ba|0)&(pa|0)<(ca|0))){Fa=na;Ga=la;break}va=U+(Y(f[W>>2]|0,qa)|0)+(pa<<2)|0;Fa=na+ +n[va>>2];Ga=la+1|0}while(0);oa=oa+1|0;if((oa|0)>=(aa|0)){Ba=Fa;Ca=ea;Da=fa;Ea=Ga;break}else{na=Fa;la=Ga}}}ha=ha+1|0;if((ha|0)>=(X|0))break;else{da=Ba;ea=Ca;fa=Da;ga=Ea}}if((Ea|0)>0){fa=1.0/+(Ea|0);Ha=fa*Ba;Ia=Ca*fa;Ja=Da*fa}else{Ha=Ba;Ia=Ca;Ja=Da}}else{Ha=0.0;Ia=0.0;Ja=0.0}n[c+($<<2)>>2]=Ha;if(r?(n[c+($+1<<2)>>2]=Ia,!V):0)n[c+($+2<<2)>>2]=Ja;$=$+t|0;_=_+d|0}while((_|0)<(a|0));if((X|0)>=(a|0))break;else P=$}}P=f[O>>2]|0;if(P|0?(a=P+12|0,P=f[a>>2]|0,f[a>>2]=P+-1,(P|0)==1):0)V$(p);f[O>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[L>>2]|0)>0){N=f[Q>>2]|0;Q=0;do{f[N+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[L>>2]|0))}L=f[S>>2]|0;if((L|0)!=(R|0))wL(L);L=f[H>>2]|0;if(L|0?(R=L+12|0,L=f[R>>2]|0,f[R>>2]=L+-1,(L|0)==1):0)V$(o);f[H>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[s>>2]|0)>0){G=f[J>>2]|0;J=0;do{f[G+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[s>>2]|0))}s=f[K>>2]|0;if((s|0)!=(F|0))wL(s);s=f[A>>2]|0;if(s|0?(F=s+12|0,s=f[F>>2]|0,f[F>>2]=s+-1,(s|0)==1):0)V$(m);f[A>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[w>>2]|0)>0){z=f[C>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[w>>2]|0))}w=f[D>>2]|0;if((w|0)==(y|0)){u=l;return}wL(w);u=l;return}function ePb(a){a=a|0;XOb(a);cYc(a);return}function fPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;gPb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function gPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0;g=u;u=u+544|0;i=g+488|0;j=g+432|0;k=g+376|0;l=g+24|0;m=g+12|0;o=g;p=f[a+16>>2]|0;q=f[a+12>>2]|0;r=+(1<<f[c+20>>2]|0);s=ALc(+n[c+8>>2]*.5/r)|0;t=f[c+24>>2]|0;v=f[q>>2]|0;w=v+(t*316|0)|0;f[i>>2]=f[w>>2];x=i+4|0;y=v+(t*316|0)+4|0;f[x>>2]=f[y>>2];z=i+8|0;f[z>>2]=f[v+(t*316|0)+8>>2];f[i+12>>2]=f[v+(t*316|0)+12>>2];A=i+16|0;f[A>>2]=f[v+(t*316|0)+16>>2];f[i+20>>2]=f[v+(t*316|0)+20>>2];f[i+24>>2]=f[v+(t*316|0)+24>>2];f[i+28>>2]=f[v+(t*316|0)+28>>2];f[i+32>>2]=f[v+(t*316|0)+32>>2];B=i+36|0;C=f[v+(t*316|0)+36>>2]|0;f[B>>2]=C;D=i+40|0;f[D>>2]=z;z=i+48|0;E=i+44|0;f[E>>2]=z;f[z>>2]=0;f[i+52>>2]=0;if(C|0){F=C+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[y>>2]|0)<3){y=f[v+(t*316|0)+44>>2]|0;v=f[E>>2]|0;f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2]}else{f[x>>2]=0;U$(i,w)}w=f[q>>2]|0;y=w+(t*316|0)+56|0;f[j>>2]=f[y>>2];v=j+4|0;F=w+(t*316|0)+60|0;C=f[F>>2]|0;f[v>>2]=C;G=j+8|0;f[G>>2]=f[w+(t*316|0)+64>>2];f[j+12>>2]=f[w+(t*316|0)+68>>2];H=j+16|0;f[H>>2]=f[w+(t*316|0)+72>>2];f[j+20>>2]=f[w+(t*316|0)+76>>2];f[j+24>>2]=f[w+(t*316|0)+80>>2];f[j+28>>2]=f[w+(t*316|0)+84>>2];f[j+32>>2]=f[w+(t*316|0)+88>>2];I=j+36|0;J=f[w+(t*316|0)+92>>2]|0;f[I>>2]=J;K=j+40|0;f[K>>2]=G;G=j+48|0;L=j+44|0;f[L>>2]=G;f[G>>2]=0;f[j+52>>2]=0;if(!J)N=C;else{C=J+12|0;f[C>>2]=(f[C>>2]|0)+1;N=f[F>>2]|0}if((N|0)<3){N=f[w+(t*316|0)+100>>2]|0;w=f[L>>2]|0;f[w>>2]=f[N>>2];f[w+4>>2]=f[N+4>>2]}else{f[v>>2]=0;U$(j,y)}y=f[q>>2]|0;q=y+(t*316|0)+112|0;f[k>>2]=f[q>>2];N=k+4|0;w=y+(t*316|0)+116|0;F=f[w>>2]|0;f[N>>2]=F;C=k+8|0;f[C>>2]=f[y+(t*316|0)+120>>2];J=k+12|0;f[J>>2]=f[y+(t*316|0)+124>>2];O=k+16|0;f[O>>2]=f[y+(t*316|0)+128>>2];f[k+20>>2]=f[y+(t*316|0)+132>>2];f[k+24>>2]=f[y+(t*316|0)+136>>2];f[k+28>>2]=f[y+(t*316|0)+140>>2];f[k+32>>2]=f[y+(t*316|0)+144>>2];P=k+36|0;Q=f[y+(t*316|0)+148>>2]|0;f[P>>2]=Q;R=k+40|0;f[R>>2]=C;S=k+48|0;T=k+44|0;f[T>>2]=S;f[S>>2]=0;f[k+52>>2]=0;if(!Q)U=F;else{F=Q+12|0;f[F>>2]=(f[F>>2]|0)+1;U=f[w>>2]|0}if((U|0)<3){U=f[y+(t*316|0)+156>>2]|0;t=f[T>>2]|0;f[t>>2]=f[U>>2];f[t+4>>2]=f[U+4>>2]}else{f[N>>2]=0;U$(k,q)}V=+n[c+4>>2]/r;W=+n[c>>2]/r;c=f[p+48>>2]|0;if((c|0)>=4){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=$Xc(32)|0;f[l>>2]=q;f[l+8>>2]=-2147483616;f[l+4>>2]=24;X=q;Z=464313;_=X+24|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));b[q+24>>0]=0;vM(-215,l,464703,463600,2127)}g1c(l|0,0,348)|0;q=f[p+52>>2]|0;if(q&1|0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=$Xc(32)|0;f[m>>2]=p;f[m+8>>2]=-2147483616;f[m+4>>2]=23;X=p;Z=464365;_=X+23|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));b[p+23>>0]=0;vM(-215,m,464703,463600,2131)}f[m>>2]=q;f[m+4>>2]=(((q<<1)+2|0)>>>0)/3|0;f[m+8>>2]=(q+1|0)>>>1;q=f[a+28>>2]|0;a:do if((q|0)>0){p=f[a+36>>2]|0;U=f[f[a+64>>2]>>2]|0;t=f[J>>2]|0;y=f[C>>2]|0;w=f[O>>2]|0;F=f[T>>2]|0;Q=f[A>>2]|0;$=f[E>>2]|0;aa=f[H>>2]|0;ba=f[L>>2]|0;ca=0;while(1){da=p+(Y(U,ca)|0)|0;ea=f[da>>2]|0;if(ea>>>0>=3)break;fa=f[m+(ea<<2)>>2]|0;if((fa|0)>0){ea=f[da+4>>2]|0;ga=f[da+8>>2]|0;da=ea+fa|0;ha=ga+fa|0;r=0.0;ia=0.0;fa=ea;ja=0.0;ea=c;while(1){ka=ALc(W+ +(Y(fa,s)|0))|0;if((ka|0)<(t|0)){la=ga;ma=ia;na=ja;oa=r;pa=ea;while(1){qa=ALc(V+ +(Y(la,s)|0))|0;b:do if((ka|qa|0)>-1&(qa|0)<(y|0)){ra=w+(Y(f[F>>2]|0,qa)|0)+(ka<<2)|0;sa=oa+ +n[ra>>2];if((pa|0)<=1){ta=sa;ua=ma;va=na;wa=pa;break}ra=Q+(Y(f[$>>2]|0,qa)|0)+(ka<<2)|0;xa=+n[ra>>2];ra=aa+(Y(f[ba>>2]|0,qa)|0)+(ka<<2)|0;ya=+n[ra>>2];switch(pa|0){case 2:{ta=sa;ua=ma+ +M(+(xa*xa+ya*ya));va=na;wa=2;break b;break}case 3:{ta=sa;ua=ma+xa;va=na+ya;wa=3;break b;break}default:{ta=sa;ua=ma;va=na;wa=pa;break b}}}else{ta=oa;ua=ma;va=na;wa=pa}while(0);la=la+1|0;if((la|0)>=(ha|0)){za=wa;Aa=va;Ba=ua;Ca=ta;break}else{ma=ua;na=va;oa=ta;pa=wa}}}else{za=ea;Aa=ja;Ba=ia;Ca=r}fa=fa+1|0;if((fa|0)>=(da|0)){Da=Ca;Ea=Ba;Fa=Aa;break}else{r=Ca;ia=Ba;ja=Aa;ea=za}}}else{Da=0.0;Ea=0.0;Fa=0.0}ea=l+((Y(ca,c)|0)<<2)|0;n[ea>>2]=Da;switch(c|0){case 2:{Ga=Ea;Ha=1;Ia=37;break}case 3:{n[ea+4>>2]=Ea;Ga=Fa;Ha=2;Ia=37;break}default:{}}if((Ia|0)==37){Ia=0;n[ea+(Ha<<2)>>2]=Ga}ca=ca+1|0;if((ca|0)>=(q|0))break a}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;ca=$Xc(32)|0;f[o>>2]=ca;f[o+8>>2]=-2147483616;f[o+4>>2]=31;X=ca;Z=464389;_=X+31|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));b[ca+31>>0]=0;vM(-215,o,464703,463600,2140)}while(0);q=f[a+92>>2]|0;Ha=a+84|0;if((((f[Ha>>2]|0)+7|0)>>>3|0)!=(e|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;a=$Xc(48)|0;f[o>>2]=a;f[o+8>>2]=-2147483600;f[o+4>>2]=43;X=a;Z=464421;_=X+43|0;do{b[X>>0]=b[Z>>0]|0;X=X+1|0;Z=Z+1|0}while((X|0)<(_|0));b[a+43>>0]=0;vM(-215,o,464703,463600,2189)}g1c(d|0,0,e|0)|0;e=f[Ha>>2]|0;if((e|0)>0){o=0;a=e;while(1){e=o<<1;if(+n[l+(f[q+(e<<2)>>2]<<2)>>2]>+n[l+(f[q+((e|1)<<2)>>2]<<2)>>2]){e=d+((o|0)/8|0)|0;b[e>>0]=h[e>>0]|0|1<<(o&7);Ja=f[Ha>>2]|0}else Ja=a;o=o+1|0;if((o|0)>=(Ja|0))break;else a=Ja}}Ja=f[P>>2]|0;if(Ja|0?(a=Ja+12|0,Ja=f[a>>2]|0,f[a>>2]=Ja+-1,(Ja|0)==1):0)V$(k);f[P>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[N>>2]|0)>0){O=f[R>>2]|0;R=0;do{f[O+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[N>>2]|0))}N=f[T>>2]|0;if((N|0)!=(S|0))wL(N);N=f[I>>2]|0;if(N|0?(S=N+12|0,N=f[S>>2]|0,f[S>>2]=N+-1,(N|0)==1):0)V$(j);f[I>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[v>>2]|0)>0){H=f[K>>2]|0;K=0;do{f[H+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[v>>2]|0))}v=f[L>>2]|0;if((v|0)!=(G|0))wL(v);v=f[B>>2]|0;if(v|0?(G=v+12|0,v=f[G>>2]|0,f[G>>2]=v+-1,(v|0)==1):0)V$(i);f[B>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[x>>2]|0)>0){A=f[D>>2]|0;D=0;do{f[A+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[x>>2]|0))}x=f[E>>2]|0;if((x|0)==(z|0)){u=g;return}wL(x);u=g;return}function hPb(a){a=a|0;cYc(a);return}function iPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;jPb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function jPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0;g=u;u=u+384|0;i=g+192|0;j=g+136|0;k=g+80|0;l=g+24|0;m=g+12|0;o=g;p=a+16|0;if((f[(f[p>>2]|0)+48>>2]|0)>=4){q=$Xc(48)|0;f[i>>2]=q;f[i+8>>2]=-2147483600;f[i+4>>2]=43;r=q;s=464784;t=r+43|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[q+43>>0]=0;vM(-215,i,464828,463600,1758)}q=f[a+12>>2]|0;v=+(1<<f[c+20>>2]|0);a=ALc(+n[c+8>>2]*.5/v)|0;w=f[c+24>>2]|0;x=f[q>>2]|0;y=x+(w*316|0)|0;f[j>>2]=f[y>>2];z=j+4|0;A=x+(w*316|0)+4|0;f[z>>2]=f[A>>2];B=j+8|0;f[B>>2]=f[x+(w*316|0)+8>>2];f[j+12>>2]=f[x+(w*316|0)+12>>2];C=j+16|0;f[C>>2]=f[x+(w*316|0)+16>>2];f[j+20>>2]=f[x+(w*316|0)+20>>2];f[j+24>>2]=f[x+(w*316|0)+24>>2];f[j+28>>2]=f[x+(w*316|0)+28>>2];f[j+32>>2]=f[x+(w*316|0)+32>>2];D=j+36|0;E=f[x+(w*316|0)+36>>2]|0;f[D>>2]=E;F=j+40|0;f[F>>2]=B;B=j+48|0;G=j+44|0;f[G>>2]=B;f[B>>2]=0;f[j+52>>2]=0;if(E|0){H=E+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[A>>2]|0)<3){A=f[x+(w*316|0)+44>>2]|0;x=f[G>>2]|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2]}else{f[z>>2]=0;U$(j,y)}y=f[q>>2]|0;A=y+(w*316|0)+56|0;f[k>>2]=f[A>>2];x=k+4|0;H=y+(w*316|0)+60|0;E=f[H>>2]|0;f[x>>2]=E;I=k+8|0;f[I>>2]=f[y+(w*316|0)+64>>2];f[k+12>>2]=f[y+(w*316|0)+68>>2];J=k+16|0;f[J>>2]=f[y+(w*316|0)+72>>2];f[k+20>>2]=f[y+(w*316|0)+76>>2];f[k+24>>2]=f[y+(w*316|0)+80>>2];f[k+28>>2]=f[y+(w*316|0)+84>>2];f[k+32>>2]=f[y+(w*316|0)+88>>2];K=k+36|0;L=f[y+(w*316|0)+92>>2]|0;f[K>>2]=L;M=k+40|0;f[M>>2]=I;I=k+48|0;N=k+44|0;f[N>>2]=I;f[I>>2]=0;f[k+52>>2]=0;if(!L)O=E;else{E=L+12|0;f[E>>2]=(f[E>>2]|0)+1;O=f[H>>2]|0}if((O|0)<3){O=f[y+(w*316|0)+100>>2]|0;y=f[N>>2]|0;f[y>>2]=f[O>>2];f[y+4>>2]=f[O+4>>2]}else{f[x>>2]=0;U$(k,A)}A=f[q>>2]|0;q=A+(w*316|0)+112|0;f[l>>2]=f[q>>2];O=l+4|0;y=A+(w*316|0)+116|0;H=f[y>>2]|0;f[O>>2]=H;E=l+8|0;f[E>>2]=f[A+(w*316|0)+120>>2];L=l+12|0;f[L>>2]=f[A+(w*316|0)+124>>2];P=l+16|0;f[P>>2]=f[A+(w*316|0)+128>>2];f[l+20>>2]=f[A+(w*316|0)+132>>2];f[l+24>>2]=f[A+(w*316|0)+136>>2];f[l+28>>2]=f[A+(w*316|0)+140>>2];f[l+32>>2]=f[A+(w*316|0)+144>>2];Q=l+36|0;R=f[A+(w*316|0)+148>>2]|0;f[Q>>2]=R;S=l+40|0;f[S>>2]=E;T=l+48|0;U=l+44|0;f[U>>2]=T;f[T>>2]=0;f[l+52>>2]=0;if(!R)V=H;else{H=R+12|0;f[H>>2]=(f[H>>2]|0)+1;V=f[y>>2]|0}if((V|0)<3){V=f[A+(w*316|0)+156>>2]|0;w=f[U>>2]|0;f[w>>2]=f[V>>2];f[w+4>>2]=f[V+4>>2]}else{f[O>>2]=0;U$(l,q)}W=+n[c+4>>2]/v;X=+n[c>>2]/v;c=f[(f[p>>2]|0)+52>>2]|0;if(c&1|0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=$Xc(32)|0;f[m>>2]=p;f[m+8>>2]=-2147483616;f[m+4>>2]=23;r=p;s=464365;t=r+23|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[p+23>>0]=0;vM(-215,m,464828,463600,1773)}f[m>>2]=c;f[m+4>>2]=(((c<<1)+2|0)>>>0)/3|0;f[m+8>>2]=(c+1|0)>>>1;g1c(d|0,0,e|0)|0;p=0-c|0;q=(c|0)>(p|0);V=f[P>>2]|0;w=f[U>>2]|0;A=f[C>>2]|0;y=f[G>>2]|0;H=f[J>>2]|0;R=f[N>>2]|0;Z=0;_=0;$=c;aa=15;ba=9;ca=5;da=4;while(1){if(q){ea=($|0)>0;fa=f[E>>2]|0;ga=f[L>>2]|0;ha=0;ia=p;while(1){ja=p;ka=ha;do{if(ea){v=0.0;la=0.0;ma=0.0;na=0;oa=0;while(1){pa=ALc(X+ +(Y(oa+ia|0,a)|0))|0;if((pa|0)>-1&(pa|0)<(ga|0)){qa=0;ra=v;sa=la;ta=ma;ua=na;while(1){va=ALc(W+ +(Y(qa+ja|0,a)|0))|0;if((va|0)>-1&(va|0)<(fa|0)){wa=V+(Y(f[w>>2]|0,va)|0)+(pa<<2)|0;xa=A+(Y(f[y>>2]|0,va)|0)+(pa<<2)|0;ya=H+(Y(f[R>>2]|0,va)|0)+(pa<<2)|0;za=ra+ +n[wa>>2];Aa=sa+ +n[xa>>2];Ba=ta+ +n[ya>>2];Ca=ua+1|0}else{za=ra;Aa=sa;Ba=ta;Ca=ua}qa=qa+1|0;if((qa|0)==($|0)){Da=za;Ea=Aa;Fa=Ba;Ga=Ca;break}else{ra=za;sa=Aa;ta=Ba;ua=Ca}}}else{Da=v;Ea=la;Fa=ma;Ga=na}oa=oa+1|0;if((oa|0)==($|0))break;else{v=Da;la=Ea;ma=Fa;na=Ga}}if((Ga|0)>0){ma=1.0/+(Ga|0);Ha=ma*Da;Ia=Ea*ma;Ja=Fa*ma}else{Ha=Da;Ia=Ea;Ja=Fa}}else{Ha=0.0;Ia=0.0;Ja=0.0}na=i+(ka*3<<2)|0;n[na>>2]=Ha;n[na+4>>2]=Ia;n[na+8>>2]=Ja;ka=ka+1|0;ja=ja+$|0}while((ja|0)<(c|0));ia=ia+$|0;if((ia|0)>=(c|0))break;else ha=ka}}ha=_+2|0;ia=Y(ha,ha)|0;a:do if(!ia)Ka=Z;else{ha=0;fa=Z;ga=ba;while(1){ea=ha;ha=ha+1|0;ja=(ha|0)<(ia|0);if(!ja){Ka=fa;break a}na=i+(ea*3<<2)|0;ma=+n[na>>2];la=+n[na+4>>2];v=+n[na+8>>2];na=ha;ea=fa;while(1){oa=i+(na*3<<2)|0;if(ma>+n[oa>>2]){ua=d+((ea|0)/8|0)|0;b[ua>>0]=h[ua>>0]|0|1<<(ea&7)}ua=ea+1|0;if(la>+n[oa+4>>2]){qa=d+((ua|0)/8|0)|0;b[qa>>0]=h[qa>>0]|0|1<<(ua&7)}ua=ea+2|0;if(v>+n[oa+8>>2]){oa=d+((ua|0)/8|0)|0;b[oa>>0]=h[oa>>0]|0|1<<(ua&7)}na=na+1|0;if((na|0)==(da|0))break;else ea=ea+3|0}ea=fa+ga|0;if(!ja){Ka=ea;break}else{fa=ea;ga=ga+-3|0}}}while(0);ia=_+1|0;if((ia|0)==3)break;ga=da+ca|0;fa=ba+aa|0;Z=Ka;_=ia;$=f[m+(ia<<2)>>2]|0;aa=aa+6|0;ba=fa;ca=ca+2|0;da=ga}if((Ka|0)>(e<<3|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;da=$Xc(32)|0;f[o>>2]=da;f[o+8>>2]=-2147483616;f[o+4>>2]=22;r=da;s=464861;t=r+22|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[da+22>>0]=0;vM(-215,o,464828,463600,1849)}if(((Ka+7|0)>>>3|0)!=(e|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;e=$Xc(32)|0;f[o>>2]=e;f[o+8>>2]=-2147483616;f[o+4>>2]=30;r=e;s=464884;t=r+30|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[e+30>>0]=0;vM(-215,o,464828,463600,1850)}o=f[Q>>2]|0;if(o|0?(e=o+12|0,o=f[e>>2]|0,f[e>>2]=o+-1,(o|0)==1):0)V$(l);f[Q>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[O>>2]|0)>0){P=f[S>>2]|0;S=0;do{f[P+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[O>>2]|0))}O=f[U>>2]|0;if((O|0)!=(T|0))wL(O);O=f[K>>2]|0;if(O|0?(T=O+12|0,O=f[T>>2]|0,f[T>>2]=O+-1,(O|0)==1):0)V$(k);f[K>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[x>>2]|0)>0){J=f[M>>2]|0;M=0;do{f[J+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[x>>2]|0))}x=f[N>>2]|0;if((x|0)!=(I|0))wL(x);x=f[D>>2]|0;if(x|0?(I=x+12|0,x=f[I>>2]|0,f[I>>2]=x+-1,(x|0)==1):0)V$(j);f[D>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[z>>2]|0)>0){C=f[F>>2]|0;F=0;do{f[C+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[z>>2]|0))}z=f[G>>2]|0;if((z|0)==(B|0)){u=g;return}wL(z);u=g;return}function kPb(a){a=a|0;cYc(a);return}function lPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;mPb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function mPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0,X=0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;g=u;u=u+112|0;h=g+56|0;i=g;if((e|0)!=64){e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=18;j=e;k=464959;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[e+18>>0]=0;vM(-215,h,464978,463600,1620)}e=f[a+12>>2]|0;m=+(1<<f[c+20>>2]|0);a=ALc(+n[c+8>>2]*.5/m)|0;o=+n[c+12>>2]*.01745329238474369;k=f[c+24>>2]|0;j=f[e>>2]|0;l=j+(k*316|0)|0;f[h>>2]=f[l>>2];p=h+4|0;q=j+(k*316|0)+4|0;f[p>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[j+(k*316|0)+8>>2];s=h+12|0;f[s>>2]=f[j+(k*316|0)+12>>2];t=h+16|0;f[t>>2]=f[j+(k*316|0)+16>>2];f[h+20>>2]=f[j+(k*316|0)+20>>2];f[h+24>>2]=f[j+(k*316|0)+24>>2];f[h+28>>2]=f[j+(k*316|0)+28>>2];f[h+32>>2]=f[j+(k*316|0)+32>>2];v=h+36|0;w=f[j+(k*316|0)+36>>2]|0;f[v>>2]=w;x=h+40|0;f[x>>2]=r;y=h+48|0;z=h+44|0;f[z>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(w|0){A=w+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[q>>2]|0)<3){q=f[j+(k*316|0)+44>>2]|0;j=f[z>>2]|0;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2]}else{f[p>>2]=0;U$(h,l)}l=f[e>>2]|0;e=l+(k*316|0)+56|0;f[i>>2]=f[e>>2];q=i+4|0;j=l+(k*316|0)+60|0;A=f[j>>2]|0;f[q>>2]=A;w=i+8|0;f[w>>2]=f[l+(k*316|0)+64>>2];f[i+12>>2]=f[l+(k*316|0)+68>>2];B=i+16|0;f[B>>2]=f[l+(k*316|0)+72>>2];f[i+20>>2]=f[l+(k*316|0)+76>>2];f[i+24>>2]=f[l+(k*316|0)+80>>2];f[i+28>>2]=f[l+(k*316|0)+84>>2];f[i+32>>2]=f[l+(k*316|0)+88>>2];C=i+36|0;D=f[l+(k*316|0)+92>>2]|0;f[C>>2]=D;E=i+40|0;f[E>>2]=w;w=i+48|0;F=i+44|0;f[F>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(!D)G=A;else{A=D+12|0;f[A>>2]=(f[A>>2]|0)+1;G=f[j>>2]|0}if((G|0)<3){G=f[l+(k*316|0)+100>>2]|0;k=f[F>>2]|0;f[k>>2]=f[G>>2];f[k+4>>2]=f[G+4>>2]}else{f[q>>2]=0;U$(i,e)}H=+n[c+4>>2]/m;I=+n[c>>2]/m;m=+O(+o);J=+P(+o);c=0-a|0;o=+(a|0)*2.5;K=o*(o*2.0);e=f[t>>2]|0;G=f[z>>2]|0;k=f[B>>2]|0;l=f[F>>2]|0;j=f[s>>2]|0;s=f[r>>2]|0;o=-.5;r=0;A=-8;N=0.0;while(1){D=A+-4|0;o=o+1.0;Q=+(Y(A+1|0,a)|0);R=m*Q;S=J*Q;Q=o+-2.0;T=Q*Q;U=A+4|0;Q=-.5;W=-8;X=r;Z=N;while(1){_=W+-4|0;$=I+(R+J*+(Y(a,~W)|0));aa=H+(S+m*+(Y(W+1|0,a)|0));ba=W+4|0;ca=D;da=0.0;ea=0.0;fa=0.0;ga=0.0;while(1){ha=+(Y(ca,a)|0);ia=J*ha;ja=m*ha;ka=_;ha=da;la=ea;ma=fa;na=ga;while(1){oa=H+(ia+m*+(Y(ka,a)|0));pa=I+(ja+J*+(Y(ka,c)|0));qa=$-pa;ra=aa-oa;sa=+V(+(-(qa*qa+ra*ra)/K));ta=~~oa;ua=ta-(+(ta|0)>oa&1)|0;ta=~~pa;va=ta-(+(ta|0)>pa&1)|0;ta=ua+1|0;wa=va+1|0;if((va|ua|0)>-1&(wa|0)<(j|0)&(ta|0)<(s|0)){ra=pa-+(va|0);pa=oa-+(ua|0);xa=f[G>>2]|0;ya=e+(Y(xa,ua)|0)|0;za=e+(Y(xa,ta)|0)|0;oa=1.0-ra;qa=1.0-pa;Aa=oa*qa;Ba=ra*qa;qa=pa*oa;oa=ra*pa;pa=Aa*+n[ya+(va<<2)>>2]+Ba*+n[ya+(wa<<2)>>2]+qa*+n[za+(va<<2)>>2]+oa*+n[za+(wa<<2)>>2];za=f[l>>2]|0;ya=k+(Y(za,ua)|0)|0;ua=k+(Y(za,ta)|0)|0;ra=Aa*+n[ya+(va<<2)>>2]+Ba*+n[ya+(wa<<2)>>2]+qa*+n[ua+(va<<2)>>2]+oa*+n[ua+(wa<<2)>>2];oa=sa*(m*pa+J*ra);qa=sa*(m*ra-J*pa);Ca=ha+qa;Da=la+ +L(+oa);Ea=ma+ +L(+qa);Fa=na+oa}else{Ca=ha;Da=la;Ea=ma;Fa=na}if((ka|0)<(ba|0)){ka=ka+1|0;ha=Ca;la=Da;ma=Ea;na=Fa}else break}if((ca|0)<(U|0)){ca=ca+1|0;da=Ca;ea=Da;fa=Ea;ga=Fa}else break}Q=Q+1.0;ga=Q+-2.0;fa=+V(+(-(T+ga*ga)/4.5));n[d+(X<<2)>>2]=Ca*fa;n[d+((X|1)<<2)>>2]=Fa*fa;n[d+((X|2)<<2)>>2]=Ea*fa;n[d+((X|3)<<2)>>2]=Da*fa;Z=Z+fa*((Da*Da+(Ea*Ea+(Fa*Fa+Ca*Ca)))*fa);W=W+5|0;if((W|0)>=12)break;else X=X+4|0}A=A+5|0;if((A|0)>=12)break;else{r=r+16|0;N=Z}}N=1.0/+M(+Z);r=0;do{A=d+(r<<2)|0;n[A>>2]=N*+n[A>>2];r=r+1|0}while((r|0)!=64);r=f[C>>2]|0;if(r|0?(d=r+12|0,r=f[d>>2]|0,f[d>>2]=r+-1,(r|0)==1):0)V$(i);f[C>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[q>>2]|0)>0){B=f[E>>2]|0;E=0;do{f[B+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[q>>2]|0))}q=f[F>>2]|0;if((q|0)!=(w|0))wL(q);q=f[v>>2]|0;if(q|0?(w=q+12|0,q=f[w>>2]|0,f[w>>2]=q+-1,(q|0)==1):0)V$(h);f[v>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[p>>2]|0)>0){t=f[x>>2]|0;x=0;do{f[t+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[p>>2]|0))}p=f[z>>2]|0;if((p|0)==(y|0)){u=g;return}wL(p);u=g;return}function nPb(a){a=a|0;cYc(a);return}function oPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[b>>2]|0;d=b+4|0;if((c|0)>=(f[d>>2]|0))return;b=a+4|0;e=a+8|0;g=c;do{c=f[e>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,g)|0)|0;pPb(a,(f[f[b>>2]>>2]|0)+(g*28|0)|0,h,f[c+12>>2]|0);g=g+1|0}while((g|0)<(f[d>>2]|0));return}function pPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0;g=u;u=u+112|0;h=g+56|0;i=g;if((e|0)!=64){e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=18;j=e;k=464959;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[e+18>>0]=0;vM(-215,h,465037,463600,1487)}e=f[a+12>>2]|0;m=+(1<<f[c+20>>2]|0);a=ALc(+n[c+8>>2]*.5/m)|0;k=f[c+24>>2]|0;j=f[e>>2]|0;l=j+(k*316|0)|0;f[h>>2]=f[l>>2];o=h+4|0;p=j+(k*316|0)+4|0;f[o>>2]=f[p>>2];q=h+8|0;f[q>>2]=f[j+(k*316|0)+8>>2];r=h+12|0;f[r>>2]=f[j+(k*316|0)+12>>2];s=h+16|0;f[s>>2]=f[j+(k*316|0)+16>>2];f[h+20>>2]=f[j+(k*316|0)+20>>2];f[h+24>>2]=f[j+(k*316|0)+24>>2];f[h+28>>2]=f[j+(k*316|0)+28>>2];f[h+32>>2]=f[j+(k*316|0)+32>>2];t=h+36|0;v=f[j+(k*316|0)+36>>2]|0;f[t>>2]=v;w=h+40|0;f[w>>2]=q;x=h+48|0;y=h+44|0;f[y>>2]=x;f[x>>2]=0;f[h+52>>2]=0;if(v|0){z=v+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[p>>2]|0)<3){p=f[j+(k*316|0)+44>>2]|0;j=f[y>>2]|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2]}else{f[o>>2]=0;U$(h,l)}l=f[e>>2]|0;e=l+(k*316|0)+56|0;f[i>>2]=f[e>>2];p=i+4|0;j=l+(k*316|0)+60|0;z=f[j>>2]|0;f[p>>2]=z;v=i+8|0;f[v>>2]=f[l+(k*316|0)+64>>2];f[i+12>>2]=f[l+(k*316|0)+68>>2];A=i+16|0;f[A>>2]=f[l+(k*316|0)+72>>2];f[i+20>>2]=f[l+(k*316|0)+76>>2];f[i+24>>2]=f[l+(k*316|0)+80>>2];f[i+28>>2]=f[l+(k*316|0)+84>>2];f[i+32>>2]=f[l+(k*316|0)+88>>2];B=i+36|0;C=f[l+(k*316|0)+92>>2]|0;f[B>>2]=C;D=i+40|0;f[D>>2]=v;v=i+48|0;E=i+44|0;f[E>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(!C)F=z;else{z=C+12|0;f[z>>2]=(f[z>>2]|0)+1;F=f[j>>2]|0}if((F|0)<3){F=f[l+(k*316|0)+100>>2]|0;k=f[E>>2]|0;f[k>>2]=f[F>>2];f[k+4>>2]=f[F+4>>2]}else{f[p>>2]=0;U$(i,e)}G=+n[c+4>>2]/m;H=+n[c>>2]/m;m=+(a|0)*2.5;I=m*(m*2.0);c=f[s>>2]|0;e=f[y>>2]|0;F=f[A>>2]|0;k=f[E>>2]|0;l=f[r>>2]|0;r=f[q>>2]|0;m=-.5;q=0;j=-8;J=0.0;while(1){z=j+-4|0;m=m+1.0;K=G+ +(Y(j+1|0,a)|0);N=m+-2.0;O=N*N;C=j+4|0;N=-.5;P=-8;Q=q;R=J;while(1){S=P+-4|0;T=H+ +(Y(P+1|0,a)|0);P=P+5|0;U=z;W=0.0;X=0.0;Z=0.0;_=0.0;while(1){$=G+ +(Y(U,a)|0);aa=K-$;ba=aa*aa;ca=~~$;da=ca-(+(ca|0)>$&1)|0;ca=da+1|0;aa=$-+(da|0);$=1.0-aa;if((ca|0)<(r|0)){ea=S;fa=W;ga=X;ha=Z;ia=_;while(1){ja=H+ +(Y(ea,a)|0);ka=T-ja;la=+V(+(-(ba+ka*ka)/I));ma=~~ja;na=ma-(+(ma|0)>ja&1)|0;ma=na+1|0;if((na|da|0)>-1&(ma|0)<(l|0)){ka=ja-+(na|0);oa=f[e>>2]|0;pa=c+(Y(oa,da)|0)|0;qa=c+(Y(oa,ca)|0)|0;ja=1.0-ka;ra=$*ja;sa=$*ka;ta=aa*ja;ja=aa*ka;oa=f[k>>2]|0;ua=F+(Y(oa,da)|0)|0;va=F+(Y(oa,ca)|0)|0;ka=la*(ra*+n[pa+(na<<2)>>2]+sa*+n[pa+(ma<<2)>>2]+ta*+n[qa+(na<<2)>>2]+ja*+n[qa+(ma<<2)>>2]);wa=la*(ra*+n[ua+(na<<2)>>2]+sa*+n[ua+(ma<<2)>>2]+ta*+n[va+(na<<2)>>2]+ja*+n[va+(ma<<2)>>2]);xa=fa+ka;ya=ga+ +L(+wa);za=ha+ +L(+ka);Aa=ia+wa}else{xa=fa;ya=ga;za=ha;Aa=ia}ea=ea+1|0;if((ea|0)>=(P|0)){Ba=xa;Ca=ya;Da=za;Ea=Aa;break}else{fa=xa;ga=ya;ha=za;ia=Aa}}}else{Ba=W;Ca=X;Da=Z;Ea=_}if((U|0)<(C|0)){U=U+1|0;W=Ba;X=Ca;Z=Da;_=Ea}else break}N=N+1.0;_=N+-2.0;Z=+V(+(-(O+_*_)/4.5));n[d+(Q<<2)>>2]=Ba*Z;n[d+((Q|1)<<2)>>2]=Ea*Z;n[d+((Q|2)<<2)>>2]=Da*Z;n[d+((Q|3)<<2)>>2]=Ca*Z;R=R+Z*((Ca*Ca+(Da*Da+(Ea*Ea+Ba*Ba)))*Z);if((P|0)>=12)break;else Q=Q+4|0}j=j+5|0;if((j|0)>=12)break;else{q=q+16|0;J=R}}J=1.0/+M(+R);q=0;do{j=d+(q<<2)|0;n[j>>2]=J*+n[j>>2];q=q+1|0}while((q|0)!=64);q=f[B>>2]|0;if(q|0?(d=q+12|0,q=f[d>>2]|0,f[d>>2]=q+-1,(q|0)==1):0)V$(i);f[B>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[p>>2]|0)>0){A=f[D>>2]|0;D=0;do{f[A+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[p>>2]|0))}p=f[E>>2]|0;if((p|0)!=(v|0))wL(p);p=f[t>>2]|0;if(p|0?(v=p+12|0,p=f[v>>2]|0,f[v>>2]=p+-1,(p|0)==1):0)V$(h);f[t>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[o>>2]|0)>0){s=f[w>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[o>>2]|0))}o=f[y>>2]|0;if((o|0)==(x|0)){u=g;return}wL(o);u=g;return}function qPb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0.0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;if(!(+(c|0)<e)?!((d|0)==0|((c|0)==0|+(d|0)<e)):0)k=0;else{l=((e+-.800000011920929)/.30000001192092896+1.0)*2.0;d=~~l;k=(+(d|0)<l&1)+d|0}d=(k&1^1)+k|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=d;f[j+4>>2]=d;l=e;Jqa(h,i,j,l,l,1);u=g;return}function rPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0.0;e=u;u=u+208|0;g=e+144|0;h=e+152|0;i=e+88|0;j=e+32|0;k=e+16|0;l=e;cS(g,a,-1);wS(c,g,dS(a,-1)|0,-1,0,0);do if((eS(a)|0)==65536){g=f[a+4>>2]|0;f[h>>2]=f[g>>2];m=h+4|0;o=g+4|0;f[m>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];q=f[g+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[g+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;U$(h,g);break}}else bS(h,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[i>>2]=f[a>>2];g=i+4|0;m=a+4|0;f[g>>2]=f[m>>2];o=i+8|0;f[o>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];p=f[a+36>>2]|0;f[i+36>>2]=p;f[i+40>>2]=o;o=i+48|0;r=i+44|0;f[r>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[a+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[g>>2]=0;U$(i,a);break}}else bS(i,b,-1);while(0);do if((eS(c)|0)==65536){b=f[c+4>>2]|0;f[j>>2]=f[b>>2];a=j+4|0;g=b+4|0;f[a>>2]=f[g>>2];m=j+8|0;f[m>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];f[j+16>>2]=f[b+16>>2];f[j+20>>2]=f[b+20>>2];f[j+24>>2]=f[b+24>>2];f[j+28>>2]=f[b+28>>2];f[j+32>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=m;m=j+48|0;r=j+44|0;f[r>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){g=f[b+44>>2]|0;m=f[r>>2]|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];break}else{f[a>>2]=0;U$(j,b);break}}else bS(j,c,-1);while(0);c=h+40|0;b=f[c>>2]|0;a=f[b+4>>2]|0;g=f[b>>2]|0;s=1.0/(d*d);if((g|0)>0?(b=f[h+16>>2]|0,m=f[f[h+44>>2]>>2]|0,r=f[i+16>>2]|0,o=f[f[i+44>>2]>>2]|0,p=f[j+16>>2]|0,q=f[f[j+44>>2]>>2]|0,(a|0)>0):0){t=0;do{v=b+(Y(m,t)|0)|0;w=r+(Y(o,t)|0)|0;x=p+(Y(q,t)|0)|0;y=0;do{d=+n[v+(y<<2)>>2];z=+n[w+(y<<2)>>2];n[x+(y<<2)>>2]=-(s*(d*d+z*z));y=y+1|0}while((y|0)!=(a|0));t=t+1|0}while((t|0)!=(g|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;OL(k,l);l=j+36|0;k=f[l>>2]|0;if(k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)V$(j);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[j+40>>2]|0;g=0;do{f[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(g=j+12|0,j=f[g>>2]|0,f[g>>2]=j+-1,(j|0)==1):0)V$(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;g=0;do{f[k+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))wL(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)V$(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[c>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return}wL(i);u=e;return}function sPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0.0;e=u;u=u+192|0;g=e+176|0;h=e+112|0;i=e+120|0;j=e+56|0;k=e;cS(h,a,-1);wS(c,h,dS(a,-1)|0,-1,0,0);do if((eS(a)|0)==65536){h=f[a+4>>2]|0;f[i>>2]=f[h>>2];l=i+4|0;m=h+4|0;f[l>>2]=f[m>>2];o=i+8|0;f[o>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[i+16>>2]=f[h+16>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[i+32>>2]=f[h+32>>2];p=f[h+36>>2]|0;f[i+36>>2]=p;f[i+40>>2]=o;o=i+48|0;q=i+44|0;f[q>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[h+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;U$(i,h);break}}else bS(i,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[j>>2]=f[a>>2];h=j+4|0;l=a+4|0;f[h>>2]=f[l>>2];m=j+8|0;f[m>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];o=f[a+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=m;m=j+48|0;q=j+44|0;f[q>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[h>>2]=0;U$(j,a);break}}else bS(j,b,-1);while(0);do if((eS(c)|0)==65536){b=f[c+4>>2]|0;f[k>>2]=f[b>>2];a=k+4|0;h=b+4|0;f[a>>2]=f[h>>2];l=k+8|0;f[l>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];f[k+32>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[k+36>>2]=m;f[k+40>>2]=l;l=k+48|0;q=k+44|0;f[q>>2]=l;f[l>>2]=0;f[k+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[h>>2]|0)<3){h=f[b+44>>2]|0;l=f[q>>2]|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];r=a;break}else{f[a>>2]=0;U$(k,b);r=a;break}}else{bS(k,c,-1);r=k+4|0}while(0);c=i+40|0;a=f[c>>2]|0;b=f[a+4>>2]|0;h=f[a>>2]|0;a=f[i>>2]&4095;if(!(((((f[r>>2]|0)<3?(f[k+8>>2]|0)==(h|0):0)?(f[k+12>>2]|0)==(b|0):0)?(f[k>>2]&4095|0)==(a|0):0)?(f[k+16>>2]|0)!=0:0)){f[g>>2]=h;f[g+4>>2]=b;S$(k,2,g,a)}s=1.0/(d*d);if((h|0)>0?(a=f[i+16>>2]|0,g=f[f[i+44>>2]>>2]|0,l=f[j+16>>2]|0,q=f[f[j+44>>2]>>2]|0,m=f[k+16>>2]|0,o=f[f[k+44>>2]>>2]|0,(b|0)>0):0){p=0;do{t=a+(Y(g,p)|0)|0;v=l+(Y(q,p)|0)|0;w=m+(Y(o,p)|0)|0;x=0;do{d=+n[t+(x<<2)>>2];y=+n[v+(x<<2)>>2];n[w+(x<<2)>>2]=1.0/(s*(d*d+y*y)+1.0);x=x+1|0}while((x|0)!=(b|0));p=p+1|0}while((p|0)!=(h|0))}h=k+36|0;p=f[h>>2]|0;if(p|0?(b=p+12|0,p=f[b>>2]|0,f[b>>2]=p+-1,(p|0)==1):0)V$(k);f[h>>2]=0;h=k+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[r>>2]|0)>0){h=f[k+40>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[r>>2]|0))}r=f[k+44>>2]|0;if((r|0)!=(k+48|0))wL(r);r=j+36|0;k=f[r>>2]|0;if(k|0?(p=k+12|0,k=f[p>>2]|0,f[p>>2]=k+-1,(k|0)==1):0)V$(j);f[r>>2]=0;r=j+16|0;k=j+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[k>>2]|0)>0){r=f[j+40>>2]|0;p=0;do{f[r+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)V$(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[c>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=e;return}wL(j);u=e;return}function tPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0;e=u;u=u+432|0;g=e+368|0;h=e+376|0;i=e+312|0;j=e+256|0;k=e+32|0;l=e;cS(g,a,-1);wS(c,g,dS(a,-1)|0,-1,0,0);do if((eS(a)|0)==65536){g=f[a+4>>2]|0;f[h>>2]=f[g>>2];m=h+4|0;o=g+4|0;f[m>>2]=f[o>>2];q=h+8|0;f[q>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];r=f[g+36>>2]|0;f[h+36>>2]=r;f[h+40>>2]=q;q=h+48|0;s=h+44|0;f[s>>2]=q;f[q>>2]=0;f[h+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[o>>2]|0)<3){o=f[g+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[o>>2];f[q+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;U$(h,g);break}}else bS(h,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[i>>2]=f[a>>2];g=i+4|0;m=a+4|0;f[g>>2]=f[m>>2];o=i+8|0;f[o>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=o;o=i+48|0;s=i+44|0;f[s>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(q|0){o=q+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[a+44>>2]|0;o=f[s>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[g>>2]=0;U$(i,a);break}}else bS(i,b,-1);while(0);do if((eS(c)|0)==65536){b=f[c+4>>2]|0;f[j>>2]=f[b>>2];a=j+4|0;g=b+4|0;f[a>>2]=f[g>>2];m=j+8|0;f[m>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];f[j+16>>2]=f[b+16>>2];f[j+20>>2]=f[b+20>>2];f[j+24>>2]=f[b+24>>2];f[j+28>>2]=f[b+28>>2];f[j+32>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+36>>2]=o;f[j+40>>2]=m;m=j+48|0;s=j+44|0;f[s>>2]=m;f[m>>2]=0;f[j+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){g=f[b+44>>2]|0;m=f[s>>2]|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];break}else{f[a>>2]=0;U$(j,b);break}}else bS(j,c,-1);while(0);c=h+40|0;b=f[c>>2]|0;a=f[b+4>>2]|0;g=f[b>>2]|0;t=1.0/(d*d);if((g|0)>0?(b=f[h+16>>2]|0,m=f[f[h+44>>2]>>2]|0,s=f[i+16>>2]|0,o=f[f[i+44>>2]>>2]|0,q=f[j+16>>2]|0,r=f[f[j+44>>2]>>2]|0,(a|0)>0):0){v=0;do{w=b+(Y(m,v)|0)|0;x=s+(Y(o,v)|0)|0;y=q+(Y(r,v)|0)|0;z=0;do{d=+n[w+(z<<2)>>2];A=+n[x+(z<<2)>>2];B=t*(d*d+A*A);n[y+(z<<2)>>2]=-3.315000057220459/(B*(B*(B*B)));z=z+1|0}while((z|0)!=(a|0));v=v+1|0}while((v|0)!=(g|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=j;g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;OL(k,l);p[l>>3]=1.0;g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;X_(k,l,j);l=f[k>>2]|0;ei[f[(f[l>>2]|0)+12>>2]&511](l,k,j,-1);Zj(k);k=j+36|0;l=f[k>>2]|0;if(l|0?(g=l+12|0,l=f[g>>2]|0,f[g>>2]=l+-1,(l|0)==1):0)V$(j);f[k>>2]=0;k=j+16|0;l=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[j+40>>2]|0;g=0;do{f[k+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))wL(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(g=j+12|0,j=f[g>>2]|0,f[g>>2]=j+-1,(j|0)==1):0)V$(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[i+40>>2]|0;g=0;do{f[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))wL(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)V$(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[c>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return}wL(i);u=e;return}function uPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;e=u;u=u+176|0;g=e+112|0;h=e+120|0;i=e+56|0;j=e;cS(g,a,-1);wS(c,g,dS(a,-1)|0,-1,0,0);do if((eS(a)|0)==65536){g=f[a+4>>2]|0;f[h>>2]=f[g>>2];k=h+4|0;l=g+4|0;f[k>>2]=f[l>>2];m=h+8|0;f[m>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];o=f[g+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[g+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;U$(h,g);break}}else bS(h,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[i>>2]=f[a>>2];g=i+4|0;k=a+4|0;f[g>>2]=f[k>>2];l=i+8|0;f[l>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];m=f[a+36>>2]|0;f[i+36>>2]=m;f[i+40>>2]=l;l=i+48|0;p=i+44|0;f[p>>2]=l;f[l>>2]=0;f[i+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+44>>2]|0;l=f[p>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[g>>2]=0;U$(i,a);break}}else bS(i,b,-1);while(0);do if((eS(c)|0)==65536){b=f[c+4>>2]|0;f[j>>2]=f[b>>2];a=j+4|0;g=b+4|0;f[a>>2]=f[g>>2];k=j+8|0;f[k>>2]=f[b+8>>2];f[j+12>>2]=f[b+12>>2];f[j+16>>2]=f[b+16>>2];f[j+20>>2]=f[b+20>>2];f[j+24>>2]=f[b+24>>2];f[j+28>>2]=f[b+28>>2];f[j+32>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[j+36>>2]=l;f[j+40>>2]=k;k=j+48|0;p=j+44|0;f[p>>2]=k;f[k>>2]=0;f[j+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[g>>2]|0)<3){g=f[b+44>>2]|0;k=f[p>>2]|0;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];break}else{f[a>>2]=0;U$(j,b);break}}else bS(j,c,-1);while(0);c=h+40|0;b=f[c>>2]|0;a=f[b+4>>2]|0;g=f[b>>2]|0;q=1.0/(d*d);if((g|0)>0?(b=f[h+16>>2]|0,k=f[f[h+44>>2]>>2]|0,p=f[i+16>>2]|0,l=f[f[i+44>>2]>>2]|0,m=f[j+16>>2]|0,o=f[f[j+44>>2]>>2]|0,(a|0)>0):0){r=0;do{s=b+(Y(k,r)|0)|0;t=p+(Y(l,r)|0)|0;v=m+(Y(o,r)|0)|0;w=0;do{d=+n[s+(w<<2)>>2];x=+n[t+(w<<2)>>2];y=1.0/+M(+(q*(d*d+x*x)+1.0));n[v+(w<<2)>>2]=y;w=w+1|0}while((w|0)!=(a|0));r=r+1|0}while((r|0)!=(g|0))}g=j+36|0;r=f[g>>2]|0;if(r|0?(a=r+12|0,r=f[a>>2]|0,f[a>>2]=r+-1,(r|0)==1):0)V$(j);f[g>>2]=0;g=j+16|0;r=j+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){g=f[j+40>>2]|0;a=0;do{f[g+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[r>>2]|0))}r=f[j+44>>2]|0;if((r|0)!=(j+48|0))wL(r);r=i+36|0;j=f[r>>2]|0;if(j|0?(a=j+12|0,j=f[a>>2]|0,f[a>>2]=j+-1,(j|0)==1):0)V$(i);f[r>>2]=0;r=i+16|0;j=i+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[i+40>>2]|0;a=0;do{f[r+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))wL(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(a=i+12|0,i=f[a>>2]|0,f[a>>2]=i+-1,(i|0)==1):0)V$(h);f[j>>2]=0;j=h+16|0;i=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[c>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=e;return}wL(i);u=e;return}function vPb(a,b,c,d,e,g){a=a|0;b=+b;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,L=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0,ea=0;h=u;u=u+896|0;i=h+880|0;j=h+864|0;k=h+856|0;l=h+840|0;m=h+784|0;o=h+448|0;p=h+728|0;q=h+224|0;r=h+672|0;s=h;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;do if(d|0)if(d>>>0>1073741823)kWc(l);else{v=d<<2;w=$Xc(v)|0;f[l>>2]=w;x=w+(d<<2)|0;f[l+8>>2]=x;g1c(w|0,0,v|0)|0;f[t>>2]=x;break}while(0);x=a+8|0;v=a+12|0;p$(o,f[x>>2]|0,f[v>>2]|0,5);f[m>>2]=1124007936;w=m+4|0;y=m+8|0;z=m+40|0;A=w;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[z>>2]=y;C=m+48|0;D=m+44|0;f[D>>2]=C;f[C>>2]=0;f[m+52>>2]=0;E=f[o>>2]|0;ei[f[(f[E>>2]|0)+12>>2]&511](E,o,m,-1);Zj(o);p$(q,f[x>>2]|0,f[v>>2]|0,5);f[p>>2]=1124007936;o=p+4|0;E=p+8|0;F=p+40|0;A=o;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[F>>2]=E;E=p+48|0;G=p+44|0;f[G>>2]=E;f[E>>2]=0;f[p+52>>2]=0;H=f[q>>2]|0;ei[f[(f[H>>2]|0)+12>>2]&511](H,q,p,-1);Zj(q);p$(s,f[x>>2]|0,f[v>>2]|0,5);f[r>>2]=1124007936;v=r+4|0;x=r+8|0;q=r+40|0;A=v;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[q>>2]=x;x=r+48|0;A=r+44|0;f[A>>2]=x;f[x>>2]=0;f[r+52>>2]=0;B=f[s>>2]|0;ei[f[(f[B>>2]|0)+12>>2]&511](B,s,r,-1);Zj(s);if(!(+(e|0)<c)?!((g|0)==0|((e|0)==0|+(g|0)<c)):0)I=0;else{J=((c+-.800000011920929)/.30000001192092896+1.0)*2.0;g=~~J;I=(+(g|0)<J&1)+g|0}g=(I&1^1)+I|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=m;f[k>>2]=g;f[k+4>>2]=g;J=c;Jqa(i,j,k,J,J,1);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;k=j+8|0;f[k>>2]=0;f[k+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=p;toa(i,j,5,1,0,1.0,0.0,4);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;k=j+8|0;f[k>>2]=0;f[k+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;toa(i,j,5,0,1,1.0,0.0,4);j=(f[y>>2]|0)+-1|0;i=(j|0)>1;do if(i){k=f[p+16>>2]|0;g=f[f[G>>2]>>2]|0;a=f[r+16>>2]|0;I=f[f[A>>2]>>2]|0;e=(f[m+12>>2]|0)+-1|0;if((e|0)>1){s=1;J=0.0;while(1){B=k+(Y(g,s)|0)|0;H=a+(Y(I,s)|0)|0;L=1;N=J;do{c=+n[B+(L<<2)>>2];O=+n[H+(L<<2)>>2];P=c*c+O*O;N=P>N?P:N;L=L+1|0}while((L|0)!=(e|0));s=s+1|0;if((s|0)>=(j|0))break;else J=N}J=+M(+N);if(i)Q=J;else{R=0.0;S=J;break}}else Q=0.0;s=f[p+16>>2]|0;e=f[G>>2]|0;I=f[r+16>>2]|0;a=f[A>>2]|0;g=m+12|0;J=+(d|0);k=f[l>>2]|0;L=1;P=0.0;H=f[g>>2]|0;while(1){B=s+(Y(f[e>>2]|0,L)|0)|0;T=I+(Y(f[a>>2]|0,L)|0)|0;if((H+-1|0)>1){U=1;O=P;V=H;while(1){c=+n[B+(U<<2)>>2];W=+n[T+(U<<2)>>2];X=c*c+W*W;if(X!=0.0){Z=~~+K(+(J*(+M(+X)/Q)));_=k+((((Z|0)==(d|0))<<31>>31)+Z<<2)|0;f[_>>2]=(f[_>>2]|0)+1;$=O+1.0;aa=f[g>>2]|0}else{$=O;aa=V}U=U+1|0;if((U|0)>=(aa+-1|0)){ba=$;ca=aa;break}else{O=$;V=aa}}}else{ba=P;ca=H}L=L+1|0;if((L|0)>=((f[y>>2]|0)+-1|0)){R=ba;S=Q;break}else{P=ba;H=ca}}}else{R=0.0;S=0.0}while(0);ca=~~(R*b);y=(ca|0)>0;if((d|0)>0&y){aa=f[l>>2]|0;i=0;j=0;while(1){i=(f[aa+(j<<2)>>2]|0)+i|0;H=j+1|0;L=(i|0)<(ca|0);if(!((H|0)<(d|0)&L)){da=H;ea=L;break}else j=H}}else{da=0;ea=y}b=ea?.029999999329447746:S*(+(da|0)/+(d|0));d=r+36|0;da=f[d>>2]|0;if(da|0?(ea=da+12|0,da=f[ea>>2]|0,f[ea>>2]=da+-1,(da|0)==1):0)V$(r);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[v>>2]|0)>0){d=f[q>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[v>>2]|0))}v=f[A>>2]|0;if((v|0)!=(x|0))wL(v);v=p+36|0;x=f[v>>2]|0;if(x|0?(A=x+12|0,x=f[A>>2]|0,f[A>>2]=x+-1,(x|0)==1):0)V$(p);f[v>>2]=0;v=p+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[o>>2]|0)>0){v=f[F>>2]|0;F=0;do{f[v+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[o>>2]|0))}o=f[G>>2]|0;if((o|0)!=(E|0))wL(o);o=m+36|0;E=f[o>>2]|0;if(E|0?(G=E+12|0,E=f[G>>2]|0,f[G>>2]=E+-1,(E|0)==1):0)V$(m);f[o>>2]=0;o=m+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[w>>2]|0)>0){o=f[z>>2]|0;z=0;do{f[o+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[w>>2]|0))}w=f[D>>2]|0;if((w|0)!=(C|0))wL(w);w=f[l>>2]|0;if(!w){u=h;return +b}l=f[t>>2]|0;if((l|0)!=(w|0))f[t>>2]=l+(~((l+-4-w|0)>>>2)<<2);cYc(w);u=h;return +b}function wPb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+192|0;h=g+128|0;i=g+72|0;j=g+56|0;k=g+40|0;l=g+16|0;m=g;n=g+32|0;f[h>>2]=1124007936;o=h+4|0;p=h+8|0;q=h+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;p=h+48|0;t=h+44|0;f[t>>2]=p;f[p>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;v=i+4|0;w=i+8|0;x=i+40|0;r=v;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[x>>2]=w;w=i+48|0;r=i+44|0;f[r>>2]=w;f[w>>2]=0;f[i+52>>2]=0;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=h;s=k+8|0;f[s>>2]=0;f[s+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;xPb(j,k,c,d,e);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[n>>2]=-1;f[n+4>>2]=-1;Aja(j,k,5,l,m,n,0.0,4);n=i+36|0;m=f[n>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)V$(i);f[n>>2]=0;n=i+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[v>>2]|0)>0){n=f[x>>2]|0;x=0;do{f[n+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[r>>2]|0;if((v|0)!=(w|0))wL(v);v=h+36|0;w=f[v>>2]|0;if(w|0?(r=w+12|0,w=f[r>>2]|0,f[r>>2]=w+-1,(w|0)==1):0)V$(h);f[v>>2]=0;v=h+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[o>>2]|0)>0){v=f[q>>2]|0;q=0;do{f[v+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[t>>2]|0;if((o|0)==(p|0)){u=g;return}wL(o);u=g;return}function xPb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0,N=0,O=0,P=0;h=u;u=u+208|0;i=h+184|0;j=h+128|0;k=h+72|0;l=h+56|0;m=h;o=g<<1|1;if((g|0)==1){poa(a,c,d,e,0,1,5);u=h;return}ZS(a,o,1,5,-1,1,0);ZS(c,o,1,5,-1,1,0);do if((eS(a)|0)==65536){p=f[a+4>>2]|0;f[j>>2]=f[p>>2];q=j+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=j+8|0;f[s>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];f[j+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[j+36>>2]=t;f[j+40>>2]=s;s=j+48|0;v=j+44|0;f[v>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;U$(j,p);break}}else bS(j,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];p=k+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=k+8|0;f[r>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=r;r=k+48|0;v=k+44|0;f[v>>2]=r;f[r>>2]=0;f[k+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(k,a);break}}else bS(k,c,-1);while(0);f[l>>2]=0;c=l+4|0;f[c>>2]=0;f[l+8>>2]=0;w=1.0/(+(g|0)*2.0*5.3333330154418945);g=m+4|0;a=m+8|0;p=m+12|0;q=m+16|0;r=m+20|0;v=m+24|0;s=m+40|0;t=m+48|0;x=m+44|0;y=m+52|0;z=m+28|0;A=i+8|0;B=i+4|0;C=m+36|0;D=w*3.3333332538604736;E=(o|0)/2|0;F=o+-1|0;G=0;do{H=(G|0)==0;I=H?j:k;n[i>>2]=0.0;xzb(l,o,i);switch((H?d:e)|0){case 0:{J=w;K=w;L=D;M=42;break}case 1:{J=1.0;K=-1.0;L=0.0;M=42;break}default:N=f[l>>2]|0}if((M|0)==42){M=0;H=f[l>>2]|0;n[H>>2]=K;n[H+(E<<2)>>2]=L;n[H+(F<<2)>>2]=J;N=H}H=f[I+8>>2]|0;O=f[I+12>>2]|0;f[m>>2]=1124007941;f[g>>2]=2;f[a>>2]=H;f[p>>2]=O;f[q>>2]=N;f[r>>2]=N;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[s>>2]=a;f[x>>2]=t;f[y>>2]=0;f[t>>2]=0;if((Y(O,H)|0)!=0&(N|0)==0){M=44;break}P=O<<2;f[t>>2]=P;f[y>>2]=4;O=N+(Y(P,H)|0)|0;f[z>>2]=O;f[v>>2]=O+(0-P)+P;R$(m);P=A;f[P>>2]=0;f[P+4>>2]=0;f[i>>2]=33619968;f[B>>2]=I;jR(m,i);I=f[C>>2]|0;if(I|0?(P=I+12|0,I=f[P>>2]|0,f[P>>2]=I+-1,(I|0)==1):0)V$(m);f[C>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[g>>2]|0)>0){I=f[s>>2]|0;P=0;do{f[I+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[g>>2]|0))}P=f[x>>2]|0;if((P|0)!=(t|0))wL(P);G=G+1|0}while((G|0)<2);if((M|0)==44){M=$Xc(32)|0;f[i>>2]=M;f[i+8>>2]=-2147483616;f[i+4>>2]=28;G=M;t=470314;x=G+28|0;do{b[G>>0]=b[t>>0]|0;G=G+1|0;t=t+1|0}while((G|0)<(x|0));b[M+28>>0]=0;vM(-215,i,470343,470347,548)}i=f[l>>2]|0;if(i|0){l=f[c>>2]|0;if((l|0)!=(i|0))f[c>>2]=l+(~((l+-4-i|0)>>>2)<<2);cYc(i)}i=k+36|0;l=f[i>>2]|0;if(l|0?(c=l+12|0,l=f[c>>2]|0,f[c>>2]=l+-1,(l|0)==1):0)V$(k);f[i>>2]=0;i=k+16|0;l=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[l>>2]|0)>0){i=f[k+40>>2]|0;c=0;do{f[i+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))wL(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)V$(j);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[j+40>>2]|0;c=0;do{f[l+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);u=h;return}function yPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=u;u=u+64|0;g=e+40|0;h=e+16|0;i=e;j=c+8|0;k=(f[j>>2]|0)+-1|0;f[g>>2]=1;f[g+4>>2]=k;f[h>>2]=116668;f[h+4>>2]=a;f[h+8>>2]=b;f[h+12>>2]=c;n[h+16>>2]=d;k=f[a+4>>2]|0;if((k|0)<3)l=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{m=f[a+40>>2]|0;o=0;p=1;while(1){q=Y(f[m+(o<<2)>>2]|0,p)|0;o=o+1|0;if((o|0)==(k|0)){l=q;break}else p=q}}h3(g,h,+(l>>>0)*.0000152587890625);l=f[c+16>>2]|0;p=c+44|0;k=f[b+16>>2]|0;o=f[f[b+44>>2]>>2]|0;b=k+o|0;m=f[a+16>>2]|0;q=f[f[a+44>>2]>>2]|0;r=m+q|0;s=f[c+12>>2]|0;t=s+-1|0;v=(t|0)>1;if(v){w=d*.5;x=1;do{y=+n[k+(x<<2)>>2];z=x;x=x+1|0;A=+n[m+(z<<2)>>2];B=z+-1|0;n[l+(z<<2)>>2]=w*((y+ +n[k+(x<<2)>>2])*(+n[m+(x<<2)>>2]-A)-(y+ +n[k+(B<<2)>>2])*(A-+n[m+(B<<2)>>2])+(y+ +n[b+(z<<2)>>2])*(+n[r+(z<<2)>>2]-A))}while((x|0)<(t|0))}x=f[j>>2]|0;j=x+-1|0;z=f[f[p>>2]>>2]|0;p=l+(Y(z,j)|0)|0;B=k+(Y(o,j)|0)|0;C=x+-2|0;x=k+(Y(o,C)|0)|0;D=m+(Y(q,j)|0)|0;E=m+(Y(q,C)|0)|0;if(v){w=d*.5;v=1;do{A=+n[B+(v<<2)>>2];C=v;v=v+1|0;y=+n[D+(C<<2)>>2];F=C+-1|0;n[p+(C<<2)>>2]=w*((A+ +n[B+(v<<2)>>2])*(+n[D+(v<<2)>>2]-y)-(A+ +n[B+(F<<2)>>2])*(y-+n[D+(F<<2)>>2])-(A+ +n[x+(C<<2)>>2])*(y-+n[E+(C<<2)>>2]))}while((v|0)<(t|0))}v=s+-2|0;if((j|0)<=1){G=g+8|0;f[G>>2]=0;H=g+12|0;f[H>>2]=0;f[g>>2]=16842752;I=g+4|0;f[I>>2]=a;J=h+8|0;f[J>>2]=0;K=h+12|0;f[K>>2]=0;f[h>>2]=16842752;L=h+4|0;f[L>>2]=c;M=i+8|0;N=M;O=N;f[O>>2]=0;P=N+4|0;Q=P;f[Q>>2]=0;f[i>>2]=33619968;R=i+4|0;f[R>>2]=a;S=fT()|0;E1(g,h,i,S,-1);u=e;return}w=d*.5;s=r;r=m;E=b;b=k;x=1;while(1){D=x;x=x+1|0;B=k+(Y(o,x)|0)|0;p=m+(Y(q,x)|0)|0;C=l+(Y(z,D)|0)|0;d=+n[E>>2];y=+n[s>>2];n[C>>2]=w*((d+ +n[E+4>>2])*(+n[s+4>>2]-y)+(d+ +n[B>>2])*(+n[p>>2]-y)-(d+ +n[b>>2])*(y-+n[r>>2]));y=+n[E+(t<<2)>>2];d=+n[s+(t<<2)>>2];n[C+(t<<2)>>2]=w*((y+ +n[B+(t<<2)>>2])*(+n[p+(t<<2)>>2]-d)-(+n[E+(v<<2)>>2]+y)*(d-+n[s+(v<<2)>>2])-(y+ +n[b+(t<<2)>>2])*(d-+n[r+(t<<2)>>2]));if((x|0)>=(j|0))break;else{C=E;D=s;s=p;E=B;b=C;r=D}}G=g+8|0;f[G>>2]=0;H=g+12|0;f[H>>2]=0;f[g>>2]=16842752;I=g+4|0;f[I>>2]=a;J=h+8|0;f[J>>2]=0;K=h+12|0;f[K>>2]=0;f[h>>2]=16842752;L=h+4|0;f[L>>2]=c;M=i+8|0;N=M;O=N;f[O>>2]=0;P=N+4|0;Q=P;f[Q>>2]=0;f[i>>2]=33619968;R=i+4|0;f[R>>2]=a;S=fT()|0;E1(g,h,i,S,-1);u=e;return}function zPb(a){a=a|0;cYc(a);return}function APb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0;c=f[a+4>>2]|0;d=f[a+8>>2]|0;e=f[a+12>>2]|0;g=f[b>>2]|0;h=f[b+4>>2]|0;if((g|0)>=(h|0))return;b=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=f[c+16>>2]|0;j=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;k=f[f[e+44>>2]>>2]|0;l=(f[e+12>>2]|0)+-1|0;e=a+16|0;if((l|0)>1)m=g;else return;do{g=m+-1|0;a=b+(Y(i,g)|0)|0;o=b+(Y(i,m)|0)|0;p=m;m=m+1|0;q=b+(Y(i,m)|0)|0;r=d+(Y(j,g)|0)|0;g=d+(Y(j,p)|0)|0;s=d+(Y(j,m)|0)|0;t=c+(Y(k,p)|0)|0;p=1;do{u=+n[o+(p<<2)>>2];v=p;p=p+1|0;w=+n[g+(v<<2)>>2];x=v+-1|0;n[t+(v<<2)>>2]=+n[e>>2]*.5*((u+ +n[o+(p<<2)>>2])*(+n[g+(p<<2)>>2]-w)-(u+ +n[o+(x<<2)>>2])*(w-+n[g+(x<<2)>>2])+(u+ +n[q+(v<<2)>>2])*(+n[s+(v<<2)>>2]-w)-(u+ +n[a+(v<<2)>>2])*(w-+n[r+(v<<2)>>2]))}while((p|0)<(l|0))}while((m|0)<(h|0));return}function BPb(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;h=d-b|0;i=d+b|0;if((h|0)>(i|0)){j=1;return j|0}k=e-b|0;l=e+b|0;b=f[a+8>>2]|0;m=f[a+12>>2]|0;o=f[a+16>>2]|0;p=f[a+44>>2]|0;if((k|0)>(l|0)){j=1;return j|0}else q=h;a:while(1){h=(q|0)==(d|0);if((q|0)>-1&(q|0)<(b|0)){a=k;while(1){do if((a|0)>-1&(a|0)<(m|0)){if(!g){r=o+(Y(f[p>>2]|0,q)|0)+(a<<2)|0;if(+n[r>>2]>c){j=0;s=11;break a}else break}if(!(h&(a|0)==(e|0))?(r=o+(Y(f[p>>2]|0,q)|0)+(a<<2)|0,+n[r>>2]>c):0){j=0;s=11;break a}}while(0);if((a|0)<(l|0))a=a+1|0;else break}}if((q|0)<(i|0))q=q+1|0;else{j=1;s=11;break}}if((s|0)==11)return j|0;return 0}function CPb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,465143)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function DPb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=116688;b=f[a+84>>2]|0;if(b|0){c=a+88|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-32-b|0)>>>5)<<5);cYc(b)}b=f[a+72>>2]|0;if(b|0){d=a+76|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0)){WRb(a);return}wL(b);WRb(a);return}function EPb(a){a=a|0;DPb(a);cYc(a);return}function FPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;g=u;u=u+192|0;h=g+172|0;i=g+160|0;j=g+104|0;k=g+84|0;l=g+56|0;m=g;f[h>>2]=0;o=h+4|0;f[o>>2]=0;f[h+8>>2]=0;f[i>>2]=0;p=i+4|0;f[p>>2]=0;f[i+8>>2]=0;do if((eS(e)|0)==65536){q=f[e+4>>2]|0;f[j>>2]=f[q>>2];r=j+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;U$(j,q);break}}else bS(j,e,-1);while(0);GPb(a,c,i,h);c=f[i>>2]|0;a=(f[p>>2]|0)-c|0;e=(a|0)/12|0;q=f[d>>2]|0;r=d+4|0;s=f[r>>2]|0;if((s|0)!=(q|0))f[r>>2]=s+(~(((s+-28-q|0)>>>0)/28|0)*28|0);a:do if((a|0)>0){q=m+4|0;s=m+8|0;t=m+12|0;w=m+16|0;v=m+40|0;x=m+48|0;y=m+44|0;z=m+52|0;A=l+8|0;B=l+12|0;C=l+4|0;D=m+36|0;E=k+12|0;F=k+8|0;G=k+4|0;H=j+16|0;I=l+4|0;J=l+8|0;K=l+12|0;L=l+16|0;N=l+20|0;O=l+24|0;P=d+8|0;Q=j+4|0;R=j+8|0;S=j+12|0;T=j+44|0;U=j+40|0;V=m+28|0;W=m+24|0;X=m+20|0;Z=0;_=c;while(1){$=f[h>>2]|0;aa=f[$+(Z<<4)>>2]|0;ba=f[$+(Z<<4)+4>>2]|0;ca=f[$+(Z<<4)+8>>2]|0;da=f[$+(Z<<4)+12>>2]|0;f[m>>2]=1124024332;f[q>>2]=2;$=f[_+(Z*12|0)+4>>2]|0;ea=f[_+(Z*12|0)>>2]|0;fa=$-ea|0;f[s>>2]=fa>>3;f[t>>2]=1;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[v>>2]=s;f[y>>2]=x;f[x>>2]=0;f[z>>2]=0;ga=ea;if((ga|0)!=($|0)){f[z>>2]=8;f[x>>2]=8;f[w>>2]=ga;f[X>>2]=ga;ga=ea+fa|0;f[W>>2]=ga;f[V>>2]=ga}f[A>>2]=0;f[B>>2]=0;f[l>>2]=16842752;f[C>>2]=m;koa(k,l);ga=f[D>>2]|0;if(ga|0?(fa=ga+12|0,ga=f[fa>>2]|0,f[fa>>2]=ga+-1,(ga|0)==1):0)V$(m);f[D>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[q>>2]|0)>0){ga=f[v>>2]|0;fa=0;do{f[ga+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[q>>2]|0))}fa=f[y>>2]|0;if((fa|0)!=(x|0))wL(fa);ha=+M(+(+n[E>>2]*+n[F>>2]));do if((ha>1.1920928955078125e-07?(ia=+n[k>>2],fa=ALc(ia)|0,ja=+n[G>>2],ga=ALc(ja)|0,(aa|0)<=(fa|0)&(fa|0)<(ca+aa|0)):0)?!((ba|0)>(ga|0)|(ga|0)>=(da+ba|0)):0){ea=f[H>>2]|0;if(ea|0){$=f[Q>>2]|0;if(($|0)<3)ka=Y(f[S>>2]|0,f[R>>2]|0)|0;else{la=f[U>>2]|0;ma=0;na=1;while(1){oa=Y(f[la+(ma<<2)>>2]|0,na)|0;ma=ma+1|0;if((ma|0)==($|0)){ka=oa;break}else na=oa}}if(!(($|0)==0|(ka|0)==0)?(na=ea+(Y(f[f[T>>2]>>2]|0,ga)|0)+fa|0,(b[na>>0]|0)==0):0)break}n[l>>2]=ia;n[I>>2]=ja;n[J>>2]=ha;n[K>>2]=-1.0;n[L>>2]=0.0;f[N>>2]=0;f[O>>2]=-1;na=f[r>>2]|0;if(na>>>0<(f[P>>2]|0)>>>0){n[na>>2]=ia;f[na+4>>2]=f[I>>2];ma=na+8|0;f[ma>>2]=f[J>>2];f[ma+4>>2]=f[J+4>>2];f[ma+8>>2]=f[J+8>>2];f[ma+12>>2]=f[J+12>>2];f[ma+16>>2]=f[J+16>>2];f[r>>2]=(f[r>>2]|0)+28}else NA(d,l)}while(0);ba=Z+1|0;if((ba|0)>=(e|0))break a;Z=ba;_=f[i>>2]|0}}while(0);e=j+36|0;l=f[e>>2]|0;if(l|0?(d=l+12|0,l=f[d>>2]|0,f[d>>2]=l+-1,(l|0)==1):0)V$(j);f[e>>2]=0;e=j+16|0;l=j+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[l>>2]|0)>0){e=f[j+40>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))wL(l);l=f[i>>2]|0;if(l|0){j=f[p>>2]|0;if((j|0)==(l|0))pa=l;else{d=j;while(1){j=d+-12|0;f[p>>2]=j;e=f[j>>2]|0;if(!e)qa=j;else{j=d+-8|0;r=f[j>>2]|0;if((r|0)!=(e|0))f[j>>2]=r+(~((r+-8-e|0)>>>3)<<3);cYc(e);qa=f[p>>2]|0}if((qa|0)==(l|0))break;else d=qa}pa=f[i>>2]|0}cYc(pa)}pa=f[h>>2]|0;if(!pa){u=g;return}h=f[o>>2]|0;if((h|0)!=(pa|0))f[o>>2]=h+(~((h+-16-pa|0)>>>4)<<4);cYc(pa);u=g;return}function GPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;g=u;u=u+1248|0;i=g;j=g+1224|0;k=g+1216|0;l=g+1208|0;m=g+1136|0;o=g+1080|0;q=g+1024|0;r=g+1200|0;s=g+1192|0;do if((eS(c)|0)==65536){t=f[c+4>>2]|0;f[q>>2]=f[t>>2];v=q+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=q+8|0;f[x>>2]=f[t+8>>2];f[q+12>>2]=f[t+12>>2];f[q+16>>2]=f[t+16>>2];f[q+20>>2]=f[t+20>>2];f[q+24>>2]=f[t+24>>2];f[q+28>>2]=f[t+28>>2];f[q+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[q+36>>2]=y;f[q+40>>2]=x;x=q+48|0;z=q+44|0;f[z>>2]=x;f[x>>2]=0;f[q+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;U$(q,t);break}}else bS(q,c,-1);while(0);c=f[d>>2]|0;t=d+4|0;v=f[t>>2]|0;if((v|0)!=(c|0)){w=v;while(1){v=w+-12|0;f[t>>2]=v;x=f[v>>2]|0;if(!x)A=v;else{v=w+-8|0;z=f[v>>2]|0;if((z|0)!=(x|0))f[v>>2]=z+(~((z+-8-x|0)>>>3)<<3);cYc(x);A=f[t>>2]|0}if((A|0)==(c|0))break;else w=A}}A=f[e>>2]|0;w=e+4|0;c=f[w>>2]|0;if((c|0)==(A|0))B=A;else{x=c+(~((c+-16-A|0)>>>4)<<4)|0;f[w>>2]=x;B=x}x=q+8|0;c=f[x>>2]|0;if((c|0)<3){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;C=$Xc(48)|0;f[i>>2]=C;D=i+8|0;f[D>>2]=-2147483600;E=i+4|0;f[E>>2]=47;F=C;G=465160;H=F+47|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=C+47|0;b[I>>0]=0;vM(-5,i,465208,465222,1047)}z=q+12|0;v=f[z>>2]|0;if((v|0)<3){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;C=$Xc(48)|0;f[i>>2]=C;D=i+8|0;f[D>>2]=-2147483600;E=i+4|0;f[E>>2]=47;F=C;G=465160;H=F+47|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=C+47|0;b[I>>0]=0;vM(-5,i,465208,465222,1047)}I=q+40|0;C=f[I>>2]|0;E=f[C+4>>2]|0;D=f[C>>2]|0;C=f[q>>2]|0;switch(C&4095){case 0:{if((C&16384|0)==0?(C=a+4|0,y=j+8|0,f[y>>2]=0,f[y+4>>2]=0,f[j>>2]=33619968,f[j+4>>2]=C,jR(q,j),(q|0)!=(C|0)):0){y=a+40|0;J=f[y>>2]|0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}K=q+36|0;J=f[K>>2]|0;if(J|0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0)V$(q);f[K>>2]=0;J=q+16|0;L=q+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[L>>2]|0)>0){M=f[I>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0;O=f[L>>2]|0}while((N|0)<(O|0));f[q>>2]=f[C>>2];if((O|0)<3)P=32;else P=34}else{f[q>>2]=f[C>>2];P=32}if((P|0)==32){O=f[a+8>>2]|0;if((O|0)<3){f[L>>2]=O;f[x>>2]=f[a+12>>2];f[z>>2]=f[a+16>>2];O=f[a+48>>2]|0;L=f[q+44>>2]|0;f[L>>2]=f[O>>2];f[L+4>>2]=f[O+4>>2]}else P=34}if((P|0)==34)U$(q,C);f[J>>2]=f[a+20>>2];f[q+20>>2]=f[a+24>>2];f[q+24>>2]=f[a+28>>2];f[q+28>>2]=f[a+32>>2];f[q+32>>2]=f[a+36>>2];f[K>>2]=f[y>>2]}PPb(a,q,i);y=a+128|0;if(!(b[y>>0]|0)){f[r>>2]=E;f[r+4>>2]=D;QPb(a,q,d,e,r,i,0);Q=0}else Q=0;do{r=i+(Q<<2)|0;K=i+(255-Q<<2)|0;J=f[r>>2]|0;f[r>>2]=f[K>>2];f[K>>2]=J;Q=Q+1|0}while((Q|0)!=128);if(((b[y>>0]|0)==0?(y=f[z>>2]|0,Q=f[x>>2]|0,(Q+-1|0)>1):0)?(J=f[a+60>>2]|0,(y+-1|0)>1):0){K=y+1|0;r=(y<<2)+-8|0;C=Q+-2|0;Q=0;do{g1c(J+(K+(Y(Q,y)|0)<<2)|0,0,r|0)|0;Q=Q+1|0}while((Q|0)!=(C|0))}f[s>>2]=E;f[s+4>>2]=D;QPb(a,q,d,e,s,i,255);break}case 24:case 16:{if((B|0)!=(A|0))f[w>>2]=B+(~((B+-16-A|0)>>>4)<<4);A=xL(Y(v<<6,c)|0)|0;c=f[z>>2]|0;v=f[x>>2]|0;B=(Y(c<<1,v)|0)-c-v|0;v=xL(B<<4)|0;c=xL(Y((f[z>>2]|0)*24|0,f[x>>2]|0)|0)|0;s=f[x>>2]|0;D=(f[z>>2]|0)+-1|0;f[m>>2]=1124007936;E=m+4|0;C=m+8|0;Q=m+40|0;F=E;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Q>>2]=C;C=m+48|0;r=m+44|0;f[r>>2]=C;f[C>>2]=0;f[m+52>>2]=0;f[i>>2]=s;s=i+4|0;f[s>>2]=D;S$(m,2,i,6);D=(f[x>>2]|0)+-1|0;y=f[z>>2]|0;f[o>>2]=1124007936;K=o+4|0;J=o+8|0;P=o+40|0;F=K;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[P>>2]=J;J=o+48|0;O=o+44|0;f[O>>2]=J;f[J>>2]=0;f[o+52>>2]=0;f[i>>2]=D;f[s>>2]=y;S$(o,2,i,6);y=f[a+152>>2]|0;s=f[q+48>>2]|0;D=f[z>>2]|0;L=(Y(D,-3)|0)+s|0;N=f[q+16>>2]|0;M=m+16|0;R=f[x>>2]|0;if((R|0)>0){S=L+3|0;T=D+-1|0;if((D|0)>1){U=(D*3|0)+-3|0;V=0;W=f[M>>2]|0;X=N+3|0;Z=N;while(1){_=0;$=W;aa=X;ba=Z;while(1){ca=h[ba>>0]|0;da=h[aa>>0]|0;ea=ca-da|0;fa=h[ba+1>>0]|0;ga=h[aa+1>>0]|0;ha=fa-ga|0;ia=h[ba+2>>0]|0;ja=h[aa+2>>0]|0;ka=ia-ja|0;la=+(Y(ea,ea)|0)/(+(da+ca|0)+1.0e-10)+ +(Y(ha,ha)|0)/(+(ga+fa|0)+1.0e-10)+ +(Y(ka,ka)|0)/(+(ja+ia|0)+1.0e-10);p[$>>3]=la;_=_+1|0;if((_|0)==(T|0))break;else{$=$+8|0;aa=aa+3|0;ba=ba+3|0}}V=V+1|0;if((V|0)==(R|0))break;else{W=W+(T<<3)|0;X=X+U+S|0;Z=Z+U+S|0}}}S=o+16|0;U=f[S>>2]|0;if((R|0)>1?(Z=R+-1|0,(D|0)>0):0){R=D*3|0;X=0;T=U;W=N+s|0;s=N;while(1){N=0;V=T;ba=W;aa=s;while(1){$=h[aa>>0]|0;_=h[ba>>0]|0;ia=$-_|0;ja=h[aa+1>>0]|0;ka=h[ba+1>>0]|0;fa=ja-ka|0;ga=h[aa+2>>0]|0;ha=h[ba+2>>0]|0;ca=ga-ha|0;la=+(Y(ia,ia)|0)/(+(_+$|0)+1.0e-10)+ +(Y(fa,fa)|0)/(+(ka+ja|0)+1.0e-10)+ +(Y(ca,ca)|0)/(+(ha+ga|0)+1.0e-10);p[V>>3]=la;N=N+1|0;if((N|0)==(D|0))break;else{V=V+8|0;ba=ba+3|0;aa=aa+3|0}}X=X+1|0;if((X|0)==(Z|0)){ma=S;na=U;break}else{T=T+(D<<3)|0;W=W+R+L|0;s=s+R+L|0}}}else{ma=S;na=U}}else{U=o+16|0;ma=U;na=f[U>>2]|0}if((y|0)>0){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=m;U=j+8|0;f[U>>2]=0;f[U+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=m;f[k>>2]=y;f[k+4>>2]=y;Jqa(i,j,k,0.0,0.0,4);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;k=j+8|0;f[k>>2]=0;f[k+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=o;f[l>>2]=y;f[l+4>>2]=y;Jqa(i,j,l,0.0,0.0,4);oa=f[z>>2]|0;pa=f[ma>>2]|0}else{oa=D;pa=na}na=f[M>>2]|0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+28>>2]=65535;f[A+24>>2]=0;f[A+32>>2]=1;f[A+36>>2]=1;f[A>>2]=A;f[A+8>>2]=A;f[A+4>>2]=A;f[A+20>>2]=0;la=+p[na>>3];p[v>>3]=la;qa=la+0.0;f[v+8>>2]=A;D=A+64|0;f[v+12>>2]=D;ma=na+8|0;l=v+16|0;j=oa+-1|0;y=(j|0)>1;f[A+76>>2]=0;f[A+80>>2]=0;f[A+92>>2]=65535;f[A+88>>2]=0;f[A+96>>2]=1;f[A+100>>2]=1;f[D>>2]=D;f[A+72>>2]=D;f[A+68>>2]=D;if(y){k=A+((oa<<6)+-64)|0;U=(oa<<4)+-16|0;S=1;L=D;R=l;s=ma;la=qa;W=v;while(1){f[L+20>>2]=S;ra=+p[s>>3];p[R>>3]=ra;la=la+ra;f[W+24>>2]=L;T=L;L=L+64|0;f[W+28>>2]=L;S=S+1|0;f[T+76>>2]=0;f[T+80>>2]=0;f[T+92>>2]=65535;f[T+88>>2]=0;f[T+96>>2]=1;f[T+100>>2]=1;f[L>>2]=L;f[T+72>>2]=L;f[T+68>>2]=L;if((S|0)==(j|0))break;else{T=R;R=R+16|0;s=s+8|0;W=T}}sa=k;ta=v+U|0;ua=la;va=na+(j<<3)|0}else{sa=D;ta=l;ua=qa;va=ma}f[sa+20>>2]=j;ma=sa+64|0;l=f[x>>2]|0;x=l+-1|0;f[sa+76>>2]=0;f[sa+80>>2]=0;f[sa+92>>2]=65535;f[sa+88>>2]=0;f[sa+96>>2]=1;f[sa+100>>2]=1;f[ma>>2]=ma;f[sa+72>>2]=ma;f[sa+68>>2]=ma;do if((x|0)>1){D=0-oa|0;na=f[z>>2]|0;U=0-na|0;k=na+-1|0;if(y){na=1;W=sa;s=ta;qa=ua;R=ma;S=pa;L=va;while(1){T=na<<16;f[W+84>>2]=T;la=+p[S>>3];p[s>>3]=la;f[s+8>>2]=R+(D<<6);f[s+12>>2]=R;ra=+p[L>>3];p[s+16>>3]=ra;f[s+24>>2]=R;Z=W+128|0;f[s+28>>2]=Z;f[W+140>>2]=0;f[W+144>>2]=0;f[W+156>>2]=65535;f[W+152>>2]=0;f[W+160>>2]=1;f[W+164>>2]=1;f[Z>>2]=Z;f[W+136>>2]=Z;f[W+132>>2]=Z;X=1;aa=s;wa=qa+la+ra;ba=s+32|0;V=Z;Z=S+8|0;N=L+8|0;while(1){f[V+20>>2]=X|T;ra=+p[Z>>3];p[ba>>3]=ra;f[aa+40>>2]=V+(U<<6);f[aa+44>>2]=V;la=+p[N>>3];p[aa+48>>3]=la;wa=wa+ra+la;f[aa+56>>2]=V;xa=V+64|0;f[aa+60>>2]=xa;X=X+1|0;ya=ba+32|0;za=Z+8|0;N=N+8|0;f[V+76>>2]=0;f[V+80>>2]=0;f[V+92>>2]=65535;f[V+88>>2]=0;f[V+96>>2]=1;f[V+100>>2]=1;f[xa>>2]=xa;f[V+72>>2]=xa;f[V+68>>2]=xa;if((X|0)>=(k|0))break;else{ga=ba;ba=ya;V=xa;Z=za;aa=ga}}f[V+84>>2]=T|j;la=+p[za>>3];p[ya>>3]=la;ra=wa+la;aa=Z+16|0;f[ba+40>>2]=xa+(D<<6);f[ba+44>>2]=xa;X=ba+48|0;na=na+1|0;ga=V+128|0;f[V+140>>2]=0;f[V+144>>2]=0;f[V+156>>2]=65535;f[V+152>>2]=0;f[V+160>>2]=1;f[V+164>>2]=1;f[ga>>2]=ga;f[V+136>>2]=ga;f[V+132>>2]=ga;if((na|0)==(x|0)){Aa=xa;Ba=ga;Ca=X;Da=aa;Ea=N;Fa=ra;break}else{W=xa;s=X;qa=ra;R=ga;S=aa;L=N}}}else{L=l<<1;S=l+-2|0;R=(l*3|0)+-6|0;s=1;W=sa;na=ta;k=ma;U=pa;aa=va;qa=ua;while(1){ga=s<<16;f[W+84>>2]=ga;ra=+p[U>>3];p[na>>3]=ra;f[na+8>>2]=k+(D<<6);f[na+12>>2]=k;la=+p[aa>>3];p[na+16>>3]=la;f[na+24>>2]=k;X=W;W=W+128|0;f[na+28>>2]=W;f[X+140>>2]=0;f[X+144>>2]=0;f[X+156>>2]=65535;f[X+152>>2]=0;f[X+160>>2]=1;f[X+164>>2]=1;f[W>>2]=W;f[X+136>>2]=W;f[X+132>>2]=W;f[X+148>>2]=ga|j;Ga=+p[U+8>>3];p[na+32>>3]=Ga;qa=qa+ra+la+Ga;f[na+40>>2]=W+(D<<6);f[na+44>>2]=W;s=s+1|0;k=X+192|0;f[X+204>>2]=0;f[X+208>>2]=0;f[X+220>>2]=65535;f[X+216>>2]=0;f[X+224>>2]=1;f[X+228>>2]=1;f[k>>2]=k;f[X+200>>2]=k;f[X+196>>2]=k;if((s|0)==(x|0))break;else{na=na+48|0;U=U+16|0;aa=aa+8|0}}aa=L+-4|0;Aa=sa+(aa<<6)|0;Ba=sa+(L+-3<<6)|0;Ca=ta+(R<<4)|0;Da=pa+(aa<<3)|0;Ea=va+(S<<3)|0;Fa=qa;break}}else{Aa=sa;Ba=ma;Ca=ta;Da=pa;Ea=va;Fa=ua}while(0);va=(l<<16)+-65536|0;f[Aa+84>>2]=va;ua=+p[Ea>>3];p[Ca>>3]=ua;f[Ca+8>>2]=Ba;l=Aa+128|0;f[Ca+12>>2]=l;Ga=+p[Da>>3];p[Ca+16>>3]=Ga;la=Fa+ua+Ga;pa=f[z>>2]|0;z=0-pa|0;f[Ca+24>>2]=Ba+(z<<6);f[Ca+28>>2]=Ba;Ba=Da+8|0;Da=pa+-1|0;f[Aa+140>>2]=0;f[Aa+144>>2]=0;f[Aa+156>>2]=65535;f[Aa+152>>2]=0;f[Aa+160>>2]=1;f[Aa+164>>2]=1;f[l>>2]=l;f[Aa+136>>2]=l;f[Aa+132>>2]=l;if((Da|0)>1){Aa=1;pa=Ca;ta=Ea;Ea=l;ma=Ba;Ga=la;while(1){sa=pa+32|0;ta=ta+8|0;f[Ea+20>>2]=Aa|va;ua=+p[ta>>3];p[sa>>3]=ua;f[pa+40>>2]=Ea;x=Ea+64|0;f[pa+44>>2]=x;Fa=+p[ma>>3];p[pa+48>>3]=Fa;ra=Ga+ua+Fa;f[pa+56>>2]=Ea+(z<<6);f[pa+60>>2]=Ea;Aa=Aa+1|0;j=ma+8|0;f[Ea+76>>2]=0;f[Ea+80>>2]=0;f[Ea+92>>2]=65535;f[Ea+88>>2]=0;f[Ea+96>>2]=1;f[Ea+100>>2]=1;f[x>>2]=x;f[Ea+72>>2]=x;f[Ea+68>>2]=x;if((Aa|0)>=(Da|0)){Ha=sa;Ia=x;Ja=j;Ka=ra;break}else{pa=sa;Ea=x;ma=j;Ga=ra}}}else{Ha=Ca;Ia=l;Ja=Ba;Ka=la}f[Ia+20>>2]=Da|va;la=+p[Ja>>3];p[Ha+32>>3]=la;f[Ha+40>>2]=Ia+(z<<6);f[Ha+44>>2]=Ia;Ga=(Ka+la)/+(B|0);Ia=v+(B<<4)|0;RPb(v,Ia,i);B=f[a+132>>2]|0;a:do if((B|0)>0){Ha=a+136|0;z=a+100|0;Ja=a+104|0;va=a+120|0;la=+(B|0);Da=v;Ba=c;l=0;while(1){Ka=+(l|0)/la*399.0;Ca=~~Ka;ma=Ca-(+(Ca|0)>Ka&1)|0;ra=Ka-+(ma|0);Ka=Ga*(+n[116788+(ma+1<<2)>>2]*ra+ +n[116788+(ma<<2)>>2]*(1.0-ra));if(Da>>>0<Ia>>>0){La=Da;Ma=Ba}else{Na=Ba;break a}while(1){ra=+p[La>>3];if(!(ra<Ka))break;ma=f[La+8>>2]|0;Ca=ma;Ea=ma;while(1){ma=f[Ca>>2]|0;f[Ca>>2]=Ea;if((ma|0)==(Ca|0))break;else{pa=Ca;Ca=ma;Ea=pa}}f[Ca>>2]=Ca;if((Ea|0)!=(Ca|0)){pa=Ea;do{ma=pa;pa=f[pa>>2]|0;f[ma>>2]=Ca}while((pa|0)!=(ma|0))}pa=f[La+12>>2]|0;Ea=pa;ma=pa;while(1){pa=f[Ea>>2]|0;f[Ea>>2]=ma;if((pa|0)==(Ea|0))break;else{Aa=Ea;Ea=pa;ma=Aa}}f[Ea>>2]=Ea;if((ma|0)!=(Ea|0)){Aa=ma;do{pa=Aa;Aa=f[Aa>>2]|0;f[pa>>2]=Ea}while((Aa|0)!=(pa|0))}do if((Ca|0)==(Ea|0))Oa=Ma;else{Aa=f[Ea+24>>2]|0;ma=f[Ca+24>>2]|0;do if((Aa|0)>(ma|0)){Pa=Ca;Qa=Ea}else{if((ma|0)!=(Aa|0)){Pa=Ea;Qa=Ca;break}pa=(f[Ca+32>>2]|0)>(f[Ea+32>>2]|0);ta=pa?Ea:Ca;j=ta+24|0;f[j>>2]=(f[j>>2]|0)+1;Pa=pa?Ca:Ea;Qa=ta}while(0);f[Pa>>2]=Qa;Aa=Pa+32|0;ma=Qa+32|0;ta=(f[ma>>2]|0)+(f[Aa>>2]|0)|0;f[ma>>2]=ta;ma=Qa+4|0;f[(f[ma>>2]|0)+8>>2]=Pa;pa=Pa+4|0;f[ma>>2]=f[pa>>2];f[(f[pa>>2]|0)+8>>2]=Qa;f[pa>>2]=Qa;Fa=+(ta|0);if(Fa>+p[Ha>>3]*+(ta-(f[Aa>>2]|0)|0)){f[Qa+36>>2]=ta;f[Qa+28>>2]=l;Aa=Qa+12|0;pa=f[Aa>>2]|0;if(!pa)Ra=Qa+48|0;else{j=Qa+48|0;p[pa+8>>3]=+p[Qa+40>>3]-+p[j>>3];f[Aa>>2]=0;Ra=j}p[Ra>>3]=ra;p[Qa+56>>3]=1.0e10;Sa=l}else Sa=f[Qa+28>>2]|0;p[Qa+40>>3]=ra;if((l|0)<=(Sa|0)){Oa=Ma;break}ua=+(ta-(f[Qa+36>>2]|0)|0)/(ra-+p[Qa+48>>3]);j=Qa+56|0;if(!(ua<+p[j>>3])){Oa=Ma;break}do if((l|0)>(Sa+1|0)){if(!((ta|0)>(f[z>>2]|0)?(ta|0)<(f[Ja>>2]|0):0)){Ta=Ma;break}Aa=Qa+16|0;pa=f[Aa>>2]|0;if(pa|0?!(+(ta-(f[pa+16>>2]|0)|0)/Fa>+p[va>>3]):0){Ta=Ma;break}pa=Qa+12|0;x=f[pa>>2]|0;if(!x){f[pa>>2]=Ma;f[Aa>>2]=Ma;Ua=Ma+24|0;Va=Ma}else{Ua=Ma;Va=x}f[Va+16>>2]=ta;f[Va>>2]=Qa;f[Va+4>>2]=f[ma>>2];p[Va+8>>3]=0.0;Ta=Ua}else Ta=Ma;while(0);p[j>>3]=ua;Oa=Ta}while(0);Ea=La+16|0;if(Ea>>>0<Ia>>>0){La=Ea;Ma=Oa}else{Na=Oa;break a}}l=l+1|0;if((l|0)>=(B|0)){Na=Ma;break}else{Da=La;Ba=Ma}}}else Na=c;while(0);if(c>>>0<Na>>>0){Ma=a+144|0;a=i+4|0;La=i+8|0;B=d+8|0;Oa=i+8|0;Ia=i+4|0;Ta=i+8|0;Ua=i+12|0;Va=e+8|0;Qa=i+4|0;Sa=c;do{if(+p[Sa+8>>3]>+p[Ma>>3]){Ra=f[Sa>>2]|0;f[i>>2]=0;f[a>>2]=0;f[La>>2]=0;Pa=f[t>>2]|0;do if(Pa>>>0<(f[B>>2]|0)>>>0){f[Pa>>2]=0;Ba=Pa+4|0;f[Ba>>2]=0;f[Pa+8>>2]=0;f[Pa>>2]=f[i>>2];f[Ba>>2]=f[a>>2];f[Pa+8>>2]=f[Oa>>2];f[Oa>>2]=0;f[a>>2]=0;f[i>>2]=0;f[t>>2]=(f[t>>2]|0)+12}else{SPb(d,i);Ba=f[i>>2]|0;if(!Ba)break;Da=f[a>>2]|0;if((Da|0)!=(Ba|0))f[a>>2]=Da+(~((Da+-8-Ba|0)>>>3)<<3);cYc(Ba)}while(0);Pa=f[t>>2]|0;Ba=Pa+-12|0;Da=Sa+16|0;l=f[Da>>2]|0;if((l|0)>0){va=Pa+-8|0;Ja=Pa+-4|0;Pa=Ra;z=-2147483648;Ha=-2147483648;S=2147483647;R=2147483647;L=0;N=l;while(1){l=f[Pa+20>>2]|0;V=l&65535;f[i>>2]=V;ba=l>>16;f[Qa>>2]=ba;l=(V|0)<(R|0)?V:R;Z=(Ha|0)<(V|0)?V:Ha;T=(ba|0)<(S|0)?ba:S;Ea=(z|0)<(ba|0)?ba:z;Pa=f[Pa+8>>2]|0;Ca=f[va>>2]|0;if((Ca|0)==(f[Ja>>2]|0)){Nw(Ba,i);Wa=f[Da>>2]|0}else{f[Ca>>2]=V;f[Ca+4>>2]=ba;f[va>>2]=Ca+8;Wa=N}L=L+1|0;if((L|0)>=(Wa|0)){Xa=Ea;Ya=Z;Za=T;_a=l;break}else{z=Ea;Ha=Z;S=T;R=l;N=Wa}}}else{Xa=-2147483648;Ya=-2147483648;Za=2147483647;_a=2147483647}f[i>>2]=_a;f[Ia>>2]=Za;f[Ta>>2]=1-_a+Ya;f[Ua>>2]=1-Za+Xa;N=f[w>>2]|0;if(N>>>0<(f[Va>>2]|0)>>>0){f[N>>2]=_a;f[N+4>>2]=f[Ia>>2];f[N+8>>2]=f[Ta>>2];f[N+12>>2]=f[Ua>>2];f[w>>2]=N+16}else TPb(e,i)}Sa=Sa+24|0}while(Sa>>>0<Na>>>0)}yL(c);yL(v);yL(A);A=o+36|0;v=f[A>>2]|0;if(v|0?(c=v+12|0,v=f[c>>2]|0,f[c>>2]=v+-1,(v|0)==1):0)V$(o);f[A>>2]=0;A=o+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[K>>2]|0)>0){A=f[P>>2]|0;P=0;do{f[A+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[K>>2]|0))}K=f[O>>2]|0;if((K|0)!=(J|0))wL(K);K=m+36|0;J=f[K>>2]|0;if(J|0?(O=J+12|0,J=f[O>>2]|0,f[O>>2]=J+-1,(J|0)==1):0)V$(m);f[K>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[E>>2]|0)>0){M=f[Q>>2]|0;Q=0;do{f[M+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[E>>2]|0))}E=f[r>>2]|0;if((E|0)!=(C|0))wL(E);break}default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;E=$Xc(48)|0;f[i>>2]=E;f[i+8>>2]=-2147483600;f[i+4>>2]=46;F=E;G=465294;H=F+46|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[E+46>>0]=0;vM(-215,i,465208,465222,1070)}}i=q+36|0;E=f[i>>2]|0;if(E|0?(G=E+12|0,E=f[G>>2]|0,f[G>>2]=E+-1,(E|0)==1):0)V$(q);f[i>>2]=0;i=q+16|0;E=q+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[E>>2]|0)>0){i=f[I>>2]|0;I=0;do{f[i+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[E>>2]|0))}E=f[q+44>>2]|0;if((E|0)==(q+48|0)){u=g;return}wL(E);u=g;return}function HPb(a,b){a=a|0;b=b|0;f[a+96>>2]=b;return}function IPb(a){a=a|0;return f[a+96>>2]|0}function JPb(a,b){a=a|0;b=b|0;f[a+100>>2]=b;return}function KPb(a){a=a|0;return f[a+100>>2]|0}function LPb(a,b){a=a|0;b=b|0;f[a+104>>2]=b;return}function MPb(a){a=a|0;return f[a+104>>2]|0}function NPb(a,c){a=a|0;c=c|0;b[a+128>>0]=c&1;return}function OPb(a){a=a|0;return (b[a+128>>0]|0)!=0|0}function PPb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g1c(c|0,0,1024)|0;d=f[b+12>>2]|0;e=f[b+8>>2]|0;g=a+60|0;i=Y(e,d)|0;j=a+64|0;k=f[j>>2]|0;l=f[g>>2]|0;m=k-l>>2;n=l;l=k;if(i>>>0<=m>>>0){if(i>>>0<m>>>0?(k=n+(i<<2)|0,(l|0)!=(k|0)):0)f[j>>2]=l+(~((l+-4-k|0)>>>2)<<2)}else _Pb(g,i-m|0);m=a+72|0;k=i+256|0;l=a+76|0;j=f[l>>2]|0;n=f[m>>2]|0;o=j-n>>2;p=n;n=j;if(k>>>0<=o>>>0){if(k>>>0<o>>>0?(j=p+(k<<2)|0,(n|0)!=(j|0)):0)f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2)}else $Pb(m,k-o|0);o=a+84|0;k=a+88|0;a=f[k>>2]|0;m=f[o>>2]|0;j=a-m>>5;n=m;m=a;if(i>>>0<=j>>>0){if(i>>>0<j>>>0?(a=n+(i<<5)|0,(m|0)!=(a|0)):0)f[k>>2]=m+(~((m+-32-a|0)>>>5)<<5)}else aQb(o,i-j|0);j=e+-1|0;if((d|0)>0){e=Y(j,d)|0;i=f[g>>2]|0;o=0;do{f[i+(o+e<<2)>>2]=-1610612736;f[i+(o<<2)>>2]=-1610612736;o=o+1|0}while((o|0)!=(d|0))}if((j|0)<=1)return;o=d+-1|0;if((o|0)<=1){i=f[g>>2]|0;e=1;do{a=i+((Y(e,d)|0)<<2)|0;f[a+(o<<2)>>2]=-1610612736;f[a>>2]=-1610612736;e=e+1|0}while((e|0)!=(j|0));return}e=f[b+16>>2]|0;i=f[b+44>>2]|0;b=f[g>>2]|0;g=1;do{a=e+(Y(f[i>>2]|0,g)|0)|0;m=b+((Y(g,d)|0)<<2)|0;f[m+(o<<2)>>2]=-1610612736;f[m>>2]=-1610612736;k=1;do{n=c+((h[a+k>>0]|0)<<2)|0;f[n>>2]=(f[n>>2]|0)+1;f[m+(k<<2)>>2]=0;k=k+1|0}while((k|0)!=(o|0));g=g+1|0}while((g|0)!=(j|0));return}function QPb(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=u;u=u+6288|0;l=k+6280|0;m=k+5256|0;n=k+112|0;o=k;p=k+92|0;q=k+80|0;f[l>>2]=f[a+84>>2];r=f[g>>2]|0;g=f[a+60>>2]|0;s=r+1|0;t=f[c+16>>2]|0;g1c(n|0,0,5140)|0;c=g+(s<<2)|0;v=o;w=a+96|0;x=v+60|0;do{f[v>>2]=f[w>>2];v=v+4|0;w=w+4|0}while((v|0)<(x|0));f[o+64>>2]=d;f[o+68>>2]=e;f[o+72>>2]=g;f[o+76>>2]=r;e=f[a+72>>2]|0;f[m>>2]=e;f[e>>2]=0;a=1;d=e;do{d=d+(f[i+(a+-1<<2)>>2]<<2)+4|0;f[m+(a<<2)>>2]=d;f[d>>2]=0;a=a+1|0}while((a|0)!=256);f[n+12>>2]=256;a=g;f[n+32>>2]=(h[t+(s<<2>>2)>>0]|0)^j;s=f[c>>2]&536870911|536870912;f[c>>2]=s;f[p>>2]=0;f[p+4>>2]=1;f[p+8>>2]=r;f[p+12>>2]=-1;f[p+16>>2]=0-r;r=c;c=n+20|0;n=s;a:while(1){s=(h[t+(r-a>>2)>>0]|0)^j;d=n>>>29;b:do if(n>>>0<2684354560){i=s;e=d;y=c;z=r;while(1){A=e;while(1){B=z+(f[p+(A<<2)>>2]<<2)|0;if((f[B>>2]|0)>>>0<=536870911){f[B>>2]=536870912;C=(h[t+(B-a>>2)>>0]|0)^j;if((C|0)<(i|0))break;D=m+(C<<2)|0;E=(f[D>>2]|0)+4|0;f[D>>2]=E;f[E>>2]=B}E=A+1|0;if((E|0)<5)A=E;else{F=i;G=E;H=z;I=y;break b}}E=m+(i<<2)|0;D=(f[E>>2]|0)+4|0;f[E>>2]=D;f[D>>2]=z;f[z>>2]=(A<<29)+536870912;D=y+20|0;f[y+24>>2]=0;f[D>>2]=0;f[y+28>>2]=0;f[y+36>>2]=0;f[y+32>>2]=C;i=C;e=1;y=D;z=B}}else{F=s;G=d;H=r;I=c}while(0);f[H>>2]=G<<29;d=H-a>>2;if(!d){J=12;break}s=I+4|0;z=f[s>>2]|0;if(!z)f[I>>2]=d;else{y=g+(z<<2)|0;f[y>>2]=f[y>>2]&-536870912|d}f[s>>2]=d;d=I+16|0;f[d>>2]=(f[d>>2]|0)+1;d=m+(F<<2)|0;s=f[d>>2]|0;y=f[s>>2]|0;do if(!y){z=F;while(1){K=z+1|0;if((K|0)>=256)break a;L=m+(K<<2)|0;M=f[L>>2]|0;N=f[M>>2]|0;if(!N)z=K;else break}if((z|0)>254)break a;f[L>>2]=M+-4;e=I+-20|0;if((K|0)<(f[I+-8>>2]|0)){WPb(I,l,o,K,0);O=N;P=I;break}else{XPb(e,e,I,l,o);O=N;P=e;break}}else{f[d>>2]=s+-4;O=y;P=I}while(0);r=O;c=P;n=f[O>>2]|0}if((J|0)==12){J=$Xc(16)|0;f[q>>2]=J;f[q+8>>2]=-2147483632;f[q+4>>2]=11;v=J;w=465341;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[J+11>>0]=0;vM(-215,q,465353,465222,490)}if((f[I+12>>2]|0)==256){u=k;return}else Q=I;while(1){WPb(Q,l,o,256,1);if((f[Q+-8>>2]|0)==256)break;else Q=Q+-20|0}u=k;return}function RPb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-16|0;i=g;while(1){j=i;b:while(1){k=j;l=b-k|0;m=l>>4;switch(m|0){case 2:{n=5;break a;break}case 3:{n=7;break a;break}case 4:{n=15;break a;break}case 5:{n=16;break a;break}case 1:case 0:{n=83;break a;break}default:{}}if((l|0)<496){n=22;break a}o=j+(((m|0)/2|0)<<4)|0;do if((l|0)>15984){q=(m|0)/4|0;r=j+(q<<4)|0;s=o+(q<<4)|0;q=UPb(j,r,o,s,c)|0;if(!(+p[h>>3]<+p[s>>3])){t=q;v=o;break};f[e>>2]=f[s>>2];f[e+4>>2]=f[s+4>>2];f[e+8>>2]=f[s+8>>2];f[e+12>>2]=f[s+12>>2];f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[s+8>>2]=f[h+8>>2];f[s+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];w=q+1|0;if(+p[s>>3]<+p[o>>3]){f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[s>>2];f[o+4>>2]=f[s+4>>2];f[o+8>>2]=f[s+8>>2];f[o+12>>2]=f[s+12>>2];f[s>>2]=f[e>>2];f[s+4>>2]=f[e+4>>2];f[s+8>>2]=f[e+8>>2];f[s+12>>2]=f[e+12>>2];s=q+2|0;if(+p[o>>3]<+p[r>>3]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];if(+p[r>>3]<+p[j>>3]){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2];f[j+8>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];t=q+4|0;v=o}else{t=q+3|0;v=o}}else{t=s;v=o}}else{t=w;v=o}}else{x=+p[o>>3];w=+p[h>>3]<x;if(!(x<+p[j>>3])){if(!w){t=0;v=o;break};f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];f[o+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+p[o>>3]<+p[j>>3])){t=1;v=o;break};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];t=2;v=o;break}if(w){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];t=1;v=o;break};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];if(+p[h>>3]<+p[o>>3]){f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];f[o+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];t=2;v=o}else{t=1;v=o}}while(0);x=+p[j>>3];y=+p[v>>3];if(x<y){z=h;A=t;break}else B=h;while(1){B=B+-16|0;if((j|0)==(B|0))break;if(+p[B>>3]<y){n=66;break b}}m=j+16|0;if(x<+p[h>>3])C=m;else{if((m|0)==(h|0)){n=83;break a}else D=m;while(1){if(x<+p[D>>3])break;m=D+16|0;if((m|0)==(h|0)){n=83;break a}else D=m}f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[e+12>>2]=f[D+12>>2];f[D>>2]=f[h>>2];f[D+4>>2]=f[h+4>>2];f[D+8>>2]=f[h+8>>2];f[D+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];C=D+16|0}if((C|0)==(h|0)){n=83;break a}else{E=h;F=C}while(1){x=+p[j>>3];m=F;while(1){G=m+16|0;if(x<+p[m>>3]){H=E;break}else m=G}do H=H+-16|0;while(x<+p[H>>3]);if(m>>>0>=H>>>0){j=m;continue b};f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[m>>2]=f[H>>2];f[m+4>>2]=f[H+4>>2];f[m+8>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];E=H;F=G}}if((n|0)==66){n=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[B>>2];f[j+4>>2]=f[B+4>>2];f[j+8>>2]=f[B+8>>2];f[j+12>>2]=f[B+12>>2];f[B>>2]=f[e>>2];f[B+4>>2]=f[e+4>>2];f[B+8>>2]=f[e+8>>2];f[B+12>>2]=f[e+12>>2];z=B;A=t+1|0}l=j+16|0;c:do if(l>>>0<z>>>0){w=o;s=z;q=l;r=A;while(1){x=+p[w>>3];I=q;while(1){J=I+16|0;if(+p[I>>3]<x)I=J;else{K=s;break}}do K=K+-16|0;while(!(+p[K>>3]<x));if(I>>>0>K>>>0){L=w;M=r;N=I;break c};f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[I>>2]=f[K>>2];f[I+4>>2]=f[K+4>>2];f[I+8>>2]=f[K+8>>2];f[I+12>>2]=f[K+12>>2];f[K>>2]=f[e>>2];f[K+4>>2]=f[e+4>>2];f[K+8>>2]=f[e+8>>2];f[K+12>>2]=f[e+12>>2];w=(w|0)==(I|0)?K:w;s=K;q=J;r=r+1|0}}else{L=o;M=A;N=l}while(0);if((N|0)!=(L|0)?+p[L>>3]<+p[N>>3]:0){f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[L>>2];f[N+4>>2]=f[L+4>>2];f[N+8>>2]=f[L+8>>2];f[N+12>>2]=f[L+12>>2];f[L>>2]=f[e>>2];f[L+4>>2]=f[e+4>>2];f[L+8>>2]=f[e+8>>2];f[L+12>>2]=f[e+12>>2];O=M+1|0}else O=M;if(!O){P=VPb(j,N,c)|0;l=N+16|0;if(VPb(l,a,c)|0){n=82;break}if(P){i=l;continue}}l=N;if((l-k|0)>=(b-l|0)){n=81;break}RPb(j,N,c);i=N+16|0}if((n|0)==81){n=0;RPb(N+16|0,a,c);g=j;a=N;continue}else if((n|0)==82){n=0;if(P){n=83;break}else{g=j;a=N;continue}}}if((n|0)==5){if(!(+p[h>>3]<+p[j>>3])){u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((n|0)==7){N=j+16|0;x=+p[N>>3];g=+p[h>>3]<x;if(!(x<+p[j>>3])){if(!g){u=d;return};f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[h>>2];f[N+4>>2]=f[h+4>>2];f[N+8>>2]=f[h+8>>2];f[N+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+p[N>>3]<+p[j>>3])){u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];u=d;return}if(g){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];if(!(+p[h>>3]<+p[N>>3])){u=d;return};f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[h>>2];f[N+4>>2]=f[h+4>>2];f[N+8>>2]=f[h+8>>2];f[N+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((n|0)==15){UPb(j,j+16|0,j+32|0,h,c)|0;u=d;return}else if((n|0)==16){N=j+16|0;g=j+32|0;P=j+48|0;UPb(j,N,g,P,c)|0;if(!(+p[h>>3]<+p[P>>3])){u=d;return};f[e>>2]=f[P>>2];f[e+4>>2]=f[P+4>>2];f[e+8>>2]=f[P+8>>2];f[e+12>>2]=f[P+12>>2];f[P>>2]=f[h>>2];f[P+4>>2]=f[h+4>>2];f[P+8>>2]=f[h+8>>2];f[P+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+p[P>>3]<+p[g>>3])){u=d;return};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[P>>2];f[g+4>>2]=f[P+4>>2];f[g+8>>2]=f[P+8>>2];f[g+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];if(!(+p[g>>3]<+p[N>>3])){u=d;return};f[e>>2]=f[N>>2];f[e+4>>2]=f[N+4>>2];f[e+8>>2]=f[N+8>>2];f[e+12>>2]=f[N+12>>2];f[N>>2]=f[g>>2];f[N+4>>2]=f[g+4>>2];f[N+8>>2]=f[g+8>>2];f[N+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+p[N>>3]<+p[j>>3])){u=d;return};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];u=d;return}else if((n|0)==22){N=j+32|0;g=j+16|0;x=+p[g>>3];y=+p[j>>3];Q=+p[N>>3];P=Q<x;do if(x<y){if(P){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[j+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];break};f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(Q<+p[g>>3]){f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[N>>2];f[g+4>>2]=f[N+4>>2];f[g+8>>2]=f[N+8>>2];f[g+12>>2]=f[N+12>>2];f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2]}}else if(P?(f[e>>2]=f[g>>2],f[e+4>>2]=f[g+4>>2],f[e+8>>2]=f[g+8>>2],f[e+12>>2]=f[g+12>>2],f[g>>2]=f[N>>2],f[g+4>>2]=f[N+4>>2],f[g+8>>2]=f[N+8>>2],f[g+12>>2]=f[N+12>>2],f[N>>2]=f[e>>2],f[N+4>>2]=f[e+4>>2],f[N+8>>2]=f[e+8>>2],f[N+12>>2]=f[e+12>>2],+p[g>>3]<y):0){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2]}while(0);e=j+48|0;if((e|0)==(a|0)){u=d;return}else{R=e;S=N}while(1){y=+p[R>>3];if(y<+p[S>>3]){N=R+8|0;e=f[N>>2]|0;g=f[N+4>>2]|0;N=S;P=R;while(1){f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];if((N|0)==(j|0)){T=j;break}h=N+-16|0;if(y<+p[h>>3]){c=N;N=h;P=c}else{T=N;break}}p[T>>3]=y;N=T+8|0;f[N>>2]=e;f[N+4>>2]=g}N=R+16|0;if((N|0)==(a|0))break;else{P=R;R=N;S=P}}u=d;return}else if((n|0)==83){u=d;return}}function SPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;g=d;i=k+(j*12|0)|0;f[k+(e*12|0)+8>>2]=0;f[d>>2]=f[b>>2];j=b+4|0;f[k+(e*12|0)+4>>2]=f[j>>2];l=b+8|0;f[k+(e*12|0)+8>>2]=f[l>>2];f[l>>2]=0;f[j>>2]=0;f[b>>2]=0;b=d+12|0;j=f[a>>2]|0;l=f[c>>2]|0;if((l|0)==(j|0)){m=g;n=j;o=j}else{e=l;l=g;g=d;do{d=g+-12|0;k=e;e=e+-12|0;f[d>>2]=0;p=g+-8|0;f[p>>2]=0;f[g+-4>>2]=0;f[d>>2]=f[e>>2];d=k+-8|0;f[p>>2]=f[d>>2];p=k+-4|0;f[g+-4>>2]=f[p>>2];f[p>>2]=0;f[d>>2]=0;f[e>>2]=0;g=l+-12|0;l=g}while((e|0)!=(j|0));m=l;n=f[a>>2]|0;o=f[c>>2]|0}f[a>>2]=m;f[c>>2]=b;f[h>>2]=i;i=n;if((o|0)!=(i|0)){h=o;do{o=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=o+-8|0;o=f[c>>2]|0;if((o|0)!=(b|0))f[c>>2]=o+(~((o+-8-b|0)>>>3)<<3);cYc(b)}}while((h|0)!=(i|0))}if(!n)return;cYc(n);return}function TPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function UPb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=+p[b>>3];i=+p[c>>3]<h;do if(h<+p[a>>3]){if(i){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];j=1;break};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];if(+p[c>>3]<+p[b>>3]){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];j=2}else j=1}else if(i){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(+p[b>>3]<+p[a>>3]){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];j=2}else j=1}else j=0;while(0);if(!(+p[d>>3]<+p[c>>3])){k=j;u=e;return k|0};f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];if(!(+p[c>>3]<+p[b>>3])){k=j+1|0;u=e;return k|0};f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(!(+p[b>>3]<+p[a>>3])){k=j+2|0;u=e;return k|0};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];k=j+3|0;u=e;return k|0}function VPb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;switch(b-a>>4|0){case 2:{g=b+-16|0;if(!(+p[g>>3]<+p[a>>3])){h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];h=1;u=d;return h|0}case 3:{g=a+16|0;i=b+-16|0;j=+p[g>>3];k=+p[i>>3]<j;if(!(j<+p[a>>3])){if(!k){h=1;u=d;return h|0};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];if(!(+p[g>>3]<+p[a>>3])){h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];h=1;u=d;return h|0}if(k){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+p[i>>3]<+p[g>>3])){h=1;u=d;return h|0};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];h=1;u=d;return h|0}case 4:{UPb(a,a+16|0,a+32|0,b+-16|0,c)|0;h=1;u=d;return h|0}case 5:{i=a+16|0;g=a+32|0;k=a+48|0;l=b+-16|0;UPb(a,i,g,k,c)|0;if(!(+p[l>>3]<+p[k>>3])){h=1;u=d;return h|0};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];if(!(+p[k>>3]<+p[g>>3])){h=1;u=d;return h|0};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[k+8>>2]=f[e+8>>2];f[k+12>>2]=f[e+12>>2];if(!(+p[g>>3]<+p[i>>3])){h=1;u=d;return h|0};f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+p[i>>3]<+p[a>>3])){h=1;u=d;return h|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{i=a+32|0;g=a+16|0;j=+p[g>>3];m=+p[a>>3];n=+p[i>>3];k=n<j;do if(j<m){if(k){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];break};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(n<+p[g>>3]){f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2]}}else if(k?(f[e>>2]=f[g>>2],f[e+4>>2]=f[g+4>>2],f[e+8>>2]=f[g+8>>2],f[e+12>>2]=f[g+12>>2],f[g>>2]=f[i>>2],f[g+4>>2]=f[i+4>>2],f[g+8>>2]=f[i+8>>2],f[g+12>>2]=f[i+12>>2],f[i>>2]=f[e>>2],f[i+4>>2]=f[e+4>>2],f[i+8>>2]=f[e+8>>2],f[i+12>>2]=f[e+12>>2],+p[g>>3]<m):0){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2]}while(0);g=a+48|0;a:do if((g|0)==(b|0)){o=1;q=0}else{k=g;l=0;c=i;while(1){m=+p[k>>3];if(m<+p[c>>3]){r=k+8|0;s=f[r+4>>2]|0;t=e;f[t>>2]=f[r>>2];f[t+4>>2]=s;s=c;t=k;while(1){f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];if((s|0)==(a|0)){v=a;break}r=s+-16|0;if(m<+p[r>>3]){w=s;s=r;t=w}else{v=s;break}}p[v>>3]=m;s=e;t=f[s+4>>2]|0;w=v+8|0;f[w>>2]=f[s>>2];f[w+4>>2]=t;t=l+1|0;if((t|0)==8){o=0;q=(k+16|0)==(b|0);break a}else x=t}else x=l;t=k+16|0;if((t|0)==(b|0)){o=1;q=0;break}else{w=k;k=t;l=x;c=w}}}while(0);h=q|o;u=d;return h|0}}return 0}function WPb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;i=h;j=a+12|0;k=f[j>>2]|0;l=(k|0)>(e|0)?k:e;m=a+8|0;o=f[m>>2]|0;if((o|0)!=0?(f[o+12>>2]|0)==(k|0):0)p=o;else{o=f[c>>2]|0;f[c>>2]=o+32;f[o+4>>2]=0;c=f[m>>2]|0;f[o>>2]=c;f[o+8>>2]=0;if(c|0)f[c+4>>2]=o;if(!o){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=9;c=i;q=465358;r=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(r|0));b[i+9>>0]=0;vM(-215,i,465368,465222,287)}else p=o}f[p+12>>2]=k;o=f[a+16>>2]|0;f[p+16>>2]=o;f[p+24>>2]=f[a>>2];a=p+20|0;n[a>>2]=3402823466385288598117041.0e14;i=p+28|0;b[i>>0]=1;if((o|0)>=(f[d+4>>2]|0)){n[a>>2]=-1.0;b[i>>0]=0}f[j>>2]=l;f[m>>2]=p;if((k|0)>=(e|0)){u=h;return}YPb(p,d,0,0,g);u=h;return}function XPb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=b;h=c;i=(f[b+12>>2]|0)<(f[c+12>>2]|0);c=i?h:g;b=f[c+12>>2]|0;j=a+12|0;f[j>>2]=b;WPb(c,d,e,b,0);b=i?g:h;WPb(b,d,e,f[j>>2]|0,0);j=f[c+16>>2]|0;if(!j)f[a>>2]=f[b>>2];else{f[a>>2]=f[c>>2];d=(f[e+72>>2]|0)+(f[c+4>>2]<<2)|0;f[d>>2]=f[d>>2]&-536870912|f[b>>2]}f[a+4>>2]=f[b+4>>2];f[a+16>>2]=(f[b+16>>2]|0)+j;j=f[c+8>>2]|0;f[a+8>>2]=j;a=f[j>>2]|0;c=f[b+8>>2]|0;b=j;if(!a){f[j>>2]=c;f[c+4>>2]=j;return}d=f[a+16>>2]|0;h=f[c+16>>2]|0;if((d|0)>(h|0)){if((h|0)<(f[e+4>>2]|0))return;h=a+8|0;f[c+8>>2]=f[h>>2];f[h>>2]=c;f[c+4>>2]=b;return}else{f[j>>2]=c;f[c+4>>2]=j;if((d|0)<(f[e+4>>2]|0))return;f[c+8>>2]=a;return}}function YPb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g+4|0;i=g;j=a+20|0;if(+n[j>>2]>=0.0){u=g;return}k=f[b>>2]|0;f[h>>2]=0;f[i>>2]=0;l=f[a>>2]|0;m=a+16|0;a:do if(l|0?(f[m>>2]|0)>=(f[b+4>>2]|0):0){o=l;do{p=o+20|0;q=+n[p>>2];if(q<0.0){r=(o|0)==(f[a>>2]|0);YPb(o,b,r?h:0,r?i:0,e);s=+n[p>>2]}else s=q;if(s<0.0)break a;o=f[o+8>>2]|0}while((o|0)!=0);o=f[i>>2]|0;if(o){t=(f[o+16>>2]|0)>(f[m>>2]|0)?o:a;v=9}else{t=a;v=9}}else{t=a;v=9}while(0);do if((v|0)==9){i=f[h>>2]|0;b:do if(i){l=a+12|0;if((i|0)==(a|0)){w=a;x=l}else{o=(f[l>>2]|0)-k|0;p=i;while(1){if((f[p+12>>2]|0)>=(o|0)){w=p;x=l;break b}p=f[p+4>>2]|0;if((p|0)==(a|0)){w=a;x=l;break}}}}else{l=a+12|0;p=a;while(1){o=f[p>>2]|0;if(!o){w=p;x=l;break b}if((f[o+12>>2]|0)<((f[l>>2]|0)-k|0)){w=p;x=l;break}else p=o}}while(0);i=t;while(1){y=i+4|0;p=f[y>>2]|0;if(!p)break;if((f[p+12>>2]|0)>((f[x>>2]|0)+k|0))break;else i=p}if(c|0)f[c>>2]=w;if(d|0)f[d>>2]=i;if((!e?(f[y>>2]|0)==0:0)?(f[i+12>>2]|0)<((f[x>>2]|0)+k|0):0)break;n[j>>2]=+((f[i+16>>2]|0)-(f[w+16>>2]|0)|0)/+(f[m>>2]|0);p=f[a>>2]|0;if(p|0){l=p;do{ZPb(l,b);l=f[l+8>>2]|0}while((l|0)!=0)}if(e?(f[a+4>>2]|0)==0:0)ZPb(a,b)}while(0);u=g;return}function ZPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+28|0;if(b[g>>0]|0){u=d;return}b[g>>0]=1;g=a+16|0;h=f[g>>2]|0;if((h|0)<(f[c+4>>2]|0)){u=d;return}if((h|0)>(f[c+8>>2]|0)){u=d;return}i=+n[a+20>>2];if(i<0.0){u=d;return}if(i>+p[c+16>>3]){u=d;return}h=f[a>>2]|0;a:do if(h|0){j=h;while(1){k=+n[j+20>>2];if(k>=0.0&i>k)break;j=f[j+8>>2]|0;if(!j)break a}u=d;return}while(0);if((i>0.0?(h=f[a+4>>2]|0,h|0):0)?(k=+n[h+20>>2],!(!(k>=0.0)|!(i>=k))):0){u=d;return}h=c+64|0;j=f[h>>2]|0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=j+4|0;o=f[m>>2]|0;if(o>>>0>=(f[j+8>>2]|0)>>>0){SPb(j,e);j=f[e>>2]|0;if(j|0){q=f[l>>2]|0;if((q|0)!=(j|0))f[l>>2]=q+(~((q+-8-j|0)>>>3)<<3);cYc(j)}}else{f[o>>2]=0;j=o+4|0;f[j>>2]=0;f[o+8>>2]=0;f[o>>2]=f[e>>2];f[j>>2]=f[l>>2];j=e+8|0;f[o+8>>2]=f[j>>2];f[j>>2]=0;f[l>>2]=0;f[e>>2]=0;f[m>>2]=(f[m>>2]|0)+12}m=f[(f[h>>2]|0)+4>>2]|0;h=m+-12|0;l=f[g>>2]|0;j=m+-8|0;m=f[j>>2]|0;o=f[h>>2]|0;q=m-o>>3;r=o;o=m;if(l>>>0<=q>>>0)if(l>>>0<q>>>0?(m=r+(l<<3)|0,(o|0)!=(m|0)):0){f[j>>2]=o+(~((o+-8-m|0)>>>3)<<3);s=l}else s=l;else{pP(h,l-q|0);s=f[g>>2]|0}g=f[c+72>>2]|0;q=f[c+76>>2]|0;if((s|0)>0){l=f[h>>2]|0;h=2147483647;m=2147483647;o=-2147483648;j=-2147483648;r=f[a+24>>2]|0;a=0;while(1){t=(r|0)/(q|0)|0;v=r-(Y(t,q)|0)|0;h=(v|0)<(h|0)?v:h;o=(o|0)<(v|0)?v:o;m=(t|0)<(m|0)?t:m;j=(j|0)<(t|0)?t:j;f[l+(a<<3)>>2]=v;f[l+(a<<3)+4>>2]=t;a=a+1|0;if((a|0)>=(s|0))break;else r=f[g+(r<<2)>>2]&536870911}w=m;x=o+1|0;y=j+1|0;z=h}else{w=2147483647;x=-2147483647;y=-2147483647;z=2147483647}h=f[c+68>>2]|0;f[e>>2]=z;c=e+4|0;f[c>>2]=w;j=e+8|0;f[j>>2]=x-z;x=e+12|0;f[x>>2]=y-w;w=h+4|0;y=f[w>>2]|0;if(y>>>0<(f[h+8>>2]|0)>>>0){f[y>>2]=z;f[y+4>>2]=f[c>>2];f[y+8>>2]=f[j>>2];f[y+12>>2]=f[x>>2];f[w>>2]=y+16}else TPb(h,e);u=d;return}function _Pb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){g1c(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)kWc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;g1c(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;cYc(h);return}function $Pb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function aQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>5>>>0>=c>>>0){i=c;j=h;do{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;n[j+20>>2]=-1.0;f[j+24>>2]=0;b[j+28>>0]=0;j=(f[g>>2]|0)+32|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>5;h=j+c|0;if(h>>>0>134217727)kWc(a);k=e-i|0;i=k>>4;e=k>>5>>>0<67108863?(i>>>0<h>>>0?h:i):134217727;do if(e)if(e>>>0>134217727){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e<<5)|0;break}else l=0;while(0);i=l+(j<<5)|0;j=l+(e<<5)|0;e=c;c=i;l=i;do{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;n[l+20>>2]=-1.0;f[l+24>>2]=0;b[l+28>>0]=0;l=c+32|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(0-(l>>5)<<5)|0;if((l|0)>0)o1c(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;cYc(e);return}function bQb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0;m=u;u=u+16|0;n=m;o=$Xc(176)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=118396;q=o+16|0;yP(q);f[q>>2]=116688;f[o+20>>2]=1124007936;r=o+28|0;s=o+60|0;t=o+24|0;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;r=o+68|0;f[o+64>>2]=r;t=r;v=t+44|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[o+112>>2]=c;f[o+116>>2]=d;f[o+120>>2]=e;p[o+128>>3]=g;p[o+136>>3]=h;b[o+144>>0]=0;e=o+145|0;b[e>>0]=b[n>>0]|0;b[e+1>>0]=b[n+1>>0]|0;b[e+2>>0]=b[n+2>>0]|0;f[o+148>>2]=i;p[o+152>>3]=j;p[o+160>>3]=k;f[o+168>>2]=l;f[a>>2]=q;f[a+4>>2]=o;u=m;return}function cQb(a){a=a|0;f[a>>2]=118396;DPb(a+16|0);NXc(a);return}function dQb(a){a=a|0;f[a>>2]=118396;DPb(a+16|0);NXc(a);cYc(a);return}function eQb(a){a=a|0;DPb(a+16|0);return}function fQb(a){a=a|0;cYc(a);return}function gQb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=118424;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function hQb(a){a=a|0;gQb(a);cYc(a);return}function iQb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+60>>2]|0;c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)<=0)return;d=f[a+44>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0));return}function jQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=118444;b=a+16|0;c=f[b>>2]|0;if(c|0){d=a+20|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;do{e=h+-48|0;f[d>>2]=e;EQ(e);h=f[d>>2]|0}while((h|0)!=(c|0));g=f[b>>2]|0}cYc(g)}hx(a+4|0);qP(a);return}function kQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=118444;b=a+16|0;c=f[b>>2]|0;if(c|0){d=a+20|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;do{e=h+-48|0;f[d>>2]=e;EQ(e);h=f[d>>2]|0}while((h|0)!=(c|0));g=f[b>>2]|0}cYc(g)}hx(a+4|0);qP(a);cYc(a);return}function lQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+16>>2]|0;c=a+20|0;d=f[c>>2]|0;if((d|0)!=(b|0)){e=d;do{d=e+-48|0;f[c>>2]=d;EQ(d);e=f[c>>2]|0}while((e|0)!=(b|0))}b=f[a+4>>2]|0;e=a+8|0;a=f[e>>2]|0;if((a|0)==(b|0))return;else g=a;do{a=g+-56|0;f[e>>2]=a;c=g+-20|0;d=f[c>>2]|0;if(d|0?(h=d+12|0,d=f[h>>2]|0,f[h>>2]=d+-1,(d|0)==1):0)V$(a);f[c>>2]=0;c=g+-40|0;a=g+-52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+-16>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[g+-12>>2]|0;if((a|0)!=(g+-8|0))wL(a);g=f[e>>2]|0}while((g|0)!=(b|0));return}function mQb(a,b){a=a|0;b=b|0;return}function nQb(a,b){a=a|0;b=b|0;return}function oQb(a){a=a|0;var b=0;if((f[a+4>>2]|0)!=(f[a+8>>2]|0)){b=0;return b|0}b=(f[a+16>>2]|0)==(f[a+20>>2]|0);return b|0}function pQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+128|0;e=d+72|0;g=d+64|0;h=d+60|0;i=d+12|0;j=d+56|0;k=d+52|0;l=d+48|0;m=d+44|0;n=d+40|0;o=d+36|0;p=d+32|0;q=d+28|0;r=d+24|0;s=d+8|0;t=d+4|0;v=d;if((eS(c)|0)==720896){f[i>>2]=0;w=i+4|0;f[w>>2]=0;f[i+8>>2]=0;jS(c,i);f[j>>2]=f[a+20>>2];f[k>>2]=f[i>>2];f[l>>2]=f[w>>2];f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];f[e>>2]=f[l>>2];rQb(a+16|0,h,g,e)|0;l=f[i>>2]|0;if(l|0){k=f[w>>2]|0;if((k|0)==(l|0))x=l;else{j=k;do{k=j+-48|0;f[w>>2]=k;EQ(k);j=f[w>>2]|0}while((j|0)!=(l|0));x=f[i>>2]|0}cYc(x)}u=d;return}if((eS(c)|0)==655360){fS(e,c,-1);sQb(i,1,e);EQ(e);f[m>>2]=f[a+20>>2];f[n>>2]=f[i>>2];x=i+4|0;f[o>>2]=f[x>>2];f[h>>2]=f[m>>2];f[g>>2]=f[n>>2];f[e>>2]=f[o>>2];rQb(a+16|0,h,g,e)|0;o=f[i>>2]|0;if(o|0){n=f[x>>2]|0;if((n|0)==(o|0))y=o;else{m=n;do{n=m+-48|0;f[x>>2]=n;EQ(n);m=f[x>>2]|0}while((m|0)!=(o|0));y=f[i>>2]|0}cYc(y)}u=d;return}if((eS(c)|0)==327680){f[i>>2]=0;y=i+4|0;f[y>>2]=0;f[i+8>>2]=0;gS(c,i);f[p>>2]=f[a+8>>2];f[q>>2]=f[i>>2];f[r>>2]=f[y>>2];f[h>>2]=f[p>>2];f[g>>2]=f[q>>2];f[e>>2]=f[r>>2];tQb(a+4|0,h,g,e)|0;hx(i);u=d;return}if((eS(c)|0)!=65536){if((eS(c)|0)==655360){u=d;return}if((eS(c)|0)==720896){u=d;return}if((eS(c)|0)==65536){u=d;return}if((eS(c)|0)==327680){u=d;return}else{r=$Xc(112)|0;f[e>>2]=r;f[e+8>>2]=-2147483536;f[e+4>>2]=106;q=r;p=465510;y=q+106|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(y|0));b[r+106>>0]=0;vM(-215,e,465617,465621,556)}}do if((eS(c)|0)==65536){r=f[c+4>>2]|0;f[e>>2]=f[r>>2];p=e+4|0;q=r+4|0;f[p>>2]=f[q>>2];y=e+8|0;f[y>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[e+16>>2]=f[r+16>>2];f[e+20>>2]=f[r+20>>2];f[e+24>>2]=f[r+24>>2];f[e+28>>2]=f[r+28>>2];f[e+32>>2]=f[r+32>>2];o=f[r+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=y;y=e+48|0;m=e+44|0;f[m>>2]=y;f[y>>2]=0;f[e+52>>2]=0;if(o|0){y=o+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[q>>2]|0)<3){q=f[r+44>>2]|0;y=f[m>>2]|0;f[y>>2]=f[q>>2];f[y+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(e,r);break}}else bS(e,c,-1);while(0);lOa(i,1,e);c=e+36|0;r=f[c>>2]|0;if(r|0?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;r=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[r>>2]|0)>0){c=f[e+40>>2]|0;p=0;do{f[c+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[r>>2]|0))}r=f[e+44>>2]|0;if((r|0)!=(e+48|0))wL(r);f[s>>2]=f[a+8>>2];f[t>>2]=f[i>>2];f[v>>2]=f[i+4>>2];f[h>>2]=f[s>>2];f[g>>2]=f[t>>2];f[e>>2]=f[v>>2];tQb(a+4|0,h,g,e)|0;hx(i);u=d;return}function qQb(a){a=a|0;return}function rQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=f[a>>2]|0;i=h;j=(f[b>>2]|0)-i|0;b=h+(((j|0)/48|0)*48|0)|0;h=f[c>>2]|0;k=f[d>>2]|0;d=k-h|0;l=(d|0)/48|0;m=h;n=k;if((d|0)<=0){o=b;u=e;return o|0}d=f[a+8>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)>((d-r|0)/48|0|0)){s=((r-i|0)/48|0)+l|0;if(s>>>0>89478485)kWc(a);t=(d-i|0)/48|0;i=t<<1;d=t>>>0<44739242?(i>>>0<s>>>0?s:i):89478485;i=(j|0)/48|0;f[g+12>>2]=0;f[g+16>>2]=a+8;do if(d)if(d>>>0>89478485){j=af(8)|0;hYc(j,512536);f[j>>2]=192348;ig(j|0,25336,2140)}else{v=$Xc(d*48|0)|0;break}else v=0;while(0);f[g>>2]=v;j=v+(i*48|0)|0;i=g+8|0;f[i>>2]=j;s=g+4|0;f[s>>2]=j;f[g+12>>2]=v+(d*48|0);if((m|0)!=(n|0)){d=h;h=m;v=j;while(1){f[v>>2]=f[h>>2];j=v+4|0;t=h+4|0;f[j>>2]=f[t>>2];w=v+8|0;f[w>>2]=f[h+8>>2];f[v+12>>2]=f[h+12>>2];f[v+16>>2]=f[h+16>>2];f[v+20>>2]=f[h+20>>2];x=f[h+24>>2]|0;f[v+24>>2]=x;f[v+28>>2]=f[h+28>>2];f[v+32>>2]=w;w=v+40|0;y=v+36|0;f[y>>2]=w;f[v+44>>2]=0;f[w>>2]=0;if(x|0){w=x+8|0;f[w>>2]=(f[w>>2]|0)+1}if((f[t>>2]|0)<3){t=f[h+36>>2]|0;w=f[y>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2]}else{f[j>>2]=0;DQ(v,h)}j=(f[i>>2]|0)+48|0;f[i>>2]=j;t=d+48|0;if((t|0)==(n|0))break;else{d=t;h=t;v=j}}}v=xQb(a,g,b)|0;h=f[s>>2]|0;s=f[i>>2]|0;if((s|0)!=(h|0)){d=s;do{s=d+-48|0;f[i>>2]=s;EQ(s);d=f[i>>2]|0}while((d|0)!=(h|0))}h=f[g>>2]|0;if(h|0)cYc(h);o=v;u=e;return o|0}v=r-b|0;r=(v|0)/48|0;do if((l|0)>(r|0)){h=m+(r*48|0)|0;g=h;if((h|0)!=(n|0)){d=g;i=h;h=q;while(1){f[h>>2]=f[i>>2];s=h+4|0;j=i+4|0;f[s>>2]=f[j>>2];t=h+8|0;f[t>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[h+16>>2]=f[i+16>>2];f[h+20>>2]=f[i+20>>2];w=f[i+24>>2]|0;f[h+24>>2]=w;f[h+28>>2]=f[i+28>>2];f[h+32>>2]=t;t=h+40|0;y=h+36|0;f[y>>2]=t;f[h+44>>2]=0;f[t>>2]=0;if(w|0){t=w+8|0;f[t>>2]=(f[t>>2]|0)+1}if((f[j>>2]|0)<3){j=f[i+36>>2]|0;t=f[y>>2]|0;f[t>>2]=f[j>>2];f[t+4>>2]=f[j+4>>2]}else{f[s>>2]=0;DQ(h,i)}s=d+48|0;j=(f[p>>2]|0)+48|0;f[p>>2]=j;if((s|0)==(n|0))break;else{d=s;i=s;h=j}}}if((v|0)>0){z=g;A=f[c>>2]|0;break}else{o=b;u=e;return o|0}}else{z=k;A=m}while(0);wQb(a,b,q,b+(l*48|0)|0);l=z;if((A|0)==(l|0)){o=b;u=e;return o|0}else{B=b;C=A}while(1){if((B|0)!=(C|0)){A=C+24|0;z=f[A>>2]|0;if(z|0){q=z+8|0;f[q>>2]=(f[q>>2]|0)+1}q=B+24|0;z=f[q>>2]|0;if(z|0?(a=z+8|0,z=f[a>>2]|0,f[a>>2]=z+-1,(z|0)==1):0)FQ(B);z=B+4|0;if((f[z>>2]|0)>0){a=f[B+32>>2]|0;m=0;do{f[a+(m<<2)>>2]=0;m=m+1|0;D=f[z>>2]|0}while((m|0)<(D|0));f[q>>2]=0;f[B>>2]=f[C>>2];if((D|0)<3)E=25;else E=27}else{f[q>>2]=0;f[B>>2]=f[C>>2];E=25}if((E|0)==25){E=0;m=f[C+4>>2]|0;if((m|0)<3){f[z>>2]=m;f[B+8>>2]=f[C+8>>2];f[B+12>>2]=f[C+12>>2];m=f[C+36>>2]|0;a=f[B+36>>2]|0;f[a>>2]=f[m>>2];f[a+4>>2]=f[m+4>>2]}else E=27}if((E|0)==27){E=0;DQ(B,C)}f[B+16>>2]=f[C+16>>2];m=B+20|0;if(!(f[m>>2]|0))f[m>>2]=f[C+20>>2];f[q>>2]=f[A>>2];f[B+28>>2]=f[C+28>>2]}C=C+48|0;if((C|0)==(l|0)){o=b;break}else B=B+48|0}u=e;return o|0}function sQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>89478485)kWc(a);e=$Xc(b*48|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*48|0);a=c+4|0;g=c+8|0;h=c+12|0;i=c+16|0;j=c+20|0;k=c+24|0;l=c+28|0;m=c+36|0;n=b;b=e;do{f[b>>2]=f[c>>2];e=b+4|0;f[e>>2]=f[a>>2];o=b+8|0;f[o>>2]=f[g>>2];f[b+12>>2]=f[h>>2];f[b+16>>2]=f[i>>2];f[b+20>>2]=f[j>>2];p=f[k>>2]|0;f[b+24>>2]=p;f[b+28>>2]=f[l>>2];f[b+32>>2]=o;o=b+40|0;q=b+36|0;f[q>>2]=o;f[b+44>>2]=0;f[o>>2]=0;if(p|0){o=p+8|0;f[o>>2]=(f[o>>2]|0)+1}if((f[a>>2]|0)<3){o=f[m>>2]|0;p=f[q>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2]}else{f[e>>2]=0;DQ(b,c)}b=(f[d>>2]|0)+48|0;f[d>>2]=b;n=n+-1|0}while((n|0)!=0);return}function tQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+32|0;g=e;h=f[a>>2]|0;i=h;j=(f[b>>2]|0)-i|0;b=h+(((j|0)/56|0)*56|0)|0;h=f[c>>2]|0;k=f[d>>2]|0;d=k-h|0;l=(d|0)/56|0;m=h;n=k;if((d|0)<=0){o=b;u=e;return o|0}d=f[a+8>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)>((d-r|0)/56|0|0)){s=((r-i|0)/56|0)+l|0;if(s>>>0>76695844)kWc(a);t=(d-i|0)/56|0;i=t<<1;d=t>>>0<38347922?(i>>>0<s>>>0?s:i):76695844;i=(j|0)/56|0;f[g+12>>2]=0;f[g+16>>2]=a+8;do if(d)if(d>>>0>76695844){j=af(8)|0;hYc(j,512536);f[j>>2]=192348;ig(j|0,25336,2140)}else{v=$Xc(d*56|0)|0;break}else v=0;while(0);f[g>>2]=v;j=v+(i*56|0)|0;i=g+8|0;f[i>>2]=j;f[g+4>>2]=j;f[g+12>>2]=v+(d*56|0);if((m|0)!=(n|0)){d=h;h=m;v=j;while(1){f[v>>2]=f[h>>2];j=v+4|0;s=h+4|0;f[j>>2]=f[s>>2];t=v+8|0;f[t>>2]=f[h+8>>2];f[v+12>>2]=f[h+12>>2];f[v+16>>2]=f[h+16>>2];f[v+20>>2]=f[h+20>>2];f[v+24>>2]=f[h+24>>2];f[v+28>>2]=f[h+28>>2];f[v+32>>2]=f[h+32>>2];w=f[h+36>>2]|0;f[v+36>>2]=w;f[v+40>>2]=t;t=v+48|0;x=v+44|0;f[x>>2]=t;f[t>>2]=0;f[v+52>>2]=0;if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[h+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[j>>2]=0;U$(v,h)}j=(f[i>>2]|0)+56|0;f[i>>2]=j;s=d+56|0;if((s|0)==(n|0))break;else{d=s;h=s;v=j}}}v=vQb(a,g,b)|0;dx(g);o=v;u=e;return o|0}v=r-b|0;r=(v|0)/56|0;do if((l|0)>(r|0)){g=m+(r*56|0)|0;h=g;if((g|0)!=(n|0)){d=h;i=g;g=q;while(1){f[g>>2]=f[i>>2];j=g+4|0;s=i+4|0;f[j>>2]=f[s>>2];t=g+8|0;f[t>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];x=f[i+36>>2]|0;f[g+36>>2]=x;f[g+40>>2]=t;t=g+48|0;w=g+44|0;f[w>>2]=t;f[t>>2]=0;f[g+52>>2]=0;if(x|0){t=x+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[i+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[j>>2]=0;U$(g,i)}j=d+56|0;s=(f[p>>2]|0)+56|0;f[p>>2]=s;if((j|0)==(n|0))break;else{d=j;i=j;g=s}}}if((v|0)>0){y=h;z=f[c>>2]|0;break}else{o=b;u=e;return o|0}}else{y=k;z=m}while(0);uQb(a,b,q,b+(l*56|0)|0);l=y;if((z|0)==(l|0)){o=b;u=e;return o|0}else{A=b;B=z}while(1){if((A|0)!=(B|0)){z=B+36|0;y=f[z>>2]|0;if(y|0){q=y+12|0;f[q>>2]=(f[q>>2]|0)+1}q=A+36|0;y=f[q>>2]|0;if(y|0?(a=y+12|0,y=f[a>>2]|0,f[a>>2]=y+-1,(y|0)==1):0)V$(A);f[q>>2]=0;y=A+16|0;a=A+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[a>>2]|0)>0){m=f[A+40>>2]|0;k=0;do{f[m+(k<<2)>>2]=0;k=k+1|0;C=f[a>>2]|0}while((k|0)<(C|0));f[A>>2]=f[B>>2];if((C|0)<3)D=25;else D=27}else{f[A>>2]=f[B>>2];D=25}if((D|0)==25){D=0;k=f[B+4>>2]|0;if((k|0)<3){f[a>>2]=k;f[A+8>>2]=f[B+8>>2];f[A+12>>2]=f[B+12>>2];k=f[B+44>>2]|0;m=f[A+44>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2]}else D=27}if((D|0)==27){D=0;U$(A,B)}f[y>>2]=f[B+16>>2];f[A+20>>2]=f[B+20>>2];f[A+24>>2]=f[B+24>>2];f[A+28>>2]=f[B+28>>2];f[A+32>>2]=f[B+32>>2];f[q>>2]=f[z>>2]}B=B+56|0;if((B|0)==(l|0)){o=b;break}else A=A+56|0}u=e;return o|0}function uQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=a+4|0;a=f[e>>2]|0;g=a-d|0;d=b+(((g|0)/56|0)*56|0)|0;if(d>>>0<c>>>0){h=d;i=a;do{f[i>>2]=f[h>>2];j=h+4|0;f[i+4>>2]=f[j>>2];k=i+8|0;l=h+8|0;f[k>>2]=f[l>>2];f[i+12>>2]=f[h+12>>2];f[i+16>>2]=f[h+16>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[i+32>>2]=f[h+32>>2];f[i+36>>2]=f[h+36>>2];m=i+40|0;f[m>>2]=k;k=i+44|0;n=i+48|0;f[k>>2]=n;o=i+52|0;f[o>>2]=0;f[n>>2]=0;p=h+44|0;if((f[j>>2]|0)<3){q=f[p>>2]|0;f[n>>2]=f[q>>2];f[o>>2]=f[q+4>>2]}else{f[k>>2]=f[p>>2];k=h+40|0;f[m>>2]=f[k>>2];f[p>>2]=h+48;f[k>>2]=l}f[h>>2]=1124007936;l=j;j=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(j|0));h=h+56|0;i=(f[e>>2]|0)+56|0;f[e>>2]=i}while(h>>>0<c>>>0)}if(!g)return;else{r=d;s=a}do{r=r+-56|0;s=s+-56|0;nOa(s,r)|0}while((r|0)!=(b|0));return}function vQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=b+4|0;e=f[d>>2]|0;g=f[a>>2]|0;if((g|0)==(c|0))h=e;else{i=c;j=e;while(1){k=j+-56|0;l=i;i=i+-56|0;f[k>>2]=f[i>>2];m=j+-52|0;n=l+-52|0;f[m>>2]=f[n>>2];o=j+-48|0;f[o>>2]=f[l+-48>>2];f[j+-44>>2]=f[l+-44>>2];f[j+-40>>2]=f[l+-40>>2];f[j+-36>>2]=f[l+-36>>2];f[j+-32>>2]=f[l+-32>>2];f[j+-28>>2]=f[l+-28>>2];f[j+-24>>2]=f[l+-24>>2];p=f[l+-20>>2]|0;f[j+-20>>2]=p;f[j+-16>>2]=o;o=j+-8|0;q=j+-12|0;f[q>>2]=o;f[o>>2]=0;f[j+-4>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+-12>>2]|0;l=f[q>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2]}else{f[m>>2]=0;U$(k,i)}k=(f[d>>2]|0)+-56|0;f[d>>2]=k;if((i|0)==(g|0)){h=k;break}else j=k}}j=a+4|0;g=f[j>>2]|0;i=b+8|0;if((g|0)==(c|0)){r=d;s=h;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}h=c;c=f[i>>2]|0;do{f[c>>2]=f[h>>2];k=c+4|0;m=h+4|0;f[k>>2]=f[m>>2];n=c+8|0;f[n>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];f[c+28>>2]=f[h+28>>2];f[c+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[c+36>>2]=l;f[c+40>>2]=n;n=c+48|0;q=c+44|0;f[q>>2]=n;f[n>>2]=0;f[c+52>>2]=0;if(l|0){n=l+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[h+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[k>>2]=0;U$(c,h)}h=h+56|0;c=(f[i>>2]|0)+56|0;f[i>>2]=c}while((h|0)!=(g|0));r=d;s=f[d>>2]|0;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}function wQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=a+4|0;a=f[e>>2]|0;g=a-d|0;d=b+(((g|0)/48|0)*48|0)|0;if(d>>>0<c>>>0){h=d;i=a;do{f[i>>2]=f[h>>2];j=h+4|0;f[i+4>>2]=f[j>>2];k=i+8|0;l=h+8|0;f[k>>2]=f[l>>2];f[i+12>>2]=f[h+12>>2];f[i+16>>2]=f[h+16>>2];f[i+20>>2]=f[h+20>>2];m=h+24|0;f[i+24>>2]=f[m>>2];n=h+28|0;f[i+28>>2]=f[n>>2];o=i+32|0;f[o>>2]=k;k=i+36|0;p=i+40|0;f[k>>2]=p;q=i+44|0;f[q>>2]=0;f[p>>2]=0;r=h+36|0;if((f[j>>2]|0)<3){s=f[r>>2]|0;f[p>>2]=f[s>>2];f[q>>2]=f[s+4>>2]}else{f[k>>2]=f[r>>2];k=h+32|0;f[o>>2]=f[k>>2];f[r>>2]=h+40;f[k>>2]=l}f[h>>2]=1124007936;f[m>>2]=0;f[n>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;h=h+48|0;i=(f[e>>2]|0)+48|0;f[e>>2]=i}while(h>>>0<c>>>0)}if(!g)return;else{t=d;u=a}do{a=t;t=t+-48|0;d=u;u=u+-48|0;if((d|0)!=(a|0)){g=d+-24|0;c=f[g>>2]|0;if(c|0?(h=c+8|0,c=f[h>>2]|0,f[h>>2]=c+-1,(c|0)==1):0)FQ(u);c=d+-44|0;if((f[c>>2]|0)>0){h=f[d+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}f[g>>2]=0;f[u>>2]=f[t>>2];i=a+-44|0;f[c>>2]=f[i>>2];h=a+-40|0;e=d+-40|0;f[e>>2]=f[h>>2];f[d+-36>>2]=f[a+-36>>2];f[d+-32>>2]=f[a+-32>>2];f[d+-28>>2]=f[a+-28>>2];j=a+-24|0;f[g>>2]=f[j>>2];n=a+-20|0;f[d+-20>>2]=f[n>>2];m=d+-12|0;l=f[m>>2]|0;k=d+-8|0;if((l|0)==(k|0))v=l;else{wL(l);f[m>>2]=k;f[d+-16>>2]=e;v=k}k=a+-12|0;if((f[i>>2]|0)<3){e=f[k>>2]|0;f[v>>2]=f[e>>2];f[v+4>>2]=f[e+4>>2]}else{f[m>>2]=f[k>>2];m=a+-16|0;f[d+-16>>2]=f[m>>2];f[k>>2]=a+-8;f[m>>2]=h}f[t>>2]=1124007936;f[j>>2]=0;f[n>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0}}while((t|0)!=(b|0));return}function xQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=b+4|0;e=f[d>>2]|0;g=f[a>>2]|0;if((g|0)==(c|0))h=e;else{i=c;j=e;while(1){k=j+-48|0;l=i;i=i+-48|0;f[k>>2]=f[i>>2];m=j+-44|0;n=l+-44|0;f[m>>2]=f[n>>2];o=j+-40|0;f[o>>2]=f[l+-40>>2];f[j+-36>>2]=f[l+-36>>2];f[j+-32>>2]=f[l+-32>>2];f[j+-28>>2]=f[l+-28>>2];p=f[l+-24>>2]|0;f[j+-24>>2]=p;f[j+-20>>2]=f[l+-20>>2];f[j+-16>>2]=o;o=j+-8|0;q=j+-12|0;f[q>>2]=o;f[j+-4>>2]=0;f[o>>2]=0;if(p|0){o=p+8|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+-12>>2]|0;l=f[q>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=f[n+4>>2]}else{f[m>>2]=0;DQ(k,i)}k=(f[d>>2]|0)+-48|0;f[d>>2]=k;if((i|0)==(g|0)){h=k;break}else j=k}}j=a+4|0;g=f[j>>2]|0;i=b+8|0;if((g|0)==(c|0)){r=d;s=h;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}h=c;c=f[i>>2]|0;do{f[c>>2]=f[h>>2];k=c+4|0;m=h+4|0;f[k>>2]=f[m>>2];n=c+8|0;f[n>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];l=f[h+24>>2]|0;f[c+24>>2]=l;f[c+28>>2]=f[h+28>>2];f[c+32>>2]=n;n=c+40|0;q=c+36|0;f[q>>2]=n;f[c+44>>2]=0;f[n>>2]=0;if(l|0){n=l+8|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[h+36>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[k>>2]=0;DQ(c,h)}h=h+48|0;c=(f[i>>2]|0)+48|0;f[i>>2]=c}while((h|0)!=(g|0));r=d;s=f[d>>2]|0;t=f[a>>2]|0;f[a>>2]=s;f[r>>2]=t;u=f[j>>2]|0;v=f[i>>2]|0;f[j>>2]=v;f[i>>2]=u;w=a+8|0;x=b+12|0;y=f[w>>2]|0;z=f[x>>2]|0;f[w>>2]=z;f[x>>2]=y;A=f[r>>2]|0;f[b>>2]=A;return e|0}function yQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=118444;b=a+16|0;c=f[b>>2]|0;if(c|0){d=a+20|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;do{e=h+-48|0;f[d>>2]=e;EQ(e);h=f[d>>2]|0}while((h|0)!=(c|0));g=f[b>>2]|0}cYc(g)}hx(a+4|0);qP(a);cYc(a);return}function zQb(a){a=a|0;return 1}function AQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=u;u=u+128|0;g=e+112|0;h=e+56|0;i=e;j=f[c+28>>2]|0;k=b[c+32>>0]|0;l=$Xc(48)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=118572;m=l+12|0;yP(m);n=l+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[m>>2]=118508;f[l+40>>2]=j;b[l+44>>0]=k;k=m;m=l;if(d){f[a>>2]=k;o=a+4|0;f[o>>2]=m;u=e;return}d=c+4|0;l=c+8|0;hS(n,((f[l>>2]|0)-(f[d>>2]|0)|0)/56|0);c=f[d>>2]|0;d=f[l>>2]|0;if((c|0)!=(d|0)){l=i+4|0;j=i+8|0;p=i+12|0;q=i+16|0;r=i+20|0;s=i+24|0;t=i+28|0;v=i+32|0;w=i+36|0;x=i+40|0;y=i+48|0;z=i+44|0;A=i+52|0;B=h+36|0;C=h+16|0;D=h+4|0;E=h+40|0;F=h+44|0;G=h+48|0;H=h+8|0;I=h+12|0;J=h+20|0;K=h+24|0;L=h+28|0;M=h+32|0;N=h+44|0;O=h+52|0;P=g+8|0;Q=g+4|0;R=c;c=f[n>>2]|0;while(1){f[i>>2]=f[R>>2];n=R+4|0;f[l>>2]=f[n>>2];f[j>>2]=f[R+8>>2];f[p>>2]=f[R+12>>2];f[q>>2]=f[R+16>>2];f[r>>2]=f[R+20>>2];f[s>>2]=f[R+24>>2];f[t>>2]=f[R+28>>2];f[v>>2]=f[R+32>>2];S=f[R+36>>2]|0;f[w>>2]=S;f[x>>2]=j;f[z>>2]=y;f[y>>2]=0;f[A>>2]=0;if(S|0){T=S+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[n>>2]|0)<3){n=f[R+44>>2]|0;T=f[z>>2]|0;f[T>>2]=f[n>>2];f[T+4>>2]=f[n+4>>2]}else{f[l>>2]=0;U$(i,R)}f[h>>2]=1124007936;n=D;T=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(T|0));f[E>>2]=H;f[F>>2]=G;f[G>>2]=0;f[O>>2]=0;S=P;f[S>>2]=0;f[S+4>>2]=0;f[g>>2]=33619968;f[Q>>2]=h;jR(i,g);if((c|0)==(h|0)){S=f[B>>2]|0;if(S|0?(U=S+12|0,S=f[U>>2]|0,f[U>>2]=S+-1,(S|0)==1):0)V$(h)}else{S=c+36|0;U=f[S>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)V$(c);f[S>>2]=0;U=c+16|0;V=c+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[V>>2]|0)>0){W=f[c+40>>2]|0;X=0;do{f[W+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[V>>2]|0))}f[c>>2]=f[h>>2];f[V>>2]=f[D>>2];X=c+8|0;f[X>>2]=f[H>>2];f[c+12>>2]=f[I>>2];f[U>>2]=f[C>>2];f[c+20>>2]=f[J>>2];f[c+24>>2]=f[K>>2];f[c+28>>2]=f[L>>2];f[c+32>>2]=f[M>>2];f[S>>2]=f[B>>2];W=c+44|0;Y=f[W>>2]|0;Z=c+48|0;if((Y|0)==(Z|0))_=Y;else{wL(Y);f[W>>2]=Z;f[c+40>>2]=X;_=Z}if((f[D>>2]|0)<3){Z=f[N>>2]|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2]}else{f[W>>2]=f[N>>2];f[c+40>>2]=f[E>>2];f[N>>2]=G;f[E>>2]=H}f[h>>2]=1124007936;n=D;T=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(T|0))}f[B>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[D>>2]|0)>0){n=f[E>>2]|0;T=0;do{f[n+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[D>>2]|0))}T=f[F>>2]|0;if((T|0)!=(G|0))wL(T);T=f[w>>2]|0;if(T|0?(n=T+12|0,T=f[n>>2]|0,f[n>>2]=T+-1,(T|0)==1):0)V$(i);f[w>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[l>>2]|0)>0){T=f[x>>2]|0;n=0;do{f[T+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}n=f[z>>2]|0;if((n|0)!=(y|0))wL(n);R=R+56|0;if((R|0)==(d|0))break;else c=c+56|0}}f[a>>2]=k;o=a+4|0;f[o>>2]=m;u=e;return}function BQb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;i=u;u=u+368|0;j=i+344|0;k=i+288|0;l=i+232|0;m=i+176|0;n=i+120|0;o=i+104|0;p=i+88|0;q=i+72|0;r=i+56|0;s=i;t=a+4|0;v=f[t>>2]|0;w=a+8|0;if((v|0)==(f[w>>2]|0))x=f[a+16>>2]|0;else x=v;v=f[x>>2]&4095;if((dS(c,-1)|0)!=(v|0)){v=$Xc(48)|0;f[j>>2]=v;f[j+8>>2]=-2147483600;f[j+4>>2]=41;y=v;z=465722;A=y+41|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[v+41>>0]=0;vM(-215,j,465780,465621,756)}do if(!(sS(c)|0)){if((f[t>>2]|0)==(f[w>>2]|0)?(f[a+16>>2]|0)==(f[a+20>>2]|0):0)break;f[j>>2]=0;v=j+4|0;f[v>>2]=0;f[j+8>>2]=0;gS(g,j);if((f[t>>2]|0)!=(f[w>>2]|0)?(x=a+16|0,B=f[x>>2]|0,C=a+20|0,D=f[C>>2]|0,(B|0)!=(D|0)):0){if((D-B|0)>0){E=k+4|0;F=k+8|0;G=k+40|0;H=k+48|0;I=k+44|0;K=k+52|0;L=l+8|0;M=l+4|0;N=a+12|0;O=k+36|0;P=k+16|0;Q=k+12|0;R=k+20|0;S=k+24|0;T=k+28|0;U=k+32|0;V=0;W=B;do{f[k>>2]=1124007936;y=E;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[G>>2]=F;f[I>>2]=H;f[H>>2]=0;f[K>>2]=0;X=L;f[X>>2]=0;f[X+4>>2]=0;f[l>>2]=33619968;f[M>>2]=k;LQ(W+(V*48|0)|0,l);X=f[w>>2]|0;if((X|0)==(f[N>>2]|0))bx(t,k);else{f[X>>2]=f[k>>2];Z=X+4|0;f[Z>>2]=f[E>>2];_=X+8|0;f[_>>2]=f[F>>2];f[X+12>>2]=f[Q>>2];f[X+16>>2]=f[P>>2];f[X+20>>2]=f[R>>2];f[X+24>>2]=f[S>>2];f[X+28>>2]=f[T>>2];f[X+32>>2]=f[U>>2];$=f[O>>2]|0;f[X+36>>2]=$;f[X+40>>2]=_;_=X+48|0;aa=X+44|0;f[aa>>2]=_;f[_>>2]=0;f[X+52>>2]=0;if($|0){_=$+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[E>>2]|0)<3){_=f[I>>2]|0;$=f[aa>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;U$(X,k)}f[w>>2]=(f[w>>2]|0)+56}X=f[O>>2]|0;if(X|0?(Z=X+12|0,X=f[Z>>2]|0,f[Z>>2]=X+-1,(X|0)==1):0)V$(k);f[O>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[E>>2]|0)>0){X=f[G>>2]|0;Z=0;do{f[X+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[E>>2]|0))}Z=f[I>>2]|0;if((Z|0)!=(H|0))wL(Z);V=V+1|0;ba=f[C>>2]|0;Z=f[x>>2]|0;W=Z}while((V|0)<((ba-Z|0)/48|0|0));ca=ba;da=W}else{ca=D;da=B}if((ca|0)!=(da|0)){V=ca;do{x=V+-48|0;f[C>>2]=x;EQ(x);V=f[C>>2]|0}while((V|0)!=(da|0))}}do if((eS(c)|0)==65536){V=f[c+4>>2]|0;f[k>>2]=f[V>>2];C=k+4|0;B=V+4|0;f[C>>2]=f[B>>2];D=k+8|0;f[D>>2]=f[V+8>>2];f[k+12>>2]=f[V+12>>2];f[k+16>>2]=f[V+16>>2];f[k+20>>2]=f[V+20>>2];f[k+24>>2]=f[V+24>>2];f[k+28>>2]=f[V+28>>2];f[k+32>>2]=f[V+32>>2];W=f[V+36>>2]|0;f[k+36>>2]=W;f[k+40>>2]=D;D=k+48|0;x=k+44|0;f[x>>2]=D;f[D>>2]=0;f[k+52>>2]=0;if(W|0){D=W+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[V+44>>2]|0;D=f[x>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];break}else{f[C>>2]=0;U$(k,V);break}}else bS(k,c,-1);while(0);if((f[t>>2]|0)==(f[w>>2]|0)?(V=a+16|0,C=f[V>>2]|0,B=a+20|0,D=f[B>>2]|0,(C|0)!=(D|0)):0){if((D-C|0)>0){x=l+4|0;W=l+8|0;H=l+40|0;I=l+48|0;E=l+44|0;G=l+52|0;P=m+8|0;O=m+4|0;U=a+12|0;T=l+36|0;S=l+16|0;R=l+12|0;Q=l+20|0;F=l+24|0;N=l+28|0;M=l+32|0;L=0;K=C;do{f[l>>2]=1124007936;y=x;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[H>>2]=W;f[E>>2]=I;f[I>>2]=0;f[G>>2]=0;Z=P;f[Z>>2]=0;f[Z+4>>2]=0;f[m>>2]=33619968;f[O>>2]=l;LQ(K+(L*48|0)|0,m);Z=f[w>>2]|0;if((Z|0)==(f[U>>2]|0))bx(t,l);else{f[Z>>2]=f[l>>2];X=Z+4|0;f[X>>2]=f[x>>2];_=Z+8|0;f[_>>2]=f[W>>2];f[Z+12>>2]=f[R>>2];f[Z+16>>2]=f[S>>2];f[Z+20>>2]=f[Q>>2];f[Z+24>>2]=f[F>>2];f[Z+28>>2]=f[N>>2];f[Z+32>>2]=f[M>>2];$=f[T>>2]|0;f[Z+36>>2]=$;f[Z+40>>2]=_;_=Z+48|0;aa=Z+44|0;f[aa>>2]=_;f[_>>2]=0;f[Z+52>>2]=0;if($|0){_=$+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[x>>2]|0)<3){_=f[E>>2]|0;$=f[aa>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2]}else{f[X>>2]=0;U$(Z,l)}f[w>>2]=(f[w>>2]|0)+56}Z=f[T>>2]|0;if(Z|0?(X=Z+12|0,Z=f[X>>2]|0,f[X>>2]=Z+-1,(Z|0)==1):0)V$(l);f[T>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[x>>2]|0)>0){Z=f[H>>2]|0;X=0;do{f[Z+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[x>>2]|0))}X=f[E>>2]|0;if((X|0)!=(I|0))wL(X);L=L+1|0;ea=f[B>>2]|0;X=f[V>>2]|0;K=X}while((L|0)<((ea-X|0)/48|0|0));fa=ea;ga=K}else{fa=D;ga=C}if((fa|0)!=(ga|0)){L=fa;do{V=L+-48|0;f[B>>2]=V;EQ(V);L=f[B>>2]|0}while((L|0)!=(ga|0))}}L=k+8|0;HQb(d,f[L>>2]|0);f[l>>2]=1124007936;B=l+4|0;C=l+8|0;D=l+40|0;y=B;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[D>>2]=C;K=l+48|0;V=l+44|0;f[V>>2]=K;f[K>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;I=m+4|0;E=m+8|0;x=m+40|0;y=I;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[x>>2]=E;H=m+48|0;S=m+44|0;f[S>>2]=H;f[H>>2]=0;f[m+52>>2]=0;T=f[t>>2]|0;M=(f[w>>2]|0)-T|0;N=(M|0)/56|0;F=a+28|0;Q=T;switch(f[F>>2]|0){case 7:case 6:{ha=1;break}case 2:{ha=(f[k>>2]&4095|0)==0;break}default:ha=0}T=ha?4:5;R=u1c(N|0,((N|0)<0)<<31>>31|0,18)|0;W=J;if(!((W|0)<0|(W|0)==0&R>>>0<2147483647)){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;R=$Xc(48)|0;f[n>>2]=R;f[n+8>>2]=-2147483600;f[n+4>>2]=36;y=R;z=465793;A=y+36|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[R+36>>0]=0;vM(-215,n,465780,465621,851)}a:do if((M|0)>0){E=n+8|0;W=n+12|0;U=n+4|0;O=o+8|0;P=o+12|0;G=o+4|0;X=p+8|0;Z=p+4|0;_=q+8|0;$=q+4|0;aa=s+4|0;ia=s+8|0;ja=s+40|0;ka=s+48|0;la=s+44|0;ma=s+52|0;na=r+8|0;oa=r+12|0;pa=r+4|0;qa=a+32|0;ra=s+36|0;sa=s+16|0;ta=s+12|0;ua=s+20|0;va=s+24|0;wa=s+28|0;xa=s+32|0;if((f[Q+8>>2]|0)<262144){ya=0;za=0;Aa=Q}else{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;Ba=$Xc(48)|0;f[n>>2]=Ba;Ca=n+8|0;f[Ca>>2]=-2147483600;Da=n+4|0;f[Da>>2]=43;y=Ba;z=465830;A=y+43|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Ea=Ba+43|0;b[Ea>>0]=0;vM(-215,n,465780,465621,855)}while(1){f[E>>2]=0;f[W>>2]=0;f[n>>2]=16842752;f[U>>2]=k;f[O>>2]=0;f[P>>2]=0;f[o>>2]=16842752;f[G>>2]=Aa+(za*56|0);Fa=X;f[Fa>>2]=0;f[Fa+4>>2]=0;f[p>>2]=33619968;f[Z>>2]=l;Fa=_;f[Fa>>2]=0;f[Fa+4>>2]=0;f[q>>2]=33619968;f[$>>2]=m;Fa=f[F>>2]|0;Ga=f[j>>2]|0;do if((Ga|0)!=(f[v>>2]|0)){Ha=Ga+(za*56|0)|0;f[s>>2]=f[Ha>>2];Ia=Ga+(za*56|0)+4|0;f[aa>>2]=f[Ia>>2];f[ia>>2]=f[Ga+(za*56|0)+8>>2];f[ta>>2]=f[Ga+(za*56|0)+12>>2];f[sa>>2]=f[Ga+(za*56|0)+16>>2];f[ua>>2]=f[Ga+(za*56|0)+20>>2];f[va>>2]=f[Ga+(za*56|0)+24>>2];f[wa>>2]=f[Ga+(za*56|0)+28>>2];f[xa>>2]=f[Ga+(za*56|0)+32>>2];Ja=f[Ga+(za*56|0)+36>>2]|0;f[ra>>2]=Ja;f[ja>>2]=ia;f[la>>2]=ka;f[ka>>2]=0;f[ma>>2]=0;if(Ja|0){Ka=Ja+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Ia>>2]|0)<3){Ia=f[Ga+(za*56|0)+44>>2]|0;Ka=f[la>>2]|0;f[Ka>>2]=f[Ia>>2];f[Ka+4>>2]=f[Ia+4>>2];break}else{f[aa>>2]=0;U$(s,Ha);break}}else{f[s>>2]=1124007936;y=aa;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[ja>>2]=ia;f[la>>2]=ka;f[ka>>2]=0;f[ma>>2]=0}while(0);f[na>>2]=0;f[oa>>2]=0;f[r>>2]=16842752;f[pa>>2]=s;pGc(n,o,p,T,q,Fa,e,r,ya,(b[qa>>0]|0)!=0);Ga=f[ra>>2]|0;if(Ga|0?(Ha=Ga+12|0,Ga=f[Ha>>2]|0,f[Ha>>2]=Ga+-1,(Ga|0)==1):0)V$(s);f[ra>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[aa>>2]|0)>0){Ga=f[ja>>2]|0;Ha=0;do{f[Ga+(Ha<<2)>>2]=0;Ha=Ha+1|0}while((Ha|0)<(f[aa>>2]|0))}Ha=f[la>>2]|0;if((Ha|0)!=(ka|0))wL(Ha);za=za+1|0;if((za|0)>=(N|0))break a;Aa=f[t>>2]|0;if((f[Aa+(za*56|0)+8>>2]|0)>=262144)break;else ya=ya+262144|0}f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;Ba=$Xc(48)|0;f[n>>2]=Ba;Ca=n+8|0;f[Ca>>2]=-2147483600;Da=n+4|0;f[Da>>2]=43;y=Ba;z=465830;A=y+43|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Ea=Ba+43|0;b[Ea>>0]=0;vM(-215,n,465780,465621,855)}while(0);if(ha){f[n>>2]=1124007936;N=n+4|0;T=n+8|0;v=n+40|0;y=N;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[v>>2]=T;F=n+48|0;Q=n+44|0;f[Q>>2]=F;f[F>>2]=0;f[n+52>>2]=0;M=o+8|0;f[M>>2]=0;f[M+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=n;dY(l,o,5,1.0,0.0);M=n+36|0;R=f[M>>2]|0;if(R|0){ka=R+12|0;f[ka>>2]=(f[ka>>2]|0)+1}ka=l+36|0;R=f[ka>>2]|0;if(R|0?(la=R+12|0,R=f[la>>2]|0,f[la>>2]=R+-1,(R|0)==1):0)V$(l);f[ka>>2]=0;R=l+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[B>>2]|0)>0){la=f[D>>2]|0;aa=0;do{f[la+(aa<<2)>>2]=0;aa=aa+1|0;La=f[B>>2]|0}while((aa|0)<(La|0));f[l>>2]=f[n>>2];if((La|0)<3)Ma=108;else Ma=110}else{f[l>>2]=f[n>>2];Ma=108}if((Ma|0)==108){aa=f[N>>2]|0;if((aa|0)<3){f[B>>2]=aa;f[C>>2]=f[T>>2];f[l+12>>2]=f[n+12>>2];aa=f[Q>>2]|0;la=f[V>>2]|0;f[la>>2]=f[aa>>2];f[la+4>>2]=f[aa+4>>2]}else Ma=110}if((Ma|0)==110)U$(l,n);aa=n+16|0;f[R>>2]=f[aa>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];la=f[M>>2]|0;f[ka>>2]=la;if(la|0?(ja=la+12|0,la=f[ja>>2]|0,f[ja>>2]=la+-1,(la|0)==1):0)V$(n);f[M>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[N>>2]|0)>0){aa=f[v>>2]|0;la=0;do{f[aa+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[N>>2]|0))}N=f[Q>>2]|0;if((N|0)!=(F|0))wL(N)}if((f[L>>2]|0)>0){N=l+16|0;la=m+16|0;aa=n+4|0;v=n+8|0;M=d+4|0;ka=d+8|0;R=n+8|0;T=m+12|0;C=h^1;ja=n+4|0;sa=n+8|0;ra=n+12|0;qa=0;do{pa=(f[N>>2]|0)+(Y(f[f[V>>2]>>2]|0,qa)|0)|0;oa=(f[la>>2]|0)+(Y(f[f[S>>2]>>2]|0,qa)|0)|0;f[n>>2]=0;f[aa>>2]=0;f[v>>2]=0;na=f[M>>2]|0;if(na>>>0>=(f[ka>>2]|0)>>>0){IQb(d,n);ma=f[n>>2]|0;if(ma|0){ia=f[aa>>2]|0;if((ia|0)!=(ma|0))f[aa>>2]=ia+(~((ia+-16-ma|0)>>>4)<<4);cYc(ma)}}else{f[na>>2]=0;ma=na+4|0;f[ma>>2]=0;f[na+8>>2]=0;f[na>>2]=f[n>>2];f[ma>>2]=f[aa>>2];f[na+8>>2]=f[R>>2];f[R>>2]=0;f[aa>>2]=0;f[n>>2]=0;f[M>>2]=(f[M>>2]|0)+12}na=f[M>>2]|0;ma=na+-12|0;JQb(ma,e);ia=na+-8|0;b:do if((f[T>>2]|0)>0){xa=na+-4|0;wa=0;do{va=f[oa+(wa<<2)>>2]|0;if((va|0)<0)break b;ua=f[pa+(wa<<2)>>2]|0;f[n>>2]=qa;f[ja>>2]=va&262143;f[sa>>2]=va>>>18;f[ra>>2]=ua;ua=f[ia>>2]|0;if(ua>>>0<(f[xa>>2]|0)>>>0){f[ua>>2]=f[n>>2];f[ua+4>>2]=f[n+4>>2];f[ua+8>>2]=f[n+8>>2];f[ua+12>>2]=f[n+12>>2];f[ia>>2]=(f[ia>>2]|0)+16}else OA(ma,n);wa=wa+1|0}while((wa|0)<(f[T>>2]|0))}while(0);if(!((f[ma>>2]|0)!=(f[ia>>2]|0)|C)){pa=f[M>>2]|0;oa=pa+-12|0;na=pa;while(1){pa=na+-12|0;f[M>>2]=pa;wa=f[pa>>2]|0;if(!wa)Na=pa;else{pa=na+-8|0;xa=f[pa>>2]|0;if((xa|0)!=(wa|0))f[pa>>2]=xa+(~((xa+-16-wa|0)>>>4)<<4);cYc(wa);Na=f[M>>2]|0}if((Na|0)==(oa|0))break;else na=Na}}qa=qa+1|0}while((qa|0)<(f[L>>2]|0))}L=m+36|0;qa=f[L>>2]|0;if(qa|0?(M=qa+12|0,qa=f[M>>2]|0,f[M>>2]=qa+-1,(qa|0)==1):0)V$(m);f[L>>2]=0;L=m+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[I>>2]|0)>0){L=f[x>>2]|0;qa=0;do{f[L+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[I>>2]|0))}I=f[S>>2]|0;if((I|0)!=(H|0))wL(I);I=l+36|0;qa=f[I>>2]|0;if(qa|0?(L=qa+12|0,qa=f[L>>2]|0,f[L>>2]=qa+-1,(qa|0)==1):0)V$(l);f[I>>2]=0;I=l+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[B>>2]|0)>0){I=f[D>>2]|0;qa=0;do{f[I+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[B>>2]|0))}B=f[V>>2]|0;if((B|0)!=(K|0))wL(B);B=k+36|0;qa=f[B>>2]|0;do if(qa|0){I=qa+12|0;D=f[I>>2]|0;f[I>>2]=D+-1;if((D|0)!=1)break;V$(k)}while(0);f[B>>2]=0;qa=k+16|0;K=k+4|0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[K>>2]|0)>0){qa=f[k+40>>2]|0;V=0;do{f[qa+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[K>>2]|0))}K=f[k+44>>2]|0;if((K|0)!=(k+48|0))wL(K);hx(j);u=i;return}while(0);j=f[d>>2]|0;k=d+4|0;d=f[k>>2]|0;if((d|0)==(j|0)){u=i;return}else Oa=d;while(1){d=Oa+-12|0;f[k>>2]=d;l=f[d>>2]|0;if(!l)Pa=d;else{d=Oa+-8|0;m=f[d>>2]|0;if((m|0)!=(l|0))f[d>>2]=m+(~((m+-16-l|0)>>>4)<<4);cYc(l);Pa=f[k>>2]|0}if((Pa|0)==(j|0))break;else Oa=Pa}u=i;return}function CQb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;i=u;u=u+352|0;j=i;k=i+328|0;l=i+272|0;m=i+216|0;o=i+160|0;p=i+144|0;q=i+128|0;r=i+112|0;s=i+56|0;t=a+4|0;v=f[t>>2]|0;w=a+8|0;if((v|0)==(f[w>>2]|0))x=f[a+16>>2]|0;else x=v;v=f[x>>2]&4095;if((dS(c,-1)|0)!=(v|0)){v=$Xc(48)|0;f[j>>2]=v;f[j+8>>2]=-2147483600;f[j+4>>2]=41;y=v;x=465722;z=y+41|0;do{b[y>>0]=b[x>>0]|0;y=y+1|0;x=x+1|0}while((y|0)<(z|0));b[v+41>>0]=0;vM(-215,j,465764,465621,907)}do if(!(sS(c)|0)){if((f[t>>2]|0)==(f[w>>2]|0)?(f[a+16>>2]|0)==(f[a+20>>2]|0):0)break;f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;gS(g,k);if((f[t>>2]|0)!=(f[w>>2]|0)?(x=a+16|0,A=f[x>>2]|0,B=a+20|0,C=f[B>>2]|0,(A|0)!=(C|0)):0){if((C-A|0)>0){D=j+4|0;E=j+8|0;F=j+40|0;G=j+48|0;H=j+44|0;I=j+52|0;J=l+8|0;K=l+4|0;L=a+12|0;M=j+36|0;N=j+16|0;O=j+12|0;P=j+20|0;Q=j+24|0;R=j+28|0;S=j+32|0;T=0;U=A;do{f[j>>2]=1124007936;y=D;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[F>>2]=E;f[H>>2]=G;f[G>>2]=0;f[I>>2]=0;V=J;f[V>>2]=0;f[V+4>>2]=0;f[l>>2]=33619968;f[K>>2]=j;LQ(U+(T*48|0)|0,l);V=f[w>>2]|0;if((V|0)==(f[L>>2]|0))bx(t,j);else{f[V>>2]=f[j>>2];W=V+4|0;f[W>>2]=f[D>>2];X=V+8|0;f[X>>2]=f[E>>2];f[V+12>>2]=f[O>>2];f[V+16>>2]=f[N>>2];f[V+20>>2]=f[P>>2];f[V+24>>2]=f[Q>>2];f[V+28>>2]=f[R>>2];f[V+32>>2]=f[S>>2];Z=f[M>>2]|0;f[V+36>>2]=Z;f[V+40>>2]=X;X=V+48|0;_=V+44|0;f[_>>2]=X;f[X>>2]=0;f[V+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[D>>2]|0)<3){X=f[H>>2]|0;Z=f[_>>2]|0;f[Z>>2]=f[X>>2];f[Z+4>>2]=f[X+4>>2]}else{f[W>>2]=0;U$(V,j)}f[w>>2]=(f[w>>2]|0)+56}V=f[M>>2]|0;if(V|0?(W=V+12|0,V=f[W>>2]|0,f[W>>2]=V+-1,(V|0)==1):0)V$(j);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[D>>2]|0)>0){V=f[F>>2]|0;W=0;do{f[V+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[D>>2]|0))}W=f[H>>2]|0;if((W|0)!=(G|0))wL(W);T=T+1|0;$=f[B>>2]|0;W=f[x>>2]|0;U=W}while((T|0)<(($-W|0)/48|0|0));aa=$;ba=U}else{aa=C;ba=A}if((aa|0)!=(ba|0)){T=aa;do{x=T+-48|0;f[B>>2]=x;EQ(x);T=f[B>>2]|0}while((T|0)!=(ba|0))}}do if((eS(c)|0)==65536){T=f[c+4>>2]|0;f[l>>2]=f[T>>2];B=l+4|0;A=T+4|0;f[B>>2]=f[A>>2];C=l+8|0;f[C>>2]=f[T+8>>2];f[l+12>>2]=f[T+12>>2];f[l+16>>2]=f[T+16>>2];f[l+20>>2]=f[T+20>>2];f[l+24>>2]=f[T+24>>2];f[l+28>>2]=f[T+28>>2];f[l+32>>2]=f[T+32>>2];U=f[T+36>>2]|0;f[l+36>>2]=U;f[l+40>>2]=C;C=l+48|0;x=l+44|0;f[x>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(U|0){C=U+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[A>>2]|0)<3){A=f[T+44>>2]|0;C=f[x>>2]|0;f[C>>2]=f[A>>2];f[C+4>>2]=f[A+4>>2];break}else{f[B>>2]=0;U$(l,T);break}}else bS(l,c,-1);while(0);if((f[t>>2]|0)==(f[w>>2]|0)?(T=a+16|0,B=f[T>>2]|0,A=a+20|0,C=f[A>>2]|0,(B|0)!=(C|0)):0){if((C-B|0)>0){x=j+4|0;U=j+8|0;G=j+40|0;H=j+48|0;D=j+44|0;F=j+52|0;N=m+8|0;M=m+4|0;S=a+12|0;R=j+36|0;Q=j+16|0;P=j+12|0;O=j+20|0;E=j+24|0;L=j+28|0;K=j+32|0;J=0;I=B;do{f[j>>2]=1124007936;y=x;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[G>>2]=U;f[D>>2]=H;f[H>>2]=0;f[F>>2]=0;W=N;f[W>>2]=0;f[W+4>>2]=0;f[m>>2]=33619968;f[M>>2]=j;LQ(I+(J*48|0)|0,m);W=f[w>>2]|0;if((W|0)==(f[S>>2]|0))bx(t,j);else{f[W>>2]=f[j>>2];V=W+4|0;f[V>>2]=f[x>>2];X=W+8|0;f[X>>2]=f[U>>2];f[W+12>>2]=f[P>>2];f[W+16>>2]=f[Q>>2];f[W+20>>2]=f[O>>2];f[W+24>>2]=f[E>>2];f[W+28>>2]=f[L>>2];f[W+32>>2]=f[K>>2];Z=f[R>>2]|0;f[W+36>>2]=Z;f[W+40>>2]=X;X=W+48|0;_=W+44|0;f[_>>2]=X;f[X>>2]=0;f[W+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[x>>2]|0)<3){X=f[D>>2]|0;Z=f[_>>2]|0;f[Z>>2]=f[X>>2];f[Z+4>>2]=f[X+4>>2]}else{f[V>>2]=0;U$(W,j)}f[w>>2]=(f[w>>2]|0)+56}W=f[R>>2]|0;if(W|0?(V=W+12|0,W=f[V>>2]|0,f[V>>2]=W+-1,(W|0)==1):0)V$(j);f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[x>>2]|0)>0){W=f[G>>2]|0;V=0;do{f[W+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[x>>2]|0))}V=f[D>>2]|0;if((V|0)!=(H|0))wL(V);J=J+1|0;ca=f[A>>2]|0;V=f[T>>2]|0;I=V}while((J|0)<((ca-V|0)/48|0|0));da=ca;ea=I}else{da=C;ea=B}if((da|0)!=(ea|0)){J=da;do{T=J+-48|0;f[A>>2]=T;EQ(T);J=f[A>>2]|0}while((J|0)!=(ea|0))}}J=l+8|0;A=f[J>>2]|0;B=d+4|0;C=f[B>>2]|0;I=f[d>>2]|0;T=(C-I|0)/12|0;H=I;I=C;if(A>>>0<=T>>>0){if(A>>>0<T>>>0?(C=H+(A*12|0)|0,(I|0)!=(C|0)):0){H=I;while(1){I=H+-12|0;f[B>>2]=I;D=f[I>>2]|0;if(!D)fa=I;else{I=H+-8|0;x=f[I>>2]|0;if((x|0)!=(D|0))f[I>>2]=x+(~((x+-16-D|0)>>>4)<<4);cYc(D);fa=f[B>>2]|0}if((fa|0)==(C|0))break;else H=fa}}}else DQb(d,A-T|0);f[m>>2]=1124007936;H=m+4|0;C=m+8|0;B=m+40|0;y=H;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[B>>2]=C;T=m+48|0;A=m+44|0;f[A>>2]=T;f[T>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;D=o+4|0;x=o+8|0;I=o+40|0;y=D;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[I>>2]=x;G=o+48|0;Q=o+44|0;f[Q>>2]=G;f[G>>2]=0;f[o+52>>2]=0;R=f[t>>2]|0;K=(f[w>>2]|0)-R|0;L=(K|0)/56|0;E=a+28|0;O=R;switch(f[E>>2]|0){case 7:case 6:{ga=1;break}case 2:{ga=(f[l>>2]&4095|0)==0;break}default:ga=0}R=ga?4:5;a:do if((K|0)>0){P=j+8|0;U=j+12|0;S=j+4|0;M=p+8|0;N=p+12|0;F=p+4|0;V=q+8|0;W=q+4|0;X=s+4|0;Z=s+8|0;_=s+40|0;ha=s+48|0;ia=s+44|0;ja=s+52|0;ka=r+8|0;la=r+12|0;ma=r+4|0;na=s+36|0;oa=s+16|0;pa=j+8|0;qa=j+4|0;ra=o+16|0;sa=o+12|0;ta=j+4|0;ua=j+8|0;va=j+12|0;wa=m+36|0;xa=o+36|0;ya=m+12|0;za=m+16|0;Aa=m+20|0;Ba=o+20|0;Ca=m+24|0;Da=o+24|0;Ea=m+28|0;Fa=o+28|0;Ga=m+32|0;Ha=o+32|0;Ia=s+12|0;Ja=s+20|0;Ka=s+24|0;La=s+28|0;Ma=s+32|0;Na=0;Oa=O;while(1){f[P>>2]=0;f[U>>2]=0;f[j>>2]=16842752;f[S>>2]=l;f[M>>2]=0;f[N>>2]=0;f[p>>2]=16842752;f[F>>2]=Oa+(Na*56|0);Pa=V;f[Pa>>2]=0;f[Pa+4>>2]=0;f[q>>2]=33619968;f[W>>2]=m;Pa=fT()|0;Qa=f[E>>2]|0;Ra=f[k>>2]|0;do if((Ra|0)!=(f[v>>2]|0)){Sa=Ra+(Na*56|0)|0;f[s>>2]=f[Sa>>2];Ta=Ra+(Na*56|0)+4|0;f[X>>2]=f[Ta>>2];f[Z>>2]=f[Ra+(Na*56|0)+8>>2];f[Ia>>2]=f[Ra+(Na*56|0)+12>>2];f[oa>>2]=f[Ra+(Na*56|0)+16>>2];f[Ja>>2]=f[Ra+(Na*56|0)+20>>2];f[Ka>>2]=f[Ra+(Na*56|0)+24>>2];f[La>>2]=f[Ra+(Na*56|0)+28>>2];f[Ma>>2]=f[Ra+(Na*56|0)+32>>2];Ua=f[Ra+(Na*56|0)+36>>2]|0;f[na>>2]=Ua;f[_>>2]=Z;f[ia>>2]=ha;f[ha>>2]=0;f[ja>>2]=0;if(Ua|0){Va=Ua+12|0;f[Va>>2]=(f[Va>>2]|0)+1}if((f[Ta>>2]|0)<3){Ta=f[Ra+(Na*56|0)+44>>2]|0;Va=f[ia>>2]|0;f[Va>>2]=f[Ta>>2];f[Va+4>>2]=f[Ta+4>>2];break}else{f[X>>2]=0;U$(s,Sa);break}}else{f[s>>2]=1124007936;y=X;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[_>>2]=Z;f[ia>>2]=ha;f[ha>>2]=0;f[ja>>2]=0}while(0);f[ka>>2]=0;f[la>>2]=0;f[r>>2]=16842752;f[ma>>2]=s;pGc(j,p,q,R,Pa,Qa,0,r,0,0);Ra=f[na>>2]|0;if(Ra|0?(Sa=Ra+12|0,Ra=f[Sa>>2]|0,f[Sa>>2]=Ra+-1,(Ra|0)==1):0)V$(s);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[X>>2]|0)>0){Ra=f[_>>2]|0;Sa=0;do{f[Ra+(Sa<<2)>>2]=0;Sa=Sa+1|0}while((Sa|0)<(f[X>>2]|0))}Sa=f[ia>>2]|0;if((Sa|0)!=(ha|0))wL(Sa);if(ga){Sa=pa;f[Sa>>2]=0;f[Sa+4>>2]=0;f[j>>2]=33619968;f[qa>>2]=o;dY(m,j,5,1.0,0.0)}else{Sa=f[wa>>2]|0;if(Sa|0){Ra=Sa+12|0;f[Ra>>2]=(f[Ra>>2]|0)+1}Ra=f[xa>>2]|0;do if(Ra|0){Sa=Ra+12|0;Qa=f[Sa>>2]|0;f[Sa>>2]=Qa+-1;if((Qa|0)!=1)break;V$(o)}while(0);f[xa>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[D>>2]|0)>0){Ra=f[I>>2]|0;Qa=0;do{f[Ra+(Qa<<2)>>2]=0;Qa=Qa+1|0;Wa=f[D>>2]|0}while((Qa|0)<(Wa|0));f[o>>2]=f[m>>2];if((Wa|0)<3)Xa=115;else Xa=117}else{f[o>>2]=f[m>>2];Xa=115}do if((Xa|0)==115){Xa=0;Qa=f[H>>2]|0;if((Qa|0)>=3){Xa=117;break}f[D>>2]=Qa;f[x>>2]=f[C>>2];f[sa>>2]=f[ya>>2];Qa=f[A>>2]|0;Ra=f[Q>>2]|0;f[Ra>>2]=f[Qa>>2];f[Ra+4>>2]=f[Qa+4>>2]}while(0);if((Xa|0)==117){Xa=0;U$(o,m)}f[ra>>2]=f[za>>2];f[Ba>>2]=f[Aa>>2];f[Da>>2]=f[Ca>>2];f[Fa>>2]=f[Ea>>2];f[Ha>>2]=f[Ga>>2];f[xa>>2]=f[wa>>2]}Qa=f[J>>2]|0;if((Qa|0)>0){Ra=0;Sa=f[sa>>2]|0;while(1){Pa=(f[ra>>2]|0)+(Y(f[f[Q>>2]>>2]|0,Ra)|0)|0;Ta=f[d>>2]|0;Va=Ta+(Ra*12|0)|0;if((Sa|0)>0){Ua=Ta+(Ra*12|0)+4|0;Ya=Ta+(Ra*12|0)+8|0;Ta=0;Za=Sa;while(1){_a=+n[Pa+(Ta<<2)>>2];if(!(_a<=e))$a=Za;else{f[j>>2]=Ra;f[ta>>2]=Ta;f[ua>>2]=Na;n[va>>2]=_a;ab=f[Ua>>2]|0;if(ab>>>0<(f[Ya>>2]|0)>>>0){f[ab>>2]=f[j>>2];f[ab+4>>2]=f[j+4>>2];f[ab+8>>2]=f[j+8>>2];f[ab+12>>2]=f[j+12>>2];f[Ua>>2]=(f[Ua>>2]|0)+16}else OA(Va,j);$a=f[sa>>2]|0}Ta=Ta+1|0;if((Ta|0)>=($a|0)){bb=$a;break}else Za=$a}}else bb=Sa;Ra=Ra+1|0;Za=f[J>>2]|0;if((Ra|0)>=(Za|0)){cb=Za;break}else Sa=bb}}else cb=Qa;Sa=Na+1|0;if((Sa|0)>=(L|0)){db=cb;break a}Na=Sa;Oa=f[t>>2]|0}}else db=f[J>>2]|0;while(0);b:do if((db|0)>0){if(h){eb=0;fb=0;gb=db}else{L=0;while(1){C=f[d>>2]|0;EQb(f[C+(L*12|0)>>2]|0,f[C+(L*12|0)+4>>2]|0,j);L=L+1|0;if((L|0)>=(f[J>>2]|0))break b}}while(1){L=f[d>>2]|0;C=L+(eb*12|0)|0;x=f[C>>2]|0;R=L+(eb*12|0)+4|0;v=x;if((x|0)==(f[R>>2]|0)){hb=fb;ib=gb}else{if((fb|0)<(eb|0)){x=L+(fb*12|0)|0;f[C>>2]=f[x>>2];f[x>>2]=v;v=L+(fb*12|0)+4|0;x=f[R>>2]|0;f[R>>2]=f[v>>2];f[v>>2]=x;x=L+(eb*12|0)+8|0;v=L+(fb*12|0)+8|0;R=f[x>>2]|0;f[x>>2]=f[v>>2];f[v>>2]=R;jb=f[d>>2]|0}else jb=L;EQb(f[jb+(fb*12|0)>>2]|0,f[jb+(fb*12|0)+4>>2]|0,j);hb=fb+1|0;ib=f[J>>2]|0}eb=eb+1|0;if((eb|0)>=(ib|0))break;else{fb=hb;gb=ib}}}while(0);J=o+36|0;L=f[J>>2]|0;if(L|0?(R=L+12|0,L=f[R>>2]|0,f[R>>2]=L+-1,(L|0)==1):0)V$(o);f[J>>2]=0;J=o+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[D>>2]|0)>0){J=f[I>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[D>>2]|0))}D=f[Q>>2]|0;if((D|0)!=(G|0))wL(D);D=m+36|0;L=f[D>>2]|0;if(L|0?(J=L+12|0,L=f[J>>2]|0,f[J>>2]=L+-1,(L|0)==1):0)V$(m);f[D>>2]=0;D=m+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[H>>2]|0)>0){D=f[B>>2]|0;L=0;do{f[D+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[H>>2]|0))}H=f[A>>2]|0;if((H|0)!=(T|0))wL(H);H=l+36|0;L=f[H>>2]|0;if(L|0?(D=L+12|0,L=f[D>>2]|0,f[D>>2]=L+-1,(L|0)==1):0)V$(l);f[H>>2]=0;H=l+16|0;L=l+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[L>>2]|0)>0){H=f[l+40>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[L>>2]|0))}L=f[l+44>>2]|0;if((L|0)!=(l+48|0))wL(L);hx(k);u=i;return}while(0);k=f[d>>2]|0;l=d+4|0;d=f[l>>2]|0;if((d|0)==(k|0)){u=i;return}else kb=d;while(1){d=kb+-12|0;f[l>>2]=d;m=f[d>>2]|0;if(!m)lb=d;else{d=kb+-8|0;o=f[d>>2]|0;if((o|0)!=(m|0))f[d>>2]=o+(~((o+-16-m|0)>>>4)<<4);cYc(m);lb=f[l>>2]|0}if((lb|0)==(k|0))break;else kb=lb}u=i;return}function DQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=d;g=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=j+-12|0;b=i;i=i+-12|0;f[d>>2]=0;n=j+-8|0;f[n>>2]=0;f[j+-4>>2]=0;f[d>>2]=f[i>>2];d=b+-8|0;f[n>>2]=f[d>>2];n=b+-4|0;f[j+-4>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[i>>2]=0;j=h+-12|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=c;c=c+-12|0;m=f[c>>2]|0;if(m|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(m|0))f[e>>2]=q+(~((q+-16-m|0)>>>4)<<4);cYc(m)}}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function EQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-16|0;i=a+-4|0;j=g;while(1){k=j;b:while(1){l=k;m=b-l|0;o=m>>4;switch(o|0){case 2:{p=5;break a;break}case 3:{p=7;break a;break}case 4:{p=15;break a;break}case 5:{p=16;break a;break}case 1:case 0:{p=84;break a;break}default:{}}if((m|0)<496){p=22;break a}q=(o|0)/2|0;r=k+(q<<4)|0;do if((m|0)>15984){s=(o|0)/4|0;t=k+(s<<4)|0;v=r+(s<<4)|0;w=FQb(k,t,r,v,c)|0;x=v+12|0;if(!(+n[i>>2]<+n[x>>2])){y=w;z=k+(q<<4)+12|0;break};f[e>>2]=f[v>>2];f[e+4>>2]=f[v+4>>2];f[e+8>>2]=f[v+8>>2];f[e+12>>2]=f[v+12>>2];f[v>>2]=f[h>>2];f[v+4>>2]=f[h+4>>2];f[v+8>>2]=f[h+8>>2];f[v+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];A=w+1|0;B=k+(q<<4)+12|0;if(+n[x>>2]<+n[B>>2]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2];f[r+8>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];f[v>>2]=f[e>>2];f[v+4>>2]=f[e+4>>2];f[v+8>>2]=f[e+8>>2];f[v+12>>2]=f[e+12>>2];v=w+2|0;x=k+(s<<4)+12|0;if(+n[B>>2]<+n[x>>2]){f[e>>2]=f[t>>2];f[e+4>>2]=f[t+4>>2];f[e+8>>2]=f[t+8>>2];f[e+12>>2]=f[t+12>>2];f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];f[t+8>>2]=f[r+8>>2];f[t+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];if(+n[x>>2]<+n[k+12>>2]){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[t>>2]=f[e>>2];f[t+4>>2]=f[e+4>>2];f[t+8>>2]=f[e+8>>2];f[t+12>>2]=f[e+12>>2];y=w+4|0;z=B}else{y=w+3|0;z=B}}else{y=v;z=B}}else{y=A;z=B}}else{B=k+(q<<4)+12|0;C=+n[B>>2];A=k+12|0;v=+n[i>>2]<C;if(!(C<+n[A>>2])){if(!v){y=0;z=B;break};f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[B>>2]<+n[A>>2])){y=1;z=B;break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];y=2;z=B;break}if(v){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];y=1;z=B;break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];f[r+8>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];if(+n[i>>2]<+n[B>>2]){f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];y=2;z=B}else{y=1;z=B}}while(0);q=k+12|0;C=+n[q>>2];D=+n[z>>2];if(C<D){E=h;F=y;break}else G=h;while(1){o=G;G=G+-16|0;if((k|0)==(G|0))break;if(+n[o+-4>>2]<D){p=67;break b}}o=k+16|0;if(C<+n[i>>2])H=o;else{if((o|0)==(h|0)){p=84;break a}else I=o;while(1){if(C<+n[I+12>>2])break;o=I+16|0;if((o|0)==(h|0)){p=84;break a}else I=o}f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[I>>2]=f[h>>2];f[I+4>>2]=f[h+4>>2];f[I+8>>2]=f[h+8>>2];f[I+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];H=I+16|0}if((H|0)==(h|0)){p=84;break a}else{J=h;K=H}while(1){C=+n[q>>2];o=K;while(1){L=o+16|0;if(C<+n[o+12>>2]){M=J;break}else o=L}do{m=M;M=M+-16|0}while(C<+n[m+-4>>2]);if(o>>>0>=M>>>0){k=o;continue b};f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[o>>2]=f[M>>2];f[o+4>>2]=f[M+4>>2];f[o+8>>2]=f[M+8>>2];f[o+12>>2]=f[M+12>>2];f[M>>2]=f[e>>2];f[M+4>>2]=f[e+4>>2];f[M+8>>2]=f[e+8>>2];f[M+12>>2]=f[e+12>>2];J=M;K=L}}if((p|0)==67){p=0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[G>>2];f[k+4>>2]=f[G+4>>2];f[k+8>>2]=f[G+8>>2];f[k+12>>2]=f[G+12>>2];f[G>>2]=f[e>>2];f[G+4>>2]=f[e+4>>2];f[G+8>>2]=f[e+8>>2];f[G+12>>2]=f[e+12>>2];E=G;F=y+1|0}q=k+16|0;c:do if(q>>>0<E>>>0){m=r;B=E;v=q;A=F;while(1){C=+n[m+12>>2];w=v;while(1){N=w+16|0;if(+n[w+12>>2]<C)w=N;else{O=B;break}}do{o=O;O=O+-16|0}while(!(+n[o+-4>>2]<C));if(w>>>0>O>>>0){P=m;Q=A;R=w;break c};f[e>>2]=f[w>>2];f[e+4>>2]=f[w+4>>2];f[e+8>>2]=f[w+8>>2];f[e+12>>2]=f[w+12>>2];f[w>>2]=f[O>>2];f[w+4>>2]=f[O+4>>2];f[w+8>>2]=f[O+8>>2];f[w+12>>2]=f[O+12>>2];f[O>>2]=f[e>>2];f[O+4>>2]=f[e+4>>2];f[O+8>>2]=f[e+8>>2];f[O+12>>2]=f[e+12>>2];m=(m|0)==(w|0)?O:m;B=O;v=N;A=A+1|0}}else{P=r;Q=F;R=q}while(0);if((R|0)!=(P|0)?+n[P+12>>2]<+n[R+12>>2]:0){f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[P>>2];f[R+4>>2]=f[P+4>>2];f[R+8>>2]=f[P+8>>2];f[R+12>>2]=f[P+12>>2];f[P>>2]=f[e>>2];f[P+4>>2]=f[e+4>>2];f[P+8>>2]=f[e+8>>2];f[P+12>>2]=f[e+12>>2];S=Q+1|0}else S=Q;if(!S){T=GQb(k,R,c)|0;q=R+16|0;if(GQb(q,a,c)|0){p=83;break}if(T){j=q;continue}}q=R;if((q-l|0)>=(b-q|0)){p=82;break}EQb(k,R,c);j=R+16|0}if((p|0)==82){p=0;EQb(R+16|0,a,c);g=k;a=R;continue}else if((p|0)==83){p=0;if(T){p=84;break}else{g=k;a=R;continue}}}if((p|0)==5){if(!(+n[i>>2]<+n[k+12>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==7){R=k+16|0;g=k+28|0;C=+n[g>>2];T=k+12|0;l=+n[i>>2]<C;if(!(C<+n[T>>2])){if(!l){u=d;return};f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[h>>2];f[R+4>>2]=f[h+4>>2];f[R+8>>2]=f[h+8>>2];f[R+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[g>>2]<+n[T>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];u=d;return}if(l){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];if(!(+n[i>>2]<+n[g>>2])){u=d;return};f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[h>>2];f[R+4>>2]=f[h+4>>2];f[R+8>>2]=f[h+8>>2];f[R+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==15){FQb(k,k+16|0,k+32|0,h,c)|0;u=d;return}else if((p|0)==16){R=k+16|0;g=k+32|0;l=k+48|0;FQb(k,R,g,l,c)|0;c=k+60|0;if(!(+n[i>>2]<+n[c>>2])){u=d;return};f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];h=k+44|0;if(!(+n[c>>2]<+n[h>>2])){u=d;return};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];l=k+28|0;if(!(+n[h>>2]<+n[l>>2])){u=d;return};f[e>>2]=f[R>>2];f[e+4>>2]=f[R+4>>2];f[e+8>>2]=f[R+8>>2];f[e+12>>2]=f[R+12>>2];f[R>>2]=f[g>>2];f[R+4>>2]=f[g+4>>2];f[R+8>>2]=f[g+8>>2];f[R+12>>2]=f[g+12>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];if(!(+n[l>>2]<+n[k+12>>2])){u=d;return};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];u=d;return}else if((p|0)==22){R=k+32|0;l=k+16|0;g=k+28|0;C=+n[g>>2];D=+n[k+12>>2];U=+n[k+44>>2];h=U<C;do if(C<D){if(h){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[R>>2];f[k+4>>2]=f[R+4>>2];f[k+8>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2];break};f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];if(U<+n[g>>2]){f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[l>>2]=f[R>>2];f[l+4>>2]=f[R+4>>2];f[l+8>>2]=f[R+8>>2];f[l+12>>2]=f[R+12>>2];f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];f[R+12>>2]=f[e+12>>2]}}else if(h?(f[e>>2]=f[l>>2],f[e+4>>2]=f[l+4>>2],f[e+8>>2]=f[l+8>>2],f[e+12>>2]=f[l+12>>2],f[l>>2]=f[R>>2],f[l+4>>2]=f[R+4>>2],f[l+8>>2]=f[R+8>>2],f[l+12>>2]=f[R+12>>2],f[R>>2]=f[e>>2],f[R+4>>2]=f[e+4>>2],f[R+8>>2]=f[e+8>>2],f[R+12>>2]=f[e+12>>2],+n[g>>2]<D):0){f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2]}while(0);l=k+48|0;if((l|0)==(a|0)){u=d;return}g=l;l=R;while(1){D=+n[g+12>>2];if(D<+n[l+12>>2]){f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];R=l;h=g;while(1){f[h>>2]=f[R>>2];f[h+4>>2]=f[R+4>>2];f[h+8>>2]=f[R+8>>2];f[h+12>>2]=f[R+12>>2];if((R|0)==(k|0)){V=k;break}if(D<+n[R+-4>>2]){c=R;R=R+-16|0;h=c}else{V=R;break}}f[R>>2]=f[e>>2];f[R+4>>2]=f[e+4>>2];f[R+8>>2]=f[e+8>>2];n[V+12>>2]=D}h=g+16|0;if((h|0)==(a|0))break;else{c=g;g=h;l=c}}u=d;return}else if((p|0)==84){u=d;return}}function FQb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0;e=u;u=u+16|0;g=e;h=b+12|0;i=+n[h>>2];j=a+12|0;k=c+12|0;l=+n[k>>2]<i;do if(i<+n[j>>2]){if(l){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];m=1;break};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];if(+n[k>>2]<+n[h>>2]){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];m=2}else m=1}else if(l){f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(+n[h>>2]<+n[j>>2]){f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];m=2}else m=1}else m=0;while(0);if(!(+n[d+12>>2]<+n[k>>2])){o=m;u=e;return o|0};f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];if(!(+n[k>>2]<+n[h>>2])){o=m+1|0;u=e;return o|0};f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];f[g+8>>2]=f[b+8>>2];f[g+12>>2]=f[b+12>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];if(!(+n[h>>2]<+n[j>>2])){o=m+2|0;u=e;return o|0};f[g>>2]=f[a>>2];f[g+4>>2]=f[a+4>>2];f[g+8>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];o=m+3|0;u=e;return o|0}function GQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;switch(b-a>>4|0){case 2:{if(!(+n[b+-4>>2]<+n[a+12>>2])){g=1;u=d;return g|0}h=b+-16|0;f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 3:{h=a+16|0;i=b+-16|0;j=a+28|0;k=+n[j>>2];l=a+12|0;m=b+-4|0;o=+n[m>>2]<k;if(!(k<+n[l>>2])){if(!o){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];if(!(+n[j>>2]<+n[l>>2])){g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];g=1;u=d;return g|0}if(o){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[m>>2]<+n[j>>2])){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 4:{FQb(a,a+16|0,a+32|0,b+-16|0,c)|0;g=1;u=d;return g|0}case 5:{i=a+16|0;h=a+32|0;j=a+48|0;FQb(a,i,h,j,c)|0;c=a+60|0;if(!(+n[b+-4>>2]<+n[c>>2])){g=1;u=d;return g|0}m=b+-16|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[m>>2];f[j+4>>2]=f[m+4>>2];f[j+8>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];m=a+44|0;if(!(+n[c>>2]<+n[m>>2])){g=1;u=d;return g|0};f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];j=a+28|0;if(!(+n[m>>2]<+n[j>>2])){g=1;u=d;return g|0};f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];if(!(+n[j>>2]<+n[a+12>>2])){g=1;u=d;return g|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];g=1;u=d;return g|0}case 1:case 0:{g=1;u=d;return g|0}default:{i=a+32|0;j=a+16|0;h=a+28|0;k=+n[h>>2];p=+n[a+12>>2];q=+n[a+44>>2];m=q<k;do if(k<p){if(m){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];break};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[j>>2];f[a+4>>2]=f[j+4>>2];f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];if(q<+n[h>>2]){f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2]}}else if(m?(f[e>>2]=f[j>>2],f[e+4>>2]=f[j+4>>2],f[e+8>>2]=f[j+8>>2],f[e+12>>2]=f[j+12>>2],f[j>>2]=f[i>>2],f[j+4>>2]=f[i+4>>2],f[j+8>>2]=f[i+8>>2],f[j+12>>2]=f[i+12>>2],f[i>>2]=f[e>>2],f[i+4>>2]=f[e+4>>2],f[i+8>>2]=f[e+8>>2],f[i+12>>2]=f[e+12>>2],+n[h>>2]<p):0){f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[a>>2]=f[j>>2];f[a+4>>2]=f[j+4>>2];f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2]}while(0);j=a+48|0;a:do if((j|0)==(b|0)){r=1;s=0}else{h=j;m=0;c=i;while(1){p=+n[h+12>>2];if(p<+n[c+12>>2]){f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];o=c;l=h;while(1){f[l>>2]=f[o>>2];f[l+4>>2]=f[o+4>>2];f[l+8>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];if((o|0)==(a|0)){t=a;break}if(p<+n[o+-4>>2]){v=o;o=o+-16|0;l=v}else{t=o;break}}f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];f[o+8>>2]=f[e+8>>2];n[t+12>>2]=p;l=m+1|0;if((l|0)==8){r=0;s=(h+16|0)==(b|0);break a}else w=l}else w=m;l=h+16|0;if((l|0)==(b|0)){r=1;s=0;break}else{v=h;h=l;m=w;c=v}}}while(0);g=s|r;u=d;return g|0}}return 0}function HQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/12|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>357913941){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}h=f[g>>2]|0;i=$Xc(b*12|0)|0;j=i+(((h-d|0)/12|0)*12|0)|0;k=j;l=i+(b*12|0)|0;b=h;if((b|0)==(e|0)){m=k;n=d;o=e}else{d=b;b=k;h=j;do{j=h+-12|0;i=d;d=d+-12|0;f[j>>2]=0;p=h+-8|0;f[p>>2]=0;f[h+-4>>2]=0;f[j>>2]=f[d>>2];j=i+-8|0;f[p>>2]=f[j>>2];p=i+-4|0;f[h+-4>>2]=f[p>>2];f[p>>2]=0;f[j>>2]=0;f[d>>2]=0;h=b+-12|0;b=h}while((d|0)!=(e|0));m=b;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=k;f[c>>2]=l;l=n;if((o|0)!=(l|0)){c=o;do{o=c;c=c+-12|0;k=f[c>>2]|0;if(k|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(k|0))f[g>>2]=o+(~((o+-16-k|0)>>>4)<<4);cYc(k)}}while((c|0)!=(l|0))}if(!n)return;cYc(n);return}function IQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;g=d;i=k+(j*12|0)|0;f[k+(e*12|0)+8>>2]=0;f[d>>2]=f[b>>2];j=b+4|0;f[k+(e*12|0)+4>>2]=f[j>>2];l=b+8|0;f[k+(e*12|0)+8>>2]=f[l>>2];f[l>>2]=0;f[j>>2]=0;f[b>>2]=0;b=d+12|0;j=f[a>>2]|0;l=f[c>>2]|0;if((l|0)==(j|0)){m=g;n=j;o=j}else{e=l;l=g;g=d;do{d=g+-12|0;k=e;e=e+-12|0;f[d>>2]=0;p=g+-8|0;f[p>>2]=0;f[g+-4>>2]=0;f[d>>2]=f[e>>2];d=k+-8|0;f[p>>2]=f[d>>2];p=k+-4|0;f[g+-4>>2]=f[p>>2];f[p>>2]=0;f[d>>2]=0;f[e>>2]=0;g=l+-12|0;l=g}while((e|0)!=(j|0));m=l;n=f[a>>2]|0;o=f[c>>2]|0}f[a>>2]=m;f[c>>2]=b;f[h>>2]=i;i=n;if((o|0)!=(i|0)){h=o;do{o=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=o+-8|0;o=f[c>>2]|0;if((o|0)!=(b|0))f[c>>2]=o+(~((o+-16-b|0)>>>4)<<4);cYc(b)}}while((h|0)!=(i|0))}if(!n)return;cYc(n);return}function JQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>4;i=$Xc(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;cYc(d);return}function KQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=118572;b=a+12|0;f[b>>2]=118444;c=a+28|0;d=f[c>>2]|0;if(d|0){e=a+32|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;do{g=i+-48|0;f[e>>2]=g;EQ(g);i=f[e>>2]|0}while((i|0)!=(d|0));h=f[c>>2]|0}cYc(h)}hx(a+16|0);qP(b);NXc(a);return}function LQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=118572;b=a+12|0;f[b>>2]=118444;c=a+28|0;d=f[c>>2]|0;if(d|0){e=a+32|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;do{g=i+-48|0;f[e>>2]=g;EQ(g);i=f[e>>2]|0}while((i|0)!=(d|0));h=f[c>>2]|0}cYc(h)}hx(a+16|0);qP(b);NXc(a);cYc(a);return}function MQb(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function NQb(a){a=a|0;cYc(a);return}function OQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=118600;gQb(a+52|0);b=f[a+48>>2]|0;if(b|0)UXc(b);b=f[a+40>>2]|0;if(b|0)UXc(b);b=f[a+32>>2]|0;if(b|0)UXc(b);f[a>>2]=118444;b=a+16|0;c=f[b>>2]|0;if(!c){d=a+4|0;hx(d);qP(a);return}e=a+20|0;g=f[e>>2]|0;if((g|0)==(c|0))h=c;else{i=g;do{g=i+-48|0;f[e>>2]=g;EQ(g);i=f[e>>2]|0}while((i|0)!=(c|0));h=f[b>>2]|0}cYc(h);d=a+4|0;hx(d);qP(a);return}function PQb(a){a=a|0;OQb(a);cYc(a);return}function QQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;lQb(a);b=f[a+112>>2]|0;c=a+116|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);b=a+56|0;d=a+92|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+72|0;b=a+60|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+96>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}f[a+44>>2]=0;b=a+48|0;c=f[b>>2]|0;f[b>>2]=0;if(!c){g=a+124|0;f[g>>2]=0;return}UXc(c);g=a+124|0;f[g>>2]=0;return}function RQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+64|0;e=d;g=d+48|0;h=d+36|0;i=d+24|0;j=d+12|0;zP(a,c);k=$Xc(16)|0;f[e>>2]=k;f[e+8>>2]=-2147483632;f[e+4>>2]=11;l=k;m=466445;n=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+11>>0]=0;k=s5(c,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;o=e+11|0;b[o>>0]=1;b[e>>0]=91;b[e+1>>0]=0;s5(k,e)|0;if((b[o>>0]|0)<0)cYc(f[e>>2]|0);o=f[a+28>>2]|0;if(o|0){f[g>>2]=0;k=g+4|0;f[k>>2]=0;f[g+8>>2]=0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;kGc(o,g,h,i,j);a:do if((f[k>>2]|0)!=(f[g>>2]|0)){o=e+11|0;t=e+1|0;v=e+11|0;w=e+4|0;x=e+11|0;y=e+4|0;z=e+11|0;A=e+5|0;B=c+4|0;C=c+8|0;D=e+11|0;E=e+8|0;F=e+11|0;G=e+1|0;H=e+11|0;I=e+1|0;J=0;b:while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[o>>0]=1;b[e>>0]=123;b[t>>0]=0;K=s5(c,e)|0;if((b[o>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[v>>0]=4;f[e>>2]=1701667182;b[w>>0]=0;L=s5(K,e)|0;if((b[v>>0]|0)<0)cYc(f[e>>2]|0);K=s5(L,(f[g>>2]|0)+(J*12|0)|0)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[x>>0]=4;f[e>>2]=1701869940;b[y>>0]=0;L=s5(K,e)|0;if((b[x>>0]|0)<0)cYc(f[e>>2]|0);K=(f[h>>2]|0)+(J<<2)|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](L)|0){M=c+4|0;if((f[M>>2]|0)==6){N=39;break}o5(L,c+8|0,f[K>>2]|0);if(f[M>>2]&4|0)f[M>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[z>>0]=5;b[e>>0]=b[502066]|0;b[e+1>>0]=b[502067]|0;b[e+2>>0]=b[502068]|0;b[e+3>>0]=b[502069]|0;b[e+4>>0]=b[502070]|0;b[A>>0]=0;s5(L,e)|0;if((b[z>>0]|0)<0)cYc(f[e>>2]|0);L=f[(f[h>>2]|0)+(J<<2)>>2]|0;if(L>>>0>9){O=+p[(f[j>>2]|0)+(J<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=47;break}q5(c,C,O);if(f[B>>2]&4|0)f[B>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[D>>0]=8;M=e;f[M>>2]=1701869940;f[M+4>>2]=1701667182;b[E>>0]=0;M=s5(c,e)|0;if((b[D>>0]|0)<0)cYc(f[e>>2]|0);s5(M,(f[i>>2]|0)+(J*12|0)|0)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[F>>0]=1;b[e>>0]=125;b[G>>0]=0;s5(c,e)|0;if((b[F>>0]|0)<0)cYc(f[e>>2]|0)}else{switch(L|0){case 0:{L=~~+p[(f[j>>2]|0)+(J<<3)>>3]&255;if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=58;break b}o5(c,C,L&255);if(f[B>>2]&4|0)f[B>>2]=6}break}case 1:{L=~~+p[(f[j>>2]|0)+(J<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=63;break b}o5(c,C,L<<24>>24);if(f[B>>2]&4|0)f[B>>2]=6}break}case 2:{L=~~+p[(f[j>>2]|0)+(J<<3)>>3]&65535;if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=68;break b}o5(c,C,L&65535);if(f[B>>2]&4|0)f[B>>2]=6}break}case 3:{L=~~+p[(f[j>>2]|0)+(J<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=73;break b}o5(c,C,L<<16>>16);if(f[B>>2]&4|0)f[B>>2]=6}break}case 9:case 8:case 4:{L=~~+p[(f[j>>2]|0)+(J<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=78;break b}o5(c,C,L);if(f[B>>2]&4|0)f[B>>2]=6}break}case 5:{O=+p[(f[j>>2]|0)+(J<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=83;break b}p5(c,C,O);if(f[B>>2]&4|0)f[B>>2]=6}break}case 6:{O=+p[(f[j>>2]|0)+(J<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[B>>2]|0)==6){N=88;break b}q5(c,C,O);if(f[B>>2]&4|0)f[B>>2]=6}break}case 7:{s5(c,(f[i>>2]|0)+(J*12|0)|0)|0;break}default:{}}f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[H>>0]=1;b[e>>0]=125;b[I>>0]=0;s5(c,e)|0;if((b[H>>0]|0)<0)cYc(f[e>>2]|0)}J=J+1|0;if(J>>>0>=(((f[k>>2]|0)-(f[g>>2]|0)|0)/12|0)>>>0)break a}if((N|0)==39){J=$Xc(32)|0;f[e>>2]=J;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=J;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[J+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==47){H=$Xc(32)|0;f[e>>2]=H;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=H;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[H+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==58){J=$Xc(32)|0;f[e>>2]=J;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=J;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[J+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==63){H=$Xc(32)|0;f[e>>2]=H;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=H;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[H+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==68){J=$Xc(32)|0;f[e>>2]=J;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=J;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[J+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==73){H=$Xc(32)|0;f[e>>2]=H;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=H;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[H+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==78){J=$Xc(32)|0;f[e>>2]=J;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=J;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[J+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==83){H=$Xc(32)|0;f[e>>2]=H;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=H;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[H+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==88){J=$Xc(32)|0;f[e>>2]=J;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=J;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[J+30>>0]=0;vM(-2,e,528568,473413,1207)}}while(0);H=f[j>>2]|0;if(H|0){I=f[s>>2]|0;if((I|0)!=(H|0))f[s>>2]=I+(~((I+-8-H|0)>>>3)<<3);cYc(H)}H=f[i>>2]|0;if(H|0){I=f[r>>2]|0;if((I|0)==(H|0))P=H;else{s=I;while(1){I=s+-12|0;f[r>>2]=I;if((b[I+11>>0]|0)<0){cYc(f[I>>2]|0);Q=f[r>>2]|0}else Q=I;if((Q|0)==(H|0))break;else s=Q}P=f[i>>2]|0}cYc(P)}P=f[h>>2]|0;if(P|0){Q=f[q>>2]|0;if((Q|0)!=(P|0))f[q>>2]=Q+(~((Q+-4-P|0)>>>2)<<2);cYc(P)}P=f[g>>2]|0;if(P|0){Q=f[k>>2]|0;if((Q|0)==(P|0))R=P;else{q=Q;while(1){Q=q+-12|0;f[k>>2]=Q;if((b[Q+11>>0]|0)<0){cYc(f[Q>>2]|0);S=f[k>>2]|0}else S=Q;if((S|0)==(P|0))break;else q=S}R=f[g>>2]|0}cYc(R)}};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=e+11|0;b[R>>0]=1;b[e>>0]=93;b[e+1>>0]=0;S=s5(c,e)|0;if((b[R>>0]|0)<0)cYc(f[e>>2]|0);R=$Xc(16)|0;f[e>>2]=R;f[e+8>>2]=-2147483632;f[e+4>>2]=12;l=R;m=466519;n=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[R+12>>0]=0;R=s5(S,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;S=e+11|0;b[S>>0]=1;b[e>>0]=91;b[e+1>>0]=0;s5(R,e)|0;if((b[S>>0]|0)<0)cYc(f[e>>2]|0);S=f[a+36>>2]|0;if(S|0){f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;f[h>>2]=0;R=h+4|0;f[R>>2]=0;f[h+8>>2]=0;f[i>>2]=0;q=i+4|0;f[q>>2]=0;f[i+8>>2]=0;f[j>>2]=0;P=j+4|0;f[P>>2]=0;f[j+8>>2]=0;kGc(S,g,h,i,j);c:do if((f[a>>2]|0)!=(f[g>>2]|0)){S=e+11|0;k=e+1|0;Q=e+11|0;s=e+4|0;H=e+11|0;r=e+4|0;I=e+11|0;B=e+5|0;C=c+4|0;F=c+8|0;G=e+11|0;D=e+8|0;E=e+11|0;z=e+1|0;A=e+11|0;x=e+1|0;y=0;d:while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[S>>0]=1;b[e>>0]=123;b[k>>0]=0;v=s5(c,e)|0;if((b[S>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Q>>0]=4;f[e>>2]=1701667182;b[s>>0]=0;w=s5(v,e)|0;if((b[Q>>0]|0)<0)cYc(f[e>>2]|0);v=s5(w,(f[g>>2]|0)+(y*12|0)|0)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[H>>0]=4;f[e>>2]=1701869940;b[r>>0]=0;w=s5(v,e)|0;if((b[H>>0]|0)<0)cYc(f[e>>2]|0);v=(f[h>>2]|0)+(y<<2)|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](w)|0){o=c+4|0;if((f[o>>2]|0)==6){N=136;break}o5(w,c+8|0,f[v>>2]|0);if(f[o>>2]&4|0)f[o>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[I>>0]=5;b[e>>0]=b[502066]|0;b[e+1>>0]=b[502067]|0;b[e+2>>0]=b[502068]|0;b[e+3>>0]=b[502069]|0;b[e+4>>0]=b[502070]|0;b[B>>0]=0;s5(w,e)|0;if((b[I>>0]|0)<0)cYc(f[e>>2]|0);w=f[(f[h>>2]|0)+(y<<2)>>2]|0;if(w>>>0>9){O=+p[(f[j>>2]|0)+(y<<3)>>3];do if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=144;break d}q5(c,F,O);if(!(f[C>>2]&4))break;f[C>>2]=6}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[G>>0]=8;o=e;f[o>>2]=1701869940;f[o+4>>2]=1701667182;b[D>>0]=0;o=s5(c,e)|0;if((b[G>>0]|0)<0)cYc(f[e>>2]|0);s5(o,(f[i>>2]|0)+(y*12|0)|0)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[E>>0]=1;b[e>>0]=125;b[z>>0]=0;s5(c,e)|0;if((b[E>>0]|0)<0)cYc(f[e>>2]|0)}else{e:do switch(w|0){case 0:{o=~~+p[(f[j>>2]|0)+(y<<3)>>3]&255;if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=155;break d}o5(c,F,o&255);if(!(f[C>>2]&4))break e;f[C>>2]=6}break}case 1:{o=~~+p[(f[j>>2]|0)+(y<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=160;break d}o5(c,F,o<<24>>24);if(!(f[C>>2]&4))break e;f[C>>2]=6}break}case 2:{o=~~+p[(f[j>>2]|0)+(y<<3)>>3]&65535;if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=165;break d}o5(c,F,o&65535);if(!(f[C>>2]&4))break e;f[C>>2]=6}break}case 3:{o=~~+p[(f[j>>2]|0)+(y<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=170;break d}o5(c,F,o<<16>>16);if(!(f[C>>2]&4))break e;f[C>>2]=6}break}case 9:case 8:case 4:{o=~~+p[(f[j>>2]|0)+(y<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=175;break d}o5(c,F,o);if(!(f[C>>2]&4))break e;f[C>>2]=6}break}case 5:{O=+p[(f[j>>2]|0)+(y<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=180;break d}p5(c,F,O);if(!(f[C>>2]&4))break e;f[C>>2]=6}break}case 6:{O=+p[(f[j>>2]|0)+(y<<3)>>3];if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[C>>2]|0)==6){N=185;break d}q5(c,F,O);if(!(f[C>>2]&4))break e;f[C>>2]=6}break}case 7:{s5(c,(f[i>>2]|0)+(y*12|0)|0)|0;break}default:{}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[A>>0]=1;b[e>>0]=125;b[x>>0]=0;s5(c,e)|0;if((b[A>>0]|0)<0)cYc(f[e>>2]|0)}y=y+1|0;if(y>>>0>=(((f[a>>2]|0)-(f[g>>2]|0)|0)/12|0)>>>0)break c}if((N|0)==136){y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=y;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[y+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==144){A=$Xc(32)|0;f[e>>2]=A;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=A;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[A+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==155){y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=y;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[y+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==160){A=$Xc(32)|0;f[e>>2]=A;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=A;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[A+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==165){y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=y;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[y+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==170){A=$Xc(32)|0;f[e>>2]=A;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=A;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[A+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==175){y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=y;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[y+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==180){A=$Xc(32)|0;f[e>>2]=A;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=A;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[A+30>>0]=0;vM(-2,e,528568,473413,1207)}else if((N|0)==185){y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=y;m=473382;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[y+30>>0]=0;vM(-2,e,528568,473413,1207)}}while(0);m=f[j>>2]|0;if(m|0){j=f[P>>2]|0;if((j|0)!=(m|0))f[P>>2]=j+(~((j+-8-m|0)>>>3)<<3);cYc(m)}m=f[i>>2]|0;if(m|0){j=f[q>>2]|0;if((j|0)==(m|0))T=m;else{P=j;while(1){j=P+-12|0;f[q>>2]=j;if((b[j+11>>0]|0)<0){cYc(f[j>>2]|0);U=f[q>>2]|0}else U=j;if((U|0)==(m|0))break;else P=U}T=f[i>>2]|0}cYc(T)}T=f[h>>2]|0;if(T|0){h=f[R>>2]|0;if((h|0)!=(T|0))f[R>>2]=h+(~((h+-4-T|0)>>>2)<<2);cYc(T)}T=f[g>>2]|0;if(T|0){h=f[a>>2]|0;if((h|0)==(T|0))V=T;else{R=h;while(1){h=R+-12|0;f[a>>2]=h;if((b[h+11>>0]|0)<0){cYc(f[h>>2]|0);W=f[a>>2]|0}else W=h;if((W|0)==(T|0))break;else R=W}V=f[g>>2]|0}cYc(V)}};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;V=e+11|0;b[V>>0]=1;b[e>>0]=93;b[e+1>>0]=0;s5(c,e)|0;if((b[V>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function SQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=u;u=u+432|0;e=d+420|0;g=d+408|0;h=d+396|0;i=d+384|0;j=d+372|0;k=d+348|0;l=d+336|0;m=d+324|0;n=d+312|0;o=d+300|0;p=d+288|0;q=d+264|0;r=d+360|0;s=d+252|0;t=d+240|0;v=d+228|0;w=d+216|0;x=d+204|0;y=d+192|0;z=d+180|0;A=d+168|0;B=d+156|0;C=d+144|0;D=d+132|0;E=d+120|0;F=d+108|0;G=d+96|0;H=d+84|0;I=d+72|0;J=d+276|0;K=d+60|0;L=d+48|0;M=d+36|0;N=d+24|0;O=d+12|0;P=d;Q=a+28|0;if(!(f[Q>>2]|0)){R=$Xc(16)|0;f[R+4>>2]=0;f[R+8>>2]=0;f[R>>2]=118720;S=R+12|0;cGc(S);TXc(R);f[Q>>2]=S;S=a+32|0;T=f[S>>2]|0;f[S>>2]=R;if(T|0)UXc(T);UXc(R)}i5(e,c,466445);if((C5(e)|0)!=4){R=$Xc(32)|0;f[g>>2]=R;f[g+8>>2]=-2147483616;f[g+4>>2]=26;U=R;V=466457;W=U+26|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[R+26>>0]=0;vM(-215,g,473221,465621,1181)}a:do if((w5(e)|0)>0){R=g+11|0;T=r+11|0;S=0;while(1){y5(g,e,S);if((C5(g)|0)!=5){X=11;break}y5(h,e,S);i5(i,h,473188);H4(g,i);y5(j,e,S);i5(k,j,466514);Y=H5(k)|0;if((Y|0)>=10){X=13;break}switch(Y|0){case 4:case 3:case 2:case 1:case 0:{Z=f[Q>>2]|0;y5(l,e,S);i5(m,l,502066);fGc(Z,g,H5(m)|0);break}case 5:{Z=f[Q>>2]|0;y5(n,e,S);i5(o,n,502066);hGc(Z,g,+I5(o));break}case 6:{Z=f[Q>>2]|0;y5(p,e,S);i5(q,p,502066);gGc(Z,g,+J5(q));break}case 7:{Z=f[Q>>2]|0;y5(s,e,S);i5(t,s,502066);H4(r,t);dGc(Z,g,r);if((b[T>>0]|0)<0)cYc(f[r>>2]|0);break}case 8:{Z=f[Q>>2]|0;y5(v,e,S);i5(w,v,502066);iGc(Z,g,(H5(w)|0)!=0);break}case 9:{Z=f[Q>>2]|0;y5(x,e,S);i5(y,x,502066);jGc(Z,H5(y)|0);break}default:{}}if((b[R>>0]|0)<0)cYc(f[g>>2]|0);S=S+1|0;if((S|0)>=(w5(e)|0))break a}if((X|0)==11){S=$Xc(32)|0;f[g>>2]=S;f[g+8>>2]=-2147483616;f[g+4>>2]=29;U=S;V=466484;W=U+29|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[S+29>>0]=0;vM(-215,g,473221,465621,1185)}else if((X|0)==13)mV(Y,9,118740)}while(0);Y=a+36|0;if(!(f[Y>>2]|0)){e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=118776;y=e+12|0;nGc(y,32,0.0,1);TXc(e);f[Y>>2]=y;y=a+40|0;x=f[y>>2]|0;f[y>>2]=e;if(x|0)UXc(x);UXc(e)}i5(g,c,466519);if((C5(g)|0)!=4){c=$Xc(32)|0;f[r>>2]=c;f[r+8>>2]=-2147483616;f[r+4>>2]=26;U=c;V=466532;W=U+26|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[c+26>>0]=0;vM(-215,r,473221,465621,1222)}b:do if((w5(g)|0)>0){c=r+11|0;e=J+11|0;x=0;while(1){y5(r,g,x);if((C5(r)|0)!=5){X=37;break}y5(z,g,x);i5(A,z,473188);H4(r,A);y5(B,g,x);i5(C,B,466514);_=H5(C)|0;if((_|0)>=10){X=39;break}switch(_|0){case 4:case 3:case 2:case 1:case 0:{y=f[Y>>2]|0;y5(D,g,x);i5(E,D,502066);fGc(y,r,H5(E)|0);break}case 5:{y=f[Y>>2]|0;y5(F,g,x);i5(G,F,502066);hGc(y,r,+I5(G));break}case 6:{y=f[Y>>2]|0;y5(H,g,x);i5(I,H,502066);gGc(y,r,+J5(I));break}case 7:{y=f[Y>>2]|0;y5(K,g,x);i5(L,K,502066);H4(J,L);dGc(y,r,J);if((b[e>>0]|0)<0)cYc(f[J>>2]|0);break}case 8:{y=f[Y>>2]|0;y5(M,g,x);i5(N,M,502066);iGc(y,r,(H5(N)|0)!=0);break}case 9:{y=f[Y>>2]|0;y5(O,g,x);i5(P,O,502066);jGc(y,H5(P)|0);break}default:{}}if((b[c>>0]|0)<0)cYc(f[r>>2]|0);x=x+1|0;if((x|0)>=(w5(g)|0))break b}if((X|0)==37){x=$Xc(32)|0;f[r>>2]=x;f[r+8>>2]=-2147483616;f[r+4>>2]=29;U=x;V=466559;W=U+29|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[x+29>>0]=0;vM(-215,r,473221,465621,1226)}else if((X|0)==39)mV(_,9,118796)}while(0);f[a+44>>2]=0;_=a+48|0;a=f[_>>2]|0;f[_>>2]=0;if(!a){u=d;return}UXc(a);u=d;return}function TQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d;pQb(a,c);if((eS(c)|0)==720896){f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;jS(c,e);h=f[g>>2]|0;i=f[e>>2]|0;j=i;k=h;if((h|0)!=(i|0)){l=a+124|0;m=(h-i|0)/48|0;h=0;n=f[l>>2]|0;do{n=n+(f[j+(h*48|0)+8>>2]|0)|0;h=h+1|0}while(h>>>0<m>>>0);f[l>>2]=n}if(i|0){if((k|0)==(j|0))o=i;else{i=k;do{k=i+-48|0;f[g>>2]=k;EQ(k);i=f[g>>2]|0}while((i|0)!=(j|0));o=f[e>>2]|0}cYc(o)}u=d;return}if((eS(c)|0)==655360){fS(e,c,-1);o=a+124|0;f[o>>2]=(f[o>>2]|0)+(f[e+8>>2]|0);EQ(e);u=d;return}if((eS(c)|0)==327680){f[e>>2]=0;o=e+4|0;f[o>>2]=0;f[e+8>>2]=0;gS(c,e);j=f[o>>2]|0;o=f[e>>2]|0;i=o;if((j|0)!=(o|0)){g=a+124|0;k=(j-o|0)/56|0;o=0;j=f[g>>2]|0;do{j=j+(f[i+(o*56|0)+8>>2]|0)|0;o=o+1|0}while(o>>>0<k>>>0);f[g>>2]=j}hx(e);u=d;return}if((eS(c)|0)!=65536){if((eS(c)|0)==655360){u=d;return}if((eS(c)|0)==720896){u=d;return}if((eS(c)|0)==65536){u=d;return}if((eS(c)|0)==327680){u=d;return}else{j=$Xc(112)|0;f[e>>2]=j;f[e+8>>2]=-2147483536;f[e+4>>2]=106;g=j;k=465510;o=g+106|0;do{b[g>>0]=b[k>>0]|0;g=g+1|0;k=k+1|0}while((g|0)<(o|0));b[j+106>>0]=0;vM(-215,e,465617,465621,1141)}}do if((eS(c)|0)==65536){j=f[c+4>>2]|0;f[e>>2]=f[j>>2];k=e+4|0;g=j+4|0;f[k>>2]=f[g>>2];o=e+8|0;f[o>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[e+16>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];i=e+36|0;n=f[j+36>>2]|0;f[i>>2]=n;f[e+40>>2]=o;l=e+48|0;m=e+44|0;f[m>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if(n|0){l=n+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[g>>2]|0)<3){g=f[j+44>>2]|0;l=f[m>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];p=i;q=o;break}else{f[k>>2]=0;U$(e,j);p=i;q=o;break}}else{bS(e,c,-1);p=e+36|0;q=e+8|0}while(0);c=a+124|0;f[c>>2]=(f[c>>2]|0)+(f[q>>2]|0);q=f[p>>2]|0;if(q|0?(c=q+12|0,q=f[c>>2]|0,f[c>>2]=q+-1,(q|0)==1):0)V$(e);f[p>>2]=0;p=e+16|0;q=e+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[e+40>>2]|0;c=0;do{f[p+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)!=(e+48|0))wL(q);u=d;return}function UQb(a){a=a|0;return 0}function VQb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;c=u;u=u+64|0;d=c;e=a+44|0;if(f[e>>2]|0?(f[a+64>>2]|0)>=(f[a+124>>2]|0):0){u=c;return}g=a+16|0;h=f[g>>2]|0;i=a+20|0;j=a+4|0;if((h|0)!=(f[i>>2]|0)){k=a+8|0;if((f[k>>2]|0)!=(f[j>>2]|0)){l=$Xc(32)|0;f[d>>2]=l;f[d+8>>2]=-2147483616;f[d+4>>2]=31;m=l;n=466251;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+31>>0]=0;vM(-215,d,466283,465621,1164)}l=a+12|0;n=d+4|0;p=d+8|0;q=d+12|0;r=d+16|0;s=d+20|0;t=d+24|0;v=d+28|0;w=d+32|0;x=d+36|0;y=d+44|0;z=d+40|0;A=d+48|0;B=d+44|0;C=0;D=h;do{NQ(d,D+(C*48|0)|0,16777216);h=f[k>>2]|0;if(h>>>0>=(f[l>>2]|0)>>>0){XLa(j,d);E=f[x>>2]|0;if(E|0?(F=E+12|0,E=f[F>>2]|0,f[F>>2]=E+-1,(E|0)==1):0)V$(d)}else{f[h>>2]=f[d>>2];f[h+4>>2]=f[n>>2];E=h+8|0;f[E>>2]=f[p>>2];f[h+12>>2]=f[q>>2];f[h+16>>2]=f[r>>2];f[h+20>>2]=f[s>>2];f[h+24>>2]=f[t>>2];f[h+28>>2]=f[v>>2];f[h+32>>2]=f[w>>2];f[h+36>>2]=f[x>>2];F=h+40|0;f[F>>2]=E;E=h+44|0;G=h+48|0;f[E>>2]=G;H=h+52|0;f[H>>2]=0;f[G>>2]=0;if((f[n>>2]|0)<3){I=f[y>>2]|0;f[G>>2]=f[I>>2];f[H>>2]=f[I+4>>2]}else{f[E>>2]=f[y>>2];f[F>>2]=f[z>>2];f[y>>2]=A;f[z>>2]=p}f[d>>2]=1124007936;m=n;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[k>>2]=h+56}f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[n>>2]|0)>0){F=f[z>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[n>>2]|0))}E=f[B>>2]|0;if((E|0)!=(A|0))wL(E);C=C+1|0;D=f[g>>2]|0}while(C>>>0<(((f[i>>2]|0)-D|0)/48|0)>>>0)}eRb(a+52|0,j);j=f[a+28>>2]|0;D=$Xc(32)|0;f[D+4>>2]=0;f[D+8>>2]=0;f[D>>2]=118692;i=D+12|0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a+56;oGc(i,d,j,1);TXc(D);f[e>>2]=i;i=a+48|0;a=f[i>>2]|0;f[i>>2]=D;if(a|0)UXc(a);UXc(D);u=c;return}function WQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;h=$Xc(140)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=118664;i=h+12|0;$Qb(i,c+28|0,c+36|0);if(d){f[a>>2]=i;f[a+4>>2]=h;u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(112)|0;f[g>>2]=e;f[g+8>>2]=-2147483536;f[g+4>>2]=107;h=e;a=466016;i=h+107|0;do{b[h>>0]=b[a>>0]|0;h=h+1|0;a=a+1|0}while((h|0)<(i|0));b[e+107>>0]=0;vM(-213,g,466124,465621,1390)}}function XQb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+224|0;e=g+200|0;h=g+144|0;i=g+88|0;j=g+32|0;k=g+16|0;l=g;do if((eS(b)|0)==65536){m=f[b+4>>2]|0;f[h>>2]=f[m>>2];n=h+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;r=h+48|0;s=h+44|0;f[s>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(q|0){r=q+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;r=f[s>>2]|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];t=p;break}else{f[n>>2]=0;U$(h,m);t=p;break}}else{bS(h,b,-1);t=h+8|0}while(0);b=f[t>>2]|0;f[i>>2]=1124007936;p=i+4|0;m=i+8|0;n=i+40|0;o=p;r=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(r|0));f[n>>2]=m;m=i+48|0;s=i+44|0;f[s>>2]=m;f[m>>2]=0;f[i+52>>2]=0;f[e>>2]=b;b=e+4|0;f[b>>2]=d;S$(i,2,e,4);q=f[t>>2]|0;f[j>>2]=1124007936;t=j+4|0;v=j+8|0;w=j+40|0;o=t;r=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(r|0));f[w>>2]=v;v=j+48|0;o=j+44|0;f[o>>2]=v;f[v>>2]=0;f[j+52>>2]=0;f[e>>2]=q;f[b>>2]=d;S$(j,2,e,5);b=f[a+44>>2]|0;q=f[(f[b>>2]|0)+12>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;r=k+8|0;f[r>>2]=0;f[r+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;r=l+8|0;f[r>>2]=0;f[r+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;Fh[q&255](b,e,k,l,d,f[a+36>>2]|0);ZQb(a+52|0,i,j,c);c=j+36|0;a=f[c>>2]|0;if(a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)V$(j);f[c>>2]=0;c=j+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[t>>2]|0)>0){c=f[w>>2]|0;w=0;do{f[c+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[o>>2]|0;if((t|0)!=(v|0))wL(t);t=i+36|0;v=f[t>>2]|0;if(v|0?(o=v+12|0,v=f[o>>2]|0,f[o>>2]=v+-1,(v|0)==1):0)V$(i);f[t>>2]=0;t=i+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[p>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[p>>2]|0))}p=f[s>>2]|0;if((p|0)!=(m|0))wL(p);p=h+36|0;m=f[p>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)V$(h);f[p>>2]=0;p=h+16|0;m=h+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[h+40>>2]|0;s=0;do{f[p+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[m>>2]|0))}m=f[h+44>>2]|0;if((m|0)==(h+48|0)){u=g;return}wL(m);u=g;return}function YQb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+400|0;e=g+384|0;h=g;i=g+328|0;j=g+272|0;k=g+216|0;l=g+160|0;m=g+104|0;n=g+48|0;o=g+32|0;do if((eS(b)|0)==65536){q=f[b+4>>2]|0;f[i>>2]=f[q>>2];r=i+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=i+8|0;f[t>>2]=f[q+8>>2];f[i+12>>2]=f[q+12>>2];f[i+16>>2]=f[q+16>>2];f[i+20>>2]=f[q+20>>2];f[i+24>>2]=f[q+24>>2];f[i+28>>2]=f[q+28>>2];f[i+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[i+36>>2]=v;f[i+40>>2]=t;w=i+48|0;x=i+44|0;f[x>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(v|0){w=v+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;w=f[x>>2]|0;f[w>>2]=f[s>>2];f[w+4>>2]=f[s+4>>2];y=t;break}else{f[r>>2]=0;U$(i,q);y=t;break}}else{bS(i,b,-1);y=i+8|0}while(0);b=a+52|0;t=f[a+64>>2]|0;q=f[y>>2]|0;p[h>>3]=-1.0;p[h+8>>3]=-1.0;p[h+16>>3]=-1.0;p[h+24>>3]=-1.0;f[j>>2]=1124007936;r=j+4|0;s=j+8|0;w=j+40|0;x=r;v=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(v|0));f[w>>2]=s;s=j+48|0;z=j+44|0;f[z>>2]=s;f[s>>2]=0;f[j+52>>2]=0;f[e>>2]=q;q=e+4|0;f[q>>2]=t;S$(j,2,e,4);lR(j,h)|0;A=f[y>>2]|0;p[h>>3]=-1.0;p[h+8>>3]=-1.0;p[h+16>>3]=-1.0;p[h+24>>3]=-1.0;f[k>>2]=1124007936;B=k+4|0;C=k+8|0;D=k+40|0;x=B;v=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(v|0));f[D>>2]=C;C=k+48|0;x=k+44|0;f[x>>2]=C;f[C>>2]=0;f[k+52>>2]=0;f[e>>2]=A;f[q>>2]=t;S$(k,2,e,5);lR(k,h)|0;if((f[y>>2]|0)>0){q=e+4|0;A=h+4|0;v=e+4|0;E=h+4|0;F=e+4|0;G=h+4|0;H=a+44|0;I=e+8|0;J=e+12|0;K=e+4|0;L=h+8|0;M=h+4|0;N=o+8|0;O=o+4|0;P=d*d;Q=a+36|0;a=n+36|0;R=n+16|0;S=n+4|0;T=n+40|0;U=n+44|0;V=n+48|0;W=m+36|0;X=m+16|0;Y=m+4|0;Z=m+40|0;_=m+44|0;$=m+48|0;aa=l+36|0;ba=l+16|0;ca=l+4|0;da=l+40|0;ea=l+44|0;fa=l+48|0;ga=0;do{ha=ga;ga=ga+1|0;f[e>>2]=ha;f[q>>2]=ga;f[h>>2]=-2147483648;f[A>>2]=2147483647;W$(l,i,e,h);f[e>>2]=ha;f[v>>2]=ga;f[h>>2]=-2147483648;f[E>>2]=2147483647;W$(m,j,e,h);f[e>>2]=ha;f[F>>2]=ga;f[h>>2]=-2147483648;f[G>>2]=2147483647;W$(n,k,e,h);ha=f[H>>2]|0;ia=f[(f[ha>>2]|0)+16>>2]|0;f[I>>2]=0;f[J>>2]=0;f[e>>2]=16842752;f[K>>2]=l;ja=L;f[ja>>2]=0;f[ja+4>>2]=0;f[h>>2]=33619968;f[M>>2]=m;ja=N;f[ja>>2]=0;f[ja+4>>2]=0;f[o>>2]=33619968;f[O>>2]=n;ai[ia&3](ha,e,h,o,P,t,f[Q>>2]|0)|0;ha=f[a>>2]|0;if(ha|0?(ia=ha+12|0,ha=f[ia>>2]|0,f[ia>>2]=ha+-1,(ha|0)==1):0)V$(n);f[a>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[S>>2]|0)>0){ha=f[T>>2]|0;ia=0;do{f[ha+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[S>>2]|0))}ia=f[U>>2]|0;if((ia|0)!=(V|0))wL(ia);ia=f[W>>2]|0;if(ia|0?(ha=ia+12|0,ia=f[ha>>2]|0,f[ha>>2]=ia+-1,(ia|0)==1):0)V$(m);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Y>>2]|0)>0){ia=f[Z>>2]|0;ha=0;do{f[ia+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[Y>>2]|0))}ha=f[_>>2]|0;if((ha|0)!=($|0))wL(ha);ha=f[aa>>2]|0;if(ha|0?(ia=ha+12|0,ha=f[ia>>2]|0,f[ia>>2]=ha+-1,(ha|0)==1):0)V$(l);f[aa>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ca>>2]|0)>0){ha=f[da>>2]|0;ia=0;do{f[ha+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ca>>2]|0))}ia=f[ea>>2]|0;if((ia|0)!=(fa|0))wL(ia)}while((ga|0)<(f[y>>2]|0))}ZQb(b,j,k,c);c=k+36|0;b=f[c>>2]|0;if(b|0?(y=b+12|0,b=f[y>>2]|0,f[y>>2]=b+-1,(b|0)==1):0)V$(k);f[c>>2]=0;c=k+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[B>>2]|0)>0){c=f[D>>2]|0;D=0;do{f[c+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[x>>2]|0;if((B|0)!=(C|0))wL(B);B=j+36|0;C=f[B>>2]|0;if(C|0?(x=C+12|0,C=f[x>>2]|0,f[x>>2]=C+-1,(C|0)==1):0)V$(j);f[B>>2]=0;B=j+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[r>>2]|0)>0){B=f[w>>2]|0;w=0;do{f[B+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[r>>2]|0))}r=f[z>>2]|0;if((r|0)!=(s|0))wL(r);r=i+36|0;s=f[r>>2]|0;if(s|0?(z=s+12|0,s=f[z>>2]|0,f[z>>2]=s+-1,(s|0)==1):0)V$(i);f[r>>2]=0;r=i+16|0;s=i+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[i+40>>2]|0;z=0;do{f[r+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[s>>2]|0))}s=f[i+44>>2]|0;if((s|0)==(i+48|0)){u=g;return}wL(s);u=g;return}function ZQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e+20|0;h=e+16|0;i=e;j=b+8|0;k=f[j>>2]|0;l=d+4|0;m=f[l>>2]|0;o=f[d>>2]|0;p=(m-o|0)/12|0;q=o;o=m;if(k>>>0<=p>>>0){if(k>>>0<p>>>0?(m=q+(k*12|0)|0,(o|0)!=(m|0)):0){q=o;while(1){o=q+-12|0;f[l>>2]=o;r=f[o>>2]|0;if(!r)s=o;else{o=q+-8|0;t=f[o>>2]|0;if((t|0)!=(r|0))f[o>>2]=t+(~((t+-16-r|0)>>>4)<<4);cYc(r);s=f[l>>2]|0}if((s|0)==(m|0))break;else q=s}}}else DQb(d,k-p|0);p=f[j>>2]|0;if((p|0)<=0){u=e;return}k=b+12|0;s=b+16|0;q=b+44|0;b=c+16|0;m=c+44|0;l=i+4|0;r=i+8|0;t=i+12|0;o=0;v=f[k>>2]|0;w=p;while(1){if((v|0)>0){p=0;x=v;while(1){y=(f[s>>2]|0)+(Y(f[f[q>>2]>>2]|0,o)|0)+(p<<2)|0;z=f[y>>2]|0;if((z|0)>-1){_Qb(a,z,g,h);z=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,o)|0)|0;if((f[c>>2]&4095|0)==4)A=+(f[z+(p<<2)>>2]|0);else A=+M(+(+n[z+(p<<2)>>2]));z=f[d>>2]|0;y=f[h>>2]|0;B=f[g>>2]|0;f[i>>2]=o;f[l>>2]=y;f[r>>2]=B;n[t>>2]=A;B=z+(o*12|0)+4|0;y=f[B>>2]|0;if(y>>>0<(f[z+(o*12|0)+8>>2]|0)>>>0){f[y>>2]=f[i>>2];f[y+4>>2]=f[i+4>>2];f[y+8>>2]=f[i+8>>2];f[y+12>>2]=f[i+12>>2];f[B>>2]=(f[B>>2]|0)+16}else OA(z+(o*12|0)|0,i);C=f[k>>2]|0}else C=x;p=p+1|0;if((p|0)>=(C|0))break;else x=C}D=f[j>>2]|0;E=C}else{D=w;E=v}o=o+1|0;if((o|0)>=(D|0))break;else{v=E;w=D}}u=e;return}function _Qb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;if((c|0)>-1?(f[a+12>>2]|0)>(c|0):0){i=f[a+60>>2]|0;j=i;k=(f[a+64>>2]|0)-j>>2;if(!k){l=i;m=l+-4|0;n=m;o=n-j|0;p=o>>2;f[d>>2]=p;q=f[m>>2]|0;r=c-q|0;f[e>>2]=r;u=g;return}else{s=k;t=i;v=i}while(1){i=(s|0)/2|0;k=v+(i<<2)|0;a=(f[k>>2]|0)>(c|0);w=k+4|0;k=a?t:w;s=a?i:s+-1-i|0;if(!s){l=k;break}else{t=k;v=a?v:w}}m=l+-4|0;n=m;o=n-j|0;p=o>>2;f[d>>2]=p;q=f[m>>2]|0;r=c-q|0;f[e>>2]=r;u=g;return}g=$Xc(48)|0;f[h>>2]=g;f[h+8>>2]=-2147483600;f[h+4>>2]=46;r=g;e=465957;q=r+46|0;do{b[r>>0]=b[e>>0]|0;r=r+1|0;e=e+1|0}while((r|0)<(q|0));b[g+46>>0]=0;vM(-215,h,466004,465621,500)}function $Qb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;yP(a);h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a>>2]=118600;f[a+28>>2]=f[c>>2];h=f[c+4>>2]|0;f[a+32>>2]=h;if(h|0)TXc(h);f[a+36>>2]=f[d>>2];h=f[d+4>>2]|0;f[a+40>>2]=h;if(h|0)TXc(h);f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=118424;f[a+56>>2]=1124007936;h=a+64|0;i=a+96|0;j=a+60|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+104|0;f[a+100>>2]=h;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;if(!(f[c>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=$Xc(16)|0;f[g>>2]=c;f[g+8>>2]=-2147483632;f[g+4>>2]=12;j=c;l=466130;k=j+12|0;do{b[j>>0]=b[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(k|0));b[c+12>>0]=0;vM(-215,g,466143,465621,1099)}if(!(f[d>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=$Xc(16)|0;f[g>>2]=d;f[g+8>>2]=-2147483632;f[g+4>>2]=13;j=d;l=466161;k=j+13|0;do{b[j>>0]=b[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(k|0));b[d+13>>0]=0;vM(-215,g,466143,465621,1100)}else{u=e;return}}function aRb(a){a=a|0;f[a>>2]=118664;OQb(a+12|0);NXc(a);return}function bRb(a){a=a|0;f[a>>2]=118664;OQb(a+12|0);NXc(a);cYc(a);return}function cRb(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function dRb(a){a=a|0;cYc(a);return}function eRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+80|0;e=d+64|0;g=d+56|0;h=d;Yi[f[(f[a>>2]|0)+8>>2]&4095](a);i=(f[c+4>>2]|0)-(f[c>>2]|0)|0;j=(i|0)/56|0;if(!i){k=$Xc(16)|0;f[e>>2]=k;f[e+8>>2]=-2147483632;f[e+4>>2]=14;l=k;m=466358;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+14>>0]=0;vM(-215,e,466373,465621,428)}k=a+60|0;o=a+64|0;p=f[o>>2]|0;q=f[k>>2]|0;r=p-q>>2;s=q;q=p;if(j>>>0<=r>>>0)if(j>>>0<r>>>0?(p=s+(j<<2)|0,(q|0)!=(p|0)):0){f[o>>2]=q+(~((q+-4-p|0)>>>2)<<2);t=s}else t=s;else{CS(k,j-r|0);t=f[k>>2]|0}f[t>>2]=0;if(j>>>0>1){t=f[c>>2]|0;r=f[k>>2]|0;s=1;p=-1;q=-1;while(1){o=s+-1|0;if(f[t+(o*56|0)+16>>2]|0){v=f[t+(o*56|0)+4>>2]|0;if((v|0)<3)w=Y(f[t+(o*56|0)+12>>2]|0,f[t+(o*56|0)+8>>2]|0)|0;else{x=f[t+(o*56|0)+40>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if(!((v|0)==0|(w|0)==0)){B=f[t+(o*56|0)+8>>2]|0;C=f[t+(o*56|0)>>2]&4095;D=f[t+(o*56|0)+12>>2]|0}else{B=0;C=p;D=q}}else{B=0;C=p;D=q}f[r+(s<<2)>>2]=(f[r+(o<<2)>>2]|0)+B;s=s+1|0;if((s|0)==(j|0)){E=C;F=D;break}else{p=C;q=D}}}else{E=-1;F=-1}do if((i|0)==56){D=f[c>>2]|0;if(!(f[D+16>>2]|0)){u=d;return}q=f[D+4>>2]|0;if((q|0)<3)G=Y(f[D+12>>2]|0,f[D+8>>2]|0)|0;else{C=f[D+40>>2]|0;p=0;s=1;while(1){B=Y(f[C+(p<<2)>>2]|0,s)|0;p=p+1|0;if((p|0)==(q|0)){G=B;break}else s=B}}if((q|0)==0|(G|0)==0){u=d;return}else{H=f[D>>2]&4095;I=f[D+12>>2]|0;break}}else{H=E;I=F}while(0);if((I|0)<=0){f[e+8>>2]=0;b[e+11>>0]=7;b[e>>0]=b[466377]|0;b[e+1>>0]=b[466378]|0;b[e+2>>0]=b[466379]|0;b[e+3>>0]=b[466380]|0;b[e+4>>0]=b[466381]|0;b[e+5>>0]=b[466382]|0;b[e+6>>0]=b[466383]|0;b[e+7>>0]=0;vM(-215,e,466373,465621,453)}F=j+-1|0;E=(f[(f[c>>2]|0)+(F*56|0)+8>>2]|0)+(f[(f[k>>2]|0)+(F<<2)>>2]|0)|0;if((E|0)<=0){u=d;return}F=a+4|0;G=H&4095;if(!(((((f[a+8>>2]|0)<3?(f[a+12>>2]|0)==(E|0):0)?(f[a+16>>2]|0)==(I|0):0)?(f[F>>2]&4095|0)==(G|0):0)?(f[a+20>>2]|0)!=0:0)){f[e>>2]=E;f[e+4>>2]=I;S$(F,2,e,G)}G=e+4|0;E=g+4|0;a=e+8|0;i=e+4|0;s=h+36|0;p=h+16|0;C=h+4|0;o=h+40|0;v=h+44|0;B=h+48|0;r=0;while(1){t=f[c>>2]|0;if(f[t+(r*56|0)+16>>2]|0){w=f[t+(r*56|0)+4>>2]|0;if((w|0)<3)J=Y(f[t+(r*56|0)+12>>2]|0,f[t+(r*56|0)+8>>2]|0)|0;else{z=f[t+(r*56|0)+40>>2]|0;y=0;x=1;while(1){A=Y(f[z+(y<<2)>>2]|0,x)|0;y=y+1|0;if((y|0)==(w|0)){J=A;break}else x=A}}if(!((w|0)==0|(J|0)==0)){if((f[t+(r*56|0)+12>>2]|0)!=(I|0)){K=44;break}if((f[t+(r*56|0)>>2]&4095|0)!=(H|0)){K=44;break}x=f[(f[k>>2]|0)+(r<<2)>>2]|0;y=(f[t+(r*56|0)+8>>2]|0)+x|0;f[e>>2]=x;f[G>>2]=y;f[g>>2]=-2147483648;f[E>>2]=2147483647;W$(h,F,e,g);y=(f[c>>2]|0)+(r*56|0)|0;x=a;f[x>>2]=0;f[x+4>>2]=0;f[e>>2]=33619968;f[i>>2]=h;jR(y,e);y=f[s>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)V$(h);f[s>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[C>>2]|0)>0){y=f[o>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[C>>2]|0))}x=f[v>>2]|0;if((x|0)!=(B|0))wL(x)}}r=r+1|0;if(r>>>0>=j>>>0){K=55;break}}if((K|0)==44){j=$Xc(64)|0;f[e>>2]=j;f[e+8>>2]=-2147483584;f[e+4>>2]=59;l=j;m=466385;n=l+59|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+59>>0]=0;vM(-215,e,466373,465621,464)}else if((K|0)==55){u=d;return}}function fRb(a){a=a|0;f[a>>2]=118692;Atc(a+12|0);NXc(a);return}function gRb(a){a=a|0;f[a>>2]=118692;Atc(a+12|0);NXc(a);cYc(a);return}function hRb(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function iRb(a){a=a|0;cYc(a);return}function jRb(a){a=a|0;f[a>>2]=118776;bGc(a+12|0);NXc(a);return}function kRb(a){a=a|0;f[a>>2]=118776;bGc(a+12|0);NXc(a);cYc(a);return}function lRb(a){a=a|0;bGc(a+12|0);return}function mRb(a){a=a|0;cYc(a);return}function nRb(a){a=a|0;f[a>>2]=118720;bGc(a+12|0);NXc(a);return}function oRb(a){a=a|0;f[a>>2]=118720;bGc(a+12|0);NXc(a);cYc(a);return}function pRb(a){a=a|0;bGc(a+12|0);return}function qRb(a){a=a|0;cYc(a);return}function rRb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+96|0;h=g+88|0;i=g+72|0;j=g+56|0;k=g;Ti[f[(f[a>>2]|0)+44>>2]&511](h,a,1);a=f[h>>2]|0;mi[f[(f[a>>2]|0)+32>>2]&2047](a,c);c=f[h>>2]|0;do if((eS(e)|0)==65536){a=f[e+4>>2]|0;f[k>>2]=f[a>>2];l=k+4|0;m=a+4|0;f[l>>2]=f[m>>2];n=k+8|0;f[n>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];o=f[a+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=n;n=k+48|0;p=k+44|0;f[p>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[a+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;U$(k,a);break}}else bS(k,e,-1);while(0);lOa(j,1,k);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=j;sRb(c,b,d,i);hx(j);j=k+36|0;i=f[j>>2]|0;if(i|0?(d=i+12|0,i=f[d>>2]|0,f[d>>2]=i+-1,(i|0)==1):0)V$(k);f[j>>2]=0;j=k+16|0;i=k+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[k+40>>2]|0;d=0;do{f[j+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[i>>2]|0))}i=f[k+44>>2]|0;if((i|0)!=(k+48|0))wL(i);i=f[h+4>>2]|0;if(!i){u=g;return}UXc(i);u=g;return}function sRb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=u;u=u+32|0;h=g+12|0;i=g;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0)?!(sS(c)|0):0){cS(h,c,-1);tRb(a,e,f[h+4>>2]|0);Yi[f[(f[a>>2]|0)+40>>2]&4095](a);Fh[f[(f[a>>2]|0)+48>>2]&255](a,c,i,1,e,1)}e=f[d>>2]|0;c=d+4|0;a=f[c>>2]|0;if((a|0)!=(e|0))f[c>>2]=a+(~((a+-16-e|0)>>>4)<<4);JQb(d,((f[j>>2]|0)-(f[i>>2]|0)|0)/12|0);e=f[j>>2]|0;a=f[i>>2]|0;k=a;l=e;a:do if((e|0)==(a|0)){m=k;n=l}else{o=d+8|0;p=0;q=a;r=l;s=k;t=e;while(1){v=q;w=f[v+(p*12|0)+4>>2]|0;x=f[v+(p*12|0)>>2]|0;v=x;if(w-x>>4>>>0>=2)break;do if((v|0)!=(w|0)){y=f[c>>2]|0;if((y|0)==(f[o>>2]|0)){l3(d,v);z=f[j>>2]|0;A=f[i>>2]|0;B=A;C=z;D=z;E=A;break}else{A=x;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];f[y+8>>2]=f[A+8>>2];f[y+12>>2]=f[A+12>>2];f[c>>2]=(f[c>>2]|0)+16;B=q;C=t;D=r;E=s;break}}else{B=q;C=t;D=r;E=s}while(0);p=p+1|0;if(p>>>0>=((C-B|0)/12|0)>>>0){m=E;n=D;break a}else{q=B;r=D;s=E;t=C}}t=$Xc(32)|0;f[h>>2]=t;f[h+8>>2]=-2147483616;f[h+4>>2]=25;s=t;r=466873;q=s+25|0;do{b[s>>0]=b[r>>0]|0;s=s+1|0;r=r+1|0}while((s|0)<(q|0));b[t+25>>0]=0;vM(-215,h,466899,465621,521)}while(0);if(!m){u=g;return}if((n|0)==(m|0))F=m;else{h=n;while(1){n=h+-12|0;f[j>>2]=n;C=f[n>>2]|0;if(!C)G=n;else{n=h+-8|0;E=f[n>>2]|0;if((E|0)!=(C|0))f[n>>2]=E+(~((E+-16-C|0)>>>4)<<4);cYc(C);G=f[j>>2]|0}if((G|0)==(m|0))break;else h=G}F=f[i>>2]|0}cYc(F);u=g;return}function tRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+32|0;g=e+12|0;h=e;f[g>>2]=0;i=g+4|0;f[i>>2]=0;f[g+8>>2]=0;gS(c,g);if(!(_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0)){hx(g);u=e;return}c=f[g>>2]|0;j=f[i>>2]|0;if((c|0)==(j|0)){hx(g);u=e;return}i=f[a+4>>2]|0;k=((f[a+8>>2]|0)-i|0)/56|0;l=f[a+16>>2]|0;m=((f[a+20>>2]|0)-l|0)/48|0;a=k>>>0<m>>>0?m:k;k=i;i=l;if(((j-c|0)/56|0|0)!=(a|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=j;o=466914;p=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[j+26>>0]=0;vM(-215,h,466941,465621,629)}if(!a){hx(g);u=e;return}else q=0;a:while(1){do if(f[c+(q*56|0)+16>>2]|0){j=f[c+(q*56|0)+4>>2]|0;if((j|0)<3)r=Y(f[c+(q*56|0)+12>>2]|0,f[c+(q*56|0)+8>>2]|0)|0;else{l=f[c+(q*56|0)+40>>2]|0;m=0;s=1;while(1){t=Y(f[l+(m<<2)>>2]|0,s)|0;m=m+1|0;if((m|0)==(j|0)){r=t;break}else s=t}}if(!((j|0)==0|(r|0)==0)){if(f[k+(q*56|0)+16>>2]|0){s=f[k+(q*56|0)+4>>2]|0;if((s|0)<3)v=Y(f[k+(q*56|0)+12>>2]|0,f[k+(q*56|0)+8>>2]|0)|0;else{m=f[k+(q*56|0)+40>>2]|0;l=0;t=1;while(1){w=Y(f[m+(l<<2)>>2]|0,t)|0;l=l+1|0;if((l|0)==(s|0)){v=w;break}else t=w}}if((s|0)==0|(v|0)==0)x=18}else x=18;if((x|0)==18){x=0;if(!(f[i+(q*48|0)+24>>2]|0))break;t=f[i+(q*48|0)+4>>2]|0;if((t|0)<3)y=Y(f[i+(q*48|0)+12>>2]|0,f[i+(q*48|0)+8>>2]|0)|0;else{l=f[i+(q*48|0)+32>>2]|0;m=0;j=1;while(1){w=Y(f[l+(m<<2)>>2]|0,j)|0;m=m+1|0;if((m|0)==(t|0)){y=w;break}else j=w}}if((t|0)==0|(y|0)==0)break}if(f[k+(q*56|0)+16>>2]|0){j=f[k+(q*56|0)+4>>2]|0;if((j|0)<3)z=Y(f[k+(q*56|0)+12>>2]|0,f[k+(q*56|0)+8>>2]|0)|0;else{m=f[k+(q*56|0)+40>>2]|0;l=0;s=1;while(1){w=Y(f[m+(l<<2)>>2]|0,s)|0;l=l+1|0;if((l|0)==(j|0)){z=w;break}else s=w}}if(!((j|0)==0|(z|0)==0))A=k+(q*56|0)+8|0;else x=30}else x=30;if((x|0)==30){x=0;A=i+(q*48|0)+8|0}if((f[c+(q*56|0)+8>>2]|0)!=(d|0)){x=35;break a}if((f[c+(q*56|0)+12>>2]|0)!=(f[A>>2]|0)){x=35;break a}if(f[c+(q*56|0)>>2]&4095|0){x=35;break a}}}while(0);q=q+1|0;if(q>>>0>=a>>>0){x=37;break}}if((x|0)==35){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=$Xc(96)|0;f[h>>2]=a;f[h+8>>2]=-2147483552;f[h+4>>2]=93;n=a;o=466952;p=n+93|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[a+93>>0]=0;vM(-215,h,466941,465621,636)}else if((x|0)==37){hx(g);u=e;return}}function uRb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+96|0;j=i+88|0;k=i+72|0;l=i+56|0;m=i;Ti[f[(f[a>>2]|0)+44>>2]&511](j,a,1);a=f[j>>2]|0;mi[f[(f[a>>2]|0)+32>>2]&2047](a,c);c=f[j>>2]|0;do if((eS(g)|0)==65536){a=f[g+4>>2]|0;f[m>>2]=f[a>>2];n=m+4|0;o=a+4|0;f[n>>2]=f[o>>2];p=m+8|0;f[p>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;U$(m,a);break}}else bS(m,g,-1);while(0);lOa(l,1,m);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=l;vRb(c,b,d,e,k,h);hx(l);l=m+36|0;h=f[l>>2]|0;if(h|0?(k=h+12|0,h=f[k>>2]|0,f[k>>2]=h+-1,(h|0)==1):0)V$(m);f[l>>2]=0;l=m+16|0;h=m+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[h>>2]|0)>0){l=f[m+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[m+44>>2]|0;if((h|0)!=(m+48|0))wL(h);h=f[j+4>>2]|0;if(!h){u=i;return}UXc(h);u=i;return}function vRb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;if(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0){u=i;return}if(sS(c)|0){u=i;return}if((e|0)<=0){f[j+8>>2]=0;b[j+11>>0]=7;b[j>>0]=b[467046]|0;b[j+1>>0]=b[467047]|0;b[j+2>>0]=b[467048]|0;b[j+3>>0]=b[467049]|0;b[j+4>>0]=b[467050]|0;b[j+5>>0]=b[467051]|0;b[j+6>>0]=b[467052]|0;b[j+7>>0]=0;vM(-215,j,467054,465621,650)}cS(j,c,-1);tRb(a,g,f[j+4>>2]|0);Yi[f[(f[a>>2]|0)+40>>2]&4095](a);Fh[f[(f[a>>2]|0)+48>>2]&255](a,c,d,e,g,h);u=i;return}function wRb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+96|0;j=i+88|0;k=i+72|0;l=i+56|0;m=i;Ti[f[(f[a>>2]|0)+44>>2]&511](j,a,1);a=f[j>>2]|0;mi[f[(f[a>>2]|0)+32>>2]&2047](a,c);c=f[j>>2]|0;do if((eS(g)|0)==65536){a=f[g+4>>2]|0;f[m>>2]=f[a>>2];n=m+4|0;o=a+4|0;f[n>>2]=f[o>>2];p=m+8|0;f[p>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;U$(m,a);break}}else bS(m,g,-1);while(0);lOa(l,1,m);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=l;xRb(c,b,d,e,k,h);hx(l);l=m+36|0;h=f[l>>2]|0;if(h|0?(k=h+12|0,h=f[k>>2]|0,f[k>>2]=h+-1,(h|0)==1):0)V$(m);f[l>>2]=0;l=m+16|0;h=m+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[h>>2]|0)>0){l=f[m+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[m+44>>2]|0;if((h|0)!=(m+48|0))wL(h);h=f[j+4>>2]|0;if(!h){u=i;return}UXc(h);u=i;return}function xRb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+16|0;j=i;k=f[d>>2]|0;l=d+4|0;m=f[l>>2]|0;if((m|0)!=(k|0)){n=m;while(1){m=n+-12|0;f[l>>2]=m;o=f[m>>2]|0;if(!o)p=m;else{m=n+-8|0;q=f[m>>2]|0;if((q|0)!=(o|0))f[m>>2]=q+(~((q+-16-o|0)>>>4)<<4);cYc(o);p=f[l>>2]|0}if((p|0)==(k|0))break;else n=p}}if(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0){u=i;return}if(sS(c)|0){u=i;return}if(!(e>1.1920928955078125e-07)){p=$Xc(64)|0;f[j>>2]=p;f[j+8>>2]=-2147483584;f[j+4>>2]=51;n=p;k=467063;l=n+51|0;do{b[n>>0]=b[k>>0]|0;n=n+1|0;k=k+1|0}while((n|0)<(l|0));b[p+51>>0]=0;vM(-215,j,467115,465621,667)}cS(j,c,-1);tRb(a,g,f[j+4>>2]|0);Yi[f[(f[a>>2]|0)+40>>2]&4095](a);tj[f[(f[a>>2]|0)+52>>2]&7](a,c,d,e,g,h);u=i;return}function yRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=$Xc(48)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=118572;g=e+12|0;yP(g);h=e+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[g>>2]=118508;f[e+40>>2]=c;b[e+44>>0]=d&1;f[a>>2]=g;f[a+4>>2]=e;return}function zRb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;if(!(MYc(c,467127)|0)){ARb(e);h=f[e>>2]|0;i=f[e+4>>2]|0;j=i;if(!i){f[a>>2]=h;f[g>>2]=i;u=d;return}else{TXc(j);f[a>>2]=h;f[g>>2]=i;UXc(j);u=d;return}}if(!(MYc(c,467138)|0)){j=$Xc(48)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=118572;i=j+12|0;yP(i);h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[i>>2]=118508;f[j+40>>2]=4;b[j+44>>0]=0;TXc(j);f[a>>2]=i;f[g>>2]=j;UXc(j);u=d;return}if(!(MYc(c,467149)|0)){j=$Xc(48)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=118572;i=j+12|0;yP(i);h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[i>>2]=118508;f[j+40>>2]=5;b[j+44>>0]=0;TXc(j);f[a>>2]=i;f[g>>2]=j;UXc(j);u=d;return}if(!(MYc(c,467164)|0)){j=$Xc(48)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=118572;i=j+12|0;yP(i);h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[i>>2]=118508;f[j+40>>2]=2;b[j+44>>0]=0;TXc(j);f[a>>2]=i;f[g>>2]=j;UXc(j);u=d;return}if(MYc(c,467178)|0?MYc(c,467197)|0:0){if(MYc(c,467219)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=$Xc(32)|0;f[e>>2]=c;f[e+8>>2]=-2147483616;f[e+4>>2]=20;j=c;i=467241;h=j+20|0;do{b[j>>0]=b[i>>0]|0;j=j+1|0;i=i+1|0}while((j|0)<(h|0));b[c+20>>0]=0;vM(-5,e,467262,465621,1049)}e=$Xc(48)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=118572;c=e+12|0;yP(c);i=e+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[c>>2]=118508;f[e+40>>2]=7;b[e+44>>0]=0;TXc(e);f[a>>2]=c;f[g>>2]=e;UXc(e);u=d;return}e=$Xc(48)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=118572;c=e+12|0;yP(c);i=e+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[c>>2]=118508;f[e+40>>2]=6;b[e+44>>0]=0;TXc(e);f[a>>2]=c;f[g>>2]=e;UXc(e);u=d;return}function ARb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=u;u=u+16|0;c=b+8|0;d=b;e=$Xc(140)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=118664;g=$Xc(16)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=118832;h=g+12|0;mGc(h,4);f[c>>2]=h;f[c+4>>2]=g;h=$Xc(16)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=118776;i=h+12|0;nGc(i,32,0.0,1);f[d>>2]=i;f[d+4>>2]=h;i=e+12|0;$Qb(i,c,d);UXc(h);UXc(g);f[a>>2]=i;f[a+4>>2]=e;u=b;return}function BRb(a){a=a|0;f[a>>2]=118832;bGc(a+12|0);NXc(a);return}function CRb(a){a=a|0;f[a>>2]=118832;bGc(a+12|0);NXc(a);cYc(a);return}function DRb(a){a=a|0;bGc(a+12|0);return}function ERb(a){a=a|0;cYc(a);return}function FRb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_Rb(e,c);c=AYc(e,467351)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function GRb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0;g=u;u=u+160|0;h=g+136|0;i=g+80|0;j=g+16|0;k=g;f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;switch(e|0){case 0:{HRb(a,h,c,0);break}case 1:{HRb(a,h,c,1);break}case 2:{HRb(a,h,c,2);break}case 3:{HRb(a,h,c,3);break}default:{}}do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[i>>2]=f[m>>2];o=i+4|0;p=m+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[m+8>>2];f[i+12>>2]=f[m+12>>2];f[i+16>>2]=f[m+16>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){t=r+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[p>>2]|0)<3){p=f[m+44>>2]|0;t=f[s>>2]|0;f[t>>2]=f[p>>2];f[t+4>>2]=f[p+4>>2];v=q;break}else{f[o>>2]=0;U$(i,m);v=q;break}}else{bS(i,a,-1);v=i+48|0}while(0);nSb(j,f[v>>2]|0,e);a=f[h>>2]|0;q=f[l>>2]|0;m=q;a:do if((a|0)==(q|0)){w=a;x=m}else{o=i+16|0;p=i+44|0;if(!e){t=a;do{y=+(pSb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[t+4>>2])|0)+~~+n[t>>2]|0,j,c)|0);n[t+16>>2]=y;t=t+28|0;z=f[l>>2]|0}while((t|0)!=(z|0));w=t;x=z;break}else{A=a;B=m;C=q}while(1){switch(e|0){case 3:{D=sSb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[A+4>>2])|0)+~~+n[A>>2]|0,j,c)|0;E=20;break}case 1:{D=qSb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[A+4>>2])|0)+~~+n[A>>2]|0,j,c)|0;E=20;break}case 2:{D=rSb((f[o>>2]|0)+(Y(f[f[p>>2]>>2]|0,~~+n[A+4>>2])|0)+~~+n[A>>2]|0,j,c)|0;E=20;break}default:{F=C;G=B}}if((E|0)==20){E=0;n[A+16>>2]=+(D|0);s=f[l>>2]|0;F=s;G=s}A=A+28|0;if((A|0)==(F|0)){w=F;x=G;break a}else{B=G;C=F}}}while(0);if(d){d=f[h>>2]|0;F=x-d|0;x=(F|0)/28|0;f[k>>2]=0;C=k+4|0;f[C>>2]=0;f[k+8>>2]=0;if(F|0){CS(k,x);g1c(f[k>>2]|0,-1,(x>>>0>1?x:1)<<2|0)|0;F=f[h>>2]|0;G=f[k>>2]|0;B=0;A=0;D=0;E=0;c=0;j=d;while(1){d=j;y=+n[d+4>>2];e=+((E+1|0)>>>0)<y;E=e?D:E;q=e?B:A;e=+(D>>>0)!=y;D=e?~~y>>>0:D;B=e?c:B;if(+((E+1|0)>>>0)==y){H=+n[F+(q*28|0)>>2];I=+n[d>>2];b:do if(H<I){J=+(E>>>0);e=q;K=H;while(1){if(!(+n[F+(e*28|0)+4>>2]==J)){L=e;M=K;break b}m=e+1|0;N=+n[F+(m*28|0)>>2];if(N<I){e=m;K=N}else{L=m;M=N;break}}}else{L=q;M=H}while(0);if((L|0)==(c|0)|M!=I)O=L;else{e=L;while(1){m=f[G+(e<<2)>>2]|0;if((m|0)==-1)break;else e=m}m=+n[F+(c*28|0)+16>>2]<+n[F+(e*28|0)+16>>2];f[G+((m?c:e)<<2)>>2]=m?e:c;O=L}}else O=q;m=c+-1|0;do if((c|0?+n[F+(m*28|0)+4>>2]==y:0)?+n[F+(m*28|0)>>2]+1.0==+n[d>>2]:0){a=G+(c<<2)|0;z=f[a>>2]|0;p=m;while(1){P=G+(p<<2)|0;o=f[P>>2]|0;if((o|0)==-1)break;else p=o}if((z|0)==-1){if((p|0)==(c|0))break;if(+n[F+(c*28|0)+16>>2]<+n[F+(p*28|0)+16>>2]){f[a>>2]=p;break}else{f[P>>2]=c;break}}else{if((p|0)==(z|0))break;if(+n[F+(z*28|0)+16>>2]<+n[F+(p*28|0)+16>>2]){f[G+(z<<2)>>2]=p;f[a>>2]=p;break}else{f[P>>2]=z;f[a>>2]=z;break}}}while(0);c=c+1|0;if(c>>>0>=x>>>0)break;else{A=O;j=d+28|0}}j=b+4|0;O=b+8|0;A=0;do{do if((f[(f[k>>2]|0)+(A<<2)>>2]|0)==-1){c=f[h>>2]|0;P=c+(A*28|0)|0;G=f[j>>2]|0;if((G|0)==(f[O>>2]|0)){Lx(b,P);break}else{f[G>>2]=f[P>>2];f[G+4>>2]=f[c+(A*28|0)+4>>2];P=G+8|0;G=c+(A*28|0)+8|0;f[P>>2]=f[G>>2];f[P+4>>2]=f[G+4>>2];f[P+8>>2]=f[G+8>>2];f[P+12>>2]=f[G+12>>2];f[P+16>>2]=f[G+16>>2];f[j>>2]=(f[j>>2]|0)+28;break}}while(0);A=A+1|0}while(A>>>0<x>>>0)}x=f[k>>2]|0;if(x|0){k=f[C>>2]|0;if((k|0)!=(x|0))f[C>>2]=k+(~((k+-4-x|0)>>>2)<<2);cYc(x)}}else if((h|0)!=(b|0))IRb(b,f[h>>2]|0,w);w=i+36|0;b=f[w>>2]|0;if(b|0?(x=b+12|0,b=f[x>>2]|0,f[x>>2]=b+-1,(b|0)==1):0)V$(i);f[w>>2]=0;w=i+16|0;b=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[b>>2]|0)>0){w=f[i+40>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[b>>2]|0))}b=f[i+44>>2]|0;if((b|0)!=(v|0))wL(b);b=f[h>>2]|0;if(!b){u=g;return}h=f[l>>2]|0;if((h|0)!=(b|0))f[l>>2]=h+(~(((h+-28-b|0)>>>0)/28|0)*28|0);cYc(b);u=g;return}function HRb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0;e=u;u=u+240|0;g=e+168|0;h=e+112|0;i=e+56|0;j=e;f[h>>2]=1124007936;k=h+4|0;l=h+8|0;m=h+40|0;o=k;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[m>>2]=l;q=h+48|0;r=h+44|0;f[r>>2]=q;f[q>>2]=0;f[h+52>>2]=0;do if((eS(a)|0)==65536){s=f[a+4>>2]|0;f[g>>2]=f[s>>2];t=g+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=g+8|0;f[w>>2]=f[s+8>>2];f[g+12>>2]=f[s+12>>2];f[g+16>>2]=f[s+16>>2];f[g+20>>2]=f[s+20>>2];f[g+24>>2]=f[s+24>>2];f[g+28>>2]=f[s+28>>2];f[g+32>>2]=f[s+32>>2];x=g+36|0;y=f[s+36>>2]|0;f[x>>2]=y;f[g+40>>2]=w;w=g+48|0;z=g+44|0;f[z>>2]=w;f[w>>2]=0;f[g+52>>2]=0;if(y|0){w=y+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];A=x;B=g;break}else{f[t>>2]=0;U$(g,s);A=x;B=g;break}}else{bS(g,a,-1);A=g+36|0;B=g}while(0);x=(f[B>>2]&16384|0)==0;B=f[A>>2]|0;if(B|0?(s=B+12|0,B=f[s>>2]|0,f[s>>2]=B+-1,(B|0)==1):0)V$(g);f[A>>2]=0;A=g+16|0;B=g+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[g+40>>2]|0;s=0;do{f[A+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[B>>2]|0))}B=f[g+44>>2]|0;if((B|0)!=(g+48|0))wL(B);if(x){do if((eS(a)|0)==65536){x=f[a+4>>2]|0;f[j>>2]=f[x>>2];B=j+4|0;s=x+4|0;f[B>>2]=f[s>>2];A=j+8|0;f[A>>2]=f[x+8>>2];f[j+12>>2]=f[x+12>>2];f[j+16>>2]=f[x+16>>2];f[j+20>>2]=f[x+20>>2];f[j+24>>2]=f[x+24>>2];f[j+28>>2]=f[x+28>>2];f[j+32>>2]=f[x+32>>2];t=f[x+36>>2]|0;f[j+36>>2]=t;f[j+40>>2]=A;A=j+48|0;v=j+44|0;f[v>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(t|0){A=t+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[s>>2]|0)<3){s=f[x+44>>2]|0;A=f[v>>2]|0;f[A>>2]=f[s>>2];f[A+4>>2]=f[s+4>>2];break}else{f[B>>2]=0;U$(j,x);break}}else bS(j,a,-1);while(0);f[i>>2]=1124007936;x=i+4|0;B=i+8|0;s=i+40|0;o=x;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[s>>2]=B;o=i+48|0;f[i+44>>2]=o;f[o>>2]=0;f[i+52>>2]=0;p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=i;jR(j,g);p=h+36|0;A=f[p>>2]|0;if(A|0?(v=A+12|0,A=f[v>>2]|0,f[v>>2]=A+-1,(A|0)==1):0)V$(h);f[p>>2]=0;A=h+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[k>>2]|0)>0){v=f[m>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}f[h>>2]=f[i>>2];t=f[x>>2]|0;f[k>>2]=t;f[l>>2]=f[B>>2];f[h+12>>2]=f[i+12>>2];v=i+16|0;f[A>>2]=f[v>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];A=i+36|0;f[p>>2]=f[A>>2];p=h+44|0;w=f[p>>2]|0;if((w|0)==(q|0))C=t;else{wL(w);f[p>>2]=q;f[m>>2]=l;C=f[x>>2]|0}w=i+44|0;if((C|0)<3){C=f[w>>2]|0;f[q>>2]=f[C>>2];f[h+52>>2]=f[C+4>>2];D=C}else{f[p>>2]=f[w>>2];f[h+40>>2]=f[s>>2];f[w>>2]=o;f[s>>2]=B;D=o}f[i>>2]=1124007936;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;f[A>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((D|0)!=(o|0))wL(D);D=j+36|0;o=f[D>>2]|0;if(o|0?(v=o+12|0,o=f[v>>2]|0,f[v>>2]=o+-1,(o|0)==1):0)V$(j);f[D>>2]=0;D=j+16|0;o=j+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[o>>2]|0)>0){D=f[j+40>>2]|0;v=0;do{f[D+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[o>>2]|0))}o=f[j+44>>2]|0;if((o|0)!=(j+48|0))wL(o)}else{do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[g>>2]=f[o>>2];j=g+4|0;v=o+4|0;f[j>>2]=f[v>>2];D=g+8|0;f[D>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];A=f[o+36>>2]|0;f[g+36>>2]=A;f[g+40>>2]=D;D=g+48|0;x=g+44|0;f[x>>2]=D;f[D>>2]=0;f[g+52>>2]=0;if(A|0){D=A+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[v>>2]|0)<3){v=f[o+44>>2]|0;D=f[x>>2]|0;f[D>>2]=f[v>>2];f[D+4>>2]=f[v+4>>2];break}else{f[j>>2]=0;U$(g,o);break}}else bS(g,a,-1);while(0);a=h+36|0;o=f[a>>2]|0;if(o|0?(j=o+12|0,o=f[j>>2]|0,f[j>>2]=o+-1,(o|0)==1):0)V$(h);f[a>>2]=0;o=h+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[k>>2]|0)>0){j=f[m>>2]|0;v=0;do{f[j+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}f[h>>2]=f[g>>2];v=g+4|0;j=f[v>>2]|0;f[k>>2]=j;D=g+8|0;f[l>>2]=f[D>>2];f[h+12>>2]=f[g+12>>2];x=g+16|0;f[o>>2]=f[x>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];o=g+36|0;f[a>>2]=f[o>>2];a=h+44|0;A=f[a>>2]|0;if((A|0)==(q|0))E=j;else{wL(A);f[a>>2]=q;f[m>>2]=l;E=f[v>>2]|0}A=g+44|0;if((E|0)<3){E=f[A>>2]|0;f[q>>2]=f[E>>2];f[h+52>>2]=f[E+4>>2];F=E}else{f[a>>2]=f[A>>2];a=g+40|0;f[h+40>>2]=f[a>>2];E=g+48|0;f[A>>2]=E;f[a>>2]=D;F=E}f[g>>2]=1124007936;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[v+28>>2]=0;f[o>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((F|0)!=(g+48|0))wL(F)}switch(d|0){case 0:{G=0;H=127888;I=124464;break}case 1:{G=2;H=126312;I=122888;break}case 2:{G=1;H=124928;I=121604;break}default:{G=2;H=118852;I=118852}}F=f[h+12>>2]|0;x=b+8|0;o=f[b>>2]|0;v=((f[x>>2]|0)-o|0)/28|0;E=-2-G+F|0;D=G+1|0;a=(f[l>>2]|0)-D|0;l=b+4|0;A=f[l>>2]|0;j=A;if(!((A|0)==(o|0)|(j|0)==(o|0)))f[l>>2]=j+(~(((j+-28-o|0)>>>0)/28|0)*28|0);nSb(g,f[q>>2]|0,d);a:do if((D|0)<(a|0)){d=h+16|0;o=i+4|0;j=i+8|0;A=i+12|0;B=i+16|0;s=i+20|0;w=i+24|0;p=i+4|0;C=i+8|0;t=i+12|0;z=i+16|0;y=i+20|0;J=i+24|0;K=D;L=v;M=0;b:while(1){N=Y(K,F)|0;O=+(K|0);P=G;Q=L;R=M;c:while(1){S=P;d:while(1){T=S+1|0;if((S|0)>=(E|0)){U=R;V=Q;break c}W=(oSb(H,g,(f[d>>2]|0)+N+T|0,c)|0)+-252|0;if(W>>>0>=4){X=T;Z=Q;_=R;$=80;break}switch((-13400&65535)>>>((W&65535)<<2&65535)&7){case 0:{S=T;break}case 4:{aa=T;ba=R;ca=Q;$=97;break d;break}case 3:{X=T;Z=Q;_=R;$=80;break d;break}case 2:{da=T;ea=Q;fa=R;$=84;break d;break}default:{$=120;break b}}}e:while(1)if(($|0)==80){$=0;S=X;while(1){T=S+1|0;if((S|0)>=(E|0)){U=_;V=Z;break c}W=(oSb(I,g,(f[d>>2]|0)+N+T|0,c)|0)+-252|0;if(W>>>0>=4){da=T;ea=Z;fa=_;$=84;continue e}switch((-13400&65535)>>>((W&65535)<<2&65535)&7){case 0:{P=T;Q=Z;R=_;continue c;break}case 4:{aa=T;ba=_;ca=Z;$=97;continue e;break}case 2:{da=T;ea=Z;fa=_;$=84;continue e;break}case 3:{S=T;break}default:{$=120;break b}}}}else if(($|0)==84){$=0;if((fa|0)==(ea|0)){$=85;break}else{ga=ea;break}}else if(($|0)==97){$=0;do if((ba|0)==(ca|0)){if(ba|0){S=ba<<1;qNb(b,S);ha=S;break}S=f[b>>2]|0;T=S;if((((f[x>>2]|0)-S|0)/28|0)>>>0<512){W=f[l>>2]|0;ia=$Xc(14336)|0;ja=ia+(((W-S|0)/28|0)*28|0)|0;S=ja;ka=ia+14336|0;ia=W;if((ia|0)==(T|0)){la=S;ma=W}else{W=ia;ia=S;na=ja;do{ja=W;W=W+-28|0;f[na+-28>>2]=f[W>>2];f[na+-24>>2]=f[ja+-24>>2];oa=na+-20|0;pa=ja+-20|0;f[oa>>2]=f[pa>>2];f[oa+4>>2]=f[pa+4>>2];f[oa+8>>2]=f[pa+8>>2];f[oa+12>>2]=f[pa+12>>2];f[oa+16>>2]=f[pa+16>>2];na=ia+-28|0;ia=na}while((W|0)!=(T|0));la=ia;ma=f[b>>2]|0}f[b>>2]=la;f[l>>2]=S;f[x>>2]=ka;if(ma){cYc(ma);ha=512}else ha=512}else ha=512}else ha=ca;while(0);qa=+(aa|0);n[i>>2]=qa;n[o>>2]=O;n[j>>2]=7.0;n[A>>2]=-1.0;n[B>>2]=0.0;f[s>>2]=0;f[w>>2]=-1;T=f[l>>2]|0;if(T>>>0<(f[x>>2]|0)>>>0){n[T>>2]=qa;f[T+4>>2]=f[o>>2];W=T+8|0;f[W>>2]=f[j>>2];f[W+4>>2]=f[j+4>>2];f[W+8>>2]=f[j+8>>2];f[W+12>>2]=f[j+12>>2];f[W+16>>2]=f[j+16>>2];f[l>>2]=(f[l>>2]|0)+28}else NA(b,i);X=aa;Z=ha;_=ba+1|0;$=80;continue}do if(($|0)==85){$=0;if(fa|0){W=fa<<1;qNb(b,W);ga=W;break}W=f[b>>2]|0;T=W;if((((f[x>>2]|0)-W|0)/28|0)>>>0<512){na=f[l>>2]|0;pa=$Xc(14336)|0;oa=pa+(((na-W|0)/28|0)*28|0)|0;W=oa;ja=pa+14336|0;pa=na;if((pa|0)==(T|0)){ra=W;sa=na}else{na=pa;pa=W;ta=oa;do{oa=na;na=na+-28|0;f[ta+-28>>2]=f[na>>2];f[ta+-24>>2]=f[oa+-24>>2];ua=ta+-20|0;va=oa+-20|0;f[ua>>2]=f[va>>2];f[ua+4>>2]=f[va+4>>2];f[ua+8>>2]=f[va+8>>2];f[ua+12>>2]=f[va+12>>2];f[ua+16>>2]=f[va+16>>2];ta=pa+-28|0;pa=ta}while((na|0)!=(T|0));ra=pa;sa=f[b>>2]|0}f[b>>2]=ra;f[l>>2]=W;f[x>>2]=ja;if(sa){cYc(sa);ga=512}else ga=512}else ga=512}while(0);qa=+(da|0);n[i>>2]=qa;n[p>>2]=O;n[C>>2]=7.0;n[t>>2]=-1.0;n[z>>2]=0.0;f[y>>2]=0;f[J>>2]=-1;T=f[l>>2]|0;if(T>>>0<(f[x>>2]|0)>>>0){n[T>>2]=qa;f[T+4>>2]=f[p>>2];na=T+8|0;f[na>>2]=f[C>>2];f[na+4>>2]=f[C+4>>2];f[na+8>>2]=f[C+8>>2];f[na+12>>2]=f[C+12>>2];f[na+16>>2]=f[C+16>>2];f[l>>2]=(f[l>>2]|0)+28}else NA(b,i);P=da;Q=ga;R=fa+1|0}K=K+1|0;if((K|0)>=(a|0))break a;else{L=V;M=U}}}while(0);U=h+36|0;V=f[U>>2]|0;if(V|0?(a=V+12|0,V=f[a>>2]|0,f[a>>2]=V+-1,(V|0)==1):0)V$(h);f[U>>2]=0;U=h+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[k>>2]|0)>0){U=f[m>>2]|0;m=0;do{f[U+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[r>>2]|0;if((k|0)==(q|0)){u=e;return}wL(k);u=e;return}function IRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/28|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0<=((g-h|0)/28|0)>>>0){j=a+4|0;k=((f[j>>2]|0)-h|0)/28|0;l=d>>>0>k>>>0;m=b+(k*28|0)|0;k=l?m:c;if((k|0)==(b|0))n=i;else{o=b;p=i;while(1){f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];q=p+8|0;r=o+8|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];o=o+28|0;r=p+28|0;if((o|0)==(k|0)){n=r;break}else p=r}}if(!l){l=f[j>>2]|0;if((l|0)==(n|0))return;f[j>>2]=l+(~(((l+-28-n|0)>>>0)/28|0)*28|0);return}if((k|0)==(c|0))return;k=m;m=f[j>>2]|0;do{f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];n=m+8|0;l=k+8|0;f[n>>2]=f[l>>2];f[n+4>>2]=f[l+4>>2];f[n+8>>2]=f[l+8>>2];f[n+12>>2]=f[l+12>>2];f[n+16>>2]=f[l+16>>2];k=k+28|0;m=(f[j>>2]|0)+28|0;f[j>>2]=m}while((k|0)!=(c|0));return}k=h;if(!h)s=g;else{g=a+4|0;m=f[g>>2]|0;if((m|0)!=(i|0))f[g>>2]=m+(~(((m+-28-h|0)>>>0)/28|0)*28|0);cYc(k);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;s=0}if(d>>>0>153391689)kWc(a);g=(s|0)/28|0;s=g<<1;k=g>>>0<76695844?(s>>>0<d>>>0?d:s):153391689;if(k>>>0>153391689)kWc(a);s=$Xc(k*28|0)|0;d=a+4|0;f[d>>2]=s;f[a>>2]=s;f[e>>2]=s+(k*28|0);if((b|0)==(c|0))return;k=b;b=s;do{f[b>>2]=f[k>>2];f[b+4>>2]=f[k+4>>2];s=b+8|0;e=k+8|0;f[s>>2]=f[e>>2];f[s+4>>2]=f[e+4>>2];f[s+8>>2]=f[e+8>>2];f[s+12>>2]=f[e+12>>2];f[s+16>>2]=f[e+16>>2];k=k+28|0;b=(f[d>>2]|0)+28|0;f[d>>2]=b}while((k|0)!=(c|0));return}function JRb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=$Xc(28)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=128344;h=g+12|0;yP(h);f[h>>2]=128372;f[g+16>>2]=c;b[g+20>>0]=d&1;f[g+24>>2]=e;f[a>>2]=h;f[a+4>>2]=g;return}function KRb(a){a=a|0;WRb(a);cYc(a);return}function LRb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+192|0;h=g+136|0;i=g+80|0;j=g+32|0;k=g+16|0;l=g;if(sS(c)|0){m=f[d>>2]|0;n=d+4|0;o=f[n>>2]|0;if((o|0)==(m|0)){u=g;return}f[n>>2]=o+(~(((o+-28-m|0)>>>0)/28|0)*28|0);u=g;return}do if((eS(e)|0)==65536){m=f[e+4>>2]|0;f[h>>2]=f[m>>2];o=h+4|0;n=m+4|0;f[o>>2]=f[n>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[n>>2]|0)<3){n=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[n>>2];f[p+4>>2]=f[n+4>>2];break}else{f[o>>2]=0;U$(h,m);break}}else bS(h,e,-1);while(0);f[i>>2]=1124007936;e=i+4|0;m=i+8|0;o=i+40|0;n=e;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[o>>2]=m;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;p=j+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[j+32>>2]=j+8;p=j+40|0;f[j+36>>2]=p;f[j+44>>2]=0;f[p>>2]=0;p=c;r=f[p+4>>2]|0;q=k;f[q>>2]=f[p>>2];f[q+4>>2]=r;r=k+8|0;f[r>>2]=f[c+8>>2];q=k+12|0;f[q>>2]=f[c+12>>2];if(dS(c,-1)|0){p=(eS(c)|0)==655360;s=l+8|0;f[s>>2]=0;f[s+4>>2]=0;if(p){f[l>>2]=34209792;f[l+4>>2]=j}else{f[l>>2]=33619968;f[l+4>>2]=i}Spa(c,l,6,0);c=l;p=f[c+4>>2]|0;s=k;f[s>>2]=f[c>>2];f[s+4>>2]=p;f[r>>2]=f[l+8>>2];f[q>>2]=f[l+12>>2]}l=f[d>>2]|0;q=d+4|0;r=f[q>>2]|0;if((r|0)!=(l|0))f[q>>2]=r+(~(((r+-28-l|0)>>>0)/28|0)*28|0);GRb(k,d,f[a+4>>2]|0,(b[a+8>>0]|0)!=0,f[a+12>>2]|0);mSb(d,h);EQ(j);j=i+36|0;d=f[j>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)V$(i);f[j>>2]=0;j=i+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[e>>2]|0)>0){j=f[o>>2]|0;o=0;do{f[j+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[e>>2]|0))}e=f[n>>2]|0;if((e|0)!=(m|0))wL(e);e=h+36|0;m=f[e>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(h);f[e>>2]=0;e=h+16|0;m=h+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[h+40>>2]|0;n=0;do{f[e+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[h+44>>2]|0;if((m|0)!=(h+48|0))wL(m);u=g;return}function MRb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function NRb(a){a=a|0;return f[a+4>>2]|0}function ORb(a,c){a=a|0;c=c|0;b[a+8>>0]=c&1;return}function PRb(a){a=a|0;return (b[a+8>>0]|0)!=0|0}function QRb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function RRb(a){a=a|0;return f[a+12>>2]|0}function SRb(a){a=a|0;f[a>>2]=128344;WRb(a+12|0);NXc(a);return}function TRb(a){a=a|0;f[a>>2]=128344;WRb(a+12|0);NXc(a);cYc(a);return}function URb(a){a=a|0;WRb(a+12|0);return}function VRb(a){a=a|0;cYc(a);return}function WRb(a){a=a|0;qP(a);return}function XRb(a,b){a=a|0;b=b|0;return}function YRb(a,b){a=a|0;b=b|0;return}function ZRb(a){a=a|0;return 1}function _Rb(a,c){a=a|0;c=c|0;var d=0,e=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=9;c=a;d=467737;e=c+9|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b[a+9>>0]=0;return}function $Rb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;if(!(sS(b)|0)){e=f[(f[a>>2]|0)+48>>2]|0;g=fT()|0;Fh[e&255](a,b,d,c,g,0);return}g=f[c>>2]|0;d=c+4|0;c=f[d>>2]|0;if((c|0)==(g|0))return;f[d>>2]=c+(~(((c+-28-g|0)>>>0)/28|0)*28|0);return}function aSb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=u;u=u+144|0;h=g+128|0;i=g+72|0;j=g;k=g+16|0;l=pS(c,-1)|0;if(!(sS(e)|0)?(pS(e,-1)|0)!=(l|0):0){m=$Xc(48)|0;f[h>>2]=m;f[h+8>>2]=-2147483600;f[h+4>>2]=32;n=m;o=467704;p=n+32|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+32>>0]=0;vM(-215,h,470600,467535,84)}m=d+4|0;o=f[m>>2]|0;n=f[d>>2]|0;p=(o-n|0)/12|0;q=n;n=o;if(l>>>0<=p>>>0){if(l>>>0<p>>>0?(o=q+(l*12|0)|0,(n|0)!=(o|0)):0){q=n;while(1){n=q+-12|0;f[m>>2]=n;r=f[n>>2]|0;if(!r)s=n;else{n=q+-8|0;t=f[n>>2]|0;if((t|0)!=(r|0))f[n>>2]=t+(~(((t+-28-r|0)>>>0)/28|0)*28|0);cYc(r);s=f[m>>2]|0}if((s|0)==(o|0))break;else q=s}}}else tMb(d,l-p|0);p=(l|0)>0;if((eS(c)|0)!=327680){if(!p){u=g;return}s=h+8|0;q=h+12|0;o=h+4|0;m=j+8|0;r=j+12|0;t=j+8|0;n=j+4|0;v=0;do{w=f[(f[a>>2]|0)+32>>2]|0;fS(i,c,v);f[s>>2]=0;f[q>>2]=0;f[h>>2]=17432576;f[o>>2]=i;x=(f[d>>2]|0)+(v*12|0)|0;if(sS(e)|0){y=fT()|0;z=y;A=f[z+4>>2]|0;B=j;f[B>>2]=f[z>>2];f[B+4>>2]=A;f[m>>2]=f[y+8>>2];f[r>>2]=f[y+12>>2];ei[w&511](a,h,x,j)}else{fS(k,e,v);y=t;f[y>>2]=0;f[y+4>>2]=0;f[j>>2]=-1022754816;f[n>>2]=k;ei[w&511](a,h,x,j);EQ(k)}EQ(i);v=v+1|0}while((v|0)<(l|0));u=g;return}if(!p){u=g;return}p=i+4|0;v=i+16|0;n=i+36|0;t=i+40|0;r=i+48|0;m=i+44|0;o=h+8|0;q=h+12|0;s=h+4|0;x=j+8|0;w=j+12|0;y=k+36|0;A=k+16|0;B=k+4|0;z=k+40|0;C=k+44|0;D=k+48|0;E=j+8|0;F=j+4|0;G=0;do{H=f[(f[a>>2]|0)+32>>2]|0;bS(i,c,G);f[o>>2]=0;f[q>>2]=0;f[h>>2]=16842752;f[s>>2]=i;I=(f[d>>2]|0)+(G*12|0)|0;if(!(sS(e)|0)){bS(k,e,G);J=E;f[J>>2]=0;f[J+4>>2]=0;f[j>>2]=-1023344640;f[F>>2]=k;ei[H&511](a,h,I,j);J=f[y>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)V$(k);f[y>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){J=f[z>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[B>>2]|0))}K=f[C>>2]|0;if((K|0)!=(D|0))wL(K)}else{K=fT()|0;J=K;L=f[J+4>>2]|0;M=j;f[M>>2]=f[J>>2];f[M+4>>2]=L;f[x>>2]=f[K+8>>2];f[w>>2]=f[K+12>>2];ei[H&511](a,h,I,j)}K=f[n>>2]|0;if(K|0?(L=K+12|0,K=f[L>>2]|0,f[L>>2]=K+-1,(K|0)==1):0)V$(i);f[n>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[p>>2]|0)>0){K=f[t>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[p>>2]|0))}L=f[m>>2]|0;if((L|0)!=(r|0))wL(L);G=G+1|0}while((G|0)<(l|0));u=g;return}function bSb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;if(sS(b)|0){vS(d);return}else{e=f[(f[a>>2]|0)+48>>2]|0;g=fT()|0;Fh[e&255](a,b,g,c,d,1);return}}function cSb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+96|0;h=g+72|0;i=g+16|0;j=g;if(!(aT(e)|0)){u=g;return}k=pS(c,-1)|0;if((((f[d+4>>2]|0)-(f[d>>2]|0)|0)/12|0|0)!=(k|0)){l=$Xc(48)|0;f[h>>2]=l;f[h+8>>2]=-2147483600;f[h+4>>2]=35;m=l;n=467612;o=m+35|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+35>>0]=0;vM(-215,h,467648,467535,139)}if((eS(e)|0)!=327680){if((eS(e)|0)!=720896){l=$Xc(48)|0;f[h>>2]=l;f[h+8>>2]=-2147483600;f[h+4>>2]=47;m=l;n=467656;o=m+47|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+47>>0]=0;vM(-5,h,467648,467535,161)}l=f[e+4>>2]|0;n=l+4|0;m=f[n>>2]|0;o=f[l>>2]|0;p=(m-o|0)/48|0;q=o;o=m;if(k>>>0<=p>>>0){if(k>>>0<p>>>0?(m=q+(k*48|0)|0,(o|0)!=(m|0)):0){q=o;do{o=q+-48|0;f[n>>2]=o;EQ(o);q=f[n>>2]|0}while((q|0)!=(m|0))}}else kS(l,k-p|0);if((k|0)<=0){u=g;return}p=h+8|0;m=h+12|0;q=h+4|0;n=j+8|0;o=j+4|0;r=0;do{s=f[(f[a>>2]|0)+40>>2]|0;fS(i,c,r);f[p>>2]=0;f[m>>2]=0;f[h>>2]=17432576;f[q>>2]=i;t=(f[d>>2]|0)+(r*12|0)|0;v=(f[l>>2]|0)+(r*48|0)|0;w=n;f[w>>2]=0;f[w+4>>2]=0;f[j>>2]=34209792;f[o>>2]=v;ei[s&511](a,h,t,j);EQ(i);r=r+1|0}while((r|0)<(k|0));u=g;return}r=f[e+4>>2]|0;hS(r,k);if((k|0)<=0){u=g;return}e=i+4|0;o=i+16|0;n=i+36|0;l=i+40|0;q=i+48|0;m=i+44|0;p=h+8|0;t=h+12|0;s=h+4|0;v=j+8|0;w=j+4|0;x=0;do{y=f[(f[a>>2]|0)+40>>2]|0;bS(i,c,x);f[p>>2]=0;f[t>>2]=0;f[h>>2]=16842752;f[s>>2]=i;z=(f[d>>2]|0)+(x*12|0)|0;A=(f[r>>2]|0)+(x*56|0)|0;B=v;f[B>>2]=0;f[B+4>>2]=0;f[j>>2]=33619968;f[w>>2]=A;ei[y&511](a,h,z,j);z=f[n>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)V$(i);f[n>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[e>>2]|0)>0){z=f[l>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[e>>2]|0))}y=f[m>>2]|0;if((y|0)!=(q|0))wL(y);x=x+1|0}while((x|0)<(k|0));u=g;return}function dSb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=u;u=u+16|0;e=g;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-213,e,467518,467535,174)}function eSb(a){a=a|0;return 0}function fSb(a){a=a|0;return 5}function gSb(a){a=a|0;var b=0;b=(_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0)==0;return (b?6:4)|0}function hSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0;c=u;u=u+48|0;d=c+8|0;e=c+44|0;g=c+40|0;h=c+36|0;i=c+32|0;j=c+28|0;k=c;if((b|0)<=-1){u=c;return}l=a+4|0;m=f[l>>2]|0;o=f[a>>2]|0;p=o;q=m;if(((m-o|0)/28|0)>>>0<=b>>>0){u=c;return}if(!b){if((q|0)==(p|0)){u=c;return}f[l>>2]=q+(~(((q+-28-o|0)>>>0)/28|0)*28|0);u=c;return}f[h>>2]=o;f[i>>2]=p+(b*28|0);f[j>>2]=m;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];f[d>>2]=f[j>>2];iSb(g,e,d,k);k=f[a>>2]|0;r=+n[k+((b+-1|0)*28|0)+16>>2];e=k+(b*28|0)|0;b=f[l>>2]|0;a:do if((e|0)==(b|0))s=e;else{k=b;g=e;while(1){j=g;while(1){if(!(+n[j+16>>2]>=r)){t=k;break}i=j+28|0;if((i|0)==(k|0)){s=k;break a}else j=i}while(1){v=t+-28|0;if((j|0)==(v|0)){s=j;break a}if(!(+n[t+-12>>2]>=r))t=v;else break}i=f[j>>2]|0;h=j+4|0;m=f[h>>2]|0;p=j+8|0;f[d>>2]=f[p>>2];f[d+4>>2]=f[p+4>>2];f[d+8>>2]=f[p+8>>2];f[d+12>>2]=f[p+12>>2];f[d+16>>2]=f[p+16>>2];f[j>>2]=f[v>>2];o=t+-24|0;f[h>>2]=f[o>>2];h=t+-20|0;f[p>>2]=f[h>>2];f[p+4>>2]=f[h+4>>2];f[p+8>>2]=f[h+8>>2];f[p+12>>2]=f[h+12>>2];f[p+16>>2]=f[h+16>>2];f[v>>2]=i;f[o>>2]=m;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[h+8>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];f[h+16>>2]=f[d+16>>2];h=j+28|0;if((h|0)==(v|0)){s=h;break}else{k=v;g=h}}}while(0);v=f[a>>2]|0;d=(s-v|0)/28|0;s=f[l>>2]|0;t=(s-v|0)/28|0;e=s;if(d>>>0>t>>>0){iL(a,d-t|0);u=c;return}if(d>>>0>=t>>>0){u=c;return}t=v+(d*28|0)|0;if((e|0)==(t|0)){u=c;return}f[l>>2]=e+(~(((e+-28-t|0)>>>0)/28|0)*28|0);u=c;return}function iSb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+64|0;g=e+8|0;h=e;i=e+56|0;j=e+52|0;k=e+48|0;l=e+44|0;m=e+28|0;o=e+40|0;p=e+36|0;q=e+32|0;r=f[b>>2]|0;b=f[c>>2]|0;if((r|0)==(b|0)){u=e;return}s=b;a:while(1){b=s+-28|0;t=b;v=(r|0)==(s|0);w=s;x=s+-28|0;y=x;z=s+-12|0;A=s+-24|0;B=s+-20|0;C=f[a>>2]|0;b:while(1){D=C;E=w-C|0;F=(E|0)/28|0;switch(F|0){case 2:{G=5;break a;break}case 3:{G=7;break a;break}case 1:case 0:{G=67;break a;break}default:{}}if((E|0)<224){G=9;break a}E=F>>>1;F=D+(E*28|0)|0;f[m>>2]=F;f[o>>2]=C;f[p>>2]=F;f[q>>2]=t;f[i>>2]=f[o>>2];f[h>>2]=f[p>>2];f[g>>2]=f[q>>2];H=jSb(i,h,g,d)|0;f[h>>2]=t;I=+n[D+(E*28|0)+16>>2];if(+n[D+16>>2]>I){J=H;K=b;break}else L=b;while(1){M=L+-28|0;f[h>>2]=M;if((D|0)==(M|0))break;if(+n[L+-12>>2]>I){G=40;break b}else L=M}E=D+28|0;F=E;f[h>>2]=y;if(+n[D+16>>2]>+n[z>>2]){N=x;O=F}else{if((E|0)==(x|0)){G=65;break a}I=+n[D+16>>2];P=F;F=E;while(1){if(I>+n[F+16>>2])break;E=F+28|0;if((E|0)==(x|0)){G=65;break a}else{P=E;F=E}}E=P;Q=f[E>>2]|0;R=F+4|0;S=f[R>>2]|0;T=F+8|0;f[g>>2]=f[T>>2];f[g+4>>2]=f[T+4>>2];f[g+8>>2]=f[T+8>>2];f[g+12>>2]=f[T+12>>2];f[g+16>>2]=f[T+16>>2];f[E>>2]=f[x>>2];f[R>>2]=f[A>>2];f[T>>2]=f[B>>2];f[T+4>>2]=f[B+4>>2];f[T+8>>2]=f[B+8>>2];f[T+12>>2]=f[B+12>>2];f[T+16>>2]=f[B+16>>2];f[x>>2]=Q;f[A>>2]=S;f[B>>2]=f[g>>2];f[B+4>>2]=f[g+4>>2];f[B+8>>2]=f[g+8>>2];f[B+12>>2]=f[g+12>>2];f[B+16>>2]=f[g+16>>2];N=f[h>>2]|0;O=F+28|0}if((O|0)==(N|0)){G=65;break a}S=(f[a>>2]|0)+16|0;Q=O;while(1){T=Q;I=+n[S>>2];if(I>+n[T+16>>2]){U=T;V=Q}else{R=T;do{T=R;R=R+28|0}while(!(I>+n[T+44>>2]));U=R;V=R}T=f[h>>2]|0;while(1){W=T+-28|0;f[h>>2]=W;if(I>+n[T+-12>>2])T=W;else break}if(U>>>0>=W>>>0)break;R=V;E=f[R>>2]|0;X=U+4|0;Y=f[X>>2]|0;Z=U+8|0;f[g>>2]=f[Z>>2];f[g+4>>2]=f[Z+4>>2];f[g+8>>2]=f[Z+8>>2];f[g+12>>2]=f[Z+12>>2];f[g+16>>2]=f[Z+16>>2];f[R>>2]=f[W>>2];R=T+-24|0;f[X>>2]=f[R>>2];X=T+-20|0;f[Z>>2]=f[X>>2];f[Z+4>>2]=f[X+4>>2];f[Z+8>>2]=f[X+8>>2];f[Z+12>>2]=f[X+12>>2];f[Z+16>>2]=f[X+16>>2];f[W>>2]=E;f[R>>2]=Y;f[X>>2]=f[g>>2];f[X+4>>2]=f[g+4>>2];f[X+8>>2]=f[g+8>>2];f[X+12>>2]=f[g+12>>2];f[X+16>>2]=f[g+16>>2];Q=U+28|0}if(r>>>0<U>>>0){G=65;break a}f[a>>2]=V;if(v){G=67;break a}else C=V}if((G|0)==40){G=0;v=C;B=f[v>>2]|0;A=D+4|0;x=f[A>>2]|0;z=D+8|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];f[g+8>>2]=f[z+8>>2];f[g+12>>2]=f[z+12>>2];f[g+16>>2]=f[z+16>>2];f[v>>2]=f[M>>2];v=L+-24|0;f[A>>2]=f[v>>2];A=L+-20|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[M>>2]=B;f[v>>2]=x;f[A>>2]=f[g>>2];f[A+4>>2]=f[g+4>>2];f[A+8>>2]=f[g+8>>2];f[A+12>>2]=f[g+12>>2];f[A+16>>2]=f[g+16>>2];J=H+1|0;K=f[h>>2]|0}A=D+28|0;x=A;v=f[m>>2]|0;c:do if(A>>>0<K>>>0){B=J;z=v;y=x;while(1){b=y;if(+n[b+16>>2]>+n[z+16>>2]){I=+n[z+16>>2];t=b;do{w=t;t=t+28|0}while(+n[w+44>>2]>I);_=t;$=t}else{_=b;$=y}I=+n[z+16>>2];T=f[h>>2]|0;while(1){aa=T+-28|0;f[h>>2]=aa;if(+n[T+-12>>2]>I)break;else T=aa}if(_>>>0>=aa>>>0){ba=B;ca=z;da=$;break c}b=$;t=f[b>>2]|0;w=_+4|0;Q=f[w>>2]|0;S=_+8|0;f[g>>2]=f[S>>2];f[g+4>>2]=f[S+4>>2];f[g+8>>2]=f[S+8>>2];f[g+12>>2]=f[S+12>>2];f[g+16>>2]=f[S+16>>2];f[b>>2]=f[aa>>2];b=T+-24|0;f[w>>2]=f[b>>2];w=T+-20|0;f[S>>2]=f[w>>2];f[S+4>>2]=f[w+4>>2];f[S+8>>2]=f[w+8>>2];f[S+12>>2]=f[w+12>>2];f[S+16>>2]=f[w+16>>2];f[aa>>2]=t;f[b>>2]=Q;f[w>>2]=f[g>>2];f[w+4>>2]=f[g+4>>2];f[w+8>>2]=f[g+8>>2];f[w+12>>2]=f[g+12>>2];f[w+16>>2]=f[g+16>>2];w=f[m>>2]|0;if((w|0)==(_|0)){Q=f[h>>2]|0;f[m>>2]=Q;ea=Q}else ea=w;B=B+1|0;z=ea;y=_+28|0}}else{ba=J;ca=v;da=x}while(0);x=da;if((x|0)!=(ca|0)?+n[ca+16>>2]>+n[x+16>>2]:0){v=da;A=f[v>>2]|0;y=x+4|0;z=f[y>>2]|0;B=x+8|0;f[g>>2]=f[B>>2];f[g+4>>2]=f[B+4>>2];f[g+8>>2]=f[B+8>>2];f[g+12>>2]=f[B+12>>2];f[g+16>>2]=f[B+16>>2];f[v>>2]=f[ca>>2];v=ca+4|0;f[y>>2]=f[v>>2];y=ca+8|0;f[B>>2]=f[y>>2];f[B+4>>2]=f[y+4>>2];f[B+8>>2]=f[y+8>>2];f[B+12>>2]=f[y+12>>2];f[B+16>>2]=f[y+16>>2];f[ca>>2]=A;f[v>>2]=z;f[y>>2]=f[g>>2];f[y+4>>2]=f[g+4>>2];f[y+8>>2]=f[g+8>>2];f[y+12>>2]=f[g+12>>2];f[y+16>>2]=f[g+16>>2];fa=ba+1|0}else fa=ba;if((r|0)==(x|0)){G=65;break}if(!fa)if(r>>>0<x>>>0){f[m>>2]=C;y=C;z=h;while(1){f[z>>2]=y;v=f[h>>2]|0;A=v+28|0;B=A;f[h>>2]=B;if((A|0)==(x|0)){G=65;break a}if(+n[v+44>>2]>+n[(f[m>>2]|0)+16>>2])break;else{y=B;z=m}}}else{f[m>>2]=da;z=da;y=h;while(1){f[y>>2]=z;B=f[h>>2]|0;v=B+28|0;A=v;f[h>>2]=A;if((v|0)==(s|0)){G=65;break a}if(+n[B+44>>2]>+n[(f[m>>2]|0)+16>>2])break;else{z=A;y=m}}}y=r>>>0<x>>>0;f[(y?c:a)>>2]=y?da:x+28|0;y=f[c>>2]|0;if((r|0)==(y|0)){G=67;break}else s=y}if((G|0)==5){r=s+-28|0;f[c>>2]=r;if(!(+n[s+-12>>2]>+n[D+16>>2])){u=e;return}da=C;a=f[da>>2]|0;m=D+4|0;fa=f[m>>2]|0;ba=D+8|0;f[g>>2]=f[ba>>2];f[g+4>>2]=f[ba+4>>2];f[g+8>>2]=f[ba+8>>2];f[g+12>>2]=f[ba+12>>2];f[g+16>>2]=f[ba+16>>2];f[da>>2]=f[r>>2];da=s+-24|0;f[m>>2]=f[da>>2];m=s+-20|0;f[ba>>2]=f[m>>2];f[ba+4>>2]=f[m+4>>2];f[ba+8>>2]=f[m+8>>2];f[ba+12>>2]=f[m+12>>2];f[ba+16>>2]=f[m+16>>2];f[r>>2]=a;f[da>>2]=fa;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];f[m+16>>2]=f[g+16>>2];u=e;return}else if((G|0)==7){f[j>>2]=C;f[k>>2]=C+28;m=s+-28|0;f[c>>2]=m;f[l>>2]=m;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];f[g>>2]=f[l>>2];jSb(i,h,g,d)|0;u=e;return}else if((G|0)==9){d=s+-28|0;i=C;if((i|0)==(d|0)){u=e;return}C=i;do{f[h>>2]=C;if((C|0)==(s|0))ga=s;else{i=h;l=g;d:while(1){f[l>>2]=f[i>>2];ha=f[h>>2]|0;k=ha+16|0;j=f[g>>2]|0;do{m=j;j=j+28|0;if((j|0)==(s|0))break d}while(!(+n[m+44>>2]>+n[k>>2]));f[g>>2]=j;i=g;l=h}ga=ha}if((ga|0)!=(C|0)){l=f[C>>2]|0;i=C+4|0;x=f[i>>2]|0;k=C+8|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[C>>2]=f[ga>>2];m=ga+4|0;f[i>>2]=f[m>>2];i=ga+8|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[k+16>>2]=f[i+16>>2];f[ga>>2]=l;f[m>>2]=x;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];f[i+16>>2]=f[g+16>>2]}C=C+28|0}while((C|0)!=(d|0));u=e;return}else if((G|0)==65){u=e;return}else if((G|0)==67){u=e;return}}function jSb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+32|0;e=d;g=f[b>>2]|0;b=f[a>>2]|0;a=g+16|0;h=+n[a>>2];i=b+16|0;j=f[c>>2]|0;c=j+16|0;k=+n[c>>2]>h;if(!(h>+n[i>>2])){if(!k){l=0;u=d;return l|0}m=f[g>>2]|0;o=g+4|0;p=f[o>>2]|0;q=g+8|0;f[e>>2]=f[q>>2];f[e+4>>2]=f[q+4>>2];f[e+8>>2]=f[q+8>>2];f[e+12>>2]=f[q+12>>2];f[e+16>>2]=f[q+16>>2];f[g>>2]=f[j>>2];r=j+4|0;f[o>>2]=f[r>>2];s=j+8|0;f[q>>2]=f[s>>2];f[q+4>>2]=f[s+4>>2];f[q+8>>2]=f[s+8>>2];f[q+12>>2]=f[s+12>>2];f[q+16>>2]=f[s+16>>2];f[j>>2]=m;f[r>>2]=p;f[s>>2]=f[e>>2];f[s+4>>2]=f[e+4>>2];f[s+8>>2]=f[e+8>>2];f[s+12>>2]=f[e+12>>2];f[s+16>>2]=f[e+16>>2];if(!(+n[a>>2]>+n[i>>2])){l=1;u=d;return l|0}i=f[b>>2]|0;s=b+4|0;p=f[s>>2]|0;r=b+8|0;f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[e+16>>2]=f[r+16>>2];f[b>>2]=f[g>>2];f[s>>2]=f[o>>2];f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];f[r+8>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];f[r+16>>2]=f[q+16>>2];f[g>>2]=i;f[o>>2]=p;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];l=2;u=d;return l|0}if(k){k=f[b>>2]|0;q=b+4|0;p=f[q>>2]|0;o=b+8|0;f[e>>2]=f[o>>2];f[e+4>>2]=f[o+4>>2];f[e+8>>2]=f[o+8>>2];f[e+12>>2]=f[o+12>>2];f[e+16>>2]=f[o+16>>2];f[b>>2]=f[j>>2];i=j+4|0;f[q>>2]=f[i>>2];q=j+8|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[j>>2]=k;f[i>>2]=p;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];l=1;u=d;return l|0}q=f[b>>2]|0;p=b+4|0;i=f[p>>2]|0;k=b+8|0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[b>>2]=f[g>>2];b=g+4|0;f[p>>2]=f[b>>2];p=g+8|0;f[k>>2]=f[p>>2];f[k+4>>2]=f[p+4>>2];f[k+8>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[g>>2]=q;f[b>>2]=i;f[p>>2]=f[e>>2];f[p+4>>2]=f[e+4>>2];f[p+8>>2]=f[e+8>>2];f[p+12>>2]=f[e+12>>2];f[p+16>>2]=f[e+16>>2];if(!(+n[c>>2]>+n[a>>2])){l=1;u=d;return l|0};f[e>>2]=f[p>>2];f[e+4>>2]=f[p+4>>2];f[e+8>>2]=f[p+8>>2];f[e+12>>2]=f[p+12>>2];f[e+16>>2]=f[p+16>>2];f[g>>2]=f[j>>2];g=j+4|0;f[b>>2]=f[g>>2];b=j+8|0;f[p>>2]=f[b>>2];f[p+4>>2]=f[b+4>>2];f[p+8>>2]=f[b+8>>2];f[p+12>>2]=f[b+12>>2];f[p+16>>2]=f[b+16>>2];f[j>>2]=q;f[g>>2]=i;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];l=2;u=d;return l|0}function kSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+28|0;g=d+24|0;h=d+20|0;i=d+16|0;j=d;if((c|0)<=0){u=d;return}k=f[b+4>>2]|0;l=c<<1;if((k|0)>(l|0)?(m=f[b>>2]|0,(m|0)>(l|0)):0){f[h>>2]=f[a>>2];l=a+4|0;f[i>>2]=f[l>>2];b=m-c|0;m=k-c|0;k=(b|0)<(c|0)?b:c;n=(m|0)<(c|0)?m:c;f[j>>2]=k;f[j+4>>2]=n;f[j+8>>2]=((b|0)>(c|0)?b:c)-k;f[j+12>>2]=((m|0)>(c|0)?m:c)-n;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];i=lSb(g,e,j)|0;j=f[l>>2]|0;if((i|0)==(j|0)){u=d;return}f[l>>2]=j+(~(((j+-28-i|0)>>>0)/28|0)*28|0);u=d;return}i=f[a>>2]|0;j=a+4|0;a=f[j>>2]|0;if((a|0)==(i|0)){u=d;return}f[j>>2]=a+(~(((a+-28-i|0)>>>0)/28|0)*28|0);u=d;return}function lSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0;d=f[a>>2]|0;e=f[b>>2]|0;a:do if((d|0)==(e|0))g=d;else{b=f[c>>2]|0;h=(f[c+8>>2]|0)+b|0;i=f[c+4>>2]|0;j=(f[c+12>>2]|0)+i|0;k=d;do{l=ALc(+n[k>>2])|0;m=ALc(+n[k+4>>2])|0;if(!((m|0)<(j|0)&(((l|0)>=(h|0)|(b|0)>(l|0)|(i|0)>(m|0))^1))){g=k;break a}k=k+28|0}while((k|0)!=(e|0));f[a>>2]=e;o=e;return o|0}while(0);f[a>>2]=g;if((g|0)==(e|0)){o=e;return o|0}d=g+28|0;if((d|0)==(e|0)){o=g;return o|0}k=c+8|0;i=c+4|0;b=c+12|0;h=d;d=g;j=g;while(1){p=+n[h>>2];g=ALc(p)|0;m=d+32|0;l=ALc(+n[m>>2])|0;q=f[c>>2]|0;if((((q|0)<=(g|0)?(g|0)<((f[k>>2]|0)+q|0):0)?(q=f[i>>2]|0,(q|0)<=(l|0)):0)?(l|0)<((f[b>>2]|0)+q|0):0){n[j>>2]=p;f[j+4>>2]=f[m>>2];m=j+8|0;q=d+36|0;f[m>>2]=f[q>>2];f[m+4>>2]=f[q+4>>2];f[m+8>>2]=f[q+8>>2];f[m+12>>2]=f[q+12>>2];f[m+16>>2]=f[q+16>>2];q=j+28|0;f[a>>2]=q;r=q}else r=j;q=h+28|0;if((q|0)==(e|0)){o=r;break}else{m=h;h=q;j=r;d=m}}return o|0}function mSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;d=u;u=u+64|0;e=d;g=f[c+16>>2]|0;h=g;if(!g){u=d;return}g=c+4|0;i=f[g>>2]|0;if((i|0)<3)j=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{k=f[c+40>>2]|0;l=0;m=1;while(1){o=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(i|0)){j=o;break}else m=o}}if((i|0)==0|(j|0)==0){u=d;return}j=f[a>>2]|0;m=a+4|0;a=f[m>>2]|0;f[e>>2]=f[c>>2];l=e+4|0;f[l>>2]=i;k=e+8|0;f[k>>2]=f[c+8>>2];f[e+12>>2]=f[c+12>>2];o=e+16|0;f[o>>2]=h;f[e+20>>2]=f[c+20>>2];f[e+24>>2]=f[c+24>>2];f[e+28>>2]=f[c+28>>2];f[e+32>>2]=f[c+32>>2];h=e+36|0;p=f[c+36>>2]|0;f[h>>2]=p;q=e+40|0;f[q>>2]=k;k=e+48|0;r=e+44|0;f[r>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(!p)s=i;else{i=p+12|0;f[i>>2]=(f[i>>2]|0)+1;s=f[g>>2]|0}if((s|0)<3){s=f[c+44>>2]|0;g=f[r>>2]|0;f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2]}else{f[l>>2]=0;U$(e,c)}a:do if((j|0)==(a|0)){t=j;v=16}else{c=f[o>>2]|0;s=f[f[r>>2]>>2]|0;g=j;while(1){i=c+(Y(~~(+n[g+4>>2]+.5),s)|0)+~~(+n[g>>2]+.5)|0;if(!(b[i>>0]|0)){t=g;v=16;break a}g=g+28|0;if((g|0)==(a|0)){w=a;break}}}while(0);if((v|0)==16)if((t|0)!=(a|0)){v=t+28|0;if((v|0)==(a|0))w=t;else{j=v;v=t;g=t;while(1){t=g+32|0;x=+n[j>>2];s=(f[o>>2]|0)+(Y(f[f[r>>2]>>2]|0,~~(+n[t>>2]+.5))|0)+~~(x+.5)|0;if(!(b[s>>0]|0))y=v;else{n[v>>2]=x;f[v+4>>2]=f[t>>2];t=v+8|0;s=g+36|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];y=v+28|0}s=j+28|0;if((s|0)==(a|0)){w=y;break}else{t=j;j=s;v=y;g=t}}}}else w=a;a=f[m>>2]|0;if((w|0)!=(a|0))f[m>>2]=a+(~(((a+-28-w|0)>>>0)/28|0)*28|0);w=f[h>>2]|0;if(w|0?(a=w+12|0,w=f[a>>2]|0,f[a>>2]=w+-1,(w|0)==1):0)V$(e);f[h>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){o=f[q>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)==(k|0)){u=d;return}wL(l);u=d;return}function nSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;switch(d|0){case 3:{h=16;i=128524;break}case 1:{h=12;i=128748;break}case 2:{h=12;i=128652;break}default:{j=(d|0)==0;h=(d+-1|0)>>>0<2?12:j?8:0;i=j?128460:0}}if(!((a|0)!=0&(i|0)!=0)){j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=16;d=j;k=467763;l=d+16|0;do{b[d>>0]=b[k>>0]|0;d=d+1|0;k=k+1|0}while((d|0)<(l|0));b[j+16>>0]=0;vM(-215,g,467780,467797,86)}if((h|0)>0)m=0;else{u=e;return}do{g=(Y(f[i+(m<<3)+4>>2]|0,c)|0)+(f[i+(m<<3)>>2]|0)|0;f[a+(m<<2)>>2]=g;m=m+1|0}while((m|0)!=(h|0));u=e;return}function oSb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0;e=h[c>>0]|0;g=e+d|0;i=e-d|0;d=f[a>>2]|0;if(d>>>0>65535)j=d;else{k=d;l=k&255;return l|0}while(1){d=h[c+(f[b+(j>>>28<<2)>>2]|0)>>0]|0;e=f[a+(((((j&4096|0)==0?(d|0)>(g|0):(d|0)<(i|0))?j>>>16:j)&4095)<<2)>>2]|0;if(e>>>0>65535)j=e;else{k=e;break}}l=k&255;return l|0}function pSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=65574;while(1){m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;n=((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l;o=n&4095;if((n&4094|0)==108)break;else l=f[128844+(o<<2)>>2]|0}l=(o|0)==108;k=l?i:c;p=l?e:i;if((p|0)==(k|0)|(p|0)==(k+-1|0))break;else{e=p;g=p+k|0;c=k}}return p|0}function qSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=65717;while(1){m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;n=((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l;o=n&4095;if((n&4094|0)==390)break;else l=f[129284+(o<<2)>>2]|0}l=(o|0)==390;k=l?i:c;p=l?e:i;if((p|0)==(k|0)|(p|0)==(k+-1|0))break;else{e=p;g=p+k|0;c=k}}return p|0}function rSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=66347;do{m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;l=f[130852+(((((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l)&4095)<<2)>>2]|0}while(l>>>0>65535);k=(l&255|0)==254;j=k?i:c;n=k?e:i;if((n|0)==(j|0)|(n|0)==(j+-1|0))break;else{e=n;g=n+j|0;c=j}}return n|0}function sSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=h[a>>0]|0;e=c;g=c+255|0;c=255;while(1){i=(g|0)/2|0;j=i+d|0;k=d-i|0;l=65848;while(1){m=h[a+(f[b+(l>>>28<<2)>>2]|0)>>0]|0;n=((l&4096|0)==0?(m|0)>(j|0):(m|0)<(k|0))?l>>>16:l;o=n&4095;if((n&4094|0)==684)break;else l=f[138316+(o<<2)>>2]|0}l=(o|0)==502|(o|0)==684;k=l?i:c;p=l?e:i;if((p|0)==(k|0)|(p|0)==(k+-1|0))break;else{e=p;g=p+k|0;c=k}}return p|0}function tSb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141068;b=f[a+352>>2]|0;if(b|0)UXc(b);EQ(a+300|0);EQ(a+252|0);EQ(a+204|0);EQ(a+156|0);b=a+100|0;c=a+136|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))wL(b);b=a+44|0;d=a+80|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+60|0;b=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+84>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0))return;wL(b);return}function uSb(a){a=a|0;tSb(a);cYc(a);return}function vSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a+8>>2]=f[c>>2];f[a+12>>2]=f[c+4>>2];c=a+24|0;b=a+348|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;c=f[b>>2]|0;if(!c){d=$Xc(24)|0;f[d+4>>2]=0;f[d+8>>2]=0;f[d>>2]=141128;e=d+12|0;f[e>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;TXc(d);f[b>>2]=e;e=a+352|0;a=f[e>>2]|0;f[e>>2]=d;if(a|0)UXc(a);UXc(d);return 1}else{d=f[c>>2]|0;a=c+4|0;c=f[a>>2]|0;if((c|0)==(d|0))return 1;f[a>>2]=c+(~(((c+-20-d|0)>>>0)/20|0)*20|0);return 1}return 0}function wSb(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function xSb(a){a=a|0;return -1}function ySb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=u;u=u+208|0;g=e+160|0;h=e+144|0;i=e+152|0;j=e+80|0;k=e+136|0;l=e+16|0;m=e;o=e+72|0;cS(h,c,-1);f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];h=HSb(a,i,d)|0;d=a+348|0;i=f[d>>2]|0;p=f[i>>2]|0;q=(f[i+4>>2]|0)-p|0;i=(q|0)/20|0;if(!q){r=0;u=e;return r|0}q=p;p=f[q+8>>2]|0;s=a+100|0;t=a+112|0;v=(f[q+4>>2]|0)+15&-16;q=f[t>>2]|0;w=(q|0)<(v|0)?v:q;q=a+108|0;v=f[q>>2]|0;x=(v|0)<(p|0)?p:v;if(h){Yi[f[(f[a>>2]|0)+48>>2]&4095](a);ISb(f[d>>2]|0,a+300|0)}if(((eS(c)|0)==655360?(f[a+24>>2]|0)>=1:0)?(f[a+28>>2]|0)>=1:0){h=a+204|0;v=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;p=f[a+16>>2]|0;if(!(((((f[a+208>>2]|0)<3?(f[a+212>>2]|0)==(v|0):0)?(f[a+216>>2]|0)==(p|0):0)?(f[h>>2]&4095|0)==4:0)?(f[a+228>>2]|0)!=0:0)){f[g>>2]=v;f[g+4>>2]=p;BQ(h,2,g,4,0)}h=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(x|0):0)?(f[a+168>>2]|0)==(w|0):0)?(f[h>>2]&4095|0)==0:0)?(f[a+180>>2]|0)!=0:0)){f[g>>2]=x;f[g+4>>2]=w;BQ(h,2,g,0,0)}p=j+4|0;v=j+8|0;y=j+12|0;z=j+8|0;A=j+4|0;B=g+32|0;C=k+4|0;D=j+8|0;E=j+12|0;F=j+4|0;G=0;do{H=f[d>>2]|0;I=f[H>>2]|0;if((((f[H+4>>2]|0)-I|0)/20|0)>>>0<=G>>>0){J=21;break}K=I;I=(f[K+(G*20|0)+4>>2]|0)+-1|0;L=(f[K+(G*20|0)+8>>2]|0)+-1|0;f[j>>2]=0;f[p>>2]=0;f[v>>2]=I;f[y>>2]=L;AQ(g,h,j);L=z;f[L>>2]=0;f[L+4>>2]=0;f[j>>2]=34209792;f[A>>2]=g;L=f[B>>2]|0;I=f[L>>2]|0;f[k>>2]=f[L+4>>2];f[C>>2]=I;M=1.0/+n[K+(G*20|0)>>2];Zna(c,j,k,M,M,5);K=f[(f[a>>2]|0)+44>>2]|0;f[D>>2]=0;f[E>>2]=0;f[j>>2]=17432576;f[F>>2]=g;Ti[K&511](a,G,j);EQ(g);G=G+1|0}while(G>>>0<i>>>0);if((J|0)==21)lWc(H);f[a+4>>2]=2;r=1;u=e;return r|0}do if((eS(c)|0)==65536){H=f[c+4>>2]|0;f[j>>2]=f[H>>2];G=j+4|0;F=H+4|0;f[G>>2]=f[F>>2];E=j+8|0;f[E>>2]=f[H+8>>2];f[j+12>>2]=f[H+12>>2];f[j+16>>2]=f[H+16>>2];f[j+20>>2]=f[H+20>>2];f[j+24>>2]=f[H+24>>2];f[j+28>>2]=f[H+28>>2];f[j+32>>2]=f[H+32>>2];D=f[H+36>>2]|0;f[j+36>>2]=D;f[j+40>>2]=E;E=j+48|0;k=j+44|0;f[k>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(D|0){E=D+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[F>>2]|0)<3){F=f[H+44>>2]|0;E=f[k>>2]|0;f[E>>2]=f[F>>2];f[E+4>>2]=f[F+4>>2];break}else{f[G>>2]=0;U$(j,H);break}}else bS(j,c,-1);while(0);c=a+44|0;H=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;G=f[a+16>>2]|0;if(!(((((f[a+48>>2]|0)<3?(f[a+52>>2]|0)==(H|0):0)?(f[a+56>>2]|0)==(G|0):0)?(f[c>>2]&4095|0)==4:0)?(f[a+60>>2]|0)!=0:0)){f[g>>2]=H;f[g+4>>2]=G;S$(c,2,g,4)}if(!(((((f[a+104>>2]|0)<3?(f[q>>2]|0)==(x|0):0)?(f[t>>2]|0)==(w|0):0)?(f[s>>2]&4095|0)==0:0)?(f[a+116>>2]|0)!=0:0)){f[g>>2]=x;f[g+4>>2]=w;S$(s,2,g,0)}s=a+116|0;w=l+4|0;x=l+8|0;t=l+12|0;q=l+16|0;c=l+20|0;G=l+24|0;H=l+40|0;F=l+48|0;E=l+44|0;k=l+52|0;D=l+28|0;C=g+8|0;B=g+12|0;A=g+4|0;z=m+8|0;h=m+4|0;y=o+4|0;v=g+8|0;p=g+12|0;K=g+4|0;I=l+36|0;L=0;while(1){N=f[d>>2]|0;O=f[N>>2]|0;if((((f[N+4>>2]|0)-O|0)/20|0)>>>0<=L>>>0){J=45;break}P=O;O=(f[P+(L*20|0)+8>>2]|0)+-1|0;Q=f[P+(L*20|0)+4>>2]|0;R=Q+-1|0;S=f[s>>2]|0;f[l>>2]=1124007936;f[w>>2]=2;f[x>>2]=O;f[t>>2]=R;f[q>>2]=S;f[c>>2]=S;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[H>>2]=x;f[E>>2]=F;f[k>>2]=0;f[F>>2]=0;T=Y(R,O)|0;if((S|0)==0&(T|0)!=0){J=47;break}f[F>>2]=R;f[k>>2]=1;O=S+T|0;f[D>>2]=O;f[G>>2]=O+(1-Q)+R;R$(l);f[C>>2]=0;f[B>>2]=0;f[g>>2]=16842752;f[A>>2]=j;R=z;f[R>>2]=0;f[R+4>>2]=0;f[m>>2]=33619968;f[h>>2]=l;R=f[H>>2]|0;Q=f[R>>2]|0;f[o>>2]=f[R+4>>2];f[y>>2]=Q;M=1.0/+n[P+(L*20|0)>>2];Zna(g,m,o,M,M,5);P=f[(f[a>>2]|0)+44>>2]|0;f[v>>2]=0;f[p>>2]=0;f[g>>2]=16842752;f[K>>2]=l;Ti[P&511](a,L,g);P=f[I>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)V$(l);f[I>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[w>>2]|0)>0){P=f[H>>2]|0;Q=0;do{f[P+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[w>>2]|0))}Q=f[E>>2]|0;if((Q|0)!=(F|0))wL(Q);L=L+1|0;if(L>>>0>=i>>>0){J=57;break}}if((J|0)==45)lWc(N);else if((J|0)==47){N=$Xc(32)|0;f[g>>2]=N;f[g+8>>2]=-2147483616;f[g+4>>2]=28;i=N;L=470314;F=i+28|0;do{b[i>>0]=b[L>>0]|0;i=i+1|0;L=L+1|0}while((i|0)<(F|0));b[N+28>>0]=0;vM(-215,g,470343,470347,548)}else if((J|0)==57){f[a+4>>2]=1;a=j+36|0;J=f[a>>2]|0;if(J|0?(g=J+12|0,J=f[g>>2]|0,f[g>>2]=J+-1,(J|0)==1):0)V$(j);f[a>>2]=0;a=j+16|0;J=j+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[J>>2]|0)>0){a=f[j+40>>2]|0;g=0;do{f[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[J>>2]|0))}J=f[j+44>>2]|0;if((J|0)!=(j+48|0))wL(J);r=1;u=e;return r|0}return 0}function zSb(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function ASb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+4|0;if(!(f[e>>2]&2)){g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=34209792;f[d+4>>2]=a+204;jR(a+44|0,d);f[e>>2]=f[e>>2]|2}e=f[b>>2]|0;d=b+4|0;g=f[d>>2]|0;if((g|0)!=(e|0)){h=g;do{g=h+-48|0;f[d>>2]=g;EQ(g);h=f[d>>2]|0}while((h|0)!=(e|0))}h=a+300|0;g=b+8|0;if((e|0)==(f[g>>2]|0)){GSb(b,h);i=f[d>>2]|0}else{f[e>>2]=f[h>>2];j=e+4|0;k=a+304|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[a+308>>2];f[e+12>>2]=f[a+312>>2];f[e+16>>2]=f[a+316>>2];f[e+20>>2]=f[a+320>>2];m=f[a+324>>2]|0;f[e+24>>2]=m;f[e+28>>2]=f[a+328>>2];f[e+32>>2]=l;l=e+40|0;n=e+36|0;f[n>>2]=l;f[e+44>>2]=0;f[l>>2]=0;if(m|0){l=m+8|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+336>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;DQ(e,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;i=h}h=a+204|0;if((i|0)==(f[g>>2]|0)){GSb(b,h);o=f[d>>2]|0}else{f[i>>2]=f[h>>2];e=i+4|0;j=a+208|0;f[e>>2]=f[j>>2];k=i+8|0;f[k>>2]=f[a+212>>2];f[i+12>>2]=f[a+216>>2];f[i+16>>2]=f[a+220>>2];f[i+20>>2]=f[a+224>>2];l=f[a+228>>2]|0;f[i+24>>2]=l;f[i+28>>2]=f[a+232>>2];f[i+32>>2]=k;k=i+40|0;n=i+36|0;f[n>>2]=k;f[i+44>>2]=0;f[k>>2]=0;if(l|0){k=l+8|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[a+240>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[e>>2]=0;DQ(i,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;o=h}h=a+252|0;if((o|0)==(f[g>>2]|0)){GSb(b,h);u=c;return}f[o>>2]=f[h>>2];b=o+4|0;g=a+256|0;f[b>>2]=f[g>>2];i=o+8|0;f[i>>2]=f[a+260>>2];f[o+12>>2]=f[a+264>>2];f[o+16>>2]=f[a+268>>2];f[o+20>>2]=f[a+272>>2];e=f[a+276>>2]|0;f[o+24>>2]=e;f[o+28>>2]=f[a+280>>2];f[o+32>>2]=i;i=o+40|0;j=o+36|0;f[j>>2]=i;f[o+44>>2]=0;f[i>>2]=0;if(e|0){i=e+8|0;f[i>>2]=(f[i>>2]|0)+1}if((f[g>>2]|0)<3){g=f[a+288>>2]|0;a=f[j>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2]}else{f[b>>2]=0;DQ(o,h)}f[d>>2]=(f[d>>2]|0)+48;u=c;return}function BSb(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;d=a+4|0;if(f[d>>2]&1|0){u=b;return}e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=33619968;f[c+4>>2]=a+44;LQ(a+204|0,c);f[d>>2]=f[d>>2]|1;u=b;return}function CSb(a,b){a=a|0;b=b|0;return 0.0}function DSb(a,b){a=a|0;b=b|0;return 0}function ESb(a,b,c){a=a|0;b=b|0;c=c|0;return}function FSb(a){a=a|0;return}function GSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/48|0;g=e+1|0;if(g>>>0>89478485)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/48|0;d=i<<1;j=i>>>0<44739242?(d>>>0<g>>>0?g:d):89478485;do if(j)if(j>>>0>89478485){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*48|0)|0;break}else k=0;while(0);d=k+(e*48|0)|0;g=d;i=k+(j*48|0)|0;f[d>>2]=f[b>>2];j=k+(e*48|0)+4|0;l=b+4|0;m=f[l>>2]|0;f[j>>2]=m;n=k+(e*48|0)+8|0;f[n>>2]=f[b+8>>2];f[k+(e*48|0)+12>>2]=f[b+12>>2];f[k+(e*48|0)+16>>2]=f[b+16>>2];f[k+(e*48|0)+20>>2]=f[b+20>>2];o=f[b+24>>2]|0;f[k+(e*48|0)+24>>2]=o;f[k+(e*48|0)+28>>2]=f[b+28>>2];f[k+(e*48|0)+32>>2]=n;n=k+(e*48|0)+40|0;p=k+(e*48|0)+36|0;f[p>>2]=n;f[k+(e*48|0)+44>>2]=0;f[n>>2]=0;if(!o)q=m;else{m=o+8|0;f[m>>2]=(f[m>>2]|0)+1;q=f[l>>2]|0}if((q|0)<3){q=f[b+36>>2]|0;l=f[p>>2]|0;f[l>>2]=f[q>>2];f[l+4>>2]=f[q+4>>2]}else{f[j>>2]=0;DQ(d,b)}b=d+48|0;j=f[a>>2]|0;q=f[c>>2]|0;if((q|0)==(j|0)){r=g;s=j;t=j}else{l=q;q=g;g=d;do{d=g+-48|0;p=l;l=l+-48|0;f[d>>2]=f[l>>2];m=g+-44|0;o=p+-44|0;f[m>>2]=f[o>>2];n=g+-40|0;f[n>>2]=f[p+-40>>2];f[g+-36>>2]=f[p+-36>>2];f[g+-32>>2]=f[p+-32>>2];f[g+-28>>2]=f[p+-28>>2];e=f[p+-24>>2]|0;f[g+-24>>2]=e;f[g+-20>>2]=f[p+-20>>2];f[g+-16>>2]=n;n=g+-8|0;k=g+-12|0;f[k>>2]=n;f[g+-4>>2]=0;f[n>>2]=0;if(e|0){n=e+8|0;f[n>>2]=(f[n>>2]|0)+1}if((f[o>>2]|0)<3){o=f[p+-12>>2]|0;p=f[k>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2]}else{f[m>>2]=0;DQ(d,l)}g=q+-48|0;q=g}while((l|0)!=(j|0));r=q;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=b;f[h>>2]=i;i=s;if((t|0)!=(i|0)){h=t;do{h=h+-48|0;EQ(h)}while((h|0)!=(i|0))}if(!s)return;cYc(s);return}function HSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;d=a+348|0;e=f[d>>2]|0;if(!e){g=$Xc(24)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=141128;h=g+12|0;f[h>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;TXc(g);f[d>>2]=h;h=a+352|0;i=f[h>>2]|0;f[h>>2]=g;if(i|0)UXc(i);UXc(g);j=f[d>>2]|0}else j=e;e=f[c>>2]|0;g=(f[c+4>>2]|0)-e>>2;i=j+4|0;h=f[i>>2]|0;k=f[j>>2]|0;l=(h-k|0)/20|0;m=k;k=h;h=e;if(g>>>0<=l>>>0)if(g>>>0<l>>>0?(e=m+(g*20|0)|0,(k|0)!=(e|0)):0){f[i>>2]=k+(~(((k+-20-e|0)>>>0)/20|0)*20|0);o=h}else o=h;else{JSb(j,g-l|0);o=f[c>>2]|0}j=a+16|0;h=f[j>>2]|0;e=a+20|0;a=f[e>>2]|0;k=(ALc(+(f[b>>2]|0)/+n[o>>2])|0)+62&-32;o=(h|0)<(k|0);f[j>>2]=o?k:h;h=(g|0)!=(l|0)|o;if(!g){p=h;q=0;r=0;s=a;t=q+r|0;u=(s|0)<(t|0);v=u?t:s;f[e>>2]=v;w=(v|0)!=(a|0);x=p|w;return x|0}o=f[d>>2]|0;d=f[o>>2]|0;l=((f[o+4>>2]|0)-d|0)/20|0;k=d;d=f[c>>2]|0;c=b+4|0;i=h;h=0;m=0;y=0;z=0;while(1){if(l>>>0<=m>>>0){A=13;break}B=k+(m*20|0)|0;if(!i){C=+n[d+(m<<2)>>2];if(+L(+(+n[B>>2]-C))>C*1.1920928955078125e-05){D=1;E=B;F=C}else{D=0;E=B;F=C}}else{D=1;E=B;F=+n[d+(m<<2)>>2]}B=ALc(+(f[b>>2]|0)/F)|0;G=ALc(+(f[c>>2]|0)/F)|0;f[k+(m*20|0)+16>>2]=F>=2.0?1:2;n[E>>2]=F;H=B+1|0;B=G+1|0;f[k+(m*20|0)+4>>2]=H;f[k+(m*20|0)+8>>2]=B;G=(m|0)==0?B:h;I=f[j>>2]|0;J=(H+y|0)>(I|0);K=J?0:y;z=(J?G:0)+z|0;h=J?B:G;G=(Y(z,I)|0)+K|0;f[k+(m*20|0)+12>>2]=G;m=m+1|0;if(m>>>0>=g>>>0)break;else{i=D;y=K+H|0}}if((A|0)==13)lWc(o);p=D;q=h;r=z;s=f[e>>2]|0;t=q+r|0;u=(s|0)<(t|0);v=u?t:s;f[e>>2]=v;w=(v|0)!=(a|0);x=p|w;return x|0}function ISb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)FQ(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[a>>2]|0;p=f[i>>2]|0}else{o=h;p=j}j=p-o|0;p=o;f[g>>2]=1124007936;h=g+4|0;f[h>>2]=2;i=g+8|0;f[i>>2]=1;f[g+12>>2]=j;a=g+16|0;f[a>>2]=p;f[g+20>>2]=p;k=g+24|0;l=g+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[l>>2]=i;i=g+48|0;n=g+44|0;f[n>>2]=i;m=g+52|0;f[m>>2]=0;f[i>>2]=0;if((o|0)==0&(j|0)!=0){o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=28;q=o;r=470314;s=q+28|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[o+28>>0]=0;vM(-215,e,470343,470347,548)}f[i>>2]=j;f[m>>2]=1;m=p+j|0;f[g+28>>2]=m;f[k>>2]=m+(0-j)+j;R$(g);j=e+8|0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;jR(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(j=c+12|0,c=f[j>>2]|0,f[j>>2]=c+-1,(c|0)==1):0)V$(g);f[e>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[l>>2]|0;l=0;do{f[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[n>>2]|0;if((h|0)==(i|0)){u=d;return}wL(h);u=d;return}function JSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)kWc(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=h;g=k+(d*20|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{j=b;b=i;i=h;do{h=j;j=j+-20|0;f[i+-20>>2]=f[j>>2];f[i+-16>>2]=f[h+-16>>2];f[i+-12>>2]=f[h+-12>>2];n=h+-8|0;h=f[n+4>>2]|0;o=i+-8|0;f[o>>2]=f[n>>2];f[o+4>>2]=h;i=b+-20|0;b=i}while((j|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function KSb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141128;b=f[a+12>>2]|0;if(!b){NXc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~(((d+-20-b|0)>>>0)/20|0)*20|0);cYc(b);NXc(a);return}function LSb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141128;b=f[a+12>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~(((d+-20-b|0)>>>0)/20|0)*20|0);cYc(b);NXc(a);cYc(a);return}function MSb(a){a=a|0;var b=0,c=0;b=f[a+12>>2]|0;if(!b)return;c=a+16|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~(((a+-20-b|0)>>>0)/20|0)*20|0);cYc(b);return}function NSb(a){a=a|0;cYc(a);return}function OSb(a){a=a|0;var b=0;f[a>>2]=141156;b=f[a+376>>2]|0;if(b|0)UXc(b);b=f[a+368>>2]|0;if(b|0)UXc(b);b=f[a+360>>2]|0;if(!b){tSb(a);return}UXc(b);tSb(a);return}function PSb(a){a=a|0;var b=0;f[a>>2]=141156;b=f[a+376>>2]|0;if(b|0)UXc(b);b=f[a+368>>2]|0;if(b|0)UXc(b);b=f[a+360>>2]|0;if(!b){tSb(a);cYc(a);return}UXc(b);tSb(a);cYc(a);return}function QSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+48|0;g=e+16|0;h=e;i=f[d+4>>2]|0;j=a+8|0;f[j>>2]=f[d>>2];d=a+12|0;f[d>>2]=i;i=a+24|0;k=a+348|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;l=f[k>>2]|0;if(l){m=f[l>>2]|0;n=l+4|0;l=f[n>>2]|0;if((l|0)!=(m|0))f[n>>2]=l+(~(((l+-20-m|0)>>>0)/20|0)*20|0)}else{m=$Xc(24)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=141128;l=m+12|0;f[l>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;TXc(m);f[k>>2]=l;l=a+352|0;k=f[l>>2]|0;f[l>>2]=m;if(k|0)UXc(k);UXc(m)}m=w5(c)|0;if(!m){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=5;b[g>>0]=b[468382]|0;b[g+1>>0]=b[468383]|0;b[g+2>>0]=b[468384]|0;b[g+3>>0]=b[468385]|0;b[g+4>>0]=b[468386]|0;b[g+5>>0]=0;vM(-215,g,473221,468086,584)}k=a+356|0;if(!(f[k>>2]|0)){l=$Xc(24)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=141244;n=l+12|0;f[n>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;TXc(l);f[k>>2]=n;n=a+360|0;o=f[n>>2]|0;f[n>>2]=l;if(o|0)UXc(o);UXc(l)}l=a+364|0;if(!(f[l>>2]|0)){o=$Xc(24)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=141272;n=o+12|0;f[n>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;TXc(o);f[l>>2]=n;n=a+368|0;l=f[n>>2]|0;f[n>>2]=o;if(l|0)UXc(l);UXc(o)}o=a+372|0;if(!(f[o>>2]|0)){l=$Xc(24)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=141272;n=l+12|0;f[n>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;TXc(l);f[o>>2]=n;n=a+376|0;o=f[n>>2]|0;f[n>>2]=l;if(o|0)UXc(o);UXc(l)}l=f[k>>2]|0;o=l+4|0;n=f[o>>2]|0;p=f[l>>2]|0;q=n-p>>6;r=p;p=n;if(m>>>0<=q>>>0){if(m>>>0<q>>>0?(n=r+(m<<6)|0,(p|0)!=(n|0)):0)f[o>>2]=p+(~((p+-64-n|0)>>>6)<<6)}else fTb(l,m-q|0);d5(g,c);c=a+380|0;b[c>>0]=0;q=f[k>>2]|0;f[a+16>>2]=0;f[a+20>>2]=0;k=a+252|0;l=a+276|0;n=f[l>>2]|0;if(n|0?(p=n+8|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)FQ(k);k=a+256|0;if((f[k>>2]|0)>0){n=f[a+284>>2]|0;p=0;do{f[n+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[k>>2]|0))}f[l>>2]=0;l=0;do{k=(f[q>>2]|0)+(l<<6)|0;g5(h,g);gTb(k,h)|0;if(b[(f[q>>2]|0)+(l<<6)>>0]|0)b[c>>0]=1;l=l+1|0;x5(g)|0}while((l|0)!=(m|0));f[a+40>>2]=b[c>>0]|0?3:2;c=(f[j>>2]|0)+-2|0;j=(f[d>>2]|0)+-2|0;f[a+408>>2]=1;f[a+412>>2]=1;f[a+416>>2]=c;f[a+420>>2]=j;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;u=e;return 1}function RSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=$Xc(448)|0;f[d+4>>2]=0;f[d+8>>2]=0;f[d>>2]=141216;e=d+12|0;g=d+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[d+56>>2]=1124007936;g=d+64|0;h=d+96|0;i=d+60|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=d+104|0;f[d+100>>2]=g;f[g>>2]=0;f[d+108>>2]=0;f[d+112>>2]=1124007936;g=d+120|0;h=d+152|0;i=d+116|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=d+160|0;f[d+156>>2]=g;f[g>>2]=0;f[d+164>>2]=0;f[d+168>>2]=1124007936;g=d+172|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[d+200>>2]=d+176;g=d+208|0;f[d+204>>2]=g;f[d+212>>2]=0;f[g>>2]=0;f[d+216>>2]=1124007936;g=d+220|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[d+248>>2]=d+224;g=d+256|0;f[d+252>>2]=g;f[d+260>>2]=0;f[g>>2]=0;f[d+264>>2]=1124007936;g=d+268|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[d+296>>2]=d+272;g=d+304|0;f[d+300>>2]=g;f[d+308>>2]=0;f[g>>2]=0;f[d+312>>2]=1124007936;g=d+316|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[d+344>>2]=d+320;g=d+352|0;f[d+348>>2]=g;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[e>>2]=141156;g=d+368|0;h=d+36|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;i=d+404|0;j=i+40|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=4;f[d+40>>2]=2;f[d+44>>2]=0;f[d+48>>2]=0;f[d+52>>2]=0;f[d+396>>2]=0;f[d+400>>2]=0;n[d+444>>2]=0.0;b[d+392>>0]=0;$Sb(e,c)|0;f[a>>2]=e;f[a+4>>2]=d;return}function SSb(a){a=a|0;return 0}function TSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0;e=u;u=u+16|0;g=e;if((d|0)<=-1){h=$Xc(64)|0;f[g>>2]=h;i=g+8|0;f[i>>2]=-2147483584;j=g+4|0;f[j>>2]=50;k=h;l=468166;m=k+50|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));o=h+50|0;b[o>>0]=0;vM(-215,g,468217,468230,46)}p=f[a+348>>2]|0;q=f[p>>2]|0;r=((f[p+4>>2]|0)-q|0)/20|0;if((r|0)<=(d|0)){h=$Xc(64)|0;f[g>>2]=h;i=g+8|0;f[i>>2]=-2147483584;j=g+4|0;f[j>>2]=50;k=h;l=468166;m=k+50|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));o=h+50|0;b[o>>0]=0;vM(-215,g,468217,468230,46)}if(r>>>0<=d>>>0)lWc(p);p=q;q=f[c>>2]|0;if((q|0)<0){s=0;u=e;return s|0}r=f[c+4>>2]|0;if((r|0)<0){s=0;u=e;return s|0}if(((f[a+8>>2]|0)+q|0)>=(f[p+(d*20|0)+4>>2]|0)){s=0;u=e;return s|0}if(((f[a+12>>2]|0)+r|0)>=(f[p+(d*20|0)+8>>2]|0)){s=0;u=e;return s|0}c=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,r)|0)+(q<<2)|0;q=c+(f[p+(d*20|0)+12>>2]<<2)|0;f[a+424>>2]=q;d=q+(f[a+388>>2]<<2)|0;p=f[a+392>>2]|0;c=f[a+396>>2]|0;r=f[a+400>>2]|0;g=f[a+404>>2]|0;t=+(Y(f[a+420>>2]|0,f[a+416>>2]|0)|0);v=+((f[q+(p<<2)>>2]|0)-(f[q+(c<<2)>>2]|0)-(f[q+(r<<2)>>2]|0)+(f[q+(g<<2)>>2]|0)|0);w=+(((f[d+(p<<2)>>2]|0)-(f[d+(c<<2)>>2]|0)-(f[d+(r<<2)>>2]|0)+(f[d+(g<<2)>>2]|0)|0)>>>0)*t-v*v;if(w>0.0){v=1.0/+M(+w);n[a+432>>2]=v;s=t*v<.1;u=e;return s|0}else{n[a+432>>2]=1.0;s=0;u=e;return s|0}return 0}function USb(a,b){a=a|0;b=b|0;return +(+_Sb(a,b))}function VSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+240|0;g=e+184|0;i=e+128|0;j=e+72|0;k=e+56|0;l=e+24|0;m=e;n=e+48|0;o=e+40|0;p=e+16|0;q=f[a+348>>2]|0;r=f[q>>2]|0;if((((f[q+4>>2]|0)-r|0)/20|0)>>>0<=c>>>0)lWc(q);q=r;r=a+380|0;s=a+16|0;t=(Y(f[a+20>>2]|0,f[s>>2]|0)|0)<<h[r>>0];v=a+388|0;f[v>>2]=t;if((eS(d)|0)==655360){t=f[q+(c*20|0)+12>>2]|0;w=f[s>>2]|0;x=(t|0)%(w|0)|0;y=(t|0)/(w|0)|0;t=((f[v>>2]|0)/(w|0)|0)+y|0;w=a+204|0;z=q+(c*20|0)+4|0;A=f[z>>2]|0;B=q+(c*20|0)+8|0;C=f[B>>2]|0;f[i>>2]=x;f[i+4>>2]=y;f[i+8>>2]=A;f[i+12>>2]=C;AQ(g,w,i);C=f[z>>2]|0;A=f[B>>2]|0;f[j>>2]=x;f[j+4>>2]=t;f[j+8>>2]=C;f[j+12>>2]=A;AQ(i,w,j);f[i>>2]=f[i>>2]&-8|4;if(!(b[r>>0]|0)){A=i+24|0;C=f[A>>2]|0;t=j+8|0;f[t>>2]=0;f[t+4>>2]=0;f[j>>2]=34209792;f[j+4>>2]=g;t=k+8|0;f[t>>2]=0;f[t+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=i;Oja(d,j,k,fT()|0,4,4);if((f[A>>2]|0)!=(C|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;D=$Xc(64)|0;f[j>>2]=D;E=j+8|0;f[E>>2]=-2147483584;F=j+4|0;f[F>>2]=61;G=D;H=468008;I=G+61|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));J=D+61|0;b[J>>0]=0;vM(-215,j,468070,468086,658)}C=f[i+32>>2]|0;if(!((f[C>>2]|0)==(f[B>>2]|0)?(f[C+4>>2]|0)==(f[z>>2]|0):0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;D=$Xc(64)|0;f[j>>2]=D;E=j+8|0;f[E>>2]=-2147483584;F=j+4|0;f[F>>2]=61;G=D;H=468008;I=G+61|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));J=D+61|0;b[J>>0]=0;vM(-215,j,468070,468086,658)}if((f[i>>2]&4095|0)!=4){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;D=$Xc(64)|0;f[j>>2]=D;E=j+8|0;f[E>>2]=-2147483584;F=j+4|0;f[F>>2]=61;G=D;H=468008;I=G+61|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));J=D+61|0;b[J>>0]=0;vM(-215,j,468070,468086,658)}}else{J=((f[a+384>>2]|0)/(f[s>>2]|0)|0)+y|0;y=f[z>>2]|0;z=f[B>>2]|0;f[k>>2]=x;f[k+4>>2]=J;f[k+8>>2]=y;f[k+12>>2]=z;AQ(j,w,k);w=k+8|0;f[w>>2]=0;f[w+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=g;w=l+8|0;f[w>>2]=0;f[w+4>>2]=0;f[l>>2]=34209792;f[l+4>>2]=i;w=m+8|0;f[w>>2]=0;f[w+4>>2]=0;f[m>>2]=34209792;f[m+4>>2]=j;Oja(d,k,l,m,4,4);EQ(j)}EQ(i);EQ(g);u=e;return}w=q+(c*20|0)+4|0;f[n>>2]=f[w>>2];z=q+(c*20|0)+8|0;f[n+4>>2]=f[z>>2];y=a+92|0;cM(g,n,4,(f[a+60>>2]|0)+(f[q+(c*20|0)+12>>2]<<2)|0,f[y>>2]|0);f[o>>2]=f[w>>2];f[o+4>>2]=f[z>>2];c=g+16|0;q=g+44|0;cM(i,o,4,(f[c>>2]|0)+(f[v>>2]<<2)|0,f[y>>2]|0);if(b[r>>0]|0){f[p>>2]=f[w>>2];f[p+4>>2]=f[z>>2];cM(j,p,4,(f[c>>2]|0)+(f[a+384>>2]<<2)|0,f[y>>2]|0);y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=g;y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=i;y=m+8|0;f[y>>2]=0;f[y+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;Oja(d,k,l,m,4,4);m=j+36|0;l=f[m>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)V$(j);f[m>>2]=0;m=j+16|0;l=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[j+40>>2]|0;y=0;do{f[m+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))wL(l)}else{l=j+8|0;f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=g;l=k+8|0;f[l>>2]=0;f[l+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;Oja(d,j,k,fT()|0,4,4)}k=i+36|0;j=f[k>>2]|0;if(j|0?(d=j+12|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)V$(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))wL(j);j=g+36|0;i=f[j>>2]|0;if(i|0?(d=i+12|0,i=f[d>>2]|0,f[d>>2]=i+-1,(i|0)==1):0)V$(g);f[j>>2]=0;j=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[j>>2]|0)>0){c=f[g+40>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(g+48|0))wL(j);u=e;return}function WSb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+16>>2]|0;if(b[a+380>>0]|0){d=Y(f[a+20>>2]|0,c)|0;f[a+384>>2]=d}d=f[a+408>>2]|0;e=f[a+412>>2]|0;g=Y(e,c)|0;f[a+392>>2]=g+d;h=(f[a+416>>2]|0)+d|0;f[a+396>>2]=h+g;g=Y((f[a+420>>2]|0)+e|0,c)|0;f[a+400>>2]=g+d;f[a+404>>2]=h+g;g=f[a+356>>2]|0;h=(f[g+4>>2]|0)-(f[g>>2]|0)>>6;d=a+364|0;e=f[d>>2]|0;i=e+4|0;j=f[i>>2]|0;k=f[e>>2]|0;l=j-k>>6;m=k;k=j;if(h>>>0<=l>>>0){if(h>>>0<l>>>0?(j=m+(h<<6)|0,(k|0)!=(j|0)):0)f[i>>2]=k+(~((k+-64-j|0)>>>6)<<6);j=f[e>>2]|0;k=a+428|0;f[k>>2]=j;if(!h)n=1;else{o=j;p=k;q=9}}else{XSb(e,h-l|0);l=f[f[d>>2]>>2]|0;d=a+428|0;f[d>>2]=l;o=l;p=d;q=9}if((q|0)==9){d=a+384|0;YSb(o,f[g>>2]|0,c,f[d>>2]|0);if((h|0)==1)n=0;else{o=1;do{YSb((f[p>>2]|0)+(o<<6)|0,(f[g>>2]|0)+(o<<6)|0,c,f[d>>2]|0);o=o+1|0}while((o|0)!=(h|0));n=0}}o=a+372|0;d=f[o>>2]|0;p=d+4|0;l=f[p>>2]|0;e=f[d>>2]|0;k=l-e>>6;j=e;e=l;if(h>>>0<=k>>>0)if(h>>>0<k>>>0?(l=j+(h<<6)|0,(e|0)!=(l|0)):0){f[p>>2]=e+(~((e+-64-l|0)>>>6)<<6);r=d}else r=d;else{XSb(d,h-k|0);r=f[o>>2]|0}if(n){s=r;t=a+252|0;ZSb(s,t);return}n=a+32|0;k=a+384|0;d=0;l=r;while(1){r=f[l>>2]|0;if((f[l+4>>2]|0)-r>>6>>>0<=d>>>0){q=19;break}e=f[n>>2]|0;YSb(r+(d<<6)|0,(f[g>>2]|0)+(d<<6)|0,(e|0)>0?e:c,f[k>>2]|0);d=d+1|0;e=f[o>>2]|0;if(d>>>0>=h>>>0){s=e;q=21;break}else l=e}if((q|0)==19)lWc(l);else if((q|0)==21){t=a+252|0;ZSb(s,t);return}}function XSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)kWc(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=m+(d<<6)|0;d=b;b=h;m=h;do{j=b;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(0-(b>>6)<<6)|0;if((b|0)>0)o1c(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;cYc(d);return}function YSb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f[a+48>>2]=f[c+20>>2];g=c+24|0;f[a+52>>2]=f[c+40>>2];h=c+44|0;f[a+56>>2]=f[c+60>>2];i=c+4|0;j=f[i>>2]|0;if(!(b[c>>0]|0)){k=c+8|0;l=(Y(f[k>>2]|0,d)|0)+j|0;f[a>>2]=l;l=c+12|0;m=(f[l>>2]|0)+(f[i>>2]|0)+(Y(f[k>>2]|0,d)|0)|0;f[a+4>>2]=m;m=c+16|0;n=(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)+(f[i>>2]|0)|0;f[a+8>>2]=n;n=(f[l>>2]|0)+(f[i>>2]|0)+(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)|0;f[a+12>>2]=n;n=c+28|0;k=(Y(f[n>>2]|0,d)|0)+(f[g>>2]|0)|0;f[a+16>>2]=k;k=c+32|0;m=(f[k>>2]|0)+(f[g>>2]|0)+(Y(f[n>>2]|0,d)|0)|0;f[a+20>>2]=m;m=c+36|0;l=(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)+(f[g>>2]|0)|0;f[a+24>>2]=l;l=(f[k>>2]|0)+(f[g>>2]|0)+(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)|0;f[a+28>>2]=l;l=c+48|0;n=(Y(f[l>>2]|0,d)|0)+(f[h>>2]|0)|0;f[a+32>>2]=n;n=c+52|0;m=(f[n>>2]|0)+(f[h>>2]|0)+(Y(f[l>>2]|0,d)|0)|0;f[a+36>>2]=m;m=c+56|0;k=(Y((f[m>>2]|0)+(f[l>>2]|0)|0,d)|0)+(f[h>>2]|0)|0;f[a+40>>2]=k;o=(f[n>>2]|0)+(f[h>>2]|0)|0;p=f[l>>2]|0;q=f[m>>2]|0;r=q+p|0;s=Y(r,d)|0;t=s+o|0;u=a+44|0;f[u>>2]=t;return}else{m=c+8|0;l=j+e+(Y(f[m>>2]|0,d)|0)|0;f[a>>2]=l;l=c+16|0;j=f[l>>2]|0;n=(f[i>>2]|0)+e-j+(Y((f[m>>2]|0)+j|0,d)|0)|0;f[a+4>>2]=n;n=c+12|0;j=f[n>>2]|0;k=(f[i>>2]|0)+e+j+(Y((f[m>>2]|0)+j|0,d)|0)|0;f[a+8>>2]=k;k=f[n>>2]|0;n=f[l>>2]|0;l=(f[i>>2]|0)+e+k-n+(Y(n+k+(f[m>>2]|0)|0,d)|0)|0;f[a+12>>2]=l;l=c+28|0;m=(f[g>>2]|0)+e+(Y(f[l>>2]|0,d)|0)|0;f[a+16>>2]=m;m=c+36|0;k=f[m>>2]|0;n=(f[g>>2]|0)+e-k+(Y((f[l>>2]|0)+k|0,d)|0)|0;f[a+20>>2]=n;n=c+32|0;k=f[n>>2]|0;i=(f[g>>2]|0)+e+k+(Y((f[l>>2]|0)+k|0,d)|0)|0;f[a+24>>2]=i;i=f[n>>2]|0;n=f[m>>2]|0;m=(f[g>>2]|0)+e+i-n+(Y(n+i+(f[l>>2]|0)|0,d)|0)|0;f[a+28>>2]=m;m=c+48|0;l=(f[h>>2]|0)+e+(Y(f[m>>2]|0,d)|0)|0;f[a+32>>2]=l;l=c+56|0;i=f[l>>2]|0;n=(f[h>>2]|0)+e-i+(Y((f[m>>2]|0)+i|0,d)|0)|0;f[a+36>>2]=n;n=c+52|0;c=f[n>>2]|0;i=(f[h>>2]|0)+e+c+(Y((f[m>>2]|0)+c|0,d)|0)|0;f[a+40>>2]=i;i=f[n>>2]|0;n=f[l>>2]|0;o=(f[h>>2]|0)+e+i-n|0;p=(f[m>>2]|0)+i|0;q=n;r=q+p|0;s=Y(r,d)|0;t=s+o|0;u=a+44|0;f[u>>2]=t;return}}function ZSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)FQ(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[a>>2]|0;p=f[i>>2]|0}else{o=h;p=j}j=p-o|0;p=o;f[g>>2]=1124007936;h=g+4|0;f[h>>2]=2;i=g+8|0;f[i>>2]=1;f[g+12>>2]=j;a=g+16|0;f[a>>2]=p;f[g+20>>2]=p;k=g+24|0;l=g+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[l>>2]=i;i=g+48|0;n=g+44|0;f[n>>2]=i;m=g+52|0;f[m>>2]=0;f[i>>2]=0;if((o|0)==0&(j|0)!=0){o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=28;q=o;r=470314;s=q+28|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[o+28>>0]=0;vM(-215,e,470343,470347,548)}f[i>>2]=j;f[m>>2]=1;m=p+j|0;f[g+28>>2]=m;f[k>>2]=m+(0-j)+j;R$(g);j=e+8|0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;jR(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(j=c+12|0,c=f[j>>2]|0,f[j>>2]=c+-1,(c|0)==1):0)V$(g);f[e>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[l>>2]|0;l=0;do{f[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[n>>2]|0;if((h|0)==(i|0)){u=d;return}wL(h);u=d;return}function _Sb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,g=0.0,h=0.0,i=0,j=0.0,k=0.0;c=f[a+428>>2]|0;d=f[a+424>>2]|0;e=+n[c+(b<<6)+48>>2]*+((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)|0)+ +n[c+(b<<6)+52>>2]*+((f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0)|0);g=+n[c+(b<<6)+56>>2];if(!(g!=0.0)){h=e;i=a+432|0;j=+n[i>>2];k=h*j;return +k}h=e+g*+((f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0)|0);i=a+432|0;j=+n[i>>2];k=h*j;return +k}function $Sb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;aTb(a,b)|0;c=f[b+356>>2]|0;d=f[b+360>>2]|0;if(d|0)TXc(d);f[a+356>>2]=c;c=a+360|0;e=f[c>>2]|0;f[c>>2]=d;if(e|0)UXc(e);e=f[b+364>>2]|0;d=f[b+368>>2]|0;if(d|0)TXc(d);f[a+364>>2]=e;e=a+368|0;c=f[e>>2]|0;f[e>>2]=d;if(c|0)UXc(c);c=f[b+372>>2]|0;d=f[b+376>>2]|0;if(d|0)TXc(d);f[a+372>>2]=c;c=a+376|0;e=f[c>>2]|0;f[c>>2]=d;if(e|0)UXc(e);e=a+380|0;d=b+380|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];f[e+8>>2]=f[d+8>>2];f[e+12>>2]=f[d+12>>2];f[e+16>>2]=f[d+16>>2];f[e+20>>2]=f[d+20>>2];f[e+24>>2]=f[d+24>>2];f[a+408>>2]=f[b+408>>2];f[a+412>>2]=f[b+412>>2];f[a+416>>2]=f[b+416>>2];f[a+420>>2]=f[b+420>>2];d=a+424|0;e=b+424|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];return a|0}function aTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];c=a+44|0;d=b+44|0;e=(a|0)==(b|0);do if(!e){g=b+80|0;h=f[g>>2]|0;if(h|0){i=h+12|0;f[i>>2]=(f[i>>2]|0)+1}i=a+80|0;h=f[i>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)V$(c);f[i>>2]=0;h=a+60|0;j=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){k=f[a+84>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[j>>2]|0}while((l|0)<(m|0));f[c>>2]=f[d>>2];if((m|0)<3)n=12;else n=14}else{f[c>>2]=f[d>>2];n=12}if((n|0)==12){l=f[b+48>>2]|0;if((l|0)<3){f[j>>2]=l;f[a+52>>2]=f[b+52>>2];f[a+56>>2]=f[b+56>>2];l=f[b+88>>2]|0;k=f[a+88>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=14}if((n|0)==14)U$(c,d);f[h>>2]=f[b+60>>2];f[a+64>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[i>>2]=f[g>>2];l=a+100|0;k=b+100|0;if(!e){o=b+136|0;p=f[o>>2]|0;if(p|0){q=p+12|0;f[q>>2]=(f[q>>2]|0)+1}q=a+136|0;p=f[q>>2]|0;if(p|0?(r=p+12|0,p=f[r>>2]|0,f[r>>2]=p+-1,(p|0)==1):0)V$(l);f[q>>2]=0;p=a+116|0;r=a+104|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[r>>2]|0)>0){s=f[a+140>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0;u=f[r>>2]|0}while((t|0)<(u|0));f[l>>2]=f[k>>2];if((u|0)<3)n=26;else n=28}else{f[l>>2]=f[k>>2];n=26}if((n|0)==26){t=f[b+104>>2]|0;if((t|0)<3){f[r>>2]=t;f[a+108>>2]=f[b+108>>2];f[a+112>>2]=f[b+112>>2];t=f[b+144>>2]|0;s=f[a+144>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else n=28}if((n|0)==28)U$(l,k);f[p>>2]=f[b+116>>2];f[a+120>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[q>>2]=f[o>>2];t=a+156|0;s=b+156|0;if(!e){g=b+180|0;i=f[g>>2]|0;if(i|0){h=i+8|0;f[h>>2]=(f[h>>2]|0)+1}h=a+180|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)FQ(t);i=a+160|0;if((f[i>>2]|0)>0){j=f[a+188>>2]|0;v=0;do{f[j+(v<<2)>>2]=0;v=v+1|0;w=f[i>>2]|0}while((v|0)<(w|0));f[h>>2]=0;f[t>>2]=f[s>>2];if((w|0)<3)n=40;else n=42}else{f[h>>2]=0;f[t>>2]=f[s>>2];n=40}if((n|0)==40){v=f[b+160>>2]|0;if((v|0)<3){f[i>>2]=v;f[a+164>>2]=f[b+164>>2];f[a+168>>2]=f[b+168>>2];v=f[b+192>>2]|0;j=f[a+192>>2]|0;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2]}else n=42}if((n|0)==42)DQ(t,s);f[a+172>>2]=f[b+172>>2];v=a+176|0;if(!(f[v>>2]|0))f[v>>2]=f[b+176>>2];f[h>>2]=f[g>>2];f[a+184>>2]=f[b+184>>2];v=a+204|0;j=b+204|0;if(!e){o=b+228|0;q=f[o>>2]|0;if(q|0){p=q+8|0;f[p>>2]=(f[p>>2]|0)+1}p=a+228|0;q=f[p>>2]|0;if(q|0?(k=q+8|0,q=f[k>>2]|0,f[k>>2]=q+-1,(q|0)==1):0)FQ(v);q=a+208|0;if((f[q>>2]|0)>0){k=f[a+236>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;x=f[q>>2]|0}while((l|0)<(x|0));f[p>>2]=0;f[v>>2]=f[j>>2];if((x|0)<3)n=56;else n=58}else{f[p>>2]=0;f[v>>2]=f[j>>2];n=56}if((n|0)==56){l=f[b+208>>2]|0;if((l|0)<3){f[q>>2]=l;f[a+212>>2]=f[b+212>>2];f[a+216>>2]=f[b+216>>2];l=f[b+240>>2]|0;k=f[a+240>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=58}if((n|0)==58)DQ(v,j);f[a+220>>2]=f[b+220>>2];l=a+224|0;if(!(f[l>>2]|0))f[l>>2]=f[b+224>>2];f[p>>2]=f[o>>2];f[a+232>>2]=f[b+232>>2];l=a+252|0;k=b+252|0;if(!e){g=b+276|0;h=f[g>>2]|0;if(h|0){s=h+8|0;f[s>>2]=(f[s>>2]|0)+1}s=a+276|0;h=f[s>>2]|0;do if(h|0){t=h+8|0;i=f[t>>2]|0;f[t>>2]=i+-1;if((i|0)!=1)break;FQ(l)}while(0);h=a+256|0;if((f[h>>2]|0)>0){o=f[a+284>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0;y=f[h>>2]|0}while((p|0)<(y|0));f[s>>2]=0;f[l>>2]=f[k>>2];if((y|0)<3)n=72;else n=74}else{f[s>>2]=0;f[l>>2]=f[k>>2];n=72}do if((n|0)==72){p=f[b+256>>2]|0;if((p|0)>=3){n=74;break}f[h>>2]=p;f[a+260>>2]=f[b+260>>2];f[a+264>>2]=f[b+264>>2];p=f[b+288>>2]|0;o=f[a+288>>2]|0;f[o>>2]=f[p>>2];f[o+4>>2]=f[p+4>>2]}while(0);if((n|0)==74)DQ(l,k);f[a+268>>2]=f[b+268>>2];h=a+272|0;if(!(f[h>>2]|0))f[h>>2]=f[b+272>>2];f[s>>2]=f[g>>2];f[a+280>>2]=f[b+280>>2];h=a+300|0;p=b+300|0;if(e)break;o=b+324|0;j=f[o>>2]|0;if(j|0){v=j+8|0;f[v>>2]=(f[v>>2]|0)+1}v=a+324|0;j=f[v>>2]|0;do if(j|0){q=j+8|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;FQ(h)}while(0);j=a+304|0;if((f[j>>2]|0)>0){g=f[a+332>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0;z=f[j>>2]|0}while((s|0)<(z|0));f[v>>2]=0;f[h>>2]=f[p>>2];if((z|0)<3)n=88;else n=90}else{f[v>>2]=0;f[h>>2]=f[p>>2];n=88}do if((n|0)==88){s=f[b+304>>2]|0;if((s|0)>=3){n=90;break}f[j>>2]=s;f[a+308>>2]=f[b+308>>2];f[a+312>>2]=f[b+312>>2];s=f[b+336>>2]|0;g=f[a+336>>2]|0;f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2]}while(0);if((n|0)==90)DQ(h,p);f[a+316>>2]=f[b+316>>2];j=a+320|0;if(!(f[j>>2]|0))f[j>>2]=f[b+320>>2];f[v>>2]=f[o>>2];f[a+328>>2]=f[b+328>>2]}}}}}while(0);n=f[b+348>>2]|0;z=f[b+352>>2]|0;if(z|0)TXc(z);f[a+348>>2]=n;n=a+352|0;b=f[n>>2]|0;f[n>>2]=z;if(!b)return a|0;UXc(b);return a|0}function bTb(a){a=a|0;var b=0,c=0;f[a>>2]=141216;b=a+12|0;f[b>>2]=141156;c=f[a+388>>2]|0;if(c|0)UXc(c);c=f[a+380>>2]|0;if(c|0)UXc(c);c=f[a+372>>2]|0;if(!c){tSb(b);NXc(a);return}UXc(c);tSb(b);NXc(a);return}function cTb(a){a=a|0;var b=0,c=0;f[a>>2]=141216;b=a+12|0;f[b>>2]=141156;c=f[a+388>>2]|0;if(c|0)UXc(c);c=f[a+380>>2]|0;if(c|0)UXc(c);c=f[a+372>>2]|0;if(!c){tSb(b);NXc(a);cYc(a);return}UXc(c);tSb(b);NXc(a);cYc(a);return}function dTb(a){a=a|0;var b=0,c=0;b=a+12|0;f[b>>2]=141156;c=f[a+388>>2]|0;if(c|0)UXc(c);c=f[a+380>>2]|0;if(c|0)UXc(c);c=f[a+372>>2]|0;if(!c){tSb(b);return}UXc(c);tSb(b);return}function eTb(a){a=a|0;cYc(a);return}function fTb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>6>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;k=j+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));j=(f[g>>2]|0)+64|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>6;h=j+c|0;if(h>>>0>67108863)kWc(a);m=e-i|0;i=m>>5;e=m>>6>>>0<33554431?(i>>>0<h>>>0?h:i):67108863;do if(e)if(e>>>0>67108863){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{n=$Xc(e<<6)|0;break}else n=0;while(0);i=n+(j<<6)|0;j=i;h=n+(e<<6)|0;e=c;c=j;n=i;do{b[n>>0]=0;k=n+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));n=c+64|0;c=n;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;n=f[g>>2]|0;k=h;if((n|0)==(h|0)){o=j;p=k}else{j=n+-64-k|0;k=n;n=i;while(1){l=k;k=k+-64|0;b[n+-64>>0]=b[k>>0]|0;f[n+-60>>2]=f[l+-60>>2];f[n+-56>>2]=f[l+-56>>2];f[n+-52>>2]=f[l+-52>>2];f[n+-48>>2]=f[l+-48>>2];f[n+-44>>2]=f[l+-44>>2];f[n+-40>>2]=f[l+-40>>2];f[n+-36>>2]=f[l+-36>>2];f[n+-32>>2]=f[l+-32>>2];f[n+-28>>2]=f[l+-28>>2];f[n+-24>>2]=f[l+-24>>2];f[n+-20>>2]=f[l+-20>>2];f[n+-16>>2]=f[l+-16>>2];f[n+-12>>2]=f[l+-12>>2];f[n+-8>>2]=f[l+-8>>2];f[n+-4>>2]=f[l+-4>>2];if((k|0)==(h|0))break;else n=n+-64|0}o=i+(~(j>>>6)<<6)|0;p=f[a>>2]|0}f[a>>2]=o;f[g>>2]=c;f[d>>2]=e;if(!p)return;cYc(p);return}function gTb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+112|0;e=d+96|0;g=d+72|0;h=d+48|0;i=d+24|0;j=d;k=d+84|0;i5(g,c,470910);d5(h,g);f5(i,g);g=a+4|0;l=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(l|0));if(!(e5(h,i)|0)){i5(k,c,470903);m=H5(k)|0;n=(m|0)!=0;o=n&1;b[a>>0]=o;u=d;return 1}g=0;while(1){g5(e,h);d5(j,e);g5(e,j);M5(e,a+4+(g*20|0)|0,0);l=x5(j)|0;g5(e,l);M5(e,a+4+(g*20|0)+4|0,0);p=x5(l)|0;g5(e,p);M5(e,a+4+(g*20|0)+8|0,0);l=x5(p)|0;g5(e,l);M5(e,a+4+(g*20|0)+12|0,0);p=x5(l)|0;g5(e,p);O5(e,a+4+(g*20|0)+16|0,0.0);x5(p)|0;x5(h)|0;if(e5(h,i)|0)g=g+1|0;else break}i5(k,c,470903);m=H5(k)|0;n=(m|0)!=0;o=n&1;b[a>>0]=o;u=d;return 1}function hTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141272;b=f[a+12>>2]|0;if(!b){NXc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-64-b|0)>>>6)<<6);cYc(b);NXc(a);return}function iTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141272;b=f[a+12>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-64-b|0)>>>6)<<6);cYc(b);NXc(a);cYc(a);return}function jTb(a){a=a|0;var b=0,c=0;b=f[a+12>>2]|0;if(!b)return;c=a+16|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-64-b|0)>>>6)<<6);cYc(b);return}function kTb(a){a=a|0;cYc(a);return}function lTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141244;b=f[a+12>>2]|0;if(!b){NXc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-64-b|0)>>>6)<<6);cYc(b);NXc(a);return}function mTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141244;b=f[a+12>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-64-b|0)>>>6)<<6);cYc(b);NXc(a);cYc(a);return}function nTb(a){a=a|0;var b=0,c=0;b=f[a+12>>2]|0;if(!b)return;c=a+16|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-64-b|0)>>>6)<<6);cYc(b);return}function oTb(a){a=a|0;cYc(a);return}function pTb(a){a=a|0;var b=0;f[a>>2]=141300;b=f[a+376>>2]|0;if(b|0)UXc(b);b=f[a+368>>2]|0;if(b|0)UXc(b);b=f[a+360>>2]|0;if(!b){tSb(a);return}UXc(b);tSb(a);return}function qTb(a){a=a|0;var b=0;f[a>>2]=141300;b=f[a+376>>2]|0;if(b|0)UXc(b);b=f[a+368>>2]|0;if(b|0)UXc(b);b=f[a+360>>2]|0;if(!b){tSb(a);cYc(a);return}UXc(b);tSb(a);cYc(a);return}function rTb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+40|0;g=d+16|0;h=d;i=f[c+4>>2]|0;f[a+8>>2]=f[c>>2];f[a+12>>2]=i;i=a+24|0;c=a+348|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;j=f[c>>2]|0;if(j){k=f[j>>2]|0;l=j+4|0;j=f[l>>2]|0;if((j|0)!=(k|0))f[l>>2]=j+(~(((j+-20-k|0)>>>0)/20|0)*20|0)}else{k=$Xc(24)|0;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=141128;j=k+12|0;f[j>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;TXc(k);f[c>>2]=j;j=a+352|0;c=f[j>>2]|0;f[j>>2]=k;if(c|0)UXc(c);UXc(k)}k=a+356|0;if(!(f[k>>2]|0)){c=$Xc(24)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=141388;j=c+12|0;f[j>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;TXc(c);f[k>>2]=j;j=a+360|0;l=f[j>>2]|0;f[j>>2]=c;if(l|0)UXc(l);UXc(c)}c=a+364|0;if(!(f[c>>2]|0)){l=$Xc(24)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=141416;j=l+12|0;f[j>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;TXc(l);f[c>>2]=j;j=a+368|0;c=f[j>>2]|0;f[j>>2]=l;if(c|0)UXc(c);UXc(l)}l=a+372|0;if(!(f[l>>2]|0)){c=$Xc(24)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=141416;j=c+12|0;f[j>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;TXc(c);f[l>>2]=j;j=a+376|0;l=f[j>>2]|0;f[j>>2]=c;if(l|0)UXc(l);UXc(c)}c=f[k>>2]|0;l=w5(b)|0;j=c+4|0;m=f[j>>2]|0;n=f[c>>2]|0;o=m-n>>4;p=n;n=m;if(l>>>0<=o>>>0){if(l>>>0<o>>>0?(m=p+(l<<4)|0,(n|0)!=(m|0)):0)f[j>>2]=n+(~((n+-16-m|0)>>>4)<<4)}else OTb(c,l-o|0);f[a+380>>2]=0;d5(e,b);f5(g,b);b=f[k>>2]|0;if(!(e5(e,g)|0)){q=a+40|0;f[q>>2]=1;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;u=d;return 1}k=0;while(1){o=(f[b>>2]|0)+(k<<4)|0;g5(h,e);PTb(o,h)|0;x5(e)|0;if(e5(e,g)|0)k=k+1|0;else break}q=a+40|0;f[q>>2]=1;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;u=d;return 1}function sTb(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(400)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=141360;d=c+12|0;ATb(d);BTb(d,b)|0;f[a>>2]=d;f[a+4>>2]=c;return}function tTb(a){a=a|0;return 1}function uTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;if((d|0)>-1?(h=f[a+348>>2]|0,i=f[h>>2]|0,j=((f[h+4>>2]|0)-i|0)/20|0,(j|0)>(d|0)):0){if(j>>>0<=d>>>0)lWc(h);h=i;i=f[c>>2]|0;if((i|0)<0){k=0;u=e;return k|0}j=f[c+4>>2]|0;if((j|0)<0){k=0;u=e;return k|0}if(((f[a+8>>2]|0)+i|0)>=(f[h+(d*20|0)+4>>2]|0)){k=0;u=e;return k|0}if(((f[a+12>>2]|0)+j|0)>=(f[h+(d*20|0)+8>>2]|0)){k=0;u=e;return k|0}c=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,j)|0)+(i<<2)|0;f[a+384>>2]=c+(f[h+(d*20|0)+12>>2]<<2);k=1;u=e;return k|0}k=$Xc(64)|0;f[g>>2]=k;f[g+8>>2]=-2147483584;f[g+4>>2]=50;e=k;d=468166;h=e+50|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(h|0));b[k+50>>0]=0;vM(-215,g,468619,468086,867);return 0}function vTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+380>>2]|0;d=f[a+384>>2]|0;a=f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0;e=f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0;g=f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0;h=f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0;i=a-e-g+h|0;j=f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0;k=f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0;l=f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0;m=f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0;n=f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0;o=f[d+(f[c+(b<<6)+56>>2]<<2)>>2]|0;p=f[d+(f[c+(b<<6)+52>>2]<<2)>>2]|0;q=f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0;return ((e-a+j-l|0)>=(i|0)?64:0)|(((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)+a-j-k|0)>=(i|0)?128:0)|((l-e-(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)+m|0)>=(i|0)?32:0)|((e-h-m+n|0)>=(i|0)?16:0)|((h-n-o+(f[d+(f[c+(b<<6)+60>>2]<<2)>>2]|0)|0)>=(i|0)?8:0)|((g-h+o-p|0)>=(i|0)?4:0)|(g-a+k-q|0)>=(i|0)|((p-g+q-(f[d+(f[c+(b<<6)+48>>2]<<2)>>2]|0)|0)>=(i|0)?2:0)|0}function wTb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+80|0;e=d+24|0;g=d+8|0;h=d;i=f[a+348>>2]|0;j=f[i>>2]|0;if((((f[i+4>>2]|0)-j|0)/20|0)>>>0<=b>>>0)lWc(i);i=j;if((eS(c)|0)==655360){j=f[i+(b*20|0)+12>>2]|0;k=f[a+16>>2]|0;l=f[i+(b*20|0)+4>>2]|0;m=f[i+(b*20|0)+8>>2]|0;f[g>>2]=(j|0)%(k|0)|0;f[g+4>>2]=(j|0)/(k|0)|0;f[g+8>>2]=l;f[g+12>>2]=m;AQ(e,a+204|0,g);m=g+8|0;f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=34209792;f[g+4>>2]=e;m=fT()|0;Oja(c,g,m,fT()|0,4,-1);EQ(e);u=d;return}f[h>>2]=f[i+(b*20|0)+4>>2];f[h+4>>2]=f[i+(b*20|0)+8>>2];cM(e,h,4,(f[a+60>>2]|0)+(f[i+(b*20|0)+12>>2]<<2)|0,f[a+92>>2]|0);a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;a=fT()|0;Oja(c,g,a,fT()|0,4,-1);a=e+36|0;g=f[a>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)V$(e);f[a>>2]=0;a=e+16|0;g=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[e+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))wL(g);u=d;return}function xTb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=f[a+16>>2]|0;c=f[a+356>>2]|0;d=(f[c+4>>2]|0)-(f[c>>2]|0)>>4;e=a+364|0;g=f[e>>2]|0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;k=i-j>>6;l=j;j=i;if(d>>>0<=k>>>0){if(d>>>0<k>>>0?(i=l+(d<<6)|0,(j|0)!=(i|0)):0)f[h>>2]=j+(~((j+-64-i|0)>>>6)<<6);i=f[g>>2]|0;f[a+380>>2]=i;if(!d){m=g;n=a+252|0;zTb(m,n);return}else{o=i;p=g}}else{yTb(g,d-k|0);k=f[e>>2]|0;e=f[k>>2]|0;f[a+380>>2]=e;o=e;p=k}k=o;o=f[c>>2]|0;c=0;do{e=f[o+(c<<4)>>2]|0;g=f[o+(c<<4)+4>>2]|0;i=f[o+(c<<4)+8>>2]|0;j=f[o+(c<<4)+12>>2]|0;h=Y(g,b)|0;f[k+(c<<6)>>2]=h+e;l=i+e|0;f[k+(c<<6)+4>>2]=l+h;q=Y(j+g|0,b)|0;f[k+(c<<6)+16>>2]=q+e;f[k+(c<<6)+20>>2]=q+l;r=(i<<1)+e|0;f[k+(c<<6)+8>>2]=r+h;s=r+i|0;f[k+(c<<6)+12>>2]=s+h;f[k+(c<<6)+24>>2]=q+r;f[k+(c<<6)+28>>2]=s+q;q=(j<<1)+g|0;g=Y(q,b)|0;f[k+(c<<6)+40>>2]=g+r;f[k+(c<<6)+44>>2]=g+s;h=Y(q+j|0,b)|0;f[k+(c<<6)+56>>2]=h+r;f[k+(c<<6)+60>>2]=h+s;f[k+(c<<6)+32>>2]=g+e;f[k+(c<<6)+36>>2]=g+l;f[k+(c<<6)+48>>2]=h+e;f[k+(c<<6)+52>>2]=h+l;c=c+1|0}while((c|0)!=(d|0));m=p;n=a+252|0;zTb(m,n);return}function yTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)kWc(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=m+(d<<6)|0;d=b;b=h;m=h;do{j=b;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(0-(b>>6)<<6)|0;if((b|0)>0)o1c(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;cYc(d);return}function zTb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)FQ(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[a>>2]|0;p=f[i>>2]|0}else{o=h;p=j}j=p-o|0;p=o;f[g>>2]=1124007936;h=g+4|0;f[h>>2]=2;i=g+8|0;f[i>>2]=1;f[g+12>>2]=j;a=g+16|0;f[a>>2]=p;f[g+20>>2]=p;k=g+24|0;l=g+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[l>>2]=i;i=g+48|0;n=g+44|0;f[n>>2]=i;m=g+52|0;f[m>>2]=0;f[i>>2]=0;if((o|0)==0&(j|0)!=0){o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=28;q=o;r=470314;s=q+28|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[o+28>>0]=0;vM(-215,e,470343,470347,548)}f[i>>2]=j;f[m>>2]=1;m=p+j|0;f[g+28>>2]=m;f[k>>2]=m+(0-j)+j;R$(g);j=e+8|0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;jR(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(j=c+12|0,c=f[j>>2]|0,f[j>>2]=c+-1,(c|0)==1):0)V$(g);f[e>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[l>>2]|0;l=0;do{f[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[n>>2]|0;if((h|0)==(i|0)){u=d;return}wL(h);u=d;return}function ATb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[a+44>>2]=1124007936;b=a+52|0;c=a+84|0;d=a+48|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+92|0;f[a+88>>2]=b;f[b>>2]=0;f[a+96>>2]=0;f[a+100>>2]=1124007936;b=a+108|0;c=a+140|0;d=a+104|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+148|0;f[a+144>>2]=b;f[b>>2]=0;f[a+152>>2]=0;f[a+156>>2]=1124007936;b=a+160|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+188>>2]=a+164;b=a+196|0;f[a+192>>2]=b;f[a+200>>2]=0;f[b>>2]=0;f[a+204>>2]=1124007936;b=a+208|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+236>>2]=a+212;b=a+244|0;f[a+240>>2]=b;f[a+248>>2]=0;f[b>>2]=0;f[a+252>>2]=1124007936;b=a+256|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+284>>2]=a+260;b=a+292|0;f[a+288>>2]=b;f[a+296>>2]=0;f[b>>2]=0;f[a+300>>2]=1124007936;b=a+304|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+332>>2]=a+308;b=a+340|0;f[a+336>>2]=b;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[a>>2]=141300;b=a+356|0;c=a+360|0;d=a+368|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;e=$Xc(24)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=141388;g=e+12|0;f[g>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;TXc(e);f[b>>2]=g;g=f[c>>2]|0;f[c>>2]=e;if(g|0)UXc(g);UXc(e);e=$Xc(24)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=141416;g=e+12|0;f[g>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;TXc(e);f[a+364>>2]=g;g=f[d>>2]|0;f[d>>2]=e;if(g|0)UXc(g);UXc(e);e=$Xc(24)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=141128;g=e+12|0;f[g>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;TXc(e);f[a+348>>2]=g;g=a+352|0;d=f[g>>2]|0;f[g>>2]=e;if(!d){UXc(e);h=a+380|0;f[h>>2]=0;i=a+384|0;f[i>>2]=0;return}UXc(d);UXc(e);h=a+380|0;f[h>>2]=0;i=a+384|0;f[i>>2]=0;return}function BTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;aTb(a,b)|0;c=f[b+356>>2]|0;d=f[b+360>>2]|0;if(d|0)TXc(d);f[a+356>>2]=c;c=a+360|0;e=f[c>>2]|0;f[c>>2]=d;if(e|0)UXc(e);e=f[b+364>>2]|0;d=f[b+368>>2]|0;if(d|0)TXc(d);f[a+364>>2]=e;e=a+368|0;c=f[e>>2]|0;f[e>>2]=d;if(c|0)UXc(c);c=f[b+372>>2]|0;d=f[b+376>>2]|0;if(d|0)TXc(d);f[a+372>>2]=c;c=a+376|0;e=f[c>>2]|0;f[c>>2]=d;if(!e){g=a+380|0;h=b+380|0;i=h;j=i;k=f[j>>2]|0;l=i+4|0;m=l;n=f[m>>2]|0;o=g;p=o;f[p>>2]=k;q=o+4|0;r=q;f[r>>2]=n;return a|0}UXc(e);g=a+380|0;h=b+380|0;i=h;j=i;k=f[j>>2]|0;l=i+4|0;m=l;n=f[m>>2]|0;o=g;p=o;f[p>>2]=k;q=o+4|0;r=q;f[r>>2]=n;return a|0}function CTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141416;b=f[a+12>>2]|0;if(!b){NXc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-64-b|0)>>>6)<<6);cYc(b);NXc(a);return}function DTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141416;b=f[a+12>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-64-b|0)>>>6)<<6);cYc(b);NXc(a);cYc(a);return}function ETb(a){a=a|0;var b=0,c=0;b=f[a+12>>2]|0;if(!b)return;c=a+16|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-64-b|0)>>>6)<<6);cYc(b);return}function FTb(a){a=a|0;cYc(a);return}function GTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141388;b=f[a+12>>2]|0;if(!b){NXc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);cYc(b);NXc(a);return}function HTb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141388;b=f[a+12>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+16|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);cYc(b);NXc(a);cYc(a);return}function ITb(a){a=a|0;var b=0,c=0;b=f[a+12>>2]|0;if(!b)return;c=a+16|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-16-b|0)>>>4)<<4);cYc(b);return}function JTb(a){a=a|0;cYc(a);return}function KTb(a){a=a|0;var b=0,c=0;f[a>>2]=141360;b=a+12|0;f[b>>2]=141300;c=f[a+388>>2]|0;if(c|0)UXc(c);c=f[a+380>>2]|0;if(c|0)UXc(c);c=f[a+372>>2]|0;if(!c){tSb(b);NXc(a);return}UXc(c);tSb(b);NXc(a);return}function LTb(a){a=a|0;var b=0,c=0;f[a>>2]=141360;b=a+12|0;f[b>>2]=141300;c=f[a+388>>2]|0;if(c|0)UXc(c);c=f[a+380>>2]|0;if(c|0)UXc(c);c=f[a+372>>2]|0;if(!c){tSb(b);NXc(a);cYc(a);return}UXc(c);tSb(b);NXc(a);cYc(a);return}function MTb(a){a=a|0;var b=0,c=0;b=a+12|0;f[b>>2]=141300;c=f[a+388>>2]|0;if(c|0)UXc(c);c=f[a+380>>2]|0;if(c|0)UXc(c);c=f[a+372>>2]|0;if(!c){tSb(b);return}UXc(c);tSb(b);return}function NTb(a){a=a|0;cYc(a);return}function OTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)kWc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function PTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=u;u=u+48|0;d=c+36|0;e=c+24|0;f=c;i5(e,b,468908);d5(f,e);g5(d,f);M5(d,a,0);e=x5(f)|0;g5(d,e);M5(d,a+4|0,0);f=x5(e)|0;g5(d,f);M5(d,a+8|0,0);e=x5(f)|0;g5(d,e);M5(d,a+12|0,0);x5(e)|0;u=c;return 1}function QTb(a){a=a|0;var b=0,c=0;f[a>>2]=141444;XXc(a+416|0);EQ(a+368|0);EQ(a+320|0);EQ(a+272|0);EQ(a+224|0);EQ(a+176|0);EQ(a+128|0);b=f[a+124>>2]|0;if(b|0)UXc(b);b=f[a+116>>2]|0;if(b|0)UXc(b);b=f[a+108>>2]|0;if(!b){c=a+4|0;oUb(c);qP(a);return}UXc(b);c=a+4|0;oUb(c);qP(a);return}function RTb(a){a=a|0;QTb(a);cYc(a);return}function STb(a,b){a=a|0;b=b|0;pUb(a,b)|0;return}function TTb(a){a=a|0;var b=0;if(f[a+112>>2]|0){b=0;return b|0}b=(f[a+32>>2]|0)==(f[a+36>>2]|0);return b|0}function UTb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+176|0;e=d+64|0;g=d+52|0;h=d+24|0;i=d+12|0;j=d;f[a+112>>2]=0;k=a+116|0;l=f[k>>2]|0;f[k>>2]=0;if(l|0)UXc(l);l=e;k=l+100|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(k|0));nUb(a+4|0,e)|0;oUb(e);f[a+104>>2]=0;l=a+108|0;k=f[l>>2]|0;f[l>>2]=0;if(k|0)UXc(k);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;$4(e,c,0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(!(u3(e)|0)){m=0;r3(e);u=d;return m|0}c5(g,e);if(pUb(a,g)|0)n=1;else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;c=i+11|0;b[c>>0]=4;f[i>>2]=1819113774;b[i+4>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;$4(h,i,5,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[c>>0]|0)<0)cYc(f[i>>2]|0);TVb(g,h)|0;w3(i,h);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t3(h,i,4,j)|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);c5(j,h);f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];j=pUb(a,g)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);r3(h);n=j}m=n;r3(e);u=d;return m|0}function VTb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+48|0;j=g+28|0;k=g+16|0;l=g+8|0;m=g;f[j>>2]=0;n=j+4|0;f[n>>2]=0;f[j+8>>2]=0;f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];XTb(a,b,c,j,k,d,e,0,l,m,0);m=f[k>>2]|0;if(m|0){k=f[o>>2]|0;if((k|0)!=(m|0))f[o>>2]=k+(~((k+-8-m|0)>>>3)<<3);cYc(m)}m=f[j>>2]|0;if(!m){u=g;return}j=f[n>>2]|0;if((j|0)!=(m|0))f[n>>2]=j+(~((j+-4-m|0)>>>2)<<2);cYc(m);u=g;return}function WTb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+112|0;l=i+56|0;m=i+44|0;n=i+32|0;o=i+8|0;p=i+24|0;q=i;do if((eS(c)|0)==65536){r=f[c+4>>2]|0;f[l>>2]=f[r>>2];s=l+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=l+8|0;f[v>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];f[l+16>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[l+36>>2]=w;f[l+40>>2]=v;v=l+48|0;x=l+44|0;f[x>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;U$(l,r);break}}else bS(l,c,-1);while(0);if(!(g>1.0)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;y=$Xc(48)|0;f[m>>2]=y;z=m+8|0;f[z>>2]=-2147483600;A=m+4|0;f[A>>2]=41;B=y;C=469221;D=B+41|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+41|0;b[E>>0]=0;vM(-215,m,468976,468086,1398)}if(f[l>>2]&7|0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;y=$Xc(48)|0;f[m>>2]=y;z=m+8|0;f[z>>2]=-2147483600;A=m+4|0;f[A>>2]=41;B=y;C=469221;D=B+41|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+41|0;b[E>>0]=0;vM(-215,m,468976,468086,1398)}if(!((f[a+112>>2]|0)==0?(f[a+32>>2]|0)==(f[a+36>>2]|0):0)){f[m>>2]=0;E=m+4|0;f[E>>2]=0;f[m+8>>2]=0;f[n>>2]=0;y=n+4|0;f[y>>2]=0;f[n+8>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[q>>2]=f[k>>2];f[q+4>>2]=f[k+4>>2];cUb(a,o,d,m,n,g,p,q,0);dUb(d,h,.2,e,0);e=f[n>>2]|0;if(e|0){n=f[y>>2]|0;if((n|0)!=(e|0))f[y>>2]=n+(~((n+-8-e|0)>>>3)<<3);cYc(e)}e=f[m>>2]|0;if(e|0){m=f[E>>2]|0;if((m|0)!=(e|0))f[E>>2]=m+(~((m+-4-e|0)>>>2)<<2);cYc(e)}}e=l+36|0;m=f[e>>2]|0;if(m|0?(E=m+12|0,m=f[E>>2]|0,f[E>>2]=m+-1,(m|0)==1):0)V$(l);f[e>>2]=0;e=l+16|0;m=l+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[l+40>>2]|0;E=0;do{f[e+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=i;return}wL(m);u=i;return}function XTb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;j=u;u=u+32|0;n=j+16|0;o=j+8|0;p=j;if(h>1.0?(qS(c,-1)|0)==0:0){if((f[a+112>>2]|0)==0?(f[a+32>>2]|0)==(f[a+36>>2]|0):0){u=j;return}f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];cUb(a,c,d,e,g,h,o,p,m);if(m){dUb(d,i,.2,e,g);u=j;return}else{dUb(d,i,.2,0,0);u=j;return}}j=$Xc(48)|0;f[n>>2]=j;f[n+8>>2]=-2147483600;f[n+4>>2]=42;i=j;d=468933;g=i+42|0;do{b[i>>0]=b[d>>0]|0;i=i+1|0;d=d+1|0}while((i|0)<(g|0));b[j+42>>0]=0;vM(-215,n,468976,468086,1360)}function YTb(a){a=a|0;return (f[a+112>>2]|0)!=0|0}function ZTb(a,b){a=a|0;b=b|0;f[a>>2]=f[b+24>>2];f[a+4>>2]=f[b+28>>2];return}function _Tb(a){a=a|0;var b=0;b=f[a+104>>2]|0;return _i[f[(f[b>>2]|0)+16>>2]&2047](b)|0}function $Tb(a){a=a|0;return f[a+112>>2]|0}function aUb(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if(d|0)TXc(d);f[a+120>>2]=c;c=a+124|0;a=f[c>>2]|0;f[c>>2]=d;if(!a)return;UXc(a);return}function bUb(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b+120>>2];c=f[b+124>>2]|0;f[a+4>>2]=c;if(!c)return;TXc(c);return}function cUb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;l=u;u=u+1344|0;m=l+1232|0;o=l+1224|0;q=l+1212|0;r=l+1200|0;s=l;t=l+1184|0;v=l+1128|0;w=l+64|0;x=l+56|0;cS(o,c,-1);y=a+24|0;z=f[y>>2]|0;A=a+28|0;B=f[A>>2]|0;C=j+4|0;if((f[C>>2]|0)!=0?(f[j>>2]|0)!=0:0){D=o+4|0;E=D;F=f[D>>2]|0}else{f[j>>2]=f[o>>2];D=o+4|0;G=f[D>>2]|0;f[C>>2]=G;E=D;F=G}if((F|0)<(B|0)){u=l;return}G=f[o>>2]|0;if((G|0)<(z|0)){u=l;return}f[q>>2]=0;D=q+4|0;f[D>>2]=0;f[q+8>>2]=0;f[r>>2]=0;H=r+4|0;f[H>>2]=0;f[r+8>>2]=0;I=q+8|0;J=$Xc(4096)|0;K=J;L=J+4096|0;f[q>>2]=K;f[D>>2]=K;f[I>>2]=L;M=r+8|0;N=$Xc(4096)|0;O=N;f[r>>2]=O;f[H>>2]=O;f[M>>2]=N+4096;P=+(z|0);N=zLc(P)|0;Q=+(B|0);a:do if(!((N|0)>(G|0)|(zLc(Q)|0)>(F|0))){R=1.0;O=J;S=G;T=L;while(1){U=R;n[m>>2]=U;if(O>>>0<T>>>0){n[O>>2]=U;f[D>>2]=O+4;V=S}else{MA(q,m);V=f[o>>2]|0}U=R*h;W=zLc(P*U)|0;X=zLc(Q*U)|0;if((W|0)>(V|0)?1:(X|0)>(f[E>>2]|0))break;R=U;O=f[D>>2]|0;S=V;T=f[I>>2]|0}T=f[D>>2]|0;S=f[q>>2]|0;O=S;X=T;if((T|0)==(S|0)){Z=D;_=O;$=X;aa=S;ba=S;ca=O;da=O}else{R=+(z|0);U=+(B|0);W=i+4|0;ea=0;fa=O;ga=O;ha=X;X=O;ia=S;S=T;T=O;while(1){O=T+(ea<<2)|0;ja=+n[O>>2];ka=ALc(R*ja)|0;la=ALc(U*ja)|0;if((ka|0)>(f[j>>2]|0)){Z=D;_=X;$=ha;aa=S;ba=ia;ca=fa;da=ga;break a}if((la|0)>(f[C>>2]|0)){Z=D;_=X;$=ha;aa=S;ba=ia;ca=fa;da=ga;break a}do if((ka|0)>=(f[i>>2]|0)?(la|0)>=(f[W>>2]|0):0){ma=f[H>>2]|0;if((ma|0)==(f[M>>2]|0)){hw(r,O);na=f[D>>2]|0;oa=f[q>>2]|0;pa=oa;qa=pa;ra=pa;sa=na;ta=pa;ua=oa;va=na;break}else{n[ma>>2]=ja;f[H>>2]=ma+4;qa=fa;ra=ga;sa=ha;ta=X;ua=ia;va=S;break}}else{qa=fa;ra=ga;sa=ha;ta=X;ua=ia;va=S}while(0);ea=ea+1|0;if(ea>>>0>=va-ua>>2>>>0){Z=D;_=ta;$=sa;aa=va;ba=ua;ca=qa;da=ra;break}else{fa=qa;ga=ra;ha=sa;X=ta;ia=ua;S=va;T=ua}}}}else{Z=D;_=J;$=J;aa=K;ba=K;ca=J;da=J}while(0);if(!((_|0)==($|0)?1:(f[r>>2]|0)!=(f[H>>2]|0))){f[m>>2]=0;$=m+4|0;f[$>>2]=0;f[m+8>>2]=0;if((aa|0)!=(ba|0)){Q=+(z|0);P=+(B|0);B=i+4|0;z=m+8|0;_=0;J=da;da=0;K=0;ua=ca;va=ba;ba=aa;while(1){h=+n[J+(_<<2)>>2];aa=ALc(Q*h)|0;ta=ALc(P*h)|0;sa=(f[i>>2]|0)-aa|0;aa=Y(sa,sa)|0;sa=(f[B>>2]|0)-ta|0;h=+((Y(sa,sa)|0)+aa|0);p[s>>3]=h;if((da|0)==(K|0)){xw(m,s);aa=f[q>>2]|0;wa=aa;xa=f[Z>>2]|0;ya=aa}else{p[da>>3]=h;f[$>>2]=da+8;wa=va;xa=ba;ya=ua}aa=_+1|0;if(aa>>>0>=xa-wa>>2>>>0)break;_=aa;J=wa;da=f[$>>2]|0;K=f[z>>2]|0;ua=ya;va=wa;ba=xa}xa=f[m>>2]|0;ba=xa;if((f[$>>2]|0)==(xa|0)){za=0;Aa=ya;Ba=ba}else{wa=(f[$>>2]|0)-xa>>3;xa=0;va=0;while(1){ua=+p[ba+(va<<3)>>3]>+p[ba+(xa<<3)>>3]?xa:va;xa=xa+1|0;if(xa>>>0>=wa>>>0){za=ua;Aa=ya;Ba=ba;break}else va=ua}}}else{za=0;Aa=ca;Ba=0}ca=Aa+(za<<2)|0;za=f[H>>2]|0;if((za|0)==(f[M>>2]|0)){hw(r,ca);Ca=f[m>>2]|0}else{f[za>>2]=f[ca>>2];f[H>>2]=za+4;Ca=Ba}if(Ca|0){Ba=f[$>>2]|0;if((Ba|0)!=(Ca|0))f[$>>2]=Ba+(~((Ba+-8-Ca|0)>>>3)<<3);cYc(Ca)}}Ca=f[d>>2]|0;Ba=d+4|0;$=f[Ba>>2]|0;if(($|0)!=(Ca|0))f[Ba>>2]=$+(~(($+-16-Ca|0)>>>4)<<4);Ca=f[e>>2]|0;$=e+4|0;Ba=f[$>>2]|0;if((Ba|0)!=(Ca|0))f[$>>2]=Ba+(~((Ba+-4-Ca|0)>>>2)<<2);Ca=f[g>>2]|0;Ba=g+4|0;$=f[Ba>>2]|0;if(($|0)!=(Ca|0))f[Ba>>2]=$+(~(($+-8-Ca|0)>>>3)<<3);f[s>>2]=1124007936;Ca=s+4|0;$=s+8|0;Ba=s+40|0;za=Ca;ca=za+36|0;do{f[za>>2]=0;za=za+4|0}while((za|0)<(ca|0));f[Ba>>2]=$;M=s+48|0;Aa=s+44|0;f[Aa>>2]=M;f[M>>2]=0;f[s+52>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;do if((rS(c,-1)|0)<=1){if((eS(c)|0)!=65536){va=m+8|0;f[va>>2]=0;f[va+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=s;uS(c,m);break}do if((eS(c)|0)==65536){va=f[c+4>>2]|0;f[m>>2]=f[va>>2];ba=m+4|0;ya=va+4|0;f[ba>>2]=f[ya>>2];wa=m+8|0;f[wa>>2]=f[va+8>>2];f[m+12>>2]=f[va+12>>2];f[m+16>>2]=f[va+16>>2];f[m+20>>2]=f[va+20>>2];f[m+24>>2]=f[va+24>>2];f[m+28>>2]=f[va+28>>2];f[m+32>>2]=f[va+32>>2];xa=f[va+36>>2]|0;f[m+36>>2]=xa;f[m+40>>2]=wa;wa=m+48|0;ua=m+44|0;f[ua>>2]=wa;f[wa>>2]=0;f[m+52>>2]=0;if(xa|0){wa=xa+12|0;f[wa>>2]=(f[wa>>2]|0)+1}if((f[ya>>2]|0)<3){ya=f[va+44>>2]|0;wa=f[ua>>2]|0;f[wa>>2]=f[ya>>2];f[wa+4>>2]=f[ya+4>>2];break}else{f[ba>>2]=0;U$(m,va);break}}else bS(m,c,-1);while(0);va=s+36|0;ba=f[va>>2]|0;if(ba|0?(ya=ba+12|0,ba=f[ya>>2]|0,f[ya>>2]=ba+-1,(ba|0)==1):0)V$(s);f[va>>2]=0;ba=s+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[Ca>>2]|0)>0){ya=f[Ba>>2]|0;wa=0;do{f[ya+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[Ca>>2]|0))}f[s>>2]=f[m>>2];wa=m+4|0;ya=f[wa>>2]|0;f[Ca>>2]=ya;ua=m+8|0;f[$>>2]=f[ua>>2];f[s+12>>2]=f[m+12>>2];xa=m+16|0;f[ba>>2]=f[xa>>2];f[s+20>>2]=f[m+20>>2];f[s+24>>2]=f[m+24>>2];f[s+28>>2]=f[m+28>>2];f[s+32>>2]=f[m+32>>2];z=m+36|0;f[va>>2]=f[z>>2];K=s+44|0;da=f[K>>2]|0;if((da|0)==(M|0))Da=ya;else{wL(da);f[K>>2]=M;f[Ba>>2]=$;Da=f[wa>>2]|0}da=m+44|0;if((Da|0)<3){ya=f[da>>2]|0;f[M>>2]=f[ya>>2];f[s+52>>2]=f[ya+4>>2];Ea=ya}else{f[K>>2]=f[da>>2];K=m+40|0;f[s+40>>2]=f[K>>2];ya=m+48|0;f[da>>2]=ya;f[K>>2]=ua;Ea=ya}f[m>>2]=1124007936;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;f[wa+16>>2]=0;f[wa+20>>2]=0;f[wa+24>>2]=0;f[wa+28>>2]=0;f[z>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((Ea|0)!=(m+48|0))wL(Ea)}else{xa=m+8|0;f[xa>>2]=0;f[xa+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=s;Spa(c,m,6,0)}while(0);f[t>>2]=16842752;c=t+4|0;f[c>>2]=s;f[t+8>>2]=0;f[t+12>>2]=0;Ea=a+104|0;Da=f[Ea>>2]|0;if(hj[f[(f[Da>>2]|0)+20>>2]&511](Da,t,r)|0){Da=f[Ea>>2]|0;Yi[f[(f[Da>>2]|0)+32>>2]&4095](Da);f[v>>2]=1124007936;Da=v+4|0;$=v+8|0;xa=v+40|0;za=Da;ca=za+36|0;do{f[za>>2]=0;za=za+4|0}while((za|0)<(ca|0));f[xa>>2]=$;z=v+48|0;wa=v+44|0;f[wa>>2]=z;f[z>>2]=0;f[v+52>>2]=0;ya=f[a+120>>2]|0;if(ya|0){ua=f[(f[ya>>2]|0)+8>>2]|0;do if((eS(t)|0)==65536){K=f[c>>2]|0;f[w>>2]=f[K>>2];da=w+4|0;J=K+4|0;f[da>>2]=f[J>>2];_=w+8|0;f[_>>2]=f[K+8>>2];f[w+12>>2]=f[K+12>>2];f[w+16>>2]=f[K+16>>2];f[w+20>>2]=f[K+20>>2];f[w+24>>2]=f[K+24>>2];f[w+28>>2]=f[K+28>>2];f[w+32>>2]=f[K+32>>2];Z=f[K+36>>2]|0;f[w+36>>2]=Z;f[w+40>>2]=_;_=w+48|0;B=w+44|0;f[B>>2]=_;f[_>>2]=0;f[w+52>>2]=0;if(Z|0){_=Z+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[J>>2]|0)<3){J=f[K+44>>2]|0;_=f[B>>2]|0;f[_>>2]=f[J>>2];f[_+4>>2]=f[J+4>>2];break}else{f[da>>2]=0;U$(w,K);break}}else bS(w,t,-1);while(0);Ti[ua&511](m,ya,w);ya=v+36|0;ua=f[ya>>2]|0;if(ua|0?(t=ua+12|0,ua=f[t>>2]|0,f[t>>2]=ua+-1,(ua|0)==1):0)V$(v);f[ya>>2]=0;ua=v+16|0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[Da>>2]|0)>0){t=f[xa>>2]|0;c=0;do{f[t+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[Da>>2]|0))}f[v>>2]=f[m>>2];c=m+4|0;t=f[c>>2]|0;f[Da>>2]=t;K=m+8|0;f[$>>2]=f[K>>2];f[v+12>>2]=f[m+12>>2];da=m+16|0;f[ua>>2]=f[da>>2];f[v+20>>2]=f[m+20>>2];f[v+24>>2]=f[m+24>>2];f[v+28>>2]=f[m+28>>2];f[v+32>>2]=f[m+32>>2];ua=m+36|0;f[ya>>2]=f[ua>>2];ya=v+44|0;J=f[ya>>2]|0;if((J|0)==(z|0))Fa=t;else{wL(J);f[ya>>2]=z;f[xa>>2]=$;Fa=f[c>>2]|0}$=m+44|0;if((Fa|0)<3){Fa=f[$>>2]|0;f[z>>2]=f[Fa>>2];f[v+52>>2]=f[Fa+4>>2];Ga=Fa}else{f[ya>>2]=f[$>>2];ya=m+40|0;f[v+40>>2]=f[ya>>2];Fa=m+48|0;f[$>>2]=Fa;f[ya>>2]=K;Ga=Fa}f[m>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[ua>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((Ga|0)!=(m+48|0))wL(Ga);Ga=w+36|0;da=f[Ga>>2]|0;do if(da|0){ua=da+12|0;c=f[ua>>2]|0;f[ua>>2]=c+-1;if((c|0)!=1)break;V$(w)}while(0);f[Ga>>2]=0;Ga=w+16|0;da=w+4|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[da>>2]|0)>0){Ga=f[w+40>>2]|0;c=0;do{f[Ga+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[da>>2]|0))}da=f[w+44>>2]|0;if((da|0)!=(w+48|0))wL(da)}da=(f[H>>2]|0)-(f[r>>2]|0)>>2;c=w+8|0;f[w>>2]=c;Ga=w+4|0;f[Ga>>2]=da;if(da>>>0>264){ua=bYc(da>>>0>1073741823?-1:da<<2)|0;f[w>>2]=ua;Ha=ua}else Ha=c;ua=f[(f[Ea>>2]|0)+348>>2]|0;Ea=f[ua>>2]|0;if(((f[ua+4>>2]|0)-Ea|0)<=0){ua=$Xc(64)|0;f[m>>2]=ua;f[m+8>>2]=-2147483584;f[m+4>>2]=50;za=ua;Fa=468166;ca=za+50|0;do{b[za>>0]=b[Fa>>0]|0;za=za+1|0;Fa=Fa+1|0}while((za|0)<(ca|0));b[ua+50>>0]=0;vM(-215,m,468217,468230,46)}ua=Ea;Ea=(f[ua+4>>2]|0)-(f[y>>2]|0)|0;P=+(((Ea|0)>0?Ea:0)|0)*.03125;Ea=~~P;y=(+(Ea|0)<P&1)+Ea|0;if(da|0){Ea=y+-1|0;Fa=0;do{za=(f[ua+(Fa*20|0)+8>>2]|0)-(f[A>>2]|0)|0;ca=f[ua+(Fa*20|0)+16>>2]|0;K=(Ea+((((za|0)>0?za:0)|0)/(ca|0)|0)|0)/(y|0)|0;za=Y((K|0)>1?K:1,ca)|0;f[Ha+(Fa<<2)>>2]=za;Fa=Fa+1|0}while((Fa|0)!=(da|0))}fUb(m,a,da,y,ua,Ha,d,e,g,k,v,a+416|0);f[x>>2]=0;f[x+4>>2]=y;h3(x,m,-1.0);f[m>>2]=141524;x=m+48|0;y=m+84|0;a=f[y>>2]|0;if(a|0?(k=a+12|0,a=f[k>>2]|0,f[k>>2]=a+-1,(a|0)==1):0)V$(x);f[y>>2]=0;y=m+64|0;x=m+52|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[x>>2]|0)>0){y=f[m+88>>2]|0;a=0;do{f[y+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[x>>2]|0))}x=f[m+92>>2]|0;if((x|0)!=(m+96|0))wL(x);x=f[m+36>>2]|0;if(x|0){a=m+40|0;m=f[a>>2]|0;if((m|0)!=(x|0))f[a>>2]=m+(~((m+-4-x|0)>>>2)<<2);cYc(x)}x=f[w>>2]|0;if((x|0)!=(c|0)){if(x|0)dYc(x);f[w>>2]=c;f[Ga>>2]=264}Ga=v+36|0;c=f[Ga>>2]|0;do if(c|0){w=c+12|0;x=f[w>>2]|0;f[w>>2]=x+-1;if((x|0)!=1)break;V$(v)}while(0);f[Ga>>2]=0;Ga=v+16|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[Da>>2]|0)>0){Ga=f[xa>>2]|0;xa=0;do{f[Ga+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[Da>>2]|0))}Da=f[wa>>2]|0;if((Da|0)!=(z|0))wL(Da)}Da=s+36|0;z=f[Da>>2]|0;if(z|0?(wa=z+12|0,z=f[wa>>2]|0,f[wa>>2]=z+-1,(z|0)==1):0)V$(s);f[Da>>2]=0;Da=s+16|0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[Ca>>2]|0)>0){Da=f[Ba>>2]|0;Ba=0;do{f[Da+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[Ca>>2]|0))}Ca=f[Aa>>2]|0;if((Ca|0)!=(M|0))wL(Ca);Ca=f[r>>2]|0;if(Ca|0){r=f[H>>2]|0;if((r|0)!=(Ca|0))f[H>>2]=r+(~((r+-4-Ca|0)>>>2)<<2);cYc(Ca)}Ca=f[q>>2]|0;if(Ca|0){q=f[D>>2]|0;if((q|0)!=(Ca|0))f[D>>2]=q+(~((q+-4-Ca|0)>>>2)<<2);cYc(Ca)}u=l;return}function dUb(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+112|0;h=g+16|0;i=g+92|0;j=g+8|0;k=g+80|0;l=g+68|0;m=g+56|0;n=g+40|0;o=g+32|0;q=g;r=g+28|0;if((b|0)>=1?(s=a+4|0,(f[a>>2]|0)!=(f[s>>2]|0)):0){f[i>>2]=0;t=i+4|0;f[t>>2]=0;f[i+8>>2]=0;p[j>>3]=c;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];j=eUb(a,i,h)|0;f[h>>2]=0;v=h+4|0;f[v>>2]=0;f[h+8>>2]=0;w=(j|0)==0;do if(!w)if(j>>>0>268435455)kWc(h);else{x=j<<4;y=$Xc(x)|0;f[h>>2]=y;f[h+8>>2]=y+(j<<4);g1c(y|0,0,x|0)|0;f[v>>2]=y+x;z=y;break}else z=0;while(0);f[k>>2]=0;y=k+4|0;f[y>>2]=0;f[k+8>>2]=0;if(w)A=0;else{x=j<<2;B=$Xc(x)|0;f[k>>2]=B;C=B+(j<<2)|0;f[k+8>>2]=C;g1c(B|0,0,x|0)|0;f[y>>2]=C;A=B}f[l>>2]=0;B=l+4|0;f[B>>2]=0;f[l+8>>2]=0;if(w)D=0;else{C=j<<2;x=$Xc(C)|0;f[l>>2]=x;E=x+(j<<2)|0;f[l+8>>2]=E;g1c(x|0,0,C|0)|0;f[B>>2]=E;D=x}f[m>>2]=0;x=m+4|0;f[x>>2]=0;f[m+8>>2]=0;if(w)F=0;else{w=$Xc(j<<3)|0;f[x>>2]=w;f[m>>2]=w;E=w+(j<<3)|0;f[m+8>>2]=E;C=j;G=w;while(1){p[G>>3]=2.2250738585072014e-308;C=C+-1|0;if(!C)break;else G=G+8|0}f[x>>2]=E;F=w}w=f[i>>2]|0;E=(f[t>>2]|0)-w|0;G=E>>2;C=(E|0)>0;E=w;if(C){w=f[a>>2]|0;H=0;do{I=f[E+(H<<2)>>2]|0;J=z+(I<<4)|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)>>2]|0);J=z+(I<<4)+4|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)+4>>2]|0);J=z+(I<<4)+8|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)+8>>2]|0);J=z+(I<<4)+12|0;f[J>>2]=(f[J>>2]|0)+(f[w+(H<<4)+12>>2]|0);J=A+(I<<2)|0;f[J>>2]=(f[J>>2]|0)+1;H=H+1|0}while((H|0)<(G|0))}H=(e|0)!=0;w=(d|0)!=0;if(w&H?(J=f[d>>2]|0,(J|0)!=(f[d+4>>2]|0)):0){I=f[e>>2]|0;K=(I|0)==(f[e+4>>2]|0);if(K|C^1){L=K;M=F}else{K=f[m>>2]|0;C=0;do{N=f[E+(C<<2)>>2]|0;O=f[J+(C<<2)>>2]|0;P=D+(N<<2)|0;Q=f[P>>2]|0;if((O|0)<=(Q|0)){if((O|0)==(Q|0)?(R=+p[I+(C<<3)>>3],Q=K+(N<<3)|0,R>+p[Q>>3]):0)p[Q>>3]=R}else{f[P>>2]=O;p[K+(N<<3)>>3]=+p[I+(C<<3)>>3]}C=C+1|0}while((C|0)<(G|0));L=0;M=K}}else{L=1;M=F}F=(j|0)>0;if(F){K=0;do{G=z+(K<<4)|0;C=z+(K<<4)+4|0;I=f[C>>2]|0;J=z+(K<<4)+8|0;E=f[J>>2]|0;N=z+(K<<4)+12|0;O=f[N>>2]|0;R=1.0/+(f[A+(K<<2)>>2]|0);P=ALc(+(f[G>>2]|0)*R)|0;Q=ALc(+(I|0)*R)|0;I=ALc(+(E|0)*R)|0;E=ALc(+(O|0)*R)|0;f[G>>2]=P;f[C>>2]=Q;f[J>>2]=I;f[N>>2]=E;K=K+1|0}while((K|0)!=(j|0))}K=f[a>>2]|0;E=f[s>>2]|0;if((E|0)!=(K|0))f[s>>2]=E+(~((E+-16-K|0)>>>4)<<4);if(w?(K=f[d>>2]|0,E=d+4|0,N=f[E>>2]|0,(N|0)!=(K|0)):0)f[E>>2]=N+(~((N+-4-K|0)>>>2)<<2);if(H?(K=f[e>>2]|0,N=e+4|0,E=f[N>>2]|0,(E|0)!=(K|0)):0)f[N>>2]=E+(~((E+-8-K|0)>>>3)<<3);if(F){F=n+4|0;K=n+8|0;E=n+12|0;N=a+8|0;I=L?o:r;L=d+4|0;J=d+8|0;Q=e+4|0;C=e+8|0;P=f[m>>2]|0;G=f[k>>2]|0;O=f[l>>2]|0;S=0;T=z;z=A;A=D;while(1){D=f[T+(S<<4)>>2]|0;f[n>>2]=D;U=f[T+(S<<4)+4>>2]|0;f[F>>2]=U;V=f[T+(S<<4)+8>>2]|0;f[K>>2]=V;W=f[T+(S<<4)+12>>2]|0;f[E>>2]=W;X=f[z+(S<<2)>>2]|0;f[o>>2]=X;p[q>>3]=+p[P+(S<<3)>>3];f[r>>2]=f[A+(S<<2)>>2];do if((X|0)>(b|0)){Y=f[h>>2]|0;Z=V+D|0;_=W+U|0;$=(X|0)>3?X:3;a:do if((X|0)<3){aa=0;while(1){do if((aa|0)!=(S|0)?(f[z+(aa<<2)>>2]|0)>(b|0):0){ba=f[Y+(aa<<4)>>2]|0;ca=f[Y+(aa<<4)+4>>2]|0;da=f[Y+(aa<<4)+8>>2]|0;ea=f[Y+(aa<<4)+12>>2]|0;fa=zLc(+(da|0)*c)|0;ga=zLc(+(ea|0)*c)|0;if((D|0)<(ba-fa|0)|(U|0)<(ca-ga|0))break;if((Z|0)>(da+ba+fa|0))break;if((_|0)<=(ea+ca+ga|0)){ha=aa;break a}}while(0);ga=aa+1|0;if((ga|0)<(j|0))aa=ga;else{ha=ga;break}}}else{aa=0;while(1){ga=f[z+(aa<<2)>>2]|0;do if((aa|0)!=(S|0)&(ga|0)>(b|0)){ca=f[Y+(aa<<4)>>2]|0;ea=f[Y+(aa<<4)+4>>2]|0;fa=f[Y+(aa<<4)+8>>2]|0;ba=f[Y+(aa<<4)+12>>2]|0;da=zLc(+(fa|0)*c)|0;ia=zLc(+(ba|0)*c)|0;if((D|0)<(ca-da|0)|(U|0)<(ea-ia|0))break;if((Z|0)>(fa+ca+da|0))break;if((ga|0)>($|0)?(_|0)<=(ba+ea+ia|0):0){ha=aa;break a}}while(0);ga=aa+1|0;if((ga|0)<(j|0))aa=ga;else{ha=ga;break}}}while(0);if((ha|0)==(j|0)){_=f[s>>2]|0;if((_|0)==(f[N>>2]|0))vx(a,n);else{f[_>>2]=D;f[_+4>>2]=U;f[_+8>>2]=V;f[_+12>>2]=W;f[s>>2]=_+16}do if(w){_=f[L>>2]|0;if((_|0)==(f[J>>2]|0)){Tv(d,I);break}else{f[_>>2]=f[I>>2];f[L>>2]=_+4;break}}while(0);if(!H)break;_=f[Q>>2]|0;if((_|0)==(f[C>>2]|0)){xw(e,q);break}else{p[_>>3]=+p[q>>3];f[Q>>2]=_+8;break}}}while(0);W=S+1|0;if((W|0)>=(j|0))break;S=W;T=f[h>>2]|0;z=G;A=O}ja=f[m>>2]|0}else ja=M;if(ja|0){M=f[x>>2]|0;if((M|0)!=(ja|0))f[x>>2]=M+(~((M+-8-ja|0)>>>3)<<3);cYc(ja)}ja=f[l>>2]|0;if(ja|0){l=f[B>>2]|0;if((l|0)!=(ja|0))f[B>>2]=l+(~((l+-4-ja|0)>>>2)<<2);cYc(ja)}ja=f[k>>2]|0;if(ja|0){k=f[y>>2]|0;if((k|0)!=(ja|0))f[y>>2]=k+(~((k+-4-ja|0)>>>2)<<2);cYc(ja)}ja=f[h>>2]|0;if(ja|0){h=f[v>>2]|0;if((h|0)!=(ja|0))f[v>>2]=h+(~((h+-16-ja|0)>>>4)<<4);cYc(ja)}ja=f[i>>2]|0;if(ja|0){i=f[t>>2]|0;if((i|0)!=(ja|0))f[t>>2]=i+(~((i+-4-ja|0)>>>2)<<2);cYc(ja)}u=g;return}if((d|0)==0|(e|0)!=0){u=g;return}e=(f[a+4>>2]|0)-(f[a>>2]|0)>>4;a=d+4|0;ja=f[a>>2]|0;i=f[d>>2]|0;t=ja-i>>2;h=i;i=ja;if(e>>>0<=t>>>0){if(e>>>0<t>>>0?(ja=h+(e<<2)|0,(i|0)!=(ja|0)):0)f[a>>2]=i+(~((i+-4-ja|0)>>>2)<<2);if(!e){u=g;return}}else CS(d,e-t|0);t=f[d>>2]|0;d=0;do{f[t+(d<<2)>>2]=1;d=d+1|0}while((d|0)!=(e|0));u=g;return}function eUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+32|0;g=e+12|0;h=e;i=f[a>>2]|0;j=(f[a+4>>2]|0)-i|0;a=j>>4;k=i;i=j>>3;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;do if(i)if(i>>>0>1073741823)kWc(g);else{m=j>>1;n=$Xc(m)|0;f[g>>2]=n;o=n+(i<<2)|0;f[g+8>>2]=o;g1c(n|0,0,m|0)|0;f[l>>2]=o;q=n;break}else q=0;while(0);i=(j|0)>0;a:do if(i){j=0;do{f[q+(j<<3)>>2]=-1;f[q+(j<<3)+4>>2]=0;j=j+1|0}while((j|0)<(a|0));if(i){j=0;b:while(1){n=j;while(1){o=f[q+(n<<3)>>2]|0;if((o|0)>-1)n=o;else break}o=k+(j<<4)+8|0;m=k+(j<<4)+12|0;r=k+(j<<4)|0;s=k+(j<<4)+4|0;t=q+(j<<3)|0;v=0;w=n;while(1){if(((((j|0)!=(v|0)?(x=f[k+(v<<4)+8>>2]|0,y=f[o>>2]|0,z=f[k+(v<<4)+12>>2]|0,A=f[m>>2]|0,B=+p[d>>3]*+(((A|0)>(z|0)?z:A)+((y|0)>(x|0)?x:y)|0)*.5,C=f[r>>2]|0,D=f[k+(v<<4)>>2]|0,E=C-D|0,+(((E|0)>-1?E:0-E|0)|0)<=B):0)?(E=f[s>>2]|0,F=f[k+(v<<4)+4>>2]|0,G=E-F|0,+(((G|0)>-1?G:0-G|0)|0)<=B):0)?(G=y-x+C-D|0,+(((G|0)>-1?G:0-G|0)|0)<=B):0)?(G=A-z+E-F|0,+(((G|0)>-1?G:0-G|0)|0)<=B):0){G=v;while(1){H=q+(G<<3)|0;F=f[H>>2]|0;if((F|0)>-1)G=F;else break}if((G|0)!=(w|0)){F=f[q+(w<<3)+4>>2]|0;E=q+(G<<3)+4|0;z=f[E>>2]|0;if((F|0)>(z|0)){f[H>>2]=w;I=w}else{f[q+(w<<3)>>2]=G;f[E>>2]=((F|0)==(z|0)&1)+z;I=G}if((f[q+(I<<3)>>2]|0)>=0)break b;z=q+(v<<3)|0;F=f[z>>2]|0;if((F|0)>-1){E=z;z=F;do{f[E>>2]=I;E=q+(z<<3)|0;z=f[E>>2]|0}while((z|0)>-1)}z=f[t>>2]|0;if((z|0)>-1){E=t;G=z;do{f[E>>2]=I;E=q+(G<<3)|0;G=f[E>>2]|0}while((G|0)>-1);J=I}else J=I}else J=w}else J=w;v=v+1|0;if((v|0)>=(a|0))break;else w=J}j=j+1|0;if((j|0)>=(a|0))break a}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=23;w=j;v=468993;t=w+23|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(t|0));b[j+23>>0]=0;vM(-215,h,469017,469027,529)}}while(0);h=c+4|0;J=f[h>>2]|0;I=f[c>>2]|0;H=J-I>>2;k=I;I=J;if(a>>>0<=H>>>0){if(a>>>0<H>>>0?(J=k+(a<<2)|0,(I|0)!=(J|0)):0)f[h>>2]=I+(~((I+-4-J|0)>>>2)<<2)}else CS(c,a-H|0);if(i){i=f[c>>2]|0;c=0;H=0;while(1){J=H;while(1){I=f[q+(J<<3)>>2]|0;if((I|0)>-1)J=I;else break}j=q+(J<<3)+4|0;I=f[j>>2]|0;if((I|0)>-1){h=~c;f[j>>2]=h;K=c+1|0;L=h}else{K=c;L=I}f[i+(H<<2)>>2]=~L;H=H+1|0;if((H|0)>=(a|0)){M=K;break}else c=K}}else M=0;K=f[g>>2]|0;if(!K){u=e;return M|0}g=f[l>>2]|0;if((g|0)!=(K|0))f[l>>2]=g+(~((g+-4-K|0)>>>2)<<2);cYc(K);u=e;return M|0}function fUb(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f[a>>2]=141524;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;n=a+48|0;f[n>>2]=1124007936;o=a+52|0;p=a+56|0;q=a+88|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=a+96|0;s=a+92|0;f[s>>2]=r;f[r>>2]=0;f[a+100>>2]=0;f[a+4>>2]=b;f[a+12>>2]=c;f[a+16>>2]=d;f[a+20>>2]=e;f[a+24>>2]=g;f[a+8>>2]=h;f[a+28>>2]=k?i:0;f[a+32>>2]=k?j:0;if((n|0)==(l|0)){t=a+104|0;f[t>>2]=m;return}j=l+36|0;k=f[j>>2]|0;if(k){i=k+12|0;f[i>>2]=(f[i>>2]|0)+1;i=a+84|0;k=f[i>>2]|0;if((k|0)!=0?(h=k+12|0,k=f[h>>2]|0,f[h>>2]=k+-1,(k|0)==1):0){V$(n);u=i}else u=i}else u=a+84|0;f[u>>2]=0;i=a+64|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[o>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0;v=f[o>>2]|0}while((q|0)<(v|0));f[n>>2]=f[l>>2];if((v|0)<3)w=12;else w=14}else{f[n>>2]=f[l>>2];w=12}if((w|0)==12){v=f[l+4>>2]|0;if((v|0)<3){f[o>>2]=v;f[p>>2]=f[l+8>>2];f[a+60>>2]=f[l+12>>2];p=f[l+44>>2]|0;v=f[s>>2]|0;f[v>>2]=f[p>>2];f[v+4>>2]=f[p+4>>2]}else w=14}if((w|0)==14)U$(n,l);f[i>>2]=f[l+16>>2];f[a+68>>2]=f[l+20>>2];f[a+72>>2]=f[l+24>>2];f[a+76>>2]=f[l+28>>2];f[a+80>>2]=f[l+32>>2];f[u>>2]=f[j>>2];t=a+104|0;f[t>>2]=m;return}function gUb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141524;b=a+48|0;c=a+84|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+64|0;b=a+52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+88>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+92>>2]|0;if((b|0)!=(a+96|0))wL(b);b=f[a+36>>2]|0;if(!b)return;d=a+40|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function hUb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141524;b=a+48|0;c=a+84|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+64|0;b=a+52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+88>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+92>>2]|0;if((b|0)!=(a+96|0))wL(b);b=f[a+36>>2]|0;if(!b){cYc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function iUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;c=u;u=u+48|0;d=c+32|0;e=c;g=c+8|0;h=c+16|0;i=a+4|0;j=f[(f[i>>2]|0)+104>>2]|0;mi[f[(f[j>>2]|0)+12>>2]&2047](d,j);p[e>>3]=0.0;j=f[i>>2]|0;k=f[j+24>>2]|0;l=f[j+28>>2]|0;j=a+12|0;m=f[j>>2]|0;if((m|0)>0){o=a+20|0;q=a+24|0;r=b+4|0;s=+(k|0);t=+(l|0);v=g+4|0;w=a+28|0;x=a+104|0;y=a+8|0;z=h+4|0;A=h+8|0;B=h+12|0;C=h+4|0;D=h+8|0;E=h+12|0;F=a+32|0;a=0;G=m;while(1){m=f[o>>2]|0;H=+n[m+(a*20|0)>>2];I=f[m+(a*20|0)+16>>2]|0;J=f[(f[q>>2]|0)+(a<<2)>>2]|0;K=Y(f[b>>2]|0,J)|0;L=(f[m+(a*20|0)+4>>2]|0)-k|0;M=(L|0)>0;N=M?L:0;L=(f[m+(a*20|0)+8>>2]|0)-l|0;m=(L|0)>0?L:0;L=Y(f[r>>2]|0,J)|0;J=(m|0)<(L|0)?m:L;L=ALc(s*H)|0;m=ALc(t*H)|0;if((K|0)<(J|0)){O=K;do{if(M){P=H*+(O|0);K=0;do{Q=f[i>>2]|0;f[g>>2]=K;f[v>>2]=O;R=jUb(Q,d,g,a,e)|0;if(!(f[w>>2]|0))if((R|0)>0){YXc(f[x>>2]|0);Q=f[y>>2]|0;S=ALc(H*+(K|0))|0;T=ALc(P)|0;f[h>>2]=S;f[z>>2]=T;f[A>>2]=L;f[B>>2]=m;T=Q+4|0;U=f[T>>2]|0;if(U>>>0<(f[Q+8>>2]|0)>>>0){f[U>>2]=S;f[U+4>>2]=f[z>>2];f[U+8>>2]=f[A>>2];f[U+12>>2]=f[B>>2];f[T>>2]=U+16}else TPb(Q,h);ZXc(f[x>>2]|0);V=R}else V=R;else{Q=f[i>>2]|0;if((R|0)==1){U=f[Q+36>>2]|0;T=f[Q+32>>2]|0;W=(U-T|0)/-12|0;X=T;Z=U}else{W=R;X=f[Q+32>>2]|0;Z=f[Q+36>>2]|0}Q=(Z-X|0)/12|0;if((Q|0)==(0-W|0)){YXc(f[x>>2]|0);R=f[y>>2]|0;U=ALc(H*+(K|0))|0;T=ALc(P)|0;f[h>>2]=U;f[C>>2]=T;f[D>>2]=L;f[E>>2]=m;T=R+4|0;S=f[T>>2]|0;if(S>>>0<(f[R+8>>2]|0)>>>0){f[S>>2]=U;f[S+4>>2]=f[C>>2];f[S+8>>2]=f[D>>2];f[S+12>>2]=f[E>>2];f[T>>2]=S+16}else TPb(R,h);R=f[w>>2]|0;f[h>>2]=Q;S=R+4|0;T=f[S>>2]|0;if(T>>>0<(f[R+8>>2]|0)>>>0){f[T>>2]=Q;f[S>>2]=T+4}else LA(R,h);R=f[F>>2]|0;T=R+4|0;S=f[T>>2]|0;if((S|0)==(f[R+8>>2]|0))xw(R,e);else{p[S>>3]=+p[e>>3];f[T>>2]=S+8}ZXc(f[x>>2]|0);V=W}else V=W}K=K+I+((V|0)==0?I:0)|0}while((K|0)<(N|0))}O=O+I|0}while((O|0)<(J|0));_=f[j>>2]|0}else _=G;a=a+1|0;if((a|0)>=(_|0))break;else G=_}}_=f[d+4>>2]|0;if(!_){u=c;return}UXc(_);u=c;return}function jUb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0.0,E=0;g=u;u=u+16|0;h=g;i=f[b>>2]|0;j=f[(f[i>>2]|0)+24>>2]|0;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];if(!(hj[j&511](i,h,d)|0)){k=-1;u=g;return k|0}d=f[a+8>>2]|0;h=(d|0)==0;if((f[a+20>>2]|0)==1){if(h){k=kUb(a,b,e)|0;u=g;return k|0}if((d|0)!=1){k=-2;u=g;return k|0}k=lUb(a,b,e)|0;u=g;return k|0}if(!h){if((d|0)!=1){k=-2;u=g;return k|0}k=mUb(a,b,e)|0;u=g;return k|0}d=f[a+32>>2]|0;h=(f[a+36>>2]|0)-d|0;i=(h|0)/12|0;j=f[b>>2]|0;b=f[a+68>>2]|0;c=f[a+56>>2]|0;l=f[a+44>>2]|0;a=d;if((h|0)>0){m=0;o=0;q=0}else{k=1;u=g;return k|0}while(1){h=f[a+(q*12|0)+4>>2]|0;p[e>>3]=0.0;if((h|0)>0){d=a+(q*12|0)|0;r=0;s=m;t=o;while(1){v=f[d>>2]|0;w=0;do{x=w+s|0;y=+_Sb(j,f[c+(x<<4)>>2]|0);w=f[(y<+n[c+(x<<4)+4>>2]?c+(x<<4)+8|0:c+(x<<4)+12|0)>>2]|0}while((w|0)>0);y=+p[e>>3]+ +n[b+(t-w<<2)>>2];p[e>>3]=y;x=f[l+(v+r<<2)>>2]|0;z=x+s|0;A=t+1+x|0;r=r+1|0;if((r|0)==(h|0)){B=z;C=A;D=y;break}else{s=z;t=A}}}else{B=m;C=o;D=0.0}if(D<+n[a+(q*12|0)+8>>2]){k=0-q|0;E=18;break}q=q+1|0;if((q|0)>=(i|0)){k=1;E=18;break}else{m=B;o=C}}if((E|0)==18){u=g;return k|0}return 0}function kUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0;e=u;u=u+16|0;g=e;h=f[a+92>>2]|0;if((h|0)==(f[a+96>>2]|0)){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=28;j=i;k=469116;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+28>>0]=0;vM(-215,g,469169,468230,575)}g=f[c>>2]|0;c=f[a+32>>2]|0;i=(f[a+36>>2]|0)-c|0;a=(i|0)/12|0;a:do if((i|0)>0){k=h;j=0;while(1){l=f[c+(j*12|0)+4>>2]|0;if((l|0)>0){m=0;o=0.0;while(1){q=+_Sb(g,f[k+(m<<4)>>2]|0);r=o+ +n[(q<+n[k+(m<<4)+4>>2]?k+(m<<4)+8|0:k+(m<<4)+12|0)>>2];m=m+1|0;if((m|0)==(l|0)){s=r;break}else o=r}}else s=0.0;if(s<+n[c+(j*12|0)+8>>2])break;m=j+1|0;if((m|0)<(a|0)){k=k+(l<<4)|0;j=m}else{t=s;break a}}p[d>>3]=s;v=0-j|0;u=e;return v|0}else t=0.0;while(0);p[d>>3]=t;v=1;u=e;return v|0}function lUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0;e=u;u=u+16|0;g=e;h=f[a+92>>2]|0;if((h|0)==(f[a+96>>2]|0)){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=28;j=i;k=469116;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+28>>0]=0;vM(-215,g,469145,468230,614)}g=f[a+32>>2]|0;i=(f[a+36>>2]|0)-g|0;k=(i|0)/12|0;j=f[c>>2]|0;c=((f[a+12>>2]|0)+31|0)/32|0;l=g;a:do if((i|0)>0){g=j+380|0;m=j+384|0;o=f[a+80>>2]|0;q=h;r=0;while(1){s=f[l+(r*12|0)+4>>2]|0;if((s|0)>0){t=f[g>>2]|0;v=f[m>>2]|0;w=0;x=0.0;while(1){y=f[q+(w<<4)>>2]|0;z=f[v+(f[t+(y<<6)+20>>2]<<2)>>2]|0;A=f[v+(f[t+(y<<6)+24>>2]<<2)>>2]|0;B=f[v+(f[t+(y<<6)+36>>2]<<2)>>2]|0;C=f[v+(f[t+(y<<6)+40>>2]<<2)>>2]|0;D=z-A-B+C|0;E=f[v+(f[t+(y<<6)+4>>2]<<2)>>2]|0;F=f[v+(f[t+(y<<6)+16>>2]<<2)>>2]|0;G=f[v+(f[t+(y<<6)+8>>2]<<2)>>2]|0;H=f[v+(f[t+(y<<6)+28>>2]<<2)>>2]|0;I=f[v+(f[t+(y<<6)+44>>2]<<2)>>2]|0;J=f[v+(f[t+(y<<6)+56>>2]<<2)>>2]|0;K=f[v+(f[t+(y<<6)+52>>2]<<2)>>2]|0;L=f[v+(f[t+(y<<6)+32>>2]<<2)>>2]|0;M=o+((Y(w,c)|0)<<2)+((((A-z+E-G|0)>=(D|0)?2:0)|(((f[v+(f[t+(y<<6)>>2]<<2)>>2]|0)+z-E-F|0)>=(D|0)?4:0)|(G-A-(f[v+(f[t+(y<<6)+12>>2]<<2)>>2]|0)+H|0)>=(D|0))<<2)|0;N=x+ +n[(1<<(((C-I-J+(f[v+(f[t+(y<<6)+60>>2]<<2)>>2]|0)|0)>=(D|0)?8:0)|((A-C-H+I|0)>=(D|0)?16:0)|((B-C+J-K|0)>=(D|0)?4:0)|(B-z+F-L|0)>=(D|0)|((K-B+L-(f[v+(f[t+(y<<6)+48>>2]<<2)>>2]|0)|0)>=(D|0)?2:0))&f[M>>2]|0?q+(w<<4)+8|0:q+(w<<4)+12|0)>>2];w=w+1|0;if((w|0)==(s|0)){O=N;break}else x=N}}else O=0.0;if(O<+n[l+(r*12|0)+8>>2])break;o=o+((Y(s,c)|0)<<2)|0;w=r+1|0;if((w|0)>=(k|0)){P=O;break a}else{q=q+(s<<4)|0;r=w}}p[d>>3]=O;Q=0-r|0;u=e;return Q|0}else P=0.0;while(0);p[d>>3]=P;Q=1;u=e;return Q|0}function mUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0;d=f[a+32>>2]|0;e=(f[a+36>>2]|0)-d|0;g=(e|0)/12|0;h=f[b>>2]|0;b=((f[a+12>>2]|0)+31|0)/32|0;i=f[a+80>>2]|0;j=f[a+68>>2]|0;k=f[a+56>>2]|0;l=f[a+44>>2]|0;a=d;if((e|0)<=0){m=1;return m|0}e=h+380|0;d=h+384|0;h=0;o=0;q=0;while(1){r=f[a+(q*12|0)+4>>2]|0;if((r|0)>0){s=f[a+(q*12|0)>>2]|0;t=f[e>>2]|0;u=f[d>>2]|0;v=0;w=h;x=o;y=0.0;while(1){z=0;do{A=z+w|0;B=f[k+(A<<4)>>2]|0;C=f[u+(f[t+(B<<6)+20>>2]<<2)>>2]|0;D=f[u+(f[t+(B<<6)+24>>2]<<2)>>2]|0;E=f[u+(f[t+(B<<6)+36>>2]<<2)>>2]|0;F=f[u+(f[t+(B<<6)+40>>2]<<2)>>2]|0;G=C-D-E+F|0;H=f[u+(f[t+(B<<6)+4>>2]<<2)>>2]|0;I=f[u+(f[t+(B<<6)+16>>2]<<2)>>2]|0;J=f[u+(f[t+(B<<6)+8>>2]<<2)>>2]|0;K=f[u+(f[t+(B<<6)+28>>2]<<2)>>2]|0;L=f[u+(f[t+(B<<6)+44>>2]<<2)>>2]|0;M=f[u+(f[t+(B<<6)+56>>2]<<2)>>2]|0;N=f[u+(f[t+(B<<6)+52>>2]<<2)>>2]|0;O=f[u+(f[t+(B<<6)+32>>2]<<2)>>2]|0;P=i+((Y(A,b)|0)<<2)+((((D-C+H-J|0)>=(G|0)?2:0)|(((f[u+(f[t+(B<<6)>>2]<<2)>>2]|0)+C-H-I|0)>=(G|0)?4:0)|(J-D-(f[u+(f[t+(B<<6)+12>>2]<<2)>>2]|0)+K|0)>=(G|0))<<2)|0;z=f[(1<<(((F-L-M+(f[u+(f[t+(B<<6)+60>>2]<<2)>>2]|0)|0)>=(G|0)?8:0)|((D-F-K+L|0)>=(G|0)?16:0)|((E-F+M-N|0)>=(G|0)?4:0)|(E-C+I-O|0)>=(G|0)|((N-E+O-(f[u+(f[t+(B<<6)+48>>2]<<2)>>2]|0)|0)>=(G|0)?2:0))&f[P>>2]|0?k+(A<<4)+8|0:k+(A<<4)+12|0)>>2]|0}while((z|0)>0);Q=y+ +n[j+(x-z<<2)>>2];A=f[l+(s+v<<2)>>2]|0;P=A+w|0;G=x+1+A|0;v=v+1|0;if((v|0)==(r|0)){R=P;S=G;T=Q;break}else{w=P;x=G;y=Q}}}else{R=h;S=o;T=0.0}if(T<+n[a+(q*12|0)+8>>2]){U=0-q|0;break}q=q+1|0;if((q|0)>=(g|0)){U=1;break}else{h=R;o=S}}p[c>>3]=T;m=U;return m|0}function nUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];c=a+28|0;d=b+28|0;e=f[c>>2]|0;g=a+32|0;if(!e)h=a+36|0;else{i=f[g>>2]|0;if((i|0)!=(e|0))f[g>>2]=i+(~(((i+-12-e|0)>>>0)/12|0)*12|0);cYc(e);e=a+36|0;f[e>>2]=0;f[g>>2]=0;f[c>>2]=0;h=e}f[c>>2]=f[d>>2];c=b+32|0;f[g>>2]=f[c>>2];g=b+36|0;f[h>>2]=f[g>>2];f[g>>2]=0;f[c>>2]=0;f[d>>2]=0;d=a+40|0;c=b+40|0;g=f[d>>2]|0;h=a+44|0;if(!g)j=a+48|0;else{e=f[h>>2]|0;if((e|0)!=(g|0))f[h>>2]=e+(~((e+-4-g|0)>>>2)<<2);cYc(g);g=a+48|0;f[g>>2]=0;f[h>>2]=0;f[d>>2]=0;j=g}f[d>>2]=f[c>>2];d=b+44|0;f[h>>2]=f[d>>2];h=b+48|0;f[j>>2]=f[h>>2];f[h>>2]=0;f[d>>2]=0;f[c>>2]=0;c=a+52|0;d=b+52|0;h=f[c>>2]|0;j=a+56|0;if(!h)k=a+60|0;else{g=f[j>>2]|0;if((g|0)!=(h|0))f[j>>2]=g+(~((g+-16-h|0)>>>4)<<4);cYc(h);h=a+60|0;f[h>>2]=0;f[j>>2]=0;f[c>>2]=0;k=h}f[c>>2]=f[d>>2];c=b+56|0;f[j>>2]=f[c>>2];j=b+60|0;f[k>>2]=f[j>>2];f[j>>2]=0;f[c>>2]=0;f[d>>2]=0;d=a+64|0;c=b+64|0;j=f[d>>2]|0;k=a+68|0;if(!j)l=a+72|0;else{h=f[k>>2]|0;if((h|0)!=(j|0))f[k>>2]=h+(~((h+-4-j|0)>>>2)<<2);cYc(j);j=a+72|0;f[j>>2]=0;f[k>>2]=0;f[d>>2]=0;l=j}f[d>>2]=f[c>>2];d=b+68|0;f[k>>2]=f[d>>2];k=b+72|0;f[l>>2]=f[k>>2];f[k>>2]=0;f[d>>2]=0;f[c>>2]=0;c=a+76|0;d=b+76|0;k=f[c>>2]|0;l=a+80|0;if(!k)m=a+84|0;else{j=f[l>>2]|0;if((j|0)!=(k|0))f[l>>2]=j+(~((j+-4-k|0)>>>2)<<2);cYc(k);k=a+84|0;f[k>>2]=0;f[l>>2]=0;f[c>>2]=0;m=k}f[c>>2]=f[d>>2];c=b+80|0;f[l>>2]=f[c>>2];l=b+84|0;f[m>>2]=f[l>>2];f[l>>2]=0;f[c>>2]=0;f[d>>2]=0;d=a+88|0;c=b+88|0;l=f[d>>2]|0;m=a+92|0;if(!l){n=a+96|0;o=f[c>>2]|0;f[d>>2]=o;p=b+92|0;q=f[p>>2]|0;f[m>>2]=q;r=b+96|0;s=f[r>>2]|0;f[n>>2]=s;f[r>>2]=0;f[p>>2]=0;f[c>>2]=0;return a|0}k=f[m>>2]|0;if((k|0)!=(l|0))f[m>>2]=k+(~((k+-16-l|0)>>>4)<<4);cYc(l);l=a+96|0;f[l>>2]=0;f[m>>2]=0;f[d>>2]=0;n=l;o=f[c>>2]|0;f[d>>2]=o;p=b+92|0;q=f[p>>2]|0;f[m>>2]=q;r=b+96|0;s=f[r>>2]|0;f[n>>2]=s;f[r>>2]=0;f[p>>2]=0;f[c>>2]=0;return a|0}function oUb(a){a=a|0;var b=0,c=0,d=0;b=f[a+88>>2]|0;if(b|0){c=a+92|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);cYc(b)}b=f[a+76>>2]|0;if(b|0){d=a+80|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+64>>2]|0;if(b|0){c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+52>>2]|0;if(b|0){d=a+56|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-16-b|0)>>>4)<<4);cYc(b)}b=f[a+40>>2]|0;if(b|0){c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+28>>2]|0;if(!b)return;d=a+32|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~(((a+-12-b|0)>>>0)/12|0)*12|0);cYc(b);return}function pUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c+8|0;e=c;g=a+224|0;h=a+248|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)FQ(g);g=a+228|0;if((f[g>>2]|0)>0){i=f[a+256>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;h=a+272|0;g=a+296|0;j=f[g>>2]|0;if(j|0?(i=j+8|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)FQ(h);h=a+276|0;if((f[h>>2]|0)>0){j=f[a+304>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}f[g>>2]=0;g=a+320|0;h=a+344|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)FQ(g);g=a+324|0;if((f[g>>2]|0)>0){i=f[a+352>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;if(!(qUb(a+4|0,b)|0)){k=0;u=c;return k|0}rUb(d,f[a+8>>2]|0);h=a+104|0;g=f[d>>2]|0;j=f[d+4>>2]|0;i=(j|0)==0;if(!i)TXc(j);f[h>>2]=g;g=a+108|0;l=f[g>>2]|0;f[g>>2]=j;if(l|0)UXc(l);if(!i)UXc(j);i5(d,b,469263);if(G5(d)|0)m=0;else{b=f[h>>2]|0;h=f[(f[b>>2]|0)+8>>2]|0;f[e>>2]=f[a+24>>2];f[e+4>>2]=f[a+28>>2];m=hj[h&511](b,d,e)|0}k=m;u=c;return k|0}function qUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;d=u;u=u+464|0;e=d+440|0;g=d+416|0;h=d+428|0;i=d+392|0;j=d+404|0;k=d+356|0;l=d+344|0;m=d+304|0;o=d+368|0;p=d+320|0;q=d+288|0;r=d+272|0;s=d+208|0;t=d+248|0;v=d+224|0;w=d+196|0;x=d+184|0;y=d+172|0;z=d+168|0;A=d+144|0;B=d+120|0;C=d+96|0;D=d+60|0;E=d+48|0;F=d+36|0;G=d+72|0;H=d+24|0;I=d+12|0;J=d;i5(g,c,471002);H4(e,g);g=e+11|0;K=b[g>>0]|0;if(((K<<24>>24<0?f[e+4>>2]|0:K&255)|0)==5?(LYc(e,0,-1,471012,5)|0)==0:0){f[a>>2]=0;i5(i,c,471018);H4(h,i);i=h+11|0;K=b[i>>0]|0;L=h+4|0;M=f[L>>2]|0;if(((K<<24>>24<0?M:K&255)|0)==4)if(!(LYc(h,0,-1,469560,4)|0)){N=0;O=12}else{P=b[i>>0]|0;Q=f[L>>2]|0;O=6}else{P=K;Q=M;O=6}do if((O|0)==6){if(((P<<24>>24<0?Q:P&255)|0)==3){if(!(LYc(h,0,-1,469565,3)|0)){N=1;O=12;break}R=b[i>>0]|0;S=f[L>>2]|0}else{R=P;S=Q}if(((R<<24>>24<0?S:R&255)|0)==3?(LYc(h,0,-1,469569,3)|0)==0:0){f[a+4>>2]=2;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;M=$Xc(48)|0;f[j>>2]=M;f[j+8>>2]=-2147483600;f[j+4>>2]=35;T=M;U=469573;V=T+35|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));b[M+35>>0]=0;vM(-213,j,473221,468086,1436)}else W=0}while(0);if((O|0)==12){f[a+4>>2]=N;i5(k,c,471037);N=H5(k)|0;k=a+20|0;f[k>>2]=N;i5(l,c,471030);N=H5(l)|0;f[a+24>>2]=N;if((N|0)<=0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;X=$Xc(48)|0;f[j>>2]=X;Z=j+8|0;f[Z>>2]=-2147483600;_=j+4|0;f[_>>2]=47;T=X;U=469609;V=T+47|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));$=X+47|0;b[$>>0]=0;vM(-215,j,473221,468086,1443)}if((f[k>>2]|0)<=0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;X=$Xc(48)|0;f[j>>2]=X;Z=j+8|0;f[Z>>2]=-2147483600;_=j+4|0;f[_>>2]=47;T=X;U=469609;V=T+47|0;do{b[T>>0]=b[U>>0]|0;T=T+1|0;U=U+1|0}while((T|0)<(V|0));$=X+47|0;b[$>>0]=0;vM(-215,j,473221,468086,1443)}i5(j,c,471068);if(!(G5(j)|0)?(i5(m,j,471082),$=H5(m)|0,f[a+8>>2]=$,m=($+31|0)/32|0,X=($|0)>0,$=X?m+3|0:4,i5(o,c,470872),f[j>>2]=f[o>>2],f[j+4>>2]=f[o+4>>2],f[j+8>>2]=f[o+8>>2],!(G5(j)|0)):0){c=a+28|0;AUb(c,w5(j)|0);U=a+40|0;T=f[U>>2]|0;V=a+44|0;_=f[V>>2]|0;if((_|0)!=(T|0))f[V>>2]=_+(~((_+-4-T|0)>>>2)<<2);T=a+52|0;_=f[T>>2]|0;Z=a+56|0;k=f[Z>>2]|0;if((k|0)!=(_|0))f[Z>>2]=k+(~((k+-16-_|0)>>>4)<<4);_=a+88|0;k=f[_>>2]|0;N=a+92|0;l=f[N>>2]|0;if((l|0)!=(k|0))f[N>>2]=l+(~((l+-16-k|0)>>>4)<<4);d5(o,j);f5(p,j);j=a+12|0;f[j>>2]=2147483647;k=a+16|0;f[k>>2]=0;l=r+8|0;R=r+4|0;S=a+32|0;Q=a+36|0;P=a+48|0;L=a+64|0;K=a+68|0;aa=a+76|0;ba=a+80|0;ca=C+8|0;da=C+12|0;ea=a+60|0;fa=C+4|0;ga=a+84|0;ha=a+72|0;ia=0;a:while(1){if(!(e5(o,p)|0)){O=65;break}g5(q,o);i5(s,q,471094);ja=+I5(s)+-9.999999747378752e-06;n[l>>2]=ja;i5(t,q,471109);f[q>>2]=f[t>>2];f[q+4>>2]=f[t+4>>2];f[q+8>>2]=f[t+8>>2];if(G5(q)|0){O=26;break}ka=w5(q)|0;f[R>>2]=ka;f[r>>2]=(f[V>>2]|0)-(f[U>>2]|0)>>2;ka=f[S>>2]|0;if((ka|0)==(f[Q>>2]|0))BUb(c,r);else{f[ka>>2]=f[r>>2];f[ka+4>>2]=f[r+4>>2];f[ka+8>>2]=f[r+8>>2];f[S>>2]=(f[S>>2]|0)+12}ka=f[c>>2]|0;CUb(U,(f[ka+(ia*12|0)+4>>2]|0)+(f[ka+(ia*12|0)>>2]|0)|0);d5(t,q);f5(v,q);while(1){if(!(e5(t,v)|0))break;g5(w,t);i5(x,w,471125);i5(y,w,471139);if(G5(x)|0){O=63;break a}if(G5(y)|0){O=63;break a}ka=(w5(x)|0)/($|0)|0;f[z>>2]=ka;la=f[j>>2]|0;f[j>>2]=(ka|0)<(la|0)?ka:la;la=f[k>>2]|0;f[k>>2]=(la|0)<(ka|0)?ka:la;la=f[V>>2]|0;if((la|0)==(f[P>>2]|0))DUb(U,z);else{f[la>>2]=ka;f[V>>2]=la+4}EUb(T,((f[Z>>2]|0)-(f[T>>2]|0)>>4)+(f[z>>2]|0)|0);la=f[K>>2]|0;ka=f[L>>2]|0;mvb(L,(la-ka>>2)+(w5(y)|0)|0);b:do if(X){cKa(aa,((f[ba>>2]|0)-(f[aa>>2]|0)>>2)+(Y(f[z>>2]|0,m)|0)|0);d5(A,x);f5(B,x);while(1){if(!(e5(A,B)|0))break b;g5(D,A);ka=H5(D)|0;f[ca>>2]=ka;x5(A)|0;g5(E,A);ka=H5(E)|0;f[da>>2]=ka;x5(A)|0;g5(F,A);ka=H5(F)|0;f[C>>2]=ka;x5(A)|0;ka=0;while(1){if((ka|0)>=(m|0))break;g5(H,A);la=H5(H)|0;f[G>>2]=la;ma=f[ba>>2]|0;if(ma>>>0<(f[ga>>2]|0)>>>0){f[ma>>2]=la;f[ba>>2]=ma+4}else LA(aa,G);x5(A)|0;ka=ka+1|0}n[fa>>2]=0.0;ka=f[Z>>2]|0;if((ka|0)==(f[ea>>2]|0))FUb(T,C);else{f[ka>>2]=f[C>>2];f[ka+4>>2]=f[C+4>>2];f[ka+8>>2]=f[C+8>>2];f[ka+12>>2]=f[C+12>>2];f[Z>>2]=(f[Z>>2]|0)+16}}}else{d5(A,x);f5(B,x);while(1){if(!(e5(A,B)|0))break b;g5(D,A);ka=H5(D)|0;f[ca>>2]=ka;x5(A)|0;g5(E,A);ka=H5(E)|0;f[da>>2]=ka;x5(A)|0;g5(F,A);ka=H5(F)|0;f[C>>2]=ka;x5(A)|0;g5(I,A);ja=+I5(I);n[fa>>2]=ja;x5(A)|0;ka=f[Z>>2]|0;if((ka|0)==(f[ea>>2]|0))FUb(T,C);else{f[ka>>2]=f[C>>2];f[ka+4>>2]=f[C+4>>2];f[ka+8>>2]=f[C+8>>2];f[ka+12>>2]=f[C+12>>2];f[Z>>2]=(f[Z>>2]|0)+16}}}while(0);d5(C,y);f[A>>2]=f[C>>2];f[A+4>>2]=f[C+4>>2];f[A+8>>2]=f[C+8>>2];f[A+12>>2]=f[C+12>>2];f[A+16>>2]=f[C+16>>2];f[A+20>>2]=f[C+20>>2];f5(G,y);f[B>>2]=f[G>>2];f[B+4>>2]=f[G+4>>2];f[B+8>>2]=f[G+8>>2];f[B+12>>2]=f[G+12>>2];f[B+16>>2]=f[G+16>>2];f[B+20>>2]=f[G+20>>2];while(1){if(!(e5(A,B)|0))break;g5(J,A);ja=+I5(J);n[C>>2]=ja;ka=f[K>>2]|0;if(ka>>>0<(f[ha>>2]|0)>>>0){n[ka>>2]=ja;f[K>>2]=ka+4}else MA(L,C);x5(A)|0}x5(t)|0}x5(o)|0;ia=ia+1|0}c:do if((O|0)==26)na=0;else if((O|0)==63)na=0;else if((O|0)==65)if((f[k>>2]|0)==1?(ia=f[c>>2]|0,o=(f[S>>2]|0)-ia|0,t=(o|0)/12|0,(o|0)!=0):0){o=a+64|0;A=q+4|0;C=q+8|0;L=q+12|0;K=a+96|0;ha=0;J=0;B=0;G=ia;while(1){ia=f[G+(B*12|0)+4>>2]|0;if((ia|0)>0){y=0;Z=ha;ea=J;while(1){fa=f[T>>2]|0;I=f[fa+(ea<<4)+4>>2]|0;F=f[o>>2]|0;da=f[F+(Z<<2)>>2]|0;E=f[F+(Z+1<<2)>>2]|0;f[q>>2]=f[fa+(ea<<4)>>2];f[A>>2]=I;f[C>>2]=da;f[L>>2]=E;E=f[N>>2]|0;if(E>>>0<(f[K>>2]|0)>>>0){f[E>>2]=f[q>>2];f[E+4>>2]=f[q+4>>2];f[E+8>>2]=f[q+8>>2];f[E+12>>2]=f[q+12>>2];f[N>>2]=(f[N>>2]|0)+16}else GUb(_,q);y=y+1|0;E=ea+1|0;da=Z+2|0;if((y|0)>=(ia|0)){oa=da;pa=E;break}else{Z=da;ea=E}}}else{oa=ha;pa=J}ea=B+1|0;if(ea>>>0>=t>>>0){na=1;break c}ha=oa;J=pa;B=ea;G=f[c>>2]|0}}else na=1;while(0);qa=na}else qa=0;W=qa}if((b[i>>0]|0)<0)cYc(f[h>>2]|0);ra=W}else ra=0;if((b[g>>0]|0)>=0){u=d;return ra|0}cYc(f[e>>2]|0);u=d;return ra|0}function rUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;switch(c|0){case 0:{c=$Xc(436)|0;d=c+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c+44>>2]=1124007936;d=c+52|0;e=c+84|0;g=c+48|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+92|0;f[c+88>>2]=d;f[d>>2]=0;f[c+96>>2]=0;f[c+100>>2]=1124007936;d=c+108|0;e=c+140|0;g=c+104|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+148|0;f[c+144>>2]=d;f[d>>2]=0;f[c+152>>2]=0;f[c+156>>2]=1124007936;d=c+160|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+188>>2]=c+164;d=c+196|0;f[c+192>>2]=d;f[c+200>>2]=0;f[d>>2]=0;f[c+204>>2]=1124007936;d=c+208|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+236>>2]=c+212;d=c+244|0;f[c+240>>2]=d;f[c+248>>2]=0;f[d>>2]=0;f[c+252>>2]=1124007936;d=c+256|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+284>>2]=c+260;d=c+292|0;f[c+288>>2]=d;f[c+296>>2]=0;f[d>>2]=0;f[c+300>>2]=1124007936;d=c+304|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+332>>2]=c+308;d=c+340|0;f[c+336>>2]=d;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c>>2]=141156;d=c+356|0;e=c+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;g=c+392|0;h=g+40|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=4;f[c+28>>2]=2;f[c+32>>2]=0;f[c+36>>2]=0;f[c+40>>2]=0;f[c+384>>2]=0;f[c+388>>2]=0;n[c+432>>2]=0.0;b[c+380>>0]=0;f[a>>2]=c;e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=141544;f[e+12>>2]=c;f[a+4>>2]=e;return}case 1:{e=$Xc(388)|0;ATb(e);f[a>>2]=e;c=$Xc(16)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=141572;f[c+12>>2]=e;f[a+4>>2]=c;return}default:{f[a>>2]=0;f[a+4>>2]=0;return}}}function sUb(a){a=a|0;NXc(a);cYc(a);return}function tUb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function uUb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==469272?a+12|0:0)|0}function vUb(a){a=a|0;cYc(a);return}function wUb(a){a=a|0;NXc(a);cYc(a);return}function xUb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function yUb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==469415?a+12|0:0)|0}function zUb(a){a=a|0;cYc(a);return}function AUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/12|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>357913941){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=$Xc(b*12|0)|0;i=h+(((g|0)/12|0)*12|0)|0;j=i+(((g|0)/-12|0)*12|0)|0;if((g|0)>0)o1c(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*12|0);if(!d)return;cYc(d);return}function BUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)kWc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;cYc(d);return}function CUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>2;i=$Xc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;cYc(d);return}function DUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function EUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>4;i=$Xc(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;cYc(d);return}function FUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;cYc(d);return}function GUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;cYc(d);return}function HUb(a,b,c){a=a|0;b=b|0;c=+c;dUb(a,b,c,0,0);return}function IUb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;dUb(a,c,d,b,0);return}function JUb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0;g=u;u=u+176|0;h=g+164|0;i=g+152|0;j=g+140|0;k=g+128|0;l=g+88|0;m=g;n=g+112|0;o=f[e>>2]|0;q=f[e+4>>2]|0;e=a+4|0;r=f[e>>2]|0;s=f[a>>2]|0;t=r-s|0;v=t>>4;f[h>>2]=0;w=h+4|0;f[w>>2]=0;f[h+8>>2]=0;x=(v|0)==0;y=s;z=r;do if(!x)if(v>>>0>178956970)kWc(h);else{r=v*24|0;A=$Xc(r)|0;f[h>>2]=A;f[h+8>>2]=A+(v*24|0);g1c(A|0,0,r|0)|0;f[w>>2]=A+r;B=A;break}else B=0;while(0);f[i>>2]=0;A=i+4|0;f[A>>2]=0;f[i+8>>2]=0;f[j>>2]=0;r=j+4|0;f[r>>2]=0;f[j+8>>2]=0;if(x)C=0;else{x=t>>1;D=$Xc(x)|0;f[j>>2]=D;E=D+(v<<3)|0;f[j+8>>2]=E;g1c(D|0,0,x|0)|0;f[r>>2]=E;C=D}f[k>>2]=0;D=k+4|0;f[D>>2]=0;f[k+8>>2]=0;if((t|0)>0){t=f[b>>2]|0;E=f[c>>2]|0;c=0;do{p[C+(c<<3)>>3]=+p[t+(c<<3)>>3];x=(f[y+(c<<4)+12>>2]|0)+(f[y+(c<<4)+4>>2]<<1)|0;F=zLc(+((f[y+(c<<4)+8>>2]|0)+(f[y+(c<<4)>>2]<<1)|0)*.5)|0;G=+(zLc(+(x|0)*.5)|0);H=+W(+(+p[E+(c<<3)>>3]));p[B+(c*24|0)>>3]=+(F|0);p[B+(c*24|0)+8>>3]=G;p[B+(c*24|0)+16>>3]=H;c=c+1|0}while((c|0)<(v|0))}if((z|0)!=(y|0))f[e>>2]=z+(~((z+-16-s|0)>>>4)<<4);s=f[b>>2]|0;z=b+4|0;y=f[z>>2]|0;if((y|0)!=(s|0))f[z>>2]=y+(~((y+-8-s|0)>>>3)<<3);p[l>>3]=8.0;p[l+8>>3]=16.0;p[l+16>>3]=.26236426446749106;KUb(m,l,h,j,1.0e-05,100);LUb(m,i,k,1.0);l=f[i>>2]|0;if((f[A>>2]|0)!=(l|0)){s=n+4|0;y=n+8|0;v=n+12|0;c=a+8|0;B=b+8|0;H=+(o|0);G=+(q|0);q=0;o=l;do{l=o;I=+V(+(+p[l+(q*24|0)+16>>3]));E=~~(H*I);t=~~(G*I);C=~~(+p[l+(q*24|0)>>3]-+((E|0)/2|0|0));F=~~(+p[l+(q*24|0)+8>>3]-+((t|0)/2|0|0));f[n>>2]=C;f[s>>2]=F;f[y>>2]=E;f[v>>2]=t;l=f[k>>2]|0;do if(+p[l+(q<<3)>>3]>d){x=f[e>>2]|0;if((x|0)==(f[c>>2]|0)){vx(a,n);J=f[k>>2]|0}else{f[x>>2]=C;f[x+4>>2]=F;f[x+8>>2]=E;f[x+12>>2]=t;f[e>>2]=x+16;J=l}x=J+(q<<3)|0;K=f[z>>2]|0;if((K|0)==(f[B>>2]|0)){xw(b,x);break}else{p[K>>3]=+p[x>>3];f[z>>2]=K+8;break}}while(0);q=q+1|0;o=f[i>>2]|0}while(q>>>0<(((f[A>>2]|0)-o|0)/24|0)>>>0)}o=f[m+64>>2]|0;if(o|0){q=m+68|0;z=f[q>>2]|0;if((z|0)!=(o|0))f[q>>2]=z+(~(((z+-24-o|0)>>>0)/24|0)*24|0);cYc(o)}o=f[m+52>>2]|0;if(o|0){z=m+56|0;q=f[z>>2]|0;if((q|0)!=(o|0))f[z>>2]=q+(~(((q+-24-o|0)>>>0)/24|0)*24|0);cYc(o)}o=f[m+12>>2]|0;if(o|0){q=m+16|0;z=f[q>>2]|0;if((z|0)!=(o|0))f[q>>2]=z+(~((z+-8-o|0)>>>3)<<3);cYc(o)}o=f[m>>2]|0;if(o|0){z=m+4|0;m=f[z>>2]|0;if((m|0)!=(o|0))f[z>>2]=m+(~(((m+-24-o|0)>>>0)/24|0)*24|0);cYc(o)}o=f[k>>2]|0;if(o|0){k=f[D>>2]|0;if((k|0)!=(o|0))f[D>>2]=k+(~((k+-8-o|0)>>>3)<<3);cYc(o)}o=f[j>>2]|0;if(o|0){j=f[r>>2]|0;if((j|0)!=(o|0))f[r>>2]=j+(~((j+-8-o|0)>>>3)<<3);cYc(o)}o=f[i>>2]|0;if(o|0){i=f[A>>2]|0;if((i|0)!=(o|0))f[A>>2]=i+(~(((i+-24-o|0)>>>0)/24|0)*24|0);cYc(o)}o=f[h>>2]|0;if(!o){u=g;return}h=f[w>>2]|0;if((h|0)!=(o|0))f[w>>2]=h+(~(((h+-24-o|0)>>>0)/24|0)*24|0);cYc(o);u=g;return}function KUb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0;h=u;u=u+48|0;i=h+24|0;j=h;k=a+4|0;l=a+12|0;m=a+52|0;n=a+56|0;o=a+64|0;q=a+68|0;r=a;s=r+48|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;p[a+24>>3]=+p[b>>3];r=a+32|0;p[r>>3]=+p[b+8>>3];s=a+40|0;p[s>>3]=+p[b+16>>3];if((l|0)!=(d|0))OUb(l,f[d>>2]|0,f[d+4>>2]|0);if((a|0)==(c|0))t=c+4|0;else{d=c+4|0;PUb(a,f[c>>2]|0,f[d>>2]|0);t=d}d=((f[t>>2]|0)-(f[c>>2]|0)|0)/24|0;c=a+48|0;f[c>>2]=d;t=f[n>>2]|0;l=f[m>>2]|0;b=(t-l|0)/24|0;v=l;l=t;if(d>>>0<=b>>>0)if(d>>>0<b>>>0?(t=v+(d*24|0)|0,(l|0)!=(t|0)):0){f[n>>2]=l+(~(((l+-24-t|0)>>>0)/24|0)*24|0);w=d}else w=d;else{QUb(m,d-b|0);w=f[c>>2]|0}c=f[q>>2]|0;b=f[o>>2]|0;d=(c-b|0)/24|0;t=b;b=c;if(w>>>0<=d>>>0){if(w>>>0<d>>>0?(c=t+(w*24|0)|0,(b|0)!=(c|0)):0)f[q>>2]=b+(~(((b+-24-c|0)>>>0)/24|0)*24|0)}else QUb(o,w-d|0);d=a+76|0;f[d>>2]=g;g=a+80|0;p[g>>3]=e;w=f[a>>2]|0;if((f[k>>2]|0)==(w|0)){u=h;return}c=i+8|0;b=i+16|0;q=i+8|0;t=i+16|0;l=j+8|0;n=j+16|0;v=a+24|0;x=0;y=w;do{RUb(i,a,y+(x*24|0)|0);w=f[m>>2]|0;z=w+(x*24|0)|0;p[z>>3]=+p[i>>3];A=w+(x*24|0)+8|0;p[A>>3]=+p[c>>3];B=w+(x*24|0)+16|0;p[B>>3]=+p[b>>3];e=+p[z>>3];C=+p[A>>3];D=+p[B>>3];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;if((f[d>>2]|0)>0){B=0;E=D;F=e;G=C;do{p[i>>3]=F;p[q>>3]=G;p[t>>3]=E;RUb(j,a,i);F=+p[j>>3];G=+p[l>>3];E=+p[n>>3];H=+p[t>>3];I=+V(+H);J=(+p[i>>3]-F)/(+p[v>>3]*I);K=(+p[q>>3]-G)/(+p[r>>3]*I);I=(H-E)/+p[s>>3];B=B+1|0;if(I*I+(K*K+J*J)<=+p[g>>3])break}while((B|0)<(f[d>>2]|0));L=F;M=G;N=E;O=f[m>>2]|0}else{L=e;M=C;N=D;O=w}B=f[o>>2]|0;p[B+(x*24|0)>>3]=L;p[B+(x*24|0)+8>>3]=M;p[B+(x*24|0)+16>>3]=N;y=f[a>>2]|0;J=+p[y+(x*24|0)+8>>3];K=+p[y+(x*24|0)+16>>3];B=O+(x*24|0)|0;p[B>>3]=+p[B>>3]-+p[y+(x*24|0)>>3];B=O+(x*24|0)+8|0;p[B>>3]=+p[B>>3]-J;B=O+(x*24|0)+16|0;p[B>>3]=+p[B>>3]-K;x=x+1|0}while(x>>>0<(((f[k>>2]|0)-y|0)/24|0)>>>0);u=h;return}function LUb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0;e=a+64|0;g=a+68|0;h=f[e>>2]|0;i=b+4|0;if((f[g>>2]|0)!=(h|0)){j=b+8|0;k=a+24|0;l=a+32|0;m=a+40|0;n=0;o=h;while(1){h=o;q=f[i>>2]|0;r=f[b>>2]|0;s=r;t=q;a:do if((q|0)==(r|0))u=14;else{v=+p[k>>3];w=+p[l>>3];x=+p[m>>3];y=(q-r|0)/24|0;z=+p[h+(n*24|0)>>3];A=+p[h+(n*24|0)+8>>3];B=+p[h+(n*24|0)+16>>3];C=0;while(1){D=+p[s+(C*24|0)+16>>3];E=+V(+D);F=(+p[s+(C*24|0)>>3]-z)/(v*E);G=(+p[s+(C*24|0)+8>>3]-A)/(w*E);E=(D-B)/x;C=C+1|0;if(E*E+(G*G+F*F)<d){H=o;break a}if(C>>>0>=y>>>0){u=14;break}}}while(0);do if((u|0)==14){u=0;s=h+(n*24|0)|0;if((t|0)==(f[j>>2]|0)){MUb(b,s);H=f[e>>2]|0;break}else{p[t>>3]=+p[s>>3];p[t+8>>3]=+p[h+(n*24|0)+8>>3];p[t+16>>3]=+p[h+(n*24|0)+16>>3];f[i>>2]=t+24;H=o;break}}while(0);n=n+1|0;if(n>>>0>=(((f[g>>2]|0)-H|0)/24|0)>>>0)break;else o=H}}H=f[i>>2]|0;o=f[b>>2]|0;g=(H-o|0)/24|0;n=c+4|0;e=f[n>>2]|0;j=f[c>>2]|0;u=e-j>>3;m=j;j=e;e=o;if(g>>>0<=u>>>0)if(g>>>0<u>>>0?(l=m+(g<<3)|0,(j|0)!=(l|0)):0){f[n>>2]=j+(~((j+-8-l|0)>>>3)<<3);I=e;J=H;K=o}else{I=e;J=H;K=o}else{Voa(c,g-u|0);u=f[b>>2]|0;I=u;J=f[i>>2]|0;K=u}if((J|0)==(K|0))return;K=0;J=I;do{d=+NUb(a,J+(K*24|0)|0);p[(f[c>>2]|0)+(K<<3)>>3]=d;K=K+1|0;J=f[b>>2]|0}while(K>>>0<(((f[i>>2]|0)-J|0)/24|0)>>>0);return}function MUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/24|0;h=g+1|0;i=e;j=d;if(h>>>0>178956970)kWc(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/24|0;l=k<<1;m=k>>>0<89478485?(l>>>0<h>>>0?h:l):178956970;do if(m)if(m>>>0>178956970){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m*24|0)|0;break}else n=0;while(0);l=n+(g*24|0)|0;h=n+(m*24|0)|0;p[l>>3]=+p[b>>3];p[n+(g*24|0)+8>>3]=+p[b+8>>3];p[n+(g*24|0)+16>>3]=+p[b+16>>3];b=l+24|0;if((j|0)==(i|0))o=l;else{g=j;j=l;while(1){l=g;g=g+-24|0;p[j+-24>>3]=+p[g>>3];p[j+-16>>3]=+p[l+-16>>3];p[j+-8>>3]=+p[l+-8>>3];l=j+-24|0;if((g|0)==(i|0)){o=l;break}else j=l}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function NUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0;c=f[a+4>>2]|0;d=f[a>>2]|0;e=d;if((c|0)==(d|0)){g=0.0;return +g}h=+p[a+24>>3];i=+p[a+32>>3];j=+p[a+40>>3];k=+p[b>>3];l=+p[b+8>>3];m=+p[b+16>>3];b=f[a+12>>2]|0;a=(c-d|0)/24|0;n=0.0;d=0;while(1){o=+p[e+(d*24|0)+16>>3];q=+V(+o);r=h*q;s=i*q;q=(+p[e+(d*24|0)>>3]-k)/r;t=(+p[e+(d*24|0)+8>>3]-l)/s;u=(o-m)/j;o=n+ +p[b+(d<<3)>>3]*+V(+((q*q+t*t+u*u)*-.5))/+M(+(j+(r+s)));d=d+1|0;if(d>>>0>=a>>>0){g=o;break}else n=o}return +g}function OUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>3>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>3;o=h>>>0>n>>>0;p=o?b+(n<<3)|0:c;c=p;n=c-e|0;e=n>>3;if(e|0)q1c(k|0,b|0,n|0)|0;n=l+(e<<3)|0;if(o){o=d-c|0;if((o|0)<=0)return;o1c(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>3<<3);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);cYc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>536870911)kWc(a);j=q>>2;n=q>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(n>>>0>536870911)kWc(a);j=$Xc(n<<3)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<3);if((g|0)<=0)return;o1c(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>3<<3);return}function PUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=(c-b|0)/24|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0<=((g-h|0)/24|0)>>>0){j=a+4|0;k=f[j>>2]|0;l=(k-h|0)/24|0;m=d>>>0>l>>>0;n=b+(l*24|0)|0;l=m?n:c;o=k;if((l|0)==(b|0))q=i;else{k=b;r=i;while(1){p[r>>3]=+p[k>>3];p[r+8>>3]=+p[k+8>>3];p[r+16>>3]=+p[k+16>>3];k=k+24|0;s=r+24|0;if((k|0)==(l|0)){q=s;break}else r=s}}if(!m){if((o|0)==(q|0))return;f[j>>2]=o+(~(((o+-24-q|0)>>>0)/24|0)*24|0);return}if((l|0)==(c|0))return;l=n;n=f[j>>2]|0;do{p[n>>3]=+p[l>>3];p[n+8>>3]=+p[l+8>>3];p[n+16>>3]=+p[l+16>>3];l=l+24|0;n=n+24|0}while((l|0)!=(c|0));f[j>>2]=n;return}n=h;if(!h)t=g;else{g=a+4|0;j=f[g>>2]|0;if((j|0)!=(i|0))f[g>>2]=j+(~(((j+-24-h|0)>>>0)/24|0)*24|0);cYc(n);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;t=0}if(d>>>0>178956970)kWc(a);g=(t|0)/24|0;t=g<<1;n=g>>>0<89478485?(t>>>0<d>>>0?d:t):178956970;if(n>>>0>178956970)kWc(a);t=$Xc(n*24|0)|0;d=a+4|0;f[d>>2]=t;f[a>>2]=t;f[e>>2]=t+(n*24|0);if((b|0)==(c|0))return;n=b;b=t;do{p[b>>3]=+p[n>>3];p[b+8>>3]=+p[n+8>>3];p[b+16>>3]=+p[n+16>>3];n=n+24|0;b=b+24|0}while((n|0)!=(c|0));f[d>>2]=b;return}function QUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=(f[e>>2]|0)+24|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/24|0;g=i+b|0;if(g>>>0>178956970)kWc(a);j=(d-h|0)/24|0;h=j<<1;d=j>>>0<89478485?(h>>>0<g>>>0?g:h):178956970;do if(d)if(d>>>0>178956970){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*24|0)|0;break}else k=0;while(0);h=k+(i*24|0)|0;i=h;g=k+(d*24|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;b=k+24|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-24|0;p[b+-24>>3]=+p[i>>3];p[b+-16>>3]=+p[h+-16>>3];p[b+-8>>3]=+p[h+-8>>3];b=b+-24|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function RUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0;d=a+8|0;e=a+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=f[b+4>>2]|0;h=f[b>>2]|0;i=h;if((g|0)==(h|0)){j=0.0;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;q=m/j;p[a>>3]=q;r=n/l;p[d>>3]=r;s=o/k;p[e>>3]=s;return}t=+p[c>>3];u=+p[c+8>>3];v=+p[b+24>>3];w=+p[b+32>>3];x=+p[b+40>>3];y=+p[c+16>>3]/x;c=f[b+12>>2]|0;b=(g-h|0)/24|0;h=0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;do{F=+p[i+(h*24|0)+16>>3];G=+V(+F);H=v*G;I=w*G;G=+p[i+(h*24|0)>>3]/H;J=+p[i+(h*24|0)+8>>3]/I;K=F/x;F=G-t/H;L=J-u/I;N=K-y;O=+p[c+(h<<3)>>3]*+V(+((N*N+(F*F+L*L))*-.5))/+M(+(x+(H+I)));C=C+G*O;D=J*O+D;E=K*O+E;z=z+O/H;B=B+O/I;A=A+O/x;h=h+1|0}while(h>>>0<b>>>0);p[a>>3]=C;p[d>>3]=D;p[e>>3]=E;j=z;k=A;l=B;m=C;n=D;o=E;q=m/j;p[a>>3]=q;r=n/l;p[d>>3]=r;s=o/k;p[e>>3]=s;return}function SUb(a){a=a|0;var b=0,c=0,d=0;yP(a);f[a>>2]=141444;b=a+128|0;c=a+4|0;d=c+124|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[b>>2]=1124007936;b=a+132|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+160>>2]=a+136;b=a+168|0;f[a+164>>2]=b;f[a+172>>2]=0;f[b>>2]=0;f[a+176>>2]=1124007936;b=a+180|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+208>>2]=a+184;b=a+216|0;f[a+212>>2]=b;f[a+220>>2]=0;f[b>>2]=0;f[a+224>>2]=1124007936;b=a+228|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+256>>2]=a+232;b=a+264|0;f[a+260>>2]=b;f[a+268>>2]=0;f[b>>2]=0;f[a+272>>2]=1124007936;b=a+276|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+304>>2]=a+280;b=a+312|0;f[a+308>>2]=b;f[a+316>>2]=0;f[b>>2]=0;f[a+320>>2]=1124007936;b=a+324|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+352>>2]=a+328;b=a+360|0;f[a+356>>2]=b;f[a+364>>2]=0;f[b>>2]=0;f[a+368>>2]=1124007936;b=a+372|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+400>>2]=a+376;b=a+408|0;f[a+404>>2]=b;f[a+412>>2]=0;f[b>>2]=0;WXc(a+416|0);return}function TUb(a){a=a|0;f[a>>2]=0;f[a+4>>2]=0;return}function UUb(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;VUb(a,b)|0;return}function VUb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=$Xc(456)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=141600;d=c+12|0;SUb(d);TXc(c);f[a>>2]=d;d=a+4|0;e=f[d>>2]|0;f[d>>2]=c;if(e|0)UXc(e);UXc(c);c=f[a>>2]|0;if(!(Mi[f[(f[c>>2]|0)+32>>2]&1023](c,b)|0)?(f[a>>2]=0,b=f[d>>2]|0,f[d>>2]=0,b|0):0)UXc(b);b=f[a>>2]|0;if(!b){g=0;return g|0}g=(_i[f[(f[b>>2]|0)+20>>2]&2047](b)|0)^1;return g|0}function WUb(a){a=a|0;f[a>>2]=141600;QTb(a+12|0);NXc(a);return}function XUb(a){a=a|0;f[a>>2]=141600;QTb(a+12|0);NXc(a);cYc(a);return}function YUb(a){a=a|0;QTb(a+12|0);return}function ZUb(a){a=a|0;cYc(a);return}function _Ub(a){a=a|0;var b=0;b=f[a+4>>2]|0;if(!b)return;UXc(b);return}function $Ub(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b){c=1;return c|0}c=_i[f[(f[b>>2]|0)+20>>2]&2047](b)|0;return c|0}function aVb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;c=j-k>>4;l=f[a>>2]|0;m=f[a+4>>2]|0;a=(d|0)!=0;n=k;if(a?((f[d+4>>2]|0)-(f[d>>2]|0)>>2|0)!=(c|0):0){k=$Xc(16)|0;f[h>>2]=k;f[h+8>>2]=-2147483632;f[h+4>>2]=14;o=k;q=469795;r=o+14|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[k+14>>0]=0;vM(-215,h,469810,468086,1619)}k=(e|0)!=0;if(k?((f[e+4>>2]|0)-(f[e>>2]|0)>>3|0)!=(c|0):0){s=$Xc(16)|0;f[h>>2]=s;f[h+8>>2]=-2147483632;f[h+4>>2]=14;o=s;q=469822;r=o+14|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[s+14>>0]=0;vM(-215,h,469810,468086,1623)}a:do if(c){h=d+4|0;s=e+4|0;if(!a){q=k^1;o=0;r=0;while(1){t=f[n+(o<<4)>>2]|0;v=(t|0)>0?t:0;w=f[n+(o<<4)+4>>2]|0;x=(w|0)>0?w:0;y=(f[n+(o<<4)+8>>2]|0)+t|0;t=((y|0)<(l|0)?y:l)-v|0;y=(f[n+(o<<4)+12>>2]|0)+w|0;w=((y|0)<(m|0)?y:m)-x|0;y=(t|0)<1|(w|0)<1;z=y?0:w;w=y?0:t;if((w|0)<1|(z|0)<1)A=r;else{f[n+(r<<4)>>2]=y?0:v;f[n+(r<<4)+4>>2]=y?0:x;f[n+(r<<4)+8>>2]=w;f[n+(r<<4)+12>>2]=z;if(!(o>>>0<=r>>>0|q)){z=f[e>>2]|0;w=(f[s>>2]|0)-z>>3;if(w>>>0<=o>>>0){B=25;break}x=z;if(w>>>0<=r>>>0){B=27;break}p[x+(r<<3)>>3]=+p[x+(o<<3)>>3]}A=r+1|0}o=o+1|0;if(o>>>0>=c>>>0){C=A;break a}else r=A}if((B|0)==25)lWc(e);else if((B|0)==27)lWc(e)}else{D=0;E=0}while(1){r=f[n+(D<<4)>>2]|0;o=(r|0)>0?r:0;q=f[n+(D<<4)+4>>2]|0;x=(q|0)>0?q:0;w=(f[n+(D<<4)+8>>2]|0)+r|0;r=((w|0)<(l|0)?w:l)-o|0;w=(f[n+(D<<4)+12>>2]|0)+q|0;q=((w|0)<(m|0)?w:m)-x|0;w=(r|0)<1|(q|0)<1;z=w?0:q;q=w?0:r;if((q|0)<1|(z|0)<1)F=E;else{f[n+(E<<4)>>2]=w?0:o;f[n+(E<<4)+4>>2]=w?0:x;f[n+(E<<4)+8>>2]=q;f[n+(E<<4)+12>>2]=z;if(D>>>0>E>>>0){z=f[d>>2]|0;q=(f[h>>2]|0)-z>>2;if(q>>>0<=D>>>0){B=22;break}x=z;if(q>>>0<=E>>>0){B=23;break}f[x+(E<<2)>>2]=f[x+(D<<2)>>2];if(k){x=f[e>>2]|0;q=(f[s>>2]|0)-x>>3;if(q>>>0<=D>>>0){B=25;break}z=x;if(q>>>0<=E>>>0){B=27;break}p[z+(E<<3)>>3]=+p[z+(D<<3)>>3]}}F=E+1|0}D=D+1|0;if(D>>>0>=c>>>0){C=F;break a}else E=F}if((B|0)==22)lWc(d);else if((B|0)==23)lWc(d);else if((B|0)==25)lWc(e);else if((B|0)==27)lWc(e)}else C=0;while(0);if(C>>>0>=c>>>0){u=g;return}c=j;j=n+(C<<4)|0;if((c|0)!=(j|0))f[i>>2]=c+(~((c+-16-j|0)>>>4)<<4);do if(a){j=d+4|0;c=f[j>>2]|0;i=f[d>>2]|0;n=c-i>>2;B=c;if(C>>>0>n>>>0){CS(d,C-n|0);break}if(C>>>0<n>>>0?(n=i+(C<<2)|0,(B|0)!=(n|0)):0)f[j>>2]=B+(~((B+-4-n|0)>>>2)<<2)}while(0);if(!k){u=g;return}k=e+4|0;d=f[k>>2]|0;a=f[e>>2]|0;n=d-a>>3;B=d;if(C>>>0>n>>>0){Voa(e,C-n|0);u=g;return}if(C>>>0>=n>>>0){u=g;return}n=a+(C<<3)|0;if((B|0)==(n|0)){u=g;return}f[k>>2]=B+(~((B+-8-n|0)>>>3)<<3);u=g;return}function bVb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+48|0;l=k;m=k+32|0;n=k+24|0;o=k+16|0;p=f[a>>2]|0;if(p|0?!(_i[f[(f[p>>2]|0)+20>>2]&2047](p)|0):0){p=f[a>>2]|0;a=f[(f[p>>2]|0)+36>>2]|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];Gh[a&3](p,c,d,e,g,h,m,n);cS(o,c,-1);aVb(o,d,0,0);u=k;return};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+11>>0]=8;k=l;f[k>>2]=1886217505;f[k+4>>2]=690518388;b[l+8>>0]=0;vM(-215,l,468976,468086,1658)}function cVb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=u;u=u+48|0;m=l;n=l+32|0;o=l+24|0;p=l+16|0;q=f[a>>2]|0;if(q|0?!(_i[f[(f[q>>2]|0)+20>>2]&2047](q)|0):0){q=f[a>>2]|0;a=f[(f[q>>2]|0)+40>>2]|0;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];uh[a&7](q,c,d,e,g,h,i,n,o);cS(p,c,-1);aVb(p,d,e,0);u=l;return};f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=8;l=m;f[l>>2]=1886217505;f[l+4>>2]=690518388;b[m+8>>0]=0;vM(-215,m,468976,468086,1672)}function dVb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=u;u=u+48|0;o=n;p=n+32|0;q=n+24|0;r=n+16|0;s=f[a>>2]|0;if(s|0?!(_i[f[(f[s>>2]|0)+20>>2]&2047](s)|0):0){s=f[a>>2]|0;a=f[(f[s>>2]|0)+44>>2]|0;f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];f[q>>2]=f[l>>2];f[q+4>>2]=f[l+4>>2];ih[a&3](s,c,d,e,g,h,i,j,p,q,m);cS(r,c,-1);aVb(r,d,e,g);u=n;return};f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=8;n=o;f[n>>2]=1886217505;f[n+4>>2]=690518388;b[o+8>>0]=0;vM(-215,o,468976,468086,1689)}function eVb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141628;b=a+268|0;c=a+304|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+284|0;b=a+272|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+308>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+312>>2]|0;if((b|0)!=(a+316|0))wL(b);b=a+212|0;d=a+248|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+228|0;b=a+216|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+252>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+256>>2]|0;if((b|0)!=(a+260|0))wL(b);b=a+156|0;c=a+192|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+172|0;b=a+160|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+196>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+200>>2]|0;if((b|0)!=(a+204|0))wL(b);b=a+100|0;d=a+136|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+116|0;b=a+104|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+140>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))wL(b);b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+16>>2]|0;if(b|0){d=a+20|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~(((c+-12-b|0)>>>0)/12|0)*12|0);cYc(b)}b=f[a+4>>2]|0;if(!b)return;c=a+8|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~(((a+-44-b|0)>>>0)/44|0)*44|0);cYc(b);return}function fVb(a){a=a|0;eVb(a);cYc(a);return}function gVb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;j=u;u=u+2208|0;k=j+1136|0;l=j+1080|0;m=j+8|0;o=j+1072|0;q=j;r=a+324|0;f[r>>2]=c;s=a+52|0;f[s>>2]=f[i>>2];t=a+56|0;f[t>>2]=f[i+4>>2];i=a+28|0;b[i>>0]=h&1;h=f[(f[c>>2]|0)+52>>2]|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;d=l+8|0;f[d>>2]=0;f[d+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a+212;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a+268;f[o>>2]=f[e>>2];d=e+4|0;f[o+4>>2]=f[d>>2];f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];Fh[h&255](c,k,l,m,o,q);q=f[d>>2]|0;f[a+92>>2]=f[e>>2];f[a+96>>2]=q;q=f[r>>2]|0;e=f[q+4>>2]|0;f[a+44>>2]=e;d=f[q+8>>2]|0;f[a+48>>2]=d;o=f[q+12>>2]|0;c=f[q+16>>2]|0;h=f[q+20>>2]|0;g=f[q+24>>2]|0;v=f[q+28>>2]|0;w=f[q+32>>2]|0;x=f[q+36>>2]|0;q=Y(c,o)|0;y=a+60|0;f[y>>2]=((e-o|0)/(h|0)|0)+1;e=a+64|0;f[e>>2]=((d-c|0)/(g|0)|0)+1;z=(o|0)/(v|0)|0;A=(c|0)/(w|0)|0;B=a+68|0;f[B>>2]=z;C=a+72|0;f[C>>2]=A;D=Y(Y(z,x)|0,A)|0;A=a+76|0;f[A>>2]=D;do if(b[i>>0]|0){z=(((f[a+224>>2]|0)-o|0)/(f[s>>2]|0)|0)+1|0;E=((d|0)/(f[t>>2]|0)|0)+1|0;F=a+100|0;G=Y(z,D)|0;if(!(((((f[a+104>>2]|0)<3?(f[a+108>>2]|0)==(E|0):0)?(f[a+112>>2]|0)==(G|0):0)?(f[F>>2]&4095|0)==5:0)?(f[a+116>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=G;S$(F,2,k,5)}F=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(E|0):0)?(f[a+168>>2]|0)==(z|0):0)?(f[F>>2]&4095|0)==0:0)?(f[a+172>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=z;S$(F,2,k,0)}F=f[a+108>>2]|0;z=a+32|0;E=a+36|0;G=f[E>>2]|0;H=f[z>>2]|0;I=G-H>>2;J=H;H=G;if(F>>>0<=I>>>0){if(F>>>0<I>>>0?(G=J+(F<<2)|0,(H|0)!=(G|0)):0)f[E>>2]=H+(~((H+-4-G|0)>>>2)<<2);if(!F)break}else CS(z,F-I|0);g1c(f[z>>2]|0,-1,F<<2|0)|0}while(0);f[l>>2]=1124007936;D=l+4|0;t=l+8|0;d=l+40|0;s=D;i=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(i|0));f[d>>2]=t;t=l+48|0;F=l+44|0;f[F>>2]=t;f[t>>2]=0;f[l+52>>2]=0;f[k>>2]=c;f[k+4>>2]=o;S$(l,2,k,5);z=f[r>>2]|0;K=+p[z+48>>3];if(K>0.0)L=K;else L=+((f[z+16>>2]|0)+(f[z+12>>2]|0)|0)*.125;K=L;L=1.0/(K*K*2.0);z=k+8|0;f[k>>2]=z;r=k+4|0;f[r>>2]=c;if(c>>>0>264){I=bYc(c>>>0>1073741823?-1:c<<2)|0;f[k>>2]=I;M=I}else M=z;I=m+8|0;f[m>>2]=I;G=m+4|0;f[G>>2]=o;if(o>>>0>264){H=bYc(o>>>0>1073741823?-1:o<<2)|0;f[m>>2]=H;N=H}else N=I;K=+(c|0)*.5;O=+(o|0)*.5;H=(c|0)>0;if(H){E=0;do{P=+(E|0)-K;n[M+(E<<2)>>2]=P*P;E=E+1|0}while((E|0)!=(c|0))}E=(o|0)>0;if(E){J=0;do{K=+(J|0)-O;n[N+(J<<2)>>2]=K*K;J=J+1|0}while((J|0)!=(o|0))}if(H?(J=f[l+16>>2]|0,E):0){Q=f[f[F>>2]>>2]|0;R=0;do{S=M+(R<<2)|0;T=J+(Y(Q,R)|0)|0;U=0;do{O=+V(+-(L*(+n[S>>2]+ +n[N+(U<<2)>>2])));n[T+(U<<2)>>2]=O;U=U+1|0}while((U|0)!=(o|0));R=R+1|0}while((R|0)!=(c|0))}if((N|0)==(I|0))W=M;else{dYc(N);N=f[k>>2]|0;f[m>>2]=I;f[G>>2]=264;W=N}if((W|0)!=(z|0)){if(W|0)dYc(W);f[k>>2]=z;f[r>>2]=264}r=a+16|0;z=Y(f[e>>2]|0,f[y>>2]|0)|0;k=a+20|0;W=f[k>>2]|0;N=f[r>>2]|0;G=(W-N|0)/12|0;I=N;N=W;if(z>>>0<=G>>>0){if(z>>>0<G>>>0?(W=I+(z*12|0)|0,(N|0)!=(W|0)):0)f[k>>2]=N+(~(((N+-12-W|0)>>>0)/12|0)*12|0)}else iVb(r,z-G|0);G=a+4|0;z=q*3|0;W=a+8|0;N=f[W>>2]|0;k=f[G>>2]|0;I=(N-k|0)/44|0;m=k;k=N;if(z>>>0<=I>>>0){if(z>>>0<I>>>0?(N=m+(z*44|0)|0,(k|0)!=(N|0)):0)f[W>>2]=k+(~(((k+-44-N|0)>>>0)/44|0)*44|0)}else jVb(G,z-I|0);I=a+88|0;f[I>>2]=0;z=a+84|0;f[z>>2]=0;N=a+80|0;f[N>>2]=0;if(E){L=+(v|0);O=+(w|0);w=q<<1;v=a+224|0;E=a+280|0;a=f[l+16>>2]|0;k=f[F>>2]|0;W=0;do{if(H){K=(+(W|0)+.5)/L+-.5;m=~~K;M=m-(+(m|0)>K&1)|0;m=M+1|0;P=K-+(M|0);K=1.0-P;R=0;do{X=(+(R|0)+.5)/O+-.5;Q=~~X;J=Q-(+(Q|0)>X&1)|0;Q=J+1|0;Z=X-+(J|0);U=f[B>>2]|0;T=M>>>0<U>>>0;do if(T&m>>>0<U>>>0){S=f[C>>2]|0;_=J>>>0<S>>>0;if(_&Q>>>0<S>>>0){$=f[I>>2]|0;f[I>>2]=$+1;aa=$+w|0;$=f[G>>2]|0;ba=Y((Y(S,M)|0)+J|0,x)|0;f[$+(aa*44|0)+8>>2]=ba;X=1.0-Z;n[$+(aa*44|0)+24>>2]=K*X;ba=Y((Y(f[C>>2]|0,m)|0)+J|0,x)|0;f[$+(aa*44|0)+12>>2]=ba;n[$+(aa*44|0)+28>>2]=P*X;ba=Y((Y(f[C>>2]|0,M)|0)+Q|0,x)|0;f[$+(aa*44|0)+16>>2]=ba;n[$+(aa*44|0)+32>>2]=K*Z;ba=Y((Y(f[C>>2]|0,m)|0)+Q|0,x)|0;f[$+(aa*44|0)+20>>2]=ba;ca=$+(aa*44|0)|0;da=3;ea=P*Z;break}else{aa=f[z>>2]|0;f[z>>2]=aa+1;$=aa+q|0;aa=f[G>>2]|0;X=_?1.0-Z:Z;ba=_?J:Q;_=Y(ba+(Y(S,M)|0)|0,x)|0;f[aa+($*44|0)+8>>2]=_;n[aa+($*44|0)+24>>2]=K*X;_=Y((Y(f[C>>2]|0,m)|0)+ba|0,x)|0;f[aa+($*44|0)+12>>2]=_;n[aa+($*44|0)+28>>2]=P*X;f[aa+($*44|0)+20>>2]=0;f[aa+($*44|0)+16>>2]=0;n[aa+($*44|0)+36>>2]=0.0;ca=aa+($*44|0)|0;da=2;ea=0.0;break}}else{X=T?K:P;$=T?M:m;aa=f[C>>2]|0;_=J>>>0<aa>>>0;if(_&Q>>>0<aa>>>0){ba=f[z>>2]|0;f[z>>2]=ba+1;S=ba+q|0;ba=f[G>>2]|0;fa=Y((Y(aa,$)|0)+J|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=(1.0-Z)*X;fa=Y((Y(f[C>>2]|0,$)|0)+Q|0,x)|0;f[ba+(S*44|0)+12>>2]=fa;n[ba+(S*44|0)+28>>2]=Z*X;f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;ca=ba+(S*44|0)|0;da=2;ea=0.0;break}else{S=f[N>>2]|0;f[N>>2]=S+1;ba=f[G>>2]|0;fa=Y((_?J:Q)+(Y(aa,$)|0)|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=X*(_?1.0-Z:Z);f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;f[ba+(S*44|0)+12>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;n[ba+(S*44|0)+32>>2]=0.0;ca=ba+(S*44|0)|0;da=1;ea=0.0;break}}while(0);n[ca+24+(da<<2)>>2]=ea;Q=(Y(f[v>>2]|0,R)|0)+W<<1;f[ca>>2]=Q;Q=(Y(f[E>>2]|0,R)|0)+W<<1;f[ca+4>>2]=Q;Q=a+(Y(f[k>>2]|0,R)|0)+(W<<2)|0;f[ca+40>>2]=f[Q>>2];R=R+1|0}while((R|0)!=(c|0))}W=W+1|0}while((W|0)!=(o|0));o=f[z>>2]|0;if((o|0)>0){W=0;do{c=f[G>>2]|0;s=c+(((f[N>>2]|0)+W|0)*44|0)|0;ga=c+((W+q|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));W=W+1|0;c=f[z>>2]|0}while((W|0)<(c|0));ha=c}else ha=o}else ha=0;o=f[I>>2]|0;if((o|0)>0){W=q<<1;q=f[G>>2]|0;s=q+(((f[N>>2]|0)+ha|0)*44|0)|0;ga=q+(W*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));q=f[I>>2]|0;if((q|0)>1){c=1;do{ca=f[G>>2]|0;s=ca+(((f[N>>2]|0)+c+(f[z>>2]|0)|0)*44|0)|0;ga=ca+((c+W|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));c=c+1|0;ca=f[I>>2]|0}while((c|0)<(ca|0));ia=ca}else ia=q;ja=ia;ka=f[z>>2]|0}else{ja=o;ka=ha}ha=ka+(f[N>>2]|0)|0;f[z>>2]=ha;f[I>>2]=ha+ja;ja=f[y>>2]|0;if((ja|0)>0?(y=f[e>>2]|0,(y|0)>0):0){e=f[r>>2]|0;r=f[A>>2]|0;A=0;do{ha=Y(A,h)|0;I=Y(y,A)|0;z=0;do{N=I+z|0;ka=Y(r,N)|0;f[e+(N*12|0)>>2]=ka;ka=Y(z,g)|0;f[e+(N*12|0)+4>>2]=ha;f[e+(N*12|0)+8>>2]=ka;z=z+1|0}while((z|0)<(y|0));A=A+1|0}while((A|0)<(ja|0))}ja=l+36|0;A=f[ja>>2]|0;if(A|0?(y=A+12|0,A=f[y>>2]|0,f[y>>2]=A+-1,(A|0)==1):0)V$(l);f[ja>>2]=0;ja=l+16|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[D>>2]|0)>0){ja=f[d>>2]|0;d=0;do{f[ja+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[D>>2]|0))}D=f[F>>2]|0;if((D|0)==(t|0)){u=j;return}wL(D);u=j;return}function hVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,q=0,r=0.0,t=0.0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+16|0;d=c+4|0;e=c;g=f[a+76>>2]|0;h=g+-4|0;i=0;j=0.0;k=0.0;l=0.0;m=0.0;do{o=+n[b+(i<<2)>>2];j=j+o*o;o=+n[b+((i|1)<<2)>>2];k=k+o*o;o=+n[b+((i|2)<<2)>>2];l=l+o*o;o=+n[b+((i|3)<<2)>>2];m=m+o*o;i=i+4|0}while(i>>>0<=h>>>0);o=m+l+(k+j);if(i>>>0<g>>>0){j=o;q=i;while(1){k=+n[b+(q<<2)>>2];l=j+k*k;q=q+1|0;if((q|0)==(g|0)){r=l;break}else j=l}}else r=o;o=1.0/(+(g>>>0)*.10000000149011612+ +M(+r));r=+p[(f[a+324>>2]|0)+64>>3];n[d>>2]=r;a=0;j=0.0;l=0.0;k=0.0;m=0.0;do{q=b+(a<<2)|0;t=o*+n[q>>2];n[e>>2]=t;i=f[(r<t?d:e)>>2]|0;f[q>>2]=i;q=b+((a|1)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;v=f[(r<t?d:e)>>2]|0;f[q>>2]=v;q=b+((a|2)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;w=f[(r<t?d:e)>>2]|0;f[q>>2]=w;q=b+((a|3)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;x=f[(r<t?d:e)>>2]|0;f[q>>2]=x;t=(f[s>>2]=i,+n[s>>2]);j=j+t*t;t=(f[s>>2]=v,+n[s>>2]);l=l+t*t;t=(f[s>>2]=w,+n[s>>2]);k=k+t*t;t=(f[s>>2]=x,+n[s>>2]);m=m+t*t;a=a+4|0}while(a>>>0<=h>>>0);t=m+k+(l+j);if(a>>>0<g>>>0){j=t;h=a;while(1){a=b+(h<<2)|0;l=o*+n[a>>2];n[e>>2]=l;x=f[(r<l?d:e)>>2]|0;f[a>>2]=x;l=(f[s>>2]=x,+n[s>>2]);k=j+l*l;h=h+1|0;if((h|0)==(g|0)){y=k;break}else j=k}}else y=t;t=1.0/(+M(+y)+1.0000000474974513e-03);if(!g){u=c;return}else z=0;do{h=b+(z<<2)|0;n[h>>2]=t*+n[h>>2];z=z+1|0}while((z|0)!=(g|0));u=c;return}function iVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=d;p=i}else{i=h;h=d;do{d=i;i=i+-12|0;f[h+-12>>2]=f[i>>2];f[h+-8>>2]=f[d+-8>>2];f[h+-4>>2]=f[d+-4>>2];h=h+-12|0}while((i|0)!=(k|0));o=h;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;cYc(p);return}function jVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/44|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+44|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/44|0;g=i+b|0;if(g>>>0>97612893)kWc(a);l=(d-h|0)/44|0;h=l<<1;d=l>>>0<48806446?(h>>>0<g>>>0?g:h):97612893;do if(d)if(d>>>0>97612893){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*44|0)|0;break}else m=0;while(0);h=m+(i*44|0)|0;i=m+(d*44|0)|0;d=b;b=h;m=h;do{j=b;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+44|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(((b|0)/-44|0)*44|0)|0;if((b|0)>0)o1c(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;cYc(d);return}function kVb(a){a=a|0;var b=0,c=0;f[a>>2]=141652;EQ(a+88|0);b=f[a+76>>2]|0;if(!b)return;c=a+80|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function lVb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=141652;EQ(a+88|0);b=f[a+76>>2]|0;if(!b){cYc(a);return}c=a+80|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function mVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=u;u=u+112|0;e=d+56|0;g=d;do if((eS(c)|0)==65536){h=f[c+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;U$(e,h);break}}else bS(e,c,-1);while(0);c=a+76|0;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=-2113732603;f[g+4>>2]=c;dY(e,g,5,1.0,0.0);h=e+36|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)V$(e);f[h>>2]=0;h=e+16|0;i=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[e+40>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))wL(i);i=a+80|0;j=(f[i>>2]|0)-(f[c>>2]|0)>>2;h=GVb(a)|0;if(!((j|0)==(h+1|0)|((j|0)==0|(j|0)==(h|0)))){h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=19;o=h;j=470811;p=o+19|0;do{b[o>>0]=b[j>>0]|0;o=o+1|0;j=j+1|0}while((o|0)<(p|0));b[h+19>>0]=0;vM(-215,e,470831,469947,115)}h=(f[i>>2]|0)-(f[c>>2]|0)>>2;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;m=g+40|0;o=j;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[m>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[e>>2]=1;f[e+4>>2]=h;S$(g,2,e,5);h=f[a+12>>2]|0;p=f[a+16>>2]|0;l=Y(Y((h|0)/(f[a+28>>2]|0)|0,f[a+36>>2]|0)|0,(p|0)/(f[a+32>>2]|0)|0)|0;q=f[a+20>>2]|0;r=f[a+24>>2]|0;s=((f[a+4>>2]|0)-h+q|0)/(q|0)|0;q=((f[a+8>>2]|0)-p+r|0)/(r|0)|0;if((q|0)>0?(r=f[g+16>>2]|0,p=(l|0)==0,(s|0)>0):0){h=f[c>>2]|0;t=0;do{v=Y(t,s)|0;if(!p){w=0;do{x=h+((Y((Y(w,q)|0)+t|0,l)|0)<<2)|0;y=r+((Y(w+v|0,l)|0)<<2)|0;z=0;do{f[y+(z<<2)>>2]=f[x+(z<<2)>>2];z=z+1|0}while((z|0)!=(l|0));w=w+1|0}while((w|0)!=(s|0))}t=t+1|0}while((t|0)!=(q|0))}q=GVb(a)|0;t=f[c>>2]|0;if((f[i>>2]|0)-t>>2>>>0>q>>>0)A=+n[t+(q<<2)>>2];else A=0.0;n[a+136>>2]=A;q=e+8|0;f[q>>2]=0;f[q+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=a+88;jR(g,e);e=g+36|0;a=f[e>>2]|0;if(a|0?(q=a+12|0,a=f[q>>2]|0,f[q>>2]=a+-1,(a|0)==1):0)V$(g);f[e>>2]=0;e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[j>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}wL(j);u=d;return}function nVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+96|0;e=d+72|0;g=d+48|0;h=d+24|0;i=d+12|0;j=d;i5(e,c,470635);if(G5(e)|0){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=23;l=k;m=470769;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+23>>0]=0;vM(-215,e,473221,469947,139)}if(!(v5(c)|0)){o=0;u=d;return o|0}i5(e,c,470635);d5(h,e);g5(e,h);M5(e,a+4|0,0);k=x5(h)|0;g5(e,k);M5(e,a+8|0,0);x5(k)|0;i5(g,c,470643);d5(e,g);f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];g5(e,h);M5(e,a+12|0,0);k=x5(h)|0;g5(e,k);M5(e,a+16|0,0);x5(k)|0;i5(g,c,470653);d5(e,g);f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];g5(e,h);M5(e,a+20|0,0);k=x5(h)|0;g5(e,k);M5(e,a+24|0,0);x5(k)|0;i5(g,c,470793);d5(e,g);f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];g5(e,h);M5(e,a+28|0,0);k=x5(h)|0;g5(e,k);M5(e,a+32|0,0);x5(k)|0;i5(e,c,470665);M5(e,a+36|0,0);i5(e,c,470671);M5(e,a+40|0,0);i5(e,c,470802);N5(e,a+48|0,0.0);i5(g,c,470685);M5(g,e,0);f[a+56>>2]=f[e>>2];i5(e,c,470703);N5(e,a+64|0,0.0);i5(g,c,470718);M5(g,e,0);b[a+72>>0]=(f[e>>2]|0)!=0&1;i5(e,c,470734);M5(e,a+140|0,0);i5(e,c,470742);if(G5(e)|0)b[a+144>>0]=0;else{i5(g,c,470742);M5(g,e,0);b[a+144>>0]=(f[e>>2]|0)!=0&1}i5(i,c,470757);if(A5(i)|0?(f[j>>2]=0,c=j+4|0,f[c>>2]=0,f[j+8>>2]=0,d5(g,i),f[e>>2]=g,QVb(e,j,2147483647),g=f[(f[a>>2]|0)+8>>2]|0,f[e+8>>2]=0,f[e+12>>2]=0,f[e>>2]=-2130509819,f[e+4>>2]=j,mi[g&2047](a,e),e=f[j>>2]|0,e|0):0){j=f[c>>2]|0;if((j|0)!=(e|0))f[c>>2]=j+(~((j+-4-e|0)>>>2)<<2);cYc(e)}o=1;u=d;return o|0}function oVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0,t=0;e=u;u=u+16|0;g=e;i=e+12|0;j=b[d+11>>0]|0;if((j<<24>>24<0?f[d+4>>2]|0:j&255)|0)s5(c,d)|0;d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=27;j=d;k=470607;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+27>>0]=0;d=s5(c,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g+8>>2]=0;m=g+11|0;b[m>>0]=7;b[g>>0]=b[470635]|0;b[g+1>>0]=b[470636]|0;b[g+2>>0]=b[470637]|0;b[g+3>>0]=b[470638]|0;b[g+4>>0]=b[470639]|0;b[g+5>>0]=b[470640]|0;b[g+6>>0]=b[470641]|0;b[g+7>>0]=0;n=s5(d,g)|0;if((b[m>>0]|0)<0)cYc(f[g>>2]|0);m=OVb(n,a+4|0)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;n=g+11|0;b[n>>0]=9;j=g;k=470643;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[g+9>>0]=0;d=s5(m,g)|0;if((b[n>>0]|0)<0)cYc(f[g>>2]|0);n=OVb(d,a+12|0)|0;d=$Xc(16)|0;f[g>>2]=d;f[g+8>>2]=-2147483632;f[g+4>>2]=11;j=d;k=470653;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+11>>0]=0;d=s5(n,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);n=OVb(d,a+20|0)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=g+11|0;b[d>>0]=8;m=g;f[m>>2]=1819043171;f[m+4>>2]=1702521171;b[g+8>>0]=0;m=s5(n,g)|0;if((b[d>>0]|0)<0)cYc(f[g>>2]|0);d=OVb(m,a+28|0)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=g+11|0;b[m>>0]=5;b[g>>0]=b[470665]|0;b[g+1>>0]=b[470666]|0;b[g+2>>0]=b[470667]|0;b[g+3>>0]=b[470668]|0;b[g+4>>0]=b[470669]|0;b[g+5>>0]=0;n=s5(d,g)|0;if((b[m>>0]|0)<0)cYc(f[g>>2]|0);m=a+36|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](n)|0){d=c+4|0;if((f[d>>2]|0)==6){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=o;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(n,c+8|0,f[m>>2]|0);if(f[d>>2]&4|0)f[d>>2]=6}d=$Xc(16)|0;f[g>>2]=d;f[g+8>>2]=-2147483632;f[g+4>>2]=13;j=d;k=470671;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+13>>0]=0;d=s5(n,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);n=a+40|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](d)|0){m=c+4|0;if((f[m>>2]|0)==6){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=o;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(d,c+8|0,f[n>>2]|0);if(f[m>>2]&4|0)f[m>>2]=6};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=g+11|0;b[m>>0]=8;n=g;f[n>>2]=1399744887;f[n+4>>2]=1634559849;b[g+8>>0]=0;n=s5(d,g)|0;if((b[m>>0]|0)<0)cYc(f[g>>2]|0);q=+p[a+48>>3];if(q>0.0)r=q;else r=+((f[a+16>>2]|0)+(f[a+12>>2]|0)|0)*.125;if(_i[f[(f[c>>2]|0)+12>>2]&2047](n)|0){m=c+4|0;if((f[m>>2]|0)==6){d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=d;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+30>>0]=0;vM(-2,g,528568,473413,1207)}q5(n,c+8|0,r);if(f[m>>2]&4|0)f[m>>2]=6}m=$Xc(32)|0;f[g>>2]=m;f[g+8>>2]=-2147483616;f[g+4>>2]=17;j=m;k=470685;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[m+17>>0]=0;m=s5(n,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);n=a+56|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](m)|0){d=c+4|0;if((f[d>>2]|0)==6){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=o;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(m,c+8|0,f[n>>2]|0);if(f[d>>2]&4|0)f[d>>2]=6}d=$Xc(16)|0;f[g>>2]=d;f[g+8>>2]=-2147483632;f[g+4>>2]=14;j=d;k=470703;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+14>>0]=0;d=s5(m,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);m=a+64|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](d)|0){n=c+4|0;if((f[n>>2]|0)==6){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=o;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+30>>0]=0;vM(-2,g,528568,473413,1207)}q5(d,c+8|0,+p[m>>3]);if(f[n>>2]&4|0)f[n>>2]=6}n=$Xc(16)|0;f[g>>2]=n;f[g+8>>2]=-2147483632;f[g+4>>2]=15;j=n;k=470718;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[n+15>>0]=0;n=s5(d,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);d=a+72|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](n)|0){m=c+4|0;if((f[m>>2]|0)==6){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=o;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(n,c+8|0,h[d>>0]|0);if(!(f[m>>2]&4))break;f[m>>2]=6}while(0);f[g+8>>2]=0;d=g+11|0;b[d>>0]=7;b[g>>0]=b[470734]|0;b[g+1>>0]=b[470735]|0;b[g+2>>0]=b[470736]|0;b[g+3>>0]=b[470737]|0;b[g+4>>0]=b[470738]|0;b[g+5>>0]=b[470739]|0;b[g+6>>0]=b[470740]|0;b[g+7>>0]=0;s=s5(n,g)|0;if((b[d>>0]|0)<0)cYc(f[g>>2]|0);d=a+140|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](s)|0){n=c+4|0;if((f[n>>2]|0)==6){t=$Xc(32)|0;f[g>>2]=t;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=t;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[t+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(s,c+8|0,f[d>>2]|0);if(!(f[n>>2]&4))break;f[n>>2]=6}while(0);d=$Xc(16)|0;f[g>>2]=d;f[g+8>>2]=-2147483632;f[g+4>>2]=14;j=d;k=470742;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+14>>0]=0;d=s5(s,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);s=a+144|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](d)|0){m=c+4|0;if((f[m>>2]|0)==6){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=o;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(d,c+8|0,h[s>>0]|0);if(!(f[m>>2]&4))break;f[m>>2]=6}while(0);s=a+76|0;do if((f[s>>2]|0)!=(f[a+80>>2]|0)){d=$Xc(16)|0;f[g>>2]=d;f[g+8>>2]=-2147483632;f[g+4>>2]=11;j=d;k=470757;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+11>>0]=0;m=s5(c,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(!(_i[f[(f[c>>2]|0)+12>>2]&2047](m)|0))break;o=c+4|0;if((f[o>>2]|0)==6){n=$Xc(32)|0;f[g>>2]=n;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=n;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[n+30>>0]=0;vM(-2,g,528568,473413,1207)}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P5(i,m,c+8|0,12,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=m;PVb(g,s);r5(i);if(!(f[o>>2]&4))break;f[o>>2]=6}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=g+11|0;b[i>>0]=1;b[g>>0]=125;b[g+1>>0]=0;s5(c,g)|0;if((b[i>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function pVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+48|0;g=e+12|0;h=e;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;$4(g,c,0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);c=b[d+11>>0]|0;if(!((c<<24>>24<0?f[d+4>>2]|0:c&255)|0))c5(h,g);else k5(h,g,d);d=Mi[f[(f[a>>2]|0)+12>>2]&1023](a,h)|0;r3(g);u=e;return d|0}function qVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+12|0;h=e;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;$4(g,c,1,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);i=f[(f[a>>2]|0)+16>>2]|0;j=b[d+11>>0]|0;if(!((j<<24>>24<0?f[d+4>>2]|0:j&255)|0))h5(h,c);else lYc(h,d);Ti[i&511](a,g,h);if((b[h+11>>0]|0)>=0){r3(g);u=e;return}cYc(f[h>>2]|0);r3(g);u=e;return}function rVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];f[c+16>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[c+36>>2]=f[a+36>>2];f[c+40>>2]=f[a+40>>2];p[c+48>>3]=+p[a+48>>3];f[c+56>>2]=f[a+56>>2];p[c+64>>3]=+p[a+64>>3];b[c+72>>0]=b[a+72>>0]|0;g=f[(f[c>>2]|0)+8>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=-2130509819;f[e+4>>2]=a+76;mi[g&2047](c,e);f[c+140>>2]=f[a+140>>2];b[c+144>>0]=b[a+144>>0]|0;u=d;return}function sVb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+416|0;i=h+400|0;j=h+392|0;k=h+336|0;l=h+8|0;m=h;n=f[d>>2]|0;o=d+4|0;p=f[o>>2]|0;if(!(p|n)){q=f[a+28>>2]|0;f[d>>2]=q;r=f[a+32>>2]|0;f[o>>2]=r;s=q;t=r}else{s=n;t=p}p=f[a+20>>2]|0;n=(s|0)<(p|0);r=n?p:s;q=n?s:p;if((q|0)>0){p=r;s=q;while(1){q=(p|0)%(s|0)|0;if((q|0)>0){n=s;s=q;p=n}else{v=s;break}}}else v=r;r=f[a+24>>2]|0;s=(t|0)<(r|0);p=s?r:t;n=s?t:r;if((n|0)>0){r=p;t=n;while(1){n=(r|0)%(t|0)|0;if((n|0)>0){s=t;t=n;r=s}else{w=t;break}}}else w=p;f[i>>2]=v;v=i+4|0;f[v>>2]=w;cS(j,b,-1);w=g+4|0;p=(f[w>>2]|0)-(f[g>>2]|0)>>3;t=f[e>>2]|0;r=f[i>>2]|0;s=r+-1+((t|0)>0?t:0)&0-r;f[e>>2]=s;r=e+4|0;t=f[r>>2]|0;n=f[v>>2]|0;v=n+-1+((t|0)>0?t:0)&0-n;f[r>>2]=v;n=(s<<1)+(f[j>>2]|0)|0;s=(v<<1)+(f[j+4>>2]|0)|0;do if((eS(b)|0)==65536){j=f[b+4>>2]|0;f[k>>2]=f[j>>2];v=k+4|0;t=j+4|0;f[v>>2]=f[t>>2];q=k+8|0;f[q>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];x=f[j+36>>2]|0;f[k+36>>2]=x;f[k+40>>2]=q;q=k+48|0;y=k+44|0;f[y>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(x|0){q=x+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[t>>2]|0)<3){t=f[j+44>>2]|0;q=f[y>>2]|0;f[q>>2]=f[t>>2];f[q+4>>2]=f[t+4>>2];break}else{f[v>>2]=0;U$(k,j);break}}else bS(k,b,-1);while(0);b=(p|0)==0;FVb(l,a,k,e,e,b,i);if(b)z=Y(((s-(f[l+48>>2]|0)|0)/(f[o>>2]|0)|0)+1|0,((n-(f[l+44>>2]|0)|0)/(f[d>>2]|0)|0)+1|0)|0;else z=p;p=f[l+16>>2]|0;s=Y(f[l+64>>2]|0,f[l+60>>2]|0)|0;b=f[l+76>>2]|0;i=GVb(a)|0;j=Y(i,z)|0;v=c+4|0;t=f[v>>2]|0;q=f[c>>2]|0;y=t-q>>2;x=q;q=t;if(j>>>0<=y>>>0){if(j>>>0<y>>>0?(t=x+(j<<2)|0,(q|0)!=(t|0)):0)f[v>>2]=q+(~((q+-4-t|0)>>>2)<<2)}else qxb(c,j-y|0);if(z|0?(y=l+44|0,j=k+12|0,t=a+4|0,q=k+8|0,v=a+8|0,a=m+4|0,x=b<<2,(s|0)>0):0){b=0;do{A=Y(b,i)|0;B=(f[c>>2]|0)+(A<<2)|0;A=f[g>>2]|0;if((A|0)!=(f[w>>2]|0)){C=f[A+(b<<3)>>2]|0;D=f[A+(b<<3)+4>>2]|0;A=f[e>>2]|0;if((((C|0)>=(0-A|0)?(C|0)<=((f[j>>2]|0)+A-(f[t>>2]|0)|0):0)?(A=f[r>>2]|0,(D|0)>=(0-A|0)):0)?(D|0)<=((f[q>>2]|0)+A-(f[v>>2]|0)|0):0){E=C;F=D;G=33}}else{D=f[d>>2]|0;C=((n-(f[y>>2]|0)|0)/(D|0)|0)+1|0;A=(b|0)/(C|0)|0;H=Y(b-(Y(C,A)|0)|0,D)|0;D=Y(f[o>>2]|0,A)|0;E=H-(f[e>>2]|0)|0;F=D-(f[r>>2]|0)|0;G=33}if((G|0)==33){G=0;D=0;do{H=(f[p+(D*12|0)+8>>2]|0)+F|0;A=B+(f[p+(D*12|0)>>2]<<2)|0;f[m>>2]=(f[p+(D*12|0)+4>>2]|0)+E;f[a>>2]=H;H=IVb(l,m,A)|0;if((H|0)!=(A|0))o1c(A|0,H|0,x|0)|0;D=D+1|0}while((D|0)<(s|0))}b=b+1|0}while(b>>>0<z>>>0)}eVb(l);l=k+36|0;z=f[l>>2]|0;if(z|0?(b=z+12|0,z=f[b>>2]|0,f[b>>2]=z+-1,(z|0)==1):0)V$(k);f[l>>2]=0;l=k+16|0;z=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[z>>2]|0)>0){l=f[k+40>>2]|0;b=0;do{f[l+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[z>>2]|0))}z=f[k+44>>2]|0;if((z|0)==(k+48|0)){u=h;return}wL(z);u=h;return}function tVb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0;k=u;u=u+448|0;l=k+384|0;m=k+376|0;o=k+48|0;q=k+32|0;r=k+24|0;s=k;t=k+16|0;do if((eS(c)|0)==65536){v=f[c+4>>2]|0;f[l>>2]=f[v>>2];w=l+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[v+8>>2];f[l+12>>2]=f[v+12>>2];f[l+16>>2]=f[v+16>>2];f[l+20>>2]=f[v+20>>2];f[l+24>>2]=f[v+24>>2];f[l+28>>2]=f[v+28>>2];f[l+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;A=l+44|0;f[A>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;U$(l,v);break}}else bS(l,c,-1);while(0);c=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;if((w|0)!=(c|0))f[v>>2]=w+(~((w+-8-c|0)>>>3)<<3);c=f[e>>2]|0;w=e+4|0;x=f[w>>2]|0;if((x|0)!=(c|0))f[w>>2]=x+(~((x+-8-c|0)>>>3)<<3);c=a+76|0;x=a+80|0;if((f[c>>2]|0)!=(f[x>>2]|0)){y=f[h>>2]|0;A=h+4|0;z=f[A>>2]|0;if(!(z|y)){B=f[a+28>>2]|0;f[h>>2]=B;C=f[a+32>>2]|0;f[A>>2]=C;D=C;E=B}else{D=z;E=y}y=f[a+20>>2]|0;z=(E|0)<(y|0);B=z?y:E;C=z?E:y;if((C|0)>0){y=B;E=C;while(1){C=(y|0)%(E|0)|0;if((C|0)>0){z=E;E=C;y=z}else{F=E;break}}}else F=B;B=f[a+24>>2]|0;E=(D|0)<(B|0);y=E?B:D;z=E?D:B;if((z|0)>0){B=y;D=z;while(1){z=(B|0)%(D|0)|0;if((z|0)>0){E=D;D=z;B=E}else{G=D;break}}}else G=y;f[m>>2]=F;y=m+4|0;f[y>>2]=G;D=j+4|0;B=(f[D>>2]|0)-(f[j>>2]|0)>>3;E=f[i>>2]|0;z=F+-1+((E|0)>0?E:0)&0-F;f[i>>2]=z;F=i+4|0;E=f[F>>2]|0;C=G+-1+((E|0)>0?E:0)&0-G;f[F>>2]=C;G=l+12|0;E=(z<<1)+(f[G>>2]|0)|0;z=l+8|0;H=(C<<1)+(f[z>>2]|0)|0;C=(B|0)==0;FVb(o,a,l,i,i,C,m);if(C)I=Y(((H-(f[o+48>>2]|0)|0)/(f[A>>2]|0)|0)+1|0,((E-(f[o+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else I=B;B=f[o+16>>2]|0;H=Y(f[o+64>>2]|0,f[o+60>>2]|0)|0;C=f[o+76>>2]|0;J=GVb(a)|0;K=f[c>>2]|0;if((f[x>>2]|0)-K>>2>>>0>J>>>0)L=+n[K+(J<<2)>>2];else L=0.0;M=L;f[q>>2]=0;J=q+4|0;f[J>>2]=0;f[q+8>>2]=0;do if(C)if(C>>>0>1073741823)kWc(q);else{K=C<<2;x=$Xc(K)|0;f[q>>2]=x;N=x+(C<<2)|0;f[q+8>>2]=N;g1c(x|0,0,K|0)|0;f[J>>2]=N;O=x;P=x;break}else{O=0;P=0}while(0);do if(I){x=r+4|0;N=o+44|0;K=(H|0)>0;Q=t+4|0;R=C+-4|0;S=(C|0)<4;T=d+8|0;U=e+8|0;V=a+4|0;W=a+8|0;X=C&-4;Z=(C|0)>0;_=(X|0)<(C|0);$=0;while(1){f[r>>2]=0;f[x>>2]=0;aa=f[j>>2]|0;if((aa|0)==(f[D>>2]|0)){ba=f[h>>2]|0;ca=((E-(f[N>>2]|0)|0)/(ba|0)|0)+1|0;da=($|0)/(ca|0)|0;ea=Y($-(Y(ca,da)|0)|0,ba)|0;ba=Y(f[A>>2]|0,da)|0;da=ea-(f[i>>2]|0)|0;ea=ba-(f[F>>2]|0)|0;f[r>>2]=da;f[x>>2]=ea;if((da|0)%(f[m>>2]|0)|0|0){fa=42;break}if(!((ea|0)%(f[y>>2]|0)|0)){ga=da;ha=ea;fa=43}else{fa=42;break}}else{ea=f[aa+($<<3)>>2]|0;f[r>>2]=ea;da=f[aa+($<<3)+4>>2]|0;f[x>>2]=da;aa=f[i>>2]|0;if((((ea|0)>=(0-aa|0)?(ea|0)<=((f[G>>2]|0)+aa-(f[V>>2]|0)|0):0)?(aa=f[F>>2]|0,(da|0)>=(0-aa|0)):0)?(da|0)<=((f[z>>2]|0)+aa-(f[W>>2]|0)|0):0){ga=ea;ha=da;fa=43}}if((fa|0)==43){fa=0;p[s>>3]=M;da=f[c>>2]|0;a:do if(K)if(S){ea=0;aa=da;ba=ga;ca=ha;while(1){ia=(f[B+(ea*12|0)+8>>2]|0)+ca|0;f[t>>2]=(f[B+(ea*12|0)+4>>2]|0)+ba;f[Q>>2]=ia;ia=IVb(o,t,f[q>>2]|0)|0;if(Z){ja=0;L=+p[s>>3];do{L=L+ +n[ia+(ja<<2)>>2]*+n[aa+(ja<<2)>>2];ja=ja+1|0}while((ja|0)!=(C|0));p[s>>3]=L}ja=ea+1|0;if((ja|0)>=(H|0))break;ea=ja;aa=aa+(C<<2)|0;ba=f[r>>2]|0;ca=f[x>>2]|0}ka=+p[s>>3];break}else{ca=0;ba=da;aa=ga;ea=ha;while(1){ja=(f[B+(ca*12|0)+8>>2]|0)+ea|0;f[t>>2]=(f[B+(ca*12|0)+4>>2]|0)+aa;f[Q>>2]=ja;ja=IVb(o,t,f[q>>2]|0)|0;ia=0;la=+p[s>>3];do{ma=ia|1;na=ia|2;oa=ia|3;la=la+(+n[ja+(ia<<2)>>2]*+n[ba+(ia<<2)>>2]+ +n[ja+(ma<<2)>>2]*+n[ba+(ma<<2)>>2]+ +n[ja+(na<<2)>>2]*+n[ba+(na<<2)>>2]+ +n[ja+(oa<<2)>>2]*+n[ba+(oa<<2)>>2]);ia=ia+4|0}while((ia|0)<=(R|0));p[s>>3]=la;if(_){ia=X;L=la;do{L=L+ +n[ja+(ia<<2)>>2]*+n[ba+(ia<<2)>>2];ia=ia+1|0}while((ia|0)!=(C|0));p[s>>3]=L;pa=L}else pa=la;ia=ca+1|0;if((ia|0)>=(H|0)){ka=pa;break a}ca=ia;ba=ba+(C<<2)|0;aa=f[r>>2]|0;ea=f[x>>2]|0}}else ka=M;while(0);do if(ka>=g){da=f[v>>2]|0;if((da|0)==(f[T>>2]|0))Nw(d,r);else{f[da>>2]=f[r>>2];f[da+4>>2]=f[x>>2];f[v>>2]=da+8}da=f[w>>2]|0;if((da|0)==(f[U>>2]|0)){xw(e,s);break}else{p[da>>3]=+p[s>>3];f[w>>2]=da+8;break}}while(0)}$=$+1|0;if($>>>0>=I>>>0){fa=29;break}}if((fa|0)==29){$=f[q>>2]|0;qa=$;ra=$;break}else if((fa|0)==42){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;$=$Xc(80)|0;f[s>>2]=$;f[s+8>>2]=-2147483568;f[s+4>>2]=65;U=$;x=470534;T=U+65|0;do{b[U>>0]=b[x>>0]|0;U=U+1|0;x=x+1|0}while((U|0)<(T|0));b[$+65>>0]=0;vM(-215,s,470600,469947,1710)}}else{qa=P;ra=O}while(0);if(qa|0){O=f[J>>2]|0;if((O|0)!=(qa|0))f[J>>2]=O+(~((O+-4-qa|0)>>>2)<<2);cYc(ra)}eVb(o)}o=l+36|0;ra=f[o>>2]|0;if(ra|0?(qa=ra+12|0,ra=f[qa>>2]|0,f[qa>>2]=ra+-1,(ra|0)==1):0)V$(l);f[o>>2]=0;o=l+16|0;ra=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[ra>>2]|0)>0){o=f[l+40>>2]|0;qa=0;do{f[o+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[ra>>2]|0))}ra=f[l+44>>2]|0;if((ra|0)==(l+48|0)){u=k;return}wL(ra);u=k;return}function uVb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;n=f[(f[a>>2]|0)+36>>2]|0;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];tg[n&7](a,b,c,j,d,k,l,h);h=f[j>>2]|0;if(!h){u=i;return}j=f[m>>2]|0;if((j|0)!=(h|0))f[m>>2]=j+(~((j+-8-h|0)>>>3)<<3);cYc(h);u=i;return}function vVb(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;l=u;u=u+304|0;m=l+112|0;n=l+288|0;o=l+276|0;q=l+264|0;r=l+252|0;s=l+240|0;t=l+228|0;v=l+200|0;w=l+144|0;x=l+136|0;y=l;z=l+128|0;A=l+120|0;p[m>>3]=1.0;cS(n,b,-1);f[o>>2]=0;B=o+4|0;f[B>>2]=0;f[o+8>>2]=0;C=a+140|0;a:do if((f[C>>2]|0)>0){D=o+8|0;E=a+4|0;F=n+4|0;G=a+8|0;if(!(i<=1.0)){H=0;I=0;J=1.0;K=0}else{xw(o,m);L=0;break}while(1){if((H|0)==(I|0))xw(o,m);else{p[H>>3]=J;f[B>>2]=H+8}M=+p[m>>3];N=zLc(+(f[n>>2]|0)/M)|0;if((N|0)<(f[E>>2]|0)){L=K;break a}N=zLc(+(f[F>>2]|0)/M)|0;if((N|0)<(f[G>>2]|0)){L=K;break a}O=M*i;p[m>>3]=O;N=K+1|0;if((N|0)>=(f[C>>2]|0)){L=N;break a}H=f[B>>2]|0;I=f[D>>2]|0;J=O;K=N}}else L=0;while(0);K=(L|0)>1?L:1;L=f[B>>2]|0;I=f[o>>2]|0;H=L-I>>3;C=I;I=L;if(K>>>0<=H>>>0){if(K>>>0<H>>>0?(L=C+(K<<3)|0,(I|0)!=(L|0)):0)f[B>>2]=I+(~((I+-8-L|0)>>>3)<<3)}else Voa(o,K-H|0);H=g+4|0;if(!(f[H>>2]|f[g>>2])){f[g>>2]=f[a+20>>2];f[H>>2]=f[a+24>>2]}f[q>>2]=0;H=q+4|0;f[H>>2]=0;f[q+8>>2]=0;f[r>>2]=0;K=r+4|0;f[K>>2]=0;f[r+8>>2]=0;f[s>>2]=0;L=s+4|0;f[L>>2]=0;f[s+8>>2]=0;f[t>>2]=0;I=t+4|0;f[I>>2]=0;f[t+8>>2]=0;WXc(v);do if((eS(b)|0)==65536){C=f[b+4>>2]|0;f[w>>2]=f[C>>2];m=w+4|0;D=C+4|0;f[m>>2]=f[D>>2];G=w+8|0;f[G>>2]=f[C+8>>2];f[w+12>>2]=f[C+12>>2];f[w+16>>2]=f[C+16>>2];f[w+20>>2]=f[C+20>>2];f[w+24>>2]=f[C+24>>2];f[w+28>>2]=f[C+28>>2];f[w+32>>2]=f[C+32>>2];F=f[C+36>>2]|0;f[w+36>>2]=F;f[w+40>>2]=G;G=w+48|0;E=w+44|0;f[E>>2]=G;f[G>>2]=0;f[w+52>>2]=0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[D>>2]|0)<3){D=f[C+44>>2]|0;G=f[E>>2]|0;f[G>>2]=f[D>>2];f[G+4>>2]=f[D+4>>2];break}else{f[m>>2]=0;U$(w,C);break}}else bS(w,b,-1);while(0);b=f[o>>2]|0;C=(f[B>>2]|0)-b>>3;f[x>>2]=0;f[x+4>>2]=C;JVb(y,a,w,e,g,h,b,q,v,s,r);h3(x,y,-1.0);x=f[r>>2]|0;b=f[K>>2]|0;if((x|0)!=(b|0)){h=t+8|0;g=x;do{x=f[I>>2]|0;if((x|0)==(f[h>>2]|0))xw(t,g);else{p[x>>3]=+p[g>>3];f[I>>2]=x+8}g=g+8|0}while((g|0)!=(b|0))}b=f[c>>2]|0;g=c+4|0;h=f[g>>2]|0;if((h|0)==(b|0))P=b;else{x=h+(~((h+-16-b|0)>>>4)<<4)|0;f[g>>2]=x;P=x}x=f[q>>2]|0;b=f[H>>2]|0;b:do if((x|0)!=(b|0)){h=c+8|0;C=P;m=x;while(1){if((C|0)==(f[h>>2]|0))vx(c,m);else{f[C>>2]=f[m>>2];f[C+4>>2]=f[m+4>>2];f[C+8>>2]=f[m+8>>2];f[C+12>>2]=f[m+12>>2];f[g>>2]=C+16}D=m+16|0;if((D|0)==(b|0))break b;C=f[g>>2]|0;m=D}}while(0);g=f[d>>2]|0;b=d+4|0;x=f[b>>2]|0;if((x|0)==(g|0))Q=g;else{P=x+(~((x+-8-g|0)>>>3)<<3)|0;f[b>>2]=P;Q=P}P=f[s>>2]|0;g=f[L>>2]|0;c:do if((P|0)!=(g|0)){x=d+8|0;m=P;C=Q;while(1){if((C|0)==(f[x>>2]|0))xw(d,m);else{p[C>>3]=+p[m>>3];f[b>>2]=C+8}h=m+8|0;if((h|0)==(g|0))break c;m=h;C=f[b>>2]|0}}while(0);if(k){f[z>>2]=f[a+4>>2];f[z+4>>2]=f[a+8>>2];JUb(c,d,t,j,z)}else KVb(0,c,d,~~j,.2);f[A>>2]=f[n>>2];f[A+4>>2]=f[n+4>>2];aVb(A,c,0,d);f[y>>2]=141744;d=y+8|0;c=y+44|0;A=f[c>>2]|0;if(A|0?(n=A+12|0,A=f[n>>2]|0,f[n>>2]=A+-1,(A|0)==1):0)V$(d);f[c>>2]=0;c=y+24|0;d=y+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[y+48>>2]|0;A=0;do{f[c+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[d>>2]|0))}d=f[y+52>>2]|0;if((d|0)!=(y+56|0))wL(d);d=w+36|0;y=f[d>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)V$(w);f[d>>2]=0;d=w+16|0;y=w+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[y>>2]|0)>0){d=f[w+40>>2]|0;A=0;do{f[d+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[y>>2]|0))}y=f[w+44>>2]|0;if((y|0)!=(w+48|0))wL(y);XXc(v);v=f[t>>2]|0;if(v|0){t=f[I>>2]|0;if((t|0)!=(v|0))f[I>>2]=t+(~((t+-8-v|0)>>>3)<<3);cYc(v)}v=f[s>>2]|0;if(v|0){s=f[L>>2]|0;if((s|0)!=(v|0))f[L>>2]=s+(~((s+-8-v|0)>>>3)<<3);cYc(v)}v=f[r>>2]|0;if(v|0){r=f[K>>2]|0;if((r|0)!=(v|0))f[K>>2]=r+(~((r+-8-v|0)>>>3)<<3);cYc(v)}v=f[q>>2]|0;if(v|0){q=f[H>>2]|0;if((q|0)!=(v|0))f[H>>2]=q+(~((q+-16-v|0)>>>4)<<4);cYc(v)}v=f[o>>2]|0;if(!v){u=l;return}o=f[B>>2]|0;if((o|0)!=(v|0))f[B>>2]=o+(~((o+-8-v|0)>>>3)<<3);cYc(v);u=l;return}function wVb(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l>>2]=0;o=l+4|0;f[o>>2]=0;f[l+8>>2]=0;p=f[(f[a>>2]|0)+44>>2]|0;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];Yg[p&3](a,b,c,l,d,m,n,h,i,j);j=f[l>>2]|0;if(!j){u=k;return}l=f[o>>2]|0;if((l|0)!=(j|0))f[o>>2]=l+(~((l+-8-j|0)>>>3)<<3);cYc(j);u=k;return}function xVb(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0;j=u;u=u+2672|0;k=j+2656|0;l=j+2584|0;m=j+2648|0;o=j+2640|0;p=j+2528|0;q=j+2472|0;r=j+2464|0;s=j+2456|0;t=j+2400|0;v=j+1336|0;w=j+272|0;x=j+216|0;y=j+160|0;z=j+104|0;A=j+48|0;B=j+32|0;C=j+16|0;D=j;do if((eS(c)|0)==65536){E=f[c+4>>2]|0;f[l>>2]=f[E>>2];F=l+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=l+8|0;f[H>>2]=f[E+8>>2];f[l+12>>2]=f[E+12>>2];I=l+16|0;f[I>>2]=f[E+16>>2];f[l+20>>2]=f[E+20>>2];f[l+24>>2]=f[E+24>>2];f[l+28>>2]=f[E+28>>2];f[l+32>>2]=f[E+32>>2];J=f[E+36>>2]|0;f[l+36>>2]=J;f[l+40>>2]=H;H=l+48|0;K=l+44|0;f[K>>2]=H;f[H>>2]=0;f[l+52>>2]=0;if(J|0){H=J+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[K>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];L=I;break}else{f[F>>2]=0;U$(l,E);L=I;break}}else{bS(l,c,-1);L=l+16|0}while(0);if(!(f[L>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;N=$Xc(16)|0;f[k>>2]=N;O=k+8|0;f[O>>2]=-2147483632;P=k+4|0;f[P>>2]=12;Q=N;R=470240;S=Q+12|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));T=N+12|0;b[T>>0]=0;vM(-215,k,470253,469947,243)}c=l+4|0;I=f[c>>2]|0;if((I|0)<3)U=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{E=f[l+40>>2]|0;F=0;G=1;while(1){H=Y(f[E+(F<<2)>>2]|0,G)|0;F=F+1|0;if((F|0)==(I|0)){U=H;break}else G=H}}if((I|0)==0|(U|0)==0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;N=$Xc(16)|0;f[k>>2]=N;O=k+8|0;f[O>>2]=-2147483632;P=k+4|0;f[P>>2]=12;Q=N;R=470240;S=Q+12|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));T=N+12|0;b[T>>0]=0;vM(-215,k,470253,469947,243)}switch(f[l>>2]&4095){case 16:case 0:break;default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;T=$Xc(48)|0;f[k>>2]=T;f[k+8>>2]=-2147483600;f[k+4>>2]=44;Q=T;R=470269;S=Q+44|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[T+44>>0]=0;vM(-215,k,470253,469947,244)}}T=f[l+12>>2]|0;N=f[g>>2]|0;P=f[i>>2]|0;O=N+T+P|0;U=g+4|0;I=(f[U>>2]|0)+(f[l+8>>2]|0)+(f[i+4>>2]|0)|0;f[m>>2]=O;f[m+4>>2]=I;wS(d,m,13,-1,0,0);f[o>>2]=O;f[o+4>>2]=I;wS(e,o,8,-1,0,0);do if((eS(d)|0)==65536){o=f[d+4>>2]|0;f[p>>2]=f[o>>2];m=p+4|0;i=o+4|0;f[m>>2]=f[i>>2];G=p+8|0;f[G>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];f[p+16>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];F=f[o+36>>2]|0;f[p+36>>2]=F;f[p+40>>2]=G;G=p+48|0;E=p+44|0;f[E>>2]=G;f[G>>2]=0;f[p+52>>2]=0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[i>>2]|0)<3){i=f[o+44>>2]|0;G=f[E>>2]|0;f[G>>2]=f[i>>2];f[G+4>>2]=f[i+4>>2];break}else{f[m>>2]=0;U$(p,o);break}}else bS(p,d,-1);while(0);do if((eS(e)|0)==65536){d=f[e+4>>2]|0;f[q>>2]=f[d>>2];o=q+4|0;m=d+4|0;f[o>>2]=f[m>>2];i=q+8|0;f[i>>2]=f[d+8>>2];f[q+12>>2]=f[d+12>>2];f[q+16>>2]=f[d+16>>2];f[q+20>>2]=f[d+20>>2];f[q+24>>2]=f[d+24>>2];f[q+28>>2]=f[d+28>>2];f[q+32>>2]=f[d+32>>2];G=f[d+36>>2]|0;f[q+36>>2]=G;f[q+40>>2]=i;i=q+48|0;E=q+44|0;f[E>>2]=i;f[i>>2]=0;f[q+52>>2]=0;if(G|0){i=G+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[m>>2]|0)<3){m=f[d+44>>2]|0;i=f[E>>2]|0;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];break}else{f[o>>2]=0;U$(q,d);break}}else bS(q,e,-1);while(0);f[r>>2]=0;e=r+4|0;f[e>>2]=0;f[s>>2]=0;d=s+4|0;f[d>>2]=0;e0(l,r,s);o=(f[l>>2]|0)>>>3&511;f[t>>2]=1124007936;m=t+4|0;i=t+8|0;E=t+40|0;Q=m;S=Q+36|0;do{f[Q>>2]=0;Q=Q+4|0}while((Q|0)<(S|0));f[E>>2]=i;i=t+48|0;G=t+44|0;f[G>>2]=i;f[i>>2]=0;f[t+52>>2]=0;f[k>>2]=1;f[k+4>>2]=256;S$(t,2,k,5);F=t+16|0;H=f[F>>2]|0;if(!(b[a+72>>0]|0)){K=0;do{n[H+(K<<2)>>2]=+(K|0);K=K+1|0}while((K|0)!=256)}else{K=0;do{V=+M(+(+(K|0)));n[H+(K<<2)>>2]=V;K=K+1|0}while((K|0)!=256)}K=O+4+I|0;J=v+8|0;f[v>>2]=J;W=v+4|0;f[W>>2]=K;if(K>>>0>264){X=bYc(K>>>0>1073741823?-1:K<<2)|0;f[v>>2]=X;Z=X}else Z=J;X=Z+4|0;K=X+(O<<2)+8|0;if((O|0)>=-1){_=-1;while(1){$=qR(_-(f[g>>2]|0)+(f[s>>2]|0)|0,f[r>>2]|0,4)|0;f[X+(_<<2)>>2]=$-(f[s>>2]|0);if((_|0)<(O|0))_=_+1|0;else break}}if((I|0)>=-1){_=-1;while(1){s=qR(_-(f[U>>2]|0)+(f[d>>2]|0)|0,f[e>>2]|0,4)|0;f[K+(_<<2)>>2]=s-(f[d>>2]|0);if((_|0)<(I|0))_=_+1|0;else break}}_=O<<2;d=w+8|0;f[w>>2]=d;e=w+4|0;f[e>>2]=_;if(_>>>0>264){U=bYc(_>>>0>1073741823?-1:_<<2)|0;f[w>>2]=U;aa=U}else aa=d;f[x>>2]=1124007941;U=x+4|0;f[U>>2]=2;s=x+8|0;f[s>>2]=1;f[x+12>>2]=O;r=x+16|0;f[r>>2]=aa;f[x+20>>2]=aa;g=x+24|0;$=x+40|0;ba=g+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[$>>2]=s;s=x+48|0;ba=x+44|0;f[ba>>2]=s;ca=(O|0)!=0;f[s>>2]=_;f[x+52>>2]=4;da=aa+(O<<2)|0;f[x+28>>2]=da;ea=0-_|0;f[g>>2]=da+ea+_;R$(x);f[y>>2]=1124007941;g=y+4|0;f[g>>2]=2;fa=y+8|0;f[fa>>2]=1;f[y+12>>2]=O;ga=y+16|0;f[ga>>2]=da;f[y+20>>2]=da;ha=y+24|0;ia=y+40|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;f[ia>>2]=fa;fa=y+48|0;ja=y+44|0;f[ja>>2]=fa;ka=y+52|0;f[ka>>2]=0;f[fa>>2]=0;if(ca&(da|0)==0){la=$Xc(32)|0;f[k>>2]=la;f[k+8>>2]=-2147483616;f[k+4>>2]=28;Q=la;R=470314;S=Q+28|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[la+28>>0]=0;vM(-215,k,470343,470347,548)}f[fa>>2]=_;f[ka>>2]=4;ka=da+(O<<2)|0;f[y+28>>2]=ka;f[ha>>2]=ka+ea+_;R$(y);ka=O<<1;ha=aa+(ka<<2)|0;f[z>>2]=1124007941;da=z+4|0;f[da>>2]=2;la=z+8|0;f[la>>2]=1;f[z+12>>2]=O;ma=z+16|0;f[ma>>2]=ha;f[z+20>>2]=ha;na=z+24|0;oa=z+40|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;f[oa>>2]=la;la=z+48|0;pa=z+44|0;f[pa>>2]=la;qa=z+52|0;f[qa>>2]=0;f[la>>2]=0;if(ca&(ha|0)==0){ra=$Xc(32)|0;f[k>>2]=ra;f[k+8>>2]=-2147483616;f[k+4>>2]=28;Q=ra;R=470314;S=Q+28|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[ra+28>>0]=0;vM(-215,k,470343,470347,548)}f[la>>2]=_;f[qa>>2]=4;qa=ha+(O<<2)|0;f[z+28>>2]=qa;f[na>>2]=qa+ea+_;R$(z);qa=O*3|0;na=aa+(qa<<2)|0;f[A>>2]=1124007941;ha=A+4|0;f[ha>>2]=2;ra=A+8|0;f[ra>>2]=1;f[A+12>>2]=O;sa=A+16|0;f[sa>>2]=na;f[A+20>>2]=na;ta=A+24|0;ua=A+40|0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;f[ua>>2]=ra;ra=A+48|0;va=A+44|0;f[va>>2]=ra;wa=A+52|0;f[wa>>2]=0;f[ra>>2]=0;if(ca&(na|0)==0){ca=$Xc(32)|0;f[k>>2]=ca;f[k+8>>2]=-2147483616;f[k+4>>2]=28;Q=ca;R=470314;S=Q+28|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[ca+28>>0]=0;vM(-215,k,470343,470347,548)}f[ra>>2]=_;f[wa>>2]=4;wa=na+(O<<2)|0;f[A+28>>2]=wa;f[ta>>2]=wa+ea+_;R$(A);if((o|0)==2&(O|0)>-2){_=T+P+N+1|0;N=0;while(1){P=Z+(N<<2)|0;f[P>>2]=(f[P>>2]|0)*3;if((N|0)==(_|0))break;else N=N+1|0}}N=a+36|0;V=+(f[N>>2]|0)/(b[a+144>>0]|0?6.283185307179586:3.141592653589793);a:do if((I|0)>0){a=l+44|0;_=l+48|0;Z=p+16|0;P=p+44|0;T=q+16|0;ea=q+44|0;wa=(o|0)==0;ta=k+8|0;na=k+12|0;ca=k+4|0;xa=B+8|0;ya=B+12|0;za=B+4|0;Aa=C+8|0;Ba=C+4|0;Ca=D+8|0;Da=D+4|0;Ea=(O|0)>0;Fa=0;b:while(1){Ga=f[L>>2]|0;Ha=Ga+(Y(f[f[a>>2]>>2]|0,f[K+(Fa<<2)>>2]|0)|0)|0;Ia=f[_>>2]|0;Ja=Ga+(Y(f[K+(Fa+-1<<2)>>2]|0,Ia)|0)|0;Ka=Fa;Fa=Fa+1|0;La=Ga+(Y(f[K+(Fa<<2)>>2]|0,Ia)|0)|0;Ia=(f[Z>>2]|0)+(Y(f[f[P>>2]>>2]|0,Ka)|0)|0;Ga=(f[T>>2]|0)+(Y(f[f[ea>>2]>>2]|0,Ka)|0)|0;do if(wa){if(!Ea)break;Ka=0;Ma=f[X>>2]|0;do{Na=Ka;Ka=Ka+1|0;Oa=Ma;Ma=f[X+(Ka<<2)>>2]|0;n[aa+(Na<<2)>>2]=+n[H+(h[Ha+Ma>>0]<<2)>>2]-+n[H+(h[Ha+(f[X+(Na+-1<<2)>>2]|0)>>0]<<2)>>2];n[aa+(Na+O<<2)>>2]=+n[H+(h[La+Oa>>0]<<2)>>2]-+n[H+(h[Ja+Oa>>0]<<2)>>2]}while((Ka|0)!=(O|0))}else{if(!Ea)break;Ka=0;Ma=f[X>>2]|0;do{Oa=Ka;Ka=Ka+1|0;Na=Ma;Ma=f[X+(Ka<<2)>>2]|0;Pa=Ha+Ma|0;Qa=Ha+(f[X+(Oa+-1<<2)>>2]|0)|0;Ra=+n[H+(h[Pa+2>>0]<<2)>>2]-+n[H+(h[Qa+2>>0]<<2)>>2];Sa=Na+2|0;Ta=+n[H+(h[La+Sa>>0]<<2)>>2]-+n[H+(h[Ja+Sa>>0]<<2)>>2];Ua=Ra*Ra+Ta*Ta;Va=+n[H+(h[Pa+1>>0]<<2)>>2]-+n[H+(h[Qa+1>>0]<<2)>>2];Sa=Na+1|0;Wa=+n[H+(h[La+Sa>>0]<<2)>>2]-+n[H+(h[Ja+Sa>>0]<<2)>>2];Xa=Va*Va+Wa*Wa;Sa=Ua<Xa;Ya=+n[H+(h[Pa>>0]<<2)>>2]-+n[H+(h[Qa>>0]<<2)>>2];Za=+n[H+(h[La+Na>>0]<<2)>>2]-+n[H+(h[Ja+Na>>0]<<2)>>2];Na=(Sa?Xa:Ua)<Ya*Ya+Za*Za;n[aa+(Oa<<2)>>2]=Na?Ya:Sa?Va:Ra;n[aa+(Oa+O<<2)>>2]=Na?Za:Sa?Wa:Ta}while((Ka|0)!=(O|0))}while(0);f[ta>>2]=0;f[na>>2]=0;f[k>>2]=16842752;f[ca>>2]=x;f[xa>>2]=0;f[ya>>2]=0;f[B>>2]=16842752;f[za>>2]=y;Ja=Aa;f[Ja>>2]=0;f[Ja+4>>2]=0;f[C>>2]=33619968;f[Ba>>2]=z;Ja=Ca;f[Ja>>2]=0;f[Ja+4>>2]=0;f[D>>2]=33619968;f[Da>>2]=A;ML(k,B,C,D,0);if(Ea){Ja=0;do{Ta=+n[aa+(Ja+ka<<2)>>2];Wa=V*+n[aa+(Ja+qa<<2)>>2]+-.5;La=~~Wa;Ha=La-(+(La|0)>Wa&1)|0;Za=Wa-+(Ha|0);La=Ja<<1;n[Ia+(La<<2)>>2]=Ta*(1.0-Za);Ka=La|1;n[Ia+(Ka<<2)>>2]=Ta*Za;Ma=f[N>>2]|0;if((Ha|0)<0)_a=Ha+Ma|0;else _a=Ha-((Ha|0)<(Ma|0)?0:Ma)|0;if(_a>>>0>=Ma>>>0)break b;b[Ga+La>>0]=_a;La=_a+1|0;b[Ga+Ka>>0]=(La|0)<(f[N>>2]|0)?La&255:0;Ja=Ja+1|0}while((Ja|0)<(O|0))}if((Fa|0)>=(I|0))break a}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;Fa=$Xc(48)|0;f[k>>2]=Fa;f[k+8>>2]=-2147483600;f[k+4>>2]=32;Q=Fa;R=470433;S=Q+32|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[Fa+32>>0]=0;vM(-215,k,470253,469947,544)}while(0);k=A+36|0;R=f[k>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)V$(A);f[k>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[ha>>2]|0)>0){sa=f[ua>>2]|0;ua=0;do{f[sa+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[ha>>2]|0))}ha=f[va>>2]|0;if((ha|0)!=(ra|0))wL(ha);ha=z+36|0;ra=f[ha>>2]|0;do if(ra|0){va=ra+12|0;ua=f[va>>2]|0;f[va>>2]=ua+-1;if((ua|0)!=1)break;V$(z)}while(0);f[ha>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[da>>2]|0)>0){ma=f[oa>>2]|0;oa=0;do{f[ma+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[da>>2]|0))}da=f[pa>>2]|0;if((da|0)!=(la|0))wL(da);da=y+36|0;la=f[da>>2]|0;do if(la|0){pa=la+12|0;oa=f[pa>>2]|0;f[pa>>2]=oa+-1;if((oa|0)!=1)break;V$(y)}while(0);f[da>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[g>>2]|0)>0){ga=f[ia>>2]|0;ia=0;do{f[ga+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[g>>2]|0))}g=f[ja>>2]|0;if((g|0)!=(fa|0))wL(g);g=x+36|0;fa=f[g>>2]|0;do if(fa|0){ja=fa+12|0;ia=f[ja>>2]|0;f[ja>>2]=ia+-1;if((ia|0)!=1)break;V$(x)}while(0);f[g>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[U>>2]|0)>0){r=f[$>>2]|0;$=0;do{f[r+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[U>>2]|0))}U=f[ba>>2]|0;if((U|0)!=(s|0))wL(U);U=f[w>>2]|0;if((U|0)!=(d|0)){if(U|0)dYc(U);f[w>>2]=d;f[e>>2]=264}e=f[v>>2]|0;if((e|0)!=(J|0)){if(e|0)dYc(e);f[v>>2]=J;f[W>>2]=264}W=t+36|0;J=f[W>>2]|0;do if(J|0){v=J+12|0;e=f[v>>2]|0;f[v>>2]=e+-1;if((e|0)!=1)break;V$(t)}while(0);f[W>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[m>>2]|0)>0){F=f[E>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[m>>2]|0))}m=f[G>>2]|0;if((m|0)!=(i|0))wL(m);m=q+36|0;i=f[m>>2]|0;do if(i|0){G=i+12|0;E=f[G>>2]|0;f[G>>2]=E+-1;if((E|0)!=1)break;V$(q)}while(0);f[m>>2]=0;m=q+16|0;i=q+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[i>>2]|0)>0){m=f[q+40>>2]|0;E=0;do{f[m+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[i>>2]|0))}i=f[q+44>>2]|0;if((i|0)!=(q+48|0))wL(i);i=p+36|0;q=f[i>>2]|0;do if(q|0){E=q+12|0;m=f[E>>2]|0;f[E>>2]=m+-1;if((m|0)!=1)break;V$(p)}while(0);f[i>>2]=0;i=p+16|0;q=p+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[q>>2]|0)>0){i=f[p+40>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[q>>2]|0))}q=f[p+44>>2]|0;if((q|0)!=(p+48|0))wL(q);q=l+36|0;p=f[q>>2]|0;do if(p|0){m=p+12|0;i=f[m>>2]|0;f[m>>2]=i+-1;if((i|0)!=1)break;V$(l)}while(0);f[q>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[c>>2]|0)>0){L=f[l+40>>2]|0;q=0;do{f[L+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[c>>2]|0))}c=f[l+44>>2]|0;if((c|0)==(l+48|0)){u=j;return}wL(c);u=j;return}function yVb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0;j=u;u=u+432|0;k=j+376|0;l=j+368|0;m=j+40|0;o=j+24|0;q=j+16|0;r=j;s=j+8|0;do if((eS(b)|0)==65536){t=f[b+4>>2]|0;f[k>>2]=f[t>>2];v=k+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=k+8|0;f[x>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[k+16>>2]=f[t+16>>2];f[k+20>>2]=f[t+20>>2];f[k+24>>2]=f[t+24>>2];f[k+28>>2]=f[t+28>>2];f[k+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=x;x=k+48|0;z=k+44|0;f[z>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;U$(k,t);break}}else bS(k,b,-1);while(0);b=f[d>>2]|0;t=d+4|0;v=f[t>>2]|0;if((v|0)!=(b|0))f[t>>2]=v+(~((v+-8-b|0)>>>3)<<3);b=f[e>>2]|0;v=e+4|0;w=f[v>>2]|0;if((w|0)!=(b|0))f[v>>2]=w+(~((w+-8-b|0)>>>3)<<3);b=a+76|0;w=a+80|0;if((f[b>>2]|0)!=(f[w>>2]|0)?(x=f[c>>2]|0,z=f[c+4>>2]|0,y=z,A=x,(x|0)!=(z|0)):0){z=f[h>>2]|0;x=h+4|0;B=f[x>>2]|0;if(!(B|z)){C=f[a+28>>2]|0;f[h>>2]=C;D=f[a+32>>2]|0;f[x>>2]=D;E=C;F=D}else{E=z;F=B}B=f[a+20>>2]|0;z=(E|0)<(B|0);D=z?B:E;C=z?E:B;if((C|0)>0){B=D;E=C;while(1){C=(B|0)%(E|0)|0;if((C|0)>0){z=E;E=C;B=z}else{G=E;break}}}else G=D;D=f[a+24>>2]|0;E=(F|0)<(D|0);B=E?D:F;z=E?F:D;if((z|0)>0){D=B;F=z;while(1){z=(D|0)%(F|0)|0;if((z|0)>0){E=F;F=z;D=E}else{H=F;break}}}else H=B;f[l>>2]=G;f[l+4>>2]=H;B=y-A>>3;A=f[i>>2]|0;y=G+-1+((A|0)>0?A:0)&0-G;f[i>>2]=y;G=i+4|0;A=f[G>>2]|0;F=H+-1+((A|0)>0?A:0)&0-H;f[G>>2]=F;H=k+12|0;A=(y<<1)+(f[H>>2]|0)|0;y=k+8|0;D=(F<<1)+(f[y>>2]|0)|0;FVb(m,a,k,i,i,1,l);if(!B)I=Y(((D-(f[m+48>>2]|0)|0)/(f[x>>2]|0)|0)+1|0,((A-(f[m+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else I=B;B=f[m+16>>2]|0;h=Y(f[m+64>>2]|0,f[m+60>>2]|0)|0;A=f[m+76>>2]|0;x=GVb(a)|0;D=f[b>>2]|0;if((f[w>>2]|0)-D>>2>>>0>x>>>0)J=+n[D+(x<<2)>>2];else J=0.0;K=J;f[o>>2]=0;x=o+4|0;f[x>>2]=0;f[o+8>>2]=0;do if(A)if(A>>>0>1073741823)kWc(o);else{D=A<<2;w=$Xc(D)|0;f[o>>2]=w;l=w+(A<<2)|0;f[o+8>>2]=l;g1c(w|0,0,D|0)|0;f[x>>2]=l;L=w;M=w;break}else{L=0;M=0}while(0);if(!I){N=M;O=L}else{L=q+4|0;M=e+8|0;w=a+4|0;l=a+8|0;a=(h|0)>0;D=s+4|0;F=A+-4|0;E=(A|0)<4;z=d+8|0;C=A&-4;P=(A|0)>0;Q=(C|0)<(A|0);R=0;do{f[q>>2]=0;f[L>>2]=0;S=f[c>>2]|0;T=f[S+(R<<3)>>2]|0;f[q>>2]=T;U=f[S+(R<<3)+4>>2]|0;f[L>>2]=U;S=f[i>>2]|0;if((((T|0)>=(0-S|0)?(T|0)<=((f[H>>2]|0)+S-(f[w>>2]|0)|0):0)?(S=f[G>>2]|0,(U|0)>=(0-S|0)):0)?(U|0)<=((f[y>>2]|0)+S-(f[l>>2]|0)|0):0){p[r>>3]=K;S=f[b>>2]|0;a:do if(a){if(E){V=0;W=S;X=T;Z=U;while(1){_=(f[B+(V*12|0)+8>>2]|0)+Z|0;f[s>>2]=(f[B+(V*12|0)+4>>2]|0)+X;f[D>>2]=_;_=IVb(m,s,f[o>>2]|0)|0;if(P){$=0;J=+p[r>>3];do{J=J+ +n[_+($<<2)>>2]*+n[W+($<<2)>>2];$=$+1|0}while(($|0)!=(A|0));p[r>>3]=J}$=V+1|0;if(($|0)>=(h|0))break a;V=$;W=W+(A<<2)|0;X=f[q>>2]|0;Z=f[L>>2]|0}}else{aa=0;ba=S;ca=T;da=U}while(1){Z=(f[B+(aa*12|0)+8>>2]|0)+da|0;f[s>>2]=(f[B+(aa*12|0)+4>>2]|0)+ca;f[D>>2]=Z;Z=IVb(m,s,f[o>>2]|0)|0;X=0;ea=+p[r>>3];do{W=X|1;V=X|2;$=X|3;ea=ea+(+n[Z+(X<<2)>>2]*+n[ba+(X<<2)>>2]+ +n[Z+(W<<2)>>2]*+n[ba+(W<<2)>>2]+ +n[Z+(V<<2)>>2]*+n[ba+(V<<2)>>2]+ +n[Z+($<<2)>>2]*+n[ba+($<<2)>>2]);X=X+4|0}while((X|0)<=(F|0));p[r>>3]=ea;if(Q){X=C;J=ea;do{J=J+ +n[Z+(X<<2)>>2]*+n[ba+(X<<2)>>2];X=X+1|0}while((X|0)!=(A|0));p[r>>3]=J}X=aa+1|0;if((X|0)>=(h|0))break a;aa=X;ba=ba+(A<<2)|0;ca=f[q>>2]|0;da=f[L>>2]|0}}while(0);U=f[v>>2]|0;if((U|0)==(f[M>>2]|0))xw(e,r);else{p[U>>3]=+p[r>>3];f[v>>2]=U+8}do if(+p[r>>3]>=g){U=f[t>>2]|0;if((U|0)==(f[z>>2]|0)){Nw(d,q);break}else{f[U>>2]=f[q>>2];f[U+4>>2]=f[L>>2];f[t>>2]=U+8;break}}while(0)}else{p[r>>3]=-10.0;U=f[v>>2]|0;if(U>>>0<(f[M>>2]|0)>>>0){p[U>>3]=-10.0;f[v>>2]=U+8}else HVb(e,r)}R=R+1|0}while(R>>>0<I>>>0);I=f[o>>2]|0;N=I;O=I}if(N|0){I=f[x>>2]|0;if((I|0)!=(N|0))f[x>>2]=I+(~((I+-4-N|0)>>>2)<<2);cYc(O)}eVb(m)}m=k+36|0;O=f[m>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)V$(k);f[m>>2]=0;m=k+16|0;O=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[O>>2]|0)>0){m=f[k+40>>2]|0;N=0;do{f[m+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[k+44>>2]|0;if((O|0)==(k+48|0)){u=j;return}wL(O);u=j;return}function zVb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+208|0;i=h+152|0;j=h+140|0;k=h+112|0;l=h+104|0;m=h;n=h+96|0;do if((eS(b)|0)==65536){o=f[b+4>>2]|0;f[i>>2]=f[o>>2];p=i+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=i+8|0;f[r>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];f[i+16>>2]=f[o+16>>2];f[i+20>>2]=f[o+20>>2];f[i+24>>2]=f[o+24>>2];f[i+28>>2]=f[o+28>>2];f[i+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[i+36>>2]=s;f[i+40>>2]=r;r=i+48|0;t=i+44|0;f[t>>2]=r;f[r>>2]=0;f[i+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(i,o);break}}else bS(i,b,-1);while(0);f[j>>2]=0;b=j+4|0;f[b>>2]=0;f[j+8>>2]=0;WXc(k);o=(f[d+4>>2]|0)-(f[d>>2]|0)>>5;f[l>>2]=0;f[l+4>>2]=o;f[n>>2]=8;f[n+4>>2]=8;AVb(m,a,i,e,n,d,j,k);h3(l,m,-1.0);f[m>>2]=141724;l=m+8|0;d=m+44|0;n=f[d>>2]|0;if(n|0?(a=n+12|0,n=f[a>>2]|0,f[a>>2]=n+-1,(n|0)==1):0)V$(l);f[d>>2]=0;d=m+24|0;l=m+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[l>>2]|0)>0){d=f[m+48>>2]|0;n=0;do{f[d+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[m+52>>2]|0;if((l|0)!=(m+56|0))wL(l);l=f[b>>2]|0;m=f[j>>2]|0;n=l-m>>4;d=c+4|0;a=f[d>>2]|0;o=f[c>>2]|0;p=a-o>>4;q=o;o=a;a=m;m=l;if(n>>>0<=p>>>0)if(n>>>0<p>>>0?(l=q+(n<<4)|0,(o|0)!=(l|0)):0){f[d>>2]=o+(~((o+-16-l|0)>>>4)<<4);v=a;w=m}else{v=a;w=m}else{BVb(c,n-p|0);v=f[j>>2]|0;w=f[b>>2]|0}if((v|0)!=(w|0)){p=v;v=f[c>>2]|0;while(1){f[v>>2]=f[p>>2];f[v+4>>2]=f[p+4>>2];f[v+8>>2]=f[p+8>>2];f[v+12>>2]=f[p+12>>2];p=p+16|0;if((p|0)==(w|0))break;else v=v+16|0}}HUb(c,g,.2);XXc(k);k=f[j>>2]|0;if(k|0){j=f[b>>2]|0;if((j|0)!=(k|0))f[b>>2]=j+(~((j+-16-k|0)>>>4)<<4);cYc(k)}k=i+36|0;j=f[k>>2]|0;if(j|0?(b=j+12|0,j=f[b>>2]|0,f[b>>2]=j+-1,(j|0)==1):0)V$(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;b=0;do{f[k+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=h;return}wL(j);u=h;return}function AVb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f[a>>2]=141724;j=a+8|0;f[j>>2]=1124007936;k=a+12|0;l=a+16|0;m=a+48|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;n=a+56|0;o=a+52|0;f[o>>2]=n;f[n>>2]=0;f[a+60>>2]=0;n=a+76|0;f[n>>2]=0;q=a+80|0;f[q>>2]=0;f[a+4>>2]=b;if((j|0)==(c|0)){r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}b=c+36|0;y=f[b>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=a+44|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){V$(j);B=z}else B=z}else B=a+44|0;f[B>>2]=0;z=a+24|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[k>>2]|0)>0){y=f[m>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0;C=f[k>>2]|0}while((m|0)<(C|0));f[j>>2]=f[c>>2];if((C|0)<3)D=12;else D=14}else{f[j>>2]=f[c>>2];D=12}if((D|0)==12){C=f[c+4>>2]|0;if((C|0)<3){f[k>>2]=C;f[l>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];l=f[c+44>>2]|0;C=f[o>>2]|0;f[C>>2]=f[l>>2];f[C+4>>2]=f[l+4>>2]}else D=14}if((D|0)==14)U$(j,c);f[z>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[B>>2]=f[b>>2];r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}function BVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)kWc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function CVb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141724;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;wL(b);return}function DVb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141724;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){cYc(a);return}wL(b);cYc(a);return}function EVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;c=u;u=u+240|0;d=c+224|0;e=c+168|0;g=c+104|0;h=c+160|0;i=c+48|0;j=c+40|0;k=c+24|0;l=c+16|0;m=c+8|0;n=c;o=f[b>>2]|0;q=f[b+4>>2]|0;b=a+8|0;r=a+20|0;s=a+72|0;t=+p[f[f[s>>2]>>2]>>3];v=+(f[r>>2]|0)/t;w=~~v;x=(+(w|0)<v&1)+w|0;w=a+16|0;v=+(f[w>>2]|0)/t;y=~~v;z=(+(y|0)<v&1)+y|0;y=f[b>>2]&4095;f[e>>2]=1124007936;A=e+4|0;B=e+8|0;C=e+40|0;D=A;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[C>>2]=B;B=e+48|0;D=e+44|0;f[D>>2]=B;f[B>>2]=0;f[e+52>>2]=0;f[d>>2]=z;f[d+4>>2]=x;S$(e,2,d,y);f[d>>2]=0;y=d+4|0;f[y>>2]=0;f[d+8>>2]=0;if((o|0)<(q|0)){x=h+4|0;z=e+16|0;E=a+48|0;F=j+4|0;G=a+24|0;H=a+56|0;I=g+36|0;J=g+16|0;K=g+4|0;L=g+40|0;M=i+4|0;N=i+8|0;O=g+8|0;P=i+12|0;Q=g+12|0;R=i+16|0;S=i+20|0;T=g+20|0;U=i+24|0;V=g+24|0;W=i+28|0;X=g+28|0;Y=i+32|0;Z=g+32|0;_=i+36|0;$=g+44|0;aa=g+48|0;ba=i+44|0;ca=i+40|0;da=i+48|0;ea=g+40|0;fa=a+4|0;ga=i+8|0;ha=i+12|0;ia=i+4|0;ja=a+64|0;ka=m+4|0;la=a+76|0;ma=n+4|0;na=a+80|0;oa=a+88|0;pa=g+44|0;qa=a+84|0;a=i+4|0;ra=i+8|0;sa=i+12|0;ta=i+8|0;ua=i+12|0;va=i+4|0;wa=k+8|0;xa=k+4|0;ya=l+4|0;za=g+52|0;Aa=o;do{v=+p[(f[f[s>>2]>>2]|0)+(Aa<<5)>>3];o=zLc(+(f[r>>2]|0)/v)|0;Ba=zLc(+(f[w>>2]|0)/v)|0;f[h>>2]=o;f[x>>2]=Ba;cM(g,h,f[b>>2]&4095,f[z>>2]|0,0);Ca=f[E>>2]|0;if((Ba|0)==(f[Ca>>2]|0)?(o|0)==(f[Ca+4>>2]|0):0){f[j>>2]=o;f[F>>2]=Ba;cM(i,j,f[b>>2]&4095,f[G>>2]|0,f[H>>2]|0);Ca=f[I>>2]|0;if(Ca|0?(Da=Ca+12|0,Ca=f[Da>>2]|0,f[Da>>2]=Ca+-1,(Ca|0)==1):0)V$(g);f[I>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[K>>2]|0)>0){Ca=f[L>>2]|0;Da=0;do{f[Ca+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[K>>2]|0))}f[g>>2]=f[i>>2];Da=f[M>>2]|0;f[K>>2]=Da;f[O>>2]=f[N>>2];f[Q>>2]=f[P>>2];f[J>>2]=f[R>>2];f[T>>2]=f[S>>2];f[V>>2]=f[U>>2];f[X>>2]=f[W>>2];f[Z>>2]=f[Y>>2];f[I>>2]=f[_>>2];Ca=f[$>>2]|0;if((Ca|0)==(aa|0))Ea=Da;else{wL(Ca);f[$>>2]=aa;f[L>>2]=O;Ea=f[M>>2]|0}if((Ea|0)<3){Ca=f[ba>>2]|0;f[aa>>2]=f[Ca>>2];f[za>>2]=f[Ca+4>>2];Fa=Ca}else{f[$>>2]=f[ba>>2];f[ea>>2]=f[ca>>2];f[ba>>2]=da;f[ca>>2]=N;Fa=da}f[i>>2]=1124007936;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;f[M+24>>2]=0;f[M+28>>2]=0;f[_>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((Fa|0)!=(da|0))wL(Fa)}else{f[ta>>2]=0;f[ua>>2]=0;f[i>>2]=16842752;f[va>>2]=b;Ca=wa;f[Ca>>2]=0;f[Ca+4>>2]=0;f[k>>2]=33619968;f[xa>>2]=g;f[l>>2]=o;f[ya>>2]=Ba;Zna(i,k,l,0.0,0.0,5)}Ca=f[fa>>2]|0;Da=f[(f[Ca>>2]|0)+56>>2]|0;f[ga>>2]=0;f[ha>>2]=0;f[i>>2]=16842752;f[ia>>2]=g;Ga=f[f[s>>2]>>2]|0;t=+p[ja>>3];f[m>>2]=0;f[ka>>2]=0;f[n>>2]=f[la>>2];f[ma>>2]=f[na>>2];Ei[Da&7](Ca,i,Ga+(Aa<<5)+8|0,d,Ga+(Aa<<5)+20|0,t,m,n);Ga=f[fa>>2]|0;Ca=zLc(v*+(f[Ga+4>>2]|0))|0;Da=zLc(v*+(f[Ga+8>>2]|0))|0;YXc(f[oa>>2]|0);Ga=f[y>>2]|0;Ha=f[d>>2]|0;if((Ga|0)!=(Ha|0)){Ia=0;Ja=Ha;Ha=Ga;while(1){Ga=Ja;Ka=f[qa>>2]|0;La=zLc(v*+(f[Ga+(Ia<<3)>>2]|0))|0;Ma=zLc(v*+(f[Ga+(Ia<<3)+4>>2]|0))|0;f[i>>2]=La;f[a>>2]=Ma;f[ra>>2]=Ca;f[sa>>2]=Da;Ma=Ka+4|0;Ga=f[Ma>>2]|0;if(Ga>>>0<(f[Ka+8>>2]|0)>>>0){f[Ga>>2]=La;f[Ga+4>>2]=f[a>>2];f[Ga+8>>2]=f[ra>>2];f[Ga+12>>2]=f[sa>>2];f[Ma>>2]=Ga+16;Na=Ja;Oa=Ha}else{TPb(Ka,i);Na=f[d>>2]|0;Oa=f[y>>2]|0}Ia=Ia+1|0;if(Ia>>>0>=Oa-Na>>3>>>0)break;else{Ja=Na;Ha=Oa}}}ZXc(f[oa>>2]|0);Ha=f[I>>2]|0;if(Ha|0?(Ja=Ha+12|0,Ha=f[Ja>>2]|0,f[Ja>>2]=Ha+-1,(Ha|0)==1):0)V$(g);f[I>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[K>>2]|0)>0){Ha=f[L>>2]|0;Ja=0;do{f[Ha+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[K>>2]|0))}Ja=f[pa>>2]|0;if((Ja|0)!=(aa|0))wL(Ja);Aa=Aa+1|0}while((Aa|0)<(q|0));q=f[d>>2]|0;if(q|0){d=f[y>>2]|0;if((d|0)!=(q|0))f[y>>2]=d+(~((d+-8-q|0)>>>3)<<3);cYc(q)}}q=e+36|0;d=f[q>>2]|0;if(d|0?(y=d+12|0,d=f[y>>2]|0,f[y>>2]=d+-1,(d|0)==1):0)V$(e);f[q>>2]=0;q=e+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[A>>2]|0)>0){q=f[C>>2]|0;C=0;do{f[q+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[D>>2]|0;if((A|0)==(B|0)){u=c;return}wL(A);u=c;return}function FVb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;f[a>>2]=141628;i=a+4|0;j=a+32|0;f[a+92>>2]=0;f[a+96>>2]=0;k=a+100|0;l=a+108|0;m=a+140|0;n=a+104|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;n=j;o=n+44|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+148|0;f[a+144>>2]=l;f[l>>2]=0;f[a+152>>2]=0;f[k>>2]=1124007941;k=a+156|0;l=a+164|0;m=a+196|0;n=a+160|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+204|0;f[a+200>>2]=l;f[l>>2]=0;f[a+208>>2]=0;f[k>>2]=1124007936;f[a+212>>2]=1124007936;k=a+220|0;l=a+252|0;n=a+216|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+260|0;f[a+256>>2]=k;f[k>>2]=0;f[a+264>>2]=0;f[a+268>>2]=1124007936;k=a+276|0;l=a+308|0;n=a+272|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+316|0;f[a+312>>2]=k;f[k>>2]=0;f[a+320>>2]=0;Ii[f[(f[a>>2]|0)+8>>2]&127](a,b,c,d,e,g,h);return}function GVb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+16|0;d=c;e=f[a+12>>2]|0;g=f[a+28>>2]|0;if(((e|0)%(g|0)|0|0)==0?(h=f[a+16>>2]|0,i=f[a+32>>2]|0,((h|0)%(i|0)|0|0)==0):0){j=(f[a+4>>2]|0)-e|0;k=f[a+20>>2]|0;if(((j|0)%(k|0)|0|0)==0?(l=(f[a+8>>2]|0)-h|0,m=f[a+24>>2]|0,((l|0)%(m|0)|0|0)==0):0){n=Y(Y(Y(Y((e|0)/(g|0)|0,f[a+36>>2]|0)|0,(h|0)/(i|0)|0)|0,((j|0)/(k|0)|0)+1|0)|0,((l|0)/(m|0)|0)+1|0)|0;u=c;return n|0}n=$Xc(128)|0;f[d>>2]=n;f[d+8>>2]=-2147483520;f[d+4>>2]=123;o=n;p=470116;q=o+123|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+123>>0]=0;vM(-215,d,470098,469947,90)}n=$Xc(96)|0;f[d>>2]=n;f[d+8>>2]=-2147483552;f[d+4>>2]=80;o=n;p=470017;q=o+80|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+80>>0]=0;vM(-215,d,470098,469947,88);return 0}function HVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function IVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0;e=u;u=u+96|0;g=e;i=e+88|0;j=e+32|0;k=f[a+96>>2]|0;l=(f[c>>2]|0)+(f[a+92>>2]|0)|0;f[c>>2]=l;m=c+4|0;o=(f[m>>2]|0)+k|0;f[m>>2]=o;do if(b[a+28>>0]|0){k=f[a+52>>2]|0;if((l|0)%(k|0)|0|0){p=$Xc(64)|0;f[g>>2]=p;q=g+8|0;f[q>>2]=-2147483584;r=g+4|0;f[r>>2]=63;s=p;t=469874;v=s+63|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+63|0;b[w>>0]=0;vM(-215,g,469938,469947,876)}x=f[a+56>>2]|0;if((o|0)%(x|0)|0|0){p=$Xc(64)|0;f[g>>2]=p;q=g+8|0;f[q>>2]=-2147483584;r=g+4|0;f[r>>2]=63;s=p;t=469874;v=s+63|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+63|0;b[w>>0]=0;vM(-215,g,469938,469947,876)}y=(l|0)/(k|0)|0;z=((o|0)/(x|0)|0|0)%(f[a+108>>2]|0)|0;A=a+32|0;if((o|0)!=(f[(f[A>>2]|0)+(z<<2)>>2]|0)){f[g>>2]=z;f[g+4>>2]=z+1;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;W$(j,a+156|0,g,i);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;lR(j,g)|0;f[(f[A>>2]|0)+(z<<2)>>2]=f[m>>2];A=j+36|0;B=f[A>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)V$(j);f[A>>2]=0;A=j+16|0;B=j+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[j+40>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[B>>2]|0))}B=f[j+44>>2]|0;if((B|0)!=(j+48|0))wL(B)}B=(f[a+116>>2]|0)+(Y(f[f[a+144>>2]>>2]|0,z)|0)|0;C=a+76|0;A=B+((Y(f[C>>2]|0,y)|0)<<2)|0;B=(f[a+172>>2]|0)+(Y(f[f[a+200>>2]>>2]|0,z)|0)+y|0;if(!(b[B>>0]|0)){b[B>>0]=1;D=A;E=C;F=f[m>>2]|0;G=f[c>>2]|0;break}else{H=A;u=e;return H|0}}else{D=d;E=a+76|0;F=o;G=l}while(0);l=f[a+80>>2]|0;o=f[a+84>>2]|0;d=f[a+88>>2]|0;c=G<<1;G=(f[a+228>>2]|0)+(Y(f[f[a+256>>2]>>2]|0,F)|0)+(c<<2)|0;m=(f[a+284>>2]|0)+(Y(f[f[a+312>>2]>>2]|0,F)|0)+c|0;g1c(D|0,0,f[E>>2]<<2|0)|0;E=f[a+4>>2]|0;if((l|0)>0){c=0;do{F=G+(f[E+(c*44|0)>>2]<<2)|0;I=+n[E+(c*44|0)+40>>2]*+n[E+(c*44|0)+24>>2];j=m+(f[E+(c*44|0)+4>>2]|0)|0;g=D+(f[E+(c*44|0)+8>>2]<<2)|0;i=g+(h[j>>0]<<2)|0;w=g+(h[j+1>>0]<<2)|0;J=+n[w>>2]+I*+n[F+4>>2];n[i>>2]=+n[i>>2]+I*+n[F>>2];n[w>>2]=J;c=c+1|0}while((c|0)!=(l|0));K=l}else K=0;if((K|0)<(o|0)){l=K;do{c=G+(f[E+(l*44|0)>>2]<<2)|0;J=+n[c>>2];I=+n[c+4>>2];c=m+(f[E+(l*44|0)+4>>2]|0)|0;w=h[c>>0]|0;F=h[c+1>>0]|0;c=D+(f[E+(l*44|0)+8>>2]<<2)|0;i=E+(l*44|0)+40|0;L=+n[i>>2]*+n[E+(l*44|0)+24>>2];j=c+(w<<2)|0;g=c+(F<<2)|0;M=+n[g>>2]+I*L;n[j>>2]=+n[j>>2]+J*L;n[g>>2]=M;g=D+(f[E+(l*44|0)+12>>2]<<2)|0;M=+n[i>>2]*+n[E+(l*44|0)+28>>2];i=g+(w<<2)|0;w=g+(F<<2)|0;L=+n[w>>2]+I*M;n[i>>2]=+n[i>>2]+J*M;n[w>>2]=L;l=l+1|0}while((l|0)!=(o|0));N=o}else N=K;if((N|0)<(d|0)){K=N;do{N=G+(f[E+(K*44|0)>>2]<<2)|0;L=+n[N>>2];M=+n[N+4>>2];N=m+(f[E+(K*44|0)+4>>2]|0)|0;o=h[N>>0]|0;l=h[N+1>>0]|0;N=D+(f[E+(K*44|0)+8>>2]<<2)|0;w=E+(K*44|0)+40|0;J=+n[w>>2]*+n[E+(K*44|0)+24>>2];i=N+(o<<2)|0;F=N+(l<<2)|0;I=+n[F>>2]+M*J;n[i>>2]=+n[i>>2]+L*J;n[F>>2]=I;F=D+(f[E+(K*44|0)+12>>2]<<2)|0;I=+n[w>>2]*+n[E+(K*44|0)+28>>2];i=F+(o<<2)|0;N=F+(l<<2)|0;J=+n[N>>2]+M*I;n[i>>2]=+n[i>>2]+L*I;n[N>>2]=J;N=D+(f[E+(K*44|0)+16>>2]<<2)|0;J=+n[w>>2]*+n[E+(K*44|0)+32>>2];i=N+(o<<2)|0;F=N+(l<<2)|0;I=+n[F>>2]+M*J;n[i>>2]=+n[i>>2]+L*J;n[F>>2]=I;F=D+(f[E+(K*44|0)+20>>2]<<2)|0;I=+n[w>>2]*+n[E+(K*44|0)+36>>2];w=F+(o<<2)|0;o=F+(l<<2)|0;J=+n[o>>2]+M*I;n[w>>2]=+n[w>>2]+L*I;n[o>>2]=J;K=K+1|0}while((K|0)!=(d|0))}mi[f[(f[a>>2]|0)+12>>2]&2047](a,D);H=D;u=e;return H|0}function JVb(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f[a>>2]=141744;m=a+8|0;f[m>>2]=1124007936;n=a+12|0;o=a+16|0;q=a+48|0;r=n;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;r=a+56|0;s=a+52|0;f[s>>2]=r;f[r>>2]=0;f[a+60>>2]=0;r=a+72|0;t=a+76|0;u=a+80|0;v=a+84|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[a+4>>2]=b;if((m|0)==(c|0)){w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}b=c+36|0;I=f[b>>2]|0;if(I){J=I+12|0;f[J>>2]=(f[J>>2]|0)+1;J=a+44|0;I=f[J>>2]|0;if((I|0)!=0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0){V$(m);L=J}else L=J}else L=a+44|0;f[L>>2]=0;J=a+24|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[n>>2]|0)>0){I=f[q>>2]|0;q=0;do{f[I+(q<<2)>>2]=0;q=q+1|0;M=f[n>>2]|0}while((q|0)<(M|0));f[m>>2]=f[c>>2];if((M|0)<3)N=12;else N=14}else{f[m>>2]=f[c>>2];N=12}if((N|0)==12){M=f[c+4>>2]|0;if((M|0)<3){f[n>>2]=M;f[o>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];o=f[c+44>>2]|0;M=f[s>>2]|0;f[M>>2]=f[o>>2];f[M+4>>2]=f[o+4>>2]}else N=14}if((N|0)==14)U$(m,c);f[J>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[L>>2]=f[b>>2];w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}function KVb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;a=u;u=u+96|0;h=a+16|0;i=a+72|0;j=a+8|0;k=a+60|0;l=a+48|0;m=a+32|0;n=a;if((e|0)<1){u=a;return}o=f[c>>2]|0;q=c+4|0;r=f[q>>2]|0;if((o|0)==(r|0)){u=a;return}s=d+4|0;if((r-o>>4|0)!=((f[s>>2]|0)-(f[d>>2]|0)>>3|0)){o=$Xc(48)|0;f[h>>2]=o;f[h+8>>2]=-2147483600;f[h+4>>2]=33;r=o;t=470466;v=r+33|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));b[o+33>>0]=0;vM(-215,h,470500,469947,3637)}f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;p[j>>3]=g;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];j=eUb(c,i,h)|0;f[h>>2]=0;t=h+4|0;f[t>>2]=0;f[h+8>>2]=0;r=(j|0)==0;do if(!r)if(j>>>0>134217727)kWc(h);else{v=j<<5;w=$Xc(v)|0;f[h>>2]=w;f[h+8>>2]=w+(j<<5);g1c(w|0,0,v|0)|0;f[t>>2]=w+v;x=w;break}else x=0;while(0);f[k>>2]=0;w=k+4|0;f[w>>2]=0;f[k+8>>2]=0;if(r)y=0;else{v=j<<2;z=$Xc(v)|0;f[k>>2]=z;A=z+(j<<2)|0;f[k+8>>2]=A;g1c(z|0,0,v|0)|0;f[w>>2]=A;y=z}f[l>>2]=0;z=l+4|0;f[z>>2]=0;f[l+8>>2]=0;if(r){B=0;C=0}else{r=$Xc(j<<3)|0;f[z>>2]=r;f[l>>2]=r;A=r+(j<<3)|0;f[l+8>>2]=A;v=j;D=r;while(1){p[D>>3]=-1797693134862315708145274.0e284;v=v+-1|0;if(!v)break;else D=D+8|0}f[z>>2]=A;B=r;C=r}r=f[i>>2]|0;A=(f[o>>2]|0)-r|0;D=A>>2;v=r;if((A|0)>0){A=0;do{r=f[v+(A<<2)>>2]|0;E=f[c>>2]|0;F=x+(r<<5)|0;p[F>>3]=+(f[E+(A<<4)>>2]|0)+ +p[F>>3];F=x+(r<<5)+8|0;p[F>>3]=+(f[E+(A<<4)+4>>2]|0)+ +p[F>>3];F=x+(r<<5)+16|0;p[F>>3]=+(f[E+(A<<4)+8>>2]|0)+ +p[F>>3];F=x+(r<<5)+24|0;p[F>>3]=+(f[E+(A<<4)+12>>2]|0)+ +p[F>>3];F=C+(r<<3)|0;G=+p[F>>3];H=+p[(f[d>>2]|0)+(A<<3)>>3];p[F>>3]=G<H?H:G;F=y+(r<<2)|0;f[F>>2]=(f[F>>2]|0)+1;A=A+1|0}while((A|0)<(D|0))}D=(j|0)>0;if(D){A=0;do{v=x+(A<<5)|0;F=x+(A<<5)+8|0;r=x+(A<<5)+16|0;E=x+(A<<5)+24|0;G=1.0/+(f[y+(A<<2)>>2]|0);H=+p[F>>3]*G;I=+p[r>>3]*G;J=+p[E>>3]*G;p[v>>3]=+p[v>>3]*G;p[F>>3]=H;p[r>>3]=I;p[E>>3]=J;A=A+1|0}while((A|0)!=(j|0))}A=f[c>>2]|0;E=f[q>>2]|0;if((E|0)!=(A|0))f[q>>2]=E+(~((E+-16-A|0)>>>4)<<4);A=f[d>>2]|0;E=f[s>>2]|0;if((E|0)!=(A|0))f[s>>2]=E+(~((E+-8-A|0)>>>3)<<3);if(D){D=m+4|0;A=m+8|0;E=m+12|0;r=c+8|0;F=d+8|0;v=f[k>>2]|0;K=f[l>>2]|0;L=0;M=x;x=y;y=C;while(1){N=zLc(+p[M+(L<<5)>>3])|0;O=zLc(+p[M+(L<<5)+8>>3])|0;P=zLc(+p[M+(L<<5)+16>>3])|0;Q=zLc(+p[M+(L<<5)+24>>3])|0;f[m>>2]=N;f[D>>2]=O;f[A>>2]=P;f[E>>2]=Q;R=f[x+(L<<2)>>2]|0;p[n>>3]=+p[y+(L<<3)>>3];do if((R|0)>(e|0)){S=f[h>>2]|0;T=P+N|0;U=Q+O|0;V=(R|0)>3?R:3;a:do if((R|0)<3){W=0;while(1){do if((W|0)!=(L|0)?(f[x+(W<<2)>>2]|0)>(e|0):0){X=zLc(+p[S+(W<<5)>>3])|0;Y=zLc(+p[S+(W<<5)+8>>3])|0;Z=zLc(+p[S+(W<<5)+16>>3])|0;_=zLc(+p[S+(W<<5)+24>>3])|0;$=zLc(+(Z|0)*g)|0;aa=zLc(+(_|0)*g)|0;if((N|0)<(X-$|0)|(O|0)<(Y-aa|0))break;if((T|0)>(Z+X+$|0))break;if((U|0)<=(_+Y+aa|0)){ba=W;break a}}while(0);aa=W+1|0;if((aa|0)<(j|0))W=aa;else{ba=aa;break}}}else{W=0;while(1){aa=f[x+(W<<2)>>2]|0;do if((W|0)!=(L|0)&(aa|0)>(e|0)){Y=zLc(+p[S+(W<<5)>>3])|0;_=zLc(+p[S+(W<<5)+8>>3])|0;$=zLc(+p[S+(W<<5)+16>>3])|0;X=zLc(+p[S+(W<<5)+24>>3])|0;Z=zLc(+($|0)*g)|0;ca=zLc(+(X|0)*g)|0;if((N|0)<(Y-Z|0)|(O|0)<(_-ca|0))break;if((T|0)>($+Y+Z|0))break;if((aa|0)>(V|0)?(U|0)<=(X+_+ca|0):0){ba=W;break a}}while(0);aa=W+1|0;if((aa|0)<(j|0))W=aa;else{ba=aa;break}}}while(0);if((ba|0)==(j|0)){U=f[q>>2]|0;if((U|0)==(f[r>>2]|0))vx(c,m);else{f[U>>2]=N;f[U+4>>2]=O;f[U+8>>2]=P;f[U+12>>2]=Q;f[q>>2]=U+16}U=f[s>>2]|0;if((U|0)==(f[F>>2]|0)){xw(d,n);break}else{p[U>>3]=+p[n>>3];f[s>>2]=U+8;break}}}while(0);Q=L+1|0;if((Q|0)>=(j|0))break;L=Q;M=f[h>>2]|0;x=v;y=K}K=f[l>>2]|0;da=K;ea=K}else{da=C;ea=B}if(da|0){B=f[z>>2]|0;if((B|0)!=(da|0))f[z>>2]=B+(~((B+-8-da|0)>>>3)<<3);cYc(ea)}ea=f[k>>2]|0;if(ea|0){k=f[w>>2]|0;if((k|0)!=(ea|0))f[w>>2]=k+(~((k+-4-ea|0)>>>2)<<2);cYc(ea)}ea=f[h>>2]|0;if(ea|0){h=f[t>>2]|0;if((h|0)!=(ea|0))f[t>>2]=h+(~((h+-32-ea|0)>>>5)<<5);cYc(ea)}ea=f[i>>2]|0;if(ea|0){i=f[o>>2]|0;if((i|0)!=(ea|0))f[o>>2]=i+(~((i+-4-ea|0)>>>2)<<2);cYc(ea)}u=a;return}function LVb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141744;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;wL(b);return}function MVb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=141744;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){cYc(a);return}wL(b);cYc(a);return}function NVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;c=u;u=u+272|0;d=c+248|0;e=c+192|0;g=c+176|0;h=c;i=c+112|0;j=c+168|0;k=c+56|0;l=c+48|0;m=c+32|0;n=c+24|0;o=c+16|0;q=c+8|0;r=f[b>>2]|0;s=f[b+4>>2]|0;do if((r|0)<=0)if((s|0)>1){t=+p[(f[a+88>>2]|0)+(r+1<<3)>>3];break}else{b=f[a+20>>2]|0;v=f[a+16>>2]|0;t=+(((b|0)<(v|0)?v:b)|0);break}else t=+p[(f[a+88>>2]|0)+(r<<3)>>3];while(0);b=a+8|0;v=a+20|0;w=+(f[v>>2]|0)/t;x=~~w;y=(+(x|0)<w&1)+x|0;x=a+16|0;w=+(f[x>>2]|0)/t;z=~~w;A=(+(z|0)<w&1)+z|0;z=f[b>>2]&4095;f[e>>2]=1124007936;B=e+4|0;C=e+8|0;D=e+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=e+48|0;E=e+44|0;f[E>>2]=C;f[C>>2]=0;f[e+52>>2]=0;f[d>>2]=A;f[d+4>>2]=y;S$(e,2,d,z);f[d>>2]=0;z=d+4|0;f[z>>2]=0;f[d+8>>2]=0;f[g>>2]=0;y=g+4|0;f[y>>2]=0;f[g+8>>2]=0;if((r|0)<(s|0)){A=a+88|0;F=j+4|0;G=e+16|0;H=a+48|0;I=l+4|0;J=a+24|0;K=a+56|0;L=i+36|0;M=i+16|0;N=i+4|0;O=i+40|0;P=k+4|0;Q=k+8|0;R=i+8|0;S=k+12|0;T=i+12|0;U=k+16|0;V=k+20|0;W=i+20|0;X=k+24|0;Y=i+24|0;Z=k+28|0;_=i+28|0;$=k+32|0;aa=i+32|0;ba=k+36|0;ca=i+44|0;da=i+48|0;ea=k+44|0;fa=k+40|0;ga=k+48|0;ha=i+40|0;ia=a+4|0;ja=k+8|0;ka=k+12|0;la=k+4|0;ma=a+64|0;na=a+72|0;oa=o+4|0;pa=a+76|0;qa=a+80|0;ra=q+4|0;sa=a+84|0;ta=m+4|0;ua=m+8|0;va=a+104|0;wa=a+96|0;xa=i+44|0;ya=a+92|0;za=k+4|0;Aa=k+8|0;Ba=k+12|0;Ca=a+100|0;a=k+8|0;Da=k+12|0;Ea=k+4|0;Fa=m+8|0;Ga=m+4|0;Ha=n+4|0;Ia=i+52|0;Ja=r;do{w=+p[(f[A>>2]|0)+(Ja<<3)>>3];p[h>>3]=w;r=zLc(+(f[v>>2]|0)/w)|0;Ka=zLc(+(f[x>>2]|0)/w)|0;f[j>>2]=r;f[F>>2]=Ka;cM(i,j,f[b>>2]&4095,f[G>>2]|0,0);La=f[H>>2]|0;if((Ka|0)==(f[La>>2]|0)?(r|0)==(f[La+4>>2]|0):0){f[l>>2]=r;f[I>>2]=Ka;cM(k,l,f[b>>2]&4095,f[J>>2]|0,f[K>>2]|0);La=f[L>>2]|0;if(La|0?(Ma=La+12|0,La=f[Ma>>2]|0,f[Ma>>2]=La+-1,(La|0)==1):0)V$(i);f[L>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[N>>2]|0)>0){La=f[O>>2]|0;Ma=0;do{f[La+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[N>>2]|0))}f[i>>2]=f[k>>2];Ma=f[P>>2]|0;f[N>>2]=Ma;f[R>>2]=f[Q>>2];f[T>>2]=f[S>>2];f[M>>2]=f[U>>2];f[W>>2]=f[V>>2];f[Y>>2]=f[X>>2];f[_>>2]=f[Z>>2];f[aa>>2]=f[$>>2];f[L>>2]=f[ba>>2];La=f[ca>>2]|0;if((La|0)==(da|0))Na=Ma;else{wL(La);f[ca>>2]=da;f[O>>2]=R;Na=f[P>>2]|0}if((Na|0)<3){La=f[ea>>2]|0;f[da>>2]=f[La>>2];f[Ia>>2]=f[La+4>>2];Oa=La}else{f[ca>>2]=f[ea>>2];f[ha>>2]=f[fa>>2];f[ea>>2]=ga;f[fa>>2]=Q;Oa=ga}f[k>>2]=1124007936;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;f[P+24>>2]=0;f[P+28>>2]=0;f[ba>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((Oa|0)!=(ga|0))wL(Oa)}else{f[a>>2]=0;f[Da>>2]=0;f[k>>2]=16842752;f[Ea>>2]=b;La=Fa;f[La>>2]=0;f[La+4>>2]=0;f[m>>2]=33619968;f[Ga>>2]=i;f[n>>2]=r;f[Ha>>2]=Ka;Zna(k,m,n,0.0,0.0,5)}La=f[ia>>2]|0;Ma=f[(f[La>>2]|0)+36>>2]|0;f[ja>>2]=0;f[ka>>2]=0;f[k>>2]=16842752;f[la>>2]=i;w=+p[ma>>3];f[o>>2]=f[na>>2];f[oa>>2]=f[pa>>2];f[q>>2]=f[qa>>2];f[ra>>2]=f[sa>>2];f[m>>2]=0;f[ta>>2]=0;f[ua>>2]=0;tg[Ma&7](La,k,d,g,w,o,q,m);La=f[m>>2]|0;if(La|0){Ma=f[ta>>2]|0;if((Ma|0)!=(La|0))f[ta>>2]=Ma+(~((Ma+-8-La|0)>>>3)<<3);cYc(La)}La=f[ia>>2]|0;w=+p[h>>3];Ma=zLc(+(f[La+4>>2]|0)*w)|0;Pa=zLc(w*+(f[La+8>>2]|0))|0;YXc(f[va>>2]|0);La=f[d>>2]|0;if((f[z>>2]|0)!=(La|0)){Qa=0;Ra=La;do{La=Ra;Sa=f[ya>>2]|0;w=+p[h>>3];Ta=zLc(+(f[La+(Qa<<3)>>2]|0)*w)|0;Ua=zLc(w*+(f[La+(Qa<<3)+4>>2]|0))|0;f[k>>2]=Ta;f[za>>2]=Ua;f[Aa>>2]=Ma;f[Ba>>2]=Pa;Ua=Sa+4|0;La=f[Ua>>2]|0;if(La>>>0<(f[Sa+8>>2]|0)>>>0){f[La>>2]=Ta;f[La+4>>2]=f[za>>2];f[La+8>>2]=f[Aa>>2];f[La+12>>2]=f[Ba>>2];f[Ua>>2]=La+16}else TPb(Sa,k);Sa=f[Ca>>2]|0;do if(Sa|0){La=Sa+4|0;Ua=f[La>>2]|0;if((Ua|0)==(f[Sa+8>>2]|0)){xw(Sa,h);break}else{p[Ua>>3]=+p[h>>3];f[La>>2]=Ua+8;break}}while(0);Qa=Qa+1|0;Ra=f[d>>2]|0}while(Qa>>>0<(f[z>>2]|0)-Ra>>3>>>0)}ZXc(f[va>>2]|0);if(f[wa>>2]|0?(f[g>>2]|0)!=(f[y>>2]|0):0){YXc(f[va>>2]|0);Ra=f[z>>2]|0;Qa=f[d>>2]|0;if((Ra|0)!=(Qa|0)){Pa=0;Ma=Qa;Qa=Ra;while(1){Ra=f[wa>>2]|0;Ka=(f[g>>2]|0)+(Pa<<3)|0;r=Ra+4|0;Sa=f[r>>2]|0;if((Sa|0)==(f[Ra+8>>2]|0)){xw(Ra,Ka);Va=f[d>>2]|0;Wa=f[z>>2]|0}else{p[Sa>>3]=+p[Ka>>3];f[r>>2]=Sa+8;Va=Ma;Wa=Qa}Pa=Pa+1|0;if(Pa>>>0>=Wa-Va>>3>>>0)break;else{Ma=Va;Qa=Wa}}}ZXc(f[va>>2]|0)}Qa=f[L>>2]|0;if(Qa|0?(Ma=Qa+12|0,Qa=f[Ma>>2]|0,f[Ma>>2]=Qa+-1,(Qa|0)==1):0)V$(i);f[L>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[N>>2]|0)>0){Qa=f[O>>2]|0;Ma=0;do{f[Qa+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[N>>2]|0))}Ma=f[xa>>2]|0;if((Ma|0)!=(da|0))wL(Ma);Ja=Ja+1|0}while((Ja|0)<(s|0));s=f[g>>2]|0;if(s|0){g=f[y>>2]|0;if((g|0)!=(s|0))f[y>>2]=g+(~((g+-8-s|0)>>>3)<<3);cYc(s)}}s=f[d>>2]|0;if(s|0){d=f[z>>2]|0;if((d|0)!=(s|0))f[z>>2]=d+(~((d+-8-s|0)>>>3)<<3);cYc(s)}s=e+36|0;d=f[s>>2]|0;if(d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)V$(e);f[s>>2]=0;s=e+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[B>>2]|0)>0){s=f[D>>2]|0;D=0;do{f[s+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)==(C|0)){u=c;return}wL(B);u=c;return}function OVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d+12|0;g=d;if(!(_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0)){u=d;return a|0}h=a+4|0;if((f[h>>2]|0)==6){i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=30;j=i;k=473382;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+30>>0]=0;vM(-2,e,528568,473413,1207)}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P5(e,a,a+8|0,12,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);n5(a,f[c>>2]|0);n5(a,f[c+4>>2]|0);r5(e);if(!(f[h>>2]&4)){u=d;return a|0}f[h>>2]=6;u=d;return a|0}function PVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d+12|0;g=d;b[e>>0]=49;b[e+1>>0]=102;b[e+2>>0]=0;h=f[a>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=dJc(e)|0;if(a>>>0>4294967279)jYc(g);if(a>>>0<11){b[g+11>>0]=a;if(!a)i=g;else{j=g;k=6}}else{l=a+16&-16;m=$Xc(l)|0;f[g>>2]=m;f[g+8>>2]=l|-2147483648;f[g+4>>2]=a;j=m;k=6}if((k|0)==6){o1c(j|0,e|0,a|0)|0;i=j}b[i+a>>0]=0;a=f[c>>2]|0;i=f[c+4>>2]|0;l5(h,g,(a|0)==(i|0)?0:a,i-a|0);if((b[g+11>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function QVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e+12|0;h=e;i=L5(f[a>>2]|0)|0;b[g>>0]=49;b[g+1>>0]=102;b[g+2>>0]=0;j=i>>>0<d>>>0?i:d;d=c+4|0;i=f[d>>2]|0;k=f[c>>2]|0;l=i-k>>2;m=k;k=i;if(j>>>0<=l>>>0){if(j>>>0<l>>>0?(i=m+(j<<2)|0,(k|0)!=(i|0)):0)f[d>>2]=k+(~((k+-4-i|0)>>>2)<<2)}else qxb(c,j-l|0);l=f[a>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=dJc(g)|0;if(a>>>0>4294967279)jYc(h);if(a>>>0<11){b[h+11>>0]=a;if(!a)n=h;else{o=h;p=11}}else{i=a+16&-16;k=$Xc(i)|0;f[h>>2]=k;f[h+8>>2]=i|-2147483648;f[h+4>>2]=a;o=k;p=11}if((p|0)==11){o1c(o|0,g|0,a|0)|0;n=o}b[n+a>>0]=0;a=f[c>>2]|0;K5(l,h,(a|0)==(f[d>>2]|0)?0:a,j<<2)|0;if((b[h+11>>0]|0)>=0){u=e;return}cYc(f[h>>2]|0);u=e;return}function RVb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=$Xc(15124)|0;f[b>>2]=c;f[a>>2]=c;d=c+15124|0;f[a+8>>2]=d;a=141756;e=c;while(1){f[e>>2]=f[a>>2];a=a+4|0;if((a|0)==156880)break;else e=e+4|0}f[b>>2]=d;return}function SVb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=$Xc(7924)|0;f[b>>2]=c;f[a>>2]=c;d=c+7924|0;f[a+8>>2]=d;a=156880;e=c;while(1){f[e>>2]=f[a>>2];a=a+4|0;if((a|0)==164804)break;else e=e+4|0}f[b>>2]=d;return}function TVb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;e=u;u=u+384|0;g=e;h=e+220|0;i=e+364|0;j=e+352|0;k=e+208|0;l=e+196|0;m=e+184|0;o=e+340|0;q=e+172|0;r=e+160|0;s=e+148|0;t=e+136|0;v=e+72|0;w=e+56|0;x=e+328|0;y=e+40|0;z=e+28|0;A=e+316|0;B=e+304|0;C=e+292|0;D=e+280|0;E=e+268|0;F=e+256|0;G=e+16|0;H=e+244|0;I=e+12|0;J=e+232|0;i5(h,a,470867);if(G5(h)|0){K=0;u=e;return K|0}y5(i,h,0);M=H5(i)|0;y5(j,h,1);h=H5(j)|0;f[k>>2]=0;j=k+4|0;f[j>>2]=0;f[k+8>>2]=0;i5(l,a,470872);a=w5(l)|0;f[m>>2]=0;i=m+4|0;f[i>>2]=0;f[m+8>>2]=0;if(!a){N=0;O=(f[j>>2]|0)-(f[k>>2]|0)|0;P=0}else{if(a>>>0>178956970)kWc(m);Q=a*24|0;R=$Xc(Q)|0;f[m>>2]=R;f[m+8>>2]=R+(a*24|0);g1c(R|0,0,Q|0)|0;f[i>>2]=R+Q;Q=v+4|0;R=k+8|0;i=w+12|0;S=w+4|0;T=w+8|0;U=v+4|0;V=v+8|0;W=v+12|0;X=v+16|0;Y=v+20|0;Z=v+24|0;_=v+28|0;$=v+32|0;aa=v+36|0;ba=v+40|0;ca=v+44|0;da=v+48|0;ea=v+52|0;fa=v+56|0;ga=v+60|0;ha=w+4|0;ia=0;do{y5(g,l,ia);ja=f[m>>2]|0;i5(o,g,470879);ka=+J5(o);p[ja+(ia*24|0)>>3]=ka;i5(q,g,512723);la=w5(q)|0;ma=ja+(ia*24|0)+8|0;UVb(ma,la);if((la|0)>0){ja=0;do{na=f[ma>>2]|0;y5(r,q,ja);oa=w5(r)|0;if((oa|0)>0){pa=na+(ja*24|0)+4|0;qa=na+(ja*24|0)+8|0;ra=na+(ja*24|0)|0;sa=na+(ja*24|0)+12|0;ta=na+(ja*24|0)+16|0;ua=na+(ja*24|0)+20|0;na=0;do{y5(s,r,na);i5(t,s,470895);b[v>>0]=0;va=Q;wa=va+60|0;do{f[va>>2]=0;va=va+4|0}while((va|0)<(wa|0));f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[w>>2]=(f[j>>2]|0)-(f[k>>2]|0)>>6;i5(x,t,470903);xa=(H5(x)|0)!=0&1;b[v>>0]=xa;i5(y,t,470910);xa=w5(y)|0;if((xa|0)>0){ya=0;do{y5(z,y,ya);y5(A,z,0);za=H5(A)|0;f[v+4+(ya*20|0)>>2]=za;y5(B,z,1);za=H5(B)|0;f[v+4+(ya*20|0)+4>>2]=za;y5(C,z,2);za=H5(C)|0;f[v+4+(ya*20|0)+8>>2]=za;y5(D,z,3);za=H5(D)|0;f[v+4+(ya*20|0)+12>>2]=za;y5(E,z,4);ka=+I5(E);n[v+4+(ya*20|0)+16>>2]=ka;ya=ya+1|0}while((ya|0)<(xa|0))}xa=f[j>>2]|0;if((xa|0)==(f[R>>2]|0))WVb(k,v);else{b[xa>>0]=b[v>>0]|0;f[xa+4>>2]=f[U>>2];f[xa+8>>2]=f[V>>2];f[xa+12>>2]=f[W>>2];f[xa+16>>2]=f[X>>2];f[xa+20>>2]=f[Y>>2];f[xa+24>>2]=f[Z>>2];f[xa+28>>2]=f[_>>2];f[xa+32>>2]=f[$>>2];f[xa+36>>2]=f[aa>>2];f[xa+40>>2]=f[ba>>2];f[xa+44>>2]=f[ca>>2];f[xa+48>>2]=f[da>>2];f[xa+52>>2]=f[ea>>2];f[xa+56>>2]=f[fa>>2];f[xa+60>>2]=f[ga>>2];f[j>>2]=xa+64}i5(F,s,470916);ka=+I5(F);n[i>>2]=ka;i5(z,s,470926);if(!(G5(z)|0)){f[S>>2]=0-((f[ta>>2]|0)-(f[sa>>2]|0)>>2);ka=+I5(z);n[G>>2]=ka;xa=f[ta>>2]|0;if(xa>>>0<(f[ua>>2]|0)>>>0){n[xa>>2]=ka;f[ta>>2]=xa+4}else MA(sa,G)}else{i5(H,s,470935);xa=H5(H)|0;f[S>>2]=xa}i5(G,s,470945);if(!(G5(G)|0)){f[T>>2]=0-((f[ta>>2]|0)-(f[sa>>2]|0)>>2);ka=+I5(G);n[I>>2]=ka;xa=f[ta>>2]|0;if(xa>>>0<(f[ua>>2]|0)>>>0){n[xa>>2]=ka;f[ta>>2]=xa+4}else MA(sa,I)}else{i5(J,s,470955);xa=H5(J)|0;f[T>>2]=xa}xa=f[pa>>2]|0;if((xa|0)==(f[qa>>2]|0))XVb(ra,w);else{f[xa>>2]=f[w>>2];f[xa+4>>2]=f[w+4>>2];f[xa+8>>2]=f[w+8>>2];f[xa+12>>2]=f[w+12>>2];f[pa>>2]=(f[pa>>2]|0)+16}na=na+1|0}while((na|0)<(oa|0))}ja=ja+1|0}while((ja|0)<(la|0))}ia=ia+1|0}while((ia|0)<(a|0));ia=(f[j>>2]|0)-(f[k>>2]|0)|0;w=f[m>>2]|0;T=0;J=0;while(1){s=((f[w+(J*24|0)+12>>2]|0)-(f[w+(J*24|0)+8>>2]|0)|0)/24|0;I=(T|0)<(s|0)?s:T;J=J+1|0;if((J|0)==(a|0)){N=I;O=ia;P=1;break}else T=I}}T=O>>6;f[g+8>>2]=0;ia=g+11|0;b[ia>>0]=7;b[g>>0]=b[470966]|0;b[g+1>>0]=b[470967]|0;b[g+2>>0]=b[470968]|0;b[g+3>>0]=b[470969]|0;b[g+4>>0]=b[470970]|0;b[g+5>>0]=b[470971]|0;b[g+6>>0]=b[470972]|0;b[g+7>>0]=0;J=s5(c,g)|0;if((b[ia>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ia=$Xc(32)|0;f[g>>2]=ia;f[g+8>>2]=-2147483616;f[g+4>>2]=27;va=ia;w=470974;wa=va+27|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ia+27>>0]=0;ia=s5(J,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;J=g+11|0;b[J>>0]=9;va=g;w=471002;wa=va+9|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[g+9>>0]=0;I=s5(ia,g)|0;if((b[J>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;J=g+11|0;b[J>>0]=5;b[g>>0]=b[471012]|0;b[g+1>>0]=b[471013]|0;b[g+2>>0]=b[471014]|0;b[g+3>>0]=b[471015]|0;b[g+4>>0]=b[471016]|0;b[g+5>>0]=0;ia=s5(I,g)|0;if((b[J>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;J=$Xc(16)|0;f[g>>2]=J;f[g+8>>2]=-2147483632;f[g+4>>2]=11;va=J;w=471018;wa=va+11|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[J+11>>0]=0;J=s5(ia,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ia=g+11|0;b[ia>>0]=4;f[g>>2]=1380008264;b[g+4>>0]=0;I=s5(J,g)|0;if((b[ia>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ia=g+11|0;b[ia>>0]=6;b[g>>0]=b[471030]|0;b[g+1>>0]=b[471031]|0;b[g+2>>0]=b[471032]|0;b[g+3>>0]=b[471033]|0;b[g+4>>0]=b[471034]|0;b[g+5>>0]=b[471035]|0;b[g+6>>0]=0;J=s5(I,g)|0;if((b[ia>>0]|0)<0)cYc(f[g>>2]|0);if(_i[f[(f[c>>2]|0)+12>>2]&2047](J)|0){ia=c+4|0;if((f[ia>>2]|0)==6){I=$Xc(32)|0;f[g>>2]=I;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=I;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[I+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(J,c+8|0,M);if(f[ia>>2]&4|0)f[ia>>2]=6};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ia=g+11|0;b[ia>>0]=5;b[g>>0]=b[471037]|0;b[g+1>>0]=b[471038]|0;b[g+2>>0]=b[471039]|0;b[g+3>>0]=b[471040]|0;b[g+4>>0]=b[471041]|0;b[g+5>>0]=0;M=s5(J,g)|0;if((b[ia>>0]|0)<0)cYc(f[g>>2]|0);if(_i[f[(f[c>>2]|0)+12>>2]&2047](M)|0){ia=c+4|0;if((f[ia>>2]|0)==6){J=$Xc(32)|0;f[g>>2]=J;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=J;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[J+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(M,c+8|0,h);if(f[ia>>2]&4|0)f[ia>>2]=6};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ia=$Xc(16)|0;f[g>>2]=ia;f[g+8>>2]=-2147483632;f[g+4>>2]=11;va=ia;w=471043;wa=va+11|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ia+11>>0]=0;ia=s5(M,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;M=g+11|0;b[M>>0]=1;b[g>>0]=123;b[g+1>>0]=0;h=s5(ia,g)|0;if((b[M>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;M=$Xc(16)|0;f[g>>2]=M;f[g+8>>2]=-2147483632;f[g+4>>2]=12;va=M;w=471055;wa=va+12|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[M+12>>0]=0;M=s5(h,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(_i[f[(f[c>>2]|0)+12>>2]&2047](M)|0){h=c+4|0;if((f[h>>2]|0)==6){ia=$Xc(32)|0;f[g>>2]=ia;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ia;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ia+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(M,c+8|0,N);if(f[h>>2]&4|0)f[h>>2]=6};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=1;b[g>>0]=125;b[g+1>>0]=0;N=s5(M,g)|0;if((b[h>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=13;va=h;w=471068;wa=va+13|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[h+13>>0]=0;h=s5(N,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;N=g+11|0;b[N>>0]=1;b[g>>0]=123;b[g+1>>0]=0;M=s5(h,g)|0;if((b[N>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;N=$Xc(16)|0;f[g>>2]=N;f[g+8>>2]=-2147483632;f[g+4>>2]=11;va=N;w=471082;wa=va+11|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[N+11>>0]=0;N=s5(M,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);do if(_i[f[(f[c>>2]|0)+12>>2]&2047](N)|0){M=c+4|0;if((f[M>>2]|0)==6){h=$Xc(32)|0;f[g>>2]=h;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=h;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[h+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(N,c+8|0,0);if(!(f[M>>2]&4))break;f[M>>2]=6}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ia=g+11|0;b[ia>>0]=1;b[g>>0]=125;b[g+1>>0]=0;J=s5(N,g)|0;if((b[ia>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ia=g+11|0;b[ia>>0]=8;N=g;f[N>>2]=1734440051;f[N+4>>2]=1836404325;b[g+8>>0]=0;N=s5(J,g)|0;if((b[ia>>0]|0)<0)cYc(f[g>>2]|0);do if(_i[f[(f[c>>2]|0)+12>>2]&2047](N)|0){ia=c+4|0;if((f[ia>>2]|0)==6){J=$Xc(32)|0;f[g>>2]=J;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=J;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[J+30>>0]=0;vM(-2,g,528568,473413,1207)}o5(N,c+8|0,a);if(!(f[ia>>2]&4))break;f[ia>>2]=6}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;M=g+11|0;b[M>>0]=6;b[g>>0]=b[470872]|0;b[g+1>>0]=b[470873]|0;b[g+2>>0]=b[470874]|0;b[g+3>>0]=b[470875]|0;b[g+4>>0]=b[470876]|0;b[g+5>>0]=b[470877]|0;b[g+6>>0]=0;h=s5(N,g)|0;if((b[M>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;M=g+11|0;b[M>>0]=1;b[g>>0]=91;b[g+1>>0]=0;s5(h,g)|0;if((b[M>>0]|0)<0)cYc(f[g>>2]|0);a:do if(P){M=g+11|0;h=g+1|0;N=g+8|0;I=g+4|0;s=g+11|0;G=g+8|0;S=g+4|0;H=g+11|0;z=g+8|0;i=g+4|0;F=g+11|0;ga=g+11|0;fa=g+1|0;ea=g+11|0;da=g+1|0;ca=g+11|0;ba=g+1|0;aa=g+11|0;$=g+1|0;_=g+8|0;Z=g+4|0;Y=g+11|0;X=g+11|0;W=g+2|0;V=g+11|0;U=g+1|0;v=g+11|0;R=g+10|0;E=g+11|0;D=g+2|0;C=g+11|0;B=g+1|0;A=g+11|0;y=g+1|0;t=c+4|0;x=c+8|0;ha=0;b:while(1){Q=f[m>>2]|0;r=(f[Q+(ha*24|0)+12>>2]|0)-(f[Q+(ha*24|0)+8>>2]|0)|0;Q=(r|0)/24|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[M>>0]=1;b[g>>0]=123;b[h>>0]=0;q=s5(c,g)|0;if((b[M>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=$Xc(16)|0;f[g>>2]=o;f[N>>2]=-2147483632;f[I>>2]=12;va=o;w=471055;wa=va+12|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[o+12>>0]=0;l=s5(q,g)|0;if((b[s>>0]|0)<0)cYc(f[g>>2]|0);do if(_i[f[(f[c>>2]|0)+12>>2]&2047](l)|0){la=c+4|0;if((f[la>>2]|0)==6){Aa=107;break b}o5(l,c+8|0,Q);if(!(f[la>>2]&4))break;f[la>>2]=6}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;q=$Xc(16)|0;f[g>>2]=q;f[G>>2]=-2147483632;f[S>>2]=14;va=q;w=471094;wa=va+14|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[q+14>>0]=0;o=s5(l,g)|0;if((b[H>>0]|0)<0)cYc(f[g>>2]|0);la=(f[m>>2]|0)+(ha*24|0)|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](o)|0){ja=c+4|0;if((f[ja>>2]|0)==6){Aa=114;break b}q5(o,c+8|0,+p[la>>3]);if(!(f[ja>>2]&4))break;f[ja>>2]=6}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;la=$Xc(16)|0;f[g>>2]=la;f[z>>2]=-2147483632;f[i>>2]=15;va=la;w=471109;wa=va+15|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[la+15>>0]=0;l=s5(o,g)|0;if((b[F>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[ga>>0]=1;b[g>>0]=91;b[fa>>0]=0;s5(l,g)|0;if((b[ga>>0]|0)<0)cYc(f[g>>2]|0);if((r|0)>0){l=0;do{q=f[(f[m>>2]|0)+(ha*24|0)+8>>2]|0;ja=q+(l*24|0)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[aa>>0]=1;b[g>>0]=123;b[$>>0]=0;ma=s5(c,g)|0;if((b[aa>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;oa=$Xc(16)|0;f[g>>2]=oa;f[_>>2]=-2147483632;f[Z>>2]=13;va=oa;w=471125;wa=va+13|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[oa+13>>0]=0;na=s5(ma,g)|0;if((b[Y>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[X>>0]=2;d[g>>1]=14939;b[W>>0]=0;s5(na,g)|0;if((b[X>>0]|0)<0)cYc(f[g>>2]|0);na=f[ja>>2]|0;pa=(f[q+(l*24|0)+4>>2]|0)-na|0;ra=pa>>4;qa=q+(l*24|0)+12|0;sa=(f[q+(l*24|0)+16>>2]|0)-(f[qa>>2]|0)|0;ta=sa>>2;c:do if((pa|0)>0){ua=0;xa=na;while(1){ya=xa+(ua<<4)+4|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[t>>2]|0)==6){Aa=132;break b}o5(c,x,f[ya>>2]|0);if(!(f[t>>2]&4))break;f[t>>2]=6}while(0);ya=(f[ja>>2]|0)+(ua<<4)+8|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[t>>2]|0)==6){Aa=137;break b}o5(c,x,f[ya>>2]|0);if(!(f[t>>2]&4))break;f[t>>2]=6}while(0);ya=(f[ja>>2]|0)+(ua<<4)|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[t>>2]|0)==6){Aa=142;break b}o5(c,x,f[ya>>2]|0);if(!(f[t>>2]&4))break;f[t>>2]=6}while(0);ya=(f[ja>>2]|0)+(ua<<4)+12|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[t>>2]|0)==6){Aa=147;break b}p5(c,x,+n[ya>>2]);if(!(f[t>>2]&4))break;f[t>>2]=6}while(0);ya=ua+1|0;if((ya|0)>=(ra|0))break c;ua=ya;xa=f[ja>>2]|0}}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[V>>0]=1;b[g>>0]=93;b[U>>0]=0;ja=s5(c,g)|0;if((b[V>>0]|0)<0)cYc(f[g>>2]|0);b[v>>0]=10;va=g;w=471139;wa=va+10|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[R>>0]=0;ra=s5(ja,g)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[E>>0]=2;d[g>>1]=14939;b[D>>0]=0;s5(ra,g)|0;if((b[E>>0]|0)<0)cYc(f[g>>2]|0);if((sa|0)>0){ra=0;do{na=(f[qa>>2]|0)+(ra<<2)|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0){if((f[t>>2]|0)==6){Aa=162;break b}p5(c,x,+n[na>>2]);if(!(f[t>>2]&4))break;f[t>>2]=6}while(0);ra=ra+1|0}while((ra|0)<(ta|0))};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[C>>0]=1;b[g>>0]=93;b[B>>0]=0;ta=s5(c,g)|0;if((b[C>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[A>>0]=1;b[g>>0]=125;b[y>>0]=0;s5(ta,g)|0;if((b[A>>0]|0)<0)cYc(f[g>>2]|0);l=l+1|0}while((l|0)<(Q|0))};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[ea>>0]=1;b[g>>0]=93;b[da>>0]=0;Q=s5(c,g)|0;if((b[ea>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[ca>>0]=1;b[g>>0]=125;b[ba>>0]=0;s5(Q,g)|0;if((b[ca>>0]|0)<0)cYc(f[g>>2]|0);ha=ha+1|0;if((ha|0)>=(a|0))break a}if((Aa|0)==107){ha=$Xc(32)|0;f[g>>2]=ha;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ha;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ha+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==114){ca=$Xc(32)|0;f[g>>2]=ca;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ca;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ca+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==132){ha=$Xc(32)|0;f[g>>2]=ha;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ha;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ha+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==137){ca=$Xc(32)|0;f[g>>2]=ca;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ca;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ca+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==142){ha=$Xc(32)|0;f[g>>2]=ha;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ha;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ha+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==147){ca=$Xc(32)|0;f[g>>2]=ca;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ca;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ca+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==162){ha=$Xc(32)|0;f[g>>2]=ha;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=ha;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[ha+30>>0]=0;vM(-2,g,528568,473413,1207)}}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=g+11|0;b[a>>0]=1;b[g>>0]=93;b[g+1>>0]=0;P=s5(c,g)|0;if((b[a>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=g+11|0;b[a>>0]=8;ca=g;f[ca>>2]=1952540006;f[ca+4>>2]=1936028277;b[g+8>>0]=0;ca=s5(P,g)|0;if((b[a>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=g+11|0;b[a>>0]=1;b[g>>0]=91;b[g+1>>0]=0;s5(ca,g)|0;if((b[a>>0]|0)<0)cYc(f[g>>2]|0);d:do if((O|0)>0){a=g+11|0;ca=g+1|0;P=g+11|0;ba=g+5|0;ea=g+11|0;da=g+1|0;A=g+11|0;y=g+2|0;C=g+11|0;B=g+1|0;t=g+11|0;x=g+1|0;E=g+11|0;D=g+1|0;v=g+11|0;R=g+6|0;V=0;e:while(1){U=f[k>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[a>>0]=1;b[g>>0]=123;b[ca>>0]=0;X=s5(c,g)|0;if((b[a>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[P>>0]=5;b[g>>0]=b[470910]|0;b[g+1>>0]=b[470911]|0;b[g+2>>0]=b[470912]|0;b[g+3>>0]=b[470913]|0;b[g+4>>0]=b[470914]|0;b[ba>>0]=0;W=s5(X,g)|0;if((b[P>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[ea>>0]=1;b[g>>0]=91;b[da>>0]=0;s5(W,g)|0;if((b[ea>>0]|0)<0)cYc(f[g>>2]|0);W=U+(V<<6)+60|0;X=0;do{if((X|0)==2?+L(+(+n[W>>2]))<1.1920928955078125e-07:0)break;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[A>>0]=2;d[g>>1]=14939;b[y>>0]=0;Y=s5(c,g)|0;if((b[A>>0]|0)<0)cYc(f[g>>2]|0);Z=U+(V<<6)+4+(X*20|0)|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](Y)|0){_=c+4|0;if((f[_>>2]|0)==6){Aa=197;break e}o5(Y,c+8|0,f[Z>>2]|0);if(!(f[_>>2]&4))break;f[_>>2]=6}while(0);Z=U+(V<<6)+4+(X*20|0)+4|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](Y)|0){_=c+4|0;if((f[_>>2]|0)==6){Aa=202;break e}o5(Y,c+8|0,f[Z>>2]|0);if(!(f[_>>2]&4))break;f[_>>2]=6}while(0);Z=U+(V<<6)+4+(X*20|0)+8|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](Y)|0){_=c+4|0;if((f[_>>2]|0)==6){Aa=207;break e}o5(Y,c+8|0,f[Z>>2]|0);if(!(f[_>>2]&4))break;f[_>>2]=6}while(0);Z=U+(V<<6)+4+(X*20|0)+12|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](Y)|0){_=c+4|0;if((f[_>>2]|0)==6){Aa=212;break e}o5(Y,c+8|0,f[Z>>2]|0);if(!(f[_>>2]&4))break;f[_>>2]=6}while(0);Z=U+(V<<6)+4+(X*20|0)+16|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](Y)|0){_=c+4|0;if((f[_>>2]|0)==6){Aa=217;break e}p5(Y,c+8|0,+n[Z>>2]);if(!(f[_>>2]&4))break;f[_>>2]=6}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[C>>0]=1;b[g>>0]=93;b[B>>0]=0;s5(Y,g)|0;if((b[C>>0]|0)<0)cYc(f[g>>2]|0);X=X+1|0}while((X|0)<3);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[t>>0]=1;b[g>>0]=93;b[x>>0]=0;s5(c,g)|0;if((b[t>>0]|0)<0)cYc(f[g>>2]|0);do if(b[U+(V<<6)>>0]|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[v>>0]=6;b[g>>0]=b[470903]|0;b[g+1>>0]=b[470904]|0;b[g+2>>0]=b[470905]|0;b[g+3>>0]=b[470906]|0;b[g+4>>0]=b[470907]|0;b[g+5>>0]=b[470908]|0;b[R>>0]=0;X=s5(c,g)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if(!(_i[f[(f[c>>2]|0)+12>>2]&2047](X)|0))break;W=c+4|0;if((f[W>>2]|0)==6){Aa=230;break e}o5(X,c+8|0,1);if(!(f[W>>2]&4))break;f[W>>2]=6}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[E>>0]=1;b[g>>0]=125;b[D>>0]=0;s5(c,g)|0;if((b[E>>0]|0)<0)cYc(f[g>>2]|0);V=V+1|0;if((V|0)>=(T|0))break d}if((Aa|0)==197){V=$Xc(32)|0;f[g>>2]=V;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=V;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[V+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==202){E=$Xc(32)|0;f[g>>2]=E;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=E;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[E+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==207){V=$Xc(32)|0;f[g>>2]=V;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=V;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[V+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==212){E=$Xc(32)|0;f[g>>2]=E;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=E;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[E+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==217){V=$Xc(32)|0;f[g>>2]=V;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=V;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[V+30>>0]=0;vM(-2,g,528568,473413,1207)}else if((Aa|0)==230){E=$Xc(32)|0;f[g>>2]=E;f[g+8>>2]=-2147483616;f[g+4>>2]=30;va=E;w=473382;wa=va+30|0;do{b[va>>0]=b[w>>0]|0;va=va+1|0;w=w+1|0}while((va|0)<(wa|0));b[E+30>>0]=0;vM(-2,g,528568,473413,1207)}}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;w=g+11|0;b[w>>0]=1;b[g>>0]=93;b[g+1>>0]=0;va=s5(c,g)|0;if((b[w>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;w=g+11|0;b[w>>0]=1;b[g>>0]=125;b[g+1>>0]=0;s5(va,g)|0;if((b[w>>0]|0)<0)cYc(f[g>>2]|0);VVb(m);m=f[k>>2]|0;if(m|0){k=f[j>>2]|0;if((k|0)!=(m|0))f[j>>2]=k+(~((k+-64-m|0)>>>6)<<6);cYc(m)}K=1;u=e;return K|0}function UVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/24|0;h=d;if(g>>>0<b>>>0){YVb(a,b-g|0);return}if(g>>>0<=b>>>0)return;g=e+(b*24|0)|0;if((h|0)==(g|0))return;else i=h;do{h=i+-24|0;f[c>>2]=h;b=f[i+-12>>2]|0;if(b|0){e=i+-8|0;a=f[e>>2]|0;if((a|0)!=(b|0))f[e>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b)}b=f[h>>2]|0;if(b|0){h=i+-20|0;a=f[h>>2]|0;if((a|0)!=(b|0))f[h>>2]=a+(~((a+-16-b|0)>>>4)<<4);cYc(b)}i=f[c>>2]|0}while((i|0)!=(g|0));return}function VVb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;while(1){d=g+-24|0;f[c>>2]=d;h=g+-16|0;i=f[h>>2]|0;if(!i)j=d;else{d=g+-12|0;k=f[d>>2]|0;if((k|0)==(i|0))l=i;else{m=k;do{k=m+-24|0;f[d>>2]=k;n=f[m+-12>>2]|0;if(n|0){o=m+-8|0;p=f[o>>2]|0;if((p|0)!=(n|0))f[o>>2]=p+(~((p+-4-n|0)>>>2)<<2);cYc(n)}n=f[k>>2]|0;if(n|0){k=m+-20|0;p=f[k>>2]|0;if((p|0)!=(n|0))f[k>>2]=p+(~((p+-16-n|0)>>>4)<<4);cYc(n)}m=f[d>>2]|0}while((m|0)!=(i|0));l=f[h>>2]|0}cYc(l);j=f[c>>2]|0}if((j|0)==(b|0))break;else g=j}e=f[a>>2]|0}cYc(e);return}function WVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>6;i=h+1|0;j=g;k=e;if(i>>>0>67108863)kWc(a);e=a+8|0;l=(f[e>>2]|0)-g|0;m=l>>5;n=l>>6>>>0<33554431?(m>>>0<i>>>0?i:m):67108863;do if(n)if(n>>>0>67108863){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{o=$Xc(n<<6)|0;break}else o=0;while(0);m=o+(h<<6)|0;i=o+(n<<6)|0;b[m>>0]=b[c>>0]|0;f[o+(h<<6)+4>>2]=f[c+4>>2];f[o+(h<<6)+8>>2]=f[c+8>>2];f[o+(h<<6)+12>>2]=f[c+12>>2];f[o+(h<<6)+16>>2]=f[c+16>>2];f[o+(h<<6)+20>>2]=f[c+20>>2];f[o+(h<<6)+24>>2]=f[c+24>>2];f[o+(h<<6)+28>>2]=f[c+28>>2];f[o+(h<<6)+32>>2]=f[c+32>>2];f[o+(h<<6)+36>>2]=f[c+36>>2];f[o+(h<<6)+40>>2]=f[c+40>>2];f[o+(h<<6)+44>>2]=f[c+44>>2];f[o+(h<<6)+48>>2]=f[c+48>>2];f[o+(h<<6)+52>>2]=f[c+52>>2];f[o+(h<<6)+56>>2]=f[c+56>>2];f[o+(h<<6)+60>>2]=f[c+60>>2];c=m+64|0;if((k|0)==(j|0))p=m;else{h=k+-64-g|0;o=k;k=m;while(1){n=o;o=o+-64|0;b[k+-64>>0]=b[o>>0]|0;f[k+-60>>2]=f[n+-60>>2];f[k+-56>>2]=f[n+-56>>2];f[k+-52>>2]=f[n+-52>>2];f[k+-48>>2]=f[n+-48>>2];f[k+-44>>2]=f[n+-44>>2];f[k+-40>>2]=f[n+-40>>2];f[k+-36>>2]=f[n+-36>>2];f[k+-32>>2]=f[n+-32>>2];f[k+-28>>2]=f[n+-28>>2];f[k+-24>>2]=f[n+-24>>2];f[k+-20>>2]=f[n+-20>>2];f[k+-16>>2]=f[n+-16>>2];f[k+-12>>2]=f[n+-12>>2];f[k+-8>>2]=f[n+-8>>2];f[k+-4>>2]=f[n+-4>>2];if((o|0)==(j|0))break;else k=k+-64|0}p=m+(~(h>>>6)<<6)|0}f[a>>2]=p;f[d>>2]=c;f[e>>2]=i;if(!g)return;cYc(j);return}function XVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;cYc(d);return}function YVb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=(f[e>>2]|0)+24|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/24|0;g=i+b|0;if(g>>>0>178956970)kWc(a);j=(d-h|0)/24|0;h=j<<1;d=j>>>0<89478485?(h>>>0<g>>>0?g:h):178956970;do if(d)if(d>>>0>178956970){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*24|0)|0;break}else k=0;while(0);h=k+(i*24|0)|0;i=h;g=k+(d*24|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;b=k+24|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g;n=g}else{j=b;b=i;i=h;do{h=i+-24|0;o=j;j=j+-24|0;f[h>>2]=0;p=i+-20|0;f[p>>2]=0;f[i+-16>>2]=0;f[h>>2]=f[j>>2];h=o+-20|0;f[p>>2]=f[h>>2];p=o+-16|0;f[i+-16>>2]=f[p>>2];f[p>>2]=0;f[h>>2]=0;f[j>>2]=0;h=i+-12|0;p=o+-12|0;f[h>>2]=0;q=i+-8|0;f[q>>2]=0;f[i+-4>>2]=0;f[h>>2]=f[p>>2];h=o+-8|0;f[q>>2]=f[h>>2];q=o+-4|0;f[i+-4>>2]=f[q>>2];f[q>>2]=0;f[h>>2]=0;f[p>>2]=0;i=b+-24|0;b=i}while((j|0)!=(g|0));l=b;m=f[a>>2]|0;n=f[e>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;d=m;if((n|0)!=(d|0)){c=n;do{n=c;c=c+-24|0;k=f[n+-12>>2]|0;if(k|0){e=n+-8|0;l=f[e>>2]|0;if((l|0)!=(k|0))f[e>>2]=l+(~((l+-4-k|0)>>>2)<<2);cYc(k)}k=f[c>>2]|0;if(k|0){l=n+-20|0;n=f[l>>2]|0;if((n|0)!=(k|0))f[l>>2]=n+(~((n+-16-k|0)>>>4)<<4);cYc(k)}}while((c|0)!=(d|0))}if(!m)return;cYc(m);return}
function Mgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+136|0;k=a+140|0;l=a+16|0;m=a+32|0;n=a+48|0;o=a+52|0;p=a+56|0;q=a+60|0;r=a+72|0;s=a+68|0;t=a+64|0;v=e+4|0;w=a+76|0;x=e+4|0;y=a+92|0;z=e+4|0;A=a+108|0;B=e+4|0;C=a+12|0;D=a+360|0;E=a+4|0;F=a+124|0;G=a+128|0;H=a+132|0;I=e+8|0;K=e+8|0;L=a+144|0;M=e+4|0;N=a+148|0;O=e+4|0;P=a+152|0;Q=e+4|0;R=a+156|0;S=e+4|0;T=a+160|0;U=e+4|0;V=a+164|0;W=e+4|0;X=a+168|0;Y=e+4|0;Z=a+172|0;_=e+4|0;$=a+176|0;aa=e+4|0;ba=a+180|0;ca=e+4|0;da=a+184|0;ea=e+4|0;fa=a+188|0;ga=e+4|0;ha=a+192|0;ia=e+4|0;ja=a+196|0;ka=e+4|0;la=a+200|0;ma=e+4|0;na=a+204|0;oa=e+4|0;pa=a+208|0;qa=e+4|0;ra=a+212|0;sa=e+4|0;ta=a+216|0;ua=e+4|0;va=a+220|0;wa=e+4|0;xa=a+224|0;ya=e+4|0;za=a+228|0;Aa=e+4|0;Ba=a+232|0;Ca=e+4|0;Da=a+236|0;Ea=e+4|0;Fa=a+240|0;Ga=e+4|0;Ha=a+244|0;Ia=e+4|0;Ja=a+248|0;Ka=e+4|0;La=a+252|0;Ma=e+4|0;Na=a+256|0;Oa=e+4|0;Pa=a+260|0;Qa=e+4|0;Ra=a+264|0;Sa=e+4|0;Ta=a+268|0;Ua=e+4|0;Va=a+272|0;Wa=e+4|0;Xa=a+276|0;Ya=e+4|0;Za=a+280|0;_a=e+4|0;$a=a+284|0;ab=e+4|0;bb=a+288|0;cb=e+4|0;db=a+292|0;eb=e+4|0;fb=a+296|0;gb=e+4|0;hb=a+300|0;ib=e+4|0;jb=a+304|0;kb=e+4|0;lb=a+308|0;mb=e+4|0;nb=a+312|0;ob=e+4|0;pb=a+316|0;qb=e+4|0;rb=a+320|0;sb=e+4|0;tb=a+324|0;ub=e+4|0;vb=a+328|0;wb=e+4|0;xb=a+332|0;yb=e+4|0;zb=a+336|0;Ab=e+4|0;Bb=a+340|0;Cb=e+4|0;Db=a+344|0;Eb=e+4|0;Fb=a+348|0;Gb=e+4|0;Hb=a+352|0;Ib=e+4|0;Jb=a+356|0;a=e+4|0;a:while(1){Kb=f[c>>2]|0;Lb=f[g>>2]|0;do if(Kb>>>0<Lb>>>0){Mb=b[Kb>>0]|0;Nb=Mb&255;Ob=Kb+1|0;if(Mb<<24>>24>0){Pb=Ob;Qb=Nb}else{if(Ob>>>0>=Lb>>>0){Rb=Nb;Sb=7;break}Mb=h[Ob>>0]|0;if(((Mb^128)&Nb)>>>0<=127){Rb=Nb;Sb=7;break}Pb=Kb+2|0;Qb=Nb+-128+(Mb<<7)|0}f[c>>2]=Pb;Tb=Qb;Sb=9}else{Rb=0;Sb=7}while(0);if((Sb|0)==7){Sb=0;Kb=ZYb(c,Rb)|0;if((Kb+-1|0)>>>0<66133690){Tb=Kb;Sb=9}else Ub=Kb}b:do if((Sb|0)==9){Sb=0;Kb=Tb>>>3&536870911;if((Kb|0)<121)do switch(Kb|0){case 1:{if((Tb&255|0)!=10){Ub=Tb;break b}f[i>>2]=f[i>>2]|1;Lb=f[j>>2]|0;if((Lb|0)==537368){mHa(j,537368);Vb=f[j>>2]|0}else Vb=Lb;if(l$b(c,Vb)|0)continue a;else{Wb=0;Sb=714;break a}break}case 2:{if((Tb&255|0)!=18){Ub=Tb;break b}f[i>>2]=f[i>>2]|2;Lb=f[k>>2]|0;if((Lb|0)==537368){mHa(k,537368);Xb=f[k>>2]|0}else Xb=Lb;if(l$b(c,Xb)|0)continue a;else{Wb=0;Sb=714;break a}break}case 3:{if((Tb&255|0)!=26){Ub=Tb;break b}if(l$b(c,pHa(l)|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 4:{if((Tb&255|0)!=34){Ub=Tb;break b}if(l$b(c,pHa(m)|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 5:{switch((Tb&255)<<24>>24){case 45:break;case 42:{if(_Za(c,n)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}Lb=f[c>>2]|0;if(((f[g>>2]|0)-Lb|0)>3){Mb=Lb;Nb=h[Mb>>0]|h[Mb+1>>0]<<8|h[Mb+2>>0]<<16|h[Mb+3>>0]<<24;f[e>>2]=Nb;f[c>>2]=Lb+4;Yb=Nb}else{if(!(WYb(c,e)|0)){Sb=37;break a}Yb=f[e>>2]|0}Nb=f[n>>2]|0;if((Nb|0)==(f[o>>2]|0)){uHa(n,Nb+1|0);Zb=f[n>>2]|0}else Zb=Nb;Nb=f[p>>2]|0;Lb=Zb+1|0;f[n>>2]=Lb;f[Nb+4+(Zb<<2)>>2]=Yb;Mb=f[c>>2]|0;Ob=(f[g>>2]|0)-Mb|0;if((Ob|0)<=0)continue a;_b=Mb;Mb=(f[o>>2]|0)-Lb|0;$b=(Ob>>>0)/5|0;ac=($b|0)<(Mb|0)?$b:Mb;if((ac|0)>0){bc=0;cc=_b;dc=Lb}else continue a;while(1){if((b[cc>>0]|0)!=45){ec=bc;break}Lb=cc+1|0;Mb=h[Lb>>0]|h[Lb+1>>0]<<8|h[Lb+2>>0]<<16|h[Lb+3>>0]<<24;Lb=dc;dc=dc+1|0;f[n>>2]=dc;f[Nb+4+(Lb<<2)>>2]=Mb;Mb=bc+1|0;if((Mb|0)>=(ac|0)){ec=Mb;break}else{bc=Mb;cc=cc+5|0}}ac=ec*5|0;if((ec|0)<=0)continue a;if((Ob|0)<(ac|0)){SYb(c,ac,Ob)|0;continue a}else{f[c>>2]=_b+ac;continue a}break}case 6:{if((Tb&255|0)!=50){Ub=Tb;break b}ac=f[r>>2]|0;do if(ac){Nb=f[t>>2]|0;Mb=f[ac>>2]|0;if((Nb|0)>=(Mb|0))if((Mb|0)==(f[s>>2]|0)){fc=Mb;Sb=45;break}else{gc=Mb;hc=ac;Sb=46;break}else{f[t>>2]=Nb+1;ic=f[ac+4+(Nb<<2)>>2]|0;break}}else{fc=f[s>>2]|0;Sb=45}while(0);if((Sb|0)==45){Sb=0;XZb(q,fc+1|0);ac=f[r>>2]|0;gc=f[ac>>2]|0;hc=ac;Sb=46}if((Sb|0)==46){Sb=0;f[hc>>2]=gc+1;ac=f[q>>2]|0;if(!ac){_b=$Xc(32)|0;mib(_b);jc=_b}else{if(f[ac+64>>2]|0)SXb(ac,16688,32);_b=RXb(ac,32,2237)|0;mib(_b);jc=_b}_b=f[r>>2]|0;ac=f[t>>2]|0;f[t>>2]=ac+1;f[_b+4+(ac<<2)>>2]=jc;ic=jc}ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;kc=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)kc=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,kc);if((f[v>>2]|0)<0){Sb=58;break a}if(!(Mi[f[(f[ic>>2]|0)+44>>2]&1023](ic,c)|0)){Sb=58;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 7:{if((Tb&255|0)!=58){Ub=Tb;break b}_b=Z$a(w)|0;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(Ob=b[ac>>0]|0,Ob<<24>>24>-1):0){f[c>>2]=ac+1;lc=Ob&255}else{Ob=YYb(c)|0;if((Ob|0)>-1)lc=Ob;else{Wb=0;Sb=714;break a}}JYb(e,c,lc);if((f[x>>2]|0)<0){Sb=67;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Sb=67;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 8:{if((Tb&255|0)!=66){Ub=Tb;break b}_b=KHa(y)|0;Ob=f[c>>2]|0;if(Ob>>>0<(f[g>>2]|0)>>>0?(ac=b[Ob>>0]|0,ac<<24>>24>-1):0){f[c>>2]=Ob+1;mc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)mc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,mc);if((f[z>>2]|0)<0){Sb=76;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Sb=76;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 9:{if((Tb&255|0)!=74){Ub=Tb;break b}_b=KHa(A)|0;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(Ob=b[ac>>0]|0,Ob<<24>>24>-1):0){f[c>>2]=ac+1;nc=Ob&255}else{Ob=YYb(c)|0;if((Ob|0)>-1)nc=Ob;else{Wb=0;Sb=714;break a}}JYb(e,c,nc);if((f[B>>2]|0)<0){Sb=85;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Sb=85;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 10:{if((Tb&255|0)!=80){Ub=Tb;break b}_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0){Ob=b[_b>>0]|0;ac=Ob&255;if(Ob<<24>>24>-1){f[c>>2]=_b+1;oc=ac}else{pc=ac;Sb=91}}else{pc=0;Sb=91}if((Sb|0)==91){Sb=0;ac=KYb(c,pc)|0;_b=J;if((_b|0)>-1|(_b|0)==-1&ac>>>0>4294967295)oc=ac;else{Wb=0;Sb=714;break a}}if(oc>>>0<2){f[C>>2]=f[C>>2]|16777216;f[D>>2]=oc;continue a}ac=f[E>>2]|0;if(!(ac&1))qc=lSa(E)|0;else qc=ac&-2;yqc(qc,10,oc,((oc|0)<0)<<31>>31);continue a;break}case 11:{switch((Tb&255)<<24>>24){case 88:break;case 90:{if(Fib(c,F)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;rc=_b<<24>>24!=0}else{LYb(e,c);_b=e;if(!(b[K>>0]|0)){Wb=0;Sb=714;break a}else rc=(f[_b>>2]|0)!=0|(f[_b+4>>2]|0)!=0}_b=f[F>>2]|0;ac=f[G>>2]|0;if((_b|0)==(ac|0)){wSa(F,_b+1|0);sc=f[F>>2]|0;tc=f[G>>2]|0}else{sc=_b;tc=ac}ac=f[H>>2]|0;_b=sc+1|0;f[F>>2]=_b;b[ac+4+sc>>0]=rc&1;Ob=tc-_b|0;if((Ob|0)>0){uc=Ob;vc=_b;wc=ac}else continue a;while(1){ac=f[c>>2]|0;_b=f[g>>2]|0;if(ac>>>0>=_b>>>0)continue a;if((b[ac>>0]|0)!=88)continue a;Ob=ac+1|0;f[c>>2]=Ob;if(Ob>>>0<_b>>>0?(_b=b[Ob>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+2;xc=_b<<24>>24!=0;yc=vc;zc=wc}else{LYb(e,c);_b=e;if(!(b[I>>0]|0)){Wb=0;Sb=714;break a}xc=(f[_b>>2]|0)!=0|(f[_b+4>>2]|0)!=0;yc=f[F>>2]|0;zc=f[H>>2]|0}_b=yc+1|0;f[F>>2]=_b;b[zc+4+yc>>0]=xc&1;if((uc|0)>1){uc=uc+-1|0;vc=_b;wc=zc}else continue a}break}case 100:{if((Tb&255|0)!=34){Ub=Tb;break b}f[i>>2]=f[i>>2]|4;_b=f[L>>2]|0;if(!_b){ac=$Xc(44)|0;s1a(ac);f[L>>2]=ac;Ac=ac}else Ac=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Bc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Bc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Bc);if((f[M>>2]|0)<0){Sb=124;break a}if(!(Mi[f[(f[Ac>>2]|0)+44>>2]&1023](Ac,c)|0)){Sb=124;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 101:{if((Tb&255|0)!=42){Ub=Tb;break b}f[i>>2]=f[i>>2]|8;ac=f[N>>2]|0;if(!ac){_b=$Xc(28)|0;z1a(_b);f[N>>2]=_b;Cc=_b}else Cc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Dc=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Dc=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Dc);if((f[O>>2]|0)<0){Sb=135;break a}if(!(Mi[f[(f[Cc>>2]|0)+44>>2]&1023](Cc,c)|0)){Sb=135;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 102:{if((Tb&255|0)!=50){Ub=Tb;break b}f[i>>2]=f[i>>2]|16;_b=f[P>>2]|0;if(!_b){ac=$Xc(28)|0;m1a(ac);f[P>>2]=ac;Ec=ac}else Ec=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Fc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Fc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Fc);if((f[Q>>2]|0)<0){Sb=146;break a}if(!(Mi[f[(f[Ec>>2]|0)+44>>2]&1023](Ec,c)|0)){Sb=146;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 103:{if((Tb&255|0)!=58){Ub=Tb;break b}f[i>>2]=f[i>>2]|32;ac=f[R>>2]|0;if(!ac){_b=$Xc(28)|0;g1a(_b);f[R>>2]=_b;Gc=_b}else Gc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Hc=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Hc=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Hc);if((f[S>>2]|0)<0){Sb=157;break a}if(!(Mi[f[(f[Gc>>2]|0)+44>>2]&1023](Gc,c)|0)){Sb=157;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 104:{if((Tb&255|0)!=66){Ub=Tb;break b}f[i>>2]=f[i>>2]|64;_b=f[T>>2]|0;if(!_b){ac=$Xc(24)|0;N0a(ac);f[T>>2]=ac;Ic=ac}else Ic=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Jc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Jc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Jc);if((f[U>>2]|0)<0){Sb=168;break a}if(!(Mi[f[(f[Ic>>2]|0)+44>>2]&1023](Ic,c)|0)){Sb=168;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 105:{if((Tb&255|0)!=74){Ub=Tb;break b}f[i>>2]=f[i>>2]|128;ac=f[V>>2]|0;if(!ac){_b=$Xc(24)|0;x1a(_b);f[V>>2]=_b;Kc=_b}else Kc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Lc=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Lc=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Lc);if((f[W>>2]|0)<0){Sb=179;break a}if(!(Mi[f[(f[Kc>>2]|0)+44>>2]&1023](Kc,c)|0)){Sb=179;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 106:{if((Tb&255|0)!=82){Ub=Tb;break b}f[i>>2]=f[i>>2]|256;_b=f[X>>2]|0;if(!_b){ac=$Xc(120)|0;O0a(ac);f[X>>2]=ac;Mc=ac}else Mc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Nc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Nc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Nc);if((f[Y>>2]|0)<0){Sb=190;break a}if(!(Mi[f[(f[Mc>>2]|0)+44>>2]&1023](Mc,c)|0)){Sb=190;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 107:{if((Tb&255|0)!=90){Ub=Tb;break b}f[i>>2]=f[i>>2]|512;ac=f[Z>>2]|0;if(!ac){_b=$Xc(52)|0;Q0a(_b);f[Z>>2]=_b;Oc=_b}else Oc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Pc=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Pc=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Pc);if((f[_>>2]|0)<0){Sb=201;break a}if(!(Mi[f[(f[Oc>>2]|0)+44>>2]&1023](Oc,c)|0)){Sb=201;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 108:{if((Tb&255|0)!=98){Ub=Tb;break b}f[i>>2]=f[i>>2]|1024;_b=f[$>>2]|0;if(!_b){ac=$Xc(24)|0;S0a(ac);f[$>>2]=ac;Qc=ac}else Qc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Rc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Rc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Rc);if((f[aa>>2]|0)<0){Sb=212;break a}if(!(Mi[f[(f[Qc>>2]|0)+44>>2]&1023](Qc,c)|0)){Sb=212;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 109:{if((Tb&255|0)!=106){Ub=Tb;break b}f[i>>2]=f[i>>2]|2048;ac=f[ba>>2]|0;if(!ac){_b=$Xc(96)|0;k1a(_b);f[ba>>2]=_b;Sc=_b}else Sc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Tc=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Tc=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Tc);if((f[ca>>2]|0)<0){Sb=223;break a}if(!(Mi[f[(f[Sc>>2]|0)+44>>2]&1023](Sc,c)|0)){Sb=223;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 110:{if((Tb&255|0)!=114){Ub=Tb;break b}f[i>>2]=f[i>>2]|4096;_b=f[da>>2]|0;if(!_b){ac=$Xc(36)|0;h1a(ac);f[da>>2]=ac;Uc=ac}else Uc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Vc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Vc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Vc);if((f[ea>>2]|0)<0){Sb=234;break a}if(!(Mi[f[(f[Uc>>2]|0)+44>>2]&1023](Uc,c)|0)){Sb=234;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 111:{if((Tb&255|0)!=122){Ub=Tb;break b}f[i>>2]=f[i>>2]|8192;ac=f[fa>>2]|0;if(!ac){_b=$Xc(28)|0;y1a(_b);f[fa>>2]=_b;Wc=_b}else Wc=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Xc=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Xc=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Xc);if((f[ga>>2]|0)<0){Sb=245;break a}if(!(Mi[f[(f[Wc>>2]|0)+44>>2]&1023](Wc,c)|0)){Sb=245;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 112:{if((Tb&255|0)!=130){Ub=Tb;break b}f[i>>2]=f[i>>2]|16384;_b=f[ha>>2]|0;if(!_b){ac=$Xc(28)|0;T0a(ac);f[ha>>2]=ac;Yc=ac}else Yc=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Zc=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Zc=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Zc);if((f[ia>>2]|0)<0){Sb=256;break a}if(!(Mi[f[(f[Yc>>2]|0)+44>>2]&1023](Yc,c)|0)){Sb=256;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 113:{if((Tb&255|0)!=138){Ub=Tb;break b}f[i>>2]=f[i>>2]|32768;ac=f[ja>>2]|0;if(!ac){_b=$Xc(20)|0;I$a(_b);f[ja>>2]=_b;_c=_b}else _c=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;$c=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)$c=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,$c);if((f[ka>>2]|0)<0){Sb=267;break a}if(!(Mi[f[(f[_c>>2]|0)+44>>2]&1023](_c,c)|0)){Sb=267;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 114:{if((Tb&255|0)!=146){Ub=Tb;break b}f[i>>2]=f[i>>2]|65536;_b=f[la>>2]|0;if(!_b){ac=$Xc(20)|0;n1a(ac);f[la>>2]=ac;ad=ac}else ad=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;bd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)bd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,bd);if((f[ma>>2]|0)<0){Sb=278;break a}if(!(Mi[f[(f[ad>>2]|0)+44>>2]&1023](ad,c)|0)){Sb=278;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 115:{if((Tb&255|0)!=154){Ub=Tb;break b}f[i>>2]=f[i>>2]|131072;ac=f[na>>2]|0;if(!ac){_b=$Xc(60)|0;V0a(_b);f[na>>2]=_b;cd=_b}else cd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;dd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)dd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,dd);if((f[oa>>2]|0)<0){Sb=289;break a}if(!(Mi[f[(f[cd>>2]|0)+44>>2]&1023](cd,c)|0)){Sb=289;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 116:{if((Tb&255|0)!=162){Ub=Tb;break b}f[i>>2]=f[i>>2]|262144;_b=f[pa>>2]|0;if(!_b){ac=$Xc(20)|0;X0a(ac);f[pa>>2]=ac;ed=ac}else ed=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;fd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)fd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,fd);if((f[qa>>2]|0)<0){Sb=300;break a}if(!(Mi[f[(f[ed>>2]|0)+44>>2]&1023](ed,c)|0)){Sb=300;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 117:{if((Tb&255|0)!=170){Ub=Tb;break b}f[i>>2]=f[i>>2]|524288;ac=f[ra>>2]|0;if(!ac){_b=$Xc(36)|0;Y0a(_b);f[ra>>2]=_b;gd=_b}else gd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;hd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)hd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,hd);if((f[sa>>2]|0)<0){Sb=311;break a}if(!(Mi[f[(f[gd>>2]|0)+44>>2]&1023](gd,c)|0)){Sb=311;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 118:{if((Tb&255|0)!=178){Ub=Tb;break b}f[i>>2]=f[i>>2]|1048576;_b=f[ta>>2]|0;if(!_b){ac=$Xc(40)|0;_0a(ac);f[ta>>2]=ac;id=ac}else id=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;jd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)jd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,jd);if((f[ua>>2]|0)<0){Sb=322;break a}if(!(Mi[f[(f[id>>2]|0)+44>>2]&1023](id,c)|0)){Sb=322;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 119:{if((Tb&255|0)!=186){Ub=Tb;break b}f[i>>2]=f[i>>2]|2097152;ac=f[va>>2]|0;if(!ac){_b=$Xc(32)|0;f1a(_b);f[va>>2]=_b;kd=_b}else kd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ld=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)ld=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,ld);if((f[wa>>2]|0)<0){Sb=333;break a}if(!(Mi[f[(f[kd>>2]|0)+44>>2]&1023](kd,c)|0)){Sb=333;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 120:{if((Tb&255|0)!=194){Ub=Tb;break b}f[i>>2]=f[i>>2]|4194304;_b=f[xa>>2]|0;if(!_b){ac=$Xc(24)|0;r1a(ac);f[xa>>2]=ac;md=ac}else md=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;nd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)nd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,nd);if((f[ya>>2]|0)<0){Sb=344;break a}if(!(Mi[f[(f[md>>2]|0)+44>>2]&1023](md,c)|0)){Sb=344;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}while(0);if((Kb|0)<137)do switch(Kb|0){case 121:{if((Tb&255|0)!=202){Ub=Tb;break b}f[i>>2]=f[i>>2]|8388608;ac=f[za>>2]|0;if(!ac){_b=$Xc(68)|0;a1a(_b);f[za>>2]=_b;od=_b}else od=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;pd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)pd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,pd);if((f[Aa>>2]|0)<0){Sb=355;break a}if(!(Mi[f[(f[od>>2]|0)+44>>2]&1023](od,c)|0)){Sb=355;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 122:{if((Tb&255|0)!=210){Ub=Tb;break b}f[i>>2]=f[i>>2]|16777216;_b=f[Ba>>2]|0;if(!_b){ac=$Xc(28)|0;e1a(ac);f[Ba>>2]=ac;qd=ac}else qd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;rd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)rd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,rd);if((f[Ca>>2]|0)<0){Sb=366;break a}if(!(Mi[f[(f[qd>>2]|0)+44>>2]&1023](qd,c)|0)){Sb=366;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 123:{if((Tb&255|0)!=218){Ub=Tb;break b}f[i>>2]=f[i>>2]|33554432;ac=f[Da>>2]|0;if(!ac){_b=$Xc(24)|0;o1a(_b);f[Da>>2]=_b;sd=_b}else sd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;td=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)td=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,td);if((f[Ea>>2]|0)<0){Sb=377;break a}if(!(Mi[f[(f[sd>>2]|0)+44>>2]&1023](sd,c)|0)){Sb=377;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 124:{if((Tb&255|0)!=226){Ub=Tb;break b}f[i>>2]=f[i>>2]|67108864;_b=f[Fa>>2]|0;if(!_b){ac=$Xc(20)|0;v1a(ac);f[Fa>>2]=ac;ud=ac}else ud=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;vd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)vd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,vd);if((f[Ga>>2]|0)<0){Sb=388;break a}if(!(Mi[f[(f[ud>>2]|0)+44>>2]&1023](ud,c)|0)){Sb=388;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 125:{if((Tb&255|0)!=234){Ub=Tb;break b}f[i>>2]=f[i>>2]|134217728;ac=f[Ha>>2]|0;if(!ac){_b=$Xc(24)|0;w1a(_b);f[Ha>>2]=_b;wd=_b}else wd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;xd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)xd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,xd);if((f[Ia>>2]|0)<0){Sb=399;break a}if(!(Mi[f[(f[wd>>2]|0)+44>>2]&1023](wd,c)|0)){Sb=399;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 126:{if((Tb&255|0)!=242){Ub=Tb;break b}f[i>>2]=f[i>>2]|268435456;_b=f[Ja>>2]|0;if(!_b){ac=$Xc(36)|0;p1a(ac);f[Ja>>2]=ac;yd=ac}else yd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;zd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)zd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,zd);if((f[Ka>>2]|0)<0){Sb=410;break a}if(!(Mi[f[(f[yd>>2]|0)+44>>2]&1023](yd,c)|0)){Sb=410;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 127:{if((Tb&255|0)!=250){Ub=Tb;break b}f[i>>2]=f[i>>2]|536870912;ac=f[La>>2]|0;if(!ac){_b=$Xc(20)|0;u1a(_b);f[La>>2]=_b;Ad=_b}else Ad=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Bd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Bd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Bd);if((f[Ma>>2]|0)<0){Sb=421;break a}if(!(Mi[f[(f[Ad>>2]|0)+44>>2]&1023](Ad,c)|0)){Sb=421;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 128:{if((Tb&255|0)!=2){Ub=Tb;break b}f[i>>2]=f[i>>2]|1073741824;_b=f[Na>>2]|0;if(!_b){ac=$Xc(20)|0;j1a(ac);f[Na>>2]=ac;Cd=ac}else Cd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Dd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Dd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Dd);if((f[Oa>>2]|0)<0){Sb=432;break a}if(!(Mi[f[(f[Cd>>2]|0)+44>>2]&1023](Cd,c)|0)){Sb=432;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 129:{if((Tb&255|0)!=10){Ub=Tb;break b}f[i>>2]=f[i>>2]|-2147483648;ac=f[Pa>>2]|0;if(!ac){_b=$Xc(64)|0;c1a(_b);f[Pa>>2]=_b;Ed=_b}else Ed=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Fd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Fd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Fd);if((f[Qa>>2]|0)<0){Sb=443;break a}if(!(Mi[f[(f[Ed>>2]|0)+44>>2]&1023](Ed,c)|0)){Sb=443;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 130:{if((Tb&255|0)!=18){Ub=Tb;break b}f[C>>2]=f[C>>2]|1;_b=f[Ra>>2]|0;if(!_b){ac=$Xc(32)|0;_cb(ac);f[Ra>>2]=ac;Gd=ac}else Gd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Hd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Hd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Hd);if((f[Sa>>2]|0)<0){Sb=454;break a}if(!(Mi[f[(f[Gd>>2]|0)+44>>2]&1023](Gd,c)|0)){Sb=454;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 131:{if((Tb&255|0)!=26){Ub=Tb;break b}f[C>>2]=f[C>>2]|2;ac=f[Ta>>2]|0;if(!ac){_b=$Xc(24)|0;q$a(_b);f[Ta>>2]=_b;Id=_b}else Id=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Jd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Jd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Jd);if((f[Ua>>2]|0)<0){Sb=465;break a}if(!(Mi[f[(f[Id>>2]|0)+44>>2]&1023](Id,c)|0)){Sb=465;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 132:{if((Tb&255|0)!=34){Ub=Tb;break b}f[C>>2]=f[C>>2]|4;_b=f[Va>>2]|0;if(!_b){ac=$Xc(28)|0;abb(ac);f[Va>>2]=ac;Kd=ac}else Kd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Ld=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Ld=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Ld);if((f[Wa>>2]|0)<0){Sb=476;break a}if(!(Mi[f[(f[Kd>>2]|0)+44>>2]&1023](Kd,c)|0)){Sb=476;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 133:{if((Tb&255|0)!=42){Ub=Tb;break b}f[C>>2]=f[C>>2]|8;ac=f[Xa>>2]|0;if(!ac){_b=$Xc(28)|0;$bb(_b);f[Xa>>2]=_b;Md=_b}else Md=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Nd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Nd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Nd);if((f[Ya>>2]|0)<0){Sb=487;break a}if(!(Mi[f[(f[Md>>2]|0)+44>>2]&1023](Md,c)|0)){Sb=487;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 134:{if((Tb&255|0)!=50){Ub=Tb;break b}f[C>>2]=f[C>>2]|16;_b=f[Za>>2]|0;if(!_b){ac=$Xc(28)|0;Idb(ac);f[Za>>2]=ac;Od=ac}else Od=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Pd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Pd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Pd);if((f[_a>>2]|0)<0){Sb=498;break a}if(!(Mi[f[(f[Od>>2]|0)+44>>2]&1023](Od,c)|0)){Sb=498;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 135:{if((Tb&255|0)!=58){Ub=Tb;break b}f[C>>2]=f[C>>2]|32;ac=f[$a>>2]|0;if(!ac){_b=$Xc(24)|0;oeb(_b);f[$a>>2]=_b;Qd=_b}else Qd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Rd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Rd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Rd);if((f[ab>>2]|0)<0){Sb=509;break a}if(!(Mi[f[(f[Qd>>2]|0)+44>>2]&1023](Qd,c)|0)){Sb=509;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 136:{if((Tb&255|0)!=66){Ub=Tb;break b}f[C>>2]=f[C>>2]|64;_b=f[bb>>2]|0;if(!_b){ac=$Xc(28)|0;qcb(ac);f[bb>>2]=ac;Sd=ac}else Sd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Td=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Td=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Td);if((f[cb>>2]|0)<0){Sb=520;break a}if(!(Mi[f[(f[Sd>>2]|0)+44>>2]&1023](Sd,c)|0)){Sb=520;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}while(0);if((Kb|0)<145)switch(Kb|0){case 137:{if((Tb&255|0)!=74){Ub=Tb;break b}f[C>>2]=f[C>>2]|128;ac=f[db>>2]|0;if(!ac){_b=$Xc(36)|0;Geb(_b);f[db>>2]=_b;Ud=_b}else Ud=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Vd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Vd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Vd);if((f[eb>>2]|0)<0){Sb=531;break a}if(!(Mi[f[(f[Ud>>2]|0)+44>>2]&1023](Ud,c)|0)){Sb=531;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 138:{if((Tb&255|0)!=82){Ub=Tb;break b}f[C>>2]=f[C>>2]|256;_b=f[fb>>2]|0;if(!_b){ac=$Xc(24)|0;rbb(ac);f[fb>>2]=ac;Wd=ac}else Wd=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;Xd=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)Xd=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,Xd);if((f[gb>>2]|0)<0){Sb=542;break a}if(!(Mi[f[(f[Wd>>2]|0)+44>>2]&1023](Wd,c)|0)){Sb=542;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 139:{if((Tb&255|0)!=90){Ub=Tb;break b}f[C>>2]=f[C>>2]|512;ac=f[hb>>2]|0;if(!ac){_b=$Xc(28)|0;Egb(_b);f[hb>>2]=_b;Yd=_b}else Yd=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;Zd=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)Zd=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,Zd);if((f[ib>>2]|0)<0){Sb=553;break a}if(!(Mi[f[(f[Yd>>2]|0)+44>>2]&1023](Yd,c)|0)){Sb=553;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 140:{if((Tb&255|0)!=98){Ub=Tb;break b}f[C>>2]=f[C>>2]|1024;_b=f[jb>>2]|0;if(!_b){ac=$Xc(20)|0;Xeb(ac);f[jb>>2]=ac;_d=ac}else _d=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;$d=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)$d=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,$d);if((f[kb>>2]|0)<0){Sb=564;break a}if(!(Mi[f[(f[_d>>2]|0)+44>>2]&1023](_d,c)|0)){Sb=564;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 141:{if((Tb&255|0)!=106){Ub=Tb;break b}f[C>>2]=f[C>>2]|2048;ac=f[lb>>2]|0;if(!ac){_b=$Xc(28)|0;ngb(_b);f[lb>>2]=_b;ae=_b}else ae=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;be=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)be=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,be);if((f[mb>>2]|0)<0){Sb=575;break a}if(!(Mi[f[(f[ae>>2]|0)+44>>2]&1023](ae,c)|0)){Sb=575;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 142:{if((Tb&255|0)!=114){Ub=Tb;break b}f[C>>2]=f[C>>2]|4096;_b=f[nb>>2]|0;if(!_b){ac=$Xc(36)|0;Jbb(ac);f[nb>>2]=ac;ce=ac}else ce=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;de=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)de=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,de);if((f[ob>>2]|0)<0){Sb=586;break a}if(!(Mi[f[(f[ce>>2]|0)+44>>2]&1023](ce,c)|0)){Sb=586;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 143:{if((Tb&255|0)!=122){Ub=Tb;break b}f[C>>2]=f[C>>2]|8192;ac=f[pb>>2]|0;if(!ac){_b=$Xc(32)|0;Zdb(_b);f[pb>>2]=_b;ee=_b}else ee=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;fe=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)fe=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,fe);if((f[qb>>2]|0)<0){Sb=597;break a}if(!(Mi[f[(f[ee>>2]|0)+44>>2]&1023](ee,c)|0)){Sb=597;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 144:{if((Tb&255|0)!=130){Ub=Tb;break b}f[C>>2]=f[C>>2]|16384;_b=f[rb>>2]|0;if(!_b){ac=$Xc(32)|0;Xfb(ac);f[rb>>2]=ac;ge=ac}else ge=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;he=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)he=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,he);if((f[sb>>2]|0)<0){Sb=608;break a}if(!(Mi[f[(f[ge>>2]|0)+44>>2]&1023](ge,c)|0)){Sb=608;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}if((Kb|0)<149)switch(Kb|0){case 145:{if((Tb&255|0)!=138){Ub=Tb;break b}f[C>>2]=f[C>>2]|32768;ac=f[tb>>2]|0;if(!ac){_b=$Xc(20)|0;rdb(_b);f[tb>>2]=_b;ie=_b}else ie=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;je=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)je=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,je);if((f[ub>>2]|0)<0){Sb=619;break a}if(!(Mi[f[(f[ie>>2]|0)+44>>2]&1023](ie,c)|0)){Sb=619;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 146:{if((Tb&255|0)!=146){Ub=Tb;break b}f[C>>2]=f[C>>2]|65536;_b=f[vb>>2]|0;if(!_b){ac=$Xc(32)|0;Icb(ac);f[vb>>2]=ac;ke=ac}else ke=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;le=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)le=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,le);if((f[wb>>2]|0)<0){Sb=630;break a}if(!(Mi[f[(f[ke>>2]|0)+44>>2]&1023](ke,c)|0)){Sb=630;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 147:{if((Tb&255|0)!=154){Ub=Tb;break b}f[C>>2]=f[C>>2]|131072;ac=f[xb>>2]|0;if(!ac){_b=$Xc(52)|0;Xgb(_b);f[xb>>2]=_b;me=_b}else me=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ne=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)ne=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,ne);if((f[yb>>2]|0)<0){Sb=641;break a}if(!(Mi[f[(f[me>>2]|0)+44>>2]&1023](me,c)|0)){Sb=641;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 148:{if((Tb&255|0)!=162){Ub=Tb;break b}f[C>>2]=f[C>>2]|262144;_b=f[zb>>2]|0;if(!_b){ac=$Xc(28)|0;Zgb(ac);f[zb>>2]=ac;oe=ac}else oe=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;pe=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)pe=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,pe);if((f[Ab>>2]|0)<0){Sb=652;break a}if(!(Mi[f[(f[oe>>2]|0)+44>>2]&1023](oe,c)|0)){Sb=652;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}if((Kb|0)<201)switch(Kb|0){case 149:{if((Tb&255|0)!=170){Ub=Tb;break b}f[C>>2]=f[C>>2]|524288;ac=f[Bb>>2]|0;if(!ac){_b=$Xc(28)|0;_gb(_b);f[Bb>>2]=_b;qe=_b}else qe=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;re=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)re=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,re);if((f[Cb>>2]|0)<0){Sb=663;break a}if(!(Mi[f[(f[qe>>2]|0)+44>>2]&1023](qe,c)|0)){Sb=663;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}case 150:{if((Tb&255|0)!=178){Ub=Tb;break b}f[C>>2]=f[C>>2]|1048576;_b=f[Db>>2]|0;if(!_b){ac=$Xc(128)|0;ahb(ac);f[Db>>2]=ac;se=ac}else se=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;te=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)te=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,te);if((f[Eb>>2]|0)<0){Sb=674;break a}if(!(Mi[f[(f[se>>2]|0)+44>>2]&1023](se,c)|0)){Sb=674;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}break}default:{Ub=Tb;break b}}if((Kb|0)<10002){switch(Kb|0){case 201:break;default:{Ub=Tb;break b}}if((Tb&255|0)!=74){Ub=Tb;break}f[C>>2]=f[C>>2]|2097152;ac=f[Fb>>2]|0;if(!ac){_b=$Xc(64)|0;$Za(_b);f[Fb>>2]=_b;ue=_b}else ue=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ve=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)ve=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,ve);if((f[Gb>>2]|0)<0){Sb=685;break a}if(!(Mi[f[(f[ue>>2]|0)+44>>2]&1023](ue,c)|0)){Sb=685;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}}if((Kb|0)<8266711){switch(Kb|0){case 10002:break;default:{Ub=Tb;break b}}if((Tb&255|0)!=146){Ub=Tb;break}f[C>>2]=f[C>>2]|4194304;_b=f[Hb>>2]|0;if(!_b){ac=$Xc(28)|0;IZa(ac);f[Hb>>2]=ac;we=ac}else we=_b;_b=f[c>>2]|0;if(_b>>>0<(f[g>>2]|0)>>>0?(ac=b[_b>>0]|0,ac<<24>>24>-1):0){f[c>>2]=_b+1;xe=ac&255}else{ac=YYb(c)|0;if((ac|0)>-1)xe=ac;else{Wb=0;Sb=714;break a}}JYb(e,c,xe);if((f[Ib>>2]|0)<0){Sb=696;break a}if(!(Mi[f[(f[we>>2]|0)+44>>2]&1023](we,c)|0)){Sb=696;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}}else{switch(Kb|0){case 8266711:break;default:{Ub=Tb;break b}}if((Tb&255|0)!=186){Ub=Tb;break}f[C>>2]=f[C>>2]|8388608;ac=f[Jb>>2]|0;if(!ac){_b=$Xc(28)|0;q_a(_b);f[Jb>>2]=_b;ye=_b}else ye=ac;ac=f[c>>2]|0;if(ac>>>0<(f[g>>2]|0)>>>0?(_b=b[ac>>0]|0,_b<<24>>24>-1):0){f[c>>2]=ac+1;ze=_b&255}else{_b=YYb(c)|0;if((_b|0)>-1)ze=_b;else{Wb=0;Sb=714;break a}}JYb(e,c,ze);if((f[a>>2]|0)<0){Sb=707;break a}if(!(Mi[f[(f[ye>>2]|0)+44>>2]&1023](ye,c)|0)){Sb=707;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Wb=0;Sb=714;break a}}}while(0);if(!Ub){Wb=1;Sb=714;break}_b=f[E>>2]|0;if(!(_b&1))Ae=lSa(E)|0;else Ae=_b&-2;if(!(Lqc(c,Ub,Ae)|0)){Wb=0;Sb=714;break}}switch(Sb|0){case 37:{Wb=0;u=d;return Wb|0}case 58:{Wb=0;u=d;return Wb|0}case 67:{Wb=0;u=d;return Wb|0}case 76:{Wb=0;u=d;return Wb|0}case 85:{Wb=0;u=d;return Wb|0}case 124:{Wb=0;u=d;return Wb|0}case 135:{Wb=0;u=d;return Wb|0}case 146:{Wb=0;u=d;return Wb|0}case 157:{Wb=0;u=d;return Wb|0}case 168:{Wb=0;u=d;return Wb|0}case 179:{Wb=0;u=d;return Wb|0}case 190:{Wb=0;u=d;return Wb|0}case 201:{Wb=0;u=d;return Wb|0}case 212:{Wb=0;u=d;return Wb|0}case 223:{Wb=0;u=d;return Wb|0}case 234:{Wb=0;u=d;return Wb|0}case 245:{Wb=0;u=d;return Wb|0}case 256:{Wb=0;u=d;return Wb|0}case 267:{Wb=0;u=d;return Wb|0}case 278:{Wb=0;u=d;return Wb|0}case 289:{Wb=0;u=d;return Wb|0}case 300:{Wb=0;u=d;return Wb|0}case 311:{Wb=0;u=d;return Wb|0}case 322:{Wb=0;u=d;return Wb|0}case 333:{Wb=0;u=d;return Wb|0}case 344:{Wb=0;u=d;return Wb|0}case 355:{Wb=0;u=d;return Wb|0}case 366:{Wb=0;u=d;return Wb|0}case 377:{Wb=0;u=d;return Wb|0}case 388:{Wb=0;u=d;return Wb|0}case 399:{Wb=0;u=d;return Wb|0}case 410:{Wb=0;u=d;return Wb|0}case 421:{Wb=0;u=d;return Wb|0}case 432:{Wb=0;u=d;return Wb|0}case 443:{Wb=0;u=d;return Wb|0}case 454:{Wb=0;u=d;return Wb|0}case 465:{Wb=0;u=d;return Wb|0}case 476:{Wb=0;u=d;return Wb|0}case 487:{Wb=0;u=d;return Wb|0}case 498:{Wb=0;u=d;return Wb|0}case 509:{Wb=0;u=d;return Wb|0}case 520:{Wb=0;u=d;return Wb|0}case 531:{Wb=0;u=d;return Wb|0}case 542:{Wb=0;u=d;return Wb|0}case 553:{Wb=0;u=d;return Wb|0}case 564:{Wb=0;u=d;return Wb|0}case 575:{Wb=0;u=d;return Wb|0}case 586:{Wb=0;u=d;return Wb|0}case 597:{Wb=0;u=d;return Wb|0}case 608:{Wb=0;u=d;return Wb|0}case 619:{Wb=0;u=d;return Wb|0}case 630:{Wb=0;u=d;return Wb|0}case 641:{Wb=0;u=d;return Wb|0}case 652:{Wb=0;u=d;return Wb|0}case 663:{Wb=0;u=d;return Wb|0}case 674:{Wb=0;u=d;return Wb|0}case 685:{Wb=0;u=d;return Wb|0}case 696:{Wb=0;u=d;return Wb|0}case 707:{Wb=0;u=d;return Wb|0}case 714:{u=d;return Wb|0}}return 0}function Ngb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+48>>2]|0;g=f[a+64>>2]|0;e=h+m+(h<<2)+g|0;if(!g)n=e;else{h=a+72|0;m=0;c=e;while(1){e=f[(f[h>>2]|0)+4+(m<<2)>>2]|0;l=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=l+c+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(g|0)){n=e;break}else c=e}}c=f[a+80>>2]|0;g=c+n|0;if(!c)o=g;else{n=a+88|0;m=0;h=g;while(1){g=f[(f[n>>2]|0)+4+(m<<2)>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;g=e+h+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(c|0)){o=g;break}else h=g}}h=f[a+96>>2]|0;c=h+o|0;if(!h)p=c;else{o=a+104|0;m=0;n=c;while(1){c=f[(f[o>>2]|0)+4+(m<<2)>>2]|0;g=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=g+n+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(h|0)){p=c;break}else n=c}}n=f[a+112>>2]|0;h=n+p|0;if(!n)q=h;else{p=a+120|0;m=0;o=h;while(1){h=f[(f[p>>2]|0)+4+(m<<2)>>2]|0;c=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;h=c+o+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=m+1|0;if((m|0)==(n|0)){q=h;break}else o=h}}o=(f[a+124>>2]<<1)+q|0;q=a+8|0;n=f[q>>2]|0;if(n&255){if(!(n&1))r=o;else{m=f[a+136>>2]|0;p=b[m+11>>0]|0;h=p<<24>>24<0?f[m+4>>2]|0:p&255;r=o+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(n&2))s=r;else{h=f[a+140>>2]|0;p=b[h+11>>0]|0;m=p<<24>>24<0?f[h+4>>2]|0:p&255;s=r+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(n&4)){t=s;u=n}else{m=f[a+144>>2]|0;r=_i[f[(f[m>>2]|0)+48>>2]&2047](m)|0;m=s+2+r+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0;t=m;u=f[q>>2]|0}if(!(u&8)){v=t;w=u}else{u=f[a+148>>2]|0;m=_i[f[(f[u>>2]|0)+48>>2]&2047](u)|0;u=t+2+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=u;w=f[q>>2]|0}if(!(w&16)){x=v;y=w}else{w=f[a+152>>2]|0;u=_i[f[(f[w>>2]|0)+48>>2]&2047](w)|0;w=v+2+u+((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)|0;x=w;y=f[q>>2]|0}if(!(y&32)){z=x;A=y}else{y=f[a+156>>2]|0;w=_i[f[(f[y>>2]|0)+48>>2]&2047](y)|0;y=x+2+w+((((($(w|1|0)|0)^31)*9|0)+73|0)>>>6)|0;z=y;A=f[q>>2]|0}if(!(A&64)){B=z;C=A}else{A=f[a+160>>2]|0;y=_i[f[(f[A>>2]|0)+48>>2]&2047](A)|0;A=z+2+y+((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;B=A;C=f[q>>2]|0}if(!(C&128)){D=B;E=C}else{C=f[a+164>>2]|0;A=_i[f[(f[C>>2]|0)+48>>2]&2047](C)|0;C=B+2+A+((((($(A|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=C;E=f[q>>2]|0}}else{D=o;E=n}if(E&65280){if(!(E&256)){F=D;G=E}else{n=f[a+168>>2]|0;o=_i[f[(f[n>>2]|0)+48>>2]&2047](n)|0;n=D+2+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0;F=n;G=f[q>>2]|0}if(!(G&512)){H=F;I=G}else{G=f[a+172>>2]|0;n=_i[f[(f[G>>2]|0)+48>>2]&2047](G)|0;G=F+2+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;H=G;I=f[q>>2]|0}if(!(I&1024)){J=H;K=I}else{I=f[a+176>>2]|0;G=_i[f[(f[I>>2]|0)+48>>2]&2047](I)|0;I=H+2+G+((((($(G|1|0)|0)^31)*9|0)+73|0)>>>6)|0;J=I;K=f[q>>2]|0}if(!(K&2048)){L=J;M=K}else{K=f[a+180>>2]|0;I=_i[f[(f[K>>2]|0)+48>>2]&2047](K)|0;K=J+2+I+((((($(I|1|0)|0)^31)*9|0)+73|0)>>>6)|0;L=K;M=f[q>>2]|0}if(!(M&4096)){N=L;O=M}else{M=f[a+184>>2]|0;K=_i[f[(f[M>>2]|0)+48>>2]&2047](M)|0;M=L+2+K+((((($(K|1|0)|0)^31)*9|0)+73|0)>>>6)|0;N=M;O=f[q>>2]|0}if(!(O&8192)){P=N;Q=O}else{O=f[a+188>>2]|0;M=_i[f[(f[O>>2]|0)+48>>2]&2047](O)|0;O=N+2+M+((((($(M|1|0)|0)^31)*9|0)+73|0)>>>6)|0;P=O;Q=f[q>>2]|0}if(!(Q&16384)){R=P;S=Q}else{Q=f[a+192>>2]|0;O=_i[f[(f[Q>>2]|0)+48>>2]&2047](Q)|0;Q=P+2+O+((((($(O|1|0)|0)^31)*9|0)+73|0)>>>6)|0;R=Q;S=f[q>>2]|0}if(!(S&32768)){T=R;U=S}else{S=f[a+196>>2]|0;Q=_i[f[(f[S>>2]|0)+48>>2]&2047](S)|0;S=R+2+Q+((((($(Q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;T=S;U=f[q>>2]|0}}else{T=D;U=E}if(U&16711680){if(!(U&65536)){V=T;W=U}else{E=f[a+200>>2]|0;D=_i[f[(f[E>>2]|0)+48>>2]&2047](E)|0;E=T+2+D+((((($(D|1|0)|0)^31)*9|0)+73|0)>>>6)|0;V=E;W=f[q>>2]|0}if(!(W&131072)){X=V;Y=W}else{W=f[a+204>>2]|0;E=_i[f[(f[W>>2]|0)+48>>2]&2047](W)|0;W=V+2+E+((((($(E|1|0)|0)^31)*9|0)+73|0)>>>6)|0;X=W;Y=f[q>>2]|0}if(!(Y&262144)){Z=X;_=Y}else{Y=f[a+208>>2]|0;W=_i[f[(f[Y>>2]|0)+48>>2]&2047](Y)|0;Y=X+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Z=Y;_=f[q>>2]|0}if(!(_&524288)){aa=Z;ba=_}else{_=f[a+212>>2]|0;Y=_i[f[(f[_>>2]|0)+48>>2]&2047](_)|0;_=Z+2+Y+((((($(Y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;aa=_;ba=f[q>>2]|0}if(!(ba&1048576)){ca=aa;da=ba}else{ba=f[a+216>>2]|0;_=_i[f[(f[ba>>2]|0)+48>>2]&2047](ba)|0;ba=aa+2+_+((((($(_|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ca=ba;da=f[q>>2]|0}if(!(da&2097152)){ea=ca;fa=da}else{da=f[a+220>>2]|0;ba=_i[f[(f[da>>2]|0)+48>>2]&2047](da)|0;da=ca+2+ba+((((($(ba|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ea=da;fa=f[q>>2]|0}if(!(fa&4194304)){ga=ea;ha=fa}else{fa=f[a+224>>2]|0;da=_i[f[(f[fa>>2]|0)+48>>2]&2047](fa)|0;fa=ea+2+da+((((($(da|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ga=fa;ha=f[q>>2]|0}if(!(ha&8388608)){ia=ga;ja=ha}else{ha=f[a+228>>2]|0;fa=_i[f[(f[ha>>2]|0)+48>>2]&2047](ha)|0;ha=ga+2+fa+((((($(fa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ia=ha;ja=f[q>>2]|0}}else{ia=T;ja=U}if(ja>>>0>16777215){if(!(ja&16777216)){ka=ia;la=ja}else{ja=f[a+232>>2]|0;U=_i[f[(f[ja>>2]|0)+48>>2]&2047](ja)|0;ja=ia+2+U+((((($(U|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ka=ja;la=f[q>>2]|0}if(!(la&33554432)){ma=ka;na=la}else{la=f[a+236>>2]|0;ja=_i[f[(f[la>>2]|0)+48>>2]&2047](la)|0;la=ka+2+ja+((((($(ja|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ma=la;na=f[q>>2]|0}if(!(na&67108864)){oa=ma;pa=na}else{na=f[a+240>>2]|0;la=_i[f[(f[na>>2]|0)+48>>2]&2047](na)|0;na=ma+2+la+((((($(la|1|0)|0)^31)*9|0)+73|0)>>>6)|0;oa=na;pa=f[q>>2]|0}if(!(pa&134217728)){qa=oa;ra=pa}else{pa=f[a+244>>2]|0;na=_i[f[(f[pa>>2]|0)+48>>2]&2047](pa)|0;pa=oa+2+na+((((($(na|1|0)|0)^31)*9|0)+73|0)>>>6)|0;qa=pa;ra=f[q>>2]|0}if(!(ra&268435456)){sa=qa;ta=ra}else{ra=f[a+248>>2]|0;pa=_i[f[(f[ra>>2]|0)+48>>2]&2047](ra)|0;ra=qa+2+pa+((((($(pa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;sa=ra;ta=f[q>>2]|0}if(!(ta&536870912)){ua=sa;va=ta}else{ta=f[a+252>>2]|0;ra=_i[f[(f[ta>>2]|0)+48>>2]&2047](ta)|0;ta=sa+2+ra+((((($(ra|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ua=ta;va=f[q>>2]|0}if(!(va&1073741824)){wa=ua;xa=va}else{va=f[a+256>>2]|0;ta=_i[f[(f[va>>2]|0)+48>>2]&2047](va)|0;va=ua+2+ta+((((($(ta|1|0)|0)^31)*9|0)+73|0)>>>6)|0;wa=va;xa=f[q>>2]|0}if((xa|0)<0){xa=f[a+260>>2]|0;q=_i[f[(f[xa>>2]|0)+48>>2]&2047](xa)|0;ya=wa+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else ya=wa}else ya=ia;ia=a+12|0;wa=f[ia>>2]|0;do if(!(wa&255)){za=ya;Aa=wa}else{if(!(wa&1)){Ba=ya;Ca=wa}else{q=f[a+264>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=ya+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ba=q;Ca=f[ia>>2]|0}if(!(Ca&2)){Da=Ba;Ea=Ca}else{q=f[a+268>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=Ba+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Da=q;Ea=f[ia>>2]|0}if(!(Ea&4)){Fa=Da;Ga=Ea}else{q=f[a+272>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=Da+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Fa=q;Ga=f[ia>>2]|0}if(!(Ga&8)){Ha=Fa;Ia=Ga}else{q=f[a+276>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=Fa+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ha=q;Ia=f[ia>>2]|0}if(!(Ia&16)){Ja=Ha;Ka=Ia}else{q=f[a+280>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=Ha+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ja=q;Ka=f[ia>>2]|0}if(!(Ka&32)){La=Ja;Ma=Ka}else{q=f[a+284>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=Ja+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;La=q;Ma=f[ia>>2]|0}if(!(Ma&64)){Na=La;Oa=Ma}else{q=f[a+288>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=La+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Na=q;Oa=f[ia>>2]|0}if(!(Oa&128)){za=Na;Aa=Oa;break}q=f[a+292>>2]|0;xa=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=Na+2+xa+((((($(xa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;za=q;Aa=f[ia>>2]|0}while(0);do if(!(Aa&65280)){Pa=za;Qa=Aa}else{if(!(Aa&256)){Ra=za;Sa=Aa}else{Na=f[a+296>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=za+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ra=Na;Sa=f[ia>>2]|0}if(!(Sa&512)){Ta=Ra;Ua=Sa}else{Na=f[a+300>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=Ra+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Ta=Na;Ua=f[ia>>2]|0}if(!(Ua&1024)){Va=Ta;Wa=Ua}else{Na=f[a+304>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=Ta+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Va=Na;Wa=f[ia>>2]|0}if(!(Wa&2048)){Xa=Va;Ya=Wa}else{Na=f[a+308>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=Va+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Xa=Na;Ya=f[ia>>2]|0}if(!(Ya&4096)){Za=Xa;_a=Ya}else{Na=f[a+312>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=Xa+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Za=Na;_a=f[ia>>2]|0}if(!(_a&8192)){$a=Za;ab=_a}else{Na=f[a+316>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=Za+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;$a=Na;ab=f[ia>>2]|0}if(!(ab&16384)){bb=$a;cb=ab}else{Na=f[a+320>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=$a+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;bb=Na;cb=f[ia>>2]|0}if(!(cb&32768)){Pa=bb;Qa=cb;break}Na=f[a+324>>2]|0;Oa=_i[f[(f[Na>>2]|0)+48>>2]&2047](Na)|0;Na=bb+2+Oa+((((($(Oa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Pa=Na;Qa=f[ia>>2]|0}while(0);do if(!(Qa&16711680)){db=Pa;eb=Qa}else{if(!(Qa&65536)){fb=Pa;gb=Qa}else{bb=f[a+328>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=Pa+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;fb=bb;gb=f[ia>>2]|0}if(!(gb&131072)){hb=fb;ib=gb}else{bb=f[a+332>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=fb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;hb=bb;ib=f[ia>>2]|0}if(!(ib&262144)){jb=hb;kb=ib}else{bb=f[a+336>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=hb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;jb=bb;kb=f[ia>>2]|0}if(!(kb&524288)){lb=jb;mb=kb}else{bb=f[a+340>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=jb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;lb=bb;mb=f[ia>>2]|0}if(!(mb&1048576)){nb=lb;ob=mb}else{bb=f[a+344>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=lb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;nb=bb;ob=f[ia>>2]|0}if(!(ob&2097152)){pb=nb;qb=ob}else{bb=f[a+348>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=nb+2+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;pb=bb;qb=f[ia>>2]|0}if(!(qb&4194304)){rb=pb;sb=qb}else{bb=f[a+352>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=pb+3+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;rb=bb;sb=f[ia>>2]|0}if(!(sb&8388608)){db=rb;eb=sb;break}bb=f[a+356>>2]|0;cb=_i[f[(f[bb>>2]|0)+48>>2]&2047](bb)|0;bb=rb+4+cb+((((($(cb|1|0)|0)^31)*9|0)+73|0)>>>6)|0;db=bb;eb=f[ia>>2]|0}while(0);if(!(eb&16777216)){tb=db;ub=a+364|0;f[ub>>2]=tb;return tb|0}eb=f[a+360>>2]|0;if((eb|0)<0)vb=11;else vb=((((($(eb|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;tb=vb+db|0;ub=a+364|0;f[ub>>2]=tb;return tb|0}function Ogb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(e&1|0)f$b(1,f[a+136>>2]|0,c);if(e&2|0)f$b(2,f[a+140>>2]|0,c);e=f[a+20>>2]|0;if((e|0)>0){g=a+28|0;h=0;do{e$b(3,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+36>>2]|0;if((e|0)>0){h=a+44|0;g=0;do{e$b(4,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+48>>2]|0;if((e|0)>0){g=a+56|0;h=0;do{a$b(5,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+64>>2]|0;if(e|0){h=a+72|0;g=0;do{k$b(6,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+80>>2]|0;if(e|0){g=a+88|0;h=0;do{k$b(7,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+96>>2]|0;if(e|0){h=a+104|0;g=0;do{k$b(8,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+112>>2]|0;if(e|0){g=a+120|0;h=0;do{k$b(9,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=a+12|0;if(f[e>>2]&16777216|0)d$b(10,f[a+360>>2]|0,c);h=f[a+124>>2]|0;if((h|0)>0){g=a+132|0;i=0;do{c$b(11,(b[(f[g>>2]|0)+4+i>>0]|0)!=0,c);i=i+1|0}while((i|0)!=(h|0))}h=f[d>>2]|0;if(h&4|0)k$b(100,f[a+144>>2]|0,c);if(h&8|0)k$b(101,f[a+148>>2]|0,c);if(h&16|0)k$b(102,f[a+152>>2]|0,c);if(h&32|0)k$b(103,f[a+156>>2]|0,c);if(h&64|0)k$b(104,f[a+160>>2]|0,c);if(h&128|0)k$b(105,f[a+164>>2]|0,c);if(h&256|0)k$b(106,f[a+168>>2]|0,c);if(h&512|0)k$b(107,f[a+172>>2]|0,c);if(h&1024|0)k$b(108,f[a+176>>2]|0,c);if(h&2048|0)k$b(109,f[a+180>>2]|0,c);if(h&4096|0)k$b(110,f[a+184>>2]|0,c);if(h&8192|0)k$b(111,f[a+188>>2]|0,c);if(h&16384|0)k$b(112,f[a+192>>2]|0,c);if(h&32768|0)k$b(113,f[a+196>>2]|0,c);if(h&65536|0)k$b(114,f[a+200>>2]|0,c);if(h&131072|0)k$b(115,f[a+204>>2]|0,c);if(h&262144|0)k$b(116,f[a+208>>2]|0,c);if(h&524288|0)k$b(117,f[a+212>>2]|0,c);if(h&1048576|0)k$b(118,f[a+216>>2]|0,c);if(h&2097152|0)k$b(119,f[a+220>>2]|0,c);if(h&4194304|0)k$b(120,f[a+224>>2]|0,c);if(h&8388608|0)k$b(121,f[a+228>>2]|0,c);if(h&16777216|0)k$b(122,f[a+232>>2]|0,c);if(h&33554432|0)k$b(123,f[a+236>>2]|0,c);if(h&67108864|0)k$b(124,f[a+240>>2]|0,c);if(h&134217728|0)k$b(125,f[a+244>>2]|0,c);if(h&268435456|0)k$b(126,f[a+248>>2]|0,c);if(h&536870912|0)k$b(127,f[a+252>>2]|0,c);if(h&1073741824|0)k$b(128,f[a+256>>2]|0,c);if((h|0)<0)k$b(129,f[a+260>>2]|0,c);h=f[e>>2]|0;if(h&1|0)k$b(130,f[a+264>>2]|0,c);if(h&2|0)k$b(131,f[a+268>>2]|0,c);if(h&4|0)k$b(132,f[a+272>>2]|0,c);if(h&8|0)k$b(133,f[a+276>>2]|0,c);if(h&16|0)k$b(134,f[a+280>>2]|0,c);if(h&32|0)k$b(135,f[a+284>>2]|0,c);if(h&64|0)k$b(136,f[a+288>>2]|0,c);if(h&128|0)k$b(137,f[a+292>>2]|0,c);if(h&256|0)k$b(138,f[a+296>>2]|0,c);if(h&512|0)k$b(139,f[a+300>>2]|0,c);if(h&1024|0)k$b(140,f[a+304>>2]|0,c);if(h&2048|0)k$b(141,f[a+308>>2]|0,c);if(h&4096|0)k$b(142,f[a+312>>2]|0,c);if(h&8192|0)k$b(143,f[a+316>>2]|0,c);if(h&16384|0)k$b(144,f[a+320>>2]|0,c);if(h&32768|0)k$b(145,f[a+324>>2]|0,c);if(h&65536|0)k$b(146,f[a+328>>2]|0,c);if(h&131072|0)k$b(147,f[a+332>>2]|0,c);if(h&262144|0)k$b(148,f[a+336>>2]|0,c);if(h&524288|0)k$b(149,f[a+340>>2]|0,c);if(h&1048576|0)k$b(150,f[a+344>>2]|0,c);if(h&2097152|0)k$b(201,f[a+348>>2]|0,c);if(h&4194304|0)k$b(10002,f[a+352>>2]|0,c);if(h&8388608|0)k$b(8266711,f[a+356>>2]|0,c);h=f[a+4>>2]|0;if(!(h&1))return;Oqc(h&-2,c);return}function Pgb(a){a=a|0;return f[a+364>>2]|0}function Qgb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0;e=a+8|0;g=f[e>>2]|0;if(!(g&1))h=d;else{i=f[a+136>>2]|0;b[d>>0]=10;h=gZb(i,d+1|0)|0}if(!(g&2))j=h;else{g=f[a+140>>2]|0;b[h>>0]=18;j=gZb(g,h+1|0)|0}h=f[a+20>>2]|0;if((h|0)>0){g=a+28|0;d=0;i=j;while(1){k=f[(f[g>>2]|0)+4+(d<<2)>>2]|0;b[i>>0]=26;l=gZb(k,i+1|0)|0;d=d+1|0;if((d|0)==(h|0)){m=l;break}else i=l}}else m=j;j=f[a+36>>2]|0;if((j|0)>0){i=a+44|0;h=0;d=m;while(1){g=f[(f[i>>2]|0)+4+(h<<2)>>2]|0;b[d>>0]=34;l=gZb(g,d+1|0)|0;h=h+1|0;if((h|0)==(j|0)){n=l;break}else d=l}}else n=m;m=f[a+48>>2]|0;if(!m)o=n;else{d=f[a+56>>2]|0;j=0;h=n;while(1){n=f[d+4+(j<<2)>>2]|0;b[h>>0]=45;i=h+1|0;b[i>>0]=n;b[i+1>>0]=n>>8;b[i+2>>0]=n>>16;b[i+3>>0]=n>>24;n=h+5|0;j=j+1|0;if((j|0)>=(m|0)){o=n;break}else h=n}}h=f[a+64>>2]|0;if(!h)p=o;else{m=a+72|0;j=0;d=o;while(1){o=f[(f[m>>2]|0)+4+(j<<2)>>2]|0;b[d>>0]=50;n=d+1|0;i=_i[f[(f[o>>2]|0)+60>>2]&2047](o)|0;if(i>>>0>127){l=i;g=n;while(1){b[g>>0]=l|128;k=l>>>7;q=g+1|0;if(l>>>0>16383){l=k;g=q}else{r=q;s=k;break}}}else{r=n;s=i}b[r>>0]=s;g=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,r+1|0)|0;j=j+1|0;if((j|0)==(h|0)){p=g;break}else d=g}}d=f[a+80>>2]|0;if(!d)t=p;else{h=a+88|0;j=0;r=p;while(1){p=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[r>>0]=58;s=r+1|0;m=_i[f[(f[p>>2]|0)+60>>2]&2047](p)|0;if(m>>>0>127){g=m;l=s;while(1){b[l>>0]=g|128;k=g>>>7;q=l+1|0;if(g>>>0>16383){g=k;l=q}else{u=q;v=k;break}}}else{u=s;v=m}b[u>>0]=v;l=hj[f[(f[p>>2]|0)+64>>2]&511](p,c,u+1|0)|0;j=j+1|0;if((j|0)==(d|0)){t=l;break}else r=l}}r=f[a+96>>2]|0;if(!r)w=t;else{d=a+104|0;j=0;u=t;while(1){t=f[(f[d>>2]|0)+4+(j<<2)>>2]|0;b[u>>0]=66;v=u+1|0;h=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(h>>>0>127){l=h;g=v;while(1){b[g>>0]=l|128;o=l>>>7;i=g+1|0;if(l>>>0>16383){l=o;g=i}else{x=i;y=o;break}}}else{x=v;y=h}b[x>>0]=y;g=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;j=j+1|0;if((j|0)==(r|0)){w=g;break}else u=g}}u=f[a+112>>2]|0;if(!u)z=w;else{r=a+120|0;j=0;x=w;while(1){w=f[(f[r>>2]|0)+4+(j<<2)>>2]|0;b[x>>0]=74;y=x+1|0;d=_i[f[(f[w>>2]|0)+60>>2]&2047](w)|0;if(d>>>0>127){g=d;l=y;while(1){b[l>>0]=g|128;p=g>>>7;m=l+1|0;if(g>>>0>16383){g=p;l=m}else{A=m;B=p;break}}}else{A=y;B=d}b[A>>0]=B;l=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,A+1|0)|0;j=j+1|0;if((j|0)==(u|0)){z=l;break}else x=l}}x=a+12|0;if(!(f[x>>2]&16777216))C=z;else{u=f[a+360>>2]|0;b[z>>0]=80;j=z+1|0;z=u&255;if(u>>>0>127){A=j;B=z;r=u;l=((u|0)<0)<<31>>31;while(1){b[A>>0]=B|-128;u=r;r=l1c(r|0,l|0,7)|0;g=A+1|0;t=r&255;if(!(l>>>0>0|(l|0)==0&u>>>0>16383)){D=g;E=t;break}else{A=g;B=t;l=J}}}else{D=j;E=z}b[D>>0]=E;C=D+1|0}D=f[a+124>>2]|0;if(!D)F=C;else{E=f[a+132>>2]|0;z=0;j=C;while(1){C=b[E+4+z>>0]|0;b[j>>0]=88;b[j+1>>0]=C;C=j+2|0;z=z+1|0;if((z|0)>=(D|0)){F=C;break}else j=C}}j=f[e>>2]|0;if(!(j&4))G=F;else{e=f[a+144>>2]|0;b[F>>0]=-94;b[F+1>>0]=6;D=F+2|0;F=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(F>>>0>127){z=F;E=D;while(1){b[E>>0]=z|128;C=z>>>7;l=E+1|0;if(z>>>0>16383){z=C;E=l}else{H=l;I=C;break}}}else{H=D;I=F}b[H>>0]=I;G=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,H+1|0)|0}if(!(j&8))K=G;else{H=f[a+148>>2]|0;b[G>>0]=-86;b[G+1>>0]=6;e=G+2|0;G=_i[f[(f[H>>2]|0)+60>>2]&2047](H)|0;if(G>>>0>127){I=G;F=e;while(1){b[F>>0]=I|128;D=I>>>7;E=F+1|0;if(I>>>0>16383){I=D;F=E}else{L=E;M=D;break}}}else{L=e;M=G}b[L>>0]=M;K=hj[f[(f[H>>2]|0)+64>>2]&511](H,c,L+1|0)|0}if(!(j&16))N=K;else{L=f[a+152>>2]|0;b[K>>0]=-78;b[K+1>>0]=6;H=K+2|0;K=_i[f[(f[L>>2]|0)+60>>2]&2047](L)|0;if(K>>>0>127){M=K;G=H;while(1){b[G>>0]=M|128;e=M>>>7;F=G+1|0;if(M>>>0>16383){M=e;G=F}else{O=F;P=e;break}}}else{O=H;P=K}b[O>>0]=P;N=hj[f[(f[L>>2]|0)+64>>2]&511](L,c,O+1|0)|0}if(!(j&32))Q=N;else{O=f[a+156>>2]|0;b[N>>0]=-70;b[N+1>>0]=6;L=N+2|0;N=_i[f[(f[O>>2]|0)+60>>2]&2047](O)|0;if(N>>>0>127){P=N;K=L;while(1){b[K>>0]=P|128;H=P>>>7;G=K+1|0;if(P>>>0>16383){P=H;K=G}else{R=G;S=H;break}}}else{R=L;S=N}b[R>>0]=S;Q=hj[f[(f[O>>2]|0)+64>>2]&511](O,c,R+1|0)|0}if(!(j&64))T=Q;else{R=f[a+160>>2]|0;b[Q>>0]=-62;b[Q+1>>0]=6;O=Q+2|0;Q=_i[f[(f[R>>2]|0)+60>>2]&2047](R)|0;if(Q>>>0>127){S=Q;N=O;while(1){b[N>>0]=S|128;L=S>>>7;K=N+1|0;if(S>>>0>16383){S=L;N=K}else{U=K;V=L;break}}}else{U=O;V=Q}b[U>>0]=V;T=hj[f[(f[R>>2]|0)+64>>2]&511](R,c,U+1|0)|0}if(!(j&128))W=T;else{U=f[a+164>>2]|0;b[T>>0]=-54;b[T+1>>0]=6;R=T+2|0;T=_i[f[(f[U>>2]|0)+60>>2]&2047](U)|0;if(T>>>0>127){V=T;Q=R;while(1){b[Q>>0]=V|128;O=V>>>7;N=Q+1|0;if(V>>>0>16383){V=O;Q=N}else{X=N;Y=O;break}}}else{X=R;Y=T}b[X>>0]=Y;W=hj[f[(f[U>>2]|0)+64>>2]&511](U,c,X+1|0)|0}if(!(j&256))Z=W;else{X=f[a+168>>2]|0;b[W>>0]=-46;b[W+1>>0]=6;U=W+2|0;W=_i[f[(f[X>>2]|0)+60>>2]&2047](X)|0;if(W>>>0>127){Y=W;T=U;while(1){b[T>>0]=Y|128;R=Y>>>7;Q=T+1|0;if(Y>>>0>16383){Y=R;T=Q}else{_=Q;$=R;break}}}else{_=U;$=W}b[_>>0]=$;Z=hj[f[(f[X>>2]|0)+64>>2]&511](X,c,_+1|0)|0}if(!(j&512))aa=Z;else{_=f[a+172>>2]|0;b[Z>>0]=-38;b[Z+1>>0]=6;X=Z+2|0;Z=_i[f[(f[_>>2]|0)+60>>2]&2047](_)|0;if(Z>>>0>127){$=Z;W=X;while(1){b[W>>0]=$|128;U=$>>>7;T=W+1|0;if($>>>0>16383){$=U;W=T}else{ba=T;ca=U;break}}}else{ba=X;ca=Z}b[ba>>0]=ca;aa=hj[f[(f[_>>2]|0)+64>>2]&511](_,c,ba+1|0)|0}if(!(j&1024))da=aa;else{ba=f[a+176>>2]|0;b[aa>>0]=-30;b[aa+1>>0]=6;_=aa+2|0;aa=_i[f[(f[ba>>2]|0)+60>>2]&2047](ba)|0;if(aa>>>0>127){ca=aa;Z=_;while(1){b[Z>>0]=ca|128;X=ca>>>7;W=Z+1|0;if(ca>>>0>16383){ca=X;Z=W}else{ea=W;fa=X;break}}}else{ea=_;fa=aa}b[ea>>0]=fa;da=hj[f[(f[ba>>2]|0)+64>>2]&511](ba,c,ea+1|0)|0}if(!(j&2048))ga=da;else{ea=f[a+180>>2]|0;b[da>>0]=-22;b[da+1>>0]=6;ba=da+2|0;da=_i[f[(f[ea>>2]|0)+60>>2]&2047](ea)|0;if(da>>>0>127){fa=da;aa=ba;while(1){b[aa>>0]=fa|128;_=fa>>>7;Z=aa+1|0;if(fa>>>0>16383){fa=_;aa=Z}else{ha=Z;ia=_;break}}}else{ha=ba;ia=da}b[ha>>0]=ia;ga=hj[f[(f[ea>>2]|0)+64>>2]&511](ea,c,ha+1|0)|0}if(!(j&4096))ja=ga;else{ha=f[a+184>>2]|0;b[ga>>0]=-14;b[ga+1>>0]=6;ea=ga+2|0;ga=_i[f[(f[ha>>2]|0)+60>>2]&2047](ha)|0;if(ga>>>0>127){ia=ga;da=ea;while(1){b[da>>0]=ia|128;ba=ia>>>7;aa=da+1|0;if(ia>>>0>16383){ia=ba;da=aa}else{ka=aa;la=ba;break}}}else{ka=ea;la=ga}b[ka>>0]=la;ja=hj[f[(f[ha>>2]|0)+64>>2]&511](ha,c,ka+1|0)|0}if(!(j&8192))ma=ja;else{ka=f[a+188>>2]|0;b[ja>>0]=-6;b[ja+1>>0]=6;ha=ja+2|0;ja=_i[f[(f[ka>>2]|0)+60>>2]&2047](ka)|0;if(ja>>>0>127){la=ja;ga=ha;while(1){b[ga>>0]=la|128;ea=la>>>7;da=ga+1|0;if(la>>>0>16383){la=ea;ga=da}else{na=da;oa=ea;break}}}else{na=ha;oa=ja}b[na>>0]=oa;ma=hj[f[(f[ka>>2]|0)+64>>2]&511](ka,c,na+1|0)|0}if(!(j&16384))pa=ma;else{na=f[a+192>>2]|0;b[ma>>0]=-126;b[ma+1>>0]=7;ka=ma+2|0;ma=_i[f[(f[na>>2]|0)+60>>2]&2047](na)|0;if(ma>>>0>127){oa=ma;ja=ka;while(1){b[ja>>0]=oa|128;ha=oa>>>7;ga=ja+1|0;if(oa>>>0>16383){oa=ha;ja=ga}else{qa=ga;ra=ha;break}}}else{qa=ka;ra=ma}b[qa>>0]=ra;pa=hj[f[(f[na>>2]|0)+64>>2]&511](na,c,qa+1|0)|0}if(!(j&32768))sa=pa;else{qa=f[a+196>>2]|0;b[pa>>0]=-118;b[pa+1>>0]=7;na=pa+2|0;pa=_i[f[(f[qa>>2]|0)+60>>2]&2047](qa)|0;if(pa>>>0>127){ra=pa;ma=na;while(1){b[ma>>0]=ra|128;ka=ra>>>7;ja=ma+1|0;if(ra>>>0>16383){ra=ka;ma=ja}else{ta=ja;ua=ka;break}}}else{ta=na;ua=pa}b[ta>>0]=ua;sa=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,c,ta+1|0)|0}if(!(j&65536))va=sa;else{ta=f[a+200>>2]|0;b[sa>>0]=-110;b[sa+1>>0]=7;qa=sa+2|0;sa=_i[f[(f[ta>>2]|0)+60>>2]&2047](ta)|0;if(sa>>>0>127){ua=sa;pa=qa;while(1){b[pa>>0]=ua|128;na=ua>>>7;ma=pa+1|0;if(ua>>>0>16383){ua=na;pa=ma}else{wa=ma;xa=na;break}}}else{wa=qa;xa=sa}b[wa>>0]=xa;va=hj[f[(f[ta>>2]|0)+64>>2]&511](ta,c,wa+1|0)|0}if(!(j&131072))ya=va;else{wa=f[a+204>>2]|0;b[va>>0]=-102;b[va+1>>0]=7;ta=va+2|0;va=_i[f[(f[wa>>2]|0)+60>>2]&2047](wa)|0;if(va>>>0>127){xa=va;sa=ta;while(1){b[sa>>0]=xa|128;qa=xa>>>7;pa=sa+1|0;if(xa>>>0>16383){xa=qa;sa=pa}else{za=pa;Aa=qa;break}}}else{za=ta;Aa=va}b[za>>0]=Aa;ya=hj[f[(f[wa>>2]|0)+64>>2]&511](wa,c,za+1|0)|0}if(!(j&262144))Ba=ya;else{za=f[a+208>>2]|0;b[ya>>0]=-94;b[ya+1>>0]=7;wa=ya+2|0;ya=_i[f[(f[za>>2]|0)+60>>2]&2047](za)|0;if(ya>>>0>127){Aa=ya;va=wa;while(1){b[va>>0]=Aa|128;ta=Aa>>>7;sa=va+1|0;if(Aa>>>0>16383){Aa=ta;va=sa}else{Ca=sa;Da=ta;break}}}else{Ca=wa;Da=ya}b[Ca>>0]=Da;Ba=hj[f[(f[za>>2]|0)+64>>2]&511](za,c,Ca+1|0)|0}if(!(j&524288))Ea=Ba;else{Ca=f[a+212>>2]|0;b[Ba>>0]=-86;b[Ba+1>>0]=7;za=Ba+2|0;Ba=_i[f[(f[Ca>>2]|0)+60>>2]&2047](Ca)|0;if(Ba>>>0>127){Da=Ba;ya=za;while(1){b[ya>>0]=Da|128;wa=Da>>>7;va=ya+1|0;if(Da>>>0>16383){Da=wa;ya=va}else{Fa=va;Ga=wa;break}}}else{Fa=za;Ga=Ba}b[Fa>>0]=Ga;Ea=hj[f[(f[Ca>>2]|0)+64>>2]&511](Ca,c,Fa+1|0)|0}if(!(j&1048576))Ha=Ea;else{Fa=f[a+216>>2]|0;b[Ea>>0]=-78;b[Ea+1>>0]=7;Ca=Ea+2|0;Ea=_i[f[(f[Fa>>2]|0)+60>>2]&2047](Fa)|0;if(Ea>>>0>127){Ga=Ea;Ba=Ca;while(1){b[Ba>>0]=Ga|128;za=Ga>>>7;ya=Ba+1|0;if(Ga>>>0>16383){Ga=za;Ba=ya}else{Ia=ya;Ja=za;break}}}else{Ia=Ca;Ja=Ea}b[Ia>>0]=Ja;Ha=hj[f[(f[Fa>>2]|0)+64>>2]&511](Fa,c,Ia+1|0)|0}if(!(j&2097152))Ka=Ha;else{Ia=f[a+220>>2]|0;b[Ha>>0]=-70;b[Ha+1>>0]=7;Fa=Ha+2|0;Ha=_i[f[(f[Ia>>2]|0)+60>>2]&2047](Ia)|0;if(Ha>>>0>127){Ja=Ha;Ea=Fa;while(1){b[Ea>>0]=Ja|128;Ca=Ja>>>7;Ba=Ea+1|0;if(Ja>>>0>16383){Ja=Ca;Ea=Ba}else{La=Ba;Ma=Ca;break}}}else{La=Fa;Ma=Ha}b[La>>0]=Ma;Ka=hj[f[(f[Ia>>2]|0)+64>>2]&511](Ia,c,La+1|0)|0}if(!(j&4194304))Na=Ka;else{La=f[a+224>>2]|0;b[Ka>>0]=-62;b[Ka+1>>0]=7;Ia=Ka+2|0;Ka=_i[f[(f[La>>2]|0)+60>>2]&2047](La)|0;if(Ka>>>0>127){Ma=Ka;Ha=Ia;while(1){b[Ha>>0]=Ma|128;Fa=Ma>>>7;Ea=Ha+1|0;if(Ma>>>0>16383){Ma=Fa;Ha=Ea}else{Oa=Ea;Pa=Fa;break}}}else{Oa=Ia;Pa=Ka}b[Oa>>0]=Pa;Na=hj[f[(f[La>>2]|0)+64>>2]&511](La,c,Oa+1|0)|0}if(!(j&8388608))Qa=Na;else{Oa=f[a+228>>2]|0;b[Na>>0]=-54;b[Na+1>>0]=7;La=Na+2|0;Na=_i[f[(f[Oa>>2]|0)+60>>2]&2047](Oa)|0;if(Na>>>0>127){Pa=Na;Ka=La;while(1){b[Ka>>0]=Pa|128;Ia=Pa>>>7;Ha=Ka+1|0;if(Pa>>>0>16383){Pa=Ia;Ka=Ha}else{Ra=Ha;Sa=Ia;break}}}else{Ra=La;Sa=Na}b[Ra>>0]=Sa;Qa=hj[f[(f[Oa>>2]|0)+64>>2]&511](Oa,c,Ra+1|0)|0}if(!(j&16777216))Ta=Qa;else{Ra=f[a+232>>2]|0;b[Qa>>0]=-46;b[Qa+1>>0]=7;Oa=Qa+2|0;Qa=_i[f[(f[Ra>>2]|0)+60>>2]&2047](Ra)|0;if(Qa>>>0>127){Sa=Qa;Na=Oa;while(1){b[Na>>0]=Sa|128;La=Sa>>>7;Ka=Na+1|0;if(Sa>>>0>16383){Sa=La;Na=Ka}else{Ua=Ka;Va=La;break}}}else{Ua=Oa;Va=Qa}b[Ua>>0]=Va;Ta=hj[f[(f[Ra>>2]|0)+64>>2]&511](Ra,c,Ua+1|0)|0}if(!(j&33554432))Wa=Ta;else{Ua=f[a+236>>2]|0;b[Ta>>0]=-38;b[Ta+1>>0]=7;Ra=Ta+2|0;Ta=_i[f[(f[Ua>>2]|0)+60>>2]&2047](Ua)|0;if(Ta>>>0>127){Va=Ta;Qa=Ra;while(1){b[Qa>>0]=Va|128;Oa=Va>>>7;Na=Qa+1|0;if(Va>>>0>16383){Va=Oa;Qa=Na}else{Xa=Na;Ya=Oa;break}}}else{Xa=Ra;Ya=Ta}b[Xa>>0]=Ya;Wa=hj[f[(f[Ua>>2]|0)+64>>2]&511](Ua,c,Xa+1|0)|0}if(!(j&67108864))Za=Wa;else{Xa=f[a+240>>2]|0;b[Wa>>0]=-30;b[Wa+1>>0]=7;Ua=Wa+2|0;Wa=_i[f[(f[Xa>>2]|0)+60>>2]&2047](Xa)|0;if(Wa>>>0>127){Ya=Wa;Ta=Ua;while(1){b[Ta>>0]=Ya|128;Ra=Ya>>>7;Qa=Ta+1|0;if(Ya>>>0>16383){Ya=Ra;Ta=Qa}else{_a=Qa;$a=Ra;break}}}else{_a=Ua;$a=Wa}b[_a>>0]=$a;Za=hj[f[(f[Xa>>2]|0)+64>>2]&511](Xa,c,_a+1|0)|0}if(!(j&134217728))ab=Za;else{_a=f[a+244>>2]|0;b[Za>>0]=-22;b[Za+1>>0]=7;Xa=Za+2|0;Za=_i[f[(f[_a>>2]|0)+60>>2]&2047](_a)|0;if(Za>>>0>127){$a=Za;Wa=Xa;while(1){b[Wa>>0]=$a|128;Ua=$a>>>7;Ta=Wa+1|0;if($a>>>0>16383){$a=Ua;Wa=Ta}else{bb=Ta;cb=Ua;break}}}else{bb=Xa;cb=Za}b[bb>>0]=cb;ab=hj[f[(f[_a>>2]|0)+64>>2]&511](_a,c,bb+1|0)|0}if(!(j&268435456))db=ab;else{bb=f[a+248>>2]|0;b[ab>>0]=-14;b[ab+1>>0]=7;_a=ab+2|0;ab=_i[f[(f[bb>>2]|0)+60>>2]&2047](bb)|0;if(ab>>>0>127){cb=ab;Za=_a;while(1){b[Za>>0]=cb|128;Xa=cb>>>7;Wa=Za+1|0;if(cb>>>0>16383){cb=Xa;Za=Wa}else{eb=Wa;fb=Xa;break}}}else{eb=_a;fb=ab}b[eb>>0]=fb;db=hj[f[(f[bb>>2]|0)+64>>2]&511](bb,c,eb+1|0)|0}if(!(j&536870912))gb=db;else{eb=f[a+252>>2]|0;b[db>>0]=-6;b[db+1>>0]=7;bb=db+2|0;db=_i[f[(f[eb>>2]|0)+60>>2]&2047](eb)|0;if(db>>>0>127){fb=db;ab=bb;while(1){b[ab>>0]=fb|128;_a=fb>>>7;Za=ab+1|0;if(fb>>>0>16383){fb=_a;ab=Za}else{hb=Za;ib=_a;break}}}else{hb=bb;ib=db}b[hb>>0]=ib;gb=hj[f[(f[eb>>2]|0)+64>>2]&511](eb,c,hb+1|0)|0}if(!(j&1073741824))jb=gb;else{hb=f[a+256>>2]|0;b[gb>>0]=-126;b[gb+1>>0]=8;eb=gb+2|0;gb=_i[f[(f[hb>>2]|0)+60>>2]&2047](hb)|0;if(gb>>>0>127){ib=gb;db=eb;while(1){b[db>>0]=ib|128;bb=ib>>>7;ab=db+1|0;if(ib>>>0>16383){ib=bb;db=ab}else{kb=ab;lb=bb;break}}}else{kb=eb;lb=gb}b[kb>>0]=lb;jb=hj[f[(f[hb>>2]|0)+64>>2]&511](hb,c,kb+1|0)|0}if((j|0)<0){j=f[a+260>>2]|0;b[jb>>0]=-118;b[jb+1>>0]=8;kb=jb+2|0;hb=_i[f[(f[j>>2]|0)+60>>2]&2047](j)|0;if(hb>>>0>127){lb=hb;gb=kb;while(1){b[gb>>0]=lb|128;eb=lb>>>7;db=gb+1|0;if(lb>>>0>16383){lb=eb;gb=db}else{mb=db;nb=eb;break}}}else{mb=kb;nb=hb}b[mb>>0]=nb;ob=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,mb+1|0)|0}else ob=jb;jb=f[x>>2]|0;if(!(jb&1))pb=ob;else{x=f[a+264>>2]|0;b[ob>>0]=-110;b[ob+1>>0]=8;mb=ob+2|0;ob=_i[f[(f[x>>2]|0)+60>>2]&2047](x)|0;if(ob>>>0>127){j=ob;nb=mb;while(1){b[nb>>0]=j|128;hb=j>>>7;kb=nb+1|0;if(j>>>0>16383){j=hb;nb=kb}else{qb=kb;rb=hb;break}}}else{qb=mb;rb=ob}b[qb>>0]=rb;pb=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,qb+1|0)|0}if(!(jb&2))sb=pb;else{qb=f[a+268>>2]|0;b[pb>>0]=-102;b[pb+1>>0]=8;x=pb+2|0;pb=_i[f[(f[qb>>2]|0)+60>>2]&2047](qb)|0;if(pb>>>0>127){rb=pb;ob=x;while(1){b[ob>>0]=rb|128;mb=rb>>>7;nb=ob+1|0;if(rb>>>0>16383){rb=mb;ob=nb}else{tb=nb;ub=mb;break}}}else{tb=x;ub=pb}b[tb>>0]=ub;sb=hj[f[(f[qb>>2]|0)+64>>2]&511](qb,c,tb+1|0)|0}if(!(jb&4))vb=sb;else{tb=f[a+272>>2]|0;b[sb>>0]=-94;b[sb+1>>0]=8;qb=sb+2|0;sb=_i[f[(f[tb>>2]|0)+60>>2]&2047](tb)|0;if(sb>>>0>127){ub=sb;pb=qb;while(1){b[pb>>0]=ub|128;x=ub>>>7;ob=pb+1|0;if(ub>>>0>16383){ub=x;pb=ob}else{wb=ob;xb=x;break}}}else{wb=qb;xb=sb}b[wb>>0]=xb;vb=hj[f[(f[tb>>2]|0)+64>>2]&511](tb,c,wb+1|0)|0}if(!(jb&8))yb=vb;else{wb=f[a+276>>2]|0;b[vb>>0]=-86;b[vb+1>>0]=8;tb=vb+2|0;vb=_i[f[(f[wb>>2]|0)+60>>2]&2047](wb)|0;if(vb>>>0>127){xb=vb;sb=tb;while(1){b[sb>>0]=xb|128;qb=xb>>>7;pb=sb+1|0;if(xb>>>0>16383){xb=qb;sb=pb}else{zb=pb;Ab=qb;break}}}else{zb=tb;Ab=vb}b[zb>>0]=Ab;yb=hj[f[(f[wb>>2]|0)+64>>2]&511](wb,c,zb+1|0)|0}if(!(jb&16))Bb=yb;else{zb=f[a+280>>2]|0;b[yb>>0]=-78;b[yb+1>>0]=8;wb=yb+2|0;yb=_i[f[(f[zb>>2]|0)+60>>2]&2047](zb)|0;if(yb>>>0>127){Ab=yb;vb=wb;while(1){b[vb>>0]=Ab|128;tb=Ab>>>7;sb=vb+1|0;if(Ab>>>0>16383){Ab=tb;vb=sb}else{Cb=sb;Db=tb;break}}}else{Cb=wb;Db=yb}b[Cb>>0]=Db;Bb=hj[f[(f[zb>>2]|0)+64>>2]&511](zb,c,Cb+1|0)|0}if(!(jb&32))Eb=Bb;else{Cb=f[a+284>>2]|0;b[Bb>>0]=-70;b[Bb+1>>0]=8;zb=Bb+2|0;Bb=_i[f[(f[Cb>>2]|0)+60>>2]&2047](Cb)|0;if(Bb>>>0>127){Db=Bb;yb=zb;while(1){b[yb>>0]=Db|128;wb=Db>>>7;vb=yb+1|0;if(Db>>>0>16383){Db=wb;yb=vb}else{Fb=vb;Gb=wb;break}}}else{Fb=zb;Gb=Bb}b[Fb>>0]=Gb;Eb=hj[f[(f[Cb>>2]|0)+64>>2]&511](Cb,c,Fb+1|0)|0}if(!(jb&64))Hb=Eb;else{Fb=f[a+288>>2]|0;b[Eb>>0]=-62;b[Eb+1>>0]=8;Cb=Eb+2|0;Eb=_i[f[(f[Fb>>2]|0)+60>>2]&2047](Fb)|0;if(Eb>>>0>127){Gb=Eb;Bb=Cb;while(1){b[Bb>>0]=Gb|128;zb=Gb>>>7;yb=Bb+1|0;if(Gb>>>0>16383){Gb=zb;Bb=yb}else{Ib=yb;Jb=zb;break}}}else{Ib=Cb;Jb=Eb}b[Ib>>0]=Jb;Hb=hj[f[(f[Fb>>2]|0)+64>>2]&511](Fb,c,Ib+1|0)|0}if(!(jb&128))Kb=Hb;else{Ib=f[a+292>>2]|0;b[Hb>>0]=-54;b[Hb+1>>0]=8;Fb=Hb+2|0;Hb=_i[f[(f[Ib>>2]|0)+60>>2]&2047](Ib)|0;if(Hb>>>0>127){Jb=Hb;Eb=Fb;while(1){b[Eb>>0]=Jb|128;Cb=Jb>>>7;Bb=Eb+1|0;if(Jb>>>0>16383){Jb=Cb;Eb=Bb}else{Lb=Bb;Mb=Cb;break}}}else{Lb=Fb;Mb=Hb}b[Lb>>0]=Mb;Kb=hj[f[(f[Ib>>2]|0)+64>>2]&511](Ib,c,Lb+1|0)|0}if(!(jb&256))Nb=Kb;else{Lb=f[a+296>>2]|0;b[Kb>>0]=-46;b[Kb+1>>0]=8;Ib=Kb+2|0;Kb=_i[f[(f[Lb>>2]|0)+60>>2]&2047](Lb)|0;if(Kb>>>0>127){Mb=Kb;Hb=Ib;while(1){b[Hb>>0]=Mb|128;Fb=Mb>>>7;Eb=Hb+1|0;if(Mb>>>0>16383){Mb=Fb;Hb=Eb}else{Ob=Eb;Pb=Fb;break}}}else{Ob=Ib;Pb=Kb}b[Ob>>0]=Pb;Nb=hj[f[(f[Lb>>2]|0)+64>>2]&511](Lb,c,Ob+1|0)|0}if(!(jb&512))Qb=Nb;else{Ob=f[a+300>>2]|0;b[Nb>>0]=-38;b[Nb+1>>0]=8;Lb=Nb+2|0;Nb=_i[f[(f[Ob>>2]|0)+60>>2]&2047](Ob)|0;if(Nb>>>0>127){Pb=Nb;Kb=Lb;while(1){b[Kb>>0]=Pb|128;Ib=Pb>>>7;Hb=Kb+1|0;if(Pb>>>0>16383){Pb=Ib;Kb=Hb}else{Rb=Hb;Sb=Ib;break}}}else{Rb=Lb;Sb=Nb}b[Rb>>0]=Sb;Qb=hj[f[(f[Ob>>2]|0)+64>>2]&511](Ob,c,Rb+1|0)|0}if(!(jb&1024))Tb=Qb;else{Rb=f[a+304>>2]|0;b[Qb>>0]=-30;b[Qb+1>>0]=8;Ob=Qb+2|0;Qb=_i[f[(f[Rb>>2]|0)+60>>2]&2047](Rb)|0;if(Qb>>>0>127){Sb=Qb;Nb=Ob;while(1){b[Nb>>0]=Sb|128;Lb=Sb>>>7;Kb=Nb+1|0;if(Sb>>>0>16383){Sb=Lb;Nb=Kb}else{Ub=Kb;Vb=Lb;break}}}else{Ub=Ob;Vb=Qb}b[Ub>>0]=Vb;Tb=hj[f[(f[Rb>>2]|0)+64>>2]&511](Rb,c,Ub+1|0)|0}if(!(jb&2048))Wb=Tb;else{Ub=f[a+308>>2]|0;b[Tb>>0]=-22;b[Tb+1>>0]=8;Rb=Tb+2|0;Tb=_i[f[(f[Ub>>2]|0)+60>>2]&2047](Ub)|0;if(Tb>>>0>127){Vb=Tb;Qb=Rb;while(1){b[Qb>>0]=Vb|128;Ob=Vb>>>7;Nb=Qb+1|0;if(Vb>>>0>16383){Vb=Ob;Qb=Nb}else{Xb=Nb;Yb=Ob;break}}}else{Xb=Rb;Yb=Tb}b[Xb>>0]=Yb;Wb=hj[f[(f[Ub>>2]|0)+64>>2]&511](Ub,c,Xb+1|0)|0}if(!(jb&4096))Zb=Wb;else{Xb=f[a+312>>2]|0;b[Wb>>0]=-14;b[Wb+1>>0]=8;Ub=Wb+2|0;Wb=_i[f[(f[Xb>>2]|0)+60>>2]&2047](Xb)|0;if(Wb>>>0>127){Yb=Wb;Tb=Ub;while(1){b[Tb>>0]=Yb|128;Rb=Yb>>>7;Qb=Tb+1|0;if(Yb>>>0>16383){Yb=Rb;Tb=Qb}else{_b=Qb;$b=Rb;break}}}else{_b=Ub;$b=Wb}b[_b>>0]=$b;Zb=hj[f[(f[Xb>>2]|0)+64>>2]&511](Xb,c,_b+1|0)|0}if(!(jb&8192))ac=Zb;else{_b=f[a+316>>2]|0;b[Zb>>0]=-6;b[Zb+1>>0]=8;Xb=Zb+2|0;Zb=_i[f[(f[_b>>2]|0)+60>>2]&2047](_b)|0;if(Zb>>>0>127){$b=Zb;Wb=Xb;while(1){b[Wb>>0]=$b|128;Ub=$b>>>7;Tb=Wb+1|0;if($b>>>0>16383){$b=Ub;Wb=Tb}else{bc=Tb;cc=Ub;break}}}else{bc=Xb;cc=Zb}b[bc>>0]=cc;ac=hj[f[(f[_b>>2]|0)+64>>2]&511](_b,c,bc+1|0)|0}if(!(jb&16384))dc=ac;else{bc=f[a+320>>2]|0;b[ac>>0]=-126;b[ac+1>>0]=9;_b=ac+2|0;ac=_i[f[(f[bc>>2]|0)+60>>2]&2047](bc)|0;if(ac>>>0>127){cc=ac;Zb=_b;while(1){b[Zb>>0]=cc|128;Xb=cc>>>7;Wb=Zb+1|0;if(cc>>>0>16383){cc=Xb;Zb=Wb}else{ec=Wb;fc=Xb;break}}}else{ec=_b;fc=ac}b[ec>>0]=fc;dc=hj[f[(f[bc>>2]|0)+64>>2]&511](bc,c,ec+1|0)|0}if(!(jb&32768))gc=dc;else{ec=f[a+324>>2]|0;b[dc>>0]=-118;b[dc+1>>0]=9;bc=dc+2|0;dc=_i[f[(f[ec>>2]|0)+60>>2]&2047](ec)|0;if(dc>>>0>127){fc=dc;ac=bc;while(1){b[ac>>0]=fc|128;_b=fc>>>7;Zb=ac+1|0;if(fc>>>0>16383){fc=_b;ac=Zb}else{hc=Zb;ic=_b;break}}}else{hc=bc;ic=dc}b[hc>>0]=ic;gc=hj[f[(f[ec>>2]|0)+64>>2]&511](ec,c,hc+1|0)|0}if(!(jb&65536))jc=gc;else{hc=f[a+328>>2]|0;b[gc>>0]=-110;b[gc+1>>0]=9;ec=gc+2|0;gc=_i[f[(f[hc>>2]|0)+60>>2]&2047](hc)|0;if(gc>>>0>127){ic=gc;dc=ec;while(1){b[dc>>0]=ic|128;bc=ic>>>7;ac=dc+1|0;if(ic>>>0>16383){ic=bc;dc=ac}else{kc=ac;lc=bc;break}}}else{kc=ec;lc=gc}b[kc>>0]=lc;jc=hj[f[(f[hc>>2]|0)+64>>2]&511](hc,c,kc+1|0)|0}if(!(jb&131072))mc=jc;else{kc=f[a+332>>2]|0;b[jc>>0]=-102;b[jc+1>>0]=9;hc=jc+2|0;jc=_i[f[(f[kc>>2]|0)+60>>2]&2047](kc)|0;if(jc>>>0>127){lc=jc;gc=hc;while(1){b[gc>>0]=lc|128;ec=lc>>>7;dc=gc+1|0;if(lc>>>0>16383){lc=ec;gc=dc}else{nc=dc;oc=ec;break}}}else{nc=hc;oc=jc}b[nc>>0]=oc;mc=hj[f[(f[kc>>2]|0)+64>>2]&511](kc,c,nc+1|0)|0}if(!(jb&262144))pc=mc;else{nc=f[a+336>>2]|0;b[mc>>0]=-94;b[mc+1>>0]=9;kc=mc+2|0;mc=_i[f[(f[nc>>2]|0)+60>>2]&2047](nc)|0;if(mc>>>0>127){oc=mc;jc=kc;while(1){b[jc>>0]=oc|128;hc=oc>>>7;gc=jc+1|0;if(oc>>>0>16383){oc=hc;jc=gc}else{qc=gc;rc=hc;break}}}else{qc=kc;rc=mc}b[qc>>0]=rc;pc=hj[f[(f[nc>>2]|0)+64>>2]&511](nc,c,qc+1|0)|0}if(!(jb&524288))sc=pc;else{qc=f[a+340>>2]|0;b[pc>>0]=-86;b[pc+1>>0]=9;nc=pc+2|0;pc=_i[f[(f[qc>>2]|0)+60>>2]&2047](qc)|0;if(pc>>>0>127){rc=pc;mc=nc;while(1){b[mc>>0]=rc|128;kc=rc>>>7;jc=mc+1|0;if(rc>>>0>16383){rc=kc;mc=jc}else{tc=jc;uc=kc;break}}}else{tc=nc;uc=pc}b[tc>>0]=uc;sc=hj[f[(f[qc>>2]|0)+64>>2]&511](qc,c,tc+1|0)|0}if(!(jb&1048576))vc=sc;else{tc=f[a+344>>2]|0;b[sc>>0]=-78;b[sc+1>>0]=9;qc=sc+2|0;sc=_i[f[(f[tc>>2]|0)+60>>2]&2047](tc)|0;if(sc>>>0>127){uc=sc;pc=qc;while(1){b[pc>>0]=uc|128;nc=uc>>>7;mc=pc+1|0;if(uc>>>0>16383){uc=nc;pc=mc}else{wc=mc;xc=nc;break}}}else{wc=qc;xc=sc}b[wc>>0]=xc;vc=hj[f[(f[tc>>2]|0)+64>>2]&511](tc,c,wc+1|0)|0}if(!(jb&2097152))yc=vc;else{wc=f[a+348>>2]|0;b[vc>>0]=-54;b[vc+1>>0]=12;tc=vc+2|0;vc=_i[f[(f[wc>>2]|0)+60>>2]&2047](wc)|0;if(vc>>>0>127){xc=vc;sc=tc;while(1){b[sc>>0]=xc|128;qc=xc>>>7;pc=sc+1|0;if(xc>>>0>16383){xc=qc;sc=pc}else{zc=pc;Ac=qc;break}}}else{zc=tc;Ac=vc}b[zc>>0]=Ac;yc=hj[f[(f[wc>>2]|0)+64>>2]&511](wc,c,zc+1|0)|0}if(!(jb&4194304))Bc=yc;else{zc=f[a+352>>2]|0;b[yc>>0]=-110;b[yc+1>>0]=-15;b[yc+2>>0]=4;wc=yc+3|0;yc=_i[f[(f[zc>>2]|0)+60>>2]&2047](zc)|0;if(yc>>>0>127){Ac=yc;vc=wc;while(1){b[vc>>0]=Ac|128;tc=Ac>>>7;sc=vc+1|0;if(Ac>>>0>16383){Ac=tc;vc=sc}else{Cc=sc;Dc=tc;break}}}else{Cc=wc;Dc=yc}b[Cc>>0]=Dc;Bc=hj[f[(f[zc>>2]|0)+64>>2]&511](zc,c,Cc+1|0)|0}if(!(jb&8388608))Ec=Bc;else{jb=f[a+356>>2]|0;b[Bc>>0]=-70;b[Bc+1>>0]=-67;b[Bc+2>>0]=-60;b[Bc+3>>0]=31;Cc=Bc+4|0;Bc=_i[f[(f[jb>>2]|0)+60>>2]&2047](jb)|0;if(Bc>>>0>127){zc=Bc;Dc=Cc;while(1){b[Dc>>0]=zc|128;yc=zc>>>7;wc=Dc+1|0;if(zc>>>0>16383){zc=yc;Dc=wc}else{Fc=wc;Gc=yc;break}}}else{Fc=Cc;Gc=Bc}b[Fc>>0]=Gc;Ec=hj[f[(f[jb>>2]|0)+64>>2]&511](jb,c,Fc+1|0)|0}Fc=f[a+4>>2]|0;if(!(Fc&1)){Hc=Ec;return Hc|0}Hc=Pqc(Fc&-2,Ec)|0;return Hc|0}function Rgb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Kgb(a);c=kZc(b,21568,16608,0)|0;if(!c){Ooc(b,a);return}else{Vgb(a,c);return}}function Sgb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16608,0)|0;if(!c){Ooc(b,a);return}else{Vgb(a,c);return}}function Tgb(a,b){a=a|0;b=b|0;f[a+364>>2]=b;return}function Ugb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535368;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Vgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}vSa(a+16|0,c+16|0);vSa(a+32|0,c+32|0);e=a+48|0;h=c+48|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+56>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+56>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}Wgb(a+60|0,c+60|0);yHa(a+76|0,c+76|0);M0a(a+92|0,c+92|0);M0a(a+108|0,c+108|0);h=a+124|0;e=c+124|0;g=f[e>>2]|0;if(g|0){wSa(h,(f[h>>2]|0)+g|0);o1c((f[h>>2]|0)+((f[a+132>>2]|0)+4)|0,(f[c+132>>2]|0)+4|0,f[e>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+136|0,g=f[c+136>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+140|0,d=f[c+140>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==537368){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);if(e&4|0){d=a+8|0;f[d>>2]=f[d>>2]|4;d=a+144|0;h=f[d>>2]|0;if(!h){g=$Xc(44)|0;s1a(g);f[d>>2]=g;i=g}else i=h;h=f[c+144>>2]|0;t1a(i,h|0?h:532712)}if(e&8|0){h=a+8|0;f[h>>2]=f[h>>2]|8;h=a+148|0;i=f[h>>2]|0;if(!i){g=$Xc(28)|0;z1a(g);f[h>>2]=g;j=g}else j=i;i=f[c+148>>2]|0;g=i|0?i:532760;i=j+4|0;h=f[g+4>>2]|0;if(h&1|0){d=f[i>>2]|0;if(!(d&1))k=lSa(i)|0;else k=d&-2;vqc(k,h&-2)}h=f[g+8>>2]|0;if(h&7|0){if(h&1|0)f[j+16>>2]=f[g+16>>2];if(h&2|0)b[j+20>>0]=b[g+20>>0]|0;if(h&4|0)f[j+24>>2]=f[g+24>>2];g=j+8|0;f[g>>2]=f[g>>2]|h}}if(e&16|0){h=a+8|0;f[h>>2]=f[h>>2]|16;h=a+152|0;g=f[h>>2]|0;if(!g){j=$Xc(28)|0;m1a(j);f[h>>2]=j;l=j}else l=g;g=f[c+152>>2]|0;j=g|0?g:532792;g=l+4|0;h=f[j+4>>2]|0;if(h&1|0){k=f[g>>2]|0;if(!(k&1))m=lSa(g)|0;else m=k&-2;vqc(m,h&-2)}h=f[j+8>>2]|0;if(h&7|0){if(h&1|0)f[l+16>>2]=f[j+16>>2];if(h&2|0)f[l+20>>2]=f[j+20>>2];if(h&4|0)f[l+24>>2]=f[j+24>>2];j=l+8|0;f[j>>2]=f[j>>2]|h}}if(e&32|0){h=a+8|0;f[h>>2]=f[h>>2]|32;h=a+156|0;j=f[h>>2]|0;if(!j){l=$Xc(28)|0;g1a(l);f[h>>2]=l;n=l}else n=j;j=f[c+156>>2]|0;l=j|0?j:532824;j=n+4|0;h=f[l+4>>2]|0;if(h&1|0){m=f[j>>2]|0;if(!(m&1))o=lSa(j)|0;else o=m&-2;vqc(o,h&-2)}h=f[l+8>>2]|0;if(h&7|0){if(h&1|0)b[n+16>>0]=b[l+16>>0]|0;if(h&2|0)f[n+20>>2]=f[l+20>>2];if(h&4|0)f[n+24>>2]=f[l+24>>2];l=n+8|0;f[l>>2]=f[l>>2]|h}}if(e&64|0){h=a+8|0;f[h>>2]=f[h>>2]|64;h=a+160|0;l=f[h>>2]|0;if(!l){n=$Xc(24)|0;N0a(n);f[h>>2]=n;p=n}else p=l;l=f[c+160>>2]|0;n=l|0?l:532856;l=p+4|0;h=f[n+4>>2]|0;if(h&1|0){o=f[l>>2]|0;if(!(o&1))q=lSa(l)|0;else q=o&-2;vqc(q,h&-2)}h=f[n+8>>2]|0;if(h&3|0){if(h&1|0)f[p+16>>2]=f[n+16>>2];if(h&2|0)f[p+20>>2]=f[n+20>>2];n=p+8|0;f[n>>2]=f[n>>2]|h}}if(e&128|0){h=a+8|0;f[h>>2]=f[h>>2]|128;h=a+164|0;n=f[h>>2]|0;if(!n){p=$Xc(24)|0;x1a(p);f[h>>2]=p;r=p}else r=n;n=f[c+164>>2]|0;p=n|0?n:532944;n=r+4|0;h=f[p+4>>2]|0;if(h&1|0){q=f[n>>2]|0;if(!(q&1))s=lSa(n)|0;else s=q&-2;vqc(s,h&-2)}h=f[p+8>>2]|0;if(h&3|0){if(h&1|0)b[r+16>>0]=b[p+16>>0]|0;if(h&2|0)f[r+20>>2]=f[p+20>>2];p=r+8|0;f[p>>2]=f[p>>2]|h}}}do if(e&65280|0){if(e&256|0){h=a+8|0;f[h>>2]=f[h>>2]|256;h=a+168|0;p=f[h>>2]|0;if(!p){r=$Xc(120)|0;O0a(r);f[h>>2]=r;t=r}else t=p;p=f[c+168>>2]|0;P0a(t,p|0?p:532968)}if(e&512|0){p=a+8|0;f[p>>2]=f[p>>2]|512;p=a+172|0;r=f[p>>2]|0;if(!r){h=$Xc(52)|0;Q0a(h);f[p>>2]=h;u=h}else u=r;r=f[c+172>>2]|0;R0a(u,r|0?r:533120)}if(e&1024|0){r=a+8|0;f[r>>2]=f[r>>2]|1024;r=a+176|0;h=f[r>>2]|0;if(!h){p=$Xc(24)|0;S0a(p);f[r>>2]=p;v=p}else v=h;h=f[c+176>>2]|0;p=h|0?h:533248;h=v+4|0;r=f[p+4>>2]|0;if(r&1|0){s=f[h>>2]|0;if(!(s&1))w=lSa(h)|0;else w=s&-2;vqc(w,r&-2)}r=f[p+8>>2]|0;if(r&3|0){if(r&1|0)f[v+16>>2]=f[p+16>>2];if(r&2|0)b[v+20>>0]=b[p+20>>0]|0;p=v+8|0;f[p>>2]=f[p>>2]|r}}if(e&2048|0){r=a+8|0;f[r>>2]=f[r>>2]|2048;r=a+180|0;p=f[r>>2]|0;if(!p){s=$Xc(96)|0;k1a(s);f[r>>2]=s;x=s}else x=p;p=f[c+180>>2]|0;l1a(x,p|0?p:533272)}if(e&4096|0){p=a+8|0;f[p>>2]=f[p>>2]|4096;p=a+184|0;s=f[p>>2]|0;if(!s){r=$Xc(36)|0;h1a(r);f[p>>2]=r;y=r}else y=s;s=f[c+184>>2]|0;i1a(y,s|0?s:533368)}if(e&8192|0){s=a+8|0;f[s>>2]=f[s>>2]|8192;s=a+188|0;r=f[s>>2]|0;if(!r){p=$Xc(28)|0;y1a(p);f[s>>2]=p;z=p}else z=r;r=f[c+188>>2]|0;p=r|0?r:533472;r=z+4|0;s=f[p+4>>2]|0;if(s&1|0){h=f[r>>2]|0;if(!(h&1))A=lSa(r)|0;else A=h&-2;vqc(A,s&-2)}s=f[p+8>>2]|0;if(s&7|0){if(s&1|0)f[z+16>>2]=f[p+16>>2];if(s&2|0)f[z+20>>2]=f[p+20>>2];if(s&4|0)f[z+24>>2]=f[p+24>>2];p=z+8|0;f[p>>2]=f[p>>2]|s}}if(e&16384|0){s=a+8|0;f[s>>2]=f[s>>2]|16384;s=a+192|0;p=f[s>>2]|0;if(!p){h=$Xc(28)|0;T0a(h);f[s>>2]=h;B=h}else B=p;p=f[c+192>>2]|0;U0a(B,p|0?p:533528)}if(e&32768|0){p=a+8|0;f[p>>2]=f[p>>2]|32768;p=a+196|0;h=f[p>>2]|0;if(!h){s=$Xc(20)|0;I$a(s);f[p>>2]=s;C=s}else C=h;h=f[c+196>>2]|0;s=h|0?h:533560;h=C+4|0;p=f[s+4>>2]|0;if(p&1|0){r=f[h>>2]|0;if(!(r&1))D=lSa(h)|0;else D=r&-2;vqc(D,p&-2)}if(f[s+8>>2]&1|0?(p=C+8|0,f[p>>2]=f[p>>2]|1,p=C+16|0,r=f[s+16>>2]|0,s=f[p>>2]|0,(s|0)!=(r|0)):0)if((s|0)==537368){mHa(p,r);break}else{oYc(s,r)|0;break}}}while(0);if(e&16711680|0){if(e&65536|0){C=a+8|0;f[C>>2]=f[C>>2]|65536;C=a+200|0;D=f[C>>2]|0;if(!D){B=$Xc(20)|0;n1a(B);f[C>>2]=B;E=B}else E=D;D=f[c+200>>2]|0;B=D|0?D:533584;D=E+4|0;C=f[B+4>>2]|0;if(C&1|0){z=f[D>>2]|0;if(!(z&1))F=lSa(D)|0;else F=z&-2;vqc(F,C&-2)}if(f[B+8>>2]&1|0){C=f[B+16>>2]|0;B=E+8|0;f[B>>2]=f[B>>2]|1;f[E+16>>2]=C}}if(e&131072|0){C=a+8|0;f[C>>2]=f[C>>2]|131072;C=a+204|0;E=f[C>>2]|0;if(!E){B=$Xc(60)|0;V0a(B);f[C>>2]=B;G=B}else G=E;E=f[c+204>>2]|0;W0a(G,E|0?E:533608)}do if(e&262144|0){E=a+8|0;f[E>>2]=f[E>>2]|262144;E=a+208|0;G=f[E>>2]|0;if(!G){B=$Xc(20)|0;X0a(B);f[E>>2]=B;H=B}else H=G;G=f[c+208>>2]|0;B=G|0?G:533672;G=H+4|0;E=f[B+4>>2]|0;if(E&1|0){C=f[G>>2]|0;if(!(C&1))I=lSa(G)|0;else I=C&-2;vqc(I,E&-2)}if(f[B+8>>2]&1|0?(E=H+8|0,f[E>>2]=f[E>>2]|1,E=H+16|0,C=f[B+16>>2]|0,B=f[E>>2]|0,(B|0)!=(C|0)):0)if((B|0)==537368){mHa(E,C);break}else{oYc(B,C)|0;break}}while(0);if(e&524288|0){H=a+8|0;f[H>>2]=f[H>>2]|524288;H=a+212|0;I=f[H>>2]|0;if(!I){C=$Xc(36)|0;Y0a(C);f[H>>2]=C;J=C}else J=I;I=f[c+212>>2]|0;Z0a(J,I|0?I:533696)}if(e&1048576|0){I=a+8|0;f[I>>2]=f[I>>2]|1048576;I=a+216|0;J=f[I>>2]|0;if(!J){C=$Xc(40)|0;_0a(C);f[I>>2]=C;K=C}else K=J;J=f[c+216>>2]|0;$0a(K,J|0?J:533800)}if(e&2097152|0){J=a+8|0;f[J>>2]=f[J>>2]|2097152;J=a+220|0;K=f[J>>2]|0;if(!K){C=$Xc(32)|0;f1a(C);f[J>>2]=C;L=C}else L=K;K=f[c+220>>2]|0;C=K|0?K:533840;K=L+4|0;J=f[C+4>>2]|0;if(J&1|0){I=f[K>>2]|0;if(!(I&1))M=lSa(K)|0;else M=I&-2;vqc(M,J&-2)}J=f[C+8>>2]|0;if(J&15|0){if(J&1|0)f[L+16>>2]=f[C+16>>2];if(J&2|0)f[L+20>>2]=f[C+20>>2];if(J&4|0)f[L+24>>2]=f[C+24>>2];if(J&8|0)f[L+28>>2]=f[C+28>>2];C=L+8|0;f[C>>2]=f[C>>2]|J}}if(e&4194304|0){J=a+8|0;f[J>>2]=f[J>>2]|4194304;J=a+224|0;C=f[J>>2]|0;if(!C){L=$Xc(24)|0;r1a(L);f[J>>2]=L;N=L}else N=C;C=f[c+224>>2]|0;L=C|0?C:533872;C=N+4|0;J=f[L+4>>2]|0;if(J&1|0){M=f[C>>2]|0;if(!(M&1))O=lSa(C)|0;else O=M&-2;vqc(O,J&-2)}J=f[L+8>>2]|0;if(J&7|0){if(J&1|0)b[N+16>>0]=b[L+16>>0]|0;if(J&2|0)b[N+17>>0]=b[L+17>>0]|0;if(J&4|0)f[N+20>>2]=f[L+20>>2];L=N+8|0;f[L>>2]=f[L>>2]|J}}if(e&8388608|0){J=a+8|0;f[J>>2]=f[J>>2]|8388608;J=a+228|0;L=f[J>>2]|0;if(!L){N=$Xc(68)|0;a1a(N);f[J>>2]=N;P=N}else P=L;L=f[c+228>>2]|0;b1a(P,L|0?L:533920)}}if(e>>>0>16777215){if(e&16777216|0){L=a+8|0;f[L>>2]=f[L>>2]|16777216;L=a+232|0;P=f[L>>2]|0;if(!P){N=$Xc(28)|0;e1a(N);f[L>>2]=N;Q=N}else Q=P;P=f[c+232>>2]|0;N=P|0?P:533992;P=Q+4|0;L=f[N+4>>2]|0;if(L&1|0){J=f[P>>2]|0;if(!(J&1))R=lSa(P)|0;else R=J&-2;vqc(R,L&-2)}L=f[N+8>>2]|0;if(L&7|0){if(L&1|0)f[Q+16>>2]=f[N+16>>2];if(L&2|0)f[Q+20>>2]=f[N+20>>2];if(L&4|0)f[Q+24>>2]=f[N+24>>2];N=Q+8|0;f[N>>2]=f[N>>2]|L}}if(e&33554432|0){L=a+8|0;f[L>>2]=f[L>>2]|33554432;L=a+236|0;N=f[L>>2]|0;if(!N){Q=$Xc(24)|0;o1a(Q);f[L>>2]=Q;S=Q}else S=N;N=f[c+236>>2]|0;Q=N|0?N:534120;N=S+4|0;L=f[Q+4>>2]|0;if(L&1|0){R=f[N>>2]|0;if(!(R&1))T=lSa(N)|0;else T=R&-2;vqc(T,L&-2)}L=f[Q+8>>2]|0;if(L&3|0){if(L&1|0)f[S+16>>2]=f[Q+16>>2];if(L&2|0)f[S+20>>2]=f[Q+20>>2];Q=S+8|0;f[Q>>2]=f[Q>>2]|L}}if(e&67108864|0){L=a+8|0;f[L>>2]=f[L>>2]|67108864;L=a+240|0;Q=f[L>>2]|0;if(!Q){S=$Xc(20)|0;v1a(S);f[L>>2]=S;U=S}else U=Q;Q=f[c+240>>2]|0;S=Q|0?Q:534216;Q=U+4|0;L=f[S+4>>2]|0;if(L&1|0){T=f[Q>>2]|0;if(!(T&1))V=lSa(Q)|0;else V=T&-2;vqc(V,L&-2)}if(f[S+8>>2]&1|0){L=f[S+16>>2]|0;S=U+8|0;f[S>>2]=f[S>>2]|1;f[U+16>>2]=L}}if(e&134217728|0){L=a+8|0;f[L>>2]=f[L>>2]|134217728;L=a+244|0;U=f[L>>2]|0;if(!U){S=$Xc(24)|0;w1a(S);f[L>>2]=S;W=S}else W=U;U=f[c+244>>2]|0;S=U|0?U:534280;U=W+4|0;L=f[S+4>>2]|0;if(L&1|0){V=f[U>>2]|0;if(!(V&1))X=lSa(U)|0;else X=V&-2;vqc(X,L&-2)}L=f[S+8>>2]|0;if(L&3|0){if(L&1|0)f[W+16>>2]=f[S+16>>2];if(L&2|0)f[W+20>>2]=f[S+20>>2];S=W+8|0;f[S>>2]=f[S>>2]|L}}if(e&268435456|0){L=a+8|0;f[L>>2]=f[L>>2]|268435456;L=a+248|0;S=f[L>>2]|0;if(!S){W=$Xc(36)|0;p1a(W);f[L>>2]=W;Y=W}else Y=S;S=f[c+248>>2]|0;q1a(Y,S|0?S:534240)}if(e&536870912|0){S=a+8|0;f[S>>2]=f[S>>2]|536870912;S=a+252|0;Y=f[S>>2]|0;if(!Y){W=$Xc(20)|0;u1a(W);f[S>>2]=W;Z=W}else Z=Y;Y=f[c+252>>2]|0;W=Y|0?Y:534304;Y=Z+4|0;S=f[W+4>>2]|0;if(S&1|0){L=f[Y>>2]|0;if(!(L&1))_=lSa(Y)|0;else _=L&-2;vqc(_,S&-2)}if(f[W+8>>2]&1|0){S=f[W+16>>2]|0;W=Z+8|0;f[W>>2]=f[W>>2]|1;f[Z+16>>2]=S}}if(e&1073741824|0){S=a+8|0;f[S>>2]=f[S>>2]|1073741824;S=a+256|0;Z=f[S>>2]|0;if(!Z){W=$Xc(20)|0;j1a(W);f[S>>2]=W;$=W}else $=Z;Z=f[c+256>>2]|0;W=Z|0?Z:534352;Z=$+4|0;S=f[W+4>>2]|0;if(S&1|0){_=f[Z>>2]|0;if(!(_&1))aa=lSa(Z)|0;else aa=_&-2;vqc(aa,S&-2)}if(f[W+8>>2]&1|0){S=f[W+16>>2]|0;W=$+8|0;f[W>>2]=f[W>>2]|1;f[$+16>>2]=S}}if((e|0)<0){e=a+8|0;f[e>>2]=f[e>>2]|-2147483648;e=a+260|0;S=f[e>>2]|0;if(!S){$=$Xc(64)|0;c1a($);f[e>>2]=$;ba=$}else ba=S;S=f[c+260>>2]|0;d1a(ba,S|0?S:534376)}}S=f[c+12>>2]|0;if(S&255|0){if(S&1|0){ba=a+12|0;f[ba>>2]=f[ba>>2]|1;ba=a+264|0;$=f[ba>>2]|0;if(!$){e=$Xc(32)|0;_cb(e);f[ba>>2]=e;ca=e}else ca=$;$=f[c+264>>2]|0;Zcb(ca,$|0?$:534024)}if(S&2|0){$=a+12|0;f[$>>2]=f[$>>2]|2;$=a+268|0;ca=f[$>>2]|0;if(!ca){e=$Xc(24)|0;q$a(e);f[$>>2]=e;da=e}else da=ca;ca=f[c+268>>2]|0;Z_a(da,ca|0?ca:534968)}if(S&4|0){ca=a+12|0;f[ca>>2]=f[ca>>2]|4;ca=a+272|0;da=f[ca>>2]|0;if(!da){e=$Xc(28)|0;abb(e);f[ca>>2]=e;ea=e}else ea=da;da=f[c+272>>2]|0;e=da|0?da:534440;da=ea+4|0;ca=f[e+4>>2]|0;if(ca&1|0){$=f[da>>2]|0;if(!($&1))fa=lSa(da)|0;else fa=$&-2;vqc(fa,ca&-2)}ca=f[e+8>>2]|0;if(ca&7|0){if(ca&1|0)f[ea+16>>2]=f[e+16>>2];if(ca&2|0)f[ea+20>>2]=f[e+20>>2];if(ca&4|0)f[ea+24>>2]=f[e+24>>2];e=ea+8|0;f[e>>2]=f[e>>2]|ca}}if(S&8|0){ca=a+12|0;f[ca>>2]=f[ca>>2]|8;ca=a+276|0;e=f[ca>>2]|0;if(!e){ea=$Xc(28)|0;$bb(ea);f[ca>>2]=ea;ga=ea}else ga=e;e=f[c+276>>2]|0;_bb(ga,e|0?e:534144)}if(S&16|0){e=a+12|0;f[e>>2]=f[e>>2]|16;e=a+280|0;ga=f[e>>2]|0;if(!ga){ea=$Xc(28)|0;Idb(ea);f[e>>2]=ea;ha=ea}else ha=ga;ga=f[c+280>>2]|0;ea=ga|0?ga:533768;ga=ha+4|0;e=f[ea+4>>2]|0;if(e&1|0){ca=f[ga>>2]|0;if(!(ca&1))ia=lSa(ga)|0;else ia=ca&-2;vqc(ia,e&-2)}e=f[ea+8>>2]|0;if(e&7|0){if(e&1|0)f[ha+16>>2]=f[ea+16>>2];if(e&2|0)f[ha+20>>2]=f[ea+20>>2];if(e&4|0)f[ha+24>>2]=f[ea+24>>2];ea=ha+8|0;f[ea>>2]=f[ea>>2]|e}}if(S&32|0){e=a+12|0;f[e>>2]=f[e>>2]|32;e=a+284|0;ea=f[e>>2]|0;if(!ea){ha=$Xc(24)|0;oeb(ha);f[e>>2]=ha;ja=ha}else ja=ea;ea=f[c+284>>2]|0;ha=ea|0?ea:533504;ea=ja+4|0;e=f[ha+4>>2]|0;if(e&1|0){ia=f[ea>>2]|0;if(!(ia&1))ka=lSa(ea)|0;else ka=ia&-2;vqc(ka,e&-2)}e=f[ha+8>>2]|0;if(e&3|0){if(e&1|0)f[ja+16>>2]=f[ha+16>>2];if(e&2|0)f[ja+20>>2]=f[ha+20>>2];ha=ja+8|0;f[ha>>2]=f[ha>>2]|e}}if(S&64|0){e=a+12|0;f[e>>2]=f[e>>2]|64;e=a+288|0;ha=f[e>>2]|0;if(!ha){ja=$Xc(28)|0;qcb(ja);f[e>>2]=ja;la=ja}else la=ha;ha=f[c+288>>2]|0;ja=ha|0?ha:534088;ha=la+4|0;e=f[ja+4>>2]|0;if(e&1|0){ka=f[ha>>2]|0;if(!(ka&1))ma=lSa(ha)|0;else ma=ka&-2;vqc(ma,e&-2)}e=f[ja+8>>2]|0;if(e&7|0){if(e&1|0)f[la+16>>2]=f[ja+16>>2];if(e&2|0)f[la+20>>2]=f[ja+20>>2];if(e&4|0)f[la+24>>2]=f[ja+24>>2];ja=la+8|0;f[ja>>2]=f[ja>>2]|e}}if(S&128|0){e=a+12|0;f[e>>2]=f[e>>2]|128;e=a+292|0;ja=f[e>>2]|0;if(!ja){la=$Xc(36)|0;Geb(la);f[e>>2]=la;na=la}else na=ja;ja=f[c+292>>2]|0;Feb(na,ja|0?ja:533432)}}if(S&65280|0){if(S&256|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|256;ja=a+296|0;na=f[ja>>2]|0;if(!na){la=$Xc(24)|0;rbb(la);f[ja>>2]=la;oa=la}else oa=na;na=f[c+296>>2]|0;la=na|0?na:534328;na=oa+4|0;ja=f[la+4>>2]|0;if(ja&1|0){e=f[na>>2]|0;if(!(e&1))pa=lSa(na)|0;else pa=e&-2;vqc(pa,ja&-2)}ja=f[la+8>>2]|0;if(ja&3|0){if(ja&1|0)f[oa+16>>2]=f[la+16>>2];if(ja&2|0)f[oa+20>>2]=f[la+20>>2];la=oa+8|0;f[la>>2]=f[la>>2]|ja}}if(S&512|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|512;ja=a+300|0;la=f[ja>>2]|0;if(!la){oa=$Xc(28)|0;Egb(oa);f[ja>>2]=oa;qa=oa}else qa=la;la=f[c+300>>2]|0;oa=la|0?la:532880;la=qa+4|0;ja=f[oa+4>>2]|0;if(ja&1|0){pa=f[la>>2]|0;if(!(pa&1))ra=lSa(la)|0;else ra=pa&-2;vqc(ra,ja&-2)}ja=f[oa+8>>2]|0;if(ja&15|0){if(ja&1|0)b[qa+16>>0]=b[oa+16>>0]|0;if(ja&2|0)b[qa+17>>0]=b[oa+17>>0]|0;if(ja&4|0)f[qa+20>>2]=f[oa+20>>2];if(ja&8|0)f[qa+24>>2]=f[oa+24>>2];oa=qa+8|0;f[oa>>2]=f[oa>>2]|ja}}if(S&1024|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|1024;ja=a+304|0;oa=f[ja>>2]|0;if(!oa){qa=$Xc(20)|0;Xeb(qa);f[ja>>2]=qa;sa=qa}else sa=oa;oa=f[c+304>>2]|0;qa=oa|0?oa:533408;oa=sa+4|0;ja=f[qa+4>>2]|0;if(ja&1|0){ra=f[oa>>2]|0;if(!(ra&1))ta=lSa(oa)|0;else ta=ra&-2;vqc(ta,ja&-2)}if(f[qa+8>>2]&1|0){ja=f[qa+16>>2]|0;qa=sa+8|0;f[qa>>2]=f[qa>>2]|1;f[sa+16>>2]=ja}}if(S&2048|0){ja=a+12|0;f[ja>>2]=f[ja>>2]|2048;ja=a+308|0;sa=f[ja>>2]|0;if(!sa){qa=$Xc(28)|0;ngb(qa);f[ja>>2]=qa;ua=qa}else ua=sa;sa=f[c+308>>2]|0;mgb(ua,sa|0?sa:532912)}if(S&4096|0){sa=a+12|0;f[sa>>2]=f[sa>>2]|4096;sa=a+312|0;ua=f[sa>>2]|0;if(!ua){qa=$Xc(36)|0;Jbb(qa);f[sa>>2]=qa;va=qa}else va=ua;ua=f[c+312>>2]|0;Ibb(va,ua|0?ua:534176)}if(S&8192|0){ua=a+12|0;f[ua>>2]=f[ua>>2]|8192;ua=a+316|0;va=f[ua>>2]|0;if(!va){qa=$Xc(32)|0;Zdb(qa);f[ua>>2]=qa;wa=qa}else wa=va;va=f[c+316>>2]|0;qa=va|0?va:533736;va=wa+4|0;ua=f[qa+4>>2]|0;if(ua&1|0){sa=f[va>>2]|0;if(!(sa&1))xa=lSa(va)|0;else xa=sa&-2;vqc(xa,ua&-2)}e5a(wa+16|0,qa+16|0)}if(S&16384|0){qa=a+12|0;f[qa>>2]=f[qa>>2]|16384;qa=a+320|0;wa=f[qa>>2]|0;if(!wa){ua=$Xc(32)|0;Xfb(ua);f[qa>>2]=ua;ya=ua}else ya=wa;wa=f[c+320>>2]|0;Wfb(ya,wa|0?wa:533088)}if(S&32768|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|32768;wa=a+324|0;ya=f[wa>>2]|0;if(!ya){ua=$Xc(20)|0;rdb(ua);f[wa>>2]=ua;za=ua}else za=ya;ya=f[c+324>>2]|0;qdb(za,ya|0?ya:533896)}}do if(S&16711680|0){if(S&65536|0){ya=a+12|0;f[ya>>2]=f[ya>>2]|65536;ya=a+328|0;za=f[ya>>2]|0;if(!za){ua=$Xc(32)|0;Icb(ua);f[ya>>2]=ua;Aa=ua}else Aa=za;za=f[c+328>>2]|0;Hcb(Aa,za|0?za:534056)}if(S&131072|0){za=a+12|0;f[za>>2]=f[za>>2]|131072;za=a+332|0;ua=f[za>>2]|0;if(!ua){ya=$Xc(52)|0;Xgb(ya);f[za>>2]=ya;Ba=ya}else Ba=ua;ua=f[c+332>>2]|0;Ygb(Ba,ua|0?ua:531664)}if(S&262144|0){ua=a+12|0;f[ua>>2]=f[ua>>2]|262144;ua=a+336|0;ya=f[ua>>2]|0;if(!ya){za=$Xc(28)|0;Zgb(za);f[ua>>2]=za;Ca=za}else Ca=ya;ya=f[c+336>>2]|0;za=ya|0?ya:531472;ya=Ca+4|0;ua=f[za+4>>2]|0;if(ua&1|0){wa=f[ya>>2]|0;if(!(wa&1))Da=lSa(ya)|0;else Da=wa&-2;vqc(Da,ua&-2)}ua=Ca+16|0;wa=za+16|0;ya=f[wa>>2]|0;if(ya|0){xHa(ua,(f[ua>>2]|0)+ya|0);o1c((f[Ca+24>>2]|0)+4+(f[ua>>2]<<2)|0,(f[za+24>>2]|0)+4|0,f[wa>>2]<<2|0)|0;f[ua>>2]=(f[ua>>2]|0)+(f[wa>>2]|0)}}if(S&524288|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|524288;wa=a+340|0;ua=f[wa>>2]|0;if(!ua){za=$Xc(28)|0;_gb(za);f[wa>>2]=za;Ea=za}else Ea=ua;ua=f[c+340>>2]|0;$gb(Ea,ua|0?ua:531504)}if(S&1048576|0){ua=a+12|0;f[ua>>2]=f[ua>>2]|1048576;ua=a+344|0;za=f[ua>>2]|0;if(!za){wa=$Xc(128)|0;ahb(wa);f[ua>>2]=wa;Fa=wa}else Fa=za;za=f[c+344>>2]|0;bhb(Fa,za|0?za:531536)}if(S&2097152|0){za=a+12|0;f[za>>2]=f[za>>2]|2097152;za=a+348|0;wa=f[za>>2]|0;if(!wa){ua=$Xc(64)|0;$Za(ua);f[za>>2]=ua;Ga=ua}else Ga=wa;wa=f[c+348>>2]|0;ZZa(Ga,wa|0?wa:535072)}do if(S&4194304|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|4194304;wa=a+352|0;ua=f[wa>>2]|0;if(!ua){za=$Xc(28)|0;IZa(za);f[wa>>2]=za;Ha=za}else Ha=ua;ua=f[c+352>>2]|0;za=ua|0?ua:535136;ua=Ha+4|0;wa=f[za+4>>2]|0;if(wa&1|0){ya=f[ua>>2]|0;if(!(ya&1))Ia=lSa(ua)|0;else Ia=ya&-2;vqc(Ia,wa&-2)}wa=f[za+8>>2]|0;if(!(wa&7))break;if(wa&1|0)f[Ha+16>>2]=f[za+16>>2];if(wa&2|0)f[Ha+20>>2]=f[za+20>>2];if(wa&4|0)f[Ha+24>>2]=f[za+24>>2];za=Ha+8|0;f[za>>2]=f[za>>2]|wa}while(0);if(S&8388608|0){wa=a+12|0;f[wa>>2]=f[wa>>2]|8388608;wa=a+356|0;za=f[wa>>2]|0;if(!za){ya=$Xc(28)|0;q_a(ya);f[wa>>2]=ya;Ja=ya}else Ja=za;za=f[c+356>>2]|0;ya=za|0?za:535040;za=Ja+4|0;wa=f[ya+4>>2]|0;if(wa&1|0){ua=f[za>>2]|0;if(!(ua&1))Ka=lSa(za)|0;else Ka=ua&-2;vqc(Ka,wa&-2)}wa=f[ya+8>>2]|0;if(!(wa&7))break;if(wa&1|0)f[Ja+16>>2]=f[ya+16>>2];if(wa&2|0)f[Ja+20>>2]=f[ya+20>>2];if(wa&4|0)f[Ja+24>>2]=f[ya+24>>2];ya=Ja+8|0;f[ya>>2]=f[ya>>2]|wa}}while(0);if(!(S&16777216))return;S=f[c+360>>2]|0;c=a+12|0;f[c>>2]=f[c>>2]|16777216;f[a+360>>2]=S;return}function Wgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{nib(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(32)|0;mib(l);nib(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16688,32);l=RXb(i,32,2237)|0;mib(l);nib(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Xgb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=98428;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=531664?(f[223079]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=29;b[d+8>>0]=0;J_b(892316,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[a+40>>2]=-1;f[a+44>>2]=1;b[a+48>>0]=1;b[a+49>>0]=1;u=c;return}function Ygb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=$Xc(28)|0;Ffb(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;d=g|0?g:533176;g=i+4|0;h=f[d+4>>2]|0;if(h&1|0){j=f[g>>2]|0;if(!(j&1))k=lSa(g)|0;else k=j&-2;vqc(k,h&-2)}h=f[d+8>>2]|0;if(h&7|0){if(h&1|0)f[i+16>>2]=f[d+16>>2];if(h&2|0)f[i+20>>2]=f[d+20>>2];if(h&4|0)f[i+24>>2]=f[d+24>>2];d=i+8|0;f[d>>2]=f[d>>2]|h}}if(e&2|0){h=a+8|0;f[h>>2]=f[h>>2]|2;h=a+20|0;d=f[h>>2]|0;if(!d){i=$Xc(40)|0;nfb(i);f[h>>2]=i;l=i}else l=d;d=f[c+20>>2]|0;mfb(l,d|0?d:533208)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)b[a+32>>0]=b[c+32>>0]|0;if(e&32|0)f[a+36>>2]=f[c+36>>2];if(e&64|0)f[a+40>>2]=f[c+40>>2];if(e&128|0)f[a+44>>2]=f[c+44>>2];d=a+8|0;f[d>>2]=f[d>>2]|e}if(!(e&768))return;if(e&256|0)b[a+48>>0]=b[c+48>>0]|0;if(e&512|0)b[a+49>>0]=b[c+49>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Zgb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=98320;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=531472?(f[223076]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=26;b[d+8>>0]=0;J_b(892304,d);a_b(d)}f[a+12>>2]=0;u=c;return}function _gb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=98212;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=531504?(f[223077]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=27;b[d+8>>0]=0;J_b(892308,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;b[a+20>>0]=1;b[a+21>>0]=1;n[a+24>>2]=1.000000013351432e-10;u=c;return}function $gb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&15))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;$_a(i,g|0?g:531776)}if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;if(e&4|0)b[a+21>>0]=b[c+21>>0]|0;if(e&8|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function ahb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=98104;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==531536;g=a+16|0;h=g+72|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223078]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=28;b[d+8>>0]=0;J_b(892312,d);a_b(d)}f[a+12>>2]=0;d=a+88|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;b[a+120>>0]=1;b[a+121>>0]=1;n[a+124>>2]=.5;u=c;return}function bhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+28|0;e=c+28|0;g=f[e>>2]|0;if(g|0){uHa(h,(f[h>>2]|0)+g|0);o1c((f[a+36>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+36>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+40|0;h=c+40|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+48>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+52|0;e=c+52|0;g=f[e>>2]|0;if(g|0){uHa(h,(f[h>>2]|0)+g|0);o1c((f[a+60>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+60>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+64|0;h=c+64|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+72>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+72>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+76|0;e=c+76|0;g=f[e>>2]|0;if(g|0){uHa(h,(f[h>>2]|0)+g|0);o1c((f[a+84>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0)f[a+88>>2]=f[c+88>>2];if(e&2|0)f[a+92>>2]=f[c+92>>2];if(e&4|0)f[a+96>>2]=f[c+96>>2];if(e&8|0)f[a+100>>2]=f[c+100>>2];if(e&16|0)f[a+104>>2]=f[c+104>>2];if(e&32|0)f[a+108>>2]=f[c+108>>2];if(e&64|0)f[a+112>>2]=f[c+112>>2];if(e&128|0)f[a+116>>2]=f[c+116>>2];h=a+8|0;f[h>>2]=f[h>>2]|e}if(!(e&1792))return;if(e&256|0)b[a+120>>0]=b[c+120>>0]|0;if(e&512|0)b[a+121>>0]=b[c+121>>0]|0;if(e&1024|0)f[a+124>>2]=f[c+124>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function chb(a){a=a|0;var b=0,c=0;f[a>>2]=98104;b=f[a+84>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+72>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+60>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+48>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function dhb(a){a=a|0;chb(a);cYc(a);return}function ehb(a){a=a|0;a=$Xc(128)|0;ahb(a);return a|0}function fhb(a,b){a=a|0;b=b|0;a=$Xc(128)|0;ahb(a);if(!b)return a|0;rhb(b,a);return a|0}function ghb(a){a=a|0;var c=0,d=0,e=0;f[a+16>>2]=0;f[a+28>>2]=0;f[a+40>>2]=0;f[a+52>>2]=0;f[a+64>>2]=0;f[a+76>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){e=a+88|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0}if(d&1792|0){b[a+120>>0]=1;b[a+121>>0]=1;n[a+124>>2]=.5}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function hhb(a){a=a|0;return 1}function ihb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+92|0;l=a+16|0;m=a+20|0;n=a+24|0;o=a+120|0;p=e+8|0;q=a+121|0;r=e+8|0;s=a+28|0;t=a+32|0;v=a+36|0;w=a+96|0;x=a+100|0;y=a+104|0;z=a+108|0;A=a+112|0;B=a+116|0;C=a+124|0;D=a+40|0;E=a+44|0;F=a+48|0;G=a+52|0;H=a+56|0;I=a+60|0;K=a+64|0;L=a+68|0;M=a+72|0;N=a+76|0;O=a+80|0;P=a+84|0;Q=a+4|0;a:while(1){a=f[c>>2]|0;R=f[g>>2]|0;do if(a>>>0<R>>>0){S=b[a>>0]|0;T=S&255;U=a+1|0;if(S<<24>>24>0){V=U;W=T}else{if(U>>>0>=R>>>0){X=T;Y=7;break}S=h[U>>0]|0;if(((S^128)&T)>>>0<=127){X=T;Y=7;break}V=a+2|0;W=T+-128+(S<<7)|0}f[c>>2]=V;Z=W;Y=9}else{X=0;Y=7}while(0);if((Y|0)==7){Y=0;a=ZYb(c,X)|0;if((a+-1|0)>>>0<16383){Z=a;Y=9}else _=a}b:do if((Y|0)==9){Y=0;do switch(Z>>>3&536870911|0){case 1:{if((Z&255|0)!=13){_=Z;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){R=a;S=h[R>>0]|h[R+1>>0]<<8|h[R+2>>0]<<16|h[R+3>>0]<<24;f[e>>2]=S;f[c>>2]=a+4;$=S}else{if(!(WYb(c,e)|0)){Y=16;break a}$=f[e>>2]|0}f[j>>2]=$;continue a;break}case 2:{if((Z&255|0)!=21){_=Z;break b}f[i>>2]=f[i>>2]|2;S=f[c>>2]|0;if(((f[g>>2]|0)-S|0)>3){a=S;R=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=R;f[c>>2]=S+4;aa=R}else{if(!(WYb(c,e)|0)){Y=23;break a}aa=f[e>>2]|0}f[k>>2]=aa;continue a;break}case 3:{switch((Z&255)<<24>>24){case 29:break;case 26:{if(_Za(c,l)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}R=f[c>>2]|0;if(((f[g>>2]|0)-R|0)>3){S=R;a=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=a;f[c>>2]=R+4;ca=a}else{if(!(WYb(c,e)|0)){Y=39;break a}ca=f[e>>2]|0}a=f[l>>2]|0;if((a|0)==(f[m>>2]|0)){uHa(l,a+1|0);da=f[l>>2]|0}else da=a;a=f[n>>2]|0;R=da+1|0;f[l>>2]=R;f[a+4+(da<<2)>>2]=ca;S=f[c>>2]|0;T=(f[g>>2]|0)-S|0;if((T|0)<=0)continue a;U=S;S=(f[m>>2]|0)-R|0;ea=(T>>>0)/5|0;fa=(ea|0)<(S|0)?ea:S;if((fa|0)>0){ga=0;ha=U;ia=R}else continue a;while(1){if((b[ha>>0]|0)!=29){ja=ga;break}R=ha+1|0;S=h[R>>0]|h[R+1>>0]<<8|h[R+2>>0]<<16|h[R+3>>0]<<24;R=ia;ia=ia+1|0;f[l>>2]=ia;f[a+4+(R<<2)>>2]=S;S=ga+1|0;if((S|0)>=(fa|0)){ja=S;break}else{ga=S;ha=ha+5|0}}fa=ja*5|0;if((ja|0)<=0)continue a;if((T|0)<(fa|0)){SYb(c,fa,T)|0;continue a}else{f[c>>2]=U+fa;continue a}break}case 4:{if((Z&255|0)!=32){_=Z;break b}f[i>>2]=f[i>>2]|256;fa=f[c>>2]|0;if(fa>>>0<(f[g>>2]|0)>>>0?(a=b[fa>>0]|0,a<<24>>24>-1):0){f[c>>2]=fa+1;ka=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[p>>0]|0)){ba=0;Y=188;break a}else ka=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=ka&1;continue a;break}case 5:{if((Z&255|0)!=40){_=Z;break b}f[i>>2]=f[i>>2]|512;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(fa=b[a>>0]|0,fa<<24>>24>-1):0){f[c>>2]=a+1;la=fa<<24>>24!=0}else{LYb(e,c);fa=e;if(!(b[r>>0]|0)){ba=0;Y=188;break a}else la=(f[fa>>2]|0)!=0|(f[fa+4>>2]|0)!=0}b[q>>0]=la&1;continue a;break}case 6:{switch((Z&255)<<24>>24){case 53:break;case 50:{if(_Za(c,s)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}fa=f[c>>2]|0;if(((f[g>>2]|0)-fa|0)>3){a=fa;S=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=S;f[c>>2]=fa+4;ma=S}else{if(!(WYb(c,e)|0)){Y=68;break a}ma=f[e>>2]|0}S=f[s>>2]|0;if((S|0)==(f[t>>2]|0)){uHa(s,S+1|0);na=f[s>>2]|0}else na=S;S=f[v>>2]|0;fa=na+1|0;f[s>>2]=fa;f[S+4+(na<<2)>>2]=ma;a=f[c>>2]|0;R=(f[g>>2]|0)-a|0;if((R|0)<=0)continue a;ea=a;a=(f[t>>2]|0)-fa|0;oa=(R>>>0)/5|0;pa=(oa|0)<(a|0)?oa:a;if((pa|0)>0){qa=0;ra=ea;sa=fa}else continue a;while(1){if((b[ra>>0]|0)!=53){ta=qa;break}fa=ra+1|0;a=h[fa>>0]|h[fa+1>>0]<<8|h[fa+2>>0]<<16|h[fa+3>>0]<<24;fa=sa;sa=sa+1|0;f[s>>2]=sa;f[S+4+(fa<<2)>>2]=a;a=qa+1|0;if((a|0)>=(pa|0)){ta=a;break}else{qa=a;ra=ra+5|0}}pa=ta*5|0;if((ta|0)<=0)continue a;if((R|0)<(pa|0)){SYb(c,pa,R)|0;continue a}else{f[c>>2]=ea+pa;continue a}break}case 7:{if((Z&255|0)!=56){_=Z;break b}f[i>>2]=f[i>>2]|4;pa=f[c>>2]|0;if(pa>>>0<(f[g>>2]|0)>>>0){S=b[pa>>0]|0;U=S&255;if(S<<24>>24>-1){f[w>>2]=U;f[c>>2]=pa+1;continue a}else ua=U}else ua=0;U=KYb(c,ua)|0;pa=J;f[w>>2]=U;if((pa|0)>-1|(pa|0)==-1&U>>>0>4294967295)continue a;else{ba=0;Y=188;break a}break}case 8:{if((Z&255|0)!=64){_=Z;break b}f[i>>2]=f[i>>2]|8;U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0){pa=b[U>>0]|0;S=pa&255;if(pa<<24>>24>-1){f[x>>2]=S;f[c>>2]=U+1;continue a}else va=S}else va=0;S=KYb(c,va)|0;U=J;f[x>>2]=S;if((U|0)>-1|(U|0)==-1&S>>>0>4294967295)continue a;else{ba=0;Y=188;break a}break}case 9:{if((Z&255|0)!=72){_=Z;break b}f[i>>2]=f[i>>2]|16;S=f[c>>2]|0;if(S>>>0<(f[g>>2]|0)>>>0){U=b[S>>0]|0;pa=U&255;if(U<<24>>24>-1){f[y>>2]=pa;f[c>>2]=S+1;continue a}else wa=pa}else wa=0;pa=KYb(c,wa)|0;S=J;f[y>>2]=pa;if((S|0)>-1|(S|0)==-1&pa>>>0>4294967295)continue a;else{ba=0;Y=188;break a}break}case 10:{if((Z&255|0)!=85){_=Z;break b}f[i>>2]=f[i>>2]|32;pa=f[c>>2]|0;if(((f[g>>2]|0)-pa|0)>3){S=pa;U=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=U;f[c>>2]=pa+4;xa=U}else{if(!(WYb(c,e)|0)){Y=91;break a}xa=f[e>>2]|0}f[z>>2]=xa;continue a;break}case 11:{if((Z&255|0)!=93){_=Z;break b}f[i>>2]=f[i>>2]|64;U=f[c>>2]|0;if(((f[g>>2]|0)-U|0)>3){pa=U;S=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=S;f[c>>2]=U+4;ya=S}else{if(!(WYb(c,e)|0)){Y=98;break a}ya=f[e>>2]|0}f[A>>2]=ya;continue a;break}case 12:{if((Z&255|0)!=101){_=Z;break b}f[i>>2]=f[i>>2]|128;S=f[c>>2]|0;if(((f[g>>2]|0)-S|0)>3){U=S;pa=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;f[e>>2]=pa;f[c>>2]=S+4;za=pa}else{if(!(WYb(c,e)|0)){Y=105;break a}za=f[e>>2]|0}f[B>>2]=za;continue a;break}case 13:{if((Z&255|0)!=109){_=Z;break b}f[i>>2]=f[i>>2]|1024;pa=f[c>>2]|0;if(((f[g>>2]|0)-pa|0)>3){S=pa;U=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=U;f[c>>2]=pa+4;Aa=U}else{if(!(WYb(c,e)|0)){Y=112;break a}Aa=f[e>>2]|0}f[C>>2]=Aa;continue a;break}case 14:{switch((Z&255)<<24>>24){case 117:break;case 114:{if(_Za(c,D)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}U=f[c>>2]|0;if(((f[g>>2]|0)-U|0)>3){pa=U;S=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=S;f[c>>2]=U+4;Ba=S}else{if(!(WYb(c,e)|0)){Y=128;break a}Ba=f[e>>2]|0}S=f[D>>2]|0;if((S|0)==(f[E>>2]|0)){uHa(D,S+1|0);Ca=f[D>>2]|0}else Ca=S;S=f[F>>2]|0;U=Ca+1|0;f[D>>2]=U;f[S+4+(Ca<<2)>>2]=Ba;pa=f[c>>2]|0;T=(f[g>>2]|0)-pa|0;if((T|0)<=0)continue a;a=pa;pa=(f[E>>2]|0)-U|0;fa=(T>>>0)/5|0;oa=(fa|0)<(pa|0)?fa:pa;if((oa|0)>0){Da=0;Ea=a;Fa=U}else continue a;while(1){if((b[Ea>>0]|0)!=117){Ga=Da;break}U=Ea+1|0;pa=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=Fa;Fa=Fa+1|0;f[D>>2]=Fa;f[S+4+(U<<2)>>2]=pa;pa=Da+1|0;if((pa|0)>=(oa|0)){Ga=pa;break}else{Da=pa;Ea=Ea+5|0}}oa=Ga*5|0;if((Ga|0)<=0)continue a;if((T|0)<(oa|0)){SYb(c,oa,T)|0;continue a}else{f[c>>2]=a+oa;continue a}break}case 15:{switch((Z&255)<<24>>24){case 125:break;case 122:{if(_Za(c,G)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}oa=f[c>>2]|0;if(((f[g>>2]|0)-oa|0)>3){S=oa;ea=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[e>>2]=ea;f[c>>2]=oa+4;Ha=ea}else{if(!(WYb(c,e)|0)){Y=145;break a}Ha=f[e>>2]|0}ea=f[G>>2]|0;if((ea|0)==(f[H>>2]|0)){uHa(G,ea+1|0);Ia=f[G>>2]|0}else Ia=ea;ea=f[I>>2]|0;oa=Ia+1|0;f[G>>2]=oa;f[ea+4+(Ia<<2)>>2]=Ha;S=f[c>>2]|0;R=(f[g>>2]|0)-S|0;if((R|0)<=0)continue a;pa=S;S=(f[H>>2]|0)-oa|0;U=(R>>>0)/5|0;fa=(U|0)<(S|0)?U:S;if((fa|0)>0){Ja=0;Ka=pa;La=oa}else continue a;while(1){if((b[Ka>>0]|0)!=125){Ma=Ja;break}oa=Ka+1|0;S=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;oa=La;La=La+1|0;f[G>>2]=La;f[ea+4+(oa<<2)>>2]=S;S=Ja+1|0;if((S|0)>=(fa|0)){Ma=S;break}else{Ja=S;Ka=Ka+5|0}}fa=Ma*5|0;if((Ma|0)<=0)continue a;if((R|0)<(fa|0)){SYb(c,fa,R)|0;continue a}else{f[c>>2]=pa+fa;continue a}break}case 16:{switch((Z&255)<<24>>24){case -123:break;case -126:{if(_Za(c,K)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}fa=f[c>>2]|0;if(((f[g>>2]|0)-fa|0)>3){ea=fa;a=h[ea>>0]|h[ea+1>>0]<<8|h[ea+2>>0]<<16|h[ea+3>>0]<<24;f[e>>2]=a;f[c>>2]=fa+4;Na=a}else{if(!(WYb(c,e)|0)){Y=163;break a}Na=f[e>>2]|0}a=f[K>>2]|0;if((a|0)==(f[L>>2]|0)){uHa(K,a+1|0);Oa=f[K>>2]|0}else Oa=a;a=f[M>>2]|0;fa=Oa+1|0;f[K>>2]=fa;f[a+4+(Oa<<2)>>2]=Na;ea=f[c>>2]|0;T=(f[g>>2]|0)-ea|0;if((T|0)<=0)continue a;S=ea;ea=(f[L>>2]|0)-fa|0;oa=(T>>>0)/6|0;U=(oa|0)<(ea|0)?oa:ea;if((U|0)>0){Pa=0;Qa=S;Ra=fa}else continue a;while(1){if((b[Qa>>0]|0)!=-123){Sa=Pa;break}if((b[Qa+1>>0]|0)!=1){Sa=Pa;break}fa=Qa+2|0;ea=h[fa>>0]|h[fa+1>>0]<<8|h[fa+2>>0]<<16|h[fa+3>>0]<<24;fa=Ra;Ra=Ra+1|0;f[K>>2]=Ra;f[a+4+(fa<<2)>>2]=ea;ea=Pa+1|0;if((ea|0)>=(U|0)){Sa=ea;break}else{Pa=ea;Qa=Qa+6|0}}U=Sa*6|0;if((Sa|0)<=0)continue a;if((T|0)<(U|0)){SYb(c,U,T)|0;continue a}else{f[c>>2]=S+U;continue a}break}case 17:{switch((Z&255)<<24>>24){case -115:break;case -118:{if(_Za(c,N)|0)continue a;else{ba=0;Y=188;break a}break}default:{_=Z;break b}}U=f[c>>2]|0;if(((f[g>>2]|0)-U|0)>3){a=U;pa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=pa;f[c>>2]=U+4;Ta=pa}else{if(!(WYb(c,e)|0)){Y=181;break a}Ta=f[e>>2]|0}pa=f[N>>2]|0;if((pa|0)==(f[O>>2]|0)){uHa(N,pa+1|0);Ua=f[N>>2]|0}else Ua=pa;pa=f[P>>2]|0;U=Ua+1|0;f[N>>2]=U;f[pa+4+(Ua<<2)>>2]=Ta;a=f[c>>2]|0;R=(f[g>>2]|0)-a|0;if((R|0)<=0)continue a;ea=a;a=(f[O>>2]|0)-U|0;fa=(R>>>0)/6|0;oa=(fa|0)<(a|0)?fa:a;if((oa|0)>0){Va=0;Wa=ea;Xa=U}else continue a;while(1){if((b[Wa>>0]|0)!=-115){Ya=Va;break}if((b[Wa+1>>0]|0)!=1){Ya=Va;break}U=Wa+2|0;a=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=Xa;Xa=Xa+1|0;f[N>>2]=Xa;f[pa+4+(U<<2)>>2]=a;a=Va+1|0;if((a|0)>=(oa|0)){Ya=a;break}else{Va=a;Wa=Wa+6|0}}oa=Ya*6|0;if((Ya|0)<=0)continue a;if((R|0)<(oa|0)){SYb(c,oa,R)|0;continue a}else{f[c>>2]=ea+oa;continue a}break}default:{_=Z;break b}}while(0)}while(0);if(!_){ba=1;Y=188;break}oa=f[Q>>2]|0;if(!(oa&1))Za=lSa(Q)|0;else Za=oa&-2;if(!(Lqc(c,_,Za)|0)){ba=0;Y=188;break}}switch(Y|0){case 16:{ba=0;u=d;return ba|0}case 23:{ba=0;u=d;return ba|0}case 39:{ba=0;u=d;return ba|0}case 68:{ba=0;u=d;return ba|0}case 91:{ba=0;u=d;return ba|0}case 98:{ba=0;u=d;return ba|0}case 105:{ba=0;u=d;return ba|0}case 112:{ba=0;u=d;return ba|0}case 128:{ba=0;u=d;return ba|0}case 145:{ba=0;u=d;return ba|0}case 163:{ba=0;u=d;return ba|0}case 181:{ba=0;u=d;return ba|0}case 188:{u=d;return ba|0}}return 0}function jhb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+16>>2]|0;d=f[a+28>>2]|0;e=f[a+40>>2]|0;g=f[a+52>>2]|0;h=f[a+64>>2]|0;i=f[a+76>>2]|0;j=b+c+d+e+g+(i<<2)+(i+h<<1)+(d+b+e+g+h<<2)|0;h=f[a+8>>2]|0;if(!(h&255))k=j;else{g=h&1|0?j+5|0:j;j=h&2|0?g+5|0:g;if(!(h&4))l=j;else l=j+1+((((($(f[a+96>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(h&8))m=l;else m=l+1+((((($(f[a+100>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(h&16))n=m;else n=m+1+((((($(f[a+104>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=h&32|0?n+5|0:n;n=h&64|0?m+5|0:m;k=h&128|0?n+5|0:n}if(!(h&1792)){o=k;p=a+12|0;f[p>>2]=o;return o|0}n=h&256|0?k+2|0:k;k=h&512|0?n+2|0:n;o=h&1024|0?k+5|0:k;p=a+12|0;f[p>>2]=o;return o|0}function khb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&1|0)a$b(1,+n[a+88>>2],c);if(d&2|0)a$b(2,+n[a+92>>2],c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{a$b(3,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&256|0)c$b(4,(b[a+120>>0]|0)!=0,c);if(d&512|0)c$b(5,(b[a+121>>0]|0)!=0,c);e=f[a+28>>2]|0;if((e|0)>0){h=a+36|0;g=0;do{a$b(6,+n[(f[h>>2]|0)+4+(g<<2)>>2],c);g=g+1|0}while((g|0)!=(e|0))}if(d&4|0)U_b(7,f[a+96>>2]|0,c);if(d&8|0)U_b(8,f[a+100>>2]|0,c);if(d&16|0)U_b(9,f[a+104>>2]|0,c);if(d&32|0)a$b(10,+n[a+108>>2],c);if(d&64|0)a$b(11,+n[a+112>>2],c);if(d&128|0)a$b(12,+n[a+116>>2],c);if(d&1024|0)a$b(13,+n[a+124>>2],c);d=f[a+40>>2]|0;if((d|0)>0){e=a+48|0;g=0;do{a$b(14,+n[(f[e>>2]|0)+4+(g<<2)>>2],c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+52>>2]|0;if((d|0)>0){g=a+60|0;e=0;do{a$b(15,+n[(f[g>>2]|0)+4+(e<<2)>>2],c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+64>>2]|0;if((d|0)>0){e=a+72|0;g=0;do{a$b(16,+n[(f[e>>2]|0)+4+(g<<2)>>2],c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+76>>2]|0;if((d|0)>0){g=a+84|0;e=0;do{a$b(17,+n[(f[g>>2]|0)+4+(e<<2)>>2],c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function lhb(a){a=a|0;return f[a+12>>2]|0}function mhb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+88>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{d=f[a+92>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}e=f[a+16>>2]|0;if(!e)j=i;else{d=f[a+24>>2]|0;g=0;h=i;while(1){i=f[d+4+(g<<2)>>2]|0;b[h>>0]=29;k=h+1|0;b[k>>0]=i;b[k+1>>0]=i>>8;b[k+2>>0]=i>>16;b[k+3>>0]=i>>24;i=h+5|0;g=g+1|0;if((g|0)>=(e|0)){j=i;break}else h=i}}if(!(c&256))l=j;else{h=b[a+120>>0]|0;b[j>>0]=32;b[j+1>>0]=h;l=j+2|0}if(!(c&512))m=l;else{j=b[a+121>>0]|0;b[l>>0]=40;b[l+1>>0]=j;m=l+2|0}l=f[a+28>>2]|0;if(!l)n=m;else{j=f[a+36>>2]|0;h=0;e=m;while(1){m=f[j+4+(h<<2)>>2]|0;b[e>>0]=53;g=e+1|0;b[g>>0]=m;b[g+1>>0]=m>>8;b[g+2>>0]=m>>16;b[g+3>>0]=m>>24;m=e+5|0;h=h+1|0;if((h|0)>=(l|0)){n=m;break}else e=m}}if(!(c&4))o=n;else{e=f[a+96>>2]|0;b[n>>0]=56;l=n+1|0;if(e>>>0>127){n=e;h=l;while(1){b[h>>0]=n|128;j=n>>>7;m=h+1|0;if(n>>>0>16383){n=j;h=m}else{p=m;q=j;break}}}else{p=l;q=e}b[p>>0]=q;o=p+1|0}if(!(c&8))r=o;else{p=f[a+100>>2]|0;b[o>>0]=64;q=o+1|0;if(p>>>0>127){o=p;e=q;while(1){b[e>>0]=o|128;l=o>>>7;h=e+1|0;if(o>>>0>16383){o=l;e=h}else{s=h;t=l;break}}}else{s=q;t=p}b[s>>0]=t;r=s+1|0}if(!(c&16))u=r;else{s=f[a+104>>2]|0;b[r>>0]=72;t=r+1|0;if(s>>>0>127){r=s;p=t;while(1){b[p>>0]=r|128;q=r>>>7;e=p+1|0;if(r>>>0>16383){r=q;p=e}else{v=e;w=q;break}}}else{v=t;w=s}b[v>>0]=w;u=v+1|0}if(!(c&32))x=u;else{v=f[a+108>>2]|0;b[u>>0]=85;w=u+1|0;b[w>>0]=v;b[w+1>>0]=v>>8;b[w+2>>0]=v>>16;b[w+3>>0]=v>>24;x=u+5|0}if(!(c&64))y=x;else{u=f[a+112>>2]|0;b[x>>0]=93;v=x+1|0;b[v>>0]=u;b[v+1>>0]=u>>8;b[v+2>>0]=u>>16;b[v+3>>0]=u>>24;y=x+5|0}if(!(c&128))z=y;else{x=f[a+116>>2]|0;b[y>>0]=101;u=y+1|0;b[u>>0]=x;b[u+1>>0]=x>>8;b[u+2>>0]=x>>16;b[u+3>>0]=x>>24;z=y+5|0}if(!(c&1024))A=z;else{c=f[a+124>>2]|0;b[z>>0]=109;y=z+1|0;b[y>>0]=c;b[y+1>>0]=c>>8;b[y+2>>0]=c>>16;b[y+3>>0]=c>>24;A=z+5|0}z=f[a+40>>2]|0;if(!z)B=A;else{c=f[a+48>>2]|0;y=0;x=A;while(1){A=f[c+4+(y<<2)>>2]|0;b[x>>0]=117;u=x+1|0;b[u>>0]=A;b[u+1>>0]=A>>8;b[u+2>>0]=A>>16;b[u+3>>0]=A>>24;A=x+5|0;y=y+1|0;if((y|0)>=(z|0)){B=A;break}else x=A}}x=f[a+52>>2]|0;if(!x)C=B;else{z=f[a+60>>2]|0;y=0;c=B;while(1){B=f[z+4+(y<<2)>>2]|0;b[c>>0]=125;A=c+1|0;b[A>>0]=B;b[A+1>>0]=B>>8;b[A+2>>0]=B>>16;b[A+3>>0]=B>>24;B=c+5|0;y=y+1|0;if((y|0)>=(x|0)){C=B;break}else c=B}}c=f[a+64>>2]|0;if(!c)D=C;else{x=f[a+72>>2]|0;y=0;z=C;while(1){C=f[x+4+(y<<2)>>2]|0;b[z>>0]=-123;b[z+1>>0]=1;B=z+2|0;b[B>>0]=C;b[B+1>>0]=C>>8;b[B+2>>0]=C>>16;b[B+3>>0]=C>>24;C=z+6|0;y=y+1|0;if((y|0)>=(c|0)){D=C;break}else z=C}}z=f[a+76>>2]|0;if(!z)E=D;else{c=f[a+84>>2]|0;y=0;x=D;while(1){D=f[c+4+(y<<2)>>2]|0;b[x>>0]=-115;b[x+1>>0]=1;C=x+2|0;b[C>>0]=D;b[C+1>>0]=D>>8;b[C+2>>0]=D>>16;b[C+3>>0]=D>>24;D=x+6|0;y=y+1|0;if((y|0)>=(z|0)){E=D;break}else x=D}}x=f[a+4>>2]|0;if(!(x&1)){F=E;return F|0}F=Pqc(x&-2,E)|0;return F|0}function nhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;f[a+16>>2]=0;f[a+28>>2]=0;f[a+40>>2]=0;f[a+52>>2]=0;f[a+64>>2]=0;f[a+76>>2]=0;d=a+8|0;e=f[d>>2]|0;if(e&255|0){g=a+88|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0}if(e&1792|0){b[a+120>>0]=1;b[a+121>>0]=1;n[a+124>>2]=.5}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16624,0)|0;if(!e){Ooc(c,a);return}else{bhb(a,e);return}}function ohb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16624,0)|0;if(!c){Ooc(b,a);return}else{bhb(a,c);return}}function phb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function qhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535288;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function rhb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function shb(a){a=a|0;var b=0,c=0;f[a>>2]=98212;if((a|0)!=531504?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function thb(a){a=a|0;var b=0,c=0;f[a>>2]=98212;if((a|0)!=531504?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function uhb(a){a=a|0;a=$Xc(28)|0;_gb(a);return a|0}function vhb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;_gb(a);if(!b)return a|0;Hhb(b,a);return a|0}function whb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&15|0){if(d&1|0){d=f[a+16>>2]|0;e=d+8|0;g=f[e>>2]|0;if(g&1|0)oYc(f[d+16>>2]|0,535168)|0;if(g&254|0){g=d+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[d+36>>2]=-1;n[d+40>>2]=1.0;n[d+44>>2]=1.0}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d)}b[a+20>>0]=1;b[a+21>>0]=1;n[a+24>>2]=1.000000013351432e-10}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function xhb(a){a=a|0;return 1}function yhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=e+8|0;l=a+16|0;m=e+4|0;n=a+21|0;o=e+8|0;p=a+24|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=ZYb(c,w)|0;if((s+-1|0)>>>0<127){t=s;v=6}else x=s}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{if((t&255|0)!=8){x=t;break b}f[i>>2]=f[i>>2]|2;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(a=b[s>>0]|0,a<<24>>24>-1):0){f[c>>2]=s+1;y=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[k>>0]|0)){z=0;v=42;break a}else y=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[j>>0]=y&1;continue a;break}case 2:{if((t&255|0)!=18){x=t;break b}f[i>>2]=f[i>>2]|1;a=f[l>>2]|0;if(!a){s=$Xc(48)|0;__a(s);f[l>>2]=s;A=s}else A=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(s=b[a>>0]|0,s<<24>>24>-1):0){f[c>>2]=a+1;B=s&255}else{s=YYb(c)|0;if((s|0)>-1)B=s;else{z=0;v=42;break a}}JYb(e,c,B);if((f[m>>2]|0)<0){v=22;break a}if(!(Mi[f[(f[A>>2]|0)+44>>2]&1023](A,c)|0)){v=22;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{z=0;v=42;break a}break}case 3:{if((t&255|0)!=24){x=t;break b}f[i>>2]=f[i>>2]|4;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(a=b[s>>0]|0,a<<24>>24>-1):0){f[c>>2]=s+1;C=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[o>>0]|0)){z=0;v=42;break a}else C=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[n>>0]=C&1;continue a;break}case 4:{if((t&255|0)!=37){x=t;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){s=a;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;f[c>>2]=a+4;D=r}else{if(!(WYb(c,e)|0)){v=36;break a}D=f[e>>2]|0}f[p>>2]=D;continue a;break}default:{x=t;break b}}}while(0);if(!x){z=1;v=42;break}r=f[q>>2]|0;if(!(r&1))E=lSa(q)|0;else E=r&-2;if(!(Lqc(c,x,E)|0)){z=0;v=42;break}}if((v|0)==22){z=0;u=d;return z|0}else if((v|0)==36){z=0;u=d;return z|0}else if((v|0)==42){u=d;return z|0}return 0}function zhb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&15)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}b=i&2|0?h+2|0:h;h=i&4|0?b+2|0:b;e=i&8|0?h+5|0:h;g=a+12|0;f[g>>2]=e;return e|0}function Ahb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&2|0)c$b(1,(b[a+20>>0]|0)!=0,c);if(d&1|0)k$b(2,f[a+16>>2]|0,c);if(d&4|0)c$b(3,(b[a+21>>0]|0)!=0,c);if(d&8|0)a$b(4,+n[a+24>>2],c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function Bhb(a){a=a|0;return f[a+12>>2]|0}function Chb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=b[a+20>>0]|0;b[d>>0]=8;b[d+1>>0]=h;g=d+2|0}if(!(e&1))i=g;else{d=f[a+16>>2]|0;b[g>>0]=18;h=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(g>>>0>127){j=g;k=h;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=h;o=g}b[n>>0]=o;i=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,n+1|0)|0}if(!(e&4))p=i;else{n=b[a+21>>0]|0;b[i>>0]=24;b[i+1>>0]=n;p=i+2|0}if(!(e&8))q=p;else{e=f[a+24>>2]|0;b[p>>0]=37;i=p+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;q=p+5|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Pqc(p&-2,q)|0;return r|0}function Dhb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;whb(a);c=kZc(b,21568,16640,0)|0;if(!c){Ooc(b,a);return}else{$gb(a,c);return}}function Ehb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16640,0)|0;if(!c){Ooc(b,a);return}else{$gb(a,c);return}}function Fhb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Ghb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535280;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Hhb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Ihb(a){a=a|0;var b=0,c=0;f[a>>2]=98320;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Jhb(a){a=a|0;var b=0,c=0;f[a>>2]=98320;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Khb(a){a=a|0;a=$Xc(28)|0;Zgb(a);return a|0}function Lhb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;Zgb(a);if(!b)return a|0;Xhb(b,a);return a|0}function Mhb(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Nhb(a){a=a|0;return 1}function Ohb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=c+4|0;e=a+16|0;g=a+20|0;h=a+24|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;if((l&-8|0)==8){switch((l&255)<<24>>24){case 8:break;case 10:{if(h4a(c,e)|0)continue a;else{p=0;m=29;break a}break}default:{o=l;break b}}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;q=j}else{r=j;m=11}}else{r=0;m=11}if((m|0)==11){m=0;j=KYb(c,r)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)q=j;else{p=0;m=29;break a}}j=f[e>>2]|0;if((j|0)==(f[g>>2]|0)){xHa(e,j+1|0);s=f[e>>2]|0}else s=j;j=f[h>>2]|0;f[e>>2]=s+1;f[j+4+(s<<2)>>2]=q;k=(f[g>>2]|0)-(f[e>>2]|0)|0;if((k|0)>0){t=k;u=j}else continue a;while(1){j=f[c>>2]|0;k=f[d>>2]|0;if(j>>>0>=k>>>0)continue a;if((b[j>>0]|0)!=8)continue a;a=j+1|0;f[c>>2]=a;if(a>>>0<k>>>0){k=b[a>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+2;v=a;w=u}else{x=a;m=19}}else{x=0;m=19}if((m|0)==19){m=0;a=KYb(c,x)|0;j=J;if(!((j|0)>-1|(j|0)==-1&a>>>0>4294967295)){p=0;m=29;break a}v=a;w=f[h>>2]|0}a=f[e>>2]|0;f[e>>2]=a+1;f[w+4+(a<<2)>>2]=v;if((t|0)>1){t=t+-1|0;u=w}else continue a}}else o=l}while(0);if(!o){p=1;m=29;break}a=f[i>>2]|0;if(!(a&1))y=lSa(i)|0;else y=a&-2;if(!(Lqc(c,o,y)|0)){p=0;m=29;break}}if((m|0)==29)return p|0;return 0}function Phb(a){a=a|0;var b=0,c=0,d=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=o$b(a+16|0)|0;d=b+c+(f[a+16>>2]|0)|0;f[a+12>>2]=d;return d|0}function Qhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+16>>2]|0;if((c|0)>0){d=a+24|0;e=0;do{U_b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Rhb(a){a=a|0;return f[a+12>>2]|0}function Shb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+16>>2]|0;if(!c)e=d;else{g=f[a+24>>2]|0;h=0;i=d;while(1){d=f[g+4+(h<<2)>>2]|0;b[i>>0]=8;j=i+1|0;if(d>>>0>127){k=d;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=d}b[o>>0]=p;l=o+1|0;h=h+1|0;if((h|0)>=(c|0)){e=l;break}else i=l}}i=f[a+4>>2]|0;if(!(i&1)){q=e;return q|0}q=Pqc(i&-2,e)|0;return q|0}function Thb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;f[a+16>>2]=0;f[a+8>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Uhb(a,b);return}function Uhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16656,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=c+16|0;e=f[g>>2]|0;if(!e)return;xHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);return}function Vhb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Whb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535272;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Xhb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Yhb(a){a=a|0;var b=0,c=0;f[a>>2]=98428;if((a|0)!=531664){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Zhb(a){a=a|0;var b=0,c=0;f[a>>2]=98428;if((a|0)!=531664){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function _hb(a){a=a|0;a=$Xc(52)|0;Xgb(a);return a|0}function $hb(a,b){a=a|0;b=b|0;a=$Xc(52)|0;Xgb(a);if(!b)return a|0;lib(b,a);return a|0}function aib(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;g=e+8|0;if(f[g>>2]&7|0){f[e+16>>2]=0;n[e+20>>2]=.30000001192092896;n[e+24>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}if(d&2|0)bfb(f[a+20>>2]|0)}if(d&252|0){e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[a+40>>2]=-1;f[a+44>>2]=1}if(d&768|0){b[a+48>>0]=1;b[a+49>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function bib(a){a=a|0;return 1}function cib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+24|0;k=a+48|0;l=e+8|0;m=a+28|0;n=a+16|0;o=e+4|0;p=a+20|0;q=e+4|0;r=a+44|0;s=a+4|0;t=a+40|0;v=a+32|0;w=e+8|0;x=a+36|0;y=a+49|0;a=e+8|0;a:while(1){z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=z+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=ZYb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;do switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=8){F=C;break b}f[i>>2]=f[i>>2]|4;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0){z=b[B>>0]|0;A=z&255;if(z<<24>>24>-1){f[j>>2]=A;f[c>>2]=B+1;continue a}else G=A}else G=0;A=KYb(c,G)|0;B=J;f[j>>2]=A;if((B|0)>-1|(B|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=87;break a}break}case 2:{if((C&255|0)!=16){F=C;break b}f[i>>2]=f[i>>2]|256;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){f[c>>2]=A+1;I=B<<24>>24!=0}else{LYb(e,c);B=e;if(!(b[l>>0]|0)){H=0;D=87;break a}else I=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0}b[k>>0]=I&1;continue a;break}case 3:{if((C&255|0)!=24){F=C;break b}f[i>>2]=f[i>>2]|8;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0){A=b[B>>0]|0;z=A&255;if(A<<24>>24>-1){f[c>>2]=B+1;K=z}else{L=z;D=22}}else{L=0;D=22}if((D|0)==22){D=0;z=KYb(c,L)|0;B=J;if((B|0)>-1|(B|0)==-1&z>>>0>4294967295)K=z;else{H=0;D=87;break a}}f[m>>2]=K;continue a;break}case 4:{if((C&255|0)!=34){F=C;break b}f[i>>2]=f[i>>2]|1;z=f[n>>2]|0;if(!z){B=$Xc(28)|0;Ffb(B);f[n>>2]=B;M=B}else M=z;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(B=b[z>>0]|0,B<<24>>24>-1):0){f[c>>2]=z+1;N=B&255}else{B=YYb(c)|0;if((B|0)>-1)N=B;else{H=0;D=87;break a}}JYb(e,c,N);if((f[o>>2]|0)<0){D=33;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){D=33;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{H=0;D=87;break a}break}case 5:{if((C&255|0)!=42){F=C;break b}f[i>>2]=f[i>>2]|2;B=f[p>>2]|0;if(!B){z=$Xc(40)|0;nfb(z);f[p>>2]=z;O=z}else O=B;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(z=b[B>>0]|0,z<<24>>24>-1):0){f[c>>2]=B+1;P=z&255}else{z=YYb(c)|0;if((z|0)>-1)P=z;else{H=0;D=87;break a}}JYb(e,c,P);if((f[q>>2]|0)<0){D=44;break a}if(!(Mi[f[(f[O>>2]|0)+44>>2]&1023](O,c)|0)){D=44;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{H=0;D=87;break a}break}case 6:{if((C&255|0)!=48){F=C;break b}z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){B=b[z>>0]|0;A=B&255;if(B<<24>>24>-1){f[c>>2]=z+1;Q=A}else{R=A;D=50}}else{R=0;D=50}if((D|0)==50){D=0;A=KYb(c,R)|0;z=J;if((z|0)>-1|(z|0)==-1&A>>>0>4294967295)Q=A;else{H=0;D=87;break a}}if((Q+-1|0)>>>0<2){f[i>>2]=f[i>>2]|128;f[r>>2]=Q;continue a}A=f[s>>2]|0;if(!(A&1))S=lSa(s)|0;else S=A&-2;yqc(S,6,Q,((Q|0)<0)<<31>>31);continue a;break}case 7:{if((C&255|0)!=56){F=C;break b}f[i>>2]=f[i>>2]|64;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){z=b[A>>0]|0;B=z&255;if(z<<24>>24>-1){f[c>>2]=A+1;T=B}else{U=B;D=61}}else{U=0;D=61}if((D|0)==61){D=0;B=KYb(c,U)|0;A=J;if((A|0)>-1|(A|0)==-1&B>>>0>4294967295)T=B;else{H=0;D=87;break a}}f[t>>2]=T;continue a;break}case 8:{if((C&255|0)!=64){F=C;break b}f[i>>2]=f[i>>2]|16;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(A=b[B>>0]|0,A<<24>>24>-1):0){f[c>>2]=B+1;V=A<<24>>24!=0}else{LYb(e,c);A=e;if(!(b[w>>0]|0)){H=0;D=87;break a}else V=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0}b[v>>0]=V&1;continue a;break}case 9:{if((C&255|0)!=77){F=C;break b}f[i>>2]=f[i>>2]|32;A=f[c>>2]|0;if(((f[g>>2]|0)-A|0)>3){B=A;z=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=z;f[c>>2]=A+4;W=z}else{if(!(WYb(c,e)|0)){D=75;break a}W=f[e>>2]|0}f[x>>2]=W;continue a;break}case 10:{if((C&255|0)!=80){F=C;break b}f[i>>2]=f[i>>2]|512;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(A=b[z>>0]|0,A<<24>>24>-1):0){f[c>>2]=z+1;X=A<<24>>24!=0}else{LYb(e,c);A=e;if(!(b[a>>0]|0)){H=0;D=87;break a}else X=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0}b[y>>0]=X&1;continue a;break}default:{F=C;break b}}while(0)}while(0);if(!F){H=1;D=87;break}A=f[s>>2]|0;if(!(A&1))Y=lSa(s)|0;else Y=A&-2;if(!(Lqc(c,F,Y)|0)){H=0;D=87;break}}if((D|0)==33){H=0;u=d;return H|0}else if((D|0)==44){H=0;u=d;return H|0}else if((D|0)==75){H=0;u=d;return H|0}else if((D|0)==87){u=d;return H|0}return 0}function dib(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(d&255){if(!(d&1)){e=c;g=d}else{h=f[a+16>>2]|0;i=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;h=c+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=h;g=f[b>>2]|0}if(!(g&2)){j=e;k=g}else{g=f[a+20>>2]|0;h=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;g=e+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=g;k=f[b>>2]|0}if(!(k&4))l=j;else l=j+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(k&8))m=l;else{j=f[a+28>>2]|0;if((j|0)<0)n=11;else n=((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=n+l|0}l=k&16|0?m+2|0:m;m=k&32|0?l+5|0:l;if(!(k&64))o=m;else{l=f[a+40>>2]|0;if((l|0)<0)p=11;else p=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;o=p+m|0}if(!(k&128)){q=o;r=k}else{m=f[a+44>>2]|0;if((m|0)<0)s=11;else s=((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;q=s+o|0;r=k}}else{q=c;r=d}if(!(r&768)){t=q;u=a+12|0;f[u>>2]=t;return t|0}d=r&256|0?q+2|0:q;t=r&512|0?d+2|0:d;u=a+12|0;f[u>>2]=t;return t|0}function eib(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)U_b(1,f[a+24>>2]|0,c);if(d&256|0)c$b(2,(b[a+48>>0]|0)!=0,c);if(d&8|0)S_b(3,f[a+28>>2]|0,c);if(d&1|0)k$b(4,f[a+16>>2]|0,c);if(d&2|0)k$b(5,f[a+20>>2]|0,c);if(d&128|0)d$b(6,f[a+44>>2]|0,c);if(d&64|0)S_b(7,f[a+40>>2]|0,c);if(d&16|0)c$b(8,(b[a+32>>0]|0)!=0,c);if(d&32|0)a$b(9,+n[a+36>>2],c);if(d&512|0)c$b(10,(b[a+49>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function fib(a){a=a|0;return f[a+12>>2]|0}function gib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&256))o=g;else{m=b[a+48>>0]|0;b[g>>0]=16;b[g+1>>0]=m;o=g+2|0}if(!(e&8))p=o;else{g=f[a+28>>2]|0;b[o>>0]=24;m=o+1|0;o=g&255;if(g>>>0>127){n=m;h=o;i=g;j=((g|0)<0)<<31>>31;while(1){b[n>>0]=h|-128;g=i;i=l1c(i|0,j|0,7)|0;d=n+1|0;k=i&255;if(!(j>>>0>0|(j|0)==0&g>>>0>16383)){q=d;r=k;break}else{n=d;h=k;j=J}}}else{q=m;r=o}b[q>>0]=r;p=q+1|0}if(!(e&1))s=p;else{q=f[a+16>>2]|0;b[p>>0]=34;r=p+1|0;p=_i[f[(f[q>>2]|0)+60>>2]&2047](q)|0;if(p>>>0>127){o=p;m=r;while(1){b[m>>0]=o|128;j=o>>>7;h=m+1|0;if(o>>>0>16383){o=j;m=h}else{t=h;u=j;break}}}else{t=r;u=p}b[t>>0]=u;s=hj[f[(f[q>>2]|0)+64>>2]&511](q,c,t+1|0)|0}if(!(e&2))v=s;else{t=f[a+20>>2]|0;b[s>>0]=42;q=s+1|0;s=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(s>>>0>127){u=s;p=q;while(1){b[p>>0]=u|128;r=u>>>7;m=p+1|0;if(u>>>0>16383){u=r;p=m}else{w=m;x=r;break}}}else{w=q;x=s}b[w>>0]=x;v=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,w+1|0)|0}if(!(e&128))y=v;else{w=f[a+44>>2]|0;b[v>>0]=48;c=v+1|0;v=w&255;if(w>>>0>127){t=c;x=w;s=((w|0)<0)<<31>>31;w=v;while(1){b[t>>0]=w|-128;q=x;x=l1c(x|0,s|0,7)|0;p=t+1|0;u=x&255;if(!(s>>>0>0|(s|0)==0&q>>>0>16383)){z=p;A=u;break}else{t=p;s=J;w=u}}}else{z=c;A=v}b[z>>0]=A;y=z+1|0}if(!(e&64))B=y;else{z=f[a+40>>2]|0;b[y>>0]=56;A=y+1|0;y=z&255;if(z>>>0>127){v=A;c=y;w=z;s=((z|0)<0)<<31>>31;while(1){b[v>>0]=c|-128;z=w;w=l1c(w|0,s|0,7)|0;t=v+1|0;x=w&255;if(!(s>>>0>0|(s|0)==0&z>>>0>16383)){C=t;D=x;break}else{v=t;c=x;s=J}}}else{C=A;D=y}b[C>>0]=D;B=C+1|0}if(!(e&16))E=B;else{C=b[a+32>>0]|0;b[B>>0]=64;b[B+1>>0]=C;E=B+2|0}if(!(e&32))F=E;else{B=f[a+36>>2]|0;b[E>>0]=77;C=E+1|0;b[C>>0]=B;b[C+1>>0]=B>>8;b[C+2>>0]=B>>16;b[C+3>>0]=B>>24;F=E+5|0}if(!(e&512))G=F;else{e=b[a+49>>0]|0;b[F>>0]=80;b[F+1>>0]=e;G=F+2|0}F=f[a+4>>2]|0;if(!(F&1)){H=G;return H|0}H=Pqc(F&-2,G)|0;return H|0}function hib(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;aib(a);c=kZc(b,21568,16672,0)|0;if(!c){Ooc(b,a);return}else{Ygb(a,c);return}}function iib(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16672,0)|0;if(!c){Ooc(b,a);return}else{Ygb(a,c);return}}function jib(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function kib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535296;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function lib(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function mib(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=98536;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532312?(f[223087]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=37;b[d+8>>0]=0;J_b(892348,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=0;n[a+24>>2]=1.0;n[a+28>>2]=1.0;u=c;return}function nib(a,b){a=a|0;b=b|0;oib(b,a);return}function oib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&15))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];if(d&8|0)f[a+28>>2]=f[b+28>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function pib(a){a=a|0;var c=0,d=0;f[a>>2]=98536;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function qib(a){a=a|0;pib(a);cYc(a);return}function rib(a){a=a|0;a=$Xc(32)|0;mib(a);return a|0}function sib(a,b){a=a|0;b=b|0;a=$Xc(32)|0;mib(a);if(!b)return a|0;Eib(b,a);return a|0}function tib(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&14|0){f[a+20>>2]=0;n[a+24>>2]=1.0;n[a+28>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function uib(a){a=a|0;return 1}function vib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+24|0;l=a+28|0;m=a+4|0;n=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=7}else{s=p;r=6}}else{s=0;r=6}if((r|0)==6){r=0;p=ZYb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=7}else t=p}c:do if((r|0)==7){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=10){t=q;break c}f[i>>2]=f[i>>2]|1;p=f[j>>2]|0;if((p|0)==537368){mHa(j,537368);v=f[j>>2]|0}else v=p;if(l$b(c,v)|0)continue b;else{w=0;r=42;break a}break}case 2:{if((q&255|0)==16)break b;else{t=q;break c}break}case 3:{if((q&255|0)!=29){t=q;break c}f[i>>2]=f[i>>2]|4;p=f[c>>2]|0;if(((f[g>>2]|0)-p|0)>3){a=p;o=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=o;f[c>>2]=p+4;x=o}else{if(!(WYb(c,e)|0)){r=29;break a}x=f[e>>2]|0}f[k>>2]=x;continue b;break}case 4:{if((q&255|0)!=37){t=q;break c}f[i>>2]=f[i>>2]|8;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){p=o;a=h[p>>0]|h[p+1>>0]<<8|h[p+2>>0]<<16|h[p+3>>0]<<24;f[e>>2]=a;f[c>>2]=o+4;y=a}else{if(!(WYb(c,e)|0)){r=36;break a}y=f[e>>2]|0}f[l>>2]=y;continue b;break}default:{t=q;break c}}}while(0);if(!t){w=1;r=42;break a}a=f[m>>2]|0;if(!(a&1))z=lSa(m)|0;else z=a&-2;if(!(Lqc(c,t,z)|0)){w=0;r=42;break a}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>-1){f[c>>2]=a+1;A=p}else{B=p;r=16}}else{B=0;r=16}if((r|0)==16){r=0;p=KYb(c,B)|0;a=J;if((a|0)>-1|(a|0)==-1&p>>>0>4294967295)A=p;else{w=0;r=42;break}}if(A>>>0<2){f[i>>2]=f[i>>2]|2;f[n>>2]=A;continue}p=f[m>>2]|0;if(!(p&1))C=lSa(m)|0;else C=p&-2;yqc(C,2,A,((A|0)<0)<<31>>31)}if((r|0)==29){w=0;u=d;return w|0}else if((r|0)==36){w=0;u=d;return w|0}else if((r|0)==42){u=d;return w|0}return 0}function wib(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&15)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;if((k|0)<0)m=11;else m=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+h|0}h=c&4|0?l+5|0:l;e=c&8|0?h+5|0:h;g=a+12|0;f[g>>2]=e;return e|0}function xib(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&2|0)d$b(2,f[a+20>>2]|0,b);if(c&4|0)a$b(3,+n[a+24>>2],b);if(c&8|0)a$b(4,+n[a+28>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function yib(a){a=a|0;return f[a+12>>2]|0}function zib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=16;g=e+1|0;e=d&255;if(d>>>0>127){i=g;j=e;k=d;l=((d|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;d=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&d>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=g;p=e}b[o>>0]=p;h=o+1|0}if(!(c&4))q=h;else{o=f[a+24>>2]|0;b[h>>0]=29;p=h+1|0;b[p>>0]=o;b[p+1>>0]=o>>8;b[p+2>>0]=o>>16;b[p+3>>0]=o>>24;q=h+5|0}if(!(c&8))r=q;else{c=f[a+28>>2]|0;b[q>>0]=37;h=q+1|0;b[h>>0]=c;b[h+1>>0]=c>>8;b[h+2>>0]=c>>16;b[h+3>>0]=c>>24;r=q+5|0}q=f[a+4>>2]|0;if(!(q&1)){s=r;return s|0}s=Pqc(q&-2,r)|0;return s|0}function Aib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;d=a+8|0;e=f[d>>2]|0;do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&14|0){f[a+20>>2]=0;n[a+24>>2]=1.0;n[a+28>>2]=1.0}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16688,0)|0;if(!e){Ooc(c,a);return}else{oib(a,e);return}}function Bib(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16688,0)|0;if(!c){Ooc(b,a);return}else{oib(a,c);return}}function Cib(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Dib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535360;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Eib(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Fib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;if(g>>>0<(f[h>>2]|0)>>>0?(i=b[g>>0]|0,i<<24>>24>-1):0){f[a>>2]=g+1;j=i&255}else{i=YYb(a)|0;if((i|0)>-1)j=i;else{k=0;u=d;return k|0}}i=HYb(a,j)|0;a:do if((PYb(a)|0)>0){j=c+4|0;g=c+8|0;l=e+8|0;while(1){m=f[a>>2]|0;if(m>>>0<(f[h>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[a>>2]=m+1;o=n<<24>>24!=0}else{LYb(e,a);n=e;if(!(b[l>>0]|0)){k=0;break}else o=(f[n>>2]|0)!=0|(f[n+4>>2]|0)!=0}n=f[c>>2]|0;if((n|0)==(f[j>>2]|0)){wSa(c,n+1|0);p=f[c>>2]|0}else p=n;n=f[g>>2]|0;f[c>>2]=p+1;b[n+4+p>>0]=o&1;if((PYb(a)|0)<=0)break a}u=d;return k|0}while(0);IYb(a,i);k=1;u=d;return k|0}function Gib(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97996;g1c(a+4|0,0,132)|0;if((a|0)!=532344?(f[223088]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=38;b[d+8>>0]=0;J_b(892352,d);a_b(d)}f[a+136>>2]=537368;f[a+140>>2]=537368;g1c(a+144|0,0,224)|0;u=c;return}function Hib(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Iib(a){a=a|0;var c=0;c=f[a+136>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+140>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==532344)return;c=f[a+144>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+148>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+152>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+156>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+160>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+164>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+168>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+172>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+176>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+180>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+184>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+188>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+192>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+196>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+200>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+204>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+208>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+212>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+216>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+220>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+224>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+228>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+232>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+236>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+240>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+244>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+248>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+252>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+256>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+260>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+264>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+268>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+272>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+276>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+280>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+284>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+288>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+292>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+296>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+300>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+304>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+308>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+312>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+316>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+320>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+324>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+328>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+332>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+336>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+340>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+344>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+348>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+352>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+356>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function Jib(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Kib(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Lib(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=98644;c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[c>>2]=0;return}function Mib(a){a=a|0;Lib(a);cYc(a);return}function Nib(a){a=a|0;a=$Xc(40)|0;_ib(a);return a|0}function Oib(a,b){a=a|0;b=b|0;a=$Xc(40)|0;_ib(a);if(!b)return a|0;$ib(b,a);return a|0}function Pib(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;if(f[c>>2]&3|0){f[a+32>>2]=0;f[a+36>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Qib(a){a=a|0;return 1}function Rib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+8|0;g=a+32|0;h=a+16|0;i=a+4|0;j=a+36|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=7}else{o=l;n=6}}else{o=0;n=6}if((n|0)==6){n=0;l=ZYb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=7}else p=l}c:do if((n|0)==7){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)==8)break b;else{p=m;break c}break}case 2:{if((m&255|0)!=16){p=m;break c}f[e>>2]=f[e>>2]|1;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){a=b[l>>0]|0;k=a&255;if(a<<24>>24>-1){f[c>>2]=l+1;q=k}else{r=k;n=23}}else{r=0;n=23}if((n|0)==23){n=0;k=KYb(c,r)|0;l=J;if((l|0)>-1|(l|0)==-1&k>>>0>4294967295)q=k;else{s=0;n=32;break a}}f[g>>2]=q;continue b;break}case 3:{if((m&255|0)!=26){p=m;break c}if(l$b(c,pHa(h)|0)|0)continue b;else{s=0;n=32;break a}break}default:{p=m;break c}}}while(0);if(!p){s=1;n=32;break a}k=f[i>>2]|0;if(!(k&1))t=lSa(i)|0;else t=k&-2;if(!(Lqc(c,p,t)|0)){s=0;n=32;break a}}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){l=b[k>>0]|0;a=l&255;if(l<<24>>24>-1){f[c>>2]=k+1;u=a}else{v=a;n=12}}else{v=0;n=12}if((n|0)==12){n=0;a=KYb(c,v)|0;k=J;if((k|0)>-1|(k|0)==-1&a>>>0>4294967295)u=a;else{s=0;n=32;break}}if(u>>>0<2){f[e>>2]=f[e>>2]|2;f[j>>2]=u;continue}a=f[i>>2]|0;if(!(a&1))w=lSa(i)|0;else w=a&-2;yqc(w,1,u,((u|0)<0)<<31>>31)}if((n|0)==32)return s|0;return 0}function Sib(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+8>>2]|0;if(!(e&3)){m=l;n=a+12|0;f[n>>2]=m;return m|0}if(!(e&1))o=l;else{h=f[a+32>>2]|0;if((h|0)<0)p=11;else p=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;o=p+l|0}if(!(e&2)){m=o;n=a+12|0;f[n>>2]=m;return m|0}e=f[a+36>>2]|0;if((e|0)<0)q=11;else q=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=q+o|0;n=a+12|0;f[n>>2]=m;return m|0}function Tib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;if(c&2|0)d$b(1,f[a+36>>2]|0,b);if(c&1|0)S_b(2,f[a+32>>2]|0,b);c=f[a+20>>2]|0;if((c|0)>0){d=a+28|0;e=0;do{e$b(3,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Uib(a){a=a|0;return f[a+12>>2]|0}function Vib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+36>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&1))q=e;else{c=f[a+32>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=l1c(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+20>>2]|0;if((r|0)>0){s=a+28|0;e=0;o=q;while(1){l=f[(f[s>>2]|0)+4+(e<<2)>>2]|0;b[o>>0]=26;d=gZb(l,o+1|0)|0;e=e+1|0;if((e|0)==(r|0)){t=d;break}else o=d}}else t=q;q=f[a+4>>2]|0;if(!(q&1)){u=t;return u|0}u=Pqc(q&-2,t)|0;return u|0}function Wib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if((a|0)==(c|0))return;d=a+20|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((h|0)!=(e|0));f[d>>2]=0}d=a+8|0;if(f[d>>2]&3|0){f[a+32>>2]=0;f[a+36>>2]=1}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);Xib(a,c);return}function Xib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16704,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}vSa(a+16|0,c+16|0);d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+32>>2]=f[c+32>>2];if(d&2|0)f[a+36>>2]=f[c+36>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function Yib(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Zib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535344;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function _ib(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=98644;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=532208?(f[223085]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=35;b[d+8>>0]=0;J_b(892340,d);a_b(d)}f[a+12>>2]=0;f[a+32>>2]=0;f[a+36>>2]=1;u=c;return}function $ib(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function ajb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=98752;c=f[a+32>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[c>>2]=0;return}function bjb(a){a=a|0;ajb(a);cYc(a);return}function cjb(a){a=a|0;a=$Xc(44)|0;qjb(a);return a|0}function djb(a,b){a=a|0;b=b|0;a=$Xc(44)|0;qjb(a);if(!b)return a|0;rjb(b,a);return a|0}function ejb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{d0a(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&1|0){g=f[a+32>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&6|0){d=a+36|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function fjb(a){a=a|0;return 1}function gjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+36|0;j=a+32|0;k=a+16|0;l=e+4|0;m=a+40|0;n=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=ZYb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=8){t=q;break b}f[h>>2]=f[h>>2]|2;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){a=b[p>>0]|0;o=a&255;if(a<<24>>24>-1){f[c>>2]=p+1;v=o}else{w=o;r=11}}else{w=0;r=11}if((r|0)==11){r=0;o=KYb(c,w)|0;p=J;if((p|0)>-1|(p|0)==-1&o>>>0>4294967295)v=o;else{x=0;r=37;break a}}f[i>>2]=v;continue a;break}case 2:{if((q&255|0)!=18){t=q;break b}f[h>>2]=f[h>>2]|1;o=f[j>>2]|0;if((o|0)==537368){mHa(j,537368);y=f[j>>2]|0}else y=o;if(l$b(c,y)|0)continue a;else{x=0;r=37;break a}break}case 3:{if((q&255|0)!=26){t=q;break b}o=Z$a(k)|0;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(a=b[p>>0]|0,a<<24>>24>-1):0){f[c>>2]=p+1;z=a&255}else{a=YYb(c)|0;if((a|0)>-1)z=a;else{x=0;r=37;break a}}JYb(e,c,z);if((f[l>>2]|0)<0){r=24;break a}if(!(Mi[f[(f[o>>2]|0)+44>>2]&1023](o,c)|0)){r=24;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{x=0;r=37;break a}break}case 4:{if((q&255|0)!=32){t=q;break b}f[h>>2]=f[h>>2]|4;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;p=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;A=p}else{B=p;r=30}}else{B=0;r=30}if((r|0)==30){r=0;p=KYb(c,B)|0;o=J;if((o|0)>-1|(o|0)==-1&p>>>0>4294967295)A=p;else{x=0;r=37;break a}}f[m>>2]=A;continue a;break}default:{t=q;break b}}}while(0);if(!t){x=1;r=37;break}p=f[n>>2]|0;if(!(p&1))C=lSa(n)|0;else C=p&-2;if(!(Lqc(c,t,C)|0)){x=0;r=37;break}}if((r|0)==24){x=0;u=d;return x|0}else if((r|0)==37){u=d;return x|0}return 0}function hjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+8>>2]|0;if(!(i&7)){k=g;l=a+12|0;f[l>>2]=k;return k|0}if(!(i&1))m=g;else{c=f[a+32>>2]|0;h=b[c+11>>0]|0;d=h<<24>>24<0?f[c+4>>2]|0:h&255;m=g+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))n=m;else{d=f[a+36>>2]|0;if((d|0)<0)o=11;else o=((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+m|0}if(!(i&4)){k=n;l=a+12|0;f[l>>2]=k;return k|0}i=f[a+40>>2]|0;if((i|0)<0)p=11;else p=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=p+n|0;l=a+12|0;f[l>>2]=k;return k|0}function ijb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&2|0)S_b(1,f[a+36>>2]|0,b);if(c&1|0)f$b(2,f[a+32>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{k$b(3,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)S_b(4,f[a+40>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function jjb(a){a=a|0;return f[a+12>>2]|0}function kjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+36>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&1))r=g;else{p=f[a+32>>2]|0;b[g>>0]=18;r=gZb(p,g+1|0)|0}g=f[a+20>>2]|0;if(!g)s=r;else{p=a+28|0;q=0;d=r;while(1){r=f[(f[p>>2]|0)+4+(q<<2)>>2]|0;b[d>>0]=26;i=d+1|0;m=_i[f[(f[r>>2]|0)+60>>2]&2047](r)|0;if(m>>>0>127){k=m;j=i;while(1){b[j>>0]=k|128;l=k>>>7;o=j+1|0;if(k>>>0>16383){k=l;j=o}else{t=o;u=l;break}}}else{t=i;u=m}b[t>>0]=u;j=hj[f[(f[r>>2]|0)+64>>2]&511](r,c,t+1|0)|0;q=q+1|0;if((q|0)==(g|0)){s=j;break}else d=j}}if(!(e&4))v=s;else{e=f[a+40>>2]|0;b[s>>0]=32;d=s+1|0;s=e&255;if(e>>>0>127){g=d;q=s;t=e;c=((e|0)<0)<<31>>31;while(1){b[g>>0]=q|-128;e=t;t=l1c(t|0,c|0,7)|0;u=g+1|0;p=t&255;if(!(c>>>0>0|(c|0)==0&e>>>0>16383)){w=u;x=p;break}else{g=u;q=p;c=J}}}else{w=d;x=s}b[w>>0]=x;v=w+1|0}w=f[a+4>>2]|0;if(!(w&1)){y=v;return y|0}y=Pqc(w&-2,v)|0;return y|0}function ljb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;d=a+20|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{d0a(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[d>>2]=0}d=a+8|0;e=f[d>>2]|0;do if(e&1|0){h=f[a+32>>2]|0;g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);if(e&6|0){e=a+36|0;f[e>>2]=0;f[e+4>>2]=0}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16720,0)|0;if(!e){Ooc(c,a);return}else{pjb(a,e);return}}function mjb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16720,0)|0;if(!c){Ooc(b,a);return}else{pjb(a,c);return}}function njb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ojb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535336;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function pjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}yHa(a+16|0,b+16|0);d=f[b+8>>2]|0;if(!(d&7))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+32|0,e=f[b+32>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(d&2|0)f[a+36>>2]=f[b+36>>2];if(d&4|0)f[a+40>>2]=f[b+40>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function qjb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=98752;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=532160?(f[223084]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=34;b[d+8>>0]=0;J_b(892336,d);a_b(d)}f[a+12>>2]=0;f[a+32>>2]=537368;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function rjb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function sjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=98860;lkb(a);c=f[a+84>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+72|0;d=f[c>>2]|0;if(d|0?(f[a+60>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+56|0;i=f[c>>2]|0;if(i|0?(f[a+44>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+28|0;j=f[c>>2]|0;if(j|0?(f[a+16>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(k);f[c>>2]=0;return}function tjb(a){a=a|0;sjb(a);cYc(a);return}function ujb(a){a=a|0;a=$Xc(232)|0;jkb(a);return a|0}function vjb(a,b){a=a|0;b=b|0;a=$Xc(232)|0;jkb(a);if(!b)return a|0;kkb(b,a);return a|0}function wjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+32>>2]=0;c=a+48|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+56>>2]|0;e=0;do{Ujb(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+64|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+72>>2]|0;g=0;do{i=f[e+4+(g<<2)>>2]|0;g=g+1|0;h=i+20|0;j=f[h>>2]|0;if((j|0)>0){k=f[i+28>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;o=m+11|0;if((b[o>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0}else{b[m>>0]=0;b[o>>0]=0}}while((l|0)!=(j|0));f[h>>2]=0}j=i+8|0;if(f[j>>2]&3|0){f[i+32>>2]=0;f[i+36>>2]=1}f[j>>2]=0;j=f[i+4>>2]|0;if(j&1|0?(l=j&-2,f[l>>2]|0):0)sqc(l)}while((g|0)!=(d|0));f[c>>2]=0}f[a+76>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){do if(d&1|0){g=f[a+88>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+92>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+96>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0){e=f[a+100>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&16|0)oYc(f[a+104>>2]|0,535184)|0;if(d&32|0)oYc(f[a+108>>2]|0,535200)|0;if(d&64|0)Ujb(f[a+112>>2]|0);if(d&128|0)Ujb(f[a+116>>2]|0)}if(d&256|0){g=f[a+120>>2]|0;e=g+20|0;l=f[e>>2]|0;if((l|0)>0){j=f[g+28>>2]|0;k=0;do{o=f[j+4+(k<<2)>>2]|0;k=k+1|0;m=o+11|0;if((b[m>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[m>>0]=0}}while((k|0)!=(l|0));f[e>>2]=0}e=g+8|0;if(f[e>>2]&3|0){f[g+32>>2]=0;f[g+36>>2]=1}f[e>>2]=0;e=f[g+4>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g)}if(d&65024|0){g=a+124|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0}if(d&16711680|0){g=a+152|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0}if(d>>>0>16777215){n[a+176>>2]=.9990000128746033;d=a+184|0;f[d>>2]=-1;f[d+4>>2]=-1;f[a+192>>2]=1;b[a+196>>0]=1;b[a+197>>0]=1;n[a+200>>2]=9.99999993922529e-09;f[a+204>>2]=1;n[a+208>>2]=-1.0}if(f[a+12>>2]&7|0){f[a+212>>2]=1;f[a+216>>2]=1;n[a+220>>2]=.9900000095367432}d=c;f[d>>2]=0;f[d+4>>2]=0;d=f[a+4>>2]|0;if(!(d&1))return;a=d&-2;if(!(f[a>>2]|0))return;sqc(a);return}function xjb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+48>>2]|0;a:do if((b|0)>0){c=f[a+56>>2]|0;d=b;b:while(1){e=d;d=d+-1|0;g=f[c+4+(d<<2)>>2]|0;h=f[g+80>>2]|0;if((h|0)>0){i=f[g+88>>2]|0;g=h;do{h=g;g=g+-1|0;j=f[i+4+(g<<2)>>2]|0;if(f[j+12>>2]&4194304|0?(f[(f[j+352>>2]|0)+8>>2]&7|0)!=7:0){k=0;break b}}while((h|0)>1)}if((e|0)<=1)break a}return k|0}while(0);b=f[a+8>>2]|0;c:do if(b&64|0?(d=f[a+112>>2]|0,c=f[d+80>>2]|0,(c|0)>0):0){g=f[d+88>>2]|0;d=c;while(1){c=d;d=d+-1|0;i=f[g+4+(d<<2)>>2]|0;if(f[i+12>>2]&4194304|0?(f[(f[i+352>>2]|0)+8>>2]&7|0)!=7:0){k=0;break}if((c|0)<=1)break c}return k|0}while(0);if(!(b&128)){k=1;return k|0}b=f[a+116>>2]|0;a=f[b+80>>2]|0;if((a|0)<=0){k=1;return k|0}d=f[b+88>>2]|0;b=a;while(1){a=b;b=b+-1|0;g=f[d+4+(b<<2)>>2]|0;if(f[g+12>>2]&4194304|0?(f[(f[g+352>>2]|0)+8>>2]&7|0)!=7:0){k=0;l=21;break}if((a|0)<=1){k=1;l=21;break}}if((l|0)==21)return k|0;return 0}function yjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+16|0;l=a+32|0;m=a+36|0;n=a+40|0;o=a+124|0;p=a+128|0;q=a+132|0;r=a+136|0;s=a+92|0;t=a+140|0;v=a+144|0;w=a+148|0;x=a+152|0;y=a+156|0;z=a+160|0;A=a+96|0;B=a+169|0;C=e+8|0;D=a+192|0;E=a+4|0;F=a+164|0;G=a+168|0;H=e+8|0;I=a+184|0;K=e+8|0;L=a+112|0;M=e+4|0;N=a+44|0;O=a+56|0;P=a+52|0;Q=a+48|0;R=e+4|0;S=a+170|0;T=e+8|0;U=a+100|0;V=a+116|0;W=e+4|0;X=a+120|0;Y=e+4|0;Z=a+60|0;_=a+72|0;$=a+68|0;aa=a+64|0;ba=e+4|0;ca=a+197|0;da=e+8|0;ea=a+104|0;fa=a+172|0;ga=a+200|0;ha=a+196|0;ia=e+8|0;ja=a+204|0;ka=a+76|0;la=a+80|0;ma=a+84|0;na=a+208|0;oa=a+12|0;pa=a+212|0;qa=a+216|0;ra=a+220|0;sa=a+176|0;ta=a+108|0;a:while(1){a=f[c>>2]|0;ua=f[g>>2]|0;do if(a>>>0<ua>>>0){va=b[a>>0]|0;wa=va&255;xa=a+1|0;if(va<<24>>24>0){ya=xa;za=wa}else{if(xa>>>0>=ua>>>0){Aa=wa;Ba=7;break}va=h[xa>>0]|0;if(((va^128)&wa)>>>0<=127){Aa=wa;Ba=7;break}ya=a+2|0;za=wa+-128+(va<<7)|0}f[c>>2]=ya;Ca=za;Ba=9}else{Aa=0;Ba=7}while(0);if((Ba|0)==7){Ba=0;a=ZYb(c,Aa)|0;if((a+-1|0)>>>0<16383){Ca=a;Ba=9}else Da=a}b:do if((Ba|0)==9){Ba=0;do switch(Ca>>>3&536870911|0){case 1:{if((Ca&255|0)!=10){Da=Ca;break b}f[i>>2]=f[i>>2]|1;a=f[j>>2]|0;if((a|0)==537368){mHa(j,537368);Ea=f[j>>2]|0}else Ea=a;if(l$b(c,Ea)|0)continue a;else{Fa=0;Ba=331;break a}break}case 2:{if((Ca&255|0)!=18){Da=Ca;break b}if(l$b(c,pHa(k)|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 3:{switch((Ca&255)<<24>>24){case 24:break;case 26:{if(dkb(c,l)|0)continue a;else{Fa=0;Ba=331;break a}break}default:{Da=Ca;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){ua=b[a>>0]|0;va=ua&255;if(ua<<24>>24>-1){f[c>>2]=a+1;Ga=va}else{Ha=va;Ba=20}}else{Ha=0;Ba=20}if((Ba|0)==20){Ba=0;va=KYb(c,Ha)|0;a=J;if((a|0)>-1|(a|0)==-1&va>>>0>4294967295)Ga=va;else{Fa=0;Ba=331;break a}}va=f[l>>2]|0;if((va|0)==(f[m>>2]|0)){qHa(l,va+1|0);Ia=f[l>>2]|0}else Ia=va;va=f[n>>2]|0;f[l>>2]=Ia+1;f[va+4+(Ia<<2)>>2]=Ga;a=(f[m>>2]|0)-(f[l>>2]|0)|0;if((a|0)>0){Ja=a;Ka=va}else continue a;while(1){va=f[c>>2]|0;a=f[g>>2]|0;if(va>>>0>=a>>>0)continue a;if((b[va>>0]|0)!=24)continue a;ua=va+1|0;f[c>>2]=ua;if(ua>>>0<a>>>0){a=b[ua>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+2;La=ua;Ma=Ka}else{Na=ua;Ba=28}}else{Na=0;Ba=28}if((Ba|0)==28){Ba=0;ua=KYb(c,Na)|0;va=J;if(!((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)){Fa=0;Ba=331;break a}La=ua;Ma=f[n>>2]|0}ua=f[l>>2]|0;f[l>>2]=ua+1;f[Ma+4+(ua<<2)>>2]=La;if((Ja|0)>1){Ja=Ja+-1|0;Ka=Ma}else continue a}break}case 4:{if((Ca&255|0)!=32){Da=Ca;break b}f[i>>2]=f[i>>2]|512;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){va=b[ua>>0]|0;a=va&255;if(va<<24>>24>-1){f[c>>2]=ua+1;Oa=a}else{Pa=a;Ba=37}}else{Pa=0;Ba=37}if((Ba|0)==37){Ba=0;a=KYb(c,Pa)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&a>>>0>4294967295)Oa=a;else{Fa=0;Ba=331;break a}}f[o>>2]=Oa;continue a;break}case 5:{if((Ca&255|0)!=45){Da=Ca;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){ua=a;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=va;f[c>>2]=a+4;Qa=va}else{if(!(WYb(c,e)|0)){Ba=45;break a}Qa=f[e>>2]|0}f[p>>2]=Qa;continue a;break}case 6:{if((Ca&255|0)!=48){Da=Ca;break b}f[i>>2]=f[i>>2]|2048;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){a=b[va>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+1;Ra=ua}else{Sa=ua;Ba=50}}else{Sa=0;Ba=50}if((Ba|0)==50){Ba=0;ua=KYb(c,Sa)|0;va=J;if((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)Ra=ua;else{Fa=0;Ba=331;break a}}f[q>>2]=Ra;continue a;break}case 7:{if((Ca&255|0)!=56){Da=Ca;break b}f[i>>2]=f[i>>2]|4096;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){va=b[ua>>0]|0;a=va&255;if(va<<24>>24>-1){f[c>>2]=ua+1;Ta=a}else{Ua=a;Ba=56}}else{Ua=0;Ba=56}if((Ba|0)==56){Ba=0;a=KYb(c,Ua)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&a>>>0>4294967295)Ta=a;else{Fa=0;Ba=331;break a}}f[r>>2]=Ta;continue a;break}case 8:{if((Ca&255|0)!=66){Da=Ca;break b}f[i>>2]=f[i>>2]|2;a=f[s>>2]|0;if((a|0)==537368){mHa(s,537368);Va=f[s>>2]|0}else Va=a;if(l$b(c,Va)|0)continue a;else{Fa=0;Ba=331;break a}break}case 9:{if((Ca&255|0)!=77){Da=Ca;break b}f[i>>2]=f[i>>2]|8192;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){ua=a;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=va;f[c>>2]=a+4;Wa=va}else{if(!(WYb(c,e)|0)){Ba=68;break a}Wa=f[e>>2]|0}f[t>>2]=Wa;continue a;break}case 10:{if((Ca&255|0)!=85){Da=Ca;break b}f[i>>2]=f[i>>2]|16384;va=f[c>>2]|0;if(((f[g>>2]|0)-va|0)>3){a=va;ua=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=ua;f[c>>2]=va+4;Xa=ua}else{if(!(WYb(c,e)|0)){Ba=75;break a}Xa=f[e>>2]|0}f[v>>2]=Xa;continue a;break}case 11:{if((Ca&255|0)!=93){Da=Ca;break b}f[i>>2]=f[i>>2]|32768;ua=f[c>>2]|0;if(((f[g>>2]|0)-ua|0)>3){va=ua;a=h[va>>0]|h[va+1>>0]<<8|h[va+2>>0]<<16|h[va+3>>0]<<24;f[e>>2]=a;f[c>>2]=ua+4;Ya=a}else{if(!(WYb(c,e)|0)){Ba=82;break a}Ya=f[e>>2]|0}f[w>>2]=Ya;continue a;break}case 12:{if((Ca&255|0)!=101){Da=Ca;break b}f[i>>2]=f[i>>2]|65536;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){ua=a;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=va;f[c>>2]=a+4;Za=va}else{if(!(WYb(c,e)|0)){Ba=89;break a}Za=f[e>>2]|0}f[x>>2]=Za;continue a;break}case 13:{if((Ca&255|0)!=104){Da=Ca;break b}f[i>>2]=f[i>>2]|131072;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){a=b[va>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+1;_a=ua}else{$a=ua;Ba=94}}else{$a=0;Ba=94}if((Ba|0)==94){Ba=0;ua=KYb(c,$a)|0;va=J;if((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)_a=ua;else{Fa=0;Ba=331;break a}}f[y>>2]=_a;continue a;break}case 14:{if((Ca&255|0)!=112){Da=Ca;break b}f[i>>2]=f[i>>2]|262144;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){va=b[ua>>0]|0;a=va&255;if(va<<24>>24>-1){f[c>>2]=ua+1;ab=a}else{bb=a;Ba=100}}else{bb=0;Ba=100}if((Ba|0)==100){Ba=0;a=KYb(c,bb)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&a>>>0>4294967295)ab=a;else{Fa=0;Ba=331;break a}}f[z>>2]=ab;continue a;break}case 15:{if((Ca&255|0)!=122){Da=Ca;break b}f[i>>2]=f[i>>2]|4;a=f[A>>2]|0;if((a|0)==537368){mHa(A,537368);cb=f[A>>2]|0}else cb=a;if(l$b(c,cb)|0)continue a;else{Fa=0;Ba=331;break a}break}case 16:{if((Ca&255|0)!=128){Da=Ca;break b}f[i>>2]=f[i>>2]|2097152;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(ua=b[a>>0]|0,ua<<24>>24>-1):0){f[c>>2]=a+1;db=ua<<24>>24!=0}else{LYb(e,c);ua=e;if(!(b[C>>0]|0)){Fa=0;Ba=331;break a}else db=(f[ua>>2]|0)!=0|(f[ua+4>>2]|0)!=0}b[B>>0]=db&1;continue a;break}case 17:{if((Ca&255|0)!=136){Da=Ca;break b}ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){a=b[ua>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+1;eb=va}else{fb=va;Ba=116}}else{fb=0;Ba=116}if((Ba|0)==116){Ba=0;va=KYb(c,fb)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)eb=va;else{Fa=0;Ba=331;break a}}if(eb>>>0<2){f[i>>2]=f[i>>2]|67108864;f[D>>2]=eb;continue a}va=f[E>>2]|0;if(!(va&1))gb=lSa(E)|0;else gb=va&-2;yqc(gb,17,eb,((eb|0)<0)<<31>>31);continue a;break}case 18:{if((Ca&255|0)!=144){Da=Ca;break b}f[i>>2]=f[i>>2]|524288;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){ua=b[va>>0]|0;a=ua&255;if(ua<<24>>24>-1){f[c>>2]=va+1;hb=a}else{ib=a;Ba=127}}else{ib=0;Ba=127}if((Ba|0)==127){Ba=0;a=KYb(c,ib)|0;va=J;if((va|0)>-1|(va|0)==-1&a>>>0>4294967295)hb=a;else{Fa=0;Ba=331;break a}}f[F>>2]=hb;continue a;break}case 19:{if((Ca&255|0)!=152){Da=Ca;break b}f[i>>2]=f[i>>2]|1048576;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;jb=va<<24>>24!=0}else{LYb(e,c);va=e;if(!(b[H>>0]|0)){Fa=0;Ba=331;break a}else jb=(f[va>>2]|0)!=0|(f[va+4>>2]|0)!=0}b[G>>0]=jb&1;continue a;break}case 20:{if((Ca&255|0)!=160){Da=Ca;break b}f[i>>2]=f[i>>2]|33554432;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;kb=a&255;lb=0}else{LYb(e,c);a=e;if(!(b[K>>0]|0)){Fa=0;Ba=331;break a}else{kb=f[a>>2]|0;lb=f[a+4>>2]|0}}a=I;f[a>>2]=kb;f[a+4>>2]=lb;continue a;break}case 21:{if((Ca&255|0)!=170){Da=Ca;break b}f[i>>2]=f[i>>2]|64;a=f[L>>2]|0;if(!a){va=$Xc(104)|0;Kjb(va);f[L>>2]=va;mb=va}else mb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;nb=va&255}else{va=YYb(c)|0;if((va|0)>-1)nb=va;else{Fa=0;Ba=331;break a}}JYb(e,c,nb);if((f[M>>2]|0)<0){Ba=150;break a}if(!(Mi[f[(f[mb>>2]|0)+44>>2]&1023](mb,c)|0)){Ba=150;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 22:{if((Ca&255|0)!=178){Da=Ca;break b}va=f[O>>2]|0;do if(va){a=f[Q>>2]|0;ua=f[va>>2]|0;if((a|0)>=(ua|0))if((ua|0)==(f[P>>2]|0)){ob=ua;Ba=158;break}else{pb=ua;qb=va;Ba=159;break}else{f[Q>>2]=a+1;rb=f[va+4+(a<<2)>>2]|0;break}}else{ob=f[P>>2]|0;Ba=158}while(0);if((Ba|0)==158){Ba=0;XZb(N,ob+1|0);va=f[O>>2]|0;pb=f[va>>2]|0;qb=va;Ba=159}if((Ba|0)==159){Ba=0;f[qb>>2]=pb+1;va=f[N>>2]|0;if(!va){a=$Xc(104)|0;Kjb(a);sb=a}else{if(f[va+64>>2]|0)SXb(va,16752,104);a=RXb(va,104,2255)|0;Kjb(a);sb=a}a=f[O>>2]|0;va=f[Q>>2]|0;f[Q>>2]=va+1;f[a+4+(va<<2)>>2]=sb;rb=sb}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;tb=a&255}else{a=YYb(c)|0;if((a|0)>-1)tb=a;else{Fa=0;Ba=331;break a}}JYb(e,c,tb);if((f[R>>2]|0)<0){Ba=171;break a}if(!(Mi[f[(f[rb>>2]|0)+44>>2]&1023](rb,c)|0)){Ba=171;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 23:{if((Ca&255|0)!=184){Da=Ca;break b}f[i>>2]=f[i>>2]|4194304;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;ub=va<<24>>24!=0}else{LYb(e,c);va=e;if(!(b[T>>0]|0)){Fa=0;Ba=331;break a}else ub=(f[va>>2]|0)!=0|(f[va+4>>2]|0)!=0}b[S>>0]=ub&1;continue a;break}case 24:{if((Ca&255|0)!=194){Da=Ca;break b}f[i>>2]=f[i>>2]|8;va=f[U>>2]|0;if((va|0)==537368){mHa(U,537368);vb=f[U>>2]|0}else vb=va;if(l$b(c,vb)|0)continue a;else{Fa=0;Ba=331;break a}break}case 25:{if((Ca&255|0)!=202){Da=Ca;break b}f[i>>2]=f[i>>2]|128;va=f[V>>2]|0;if(!va){a=$Xc(104)|0;Kjb(a);f[V>>2]=a;wb=a}else wb=va;va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;xb=a&255}else{a=YYb(c)|0;if((a|0)>-1)xb=a;else{Fa=0;Ba=331;break a}}JYb(e,c,xb);if((f[W>>2]|0)<0){Ba=192;break a}if(!(Mi[f[(f[wb>>2]|0)+44>>2]&1023](wb,c)|0)){Ba=192;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 26:{if((Ca&255|0)!=210){Da=Ca;break b}f[i>>2]=f[i>>2]|256;a=f[X>>2]|0;if(!a){va=$Xc(40)|0;_ib(va);f[X>>2]=va;yb=va}else yb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;zb=va&255}else{va=YYb(c)|0;if((va|0)>-1)zb=va;else{Fa=0;Ba=331;break a}}JYb(e,c,zb);if((f[Y>>2]|0)<0){Ba=203;break a}if(!(Mi[f[(f[yb>>2]|0)+44>>2]&1023](yb,c)|0)){Ba=203;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 27:{if((Ca&255|0)!=218){Da=Ca;break b}va=f[_>>2]|0;do if(va){a=f[aa>>2]|0;ua=f[va>>2]|0;if((a|0)>=(ua|0))if((ua|0)==(f[$>>2]|0)){Ab=ua;Ba=211;break}else{Bb=ua;Cb=va;Ba=212;break}else{f[aa>>2]=a+1;Db=f[va+4+(a<<2)>>2]|0;break}}else{Ab=f[$>>2]|0;Ba=211}while(0);if((Ba|0)==211){Ba=0;XZb(Z,Ab+1|0);va=f[_>>2]|0;Bb=f[va>>2]|0;Cb=va;Ba=212}if((Ba|0)==212){Ba=0;f[Cb>>2]=Bb+1;va=f[Z>>2]|0;if(!va){a=$Xc(40)|0;_ib(a);Eb=a}else{if(f[va+64>>2]|0)SXb(va,16704,40);a=RXb(va,40,2256)|0;_ib(a);Eb=a}a=f[_>>2]|0;va=f[aa>>2]|0;f[aa>>2]=va+1;f[a+4+(va<<2)>>2]=Eb;Db=Eb}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0?(a=b[va>>0]|0,a<<24>>24>-1):0){f[c>>2]=va+1;Fb=a&255}else{a=YYb(c)|0;if((a|0)>-1)Fb=a;else{Fa=0;Ba=331;break a}}JYb(e,c,Fb);if((f[ba>>2]|0)<0){Ba=224;break a}if(!(Mi[f[(f[Db>>2]|0)+44>>2]&1023](Db,c)|0)){Ba=224;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Fa=0;Ba=331;break a}break}case 28:{if((Ca&255|0)!=224){Da=Ca;break b}f[i>>2]=f[i>>2]|268435456;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(va=b[a>>0]|0,va<<24>>24>-1):0){f[c>>2]=a+1;Gb=va<<24>>24!=0}else{LYb(e,c);va=e;if(!(b[da>>0]|0)){Fa=0;Ba=331;break a}else Gb=(f[va>>2]|0)!=0|(f[va+4>>2]|0)!=0}b[ca>>0]=Gb&1;continue a;break}case 29:{if((Ca&255|0)!=234){Da=Ca;break b}f[i>>2]=f[i>>2]|16;va=f[ea>>2]|0;if((va|0)==535184){mHa(ea,535184);Hb=f[ea>>2]|0}else Hb=va;if(l$b(c,Hb)|0)continue a;else{Fa=0;Ba=331;break a}break}case 30:{if((Ca&255|0)!=240){Da=Ca;break b}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){a=b[va>>0]|0;ua=a&255;if(a<<24>>24>-1){f[c>>2]=va+1;Ib=ua}else{Jb=ua;Ba=240}}else{Jb=0;Ba=240}if((Ba|0)==240){Ba=0;ua=KYb(c,Jb)|0;va=J;if((va|0)>-1|(va|0)==-1&ua>>>0>4294967295)Ib=ua;else{Fa=0;Ba=331;break a}}if(Ib>>>0<6){f[i>>2]=f[i>>2]|8388608;f[fa>>2]=Ib;continue a}ua=f[E>>2]|0;if(!(ua&1))Kb=lSa(E)|0;else Kb=ua&-2;yqc(Kb,30,Ib,((Ib|0)<0)<<31>>31);continue a;break}case 31:{if((Ca&255|0)!=253){Da=Ca;break b}f[i>>2]=f[i>>2]|536870912;ua=f[c>>2]|0;if(((f[g>>2]|0)-ua|0)>3){va=ua;a=h[va>>0]|h[va+1>>0]<<8|h[va+2>>0]<<16|h[va+3>>0]<<24;f[e>>2]=a;f[c>>2]=ua+4;Lb=a}else{if(!(WYb(c,e)|0)){Ba=253;break a}Lb=f[e>>2]|0}f[ga>>2]=Lb;continue a;break}case 32:{if(Ca&255|0){Da=Ca;break b}f[i>>2]=f[i>>2]|134217728;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(ua=b[a>>0]|0,ua<<24>>24>-1):0){f[c>>2]=a+1;Mb=ua<<24>>24!=0}else{LYb(e,c);ua=e;if(!(b[ia>>0]|0)){Fa=0;Ba=331;break a}else Mb=(f[ua>>2]|0)!=0|(f[ua+4>>2]|0)!=0}b[ha>>0]=Mb&1;continue a;break}case 33:{if((Ca&255|0)!=8){Da=Ca;break b}f[i>>2]=f[i>>2]|1073741824;ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){a=b[ua>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+1;Nb=va}else{Ob=va;Ba=264}}else{Ob=0;Ba=264}if((Ba|0)==264){Ba=0;va=KYb(c,Ob)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)Nb=va;else{Fa=0;Ba=331;break a}}f[ja>>2]=Nb;continue a;break}case 34:{switch((Ca&255)<<24>>24){case 16:break;case 18:{if(dkb(c,ka)|0)continue a;else{Fa=0;Ba=331;break a}break}default:{Da=Ca;break b}}va=f[c>>2]|0;if(va>>>0<(f[g>>2]|0)>>>0){ua=b[va>>0]|0;a=ua&255;if(ua<<24>>24>-1){f[c>>2]=va+1;Pb=a}else{Qb=a;Ba=270}}else{Qb=0;Ba=270}if((Ba|0)==270){Ba=0;a=KYb(c,Qb)|0;va=J;if((va|0)>-1|(va|0)==-1&a>>>0>4294967295)Pb=a;else{Fa=0;Ba=331;break a}}a=f[ka>>2]|0;if((a|0)==(f[la>>2]|0)){qHa(ka,a+1|0);Rb=f[ka>>2]|0}else Rb=a;a=f[ma>>2]|0;f[ka>>2]=Rb+1;f[a+4+(Rb<<2)>>2]=Pb;va=(f[la>>2]|0)-(f[ka>>2]|0)|0;if((va|0)>0){Sb=va;Tb=a}else continue a;while(1){a=f[g>>2]|0;va=f[c>>2]|0;ua=va;if((a-va|0)<=1)continue a;if((b[ua>>0]|0)!=-112)continue a;if((b[ua+1>>0]|0)!=2)continue a;va=ua+2|0;f[c>>2]=va;if(va>>>0<a>>>0){a=b[va>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+3;Ub=va;Vb=Tb}else{Wb=va;Ba=279}}else{Wb=0;Ba=279}if((Ba|0)==279){Ba=0;va=KYb(c,Wb)|0;ua=J;if(!((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)){Fa=0;Ba=331;break a}Ub=va;Vb=f[ma>>2]|0}va=f[ka>>2]|0;f[ka>>2]=va+1;f[Vb+4+(va<<2)>>2]=Ub;if((Sb|0)>1){Sb=Sb+-1|0;Tb=Vb}else continue a}break}case 35:{if((Ca&255|0)!=29){Da=Ca;break b}f[i>>2]=f[i>>2]|-2147483648;va=f[c>>2]|0;if(((f[g>>2]|0)-va|0)>3){ua=va;a=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=a;f[c>>2]=va+4;Xb=a}else{if(!(WYb(c,e)|0)){Ba=290;break a}Xb=f[e>>2]|0}f[na>>2]=Xb;continue a;break}case 36:{if((Ca&255|0)!=32){Da=Ca;break b}f[oa>>2]=f[oa>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){va=b[a>>0]|0;ua=va&255;if(va<<24>>24>-1){f[c>>2]=a+1;Yb=ua}else{Zb=ua;Ba=295}}else{Zb=0;Ba=295}if((Ba|0)==295){Ba=0;ua=KYb(c,Zb)|0;a=J;if((a|0)>-1|(a|0)==-1&ua>>>0>4294967295)Yb=ua;else{Fa=0;Ba=331;break a}}f[pa>>2]=Yb;continue a;break}case 37:{if((Ca&255|0)!=40){Da=Ca;break b}ua=f[c>>2]|0;if(ua>>>0<(f[g>>2]|0)>>>0){a=b[ua>>0]|0;va=a&255;if(a<<24>>24>-1){f[c>>2]=ua+1;_b=va}else{$b=va;Ba=301}}else{$b=0;Ba=301}if((Ba|0)==301){Ba=0;va=KYb(c,$b)|0;ua=J;if((ua|0)>-1|(ua|0)==-1&va>>>0>4294967295)_b=va;else{Fa=0;Ba=331;break a}}if(_b>>>0<2){f[oa>>2]=f[oa>>2]|2;f[qa>>2]=_b;continue a}va=f[E>>2]|0;if(!(va&1))ac=lSa(E)|0;else ac=va&-2;yqc(ac,37,_b,((_b|0)<0)<<31>>31);continue a;break}case 38:{if((Ca&255|0)!=53){Da=Ca;break b}f[oa>>2]=f[oa>>2]|4;va=f[c>>2]|0;if(((f[g>>2]|0)-va|0)>3){ua=va;a=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;f[e>>2]=a;f[c>>2]=va+4;bc=a}else{if(!(WYb(c,e)|0)){Ba=314;break a}bc=f[e>>2]|0}f[ra>>2]=bc;continue a;break}case 39:{if((Ca&255|0)!=61){Da=Ca;break b}f[i>>2]=f[i>>2]|16777216;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){va=a;ua=h[va>>0]|h[va+1>>0]<<8|h[va+2>>0]<<16|h[va+3>>0]<<24;f[e>>2]=ua;f[c>>2]=a+4;cc=ua}else{if(!(WYb(c,e)|0)){Ba=321;break a}cc=f[e>>2]|0}f[sa>>2]=cc;continue a;break}case 40:{if((Ca&255|0)!=66){Da=Ca;break b}f[i>>2]=f[i>>2]|32;ua=f[ta>>2]|0;if((ua|0)==535200){mHa(ta,535200);dc=f[ta>>2]|0}else dc=ua;if(l$b(c,dc)|0)continue a;else{Fa=0;Ba=331;break a}break}default:{Da=Ca;break b}}while(0)}while(0);if(!Da){Fa=1;Ba=331;break}ua=f[E>>2]|0;if(!(ua&1))ec=lSa(E)|0;else ec=ua&-2;if(!(Lqc(c,Da,ec)|0)){Fa=0;Ba=331;break}}switch(Ba|0){case 45:{Fa=0;u=d;return Fa|0}case 68:{Fa=0;u=d;return Fa|0}case 75:{Fa=0;u=d;return Fa|0}case 82:{Fa=0;u=d;return Fa|0}case 89:{Fa=0;u=d;return Fa|0}case 150:{Fa=0;u=d;return Fa|0}case 171:{Fa=0;u=d;return Fa|0}case 192:{Fa=0;u=d;return Fa|0}case 203:{Fa=0;u=d;return Fa|0}case 224:{Fa=0;u=d;return Fa|0}case 253:{Fa=0;u=d;return Fa|0}case 290:{Fa=0;u=d;return Fa|0}case 314:{Fa=0;u=d;return Fa|0}case 321:{Fa=0;u=d;return Fa|0}case 331:{u=d;return Fa|0}}return 0}function zjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=n$b(a+32|0)|0;h=f[a+48>>2]|0;c=e+l+(f[a+32>>2]|0)+(h<<1)|0;if(!h)m=c;else{l=a+56|0;e=0;g=c;while(1){c=f[(f[l>>2]|0)+4+(e<<2)>>2]|0;d=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=d+g+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){m=c;break}else g=c}}g=f[a+64>>2]|0;h=(g<<1)+m|0;if(!g)n=h;else{m=a+72|0;e=0;l=h;while(1){h=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;c=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;h=c+l+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(g|0)){n=h;break}else l=h}}l=n$b(a+76|0)|0;g=l+n+(f[a+76>>2]<<1)|0;n=a+8|0;l=f[n>>2]|0;if(l&255){if(!(l&1))o=g;else{e=f[a+88>>2]|0;m=b[e+11>>0]|0;h=m<<24>>24<0?f[e+4>>2]|0:m&255;o=g+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&2))p=o;else{h=f[a+92>>2]|0;m=b[h+11>>0]|0;e=m<<24>>24<0?f[h+4>>2]|0:m&255;p=o+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&4))q=p;else{e=f[a+96>>2]|0;o=b[e+11>>0]|0;m=o<<24>>24<0?f[e+4>>2]|0:o&255;q=p+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&8))r=q;else{m=f[a+100>>2]|0;p=b[m+11>>0]|0;o=p<<24>>24<0?f[m+4>>2]|0:p&255;r=q+2+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&16))s=r;else{o=f[a+104>>2]|0;q=b[o+11>>0]|0;p=q<<24>>24<0?f[o+4>>2]|0:q&255;s=r+2+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&32))t=s;else{p=f[a+108>>2]|0;r=b[p+11>>0]|0;q=r<<24>>24<0?f[p+4>>2]|0:r&255;t=s+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&64)){u=t;v=l}else{q=f[a+112>>2]|0;s=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=t+2+s+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=q;v=f[n>>2]|0}if(!(v&128)){w=u;x=v}else{v=f[a+116>>2]|0;q=_i[f[(f[v>>2]|0)+48>>2]&2047](v)|0;v=u+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=v;x=f[n>>2]|0}}else{w=g;x=l}if(!(x&65280)){y=w;z=x}else{if(!(x&256)){A=w;B=x}else{x=f[a+120>>2]|0;l=_i[f[(f[x>>2]|0)+48>>2]&2047](x)|0;x=w+2+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;A=x;B=f[n>>2]|0}if(!(B&512))C=A;else{n=f[a+124>>2]|0;if((n|0)<0)D=10;else D=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;C=A+1+D|0}D=B&1024|0?C+5|0:C;if(!(B&2048))E=D;else{C=f[a+132>>2]|0;if((C|0)<0)F=10;else F=(((($(C|1|0)|0)^31)*9|0)+73|0)>>>6;E=D+1+F|0}if(!(B&4096))G=E;else{F=f[a+136>>2]|0;if((F|0)<0)H=10;else H=(((($(F|1|0)|0)^31)*9|0)+73|0)>>>6;G=E+1+H|0}H=B&8192|0?G+5|0:G;G=B&16384|0?H+5|0:H;y=B&32768|0?G+5|0:G;z=B}if(z&16711680){B=z&65536|0?y+5|0:y;if(!(z&131072))I=B;else{G=f[a+156>>2]|0;if((G|0)<0)J=10;else J=(((($(G|1|0)|0)^31)*9|0)+73|0)>>>6;I=B+1+J|0}if(!(z&262144))K=I;else{J=f[a+160>>2]|0;if((J|0)<0)L=10;else L=(((($(J|1|0)|0)^31)*9|0)+73|0)>>>6;K=I+1+L|0}if(!(z&524288))M=K;else{L=f[a+164>>2]|0;if((L|0)<0)N=12;else N=((((($(L|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;M=N+K|0}K=z&1048576|0?M+3|0:M;M=z&2097152|0?K+3|0:K;K=z&4194304|0?M+3|0:M;if(!(z&8388608))O=K;else{M=f[a+172>>2]|0;if((M|0)<0)P=12;else P=((((($(M|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;O=P+K|0}}else O=y;if(z>>>0>16777215){y=z&16777216|0?O+6|0:O;if(!(z&33554432))Q=y;else{K=a+184|0;P=t1c(f[K>>2]|1|0,f[K+4>>2]|0,1)|0;Q=y+2+((((P^63)*9|0)+73|0)>>>6)|0}if(!(z&67108864))R=Q;else{P=f[a+192>>2]|0;if((P|0)<0)S=12;else S=((((($(P|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;R=S+Q|0}Q=z&134217728|0?R+3|0:R;R=z&268435456|0?Q+3|0:Q;Q=z&536870912|0?R+6|0:R;if(!(z&1073741824))T=Q;else{R=f[a+204>>2]|0;if((R|0)<0)U=12;else U=((((($(R|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;T=U+Q|0}V=(z|0)<0?T+6|0:T}else V=O;O=f[a+12>>2]|0;if(!(O&7)){W=V;X=a+224|0;f[X>>2]=W;return W|0}if(!(O&1))Y=V;else{T=f[a+212>>2]|0;if((T|0)<0)Z=12;else Z=((((($(T|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;Y=Z+V|0}if(!(O&2))_=Y;else{V=f[a+216>>2]|0;if((V|0)<0)aa=12;else aa=((((($(V|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;_=aa+Y|0}W=O&4|0?_+6|0:_;X=a+224|0;f[X>>2]=W;return W|0}function Ajb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(e&1|0)f$b(1,f[a+88>>2]|0,c);g=f[a+20>>2]|0;if((g|0)>0){h=a+28|0;i=0;do{e$b(2,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}g=f[a+32>>2]|0;if((g|0)>0){i=a+40|0;h=0;do{S_b(3,f[(f[i>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(g|0))}if(e&512|0)S_b(4,f[a+124>>2]|0,c);if(e&1024|0)a$b(5,+n[a+128>>2],c);if(e&2048|0)S_b(6,f[a+132>>2]|0,c);if(e&4096|0)S_b(7,f[a+136>>2]|0,c);if(e&2|0)f$b(8,f[a+92>>2]|0,c);if(e&8192|0)a$b(9,+n[a+140>>2],c);if(e&16384|0)a$b(10,+n[a+144>>2],c);if(e&32768|0)a$b(11,+n[a+148>>2],c);if(e&65536|0)a$b(12,+n[a+152>>2],c);if(e&131072|0)S_b(13,f[a+156>>2]|0,c);if(e&262144|0)S_b(14,f[a+160>>2]|0,c);if(e&4|0)f$b(15,f[a+96>>2]|0,c);if(e&2097152|0)c$b(16,(b[a+169>>0]|0)!=0,c);if(e&67108864|0)d$b(17,f[a+192>>2]|0,c);if(e&524288|0)S_b(18,f[a+164>>2]|0,c);if(e&1048576|0)c$b(19,(b[a+168>>0]|0)!=0,c);if(e&33554432|0){g=a+184|0;T_b(20,f[g>>2]|0,f[g+4>>2]|0,c)}if(e&64|0)k$b(21,f[a+112>>2]|0,c);g=f[a+48>>2]|0;if(g|0){h=a+56|0;i=0;do{k$b(22,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}if(e&4194304|0)c$b(23,(b[a+170>>0]|0)!=0,c);if(e&8|0)f$b(24,f[a+100>>2]|0,c);if(e&128|0)k$b(25,f[a+116>>2]|0,c);if(e&256|0)k$b(26,f[a+120>>2]|0,c);g=f[a+64>>2]|0;if(g|0){i=a+72|0;h=0;do{k$b(27,f[(f[i>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(g|0))}if(e&268435456|0)c$b(28,(b[a+197>>0]|0)!=0,c);if(e&16|0)f$b(29,f[a+104>>2]|0,c);if(e&8388608|0)d$b(30,f[a+172>>2]|0,c);if(e&536870912|0)a$b(31,+n[a+200>>2],c);if(e&134217728|0)c$b(32,(b[a+196>>0]|0)!=0,c);if(e&1073741824|0)S_b(33,f[a+204>>2]|0,c);g=f[a+76>>2]|0;if((g|0)>0){h=a+84|0;i=0;do{S_b(34,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}if((e|0)<0)a$b(35,+n[a+208>>2],c);e=f[a+12>>2]|0;if(e&1|0)S_b(36,f[a+212>>2]|0,c);if(e&2|0)d$b(37,f[a+216>>2]|0,c);if(e&4|0)a$b(38,+n[a+220>>2],c);e=f[d>>2]|0;if(e&16777216|0)a$b(39,+n[a+176>>2],c);if(e&32|0)f$b(40,f[a+108>>2]|0,c);e=f[a+4>>2]|0;if(!(e&1))return;Oqc(e&-2,c);return}function Bjb(a){a=a|0;return f[a+224>>2]|0}function Cjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;e=a+8|0;g=f[e>>2]|0;if(!(g&1))h=d;else{i=f[a+88>>2]|0;b[d>>0]=10;h=gZb(i,d+1|0)|0}d=f[a+20>>2]|0;if((d|0)>0){i=a+28|0;j=0;k=h;while(1){l=f[(f[i>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;m=gZb(l,k+1|0)|0;j=j+1|0;if((j|0)==(d|0)){n=m;break}else k=m}}else n=h;h=f[a+32>>2]|0;if(!h)o=n;else{k=f[a+40>>2]|0;d=0;j=n;while(1){n=f[k+4+(d<<2)>>2]|0;b[j>>0]=24;i=j+1|0;m=n&255;if(n>>>0>127){l=i;p=m;q=n;r=((n|0)<0)<<31>>31;while(1){b[l>>0]=p|-128;n=q;q=l1c(q|0,r|0,7)|0;s=l+1|0;t=q&255;if(!(r>>>0>0|(r|0)==0&n>>>0>16383)){u=s;v=t;break}else{l=s;p=t;r=J}}}else{u=i;v=m}b[u>>0]=v;r=u+1|0;d=d+1|0;if((d|0)>=(h|0)){o=r;break}else j=r}}if(!(g&512))w=o;else{j=f[a+124>>2]|0;b[o>>0]=32;h=o+1|0;o=j&255;if(j>>>0>127){d=h;u=o;v=j;k=((j|0)<0)<<31>>31;while(1){b[d>>0]=u|-128;j=v;v=l1c(v|0,k|0,7)|0;r=d+1|0;p=v&255;if(!(k>>>0>0|(k|0)==0&j>>>0>16383)){x=r;y=p;break}else{d=r;u=p;k=J}}}else{x=h;y=o}b[x>>0]=y;w=x+1|0}if(!(g&1024))z=w;else{x=f[a+128>>2]|0;b[w>>0]=45;y=w+1|0;b[y>>0]=x;b[y+1>>0]=x>>8;b[y+2>>0]=x>>16;b[y+3>>0]=x>>24;z=w+5|0}if(!(g&2048))A=z;else{w=f[a+132>>2]|0;b[z>>0]=48;x=z+1|0;z=w&255;if(w>>>0>127){y=x;o=z;h=w;k=((w|0)<0)<<31>>31;while(1){b[y>>0]=o|-128;w=h;h=l1c(h|0,k|0,7)|0;u=y+1|0;d=h&255;if(!(k>>>0>0|(k|0)==0&w>>>0>16383)){B=u;C=d;break}else{y=u;o=d;k=J}}}else{B=x;C=z}b[B>>0]=C;A=B+1|0}if(!(g&4096))D=A;else{B=f[a+136>>2]|0;b[A>>0]=56;C=A+1|0;A=B&255;if(B>>>0>127){z=C;x=A;k=B;o=((B|0)<0)<<31>>31;while(1){b[z>>0]=x|-128;B=k;k=l1c(k|0,o|0,7)|0;y=z+1|0;h=k&255;if(!(o>>>0>0|(o|0)==0&B>>>0>16383)){E=y;F=h;break}else{z=y;x=h;o=J}}}else{E=C;F=A}b[E>>0]=F;D=E+1|0}if(!(g&2))G=D;else{E=f[a+92>>2]|0;b[D>>0]=66;G=gZb(E,D+1|0)|0}if(!(g&8192))H=G;else{D=f[a+140>>2]|0;b[G>>0]=77;E=G+1|0;b[E>>0]=D;b[E+1>>0]=D>>8;b[E+2>>0]=D>>16;b[E+3>>0]=D>>24;H=G+5|0}if(!(g&16384))I=H;else{G=f[a+144>>2]|0;b[H>>0]=85;D=H+1|0;b[D>>0]=G;b[D+1>>0]=G>>8;b[D+2>>0]=G>>16;b[D+3>>0]=G>>24;I=H+5|0}if(!(g&32768))K=I;else{H=f[a+148>>2]|0;b[I>>0]=93;G=I+1|0;b[G>>0]=H;b[G+1>>0]=H>>8;b[G+2>>0]=H>>16;b[G+3>>0]=H>>24;K=I+5|0}if(!(g&65536))L=K;else{I=f[a+152>>2]|0;b[K>>0]=101;H=K+1|0;b[H>>0]=I;b[H+1>>0]=I>>8;b[H+2>>0]=I>>16;b[H+3>>0]=I>>24;L=K+5|0}if(!(g&131072))M=L;else{K=f[a+156>>2]|0;b[L>>0]=104;I=L+1|0;L=K&255;if(K>>>0>127){H=I;G=L;D=K;E=((K|0)<0)<<31>>31;while(1){b[H>>0]=G|-128;K=D;D=l1c(D|0,E|0,7)|0;F=H+1|0;A=D&255;if(!(E>>>0>0|(E|0)==0&K>>>0>16383)){N=F;O=A;break}else{H=F;G=A;E=J}}}else{N=I;O=L}b[N>>0]=O;M=N+1|0}if(!(g&262144))P=M;else{N=f[a+160>>2]|0;b[M>>0]=112;O=M+1|0;M=N&255;if(N>>>0>127){L=O;I=M;E=N;G=((N|0)<0)<<31>>31;while(1){b[L>>0]=I|-128;N=E;E=l1c(E|0,G|0,7)|0;H=L+1|0;D=E&255;if(!(G>>>0>0|(G|0)==0&N>>>0>16383)){Q=H;R=D;break}else{L=H;I=D;G=J}}}else{Q=O;R=M}b[Q>>0]=R;P=Q+1|0}if(!(g&4))S=P;else{Q=f[a+96>>2]|0;b[P>>0]=122;S=gZb(Q,P+1|0)|0}if(!(g&2097152))T=S;else{P=b[a+169>>0]|0;b[S>>0]=-128;b[S+1>>0]=1;b[S+2>>0]=P;T=S+3|0}if(!(g&67108864))U=T;else{S=f[a+192>>2]|0;b[T>>0]=-120;b[T+1>>0]=1;P=T+2|0;T=S&255;if(S>>>0>127){Q=P;R=T;M=S;O=((S|0)<0)<<31>>31;while(1){b[Q>>0]=R|-128;S=M;M=l1c(M|0,O|0,7)|0;G=Q+1|0;I=M&255;if(!(O>>>0>0|(O|0)==0&S>>>0>16383)){V=G;W=I;break}else{Q=G;R=I;O=J}}}else{V=P;W=T}b[V>>0]=W;U=V+1|0}if(!(g&524288))X=U;else{V=f[a+164>>2]|0;b[U>>0]=-112;b[U+1>>0]=1;W=U+2|0;U=V&255;if(V>>>0>127){T=W;P=U;O=V;R=((V|0)<0)<<31>>31;while(1){b[T>>0]=P|-128;V=O;O=l1c(O|0,R|0,7)|0;Q=T+1|0;M=O&255;if(!(R>>>0>0|(R|0)==0&V>>>0>16383)){Y=Q;Z=M;break}else{T=Q;P=M;R=J}}}else{Y=W;Z=U}b[Y>>0]=Z;X=Y+1|0}if(!(g&1048576))_=X;else{Y=b[a+168>>0]|0;b[X>>0]=-104;b[X+1>>0]=1;b[X+2>>0]=Y;_=X+3|0}if(!(g&33554432))$=_;else{X=a+184|0;Y=f[X>>2]|0;Z=f[X+4>>2]|0;b[_>>0]=-96;b[_+1>>0]=1;X=_+2|0;_=Y&255;if(Z>>>0>0|(Z|0)==0&Y>>>0>127){U=X;W=_;R=Y;Y=Z;while(1){b[U>>0]=W|-128;Z=R;R=l1c(R|0,Y|0,7)|0;P=U+1|0;T=R&255;if(!(Y>>>0>0|(Y|0)==0&Z>>>0>16383)){aa=P;ba=T;break}else{U=P;W=T;Y=J}}}else{aa=X;ba=_}b[aa>>0]=ba;$=aa+1|0}if(!(g&64))ca=$;else{aa=f[a+112>>2]|0;b[$>>0]=-86;b[$+1>>0]=1;ba=$+2|0;$=_i[f[(f[aa>>2]|0)+60>>2]&2047](aa)|0;if($>>>0>127){_=$;X=ba;while(1){b[X>>0]=_|128;Y=_>>>7;W=X+1|0;if(_>>>0>16383){_=Y;X=W}else{da=W;ea=Y;break}}}else{da=ba;ea=$}b[da>>0]=ea;ca=hj[f[(f[aa>>2]|0)+64>>2]&511](aa,c,da+1|0)|0}da=f[a+48>>2]|0;if(!da)fa=ca;else{aa=a+56|0;ea=0;$=ca;while(1){ca=f[(f[aa>>2]|0)+4+(ea<<2)>>2]|0;b[$>>0]=-78;b[$+1>>0]=1;ba=$+2|0;X=_i[f[(f[ca>>2]|0)+60>>2]&2047](ca)|0;if(X>>>0>127){_=X;Y=ba;while(1){b[Y>>0]=_|128;W=_>>>7;U=Y+1|0;if(_>>>0>16383){_=W;Y=U}else{ga=U;ha=W;break}}}else{ga=ba;ha=X}b[ga>>0]=ha;Y=hj[f[(f[ca>>2]|0)+64>>2]&511](ca,c,ga+1|0)|0;ea=ea+1|0;if((ea|0)==(da|0)){fa=Y;break}else $=Y}}if(!(g&4194304))ia=fa;else{$=b[a+170>>0]|0;b[fa>>0]=-72;b[fa+1>>0]=1;b[fa+2>>0]=$;ia=fa+3|0}if(!(g&8))ja=ia;else{fa=f[a+100>>2]|0;b[ia>>0]=-62;b[ia+1>>0]=1;ja=gZb(fa,ia+2|0)|0}if(!(g&128))ka=ja;else{ia=f[a+116>>2]|0;b[ja>>0]=-54;b[ja+1>>0]=1;fa=ja+2|0;ja=_i[f[(f[ia>>2]|0)+60>>2]&2047](ia)|0;if(ja>>>0>127){$=ja;da=fa;while(1){b[da>>0]=$|128;ea=$>>>7;ga=da+1|0;if($>>>0>16383){$=ea;da=ga}else{la=ga;ma=ea;break}}}else{la=fa;ma=ja}b[la>>0]=ma;ka=hj[f[(f[ia>>2]|0)+64>>2]&511](ia,c,la+1|0)|0}if(!(g&256))na=ka;else{la=f[a+120>>2]|0;b[ka>>0]=-46;b[ka+1>>0]=1;ia=ka+2|0;ka=_i[f[(f[la>>2]|0)+60>>2]&2047](la)|0;if(ka>>>0>127){ma=ka;ja=ia;while(1){b[ja>>0]=ma|128;fa=ma>>>7;da=ja+1|0;if(ma>>>0>16383){ma=fa;ja=da}else{oa=da;pa=fa;break}}}else{oa=ia;pa=ka}b[oa>>0]=pa;na=hj[f[(f[la>>2]|0)+64>>2]&511](la,c,oa+1|0)|0}oa=f[a+64>>2]|0;if(!oa)qa=na;else{la=a+72|0;pa=0;ka=na;while(1){na=f[(f[la>>2]|0)+4+(pa<<2)>>2]|0;b[ka>>0]=-38;b[ka+1>>0]=1;ia=ka+2|0;ja=_i[f[(f[na>>2]|0)+60>>2]&2047](na)|0;if(ja>>>0>127){ma=ja;fa=ia;while(1){b[fa>>0]=ma|128;da=ma>>>7;$=fa+1|0;if(ma>>>0>16383){ma=da;fa=$}else{ra=$;sa=da;break}}}else{ra=ia;sa=ja}b[ra>>0]=sa;fa=hj[f[(f[na>>2]|0)+64>>2]&511](na,c,ra+1|0)|0;pa=pa+1|0;if((pa|0)==(oa|0)){qa=fa;break}else ka=fa}}if(!(g&268435456))ta=qa;else{ka=b[a+197>>0]|0;b[qa>>0]=-32;b[qa+1>>0]=1;b[qa+2>>0]=ka;ta=qa+3|0}if(!(g&16))ua=ta;else{qa=f[a+104>>2]|0;b[ta>>0]=-22;b[ta+1>>0]=1;ua=gZb(qa,ta+2|0)|0}if(!(g&8388608))va=ua;else{ta=f[a+172>>2]|0;b[ua>>0]=-16;b[ua+1>>0]=1;qa=ua+2|0;ua=ta&255;if(ta>>>0>127){ka=qa;oa=ua;pa=ta;ra=((ta|0)<0)<<31>>31;while(1){b[ka>>0]=oa|-128;ta=pa;pa=l1c(pa|0,ra|0,7)|0;c=ka+1|0;sa=pa&255;if(!(ra>>>0>0|(ra|0)==0&ta>>>0>16383)){wa=c;xa=sa;break}else{ka=c;oa=sa;ra=J}}}else{wa=qa;xa=ua}b[wa>>0]=xa;va=wa+1|0}if(!(g&536870912))ya=va;else{wa=f[a+200>>2]|0;b[va>>0]=-3;b[va+1>>0]=1;xa=va+2|0;b[xa>>0]=wa;b[xa+1>>0]=wa>>8;b[xa+2>>0]=wa>>16;b[xa+3>>0]=wa>>24;ya=va+6|0}if(!(g&134217728))za=ya;else{va=b[a+196>>0]|0;b[ya>>0]=-128;b[ya+1>>0]=2;b[ya+2>>0]=va;za=ya+3|0}if(!(g&1073741824))Aa=za;else{ya=f[a+204>>2]|0;b[za>>0]=-120;b[za+1>>0]=2;va=za+2|0;za=ya&255;if(ya>>>0>127){wa=va;xa=za;ua=ya;qa=((ya|0)<0)<<31>>31;while(1){b[wa>>0]=xa|-128;ya=ua;ua=l1c(ua|0,qa|0,7)|0;ra=wa+1|0;oa=ua&255;if(!(qa>>>0>0|(qa|0)==0&ya>>>0>16383)){Ba=ra;Ca=oa;break}else{wa=ra;xa=oa;qa=J}}}else{Ba=va;Ca=za}b[Ba>>0]=Ca;Aa=Ba+1|0}Ba=f[a+76>>2]|0;if(!Ba)Da=Aa;else{Ca=f[a+84>>2]|0;za=0;va=Aa;while(1){Aa=f[Ca+4+(za<<2)>>2]|0;b[va>>0]=-112;b[va+1>>0]=2;qa=va+2|0;xa=Aa&255;if(Aa>>>0>127){wa=qa;ua=xa;oa=Aa;ra=((Aa|0)<0)<<31>>31;while(1){b[wa>>0]=ua|-128;Aa=oa;oa=l1c(oa|0,ra|0,7)|0;ya=wa+1|0;ka=oa&255;if(!(ra>>>0>0|(ra|0)==0&Aa>>>0>16383)){Ea=ya;Fa=ka;break}else{wa=ya;ua=ka;ra=J}}}else{Ea=qa;Fa=xa}b[Ea>>0]=Fa;ra=Ea+1|0;za=za+1|0;if((za|0)>=(Ba|0)){Da=ra;break}else va=ra}}if((g|0)<0){g=f[a+208>>2]|0;b[Da>>0]=-99;b[Da+1>>0]=2;va=Da+2|0;b[va>>0]=g;b[va+1>>0]=g>>8;b[va+2>>0]=g>>16;b[va+3>>0]=g>>24;Ga=Da+6|0}else Ga=Da;Da=f[a+12>>2]|0;if(!(Da&1))Ha=Ga;else{g=f[a+212>>2]|0;b[Ga>>0]=-96;b[Ga+1>>0]=2;va=Ga+2|0;Ga=g&255;if(g>>>0>127){Ba=va;za=Ga;Ea=g;Fa=((g|0)<0)<<31>>31;while(1){b[Ba>>0]=za|-128;g=Ea;Ea=l1c(Ea|0,Fa|0,7)|0;Ca=Ba+1|0;ra=Ea&255;if(!(Fa>>>0>0|(Fa|0)==0&g>>>0>16383)){Ia=Ca;Ja=ra;break}else{Ba=Ca;za=ra;Fa=J}}}else{Ia=va;Ja=Ga}b[Ia>>0]=Ja;Ha=Ia+1|0}if(!(Da&2))Ka=Ha;else{Ia=f[a+216>>2]|0;b[Ha>>0]=-88;b[Ha+1>>0]=2;Ja=Ha+2|0;Ha=Ia&255;if(Ia>>>0>127){Ga=Ja;va=Ha;Fa=Ia;za=((Ia|0)<0)<<31>>31;while(1){b[Ga>>0]=va|-128;Ia=Fa;Fa=l1c(Fa|0,za|0,7)|0;Ba=Ga+1|0;Ea=Fa&255;if(!(za>>>0>0|(za|0)==0&Ia>>>0>16383)){La=Ba;Ma=Ea;break}else{Ga=Ba;va=Ea;za=J}}}else{La=Ja;Ma=Ha}b[La>>0]=Ma;Ka=La+1|0}if(!(Da&4))Na=Ka;else{Da=f[a+220>>2]|0;b[Ka>>0]=-75;b[Ka+1>>0]=2;La=Ka+2|0;b[La>>0]=Da;b[La+1>>0]=Da>>8;b[La+2>>0]=Da>>16;b[La+3>>0]=Da>>24;Na=Ka+6|0}Ka=f[e>>2]|0;if(!(Ka&16777216))Oa=Na;else{e=f[a+176>>2]|0;b[Na>>0]=-67;b[Na+1>>0]=2;Da=Na+2|0;b[Da>>0]=e;b[Da+1>>0]=e>>8;b[Da+2>>0]=e>>16;b[Da+3>>0]=e>>24;Oa=Na+6|0}if(!(Ka&32))Pa=Oa;else{Ka=f[a+108>>2]|0;b[Oa>>0]=-62;b[Oa+1>>0]=2;Pa=gZb(Ka,Oa+2|0)|0}Oa=f[a+4>>2]|0;if(!(Oa&1)){Qa=Pa;return Qa|0}Qa=Pqc(Oa&-2,Pa)|0;return Qa|0}function Djb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;wjb(a);c=kZc(b,21568,16736,0)|0;if(!c){Ooc(b,a);return}else{Hjb(a,c);return}}function Ejb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16736,0)|0;if(!c){Ooc(b,a);return}else{Hjb(a,c);return}}function Fjb(a,b){a=a|0;b=b|0;f[a+224>>2]=b;return}function Gjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535328;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Hjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}vSa(a+16|0,c+16|0);e=a+32|0;h=c+32|0;g=f[h>>2]|0;if(g|0){qHa(e,(f[e>>2]|0)+g|0);o1c((f[a+40>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+40>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}Ijb(a+44|0,c+44|0);Jjb(a+60|0,c+60|0);h=a+76|0;e=c+76|0;g=f[e>>2]|0;if(g|0){qHa(h,(f[h>>2]|0)+g|0);o1c((f[a+84>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+88|0,g=f[c+88>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+92|0,d=f[c+92>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==537368){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+96|0,h=f[c+96>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==537368){mHa(d,h);break}else{oYc(g,h)|0;break}while(0);do if(e&8|0?(h=a+8|0,f[h>>2]=f[h>>2]|8,h=a+100|0,g=f[c+100>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&16|0?(g=a+8|0,f[g>>2]=f[g>>2]|16,g=a+104|0,d=f[c+104>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==535184){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);do if(e&32|0?(d=a+8|0,f[d>>2]=f[d>>2]|32,d=a+108|0,h=f[c+108>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==535200){mHa(d,h);break}else{oYc(g,h)|0;break}while(0);if(e&64|0){h=a+8|0;f[h>>2]=f[h>>2]|64;h=a+112|0;g=f[h>>2]|0;if(!g){d=$Xc(104)|0;Kjb(d);f[h>>2]=d;i=d}else i=g;g=f[c+112>>2]|0;Ljb(i,g|0?g:531824)}if(e&128|0){g=a+8|0;f[g>>2]=f[g>>2]|128;g=a+116|0;i=f[g>>2]|0;if(!i){d=$Xc(104)|0;Kjb(d);f[g>>2]=d;j=d}else j=i;i=f[c+116>>2]|0;Ljb(j,i|0?i:531824)}}if(e&65280|0){if(e&256|0){i=a+8|0;f[i>>2]=f[i>>2]|256;i=a+120|0;j=f[i>>2]|0;if(!j){d=$Xc(40)|0;_ib(d);f[i>>2]=d;k=d}else k=j;j=f[c+120>>2]|0;d=j|0?j:532208;j=k+4|0;i=f[d+4>>2]|0;if(i&1|0){g=f[j>>2]|0;if(!(g&1))l=lSa(j)|0;else l=g&-2;vqc(l,i&-2)}vSa(k+16|0,d+16|0);i=f[d+8>>2]|0;if(i&3|0){if(i&1|0)f[k+32>>2]=f[d+32>>2];if(i&2|0)f[k+36>>2]=f[d+36>>2];d=k+8|0;f[d>>2]=f[d>>2]|i}}if(e&512|0)f[a+124>>2]=f[c+124>>2];if(e&1024|0)f[a+128>>2]=f[c+128>>2];if(e&2048|0)f[a+132>>2]=f[c+132>>2];if(e&4096|0)f[a+136>>2]=f[c+136>>2];if(e&8192|0)f[a+140>>2]=f[c+140>>2];if(e&16384|0)f[a+144>>2]=f[c+144>>2];if(e&32768|0)f[a+148>>2]=f[c+148>>2];i=a+8|0;f[i>>2]=f[i>>2]|e}if(e&16711680|0){if(e&65536|0)f[a+152>>2]=f[c+152>>2];if(e&131072|0)f[a+156>>2]=f[c+156>>2];if(e&262144|0)f[a+160>>2]=f[c+160>>2];if(e&524288|0)f[a+164>>2]=f[c+164>>2];if(e&1048576|0)b[a+168>>0]=b[c+168>>0]|0;if(e&2097152|0)b[a+169>>0]=b[c+169>>0]|0;if(e&4194304|0)b[a+170>>0]=b[c+170>>0]|0;if(e&8388608|0)f[a+172>>2]=f[c+172>>2];i=a+8|0;f[i>>2]=f[i>>2]|e}if(e>>>0>16777215){if(e&16777216|0)f[a+176>>2]=f[c+176>>2];if(e&33554432|0){i=c+184|0;d=f[i+4>>2]|0;k=a+184|0;f[k>>2]=f[i>>2];f[k+4>>2]=d}if(e&67108864|0)f[a+192>>2]=f[c+192>>2];if(e&134217728|0)b[a+196>>0]=b[c+196>>0]|0;if(e&268435456|0)b[a+197>>0]=b[c+197>>0]|0;if(e&536870912|0)f[a+200>>2]=f[c+200>>2];if(e&1073741824|0)f[a+204>>2]=f[c+204>>2];if((e|0)<0)f[a+208>>2]=f[c+208>>2];d=a+8|0;f[d>>2]=f[d>>2]|e}e=f[c+12>>2]|0;if(!(e&7))return;if(e&1|0)f[a+212>>2]=f[c+212>>2];if(e&2|0)f[a+216>>2]=f[c+216>>2];if(e&4|0)f[a+220>>2]=f[c+220>>2];c=a+12|0;f[c>>2]=f[c>>2]|e;return}function Ijb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{hkb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(104)|0;Kjb(l);hkb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16752,104);l=RXb(i,104,2255)|0;Kjb(l);hkb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Jjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{fkb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(40)|0;_ib(l);fkb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16704,40);l=RXb(i,40,2256)|0;_ib(l);fkb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Kjb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;e=c;f[a>>2]=98968;f[a+4>>2]=0;f[a+8>>2]=0;g=(a|0)==531824;h=a+16|0;i=h+76|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));if(!g?(f[223082]|0)!=2:0){f[e>>2]=165456;f[e+4>>2]=32;b[e+8>>0]=0;J_b(892328,e);a_b(e)}f[a+12>>2]=0;f[a+92>>2]=537368;e=a+96|0;f[e>>2]=0;d[e+4>>1]=0;u=c;return}function Ljb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}Mjb(a+16|0,c+16|0);vSa(a+32|0,c+32|0);e=a+48|0;h=c+48|0;g=f[h>>2]|0;if(g|0){qHa(e,(f[e>>2]|0)+g|0);o1c((f[a+56>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+56>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}e5a(a+60|0,c+60|0);Njb(a+76|0,c+76|0);h=f[c+8>>2]|0;if(!(h&15))return;do if(h&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+92|0,g=f[c+92>>2]|0,d=f[e>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(e,g);break}else{oYc(d,g)|0;break}while(0);if(h&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+96|0;d=f[g>>2]|0;if(!d){e=$Xc(40)|0;_ib(e);f[g>>2]=e;i=e}else i=d;d=f[c+96>>2]|0;e=d|0?d:532208;d=i+4|0;g=f[e+4>>2]|0;if(g&1|0){j=f[d>>2]|0;if(!(j&1))k=lSa(d)|0;else k=j&-2;vqc(k,g&-2)}vSa(i+16|0,e+16|0);g=f[e+8>>2]|0;if(g&3|0){if(g&1|0)f[i+32>>2]=f[e+32>>2];if(g&2|0)f[i+36>>2]=f[e+36>>2];e=i+8|0;f[e>>2]=f[e>>2]|g}}if(h&4|0)b[a+100>>0]=b[c+100>>0]|0;if(h&8|0)b[a+101>>0]=b[c+101>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|h;return}function Mjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Pjb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(296)|0;Iab(l);Pjb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15824,296);l=RXb(i,296,2232)|0;Iab(l);Pjb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Njb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Ojb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(368)|0;Gib(l);Ojb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16608,368);l=RXb(i,368,2235)|0;Gib(l);Ojb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Ojb(a,b){a=a|0;b=b|0;Vgb(b,a);return}function Pjb(a,b){a=a|0;b=b|0;L0a(b,a);return}function Qjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=98968;c=f[a+92>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=531824?(c=f[a+96>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=a+88|0;d=f[c>>2]|0;if(d|0?(f[a+76>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+72|0;i=f[c>>2]|0;if(i|0?(f[a+60>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+44|0;j=f[c>>2]|0;if(j|0?(f[a+32>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+28|0;k=f[c>>2]|0;if(k|0?(f[a+16>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;cYc(l)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}l=a&-2;a=l;if((l|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(l);f[c>>2]=0;return}function Rjb(a){a=a|0;Qjb(a);cYc(a);return}function Sjb(a){a=a|0;a=$Xc(104)|0;Kjb(a);return a|0}function Tjb(a,b){a=a|0;b=b|0;a=$Xc(104)|0;Kjb(a);if(!b)return a|0;ekb(b,a);return a|0}function Ujb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+20|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{A0a(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[c>>2]=0}c=a+36|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+44>>2]|0;g=0;do{i=f[h+4+(g<<2)>>2]|0;g=g+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((g|0)!=(e|0));f[c>>2]=0}f[a+48>>2]=0;c=a+64|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+72>>2]|0;h=0;do{j=f[g+4+(h<<2)>>2]|0;h=h+1|0;f[j+16>>2]=0;f[j+8>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)sqc(j)}while((h|0)!=(e|0));f[c>>2]=0}c=a+80|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+88>>2]|0;g=0;do{Kgb(f[h+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(e|0));f[c>>2]=0}c=a+8|0;e=f[c>>2]|0;if(e&3|0){do if(e&1|0){g=f[a+92>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&2|0){e=f[a+96>>2]|0;h=e+20|0;g=f[h>>2]|0;if((g|0)>0){j=f[e+28>>2]|0;i=0;do{k=f[j+4+(i<<2)>>2]|0;i=i+1|0;l=k+11|0;if((b[l>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0}else{b[k>>0]=0;b[l>>0]=0}}while((i|0)!=(g|0));f[h>>2]=0}h=e+8|0;if(f[h>>2]&3|0){f[e+32>>2]=0;f[e+36>>2]=1}f[h>>2]=0;h=f[e+4>>2]|0;if(h&1|0?(e=h&-2,f[e>>2]|0):0)sqc(e)}}d[a+100>>1]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Vjb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+80>>2]|0;if((b|0)<=0){c=1;return c|0}d=f[a+88>>2]|0;a=b;while(1){b=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;if(f[e+12>>2]&4194304|0?(f[(f[e+352>>2]|0)+8>>2]&7|0)!=7:0){c=0;g=6;break}if((b|0)<=1){c=1;g=6;break}}if((g|0)==6)return c|0;return 0}function Wjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+92|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=e+4|0;p=a+32|0;q=a+48|0;r=a+52|0;s=a+56|0;t=a+100|0;v=e+8|0;w=a+96|0;x=e+4|0;y=a+101|0;z=e+8|0;A=a+60|0;B=e+4|0;C=a+76|0;D=a+88|0;E=a+84|0;F=a+80|0;G=e+4|0;H=a+4|0;a:while(1){a=f[c>>2]|0;I=f[g>>2]|0;do if(a>>>0<I>>>0){K=b[a>>0]|0;L=K&255;M=a+1|0;if(K<<24>>24>0){N=M;O=L}else{if(M>>>0>=I>>>0){P=L;Q=7;break}K=h[M>>0]|0;if(((K^128)&L)>>>0<=127){P=L;Q=7;break}N=a+2|0;O=L+-128+(K<<7)|0}f[c>>2]=N;R=O;Q=9}else{P=0;Q=7}while(0);if((Q|0)==7){Q=0;a=ZYb(c,P)|0;if((a+-1|0)>>>0<16383){R=a;Q=9}else S=a}b:do if((Q|0)==9){Q=0;switch(R>>>3&536870911|0){case 1:{if((R&255|0)!=10){S=R;break b}f[i>>2]=f[i>>2]|1;a=f[j>>2]|0;if((a|0)==537368){mHa(j,537368);T=f[j>>2]|0}else T=a;if(l$b(c,T)|0)continue a;else{U=0;Q=112;break a}break}case 2:{if((R&255|0)!=18){S=R;break b}a=f[l>>2]|0;do if(a){I=f[n>>2]|0;K=f[a>>2]|0;if((I|0)>=(K|0))if((K|0)==(f[m>>2]|0)){V=K;Q=20;break}else{W=K;X=a;Q=21;break}else{f[n>>2]=I+1;Y=f[a+4+(I<<2)>>2]|0;break}}else{V=f[m>>2]|0;Q=20}while(0);if((Q|0)==20){Q=0;XZb(k,V+1|0);a=f[l>>2]|0;W=f[a>>2]|0;X=a;Q=21}if((Q|0)==21){Q=0;f[X>>2]=W+1;a=f[k>>2]|0;if(!a){I=$Xc(296)|0;Iab(I);Z=I}else{if(f[a+64>>2]|0)SXb(a,15824,296);I=RXb(a,296,2232)|0;Iab(I);Z=I}I=f[l>>2]|0;a=f[n>>2]|0;f[n>>2]=a+1;f[I+4+(a<<2)>>2]=Z;Y=Z}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(I=b[a>>0]|0,I<<24>>24>-1):0){f[c>>2]=a+1;_=I&255}else{I=YYb(c)|0;if((I|0)>-1)_=I;else{U=0;Q=112;break a}}JYb(e,c,_);if((f[o>>2]|0)<0){Q=33;break a}if(!(Mi[f[(f[Y>>2]|0)+44>>2]&1023](Y,c)|0)){Q=33;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}case 3:{if((R&255|0)!=26){S=R;break b}if(l$b(c,pHa(p)|0)|0)continue a;else{U=0;Q=112;break a}break}case 4:{switch((R&255)<<24>>24){case 32:break;case 34:{if(dkb(c,q)|0)continue a;else{U=0;Q=112;break a}break}default:{S=R;break b}}I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0){a=b[I>>0]|0;K=a&255;if(a<<24>>24>-1){f[c>>2]=I+1;$=K}else{aa=K;Q=41}}else{aa=0;Q=41}if((Q|0)==41){Q=0;K=KYb(c,aa)|0;I=J;if((I|0)>-1|(I|0)==-1&K>>>0>4294967295)$=K;else{U=0;Q=112;break a}}K=f[q>>2]|0;if((K|0)==(f[r>>2]|0)){qHa(q,K+1|0);ba=f[q>>2]|0}else ba=K;K=f[s>>2]|0;f[q>>2]=ba+1;f[K+4+(ba<<2)>>2]=$;I=(f[r>>2]|0)-(f[q>>2]|0)|0;if((I|0)>0){ca=I;da=K}else continue a;while(1){K=f[c>>2]|0;I=f[g>>2]|0;if(K>>>0>=I>>>0)continue a;if((b[K>>0]|0)!=32)continue a;a=K+1|0;f[c>>2]=a;if(a>>>0<I>>>0){I=b[a>>0]|0;a=I&255;if(I<<24>>24>-1){f[c>>2]=K+2;ea=a;fa=da}else{ga=a;Q=49}}else{ga=0;Q=49}if((Q|0)==49){Q=0;a=KYb(c,ga)|0;K=J;if(!((K|0)>-1|(K|0)==-1&a>>>0>4294967295)){U=0;Q=112;break a}ea=a;fa=f[s>>2]|0}a=f[q>>2]|0;f[q>>2]=a+1;f[fa+4+(a<<2)>>2]=ea;if((ca|0)>1){ca=ca+-1|0;da=fa}else continue a}break}case 5:{if((R&255|0)!=40){S=R;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(K=b[a>>0]|0,K<<24>>24>-1):0){f[c>>2]=a+1;ha=K<<24>>24!=0}else{LYb(e,c);K=e;if(!(b[v>>0]|0)){U=0;Q=112;break a}else ha=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[t>>0]=ha&1;continue a;break}case 6:{if((R&255|0)!=50){S=R;break b}f[i>>2]=f[i>>2]|2;K=f[w>>2]|0;if(!K){a=$Xc(40)|0;_ib(a);f[w>>2]=a;ia=a}else ia=K;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(a=b[K>>0]|0,a<<24>>24>-1):0){f[c>>2]=K+1;ja=a&255}else{a=YYb(c)|0;if((a|0)>-1)ja=a;else{U=0;Q=112;break a}}JYb(e,c,ja);if((f[x>>2]|0)<0){Q=69;break a}if(!(Mi[f[(f[ia>>2]|0)+44>>2]&1023](ia,c)|0)){Q=69;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}case 7:{if((R&255|0)!=56){S=R;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(K=b[a>>0]|0,K<<24>>24>-1):0){f[c>>2]=a+1;ka=K<<24>>24!=0}else{LYb(e,c);K=e;if(!(b[z>>0]|0)){U=0;Q=112;break a}else ka=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0}b[y>>0]=ka&1;continue a;break}case 8:{if((R&255|0)!=66){S=R;break b}K=y5a(A)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(I=b[a>>0]|0,I<<24>>24>-1):0){f[c>>2]=a+1;la=I&255}else{I=YYb(c)|0;if((I|0)>-1)la=I;else{U=0;Q=112;break a}}JYb(e,c,la);if((f[B>>2]|0)<0){Q=84;break a}if(!(Mi[f[(f[K>>2]|0)+44>>2]&1023](K,c)|0)){Q=84;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}case 100:{if((R&255|0)!=34){S=R;break b}K=f[D>>2]|0;do if(K){I=f[F>>2]|0;a=f[K>>2]|0;if((I|0)>=(a|0))if((a|0)==(f[E>>2]|0)){ma=a;Q=92;break}else{na=a;oa=K;Q=93;break}else{f[F>>2]=I+1;pa=f[K+4+(I<<2)>>2]|0;break}}else{ma=f[E>>2]|0;Q=92}while(0);if((Q|0)==92){Q=0;XZb(C,ma+1|0);K=f[D>>2]|0;na=f[K>>2]|0;oa=K;Q=93}if((Q|0)==93){Q=0;f[oa>>2]=na+1;K=f[C>>2]|0;if(!K){I=$Xc(368)|0;Gib(I);qa=I}else{if(f[K+64>>2]|0)SXb(K,16608,368);I=RXb(K,368,2235)|0;Gib(I);qa=I}I=f[D>>2]|0;K=f[F>>2]|0;f[F>>2]=K+1;f[I+4+(K<<2)>>2]=qa;pa=qa}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(I=b[K>>0]|0,I<<24>>24>-1):0){f[c>>2]=K+1;ra=I&255}else{I=YYb(c)|0;if((I|0)>-1)ra=I;else{U=0;Q=112;break a}}JYb(e,c,ra);if((f[G>>2]|0)<0){Q=105;break a}if(!(Mi[f[(f[pa>>2]|0)+44>>2]&1023](pa,c)|0)){Q=105;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;Q=112;break a}break}default:{S=R;break b}}}while(0);if(!S){U=1;Q=112;break}I=f[H>>2]|0;if(!(I&1))sa=lSa(H)|0;else sa=I&-2;if(!(Lqc(c,S,sa)|0)){U=0;Q=112;break}}if((Q|0)==33){U=0;u=d;return U|0}else if((Q|0)==69){U=0;u=d;return U|0}else if((Q|0)==84){U=0;u=d;return U|0}else if((Q|0)==105){U=0;u=d;return U|0}else if((Q|0)==112){u=d;return U|0}return 0}function Xjb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if((i|0)>0){g=f[a+44>>2]|0;h=0;d=c;while(1){e=f[g+4+(h<<2)>>2]|0;j=b[e+11>>0]|0;k=j<<24>>24<0?f[e+4>>2]|0:j&255;j=k+d+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){l=j;break}else d=j}}else l=c;c=n$b(a+48|0)|0;d=f[a+64>>2]|0;i=c+l+(f[a+48>>2]|0)+d|0;if(!d)m=i;else{l=a+72|0;c=0;h=i;while(1){i=f[(f[l>>2]|0)+4+(c<<2)>>2]|0;g=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=g+h+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(d|0)){m=i;break}else h=i}}h=f[a+80>>2]|0;d=(h<<1)+m|0;if(!h)n=d;else{m=a+88|0;c=0;l=d;while(1){d=f[(f[m>>2]|0)+4+(c<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=i+l+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(h|0)){n=d;break}else l=d}}l=a+8|0;h=f[l>>2]|0;if(!(h&15)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(h&1))q=n;else{c=f[a+92>>2]|0;m=b[c+11>>0]|0;d=m<<24>>24<0?f[c+4>>2]|0:m&255;q=n+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(h&2)){r=q;s=h}else{h=f[a+96>>2]|0;d=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;h=q+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=h;s=f[l>>2]|0}l=s&4|0?r+2|0:r;o=s&8|0?l+2|0:l;p=a+12|0;f[p>>2]=o;return o|0}function Yjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+92>>2]|0,c);e=f[a+20>>2]|0;if(e|0){g=a+28|0;h=0;do{k$b(2,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+36>>2]|0;if((e|0)>0){h=a+44|0;g=0;do{e$b(3,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}e=f[a+48>>2]|0;if((e|0)>0){g=a+56|0;h=0;do{S_b(4,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}if(d&4|0)c$b(5,(b[a+100>>0]|0)!=0,c);if(d&2|0)k$b(6,f[a+96>>2]|0,c);if(d&8|0)c$b(7,(b[a+101>>0]|0)!=0,c);d=f[a+64>>2]|0;if(d|0){e=a+72|0;h=0;do{k$b(8,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(d|0))}d=f[a+80>>2]|0;if(d|0){h=a+88|0;e=0;do{k$b(100,f[(f[h>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function Zjb(a){a=a|0;return f[a+12>>2]|0}function _jb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+92>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&2047](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}k=f[a+36>>2]|0;if((k|0)>0){d=a+44|0;j=0;r=i;while(1){s=f[(f[d>>2]|0)+4+(j<<2)>>2]|0;b[r>>0]=26;h=gZb(s,r+1|0)|0;j=j+1|0;if((j|0)==(k|0)){t=h;break}else r=h}}else t=i;i=f[a+48>>2]|0;if(!i)u=t;else{r=f[a+56>>2]|0;k=0;j=t;while(1){t=f[r+4+(k<<2)>>2]|0;b[j>>0]=32;d=j+1|0;h=t&255;if(t>>>0>127){s=d;o=h;n=t;p=((t|0)<0)<<31>>31;while(1){b[s>>0]=o|-128;t=n;n=l1c(n|0,p|0,7)|0;q=s+1|0;v=n&255;if(!(p>>>0>0|(p|0)==0&t>>>0>16383)){w=q;x=v;break}else{s=q;o=v;p=J}}}else{w=d;x=h}b[w>>0]=x;p=w+1|0;k=k+1|0;if((k|0)>=(i|0)){u=p;break}else j=p}}if(!(e&4))y=u;else{j=b[a+100>>0]|0;b[u>>0]=40;b[u+1>>0]=j;y=u+2|0}if(!(e&2))z=y;else{u=f[a+96>>2]|0;b[y>>0]=50;j=y+1|0;y=_i[f[(f[u>>2]|0)+60>>2]&2047](u)|0;if(y>>>0>127){i=y;k=j;while(1){b[k>>0]=i|128;w=i>>>7;x=k+1|0;if(i>>>0>16383){i=w;k=x}else{A=x;B=w;break}}}else{A=j;B=y}b[A>>0]=B;z=hj[f[(f[u>>2]|0)+64>>2]&511](u,c,A+1|0)|0}if(!(e&8))C=z;else{e=b[a+101>>0]|0;b[z>>0]=56;b[z+1>>0]=e;C=z+2|0}z=f[a+64>>2]|0;if(!z)D=C;else{e=a+72|0;A=0;u=C;while(1){C=f[(f[e>>2]|0)+4+(A<<2)>>2]|0;b[u>>0]=66;B=u+1|0;y=_i[f[(f[C>>2]|0)+60>>2]&2047](C)|0;if(y>>>0>127){j=y;k=B;while(1){b[k>>0]=j|128;i=j>>>7;w=k+1|0;if(j>>>0>16383){j=i;k=w}else{E=w;F=i;break}}}else{E=B;F=y}b[E>>0]=F;k=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,E+1|0)|0;A=A+1|0;if((A|0)==(z|0)){D=k;break}else u=k}}u=f[a+80>>2]|0;if(!u)G=D;else{z=a+88|0;A=0;E=D;while(1){D=f[(f[z>>2]|0)+4+(A<<2)>>2]|0;b[E>>0]=-94;b[E+1>>0]=6;F=E+2|0;e=_i[f[(f[D>>2]|0)+60>>2]&2047](D)|0;if(e>>>0>127){k=e;j=F;while(1){b[j>>0]=k|128;h=k>>>7;d=j+1|0;if(k>>>0>16383){k=h;j=d}else{H=d;I=h;break}}}else{H=F;I=e}b[H>>0]=I;j=hj[f[(f[D>>2]|0)+64>>2]&511](D,c,H+1|0)|0;A=A+1|0;if((A|0)==(u|0)){G=j;break}else E=j}}E=f[a+4>>2]|0;if(!(E&1)){K=G;return K|0}K=Pqc(E&-2,G)|0;return K|0}function $jb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Ujb(a);c=kZc(b,21568,16752,0)|0;if(!c){Ooc(b,a);return}else{Ljb(a,c);return}}function akb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16752,0)|0;if(!c){Ooc(b,a);return}else{Ljb(a,c);return}}function bkb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ckb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535320;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function dkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;if(d>>>0<(f[e>>2]|0)>>>0?(g=b[d>>0]|0,g<<24>>24>-1):0){f[a>>2]=d+1;h=g&255}else{g=YYb(a)|0;if((g|0)>-1)h=g;else{i=0;return i|0}}g=HYb(a,h)|0;a:do if((PYb(a)|0)>0){h=c+4|0;d=c+8|0;while(1){j=f[a>>2]|0;if(j>>>0<(f[e>>2]|0)>>>0){k=b[j>>0]|0;l=k&255;if(k<<24>>24>-1){f[a>>2]=j+1;m=l}else{n=l;o=10}}else{n=0;o=10}if((o|0)==10){o=0;l=KYb(a,n)|0;j=J;if((j|0)>-1|(j|0)==-1&l>>>0>4294967295)m=l;else{i=0;break}}l=f[c>>2]|0;if((l|0)==(f[h>>2]|0)){qHa(c,l+1|0);p=f[c>>2]|0}else p=l;l=f[d>>2]|0;f[c>>2]=p+1;f[l+4+(p<<2)>>2]=m;if((PYb(a)|0)<=0)break a}return i|0}while(0);IYb(a,g);i=1;return i|0}function ekb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function fkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}vSa(b+16|0,a+16|0);d=f[a+8>>2]|0;if(!(d&3))return;if(d&1|0)f[b+32>>2]=f[a+32>>2];if(d&2|0)f[b+36>>2]=f[a+36>>2];a=b+8|0;f[a>>2]=f[a>>2]|d;return}function gkb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function hkb(a,b){a=a|0;b=b|0;Ljb(b,a);return}function ikb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function jkb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=98860;e=(a|0)==531928;g=a+4|0;h=g+84|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223083]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=33;b[d+8>>0]=0;J_b(892332,d);a_b(d)}f[a+88>>2]=537368;f[a+92>>2]=537368;f[a+96>>2]=537368;f[a+100>>2]=537368;f[a+104>>2]=535184;f[a+108>>2]=535200;g=a+112|0;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));n[a+176>>2]=.9990000128746033;g=a+184|0;f[g>>2]=-1;f[g+4>>2]=-1;f[a+192>>2]=1;b[a+196>>0]=1;b[a+197>>0]=1;n[a+200>>2]=9.99999993922529e-09;f[a+204>>2]=1;n[a+208>>2]=-1.0;f[a+212>>2]=1;f[a+216>>2]=1;n[a+220>>2]=.9900000095367432;f[a+224>>2]=0;u=c;return}function kkb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function lkb(a){a=a|0;var c=0;c=f[a+88>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+92>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+96>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+100>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+104>>2]|0;if(!((c|0)==535184|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+108>>2]|0;if(!((c|0)==535200|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==531928)return;c=f[a+112>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+116>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+120>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function mkb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function nkb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function okb(a){a=a|0;var c=0,d=0;f[a>>2]=99076;c=f[a+28>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function pkb(a){a=a|0;okb(a);cYc(a);return}function qkb(a){a=a|0;a=$Xc(52)|0;Ekb(a);return a|0}function rkb(a,b){a=a|0;b=b|0;a=$Xc(52)|0;Ekb(a);if(!b)return a|0;Fkb(b,a);return a|0}function skb(a){a=a|0;var c=0,d=0,e=0,g=0;f[a+16>>2]=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0){e=f[a+28>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&62|0){d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function tkb(a){a=a|0;return 1}function ukb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+32|0;k=a+36|0;l=a+40|0;m=a+28|0;n=a+44|0;o=a+16|0;p=a+20|0;q=a+24|0;r=a+48|0;s=e+8|0;t=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){v=b[a>>0]|0;w=v&255;if(v<<24>>24>0){f[c>>2]=a+1;x=w;y=6}else{z=w;y=5}}else{z=0;y=5}if((y|0)==5){y=0;w=ZYb(c,z)|0;if((w+-1|0)>>>0<127){x=w;y=6}else A=w}b:do if((y|0)==6){y=0;switch(x>>>3&536870911|0){case 1:{if((x&255|0)!=8){A=x;break b}f[i>>2]=f[i>>2]|2;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){a=b[w>>0]|0;v=a&255;if(a<<24>>24>-1){f[c>>2]=w+1;B=v}else{C=v;y=11}}else{C=0;y=11}if((y|0)==11){y=0;v=KYb(c,C)|0;w=J;if((w|0)>-1|(w|0)==-1&v>>>0>4294967295)B=v;else{D=0;y=63;break a}}f[j>>2]=B;continue a;break}case 2:{if((x&255|0)!=16){A=x;break b}f[i>>2]=f[i>>2]|4;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){w=b[v>>0]|0;a=w&255;if(w<<24>>24>-1){f[c>>2]=v+1;E=a}else{F=a;y=17}}else{F=0;y=17}if((y|0)==17){y=0;a=KYb(c,F)|0;v=J;if((v|0)>-1|(v|0)==-1&a>>>0>4294967295)E=a;else{D=0;y=63;break a}}f[k>>2]=E;continue a;break}case 3:{if((x&255|0)!=24){A=x;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){v=b[a>>0]|0;w=v&255;if(v<<24>>24>-1){f[c>>2]=a+1;G=w}else{H=w;y=23}}else{H=0;y=23}if((y|0)==23){y=0;w=KYb(c,H)|0;a=J;if((a|0)>-1|(a|0)==-1&w>>>0>4294967295)G=w;else{D=0;y=63;break a}}f[l>>2]=G;continue a;break}case 4:{if((x&255|0)!=34){A=x;break b}f[i>>2]=f[i>>2]|1;w=f[m>>2]|0;if((w|0)==537368){mHa(m,537368);I=f[m>>2]|0}else I=w;if(l$b(c,I)|0)continue a;else{D=0;y=63;break a}break}case 5:{if((x&255|0)!=40){A=x;break b}f[i>>2]=f[i>>2]|16;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){a=b[w>>0]|0;v=a&255;if(a<<24>>24>-1){f[c>>2]=w+1;K=v}else{L=v;y=33}}else{L=0;y=33}if((y|0)==33){y=0;v=KYb(c,L)|0;w=J;if((w|0)>-1|(w|0)==-1&v>>>0>4294967295)K=v;else{D=0;y=63;break a}}f[n>>2]=K;continue a;break}case 6:{switch((x&255)<<24>>24){case 53:break;case 50:{if(_Za(c,o)|0)continue a;else{D=0;y=63;break a}break}default:{A=x;break b}}v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){w=v;a=h[w>>0]|h[w+1>>0]<<8|h[w+2>>0]<<16|h[w+3>>0]<<24;f[e>>2]=a;f[c>>2]=v+4;M=a}else{if(!(WYb(c,e)|0)){y=50;break a}M=f[e>>2]|0}a=f[o>>2]|0;if((a|0)==(f[p>>2]|0)){uHa(o,a+1|0);N=f[o>>2]|0}else N=a;a=f[q>>2]|0;v=N+1|0;f[o>>2]=v;f[a+4+(N<<2)>>2]=M;w=f[c>>2]|0;O=(f[g>>2]|0)-w|0;if((O|0)<=0)continue a;P=w;w=(f[p>>2]|0)-v|0;Q=(O>>>0)/5|0;R=(Q|0)<(w|0)?Q:w;if((R|0)>0){S=0;T=P;U=v}else continue a;while(1){if((b[T>>0]|0)!=53){V=S;break}v=T+1|0;w=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;v=U;U=U+1|0;f[o>>2]=U;f[a+4+(v<<2)>>2]=w;w=S+1|0;if((w|0)>=(R|0)){V=w;break}else{S=w;T=T+5|0}}R=V*5|0;if((V|0)<=0)continue a;if((O|0)<(R|0)){SYb(c,R,O)|0;continue a}else{f[c>>2]=P+R;continue a}break}case 7:{if((x&255|0)!=56){A=x;break b}f[i>>2]=f[i>>2]|32;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;W=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[s>>0]|0)){D=0;y=63;break a}else W=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[r>>0]=W&1;continue a;break}default:{A=x;break b}}}while(0);if(!A){D=1;y=63;break}a=f[t>>2]|0;if(!(a&1))X=lSa(t)|0;else X=a&-2;if(!(Lqc(c,A,X)|0)){D=0;y=63;break}}if((y|0)==50){D=0;u=d;return D|0}else if((y|0)==63){u=d;return D|0}return 0}function vkb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+16>>2]|0;e=c+d+(c<<2)|0;c=f[a+8>>2]|0;if(!(c&63)){g=e;h=a+12|0;f[h>>2]=g;return g|0}if(!(c&1))i=e;else{d=f[a+28>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;i=e+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=i;else{k=f[a+32>>2]|0;if((k|0)<0)m=11;else m=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+i|0}if(!(c&4))n=l;else{i=f[a+36>>2]|0;if((i|0)<0)o=11;else o=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+l|0}if(!(c&8))p=n;else{l=f[a+40>>2]|0;if((l|0)<0)q=11;else q=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=q+n|0}if(!(c&16))r=p;else{n=f[a+44>>2]|0;if((n|0)<0)s=11;else s=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+p|0}g=c&32|0?r+2|0:r;h=a+12|0;f[h>>2]=g;return g|0}function wkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&2|0)S_b(1,f[a+32>>2]|0,c);if(d&4|0)S_b(2,f[a+36>>2]|0,c);if(d&8|0)S_b(3,f[a+40>>2]|0,c);if(d&1|0)h$b(4,f[a+28>>2]|0,c);if(d&16|0)S_b(5,f[a+44>>2]|0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{a$b(6,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&32|0)c$b(7,(b[a+48>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function xkb(a){a=a|0;return f[a+12>>2]|0}function ykb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+32>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&4))q=e;else{o=f[a+36>>2]|0;b[e>>0]=16;p=e+1|0;e=o&255;if(o>>>0>127){d=p;h=e;l=o;j=((o|0)<0)<<31>>31;while(1){b[d>>0]=h|-128;o=l;l=l1c(l|0,j|0,7)|0;i=d+1|0;k=l&255;if(!(j>>>0>0|(j|0)==0&o>>>0>16383)){r=i;s=k;break}else{d=i;h=k;j=J}}}else{r=p;s=e}b[r>>0]=s;q=r+1|0}if(!(c&8))t=q;else{r=f[a+40>>2]|0;b[q>>0]=24;s=q+1|0;q=r&255;if(r>>>0>127){e=s;p=q;j=r;h=((r|0)<0)<<31>>31;while(1){b[e>>0]=p|-128;r=j;j=l1c(j|0,h|0,7)|0;d=e+1|0;l=j&255;if(!(h>>>0>0|(h|0)==0&r>>>0>16383)){u=d;v=l;break}else{e=d;p=l;h=J}}}else{u=s;v=q}b[u>>0]=v;t=u+1|0}if(!(c&1))w=t;else{u=f[a+28>>2]|0;b[t>>0]=34;w=gZb(u,t+1|0)|0}if(!(c&16))x=w;else{t=f[a+44>>2]|0;b[w>>0]=40;u=w+1|0;w=t&255;if(t>>>0>127){v=u;q=w;s=t;h=((t|0)<0)<<31>>31;while(1){b[v>>0]=q|-128;t=s;s=l1c(s|0,h|0,7)|0;p=v+1|0;e=s&255;if(!(h>>>0>0|(h|0)==0&t>>>0>16383)){y=p;z=e;break}else{v=p;q=e;h=J}}}else{y=u;z=w}b[y>>0]=z;x=y+1|0}y=f[a+16>>2]|0;if(!y)A=x;else{z=f[a+24>>2]|0;w=0;u=x;while(1){x=f[z+4+(w<<2)>>2]|0;b[u>>0]=53;h=u+1|0;b[h>>0]=x;b[h+1>>0]=x>>8;b[h+2>>0]=x>>16;b[h+3>>0]=x>>24;x=u+5|0;w=w+1|0;if((w|0)>=(y|0)){A=x;break}else u=x}}if(!(c&32))B=A;else{c=b[a+48>>0]|0;b[A>>0]=56;b[A+1>>0]=c;B=A+2|0}A=f[a+4>>2]|0;if(!(A&1)){C=B;return C|0}C=Pqc(A&-2,B)|0;return C|0}function zkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;f[a+16>>2]=0;d=a+8|0;e=f[d>>2]|0;do if(e&1|0){g=f[a+28>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&62|0){e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;b[e+16>>0]=0}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16768,0)|0;if(!e){Ooc(c,a);return}else{Dkb(a,e);return}}function Akb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16768,0)|0;if(!c){Ooc(b,a);return}else{Dkb(a,c);return}}function Bkb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Ckb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535304;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Dkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=f[c+8>>2]|0;if(!(h&63))return;do if(h&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+28|0,g=f[c+28>>2]|0,d=f[e>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(e,g);break}else{oYc(d,g)|0;break}while(0);if(h&2|0)f[a+32>>2]=f[c+32>>2];if(h&4|0)f[a+36>>2]=f[c+36>>2];if(h&8|0)f[a+40>>2]=f[c+40>>2];if(h&16|0)f[a+44>>2]=f[c+44>>2];if(h&32|0)b[a+48>>0]=b[c+48>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|h;return}function Ekb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=99076;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=531720?(f[223080]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=30;b[d+8>>0]=0;J_b(892320,d);a_b(d)}f[a+12>>2]=0;f[a+28>>2]=537368;d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0;u=c;return}function Fkb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Gkb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=99184;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function Hkb(a){a=a|0;Gkb(a);cYc(a);return}function Ikb(a){a=a|0;a=$Xc(32)|0;Vkb(a);return a|0}function Jkb(a,b){a=a|0;b=b|0;a=$Xc(32)|0;Vkb(a);if(!b)return a|0;Wkb(b,a);return a|0}function Kkb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{d0a(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Lkb(a){a=a|0;return 1}function Mkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=e+4|0;j=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=ZYb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}if((n|0)==6){n=0;if((m|0)==10){l=Z$a(h)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(k=b[a>>0]|0,k<<24>>24>-1):0){f[c>>2]=a+1;q=k&255}else{k=YYb(c)|0;if((k|0)>-1)q=k;else{r=0;n=20;break}}JYb(e,c,q);if((f[i>>2]|0)<0){n=13;break}if(!(Mi[f[(f[l>>2]|0)+44>>2]&1023](l,c)|0)){n=13;break}if(OYb(c,f[e>>2]|0)|0)continue;else{r=0;n=20;break}}else p=m}if(!p){r=1;n=20;break}l=f[j>>2]|0;if(!(l&1))s=lSa(j)|0;else s=l&-2;if(!(Lqc(c,p,s)|0)){r=0;n=20;break}}if((n|0)==13){r=0;u=d;return r|0}else if((n|0)==20){u=d;return r|0}return 0}function Nkb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function Okb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Pkb(a){a=a|0;return f[a+12>>2]|0}function Qkb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Pqc(j&-2,g)|0;return s|0}function Rkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))return;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{d0a(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=a+4|0;d=f[c>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(b,21568,16784,0)|0;if(!g){Ooc(b,a);return}b=f[g+4>>2]|0;if(b&1|0){d=f[c>>2]|0;if(!(d&1))h=lSa(c)|0;else h=d&-2;vqc(h,b&-2)}yHa(a+16|0,g+16|0);return}function Skb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16784,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}yHa(a+16|0,c+16|0);return}function Tkb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Ukb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535264;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Vkb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=99184;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=531440?(f[223075]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=25;b[d+8>>0]=0;J_b(892300,d);a_b(d)}f[a+12>>2]=0;u=c;return}function Wkb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Xkb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Ykb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223072]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=22;b[c+8>>0]=0;J_b(892288,c);a_b(c);u=a;return}function Zkb(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;c=a+8|0;d=f[c>>2]|0;if(d&1|0)oYc(f[a+16>>2]|0,535168)|0;if(d&254|0){d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[a+36>>2]=-1;n[a+40>>2]=1.0;n[a+44>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);$_a(a,b);return}function _kb(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=98968;c=a+4|0;f[c>>2]=0;e=b+8|0;f[a+8>>2]=f[e>>2];g=a+12|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;Mjb(a+16|0,b+16|0);g=a+32|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;vSa(g,b+32|0);g=a+48|0;f[g>>2]=0;f[a+52>>2]=0;h=a+56|0;f[h>>2]=0;i=b+48|0;j=f[i>>2]|0;if(j|0){qHa(g,j);o1c((f[h>>2]|0)+4|0,(f[b+56>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[g>>2]=f[i>>2]}i=a+60|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;e5a(i,b+60|0);i=a+76|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;Njb(i,b+76|0);i=f[b+4>>2]|0;if(i&1|0){g=f[c>>2]|0;if(!(g&1))k=lSa(c)|0;else k=g&-2;vqc(k,i&-2)}i=a+92|0;f[i>>2]=537368;k=f[e>>2]|0;if((k&1|0)!=0?(g=f[b+92>>2]|0,(g|0)!=537368):0){mHa(i,g);l=f[e>>2]|0}else l=k;if(!(l&2)){m=0;n=a+96|0;f[n>>2]=m;o=a+100|0;p=b+100|0;q=d[p>>1]|0;d[o>>1]=q;return}l=$Xc(40)|0;$kb(l,f[b+96>>2]|0);m=l;n=a+96|0;f[n>>2]=m;o=a+100|0;p=b+100|0;q=d[p>>1]|0;d[o>>1]=q;return}function $kb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=98644;c=a+4|0;f[c>>2]=0;f[a+8>>2]=f[b+8>>2];d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;vSa(a+16|0,b+16|0);d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=b+32|0;b=f[d+4>>2]|0;g=a+32|0;f[g>>2]=f[d>>2];f[g+4>>2]=b;return}function alb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Ujb(a);Ljb(a,b);return}function blb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;vab(a);qab(a,b);return}function clb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=95620;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];f[a+12>>2]=0;e=f[b+4>>2]|0;if(e&1|0)vqc(lSa(c)|0,e&-2);e=a+16|0;f[e>>2]=537368;c=f[d>>2]|0;if((c&1|0)!=0?(g=f[b+16>>2]|0,(g|0)!=537368):0){mHa(e,g);h=f[d>>2]|0}else h=c;c=a+20|0;f[c>>2]=537368;if(h&2|0?(h=f[b+20>>2]|0,(h|0)!=537368):0)mHa(c,h);h=a+24|0;a=b+24|0;f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];return}function dlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=95296;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];f[a+12>>2]=0;e=f[b+4>>2]|0;if(e&1|0)vqc(lSa(c)|0,e&-2);e=a+16|0;f[e>>2]=537368;c=f[d>>2]|0;if((c&1|0)!=0?(g=f[b+16>>2]|0,(g|0)!=537368):0){mHa(e,g);h=f[d>>2]|0}else h=c;c=a+20|0;f[c>>2]=537368;if((h&2|0)!=0?(g=f[b+20>>2]|0,(g|0)!=537368):0){mHa(c,g);i=f[d>>2]|0}else i=h;h=a+24|0;f[h>>2]=537368;if(i&4|0?(i=f[b+24>>2]|0,(i|0)!=537368):0)mHa(h,i);i=a+28|0;a=b+28|0;f[i>>2]=f[a>>2];f[i+4>>2]=f[a+4>>2];f[i+8>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];return}function elb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=94756;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];f[a+12>>2]=0;e=f[b+4>>2]|0;if(e&1|0)vqc(lSa(c)|0,e&-2);e=a+16|0;f[e>>2]=537368;c=f[d>>2]|0;if((c&1|0)!=0?(g=f[b+16>>2]|0,(g|0)!=537368):0){mHa(e,g);h=f[d>>2]|0}else h=c;c=a+20|0;f[c>>2]=537368;if((h&2|0)!=0?(g=f[b+20>>2]|0,(g|0)!=537368):0){mHa(c,g);i=f[d>>2]|0}else i=h;h=a+24|0;f[h>>2]=535216;if((i&4|0)!=0?(g=f[b+24>>2]|0,(g|0)!=535216):0){mHa(h,g);j=f[d>>2]|0}else j=i;i=a+28|0;f[i>>2]=537368;if(j&8|0?(j=f[b+28>>2]|0,(j|0)!=537368):0)mHa(i,j);j=a+32|0;a=b+32|0;f[j>>2]=f[a>>2];f[j+4>>2]=f[a+4>>2];f[j+8>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];return}function flb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;f[a+16>>2]=0;e=a+8|0;g=f[e>>2]|0;do if(g&1|0){h=f[a+28>>2]|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[i>>0]=0;break}}while(0);if(g&62|0){g=a+32|0;f[g>>2]=0;d[g+4>>1]=0;b[g+6>>0]=0;n[a+40>>2]=1.0}f[e>>2]=0;e=f[a+4>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);t1a(a,c);return}function glb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;d=a+8|0;if(f[d>>2]&7|0){e=a+16|0;f[e>>2]=0;b[e+4>>0]=0;f[a+24>>2]=1}f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=f[c+4>>2]|0;if(h&1|0){g=f[e>>2]|0;if(!(g&1))i=lSa(e)|0;else i=g&-2;vqc(i,h&-2)}h=f[c+8>>2]|0;if(!(h&7))return;if(h&1|0)f[a+16>>2]=f[c+16>>2];if(h&2|0)b[a+20>>0]=b[c+20>>0]|0;if(h&4|0)f[a+24>>2]=f[c+24>>2];f[d>>2]=f[d>>2]|h;return}function hlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&7|0){f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1}f[c>>2]=0;d=a+4|0;e=f[d>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){e=f[d>>2]|0;if(!(e&1))h=lSa(d)|0;else h=e&-2;vqc(h,g&-2)}g=f[b+8>>2]|0;if(!(g&7))return;if(g&1|0)f[a+16>>2]=f[b+16>>2];if(g&2|0)f[a+20>>2]=f[b+20>>2];if(g&4|0)f[a+24>>2]=f[b+24>>2];f[c>>2]=f[c>>2]|g;return}function ilb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;d=a+8|0;if(f[d>>2]&7|0){e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[a+24>>2]=1}f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=f[c+4>>2]|0;if(h&1|0){g=f[e>>2]|0;if(!(g&1))i=lSa(e)|0;else i=g&-2;vqc(i,h&-2)}h=f[c+8>>2]|0;if(!(h&7))return;if(h&1|0)b[a+16>>0]=b[c+16>>0]|0;if(h&2|0)f[a+20>>2]=f[c+20>>2];if(h&4|0)f[a+24>>2]=f[c+24>>2];f[d>>2]=f[d>>2]|h;return}function jlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=1}f[c>>2]=0;d=a+4|0;e=f[d>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){e=f[d>>2]|0;if(!(e&1))h=lSa(d)|0;else h=e&-2;vqc(h,g&-2)}g=f[b+8>>2]|0;if(!(g&3))return;if(g&1|0)f[a+16>>2]=f[b+16>>2];if(g&2|0)f[a+20>>2]=f[b+20>>2];f[c>>2]=f[c>>2]|g;return}function klb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;d=a+8|0;if(f[d>>2]&3|0){b[a+16>>0]=0;n[a+20>>2]=1.0}f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=f[c+4>>2]|0;if(h&1|0){g=f[e>>2]|0;if(!(g&1))i=lSa(e)|0;else i=g&-2;vqc(i,h&-2)}h=f[c+8>>2]|0;if(!(h&3))return;if(h&1|0)b[a+16>>0]=b[c+16>>0]|0;if(h&2|0)f[a+20>>2]=f[c+20>>2];f[d>>2]=f[d>>2]|h;return}function llb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;O9a(a);P0a(a,b);return}function mlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;d=a+8|0;e=f[d>>2]|0;do if(e&3|0){do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&2|0){h=f[a+20>>2]|0;g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}}while(0);if(e&252|0){g=a+24|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0}if(e&768|0){n[a+44>>2]=1.0;f[a+48>>2]=4}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);R0a(a,c);return}function nlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;d=a+8|0;if(f[d>>2]&3|0){n[a+16>>2]=.5;b[a+20>>0]=1}f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=f[c+4>>2]|0;if(h&1|0){g=f[e>>2]|0;if(!(g&1))i=lSa(e)|0;else i=g&-2;vqc(i,h&-2)}h=f[c+8>>2]|0;if(!(h&3))return;if(h&1|0)f[a+16>>2]=f[c+16>>2];if(h&2|0)b[a+20>>0]=b[c+20>>0]|0;f[d>>2]=f[d>>2]|h;return}function olb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;n5a(a);l1a(a,b);return}function plb(a,c){a=a|0;c=c|0;var d=0,e=0;if((c|0)==(a|0))return;f[a+16>>2]=0;d=a+8|0;if(f[d>>2]&3|0){f[a+28>>2]=1;b[a+32>>0]=1}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);i1a(a,c);return}function qlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0}f[c>>2]=0;d=a+4|0;e=f[d>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){e=f[d>>2]|0;if(!(e&1))h=lSa(d)|0;else h=e&-2;vqc(h,g&-2)}g=f[b+8>>2]|0;if(!(g&7))return;if(g&1|0)f[a+16>>2]=f[b+16>>2];if(g&2|0)f[a+20>>2]=f[b+20>>2];if(g&4|0)f[a+24>>2]=f[b+24>>2];f[c>>2]=f[c>>2]|g;return}function rlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;d=a+8|0;e=f[d>>2]|0;do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&6|0){e=a+20|0;f[e>>2]=0;b[e+4>>0]=0}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);U0a(a,c);return}function slb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;d=a+8|0;do if(f[d>>2]&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[d>>2]=0;g=a+4|0;e=f[g>>2]|0;if(e&1|0?(h=e&-2,f[h>>2]|0):0)sqc(h);h=f[c+4>>2]|0;if(h&1|0){e=f[g>>2]|0;if(!(e&1))i=lSa(g)|0;else i=e&-2;vqc(i,h&-2)}if(!(f[c+8>>2]&1))return;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[c+16>>2]|0;c=f[d>>2]|0;if((c|0)==(a|0))return;if((c|0)==537368){mHa(d,a);return}else{oYc(c,a)|0;return}}function tlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+16|0;f[c>>2]=1;d=a+8|0;f[d>>2]=0;e=a+4|0;a=f[e>>2]|0;if(a&1|0?(g=a&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){a=f[e>>2]|0;if(!(a&1))h=lSa(e)|0;else h=a&-2;vqc(h,g&-2)}if(!(f[b+8>>2]&1))return;g=f[b+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=g;return}function ulb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;D8a(a);W0a(a,b);return}function vlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;d=a+8|0;do if(f[d>>2]&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[d>>2]=0;g=a+4|0;e=f[g>>2]|0;if(e&1|0?(h=e&-2,f[h>>2]|0):0)sqc(h);h=f[c+4>>2]|0;if(h&1|0){e=f[g>>2]|0;if(!(e&1))i=lSa(g)|0;else i=e&-2;vqc(i,h&-2)}if(!(f[c+8>>2]&1))return;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[c+16>>2]|0;c=f[d>>2]|0;if((c|0)==(a|0))return;if((c|0)==537368){mHa(d,a);return}else{oYc(c,a)|0;return}}function wlb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;Z7a(a);Z0a(a,b);return}function xlb(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&63|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);$0a(a,b);return}function ylb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&15|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0}f[c>>2]=0;d=a+4|0;e=f[d>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){e=f[d>>2]|0;if(!(e&1))h=lSa(d)|0;else h=e&-2;vqc(h,g&-2)}g=f[b+8>>2]|0;if(!(g&15))return;if(g&1|0)f[a+16>>2]=f[b+16>>2];if(g&2|0)f[a+20>>2]=f[b+20>>2];if(g&4|0)f[a+24>>2]=f[b+24>>2];if(g&8|0)f[a+28>>2]=f[b+28>>2];f[c>>2]=f[c>>2]|g;return}function zlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;d=a+8|0;if(f[d>>2]&7|0){b[a+16>>0]=0;b[a+17>>0]=1;n[a+20>>2]=9.999999717180685e-10}f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=f[c+4>>2]|0;if(h&1|0){g=f[e>>2]|0;if(!(g&1))i=lSa(e)|0;else i=g&-2;vqc(i,h&-2)}h=f[c+8>>2]|0;if(!(h&7))return;if(h&1|0)b[a+16>>0]=b[c+16>>0]|0;if(h&2|0)b[a+17>>0]=b[c+17>>0]|0;if(h&4|0)f[a+20>>2]=f[c+20>>2];f[d>>2]=f[d>>2]|h;return}function Alb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((c|0)==(a|0))return;d=a+8|0;e=f[d>>2]|0;if(e&255|0){g=a+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0}if(e&7936|0){e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;b[e+8>>0]=0;f[a+60>>2]=1;b[a+64>>0]=1}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);b1a(a,c);return}function Blb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=1.0;n[a+24>>2]=1.0}f[c>>2]=0;d=a+4|0;e=f[d>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){e=f[d>>2]|0;if(!(e&1))h=lSa(d)|0;else h=e&-2;vqc(h,g&-2)}g=f[b+8>>2]|0;if(!(g&7))return;if(g&1|0)f[a+16>>2]=f[b+16>>2];if(g&2|0)f[a+20>>2]=f[b+20>>2];if(g&4|0)f[a+24>>2]=f[b+24>>2];f[c>>2]=f[c>>2]|g;return}function Clb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&3|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;d=a+4|0;e=f[d>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){e=f[d>>2]|0;if(!(e&1))h=lSa(d)|0;else h=e&-2;vqc(h,g&-2)}g=f[b+8>>2]|0;if(!(g&3))return;if(g&1|0)f[a+16>>2]=f[b+16>>2];if(g&2|0)f[a+20>>2]=f[b+20>>2];f[c>>2]=f[c>>2]|g;return}function Dlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+16|0;f[c>>2]=0;d=a+8|0;f[d>>2]=0;e=a+4|0;a=f[e>>2]|0;if(a&1|0?(g=a&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){a=f[e>>2]|0;if(!(a&1))h=lSa(e)|0;else h=a&-2;vqc(h,g&-2)}if(!(f[b+8>>2]&1))return;g=f[b+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=g;return}function Elb(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;f[a+16>>2]=0;c=a+8|0;if(f[c>>2]&3|0){f[a+28>>2]=1;f[a+32>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);q1a(a,b);return}function Flb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+8|0;if(f[c>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[c>>2]=0;d=a+4|0;e=f[d>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){e=f[d>>2]|0;if(!(e&1))h=lSa(d)|0;else h=e&-2;vqc(h,g&-2)}g=f[b+8>>2]|0;if(!(g&3))return;if(g&1|0)f[a+16>>2]=f[b+16>>2];if(g&2|0)f[a+20>>2]=f[b+20>>2];f[c>>2]=f[c>>2]|g;return}function Glb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+16|0;f[c>>2]=0;d=a+8|0;f[d>>2]=0;e=a+4|0;a=f[e>>2]|0;if(a&1|0?(g=a&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){a=f[e>>2]|0;if(!(a&1))h=lSa(e)|0;else h=a&-2;vqc(h,g&-2)}if(!(f[b+8>>2]&1))return;g=f[b+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=g;return}function Hlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+16|0;n[c>>2]=0.0;d=a+8|0;f[d>>2]=0;e=a+4|0;a=f[e>>2]|0;if(a&1|0?(g=a&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){a=f[e>>2]|0;if(!(a&1))h=lSa(e)|0;else h=a&-2;vqc(h,g&-2)}if(!(f[b+8>>2]&1))return;g=f[b+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=g;return}function Ilb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;c7a(a);d1a(a,b);return}function Jlb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;A0a(a);L0a(a,b);return}function Klb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=100088;Zqb(a);c=a+84|0;d=f[c>>2]|0;if(d|0?(f[a+72>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+68|0;i=f[c>>2]|0;if(i|0?(f[a+56>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+52|0;j=f[c>>2]|0;if(j|0?(f[a+40>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=f[a+36>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(k);f[c>>2]=0;return}function Llb(a){a=a|0;Klb(a);cYc(a);return}function Mlb(a){a=a|0;a=$Xc(128)|0;_pb(a);return a|0}function Nlb(a,b){a=a|0;b=b|0;a=$Xc(128)|0;_pb(a);if(!b)return a|0;Yqb(b,a);return a|0}function Olb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a+16>>2]=0;f[a+28>>2]=0;c=a+44|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+52>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+60|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+68>>2]|0;e=0;do{aob(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+76|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+84>>2]|0;g=0;do{Bqb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&63|0){do if(d&1|0){g=f[a+88>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+92>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+96>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0){e=f[a+100>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&16|0)aob(f[a+104>>2]|0);if(d&32|0)Bqb(f[a+108>>2]|0)}if(d&192|0){d=a+112|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[a+124>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Plb(a){a=a|0;return 1}function Qlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+120|0;l=a+112|0;m=e+8|0;n=a+92|0;o=a+104|0;p=e+4|0;q=a+108|0;r=e+4|0;s=a+16|0;t=a+20|0;v=a+24|0;w=a+28|0;x=a+32|0;y=a+36|0;z=e+8|0;A=e+8|0;B=a+40|0;C=a+56|0;D=e+4|0;E=a+72|0;F=a+84|0;G=a+80|0;H=a+76|0;I=e+4|0;K=a+96|0;L=a+124|0;M=a+4|0;N=a+100|0;a:while(1){a=f[c>>2]|0;O=f[g>>2]|0;do if(a>>>0<O>>>0){P=b[a>>0]|0;Q=P&255;R=a+1|0;if(P<<24>>24>0){S=R;T=Q}else{if(R>>>0>=O>>>0){U=Q;V=7;break}P=h[R>>0]|0;if(((P^128)&Q)>>>0<=127){U=Q;V=7;break}S=a+2|0;T=Q+-128+(P<<7)|0}f[c>>2]=S;W=T;V=9}else{U=0;V=7}while(0);if((V|0)==7){V=0;a=ZYb(c,U)|0;if((a+-1|0)>>>0<16383){W=a;V=9}else X=a}b:do if((V|0)==9){V=0;do switch(W>>>3&536870911|0){case 1:{if((W&255|0)!=10){X=W;break b}f[i>>2]=f[i>>2]|1;a=f[j>>2]|0;if((a|0)==537368){mHa(j,537368);Y=f[j>>2]|0}else Y=a;if(l$b(c,Y)|0)continue a;else{Z=0;V=143;break a}break}case 2:{if((W&255|0)!=21){X=W;break b}f[i>>2]=f[i>>2]|128;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){O=a;P=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;f[e>>2]=P;f[c>>2]=a+4;_=P}else{if(!(WYb(c,e)|0)){V=20;break a}_=f[e>>2]|0}f[k>>2]=_;continue a;break}case 3:{if((W&255|0)!=24){X=W;break b}f[i>>2]=f[i>>2]|64;P=f[c>>2]|0;if(P>>>0<(f[g>>2]|0)>>>0?(a=b[P>>0]|0,a<<24>>24>-1):0){f[c>>2]=P+1;$=a&255;aa=0}else{LYb(e,c);a=e;if(!(b[m>>0]|0)){Z=0;V=143;break a}else{$=f[a>>2]|0;aa=f[a+4>>2]|0}}a=l;f[a>>2]=$;f[a+4>>2]=aa;continue a;break}case 4:{if((W&255|0)!=34){X=W;break b}f[i>>2]=f[i>>2]|2;a=f[n>>2]|0;if((a|0)==537368){mHa(n,537368);ba=f[n>>2]|0}else ba=a;if(l$b(c,ba)|0)continue a;else{Z=0;V=143;break a}break}case 5:{if((W&255|0)!=42){X=W;break b}f[i>>2]=f[i>>2]|16;a=f[o>>2]|0;if(!a){P=$Xc(144)|0;Gob(P);f[o>>2]=P;ca=P}else ca=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(P=b[a>>0]|0,P<<24>>24>-1):0){f[c>>2]=a+1;da=P&255}else{P=YYb(c)|0;if((P|0)>-1)da=P;else{Z=0;V=143;break a}}JYb(e,c,da);if((f[p>>2]|0)<0){V=40;break a}if(!(Mi[f[(f[ca>>2]|0)+44>>2]&1023](ca,c)|0)){V=40;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 6:{if((W&255|0)!=50){X=W;break b}f[i>>2]=f[i>>2]|32;P=f[q>>2]|0;if(!P){a=$Xc(104)|0;upb(a);f[q>>2]=a;ea=a}else ea=P;P=f[c>>2]|0;if(P>>>0<(f[g>>2]|0)>>>0?(a=b[P>>0]|0,a<<24>>24>-1):0){f[c>>2]=P+1;fa=a&255}else{a=YYb(c)|0;if((a|0)>-1)fa=a;else{Z=0;V=143;break a}}JYb(e,c,fa);if((f[r>>2]|0)<0){V=51;break a}if(!(Mi[f[(f[ea>>2]|0)+44>>2]&1023](ea,c)|0)){V=51;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 7:{switch((W&255)<<24>>24){case 61:break;case 58:{if(_Za(c,s)|0)continue a;else{Z=0;V=143;break a}break}default:{X=W;break b}}a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){P=a;O=h[P>>0]|h[P+1>>0]<<8|h[P+2>>0]<<16|h[P+3>>0]<<24;f[e>>2]=O;f[c>>2]=a+4;ga=O}else{if(!(WYb(c,e)|0)){V=68;break a}ga=f[e>>2]|0}O=f[s>>2]|0;if((O|0)==(f[t>>2]|0)){uHa(s,O+1|0);ha=f[s>>2]|0}else ha=O;O=f[v>>2]|0;a=ha+1|0;f[s>>2]=a;f[O+4+(ha<<2)>>2]=ga;P=f[c>>2]|0;Q=(f[g>>2]|0)-P|0;if((Q|0)<=0)continue a;R=P;P=(f[t>>2]|0)-a|0;ia=(Q>>>0)/5|0;ja=(ia|0)<(P|0)?ia:P;if((ja|0)>0){ka=0;la=R;ma=a}else continue a;while(1){if((b[la>>0]|0)!=61){na=ka;break}a=la+1|0;P=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=ma;ma=ma+1|0;f[s>>2]=ma;f[O+4+(a<<2)>>2]=P;P=ka+1|0;if((P|0)>=(ja|0)){na=P;break}else{ka=P;la=la+5|0}}ja=na*5|0;if((na|0)<=0)continue a;if((Q|0)<(ja|0)){SYb(c,ja,Q)|0;continue a}else{f[c>>2]=R+ja;continue a}break}case 8:{switch((W&255)<<24>>24){case 64:break;case 66:{if(Eob(c,w)|0)continue a;else{Z=0;V=143;break a}break}default:{X=W;break b}}ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(O=b[ja>>0]|0,O<<24>>24>-1):0){f[c>>2]=ja+1;oa=O&255;pa=0}else{LYb(e,c);O=e;if(!(b[A>>0]|0)){Z=0;V=143;break a}else{oa=f[O>>2]|0;pa=f[O+4>>2]|0}}O=f[w>>2]|0;ja=f[x>>2]|0;if((O|0)==(ja|0)){_Ma(w,O+1|0);qa=f[w>>2]|0;ra=f[x>>2]|0}else{qa=O;ra=ja}ja=f[y>>2]|0;O=qa+1|0;f[w>>2]=O;P=ja+8+(qa<<3)|0;f[P>>2]=oa;f[P+4>>2]=pa;P=ra-O|0;if((P|0)>0){sa=P;ta=O;ua=ja}else continue a;while(1){ja=f[c>>2]|0;O=f[g>>2]|0;if(ja>>>0>=O>>>0)continue a;if((b[ja>>0]|0)!=64)continue a;P=ja+1|0;f[c>>2]=P;if(P>>>0<O>>>0?(O=b[P>>0]|0,O<<24>>24>-1):0){f[c>>2]=ja+2;va=ta;wa=ua;xa=O&255;ya=0}else{LYb(e,c);O=e;if(!(b[z>>0]|0)){Z=0;V=143;break a}va=f[w>>2]|0;wa=f[y>>2]|0;xa=f[O>>2]|0;ya=f[O+4>>2]|0}O=va+1|0;f[w>>2]=O;ja=wa+8+(va<<3)|0;f[ja>>2]=xa;f[ja+4>>2]=ya;if((sa|0)>1){sa=sa+-1|0;ta=O;ua=wa}else continue a}break}case 9:{if((W&255|0)!=74){X=W;break b}if(l$b(c,pHa(B)|0)|0)continue a;else{Z=0;V=143;break a}break}case 10:{if((W&255|0)!=82){X=W;break b}R=Mqb(C)|0;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0?(O=b[Q>>0]|0,O<<24>>24>-1):0){f[c>>2]=Q+1;za=O&255}else{O=YYb(c)|0;if((O|0)>-1)za=O;else{Z=0;V=143;break a}}JYb(e,c,za);if((f[D>>2]|0)<0){V=96;break a}if(!(Mi[f[(f[R>>2]|0)+44>>2]&1023](R,c)|0)){V=96;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 11:{if((W&255|0)!=90){X=W;break b}R=f[F>>2]|0;do if(R){O=f[H>>2]|0;Q=f[R>>2]|0;if((O|0)>=(Q|0))if((Q|0)==(f[G>>2]|0)){Aa=Q;V=104;break}else{Ba=Q;Ca=R;V=105;break}else{f[H>>2]=O+1;Da=f[R+4+(O<<2)>>2]|0;break}}else{Aa=f[G>>2]|0;V=104}while(0);if((V|0)==104){V=0;XZb(E,Aa+1|0);R=f[F>>2]|0;Ba=f[R>>2]|0;Ca=R;V=105}if((V|0)==105){V=0;f[Ca>>2]=Ba+1;R=f[E>>2]|0;if(!R){O=$Xc(104)|0;upb(O);Ea=O}else{if(f[R+64>>2]|0)SXb(R,16992,104);O=RXb(R,104,2257)|0;upb(O);Ea=O}O=f[F>>2]|0;R=f[H>>2]|0;f[H>>2]=R+1;f[O+4+(R<<2)>>2]=Ea;Da=Ea}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(O=b[R>>0]|0,O<<24>>24>-1):0){f[c>>2]=R+1;Fa=O&255}else{O=YYb(c)|0;if((O|0)>-1)Fa=O;else{Z=0;V=143;break a}}JYb(e,c,Fa);if((f[I>>2]|0)<0){V=117;break a}if(!(Mi[f[(f[Da>>2]|0)+44>>2]&1023](Da,c)|0)){V=117;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Z=0;V=143;break a}break}case 13:{if((W&255|0)!=106){X=W;break b}f[i>>2]=f[i>>2]|4;O=f[K>>2]|0;if((O|0)==537368){mHa(K,537368);Ga=f[K>>2]|0}else Ga=O;if(l$b(c,Ga)|0)continue a;else{Z=0;V=143;break a}break}case 20:{if((W&255|0)!=160){X=W;break b}O=f[c>>2]|0;if(O>>>0<(f[g>>2]|0)>>>0){R=b[O>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=O+1;Ha=Q}else{Ia=Q;V=127}}else{Ia=0;V=127}if((V|0)==127){V=0;Q=KYb(c,Ia)|0;O=J;if((O|0)>-1|(O|0)==-1&Q>>>0>4294967295)Ha=Q;else{Z=0;V=143;break a}}if(Ha>>>0<11){f[i>>2]=f[i>>2]|256;f[L>>2]=Ha;continue a}Q=f[M>>2]|0;if(!(Q&1))Ja=lSa(M)|0;else Ja=Q&-2;yqc(Ja,20,Ha,((Ha|0)<0)<<31>>31);continue a;break}case 21:{if((W&255|0)!=170){X=W;break b}f[i>>2]=f[i>>2]|8;Q=f[N>>2]|0;if((Q|0)==537368){mHa(N,537368);Ka=f[N>>2]|0}else Ka=Q;if(l$b(c,Ka)|0)continue a;else{Z=0;V=143;break a}break}default:{X=W;break b}}while(0)}while(0);if(!X){Z=1;V=143;break}Q=f[M>>2]|0;if(!(Q&1))La=lSa(M)|0;else La=Q&-2;if(!(Lqc(c,X,La)|0)){Z=0;V=143;break}}if((V|0)==20){Z=0;u=d;return Z|0}else if((V|0)==40){Z=0;u=d;return Z|0}else if((V|0)==51){Z=0;u=d;return Z|0}else if((V|0)==68){Z=0;u=d;return Z|0}else if((V|0)==96){Z=0;u=d;return Z|0}else if((V|0)==117){Z=0;u=d;return Z|0}else if((V|0)==143){u=d;return Z|0}return 0}function Rlb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+16>>2]|0;e=c+d+(c<<2)|0;c=f[a+28>>2]|0;if((c|0)>0){d=f[a+36>>2]|0;g=0;h=0;while(1){i=d+8+(h<<3)|0;j=t1c(f[i>>2]|1|0,f[i+4>>2]|0,1)|0;i=((((j^63)*9|0)+73|0)>>>6)+g|0;h=h+1|0;if((h|0)==(c|0)){k=i;break}else g=i}}else k=0;g=f[a+44>>2]|0;h=e+k+c+g|0;if((g|0)>0){c=f[a+52>>2]|0;k=0;e=h;while(1){d=f[c+4+(k<<2)>>2]|0;i=b[d+11>>0]|0;j=i<<24>>24<0?f[d+4>>2]|0:i&255;i=j+e+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=k+1|0;if((k|0)==(g|0)){l=i;break}else e=i}}else l=h;h=f[a+60>>2]|0;e=h+l|0;if(!h)m=e;else{l=a+68|0;g=0;k=e;while(1){e=f[(f[l>>2]|0)+4+(g<<2)>>2]|0;c=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=c+k+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(h|0)){m=e;break}else k=e}}k=f[a+76>>2]|0;h=k+m|0;if(!k)n=h;else{m=a+84|0;g=0;l=h;while(1){h=f[(f[m>>2]|0)+4+(g<<2)>>2]|0;e=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;h=e+l+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(k|0)){n=h;break}else l=h}}l=a+8|0;k=f[l>>2]|0;if(!(k&255)){o=n;p=k}else{if(!(k&1))q=n;else{g=f[a+88>>2]|0;m=b[g+11>>0]|0;h=m<<24>>24<0?f[g+4>>2]|0:m&255;q=n+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&2))r=q;else{h=f[a+92>>2]|0;n=b[h+11>>0]|0;m=n<<24>>24<0?f[h+4>>2]|0:n&255;r=q+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&4))s=r;else{m=f[a+96>>2]|0;q=b[m+11>>0]|0;n=q<<24>>24<0?f[m+4>>2]|0:q&255;s=r+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&8))t=s;else{n=f[a+100>>2]|0;r=b[n+11>>0]|0;q=r<<24>>24<0?f[n+4>>2]|0:r&255;t=s+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(k&16)){u=t;v=k}else{k=f[a+104>>2]|0;q=_i[f[(f[k>>2]|0)+48>>2]&2047](k)|0;k=t+1+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=k;v=f[l>>2]|0}if(!(v&32)){w=u;x=v}else{v=f[a+108>>2]|0;k=_i[f[(f[v>>2]|0)+48>>2]&2047](v)|0;v=u+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=v;x=f[l>>2]|0}if(!(x&64))y=w;else{l=a+112|0;v=t1c(f[l>>2]|1|0,f[l+4>>2]|0,1)|0;y=w+1+((((v^63)*9|0)+73|0)>>>6)|0}o=x&128|0?y+5|0:y;p=x}if(!(p&256)){z=o;A=a+12|0;f[A>>2]=z;return z|0}p=f[a+124>>2]|0;if((p|0)<0)B=12;else B=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;z=B+o|0;A=a+12|0;f[A>>2]=z;return z|0}function Slb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+88>>2]|0,b);if(c&128|0)a$b(2,+n[a+120>>2],b);if(c&64|0){d=a+112|0;T_b(3,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&2|0)h$b(4,f[a+92>>2]|0,b);if(c&16|0)k$b(5,f[a+104>>2]|0,b);if(c&32|0)k$b(6,f[a+108>>2]|0,b);d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{a$b(7,+n[(f[e>>2]|0)+4+(g<<2)>>2],b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+28>>2]|0;if((d|0)>0){g=a+36|0;e=0;do{h=(f[g>>2]|0)+8+(e<<3)|0;T_b(8,f[h>>2]|0,f[h+4>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+44>>2]|0;if((d|0)>0){e=a+52|0;g=0;do{g$b(9,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+60>>2]|0;if(d|0){g=a+68|0;e=0;do{k$b(10,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+76>>2]|0;if(d|0){e=a+84|0;g=0;do{k$b(11,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)f$b(13,f[a+96>>2]|0,b);if(c&256|0)d$b(20,f[a+124>>2]|0,b);if(c&8|0)f$b(21,f[a+100>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Tlb(a){a=a|0;return f[a+12>>2]|0}function Ulb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+88>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&128))i=g;else{d=f[a+120>>2]|0;b[g>>0]=21;h=g+1|0;b[h>>0]=d;b[h+1>>0]=d>>8;b[h+2>>0]=d>>16;b[h+3>>0]=d>>24;i=g+5|0}if(!(e&64))j=i;else{g=a+112|0;d=f[g>>2]|0;h=f[g+4>>2]|0;b[i>>0]=24;g=i+1|0;i=d&255;if(h>>>0>0|(h|0)==0&d>>>0>127){k=g;l=i;m=d;d=h;while(1){b[k>>0]=l|-128;h=m;m=l1c(m|0,d|0,7)|0;n=k+1|0;o=m&255;if(!(d>>>0>0|(d|0)==0&h>>>0>16383)){p=n;q=o;break}else{k=n;l=o;d=J}}}else{p=g;q=i}b[p>>0]=q;j=p+1|0}if(!(e&2))r=j;else{p=f[a+92>>2]|0;b[j>>0]=34;r=gZb(p,j+1|0)|0}if(!(e&16))s=r;else{j=f[a+104>>2]|0;b[r>>0]=42;p=r+1|0;r=_i[f[(f[j>>2]|0)+60>>2]&2047](j)|0;if(r>>>0>127){q=r;i=p;while(1){b[i>>0]=q|128;g=q>>>7;d=i+1|0;if(q>>>0>16383){q=g;i=d}else{t=d;u=g;break}}}else{t=p;u=r}b[t>>0]=u;s=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,t+1|0)|0}if(!(e&32))v=s;else{t=f[a+108>>2]|0;b[s>>0]=50;j=s+1|0;s=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(s>>>0>127){u=s;r=j;while(1){b[r>>0]=u|128;p=u>>>7;i=r+1|0;if(u>>>0>16383){u=p;r=i}else{w=i;x=p;break}}}else{w=j;x=s}b[w>>0]=x;v=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,w+1|0)|0}w=f[a+16>>2]|0;if(!w)y=v;else{t=f[a+24>>2]|0;x=0;s=v;while(1){v=f[t+4+(x<<2)>>2]|0;b[s>>0]=61;j=s+1|0;b[j>>0]=v;b[j+1>>0]=v>>8;b[j+2>>0]=v>>16;b[j+3>>0]=v>>24;v=s+5|0;x=x+1|0;if((x|0)>=(w|0)){y=v;break}else s=v}}s=f[a+28>>2]|0;if(!s)z=y;else{w=f[a+36>>2]|0;x=0;t=y;while(1){y=w+8+(x<<3)|0;v=f[y>>2]|0;j=f[y+4>>2]|0;b[t>>0]=64;y=t+1|0;r=v&255;if(j>>>0>0|(j|0)==0&v>>>0>127){u=y;p=r;i=v;v=j;while(1){b[u>>0]=p|-128;j=i;i=l1c(i|0,v|0,7)|0;q=u+1|0;g=i&255;if(!(v>>>0>0|(v|0)==0&j>>>0>16383)){A=q;B=g;break}else{u=q;p=g;v=J}}}else{A=y;B=r}b[A>>0]=B;v=A+1|0;x=x+1|0;if((x|0)>=(s|0)){z=v;break}else t=v}}t=f[a+44>>2]|0;if((t|0)>0){s=a+52|0;x=0;A=z;while(1){B=f[(f[s>>2]|0)+4+(x<<2)>>2]|0;b[A>>0]=74;w=gZb(B,A+1|0)|0;x=x+1|0;if((x|0)==(t|0)){C=w;break}else A=w}}else C=z;z=f[a+60>>2]|0;if(!z)D=C;else{A=a+68|0;t=0;x=C;while(1){C=f[(f[A>>2]|0)+4+(t<<2)>>2]|0;b[x>>0]=82;s=x+1|0;w=_i[f[(f[C>>2]|0)+60>>2]&2047](C)|0;if(w>>>0>127){B=w;v=s;while(1){b[v>>0]=B|128;p=B>>>7;u=v+1|0;if(B>>>0>16383){B=p;v=u}else{E=u;F=p;break}}}else{E=s;F=w}b[E>>0]=F;v=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,E+1|0)|0;t=t+1|0;if((t|0)==(z|0)){D=v;break}else x=v}}x=f[a+76>>2]|0;if(!x)G=D;else{z=a+84|0;t=0;E=D;while(1){D=f[(f[z>>2]|0)+4+(t<<2)>>2]|0;b[E>>0]=90;F=E+1|0;A=_i[f[(f[D>>2]|0)+60>>2]&2047](D)|0;if(A>>>0>127){v=A;B=F;while(1){b[B>>0]=v|128;r=v>>>7;y=B+1|0;if(v>>>0>16383){v=r;B=y}else{H=y;I=r;break}}}else{H=F;I=A}b[H>>0]=I;B=hj[f[(f[D>>2]|0)+64>>2]&511](D,c,H+1|0)|0;t=t+1|0;if((t|0)==(x|0)){G=B;break}else E=B}}if(!(e&4))K=G;else{E=f[a+96>>2]|0;b[G>>0]=106;K=gZb(E,G+1|0)|0}if(!(e&256))L=K;else{G=f[a+124>>2]|0;b[K>>0]=-96;b[K+1>>0]=1;E=K+2|0;K=G&255;if(G>>>0>127){x=E;t=K;H=G;c=((G|0)<0)<<31>>31;while(1){b[x>>0]=t|-128;G=H;H=l1c(H|0,c|0,7)|0;I=x+1|0;z=H&255;if(!(c>>>0>0|(c|0)==0&G>>>0>16383)){M=I;N=z;break}else{x=I;t=z;c=J}}}else{M=E;N=K}b[M>>0]=N;L=M+1|0}if(!(e&8))O=L;else{e=f[a+100>>2]|0;b[L>>0]=-86;b[L+1>>0]=1;O=gZb(e,L+2|0)|0}L=f[a+4>>2]|0;if(!(L&1)){P=O;return P|0}P=Pqc(L&-2,O)|0;return P|0}function Vlb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Olb(a);c=kZc(b,21568,16800,0)|0;if(!c){Ooc(b,a);return}else{bqb(a,c);return}}function Wlb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16800,0)|0;if(!c){Ooc(b,a);return}else{bqb(a,c);return}}function Xlb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Ylb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536632;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Zlb(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223148]|0)!=2){f[c>>2]=165456;f[c+4>>2]=95;b[c+8>>0]=0;J_b(892592,c);a_b(c)}d=$Xc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=17;e=d;g=424438;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+17>>0]=0;ejc(c,100188,100344,99284,0,536632,892576,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function _lb(){$lb();n3b(424456,2523);Boc(424438,2258);return}function $lb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223149]|0)!=2){f[c>>2]=165456;f[c+4>>2]=96;b[c+8>>0]=0;J_b(892596,c);a_b(c)}if((f[223150]|0)!=2){f[c>>2]=165456;f[c+4>>2]=97;b[c+8>>0]=0;J_b(892600,c);a_b(c)}if((f[223151]|0)!=2){f[c>>2]=165456;f[c+4>>2]=98;b[c+8>>0]=0;J_b(892604,c);a_b(c)}if((f[223152]|0)!=2){f[c>>2]=165456;f[c+4>>2]=99;b[c+8>>0]=0;J_b(892608,c);a_b(c)}if((f[223153]|0)!=2){f[c>>2]=165456;f[c+4>>2]=100;b[c+8>>0]=0;J_b(892612,c);a_b(c)}if((f[223154]|0)!=2){f[c>>2]=165456;f[c+4>>2]=101;b[c+8>>0]=0;J_b(892616,c);a_b(c)}if((f[223155]|0)!=2){f[c>>2]=165456;f[c+4>>2]=102;b[c+8>>0]=0;J_b(892620,c);a_b(c)}if((f[223156]|0)!=2){f[c>>2]=165456;f[c+4>>2]=103;b[c+8>>0]=0;J_b(892624,c);a_b(c)}if((f[223157]|0)!=2){f[c>>2]=165456;f[c+4>>2]=104;b[c+8>>0]=0;J_b(892628,c);a_b(c)}if((f[223158]|0)!=2){f[c>>2]=165456;f[c+4>>2]=105;b[c+8>>0]=0;J_b(892632,c);a_b(c)}if((f[223159]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=106;b[c+8>>0]=0;J_b(892636,c);a_b(c);u=a;return}function amb(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223147]|0)!=2){f[c>>2]=165456;f[c+4>>2]=94;b[c+8>>0]=0;J_b(892588,c);a_b(c)}jjc(536632,13);u=a;return}function bmb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,426980);WXb();if((f[223154]|0)!=2){f[c>>2]=165456;f[c+4>>2]=101;b[c+8>>0]=0;J_b(892616,c);a_b(c)}if((f[223150]|0)!=2){f[c>>2]=165456;f[c+4>>2]=97;b[c+8>>0]=0;J_b(892600,c);a_b(c)}f[133954]=100088;f[133955]=0;c=535824;d=c+80|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[133976]=537368;f[133977]=537368;f[133978]=537368;f[133979]=537368;f[133980]=0;f[133981]=0;f[133982]=0;f[133983]=0;f[133984]=0;f[133985]=0;C_b(535816);f[133994]=101484;f[133995]=0;c=535984;d=c+56|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[134010]=537368;f[134011]=537368;f[134012]=537368;f[134013]=537368;C_b(535976);f[134042]=101592;f[134043]=0;c=536176;d=c+88|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[134066]=537368;f[134067]=537368;C_b(536168);f[133980]=536304;f[133981]=536168;u=a;return}function cmb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,426980);WXb();if((f[223158]|0)!=2){f[c>>2]=165456;f[c+4>>2]=105;b[c+8>>0]=0;J_b(892632,c);a_b(c)}f[133986]=101376;f[133987]=0;f[133988]=0;f[133989]=0;f[133990]=537368;f[133991]=537368;f[133992]=0;C_b(535944);f[133992]=536560;u=a;return}function dmb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,426980);WXb();if((f[223159]|0)!=2){f[c>>2]=165456;f[c+4>>2]=106;b[c+8>>0]=0;J_b(892636,c);a_b(c)}if((f[223149]|0)!=2){f[c>>2]=165456;f[c+4>>2]=96;b[c+8>>0]=0;J_b(892596,c);a_b(c)}if((f[223152]|0)!=2){f[c>>2]=165456;f[c+4>>2]=99;b[c+8>>0]=0;J_b(892608,c);a_b(c)}f[134014]=101268;f[134015]=0;c=536064;d=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[134026]=537368;f[134027]=537368;f[134028]=537368;f[134029]=537368;f[134030]=0;f[134031]=0;f[134032]=0;f[134033]=0;f[134034]=0;f[134035]=0;C_b(536056);f[134030]=536168;u=a;return}function emb(){d_b(3005001,3005e3,426980);WXb();f[134036]=101160;f[134037]=0;f[134038]=0;f[134039]=0;f[134040]=537368;f[134041]=537368;C_b(536144);return}function fmb(){d_b(3005001,3005e3,426980);WXb();f[134068]=101052;f[134069]=0;f[134070]=0;f[134071]=0;f[134072]=0;f[134073]=0;f[134074]=0;f[134075]=0;C_b(536272);return}function gmb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,426980);WXb();if((f[223153]|0)!=2){f[c>>2]=165456;f[c+4>>2]=100;b[c+8>>0]=0;J_b(892612,c);a_b(c)}f[134076]=100944;f[134077]=0;f[134087]=0;f[134088]=0;f[134089]=0;f[134099]=0;f[134100]=0;f[134101]=0;f[134103]=0;f[134104]=0;f[134105]=0;f[134091]=0;f[134092]=0;f[134093]=0;f[134094]=0;f[134095]=0;f[134096]=0;f[134097]=0;f[134078]=0;f[134079]=0;f[134080]=0;f[134081]=0;f[134082]=0;f[134083]=0;f[134084]=0;f[134085]=0;f[134107]=537368;f[134108]=537368;f[134109]=537368;c=536440;f[c>>2]=0;f[c+4>>2]=0;C_b(536304);f[134110]=536272;u=a;return}function hmb(){var a=0;d_b(3005001,3005e3,426980);WXb();f[134112]=100620;f[134113]=0;f[134114]=0;f[134115]=0;f[134116]=537368;f[134120]=0;C_b(536448);a=536488;f[a>>2]=0;f[a+4>>2]=0;f[134124]=537368;return}function imb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,426980);WXb();if((f[223155]|0)!=2){f[c>>2]=165456;f[c+4>>2]=102;b[c+8>>0]=0;J_b(892620,c);a_b(c)}f[134126]=100728;f[134127]=0;f[134128]=0;f[134129]=0;f[134130]=0;f[134131]=0;f[134132]=0;f[134133]=0;C_b(536504);u=a;return}function jmb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,426980);WXb();if((f[223156]|0)!=2){f[c>>2]=165456;f[c+4>>2]=103;b[c+8>>0]=0;J_b(892624,c);a_b(c)}f[134134]=100836;f[134135]=0;f[134136]=0;f[134137]=0;f[134138]=0;f[134139]=0;C_b(536536);f[134138]=536504;u=a;return}function kmb(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,426980);WXb();if((f[223157]|0)!=2){f[c>>2]=165456;f[c+4>>2]=104;b[c+8>>0]=0;J_b(892628,c);a_b(c)}f[134140]=100512;f[134141]=0;f[134142]=0;f[134143]=0;f[134144]=537368;f[134146]=0;C_b(536560);f[134148]=536536;u=a;return}function lmb(){var a=0;d_b(3005001,3005e3,426980);WXb();f[134150]=100404;f[134151]=0;f[134152]=0;f[134153]=0;f[134154]=537368;a=536624;f[a>>2]=0;f[a+4>>2]=0;C_b(536600);return}function mmb(a){a=a|0;var c=0,d=0;f[a>>2]=100404;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function nmb(a){a=a|0;mmb(a);cYc(a);return}function omb(a){a=a|0;a=$Xc(32)|0;Cmb(a);return a|0}function pmb(a,b){a=a|0;b=b|0;a=$Xc(32)|0;Cmb(a);if(!b)return a|0;Dmb(b,a);return a|0}function qmb(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function rmb(a){a=a|0;return 1}function smb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+24|0;k=e+8|0;l=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)!=10){r=o;break b}f[h>>2]=f[h>>2]|1;n=f[i>>2]|0;if((n|0)==537368){mHa(i,537368);s=f[i>>2]|0}else s=n;if(l$b(c,s)|0)continue a;else{t=0;p=22;break a}break}case 2:break;default:{r=o;break b}}if((o&255|0)==16){f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;v=a&255;w=0}else{LYb(e,c);a=e;if(!(b[k>>0]|0)){t=0;p=22;break a}else{v=f[a>>2]|0;w=f[a+4>>2]|0}}a=j;f[a>>2]=v;f[a+4>>2]=w;continue a}else r=o}while(0);if(!r){t=1;p=22;break}a=f[l>>2]|0;if(!(a&1))x=lSa(l)|0;else x=a&-2;if(!(Lqc(c,r,x)|0)){t=0;p=22;break}}if((p|0)==22){u=d;return t|0}return 0}function tmb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=a+24|0;k=t1c(f[c>>2]|1|0,f[c+4>>2]|0,1)|0;e=h+1+((((k^63)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function umb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&2|0){c=a+24|0;T_b(2,f[c>>2]|0,f[c+4>>2]|0,b)}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function vmb(a){a=a|0;return f[a+12>>2]|0}function wmb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{c=a+24|0;d=f[c>>2]|0;g=f[c+4>>2]|0;b[e>>0]=16;c=e+1|0;e=d&255;if(g>>>0>0|(g|0)==0&d>>>0>127){i=c;j=e;k=d;d=g;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,d|0,7)|0;l=i+1|0;m=k&255;if(!(d>>>0>0|(d|0)==0&g>>>0>16383)){n=l;o=m;break}else{i=l;j=m;d=J}}}else{n=c;o=e}b[n>>0]=o;h=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=h;return p|0}p=Pqc(n&-2,h)|0;return p|0}function xmb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;do if(f[d>>2]&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);g=a+24|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(c,21568,16816,0)|0;if(!g){Ooc(c,a);return}else{Bmb(a,g);return}}function ymb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16816,0)|0;if(!c){Ooc(b,a);return}else{Bmb(a,c);return}}function zmb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Amb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536728;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Bmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(d&2|0){e=b+24|0;b=f[e+4>>2]|0;c=a+24|0;f[c>>2]=f[e>>2];f[c+4>>2]=b}b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Cmb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=100404;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=536600?(f[223159]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=106;b[d+8>>0]=0;J_b(892636,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Dmb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Emb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=100512;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+24|0;switch(f[c>>2]|0){case 0:break;case 1:{d=f[a+20>>2]|0;if(!d)e=8;else{Yi[f[(f[d>>2]|0)+4>>2]&4095](d);e=8}break}default:e=8}if((e|0)==8)f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}e=a&-2;a=e;if((e|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(e);f[c>>2]=0;return}function Fmb(a){a=a|0;Emb(a);cYc(a);return}function Gmb(a){a=a|0;a=$Xc(28)|0;Wnb(a);return a|0}function Hmb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;Wnb(a);if(!b)return a|0;Xnb(b,a);return a|0}function Imb(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);e=a+24|0;if((f[e>>2]|0)==1?(d=f[a+20>>2]|0,d|0):0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);f[e>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Jmb(a){a=a|0;return 1}function Kmb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+24|0;i=a+20|0;j=e+4|0;k=a+8|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:break;case 6:{if((p&255|0)!=50){s=p;break b}f[k>>2]=f[k>>2]|1;o=f[l>>2]|0;if((o|0)==537368){mHa(l,537368);t=f[l>>2]|0}else t=o;if(l$b(c,t)|0)continue a;else{v=0;q=28;break a}break}default:{s=p;break b}}if((p&255|0)==10){if((f[h>>2]|0)==1)w=f[i>>2]|0;else{f[h>>2]=1;o=$Xc(24)|0;Umb(o);f[i>>2]=o;w=o}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;x=a&255}else{a=YYb(c)|0;if((a|0)>-1)x=a;else{v=0;q=28;break a}}JYb(e,c,x);if((f[j>>2]|0)<0){q=17;break a}if(!(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,c)|0)){q=17;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{v=0;q=28;break a}}else s=p}while(0);if(!s){v=1;q=28;break}a=f[m>>2]|0;if(!(a&1))y=lSa(m)|0;else y=a&-2;if(!(Lqc(c,s,y)|0)){v=0;q=28;break}}if((q|0)==17){v=0;u=d;return v|0}else if((q|0)==28){u=d;return v|0}return 0}function Lmb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;g=b[c+11>>0]|0;h=g<<24>>24<0?f[c+4>>2]|0:g&255;e=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((f[a+24>>2]|0)!=1){i=e;j=a+12|0;f[j>>2]=i;return i|0}h=f[a+20>>2]|0;d=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;i=e+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}function Mmb(a,b){a=a|0;b=b|0;var c=0;if((f[a+24>>2]|0)==1)k$b(1,f[a+20>>2]|0,b);if(f[a+8>>2]&1|0)f$b(6,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Nmb(a){a=a|0;return f[a+12>>2]|0}function Omb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((f[a+24>>2]|0)==1){e=f[a+20>>2]|0;b[d>>0]=10;g=d+1|0;h=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(h>>>0>127){i=h;j=g;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=g;n=h}b[m>>0]=n;o=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,m+1|0)|0}else o=d;if(!(f[a+8>>2]&1))p=o;else{d=f[a+16>>2]|0;b[o>>0]=50;p=gZb(d,o+1|0)|0}o=f[a+4>>2]|0;if(!(o&1)){q=p;return q|0}q=Pqc(o&-2,p)|0;return q|0}function Pmb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;do if(f[d>>2]&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);g=a+24|0;if((f[g>>2]|0)==1?(e=f[a+20>>2]|0,e|0):0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);f[g>>2]=0;f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(c,21568,16832,0)|0;if(!g){Ooc(c,a);return}else{Tmb(a,g);return}}function Qmb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16832,0)|0;if(!c){Ooc(b,a);return}else{Tmb(a,c);return}}function Rmb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Smb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536720;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Tmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}do if(f[b+8>>2]&1|0?(d=a+8|0,f[d>>2]=f[d>>2]|1,d=a+16|0,g=f[b+16>>2]|0,e=f[d>>2]|0,(e|0)!=(g|0)):0)if((e|0)==537368){mHa(d,g);break}else{oYc(e,g)|0;break}while(0);g=b+24|0;if((f[g>>2]|0)!=1)return;e=a+24|0;if((f[e>>2]|0)!=1){f[e>>2]=1;e=$Xc(24)|0;Umb(e);f[a+20>>2]=e;if((f[g>>2]|0)==1){h=e;i=15}else{j=e;k=536536}}else{h=f[a+20>>2]|0;i=15}if((i|0)==15){j=h;k=f[b+20>>2]|0}Vmb(j,k);return}function Umb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=100836;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=536536?(f[223157]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=104;b[d+8>>0]=0;J_b(892628,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Vmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){c=$Xc(32)|0;Wmb(c);f[g>>2]=c;h=c}else h=e;e=f[b+16>>2]|0;c=e|0?e:536504;e=h+4|0;g=f[c+4>>2]|0;if(g&1|0){i=f[e>>2]|0;if(!(i&1))j=lSa(e)|0;else j=i&-2;vqc(j,g&-2)}Xmb(h+16|0,c+16|0)}if(d&2|0)f[a+20>>2]=f[b+20>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Wmb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=100728;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=536504?(f[223156]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=103;b[d+8>>0]=0;J_b(892624,d);a_b(d)}f[a+12>>2]=0;u=c;return}function Xmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Zmb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(40)|0;Ymb(l);Zmb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16848,40);l=RXb(i,40,2259)|0;Ymb(l);Zmb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Ymb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=100620;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=536448?(f[223155]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=102;b[d+8>>0]=0;J_b(892620,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+32>>2]=0;u=c;return}function Zmb(a,b){a=a|0;b=b|0;$mb(b,a);return}function _mb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function $mb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}do if(f[c+8>>2]&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+16|0,h=f[c+16>>2]|0,g=f[e>>2]|0,(g|0)!=(h|0)):0)if((g|0)==537368){mHa(e,h);break}else{oYc(g,h)|0;break}while(0);switch(f[c+32>>2]|0){case 1:{h=c+24|0;g=f[h>>2]|0;e=f[h+4>>2]|0;h=a+32|0;switch(f[h>>2]|0){case 1:break;case 2:{d=f[a+24>>2]|0;if((d|0)==537368|(d|0)==0)i=17;else{if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);cYc(d);i=17}break}default:i=17}if((i|0)==17)f[h>>2]=1;h=a+24|0;f[h>>2]=g;f[h+4>>2]=e;return}case 2:{e=f[c+24>>2]|0;c=a+32|0;if((f[c>>2]|0)==2){h=a+24|0;g=f[h>>2]|0;if((g|0)==537368)j=h;else{oYc(g,e)|0;return}}else{f[c>>2]=2;c=a+24|0;f[c>>2]=537368;j=c}mHa(j,e);return}default:return}}function anb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=100620;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+32|0;switch(f[c>>2]|0){case 0:break;case 2:{d=f[a+24>>2]|0;if((d|0)==537368|(d|0)==0)e=10;else{if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);cYc(d);e=10}break}default:e=10}if((e|0)==10)f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}e=a&-2;a=e;if((e|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(e);f[c>>2]=0;return}function bnb(a){a=a|0;anb(a);cYc(a);return}function cnb(a){a=a|0;a=$Xc(40)|0;Ymb(a);return a|0}function dnb(a,b){a=a|0;b=b|0;a=$Xc(40)|0;Ymb(a);if(!b)return a|0;pnb(b,a);return a|0}function enb(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);e=a+32|0;if((f[e>>2]|0)==2?(d=f[a+24>>2]|0,!((d|0)==537368|(d|0)==0)):0){if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);cYc(d)}f[e>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function fnb(a){a=a|0;return 1}function gnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+32|0;i=a+24|0;j=a+24|0;k=e+8|0;l=a+8|0;m=a+16|0;n=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=ZYb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=8){t=q;break b}if((f[h>>2]|0)==2?(p=f[i>>2]|0,!((p|0)==537368|(p|0)==0)):0){if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);cYc(p)}f[h>>2]=0;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(a=b[p>>0]|0,a<<24>>24>-1):0){f[c>>2]=p+1;v=a&255;w=0}else{LYb(e,c);a=e;if(!(b[k>>0]|0)){x=0;r=33;break a}else{v=f[a>>2]|0;w=f[a+4>>2]|0}}a=j;f[a>>2]=v;f[a+4>>2]=w;f[h>>2]=1;continue a;break}case 2:{if((q&255|0)!=18){t=q;break b}if((f[h>>2]|0)==2){a=f[i>>2]|0;if((a|0)==537368)r=22;else y=a}else{f[h>>2]=2;f[i>>2]=537368;r=22}if((r|0)==22){r=0;mHa(i,537368);y=f[i>>2]|0}if(l$b(c,y)|0)continue a;else{x=0;r=33;break a}break}case 3:{if((q&255|0)!=26){t=q;break b}f[l>>2]=f[l>>2]|1;a=f[m>>2]|0;if((a|0)==537368){mHa(m,537368);z=f[m>>2]|0}else z=a;if(l$b(c,z)|0)continue a;else{x=0;r=33;break a}break}default:{t=q;break b}}}while(0);if(!t){x=1;r=33;break}a=f[n>>2]|0;if(!(a&1))A=lSa(n)|0;else A=a&-2;if(!(Lqc(c,t,A)|0)){x=0;r=33;break}}if((r|0)==33){u=d;return x|0}return 0}function hnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;g=b[c+11>>0]|0;h=g<<24>>24<0?f[c+4>>2]|0:g&255;e=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}switch(f[a+32>>2]|0){case 1:{h=a+24|0;i=e+1+(((((t1c(f[h>>2]|1|0,f[h+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}case 2:{h=f[a+24>>2]|0;d=b[h+11>>0]|0;g=d<<24>>24<0?f[h+4>>2]|0:d&255;i=e+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}default:{i=e;j=a+12|0;f[j>>2]=i;return i|0}}return 0}function inb(a,b){a=a|0;b=b|0;var c=0;switch(f[a+32>>2]|0){case 1:{c=a+24|0;T_b(1,f[c>>2]|0,f[c+4>>2]|0,b);break}case 2:{f$b(2,f[a+24>>2]|0,b);break}default:{}}if(f[a+8>>2]&1|0)f$b(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function jnb(a){a=a|0;return f[a+12>>2]|0}function knb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;switch(f[a+32>>2]|0){case 1:{c=a+24|0;e=f[c>>2]|0;g=f[c+4>>2]|0;b[d>>0]=8;c=d+1|0;h=e&255;if(g>>>0>0|(g|0)==0&e>>>0>127){i=c;j=h;k=e;e=g;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,e|0,7)|0;l=i+1|0;m=k&255;if(!(e>>>0>0|(e|0)==0&g>>>0>16383)){n=l;o=m;break}else{i=l;j=m;e=J}}}else{n=c;o=h}b[n>>0]=o;p=n+1|0;break}case 2:{n=f[a+24>>2]|0;b[d>>0]=18;p=gZb(n,d+1|0)|0;break}default:p=d}if(!(f[a+8>>2]&1))q=p;else{d=f[a+16>>2]|0;b[p>>0]=26;q=gZb(d,p+1|0)|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Pqc(p&-2,q)|0;return r|0}function lnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;do if(f[d>>2]&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);g=a+32|0;if((f[g>>2]|0)==2?(e=f[a+24>>2]|0,!((e|0)==537368|(e|0)==0)):0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}f[g>>2]=0;f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(c,21568,16848,0)|0;if(!g){Ooc(c,a);return}else{$mb(a,g);return}}function mnb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16848,0)|0;if(!c){Ooc(b,a);return}else{$mb(a,c);return}}function nnb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function onb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536696;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function pnb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function qnb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=100728;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function rnb(a){a=a|0;qnb(a);cYc(a);return}function snb(a){a=a|0;a=$Xc(32)|0;Wmb(a);return a|0}function tnb(a,b){a=a|0;b=b|0;a=$Xc(32)|0;Wmb(a);if(!b)return a|0;Fnb(b,a);return a|0}function unb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+8|0;do if(f[i>>2]&1|0){j=f[h+16>>2]|0;k=j+11|0;if((b[k>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[k>>0]=0;break}}while(0);k=h+32|0;if((f[k>>2]|0)==2?(j=f[h+24>>2]|0,!((j|0)==537368|(j|0)==0)):0){if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(j)}f[k>>2]=0;f[i>>2]=0;k=f[h+4>>2]|0;if(k&1|0?(j=k&-2,f[j>>2]|0):0)sqc(j)}while((g|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function vnb(a){a=a|0;return 1}function wnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;XZb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=$Xc(40)|0;Ymb(a);y=a}else{if(f[o+64>>2]|0)SXb(o,16848,40);a=RXb(o,40,2259)|0;Ymb(a);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=YYb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}JYb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(OYb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=lSa(m)|0;else B=a&-2;if(!(Lqc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function xnb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function ynb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function znb(a){a=a|0;return f[a+12>>2]|0}function Anb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Pqc(j&-2,g)|0;return s|0}function Bnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;unb(a);c=kZc(b,21568,16864,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}Xmb(a+16|0,c+16|0);return}function Cnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16864,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}Xmb(a+16|0,c+16|0);return}function Dnb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Enb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536704;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Fnb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Gnb(a){a=a|0;var b=0,c=0;f[a>>2]=100836;if((a|0)!=536536?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Hnb(a){a=a|0;var b=0,c=0;f[a>>2]=100836;if((a|0)!=536536?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Inb(a){a=a|0;a=$Xc(24)|0;Umb(a);return a|0}function Jnb(a,b){a=a|0;b=b|0;a=$Xc(24)|0;Umb(a);if(!b)return a|0;Vnb(b,a);return a|0}function Knb(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&1|0)unb(f[a+16>>2]|0);f[a+20>>2]=0;f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Lnb(a){a=a|0;return 1}function Mnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+4|0;l=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=7}else{q=n;p=6}}else{q=0;p=6}if((p|0)==6){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=7}else r=n}c:do if((p|0)==7){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)==8)break b;else{r=o;break c}break}case 2:break;default:{r=o;break c}}if((o&255|0)==18){f[h>>2]=f[h>>2]|1;n=f[i>>2]|0;if(!n){a=$Xc(32)|0;Wmb(a);f[i>>2]=a;s=a}else s=n;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;t=a&255}else{a=YYb(c)|0;if((a|0)>-1)t=a;else{v=0;p=35;break a}}JYb(e,c,t);if((f[j>>2]|0)<0){p=28;break a}if(!(Mi[f[(f[s>>2]|0)+44>>2]&1023](s,c)|0)){p=28;break a}if(OYb(c,f[e>>2]|0)|0)continue b;else{v=0;p=35;break a}}else r=o}while(0);if(!r){v=1;p=35;break a}a=f[k>>2]|0;if(!(a&1))w=lSa(k)|0;else w=a&-2;if(!(Lqc(c,r,w)|0)){v=0;p=35;break a}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;m=n&255;if(n<<24>>24>-1){f[c>>2]=a+1;x=m}else{y=m;p=12}}else{y=0;p=12}if((p|0)==12){p=0;m=KYb(c,y)|0;a=J;if((a|0)>-1|(a|0)==-1&m>>>0>4294967295)x=m;else{v=0;p=35;break}}if(x>>>0<16){f[h>>2]=f[h>>2]|2;f[l>>2]=x;continue}m=f[k>>2]|0;if(!(m&1))z=lSa(k)|0;else z=m&-2;yqc(z,1,x,((x|0)<0)<<31>>31)}if((p|0)==28){v=0;u=d;return v|0}else if((p|0)==35){u=d;return v|0}return 0}function Nnb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&3)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+20>>2]|0;if((i|0)<0)k=11;else k=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=k+h|0;g=a+12|0;f[g>>2]=e;return e|0}function Onb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)d$b(1,f[a+20>>2]|0,b);if(c&1|0)k$b(2,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Pnb(a){a=a|0;return f[a+12>>2]|0}function Qnb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&1))r=g;else{e=f[a+16>>2]|0;b[g>>0]=18;p=g+1|0;g=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(g>>>0>127){q=g;d=p;while(1){b[d>>0]=q|128;i=q>>>7;m=d+1|0;if(q>>>0>16383){q=i;d=m}else{s=m;t=i;break}}}else{s=p;t=g}b[s>>0]=t;r=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,s+1|0)|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Pqc(s&-2,r)|0;return u|0}function Rnb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&1|0)unb(f[a+16>>2]|0);f[a+20>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,16880,0)|0;if(!d){Ooc(b,a);return}else{Vmb(a,d);return}}function Snb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16880,0)|0;if(!c){Ooc(b,a);return}else{Vmb(a,c);return}}function Tnb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Unb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536712;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Vnb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Wnb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=100512;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=536560?(f[223158]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=105;b[d+8>>0]=0;J_b(892632,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+24>>2]=0;u=c;return}function Xnb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Ynb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=100944;Iob(a);c=f[a+116>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+100>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+84>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+72|0;d=f[c>>2]|0;if(d|0?(f[a+60>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=f[a+52>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+36>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[c>>2]=0;return}function Znb(a){a=a|0;Ynb(a);cYc(a);return}function _nb(a){a=a|0;a=$Xc(144)|0;Gob(a);return a|0}function $nb(a,b){a=a|0;b=b|0;a=$Xc(144)|0;Gob(a);if(!b)return a|0;Hob(b,a);return a|0}function aob(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a+16>>2]=0;f[a+28>>2]=0;f[a+44>>2]=0;c=a+64|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+72>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+76>>2]=0;f[a+92>>2]=0;f[a+108>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&15|0){do if(d&1|0){g=f[a+124>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+128>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+132>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&8|0){d=f[a+136>>2]|0;e=d+8|0;if(f[e>>2]&3|0){g=d+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d)}}f[a+140>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function bob(a){a=a|0;return 1}function cob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+16|0;j=a+20|0;k=a+24|0;l=e+8|0;m=e+8|0;n=a+8|0;o=a+140|0;q=a+4|0;r=a+136|0;t=e+4|0;v=a+28|0;w=a+32|0;x=a+36|0;y=a+44|0;z=a+48|0;A=a+52|0;B=a+60|0;C=a+76|0;D=a+80|0;E=a+84|0;F=e+8|0;G=a+124|0;H=a+128|0;I=a+92|0;K=a+96|0;L=a+100|0;M=a+108|0;N=a+112|0;O=a+116|0;P=e+8|0;Q=a+132|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;S=R&255;if(R<<24>>24>0){f[c>>2]=a+1;T=S;U=6}else{V=S;U=5}}else{V=0;U=5}if((U|0)==5){U=0;S=ZYb(c,V)|0;if((S+-1|0)>>>0<127){T=S;U=6}else W=S}b:do if((U|0)==6){U=0;do switch(T>>>3&536870911|0){case 1:{switch((T&255)<<24>>24){case 8:break;case 10:{if(Eob(c,i)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}S=f[c>>2]|0;if(S>>>0<(f[g>>2]|0)>>>0?(a=b[S>>0]|0,a<<24>>24>-1):0){f[c>>2]=S+1;Y=a&255;Z=0}else{LYb(e,c);a=e;if(!(b[m>>0]|0)){X=0;U=156;break a}else{Y=f[a>>2]|0;Z=f[a+4>>2]|0}}a=f[i>>2]|0;S=f[j>>2]|0;if((a|0)==(S|0)){_Ma(i,a+1|0);_=f[i>>2]|0;$=f[j>>2]|0}else{_=a;$=S}S=f[k>>2]|0;a=_+1|0;f[i>>2]=a;R=S+8+(_<<3)|0;f[R>>2]=Y;f[R+4>>2]=Z;R=$-a|0;if((R|0)>0){aa=R;ba=a;ca=S}else continue a;while(1){S=f[c>>2]|0;a=f[g>>2]|0;if(S>>>0>=a>>>0)continue a;if((b[S>>0]|0)!=8)continue a;R=S+1|0;f[c>>2]=R;if(R>>>0<a>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=S+2;da=a&255;ea=0;fa=ba;ga=ca}else{LYb(e,c);a=e;if(!(b[l>>0]|0)){X=0;U=156;break a}da=f[a>>2]|0;ea=f[a+4>>2]|0;fa=f[i>>2]|0;ga=f[k>>2]|0}a=fa+1|0;f[i>>2]=a;S=ga+8+(fa<<3)|0;f[S>>2]=da;f[S+4>>2]=ea;if((aa|0)>1){aa=aa+-1|0;ba=a;ca=ga}else continue a}break}case 2:{if((T&255|0)!=16){W=T;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){S=b[a>>0]|0;R=S&255;if(S<<24>>24>-1){f[c>>2]=a+1;ha=R}else{ia=R;U=28}}else{ia=0;U=28}if((U|0)==28){U=0;R=KYb(c,ia)|0;a=J;if((a|0)>-1|(a|0)==-1&R>>>0>4294967295)ha=R;else{X=0;U=156;break a}}if(ha>>>0<16){f[n>>2]=f[n>>2]|16;f[o>>2]=ha;continue a}R=f[q>>2]|0;if(!(R&1))ja=lSa(q)|0;else ja=R&-2;yqc(ja,2,ha,((ha|0)<0)<<31>>31);continue a;break}case 3:{if((T&255|0)!=26){W=T;break b}f[n>>2]=f[n>>2]|8;R=f[r>>2]|0;if(!R){a=$Xc(32)|0;nob(a);f[r>>2]=a;ka=a}else ka=R;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;la=a&255}else{a=YYb(c)|0;if((a|0)>-1)la=a;else{X=0;U=156;break a}}JYb(e,c,la);if((f[t>>2]|0)<0){U=44;break a}if(!(Mi[f[(f[ka>>2]|0)+44>>2]&1023](ka,c)|0)){U=44;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{X=0;U=156;break a}break}case 4:{switch((T&255)<<24>>24){case 34:break;case 37:{if(eUa(1,34,c,v)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;ma=R&255}else{R=YYb(c)|0;if((R|0)>-1)ma=R;else{X=0;U=156;break a}}na=f[v>>2]|0;R=(ma|0)/4|0;if((R<<2|0)!=(ma|0)){X=0;U=156;break a}a=RYb(c)|0;S=PYb(c)|0;if((((a|0)==-1|(S|0)<(a|0)?S:a)|0)>=(ma|0)){a=na+R|0;if((f[v>>2]|0)<(a|0)?(uHa(v,a),S=f[v>>2]|0,oa=a-S|0,(oa<<2|0)>0):0)g1c((f[x>>2]|0)+((S<<2)+4)|0,0,(((oa|-1073741824|0)==-1073741824?1073741823:1073741822)+oa<<2)+8|0)|0;f[v>>2]=a;a=f[x>>2]|0;if(TYb(c,((a|0)==0?0:a+4|0)+(na<<2)|0,ma)|0)continue a;else{U=58;break a}}if((ma|0)>3)pa=0;else continue a;while(1){a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){oa=a;S=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;f[e>>2]=S;f[c>>2]=a+4;qa=S}else{if(!(WYb(c,e)|0)){U=67;break a}qa=f[e>>2]|0}S=f[v>>2]|0;if((S|0)==(f[w>>2]|0)){uHa(v,S+1|0);ra=f[v>>2]|0}else ra=S;S=f[x>>2]|0;f[v>>2]=ra+1;f[S+4+(ra<<2)>>2]=qa;S=pa+1|0;if((S|0)<(R|0))pa=S;else continue a}break}case 5:{switch((T&255)<<24>>24){case 42:break;case 40:{if(OUa(1,42,c,y)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(S=b[R>>0]|0,S<<24>>24>-1):0){f[c>>2]=R+1;sa=S&255}else{S=YYb(c)|0;if((S|0)>-1)sa=S;else{X=0;U=156;break a}}S=HYb(c,sa)|0;if((PYb(c)|0)>0)do{R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){a=b[R>>0]|0;oa=a&255;if(a<<24>>24>-1){f[c>>2]=R+1;ta=oa}else{ua=oa;U=78}}else{ua=0;U=78}if((U|0)==78){U=0;oa=KYb(c,ua)|0;R=J;if((R|0)>-1|(R|0)==-1&oa>>>0>4294967295)ta=oa;else{X=0;U=156;break a}}oa=f[y>>2]|0;if((oa|0)==(f[z>>2]|0)){qHa(y,oa+1|0);va=f[y>>2]|0}else va=oa;oa=f[A>>2]|0;f[y>>2]=va+1;f[oa+4+(va<<2)>>2]=ta}while((PYb(c)|0)>0);IYb(c,S);continue a;break}case 6:{if((T&255|0)!=50){W=T;break b}if(l$b(c,pHa(B)|0)|0)continue a;else{X=0;U=156;break a}break}case 7:{switch((T&255)<<24>>24){case 58:break;case 56:{if(dUa(1,58,c,C)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(R=b[oa>>0]|0,R<<24>>24>-1):0){f[c>>2]=oa+1;wa=R&255}else{R=YYb(c)|0;if((R|0)>-1)wa=R;else{X=0;U=156;break a}}R=HYb(c,wa)|0;if((PYb(c)|0)>0)do{oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(a=b[oa>>0]|0,a<<24>>24>-1):0){f[c>>2]=oa+1;xa=a&255;ya=0}else{LYb(e,c);a=e;if(!(b[F>>0]|0)){X=0;U=156;break a}else{xa=f[a>>2]|0;ya=f[a+4>>2]|0}}a=f[C>>2]|0;if((a|0)==(f[D>>2]|0)){_Ma(C,a+1|0);za=f[C>>2]|0}else za=a;a=f[E>>2]|0;f[C>>2]=za+1;oa=a+8+(za<<3)|0;f[oa>>2]=xa;f[oa+4>>2]=ya}while((PYb(c)|0)>0);IYb(c,R);continue a;break}case 8:{if((T&255|0)!=66){W=T;break b}f[n>>2]=f[n>>2]|1;S=f[G>>2]|0;if((S|0)==537368){mHa(G,537368);Aa=f[G>>2]|0}else Aa=S;if(l$b(c,Aa)|0)continue a;else{X=0;U=156;break a}break}case 9:{if((T&255|0)!=74){W=T;break b}f[n>>2]=f[n>>2]|2;S=f[H>>2]|0;if((S|0)==537368){mHa(H,537368);Ba=f[H>>2]|0}else Ba=S;if(l$b(c,Ba)|0)continue a;else{X=0;U=156;break a}break}case 10:{switch((T&255)<<24>>24){case 82:break;case 81:{if(NUa(1,82,c,I)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}S=f[c>>2]|0;if(S>>>0<(f[g>>2]|0)>>>0?(oa=b[S>>0]|0,oa<<24>>24>-1):0){f[c>>2]=S+1;Ca=oa&255}else{oa=YYb(c)|0;if((oa|0)>-1)Ca=oa;else{X=0;U=156;break a}}Da=f[I>>2]|0;oa=(Ca|0)/8|0;if((oa<<3|0)!=(Ca|0)){X=0;U=156;break a}S=RYb(c)|0;a=PYb(c)|0;if((((S|0)==-1|(a|0)<(S|0)?a:S)|0)>=(Ca|0)){S=Da+oa|0;if((f[I>>2]|0)<(S|0)?(ZMa(I,S),a=f[I>>2]|0,Ea=S-a|0,(Ea<<3|0)>0):0)g1c((f[L>>2]|0)+((a<<3)+8)|0,0,(((Ea|-536870912|0)==-536870912?536870911:536870910)+Ea<<3)+16|0)|0;f[I>>2]=S;S=f[L>>2]|0;if(TYb(c,((S|0)==0?0:S+8|0)+(Da<<3)|0,Ca)|0)continue a;else{U=121;break a}}if((Ca|0)>7)Fa=0;else continue a;while(1){S=f[c>>2]|0;if(((f[g>>2]|0)-S|0)>7){Ea=S;a=Ea;Ga=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=Ea+4|0;Ea=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=e;f[a>>2]=Ga;f[a+4>>2]=Ea;f[c>>2]=S+8;f[s>>2]=Ga;f[s+4>>2]=Ea;Ha=+p[s>>3]}else{if(!(XYb(c,e)|0)){U=130;break a}Ha=+p[e>>3]}Ea=f[I>>2]|0;if((Ea|0)==(f[K>>2]|0)){ZMa(I,Ea+1|0);Ia=f[I>>2]|0}else Ia=Ea;Ea=f[L>>2]|0;f[I>>2]=Ia+1;p[Ea+8+(Ia<<3)>>3]=Ha;Ea=Fa+1|0;if((Ea|0)<(oa|0))Fa=Ea;else continue a}break}case 11:{switch((T&255)<<24>>24){case 90:break;case 88:{if(Fob(1,90,c,M)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(R=b[oa>>0]|0,R<<24>>24>-1):0){f[c>>2]=oa+1;Ja=R&255}else{R=YYb(c)|0;if((R|0)>-1)Ja=R;else{X=0;U=156;break a}}R=HYb(c,Ja)|0;if((PYb(c)|0)>0)do{oa=f[c>>2]|0;if(oa>>>0<(f[g>>2]|0)>>>0?(Ea=b[oa>>0]|0,Ea<<24>>24>-1):0){f[c>>2]=oa+1;Ka=Ea&255;La=0}else{LYb(e,c);Ea=e;if(!(b[P>>0]|0)){X=0;U=156;break a}else{Ka=f[Ea>>2]|0;La=f[Ea+4>>2]|0}}Ea=f[M>>2]|0;if((Ea|0)==(f[N>>2]|0)){mob(M,Ea+1|0);Ma=f[M>>2]|0}else Ma=Ea;Ea=f[O>>2]|0;f[M>>2]=Ma+1;oa=Ea+8+(Ma<<3)|0;f[oa>>2]=Ka;f[oa+4>>2]=La}while((PYb(c)|0)>0);IYb(c,R);continue a;break}case 12:{if((T&255|0)!=98){W=T;break b}f[n>>2]=f[n>>2]|4;oa=f[Q>>2]|0;if((oa|0)==537368){mHa(Q,537368);Na=f[Q>>2]|0}else Na=oa;if(l$b(c,Na)|0)continue a;else{X=0;U=156;break a}break}default:{W=T;break b}}while(0)}while(0);if(!W){X=1;U=156;break}oa=f[q>>2]|0;if(!(oa&1))Oa=lSa(q)|0;else Oa=oa&-2;if(!(Lqc(c,W,Oa)|0)){X=0;U=156;break}}if((U|0)==44){X=0;u=d;return X|0}else if((U|0)==58){if((f[v>>2]|0)<=0){X=0;u=d;return X|0}f[v>>2]=na;X=0;u=d;return X|0}else if((U|0)==67){X=0;u=d;return X|0}else if((U|0)==121){if((f[I>>2]|0)<=0){X=0;u=d;return X|0}f[I>>2]=Da;X=0;u=d;return X|0}else if((U|0)==130){X=0;u=d;return X|0}else if((U|0)==156){u=d;return X|0}return 0}function dob(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+16>>2]|0;if((c|0)>0){e=f[a+24>>2]|0;g=0;h=0;while(1){i=e+8+(h<<3)|0;j=t1c(f[i>>2]|1|0,f[i+4>>2]|0,1)|0;i=((((j^63)*9|0)+73|0)>>>6)+g|0;h=h+1|0;if((h|0)==(c|0)){k=i;break}else g=i}}else k=0;g=k+d+c|0;c=f[a+28>>2]<<2;if(!c)l=g;else{if((c|0)<0)m=10;else m=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;l=g+1+m|0}f[a+40>>2]=c;m=l+c|0;c=n$b(a+44|0)|0;if(!c)n=m;else{if((c|0)<0)o=10;else o=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;n=m+1+o|0}f[a+56>>2]=c;o=f[a+64>>2]|0;m=n+c+o|0;if((o|0)>0){c=f[a+72>>2]|0;n=0;l=m;while(1){g=f[c+4+(n<<2)>>2]|0;d=b[g+11>>0]|0;k=d<<24>>24<0?f[g+4>>2]|0:d&255;d=k+l+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(o|0)){p=d;break}else l=d}}else p=m;m=f[a+76>>2]|0;if((m|0)>0){l=f[a+84>>2]|0;o=0;n=0;do{c=l+8+(n<<3)|0;d=t1c(f[c>>2]|1|0,f[c+4>>2]|0,1)|0;o=((((d^63)*9|0)+73|0)>>>6)+o|0;n=n+1|0}while((n|0)!=(m|0));if(o){if((o|0)<0)q=11;else q=((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=o;s=q+p|0}else{r=0;s=p}}else{r=0;s=p}f[a+88>>2]=r;p=s+r|0;r=f[a+92>>2]<<3;if(!r)t=p;else{if((r|0)<0)u=11;else u=((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;t=u+p|0}f[a+104>>2]=r;p=t+r|0;r=f[a+108>>2]|0;if((r|0)>0){t=f[a+116>>2]|0;u=0;s=0;do{q=t+8+(s<<3)|0;o=t1c(f[q>>2]|1|0,f[q+4>>2]|0,1)|0;u=((((o^63)*9|0)+73|0)>>>6)+u|0;s=s+1|0}while((s|0)!=(r|0));if(u){if((u|0)<0)v=11;else v=((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;w=u;x=v+p|0}else{w=0;x=p}}else{w=0;x=p}f[a+120>>2]=w;p=x+w|0;w=a+8|0;x=f[w>>2]|0;if(!(x&31)){y=p;z=a+12|0;f[z>>2]=y;return y|0}if(!(x&1))A=p;else{v=f[a+124>>2]|0;u=b[v+11>>0]|0;r=u<<24>>24<0?f[v+4>>2]|0:u&255;A=p+1+r+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(x&2))B=A;else{r=f[a+128>>2]|0;p=b[r+11>>0]|0;u=p<<24>>24<0?f[r+4>>2]|0:p&255;B=A+1+u+((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(x&4))C=B;else{u=f[a+132>>2]|0;A=b[u+11>>0]|0;p=A<<24>>24<0?f[u+4>>2]|0:A&255;C=B+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(x&8)){D=C;E=x}else{x=f[a+136>>2]|0;p=_i[f[(f[x>>2]|0)+48>>2]&2047](x)|0;x=C+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=x;E=f[w>>2]|0}if(!(E&16)){y=D;z=a+12|0;f[z>>2]=y;return y|0}E=f[a+140>>2]|0;if((E|0)<0)F=11;else F=((((($(E|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;y=F+D|0;z=a+12|0;f[z>>2]=y;return y|0}function eob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{h=(f[e>>2]|0)+8+(g<<3)|0;T_b(1,f[h>>2]|0,f[h+4>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=f[a+8>>2]|0;if(d&16|0)d$b(2,f[a+140>>2]|0,c);if(d&8|0)k$b(3,f[a+136>>2]|0,c);g=a+28|0;if((f[g>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){h=c+4|0;b[f[h>>2]>>0]=34;f[h>>2]=(f[h>>2]|0)+1;h=(f[e>>2]|0)+-1|0;f[e>>2]=h;i=h}else{eZb(c,34);i=f[e>>2]|0}h=f[a+40>>2]|0;if((i|0)>4){i=c+4|0;j=f[i>>2]|0;if(h>>>0>127){k=h;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=h}b[o>>0]=p;p=o+1-j|0;f[i>>2]=(f[i>>2]|0)+p;f[e>>2]=(f[e>>2]|0)-p}else eZb(c,h);h=f[a+36>>2]|0;P_b((h|0)==0?0:h+4|0,f[g>>2]|0,c)}g=a+44|0;if((f[g>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){p=c+4|0;b[f[p>>2]>>0]=42;f[p>>2]=(f[p>>2]|0)+1;p=(f[h>>2]|0)+-1|0;f[h>>2]=p;q=p}else{eZb(c,42);q=f[h>>2]|0}p=f[a+56>>2]|0;if((q|0)>4){q=c+4|0;e=f[q>>2]|0;if(p>>>0>127){i=p;j=e;while(1){b[j>>0]=i|128;o=i>>>7;l=j+1|0;if(i>>>0>16383){i=o;j=l}else{r=l;s=o;break}}}else{r=e;s=p}b[r>>0]=s;s=r+1-e|0;f[q>>2]=(f[q>>2]|0)+s;f[h>>2]=(f[h>>2]|0)-s}else eZb(c,p);p=f[g>>2]|0;if((p|0)>0){g=a+52|0;s=c+8|0;h=c+4|0;q=0;do{e=f[(f[g>>2]|0)+4+(q<<2)>>2]|0;r=((e|0)<0)<<31>>31;if((f[s>>2]|0)>9){j=f[h>>2]|0;i=e&255;if(e>>>0>127){o=j;l=i;k=e;m=r;while(1){b[o>>0]=l|-128;n=k;k=l1c(k|0,m|0,7)|0;t=o+1|0;u=k&255;if(!(m>>>0>0|(m|0)==0&n>>>0>16383)){v=t;w=u;break}else{o=t;l=u;m=J}}}else{v=j;w=i}b[v>>0]=w;m=v+1-j|0;f[h>>2]=(f[h>>2]|0)+m;f[s>>2]=(f[s>>2]|0)-m}else fZb(c,e,r);q=q+1|0}while((q|0)!=(p|0))}}p=f[a+64>>2]|0;if((p|0)>0){q=a+72|0;s=0;do{g$b(6,f[(f[q>>2]|0)+4+(s<<2)>>2]|0,c);s=s+1|0}while((s|0)!=(p|0))}p=a+76|0;if((f[p>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){q=c+4|0;b[f[q>>2]>>0]=58;f[q>>2]=(f[q>>2]|0)+1;q=(f[s>>2]|0)+-1|0;f[s>>2]=q;x=q}else{eZb(c,58);x=f[s>>2]|0}q=f[a+88>>2]|0;if((x|0)>4){x=c+4|0;h=f[x>>2]|0;if(q>>>0>127){v=q;w=h;while(1){b[w>>0]=v|128;g=v>>>7;m=w+1|0;if(v>>>0>16383){v=g;w=m}else{y=m;z=g;break}}}else{y=h;z=q}b[y>>0]=z;z=y+1-h|0;f[x>>2]=(f[x>>2]|0)+z;f[s>>2]=(f[s>>2]|0)-z}else eZb(c,q);q=f[p>>2]|0;if((q|0)>0){p=a+84|0;z=c+8|0;s=c+4|0;x=0;do{h=(f[p>>2]|0)+8+(x<<3)|0;y=f[h>>2]|0;w=f[h+4>>2]|0;if((f[z>>2]|0)>9){h=f[s>>2]|0;v=y&255;if(w>>>0>0|(w|0)==0&y>>>0>127){g=h;m=v;l=y;o=w;while(1){b[g>>0]=m|-128;k=l;l=l1c(l|0,o|0,7)|0;u=g+1|0;t=l&255;if(!(o>>>0>0|(o|0)==0&k>>>0>16383)){A=u;B=t;break}else{g=u;m=t;o=J}}}else{A=h;B=v}b[A>>0]=B;o=A+1-h|0;f[s>>2]=(f[s>>2]|0)+o;f[z>>2]=(f[z>>2]|0)-o}else fZb(c,y,w);x=x+1|0}while((x|0)!=(q|0))}}if(d&1|0)f$b(8,f[a+124>>2]|0,c);if(d&2|0)h$b(9,f[a+128>>2]|0,c);q=a+92|0;if((f[q>>2]|0)>0){x=c+8|0;if((f[x>>2]|0)>4){z=c+4|0;b[f[z>>2]>>0]=82;f[z>>2]=(f[z>>2]|0)+1;z=(f[x>>2]|0)+-1|0;f[x>>2]=z;C=z}else{eZb(c,82);C=f[x>>2]|0}z=f[a+104>>2]|0;if((C|0)>4){C=c+4|0;s=f[C>>2]|0;if(z>>>0>127){A=z;B=s;while(1){b[B>>0]=A|128;p=A>>>7;o=B+1|0;if(A>>>0>16383){A=p;B=o}else{D=o;E=p;break}}}else{D=s;E=z}b[D>>0]=E;E=D+1-s|0;f[C>>2]=(f[C>>2]|0)+E;f[x>>2]=(f[x>>2]|0)-E}else eZb(c,z);z=f[a+100>>2]|0;Q_b((z|0)==0?0:z+8|0,f[q>>2]|0,c)}q=a+108|0;if((f[q>>2]|0)>0){z=c+8|0;if((f[z>>2]|0)>4){E=c+4|0;b[f[E>>2]>>0]=90;f[E>>2]=(f[E>>2]|0)+1;E=(f[z>>2]|0)+-1|0;f[z>>2]=E;F=E}else{eZb(c,90);F=f[z>>2]|0}E=f[a+120>>2]|0;if((F|0)>4){F=c+4|0;x=f[F>>2]|0;if(E>>>0>127){C=E;s=x;while(1){b[s>>0]=C|128;D=C>>>7;B=s+1|0;if(C>>>0>16383){C=D;s=B}else{G=B;H=D;break}}}else{G=x;H=E}b[G>>0]=H;H=G+1-x|0;f[F>>2]=(f[F>>2]|0)+H;f[z>>2]=(f[z>>2]|0)-H}else eZb(c,E);E=f[q>>2]|0;if((E|0)>0){q=a+116|0;H=c+8|0;z=c+4|0;F=0;do{x=(f[q>>2]|0)+8+(F<<3)|0;G=f[x>>2]|0;s=f[x+4>>2]|0;if((f[H>>2]|0)>9){x=f[z>>2]|0;C=G&255;if(s>>>0>0|(s|0)==0&G>>>0>127){D=x;B=C;A=G;p=s;while(1){b[D>>0]=B|-128;o=A;A=l1c(A|0,p|0,7)|0;m=D+1|0;g=A&255;if(!(p>>>0>0|(p|0)==0&o>>>0>16383)){I=m;K=g;break}else{D=m;B=g;p=J}}}else{I=x;K=C}b[I>>0]=K;p=I+1-x|0;f[z>>2]=(f[z>>2]|0)+p;f[H>>2]=(f[H>>2]|0)-p}else fZb(c,G,s);F=F+1|0}while((F|0)!=(E|0))}}if(d&4|0)f$b(12,f[a+132>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function fob(a){a=a|0;return f[a+12>>2]|0}function gob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=f[a+16>>2]|0;if(!e)g=d;else{h=f[a+24>>2]|0;i=0;j=d;while(1){d=h+8+(i<<3)|0;k=f[d>>2]|0;l=f[d+4>>2]|0;b[j>>0]=8;d=j+1|0;m=k&255;if(l>>>0>0|(l|0)==0&k>>>0>127){n=d;o=m;p=k;k=l;while(1){b[n>>0]=o|-128;l=p;p=l1c(p|0,k|0,7)|0;q=n+1|0;r=p&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){s=q;t=r;break}else{n=q;o=r;k=J}}}else{s=d;t=m}b[s>>0]=t;k=s+1|0;i=i+1|0;if((i|0)>=(e|0)){g=k;break}else j=k}}j=f[a+8>>2]|0;if(!(j&16))u=g;else{e=f[a+140>>2]|0;b[g>>0]=16;i=g+1|0;g=e&255;if(e>>>0>127){s=i;t=g;h=e;k=((e|0)<0)<<31>>31;while(1){b[s>>0]=t|-128;e=h;h=l1c(h|0,k|0,7)|0;o=s+1|0;n=h&255;if(!(k>>>0>0|(k|0)==0&e>>>0>16383)){v=o;w=n;break}else{s=o;t=n;k=J}}}else{v=i;w=g}b[v>>0]=w;u=v+1|0}if(!(j&8))x=u;else{v=f[a+136>>2]|0;b[u>>0]=26;w=u+1|0;u=_i[f[(f[v>>2]|0)+60>>2]&2047](v)|0;if(u>>>0>127){g=u;i=w;while(1){b[i>>0]=g|128;k=g>>>7;t=i+1|0;if(g>>>0>16383){g=k;i=t}else{y=t;z=k;break}}}else{y=w;z=u}b[y>>0]=z;x=hj[f[(f[v>>2]|0)+64>>2]&511](v,c,y+1|0)|0}y=a+28|0;if((f[y>>2]|0)>0){b[x>>0]=34;c=x+1|0;v=f[a+40>>2]|0;if(v>>>0>127){z=v;u=c;while(1){b[u>>0]=z|128;w=z>>>7;i=u+1|0;if(z>>>0>16383){z=w;u=i}else{A=i;B=w;break}}}else{A=c;B=v}b[A>>0]=B;B=A+1|0;A=f[y>>2]<<2;o1c(B|0,(f[a+36>>2]|0)+4|0,A|0)|0;C=B+A|0}else C=x;x=a+44|0;if((f[x>>2]|0)>0){b[C>>0]=42;A=C+1|0;B=f[a+56>>2]|0;if(B>>>0>127){y=B;v=A;while(1){b[v>>0]=y|128;c=y>>>7;u=v+1|0;if(y>>>0>16383){y=c;v=u}else{D=u;E=c;break}}}else{D=A;E=B}b[D>>0]=E;E=f[x>>2]|0;x=f[a+52>>2]|0;B=0;A=D+1|0;while(1){D=f[x+4+(B<<2)>>2]|0;v=D&255;if(D>>>0>127){y=A;c=v;u=D;z=((D|0)<0)<<31>>31;while(1){b[y>>0]=c|-128;D=u;u=l1c(u|0,z|0,7)|0;w=y+1|0;i=u&255;if(!(z>>>0>0|(z|0)==0&D>>>0>16383)){F=w;G=i;break}else{y=w;c=i;z=J}}}else{F=A;G=v}b[F>>0]=G;z=F+1|0;B=B+1|0;if((B|0)>=(E|0)){H=z;break}else A=z}}else H=C;C=f[a+64>>2]|0;if((C|0)>0){A=a+72|0;E=0;B=H;while(1){F=f[(f[A>>2]|0)+4+(E<<2)>>2]|0;b[B>>0]=50;G=gZb(F,B+1|0)|0;E=E+1|0;if((E|0)==(C|0)){I=G;break}else B=G}}else I=H;H=a+76|0;if((f[H>>2]|0)>0){b[I>>0]=58;B=I+1|0;C=f[a+88>>2]|0;if(C>>>0>127){E=C;A=B;while(1){b[A>>0]=E|128;G=E>>>7;F=A+1|0;if(E>>>0>16383){E=G;A=F}else{K=F;L=G;break}}}else{K=B;L=C}b[K>>0]=L;L=f[H>>2]|0;H=f[a+84>>2]|0;C=0;B=K+1|0;while(1){K=H+8+(C<<3)|0;A=f[K>>2]|0;E=f[K+4>>2]|0;K=A&255;if(E>>>0>0|(E|0)==0&A>>>0>127){G=B;F=K;x=A;A=E;while(1){b[G>>0]=F|-128;E=x;x=l1c(x|0,A|0,7)|0;z=G+1|0;c=x&255;if(!(A>>>0>0|(A|0)==0&E>>>0>16383)){M=z;N=c;break}else{G=z;F=c;A=J}}}else{M=B;N=K}b[M>>0]=N;A=M+1|0;C=C+1|0;if((C|0)>=(L|0)){O=A;break}else B=A}}else O=I;if(!(j&1))P=O;else{I=f[a+124>>2]|0;b[O>>0]=66;P=gZb(I,O+1|0)|0}if(!(j&2))Q=P;else{O=f[a+128>>2]|0;b[P>>0]=74;Q=gZb(O,P+1|0)|0}P=a+92|0;if((f[P>>2]|0)>0){b[Q>>0]=82;O=Q+1|0;I=f[a+104>>2]|0;if(I>>>0>127){B=I;L=O;while(1){b[L>>0]=B|128;C=B>>>7;M=L+1|0;if(B>>>0>16383){B=C;L=M}else{R=M;S=C;break}}}else{R=O;S=I}b[R>>0]=S;S=R+1|0;R=f[P>>2]<<3;o1c(S|0,(f[a+100>>2]|0)+8|0,R|0)|0;T=S+R|0}else T=Q;Q=a+108|0;if((f[Q>>2]|0)>0){b[T>>0]=90;R=T+1|0;S=f[a+120>>2]|0;if(S>>>0>127){P=S;I=R;while(1){b[I>>0]=P|128;O=P>>>7;L=I+1|0;if(P>>>0>16383){P=O;I=L}else{U=L;V=O;break}}}else{U=R;V=S}b[U>>0]=V;V=f[Q>>2]|0;Q=f[a+116>>2]|0;S=0;R=U+1|0;while(1){U=Q+8+(S<<3)|0;I=f[U>>2]|0;P=f[U+4>>2]|0;U=I&255;if(P>>>0>0|(P|0)==0&I>>>0>127){O=R;L=U;B=I;I=P;while(1){b[O>>0]=L|-128;P=B;B=l1c(B|0,I|0,7)|0;C=O+1|0;M=B&255;if(!(I>>>0>0|(I|0)==0&P>>>0>16383)){W=C;X=M;break}else{O=C;L=M;I=J}}}else{W=R;X=U}b[W>>0]=X;I=W+1|0;S=S+1|0;if((S|0)>=(V|0)){Y=I;break}else R=I}}else Y=T;if(!(j&4))Z=Y;else{j=f[a+132>>2]|0;b[Y>>0]=98;Z=gZb(j,Y+1|0)|0}Y=f[a+4>>2]|0;if(!(Y&1)){_=Z;return _|0}_=Pqc(Y&-2,Z)|0;return _|0}function hob(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;aob(a);c=kZc(b,21568,16896,0)|0;if(!c){Ooc(b,a);return}else{lob(a,c);return}}function iob(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16896,0)|0;if(!c){Ooc(b,a);return}else{lob(a,c);return}}function job(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function kob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536688;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function lob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){_Ma(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+24>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+28|0;d=b+28|0;e=f[d>>2]|0;if(e|0){uHa(g,(f[g>>2]|0)+e|0);o1c((f[a+36>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+36>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+44|0;g=b+44|0;e=f[g>>2]|0;if(e|0){qHa(d,(f[d>>2]|0)+e|0);o1c((f[a+52>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+52>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}vSa(a+60|0,b+60|0);g=a+76|0;d=b+76|0;e=f[d>>2]|0;if(e|0){_Ma(g,(f[g>>2]|0)+e|0);o1c((f[a+84>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+84>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+92|0;g=b+92|0;e=f[g>>2]|0;if(e|0){ZMa(d,(f[d>>2]|0)+e|0);o1c((f[a+100>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+100>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+108|0;d=b+108|0;e=f[d>>2]|0;if(e|0){mob(g,(f[g>>2]|0)+e|0);o1c((f[a+116>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+116>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&31))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+124|0,e=f[b+124>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+128|0,c=f[b+128>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==537368){mHa(e,c);break}else{oYc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+132|0,g=f[b+132>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==537368){mHa(c,g);break}else{oYc(e,g)|0;break}while(0);if(d&8|0){g=a+8|0;f[g>>2]=f[g>>2]|8;g=a+136|0;e=f[g>>2]|0;if(!e){c=$Xc(32)|0;nob(c);f[g>>2]=c;h=c}else h=e;e=f[b+136>>2]|0;c=e|0?e:536272;e=h+4|0;g=f[c+4>>2]|0;if(g&1|0){i=f[e>>2]|0;if(!(i&1))j=lSa(e)|0;else j=i&-2;vqc(j,g&-2)}g=f[c+8>>2]|0;if(g&3|0){if(g&1|0){j=c+16|0;i=f[j+4>>2]|0;e=h+16|0;f[e>>2]=f[j>>2];f[e+4>>2]=i}if(g&2|0){i=c+24|0;c=f[i+4>>2]|0;e=h+24|0;f[e>>2]=f[i>>2];f[e+4>>2]=c}c=h+8|0;f[c>>2]=f[c>>2]|g}}if(d&16|0)f[a+140>>2]=f[b+140>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function mob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<3;if(!i)k=$Xc(d+8|0)|0;else{b=d+15&-8;if(f[i+64>>2]|0)SXb(i,25456,b);k=QXb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)o1c(k+8|0,g+8|0,j<<3|0)|0;if(h)return;if(f[g>>2]|0)return;cYc(g);return}function nob(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=101052;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=536272?(f[223153]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=100;b[d+8>>0]=0;J_b(892612,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;u=c;return}function oob(a){a=a|0;var b=0,c=0;f[a>>2]=101052;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function pob(a){a=a|0;var b=0,c=0;f[a>>2]=101052;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function qob(a){a=a|0;a=$Xc(32)|0;nob(a);return a|0}function rob(a,b){a=a|0;b=b|0;a=$Xc(32)|0;nob(a);if(!b)return a|0;Dob(b,a);return a|0}function sob(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function tob(a){a=a|0;return 1}function uob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+8|0;k=a+24|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;t=a&255;v=0}else{LYb(e,c);a=e;if(!(b[j>>0]|0)){w=0;q=24;break a}else{t=f[a>>2]|0;v=f[a+4>>2]|0}}a=i;f[a>>2]=t;f[a+4>>2]=v;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(o=b[a>>0]|0,o<<24>>24>-1):0){f[c>>2]=a+1;x=o&255;y=0}else{LYb(e,c);o=e;if(!(b[l>>0]|0)){w=0;q=24;break a}else{x=f[o>>2]|0;y=f[o+4>>2]|0}}o=k;f[o>>2]=x;f[o+4>>2]=y;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=24;break}o=f[m>>2]|0;if(!(o&1))z=lSa(m)|0;else z=o&-2;if(!(Lqc(c,s,z)|0)){w=0;q=24;break}}if((q|0)==24){u=d;return w|0}return 0}function vob(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=a+16|0;i=t1c(f[h>>2]|1|0,f[h+4>>2]|0,1)|0;g=c+1+((((i^63)*9|0)+73|0)>>>6)|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=a+24|0;i=t1c(f[b>>2]|1|0,f[b+4>>2]|0,1)|0;d=g+1+((((i^63)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function wob(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a+8>>2]|0;if(c&1|0){d=a+16|0;T_b(1,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&2|0){c=a+24|0;T_b(2,f[c>>2]|0,f[c+4>>2]|0,b)}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function xob(a){a=a|0;return f[a+12>>2]|0}function yob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=a+16|0;h=f[g>>2]|0;i=f[g+4>>2]|0;b[d>>0]=8;g=d+1|0;d=h&255;if(i>>>0>0|(i|0)==0&h>>>0>127){j=g;k=d;l=h;h=i;while(1){b[j>>0]=k|-128;i=l;l=l1c(l|0,h|0,7)|0;m=j+1|0;n=l&255;if(!(h>>>0>0|(h|0)==0&i>>>0>16383)){o=m;p=n;break}else{j=m;k=n;h=J}}}else{o=g;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=a+24|0;o=f[c>>2]|0;p=f[c+4>>2]|0;b[e>>0]=16;c=e+1|0;e=o&255;if(p>>>0>0|(p|0)==0&o>>>0>127){d=c;g=e;h=o;o=p;while(1){b[d>>0]=g|-128;p=h;h=l1c(h|0,o|0,7)|0;k=d+1|0;j=h&255;if(!(o>>>0>0|(o|0)==0&p>>>0>16383)){r=k;s=j;break}else{d=k;g=j;o=J}}}else{r=c;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function zob(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Aob(a,b);return}function Aob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16912,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0){g=c+16|0;e=f[g+4>>2]|0;b=a+16|0;f[b>>2]=f[g>>2];f[b+4>>2]=e}if(d&2|0){e=c+24|0;c=f[e+4>>2]|0;b=a+24|0;f[b>>2]=f[e>>2];f[b+4>>2]=c}c=a+8|0;f[c>>2]=f[c>>2]|d;return}function Bob(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Cob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536680;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Dob(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Eob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;if(g>>>0<(f[h>>2]|0)>>>0?(i=b[g>>0]|0,i<<24>>24>-1):0){f[a>>2]=g+1;j=i&255}else{i=YYb(a)|0;if((i|0)>-1)j=i;else{k=0;u=d;return k|0}}i=HYb(a,j)|0;a:do if((PYb(a)|0)>0){j=c+4|0;g=c+8|0;l=e+8|0;while(1){m=f[a>>2]|0;if(m>>>0<(f[h>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[a>>2]=m+1;o=n&255;p=0}else{LYb(e,a);n=e;if(!(b[l>>0]|0)){k=0;break}else{o=f[n>>2]|0;p=f[n+4>>2]|0}}n=f[c>>2]|0;if((n|0)==(f[j>>2]|0)){_Ma(c,n+1|0);q=f[c>>2]|0}else q=n;n=f[g>>2]|0;f[c>>2]=q+1;m=n+8+(q<<3)|0;f[m>>2]=o;f[m+4>>2]=p;if((PYb(a)|0)<=0)break a}u=d;return k|0}while(0);IYb(a,i);k=1;u=d;return k|0}function Fob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k&255;m=0}else{LYb(g,d);k=g;if(!(b[g+8>>0]|0)){n=0;u=a;return n|0}else{l=f[k>>2]|0;m=f[k+4>>2]|0}}k=f[e>>2]|0;i=e+4|0;o=f[i>>2]|0;if((k|0)==(o|0)){mob(e,k+1|0);p=f[e>>2]|0;q=f[i>>2]|0}else{p=k;q=o}o=e+8|0;k=f[o>>2]|0;i=p+1|0;f[e>>2]=i;r=k+8+(p<<3)|0;f[r>>2]=l;f[r+4>>2]=m;m=q-i|0;if((m|0)<=0){n=1;u=a;return n|0}q=g+8|0;r=c&127|128;l=c>>>7&255;if(c>>>0<128){p=m;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){n=1;x=27;break}if((h[v>>0]|0)!=(c|0)){n=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=s;A=t;B=w&255;C=0}else{LYb(g,d);w=g;if(!(b[q>>0]|0)){n=0;x=27;break}z=f[e>>2]|0;A=f[o>>2]|0;B=f[w>>2]|0;C=f[w+4>>2]|0}s=z+1|0;f[e>>2]=s;w=A+8+(z<<3)|0;f[w>>2]=B;f[w+4>>2]=C;if((p|0)<=1){n=1;x=27;break}else{p=p+-1|0;t=A}}if((x|0)==27){u=a;return n|0}}if(c>>>0<16384){D=m;E=i;F=k}else{n=1;u=a;return n|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;m=i;if((k-i|0)<=1){n=1;x=27;break}if((h[m>>0]|0)!=(r|0)){n=1;x=27;break}if((b[m+1>>0]|0)!=l<<24>>24){n=1;x=27;break}i=m+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=m+3;G=E;H=F;I=k&255;J=0}else{LYb(g,d);k=g;if(!(b[q>>0]|0)){n=0;x=27;break}G=f[e>>2]|0;H=f[o>>2]|0;I=f[k>>2]|0;J=f[k+4>>2]|0}E=G+1|0;f[e>>2]=E;k=H+8+(G<<3)|0;f[k>>2]=I;f[k+4>>2]=J;if((D|0)<=1){n=1;x=27;break}else{D=D+-1|0;F=H}}if((x|0)==27){u=a;return n|0}return 0}function Gob(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=100944;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;g=a+60|0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+116>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;if((a|0)!=536304?(f[223154]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=101;b[d+8>>0]=0;J_b(892616,d);a_b(d)}f[a+12>>2]=0;f[a+124>>2]=537368;f[a+128>>2]=537368;f[a+132>>2]=537368;d=a+136|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Hob(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Iob(a){a=a|0;var c=0;c=f[a+124>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+128>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+132>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==536304)return;c=f[a+136>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function Job(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Kob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Lob(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Mob(a){a=a|0;var c=0,d=0;f[a>>2]=101160;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function Nob(a){a=a|0;Mob(a);cYc(a);return}function Oob(a){a=a|0;a=$Xc(24)|0;apb(a);return a|0}function Pob(a,b){a=a|0;b=b|0;a=$Xc(24)|0;apb(a);if(!b)return a|0;bpb(b,a);return a|0}function Qob(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Rob(a){a=a|0;return 1}function Sob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=10){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[g>>2]|0;if((k|0)==537368){mHa(g,537368);p=f[g>>2]|0}else p=k;if(l$b(c,p)|0)continue a;else{q=0;m=20;break a}break}case 2:{if((l&255|0)!=18){o=l;break b}f[e>>2]=f[e>>2]|2;k=f[h>>2]|0;if((k|0)==537368){mHa(h,537368);r=f[h>>2]|0}else r=k;if(l$b(c,r)|0)continue a;else{q=0;m=20;break a}break}default:{o=l;break b}}}while(0);if(!o){q=1;m=20;break}k=f[i>>2]|0;if(!(k&1))s=lSa(i)|0;else s=k&-2;if(!(Lqc(c,o,s)|0)){q=0;m=20;break}}if((m|0)==20)return q|0;return 0}function Tob(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+20>>2]|0;k=b[c+11>>0]|0;d=k<<24>>24<0?f[c+4>>2]|0:k&255;e=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function Uob(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&2|0)f$b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Vob(a){a=a|0;return f[a+12>>2]|0}function Wob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{c=f[a+20>>2]|0;b[e>>0]=18;h=gZb(c,e+1|0)|0}e=f[a+4>>2]|0;if(!(e&1)){i=h;return i|0}i=Pqc(e&-2,h)|0;return i|0}function Xob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;d=a+8|0;e=f[d>>2]|0;do if(e&3|0){do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&2|0){h=f[a+20>>2]|0;g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}}while(0);f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16928,0)|0;if(!e){Ooc(c,a);return}else{$ob(a,e);return}}function Yob(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16928,0)|0;if(!c){Ooc(b,a);return}else{$ob(a,c);return}}function Zob(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function _ob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536664;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function $ob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+20|0;a=f[b+20>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==537368){mHa(d,a);return}else{oYc(b,a)|0;return}}function apb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=101160;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=536144?(f[223152]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=99;b[d+8>>0]=0;J_b(892608,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;u=c;return}function bpb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function cpb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=101268;Vqb(a);b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+28|0;h=f[b>>2]|0;if(h|0?(f[a+16>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;cYc(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[b>>2]=0;return}function dpb(a){a=a|0;cpb(a);cYc(a);return}function epb(a){a=a|0;a=$Xc(88)|0;Tqb(a);return a|0}function fpb(a,b){a=a|0;b=b|0;a=$Xc(88)|0;Tqb(a);if(!b)return a|0;Uqb(b,a);return a|0}function gpb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+8|0;do if(f[i>>2]&1|0){j=f[h+16>>2]|0;k=j+11|0;if((b[k>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[k>>0]=0;break}}while(0);k=h+24|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=0;k=f[h+4>>2]|0;if(k&1|0?(j=k&-2,f[j>>2]|0):0)sqc(j)}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{j=f[g+4+(e<<2)>>2]|0;e=e+1|0;k=j+8|0;l=f[k>>2]|0;do if(l&3|0){do if(l&1|0){m=f[j+16>>2]|0;n=m+11|0;if((b[n>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0;break}else{b[m>>0]=0;b[n>>0]=0;break}}while(0);if(l&2|0){n=f[j+20>>2]|0;m=n+11|0;if((b[m>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0;break}else{b[n>>0]=0;b[m>>0]=0;break}}}while(0);f[k>>2]=0;l=f[j+4>>2]|0;if(l&1|0?(h=l&-2,f[h>>2]|0):0)sqc(h)}while((e|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&31|0){do if(d&1|0){e=f[a+48>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+52>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&4|0){e=f[a+56>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&8|0){g=f[a+60>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&16|0)Bqb(f[a+64>>2]|0)}if(d&96|0){d=a+72|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function hpb(a){a=a|0;return 1}function ipb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+72|0;j=e+8|0;k=a+48|0;l=a+52|0;m=a+56|0;n=a+80|0;o=e+8|0;p=a+60|0;q=a+64|0;r=e+4|0;s=a+16|0;t=a+28|0;v=a+24|0;w=a+20|0;x=e+4|0;y=a+32|0;z=a+44|0;A=a+40|0;B=a+36|0;C=e+4|0;D=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){E=b[a>>0]|0;F=E&255;if(E<<24>>24>0){f[c>>2]=a+1;G=F;H=6}else{I=F;H=5}}else{I=0;H=5}if((H|0)==5){H=0;F=ZYb(c,I)|0;if((F+-1|0)>>>0<127){G=F;H=6}else J=F}b:do if((H|0)==6){H=0;switch(G>>>3&536870911|0){case 1:{if((G&255|0)!=8){J=G;break b}f[h>>2]=f[h>>2]|32;F=f[c>>2]|0;if(F>>>0<(f[g>>2]|0)>>>0?(a=b[F>>0]|0,a<<24>>24>-1):0){f[c>>2]=F+1;K=a&255;L=0}else{LYb(e,c);a=e;if(!(b[j>>0]|0)){M=0;H=93;break a}else{K=f[a>>2]|0;L=f[a+4>>2]|0}}a=i;f[a>>2]=K;f[a+4>>2]=L;continue a;break}case 2:{if((G&255|0)!=18){J=G;break b}f[h>>2]=f[h>>2]|1;a=f[k>>2]|0;if((a|0)==537368){mHa(k,537368);N=f[k>>2]|0}else N=a;if(l$b(c,N)|0)continue a;else{M=0;H=93;break a}break}case 3:{if((G&255|0)!=26){J=G;break b}f[h>>2]=f[h>>2]|2;a=f[l>>2]|0;if((a|0)==537368){mHa(l,537368);O=f[l>>2]|0}else O=a;if(l$b(c,O)|0)continue a;else{M=0;H=93;break a}break}case 4:{if((G&255|0)!=34){J=G;break b}f[h>>2]=f[h>>2]|4;a=f[m>>2]|0;if((a|0)==537368){mHa(m,537368);P=f[m>>2]|0}else P=a;if(l$b(c,P)|0)continue a;else{M=0;H=93;break a}break}case 5:{if((G&255|0)!=40){J=G;break b}f[h>>2]=f[h>>2]|64;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(F=b[a>>0]|0,F<<24>>24>-1):0){f[c>>2]=a+1;Q=F&255;R=0}else{LYb(e,c);F=e;if(!(b[o>>0]|0)){M=0;H=93;break a}else{Q=f[F>>2]|0;R=f[F+4>>2]|0}}F=n;f[F>>2]=Q;f[F+4>>2]=R;continue a;break}case 6:{if((G&255|0)!=50){J=G;break b}f[h>>2]=f[h>>2]|8;F=f[p>>2]|0;if((F|0)==537368){mHa(p,537368);S=f[p>>2]|0}else S=F;if(l$b(c,S)|0)continue a;else{M=0;H=93;break a}break}case 7:{if((G&255|0)!=58){J=G;break b}f[h>>2]=f[h>>2]|16;F=f[q>>2]|0;if(!F){a=$Xc(104)|0;upb(a);f[q>>2]=a;T=a}else T=F;F=f[c>>2]|0;if(F>>>0<(f[g>>2]|0)>>>0?(a=b[F>>0]|0,a<<24>>24>-1):0){f[c>>2]=F+1;U=a&255}else{a=YYb(c)|0;if((a|0)>-1)U=a;else{M=0;H=93;break a}}JYb(e,c,U);if((f[r>>2]|0)<0){H=44;break a}if(!(Mi[f[(f[T>>2]|0)+44>>2]&1023](T,c)|0)){H=44;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{M=0;H=93;break a}break}case 8:{if((G&255|0)!=66){J=G;break b}a=f[t>>2]|0;do if(a){F=f[w>>2]|0;E=f[a>>2]|0;if((F|0)>=(E|0))if((E|0)==(f[v>>2]|0)){V=E;H=52;break}else{W=E;X=a;H=53;break}else{f[w>>2]=F+1;Y=f[a+4+(F<<2)>>2]|0;break}}else{V=f[v>>2]|0;H=52}while(0);if((H|0)==52){H=0;XZb(s,V+1|0);a=f[t>>2]|0;W=f[a>>2]|0;X=a;H=53}if((H|0)==53){H=0;f[X>>2]=W+1;a=f[s>>2]|0;if(!a){F=$Xc(32)|0;Cmb(F);Z=F}else{if(f[a+64>>2]|0)SXb(a,16816,32);F=RXb(a,32,2260)|0;Cmb(F);Z=F}F=f[t>>2]|0;a=f[w>>2]|0;f[w>>2]=a+1;f[F+4+(a<<2)>>2]=Z;Y=Z}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(F=b[a>>0]|0,F<<24>>24>-1):0){f[c>>2]=a+1;_=F&255}else{F=YYb(c)|0;if((F|0)>-1)_=F;else{M=0;H=93;break a}}JYb(e,c,_);if((f[x>>2]|0)<0){H=65;break a}if(!(Mi[f[(f[Y>>2]|0)+44>>2]&1023](Y,c)|0)){H=65;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{M=0;H=93;break a}break}case 14:{if((G&255|0)!=114){J=G;break b}F=f[z>>2]|0;do if(F){a=f[B>>2]|0;E=f[F>>2]|0;if((a|0)>=(E|0))if((E|0)==(f[A>>2]|0)){$=E;H=73;break}else{aa=E;ba=F;H=74;break}else{f[B>>2]=a+1;ca=f[F+4+(a<<2)>>2]|0;break}}else{$=f[A>>2]|0;H=73}while(0);if((H|0)==73){H=0;XZb(y,$+1|0);F=f[z>>2]|0;aa=f[F>>2]|0;ba=F;H=74}if((H|0)==74){H=0;f[ba>>2]=aa+1;F=f[y>>2]|0;if(!F){a=$Xc(24)|0;apb(a);da=a}else{if(f[F+64>>2]|0)SXb(F,16928,24);a=RXb(F,24,2261)|0;apb(a);da=a}a=f[z>>2]|0;F=f[B>>2]|0;f[B>>2]=F+1;f[a+4+(F<<2)>>2]=da;ca=da}F=f[c>>2]|0;if(F>>>0<(f[g>>2]|0)>>>0?(a=b[F>>0]|0,a<<24>>24>-1):0){f[c>>2]=F+1;ea=a&255}else{a=YYb(c)|0;if((a|0)>-1)ea=a;else{M=0;H=93;break a}}JYb(e,c,ea);if((f[C>>2]|0)<0){H=86;break a}if(!(Mi[f[(f[ca>>2]|0)+44>>2]&1023](ca,c)|0)){H=86;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{M=0;H=93;break a}break}default:{J=G;break b}}}while(0);if(!J){M=1;H=93;break}a=f[D>>2]|0;if(!(a&1))fa=lSa(D)|0;else fa=a&-2;if(!(Lqc(c,J,fa)|0)){M=0;H=93;break}}if((H|0)==44){M=0;u=d;return M|0}else if((H|0)==65){M=0;u=d;return M|0}else if((H|0)==86){M=0;u=d;return M|0}else if((H|0)==93){u=d;return M|0}return 0}function jpb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=a+8|0;i=f[d>>2]|0;if(!(i&127)){l=k;m=a+12|0;f[m>>2]=l;return l|0}if(!(i&1))n=k;else{h=f[a+48>>2]|0;g=b[h+11>>0]|0;c=g<<24>>24<0?f[h+4>>2]|0:g&255;n=k+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))o=n;else{c=f[a+52>>2]|0;k=b[c+11>>0]|0;g=k<<24>>24<0?f[c+4>>2]|0:k&255;o=n+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&4))p=o;else{g=f[a+56>>2]|0;n=b[g+11>>0]|0;k=n<<24>>24<0?f[g+4>>2]|0:n&255;p=o+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&8))q=p;else{k=f[a+60>>2]|0;o=b[k+11>>0]|0;n=o<<24>>24<0?f[k+4>>2]|0:o&255;q=p+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&16)){r=q;s=i}else{i=f[a+64>>2]|0;n=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=q+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=i;s=f[d>>2]|0}if(!(s&32))t=r;else{d=a+72|0;i=t1c(f[d>>2]|1|0,f[d+4>>2]|0,1)|0;t=r+1+((((i^63)*9|0)+73|0)>>>6)|0}if(!(s&64)){l=t;m=a+12|0;f[m>>2]=l;return l|0}s=a+80|0;i=t1c(f[s>>2]|1|0,f[s+4>>2]|0,1)|0;l=t+1+((((i^63)*9|0)+73|0)>>>6)|0;m=a+12|0;f[m>>2]=l;return l|0}function kpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;if(c&32|0){d=a+72|0;T_b(1,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&1|0)f$b(2,f[a+48>>2]|0,b);if(c&2|0)f$b(3,f[a+52>>2]|0,b);if(c&4|0)f$b(4,f[a+56>>2]|0,b);if(c&64|0){d=a+80|0;T_b(5,f[d>>2]|0,f[d+4>>2]|0,b)}if(c&8|0)f$b(6,f[a+60>>2]|0,b);if(c&16|0)k$b(7,f[a+64>>2]|0,b);c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(8,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+36>>2]|0;if(c|0){e=a+44|0;d=0;do{k$b(14,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function lpb(a){a=a|0;return f[a+12>>2]|0}function mpb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a+8>>2]|0;if(!(e&32))g=d;else{h=a+72|0;i=f[h>>2]|0;j=f[h+4>>2]|0;b[d>>0]=8;h=d+1|0;d=i&255;if(j>>>0>0|(j|0)==0&i>>>0>127){k=h;l=d;m=i;i=j;while(1){b[k>>0]=l|-128;j=m;m=l1c(m|0,i|0,7)|0;n=k+1|0;o=m&255;if(!(i>>>0>0|(i|0)==0&j>>>0>16383)){p=n;q=o;break}else{k=n;l=o;i=J}}}else{p=h;q=d}b[p>>0]=q;g=p+1|0}if(!(e&1))r=g;else{p=f[a+48>>2]|0;b[g>>0]=18;r=gZb(p,g+1|0)|0}if(!(e&2))s=r;else{g=f[a+52>>2]|0;b[r>>0]=26;s=gZb(g,r+1|0)|0}if(!(e&4))t=s;else{r=f[a+56>>2]|0;b[s>>0]=34;t=gZb(r,s+1|0)|0}if(!(e&64))u=t;else{s=a+80|0;r=f[s>>2]|0;g=f[s+4>>2]|0;b[t>>0]=40;s=t+1|0;t=r&255;if(g>>>0>0|(g|0)==0&r>>>0>127){p=s;q=t;d=r;r=g;while(1){b[p>>0]=q|-128;g=d;d=l1c(d|0,r|0,7)|0;h=p+1|0;i=d&255;if(!(r>>>0>0|(r|0)==0&g>>>0>16383)){v=h;w=i;break}else{p=h;q=i;r=J}}}else{v=s;w=t}b[v>>0]=w;u=v+1|0}if(!(e&8))x=u;else{v=f[a+60>>2]|0;b[u>>0]=50;x=gZb(v,u+1|0)|0}if(!(e&16))y=x;else{e=f[a+64>>2]|0;b[x>>0]=58;u=x+1|0;x=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(x>>>0>127){v=x;w=u;while(1){b[w>>0]=v|128;t=v>>>7;s=w+1|0;if(v>>>0>16383){v=t;w=s}else{z=s;A=t;break}}}else{z=u;A=x}b[z>>0]=A;y=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,z+1|0)|0}z=f[a+20>>2]|0;if(!z)B=y;else{e=a+28|0;A=0;x=y;while(1){y=f[(f[e>>2]|0)+4+(A<<2)>>2]|0;b[x>>0]=66;u=x+1|0;w=_i[f[(f[y>>2]|0)+60>>2]&2047](y)|0;if(w>>>0>127){v=w;t=u;while(1){b[t>>0]=v|128;s=v>>>7;r=t+1|0;if(v>>>0>16383){v=s;t=r}else{C=r;D=s;break}}}else{C=u;D=w}b[C>>0]=D;t=hj[f[(f[y>>2]|0)+64>>2]&511](y,c,C+1|0)|0;A=A+1|0;if((A|0)==(z|0)){B=t;break}else x=t}}x=f[a+36>>2]|0;if(!x)E=B;else{z=a+44|0;A=0;C=B;while(1){B=f[(f[z>>2]|0)+4+(A<<2)>>2]|0;b[C>>0]=114;D=C+1|0;e=_i[f[(f[B>>2]|0)+60>>2]&2047](B)|0;if(e>>>0>127){t=e;v=D;while(1){b[v>>0]=t|128;s=t>>>7;r=v+1|0;if(t>>>0>16383){t=s;v=r}else{F=r;G=s;break}}}else{F=D;G=e}b[F>>0]=G;v=hj[f[(f[B>>2]|0)+64>>2]&511](B,c,F+1|0)|0;A=A+1|0;if((A|0)==(x|0)){E=v;break}else C=v}}C=f[a+4>>2]|0;if(!(C&1)){H=E;return H|0}H=Pqc(C&-2,E)|0;return H|0}function npb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;gpb(a);c=kZc(b,21568,16944,0)|0;if(!c){Ooc(b,a);return}else{rpb(a,c);return}}function opb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16944,0)|0;if(!c){Ooc(b,a);return}else{rpb(a,c);return}}function ppb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function qpb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536656;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function rpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}spb(a+16|0,b+16|0);tpb(a+32|0,b+32|0);d=f[b+8>>2]|0;if(!(d&127))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+48|0,e=f[b+48>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+52|0,c=f[b+52>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==537368){mHa(e,c);break}else{oYc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+56|0,g=f[b+56>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==537368){mHa(c,g);break}else{oYc(e,g)|0;break}while(0);do if(d&8|0?(g=a+8|0,f[g>>2]=f[g>>2]|8,g=a+60|0,e=f[b+60>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(d&16|0){e=a+8|0;f[e>>2]=f[e>>2]|16;e=a+64|0;c=f[e>>2]|0;if(!c){g=$Xc(104)|0;upb(g);f[e>>2]=g;h=g}else h=c;c=f[b+64>>2]|0;vpb(h,c|0?c:536168)}if(d&32|0){c=b+72|0;h=f[c+4>>2]|0;g=a+72|0;f[g>>2]=f[c>>2];f[g+4>>2]=h}if(d&64|0){h=b+80|0;b=f[h+4>>2]|0;g=a+80|0;f[g>>2]=f[h>>2];f[g+4>>2]=b}b=a+8|0;f[b>>2]=f[b>>2]|d;return}function spb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Rqb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(32)|0;Cmb(l);Rqb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16816,32);l=RXb(i,32,2260)|0;Cmb(l);Rqb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function tpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Pqb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(24)|0;apb(l);Pqb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16928,24);l=RXb(i,24,2261)|0;apb(l);Pqb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function upb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=101592;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==536168;g=a+16|0;h=g+80|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223149]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=96;b[d+8>>0]=0;J_b(892596,d);a_b(d)}f[a+12>>2]=0;f[a+96>>2]=537368;f[a+100>>2]=537368;u=c;return}function vpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}wpb(a+16|0,b+16|0);xpb(a+32|0,b+32|0);ypb(a+48|0,b+48|0);ypb(a+64|0,b+64|0);ypb(a+80|0,b+80|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+96|0,e=f[b+96>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+100|0;a=f[b+100>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==537368){mHa(d,a);return}else{oYc(b,a)|0;return}}function wpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Wpb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(80)|0;Vpb(l);Wpb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16976,80);l=RXb(i,80,2262)|0;Vpb(l);Wpb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function xpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Tpb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(144)|0;Gob(l);Tpb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16896,144);l=RXb(i,144,2263)|0;Gob(l);Tpb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ypb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Apb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(28)|0;zpb(l);Apb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16960,32);l=RXb(i,32,2264)|0;zpb(l);Apb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function zpb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=101376;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=535944?(f[223150]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=97;b[d+8>>0]=0;J_b(892600,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=0;u=c;return}function Apb(a,b){a=a|0;b=b|0;Cpb(b,a);return}function Bpb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function Cpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+20|0,c=f[b+20>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==537368){mHa(e,c);break}else{oYc(g,c)|0;break}while(0);if(!(d&4))return;d=a+8|0;f[d>>2]=f[d>>2]|4;d=a+24|0;a=f[d>>2]|0;if(!a){c=$Xc(28)|0;Wnb(c);f[d>>2]=c;h=c}else h=a;a=f[b+24>>2]|0;Tmb(h,a|0?a:536560);return}function Dpb(a){a=a|0;var c=0,d=0;f[a>>2]=101376;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=535944?(c=f[a+24>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function Epb(a){a=a|0;Dpb(a);cYc(a);return}function Fpb(a){a=a|0;a=$Xc(28)|0;zpb(a);return a|0}function Gpb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;zpb(a);if(!b)return a|0;Spb(b,a);return a|0}function Hpb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&7|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&4|0){d=f[a+24>>2]|0;e=d+8|0;do if(f[e>>2]&1|0){g=f[d+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);h=d+24|0;if((f[h>>2]|0)==1?(g=f[d+20>>2]|0,g|0):0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);f[h>>2]=0;f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Ipb(a){a=a|0;return 1}function Jpb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+24|0;k=e+4|0;l=a+20|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[i>>2]|0;if((o|0)==537368){mHa(i,537368);t=f[i>>2]|0}else t=o;if(l$b(c,t)|0)continue a;else{v=0;q=31;break a}break}case 2:{if((p&255|0)!=18){s=p;break b}f[h>>2]=f[h>>2]|4;o=f[j>>2]|0;if(!o){a=$Xc(28)|0;Wnb(a);f[j>>2]=a;w=a}else w=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;x=a&255}else{a=YYb(c)|0;if((a|0)>-1)x=a;else{v=0;q=31;break a}}JYb(e,c,x);if((f[k>>2]|0)<0){q=20;break a}if(!(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,c)|0)){q=20;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{v=0;q=31;break a}break}case 3:{if((p&255|0)!=26){s=p;break b}f[h>>2]=f[h>>2]|2;a=f[l>>2]|0;if((a|0)==537368){mHa(l,537368);y=f[l>>2]|0}else y=a;if(l$b(c,y)|0)continue a;else{v=0;q=31;break a}break}default:{s=p;break b}}}while(0);if(!s){v=1;q=31;break}a=f[m>>2]|0;if(!(a&1))z=lSa(m)|0;else z=a&-2;if(!(Lqc(c,s,z)|0)){v=0;q=31;break}}if((q|0)==20){v=0;u=d;return v|0}else if((q|0)==31){u=d;return v|0}return 0}function Kpb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&7)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;d=b[k+11>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;l=h+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4)){e=l;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+24>>2]|0;j=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;e=l+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function Lpb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&4|0)k$b(2,f[a+24>>2]|0,b);if(c&2|0)f$b(3,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Mpb(a){a=a|0;return f[a+12>>2]|0}function Npb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&4))i=g;else{d=f[a+24>>2]|0;b[g>>0]=18;h=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(g>>>0>127){j=g;k=h;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=h;o=g}b[n>>0]=o;i=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,n+1|0)|0}if(!(e&2))p=i;else{e=f[a+20>>2]|0;b[i>>0]=26;p=gZb(e,i+1|0)|0}i=f[a+4>>2]|0;if(!(i&1)){q=p;return q|0}q=Pqc(i&-2,p)|0;return q|0}function Opb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Hpb(a);c=kZc(b,21568,16960,0)|0;if(!c){Ooc(b,a);return}else{Cpb(a,c);return}}function Ppb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16960,0)|0;if(!c){Ooc(b,a);return}else{Cpb(a,c);return}}function Qpb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Rpb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536640;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Spb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Tpb(a,b){a=a|0;b=b|0;lob(b,a);return}function Upb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function Vpb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=101484;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==535976;g=a+16|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223149]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=96;b[d+8>>0]=0;J_b(892596,d);a_b(d)}f[a+12>>2]=0;f[a+64>>2]=537368;f[a+68>>2]=537368;f[a+72>>2]=537368;f[a+76>>2]=537368;u=c;return}function Wpb(a,b){a=a|0;b=b|0;Ypb(b,a);return}function Xpb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function Ypb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}vSa(a+16|0,b+16|0);vSa(a+32|0,b+32|0);Zpb(a+48|0,b+48|0);d=f[b+8>>2]|0;if(!(d&15))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+64|0,e=f[b+64>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+68|0,c=f[b+68>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==537368){mHa(e,c);break}else{oYc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+72|0,g=f[b+72>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==537368){mHa(c,g);break}else{oYc(e,g)|0;break}while(0);if(!(d&8))return;d=a+8|0;f[d>>2]=f[d>>2]|8;d=a+76|0;a=f[b+76>>2]|0;b=f[d>>2]|0;if((b|0)==(a|0))return;if((b|0)==537368){mHa(d,a);return}else{oYc(b,a)|0;return}}function Zpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{$pb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(128)|0;_pb(l);$pb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16800,128);l=RXb(i,128,2265)|0;_pb(l);$pb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function _pb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=100088;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==535816;g=a+16|0;h=g+72|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223149]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=96;b[d+8>>0]=0;J_b(892596,d);a_b(d)}f[a+12>>2]=0;f[a+88>>2]=537368;f[a+92>>2]=537368;f[a+96>>2]=537368;f[a+100>>2]=537368;d=a+104|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function $pb(a,b){a=a|0;b=b|0;bqb(b,a);return}function aqb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function bqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){uHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+28|0;d=b+28|0;e=f[d>>2]|0;if(e|0){_Ma(g,(f[g>>2]|0)+e|0);o1c((f[a+36>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+36>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}vSa(a+40|0,b+40|0);xpb(a+56|0,b+56|0);cqb(a+72|0,b+72|0);d=f[b+8>>2]|0;if(d&255|0){do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+88|0,e=f[b+88>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+92|0,c=f[b+92>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==537368){mHa(e,c);break}else{oYc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+96|0,g=f[b+96>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==537368){mHa(c,g);break}else{oYc(e,g)|0;break}while(0);do if(d&8|0?(g=a+8|0,f[g>>2]=f[g>>2]|8,g=a+100|0,e=f[b+100>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(d&16|0){e=a+8|0;f[e>>2]=f[e>>2]|16;e=a+104|0;c=f[e>>2]|0;if(!c){g=$Xc(144)|0;Gob(g);f[e>>2]=g;h=g}else h=c;c=f[b+104>>2]|0;lob(h,c|0?c:536304)}if(d&32|0){c=a+8|0;f[c>>2]=f[c>>2]|32;c=a+108|0;h=f[c>>2]|0;if(!h){g=$Xc(104)|0;upb(g);f[c>>2]=g;i=g}else i=h;h=f[b+108>>2]|0;vpb(i,h|0?h:536168)}if(d&64|0){h=b+112|0;i=f[h+4>>2]|0;g=a+112|0;f[g>>2]=f[h>>2];f[g+4>>2]=i}if(d&128|0)f[a+120>>2]=f[b+120>>2];i=a+8|0;f[i>>2]=f[i>>2]|d}if(!(d&256))return;d=f[b+124>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|256;f[a+124>>2]=d;return}function cqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{dqb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(104)|0;upb(l);dqb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16992,104);l=RXb(i,104,2257)|0;upb(l);dqb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function dqb(a,b){a=a|0;b=b|0;vpb(b,a);return}function eqb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function fqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=101484;vqb(a);c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+44|0;i=f[c>>2]|0;if(i|0?(f[a+32>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);cYc(g)}e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+28|0;j=f[c>>2]|0;if(j|0?(f[a+16>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(k);f[c>>2]=0;return}function gqb(a){a=a|0;fqb(a);cYc(a);return}function hqb(a){a=a|0;a=$Xc(80)|0;Vpb(a);return a|0}function iqb(a,b){a=a|0;b=b|0;a=$Xc(80)|0;Vpb(a);if(!b)return a|0;uqb(b,a);return a|0}function jqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{Olb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&15|0){do if(d&1|0){g=f[a+64>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+68>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+72>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&8|0){e=f[a+76>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function kqb(a){a=a|0;return 1}function lqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+32|0;j=a+8|0;k=a+64|0;l=a+68|0;m=a+48|0;n=a+60|0;o=a+56|0;p=a+52|0;q=e+4|0;r=a+72|0;s=a+76|0;t=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){v=b[a>>0]|0;w=v&255;if(v<<24>>24>0){f[c>>2]=a+1;x=w;y=6}else{z=w;y=5}}else{z=0;y=5}if((y|0)==5){y=0;w=ZYb(c,z)|0;if((w+-1|0)>>>0<127){x=w;y=6}else A=w}b:do if((y|0)==6){y=0;switch(x>>>3&536870911|0){case 1:{if((x&255|0)!=10){A=x;break b}if(l$b(c,pHa(h)|0)|0)continue a;else{B=0;y=53;break a}break}case 2:{if((x&255|0)!=18){A=x;break b}if(l$b(c,pHa(i)|0)|0)continue a;else{B=0;y=53;break a}break}case 3:{if((x&255|0)!=26){A=x;break b}f[j>>2]=f[j>>2]|1;w=f[k>>2]|0;if((w|0)==537368){mHa(k,537368);C=f[k>>2]|0}else C=w;if(l$b(c,C)|0)continue a;else{B=0;y=53;break a}break}case 4:{if((x&255|0)!=34){A=x;break b}f[j>>2]=f[j>>2]|2;w=f[l>>2]|0;if((w|0)==537368){mHa(l,537368);D=f[l>>2]|0}else D=w;if(l$b(c,D)|0)continue a;else{B=0;y=53;break a}break}case 5:{if((x&255|0)!=42){A=x;break b}w=f[n>>2]|0;do if(w){a=f[p>>2]|0;v=f[w>>2]|0;if((a|0)>=(v|0))if((v|0)==(f[o>>2]|0)){E=v;y=25;break}else{F=v;G=w;y=26;break}else{f[p>>2]=a+1;H=f[w+4+(a<<2)>>2]|0;break}}else{E=f[o>>2]|0;y=25}while(0);if((y|0)==25){y=0;XZb(m,E+1|0);w=f[n>>2]|0;F=f[w>>2]|0;G=w;y=26}if((y|0)==26){y=0;f[G>>2]=F+1;w=f[m>>2]|0;if(!w){a=$Xc(128)|0;_pb(a);I=a}else{if(f[w+64>>2]|0)SXb(w,16800,128);a=RXb(w,128,2265)|0;_pb(a);I=a}a=f[n>>2]|0;w=f[p>>2]|0;f[p>>2]=w+1;f[a+4+(w<<2)>>2]=I;H=I}w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;J=a&255}else{a=YYb(c)|0;if((a|0)>-1)J=a;else{B=0;y=53;break a}}JYb(e,c,J);if((f[q>>2]|0)<0){y=38;break a}if(!(Mi[f[(f[H>>2]|0)+44>>2]&1023](H,c)|0)){y=38;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;y=53;break a}break}case 6:{if((x&255|0)!=50){A=x;break b}f[j>>2]=f[j>>2]|4;a=f[r>>2]|0;if((a|0)==537368){mHa(r,537368);K=f[r>>2]|0}else K=a;if(l$b(c,K)|0)continue a;else{B=0;y=53;break a}break}case 7:{if((x&255|0)!=58){A=x;break b}f[j>>2]=f[j>>2]|8;a=f[s>>2]|0;if((a|0)==537368){mHa(s,537368);L=f[s>>2]|0}else L=a;if(l$b(c,L)|0)continue a;else{B=0;y=53;break a}break}default:{A=x;break b}}}while(0);if(!A){B=1;y=53;break}a=f[t>>2]|0;if(!(a&1))M=lSa(t)|0;else M=a&-2;if(!(Lqc(c,A,M)|0)){B=0;y=53;break}}if((y|0)==38){B=0;u=d;return B|0}else if((y|0)==53){u=d;return B|0}return 0}function mqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+52>>2]|0;g=h+m|0;if(!h)n=g;else{m=a+60|0;e=0;c=g;while(1){g=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;l=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;g=l+c+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){n=g;break}else c=g}}c=f[a+8>>2]|0;if(!(c&15)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(c&1))q=n;else{h=f[a+64>>2]|0;e=b[h+11>>0]|0;m=e<<24>>24<0?f[h+4>>2]|0:e&255;q=n+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))r=q;else{m=f[a+68>>2]|0;n=b[m+11>>0]|0;e=n<<24>>24<0?f[m+4>>2]|0:n&255;r=q+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))s=r;else{e=f[a+72>>2]|0;q=b[e+11>>0]|0;n=q<<24>>24<0?f[e+4>>2]|0:q&255;s=r+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8)){o=s;p=a+12|0;f[p>>2]=o;return o|0}c=f[a+76>>2]|0;n=b[c+11>>0]|0;r=n<<24>>24<0?f[c+4>>2]|0:n&255;o=s+1+r+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=a+12|0;f[p>>2]=o;return o|0}function nqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+20>>2]|0;if((c|0)>0){d=a+28|0;e=0;do{e$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+36>>2]|0;if((c|0)>0){e=a+44|0;d=0;do{e$b(2,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+8>>2]|0;if(c&1|0)f$b(3,f[a+64>>2]|0,b);if(c&2|0)f$b(4,f[a+68>>2]|0,b);d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{k$b(5,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)f$b(6,f[a+72>>2]|0,b);if(c&8|0)f$b(7,f[a+76>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function oqb(a){a=a|0;return f[a+12>>2]|0}function pqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+20>>2]|0;if((e|0)>0){g=a+28|0;h=0;i=d;while(1){j=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;k=gZb(j,i+1|0)|0;h=h+1|0;if((h|0)==(e|0)){l=k;break}else i=k}}else l=d;d=f[a+36>>2]|0;if((d|0)>0){i=a+44|0;e=0;h=l;while(1){g=f[(f[i>>2]|0)+4+(e<<2)>>2]|0;b[h>>0]=18;k=gZb(g,h+1|0)|0;e=e+1|0;if((e|0)==(d|0)){m=k;break}else h=k}}else m=l;l=f[a+8>>2]|0;if(!(l&1))n=m;else{h=f[a+64>>2]|0;b[m>>0]=26;n=gZb(h,m+1|0)|0}if(!(l&2))o=n;else{m=f[a+68>>2]|0;b[n>>0]=34;o=gZb(m,n+1|0)|0}n=f[a+52>>2]|0;if(!n)p=o;else{m=a+60|0;h=0;d=o;while(1){o=f[(f[m>>2]|0)+4+(h<<2)>>2]|0;b[d>>0]=42;e=d+1|0;i=_i[f[(f[o>>2]|0)+60>>2]&2047](o)|0;if(i>>>0>127){k=i;g=e;while(1){b[g>>0]=k|128;j=k>>>7;q=g+1|0;if(k>>>0>16383){k=j;g=q}else{r=q;s=j;break}}}else{r=e;s=i}b[r>>0]=s;g=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,r+1|0)|0;h=h+1|0;if((h|0)==(n|0)){p=g;break}else d=g}}if(!(l&4))t=p;else{d=f[a+72>>2]|0;b[p>>0]=50;t=gZb(d,p+1|0)|0}if(!(l&8))u=t;else{l=f[a+76>>2]|0;b[t>>0]=58;u=gZb(l,t+1|0)|0}t=f[a+4>>2]|0;if(!(t&1)){v=u;return v|0}v=Pqc(t&-2,u)|0;return v|0}function qqb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;jqb(a);c=kZc(b,21568,16976,0)|0;if(!c){Ooc(b,a);return}else{Ypb(a,c);return}}function rqb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16976,0)|0;if(!c){Ooc(b,a);return}else{Ypb(a,c);return}}function sqb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function tqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536648;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function uqb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function vqb(a){a=a|0;var c=0;c=f[a+64>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+68>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+72>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+76>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function wqb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function xqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=101592;c=f[a+96>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+100>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+92|0;d=f[c>>2]|0;if(d|0?(f[a+80>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+76|0;i=f[c>>2]|0;if(i|0?(f[a+64>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+60|0;j=f[c>>2]|0;if(j|0?(f[a+48>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+44|0;k=f[c>>2]|0;if(k|0?(f[a+32>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;cYc(l)}f[c>>2]=0;c=a+28|0;l=f[c>>2]|0;if(l|0?(f[a+16>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0)Yi[f[(f[i>>2]|0)+4>>2]&4095](i);j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;cYc(m)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}m=a&-2;a=m;if((m|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(m);f[c>>2]=0;return}function yqb(a){a=a|0;xqb(a);cYc(a);return}function zqb(a){a=a|0;a=$Xc(104)|0;upb(a);return a|0}function Aqb(a,b){a=a|0;b=b|0;a=$Xc(104)|0;upb(a);if(!b)return a|0;Oqb(b,a);return a|0}function Bqb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{jqb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{aob(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{Hpb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+68|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+76>>2]|0;e=0;do{Hpb(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+84|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+92>>2]|0;g=0;do{Hpb(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0){g=f[a+96>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&2|0){e=f[a+100>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Cqb(a){a=a|0;return 1}function Dqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+8|0;n=a+96|0;o=a+32|0;p=e+4|0;q=a+100|0;r=a+48|0;s=e+4|0;t=a+64|0;v=e+4|0;w=a+80|0;x=e+4|0;y=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){z=b[a>>0]|0;A=z&255;if(z<<24>>24>0){f[c>>2]=a+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=ZYb(c,D)|0;if((A+-1|0)>>>0<127){B=A;C=6}else E=A}b:do if((C|0)==6){C=0;switch(B>>>3&536870911|0){case 1:{if((B&255|0)!=10){E=B;break b}A=f[i>>2]|0;do if(A){a=f[k>>2]|0;z=f[A>>2]|0;if((a|0)>=(z|0))if((z|0)==(f[j>>2]|0)){F=z;C=13;break}else{G=z;H=A;C=14;break}else{f[k>>2]=a+1;I=f[A+4+(a<<2)>>2]|0;break}}else{F=f[j>>2]|0;C=13}while(0);if((C|0)==13){C=0;XZb(h,F+1|0);A=f[i>>2]|0;G=f[A>>2]|0;H=A;C=14}if((C|0)==14){C=0;f[H>>2]=G+1;A=f[h>>2]|0;if(!A){a=$Xc(80)|0;Vpb(a);J=a}else{if(f[A+64>>2]|0)SXb(A,16976,80);a=RXb(A,80,2262)|0;Vpb(a);J=a}a=f[i>>2]|0;A=f[k>>2]|0;f[k>>2]=A+1;f[a+4+(A<<2)>>2]=J;I=J}A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;K=a&255}else{a=YYb(c)|0;if((a|0)>-1)K=a;else{L=0;C=77;break a}}JYb(e,c,K);if((f[l>>2]|0)<0){C=26;break a}if(!(Mi[f[(f[I>>2]|0)+44>>2]&1023](I,c)|0)){C=26;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 2:{if((B&255|0)!=18){E=B;break b}f[m>>2]=f[m>>2]|1;a=f[n>>2]|0;if((a|0)==537368){mHa(n,537368);M=f[n>>2]|0}else M=a;if(l$b(c,M)|0)continue a;else{L=0;C=77;break a}break}case 5:{if((B&255|0)!=42){E=B;break b}a=Mqb(o)|0;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(z=b[A>>0]|0,z<<24>>24>-1):0){f[c>>2]=A+1;N=z&255}else{z=YYb(c)|0;if((z|0)>-1)N=z;else{L=0;C=77;break a}}JYb(e,c,N);if((f[p>>2]|0)<0){C=39;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=39;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 10:{if((B&255|0)!=82){E=B;break b}f[m>>2]=f[m>>2]|2;a=f[q>>2]|0;if((a|0)==537368){mHa(q,537368);O=f[q>>2]|0}else O=a;if(l$b(c,O)|0)continue a;else{L=0;C=77;break a}break}case 11:{if((B&255|0)!=90){E=B;break b}a=Nqb(r)|0;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(A=b[z>>0]|0,A<<24>>24>-1):0){f[c>>2]=z+1;P=A&255}else{A=YYb(c)|0;if((A|0)>-1)P=A;else{L=0;C=77;break a}}JYb(e,c,P);if((f[s>>2]|0)<0){C=52;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=52;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 12:{if((B&255|0)!=98){E=B;break b}a=Nqb(t)|0;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(z=b[A>>0]|0,z<<24>>24>-1):0){f[c>>2]=A+1;Q=z&255}else{z=YYb(c)|0;if((z|0)>-1)Q=z;else{L=0;C=77;break a}}JYb(e,c,Q);if((f[v>>2]|0)<0){C=61;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=61;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}case 13:{if((B&255|0)!=106){E=B;break b}a=Nqb(w)|0;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(A=b[z>>0]|0,A<<24>>24>-1):0){f[c>>2]=z+1;R=A&255}else{A=YYb(c)|0;if((A|0)>-1)R=A;else{L=0;C=77;break a}}JYb(e,c,R);if((f[x>>2]|0)<0){C=70;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){C=70;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{L=0;C=77;break a}break}default:{E=B;break b}}}while(0);if(!E){L=1;C=77;break}a=f[y>>2]|0;if(!(a&1))S=lSa(y)|0;else S=a&-2;if(!(Lqc(c,E,S)|0)){L=0;C=77;break}}if((C|0)==26){L=0;u=d;return L|0}else if((C|0)==39){L=0;u=d;return L|0}else if((C|0)==52){L=0;u=d;return L|0}else if((C|0)==61){L=0;u=d;return L|0}else if((C|0)==70){L=0;u=d;return L|0}else if((C|0)==77){u=d;return L|0}return 0}function Eqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+52>>2]|0;i=d+k|0;if(!d)l=i;else{k=a+60|0;h=0;g=i;while(1){i=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;c=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=c+g+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=i;break}else g=i}}g=f[a+68>>2]|0;d=g+l|0;if(!g)m=d;else{l=a+76|0;h=0;k=d;while(1){d=f[(f[l>>2]|0)+4+(h<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=i+k+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(g|0)){m=d;break}else k=d}}k=f[a+84>>2]|0;g=k+m|0;if(!k)n=g;else{m=a+92|0;h=0;l=g;while(1){g=f[(f[m>>2]|0)+4+(h<<2)>>2]|0;d=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;g=d+l+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(k|0)){n=g;break}else l=g}}l=f[a+8>>2]|0;if(!(l&3)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(l&1))q=n;else{k=f[a+96>>2]|0;h=b[k+11>>0]|0;m=h<<24>>24<0?f[k+4>>2]|0:h&255;q=n+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&2)){o=q;p=a+12|0;f[p>>2]=o;return o|0}l=f[a+100>>2]|0;m=b[l+11>>0]|0;n=m<<24>>24<0?f[l+4>>2]|0:m&255;o=q+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=a+12|0;f[p>>2]=o;return o|0}function Fqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+8>>2]|0;if(c&1|0)f$b(2,f[a+96>>2]|0,b);e=f[a+36>>2]|0;if(e|0){d=a+44|0;g=0;do{k$b(5,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(e|0))}if(c&2|0)f$b(10,f[a+100>>2]|0,b);c=f[a+52>>2]|0;if(c|0){e=a+60|0;g=0;do{k$b(11,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+68>>2]|0;if(c|0){g=a+76|0;e=0;do{k$b(12,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+84>>2]|0;if(c|0){e=a+92|0;g=0;do{k$b(13,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Gqb(a){a=a|0;return f[a+12>>2]|0}function Hqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=d;d=0;while(1){j=f[(f[h>>2]|0)+4+(d<<2)>>2]|0;b[i>>0]=10;k=i+1|0;l=_i[f[(f[j>>2]|0)+60>>2]&2047](j)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,q+1|0)|0;d=d+1|0;if((d|0)==(e|0)){g=n;break}else i=n}}i=f[a+8>>2]|0;if(!(i&1))s=g;else{e=f[a+96>>2]|0;b[g>>0]=18;s=gZb(e,g+1|0)|0}g=f[a+36>>2]|0;if(!g)t=s;else{e=a+44|0;d=0;q=s;while(1){s=f[(f[e>>2]|0)+4+(d<<2)>>2]|0;b[q>>0]=42;r=q+1|0;h=_i[f[(f[s>>2]|0)+60>>2]&2047](s)|0;if(h>>>0>127){n=h;m=r;while(1){b[m>>0]=n|128;o=n>>>7;p=m+1|0;if(n>>>0>16383){n=o;m=p}else{u=p;v=o;break}}}else{u=r;v=h}b[u>>0]=v;m=hj[f[(f[s>>2]|0)+64>>2]&511](s,c,u+1|0)|0;d=d+1|0;if((d|0)==(g|0)){t=m;break}else q=m}}if(!(i&2))w=t;else{i=f[a+100>>2]|0;b[t>>0]=82;w=gZb(i,t+1|0)|0}t=f[a+52>>2]|0;if(!t)x=w;else{i=a+60|0;q=0;g=w;while(1){w=f[(f[i>>2]|0)+4+(q<<2)>>2]|0;b[g>>0]=90;d=g+1|0;u=_i[f[(f[w>>2]|0)+60>>2]&2047](w)|0;if(u>>>0>127){v=u;e=d;while(1){b[e>>0]=v|128;m=v>>>7;n=e+1|0;if(v>>>0>16383){v=m;e=n}else{y=n;z=m;break}}}else{y=d;z=u}b[y>>0]=z;e=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,y+1|0)|0;q=q+1|0;if((q|0)==(t|0)){x=e;break}else g=e}}g=f[a+68>>2]|0;if(!g)A=x;else{t=a+76|0;q=0;y=x;while(1){x=f[(f[t>>2]|0)+4+(q<<2)>>2]|0;b[y>>0]=98;z=y+1|0;i=_i[f[(f[x>>2]|0)+60>>2]&2047](x)|0;if(i>>>0>127){e=i;v=z;while(1){b[v>>0]=e|128;s=e>>>7;h=v+1|0;if(e>>>0>16383){e=s;v=h}else{B=h;C=s;break}}}else{B=z;C=i}b[B>>0]=C;v=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,B+1|0)|0;q=q+1|0;if((q|0)==(g|0)){A=v;break}else y=v}}y=f[a+84>>2]|0;if(!y)D=A;else{g=a+92|0;q=0;B=A;while(1){A=f[(f[g>>2]|0)+4+(q<<2)>>2]|0;b[B>>0]=106;C=B+1|0;t=_i[f[(f[A>>2]|0)+60>>2]&2047](A)|0;if(t>>>0>127){v=t;e=C;while(1){b[e>>0]=v|128;w=v>>>7;u=e+1|0;if(v>>>0>16383){v=w;e=u}else{E=u;F=w;break}}}else{E=C;F=t}b[E>>0]=F;e=hj[f[(f[A>>2]|0)+64>>2]&511](A,c,E+1|0)|0;q=q+1|0;if((q|0)==(y|0)){D=e;break}else B=e}}B=f[a+4>>2]|0;if(!(B&1)){G=D;return G|0}G=Pqc(B&-2,D)|0;return G|0}function Iqb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Bqb(a);c=kZc(b,21568,16992,0)|0;if(!c){Ooc(b,a);return}else{vpb(a,c);return}}function Jqb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16992,0)|0;if(!c){Ooc(b,a);return}else{vpb(a,c);return}}function Kqb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Lqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223147]|0)!=2){f[d>>2]=165456;f[d+4>>2]=94;b[d+8>>0]=0;J_b(892588,d);a_b(d)}d=536672;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Mqb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(144)|0;Gob(a);o=a}else{if(f[l+64>>2]|0)SXb(l,16896,144);a=RXb(l,144,2263)|0;Gob(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function Nqb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(28)|0;zpb(a);o=a}else{if(f[l+64>>2]|0)SXb(l,16960,32);a=RXb(l,32,2264)|0;zpb(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function Oqb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Pqb(a,b){a=a|0;b=b|0;$ob(b,a);return}function Qqb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function Rqb(a,b){a=a|0;b=b|0;Bmb(b,a);return}function Sqb(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function Tqb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=101268;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((a|0)!=536056?(f[223151]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=98;b[d+8>>0]=0;J_b(892604,d);a_b(d)}f[a+12>>2]=0;f[a+48>>2]=537368;f[a+52>>2]=537368;f[a+56>>2]=537368;f[a+60>>2]=537368;d=a+64|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function Uqb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Vqb(a){a=a|0;var c=0;c=f[a+48>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+52>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+56>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+60>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==536056)return;c=f[a+64>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function Wqb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Xqb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Yqb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Zqb(a){a=a|0;var c=0;c=f[a+88>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+92>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+96>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+100>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==535816)return;c=f[a+104>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+108>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function _qb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function $qb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function arb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223148]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=95;b[c+8>>0]=0;J_b(892592,c);a_b(c);u=a;return}function brb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[223147]|0)==2){d=f[223145]|0;u=a;return d|0}f[c>>2]=165456;f[c+4>>2]=94;b[c+8>>0]=0;J_b(892588,c);a_b(c);d=f[223145]|0;u=a;return d|0}function crb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=100088;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];e=a+12|0;g=a+16|0;h=b+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;e=f[h>>2]|0;if(e|0){uHa(g,e);o1c((f[a+24>>2]|0)+4|0,(f[b+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[g>>2]=f[h>>2]}h=a+28|0;f[h>>2]=0;f[a+32>>2]=0;g=a+36|0;f[g>>2]=0;e=b+28|0;i=f[e>>2]|0;if(i|0){_Ma(h,i);o1c((f[g>>2]|0)+8|0,(f[b+36>>2]|0)+8|0,f[e>>2]<<3|0)|0;f[h>>2]=f[e>>2]}e=a+40|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;vSa(e,b+40|0);e=a+56|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;xpb(e,b+56|0);e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;cqb(e,b+72|0);e=f[b+4>>2]|0;if(e&1|0){h=f[c>>2]|0;if(!(h&1))j=lSa(c)|0;else j=h&-2;vqc(j,e&-2)}e=a+88|0;f[e>>2]=537368;j=f[d>>2]|0;if((j&1|0)!=0?(h=f[b+88>>2]|0,(h|0)!=537368):0){mHa(e,h);k=f[d>>2]|0}else k=j;j=a+92|0;f[j>>2]=537368;if((k&2|0)!=0?(h=f[b+92>>2]|0,(h|0)!=537368):0){mHa(j,h);l=f[d>>2]|0}else l=k;k=a+96|0;f[k>>2]=537368;if((l&4|0)!=0?(h=f[b+96>>2]|0,(h|0)!=537368):0){mHa(k,h);m=f[d>>2]|0}else m=l;l=a+100|0;f[l>>2]=537368;if((m&8|0)!=0?(h=f[b+100>>2]|0,(h|0)!=537368):0){mHa(l,h);n=f[d>>2]|0}else n=m;if(!(n&16)){o=0;p=n}else{n=$Xc(144)|0;drb(n,f[b+104>>2]|0);o=n;p=f[d>>2]|0}f[a+104>>2]=o;if(!(p&32)){q=0;r=a+108|0;f[r>>2]=q;s=a+112|0;t=b+112|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];f[s+8>>2]=f[t+8>>2];f[s+12>>2]=f[t+12>>2];return}p=$Xc(104)|0;erb(p,f[b+108>>2]|0);q=p;r=a+108|0;f[r>>2]=q;s=a+112|0;t=b+112|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];f[s+8>>2]=f[t+8>>2];f[s+12>>2]=f[t+12>>2];return}function drb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=100944;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];e=a+12|0;g=a+16|0;h=b+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;e=f[h>>2]|0;if(e|0){_Ma(g,e);o1c((f[a+24>>2]|0)+8|0,(f[b+24>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[g>>2]=f[h>>2]}h=a+28|0;f[h>>2]=0;f[a+32>>2]=0;g=a+36|0;f[g>>2]=0;e=b+28|0;i=f[e>>2]|0;if(i|0){uHa(h,i);o1c((f[g>>2]|0)+4|0,(f[b+36>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=f[e>>2]}e=a+44|0;f[e>>2]=0;f[a+48>>2]=0;h=a+52|0;f[h>>2]=0;g=b+44|0;i=f[g>>2]|0;if(i|0){qHa(e,i);o1c((f[h>>2]|0)+4|0,(f[b+52>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[e>>2]=f[g>>2]}g=a+60|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;vSa(g,b+60|0);g=a+76|0;f[g>>2]=0;f[a+80>>2]=0;e=a+84|0;f[e>>2]=0;h=b+76|0;i=f[h>>2]|0;if(i|0){_Ma(g,i);o1c((f[e>>2]|0)+8|0,(f[b+84>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[g>>2]=f[h>>2]}h=a+92|0;f[h>>2]=0;f[a+96>>2]=0;g=a+100|0;f[g>>2]=0;e=b+92|0;i=f[e>>2]|0;if(i|0){ZMa(h,i);o1c((f[g>>2]|0)+8|0,(f[b+100>>2]|0)+8|0,f[e>>2]<<3|0)|0;f[h>>2]=f[e>>2]}e=a+108|0;f[e>>2]=0;f[a+112>>2]=0;h=a+116|0;f[h>>2]=0;g=b+108|0;i=f[g>>2]|0;if(i|0){mob(e,i);o1c((f[h>>2]|0)+8|0,(f[b+116>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[e>>2]=f[g>>2]}g=f[b+4>>2]|0;if(g&1|0){e=f[c>>2]|0;if(!(e&1))j=lSa(c)|0;else j=e&-2;vqc(j,g&-2)}g=a+124|0;f[g>>2]=537368;j=f[d>>2]|0;if((j&1|0)!=0?(e=f[b+124>>2]|0,(e|0)!=537368):0){mHa(g,e);k=f[d>>2]|0}else k=j;j=a+128|0;f[j>>2]=537368;if((k&2|0)!=0?(e=f[b+128>>2]|0,(e|0)!=537368):0){mHa(j,e);l=f[d>>2]|0}else l=k;k=a+132|0;f[k>>2]=537368;if((l&4|0)!=0?(e=f[b+132>>2]|0,(e|0)!=537368):0){mHa(k,e);m=f[d>>2]|0}else m=l;if(!(m&8)){n=0;o=a+136|0;f[o>>2]=n;p=b+140|0;q=f[p>>2]|0;r=a+140|0;f[r>>2]=q;return}m=$Xc(32)|0;frb(m,f[b+136>>2]|0);n=m;o=a+136|0;f[o>>2]=n;p=b+140|0;q=f[p>>2]|0;r=a+140|0;f[r>>2]=q;return}function erb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=101592;c=a+4|0;f[c>>2]=0;d=b+8|0;f[a+8>>2]=f[d>>2];e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;wpb(a+16|0,b+16|0);e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;xpb(e,b+32|0);e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;ypb(e,b+48|0);e=a+64|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;ypb(e,b+64|0);e=a+80|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;ypb(e,b+80|0);e=f[b+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}e=a+96|0;f[e>>2]=537368;h=f[d>>2]|0;if((h&1|0)!=0?(g=f[b+96>>2]|0,(g|0)!=537368):0){mHa(e,g);i=f[d>>2]|0}else i=h;h=a+100|0;f[h>>2]=537368;if(!(i&2))return;i=f[b+100>>2]|0;if((i|0)==537368)return;mHa(h,i);return}function frb(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=101052;c=a+4|0;f[c>>2]=0;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=0;d=f[b+4>>2]|0;if(d&1|0)vqc(lSa(c)|0,d&-2);d=a+16|0;a=b+16|0;f[d>>2]=f[a>>2];f[d+4>>2]=f[a+4>>2];f[d+8>>2]=f[a+8>>2];f[d+12>>2]=f[a+12>>2];return}function grb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;jqb(a);Ypb(a,b);return}function hrb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;aob(a);lob(a,b);return}function irb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+176|0;e=d;vHa(e,427486,427563,42,427598,427604,eIa(a,c)|0);c=e+21|0;g=e+32|0;while(1){if(!(b[c>>0]|0))break;h=BM(g,427647,31)|0;BM(h,a,dJc(a)|0)|0;wHa(e)}a=e+24|0;f[a>>2]=35856;c=e+88|0;f[c>>2]=35896;f[g>>2]=35876;g=e+36|0;f[g>>2]=35912;h=e+68|0;if((b[h+11>>0]|0)>=0){LMc(g);TNc(a,35972);GMc(c);u=d;return}cYc(f[h>>2]|0);LMc(g);TNc(a,35972);GMc(c);u=d;return}function jrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+176|0;g=e;vHa(g,427486,427679,48,427598,427716,gIa(a,c,d)|0);d=g+21|0;c=g+32|0;while(1){if(!(b[d>>0]|0))break;BM(c,427760,31)|0;wHa(g)}d=g+24|0;f[d>>2]=35856;a=g+88|0;f[a>>2]=35896;f[c>>2]=35876;c=g+36|0;f[c>>2]=35912;h=g+68|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);LMc(c);TNc(d,35972);GMc(a);u=e;return}function krb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+176|0;e=d;vHa(e,427486,427792,54,427598,427825,QHa(a,c)|0);c=e+21|0;g=e+32|0;while(1){if(!(b[c>>0]|0))break;h=BM(g,427647,31)|0;BM(h,a,dJc(a)|0)|0;wHa(e)}a=e+24|0;f[a>>2]=35856;c=e+88|0;f[c>>2]=35896;f[g>>2]=35876;g=e+36|0;f[g>>2]=35912;h=e+68|0;if((b[h+11>>0]|0)>=0){LMc(g);TNc(a,35972);GMc(c);u=d;return}cYc(f[h>>2]|0);LMc(g);TNc(a,35972);GMc(c);u=d;return}function lrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+176|0;g=e;vHa(g,427486,427866,60,427598,427901,fIa(a,c,d)|0);d=g+21|0;c=g+32|0;while(1){if(!(b[d>>0]|0))break;BM(c,427760,31)|0;wHa(g)}d=g+24|0;f[d>>2]=35856;a=g+88|0;f[a>>2]=35896;f[c>>2]=35876;c=g+36|0;f[c>>2]=35912;h=g+68|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);LMc(c);TNc(d,35972);GMc(a);u=e;return}function mrb(a,b){a=a|0;b=b|0;return}function nrb(){return 0}function orb(){return 0}function prb(a){a=a|0;var c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;a=$Xc(16)|0;f[c>>2]=a;f[c+8>>2]=-2147483632;f[c+4>>2]=15;d=a;e=427943;g=d+15|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));b[a+15>>0]=0;vM(-215,c,427959,427976,615)}function qrb(){f[223160]=0;f[223161]=0;f[223162]=0;b[892651]=4;f[223160]=1635017060;b[892644]=0;be(2220,892640,x|0)|0;return}function rrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0.0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0;d=u;u=u+592|0;e=d+568|0;g=d+544|0;h=d+520|0;i=d+488|0;j=d+556|0;k=d+532|0;l=d+16|0;m=d+340|0;n=d+316|0;o=d+472|0;p=d+460|0;q=d+448|0;r=d+436|0;s=d+424|0;t=d+412|0;v=d+400|0;w=d+388|0;x=d+376|0;y=d+364|0;z=d+352|0;A=d+328|0;B=d+304|0;C=d+292|0;D=d+280|0;E=d+268|0;F=d+256|0;G=d+244|0;H=d+232|0;I=d;J=d+220|0;K=d+208|0;L=d+196|0;M=d+184|0;N=d+172|0;O=d+160|0;P=d+148|0;Q=d+136|0;R=d+124|0;S=d+112|0;T=d+100|0;U=d+88|0;V=d+64|0;W=d+52|0;X=d+28|0;Z=d+76|0;_=d+40|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;$=g+11|0;aa=g+4|0;ba=e+11|0;ca=e+4|0;da=h+11|0;ea=h+4|0;fa=c+48|0;ga=c+36|0;ha=c+40|0;ia=c+40|0;ja=c+44|0;ka=i+11|0;la=i+4|0;ma=h+11|0;na=-1;oa=0;a:while(1){ZNc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);pa=DPc(e,896088)|0;qa=Mi[f[(f[pa>>2]|0)+28>>2]&1023](pa,10)|0;EPc(e);pa=srb(a,g,qa)|0;if(f[pa+(f[(f[pa>>2]|0)+-12>>2]|0)+16>>2]&5|0){ra=3;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;pa=b[$>>0]|0;qa=f[aa>>2]|0;if(!((pa<<24>>24<0?qa:pa&255)|0))sa=pa;else{ta=0;ua=qa;qa=pa;while(1){pa=b[(qa<<24>>24<0?f[g>>2]|0:g)+ta>>0]|0;if((pa+-33&255)<90){BYc(e,pa);va=b[$>>0]|0;wa=f[aa>>2]|0}else{va=qa;wa=ua}ta=ta+1|0;if(ta>>>0>=(va<<24>>24<0?wa:va&255)>>>0){sa=va;break}else{ua=wa;qa=va}}}if(sa<<24>>24<0){b[f[g>>2]>>0]=0;f[aa>>2]=0}else{b[g>>0]=0;b[$>>0]=0}sYc(g,0);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];qa=b[$>>0]|0;ua=f[aa>>2]|0;ta=qa<<24>>24<0;pa=ta?ua:qa&255;if(!pa){xa=oa;ya=na;oa=xa;na=ya;continue}za=f[g>>2]|0;switch(b[(ta?za:g)>>0]|0){case 59:case 35:case 0:{xa=oa;ya=na;oa=xa;na=ya;continue a;break}case 91:{if((pa|0)==5){if(!(LYc(g,0,-1,428050,5)|0)){ya=na;oa=1;na=ya;continue a}Aa=b[$>>0]|0;Ba=f[g>>2]|0;Ca=f[aa>>2]|0}else{Aa=qa;Ba=za;Ca=ua}ua=na+1|0;za=Aa<<24>>24<0;qa=za?Ba:g;pa=za?Ca:Aa&255;za=qa+pa|0;ta=za;Da=qa;b:do if((pa|0)<1)Ea=za;else{Fa=qa;Ga=pa;while(1){Ha=AJc(Fa,93,Ga)|0;if(!Ha){Ea=za;break b}if((b[Ha>>0]|0)==93){Ea=Ha;break b}Fa=Ha+1|0;Ga=ta-Fa|0;if((Ga|0)<1){Ea=za;break}}}while(0);ta=(Ea|0)==(za|0)?-2:Ea-Da+-1|0;if(ta>>>0>=pa>>>0){ra=39;break a}mYc(h,g,1,ta,g);ta=f[ha>>2]|0;do if(ta){qa=ia;Ga=ta;while(1){Fa=f[Ga+16>>2]|0;if((ua|0)<(Fa|0)){Ha=f[Ga>>2]|0;if(!Ha){ra=44;break}else{Ia=Ga;Ja=Ha}}else{if((Fa|0)>(na|0)){ra=48;break}Ka=Ga+4|0;Fa=f[Ka>>2]|0;if(!Fa){ra=47;break}else{Ia=Ka;Ja=Fa}}qa=Ia;Ga=Ja}if((ra|0)==44){ra=0;La=Ga;Ma=Ga;break}else if((ra|0)==47){ra=0;La=Ga;Ma=Ka;break}else if((ra|0)==48){ra=0;La=Ga;Ma=qa;break}}else{La=ha;Ma=ha}while(0);ta=f[Ma>>2]|0;if(!ta){pa=$Xc(32)|0;f[pa+16>>2]=ua;Da=pa+24|0;f[Da>>2]=0;f[pa+28>>2]=0;f[pa+20>>2]=Da;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=La;f[Ma>>2]=pa;Da=f[f[ga>>2]>>2]|0;if(!Da)Na=pa;else{f[ga>>2]=Da;Na=f[Ma>>2]|0}UQ(f[ia>>2]|0,Na);f[ja>>2]=(f[ja>>2]|0)+1;Oa=pa}else Oa=ta;ta=Oa+20|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ka>>0]=4;f[i>>2]=1701869940;b[la>>0]=0;pa=DLa(ta,e,i)|0;Da=f[pa>>2]|0;if(!Da){za=$Xc(40)|0;Fa=za+16|0;f[Fa>>2]=f[i>>2];f[Fa+4>>2]=f[i+4>>2];f[Fa+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Fa=za+28|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;Fa=f[e>>2]|0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=Fa;f[pa>>2]=za;Fa=f[f[ta>>2]>>2]|0;if(!Fa)Pa=za;else{f[ta>>2]=Fa;Pa=f[pa>>2]|0}UQ(f[Oa+24>>2]|0,Pa);pa=Oa+28|0;f[pa>>2]=(f[pa>>2]|0)+1;Qa=za}else Qa=Da;oYc(Qa+28|0,h)|0;if((b[ka>>0]|0)<0)cYc(f[i>>2]|0);if((b[ma>>0]|0)<0)cYc(f[h>>2]|0);na=ua;oa=0;continue a;break}default:{}}Da=JYc(g,61,0)|0;za=b[$>>0]|0;if(Da>>>0>=(za<<24>>24<0?f[aa>>2]|0:za&255)>>>0){ra=63;break}mYc(e,g,0,Da,g);za=Da+1|0;Da=b[$>>0]|0;mYc(h,g,za,(Da<<24>>24<0?f[aa>>2]|0:Da&255)-za|0,g);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;za=b[ba>>0]|0;Da=f[ca>>2]|0;if(!((za<<24>>24<0?Da:za&255)|0))Ra=za;else{pa=0;Fa=Da;Da=za;while(1){za=b[(Da<<24>>24<0?f[e>>2]|0:e)+pa>>0]|0;if((za+-33&255)<90){BYc(i,za);Sa=b[ba>>0]|0;Ta=f[ca>>2]|0}else{Sa=Da;Ta=Fa}pa=pa+1|0;if(pa>>>0>=(Sa<<24>>24<0?Ta:Sa&255)>>>0){Ra=Sa;break}else{Fa=Ta;Da=Sa}}}if(Ra<<24>>24<0){b[f[e>>2]>>0]=0;f[ca>>2]=0}else{b[e>>0]=0;b[ba>>0]=0}sYc(e,0);f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];Da=b[da>>0]|0;Fa=f[ea>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(!((Da<<24>>24<0?Fa:Da&255)|0))Ua=Da;else{pa=0;ua=Fa;Fa=Da;while(1){Da=b[(Fa<<24>>24<0?f[h>>2]|0:h)+pa>>0]|0;if((Da+-33&255)<90){BYc(i,Da);Va=b[da>>0]|0;Wa=f[ea>>2]|0}else{Va=Fa;Wa=ua}pa=pa+1|0;if(pa>>>0>=(Va<<24>>24<0?Wa:Va&255)>>>0){Ua=Va;break}else{ua=Wa;Fa=Va}}}if(Ua<<24>>24<0){b[f[h>>2]>>0]=0;f[ea>>2]=0}else{b[h>>0]=0;b[da>>0]=0}sYc(h,0);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];Fa=b[ba>>0]|0;ua=b[da>>0]|0;pa=ua<<24>>24<0;if(!((Fa<<24>>24<0?f[ca>>2]|0:Fa&255)|0)){if(pa){cYc(f[h>>2]|0);Xa=b[ba>>0]|0}else Xa=Fa;if(Xa<<24>>24<0)cYc(f[e>>2]|0);xa=oa;ya=na;oa=xa;na=ya;continue}if(!((pa?f[ea>>2]|0:ua&255)|0)){if(pa){cYc(f[h>>2]|0);Ya=b[ba>>0]|0}else Ya=Fa;if(Ya<<24>>24<0)cYc(f[e>>2]|0);xa=oa;ya=na;oa=xa;na=ya;continue}if(oa)oYc(ALa(fa,e)|0,h)|0;else{Fa=f[ha>>2]|0;do if(Fa){pa=ia;ua=Fa;while(1){Da=f[ua+16>>2]|0;if((na|0)<(Da|0)){za=f[ua>>2]|0;if(!za){ra=86;break}else{Za=ua;_a=za}}else{if((Da|0)>=(na|0)){ra=90;break}$a=ua+4|0;Da=f[$a>>2]|0;if(!Da){ra=89;break}else{Za=$a;_a=Da}}pa=Za;ua=_a}if((ra|0)==86){ra=0;ab=ua;bb=ua;break}else if((ra|0)==89){ra=0;ab=ua;bb=$a;break}else if((ra|0)==90){ra=0;ab=ua;bb=pa;break}}else{ab=ha;bb=ha}while(0);Fa=f[bb>>2]|0;if(!Fa){qa=$Xc(32)|0;f[qa+16>>2]=na;Ga=qa+24|0;f[Ga>>2]=0;f[qa+28>>2]=0;f[qa+20>>2]=Ga;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=ab;f[bb>>2]=qa;Ga=f[f[ga>>2]>>2]|0;if(!Ga)cb=qa;else{f[ga>>2]=Ga;cb=f[bb>>2]|0}UQ(f[ia>>2]|0,cb);f[ja>>2]=(f[ja>>2]|0)+1;db=qa}else db=Fa;oYc(ALa(db+20|0,e)|0,h)|0}if((b[da>>0]|0)<0)cYc(f[h>>2]|0);if((b[ba>>0]|0)<0)cYc(f[e>>2]|0);xa=oa;ya=na;oa=xa;na=ya}if((ra|0)==3){if((b[$>>0]|0)<0)cYc(f[g>>2]|0);$=(f[ja>>2]|0)+-1|0;ya=f[ha>>2]|0;do if(ya){na=ia;xa=ya;while(1){oa=f[xa+16>>2]|0;if(($|0)<(oa|0)){ba=f[xa>>2]|0;if(!ba){ra=9;break}else{eb=xa;fb=ba}}else{if((oa|0)>=($|0)){ra=13;break}gb=xa+4|0;oa=f[gb>>2]|0;if(!oa){ra=12;break}else{eb=gb;fb=oa}}na=eb;xa=fb}if((ra|0)==9){hb=xa;ib=xa;break}else if((ra|0)==12){hb=xa;ib=gb;break}else if((ra|0)==13){hb=xa;ib=na;break}}else{hb=ha;ib=ha}while(0);gb=f[ib>>2]|0;if(!gb){fb=$Xc(32)|0;f[fb+16>>2]=$;$=fb+24|0;f[$>>2]=0;f[fb+28>>2]=0;f[fb+20>>2]=$;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=hb;f[ib>>2]=fb;hb=f[f[ga>>2]>>2]|0;if(!hb)jb=fb;else{f[ga>>2]=hb;jb=f[ib>>2]|0}UQ(f[ia>>2]|0,jb);f[ja>>2]=(f[ja>>2]|0)+1;kb=fb}else kb=gb;gb=kb+20|0;f[h+8>>2]=0;fb=h+11|0;b[fb>>0]=7;b[h>>0]=b[438918]|0;b[h+1>>0]=b[438919]|0;b[h+2>>0]=b[438920]|0;b[h+3>>0]=b[438921]|0;b[h+4>>0]=b[438922]|0;b[h+5>>0]=b[438923]|0;b[h+6>>0]=b[438924]|0;b[h+7>>0]=0;jb=DLa(gb,e,h)|0;ia=f[jb>>2]|0;if(!ia){ib=$Xc(40)|0;hb=ib+16|0;f[hb>>2]=f[h>>2];f[hb+4>>2]=f[h+4>>2];f[hb+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;hb=ib+28|0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;hb=f[e>>2]|0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=hb;f[jb>>2]=ib;hb=f[f[gb>>2]>>2]|0;if(!hb)lb=ib;else{f[gb>>2]=hb;lb=f[jb>>2]|0}UQ(f[kb+24>>2]|0,lb);lb=kb+28|0;f[lb>>2]=(f[lb>>2]|0)+1;mb=ib}else mb=ia;lYc(g,mb+28|0);if((b[fb>>0]|0)<0)cYc(f[h>>2]|0);trb(h,g);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;fb=j+11|0;b[fb>>0]=5;b[j>>0]=b[471037]|0;b[j+1>>0]=b[471038]|0;b[j+2>>0]=b[471039]|0;b[j+3>>0]=b[471040]|0;b[j+4>>0]=b[471041]|0;b[j+5>>0]=0;mb=urb(fa,j,416)|0;f[c>>2]=mb;if((b[fb>>0]|0)<0)cYc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=k+11|0;b[j>>0]=6;b[k>>0]=b[471030]|0;b[k+1>>0]=b[471031]|0;b[k+2>>0]=b[471032]|0;b[k+3>>0]=b[471033]|0;b[k+4>>0]=b[471034]|0;b[k+5>>0]=b[471035]|0;b[k+6>>0]=0;fb=urb(fa,k,416)|0;mb=c+4|0;f[mb>>2]=fb;if((b[j>>0]|0)<0)cYc(f[k>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;k=l+11|0;b[k>>0]=8;j=l;f[j>>2]=1851877475;f[j+4>>2]=1936483694;b[l+8>>0]=0;j=urb(fa,l,3)|0;fa=c+8|0;f[fa>>2]=j;if((b[k>>0]|0)<0)cYc(f[l>>2]|0);if((f[c>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;nb=$Xc(64)|0;f[e>>2]=nb;ob=e+8|0;f[ob>>2]=-2147483584;pb=e+4|0;f[pb>>2]=54;qb=nb;rb=428220;sb=qb+54|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));tb=nb+54|0;b[tb>>0]=0;vM(-215,e,428086,428111,528)}if((f[mb>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;nb=$Xc(64)|0;f[e>>2]=nb;ob=e+8|0;f[ob>>2]=-2147483584;pb=e+4|0;f[pb>>2]=54;qb=nb;rb=428220;sb=qb+54|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));tb=nb+54|0;b[tb>>0]=0;vM(-215,e,428086,428111,528)}mb=f[fa>>2]|0;if((mb|0)<=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;nb=$Xc(64)|0;f[e>>2]=nb;ob=e+8|0;f[ob>>2]=-2147483584;pb=e+4|0;f[pb>>2]=54;qb=nb;rb=428220;sb=qb+54|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));tb=nb+54|0;b[tb>>0]=0;vM(-215,e,428086,428111,528)}tb=c+24|0;nb=f[ja>>2]|0;ja=c+28|0;pb=f[ja>>2]|0;ob=f[tb>>2]|0;fa=pb-ob>>2;l=ob;ob=pb;if(nb>>>0<=fa>>>0){if(nb>>>0<fa>>>0?(pb=l+(nb<<2)|0,(ob|0)!=(pb|0)):0)f[ja>>2]=ob+(~((ob+-4-pb|0)>>>2)<<2)}else CS(tb,nb-fa|0);f[i>>2]=c;f[i+4>>2]=0;c=i+8|0;lYc(c,892640);f[i+20>>2]=0;fa=i+24|0;f[fa>>2]=0;f[i+28>>2]=0;nb=f[ga>>2]|0;c:do if((nb|0)!=(ha|0)){ga=n+11|0;pb=n+4|0;ob=m+11|0;ja=m+4|0;l=o+11|0;k=o+4|0;j=p+11|0;fb=p+3|0;ia=q+11|0;ib=q+6|0;lb=r+11|0;kb=r+7|0;jb=s+11|0;hb=s+10|0;gb=t+11|0;$=t+6|0;eb=v+8|0;ya=v+4|0;oa=v+11|0;ba=e+11|0;da=e+4|0;db=w+11|0;cb=w+7|0;bb=x+11|0;ab=x+4|0;$a=y+11|0;_a=y+6|0;Za=z+11|0;Ya=z+3|0;ea=A+11|0;Xa=A+6|0;ca=B+11|0;Ua=B+6|0;Va=C+11|0;Wa=e+11|0;Ra=e+4|0;Sa=n+4|0;Ta=D+11|0;aa=D+6|0;ma=E+11|0;ka=E+6|0;Qa=F+11|0;Oa=F+6|0;Pa=G+11|0;la=G+7|0;Na=H+11|0;Ma=H+3|0;La=I+11|0;Ka=I+8|0;Ja=J+11|0;Ia=J+7|0;Ea=K+11|0;Aa=K+4|0;Ca=L+11|0;Ba=e+11|0;sa=e+4|0;va=M+11|0;wa=M+7|0;a=N+11|0;Fa=e+11|0;qa=e+4|0;Ga=n+4|0;Da=P+11|0;za=P+4|0;ta=Q+11|0;Ha=e+11|0;ub=e+4|0;vb=R+11|0;wb=R+6|0;xb=S+11|0;yb=S+7|0;zb=T+11|0;Ab=T+3|0;Bb=U+11|0;Cb=U+7|0;Db=V+11|0;Eb=e+11|0;Fb=e+4|0;Gb=W+11|0;Hb=W+4|0;Ib=X+11|0;Jb=O+11|0;Kb=O+4|0;Lb=n+4|0;Mb=Z+4|0;Nb=p+4|0;Ob=r+8|0;Pb=w+8|0;Qb=z+4|0;Rb=G+8|0;Sb=H+4|0;Tb=J+8|0;Ub=M+8|0;Vb=S+8|0;Wb=T+4|0;Xb=U+8|0;Yb=mb;Zb=-1;_b=nb;d:while(1){Zb=Zb+1|0;$b=_b+20|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;b[ga>>0]=4;f[n>>2]=1701869940;b[pb>>0]=0;ac=DLa($b,e,n)|0;bc=f[ac>>2]|0;if(!bc){cc=$Xc(40)|0;dc=cc+16|0;f[dc>>2]=f[n>>2];f[dc+4>>2]=f[n+4>>2];f[dc+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;dc=cc+28|0;f[dc>>2]=0;f[dc+4>>2]=0;f[dc+8>>2]=0;dc=f[e>>2]|0;f[cc>>2]=0;f[cc+4>>2]=0;f[cc+8>>2]=dc;f[ac>>2]=cc;dc=f[f[$b>>2]>>2]|0;if(!dc)ec=cc;else{f[$b>>2]=dc;ec=f[ac>>2]|0}UQ(f[_b+24>>2]|0,ec);ac=_b+28|0;f[ac>>2]=(f[ac>>2]|0)+1;fc=cc}else fc=bc;lYc(m,fc+28|0);if((b[ga>>0]|0)<0)cYc(f[n>>2]|0);bc=b[ob>>0]|0;cc=f[ja>>2]|0;do if(((bc<<24>>24<0?cc:bc&255)|0)==13){if(LYc(m,0,-1,428275,13)|0){gc=b[ob>>0]|0;hc=f[ja>>2]|0;ra=188;break};f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[l>>0]=4;f[o>>2]=1702521203;b[k>>0]=0;ac=urb($b,o,-1)|0;if((b[l>>0]|0)<0)cYc(f[o>>2]|0);dc=Nb;f[dc>>2]=0;f[dc+4>>2]=0;b[j>>0]=3;b[p>>0]=b[446809]|0;b[p+1>>0]=b[446810]|0;b[p+2>>0]=b[446811]|0;b[fb>>0]=0;dc=urb($b,p,0)|0;if((b[j>>0]|0)<0)cYc(f[p>>2]|0);f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;b[ia>>0]=6;b[q>>0]=b[446813]|0;b[q+1>>0]=b[446814]|0;b[q+2>>0]=b[446815]|0;b[q+3>>0]=b[446816]|0;b[q+4>>0]=b[446817]|0;b[q+5>>0]=b[446818]|0;b[ib>>0]=0;ic=urb($b,q,1)|0;if((b[ia>>0]|0)<0)cYc(f[q>>2]|0);f[Ob>>2]=0;b[lb>>0]=7;b[r>>0]=b[428289]|0;b[r+1>>0]=b[428290]|0;b[r+2>>0]=b[428291]|0;b[r+3>>0]=b[428292]|0;b[r+4>>0]=b[428293]|0;b[r+5>>0]=b[428294]|0;b[r+6>>0]=b[428295]|0;b[kb>>0]=0;jc=urb($b,r,-1)|0;if((b[lb>>0]|0)<0)cYc(f[r>>2]|0);b[jb>>0]=10;qb=s;rb=428297;sb=qb+10|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[hb>>0]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;b[gb>>0]=6;b[t>>0]=b[428308]|0;b[t+1>>0]=b[428309]|0;b[t+2>>0]=b[428310]|0;b[t+3>>0]=b[428311]|0;b[t+4>>0]=b[428312]|0;b[t+5>>0]=b[428313]|0;b[$>>0]=0;vrb(e,$b,s,t);if((b[gb>>0]|0)<0)cYc(f[t>>2]|0);if((b[jb>>0]|0)<0)cYc(f[s>>2]|0);f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;kc=$Xc(16)|0;f[v>>2]=kc;f[eb>>2]=-2147483632;f[ya>>2]=15;qb=kc;rb=428315;sb=qb+15|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[kc+15>>0]=0;lc=(urb($b,v,0)|0)==1;if((b[oa>>0]|0)<0)cYc(f[v>>2]|0);mc=b[ba>>0]|0;nc=f[da>>2]|0;do if(((mc<<24>>24<0?nc:mc&255)|0)==6){if(!(LYc(e,0,-1,428308,6)|0))break;oc=b[ba>>0]|0;pc=f[da>>2]|0;ra=172}else{oc=mc;pc=nc;ra=172}while(0);if((ra|0)==172){ra=0;if(((oc<<24>>24<0?pc:oc&255)|0)!=5){ra=174;break d}if(LYc(e,0,-1,428331,5)|0){ra=174;break d}}f[Pb>>2]=0;b[db>>0]=7;b[w>>0]=b[428362]|0;b[w+1>>0]=b[428363]|0;b[w+2>>0]=b[428364]|0;b[w+3>>0]=b[428365]|0;b[w+4>>0]=b[428366]|0;b[w+5>>0]=b[428367]|0;b[w+6>>0]=b[428368]|0;b[cb>>0]=0;nc=urb($b,w,0)|0;if((b[db>>0]|0)<0)cYc(f[w>>2]|0);if((nc|0)==1){ra=178;break d}if(!((ac|0)>0&(jc|0)>0)){ra=180;break d}if((Yb|0)<=0){ra=182;break d}nc=b[ba>>0]|0;if(((nc<<24>>24<0?f[da>>2]|0:nc&255)|0)==5)qc=(LYc(e,0,-1,428331,5)|0)==0;else qc=0;wrb(i,ac,(ac|0)<3?0:dc,ic,jc,Yb,lc&1,qc&1);if((b[ba>>0]|0)<0)cYc(f[e>>2]|0);rc=jc}else{gc=bc;hc=cc;ra=188}while(0);e:do if((ra|0)==188){ra=0;do if(((gc<<24>>24<0?hc:gc&255)|0)==7){if(LYc(m,0,-1,428477,7)|0){sc=b[ob>>0]|0;tc=f[ja>>2]|0;break};f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;b[bb>>0]=4;f[x>>2]=1702521203;b[ab>>0]=0;cc=urb($b,x,2)|0;if((b[bb>>0]|0)<0)cYc(f[x>>2]|0);f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;b[$a>>0]=6;b[y>>0]=b[446813]|0;b[y+1>>0]=b[446814]|0;b[y+2>>0]=b[446815]|0;b[y+3>>0]=b[446816]|0;b[y+4>>0]=b[446817]|0;b[y+5>>0]=b[446818]|0;b[_a>>0]=0;bc=urb($b,y,2)|0;if((b[$a>>0]|0)<0)cYc(f[y>>2]|0);pa=Qb;f[pa>>2]=0;f[pa+4>>2]=0;b[Za>>0]=3;b[z>>0]=b[446809]|0;b[z+1>>0]=b[446810]|0;b[z+2>>0]=b[446811]|0;b[Ya>>0]=0;pa=urb($b,z,0)|0;if((b[Za>>0]|0)<0)cYc(f[z>>2]|0);xrb(i,cc,pa,bc);rc=Yb;break e}else{sc=gc;tc=hc}while(0);do if(((sc<<24>>24<0?tc:sc&255)|0)==7)if(!(LYc(m,0,-1,428485,7)|0)){yrb(i);rc=Yb;break e}else{uc=b[ob>>0]|0;vc=f[ja>>2]|0;break}else{uc=sc;vc=tc}while(0);do if(((uc<<24>>24<0?vc:uc&255)|0)==7){if(LYc(m,0,-1,438926,7)|0){wc=b[ob>>0]|0;xc=f[ja>>2]|0;break};f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;b[ea>>0]=6;b[A>>0]=b[428493]|0;b[A+1>>0]=b[428494]|0;b[A+2>>0]=b[428495]|0;b[A+3>>0]=b[428496]|0;b[A+4>>0]=b[428497]|0;b[A+5>>0]=b[428498]|0;b[Xa>>0]=0;jc=urb($b,A,1)|0;if((b[ea>>0]|0)<0)cYc(f[A>>2]|0);if((jc|0)!=1){ra=208;break d}zrb(i);rc=Yb;break e}else{wc=uc;xc=vc}while(0);do if(((wc<<24>>24<0?xc:wc&255)|0)==5){if(LYc(m,0,-1,428538,5)|0){yc=b[ob>>0]|0;zc=f[ja>>2]|0;break};f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;b[ca>>0]=6;b[B>>0]=b[428544]|0;b[B+1>>0]=b[428545]|0;b[B+2>>0]=b[428546]|0;b[B+3>>0]=b[428547]|0;b[B+4>>0]=b[428548]|0;b[B+5>>0]=b[428549]|0;b[Ua>>0]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;vrb(e,$b,B,C);if((b[Va>>0]|0)<0)cYc(f[C>>2]|0);if((b[ca>>0]|0)<0)cYc(f[B>>2]|0);jc=b[Wa>>0]|0;if(!((jc<<24>>24<0?f[Ra>>2]|0:jc&255)|0)){ra=218;break d}Arb(n,e);jc=f[n>>2]|0;lc=(f[Sa>>2]|0)-jc>>2;ic=jc;do if(!lc){Ac=0;Bc=0;ra=224}else{jc=f[tb>>2]|0;dc=0;ac=0;do{bc=ic+(dc<<2)|0;pa=f[bc>>2]|0;cc=((pa|0)>0?0:Zb)+pa|0;f[bc>>2]=cc;ac=(f[jc+(cc<<2)>>2]|0)+ac|0;dc=dc+1|0}while(dc>>>0<lc>>>0);if((lc|0)!=1){Ac=ac;Bc=lc;ra=224;break}Brb(i,f[ic>>2]|0);Cc=ac}while(0);if((ra|0)==224){ra=0;Crb(i,Bc,ic);Cc=Ac}lc=f[n>>2]|0;if(lc|0){dc=f[Sa>>2]|0;if((dc|0)!=(lc|0))f[Sa>>2]=dc+(~((dc+-4-lc|0)>>>2)<<2);cYc(lc)}if((b[Wa>>0]|0)<0)cYc(f[e>>2]|0);rc=Cc;break e}else{yc=wc;zc=xc}while(0);do if(((yc<<24>>24<0?zc:yc&255)|0)==5){if(LYc(m,0,-1,428574,5)|0){Dc=b[ob>>0]|0;Ec=f[ja>>2]|0;break};f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;b[Ta>>0]=6;b[D>>0]=b[446813]|0;b[D+1>>0]=b[446814]|0;b[D+2>>0]=b[446815]|0;b[D+3>>0]=b[446816]|0;b[D+4>>0]=b[446817]|0;b[D+5>>0]=b[446818]|0;b[aa>>0]=0;lc=urb($b,D,2)|0;if((b[Ta>>0]|0)<0)cYc(f[D>>2]|0);Drb(i,lc);rc=Y(Y(lc,Yb)|0,lc)|0;break e}else{Dc=yc;Ec=zc}while(0);do if(((Dc<<24>>24<0?Ec:Dc&255)|0)==6){if(LYc(m,0,-1,428580,6)|0){Fc=b[ob>>0]|0;Gc=f[ja>>2]|0;break};f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;b[ma>>0]=6;b[E>>0]=b[438896]|0;b[E+1>>0]=b[438897]|0;b[E+2>>0]=b[438898]|0;b[E+3>>0]=b[438899]|0;b[E+4>>0]=b[438900]|0;b[E+5>>0]=b[438901]|0;b[ka>>0]=0;Hc=+Erb($b,E,1.0000000474974513e-03);if((b[ma>>0]|0)<0)cYc(f[E>>2]|0);f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;b[Qa>>0]=6;b[F>>0]=b[438903]|0;b[F+1>>0]=b[438904]|0;b[F+2>>0]=b[438905]|0;b[F+3>>0]=b[438906]|0;b[F+4>>0]=b[438907]|0;b[F+5>>0]=b[438908]|0;b[Oa>>0]=0;lc=urb($b,F,4)|0;if((b[Qa>>0]|0)<0)cYc(f[F>>2]|0);f[Rb>>2]=0;b[Pa>>0]=7;b[G>>0]=b[438910]|0;b[G+1>>0]=b[438911]|0;b[G+2>>0]=b[438912]|0;b[G+3>>0]=b[438913]|0;b[G+4>>0]=b[438914]|0;b[G+5>>0]=b[438915]|0;b[G+6>>0]=b[438916]|0;b[la>>0]=0;dc=urb($b,G,-1)|0;if((b[Pa>>0]|0)<0)cYc(f[G>>2]|0);jc=Sb;f[jc>>2]=0;f[jc+4>>2]=0;b[Na>>0]=3;b[H>>0]=b[428587]|0;b[H+1>>0]=b[428588]|0;b[H+2>>0]=b[428589]|0;b[Ma>>0]=0;jc=urb($b,H,-1)|0;if((b[Na>>0]|0)<0)cYc(f[H>>2]|0);f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;b[La>>0]=8;cc=I;f[cc>>2]=1935764579;f[cc+4>>2]=2020173427;b[Ka>>0]=0;cc=urb($b,I,0)|0;if((b[La>>0]|0)<0)cYc(f[I>>2]|0);f[Tb>>2]=0;b[Ja>>0]=7;b[J>>0]=b[438926]|0;b[J+1>>0]=b[438927]|0;b[J+2>>0]=b[438928]|0;b[J+3>>0]=b[438929]|0;b[J+4>>0]=b[438930]|0;b[J+5>>0]=b[438931]|0;b[J+6>>0]=b[438932]|0;b[Ia>>0]=0;bc=(urb($b,J,0)|0)==1;if((b[Ja>>0]|0)<0)cYc(f[J>>2]|0);f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;b[Ea>>0]=4;f[K>>2]=1701147252;b[Aa>>0]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;vrb(e,$b,K,L);pa=b[Ba>>0]|0;ua=pa<<24>>24<0;nc=((ua?f[sa>>2]|0:pa&255)|0)!=0;if(ua)cYc(f[e>>2]|0);if((b[Ca>>0]|0)<0)cYc(f[L>>2]|0);if((b[Ea>>0]|0)<0)cYc(f[K>>2]|0);f[Ub>>2]=0;b[va>>0]=7;b[M>>0]=b[438918]|0;b[M+1>>0]=b[438919]|0;b[M+2>>0]=b[438920]|0;b[M+3>>0]=b[438921]|0;b[M+4>>0]=b[438922]|0;b[M+5>>0]=b[438923]|0;b[M+6>>0]=b[438924]|0;b[wa>>0]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;vrb(e,$b,M,N);if((b[a>>0]|0)<0)cYc(f[N>>2]|0);if((b[va>>0]|0)<0)cYc(f[M>>2]|0);ua=b[Fa>>0]|0;if(!((ua<<24>>24<0?f[qa>>2]|0:ua&255)|0)){ra=264;break d}trb(n,e);if(!((dc|0)>0&(jc|0)>0)){ra=267;break d}if((jc<<1|0)!=((f[Ga>>2]|0)-(f[n>>2]|0)>>2|0)){ra=267;break d}Frb(i,0);Grb(i,Hc,lc,dc,jc,cc,bc&1,nc&1,f[n>>2]|0);nc=f[n>>2]|0;if(nc|0){bc=f[Ga>>2]|0;if((bc|0)!=(nc|0))f[Ga>>2]=bc+(~((bc+-4-nc|0)>>>2)<<2);cYc(nc)}if((b[Fa>>0]|0)<0)cYc(f[e>>2]|0);rc=Yb;break e}else{Fc=Dc;Gc=Ec}while(0);do if(((Fc<<24>>24<0?Gc:Fc&255)|0)==8){if(LYc(m,0,-1,428695,8)|0){Ic=b[ob>>0]|0;Jc=f[ja>>2]|0;break};f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;b[Da>>0]=4;f[P>>2]=1836020326;b[za>>0]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;vrb(e,$b,P,Q);if((b[ta>>0]|0)<0)cYc(f[Q>>2]|0);if((b[Da>>0]|0)<0)cYc(f[P>>2]|0);nc=b[Ha>>0]|0;bc=nc<<24>>24<0;if(!((bc?f[ub>>2]|0:nc&255)|0)){ra=283;break d}nc=(jLc(bc?f[e>>2]|0:e)|0)+Zb|0;bc=f[(f[tb>>2]|0)+(nc<<2)>>2]|0;Hrb(i,nc);if((b[Ha>>0]|0)<0)cYc(f[e>>2]|0);rc=bc;break e}else{Ic=Fc;Jc=Gc}while(0);do if(((Ic<<24>>24<0?Jc:Ic&255)|0)==8){if(LYc(m,0,-1,428726,8)|0){Kc=b[ob>>0]|0;Lc=f[ja>>2]|0;break};f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;b[vb>>0]=6;b[R>>0]=b[446813]|0;b[R+1>>0]=b[446814]|0;b[R+2>>0]=b[446815]|0;b[R+3>>0]=b[446816]|0;b[R+4>>0]=b[446817]|0;b[R+5>>0]=b[446818]|0;b[wb>>0]=0;bc=urb($b,R,1)|0;if((b[vb>>0]|0)<0)cYc(f[R>>2]|0);Irb(i,bc);rc=Yb;break e}else{Kc=Ic;Lc=Jc}while(0);if(((Kc<<24>>24<0?Lc:Kc&255)|0)!=4){ra=327;break d}if(LYc(m,0,-1,428735,4)|0){ra=327;break d}f[Vb>>2]=0;b[xb>>0]=7;b[S>>0]=b[438910]|0;b[S+1>>0]=b[438911]|0;b[S+2>>0]=b[438912]|0;b[S+3>>0]=b[438913]|0;b[S+4>>0]=b[438914]|0;b[S+5>>0]=b[438915]|0;b[S+6>>0]=b[438916]|0;b[yb>>0]=0;bc=urb($b,S,-1)|0;if((b[xb>>0]|0)<0)cYc(f[S>>2]|0);nc=Wb;f[nc>>2]=0;f[nc+4>>2]=0;b[zb>>0]=3;b[T>>0]=b[428587]|0;b[T+1>>0]=b[428588]|0;b[T+2>>0]=b[428589]|0;b[Ab>>0]=0;nc=urb($b,T,-1)|0;if((b[zb>>0]|0)<0)cYc(f[T>>2]|0);f[Xb>>2]=0;b[Bb>>0]=7;b[U>>0]=b[438918]|0;b[U+1>>0]=b[438919]|0;b[U+2>>0]=b[438920]|0;b[U+3>>0]=b[438921]|0;b[U+4>>0]=b[438922]|0;b[U+5>>0]=b[438923]|0;b[U+6>>0]=b[438924]|0;b[Cb>>0]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;vrb(e,$b,U,V);if((b[Db>>0]|0)<0)cYc(f[V>>2]|0);if((b[Bb>>0]|0)<0)cYc(f[U>>2]|0);cc=b[Eb>>0]|0;if(!((cc<<24>>24<0?f[Fb>>2]|0:cc&255)|0)){ra=304;break d}trb(n,e);f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;b[Gb>>0]=4;f[W>>2]=1802723693;b[Hb>>0]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;vrb(O,$b,W,X);if((b[Ib>>0]|0)<0)cYc(f[X>>2]|0);if((b[Gb>>0]|0)<0)cYc(f[W>>2]|0);cc=b[Jb>>0]|0;if(!((cc<<24>>24<0?f[Kb>>2]|0:cc&255)|0)){ra=310;break d}Arb(Z,O);if(!((bc|0)>0&(nc|0)>0)){ra=313;break d}if((nc<<1|0)!=((f[Lb>>2]|0)-(f[n>>2]|0)>>2|0)){ra=313;break d}Frb(i,0);Jrb(i,bc,Z,n);bc=f[Z>>2]|0;if(bc|0){nc=f[Mb>>2]|0;if((nc|0)!=(bc|0))f[Mb>>2]=nc+(~((nc+-4-bc|0)>>>2)<<2);cYc(bc)}if((b[Jb>>0]|0)<0)cYc(f[O>>2]|0);bc=f[n>>2]|0;if(bc|0){nc=f[Lb>>2]|0;if((nc|0)!=(bc|0))f[Lb>>2]=nc+(~((nc+-4-bc|0)>>>2)<<2);cYc(bc)}if((b[Eb>>0]|0)<0)cYc(f[e>>2]|0);rc=Yb}while(0);f[(f[tb>>2]|0)+(Zb<<2)>>2]=rc;if((b[ob>>0]|0)<0)cYc(f[m>>2]|0);$b=f[_b+4>>2]|0;do if(!$b){bc=_b+8|0;nc=f[bc>>2]|0;if((f[nc>>2]|0)==(_b|0)){Mc=nc;break}else Nc=bc;do{bc=f[Nc>>2]|0;Nc=bc+8|0;nc=f[Nc>>2]|0}while((f[nc>>2]|0)!=(bc|0));Mc=nc}else{nc=$b;while(1){bc=f[nc>>2]|0;if(!bc)break;else nc=bc}Mc=nc}while(0);if((Mc|0)==(ha|0)){ra=130;break}else{Yb=rc;_b=Mc}}switch(ra|0){case 130:{_b=i+20|0;Yb=f[_b>>2]|0;if(!Yb)break c;ob=f[fa>>2]|0;if((ob|0)==(Yb|0))Oc=Yb;else{Zb=ob;while(1){ob=Zb+-12|0;f[fa>>2]=ob;if((b[ob+11>>0]|0)<0){cYc(f[ob>>2]|0);Pc=f[fa>>2]|0}else Pc=ob;if((Pc|0)==(Yb|0))break;else Zb=Pc}Oc=f[_b>>2]|0}cYc(Oc);break c;break}case 174:{SGa(n,428337,e);vM(-212,n,428086,428111,552);break}case 178:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;Zb=$Xc(64)|0;f[n>>2]=Zb;f[n+8>>2]=-2147483584;f[n+4>>2]=54;qb=Zb;rb=428370;sb=qb+54|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[Zb+54>>0]=0;vM(-213,n,428086,428111,555);break}case 180:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;_b=$Xc(32)|0;f[n>>2]=_b;f[n+8>>2]=-2147483616;f[n+4>>2]=30;qb=_b;rb=428425;sb=qb+30|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[_b+30>>0]=0;vM(-215,n,428086,428111,560);break}case 182:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;Zb=$Xc(32)|0;f[n>>2]=Zb;f[n+8>>2]=-2147483616;f[n+4>>2]=20;qb=Zb;rb=428456;sb=qb+20|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[Zb+20>>0]=0;vM(-215,n,428086,428111,561);break}case 208:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;_b=$Xc(48)|0;f[e>>2]=_b;f[e+8>>2]=-2147483600;f[e+4>>2]=37;qb=_b;rb=428500;sb=qb+37|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[_b+37>>0]=0;vM(-213,e,428086,428111,583);break}case 218:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;Zb=$Xc(32)|0;f[n>>2]=Zb;f[n+8>>2]=-2147483616;f[n+4>>2]=22;qb=Zb;rb=428551;sb=qb+22|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[Zb+22>>0]=0;vM(-215,n,428086,428111,589);break}case 264:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;_b=$Xc(32)|0;f[n>>2]=_b;f[n+8>>2]=-2147483616;f[n+4>>2]=23;qb=_b;rb=428591;sb=qb+23|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[_b+23>>0]=0;vM(-215,n,428086,428111,621);break}case 267:{f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;Zb=$Xc(80)|0;f[O>>2]=Zb;f[O+8>>2]=-2147483568;f[O+4>>2]=79;qb=Zb;rb=428615;sb=qb+79|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[Zb+79>>0]=0;vM(-215,O,428086,428111,624);break}case 283:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;_b=$Xc(32)|0;f[n>>2]=_b;f[n+8>>2]=-2147483616;f[n+4>>2]=21;qb=_b;rb=428704;sb=qb+21|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[_b+21>>0]=0;vM(-215,n,428086,428111,632);break}case 304:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;Zb=$Xc(32)|0;f[n>>2]=Zb;f[n+8>>2]=-2147483616;f[n+4>>2]=23;qb=Zb;rb=428591;sb=qb+23|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[Zb+23>>0]=0;vM(-215,n,428086,428111,651);break}case 310:{f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;_b=$Xc(32)|0;f[Z>>2]=_b;f[Z+8>>2]=-2147483616;f[Z+4>>2]=20;qb=_b;rb=428740;sb=qb+20|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[_b+20>>0]=0;vM(-215,Z,428086,428111,655);break}case 313:{f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;Zb=$Xc(80)|0;f[_>>2]=Zb;f[_+8>>2]=-2147483568;f[_+4>>2]=79;qb=Zb;rb=428615;sb=qb+79|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[Zb+79>>0]=0;vM(-215,_,428086,428111,658);break}case 327:{SGa(e,428761,m);vM(-212,e,428086,428111,664);break}}}while(0);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=f[h>>2]|0;if(c|0){m=h+4|0;h=f[m>>2]|0;if((h|0)!=(c|0))f[m>>2]=h+(~((h+-4-c|0)>>>2)<<2);cYc(c)}if((b[g+11>>0]|0)>=0){u=d;return 1}cYc(f[g>>2]|0);u=d;return 1}else if((ra|0)==39){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=29;qb=d;rb=428056;sb=qb+29|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[d+29>>0]=0;vM(-215,e,428086,428111,499)}else if((ra|0)==63){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ra=$Xc(32)|0;f[e>>2]=ra;f[e+8>>2]=-2147483616;f[e+4>>2]=29;qb=ra;rb=428190;sb=qb+29|0;do{b[qb>>0]=b[rb>>0]|0;qb=qb+1|0;rb=rb+1|0}while((qb|0)<(sb|0));b[ra+29>>0]=0;vM(-215,e,428086,428111,507)}return 0}function srb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;cOc(g,a,1);if(!(b[g>>0]|0)){u=e;return a|0}g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;i=c+4|0;f[i>>2]=0;j=i}else{b[c>>0]=0;b[g>>0]=0;j=c+4|0}i=0;while(1){k=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;l=k+12|0;m=f[l>>2]|0;if((m|0)==(f[k+16>>2]|0)){n=_i[f[(f[k>>2]|0)+40>>2]&2047](k)|0;if((n|0)==-1){o=i;p=2;break}else q=n}else{f[l>>2]=m+1;q=h[m>>0]|0}m=i+1|0;l=q&255;if(l<<24>>24==d<<24>>24){o=m;p=0;break}BYc(c,l);if((b[g>>0]|0)<0&(f[j>>2]|0)==-17){o=m;p=4;break}else i=m}i=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(i,f[i+16>>2]|((o|0)==0?p|4:p));u=e;return a|0}function trb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+320|0;e=d+168|0;g=d+152|0;h=d+8|0;i=d;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;k=e+64|0;l=e+8|0;f[l>>2]=35876;m=e+12|0;f[e>>2]=6740;f[k>>2]=6760;f[e+4>>2]=0;XNc(e+64|0,m);f[e+136>>2]=0;f[e+140>>2]=-1;f[e>>2]=35856;f[k>>2]=35896;f[l>>2]=35876;aOc(m);f[m>>2]=35912;l=e+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[e+60>>2]=24;AM(m,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=h+64|0;n=h+8|0;o=h+12|0;p=h+4|0;q=h+64|0;r=h+136|0;s=h+140|0;t=h+44|0;v=h+60|0;w=a+8|0;x=h+8|0;y=t+11|0;while(1){z=srb(e,g,44)|0;if(f[z+(f[(f[z>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;f[n>>2]=35876;f[h>>2]=6740;f[c>>2]=6760;f[p>>2]=0;XNc(q,o);f[r>>2]=0;f[s>>2]=-1;f[h>>2]=35856;f[c>>2]=35896;f[n>>2]=35876;aOc(o);f[o>>2]=35912;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[v>>2]=24;AM(o,g);hOc(h,i)|0;z=f[j>>2]|0;if((z|0)==(f[w>>2]|0))hw(a,i);else{f[z>>2]=f[i>>2];f[j>>2]=z+4}f[h>>2]=35856;f[c>>2]=35896;f[x>>2]=35876;f[o>>2]=35912;if((b[y>>0]|0)<0)cYc(f[t>>2]|0);LMc(o);TNc(h,35972);GMc(c)}if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[e>>2]=35856;f[k>>2]=35896;f[e+8>>2]=35876;f[m>>2]=35912;if((b[l+11>>0]|0)>=0){LMc(m);TNc(e,35972);GMc(k);u=d;return}cYc(f[l>>2]|0);LMc(m);TNc(e,35972);GMc(k);u=d;return}function urb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+160|0;g=e;h=e+8|0;f[g>>2]=d;i=Orb(a,c)|0;if((i|0)==(a+4|0)){j=d;u=e;return j|0}d=h+64|0;a=h+8|0;f[a>>2]=35876;c=h+12|0;f[h>>2]=6740;f[d>>2]=6760;f[h+4>>2]=0;XNc(h+64|0,c);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=35856;f[d>>2]=35896;f[a>>2]=35876;aOc(c);f[c>>2]=35912;a=h+44|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[h+60>>2]=24;AM(c,i+28|0);gOc(h,g)|0;f[h>>2]=35856;f[d>>2]=35896;f[h+8>>2]=35876;f[c>>2]=35912;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);LMc(c);TNc(h,35972);GMc(d);j=f[g>>2]|0;u=e;return j|0}function vrb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+144|0;h=g;i=Orb(c,d)|0;if((i|0)==(c+4|0)){f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];f[a+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;u=g;return}c=h+64|0;d=h+8|0;f[d>>2]=35876;j=h+12|0;f[h>>2]=6740;f[c>>2]=6760;f[h+4>>2]=0;XNc(h+64|0,j);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=35856;f[c>>2]=35896;f[d>>2]=35876;aOc(j);f[j>>2]=35912;d=h+44|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[h+60>>2]=24;AM(j,i+28|0);Qrb(h,e)|0;f[h>>2]=35856;f[c>>2]=35896;f[h+8>>2]=35876;f[j>>2]=35912;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);LMc(j);TNc(h,35972);GMc(c);f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];f[a+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;u=g;return}function wrb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+336|0;k=h+16|0;l=h+324|0;m=h+8|0;o=h;p=h+320|0;q=h+272|0;r=h+224|0;s=h+136|0;t=h+124|0;v=h+40|0;w=h+28|0;Prb(r,a,c,d,e,g);f[s+40>>2]=0;f[s+44>>2]=0;g=s+40|0;e=s+36|0;d=s;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[e>>2]=g;d=s+48|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));g=a+4|0;f[k>>2]=f[g>>2];DM(t,429084,k);e=(i|0)!=0;if(!e){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;i=k+11|0;b[i>>0]=9;d=k;x=445999;c=d+9|0;do{b[d>>0]=b[x>>0]|0;d=d+1|0;x=x+1|0}while((d|0)<(c|0));b[k+9>>0]=0;b[l>>0]=1;cHa(r,k,l)|0;if((b[i>>0]|0)<0)cYc(f[k>>2]|0)}oYc(s,t)|0;i=r+36|0;oYc(s+12|0,i)|0;f[p>>2]=f[r>>2];y=r+4|0;f[q>>2]=y;f[l>>2]=f[p>>2];f[k>>2]=f[q>>2];Krb(s+36|0,l,k);JPa(s+48|0,f[r+12>>2]|0,f[r+16>>2]|0);z=r+24|0;oYc(s+60|0,z)|0;oYc(s+72|0,i)|0;A=a+8|0;B=s+28|0;C=f[B>>2]|0;if((C|0)==(f[s+32>>2]|0))NN(s+24|0,A);else{lYc(C,A);f[B>>2]=(f[B>>2]|0)+12}oYc(A,t)|0;B=f[a>>2]|0;C=B+16|0;D=f[C>>2]|0;if((D|0)==(f[B+20>>2]|0))Lrb(B+12|0,s);else{DNa(D,s);f[C>>2]=(f[C>>2]|0)+84}if(e){f[q+4>>2]=0;f[q+8>>2]=0;e=q+4|0;f[q>>2]=e;C=q+12|0;d=C;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));D=q+24|0;tYc(D,429092)|0;B=q+36|0;tYc(B,429107)|0;E=k+11|0;b[E>>0]=10;d=k;x=444583;c=d+10|0;do{b[d>>0]=b[x>>0]|0;d=d+1|0;x=x+1|0}while((d|0)<(c|0));b[k+10>>0]=0;b[l>>0]=1;cHa(q,k,l)|0;if((b[E>>0]|0)<0)cYc(f[k>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;E=k+11|0;b[E>>0]=8;F=k;f[F>>2]=1601397096;f[F+4>>2]=1935763810;b[k+8>>0]=0;b[l>>0]=1;cHa(q,k,l)|0;if((b[E>>0]|0)<0)cYc(f[k>>2]|0);E=k+4|0;f[E>>2]=0;f[E+4>>2]=0;E=k+11|0;b[E>>0]=3;b[k>>0]=b[513188]|0;b[k+1>>0]=b[513189]|0;b[k+2>>0]=b[513190]|0;b[k+3>>0]=0;n[l>>2]=9.999999974752427e-07;OGa(q,k,l)|0;if((b[E>>0]|0)<0)cYc(f[k>>2]|0);f[v+40>>2]=0;f[v+44>>2]=0;E=v+40|0;F=v+36|0;d=v;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[F>>2]=E;d=v+48|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[o>>2]=f[g>>2];DM(w,429117,o);oYc(v,w)|0;oYc(v+12|0,B)|0;f[o>>2]=f[q>>2];f[p>>2]=e;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];Krb(v+36|0,l,k);JPa(v+48|0,f[C>>2]|0,f[q+16>>2]|0);oYc(v+60|0,D)|0;oYc(v+72|0,B)|0;C=v+28|0;o=f[C>>2]|0;if((o|0)==(f[v+32>>2]|0))NN(v+24|0,A);else{lYc(o,A);f[C>>2]=(f[C>>2]|0)+12}oYc(A,w)|0;C=f[a>>2]|0;o=C+16|0;E=f[o>>2]|0;if((E|0)==(f[C+20>>2]|0))Lrb(C+12|0,v);else{DNa(E,v);f[o>>2]=(f[o>>2]|0)+84}if((b[w+11>>0]|0)<0)cYc(f[w>>2]|0);BNa(v);if((b[B+11>>0]|0)<0)cYc(f[B>>2]|0);if((b[D+11>>0]|0)<0)cYc(f[D>>2]|0);hx(q+12|0);QGa(q,f[e>>2]|0)}if(j|0){f[q+4>>2]=0;f[q+8>>2]=0;j=q+4|0;f[q>>2]=j;e=q+12|0;d=e;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(16)|0;f[k>>2]=D;f[k+8>>2]=-2147483632;f[k+4>>2]=14;d=D;x=429299;c=d+14|0;do{b[d>>0]=b[x>>0]|0;d=d+1|0;x=x+1|0}while((d|0)<(c|0));b[D+14>>0]=0;n[l>>2]=.10000000149011612;OGa(q,k,l)|0;if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);D=q+24|0;tYc(D,429123)|0;x=q+36|0;tYc(x,429133)|0;f[v+40>>2]=0;f[v+44>>2]=0;B=v+40|0;o=v+36|0;d=v;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[o>>2]=B;d=v+48|0;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[m>>2]=f[g>>2];DM(w,429138,m);oYc(v,w)|0;oYc(v+12|0,x)|0;f[m>>2]=f[q>>2];f[p>>2]=j;f[l>>2]=f[m>>2];f[k>>2]=f[p>>2];Krb(v+36|0,l,k);JPa(v+48|0,f[e>>2]|0,f[q+16>>2]|0);oYc(v+60|0,D)|0;oYc(v+72|0,x)|0;e=v+28|0;k=f[e>>2]|0;if((k|0)==(f[v+32>>2]|0))NN(v+24|0,A);else{lYc(k,A);f[e>>2]=(f[e>>2]|0)+12}oYc(A,w)|0;e=f[a>>2]|0;k=e+16|0;l=f[k>>2]|0;if((l|0)==(f[e+20>>2]|0))Lrb(e+12|0,v);else{DNa(l,v);f[k>>2]=(f[k>>2]|0)+84}if((b[w+11>>0]|0)<0)cYc(f[w>>2]|0);BNa(v);if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[D+11>>0]|0)<0)cYc(f[D>>2]|0);hx(q+12|0);QGa(q,f[j>>2]|0)}f[g>>2]=(f[g>>2]|0)+1;g=a+24|0;j=f[g>>2]|0;if((j|0)==(f[a+28>>2]|0))NN(a+20|0,A);else{lYc(j,A);f[g>>2]=(f[g>>2]|0)+12}if((b[t+11>>0]|0)<0)cYc(f[t>>2]|0);BNa(s);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[z+11>>0]|0)>=0){G=r+12|0;hx(G);H=f[y>>2]|0;QGa(r,H);u=h;return}cYc(f[z>>2]|0);G=r+12|0;hx(G);H=f[y>>2]|0;QGa(r,H);u=h;return}function xrb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+192|0;h=g+16|0;i=g;j=g+172|0;k=g+168|0;l=g+120|0;m=g+32|0;n=g+20|0;f[l+4>>2]=0;f[l+8>>2]=0;o=l+4|0;f[l>>2]=o;p=l+12|0;q=p;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;s=i+11|0;b[s>>0]=4;f[i>>2]=1819242352;b[i+4>>0]=0;t=j+4|0;f[t>>2]=0;f[t+4>>2]=0;t=j+11|0;b[t>>0]=3;b[j>>0]=b[443327]|0;b[j+1>>0]=b[443328]|0;b[j+2>>0]=b[443329]|0;b[j+3>>0]=0;_Ga(l,i,j)|0;if((b[t>>0]|0)<0)cYc(f[j>>2]|0);if((b[s>>0]|0)<0)cYc(f[i>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;s=$Xc(16)|0;f[i>>2]=s;f[i+8>>2]=-2147483632;f[i+4>>2]=11;q=s;t=446598;r=q+11|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(r|0));b[s+11>>0]=0;f[j>>2]=c;aHa(l,i,j)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);c=i+4|0;f[c>>2]=0;f[c+4>>2]=0;c=i+11|0;b[c>>0]=3;b[i>>0]=b[446809]|0;b[i+1>>0]=b[446810]|0;b[i+2>>0]=b[446811]|0;b[i+3>>0]=0;f[j>>2]=d;aHa(l,i,j)|0;if((b[c>>0]|0)<0)cYc(f[i>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;c=i+11|0;b[c>>0]=6;b[i>>0]=b[446813]|0;b[i+1>>0]=b[446814]|0;b[i+2>>0]=b[446815]|0;b[i+3>>0]=b[446816]|0;b[i+4>>0]=b[446817]|0;b[i+5>>0]=b[446818]|0;b[i+6>>0]=0;f[j>>2]=e;aHa(l,i,j)|0;if((b[c>>0]|0)<0)cYc(f[i>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;c=i+11|0;b[c>>0]=8;e=i;f[e>>2]=1600414064;f[e+4>>2]=1701080941;b[i+8>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;e=j+11|0;b[e>>0]=4;f[j>>2]=1162690899;b[j+4>>0]=0;_Ga(l,i,j)|0;if((b[e>>0]|0)<0)cYc(f[j>>2]|0);if((b[c>>0]|0)<0)cYc(f[i>>2]|0);c=l+24|0;tYc(c,429044)|0;e=l+36|0;tYc(e,429057)|0;f[m+40>>2]=0;f[m+44>>2]=0;d=m+40|0;s=m+36|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[s>>2]=d;q=m+48|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));q=a+4|0;f[h>>2]=f[q>>2];DM(n,429076,h);oYc(m,n)|0;oYc(m+12|0,e)|0;f[j>>2]=f[l>>2];f[k>>2]=o;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];Krb(m+36|0,i,h);JPa(m+48|0,f[p>>2]|0,f[l+16>>2]|0);oYc(m+60|0,c)|0;oYc(m+72|0,e)|0;p=a+8|0;h=m+28|0;i=f[h>>2]|0;if((i|0)==(f[m+32>>2]|0))NN(m+24|0,p);else{lYc(i,p);f[h>>2]=(f[h>>2]|0)+12}oYc(p,n)|0;h=f[a>>2]|0;i=h+16|0;k=f[i>>2]|0;if((k|0)==(f[h+20>>2]|0))Lrb(h+12|0,m);else{DNa(k,m);f[i>>2]=(f[i>>2]|0)+84}f[q>>2]=(f[q>>2]|0)+1;q=a+24|0;i=f[q>>2]|0;if((i|0)==(f[a+28>>2]|0))NN(a+20|0,p);else{lYc(i,p);f[q>>2]=(f[q>>2]|0)+12}if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);BNa(m);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[c+11>>0]|0)>=0){v=l+12|0;hx(v);w=f[o>>2]|0;QGa(l,w);u=g;return}cYc(f[c>>2]|0);v=l+12|0;hx(v);w=f[o>>2]|0;QGa(l,w);u=g;return}function yrb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+192|0;d=c;e=c+168|0;g=c+156|0;h=c+152|0;i=c+104|0;j=c+16|0;k=c+4|0;f[i+4>>2]=0;f[i+8>>2]=0;l=i+4|0;f[i>>2]=l;m=i+12|0;n=m;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=4;f[e>>2]=1819242352;b[e+4>>0]=0;q=g+4|0;f[q>>2]=0;f[q+4>>2]=0;q=g+11|0;b[q>>0]=3;b[g>>0]=b[443331]|0;b[g+1>>0]=b[443332]|0;b[g+2>>0]=b[443333]|0;b[g+3>>0]=0;_Ga(i,e,g)|0;if((b[q>>0]|0)<0)cYc(f[g>>2]|0);if((b[p>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=$Xc(16)|0;f[e>>2]=p;f[e+8>>2]=-2147483632;f[e+4>>2]=14;n=p;q=446919;o=n+14|0;do{b[n>>0]=b[q>>0]|0;n=n+1|0;q=q+1|0}while((n|0)<(o|0));b[p+14>>0]=0;b[g>>0]=1;cHa(i,e,g)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);p=i+24|0;tYc(p,429044)|0;q=i+36|0;tYc(q,429057)|0;f[j+40>>2]=0;f[j+44>>2]=0;r=j+40|0;s=j+36|0;n=j;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[s>>2]=r;n=j+48|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));n=a+4|0;f[d>>2]=f[n>>2];DM(k,429065,d);oYc(j,k)|0;oYc(j+12|0,q)|0;f[g>>2]=f[i>>2];f[h>>2]=l;f[e>>2]=f[g>>2];f[d>>2]=f[h>>2];Krb(j+36|0,e,d);JPa(j+48|0,f[m>>2]|0,f[i+16>>2]|0);oYc(j+60|0,p)|0;oYc(j+72|0,q)|0;m=a+8|0;d=j+28|0;e=f[d>>2]|0;if((e|0)==(f[j+32>>2]|0))NN(j+24|0,m);else{lYc(e,m);f[d>>2]=(f[d>>2]|0)+12}oYc(m,k)|0;d=f[a>>2]|0;e=d+16|0;h=f[e>>2]|0;if((h|0)==(f[d+20>>2]|0))Lrb(d+12|0,j);else{DNa(h,j);f[e>>2]=(f[e>>2]|0)+84}f[n>>2]=(f[n>>2]|0)+1;n=a+24|0;e=f[n>>2]|0;if((e|0)==(f[a+28>>2]|0))NN(a+20|0,m);else{lYc(e,m);f[n>>2]=(f[n>>2]|0)+12}if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);BNa(j);if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[p+11>>0]|0)>=0){t=i+12|0;hx(t);v=f[l>>2]|0;QGa(i,v);u=c;return}cYc(f[p>>2]|0);t=i+12|0;hx(t);v=f[l>>2]|0;QGa(i,v);u=c;return}function zrb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+176|0;d=c;e=c+160|0;g=c+156|0;h=c+152|0;i=c+104|0;j=c+16|0;k=c+4|0;f[i+4>>2]=0;f[i+8>>2]=0;l=i+4|0;f[i>>2]=l;m=i+12|0;n=m;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));p=i+24|0;tYc(p,429012)|0;q=i+36|0;tYc(q,429025)|0;f[j+40>>2]=0;f[j+44>>2]=0;r=j+40|0;s=j+36|0;n=j;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[s>>2]=r;n=j+48|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));n=a+4|0;f[d>>2]=f[n>>2];DM(k,429033,d);oYc(j,k)|0;oYc(j+12|0,q)|0;f[g>>2]=f[i>>2];f[h>>2]=l;f[e>>2]=f[g>>2];f[d>>2]=f[h>>2];Krb(j+36|0,e,d);JPa(j+48|0,f[m>>2]|0,f[i+16>>2]|0);oYc(j+60|0,p)|0;oYc(j+72|0,q)|0;m=a+8|0;d=j+28|0;e=f[d>>2]|0;if((e|0)==(f[j+32>>2]|0))NN(j+24|0,m);else{lYc(e,m);f[d>>2]=(f[d>>2]|0)+12}oYc(m,k)|0;d=f[a>>2]|0;e=d+16|0;h=f[e>>2]|0;if((h|0)==(f[d+20>>2]|0))Lrb(d+12|0,j);else{DNa(h,j);f[e>>2]=(f[e>>2]|0)+84}f[n>>2]=(f[n>>2]|0)+1;n=a+24|0;e=f[n>>2]|0;if((e|0)==(f[a+28>>2]|0))NN(a+20|0,m);else{lYc(e,m);f[n>>2]=(f[n>>2]|0)+12}if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);BNa(j);if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[p+11>>0]|0)>=0){t=i+12|0;hx(t);v=f[l>>2]|0;QGa(i,v);u=c;return}cYc(f[p>>2]|0);t=i+12|0;hx(t);v=f[l>>2]|0;QGa(i,v);u=c;return}function Arb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+320|0;e=d+168|0;g=d+152|0;h=d+8|0;i=d;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;k=e+64|0;l=e+8|0;f[l>>2]=35876;m=e+12|0;f[e>>2]=6740;f[k>>2]=6760;f[e+4>>2]=0;XNc(e+64|0,m);f[e+136>>2]=0;f[e+140>>2]=-1;f[e>>2]=35856;f[k>>2]=35896;f[l>>2]=35876;aOc(m);f[m>>2]=35912;l=e+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[e+60>>2]=24;AM(m,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=h+64|0;n=h+8|0;o=h+12|0;p=h+4|0;q=h+64|0;r=h+136|0;s=h+140|0;t=h+44|0;v=h+60|0;w=a+8|0;x=h+8|0;y=t+11|0;while(1){z=srb(e,g,44)|0;if(f[z+(f[(f[z>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;f[n>>2]=35876;f[h>>2]=6740;f[c>>2]=6760;f[p>>2]=0;XNc(q,o);f[r>>2]=0;f[s>>2]=-1;f[h>>2]=35856;f[c>>2]=35896;f[n>>2]=35876;aOc(o);f[o>>2]=35912;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[v>>2]=24;AM(o,g);gOc(h,i)|0;z=f[j>>2]|0;if((z|0)==(f[w>>2]|0))Tv(a,i);else{f[z>>2]=f[i>>2];f[j>>2]=z+4}f[h>>2]=35856;f[c>>2]=35896;f[x>>2]=35876;f[o>>2]=35912;if((b[y>>0]|0)<0)cYc(f[t>>2]|0);LMc(o);TNc(h,35972);GMc(c)}if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[e>>2]=35856;f[k>>2]=35896;f[e+8>>2]=35876;f[m>>2]=35912;if((b[l+11>>0]|0)>=0){LMc(m);TNc(e,35972);GMc(k);u=d;return}cYc(f[l>>2]|0);LMc(m);TNc(e,35972);GMc(k);u=d;return}function Brb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+176|0;e=d;g=d+160|0;h=d+156|0;i=d+152|0;j=d+104|0;k=d+16|0;l=d+4|0;f[j+4>>2]=0;f[j+8>>2]=0;m=j+4|0;f[j>>2]=m;n=j+12|0;o=n;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));q=j+24|0;tYc(q,428977)|0;r=j+36|0;tYc(r,428991)|0;f[k+40>>2]=0;f[k+44>>2]=0;s=k+40|0;t=k+36|0;o=k;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[t>>2]=s;o=k+48|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));o=a+4|0;f[e>>2]=f[o>>2];DM(l,429e3,e);oYc(k,l)|0;oYc(k+12|0,r)|0;f[h>>2]=f[j>>2];f[i>>2]=m;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Krb(k+36|0,g,e);JPa(k+48|0,f[n>>2]|0,f[j+16>>2]|0);oYc(k+60|0,q)|0;oYc(k+72|0,r)|0;n=a+20|0;e=a+24|0;g=f[n>>2]|0;if((((f[e>>2]|0)-g|0)/12|0)>>>0<=c>>>0)lWc(n);i=g+(c*12|0)|0;c=k+28|0;g=f[c>>2]|0;if((g|0)==(f[k+32>>2]|0))NN(k+24|0,i);else{lYc(g,i);f[c>>2]=(f[c>>2]|0)+12}c=a+8|0;oYc(c,l)|0;i=f[a>>2]|0;g=i+16|0;h=f[g>>2]|0;if((h|0)==(f[i+20>>2]|0))Lrb(i+12|0,k);else{DNa(h,k);f[g>>2]=(f[g>>2]|0)+84}f[o>>2]=(f[o>>2]|0)+1;o=f[e>>2]|0;if((o|0)==(f[a+28>>2]|0))NN(n,c);else{lYc(o,c);f[e>>2]=(f[e>>2]|0)+12}if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);BNa(k);if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);if((b[q+11>>0]|0)>=0){v=j+12|0;hx(v);w=f[m>>2]|0;QGa(j,w);u=d;return}cYc(f[q>>2]|0);v=j+12|0;hx(v);w=f[m>>2]|0;QGa(j,w);u=d;return}function Crb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+176|0;g=e;h=e+160|0;i=e+156|0;j=e+152|0;k=e+104|0;l=e+16|0;m=e+4|0;f[k+4>>2]=0;f[k+8>>2]=0;n=k+4|0;f[k>>2]=n;o=k+12|0;p=o;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));r=k+24|0;tYc(r,428948)|0;s=k+36|0;tYc(s,428960)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=h+11|0;b[t>>0]=4;f[h>>2]=1936291937;b[h+4>>0]=0;f[i>>2]=1;aHa(k,h,i)|0;if((b[t>>0]|0)<0)cYc(f[h>>2]|0);f[l+40>>2]=0;f[l+44>>2]=0;t=l+40|0;v=l+36|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[v>>2]=t;p=l+48|0;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));p=a+4|0;f[g>>2]=f[p>>2];DM(m,428967,g);oYc(l,m)|0;oYc(l+12|0,s)|0;f[i>>2]=f[k>>2];f[j>>2]=n;f[h>>2]=f[i>>2];f[g>>2]=f[j>>2];Krb(l+36|0,h,g);JPa(l+48|0,f[o>>2]|0,f[k+16>>2]|0);oYc(l+60|0,r)|0;oYc(l+72|0,s)|0;a:do if((c|0)>0){o=a+20|0;g=a+24|0;h=l+28|0;j=l+32|0;i=l+24|0;q=0;while(1){t=f[d+(q<<2)>>2]|0;v=f[o>>2]|0;if((((f[g>>2]|0)-v|0)/12|0)>>>0<=t>>>0)break;w=v+(t*12|0)|0;t=f[h>>2]|0;if((t|0)==(f[j>>2]|0))NN(i,w);else{lYc(t,w);f[h>>2]=(f[h>>2]|0)+12}q=q+1|0;if((q|0)>=(c|0))break a}lWc(o)}while(0);c=a+8|0;oYc(c,m)|0;d=f[a>>2]|0;q=d+16|0;h=f[q>>2]|0;if((h|0)==(f[d+20>>2]|0))Lrb(d+12|0,l);else{DNa(h,l);f[q>>2]=(f[q>>2]|0)+84}f[p>>2]=(f[p>>2]|0)+1;p=a+24|0;q=f[p>>2]|0;if((q|0)==(f[a+28>>2]|0))NN(a+20|0,c);else{lYc(q,c);f[p>>2]=(f[p>>2]|0)+12}if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);BNa(l);if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);if((b[r+11>>0]|0)>=0){x=k+12|0;hx(x);y=f[n>>2]|0;QGa(k,y);u=e;return}cYc(f[r>>2]|0);x=k+12|0;hx(x);y=f[n>>2]|0;QGa(k,y);u=e;return}function Drb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+176|0;e=d;g=d+164|0;h=d+160|0;i=d+152|0;j=d+156|0;k=d+104|0;l=d+16|0;m=d+4|0;f[j>>2]=c;f[k+4>>2]=0;f[k+8>>2]=0;c=k+4|0;f[k>>2]=c;n=k+12|0;o=n;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));q=k+24|0;tYc(q,428922)|0;r=k+36|0;tYc(r,428933)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;s=$Xc(16)|0;f[g>>2]=s;f[g+8>>2]=-2147483632;f[g+4>>2]=12;o=s;t=440394;p=o+12|0;do{b[o>>0]=b[t>>0]|0;o=o+1|0;t=t+1|0}while((o|0)<(p|0));b[s+12>>0]=0;aHa(k,g,j)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[l+40>>2]=0;f[l+44>>2]=0;j=l+40|0;s=l+36|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[s>>2]=j;o=l+48|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));o=a+4|0;f[e>>2]=f[o>>2];DM(m,428939,e);oYc(l,m)|0;oYc(l+12|0,r)|0;f[h>>2]=f[k>>2];f[i>>2]=c;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Krb(l+36|0,g,e);JPa(l+48|0,f[n>>2]|0,f[k+16>>2]|0);oYc(l+60|0,q)|0;oYc(l+72|0,r)|0;n=a+8|0;e=l+28|0;g=f[e>>2]|0;if((g|0)==(f[l+32>>2]|0))NN(l+24|0,n);else{lYc(g,n);f[e>>2]=(f[e>>2]|0)+12}oYc(n,m)|0;e=f[a>>2]|0;g=e+16|0;i=f[g>>2]|0;if((i|0)==(f[e+20>>2]|0))Lrb(e+12|0,l);else{DNa(i,l);f[g>>2]=(f[g>>2]|0)+84}f[o>>2]=(f[o>>2]|0)+1;o=a+24|0;g=f[o>>2]|0;if((g|0)==(f[a+28>>2]|0))NN(a+20|0,n);else{lYc(g,n);f[o>>2]=(f[o>>2]|0)+12}if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);BNa(l);if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);if((b[q+11>>0]|0)>=0){v=k+12|0;hx(v);w=f[c>>2]|0;QGa(k,w);u=d;return}cYc(f[q>>2]|0);v=k+12|0;hx(v);w=f[c>>2]|0;QGa(k,w);u=d;return}function Erb(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0.0,k=0;e=u;u=u+160|0;g=e;h=e+8|0;n[g>>2]=d;i=Orb(a,c)|0;if((i|0)==(a+4|0)){j=d;u=e;return +j}a=h+64|0;c=h+8|0;f[c>>2]=35876;k=h+12|0;f[h>>2]=6740;f[a>>2]=6760;f[h+4>>2]=0;XNc(h+64|0,k);f[h+136>>2]=0;f[h+140>>2]=-1;f[h>>2]=35856;f[a>>2]=35896;f[c>>2]=35876;aOc(k);f[k>>2]=35912;c=h+44|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[h+60>>2]=24;AM(k,i+28|0);hOc(h,g)|0;f[h>>2]=35856;f[a>>2]=35896;f[h+8>>2]=35876;f[k>>2]=35912;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);LMc(k);TNc(h,35972);GMc(a);j=+n[g>>2];u=e;return +j}function Frb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+192|0;e=d;g=d+168|0;h=d+164|0;i=d+160|0;j=d+112|0;k=d+104|0;l=d+16|0;m=d+4|0;f[j+4>>2]=0;f[j+8>>2]=0;n=j+4|0;f[j>>2]=n;o=j+12|0;p=o;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));r=j+24|0;tYc(r,428890)|0;s=j+36|0;tYc(s,428903)|0;t=$Xc(16)|0;f[t>>2]=t+8;f[t+4>>2]=4;v=bYc(32)|0;f[t>>2]=v;f[k>>2]=0;f[k+4>>2]=t;t=v;f[t>>2]=0;f[t+4>>2]=0;t=v+8|0;f[t>>2]=2;f[t+4>>2]=0;t=v+16|0;f[t>>2]=3;f[t+4>>2]=0;t=v+24|0;f[t>>2]=1;f[t+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;t=g+11|0;b[t>>0]=5;b[g>>0]=b[450562]|0;b[g+1>>0]=b[450563]|0;b[g+2>>0]=b[450564]|0;b[g+3>>0]=b[450565]|0;b[g+4>>0]=b[450566]|0;b[g+5>>0]=0;$Ga(j,g,k)|0;if((b[t>>0]|0)<0)cYc(f[g>>2]|0);f[l+40>>2]=0;f[l+44>>2]=0;t=l+40|0;v=l+36|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[v>>2]=t;p=l+48|0;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));p=a+4|0;f[e>>2]=f[p>>2];DM(m,428911,e);oYc(l,m)|0;oYc(l+12|0,s)|0;f[h>>2]=f[j>>2];f[i>>2]=n;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Krb(l+36|0,g,e);JPa(l+48|0,f[o>>2]|0,f[j+16>>2]|0);oYc(l+60|0,r)|0;oYc(l+72|0,s)|0;o=a+8|0;e=l+28|0;g=f[e>>2]|0;if((g|0)==(f[l+32>>2]|0))NN(l+24|0,o);else{lYc(g,o);f[e>>2]=(f[e>>2]|0)+12}oYc(o,m)|0;e=f[a>>2]|0;g=e+16|0;i=f[g>>2]|0;if((i|0)==(f[e+20>>2]|0))Lrb(e+12|0,l);else{DNa(i,l);f[g>>2]=(f[g>>2]|0)+84}do if(c){f[p>>2]=(f[p>>2]|0)+1;g=a+24|0;i=f[g>>2]|0;if((i|0)==(f[a+28>>2]|0)){NN(a+20|0,o);break}else{lYc(i,o);f[g>>2]=(f[g>>2]|0)+12;break}}while(0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);BNa(l);RGa(k);if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);if((b[r+11>>0]|0)>=0){w=j+12|0;hx(w);x=f[n>>2]|0;QGa(j,x);u=d;return}cYc(f[r>>2]|0);w=j+12|0;hx(w);x=f[n>>2]|0;QGa(j,x);u=d;return}function Grb(a,c,d,e,g,h,i,j,k){a=a|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=u;u=u+304|0;m=l;o=l+248|0;p=l+244|0;q=l+240|0;r=l+236|0;s=l+232|0;t=l+176|0;v=l+172|0;w=l+168|0;x=l+184|0;y=l+112|0;z=l+28|0;A=l+16|0;n[r>>2]=c;f[s>>2]=d;f[t>>2]=e;f[v>>2]=g;f[w>>2]=h;f[x+4>>2]=0;f[x+8>>2]=0;h=x+4|0;f[x>>2]=h;g=x+12|0;e=g;d=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(d|0));B=x+24|0;tYc(B,428782)|0;C=x+36|0;tYc(C,428794)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;D=m+11|0;b[D>>0]=6;b[m>>0]=b[438896]|0;b[m+1>>0]=b[438897]|0;b[m+2>>0]=b[438898]|0;b[m+3>>0]=b[438899]|0;b[m+4>>0]=b[438900]|0;b[m+5>>0]=b[438901]|0;b[m+6>>0]=0;OGa(x,m,r)|0;if((b[D>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;D=m+11|0;b[D>>0]=6;b[m>>0]=b[438903]|0;b[m+1>>0]=b[438904]|0;b[m+2>>0]=b[438905]|0;b[m+3>>0]=b[438906]|0;b[m+4>>0]=b[438907]|0;b[m+5>>0]=b[438908]|0;b[m+6>>0]=0;aHa(x,m,s)|0;if((b[D>>0]|0)<0)cYc(f[m>>2]|0);f[m+8>>2]=0;D=m+11|0;b[D>>0]=7;b[m>>0]=b[438910]|0;b[m+1>>0]=b[438911]|0;b[m+2>>0]=b[438912]|0;b[m+3>>0]=b[438913]|0;b[m+4>>0]=b[438914]|0;b[m+5>>0]=b[438915]|0;b[m+6>>0]=b[438916]|0;b[m+7>>0]=0;aHa(x,m,t)|0;if((b[D>>0]|0)<0)cYc(f[m>>2]|0);f[m+8>>2]=0;D=m+11|0;b[D>>0]=7;b[m>>0]=b[438918]|0;b[m+1>>0]=b[438919]|0;b[m+2>>0]=b[438920]|0;b[m+3>>0]=b[438921]|0;b[m+4>>0]=b[438922]|0;b[m+5>>0]=b[438923]|0;b[m+6>>0]=b[438924]|0;b[m+7>>0]=0;aHa(x,m,v)|0;if((b[D>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;D=m+11|0;b[D>>0]=8;t=m;f[t>>2]=1935764579;f[t+4>>2]=2020173427;b[m+8>>0]=0;aHa(x,m,w)|0;if((b[D>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;D=$Xc(16)|0;f[m>>2]=D;f[m+8>>2]=-2147483632;f[m+4>>2]=12;e=D;w=439017;d=e+12|0;do{b[e>>0]=b[w>>0]|0;e=e+1|0;w=w+1|0}while((e|0)<(d|0));b[D+12>>0]=0;b[o>>0]=(j|0)!=0&1;cHa(x,m,o)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);f[m+8>>2]=0;j=m+11|0;b[j>>0]=7;b[m>>0]=b[438926]|0;b[m+1>>0]=b[438927]|0;b[m+2>>0]=b[438928]|0;b[m+3>>0]=b[438929]|0;b[m+4>>0]=b[438930]|0;b[m+5>>0]=b[438931]|0;b[m+6>>0]=b[438932]|0;b[m+7>>0]=0;b[o>>0]=(i|0)!=0&1;cHa(x,m,o)|0;if((b[j>>0]|0)<0)cYc(f[m>>2]|0);j=f[v>>2]|0;f[o>>2]=1124007941;v=o+4|0;f[v>>2]=2;i=o+8|0;f[i>>2]=1;f[o+12>>2]=j<<1;D=o+16|0;f[D>>2]=k;f[o+20>>2]=k;t=o+24|0;s=o+40|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[s>>2]=i;i=o+48|0;r=o+44|0;f[r>>2]=i;E=o+52|0;f[E>>2]=0;f[i>>2]=0;if((k|0)==0&(j|0)!=0){F=$Xc(32)|0;f[m>>2]=F;f[m+8>>2]=-2147483616;f[m+4>>2]=28;e=F;w=470314;d=e+28|0;do{b[e>>0]=b[w>>0]|0;e=e+1|0;w=w+1|0}while((e|0)<(d|0));b[F+28>>0]=0;vM(-215,m,470343,470347,548)}F=j<<3;f[i>>2]=F;f[E>>2]=4;E=k+F|0;f[o+28>>2]=E;f[t>>2]=E+(0-F)+F;R$(o);f[y>>2]=1124007936;F=y+4|0;E=y+8|0;t=y+40|0;e=F;d=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(d|0));f[t>>2]=E;k=y+48|0;j=y+44|0;f[j>>2]=k;f[k>>2]=0;f[y+52>>2]=0;G=m+8|0;f[G>>2]=0;f[G+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=y;jR(o,m);G=o+36|0;H=f[G>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)V$(o);f[G>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[v>>2]|0)>0){D=f[s>>2]|0;s=0;do{f[D+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[v>>2]|0))}v=f[r>>2]|0;if((v|0)!=(i|0))wL(v);v=x+16|0;i=f[v>>2]|0;if((i|0)==(f[x+20>>2]|0))bx(x+12|0,y);else{f[i>>2]=f[y>>2];r=i+4|0;f[r>>2]=f[F>>2];s=i+8|0;f[s>>2]=f[E>>2];f[i+12>>2]=f[y+12>>2];f[i+16>>2]=f[y+16>>2];f[i+20>>2]=f[y+20>>2];f[i+24>>2]=f[y+24>>2];f[i+28>>2]=f[y+28>>2];f[i+32>>2]=f[y+32>>2];E=f[y+36>>2]|0;f[i+36>>2]=E;f[i+40>>2]=s;s=i+48|0;D=i+44|0;f[D>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(E|0){s=E+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[F>>2]|0)<3){s=f[j>>2]|0;E=f[D>>2]|0;f[E>>2]=f[s>>2];f[E+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(i,y)}f[v>>2]=(f[v>>2]|0)+56}f[z+40>>2]=0;f[z+44>>2]=0;i=z+40|0;r=z+36|0;e=z;d=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(d|0));f[r>>2]=i;e=z+48|0;d=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(d|0));f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;i=$Xc(16)|0;f[A>>2]=i;f[A+8>>2]=-2147483632;f[A+4>>2]=13;e=i;w=428876;d=e+13|0;do{b[e>>0]=b[w>>0]|0;e=e+1|0;w=w+1|0}while((e|0)<(d|0));b[i+13>>0]=0;oYc(z,A)|0;oYc(z+12|0,C)|0;f[p>>2]=f[x>>2];f[q>>2]=h;f[o>>2]=f[p>>2];f[m>>2]=f[q>>2];Krb(z+36|0,o,m);JPa(z+48|0,f[g>>2]|0,f[v>>2]|0);oYc(z+60|0,B)|0;oYc(z+72|0,C)|0;v=a+8|0;g=z+28|0;m=f[g>>2]|0;if((m|0)==(f[z+32>>2]|0))NN(z+24|0,v);else{lYc(m,v);f[g>>2]=(f[g>>2]|0)+12}oYc(v,A)|0;g=f[a>>2]|0;m=g+16|0;o=f[m>>2]|0;if((o|0)==(f[g+20>>2]|0))Lrb(g+12|0,z);else{DNa(o,z);f[m>>2]=(f[m>>2]|0)+84}m=a+4|0;f[m>>2]=(f[m>>2]|0)+1;m=a+24|0;o=f[m>>2]|0;if((o|0)==(f[a+28>>2]|0))NN(a+20|0,v);else{lYc(o,v);f[m>>2]=(f[m>>2]|0)+12}if((b[A+11>>0]|0)<0)cYc(f[A>>2]|0);BNa(z);z=y+36|0;A=f[z>>2]|0;if(A|0?(m=A+12|0,A=f[m>>2]|0,f[m>>2]=A+-1,(A|0)==1):0)V$(y);f[z>>2]=0;z=y+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[F>>2]|0)>0){z=f[t>>2]|0;t=0;do{f[z+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[F>>2]|0))}F=f[j>>2]|0;if((F|0)!=(k|0))wL(F);if((b[C+11>>0]|0)<0)cYc(f[C>>2]|0);if((b[B+11>>0]|0)>=0){J=x+12|0;hx(J);K=f[h>>2]|0;QGa(x,K);u=l;return}cYc(f[B>>2]|0);J=x+12|0;hx(J);K=f[h>>2]|0;QGa(x,K);u=l;return}function Hrb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+192|0;g=e;h=e+168|0;i=e+156|0;j=e+152|0;k=e+104|0;l=e+16|0;m=e+4|0;f[k+4>>2]=0;f[k+8>>2]=0;n=k+4|0;f[k>>2]=n;o=k+12|0;p=o;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));r=k+24|0;tYc(r,428842)|0;s=k+36|0;tYc(s,428856)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=h+11|0;b[t>>0]=2;d[h>>1]=28783;b[h+2>>0]=0;v=i+4|0;f[v>>2]=0;f[v+4>>2]=0;v=i+11|0;b[v>>0]=3;b[i>>0]=b[437393]|0;b[i+1>>0]=b[437394]|0;b[i+2>>0]=b[437395]|0;b[i+3>>0]=0;_Ga(k,h,i)|0;if((b[v>>0]|0)<0)cYc(f[i>>2]|0);if((b[t>>0]|0)<0)cYc(f[h>>2]|0);f[l+40>>2]=0;f[l+44>>2]=0;t=l+40|0;v=l+36|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[v>>2]=t;p=l+48|0;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));p=a+4|0;f[g>>2]=f[p>>2];DM(m,428864,g);oYc(l,m)|0;oYc(l+12|0,s)|0;f[i>>2]=f[k>>2];f[j>>2]=n;f[h>>2]=f[i>>2];f[g>>2]=f[j>>2];Krb(l+36|0,h,g);JPa(l+48|0,f[o>>2]|0,f[k+16>>2]|0);oYc(l+60|0,r)|0;oYc(l+72|0,s)|0;o=l+24|0;g=a+20|0;h=a+24|0;j=f[g>>2]|0;if((((f[h>>2]|0)-j|0)/12|0)>>>0<=c>>>0)lWc(g);i=j+(c*12|0)|0;c=l+28|0;j=f[c>>2]|0;q=l+32|0;if((j|0)==(f[q>>2]|0)){NN(o,i);w=f[c>>2]|0}else{lYc(j,i);i=(f[c>>2]|0)+12|0;f[c>>2]=i;w=i}i=a+8|0;if((w|0)==(f[q>>2]|0))NN(o,i);else{lYc(w,i);f[c>>2]=(f[c>>2]|0)+12}oYc(i,m)|0;c=f[a>>2]|0;w=c+16|0;o=f[w>>2]|0;if((o|0)==(f[c+20>>2]|0))Lrb(c+12|0,l);else{DNa(o,l);f[w>>2]=(f[w>>2]|0)+84}f[p>>2]=(f[p>>2]|0)+1;p=f[h>>2]|0;if((p|0)==(f[a+28>>2]|0))NN(g,i);else{lYc(p,i);f[h>>2]=(f[h>>2]|0)+12}if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);BNa(l);if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);if((b[r+11>>0]|0)>=0){x=k+12|0;hx(x);y=f[n>>2]|0;QGa(k,y);u=e;return}cYc(f[r>>2]|0);x=k+12|0;hx(x);y=f[n>>2]|0;QGa(k,y);u=e;return}function Irb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+192|0;e=d;g=d+172|0;h=d+160|0;i=d+152|0;j=d+156|0;k=d+104|0;l=d+16|0;m=d+4|0;f[j>>2]=c;f[k+4>>2]=0;f[k+8>>2]=0;c=k+4|0;f[k>>2]=c;n=k+12|0;o=n;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));q=k+24|0;tYc(q,428809)|0;r=k+36|0;tYc(r,428823)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;s=$Xc(16)|0;f[g>>2]=s;f[g+8>>2]=-2147483632;f[g+4>>2]=11;o=s;t=435694;p=o+11|0;do{b[o>>0]=b[t>>0]|0;o=o+1|0;t=t+1|0}while((o|0)<(p|0));b[s+11>>0]=0;aHa(k,g,j)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(16)|0;f[g>>2]=j;f[g+8>>2]=-2147483632;f[g+4>>2]=13;o=j;t=435950;p=o+13|0;do{b[o>>0]=b[t>>0]|0;o=o+1|0;t=t+1|0}while((o|0)<(p|0));b[j+13>>0]=0;f[h+8>>2]=0;j=h+11|0;b[j>>0]=7;b[h>>0]=b[435964]|0;b[h+1>>0]=b[435965]|0;b[h+2>>0]=b[435966]|0;b[h+3>>0]=b[435967]|0;b[h+4>>0]=b[435968]|0;b[h+5>>0]=b[435969]|0;b[h+6>>0]=b[435970]|0;b[h+7>>0]=0;_Ga(k,g,h)|0;if((b[j>>0]|0)<0)cYc(f[h>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[l+40>>2]=0;f[l+44>>2]=0;j=l+40|0;t=l+36|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[t>>2]=j;o=l+48|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));o=a+4|0;f[e>>2]=f[o>>2];DM(m,428830,e);oYc(l,m)|0;oYc(l+12|0,r)|0;f[h>>2]=f[k>>2];f[i>>2]=c;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Krb(l+36|0,g,e);JPa(l+48|0,f[n>>2]|0,f[k+16>>2]|0);oYc(l+60|0,q)|0;oYc(l+72|0,r)|0;n=a+8|0;e=l+28|0;g=f[e>>2]|0;if((g|0)==(f[l+32>>2]|0))NN(l+24|0,n);else{lYc(g,n);f[e>>2]=(f[e>>2]|0)+12}oYc(n,m)|0;e=f[a>>2]|0;g=e+16|0;i=f[g>>2]|0;if((i|0)==(f[e+20>>2]|0))Lrb(e+12|0,l);else{DNa(i,l);f[g>>2]=(f[g>>2]|0)+84}f[o>>2]=(f[o>>2]|0)+1;o=a+24|0;g=f[o>>2]|0;if((g|0)==(f[a+28>>2]|0))NN(a+20|0,n);else{lYc(g,n);f[o>>2]=(f[o>>2]|0)+12}if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);BNa(l);if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);if((b[q+11>>0]|0)>=0){v=k+12|0;hx(v);w=f[c>>2]|0;QGa(k,w);u=d;return}cYc(f[q>>2]|0);v=k+12|0;hx(v);w=f[c>>2]|0;QGa(k,w);u=d;return}function Jrb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+304|0;h=g+16|0;i=g;j=g+248|0;k=g+240|0;l=g+244|0;m=g+192|0;n=g+188|0;o=g+176|0;p=g+120|0;q=g+32|0;r=g+20|0;f[l>>2]=c;f[m+4>>2]=0;f[m+8>>2]=0;c=m+4|0;f[m>>2]=c;s=m+12|0;t=s;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));w=m+24|0;tYc(w,428782)|0;x=m+36|0;tYc(x,428794)|0;f[n>>2]=(f[d+4>>2]|0)-(f[d>>2]|0)>>2;f[i+8>>2]=0;y=i+11|0;b[y>>0]=7;b[i>>0]=b[438910]|0;b[i+1>>0]=b[438911]|0;b[i+2>>0]=b[438912]|0;b[i+3>>0]=b[438913]|0;b[i+4>>0]=b[438914]|0;b[i+5>>0]=b[438915]|0;b[i+6>>0]=b[438916]|0;b[i+7>>0]=0;aHa(m,i,l)|0;if((b[y>>0]|0)<0)cYc(f[i>>2]|0);f[i+8>>2]=0;y=i+11|0;b[y>>0]=7;b[i>>0]=b[438918]|0;b[i+1>>0]=b[438919]|0;b[i+2>>0]=b[438920]|0;b[i+3>>0]=b[438921]|0;b[i+4>>0]=b[438922]|0;b[i+5>>0]=b[438923]|0;b[i+6>>0]=b[438924]|0;b[i+7>>0]=0;aHa(m,i,n)|0;if((b[y>>0]|0)<0)cYc(f[i>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;y=i+11|0;b[y>>0]=8;l=i;f[l>>2]=1768386412;f[l+4>>2]=1667855475;b[i+8>>0]=0;b[j>>0]=1;cHa(m,i,j)|0;if((b[y>>0]|0)<0)cYc(f[i>>2]|0);y=f[n>>2]|0;n=y<<1;f[o>>2]=0;l=o+4|0;f[l>>2]=0;f[o+8>>2]=0;if(y){if(n>>>0>1073741823)kWc(o);z=y<<3;A=$Xc(z)|0;f[o>>2]=A;B=A+(n<<2)|0;f[o+8>>2]=B;g1c(A|0,0,z|0)|0;f[l>>2]=B;if((y|0)>0){B=f[d>>2]|0;d=f[e>>2]|0;e=0;do{z=f[B+(e<<2)>>2]<<1;C=e<<1;f[A+(C<<2)>>2]=f[d+(z<<2)>>2];f[A+((C|1)<<2)>>2]=f[d+((z|1)<<2)>>2];e=e+1|0}while((e|0)<(y|0));D=A}else D=A}else D=0;f[j>>2]=1124007941;A=j+4|0;f[A>>2]=2;e=j+8|0;f[e>>2]=1;f[j+12>>2]=n;n=j+16|0;f[n>>2]=D;f[j+20>>2]=D;d=j+24|0;B=j+40|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[B>>2]=e;e=j+48|0;z=j+44|0;f[z>>2]=e;C=j+52|0;f[C>>2]=0;f[e>>2]=0;if((y|0)!=0&(D|0)==0){E=$Xc(32)|0;f[i>>2]=E;f[i+8>>2]=-2147483616;f[i+4>>2]=28;t=E;F=470314;v=t+28|0;do{b[t>>0]=b[F>>0]|0;t=t+1|0;F=F+1|0}while((t|0)<(v|0));b[E+28>>0]=0;vM(-215,i,470343,470347,548)}E=y<<3;f[e>>2]=E;f[C>>2]=4;C=D+E|0;f[j+28>>2]=C;f[d>>2]=C+(0-E)+E;R$(j);f[p>>2]=1124007936;E=p+4|0;C=p+8|0;d=p+40|0;t=E;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[d>>2]=C;D=p+48|0;y=p+44|0;f[y>>2]=D;f[D>>2]=0;f[p+52>>2]=0;F=i+8|0;f[F>>2]=0;f[F+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=p;jR(j,i);F=j+36|0;G=f[F>>2]|0;if(G|0?(H=G+12|0,G=f[H>>2]|0,f[H>>2]=G+-1,(G|0)==1):0)V$(j);f[F>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[A>>2]|0)>0){n=f[B>>2]|0;B=0;do{f[n+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[A>>2]|0))}A=f[z>>2]|0;if((A|0)!=(e|0))wL(A);A=m+16|0;e=f[A>>2]|0;if((e|0)==(f[m+20>>2]|0))bx(m+12|0,p);else{f[e>>2]=f[p>>2];z=e+4|0;f[z>>2]=f[E>>2];B=e+8|0;f[B>>2]=f[C>>2];f[e+12>>2]=f[p+12>>2];f[e+16>>2]=f[p+16>>2];f[e+20>>2]=f[p+20>>2];f[e+24>>2]=f[p+24>>2];f[e+28>>2]=f[p+28>>2];f[e+32>>2]=f[p+32>>2];C=f[p+36>>2]|0;f[e+36>>2]=C;f[e+40>>2]=B;B=e+48|0;n=e+44|0;f[n>>2]=B;f[B>>2]=0;f[e+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[E>>2]|0)<3){B=f[y>>2]|0;C=f[n>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2]}else{f[z>>2]=0;U$(e,p)}f[A>>2]=(f[A>>2]|0)+56}f[q+40>>2]=0;f[q+44>>2]=0;e=q+40|0;z=q+36|0;t=q;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[z>>2]=e;t=q+48|0;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));t=a+4|0;f[h>>2]=f[t>>2];DM(r,428801,h);oYc(q,r)|0;oYc(q+12|0,x)|0;f[j>>2]=f[m>>2];f[k>>2]=c;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];Krb(q+36|0,i,h);JPa(q+48|0,f[s>>2]|0,f[A>>2]|0);oYc(q+60|0,w)|0;oYc(q+72|0,x)|0;A=q+24|0;s=a+8|0;h=q+28|0;i=f[h>>2]|0;k=q+32|0;if((i|0)==(f[k>>2]|0)){NN(A,s);I=f[h>>2]|0}else{lYc(i,s);i=(f[h>>2]|0)+12|0;f[h>>2]=i;I=i}if((I|0)==(f[k>>2]|0))NN(A,892640);else{lYc(I,892640);f[h>>2]=(f[h>>2]|0)+12}oYc(s,r)|0;h=f[a>>2]|0;I=h+16|0;A=f[I>>2]|0;if((A|0)==(f[h+20>>2]|0))Lrb(h+12|0,q);else{DNa(A,q);f[I>>2]=(f[I>>2]|0)+84}f[t>>2]=(f[t>>2]|0)+1;t=a+24|0;I=f[t>>2]|0;if((I|0)==(f[a+28>>2]|0))NN(a+20|0,s);else{lYc(I,s);f[t>>2]=(f[t>>2]|0)+12}if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);BNa(q);q=p+36|0;r=f[q>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)V$(p);f[q>>2]=0;q=p+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[E>>2]|0)>0){q=f[d>>2]|0;d=0;do{f[q+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[E>>2]|0))}E=f[y>>2]|0;if((E|0)!=(D|0))wL(E);E=f[o>>2]|0;if(E|0){o=f[l>>2]|0;if((o|0)!=(E|0))f[l>>2]=o+(~((o+-4-E|0)>>>2)<<2);cYc(E)}if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[w+11>>0]|0)>=0){J=m+12|0;hx(J);K=f[c>>2]|0;QGa(m,K);u=g;return}cYc(f[w>>2]|0);J=m+12|0;hx(J);K=f[c>>2]|0;QGa(m,K);u=g;return}function Krb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=a+8|0;a:do if(f[e>>2]|0?(g=f[a>>2]|0,h=a+4|0,f[a>>2]=h,f[(f[h>>2]|0)+8>>2]=0,f[h>>2]=0,f[e>>2]=0,i=f[g+4>>2]|0,j=(i|0)==0?g:i,j|0):0){i=a+4|0;g=j;j=f[c>>2]|0;while(1){if((j|0)==(f[d>>2]|0))break;k=g+16|0;oYc(k,j+16|0)|0;UGa(g+28|0,j+28|0)|0;l=g+8|0;m=f[l>>2]|0;do if(m){n=f[m>>2]|0;if((n|0)==(g|0)){f[m>>2]=0;o=f[m+4>>2]|0;if(!o){p=m;break}else q=o;while(1){o=f[q>>2]|0;if(o|0){q=o;continue}o=f[q+4>>2]|0;if(!o)break;else q=o}p=q;break}else{f[m+4>>2]=0;if(!n){p=m;break}else r=n;while(1){o=f[r>>2]|0;if(o|0){r=o;continue}o=f[r+4>>2]|0;if(!o)break;else r=o}p=r;break}}else p=0;while(0);m=f[h>>2]|0;do if(m){n=b[k+11>>0]|0;o=n<<24>>24<0;s=o?f[g+20>>2]|0:n&255;n=o?f[k>>2]|0:k;o=m;while(1){t=o+16|0;u=b[t+11>>0]|0;v=u<<24>>24<0;w=v?f[o+20>>2]|0:u&255;u=w>>>0<s>>>0?w:s;if((u|0)!=0?(x=WKc(n,v?f[t>>2]|0:t,u)|0,(x|0)!=0):0)if((x|0)<0)y=24;else y=26;else if(s>>>0<w>>>0)y=24;else y=26;if((y|0)==24){y=0;w=f[o>>2]|0;if(!w){y=25;break}else z=w}else if((y|0)==26){y=0;A=o+4|0;w=f[A>>2]|0;if(!w){y=28;break}else z=w}o=z}if((y|0)==25){y=0;B=o;C=o;break}else if((y|0)==28){y=0;B=A;C=o;break}}else{B=h;C=h}while(0);f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=C;f[B>>2]=g;m=f[f[a>>2]>>2]|0;if(!m)D=g;else{f[a>>2]=m;D=f[B>>2]|0}UQ(f[i>>2]|0,D);f[e>>2]=(f[e>>2]|0)+1;m=f[j+4>>2]|0;if(!m){k=j+8|0;s=f[k>>2]|0;if((f[s>>2]|0)==(j|0))E=s;else{s=k;do{k=f[s>>2]|0;s=k+8|0;n=f[s>>2]|0}while((f[n>>2]|0)!=(k|0));E=n}}else{s=m;while(1){l=f[s>>2]|0;if(!l)break;else s=l}E=s}f[c>>2]=E;if(!p)break a;else{g=p;j=E}}j=f[g+8>>2]|0;if(!j)F=g;else{i=j;while(1){j=f[i+8>>2]|0;if(!j)break;else i=j}F=i}QGa(a,F)}while(0);F=f[c>>2]|0;E=f[d>>2]|0;if((F|0)==(E|0))return;else G=F;while(1){Nrb(a,G+16|0)|0;F=f[G+4>>2]|0;if(!F){d=G+8|0;p=f[d>>2]|0;if((f[p>>2]|0)==(G|0))H=p;else{p=d;do{d=f[p>>2]|0;p=d+8|0;e=f[p>>2]|0}while((f[e>>2]|0)!=(d|0));H=e}}else{p=F;while(1){i=f[p>>2]|0;if(!i)break;else p=i}H=p}f[c>>2]=H;if((H|0)==(E|0))break;else G=H}return}function Lrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/84|0;h=g+1|0;if(h>>>0>51130563)kWc(a);i=((f[a+8>>2]|0)-e|0)/84|0;e=i<<1;j=i>>>0<25565281?(e>>>0<h>>>0?h:e):51130563;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>51130563){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{k=$Xc(j*84|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*84|0)|0;g=d+8|0;f[g>>2]=e;h=d+4|0;f[h>>2]=e;f[d+12>>2]=k+(j*84|0);DNa(e,b);f[g>>2]=e+84;Mrb(a,d);a=f[h>>2]|0;h=f[g>>2]|0;if((h|0)!=(a|0)){e=h;do{h=e+-84|0;f[g>>2]=h;BNa(h);e=f[g>>2]|0}while((e|0)!=(a|0))}a=f[d>>2]|0;if(!a){u=c;return}cYc(a);u=c;return}function Mrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;if((e|0)==(c|0)){h=g;i=a;j=f[g>>2]|0;k=c;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}t=e;e=f[g>>2]|0;do{u=e+-84|0;v=t;t=t+-84|0;f[u>>2]=f[t>>2];f[u+4>>2]=f[t+4>>2];f[u+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;u=e+-72|0;w=v+-72|0;f[u>>2]=f[w>>2];f[u+4>>2]=f[w+4>>2];f[u+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;w=e+-60|0;u=v+-60|0;f[w>>2]=0;x=e+-56|0;f[x>>2]=0;f[e+-52>>2]=0;f[w>>2]=f[u>>2];w=v+-56|0;f[x>>2]=f[w>>2];x=v+-52|0;f[e+-52>>2]=f[x>>2];f[x>>2]=0;f[w>>2]=0;f[u>>2]=0;u=e+-48|0;w=v+-48|0;f[u>>2]=f[w>>2];x=f[v+-44>>2]|0;f[e+-44>>2]=x;y=v+-40|0;z=f[y>>2]|0;f[e+-40>>2]=z;A=e+-44|0;if(!z)f[u>>2]=A;else{f[x+8>>2]=A;A=v+-44|0;f[w>>2]=A;f[A>>2]=0;f[y>>2]=0}y=e+-36|0;A=v+-36|0;f[y>>2]=0;w=e+-32|0;f[w>>2]=0;f[e+-28>>2]=0;f[y>>2]=f[A>>2];y=v+-32|0;f[w>>2]=f[y>>2];w=v+-28|0;f[e+-28>>2]=f[w>>2];f[w>>2]=0;f[y>>2]=0;f[A>>2]=0;A=e+-24|0;y=v+-24|0;f[A>>2]=f[y>>2];f[A+4>>2]=f[y+4>>2];f[A+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;y=e+-12|0;A=v+-12|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];f[y+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;e=(f[g>>2]|0)+-84|0;f[g>>2]=e}while((t|0)!=(c|0));h=g;i=a;j=e;k=f[a>>2]|0;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}function Nrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=$Xc(36)|0;e=d+16|0;lYc(e,c);VGa(d+28|0,c+12|0);c=a+4|0;g=f[c>>2]|0;do if(g){h=b[d+27>>0]|0;i=h<<24>>24<0;j=i?f[d+20>>2]|0:h&255;h=i?f[e>>2]|0:e;i=g;while(1){k=i+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[i+20>>2]|0:l&255;l=n>>>0<j>>>0?n:j;if((l|0)!=0?(o=WKc(h,m?f[k>>2]|0:k,l)|0,(o|0)!=0):0)if((o|0)<0)p=7;else p=9;else if(j>>>0<n>>>0)p=7;else p=9;if((p|0)==7){p=0;n=f[i>>2]|0;if(!n){p=8;break}else q=n}else if((p|0)==9){p=0;r=i+4|0;n=f[r>>2]|0;if(!n){p=11;break}else q=n}i=q}if((p|0)==8){s=i;t=i;break}else if((p|0)==11){s=i;t=r;break}}else{s=c;t=c}while(0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=s;f[t>>2]=d;s=f[f[a>>2]>>2]|0;if(!s){u=d;v=a+4|0;w=f[v>>2]|0;UQ(w,u);x=a+8|0;y=f[x>>2]|0;z=y+1|0;f[x>>2]=z;return d|0}f[a>>2]=s;u=f[t>>2]|0;v=a+4|0;w=f[v>>2]|0;UQ(w,u);x=a+8|0;y=f[x>>2]|0;z=y+1|0;f[x>>2]=z;return d|0}function Orb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function Prb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;i=c+12|0;j=c+8|0;k=c+4|0;l=c;m=c+16|0;n=c+28|0;f[i>>2]=d;f[j>>2]=e;f[k>>2]=g;f[l>>2]=h;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;h=a+12|0;g=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(g|0));tYc(a+24|0,429146)|0;tYc(a+36|0,429163)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=$Xc(16)|0;f[m>>2]=e;f[m+8>>2]=-2147483632;f[m+4>>2]=11;h=e;d=446598;g=h+11|0;do{b[h>>0]=b[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(g|0));b[e+11>>0]=0;aHa(a,m,i)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);i=m+4|0;f[i>>2]=0;f[i+4>>2]=0;i=m+11|0;b[i>>0]=3;b[m>>0]=b[446809]|0;b[m+1>>0]=b[446810]|0;b[m+2>>0]=b[446811]|0;b[m+3>>0]=0;aHa(a,m,j)|0;if((b[i>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;i=m+11|0;b[i>>0]=6;b[m>>0]=b[446813]|0;b[m+1>>0]=b[446814]|0;b[m+2>>0]=b[446815]|0;b[m+3>>0]=b[446816]|0;b[m+4>>0]=b[446817]|0;b[m+5>>0]=b[446818]|0;b[m+6>>0]=0;aHa(a,m,k)|0;if((b[i>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;i=m+11|0;b[i>>0]=9;h=m;d=445999;g=h+9|0;do{b[h>>0]=b[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(g|0));b[m+9>>0]=0;b[n>>0]=0;cHa(a,m,n)|0;if((b[i>>0]|0)<0)cYc(f[m>>2]|0);i=m+11|0;b[i>>0]=10;h=m;d=453228;g=h+10|0;do{b[h>>0]=b[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(g|0));b[m+10>>0]=0;aHa(a,m,l)|0;if((b[i>>0]|0)>=0){u=c;return}cYc(f[m>>2]|0);u=c;return}function Qrb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+4|0;i=e;cOc(g,a,0);if(!(b[g>>0]|0)){g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(g,f[g+16>>2]|4);u=e;return a|0}g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[g>>0]=0}g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;j=f[g+12>>2]|0;k=(j|0)<1?2147483647:j;ZNc(i,g);g=DPc(i,896088)|0;EPc(i);a:do if((k|0)>0){i=g+8|0;j=0;while(1){l=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;m=f[l+12>>2]|0;if((m|0)==(f[l+16>>2]|0)){n=_i[f[(f[l>>2]|0)+36>>2]&2047](l)|0;if((n|0)==-1){o=j;p=2;break a}else q=n}else q=h[m>>0]|0;m=q&255;if(m<<24>>24>-1?d[(f[i>>2]|0)+(q<<24>>24<<1)>>1]&8192:0){o=j;p=0;break a}BYc(c,m);m=j+1|0;n=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;l=n+12|0;r=f[l>>2]|0;if((r|0)==(f[n+16>>2]|0))_i[f[(f[n>>2]|0)+40>>2]&2047](n)|0;else f[l>>2]=r+1;if((m|0)<(k|0))j=m;else{o=m;p=0;break}}}else{o=0;p=0}while(0);f[a+(f[(f[a>>2]|0)+-12>>2]|0)+12>>2]=0;k=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(k,f[k+16>>2]|((o|0)==0?p|4:p));u=e;return a|0}function Rrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0;d=u;u=u+496|0;e=d+472|0;g=d+468|0;h=d+464|0;i=d;j=d+416|0;k=d+392|0;l=d+368|0;m=d+448|0;n=d+404|0;o=d+380|0;p=d+356|0;q=d+344|0;r=d+328|0;s=d+272|0;t=d+216|0;v=d+160|0;w=d+88|0;x=d+32|0;y=d+144|0;z=d+8|0;A=d+20|0;iOc(a,g,4)|0;iOc(a,h,4)|0;iOc(a,d+460|0,4)|0;if((((f[g>>2]|0)*10|0)+(f[h>>2]|0)|0)>1)iOc(a,i,8)|0;else{f[e>>2]=0;iOc(a,e,4)|0;B=f[e>>2]|0;C=i;f[C>>2]=B;f[C+4>>2]=((B|0)<0)<<31>>31}if((f[g>>2]|0)>1e3|(f[h>>2]|0)>1e3){h=$Xc(80)|0;f[e>>2]=h;f[e+8>>2]=-2147483568;f[e+4>>2]=67;D=h;E=429175;F=D+67|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[h+67>>0]=0;vM(-213,e,429243,428111,690)}h=f[c+8>>2]|0;f[j>>2]=c;f[j+4>>2]=0;g=j+8|0;lYc(g,892640);f[j+20>>2]=0;B=j+24|0;f[B>>2]=0;f[j+28>>2]=0;C=f[c+36>>2]|0;i=c+40|0;do if((C|0)!=(i|0)){G=l+11|0;H=l+4|0;I=k+11|0;J=k+4|0;K=m+11|0;L=m+4|0;M=n+11|0;N=n+7|0;O=o+11|0;P=o+10|0;Q=p+11|0;R=p+6|0;S=q+8|0;T=q+4|0;U=q+11|0;V=r+4|0;W=r+8|0;X=r+12|0;Z=s+4|0;_=s+8|0;$=s+40|0;aa=s+48|0;ba=s+44|0;ca=s+52|0;da=t+4|0;ea=t+8|0;fa=t+40|0;ga=t+48|0;ha=t+44|0;ia=t+52|0;ja=e+4|0;ka=v+4|0;la=v+8|0;ma=v+40|0;na=v+48|0;oa=v+44|0;pa=v+52|0;qa=w+4|0;ra=w+8|0;sa=w+40|0;ta=w+48|0;ua=w+44|0;va=w+52|0;wa=x+4|0;xa=x+8|0;ya=x+40|0;za=x+48|0;Aa=x+44|0;Ba=x+52|0;Ca=x+16|0;Da=w+16|0;Ea=t+16|0;Fa=v+16|0;Ga=s+16|0;Ha=e+4|0;Ia=e+8|0;Ja=e+8|0;Ka=z+4|0;La=z+8|0;Ma=z+8|0;Na=A+4|0;Oa=x+12|0;Pa=x+20|0;Qa=x+24|0;Ra=x+28|0;Sa=x+32|0;Ta=x+36|0;Ua=w+12|0;Va=w+20|0;Wa=w+24|0;Xa=w+28|0;Ya=w+32|0;Za=w+36|0;_a=v+12|0;$a=v+20|0;ab=v+24|0;bb=v+28|0;cb=v+32|0;db=v+36|0;eb=l+11|0;fb=l+4|0;gb=t+36|0;hb=s+36|0;ib=y+4|0;jb=c+24|0;kb=n+8|0;lb=-1;mb=h;nb=-1;ob=C;while(1){lb=lb+1|0;pb=nb+1|0;qb=ob+20|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[G>>0]=4;f[l>>2]=1701869940;b[H>>0]=0;rb=DLa(qb,e,l)|0;sb=f[rb>>2]|0;if(!sb){tb=$Xc(40)|0;ub=tb+16|0;f[ub>>2]=f[l>>2];f[ub+4>>2]=f[l+4>>2];f[ub+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ub=tb+28|0;f[ub>>2]=0;f[ub+4>>2]=0;f[ub+8>>2]=0;ub=f[e>>2]|0;f[tb>>2]=0;f[tb+4>>2]=0;f[tb+8>>2]=ub;f[rb>>2]=tb;ub=f[f[qb>>2]>>2]|0;if(!ub)vb=tb;else{f[qb>>2]=ub;vb=f[rb>>2]|0}UQ(f[ob+24>>2]|0,vb);rb=ob+28|0;f[rb>>2]=(f[rb>>2]|0)+1;wb=tb}else wb=sb;lYc(k,wb+28|0);if((b[G>>0]|0)<0)cYc(f[l>>2]|0);sb=b[I>>0]|0;if(((sb<<24>>24<0?f[J>>2]|0:sb&255)|0)==13?(LYc(k,0,-1,428275,13)|0)==0:0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[K>>0]=4;f[m>>2]=1702521203;b[L>>0]=0;sb=urb(qb,m,-1)|0;if((b[K>>0]|0)<0)cYc(f[m>>2]|0);f[kb>>2]=0;b[M>>0]=7;b[n>>0]=b[428289]|0;b[n+1>>0]=b[428290]|0;b[n+2>>0]=b[428291]|0;b[n+3>>0]=b[428292]|0;b[n+4>>0]=b[428293]|0;b[n+5>>0]=b[428294]|0;b[n+6>>0]=b[428295]|0;b[N>>0]=0;tb=urb(qb,n,-1)|0;if((b[M>>0]|0)<0)cYc(f[n>>2]|0);b[O>>0]=10;D=o;E=428297;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[P>>0]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;b[Q>>0]=6;b[p>>0]=b[428308]|0;b[p+1>>0]=b[428309]|0;b[p+2>>0]=b[428310]|0;b[p+3>>0]=b[428311]|0;b[p+4>>0]=b[428312]|0;b[p+5>>0]=b[428313]|0;b[R>>0]=0;vrb(l,qb,o,p);if((b[Q>>0]|0)<0)cYc(f[p>>2]|0);if((b[O>>0]|0)<0)cYc(f[o>>2]|0);f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;rb=$Xc(16)|0;f[q>>2]=rb;f[S>>2]=-2147483632;f[T>>2]=15;D=rb;E=428315;F=D+15|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[rb+15>>0]=0;ub=(urb(qb,q,0)|0)==1;if((b[U>>0]|0)<0)cYc(f[q>>2]|0);if(!((sb|0)>0&(tb|0)>0)){xb=37;break}if((mb|0)<=0){xb=39;break}f[r>>2]=tb;f[V>>2]=mb;f[W>>2]=sb;f[X>>2]=sb;f[s>>2]=1124007936;D=Z;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[$>>2]=_;f[ba>>2]=aa;f[aa>>2]=0;f[ca>>2]=0;S$(s,4,r,5);if(!(f[s>>2]&16384)){xb=41;break}f[t>>2]=1124007936;D=da;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[fa>>2]=ea;f[ha>>2]=ga;f[ga>>2]=0;f[ia>>2]=0;f[e>>2]=1;f[ja>>2]=tb;S$(t,2,e,5);f[v>>2]=1124007936;D=ka;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[ma>>2]=la;f[oa>>2]=na;f[na>>2]=0;f[pa>>2]=0;f[e>>2]=1;f[ja>>2]=tb;S$(v,2,e,5);f[w>>2]=1124007936;D=qa;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[sa>>2]=ra;f[ua>>2]=ta;f[ta>>2]=0;f[va>>2]=0;f[e>>2]=1;f[ja>>2]=tb;S$(w,2,e,5);f[x>>2]=1124007936;D=wa;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[ya>>2]=xa;f[Aa>>2]=za;f[za>>2]=0;f[Ba>>2]=0;f[e>>2]=1;f[ja>>2]=tb;S$(x,2,e,5);qb=tb<<2;iOc(a,f[Ca>>2]|0,qb)|0;if(ub){iOc(a,f[Da>>2]|0,qb)|0;iOc(a,f[Ea>>2]|0,qb)|0;iOc(a,f[Fa>>2]|0,qb)|0;yb=ub}else yb=0;iOc(a,f[Ga>>2]|0,Y(Y(Y(mb<<2,sb)|0,sb)|0,tb)|0)|0;f[e>>2]=0;f[Ha>>2]=0;f[Ia>>2]=0;bx(e,s);do if(!yb){qb=f[Ha>>2]|0;if((qb|0)==(f[Ja>>2]|0)){bx(e,x);break}f[qb>>2]=f[x>>2];rb=qb+4|0;f[rb>>2]=f[wa>>2];zb=qb+8|0;f[zb>>2]=f[xa>>2];f[qb+12>>2]=f[Oa>>2];f[qb+16>>2]=f[Ca>>2];f[qb+20>>2]=f[Pa>>2];f[qb+24>>2]=f[Qa>>2];f[qb+28>>2]=f[Ra>>2];f[qb+32>>2]=f[Sa>>2];Ab=f[Ta>>2]|0;f[qb+36>>2]=Ab;f[qb+40>>2]=zb;zb=qb+48|0;Bb=qb+44|0;f[Bb>>2]=zb;f[zb>>2]=0;f[qb+52>>2]=0;if(Ab|0){zb=Ab+12|0;f[zb>>2]=(f[zb>>2]|0)+1}if((f[wa>>2]|0)<3){zb=f[Aa>>2]|0;Ab=f[Bb>>2]|0;f[Ab>>2]=f[zb>>2];f[Ab+4>>2]=f[zb+4>>2]}else{f[rb>>2]=0;U$(qb,x)}f[Ha>>2]=(f[Ha>>2]|0)+56}while(0);GNa(y,e);tb=(f[(f[j>>2]|0)+12>>2]|0)+(pb*84|0)+48|0;if((tb|0)!=(y|0))JPa(tb,f[y>>2]|0,f[ib>>2]|0);hx(y);if(ub){tb=nb+2|0;f[z>>2]=0;f[Ka>>2]=0;f[La>>2]=0;bx(z,t);sb=f[Ka>>2]|0;if((sb|0)==(f[Ma>>2]|0)){bx(z,v);Cb=f[Ka>>2]|0}else{f[sb>>2]=f[v>>2];qb=sb+4|0;f[qb>>2]=f[ka>>2];rb=sb+8|0;f[rb>>2]=f[la>>2];f[sb+12>>2]=f[_a>>2];f[sb+16>>2]=f[Fa>>2];f[sb+20>>2]=f[$a>>2];f[sb+24>>2]=f[ab>>2];f[sb+28>>2]=f[bb>>2];f[sb+32>>2]=f[cb>>2];zb=f[db>>2]|0;f[sb+36>>2]=zb;f[sb+40>>2]=rb;rb=sb+48|0;Ab=sb+44|0;f[Ab>>2]=rb;f[rb>>2]=0;f[sb+52>>2]=0;if(zb|0){rb=zb+12|0;f[rb>>2]=(f[rb>>2]|0)+1}if((f[ka>>2]|0)<3){rb=f[oa>>2]|0;zb=f[Ab>>2]|0;f[zb>>2]=f[rb>>2];f[zb+4>>2]=f[rb+4>>2]}else{f[qb>>2]=0;U$(sb,v)}sb=(f[Ka>>2]|0)+56|0;f[Ka>>2]=sb;Cb=sb}if((Cb|0)==(f[Ma>>2]|0)){bx(z,w);Db=f[Ka>>2]|0}else{f[Cb>>2]=f[w>>2];sb=Cb+4|0;f[sb>>2]=f[qa>>2];qb=Cb+8|0;f[qb>>2]=f[ra>>2];f[Cb+12>>2]=f[Ua>>2];f[Cb+16>>2]=f[Da>>2];f[Cb+20>>2]=f[Va>>2];f[Cb+24>>2]=f[Wa>>2];f[Cb+28>>2]=f[Xa>>2];f[Cb+32>>2]=f[Ya>>2];rb=f[Za>>2]|0;f[Cb+36>>2]=rb;f[Cb+40>>2]=qb;qb=Cb+48|0;zb=Cb+44|0;f[zb>>2]=qb;f[qb>>2]=0;f[Cb+52>>2]=0;if(rb|0){qb=rb+12|0;f[qb>>2]=(f[qb>>2]|0)+1}if((f[qa>>2]|0)<3){qb=f[ua>>2]|0;rb=f[zb>>2]|0;f[rb>>2]=f[qb>>2];f[rb+4>>2]=f[qb+4>>2]}else{f[sb>>2]=0;U$(Cb,w)}sb=(f[Ka>>2]|0)+56|0;f[Ka>>2]=sb;Db=sb}if((Db|0)==(f[Ma>>2]|0))bx(z,x);else{f[Db>>2]=f[x>>2];sb=Db+4|0;f[sb>>2]=f[wa>>2];qb=Db+8|0;f[qb>>2]=f[xa>>2];f[Db+12>>2]=f[Oa>>2];f[Db+16>>2]=f[Ca>>2];f[Db+20>>2]=f[Pa>>2];f[Db+24>>2]=f[Qa>>2];f[Db+28>>2]=f[Ra>>2];f[Db+32>>2]=f[Sa>>2];rb=f[Ta>>2]|0;f[Db+36>>2]=rb;f[Db+40>>2]=qb;qb=Db+48|0;zb=Db+44|0;f[zb>>2]=qb;f[qb>>2]=0;f[Db+52>>2]=0;if(rb|0){qb=rb+12|0;f[qb>>2]=(f[qb>>2]|0)+1}if((f[wa>>2]|0)<3){qb=f[Aa>>2]|0;rb=f[zb>>2]|0;f[rb>>2]=f[qb>>2];f[rb+4>>2]=f[qb+4>>2]}else{f[sb>>2]=0;U$(Db,x)}f[Ka>>2]=(f[Ka>>2]|0)+56}GNa(A,z);sb=(f[(f[j>>2]|0)+12>>2]|0)+(tb*84|0)+48|0;if((sb|0)!=(A|0))JPa(sb,f[A>>2]|0,f[Na>>2]|0);hx(A);hx(z);Eb=tb}else Eb=pb;tb=b[eb>>0]|0;if(((tb<<24>>24<0?f[fb>>2]|0:tb&255)|0)==5)Fb=((LYc(l,0,-1,428331,5)|0)==0&1)+Eb|0;else Fb=Eb;hx(e);tb=f[Ta>>2]|0;do if(tb|0){sb=tb+12|0;qb=f[sb>>2]|0;f[sb>>2]=qb+-1;if((qb|0)!=1)break;V$(x)}while(0);f[Ta>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[wa>>2]|0)>0){tb=f[ya>>2]|0;ub=0;do{f[tb+(ub<<2)>>2]=0;ub=ub+1|0}while((ub|0)<(f[wa>>2]|0))}ub=f[Aa>>2]|0;if((ub|0)!=(za|0))wL(ub);ub=f[Za>>2]|0;do if(ub|0){tb=ub+12|0;qb=f[tb>>2]|0;f[tb>>2]=qb+-1;if((qb|0)!=1)break;V$(w)}while(0);f[Za>>2]=0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[qa>>2]|0)>0){ub=f[sa>>2]|0;qb=0;do{f[ub+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[qa>>2]|0))}qb=f[ua>>2]|0;if((qb|0)!=(ta|0))wL(qb);qb=f[db>>2]|0;do if(qb|0){ub=qb+12|0;tb=f[ub>>2]|0;f[ub>>2]=tb+-1;if((tb|0)!=1)break;V$(v)}while(0);f[db>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;if((f[ka>>2]|0)>0){qb=f[ma>>2]|0;tb=0;do{f[qb+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[ka>>2]|0))}tb=f[oa>>2]|0;if((tb|0)!=(na|0))wL(tb);tb=f[gb>>2]|0;do if(tb|0){qb=tb+12|0;ub=f[qb>>2]|0;f[qb>>2]=ub+-1;if((ub|0)!=1)break;V$(t)}while(0);f[gb>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[da>>2]|0)>0){tb=f[fa>>2]|0;ub=0;do{f[tb+(ub<<2)>>2]=0;ub=ub+1|0}while((ub|0)<(f[da>>2]|0))}ub=f[ha>>2]|0;if((ub|0)!=(ga|0))wL(ub);ub=f[hb>>2]|0;do if(ub|0){tb=ub+12|0;qb=f[tb>>2]|0;f[tb>>2]=qb+-1;if((qb|0)!=1)break;V$(s)}while(0);f[hb>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[Z>>2]|0)>0){ub=f[$>>2]|0;qb=0;do{f[ub+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[Z>>2]|0))}qb=f[ba>>2]|0;if((qb|0)!=(aa|0))wL(qb);if((b[eb>>0]|0)<0)cYc(f[l>>2]|0);Gb=Fb}else Gb=pb;qb=b[I>>0]|0;ub=f[J>>2]|0;if(((qb<<24>>24<0?ub:qb&255)|0)==6)if(!(LYc(k,0,-1,428580,6)|0))xb=133;else{Hb=b[I>>0]|0;Ib=f[J>>2]|0;xb=131}else{Hb=qb;Ib=ub;xb=131}if((xb|0)==131){xb=0;if(((Hb<<24>>24<0?Ib:Hb&255)|0)==4?(LYc(k,0,-1,428735,4)|0)==0:0)xb=133;else Jb=Gb}if((xb|0)==133){xb=0;Jb=Gb+1|0}mb=f[(f[jb>>2]|0)+(lb<<2)>>2]|0;if((b[I>>0]|0)<0)cYc(f[k>>2]|0);ub=f[ob+4>>2]|0;if(!ub){qb=ob+8|0;tb=f[qb>>2]|0;if((f[tb>>2]|0)==(ob|0))Kb=tb;else{tb=qb;do{qb=f[tb>>2]|0;tb=qb+8|0;sb=f[tb>>2]|0}while((f[sb>>2]|0)!=(qb|0));Kb=sb}}else{tb=ub;while(1){pb=f[tb>>2]|0;if(!pb)break;else tb=pb}Kb=tb}if((Kb|0)==(i|0)){xb=8;break}else{nb=Jb;ob=Kb}}if((xb|0)==8){ob=j+20|0;nb=f[ob>>2]|0;if(!nb)break;I=f[B>>2]|0;if((I|0)==(nb|0))Lb=nb;else{lb=I;while(1){I=lb+-12|0;f[B>>2]=I;if((b[I+11>>0]|0)<0){cYc(f[I>>2]|0);Mb=f[B>>2]|0}else Mb=I;if((Mb|0)==(nb|0))break;else lb=Mb}Lb=f[ob>>2]|0}cYc(Lb);break}else if((xb|0)==37){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;lb=$Xc(32)|0;f[e>>2]=lb;f[e+8>>2]=-2147483616;f[e+4>>2]=30;D=lb;E=428425;F=D+30|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[lb+30>>0]=0;vM(-215,e,429243,428111,712)}else if((xb|0)==39){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ob=$Xc(32)|0;f[e>>2]=ob;f[e+8>>2]=-2147483616;f[e+4>>2]=20;D=ob;E=428456;F=D+20|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[ob+20>>0]=0;vM(-215,e,429243,428111,713)}else if((xb|0)==41){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;lb=$Xc(32)|0;f[e>>2]=lb;f[e+8>>2]=-2147483616;f[e+4>>2]=26;D=lb;E=429272;F=D+26|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[lb+26>>0]=0;vM(-215,e,429243,428111,719)}}while(0);if((b[g+11>>0]|0)>=0){u=d;return 1}cYc(f[g>>2]|0);u=d;return 1}function Srb(a,b){a=a|0;b=b|0;rrb(a,b)|0;return}function Trb(a,b){a=a|0;b=b|0;Rrb(a,b)|0;return}function Urb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0;d=u;u=u+16|0;e=d;g=$Xc(16)|0;f[e>>2]=g;f[e+8>>2]=-2147483632;f[e+4>>2]=14;h=g;i=429299;j=h+14|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+14>>0]=0;g=LGa(c,e)|0;if((g|0)==(c+4|0))k=0.0;else k=+NGa(g+28|0,-1);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);e=$Xc(56)|0;qQa(e);f[e>>2]=101700;b[e+52>>0]=0;n[e+48>>2]=k;f[a>>2]=e;g=$Xc(16)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=101816;f[g+12>>2]=e;f[a+4>>2]=g;rQa(e,c);n[e+44>>2]=k;u=d;return}function Vrb(a){a=a|0;NXc(a);cYc(a);return}function Wrb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Xrb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==429314?a+12|0:0)|0}function Yrb(a){a=a|0;cYc(a);return}function Zrb(a){a=a|0;MNa(a);cYc(a);return}function _rb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+48|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=101844;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function $rb(a,b){a=a|0;b=b|0;return (b+-1|0)>>>0<4|0}function asb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function bsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function csb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function dsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function esb(a,b){a=a|0;b=b|0;return 0}function fsb(a,b,c){a=a|0;b=b|0;c=c|0;return}function gsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function hsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=d1c(r|0,0,e|0,k|0)|0;g=g+1|0;o=k1c(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function isb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,k=0,l=0.0;h=+n[a+48>>2];if((d|0)>0&(f|0)<(g|0)){i=f;j=c;k=b}else return;while(1){b=0;do{l=+n[k+(b<<2)>>2];n[j+(b<<2)>>2]=!(l>=0.0)?h*l:l;b=b+1|0}while((b|0)!=(d|0));i=i+1|0;if((i|0)==(g|0))break;else{j=j+(e<<2)|0;k=k+(e<<2)|0}}return}function jsb(a){a=a|0;cYc(a);return}function ksb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;i=f[d+16>>2]|0;e=f[f[d+44>>2]>>2]|0;d=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(a|0)>0)q=0;else return;do{o=h+(Y(b,q)|0)+(c<<2)|0;m=i+(Y(e,q)|0)+(c<<2)|0;r=+n[d>>2];g=0;p=m;m=o;while(1){o=0;do{s=+n[m+(o<<2)>>2];n[p+(o<<2)>>2]=!(s>=0.0)?r*s:s;o=o+1|0}while((o|0)!=(a|0));g=g+1|0;if((g|0)==(j|0))break;else{p=p+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function lsb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=9;h=e;i=429854;j=h+9|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+9>>0]=0;k=LGa(c,e)|0;l=c+4|0;if((k|0)==(l|0))m=0.0;else m=+NGa(k+28|0,-1);if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=9;h=e;i=429864;j=h+9|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+9>>0]=0;k=LGa(c,e)|0;if((k|0)==(l|0))o=6.0;else o=+NGa(k+28|0,-1);if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=$Xc(64)|0;if(!(m<=o)){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=20;h=k;i=429874;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[k+20>>0]=0;vM(-215,e,429895,429630,393)}else{qQa(g);f[g>>2]=101864;b[g+60>>0]=0;n[g+52>>2]=m;n[g+56>>2]=o;f[a>>2]=g;e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=101980;f[e+12>>2]=g;f[a+4>>2]=e;rQa(g,c);n[g+44>>2]=m;n[g+48>>2]=o;u=d;return}}function msb(a){a=a|0;NXc(a);cYc(a);return}function nsb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function osb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==429908?a+12|0:0)|0}function psb(a){a=a|0;cYc(a);return}function qsb(a){a=a|0;MNa(a);cYc(a);return}function rsb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+52|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=102008;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function ssb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function tsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function usb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function vsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function wsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function xsb(a,b){a=a|0;b=b|0;return 0}function ysb(a,b,c){a=a|0;b=b|0;c=c|0;return}function zsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function Asb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=u1c(r|0,((r|0)<0)<<31>>31|0,1)|0;o=d1c(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=k1c(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function Bsb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0;if((f|0)>=(g|0))return;h=a+52|0;i=a+56|0;if((d|0)>0){j=f;k=c;l=b}else return;while(1){b=0;do{m=+n[l+(b<<2)>>2];o=+n[h>>2];if(!(m>=o))p=o;else{o=+n[i>>2];p=m<=o?m:o}n[k+(b<<2)>>2]=p;b=b+1|0}while((b|0)!=(d|0));j=j+1|0;if((j|0)==(g|0))break;else{k=k+(e<<2)|0;l=l+(e<<2)|0}}return}function Csb(a){a=a|0;cYc(a);return}function Dsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[a+12>>2]|0;b=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;o=(a|0)>0;i=b+4|0;if((j|0)<=0)return;e=f[h+16>>2]|0;m=f[f[h+44>>2]>>2]|0;h=f[d+16>>2]|0;g=f[f[d+44>>2]>>2]|0;d=0;do{if(o){p=0;q=e+(Y(m,d)|0)+(c<<2)|0;r=h+(Y(g,d)|0)+(c<<2)|0;while(1){s=0;do{t=+n[r+(s<<2)>>2];u=+n[b>>2];if(!(t>=u))v=u;else{u=+n[i>>2];v=t<=u?t:u}n[q+(s<<2)>>2]=v;s=s+1|0}while((s|0)!=(a|0));p=p+1|0;if((p|0)==(j|0))break;else{q=q+(k<<2)|0;r=r+(k<<2)|0}}}d=d+1|0}while((d|0)!=(l|0));return}function Esb(a,c){a=a|0;c=c|0;var d=0,e=0;d=$Xc(48)|0;qQa(d);f[d>>2]=102028;b[d+45>>0]=0;f[a>>2]=d;e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=102144;f[e+12>>2]=d;f[a+4>>2]=e;rQa(d,c);return}function Fsb(a){a=a|0;NXc(a);cYc(a);return}function Gsb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Hsb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==430251?a+12|0:0)|0}function Isb(a){a=a|0;cYc(a);return}function Jsb(a){a=a|0;MNa(a);cYc(a);return}function Ksb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+44|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=102172;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function Lsb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function Msb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Nsb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Osb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Psb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Qsb(a,b){a=a|0;b=b|0;return 0}function Rsb(a,b,c){a=a|0;b=b|0;c=c|0;return}function Ssb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function Tsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=d1c(r|0,0,e|0,k|0)|0;g=g+1|0;o=k1c(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function Usb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+CLc(+n[j+(b<<2)>>2]);n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Vsb(a){a=a|0;cYc(a);return}function Wsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+CLc(+n[m+(g<<2)>>2]);n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Xsb(a,c){a=a|0;c=c|0;var d=0,e=0;d=$Xc(48)|0;qQa(d);f[d>>2]=102192;b[d+45>>0]=0;f[a>>2]=d;e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=102308;f[e+12>>2]=d;f[a+4>>2]=e;rQa(d,c);return}function Ysb(a){a=a|0;NXc(a);cYc(a);return}function Zsb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function _sb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==430588?a+12|0:0)|0}function $sb(a){a=a|0;cYc(a);return}function atb(a){a=a|0;MNa(a);cYc(a);return}function btb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+44|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=102336;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function ctb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function dtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function etb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ftb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function gtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function htb(a,b){a=a|0;b=b|0;return 0}function itb(a,b,c){a=a|0;b=b|0;c=c|0;return}function jtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function ktb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=x1c(r|0,((r|0)<0)<<31>>31|0,3,0)|0;o=d1c(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=k1c(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function ltb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=1.0/(+V(+-+n[j+(b<<2)>>2])+1.0);n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function mtb(a){a=a|0;cYc(a);return}function ntb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=1.0/(+V(+-+n[m+(g<<2)>>2])+1.0);n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function otb(a,c){a=a|0;c=c|0;var d=0,e=0;d=$Xc(48)|0;qQa(d);f[d>>2]=102356;b[d+45>>0]=0;f[a>>2]=d;e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=102472;f[e+12>>2]=d;f[a+4>>2]=e;rQa(d,c);return}function ptb(a){a=a|0;NXc(a);cYc(a);return}function qtb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function rtb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==430941?a+12|0:0)|0}function stb(a){a=a|0;cYc(a);return}function ttb(a){a=a|0;MNa(a);cYc(a);return}function utb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+44|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=102500;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function vtb(a,b){a=a|0;b=b|0;return (b|0)==2|(b|2|0)==3|0}function wtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function xtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ytb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ztb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Atb(a,b){a=a|0;b=b|0;return 0}function Btb(a,b,c){a=a|0;b=b|0;c=c|0;return}function Ctb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function Dtb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=u1c(r|0,((r|0)<0)<<31>>31|0,1)|0;o=d1c(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=k1c(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function Etb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+n[j+(b<<2)>>2];if(!(k>=0.0))l=+V(+k)+-1.0;else l=k;n[i+(b<<2)>>2]=l;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Ftb(a){a=a|0;cYc(a);return}function Gtb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+n[m+(g<<2)>>2];if(!(r>=0.0))s=+V(+r)+-1.0;else s=r;n[e+(g<<2)>>2]=s;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Htb(a,c){a=a|0;c=c|0;var d=0,e=0;d=$Xc(48)|0;qQa(d);f[d>>2]=102520;b[d+45>>0]=0;f[a>>2]=d;e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=102636;f[e+12>>2]=d;f[a+4>>2]=e;rQa(d,c);return}function Itb(a){a=a|0;NXc(a);cYc(a);return}function Jtb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Ktb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==431273?a+12|0:0)|0}function Ltb(a){a=a|0;cYc(a);return}function Mtb(a){a=a|0;MNa(a);cYc(a);return}function Ntb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+44|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=102664;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function Otb(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function Ptb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Qtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Rtb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Stb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ttb(a,b){a=a|0;b=b|0;return 0}function Utb(a,b,c){a=a|0;b=b|0;c=c|0;return}function Vtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function Wtb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=d1c(r|0,0,e|0,k|0)|0;g=g+1|0;o=k1c(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function Xtb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+L(+(+n[j+(b<<2)>>2]));n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Ytb(a){a=a|0;cYc(a);return}function Ztb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+L(+(+n[m+(g<<2)>>2]));n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function _tb(a,c){a=a|0;c=c|0;var d=0,e=0;d=$Xc(48)|0;qQa(d);f[d>>2]=102684;b[d+45>>0]=0;f[a>>2]=d;e=$Xc(16)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=102800;f[e+12>>2]=d;f[a+4>>2]=e;rQa(d,c);return}function $tb(a){a=a|0;NXc(a);cYc(a);return}function aub(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function bub(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==431617?a+12|0:0)|0}function cub(a){a=a|0;cYc(a);return}function dub(a){a=a|0;MNa(a);cYc(a);return}function eub(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+44|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=102828;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function fub(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function gub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function hub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function iub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function jub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function kub(a,b){a=a|0;b=b|0;return 0}function lub(a,b,c){a=a|0;b=b|0;c=c|0;return}function mub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function nub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=x1c(r|0,((r|0)<0)<<31>>31|0,5,0)|0;o=d1c(l|0,J|0,e|0,k|0)|0;g=g+1|0;l=k1c(0,o|0,32)|0;o=J;if(g>>>0>=j>>>0){h=o;i=l;q=3;break}else{e=l;k=o}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function oub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+W(+(+V(+-+L(+(+n[j+(b<<2)>>2])))+1.0));n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function pub(a){a=a|0;cYc(a);return}function qub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+W(+(+V(+-+L(+(+n[m+(g<<2)>>2])))+1.0));n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function rub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[431954]|0;b[e+1>>0]=b[431955]|0;b[e+2>>0]=b[431956]|0;b[e+3>>0]=b[431957]|0;b[e+4>>0]=b[431958]|0;b[e+5>>0]=0;h=LGa(c,e)|0;i=c+4|0;if((h|0)==(i|0))j=1.0;else j=+NGa(h+28|0,-1);if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[439436]|0;b[e+1>>0]=b[439437]|0;b[e+2>>0]=b[439438]|0;b[e+3>>0]=b[439439]|0;b[e+4>>0]=b[439440]|0;b[e+5>>0]=0;h=LGa(c,e)|0;if((h|0)==(i|0))k=1.0;else k=+NGa(h+28|0,-1);if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[431960]|0;b[e+1>>0]=b[431961]|0;b[e+2>>0]=b[431962]|0;b[e+3>>0]=b[431963]|0;b[e+4>>0]=b[431964]|0;b[e+5>>0]=0;h=LGa(c,e)|0;if((h|0)==(i|0))l=0.0;else l=+NGa(h+28|0,-1);if((b[g>>0]|0)<0)cYc(f[e>>2]|0);e=$Xc(72)|0;qQa(e);f[e>>2]=102848;b[e+68>>0]=0;n[e+56>>2]=j;n[e+60>>2]=k;n[e+64>>2]=l;f[a>>2]=e;g=$Xc(16)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=102964;f[g+12>>2]=e;f[a+4>>2]=g;rQa(e,c);n[e+44>>2]=j;n[e+48>>2]=k;n[e+52>>2]=l;u=d;return}function sub(a){a=a|0;NXc(a);cYc(a);return}function tub(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function uub(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==431966?a+12|0:0)|0}function vub(a){a=a|0;cYc(a);return}function wub(a){a=a|0;MNa(a);cYc(a);return}function xub(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+56|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=102992;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function yub(a,b){a=a|0;b=b|0;var c=0;if((b|0)!=2){c=(b|2|0)==3;return c|0}if(((f[a+40>>2]|0)+-1|0)>>>0>1){c=1;return c|0}c=+n[a+56>>2]==1.0;return c|0}function zub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Aub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Bub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Cub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Dub(a,b){a=a|0;b=b|0;return Jub(a+56|0,b)|0}function Eub(a,b,c){a=a|0;b=b|0;c=c|0;Iub(a+56|0,b,c);return}function Fub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function Gub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+16|0;e=c;g=f[d+4>>2]|0;h=f[d>>2]|0;d=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=c;return j|0}k=a+56|0;a=(g-h|0)/12|0;h=0;g=0;l=0;while(1){m=f[d+(h*12|0)+4>>2]|0;o=f[d+(h*12|0)>>2]|0;p=m-o|0;q=p>>2;r=o;if((r|0)!=(m|0)){if((p|0)<=-4){s=7;break}if((p|0)>0){p=0;m=1;while(1){o=Y(f[r+(p<<2)>>2]|0,m)|0;p=p+1|0;if((p|0)>=(q|0)){t=o;break}else m=o}}else t=1}else t=0;m=+n[k>>2]==1.0;q=x1c((m?2:10)|0,(m?0:0)|0,t|0,((t|0)<0)<<31>>31|0)|0;m=d1c(q|0,J|0,g|0,l|0)|0;h=h+1|0;q=k1c(0,m|0,32)|0;m=J;if(h>>>0>=a>>>0){i=m;j=q;s=3;break}else{g=q;l=m}}if((s|0)==3){J=i;u=c;return j|0}else if((s|0)==7){s=$Xc(80)|0;f[e>>2]=s;f[e+8>>2]=-2147483568;f[e+4>>2]=70;j=s;c=454543;i=j+70|0;do{b[j>>0]=b[c>>0]|0;j=j+1|0;c=c+1|0}while((j|0)<(i|0));b[s+70>>0]=0;vM(-215,e,454614,454620,161)}return 0}function Hub(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0;h=+n[a+60>>2];i=+n[a+64>>2];j=+n[a+56>>2];a=(d|0)>0&(f|0)<(g|0);if(j==1.0){if(a){k=c;l=f;m=b}else return;while(1){o=0;do{n[k+(o<<2)>>2]=i+h*+n[m+(o<<2)>>2];o=o+1|0}while((o|0)!=(d|0));l=l+1|0;if((l|0)==(g|0))break;else{k=k+(e<<2)|0;m=m+(e<<2)|0}}return}else{if(a){p=f;q=c;r=b}else return;while(1){b=0;do{s=+N(+(i+h*+n[r+(b<<2)>>2]),+j);n[q+(b<<2)>>2]=s;b=b+1|0}while((b|0)!=(d|0));p=p+1|0;if((p|0)==(g|0))break;else{q=q+(e<<2)|0;r=r+(e<<2)|0}}return}}function Iub(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;if(!(+n[a>>2]==1.0)){u=d;return}p[h>>3]=+n[a+4>>2];i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;o=g+48|0;q=g+44|0;f[q>>2]=o;f[o>>2]=0;f[g+52>>2]=0;f[e>>2]=1;r=e+4|0;f[r>>2]=1;S$(g,2,e,5);lR(g,h)|0;s=b+36|0;t=f[s>>2]|0;if((g|0)==(b|0)){v=g+36|0;if((t|0)!=0?(w=t+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0){V$(g);y=v}else y=v}else{if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)V$(b);f[s>>2]=0;t=b+16|0;v=b+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[v>>2]|0)>0){x=f[b+40>>2]|0;w=0;do{f[x+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[v>>2]|0))}f[b>>2]=f[g>>2];w=f[i>>2]|0;f[v>>2]=w;v=b+8|0;f[v>>2]=f[j>>2];f[b+12>>2]=f[g+12>>2];f[t>>2]=f[g+16>>2];f[b+20>>2]=f[g+20>>2];f[b+24>>2]=f[g+24>>2];f[b+28>>2]=f[g+28>>2];f[b+32>>2]=f[g+32>>2];t=g+36|0;f[s>>2]=f[t>>2];s=b+44|0;x=f[s>>2]|0;z=b+48|0;if((x|0)==(z|0)){A=w;B=x}else{wL(x);f[s>>2]=z;f[b+40>>2]=v;A=f[i>>2]|0;B=z}z=g+44|0;if((A|0)<3){A=f[z>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2]}else{f[s>>2]=f[z>>2];f[b+40>>2]=f[k>>2];f[z>>2]=o;f[k>>2]=j}f[g>>2]=1124007936;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));y=t}f[y>>2]=0;y=g+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[i>>2]|0)>0){y=f[k>>2]|0;k=0;do{f[y+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[q>>2]|0;if((i|0)!=(o|0))wL(i);p[h>>3]=+n[a+8>>2];a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[g>>2]=1124007936;a=g+4|0;i=g+8|0;o=g+40|0;l=a;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[o>>2]=i;q=g+48|0;k=g+44|0;f[k>>2]=q;f[q>>2]=0;f[g+52>>2]=0;f[e>>2]=1;f[r>>2]=1;S$(g,2,e,5);lR(g,h)|0;h=c+36|0;e=f[h>>2]|0;if((g|0)==(c|0)){r=g+36|0;if((e|0)!=0?(y=e+12|0,t=f[y>>2]|0,f[y>>2]=t+-1,(t|0)==1):0){V$(g);C=r}else C=r}else{if(e|0?(r=e+12|0,e=f[r>>2]|0,f[r>>2]=e+-1,(e|0)==1):0)V$(c);f[h>>2]=0;e=c+16|0;r=c+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[r>>2]|0)>0){t=f[c+40>>2]|0;y=0;do{f[t+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[r>>2]|0))}f[c>>2]=f[g>>2];y=f[a>>2]|0;f[r>>2]=y;r=c+8|0;f[r>>2]=f[i>>2];f[c+12>>2]=f[g+12>>2];f[e>>2]=f[g+16>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];e=g+36|0;f[h>>2]=f[e>>2];h=c+44|0;t=f[h>>2]|0;j=c+48|0;if((t|0)==(j|0)){D=y;E=t}else{wL(t);f[h>>2]=j;f[c+40>>2]=r;D=f[a>>2]|0;E=j}j=g+44|0;if((D|0)<3){D=f[j>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[h>>2]=f[j>>2];f[c+40>>2]=f[o>>2];f[j>>2]=q;f[o>>2]=i}f[g>>2]=1124007936;l=a;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));C=e}f[C>>2]=0;C=g+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[a>>2]|0)>0){C=f[o>>2]|0;o=0;do{f[C+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[k>>2]|0;if((a|0)!=(q|0))wL(a);u=d;return}function Jub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,L=0.0;c=u;u=u+112|0;d=c+56|0;e=c;if(+n[a>>2]!=1.0?+n[a+8>>2]!=0.0:0){g=0;u=c;return g|0}f[d>>2]=1124007936;h=d+4|0;i=d+8|0;j=d+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=d+48|0;o=d+44|0;f[o>>2]=m;f[m>>2]=0;f[d+52>>2]=0;f[e>>2]=1124007936;p=e+4|0;q=e+8|0;r=e+40|0;k=p;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[r>>2]=q;k=e+48|0;l=e+44|0;f[l>>2]=k;f[k>>2]=0;f[e+52>>2]=0;s=f[b>>2]|0;Ti[f[(f[s>>2]|0)+88>>2]&511](s,d,e);s=d+16|0;b=f[s>>2]|0;t=(b|0)==0;if(!t){v=f[h>>2]|0;if((v|0)<3)w=Y(f[d+12>>2]|0,f[i>>2]|0)|0;else{x=f[j>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if(!((v|0)==0|(w|0)==0)){B=v;C=16}else C=9}else C=9;if((C|0)==9)if(f[e+16>>2]|0){v=f[p>>2]|0;if((v|0)<3)D=Y(f[e+12>>2]|0,f[q>>2]|0)|0;else{w=f[r>>2]|0;z=0;y=1;while(1){x=Y(f[w+(z<<2)>>2]|0,y)|0;z=z+1|0;if((z|0)==(v|0)){D=x;break}else y=x}}if(!((v|0)==0|(D|0)==0)){B=f[h>>2]|0;C=16}else E=0}else E=0;if((C|0)==16){C=(B|0)<3;if(C)F=Y(f[d+12>>2]|0,f[i>>2]|0)|0;else{D=f[j>>2]|0;v=0;y=1;while(1){z=Y(f[D+(v<<2)>>2]|0,y)|0;v=v+1|0;if((v|0)==(B|0)){F=z;break}else y=z}}if(F>>>0<=1){F=f[p>>2]|0;y=(F|0)<3;if(y)G=Y(f[e+12>>2]|0,f[q>>2]|0)|0;else{v=f[r>>2]|0;D=0;z=1;while(1){w=Y(f[v+(D<<2)>>2]|0,z)|0;D=D+1|0;if((D|0)==(F|0)){G=w;break}else z=w}}if(G>>>0<=1){if(!t){if(C)H=Y(f[d+12>>2]|0,f[i>>2]|0)|0;else{i=f[j>>2]|0;C=0;t=1;while(1){G=Y(f[i+(C<<2)>>2]|0,t)|0;C=C+1|0;if((C|0)==(B|0)){H=G;break}else t=G}}if(!((B|0)==0|(H|0)==0))I=+n[b>>2];else I=1.0}else I=1.0;b=f[e+16>>2]|0;if(b){if(y)J=Y(f[e+12>>2]|0,f[q>>2]|0)|0;else{q=f[r>>2]|0;y=0;H=1;while(1){B=Y(f[q+(y<<2)>>2]|0,H)|0;y=y+1|0;if((y|0)==(F|0)){J=B;break}else H=B}}if(!((F|0)==0|(J|0)==0))K=+n[b>>2];else K=0.0}else K=0.0;b=a+4|0;L=I*+N(+(+n[b>>2]),+(+n[a>>2]));n[b>>2]=L;b=a+8|0;n[b>>2]=K+I*+n[b>>2];E=1}else E=0}else E=0}b=e+36|0;a=f[b>>2]|0;if(a|0?(J=a+12|0,a=f[J>>2]|0,f[J>>2]=a+-1,(a|0)==1):0)V$(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[p>>2]|0)>0){b=f[r>>2]|0;r=0;do{f[b+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[l>>2]|0;if((p|0)!=(k|0))wL(p);p=d+36|0;k=f[p>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)V$(d);f[p>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[h>>2]|0)>0){s=f[j>>2]|0;j=0;do{f[s+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[o>>2]|0;if((h|0)!=(m|0))wL(h);g=E;u=c;return g|0}function Kub(a){a=a|0;cYc(a);return}function Lub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;i=f[d+16>>2]|0;e=f[f[d+44>>2]>>2]|0;d=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;o=d+4|0;m=d+8|0;if((j|0)>0&(a|0)>0)q=0;else return;do{g=h+(Y(b,q)|0)+(c<<2)|0;p=i+(Y(e,q)|0)+(c<<2)|0;r=+n[o>>2];s=+n[m>>2];t=+n[d>>2];if(t==1.0){u=p;v=0;w=g;while(1){x=0;do{n[u+(x<<2)>>2]=s+r*+n[w+(x<<2)>>2];x=x+1|0}while((x|0)!=(a|0));v=v+1|0;if((v|0)==(j|0))break;else{u=u+(k<<2)|0;w=w+(k<<2)|0}}}else{w=0;u=p;v=g;while(1){x=0;do{y=+N(+(s+r*+n[v+(x<<2)>>2]),+t);n[u+(x<<2)>>2]=y;x=x+1|0}while((x|0)!=(a|0));w=w+1|0;if((w|0)==(j|0))break;else{u=u+(k<<2)|0;v=v+(k<<2)|0}}}q=q+1|0}while((q|0)!=(l|0));return}function Mub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+80|0;e=d+16|0;g=d;h=c+12|0;i=f[h>>2]|0;j=i;if(((f[c+16>>2]|0)-i|0)!=56){i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=24;k=i;l=432309;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[i+24>>0]=0;vM(-215,e,467262,429630,1246)}i=j+4|0;n=f[i>>2]|0;if((n|0)<3)o=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{p=f[j+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((o|0)==1){ENa(e,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=$Xc(16)|0;f[g>>2]=o;f[g+8>>2]=-2147483632;f[g+4>>2]=14;k=o;l=429299;m=k+14|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[o+14>>0]=0;OGa(e,g,f[(f[h>>2]|0)+16>>2]|0)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);Urb(g,e);f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];g=e+36|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);g=e+24|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);hx(e+12|0);QGa(e,f[e+4>>2]|0);u=d;return}g=$Xc(104)|0;f[e>>2]=f[j>>2];h=e+4|0;f[h>>2]=f[i>>2];o=e+8|0;f[o>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];l=e+16|0;f[l>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];k=e+36|0;m=f[j+36>>2]|0;f[k>>2]=m;r=e+40|0;f[r>>2]=o;o=e+48|0;n=e+44|0;f[n>>2]=o;f[o>>2]=0;f[e+52>>2]=0;if(m|0){q=m+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[i>>2]|0)<3){i=f[j+44>>2]|0;q=f[n>>2]|0;f[q>>2]=f[i>>2];f[q+4>>2]=f[i+4>>2]}else{f[h>>2]=0;U$(e,j)}Nub(g,e);j=g;i=$Xc(16)|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=103012;f[i+12>>2]=j;q=i;i=f[k>>2]|0;if(i|0?(m=i+12|0,i=f[m>>2]|0,f[m>>2]=i+-1,(i|0)==1):0)V$(e);f[k>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[h>>2]|0)>0){l=f[r>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[h>>2]|0))}h=f[n>>2]|0;if((h|0)!=(o|0))wL(h);rQa(g,c);f[a>>2]=j;f[a+4>>2]=q;u=d;return}function Nub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;qQa(a);f[a>>2]=103040;d=a+44|0;f[d>>2]=1124007936;e=a+48|0;g=a+52|0;h=a+56|0;i=a+60|0;j=a+64|0;k=a+68|0;l=a+72|0;m=a+76|0;n=a+80|0;o=a+84|0;p=e;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=g;p=a+92|0;q=a+88|0;f[q>>2]=p;f[p>>2]=0;f[a+96>>2]=0;b[a+100>>0]=0;if((d|0)==(c|0))return;a=c+36|0;p=f[a>>2]|0;if((p|0?(r=p+12|0,f[r>>2]=(f[r>>2]|0)+1,r=f[n>>2]|0,r|0):0)?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)V$(d);f[n>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[e>>2]|0)>0){r=f[o>>2]|0;o=0;do{f[r+(o<<2)>>2]=0;o=o+1|0;s=f[e>>2]|0}while((o|0)<(s|0));f[d>>2]=f[c>>2];if((s|0)<3)t=11;else t=13}else{f[d>>2]=f[c>>2];t=11}if((t|0)==11){s=f[c+4>>2]|0;if((s|0)<3){f[e>>2]=s;f[g>>2]=f[c+8>>2];f[h>>2]=f[c+12>>2];h=f[c+44>>2]|0;g=f[q>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else t=13}if((t|0)==13)U$(d,c);f[i>>2]=f[c+16>>2];f[j>>2]=f[c+20>>2];f[k>>2]=f[c+24>>2];f[l>>2]=f[c+28>>2];f[m>>2]=f[c+32>>2];f[n>>2]=f[a>>2];return}function Oub(a){a=a|0;NXc(a);cYc(a);return}function Pub(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Qub(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==432334?a+12|0:0)|0}function Rub(a){a=a|0;cYc(a);return}function Sub(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103040;b=a+44|0;c=a+80|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+60|0;b=a+48|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+84>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0)){MNa(a);return}wL(b);MNa(a);return}function Tub(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103040;b=a+44|0;c=a+80|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+60|0;b=a+48|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+84>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0)){MNa(a);cYc(a);return}wL(b);MNa(a);cYc(a);return}function Uub(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+64|0;h=g+40|0;i=g+28|0;j=g+8|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;a:do if((f[e>>2]|0)!=(d|0)){c=a+44|0;l=j+4|0;m=j+8|0;n=j+12|0;o=j+16|0;p=k+4|0;q=0;r=d;b:while(1){s=r;t=s+(q*56|0)|0;v=f[i>>2]|0;w=v+(q*56|0)|0;x=f[s+(q*56|0)+40>>2]|0;s=f[x+-4>>2]|0;y=f[v+(q*56|0)+40>>2]|0;if((s|0)!=(f[y+-4>>2]|0))break;if((s|0)==2){if((f[x>>2]|0)!=(f[y>>2]|0))break;if((f[x+4>>2]|0)!=(f[y+4>>2]|0))break}else if((s|0)>0){v=0;do{if((f[x+(v<<2)>>2]|0)!=(f[y+(v<<2)>>2]|0))break b;v=v+1|0}while((v|0)<(s|0))}s=f[t>>2]|0;v=s&4095;y=f[w>>2]|0;if(!((v|0)==5&((v|0)==(y&4095|0)&(s&16384&y|0)!=0)))break;y=i3()|0;f[j>>2]=103156;f[l>>2]=c;f[m>>2]=t;f[n>>2]=w;f[o>>2]=y;f[k>>2]=0;f[p>>2]=y;h3(k,j,+(y|0));q=q+1|0;r=f[h>>2]|0;if(q>>>0>=(((f[e>>2]|0)-r|0)/56|0)>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(128)|0;f[j>>2]=r;f[j+8>>2]=-2147483520;f[j+4>>2]=116;q=r;p=429513;o=q+116|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(o|0));b[r+116>>0]=0;vM(-215,j,456135,429630,213)}while(0);hx(i);hx(h);u=g;return}function Vub(a,b){a=a|0;b=b|0;return (b|2|0)==3|0}function Wub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Xub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Yub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Zub(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function _ub(a,b){a=a|0;b=b|0;return 0}function $ub(a,b,c){a=a|0;b=b|0;c=c|0;return}function avb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function bvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;a=c;e=f[d+4>>2]|0;g=f[d>>2]|0;d=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=c;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[d+(g*12|0)+4>>2]|0;m=f[d+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=d1c(r|0,0,e|0,k|0)|0;g=g+1|0;o=k1c(0,l|0,32)|0;l=J;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=c;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;c=454543;h=i+70|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function cvb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dvb(a+44|0,b,c,d,e,f,g);return}function dvb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;j=u;u=u+16|0;k=j;if((f[a>>2]&20479|0)!=16389){l=$Xc(48)|0;f[k>>2]=l;f[k+8>>2]=-2147483600;f[k+4>>2]=46;m=l;o=432551;p=m+46|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));b[l+46>>0]=0;vM(-215,k,473123,429630,1062)}l=f[a+16>>2]|0;if((h|0)>-1&(h|0)<(i|0)){q=f[a+4>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+40>>2]|0;a=0;t=1;while(1){v=Y(f[s+(a<<2)>>2]|0,t)|0;a=a+1|0;if((a|0)==(q|0)){r=v;break}else t=v}}if((r|0)>=(i|0)){if((e|0)>0){w=d;x=h;y=c}else{u=j;return}while(1){z=+n[l+(x<<2)>>2];c=0;do{A=+n[y+(c<<2)>>2];n[w+(c<<2)>>2]=!(A>=0.0)?z*A:A;c=c+1|0}while((c|0)!=(e|0));x=x+1|0;if((x|0)==(i|0))break;else{w=w+(g<<2)|0;y=y+(g<<2)|0}}u=j;return}}j=$Xc(64)|0;f[k>>2]=j;f[k+8>>2]=-2147483584;f[k+4>>2]=50;m=j;o=432598;p=m+50|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));b[j+50>>0]=0;vM(-215,k,473123,429630,1065)}function evb(a){a=a|0;cYc(a);return}function fvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+16>>2]|0;d=a+8|0;e=f[d>>2]|0;g=f[e+4>>2]|0;h=f[e+40>>2]|0;i=f[h>>2]|0;if((g|0)>1){j=f[h+4>>2]|0;if((g|0)==2){k=j;l=1;m=i}else{n=2;o=1;while(1){p=Y(f[h+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)>=(g|0)){k=j;l=p;m=i;break}else o=p}}}else{k=i;l=1;m=1}i=((c+-1+l|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,i)|0;o=Y(f[b+4>>2]|0,i)|0;if((m|0)<=0)return;i=a+12|0;b=a+4|0;a=(l>>>0<o>>>0?l:o)-c|0;o=0;j=e;while(1){e=(f[j+16>>2]|0)+(Y(f[f[j+44>>2]>>2]|0,o)|0)+(c<<2)|0;g=f[i>>2]|0;n=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,o)|0)+(c<<2)|0;dvb(f[b>>2]|0,e,n,a,l,0,k);n=o+1|0;if((n|0)==(m|0))break;o=n;j=f[d>>2]|0}return}function gvb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(168)|0;hvb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=103176;f[b+12>>2]=c;f[a+4>>2]=b;return}function hvb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0,ia=0;d=u;u=u+192|0;e=d+104|0;g=d+96|0;h=d+88|0;i=d+80|0;j=d+72|0;k=d+64|0;l=d+16|0;m=d+136|0;o=d;q=d+120|0;r=d+112|0;qQa(a);f[a>>2]=103204;s=a+44|0;t=a+48|0;v=a+52|0;w=a+56|0;x=a+60|0;y=a+64|0;z=a+68|0;A=a+72|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[s+28>>2]=0;f[a+92>>2]=1124007936;B=a+100|0;C=a+132|0;D=a+96|0;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[C>>2]=B;B=a+140|0;f[a+136>>2]=B;f[B>>2]=0;f[a+144>>2]=0;B=a+152|0;f[B>>2]=0;C=a+156|0;F=$Xc(16)|0;G=F+8|0;f[F>>2]=G;f[F+4>>2]=1;f[C>>2]=F;F=G;f[F>>2]=0;f[F+4>>2]=0;F=a+160|0;f[F>>2]=0;G=a+164|0;H=$Xc(16)|0;I=H+8|0;f[H>>2]=I;f[H+4>>2]=1;f[G>>2]=H;H=I;f[H>>2]=0;f[H+4>>2]=0;rQa(a,c);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;H=$Xc(16)|0;f[l>>2]=H;f[l+8>>2]=-2147483632;f[l+4>>2]=11;D=H;I=432976;E=D+11|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[H+11>>0]=0;H=LGa(c,l)|0;J=c+4|0;if((H|0)==(J|0))L=16;else{N=MGa(H+28|0,-1)|0;L=N}N=a+84|0;f[N>>2]=L;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;L=l+11|0;b[L>>0]=9;D=l;I=432988;E=D+9|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[l+9>>0]=0;H=LGa(c,l)|0;if((H|0)==(J|0))O=16;else{P=MGa(H+28|0,-1)|0;O=P}P=a+88|0;f[P>>2]=O;if((b[L>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;L=$Xc(16)|0;f[l>>2]=L;f[l+8>>2]=-2147483632;f[l+4>>2]=12;D=L;I=432998;E=D+12|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[L+12>>0]=0;L=LGa(c,l)|0;if((L|0)==(J|0))Q=6e3;else{O=MGa(L+28|0,-1)|0;Q=O}O=a+76|0;f[O>>2]=Q;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Q=$Xc(16)|0;f[l>>2]=Q;f[l+8>>2]=-2147483632;f[l+4>>2]=13;D=Q;I=433011;E=D+13|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[Q+13>>0]=0;Q=LGa(c,l)|0;if((Q|0)==(J|0))R=300;else{L=MGa(Q+28|0,-1)|0;R=L}L=a+80|0;f[L>>2]=R;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);R=l+11|0;b[R>>0]=10;D=l;I=433025;E=D+10|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[l+10>>0]=0;Q=LGa(c,l)|0;if((Q|0)==(J|0))S=.699999988079071;else S=+NGa(Q+28|0,-1);Q=a+148|0;n[Q>>2]=S;if((b[R>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;R=l+11|0;b[R>>0]=5;b[l>>0]=b[433036]|0;b[l+1>>0]=b[433037]|0;b[l+2>>0]=b[433038]|0;b[l+3>>0]=b[433039]|0;b[l+4>>0]=b[433040]|0;b[l+5>>0]=0;UGa(B,NIa(c,l)|0)|0;if((b[R>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;R=l+11|0;b[R>>0]=5;b[l>>0]=b[439436]|0;b[l+1>>0]=b[439437]|0;b[l+2>>0]=b[439438]|0;b[l+3>>0]=b[439439]|0;b[l+4>>0]=b[439440]|0;b[l+5>>0]=0;UGa(F,NIa(c,l)|0)|0;if((b[R>>0]|0)<0)cYc(f[l>>2]|0);f[m+4>>2]=0;f[m+8>>2]=0;R=m+4|0;f[m>>2]=R;D=m+12|0;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c=l+11|0;b[c>>0]=4;f[l>>2]=1885697139;b[l+4>>0]=0;bHa(m,l,N)|0;if((b[c>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c=l+11|0;b[c>>0]=4;f[l>>2]=1885957222;b[l+4>>0]=0;b[o>>0]=0;cHa(m,l,o)|0;if((b[c>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c=l+11|0;b[c>>0]=4;f[l>>2]=1885957219;b[l+4>>0]=0;b[o>>0]=0;cHa(m,l,o)|0;if((b[c>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c=$Xc(16)|0;f[l>>2]=c;f[l+8>>2]=-2147483632;f[l+4>>2]=15;D=c;I=447547;E=D+15|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[c+15>>0]=0;b[o>>0]=0;cHa(m,l,o)|0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c=l+11|0;b[c>>0]=6;b[l>>0]=b[455356]|0;b[l+1>>0]=b[455357]|0;b[l+2>>0]=b[455358]|0;b[l+3>>0]=b[455359]|0;b[l+4>>0]=b[455360]|0;b[l+5>>0]=b[455361]|0;b[l+6>>0]=0;p[o>>3]=+((f[P>>2]|0)>>>0)*.5/+((f[N>>2]|0)>>>0);dHa(m,l,o)|0;if((b[c>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c=l+11|0;b[c>>0]=8;N=l;f[N>>2]=1769103734;f[N+4>>2]=1701015137;b[l+8>>0]=0;N=$Xc(16)|0;f[N>>2]=N+8;f[N+4>>2]=4;J=bYc(32)|0;f[N>>2]=J;f[o>>2]=2;f[o+4>>2]=N;p[J>>3]=.10000000149011612;p[J+8>>3]=.10000000149011612;p[J+16>>3]=.20000000298023224;p[J+24>>3]=.20000000298023224;$Ga(m,l,o)|0;RGa(o);if((b[c>>0]|0)<0)cYc(f[l>>2]|0);f[o>>2]=0;c=o+4|0;f[c>>2]=0;f[o+8>>2]=0;f[q>>2]=0;J=q+4|0;f[J>>2]=0;f[q+8>>2]=0;N=f[B>>2]|0;switch(N|0){case 0:{T=(f[C>>2]|0)+4|0;break}case 3:{T=(f[a+156>>2]|0)+4|0;break}case 2:{T=(f[a+156>>2]|0)+4|0;break}default:{f[k>>2]=N;DM(l,455363,k);vM(-3,l,470867,455383,297)}}k=f[T>>2]|0;T=f[F>>2]|0;switch(T|0){case 0:{U=(f[G>>2]|0)+4|0;break}case 3:{U=(f[a+164>>2]|0)+4|0;break}case 2:{U=(f[a+164>>2]|0)+4|0;break}default:{f[j>>2]=T;DM(l,455363,j);vM(-3,l,470867,455383,297)}}mvb(o,Y(f[U>>2]|0,k)|0);k=f[B>>2]|0;switch(k|0){case 0:{V=(f[C>>2]|0)+4|0;break}case 3:{V=(f[a+156>>2]|0)+4|0;break}case 2:{V=(f[a+156>>2]|0)+4|0;break}default:{f[i>>2]=k;DM(l,455363,i);vM(-3,l,470867,455383,297)}}i=f[V>>2]|0;V=f[F>>2]|0;switch(V|0){case 0:{W=(f[G>>2]|0)+4|0;break}case 3:{W=(f[a+164>>2]|0)+4|0;break}case 2:{W=(f[a+164>>2]|0)+4|0;break}default:{f[h>>2]=V;DM(l,455363,h);vM(-3,l,470867,455383,297)}}mvb(q,Y(f[W>>2]|0,i)|0);i=o+8|0;W=q+8|0;h=a+164|0;V=a+156|0;a=0;a:while(1){X=f[B>>2]|0;switch(X|0){case 0:{Z=(f[C>>2]|0)+4|0;break}case 3:{Z=(f[V>>2]|0)+4|0;break}case 2:{Z=(f[V>>2]|0)+4|0;break}default:{_=62;break a}}if((a|0)>=(f[Z>>2]|0)){_=64;break}S=+NGa(B,a);k=0;while(1){$=f[F>>2]|0;switch($|0){case 0:{aa=(f[G>>2]|0)+4|0;break}case 3:{aa=(f[h>>2]|0)+4|0;break}case 2:{aa=(f[h>>2]|0)+4|0;break}default:{_=70;break a}}if((k|0)>=(f[aa>>2]|0))break;ba=+NGa(F,k);ca=+K(+(+((f[P>>2]|0)>>>0)/+M(+S)+.5));da=+K(+(S*ca+.5));ea=ba*ca;n[l>>2]=ea;U=f[c>>2]|0;if(U>>>0<(f[i>>2]|0)>>>0){n[U>>2]=ea;f[c>>2]=U+4}else MA(o,l);ea=ba*da;n[l>>2]=ea;U=f[J>>2]|0;if(U>>>0<(f[W>>2]|0)>>>0){n[U>>2]=ea;f[J>>2]=U+4}else MA(q,l);k=k+1|0}a=a+1|0}if((_|0)==62){f[g>>2]=X;DM(l,455363,g);vM(-3,l,470867,455383,297)}else if((_|0)==64){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;g=l+11|0;b[g>>0]=5;b[l>>0]=b[471037]|0;b[l+1>>0]=b[471038]|0;b[l+2>>0]=b[471039]|0;b[l+3>>0]=b[471040]|0;b[l+4>>0]=b[471041]|0;b[l+5>>0]=0;X=f[o>>2]|0;a=(f[c>>2]|0)-X|0;W=a>>2;i=$Xc(16)|0;P=i+8|0;f[i>>2]=P;f[i+4>>2]=W;if(W>>>0>1){F=bYc(W>>>0>536870911?-1:W<<3)|0;f[i>>2]=F;fa=F}else fa=P;f[r>>2]=2;f[r+4>>2]=i;if((a|0)>0){a=X;X=0;while(1){p[fa+(X<<3)>>3]=+n[a>>2];X=X+1|0;if((X|0)==(W|0))break;else a=a+4|0}}$Ga(m,l,r)|0;RGa(r);if((b[g>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;g=l+11|0;b[g>>0]=6;b[l>>0]=b[471030]|0;b[l+1>>0]=b[471031]|0;b[l+2>>0]=b[471032]|0;b[l+3>>0]=b[471033]|0;b[l+4>>0]=b[471034]|0;b[l+5>>0]=b[471035]|0;b[l+6>>0]=0;a=f[q>>2]|0;W=(f[J>>2]|0)-a|0;X=W>>2;fa=$Xc(16)|0;i=fa+8|0;f[fa>>2]=i;f[fa+4>>2]=X;if(X>>>0>1){P=bYc(X>>>0>536870911?-1:X<<3)|0;f[fa>>2]=P;ga=P}else ga=i;f[r>>2]=2;f[r+4>>2]=fa;if((W|0)>0){W=a;a=0;while(1){p[ga+(a<<3)>>3]=+n[W>>2];a=a+1|0;if((a|0)==(X|0))break;else W=W+4|0}}$Ga(m,l,r)|0;RGa(r);if((b[g>>0]|0)<0)cYc(f[l>>2]|0);mzb(l,m);g=f[l>>2]|0;r=l+4|0;W=f[r>>2]|0;if(W|0)TXc(W);f[s>>2]=g;g=f[t>>2]|0;f[t>>2]=W;if(g|0)UXc(g);g=f[r>>2]|0;if(g|0)UXc(g);g=f[q>>2]|0;if(g|0){q=f[J>>2]|0;if((q|0)!=(g|0))f[J>>2]=q+(~((q+-4-g|0)>>>2)<<2);cYc(g)}g=f[o>>2]|0;if(g|0){q=f[c>>2]|0;if((q|0)!=(g|0))f[c>>2]=q+(~((q+-4-g|0)>>>2)<<2);cYc(g)}g=m+36|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);g=m+24|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);hx(m+12|0);QGa(m,f[R>>2]|0);f[l+4>>2]=0;f[l+8>>2]=0;R=l+4|0;f[l>>2]=R;D=l+12|0;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=m+11|0;b[g>>0]=5;b[m>>0]=b[450562]|0;b[m+1>>0]=b[450563]|0;b[m+2>>0]=b[450564]|0;b[m+3>>0]=b[450565]|0;b[m+4>>0]=b[450566]|0;b[m+5>>0]=0;q=$Xc(16)|0;f[q>>2]=q+8;f[q+4>>2]=4;c=bYc(32)|0;f[q>>2]=c;f[o>>2]=0;f[o+4>>2]=q;q=c;f[q>>2]=0;f[q+4>>2]=0;q=c+8|0;f[q>>2]=2;f[q+4>>2]=0;q=c+16|0;f[q>>2]=3;f[q+4>>2]=0;q=c+24|0;f[q>>2]=1;f[q+4>>2]=0;$Ga(l,m,o)|0;RGa(o);if((b[g>>0]|0)<0)cYc(f[m>>2]|0);iDb(m,l);g=f[m>>2]|0;q=m+4|0;c=f[q>>2]|0;if(c|0)TXc(c);f[x>>2]=g;g=f[y>>2]|0;f[y>>2]=c;if(g|0)UXc(g);g=f[q>>2]|0;if(g|0)UXc(g);iDb(m,l);g=f[m>>2]|0;q=m+4|0;c=f[q>>2]|0;if(c|0)TXc(c);f[z>>2]=g;g=f[A>>2]|0;f[A>>2]=c;if(g|0)UXc(g);g=f[q>>2]|0;if(g|0)UXc(g);g=l+36|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);g=l+24|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);hx(l+12|0);QGa(l,f[R>>2]|0);f[l+4>>2]=0;f[l+8>>2]=0;R=l+4|0;f[l>>2]=R;D=l+12|0;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=m+11|0;b[g>>0]=9;D=m;I=447728;E=D+9|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[m+9>>0]=0;nvb(l,m,447750)|0;if((b[g>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=$Xc(16)|0;f[m>>2]=g;f[m+8>>2]=-2147483632;f[m+4>>2]=11;D=g;I=447415;E=D+11|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[g+11>>0]=0;f[o>>2]=1;aHa(l,m,o)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=$Xc(16)|0;f[m>>2]=g;f[m+8>>2]=-2147483632;f[m+4>>2]=14;D=g;I=447427;E=D+14|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[g+14>>0]=0;b[o>>0]=1;cHa(l,m,o)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=$Xc(32)|0;f[m>>2]=g;f[m+8>>2]=-2147483616;f[m+4>>2]=19;D=g;I=447442;E=D+19|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[g+19>>0]=0;f[o>>2]=1;aHa(l,m,o)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=$Xc(32)|0;f[m>>2]=g;f[m+8>>2]=-2147483616;f[m+4>>2]=26;D=g;I=447462;E=D+26|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[g+26>>0]=0;b[o>>0]=1;cHa(l,m,o)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);g=m+11|0;b[g>>0]=10;D=m;I=447489;E=D+10|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[m+10>>0]=0;bHa(l,m,L)|0;if((b[g>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=m+11|0;b[g>>0]=5;b[m>>0]=b[447521]|0;b[m+1>>0]=b[447522]|0;b[m+2>>0]=b[447523]|0;b[m+3>>0]=b[447524]|0;b[m+4>>0]=b[447525]|0;b[m+5>>0]=0;bHa(l,m,O)|0;if((b[g>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=$Xc(16)|0;f[m>>2]=g;f[m+8>>2]=-2147483632;f[m+4>>2]=13;D=g;I=447580;E=D+13|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[g+13>>0]=0;OGa(l,m,Q)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;Q=$Xc(16)|0;f[m>>2]=Q;f[m+8>>2]=-2147483632;f[m+4>>2]=15;D=Q;I=447547;E=D+15|0;do{b[D>>0]=b[I>>0]|0;D=D+1|0;I=I+1|0}while((D|0)<(E|0));b[Q+15>>0]=0;b[o>>0]=0;cHa(l,m,o)|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;Q=m+11|0;b[Q>>0]=4;f[m>>2]=1885957219;b[m+4>>0]=0;b[o>>0]=1;cHa(l,m,o)|0;if((b[Q>>0]|0)<0)cYc(f[m>>2]|0);wBb(m,l);Q=f[m>>2]|0;o=m+4|0;m=f[o>>2]|0;if(m|0)TXc(m);f[v>>2]=Q;Q=f[w>>2]|0;f[w>>2]=m;if(Q|0)UXc(Q);Q=f[o>>2]|0;if(Q|0)UXc(Q);Q=l+36|0;if((b[Q+11>>0]|0)<0)cYc(f[Q>>2]|0);Q=l+24|0;if((b[Q+11>>0]|0)>=0){ha=l+12|0;hx(ha);ia=f[R>>2]|0;QGa(l,ia);u=d;return}cYc(f[Q>>2]|0);ha=l+12|0;hx(ha);ia=f[R>>2]|0;QGa(l,ia);u=d;return}else if((_|0)==70){f[e>>2]=$;DM(l,455363,e);vM(-3,l,470867,455383,297)}}function ivb(a){a=a|0;NXc(a);cYc(a);return}function jvb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function kvb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==432815?a+12|0:0)|0}function lvb(a){a=a|0;cYc(a);return}function mvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>2;i=$Xc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;cYc(d);return}function nvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;tYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;tYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function ovb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103204;RGa(a+160|0);RGa(a+152|0);b=a+92|0;c=a+128|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+108|0;b=a+96|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+132>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+136>>2]|0;if((b|0)!=(a+140|0))wL(b);b=f[a+72>>2]|0;if(b|0)UXc(b);b=f[a+64>>2]|0;if(b|0)UXc(b);b=f[a+56>>2]|0;if(b|0)UXc(b);b=f[a+48>>2]|0;if(!b){MNa(a);return}UXc(b);MNa(a);return}function pvb(a){a=a|0;ovb(a);cYc(a);return}function qvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+192|0;e=d+168|0;g=d+152|0;h=d+140|0;i=d+128|0;j=d+72|0;k=d+16|0;l=d;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;gS(c,g);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;wvb(j,f[g>>2]|0);xvb(h,1,j);c=j+40|0;m=f[c>>2]|0;n=f[m+8>>2]|0;o=f[m+12>>2]|0;p=f[m+4>>2]|0;f[e>>2]=f[m>>2];m=e+4|0;f[m>>2]=n;n=e+8|0;f[n>>2]=o;o=e+12|0;f[o>>2]=p;f[l>>2]=0;p=l+4|0;f[p>>2]=0;f[l+8>>2]=0;q=e+16|0;gOa(l,e,q);r=f[l>>2]|0;s=f[p>>2]|0;a:do if((r|0)==(s|0)){t=r;v=4}else{w=r;do{if((f[w>>2]|0)<0){t=w;v=4;break a}w=w+4|0}while((w|0)!=(s|0))}while(0);if((v|0)==4?(t|0)!=(s|0):0){r=t+4|0;if((r|0)==(s|0)){x=s;y=t}else{w=r;r=t;while(1){t=f[w>>2]|0;if((t|0)<0)z=r;else{f[r>>2]=t;z=r+4|0}w=w+4|0;if((w|0)==(s|0))break;else r=z}x=f[p>>2]|0;y=z}if((y|0)!=(x|0))f[p>>2]=x+(~((x+-4-y|0)>>>2)<<2)}f[k>>2]=1124007936;y=k+4|0;x=k+8|0;z=k+40|0;r=y;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[z>>2]=x;x=k+48|0;w=k+44|0;f[w>>2]=x;f[x>>2]=0;f[k+52>>2]=0;T$(k,l,5);xvb(i,1,k);t=k+36|0;A=f[t>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)V$(k);f[t>>2]=0;t=k+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[y>>2]|0)>0){t=f[z>>2]|0;z=0;do{f[t+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[w>>2]|0;if((y|0)!=(x|0))wL(y);y=f[l>>2]|0;if(y|0){x=f[p>>2]|0;if((x|0)!=(y|0))f[p>>2]=x+(~((x+-4-y|0)>>>2)<<2);cYc(y)}sQa(f[a+68>>2]|0,h,i);y=f[g>>2]|0;if((f[y+60>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;x=$Xc(32)|0;f[e>>2]=x;f[e+8>>2]=-2147483616;f[e+4>>2]=20;r=x;p=433363;s=r+20|0;do{b[r>>0]=b[p>>0]|0;r=r+1|0;p=p+1|0}while((r|0)<(s|0));b[x+20>>0]=0;vM(-215,e,455619,433061,157)}xvb(h,1,y+56|0);x=f[y+96>>2]|0;y=f[x+8>>2]|0;p=f[x+12>>2]|0;w=f[x+4>>2]|0;f[e>>2]=f[x>>2];f[m>>2]=y;f[n>>2]=p;f[o>>2]=w;f[l>>2]=0;w=l+4|0;f[w>>2]=0;f[l+8>>2]=0;gOa(l,e,q);q=f[l>>2]|0;e=f[w>>2]|0;b:do if((q|0)==(e|0)){C=q;v=29}else{o=q;do{if((f[o>>2]|0)<0){C=o;v=29;break b}o=o+4|0}while((o|0)!=(e|0))}while(0);if((v|0)==29?(C|0)!=(e|0):0){v=C+4|0;if((v|0)==(e|0)){D=e;E=C}else{q=v;v=C;while(1){C=f[q>>2]|0;if((C|0)<0)F=v;else{f[v>>2]=C;F=v+4|0}q=q+4|0;if((q|0)==(e|0))break;else v=F}D=f[w>>2]|0;E=F}if((E|0)!=(D|0))f[w>>2]=D+(~((D+-4-E|0)>>>2)<<2)}f[k>>2]=1124007936;E=k+4|0;D=k+8|0;F=k+40|0;r=E;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[F>>2]=D;D=k+48|0;r=k+44|0;f[r>>2]=D;f[D>>2]=0;f[k+52>>2]=0;T$(k,l,5);xvb(i,1,k);s=k+36|0;v=f[s>>2]|0;if(v|0?(e=v+12|0,v=f[e>>2]|0,f[e>>2]=v+-1,(v|0)==1):0)V$(k);f[s>>2]=0;s=k+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[E>>2]|0)>0){s=f[F>>2]|0;F=0;do{f[s+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[E>>2]|0))}E=f[r>>2]|0;if((E|0)!=(D|0))wL(E);E=f[l>>2]|0;if(E|0){l=f[w>>2]|0;if((l|0)!=(E|0))f[w>>2]=l+(~((l+-4-E|0)>>>2)<<2);cYc(E)}sQa(f[a+60>>2]|0,h,i);a=j+36|0;E=f[a>>2]|0;if(E|0?(l=E+12|0,E=f[l>>2]|0,f[l>>2]=E+-1,(E|0)==1):0)V$(j);f[a>>2]=0;a=j+16|0;E=j+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[E>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[E>>2]|0))}E=f[j+44>>2]|0;if((E|0)==(j+48|0)){hx(i);hx(h);hx(g);u=d;return}wL(E);hx(i);hx(h);hx(g);u=d;return}function rvb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;g=u;u=u+320|0;h=g+264|0;i=g;j=g+248|0;k=g+236|0;l=g+224|0;m=g+212|0;o=g+200|0;q=g+144|0;r=g+88|0;s=g+72|0;t=g+16|0;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[j>>2]=0;v=j+4|0;f[v>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[l>>2]=0;w=l+4|0;f[w>>2]=0;f[l+8>>2]=0;gS(c,j);gS(d,k);gS(e,l);e=f[j>>2]|0;d=e;if(((f[v>>2]|0)-e|0)!=168){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=18;x=e;y=433042;z=x+18|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[e+18>>0]=0;vM(-215,h,456135,433061,268)}e=f[l>>2]|0;v=e;if(((f[w>>2]|0)-e|0)!=168){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=21;x=e;y=433231;z=x+21|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[e+21>>0]=0;vM(-215,h,456135,433061,269)}e=d+56|0;w=v+56|0;c=v+112|0;A=f[d+116>>2]|0;if((A|0)<3)B=Y(f[d+124>>2]|0,f[d+120>>2]|0)|0;else{C=f[d+152>>2]|0;D=0;E=1;while(1){F=Y(f[C+(D<<2)>>2]|0,E)|0;D=D+1|0;if((D|0)==(A|0)){B=F;break}else E=F}}if(B>>>0<=1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=$Xc(32)|0;f[h>>2]=B;f[h+8>>2]=-2147483616;f[h+4>>2]=19;x=B;y=433253;z=x+19|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[B+19>>0]=0;vM(-215,h,456135,433061,277)}B=a+92|0;E=f[d+128>>2]|0;G=+n[E>>2];do if((f[d+112>>2]&16384|0)==0?(A=f[d+152>>2]|0,(f[A>>2]|0)!=1):0){D=f[f[d+156>>2]>>2]|0;if((f[A+4>>2]|0)==1){H=E+D|0;break}else{A=f[d+124>>2]|0;C=(A+1|0)>>>0<3?A:0;H=E+(Y(C,D)|0)+(1-(Y(C,A)|0)<<2)|0;break}}else I=15;while(0);if((I|0)==15)H=E+4|0;E=~~+n[H>>2];f[h>>2]=1;f[h+4>>2]=1;f[h+8>>2]=~~G;f[h+12>>2]=E;f[i>>2]=0;E=i+4|0;f[E>>2]=0;f[i+8>>2]=0;gOa(i,h,h+16|0);H=f[i>>2]|0;A=f[E>>2]|0;a:do if((H|0)==(A|0)){J=H;I=22}else{C=H;do{if((f[C>>2]|0)<0){J=C;I=22;break a}C=C+4|0}while((C|0)!=(A|0))}while(0);if((I|0)==22?(J|0)!=(A|0):0){H=J+4|0;if((H|0)==(A|0)){K=A;L=J}else{C=H;H=J;while(1){J=f[C>>2]|0;if((J|0)<0)M=H;else{f[H>>2]=J;M=H+4|0}C=C+4|0;if((C|0)==(A|0))break;else H=M}K=f[E>>2]|0;L=M}if((L|0)!=(K|0))f[E>>2]=K+(~((K+-4-L|0)>>>2)<<2)}T$(B,i,0);L=f[i>>2]|0;if(L|0){K=f[E>>2]|0;if((K|0)!=(L|0))f[E>>2]=K+(~((K+-4-L|0)>>>2)<<2);cYc(L)}f[m>>2]=0;L=m+4|0;f[L>>2]=0;f[m+8>>2]=0;K=$Xc(112)|0;f[m>>2]=K;f[m+8>>2]=K+112;f[K>>2]=1124007936;E=K+8|0;M=K+40|0;x=K+4|0;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[M>>2]=E;E=K+48|0;f[K+44>>2]=E;f[E>>2]=0;f[K+52>>2]=0;f[K+56>>2]=1124007936;E=K+64|0;M=K+96|0;x=K+60|0;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[M>>2]=E;E=K+104|0;f[K+100>>2]=E;f[E>>2]=0;f[K+108>>2]=0;f[L>>2]=K+112;lOa(o,1,v);K=f[m>>2]|0;if((K|0)==(d|0))N=d;else{L=d+36|0;E=f[L>>2]|0;if(E|0){M=E+12|0;f[M>>2]=(f[M>>2]|0)+1}M=K+36|0;E=f[M>>2]|0;if(E|0?(H=E+12|0,E=f[H>>2]|0,f[H>>2]=E+-1,(E|0)==1):0)V$(K);f[M>>2]=0;E=K+16|0;H=K+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[H>>2]|0)>0){A=f[K+40>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0;O=f[H>>2]|0}while((C|0)<(O|0));f[K>>2]=f[d>>2];if((O|0)<3)I=45;else I=47}else{f[K>>2]=f[d>>2];I=45}if((I|0)==45){O=f[d+4>>2]|0;if((O|0)<3){f[H>>2]=O;f[K+8>>2]=f[d+8>>2];f[K+12>>2]=f[d+12>>2];O=f[d+44>>2]|0;H=f[K+44>>2]|0;f[H>>2]=f[O>>2];f[H+4>>2]=f[O+4>>2]}else I=47}if((I|0)==47)U$(K,d);f[E>>2]=f[d+16>>2];f[K+20>>2]=f[d+20>>2];f[K+24>>2]=f[d+24>>2];f[K+28>>2]=f[d+28>>2];f[K+32>>2]=f[d+32>>2];f[M>>2]=f[L>>2];N=f[m>>2]|0}L=N+56|0;if((L|0)!=(B|0)){M=a+128|0;K=f[M>>2]|0;if(K|0){E=K+12|0;f[E>>2]=(f[E>>2]|0)+1}E=N+92|0;K=f[E>>2]|0;if(K|0?(O=K+12|0,K=f[O>>2]|0,f[O>>2]=K+-1,(K|0)==1):0)V$(L);f[E>>2]=0;K=N+72|0;O=N+60|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[O>>2]|0)>0){H=f[N+96>>2]|0;C=0;do{f[H+(C<<2)>>2]=0;C=C+1|0;P=f[O>>2]|0}while((C|0)<(P|0));f[L>>2]=f[B>>2];if((P|0)<3)I=60;else I=62}else{f[L>>2]=f[B>>2];I=60}if((I|0)==60){P=f[a+96>>2]|0;if((P|0)<3){f[O>>2]=P;f[N+64>>2]=f[a+100>>2];f[N+68>>2]=f[a+104>>2];P=f[a+136>>2]|0;O=f[N+100>>2]|0;f[O>>2]=f[P>>2];f[O+4>>2]=f[P+4>>2]}else I=62}if((I|0)==62)U$(L,B);f[K>>2]=f[a+108>>2];f[N+76>>2]=f[a+112>>2];f[N+80>>2]=f[a+116>>2];f[N+84>>2]=f[a+120>>2];f[N+88>>2]=f[a+124>>2];f[E>>2]=f[M>>2]}M=f[a+44>>2]|0;E=f[(f[M>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;N=i+8|0;f[N>>2]=0;f[N+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;N=q+8|0;f[N>>2]=0;f[N+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[E&511](M,h,i,q);wvb(h,d);xvb(m,1,h);d=h+36|0;M=f[d>>2]|0;if(M|0?(E=M+12|0,M=f[E>>2]|0,f[E>>2]=M+-1,(M|0)==1):0)V$(h);f[d>>2]=0;d=h+16|0;M=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[M>>2]|0)>0){d=f[h+40>>2]|0;E=0;do{f[d+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[M>>2]|0))}M=f[h+44>>2]|0;if((M|0)!=(h+48|0))wL(M);xvb(o,1,w);M=f[a+68>>2]|0;E=f[(f[M>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;d=i+8|0;f[d>>2]=0;f[d+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[E&511](M,h,i,q);xvb(m,1,e);xvb(o,1,c);e=f[a+60>>2]|0;M=f[(f[e>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;E=i+8|0;f[E>>2]=0;f[E+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;E=q+8|0;f[E>>2]=0;f[E+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[M&511](e,h,i,q);hS(m,4);e=f[m>>2]|0;if((e|0)!=(c|0)){M=v+148|0;E=f[M>>2]|0;if(E|0){d=E+12|0;f[d>>2]=(f[d>>2]|0)+1}d=e+36|0;E=f[d>>2]|0;if(E|0?(N=E+12|0,E=f[N>>2]|0,f[N>>2]=E+-1,(E|0)==1):0)V$(e);f[d>>2]=0;E=e+16|0;N=e+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[N>>2]|0)>0){K=f[e+40>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0;Q=f[N>>2]|0}while((L|0)<(Q|0));f[e>>2]=f[c>>2];if((Q|0)<3)I=83;else I=85}else{f[e>>2]=f[c>>2];I=83}if((I|0)==83){Q=f[v+116>>2]|0;if((Q|0)<3){f[N>>2]=Q;f[e+8>>2]=f[v+120>>2];f[e+12>>2]=f[v+124>>2];Q=f[v+156>>2]|0;N=f[e+44>>2]|0;f[N>>2]=f[Q>>2];f[N+4>>2]=f[Q+4>>2]}else I=85}if((I|0)==85)U$(e,c);f[E>>2]=f[v+128>>2];f[e+20>>2]=f[v+132>>2];f[e+24>>2]=f[v+136>>2];f[e+28>>2]=f[v+140>>2];f[e+32>>2]=f[v+144>>2];f[d>>2]=f[M>>2];M=f[m>>2]|0;if((M|0)==(v|0))R=v;else{S=M;I=87}}else{S=c;I=87}if((I|0)==87){c=S+56|0;M=v+92|0;d=f[M>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=S+92|0;d=f[e>>2]|0;if(d|0?(E=d+12|0,d=f[E>>2]|0,f[E>>2]=d+-1,(d|0)==1):0)V$(c);f[e>>2]=0;d=S+72|0;E=S+60|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[E>>2]|0)>0){Q=f[S+96>>2]|0;N=0;do{f[Q+(N<<2)>>2]=0;N=N+1|0;T=f[E>>2]|0}while((N|0)<(T|0));f[c>>2]=f[w>>2];if((T|0)<3)I=97;else I=99}else{f[c>>2]=f[w>>2];I=97}if((I|0)==97){T=f[v+60>>2]|0;if((T|0)<3){f[E>>2]=T;f[S+64>>2]=f[v+64>>2];f[S+68>>2]=f[v+68>>2];T=f[v+100>>2]|0;E=f[S+100>>2]|0;f[E>>2]=f[T>>2];f[E+4>>2]=f[T+4>>2]}else I=99}if((I|0)==99)U$(c,w);f[d>>2]=f[v+72>>2];f[S+76>>2]=f[v+76>>2];f[S+80>>2]=f[v+80>>2];f[S+84>>2]=f[v+84>>2];f[S+88>>2]=f[v+88>>2];f[e>>2]=f[M>>2];R=f[m>>2]|0}M=R+112|0;if((M|0)==(v|0))U=R;else{e=v+36|0;S=f[e>>2]|0;if(S|0){d=S+12|0;f[d>>2]=(f[d>>2]|0)+1}d=R+148|0;S=f[d>>2]|0;if(S|0?(w=S+12|0,S=f[w>>2]|0,f[w>>2]=S+-1,(S|0)==1):0)V$(M);f[d>>2]=0;S=R+128|0;w=R+116|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[w>>2]|0)>0){c=f[R+152>>2]|0;T=0;do{f[c+(T<<2)>>2]=0;T=T+1|0;V=f[w>>2]|0}while((T|0)<(V|0));f[M>>2]=f[v>>2];if((V|0)<3)I=112;else I=114}else{f[M>>2]=f[v>>2];I=112}do if((I|0)==112){V=f[v+4>>2]|0;if((V|0)>=3){I=114;break}f[w>>2]=V;f[R+120>>2]=f[v+8>>2];f[R+124>>2]=f[v+12>>2];V=f[v+44>>2]|0;T=f[R+156>>2]|0;f[T>>2]=f[V>>2];f[T+4>>2]=f[V+4>>2]}while(0);if((I|0)==114)U$(M,v);f[S>>2]=f[v+16>>2];f[R+132>>2]=f[v+20>>2];f[R+136>>2]=f[v+24>>2];f[R+140>>2]=f[v+28>>2];f[R+144>>2]=f[v+32>>2];f[d>>2]=f[e>>2];U=f[m>>2]|0}e=U+168|0;if((e|0)!=(B|0)){d=a+128|0;v=f[d>>2]|0;if(v|0){R=v+12|0;f[R>>2]=(f[R>>2]|0)+1}R=U+204|0;v=f[R>>2]|0;do if(v|0){S=v+12|0;M=f[S>>2]|0;f[S>>2]=M+-1;if((M|0)!=1)break;V$(e)}while(0);f[R>>2]=0;v=U+184|0;M=U+172|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[M>>2]|0)>0){S=f[U+208>>2]|0;w=0;do{f[S+(w<<2)>>2]=0;w=w+1|0;W=f[M>>2]|0}while((w|0)<(W|0));f[e>>2]=f[B>>2];if((W|0)<3)I=127;else I=129}else{f[e>>2]=f[B>>2];I=127}do if((I|0)==127){W=f[a+96>>2]|0;if((W|0)>=3){I=129;break}f[M>>2]=W;f[U+176>>2]=f[a+100>>2];f[U+180>>2]=f[a+104>>2];W=f[a+136>>2]|0;w=f[U+212>>2]|0;f[w>>2]=f[W>>2];f[w+4>>2]=f[W+4>>2]}while(0);if((I|0)==129)U$(e,B);f[v>>2]=f[a+108>>2];f[U+188>>2]=f[a+112>>2];f[U+192>>2]=f[a+116>>2];f[U+196>>2]=f[a+120>>2];f[U+200>>2]=f[a+124>>2];f[R>>2]=f[d>>2]}f[h>>2]=1124007936;d=h+4|0;R=h+8|0;U=h+40|0;x=d;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[U>>2]=R;v=h+48|0;f[h+44>>2]=v;f[v>>2]=0;f[h+52>>2]=0;B=f[o>>2]|0;do if((B|0)==(h|0)){f[h+36>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0}else{e=B+36|0;I=f[e>>2]|0;do if(I|0){M=I+12|0;W=f[M>>2]|0;f[M>>2]=W+-1;if((W|0)!=1)break;V$(B)}while(0);f[e>>2]=0;I=B+16|0;W=B+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[W>>2]|0)>0){M=f[B+40>>2]|0;w=0;do{f[M+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[W>>2]|0))}f[B>>2]=f[h>>2];f[W>>2]=f[d>>2];w=B+8|0;f[w>>2]=f[R>>2];f[B+12>>2]=f[h+12>>2];f[I>>2]=f[h+16>>2];f[B+20>>2]=f[h+20>>2];f[B+24>>2]=f[h+24>>2];f[B+28>>2]=f[h+28>>2];f[B+32>>2]=f[h+32>>2];M=h+36|0;f[e>>2]=f[M>>2];S=B+44|0;V=f[S>>2]|0;T=B+48|0;if((V|0)==(T|0))X=V;else{wL(V);f[S>>2]=T;f[B+40>>2]=w;X=T}T=h+44|0;if((f[d>>2]|0)<3){w=f[T>>2]|0;f[X>>2]=f[w>>2];f[X+4>>2]=f[w+4>>2];Z=w}else{f[S>>2]=f[T>>2];f[B+40>>2]=f[U>>2];f[T>>2]=v;f[U>>2]=R;Z=v}f[h>>2]=1124007936;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[M>>2]=0;M=h+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((Z|0)==(v|0))break;wL(Z)}while(0);Z=f[a+52>>2]|0;v=f[(f[Z>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=m;d=i+8|0;f[d>>2]=0;f[d+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=o;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33882112;f[q+4>>2]=l;ei[v&511](Z,h,i,q);Z=f[o>>2]|0;v=f[Z+4>>2]|0;if((v|0)<3)_=Y(f[Z+12>>2]|0,f[Z+8>>2]|0)|0;else{d=f[Z+40>>2]|0;R=0;U=1;while(1){B=Y(f[d+(R<<2)>>2]|0,U)|0;R=R+1|0;if((R|0)==(v|0)){_=B;break}else U=B}}U=(_>>>0)/7|0;_=a+80|0;if(U>>>0>(f[_>>2]|0)>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=$Xc(32)|0;f[h>>2]=a;f[h+8>>2]=-2147483616;f[h+4>>2]=26;x=a;y=433273;z=x+26|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[a+26>>0]=0;vM(-215,h,456135,433061,311)}g0(h,Z,1,U);Z=f[o>>2]|0;do if((Z|0)==(h|0)){a=h+36|0;y=f[a>>2]|0;if(!y){$=a;break}v=y+12|0;y=f[v>>2]|0;f[v>>2]=y+-1;if((y|0)!=1){$=a;break}V$(h);$=a}else{a=Z+36|0;y=f[a>>2]|0;do if(y|0){v=y+12|0;R=f[v>>2]|0;f[v>>2]=R+-1;if((R|0)!=1)break;V$(Z)}while(0);f[a>>2]=0;y=Z+16|0;e=Z+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[e>>2]|0)>0){I=f[Z+40>>2]|0;W=0;do{f[I+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[e>>2]|0))}f[Z>>2]=f[h>>2];W=h+4|0;f[e>>2]=f[W>>2];I=h+8|0;R=Z+8|0;f[R>>2]=f[I>>2];f[Z+12>>2]=f[h+12>>2];f[y>>2]=f[h+16>>2];f[Z+20>>2]=f[h+20>>2];f[Z+24>>2]=f[h+24>>2];f[Z+28>>2]=f[h+28>>2];f[Z+32>>2]=f[h+32>>2];v=h+36|0;f[a>>2]=f[v>>2];d=Z+44|0;B=f[d>>2]|0;X=Z+48|0;if((B|0)==(X|0))aa=B;else{wL(B);f[d>>2]=X;f[Z+40>>2]=R;aa=X}X=h+44|0;if((f[W>>2]|0)<3){R=f[X>>2]|0;f[aa>>2]=f[R>>2];f[aa+4>>2]=f[R+4>>2]}else{f[d>>2]=f[X>>2];d=h+40|0;f[Z+40>>2]=f[d>>2];f[X>>2]=h+48;f[d>>2]=I}f[h>>2]=1124007936;x=W;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));$=v}while(0);f[$>>2]=0;$=h+16|0;x=h+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[x>>2]|0)>0){$=f[h+40>>2]|0;z=0;do{f[$+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)!=(h+48|0))wL(x);x=f[k>>2]|0;f[h>>2]=0;f[h+4>>2]=U;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;W$(q,x,h,i);x=f[o>>2]|0;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=3;f[i+4>>2]=7;W$(r,x,h,i);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=1;f[i+4>>2]=5;W$(t,q,h,i);x=s+8|0;f[x>>2]=0;f[x+4>>2]=0;f[s>>2]=-1040121856;f[s+4>>2]=t;jR(r,s);s=t+36|0;x=f[s>>2]|0;do if(x|0){z=x+12|0;$=f[z>>2]|0;f[z>>2]=$+-1;if(($|0)!=1)break;V$(t)}while(0);f[s>>2]=0;s=t+16|0;x=t+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[x>>2]|0)>0){s=f[t+40>>2]|0;$=0;do{f[s+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[x>>2]|0))}x=f[t+44>>2]|0;if((x|0)!=(t+48|0))wL(x);x=r+36|0;t=f[x>>2]|0;do if(t|0){$=t+12|0;s=f[$>>2]|0;f[$>>2]=s+-1;if((s|0)!=1)break;V$(r)}while(0);f[x>>2]=0;x=r+16|0;t=r+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[t>>2]|0)>0){x=f[r+40>>2]|0;s=0;do{f[x+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))wL(t);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=0;f[i+4>>2]=1;W$(r,q,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;mR(r,h,fT()|0)|0;t=r+36|0;s=f[t>>2]|0;do if(s|0){x=s+12|0;$=f[x>>2]|0;f[x>>2]=$+-1;if(($|0)!=1)break;V$(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;$=0;do{f[t+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))wL(s);s=(f[k>>2]|0)+56|0;f[h>>2]=0;f[h+4>>2]=U;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;W$(r,s,h,i);s=q+36|0;$=f[s>>2]|0;do if($|0){t=$+12|0;x=f[t>>2]|0;f[t>>2]=x+-1;if((x|0)!=1)break;V$(q)}while(0);f[s>>2]=0;$=q+16|0;x=q+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[x>>2]|0)>0){t=f[q+40>>2]|0;z=0;do{f[t+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}f[q>>2]=f[r>>2];z=r+4|0;t=f[z>>2]|0;f[x>>2]=t;Z=r+8|0;aa=q+8|0;f[aa>>2]=f[Z>>2];f[q+12>>2]=f[r+12>>2];a=r+16|0;f[$>>2]=f[a>>2];f[q+20>>2]=f[r+20>>2];f[q+24>>2]=f[r+24>>2];f[q+28>>2]=f[r+28>>2];f[q+32>>2]=f[r+32>>2];y=r+36|0;f[s>>2]=f[y>>2];e=q+44|0;W=f[e>>2]|0;I=q+48|0;if((W|0)==(I|0)){ba=t;ca=W}else{wL(W);f[e>>2]=I;f[q+40>>2]=aa;ba=f[z>>2]|0;ca=I}aa=r+44|0;if((ba|0)<3){ba=f[aa>>2]|0;f[ca>>2]=f[ba>>2];f[ca+4>>2]=f[ba+4>>2];da=ba}else{f[e>>2]=f[aa>>2];e=r+40|0;f[q+40>>2]=f[e>>2];ba=r+48|0;f[aa>>2]=ba;f[e>>2]=Z;da=ba}f[r>>2]=1124007936;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[y>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((da|0)!=(r+48|0))wL(da);da=f[o>>2]|0;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=2;f[i+4>>2]=3;W$(r,da,h,i);da=h+8|0;f[da>>2]=0;f[da+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;jR(r,h);da=r+36|0;a=f[da>>2]|0;do if(a|0){y=a+12|0;z=f[y>>2]|0;f[y>>2]=z+-1;if((z|0)!=1)break;V$(r)}while(0);f[da>>2]=0;da=r+16|0;a=r+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[a>>2]|0)>0){da=f[r+40>>2]|0;z=0;do{f[da+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[a>>2]|0))}a=f[r+44>>2]|0;if((a|0)!=(r+48|0))wL(a);a=f[_>>2]|0;if(U>>>0<a>>>0){z=h+4|0;da=i+4|0;y=h+8|0;ba=h+12|0;Z=h+4|0;e=r+36|0;aa=r+16|0;ca=r+4|0;W=r+40|0;t=r+44|0;d=r+48|0;X=f[k>>2]|0;f[h>>2]=U;f[z>>2]=a;f[i>>2]=-2147483648;f[da>>2]=2147483647;W$(r,X,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[Z>>2]=i;f[y>>2]=1;f[ba>>2]=1;mR(r,h,fT()|0)|0;X=f[e>>2]|0;do if(X|0){a=X+12|0;R=f[a>>2]|0;f[a>>2]=R+-1;if((R|0)!=1)break;V$(r)}while(0);f[e>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[ca>>2]|0)>0){X=f[W>>2]|0;R=0;do{f[X+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[ca>>2]|0))}R=f[t>>2]|0;if((R|0)!=(d|0))wL(R);R=(f[k>>2]|0)+56|0;X=f[_>>2]|0;f[h>>2]=U;f[z>>2]=X;f[i>>2]=-2147483648;f[da>>2]=2147483647;W$(r,R,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[Z>>2]=i;f[y>>2]=1;f[ba>>2]=1;mR(r,h,fT()|0)|0;h=f[e>>2]|0;do if(h|0){ba=h+12|0;y=f[ba>>2]|0;f[ba>>2]=y+-1;if((y|0)!=1)break;V$(r)}while(0);f[e>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[ca>>2]|0)>0){aa=f[W>>2]|0;W=0;do{f[aa+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[ca>>2]|0))}ca=f[t>>2]|0;if((ca|0)!=(d|0))wL(ca)}ca=f[s>>2]|0;do if(ca|0){d=ca+12|0;t=f[d>>2]|0;f[d>>2]=t+-1;if((t|0)!=1)break;V$(q)}while(0);f[s>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[x>>2]|0)>0){$=f[q+40>>2]|0;s=0;do{f[$+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[x>>2]|0))}x=f[q+44>>2]|0;if((x|0)!=(I|0))wL(x);hx(o);hx(m);hx(l);hx(k);hx(j);u=g;return}function svb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=(f[a+40>>2]|0)!=3;break}default:c=0}return c|0}function tvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function uvb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=u;u=u+80|0;h=d+64|0;i=d+48|0;j=d+36|0;k=d+24|0;l=d+12|0;m=d;n=f[c>>2]|0;o=n;if(((f[c+4>>2]|0)-n|0)!=36){c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=18;p=c;q=433042;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+18>>0]=0;vM(-215,h,456079,433061,102)}c=o+12|0;f[i>>2]=0;s=i+4|0;f[s>>2]=0;f[i+8>>2]=0;f[j>>2]=0;t=j+4|0;f[t>>2]=0;f[j+8>>2]=0;f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;eOa(i,1,o);w=f[a+44>>2]|0;_h[f[(f[w>>2]|0)+96>>2]&127](w,i,1,j,k)|0;w=f[j>>2]|0;x=w;if(((f[t>>2]|0)-w|0)!=12){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(32)|0;f[h>>2]=w;f[h+8>>2]=-2147483616;f[h+4>>2]=24;p=w;q=433143;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[w+24>>0]=0;vM(-215,h,456079,433061,112)}if((f[k>>2]|0)!=(f[v>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(32)|0;f[h>>2]=w;f[h+8>>2]=-2147483616;f[h+4>>2]=22;p=w;q=433168;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[w+22>>0]=0;vM(-215,h,456079,433061,113)}w=g+4|0;y=f[w>>2]|0;z=g+8|0;if((y|0)==(f[z>>2]|0))fKa(g,x);else{eKa(y,x);f[w>>2]=(f[w>>2]|0)+12}if(((f[o+4>>2]|0)-(f[n>>2]|0)|0)!=16){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;n=$Xc(32)|0;f[h>>2]=n;f[h+8>>2]=-2147483616;f[h+4>>2]=18;p=n;q=433191;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[n+18>>0]=0;vM(-215,h,456079,433061,117)}eKa(l,o);if(f[(f[o>>2]|0)+4>>2]&1|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=$Xc(32)|0;f[h>>2]=o;f[h+8>>2]=-2147483616;f[h+4>>2]=20;p=o;q=433210;r=p+20|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+20>>0]=0;vM(-215,h,456079,433061,119)}o=(f[l>>2]|0)+4|0;f[o>>2]=(f[o>>2]|0)/2|0;eOa(i,1,l);o=f[a+68>>2]|0;_h[f[(f[o>>2]|0)+96>>2]&127](o,i,1,j,k)|0;o=f[j>>2]|0;n=o;if(((f[t>>2]|0)-o|0)!=12){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=$Xc(32)|0;f[h>>2]=o;f[h+8>>2]=-2147483616;f[h+4>>2]=24;p=o;q=433143;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+24>>0]=0;vM(-215,h,456079,433061,123)}if((f[k>>2]|0)!=(f[v>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=$Xc(32)|0;f[h>>2]=o;f[h+8>>2]=-2147483616;f[h+4>>2]=22;p=o;q=433168;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+22>>0]=0;vM(-215,h,456079,433061,124)}o=f[w>>2]|0;if((o|0)==(f[z>>2]|0))fKa(g,n);else{eKa(o,n);f[w>>2]=(f[w>>2]|0)+12}eOa(i,1,c);c=f[a+60>>2]|0;_h[f[(f[c>>2]|0)+96>>2]&127](c,i,1,j,k)|0;c=f[j>>2]|0;n=c;if(((f[t>>2]|0)-c|0)!=12){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=24;p=c;q=433143;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+24>>0]=0;vM(-215,h,456079,433061,130)}if((f[k>>2]|0)!=(f[v>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=22;p=c;q=433168;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+22>>0]=0;vM(-215,h,456079,433061,131)}c=f[w>>2]|0;if((c|0)==(f[z>>2]|0))fKa(g,n);else{eKa(c,n);f[w>>2]=(f[w>>2]|0)+12}w=e+4|0;n=f[w>>2]|0;c=f[e>>2]|0;g=n-c|0;z=(g|0)/12|0;q=c;c=n;if(z>>>0>=2){if((g|0)!=24?(g=q+24|0,(c|0)!=(g|0)):0){q=c;while(1){c=q+-12|0;f[w>>2]=c;n=f[c>>2]|0;if(!n)A=c;else{c=q+-8|0;p=f[c>>2]|0;if((p|0)!=(n|0))f[c>>2]=p+(~((p+-4-n|0)>>>2)<<2);cYc(n);A=f[w>>2]|0}if((A|0)==(g|0))break;else q=A}}}else vvb(e,2-z|0);z=a+80|0;f[h>>2]=f[z>>2];a=h+4|0;f[a>>2]=5;A=h+8|0;f[A>>2]=-1;q=h+12|0;f[q>>2]=-1;f[m>>2]=0;g=m+4|0;f[g>>2]=0;f[m+8>>2]=0;w=h+16|0;gOa(m,h,w);n=f[m>>2]|0;p=f[g>>2]|0;c=n;r=p;a:do if((n|0)==(p|0)){B=n;C=40}else{o=n;while(1){if((f[o>>2]|0)<0){B=o;C=40;break a}o=o+4|0;if((o|0)==(p|0)){D=r;break}}}while(0);if((C|0)==40)if((B|0)!=(p|0)){n=B+4|0;if((n|0)==(p|0)){E=p;F=B;G=r}else{o=n;n=B;while(1){B=f[o>>2]|0;if((B|0)<0)H=n;else{f[n>>2]=B;H=n+4|0}o=o+4|0;if((o|0)==(p|0))break;else n=H}n=f[g>>2]|0;E=n;F=H;G=n}if((F|0)==(E|0))D=G;else{G=E+(~((E+-4-F|0)>>>2)<<2)|0;f[g>>2]=G;D=G}}else D=r;r=f[e>>2]|0;G=f[r>>2]|0;F=r+4|0;if(!G){I=r+8|0;J=c;K=D}else{D=f[F>>2]|0;if((D|0)!=(G|0))f[F>>2]=D+(~((D+-4-G|0)>>>2)<<2);cYc(G);G=r+8|0;f[G>>2]=0;f[F>>2]=0;f[r>>2]=0;I=G;J=f[m>>2]|0;K=f[g>>2]|0}f[r>>2]=J;f[F>>2]=K;f[I>>2]=f[m+8>>2];f[h>>2]=f[z>>2];f[a>>2]=1;f[A>>2]=-1;f[q>>2]=-1;f[m>>2]=0;q=m+4|0;f[q>>2]=0;f[m+8>>2]=0;gOa(m,h,w);w=f[m>>2]|0;h=f[q>>2]|0;A=w;a=h;b:do if((w|0)==(h|0)){L=w;C=56}else{z=w;while(1){if((f[z>>2]|0)<0){L=z;C=56;break b}z=z+4|0;if((z|0)==(h|0)){M=a;break}}}while(0);if((C|0)==56)if((L|0)!=(h|0)){C=L+4|0;if((C|0)==(h|0)){N=h;O=L;P=a}else{w=C;C=L;while(1){L=f[w>>2]|0;if((L|0)<0)Q=C;else{f[C>>2]=L;Q=C+4|0}w=w+4|0;if((w|0)==(h|0))break;else C=Q}C=f[q>>2]|0;N=C;O=Q;P=C}if((O|0)==(N|0))M=P;else{P=N+(~((N+-4-O|0)>>>2)<<2)|0;f[q>>2]=P;M=P}}else M=a;a=f[e>>2]|0;e=a+12|0;P=f[e>>2]|0;O=a+16|0;if(!P){R=a+20|0;S=A;T=M}else{M=f[O>>2]|0;if((M|0)!=(P|0))f[O>>2]=M+(~((M+-4-P|0)>>>2)<<2);cYc(P);P=a+20|0;f[P>>2]=0;f[O>>2]=0;f[e>>2]=0;R=P;S=f[m>>2]|0;T=f[q>>2]|0}f[e>>2]=S;f[O>>2]=T;f[R>>2]=f[m+8>>2];m=f[l>>2]|0;if(m|0){R=l+4|0;l=f[R>>2]|0;if((l|0)!=(m|0))f[R>>2]=l+(~((l+-4-m|0)>>>2)<<2);cYc(m)}m=f[k>>2]|0;if(m|0){l=f[v>>2]|0;if((l|0)==(m|0))U=m;else{R=l;while(1){l=R+-12|0;f[v>>2]=l;T=f[l>>2]|0;if(!T)V=l;else{l=R+-8|0;O=f[l>>2]|0;if((O|0)!=(T|0))f[l>>2]=O+(~((O+-4-T|0)>>>2)<<2);cYc(T);V=f[v>>2]|0}if((V|0)==(m|0))break;else R=V}U=f[k>>2]|0}cYc(U)}U=f[j>>2]|0;if(U|0){k=f[t>>2]|0;if((k|0)==(U|0))W=U;else{V=k;while(1){k=V+-12|0;f[t>>2]=k;R=f[k>>2]|0;if(!R)X=k;else{k=V+-8|0;m=f[k>>2]|0;if((m|0)!=(R|0))f[k>>2]=m+(~((m+-4-R|0)>>>2)<<2);cYc(R);X=f[t>>2]|0}if((X|0)==(U|0))break;else V=X}W=f[j>>2]|0}cYc(W)}W=f[i>>2]|0;if(!W){u=d;return 0}j=f[s>>2]|0;if((j|0)==(W|0))Y=W;else{X=j;while(1){j=X+-12|0;f[s>>2]=j;V=f[j>>2]|0;if(!V)Z=j;else{j=X+-8|0;U=f[j>>2]|0;if((U|0)!=(V|0))f[j>>2]=U+(~((U+-4-V|0)>>>2)<<2);cYc(V);Z=f[s>>2]|0}if((Z|0)==(W|0))break;else X=Z}Y=f[i>>2]|0}cYc(Y);u=d;return 0}function vvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=d;g=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=j+-12|0;b=i;i=i+-12|0;f[d>>2]=0;n=j+-8|0;f[n>>2]=0;f[j+-4>>2]=0;f[d>>2]=f[i>>2];d=b+-8|0;f[n>>2]=f[d>>2];n=b+-4|0;f[j+-4>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[i>>2]=0;j=h+-12|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=c;c=c+-12|0;m=f[c>>2]|0;if(m|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(m|0))f[e>>2]=q+(~((q+-4-m|0)>>>2)<<2);cYc(m)}}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function wvb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+256|0;e=d;if((f[c+4>>2]|0)!=4){g=$Xc(16)|0;f[e>>2]=g;f[e+8>>2]=-2147483632;f[e+4>>2]=11;h=g;i=433300;j=h+11|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+11>>0]=0;vM(-215,e,433312,433061,364)}g=f[c+40>>2]|0;if((f[g>>2]|0)!=1){k=$Xc(16)|0;f[e>>2]=k;f[e+8>>2]=-2147483632;f[e+4>>2]=14;h=k;i=433328;j=h+14|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[k+14>>0]=0;vM(-215,e,433312,433061,365)}k=f[g+4>>2]|0;if(!(k&1)){g1c(e|0,0,256)|0;g=e+16|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;g=e+24|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;g=e;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;g=e+8|0;f[g>>2]=(k|0)/2|0;f[g+4>>2]=k;X$(a,c,e);u=d;return}else{d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=19;h=d;i=433343;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[d+19>>0]=0;vM(-215,e,433312,433061,367)}}function xvb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+8|0;e=f[a>>2]|0;g=e;if((((f[d>>2]|0)-e|0)/56|0)>>>0<b>>>0){oNa(a);if(b>>>0>76695844)kWc(a);h=((f[d>>2]|0)-(f[a>>2]|0)|0)/56|0;i=h<<1;j=h>>>0<38347922?(i>>>0<b>>>0?b:i):76695844;if(j>>>0>76695844)kWc(a);i=$Xc(j*56|0)|0;h=a+4|0;f[h>>2]=i;f[a>>2]=i;f[d>>2]=i+(j*56|0);j=c+4|0;d=c+8|0;k=c+12|0;l=c+16|0;m=c+20|0;n=c+24|0;o=c+28|0;p=c+32|0;q=c+36|0;r=c+44|0;s=b;t=i;do{f[t>>2]=f[c>>2];i=t+4|0;f[i>>2]=f[j>>2];u=t+8|0;f[u>>2]=f[d>>2];f[t+12>>2]=f[k>>2];f[t+16>>2]=f[l>>2];f[t+20>>2]=f[m>>2];f[t+24>>2]=f[n>>2];f[t+28>>2]=f[o>>2];f[t+32>>2]=f[p>>2];v=f[q>>2]|0;f[t+36>>2]=v;f[t+40>>2]=u;u=t+48|0;w=t+44|0;f[w>>2]=u;f[u>>2]=0;f[t+52>>2]=0;if(v|0){u=v+12|0;f[u>>2]=(f[u>>2]|0)+1}if((f[j>>2]|0)<3){u=f[r>>2]|0;v=f[w>>2]|0;f[v>>2]=f[u>>2];f[v+4>>2]=f[u+4>>2]}else{f[i>>2]=0;U$(t,c)}t=(f[h>>2]|0)+56|0;f[h>>2]=t;s=s+-1|0}while((s|0)!=0);return}s=a+4|0;t=((f[s>>2]|0)-e|0)/56|0;e=t>>>0<b>>>0;h=e?t:b;if(h|0){r=c+36|0;j=c+4|0;q=c+8|0;p=c+12|0;o=c+44|0;n=c+16|0;m=c+20|0;l=c+24|0;k=c+28|0;d=c+32|0;i=h;h=g;while(1){if((h|0)!=(c|0)){g=f[r>>2]|0;if(g|0){u=g+12|0;f[u>>2]=(f[u>>2]|0)+1}u=h+36|0;g=f[u>>2]|0;if(g|0?(v=g+12|0,g=f[v>>2]|0,f[v>>2]=g+-1,(g|0)==1):0)V$(h);f[u>>2]=0;g=h+16|0;v=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[v>>2]|0)>0){w=f[h+40>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0;y=f[v>>2]|0}while((x|0)<(y|0));f[h>>2]=f[c>>2];if((y|0)<3)z=15;else z=17}else{f[h>>2]=f[c>>2];z=15}if((z|0)==15){z=0;x=f[j>>2]|0;if((x|0)<3){f[v>>2]=x;f[h+8>>2]=f[q>>2];f[h+12>>2]=f[p>>2];x=f[o>>2]|0;w=f[h+44>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2]}else z=17}if((z|0)==17){z=0;U$(h,c)}f[g>>2]=f[n>>2];f[h+20>>2]=f[m>>2];f[h+24>>2]=f[l>>2];f[h+28>>2]=f[k>>2];f[h+32>>2]=f[d>>2];f[u>>2]=f[r>>2]}i=i+-1|0;if(!i)break;else h=h+56|0}}if(e){e=c+4|0;h=c+8|0;i=c+12|0;r=c+16|0;d=c+20|0;k=c+24|0;l=c+28|0;m=c+32|0;n=c+36|0;z=c+44|0;o=b-t|0;t=f[s>>2]|0;do{f[t>>2]=f[c>>2];p=t+4|0;f[p>>2]=f[e>>2];q=t+8|0;f[q>>2]=f[h>>2];f[t+12>>2]=f[i>>2];f[t+16>>2]=f[r>>2];f[t+20>>2]=f[d>>2];f[t+24>>2]=f[k>>2];f[t+28>>2]=f[l>>2];f[t+32>>2]=f[m>>2];j=f[n>>2]|0;f[t+36>>2]=j;f[t+40>>2]=q;q=t+48|0;y=t+44|0;f[y>>2]=q;f[q>>2]=0;f[t+52>>2]=0;if(j|0){q=j+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[e>>2]|0)<3){q=f[z>>2]|0;j=f[y>>2]|0;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2]}else{f[p>>2]=0;U$(t,c)}t=(f[s>>2]|0)+56|0;f[s>>2]=t;o=o+-1|0}while((o|0)!=0);return}o=(f[a>>2]|0)+(b*56|0)|0;b=f[s>>2]|0;if((b|0)==(o|0))return;else A=b;do{b=A+-56|0;f[s>>2]=b;a=A+-20|0;t=f[a>>2]|0;if(t|0?(c=t+12|0,t=f[c>>2]|0,f[c>>2]=t+-1,(t|0)==1):0)V$(b);f[a>>2]=0;a=A+-40|0;b=A+-52|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[b>>2]|0)>0){a=f[A+-16>>2]|0;t=0;do{f[a+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[b>>2]|0))}b=f[A+-12>>2]|0;if((b|0)!=(A+-8|0))wL(b);A=f[s>>2]|0}while((A|0)!=(o|0));return}function yvb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(172)|0;zvb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=103316;f[b+12>>2]=c;f[a+4>>2]=b;return}function zvb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+432|0;e=d+32|0;g=d;h=d+368|0;i=d+312|0;j=d+256|0;qQa(a);f[a>>2]=103344;k=a+52|0;f[k>>2]=1124007936;l=a+56|0;m=a+60|0;n=a+92|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+100|0;r=a+96|0;f[r>>2]=q;f[q>>2]=0;f[a+104>>2]=0;s=a+108|0;f[s>>2]=1124007936;t=a+112|0;v=a+116|0;w=a+148|0;o=t;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[w>>2]=v;x=a+156|0;y=a+152|0;f[y>>2]=x;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;rQa(a,c);x=a+4|0;z=a+8|0;A=(f[z>>2]|0)-(f[x>>2]|0)|0;if(!((A|0)!=0&((A|0)/56|0)>>>0<3)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;A=$Xc(48)|0;f[e>>2]=A;f[e+8>>2]=-2147483600;f[e+4>>2]=38;o=A;B=433627;p=o+38|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));b[A+38>>0]=0;vM(-215,e,433666,433690,73)}A=e+11|0;b[A>>0]=10;o=e;B=453228;p=o+10|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));b[e+10>>0]=0;C=MGa(NIa(c,e)|0,-1)|0;if((b[A>>0]|0)<0)cYc(f[e>>2]|0);A=f[x>>2]|0;D=f[A+4>>2]|0;if((D|0)<3)E=Y(f[A+12>>2]|0,f[A+8>>2]|0)|0;else{F=f[A+40>>2]|0;A=0;G=1;while(1){H=Y(f[F+(A<<2)>>2]|0,G)|0;A=A+1|0;if((A|0)==(D|0)){E=H;break}else G=H}};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G=e+11|0;b[G>>0]=9;o=e;B=445999;p=o+9|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));b[e+9>>0]=0;D=LGa(c,e)|0;A=c+4|0;if((D|0)==(A|0))I=1;else{F=MGa(D+28|0,-1)|0;I=(F|0)!=0|(J|0)!=0}F=a+48|0;b[F>>0]=I&1;if((b[G>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G=e+11|0;b[G>>0]=4;f[e>>2]=1936291937;b[e+4>>0]=0;I=LGa(c,e)|0;if((I|0)==(A|0))K=1;else{A=MGa(I+28|0,-1)|0;K=A}f[a+44>>2]=K;if((b[G>>0]|0)<0)cYc(f[e>>2]|0);G=f[x>>2]|0;K=f[G+4>>2]|0;A=G;if((K|0)<=1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;L=$Xc(80)|0;f[e>>2]=L;M=e+8|0;f[M>>2]=-2147483568;N=e+4|0;f[N>>2]=73;o=L;B=433779;p=o+73|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));O=L+73|0;b[O>>0]=0;vM(-215,e,433666,433690,80)}if((K|0)==2)P=Y(f[G+12>>2]|0,f[G+8>>2]|0)|0;else{I=f[G+40>>2]|0;c=0;D=1;while(1){H=Y(f[I+(c<<2)>>2]|0,D)|0;c=c+1|0;if((c|0)==(K|0)){P=H;break}else D=H}}if((E-((E|0)%(C|0)|0)|0)!=(P|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;L=$Xc(80)|0;f[e>>2]=L;M=e+8|0;f[M>>2]=-2147483568;N=e+4|0;f[N>>2]=73;o=L;B=433779;p=o+73|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));O=L+73|0;b[O>>0]=0;vM(-215,e,433666,433690,80)}if(b[F>>0]|0){if(((f[z>>2]|0)-A|0)!=112){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Q=$Xc(80)|0;f[e>>2]=Q;R=e+8|0;f[R>>2]=-2147483568;S=e+4|0;f[S>>2]=69;o=Q;B=433853;p=o+69|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));T=Q+69|0;b[T>>0]=0;vM(-215,e,433666,433690,81)}A=f[G+60>>2]|0;if((A|0)<3)U=Y(f[G+68>>2]|0,f[G+64>>2]|0)|0;else{z=f[G+96>>2]|0;O=0;L=1;while(1){N=Y(f[z+(O<<2)>>2]|0,L)|0;O=O+1|0;if((O|0)==(A|0)){U=N;break}else L=N}}if((C|0)!=(U|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Q=$Xc(80)|0;f[e>>2]=Q;R=e+8|0;f[R>>2]=-2147483568;S=e+4|0;f[S>>2]=69;o=Q;B=433853;p=o+69|0;do{b[o>>0]=b[B>>0]|0;o=o+1|0;B=B+1|0}while((o|0)<(p|0));T=Q+69|0;b[T>>0]=0;vM(-215,e,433666,433690,81)}}g0(e,G,1,C);G=f[x>>2]|0;if((G|0)!=(e|0)){T=G+36|0;Q=f[T>>2]|0;if(Q|0?(B=Q+12|0,Q=f[B>>2]|0,f[B>>2]=Q+-1,(Q|0)==1):0)V$(G);f[T>>2]=0;Q=G+16|0;B=G+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[B>>2]|0)>0){S=f[G+40>>2]|0;R=0;do{f[S+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[B>>2]|0))}f[G>>2]=f[e>>2];R=e+4|0;f[B>>2]=f[R>>2];B=e+8|0;S=G+8|0;f[S>>2]=f[B>>2];f[G+12>>2]=f[e+12>>2];f[Q>>2]=f[e+16>>2];f[G+20>>2]=f[e+20>>2];f[G+24>>2]=f[e+24>>2];f[G+28>>2]=f[e+28>>2];f[G+32>>2]=f[e+32>>2];f[T>>2]=f[e+36>>2];T=G+44|0;Q=f[T>>2]|0;U=G+48|0;if((Q|0)==(U|0))V=Q;else{wL(Q);f[T>>2]=U;f[G+40>>2]=S;V=U}U=e+44|0;if((f[R>>2]|0)<3){S=f[U>>2]|0;f[V>>2]=f[S>>2];f[V+4>>2]=f[S+4>>2]}else{f[T>>2]=f[U>>2];T=e+40|0;f[G+40>>2]=f[T>>2];f[U>>2]=e+48;f[T>>2]=B}f[e>>2]=1124007936;o=R;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0))}if((k|0)!=(G|0)){R=G+36|0;B=f[R>>2]|0;if(B|0){T=B+12|0;f[T>>2]=(f[T>>2]|0)+1}T=a+88|0;B=f[T>>2]|0;if(B|0?(U=B+12|0,B=f[U>>2]|0,f[U>>2]=B+-1,(B|0)==1):0)V$(k);f[T>>2]=0;B=a+68|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[l>>2]|0)>0){U=f[n>>2]|0;S=0;do{f[U+(S<<2)>>2]=0;S=S+1|0;W=f[l>>2]|0}while((S|0)<(W|0));f[k>>2]=f[G>>2];if((W|0)<3)X=56;else X=58}else{f[k>>2]=f[G>>2];X=56}if((X|0)==56){W=f[G+4>>2]|0;if((W|0)<3){f[l>>2]=W;f[m>>2]=f[G+8>>2];f[a+64>>2]=f[G+12>>2];W=f[G+44>>2]|0;S=f[r>>2]|0;f[S>>2]=f[W>>2];f[S+4>>2]=f[W+4>>2]}else X=58}if((X|0)==58)U$(k,G);f[B>>2]=f[G+16>>2];f[a+72>>2]=f[G+20>>2];f[a+76>>2]=f[G+24>>2];f[a+80>>2]=f[G+28>>2];f[a+84>>2]=f[G+32>>2];f[T>>2]=f[R>>2]}R=e+36|0;T=f[R>>2]|0;if(T|0?(G=T+12|0,T=f[G>>2]|0,f[G>>2]=T+-1,(T|0)==1):0)V$(e);f[R>>2]=0;R=e+16|0;T=e+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[T>>2]|0)>0){R=f[e+40>>2]|0;G=0;do{f[R+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[T>>2]|0))}T=f[e+44>>2]|0;if((T|0)!=(e+48|0))wL(T);T=a+64|0;G=f[T>>2]|0;if(G&7|0){R=G+7&-8;B=f[m>>2]|0;W=f[k>>2]&4095;f[h>>2]=1124007936;S=h+4|0;r=h+8|0;U=h+40|0;o=S;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[U>>2]=r;r=h+48|0;V=h+44|0;f[V>>2]=r;f[r>>2]=0;f[h+52>>2]=0;f[e>>2]=B;f[e+4>>2]=R;S$(h,2,e,W);f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=G;f[g+4>>2]=R;W$(i,h,e,g);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=-1056833530;f[e+4>>2]=g;f[e+8>>2]=1;f[e+12>>2]=4;mR(i,e,fT()|0)|0;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=0;f[g+4>>2]=G;W$(j,h,e,g);do if((k|0)==(j|0)){g=j+36|0;G=f[g>>2]|0;if(!G){Z=g;break}R=G+12|0;G=f[R>>2]|0;f[R>>2]=G+-1;if((G|0)!=1){Z=g;break}V$(j);Z=g}else{g=a+88|0;G=f[g>>2]|0;do if(G|0){R=G+12|0;W=f[R>>2]|0;f[R>>2]=W+-1;if((W|0)!=1)break;V$(k)}while(0);f[g>>2]=0;G=a+68|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[l>>2]|0)>0){W=f[n>>2]|0;R=0;do{f[W+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[l>>2]|0))}f[k>>2]=f[j>>2];R=j+4|0;W=f[R>>2]|0;f[l>>2]=W;B=j+8|0;f[m>>2]=f[B>>2];f[T>>2]=f[j+12>>2];f[G>>2]=f[j+16>>2];f[a+72>>2]=f[j+20>>2];f[a+76>>2]=f[j+24>>2];f[a+80>>2]=f[j+28>>2];f[a+84>>2]=f[j+32>>2];Q=j+36|0;f[g>>2]=f[Q>>2];L=a+96|0;A=f[L>>2]|0;if((A|0)==(q|0))_=W;else{wL(A);f[L>>2]=q;f[n>>2]=m;_=f[R>>2]|0}A=j+44|0;if((_|0)<3){W=f[A>>2]|0;f[q>>2]=f[W>>2];f[a+104>>2]=f[W+4>>2]}else{f[L>>2]=f[A>>2];L=j+40|0;f[a+92>>2]=f[L>>2];f[A>>2]=j+48;f[L>>2]=B}f[j>>2]=1124007936;o=R;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));Z=Q}while(0);f[Z>>2]=0;Z=j+16|0;q=j+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[q>>2]|0)>0){Z=f[j+40>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[q>>2]|0))}q=f[j+44>>2]|0;if((q|0)!=(j+48|0))wL(q);q=f[x>>2]|0;j=e+8|0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=k;jR(q,e);q=i+36|0;j=f[q>>2]|0;do if(j|0){_=j+12|0;Z=f[_>>2]|0;f[_>>2]=Z+-1;if((Z|0)!=1)break;V$(i)}while(0);f[q>>2]=0;q=i+16|0;j=i+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[i+40>>2]|0;Z=0;do{f[q+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))wL(j);j=h+36|0;i=f[j>>2]|0;do if(i|0){Z=i+12|0;q=f[Z>>2]|0;f[Z>>2]=q+-1;if((q|0)!=1)break;V$(h)}while(0);f[j>>2]=0;j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[S>>2]|0)>0){j=f[U>>2]|0;U=0;do{f[j+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[S>>2]|0))}S=f[V>>2]|0;if((S|0)!=(r|0))wL(S)}if(!(b[F>>0]|0)){p$(e,1,C,f[k>>2]&4095);k=f[e>>2]|0;ei[f[(f[k>>2]|0)+12>>2]&511](k,e,s,-1);Zj(e);u=d;return}g0(e,(f[x>>2]|0)+56|0,1,1);k=f[x>>2]|0;x=k+56|0;if((x|0)!=(e|0)){C=k+92|0;F=f[C>>2]|0;do if(F|0){S=F+12|0;r=f[S>>2]|0;f[S>>2]=r+-1;if((r|0)!=1)break;V$(x)}while(0);f[C>>2]=0;F=k+72|0;r=k+60|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[r>>2]|0)>0){S=f[k+96>>2]|0;V=0;do{f[S+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[r>>2]|0))}f[x>>2]=f[e>>2];V=e+4|0;S=f[V>>2]|0;f[r>>2]=S;r=e+8|0;U=k+64|0;f[U>>2]=f[r>>2];f[k+68>>2]=f[e+12>>2];f[F>>2]=f[e+16>>2];f[k+76>>2]=f[e+20>>2];f[k+80>>2]=f[e+24>>2];f[k+84>>2]=f[e+28>>2];f[k+88>>2]=f[e+32>>2];f[C>>2]=f[e+36>>2];C=k+100|0;F=f[C>>2]|0;j=k+104|0;if((F|0)==(j|0)){$=S;aa=F}else{wL(F);f[C>>2]=j;f[k+96>>2]=U;$=f[V>>2]|0;aa=j}j=e+44|0;if(($|0)<3){$=f[j>>2]|0;f[aa>>2]=f[$>>2];f[aa+4>>2]=f[$+4>>2]}else{f[C>>2]=f[j>>2];C=e+40|0;f[k+96>>2]=f[C>>2];f[j>>2]=e+48;f[C>>2]=r}f[e>>2]=1124007936;o=V;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0))}if((s|0)!=(x|0)){o=k+92|0;p=f[o>>2]|0;if(p|0){V=p+12|0;f[V>>2]=(f[V>>2]|0)+1}V=a+144|0;p=f[V>>2]|0;do if(p|0){r=p+12|0;C=f[r>>2]|0;f[r>>2]=C+-1;if((C|0)!=1)break;V$(s)}while(0);f[V>>2]=0;p=a+124|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[t>>2]|0)>0){C=f[w>>2]|0;w=0;do{f[C+(w<<2)>>2]=0;w=w+1|0;ba=f[t>>2]|0}while((w|0)<(ba|0));f[s>>2]=f[x>>2];if((ba|0)<3)X=132;else X=134}else{f[s>>2]=f[x>>2];X=132}do if((X|0)==132){ba=f[k+60>>2]|0;if((ba|0)>=3){X=134;break}f[t>>2]=ba;f[v>>2]=f[k+64>>2];f[a+120>>2]=f[k+68>>2];ba=f[k+100>>2]|0;w=f[y>>2]|0;f[w>>2]=f[ba>>2];f[w+4>>2]=f[ba+4>>2]}while(0);if((X|0)==134)U$(s,x);f[p>>2]=f[k+72>>2];f[a+128>>2]=f[k+76>>2];f[a+132>>2]=f[k+80>>2];f[a+136>>2]=f[k+84>>2];f[a+140>>2]=f[k+88>>2];f[V>>2]=f[o>>2]}o=e+36|0;V=f[o>>2]|0;do if(V|0){k=V+12|0;a=f[k>>2]|0;f[k>>2]=a+-1;if((a|0)!=1)break;V$(e)}while(0);f[o>>2]=0;o=e+16|0;V=e+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[V>>2]|0)>0){o=f[e+40>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[V>>2]|0))}V=f[e+44>>2]|0;if((V|0)!=(e+48|0))wL(V);u=d;return}function Avb(a){a=a|0;NXc(a);cYc(a);return}function Bvb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Cvb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==433454?a+12|0:0)|0}function Dvb(a){a=a|0;cYc(a);return}function Evb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103344;b=f[a+168>>2]|0;if(b|0)UXc(b);b=a+108|0;c=a+144|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+124|0;b=a+112|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+148>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+152>>2]|0;if((b|0)!=(a+156|0))wL(b);b=a+52|0;d=a+88|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+68|0;b=a+56|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+92>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+96>>2]|0;if((b|0)==(a+100|0)){MNa(a);return}wL(b);MNa(a);return}function Fvb(a){a=a|0;Evb(a);cYc(a);return}function Gvb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+144|0;h=g+80|0;i=g+68|0;j=g+56|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;gS(c,i);gS(d,j);d=f[a+44>>2]|0;c=f[i>>2]|0;l=f[c+4>>2]|0;m=((d|0)<0?l:0)+d|0;d=c;if((m|0)<0){n=$Xc(48)|0;f[h>>2]=n;f[h+8>>2]=-2147483600;f[h+4>>2]=35;o=n;p=436972;q=o+35|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+35>>0]=0;vM(-215,h,454614,470347,962)}n=(l|0)<(m|0)?l:m;if((n|0)>0){m=f[c+40>>2]|0;l=1;p=0;while(1){o=Y(f[m+(p<<2)>>2]|0,l)|0;p=p+1|0;if((p|0)>=(n|0)){r=o;break}else l=o}}else r=1;if((f[e>>2]|0)!=(d|0)){d=a+52|0;l=a+108|0;n=a+164|0;a=k+36|0;p=k+16|0;m=k+4|0;o=k+40|0;q=k+44|0;s=k+48|0;t=h+36|0;v=h+16|0;w=h+4|0;x=h+40|0;y=h+44|0;z=h+48|0;A=0;B=c;do{g0(h,B+(A*56|0)|0,1,r);g0(k,(f[j>>2]|0)+(A*56|0)|0,1,r);c=i3()|0;Ovb(h,d,l,k,f[n>>2]|0,c);c=f[a>>2]|0;if(c|0?(C=c+12|0,c=f[C>>2]|0,f[C>>2]=c+-1,(c|0)==1):0)V$(k);f[a>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){c=f[o>>2]|0;C=0;do{f[c+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[m>>2]|0))}C=f[q>>2]|0;if((C|0)!=(s|0))wL(C);C=f[t>>2]|0;if(C|0?(c=C+12|0,C=f[c>>2]|0,f[c>>2]=C+-1,(C|0)==1):0)V$(h);f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){C=f[x>>2]|0;c=0;do{f[C+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[w>>2]|0))}c=f[y>>2]|0;if((c|0)!=(z|0))wL(c);A=A+1|0;B=f[i>>2]|0}while(A>>>0<(((f[e>>2]|0)-B|0)/56|0)>>>0)}hx(j);hx(i);u=g;return}function Hvb(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 3:{c=1;break}case 1:{if(zQa()|0?(f[a+44>>2]|0)==1:0)c=1;else d=6;break}case 2:{if(orb()|0)c=(f[a+44>>2]|0)==1;else c=0;break}default:d=6}if((d|0)==6)c=0;return c|0}function Ivb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Jvb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Kvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+164|0;do if(f[c>>2]|0){d=f[b>>2]|0;if(!d){e=d;break}else{g=0;return g|0}}else e=f[b>>2]|0;while(0);d=f[b+4>>2]|0;if(d|0)TXc(d);f[c>>2]=e;b=a+168|0;a=f[b>>2]|0;f[b>>2]=d;if(!a)h=e;else{UXc(a);h=f[c>>2]|0}g=(h|0)!=0;return g|0}function Lvb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+32|0;d=g+12|0;h=g;i=f[c>>2]|0;j=i;if(((f[c+4>>2]|0)-i|0)!=12){c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=18;k=c;l=456060;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[c+18>>0]=0;vM(-215,d,456079,433690,106)}c=a+4|0;n=f[c>>2]|0;o=(f[a+8>>2]|0)-n|0;p=n;if(!((o|0)!=0&((o|0)/56|0)>>>0<3)){o=$Xc(48)|0;f[d>>2]=o;f[d+8>>2]=-2147483600;f[d+4>>2]=38;k=o;l=433627;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[o+38>>0]=0;vM(-215,d,456079,433690,107)}if((f[p+4>>2]|0)!=2){o=$Xc(32)|0;f[d>>2]=o;f[d+8>>2]=-2147483616;f[d+4>>2]=18;k=o;l=433923;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[o+18>>0]=0;vM(-215,d,456079,433690,108)}o=f[a+44>>2]|0;n=((o|0)<0?(f[j+4>>2]|0)-(f[i>>2]|0)>>2:0)+o|0;o=f[f[p+40>>2]>>2]|0;p=n+1|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;f[d+8>>2]=0;if(p>>>0>1073741823)kWc(d);q=p<<2;r=$Xc(q)|0;f[d>>2]=r;s=r+(p<<2)|0;f[d+8>>2]=s;g1c(r|0,0,q|0)|0;f[i>>2]=s;if((n|0)>0){q=f[j>>2]|0;j=0;do{f[r+(j<<2)>>2]=f[q+(j<<2)>>2];j=j+1|0}while((j|0)!=(n|0))}f[s+-4>>2]=o;s=e+4|0;n=f[s>>2]|0;j=f[e>>2]|0;q=n-j|0;r=(q|0)/12|0;p=j;j=n;if(q){if(r>>>0>1?(q=p+12|0,(j|0)!=(q|0)):0){p=j;while(1){j=p+-12|0;f[s>>2]=j;n=f[j>>2]|0;if(!n)t=j;else{j=p+-8|0;v=f[j>>2]|0;if((v|0)!=(n|0))f[j>>2]=v+(~((v+-4-n|0)>>>2)<<2);cYc(n);t=f[s>>2]|0}if((t|0)==(q|0))break;else p=t}}}else Nvb(e,1-r|0,d);if(b[a+48>>0]|0){a=f[c>>2]|0;c=f[a+60>>2]|0;if((c|0)<3)w=Y(f[a+68>>2]|0,f[a+64>>2]|0)|0;else{r=f[a+96>>2]|0;a=0;e=1;while(1){t=Y(f[r+(a<<2)>>2]|0,e)|0;a=a+1|0;if((a|0)==(c|0)){w=t;break}else e=t}}if((o|0)!=(w|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(48)|0;f[h>>2]=w;f[h+8>>2]=-2147483600;f[h+4>>2]=46;k=w;l=433942;m=k+46|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[w+46>>0]=0;vM(-215,h,456079,433690,119)}}h=f[d>>2]|0;if(!h){u=g;return 0}d=f[i>>2]|0;if((d|0)!=(h|0))f[i>>2]=d+(~((d+-4-h|0)>>>2)<<2);cYc(h);u=g;return 0}function Mvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+16|0;e=c;g=f[d+4>>2]|0;h=f[d>>2]|0;d=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=c;return j|0}k=f[(f[(f[a+4>>2]|0)+40>>2]|0)+4>>2]|0;a=x1c(k|0,((k|0)<0)<<31>>31|0,3,0)|0;k=J;l=(g-h|0)/12|0;h=0;g=0;m=0;while(1){n=f[d+(h*12|0)+4>>2]|0;o=f[d+(h*12|0)>>2]|0;p=n-o|0;q=p>>2;r=o;if((r|0)!=(n|0)){if((p|0)<=-4){s=7;break}if((p|0)>0){p=0;n=1;while(1){o=Y(f[r+(p<<2)>>2]|0,n)|0;p=p+1|0;if((p|0)>=(q|0)){t=o;break}else n=o}}else t=1}else t=0;n=x1c(a|0,k|0,t|0,((t|0)<0)<<31>>31|0)|0;q=d1c(n|0,J|0,g|0,m|0)|0;h=h+1|0;n=k1c(0,q|0,32)|0;q=J;if(h>>>0>=l>>>0){i=q;j=n;s=3;break}else{g=n;m=q}}if((s|0)==3){J=i;u=c;return j|0}else if((s|0)==7){s=$Xc(80)|0;f[e>>2]=s;f[e+8>>2]=-2147483568;f[e+4>>2]=70;j=s;c=454543;i=j+70|0;do{b[j>>0]=b[c>>0]|0;j=j+1|0;c=c+1|0}while((j|0)<(i|0));b[s+70>>0]=0;vM(-215,e,454614,454620,161)}return 0}function Nvb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{eKa(j,c);j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)kWc(a);k=(e-i|0)/12|0;i=k<<1;e=k>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;do if(e)if(e>>>0>357913941){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e*12|0)|0;break}else l=0;while(0);i=l+(j*12|0)|0;j=i;h=l+(e*12|0)|0;e=b;b=j;l=i;do{eKa(l,c);l=b+12|0;b=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(e|0)){m=j;n=e;o=e}else{c=l;l=j;j=i;do{i=j+-12|0;k=c;c=c+-12|0;f[i>>2]=0;p=j+-8|0;f[p>>2]=0;f[j+-4>>2]=0;f[i>>2]=f[c>>2];i=k+-8|0;f[p>>2]=f[i>>2];p=k+-4|0;f[j+-4>>2]=f[p>>2];f[p>>2]=0;f[i>>2]=0;f[c>>2]=0;j=l+-12|0;l=j}while((c|0)!=(e|0));m=l;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~((o+-4-b|0)>>>2)<<2);cYc(b)}}while((d|0)!=(h|0))}if(!n)return;cYc(n);return}function Ovb(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;j=u;u=u+48|0;k=j+8|0;l=j;do if((((((f[a+4>>2]|0)==2?(f[a+12>>2]|0)==(f[c+12>>2]|0):0)?(f[g+8>>2]|0)==(f[a+8>>2]|0):0)?(m=f[g+12>>2]|0,(m|0)==(f[c+8>>2]|0)):0)?(n=f[a>>2]|0,o=n&4095,(o|0)==(f[c>>2]&4095|0)):0)?((o|0)==5?(o|0)==(f[g>>2]&4095|0):0):0){if(f[e+16>>2]|0){o=f[e+4>>2]|0;p=(o|0)<3;if(p)q=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{r=f[e+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(o|0)){q=v;break}else t=v}}if(!((o|0)==0|(q|0)==0)){t=f[e>>2]|0;if(!((t&16384|0)!=0&((n^t)&4095|0)==0))break;if(p)w=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{t=f[e+40>>2]|0;s=0;r=1;while(1){v=Y(f[t+(s<<2)>>2]|0,r)|0;s=s+1|0;if((s|0)==(o|0)){w=v;break}else r=v}}if((w|0)!=(m|0))break}}f[k>>2]=103456;r=k+4|0;o=r+24|0;d[o>>1]=0;b[o+2>>0]=0;f[r>>2]=a;f[k+8>>2]=c;f[k+12>>2]=e;f[k+20>>2]=g;f[k+24>>2]=i;f[k+16>>2]=h;r=(fN(10)|0)&1;b[k+28>>0]=r;r=(fN(11)|0)&1;b[k+29>>0]=r;b[k+30>>0]=0;f[l>>2]=0;f[l+4>>2]=i;h3(l,k,+(i|0));u=j;return}while(0);j=$Xc(336)|0;f[k>>2]=j;f[k+8>>2]=-2147483312;f[k+4>>2]=328;o1c(j|0,433989,328)|0;b[j+328>>0]=0;vM(-215,k,452230,433690,154)}function Pvb(a){a=a|0;cYc(a);return}function Qvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;c=u;u=u+1072|0;d=c;e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;j=f[i+8>>2]|0;k=f[g+12>>2]|0;l=k+7|0;m=l&-8;o=Y(j,f[g+8>>2]|0)|0;g=f[a+24>>2]|0;p=((o+-1+g|0)>>>0)/(g>>>0)|0;q=Y(f[b>>2]|0,p)|0;r=f[b+4>>2]|0;b=Y(r,p)|0;p=(r|0)==(g|0)|o>>>0<b>>>0?o:b;b=((f[f[i+44>>2]>>2]|0)>>>0)/((675553809>>>(f[i>>2]<<2&28)&15)>>>0)|0;i=m+8|0;o=d+8|0;f[d>>2]=o;g=d+4|0;f[g>>2]=i;if(i>>>0>264){r=bYc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=r;s=r}else s=o;r=s+31&-32;s=r;if((k|0)<(m|0))g1c(s+(k<<2)|0,0,(l>>>3<<5)-(k<<2)|0)|0;a:do if(p>>>0>q>>>0){l=a+20|0;m=a+12|0;i=r;t=k<<2;v=a+16|0;if((k|0)>0)w=q;else{x=q;while(1){y=(x>>>0)/(j>>>0)|0;z=x-(Y(y,j)|0)|0;A=f[e>>2]|0;B=(f[A+16>>2]|0)+(Y(f[f[A+44>>2]>>2]|0,y)|0)|0;A=f[l>>2]|0;C=(f[A+16>>2]|0)+(Y(f[f[A+44>>2]>>2]|0,y)|0)+(z<<2)|0;y=(f[(f[m>>2]|0)+16>>2]|0)+(z<<2)|0;A=j-z|0;D=p-x|0;E=(D|0)<(A|0)?D:A;o1c(i|0,B|0,t|0)|0;if((E|0)>0){B=0;do{f[C+(B<<2)>>2]=f[y+(B<<2)>>2];B=B+1|0}while((B|0)<(E|0))}B=f[v>>2]|0;if(B|0)Ii[f[(f[B>>2]|0)+104>>2]&127](B,C,C,1,1,z,E+z|0);x=E+x|0;if(p>>>0<=x>>>0)break a}}do{x=(w>>>0)/(j>>>0)|0;B=w-(Y(x,j)|0)|0;y=f[e>>2]|0;A=(f[y+16>>2]|0)+(Y(f[f[y+44>>2]>>2]|0,x)|0)|0;y=f[h>>2]|0;D=f[y+16>>2]|0;F=f[f[y+44>>2]>>2]|0;y=f[l>>2]|0;G=(f[y+16>>2]|0)+(Y(f[f[y+44>>2]>>2]|0,x)|0)+(B<<2)|0;x=(f[(f[m>>2]|0)+16>>2]|0)+(B<<2)|0;y=j-B|0;H=p-w|0;I=(H|0)<(y|0)?H:y;o1c(i|0,A|0,t|0)|0;if((I|0)>0){A=0;y=D+(Y(F,B)|0)|0;while(1){J=+n[x+(A<<2)>>2];F=0;do{J=J+ +n[s+(F<<2)>>2]*+n[y+(F<<2)>>2];F=F+1|0}while((F|0)!=(k|0));n[G+(A<<2)>>2]=J;A=A+1|0;if((A|0)>=(I|0))break;else y=y+(b<<2)|0}}y=f[v>>2]|0;if(y|0)Ii[f[(f[y>>2]|0)+104>>2]&127](y,G,G,1,1,B,I+B|0);w=I+w|0}while(p>>>0>w>>>0)}while(0);w=f[d>>2]|0;if((w|0)==(o|0)){u=c;return}if(w|0)dYc(w);f[d>>2]=o;f[g>>2]=264;u=c;return}function Rvb(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(52)|0;Svb(c,b);b=$Xc(16)|0;d=c;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=103476;f[b+12>>2]=d;f[a>>2]=d;f[a+4>>2]=b;return}function Svb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=103504;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[471037]|0;b[e+1>>0]=b[471038]|0;b[e+2>>0]=b[471039]|0;b[e+3>>0]=b[471040]|0;b[e+4>>0]=b[471041]|0;b[e+5>>0]=0;h=(HIa(c,e)|0)==0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);if(h){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=19;i=h;j=434620;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+19>>0]=0;vM(-215,e,434640,434663,17)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=e+11|0;b[h>>0]=6;b[e>>0]=b[471030]|0;b[e+1>>0]=b[471031]|0;b[e+2>>0]=b[471032]|0;b[e+3>>0]=b[471033]|0;b[e+4>>0]=b[471034]|0;b[e+5>>0]=b[471035]|0;b[e+6>>0]=0;g=(HIa(c,e)|0)==0;if((b[h>>0]|0)<0)cYc(f[e>>2]|0);if(g){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=20;i=g;j=434752;k=i+20|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[g+20>>0]=0;vM(-215,e,434640,434663,17)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[471037]|0;b[e+1>>0]=b[471038]|0;b[e+2>>0]=b[471039]|0;b[e+3>>0]=b[471040]|0;b[e+4>>0]=b[471041]|0;b[e+5>>0]=0;j=~~+NGa(NIa(c,e)|0,-1);f[a+44>>2]=j;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=6;b[e>>0]=b[471030]|0;b[e+1>>0]=b[471031]|0;b[e+2>>0]=b[471032]|0;b[e+3>>0]=b[471033]|0;b[e+4>>0]=b[471034]|0;b[e+5>>0]=b[471035]|0;b[e+6>>0]=0;j=~~+NGa(NIa(c,e)|0,-1);f[a+48>>2]=j;if((b[g>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function Tvb(a){a=a|0;NXc(a);cYc(a);return}function Uvb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Vvb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==434449?a+12|0:0)|0}function Wvb(a){a=a|0;cYc(a);return}function Xvb(a){a=a|0;MNa(a);cYc(a);return}function Yvb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0;g=u;u=u+176|0;h=g+164|0;i=g+152|0;j=g+96|0;k=g+80|0;l=g+24|0;m=g+8|0;o=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;c=f[i>>2]|0;e=d+56|0;q=f[d+60>>2]|0;if((q|0)<3)r=Y(f[d+68>>2]|0,f[d+64>>2]|0)|0;else{s=f[d+96>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}g0(j,e,1,(r>>>0)/7|0);r=f[d+40>>2]|0;e=f[r+4>>2]|0;v=f[r+8>>2]|0;q=f[r+12>>2]|0;r=Y(q,v)|0;t=f[a+48>>2]|0;s=f[a+44>>2]|0;a=Y(s,t)|0;if(!(f[d>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=$Xc(32)|0;f[k>>2]=w;f[k+8>>2]=-2147483616;f[k+4>>2]=18;x=w;y=436075;z=x+18|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[w+18>>0]=0;vM(-215,k,456135,434663,61)}if(!(f[c>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=$Xc(32)|0;f[k>>2]=w;f[k+8>>2]=-2147483616;f[k+4>>2]=18;x=w;y=436094;z=x+18|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[w+18>>0]=0;vM(-215,k,456135,434663,61)}w=j+8|0;y=f[w>>2]|0;if((y|0)>0){x=f[c+16>>2]|0;z=f[f[c+44>>2]>>2]|0;A=f[j+16>>2]|0;B=f[f[j+44>>2]>>2]|0;C=+(v+-1|0);D=+(t+-1|0);E=q+-1|0;F=+(E|0);G=+(s+-1|0);H=(t|0)>0;I=d+16|0;J=d+44|0;K=(e|0)>0;L=(s|0)>0;M=0;do{N=x+(Y(z,M)|0)|0;O=A+(Y(B,M)|0)|0;P=+n[O+12>>2];Q=+n[O+16>>2];R=C*(+n[O+24>>2]-Q)/D;S=F*(+n[O+20>>2]-P)/G;if(H){T=C*Q;O=f[I>>2]|0;U=f[(f[J>>2]|0)+8>>2]|0;Q=F*P;V=0;do{P=T+R*+(V|0);W=~~P;X=O+(Y(U,W)|0)|0;Z=(W+1|0)<(v|0)?X+(q<<2)|0:X;if(L?(_=P-+(W|0),K):0){W=N+((Y(s,V)|0)<<2)|0;$=0;do{P=Q+S*+($|0);aa=~~P;ba=aa+1|0;ca=(E|0)<(ba|0)?E:ba;da=P-+(aa|0);ba=Z;ea=X;fa=W+($<<2)|0;ga=0;while(1){P=+n[ea+(aa<<2)>>2];ha=+n[ba+(aa<<2)>>2];ia=+n[ea+(ca<<2)>>2];n[fa>>2]=P+_*(ha-P)+da*(ia-P+_*(P+(+n[ba+(ca<<2)>>2]-ia-ha)));ga=ga+1|0;if((ga|0)==(e|0))break;else{ba=ba+(r<<2)|0;ea=ea+(r<<2)|0;fa=fa+(a<<2)|0}}$=$+1|0}while(($|0)<(s|0))}V=V+1|0}while((V|0)<(t|0))}M=M+1|0}while((M|0)<(y|0))}M=c+40|0;if((y|0)<(f[f[M>>2]>>2]|0)){f[k>>2]=0;y=k+4|0;f[y>>2]=0;f[k+8>>2]=0;t=$Xc(32)|0;f[k>>2]=t;f[k+8>>2]=t+32;s=t;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=t+8|0;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=t+16|0;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=t+24|0;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;f[y>>2]=t+32;s=f[f[M>>2]>>2]|0;M=t;f[M>>2]=f[w>>2];f[M+4>>2]=s;a0(l,c,k);p[o>>3]=+n[f[d+16>>2]>>2];f[m>>2]=-1056833530;f[m+4>>2]=o;f[m+8>>2]=1;f[m+12>>2]=1;mR(l,m,fT()|0)|0;m=l+36|0;o=f[m>>2]|0;if(o|0?(d=o+12|0,o=f[d>>2]|0,f[d>>2]=o+-1,(o|0)==1):0)V$(l);f[m>>2]=0;m=l+16|0;o=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){m=f[l+40>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))wL(o);o=f[k>>2]|0;if(o|0){k=f[y>>2]|0;if((k|0)!=(o|0))f[y>>2]=k+(~((k+-8-o|0)>>>3)<<3);cYc(o)}}o=j+36|0;k=f[o>>2]|0;if(k|0?(y=k+12|0,k=f[y>>2]|0,f[y>>2]=k+-1,(k|0)==1):0)V$(j);f[o>>2]=0;o=j+16|0;k=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[k>>2]|0)>0){o=f[j+40>>2]|0;y=0;do{f[o+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);hx(i);hx(h);u=g;return}function Zvb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)!=24){i=$Xc(32)|0;f[d>>2]=i;f[d+8>>2]=-2147483616;f[d+4>>2]=18;j=i;k=455503;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+18>>0]=0;vM(-215,d,456079,434663,27)}i=f[h>>2]|0;if(((f[h+4>>2]|0)-i|0)!=16){h=$Xc(32)|0;f[d>>2]=h;f[d+8>>2]=-2147483616;f[d+4>>2]=21;j=h;k=436053;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[h+21>>0]=0;vM(-215,d,456079,434663,27)}if((f[i>>2]|0)!=1){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-213,d,456079,434663,29)}f[d>>2]=0;i=d+4|0;f[i>>2]=0;f[d+8>>2]=0;h=$Xc(16)|0;f[d>>2]=h;k=h+16|0;f[d+8>>2]=k;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[i>>2]=k;k=e+4|0;j=f[k>>2]|0;l=f[e>>2]|0;m=j-l|0;n=(m|0)/12|0;o=l;l=j;if(!m){Nvb(e,1-n|0,d);m=f[d>>2]|0;if(!m){p=f[c>>2]|0;q=p+12|0;r=f[q>>2]|0;s=r+8|0;t=f[s>>2]|0;v=f[e>>2]|0;w=f[v>>2]|0;f[w>>2]=t;x=f[p>>2]|0;y=x+4|0;z=f[y>>2]|0;A=w+4|0;f[A>>2]=z;B=a+48|0;C=f[B>>2]|0;D=w+8|0;f[D>>2]=C;E=a+44|0;F=f[E>>2]|0;G=w+12|0;f[G>>2]=F;u=g;return 0}else{H=m;I=m}}else if(n>>>0>1?(n=o+12|0,(l|0)!=(n|0)):0){o=l;while(1){l=o+-12|0;f[k>>2]=l;m=f[l>>2]|0;if(!m)J=l;else{l=o+-8|0;d=f[l>>2]|0;if((d|0)!=(m|0))f[l>>2]=d+(~((d+-4-m|0)>>>2)<<2);cYc(m);J=f[k>>2]|0}if((J|0)==(n|0)){H=h;I=h;break}else o=J}}else{H=h;I=h}h=f[i>>2]|0;if((h|0)!=(H|0))f[i>>2]=h+(~((h+-4-H|0)>>>2)<<2);cYc(I);p=f[c>>2]|0;q=p+12|0;r=f[q>>2]|0;s=r+8|0;t=f[s>>2]|0;v=f[e>>2]|0;w=f[v>>2]|0;f[w>>2]=t;x=f[p>>2]|0;y=x+4|0;z=f[y>>2]|0;A=w+4|0;f[A>>2]=z;B=a+48|0;C=f[B>>2]|0;D=w+8|0;f[D>>2]=C;E=a+44|0;F=f[E>>2]|0;G=w+12|0;f[G>>2]=F;u=g;return 0}function _vb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(52)|0;$vb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=103616;f[b+12>>2]=c;f[a+4>>2]=b;return}function $vb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=103644;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=4;f[e>>2]=1936291937;b[e+4>>0]=0;h=LGa(c,e)|0;i=c+4|0;if((h|0)==(i|0))j=1;else{k=MGa(h+28|0,-1)|0;j=k}f[a+44>>2]=j;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e+8>>2]=0;g=e+11|0;b[g>>0]=7;b[e>>0]=b[435010]|0;b[e+1>>0]=b[435011]|0;b[e+2>>0]=b[435012]|0;b[e+3>>0]=b[435013]|0;b[e+4>>0]=b[435014]|0;b[e+5>>0]=b[435015]|0;b[e+6>>0]=b[435016]|0;b[e+7>>0]=0;j=LGa(c,e)|0;if((j|0)==(i|0))l=0;else{i=MGa(j+28|0,-1)|0;l=((i|0)!=0|(J|0)!=0)&1}b[a+48>>0]=l;if((b[g>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function awb(a){a=a|0;NXc(a);cYc(a);return}function bwb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function cwb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==434853?a+12|0:0)|0}function dwb(a){a=a|0;cYc(a);return}function ewb(a){a=a|0;MNa(a);cYc(a);return}function fwb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+112|0;g=e+100|0;h=e+88|0;i=e+72|0;j=e;k=e+16|0;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=f[a+44>>2]|0;c=((d|0)<0?f[(f[g>>2]|0)+4>>2]|0:0)+d|0;d=f[h>>2]|0;m=a+48|0;if(b[m>>0]|0){p[j>>3]=0.0;f[i>>2]=-1056833530;f[i+4>>2]=j;f[i+8>>2]=1;f[i+12>>2]=1;mR(d,i,fT()|0)|0}if(((c|0)==1?(f[d+4>>2]|0)==4:0)?(b[m>>0]|0)==0:0){lwb(g,d,i3()|0);hx(h);hx(g);u=e;return}m=f[(f[h>>2]|0)+4>>2]|0;f[i>>2]=0;a=i+4|0;f[a>>2]=0;f[i+8>>2]=0;if(m>>>0>536870911)kWc(i);n=$Xc(m<<3)|0;f[a>>2]=n;f[i>>2]=n;f[i+8>>2]=n+(m<<3);o=m;q=n;r=n;while(1){s=q;f[s>>2]=-2147483648;f[s+4>>2]=2147483647;s=r+8|0;t=o+-1|0;if(!t)break;else{o=t;q=s;r=s}}f[a>>2]=n+(m<<3);f[n+(c<<3)>>2]=0;m=f[g>>2]|0;if((f[l>>2]|0)==(m|0))v=n;else{r=d+4|0;q=j+8|0;o=j+4|0;s=k+36|0;t=k+16|0;w=k+4|0;x=k+40|0;y=k+44|0;z=k+48|0;A=d+40|0;B=0;C=m;m=f[n+(c<<3)>>2]|0;D=n;while(1){n=C;f[D+(c<<3)+4>>2]=(f[(f[n+(B*56|0)+40>>2]|0)+(c<<2)>>2]|0)+m;E=f[r>>2]|0;if((E|0)>0){F=n+(B*56|0)+40|0;G=f[i>>2]|0;H=0;do{if((H|0)!=(c|0)){I=(f[F>>2]|0)+(H<<2)|0;J=((f[(f[A>>2]|0)+(H<<2)>>2]|0)-(f[I>>2]|0)|0)/2|0;f[G+(H<<3)>>2]=J;f[G+(H<<3)+4>>2]=(f[I>>2]|0)+J}H=H+1|0}while((H|0)<(E|0))}X$(k,d,f[i>>2]|0);E=q;f[E>>2]=0;f[E+4>>2]=0;f[j>>2]=-1040121856;f[o>>2]=k;jR(n+(B*56|0)|0,j);E=f[s>>2]|0;if(E|0?(H=E+12|0,E=f[H>>2]|0,f[H>>2]=E+-1,(E|0)==1):0)V$(k);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){E=f[x>>2]|0;H=0;do{f[E+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[w>>2]|0))}H=f[y>>2]|0;if((H|0)!=(z|0))wL(H);H=f[i>>2]|0;m=f[H+(c<<3)+4>>2]|0;f[H+(c<<3)>>2]=m;B=B+1|0;C=f[g>>2]|0;if(B>>>0>=(((f[l>>2]|0)-C|0)/56|0)>>>0){v=H;break}else D=H}}if(v|0){D=f[a>>2]|0;if((D|0)!=(v|0))f[a>>2]=D+(~((D+-8-v|0)>>>3)<<3);cYc(v)}hx(h);hx(g);u=e;return}function gwb(a,c){a=a|0;c=c|0;var d=0,e=0;a:do switch(c|0){case 3:{d=1;break}case 1:{if((zQa()|0?(f[a+44>>2]|0)==1:0)?(b[a+48>>0]|0)==0:0){d=1;break a}d=0;break}case 2:{if(orb()|0?(b[a+48>>0]|0)==0:0)d=1;else e=10;break}case 4:{if(nrb()|0)d=(b[a+48>>0]|0)==0;else d=0;break}default:e=10}while(0);if((e|0)==10)d=0;return d|0}function hwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function iwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function jwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function kwb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+32|0;d=g+12|0;h=g;i=c+4|0;j=f[c>>2]|0;k=j;if((f[i>>2]|0)==(j|0)){j=$Xc(32)|0;f[d>>2]=j;f[d+8>>2]=-2147483616;f[d+4>>2]=17;l=j;m=452630;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+17>>0]=0;vM(-215,d,456079,435018,73)}j=e+4|0;o=f[j>>2]|0;p=f[e>>2]|0;q=o-p|0;r=(q|0)/12|0;s=p;p=o;if(q){if(r>>>0>1?(q=s+12|0,(p|0)!=(q|0)):0){s=p;while(1){p=s+-12|0;f[j>>2]=p;o=f[p>>2]|0;if(!o)t=p;else{p=s+-8|0;v=f[p>>2]|0;if((v|0)!=(o|0))f[p>>2]=v+(~((v+-4-o|0)>>>2)<<2);cYc(o);t=f[j>>2]|0}if((t|0)==(q|0))break;else s=t}}}else Nvb(e,1-r|0,k);k=f[a+44>>2]|0;r=f[c>>2]|0;t=((k|0)<0?(f[r+4>>2]|0)-(f[r>>2]|0)>>2:0)+k|0;if((f[i>>2]|0)==(r|0)){w=0;x=e;y=f[x>>2]|0;z=f[y>>2]|0;A=z+(t<<2)|0;f[A>>2]=w;u=g;return 0}k=a+48|0;a=d+4|0;s=0;q=0;j=r;a:while(1){eKa(d,j+(s*12|0)|0);if(!(b[k>>0]|0)){r=f[d>>2]|0;o=(f[a>>2]|0)-r|0;v=f[e>>2]|0;p=f[v+4>>2]|0;B=f[v>>2]|0;v=r;r=B;if((o|0)!=(p-B|0)){C=24;break}if((p|0)==(B|0)){D=v;C=29}else{B=o>>2;o=0;while(1){if((o|0)!=(t|0)?(f[r+(o<<2)>>2]|0)!=(f[v+(o<<2)>>2]|0):0){C=27;break a}o=o+1|0;if(o>>>0>=B>>>0){D=v;C=29;break}}}}else{v=f[e>>2]|0;B=f[v+4>>2]|0;o=f[v>>2]|0;v=o;r=f[d>>2]|0;if((B|0)==(o|0)){D=r;C=29}else{p=B-o>>2;o=0;do{B=v+(o<<2)|0;E=f[B>>2]|0;F=f[r+(o<<2)>>2]|0;f[B>>2]=(E|0)<(F|0)?F:E;o=o+1|0}while(o>>>0<p>>>0);G=r;H=(f[r+(t<<2)>>2]|0)+q|0;C=30}}if((C|0)==29){C=0;p=(f[D+(t<<2)>>2]|0)+q|0;if(!D)I=p;else{G=D;H=p;C=30}}if((C|0)==30){C=0;p=f[a>>2]|0;if((p|0)!=(G|0))f[a>>2]=p+(~((p+-4-G|0)>>>2)<<2);cYc(G);I=H}s=s+1|0;j=f[c>>2]|0;if(s>>>0>=(((f[i>>2]|0)-j|0)/12|0)>>>0){w=I;x=e;C=15;break}else q=I}if((C|0)==15){y=f[x>>2]|0;z=f[y>>2]|0;A=z+(t<<2)|0;f[A>>2]=w;u=g;return 0}else if((C|0)==24){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;g=$Xc(48)|0;f[h>>2]=g;f[h+8>>2]=-2147483600;f[h+4>>2]=36;l=g;m=435098;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[g+36>>0]=0;vM(-215,h,456079,435018,91)}else if((C|0)==27){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;C=$Xc(48)|0;f[h>>2]=C;f[h+8>>2]=-2147483600;f[h+4>>2]=34;l=C;m=435135;n=l+34|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[C+34>>0]=0;vM(-201,h,456079,435018,95)}return 0}function lwb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+48|0;g=e+12|0;h=e;f[g>>2]=103756;i=g+4|0;j=i+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[i>>2]=a;f[g+8>>2]=c;f[g+12>>2]=d;i=f[a>>2]|0;j=(f[a+4>>2]|0)-i|0;k=(j|0)/56|0;l=f[c+40>>2]|0;m=f[l>>2]|0;n=(j|0)==0;j=i;a:do if(n)o=0;else{i=l+8|0;p=l+12|0;q=0;r=0;b:while(1){s=f[j+(q*56|0)>>2]|0;if(!(s&16384))break;switch(s&4095){case 3:case 5:break;default:break b}if((f[j+(q*56|0)+4>>2]|0)!=4)break;s=f[j+(q*56|0)+40>>2]|0;if((f[s>>2]|0)!=(m|0))break;if((f[s+8>>2]|0)!=(f[i>>2]|0))break;if((f[s+12>>2]|0)!=(f[p>>2]|0))break;t=(f[s+4>>2]|0)+r|0;q=q+1|0;if(q>>>0>=k>>>0){o=t;break a}else r=t}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=$Xc(192)|0;f[h>>2]=r;f[h+8>>2]=-2147483456;f[h+4>>2]=184;o1c(r|0,435170,184)|0;b[r+184>>0]=0;vM(-215,h,452230,435018,136)}while(0);if((o|0)!=(f[l+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=$Xc(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=27;v=l;w=435355;x=v+27|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[l+27>>0]=0;vM(-215,h,452230,435018,139)}l=f[c>>2]|0;if(!(l&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(80)|0;f[h>>2]=y;z=h+8|0;f[z>>2]=-2147483568;A=h+4|0;f[A>>2]=77;v=y;w=435383;x=v+77|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));B=y+77|0;b[B>>0]=0;vM(-215,h,452230,435018,140)}switch(l&4095){case 3:case 5:break;default:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(80)|0;f[h>>2]=y;z=h+8|0;f[z>>2]=-2147483568;A=h+4|0;f[A>>2]=77;v=y;w=435383;x=v+77|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));B=y+77|0;b[B>>0]=0;vM(-215,h,452230,435018,140)}}B=g+16|0;y=Y(o,m)|0;w=g+20|0;if(y|0)mwb(B,y);if(!n?(m|0)>0:0){n=0;y=0;while(1){v=f[a>>2]|0;x=v+(y*56|0)+40|0;A=v+(y*56|0)+16|0;z=v+(y*56|0)+44|0;v=0;l=f[(f[x>>2]|0)+4>>2]|0;while(1){if((l|0)>0){c=(Y(v,o)|0)+n|0;j=0;do{r=f[z>>2]|0;q=(f[A>>2]|0)+(Y(f[r>>2]|0,v)|0)|0;p=q+(Y(f[r+4>>2]|0,j)|0)|0;f[(f[B>>2]|0)+(c+j<<2)>>2]=p;j=j+1|0;p=f[(f[x>>2]|0)+4>>2]|0}while((j|0)<(p|0));C=p}else C=l;v=v+1|0;if((v|0)==(m|0))break;else l=C}y=y+1|0;if(y>>>0>=k>>>0)break;else n=C+n|0}}f[h>>2]=0;f[h+4>>2]=d;h3(h,g,+(d|0));f[g>>2]=103756;d=f[g+16>>2]|0;if(!d){u=e;return}g=f[w>>2]|0;if((g|0)!=(d|0))f[w>>2]=g+(~((g+-4-d|0)>>>2)<<2);cYc(d);u=e;return}function mwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function nwb(a){a=a|0;var b=0,c=0;f[a>>2]=103756;b=f[a+16>>2]|0;if(!b)return;c=a+20|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function owb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=103756;b=f[a+16>>2]|0;if(!b){cYc(a);return}c=a+20|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function pwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;d=f[c+40>>2]|0;e=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;d=f[a+16>>2]|0;g=Y((f[a+20>>2]|0)-d>>2,e)|0;h=f[a+12>>2]|0;a=((h+-1+g|0)>>>0)/(h>>>0)|0;h=Y(f[b>>2]|0,a)|0;i=Y(f[b+4>>2]|0,a)|0;a=i>>>0<g>>>0?i:g;g=d;d=f[c+16>>2]|0;if(h>>>0<a>>>0)j=h;else return;do{h=(j>>>0)/(e>>>0)|0;c=j-(Y(h,e)|0)|0;i=e-c|0;b=i>>>0<65536?i:65536;o1c(d+(j<<2)|0,(f[g+(h<<2)>>2]|0)+(c<<2)|0,b<<2|0)|0;j=b+j|0}while(j>>>0<a>>>0);return}function qwb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(84)|0;rwb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=103776;f[b+12>>2]=c;f[a+4>>2]=b;return}function rwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+32|0;e=d+12|0;g=d;qQa(a);f[a>>2]=103804;h=a+52|0;i=a+56|0;j=a+60|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=e+11|0;b[k>>0]=5;b[e>>0]=b[471037]|0;b[e+1>>0]=b[471038]|0;b[e+2>>0]=b[471039]|0;b[e+3>>0]=b[471040]|0;b[e+4>>0]=b[471041]|0;b[e+5>>0]=0;l=LGa(c,e)|0;m=c+4|0;if((l|0)==(m|0))n=0.0;else n=+NGa(l+28|0,-1);f[a+44>>2]=~~n;if((b[k>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=e+11|0;b[k>>0]=6;b[e>>0]=b[471030]|0;b[e+1>>0]=b[471031]|0;b[e+2>>0]=b[471032]|0;b[e+3>>0]=b[471033]|0;b[e+4>>0]=b[471034]|0;b[e+5>>0]=b[471035]|0;b[e+6>>0]=0;l=LGa(c,e)|0;if((l|0)==(m|0))o=0.0;else o=+NGa(l+28|0,-1);f[a+48>>2]=~~o;if((b[k>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=$Xc(16)|0;f[e>>2]=k;f[e+8>>2]=-2147483632;f[e+4>>2]=11;l=k;p=435694;q=l+11|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[k+11>>0]=0;k=(HIa(c,e)|0)==0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(k){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=$Xc(16)|0;f[e>>2]=k;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=k;p=435706;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[k+13>>0]=0;if(!(HIa(c,e)|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=$Xc(16)|0;f[g>>2]=k;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=k;p=435720;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[k+13>>0]=0;k=(HIa(c,g)|0)!=0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);r=k}else r=1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(r){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=$Xc(16)|0;f[e>>2]=r;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=r;p=435706;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[r+13>>0]=0;if(!(HIa(c,e)|0))s=0;else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;r=$Xc(16)|0;f[g>>2]=r;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=r;p=435720;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[r+13>>0]=0;r=(HIa(c,g)|0)!=0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);s=r}if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(!s){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;s=$Xc(64)|0;f[e>>2]=s;f[e+8>>2]=-2147483584;f[e+4>>2]=58;l=s;p=435891;q=l+58|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[s+58>>0]=0;vM(-215,e,435795,435811,29)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;s=$Xc(16)|0;f[e>>2]=s;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=s;p=435706;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[s+13>>0]=0;s=MGa(NIa(c,e)|0,-1)|0;f[h>>2]=s;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;s=$Xc(16)|0;f[e>>2]=s;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=s;p=435720;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[s+13>>0]=0;s=MGa(NIa(c,e)|0,-1)|0;f[i>>2]=s;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0)}}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;s=$Xc(16)|0;f[e>>2]=s;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=s;p=435706;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[s+13>>0]=0;if(!(HIa(c,e)|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;s=$Xc(16)|0;f[g>>2]=s;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=s;p=435720;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[s+13>>0]=0;s=(HIa(c,g)|0)==0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);t=s}else t=0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(!t){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=$Xc(64)|0;f[e>>2]=t;f[e+8>>2]=-2147483584;f[e+4>>2]=60;l=t;p=435734;q=l+60|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[t+60>>0]=0;vM(-215,e,435795,435811,24)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=$Xc(16)|0;f[e>>2]=t;f[e+8>>2]=-2147483632;f[e+4>>2]=11;l=t;p=435694;q=l+11|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[t+11>>0]=0;t=MGa(NIa(c,e)|0,-1)|0;f[i>>2]=t;f[h>>2]=t;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;t=$Xc(16)|0;f[g>>2]=t;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=t;p=435950;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[t+13>>0]=0;OIa(e,NIa(c,g)|0,-1);t=j+11|0;if((b[t>>0]|0)<0){b[f[j>>2]>>0]=0;f[a+64>>2]=0}else{b[j>>0]=0;b[t>>0]=0}sYc(j,0);f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);g=b[t>>0]|0;h=a+64|0;i=f[h>>2]|0;if(((g<<24>>24<0?i:g&255)|0)==7){if(LYc(j,0,-1,435964,7)|0){v=b[t>>0]|0;w=f[h>>2]|0;x=51}}else{v=g;w=i;x=51}if((x|0)==51){if(((v<<24>>24<0?w:v&255)|0)!=8){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;y=$Xc(64)|0;f[e>>2]=y;z=e+8|0;f[z>>2]=-2147483584;A=e+4|0;f[A>>2]=57;l=y;p=435981;q=l+57|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));B=y+57|0;b[B>>0]=0;vM(-215,e,435795,435811,34)}if(LYc(j,0,-1,435972,8)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;y=$Xc(64)|0;f[e>>2]=y;z=e+8|0;f[z>>2]=-2147483584;A=e+4|0;f[A>>2]=57;l=y;p=435981;q=l+57|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));B=y+57|0;b[B>>0]=0;vM(-215,e,435795,435811,34)}};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;B=$Xc(16)|0;f[e>>2]=B;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=B;p=436039;q=l+13|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[B+13>>0]=0;B=LGa(c,e)|0;if((B|0)==(m|0))C=0;else{m=MGa(B+28|0,-1)|0;C=((m|0)!=0|(J|0)!=0)&1}b[a+80>>0]=C;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function swb(a){a=a|0;NXc(a);cYc(a);return}function twb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function uwb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==435537?a+12|0:0)|0}function vwb(a){a=a|0;cYc(a);return}function wwb(a){a=a|0;var c=0;f[a>>2]=103804;c=a+60|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);return}function xwb(a){a=a|0;var c=0;f[a>>2]=103804;c=a+60|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);cYc(a);return}function ywb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0;e=u;u=u+32|0;g=e+12|0;h=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=a+44|0;c=f[d>>2]|0;if(!c){i=a+48|0;if(!(f[i>>2]|0)){j=f[(f[h>>2]|0)+40>>2]|0;f[i>>2]=f[j+8>>2];i=f[j+12>>2]|0;f[d>>2]=i;k=i}else k=0}else k=c;c=(b[a+80>>0]|0)==0;i=f[a+48>>2]|0;d=f[(f[g>>2]|0)+40>>2]|0;j=f[d+8>>2]|0;if((i|0)>1&(c^1)){n[a+76>>2]=+(j+-1|0)/+(i+-1|0);if((k|0)>1)l=7;else l=8}else{n[a+76>>2]=+(j|0)/+(i|0);if((k|0)>1&(c^1))l=7;else l=8}if((l|0)==7){m=(f[d+12>>2]|0)+-1|0;o=k+-1|0;p=+(m|0);q=+(o|0);r=p/q;s=a+72|0;n[s>>2]=r;hx(h);hx(g);u=e;return}else if((l|0)==8){m=f[d+12>>2]|0;o=k;p=+(m|0);q=+(o|0);r=p/q;s=a+72|0;n[s>>2]=r;hx(h);hx(g);u=e;return}}function zwb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0;g=u;u=u+368|0;h=g+232|0;i=g+216|0;j=g+204|0;k=g+192|0;l=g+136|0;m=g+80|0;o=g+56|0;p=g;q=g+72|0;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;gS(c,i);gS(d,j);gS(e,k);e=a+48|0;d=f[i>>2]|0;c=d+40|0;r=f[c>>2]|0;if(!((f[e>>2]|0)==(f[r+8>>2]|0)?(f[a+44>>2]|0)==(f[r+12>>2]|0):0))s=5;a:do if((s|0)==5){r=f[j>>2]|0;t=a+60|0;v=t+11|0;w=b[v>>0]|0;x=a+64|0;y=f[x>>2]|0;do if(((w<<24>>24<0?y:w&255)|0)==7){if(LYc(t,0,-1,435964,7)|0){z=b[v>>0]|0;A=f[x>>2]|0;break}B=f[(f[i>>2]|0)+40>>2]|0;C=f[B>>2]|0;if(!C)break a;D=d+4|0;E=d+16|0;F=d+44|0;G=l+8|0;H=l+12|0;I=l+4|0;J=r+4|0;K=r+40|0;L=r+16|0;M=r+44|0;N=o+8|0;O=o+4|0;P=a+44|0;Q=q+4|0;R=p+36|0;S=p+16|0;T=p+4|0;U=p+40|0;V=p+44|0;W=p+48|0;X=m+36|0;Z=m+16|0;_=m+4|0;$=m+40|0;aa=m+44|0;ba=m+48|0;ca=0;da=C;C=B;b:while(1){if(!(f[C+4>>2]|0)){ea=C;fa=da}else{B=0;do{ga=f[D>>2]|0;if((ga|0)<=2){s=14;break b}ha=f[c>>2]|0;ia=2;do{f[h+(ia+-2<<2)>>2]=f[ha+(ia<<2)>>2];ia=ia+1|0}while((ia|0)!=(ga|0));ia=f[F>>2]|0;ha=(f[E>>2]|0)+(Y(f[ia>>2]|0,ca)|0)|0;_$(m,ga+-2|0,h,f[d>>2]&4095,ha+(Y(f[ia+4>>2]|0,B)|0)|0,0);f[G>>2]=0;f[H>>2]=0;f[l>>2]=16842752;f[I>>2]=m;ia=f[J>>2]|0;if((ia|0)<=2){s=18;break b}ha=f[K>>2]|0;ja=2;do{f[h+(ja+-2<<2)>>2]=f[ha+(ja<<2)>>2];ja=ja+1|0}while((ja|0)!=(ia|0));ja=f[M>>2]|0;ha=(f[L>>2]|0)+(Y(f[ja>>2]|0,ca)|0)|0;_$(p,ia+-2|0,h,f[r>>2]&4095,ha+(Y(f[ja+4>>2]|0,B)|0)|0,0);ja=N;f[ja>>2]=0;f[ja+4>>2]=0;f[o>>2]=-1040121856;f[O>>2]=p;ja=f[e>>2]|0;f[q>>2]=f[P>>2];f[Q>>2]=ja;Zna(l,o,q,0.0,0.0,0);ja=f[R>>2]|0;if(ja|0?(ha=ja+12|0,ja=f[ha>>2]|0,f[ha>>2]=ja+-1,(ja|0)==1):0)V$(p);f[R>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[T>>2]|0)>0){ja=f[U>>2]|0;ha=0;do{f[ja+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[T>>2]|0))}ha=f[V>>2]|0;if((ha|0)!=(W|0))wL(ha);ha=f[X>>2]|0;if(ha|0?(ja=ha+12|0,ha=f[ja>>2]|0,f[ja>>2]=ha+-1,(ha|0)==1):0)V$(m);f[X>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[_>>2]|0)>0){ha=f[$>>2]|0;ja=0;do{f[ha+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[_>>2]|0))}ja=f[aa>>2]|0;if((ja|0)!=(ba|0))wL(ja);B=B+1|0;ka=f[(f[i>>2]|0)+40>>2]|0}while(B>>>0<(f[ka+4>>2]|0)>>>0);ea=ka;fa=f[ka>>2]|0}ca=ca+1|0;if(ca>>>0>=fa>>>0)break a;else{da=fa;C=ea}}if((s|0)==14){b[h+11>>0]=10;la=h;ma=450129;na=la+10|0;do{b[la>>0]=b[ma>>0]|0;la=la+1|0;ma=ma+1|0}while((la|0)<(na|0));b[h+10>>0]=0;vM(-215,h,450140,454620,110)}else if((s|0)==18){b[h+11>>0]=10;la=h;ma=450129;na=la+10|0;do{b[la>>0]=b[ma>>0]|0;la=la+1|0;ma=ma+1|0}while((la|0)<(na|0));b[h+10>>0]=0;vM(-215,h,450140,454620,110)}}else{z=w;A=y}while(0);if(((z<<24>>24<0?A:z&255)|0)!=8){SGa(h,436113,t);vM(-213,h,456135,435811,160)}if(LYc(t,0,-1,435972,8)|0){SGa(h,436113,t);vM(-213,h,456135,435811,160)}y=f[c>>2]|0;w=f[y+8>>2]|0;x=f[y+12>>2]|0;v=Y(x,w)|0;C=a+44|0;da=Y(f[C>>2]|0,f[e>>2]|0)|0;ca=Y(f[y+4>>2]|0,f[y>>2]|0)|0;if(!(f[d>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(32)|0;f[h>>2]=y;f[h+8>>2]=-2147483616;f[h+4>>2]=18;la=y;ma=436075;na=la+18|0;do{b[la>>0]=b[ma>>0]|0;la=la+1|0;ma=ma+1|0}while((la|0)<(na|0));b[y+18>>0]=0;vM(-215,h,456135,435811,126)}if(!(f[r>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=$Xc(32)|0;f[h>>2]=t;f[h+8>>2]=-2147483616;f[h+4>>2]=18;la=t;ma=436094;na=la+18|0;do{b[la>>0]=b[ma>>0]|0;la=la+1|0;ma=ma+1|0}while((la|0)<(na|0));b[t+18>>0]=0;vM(-215,h,456135,435811,126)}g0(h,d,1,Y(ca,w)|0);g0(l,r,1,Y(f[e>>2]|0,ca)|0);y=f[e>>2]|0;if((y|0)>0){ba=a+76|0;aa=f[h+16>>2]|0;_=f[f[h+44>>2]>>2]|0;$=w+-1|0;Z=f[C>>2]|0;X=(Z|0)>0;W=a+72|0;V=x+-1|0;T=f[l+16>>2]|0;U=f[l+44>>2]|0;S=U+4|0;R=(ca|0)>0;Q=0;do{oa=+(Q|0)*+n[ba>>2];P=~~oa;O=aa+(Y(_,P)|0)|0;N=P+1|0;L=aa+(Y(($|0)<(N|0)?$:N,_)|0)|0;if(X?(N=T+(Y(f[U>>2]|0,Q)|0)|0,M=f[S>>2]|0,pa=oa-+(P|0),R):0){P=0;do{oa=+(P|0)*+n[W>>2];K=~~oa;J=K+1|0;I=(V|0)<(J|0)?V:J;qa=oa-+(K|0);J=L;H=O;G=N+(Y(M,P)|0)|0;E=0;while(1){oa=+n[H+(K<<2)>>2];ra=+n[J+(K<<2)>>2];sa=+n[H+(I<<2)>>2];n[G>>2]=oa+pa*(ra-oa)+qa*(sa-oa+pa*(oa+(+n[J+(I<<2)>>2]-sa-ra)));E=E+1|0;if((E|0)==(ca|0))break;else{J=J+(v<<2)|0;H=H+(v<<2)|0;G=G+(da<<2)|0}}P=P+1|0}while((P|0)<(Z|0))}Q=Q+1|0}while((Q|0)<(y|0))}y=l+36|0;Q=f[y>>2]|0;if(Q|0?(Z=Q+12|0,Q=f[Z>>2]|0,f[Z>>2]=Q+-1,(Q|0)==1):0)V$(l);f[y>>2]=0;y=l+16|0;Q=l+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[Q>>2]|0)>0){y=f[l+40>>2]|0;Z=0;do{f[y+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[Q>>2]|0))}Q=f[l+44>>2]|0;if((Q|0)!=(l+48|0))wL(Q);Q=h+36|0;Z=f[Q>>2]|0;if(Z|0?(y=Z+12|0,Z=f[y>>2]|0,f[y>>2]=Z+-1,(Z|0)==1):0)V$(h);f[Q>>2]=0;Q=h+16|0;Z=h+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[Z>>2]|0)>0){Q=f[h+40>>2]|0;y=0;do{f[Q+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[Z>>2]|0))}Z=f[h+44>>2]|0;if((Z|0)!=(h+48|0))wL(Z)}while(0);hx(k);hx(j);hx(i);u=g;return}function Awb(a,b){a=a|0;b=b|0;return (b|0)==3|0}function Bwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Cwb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=12){j=$Xc(32)|0;f[d>>2]=j;f[d+8>>2]=-2147483616;f[d+4>>2]=18;k=j;l=456060;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+18>>0]=0;vM(-215,d,456079,435811,44)}if(((f[i+4>>2]|0)-(f[h>>2]|0)|0)!=16){h=$Xc(32)|0;f[d>>2]=h;f[d+8>>2]=-2147483616;f[d+4>>2]=21;k=h;l=436053;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[h+21>>0]=0;vM(-215,d,456079,435811,44)}d=e+4|0;h=f[d>>2]|0;l=f[e>>2]|0;k=h-l|0;m=(k|0)/12|0;j=l;l=h;if(k){if(m>>>0>1?(k=j+12|0,(l|0)!=(k|0)):0){j=l;while(1){l=j+-12|0;f[d>>2]=l;h=f[l>>2]|0;if(!h)n=l;else{l=j+-8|0;o=f[l>>2]|0;if((o|0)!=(h|0))f[l>>2]=o+(~((o+-4-h|0)>>>2)<<2);cYc(h);n=f[d>>2]|0}if((n|0)==(k|0))break;else j=n}}}else Nvb(e,1-m|0,i);i=f[a+48>>2]|0;m=f[f[e>>2]>>2]|0;if((i|0)>0)p=i;else p=Y(f[a+56>>2]|0,f[m+8>>2]|0)|0;f[m+8>>2]=p;i=f[a+44>>2]|0;e=m+12|0;if((i|0)>0)q=i;else q=Y(f[a+52>>2]|0,f[e>>2]|0)|0;f[e>>2]=q;e=f[f[c>>2]>>2]|0;if((p|0)!=(f[e+8>>2]|0)){r=0;u=g;return r|0}r=(q|0)==(f[e+12>>2]|0);u=g;return r|0}function Dwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d+16|0;g=d;ENa(e,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=$Xc(16)|0;f[g>>2]=c;f[g+8>>2]=-2147483632;f[g+4>>2]=13;h=c;i=435950;j=h+13|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[c+13>>0]=0;QIa(e,g,435972)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);g=$Xc(84)|0;rwb(g,e);f[g>>2]=103916;f[a>>2]=g;c=$Xc(16)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=104028;f[c+12>>2]=g;f[a+4>>2]=c;c=e+36|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=e+24|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);hx(e+12|0);QGa(e,f[e+4>>2]|0);u=d;return}function Ewb(a){a=a|0;NXc(a);cYc(a);return}function Fwb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Gwb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==436203?a+12|0:0)|0}function Hwb(a){a=a|0;cYc(a);return}function Iwb(a){a=a|0;var c=0;f[a>>2]=103804;c=a+60|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);cYc(a);return}function Jwb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0;d=u;u=u+32|0;e=d+12|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;gS(b,e);gS(c,g);c=a+44|0;b=f[c>>2]|0;h=a+48|0;i=f[h>>2]|0;if(!b)if(!i){j=f[(f[g>>2]|0)+40>>2]|0;k=f[j+8>>2]|0;f[h>>2]=k;h=f[j+12>>2]|0;f[c>>2]=h;l=k;m=h}else{l=i;m=0}else{l=i;m=b}b=f[(f[e>>2]|0)+40>>2]|0;i=f[b+12>>2]|0;if((l|0)>1)o=+((f[b+8>>2]|0)+-1|0)/+(l+-1|0);else o=0.0;n[a+76>>2]=o;if((m|0)<=1){p=0.0;q=a+72|0;n[q>>2]=p;hx(g);hx(e);u=d;return}p=+(i+-1|0)/+(m+-1|0);q=a+72|0;n[q>>2]=p;hx(g);hx(e);u=d;return}function Kwb(a,b){a=a|0;b=b|0;return (b|1|0)==3|0}function Lwb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Mwb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=12){j=$Xc(32)|0;f[d>>2]=j;f[d+8>>2]=-2147483616;f[d+4>>2]=18;k=j;l=456060;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+18>>0]=0;vM(-215,d,456079,435811,217)}if(((f[i+4>>2]|0)-(f[h>>2]|0)|0)!=16){h=$Xc(32)|0;f[d>>2]=h;f[d+8>>2]=-2147483616;f[d+4>>2]=21;k=h;l=436053;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[h+21>>0]=0;vM(-215,d,456079,435811,217)}d=e+4|0;h=f[d>>2]|0;l=f[e>>2]|0;k=h-l|0;m=(k|0)/12|0;j=l;l=h;if(k){if(m>>>0>1?(k=j+12|0,(l|0)!=(k|0)):0){j=l;while(1){l=j+-12|0;f[d>>2]=l;h=f[l>>2]|0;if(!h)n=l;else{l=j+-8|0;o=f[l>>2]|0;if((o|0)!=(h|0))f[l>>2]=o+(~((o+-4-h|0)>>>2)<<2);cYc(h);n=f[d>>2]|0}if((n|0)==(k|0))break;else j=n}}}else Nvb(e,1-m|0,i);i=f[a+48>>2]|0;if((i|0)>0){p=f[f[e>>2]>>2]|0;q=i}else{i=f[f[e>>2]>>2]|0;p=i;q=(Y((f[i+8>>2]|0)+-1|0,f[a+56>>2]|0)|0)+1|0}f[p+8>>2]=q;i=f[a+44>>2]|0;if((i|0)>0){r=p+12|0;s=i}else{i=p+12|0;r=i;s=(Y((f[i>>2]|0)+-1|0,f[a+52>>2]|0)|0)+1|0}f[r>>2]=s;r=f[f[c>>2]>>2]|0;if((q|0)!=(f[r+8>>2]|0)){t=0;u=g;return t|0}t=(s|0)==(f[r+12>>2]|0);u=g;return t|0}function Nwb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(80)|0;Owb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=104056;f[b+12>>2]=c;f[a+4>>2]=b;return}function Owb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=104084;g=a+48|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[479226]|0;b[e+1>>0]=b[479227]|0;b[e+2>>0]=b[479228]|0;b[e+3>>0]=b[479229]|0;b[e+4>>0]=b[479230]|0;b[e+5>>0]=0;h=LGa(c,e)|0;if((h|0)==(c+4|0))i=1;else{j=MGa(h+28|0,-1)|0;i=j}f[a+44>>2]=i;if((b[g>>0]|0)>=0){rQa(a,c);u=d;return}cYc(f[e>>2]|0);rQa(a,c);u=d;return}function Pwb(a){a=a|0;NXc(a);cYc(a);return}function Qwb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Rwb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==436387?a+12|0:0)|0}function Swb(a){a=a|0;cYc(a);return}function Twb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=104084;b=f[a+68>>2]|0;if(b|0){c=a+72|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+56>>2]|0;if(b|0){d=a+60|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+52>>2]|0;if(!b){MNa(a);return}UXc(b);MNa(a);return}function Uwb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=104084;b=f[a+68>>2]|0;if(b|0){c=a+72|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+56>>2]|0;if(b|0){d=a+60|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+52>>2]|0;if(!b){MNa(a);cYc(a);return}UXc(b);MNa(a);cYc(a);return}function Vwb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+208|0;g=e+188|0;h=e+176|0;i=e+128|0;j=e+112|0;k=e+56|0;l=e;m=a+44|0;if((f[m>>2]|0)==1){u=e;return}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);f[i+4>>2]=0;f[i+8>>2]=0;d=i+4|0;f[i>>2]=d;c=i+12|0;n=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(n|0));f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=j+11|0;b[c>>0]=5;b[j>>0]=b[450562]|0;b[j+1>>0]=b[450563]|0;b[j+2>>0]=b[450564]|0;b[j+3>>0]=b[450565]|0;b[j+4>>0]=b[450566]|0;b[j+5>>0]=0;n=$Xc(16)|0;f[n>>2]=n+8;f[n+4>>2]=4;o=bYc(32)|0;f[n>>2]=o;f[k>>2]=0;f[k+4>>2]=n;n=o;f[n>>2]=0;f[n+4>>2]=0;n=o+8|0;f[n>>2]=2;f[n+4>>2]=0;n=o+16|0;f[n>>2]=1;f[n+4>>2]=0;n=o+24|0;f[n>>2]=3;f[n+4>>2]=0;$Ga(i,j,k)|0;RGa(k);if((b[c>>0]|0)<0)cYc(f[j>>2]|0);iDb(j,i);c=a+48|0;n=f[j>>2]|0;o=j+4|0;p=f[o>>2]|0;if(p|0)TXc(p);f[c>>2]=n;n=a+52|0;q=f[n>>2]|0;f[n>>2]=p;if(q|0)UXc(q);q=f[o>>2]|0;if(q|0)UXc(q);q=f[g>>2]|0;o=f[h>>2]|0;p=a+56|0;n=a+60|0;r=f[n>>2]|0;s=f[p>>2]|0;t=r-s>>2;v=s;s=r;if(t>>>0>=4)if((t|0)!=4?(r=v+16|0,(s|0)!=(r|0)):0){f[n>>2]=s+(~((s+-4-r|0)>>>2)<<2);w=v}else w=v;else{CS(p,4-t|0);w=f[p>>2]|0}t=f[q+40>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[m>>2];f[w+8>>2]=(f[t+4>>2]|0)/(f[m>>2]|0)|0;m=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;f[w+12>>2]=m;m=a+68|0;t=a+72|0;a=f[t>>2]|0;v=f[m>>2]|0;r=a-v>>2;s=v;v=a;if(r>>>0>=4)if((r|0)!=4?(a=s+16|0,(v|0)!=(a|0)):0){f[t>>2]=v+(~((v+-4-a|0)>>>2)<<2);x=w;y=s}else{x=w;y=s}else{CS(m,4-r|0);x=f[p>>2]|0;y=f[m>>2]|0}f[y>>2]=f[x>>2];f[y+4>>2]=f[x+8>>2];f[y+8>>2]=f[x+4>>2];f[y+12>>2]=f[x+12>>2];i0(k,q,1,p);lOa(j,1,k);p=k+36|0;q=f[p>>2]|0;if(q|0?(x=q+12|0,q=f[x>>2]|0,f[x>>2]=q+-1,(q|0)==1):0)V$(k);f[p>>2]=0;p=k+16|0;q=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[k+40>>2]|0;x=0;do{f[p+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))wL(q);i0(l,o,1,m);lOa(k,1,l);m=l+36|0;o=f[m>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)V$(l);f[m>>2]=0;m=l+16|0;o=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){m=f[l+40>>2]|0;q=0;do{f[m+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))wL(o);sQa(f[c>>2]|0,j,k);hx(k);hx(j);j=i+36|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);j=i+24|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);hx(i+12|0);QGa(i,f[d>>2]|0);hx(h);hx(g);u=e;return}function Wwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=u;u=u+272|0;g=e+256|0;h=e+244|0;i=e+232|0;j=e+176|0;k=e+120|0;l=e+64|0;m=e+48|0;n=e+32|0;o=e+16|0;p=e;if((qS(b,-1)|0)==3){fOa(a,b,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(b,g);gS(c,h);gS(d,i);d=f[g>>2]|0;f[j>>2]=f[d>>2];c=j+4|0;b=d+4|0;f[c>>2]=f[b>>2];q=j+8|0;f[q>>2]=f[d+8>>2];r=j+12|0;f[r>>2]=f[d+12>>2];s=j+16|0;f[s>>2]=f[d+16>>2];t=j+20|0;f[t>>2]=f[d+20>>2];v=j+24|0;f[v>>2]=f[d+24>>2];w=j+28|0;f[w>>2]=f[d+28>>2];x=j+32|0;f[x>>2]=f[d+32>>2];y=j+36|0;z=f[d+36>>2]|0;f[y>>2]=z;A=j+40|0;f[A>>2]=q;B=j+48|0;C=j+44|0;f[C>>2]=B;f[B>>2]=0;f[j+52>>2]=0;if(z|0){D=z+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[b>>2]|0)<3){b=f[d+44>>2]|0;D=f[C>>2]|0;f[D>>2]=f[b>>2];f[D+4>>2]=f[b+4>>2]}else{f[c>>2]=0;U$(j,d)}d=f[h>>2]|0;f[k>>2]=f[d>>2];b=k+4|0;D=d+4|0;f[b>>2]=f[D>>2];z=k+8|0;f[z>>2]=f[d+8>>2];E=k+12|0;f[E>>2]=f[d+12>>2];F=k+16|0;f[F>>2]=f[d+16>>2];G=k+20|0;f[G>>2]=f[d+20>>2];H=k+24|0;f[H>>2]=f[d+24>>2];I=k+28|0;f[I>>2]=f[d+28>>2];J=k+32|0;f[J>>2]=f[d+32>>2];K=k+36|0;L=f[d+36>>2]|0;f[K>>2]=L;M=k+40|0;f[M>>2]=z;N=k+48|0;O=k+44|0;f[O>>2]=N;f[N>>2]=0;f[k+52>>2]=0;if(L|0){P=L+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[D>>2]|0)<3){D=f[d+44>>2]|0;P=f[O>>2]|0;f[P>>2]=f[D>>2];f[P+4>>2]=f[D+4>>2]}else{f[b>>2]=0;U$(k,d)}do if((f[s>>2]|0)!=(f[F>>2]|0)){d=a+48|0;if(!(f[d>>2]|0)){D=l+8|0;f[D>>2]=0;f[D+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;jR(j,l);break}i0(l,j,1,a+56|0);D=f[y>>2]|0;if(D|0?(P=D+12|0,D=f[P>>2]|0,f[P>>2]=D+-1,(D|0)==1):0)V$(j);f[y>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[c>>2]|0)>0){D=f[A>>2]|0;P=0;do{f[D+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[c>>2]|0))}f[j>>2]=f[l>>2];P=l+4|0;D=f[P>>2]|0;f[c>>2]=D;L=l+8|0;f[q>>2]=f[L>>2];f[r>>2]=f[l+12>>2];Q=l+16|0;f[s>>2]=f[Q>>2];f[t>>2]=f[l+20>>2];f[v>>2]=f[l+24>>2];f[w>>2]=f[l+28>>2];f[x>>2]=f[l+32>>2];R=l+36|0;f[y>>2]=f[R>>2];S=j+44|0;T=f[S>>2]|0;if((T|0)==(B|0))U=D;else{wL(T);f[S>>2]=B;f[A>>2]=q;U=f[P>>2]|0}T=l+44|0;if((U|0)<3){D=f[T>>2]|0;f[B>>2]=f[D>>2];f[j+52>>2]=f[D+4>>2];V=D}else{f[S>>2]=f[T>>2];S=l+40|0;f[j+40>>2]=f[S>>2];D=l+48|0;f[T>>2]=D;f[S>>2]=L;V=D}f[l>>2]=1124007936;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;f[P+24>>2]=0;f[P+28>>2]=0;f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((V|0)!=(l+48|0))wL(V);i0(l,k,1,a+68|0);Q=f[K>>2]|0;if(Q|0?(R=Q+12|0,Q=f[R>>2]|0,f[R>>2]=Q+-1,(Q|0)==1):0)V$(k);f[K>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[b>>2]|0)>0){Q=f[M>>2]|0;R=0;do{f[Q+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[b>>2]|0))}f[k>>2]=f[l>>2];R=l+4|0;Q=f[R>>2]|0;f[b>>2]=Q;P=l+8|0;f[z>>2]=f[P>>2];f[E>>2]=f[l+12>>2];D=l+16|0;f[F>>2]=f[D>>2];f[G>>2]=f[l+20>>2];f[H>>2]=f[l+24>>2];f[I>>2]=f[l+28>>2];f[J>>2]=f[l+32>>2];L=l+36|0;f[K>>2]=f[L>>2];S=k+44|0;T=f[S>>2]|0;if((T|0)==(N|0))W=Q;else{wL(T);f[S>>2]=N;f[M>>2]=z;W=f[R>>2]|0}T=l+44|0;if((W|0)<3){Q=f[T>>2]|0;f[N>>2]=f[Q>>2];f[k+52>>2]=f[Q+4>>2];X=Q}else{f[S>>2]=f[T>>2];S=l+40|0;f[k+40>>2]=f[S>>2];Q=l+48|0;f[T>>2]=Q;f[S>>2]=P;X=Q}f[l>>2]=1124007936;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;f[R+16>>2]=0;f[R+20>>2]=0;f[R+24>>2]=0;f[R+28>>2]=0;f[L>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((X|0)!=(l+48|0))wL(X);lOa(l,1,j);lOa(m,1,k);D=f[d>>2]|0;L=f[(f[D>>2]|0)+44>>2]|0;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=17104896;f[n+4>>2]=l;R=o+8|0;f[R>>2]=0;f[R+4>>2]=0;f[o>>2]=33882112;f[o+4>>2]=m;R=p+8|0;f[R>>2]=0;f[R+4>>2]=0;f[p>>2]=33882112;f[p+4>>2]=i;ei[L&511](D,n,o,p);hx(m);hx(l)}while(0);l=f[K>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)V$(k);f[K>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[b>>2]|0)>0){F=f[M>>2]|0;M=0;do{f[F+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[b>>2]|0))}b=f[O>>2]|0;if((b|0)!=(N|0))wL(b);b=f[y>>2]|0;if(b|0?(N=b+12|0,b=f[N>>2]|0,f[N>>2]=b+-1,(b|0)==1):0)V$(j);f[y>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[c>>2]|0)>0){s=f[A>>2]|0;A=0;do{f[s+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}c=f[C>>2]|0;if((c|0)!=(B|0))wL(c);hx(i);hx(h);hx(g);u=e;return}function Xwb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=f[c>>2]|0;if(((f[c+4>>2]|0)-j|0)==12?(k=f[j>>2]|0,((f[j+4>>2]|0)-k|0)==16):0){j=a+44|0;if(!((f[k+4>>2]|0)%(f[j>>2]|0)|0)){cOa(a,c,d,e,g)|0;u=h;return (f[j>>2]|0)==1|0}else{j=$Xc(32)|0;f[i>>2]=j;f[i+8>>2]=-2147483616;f[i+4>>2]=25;l=j;m=436693;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+25>>0]=0;vM(-215,i,456079,436604,26)}}j=$Xc(48)|0;f[i>>2]=j;f[i+8>>2]=-2147483600;f[i+4>>2]=43;l=j;m=436560;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+43>>0]=0;vM(-215,i,456079,436604,25);return 0}function Ywb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(52)|0;Zwb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=104196;f[b+12>>2]=c;f[a+4>>2]=b;return}function Zwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=104224;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=4;f[e>>2]=1936291937;b[e+4>>0]=0;h=LGa(c,e)|0;i=c+4|0;if((h|0)==(i|0))j=1;else{k=MGa(h+28|0,-1)|0;j=k}f[a+48>>2]=j;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(16)|0;f[e>>2]=g;f[e+8>>2]=-2147483632;f[e+4>>2]=11;j=g;k=436960;h=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(h|0));b[g+11>>0]=0;g=LGa(c,e)|0;if((g|0)==(i|0))l=0;else{i=MGa(g+28|0,-1)|0;l=((i|0)!=0|(J|0)!=0)&1}b[a+44>>0]=l;if((b[e+11>>0]|0)>=0){rQa(a,c);u=d;return}cYc(f[e>>2]|0);rQa(a,c);u=d;return}function _wb(a){a=a|0;NXc(a);cYc(a);return}function $wb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function axb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==436801?a+12|0:0)|0}function bxb(a){a=a|0;cYc(a);return}function cxb(a){a=a|0;MNa(a);cYc(a);return}function dxb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0;g=u;u=u+80|0;h=g+56|0;i=g+40|0;j=g+28|0;k=g+16|0;l=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;gS(c,i);gS(d,j);gS(e,k);e=f[i>>2]|0;d=f[j>>2]|0;c=f[a+48>>2]|0;m=f[e+4>>2]|0;o=((c|0)<0?m:0)+c|0;if((o|0)<0){c=$Xc(48)|0;f[h>>2]=c;f[h+8>>2]=-2147483600;f[h+4>>2]=35;p=c;q=436972;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+35>>0]=0;vM(-215,h,454614,470347,962)}c=(m|0)<(o|0)?m:o;s=f[e+40>>2]|0;if((c|0)>0){t=1;v=0;do{t=Y(f[s+(v<<2)>>2]|0,t)|0;v=v+1|0}while((v|0)<(c|0));if((o|0)<-1){c=$Xc(48)|0;f[h>>2]=c;f[h+8>>2]=-2147483600;f[h+4>>2]=35;p=c;q=436972;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+35>>0]=0;vM(-215,h,454614,470347,962)}else w=t}else w=1;t=f[s+(o<<2)>>2]|0;c=o+1|0;v=(m|0)>(c|0);if(v){x=1;y=c;while(1){z=Y(f[s+(y<<2)>>2]|0,x)|0;y=y+1|0;if((y|0)==(m|0)){A=z;break}else x=z}}else A=1;x=f[e>>2]|0;if((x&4095|0)!=5){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(32)|0;f[h>>2]=y;f[h+8>>2]=-2147483616;f[h+4>>2]=20;p=y;q=437008;r=p+20|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[y+20>>0]=0;vM(-215,h,456135,437029,213)}if(!(x&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=$Xc(48)|0;f[h>>2]=B;C=h+8|0;f[C>>2]=-2147483600;D=h+4|0;f[D>>2]=40;p=B;q=437110;r=p+40|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));E=B+40|0;b[E>>0]=0;vM(-215,h,456135,437029,214)}if(!(f[d>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=$Xc(48)|0;f[h>>2]=B;C=h+8|0;f[C>>2]=-2147483600;D=h+4|0;f[D>>2]=40;p=B;q=437110;r=p+40|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));E=B+40|0;b[E>>0]=0;vM(-215,h,456135,437029,214)}E=f[e+16>>2]|0;e=f[d+16>>2]|0;B=f[(f[k>>2]|0)+16>>2]|0;if((m|0)>(o|0)){q=o+1|0;if((q|0)==(m|0))F=t;else{o=q;q=t;while(1){p=Y(f[s+(o<<2)>>2]|0,q)|0;o=o+1|0;if((o|0)==(m|0)){F=p;break}else q=p}}}else F=1;if(v){v=1;q=c;while(1){c=Y(f[s+(q<<2)>>2]|0,v)|0;q=q+1|0;if((q|0)==(m|0)){G=c;break}else v=c}}else G=1;v=(w|0)==0;if(!v){m=A<<2;q=(A|0)==0;if(t>>>0>1){s=0;do{c=Y(s,F)|0;o=Y(s,G)|0;o1c(B+(o<<2)|0,E+(c<<2)|0,m|0)|0;if(!q){p=1;do{r=(Y(p,G)|0)+c|0;D=0;do{C=B+(D+o<<2)|0;x=E+(r+D<<2)|0;f[C>>2]=f[(+n[C>>2]<+n[x>>2]?x:C)>>2];D=D+1|0}while((D|0)!=(A|0));p=p+1|0}while((p|0)!=(t|0))}s=s+1|0}while((s|0)!=(w|0))}else{s=0;do{o1c(B+((Y(s,G)|0)<<2)|0,E+((Y(s,F)|0)<<2)|0,m|0)|0;s=s+1|0}while((s|0)!=(w|0))}if(!v?(s=(A|0)==0,t|0):0){m=0;do{q=Y(m,F)|0;p=Y(m,G)|0;if(!s){o=0;do{c=(Y(o,G)|0)+q|0;D=0;do{r=c+D|0;n[e+(r<<2)>>2]=+n[E+(r<<2)>>2]-+n[B+(D+p<<2)>>2];D=D+1|0}while((D|0)!=(A|0));o=o+1|0}while((o|0)!=(t|0))}m=m+1|0}while((m|0)!=(w|0))}}f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=d;OL(h,l);if(!v){v=(A|0)==0;l=(t|0)==0;h=A<<2;d=(b[a+44>>0]|0)==0|l|v;a=0;do{m=Y(G,a)|0;E=Y(a,F)|0;if(!v)g1c(B+(m<<2)|0,0,h|0)|0;do if(!l){if(!v){s=0;do{o=(Y(s,G)|0)+E|0;p=0;do{q=B+(p+m<<2)|0;n[q>>2]=+n[e+(o+p<<2)>>2]+ +n[q>>2];p=p+1|0}while((p|0)!=(A|0));s=s+1|0}while((s|0)!=(t|0));if(l)break;if(!v){s=0;do{p=(Y(s,G)|0)+E|0;o=0;do{q=e+(p+o<<2)|0;n[q>>2]=+n[q>>2]/+n[B+(o+m<<2)>>2];o=o+1|0}while((o|0)!=(A|0));s=s+1|0}while((s|0)!=(t|0))}}if(!d){s=0;do{o=(Y(s,G)|0)+E|0;p=0;do{q=e+(o+p<<2)|0;H=+W(+(+n[q>>2]));n[q>>2]=H;p=p+1|0}while((p|0)!=(A|0));s=s+1|0}while((s|0)!=(t|0))}}while(0);a=a+1|0}while((a|0)!=(w|0))}hx(k);hx(j);hx(i);u=g;return}function exb(a,c){a=a|0;c=c|0;var d=0,e=0;a:do switch(c|0){case 3:{d=1;break}case 1:{if(zQa()|0?(f[a+48>>2]|0)==1:0){d=1;break a}d=0;break}case 2:{if(orb()|0?(b[a+44>>0]|0)==0:0)d=1;else e=8;break}case 4:{d=nrb()|0;break}default:e=8}while(0);if((e|0)==8)d=0;return d|0}function fxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function gxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function hxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ixb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=cOa(a,b,c,d,e)|0;eKa(h,f[b>>2]|0);b=f[a+48>>2]|0;a=h+4|0;d=f[h>>2]|0;f[d+(((b|0)<0?(f[a>>2]|0)-d>>2:0)+b<<2)>>2]=1;eOa(e,1,h);e=f[h>>2]|0;if(!e){u=g;return i|0}h=f[a>>2]|0;if((h|0)!=(e|0))f[a>>2]=h+(~((h+-4-e|0)>>>2)<<2);cYc(e);u=g;return i|0}function jxb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r<<2;o=d1c(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;d=454543;h=i+70|0;do{b[i>>0]=b[d>>0]|0;i=i+1|0;d=d+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function kxb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(68)|0;lxb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=104336;f[b+12>>2]=c;f[a+4>>2]=b;return}function lxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;d=u;u=u+48|0;e=d;g=d+28|0;h=d+16|0;i=d+4|0;qQa(a);f[a>>2]=104364;j=a+48|0;k=a+52|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;rQa(a,c);l=a+44|0;f[l>>2]=1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=g+11|0;b[a>>0]=9;m=g;o=437378;p=m+9|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));b[g+9>>0]=0;q=(HIa(c,g)|0)==0;if((b[a>>0]|0)<0)cYc(f[g>>2]|0);if(!q){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=i+11|0;b[q>>0]=9;m=i;o=437378;p=m+9|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));b[i+9>>0]=0;OIa(h,NIa(c,i)|0,-1);lYc(g,h);o=g+11|0;m=b[o>>0]|0;p=m<<24>>24<0;a=f[g>>2]|0;r=g+4|0;s=p?a+(f[r>>2]|0)|0:g+(m&255)|0;m=p?a:g;if((m|0)!=(s|0)){a=m;do{m=(OIc(b[a>>0]|0)|0)&255;b[a>>0]=m;a=a+1|0}while((a|0)!=(s|0))}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[q>>0]|0)<0)cYc(f[i>>2]|0);q=b[o>>0]|0;s=f[r>>2]|0;if(((q<<24>>24<0?s:q&255)|0)==4)if(!(LYc(g,0,-1,437388,4)|0))t=0;else{v=b[o>>0]|0;w=f[r>>2]|0;x=13}else{v=q;w=s;x=13}do if((x|0)==13){if(((v<<24>>24<0?w:v&255)|0)==3){if(!(LYc(g,0,-1,437393,3)|0)){t=1;break}y=b[o>>0]|0;z=f[r>>2]|0}else{y=v;z=w}if(((y<<24>>24<0?z:y&255)|0)!=3){SGa(i,437397,g);A=AYc(i,505469)|0;f[h>>2]=f[A>>2];f[h+4>>2]=f[A+4>>2];f[h+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;vM(-5,h,437422,437439,82)}if(!(LYc(g,0,-1,443327,3)|0))t=2;else{SGa(i,437397,g);A=AYc(i,505469)|0;f[h>>2]=f[A>>2];f[h+4>>2]=f[A+4>>2];f[h+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;vM(-5,h,437422,437439,82)}}while(0);f[l>>2]=t;if((b[o>>0]|0)<0)cYc(f[g>>2]|0)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=g+11|0;b[o>>0]=5;b[g>>0]=b[437520]|0;b[g+1>>0]=b[437521]|0;b[g+2>>0]=b[437522]|0;b[g+3>>0]=b[437523]|0;b[g+4>>0]=b[437524]|0;b[g+5>>0]=0;t=(HIa(c,g)|0)==0;if((b[o>>0]|0)<0)cYc(f[g>>2]|0);if(t){u=d;return};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;t=g+11|0;b[t>>0]=5;b[g>>0]=b[437520]|0;b[g+1>>0]=b[437521]|0;b[g+2>>0]=b[437522]|0;b[g+3>>0]=b[437523]|0;b[g+4>>0]=b[437524]|0;b[g+5>>0]=0;VGa(h,NIa(c,g)|0);if((b[t>>0]|0)<0)cYc(f[g>>2]|0);t=f[h>>2]|0;switch(t|0){case 0:{B=(f[h+4>>2]|0)+4|0;break}case 3:{B=(f[h+4>>2]|0)+4|0;break}case 2:{B=(f[h+4>>2]|0)+4|0;break}default:{f[e>>2]=t;DM(g,455363,e);vM(-3,g,470867,455383,297)}}g=f[B>>2]|0;B=f[k>>2]|0;e=f[j>>2]|0;t=B-e>>2;c=e;e=B;if(g>>>0<=t>>>0){if(g>>>0<t>>>0?(B=c+(g<<2)|0,(e|0)!=(B|0)):0)f[k>>2]=e+(~((e+-4-B|0)>>>2)<<2)}else qxb(j,g-t|0);if((g|0)>0){t=0;do{C=+NGa(h,t);n[(f[j>>2]|0)+(t<<2)>>2]=C;t=t+1|0}while((t|0)<(g|0))}RGa(h);u=d;return}function mxb(a){a=a|0;NXc(a);cYc(a);return}function nxb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function oxb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==437219?a+12|0:0)|0}function pxb(a){a=a|0;cYc(a);return}function qxb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){g1c(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)kWc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;g1c(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;cYc(h);return}function rxb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=104364;b=f[a+64>>2]|0;if(b|0)UXc(b);b=f[a+48>>2]|0;if(!b){MNa(a);return}c=a+52|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);return}function sxb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=104364;b=f[a+64>>2]|0;if(b|0)UXc(b);b=f[a+48>>2]|0;if(!b){MNa(a);cYc(a);return}c=a+52|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);cYc(a);return}function txb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);if(((f[k>>2]|0)-(f[i>>2]|0)|0)!=56){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=$Xc(32)|0;f[j>>2]=k;f[j+8>>2]=-2147483616;f[j+4>>2]=19;d=k;c=452040;l=d+19|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(l|0));b[k+19>>0]=0;vM(-215,j,456135,437439,370)}j=i3()|0;k=f[h>>2]|0;Axb(k,((f[e>>2]|0)-k|0)/56|0,f[i>>2]|0,a+48|0,f[a+44>>2]|0,f[a+60>>2]|0,j);hx(i);hx(h);u=g;return}function uxb(a,b){a=a|0;b=b|0;var c=0;if((b|2|0)==3){c=1;return c|0}if((b|0)!=2){c=0;return c|0}if((f[a+44>>2]|0)!=1){c=1;return c|0}c=(f[a+48>>2]|0)==(f[a+52>>2]|0);return c|0}function vxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function wxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function xxb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+60|0;do if(f[c>>2]|0){d=f[b>>2]|0;if(!d){e=d;break}else{g=0;return g|0}}else e=f[b>>2]|0;while(0);d=f[b+4>>2]|0;if(d|0)TXc(d);f[c>>2]=e;b=a+64|0;a=f[b>>2]|0;f[b>>2]=d;if(!a)h=e;else{UXc(a);h=f[c>>2]|0}g=(h|0)!=0;return g|0}function yxb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=((f[c+4>>2]|0)-h|0)/12|0;if(i>>>0<=1){c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=18;j=c;k=437526;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[c+18>>0]=0;vM(-215,d,456079,437439,109)}c=f[a+52>>2]|0;m=f[a+48>>2]|0;n=c-m>>2;if(!((n|0)==0|(n|0)==(i|0))){n=$Xc(64)|0;f[d>>2]=n;f[d+8>>2]=-2147483584;f[d+4>>2]=52;j=n;k=437545;l=j+52|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[n+52>>0]=0;vM(-215,d,456079,437439,110)}if(!((c|0)==(m|0)?1:(f[a+44>>2]|0)==1)){a=$Xc(32)|0;f[d>>2]=a;f[d+8>>2]=-2147483616;f[d+4>>2]=31;j=a;k=437598;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[a+31>>0]=0;vM(-215,d,456079,437439,111)}a=h;m=f[a+4>>2]|0;c=f[h>>2]|0;h=m-c|0;n=c;c=m;m=(n|0)==(c|0);o=1;a:while(1){p=f[a+(o*12|0)>>2]|0;if((h|0)!=((f[a+(o*12|0)+4>>2]|0)-p|0)){q=14;break}if(!m){r=n;s=p;while(1){if((f[r>>2]|0)!=(f[s>>2]|0)){q=14;break a}r=r+4|0;if((r|0)==(c|0))break;else s=s+4|0}}o=o+1|0;if(o>>>0>=i>>>0){q=8;break}}if((q|0)==8){eOa(e,1,a);u=g;return 0}else if((q|0)==14){q=$Xc(32)|0;f[d>>2]=q;f[d+8>>2]=-2147483616;f[d+4>>2]=22;j=q;k=437630;l=j+22|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+22>>0]=0;vM(-215,d,456079,437439,115)}return 0}function zxb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;a=d;e=f[c>>2]|0;g=(f[c+4>>2]|0)-e|0;c=(g|0)/12|0;if(!g){g=$Xc(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=13;h=g;i=442829;j=h+13|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+13>>0]=0;vM(-215,a,451616,437439,447)}g=f[e+4>>2]|0;k=f[e>>2]|0;e=g-k|0;l=e>>2;m=k;if((m|0)==(g|0)){n=0;o=Y(n,c)|0;p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}if((e|0)<=-4){g=$Xc(80)|0;f[a>>2]=g;f[a+8>>2]=-2147483568;f[a+4>>2]=70;h=g;i=454543;j=h+70|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+70>>0]=0;vM(-215,a,454614,454620,161)}if((e|0)>0){r=0;s=1}else{n=1;o=Y(n,c)|0;p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}while(1){e=Y(f[m+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)>=(l|0)){n=e;break}else s=e}o=Y(n,c)|0;p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}function Axb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0;j=u;u=u+64|0;k=j+16|0;l=j;m=f[d+4>>2]|0;o=m+-2|0;if(o>>>0>=3)sV(m,104468);p=f[d>>2]|0;q=p&4095;if((q|0)!=5)kV(q,5,104496);if(!(p&16384)){q=$Xc(32)|0;f[k>>2]=q;f[k+8>>2]=-2147483616;f[k+4>>2]=18;r=q;s=443864;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[q+18>>0]=0;vM(-215,k,452230,437439,142)}q=f[e>>2]|0;v=f[e+4>>2]|0;w=(q|0)==(v|0);x=v;v=q;if(!w?(x-v>>2|0)!=(c|0):0){y=$Xc(64)|0;f[k>>2]=y;f[k+8>>2]=-2147483584;f[k+4>>2]=48;r=y;s=437653;t=r+48|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[y+48>>0]=0;vM(-215,k,452230,437439,143)}if((c|0)<0){y=f[d+40>>2]|0;z=f[y+-4>>2]|0;A=y+4|0;B=(z|0)==2;C=(z|0)>0;D=0;a:while(1){E=f[a+(D*56|0)+40>>2]|0;if((f[E+-4>>2]|0)!=(z|0))break;if(B){if((f[E>>2]|0)!=(f[y>>2]|0))break;if((f[E+4>>2]|0)!=(f[A>>2]|0))break}else if(C){F=0;do{if((f[E+(F<<2)>>2]|0)!=(f[y+(F<<2)>>2]|0))break a;F=F+1|0}while((F|0)<(z|0))}F=f[a+(D*56|0)>>2]|0;if(!((F&16384|0)!=0&((p^F)&4095|0)==0))break;D=D+1|0}D=$Xc(96)|0;f[k>>2]=D;f[k+8>>2]=-2147483552;f[k+4>>2]=82;r=D;s=437702;t=r+82|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[D+82>>0]=0;vM(-215,k,452230,437439,149)}f[k>>2]=104532;D=k+4|0;p=D+12|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[D>>2]=a;f[k+8>>2]=c;f[k+12>>2]=d;f[k+20>>2]=g;f[k+24>>2]=i;a=f[d+40>>2]|0;if((m|0)!=4){f[k+32>>2]=1;D=f[a+(m+-1<<2)>>2]|0;if((m|0)>2){G=1;H=D;I=25}else{f[k+36>>2]=D;J=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;K=1;L=D}}else{D=f[a+4>>2]|0;f[k+32>>2]=D;G=D;H=f[a+(m+-1<<2)>>2]|0;I=25}if((I|0)==25){D=Y(f[a+(o<<2)>>2]|0,H)|0;f[k+36>>2]=D;H=0;o=1;while(1){d=Y(f[a+(H<<2)>>2]|0,o)|0;H=H+1|0;if((H|0)==(m|0)){J=d;K=G;L=D;break}else o=d}}if((J|0)!=(Y(Y(K,f[a>>2]|0)|0,L)|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;L=$Xc(64)|0;f[l>>2]=L;f[l+8>>2]=-2147483584;f[l+4>>2]=53;r=L;s=437785;t=r+53|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[L+53>>0]=0;vM(-215,l,452230,437439,161)}if((g|0)!=1|w){M=0;N=k+16|0;f[N>>2]=M;O=k+28|0;f[O>>2]=h;f[l>>2]=0;P=l+4|0;f[P>>2]=i;Q=+(i|0);h3(l,k,Q);u=j;return}if((x-v>>2|0)==(c|0))R=0;else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;v=$Xc(32)|0;f[l>>2]=v;f[l+8>>2]=-2147483616;f[l+4>>2]=30;r=v;s=437839;t=r+30|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[v+30>>0]=0;vM(-215,l,452230,437439,166)}while(1){if(+n[q+(R<<2)>>2]!=1.0){M=e;I=35;break}R=R+1|0;if(R>>>0>=c>>>0){M=0;I=35;break}}if((I|0)==35){N=k+16|0;f[N>>2]=M;O=k+28|0;f[O>>2]=h;f[l>>2]=0;P=l+4|0;f[P>>2]=i;Q=+(i|0);h3(l,k,Q);u=j;return}}function Bxb(a){a=a|0;cYc(a);return}function Cxb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0;c=f[a+12>>2]|0;d=a+36|0;e=f[d>>2]|0;g=Y(e,f[f[c+40>>2]>>2]|0)|0;h=f[a+24>>2]|0;i=((h+-1+g|0)>>>0)/(h>>>0)|0;h=Y(f[b>>2]|0,i)|0;j=Y(f[b+4>>2]|0,i)|0;i=g>>>0<j>>>0?g:j;j=f[a+8>>2]|0;g=f[a+16>>2]|0;if(!g)k=0;else{b=f[g>>2]|0;k=(b|0)==(f[g+4>>2]|0)?0:b}b=f[c+16>>2]|0;if(i>>>0<=h>>>0)return;c=a+32|0;g=a+28|0;l=a+4|0;m=a+20|0;a=(k|0)==0;o=(j|0)>1;p=(h>>>0)/(e>>>0)|0;q=h-(Y(p,e)|0)|0;r=i-h|0;s=e-q|0;t=(s|0)<(r|0)?s:r;r=(t|0)<4096?t:4096;if((r|0)<1)return;else{u=h;v=r;w=t;x=p;y=e;z=q}while(1){q=f[c>>2]|0;a:do if((q|0)>0){e=f[l>>2]|0;p=f[e+16>>2]|0;t=f[m>>2]|0;r=(w|0)>0;h=Y(q,x)|0;s=o&r;A=o&r;B=o&r;r=0;while(1){C=(Y(y,h+r|0)|0)+z|0;D=b+(C<<2)|0;b:do switch(t|0){case 0:{if(A){E=1;F=p;while(1){G=(f[e+(E*56|0)+16>>2]|0)+(C<<2)|0;H=F+(C<<2)|0;I=0;do{n[D+(I<<2)>>2]=+n[H+(I<<2)>>2]*+n[G+(I<<2)>>2];I=I+1|0}while((I|0)<(v|0));I=E+1|0;if((I|0)==(j|0))break;else{E=I;F=b}}}break}case 2:{if(B){F=1;E=p;while(1){I=(f[e+(F*56|0)+16>>2]|0)+(C<<2)|0;G=E+(C<<2)|0;H=0;do{J=G+(H<<2)|0;K=I+(H<<2)|0;f[D+(H<<2)>>2]=f[(+n[J>>2]<+n[K>>2]?K:J)>>2];H=H+1|0}while((H|0)<(v|0));H=F+1|0;if((H|0)==(j|0))break;else{F=H;E=b}}}break}default:{if(a){if(s){L=1;M=p}else break b;while(1){E=(f[e+(L*56|0)+16>>2]|0)+(C<<2)|0;F=M+(C<<2)|0;H=0;do{n[D+(H<<2)>>2]=+n[F+(H<<2)>>2]+ +n[E+(H<<2)>>2];H=H+1|0}while((H|0)<(v|0));H=L+1|0;if((H|0)==(j|0))break b;else{L=H;M=b}}}if(s){N=+n[k>>2];H=1;E=p;while(1){F=(f[e+(H*56|0)+16>>2]|0)+(C<<2)|0;O=+n[k+(H<<2)>>2];I=E+(C<<2)|0;G=0;do{n[D+(G<<2)>>2]=N*+n[I+(G<<2)>>2]+O*+n[F+(G<<2)>>2];G=G+1|0}while((G|0)<(v|0));G=H+1|0;if((G|0)==(j|0))break;else{N=1.0;H=G;E=b}}}}}while(0);r=r+1|0;if((r|0)>=(q|0))break a}}while(0);r=f[g>>2]|0;if(r|0){e=b+(z<<2)+((Y(Y(q,x)|0,y)|0)<<2)|0;Ii[f[(f[r>>2]|0)+104>>2]&127](r,e,e,v,y,0,q)}u=v+u|0;if(i>>>0<=u>>>0){P=31;break}y=f[d>>2]|0;x=(u>>>0)/(y>>>0)|0;z=u-(Y(x,y)|0)|0;e=i-u|0;r=y-z|0;w=(r|0)<(e|0)?r:e;v=(w|0)<4096?w:4096;if((v|0)<1){P=31;break}}if((P|0)==31)return}function Dxb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(52)|0;Exb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=104552;f[b+12>>2]=c;f[a+4>>2]=b;return}function Exb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=104580;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=4;f[e>>2]=1936291937;b[e+4>>0]=0;h=LGa(c,e)|0;i=c+4|0;if((h|0)==(i|0))j=1;else{k=MGa(h+28|0,-1)|0;j=k}f[a+44>>2]=j;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=8;j=e;f[j>>2]=1600417381;f[j+4>>2]=1936291937;b[e+8>>0]=0;j=LGa(c,e)|0;if((j|0)==(i|0))l=-1;else{i=MGa(j+28|0,-1)|0;l=i}f[a+48>>2]=l;if((b[g>>0]|0)>=0){rQa(a,c);u=d;return}cYc(f[e>>2]|0);rQa(a,c);u=d;return}function Fxb(a){a=a|0;NXc(a);cYc(a);return}function Gxb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Hxb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==438205?a+12|0:0)|0}function Ixb(a){a=a|0;cYc(a);return}function Jxb(a){a=a|0;MNa(a);cYc(a);return}function Kxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+112|0;a=d+96|0;e=d+84|0;g=d+72|0;h=d+16|0;i=d;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;gS(b,a);gS(c,e);if((f[j>>2]|0)==(f[a>>2]|0)){hx(e);hx(a);u=d;return}c=g+4|0;b=g+8|0;k=i+8|0;l=i+4|0;m=h+36|0;n=h+16|0;o=h+4|0;p=h+40|0;q=h+44|0;r=h+48|0;s=0;do{t=f[e>>2]|0;v=f[t+(s*56|0)+4>>2]|0;w=f[t+(s*56|0)+40>>2]|0;f[g>>2]=0;f[c>>2]=0;f[b>>2]=0;gOa(g,w,w+(v<<2)|0);v=f[a>>2]|0;if((f[v+(s*56|0)+16>>2]|0)!=(f[(f[e>>2]|0)+(s*56|0)+16>>2]|0)){w=f[g>>2]|0;h0(h,v+(s*56|0)|0,1,(f[c>>2]|0)-w>>2,w);w=(f[e>>2]|0)+(s*56|0)|0;v=k;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[l>>2]=w;jR(h,i);w=f[m>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)V$(h);f[m>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){w=f[p>>2]|0;v=0;do{f[w+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[o>>2]|0))}v=f[q>>2]|0;if((v|0)!=(r|0))wL(v)}v=f[g>>2]|0;if(v|0){w=f[c>>2]|0;if((w|0)!=(v|0))f[c>>2]=w+(~((w+-4-v|0)>>>2)<<2);cYc(v)}s=s+1|0}while(s>>>0<(((f[j>>2]|0)-(f[a>>2]|0)|0)/56|0)>>>0);hx(e);hx(a);u=d;return}function Lxb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=orb()|0;break}default:c=0}return c|0}function Mxb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Nxb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+32|0;d=g+12|0;h=g;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=k;if((j|0)==(k|0)){m=$Xc(32)|0;f[d>>2]=m;f[d+8>>2]=-2147483616;f[d+4>>2]=17;n=m;o=452630;p=n+17|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+17>>0]=0;vM(-215,d,456079,438364,76)}m=(j-k|0)/12|0;j=f[l+4>>2]|0;q=k;a:do if(m>>>0>1){k=f[q>>2]|0;r=j-k|0;s=k;k=1;b:while(1){t=f[l+(k*12|0)+4>>2]|0;v=f[l+(k*12|0)>>2]|0;w=v;x=t;if((t-v|0)!=(r|0)){y=10;break}if((w|0)!=(x|0)){v=w;w=s;while(1){if((f[v>>2]|0)!=(f[w>>2]|0)){y=10;break b}v=v+4|0;if((v|0)==(x|0))break;else w=w+4|0}}k=k+1|0;if(k>>>0>=m>>>0)break a}if((y|0)==10){k=$Xc(32)|0;f[d>>2]=k;f[d+8>>2]=-2147483616;f[d+4>>2]=22;n=k;o=438445;p=n+22|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[k+22>>0]=0;vM(-215,d,456079,438364,79)}}while(0);m=f[q>>2]|0;q=j-m>>2;s=f[a+44>>2]|0;r=((s|0)<0?q:0)+s|0;s=f[a+48>>2]|0;a=((s|0)<0?q:0)+s|0;if((r|0)<=-1){s=$Xc(16)|0;f[d>>2]=s;f[d+8>>2]=-2147483632;f[d+4>>2]=14;n=s;o=438468;p=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[s+14>>0]=0;vM(-215,d,456079,438364,86)}if(!((a|0)>=(r|0)&(a|0)<(q|0))){s=$Xc(48)|0;f[d>>2]=s;f[d+8>>2]=-2147483600;f[d+4>>2]=46;n=s;o=438483;p=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[s+46>>0]=0;vM(-215,d,456079,438364,87)}s=a+1|0;if((s|0)==-1){z=q;A=m;B=m}else{m=f[l>>2]|0;z=s;A=m;B=m}if((A|0)!=(j|0)){m=j-B>>2;if((r|0)>(m|0)){C=$Xc(80)|0;f[d>>2]=C;D=d+8|0;f[D>>2]=-2147483568;E=d+4|0;f[E>>2]=70;n=C;o=454543;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));F=C+70|0;b[F>>0]=0;vM(-215,d,454614,454620,161)}if((r|0)>(z|0)|(z|0)>(m|0)){C=$Xc(80)|0;f[d>>2]=C;D=d+8|0;f[D>>2]=-2147483568;E=d+4|0;f[E>>2]=70;n=C;o=454543;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));F=C+70|0;b[F>>0]=0;vM(-215,d,454614,454620,161)}if((r|0)<(z|0)){F=1;C=r;while(1){E=Y(f[A+(C<<2)>>2]|0,F)|0;C=C+1|0;if((C|0)==(z|0)){G=E;break}else F=E}}else G=1}else G=0;f[d>>2]=0;F=d+4|0;f[F>>2]=0;f[d+8>>2]=0;z=d+8|0;if((r|0)>0){C=0;A=0;E=l;l=0;while(1){D=(f[E>>2]|0)+(C<<2)|0;if((l|0)==(A|0))Tv(d,D);else{f[l>>2]=f[D>>2];f[F>>2]=l+4}D=C+1|0;if((D|0)>=(r|0))break;C=D;A=f[z>>2]|0;E=f[c>>2]|0;l=f[F>>2]|0}l=f[F>>2]|0;E=f[z>>2]|0;f[h>>2]=G;if(l>>>0<E>>>0){f[l>>2]=G;f[F>>2]=l+4;H=h}else{I=h;y=28}}else{f[h>>2]=G;I=h;y=28}if((y|0)==28){LA(d,h);H=I}if(s>>>0<q>>>0){I=s;do{s=(f[f[c>>2]>>2]|0)+(I<<2)|0;H=f[F>>2]|0;if((H|0)==(f[z>>2]|0))Tv(d,s);else{f[H>>2]=f[s>>2];f[F>>2]=H+4}I=I+1|0}while(I>>>0<q>>>0)}if((f[F>>2]|0)-(f[d>>2]|0)>>2>>>0>=5){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=$Xc(32)|0;f[h>>2]=q;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=q;o=438530;p=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+26>>0]=0;vM(-215,h,456079,438364,101)}h=((f[i>>2]|0)-(f[c>>2]|0)|0)/12|0;c=e+4|0;i=f[c>>2]|0;q=f[e>>2]|0;o=(i-q|0)/12|0;n=q;q=i;if(h>>>0<=o>>>0){if(h>>>0<o>>>0?(i=n+(h*12|0)|0,(q|0)!=(i|0)):0){n=q;while(1){q=n+-12|0;f[c>>2]=q;p=f[q>>2]|0;if(!p)J=q;else{q=n+-8|0;I=f[q>>2]|0;if((I|0)!=(p|0))f[q>>2]=I+(~((I+-4-p|0)>>>2)<<2);cYc(p);J=f[c>>2]|0}if((J|0)==(i|0))break;else n=J}}}else Nvb(e,h-o|0,d);o=f[d>>2]|0;if(!o){u=g;return 1}d=f[F>>2]|0;if((d|0)!=(o|0))f[F>>2]=d+(~((d+-4-o|0)>>>2)<<2);cYc(o);u=g;return 1}function Oxb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(72)|0;Pxb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=104692;f[b+12>>2]=c;f[a+4>>2]=b;return}function Pxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=104720;rQa(a,c);if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)!=56){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=17;h=g;i=438782;j=h+17|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+17>>0]=0;vM(-215,e,438800,438816,70)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=6;b[e>>0]=b[438896]|0;b[e+1>>0]=b[438897]|0;b[e+2>>0]=b[438898]|0;b[e+3>>0]=b[438899]|0;b[e+4>>0]=b[438900]|0;b[e+5>>0]=b[438901]|0;b[e+6>>0]=0;k=LGa(c,e)|0;l=c+4|0;if((k|0)==(l|0))m=.20000000298023224;else m=+NGa(k+28|0,-1);n[a+60>>2]=m;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=6;b[e>>0]=b[438903]|0;b[e+1>>0]=b[438904]|0;b[e+2>>0]=b[438905]|0;b[e+3>>0]=b[438906]|0;b[e+4>>0]=b[438907]|0;b[e+5>>0]=b[438908]|0;b[e+6>>0]=0;k=LGa(c,e)|0;if((k|0)==(l|0))o=4;else{p=MGa(k+28|0,-1)|0;o=p}p=a+44|0;f[p>>2]=o;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e+8>>2]=0;g=e+11|0;b[g>>0]=7;b[e>>0]=b[438910]|0;b[e+1>>0]=b[438911]|0;b[e+2>>0]=b[438912]|0;b[e+3>>0]=b[438913]|0;b[e+4>>0]=b[438914]|0;b[e+5>>0]=b[438915]|0;b[e+6>>0]=b[438916]|0;b[e+7>>0]=0;o=LGa(c,e)|0;if((o|0)==(l|0))q=0;else{k=MGa(o+28|0,-1)|0;q=k}k=a+48|0;f[k>>2]=q;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e+8>>2]=0;g=e+11|0;b[g>>0]=7;b[e>>0]=b[438918]|0;b[e+1>>0]=b[438919]|0;b[e+2>>0]=b[438920]|0;b[e+3>>0]=b[438921]|0;b[e+4>>0]=b[438922]|0;b[e+5>>0]=b[438923]|0;b[e+6>>0]=b[438924]|0;b[e+7>>0]=0;q=LGa(c,e)|0;if((q|0)==(l|0))r=5;else{o=MGa(q+28|0,-1)|0;r=o}o=a+52|0;f[o>>2]=r;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=8;r=e;f[r>>2]=1935764579;f[r+4>>2]=2020173427;b[e+8>>0]=0;r=LGa(c,e)|0;if((r|0)==(l|0))s=0;else{q=MGa(r+28|0,-1)|0;s=q}f[a+56>>2]=s;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e+8>>2]=0;g=e+11|0;b[g>>0]=7;b[e>>0]=b[438926]|0;b[e+1>>0]=b[438927]|0;b[e+2>>0]=b[438928]|0;b[e+3>>0]=b[438929]|0;b[e+4>>0]=b[438930]|0;b[e+5>>0]=b[438931]|0;b[e+6>>0]=b[438932]|0;b[e+7>>0]=0;s=LGa(c,e)|0;if((s|0)==(l|0))t=0;else{q=MGa(s+28|0,-1)|0;t=(q|0)!=0|(J|0)!=0}q=a+68|0;b[q>>0]=t&1;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=8;t=e;f[t>>2]=1768386412;f[t+4>>2]=1667855475;b[e+8>>0]=0;t=LGa(c,e)|0;if((t|0)==(l|0))v=0;else{s=MGa(t+28|0,-1)|0;v=(s|0)!=0|(J|0)!=0}s=a+69|0;b[s>>0]=v&1;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(16)|0;f[e>>2]=g;f[e+8>>2]=-2147483632;f[e+4>>2]=13;h=g;i=447580;j=h+13|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+13>>0]=0;g=LGa(c,e)|0;if((g|0)==(l|0))w=.4000000059604645;else w=+NGa(g+28|0,-1);g=a+64|0;n[g>>2]=w;if((b[e+11>>0]|0)<0){cYc(f[e>>2]|0);x=+n[g>>2]}else x=w;if(!(x>=0.0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=18;h=g;i=438934;j=h+18|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+18>>0]=0;vM(-215,e,438800,438816,81)}if((f[p>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=$Xc(16)|0;f[e>>2]=p;f[e+8>>2]=-2147483632;f[e+4>>2]=11;h=p;i=438953;j=h+11|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[p+11>>0]=0;vM(-215,e,438800,438816,82)}if((f[k>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=$Xc(16)|0;f[e>>2]=k;f[e+8>>2]=-2147483632;f[e+4>>2]=12;h=k;i=438965;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[k+12>>0]=0;vM(-215,e,438800,438816,83)}if((f[o>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;o=$Xc(16)|0;f[e>>2]=o;f[e+8>>2]=-2147483632;f[e+4>>2]=12;h=o;i=438978;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[o+12>>0]=0;vM(-215,e,438800,438816,84)}do if(!(b[s>>0]|0)){if(b[q>>0]|0)break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;o=$Xc(32)|0;f[e>>2]=o;f[e+8>>2]=-2147483616;f[e+4>>2]=25;h=o;i=438991;j=h+25|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[o+25>>0]=0;vM(-215,e,438800,438816,85)}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=12;h=q;i=439017;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[q+12>>0]=0;q=LGa(c,e)|0;if((q|0)==(l|0))y=0;else{l=MGa(q+28|0,-1)|0;y=(l|0)!=0|(J|0)!=0}if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(y){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=27;h=y;i=439030;j=h+27|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[y+27>>0]=0;vM(-213,e,438800,438816,87)}else{u=d;return}}function Qxb(a){a=a|0;NXc(a);cYc(a);return}function Rxb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Sxb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==438625?a+12|0:0)|0}function Txb(a){a=a|0;cYc(a);return}function Uxb(a){a=a|0;MNa(a);cYc(a);return}function Vxb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0;g=u;u=u+48|0;h=g+36|0;i=g+24|0;j=g+12|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;f[i>>2]=0;m=i+4|0;f[m>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;gS(c,h);gS(d,i);gS(e,j);e=f[h>>2]|0;d=e;if((f[l>>2]|0)==(e|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;c=$Xc(32)|0;f[k>>2]=c;f[k+8>>2]=-2147483616;f[k+4>>2]=18;o=c;p=439105;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[c+18>>0]=0;vM(-215,k,456135,438816,218)}c=f[m>>2]|0;r=f[i>>2]|0;if((c-r|0)!=56){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=$Xc(32)|0;f[k>>2]=s;f[k+8>>2]=-2147483616;f[k+4>>2]=19;o=s;p=452040;q=o+19|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[s+19>>0]=0;vM(-215,k,456135,438816,219)}s=a+48|0;t=(f[s>>2]|0)+1+(f[a+44>>2]|0)|0;v=f[(f[a+4>>2]|0)+16>>2]|0;a:do if((c|0)!=(r|0)){w=a+52|0;x=a+68|0;y=a+69|0;z=a+64|0;A=a+60|0;B=a+56|0;C=0;D=e;E=c;F=r;G=d;while(1){H=F;I=f[G+(C*56|0)+40>>2]|0;J=f[I>>2]|0;K=f[I+4>>2]|0;L=f[I+8>>2]|0;M=Y(Y(K,t)|0,L)|0;N=f[w>>2]|0;O=Y(M,N)|0;M=Y(O,J)|0;P=f[G+(C*56|0)+4>>2]|0;if((P|0)<3)Q=Y(f[G+(C*56|0)+12>>2]|0,f[G+(C*56|0)+8>>2]|0)|0;else{R=1;S=J;while(1){T=Y(f[I+(R<<2)>>2]|0,S)|0;R=R+1|0;if((R|0)==(P|0)){Q=T;break}else S=T}}if((M|0)!=(Q|0)){U=14;break}S=f[H+(C*56|0)+4>>2]|0;if((S|0)<3)W=Y(f[H+(C*56|0)+12>>2]|0,f[H+(C*56|0)+8>>2]|0)|0;else{P=f[H+(C*56|0)+40>>2]|0;R=0;I=1;while(1){T=Y(f[P+(R<<2)>>2]|0,I)|0;R=R+1|0;if((R|0)==(S|0)){W=T;break}else I=T}}if((M|0)!=(W|0)){U=20;break}I=f[l>>2]|0;if(((I-D|0)/56|0)>>>0>=2?(f[G+60>>2]|0)!=4:0){U=23;break}if(((I-D|0)/56|0)>>>0>1)X=f[(f[G+96>>2]|0)+8>>2]|0;else X=K;if(((I-D|0)/56|0)>>>0>1)Z=f[(f[G+96>>2]|0)+12>>2]|0;else Z=L;I=f[G+(C*56|0)+16>>2]|0;S=f[H+(C*56|0)+16>>2]|0;R=Y(N,Y(Y(K,J)|0,L)|0)|0;P=(R|0)>0;if(P){T=0;do{_=(Y(T,t)|0)+4|0;$=1.0/(+V(+-+n[I+(_<<2)>>2])+1.0);n[S+(_<<2)>>2]=$;T=T+1|0}while((T|0)<(R|0))}if(!(b[x>>0]|0)){if(!((b[y>>0]|0)==0|P^1)?(T=f[s>>2]|0,(T|0)>0):0){H=0;do{M=Y(H,t)|0;_=I+(M<<2)+20|0;aa=S+(M<<2)+20|0;M=0;do{$=1.0/(+V(+-+n[_+(M<<2)>>2])+1.0);n[aa+(M<<2)>>2]=$;M=M+1|0}while((M|0)<(T|0));H=H+1|0}while((H|0)<(R|0))}}else if(P?(H=f[s>>2]|0,(H|0)>0):0){T=0;do{M=Y(T,t)|0;aa=I+(M<<2)+20|0;_=S+(M<<2)|0;$=-3402823466385288598117041.0e14;M=0;do{ba=+n[aa+(M<<2)>>2];$=ba>$?ba:$;M=M+1|0}while((M|0)!=(H|0));M=_+20|0;ba=0.0;ca=0;do{da=+V(+(+n[aa+(ca<<2)>>2]-$));ba=ba+da;n[M+(ca<<2)>>2]=da;ca=ca+1|0}while((ca|0)!=(H|0));ea=0;do{ca=M+(ea<<2)|0;n[ca>>2]=+n[ca>>2]/ba;ea=ea+1|0}while((ea|0)!=(H|0));T=T+1|0}while((T|0)<(R|0))}R=(J|0)>0;if(R){T=(L|0)>0;H=(K|0)>0;ba=+(L|0);$=+(K|0);da=+(X|0);fa=+(Z|0);P=(N|0)>0;M=0;do{if(T){ca=Y(M,O)|0;aa=0;do{if(H){ga=+(aa|0);_=0;do{if(P){ha=(Y(_,L)|0)+aa|0;ia=(f[B>>2]|0)==-1;ja=+(_|0);ka=f[s>>2]|0;la=(ka|0)>0;ma=Y(N,ha)|0;ha=0;do{na=(Y(ma+ha|0,t)|0)+ca|0;oa=+n[S+(na+4<<2)>>2];pa=oa<.5&ia?0.0:oa;oa=(ga+1.0/(+V(+-+n[I+(na<<2)>>2])+1.0))/ba;n[S+(na<<2)>>2]=oa;qa=na+1|0;oa=(ja+1.0/(+V(+-+n[I+(qa<<2)>>2])+1.0))/$;n[S+(qa<<2)>>2]=oa;qa=na+2|0;oa=+V(+(+n[I+(qa<<2)>>2]));ra=ha<<1;n[S+(qa<<2)>>2]=oa*+n[v+(ra<<2)>>2]/da;qa=na+3|0;oa=+V(+(+n[I+(qa<<2)>>2]));n[S+(qa<<2)>>2]=oa*+n[v+((ra|1)<<2)>>2]/fa;ra=na+5|0;if(la){na=0;do{qa=S+(ra+na<<2)|0;oa=pa*+n[qa>>2];n[qa>>2]=oa>+n[A>>2]?oa:0.0;na=na+1|0}while((na|0)<(ka|0))}ha=ha+1|0}while((ha|0)<(N|0))}_=_+1|0}while((_|0)!=(K|0))}aa=aa+1|0}while((aa|0)!=(L|0))}M=M+1|0}while((M|0)!=(J|0));fa=+n[z>>2];if(fa>0.0&R){M=Y(L,K)|0;I=0;P=N;da=fa;while(1){H=S+((Y(I,O)|0)<<2)|0;T=Y(M,P)|0;Yxb(a,H,T,+n[A>>2],da);T=I+1|0;if((T|0)>=(J|0))break;I=T;P=f[w>>2]|0;da=+n[z>>2]}sa=f[i>>2]|0;ta=f[m>>2]|0}else{sa=F;ta=E}}else{sa=F;ta=E}P=C+1|0;if(P>>>0>=((ta-sa|0)/56|0)>>>0)break a;I=f[h>>2]|0;C=P;D=I;E=ta;F=sa;G=I}if((U|0)==14){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;G=$Xc(48)|0;f[k>>2]=G;f[k+8>>2]=-2147483600;f[k+4>>2]=41;o=G;p=439124;q=o+41|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[G+41>>0]=0;vM(-215,k,456135,438816,237)}else if((U|0)==20){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=$Xc(48)|0;f[k>>2]=F;f[k+8>>2]=-2147483600;f[k+4>>2]=41;o=F;p=439166;q=o+41|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[F+41>>0]=0;vM(-215,k,456135,438816,238)}else if((U|0)==23){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;G=$Xc(48)|0;f[k>>2]=G;f[k+8>>2]=-2147483600;f[k+4>>2]=40;o=G;p=439208;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[G+40>>0]=0;vM(-215,k,456135,438816,240)}}while(0);hx(j);hx(i);hx(h);u=g;return}function Wxb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;g=u;u=u+32|0;d=g+16|0;h=g;i=f[c>>2]|0;if((f[c+4>>2]|0)==(i|0)){c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=17;j=c;k=452630;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[c+17>>0]=0;vM(-215,d,456079,438816,95)}c=f[i>>2]|0;i=f[c+12>>2]|0;m=f[a+52>>2]|0;if((i|0)!=(Y((f[a+44>>2]|0)+1+(f[a+48>>2]|0)|0,m)|0)){a=$Xc(48)|0;f[d>>2]=a;f[d+8>>2]=-2147483600;f[d+4>>2]=46;j=a;k=439058;l=j+46|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[a+46>>0]=0;vM(-215,d,456079,438816,97)}a=f[c>>2]|0;if((a|0)>1){k=Y(Y(f[c+8>>2]|0,f[c+4>>2]|0)|0,m)|0;f[d>>2]=a;f[d+4>>2]=k;f[d+8>>2]=(i|0)/(m|0)|0;f[d+12>>2]=-1;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;gOa(h,d,d+16|0);a=f[h>>2]|0;j=f[k>>2]|0;l=j;n=a;a:do if((a|0)==(j|0)){o=a;p=9}else{q=a;while(1){if((f[q>>2]|0)<0){o=q;p=9;break a}q=q+4|0;if((q|0)==(j|0)){r=l;break}}}while(0);if((p|0)==9)if((o|0)!=(j|0)){q=o+4|0;if((q|0)==(j|0)){s=j;t=o;v=l}else{w=q;q=o;while(1){o=f[w>>2]|0;if((o|0)<0)x=q;else{f[q>>2]=o;x=q+4|0}w=w+4|0;if((w|0)==(j|0))break;else q=x}q=f[k>>2]|0;s=q;t=x;v=q}if((t|0)==(s|0))r=v;else{v=s+(~((s+-4-t|0)>>>2)<<2)|0;f[k>>2]=v;r=v}}else r=l;l=$Xc(12)|0;v=l;t=l+12|0;f[l>>2]=0;s=l+4|0;f[s>>2]=0;f[l+8>>2]=0;q=r-n|0;n=q>>2;if(n){if(n>>>0>1073741823)kWc(l);x=$Xc(q)|0;f[s>>2]=x;f[l>>2]=x;f[l+8>>2]=x+(n<<2);n=f[h>>2]|0;q=r-n|0;if((q|0)>0){o1c(x|0,n|0,q|0)|0;f[s>>2]=x+(q>>>2<<2);y=n}else y=n}else y=a;a=l+12|0;l=f[e>>2]|0;if(!l){z=e+4|0;A=e+8|0;B=y}else{y=e+4|0;n=f[y>>2]|0;if((n|0)==(l|0))C=l;else{q=n;while(1){n=q+-12|0;f[y>>2]=n;x=f[n>>2]|0;if(!x)D=n;else{n=q+-8|0;s=f[n>>2]|0;if((s|0)!=(x|0))f[n>>2]=s+(~((s+-4-x|0)>>>2)<<2);cYc(x);D=f[y>>2]|0}if((D|0)==(l|0))break;else q=D}C=f[e>>2]|0}cYc(C);C=e+8|0;f[C>>2]=0;f[y>>2]=0;f[e>>2]=0;z=y;A=C;B=f[h>>2]|0}f[e>>2]=v;f[z>>2]=a;f[A>>2]=t;if(B|0){t=f[k>>2]|0;if((t|0)!=(B|0))f[k>>2]=t+(~((t+-4-B|0)>>>2)<<2);cYc(B)}u=g;return 0}else{B=Y(Y(f[c+8>>2]|0,f[c+4>>2]|0)|0,m)|0;f[d>>2]=B;f[d+4>>2]=(i|0)/(m|0)|0;f[d+8>>2]=-1;f[d+12>>2]=-1;f[h>>2]=0;m=h+4|0;f[m>>2]=0;f[h+8>>2]=0;gOa(h,d,d+16|0);d=f[h>>2]|0;i=f[m>>2]|0;B=i;c=d;b:do if((d|0)==(i|0)){E=d;p=40}else{t=d;while(1){if((f[t>>2]|0)<0){E=t;p=40;break b}t=t+4|0;if((t|0)==(i|0)){F=B;break}}}while(0);if((p|0)==40)if((E|0)!=(i|0)){p=E+4|0;if((p|0)==(i|0)){G=i;H=E;I=B}else{t=p;p=E;while(1){E=f[t>>2]|0;if((E|0)<0)J=p;else{f[p>>2]=E;J=p+4|0}t=t+4|0;if((t|0)==(i|0))break;else p=J}p=f[m>>2]|0;G=p;H=J;I=p}if((H|0)==(G|0))F=I;else{I=G+(~((G+-4-H|0)>>>2)<<2)|0;f[m>>2]=I;F=I}}else F=B;B=$Xc(12)|0;I=B;H=B+12|0;f[B>>2]=0;G=B+4|0;f[G>>2]=0;f[B+8>>2]=0;p=F-c|0;c=p>>2;if(c){if(c>>>0>1073741823)kWc(B);J=$Xc(p)|0;f[G>>2]=J;f[B>>2]=J;f[B+8>>2]=J+(c<<2);c=f[h>>2]|0;p=F-c|0;if((p|0)>0){o1c(J|0,c|0,p|0)|0;f[G>>2]=J+(p>>>2<<2);K=c}else K=c}else K=d;d=B+12|0;B=f[e>>2]|0;if(!B){L=e+4|0;M=e+8|0;N=K}else{K=e+4|0;c=f[K>>2]|0;if((c|0)==(B|0))O=B;else{p=c;while(1){c=p+-12|0;f[K>>2]=c;J=f[c>>2]|0;if(!J)P=c;else{c=p+-8|0;G=f[c>>2]|0;if((G|0)!=(J|0))f[c>>2]=G+(~((G+-4-J|0)>>>2)<<2);cYc(J);P=f[K>>2]|0}if((P|0)==(B|0))break;else p=P}O=f[e>>2]|0}cYc(O);O=e+8|0;f[O>>2]=0;f[K>>2]=0;f[e>>2]=0;L=K;M=O;N=f[h>>2]|0}f[e>>2]=I;f[L>>2]=d;f[M>>2]=H;if(N|0){H=f[m>>2]|0;if((H|0)!=(N|0))f[m>>2]=H+(~((H+-4-N|0)>>>2)<<2);cYc(N)}u=g;return 0}return 0}function Xxb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r*60|0;o=d1c(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;d=454543;h=i+70|0;do{b[i>>0]=b[d>>0]|0;i=i+1|0;d=d+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function Yxb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;l=(c|0)==0;do if(!l)if(c>>>0>134217727)kWc(h);else{m=c<<5;o=$Xc(m)|0;f[h>>2]=o;f[h+8>>2]=o+(c<<5);g1c(o|0,0,m|0)|0;f[k>>2]=o+m;q=o;break}else q=0;while(0);f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;if(l){l=a+48|0;r=l;s=0;t=0;v=f[l>>2]|0}else{l=c<<2;m=$Xc(l)|0;f[i>>2]=m;w=m+(c<<2)|0;f[i+8>>2]=w;g1c(m|0,0,l|0)|0;f[o>>2]=w;w=a+48|0;l=f[w>>2]|0;x=l+1+(f[a+44>>2]|0)|0;y=0;do{z=Y(x,y)|0;A=+n[b+(z+2<<2)>>2];p[q+(y<<5)+16>>3]=A;B=+n[b+(z+3<<2)>>2];p[q+(y<<5)+24>>3]=B;p[q+(y<<5)>>3]=+n[b+(z<<2)>>2]-A*.5;p[q+(y<<5)+8>>3]=+n[b+(z+1<<2)>>2]-B*.5;y=y+1|0}while((y|0)!=(c|0));r=w;s=1;t=m;v=l}f[j>>2]=0;l=j+4|0;f[l>>2]=0;f[j+8>>2]=0;if((v|0)>0){m=a+44|0;a:do if(s){a=0;w=v;y=t;while(1){q=w+1+(f[m>>2]|0)|0;x=a+5|0;z=0;do{C=b+(x+(Y(q,z)|0)<<2)|0;f[y+(z<<2)>>2]=f[C>>2];n[C>>2]=0.0;z=z+1|0}while((z|0)!=(c|0));PKb(h,i,d,e,j,1.0,0);z=f[l>>2]|0;q=f[j>>2]|0;C=z-q|0;D=C>>2;E=q;q=f[r>>2]|0;if((C|0)>0){C=q+1+(f[m>>2]|0)|0;F=f[i>>2]|0;G=0;do{H=f[E+(G<<2)>>2]|0;I=Y(C,H)|0;f[b+(x+I<<2)>>2]=f[F+(H<<2)>>2];G=G+1|0}while((G|0)<(D|0))}D=a+1|0;if((D|0)>=(q|0)){J=z;K=E;break a}a=D;w=q;y=f[i>>2]|0}}else{y=0;do{PKb(h,i,d,e,j,1.0,0);w=f[l>>2]|0;a=f[j>>2]|0;D=w-a|0;G=D>>2;F=a;a=f[r>>2]|0;if((D|0)>0){D=a+1+(f[m>>2]|0)|0;x=f[i>>2]|0;C=y+5|0;H=0;do{I=f[F+(H<<2)>>2]|0;L=Y(D,I)|0;f[b+(C+L<<2)>>2]=f[x+(I<<2)>>2];H=H+1|0}while((H|0)<(G|0))}y=y+1|0}while((y|0)<(a|0));J=w;K=F}while(0);b=J;if(K|0){if((b|0)!=(K|0))f[l>>2]=b+(~((b+-4-K|0)>>>2)<<2);cYc(K)}}K=f[i>>2]|0;if(K|0){i=f[o>>2]|0;if((i|0)!=(K|0))f[o>>2]=i+(~((i+-4-K|0)>>>2)<<2);cYc(K)}K=f[h>>2]|0;if(!K){u=g;return}h=f[k>>2]|0;if((h|0)!=(K|0))f[k>>2]=h+(~((h+-32-K|0)>>>5)<<5);cYc(K);u=g;return}function Zxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0;d=u;u=u+80|0;e=d+64|0;g=d+16|0;h=d;i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=11;j=i;k=439315;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+11>>0]=0;i=LGa(c,e)|0;m=c+4|0;if((i|0)==(m|0))o=1;else{p=MGa(i+28|0,-1)|0;o=(p|0)!=0|(J|0)!=0}if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(o){o=$Xc(44)|0;qQa(o);f[o>>2]=104832;rQa(o,c);p=$Xc(16)|0;i=o;f[p+4>>2]=0;f[p+8>>2]=0;f[p>>2]=104944;f[p+12>>2]=i;f[a>>2]=i;f[a+4>>2]=p;u=d;return}p=$Xc(16)|0;f[g>>2]=p;f[g+8>>2]=-2147483632;f[g+4>>2]=13;j=p;k=439327;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[p+13>>0]=0;p=LGa(c,g)|0;if((p|0)==(m|0))q=.5;else q=+NGa(p+28|0,-1);r=1.0-q;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);n[e>>2]=r;if(!(r>0.0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=9;j=g;k=439341;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[g+9>>0]=0;vM(-215,g,467262,439351,139)}f[g+4>>2]=0;f[g+8>>2]=0;k=g+4|0;f[g>>2]=k;j=g+12|0;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));j=g+24|0;oYc(j,c+24|0)|0;c=g+36|0;tYc(c,439430)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=5;b[h>>0]=b[439436]|0;b[h+1>>0]=b[439437]|0;b[h+2>>0]=b[439438]|0;b[h+3>>0]=b[439439]|0;b[h+4>>0]=b[439440]|0;b[h+5>>0]=0;OGa(g,h,e)|0;if((b[l>>0]|0)<0)cYc(f[h>>2]|0);rub(h,g);f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);hx(g+12|0);QGa(g,f[k>>2]|0);u=d;return}function _xb(a){a=a|0;NXc(a);cYc(a);return}function $xb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function ayb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==439442?a+12|0:0)|0}function byb(a){a=a|0;cYc(a);return}function cyb(a){a=a|0;MNa(a);cYc(a);return}function dyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;a=d+28|0;e=d+16|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;gS(b,a);gS(c,e);c=f[e>>2]|0;b=(f[h>>2]|0)-c|0;h=(b|0)/56|0;if((b|0)<=0){hx(e);hx(a);u=d;return}b=g+8|0;i=g+4|0;j=0;k=c;while(1){c=f[a>>2]|0;if((f[k+(j*56|0)+16>>2]|0)!=(f[c+(j*56|0)+16>>2]|0)){l=b;f[l>>2]=0;f[l+4>>2]=0;f[g>>2]=33619968;f[i>>2]=k+(j*56|0);jR(c+(j*56|0)|0,g)}c=j+1|0;if((c|0)>=(h|0))break;j=c;k=f[e>>2]|0}hx(e);hx(a);u=d;return}function eyb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=orb()|0;break}default:c=0}return c|0}function fyb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function gyb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cOa(a,b,c,d,e)|0;return 1}function hyb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(68)|0;iyb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=104972;f[b+12>>2]=c;f[a+4>>2]=b;return}function iyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+16|0;g=d;qQa(a);h=a+44|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a>>2]=105e3;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=8;j=e;f[j>>2]=1819242352;f[j+4>>2]=2002742111;b[e+8>>0]=0;j=MGa(NIa(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=g+11|0;b[k>>0]=8;l=g;f[l>>2]=1819242352;f[l+4>>2]=1751083871;b[g+8>>0]=0;l=MGa(NIa(c,g)|0,-1)|0;f[h>>2]=j;f[a+48>>2]=l;if((b[k>>0]|0)<0)cYc(f[g>>2]|0);if((b[i>>0]|0)<0)cYc(f[e>>2]|0);i=e+11|0;b[i>>0]=10;k=e;l=439824;j=k+10|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(j|0));b[e+10>>0]=0;h=MGa(NIa(c,e)|0,-1)|0;m=g+11|0;b[m>>0]=10;k=g;l=439835;j=k+10|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(j|0));b[g+10>>0]=0;n=MGa(NIa(c,g)|0,-1)|0;f[a+52>>2]=h;f[a+56>>2]=n;if((b[m>>0]|0)<0)cYc(f[g>>2]|0);if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=13;k=i;l=439846;j=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(j|0));b[i+13>>0]=0;i=MGa(NIa(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=$Xc(16)|0;f[g>>2]=m;f[g+8>>2]=-2147483632;f[g+4>>2]=13;k=m;l=439860;j=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(j|0));b[m+13>>0]=0;m=MGa(NIa(c,g)|0,-1)|0;f[a+60>>2]=i;f[a+64>>2]=m;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function jyb(a){a=a|0;NXc(a);cYc(a);return}function kyb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function lyb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==439661?a+12|0:0)|0}function myb(a){a=a|0;cYc(a);return}function nyb(a){a=a|0;MNa(a);cYc(a);return}function oyb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;g=u;u=u+208|0;h=g+80|0;i=g+68|0;j=g+56|0;k=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;a=j+4|0;f[a>>2]=0;f[j+8>>2]=0;gS(c,i);gS(d,j);d=f[i>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=112){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(32)|0;f[h>>2]=d;f[h+8>>2]=-2147483616;f[h+4>>2]=18;l=d;m=455503;o=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[d+18>>0]=0;vM(-215,h,456135,439874,74)}d=f[c+4>>2]|0;if((d|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{e=f[c+40>>2]|0;r=0;s=1;while(1){t=Y(f[e+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(d|0)){q=t;break}else s=t}}s=f[c+60>>2]|0;if((s|0)<3)v=Y(f[c+68>>2]|0,f[c+64>>2]|0)|0;else{d=f[c+96>>2]|0;r=0;e=1;while(1){t=Y(f[d+(r<<2)>>2]|0,e)|0;r=r+1|0;if((r|0)==(s|0)){v=t;break}else e=t}}if((q|0)!=(v|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=32;l=v;m=439961;o=l+32|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[v+32>>0]=0;vM(-215,h,456135,439874,78)}v=c+40|0;if((f[f[v>>2]>>2]|0)!=1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=$Xc(32)|0;f[h>>2]=q;f[h+8>>2]=-2147483616;f[h+4>>2]=18;l=q;m=439994;o=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[q+18>>0]=0;vM(-215,h,456135,439874,79)}if(!(f[c>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=$Xc(32)|0;f[h>>2]=q;f[h+8>>2]=-2147483616;f[h+4>>2]=20;l=q;m=452483;o=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[q+20>>0]=0;vM(-215,h,456135,439874,80)}q=f[j>>2]|0;a:do if((f[a>>2]|0)!=(q|0)){e=h+8|0;s=h+12|0;r=h+4|0;d=c+16|0;t=c+44|0;w=c+72|0;x=c+100|0;y=k+16|0;z=k+44|0;A=k+36|0;B=k+4|0;C=k+40|0;D=k+48|0;E=0;F=q;b:while(1){G=F;H=G+(E*56|0)|0;p[k>>3]=0.0;f[h>>2]=-1056833530;f[r>>2]=k;f[e>>2]=1;f[s>>2]=1;mR(H,h,fT()|0)|0;I=f[(f[v>>2]|0)+4>>2]|0;J=G+(E*56|0)+40|0;K=f[J>>2]|0;if((I|0)!=(f[K+4>>2]|0)){L=23;break}M=Y(f[K+12>>2]|0,f[K+8>>2]|0)|0;if((I|0)>0){I=G+(E*56|0)+4|0;K=G+(E*56|0)+16|0;N=G+(E*56|0)+44|0;O=0;while(1){G=f[I>>2]|0;if((G|0)<=2){L=28;break b}P=f[J>>2]|0;Q=2;do{f[h+(Q+-2<<2)>>2]=f[P+(Q<<2)>>2];Q=Q+1|0}while((Q|0)!=(G|0));_$(k,G+-2|0,h,f[H>>2]&4095,(f[K>>2]|0)+(Y(f[(f[N>>2]|0)+4>>2]|0,O)|0)|0,0);Q=f[v>>2]|0;P=Y(f[Q+12>>2]|0,f[Q+8>>2]|0)|0;R=(f[d>>2]|0)+(Y(f[(f[t>>2]|0)+4>>2]|0,O)|0)|0;Q=(f[w>>2]|0)+(Y(f[(f[x>>2]|0)+4>>2]|0,O)|0)|0;S=f[y>>2]|0;if((P|0)>0){T=0;while(1){U=~~+n[Q+(T<<2)>>2];if(!((U|0)>-1&(U|0)<(M|0))){L=42;break b}f[S+(U<<2)>>2]=f[R+(T<<2)>>2];V=T+1|0;if((V|0)<(P|0))T=V;else break}}P=f[A>>2]|0;if(P|0?(S=P+12|0,P=f[S>>2]|0,f[S>>2]=P+-1,(P|0)==1):0)V$(k);f[A>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[B>>2]|0)>0){P=f[C>>2]|0;S=0;do{f[P+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[B>>2]|0))}S=f[z>>2]|0;if((S|0)!=(D|0))wL(S);S=O+1|0;if((S|0)<(f[(f[v>>2]|0)+4>>2]|0))O=S;else break}}N=E+1|0;F=f[j>>2]|0;if(N>>>0>=(((f[a>>2]|0)-F|0)/56|0)>>>0)break a;else E=N}if((L|0)==23){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;F=$Xc(48)|0;f[h>>2]=F;f[h+8>>2]=-2147483600;f[h+4>>2]=32;l=F;m=440013;o=l+32|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[F+32>>0]=0;vM(-215,h,456135,439874,86)}else if((L|0)==28){b[h+11>>0]=10;l=h;m=450129;o=l+10|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[h+10>>0]=0;vM(-215,h,450140,454620,110)}else if((L|0)==42){F=nOc(BM(895384,440046,4)|0,E)|0;ZNc(h,F+(f[(f[F>>2]|0)+-12>>2]|0)|0);D=DPc(h,896088)|0;z=Mi[f[(f[D>>2]|0)+28>>2]&1023](D,10)|0;EPc(h);sOc(F,z)|0;dOc(F)|0;z=nOc(BM(F,440051,4)|0,O)|0;ZNc(h,z+(f[(f[z>>2]|0)+-12>>2]|0)|0);F=DPc(h,896088)|0;D=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;EPc(h);sOc(z,D)|0;dOc(z)|0;D=nOc(BM(z,440056,5)|0,T)|0;ZNc(h,D+(f[(f[D>>2]|0)+-12>>2]|0)|0);z=DPc(h,896088)|0;F=Mi[f[(f[z>>2]|0)+28>>2]&1023](z,10)|0;EPc(h);sOc(D,F)|0;dOc(D)|0;F=nOc(BM(D,440062,6)|0,U)|0;ZNc(h,F+(f[(f[F>>2]|0)+-12>>2]|0)|0);D=DPc(h,896088)|0;z=Mi[f[(f[D>>2]|0)+28>>2]&1023](D,10)|0;EPc(h);sOc(F,z)|0;dOc(F)|0;z=BM(F,440069,7)|0;F=pOc(z,+n[R+(T<<2)>>2])|0;ZNc(h,F+(f[(f[F>>2]|0)+-12>>2]|0)|0);z=DPc(h,896088)|0;D=Mi[f[(f[z>>2]|0)+28>>2]&1023](z,10)|0;EPc(h);sOc(F,D)|0;dOc(F)|0;D=nOc(BM(F,440077,14)|0,M)|0;ZNc(h,D+(f[(f[D>>2]|0)+-12>>2]|0)|0);F=DPc(h,896088)|0;z=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;EPc(h);sOc(D,z)|0;dOc(D)|0;z=BM(D,440092,11)|0;D=f[v>>2]|0;F=f[D+-4>>2]|0;c:do if((F|0)>0){B=F+-1|0;C=0;y=D;while(1){nOc(z,f[y+(C<<2)>>2]|0)|0;if((C|0)<(B|0))BM(z,440104,3)|0;A=C+1|0;if((A|0)==(F|0))break c;C=A;y=f[v>>2]|0}}while(0);ZNc(h,z+(f[(f[z>>2]|0)+-12>>2]|0)|0);F=DPc(h,896088)|0;D=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;EPc(h);sOc(z,D)|0;dOc(z)|0;D=BM(z,440108,13)|0;F=c+96|0;E=f[F>>2]|0;y=f[E+-4>>2]|0;d:do if((y|0)>0){C=y+-1|0;B=0;A=E;while(1){nOc(D,f[A+(B<<2)>>2]|0)|0;if((B|0)<(C|0))BM(D,440104,3)|0;x=B+1|0;if((x|0)==(y|0))break d;B=x;A=f[F>>2]|0}}while(0);ZNc(h,D+(f[(f[D>>2]|0)+-12>>2]|0)|0);F=DPc(h,896088)|0;y=Mi[f[(f[F>>2]|0)+28>>2]&1023](F,10)|0;EPc(h);sOc(D,y)|0;dOc(D)|0;y=BM(D,440122,8)|0;F=f[J>>2]|0;E=f[F+-4>>2]|0;if((E|0)<=0){W=f[y>>2]|0;X=W+-12|0;Z=f[X>>2]|0;_=y+Z|0;ZNc(h,_);$=DPc(h,896088)|0;aa=f[$>>2]|0;ba=aa+28|0;ca=f[ba>>2]|0;da=Mi[ca&1023]($,10)|0;EPc(h);sOc(y,da)|0;dOc(y)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ea=$Xc(48)|0;f[h>>2]=ea;fa=h+8|0;f[fa>>2]=-2147483600;ga=h+4|0;f[ga>>2]=35;l=ea;m=440131;o=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));ha=ea+35|0;b[ha>>0]=0;vM(-215,h,456135,439874,113)}D=E+-1|0;z=0;A=F;while(1){nOc(y,f[A+(z<<2)>>2]|0)|0;if((z|0)<(D|0))BM(y,440104,3)|0;B=z+1|0;if((B|0)==(E|0))break;z=B;A=f[J>>2]|0}W=f[y>>2]|0;X=W+-12|0;Z=f[X>>2]|0;_=y+Z|0;ZNc(h,_);$=DPc(h,896088)|0;aa=f[$>>2]|0;ba=aa+28|0;ca=f[ba>>2]|0;da=Mi[ca&1023]($,10)|0;EPc(h);sOc(y,da)|0;dOc(y)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ea=$Xc(48)|0;f[h>>2]=ea;fa=h+8|0;f[fa>>2]=-2147483600;ga=h+4|0;f[ga>>2]=35;l=ea;m=440131;o=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));ha=ea+35|0;b[ha>>0]=0;vM(-215,h,456135,439874,113)}}while(0);hx(j);hx(i);u=g;return}function pyb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 1:{if(zQa()|0?(f[a+52>>2]|0)==0:0)c=(f[a+56>>2]|0)==0;else c=0;break}default:c=0}return c|0}function qyb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ryb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=24){c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=18;j=c;k=455503;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[c+18>>0]=0;vM(-215,d,456079,439874,46)}c=f[i+4>>2]|0;m=f[h>>2]|0;h=c-m|0;n=h>>2;o=m;if((o|0)!=(c|0)){if((h|0)<=-4){c=$Xc(80)|0;f[d>>2]=c;f[d+8>>2]=-2147483568;f[d+4>>2]=70;j=c;k=454543;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[c+70>>0]=0;vM(-215,d,454614,454620,161)}if((h|0)>0){h=0;c=1;while(1){m=Y(f[o+(h<<2)>>2]|0,c)|0;h=h+1|0;if((h|0)>=(n|0)){p=m;break}else c=m}}else p=1}else p=0;c=f[i+16>>2]|0;n=f[i+12>>2]|0;h=c-n|0;o=h>>2;m=n;if((m|0)!=(c|0)){if((h|0)<=-4){c=$Xc(80)|0;f[d>>2]=c;f[d+8>>2]=-2147483568;f[d+4>>2]=70;j=c;k=454543;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[c+70>>0]=0;vM(-215,d,454614,454620,161)}if((h|0)>0){h=0;c=1;while(1){n=Y(f[m+(h<<2)>>2]|0,c)|0;h=h+1|0;if((h|0)>=(o|0)){q=n;break}else c=n}}else q=1}else q=0;if((p|0)!=(q|0)){q=$Xc(48)|0;f[d>>2]=q;f[d+8>>2]=-2147483600;f[d+4>>2]=36;j=q;k=441374;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+36>>0]=0;vM(-215,d,456079,439874,47)}eKa(d,i);i=f[d>>2]|0;q=i+8|0;k=Y((f[q>>2]|0)+-1|0,f[a+64>>2]|0)|0;f[q>>2]=k+(f[a+48>>2]|0)-(f[a+56>>2]<<1);k=i+12|0;i=Y((f[k>>2]|0)+-1|0,f[a+60>>2]|0)|0;f[k>>2]=i+(f[a+44>>2]|0)-(f[a+52>>2]<<1);a=f[e>>2]|0;i=e+4|0;k=f[i>>2]|0;if((k|0)!=(a|0)){q=k;while(1){k=q+-12|0;f[i>>2]=k;j=f[k>>2]|0;if(!j)r=k;else{k=q+-8|0;l=f[k>>2]|0;if((l|0)!=(j|0))f[k>>2]=l+(~((l+-4-j|0)>>>2)<<2);cYc(j);r=f[i>>2]|0}if((r|0)==(a|0))break;else q=r}}if((a|0)==(f[e+8>>2]|0)){fKa(e,d);s=f[d>>2]|0}else{f[a>>2]=0;e=a+4|0;f[e>>2]=0;f[a+8>>2]=0;r=d+4|0;q=f[d>>2]|0;j=(f[r>>2]|0)-q|0;l=j>>2;if(l){if(l>>>0>1073741823)kWc(a);k=$Xc(j)|0;f[e>>2]=k;f[a>>2]=k;f[a+8>>2]=k+(l<<2);l=f[d>>2]|0;a=(f[r>>2]|0)-l|0;if((a|0)>0){o1c(k|0,l|0,a|0)|0;f[e>>2]=k+(a>>>2<<2);t=l}else t=l}else t=q;f[i>>2]=(f[i>>2]|0)+12;s=t}if(!s){u=g;return 0}t=d+4|0;d=f[t>>2]|0;if((d|0)!=(s|0))f[t>>2]=d+(~((d+-4-s|0)>>>2)<<2);cYc(s);u=g;return 0}function syb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(80)|0;tyb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=105112;f[b+12>>2]=c;f[a+4>>2]=b;return}function tyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=105140;g=a+48|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(16)|0;f[e>>2]=g;f[e+8>>2]=-2147483632;f[e+4>>2]=12;h=g;i=440394;j=h+12|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+12>>0]=0;g=LGa(c,e)|0;if((g|0)==(c+4|0))k=2;else{c=MGa(g+28|0,-1)|0;k=c}c=a+44|0;f[c>>2]=k;if((b[e+11>>0]|0)<0){cYc(f[e>>2]|0);l=f[c>>2]|0}else l=k;if((l|0)>0){u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;d=$Xc(16)|0;f[e>>2]=d;f[e+8>>2]=-2147483632;f[e+4>>2]=15;h=d;i=440407;j=h+15|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[d+15>>0]=0;vM(-215,e,440423,440438,67)}}function uyb(a){a=a|0;NXc(a);cYc(a);return}function vyb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function wyb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==440239?a+12|0:0)|0}function xyb(a){a=a|0;cYc(a);return}function yyb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=105140;b=f[a+68>>2]|0;if(b|0){c=a+72|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+56>>2]|0;if(b|0){d=a+60|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+52>>2]|0;if(!b){MNa(a);return}UXc(b);MNa(a);return}function zyb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=105140;b=f[a+68>>2]|0;if(b|0){c=a+72|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+56>>2]|0;if(b|0){d=a+60|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+52>>2]|0;if(!b){MNa(a);cYc(a);return}UXc(b);MNa(a);cYc(a);return}function Ayb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=u;u=u+320|0;g=e+300|0;h=e+288|0;i=e+232|0;j=e+176|0;k=e+128|0;l=e+112|0;m=e+56|0;n=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=f[g>>2]|0;f[i>>2]=f[d>>2];c=i+4|0;o=d+4|0;f[c>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];q=i+16|0;f[q>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[i+32>>2]=f[d+32>>2];r=i+36|0;s=f[d+36>>2]|0;f[r>>2]=s;t=i+40|0;f[t>>2]=p;p=i+48|0;v=i+44|0;f[v>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(s|0){w=s+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[o>>2]|0)<3){o=f[d+44>>2]|0;w=f[v>>2]|0;f[w>>2]=f[o>>2];f[w+4>>2]=f[o+4>>2]}else{f[c>>2]=0;U$(i,d)}d=f[h>>2]|0;f[j>>2]=f[d>>2];o=j+4|0;w=d+4|0;f[o>>2]=f[w>>2];s=j+8|0;f[s>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];x=j+16|0;f[x>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];y=j+36|0;z=f[d+36>>2]|0;f[y>>2]=z;A=j+40|0;f[A>>2]=s;s=j+48|0;B=j+44|0;f[B>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(z|0){C=z+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[w>>2]|0)<3){w=f[d+44>>2]|0;C=f[B>>2]|0;f[C>>2]=f[w>>2];f[C+4>>2]=f[w+4>>2]}else{f[o>>2]=0;U$(j,d)}d=f[f[t>>2]>>2]|0;f[k+4>>2]=0;f[k+8>>2]=0;w=k+4|0;f[k>>2]=w;C=k+12|0;z=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(z|0));if((d|0)==1){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;C=l+11|0;b[C>>0]=5;b[l>>0]=b[450562]|0;b[l+1>>0]=b[450563]|0;b[l+2>>0]=b[450564]|0;b[l+3>>0]=b[450565]|0;b[l+4>>0]=b[450566]|0;b[l+5>>0]=0;z=$Xc(16)|0;f[z>>2]=z+8;f[z+4>>2]=4;D=bYc(32)|0;f[z>>2]=D;f[m>>2]=0;f[m+4>>2]=z;z=D;f[z>>2]=1;f[z+4>>2]=0;z=D+8|0;f[z>>2]=3;f[z+4>>2]=0;z=D+16|0;f[z>>2]=0;f[z+4>>2]=0;z=D+24|0;f[z>>2]=2;f[z+4>>2]=0;$Ga(k,l,m)|0;RGa(m);if((b[C>>0]|0)<0)cYc(f[l>>2]|0);C=a+56|0;z=a+60|0;D=f[z>>2]|0;E=f[C>>2]|0;F=D-E>>2;G=E;E=D;if(F>>>0>=4)if((F|0)!=4?(D=G+16|0,(E|0)!=(D|0)):0){f[z>>2]=E+(~((E+-4-D|0)>>>2)<<2);H=G}else H=G;else{CS(C,4-F|0);H=f[C>>2]|0}F=f[t>>2]|0;G=Y(f[F+8>>2]|0,f[F+4>>2]|0)|0;D=a+44|0;E=f[D>>2]|0;z=(G|0)/(Y(E,E)|0)|0;f[H>>2]=z;f[H+4>>2]=f[D>>2];f[H+8>>2]=f[F+12>>2];f[H+12>>2]=f[D>>2];D=a+68|0;F=a+72|0;z=f[F>>2]|0;E=f[D>>2]|0;G=z-E>>2;I=E;E=z;if(G>>>0>=4)if((G|0)!=4?(z=I+16|0,(E|0)!=(z|0)):0){f[F>>2]=E+(~((E+-4-z|0)>>>2)<<2);J=H;K=I}else{J=H;K=I}else{CS(D,4-G|0);J=f[C>>2]|0;K=f[D>>2]|0}f[K>>2]=f[J+4>>2];f[K+4>>2]=f[J+12>>2];f[K+8>>2]=f[J>>2];L=J+8|0;M=K+12|0}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;K=l+11|0;b[K>>0]=5;b[l>>0]=b[450562]|0;b[l+1>>0]=b[450563]|0;b[l+2>>0]=b[450564]|0;b[l+3>>0]=b[450565]|0;b[l+4>>0]=b[450566]|0;b[l+5>>0]=0;J=$Xc(16)|0;f[J>>2]=J+8;f[J+4>>2]=5;D=bYc(40)|0;f[J>>2]=D;f[m>>2]=0;f[m+4>>2]=J;J=D;f[J>>2]=0;f[J+4>>2]=0;J=D+8|0;f[J>>2]=2;f[J+4>>2]=0;J=D+16|0;f[J>>2]=4;f[J+4>>2]=0;J=D+24|0;f[J>>2]=1;f[J+4>>2]=0;J=D+32|0;f[J>>2]=3;f[J+4>>2]=0;$Ga(k,l,m)|0;RGa(m);if((b[K>>0]|0)<0)cYc(f[l>>2]|0);K=a+56|0;J=a+60|0;D=f[J>>2]|0;C=f[K>>2]|0;G=D-C>>2;I=C;C=D;if(G>>>0>=5)if((G|0)!=5?(D=I+20|0,(C|0)!=(D|0)):0){f[J>>2]=C+(~((C+-4-D|0)>>>2)<<2);N=I}else N=I;else{CS(K,5-G|0);N=f[K>>2]|0}f[N>>2]=d;d=f[t>>2]|0;G=Y(f[d+8>>2]|0,f[d+4>>2]|0)|0;I=a+44|0;D=f[I>>2]|0;C=(G|0)/(Y(D,D)|0)|0;f[N+4>>2]=C;f[N+8>>2]=f[I>>2];f[N+12>>2]=f[d+12>>2];f[N+16>>2]=f[I>>2];I=a+68|0;d=a+72|0;C=f[d>>2]|0;D=f[I>>2]|0;G=C-D>>2;J=D;D=C;if(G>>>0>=5)if((G|0)!=5?(C=J+20|0,(D|0)!=(C|0)):0){f[d>>2]=D+(~((D+-4-C|0)>>>2)<<2);O=N;P=J}else{O=N;P=J}else{CS(I,5-G|0);O=f[K>>2]|0;P=f[I>>2]|0}f[P>>2]=f[O>>2];f[P+4>>2]=f[O+8>>2];f[P+8>>2]=f[O+16>>2];f[P+12>>2]=f[O+4>>2];L=O+12|0;M=P+16|0}f[M>>2]=f[L>>2];iDb(l,k);L=a+48|0;M=f[l>>2]|0;P=l+4|0;O=f[P>>2]|0;if(O|0)TXc(O);f[L>>2]=M;M=a+52|0;I=f[M>>2]|0;f[M>>2]=O;if(I|0)UXc(I);I=f[P>>2]|0;if(I|0)UXc(I);i0(m,i,1,a+56|0);lOa(l,1,m);I=m+36|0;P=f[I>>2]|0;if(P|0?(O=P+12|0,P=f[O>>2]|0,f[O>>2]=P+-1,(P|0)==1):0)V$(m);f[I>>2]=0;I=m+16|0;P=m+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[P>>2]|0)>0){I=f[m+40>>2]|0;O=0;do{f[I+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[m+44>>2]|0;if((P|0)!=(m+48|0))wL(P);i0(n,j,1,a+68|0);lOa(m,1,n);a=n+36|0;P=f[a>>2]|0;if(P|0?(O=P+12|0,P=f[O>>2]|0,f[O>>2]=P+-1,(P|0)==1):0)V$(n);f[a>>2]=0;a=n+16|0;P=n+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[P>>2]|0)>0){a=f[n+40>>2]|0;O=0;do{f[a+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[n+44>>2]|0;if((P|0)!=(n+48|0))wL(P);sQa(f[L>>2]|0,l,m);hx(m);hx(l);l=k+36|0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);l=k+24|0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);hx(k+12|0);QGa(k,f[w>>2]|0);w=f[y>>2]|0;if(w|0?(k=w+12|0,w=f[k>>2]|0,f[k>>2]=w+-1,(w|0)==1):0)V$(j);f[y>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[o>>2]|0)>0){x=f[A>>2]|0;A=0;do{f[x+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[o>>2]|0))}o=f[B>>2]|0;if((o|0)!=(s|0))wL(o);o=f[r>>2]|0;do if(o|0){s=o+12|0;B=f[s>>2]|0;f[s>>2]=B+-1;if((B|0)!=1)break;V$(i)}while(0);f[r>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[c>>2]|0)>0){q=f[t>>2]|0;t=0;do{f[q+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[c>>2]|0))}c=f[v>>2]|0;if((c|0)==(p|0)){hx(h);hx(g);u=e;return}wL(c);hx(h);hx(g);u=e;return}function Byb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+16|0;j=e;if((qS(b,-1)|0)==3){fOa(a,b,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(b,g);gS(c,h);i0(i,f[g>>2]|0,1,a+56|0);c=f[g>>2]|0;if((c|0)==(i|0)){b=i+36|0;k=f[b>>2]|0;if((k|0)!=0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0){V$(i);m=b}else m=b}else{b=c+36|0;k=f[b>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)V$(c);f[b>>2]=0;k=c+16|0;l=c+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){n=f[c+40>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}f[c>>2]=f[i>>2];o=i+4|0;f[l>>2]=f[o>>2];l=i+8|0;n=c+8|0;f[n>>2]=f[l>>2];f[c+12>>2]=f[i+12>>2];f[k>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[c+28>>2]=f[i+28>>2];f[c+32>>2]=f[i+32>>2];k=i+36|0;f[b>>2]=f[k>>2];b=c+44|0;p=f[b>>2]|0;q=c+48|0;if((p|0)==(q|0))r=p;else{wL(p);f[b>>2]=q;f[c+40>>2]=n;r=q}q=i+44|0;if((f[o>>2]|0)<3){n=f[q>>2]|0;f[r>>2]=f[n>>2];f[r+4>>2]=f[n+4>>2]}else{f[b>>2]=f[q>>2];b=i+40|0;f[c+40>>2]=f[b>>2];f[q>>2]=i+48;f[b>>2]=l}f[i>>2]=1124007936;s=o;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));m=k}f[m>>2]=0;m=i+16|0;k=i+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[i+40>>2]|0;o=0;do{f[m+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))wL(k);i0(i,f[h>>2]|0,1,a+68|0);k=f[h>>2]|0;if((k|0)==(i|0)){o=i+36|0;m=f[o>>2]|0;if((m|0)!=0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0){V$(i);v=o}else v=o}else{o=k+36|0;m=f[o>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)V$(k);f[o>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){b=f[k+40>>2]|0;q=0;do{f[b+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[l>>2]|0))}f[k>>2]=f[i>>2];q=i+4|0;f[l>>2]=f[q>>2];l=i+8|0;b=k+8|0;f[b>>2]=f[l>>2];f[k+12>>2]=f[i+12>>2];f[m>>2]=f[i+16>>2];f[k+20>>2]=f[i+20>>2];f[k+24>>2]=f[i+24>>2];f[k+28>>2]=f[i+28>>2];f[k+32>>2]=f[i+32>>2];m=i+36|0;f[o>>2]=f[m>>2];o=k+44|0;c=f[o>>2]|0;n=k+48|0;if((c|0)==(n|0))w=c;else{wL(c);f[o>>2]=n;f[k+40>>2]=b;w=n}n=i+44|0;if((f[q>>2]|0)<3){b=f[n>>2]|0;f[w>>2]=f[b>>2];f[w+4>>2]=f[b+4>>2]}else{f[o>>2]=f[n>>2];o=i+40|0;f[k+40>>2]=f[o>>2];f[n>>2]=i+48;f[o>>2]=l}f[i>>2]=1124007936;s=q;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));v=m}f[v>>2]=0;v=i+16|0;m=i+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[m>>2]|0)>0){v=f[i+40>>2]|0;s=0;do{f[v+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[m>>2]|0))}m=f[i+44>>2]|0;if((m|0)!=(i+48|0))wL(m);m=f[a+48>>2]|0;a=f[(f[m>>2]|0)+44>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=g;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33882112;f[j+4>>2]=h;ei[a&511](m,i,j,d);hx(h);hx(g);u=e;return}function Cyb(a,b){a=a|0;b=b|0;return (b|1|0)==3|0}function Dyb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Eyb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+48|0;d=g+24|0;h=g+12|0;i=g;j=f[c+4>>2]|0;k=f[c>>2]|0;if((j|0)==(k|0)){l=$Xc(32)|0;f[d>>2]=l;f[d+8>>2]=-2147483616;f[d+4>>2]=17;m=l;n=452630;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+17>>0]=0;vM(-215,d,456079,440438,75)}l=(j-k|0)/12|0;j=f[k>>2]|0;k=f[a+44>>2]|0;a=Y(Y(k,f[j+4>>2]|0)|0,k)|0;p=(f[j+8>>2]|0)/(k|0)|0;q=(f[j+12>>2]|0)/(k|0)|0;f[d>>2]=f[j>>2];f[d+4>>2]=a;f[d+8>>2]=p;f[d+12>>2]=q;f[i>>2]=0;q=i+4|0;f[q>>2]=0;f[i+8>>2]=0;gOa(i,d,d+16|0);p=f[i>>2]|0;a=f[q>>2]|0;a:do if((p|0)==(a|0)){r=p;s=6}else{j=p;do{if((f[j>>2]|0)<0){r=j;s=6;break a}j=j+4|0}while((j|0)!=(a|0))}while(0);if((s|0)==6?(r|0)!=(a|0):0){s=r+4|0;if((s|0)==(a|0)){t=a;v=r}else{p=s;s=r;while(1){r=f[p>>2]|0;if((r|0)<0)w=s;else{f[s>>2]=r;w=s+4|0}p=p+4|0;if((p|0)==(a|0))break;else s=w}t=f[q>>2]|0;v=w}if((v|0)!=(t|0))f[q>>2]=t+(~((t+-4-v|0)>>>2)<<2)}Gyb(h,l,i);l=f[e>>2]|0;if(!l){x=e+4|0;y=e+8|0}else{v=e+4|0;t=f[v>>2]|0;if((t|0)==(l|0))z=l;else{w=t;while(1){t=w+-12|0;f[v>>2]=t;s=f[t>>2]|0;if(!s)A=t;else{t=w+-8|0;a=f[t>>2]|0;if((a|0)!=(s|0))f[t>>2]=a+(~((a+-4-s|0)>>>2)<<2);cYc(s);A=f[v>>2]|0}if((A|0)==(l|0))break;else w=A}z=f[e>>2]|0}cYc(z);z=e+8|0;f[z>>2]=0;f[v>>2]=0;f[e>>2]=0;x=v;y=z}z=f[h>>2]|0;f[e>>2]=z;v=h+4|0;f[x>>2]=f[v>>2];x=h+8|0;f[y>>2]=f[x>>2];f[x>>2]=0;f[v>>2]=0;f[h>>2]=0;h=f[i>>2]|0;if(!h)B=z;else{z=f[q>>2]|0;if((z|0)!=(h|0))f[q>>2]=z+(~((z+-4-h|0)>>>2)<<2);cYc(h);B=f[e>>2]|0}e=f[B>>2]|0;h=f[e>>2]|0;z=e;if((((h|0)>0?(f[e+4>>2]|0)>0:0)?(f[e+8>>2]|0)>0:0)?(f[e+12>>2]|0)>0:0){q=f[B+4>>2]|0;B=q-z|0;z=B>>2;if((e|0)!=(q|0)){if((B|0)<=-4){q=$Xc(80)|0;f[d>>2]=q;f[d+8>>2]=-2147483568;f[d+4>>2]=70;m=q;n=454543;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[q+70>>0]=0;vM(-215,d,454614,454620,161)}if((B|0)>0)if((B|0)>4){B=1;q=h;while(1){i=Y(f[e+(B<<2)>>2]|0,q)|0;B=B+1|0;if((B|0)>=(z|0)){C=i;break}else q=i}}else C=h;else C=1}else C=0;h=f[c>>2]|0;c=f[h+4>>2]|0;q=f[h>>2]|0;h=c-q|0;z=h>>2;B=q;if((B|0)!=(c|0)){if((h|0)<=-4){c=$Xc(80)|0;f[d>>2]=c;f[d+8>>2]=-2147483568;f[d+4>>2]=70;m=c;n=454543;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[c+70>>0]=0;vM(-215,d,454614,454620,161)}if((h|0)>0){h=0;c=1;while(1){q=Y(f[B+(h<<2)>>2]|0,c)|0;h=h+1|0;if((h|0)>=(z|0)){D=q;break}else c=q}}else D=1}else D=0;if((C|0)==(D|0)){u=g;return 0}else{g=$Xc(48)|0;f[d>>2]=g;f[d+8>>2]=-2147483600;f[d+4>>2]=37;m=g;n=440598;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[g+37>>0]=0;vM(-215,d,456079,440438,83)}}g=$Xc(96)|0;f[d>>2]=g;f[d+8>>2]=-2147483552;f[d+4>>2]=80;m=g;n=440517;o=m+80|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[g+80>>0]=0;vM(-215,d,456079,440438,82);return 0}function Fyb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r*21|0;o=d1c(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;d=454543;h=i+70|0;do{b[i>>0]=b[d>>0]|0;i=i+1|0;d=d+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function Gyb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)kWc(a);e=$Xc(b*12|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*12|0);a=b;b=e;do{eKa(b,c);b=(f[d>>2]|0)+12|0;f[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function Hyb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(64)|0;Iyb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=105252;f[b+12>>2]=c;f[a+4>>2]=b;return}function Iyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d+16|0;g=d;qQa(a);h=a+44|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[a>>2]=105280;rQa(a,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=4;f[g>>2]=1936291937;b[g+4>>0]=0;i=LGa(c,g)|0;j=c+4|0;if((i|0)==(j|0))k=0;else{l=MGa(i+28|0,-1)|0;k=l}if((b[h>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=8;l=g;f[l>>2]=1601009006;f[l+4>>2]=1936029793;b[g+8>>0]=0;l=LGa(c,g)|0;if((l|0)==(j|0))m=-1;else{j=MGa(l+28|0,-1)|0;m=j}if((b[h>>0]|0)<0)cYc(f[g>>2]|0);if((m|0)<=-2){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=13;j=h;l=440859;i=j+13|0;do{b[j>>0]=b[l>>0]|0;j=j+1|0;l=l+1|0}while((j|0)<(i|0));b[h+13>>0]=0;vM(-215,g,440873,440890,164)}h=(m|0)==-1;l=m+k|0;m=a+56|0;j=m;f[j>>2]=k;f[j+4>>2]=h?2147483647:l;l=a+44|0;h=f[l>>2]|0;j=a+48|0;a=f[j>>2]|0;if((a|0)!=(h|0))f[j>>2]=a+(~((a+-4-h|0)>>>2)<<2);h=g+4|0;f[h>>2]=0;f[h+4>>2]=0;h=g+11|0;b[h>>0]=3;b[g>>0]=b[515177]|0;b[g+1>>0]=b[515178]|0;b[g+2>>0]=b[515179]|0;b[g+3>>0]=0;a=(HIa(c,g)|0)==0;if((b[h>>0]|0)<0)cYc(f[g>>2]|0);if(a){u=d;return}a=g+4|0;f[a>>2]=0;f[a+4>>2]=0;a=g+11|0;b[a>>0]=3;b[g>>0]=b[515177]|0;b[g+1>>0]=b[515178]|0;b[g+2>>0]=b[515179]|0;b[g+3>>0]=0;h=NIa(c,g)|0;if((b[a>>0]|0)<0)cYc(f[g>>2]|0);a=f[h>>2]|0;switch(a|0){case 0:{n=(f[h+4>>2]|0)+4|0;break}case 3:{n=(f[h+4>>2]|0)+4|0;break}case 2:{n=(f[h+4>>2]|0)+4|0;break}default:{f[e>>2]=a;DM(g,455363,e);vM(-3,g,470867,455383,297)}}g=f[n>>2]|0;n=f[j>>2]|0;e=f[l>>2]|0;a=n-e>>2;c=e;e=n;if(g>>>0<=a>>>0){if(g>>>0<a>>>0?(n=c+(g<<2)|0,(e|0)!=(n|0)):0)f[j>>2]=e+(~((e+-4-n|0)>>>2)<<2)}else CS(l,g-a|0);if((g|0)>0)o=0;else{u=d;return}do{a=MGa(h,o)|0;f[(f[l>>2]|0)+(o<<2)>>2]=a;o=o+1|0}while((o|0)<(g|0));u=d;return}function Jyb(a){a=a|0;NXc(a);cYc(a);return}function Kyb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Lyb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==440700?a+12|0:0)|0}function Myb(a){a=a|0;cYc(a);return}function Nyb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=105392;b=f[a+44>>2]|0;if(!b){MNa(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);return}function Oyb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=105392;b=f[a+44>>2]|0;if(!b){MNa(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);cYc(a);return}function Pyb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=105392;b=f[a+44>>2]|0;if(!b){MNa(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);cYc(a);return}function Qyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+176|0;a=d+156|0;e=d+144|0;g=d+88|0;h=d+32|0;i=d+16|0;j=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[e>>2]=0;k=e+4|0;f[k>>2]=0;f[e+8>>2]=0;gS(b,a);gS(c,e);if((f[k>>2]|0)==(f[e>>2]|0)){hx(e);hx(a);u=d;return}c=g+4|0;b=g+8|0;l=g+12|0;m=g+16|0;n=g+20|0;o=g+24|0;p=g+28|0;q=g+32|0;r=g+36|0;s=g+40|0;t=g+48|0;v=g+44|0;w=g+52|0;x=i+4|0;y=i+8|0;z=j+8|0;A=j+4|0;B=h+36|0;C=h+16|0;D=h+4|0;E=h+40|0;F=h+44|0;G=h+48|0;H=0;do{I=f[a>>2]|0;J=I+(H*56|0)|0;f[g>>2]=f[J>>2];K=I+(H*56|0)+4|0;f[c>>2]=f[K>>2];f[b>>2]=f[I+(H*56|0)+8>>2];f[l>>2]=f[I+(H*56|0)+12>>2];f[m>>2]=f[I+(H*56|0)+16>>2];f[n>>2]=f[I+(H*56|0)+20>>2];f[o>>2]=f[I+(H*56|0)+24>>2];f[p>>2]=f[I+(H*56|0)+28>>2];f[q>>2]=f[I+(H*56|0)+32>>2];L=f[I+(H*56|0)+36>>2]|0;f[r>>2]=L;f[s>>2]=b;f[v>>2]=t;f[t>>2]=0;f[w>>2]=0;if(L|0){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[K>>2]|0)<3){K=f[I+(H*56|0)+44>>2]|0;I=f[v>>2]|0;f[I>>2]=f[K>>2];f[I+4>>2]=f[K+4>>2]}else{f[c>>2]=0;U$(g,J)}J=f[e>>2]|0;if((f[J+(H*56|0)+16>>2]|0)!=(f[m>>2]|0)){K=f[J+(H*56|0)+4>>2]|0;I=f[J+(H*56|0)+40>>2]|0;f[i>>2]=0;f[x>>2]=0;f[y>>2]=0;gOa(i,I,I+(K<<2)|0);i0(h,g,1,i);K=(f[e>>2]|0)+(H*56|0)|0;I=z;f[I>>2]=0;f[I+4>>2]=0;f[j>>2]=33619968;f[A>>2]=K;jR(h,j);K=f[B>>2]|0;if(K|0?(I=K+12|0,K=f[I>>2]|0,f[I>>2]=K+-1,(K|0)==1):0)V$(h);f[B>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[D>>2]|0)>0){K=f[E>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[D>>2]|0))}I=f[F>>2]|0;if((I|0)!=(G|0))wL(I);I=f[i>>2]|0;if(I|0){K=f[x>>2]|0;if((K|0)!=(I|0))f[x>>2]=K+(~((K+-4-I|0)>>>2)<<2);cYc(I)}}I=f[r>>2]|0;if(I|0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0)V$(g);f[r>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[c>>2]|0)>0){I=f[s>>2]|0;K=0;do{f[I+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[c>>2]|0))}K=f[v>>2]|0;if((K|0)!=(t|0))wL(K);H=H+1|0}while(H>>>0<(((f[k>>2]|0)-(f[e>>2]|0)|0)/56|0)>>>0);hx(e);hx(a);u=d;return}function Ryb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=orb()|0;break}default:c=0}return c|0}function Syb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Tyb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;g=u;u=u+16|0;h=g;i=g+4|0;j=c+4|0;k=f[j>>2]|0;l=f[c>>2]|0;m=k-l|0;n=l;if(!((m|0)==12?1:((m|0)/12|0|0)==(d|0))){if((m|0)!=24){m=$Xc(32)|0;f[i>>2]=m;f[i+8>>2]=-2147483616;f[i+4>>2]=18;o=m;p=455503;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+18>>0]=0;vM(-215,i,456079,440890,200)}m=f[n+4>>2]|0;d=f[l>>2]|0;r=m-d|0;s=r>>2;t=d;if((t|0)!=(m|0)){if((r|0)<0){m=$Xc(80)|0;f[i>>2]=m;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=m;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+70>>0]=0;vM(-215,i,454614,454620,161)}if(!r)v=1;else{r=1;m=0;while(1){d=Y(f[t+(m<<2)>>2]|0,r)|0;m=m+1|0;if((m|0)==(s|0)){v=d;break}else r=d}}}else v=0;r=n+12|0;s=f[n+16>>2]|0;n=f[r>>2]|0;m=s-n|0;t=m>>2;d=n;if((d|0)!=(s|0)){if((m|0)<0){s=$Xc(80)|0;f[i>>2]=s;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=s;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[s+70>>0]=0;vM(-215,i,454614,454620,161)}if(!m)w=1;else{m=1;s=0;while(1){n=Y(f[d+(s<<2)>>2]|0,m)|0;s=s+1|0;if((s|0)==(t|0)){w=n;break}else m=n}}}else w=0;if((v|0)!=(w|0)){w=$Xc(48)|0;f[i>>2]=w;f[i+8>>2]=-2147483600;f[i+4>>2]=36;o=w;p=441374;q=o+36|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[w+36>>0]=0;vM(-215,i,456079,440890,200)}eOa(e,1,r);u=g;return 1}r=f[e>>2]|0;w=e+4|0;v=f[w>>2]|0;if((v|0)==(r|0)){x=k;y=l}else{l=v;while(1){v=l+-12|0;f[w>>2]=v;k=f[v>>2]|0;if(!k)z=v;else{v=l+-8|0;m=f[v>>2]|0;if((m|0)!=(k|0))f[v>>2]=m+(~((m+-4-k|0)>>>2)<<2);cYc(k);z=f[w>>2]|0}if((z|0)==(r|0))break;else l=z}x=f[j>>2]|0;y=f[c>>2]|0}if((x|0)==(y|0)){u=g;return 1}y=i+4|0;x=i+8|0;z=e+8|0;l=i+8|0;k=a+44|0;m=a+56|0;v=a+48|0;a=0;t=r;a:while(1){f[i>>2]=0;f[y>>2]=0;f[x>>2]=0;if(t>>>0>=(f[z>>2]|0)>>>0){BPa(e,i);r=f[i>>2]|0;if(r|0){s=f[y>>2]|0;if((s|0)!=(r|0))f[y>>2]=s+(~((s+-4-r|0)>>>2)<<2);cYc(r)}}else{f[t>>2]=0;r=t+4|0;f[r>>2]=0;f[t+8>>2]=0;f[t>>2]=f[i>>2];f[r>>2]=f[y>>2];f[t+8>>2]=f[l>>2];f[l>>2]=0;f[y>>2]=0;f[i>>2]=0;f[w>>2]=(f[w>>2]|0)+12}r=f[c>>2]|0;s=r+(a*12|0)|0;d=m;n=f[d>>2]|0;A=f[d+4>>2]|0;d=f[w>>2]|0;B=d+-12|0;C=r+(a*12|0)+4|0;r=f[C>>2]|0;D=f[s>>2]|0;E=r-D>>2;F=f[v>>2]|0;G=f[k>>2]|0;H=F-G|0;I=H>>2;J=(A|0)==2147483647;K=G;G=F;F=r;r=D;L=(n|0)<0?E:0;M=(n|0)==-2147483648&J?0:L+n|0;n=J?E:L+A|0;A=(K|0)!=(G|0);L=(H|0)>0;if(L&A){J=0;do{N=(f[K+(J<<2)>>2]|0)>0;J=J+1|0}while((J|0)<(I|0)&N);O=N}else O=A;if(O){if((K|0)!=(G|0)){if((H|0)<0){P=23;break}if(!H)Q=1;else{J=1;N=0;while(1){R=Y(f[K+(N<<2)>>2]|0,J)|0;N=N+1|0;if((N|0)==(I|0)){Q=R;break}else J=R}}}else Q=0;J=n+-1|0;b:do if((n|0)>(M|0)){N=(r|0)==(F|0);if((n|0)==-1){if(N){K=(Q|0)==0;H=0;G=-1;A=J;while(1){if(H){if(!K){S=G;P=55;break b}if(!A){S=0;P=55;break b}else T=1}else T=K;if((A|0)>(M|0)){R=A;H=T;A=A+-1|0;G=R}else{U=M;break b}}}else{V=0;W=-1;X=J}while(1){G=(W|0)==0?0:X;if((G|0)>(E|0)){P=49;break a}if((G|0)<(E|0)){A=1;H=G;while(1){G=Y(f[r+(H<<2)>>2]|0,A)|0;H=H+1|0;if((H|0)==(E|0)){Z=G;break}else A=G}}else Z=1;A=(Z|0)==(Q|0);if(V){if(!A){S=W;P=55;break b}if(!X){S=0;P=55;break b}else _=1}else _=A;if((X|0)>(M|0)){A=X;V=_;X=X+-1|0;W=A}else{U=M;break b}}}if(N){A=(Q|0)==0;H=0;G=n;K=J;while(1){if(H){if(!A){S=G;P=55;break b}if(!K){S=0;P=55;break b}else $=1}else $=A;if((K|0)>(M|0)){R=K;H=$;K=K+-1|0;G=R}else{U=M;break b}}}if((n|0)>(E|0)){P=49;break a}else{aa=0;ba=n;ca=J}while(1){G=(ba|0)==0?0:ca;if((G|0)>(E|0)|(G|0)>(n|0)){P=49;break a}if((G|0)<(n|0)){K=1;H=G;while(1){G=Y(f[r+(H<<2)>>2]|0,K)|0;H=H+1|0;if((H|0)==(n|0)){da=G;break}else K=G}}else da=1;K=(da|0)==(Q|0);if(aa){if(!K){S=ba;P=55;break b}if(!ca){S=0;P=55;break b}else ea=1}else ea=K;if((ca|0)>(M|0)){K=ca;aa=ea;ca=ca+-1|0;ba=K}else{U=M;break}}}else U=M;while(0);while(1){if((P|0)==55){P=0;U=S}fa=(U|0)==-1?0:U;ga=(n|0)==-1?E:n;ha=(r|0)==(F|0);if(!ha){if((fa|0)>(E|0)){P=60;break a}if((ga|0)>(E|0)|(fa|0)>(ga|0)){P=60;break a}if((fa|0)<(ga|0)){J=1;K=fa;while(1){H=Y(f[r+(K<<2)>>2]|0,J)|0;K=K+1|0;if((K|0)==(ga|0)){ia=H;break}else J=H}}else ia=1}else ia=0;if(!((U|0)>0&(ia|0)!=(Q|0)))break;S=U+-1|0;P=55}if(!ha){if((fa|0)>(E|0)){P=68;break}if((ga|0)>(E|0)|(fa|0)>(ga|0)){P=68;break}if((fa|0)<(ga|0)){F=1;J=fa;while(1){K=Y(f[r+(J<<2)>>2]|0,F)|0;J=J+1|0;if((J|0)==(ga|0)){ja=K;break}else F=K}}else ja=1}else ja=0;if((ja|0)==(Q|0))ka=U;else{P=71;break}}else ka=M;if((ka|0)<=-1){P=74;break}if((n|0)>(E|0)|(ka|0)>(n|0)){P=74;break}F=I+E-n+ka|0;J=d+-8|0;K=f[J>>2]|0;H=f[B>>2]|0;G=K-H>>2;A=H;H=K;if(F>>>0<=G>>>0)if(F>>>0<G>>>0?(K=A+(F<<2)|0,(H|0)!=(K|0)):0){f[J>>2]=H+(~((H+-4-K|0)>>>2)<<2);la=r;ma=D}else{la=r;ma=D}else{CS(B,F-G|0);G=f[s>>2]|0;la=G;ma=G}G=la+(ka<<2)|0;if(ka|0){F=f[B>>2]|0;K=la;while(1){f[F>>2]=f[K>>2];K=K+4|0;if((K|0)==(G|0))break;else F=F+4|0}}F=la+(E<<2)|0;if((n|0)!=(E|0)){G=(f[B>>2]|0)+(ka<<2)+(I<<2)|0;K=la+(n<<2)|0;while(1){f[G>>2]=f[K>>2];K=K+4|0;if((K|0)==(F|0))break;else G=G+4|0}}if(L){G=f[k>>2]|0;F=f[B>>2]|0;K=f[s>>2]|0;n=K;D=0;r=-1;while(1){d=f[G+(D<<2)>>2]|0;c:do if((d|0)>0){na=r;oa=d;pa=D+ka|0}else switch(d|0){case 0:{qa=D+ka|0;if((qa|0)>=(E|0)){P=103;break a}na=r;oa=f[K+(qa<<2)>>2]|0;pa=qa;break c;break}case -1:{if((r|0)!=-1){P=106;break a}M=D+ka|0;na=M;oa=1;pa=M;break c;break}default:{P=108;break a}}while(0);f[F+(pa<<2)>>2]=oa;D=D+1|0;if((D|0)>=(I|0)){ra=na;sa=n;break}else r=na}}else{ra=-1;sa=ma}r=f[C>>2]|0;n=r-sa|0;I=n>>2;D=sa;if((D|0)!=(r|0)){if((n|0)<0){P=91;break}if(!n)ta=1;else{n=1;r=0;while(1){F=Y(f[D+(r<<2)>>2]|0,n)|0;r=r+1|0;if((r|0)==(I|0)){ta=F;break}else n=F}}}else ta=0;n=f[J>>2]|0;I=f[B>>2]|0;r=n-I|0;D=r>>2;C=I;if((C|0)!=(n|0)){if((r|0)<0){P=96;break}if(!r)ua=1;else{r=1;n=0;while(1){I=Y(f[C+(n<<2)>>2]|0,r)|0;n=n+1|0;if((n|0)==(D|0)){ua=I;break}else r=I}}}else ua=0;if((ra|0)==-1){if((ta|0)!=(ua|0)){P=114;break}}else{if((ta>>>0)%(ua>>>0)|0|0){P=111;break}f[C+(ra<<2)>>2]=(ta>>>0)/(ua>>>0)|0}r=a+1|0;if(r>>>0>=(((f[j>>2]|0)-(f[c>>2]|0)|0)/12|0)>>>0){P=132;break}a=r;t=f[w>>2]|0}switch(P|0){case 23:{P=$Xc(80)|0;f[i>>2]=P;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=P;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+70>>0]=0;vM(-215,i,454614,454620,161);break}case 49:{P=$Xc(80)|0;f[i>>2]=P;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=P;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+70>>0]=0;vM(-215,i,454614,454620,161);break}case 60:{P=$Xc(80)|0;f[i>>2]=P;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=P;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+70>>0]=0;vM(-215,i,454614,454620,161);break}case 68:{P=$Xc(80)|0;f[i>>2]=P;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=P;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+70>>0]=0;vM(-215,i,454614,454620,161);break}case 71:{P=$Xc(64)|0;f[i>>2]=P;f[i+8>>2]=-2147483584;f[i+4>>2]=58;o=P;p=441011;q=o+58|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+58>>0]=0;vM(-215,i,441070,440890,105);break}case 74:{P=$Xc(96)|0;f[i>>2]=P;f[i+8>>2]=-2147483552;f[i+4>>2]=85;o=P;p=441096;q=o+85|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+85>>0]=0;vM(-215,i,441070,440890,108);break}case 91:{P=$Xc(80)|0;f[i>>2]=P;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=P;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+70>>0]=0;vM(-215,i,454614,454620,161);break}case 96:{P=$Xc(80)|0;f[i>>2]=P;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=P;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[P+70>>0]=0;vM(-215,i,454614,454620,161);break}case 103:{f[h>>2]=qa;DM(i,441182,h);vM(-5,i,441070,440890,125);break}case 106:{h=$Xc(64)|0;f[i>>2]=h;f[i+8>>2]=-2147483584;f[i+4>>2]=50;o=h;p=441251;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[h+50>>0]=0;vM(-215,i,441070,440890,131);break}case 108:{h=$Xc(32)|0;f[i>>2]=h;f[i+8>>2]=-2147483616;f[i+4>>2]=18;o=h;p=441302;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[h+18>>0]=0;vM(-5,i,441070,440890,136);break}case 111:{h=$Xc(32)|0;f[i>>2]=h;f[i+8>>2]=-2147483616;f[i+4>>2]=31;o=h;p=441321;q=o+31|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[h+31>>0]=0;vM(-1,i,441070,440890,145);break}case 114:{h=$Xc(32)|0;f[i>>2]=h;f[i+8>>2]=-2147483616;f[i+4>>2]=20;o=h;p=441353;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[h+20>>0]=0;vM(-215,i,441070,440890,151);break}case 132:{u=g;return 1}}return 0}function Uyb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(68)|0;Vyb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=105504;f[b+12>>2]=c;f[a+4>>2]=b;return}function Vyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;qQa(a);f[a>>2]=105532;rQa(a,c);i=a+44|0;f[i>>2]=-1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(16)|0;f[g>>2]=j;f[g+8>>2]=-2147483632;f[g+4>>2]=11;k=j;l=441590;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+11>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(16)|0;f[h>>2]=j;f[h+8>>2]=-2147483632;f[h+4>>2]=15;k=j;l=441602;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+15>>0]=0;j=LGa(c,g)|0;o=c+4|0;if((j|0)==(o|0))lYc(e,h);else OIa(e,j+28|0,-1);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);j=e+11|0;p=b[j>>0]|0;q=e+4|0;r=f[q>>2]|0;if(((p<<24>>24<0?r:p&255)|0)==15)if(!(LYc(e,0,-1,441602,15)|0))s=0;else{t=b[j>>0]|0;v=f[q>>2]|0;w=11}else{t=p;v=r;w=11}if((w|0)==11){if(((t<<24>>24<0?v:t&255)|0)!=14){SGa(h,441633,e);x=AYc(h,505469)|0;f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];f[g+8>>2]=f[x+8>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;vM(-5,g,441655,441668,76)}if(!(LYc(e,0,-1,441618,14)|0))s=1;else{SGa(h,441633,e);x=AYc(h,505469)|0;f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];f[g+8>>2]=f[x+8>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;vM(-5,g,441655,441668,76)}}f[i>>2]=s;s=g+11|0;b[s>>0]=10;k=g;l=441745;m=k+10|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[g+10>>0]=0;i=LGa(c,g)|0;if((i|0)==(o|0))y=5;else{x=MGa(i+28|0,-1)|0;y=x}x=a+48|0;f[x>>2]=y;if((b[s>>0]|0)<0){cYc(f[g>>2]|0);z=f[x>>2]|0}else z=y;if((z|0)<1|((z|0)%2|0|0)!=1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(64)|0;f[g>>2]=z;f[g+8>>2]=-2147483584;f[g+4>>2]=58;k=z;l=441756;m=k+58|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[z+58>>0]=0;vM(-5,g,441655,441668,80)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=g+11|0;b[z>>0]=5;b[g>>0]=b[441815]|0;b[g+1>>0]=b[441816]|0;b[g+2>>0]=b[441817]|0;b[g+3>>0]=b[441818]|0;b[g+4>>0]=b[441819]|0;b[g+5>>0]=0;y=LGa(c,g)|0;if((y|0)==(o|0))A=1.0;else A=+NGa(y+28|0,-1);n[a+52>>2]=A;if((b[z>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=g+11|0;b[z>>0]=4;f[g>>2]=1635018082;b[g+4>>0]=0;y=LGa(c,g)|0;if((y|0)==(o|0))B=.75;else B=+NGa(y+28|0,-1);n[a+56>>2]=B;if((b[z>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=g+11|0;b[z>>0]=4;f[g>>2]=1935763810;b[g+4>>0]=0;y=LGa(c,g)|0;if((y|0)==(o|0))C=1.0;else C=+NGa(y+28|0,-1);n[a+60>>2]=C;if((b[z>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(16)|0;f[g>>2]=z;f[g+8>>2]=-2147483632;f[g+4>>2]=12;k=z;l=441821;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[z+12>>0]=0;z=LGa(c,g)|0;if((z|0)==(o|0))D=1;else{o=MGa(z+28|0,-1)|0;D=((o|0)!=0|(J|0)!=0)&1}b[a+64>>0]=D;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[j>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function Wyb(a){a=a|0;NXc(a);cYc(a);return}function Xyb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Yyb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==441439?a+12|0:0)|0}function Zyb(a){a=a|0;cYc(a);return}function _yb(a){a=a|0;MNa(a);cYc(a);return}function $yb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;k=pS(c,-1)|0;if((k|0)!=(pS(d,-1)|0)){k=$Xc(48)|0;f[h>>2]=k;f[h+8>>2]=-2147483600;f[h+4>>2]=41;l=k;m=441834;n=l+41|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+41>>0]=0;vM(-215,h,456135,441668,151)}if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[e>>2]|0;c=f[h>>2]|0;if((d-c|0)!=((f[k>>2]|0)-(f[i>>2]|0)|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=$Xc(32)|0;f[j>>2]=k;f[j+8>>2]=-2147483616;f[j+4>>2]=31;l=k;m=451584;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+31>>0]=0;vM(-215,j,456135,441668,166)}a:do if((d|0)!=(c|0)){k=a+44|0;o=0;p=c;b:while(1){q=p;r=q+(o*56|0)|0;if((f[q+(o*56|0)+4>>2]|0)!=4){s=11;break}q=(f[i>>2]|0)+(o*56|0)|0;switch(f[k>>2]|0){case 0:{gzb(a,r,q);break}case 1:{hzb(a,r,q);break}default:{s=15;break b}}o=o+1|0;p=f[h>>2]|0;if(o>>>0>=(((f[e>>2]|0)-p|0)/56|0)>>>0)break a}if((s|0)==11){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=$Xc(32)|0;f[j>>2]=p;f[j+8>>2]=-2147483616;f[j+4>>2]=19;l=p;m=441876;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[p+19>>0]=0;vM(-215,j,456135,441668,170)}else if((s|0)==15){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;o=$Xc(32)|0;f[j>>2]=o;f[j+8>>2]=-2147483616;f[j+4>>2]=31;l=o;m=441896;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+31>>0]=0;vM(-213,j,456135,441668,184)}}while(0);hx(i);hx(h);u=g;return}function azb(a,b){a=a|0;b=b|0;var c=0;a:do if((b|2|0)!=3){switch(b|0){case 2:{if((f[a+40>>2]|0)!=3){c=1;break a}return (f[a+44>>2]|0)==0|0}case 4:break;default:{c=0;break a}}if(nrb()|0?((f[a+48>>2]|0)%2|0|0)==1:0)c=(f[a+44>>2]|0)==0;else c=0}else c=1;while(0);return c|0}function bzb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function czb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function dzb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ezb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function fzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0;d=u;u=u+16|0;e=d;g=f[c+4>>2]|0;h=f[c>>2]|0;c=h;if((g|0)==(h|0)){i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=17;j=i;k=452630;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+17>>0]=0;vM(-215,e,451616,441668,416)}i=(f[a+44>>2]|0)==0;m=a+48|0;a=(g-h|0)/12|0;h=0;g=0;a:while(1){n=c+(g*12|0)|0;if(i){o=f[n>>2]|0;p=f[o+4>>2]|0;q=f[m>>2]|0;r=(q+-1|0)/2|0;s=f[o>>2]|0;t=((p|0)<(r|0)?p:r)<<1;v=f[c+(g*12|0)+4>>2]|0;w=v-o|0;x=w>>2;y=(o|0)==(v|0);do if(!y){if((w|0)<8){z=11;break a}if((w|0)==8){A=1;B=p<<2;C=t;break}else{D=2;E=1}do{E=Y(f[o+(D<<2)>>2]|0,E)|0;D=D+1|0}while((D|0)!=(x|0));v=Y(t,E)|0;F=p<<2;if(!y){if((w|0)<8){z=16;break a}if((w|0)==8){A=1;B=F;C=v}else{G=2;H=1;while(1){I=Y(f[o+(G<<2)>>2]|0,H)|0;G=G+1|0;if((G|0)==(x|0)){A=I;B=F;C=v;break}else H=I}}}else{A=0;B=F;C=v}}else{A=0;B=p<<2;C=0}while(0);t=(Y((Y(B,A)|0)+C|0,s)|0)+h|0;if((r|0)<(p|0)){H=(p-q<<1)+q|0;if(!y){if((w|0)<8){z=22;break}if((w|0)==8)K=1;else{G=2;I=1;while(1){L=Y(f[o+(G<<2)>>2]|0,I)|0;G=G+1|0;if((G|0)==(x|0)){K=L;break}else I=L}}}else K=0;M=(Y(K,H)|0)+t|0}else M=t}else{I=f[c+(g*12|0)+4>>2]|0;x=f[n>>2]|0;G=I-x|0;o=G>>2;w=x;if((w|0)!=(I|0)){if((G|0)<0){z=28;break}if(!G)N=1;else{G=0;I=1;while(1){x=Y(f[w+(G<<2)>>2]|0,I)|0;G=G+1|0;if((G|0)==(o|0)){N=x;break}else I=x}}}else N=0;I=f[m>>2]|0;M=(Y((Y(I<<1,I)|0)+2|0,N)|0)+h|0}g=g+1|0;if(g>>>0>=a>>>0){z=4;break}else h=M}if((z|0)==4){J=((M|0)<0)<<31>>31;u=d;return M|0}else if((z|0)==11){M=$Xc(80)|0;f[e>>2]=M;f[e+8>>2]=-2147483568;f[e+4>>2]=70;j=M;k=454543;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[M+70>>0]=0;vM(-215,e,454614,454620,161)}else if((z|0)==16){M=$Xc(80)|0;f[e>>2]=M;f[e+8>>2]=-2147483568;f[e+4>>2]=70;j=M;k=454543;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[M+70>>0]=0;vM(-215,e,454614,454620,161)}else if((z|0)==22){M=$Xc(80)|0;f[e>>2]=M;f[e+8>>2]=-2147483568;f[e+4>>2]=70;j=M;k=454543;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[M+70>>0]=0;vM(-215,e,454614,454620,161)}else if((z|0)==28){z=$Xc(80)|0;f[e>>2]=z;f[e+8>>2]=-2147483568;f[e+4>>2]=70;j=z;k=454543;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[z+70>>0]=0;vM(-215,e,454614,454620,161)}return 0}function gzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0;e=u;u=u+64|0;g=e+8|0;h=e;i=f[c+40>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;l=f[a+48>>2]|0;m=(b[a+64>>0]|0)==0?1.0:+(l|0);o=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;i=i3()|0;p=(i|0)>1?i:1;i=f[c+16>>2]|0;c=f[d+16>>2]|0;q=+n[a+52>>2]/m;d=f[a+60>>2]|0;m=-+n[a+56>>2];f[g>>2]=105644;f[g+4>>2]=i;f[g+8>>2]=c;f[g+28>>2]=k;f[g+32>>2]=(l+-1|0)/2|0;n[g+12>>2]=q;f[g+16>>2]=d;n[g+20>>2]=m;f[g+24>>2]=o;f[g+36>>2]=j;f[g+40>>2]=p;f[h>>2]=0;f[h+4>>2]=p;h3(h,g,+(p|0));u=e;return}function hzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0;e=u;u=u+384|0;g=e+256|0;h=e+200|0;i=e+144|0;j=e+88|0;k=e+32|0;l=e+16|0;m=e;o=f[c+40>>2]|0;p=f[o>>2]|0;q=f[o+4>>2]|0;if(!(b[a+64>>0]|0))r=1;else{o=f[a+48>>2]|0;r=Y(o,o)|0}f[h>>2]=f[c>>2];o=h+4|0;s=c+4|0;t=f[s>>2]|0;f[o>>2]=t;v=h+8|0;f[v>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];w=h+16|0;f[w>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];x=h+36|0;y=f[c+36>>2]|0;f[x>>2]=y;z=h+40|0;f[z>>2]=v;v=h+48|0;A=h+44|0;f[A>>2]=v;f[v>>2]=0;f[h+52>>2]=0;if(!y)B=t;else{t=y+12|0;f[t>>2]=(f[t>>2]|0)+1;B=f[s>>2]|0}if((B|0)<3){B=f[c+44>>2]|0;s=f[A>>2]|0;f[s>>2]=f[B>>2];f[s+4>>2]=f[B+4>>2]}else{f[o>>2]=0;U$(h,c)}f[i>>2]=f[d>>2];c=i+4|0;B=d+4|0;s=f[B>>2]|0;f[c>>2]=s;t=i+8|0;f[t>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];y=i+16|0;f[y>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[i+32>>2]=f[d+32>>2];C=i+36|0;D=f[d+36>>2]|0;f[C>>2]=D;E=i+40|0;f[E>>2]=t;t=i+48|0;F=i+44|0;f[F>>2]=t;f[t>>2]=0;f[i+52>>2]=0;if(!D)G=s;else{s=D+12|0;f[s>>2]=(f[s>>2]|0)+1;G=f[B>>2]|0}if((G|0)<3){G=f[d+44>>2]|0;B=f[F>>2]|0;f[B>>2]=f[G>>2];f[B+4>>2]=f[G+4>>2]}else{f[c>>2]=0;U$(i,d)}a:do if((p|0)>0){d=(q|0)>0;G=g+8|0;B=g+4|0;s=a+52|0;H=+(r|0);D=a+60|0;I=g+8|0;J=g+12|0;K=g+4|0;L=a+56|0;M=l+8|0;N=l+4|0;O=g+8|0;P=g+12|0;Q=g+4|0;R=l+8|0;S=l+12|0;T=l+4|0;U=m+8|0;V=m+4|0;W=k+36|0;X=k+16|0;Z=k+4|0;_=k+40|0;$=k+44|0;aa=k+48|0;ba=j+36|0;ca=j+16|0;da=j+4|0;ea=j+40|0;fa=j+44|0;ga=j+48|0;ha=0;b:while(1){if(d){ia=0;do{ja=f[o>>2]|0;if((ja|0)<=2){ka=35;break b}la=f[z>>2]|0;ma=2;do{f[g+(ma+-2<<2)>>2]=f[la+(ma<<2)>>2];ma=ma+1|0}while((ma|0)!=(ja|0));ma=f[A>>2]|0;la=(f[w>>2]|0)+(Y(f[ma>>2]|0,ha)|0)|0;_$(j,ja+-2|0,g,f[h>>2]&4095,la+(Y(f[ma+4>>2]|0,ia)|0)|0,0);ma=f[c>>2]|0;if((ma|0)<=2){ka=39;break b}la=f[E>>2]|0;na=2;do{f[g+(na+-2<<2)>>2]=f[la+(na<<2)>>2];na=na+1|0}while((na|0)!=(ma|0));na=f[F>>2]|0;la=(f[y>>2]|0)+(Y(f[na>>2]|0,ha)|0)|0;_$(k,ma+-2|0,g,f[i>>2]&4095,la+(Y(f[na+4>>2]|0,ia)|0)|0,0);izb(a,j,k);na=G;f[na>>2]=0;f[na+4>>2]=0;f[g>>2]=33619968;f[B>>2]=k;dY(k,g,f[k>>2]&4095,+n[s>>2]/H,+n[D>>2]);f[I>>2]=0;f[J>>2]=0;f[g>>2]=16842752;f[K>>2]=k;oa=+n[L>>2];na=M;f[na>>2]=0;f[na+4>>2]=0;f[l>>2]=33619968;f[N>>2]=k;QL(g,oa,l);f[O>>2]=0;f[P>>2]=0;f[g>>2]=16842752;f[Q>>2]=j;f[R>>2]=0;f[S>>2]=0;f[l>>2]=16842752;f[T>>2]=k;na=U;f[na>>2]=0;f[na+4>>2]=0;f[m>>2]=33619968;f[V>>2]=k;J1(g,l,m,1.0,-1);na=f[W>>2]|0;if(na|0?(la=na+12|0,na=f[la>>2]|0,f[la>>2]=na+-1,(na|0)==1):0)V$(k);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){na=f[_>>2]|0;la=0;do{f[na+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Z>>2]|0))}la=f[$>>2]|0;if((la|0)!=(aa|0))wL(la);la=f[ba>>2]|0;if(la|0?(na=la+12|0,la=f[na>>2]|0,f[na>>2]=la+-1,(la|0)==1):0)V$(j);f[ba>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){la=f[ea>>2]|0;na=0;do{f[la+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[da>>2]|0))}na=f[fa>>2]|0;if((na|0)!=(ga|0))wL(na);ia=ia+1|0}while((ia|0)<(q|0))}ha=ha+1|0;if((ha|0)>=(p|0))break a}if((ka|0)==35){b[g+11>>0]=10;pa=g;qa=450129;ra=pa+10|0;do{b[pa>>0]=b[qa>>0]|0;pa=pa+1|0;qa=qa+1|0}while((pa|0)<(ra|0));b[g+10>>0]=0;vM(-215,g,450140,454620,110)}else if((ka|0)==39){b[g+11>>0]=10;pa=g;qa=450129;ra=pa+10|0;do{b[pa>>0]=b[qa>>0]|0;pa=pa+1|0;qa=qa+1|0}while((pa|0)<(ra|0));b[g+10>>0]=0;vM(-215,g,450140,454620,110)}}while(0);g=f[C>>2]|0;if(g|0?(qa=g+12|0,g=f[qa>>2]|0,f[qa>>2]=g+-1,(g|0)==1):0)V$(i);f[C>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[E>>2]|0;E=0;do{f[y+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[c>>2]|0))}c=f[F>>2]|0;if((c|0)!=(t|0))wL(c);c=f[x>>2]|0;if(c|0?(t=c+12|0,c=f[t>>2]|0,f[t>>2]=c+-1,(c|0)==1):0)V$(h);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[o>>2]|0)>0){w=f[z>>2]|0;z=0;do{f[w+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[o>>2]|0))}o=f[A>>2]|0;if((o|0)==(v|0)){u=e;return}wL(o);u=e;return}function izb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+112|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d+8|0;j=d;Tj(e,f[b+8>>2]|0,f[b+12>>2]|0,f[b>>2]&4095,f[b+16>>2]|0,f[f[b+44>>2]>>2]|0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=e;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;b=f[c>>2]&7;c=f[a+48>>2]|0;f[i>>2]=c;f[i+4>>2]=c;f[j>>2]=-1;f[j+4>>2]=-1;Wua(g,h,b,i,j,0,0);j=e+36|0;i=f[j>>2]|0;if(i|0?(b=i+12|0,i=f[b>>2]|0,f[b>>2]=i+-1,(i|0)==1):0)V$(e);f[j>>2]=0;j=e+16|0;i=e+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[e+40>>2]|0;b=0;do{f[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)==(e+48|0)){u=d;return}wL(i);u=d;return}function jzb(a){a=a|0;cYc(a);return}function kzb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0;c=u;u=u+1072|0;d=c;e=f[a+36>>2]|0;g=f[a+40>>2]|0;h=f[a+24>>2]|0;i=Y(h,e)|0;j=((g+-1+i|0)>>>0)/(g>>>0)|0;k=Y(f[b>>2]|0,j)|0;l=f[b+4>>2]|0;b=Y(l,j)|0;j=(l|0)==(g|0)?i:b;b=i>>>0<k>>>0?i:k;k=i>>>0<j>>>0?i:j;m=+n[a+12>>2];o=+n[a+16>>2];p=+n[a+20>>2];j=f[a+28>>2]|0;i=f[a+32>>2]|0;g=(i+j<<1)+2|0;l=d+8|0;f[d>>2]=l;q=d+4|0;f[q>>2]=g;if(g>>>0>264){r=bYc(g>>>0>1073741823?-1:g<<2)|0;f[d>>2]=r;s=r}else s=l;r=s+(j<<2)+(i<<2)+4|0;if((i|0)>=0){g=0;while(1){n[r+(g+j<<2)>>2]=0.0;n[r+(~g<<2)>>2]=0.0;if((g|0)==(i|0))break;else g=g+1|0}}if(k>>>0>b>>>0){g=a+4|0;t=a+8|0;a=(j|0)>0;v=(i|0)>0;w=~i;x=b;while(1){b=(x>>>0)/(h>>>0)|0;if((b|0)>=(e|0))break;y=Y(b,h)|0;b=x-y|0;z=h-b|0;A=k-x|0;B=(A>>>0<z>>>0?A:z)+x|0;z=Y(y,j)|0;y=(f[t>>2]|0)+(z<<2)+(b<<2)|0;a:do if(x>>>0<B>>>0){if(!a){A=x;while(1){if(v){C=0;do C=C+1|0;while((C|0)!=(i|0))}dQ(s,s,j);bQ(s,s,j);C=A+1|0;if(C>>>0<B>>>0)A=C;else{D=C;break a}}}A=y;C=(f[g>>2]|0)+(z<<2)+(b<<2)|0;E=x;while(1){F=0;do{G=C+((Y(F,h)|0)<<2)|0;f[r+(F<<2)>>2]=f[G>>2];F=F+1|0}while((F|0)!=(j|0));if(v){H=0.0;F=0;while(1){I=+n[r+(F<<2)>>2];J=H+I*I;F=F+1|0;if((F|0)==(i|0)){K=J;L=0;break}else H=J}}else{K=0.0;L=0}do{H=+n[r+(L+i<<2)>>2];J=+n[r+(L+w<<2)>>2];I=K+(H+J)*(H-J);K=I<0.0?0.0:I;n[s+(L<<2)>>2]=o+m*K;L=L+1|0}while((L|0)!=(j|0));dQ(s,s,j);F=0;do{G=s+(F<<2)|0;n[G>>2]=p*+n[G>>2];F=F+1|0}while((F|0)!=(j|0));bQ(s,s,j);F=0;do{G=A+((Y(F,h)|0)<<2)|0;n[G>>2]=+n[r+(F<<2)>>2]*+n[s+(F<<2)>>2];F=F+1|0}while((F|0)!=(j|0));F=E+1|0;if(F>>>0<B>>>0){A=A+4|0;C=C+4|0;E=F}else{D=F;break}}}else D=x;while(0);if(k>>>0>D>>>0)x=D;else break}M=f[d>>2]|0}else M=s;if((M|0)==(l|0)){u=c;return}if(M|0)dYc(M);f[d>>2]=l;f[q>>2]=264;u=c;return}function lzb(){var a=0;f[134184]=0;f[134185]=0;f[134186]=0;b[536747]=8;a=536736;f[a>>2]=1869181520;f[a+4>>2]=2020557426;b[536744]=0;be(2220,536736,x|0)|0;return}function mzb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(140)|0;nzb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=105664;f[b+12>>2]=c;f[a+4>>2]=b;return}function nzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0;d=u;u=u+64|0;e=d+32|0;g=d+52|0;h=d+16|0;i=d;j=d+48|0;k=d+44|0;qQa(a);f[a>>2]=105692;l=a+60|0;m=a+64|0;o=a+84|0;p=a+88|0;q=a+96|0;r=a+100|0;s=a+108|0;t=a+112|0;v=a+120|0;w=a+124|0;x=l;y=x+72|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=8;A=e;f[A>>2]=1601071469;f[A+4>>2]=1702521203;b[e+8>>0]=0;f[g>>2]=0;n[h>>2]=0.0;B=+szb(a,c,e,g,0,h);A=a+44|0;n[A>>2]=B;if((b[z>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=4;f[e>>2]=1885957222;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=1;C=(tzb(a,c,e,g,0,h)|0)&1;b[a+132>>0]=C;if((b[z>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=4;f[e>>2]=1885957219;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=1;C=(tzb(a,c,e,g,0,h)|0)&1;b[a+133>>0]=C;if((b[z>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=$Xc(16)|0;f[e>>2]=z;f[e+8>>2]=-2147483632;f[e+4>>2]=15;x=z;C=447547;y=x+15|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[z+15>>0]=0;f[g>>2]=0;b[h>>0]=1;z=(tzb(a,c,e,g,0,h)|0)&1;b[a+135>>0]=z;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);z=f[l>>2]|0;D=f[m>>2]|0;if((D|0)!=(z|0))f[m>>2]=D+(~((D+-4-z|0)>>>2)<<2);uzb(a,c);vzb(a,c);z=a+48|0;n[z>>2]=-1.0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;D=e+11|0;b[D>>0]=8;E=e;f[E>>2]=1601724781;f[E+4>>2]=1702521203;b[e+8>>0]=0;E=(HIa(c,e)|0)==0;if((b[D>>0]|0)<0)cYc(f[e>>2]|0);if(!E){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=e+11|0;b[E>>0]=8;D=e;f[D>>2]=1601724781;f[D+4>>2]=1702521203;b[e+8>>0]=0;B=+NGa(NIa(c,e)|0,0);n[z>>2]=B;if((b[E>>0]|0)<0){cYc(f[e>>2]|0);F=+n[z>>2]}else F=B;if(!(F>+n[A>>2])){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=$Xc(32)|0;f[e>>2]=E;f[e+8>>2]=-2147483616;f[e+4>>2]=19;x=E;C=442184;y=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[E+19>>0]=0;vM(-215,e,442204,442222,198)}}f[e>>2]=0;E=e+4|0;f[E>>2]=0;f[e+8>>2]=0;f[g>>2]=0;D=g+4|0;f[D>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=h+11|0;b[G>>0]=5;b[h>>0]=b[471037]|0;b[h+1>>0]=b[471038]|0;b[h+2>>0]=b[471039]|0;b[h+3>>0]=b[471040]|0;b[h+4>>0]=b[471041]|0;b[h+5>>0]=0;wzb(h,c,e);if((b[G>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=h+11|0;b[G>>0]=6;b[h>>0]=b[471030]|0;b[h+1>>0]=b[471031]|0;b[h+2>>0]=b[471032]|0;b[h+3>>0]=b[471033]|0;b[h+4>>0]=b[471034]|0;b[h+5>>0]=b[471035]|0;b[h+6>>0]=0;wzb(h,c,g);if((b[G>>0]|0)<0)cYc(f[h>>2]|0);G=f[e>>2]|0;H=f[E>>2]|0;I=(G|0)!=(H|0);b[a+134>>0]=I&1;if((H-G|0)!=((f[D>>2]|0)-(f[g>>2]|0)|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=$Xc(32)|0;f[h>>2]=G;f[h+8>>2]=-2147483616;f[h+4>>2]=31;x=G;C=442305;y=x+31|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[G+31>>0]=0;vM(-215,h,442204,442222,205)}if(I){if((f[l>>2]|0)!=(f[m>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;I=$Xc(32)|0;f[h>>2]=I;f[h+8>>2]=-2147483616;f[h+4>>2]=21;x=I;C=442337;y=x+21|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[I+21>>0]=0;vM(-215,h,442204,442222,209)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;I=h+11|0;b[I>>0]=8;G=h;f[G>>2]=1601071469;f[G+4>>2]=1702521203;b[h+8>>0]=0;G=(HIa(c,h)|0)==0;if((b[I>>0]|0)<0)cYc(f[h>>2]|0);if(!G){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=$Xc(32)|0;f[h>>2]=G;f[h+8>>2]=-2147483616;f[h+4>>2]=23;x=G;C=442359;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[G+23>>0]=0;vM(-215,h,442204,442222,210)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=h+11|0;b[G>>0]=8;I=h;f[I>>2]=1601724781;f[I+4>>2]=1702521203;b[h+8>>0]=0;I=(HIa(c,h)|0)==0;if((b[G>>0]|0)<0)cYc(f[h>>2]|0);if(!I){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;I=$Xc(32)|0;f[h>>2]=I;f[h+8>>2]=-2147483616;f[h+4>>2]=23;x=I;C=442383;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[I+23>>0]=0;vM(-215,h,442204,442222,211)}if((s|0)!=(e|0))yF(s,f[e>>2]|0,f[E>>2]|0);if((v|0)!=(g|0))yF(v,f[g>>2]|0,f[D>>2]|0)}else{if(!(+n[A>>2]>0.0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;I=$Xc(16)|0;f[h>>2]=I;f[h+8>>2]=-2147483632;f[h+4>>2]=12;x=I;C=442407;y=x+12|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[I+12>>0]=0;vM(-215,h,442204,442222,217)}I=((f[m>>2]|0)-(f[l>>2]|0)>>2)+(+n[z>>2]>0.0?2:1)|0;G=f[t>>2]|0;H=f[s>>2]|0;J=G-H>>2;K=H;L=G;N=H;if(I>>>0<=J>>>0)if(I>>>0<J>>>0?(O=K+(I<<2)|0,(L|0)!=(O|0)):0){P=L+(~((L+-4-O|0)>>>2)<<2)|0;f[t>>2]=P;Q=H;R=P;S=K;T=N}else{Q=H;R=G;S=K;T=N}else{qxb(s,I-J|0);J=f[s>>2]|0;Q=J;R=f[t>>2]|0;S=J;T=J}J=R-Q>>2;Q=f[w>>2]|0;R=f[v>>2]|0;I=Q-R>>2;N=R;K=Q;Q=R;if(J>>>0<=I>>>0)if(J>>>0<I>>>0?(R=N+(J<<2)|0,(K|0)!=(R|0)):0){f[w>>2]=K+(~((K+-4-R|0)>>>2)<<2);U=Q;V=T;W=N;X=S}else{U=Q;V=T;W=N;X=S}else{qxb(v,J-I|0);I=f[v>>2]|0;J=f[s>>2]|0;U=I;V=J;W=I;X=J}J=f[A>>2]|0;f[U>>2]=J;f[V>>2]=J;F=+n[z>>2];if(F>0.0){B=+M(+(F*+n[A>>2]));n[W+4>>2]=B;n[X+4>>2]=B;Z=2}else Z=1;z=f[m>>2]|0;m=f[l>>2]|0;l=m;if((z|0)!=(m|0)){J=z-m>>2;m=0;do{B=+M(+(+n[l+(m<<2)>>2]));z=m+Z|0;n[X+(z<<2)>>2]=B*+n[A>>2];n[W+(z<<2)>>2]=+n[A>>2]/B;m=m+1|0}while(m>>>0<J>>>0)}}J=(f[t>>2]|0)-(f[s>>2]|0)>>2;if((J|0)!=((f[w>>2]|0)-(f[v>>2]|0)>>2|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=39;x=v;C=442420;y=x+39|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[v+39>>0]=0;vM(-215,h,442204,442222,238)}v=a+136|0;f[v>>2]=J;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;J=h+11|0;b[J>>0]=6;b[h>>0]=b[442460]|0;b[h+1>>0]=b[442461]|0;b[h+2>>0]=b[442462]|0;b[h+3>>0]=b[442463]|0;b[h+4>>0]=b[442464]|0;b[h+5>>0]=b[442465]|0;b[h+6>>0]=0;if(!(HIa(c,h)|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=i+11|0;b[w>>0]=6;b[i>>0]=b[442467]|0;b[i+1>>0]=b[442468]|0;b[i+2>>0]=b[442469]|0;b[i+3>>0]=b[442470]|0;b[i+4>>0]=b[442471]|0;b[i+5>>0]=b[442472]|0;b[i+6>>0]=0;s=(HIa(c,i)|0)!=0;if((b[w>>0]|0)<0)cYc(f[i>>2]|0);_=s}else _=1;if((b[J>>0]|0)<0)cYc(f[h>>2]|0);do if(_){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;J=h+11|0;b[J>>0]=4;f[h>>2]=1885697139;b[h+4>>0]=0;s=(HIa(c,h)|0)==0;if((b[J>>0]|0)<0)cYc(f[h>>2]|0);if(!s){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=$Xc(32)|0;f[h>>2]=s;f[h+8>>2]=-2147483616;f[h+4>>2]=19;x=s;C=442474;y=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[s+19>>0]=0;vM(-215,h,442204,442222,242)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;J=h+11|0;b[J>>0]=6;b[h>>0]=b[442460]|0;b[h+1>>0]=b[442461]|0;b[h+2>>0]=b[442462]|0;b[h+3>>0]=b[442463]|0;b[h+4>>0]=b[442464]|0;b[h+5>>0]=b[442465]|0;b[h+6>>0]=0;f[i>>2]=0;n[j>>2]=0.0;B=+szb(a,c,h,i,1,j);w=a+56|0;n[w>>2]=B;if((b[J>>0]|0)<0){cYc(f[h>>2]|0);$=+n[w>>2]}else $=B;if(!($>0.0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(16)|0;f[h>>2]=w;f[h+8>>2]=-2147483632;f[h+4>>2]=11;x=w;C=442494;y=x+11|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[w+11>>0]=0;vM(-215,h,442204,442222,244)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=h+11|0;b[s>>0]=6;b[h>>0]=b[442467]|0;b[h+1>>0]=b[442468]|0;b[h+2>>0]=b[442469]|0;b[h+3>>0]=b[442470]|0;b[h+4>>0]=b[442471]|0;b[h+5>>0]=b[442472]|0;b[h+6>>0]=0;f[i>>2]=0;n[j>>2]=0.0;B=+szb(a,c,h,i,1,j);J=a+52|0;n[J>>2]=B;if((b[s>>0]|0)<0){cYc(f[h>>2]|0);aa=+n[J>>2]}else aa=B;if(aa>0.0)break;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;J=$Xc(16)|0;f[h>>2]=J;f[h+8>>2]=-2147483632;f[h+4>>2]=11;x=J;C=442506;y=x+11|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[J+11>>0]=0;vM(-215,h,442204,442222,246)}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=h+11|0;b[w>>0]=4;f[h>>2]=1885697139;b[h+4>>0]=0;s=(HIa(c,h)|0)==0;if((b[w>>0]|0)<0)cYc(f[h>>2]|0);do if(s)ba=0.0;else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=h+11|0;b[w>>0]=4;f[h>>2]=1885697139;b[h+4>>0]=0;f[i>>2]=0;n[j>>2]=0.0;B=+szb(a,c,h,i,1,j);if((b[w>>0]|0)<0)cYc(f[h>>2]|0);if(B>0.0){ba=B;break};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=8;w=h;f[w>>2]=1885697139;f[w+4>>2]=807419424;b[h+8>>0]=0;vM(-215,h,442204,442222,249)}while(0);n[a+56>>2]=ba;n[a+52>>2]=ba}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=h+11|0;b[_>>0]=8;s=h;f[s>>2]=1936090735;f[s+4>>2]=1751086181;b[h+8>>0]=0;if(!(HIa(c,h)|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;s=i+11|0;b[s>>0]=8;J=i;f[J>>2]=1936090735;f[J+4>>2]=2002744421;b[i+8>>0]=0;J=(HIa(c,i)|0)!=0;if((b[s>>0]|0)<0)cYc(f[i>>2]|0);ca=J}else ca=1;if((b[_>>0]|0)<0)cYc(f[h>>2]|0);do if(ca){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=h+11|0;b[_>>0]=6;b[h>>0]=b[455356]|0;b[h+1>>0]=b[455357]|0;b[h+2>>0]=b[455358]|0;b[h+3>>0]=b[455359]|0;b[h+4>>0]=b[455360]|0;b[h+5>>0]=b[455361]|0;b[h+6>>0]=0;J=(HIa(c,h)|0)==0;if((b[_>>0]|0)<0)cYc(f[h>>2]|0);if(!J){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;J=$Xc(32)|0;f[h>>2]=J;f[h+8>>2]=-2147483616;f[h+4>>2]=21;x=J;C=442518;y=x+21|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[J+21>>0]=0;vM(-215,h,442204,442222,258)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=h+11|0;b[_>>0]=8;s=h;f[s>>2]=1936090735;f[s+4>>2]=1751086181;b[h+8>>0]=0;s=(HIa(c,h)|0)==0;if((b[_>>0]|0)<0)cYc(f[h>>2]|0);if(s){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=$Xc(32)|0;f[h>>2]=s;f[h+8>>2]=-2147483616;f[h+4>>2]=22;x=s;C=442540;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[s+22>>0]=0;vM(-215,h,442204,442222,258)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;J=h+11|0;b[J>>0]=8;_=h;f[_>>2]=1936090735;f[_+4>>2]=2002744421;b[h+8>>0]=0;_=(HIa(c,h)|0)==0;if((b[J>>0]|0)<0)cYc(f[h>>2]|0);if(_){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=$Xc(32)|0;f[h>>2]=_;f[h+8>>2]=-2147483616;f[h+4>>2]=22;x=_;C=442563;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[_+22>>0]=0;vM(-215,h,442204,442222,258)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=h+11|0;b[s>>0]=8;J=h;f[J>>2]=1936090735;f[J+4>>2]=1751086181;b[h+8>>0]=0;wzb(h,c,q);if((b[s>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=h+11|0;b[s>>0]=8;J=h;f[J>>2]=1936090735;f[J+4>>2]=2002744421;b[h+8>>0]=0;wzb(h,c,o);if((b[s>>0]|0)<0)cYc(f[h>>2]|0);s=(f[p>>2]|0)-(f[o>>2]|0)|0;if((s|0)==((f[r>>2]|0)-(f[q>>2]|0)|0)){J=(s>>1)+-2|0;s=Y(f[v>>2]|0,J>>>0>1?J:1)|0;f[v>>2]=s;break}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=$Xc(48)|0;f[h>>2]=s;f[h+8>>2]=-2147483600;f[h+4>>2]=36;x=s;C=442586;y=x+36|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[s+36>>0]=0;vM(-215,h,442204,442222,261)}}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;_=i+11|0;b[_>>0]=6;b[i>>0]=b[455356]|0;b[i+1>>0]=b[455357]|0;b[i+2>>0]=b[455358]|0;b[i+3>>0]=b[455359]|0;b[i+4>>0]=b[455360]|0;b[i+5>>0]=b[455361]|0;b[i+6>>0]=0;f[j>>2]=0;n[k>>2]=.5;ba=+szb(a,c,i,j,0,k);if((b[_>>0]|0)<0)cYc(f[i>>2]|0);n[h>>2]=ba;xzb(o,1,h);xzb(q,1,h)}while(0);h=f[g>>2]|0;if(h|0){g=f[D>>2]|0;if((g|0)!=(h|0))f[D>>2]=g+(~((g+-4-h|0)>>>2)<<2);cYc(h)}h=f[e>>2]|0;if(!h){u=d;return}e=f[E>>2]|0;if((e|0)!=(h|0))f[E>>2]=e+(~((e+-4-h|0)>>>2)<<2);cYc(h);u=d;return}function ozb(a){a=a|0;NXc(a);cYc(a);return}function pzb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function qzb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==442023?a+12|0:0)|0}function rzb(a){a=a|0;cYc(a);return}function szb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0;a=u;u=u+32|0;i=a+16|0;j=a;f[i>>2]=0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[i+4>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;if(HIa(c,d)|0){UGa(i,NIa(c,d)|0)|0;m=+NGa(i,f[e>>2]|0);RGa(i);u=a;return +m}if(g){lYc(j,536736);AYc(j,447769)|0;g=b[d+11>>0]|0;e=g<<24>>24<0;zYc(j,e?f[d>>2]|0:d,e?f[d+4>>2]|0:g&255)|0;AYc(j,447804)|0;vM(-5,j,447816,442222,93)}m=+n[h>>2];RGa(i);u=a;return +m}function tzb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=u;u=u+32|0;i=a+16|0;j=a;f[i>>2]=0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[i+4>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;if(HIa(c,d)|0){UGa(i,NIa(c,d)|0)|0;c=MGa(i,f[e>>2]|0)|0;m=(c|0)!=0|(J|0)!=0;RGa(i);u=a;return m|0}if(g){lYc(j,536736);AYc(j,447769)|0;g=b[d+11>>0]|0;c=g<<24>>24<0;zYc(j,c?f[d>>2]|0:d,c?f[d+4>>2]|0:g&255)|0;AYc(j,447804)|0;vM(-5,j,447816,442222,93)}m=(b[h>>0]|0)!=0;RGa(i);u=a;return m|0}function uzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;d=u;u=u+32|0;e=d;g=d+16|0;h=d+8|0;i=d+4|0;f[h>>2]=0;j=h+4|0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[j>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=$Xc(16)|0;f[g>>2]=k;f[g+8>>2]=-2147483632;f[g+4>>2]=12;l=k;m=442693;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+12>>0]=0;if(!(HIa(c,g)|0))p=0;else{UGa(h,NIa(c,g)|0)|0;p=1}if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(!p){RGa(h);u=d;return}p=a+60|0;c=a+64|0;k=a+68|0;m=a+132|0;a=h+4|0;l=0;a:while(1){q=f[h>>2]|0;switch(q|0){case 0:{r=(f[j>>2]|0)+4|0;break}case 3:{r=(f[a>>2]|0)+4|0;break}case 2:{r=(f[a>>2]|0)+4|0;break}default:{s=11;break a}}if((l|0)>=(f[r>>2]|0)){s=26;break}t=+NGa(h,l);n[g>>2]=t;o=+L(+(t+-1.0))<9.999999974752427e-07;v=f[c>>2]|0;w=f[p>>2]|0;x=w;y=v;if(o|(v|0)==(w|0))z=o;else{o=v-w>>2;w=0;do{A=+L(+(t-+n[x+(w<<2)>>2]))<1.0e-06;w=w+1|0}while(!(A|w>>>0>=o>>>0));z=A}if(!z){if((y|0)==(f[k>>2]|0))hw(p,g);else{n[v>>2]=t;f[c>>2]=y+4}if(b[m>>0]|0){B=1.0/+n[g>>2];n[i>>2]=B;o=f[c>>2]|0;if(o>>>0<(f[k>>2]|0)>>>0){n[o>>2]=B;f[c>>2]=o+4}else MA(p,i)}}l=l+1|0}if((s|0)==11){f[e>>2]=q;DM(g,455363,e);vM(-3,g,470867,455383,297)}else if((s|0)==26){RGa(h);u=d;return}}function vzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;i=d+20|0;f[h>>2]=0;j=h+4|0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[j>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=g+11|0;b[k>>0]=8;l=g;f[l>>2]=1769103734;f[l+4>>2]=1701015137;b[g+8>>0]=0;if(!(HIa(c,g)|0))m=0;else{UGa(h,NIa(c,g)|0)|0;m=1}if((b[k>>0]|0)<0)cYc(f[g>>2]|0);if(!m){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=$Xc(32)|0;f[g>>2]=m;f[g+8>>2]=-2147483616;f[g+4>>2]=26;o=m;p=442623;q=o+26|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+26>>0]=0;vM(-215,g,442650,442222,150)}m=f[h>>2]|0;switch(m|0){case 0:{r=(f[j>>2]|0)+4|0;break}case 3:{r=(f[h+4>>2]|0)+4|0;break}case 2:{r=(f[h+4>>2]|0)+4|0;break}default:{f[e>>2]=m;DM(g,455363,e);vM(-3,g,470867,455383,297)}}e=f[r>>2]|0;if((e|0)<=1){if((e|0)!=1){n[g>>2]=.10000000149011612;r=a+76|0;m=f[r>>2]|0;if(m>>>0<(f[a+80>>2]|0)>>>0){f[m>>2]=1036831949;f[r>>2]=m+4}else MA(a+72|0,g);RGa(h);u=d;return}s=+NGa(h,0);n[g>>2]=s;if(!(s>0.0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;m=$Xc(16)|0;f[i>>2]=m;f[i+8>>2]=-2147483632;f[i+4>>2]=12;o=m;p=442680;q=o+12|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+12>>0]=0;vM(-215,i,442650,442222,170)}m=a+76|0;r=f[m>>2]|0;if((r|0)==(f[a+80>>2]|0))hw(a+72|0,g);else{n[r>>2]=s;f[m>>2]=r+4}RGa(h);u=d;return}if((e|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=17;o=e;p=442662;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[e+17>>0]=0;vM(-215,g,442650,442222,156)}e=a+76|0;r=a+80|0;m=a+72|0;s=+NGa(h,0);n[g>>2]=s;if(s>0.0){a=f[e>>2]|0;if((a|0)==(f[r>>2]|0))hw(m,g);else{n[a>>2]=s;f[e>>2]=a+4}s=+NGa(h,1);n[g>>2]=s;if(s>0.0){a=f[e>>2]|0;if((a|0)==(f[r>>2]|0))hw(m,g);else{n[a>>2]=s;f[e>>2]=a+4}s=+NGa(h,2);n[g>>2]=s;if(s>0.0){a=f[e>>2]|0;if((a|0)==(f[r>>2]|0))hw(m,g);else{n[a>>2]=s;f[e>>2]=a+4}s=+NGa(h,3);n[g>>2]=s;if(s>0.0){a=f[e>>2]|0;if((a|0)==(f[r>>2]|0))hw(m,g);else{n[a>>2]=s;f[e>>2]=a+4}RGa(h);u=d;return}}}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=$Xc(16)|0;f[i>>2]=d;f[i+8>>2]=-2147483632;f[i+4>>2]=12;o=d;p=442680;q=o+12|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+12>>0]=0;vM(-215,i,442650,442222,161)}function wzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0;d=u;u=u+48|0;e=d+8|0;g=d;h=d+24|0;i=d+16|0;f[i>>2]=0;j=i+4|0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[j>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;if(!(HIa(b,a)|0)){k=f[c>>2]|0;l=c+4|0;m=f[l>>2]|0;if((m|0)==(k|0)){RGa(i);u=d;return}f[l>>2]=m+(~((m+-4-k|0)>>>2)<<2);RGa(i);u=d;return}UGa(i,NIa(b,a)|0)|0;a=f[i>>2]|0;switch(a|0){case 0:{o=(f[j>>2]|0)+4|0;break}case 3:{o=(f[i+4>>2]|0)+4|0;break}case 2:{o=(f[i+4>>2]|0)+4|0;break}default:{f[g>>2]=a;DM(h,455363,g);vM(-3,h,470867,455383,297)}}g=f[o>>2]|0;o=c+4|0;a=f[o>>2]|0;b=f[c>>2]|0;k=a-b>>2;m=b;b=a;if(g>>>0<=k>>>0){if(g>>>0<k>>>0?(a=m+(g<<2)|0,(b|0)!=(a|0)):0)f[o>>2]=b+(~((b+-4-a|0)>>>2)<<2)}else qxb(c,g-k|0);k=i+4|0;g=0;a:while(1){p=f[i>>2]|0;switch(p|0){case 0:{q=(f[j>>2]|0)+4|0;break}case 3:{q=(f[k>>2]|0)+4|0;break}case 2:{q=(f[k>>2]|0)+4|0;break}default:{r=17;break a}}if((g|0)>=(f[q>>2]|0)){r=22;break}s=+NGa(i,g);n[(f[c>>2]|0)+(g<<2)>>2]=s;g=g+1|0}if((r|0)==17){f[e>>2]=p;DM(h,455363,e);vM(-3,h,470867,455383,297)}else if((r|0)==22){RGa(i);u=d;return}}function xzb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;if(e-g>>2>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>2;l=k>>>0<b>>>0;m=l?k:b;n=j;o=j;if(m|0){p=m;m=h;while(1){f[m>>2]=f[c>>2];p=p+-1|0;if(!p)break;else m=m+4|0}}if(l){l=b-k|0;k=o+(l<<2)|0;o=l;l=j;while(1){f[l>>2]=f[c>>2];o=o+-1|0;if(!o)break;else l=l+4|0}f[i>>2]=k;return}else{k=h+(b<<2)|0;if((n|0)==(k|0))return;f[i>>2]=n+(~((n+-4-k|0)>>>2)<<2);return}}else{k=g;if(!g)q=e;else{e=a+4|0;n=f[e>>2]|0;if((n|0)!=(h|0))f[e>>2]=n+(~((n+-4-g|0)>>>2)<<2);cYc(k);f[d>>2]=0;f[e>>2]=0;f[a>>2]=0;q=0}if(b>>>0>1073741823)kWc(a);e=q>>1;k=q>>2>>>0<536870911?(e>>>0<b>>>0?b:e):1073741823;if(k>>>0>1073741823)kWc(a);e=$Xc(k<<2)|0;q=a+4|0;f[q>>2]=e;f[a>>2]=e;f[d>>2]=e+(k<<2);k=e+(b<<2)|0;d=b;b=e;while(1){f[b>>2]=f[c>>2];d=d+-1|0;if(!d)break;else b=b+4|0}f[q>>2]=k;return}}function yzb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=105692;b=f[a+120>>2]|0;if(b|0){c=a+124|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+108>>2]|0;if(b|0){d=a+112|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+96>>2]|0;if(b|0){c=a+100|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+84>>2]|0;if(b|0){d=a+88|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+72>>2]|0;if(b|0){c=a+76|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+60>>2]|0;if(!b){MNa(a);return}d=a+64|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b);MNa(a);return}function zzb(a){a=a|0;yzb(a);cYc(a);return}function Azb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;gS(b,d);b=f[d>>2]|0;g=((f[e>>2]|0)-b|0)/56|0;e=b;if(g>>>0<=1)nV(g,1,105796);g=f[e+4>>2]|0;if((g|0)!=4)mV(g,4,105824);g=f[e+60>>2]|0;if((g|0)!=4)mV(g,4,105852);g=f[e+40>>2]|0;b=f[g+12>>2]|0;h=f[e+96>>2]|0;e=f[h+12>>2]|0;i=a+56|0;j=+n[i>>2];if(!(j==0.0)){k=j;n[i>>2]=k;l=a+52|0;m=+n[l>>2];o=m==0.0;p=+(e|0);q=+(b|0);r=p/q;s=o?r:m;n[l>>2]=s;hx(d);u=c;return}k=+(f[h+8>>2]|0)/+(f[g+8>>2]|0);n[i>>2]=k;l=a+52|0;m=+n[l>>2];o=m==0.0;p=+(e|0);q=+(b|0);r=p/q;s=o?r:m;n[l>>2]=s;hx(d);u=c;return}function Bzb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;g=u;u=u+128|0;h=g+112|0;i=g+100|0;j=g+88|0;k=g+32|0;l=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;gS(c,i);gS(d,j);d=f[i>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=112){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(32)|0;f[h>>2]=d;f[h+8>>2]=-2147483616;f[h+4>>2]=18;m=d;o=455503;q=m+18|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));b[d+18>>0]=0;vM(-215,h,456135,442222,420)}d=f[c+40>>2]|0;e=f[d+12>>2]|0;r=f[d+8>>2]|0;d=f[c+96>>2]|0;c=(r|0)==0;if(!c?(s=a+108|0,t=a+112|0,v=a+120|0,w=a+84|0,x=a+88|0,y=a+52|0,z=a+96|0,A=a+56|0,B=+(f[d+12>>2]|0),C=+(f[d+8>>2]|0),d=a+135|0,e|0):0){D=f[(f[j>>2]|0)+16>>2]|0;E=0;F=f[t>>2]|0;G=f[s>>2]|0;while(1){H=+(E>>>0);I=0;J=D;K=F;L=G;M=G;N=G;while(1){if((K|0)==(L|0)){O=J;P=M;Q=N;R=L;S=L}else{T=+(I>>>0);U=f[w>>2]|0;V=0;W=J;X=N;Z=M;_=K;$=U;aa=f[x>>2]|0;ba=U;while(1){if((aa|0)==(ba|0)){ca=W;da=$;ea=ba;fa=ba;ga=Z;ha=_}else{ia=+n[X+(V<<2)>>2]*.5;ja=+n[(f[v>>2]|0)+(V<<2)>>2]*.5;U=0;ka=W;la=$;do{ma=(T+ +n[la+(U<<2)>>2])*+n[y>>2];na=(H+ +n[(f[z>>2]|0)+(U<<2)>>2])*+n[A>>2];oa=ma-ia;pa=ia+ma;ma=ja+na;qa=na-ja;if(!(b[d>>0]|0)){n[ka>>2]=oa;ra=ma+-1.0;sa=pa+-1.0;ta=qa}else{n[ka>>2]=oa/B;ra=ma/C;sa=pa/B;ta=qa/C}n[ka+4>>2]=ta;n[ka+8>>2]=sa;n[ka+12>>2]=ra;ka=ka+16|0;U=U+1|0;ua=f[x>>2]|0;va=f[w>>2]|0;la=va}while(U>>>0<ua-va>>2>>>0);ca=ka;da=la;ea=va;fa=ua;ga=f[s>>2]|0;ha=f[t>>2]|0}V=V+1|0;U=ga;if(V>>>0>=ha-ga>>2>>>0){O=ca;P=ga;Q=U;R=ga;S=ha;break}else{W=ca;X=U;Z=ga;_=ha;$=da;aa=fa;ba=ea}}}I=I+1|0;if((I|0)==(e|0))break;else{J=O;K=S;L=R;M=P;N=Q}}E=E+1|0;if((E|0)==(r|0))break;else{D=O;F=S;G=P}}}if(b[a+133>>0]|0){P=Y(Y(e<<2,r)|0,f[a+136>>2]|0)|0;G=f[j>>2]|0;S=f[G+16>>2]|0;if(!P){wa=G;xa=S}else{F=0;do{O=S+(F<<2)|0;n[h>>2]=0.0;D=+n[O>>2]<0.0?h:O;n[k>>2]=1.0;f[O>>2]=f[(+n[D>>2]>1.0?k:D)>>2];F=F+1|0}while((F|0)!=(P|0));wa=G;xa=S}}else{S=f[j>>2]|0;wa=S;xa=f[S+16>>2]|0}S=xa+(f[(f[wa+44>>2]|0)+4>>2]|0)|0;xa=a+72|0;G=f[xa>>2]|0;P=G;if(((f[a+76>>2]|0)-G|0)==4){F=f[(f[wa+40>>2]|0)+8>>2]|0;f[k>>2]=1124007941;wa=k+4|0;f[wa>>2]=2;D=k+8|0;f[D>>2]=1;f[k+12>>2]=F;O=k+16|0;f[O>>2]=S;f[k+20>>2]=S;E=k+24|0;Q=k+40|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[Q>>2]=D;D=k+48|0;R=k+44|0;f[R>>2]=D;ea=k+52|0;f[ea>>2]=0;f[D>>2]=0;if((S|0)==0&(F|0)!=0){fa=$Xc(32)|0;f[h>>2]=fa;f[h+8>>2]=-2147483616;f[h+4>>2]=28;m=fa;o=470314;q=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));b[fa+28>>0]=0;vM(-215,h,470343,470347,548)}fa=F<<2;f[D>>2]=fa;f[ea>>2]=4;ea=S+fa|0;f[k+28>>2]=ea;f[E>>2]=ea+(0-fa)+fa;R$(k);ra=+n[f[xa>>2]>>2];p[l>>3]=ra;p[l+8>>3]=ra;p[l+16>>3]=ra;p[l+24>>3]=ra;f[h>>2]=-1056833530;f[h+4>>2]=l;f[h+8>>2]=1;f[h+12>>2]=4;mR(k,h,fT()|0)|0;h=k+36|0;l=f[h>>2]|0;if(l|0?(xa=l+12|0,l=f[xa>>2]|0,f[xa>>2]=l+-1,(l|0)==1):0)V$(k);f[h>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[wa>>2]|0)>0){O=f[Q>>2]|0;Q=0;do{f[O+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[wa>>2]|0))}wa=f[R>>2]|0;if((wa|0)!=(D|0))wL(wa)}else if(!(c|(e|0)==0)){c=f[a+136>>2]|0;a=G;G=P+4|0;wa=P+8|0;D=P+12|0;P=0;R=0;Q=c;while(1){if(!Q){ya=0;za=R}else{O=0;h=R;while(1){k=0;l=h;do{f[S+(l<<2)>>2]=f[a>>2];f[S+(l+1<<2)>>2]=f[G>>2];f[S+(l+2<<2)>>2]=f[wa>>2];f[S+(l+3<<2)>>2]=f[D>>2];l=l+4|0;k=k+1|0}while(k>>>0<c>>>0);O=O+1|0;if((O|0)==(e|0)){ya=c;za=l;break}else h=l}}P=P+1|0;if((P|0)==(r|0))break;else{R=za;Q=ya}}}hx(j);hx(i);u=g;return}function Czb(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 3:{c=1;break}case 2:{if(orb()|0)c=1;else d=4;break}case 4:{c=nrb()|0;break}default:d=4}if((d|0)==4)c=0;return c|0}function Dzb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ezb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Fzb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+32|0;d=g+16|0;h=g;i=f[c>>2]|0;if((i|0)==(f[c+4>>2]|0)){c=$Xc(16)|0;f[d>>2]=c;f[d+8>>2]=-2147483632;f[d+4>>2]=15;j=c;k=444255;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[c+15>>0]=0;vM(-215,d,456079,442222,284)}c=f[i>>2]|0;i=Y(Y(f[c+8>>2]<<2,f[c+12>>2]|0)|0,f[a+136>>2]|0)|0;f[d>>2]=1;f[d+4>>2]=2;f[d+8>>2]=i;f[d+12>>2]=-1;f[h>>2]=0;i=h+4|0;f[i>>2]=0;f[h+8>>2]=0;gOa(h,d,d+16|0);d=f[h>>2]|0;a=f[i>>2]|0;a:do if((d|0)==(a|0)){m=d;n=6}else{c=d;do{if((f[c>>2]|0)<0){m=c;n=6;break a}c=c+4|0}while((c|0)!=(a|0))}while(0);if((n|0)==6?(m|0)!=(a|0):0){n=m+4|0;if((n|0)==(a|0)){o=a;p=m}else{d=n;n=m;while(1){m=f[d>>2]|0;if((m|0)<0)q=n;else{f[n>>2]=m;q=n+4|0}d=d+4|0;if((d|0)==(a|0))break;else n=q}o=f[i>>2]|0;p=q}if((p|0)!=(o|0))f[i>>2]=o+(~((o+-4-p|0)>>>2)<<2)}p=e+4|0;o=f[p>>2]|0;q=f[e>>2]|0;n=o-q|0;a=(n|0)/12|0;d=q;q=o;if(n){if(a>>>0>1?(n=d+12|0,(q|0)!=(n|0)):0){d=q;while(1){q=d+-12|0;f[p>>2]=q;o=f[q>>2]|0;if(!o)r=q;else{q=d+-8|0;m=f[q>>2]|0;if((m|0)!=(o|0))f[q>>2]=m+(~((m+-4-o|0)>>>2)<<2);cYc(o);r=f[p>>2]|0}if((r|0)==(n|0))break;else d=r}}}else Nvb(e,1-a|0,h);a=f[h>>2]|0;if(!a){u=g;return 0}h=f[i>>2]|0;if((h|0)!=(a|0))f[i>>2]=h+(~((h+-4-a|0)>>>2)<<2);cYc(a);u=g;return 0}function Gzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=f[c+4>>2]|0;h=f[c>>2]|0;c=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=d;return j|0}k=a+136|0;a=(g-h|0)/12|0;h=0;g=0;do{l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=4){q=8;break}if((n|0)>8){n=2;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;h=(Y(r<<2,f[k>>2]|0)|0)+h|0;g=g+1|0}while(g>>>0<a>>>0);if((q|0)==8){q=$Xc(80)|0;f[e>>2]=q;f[e+8>>2]=-2147483568;f[e+4>>2]=70;a=q;g=454543;k=a+70|0;do{b[a>>0]=b[g>>0]|0;a=a+1|0;g=g+1|0}while((a|0)<(k|0));b[q+70>>0]=0;vM(-215,e,454614,454620,161)}i=((h|0)<0)<<31>>31;j=h;J=i;u=d;return j|0}function Hzb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(184)|0;Izb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=105888;f[b+12>>2]=c;f[a+4>>2]=b;return}function Izb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=105916;f[a+52>>2]=1124007936;g=a+60|0;h=a+92|0;i=a+56|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+100|0;f[a+96>>2]=g;f[g>>2]=0;f[a+104>>2]=0;f[a+108>>2]=1124007936;g=a+116|0;h=a+148|0;i=a+112|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+156|0;f[a+152>>2]=g;f[g>>2]=0;f[a+160>>2]=0;f[a+168>>2]=0;f[a+172>>2]=0;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=18;i=g;h=443074;j=i+18|0;do{b[i>>0]=b[h>>0]|0;i=i+1|0;h=h+1|0}while((i|0)<(j|0));b[g+18>>0]=0;g=LGa(c,e)|0;k=c+4|0;if((g|0)==(k|0))l=1;else{m=MGa(g+28|0,-1)|0;l=(m|0)!=0|(J|0)!=0}b[a+48>>0]=l&1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=$Xc(16)|0;f[e>>2]=l;f[e+8>>2]=-2147483632;f[e+4>>2]=15;i=l;h=443093;j=i+15|0;do{b[i>>0]=b[h>>0]|0;i=i+1|0;h=h+1|0}while((i|0)<(j|0));b[l+15>>0]=0;l=LGa(c,e)|0;if((l|0)==(k|0))o=0;else{h=MGa(l+28|0,-1)|0;o=(h|0)!=0|(J|0)!=0}b[a+49>>0]=o&1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);o=e+4|0;f[o>>2]=0;f[o+4>>2]=0;o=e+11|0;b[o>>0]=3;b[e>>0]=b[513188]|0;b[e+1>>0]=b[513189]|0;b[e+2>>0]=b[513190]|0;b[e+3>>0]=0;h=LGa(c,e)|0;if((h|0)==(k|0))p=1.0e-09;else p=+NGa(h+28|0,-1);n[a+44>>2]=p;if((b[o>>0]|0)>=0){q=a+164|0;b[q>>0]=0;r=a+180|0;b[r>>0]=0;s=a+176|0;n[s>>2]=0.0;t=a+181|0;b[t>>0]=0;u=d;return}cYc(f[e>>2]|0);q=a+164|0;b[q>>0]=0;r=a+180|0;b[r>>0]=0;s=a+176|0;n[s>>2]=0.0;t=a+181|0;b[t>>0]=0;u=d;return}function Jzb(a){a=a|0;NXc(a);cYc(a);return}function Kzb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Lzb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==442923?a+12|0:0)|0}function Mzb(a){a=a|0;cYc(a);return}function Nzb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=105916;b=f[a+172>>2]|0;if(b|0)UXc(b);b=a+108|0;c=a+144|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+124|0;b=a+112|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+148>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+152>>2]|0;if((b|0)!=(a+156|0))wL(b);b=a+52|0;d=a+88|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+68|0;b=a+56|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+92>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+96>>2]|0;if((b|0)==(a+100|0)){MNa(a);return}wL(b);MNa(a);return}function Ozb(a){a=a|0;Nzb(a);cYc(a);return}function Pzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;gS(c,e);c=b[a+49>>0]|0?1:2;g=f[e>>2]|0;h=f[g+40>>2]|0;i=0;j=1;do{j=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0}while((i|0)<(c|0));c=f[g+4>>2]|0;if((c|0)<3){k=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;l=(k|0)==(j|0);m=a+181|0;n=l&1;b[m>>0]=n;hx(e);u=d;return}else{g=0;i=1;while(1){o=Y(f[h+(g<<2)>>2]|0,i)|0;g=g+1|0;if((g|0)==(c|0)){k=o;break}else i=o}l=(k|0)==(j|0);m=a+181|0;n=l&1;b[m>>0]=n;hx(e);u=d;return}}function Qzb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0;g=u;u=u+400|0;h=g+384|0;i=g+104|0;j=g+368|0;k=g+356|0;l=g+344|0;m=g+288|0;o=g+232|0;q=g+48|0;r=g+16|0;s=g+176|0;t=g+120|0;v=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[j>>2]=0;w=j+4|0;f[w>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;gS(c,j);gS(d,k);gS(e,l);a:do if((f[w>>2]|0)!=(f[j>>2]|0)){e=a+49|0;d=a+124|0;c=h+8|0;x=h+12|0;y=h+4|0;z=a+112|0;A=a+116|0;B=a+120|0;C=h+4|0;D=i+4|0;E=h+8|0;F=h+12|0;G=h+4|0;H=q+36|0;I=q+16|0;J=q+4|0;K=q+40|0;L=q+44|0;M=q+48|0;N=a+148|0;O=o+36|0;P=o+16|0;Q=o+4|0;R=o+40|0;S=o+44|0;T=o+48|0;U=m+36|0;V=m+16|0;W=m+4|0;X=m+40|0;Z=m+44|0;_=m+48|0;$=h+4|0;aa=i+4|0;ba=h+4|0;ca=i+4|0;da=a+164|0;ea=h+8|0;fa=h+12|0;ga=h+4|0;ha=i+4|0;ia=i+8|0;ja=i+12|0;ka=a+48|0;la=v+8|0;ma=v+12|0;na=h+8|0;oa=h+4|0;pa=t+36|0;qa=t+16|0;ra=t+4|0;sa=t+40|0;ta=t+44|0;ua=t+48|0;va=s+36|0;wa=s+16|0;xa=s+4|0;ya=s+40|0;za=s+44|0;Aa=s+48|0;Ba=a+44|0;Ca=v+4|0;Da=a+64|0;Ea=a+68|0;Fa=0;Ga=f[j>>2]|0;do{Ha=f[k>>2]|0;Ia=b[e>>0]|0?1:2;Ja=Ga+(Fa*56|0)+40|0;Ka=f[Ja>>2]|0;La=1;Ma=0;do{La=Y(f[Ka+(Ma<<2)>>2]|0,La)|0;Ma=Ma+1|0}while((Ma|0)<(Ia|0));Ia=Ha+(Fa*56|0)|0;g0(m,Ga+(Fa*56|0)|0,1,La);g0(o,Ia,1,La);Ma=f[Ga+(Fa*56|0)+4>>2]|0;if((Ma|0)<3)Na=Y(f[Ga+(Fa*56|0)+12>>2]|0,f[Ga+(Fa*56|0)+8>>2]|0)|0;else{Ka=f[Ja>>2]|0;Oa=0;Pa=1;while(1){Qa=Y(f[Ka+(Oa<<2)>>2]|0,Pa)|0;Oa=Oa+1|0;if((Oa|0)==(Ma|0)){Na=Qa;break}else Pa=Qa}}b:do if((Na|0)==(La|0)){if(f[d>>2]|0){Pa=f[z>>2]|0;if((Pa|0)<3)Ra=Y(f[B>>2]|0,f[A>>2]|0)|0;else{Ma=f[N>>2]|0;Oa=0;Ka=1;while(1){Ja=Y(f[Ma+(Oa<<2)>>2]|0,Ka)|0;Oa=Oa+1|0;if((Oa|0)==(Pa|0)){Ra=Ja;break}else Ka=Ja}}if(!((Pa|0)==0|(Ra|0)==0)){if((La|0)>0)Sa=0;else{Ta=1;break}while(1){Ka=Sa;Sa=Sa+1|0;f[h>>2]=Ka;f[C>>2]=Sa;f[i>>2]=-2147483648;f[D>>2]=2147483647;W$(q,o,h,i);p[i>>3]=+n[(f[d>>2]|0)+(Ka<<2)>>2];f[h>>2]=-1056833530;f[G>>2]=i;f[E>>2]=1;f[F>>2]=1;mR(q,h,fT()|0)|0;Ka=f[H>>2]|0;if(Ka|0?(Oa=Ka+12|0,Ka=f[Oa>>2]|0,f[Oa>>2]=Ka+-1,(Ka|0)==1):0)V$(q);f[H>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[J>>2]|0)>0){Ka=f[K>>2]|0;Oa=0;do{f[Ka+(Oa<<2)>>2]=0;Oa=Oa+1|0}while((Oa|0)<(f[J>>2]|0))}Oa=f[L>>2]|0;if((Oa|0)!=(M|0))wL(Oa);if((Sa|0)>=(La|0)){Ta=1;break b}}}}p[i>>3]=0.0;f[h>>2]=-1056833530;f[y>>2]=i;f[c>>2]=1;f[x>>2]=1;mR(Ia,h,fT()|0)|0;Ta=1}else{f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[q+28>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;if((La|0)>0){Pa=0;do{Oa=Pa;Pa=Pa+1|0;f[h>>2]=Oa;f[$>>2]=Pa;f[i>>2]=-2147483648;f[aa>>2]=2147483647;W$(s,m,h,i);f[h>>2]=Oa;f[ba>>2]=Pa;f[i>>2]=-2147483648;f[ca>>2]=2147483647;W$(t,o,h,i);if(b[da>>0]|0){if((Oa|0)<(f[Da>>2]|0))Ua=+n[(f[Ea>>2]|0)+(Oa<<2)>>2];else Ua=1.0;if((Oa|0)<(f[B>>2]|0)){Va=+n[(f[d>>2]|0)+(Oa<<2)>>2];Wa=Ua}else{Va=0.0;Wa=Ua}}else{Va=0.0;Wa=1.0}f[ea>>2]=0;f[fa>>2]=0;f[h>>2]=16842752;f[ga>>2]=s;f[i>>2]=-1040056314;f[ha>>2]=q;f[ia>>2]=1;f[ja>>2]=4;if(!(b[ka>>0]|0)){Oa=fT()|0;Ka=Oa;Ma=f[Ka+4>>2]|0;Ja=v;f[Ja>>2]=f[Ka>>2];f[Ja+4>>2]=Ma;f[la>>2]=f[Oa+8>>2];Xa=f[Oa+12>>2]|0}else{f[v>>2]=-1023279098;f[Ca>>2]=r;f[la>>2]=1;Xa=4}f[ma>>2]=Xa;nL(h,i,v,fT()|0);if(!(b[ka>>0]|0))Ya=1.0;else Ya=1.0/(+n[Ba>>2]+ +p[r>>3]);if(!(b[da>>0]|0)){Za=-(Ya*+p[q>>3]);_a=Ya}else{$a=Wa*Ya;Za=Va-$a*+p[q>>3];_a=$a}Oa=na;f[Oa>>2]=0;f[Oa+4>>2]=0;f[h>>2]=33619968;f[oa>>2]=t;dY(s,h,f[t>>2]&4095,_a,Za);Oa=f[pa>>2]|0;if(Oa|0?(Ma=Oa+12|0,Oa=f[Ma>>2]|0,f[Ma>>2]=Oa+-1,(Oa|0)==1):0)V$(t);f[pa>>2]=0;f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;f[qa+12>>2]=0;if((f[ra>>2]|0)>0){Oa=f[sa>>2]|0;Ma=0;do{f[Oa+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[ra>>2]|0))}Ma=f[ta>>2]|0;if((Ma|0)!=(ua|0))wL(Ma);Ma=f[va>>2]|0;if(Ma|0?(Oa=Ma+12|0,Ma=f[Oa>>2]|0,f[Oa>>2]=Ma+-1,(Ma|0)==1):0)V$(s);f[va>>2]=0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[xa>>2]|0)>0){Ma=f[ya>>2]|0;Oa=0;do{f[Ma+(Oa<<2)>>2]=0;Oa=Oa+1|0}while((Oa|0)<(f[xa>>2]|0))}Oa=f[za>>2]|0;if((Oa|0)!=(Aa|0))wL(Oa)}while((Pa|0)<(La|0))}Ta=0}while(0);La=f[O>>2]|0;if(La|0?(Ia=La+12|0,La=f[Ia>>2]|0,f[Ia>>2]=La+-1,(La|0)==1):0)V$(o);f[O>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[Q>>2]|0)>0){La=f[R>>2]|0;Ia=0;do{f[La+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[Q>>2]|0))}Ia=f[S>>2]|0;if((Ia|0)!=(T|0))wL(Ia);Ia=f[U>>2]|0;if(Ia|0?(La=Ia+12|0,Ia=f[La>>2]|0,f[La>>2]=Ia+-1,(Ia|0)==1):0)V$(m);f[U>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[W>>2]|0)>0){Ia=f[X>>2]|0;La=0;do{f[Ia+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[W>>2]|0))}La=f[Z>>2]|0;if((La|0)!=(_|0))wL(La);Fa=Fa+1|0;if(Ta|0)break a;Ga=f[j>>2]|0}while(Fa>>>0<(((f[w>>2]|0)-Ga|0)/56|0)>>>0)}while(0);hx(l);hx(k);hx(j);u=g;return}function Rzb(a,c){a=a|0;c=c|0;var d=0;if((c|0)!=2){d=(c|0)==3;return d|0}if(b[a+181>>0]|0){d=0;return d|0}if(!(f[a+40>>2]|0)){d=1;return d|0}d=+n[a+44>>2]<=1.0000000116860974e-07;return d|0}function Szb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Tzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=a+180|0;if(d|0){if((b[e>>0]|0)==0?(g=a+164|0,(b[g>>0]|0)==0):0){Ti[f[(f[d>>2]|0)+88>>2]&511](d,a+52|0,a+108|0);if(f[a+68>>2]|0){h=f[a+56>>2]|0;if((h|0)<3)i=Y(f[a+64>>2]|0,f[a+60>>2]|0)|0;else{j=f[a+92>>2]|0;k=0;l=1;while(1){m=Y(f[j+(k<<2)>>2]|0,l)|0;k=k+1|0;if((k|0)==(h|0)){i=m;break}else l=m}}if(!((h|0)==0|(i|0)==0)){n=g;o=1;p=o&1;b[n>>0]=p;return o|0}}if(!(f[a+124>>2]|0)){n=g;o=0;p=o&1;b[n>>0]=p;return o|0}i=f[a+112>>2]|0;if((i|0)<3)q=Y(f[a+120>>2]|0,f[a+116>>2]|0)|0;else{h=f[a+148>>2]|0;l=0;k=1;while(1){j=Y(f[h+(l<<2)>>2]|0,k)|0;l=l+1|0;if((l|0)==(i|0)){q=j;break}else k=j}}n=g;o=(i|0)!=0&(q|0)!=0;p=o&1;b[n>>0]=p;return o|0}if((f[a+40>>2]|0)==1){q=kZc(d,15248,17056,0)|0;if(q){d=q;q=f[c+4>>2]|0;if(q|0)TXc(q);c=a+168|0;if(!q){r=d;s=0;t=c;u=q;v=1}else{TXc(q);r=d;s=q;t=c;u=q;v=0}}else{r=0;s=0;t=a+168|0;u=0;v=1}f[t>>2]=r;r=a+172|0;t=f[r>>2]|0;f[r>>2]=s;if(t|0)UXc(t);if(!v)UXc(u);u=f[a+168>>2]|0;if(u|0)f[a+176>>2]=f[u+44>>2]}}n=e;o=(f[a+168>>2]|0)!=0;p=o&1;b[n>>0]=p;return o|0}function Uzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=f[c+4>>2]|0;h=f[c>>2]|0;c=h;if((g|0)==(h|0)){i=0;j=0;J=i;u=d;return j|0}k=a+48|0;a=(g-h|0)/12|0;h=0;g=0;a:while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;m=(p|0)==(l|0);do if(m){q=0;r=0}else{if((n|0)<0){s=9;break a}if(n){l=1;t=0;do{l=Y(f[p+(t<<2)>>2]|0,l)|0;t=t+1|0}while((t|0)!=(o|0));t=l*6|0;if(m){q=0;r=t;break}else{v=b[k>>0]|0?2:1;w=t}}else{v=b[k>>0]|0?2:1;w=6}if((n|0)<0|(v|0)>(o|0)){s=13;break a}else{x=1;y=0}while(1){t=Y(f[p+(y<<2)>>2]|0,x)|0;y=y+1|0;if((y|0)==(v|0)){q=t;r=w;break}else x=t}}while(0);h=r+h+(q*3|0)|0;g=g+1|0;if(g>>>0>=a>>>0){s=3;break}}if((s|0)==3){i=((h|0)<0)<<31>>31;j=h;J=i;u=d;return j|0}else if((s|0)==9){j=$Xc(80)|0;f[e>>2]=j;f[e+8>>2]=-2147483568;f[e+4>>2]=70;z=j;A=454543;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[j+70>>0]=0;vM(-215,e,454614,454620,161)}else if((s|0)==13){s=$Xc(80)|0;f[e>>2]=s;f[e+8>>2]=-2147483568;f[e+4>>2]=70;z=s;A=454543;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[s+70>>0]=0;vM(-215,e,454614,454620,161)}return 0}function Vzb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(124)|0;Wzb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=106028;f[b+12>>2]=c;f[a+4>>2]=b;return}function Wzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d;qQa(a);j=a+48|0;k=a+80|0;f[k>>2]=0;l=a+84|0;f[l>>2]=0;m=a+92|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;o=a+108|0;f[o>>2]=0;p=a+112|0;f[p>>2]=0;q=j;f[q>>2]=0;f[q+4>>2]=0;f[a>>2]=106056;b[a+89>>0]=1;q=a+88|0;b[q>>0]=0;r=a+56|0;f[r>>2]=1;s=a+60|0;f[s>>2]=1;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=4;f[e>>2]=1819242352;b[e+4>>0]=0;if(!(HIa(c,e)|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=$Xc(16)|0;f[g>>2]=v;f[g+8>>2]=-2147483632;f[g+4>>2]=11;w=v;x=446598;y=w+11|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[v+11>>0]=0;if(!(HIa(c,g)|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=h+11|0;b[v>>0]=8;z=h;f[z>>2]=1852990827;f[z+4>>2]=2002742373;b[h+8>>0]=0;if(!(HIa(c,h)|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;z=i+11|0;b[z>>0]=8;A=i;f[A>>2]=1852990827;f[A+4>>2]=1751084133;b[i+8>>0]=0;A=(HIa(c,i)|0)!=0;if((b[z>>0]|0)<0)cYc(f[i>>2]|0);B=A}else B=1;if((b[v>>0]|0)<0)cYc(f[h>>2]|0);C=B}else C=1;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);D=C}else D=1;if((b[t>>0]|0)<0)cYc(f[e>>2]|0);do if(D){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=h+11|0;b[t>>0]=4;f[h>>2]=1819242352;b[h+4>>0]=0;C=i+4|0;f[C>>2]=0;f[C+4>>2]=0;C=i+11|0;b[C>>0]=3;b[i>>0]=b[443327]|0;b[i+1>>0]=b[443328]|0;b[i+2>>0]=b[443329]|0;b[i+3>>0]=0;B=LGa(c,h)|0;if((B|0)==(c+4|0))lYc(g,i);else OIa(g,B+28|0,-1);lYc(e,g);B=e+11|0;v=b[B>>0]|0;A=v<<24>>24<0;z=f[e>>2]|0;E=e+4|0;F=A?z+(f[E>>2]|0)|0:e+(v&255)|0;v=A?z:e;if((v|0)!=(F|0)){z=v;do{v=(OIc(b[z>>0]|0)|0)&255;b[z>>0]=v;z=z+1|0}while((z|0)!=(F|0))}if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[C>>0]|0)<0)cYc(f[i>>2]|0);if((b[t>>0]|0)<0)cYc(f[h>>2]|0);F=b[B>>0]|0;z=f[E>>2]|0;if(((F<<24>>24<0?z:F&255)|0)==3)if(!(LYc(e,0,-1,443327,3)|0))G=0;else{H=b[B>>0]|0;I=f[E>>2]|0;K=30}else{H=F;I=z;K=30}do if((K|0)==30){if(((H<<24>>24<0?I:H&255)|0)==3){if(!(LYc(e,0,-1,443331,3)|0)){G=1;break}L=b[B>>0]|0;M=f[E>>2]|0}else{L=H;M=I}if(((L<<24>>24<0?M:L&255)|0)!=10){SGa(h,443346,e);N=AYc(h,505469)|0;f[g>>2]=f[N>>2];f[g+4>>2]=f[N+4>>2];f[g+8>>2]=f[N+8>>2];f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;vM(-5,g,443369,443386,88)}if(!(LYc(e,0,-1,443335,10)|0))G=2;else{SGa(h,443346,e);N=AYc(h,505469)|0;f[g>>2]=f[N>>2];f[g+4>>2]=f[N+4>>2];f[g+8>>2]=f[N+8>>2];f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;vM(-5,g,443369,443386,88)}}while(0);f[a+44>>2]=G;E=a+68|0;t=a+64|0;rBb(c,a+52|0,j,q,E,t,a+76|0,a+72|0,s,r,m);f[k>>2]=f[t>>2];f[l>>2]=f[E>>2];if((b[B>>0]|0)<0)cYc(f[e>>2]|0)}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=e+11|0;b[E>>0]=8;t=e;f[t>>2]=1819242352;f[t+4>>2]=2002740325;b[e+8>>0]=0;if(!(HIa(c,e)|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;t=g+11|0;b[t>>0]=8;C=g;f[C>>2]=1819242352;f[C+4>>2]=1751082085;b[g+8>>0]=0;C=(HIa(c,g)|0)!=0;if((b[t>>0]|0)<0)cYc(f[g>>2]|0);O=C}else O=1;if((b[E>>0]|0)<0)cYc(f[e>>2]|0);if(O){f[a+44>>2]=3;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=e+11|0;b[E>>0]=8;C=e;f[C>>2]=1819242352;f[C+4>>2]=2002740325;b[e+8>>0]=0;C=LGa(c,e)|0;t=c+4|0;if((C|0)==(t|0))P=1;else{z=MGa(C+28|0,-1)|0;P=z}f[o>>2]=P;if((b[E>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=e+11|0;b[E>>0]=8;z=e;f[z>>2]=1819242352;f[z+4>>2]=1751082085;b[e+8>>0]=0;z=LGa(c,e)|0;if((z|0)==(t|0))Q=1;else{t=MGa(z+28|0,-1)|0;Q=t}f[p>>2]=Q;if((b[E>>0]|0)<0)cYc(f[e>>2]|0);break}E=e+11|0;b[E>>0]=10;w=e;x=443467;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[e+10>>0]=0;if(!(HIa(c,e)|0))R=0;else{B=g+11|0;b[B>>0]=10;w=g;x=443478;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[g+10>>0]=0;t=(HIa(c,g)|0)!=0;if((b[B>>0]|0)<0)cYc(f[g>>2]|0);R=t}if((b[E>>0]|0)<0)cYc(f[e>>2]|0);if(!R){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=$Xc(32)|0;f[e>>2]=t;f[e+8>>2]=-2147483616;f[e+4>>2]=29;w=t;x=443489;y=w+29|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[t+29>>0]=0;vM(-5,e,443369,443386,110)}f[a+44>>2]=4;E=e+11|0;b[E>>0]=10;w=e;x=443478;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[e+10>>0]=0;t=MGa(NIa(c,e)|0,-1)|0;f[o>>2]=t;if((b[E>>0]|0)<0){cYc(f[e>>2]|0);S=f[o>>2]|0}else S=t;f[p>>2]=S;t=e+11|0;b[t>>0]=10;w=e;x=443467;y=w+10|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[e+10>>0]=0;E=MGa(NIa(c,e)|0,-1)|0;f[a+120>>2]=E;if((b[t>>0]|0)<0)cYc(f[e>>2]|0)}while(0);rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;S=e+11|0;b[S>>0]=9;w=e;x=443519;y=w+9|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[e+9>>0]=0;p=LGa(c,e)|0;o=c+4|0;if((p|0)==(o|0))T=1;else{R=MGa(p+28|0,-1)|0;T=((R|0)!=0|(J|0)!=0)&1}b[a+104>>0]=T;if((b[S>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;S=$Xc(16)|0;f[e>>2]=S;f[e+8>>2]=-2147483632;f[e+4>>2]=13;w=S;x=443529;y=w+13|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[S+13>>0]=0;S=LGa(c,e)|0;if((S|0)==(o|0))U=1.0;else U=+NGa(S+28|0,-1);n[a+116>>2]=U;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;S=$Xc(32)|0;f[e>>2]=S;f[e+8>>2]=-2147483616;f[e+4>>2]=20;w=S;x=443543;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[S+20>>0]=0;S=LGa(c,e)|0;if((S|0)==(o|0))V=1;else{o=MGa(S+28|0,-1)|0;V=((o|0)!=0|(J|0)!=0)&1}b[a+105>>0]=V;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function Xzb(a){a=a|0;NXc(a);cYc(a);return}function Yzb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function Zzb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==443168?a+12|0:0)|0}function _zb(a){a=a|0;cYc(a);return}function $zb(a){a=a|0;var c=0;f[a>>2]=106176;c=a+92|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);return}function aAb(a){a=a|0;var c=0;f[a>>2]=106176;c=a+92|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);cYc(a);return}function bAb(a){a=a|0;var c=0;f[a>>2]=106176;c=a+92|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);cYc(a);return}function cAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+28|0;i=e+16|0;j=e+8|0;k=e;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=f[g>>2]|0;if((d|0)==(f[l>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=$Xc(16)|0;f[i>>2]=l;f[i+8>>2]=-2147483632;f[i+4>>2]=15;c=l;m=444255;n=c+15|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(n|0));b[l+15>>0]=0;vM(-215,i,455619,443386,127)}l=f[d+40>>2]|0;d=f[l+12>>2]|0;m=f[l+8>>2]|0;f[i>>2]=d;f[i+4>>2]=m;l=f[(f[h>>2]|0)+40>>2]|0;c=f[l+8>>2]|0;f[j>>2]=f[l+12>>2];f[j+4>>2]=c;if(b[a+88>>0]|0){f[a+48>>2]=d;f[a+52>>2]=m}f[k>>2]=1;f[k+4>>2]=1;m=a+68|0;d=a+64|0;uBb(i,j,a+48|0,a+56|0,a+92|0,k,m,d,a+76|0,a+72|0);f[a+80>>2]=f[d>>2];f[a+84>>2]=f[m>>2];b[a+89>>0]=(f[a+44>>2]|0)==0&1;hx(h);hx(g);u=e;return}function dAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+80|0;h=g+68|0;i=g+56|0;j=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);a:do switch(f[a+44>>2]|0){case 0:{if(((f[e>>2]|0)-(f[h>>2]|0)|0)!=56){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=$Xc(32)|0;f[j>>2]=d;f[j+8>>2]=-2147483616;f[j+4>>2]=18;l=d;m=456060;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[d+18>>0]=0;vM(-215,j,456135,443386,231)}do if(b[a+89>>0]|0){if(((f[k>>2]|0)-(f[i>>2]|0)|0)!=112){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=$Xc(48)|0;f[j>>2]=c;f[j+8>>2]=-2147483600;f[j+4>>2]=37;l=c;m=443791;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[c+37>>0]=0;vM(-215,j,456135,443386,231)}o=f[i>>2]|0;p=o+56|0;f[j>>2]=f[p>>2];q=j+4|0;r=o+60|0;s=f[r>>2]|0;f[q>>2]=s;t=j+8|0;f[t>>2]=f[o+64>>2];f[j+12>>2]=f[o+68>>2];f[j+16>>2]=f[o+72>>2];f[j+20>>2]=f[o+76>>2];f[j+24>>2]=f[o+80>>2];f[j+28>>2]=f[o+84>>2];f[j+32>>2]=f[o+88>>2];v=f[o+92>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(!v)x=s;else{s=v+12|0;f[s>>2]=(f[s>>2]|0)+1;x=f[r>>2]|0}if((x|0)<3){r=f[o+100>>2]|0;o=f[w>>2]|0;f[o>>2]=f[r>>2];f[o+4>>2]=f[r+4>>2];y=j;break}else{f[q>>2]=0;U$(j,p);y=j;break}}else{f[j>>2]=1124007936;p=j+8|0;q=j+40|0;l=j+4|0;n=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[q>>2]=p;c=j+48|0;f[j+44>>2]=c;f[c>>2]=0;f[j+52>>2]=0;y=j}while(0);nAb(a,f[h>>2]|0,f[i>>2]|0,j);d=j+36|0;c=f[d>>2]|0;if(c|0?(r=c+12|0,c=f[r>>2]|0,f[r>>2]=c+-1,(c|0)==1):0)V$(j);f[d>>2]=0;d=j+16|0;c=j+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[j+40>>2]|0;r=0;do{f[d+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)!=(j+48|0))wL(c);break}case 1:{c=f[h>>2]|0;r=c;if(((f[e>>2]|0)-c|0)!=56){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=$Xc(32)|0;f[j>>2]=c;f[j+8>>2]=-2147483616;f[j+4>>2]=18;l=c;m=456060;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[c+18>>0]=0;vM(-215,j,456135,443386,237)}d=f[i>>2]|0;if(((f[k>>2]|0)-d|0)==56){oAb(a,r,d);break a}else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=$Xc(32)|0;f[j>>2]=d;f[j+8>>2]=-2147483616;f[j+4>>2]=19;l=d;m=452040;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[d+19>>0]=0;vM(-215,j,456135,443386,237)}break}case 4:case 3:{r=f[h>>2]|0;c=r;if(((f[e>>2]|0)-r|0)!=112){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(32)|0;f[j>>2]=r;f[j+8>>2]=-2147483616;f[j+4>>2]=18;l=r;m=455503;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[r+18>>0]=0;vM(-215,j,456135,443386,241)}d=f[i>>2]|0;if(((f[k>>2]|0)-d|0)==56){pAb(a,c,c+56|0,d);break a}else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=$Xc(32)|0;f[j>>2]=d;f[j+8>>2]=-2147483616;f[j+4>>2]=19;l=d;m=452040;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[d+19>>0]=0;vM(-215,j,456135,443386,241)}break}default:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=$Xc(16)|0;f[j>>2]=c;f[j+8>>2]=-2147483632;f[j+4>>2]=15;l=c;m=443829;n=l+15|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[c+15>>0]=0;vM(-213,j,456135,443386,245)}}while(0);hx(i);hx(h);u=g;return}function eAb(a,b){a=a|0;b=b|0;var c=0,d=0;a:do switch(b|0){case 2:{c=f[a+44>>2]|0;if((f[a+40>>2]|0)==3){d=(c|1|0)==1;return d|0}else{d=(c|0)!=2;return d|0}break}case 1:{if(zQa()|0){switch(f[a+44>>2]|0){case 1:break;case 0:{d=1;return d|0}default:break a}if((((f[a+68>>2]|0)==0?(f[a+64>>2]|0)==0:0)?(f[a+76>>2]|0)==0:0)?(f[a+72>>2]|0)==0:0){d=1;return d|0}}break}case 4:{if(nrb()|0)return (f[a+44>>2]|1|0)==1|0;else{d=0;return d|0}break}case 3:{d=1;return d|0}default:{}}while(0);d=0;return d|0}function fAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function gAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function hAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function iAb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function jAb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0.0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Z=0,_=0;g=u;u=u+64|0;h=g+40|0;i=g+32|0;j=g+16|0;k=g;l=c+4|0;m=f[c>>2]|0;n=m;if((f[l>>2]|0)==(m|0)){o=$Xc(32)|0;f[h>>2]=o;f[h+8>>2]=-2147483616;f[h+4>>2]=18;p=o;q=453566;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+18>>0]=0;vM(-215,h,456079,443386,906)}o=f[n>>2]|0;s=f[o+12>>2]|0;t=f[o+8>>2]|0;f[h>>2]=s;f[h+4>>2]=t;f[i>>2]=0;v=i+4|0;f[v>>2]=0;do if(!(b[a+88>>0]|0)){w=a+44|0;if(((f[w>>2]|0)+-3|0)>>>0<2){x=f[a+112>>2]|0;f[v>>2]=x;y=f[a+108>>2]|0;f[i>>2]=y;z=w;A=o;B=x;C=y;D=m;E=n;break}y=a+92|0;x=b[y+11>>0]|0;if(x<<24>>24<0)F=f[a+96>>2]|0;else F=x&255;if(F|0){f[j>>2]=1;f[j+4>>2]=1;tBb(h,a+48|0,a+56|0,y,j,i);y=f[c>>2]|0;z=w;A=f[y>>2]|0;B=f[v>>2]|0;C=f[i>>2]|0;D=y;E=y;break}y=f[a+76>>2]|0;x=f[a+60>>2]|0;G=+((f[a+68>>2]|0)+t+y-(f[a+52>>2]|0)|0)/+(x|0);H=f[a+72>>2]|0;I=f[a+56>>2]|0;J=+((f[a+64>>2]|0)+s+H-(f[a+48>>2]|0)|0)/+(I|0);if(!(b[a+104>>0]|0)){L=~~(+K(+G)+1.0);f[v>>2]=L;M=+K(+J);N=L}else{L=~~(+X(+G)+1.0);f[v>>2]=L;M=+X(+J);N=L}L=~~(M+1.0);f[i>>2]=L;if(y|H){O=N+-1|0;P=t+y|0;if((Y(O,x)|0)<(P|0))Q=N;else{f[v>>2]=O;Q=O}O=L+-1|0;y=s+H|0;if((Y(O,I)|0)<(y|0))R=L;else{f[i>>2]=O;R=O}if((Y(Q+-1|0,x)|0)>=(P|0)){P=$Xc(64)|0;f[j>>2]=P;f[j+8>>2]=-2147483584;f[j+4>>2]=52;p=P;q=443564;r=p+52|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[P+52>>0]=0;vM(-215,j,456079,443386,934)}if((Y(R+-1|0,I)|0)<(y|0)){z=w;A=o;B=Q;C=R;D=m;E=n}else{x=$Xc(64)|0;f[j>>2]=x;f[j+8>>2]=-2147483584;f[j+4>>2]=49;p=x;q=443617;r=p+49|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[x+49>>0]=0;vM(-215,j,456079,443386,935)}}else{z=w;A=o;B=N;C=L;D=m;E=n}}else{f[v>>2]=1;f[i>>2]=1;z=a+44|0;A=o;B=1;C=1;D=m;E=n}while(0);f[j>>2]=f[A>>2];n=A+4|0;f[j+4>>2]=f[n>>2];f[j+8>>2]=B;f[j+12>>2]=C;C=f[z>>2]|0;a:do switch(C|0){case 3:{if(((f[l>>2]|0)-D|0)==24){S=0;T=f[f[E+12>>2]>>2]|0;U=33;break a}else{z=$Xc(32)|0;f[k>>2]=z;f[k+8>>2]=-2147483616;f[k+4>>2]=18;p=z;q=455503;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[z+18>>0]=0;vM(-215,k,456079,443386,946)}break}case 4:{if(((f[l>>2]|0)-D|0)!=24){L=$Xc(32)|0;f[k>>2]=L;f[k+8>>2]=-2147483616;f[k+4>>2]=18;p=L;q=455503;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[L+18>>0]=0;vM(-215,k,456079,443386,951)}z=f[a+120>>2]|0;if((Y(Y(f[a+108>>2]|0,z)|0,f[a+112>>2]|0)|0)==(f[n>>2]|0)){f[j>>2]=f[f[E+12>>2]>>2];S=1;T=z;U=33;break a}else{z=$Xc(80)|0;f[k>>2]=z;f[k+8>>2]=-2147483568;f[k+4>>2]=71;p=z;q=443667;r=p+71|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[z+71>>0]=0;vM(-215,k,456079,443386,952)}break}default:{}}while(0);if((U|0)==33)f[j+(S<<2)>>2]=T;T=(d|0)==0?((C|0)==0?2:1):d;switch(T|0){case 1:break;case 2:{U=35;break}default:{V=$Xc(64)|0;f[k>>2]=V;W=k+8|0;f[W>>2]=-2147483584;Z=k+4|0;f[Z>>2]=51;p=V;q=443739;r=p+51|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));_=V+51|0;b[_>>0]=0;vM(-215,k,456079,443386,958)}}if((U|0)==35?C|0:0){V=$Xc(64)|0;f[k>>2]=V;W=k+8|0;f[W>>2]=-2147483584;Z=k+4|0;f[Z>>2]=51;p=V;q=443739;r=p+51|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));_=V+51|0;b[_>>0]=0;vM(-215,k,456079,443386,958)}f[k>>2]=0;_=k+4|0;f[_>>2]=0;f[k+8>>2]=0;gOa(k,j,j+16|0);eOa(e,T,k);T=f[k>>2]|0;if(!T){u=g;return 0}k=f[_>>2]|0;if((k|0)!=(T|0))f[_>>2]=k+(~((k+-4-T|0)>>>2)<<2);cYc(T);u=g;return 0}function kAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=u;u=u+16|0;e=c;g=f[d+4>>2]|0;h=f[d>>2]|0;d=h;if((g|0)==(h|0)){i=0;j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}l=a+48|0;m=a+52|0;n=(g-h|0)/12|0;if(f[a+44>>2]|0){a=0;h=0;while(1){g=f[d+(h*12|0)+4>>2]|0;o=f[d+(h*12|0)>>2]|0;p=g-o|0;q=p>>2;r=o;if((r|0)!=(g|0)){if((p|0)<=-4){s=15;break}if((p|0)>0){p=0;g=1;while(1){o=Y(f[r+(p<<2)>>2]|0,g)|0;p=p+1|0;if((p|0)>=(q|0)){t=o;break}else g=o}}else t=1}else t=0;g=(Y((Y(f[m>>2]|0,f[l>>2]|0)|0)+1|0,t)|0)+a|0;h=h+1|0;if(h>>>0>=n>>>0){i=g;s=10;break}else a=g}if((s|0)==10){j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}else if((s|0)==15){a=$Xc(80)|0;f[e>>2]=a;f[e+8>>2]=-2147483568;f[e+4>>2]=70;v=a;w=454543;x=v+70|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[a+70>>0]=0;vM(-215,e,454614,454620,161)}}else{y=0;z=0}while(1){if(!(z&1)){a=f[d+(z*12|0)+4>>2]|0;h=f[d+(z*12|0)>>2]|0;t=a-h|0;g=t>>2;q=h;if((q|0)!=(a|0)){if((t|0)<=-4){s=12;break}if((t|0)>0){t=0;a=1;while(1){h=Y(f[q+(t<<2)>>2]|0,a)|0;t=t+1|0;if((t|0)>=(g|0)){A=h;break}else a=h}}else A=1}else A=0;B=(Y(Y(f[l>>2]|0,A)|0,f[m>>2]|0)|0)+y|0}else B=y;z=z+1|0;if(z>>>0>=n>>>0){i=B;s=10;break}else y=B}if((s|0)==10){j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}else if((s|0)==12){s=$Xc(80)|0;f[e>>2]=s;f[e+8>>2]=-2147483568;f[e+4>>2]=70;v=s;w=454543;x=v+70|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[s+70>>0]=0;vM(-215,e,454614,454620,161)}return 0}function lAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function mAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function nAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+80|0;h=g+16|0;i=g+8|0;j=g;k=i3()|0;f[h>>2]=1124007936;l=h+4|0;m=h+8|0;o=h+40|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+48>>2];f[i+4>>2]=f[a+52>>2];f[j>>2]=f[a+56>>2];f[j+4>>2]=f[a+60>>2];qAb(c,h,d,e,i,j,f[a+64>>2]|0,f[a+68>>2]|0,f[a+72>>2]|0,f[a+76>>2]|0,(b[a+105>>0]|0)!=0,f[a+44>>2]|0,+n[a+116>>2],(b[a+89>>0]|0)!=0,k);k=h+36|0;a=f[k>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)V$(h);f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[o>>2]|0;o=0;do{f[k+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[p>>2]|0;if((l|0)==(m|0)){u=g;return}wL(l);u=g;return}function oAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e+8|0;j=e;k=i3()|0;f[g>>2]=1124007936;l=g+4|0;m=g+8|0;o=g+40|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;m=g+48|0;r=g+44|0;f[r>>2]=m;f[m>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;s=h+4|0;t=h+8|0;v=h+40|0;p=s;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[v>>2]=t;t=h+48|0;p=h+44|0;f[p>>2]=t;f[t>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+48>>2];f[i+4>>2]=f[a+52>>2];f[j>>2]=f[a+56>>2];f[j+4>>2]=f[a+60>>2];qAb(c,g,d,h,i,j,f[a+64>>2]|0,f[a+68>>2]|0,f[a+72>>2]|0,f[a+76>>2]|0,(b[a+105>>0]|0)!=0,f[a+44>>2]|0,+n[a+116>>2],(b[a+89>>0]|0)!=0,k);k=h+36|0;a=f[k>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)V$(h);f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[v>>2]|0;v=0;do{f[k+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[p>>2]|0;if((s|0)!=(t|0))wL(s);s=g+36|0;t=f[s>>2]|0;if(t|0?(p=t+12|0,t=f[p>>2]|0,f[p>>2]=t+-1,(t|0)==1):0)V$(g);f[s>>2]=0;s=g+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[l>>2]|0)>0){s=f[o>>2]|0;o=0;do{f[s+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)==(m|0)){u=e;return}wL(l);u=e;return}function pAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+80|0;h=g+16|0;i=g+8|0;j=g;k=i3()|0;f[h>>2]=1124007936;l=h+4|0;m=h+8|0;o=h+40|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+48>>2];f[i+4>>2]=f[a+52>>2];f[j>>2]=f[a+56>>2];f[j+4>>2]=f[a+60>>2];qAb(c,d,e,h,i,j,f[a+64>>2]|0,f[a+68>>2]|0,f[a+72>>2]|0,f[a+76>>2]|0,(b[a+105>>0]|0)!=0,f[a+44>>2]|0,+n[a+116>>2],(b[a+89>>0]|0)!=0,k);k=h+36|0;a=f[k>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)V$(h);f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[o>>2]|0;o=0;do{f[k+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[p>>2]|0;if((l|0)==(m|0)){u=g;return}wL(l);u=g;return}function qAb(a,c,d,e,g,h,i,j,k,l,m,o,p,q,r){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;p=+p;q=q|0;r=r|0;var s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;s=u;u=u+96|0;t=s+8|0;v=s;w=m&1;m=q&1;x=f[a>>2]|0;if(!(x&16384)){y=$Xc(32)|0;f[t>>2]=y;f[t+8>>2]=-2147483616;f[t+4>>2]=18;z=y;A=443845;B=z+18|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+18>>0]=0;vM(-215,t,452230,443386,389)}y=f[d>>2]|0;if(!(y&16384)){C=$Xc(32)|0;f[t>>2]=C;f[t+8>>2]=-2147483616;f[t+4>>2]=18;z=C;A=443864;B=z+18|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[C+18>>0]=0;vM(-215,t,452230,443386,389)}if((x&4095|0)!=5){C=$Xc(16)|0;f[t>>2]=C;f[t+8>>2]=-2147483632;f[t+4>>2]=15;z=C;A=443883;B=z+15|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[C+15>>0]=0;vM(-215,t,452230,443386,389)}if((y&4095|0)!=5){y=$Xc(32)|0;f[t>>2]=y;f[t+8>>2]=-2147483616;f[t+4>>2]=24;z=y;A=443899;B=z+24|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+24>>0]=0;vM(-215,t,452230,443386,389)}if((f[a+4>>2]|0)!=4){y=$Xc(16)|0;f[t>>2]=y;f[t+8>>2]=-2147483632;f[t+4>>2]=13;z=y;A=443924;B=z+13|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+13>>0]=0;vM(-215,t,452230,443386,389)}if((f[d+4>>2]|0)!=4){y=$Xc(16)|0;f[t>>2]=y;f[t+8>>2]=-2147483632;f[t+4>>2]=13;z=y;A=443938;B=z+13|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+13>>0]=0;vM(-215,t,452230,443386,389)}y=(o|0)==4;C=f[d+40>>2]|0;D=f[C>>2]|0;if(!((o+-3|0)>>>0<2?(D|0)==(f[f[c+40>>2]>>2]|0):0))E=15;if((E|0)==15?(f[f[a+40>>2]>>2]|0)!=(D|0):0){E=$Xc(112)|0;f[t>>2]=E;f[t+8>>2]=-2147483536;f[t+4>>2]=109;z=E;A=443952;B=z+109|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[E+109>>0]=0;vM(-215,t,452230,443386,389)}if(!y?(f[(f[a+40>>2]|0)+4>>2]|0)!=(f[C+4>>2]|0):0){y=$Xc(64)|0;f[t>>2]=y;f[t+8>>2]=-2147483584;f[t+4>>2]=50;z=y;A=444062;B=z+50|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+50>>0]=0;vM(-215,t,452230,443386,389)}a:do if(f[e+16>>2]|0){y=f[e+4>>2]|0;if((y|0)<3)F=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{E=f[e+40>>2]|0;G=0;H=1;while(1){I=Y(f[E+(G<<2)>>2]|0,H)|0;G=G+1|0;if((G|0)==(y|0)){F=I;break}else H=I}}if(!((y|0)==0|(F|0)==0)){do if(((x^f[e>>2])&4095|0)==0?(H=f[e+40>>2]|0,G=f[H+-4>>2]|0,(G|0)==(f[C+-4>>2]|0)):0){if((G|0)==2){if((f[H>>2]|0)!=(D|0))break;if((f[H+4>>2]|0)==(f[C+4>>2]|0))break a;else break}if((G|0)<=0)break a;if((f[H>>2]|0)==(D|0)){E=1;while(1){if((E|0)>=(G|0))break a;if((f[H+(E<<2)>>2]|0)==(f[C+(E<<2)>>2]|0))E=E+1|0;else break}}}while(0);y=$Xc(80)|0;f[t>>2]=y;f[t+8>>2]=-2147483568;f[t+4>>2]=70;z=y;A=444113;B=z+70|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+70>>0]=0;vM(-215,t,452230,443386,389)}}while(0);f[t>>2]=106288;A=t+64|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[t+4>>2]=a;f[t+8>>2]=c;f[t+12>>2]=d;f[t+16>>2]=e;e=f[g>>2]|0;f[t+20>>2]=e;d=g+4|0;c=f[d>>2]|0;f[t+24>>2]=c;f[t+28>>2]=f[h>>2];f[t+32>>2]=f[h+4>>2];f[t+36>>2]=i;f[t+40>>2]=j;f[t+44>>2]=k;f[t+48>>2]=l;b[t+52>>0]=w;f[t+56>>2]=r;b[t+60>>0]=m;f[t+76>>2]=o;n[t+80>>2]=p;if(!q){q=t+64|0;o=Y(c,e)|0;if(!o)J=c;else{CS(q,o);J=f[d>>2]|0}if((J|0)>0){o=(f[a+40>>2]|0)+12|0;a=f[q>>2]|0;q=0;c=f[g>>2]|0;e=J;while(1){if((c|0)>0){J=0;m=c;do{w=(Y(f[o>>2]|0,q)|0)+J|0;l=a+((Y(m,q)|0)+J<<2)|0;f[l>>2]=w;J=J+1|0;m=f[g>>2]|0}while((J|0)<(m|0));K=f[d>>2]|0;L=m}else{K=e;L=c}q=q+1|0;if((q|0)>=(K|0))break;else{c=L;e=K}}}}f[v>>2]=0;f[v+4>>2]=r;h3(v,t,+(r|0));f[t>>2]=106288;r=f[A>>2]|0;if(!r){u=s;return}A=t+68|0;t=f[A>>2]|0;if((t|0)!=(r|0))f[A>>2]=t+(~((t+-4-r|0)>>>2)<<2);cYc(r);u=s;return}function rAb(a){a=a|0;var b=0,c=0;f[a>>2]=106288;b=f[a+64>>2]|0;if(!b)return;c=a+68|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function sAb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=106288;b=f[a+64>>2]|0;if(!b){cYc(a);return}c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function tAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0,J=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;d=u;u=u+16|0;e=d;g=a+12|0;h=f[g>>2]|0;i=f[h+40>>2]|0;j=f[i+4>>2]|0;k=f[i+12>>2]|0;l=f[i+8>>2]|0;m=a+4|0;o=f[(f[m>>2]|0)+40>>2]|0;p=f[o+12>>2]|0;q=f[o+8>>2]|0;o=f[h+4>>2]|0;if((o|0)<3)r=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{h=0;t=1;while(1){v=Y(f[i+(h<<2)>>2]|0,t)|0;h=h+1|0;if((h|0)==(o|0)){r=v;break}else t=v}}t=f[a+56>>2]|0;o=((r+-1+t|0)>>>0)/(t>>>0)|0;t=Y(f[c>>2]|0,o)|0;h=Y(f[c+4>>2]|0,o)|0;o=r>>>0<h>>>0?r:h;h=f[a+20>>2]|0;r=f[a+24>>2]|0;c=f[a+28>>2]|0;i=f[a+32>>2]|0;v=(b[a+60>>0]|0)!=0;if(o>>>0<=t>>>0){u=d;return}w=a+76|0;x=f[w>>2]|0;y=a+40|0;z=a+48|0;A=a+16|0;B=a+8|0;C=a+80|0;D=+(k|0);E=a+36|0;F=a+44|0;G=a+52|0;H=+(l|0);a=t;a:while(1){t=(a>>>0)%(k>>>0)|0;I=(a>>>0)/(k>>>0)|0;J=(I>>>0)%(l>>>0)|0;L=(I>>>0)/(l>>>0)|0;I=(L>>>0)%(j>>>0)|0;M=(L>>>0)/(j>>>0)|0;switch(x|0){case 3:{L=f[B>>2]|0;N=(f[L+16>>2]|0)+(Y(f[f[L+44>>2]>>2]|0,M)|0)|0;O=+n[C>>2];P=+n[N+8>>2]*O;L=~~(P+(P>=0.0?.5:-.5));P=O*+n[N+16>>2];Q=~~(P+(P>=0.0?.5:-.5))-L+1|0;P=+(((Q|0)>1?Q:1)|0)/H;O=+(L|0);R=+n[N>>2];N=f[m>>2]|0;if(!(R<+(f[f[N+40>>2]>>2]|0))){S=10;break a}L=~~(O+ +X(+(+(J+1|0)*P)));Q=f[N+44>>2]|0;T=(f[N+16>>2]|0)+(Y(f[Q>>2]|0,~~R)|0)+(Y(f[Q+4>>2]|0,I)|0)|0;U=~~(O+ +(J|0)*P);V=L;break}case 4:{L=f[B>>2]|0;Q=(f[L+16>>2]|0)+(Y(f[f[L+44>>2]>>2]|0,M)|0)|0;P=+n[Q+8>>2];O=+n[C>>2];R=O*+(~~(P+(P>=0.0?.5:-.5))|0);P=+n[Q+16>>2]+1.0;W=O*+(~~(P+(P>=0.0?.5:-.5))|0)-R;P=(W<.10000000149011612?.10000000149011612:W)/H;T=0;U=~~+K(+(R+ +(J|0)*P));V=~~+X(+(R+ +(J+1|0)*P));break}default:{Q=(Y(J,i)|0)-(f[y>>2]|0)|0;L=Q+r|0;N=(f[z>>2]|0)+q|0;Z=f[m>>2]|0;_=f[Z+44>>2]|0;T=(f[Z+16>>2]|0)+(Y(f[_>>2]|0,M)|0)+(Y(f[_+4>>2]|0,I)|0)|0;U=Q;V=(N|0)<(L|0)?N:L}}L=V-U|0;N=(U|0)>0?U:0;Q=(q|0)<(V|0)?q:V;_=f[g>>2]|0;Z=f[_+16>>2]|0;$=f[_+44>>2]|0;_=Y(f[$>>2]|0,M)|0;aa=Y(f[$+4>>2]|0,I)|0;ba=Y(f[$+8>>2]|0,J)|0;$=Z+_+aa+ba|0;ca=f[A>>2]|0;da=f[ca+16>>2]|0;if(!da)ea=0;else{fa=f[ca+44>>2]|0;ca=da+(Y(f[fa>>2]|0,M)|0)|0;da=ca+(Y(f[fa+4>>2]|0,I)|0)|0;ea=da+(Y(f[fa+8>>2]|0,J)|0)|0}fa=o-a|0;da=k-t|0;ca=(da|0)<(fa|0)?da:fa;a=ca+a|0;fa=ca+t|0;da=f[w>>2]|0;b:do switch(da|0){case 0:{if((ca|0)>0){ga=f[E>>2]|0;ha=(Q|0)>(N|0);ia=(ea|0)==0;ja=v&(ea|0)!=0;ka=t;do{la=(Y(ka,c)|0)-ga|0;ma=la+h|0;na=(p|0)<(ma|0)?p:ma;ma=(la|0)>0?la:0;do if(ha&(ma|0)<(na|0)){if(v){oa=-1;pa=N;qa=-3402823466385288598117041.0e14}else{la=N;P=-3402823466385288598117041.0e14;ra=-8388609;while(1){sa=Y(la,p)|0;ta=ma;R=P;ua=ra;do{va=f[T+(ta+sa<<2)>>2]|0;ua=R<(f[s>>2]=va,+n[s>>2])?va:ua;ta=ta+1|0;R=(f[s>>2]=ua,+n[s>>2])}while((ta|0)<(na|0));la=la+1|0;if((la|0)>=(Q|0))break;else{P=R;ra=ua}}f[$+(ka<<2)>>2]=ua;break}while(1){ra=Y(pa,p)|0;la=ma;wa=oa;xa=qa;do{ta=la+ra|0;P=+n[T+(ta<<2)>>2];sa=P>xa;xa=sa?P:xa;wa=sa?ta:wa;la=la+1|0}while((la|0)<(na|0));pa=pa+1|0;if((pa|0)>=(Q|0))break;else{oa=wa;qa=xa}}n[$+(ka<<2)>>2]=xa;if(!ia)n[ea+(ka<<2)>>2]=+(wa|0)}else{n[$+(ka<<2)>>2]=0.0;if(ja)n[ea+(ka<<2)>>2]=-1.0}while(0);ka=ka+1|0}while((ka|0)<(fa|0))}break}case 1:{if((ca|0)>0){ka=f[E>>2]|0;ja=(f[F>>2]|0)+p|0;ia=(b[G>>0]|0)==0;ha=Q-N|0;if((Q|0)>(N|0))ya=t;else{ga=t;while(1){na=(Y(ga,c)|0)-ka|0;ma=na+h|0;la=(ja|0)<(ma|0)?ja:ma;R=1.0/+(Y(ia?((p|0)<(la|0)?p:la)-((na|0)>0?na:0)|0:L,ia?ha:la-na|0)|0)*0.0;n[$+(ga<<2)>>2]=R;ga=ga+1|0;if((ga|0)>=(fa|0))break b}}do{ga=(Y(ya,c)|0)-ka|0;na=ga+h|0;la=(ja|0)<(na|0)?ja:na;na=(ga|0)>0?ga:0;ma=(p|0)<(la|0)?p:la;R=1.0/+(Y(ia?ma-na|0:L,ia?ha:la-ga|0)|0);if((ma|0)>(na|0)){P=0.0;ga=N;while(1){la=Y(ga,p)|0;ra=na;W=P;do{W=W+ +n[T+(ra+la<<2)>>2];ra=ra+1|0}while((ra|0)<(ma|0));ga=ga+1|0;if((ga|0)>=(Q|0)){za=W;break}else P=W}}else za=0.0;n[$+(ya<<2)>>2]=R*za;ya=ya+1|0}while((ya|0)<(fa|0))}break}default:{ha=f[B>>2]|0;ia=(f[ha+16>>2]|0)+(Y(f[f[ha+44>>2]>>2]|0,M)|0)|0;if((da|0)!=3){ha=f[m>>2]|0;if(!(+n[ia>>2]<+(f[f[ha+40>>2]>>2]|0))){S=56;break a}P=+n[ia+4>>2];O=+n[C>>2];Aa=O*+(~~(P+(P>=0.0?.5:-.5))|0);P=+n[ia+12>>2]+1.0;Ba=O*+(~~(P+(P>=0.0?.5:-.5))|0)-Aa;P=(Ba<.10000000149011612?.10000000149011612:Ba)/D;if((ca|0)<=0)break b;ja=Y((Y(I,l)|0)+J|0,k)|0;ka=Q-N|0;if((Q|0)<=(N|0)){ga=t<<2;ma=t+1|0;g1c(Z+(ba+aa+_+ga)|0,0,(((fa|0)>(ma|0)?fa:ma)<<2)-ga|0)|0;break b}ga=ha+16|0;ma=ha+44|0;ha=t;while(1){na=~~+K(+(Aa+P*+(ha|0)));ra=ha;ha=ha+1|0;la=~~+X(+(Aa+P*+(ha|0)));ta=(na|0)>0?na:0;na=(p|0)<(la|0)?p:la;if((na|0)>(ta|0)){la=f[ma>>2]|0;sa=(f[ga>>2]|0)+(Y(f[la>>2]|0,~~+n[ia>>2])|0)|0;va=sa+(Y(f[la+4>>2]|0,ra+ja|0)|0)|0;la=N;Ba=0.0;while(1){sa=Y(la,p)|0;Ca=ta;Da=Ba;do{Da=Da+ +n[va+(Ca+sa<<2)>>2];Ca=Ca+1|0}while((Ca|0)<(na|0));la=la+1|0;if((la|0)>=(Q|0))break;else Ba=Da}Ea=Da/+(Y(na-ta|0,ka)|0)}else Ea=0.0;n[$+(ra<<2)>>2]=Ea;if((ha|0)>=(fa|0))break b}}P=+n[C>>2];Aa=+n[ia+4>>2]*P;ha=~~(Aa+(Aa>=0.0?.5:-.5));Aa=P*+n[ia+12>>2];ka=~~(Aa+(Aa>=0.0?.5:-.5))-ha+1|0;Aa=+(((ka|0)>1?ka:1)|0)/D;if((ca|0)>0){P=+(ha|0);ha=v&(ea|0)!=0;if((Q|0)>(N|0))Fa=t;else{ka=t;while(1){n[$+(ka<<2)>>2]=0.0;if(ha)n[ea+(ka<<2)>>2]=-1.0;ka=ka+1|0;if((ka|0)>=(fa|0))break b}}do{ka=~~(P+Aa*+(Fa|0));ia=Fa;Fa=Fa+1|0;ja=~~(P+ +X(+(Aa*+(Fa|0))));ga=(ka|0)>0?ka:0;ka=(p|0)<(ja|0)?p:ja;if((ga|0)>=(ka|0)){n[$+(ia<<2)>>2]=0.0;if(ha)n[ea+(ia<<2)>>2]=-1.0}else{ja=N;Ba=-3402823466385288598117041.0e14;ma=-8388609;while(1){la=Y(ja,p)|0;va=ga;R=Ba;Ga=ma;do{Ca=f[T+(va+la<<2)>>2]|0;Ga=R<(f[s>>2]=Ca,+n[s>>2])?Ca:Ga;va=va+1|0;R=(f[s>>2]=Ga,+n[s>>2])}while((va|0)<(ka|0));ja=ja+1|0;if((ja|0)>=(Q|0))break;else{Ba=R;ma=Ga}}f[$+(ia<<2)>>2]=Ga}}while((Fa|0)<(fa|0))}}}while(0);if(o>>>0<=a>>>0){S=7;break}}if((S|0)==7){u=d;return}else if((S|0)==10){d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=26;Ha=d;Ia=444184;Ja=Ha+26|0;do{b[Ha>>0]=b[Ia>>0]|0;Ha=Ha+1|0;Ia=Ia+1|0}while((Ha|0)<(Ja|0));b[d+26>>0]=0;vM(-215,e,528391,443386,464)}else if((S|0)==56){S=$Xc(32)|0;f[e>>2]=S;f[e+8>>2]=-2147483616;f[e+4>>2]=26;Ha=S;Ia=444184;Ja=Ha+26|0;do{b[Ha>>0]=b[Ia>>0]|0;Ha=Ha+1|0;Ia=Ia+1|0}while((Ha|0)<(Ja|0));b[S+26>>0]=0;vM(-215,e,528391,443386,727)}}function uAb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(264)|0;vAb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=106308;f[b+12>>2]=c;f[a+4>>2]=b;return}function vAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0.0,L=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=106336;g=a+52|0;f[g>>2]=1124007936;h=a+56|0;i=a+60|0;j=a+92|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;j=a+100|0;f[a+96>>2]=j;f[j>>2]=0;f[a+104>>2]=0;j=a+108|0;f[j>>2]=1124007936;m=a+112|0;o=a+116|0;p=a+148|0;k=m;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[p>>2]=o;p=a+156|0;f[a+152>>2]=p;f[p>>2]=0;f[a+160>>2]=0;f[a+164>>2]=1124007936;p=a+168|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[a+196>>2]=a+172;p=a+204|0;f[a+200>>2]=p;f[a+208>>2]=0;f[p>>2]=0;f[a+212>>2]=1124007936;p=a+216|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[a+244>>2]=a+220;p=a+252|0;f[a+248>>2]=p;f[a+256>>2]=0;f[p>>2]=0;rQa(a,c);p=a+4|0;q=a+8|0;if((((f[q>>2]|0)-(f[p>>2]|0)|0)/56|0)>>>0<=1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=$Xc(32)|0;f[e>>2]=r;f[e+8>>2]=-2147483616;f[e+4>>2]=17;k=r;s=444462;l=k+17|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));b[r+17>>0]=0;vM(-215,e,444480,444499,36)}r=e+11|0;b[r>>0]=10;k=e;s=444583;l=k+10|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));b[e+10>>0]=0;t=LGa(c,e)|0;v=c+4|0;if((t|0)==(v|0))w=0;else{x=MGa(t+28|0,-1)|0;w=(x|0)!=0|(J|0)!=0}x=a+44|0;b[x>>0]=w&1;if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=8;w=e;f[w>>2]=1601397096;f[w+4>>2]=1935763810;b[e+8>>0]=0;w=LGa(c,e)|0;if((w|0)==(v|0))y=0;else{t=MGa(w+28|0,-1)|0;y=(t|0)!=0|(J|0)!=0}t=a+45|0;b[t>>0]=y&1;if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=$Xc(32)|0;f[e>>2]=r;f[e+8>>2]=-2147483616;f[e+4>>2]=16;k=r;s=444594;l=k+16|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));b[r+16>>0]=0;r=LGa(c,e)|0;if((r|0)==(v|0))z=1;else{y=MGa(r+28|0,-1)|0;z=(y|0)!=0|(J|0)!=0}y=a+260|0;b[y>>0]=z&1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);z=e+11|0;b[z>>0]=10;k=e;s=444611;l=k+10|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));b[e+10>>0]=0;r=LGa(c,e)|0;if((r|0)==(v|0))A=0;else{w=MGa(r+28|0,-1)|0;A=(w|0)!=0|(J|0)!=0}if((b[z>>0]|0)<0)cYc(f[e>>2]|0);if(A){b[t>>0]=1;b[x>>0]=1}A=e+4|0;f[A>>2]=0;f[A+4>>2]=0;A=e+11|0;b[A>>0]=3;b[e>>0]=b[513188]|0;b[e+1>>0]=b[513189]|0;b[e+2>>0]=b[513190]|0;b[e+3>>0]=0;z=LGa(c,e)|0;if((z|0)==(v|0))B=9.999999747378752e-06;else B=+NGa(z+28|0,-1);z=a+48|0;n[z>>2]=B;if((b[A>>0]|0)<0)cYc(f[e>>2]|0);A=f[p>>2]|0;p=f[A+4>>2]|0;v=A;if((p|0)<3)C=Y(f[A+12>>2]|0,f[A+8>>2]|0)|0;else{c=f[A+40>>2]|0;w=0;r=1;while(1){D=Y(f[c+(w<<2)>>2]|0,r)|0;w=w+1|0;if((w|0)==(p|0)){C=D;break}else r=D}}r=f[A+60>>2]|0;if((r|0)<3)E=Y(f[A+68>>2]|0,f[A+64>>2]|0)|0;else{p=f[A+96>>2]|0;w=0;c=1;while(1){D=Y(f[p+(w<<2)>>2]|0,c)|0;w=w+1|0;if((w|0)==(r|0)){E=D;break}else c=D}}if((E|0)!=(C|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;F=$Xc(144)|0;f[e>>2]=F;G=e+8|0;f[G>>2]=-2147483504;H=e+4|0;f[H>>2]=133;o1c(F|0,444622,133)|0;I=F+133|0;b[I>>0]=0;vM(-215,e,444480,444499,48)}E=f[A>>2]|0;if(!(E&16384)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;F=$Xc(144)|0;f[e>>2]=F;G=e+8|0;f[G>>2]=-2147483504;H=e+4|0;f[H>>2]=133;o1c(F|0,444622,133)|0;I=F+133|0;b[I>>0]=0;vM(-215,e,444480,444499,48)}if(!((E&4095|0)==5?(f[A+56>>2]&20479|0)==16389:0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;F=$Xc(144)|0;f[e>>2]=F;G=e+8|0;f[G>>2]=-2147483504;H=e+4|0;f[H>>2]=133;o1c(F|0,444622,133)|0;I=F+133|0;b[I>>0]=0;vM(-215,e,444480,444499,48)}I=(b[x>>0]|0)==0;do if(I){F=b[t>>0]|0;H=(f[q>>2]|0)-v|0;G=(H|0)/56|0;if(F<<24>>24){E=G+-1|0;K=1.0;L=H;N=E-(F&255)|0;O=E;P=59;break}if(G>>>0<=2){Q=1.0;P=48;break}if(!(b[y>>0]|0)){Q=1.0;P=48;break}if((H|0)!=168){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;H=$Xc(32)|0;f[e>>2]=H;f[e+8>>2]=-2147483616;f[e+4>>2]=17;k=H;s=444756;l=k+17|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));b[H+17>>0]=0;vM(-215,e,444480,444499,52)}G=f[A+112>>2]&4095;if((G|0)!=5)kV(G,5,106444);B=+n[f[A+128>>2]>>2];if(!(B!=0.0)){Q=B;P=48;break}Q=1.0/B;P=48}else{Q=1.0;P=48}while(0);if((P|0)==48){y=b[t>>0]|0;G=(f[q>>2]|0)-v|0;v=(G|0)/56|0;q=v+-1|0;E=q-(y&255)|0;do if(!I){if(E>>>0>=v>>>0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;F=$Xc(48)|0;f[e>>2]=F;f[e+8>>2]=-2147483600;f[e+4>>2]=39;k=F;s=444774;l=k+39|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));b[F+39>>0]=0;vM(-215,e,444480,444499,63)}if((f[A+(E*56|0)>>2]&20479|0)!=16389){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(80)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483568;T=e+4|0;f[T>>2]=64;k=R;s=444814;l=k+64|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));U=R+64|0;b[U>>0]=0;vM(-215,e,444480,444499,65)}F=f[A+(E*56|0)+4>>2]|0;if((F|0)<3)V=Y(f[A+(E*56|0)+12>>2]|0,f[A+(E*56|0)+8>>2]|0)|0;else{H=f[A+(E*56|0)+40>>2]|0;c=0;r=1;while(1){w=Y(f[H+(c<<2)>>2]|0,r)|0;c=c+1|0;if((c|0)==(F|0)){V=w;break}else r=w}}if((V|0)==(C|0))break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;R=$Xc(80)|0;f[e>>2]=R;S=e+8|0;f[S>>2]=-2147483568;T=e+4|0;f[T>>2]=64;k=R;s=444814;l=k+64|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));U=R+64|0;b[U>>0]=0;vM(-215,e,444480,444499,65)}while(0);if(!(y<<24>>24)){W=Q;X=E;Z=q;_=1}else{K=Q;L=G;N=E;O=q;P=59}}do if((P|0)==59){if(!L){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(48)|0;f[e>>2]=q;f[e+8>>2]=-2147483600;f[e+4>>2]=36;k=q;s=444879;l=k+36|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));b[q+36>>0]=0;vM(-215,e,444480,444499,70)}if((f[A+(N*56|0)>>2]&20479|0)!=16389){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(80)|0;f[e>>2]=$;aa=e+8|0;f[aa>>2]=-2147483568;ba=e+4|0;f[ba>>2]=64;k=$;s=444916;l=k+64|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));ca=$+64|0;b[ca>>0]=0;vM(-215,e,444480,444499,72)}q=f[A+(N*56|0)+4>>2]|0;if((q|0)<3)da=Y(f[A+(N*56|0)+12>>2]|0,f[A+(N*56|0)+8>>2]|0)|0;else{E=f[A+(N*56|0)+40>>2]|0;G=0;y=1;while(1){U=Y(f[E+(G<<2)>>2]|0,y)|0;G=G+1|0;if((G|0)==(q|0)){da=U;break}else y=U}}if((da|0)==(C|0)){W=K;X=N;Z=O;_=0;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(80)|0;f[e>>2]=$;aa=e+8|0;f[aa>>2]=-2147483568;ba=e+4|0;f[ba>>2]=64;k=$;s=444916;l=k+64|0;do{b[k>>0]=b[s>>0]|0;k=k+1|0;s=s+1|0}while((k|0)<(l|0));ca=$+64|0;b[ca>>0]=0;vM(-215,e,444480,444499,72)}while(0);ca=f[A+16>>2]|0;$=f[A+72>>2]|0;if(I)ea=0;else ea=f[A+(X*56|0)+16>>2]|0;if(_)fa=0;else fa=f[A+(Z*56|0)+16>>2]|0;do if((f[h>>2]|0)<3){if((f[i>>2]|0)!=1){P=77;break}if((f[a+64>>2]|0)!=(C|0)){P=77;break}if((f[g>>2]&4095|0)!=5){P=77;break}if(!(f[a+68>>2]|0))P=77}else P=77;while(0);if((P|0)==77){f[e>>2]=1;f[e+4>>2]=C;S$(g,2,e,5)}do if((f[m>>2]|0)<3){if((f[o>>2]|0)!=1){P=84;break}if((f[a+120>>2]|0)!=(C|0)){P=84;break}if((f[j>>2]&4095|0)!=5){P=84;break}g=f[a+124>>2]|0;if(!g){P=84;break}ga=g}else P=84;while(0);if((P|0)==84){f[e>>2]=1;f[e+4>>2]=C;S$(j,2,e,5);ga=f[a+124>>2]|0}e=f[a+68>>2]|0;if(!C){u=d;return}a=(b[t>>0]|0)==0;if(b[x>>0]|0){x=0;do{K=+n[ea+(x<<2)>>2]/+M(+(W*+n[$+(x<<2)>>2]+ +n[z>>2]));n[e+(x<<2)>>2]=K;if(a)ha=0.0;else ha=+n[fa+(x<<2)>>2];n[ga+(x<<2)>>2]=ha-W*(K*+n[ca+(x<<2)>>2]);x=x+1|0}while((x|0)!=(C|0));u=d;return}if(a){a=0;do{ha=1.0/+M(+(W*+n[$+(a<<2)>>2]+ +n[z>>2]));n[e+(a<<2)>>2]=ha;n[ga+(a<<2)>>2]=0.0-W*(ha*+n[ca+(a<<2)>>2]);a=a+1|0}while((a|0)!=(C|0));u=d;return}else{a=0;do{ha=1.0/+M(+(W*+n[$+(a<<2)>>2]+ +n[z>>2]));n[e+(a<<2)>>2]=ha;n[ga+(a<<2)>>2]=+n[fa+(a<<2)>>2]-W*(ha*+n[ca+(a<<2)>>2]);a=a+1|0}while((a|0)!=(C|0));u=d;return}}function wAb(a){a=a|0;NXc(a);cYc(a);return}function xAb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function yAb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==444299?a+12|0:0)|0}function zAb(a){a=a|0;cYc(a);return}function AAb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=106336;EQ(a+212|0);EQ(a+164|0);b=a+108|0;c=a+144|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+124|0;b=a+112|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+148>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+152>>2]|0;if((b|0)!=(a+156|0))wL(b);b=a+52|0;d=a+88|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+68|0;b=a+56|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+92>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+96>>2]|0;if((b|0)==(a+100|0)){MNa(a);return}wL(b);MNa(a);return}function BAb(a){a=a|0;AAb(a);cYc(a);return}function CAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0;g=u;u=u+160|0;h=g+136|0;i=g+124|0;j=g+112|0;k=g+56|0;l=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;gS(c,i);gS(d,j);if((((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/56|0)>>>0<=1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(32)|0;f[h>>2]=d;f[h+8>>2]=-2147483616;f[h+4>>2]=17;o=d;p=444462;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+17>>0]=0;vM(-215,h,456135,444499,247)}d=f[i>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=56){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(32)|0;f[h>>2]=d;f[h+8>>2]=-2147483616;f[h+4>>2]=18;o=d;p=456060;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+18>>0]=0;vM(-215,h,456135,444499,248)}d=f[c+4>>2]|0;switch(d|0){case 4:case 2:break;default:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=$Xc(48)|0;f[h>>2]=e;f[h+8>>2]=-2147483600;f[h+4>>2]=38;o=e;p=445148;q=o+38|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[e+38>>0]=0;vM(-215,h,456135,444499,251)}}if((d|0)>2){d=f[c+40>>2]|0;r=f[d+8>>2]|0;s=f[d+12>>2]|0}else{r=1;s=1}d=f[j>>2]|0;a:do if((f[m>>2]|0)!=(d|0)){e=a+52|0;t=a+68|0;v=a+92|0;w=a+96|0;x=a+64|0;y=a+108|0;z=a+124|0;A=a+148|0;B=a+152|0;C=a+120|0;D=c+16|0;E=c+44|0;F=k+4|0;G=k+8|0;H=k+12|0;I=k+16|0;J=k+20|0;K=k+24|0;L=k+40|0;M=k+48|0;N=k+44|0;O=k+52|0;P=(Y(s,r)|0)!=0;Q=k+28|0;R=s<<2;S=Y(R,r)|0;T=0-R|0;U=l+4|0;V=l+8|0;W=l+12|0;X=l+16|0;Z=l+20|0;_=l+24|0;$=l+40|0;aa=l+48|0;ba=l+44|0;ca=l+52|0;da=l+28|0;ea=h+8|0;fa=h+4|0;ga=l+36|0;ha=k+36|0;ia=0;ja=d;b:while(1){ka=ja;la=ka+(ia*56|0)+40|0;ma=f[la>>2]|0;na=f[ma>>2]|0;if((na|0)>0){oa=ka+(ia*56|0)+16|0;pa=ka+(ia*56|0)+44|0;ka=0;qa=ma;ma=na;while(1){if((f[qa+4>>2]|0)>0){na=0;do{ra=f[t>>2]|0;do if((f[e>>2]&16384|0)==0?(sa=f[v>>2]|0,(f[sa>>2]|0)!=1):0){ta=f[f[w>>2]>>2]|0;if((f[sa+4>>2]|0)==1){ua=ra+(Y(ta,na)|0)|0;break}else{sa=f[x>>2]|0;va=(na|0)/(sa|0)|0;ua=ra+(Y(va,ta)|0)+(na-(Y(va,sa)|0)<<2)|0;break}}else wa=22;while(0);if((wa|0)==22){wa=0;ua=ra+(na<<2)|0}xa=+n[ua>>2];sa=f[z>>2]|0;do if((f[y>>2]&16384|0)==0?(va=f[A>>2]|0,(f[va>>2]|0)!=1):0){ta=f[f[B>>2]>>2]|0;if((f[va+4>>2]|0)==1){ya=sa+(Y(ta,na)|0)|0;break}else{va=f[C>>2]|0;za=(na|0)/(va|0)|0;ya=sa+(Y(za,ta)|0)+(na-(Y(za,va)|0)<<2)|0;break}}else wa=28;while(0);if((wa|0)==28){wa=0;ya=sa+(na<<2)|0}Aa=+n[ya>>2];ra=f[E>>2]|0;va=(f[D>>2]|0)+(Y(f[ra>>2]|0,ka)|0)|0;za=va+(Y(f[ra+4>>2]|0,na)|0)|0;f[k>>2]=1124007941;f[F>>2]=2;f[G>>2]=r;f[H>>2]=s;f[I>>2]=za;f[J>>2]=za;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[L>>2]=G;f[N>>2]=M;f[O>>2]=0;f[M>>2]=0;if(P&(za|0)==0){wa=33;break b}f[M>>2]=R;f[O>>2]=4;ra=za+S|0;f[Q>>2]=ra;f[K>>2]=ra+T+R;R$(k);ra=f[pa>>2]|0;za=(f[oa>>2]|0)+(Y(f[ra>>2]|0,ka)|0)|0;va=za+(Y(f[ra+4>>2]|0,na)|0)|0;f[l>>2]=1124007941;f[U>>2]=2;f[V>>2]=r;f[W>>2]=s;f[X>>2]=va;f[Z>>2]=va;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;f[$>>2]=V;f[ba>>2]=aa;f[ca>>2]=0;f[aa>>2]=0;if(P&(va|0)==0){wa=35;break b}f[aa>>2]=R;f[ca>>2]=4;ra=va+S|0;f[da>>2]=ra;f[_>>2]=ra+T+R;R$(l);ra=ea;f[ra>>2]=0;f[ra+4>>2]=0;f[h>>2]=33619968;f[fa>>2]=l;dY(k,h,5,xa,Aa);ra=f[ga>>2]|0;if(ra|0?(va=ra+12|0,ra=f[va>>2]|0,f[va>>2]=ra+-1,(ra|0)==1):0)V$(l);f[ga>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[U>>2]|0)>0){ra=f[$>>2]|0;va=0;do{f[ra+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[U>>2]|0))}va=f[ba>>2]|0;if((va|0)!=(aa|0))wL(va);va=f[ha>>2]|0;do if(va|0){ra=va+12|0;sa=f[ra>>2]|0;f[ra>>2]=sa+-1;if((sa|0)!=1)break;V$(k)}while(0);f[ha>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[F>>2]|0)>0){va=f[L>>2]|0;sa=0;do{f[va+(sa<<2)>>2]=0;sa=sa+1|0}while((sa|0)<(f[F>>2]|0))}sa=f[N>>2]|0;if((sa|0)!=(M|0))wL(sa);na=na+1|0;Ba=f[la>>2]|0}while((na|0)<(f[Ba+4>>2]|0));Ca=f[Ba>>2]|0;Da=Ba}else{Ca=ma;Da=qa}ka=ka+1|0;if((ka|0)>=(Ca|0))break;else{qa=Da;ma=Ca}}}ia=ia+1|0;ja=f[j>>2]|0;if(ia>>>0>=(((f[m>>2]|0)-ja|0)/56|0)>>>0)break a}if((wa|0)==33){ja=$Xc(32)|0;f[h>>2]=ja;f[h+8>>2]=-2147483616;f[h+4>>2]=28;o=ja;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[ja+28>>0]=0;vM(-215,h,470343,470347,548)}else if((wa|0)==35){ia=$Xc(32)|0;f[h>>2]=ia;f[h+8>>2]=-2147483616;f[h+4>>2]=28;o=ia;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[ia+28>>0]=0;vM(-215,h,470343,470347,548)}}while(0);hx(j);hx(i);u=g;return}function DAb(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 3:{c=1;break}case 1:{if(zQa()|0)c=1;else d=4;break}case 2:{c=orb()|0;break}default:d=4}if((d|0)==4)c=0;return c|0}function EAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function FAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function GAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function HAb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;c=u;u=u+256|0;d=c+200|0;e=c+144|0;g=c+88|0;h=c+72|0;i=c;j=c+56|0;f[d>>2]=1124007936;k=d+4|0;l=d+8|0;m=d+40|0;o=k;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[m>>2]=l;r=d+48|0;s=d+44|0;f[s>>2]=r;f[r>>2]=0;f[d+52>>2]=0;f[e>>2]=1124007936;t=e+4|0;v=e+8|0;w=e+40|0;o=t;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[w>>2]=v;o=e+48|0;q=e+44|0;f[q>>2]=o;f[o>>2]=0;f[e+52>>2]=0;x=f[b>>2]|0;Ti[f[(f[x>>2]|0)+88>>2]&511](x,d,e);x=d+16|0;b=(f[x>>2]|0)==0;if(!b){y=f[k>>2]|0;if((y|0)<3)z=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{A=f[m>>2]|0;B=0;C=1;while(1){D=Y(f[A+(B<<2)>>2]|0,C)|0;B=B+1|0;if((B|0)==(y|0)){z=D;break}else C=D}}if(!((y|0)==0|(z|0)==0))E=13;else E=7}else E=7;if((E|0)==7)if(f[e+16>>2]|0){z=f[t>>2]|0;if((z|0)<3)F=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{y=f[w>>2]|0;C=0;B=1;while(1){A=Y(f[y+(C<<2)>>2]|0,B)|0;C=C+1|0;if((C|0)==(z|0)){F=A;break}else B=A}}if(!((z|0)==0|(F|0)==0))E=13;else G=0}else G=0;do if((E|0)==13){F=a+52|0;z=f[a+56>>2]|0;if((z|0)<3)H=Y(f[a+64>>2]|0,f[a+60>>2]|0)|0;else{B=f[a+92>>2]|0;C=0;y=1;while(1){A=Y(f[B+(C<<2)>>2]|0,y)|0;C=C+1|0;if((C|0)==(z|0)){H=A;break}else y=A}}y=f[k>>2]|0;z=(y|0)<3;if(z)I=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{C=f[m>>2]|0;B=0;A=1;while(1){D=Y(f[C+(B<<2)>>2]|0,A)|0;B=B+1|0;if((B|0)==(y|0)){I=D;break}else A=D}}A=f[t>>2]|0;B=(A|0)<3;if(B)J=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{C=f[w>>2]|0;D=0;K=1;while(1){L=Y(f[C+(D<<2)>>2]|0,K)|0;D=D+1|0;if((D|0)==(A|0)){J=L;break}else K=L}}K=(I|0)==1;if(!(K|(I|0)==(H|0)|b)){if(z)M=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{D=f[m>>2]|0;C=0;L=1;while(1){N=Y(f[D+(C<<2)>>2]|0,L)|0;C=C+1|0;if((C|0)==(y|0)){M=N;break}else L=N}}if(!((y|0)==0|(M|0)==0)){G=0;break}}if((J|0)!=(H|0)&(J|0)!=1?f[e+16>>2]|0:0){if(B)O=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{L=f[w>>2]|0;C=0;D=1;while(1){N=Y(f[L+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(A|0)){O=N;break}else D=N}}if(!((A|0)==0|(O|0)==0)){G=0;break}}do if(!b){if(z)P=Y(f[d+12>>2]|0,f[l>>2]|0)|0;else{D=f[m>>2]|0;C=0;L=1;while(1){B=Y(f[D+(C<<2)>>2]|0,L)|0;C=C+1|0;if((C|0)==(y|0)){P=B;break}else L=B}}if(!((y|0)==0|(P|0)==0)){g0(g,d,1,1);L=d+36|0;C=f[L>>2]|0;if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)V$(d);f[L>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){C=f[m>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[k>>2]|0))}f[d>>2]=f[g>>2];D=g+4|0;C=f[D>>2]|0;f[k>>2]=C;B=g+8|0;f[l>>2]=f[B>>2];f[d+12>>2]=f[g+12>>2];N=g+16|0;f[x>>2]=f[N>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];Q=g+36|0;f[L>>2]=f[Q>>2];R=d+44|0;S=f[R>>2]|0;if((S|0)==(r|0))T=C;else{wL(S);f[R>>2]=r;f[m>>2]=l;T=f[D>>2]|0}S=g+44|0;if((T|0)<3){C=f[S>>2]|0;f[r>>2]=f[C>>2];f[d+52>>2]=f[C+4>>2];U=C}else{f[R>>2]=f[S>>2];R=g+40|0;f[d+40>>2]=f[R>>2];C=g+48|0;f[S>>2]=C;f[R>>2]=B;U=C}f[g>>2]=1124007936;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[D+24>>2]=0;f[D+28>>2]=0;f[Q>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((U|0)!=(g+48|0))wL(U);if(K){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=F;p[i>>3]=+n[f[x>>2]>>2];f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;N=j+8|0;f[N>>2]=0;f[N+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=F;I1(g,h,j,1.0,-1);N=a+108|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=N;p[i>>3]=+n[f[x>>2]>>2];f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;Q=j+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=N;I1(g,h,j,1.0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=F;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;N=i+8|0;f[N>>2]=0;f[N+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=F;I1(g,h,i,1.0,-1);N=a+108|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=N;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=d;Q=i+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=N;I1(g,h,i,1.0,-1);break}}}while(0);F=e+16|0;if(f[F>>2]|0){K=f[t>>2]|0;if((K|0)<3)V=Y(f[e+12>>2]|0,f[v>>2]|0)|0;else{y=f[w>>2]|0;z=0;A=1;while(1){N=Y(f[y+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(K|0)){V=N;break}else A=N}}if(!((K|0)==0|(V|0)==0)){g0(g,e,1,1);A=e+36|0;z=f[A>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)V$(e);f[A>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[t>>2]|0)>0){z=f[w>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[t>>2]|0))}f[e>>2]=f[g>>2];y=g+4|0;z=f[y>>2]|0;f[t>>2]=z;K=g+8|0;f[v>>2]=f[K>>2];f[e+12>>2]=f[g+12>>2];N=g+16|0;f[F>>2]=f[N>>2];f[e+20>>2]=f[g+20>>2];f[e+24>>2]=f[g+24>>2];f[e+28>>2]=f[g+28>>2];f[e+32>>2]=f[g+32>>2];Q=g+36|0;f[A>>2]=f[Q>>2];D=e+44|0;C=f[D>>2]|0;if((C|0)==(o|0))W=z;else{wL(C);f[D>>2]=o;f[w>>2]=v;W=f[y>>2]|0}C=g+44|0;if((W|0)<3){z=f[C>>2]|0;f[o>>2]=f[z>>2];f[e+52>>2]=f[z+4>>2];X=z}else{f[D>>2]=f[C>>2];D=g+40|0;f[e+40>>2]=f[D>>2];z=g+48|0;f[C>>2]=z;f[D>>2]=K;X=z}f[g>>2]=1124007936;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[y+24>>2]=0;f[y+28>>2]=0;f[Q>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((X|0)!=(g+48|0))wL(X);if((J|0)==1){N=a+108|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=N;p[i>>3]=+n[f[F>>2]>>2];f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;Q=j+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=N;E1(g,h,j,fT()|0,-1);G=1;break}N=a+108|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=N;g0(i,e,1,1);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=i;Q=j+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=N;E1(g,h,j,fT()|0,-1);N=i+36|0;Q=f[N>>2]|0;if(Q|0?(y=Q+12|0,Q=f[y>>2]|0,f[y>>2]=Q+-1,(Q|0)==1):0)V$(i);f[N>>2]=0;N=i+16|0;Q=i+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Q>>2]|0)>0){N=f[i+40>>2]|0;y=0;do{f[N+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[Q>>2]|0))}Q=f[i+44>>2]|0;if((Q|0)!=(i+48|0))wL(Q);G=1}else G=1}else G=1}while(0);i=e+36|0;j=f[i>>2]|0;if(j|0?(h=j+12|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)V$(e);f[i>>2]=0;i=e+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[t>>2]|0)>0){i=f[w>>2]|0;w=0;do{f[i+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[q>>2]|0;if((t|0)!=(o|0))wL(t);t=d+36|0;o=f[t>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)V$(d);f[t>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){x=f[m>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[s>>2]|0;if((k|0)==(r|0)){u=c;return G|0}wL(k);u=c;return G|0}function IAb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+52|0;if((d|0)!=(b|0)){e=a+88|0;g=f[e>>2]|0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}h=b+36|0;g=f[h>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)V$(b);f[h>>2]=0;g=b+16|0;i=b+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){j=f[b+40>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;l=f[i>>2]|0}while((k|0)<(l|0));f[b>>2]=f[d>>2];if((l|0)<3)m=12;else m=14}else{f[b>>2]=f[d>>2];m=12}if((m|0)==12){l=f[a+56>>2]|0;if((l|0)<3){f[i>>2]=l;f[b+8>>2]=f[a+60>>2];f[b+12>>2]=f[a+64>>2];l=f[a+96>>2]|0;i=f[b+44>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2]}else m=14}if((m|0)==14)U$(b,d);f[g>>2]=f[a+68>>2];f[b+20>>2]=f[a+72>>2];f[b+24>>2]=f[a+76>>2];f[b+28>>2]=f[a+80>>2];f[b+32>>2]=f[a+84>>2];f[h>>2]=f[e>>2]}e=a+108|0;if((e|0)==(c|0))return;h=a+144|0;b=f[h>>2]|0;if(b|0){g=b+12|0;f[g>>2]=(f[g>>2]|0)+1}g=c+36|0;b=f[g>>2]|0;if(b|0?(d=b+12|0,b=f[d>>2]|0,f[d>>2]=b+-1,(b|0)==1):0)V$(c);f[g>>2]=0;b=c+16|0;d=c+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){l=f[c+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0;n=f[d>>2]|0}while((i|0)<(n|0));f[c>>2]=f[e>>2];if((n|0)<3)m=27;else m=29}else{f[c>>2]=f[e>>2];m=27}if((m|0)==27){n=f[a+112>>2]|0;if((n|0)<3){f[d>>2]=n;f[c+8>>2]=f[a+116>>2];f[c+12>>2]=f[a+120>>2];n=f[a+152>>2]|0;d=f[c+44>>2]|0;f[d>>2]=f[n>>2];f[d+4>>2]=f[n+4>>2]}else m=29}if((m|0)==29)U$(c,e);f[b>>2]=f[a+124>>2];f[c+20>>2]=f[a+128>>2];f[c+24>>2]=f[a+132>>2];f[c+28>>2]=f[a+136>>2];f[c+32>>2]=f[a+140>>2];f[g>>2]=f[h>>2];return}function JAb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;if((b[a+260>>0]|0)==0?(f[f[f[c>>2]>>2]>>2]|0)!=1:0){j=$Xc(64)|0;f[i>>2]=j;f[i+8>>2]=-2147483584;f[i+4>>2]=56;k=j;l=445091;m=k+56|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+56>>0]=0;vM(-213,i,456079,444499,146)}cOa(a,c,d,e,g)|0;u=h;return 1}function KAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;k=0;while(1){l=f[c+(g*12|0)+4>>2]|0;m=f[c+(g*12|0)>>2]|0;n=l-m|0;o=n>>2;p=m;if((p|0)!=(l|0)){if((n|0)<=-4){q=7;break}if((n|0)>0){n=0;l=1;while(1){m=Y(f[p+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)>=(o|0)){r=m;break}else l=m}}else r=1}else r=0;l=r*3|0;o=d1c(l|0,((l|0)<0)<<31>>31|0,e|0,k|0)|0;l=J;g=g+1|0;if(g>>>0>=j>>>0){h=l;i=o;q=3;break}else{e=o;k=l}}if((q|0)==3){J=h;u=d;return i|0}else if((q|0)==7){q=$Xc(80)|0;f[a>>2]=q;f[a+8>>2]=-2147483568;f[a+4>>2]=70;i=q;d=454543;h=i+70|0;do{b[i>>0]=b[d>>0]|0;i=i+1|0;d=d+1|0}while((i|0)<(h|0));b[q+70>>0]=0;vM(-215,a,454614,454620,161)}return 0}function LAb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;if((g|0)>=(h|0))return;i=f[a+68>>2]|0;j=a+96|0;k=a+64|0;l=(f[a+108>>2]&16384|0)==0;m=f[a+124>>2]|0;o=a+148|0;p=a+152|0;q=a+120|0;r=(d|0)>0;if(f[a+52>>2]&16384|0){s=c;t=g;u=b;while(1){v=+n[i+(t<<2)>>2];do if(l?(w=f[o>>2]|0,(f[w>>2]|0)!=1):0){x=f[f[p>>2]>>2]|0;if((f[w+4>>2]|0)==1){y=m+(Y(x,t)|0)|0;break}else{w=f[q>>2]|0;z=(t|0)/(w|0)|0;y=m+(Y(z,x)|0)+(t-(Y(z,w)|0)<<2)|0;break}}else A=21;while(0);if((A|0)==21){A=0;y=m+(t<<2)|0}B=+n[y>>2];if(r){w=0;do{n[s+(w<<2)>>2]=B+v*+n[u+(w<<2)>>2];w=w+1|0}while((w|0)!=(d|0))}t=t+1|0;if((t|0)==(h|0))break;else{s=s+(e<<2)|0;u=u+(e<<2)|0}}return}u=f[a+92>>2]|0;a=(f[u>>2]|0)==1;s=u+4|0;u=c;c=g;g=b;while(1){do if(!a){b=f[f[j>>2]>>2]|0;if((f[s>>2]|0)==1){C=i+(Y(b,c)|0)|0;break}else{t=f[k>>2]|0;y=(c|0)/(t|0)|0;C=i+(Y(y,b)|0)+(c-(Y(y,t)|0)<<2)|0;break}}else C=i+(c<<2)|0;while(0);v=+n[C>>2];do if(l?(t=f[o>>2]|0,(f[t>>2]|0)!=1):0){y=f[f[p>>2]>>2]|0;if((f[t+4>>2]|0)==1){D=m+(Y(y,c)|0)|0;break}else{t=f[q>>2]|0;b=(c|0)/(t|0)|0;D=m+(Y(b,y)|0)+(c-(Y(b,t)|0)<<2)|0;break}}else A=14;while(0);if((A|0)==14){A=0;D=m+(c<<2)|0}B=+n[D>>2];if(r){t=0;do{n[u+(t<<2)>>2]=B+v*+n[g+(t<<2)>>2];t=t+1|0}while((t|0)!=(d|0))}c=c+1|0;if((c|0)==(h|0))break;else{u=u+(e<<2)|0;g=g+(e<<2)|0}}return}function MAb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(64)|0;NAb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=106480;f[b+12>>2]=c;f[a+4>>2]=b;return}function NAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+32|0;e=d+16|0;g=d;qQa(a);f[a>>2]=106508;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=e+11|0;b[h>>0]=1;b[e>>0]=112;b[e+1>>0]=0;i=LGa(c,e)|0;j=c+4|0;if((i|0)==(j|0))k=2.0;else k=+NGa(i+28|0,-1);i=a+44|0;n[i>>2]=k;if((b[h>>0]|0)<0)cYc(f[e>>2]|0);h=e+4|0;f[h>>2]=0;f[h+4>>2]=0;h=e+11|0;b[h>>0]=3;b[e>>0]=b[513188]|0;b[e+1>>0]=b[513189]|0;b[e+2>>0]=b[513190]|0;b[e+3>>0]=0;l=LGa(c,e)|0;if((l|0)==(j|0))m=1.000000013351432e-10;else m=+NGa(l+28|0,-1);n[a+48>>2]=m;if((b[h>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=$Xc(16)|0;f[e>>2]=h;f[e+8>>2]=-2147483632;f[e+4>>2]=14;l=h;o=445430;p=l+14|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));b[h+14>>0]=0;h=LGa(c,e)|0;if((h|0)==(j|0))q=1;else{r=MGa(h+28|0,-1)|0;q=(r|0)!=0|(J|0)!=0}r=a+52|0;b[r>>0]=q&1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);q=e+11|0;b[q>>0]=10;l=e;o=445445;p=l+10|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));b[e+10>>0]=0;h=LGa(c,e)|0;if((h|0)==(j|0))s=1;else{t=MGa(h+28|0,-1)|0;s=t}t=a+56|0;f[t>>2]=s;if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=14;l=q;o=445430;p=l+14|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));b[q+14>>0]=0;if(!(HIa(c,e)|0))v=1;else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;q=g+11|0;b[q>>0]=8;s=g;f[s>>2]=1600417381;f[s+4>>2]=1936291937;b[g+8>>0]=0;s=(HIa(c,g)|0)==0;if((b[q>>0]|0)<0)cYc(f[g>>2]|0);v=s}if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(!v){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;v=$Xc(64)|0;f[e>>2]=v;f[e+8>>2]=-2147483584;f[e+4>>2]=56;l=v;o=445456;p=l+56|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));b[v+56>>0]=0;vM(-215,e,445513,445536,59)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;v=e+11|0;b[v>>0]=8;s=e;f[s>>2]=1600417381;f[s+4>>2]=1936291937;b[e+8>>0]=0;if(!(b[r>>0]|0))w=f[t>>2]|0;else w=-1;t=LGa(c,e)|0;if((t|0)==(j|0))x=w;else{w=MGa(t+28|0,-1)|0;x=w}f[a+60>>2]=x;if((b[v>>0]|0)<0)cYc(f[e>>2]|0);if(+n[i>>2]>0.0){u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=9;l=e;o=445624;p=l+9|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));b[e+9>>0]=0;vM(-215,e,445513,445536,61)}}function OAb(a){a=a|0;NXc(a);cYc(a);return}function PAb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function QAb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==445259?a+12|0:0)|0}function RAb(a){a=a|0;cYc(a);return}function SAb(a){a=a|0;MNa(a);cYc(a);return}function TAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d+12|0;g=d;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;gS(c,e);c=f[e>>2]|0;i=c;if(((f[h>>2]|0)-c|0)!=56){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=$Xc(32)|0;f[g>>2]=c;f[g+8>>2]=-2147483616;f[g+4>>2]=18;h=c;j=456060;k=h+18|0;do{b[h>>0]=b[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(k|0));b[c+18>>0]=0;vM(-215,g,455619,445536,96)}g=a+60|0;c=f[g>>2]|0;if((c|0)==-1)l=(f[i+4>>2]|0)+-1|0;else l=c;f[g>>2]=l;g=a+56|0;c=f[g>>2]|0;if((c|0)==-1)m=(f[i+4>>2]|0)+-1|0;else m=c;f[g>>2]=m;if((m|0)!=1){n=0;o=a+52|0;b[o>>0]=n;hx(e);u=d;return}n=(l|0)==((f[i+4>>2]|0)+-1|0)&1;o=a+52|0;b[o>>0]=n;hx(e);u=d;return}function UAb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0.0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0;g=u;u=u+528|0;h=g+512|0;i=g+80|0;j=g+64|0;k=g+496|0;l=g+484|0;m=g+472|0;o=g+416|0;q=g+360|0;r=g+32|0;s=g+304|0;t=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[k>>2]=0;v=k+4|0;f[v>>2]=0;f[k+8>>2]=0;f[l>>2]=0;w=l+4|0;f[w>>2]=0;f[l+8>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;gS(c,k);gS(d,l);gS(e,m);e=f[k>>2]|0;d=e;if(((f[v>>2]|0)-e|0)!=56){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(48)|0;f[h>>2]=x;y=h+8|0;f[y>>2]=-2147483600;z=h+4|0;f[z>>2]=41;A=x;B=445634;C=A+41|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+41|0;b[D>>0]=0;vM(-215,h,456135,445536,201)}e=f[l>>2]|0;v=e;if(((f[w>>2]|0)-e|0)!=56){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(48)|0;f[h>>2]=x;y=h+8|0;f[y>>2]=-2147483600;z=h+4|0;f[z>>2]=41;A=x;B=445634;C=A+41|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+41|0;b[D>>0]=0;vM(-215,h,456135,445536,201)}D=d+4|0;x=f[D>>2]|0;if((x|0)<3)E=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{z=f[d+40>>2]|0;y=0;e=1;while(1){w=Y(f[z+(y<<2)>>2]|0,e)|0;y=y+1|0;if((y|0)==(x|0)){E=w;break}else e=w}}e=f[v+4>>2]|0;if((e|0)<3)F=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{y=f[v+40>>2]|0;z=0;w=1;while(1){c=Y(f[y+(z<<2)>>2]|0,w)|0;z=z+1|0;if((z|0)==(e|0)){F=c;break}else w=c}}if((E|0)!=(F|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;F=$Xc(48)|0;f[h>>2]=F;f[h+8>>2]=-2147483600;f[h+4>>2]=39;A=F;B=445676;C=A+39|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[F+39>>0]=0;vM(-215,h,456135,445536,202)}F=f[m>>2]|0;E=a+56|0;w=f[E>>2]|0;f[E>>2]=((w|0)<0?x:0)+w;w=a+60|0;e=f[w>>2]|0;f[w>>2]=((e|0)<0?x:0)+e;e=f[d+16>>2]|0;x=f[v+16>>2]|0;v=d+40|0;z=f[v>>2]|0;y=f[z+-4>>2]|0;f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;gOa(i,z,z+(y<<2)|0);y=f[E>>2]|0;if((y|0)==-1){z=f[c>>2]|0;G=f[i>>2]|0;H=z-G>>2;I=G;J=z;K=G;L=z}else{z=f[i>>2]|0;G=f[c>>2]|0;H=y;I=z;J=G;K=z;L=G}if((I|0)!=(J|0)){G=L-K|0;if((G|0)<0|H>>>0>G>>>2>>>0){G=$Xc(80)|0;f[h>>2]=G;f[h+8>>2]=-2147483568;f[h+4>>2]=70;A=G;B=454543;C=A+70|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[G+70>>0]=0;vM(-215,h,454614,454620,161)}if((H|0)>0){G=1;K=0;while(1){L=Y(f[I+(K<<2)>>2]|0,G)|0;K=K+1|0;if((K|0)==(H|0)){M=L;break}else G=L}}else M=1}else M=0;if(I|0){if((J|0)!=(I|0))f[c>>2]=J+(~((J+-4-I|0)>>>2)<<2);cYc(I)}I=f[v>>2]|0;J=f[I+-4>>2]|0;f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;gOa(i,I,I+(J<<2)|0);J=f[E>>2]|0;E=(f[w>>2]|0)+1|0;w=(J|0)==-1?0:J;if((E|0)==-1){J=f[c>>2]|0;I=f[i>>2]|0;O=J-I>>2;P=I;Q=J;R=I;S=J}else{J=f[i>>2]|0;I=f[c>>2]|0;O=E;P=J;Q=I;R=J;S=I}if((P|0)!=(Q|0)){I=S-R>>2;if((w|0)>(I|0)){T=$Xc(80)|0;f[h>>2]=T;U=h+8|0;f[U>>2]=-2147483568;V=h+4|0;f[V>>2]=70;A=T;B=454543;C=A+70|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));W=T+70|0;b[W>>0]=0;vM(-215,h,454614,454620,161)}if((w|0)>(O|0)|(O|0)>(I|0)){T=$Xc(80)|0;f[h>>2]=T;U=h+8|0;f[U>>2]=-2147483568;V=h+4|0;f[V>>2]=70;A=T;B=454543;C=A+70|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));W=T+70|0;b[W>>0]=0;vM(-215,h,454614,454620,161)}if((w|0)<(O|0)){W=1;T=w;while(1){w=Y(f[P+(T<<2)>>2]|0,W)|0;T=T+1|0;if((T|0)==(O|0)){X=w;break}else W=w}}else X=1}else X=0;if(P|0){if((Q|0)!=(P|0))f[c>>2]=Q+(~((Q+-4-P|0)>>>2)<<2);cYc(P)}P=Y(X,M)|0;if(!P){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=$Xc(32)|0;f[h>>2]=Q;f[h+8>>2]=-2147483616;f[h+4>>2]=20;A=Q;B=445716;C=A+20|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[Q+20>>0]=0;vM(-215,h,456135,445536,214)}Q=f[D>>2]|0;if((Q|0)<3)Z=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{d=f[v>>2]|0;v=0;D=1;while(1){c=Y(f[d+(v<<2)>>2]|0,D)|0;v=v+1|0;if((v|0)==(Q|0)){Z=c;break}else D=c}}D=(Z>>>0)/(P>>>0)|0;a:do if(M|0){P=o+4|0;Z=o+8|0;Q=o+12|0;v=o+16|0;d=o+20|0;c=o+24|0;W=o+40|0;O=o+48|0;T=o+44|0;w=o+52|0;V=Y(D,X)|0;U=(V|0)!=0;I=o+28|0;R=D<<2;S=Y(R,X)|0;J=0-R|0;E=q+4|0;G=q+8|0;H=q+12|0;K=q+16|0;L=q+20|0;z=q+24|0;y=q+40|0;_=q+48|0;$=q+44|0;aa=q+52|0;ba=q+28|0;ca=h+8|0;da=h+12|0;ea=h+4|0;fa=a+44|0;ga=j+8|0;ha=j+4|0;ia=(D|0)==1;ja=h+8|0;ka=h+12|0;la=h+4|0;ma=a+48|0;na=h+8|0;oa=h+12|0;pa=h+4|0;qa=i+8|0;ra=i+12|0;sa=i+4|0;ta=s+8|0;ua=s+4|0;va=a+4|0;wa=a+8|0;xa=q+36|0;ya=o+36|0;za=i+4|0;Aa=i+8|0;Ba=i+12|0;Ca=i+16|0;Da=i+20|0;Ea=i+24|0;Fa=i+28|0;Ga=i+32|0;Ha=i+36|0;Ia=i+40|0;Ja=i+48|0;Ka=i+44|0;La=i+52|0;Ma=h+8|0;Na=h+4|0;Oa=h+8|0;Pa=h+12|0;Qa=h+4|0;Ra=j+8|0;Sa=j+4|0;Ta=h+8|0;Ua=h+12|0;Va=h+4|0;Wa=j+8|0;Xa=j+12|0;Ya=j+4|0;Za=s+8|0;_a=s+4|0;$a=s+4|0;ab=s+8|0;bb=s+40|0;cb=s+48|0;db=s+44|0;eb=s+52|0;fb=h+8|0;gb=h+12|0;hb=h+4|0;ib=i+8|0;jb=i+4|0;kb=t+8|0;lb=h+8|0;mb=h+12|0;nb=h+4|0;ob=i+8|0;pb=i+12|0;qb=i+4|0;rb=j+8|0;sb=j+4|0;tb=h+8|0;ub=h+12|0;vb=h+4|0;wb=i+8|0;xb=i+4|0;yb=h+8|0;zb=h+12|0;Ab=h+4|0;Bb=i+8|0;Cb=i+4|0;Db=h+8|0;Eb=h+12|0;Fb=h+4|0;Gb=i+8|0;Hb=i+12|0;Ib=i+4|0;Jb=j+8|0;Kb=j+4|0;Lb=s+36|0;Mb=s+16|0;Nb=0;Ob=e;Pb=x;while(1){f[o>>2]=1124007941;f[P>>2]=2;f[Z>>2]=X;f[Q>>2]=D;f[v>>2]=Ob;f[d>>2]=Ob;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[W>>2]=Z;f[T>>2]=O;f[w>>2]=0;f[O>>2]=0;if(U&(Ob|0)==0){Qb=51;break}f[O>>2]=R;f[w>>2]=4;Rb=Ob+S|0;f[I>>2]=Rb;f[c>>2]=Rb+J+R;R$(o);f[q>>2]=1124007941;f[E>>2]=2;f[G>>2]=X;f[H>>2]=D;f[K>>2]=Pb;f[L>>2]=Pb;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[y>>2]=G;f[$>>2]=_;f[aa>>2]=0;f[_>>2]=0;if(U&(Pb|0)==0){Qb=53;break}f[_>>2]=R;f[aa>>2]=4;Rb=Pb+S|0;f[ba>>2]=Rb;f[z>>2]=Rb+J+R;R$(q);j$(i,o);f[ca>>2]=0;f[da>>2]=0;f[h>>2]=-1056571392;f[ea>>2]=i;Sb=+n[fa>>2];Rb=ga;f[Rb>>2]=0;f[Rb+4>>2]=0;f[j>>2]=33619968;f[ha>>2]=F;QL(h,Sb,j);Zj(i);if(!ia){f[s>>2]=1124007936;A=$a;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[bb>>2]=ab;f[db>>2]=cb;f[cb>>2]=0;f[eb>>2]=0;f[fb>>2]=0;f[gb>>2]=0;f[h>>2]=16842752;f[hb>>2]=F;Rb=ib;f[Rb>>2]=0;f[Rb+4>>2]=0;f[i>>2]=33619968;f[jb>>2]=s;WV(h,i,0,0,-1);p[t>>3]=+n[ma>>2];f[kb>>2]=0;f[kb+4>>2]=0;f[kb+8>>2]=0;f[kb+12>>2]=0;f[kb+16>>2]=0;f[kb+20>>2]=0;f[lb>>2]=0;f[mb>>2]=0;f[h>>2]=16842752;f[nb>>2]=s;f[i>>2]=-1056833530;f[qb>>2]=t;f[ob>>2]=1;f[pb>>2]=4;Rb=rb;f[Rb>>2]=0;f[Rb+4>>2]=0;f[j>>2]=33619968;f[sb>>2]=s;E1(h,i,j,fT()|0,-1);f[tb>>2]=0;f[ub>>2]=0;f[h>>2]=16842752;f[vb>>2]=s;Sb=+n[fa>>2];Rb=wb;f[Rb>>2]=0;f[Rb+4>>2]=0;f[i>>2]=33619968;f[xb>>2]=s;QL(h,-1.0/Sb,i);f[yb>>2]=0;f[zb>>2]=0;f[h>>2]=16842752;f[Ab>>2]=s;Rb=Bb;f[Rb>>2]=0;f[Rb+4>>2]=0;f[i>>2]=33619968;f[Cb>>2]=F;pR(h,X,1,i);f[Db>>2]=0;f[Eb>>2]=0;f[h>>2]=16842752;f[Fb>>2]=o;f[Gb>>2]=0;f[Hb>>2]=0;f[i>>2]=16842752;f[Ib>>2]=F;Rb=Jb;f[Rb>>2]=0;f[Rb+4>>2]=0;f[j>>2]=33619968;f[Kb>>2]=q;I1(h,i,j,1.0,-1);Rb=f[Lb>>2]|0;do if(Rb|0){Tb=Rb+12|0;Ub=f[Tb>>2]|0;f[Tb>>2]=Ub+-1;if((Ub|0)!=1)break;V$(s)}while(0);f[Lb>>2]=0;f[Mb>>2]=0;f[Mb+4>>2]=0;f[Mb+8>>2]=0;f[Mb+12>>2]=0;if((f[$a>>2]|0)>0){Rb=f[bb>>2]|0;Ub=0;do{f[Rb+(Ub<<2)>>2]=0;Ub=Ub+1|0}while((Ub|0)<(f[$a>>2]|0))}Ub=f[db>>2]|0;if((Ub|0)!=(cb|0))wL(Ub)}else{f[ja>>2]=0;f[ka>>2]=0;f[h>>2]=16842752;f[la>>2]=F;iV(r,h);Sb=+N(+(+p[r>>3]+ +n[ma>>2]),+(1.0/+n[fa>>2]));f[na>>2]=0;f[oa>>2]=0;f[h>>2]=16842752;f[pa>>2]=o;p[j>>3]=1.0/Sb;f[i>>2]=-1056833530;f[sa>>2]=j;f[qa>>2]=1;f[ra>>2]=1;Ub=ta;f[Ub>>2]=0;f[Ub+4>>2]=0;f[s>>2]=33619968;f[ua>>2]=q;I1(h,i,s,1.0,-1)}Ub=f[va>>2]|0;if((Ub|0)!=(f[wa>>2]|0)){f[i>>2]=f[Ub>>2];Rb=Ub+4|0;f[za>>2]=f[Rb>>2];f[Aa>>2]=f[Ub+8>>2];f[Ba>>2]=f[Ub+12>>2];f[Ca>>2]=f[Ub+16>>2];f[Da>>2]=f[Ub+20>>2];f[Ea>>2]=f[Ub+24>>2];f[Fa>>2]=f[Ub+28>>2];f[Ga>>2]=f[Ub+32>>2];Tb=f[Ub+36>>2]|0;f[Ha>>2]=Tb;f[Ia>>2]=Aa;f[Ka>>2]=Ja;f[Ja>>2]=0;f[La>>2]=0;if(Tb|0){Vb=Tb+12|0;f[Vb>>2]=(f[Vb>>2]|0)+1}if((f[Rb>>2]|0)<3){Rb=f[Ub+44>>2]|0;Vb=f[Ka>>2]|0;f[Vb>>2]=f[Rb>>2];f[Vb+4>>2]=f[Rb+4>>2]}else{f[za>>2]=0;U$(i,Ub)}Ub=f[za>>2]|0;Rb=(Ub|0)<3;if(Rb)Wb=Y(f[Ba>>2]|0,f[Aa>>2]|0)|0;else{Vb=f[Ia>>2]|0;Tb=0;Xb=1;while(1){Yb=Y(f[Vb+(Tb<<2)>>2]|0,Xb)|0;Tb=Tb+1|0;if((Tb|0)==(Ub|0)){Wb=Yb;break}else Xb=Yb}}if((Wb|0)==1){Sb=+n[f[Ca>>2]>>2];Xb=Ma;f[Xb>>2]=0;f[Xb+4>>2]=0;f[h>>2]=33619968;f[Na>>2]=q;dY(q,h,-1,Sb,0.0)}else{if(Rb)Zb=Y(f[Ba>>2]|0,f[Aa>>2]|0)|0;else{Xb=f[Ia>>2]|0;Tb=0;Vb=1;while(1){Yb=Y(f[Xb+(Tb<<2)>>2]|0,Vb)|0;Tb=Tb+1|0;if((Tb|0)==(Ub|0)){Zb=Yb;break}else Vb=Yb}}if((Zb|0)!=(X|0)){Qb=82;break}f[Oa>>2]=0;f[Pa>>2]=0;f[h>>2]=16842752;f[Qa>>2]=i;Vb=f[H>>2]|0;Ub=Ra;f[Ub>>2]=0;f[Ub+4>>2]=0;f[j>>2]=33619968;f[Sa>>2]=F;pR(h,1,Vb,j);f[Ta>>2]=0;f[Ua>>2]=0;f[h>>2]=16842752;f[Va>>2]=q;f[Wa>>2]=0;f[Xa>>2]=0;f[j>>2]=16842752;f[Ya>>2]=F;Vb=Za;f[Vb>>2]=0;f[Vb+4>>2]=0;f[s>>2]=33619968;f[_a>>2]=q;I1(h,j,s,1.0,-1)}Vb=f[Ha>>2]|0;do if(Vb|0){Ub=Vb+12|0;Tb=f[Ub>>2]|0;f[Ub>>2]=Tb+-1;if((Tb|0)!=1)break;V$(i)}while(0);f[Ha>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[za>>2]|0)>0){Vb=f[Ia>>2]|0;Tb=0;do{f[Vb+(Tb<<2)>>2]=0;Tb=Tb+1|0}while((Tb|0)<(f[za>>2]|0))}Tb=f[Ka>>2]|0;if((Tb|0)!=(Ja|0))wL(Tb)}Ob=Ob+(V<<2)|0;Pb=Pb+(V<<2)|0;Tb=f[xa>>2]|0;do if(Tb|0){Vb=Tb+12|0;Ub=f[Vb>>2]|0;f[Vb>>2]=Ub+-1;if((Ub|0)!=1)break;V$(q)}while(0);f[xa>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[E>>2]|0)>0){Tb=f[y>>2]|0;Ub=0;do{f[Tb+(Ub<<2)>>2]=0;Ub=Ub+1|0}while((Ub|0)<(f[E>>2]|0))}Ub=f[$>>2]|0;if((Ub|0)!=(_|0))wL(Ub);Ub=f[ya>>2]|0;do if(Ub|0){Tb=Ub+12|0;Vb=f[Tb>>2]|0;f[Tb>>2]=Vb+-1;if((Vb|0)!=1)break;V$(o)}while(0);f[ya>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[P>>2]|0)>0){Ub=f[W>>2]|0;Vb=0;do{f[Ub+(Vb<<2)>>2]=0;Vb=Vb+1|0}while((Vb|0)<(f[P>>2]|0))}Vb=f[T>>2]|0;if((Vb|0)!=(O|0))wL(Vb);Nb=Nb+1|0;if(Nb>>>0>=M>>>0)break a}if((Qb|0)==51){Nb=$Xc(32)|0;f[h>>2]=Nb;f[h+8>>2]=-2147483616;f[h+4>>2]=28;A=Nb;B=470314;C=A+28|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[Nb+28>>0]=0;vM(-215,h,470343,470347,548)}else if((Qb|0)==53){O=$Xc(32)|0;f[h>>2]=O;f[h+8>>2]=-2147483616;f[h+4>>2]=28;A=O;B=470314;C=A+28|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[O+28>>0]=0;vM(-215,h,470343,470347,548)}else if((Qb|0)==82){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Nb=$Xc(32)|0;f[h>>2]=Nb;f[h+8>>2]=-2147483616;f[h+4>>2]=26;A=Nb;B=445737;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[Nb+26>>0]=0;vM(-215,h,456135,445536,254)}}while(0);hx(m);hx(l);hx(k);u=g;return}function VAb(a,c){a=a|0;c=c|0;var d=0;if((c|0)!=2){d=(c|0)==3;return d|0}if(+n[a+44>>2]!=2.0){d=0;return d|0}if((f[a+4>>2]|0)!=(f[a+8>>2]|0)){d=1;return d|0}if((f[a+40>>2]|0)==3){d=(b[a+52>>0]|0)==0;return d|0}if((f[a+56>>2]|0)!=1){d=0;return d|0}if(!(b[a+52>>0]|0)){d=1;return d|0}d=(f[a+60>>2]|0)>1;return d|0}function WAb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function XAb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=12){j=$Xc(32)|0;f[i>>2]=j;f[i+8>>2]=-2147483616;f[i+4>>2]=18;k=j;l=456060;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+18>>0]=0;vM(-215,i,456079,445536,85)}cOa(a,c,d,e,g)|0;e=g+4|0;d=f[e>>2]|0;a=f[g>>2]|0;i=d-a|0;j=(i|0)/12|0;l=d;if(!i){Nvb(g,1-j|0,f[c>>2]|0);n=f[g>>2]|0;o=f[n>>2]|0;f[o>>2]=1;u=h;return 1}if(j>>>0<=1){n=f[g>>2]|0;o=f[n>>2]|0;f[o>>2]=1;u=h;return 1}j=a+12|0;if((l|0)==(j|0)){n=f[g>>2]|0;o=f[n>>2]|0;f[o>>2]=1;u=h;return 1}else p=l;while(1){l=p+-12|0;f[e>>2]=l;a=f[l>>2]|0;if(!a)q=l;else{l=p+-8|0;c=f[l>>2]|0;if((c|0)!=(a|0))f[l>>2]=c+(~((c+-4-a|0)>>>2)<<2);cYc(a);q=f[e>>2]|0}if((q|0)==(j|0))break;else p=q}n=f[g>>2]|0;o=f[n>>2]|0;f[o>>2]=1;u=h;return 1}function YAb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(56)|0;ZAb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=106620;f[b+12>>2]=c;f[a+4>>2]=b;return}function ZAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;qQa(a);f[a>>2]=106648;rQa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=9;h=e;i=445999;j=h+9|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+9>>0]=0;i=LGa(c,e)|0;h=c+4|0;if((i|0)==(h|0))k=0;else{j=MGa(i+28|0,-1)|0;k=((j|0)!=0|(J|0)!=0)&1}b[a+44>>0]=k;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=4;f[e>>2]=1936291937;b[e+4>>0]=0;k=LGa(c,e)|0;if((k|0)==(h|0))l=1;else{h=MGa(k+28|0,-1)|0;l=h}f[a+48>>2]=l;if((b[g>>0]|0)>=0){m=a+52|0;b[m>>0]=0;u=d;return}cYc(f[e>>2]|0);m=a+52|0;b[m>>0]=0;u=d;return}function _Ab(a){a=a|0;NXc(a);cYc(a);return}function $Ab(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function aBb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==445844?a+12|0:0)|0}function bBb(a){a=a|0;cYc(a);return}function cBb(a){a=a|0;MNa(a);cYc(a);return}function dBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d+12|0;g=d;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;gS(c,e);c=f[a+8>>2]|0;i=f[a+4>>2]|0;j=(c-i|0)/56|0;k=i;i=c;switch(j|0){case 2:{l=1;break}case 1:{l=b[a+44>>0]^1;break}default:l=0}b[a+52>>0]=l;if((k|0)==(i|0)?((f[h>>2]|0)-(f[e>>2]|0)|0)==112:0){hx(e);u=d;return}if((j|0)==((b[a+44>>0]|0)+l&255|0)){hx(e);u=d;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=$Xc(96)|0;f[g>>2]=d;f[g+8>>2]=-2147483552;f[g+4>>2]=87;e=d;l=446433;a=e+87|0;do{b[e>>0]=b[l>>0]|0;e=e+1|0;l=l+1|0}while((e|0)<(a|0));b[d+87>>0]=0;vM(-215,g,455619,446009,48)}}function eBb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0;g=u;u=u+352|0;h=g+296|0;i=g+284|0;j=g+272|0;k=g+216|0;l=g+160|0;m=g+144|0;o=g+88|0;p=g+32|0;q=g+16|0;r=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;e=i+4|0;f[e>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;gS(c,i);gS(d,j);d=f[j>>2]|0;c=d;if(((f[s>>2]|0)-d|0)!=56){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(32)|0;f[h>>2]=d;f[h+8>>2]=-2147483616;f[h+4>>2]=19;t=d;v=452040;w=t+19|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[d+19>>0]=0;vM(-215,h,456135,446009,72)}d=f[a+4>>2]|0;s=a+8|0;do if((d|0)==(f[s>>2]|0)){x=f[i>>2]|0;y=x;if(((f[e>>2]|0)-x|0)!=112){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(48)|0;f[h>>2]=x;f[h+8>>2]=-2147483600;f[h+4>>2]=36;t=x;v=446088;w=t+36|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[x+36>>0]=0;vM(-215,h,456135,446009,72)}z=y+56|0;f[k>>2]=f[z>>2];A=k+4|0;B=y+60|0;C=f[B>>2]|0;f[A>>2]=C;D=k+8|0;f[D>>2]=f[y+64>>2];f[k+12>>2]=f[y+68>>2];f[k+16>>2]=f[y+72>>2];f[k+20>>2]=f[y+76>>2];f[k+24>>2]=f[y+80>>2];f[k+28>>2]=f[y+84>>2];f[k+32>>2]=f[y+88>>2];E=f[y+92>>2]|0;f[k+36>>2]=E;f[k+40>>2]=D;D=k+48|0;F=k+44|0;f[F>>2]=D;f[D>>2]=0;f[k+52>>2]=0;if(!E)G=C;else{C=E+12|0;f[C>>2]=(f[C>>2]|0)+1;G=f[B>>2]|0}if((G|0)<3){B=f[y+100>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];H=y;I=k;break}else{f[A>>2]=0;U$(k,z);H=y;I=k;break}}else{z=f[i>>2]|0;if(!(b[a+52>>0]|0)){f[k>>2]=1124007936;A=k+8|0;B=k+40|0;t=k+4|0;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[B>>2]=A;y=k+48|0;f[k+44>>2]=y;f[y>>2]=0;f[k+52>>2]=0;H=z;I=k;break}f[k>>2]=f[d>>2];y=k+4|0;x=d+4|0;f[y>>2]=f[x>>2];C=k+8|0;f[C>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];f[k+16>>2]=f[d+16>>2];f[k+20>>2]=f[d+20>>2];f[k+24>>2]=f[d+24>>2];f[k+28>>2]=f[d+28>>2];f[k+32>>2]=f[d+32>>2];F=f[d+36>>2]|0;f[k+36>>2]=F;f[k+40>>2]=C;C=k+48|0;E=k+44|0;f[E>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(F|0){C=F+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[x>>2]|0)<3){x=f[d+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[x>>2];f[C+4>>2]=f[x+4>>2];H=z;I=k;break}else{f[y>>2]=0;U$(k,d);H=z;I=k;break}}while(0);I=a+44|0;if(!(b[I>>0]|0)){f[l>>2]=1124007936;d=l+8|0;G=l+40|0;t=l+4|0;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[G>>2]=d;d=l+48|0;f[l+44>>2]=d;f[d>>2]=0;f[l+52>>2]=0}else g0(l,(f[s>>2]|0)+-56|0,1,1);s=k+16|0;if(f[s>>2]|0){d=k+4|0;G=f[d>>2]|0;if((G|0)<3)J=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{e=f[k+40>>2]|0;y=0;x=1;while(1){C=Y(f[e+(y<<2)>>2]|0,x)|0;y=y+1|0;if((y|0)==(G|0)){J=C;break}else x=C}}if(!((G|0)==0|(J|0)==0)){g0(h,k,1,1);J=k+36|0;G=f[J>>2]|0;if(G|0?(x=G+12|0,G=f[x>>2]|0,f[x>>2]=G+-1,(G|0)==1):0)V$(k);f[J>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[d>>2]|0)>0){G=f[k+40>>2]|0;x=0;do{f[G+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[d>>2]|0))}f[k>>2]=f[h>>2];x=h+4|0;G=f[x>>2]|0;f[d>>2]=G;d=h+8|0;y=k+8|0;f[y>>2]=f[d>>2];f[k+12>>2]=f[h+12>>2];e=h+16|0;f[s>>2]=f[e>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];C=h+36|0;f[J>>2]=f[C>>2];J=k+44|0;E=f[J>>2]|0;F=k+48|0;if((E|0)==(F|0))K=G;else{wL(E);f[J>>2]=F;f[k+40>>2]=y;K=f[x>>2]|0}y=h+44|0;if((K|0)<3){K=f[y>>2]|0;f[F>>2]=f[K>>2];f[k+52>>2]=f[K+4>>2];L=K}else{f[J>>2]=f[y>>2];J=h+40|0;f[k+40>>2]=f[J>>2];K=h+48|0;f[y>>2]=K;f[J>>2]=d;L=K}f[h>>2]=1124007936;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;f[C>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((L|0)!=(h+48|0))wL(L)}}L=H+4|0;e=f[L>>2]|0;C=f[H+40>>2]|0;f[m>>2]=0;x=m+4|0;f[x>>2]=0;f[m+8>>2]=0;gOa(m,C,C+(e<<2)|0);e=f[s>>2]|0;C=(e|0)==0;do if(!C){K=f[k+4>>2]|0;d=(K|0)<3;if(d)M=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{J=f[k+40>>2]|0;y=0;F=1;while(1){E=Y(f[J+(y<<2)>>2]|0,F)|0;y=y+1|0;if((y|0)==(K|0)){M=E;break}else F=E}}if(!((K|0)==0|(M|0)==0)){if(d){N=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;break}F=f[k+40>>2]|0;y=0;J=1;while(1){z=Y(f[F+(y<<2)>>2]|0,J)|0;y=y+1|0;if((y|0)==(K|0)){N=z;break}else J=z}}else O=53}else O=53;while(0);do if((O|0)==53){M=f[l+4>>2]|0;if((M|0)<3){N=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;break}J=f[l+40>>2]|0;K=0;y=1;while(1){F=Y(f[J+(K<<2)>>2]|0,y)|0;K=K+1|0;if((K|0)==(M|0)){N=F;break}else y=F}}while(0);if(!N){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(16)|0;f[h>>2]=y;f[h+8>>2]=-2147483632;f[h+4>>2]=15;t=y;v=446125;w=t+15|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[y+15>>0]=0;vM(-215,h,456135,446009,84)}if(b[a+52>>0]|0?b[I>>0]|0:0){y=f[k+4>>2]|0;M=(y|0)<3;if(M)P=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{K=f[k+40>>2]|0;J=0;F=1;while(1){d=Y(f[K+(J<<2)>>2]|0,F)|0;J=J+1|0;if((J|0)==(y|0)){P=d;break}else F=d}}F=f[l+4>>2]|0;J=(F|0)<3;if(J)Q=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{K=f[l+40>>2]|0;d=0;z=1;while(1){A=Y(f[K+(d<<2)>>2]|0,z)|0;d=d+1|0;if((d|0)==(F|0)){Q=A;break}else z=A}}if((P|0)!=(Q|0)){if(M)R=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{M=f[k+40>>2]|0;Q=0;P=1;while(1){z=Y(f[M+(Q<<2)>>2]|0,P)|0;Q=Q+1|0;if((Q|0)==(y|0)){R=z;break}else P=z}}if(J){S=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;nV(R,S,106752)}J=f[l+40>>2]|0;P=0;y=1;while(1){Q=Y(f[J+(P<<2)>>2]|0,y)|0;P=P+1|0;if((P|0)==(F|0)){S=Q;break}else y=Q}nV(R,S,106752)}}S=f[a+48>>2]|0;a=f[L>>2]|0;L=f[x>>2]|0;R=f[m>>2]|0;y=L-R|0;F=y>>2;P=R;R=L;L=(S|0)==-1?0:S;J=(P|0)==(R|0);Q=(L|0)>(F|0);M=S;while(1){z=M;M=M+1|0;if((z|0)>=(a|0)){O=88;break}z=(M|0)==-1?F:M;if(!J){if(Q){O=85;break}if((L|0)>(z|0)|(z|0)>(F|0)){O=85;break}if((L|0)<(z|0)){d=1;K=L;while(1){A=Y(f[P+(K<<2)>>2]|0,d)|0;K=K+1|0;if((K|0)==(z|0)){T=A;break}else d=A}}else T=1}else T=0;if((T|0)==(N|0)){O=88;break}}if((O|0)==85){T=$Xc(80)|0;f[h>>2]=T;f[h+8>>2]=-2147483568;f[h+4>>2]=70;t=T;v=454543;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[T+70>>0]=0;vM(-215,h,454614,454620,161)}else if((O|0)==88){T=(S|0)==-1;L=T?0:S;Q=(M|0)==-1;J=Q?F:M;d=(P|0)==(R|0);if(!d){if((L|0)>(F|0)){U=$Xc(80)|0;f[h>>2]=U;V=h+8|0;f[V>>2]=-2147483568;W=h+4|0;f[W>>2]=70;t=U;v=454543;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));X=U+70|0;b[X>>0]=0;vM(-215,h,454614,454620,161)}if((L|0)>(J|0)|(J|0)>(F|0)){U=$Xc(80)|0;f[h>>2]=U;V=h+8|0;f[V>>2]=-2147483568;W=h+4|0;f[W>>2]=70;t=U;v=454543;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));X=U+70|0;b[X>>0]=0;vM(-215,h,454614,454620,161)}if((L|0)<(J|0)){X=1;U=L;while(1){L=Y(f[P+(U<<2)>>2]|0,X)|0;U=U+1|0;if((U|0)==(J|0)){Z=L;break}else X=L}}else Z=1}else Z=0;if((Z|0)!=(N|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Z=$Xc(48)|0;f[h>>2]=Z;f[h+8>>2]=-2147483600;f[h+4>>2]=44;t=Z;v=446141;w=t+44|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[Z+44>>0]=0;vM(-215,h,456135,446009,94)}Z=b[I>>0]|0;if(Z<<24>>24){X=f[l+4>>2]|0;if((X|0)<3)_=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{J=f[l+40>>2]|0;U=0;L=1;while(1){W=Y(f[J+(U<<2)>>2]|0,L)|0;U=U+1|0;if((U|0)==(X|0)){_=W;break}else L=W}}if((N|0)!=(_|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=$Xc(48)|0;f[h>>2]=_;f[h+8>>2]=-2147483600;f[h+4>>2]=38;t=_;v=446186;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[_+38>>0]=0;vM(-215,h,456135,446009,95)}}_=f[H>>2]&4095;if((_|0)!=5)kV(_,5,106780);_=f[c>>2]&4095;if((_|0)!=5)kV(_,5,106808);_=T?F:S;if(!d){if((y|0)<0){$=$Xc(80)|0;f[h>>2]=$;aa=h+8|0;f[aa>>2]=-2147483568;ba=h+4|0;f[ba>>2]=70;t=$;v=454543;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));ca=$+70|0;b[ca>>0]=0;vM(-215,h,454614,454620,161)}if((_|0)<0|(_|0)>(F|0)){$=$Xc(80)|0;f[h>>2]=$;aa=h+8|0;f[aa>>2]=-2147483568;ba=h+4|0;f[ba>>2]=70;t=$;v=454543;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));ca=$+70|0;b[ca>>0]=0;vM(-215,h,454614,454620,161)}if((_|0)>0){ca=1;$=0;while(1){ba=Y(f[P+($<<2)>>2]|0,ca)|0;$=$+1|0;if(($|0)==(_|0)){da=ba;break}else ca=ba}}else da=1}else da=0;ca=f[H+16>>2]|0;H=f[c+16>>2]|0;a:do if((M|0)==(a|0)){if((da|0)>0){c=o+4|0;_=o+8|0;$=o+12|0;ba=o+16|0;aa=o+20|0;y=o+24|0;S=o+40|0;T=o+48|0;L=o+44|0;X=o+52|0;U=o+28|0;J=N<<2;W=0-J|0;V=p+4|0;R=p+8|0;z=p+12|0;K=p+16|0;A=p+20|0;B=p+24|0;E=p+40|0;G=p+48|0;D=p+44|0;ea=p+52|0;fa=p+28|0;ga=h+8|0;ha=h+12|0;ia=h+4|0;ja=q+8|0;ka=q+12|0;la=q+4|0;ma=r+8|0;na=r+4|0;oa=p+36|0;pa=o+36|0;qa=k+4|0;ra=k+8|0;sa=k+12|0;ta=h+8|0;ua=h+12|0;va=h+4|0;wa=q+8|0;xa=q+12|0;ya=q+4|0;za=r+8|0;Aa=r+4|0;Ba=h+8|0;Ca=h+12|0;Da=h+4|0;Ea=q+8|0;Fa=q+12|0;Ga=q+4|0;Ha=r+8|0;Ia=r+4|0;Ja=k+40|0;Ka=0;La=ca;Ma=H;while(1){f[o>>2]=1124007941;f[c>>2]=2;f[_>>2]=1;f[$>>2]=N;f[ba>>2]=La;f[aa>>2]=La;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[S>>2]=_;f[L>>2]=T;f[X>>2]=0;f[T>>2]=0;if(!La){O=158;break}f[T>>2]=J;f[X>>2]=4;La=La+(N<<2)|0;f[U>>2]=La;f[y>>2]=La+W+J;R$(o);f[p>>2]=1124007941;f[V>>2]=2;f[R>>2]=1;f[z>>2]=N;f[K>>2]=Ma;f[A>>2]=Ma;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[E>>2]=R;f[D>>2]=G;f[ea>>2]=0;f[G>>2]=0;if(!Ma){O=160;break}f[G>>2]=J;f[ea>>2]=4;Ma=Ma+(N<<2)|0;f[fa>>2]=Ma;f[B>>2]=Ma+W+J;R$(p);do if(!(f[s>>2]|0))O=169;else{Na=f[qa>>2]|0;if((Na|0)<3)Oa=Y(f[sa>>2]|0,f[ra>>2]|0)|0;else{Pa=f[Ja>>2]|0;Qa=0;Ra=1;while(1){Sa=Y(f[Pa+(Qa<<2)>>2]|0,Ra)|0;Qa=Qa+1|0;if((Qa|0)==(Na|0)){Oa=Sa;break}else Ra=Sa}}if((Na|0)==0|(Oa|0)==0){O=169;break}f[ta>>2]=0;f[ua>>2]=0;f[h>>2]=16842752;f[va>>2]=o;f[wa>>2]=0;f[xa>>2]=0;f[q>>2]=16842752;f[ya>>2]=k;Ra=za;f[Ra>>2]=0;f[Ra+4>>2]=0;f[r>>2]=33619968;f[Aa>>2]=p;I1(h,q,r,1.0,-1);if(!(b[I>>0]|0))break;f[Ba>>2]=0;f[Ca>>2]=0;f[h>>2]=16842752;f[Da>>2]=p;f[Ea>>2]=0;f[Fa>>2]=0;f[q>>2]=16842752;f[Ga>>2]=l;Ra=Ha;f[Ra>>2]=0;f[Ra+4>>2]=0;f[r>>2]=33619968;f[Ia>>2]=p;E1(h,q,r,fT()|0,-1)}while(0);do if((O|0)==169){O=0;if(!(b[I>>0]|0))break;f[ga>>2]=0;f[ha>>2]=0;f[h>>2]=16842752;f[ia>>2]=o;f[ja>>2]=0;f[ka>>2]=0;f[q>>2]=16842752;f[la>>2]=l;Ra=ma;f[Ra>>2]=0;f[Ra+4>>2]=0;f[r>>2]=33619968;f[na>>2]=p;E1(h,q,r,fT()|0,-1)}while(0);Ra=f[oa>>2]|0;do if(Ra|0){Qa=Ra+12|0;Pa=f[Qa>>2]|0;f[Qa>>2]=Pa+-1;if((Pa|0)!=1)break;V$(p)}while(0);f[oa>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[V>>2]|0)>0){Ra=f[E>>2]|0;Pa=0;do{f[Ra+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[V>>2]|0))}Pa=f[D>>2]|0;if((Pa|0)!=(G|0))wL(Pa);Pa=f[pa>>2]|0;do if(Pa|0){Ra=Pa+12|0;Qa=f[Ra>>2]|0;f[Ra>>2]=Qa+-1;if((Qa|0)!=1)break;V$(o)}while(0);f[pa>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[c>>2]|0)>0){Pa=f[S>>2]|0;Qa=0;do{f[Pa+(Qa<<2)>>2]=0;Qa=Qa+1|0}while((Qa|0)<(f[c>>2]|0))}Qa=f[L>>2]|0;if((Qa|0)!=(T|0))wL(Qa);Ka=Ka+1|0;if((Ka|0)>=(da|0))break a}if((O|0)==158){Ka=$Xc(32)|0;f[h>>2]=Ka;f[h+8>>2]=-2147483616;f[h+4>>2]=28;t=Ka;v=470314;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[Ka+28>>0]=0;vM(-215,h,470343,470347,548)}else if((O|0)==160){T=$Xc(32)|0;f[h>>2]=T;f[h+8>>2]=-2147483616;f[h+4>>2]=28;t=T;v=470314;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[T+28>>0]=0;vM(-215,h,470343,470347,548)}}}else{if(!C){Ka=f[k+4>>2]|0;if((Ka|0)<3)Ta=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{L=f[k+40>>2]|0;c=0;S=1;while(1){ba=Y(f[L+(c<<2)>>2]|0,S)|0;c=c+1|0;if((c|0)==(Ka|0)){Ta=ba;break}else S=ba}}if(!((Ka|0)==0|(Ta|0)==0))Ua=e;else O=122}else O=122;if((O|0)==122)Ua=0;S=Z<<24>>24?f[l+16>>2]|0:0;c=Q?0:M;do if(d)Va=0;else{if((c|0)>(F|0)){L=$Xc(80)|0;f[h>>2]=L;f[h+8>>2]=-2147483568;f[h+4>>2]=70;t=L;v=454543;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[L+70>>0]=0;vM(-215,h,454614,454620,161)}if((c|0)<(F|0)){Wa=1;Xa=c}else{Va=1;break}while(1){T=Y(f[P+(Xa<<2)>>2]|0,Wa)|0;Xa=Xa+1|0;if((Xa|0)==(F|0)){Va=T;break}else Wa=T}}while(0);if((da|0)>0){c=(N|0)>0;Ka=(Ua|0)==0;L=(S|0)==0;T=o+4|0;ba=o+8|0;pa=o+12|0;G=o+16|0;D=o+20|0;V=o+24|0;E=o+40|0;K=o+48|0;oa=o+44|0;na=o+52|0;ma=(Va|0)!=0;la=o+28|0;ka=Va<<2;ja=0-ka|0;ia=p+4|0;ha=p+8|0;ga=p+12|0;Ia=p+16|0;Ha=p+20|0;Ga=p+24|0;Fa=p+40|0;Ea=p+48|0;Da=p+44|0;Ca=p+52|0;Ba=p+28|0;Aa=h+8|0;za=h+4|0;ya=p+36|0;xa=o+36|0;wa=0;va=ca;ua=H;b:while(1){if(c){ta=0;Ja=va;ra=ua;while(1){if(Ka)Ya=1.0;else Ya=+n[Ua+(ta<<2)>>2];if(L)Za=0.0;else Za=+n[S+(ta<<2)>>2];f[o>>2]=1124007941;f[T>>2]=2;f[ba>>2]=1;f[pa>>2]=Va;f[G>>2]=Ja;f[D>>2]=Ja;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;f[E>>2]=ba;f[oa>>2]=K;f[na>>2]=0;f[K>>2]=0;if(ma&(Ja|0)==0){O=137;break b}f[K>>2]=ka;f[na>>2]=4;sa=Ja+(Va<<2)|0;f[la>>2]=sa;f[V>>2]=sa+ja+ka;R$(o);f[p>>2]=1124007941;f[ia>>2]=2;f[ha>>2]=1;f[ga>>2]=Va;f[Ia>>2]=ra;f[Ha>>2]=ra;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;f[Fa>>2]=ha;f[Da>>2]=Ea;f[Ca>>2]=0;f[Ea>>2]=0;if(ma&(ra|0)==0){O=139;break b}f[Ea>>2]=ka;f[Ca>>2]=4;qa=ra+(Va<<2)|0;f[Ba>>2]=qa;f[Ga>>2]=qa+ja+ka;R$(p);J=Aa;f[J>>2]=0;f[J+4>>2]=0;f[h>>2]=33619968;f[za>>2]=p;dY(o,h,5,Ya,Za);J=f[ya>>2]|0;do if(J|0){W=J+12|0;Ma=f[W>>2]|0;f[W>>2]=Ma+-1;if((Ma|0)!=1)break;V$(p)}while(0);f[ya>>2]=0;f[Ia>>2]=0;f[Ia+4>>2]=0;f[Ia+8>>2]=0;f[Ia+12>>2]=0;if((f[ia>>2]|0)>0){J=f[Fa>>2]|0;Na=0;do{f[J+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[ia>>2]|0))}Na=f[Da>>2]|0;if((Na|0)!=(Ea|0))wL(Na);Na=f[xa>>2]|0;do if(Na|0){J=Na+12|0;Ma=f[J>>2]|0;f[J>>2]=Ma+-1;if((Ma|0)!=1)break;V$(o)}while(0);f[xa>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[T>>2]|0)>0){Na=f[E>>2]|0;Ma=0;do{f[Na+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[T>>2]|0))}Ma=f[oa>>2]|0;if((Ma|0)!=(K|0))wL(Ma);ta=ta+1|0;if((ta|0)>=(N|0)){_a=sa;$a=qa;break}else{Ja=sa;ra=qa}}}else{_a=va;$a=ua}wa=wa+1|0;if((wa|0)>=(da|0))break a;else{va=_a;ua=$a}}if((O|0)==137){ua=$Xc(32)|0;f[h>>2]=ua;f[h+8>>2]=-2147483616;f[h+4>>2]=28;t=ua;v=470314;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[ua+28>>0]=0;vM(-215,h,470343,470347,548)}else if((O|0)==139){va=$Xc(32)|0;f[h>>2]=va;f[h+8>>2]=-2147483616;f[h+4>>2]=28;t=va;v=470314;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[va+28>>0]=0;vM(-215,h,470343,470347,548)}}}while(0);h=f[m>>2]|0;if(h|0){m=f[x>>2]|0;if((m|0)!=(h|0))f[x>>2]=m+(~((m+-4-h|0)>>>2)<<2);cYc(h)}h=l+36|0;m=f[h>>2]|0;if(m|0?(x=m+12|0,m=f[x>>2]|0,f[x>>2]=m+-1,(m|0)==1):0)V$(l);f[h>>2]=0;h=l+16|0;m=l+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[m>>2]|0)>0){h=f[l+40>>2]|0;x=0;do{f[h+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))wL(m);m=k+36|0;l=f[m>>2]|0;do if(l|0){x=l+12|0;h=f[x>>2]|0;f[x>>2]=h+-1;if((h|0)!=1)break;V$(k)}while(0);f[m>>2]=0;m=k+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[m>>2]|0)>0){s=f[k+40>>2]|0;l=0;do{f[s+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))wL(m);hx(j);hx(i);u=g;return}}function fBb(a,b){a=a|0;b=b|0;var c=0;if((b|2|0)!=3)if((b|0)==2)c=(f[a+48>>2]|0)==1;else c=0;else c=1;return c|0}function gBb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function hBb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function iBb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function jBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+64|0;g=e;do if(b[a+52>>0]|0){h=f[a+4>>2]|0;f[g>>2]=f[h>>2];i=g+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=g+8|0;f[k>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[g+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=k;k=g+48|0;m=g+44|0;f[m>>2]=k;f[k>>2]=0;f[g+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;U$(g,h);break}}else{f[g>>2]=1124007936;h=g+8|0;i=g+40|0;n=g+4|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[i>>2]=h;j=g+48|0;f[g+44>>2]=j;f[j>>2]=0;f[g+52>>2]=0}while(0);if((g|0)==(c|0)){p=g+36|0;q=f[c+36>>2]|0}else{j=g+36|0;k=f[j>>2]|0;if(k|0){m=k+12|0;f[m>>2]=(f[m>>2]|0)+1}m=c+36|0;k=f[m>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)V$(c);f[m>>2]=0;k=c+16|0;l=c+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){r=f[c+40>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0;t=f[l>>2]|0}while((s|0)<(t|0));f[c>>2]=f[g>>2];if((t|0)<3)v=20;else v=22}else{f[c>>2]=f[g>>2];v=20}if((v|0)==20){t=f[g+4>>2]|0;if((t|0)<3){f[l>>2]=t;f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];t=f[g+44>>2]|0;l=f[c+44>>2]|0;f[l>>2]=f[t>>2];f[l+4>>2]=f[t+4>>2]}else v=22}if((v|0)==22)U$(c,g);f[k>>2]=f[g+16>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];c=f[j>>2]|0;f[m>>2]=c;p=j;q=c}if(q|0?(c=q+12|0,q=f[c>>2]|0,f[c>>2]=q+-1,(q|0)==1):0)V$(g);f[p>>2]=0;p=g+16|0;q=g+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[g+40>>2]|0;c=0;do{f[p+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[q>>2]|0))}q=f[g+44>>2]|0;if((q|0)!=(g+48|0))wL(q);do if(b[a+44>>0]|0){q=f[a+8>>2]|0;c=q+-56|0;f[g>>2]=f[c>>2];p=g+4|0;j=q+-52|0;f[p>>2]=f[j>>2];m=g+8|0;f[m>>2]=f[q+-48>>2];f[g+12>>2]=f[q+-44>>2];f[g+16>>2]=f[q+-40>>2];f[g+20>>2]=f[q+-36>>2];f[g+24>>2]=f[q+-32>>2];f[g+28>>2]=f[q+-28>>2];f[g+32>>2]=f[q+-24>>2];k=f[q+-20>>2]|0;f[g+36>>2]=k;f[g+40>>2]=m;m=g+48|0;t=g+44|0;f[t>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(k|0){m=k+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[j>>2]|0)<3){j=f[q+-12>>2]|0;q=f[t>>2]|0;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];break}else{f[p>>2]=0;U$(g,c);break}}else{f[g>>2]=1124007936;c=g+8|0;p=g+40|0;n=g+4|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[p>>2]=c;h=g+48|0;f[g+44>>2]=h;f[h>>2]=0;f[g+52>>2]=0}while(0);if((g|0)==(d|0)){w=g+36|0;x=f[d+36>>2]|0}else{n=g+36|0;o=f[n>>2]|0;if(o|0){a=o+12|0;f[a>>2]=(f[a>>2]|0)+1}a=d+36|0;o=f[a>>2]|0;if(o|0?(h=o+12|0,o=f[h>>2]|0,f[h>>2]=o+-1,(o|0)==1):0)V$(d);f[a>>2]=0;o=d+16|0;h=d+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[h>>2]|0)>0){i=f[d+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0;y=f[h>>2]|0}while((j|0)<(y|0));f[d>>2]=f[g>>2];if((y|0)<3)v=51;else v=53}else{f[d>>2]=f[g>>2];v=51}if((v|0)==51){y=f[g+4>>2]|0;if((y|0)<3){f[h>>2]=y;f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];y=f[g+44>>2]|0;h=f[d+44>>2]|0;f[h>>2]=f[y>>2];f[h+4>>2]=f[y+4>>2]}else v=53}if((v|0)==53)U$(d,g);f[o>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];d=f[n>>2]|0;f[a>>2]=d;w=n;x=d}if(x|0?(d=x+12|0,x=f[d>>2]|0,f[d>>2]=x+-1,(x|0)==1):0)V$(g);f[w>>2]=0;w=g+16|0;x=g+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[g+40>>2]|0;d=0;do{f[w+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[x>>2]|0))}x=f[g+44>>2]|0;if((x|0)==(g+48|0)){u=e;return}wL(x);u=e;return}function kBb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eOa(d,1,f[b>>2]|0);return 1}function lBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;a=d;e=f[c+4>>2]|0;g=f[c>>2]|0;c=g;if((e|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=(e-g|0)/12|0;g=0;e=0;do{k=f[c+(e*12|0)+4>>2]|0;l=f[c+(e*12|0)>>2]|0;m=k-l|0;n=m>>2;o=l;if((o|0)!=(k|0)){if((m|0)<0){p=8;break}if(!m)q=1;else{m=1;k=0;while(1){l=Y(f[o+(k<<2)>>2]|0,m)|0;k=k+1|0;if((k|0)==(n|0)){q=l;break}else m=l}}}else q=0;g=(q<<1)+g|0;e=e+1|0}while(e>>>0<j>>>0);if((p|0)==8){p=$Xc(80)|0;f[a>>2]=p;f[a+8>>2]=-2147483568;f[a+4>>2]=70;j=p;e=454543;q=j+70|0;do{b[j>>0]=b[e>>0]|0;j=j+1|0;e=e+1|0}while((j|0)<(q|0));b[p+70>>0]=0;vM(-215,a,454614,454620,161)}h=((g|0)<0)<<31>>31;i=g;J=h;u=d;return i|0}function mBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d+16|0;g=d+4|0;h=d;f[e+4>>2]=0;f[e+8>>2]=0;i=e+4|0;f[e>>2]=i;j=e+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));l=e+24|0;oYc(l,c+24|0)|0;m=e+36|0;tYc(m,446585)|0;if((e|0)!=(c|0))JPa(e+12|0,f[c+12>>2]|0,f[c+16>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=9;j=g;n=445999;k=j+9|0;do{b[j>>0]=b[n>>0]|0;j=j+1|0;n=n+1|0}while((j|0)<(k|0));b[g+9>>0]=0;b[h>>0]=1;cHa(e,g,h)|0;if((b[c>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=4;f[g>>2]=1936291937;b[g+4>>0]=0;f[h>>2]=0;aHa(e,g,h)|0;if((b[c>>0]|0)<0)cYc(f[g>>2]|0);g=$Xc(56)|0;ZAb(g,e);c=$Xc(16)|0;h=g;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=106620;f[c+12>>2]=h;f[a>>2]=h;f[a+4>>2]=c;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[l+11>>0]|0)>=0){o=e+12|0;hx(o);p=f[i>>2]|0;QGa(e,p);u=d;return}cYc(f[l>>2]|0);o=e+12|0;hx(o);p=f[i>>2]|0;QGa(e,p);u=d;return}function nBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=g?f[c>>2]|0:c;c=j+h|0;if(c>>>0>4294967279)jYc(a);if(c>>>0<11){b[a+11>>0]=h;k=a}else{g=c+16&-16;c=$Xc(g)|0;f[a>>2]=c;f[a+8>>2]=g|-2147483648;f[a+4>>2]=h;k=c}if(!h){l=k+h|0;b[l>>0]=0;m=f[d>>2]|0;n=i?m:d;zYc(a,n,j)|0;return}o1c(k|0,e|0,h|0)|0;l=k+h|0;b[l>>0]=0;m=f[d>>2]|0;n=i?m:d;zYc(a,n,j)|0;return}function oBb(a,c,e,g,h,i,j){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+80|0;l=k+8|0;m=k;n=k+60|0;o=k+48|0;p=k+36|0;q=k+24|0;r=k+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;s=n+11|0;b[s>>0]=2;d[n>>1]=26719;b[n+2>>0]=0;nBb(o,c,n);if((b[s>>0]|0)<0)cYc(f[n>>2]|0);f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;s=n+11|0;b[s>>0]=2;d[n>>1]=30559;b[n+2>>0]=0;nBb(p,c,n);if((b[s>>0]|0)<0)cYc(f[n>>2]|0);lYc(q,e);e=q+11|0;s=b[e>>0]|0;if(((s<<24>>24<0?f[q+4>>2]|0:s&255)|0)==0?(LYc(q,0,-1,1165591,0)|0)==0:0)oYc(q,c)|0;if((HIa(a,o)|0)!=0?(HIa(a,p)|0)!=0:0){c=MGa(NIa(a,o)|0,-1)|0;f[g>>2]=c;c=MGa(NIa(a,p)|0,-1)|0;f[h>>2]=c;t=1}else v=11;do if((v|0)==11){if(!(HIa(a,q)|0)){if(!i){t=0;break}c=f[j>>2]|0;f[h>>2]=c;f[g>>2]=c;t=1;break}VGa(r,NIa(a,q)|0);c=MGa(r,0)|0;f[g>>2]=c;s=f[r>>2]|0;switch(s|0){case 0:{w=f[r+4>>2]|0;x=w+4|0;y=w;z=w;A=w;break}case 3:{w=f[r+4>>2]|0;x=w+4|0;y=w;z=w;A=w;break}case 2:{w=f[r+4>>2]|0;x=w+4|0;y=w;z=w;A=w;break}default:{f[m>>2]=s;DM(n,455363,m);vM(-3,n,470867,455383,297)}}if((f[x>>2]|0)!=1){switch(s|0){case 0:{B=y+4|0;break}case 3:{B=z+4|0;break}case 2:{B=A+4|0;break}default:{f[l>>2]=s;DM(n,455363,l);vM(-3,n,470867,455383,297)}}if((f[B>>2]|0)==2){s=MGa(r,1)|0;C=s;v=25}else D=0}else{C=c;v=25}if((v|0)==25){f[h>>2]=C;D=1}RGa(r);t=D}while(0);if((b[e>>0]|0)<0)cYc(f[q>>2]|0);if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);if((b[o+11>>0]|0)>=0){u=k;return t|0}cYc(f[o>>2]|0);u=k;return t|0}function pBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e+4|0;i=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=6;b[g>>0]=b[446591]|0;b[g+1>>0]=b[446592]|0;b[g+2>>0]=b[446593]|0;b[g+3>>0]=b[446594]|0;b[g+4>>0]=b[446595]|0;b[g+5>>0]=b[446596]|0;b[g+6>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=$Xc(16)|0;f[h>>2]=k;f[h+8>>2]=-2147483632;f[h+4>>2]=11;l=k;m=446598;n=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+11>>0]=0;f[i>>2]=0;k=oBb(a,g,h,c,d,0,i)|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[j>>0]|0)<0)cYc(f[g>>2]|0);if(!k){k=$Xc(64)|0;f[g>>2]=k;f[g+8>>2]=-2147483584;f[g+4>>2]=52;l=k;m=446610;n=l+52|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+52>>0]=0;vM(-5,g,446663,446677,115)}if((f[c>>2]|0)>0&(f[d>>2]|0)>0){u=e;return}else{e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=26;l=e;m=446758;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[e+26>>0]=0;vM(-215,g,446663,446677,118)}}function qBb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;k=u;u=u+64|0;l=k+16|0;m=k;n=k+40|0;o=k+28|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;p=l+11|0;b[p>>0]=5;b[l>>0]=b[446785]|0;b[l+1>>0]=b[446786]|0;b[l+2>>0]=b[446787]|0;b[l+3>>0]=b[446788]|0;b[l+4>>0]=b[446789]|0;b[l+5>>0]=0;if(!(HIa(a,l)|0))q=0;else{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;r=m+11|0;b[r>>0]=5;b[m>>0]=b[446791]|0;b[m+1>>0]=b[446792]|0;b[m+2>>0]=b[446793]|0;b[m+3>>0]=b[446794]|0;b[m+4>>0]=b[446795]|0;b[m+5>>0]=0;if(!(HIa(a,m)|0))s=0;else{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;t=n+11|0;b[t>>0]=5;b[n>>0]=b[446797]|0;b[n+1>>0]=b[446798]|0;b[n+2>>0]=b[446799]|0;b[n+3>>0]=b[446800]|0;b[n+4>>0]=b[446801]|0;b[n+5>>0]=0;if(!(HIa(a,n)|0))v=0;else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;w=o+11|0;b[w>>0]=5;b[o>>0]=b[446803]|0;b[o+1>>0]=b[446804]|0;b[o+2>>0]=b[446805]|0;b[o+3>>0]=b[446806]|0;b[o+4>>0]=b[446807]|0;b[o+5>>0]=0;x=(HIa(a,o)|0)!=0;if((b[w>>0]|0)<0)cYc(f[o>>2]|0);v=x}if((b[t>>0]|0)<0)cYc(f[n>>2]|0);s=v}if((b[r>>0]|0)<0)cYc(f[m>>2]|0);q=s}if((b[p>>0]|0)<0)cYc(f[l>>2]|0);if(q){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=5;b[l>>0]=b[446791]|0;b[l+1>>0]=b[446792]|0;b[l+2>>0]=b[446793]|0;b[l+3>>0]=b[446794]|0;b[l+4>>0]=b[446795]|0;b[l+5>>0]=0;p=MGa(NIa(a,l)|0,-1)|0;f[c>>2]=p;if((b[q>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=5;b[l>>0]=b[446785]|0;b[l+1>>0]=b[446786]|0;b[l+2>>0]=b[446787]|0;b[l+3>>0]=b[446788]|0;b[l+4>>0]=b[446789]|0;b[l+5>>0]=0;p=MGa(NIa(a,l)|0,-1)|0;f[d>>2]=p;if((b[q>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=5;b[l>>0]=b[446803]|0;b[l+1>>0]=b[446804]|0;b[l+2>>0]=b[446805]|0;b[l+3>>0]=b[446806]|0;b[l+4>>0]=b[446807]|0;b[l+5>>0]=0;p=MGa(NIa(a,l)|0,-1)|0;f[e>>2]=p;if((b[q>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=5;b[l>>0]=b[446797]|0;b[l+1>>0]=b[446798]|0;b[l+2>>0]=b[446799]|0;b[l+3>>0]=b[446800]|0;b[l+4>>0]=b[446801]|0;b[l+5>>0]=0;p=MGa(NIa(a,l)|0,-1)|0;f[g>>2]=p;if((b[q>>0]|0)<0)cYc(f[l>>2]|0)}else{q=l+4|0;f[q>>2]=0;f[q+4>>2]=0;q=l+11|0;b[q>>0]=3;b[l>>0]=b[446809]|0;b[l+1>>0]=b[446810]|0;b[l+2>>0]=b[446811]|0;b[l+3>>0]=0;p=m+4|0;f[p>>2]=0;f[p+4>>2]=0;p=m+11|0;b[p>>0]=3;b[m>>0]=b[446809]|0;b[m+1>>0]=b[446810]|0;b[m+2>>0]=b[446811]|0;b[m+3>>0]=0;f[n>>2]=0;oBb(a,l,m,c,d,1,n)|0;if((b[p>>0]|0)<0)cYc(f[m>>2]|0);if((b[q>>0]|0)<0)cYc(f[l>>2]|0);f[e>>2]=f[c>>2];f[g>>2]=f[d>>2]};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=6;b[l>>0]=b[446813]|0;b[l+1>>0]=b[446814]|0;b[l+2>>0]=b[446815]|0;b[l+3>>0]=b[446816]|0;b[l+4>>0]=b[446817]|0;b[l+5>>0]=b[446818]|0;b[l+6>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=m+11|0;b[p>>0]=6;b[m>>0]=b[446813]|0;b[m+1>>0]=b[446814]|0;b[m+2>>0]=b[446815]|0;b[m+3>>0]=b[446816]|0;b[m+4>>0]=b[446817]|0;b[m+5>>0]=b[446818]|0;b[m+6>>0]=0;f[n>>2]=1;oBb(a,l,m,h,i,1,n)|0;if((b[p>>0]|0)<0)cYc(f[m>>2]|0);if((b[q>>0]|0)<0)cYc(f[l>>2]|0);tYc(j,1165591)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=l+11|0;b[q>>0]=8;p=l;f[p>>2]=1600414064;f[p+4>>2]=1701080941;b[l+8>>0]=0;p=(HIa(a,l)|0)==0;if((b[q>>0]|0)<0)cYc(f[l>>2]|0);if(!p){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=m+11|0;b[p>>0]=8;q=m;f[q>>2]=1600414064;f[q+4>>2]=1701080941;b[m+8>>0]=0;OIa(l,NIa(a,m)|0,-1);a=j+11|0;if((b[a>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0}else{b[j>>0]=0;b[a>>0]=0}sYc(j,0);f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];f[j+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if((b[p>>0]|0)<0)cYc(f[m>>2]|0)}if(((f[h>>2]|0)>0?(f[d>>2]|f[c>>2]|f[e>>2]|f[g>>2]|0)>-1:0)&(f[i>>2]|0)>0){u=k;return}else{k=$Xc(80)|0;f[l>>2]=k;f[l+8>>2]=-2147483568;f[l+4>>2]=78;i=k;g=446820;e=i+78|0;do{b[i>>0]=b[g>>0]|0;i=i+1|0;g=g+1|0}while((i|0)<(e|0));b[k+78>>0]=0;vM(-215,l,446899,446677,142)}}function rBb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;n=u;u=u+48|0;o=n+16|0;p=n;q=n+28|0;qBb(a,g,h,i,j,k,l,m);m=$Xc(16)|0;f[o>>2]=m;f[o+8>>2]=-2147483632;f[o+4>>2]=14;r=m;s=446919;t=r+14|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[m+14>>0]=0;if(HIa(a,o)|0){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;m=$Xc(16)|0;f[p>>2]=m;f[p+8>>2]=-2147483632;f[p+4>>2]=14;r=m;s=446919;t=r+14|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[m+14>>0]=0;m=MGa(NIa(a,p)|0,-1)|0;b[e>>0]=((m|0)!=0|(J|0)!=0)&1;if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0)}else b[e>>0]=0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);if(!(b[e>>0]|0)){pBb(a,c,d);u=n;return};f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;d=o+11|0;b[d>>0]=8;c=o;f[c>>2]=1852990827;f[c+4>>2]=1751084133;b[o+8>>0]=0;if(!(HIa(a,o)|0)){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;c=p+11|0;b[c>>0]=8;e=p;f[e>>2]=1852990827;f[e+4>>2]=2002742373;b[p+8>>0]=0;if(!(HIa(a,p)|0)){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;e=$Xc(16)|0;f[q>>2]=e;f[q+8>>2]=-2147483632;f[q+4>>2]=11;r=e;s=446598;t=r+11|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[e+11>>0]=0;e=(HIa(a,q)|0)!=0;if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);v=e}else v=1;if((b[c>>0]|0)<0)cYc(f[p>>2]|0);w=v}else w=1;if((b[d>>0]|0)<0)cYc(f[o>>2]|0);if(w){w=$Xc(96)|0;f[o>>2]=w;f[o+8>>2]=-2147483552;f[o+4>>2]=82;r=w;s=446934;t=r+82|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[w+82>>0]=0;vM(-5,o,447017,446677,159)}if(((f[k>>2]|0)==1?(f[h>>2]|f[g>>2]|f[i>>2]|f[j>>2]|0)==0:0)&(f[l>>2]|0)==1){u=n;return}else{n=$Xc(80)|0;f[o>>2]=n;f[o+8>>2]=-2147483568;f[o+4>>2]=79;r=n;s=447040;t=r+79|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[n+79>>0]=0;vM(-5,o,447017,446677,163)}}function sBb(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0;o=u;u=u+32|0;p=o+16|0;q=o;r=o+28|0;pBb(a,c,d);qBb(a,e,g,h,i,j,k,n);f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;n=p+11|0;b[n>>0]=8;k=p;f[k>>2]=1634494820;f[k+4>>2]=1852795252;b[p+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;k=q+11|0;b[k>>0]=8;j=q;f[j>>2]=1634494820;f[j+4>>2]=1852795252;b[q+8>>0]=0;f[r>>2]=1;oBb(a,p,q,l,m,1,r)|0;if((b[k>>0]|0)<0)cYc(f[q>>2]|0);if((b[n>>0]|0)<0)cYc(f[p>>2]|0);if((f[l>>2]|0)>0&(f[m>>2]|0)>0){u=o;return}else{o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=30;m=o;l=447120;n=m+30|0;do{b[m>>0]=b[l>>0]|0;m=m+1|0;l=l+1|0}while((m|0)<(n|0));b[o+30>>0]=0;vM(-215,p,447151,446677,179)}}function tBb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;i=u;u=u+16|0;j=i;k=e+11|0;l=b[k>>0]|0;m=e+4|0;n=f[m>>2]|0;do if(((l<<24>>24<0?n:l&255)|0)==5){if(LYc(e,0,-1,453585,5)|0){o=b[k>>0]|0;p=f[m>>2]|0;break}q=Y((f[c+4>>2]|0)+-1|0,f[g+4>>2]|0)|0;r=f[d+4>>2]|0;f[h+4>>2]=((f[a+4>>2]|0)+-1+r-q|0)/(r|0)|0;r=Y((f[c>>2]|0)+-1|0,f[g>>2]|0)|0;q=f[d>>2]|0;s=(f[a>>2]|0)+-1+q-r|0;t=q;v=(s|0)/(t|0)|0;f[h>>2]=v;u=i;return}else{o=l;p=n}while(0);if(((o<<24>>24<0?p:o&255)|0)==4?(LYc(e,0,-1,453591,4)|0)==0:0){e=f[d+4>>2]|0;f[h+4>>2]=((f[a+4>>2]|0)+-1+e|0)/(e|0)|0;e=f[d>>2]|0;s=(f[a>>2]|0)+-1+e|0;t=e;v=(s|0)/(t|0)|0;f[h>>2]=v;u=i;return}i=$Xc(32)|0;f[j>>2]=i;f[j+8>>2]=-2147483616;f[j+4>>2]=24;v=i;h=447178;t=v+24|0;do{b[v>>0]=b[h>>0]|0;v=v+1|0;h=h+1|0}while((v|0)<(t|0));b[i+24>>0]=0;vM(-2,j,447203,446677,207)}function uBb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;m=g+11|0;n=b[m>>0]|0;o=g+4|0;p=f[o>>2]|0;do if(((n<<24>>24<0?p:n&255)|0)==5){if(LYc(g,0,-1,453585,5)|0){q=b[m>>0]|0;r=f[o>>2]|0;break}f[l>>2]=0;f[k>>2]=0;f[j>>2]=0;f[i>>2]=0;return}else{q=n;r=p}while(0);if(((q<<24>>24<0?r:q&255)|0)!=4)return;if(LYc(g,0,-1,453591,4)|0)return;g=Y((f[c+4>>2]|0)+-1|0,f[e+4>>2]|0)|0;q=Y((f[d+4>>2]|0)+-1|0,f[h+4>>2]|0)|0;r=g+1-(f[a+4>>2]|0)+q|0;q=Y((f[c>>2]|0)+-1|0,f[e>>2]|0)|0;e=Y((f[d>>2]|0)+-1|0,f[h>>2]|0)|0;h=q+1-(f[a>>2]|0)+e|0;e=((r|0)>0?r:0)>>>1;f[k>>2]=e;f[i>>2]=e;e=((h|0)>0?h:0)>>>1;f[l>>2]=e;f[j>>2]=e;return}function vBb(){var a=0,c=0,d=0,e=0;f[223163]=0;f[223164]=0;f[223165]=0;a=$Xc(16)|0;f[223163]=a;f[223165]=-2147483632;f[223164]=15;c=a;d=447224;e=c+15|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b[a+15>>0]=0;be(2220,892652,x|0)|0;return}function wBb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(96)|0;xBb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=106844;f[b+12>>2]=c;f[a+4>>2]=b;return}function xBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;d=u;u=u+32|0;e=d+8|0;g=d+4|0;h=d;qQa(a);f[a>>2]=106872;i=a+60|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=11;j=i;k=447415;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+11>>0]=0;f[g>>2]=0;f[h>>2]=0;i=CBb(a,c,e,g,1,h)|0;m=a+44|0;f[m>>2]=i;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=14;j=i;k=447427;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+14>>0]=0;f[g>>2]=0;b[h>>0]=0;i=a+48|0;o=(DBb(a,c,e,g,1,h)|0)&1;b[i>>0]=o;if((b[e+11>>0]|0)<0){cYc(f[e>>2]|0);p=b[i>>0]|0}else p=o;if(!(p<<24>>24))q=f[m>>2]|0;else q=1;f[a+52>>2]=q;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=19;j=q;k=447442;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+19>>0]=0;f[g>>2]=0;f[h>>2]=0;q=EBb(a,c,e,g,1,h)|0;f[a+56>>2]=q;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=26;j=q;k=447462;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+26>>0]=0;f[g>>2]=0;b[h>>0]=0;q=(DBb(a,c,e,g,0,h)|0)&1;b[a+72>>0]=q;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);q=e+11|0;b[q>>0]=10;j=e;k=447489;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[e+10>>0]=0;f[g>>2]=0;f[h>>2]=0;m=EBb(a,c,e,g,1,h)|0;f[a+76>>2]=m;if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=20;j=q;k=447500;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+20>>0]=0;f[g>>2]=0;n[h>>2]=-3402823466385288598117041.0e14;r=+FBb(a,c,e,g,0,h);n[a+80>>2]=r;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=5;b[e>>0]=b[447521]|0;b[e+1>>0]=b[447522]|0;b[e+2>>0]=b[447523]|0;b[e+3>>0]=b[447524]|0;b[e+4>>0]=b[447525]|0;b[e+5>>0]=0;f[g>>2]=0;f[h>>2]=-1;m=EBb(a,c,e,g,0,h)|0;f[a+88>>2]=m;if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=19;j=q;k=447527;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+19>>0]=0;f[g>>2]=0;b[h>>0]=0;q=(DBb(a,c,e,g,0,h)|0)&1;b[a+92>>0]=q;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=15;j=q;k=447547;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+15>>0]=0;f[g>>2]=0;b[h>>0]=1;q=(DBb(a,c,e,g,0,h)|0)&1;b[a+93>>0]=q;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=4;f[e>>2]=1885957219;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=0;m=(DBb(a,c,e,g,0,h)|0)&1;b[a+94>>0]=m;if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=16;j=q;k=447563;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+16>>0]=0;f[g>>2]=0;b[h>>0]=1;q=(DBb(a,c,e,g,0,h)|0)&1;b[a+95>>0]=q;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);GBb(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=$Xc(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=13;j=q;k=447580;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+13>>0]=0;f[g>>2]=0;n[h>>2]=0.0;r=+FBb(a,c,e,g,1,h);h=a+84|0;n[h>>2]=r;if((b[e+11>>0]|0)<0){cYc(f[e>>2]|0);s=+n[h>>2]}else s=r;if(s>0.0){rQa(a,c);u=d;return}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=18;j=d;k=447594;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+18>>0]=0;vM(-215,e,447613,447638,193)}}function yBb(a){a=a|0;NXc(a);cYc(a);return}function zBb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function ABb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==447240?a+12|0:0)|0}function BBb(a){a=a|0;cYc(a);return}function CBb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=u;u=u+32|0;i=a+16|0;j=a;f[i>>2]=0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[i+4>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;if(HIa(c,d)|0){UGa(i,NIa(c,d)|0)|0;c=MGa(i,f[e>>2]|0)|0;m=c;RGa(i);u=a;return m|0}if(g){lYc(j,892652);AYc(j,447769)|0;g=b[d+11>>0]|0;c=g<<24>>24<0;zYc(j,c?f[d>>2]|0:d,c?f[d+4>>2]|0:g&255)|0;AYc(j,447804)|0;vM(-5,j,447816,447638,155)}m=f[h>>2]|0;RGa(i);u=a;return m|0}function DBb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=u;u=u+32|0;i=a+16|0;j=a;f[i>>2]=0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[i+4>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;if(HIa(c,d)|0){UGa(i,NIa(c,d)|0)|0;c=MGa(i,f[e>>2]|0)|0;m=(c|0)!=0|(J|0)!=0;RGa(i);u=a;return m|0}if(g){lYc(j,892652);AYc(j,447769)|0;g=b[d+11>>0]|0;c=g<<24>>24<0;zYc(j,c?f[d>>2]|0:d,c?f[d+4>>2]|0:g&255)|0;AYc(j,447804)|0;vM(-5,j,447816,447638,155)}m=(b[h>>0]|0)!=0;RGa(i);u=a;return m|0}function EBb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;a=u;u=u+32|0;i=a+16|0;j=a;f[i>>2]=0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[i+4>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;if(HIa(c,d)|0){UGa(i,NIa(c,d)|0)|0;c=MGa(i,f[e>>2]|0)|0;m=c;RGa(i);u=a;return m|0}if(g){lYc(j,892652);AYc(j,447769)|0;g=b[d+11>>0]|0;c=g<<24>>24<0;zYc(j,c?f[d>>2]|0:d,c?f[d+4>>2]|0:g&255)|0;AYc(j,447804)|0;vM(-5,j,447816,447638,155)}m=f[h>>2]|0;RGa(i);u=a;return m|0}function FBb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0;a=u;u=u+32|0;i=a+16|0;j=a;f[i>>2]=0;k=$Xc(16)|0;l=k+8|0;f[k>>2]=l;f[k+4>>2]=1;f[i+4>>2]=k;k=l;f[k>>2]=0;f[k+4>>2]=0;if(HIa(c,d)|0){UGa(i,NIa(c,d)|0)|0;m=+NGa(i,f[e>>2]|0);RGa(i);u=a;return +m}if(g){lYc(j,892652);AYc(j,447769)|0;g=b[d+11>>0]|0;e=g<<24>>24<0;zYc(j,e?f[d>>2]|0:d,e?f[d+4>>2]|0:g&255)|0;AYc(j,447804)|0;vM(-5,j,447816,447638,155)}m=+n[h>>2];RGa(i);u=a;return +m}function GBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=9;j=h;k=447728;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[h+9>>0]=0;OIa(g,NIa(c,h)|0,-1);lYc(e,g);c=e+11|0;k=b[c>>0]|0;j=k<<24>>24<0;l=f[e>>2]|0;m=e+4|0;n=j?l+(f[m>>2]|0)|0:e+(k&255)|0;k=j?l:e;if((k|0)!=(n|0)){l=k;do{k=(OIc(b[l>>0]|0)|0)&255;b[l>>0]=k;l=l+1|0}while((l|0)!=(n|0))}if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[i>>0]|0)<0)cYc(f[h>>2]|0);h=b[c>>0]|0;if(((h<<24>>24<0?f[m>>2]|0:h&255)|0)==11){h=a+60|0;if(!(LYc(e,0,-1,447738,11)|0))tYc(h,447750)|0;else{o=h;p=11}}else{o=a+60|0;p=11}if((p|0)==11)tYc(o,447762)|0;if((b[c>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function HBb(a){a=a|0;var c=0;f[a>>2]=106872;c=a+60|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);return}function IBb(a){a=a|0;var c=0;f[a>>2]=106872;c=a+60|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);cYc(a);return}function JBb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;g=u;u=u+208|0;h=g+192|0;i=g+180|0;j=g+168|0;k=g+156|0;l=g+144|0;m=g+112|0;o=g+56|0;q=g+40|0;r=g;s=g+24|0;t=a+93|0;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);f[j>>2]=0;c=j+4|0;f[c>>2]=0;f[j+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;v=f[h>>2]|0;w=f[f[v+40>>2]>>2]|0;x=(f[(f[v+152>>2]|0)+8>>2]|0)/4|0;f[l>>2]=x;y=f[v+16>>2]|0;z=f[v+72>>2]|0;A=f[v+128>>2]|0;f[m>>2]=0;v=m+4|0;f[v>>2]=0;f[m+8>>2]=0;B=a+52|0;C=a+48|0;NBb(y,w,x,f[B>>2]|0,(b[C>>0]|0)!=0,(b[a+92>>0]|0)!=0,m);OBb(z,w,f[l>>2]|0,f[a+44>>2]|0,k);f[o>>2]=0;z=o+4|0;f[z>>2]=0;f[o+8>>2]=0;f[q>>2]=0;x=q+4|0;f[x>>2]=0;f[q+8>>2]=0;PBb(A,l,(b[t>>0]|0)!=0,o,q);n[r+20>>2]=0.0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;b[r+16>>0]=0;A=b[a+94>>0]|0;y=b[t>>0]|0;do if(A<<24>>24){if(y<<24>>24){n[r+4>>2]=0.0;n[r>>2]=0.0;n[r+12>>2]=1.0;n[r+8>>2]=1.0;D=1;break}if((((f[e>>2]|0)-(f[h>>2]|0)|0)/56|0)>>>0<=3){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;t=$Xc(48)|0;f[s>>2]=t;f[s+8>>2]=-2147483600;f[s+4>>2]=39;E=t;F=448038;G=E+39|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[t+39>>0]=0;vM(-215,s,456135,447638,461)}n[r+4>>2]=0.0;n[r>>2]=0.0;H=f[h>>2]|0;if((f[H+172>>2]|0)==4){I=f[H+208>>2]|0;n[r+8>>2]=+((f[I+12>>2]|0)+-1|0);n[r+12>>2]=+((f[I+8>>2]|0)+-1|0);D=0;break}else{f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;I=$Xc(32)|0;f[s>>2]=I;f[s+8>>2]=-2147483616;f[s+4>>2]=19;E=I;F=448078;G=E+19|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[I+19>>0]=0;vM(-215,s,456135,447638,468)}}else D=y;while(0);QBb(m,o,q,w,(b[C>>0]|0)!=0,f[B>>2]|0,f[a+56>>2]|0,a+60|0,(b[a+72>>0]|0)!=0,A<<24>>24!=0,r,D<<24>>24!=0,j);D=f[q>>2]|0;if(D|0){A=f[x>>2]|0;if((A|0)==(D|0))J=D;else{B=A;while(1){A=B+-12|0;f[x>>2]=A;C=f[A>>2]|0;if(!C)K=A;else{A=B+-8|0;y=f[A>>2]|0;if((y|0)!=(C|0))f[A>>2]=y+(~((y+-4-C|0)>>>2)<<2);cYc(C);K=f[x>>2]|0}if((K|0)==(D|0))break;else B=K}J=f[q>>2]|0}cYc(J)}J=f[o>>2]|0;if(J|0){K=f[z>>2]|0;if((K|0)!=(J|0))f[z>>2]=K+(~(((K+-24-J|0)>>>0)/24|0)*24|0);cYc(J)}J=f[m>>2]|0;if(J|0){K=f[v>>2]|0;if((K|0)==(J|0))L=J;else{z=K;do{K=z+-12|0;f[v>>2]=K;RBb(K,f[z+-8>>2]|0);z=f[v>>2]|0}while((z|0)!=(J|0));L=f[m>>2]|0}cYc(L)}f[l>>2]=0;L=l+4|0;f[L>>2]=0;f[l+8>>2]=0;J=(w|0)>0;do if(J){z=0;v=0;do{v=(SBb(a,(f[j>>2]|0)+(z*12|0)|0,(f[k>>2]|0)+(z*56|0)|0,l)|0)+v|0;z=z+1|0}while((z|0)<(w|0));if(v){f[m>>2]=1;f[m+4>>2]=1;f[m+8>>2]=v;f[m+12>>2]=7;S$(f[i>>2]|0,4,m,5);z=f[(f[i>>2]|0)+16>>2]|0;if(J){I=a+95|0;K=0;B=0;while(1){D=(TBb(a,K,z+(B*7<<2)|0,(f[j>>2]|0)+(K*12|0)|0,(f[k>>2]|0)+(K*56|0)|0,(f[l>>2]|0)+(K*12|0)|0,(b[I>>0]|0)!=0)|0)+B|0;K=K+1|0;if((K|0)>=(w|0)){M=D;break}else B=D}}else M=0;if((M|0)==(v|0)){eT(d,i);break}else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;B=$Xc(32)|0;f[o>>2]=B;f[o+8>>2]=-2147483616;f[o+4>>2]=16;E=B;F=448098;G=E+16|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[B+16>>0]=0;vM(-215,o,456135,447638,504)}}else N=32}else N=32;while(0);if((N|0)==32){f[m>>2]=-2147483648;f[m+4>>2]=2147483647;f[m+8>>2]=-2147483648;f[m+12>>2]=2147483647;f[m+16>>2]=-2147483648;f[m+20>>2]=2147483647;f[m+24>>2]=2;f[m+28>>2]=3;X$(o,f[i>>2]|0,m);p[r>>3]=0.0;f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;mR(o,q,fT()|0)|0;q=o+36|0;r=f[q>>2]|0;if(r|0?(m=r+12|0,r=f[m>>2]|0,f[m>>2]=r+-1,(r|0)==1):0)V$(o);f[q>>2]=0;q=o+16|0;r=o+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[r>>2]|0)>0){q=f[o+40>>2]|0;m=0;do{f[q+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[r>>2]|0))}r=f[o+44>>2]|0;if((r|0)!=(o+48|0))wL(r)}r=f[l>>2]|0;if(r|0){o=f[L>>2]|0;if((o|0)==(r|0))O=r;else{m=o;do{o=m+-12|0;f[L>>2]=o;cQa(o,f[m+-8>>2]|0);m=f[L>>2]|0}while((m|0)!=(r|0));O=f[l>>2]|0}cYc(O)}hx(k);k=f[j>>2]|0;if(k|0){O=f[c>>2]|0;if((O|0)==(k|0))P=k;else{l=O;do{O=l+-12|0;f[c>>2]=O;RBb(O,f[l+-8>>2]|0);l=f[c>>2]|0}while((l|0)!=(k|0));P=f[j>>2]|0}cYc(P)}hx(i);hx(h);u=g;return}function KBb(a,c){a=a|0;c=c|0;var d=0;switch(c|0){case 3:{d=1;break}case 2:{if((b[a+92>>0]|0)==0?(b[a+93>>0]|0)!=0:0)d=(b[a+94>>0]|0)==0;else d=0;break}default:d=0}return d|0}function LBb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function MBb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+32|0;d=g+16|0;h=g;i=f[c>>2]|0;j=i;if((((f[c+4>>2]|0)-i|0)/12|0)>>>0<=2){i=$Xc(32)|0;f[d>>2]=i;f[d+8>>2]=-2147483616;f[d+4>>2]=18;k=i;l=447829;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[i+18>>0]=0;vM(-215,d,456079,447638,209)}i=f[j>>2]|0;if((f[i>>2]|0)!=(f[f[j+12>>2]>>2]|0)){c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=28;k=c;l=447848;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[c+28>>0]=0;vM(-215,d,456079,447638,210)}c=f[j+24>>2]|0;n=(f[c+8>>2]|0)/4|0;o=Y(f[a+52>>2]<<2,n)|0;p=f[j+4>>2]|0;q=p-i|0;r=q>>2;if((i|0)!=(p|0)){if((q|0)<=0){p=$Xc(80)|0;f[d>>2]=p;f[d+8>>2]=-2147483568;f[d+4>>2]=70;k=p;l=454543;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[p+70>>0]=0;vM(-215,d,454614,454620,161)}if((q|0)>4){q=1;p=1;while(1){s=Y(f[i+(q<<2)>>2]|0,p)|0;q=q+1|0;if((q|0)>=(r|0)){t=s;break}else p=s}}else t=1}else t=0;if((o|0)!=(t|0)){t=$Xc(64)|0;f[d>>2]=t;f[d+8>>2]=-2147483584;f[d+4>>2]=55;k=t;l=447877;m=k+55|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[t+55>>0]=0;vM(-215,d,456079,447638,213)}t=Y(f[a+44>>2]|0,n)|0;n=f[j+16>>2]|0;o=f[j+12>>2]|0;j=n-o|0;p=j>>2;r=o;if((r|0)!=(n|0)){if((j|0)<=0){n=$Xc(80)|0;f[d>>2]=n;f[d+8>>2]=-2147483568;f[d+4>>2]=70;k=n;l=454543;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[n+70>>0]=0;vM(-215,d,454614,454620,161)}if((j|0)>4){j=1;n=1;while(1){o=Y(f[r+(j<<2)>>2]|0,n)|0;j=j+1|0;if((j|0)>=(p|0)){v=o;break}else n=o}}else v=1}else v=0;if((t|0)!=(v|0)){v=$Xc(64)|0;f[d>>2]=v;f[d+8>>2]=-2147483584;f[d+4>>2]=51;k=v;l=447933;m=k+51|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[v+51>>0]=0;vM(-215,d,456079,447638,214)}if((f[c+4>>2]|0)!=(2-(b[a+72>>0]|0)&255|0)){c=$Xc(64)|0;f[d>>2]=c;f[d+8>>2]=-2147483584;f[d+4>>2]=52;k=c;l=447985;m=k+52|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[c+52>>0]=0;vM(-215,d,456079,447638,215)}c=f[a+76>>2]|0;f[d>>2]=1;f[d+4>>2]=1;f[d+8>>2]=c;f[d+12>>2]=7;f[h>>2]=0;c=h+4|0;f[c>>2]=0;f[h+8>>2]=0;gOa(h,d,d+16|0);d=f[h>>2]|0;a=f[c>>2]|0;a:do if((d|0)==(a|0)){w=d;x=24}else{l=d;do{if((f[l>>2]|0)<0){w=l;x=24;break a}l=l+4|0}while((l|0)!=(a|0))}while(0);if((x|0)==24?(w|0)!=(a|0):0){x=w+4|0;if((x|0)==(a|0)){y=a;z=w}else{d=x;x=w;while(1){w=f[d>>2]|0;if((w|0)<0)A=x;else{f[x>>2]=w;A=x+4|0}d=d+4|0;if((d|0)==(a|0))break;else x=A}y=f[c>>2]|0;z=A}if((z|0)!=(y|0))f[c>>2]=y+(~((y+-4-z|0)>>>2)<<2)}z=e+4|0;y=f[z>>2]|0;A=f[e>>2]|0;x=y-A|0;a=(x|0)/12|0;d=A;A=y;if(x){if(a>>>0>1?(x=d+12|0,(A|0)!=(x|0)):0){d=A;while(1){A=d+-12|0;f[z>>2]=A;y=f[A>>2]|0;if(!y)B=A;else{A=d+-8|0;w=f[A>>2]|0;if((w|0)!=(y|0))f[A>>2]=w+(~((w+-4-y|0)>>>2)<<2);cYc(y);B=f[z>>2]|0}if((B|0)==(x|0))break;else d=B}}}else Nvb(e,1-a|0,h);a=f[h>>2]|0;if(!a){u=g;return 0}h=f[c>>2]|0;if((h|0)!=(a|0))f[c>>2]=h+(~((h+-4-a|0)>>>2)<<2);cYc(a);u=g;return 0}function NBb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;j=u;u=u+16|0;k=j;l=f[i>>2]|0;m=i+4|0;n=f[m>>2]|0;if((n|0)==(l|0))o=n;else{p=n;while(1){n=p+-12|0;f[m>>2]=n;RBb(n,f[p+-8>>2]|0);n=f[m>>2]|0;if((n|0)==(l|0)){o=n;break}else p=n}}if(!((e|0)==1|g^1)){p=$Xc(32)|0;f[k>>2]=p;f[k+8>>2]=-2147483616;f[k+4>>2]=18;l=p;n=448607;q=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(q|0));b[p+18>>0]=0;vM(-215,k,448626,447638,851)}k=f[i>>2]|0;p=(o-k|0)/12|0;n=k;if(p>>>0>=c>>>0){if(p>>>0>c>>>0?(k=n+(c*12|0)|0,(o|0)!=(k|0)):0){n=o;do{o=n+-12|0;f[m>>2]=o;RBb(o,f[n+-8>>2]|0);n=f[m>>2]|0}while((n|0)!=(k|0))}}else tCb(i,c-p|0);if((c|0)<=0){u=j;return}p=(d|0)>0;k=Y(d<<2,e)|0;n=(e|0)>0;m=a;a=0;while(1){o=f[i>>2]|0;l=o+(a*12|0)|0;if(p){q=o+(a*12|0)+4|0;r=o+(a*12|0)+4|0;s=o+(a*12|0)+8|0;o=0;do{t=Y(o,e)|0;if(n){v=0;do{w=g?-1:v;x=f[q>>2]|0;do if(x){y=q;z=x;a:while(1){A=z;while(1){if((f[A+16>>2]|0)>=(w|0))break;B=f[A+4>>2]|0;if(!B){C=y;break a}else A=B}z=f[A>>2]|0;if(!z){C=A;break}else y=A}if((C|0)!=(q|0)?(w|0)>=(f[C+16>>2]|0):0)break;else{D=r;E=x}while(1){y=f[E+16>>2]|0;if((w|0)<(y|0)){z=f[E>>2]|0;if(!z){F=28;break}else{G=E;H=z}}else{if((y|0)>=(w|0)){F=32;break}I=E+4|0;y=f[I>>2]|0;if(!y){F=31;break}else{G=I;H=y}}D=G;E=H}if((F|0)==28){F=0;J=E;K=E;F=33;break}else if((F|0)==31){F=0;J=E;K=I;F=33;break}else if((F|0)==32){F=0;J=E;K=D;F=33;break}}else{J=q;K=q;F=33}while(0);do if((F|0)==33){F=0;x=f[K>>2]|0;if(!x){y=$Xc(32)|0;f[y+16>>2]=w;f[y+20>>2]=0;f[y+24>>2]=0;f[y+28>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=J;f[K>>2]=y;z=f[f[l>>2]>>2]|0;if(!z)L=y;else{f[l>>2]=z;L=f[K>>2]|0}UQ(f[r>>2]|0,L);f[s>>2]=(f[s>>2]|0)+1;M=y}else M=x;x=M+20|0;y=M+24|0;z=f[y>>2]|0;B=f[x>>2]|0;N=(z-B|0)/24|0;O=z;if(N>>>0<d>>>0){vCb(x,d-N|0);break}if(N>>>0>d>>>0?(N=B+(d*24|0)|0,(O|0)!=(N|0)):0)f[y>>2]=O+(~(((O+-24-N|0)>>>0)/24|0)*24|0)}while(0);N=f[q>>2]|0;do if(N){O=r;y=N;while(1){B=f[y+16>>2]|0;if((w|0)<(B|0)){x=f[y>>2]|0;if(!x){F=46;break}else{P=y;Q=x}}else{if((B|0)>=(w|0)){F=50;break}R=y+4|0;B=f[R>>2]|0;if(!B){F=49;break}else{P=R;Q=B}}O=P;y=Q}if((F|0)==46){F=0;S=y;T=y;break}else if((F|0)==49){F=0;S=y;T=R;break}else if((F|0)==50){F=0;S=y;T=O;break}}else{S=q;T=q}while(0);N=f[T>>2]|0;if(!N){B=$Xc(32)|0;f[B+16>>2]=w;f[B+20>>2]=0;f[B+24>>2]=0;f[B+28>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=S;f[T>>2]=B;x=f[f[l>>2]>>2]|0;if(!x)U=B;else{f[l>>2]=x;U=f[T>>2]|0}UQ(f[r>>2]|0,U);f[s>>2]=(f[s>>2]|0)+1;V=B}else V=N;N=f[V+20>>2]|0;B=N+(o*24|0)|0;x=v+t<<2;z=f[m+(x<<2)>>2]|0;W=x|1;X=x|2;if(h){f[N+(o*24|0)+4>>2]=z;f[B>>2]=f[m+(W<<2)>>2];f[N+(o*24|0)+12>>2]=f[m+(X<<2)>>2];Z=N+(o*24|0)+8|0}else{f[B>>2]=z;f[N+(o*24|0)+4>>2]=f[m+(W<<2)>>2];f[N+(o*24|0)+8>>2]=f[m+(X<<2)>>2];Z=N+(o*24|0)+12|0}f[Z>>2]=f[m+((x|3)<<2)>>2];v=v+1|0}while((v|0)!=(e|0))}o=o+1|0}while((o|0)!=(d|0))}a=a+1|0;if((a|0)==(c|0))break;else m=m+(k<<2)|0}u=j;return}function OBb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+56|0;i=g;f[h>>2]=d;f[h+4>>2]=c;j=(b|0)>0;if(!j){u=g;return}k=i+4|0;l=i+8|0;m=i+40|0;n=i+48|0;o=i+44|0;p=i+52|0;q=e+4|0;r=e+8|0;s=i+12|0;t=i+16|0;v=i+20|0;w=i+24|0;x=i+28|0;y=i+32|0;z=i+36|0;A=i+44|0;B=0;do{f[i>>2]=1124007936;C=k;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[m>>2]=l;f[o>>2]=n;f[n>>2]=0;f[p>>2]=0;S$(i,2,h,5);E=f[q>>2]|0;if(E>>>0>=(f[r>>2]|0)>>>0){XLa(e,i);F=f[z>>2]|0;if(F|0?(G=F+12|0,F=f[G>>2]|0,f[G>>2]=F+-1,(F|0)==1):0)V$(i)}else{f[E>>2]=f[i>>2];f[E+4>>2]=f[k>>2];F=E+8|0;f[F>>2]=f[l>>2];f[E+12>>2]=f[s>>2];f[E+16>>2]=f[t>>2];f[E+20>>2]=f[v>>2];f[E+24>>2]=f[w>>2];f[E+28>>2]=f[x>>2];f[E+32>>2]=f[y>>2];f[E+36>>2]=f[z>>2];G=E+40|0;f[G>>2]=F;F=E+44|0;H=E+48|0;f[F>>2]=H;I=E+52|0;f[I>>2]=0;f[H>>2]=0;if((f[k>>2]|0)<3){J=f[A>>2]|0;f[H>>2]=f[J>>2];f[I>>2]=f[J+4>>2]}else{f[F>>2]=f[A>>2];f[G>>2]=f[m>>2];f[A>>2]=n;f[m>>2]=l}f[i>>2]=1124007936;C=k;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[q>>2]=E+56}f[z>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[k>>2]|0)>0){C=f[m>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[k>>2]|0))}D=f[o>>2]|0;if((D|0)!=(n|0))wL(D);B=B+1|0}while((B|0)<(b|0));if(!j){u=g;return}j=i+4|0;B=i+8|0;n=i+12|0;o=i+16|0;k=i+20|0;m=i+24|0;t=i+28|0;z=i+32|0;q=i+36|0;l=i+40|0;A=i+48|0;y=i+44|0;x=i+52|0;w=(d|0)>0;v=(c|0)>0;s=Y(d,c)|0;r=0;h=a;while(1){a=f[e>>2]|0;p=a+(r*56|0)|0;f[i>>2]=f[p>>2];D=a+(r*56|0)+4|0;f[j>>2]=f[D>>2];f[B>>2]=f[a+(r*56|0)+8>>2];f[n>>2]=f[a+(r*56|0)+12>>2];f[o>>2]=f[a+(r*56|0)+16>>2];f[k>>2]=f[a+(r*56|0)+20>>2];f[m>>2]=f[a+(r*56|0)+24>>2];f[t>>2]=f[a+(r*56|0)+28>>2];f[z>>2]=f[a+(r*56|0)+32>>2];C=f[a+(r*56|0)+36>>2]|0;f[q>>2]=C;f[l>>2]=B;f[y>>2]=A;f[A>>2]=0;f[x>>2]=0;if(C|0){E=C+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[a+(r*56|0)+44>>2]|0;a=f[y>>2]|0;f[a>>2]=f[D>>2];f[a+4>>2]=f[D+4>>2]}else{f[j>>2]=0;U$(i,p)}if(w?(p=f[o>>2]|0,v):0){D=f[f[y>>2]>>2]|0;a=0;do{E=p+(Y(D,a)|0)|0;C=0;do{G=h+((Y(C,d)|0)+a<<2)|0;f[E+(C<<2)>>2]=f[G>>2];C=C+1|0}while((C|0)!=(c|0));a=a+1|0}while((a|0)!=(d|0))}a=f[q>>2]|0;if(a|0?(D=a+12|0,a=f[D>>2]|0,f[D>>2]=a+-1,(a|0)==1):0)V$(i);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[j>>2]|0)>0){a=f[l>>2]|0;D=0;do{f[a+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[j>>2]|0))}D=f[y>>2]|0;if((D|0)!=(A|0))wL(D);r=r+1|0;if((r|0)>=(b|0))break;else h=h+(s<<2)|0}u=g;return}function PBb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[e>>2]|0;i=e+4|0;j=f[i>>2]|0;k=h;if((j|0)==(h|0))l=j;else{m=j+(~(((j+-24-k|0)>>>0)/24|0)*24|0)|0;f[i>>2]=m;l=m}m=f[c>>2]|0;j=(l-k|0)/24|0;if(m>>>0<=j>>>0){if(m>>>0<j>>>0?(k=h+(m*24|0)|0,(l|0)!=(k|0)):0)f[i>>2]=l+(~(((l+-24-k|0)>>>0)/24|0)*24|0)}else vCb(e,m-j|0);j=f[g>>2]|0;m=g+4|0;k=f[m>>2]|0;if((k|0)==(j|0)){o=k;p=j}else{l=k;while(1){k=l+-12|0;f[m>>2]=k;i=f[k>>2]|0;if(!i)q=k;else{k=l+-8|0;h=f[k>>2]|0;if((h|0)!=(i|0))f[k>>2]=h+(~((h+-4-i|0)>>>2)<<2);cYc(i);q=f[m>>2]|0}if((q|0)==(j|0))break;else l=q}o=q;p=f[g>>2]|0}q=f[c>>2]|0;l=(o-p|0)/12|0;j=p;if(q>>>0<=l>>>0){if(q>>>0<l>>>0?(p=j+(q*12|0)|0,(o|0)!=(p|0)):0){j=o;while(1){o=j+-12|0;f[m>>2]=o;i=f[o>>2]|0;if(!i)r=o;else{o=j+-8|0;h=f[o>>2]|0;if((h|0)!=(i|0))f[o>>2]=h+(~((h+-4-i|0)>>>2)<<2);cYc(i);r=f[m>>2]|0}if((r|0)==(p|0))break;else j=r}}}else yCb(g,q-l|0);l=f[c>>2]|0;q=(l|0)>0;if(!q)return;r=f[e>>2]|0;if(d){d=0;do{e=d<<2;j=f[a+(e<<2)>>2]|0;f[r+(d*24|0)>>2]=j;p=f[a+((e|1)<<2)>>2]|0;f[r+(d*24|0)+4>>2]=p;m=f[a+((e|2)<<2)>>2]|0;f[r+(d*24|0)+8>>2]=m;i=f[a+((e|3)<<2)>>2]|0;f[r+(d*24|0)+12>>2]=i;t=(f[s>>2]=m,+n[s>>2]);u=(f[s>>2]=j,+n[s>>2]);v=(f[s>>2]=i,+n[s>>2]);w=(f[s>>2]=p,+n[s>>2]);do if(!(t<u|v<w))if(!(b[r+(d*24|0)+16>>0]|0)){x=(t-u)*(v-w);break}else{x=+n[r+(d*24|0)+20>>2];break}else x=0.0;while(0);n[r+(d*24|0)+20>>2]=x;b[r+(d*24|0)+16>>0]=1;d=d+1|0}while((d|0)<(l|0))}else{d=0;do{p=d<<2;i=f[a+(p<<2)>>2]|0;f[r+(d*24|0)>>2]=i;j=f[a+((p|1)<<2)>>2]|0;f[r+(d*24|0)+4>>2]=j;m=f[a+((p|2)<<2)>>2]|0;f[r+(d*24|0)+8>>2]=m;e=f[a+((p|3)<<2)>>2]|0;f[r+(d*24|0)+12>>2]=e;x=(f[s>>2]=m,+n[s>>2]);w=(f[s>>2]=i,+n[s>>2]);v=(f[s>>2]=e,+n[s>>2]);u=(f[s>>2]=j,+n[s>>2]);do if(!(x<w|v<u))if(!(b[r+(d*24|0)+16>>0]|0)){y=(x-w+1.0)*(v-u+1.0);break}else{y=+n[r+(d*24|0)+20>>2];break}else y=0.0;while(0);n[r+(d*24|0)+20>>2]=y;b[r+(d*24|0)+16>>0]=1;d=d+1|0}while((d|0)<(l|0))}if(q){z=0;A=l}else return;do{l=A+z<<2;q=f[g>>2]|0;d=a+(l<<2)|0;r=q+(z*12|0)+4|0;j=f[r>>2]|0;e=f[q+(z*12|0)+8>>2]|0;if((j|0)==(e|0)){hw(q+(z*12|0)|0,d);i=f[g>>2]|0;B=f[i+(z*12|0)+4>>2]|0;C=f[i+(z*12|0)+8>>2]|0;D=i}else{f[j>>2]=f[d>>2];d=j+4|0;f[r>>2]=d;B=d;C=e;D=q}q=a+((l|1)<<2)|0;if((B|0)==(C|0)){hw(D+(z*12|0)|0,q);e=f[g>>2]|0;E=f[e+(z*12|0)+4>>2]|0;F=f[e+(z*12|0)+8>>2]|0;G=e}else{f[B>>2]=f[q>>2];q=B+4|0;f[D+(z*12|0)+4>>2]=q;E=q;F=C;G=D}q=a+((l|2)<<2)|0;if((E|0)==(F|0)){hw(G+(z*12|0)|0,q);e=f[g>>2]|0;H=f[e+(z*12|0)+4>>2]|0;I=f[e+(z*12|0)+8>>2]|0;J=e}else{f[E>>2]=f[q>>2];q=E+4|0;f[G+(z*12|0)+4>>2]=q;H=q;I=F;J=G}q=a+((l|3)<<2)|0;if((H|0)==(I|0))hw(J+(z*12|0)|0,q);else{f[H>>2]=f[q>>2];f[J+(z*12|0)+4>>2]=H+4}z=z+1|0;A=f[c>>2]|0}while((z|0)<(A|0));return}function QBb(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;p=u;u=u+16|0;q=p;r=p+4|0;if((((f[a+4>>2]|0)-(f[a>>2]|0)|0)/12|0|0)!=(e|0)){s=$Xc(32)|0;f[r>>2]=s;f[r+8>>2]=-2147483616;f[r+4>>2]=27;t=s;v=448359;w=t+27|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+27>>0]=0;vM(-215,r,448387,447638,776)}s=f[o>>2]|0;v=o+4|0;t=f[v>>2]|0;if((t|0)==(s|0)){x=t;y=s}else{w=t;do{t=w+-12|0;f[v>>2]=t;RBb(t,f[w+-8>>2]|0);w=f[v>>2]|0}while((w|0)!=(s|0));x=w;y=f[o>>2]|0}w=(x-y|0)/12|0;s=y;if(w>>>0>=e>>>0){if(w>>>0>e>>>0?(y=s+(e*12|0)|0,(x|0)!=(y|0)):0){s=x;do{x=s+-12|0;f[v>>2]=x;RBb(x,f[s+-8>>2]|0);s=f[v>>2]|0}while((s|0)!=(y|0))}}else tCb(o,e-w|0);if((e|0)<=0){u=p;return}w=(h|0)>0;y=(i|0)==-1;s=0;a:while(1){v=f[o>>2]|0;x=v+(s*12|0)|0;if(w){t=(f[a>>2]|0)+(s*12|0)+4|0;z=v+(s*12|0)+4|0;A=v+(s*12|0)+4|0;B=v+(s*12|0)+8|0;if(g){v=0;do{if(!y){C=f[t>>2]|0;if(!C){D=-1;E=49;break a}else{F=t;G=C}b:while(1){C=G;while(1){if((f[C+16>>2]|0)>=-1)break;H=f[C+4>>2]|0;if(!H){I=F;break b}else C=H}G=f[C>>2]|0;if(!G){I=C;break}else F=C}if((I|0)==(t|0)){D=-1;E=49;break a}if((f[I+16>>2]|0)>-1){D=-1;E=49;break a}H=I+20|0;J=f[z>>2]|0;do if(J){K=A;L=J;while(1){M=f[L+16>>2]|0;if((M|0)>-1){N=f[L>>2]|0;if(!N){E=33;break}else{O=L;P=N}}else{if((M|0)==-1){E=28;break}Q=L+4|0;M=f[Q>>2]|0;if(!M){E=30;break}else{O=Q;P=M}}K=O;L=P}if((E|0)==28){E=0;R=L;S=K;break}else if((E|0)==30){E=0;R=L;S=Q;break}else if((E|0)==33){E=0;R=L;S=L;break}}else{R=z;S=z}while(0);J=f[S>>2]|0;if(!J){C=$Xc(32)|0;f[C+16>>2]=-1;f[C+20>>2]=0;f[C+24>>2]=0;f[C+28>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=R;f[S>>2]=C;M=f[f[x>>2]>>2]|0;if(!M)T=C;else{f[x>>2]=M;T=f[S>>2]|0}UQ(f[A>>2]|0,T);f[B>>2]=(f[B>>2]|0)+1;U=C}else U=J;uCb(c,d,j,k,l,m,n,H,U+20|0)}v=v+1|0}while((v|0)<(h|0))}else{v=0;do{if((v|0)!=(i|0)){J=f[t>>2]|0;if(!J){D=v;E=49;break a}else{V=t;W=J}c:while(1){J=W;while(1){if((f[J+16>>2]|0)>=(v|0))break;C=f[J+4>>2]|0;if(!C){X=V;break c}else J=C}W=f[J>>2]|0;if(!W){X=J;break}else V=J}if((X|0)==(t|0)){D=v;E=49;break a}if((v|0)<(f[X+16>>2]|0)){D=v;E=49;break a}H=X+20|0;L=f[z>>2]|0;do if(L){K=A;C=L;while(1){M=f[C+16>>2]|0;if((v|0)<(M|0)){N=f[C>>2]|0;if(!N){E=54;break}else{Y=C;Z=N}}else{if((M|0)>=(v|0)){E=58;break}_=C+4|0;M=f[_>>2]|0;if(!M){E=57;break}else{Y=_;Z=M}}K=Y;C=Z}if((E|0)==54){E=0;$=C;aa=C;break}else if((E|0)==57){E=0;$=C;aa=_;break}else if((E|0)==58){E=0;$=C;aa=K;break}}else{$=z;aa=z}while(0);L=f[aa>>2]|0;if(!L){J=$Xc(32)|0;f[J+16>>2]=v;f[J+20>>2]=0;f[J+24>>2]=0;f[J+28>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=$;f[aa>>2]=J;M=f[f[x>>2]>>2]|0;if(!M)ba=J;else{f[x>>2]=M;ba=f[aa>>2]|0}UQ(f[A>>2]|0,ba);f[B>>2]=(f[B>>2]|0)+1;ca=J}else ca=L;uCb(c,d,j,k,l,m,n,H,ca+20|0)}v=v+1|0}while((v|0)<(h|0))}}s=s+1|0;if((s|0)>=(e|0)){E=14;break}}if((E|0)==14){u=p;return}else if((E|0)==49){f[q>>2]=D;DM(r,448184,q);vM(-2,r,448387,447638,791)}}function RBb(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;RBb(a,f[b>>2]|0);RBb(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0){c=b+24|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~(((d+-24-a|0)>>>0)/24|0)*24|0);cYc(a)}cYc(b);return}function SBb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0;g=u;u=u+192|0;h=g+176|0;i=g+16|0;j=g+8|0;k=g;l=g+168|0;m=g+44|0;o=g+32|0;p=g+112|0;q=g+20|0;r=g+56|0;s=m+4|0;f[s>>2]=0;t=m+8|0;f[t>>2]=0;v=m+4|0;f[m>>2]=v;w=a+44|0;x=f[w>>2]|0;do if((x|0)>0){y=a+56|0;z=d+8|0;A=h+4|0;B=l+4|0;C=o+4|0;D=o+8|0;E=h+8|0;F=h+4|0;G=p+36|0;H=p+16|0;I=p+4|0;J=p+40|0;K=p+44|0;L=p+48|0;M=a+48|0;N=c+4|0;O=a+93|0;P=a+80|0;Q=a+84|0;R=a+88|0;S=h+4|0;T=h+8|0;U=h+4|0;V=h+8|0;W=0;X=x;Y=0;while(1){if((Y|0)==(f[y>>2]|0)){Z=W;_=Y+1|0;$=X}else{if((Y|0)>=(f[z>>2]|0)){aa=7;break}ba=Y+1|0;f[h>>2]=Y;f[A>>2]=ba;f[l>>2]=-2147483648;f[B>>2]=2147483647;W$(p,d,h,l);f[o>>2]=0;f[C>>2]=0;f[D>>2]=0;ca=E;f[ca>>2]=0;f[ca+4>>2]=0;f[h>>2]=-2113732603;f[F>>2]=o;jR(p,h);ca=f[G>>2]|0;if(ca|0?(da=ca+12|0,ca=f[da>>2]|0,f[da>>2]=ca+-1,(ca|0)==1):0)V$(p);f[G>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[I>>2]|0)>0){ca=f[J>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[I>>2]|0))}da=f[K>>2]|0;if((da|0)!=(L|0))wL(da);ea=b[M>>0]|0?-1:Y;da=f[N>>2]|0;if(!da){aa=23;break}else{fa=N;ga=da}a:while(1){da=ga;while(1){if((f[da+16>>2]|0)>=(ea|0))break;ca=f[da+4>>2]|0;if(!ca){ha=fa;break a}else da=ca}ga=f[da>>2]|0;if(!ga){ha=da;break}else fa=da}if((ha|0)==(N|0)){aa=23;break}if((ea|0)<(f[ha+16>>2]|0)){aa=23;break}ia=+n[P>>2];ja=+n[Q>>2];ca=f[R>>2]|0;ka=f[v>>2]|0;la=(ka|0)==0;if(!(b[O>>0]|0)){do if(!la){ma=s;na=ka;while(1){oa=f[na+16>>2]|0;if((Y|0)<(oa|0)){pa=f[na>>2]|0;if(!pa){aa=62;break}else{qa=na;ra=pa}}else{if((oa|0)>=(Y|0)){aa=66;break}sa=na+4|0;oa=f[sa>>2]|0;if(!oa){aa=65;break}else{qa=sa;ra=oa}}ma=qa;na=ra}if((aa|0)==62){aa=0;ta=na;ua=na;break}else if((aa|0)==65){aa=0;ta=na;ua=sa;break}else if((aa|0)==66){aa=0;ta=na;ua=ma;break}}else{ta=v;ua=v}while(0);da=f[ua>>2]|0;if(!da){oa=$Xc(32)|0;f[oa+16>>2]=Y;f[oa+20>>2]=0;f[oa+24>>2]=0;f[oa+28>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=ta;f[ua>>2]=oa;pa=f[f[m>>2]>>2]|0;if(!pa)va=oa;else{f[m>>2]=pa;va=f[ua>>2]|0}UQ(f[s>>2]|0,va);f[t>>2]=(f[t>>2]|0)+1;wa=oa}else wa=da;da=wa+20|0;oa=ha+20|0;if((((f[ha+24>>2]|0)-(f[oa>>2]|0)|0)/24|0|0)!=((f[C>>2]|0)-(f[o>>2]|0)>>2|0)){aa=72;break}f[h>>2]=0;f[S>>2]=0;f[T>>2]=0;$Bb(o,ia,ca,h);pa=f[da>>2]|0;xa=wa+24|0;ya=f[xa>>2]|0;za=pa;Aa=ya+(~((ya+-4-za|0)>>>2)<<2)|0;if((ya|0)==(pa|0))Ba=pa;else{f[xa>>2]=Aa;Ba=Aa}Aa=f[S>>2]|0;ya=f[h>>2]|0;Ca=ya;b:do if((Aa|0)==(ya|0)){Da=Aa;Ea=Ca}else{Fa=wa+28|0;Ga=0;Ha=Ca;Ia=za;Ja=Ba;Ka=Ba;La=pa;while(1){Ma=f[Ha+(Ga<<3)+4>>2]|0;f[l>>2]=Ma;if((Ja-Ia|0)>0){Na=0;Oa=La;Pa=Ma;while(1){Ma=f[oa>>2]|0;Qa=+bCb(Ma+(Pa*24|0)|0,Ma+((f[Oa+(Na<<2)>>2]|0)*24|0)|0)<=ja;Ma=Na+1|0;Ra=f[xa>>2]|0;Sa=f[da>>2]|0;if(!(Qa&(Ma|0)<(Ra-Sa>>2|0)))break;Na=Ma;Oa=Sa;Pa=f[l>>2]|0}if(Qa){Ta=Ra;aa=85}}else{Ta=Ka;aa=85}do if((aa|0)==85){aa=0;if((Ta|0)==(f[Fa>>2]|0)){Tv(da,l);break}else{f[Ta>>2]=f[l>>2];f[xa>>2]=Ta+4;break}}while(0);Pa=Ga+1|0;Oa=f[S>>2]|0;Na=f[h>>2]|0;Sa=Na;if(Pa>>>0>=Oa-Na>>3>>>0){Da=Oa;Ea=Sa;break b}Oa=f[xa>>2]|0;Na=f[da>>2]|0;Ga=Pa;Ha=Sa;Ia=Na;Ja=Oa;Ka=Oa;La=Na}}while(0);da=Da;if(Ea|0){if((da|0)!=(Ea|0))f[S>>2]=da+(~((da+-8-Ea|0)>>>3)<<3);cYc(Ea)}}else{do if(!la){da=s;xa=ka;while(1){oa=f[xa+16>>2]|0;if((Y|0)<(oa|0)){pa=f[xa>>2]|0;if(!pa){aa=29;break}else{Ua=xa;Va=pa}}else{if((oa|0)>=(Y|0)){aa=33;break}Wa=xa+4|0;oa=f[Wa>>2]|0;if(!oa){aa=32;break}else{Ua=Wa;Va=oa}}da=Ua;xa=Va}if((aa|0)==29){aa=0;Xa=xa;Ya=xa;break}else if((aa|0)==32){aa=0;Xa=xa;Ya=Wa;break}else if((aa|0)==33){aa=0;Xa=xa;Ya=da;break}}else{Xa=v;Ya=v}while(0);ka=f[Ya>>2]|0;if(!ka){la=$Xc(32)|0;f[la+16>>2]=Y;f[la+20>>2]=0;f[la+24>>2]=0;f[la+28>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=Xa;f[Ya>>2]=la;oa=f[f[m>>2]>>2]|0;if(!oa)Za=la;else{f[m>>2]=oa;Za=f[Ya>>2]|0}UQ(f[s>>2]|0,Za);f[t>>2]=(f[t>>2]|0)+1;_a=la}else _a=ka;ka=_a+20|0;la=ha+20|0;if((((f[ha+24>>2]|0)-(f[la>>2]|0)|0)/24|0|0)!=((f[C>>2]|0)-(f[o>>2]|0)>>2|0)){aa=39;break}f[h>>2]=0;f[U>>2]=0;f[V>>2]=0;$Bb(o,ia,ca,h);oa=f[ka>>2]|0;pa=_a+24|0;za=f[pa>>2]|0;Ca=oa;Aa=za+(~((za+-4-Ca|0)>>>2)<<2)|0;if((za|0)==(oa|0))$a=oa;else{f[pa>>2]=Aa;$a=Aa}Aa=f[U>>2]|0;za=f[h>>2]|0;ya=za;c:do if((Aa|0)==(za|0)){ab=Aa;bb=ya}else{La=_a+28|0;Ka=0;Ja=ya;Ia=Ca;Ha=$a;Ga=$a;Fa=oa;while(1){ma=f[Ja+(Ka<<3)+4>>2]|0;f[l>>2]=ma;if((Ha-Ia|0)>0){na=0;Na=Fa;Oa=ma;while(1){ma=f[la>>2]|0;cb=+aCb(ma+(Oa*24|0)|0,ma+((f[Na+(na<<2)>>2]|0)*24|0)|0)<=ja;ma=na+1|0;db=f[pa>>2]|0;Sa=f[ka>>2]|0;if(!(cb&(ma|0)<(db-Sa>>2|0)))break;na=ma;Na=Sa;Oa=f[l>>2]|0}if(cb){eb=db;aa=52}}else{eb=Ga;aa=52}do if((aa|0)==52){aa=0;if((eb|0)==(f[La>>2]|0)){Tv(ka,l);break}else{f[eb>>2]=f[l>>2];f[pa>>2]=eb+4;break}}while(0);Oa=Ka+1|0;Na=f[U>>2]|0;na=f[h>>2]|0;Sa=na;if(Oa>>>0>=Na-na>>3>>>0){ab=Na;bb=Sa;break c}Na=f[pa>>2]|0;na=f[ka>>2]|0;Ka=Oa;Ja=Sa;Ia=na;Ha=Na;Ga=Na;Fa=na}}while(0);ka=ab;if(bb|0){if((ka|0)!=(bb|0))f[U>>2]=ka+(~((ka+-8-bb|0)>>>3)<<3);cYc(bb)}}ka=f[v>>2]|0;do if(ka){pa=s;la=ka;while(1){oa=f[la+16>>2]|0;if((Y|0)<(oa|0)){Ca=f[la>>2]|0;if(!Ca){aa=95;break}else{fb=la;gb=Ca}}else{if((oa|0)>=(Y|0)){aa=99;break}hb=la+4|0;oa=f[hb>>2]|0;if(!oa){aa=98;break}else{fb=hb;gb=oa}}pa=fb;la=gb}if((aa|0)==95){aa=0;ib=la;jb=la;break}else if((aa|0)==98){aa=0;ib=la;jb=hb;break}else if((aa|0)==99){aa=0;ib=la;jb=pa;break}}else{ib=v;jb=v}while(0);ka=f[jb>>2]|0;if(!ka){oa=$Xc(32)|0;f[oa+16>>2]=Y;f[oa+20>>2]=0;f[oa+24>>2]=0;f[oa+28>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=ib;f[jb>>2]=oa;Ca=f[f[m>>2]>>2]|0;if(!Ca)kb=oa;else{f[m>>2]=Ca;kb=f[jb>>2]|0}UQ(f[s>>2]|0,kb);f[t>>2]=(f[t>>2]|0)+1;lb=oa}else lb=ka;ka=((f[lb+24>>2]|0)-(f[lb+20>>2]|0)>>2)+W|0;oa=f[o>>2]|0;if(oa|0){Ca=f[C>>2]|0;if((Ca|0)!=(oa|0))f[C>>2]=Ca+(~((Ca+-4-oa|0)>>>2)<<2);cYc(oa)}Z=ka;_=ba;$=f[w>>2]|0}if((_|0)<($|0)){W=Z;X=$;Y=_}else{aa=3;break}}if((aa|0)==3){X=a+76|0;W=f[X>>2]|0;if(!((W|0)>-1&Z>>>0>W>>>0)){mb=Z;break}f[o>>2]=0;W=o+4|0;f[W>>2]=0;f[o+8>>2]=0;C=f[m>>2]|0;do if((C|0)!=(v|0)){U=d+8|0;V=h+4|0;S=l+4|0;T=q+4|0;O=q+8|0;R=h+8|0;Q=h+4|0;P=r+36|0;N=r+16|0;M=r+4|0;L=r+40|0;K=r+44|0;I=r+48|0;J=h+4|0;H=h+8|0;G=o+8|0;F=C;d:while(1){nb=f[F+16>>2]|0;E=F+20|0;if((nb|0)>=(f[U>>2]|0)){aa=115;break}f[h>>2]=nb;f[V>>2]=nb+1;f[l>>2]=-2147483648;f[S>>2]=2147483647;W$(r,d,h,l);f[q>>2]=0;f[T>>2]=0;f[O>>2]=0;D=R;f[D>>2]=0;f[D+4>>2]=0;f[h>>2]=-2113732603;f[Q>>2]=q;jR(r,h);D=f[P>>2]|0;if(D|0?(B=D+12|0,D=f[B>>2]|0,f[B>>2]=D+-1,(D|0)==1):0)V$(r);f[P>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[M>>2]|0)>0){D=f[L>>2]|0;B=0;do{f[D+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[M>>2]|0))}B=f[K>>2]|0;if((B|0)!=(I|0))wL(B);B=F+24|0;D=f[E>>2]|0;if((f[B>>2]|0)!=(D|0)){pa=0;la=D;do{D=f[la+(pa<<2)>>2]|0;A=f[q>>2]|0;if(D>>>0>=(f[T>>2]|0)-A>>2>>>0){aa=136;break d}f[h>>2]=f[A+(D<<2)>>2];f[J>>2]=nb;f[H>>2]=D;D=f[W>>2]|0;if(D>>>0<(f[G>>2]|0)>>>0){f[D>>2]=f[h>>2];f[D+4>>2]=f[h+4>>2];f[D+8>>2]=f[h+8>>2];f[W>>2]=(f[W>>2]|0)+12}else eCb(o,h);pa=pa+1|0;la=f[E>>2]|0}while(pa>>>0<(f[B>>2]|0)-la>>2>>>0)}la=f[q>>2]|0;if(la|0){B=f[T>>2]|0;if((B|0)!=(la|0))f[T>>2]=B+(~((B+-4-la|0)>>>2)<<2);cYc(la)}la=f[F+4>>2]|0;if(!la){B=F+8|0;pa=f[B>>2]|0;if((f[pa>>2]|0)==(F|0))ob=pa;else{pa=B;do{B=f[pa>>2]|0;pa=B+8|0;E=f[pa>>2]|0}while((f[E>>2]|0)!=(B|0));ob=E}}else{pa=la;while(1){E=f[pa>>2]|0;if(!E)break;else pa=E}ob=pa}if((ob|0)==(v|0)){aa=112;break}else F=ob}if((aa|0)==112){pb=f[o>>2]|0;qb=f[W>>2]|0;break}else if((aa|0)==115){f[i>>2]=nb;DM(h,448184,i);vM(-2,h,448233,447638,609)}else if((aa|0)==136){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;F=$Xc(32)|0;f[h>>2]=F;f[h+8>>2]=-2147483616;f[h+4>>2]=19;rb=F;sb=448339;tb=rb+19|0;do{b[rb>>0]=b[sb>>0]|0;rb=rb+1|0;sb=sb+1|0}while((rb|0)<(tb|0));b[F+19>>0]=0;vM(-215,h,448233,447638,614)}}else{pb=0;qb=0}while(0);f[h>>2]=619;dCb(pb,qb,h);C=f[X>>2]|0;T=f[W>>2]|0;G=f[o>>2]|0;H=(T-G|0)/12|0;J=G;I=T;if(C>>>0<=H>>>0)if(C>>>0<H>>>0?(K=J+(C*12|0)|0,(I|0)!=(K|0)):0){M=I+(~(((I+-12-K|0)>>>0)/12|0)*12|0)|0;f[W>>2]=M;ub=M;vb=G;wb=J}else{ub=T;vb=G;wb=J}else{fCb(o,C-H|0);H=f[o>>2]|0;ub=f[W>>2]|0;vb=H;wb=H}H=q+4|0;f[H>>2]=0;C=q+8|0;f[C>>2]=0;J=q+4|0;f[q>>2]=J;e:do if((ub|0)!=(vb|0)){G=0;T=wb;M=0;while(1){K=f[T+(G*12|0)+4>>2]|0;f[h>>2]=f[T+(G*12|0)+8>>2];do if(M){I=H;L=M;while(1){N=f[L+16>>2]|0;if((K|0)<(N|0)){P=f[L>>2]|0;if(!P){aa=162;break}else{xb=L;yb=P}}else{if((N|0)>=(K|0)){aa=166;break}zb=L+4|0;N=f[zb>>2]|0;if(!N){aa=165;break}else{xb=zb;yb=N}}I=xb;L=yb}if((aa|0)==162){aa=0;Ab=L;Bb=L;break}else if((aa|0)==165){aa=0;Ab=L;Bb=zb;break}else if((aa|0)==166){aa=0;Ab=L;Bb=I;break}}else{Ab=J;Bb=J}while(0);pa=f[Bb>>2]|0;if(!pa){N=$Xc(32)|0;f[N+16>>2]=K;f[N+20>>2]=0;f[N+24>>2]=0;f[N+28>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=Ab;f[Bb>>2]=N;P=f[f[q>>2]>>2]|0;if(!P)Cb=N;else{f[q>>2]=P;Cb=f[Bb>>2]|0}UQ(f[H>>2]|0,Cb);f[C>>2]=(f[C>>2]|0)+1;Db=N}else Db=pa;pa=Db+24|0;N=f[pa>>2]|0;if((N|0)==(f[Db+28>>2]|0))Tv(Db+20|0,h);else{f[N>>2]=f[h>>2];f[pa>>2]=N+4}N=G+1|0;pa=f[o>>2]|0;if(N>>>0>=(((f[W>>2]|0)-pa|0)/12|0)>>>0)break e;G=N;T=pa;M=f[J>>2]|0}}while(0);C=e+4|0;H=f[C>>2]|0;if((H|0)==(f[e+8>>2]|0))hCb(e,q);else{f[H+4>>2]=0;f[H+8>>2]=0;M=H+4|0;f[H>>2]=M;T=f[q>>2]|0;if((T|0)!=(J|0)){G=M;M=T;while(1){T=M+16|0;f[l>>2]=G;f[h>>2]=f[l>>2];gCb(H,h,T,T)|0;T=f[M+4>>2]|0;if(!T){F=M+8|0;pa=f[F>>2]|0;if((f[pa>>2]|0)==(M|0))Eb=pa;else{pa=F;do{F=f[pa>>2]|0;pa=F+8|0;N=f[pa>>2]|0}while((f[N>>2]|0)!=(F|0));Eb=N}}else{pa=T;while(1){N=f[pa>>2]|0;if(!N)break;else pa=N}Eb=pa}if((Eb|0)==(J|0))break;else M=Eb}}f[C>>2]=(f[C>>2]|0)+12}M=f[X>>2]|0;cQa(q,f[J>>2]|0);H=f[o>>2]|0;if(H|0){G=f[W>>2]|0;if((G|0)!=(H|0))f[W>>2]=G+(~(((G+-12-H|0)>>>0)/12|0)*12|0);cYc(H)}Fb=M;Gb=f[v>>2]|0;cQa(m,Gb);u=g;return Fb|0}else if((aa|0)==7){f[k>>2]=Y;DM(h,448115,k);vM(-2,h,448233,447638,584)}else if((aa|0)==23){f[j>>2]=ea;DM(h,448184,j);vM(-2,h,448233,447638,591)}else if((aa|0)==39){M=$Xc(32)|0;f[h>>2]=M;f[h+8>>2]=-2147483616;f[h+4>>2]=30;rb=M;sb=460516;tb=rb+30|0;do{b[rb>>0]=b[sb>>0]|0;rb=rb+1|0;sb=sb+1|0}while((rb|0)<(tb|0));b[M+30>>0]=0;vM(-215,h,448252,448261,72)}else if((aa|0)==72){Y=$Xc(32)|0;f[h>>2]=Y;f[h+8>>2]=-2147483616;f[h+4>>2]=30;rb=Y;sb=460516;tb=rb+30|0;do{b[rb>>0]=b[sb>>0]|0;rb=rb+1|0;sb=sb+1|0}while((rb|0)<(tb|0));b[Y+30>>0]=0;vM(-215,h,448252,448261,72)}}else mb=0;while(0);sb=e+4|0;rb=f[sb>>2]|0;if((rb|0)==(f[e+8>>2]|0)){hCb(e,m);Fb=mb;Gb=f[v>>2]|0;cQa(m,Gb);u=g;return Fb|0}f[rb+4>>2]=0;f[rb+8>>2]=0;e=rb+4|0;f[rb>>2]=e;tb=f[m>>2]|0;if((tb|0)!=(v|0)){aa=e;e=tb;while(1){tb=e+16|0;f[l>>2]=aa;f[h>>2]=f[l>>2];gCb(rb,h,tb,tb)|0;tb=f[e+4>>2]|0;if(!tb){j=e+8|0;ea=f[j>>2]|0;if((f[ea>>2]|0)==(e|0))Hb=ea;else{ea=j;do{j=f[ea>>2]|0;ea=j+8|0;k=f[ea>>2]|0}while((f[k>>2]|0)!=(j|0));Hb=k}}else{ea=tb;while(1){Y=f[ea>>2]|0;if(!Y)break;else ea=Y}Hb=ea}if((Hb|0)==(v|0))break;else e=Hb}}f[sb>>2]=(f[sb>>2]|0)+12;Fb=mb;Gb=f[v>>2]|0;cQa(m,Gb);u=g;return Fb|0}function TBb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0;j=u;u=u+192|0;k=j+32|0;l=j+24|0;m=j+16|0;o=j;p=j+184|0;q=j+60|0;r=j+48|0;s=j+36|0;t=j+128|0;v=j+72|0;f[q>>2]=0;w=q+4|0;f[w>>2]=0;f[q+8>>2]=0;f[r>>2]=0;x=r+4|0;f[x>>2]=0;f[r+8>>2]=0;y=f[h>>2]|0;z=h+4|0;a:do if((y|0)!=(z|0)){A=g+8|0;B=o+4|0;C=p+4|0;D=s+4|0;E=s+8|0;F=o+8|0;G=o+4|0;H=t+36|0;I=t+16|0;J=t+4|0;K=t+40|0;L=t+44|0;M=t+48|0;N=o+4|0;O=r+8|0;P=y;while(1){Q=f[P+16>>2]|0;if((f[A>>2]|0)<=(Q|0))break;f[o>>2]=Q;f[B>>2]=Q+1;f[p>>2]=-2147483648;f[C>>2]=2147483647;W$(t,g,o,p);f[s>>2]=0;f[D>>2]=0;f[E>>2]=0;R=F;f[R>>2]=0;f[R+4>>2]=0;f[o>>2]=-2113732603;f[G>>2]=s;jR(t,o);R=f[H>>2]|0;if(R|0?(S=R+12|0,R=f[S>>2]|0,f[S>>2]=R+-1,(R|0)==1):0)V$(t);f[H>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[J>>2]|0)>0){R=f[K>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[J>>2]|0))}S=f[L>>2]|0;if((S|0)!=(M|0))wL(S);S=P+20|0;R=(f[x>>2]|0)-(f[r>>2]|0)>>3;T=P+24|0;UBb(r,((f[T>>2]|0)-(f[S>>2]|0)>>2)+R|0);U=f[S>>2]|0;if((f[T>>2]|0)!=(U|0)){V=0;W=U;do{f[o>>2]=f[(f[s>>2]|0)+(f[W+(V<<2)>>2]<<2)>>2];f[N>>2]=V+R;U=f[x>>2]|0;if(U>>>0<(f[O>>2]|0)>>>0){X=o;Y=f[X+4>>2]|0;Z=U;f[Z>>2]=f[X>>2];f[Z+4>>2]=Y;f[x>>2]=(f[x>>2]|0)+8}else VBb(r,o);V=V+1|0;W=f[S>>2]|0}while(V>>>0<(f[T>>2]|0)-W>>2>>>0)}W=f[s>>2]|0;if(W|0){T=f[D>>2]|0;if((T|0)!=(W|0))f[D>>2]=T+(~((T+-4-W|0)>>>2)<<2);cYc(W)}W=f[P+4>>2]|0;if(!W){T=P+8|0;V=f[T>>2]|0;if((f[V>>2]|0)==(P|0))_=V;else{V=T;do{T=f[V>>2]|0;V=T+8|0;S=f[V>>2]|0}while((f[S>>2]|0)!=(T|0));_=S}}else{V=W;while(1){S=f[V>>2]|0;if(!S)break;else V=S}_=V}if((_|0)==(z|0))break a;else P=_}f[m>>2]=Q;DM(o,448115,m);vM(-2,o,448166,447638,522)}while(0);if(!i){i=f[r>>2]|0;m=f[x>>2]|0;f[o>>2]=620;XBb(i,m,o)}m=(f[x>>2]|0)-(f[r>>2]|0)>>3;i=f[w>>2]|0;Q=f[q>>2]|0;_=i-Q>>2;t=Q;y=i;if(m>>>0<=_>>>0)if(m>>>0<_>>>0?(P=t+(m<<2)|0,(y|0)!=(P|0)):0){D=y+(~((y+-4-P|0)>>>2)<<2)|0;f[w>>2]=D;$=D;aa=Q;ba=t}else{$=i;aa=Q;ba=t}else{CS(q,m-_|0);_=f[q>>2]|0;$=f[w>>2]|0;aa=_;ba=_}if(($|0)!=(aa|0)){aa=f[r>>2]|0;_=$-ba>>2;$=0;do{f[ba+(f[aa+($<<3)+4>>2]<<2)>>2]=$;$=$+1|0}while($>>>0<_>>>0)}_=f[h>>2]|0;b:do if((_|0)!=(z|0)){h=g+8|0;$=o+4|0;aa=p+4|0;ba=s+4|0;m=s+8|0;t=o+8|0;Q=o+4|0;i=v+36|0;D=v+16|0;P=v+4|0;y=v+40|0;O=v+44|0;N=v+48|0;M=a+48|0;L=e+4|0;ca=+(c|0);J=0;K=_;while(1){da=f[K+16>>2]|0;if((f[h>>2]|0)<=(da|0)){ea=50;break}f[o>>2]=da;f[$>>2]=da+1;f[p>>2]=-2147483648;f[aa>>2]=2147483647;W$(v,g,o,p);f[s>>2]=0;f[ba>>2]=0;f[m>>2]=0;I=t;f[I>>2]=0;f[I+4>>2]=0;f[o>>2]=-2113732603;f[Q>>2]=s;jR(v,o);I=f[i>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)V$(v);f[i>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[P>>2]|0)>0){I=f[y>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[P>>2]|0))}H=f[O>>2]|0;if((H|0)!=(N|0))wL(H);fa=b[M>>0]|0?-1:da;H=f[L>>2]|0;if(!H){ea=66;break}else{ga=L;ha=H}c:while(1){H=ha;while(1){if((f[H+16>>2]|0)>=(fa|0))break;I=f[H+4>>2]|0;if(!I){ia=ga;break c}else H=I}ha=f[H>>2]|0;if(!ha){ia=H;break}else ga=H}if((ia|0)==(L|0)){ea=66;break}if((fa|0)<(f[ia+16>>2]|0)){ea=66;break}I=f[K+24>>2]|0;V=f[K+20>>2]|0;G=V;if((I|0)==(V|0)){F=f[s>>2]|0;if(!F)ja=J;else{ka=J;la=F;ea=70}}else{F=f[q>>2]|0;E=f[ia+20>>2]|0;ma=+(da|0);C=f[s>>2]|0;B=I-V>>2;V=0;I=J;while(1){A=f[G+(V<<2)>>2]|0;W=(f[F+(I<<2)>>2]|0)*7|0;n[d+(W<<2)>>2]=ca;n[d+(W+1<<2)>>2]=ma;f[d+(W+2<<2)>>2]=f[C+(A<<2)>>2];f[d+(W+3<<2)>>2]=f[E+(A*24|0)>>2];f[d+(W+4<<2)>>2]=f[E+(A*24|0)+4>>2];f[d+(W+5<<2)>>2]=f[E+(A*24|0)+8>>2];f[d+(W+6<<2)>>2]=f[E+(A*24|0)+12>>2];V=V+1|0;A=I+1|0;if(V>>>0>=B>>>0){ka=A;la=C;ea=70;break}else I=A}}if((ea|0)==70){ea=0;I=f[ba>>2]|0;if((I|0)!=(la|0))f[ba>>2]=I+(~((I+-4-la|0)>>>2)<<2);cYc(la);ja=ka}I=f[K+4>>2]|0;if(!I){C=K+8|0;B=f[C>>2]|0;if((f[B>>2]|0)==(K|0))na=B;else{B=C;do{C=f[B>>2]|0;B=C+8|0;V=f[B>>2]|0}while((f[V>>2]|0)!=(C|0));na=V}}else{B=I;while(1){V=f[B>>2]|0;if(!V)break;else B=V}na=B}if((na|0)==(z|0)){oa=ja;break b}else{J=ja;K=na}}if((ea|0)==50){f[l>>2]=da;DM(o,448115,l);vM(-2,o,448166,447638,547)}else if((ea|0)==66){f[k>>2]=fa;DM(o,448184,k);vM(-2,o,448166,447638,552)}}else oa=0;while(0);o=f[r>>2]|0;if(o|0){r=f[x>>2]|0;if((r|0)!=(o|0))f[x>>2]=r+(~((r+-8-o|0)>>>3)<<3);cYc(o)}o=f[q>>2]|0;if(!o){u=j;return oa|0}q=f[w>>2]|0;if((q|0)!=(o|0))f[w>>2]=q+(~((q+-4-o|0)>>>2)<<2);cYc(o);u=j;return oa|0}function UBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function VBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function WBb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function XBb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-8|0;i=a+-4|0;j=g;while(1){k=j;b:while(1){l=k;m=b-l|0;n=m>>3;switch(n|0){case 2:{o=5;break a;break}case 3:{o=7;break a;break}case 4:{o=8;break a;break}case 5:{o=12;break a;break}case 1:case 0:{o=56;break a;break}default:{}}if((m|0)<56){o=14;break a}p=k+(((n|0)/2|0)<<3)|0;if((m|0)>7992){m=(n|0)/4|0;q=ZBb(k,k+(m<<3)|0,p,p+(m<<3)|0,h,c)|0}else q=YBb(k,p,h,c)|0;if(Mi[f[c>>2]&1023](k,p)|0){r=h;s=q;break}else t=h;while(1){v=t+-8|0;if((k|0)==(v|0))break;if(Mi[f[c>>2]&1023](v,p)|0){o=39;break b}else t=v}m=k+8|0;if(Mi[f[c>>2]&1023](k,h)|0)w=m;else{if((m|0)==(h|0)){o=56;break a}else x=m;while(1){if(Mi[f[c>>2]&1023](k,x)|0)break;m=x+8|0;if((m|0)==(h|0)){o=56;break a}else x=m}m=f[x>>2]|0;f[x>>2]=f[h>>2];f[h>>2]=m;m=x+4|0;n=f[m>>2]|0;f[m>>2]=f[i>>2];f[i>>2]=n;w=x+8|0}if((w|0)==(h|0)){o=56;break a}else{y=h;z=w}while(1){n=z;while(1){A=n+8|0;if(Mi[f[c>>2]&1023](k,n)|0){B=y;break}else n=A}while(1){C=B+-8|0;if(Mi[f[c>>2]&1023](k,C)|0)B=C;else break}if(n>>>0>=C>>>0){k=n;continue b}m=f[n>>2]|0;f[n>>2]=f[C>>2];f[C>>2]=m;m=n+4|0;D=B+-4|0;E=f[m>>2]|0;f[m>>2]=f[D>>2];f[D>>2]=E;y=C;z=A}}if((o|0)==39){o=0;E=f[k>>2]|0;f[k>>2]=f[v>>2];f[v>>2]=E;E=k+4|0;D=t+-4|0;m=f[E>>2]|0;f[E>>2]=f[D>>2];f[D>>2]=m;r=v;s=q+1|0}m=k+8|0;c:do if(m>>>0<r>>>0){D=p;E=r;F=m;G=s;while(1){H=F;while(1){I=H+8|0;if(Mi[f[c>>2]&1023](H,D)|0)H=I;else{J=E;break}}while(1){K=J+-8|0;if(Mi[f[c>>2]&1023](K,D)|0)break;else J=K}if(H>>>0>K>>>0){L=D;M=G;N=H;break c}n=f[H>>2]|0;f[H>>2]=f[K>>2];f[K>>2]=n;n=H+4|0;O=J+-4|0;P=f[n>>2]|0;f[n>>2]=f[O>>2];f[O>>2]=P;D=(D|0)==(H|0)?K:D;E=K;F=I;G=G+1|0}}else{L=p;M=s;N=m}while(0);if((N|0)!=(L|0)?Mi[f[c>>2]&1023](L,N)|0:0){m=f[N>>2]|0;f[N>>2]=f[L>>2];f[L>>2]=m;m=N+4|0;G=L+4|0;F=f[m>>2]|0;f[m>>2]=f[G>>2];f[G>>2]=F;Q=M+1|0}else Q=M;if(!Q){R=_Bb(k,N,c)|0;F=N+8|0;if(_Bb(F,a,c)|0){o=55;break}if(R){j=F;continue}}F=N;if((F-l|0)>=(b-F|0)){o=54;break}XBb(k,N,c);j=N+8|0}if((o|0)==54){o=0;XBb(N+8|0,a,c);g=k;a=N;continue}else if((o|0)==55){o=0;if(R){o=56;break}else{g=k;a=N;continue}}}if((o|0)==5){if(!(Mi[f[c>>2]&1023](h,k)|0)){u=d;return}N=f[k>>2]|0;f[k>>2]=f[h>>2];f[h>>2]=N;N=k+4|0;g=f[N>>2]|0;f[N>>2]=f[i>>2];f[i>>2]=g;u=d;return}else if((o|0)==7){YBb(k,k+8|0,h,c)|0;u=d;return}else if((o|0)==8){g=k+8|0;N=k+16|0;YBb(k,g,N,c)|0;if(!(Mi[f[c>>2]&1023](h,N)|0)){u=d;return}R=f[N>>2]|0;f[N>>2]=f[h>>2];f[h>>2]=R;R=k+20|0;l=f[R>>2]|0;f[R>>2]=f[i>>2];f[i>>2]=l;if(!(Mi[f[c>>2]&1023](N,g)|0)){u=d;return}l=f[g>>2]|0;f[g>>2]=f[N>>2];f[N>>2]=l;l=k+12|0;N=f[l>>2]|0;f[l>>2]=f[R>>2];f[R>>2]=N;if(!(Mi[f[c>>2]&1023](g,k)|0)){u=d;return}N=f[k>>2]|0;f[k>>2]=f[g>>2];f[g>>2]=N;N=k+4|0;g=f[N>>2]|0;f[N>>2]=f[l>>2];f[l>>2]=g;u=d;return}else if((o|0)==12){ZBb(k,k+8|0,k+16|0,k+24|0,h,c)|0;u=d;return}else if((o|0)==14){h=k+16|0;YBb(k,k+8|0,h,c)|0;g=k+24|0;if((g|0)==(a|0)){u=d;return}l=e+4|0;N=g;g=h;while(1){if(Mi[f[c>>2]&1023](N,g)|0){h=N;R=f[h+4>>2]|0;i=e;f[i>>2]=f[h>>2];f[i+4>>2]=R;R=g;i=N;while(1){f[i>>2]=f[R>>2];S=R+4|0;f[i+4>>2]=f[S>>2];if((R|0)==(k|0))break;h=R+-8|0;if(Mi[f[c>>2]&1023](e,h)|0){Q=R;R=h;i=Q}else break}f[R>>2]=f[e>>2];f[S>>2]=f[l>>2]}i=N+8|0;if((i|0)==(a|0))break;else{Q=N;N=i;g=Q}}u=d;return}else if((o|0)==56){u=d;return}}function YBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=Mi[f[d>>2]&1023](b,a)|0;g=Mi[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=e;e=b+4|0;i=c+4|0;j=f[e>>2]|0;f[e>>2]=f[i>>2];f[i>>2]=j;if(!(Mi[f[d>>2]&1023](b,a)|0)){h=1;return h|0}j=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=j;j=a+4|0;i=f[j>>2]|0;f[j>>2]=f[e>>2];f[e>>2]=i;h=2;return h|0}i=f[a>>2]|0;if(g){f[a>>2]=f[c>>2];f[c>>2]=i;g=a+4|0;e=c+4|0;j=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=j;h=1;return h|0}f[a>>2]=f[b>>2];f[b>>2]=i;i=a+4|0;a=b+4|0;j=f[i>>2]|0;f[i>>2]=f[a>>2];f[a>>2]=j;if(!(Mi[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=c+4|0;c=f[a>>2]|0;f[a>>2]=f[d>>2];f[d>>2]=c;h=2;return h|0}function ZBb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=YBb(a,b,c,g)|0;if(Mi[f[g>>2]&1023](d,c)|0){i=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=i;i=c+4|0;j=d+4|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;k=h+1|0;if(Mi[f[g>>2]&1023](c,b)|0){j=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=j;j=b+4|0;l=f[j>>2]|0;f[j>>2]=f[i>>2];f[i>>2]=l;if(Mi[f[g>>2]&1023](b,a)|0){l=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=l;l=a+4|0;i=f[l>>2]|0;f[l>>2]=f[j>>2];f[j>>2]=i;m=h+3|0}else m=h+2|0}else m=k}else m=h;if(!(Mi[f[g>>2]&1023](e,d)|0)){n=m;return n|0}h=f[d>>2]|0;f[d>>2]=f[e>>2];f[e>>2]=h;h=d+4|0;k=e+4|0;e=f[h>>2]|0;f[h>>2]=f[k>>2];f[k>>2]=e;if(!(Mi[f[g>>2]&1023](d,c)|0)){n=m+1|0;return n|0}e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=c+4|0;d=f[e>>2]|0;f[e>>2]=f[h>>2];f[h>>2]=d;if(!(Mi[f[g>>2]&1023](c,b)|0)){n=m+2|0;return n|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=b+4|0;c=f[d>>2]|0;f[d>>2]=f[e>>2];f[e>>2]=c;if(!(Mi[f[g>>2]&1023](b,a)|0)){n=m+3|0;return n|0}g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;a=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=a;n=m+4|0;return n|0}function _Bb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;switch(b-a>>3|0){case 2:{g=b+-8|0;if(!(Mi[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;f[a>>2]=f[g>>2];f[g>>2]=i;i=a+4|0;g=b+-4|0;j=f[i>>2]|0;f[i>>2]=f[g>>2];f[g>>2]=j;h=1;u=d;return h|0}case 3:{YBb(a,a+8|0,b+-8|0,c)|0;h=1;u=d;return h|0}case 4:{j=a+8|0;g=a+16|0;i=b+-8|0;YBb(a,j,g,c)|0;if(!(Mi[f[c>>2]&1023](i,g)|0)){h=1;u=d;return h|0}k=f[g>>2]|0;f[g>>2]=f[i>>2];f[i>>2]=k;k=a+20|0;i=b+-4|0;l=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=l;if(!(Mi[f[c>>2]&1023](g,j)|0)){h=1;u=d;return h|0}l=f[j>>2]|0;f[j>>2]=f[g>>2];f[g>>2]=l;l=a+12|0;g=f[l>>2]|0;f[l>>2]=f[k>>2];f[k>>2]=g;if(!(Mi[f[c>>2]&1023](j,a)|0)){h=1;u=d;return h|0}g=f[a>>2]|0;f[a>>2]=f[j>>2];f[j>>2]=g;g=a+4|0;j=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=j;h=1;u=d;return h|0}case 5:{ZBb(a,a+8|0,a+16|0,a+24|0,b+-8|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{j=a+16|0;YBb(a,a+8|0,j,c)|0;l=a+24|0;a:do if((l|0)==(b|0)){m=1;n=0}else{g=e+4|0;k=l;i=0;o=j;while(1){if(Mi[f[c>>2]&1023](k,o)|0){p=k;q=f[p+4>>2]|0;r=e;f[r>>2]=f[p>>2];f[r+4>>2]=q;q=o;r=k;while(1){f[r>>2]=f[q>>2];s=q+4|0;f[r+4>>2]=f[s>>2];if((q|0)==(a|0))break;p=q+-8|0;if(Mi[f[c>>2]&1023](e,p)|0){t=q;q=p;r=t}else break}f[q>>2]=f[e>>2];f[s>>2]=f[g>>2];r=i+1|0;if((r|0)==8){m=0;n=(k+8|0)==(b|0);break a}else v=r}else v=i;r=k+8|0;if((r|0)==(b|0)){m=1;n=0;break}else{t=k;k=r;i=v;o=t}}}while(0);h=n|m;u=d;return h|0}}return 0}function $Bb(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+32|0;g=e;h=e+20|0;i=e+16|0;j=e+12|0;k=e+8|0;l=a+4|0;m=f[l>>2]|0;o=f[a>>2]|0;if((m|0)==(o|0))p=d+4|0;else{q=g+4|0;r=d+4|0;s=d+8|0;t=o;o=m;m=0;while(1){v=t;if(+n[v+(m<<2)>>2]>b){f[g>>2]=f[v+(m<<2)>>2];f[q>>2]=m;v=f[r>>2]|0;if(v>>>0<(f[s>>2]|0)>>>0){w=g;x=f[w+4>>2]|0;y=v;f[y>>2]=f[w>>2];f[y+4>>2]=x;f[r>>2]=(f[r>>2]|0)+8}else VBb(d,g);z=f[a>>2]|0;A=f[l>>2]|0}else{z=t;A=o}m=m+1|0;if(m>>>0>=A-z>>2>>>0){p=r;break}else{t=z;o=A}}}A=f[d>>2]|0;o=f[p>>2]|0;f[i>>2]=621;z=o-A|0;t=z>>3;if((z|0)>0){z=(t|0)<268435455?t:268435455;while(1){r=aYc(z<<3,1165590)|0;if(r|0){B=r;C=z;break}z=z>>>1;if(!z){B=0;C=0;break}}D=B;E=C;F=B}else{D=0;E=0;F=0}f[j>>2]=A;f[k>>2]=o;f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];oCb(h,g,i,t,D,E);if(D|0)cYc(F);if((c|0)<=0){u=e;return}F=f[p>>2]|0;D=f[d>>2]|0;E=F-D>>3;if((E|0)<=(c|0)){u=e;return}t=F;if(E>>>0<c>>>0){pCb(d,c-E|0);u=e;return}if(E>>>0<=c>>>0){u=e;return}E=D+(c<<3)|0;if((t|0)==(E|0)){u=e;return}f[p>>2]=t+(~((t+-8-E|0)>>>3)<<3);u=e;return}function aCb(a,c){a=a|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=+n[a>>2];e=+n[c>>2];f=d<e?e:d;g=+n[c+8>>2];h=+n[a+8>>2];i=g<h?g:h;if(i<f){j=0.0;return +j}k=+n[c+12>>2];l=+n[a+12>>2];m=k<l?k:l;o=+n[a+4>>2];p=+n[c+4>>2];q=o<p?p:o;if(m<q){j=0.0;return +j}r=(i-f)*(m-q);if(!(r>0.0)){j=0.0;return +j}do if(!(h<d|l<o))if(!(b[a+16>>0]|0)){s=(h-d)*(l-o);break}else{s=+n[a+20>>2];break}else s=0.0;while(0);do if(!(g<e|k<p))if(!(b[c+16>>0]|0)){t=(g-e)*(k-p);break}else{t=+n[c+20>>2];break}else t=0.0;while(0);j=r/(s+t-r);return +j}function bCb(a,c){a=a|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=+n[a>>2];e=+n[c>>2];f=d<e?e:d;g=+n[c+8>>2];h=+n[a+8>>2];i=g<h?g:h;if(i<f){j=0.0;return +j}k=+n[c+12>>2];l=+n[a+12>>2];m=k<l?k:l;o=+n[a+4>>2];p=+n[c+4>>2];q=o<p?p:o;if(m<q){j=0.0;return +j}r=(i-f+1.0)*(m-q+1.0);if(!(r>0.0)){j=0.0;return +j}do if(!(h<d|l<o))if(!(b[a+16>>0]|0)){s=(h-d+1.0)*(l-o+1.0);break}else{s=+n[a+20>>2];break}else s=0.0;while(0);do if(!(g<e|k<p))if(!(b[c+16>>0]|0)){t=(g-e+1.0)*(k-p+1.0);break}else{t=+n[c+20>>2];break}else t=0.0;while(0);j=r/(s+t-r);return +j}function cCb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function dCb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-12|0;i=a+-8|0;j=a+-4|0;k=g;while(1){l=k;b:while(1){m=l;n=b-m|0;switch((n|0)/12|0|0){case 2:{o=5;break a;break}case 3:{o=7;break a;break}case 4:{o=8;break a;break}case 5:{o=9;break a;break}case 1:case 0:{o=53;break a;break}default:{}}if((n|0)<84){o=11;break a}p=l+(((n>>>0)/24|0)*12|0)|0;if((n|0)>11988){q=(n>>>0)/48|0;r=lCb(l,l+(q*12|0)|0,p,p+(q*12|0)|0,h,c)|0}else r=jCb(l,p,h,c)|0;if(Mi[f[c>>2]&1023](l,p)|0){s=h;t=r;break}else v=h;while(1){w=v+-12|0;if((l|0)==(w|0))break;if(Mi[f[c>>2]&1023](w,p)|0){o=36;break b}else v=w}q=l+12|0;if(Mi[f[c>>2]&1023](l,h)|0)x=q;else{if((q|0)==(h|0)){o=53;break a}else y=q;while(1){if(Mi[f[c>>2]&1023](l,y)|0)break;q=y+12|0;if((q|0)==(h|0)){o=53;break a}else y=q}q=f[y>>2]|0;f[y>>2]=f[h>>2];f[h>>2]=q;q=y+4|0;n=f[q>>2]|0;f[q>>2]=f[i>>2];f[i>>2]=n;n=y+8|0;q=f[n>>2]|0;f[n>>2]=f[j>>2];f[j>>2]=q;x=y+12|0}if((x|0)==(h|0)){o=53;break a}else{z=h;A=x}while(1){q=A;while(1){B=q+12|0;if(Mi[f[c>>2]&1023](l,q)|0){C=z;break}else q=B}while(1){D=C+-12|0;if(Mi[f[c>>2]&1023](l,D)|0)C=D;else break}if(q>>>0>=D>>>0){l=q;continue b}n=f[q>>2]|0;f[q>>2]=f[D>>2];f[D>>2]=n;n=q+4|0;E=C+-8|0;F=f[n>>2]|0;f[n>>2]=f[E>>2];f[E>>2]=F;F=q+8|0;E=C+-4|0;n=f[F>>2]|0;f[F>>2]=f[E>>2];f[E>>2]=n;z=D;A=B}}if((o|0)==36){o=0;n=f[l>>2]|0;f[l>>2]=f[w>>2];f[w>>2]=n;n=l+4|0;E=v+-8|0;F=f[n>>2]|0;f[n>>2]=f[E>>2];f[E>>2]=F;F=l+8|0;E=v+-4|0;n=f[F>>2]|0;f[F>>2]=f[E>>2];f[E>>2]=n;s=w;t=r+1|0}n=l+12|0;c:do if(n>>>0<s>>>0){E=p;F=s;G=n;H=t;while(1){I=G;while(1){J=I+12|0;if(Mi[f[c>>2]&1023](I,E)|0)I=J;else{K=F;break}}while(1){L=K+-12|0;if(Mi[f[c>>2]&1023](L,E)|0)break;else K=L}if(I>>>0>L>>>0){M=E;N=H;O=I;break c}q=f[I>>2]|0;f[I>>2]=f[L>>2];f[L>>2]=q;q=I+4|0;P=K+-8|0;Q=f[q>>2]|0;f[q>>2]=f[P>>2];f[P>>2]=Q;Q=I+8|0;P=K+-4|0;q=f[Q>>2]|0;f[Q>>2]=f[P>>2];f[P>>2]=q;E=(E|0)==(I|0)?L:E;F=L;G=J;H=H+1|0}}else{M=p;N=t;O=n}while(0);if((O|0)!=(M|0)?Mi[f[c>>2]&1023](M,O)|0:0){n=f[O>>2]|0;f[O>>2]=f[M>>2];f[M>>2]=n;n=O+4|0;H=M+4|0;G=f[n>>2]|0;f[n>>2]=f[H>>2];f[H>>2]=G;G=O+8|0;H=M+8|0;n=f[G>>2]|0;f[G>>2]=f[H>>2];f[H>>2]=n;R=N+1|0}else R=N;if(!R){S=mCb(l,O,c)|0;n=O+12|0;if(mCb(n,a,c)|0){o=52;break}if(S){k=n;continue}}n=O;if((n-m|0)>=(b-n|0)){o=51;break}dCb(l,O,c);k=O+12|0}if((o|0)==51){o=0;dCb(O+12|0,a,c);g=l;a=O;continue}else if((o|0)==52){o=0;if(S){o=53;break}else{g=l;a=O;continue}}}if((o|0)==5){if(!(Mi[f[c>>2]&1023](h,l)|0)){u=d;return}O=f[l>>2]|0;f[l>>2]=f[h>>2];f[h>>2]=O;O=l+4|0;g=f[O>>2]|0;f[O>>2]=f[i>>2];f[i>>2]=g;g=l+8|0;i=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=i;u=d;return}else if((o|0)==7){jCb(l,l+12|0,h,c)|0;u=d;return}else if((o|0)==8){kCb(l,l+12|0,l+24|0,h,c)|0;u=d;return}else if((o|0)==9){lCb(l,l+12|0,l+24|0,l+36|0,h,c)|0;u=d;return}else if((o|0)==11){h=l+24|0;jCb(l,l+12|0,h,c)|0;i=l+36|0;if((i|0)==(a|0)){u=d;return}j=e+4|0;g=e+8|0;O=i;i=h;while(1){if(Mi[f[c>>2]&1023](O,i)|0){f[e>>2]=f[O>>2];f[e+4>>2]=f[O+4>>2];f[e+8>>2]=f[O+8>>2];h=i;S=O;while(1){f[S>>2]=f[h>>2];T=h+4|0;f[S+4>>2]=f[T>>2];U=h+8|0;f[S+8>>2]=f[U>>2];if((h|0)==(l|0))break;m=h+-12|0;if(Mi[f[c>>2]&1023](e,m)|0){R=h;h=m;S=R}else break}f[h>>2]=f[e>>2];f[T>>2]=f[j>>2];f[U>>2]=f[g>>2]}S=O+12|0;if((S|0)==(a|0))break;else{R=O;O=S;i=R}}u=d;return}else if((o|0)==53){u=d;return}}function eCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)kWc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;cYc(d);return}function fCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=g+(b*12|0);return}h=f[a>>2]|0;i=g-h|0;g=(i|0)/12|0;j=g+b|0;if(j>>>0>357913941)kWc(a);k=(d-h|0)/12|0;d=k<<1;l=k>>>0<178956970?(d>>>0<j>>>0?j:d):357913941;do if(l)if(l>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l*12|0)|0;break}else m=0;while(0);d=m+(g*12|0)|0;g1c(d|0,0,b*12|0)|0;g=d+(((i|0)/-12|0)*12|0)|0;if((i|0)>0)o1c(g|0,h|0,i|0)|0;f[a>>2]=g;f[e>>2]=d+(b*12|0);f[c>>2]=m+(l*12|0);if(!h)return;cYc(h);return}function gCb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;f[i>>2]=f[b>>2];f[g>>2]=f[i>>2];i=iCb(a,g,h,e+4|0,c)|0;c=f[i>>2]|0;if(c|0){j=c;u=e;return j|0}c=$Xc(32)|0;f[c+16>>2]=f[d>>2];eKa(c+20|0,d+4|0);d=f[h>>2]|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=d;f[i>>2]=c;d=f[f[a>>2]>>2]|0;if(!d)k=c;else{f[a>>2]=d;k=f[i>>2]|0}UQ(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;j=c;u=e;return j|0}function hCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[a>>2]|0;j=(h-i|0)/12|0;k=j+1|0;l=i;m=h;if(k>>>0>357913941)kWc(a);h=a+8|0;n=((f[h>>2]|0)-i|0)/12|0;i=n<<1;o=n>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(o)if(o>>>0>357913941){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{p=$Xc(o*12|0)|0;break}else p=0;while(0);i=p+(j*12|0)|0;k=i;n=p+(o*12|0)|0;f[p+(j*12|0)+4>>2]=0;f[p+(j*12|0)+8>>2]=0;o=p+(j*12|0)+4|0;f[i>>2]=o;j=f[b>>2]|0;p=b+4|0;if((j|0)==(p|0)){q=m;r=l}else{l=o;o=j;while(1){j=o+16|0;f[e>>2]=l;f[d>>2]=f[e>>2];gCb(i,d,j,j)|0;j=f[o+4>>2]|0;if(!j){m=o+8|0;b=f[m>>2]|0;if((f[b>>2]|0)==(o|0))s=b;else{b=m;do{m=f[b>>2]|0;b=m+8|0;t=f[b>>2]|0}while((f[t>>2]|0)!=(m|0));s=t}}else{b=j;while(1){t=f[b>>2]|0;if(!t)break;else b=t}s=b}if((s|0)==(p|0))break;else o=s}q=f[g>>2]|0;r=f[a>>2]|0}s=i+12|0;if((q|0)==(r|0)){v=k;w=q;x=q}else{o=q;q=k;k=i;do{i=k+-12|0;p=o;o=o+-12|0;f[i>>2]=f[o>>2];d=f[p+-8>>2]|0;f[k+-8>>2]=d;e=p+-4|0;l=f[e>>2]|0;f[k+-4>>2]=l;j=k+-8|0;if(!l)f[i>>2]=j;else{f[d+8>>2]=j;j=p+-8|0;f[o>>2]=j;f[j>>2]=0;f[e>>2]=0}k=q+-12|0;q=k}while((o|0)!=(r|0));v=q;w=f[a>>2]|0;x=f[g>>2]|0}f[a>>2]=v;f[g>>2]=s;f[h>>2]=n;n=w;if((x|0)!=(n|0)){h=x;do{x=h;h=h+-12|0;cQa(h,f[x+-8>>2]|0)}while((h|0)!=(n|0))}if(!w){u=c;return}cYc(w);u=c;return}function iCb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function jCb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=Mi[f[d>>2]&1023](b,a)|0;g=Mi[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=e;e=b+4|0;i=c+4|0;j=f[e>>2]|0;f[e>>2]=f[i>>2];f[i>>2]=j;j=b+8|0;i=c+8|0;k=f[j>>2]|0;f[j>>2]=f[i>>2];f[i>>2]=k;if(!(Mi[f[d>>2]&1023](b,a)|0)){h=1;return h|0}k=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=k;k=a+4|0;i=f[k>>2]|0;f[k>>2]=f[e>>2];f[e>>2]=i;i=a+8|0;e=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=e;h=2;return h|0}e=f[a>>2]|0;if(g){f[a>>2]=f[c>>2];f[c>>2]=e;g=a+4|0;j=c+4|0;i=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=i;i=a+8|0;j=c+8|0;g=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=g;h=1;return h|0}f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;g=b+4|0;j=f[e>>2]|0;f[e>>2]=f[g>>2];f[g>>2]=j;j=a+8|0;a=b+8|0;e=f[j>>2]|0;f[j>>2]=f[a>>2];f[a>>2]=e;if(!(Mi[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=c+4|0;b=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=b;b=c+8|0;c=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=c;h=2;return h|0}function kCb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=jCb(a,b,c,e)|0;if(!(Mi[f[e>>2]&1023](d,c)|0)){h=g;return h|0}i=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=i;i=c+4|0;j=d+4|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;k=c+8|0;j=d+8|0;d=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=d;if(!(Mi[f[e>>2]&1023](c,b)|0)){h=g+1|0;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=b+4|0;c=f[d>>2]|0;f[d>>2]=f[i>>2];f[i>>2]=c;c=b+8|0;i=f[c>>2]|0;f[c>>2]=f[k>>2];f[k>>2]=i;if(!(Mi[f[e>>2]&1023](b,a)|0)){h=g+2|0;return h|0}e=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;b=f[e>>2]|0;f[e>>2]=f[d>>2];f[d>>2]=b;b=a+8|0;a=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=a;h=g+3|0;return h|0}function lCb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=kCb(a,b,c,d,g)|0;if(!(Mi[f[g>>2]&1023](e,d)|0)){i=h;return i|0}j=f[d>>2]|0;f[d>>2]=f[e>>2];f[e>>2]=j;j=d+4|0;k=e+4|0;l=f[j>>2]|0;f[j>>2]=f[k>>2];f[k>>2]=l;l=d+8|0;k=e+8|0;e=f[l>>2]|0;f[l>>2]=f[k>>2];f[k>>2]=e;if(!(Mi[f[g>>2]&1023](d,c)|0)){i=h+1|0;return i|0}e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=c+4|0;d=f[e>>2]|0;f[e>>2]=f[j>>2];f[j>>2]=d;d=c+8|0;j=f[d>>2]|0;f[d>>2]=f[l>>2];f[l>>2]=j;if(!(Mi[f[g>>2]&1023](c,b)|0)){i=h+2|0;return i|0}j=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=j;j=b+4|0;c=f[j>>2]|0;f[j>>2]=f[e>>2];f[e>>2]=c;c=b+8|0;e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;if(!(Mi[f[g>>2]&1023](b,a)|0)){i=h+3|0;return i|0}g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;b=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=b;b=a+8|0;a=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=a;i=h+4|0;return i|0}function mCb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;switch((b-a|0)/12|0|0){case 2:{g=b+-12|0;if(!(Mi[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;f[a>>2]=f[g>>2];f[g>>2]=i;i=a+4|0;g=b+-8|0;j=f[i>>2]|0;f[i>>2]=f[g>>2];f[g>>2]=j;j=a+8|0;g=b+-4|0;i=f[j>>2]|0;f[j>>2]=f[g>>2];f[g>>2]=i;h=1;u=d;return h|0}case 3:{jCb(a,a+12|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 4:{kCb(a,a+12|0,a+24|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 5:{lCb(a,a+12|0,a+24|0,a+36|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{i=a+24|0;jCb(a,a+12|0,i,c)|0;g=a+36|0;a:do if((g|0)==(b|0)){k=1;l=0}else{j=e+4|0;m=e+8|0;n=g;o=0;p=i;while(1){if(Mi[f[c>>2]&1023](n,p)|0){f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];f[e+8>>2]=f[n+8>>2];q=p;r=n;while(1){f[r>>2]=f[q>>2];s=q+4|0;f[r+4>>2]=f[s>>2];t=q+8|0;f[r+8>>2]=f[t>>2];if((q|0)==(a|0))break;v=q+-12|0;if(Mi[f[c>>2]&1023](e,v)|0){w=q;q=v;r=w}else break}f[q>>2]=f[e>>2];f[s>>2]=f[j>>2];f[t>>2]=f[m>>2];r=o+1|0;if((r|0)==8){k=0;l=(n+12|0)==(b|0);break a}else x=r}else x=o;r=n+12|0;if((r|0)==(b|0)){k=1;l=0;break}else{w=n;n=r;o=x;p=w}}}while(0);h=l|k;u=d;return h|0}}return 0}function nCb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function oCb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;h=u;u=u+64|0;i=h;j=h+56|0;k=h+52|0;l=h+48|0;m=h+44|0;n=h+40|0;o=h+36|0;p=h+32|0;q=h+28|0;r=h+24|0;s=h+20|0;t=h+16|0;v=h+12|0;w=h+8|0;switch(d|0){case 2:{x=f[c>>2]|0;y=f[b>>2]|0;z=y+-8|0;f[b>>2]=z;A=f[a>>2]|0;if(!(Mi[x&1023](z,A)|0)){u=h;return}x=f[A>>2]|0;f[A>>2]=f[z>>2];f[z>>2]=x;x=A+4|0;A=y+-4|0;y=f[x>>2]|0;f[x>>2]=f[A>>2];f[A>>2]=y;u=h;return}case 1:case 0:{u=h;return}default:{if((d|0)<1){y=f[a>>2]|0;A=f[b>>2]|0;if((y|0)==(A|0)){u=h;return}x=y+8|0;if((x|0)==(A|0)){u=h;return}z=i+4|0;B=x;do{x=B;C=B;D=f[C>>2]|0;E=f[C+4>>2]|0;C=i;f[C>>2]=D;f[C+4>>2]=E;if((B|0)==(y|0)){F=x;G=D;H=E}else{E=x;x=B;while(1){D=x;x=x+-8|0;if(!(Mi[f[c>>2]&1023](i,x)|0)){I=E;break}C=E;f[E>>2]=f[x>>2];f[C+4>>2]=f[D+-4>>2];D=C+-8|0;if((x|0)==(y|0)){I=D;break}else E=D}F=I;G=f[i>>2]|0;H=f[z>>2]|0}f[F>>2]=G;f[F+4>>2]=H;B=B+8|0}while((B|0)!=(A|0));u=h;return}A=d>>>1;B=f[a>>2]|0;a=B+(A<<3)|0;H=B;if((d|0)>(g|0)){f[p>>2]=H;f[q>>2]=a;f[j>>2]=f[p>>2];f[i>>2]=f[q>>2];oCb(j,i,c,A,e,g);f[r>>2]=a;q=f[b>>2]|0;f[s>>2]=q;p=d-A|0;f[j>>2]=f[r>>2];f[i>>2]=f[s>>2];oCb(j,i,c,p,e,g);f[t>>2]=H;f[v>>2]=a;f[w>>2]=q;f[k>>2]=f[t>>2];f[j>>2]=f[v>>2];f[i>>2]=f[w>>2];rCb(k,j,i,c,A,p,e,g);u=h;return}f[l>>2]=H;f[m>>2]=a;f[j>>2]=f[l>>2];f[i>>2]=f[m>>2];qCb(j,i,c,A,e);f[n>>2]=a;f[o>>2]=f[b>>2];b=e+(A<<3)|0;f[j>>2]=f[n>>2];f[i>>2]=f[o>>2];qCb(j,i,c,d-A|0,b);A=e+(d<<3)|0;d=b;i=e;e=H;while(1){if((d|0)==(A|0))break;H=e;if(Mi[f[c>>2]&1023](d,i)|0){f[e>>2]=f[d>>2];J=d;K=d+8|0;L=i}else{f[e>>2]=f[i>>2];J=i;K=d;L=i+8|0}f[H+4>>2]=f[J+4>>2];M=H+8|0;if((L|0)==(b|0)){N=15;break}else{d=K;i=L;e=M}}if((N|0)==15){if((K|0)==(A|0)){u=h;return}else{O=K;P=M}while(1){f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2];O=O+8|0;if((O|0)==(A|0))break;else P=P+8|0}u=h;return}if((i|0)==(b|0)){u=h;return}P=i;i=e;while(1){f[i>>2]=f[P>>2];f[i+4>>2]=f[P+4>>2];P=P+8|0;if((P|0)==(b|0))break;else i=i+8|0}u=h;return}}}function pCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){g1c(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)kWc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;g1c(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;cYc(h);return}function qCb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+32|0;h=g+8|0;i=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;switch(d|0){case 1:{n=f[a>>2]|0;o=f[n+4>>2]|0;p=e;f[p>>2]=f[n>>2];f[p+4>>2]=o;u=g;return}case 2:{o=f[c>>2]|0;p=(f[b>>2]|0)+-8|0;f[b>>2]=p;n=Mi[o&1023](p,f[a>>2]|0)|0;p=f[(n?b:a)>>2]|0;o=f[p+4>>2]|0;q=e;f[q>>2]=f[p>>2];f[q+4>>2]=o;o=f[(n?a:b)>>2]|0;n=f[o+4>>2]|0;q=e+8|0;f[q>>2]=f[o>>2];f[q+4>>2]=n;u=g;return}case 0:{u=g;return}default:{if((d|0)<9){n=f[a>>2]|0;q=f[b>>2]|0;if((n|0)==(q|0)){u=g;return}o=n;p=f[o+4>>2]|0;r=e;f[r>>2]=f[o>>2];f[r+4>>2]=p;p=n+8|0;if((p|0)==(q|0)){u=g;return}else{s=p;t=e}do{p=t;t=t+8|0;if(Mi[f[c>>2]&1023](s,p)|0){n=p;r=f[n+4>>2]|0;o=t;f[o>>2]=f[n>>2];f[o+4>>2]=r;a:do if((p|0)==(e|0))v=e;else{r=p;while(1){o=r;r=r+-8|0;if(!(Mi[f[c>>2]&1023](s,r)|0)){v=o;break a}f[o>>2]=f[r>>2];f[o+4>>2]=f[o+-4>>2];if((r|0)==(e|0)){v=e;break}}}while(0);f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2]}else{p=s;r=f[p+4>>2]|0;o=t;f[o>>2]=f[p>>2];f[o+4>>2]=r}s=s+8|0}while((s|0)!=(q|0));u=g;return}q=d>>>1;s=f[a>>2]|0;a=s+(q<<3)|0;t=s;f[j>>2]=t;f[k>>2]=a;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];oCb(i,h,c,q,e,q);f[l>>2]=a;k=f[b>>2]|0;f[m>>2]=k;b=d-q|0;f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];oCb(i,h,c,b,e+(q<<3)|0,b);b=k;f[h>>2]=a;f[i>>2]=t;b:do if(q){if((a|0)==(b|0)){w=e;x=s}else{t=e;k=s;m=a;while(1){l=Mi[f[c>>2]&1023](m,k)|0;d=l?h:i;l=f[d>>2]|0;j=l;v=f[j+4>>2]|0;r=t;f[r>>2]=f[j>>2];f[r+4>>2]=v;f[d>>2]=l+8;l=t+8|0;d=f[i>>2]|0;m=f[h>>2]|0;if((d|0)==(a|0)){y=l;z=m;A=16;break b}if((m|0)==(b|0)){w=l;x=d;break}else{t=l;k=d}}}if((x|0)!=(a|0)){k=(a+-8-x|0)>>>3;t=w;m=x;while(1){d=m;l=f[d+4>>2]|0;v=t;f[v>>2]=f[d>>2];f[v+4>>2]=l;m=m+8|0;if((m|0)==(a|0))break;else t=t+8|0}f[i>>2]=x+(k+1<<3)}}else{y=e;z=s;A=16}while(0);if((A|0)==16?(z|0)!=(b|0):0){A=(b+-8-z|0)>>>3;s=y;y=z;while(1){e=y;x=f[e+4>>2]|0;i=s;f[i>>2]=f[e>>2];f[i+4>>2]=x;y=y+8|0;if((y|0)==(b|0))break;else s=s+8|0}f[h>>2]=z+(A+1<<3)}u=g;return}}}function rCb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;j=u;u=u+64|0;k=j+52|0;l=j;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+16|0;r=j+8|0;s=j+32|0;t=j+28|0;v=j+24|0;w=j+20|0;x=j+12|0;y=j+4|0;if(!g){u=j;return}z=e;e=g;a:while(1){if(!((e|0)>(i|0)&(z|0)>(i|0))){A=6;break}if(!z){A=37;break}B=f[b>>2]|0;g=B;C=z;D=f[a>>2]|0;while(1){if(Mi[f[d>>2]&1023](B,D)|0)break;E=D+8|0;f[a>>2]=E;F=C+-1|0;if(!F){A=37;break a}else{C=F;D=E}}E=D;if((C|0)<(e|0)){F=(e|0)/2|0;G=B+(F<<3)|0;f[r>>2]=G;H=g-E>>3;if(!H)I=D;else{J=H;H=D;K=D;while(1){L=(J|0)/2|0;M=K+(L<<3)|0;N=Mi[f[d>>2]&1023](G,M)|0;O=M+8|0;M=N?H:O;J=N?L:J+-1-L|0;if(!J){I=M;break}else{H=M;K=N?K:O}}}K=I;f[q>>2]=K;P=K-E>>3;Q=F;R=G;S=I}else{if((C|0)==1){A=14;break}K=(C|0)/2|0;H=D+(K<<3)|0;f[q>>2]=H;J=(f[c>>2]|0)-g>>3;if(!J)T=B;else{O=J;J=B;N=B;while(1){M=(O|0)/2|0;L=N+(M<<3)|0;U=Mi[f[d>>2]&1023](L,H)|0;V=L+8|0;L=U?V:J;O=U?O+-1-M|0:M;if(!O){T=L;break}else{J=L;N=U?V:N}}}N=T;f[r>>2]=N;P=K;Q=N-g>>3;R=T;S=H}N=C-P|0;J=e-Q|0;if((S|0)!=(B|0))if((B|0)==(R|0))W=S;else{f[l>>2]=g;O=S;G=l;F=k;b:while(1){f[F>>2]=f[G>>2];E=f[l>>2]|0;V=f[k>>2]|0;X=O;do{U=f[X>>2]|0;f[X>>2]=f[V>>2];f[V>>2]=U;U=X+4|0;L=V+4|0;M=f[U>>2]|0;f[U>>2]=f[L>>2];f[L>>2]=M;X=X+8|0;V=V+8|0;Y=(X|0)==(E|0);if((V|0)==(R|0))break b}while(!Y);f[k>>2]=V;O=E;G=k;F=l}f[k>>2]=R;if(!Y){F=k;G=l;O=X;while(1){f[F>>2]=f[G>>2];g=f[l>>2]|0;C=g;H=f[k>>2]|0;K=O;while(1){M=f[K>>2]|0;f[K>>2]=f[H>>2];f[H>>2]=M;M=K+4|0;L=H+4|0;U=f[M>>2]|0;f[M>>2]=f[L>>2];f[L>>2]=U;K=K+8|0;H=H+8|0;Z=(K|0)==(C|0);if((H|0)==(R|0)){A=30;break}if(Z){A=27;break}}if((A|0)==27){A=0;f[k>>2]=H;F=l;G=k;O=g;continue}else if((A|0)==30){A=0;f[k>>2]=R;if(Z)break;else{F=k;G=l;O=K;continue}}}}W=X}else W=R;f[b>>2]=W;O=W;if((P+Q|0)<(N+J|0)){f[s>>2]=f[a>>2];f[t>>2]=f[q>>2];f[v>>2]=O;f[m>>2]=f[s>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];rCb(m,l,k,d,P,Q,h,i);_=J;$=N;aa=r;ba=a}else{f[w>>2]=O;f[x>>2]=f[r>>2];f[y>>2]=f[c>>2];f[m>>2]=f[w>>2];f[l>>2]=f[x>>2];f[k>>2]=f[y>>2];rCb(m,l,k,d,N,J,h,i);_=Q;$=P;aa=q;ba=c}f[ba>>2]=O;f[b>>2]=f[aa>>2];if(!_){A=37;break}else{z=$;e=_}}if((A|0)==6){f[n>>2]=f[a>>2];f[o>>2]=f[b>>2];f[p>>2]=f[c>>2];f[m>>2]=f[n>>2];f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];sCb(m,l,k,d,z,e,h);u=j;return}else if((A|0)==14){h=f[D>>2]|0;f[D>>2]=f[B>>2];f[B>>2]=h;h=D+4|0;D=B+4|0;B=f[h>>2]|0;f[h>>2]=f[D>>2];f[D>>2]=B;u=j;return}else if((A|0)==37){u=j;return}}function sCb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+16|0;j=i+4|0;k=i;if((e|0)>(g|0)){g=f[b>>2]|0;e=g;l=f[c>>2]|0;if((e|0)==(l|0))m=h;else{n=((l+-8+(0-g)|0)>>>3)+1|0;o=h;p=g;q=e;while(1){r=p;s=f[r+4>>2]|0;t=o;f[t>>2]=f[r>>2];f[t+4>>2]=s;s=q+8|0;if((s|0)==(l|0))break;else{o=o+8|0;p=s;q=s}}m=h+(n<<3)|0}n=f[a>>2]|0;f[j>>2]=g;f[k>>2]=m;a:do if((m|0)!=(h|0)){if((e|0)==(n|0)){v=m;w=l}else{g=e;q=m;p=l;while(1){o=Mi[f[d>>2]&1023](g+-8|0,q+-8|0)|0;s=o?k:j;o=f[s>>2]|0;t=o+-8|0;r=p+-8|0;f[r>>2]=f[t>>2];f[p+-4>>2]=f[o+-4>>2];f[s>>2]=t;t=f[k>>2]|0;if((t|0)==(h|0))break a;g=f[j>>2]|0;if((g|0)==(n|0)){v=t;w=r;break}else{q=t;p=r}}}if((v|0)!=(h|0)){p=v;q=w;do{g=p;p=p+-8|0;r=q;q=q+-8|0;f[q>>2]=f[p>>2];f[r+-4>>2]=f[g+-4>>2]}while((p|0)!=(h|0))}}while(0);u=i;return}w=f[a>>2]|0;a=w;v=f[b>>2]|0;if((a|0)==(v|0)){u=i;return}b=((v+-8+(0-w)|0)>>>3)+1|0;n=h;j=w;k=a;while(1){a=j;l=f[a+4>>2]|0;m=n;f[m>>2]=f[a>>2];f[m+4>>2]=l;l=k+8|0;if((l|0)==(v|0))break;else{n=n+8|0;j=l;k=l}}k=h+(b<<3)|0;b=f[d>>2]|0;if((k|0)==(h|0)){u=i;return}d=f[c>>2]|0;c=h;h=w;w=v;while(1){if((w|0)==(d|0))break;v=h;if(Mi[b&1023](w,c)|0){f[h>>2]=f[w>>2];x=w;y=c;z=w+8|0}else{f[h>>2]=f[c>>2];x=c;y=c+8|0;z=w}f[v+4>>2]=f[x+4>>2];if((y|0)==(k|0)){A=25;break}else{c=y;h=v+8|0;w=z}}if((A|0)==25){u=i;return}A=c;c=h;while(1){f[c>>2]=f[A>>2];f[c+4>>2]=f[A+4>>2];A=A+8|0;if((A|0)==(k|0))break;else c=c+8|0}u=i;return}function tCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=i+4;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)kWc(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=h;g=k+(d*12|0)|0;d=b;b=i;k=h;do{f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=k+4;k=b+12|0;b=k;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;k=f[e>>2]|0;if((k|0)==(g|0)){l=i;m=g;n=g}else{j=k;k=i;i=h;do{h=i+-12|0;o=j;j=j+-12|0;f[h>>2]=f[j>>2];p=f[o+-8>>2]|0;f[i+-8>>2]=p;q=o+-4|0;r=f[q>>2]|0;f[i+-4>>2]=r;s=i+-8|0;if(!r)f[h>>2]=s;else{f[p+8>>2]=s;s=o+-8|0;f[j>>2]=s;f[s>>2]=0;f[q>>2]=0}i=k+-12|0;k=i}while((j|0)!=(g|0));l=k;m=f[a>>2]|0;n=f[e>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=d;d=m;if((n|0)!=(d|0)){c=n;do{n=c;c=c+-12|0;RBb(c,f[n+-8>>2]|0)}while((c|0)!=(d|0))}if(!m)return;cYc(m);return}function uCb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;l=u;u=u+16|0;m=l;n=(f[a+4>>2]|0)-(f[a>>2]|0)|0;o=(n|0)/24|0;p=f[c>>2]|0;q=p;if((o|0)!=(((f[c+4>>2]|0)-p|0)/12|0|0)){r=$Xc(48)|0;f[m>>2]=r;f[m+8>>2]=-2147483600;f[m+4>>2]=45;s=r;t=448403;v=s+45|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+45>>0]=0;vM(-215,m,448449,447638,745)}if((o|0)!=(((f[j+4>>2]|0)-(f[j>>2]|0)|0)/24|0|0)){r=$Xc(48)|0;f[m>>2]=r;f[m+8>>2]=-2147483600;f[m+4>>2]=36;s=r;t=448462;v=s+36|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+36>>0]=0;vM(-215,m,448449,447638,746)}if(n|0?((f[q+4>>2]|0)-(f[p>>2]|0)|0)!=16:0){p=$Xc(64)|0;f[m>>2]=p;f[m+8>>2]=-2147483584;f[m+4>>2]=49;s=p;t=448499;v=s+49|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[p+49>>0]=0;vM(-215,m,448449,447638,748)}m=f[k>>2]|0;p=k+4|0;t=f[p>>2]|0;s=m;if((t|0)==(m|0))w=t;else{v=t+(~(((t+-24-s|0)>>>0)/24|0)*24|0)|0;f[p>>2]=v;w=v}v=(w-s|0)/24|0;if(o>>>0<=v>>>0){if(o>>>0<v>>>0?(s=m+(o*24|0)|0,(w|0)!=(s|0)):0)f[p>>2]=w+(~(((w+-24-s|0)>>>0)/24|0)*24|0)}else vCb(k,o-v|0);v=(n|0)!=0;if(e){if(!v){u=l;return}e=0;do{wCb((f[a>>2]|0)+(e*24|0)|0,(f[c>>2]|0)+(e*12|0)|0,d,g,h,i,(f[j>>2]|0)+(e*24|0)|0,(f[k>>2]|0)+(e*24|0)|0);e=e+1|0}while(e>>>0<o>>>0);u=l;return}else{if(!v){u=l;return}v=0;do{xCb((f[a>>2]|0)+(v*24|0)|0,(f[c>>2]|0)+(v*12|0)|0,d,g,h,i,(f[j>>2]|0)+(v*24|0)|0,(f[k>>2]|0)+(v*24|0)|0);v=v+1|0}while(v>>>0<o>>>0);u=l;return}}function vCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/24|0)>>>0>=c>>>0){i=c;j=h;do{n[j+20>>2]=0.0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;b[j+16>>0]=0;j=(f[g>>2]|0)+24|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/24|0;h=j+c|0;if(h>>>0>178956970)kWc(a);k=(e-i|0)/24|0;i=k<<1;e=k>>>0<89478485?(i>>>0<h>>>0?h:i):178956970;do if(e)if(e>>>0>178956970){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e*24|0)|0;break}else l=0;while(0);i=l+(j*24|0)|0;j=l+(e*24|0)|0;e=c;c=i;l=i;do{n[l+20>>2]=0.0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;b[l+16>>0]=0;l=c+24|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(((l|0)/-24|0)*24|0)|0;if((l|0)>0)o1c(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;cYc(e);return}function wCb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0;c=u;u=u+16|0;k=c;l=+n[i>>2];m=+n[i+4>>2];o=+n[i+8>>2];p=+n[i+12>>2];i=d+11|0;q=b[i>>0]|0;r=d+4|0;t=f[r>>2]|0;do if(((q<<24>>24<0?t:q&255)|0)==6)if(!(LYc(d,0,-1,447762,6)|0)){v=l+ +n[a>>2];n[j>>2]=v;w=m+ +n[a+4>>2];n[j+4>>2]=w;x=o+ +n[a+8>>2];n[j+8>>2]=x;y=p+ +n[a+12>>2];z=v;A=w;B=x;break}else{C=b[i>>0]|0;D=f[r>>2]|0;E=5;break}else{C=q;D=t;E=5}while(0);do if((E|0)==5){if(((C<<24>>24<0?D:C&255)|0)!=11){F=$Xc(16)|0;f[k>>2]=F;G=k+8|0;f[G>>2]=-2147483632;H=k+4|0;f[H>>2]=13;I=F;J=448593;K=I+13|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));L=F+13|0;b[L>>0]=0;vM(-5,k,448565,447638,722)}if(LYc(d,0,-1,447750,11)|0){F=$Xc(16)|0;f[k>>2]=F;G=k+8|0;f[G>>2]=-2147483632;H=k+4|0;f[H>>2]=13;I=F;J=448593;K=I+13|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));L=F+13|0;b[L>>0]=0;vM(-5,k,448565,447638,722)}x=+n[a>>2];w=+n[a+8>>2]-x;v=+n[a+4>>2];M=+n[a+12>>2]-v;N=h?M:M+1.0;M=h?w:w+1.0;if(!(M>0.0)){t=$Xc(16)|0;f[k>>2]=t;f[k+8>>2]=-2147483632;f[k+4>>2]=15;I=t;J=448549;K=I+15|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[t+15>>0]=0;vM(-215,k,448565,447638,705)}if(N>0.0){w=N*+V(+p);O=l*M+(x+M*.5);P=M*+V(+o)*.5;Q=O-P;n[j>>2]=Q;R=m*N+(v+N*.5);S=w*.5;w=R-S;n[j+4>>2]=w;T=O+P;n[j+8>>2]=T;y=R+S;z=Q;A=w;B=T;break}else{q=$Xc(32)|0;f[k>>2]=q;f[k+8>>2]=-2147483616;f[k+4>>2]=16;I=q;J=448576;K=I+16|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[q+16>>0]=0;vM(-215,k,448565,447638,706)}}while(0);k=j+12|0;n[k>>2]=y;if(e){e=g+8|0;J=+n[e>>2]<z?e:j;I=f[(+n[J>>2]<+n[g>>2]?g:J)>>2]|0;f[j>>2]=I;J=j+4|0;K=g+12|0;a=+n[K>>2]<A?K:J;L=g+4|0;F=f[(+n[a>>2]<+n[L>>2]?L:a)>>2]|0;f[J>>2]=F;J=j+8|0;a=+n[e>>2]<B?e:J;e=f[(+n[a>>2]<+n[g>>2]?g:a)>>2]|0;f[J>>2]=e;J=+n[K>>2]<y?K:k;K=f[(+n[J>>2]<+n[L>>2]?L:J)>>2]|0;f[k>>2]=K;m=(f[s>>2]=e,+n[s>>2]);o=(f[s>>2]=I,+n[s>>2]);l=(f[s>>2]=K,+n[s>>2]);U=o;W=m;X=(f[s>>2]=F,+n[s>>2]);Y=l}else{U=z;W=B;X=A;Y=y}F=j+20|0;n[F>>2]=0.0;K=j+16|0;b[K>>0]=0;if(W<U|Y<X){Z=0.0;n[F>>2]=Z;b[K>>0]=1;u=c;return}y=W-U;U=Y-X;if(h){Z=y*U;n[F>>2]=Z;b[K>>0]=1;u=c;return}else{Z=(y+1.0)*(U+1.0);n[F>>2]=Z;b[K>>0]=1;u=c;return}}function xCb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0;k=u;u=u+16|0;l=k;m=f[c>>2]|0;o=+n[m>>2]*+n[i>>2];p=+n[m+4>>2]*+n[i+4>>2];q=+n[m+8>>2]*+n[i+8>>2];r=+n[m+12>>2]*+n[i+12>>2];i=d+11|0;m=b[i>>0]|0;c=d+4|0;t=f[c>>2]|0;do if(((m<<24>>24<0?t:m&255)|0)==6)if(!(LYc(d,0,-1,447762,6)|0)){v=o+ +n[a>>2];n[j>>2]=v;w=p+ +n[a+4>>2];n[j+4>>2]=w;x=q+ +n[a+8>>2];n[j+8>>2]=x;y=r+ +n[a+12>>2];z=v;A=w;B=x;break}else{C=b[i>>0]|0;D=f[c>>2]|0;E=5;break}else{C=m;D=t;E=5}while(0);do if((E|0)==5){if(((C<<24>>24<0?D:C&255)|0)!=11){F=$Xc(16)|0;f[l>>2]=F;G=l+8|0;f[G>>2]=-2147483632;H=l+4|0;f[H>>2]=13;I=F;J=448593;K=I+13|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));L=F+13|0;b[L>>0]=0;vM(-5,l,448565,447638,722)}if(LYc(d,0,-1,447750,11)|0){F=$Xc(16)|0;f[l>>2]=F;G=l+8|0;f[G>>2]=-2147483632;H=l+4|0;f[H>>2]=13;I=F;J=448593;K=I+13|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));L=F+13|0;b[L>>0]=0;vM(-5,l,448565,447638,722)}x=+n[a>>2];w=+n[a+8>>2]-x;v=+n[a+4>>2];M=+n[a+12>>2]-v;N=h?M:M+1.0;M=h?w:w+1.0;if(!(M>0.0)){t=$Xc(16)|0;f[l>>2]=t;f[l+8>>2]=-2147483632;f[l+4>>2]=15;I=t;J=448549;K=I+15|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[t+15>>0]=0;vM(-215,l,448565,447638,705)}if(N>0.0){w=N*+V(+r);O=o*M+(x+M*.5);P=M*+V(+q)*.5;Q=O-P;n[j>>2]=Q;R=p*N+(v+N*.5);S=w*.5;w=R-S;n[j+4>>2]=w;T=O+P;n[j+8>>2]=T;y=R+S;z=Q;A=w;B=T;break}else{m=$Xc(32)|0;f[l>>2]=m;f[l+8>>2]=-2147483616;f[l+4>>2]=16;I=m;J=448576;K=I+16|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[m+16>>0]=0;vM(-215,l,448565,447638,706)}}while(0);l=j+12|0;n[l>>2]=y;if(e){e=g+8|0;J=+n[e>>2]<z?e:j;I=f[(+n[J>>2]<+n[g>>2]?g:J)>>2]|0;f[j>>2]=I;J=j+4|0;K=g+12|0;a=+n[K>>2]<A?K:J;L=g+4|0;F=f[(+n[a>>2]<+n[L>>2]?L:a)>>2]|0;f[J>>2]=F;J=j+8|0;a=+n[e>>2]<B?e:J;e=f[(+n[a>>2]<+n[g>>2]?g:a)>>2]|0;f[J>>2]=e;J=+n[K>>2]<y?K:l;K=f[(+n[J>>2]<+n[L>>2]?L:J)>>2]|0;f[l>>2]=K;p=(f[s>>2]=e,+n[s>>2]);q=(f[s>>2]=I,+n[s>>2]);o=(f[s>>2]=K,+n[s>>2]);U=q;W=p;X=(f[s>>2]=F,+n[s>>2]);Y=o}else{U=z;W=B;X=A;Y=y}F=j+20|0;n[F>>2]=0.0;K=j+16|0;b[K>>0]=0;if(W<U|Y<X){Z=0.0;n[F>>2]=Z;b[K>>0]=1;u=k;return}y=W-U;U=Y-X;if(h){Z=y*U;n[F>>2]=Z;b[K>>0]=1;u=k;return}else{Z=(y+1.0)*(U+1.0);n[F>>2]=Z;b[K>>0]=1;u=k;return}}function yCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=d;g=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=j+-12|0;b=i;i=i+-12|0;f[d>>2]=0;n=j+-8|0;f[n>>2]=0;f[j+-4>>2]=0;f[d>>2]=f[i>>2];d=b+-8|0;f[n>>2]=f[d>>2];n=b+-4|0;f[j+-4>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[i>>2]=0;j=h+-12|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=c;c=c+-12|0;m=f[c>>2]|0;if(m|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(m|0))f[e>>2]=q+(~((q+-4-m|0)>>>2)<<2);cYc(m)}}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function zCb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(60)|0;ACb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=106984;f[b+12>>2]=c;f[a+4>>2]=b;return}function ACb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+80|0;e=d+40|0;g=d+32|0;h=d+24|0;i=d+16|0;j=d+8|0;k=d;l=d+68|0;m=d+56|0;n=d+44|0;qQa(a);f[a+44>>2]=0;o=a+48|0;f[o>>2]=0;f[a+52>>2]=0;f[a>>2]=107012;rQa(a,c);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;p=l+11|0;b[p>>0]=4;f[l>>2]=1936291937;b[l+4>>0]=0;q=LGa(c,l)|0;if((q|0)==(c+4|0))r=1;else{s=MGa(q+28|0,-1)|0;r=s}s=a+56|0;f[s>>2]=r;if((b[p>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;p=$Xc(16)|0;f[l>>2]=p;f[l+8>>2]=-2147483632;f[l+4>>2]=11;r=p;q=448883;t=r+11|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[p+11>>0]=0;p=(HIa(c,l)|0)==0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if(!p){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;p=l+11|0;b[p>>0]=5;b[l>>0]=b[448895]|0;b[l+1>>0]=b[448896]|0;b[l+2>>0]=b[448897]|0;b[l+3>>0]=b[448898]|0;b[l+4>>0]=b[448899]|0;b[l+5>>0]=0;if(!(HIa(c,l)|0)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;v=m+11|0;b[v>>0]=4;f[m>>2]=1702521203;b[m+4>>0]=0;if(!(HIa(c,m)|0)){w=n+4|0;f[w>>2]=0;f[w+4>>2]=0;w=n+11|0;b[w>>0]=3;b[n>>0]=b[448901]|0;b[n+1>>0]=b[448902]|0;b[n+2>>0]=b[448903]|0;b[n+3>>0]=0;x=(HIa(c,n)|0)==0;if((b[w>>0]|0)<0)cYc(f[n>>2]|0);y=x}else y=0;if((b[v>>0]|0)<0)cYc(f[m>>2]|0);z=y}else z=0;if((b[p>>0]|0)<0)cYc(f[l>>2]|0);if(!z){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;z=$Xc(80)|0;f[l>>2]=z;f[l+8>>2]=-2147483568;f[l+4>>2]=65;r=z;q=448905;t=r+65|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[z+65>>0]=0;vM(-215,l,448971,448986,66)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;z=$Xc(16)|0;f[l>>2]=z;f[l+8>>2]=-2147483632;f[l+4>>2]=11;r=z;q=448883;t=r+11|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[z+11>>0]=0;z=NIa(c,l)|0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);p=a+44|0;y=f[z>>2]|0;switch(y|0){case 0:{A=(f[z+4>>2]|0)+4|0;break}case 3:{A=(f[z+4>>2]|0)+4|0;break}case 2:{A=(f[z+4>>2]|0)+4|0;break}default:{f[k>>2]=y;DM(l,455363,k);vM(-3,l,470867,455383,297)}}k=(f[A>>2]|0)+1|0;A=(f[s>>2]|0)+1|0;f[l>>2]=0;y=l+4|0;f[y>>2]=0;f[l+8>>2]=0;if(A|0){if(A>>>0>536870911)kWc(l);v=$Xc(A<<3)|0;f[y>>2]=v;f[l>>2]=v;f[l+8>>2]=v+(A<<3);x=A;n=v;w=v;while(1){B=n;f[B>>2]=-2147483648;f[B+4>>2]=2147483647;B=w+8|0;C=x+-1|0;if(!C)break;else{x=C;n=B;w=B}}f[y>>2]=v+(A<<3)}A=f[o>>2]|0;v=f[p>>2]|0;w=(A-v|0)/12|0;n=v;v=A;if(k>>>0<=w>>>0){if(k>>>0<w>>>0?(A=n+(k*12|0)|0,(v|0)!=(A|0)):0){n=v;while(1){v=n+-12|0;f[o>>2]=v;x=f[v>>2]|0;if(!x)D=v;else{v=n+-8|0;B=f[v>>2]|0;if((B|0)!=(x|0))f[v>>2]=B+(~((B+-8-x|0)>>>3)<<3);cYc(x);D=f[o>>2]|0}if((D|0)==(A|0))break;else n=D}}}else FCb(p,k-w|0,l);w=f[l>>2]|0;if(w|0){k=f[y>>2]|0;if((k|0)!=(w|0))f[y>>2]=k+(~((k+-8-w|0)>>>3)<<3);cYc(w)}w=z+4|0;k=z+4|0;y=0;D=0;a:while(1){E=f[z>>2]|0;switch(E|0){case 0:{F=(f[w>>2]|0)+4|0;break}case 3:{F=(f[k>>2]|0)+4|0;break}case 2:{F=(f[k>>2]|0)+4|0;break}default:{G=51;break a}}if((y|0)>=(f[F>>2]|0))break;f[(f[(f[p>>2]|0)+(y*12|0)>>2]|0)+(f[s>>2]<<3)>>2]=D;n=MGa(z,y)|0;f[(f[(f[p>>2]|0)+(y*12|0)>>2]|0)+(f[s>>2]<<3)+4>>2]=n;y=y+1|0;D=n}if((G|0)==51){f[j>>2]=E;DM(l,455363,j);vM(-3,l,470867,455383,297)}f[(f[(f[o>>2]|0)+-12>>2]|0)+(f[s>>2]<<3)>>2]=D;u=d;return};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=l+11|0;b[D>>0]=5;b[l>>0]=b[448895]|0;b[l+1>>0]=b[448896]|0;b[l+2>>0]=b[448897]|0;b[l+3>>0]=b[448898]|0;b[l+4>>0]=b[448899]|0;b[l+5>>0]=0;s=(HIa(c,l)|0)==0;if((b[D>>0]|0)<0)cYc(f[l>>2]|0);if(s){u=d;return};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;s=l+11|0;b[s>>0]=4;f[l>>2]=1702521203;b[l+4>>0]=0;D=HIa(c,l)|0;j=m+4|0;f[j>>2]=0;f[j+4>>2]=0;j=m+11|0;b[j>>0]=3;b[m>>0]=b[448901]|0;b[m+1>>0]=b[448902]|0;b[m+2>>0]=b[448903]|0;b[m+3>>0]=0;E=(D|0)!=0^(HIa(c,m)|0)!=0;if((b[j>>0]|0)<0)cYc(f[m>>2]|0);if((b[s>>0]|0)<0)cYc(f[l>>2]|0);if(!E){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;E=$Xc(48)|0;f[l>>2]=E;f[l+8>>2]=-2147483600;f[l+4>>2]=38;r=E;q=449065;t=r+38|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[E+38>>0]=0;vM(-215,l,448971,448986,81)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;E=l+11|0;b[E>>0]=5;b[l>>0]=b[448895]|0;b[l+1>>0]=b[448896]|0;b[l+2>>0]=b[448897]|0;b[l+3>>0]=b[448898]|0;b[l+4>>0]=b[448899]|0;b[l+5>>0]=0;s=NIa(c,l)|0;if((b[E>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;E=l+11|0;b[E>>0]=4;f[l>>2]=1702521203;b[l+4>>0]=0;if(!(HIa(c,l)|0)){j=m+4|0;f[j>>2]=0;f[j+4>>2]=0;j=m+11|0;b[j>>0]=3;b[m>>0]=b[448901]|0;b[m+1>>0]=b[448902]|0;b[m+2>>0]=b[448903]|0;b[m+3>>0]=0;D=NIa(c,m)|0;if((b[j>>0]|0)<0)cYc(f[m>>2]|0);H=D}else{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;D=m+11|0;b[D>>0]=4;f[m>>2]=1702521203;b[m+4>>0]=0;j=NIa(c,m)|0;if((b[D>>0]|0)<0)cYc(f[m>>2]|0);H=j}if((b[E>>0]|0)<0)cYc(f[l>>2]|0);E=f[s>>2]|0;switch(E|0){case 0:{I=(f[s+4>>2]|0)+4|0;break}case 3:{I=(f[s+4>>2]|0)+4|0;break}case 2:{I=(f[s+4>>2]|0)+4|0;break}default:{f[i>>2]=E;DM(l,455363,i);vM(-3,l,470867,455383,297)}}i=f[I>>2]|0;I=f[H>>2]|0;switch(I|0){case 0:{J=(f[H+4>>2]|0)+4|0;break}case 3:{J=(f[H+4>>2]|0)+4|0;break}case 2:{J=(f[H+4>>2]|0)+4|0;break}default:{f[h>>2]=I;DM(l,455363,h);vM(-3,l,470867,455383,297)}}if((i|0)!=(f[J>>2]|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;J=$Xc(48)|0;f[l>>2]=J;f[l+8>>2]=-2147483600;f[l+4>>2]=35;r=J;q=449104;t=r+35|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[J+35>>0]=0;vM(-215,l,448971,448986,84)}J=a+44|0;a=f[o>>2]|0;i=f[J>>2]|0;h=a-i|0;I=(h|0)/12|0;E=i;i=a;if(h){if(I>>>0>1?(h=E+12|0,(i|0)!=(h|0)):0){E=i;while(1){i=E+-12|0;f[o>>2]=i;a=f[i>>2]|0;if(!a)K=i;else{i=E+-8|0;j=f[i>>2]|0;if((j|0)!=(a|0))f[i>>2]=j+(~((j+-8-a|0)>>>3)<<3);cYc(a);K=f[o>>2]|0}if((K|0)==(h|0))break;else E=K}}}else GCb(J,1-I|0);I=f[J>>2]|0;K=f[s>>2]|0;switch(K|0){case 0:{L=(f[s+4>>2]|0)+4|0;break}case 3:{L=(f[s+4>>2]|0)+4|0;break}case 2:{L=(f[s+4>>2]|0)+4|0;break}default:{f[g>>2]=K;DM(l,455363,g);vM(-3,l,470867,455383,297)}}g=f[L>>2]|0;f[l>>2]=-2147483648;f[l+4>>2]=2147483647;L=I+4|0;K=f[L>>2]|0;E=f[I>>2]|0;h=K-E>>3;o=E;E=K;if(g>>>0<=h>>>0){if(g>>>0<h>>>0?(K=o+(g<<3)|0,(E|0)!=(K|0)):0)f[L>>2]=E+(~((E+-8-K|0)>>>3)<<3)}else HCb(I,g-h|0,l);h=s+4|0;g=l+11|0;I=l+4|0;K=s+4|0;E=0;b:while(1){M=f[s>>2]|0;switch(M|0){case 0:{N=(f[h>>2]|0)+4|0;break}case 3:{N=(f[K>>2]|0)+4|0;break}case 2:{N=(f[K>>2]|0)+4|0;break}default:{G=111;break b}}if((E|0)>=(f[N>>2]|0)){G=124;break}L=MGa(s,E)|0;o=MGa(H,E)|0;if((L|0)<=-1){G=114;break}f[(f[f[J>>2]>>2]|0)+(E<<3)>>2]=L;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[g>>0]=4;f[l>>2]=1702521203;b[I>>0]=0;a=(HIa(c,l)|0)==0;if((b[g>>0]|0)<0)cYc(f[l>>2]|0);if(a)if((o|0)<0|(o|0)>(L|0))O=o;else{G=122;break}else{a=(o|0)>0;if(!((o|0)==-1|a)){G=119;break}O=a?o+L|0:-1}f[(f[f[J>>2]>>2]|0)+(E<<3)+4>>2]=O;E=E+1|0}if((G|0)==111){f[e>>2]=M;DM(l,455363,e);vM(-3,l,470867,455383,297)}else if((G|0)==114){b[l+11>>0]=10;r=l;q=449140;t=r+10|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[l+10>>0]=0;vM(-215,l,448971,448986,92)}else if((G|0)==119){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=$Xc(32)|0;f[l>>2]=e;f[l+8>>2]=-2147483616;f[l+4>>2]=22;r=e;q=449151;t=r+22|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[e+22>>0]=0;vM(-215,l,448971,448986,98)}else if((G|0)==122){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=$Xc(32)|0;f[l>>2]=e;f[l+8>>2]=-2147483616;f[l+4>>2]=22;r=e;q=449174;t=r+22|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(t|0));b[e+22>>0]=0;vM(-215,l,448971,448986,104)}else if((G|0)==124){u=d;return}}function BCb(a){a=a|0;NXc(a);cYc(a);return}function CCb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function DCb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==448728?a+12|0:0)|0}function ECb(a){a=a|0;cYc(a);return}function FCb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{KCb(j,c);j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)kWc(a);k=(e-i|0)/12|0;i=k<<1;e=k>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;do if(e)if(e>>>0>357913941){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e*12|0)|0;break}else l=0;while(0);i=l+(j*12|0)|0;j=i;h=l+(e*12|0)|0;e=b;b=j;l=i;do{KCb(l,c);l=b+12|0;b=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(e|0)){m=j;n=e;o=e}else{c=l;l=j;j=i;do{i=j+-12|0;k=c;c=c+-12|0;f[i>>2]=0;p=j+-8|0;f[p>>2]=0;f[j+-4>>2]=0;f[i>>2]=f[c>>2];i=k+-8|0;f[p>>2]=f[i>>2];p=k+-4|0;f[j+-4>>2]=f[p>>2];f[p>>2]=0;f[i>>2]=0;f[c>>2]=0;j=l+-12|0;l=j}while((c|0)!=(e|0));m=l;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~((o+-8-b|0)>>>3)<<3);cYc(b)}}while((d|0)!=(h|0))}if(!n)return;cYc(n);return}function GCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=d;g=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=j+-12|0;b=i;i=i+-12|0;f[d>>2]=0;n=j+-8|0;f[n>>2]=0;f[j+-4>>2]=0;f[d>>2]=f[i>>2];d=b+-8|0;f[n>>2]=f[d>>2];n=b+-4|0;f[j+-4>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[i>>2]=0;j=h+-12|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=c;c=c+-12|0;m=f[c>>2]|0;if(m|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(m|0))f[e>>2]=q+(~((q+-8-m|0)>>>3)<<3);cYc(m)}}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function HCb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>3>>>0>=b>>>0){i=b;j=h;do{k=c;l=f[k+4>>2]|0;m=j;f[m>>2]=f[k>>2];f[m+4>>2]=l;j=(f[g>>2]|0)+8|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>3;h=j+b|0;if(h>>>0>536870911)kWc(a);l=e-i|0;i=l>>2;e=l>>3>>>0<268435455?(i>>>0<h>>>0?h:i):536870911;do if(e)if(e>>>0>536870911){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{n=$Xc(e<<3)|0;break}else n=0;while(0);i=n+(j<<3)|0;j=n+(e<<3)|0;e=b;b=i;n=i;do{h=c;l=f[h+4>>2]|0;m=b;f[m>>2]=f[h>>2];f[m+4>>2]=l;b=n+8|0;n=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>3)<<3)|0;if((b|0)>0)o1c(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=n;f[d>>2]=j;if(!e)return;cYc(e);return}function ICb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=107124;b=a+44|0;c=f[b>>2]|0;if(!c){MNa(a);return}d=a+48|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);cYc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}cYc(g);MNa(a);return}function JCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=107124;b=a+44|0;c=f[b>>2]|0;if(!c){MNa(a);cYc(a);return}d=a+48|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);cYc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}cYc(g);MNa(a);cYc(a);return}function KCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;o1c(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function LCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=107124;b=a+44|0;c=f[b>>2]|0;if(!c){MNa(a);cYc(a);return}d=a+48|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);cYc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}cYc(g);MNa(a);cYc(a);return}function MCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;f[g>>2]=0;j=g+4|0;f[j>>2]=0;f[g+8>>2]=0;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=f[g>>2]|0;if(((f[j>>2]|0)-d|0)!=56){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=$Xc(32)|0;f[i>>2]=j;f[i+8>>2]=-2147483616;f[i+4>>2]=18;l=j;m=456060;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+18>>0]=0;vM(-215,i,455619,448986,153)}j=d+40|0;d=a+44|0;c=f[d>>2]|0;o=a+48|0;p=f[o>>2]|0;q=p;r=c;if((c|0)!=(p|0)){p=f[k>>2]|0;c=f[h>>2]|0;if(((p-c|0)/56|0|0)==((q-r|0)/12|0|0)){s=h;t=k;v=p;w=c}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;c=$Xc(48)|0;f[i>>2]=c;f[i+8>>2]=-2147483600;f[i+4>>2]=36;l=c;m=449431;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[c+36>>0]=0;vM(-215,i,455619,448986,171)}}else{c=a+56|0;a=f[c>>2]|0;p=((f[k>>2]|0)-(f[h>>2]|0)|0)/56|0;x=((f[(f[j>>2]|0)+(a<<2)>>2]|0)>>>0)/(p>>>0)|0;y=a+1|0;f[i>>2]=0;a=i+4|0;f[a>>2]=0;f[i+8>>2]=0;if(!y){z=r;A=q}else{if(y>>>0>536870911)kWc(i);q=$Xc(y<<3)|0;f[a>>2]=q;f[i>>2]=q;f[i+8>>2]=q+(y<<3);r=y;B=q;C=q;while(1){D=B;f[D>>2]=-2147483648;f[D+4>>2]=2147483647;D=C+8|0;E=r+-1|0;if(!E)break;else{r=E;B=D;C=D}}f[a>>2]=q+(y<<3);z=f[d>>2]|0;A=f[o>>2]|0}y=(A-z|0)/12|0;q=z;z=A;if(p>>>0<=y>>>0){if(p>>>0<y>>>0?(A=q+(p*12|0)|0,(z|0)!=(A|0)):0){q=z;while(1){z=q+-12|0;f[o>>2]=z;C=f[z>>2]|0;if(!C)F=z;else{z=q+-8|0;B=f[z>>2]|0;if((B|0)!=(C|0))f[z>>2]=B+(~((B+-8-C|0)>>>3)<<3);cYc(C);F=f[o>>2]|0}if((F|0)==(A|0))break;else q=F}}}else FCb(d,p-y|0,i);y=f[i>>2]|0;if(y|0){p=f[a>>2]|0;if((p|0)!=(y|0))f[a>>2]=p+(~((p+-8-y|0)>>>3)<<3);cYc(y)}y=f[k>>2]|0;p=f[h>>2]|0;if((y|0)==(p|0)){hx(h);hx(g);u=e;return}a=f[d>>2]|0;F=f[c>>2]|0;c=(y-p|0)/56|0;q=0;A=0;do{o=f[a+(q*12|0)>>2]|0;f[o+(F<<3)>>2]=A;A=A+x|0;f[o+(F<<3)+4>>2]=A;q=q+1|0}while(q>>>0<c>>>0);s=h;t=k;v=y;w=p}if((v|0)==(w|0)){hx(h);hx(g);u=e;return}w=i+4|0;v=0;p=f[j>>2]|0;while(1){y=f[d>>2]|0;k=(f[y+(v*12|0)+4>>2]|0)-(f[y+(v*12|0)>>2]|0)>>3;c=f[p+-4>>2]|0;if(k>>>0>c>>>0){G=33;break}if(!k){H=0;I=c;J=y;K=p}else{c=0;k=y;y=p;do{RCb(i,(f[k+(v*12|0)>>2]|0)+(c<<3)|0,f[y+(c<<2)>>2]|0);q=i;A=f[q+4>>2]|0;F=(f[(f[d>>2]|0)+(v*12|0)>>2]|0)+(c<<3)|0;f[F>>2]=f[q>>2];f[F+4>>2]=A;c=c+1|0;k=f[d>>2]|0;L=(f[k+(v*12|0)+4>>2]|0)-(f[k+(v*12|0)>>2]|0)>>3;y=f[j>>2]|0}while(c>>>0<L>>>0);H=L;I=f[y+-4>>2]|0;J=k;K=y}a:do if((H|0)<(I|0)){c=H;A=J;while(1){f[i>>2]=-2147483648;f[w>>2]=2147483647;F=A+(v*12|0)+4|0;q=f[F>>2]|0;if(q>>>0<(f[A+(v*12|0)+8>>2]|0)>>>0){x=i;a=f[x+4>>2]|0;o=q;f[o>>2]=f[x>>2];f[o+4>>2]=a;f[F>>2]=(f[F>>2]|0)+8}else SCb(A+(v*12|0)|0,i);F=c+1|0;a=f[j>>2]|0;if((F|0)>=(f[a+-4>>2]|0)){M=a;break a}c=F;A=f[d>>2]|0}}else M=K;while(0);v=v+1|0;if(v>>>0>=(((f[t>>2]|0)-(f[s>>2]|0)|0)/56|0)>>>0){G=30;break}else p=M}if((G|0)==30){hx(h);hx(g);u=e;return}else if((G|0)==33){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;G=$Xc(48)|0;f[i>>2]=G;f[i+8>>2]=-2147483600;f[i+4>>2]=40;l=G;m=449468;n=l+40|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[G+40>>0]=0;vM(-215,i,455619,448986,175)}}function NCb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+16|0;j=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=f[g>>2]|0;c=f[k>>2]|0;l=f[h>>2]|0;m=a+44|0;n=f[m>>2]|0;o=n;if(((c-l|0)/56|0|0)!=(((f[a+48>>2]|0)-n|0)/12|0|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=$Xc(48)|0;f[i>>2]=n;f[i+8>>2]=-2147483600;f[i+4>>2]=36;a=n;p=449431;q=a+36|0;do{b[a>>0]=b[p>>0]|0;a=a+1|0;p=p+1|0}while((a|0)<(q|0));b[n+36>>0]=0;vM(-215,i,456135,448986,250)}if((c|0)==(l|0)){hx(h);hx(g);u=e;return}l=j+8|0;c=j+4|0;n=i+36|0;p=i+16|0;a=i+4|0;q=i+40|0;r=i+44|0;s=i+48|0;t=0;v=o;while(1){a0(i,d,v+(t*12|0)|0);o=(f[h>>2]|0)+(t*56|0)|0;w=l;f[w>>2]=0;f[w+4>>2]=0;f[j>>2]=33619968;f[c>>2]=o;jR(i,j);o=f[n>>2]|0;if(o|0?(w=o+12|0,o=f[w>>2]|0,f[w>>2]=o+-1,(o|0)==1):0)V$(i);f[n>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[a>>2]|0)>0){o=f[q>>2]|0;w=0;do{f[o+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}w=f[r>>2]|0;if((w|0)!=(s|0))wL(w);w=t+1|0;if(w>>>0>=(((f[k>>2]|0)-(f[h>>2]|0)|0)/56|0)>>>0)break;t=w;v=f[m>>2]|0}hx(h);hx(g);u=e;return}function OCb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 2:{b=f[a+44>>2]|0;if(((f[a+48>>2]|0)-b|0)!=12){c=0;return c|0}c=((f[b+4>>2]|0)-(f[b>>2]|0)|0)==32;return c|0}case 3:{c=1;return c|0}default:{c=0;return c|0}}return 0}function PCb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function QCb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=u;u=u+32|0;h=g+12|0;i=g;j=f[c>>2]|0;if(((f[c+4>>2]|0)-j|0)!=12){c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=18;k=c;l=456060;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[c+18>>0]=0;vM(-215,h,456079,448986,122)}eKa(h,j);j=a+44|0;c=f[j>>2]|0;n=f[a+48>>2]|0;a:do if((c|0)==(n|0)){o=f[a+56>>2]|0;if((o|0)<=-1){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=$Xc(48)|0;f[i>>2]=p;q=i+8|0;f[q>>2]=-2147483600;r=i+4|0;f[r>>2]=35;k=p;l=449276;m=k+35|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));s=p+35|0;b[s>>0]=0;vM(-215,i,456079,448986,139)}t=f[h>>2]|0;v=t;if(o>>>0>=(f[h+4>>2]|0)-t>>2>>>0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=$Xc(48)|0;f[i>>2]=p;q=i+8|0;f[q>>2]=-2147483600;r=i+4|0;f[r>>2]=35;k=p;l=449276;m=k+35|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));s=p+35|0;b[s>>0]=0;vM(-215,i,456079,448986,139)}if((d|0)<=0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(64)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483584;y=i+4|0;f[y>>2]=60;k=w;l=449312;m=k+60|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z=w+60|0;b[z>>0]=0;vM(-215,i,456079,448986,140)}t=v+(o<<2)|0;A=f[t>>2]|0;if((A|0)%(d|0)|0|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(64)|0;f[i>>2]=w;x=i+8|0;f[x>>2]=-2147483584;y=i+4|0;f[y>>2]=60;k=w;l=449312;m=k+60|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));z=w+60|0;b[z>>0]=0;vM(-215,i,456079,448986,140)}f[t>>2]=(A|0)/(d|0)|0;o=e+4|0;v=f[o>>2]|0;B=f[e>>2]|0;C=(v-B|0)/12|0;D=v;if(C>>>0<d>>>0){Nvb(e,d-C|0,h);E=h;break}if(C>>>0>d>>>0?(C=B+(d*12|0)|0,(D|0)!=(C|0)):0){B=D;while(1){D=B+-12|0;f[o>>2]=D;v=f[D>>2]|0;if(!v)F=D;else{D=B+-8|0;G=f[D>>2]|0;if((G|0)!=(v|0))f[D>>2]=G+(~((G+-4-v|0)>>>2)<<2);cYc(v);F=f[o>>2]|0}if((F|0)==(C|0)){E=h;break}else B=F}}else E=h}else{B=(n-c|0)/12|0;C=e+4|0;o=f[C>>2]|0;A=f[e>>2]|0;t=(o-A|0)/12|0;v=A;A=o;if(B>>>0<=t>>>0)if(B>>>0<t>>>0?(G=v+(B*12|0)|0,(A|0)!=(G|0)):0){v=A;while(1){A=v+-12|0;f[C>>2]=A;D=f[A>>2]|0;if(!D)H=A;else{A=v+-8|0;I=f[A>>2]|0;if((I|0)!=(D|0))f[A>>2]=I+(~((I+-4-D|0)>>>2)<<2);cYc(D);H=f[C>>2]|0}if((H|0)==(G|0))break;else v=H}J=H}else J=o;else{Nvb(e,B-t|0,h);J=f[C>>2]|0}v=f[e>>2]|0;if((J|0)==(v|0)){E=h;break}G=h+4|0;D=i+4|0;I=0;A=v;v=J;K=f[j>>2]|0;while(1){L=f[K+(I*12|0)+4>>2]|0;M=f[K+(I*12|0)>>2]|0;N=f[h>>2]|0;if(L-M>>3>>>0>(f[G>>2]|0)-N>>2>>>0)break;if((L|0)==(M|0)){O=K;P=A;Q=v}else{M=0;L=K;R=N;while(1){RCb(i,(f[L+(I*12|0)>>2]|0)+(M<<3)|0,f[R+(M<<2)>>2]|0);S=f[e>>2]|0;f[(f[S+(I*12|0)>>2]|0)+(M<<2)>>2]=(f[D>>2]|0)-(f[i>>2]|0);N=M+1|0;T=f[j>>2]|0;if(N>>>0>=(f[T+(I*12|0)+4>>2]|0)-(f[T+(I*12|0)>>2]|0)>>3>>>0)break;M=N;L=T;R=f[h>>2]|0}O=T;P=S;Q=f[C>>2]|0}I=I+1|0;if(I>>>0>=((Q-P|0)/12|0)>>>0){E=h;break a}else{A=P;v=Q;K=O}}f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;K=$Xc(48)|0;f[i>>2]=K;f[i+8>>2]=-2147483600;f[i+4>>2]=40;k=K;l=449235;m=k+40|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[K+40>>0]=0;vM(-215,i,456079,448986,130)}while(0);i=f[E>>2]|0;if(!i){u=g;return 0}E=h+4|0;h=f[E>>2]|0;if((h|0)!=(i|0))f[E>>2]=h+(~((h+-4-i|0)>>>2)<<2);cYc(i);u=g;return 0}function RCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;i=(h|0)>0?h:0;h=f[c+4>>2]|0;c=(h|0)>0?((h|0)>(d|0)?d:h):d+1+h|0;f[a>>2]=i;f[a+4>>2]=c;if((i|0)>=(c|0)){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=27;j=i;k=449373;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+27>>0]=0;vM(-215,g,449401,454620,212)}if((c|0)>(d|0)){d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=23;j=d;k=449407;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+23>>0]=0;vM(-215,g,449401,454620,212)}else{u=e;return}}function SCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function TCb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(88)|0;UCb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=107236;f[b+12>>2]=c;f[a+4>>2]=b;return}function UCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+64|0;e=d+40|0;g=d+32|0;h=d+16|0;i=d+44|0;j=d;qQa(a);f[a>>2]=107264;k=a+44|0;l=a+48|0;m=a+76|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;rQa(a,c);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=h+11|0;b[o>>0]=5;b[h>>0]=b[502066]|0;b[h+1>>0]=b[502067]|0;b[h+2>>0]=b[502068]|0;b[h+3>>0]=b[502069]|0;b[h+4>>0]=b[502070]|0;b[h+5>>0]=0;p=LGa(c,h)|0;q=c+4|0;if((p|0)==(q|0))r=0.0;else r=+NGa(p+28|0,-1);n[a+72>>2]=r;if((b[o>>0]|0)<0)cYc(f[h>>2]|0);o=h+11|0;b[o>>0]=10;p=h;s=449694;t=p+10|0;do{b[p>>0]=b[s>>0]|0;p=p+1|0;s=s+1|0}while((p|0)<(t|0));b[h+10>>0]=0;v=LGa(c,h)|0;if((v|0)==(q|0))w=-1;else{x=MGa(v+28|0,-1)|0;w=x}f[a+68>>2]=w;if((b[o>>0]|0)<0)cYc(f[h>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;o=i+11|0;b[o>>0]=4;f[i>>2]=1701869940;b[i+4>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;w=j+11|0;b[w>>0]=8;x=j;f[x>>2]=1936617315;f[x+4>>2]=1953390964;b[j+8>>0]=0;x=LGa(c,i)|0;if((x|0)==(q|0))lYc(h,j);else OIa(h,x+28|0,-1);x=m+11|0;if((b[x>>0]|0)<0){b[f[m>>2]>>0]=0;f[a+80>>2]=0}else{b[m>>0]=0;b[x>>0]=0}sYc(m,0);f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if((b[w>>0]|0)<0)cYc(f[j>>2]|0);if((b[o>>0]|0)<0)cYc(f[i>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=8;o=h;f[o>>2]=1684300144;f[o+4>>2]=1936158313;b[h+8>>0]=0;o=(HIa(c,h)|0)==0;if((b[i>>0]|0)<0)cYc(f[h>>2]|0);if(o){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=$Xc(32)|0;f[h>>2]=o;f[h+8>>2]=-2147483616;f[h+4>>2]=22;p=o;s=449705;t=p+22|0;do{b[p>>0]=b[s>>0]|0;p=p+1|0;s=s+1|0}while((p|0)<(t|0));b[o+22>>0]=0;vM(-215,h,449728,449745,32)};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=h+11|0;b[o>>0]=8;i=h;f[i>>2]=1684300144;f[i+4>>2]=1936158313;b[h+8>>0]=0;i=NIa(c,h)|0;if((b[o>>0]|0)<0)cYc(f[h>>2]|0);o=f[i>>2]|0;switch(o|0){case 0:{c=f[i+4>>2]|0;y=c+4|0;z=c;A=c;B=c;break}case 3:{c=f[i+4>>2]|0;y=c+4|0;z=c;A=c;B=c;break}case 2:{c=f[i+4>>2]|0;y=c+4|0;z=c;A=c;B=c;break}default:{f[g>>2]=o;DM(h,455363,g);vM(-3,h,470867,455383,297)}}if(f[y>>2]&1|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(32)|0;f[h>>2]=y;f[h+8>>2]=-2147483616;f[h+4>>2]=31;p=y;s=449826;t=p+31|0;do{b[p>>0]=b[s>>0]|0;p=p+1|0;s=s+1|0}while((p|0)<(t|0));b[y+31>>0]=0;vM(-215,h,449728,449745,34)}switch(o|0){case 0:{C=z+4|0;break}case 3:{C=A+4|0;break}case 2:{C=B+4|0;break}default:{f[e>>2]=o;DM(h,455363,e);vM(-3,h,470867,455383,297)}}e=(f[C>>2]|0)/2|0;C=f[l>>2]|0;o=f[k>>2]|0;B=C-o>>3;A=o;z=C;if(e>>>0<=B>>>0)if(e>>>0<B>>>0?(y=A+(e<<3)|0,(z|0)!=(y|0)):0){A=z+(~((z+-8-y|0)>>>3)<<3)|0;f[l>>2]=A;D=A;E=o}else{D=C;E=o}else{ZCb(k,e-B|0);D=f[l>>2]|0;E=f[k>>2]|0}if((D|0)==(E|0)){u=d;return}else F=0;while(1){E=F<<1;D=MGa(i,E)|0;f[(f[k>>2]|0)+(F<<3)>>2]=D;D=MGa(i,E|1)|0;E=f[k>>2]|0;f[E+(F<<3)+4>>2]=D;if((f[E+(F<<3)>>2]|0)<=-1){G=46;break}F=F+1|0;if((D|0)<=-1){G=48;break}if(F>>>0>=(f[l>>2]|0)-E>>3>>>0){G=44;break}}if((G|0)==44){u=d;return}else if((G|0)==46){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(32)|0;f[h>>2]=d;f[h+8>>2]=-2147483616;f[h+4>>2]=22;p=d;s=449858;t=p+22|0;do{b[p>>0]=b[s>>0]|0;p=p+1|0;s=s+1|0}while((p|0)<(t|0));b[d+22>>0]=0;vM(-215,h,449728,449745,41)}else if((G|0)==48){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=$Xc(32)|0;f[h>>2]=G;f[h+8>>2]=-2147483616;f[h+4>>2]=23;p=G;s=449881;t=p+23|0;do{b[p>>0]=b[s>>0]|0;p=p+1|0;s=s+1|0}while((p|0)<(t|0));b[G+23>>0]=0;vM(-215,h,449728,449745,41)}}function VCb(a){a=a|0;NXc(a);cYc(a);return}function WCb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function XCb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==449535?a+12|0:0)|0}function YCb(a){a=a|0;cYc(a);return}function ZCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){g1c(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)kWc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;g1c(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;cYc(h);return}function _Cb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=107264;c=a+76|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=f[a+56>>2]|0;if(c|0){d=a+60|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);cYc(c)}c=f[a+44>>2]|0;if(!c){MNa(a);return}e=a+48|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);cYc(c);MNa(a);return}function $Cb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=107264;c=a+76|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=f[a+56>>2]|0;if(c|0){d=a+60|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);cYc(c)}c=f[a+44>>2]|0;if(!c){MNa(a);cYc(a);return}e=a+48|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);cYc(c);MNa(a);cYc(a);return}function aDb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+48|0;d=c;e=c+24|0;g=c+8|0;h=c+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;gS(b,e);b=f[e>>2]|0;i=a+56|0;j=a+44|0;k=a+48|0;l=(f[k>>2]|0)-(f[j>>2]|0)>>3;m=a+60|0;n=f[m>>2]|0;o=f[i>>2]|0;p=n-o>>3;q=o;o=n;if(l>>>0<=p>>>0){if(l>>>0<p>>>0?(n=q+(l<<3)|0,(o|0)!=(n|0)):0)f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3)}else fDb(i,l-p|0);p=f[a+68>>2]|0;if((p|0)!=-1?(f[(f[e>>2]|0)+4>>2]|0)!=(p|0):0){f[g>>2]=f[i>>2];f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[d>>2]=f[g>>2];gDb(i,d,h)|0;r=1}else r=0;h=f[k>>2]|0;k=f[j>>2]|0;j=k;if((h|0)==(k|0))s=f[i>>2]|0;else{g=f[i>>2]|0;p=f[b+40>>2]|0;b=h-k>>3;k=g;h=0;do{l=f[j+(h<<3)>>2]|0;n=h+r|0;f[g+(n<<3)>>2]=l;f[g+(n<<3)+4>>2]=(f[p+(n<<2)>>2]|0)+l;h=h+1|0}while(h>>>0<b>>>0);s=k}k=f[m>>2]|0;b=k-s>>3;if((b|0)>=(f[(f[e>>2]|0)+4>>2]|0)){hx(e);u=c;return}s=d+4|0;h=a+64|0;a=b;b=k;while(1){f[d>>2]=-2147483648;f[s>>2]=2147483647;if(b>>>0<(f[h>>2]|0)>>>0){k=d;p=f[k+4>>2]|0;g=b;f[g>>2]=f[k>>2];f[g+4>>2]=p;f[m>>2]=(f[m>>2]|0)+8}else SCb(i,d);p=a+1|0;if((p|0)>=(f[(f[e>>2]|0)+4>>2]|0))break;a=p;b=f[m>>2]|0}hx(e);u=c;return}function bDb(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;g=u;u=u+336|0;h=g+72|0;i=g+324|0;j=g+312|0;k=g+16|0;l=g+256|0;m=g;o=g+200|0;f[i>>2]=0;q=i+4|0;f[q>>2]=0;f[i+8>>2]=0;f[j>>2]=0;r=j+4|0;f[r>>2]=0;f[j+8>>2]=0;gS(c,i);gS(e,j);e=a+76|0;s=e+11|0;t=b[s>>0]|0;v=a+80|0;w=f[v>>2]|0;do if(((t<<24>>24<0?w:t&255)|0)==8){if(LYc(e,0,-1,450025,8)|0){x=b[s>>0]|0;y=f[v>>2]|0;break}if((qS(c,-1)|0)==3){f[h>>2]=0;z=h+4|0;f[z>>2]=0;f[h+8>>2]=0;A=$Xc(4)|0;f[h>>2]=A;B=A+4|0;f[h+8>>2]=B;f[A>>2]=f[a+72>>2];f[z>>2]=B;f[k>>2]=0;B=k+4|0;f[B>>2]=0;f[k+8>>2]=0;A=$Xc(2)|0;f[k>>2]=A;C=A+2|0;f[k+8>>2]=C;d[A>>1]=0;f[B>>2]=C;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=-2130509819;f[l+4>>2]=h;C=m+8|0;f[C>>2]=0;f[C+4>>2]=0;f[m>>2]=-2113732605;f[m+4>>2]=k;eY(l,m);C=f[j>>2]|0;p[m>>3]=+(d[f[k>>2]>>1]|0);f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;mR(C,l,fT()|0)|0;C=f[k>>2]|0;if(C|0){A=f[B>>2]|0;if((A|0)!=(C|0))f[B>>2]=A+(~((A+-2-C|0)>>>1)<<1);cYc(C)}C=f[h>>2]|0;if(C|0){A=f[z>>2]|0;if((A|0)!=(C|0))f[z>>2]=A+(~((A+-4-C|0)>>>2)<<2);cYc(C)}}else{C=f[j>>2]|0;p[k>>3]=+n[a+72>>2];f[h>>2]=-1056833530;f[h+4>>2]=k;f[h+8>>2]=1;f[h+12>>2]=1;mR(C,h,fT()|0)|0}C=f[i>>2]|0;a0(k,f[j>>2]|0,a+56|0);A=h+8|0;f[A>>2]=0;f[A+4>>2]=0;f[h>>2]=-1040121856;f[h+4>>2]=k;jR(C,h);C=k+36|0;A=f[C>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)V$(k);f[C>>2]=0;C=k+16|0;A=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){C=f[k+40>>2]|0;z=0;do{f[C+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[A>>2]|0))}A=f[k+44>>2]|0;if((A|0)!=(k+48|0))wL(A);hx(j);hx(i);u=g;return}else{x=t;y=w}while(0);if(((x<<24>>24<0?y:x&255)|0)!=7){SGa(h,450149,e);vM(-213,h,456135,449745,152)}if(LYc(e,0,-1,450034,7)|0){SGa(h,450149,e);vM(-213,h,456135,449745,152)}e=f[i>>2]|0;x=e;if(((f[q>>2]|0)-e|0)!=56){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=18;D=e;E=456060;F=D+18|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[e+18>>0]=0;vM(-215,h,456135,449745,121)}e=f[j>>2]|0;q=e;if(((f[r>>2]|0)-e|0)!=56){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=19;D=e;E=452040;F=D+19|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[e+19>>0]=0;vM(-215,h,456135,449745,122)}if((f[x+4>>2]|0)!=4){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=19;D=e;E=450042;F=D+19|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[e+19>>0]=0;vM(-215,h,456135,449745,123)}if((f[q+4>>2]|0)!=4){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=20;D=e;E=450062;F=D+20|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[e+20>>0]=0;vM(-215,h,456135,449745,124)}e=f[x+40>>2]|0;r=f[e>>2]|0;y=f[q+40>>2]|0;if((r|0)!=(f[y>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=$Xc(48)|0;f[h>>2]=G;H=h+8|0;f[H>>2]=-2147483600;I=h+4|0;f[I>>2]=45;D=G;E=450083;F=D+45|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));J=G+45|0;b[J>>0]=0;vM(-213,h,456135,449745,127)}q=f[e+4>>2]|0;if((q|0)!=(f[y+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=$Xc(48)|0;f[h>>2]=G;H=h+8|0;f[H>>2]=-2147483600;I=h+4|0;f[I>>2]=45;D=G;E=450083;F=D+45|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));J=G+45|0;b[J>>0]=0;vM(-213,h,456135,449745,127)}J=f[e+8>>2]|0;G=f[e+12>>2]|0;e=f[a+56>>2]|0;a=f[e+16>>2]|0;I=(f[y+8>>2]|0)-(f[e+20>>2]|0)|0;H=f[e+24>>2]|0;w=(f[y+12>>2]|0)-(f[e+28>>2]|0)|0;if((a|0)>=(J|0))mV(a,J,107368);if((I|0)>=(J|0))mV(I,J,107396);if((H|0)>=(G|0))mV(H,G,107424);if((w|0)>=(G|0))mV(w,G,107452);if(!r){hx(j);hx(i);u=g;return}G=k+8|0;J=k+12|0;e=k+4|0;y=m+8|0;t=m+4|0;c=o+36|0;v=o+16|0;s=o+4|0;A=o+40|0;z=o+44|0;C=o+48|0;B=l+36|0;K=l+16|0;L=l+4|0;M=l+40|0;N=l+44|0;O=l+48|0;P=0;Q=q;q=r;r=x;a:while(1){if(!Q){R=0;S=q;T=r}else{x=0;U=r;do{V=f[U+4>>2]|0;if((V|0)<=2){W=51;break a}X=f[U+40>>2]|0;Z=2;do{f[h+(Z+-2<<2)>>2]=f[X+(Z<<2)>>2];Z=Z+1|0}while((Z|0)!=(V|0));Z=f[U+44>>2]|0;X=(f[U+16>>2]|0)+(Y(f[Z>>2]|0,P)|0)|0;_$(l,V+-2|0,h,f[U>>2]&4095,X+(Y(f[Z+4>>2]|0,x)|0)|0,0);f[G>>2]=0;f[J>>2]=0;f[k>>2]=16842752;f[e>>2]=l;Z=f[j>>2]|0;X=f[Z+4>>2]|0;if((X|0)<=2){W=55;break a}_=f[Z+40>>2]|0;$=2;do{f[h+($+-2<<2)>>2]=f[_+($<<2)>>2];$=$+1|0}while(($|0)!=(X|0));$=f[Z+44>>2]|0;_=(f[Z+16>>2]|0)+(Y(f[$>>2]|0,P)|0)|0;_$(o,X+-2|0,h,f[Z>>2]&4095,_+(Y(f[$+4>>2]|0,x)|0)|0,0);$=y;f[$>>2]=0;f[$+4>>2]=0;f[m>>2]=-1040121856;f[t>>2]=o;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;rR(k,m,a,I,H,w,4,h);$=f[c>>2]|0;do if($|0){_=$+12|0;V=f[_>>2]|0;f[_>>2]=V+-1;if((V|0)!=1)break;V$(o)}while(0);f[c>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[s>>2]|0)>0){$=f[A>>2]|0;Z=0;do{f[$+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[s>>2]|0))}Z=f[z>>2]|0;if((Z|0)!=(C|0))wL(Z);Z=f[B>>2]|0;do if(Z|0){$=Z+12|0;X=f[$>>2]|0;f[$>>2]=X+-1;if((X|0)!=1)break;V$(l)}while(0);f[B>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[L>>2]|0)>0){Z=f[M>>2]|0;X=0;do{f[Z+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[L>>2]|0))}X=f[N>>2]|0;if((X|0)!=(O|0))wL(X);x=x+1|0;U=f[i>>2]|0;aa=f[U+40>>2]|0;ba=f[aa+4>>2]|0}while(x>>>0<ba>>>0);R=ba;S=f[aa>>2]|0;T=U}P=P+1|0;if(P>>>0>=S>>>0){W=76;break}else{Q=R;q=S;r=T}}if((W|0)==51){b[h+11>>0]=10;D=h;E=450129;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[h+10>>0]=0;vM(-215,h,450140,454620,110)}else if((W|0)==55){b[h+11>>0]=10;D=h;E=450129;F=D+10|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[h+10>>0]=0;vM(-215,h,450140,454620,110)}else if((W|0)==76){hx(j);hx(i);u=g;return}}function cDb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 1:{if(zQa()|0)c=((f[a+60>>2]|0)-(f[a+56>>2]|0)|0)==32;else c=0;break}default:c=0}return c|0}function dDb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function eDb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;i=h;if(((f[c+4>>2]|0)-h|0)!=12){c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=18;j=c;k=456060;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[c+18>>0]=0;vM(-215,d,456079,449745,50)}c=i+4|0;m=h;h=(f[c>>2]|0)-(f[m>>2]|0)>>2;n=a+44|0;o=a+48|0;p=(f[o>>2]|0)-(f[n>>2]|0)>>3;if(h>>>0<p>>>0){q=$Xc(48)|0;f[d>>2]=q;f[d+8>>2]=-2147483600;f[d+4>>2]=34;j=q;k=449905;l=j+34|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+34>>0]=0;vM(-215,d,456079,449745,52)}q=a+68|0;a=f[q>>2]|0;if(!(h>>>0>p>>>0|((a|0)==-1|(h|0)==(a|0)))){a=$Xc(96)|0;f[d>>2]=a;f[d+8>>2]=-2147483552;f[d+4>>2]=84;j=a;k=449940;l=j+84|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[a+84>>0]=0;vM(-215,d,456079,449745,53)}d=e+4|0;a=f[d>>2]|0;k=f[e>>2]|0;j=a-k|0;l=(j|0)/12|0;h=k;k=a;if(j){if(l>>>0>1?(j=h+12|0,(k|0)!=(j|0)):0){h=k;while(1){k=h+-12|0;f[d>>2]=k;a=f[k>>2]|0;if(!a)r=k;else{k=h+-8|0;p=f[k>>2]|0;if((p|0)!=(a|0))f[k>>2]=p+(~((p+-4-a|0)>>>2)<<2);cYc(a);r=f[d>>2]|0}if((r|0)==(j|0))break;else h=r}}}else Nvb(e,1-l|0,i);l=f[q>>2]|0;if((l|0)==-1)s=0;else s=(f[c>>2]|0)-(f[m>>2]|0)>>2>>>0>l>>>0&1;l=f[o>>2]|0;o=f[n>>2]|0;n=o;if((l|0)==(o|0)){u=g;return 0}m=f[i>>2]|0;i=f[f[e>>2]>>2]|0;e=l-o>>3;o=0;do{l=o+s|0;f[i+(l<<2)>>2]=(f[n+(o<<3)>>2]|0)+(f[m+(l<<2)>>2]|0)+(f[n+(o<<3)+4>>2]|0);o=o+1|0}while(o>>>0<e>>>0);u=g;return 0}function fDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){g1c(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)kWc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;g1c(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;cYc(h);return}function gDb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+32|0;e=d;g=f[a>>2]|0;h=g;i=(f[b>>2]|0)-h|0;b=g+(i>>3<<3)|0;g=a+4|0;j=f[g>>2]|0;k=a+8|0;l=f[k>>2]|0;m=j;n=l;if(j>>>0<l>>>0){if((b|0)==(j|0)){l=c;o=f[l+4>>2]|0;p=b;f[p>>2]=f[l>>2];f[p+4>>2]=o;f[g>>2]=(f[g>>2]|0)+8;q=b;u=d;return q|0}o=m-(b+8)|0;p=o>>3;l=b+(p<<3)|0;if(l>>>0<j>>>0){r=l;l=j;do{s=r;t=f[s+4>>2]|0;v=l;f[v>>2]=f[s>>2];f[v+4>>2]=t;r=r+8|0;l=(f[g>>2]|0)+8|0;f[g>>2]=l}while(r>>>0<j>>>0)}if(p|0)q1c(j+(0-p<<3)|0,b|0,o|0)|0;o=c;p=f[o+4>>2]|0;j=b;f[j>>2]=f[o>>2];f[j+4>>2]=p;q=b;u=d;return q|0}p=(m-h>>3)+1|0;if(p>>>0>536870911)kWc(a);m=n-h|0;h=m>>2;n=m>>3>>>0<268435455?(h>>>0<p>>>0?p:h):536870911;h=b;p=i>>3;f[e+12>>2]=0;f[e+16>>2]=a+8;do if(n)if(n>>>0>536870911){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{w=$Xc(n<<3)|0;break}else w=0;while(0);f[e>>2]=w;i=w+(p<<3)|0;p=e+8|0;f[p>>2]=i;m=e+4|0;f[m>>2]=i;i=e+12|0;f[i>>2]=w+(n<<3);hDb(e,c);c=f[m>>2]|0;n=f[a>>2]|0;w=h-n|0;j=c+(0-(w>>3)<<3)|0;f[m>>2]=j;if((w|0)>0)o1c(j|0,n|0,w|0)|0;w=f[g>>2]|0;n=w-h|0;if((n|0)>0){o1c(f[p>>2]|0,b|0,n|0)|0;b=(f[p>>2]|0)+(n>>>3<<3)|0;f[p>>2]=b;x=p;y=b;z=f[g>>2]|0}else{x=p;y=f[p>>2]|0;z=w}w=f[a>>2]|0;f[a>>2]=f[m>>2];f[m>>2]=w;f[g>>2]=y;f[x>>2]=z;x=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=x;f[e>>2]=w;e=z;if((e|0)!=(w|0))f[p>>2]=e+(~((e+-8-w|0)>>>3)<<3);if(w|0)cYc(w);q=c;u=d;return q|0}function hDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;i=d;do if((d|0)==(g|0)){j=a+4|0;k=f[j>>2]|0;l=f[a>>2]|0;m=l;if(k>>>0>l>>>0){n=k;o=((n-m>>3)+1|0)/-2|0;p=k+(o<<3)|0;q=i-n|0;n=q>>3;if(!n)r=k;else{q1c(p|0,k|0,q|0)|0;r=f[j>>2]|0}q=p+(n<<3)|0;f[c>>2]=q;f[j>>2]=r+(o<<3);s=q;break}q=h-m>>2;m=(q|0)==0?1:q;if(m>>>0>536870911){q=af(8)|0;hYc(q,512536);f[q>>2]=192348;ig(q|0,25336,2140)}q=$Xc(m<<3)|0;o=q;n=q+(m>>>2<<3)|0;p=n;t=q+(m<<3)|0;if((k|0)==(d|0)){u=p;v=l}else{l=n;n=p;m=k;do{k=m;q=f[k+4>>2]|0;w=l;f[w>>2]=f[k>>2];f[w+4>>2]=q;l=n+8|0;n=l;m=m+8|0}while((m|0)!=(d|0));u=n;v=f[a>>2]|0}f[a>>2]=o;f[j>>2]=p;f[c>>2]=u;f[e>>2]=t;if(!v)s=u;else{cYc(v);s=f[c>>2]|0}}else s=d;while(0);d=b;b=f[d+4>>2]|0;v=s;f[v>>2]=f[d>>2];f[v+4>>2]=b;f[c>>2]=(f[c>>2]|0)+8;return}function iDb(a,b){a=a|0;b=b|0;var c=0;c=$Xc(116)|0;jDb(c,b);f[a>>2]=c;b=$Xc(16)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=107488;f[b+12>>2]=c;f[a+4>>2]=b;return}function jDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+48|0;e=d+8|0;g=d;h=d+24|0;i=d+16|0;qQa(a);f[a>>2]=107516;j=a+44|0;k=a+48|0;l=a+52|0;m=a+108|0;n=a+112|0;f[n>>2]=0;o=j;p=o+64|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));b[j+64>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=h+11|0;b[j>>0]=5;b[h>>0]=b[450562]|0;b[h+1>>0]=b[450563]|0;b[h+2>>0]=b[450564]|0;b[h+3>>0]=b[450565]|0;b[h+4>>0]=b[450566]|0;b[h+5>>0]=0;q=(HIa(c,h)|0)==0;if((b[j>>0]|0)<0)cYc(f[h>>2]|0);if(q){u=d;return};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=h+11|0;b[q>>0]=5;b[h>>0]=b[450562]|0;b[h+1>>0]=b[450563]|0;b[h+2>>0]=b[450564]|0;b[h+3>>0]=b[450565]|0;b[h+4>>0]=b[450566]|0;b[h+5>>0]=0;VGa(i,NIa(c,h)|0);if((b[q>>0]|0)<0)cYc(f[h>>2]|0);q=f[i>>2]|0;switch(q|0){case 0:{r=(f[i+4>>2]|0)+4|0;break}case 3:{r=(f[i+4>>2]|0)+4|0;break}case 2:{r=(f[i+4>>2]|0)+4|0;break}default:{f[g>>2]=q;DM(h,455363,g);vM(-3,h,470867,455383,297)}}g=f[r>>2]|0;f[n>>2]=g;a:do if(g|0){r=a+56|0;q=0;while(1){j=MGa(i,q)|0;s=f[n>>2]|0;if((j|0)<0|j>>>0>s>>>0){t=15;break}v=f[k>>2]|0;w=f[l>>2]|0;b:do if((v|0)==(w|0)){x=v;t=19}else{y=v;do{if((f[y>>2]|0)==(j|0)){x=y;t=19;break b}y=y+4|0}while((y|0)!=(w|0))}while(0);if((t|0)==19?(t=0,(x|0)!=(w|0)):0){t=20;break}f[h>>2]=j;if(w>>>0<(f[r>>2]|0)>>>0){f[w>>2]=j;f[l>>2]=w+4}else YQ(k,h);q=q+1|0;if(q>>>0>=(f[n>>2]|0)>>>0)break a}if((t|0)==15){f[e>>2]=s+-1;DM(h,450568,e);vM(-5,h,450636,450653,92)}else if((t|0)==20){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=$Xc(64)|0;f[h>>2]=q;f[h+8>>2]=-2147483584;f[h+4>>2]=51;o=q;r=450734;p=o+51|0;do{b[o>>0]=b[r>>0]|0;o=o+1|0;r=r+1|0}while((o|0)<(p|0));b[q+51>>0]=0;vM(-5,h,450636,450653,97)}}while(0);rQa(a,c);b[m>>0]=0;c=f[n>>2]|0;c:do if(c|0){n=f[a+48>>2]|0;h=0;while(1){if((f[n+(h<<2)>>2]|0)!=(h|0))break;h=h+1|0;if(h>>>0>=c>>>0)break c}b[m>>0]=1}while(0);RGa(i);u=d;return}function kDb(a){a=a|0;NXc(a);cYc(a);return}function lDb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function mDb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==450403?a+12|0:0)|0}function nDb(a){a=a|0;cYc(a);return}function oDb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=107516;b=f[a+96>>2]|0;if(b|0){c=a+100|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+84>>2]|0;if(b|0){d=a+88|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+72>>2]|0;if(b|0){c=a+76|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+60>>2]|0;if(b|0){d=a+64|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(!b){MNa(a);return}c=a+52|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);MNa(a);return}function pDb(a){a=a|0;oDb(a);cYc(a);return}function qDb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(!(b[a+108>>0]|0)){u=e;return}f[g>>2]=0;k=g+4|0;f[k>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;gS(c,g);gS(d,h);d=f[g>>2]|0;c=d;if((f[k>>2]|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=$Xc(32)|0;f[i>>2]=d;f[i+8>>2]=-2147483616;f[i+4>>2]=17;l=d;m=452630;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[d+17>>0]=0;vM(-215,i,455619,450653,171)}d=f[a+112>>2]|0;if((d|0)!=(f[c+4>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=$Xc(32)|0;f[i>>2]=k;f[i+8>>2]=-2147483616;f[i+4>>2]=26;l=k;m=451274;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+26>>0]=0;vM(-215,i,455619,450653,173)}k=f[c+40>>2]|0;f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;gOa(i,k,k+(d<<2)|0);d=f[h>>2]|0;k=f[d+4>>2]|0;m=f[d+40>>2]|0;f[j>>2]=0;d=j+4|0;f[d>>2]=0;f[j+8>>2]=0;gOa(j,m,m+(k<<2)|0);zDb(a,i,j);a=f[j>>2]|0;if(a|0){j=f[d>>2]|0;if((j|0)!=(a|0))f[d>>2]=j+(~((j+-4-a|0)>>>2)<<2);cYc(a)}a=f[i>>2]|0;if(a|0){i=f[c>>2]|0;if((i|0)!=(a|0))f[c>>2]=i+(~((i+-4-a|0)>>>2)<<2);cYc(a)}hx(h);hx(g);u=e;return}function rDb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;g=u;u=u+48|0;h=g+28|0;i=g+16|0;j=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;c=(f[e>>2]|0)-d|0;e=(c|0)/56|0;k=d;a:do if(!(b[a+108>>0]|0)){if(c|0){d=j+8|0;l=j+4|0;m=0;while(1){n=f[i>>2]|0;o=f[n+(m*56|0)+4>>2]|0;if((o|0)<3)p=Y(f[n+(m*56|0)+12>>2]|0,f[n+(m*56|0)+8>>2]|0)|0;else{q=f[n+(m*56|0)+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}s=f[h>>2]|0;o=f[s+(m*56|0)+4>>2]|0;if((o|0)<3)v=Y(f[s+(m*56|0)+12>>2]|0,f[s+(m*56|0)+8>>2]|0)|0;else{r=f[s+(m*56|0)+40>>2]|0;q=0;t=1;while(1){w=Y(f[r+(q<<2)>>2]|0,t)|0;q=q+1|0;if((q|0)==(o|0)){v=w;break}else t=w}}if((p|0)!=(v|0))break;if((f[n+(m*56|0)+16>>2]|0)!=(f[s+(m*56|0)+16>>2]|0)){t=d;f[t>>2]=0;f[t+4>>2]=0;f[j>>2]=33619968;f[l>>2]=n+(m*56|0);jR(s+(m*56|0)|0,j)}m=m+1|0;if(m>>>0>=e>>>0)break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;m=$Xc(48)|0;f[j>>2]=m;f[j+8>>2]=-2147483600;f[j+4>>2]=39;x=m;y=450858;z=x+39|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[m+39>>0]=0;vM(-215,j,456135,450653,325)}}else{l=f[a+44>>2]|0;d=f[a+112>>2]|0;t=f[a+96>>2]|0;o=f[a+84>>2]|0;q=a+48|0;r=f[q>>2]|0;if(c|0){w=(d|0)==4;A=(l|0)==0;B=(d|0)==0;C=f[i>>2]|0;b:do if((f[k+4>>2]|0)==(d|0)){D=0;E=C;F=k;G=C;H=k;c:while(1){I=f[H+(D*56|0)+40>>2]|0;J=f[I+-4>>2]|0;K=f[H+40>>2]|0;if((J|0)!=(f[K+-4>>2]|0))break b;if((J|0)==2){if((f[I>>2]|0)!=(f[K>>2]|0))break b;if((f[I+4>>2]|0)!=(f[K+4>>2]|0))break b}else if((J|0)>0){L=0;do{if((f[I+(L<<2)>>2]|0)!=(f[K+(L<<2)>>2]|0))break b;L=L+1|0}while((L|0)<(J|0))}if((f[E+(D*56|0)+4>>2]|0)!=(d|0)){M=37;break}J=f[E+(D*56|0)+40>>2]|0;L=f[J+-4>>2]|0;K=f[E+40>>2]|0;if((L|0)!=(f[K+-4>>2]|0)){M=37;break}if((L|0)==2){if((f[J>>2]|0)!=(f[K>>2]|0)){M=37;break}if((f[J+4>>2]|0)!=(f[K+4>>2]|0)){M=37;break}}else if((L|0)>0){I=0;do{if((f[J+(I<<2)>>2]|0)!=(f[K+(I<<2)>>2]|0)){M=37;break c}I=I+1|0}while((I|0)<(L|0))}L=f[F>>2]|0;if(!(L&16384)){M=40;break}I=f[G>>2]|0;if(!(I&16384)){M=40;break}if(!((L&4095|0)==5&(I&4095|0)==5)){M=42;break}d:do if(!w){I=f[H+(D*56|0)+16>>2]|0;L=f[E+(D*56|0)+16>>2]|0;if(!A){if(B){K=0;while(1){f[L+(K<<2)>>2]=f[I>>2];K=K+1|0;if((K|0)==(l|0))break d}}else N=0;do{K=0;J=0;O=N;while(1){P=f[t+(J<<2)>>2]|0;K=(Y(f[o+(f[r+(J<<2)>>2]<<2)>>2]|0,(O>>>0)/(P>>>0)|0)|0)+K|0;J=J+1|0;if((J|0)==(d|0))break;else O=(O>>>0)%(P>>>0)|0}f[L+(N<<2)>>2]=f[I+(K<<2)>>2];N=N+1|0}while((N|0)!=(l|0))}}else wDb(F,G,q,i3()|0);while(0);I=D+1|0;if(I>>>0>=e>>>0)break a;L=f[h>>2]|0;O=f[i>>2]|0;if((f[L+(I*56|0)+4>>2]|0)==(d|0)){D=I;E=O;F=L+(I*56|0)|0;G=O+(I*56|0)|0;H=L}else break b}if((M|0)==37){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;H=$Xc(64)|0;f[j>>2]=H;f[j+8>>2]=-2147483584;f[j+4>>2]=50;x=H;y=450948;z=x+50|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[H+50>>0]=0;vM(-215,j,456135,450653,343)}else if((M|0)==40){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;G=$Xc(48)|0;f[j>>2]=G;f[j+8>>2]=-2147483600;f[j+4>>2]=40;x=G;y=450999;z=x+40|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[G+40>>0]=0;vM(-215,j,456135,450653,345)}else if((M|0)==42){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;H=$Xc(48)|0;f[j>>2]=H;f[j+8>>2]=-2147483600;f[j+4>>2]=44;x=H;y=451040;z=x+44|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[H+44>>0]=0;vM(-215,j,456135,450653,346)}}while(0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=$Xc(64)|0;f[j>>2]=d;f[j+8>>2]=-2147483584;f[j+4>>2]=49;x=d;y=450898;z=x+49|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[d+49>>0]=0;vM(-215,j,456135,450653,342)}}while(0);hx(i);hx(h);u=g;return}function sDb(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 3:{c=1;break}case 2:{if(orb()|0)c=1;else d=4;break}case 4:{c=nrb()|0;break}default:d=4}if((d|0)==4)c=0;return c|0}function tDb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function uDb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function vDb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+48|0;i=h+24|0;j=h+12|0;k=h;if(!(b[a+108>>0]|0)){cOa(a,c,d,e,g)|0;l=1;u=h;return l|0}g=c+4|0;d=f[c>>2]|0;m=d;if((f[g>>2]|0)==(d|0)){n=$Xc(32)|0;f[i>>2]=n;f[i+8>>2]=-2147483616;f[i+4>>2]=17;o=n;p=452630;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+17>>0]=0;vM(-215,i,456079,450653,124)}n=a+112|0;if((f[n>>2]|0)!=((f[m+4>>2]|0)-(f[d>>2]|0)>>2|0)){d=$Xc(48)|0;f[i>>2]=d;f[i+8>>2]=-2147483600;f[i+4>>2]=33;o=d;p=450786;q=o+33|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+33>>0]=0;vM(-215,i,456079,450653,125)}eKa(j,m);f[k>>2]=0;m=k+4|0;f[m>>2]=0;f[k+8>>2]=0;a:do if(f[n>>2]|0){d=a+48|0;r=k+8|0;s=0;t=0;v=0;while(1){w=(f[j>>2]|0)+(f[(f[d>>2]|0)+(s<<2)>>2]<<2)|0;if((t|0)==(v|0))Tv(k,w);else{f[t>>2]=f[w>>2];f[m>>2]=t+4}w=s+1|0;if(w>>>0>=(f[n>>2]|0)>>>0)break a;s=w;t=f[m>>2]|0;v=f[r>>2]|0}}while(0);n=f[e>>2]|0;a=e+4|0;r=f[a>>2]|0;if((r|0)!=(n|0)){v=r;while(1){r=v+-12|0;f[a>>2]=r;t=f[r>>2]|0;if(!t)x=r;else{r=v+-8|0;s=f[r>>2]|0;if((s|0)!=(t|0))f[r>>2]=s+(~((s+-4-t|0)>>>2)<<2);cYc(t);x=f[a>>2]|0}if((x|0)==(n|0))break;else v=x}}x=f[c>>2]|0;b:do if((f[g>>2]|0)!=(x|0)){v=e+8|0;n=0;t=x;while(1){s=t;r=f[s+(n*12|0)+4>>2]|0;d=f[s+(n*12|0)>>2]|0;s=r-d|0;w=s>>2;y=d;if((y|0)!=(r|0)){if((s|0)<=-4){z=34;break}if((s|0)>0){s=0;r=1;while(1){d=Y(f[y+(s<<2)>>2]|0,r)|0;s=s+1|0;if((s|0)>=(w|0)){A=d;break}else r=d}}else A=1}else A=0;r=f[m>>2]|0;w=f[k>>2]|0;s=r-w|0;y=s>>2;d=w;if((d|0)!=(r|0)){if((s|0)<=-4){z=39;break}if((s|0)>0){s=0;r=1;while(1){w=Y(f[d+(s<<2)>>2]|0,r)|0;s=s+1|0;if((s|0)>=(y|0)){B=w;break}else r=w}}else B=1}else B=0;if((A|0)!=(B|0)){z=42;break}C=f[a>>2]|0;if((C|0)==(f[v>>2]|0))fKa(e,k);else{f[C>>2]=0;r=C+4|0;f[r>>2]=0;f[C+8>>2]=0;y=(f[m>>2]|0)-(f[k>>2]|0)|0;s=y>>2;if(s|0){if(s>>>0>1073741823){z=46;break}d=$Xc(y)|0;f[r>>2]=d;f[C>>2]=d;f[C+8>>2]=d+(s<<2);s=f[k>>2]|0;y=(f[m>>2]|0)-s|0;if((y|0)>0){o1c(d|0,s|0,y|0)|0;f[r>>2]=d+(y>>>2<<2)}}f[a>>2]=(f[a>>2]|0)+12}n=n+1|0;t=f[c>>2]|0;if(n>>>0>=(((f[g>>2]|0)-t|0)/12|0)>>>0)break b}if((z|0)==34){t=$Xc(80)|0;f[i>>2]=t;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=t;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+70>>0]=0;vM(-215,i,454614,454620,161)}else if((z|0)==39){n=$Xc(80)|0;f[i>>2]=n;f[i+8>>2]=-2147483568;f[i+4>>2]=70;o=n;p=454543;q=o+70|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+70>>0]=0;vM(-215,i,454614,454620,161)}else if((z|0)==42){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;t=$Xc(48)|0;f[i>>2]=t;f[i+8>>2]=-2147483600;f[i+4>>2]=37;o=t;p=450820;q=o+37|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+37>>0]=0;vM(-215,i,456079,450653,137)}else if((z|0)==46)kWc(C)}while(0);C=f[k>>2]|0;if(C|0){k=f[m>>2]|0;if((k|0)!=(C|0))f[m>>2]=k+(~((k+-4-C|0)>>>2)<<2);cYc(C)}C=f[j>>2]|0;if(C|0){k=j+4|0;j=f[k>>2]|0;if((j|0)!=(C|0))f[k>>2]=j+(~((j+-4-C|0)>>>2)<<2);cYc(C)}l=0;u=h;return l|0}function wDb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+12|0;i=g;f[h>>2]=107628;f[h+4>>2]=a;f[h+8>>2]=c;f[h+12>>2]=d;f[h+16>>2]=e;j=f[c+40>>2]|0;c=f[d>>2]|0;d=f[a+40>>2]|0;if((((f[j>>2]|0)==(f[d+(f[c>>2]<<2)>>2]|0)?(f[j+4>>2]|0)==(f[d+(f[c+4>>2]<<2)>>2]|0):0)?(f[j+8>>2]|0)==(f[d+(f[c+8>>2]<<2)>>2]|0):0)?(f[j+12>>2]|0)==(f[d+(f[c+12>>2]<<2)>>2]|0):0){f[i>>2]=0;f[i+4>>2]=e;h3(i,h,+(e|0));u=g;return};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;g=$Xc(160)|0;f[i>>2]=g;f[i+8>>2]=-2147483488;f[i+4>>2]=144;o1c(g|0,451085,144)|0;b[g+144>>0]=0;vM(-215,i,452230,450653,215)}function xDb(a){a=a|0;cYc(a);return}function yDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+8>>2]|0;d=f[c+40>>2]|0;e=f[d>>2]|0;g=f[d+4>>2]|0;h=f[d+8>>2]|0;i=f[d+12>>2]|0;d=Y(Y(g,e)|0,h)|0;j=f[a+16>>2]|0;k=((d+-1+j|0)>>>0)/(j>>>0)|0;j=Y(f[b>>2]|0,k)|0;l=Y(f[b+4>>2]|0,k)|0;k=d>>>0<l>>>0?d:l;l=f[c+44>>2]|0;d=(f[l>>2]|0)>>>2;b=(f[l+4>>2]|0)>>>2;m=(f[l+8>>2]|0)>>>2;l=f[a+12>>2]|0;n=f[l>>2]|0;if((f[l+4>>2]|0)==(n|0))lWc(l);l=n;n=f[a+4>>2]|0;a=f[n+44>>2]|0;o=(f[a+(f[l>>2]<<2)>>2]|0)>>>2;p=(f[a+(f[l+4>>2]<<2)>>2]|0)>>>2;q=(f[a+(f[l+8>>2]<<2)>>2]|0)>>>2;r=(f[a+(f[l+12>>2]<<2)>>2]|0)>>>2;l=(j>>>0)/(h>>>0)|0;a=f[n+16>>2]|0;n=f[c+16>>2]|0;if(!(j>>>0<k>>>0&(i|0)>0))return;c=(j>>>0)%(h>>>0)|0;s=(l>>>0)%(g>>>0)|0;t=j;j=(l>>>0)/(g>>>0)|0;while(1){l=a+((Y(j,o)|0)<<2)+((Y(s,p)|0)<<2)+((Y(c,q)|0)<<2)|0;u=n+((Y(j,d)|0)<<2)+((Y(s,b)|0)<<2)+((Y(c,m)|0)<<2)|0;v=0;do{w=l+((Y(v,r)|0)<<2)|0;f[u+(v<<2)>>2]=f[w>>2];v=v+1|0}while((v|0)!=(i|0));v=c+1|0;if((v|0)>=(h|0)){u=s+1|0;if((u|0)>=(g|0)){l=j+1|0;if((l|0)<(e|0)){x=0;y=0;z=l}else{A=11;break}}else{x=0;y=u;z=j}}else{x=v;y=s;z=j}t=t+1|0;if(t>>>0>=k>>>0){A=11;break}else{c=x;s=y;j=z}}if((A|0)==11)return}function zDb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=a+84|0;e=a+112|0;g=f[e>>2]|0;h=a+88|0;i=f[h>>2]|0;j=f[d>>2]|0;k=i-j>>2;l=j;j=i;if(g>>>0<=k>>>0)if(g>>>0<k>>>0?(i=l+(g<<2)|0,(j|0)!=(i|0)):0){f[h>>2]=j+(~((j+-4-i|0)>>>2)<<2);m=g}else m=g;else{oaa(d,g-k|0);m=f[e>>2]|0}k=a+96|0;g=a+100|0;i=f[g>>2]|0;j=f[k>>2]|0;h=i-j>>2;l=j;j=i;if(m>>>0<=h>>>0)if(m>>>0<h>>>0?(i=l+(m<<2)|0,(j|0)!=(i|0)):0){f[g>>2]=j+(~((j+-4-i|0)>>>2)<<2);n=m;o=l}else{n=m;o=l}else{oaa(k,m-h|0);n=f[e>>2]|0;o=f[k>>2]|0}h=f[d>>2]|0;f[h+(n+-1<<2)>>2]=1;f[o+((f[e>>2]|0)+-1<<2)>>2]=1;o=(f[e>>2]|0)+-2|0;if((o|0)<=-1){p=f[b>>2]|0;q=f[h>>2]|0;r=f[p>>2]|0;s=Y(r,q)|0;t=a+44|0;f[t>>2]=s;return}e=f[b>>2]|0;b=f[k>>2]|0;k=f[c>>2]|0;c=o;while(1){o=c+1|0;n=Y(f[e+(o<<2)>>2]|0,f[h+(o<<2)>>2]|0)|0;f[h+(c<<2)>>2]=n;n=Y(f[k+(o<<2)>>2]|0,f[b+(o<<2)>>2]|0)|0;f[b+(c<<2)>>2]=n;if((c|0)>0)c=c+-1|0;else{p=e;break}}q=f[h>>2]|0;r=f[p>>2]|0;s=Y(r,q)|0;t=a+44|0;f[t>>2]=s;return}function ADb(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0;c=$Xc(204)|0;BDb(c,b);f[c>>2]=107648;f[c+100>>2]=1124007936;b=c+108|0;e=c+140|0;g=c+104|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=b;b=c+148|0;f[c+144>>2]=b;g=b;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));d[b+52>>1]=0;b=c;c=$Xc(16)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=107876;f[c+12>>2]=b;f[a>>2]=b;f[a+4>>2]=c;return}function BDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+32|0;e=d+24|0;g=d+20|0;h=d+16|0;i=d+12|0;j=d;qQa(a);k=a+44|0;l=k;m=l+52|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[a>>2]=107924;rQa(a,c);f[e>>2]=0;f[g>>2]=0;f[h>>2]=0;f[i>>2]=0;n=a+56|0;o=a+52|0;sBb(c,a+48|0,k,e,g,i,h,n,o,a+72|0,a+68|0,a+84|0);k=f[e>>2]|0;if((k|0)!=(f[i>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=$Xc(64)|0;f[j>>2]=p;q=j+8|0;f[q>>2]=-2147483584;r=j+4|0;f[r>>2]=51;l=p;s=453039;m=l+51|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));t=p+51|0;b[t>>0]=0;vM(-213,j,453203,451625,74)}i=f[g>>2]|0;if((i|0)!=(f[h>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=$Xc(64)|0;f[j>>2]=p;q=j+8|0;f[q>>2]=-2147483584;r=j+4|0;f[r>>2]=51;l=p;s=453039;m=l+51|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));t=p+51|0;b[t>>0]=0;vM(-213,j,453203,451625,74)}f[a+60>>2]=i;f[a+64>>2]=k;k=j+11|0;b[k>>0]=10;l=j;s=453228;m=l+10|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));b[j+10>>0]=0;i=MGa(NIa(c,j)|0,-1)|0;t=a+96|0;f[t>>2]=i;if((b[k>>0]|0)<0)cYc(f[j>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=j+11|0;b[k>>0]=5;b[j>>0]=b[479226]|0;b[j+1>>0]=b[479227]|0;b[j+2>>0]=b[479228]|0;b[j+3>>0]=b[479229]|0;b[j+4>>0]=b[479230]|0;b[j+5>>0]=0;i=LGa(c,j)|0;p=c+4|0;if((i|0)==(p|0))v=1;else{r=MGa(i+28|0,-1)|0;v=r}if((b[k>>0]|0)<0)cYc(f[j>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=j+11|0;b[k>>0]=5;b[j>>0]=b[453239]|0;b[j+1>>0]=b[453240]|0;b[j+2>>0]=b[453241]|0;b[j+3>>0]=b[453242]|0;b[j+4>>0]=b[453243]|0;b[j+5>>0]=0;r=LGa(c,j)|0;if((r|0)==(p|0))w=0;else{i=MGa(r+28|0,-1)|0;w=i}i=a+80|0;f[i>>2]=w;if((b[k>>0]|0)<0)cYc(f[j>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=j+11|0;b[k>>0]=5;b[j>>0]=b[453245]|0;b[j+1>>0]=b[453246]|0;b[j+2>>0]=b[453247]|0;b[j+3>>0]=b[453248]|0;b[j+4>>0]=b[453249]|0;b[j+5>>0]=0;w=LGa(c,j)|0;if((w|0)==(p|0))x=0;else{p=MGa(w+28|0,-1)|0;x=p}p=a+76|0;f[p>>2]=x;if((b[k>>0]|0)<0)cYc(f[j>>2]|0);if((f[t>>2]|0)%(v|0)|0|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=$Xc(32)|0;f[j>>2]=v;f[j+8>>2]=-2147483616;f[j+4>>2]=24;l=v;s=453251;m=l+24|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));b[v+24>>0]=0;vM(-215,j,453203,451625,85)}if((f[p>>2]|0)>=(f[o>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;y=$Xc(80)|0;f[j>>2]=y;z=j+8|0;f[z>>2]=-2147483568;A=j+4|0;f[A>>2]=66;l=y;s=453276;m=l+66|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));B=y+66|0;b[B>>0]=0;vM(-215,j,453203,451625,87)}if((f[i>>2]|0)<(f[n>>2]|0)){u=d;return}else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;y=$Xc(80)|0;f[j>>2]=y;z=j+8|0;f[z>>2]=-2147483568;A=j+4|0;f[A>>2]=66;l=y;s=453276;m=l+66|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));B=y+66|0;b[B>>0]=0;vM(-215,j,453203,451625,87)}}function CDb(a){a=a|0;NXc(a);cYc(a);return}function DDb(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function EDb(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==451369?a+12|0:0)|0}function FDb(a){a=a|0;cYc(a);return}function GDb(a){a=a|0;var c=0;f[a>>2]=107764;c=a+84|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);return}function HDb(a){a=a|0;var c=0;f[a>>2]=107764;c=a+84|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);MNa(a);cYc(a);return}function IDb(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=107648;c=f[a+196>>2]|0;if(c|0)UXc(c);c=f[a+180>>2]|0;if(c|0){d=a+184|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);cYc(c)}c=f[a+168>>2]|0;if(c|0){e=a+172|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-4-c|0)>>>2)<<2);cYc(c)}c=f[a+156>>2]|0;if(c|0){d=a+160|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);cYc(c)}c=a+100|0;e=a+136|0;d=f[e>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)V$(c);f[e>>2]=0;e=a+116|0;c=a+104|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[c>>2]|0)>0){e=f[a+140>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+144>>2]|0;if((c|0)!=(a+148|0))wL(c);f[a>>2]=107764;c=a+84|0;if((b[c+11>>0]|0)>=0){MNa(a);return}cYc(f[c>>2]|0);MNa(a);return}function JDb(a){a=a|0;IDb(a);cYc(a);return}function KDb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+336|0;g=e+56|0;h=e;i=e+280|0;j=e+224|0;k=e+168|0;l=e+112|0;$Db(a,c,d);d=f[a+4>>2]|0;c=a+8|0;if((d|0)==(f[c>>2]|0)){m=$Xc(16)|0;f[g>>2]=m;f[g+8>>2]=-2147483632;f[g+4>>2]=14;n=m;o=452615;q=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[m+14>>0]=0;vM(-215,g,455619,451625,272)}m=f[f[d+40>>2]>>2]|0;g0(h,d,1,m);f[i>>2]=1124007936;d=i+4|0;o=i+8|0;r=i+40|0;n=d;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[r>>2]=o;s=i+48|0;t=i+44|0;f[t>>2]=s;f[s>>2]=0;f[i+52>>2]=0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=i;jR(h,g);v=h+36|0;w=f[v>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)V$(h);f[v>>2]=0;v=h+16|0;w=h+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){v=f[h+40>>2]|0;x=0;do{f[v+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[w>>2]|0))}w=f[h+44>>2]|0;if((w|0)!=(h+48|0))wL(w);w=f[i>>2]|0;x=((f[f[t>>2]>>2]|0)>>>0)/((675553809>>>(w<<2&28)&15)>>>0)|0;if(x&7|0){v=x+7&-8;x=w&4095;f[j>>2]=1124007936;w=j+4|0;y=j+8|0;z=j+40|0;n=w;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[z>>2]=y;y=j+48|0;A=j+44|0;f[A>>2]=y;f[y>>2]=0;f[j+52>>2]=0;f[g>>2]=m;f[g+4>>2]=v;S$(j,2,g,x);x=i+12|0;B=f[x>>2]|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=B;f[h+4>>2]=v;W$(k,j,g,h);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=-1056833530;f[g+4>>2]=h;f[g+8>>2]=1;f[g+12>>2]=4;mR(k,g,fT()|0)|0;v=f[x>>2]|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=v;W$(l,j,g,h);h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;jR(i,g);h=l+36|0;v=f[h>>2]|0;if(v|0){B=v+12|0;f[B>>2]=(f[B>>2]|0)+1}B=i+36|0;v=f[B>>2]|0;if(v|0?(C=v+12|0,v=f[C>>2]|0,f[C>>2]=v+-1,(v|0)==1):0)V$(i);f[B>>2]=0;v=i+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[d>>2]|0)>0){C=f[r>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0;E=f[d>>2]|0}while((D|0)<(E|0));f[i>>2]=f[l>>2];if((E|0)<3)F=22;else F=24}else{f[i>>2]=f[l>>2];F=22}if((F|0)==22){E=f[l+4>>2]|0;if((E|0)<3){f[d>>2]=E;f[o>>2]=f[l+8>>2];f[x>>2]=f[l+12>>2];x=f[l+44>>2]|0;E=f[t>>2]|0;f[E>>2]=f[x>>2];f[E+4>>2]=f[x+4>>2]}else F=24}if((F|0)==24)U$(i,l);x=l+16|0;f[v>>2]=f[x>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[i+32>>2]=f[l+32>>2];v=f[h>>2]|0;f[B>>2]=v;if(v|0?(B=v+12|0,v=f[B>>2]|0,f[B>>2]=v+-1,(v|0)==1):0)V$(l);f[h>>2]=0;h=l+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[h>>2]|0)>0){x=f[l+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[h>>2]|0))}h=f[l+44>>2]|0;if((h|0)!=(l+48|0))wL(h);h=k+36|0;l=f[h>>2]|0;if(l|0?(v=l+12|0,l=f[v>>2]|0,f[v>>2]=l+-1,(l|0)==1):0)V$(k);f[h>>2]=0;h=k+16|0;l=k+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[l>>2]|0)>0){h=f[k+40>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))wL(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(v=k+12|0,k=f[v>>2]|0,f[v>>2]=k+-1,(k|0)==1):0)V$(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[w>>2]|0)>0){l=f[z>>2]|0;z=0;do{f[l+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[w>>2]|0))}w=f[A>>2]|0;if((w|0)!=(y|0))wL(w)}w=a+100|0;if((w|0)!=(i|0)){y=i+36|0;A=f[y>>2]|0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}z=a+136|0;A=f[z>>2]|0;if(A|0?(l=A+12|0,A=f[l>>2]|0,f[l>>2]=A+-1,(A|0)==1):0)V$(w);f[z>>2]=0;A=a+116|0;l=a+104|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[l>>2]|0)>0){j=f[a+140>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;G=f[l>>2]|0}while((k|0)<(G|0));f[w>>2]=f[i>>2];if((G|0)<3)F=61;else F=63}else{f[w>>2]=f[i>>2];F=61}if((F|0)==61){G=f[d>>2]|0;if((G|0)<3){f[l>>2]=G;f[a+108>>2]=f[o>>2];f[a+112>>2]=f[i+12>>2];o=f[t>>2]|0;G=f[a+144>>2]|0;f[G>>2]=f[o>>2];f[G+4>>2]=f[o+4>>2]}else F=63}if((F|0)==63)U$(w,i);f[A>>2]=f[i+16>>2];f[a+120>>2]=f[i+20>>2];f[a+124>>2]=f[i+24>>2];f[a+128>>2]=f[i+28>>2];f[a+132>>2]=f[i+32>>2];f[z>>2]=f[y>>2]}p[g>>3]=1.0;aEb(a+156|0,m,g);y=f[a+4>>2]|0;if((((f[c>>2]|0)-y|0)/56|0)>>>0>1)g0(g,y+56|0,1,m);else{f[g>>2]=1124007936;y=g+8|0;c=g+40|0;n=g+4|0;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[c>>2]=y;y=g+48|0;f[g+44>>2]=y;f[y>>2]=0;f[g+52>>2]=0}y=a+168|0;c=m+2|0;n=a+172|0;a=f[n>>2]|0;q=f[y>>2]|0;z=a-q>>2;A=q;q=a;if(c>>>0<=z>>>0){if(c>>>0<z>>>0?(a=A+(c<<2)|0,(q|0)!=(a|0)):0)f[n>>2]=q+(~((q+-4-a|0)>>>2)<<2)}else qxb(y,c-z|0);z=g+16|0;c=f[z>>2]|0;a:do if(c){a=f[g+4>>2]|0;if((a|0)<3)H=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{q=f[g+40>>2]|0;n=0;A=1;while(1){w=Y(f[q+(n<<2)>>2]|0,A)|0;n=n+1|0;if((n|0)==(a|0)){H=w;break}else A=w}}if(!((a|0)==0|(H|0)==0)){if((m|0)>0){A=f[g+40>>2]|0;n=A+4|0;q=f[g+44>>2]|0;w=f[g+12>>2]|0;o=f[y>>2]|0;if(f[g>>2]&16384|0){G=0;while(1){f[o+(G<<2)>>2]=f[c+(G<<2)>>2];G=G+1|0;if((G|0)==(m|0))break a}}G=(f[A>>2]|0)==1;a=0;do{do if(!G){l=f[q>>2]|0;if((f[n>>2]|0)==1){I=c+(Y(l,a)|0)|0;break}else{k=(a|0)/(w|0)|0;I=c+(Y(k,l)|0)+(a-(Y(k,w)|0)<<2)|0;break}}else I=c+(a<<2)|0;while(0);f[o+(a<<2)>>2]=f[I>>2];a=a+1|0}while((a|0)!=(m|0))}}else F=88}else F=88;while(0);if((F|0)==88?(m|0)>0:0)g1c(f[y>>2]|0,0,m<<2|0)|0;m=g+36|0;y=f[m>>2]|0;if(y|0?(F=y+12|0,y=f[F>>2]|0,f[F>>2]=y+-1,(y|0)==1):0)V$(g);f[m>>2]=0;m=g+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[m>>2]|0)>0){z=f[g+40>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[m>>2]|0))}m=f[g+44>>2]|0;if((m|0)!=(g+48|0))wL(m);m=i+36|0;g=f[m>>2]|0;if(g|0?(y=g+12|0,g=f[y>>2]|0,f[y>>2]=g+-1,(g|0)==1):0)V$(i);f[m>>2]=0;m=i+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[d>>2]|0)>0){m=f[r>>2]|0;r=0;do{f[m+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[d>>2]|0))}d=f[t>>2]|0;if((d|0)==(s|0)){u=e;return}wL(d);u=e;return}function LDb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=u;u=u+80|0;h=g+56|0;i=g+44|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;if((qS(c,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;gS(c,h);gS(d,i);d=f[h>>2]|0;c=d;if(((f[e>>2]|0)-d|0)!=56){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=$Xc(32)|0;f[j>>2]=d;f[j+8>>2]=-2147483616;f[j+4>>2]=26;p=d;q=451787;r=p+26|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[d+26>>0]=0;vM(-215,j,456135,451625,1114)}d=f[(f[c+40>>2]|0)+4>>2]|0;e=f[(f[a+4>>2]|0)+40>>2]|0;s=f[e+4>>2]|0;if((d|0)%(s|0)|0|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=$Xc(48)|0;f[j>>2]=t;f[j+8>>2]=-2147483600;f[j+4>>2]=41;p=t;q=451998;r=p+41|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[t+41>>0]=0;vM(-215,j,456135,451625,1114)}t=f[i>>2]|0;v=t;if(((f[o>>2]|0)-t|0)!=56){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=$Xc(32)|0;f[j>>2]=t;f[j+8>>2]=-2147483616;f[j+4>>2]=19;p=t;q=452040;r=p+19|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[t+19>>0]=0;vM(-215,j,456135,451625,1114)}if((f[c+16>>2]|0)==(f[v+16>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=$Xc(48)|0;f[j>>2]=c;f[j+8>>2]=-2147483600;f[j+4>>2]=33;p=c;q=452060;r=p+33|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+33>>0]=0;vM(-215,j,456135,451625,1114)}c=(d|0)/(s|0)|0;if((f[(f[v+40>>2]|0)+4>>2]|0)%(c|0)|0|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=$Xc(48)|0;f[j>>2]=v;f[j+8>>2]=-2147483600;f[j+4>>2]=33;p=v;q=452094;r=p+33|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[v+33>>0]=0;vM(-215,j,456135,451625,1117)}v=f[e>>2]|0;e=a+180|0;s=f[e>>2]|0;d=a+184|0;t=f[d>>2]|0;if((t|0)!=(s|0))f[d>>2]=t+(~((t+-4-s|0)>>>2)<<2);s=a+192|0;t=f[s>>2]|0;if(t|0){o=kZc(t,15248,17056,0)|0;if(o){t=f[a+196>>2]|0;w=t;if(t|0)TXc(t);if(!o)x=w;else{xzb(e,v+2|0,o+44|0);x=w}}else x=0;w=f[s>>2]|0;if(w|0?(o=kZc(w,15248,17568,0)|0,o|0):0){w=f[a+196>>2]|0;if(w|0)TXc(w);if(o|0){t=f[o+4>>2]|0;if((f[t>>2]&20479|0)!=16389){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;y=$Xc(80)|0;f[j>>2]=y;z=j+8|0;f[z>>2]=-2147483568;A=j+4|0;f[A>>2]=65;p=y;q=452128;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));B=y+65|0;b[B>>0]=0;vM(-215,j,456135,451625,1133)}o=f[t+4>>2]|0;if((o|0)<3)C=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{D=f[t+40>>2]|0;E=0;F=1;while(1){G=Y(f[D+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(o|0)){C=G;break}else F=G}}if((C|0)!=(v|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;y=$Xc(80)|0;f[j>>2]=y;z=j+8|0;f[z>>2]=-2147483568;A=j+4|0;f[A>>2]=65;p=y;q=452128;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));B=y+65|0;b[B>>0]=0;vM(-215,j,456135,451625,1133)}j=f[t+16>>2]|0;t=v+2|0;B=f[d>>2]|0;y=f[e>>2]|0;q=B-y>>2;p=y;y=B;do if(t>>>0>q>>>0)qxb(e,t-q|0);else{if(t>>>0>=q>>>0)break;B=p+(t<<2)|0;if((y|0)==(B|0))break;f[d>>2]=y+(~((y+-4-B|0)>>>2)<<2)}while(0);y=j+(v<<2)-j|0;if(y|0)q1c(f[e>>2]|0,j|0,y|0)|0;y=f[e>>2]|0;j=f[y+(v+-1<<2)>>2]|0;f[y+(v+1<<2)>>2]=j;f[y+(v<<2)>>2]=j}if(w|0)UXc(w)}if(x|0)UXc(x)}x=i3()|0;w=f[h>>2]|0;j=f[i>>2]|0;f[k>>2]=f[a+44>>2];f[k+4>>2]=f[a+48>>2];f[l>>2]=f[a+60>>2];f[l+4>>2]=f[a+64>>2];f[m>>2]=f[a+52>>2];f[m+4>>2]=f[a+56>>2];f[n>>2]=f[a+68>>2];f[n+4>>2]=f[a+72>>2];XDb(w,j,a+100|0,a+168|0,e,k,l,m,n,f[s>>2]|0,c,(x|0)>1?x:1);hx(i);hx(h);u=g;return}function MDb(a,b){a=a|0;b=b|0;var c=0;if((b|0)==2)if((f[a+40>>2]|0)==3)c=(f[a+68>>2]|0)==(f[a+72>>2]|0);else c=1;else if((b|2|0)!=3)if((b|0)==4)c=nrb()|0;else c=0;else c=1;return c|0}function NDb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ODb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function PDb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function QDb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function RDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+192|0;do if(f[c>>2]|0){d=f[b>>2]|0;if(!d){e=d;break}else{g=0;return g|0}}else e=f[b>>2]|0;while(0);d=f[b+4>>2]|0;if(d|0)TXc(d);f[c>>2]=e;b=a+196|0;h=f[b>>2]|0;f[b>>2]=d;if(!h)i=e;else{UXc(h);i=f[c>>2]|0}if((i|0)==0?(c=f[a+180>>2]|0,h=a+184|0,a=f[h>>2]|0,(a|0)!=(c|0)):0)f[h>>2]=a+(~((a+-4-c|0)>>>2)<<2);g=(i|0)!=0;return g|0}function SDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+112|0;d=c+56|0;e=c;f[d>>2]=1124007936;g=d+4|0;h=d+8|0;i=d+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;l=d+48|0;m=d+44|0;f[m>>2]=l;f[l>>2]=0;f[d+52>>2]=0;f[e>>2]=1124007936;n=e+4|0;o=e+8|0;p=e+40|0;j=n;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[p>>2]=o;j=e+48|0;k=e+44|0;f[k>>2]=j;f[j>>2]=0;f[e+52>>2]=0;q=f[b>>2]|0;Ti[f[(f[q>>2]|0)+88>>2]&511](q,d,e);q=d+16|0;if(f[q>>2]|0){b=f[g>>2]|0;if((b|0)<3)r=Y(f[d+12>>2]|0,f[h>>2]|0)|0;else{h=f[i>>2]|0;s=0;t=1;while(1){v=Y(f[h+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(b|0)){r=v;break}else t=v}}if(!((b|0)==0|(r|0)==0))w=13;else w=7}else w=7;if((w|0)==7)if(f[e+16>>2]|0){r=f[n>>2]|0;if((r|0)<3)x=Y(f[e+12>>2]|0,f[o>>2]|0)|0;else{o=f[p>>2]|0;b=0;t=1;while(1){s=Y(f[o+(b<<2)>>2]|0,t)|0;b=b+1|0;if((b|0)==(r|0)){x=s;break}else t=s}}if(!((r|0)==0|(x|0)==0))w=13;else y=0}else y=0;if((w|0)==13){WDb(a,d,e);y=1}a=e+36|0;w=f[a>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)V$(e);f[a>>2]=0;a=e+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){a=f[p>>2]|0;p=0;do{f[a+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[n>>2]|0))}n=f[k>>2]|0;if((n|0)!=(j|0))wL(n);n=d+36|0;j=f[n>>2]|0;if(j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)V$(d);f[n>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[g>>2]|0)>0){q=f[i>>2]|0;i=0;do{f[q+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[m>>2]|0;if((g|0)==(l|0)){u=c;return y|0}wL(g);u=c;return y|0}function TDb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+48|0;h=d+32|0;i=d+16|0;j=d;k=a+4|0;l=f[a+8>>2]|0;m=f[k>>2]|0;n=m;if((l|0)==(m|0)){o=$Xc(32)|0;f[h>>2]=o;f[h+8>>2]=-2147483616;f[h+4>>2]=17;p=o;q=451710;r=p+17|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+17>>0]=0;vM(-215,h,456079,451625,236)}if(((l-m|0)/56|0)>>>0>1){m=f[n+60>>2]|0;if((m|0)<3)s=Y(f[n+68>>2]|0,f[n+64>>2]|0)|0;else{l=f[n+96>>2]|0;o=0;t=1;while(1){v=Y(f[l+(o<<2)>>2]|0,t)|0;o=o+1|0;if((o|0)==(m|0)){s=v;break}else t=v}}if((s|0)!=(f[f[n+40>>2]>>2]|0)){s=$Xc(64)|0;f[h>>2]=s;f[h+8>>2]=-2147483584;f[h+4>>2]=58;p=s;q=451728;r=p+58|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[s+58>>0]=0;vM(-215,h,456079,451625,237)}}s=c+4|0;t=f[c>>2]|0;m=t;if(((f[s>>2]|0)-t|0)!=12){t=$Xc(32)|0;f[h>>2]=t;f[h+8>>2]=-2147483616;f[h+4>>2]=26;p=t;q=451787;r=p+26|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[t+26>>0]=0;vM(-215,h,456079,451625,238)}t=f[g>>2]|0;o=g+4|0;g=f[o>>2]|0;if((g|0)==(t|0)){w=k;x=c;y=m;z=n}else{n=g;while(1){g=n+-12|0;f[o>>2]=g;m=f[g>>2]|0;if(!m)A=g;else{g=n+-8|0;l=f[g>>2]|0;if((l|0)!=(m|0))f[g>>2]=l+(~((l+-4-m|0)>>>2)<<2);cYc(m);A=f[o>>2]|0}if((A|0)==(t|0))break;else n=A}w=k;x=c;y=f[c>>2]|0;z=f[k>>2]|0}k=f[y>>2]|0;y=f[k+4>>2]|0;c=f[k+8>>2]|0;A=f[k+12>>2]|0;k=f[f[z+40>>2]>>2]|0;f[h>>2]=0;z=h+4|0;f[z>>2]=0;n=a+84|0;t=b[n+11>>0]|0;if(t<<24>>24<0)B=f[a+88>>2]|0;else B=t&255;if(!B){B=c+-1+(f[a+64>>2]<<1)-(Y((f[a+48>>2]|0)+-1|0,f[a+72>>2]|0)|0)|0;f[z>>2]=((B|0)/(f[a+56>>2]|0)|0)+1;B=A+-1+(f[a+60>>2]<<1)-(Y((f[a+44>>2]|0)+-1|0,f[a+68>>2]|0)|0)|0;f[h>>2]=((B|0)/(f[a+52>>2]|0)|0)+1}else{f[i>>2]=A;f[i+4>>2]=c;tBb(i,a+44|0,a+52|0,n,a+68|0,h)}a=(y|0)/(f[(f[(f[w>>2]|0)+40>>2]|0)+4>>2]|0)|0;if((a|0)<=0){C=$Xc(64)|0;f[i>>2]=C;D=i+8|0;f[D>>2]=-2147483584;E=i+4|0;f[E>>2]=59;p=C;q=451814;r=p+59|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));F=C+59|0;b[F>>0]=0;vM(-215,i,456079,451625,260)}if((y|0)%(a|0)|0|0){C=$Xc(64)|0;f[i>>2]=C;D=i+8|0;f[D>>2]=-2147483584;E=i+4|0;f[E>>2]=59;p=C;q=451814;r=p+59|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));F=C+59|0;b[F>>0]=0;vM(-215,i,456079,451625,260)}if((k|0)%(a|0)|0|0){C=$Xc(64)|0;f[i>>2]=C;D=i+8|0;f[D>>2]=-2147483584;E=i+4|0;f[E>>2]=59;p=C;q=451814;r=p+59|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));F=C+59|0;b[F>>0]=0;vM(-215,i,456079,451625,260)}F=f[x>>2]|0;f[i>>2]=f[f[F>>2]>>2];f[i+4>>2]=k;f[i+8>>2]=f[z>>2];f[i+12>>2]=f[h>>2];h=((f[s>>2]|0)-F|0)/12|0;f[j>>2]=0;F=j+4|0;f[F>>2]=0;f[j+8>>2]=0;gOa(j,i,i+16|0);i=e+4|0;s=f[i>>2]|0;z=f[e>>2]|0;k=(s-z|0)/12|0;x=z;z=s;if(h>>>0<=k>>>0){if(h>>>0<k>>>0?(s=x+(h*12|0)|0,(z|0)!=(s|0)):0){x=z;while(1){z=x+-12|0;f[i>>2]=z;C=f[z>>2]|0;if(!C)G=z;else{z=x+-8|0;q=f[z>>2]|0;if((q|0)!=(C|0))f[z>>2]=q+(~((q+-4-C|0)>>>2)<<2);cYc(C);G=f[i>>2]|0}if((G|0)==(s|0))break;else x=G}}}else Nvb(e,h-k|0,j);k=f[j>>2]|0;if(!k){u=d;return 0}j=f[F>>2]|0;if((j|0)!=(k|0))f[F>>2]=j+(~((j+-4-k|0)>>>2)<<2);cYc(k);u=d;return 0}function UDb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[c+4>>2]|0;i=f[c>>2]|0;c=h-i|0;j=f[d>>2]|0;k=j;l=i;if((c|0)!=((f[d+4>>2]|0)-j|0)){j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=31;m=j;n=451584;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[j+31>>0]=0;vM(-215,g,451616,451625,1150)}if((h|0)==(i|0)){p=0;q=0;J=p;u=e;return q|0}i=a+44|0;h=a+48|0;a=(c|0)/12|0;c=0;j=0;d=0;while(1){r=f[k+(c*12|0)+4>>2]|0;s=f[k+(c*12|0)>>2]|0;t=r-s|0;v=t>>2;w=s;if((w|0)!=(r|0)){if((t|0)<=-4){x=9;break}if((t|0)>0){t=0;r=1;while(1){s=Y(f[w+(t<<2)>>2]|0,r)|0;t=t+1|0;if((t|0)>=(v|0)){y=s;break}else r=s}}else y=1}else y=0;r=Y(f[h>>2]|0,f[i>>2]|0)|0;v=u1c(r|0,((r|0)<0)<<31>>31|0,1)|0;r=f[(f[l+(c*12|0)>>2]|0)+4>>2]|0;t=x1c(v|0,J|0,r|0,((r|0)<0)<<31>>31|0)|0;r=x1c(t|1|0,J|0,y|0,((y|0)<0)<<31>>31|0)|0;t=d1c(r|0,J|0,j|0,d|0)|0;r=J;c=c+1|0;if(c>>>0>=a>>>0){p=r;q=t;x=5;break}else{j=t;d=r}}if((x|0)==5){J=p;u=e;return q|0}else if((x|0)==9){x=$Xc(80)|0;f[g>>2]=x;f[g+8>>2]=-2147483568;f[g+4>>2]=70;m=x;n=454543;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[x+70>>0]=0;vM(-215,g,454614,454620,161)}return 0}
function Yzc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+40|0;h=e+36|0;i=e+24|0;j=e;k=e+12|0;f[a>>2]=174276;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;l=a+16|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+36|0;f[a+40>>2]=0;f[a+44>>2]=0;l=a+40|0;f[c>>2]=l;m=f[d>>2]|0;n=d+4|0;if((m|0)!=(n|0)){d=l;o=m;while(1){m=o+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,m,m)|0;m=f[o+4>>2]|0;if(!m){p=o+8|0;q=f[p>>2]|0;if((f[q>>2]|0)==(o|0))r=q;else{q=p;do{p=f[q>>2]|0;q=p+8|0;s=f[q>>2]|0}while((f[s>>2]|0)!=(p|0));r=s}}else{q=m;while(1){s=f[q>>2]|0;if(!s)break;else q=s}r=q}if((r|0)==(n|0))break;else o=r}}r=a+60|0;f[r>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;o=$Xc(16)|0;f[i>>2]=o;f[i+8>>2]=-2147483632;f[i+4>>2]=12;n=o;g=512123;h=n+12|0;do{b[n>>0]=b[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(h|0));b[o+12>>0]=0;o=auc(c,i)|0;do if((o|0)!=(l|0)){d=o+28|0;m=f[d>>2]|0;s=(_i[f[(f[m>>2]|0)+28>>2]&2047](m)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[d>>2]|0;d=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,o+32|0)|0;t=f[d>>2]|0;break}else ig(af(1)|0,22144,0)}else t=12;while(0);f[a+48>>2]=t;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=j+11|0;b[i>>0]=8;t=j;f[t>>2]=1601791339;f[t+4>>2]=1702521203;b[j+8>>0]=0;t=auc(c,j)|0;do if((t|0)!=(l|0)){o=t+28|0;d=f[o>>2]|0;s=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[o>>2]|0;o=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,t+32|0)|0;v=f[o>>2]|0;break}else ig(af(1)|0,22144,0)}else v=20;while(0);t=a+52|0;f[t>>2]=v;if((b[i>>0]|0)<0)cYc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(32)|0;f[k>>2]=j;f[k+8>>2]=-2147483616;f[k+4>>2]=17;n=j;g=512136;h=n+17|0;do{b[n>>0]=b[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(h|0));b[j+17>>0]=0;j=auc(c,k)|0;do if((j|0)!=(l|0)){c=j+28|0;g=f[c>>2]|0;n=(_i[f[(f[g>>2]|0)+28>>2]&2047](g)|0)+4|0;if((f[n>>2]|0)==(f[6379]|0)){n=f[c>>2]|0;c=Mi[f[(f[n>>2]|0)+20>>2]&1023](n,j+32|0)|0;w=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else w=2;while(0);j=a+56|0;f[j>>2]=w;if((b[k+11>>0]|0)>=0){x=w;y=a+20|0;z=f[y>>2]|0;A=a+32|0;f[A>>2]=z;B=f[t>>2]|0;Zzc(a,0,B,x,r);u=e;return}cYc(f[k>>2]|0);x=f[j>>2]|0;y=a+20|0;z=f[y>>2]|0;A=a+32|0;f[A>>2]=z;B=f[t>>2]|0;Zzc(a,0,B,x,r);u=e;return}function Zzc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;f[h>>2]=b;i=e+4|0;j=f[i>>2]|0;if((j|0)==(f[e+8>>2]|0))P3(e,h);else{f[j>>2]=b;f[i>>2]=j+4}if(!((d|0)!=0&(c|0)>0)){u=g;return}j=d+-1|0;d=c;do{c=d;d=d+-1|0;Zzc(a,f[h>>2]|1<<d,d,j,e)}while((c|0)>1);u=g;return}function _zc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=174276;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}Ptc(a+36|0,f[a+40>>2]|0);b=a+4|0;d=f[b>>2]|0;if(!d)return;c=a+8|0;a=f[c>>2]|0;if((a|0)==(d|0))e=d;else{g=a;do{a=g+-72|0;f[c>>2]=a;cuc(a);g=f[c>>2]|0}while((g|0)!=(d|0));e=f[b>>2]|0}cYc(e);return}function $zc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=174276;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}Ptc(a+36|0,f[a+40>>2]|0);b=a+4|0;d=f[b>>2]|0;if(!d){cYc(a);return}c=a+8|0;e=f[c>>2]|0;if((e|0)==(d|0))g=d;else{h=e;do{e=h+-72|0;f[c>>2]=e;cuc(e);h=f[c>>2]|0}while((h|0)!=(d|0));g=f[b>>2]|0}cYc(g);cYc(a);return}function aAc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+80|0;c=b;d=a+4|0;e=a+48|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;j=f[d>>2]|0;k=(i-j|0)/72|0;l=j;j=i;if(g>>>0<=k>>>0){if(g>>>0<k>>>0?(i=l+(g*72|0)|0,(j|0)!=(i|0)):0){l=j;do{j=l+-72|0;f[h>>2]=j;cuc(j);l=f[h>>2]|0}while((l|0)!=(i|0))}}else Wuc(d,g-k|0);if(!(f[e>>2]|0)){u=b;return}k=a+32|0;g=a+52|0;i=a+16|0;l=a+24|0;h=a+28|0;a=0;do{j=f[d>>2]|0;m=j+(a*72|0)|0;Xuc(c,f[k>>2]|0,f[g>>2]|0);Yuc(m,c)|0;cuc(c);n=f[i>>2]|0;o=f[l>>2]|0;p=f[h>>2]|0;Zuc(j+(a*72|0)+12|0,~~(+(((f[j+(a*72|0)+24>>2]|0)+n|0)>>>0)*1.2)>>>0);if(n|0){j=0;do{_uc(m,j,p+((Y(j,o)|0)<<2)|0);j=j+1|0}while((j|0)!=(n|0))}$uc(m);a=a+1|0}while(a>>>0<(f[e>>2]|0)>>>0);u=b;return}function bAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;i=u;u=u+48|0;j=i+12|0;k=i;l=j+4|0;m=j+8|0;o=j+20|0;p=j+16|0;q=j+12|0;f[j>>2]=173220;f[j+24>>2]=g;r=j+12|0;f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;if(!(f[c>>2]|0)){s=0;f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}v=d+12|0;w=d+8|0;d=(g|0)>0;x=c+12|0;y=c+8|0;z=k+11|0;A=k+6|0;B=h+4|0;C=(g|0)<0;D=(g|0)!=0;E=e+12|0;F=e+8|0;e=~g;G=(((e|0)>-2?e:-2)+g<<2)+8|0;e=0;H=0;while(1){Fuc(r,H);f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;if(d){g1c((f[v>>2]|0)+((Y(f[w>>2]|0,e)|0)<<2)|0,-1,G|0)|0;I=g;J=(f[E>>2]|0)+((Y(f[F>>2]|0,e)|0)<<2)|0;while(1){f[J>>2]=2139095039;if((I|0)>1){I=I+-1|0;J=J+4|0}else break}}J=(f[x>>2]|0)+((Y(f[y>>2]|0,e)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,J,h);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[z>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[A>>0]=0;J=auc(h,k)|0;if((J|0)==(B|0))K=1;else{I=J+28|0;L=f[I>>2]|0;M=(_i[f[(f[L>>2]|0)+28>>2]&2047](L)|0)+4|0;if((f[M>>2]|0)!=(f[6363]|0)){N=9;break}M=f[I>>2]|0;I=Mi[f[(f[M>>2]|0)+20>>2]&1023](M,J+32|0)|0;K=b[I>>0]|0}if((b[z>>0]|0)<0)cYc(f[k>>2]|0);I=(f[v>>2]|0)+((Y(f[w>>2]|0,e)|0)<<2)|0;J=(f[E>>2]|0)+((Y(f[F>>2]|0,e)|0)<<2)|0;do if(!(K<<24>>24)){M=f[q>>2]|0;if(C){if((M|0)==(p|0))break;else{O=I;P=J;Q=M}while(1){f[O>>2]=f[Q+20>>2];f[P>>2]=f[Q+16>>2];L=f[Q+4>>2]|0;if(!L){R=Q+8|0;S=f[R>>2]|0;if((f[S>>2]|0)==(Q|0))T=S;else{S=R;do{R=f[S>>2]|0;S=R+8|0;U=f[S>>2]|0}while((f[U>>2]|0)!=(R|0));T=U}}else{S=L;while(1){U=f[S>>2]|0;if(!U)break;else S=U}T=S}if((T|0)==(p|0))break;else{O=O+4|0;P=P+4|0;Q=T}}}else{if(D&(M|0)!=(p|0)){V=0;W=J;X=I;Z=M}else break;while(1){f[X>>2]=f[Z+20>>2];f[W>>2]=f[Z+16>>2];L=f[Z+4>>2]|0;if(!L){U=Z+8|0;R=f[U>>2]|0;if((f[R>>2]|0)==(Z|0))_=R;else{R=U;do{U=f[R>>2]|0;R=U+8|0;$=f[R>>2]|0}while((f[$>>2]|0)!=(U|0));_=$}}else{R=L;while(1){S=f[R>>2]|0;if(!S)break;else R=S}_=R}V=V+1|0;if(!((V|0)<(g|0)&(_|0)!=(p|0)))break;else{W=W+4|0;X=X+4|0;Z=_}}}}else ei[f[(f[j>>2]|0)+24>>2]&511](j,I,J,g);while(0);e=e+1|0;J=f[p>>2]|0;if(e>>>0>=(f[c>>2]|0)>>>0){s=J;N=3;break}else H=J}if((N|0)==3){f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}else if((N|0)==9)ig(af(1)|0,22144,0)}function cAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+48|0;j=i+12|0;k=i;if((f[c>>2]|0)!=1){eKc(512345,57,1,f[46249]|0)|0;l=-1;u=i;return l|0}m=f[d+4>>2]|0;o=(m|0)==0;p=o?0:f[d+12>>2]|0;d=o?0:f[e+12>>2]|0;n[j+8>>2]=3402823466385288598117041.0e14;f[j+16>>2]=0;e=j+20|0;f[e>>2]=0;o=j+16|0;q=j+12|0;f[q>>2]=o;f[j>>2]=173140;n[j+24>>2]=g;b[j+4>>0]=1;r=j+12|0;Fuc(r,0);f[e>>2]=0;f[r>>2]=o;f[o>>2]=0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,f[c+12>>2]|0,h);do if((m|0)>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;c=k+11|0;b[c>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[k+6>>0]=0;a=auc(h,k)|0;do if((a|0)!=(h+4|0)){r=a+28|0;s=f[r>>2]|0;t=(_i[f[(f[s>>2]|0)+28>>2]&2047](s)|0)+4|0;if((f[t>>2]|0)==(f[6363]|0)){t=f[r>>2]|0;r=Mi[f[(f[t>>2]|0)+20>>2]&1023](t,a+32|0)|0;v=(b[r>>0]|0)!=0;break}else ig(af(1)|0,22144,0)}else v=1;while(0);if((b[c>>0]|0)<0)cYc(f[k>>2]|0);if(v){ei[f[(f[j>>2]|0)+24>>2]&511](j,p,d,m);break}a=f[q>>2]|0;if((m|0)<0){if((a|0)==(o|0))break;else{w=p;x=d;y=a}while(1){f[w>>2]=f[y+20>>2];f[x>>2]=f[y+16>>2];r=f[y+4>>2]|0;if(!r){t=y+8|0;s=f[t>>2]|0;if((f[s>>2]|0)==(y|0))z=s;else{s=t;do{t=f[s>>2]|0;s=t+8|0;A=f[s>>2]|0}while((f[A>>2]|0)!=(t|0));z=A}}else{s=r;while(1){A=f[s>>2]|0;if(!A)break;else s=A}z=s}if((z|0)==(o|0))break;else{w=w+4|0;x=x+4|0;y=z}}}else{if((m|0)!=0&(a|0)!=(o|0)){B=0;C=d;D=p;E=a}else break;while(1){f[D>>2]=f[E+20>>2];f[C>>2]=f[E+16>>2];c=f[E+4>>2]|0;if(!c){r=E+8|0;A=f[r>>2]|0;if((f[A>>2]|0)==(E|0))F=A;else{A=r;do{r=f[A>>2]|0;A=r+8|0;t=f[A>>2]|0}while((f[t>>2]|0)!=(r|0));F=t}}else{A=c;while(1){s=f[A>>2]|0;if(!s)break;else A=s}F=A}B=B+1|0;if(!((B|0)<(m|0)&(F|0)!=(o|0)))break;else{C=C+4|0;D=D+4|0;E=F}}}}while(0);F=f[e>>2]|0;f[j>>2]=173180;Fuc(j+12|0,f[o>>2]|0);l=F;u=i;return l|0}function dAc(a,b){a=a|0;b=b|0;var c=0;eKc(a+48|0,4,1,b)|0;eKc(a+52|0,4,1,b)|0;eKc(a+56|0,4,1,b)|0;c=a+16|0;eKc(c,16,1,b)|0;eKc(f[a+28>>2]|0,4,Y(f[a+20>>2]|0,f[c>>2]|0)|0,b)|0;return}function eAc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+32|0;e=d+24|0;g=d;h=d+12|0;i=a+48|0;if((NLc(i,4,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+52|0;if((NLc(j,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=a+56|0;if((NLc(k,4,1,c)|0)!=1){l=af(60)|0;Jtc(l,511860);ig(l|0,22128,1)}tuc(c,a+16|0);Yi[f[(f[a>>2]|0)+8>>2]&4095](a);c=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=c;c=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=9;m=h;n=512094;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[h+9>>0]=0;p=Ntc(c,e,h)|0;q=f[p>>2]|0;if(!q){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[s+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[p>>2]=r;s=f[f[c>>2]>>2]|0;if(!s)t=r;else{f[c>>2]=s;t=f[p>>2]|0}UQ(f[a+40>>2]|0,t);t=a+44|0;f[t>>2]=(f[t>>2]|0)+1;v=r}else v=q;q=v+28|0;r=f[q>>2]|0;t=v+32|0;mi[f[f[r>>2]>>2]&2047](r,t);f[q>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,t);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;m=h;n=512123;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[h+12>>0]=0;h=Ntc(c,e,g)|0;l=f[h>>2]|0;if(!l){t=$Xc(36)|0;q=t+16|0;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];f[q+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[h>>2]=t;q=f[f[c>>2]>>2]|0;if(!q)w=t;else{f[c>>2]=q;w=f[h>>2]|0}UQ(f[a+40>>2]|0,w);w=a+44|0;f[w>>2]=(f[w>>2]|0)+1;x=t}else x=l;l=x+28|0;t=f[l>>2]|0;w=x+32|0;mi[f[f[t>>2]>>2]&2047](t,w);f[l>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,i,w);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;w=g+11|0;b[w>>0]=8;i=g;f[i>>2]=1601791339;f[i+4>>2]=1702521203;b[g+8>>0]=0;i=Ntc(c,e,g)|0;l=f[i>>2]|0;if(!l){t=$Xc(36)|0;x=t+16|0;f[x>>2]=f[g>>2];f[x+4>>2]=f[g+4>>2];f[x+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;x=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=x;f[i>>2]=t;x=f[f[c>>2]>>2]|0;if(!x)y=t;else{f[c>>2]=x;y=f[i>>2]|0}UQ(f[a+40>>2]|0,y);y=a+44|0;f[y>>2]=(f[y>>2]|0)+1;z=t}else z=l;l=z+28|0;t=f[l>>2]|0;y=z+32|0;mi[f[f[t>>2]>>2]&2047](t,y);f[l>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,j,y);if((b[w>>0]|0)<0)cYc(f[g>>2]|0);w=$Xc(32)|0;f[g>>2]=w;f[g+8>>2]=-2147483616;f[g+4>>2]=17;m=w;n=512136;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[w+17>>0]=0;w=Ntc(c,e,g)|0;n=f[w>>2]|0;if(!n){m=$Xc(36)|0;o=m+16|0;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[m+28>>2]=172888;f[m+32>>2]=0;o=f[e>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=o;f[w>>2]=m;o=f[f[c>>2]>>2]|0;if(!o)A=m;else{f[c>>2]=o;A=f[w>>2]|0}UQ(f[a+40>>2]|0,A);A=a+44|0;f[A>>2]=(f[A>>2]|0)+1;B=m}else B=n;n=B+28|0;m=f[n>>2]|0;A=B+32|0;mi[f[f[m>>2]>>2]&2047](m,A);f[n>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,k,A);if((b[g+11>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function fAc(a){a=a|0;return f[a+16>>2]|0}function gAc(a){a=a|0;return f[a+32>>2]|0}function hAc(a){a=a|0;return f[a+16>>2]<<2|0}function iAc(a){a=a|0;return 6}function jAc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+36>>2]|0;i=b+40|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function kAc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;lAc(a,c,b);return}function lAc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;d=f[a+4>>2]|0;e=f[a+8>>2]|0;if((d|0)==(e|0))return;g=a+64|0;h=a+28|0;i=a+24|0;j=a+20|0;k=3-b|0;l=a+60|0;a=d;do{d=ruc(a,b)|0;m=f[l>>2]|0;o=f[g>>2]|0;if((m|0)!=(o|0)){p=m;do{m=suc(a,f[p>>2]^d)|0;if(m|0?(q=f[m>>2]|0,r=f[m+4>>2]|0,q>>>0<r>>>0):0){m=q;do{q=f[m>>2]|0;s=(f[h>>2]|0)+((Y(f[i>>2]|0,q)|0)<<2)|0;t=b+(f[j>>2]<<2)|0;u=t+-12|0;v=((u>>>0<b>>>0?b:u)+12+k|0)>>>4<<2;w=s+(v<<2)|0;if(u>>>0>b>>>0){x=b;y=s;z=0.0;while(1){A=+n[x>>2]-+n[y>>2];B=+n[x+4>>2]-+n[y+4>>2];C=+n[x+8>>2]-+n[y+8>>2];D=+n[x+12>>2]-+n[y+12>>2];E=z+(A*A+B*B+C*C+D*D);x=x+16|0;if(x>>>0>=u>>>0){F=E;break}else{y=y+16|0;z=E}}}else F=0.0;y=b+(v<<2)|0;if(y>>>0<t>>>0){u=w;z=F;x=y;while(1){E=+n[x>>2]-+n[u>>2];x=x+4|0;D=z+E*E;if(x>>>0>=t>>>0){G=D;break}else{u=u+4|0;z=D}}}else G=F;Hg[f[(f[c>>2]|0)+12>>2]&15](c,G,q);m=m+4|0}while(m>>>0<r>>>0)}p=p+4|0}while((p|0)!=(o|0))}a=a+72|0}while((a|0)!=(e|0));return}function mAc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0;h=u;u=u+32|0;i=h;jvc(i,d);a:do if((b|0)>0){d=i+16|0;j=f[i>>2]|0;k=a+24|0;l=a+20|0;m=a+16|0;o=f[i+12>>2]|0;p=f[d>>2]|0;q=0;b:while(1){r=e+(q<<2)|0;s=(q|0)>0;if((p|0)==(o|0)){t=q;v=j;w=22;break a}else x=p;while(1){y=x;x=x+1|0;f[d>>2]=x;z=f[j+(y<<2)>>2]|0;if((z|0)<0)break b;y=f[c+(z<<2)>>2]|0;f[r>>2]=y;if(!s)break;z=f[k>>2]|0;A=f[l>>2]|0;B=z+((Y(A,y)|0)<<2)|0;y=B+(f[m>>2]<<2)|0;C=y+-12|0;D=((C>>>0<B>>>0?B:C)+12+(3-B)|0)>>>4<<2;E=B+(D<<2)|0;F=E>>>0<y>>>0;if(B>>>0>=C>>>0){if(F){G=0;H=0;while(1){I=z+((Y(f[e+(G<<2)>>2]|0,A)|0)<<2)+(D<<2)|0;J=0.0;K=E;while(1){L=+n[K>>2]-+n[I>>2];K=K+4|0;J=J+L*L;if(K>>>0>=y>>>0)break;else I=I+4|0}I=J<1.0e-16?1:H;G=G+1|0;if((G|0)==(q|0)){M=I;w=19;break}else H=I}}}else{H=0;G=0;while(1){I=z+((Y(f[e+(H<<2)>>2]|0,A)|0)<<2)|0;K=B;N=I;L=0.0;while(1){O=+n[K>>2]-+n[N>>2];P=+n[K+4>>2]-+n[N+4>>2];Q=+n[K+8>>2]-+n[N+8>>2];R=+n[K+12>>2]-+n[N+12>>2];L=L+(O*O+P*P+Q*Q+R*R);K=K+16|0;if(K>>>0>=C>>>0)break;else N=N+16|0}if(F){N=I+(D<<2)|0;J=L;K=E;while(1){R=+n[K>>2]-+n[N>>2];K=K+4|0;Q=J+R*R;if(K>>>0>=y>>>0){S=Q;break}else{N=N+4|0;J=Q}}}else S=L;N=S<1.0e-16?1:G;H=H+1|0;if((H|0)==(q|0)){M=N;w=19;break}else G=N}}if((w|0)==19?(w=0,(M&1)==0):0)break;if((x|0)==(o|0)){t=q;v=j;w=22;break a}}s=q+1|0;if((s|0)<(b|0)){p=x;q=s}else{t=s;v=j;w=22;break a}}f[g>>2]=q;T=j}else{t=0;v=f[i>>2]|0;w=22}while(0);if((w|0)==22){f[g>>2]=t;if(!v){u=h;return}else T=v}v=i+4|0;i=f[v>>2]|0;if((i|0)!=(T|0))f[v>>2]=i+(~((i+-4-T|0)>>>2)<<2);cYc(T);u=h;return}function nAc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0;h=OR()|0;i=h;j=f[i+4>>2]|0;k=x1c(f[i>>2]|0,0,-130063606,0)|0;i=d1c(k|0,J|0,j|0,0)|0;j=h;f[j>>2]=i;f[j+4>>2]=J;f[e>>2]=f[c+(~~(+(d|0)*(+(i&2147483647|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){l=1;f[g>>2]=l;return}i=(d|0)>0;j=a+24|0;h=a+20|0;k=a+16|0;a=1;while(1){if(!i){l=a;m=18;break}o=f[j>>2]|0;p=f[h>>2]|0;q=o+((Y(p,f[e>>2]|0)|0)<<2)|0;r=f[k>>2]|0;s=q+(r<<2)|0;t=s+-12|0;u=((t>>>0<q>>>0?q:t)+12+(3-q)|0)>>>4<<2;v=q>>>0<t>>>0;w=q+(u<<2)|0;x=w>>>0<s>>>0;y=(a|0)>1;z=0;A=0.0;B=-1;while(1){C=o+((Y(f[c+(z<<2)>>2]|0,p)|0)<<2)|0;D=C+(u<<2)|0;if(v){E=q;F=C;G=0.0;while(1){H=+n[E>>2]-+n[F>>2];I=+n[E+4>>2]-+n[F+4>>2];K=+n[E+8>>2]-+n[F+8>>2];L=+n[E+12>>2]-+n[F+12>>2];M=G+(H*H+I*I+K*K+L*L);E=E+16|0;if(E>>>0>=t>>>0){N=M;break}else{F=F+16|0;G=M}}}else N=0.0;if(x){F=D;G=N;E=w;while(1){M=+n[E>>2]-+n[F>>2];E=E+4|0;L=G+M*M;if(E>>>0>=s>>>0){O=L;break}else{F=F+4|0;G=L}}}else O=N;if(y){F=1;G=O;while(1){E=o+((Y(p,f[e+(F<<2)>>2]|0)|0)<<2)|0;D=E+(r<<2)|0;P=D+-12|0;Q=((P>>>0<E>>>0?E:P)+12+(3-E)|0)>>>4<<2;R=C+(Q<<2)|0;if(E>>>0<P>>>0){S=E;T=C;L=0.0;while(1){M=+n[S>>2]-+n[T>>2];K=+n[S+4>>2]-+n[T+4>>2];I=+n[S+8>>2]-+n[T+8>>2];H=+n[S+12>>2]-+n[T+12>>2];U=L+(M*M+K*K+I*I+H*H);S=S+16|0;if(S>>>0>=P>>>0){V=U;break}else{T=T+16|0;L=U}}}else V=0.0;T=E+(Q<<2)|0;if(T>>>0<D>>>0){P=R;L=V;S=T;while(1){U=+n[S>>2]-+n[P>>2];S=S+4|0;H=L+U*U;if(S>>>0>=D>>>0){W=H;break}else{P=P+4|0;L=H}}}else W=V;L=W<G?W:G;F=F+1|0;if((F|0)==(a|0)){X=L;break}else G=L}}else X=O;F=X>A;B=F?z:B;z=z+1|0;if((z|0)==(d|0))break;else A=F?X:A}if((B|0)==-1){l=a;m=18;break}f[e+(a<<2)>>2]=f[c+(B<<2)>>2];z=a+1|0;if((z|0)<(b|0))a=z;else{l=z;m=18;break}}if((m|0)==18){f[g>>2]=l;return}}function oAc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0;h=u;u=u+16|0;i=h;j=bYc(d>>>0>1073741823?-1:d<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;o=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(o|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=c+(~~(+(d|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[e>>2]=f[m>>2];l=(d|0)>0;if(l){k=f[a+24>>2]|0;o=f[a+20>>2]|0;p=k+((Y(f[m>>2]|0,o)|0)<<2)|0;m=f[a+16>>2]|0;q=0;r=0.0;while(1){s=k+((Y(o,f[c+(q<<2)>>2]|0)|0)<<2)|0;t=s+(m<<2)|0;v=t+-12|0;w=((v>>>0<s>>>0?s:v)+12+(3-s)|0)>>>4<<2;x=p+(w<<2)|0;if(s>>>0<v>>>0){y=s;z=p;A=0.0;while(1){B=+n[y>>2]-+n[z>>2];C=+n[y+4>>2]-+n[z+4>>2];D=+n[y+8>>2]-+n[z+8>>2];E=+n[y+12>>2]-+n[z+12>>2];F=A+(B*B+C*C+D*D+E*E);y=y+16|0;if(y>>>0>=v>>>0){G=F;break}else{z=z+16|0;A=F}}}else G=0.0;z=s+(w<<2)|0;if(z>>>0<t>>>0){v=x;A=G;y=z;while(1){F=+n[y>>2]-+n[v>>2];y=y+4|0;E=A+F*F;if(y>>>0>=t>>>0){H=E;break}else{v=v+4|0;A=E}}}else H=G;n[j+(q<<2)>>2]=H;A=r+H;q=q+1|0;if((q|0)==(d|0)){I=A;break}else r=A}}else I=0.0;if((b|0)<=1){K=1;f[g>>2]=K;dYc(j);u=h;return}q=d+-1|0;p=(d|0)>1;m=a+24|0;o=a+20|0;k=a+16|0;a=1;r=I;while(1){v=OR()|0;t=v;y=f[t+4>>2]|0;x=x1c(f[t>>2]|0,0,-130063606,0)|0;t=d1c(x|0,J|0,y|0,0)|0;y=v;f[y>>2]=t;f[y+4>>2]=J;a:do if(p){y=0;I=r*(+(t&2147483647|0)*4.656612873077393e-10)+0.0;while(1){H=+n[j+(y<<2)>>2];if(I<=H){L=y;break a}v=y+1|0;if((v|0)<(q|0)){y=v;I=I-H}else{L=v;break}}}else L=0;while(0);if(l){t=f[m>>2]|0;y=f[o>>2]|0;v=c+(L<<2)|0;x=f[v>>2]|0;w=t+((Y(x,y)|0)<<2)|0;s=f[k>>2]|0;z=0;I=0.0;do{M=t+((Y(y,f[c+(z<<2)>>2]|0)|0)<<2)|0;N=M+(s<<2)|0;O=N+-12|0;P=((O>>>0<M>>>0?M:O)+12+(3-M)|0)>>>4<<2;Q=w+(P<<2)|0;if(M>>>0<O>>>0){R=M;S=w;H=0.0;while(1){G=+n[R>>2]-+n[S>>2];A=+n[R+4>>2]-+n[S+4>>2];E=+n[R+8>>2]-+n[S+8>>2];F=+n[R+12>>2]-+n[S+12>>2];D=H+(G*G+A*A+E*E+F*F);R=R+16|0;if(R>>>0>=O>>>0){T=D;break}else{S=S+16|0;H=D}}}else T=0.0;S=M+(P<<2)|0;if(S>>>0<N>>>0){O=Q;H=T;R=S;while(1){D=+n[R>>2]-+n[O>>2];R=R+4|0;F=H+D*D;if(R>>>0>=N>>>0){U=F;break}else{O=O+4|0;H=F}}}else U=T;H=+n[j+(z<<2)>>2];I=I+(H<U?H:U);z=z+1|0}while((z|0)!=(d|0));f[e+(a<<2)>>2]=x;if(l){z=f[m>>2]|0;w=f[o>>2]|0;s=z+((Y(f[v>>2]|0,w)|0)<<2)|0;y=f[k>>2]|0;t=0;do{O=z+((Y(w,f[c+(t<<2)>>2]|0)|0)<<2)|0;N=O+(y<<2)|0;R=N+-12|0;Q=((R>>>0<O>>>0?O:R)+12+(3-O)|0)>>>4<<2;P=s+(Q<<2)|0;if(O>>>0<R>>>0){M=O;S=s;H=0.0;while(1){F=+n[M>>2]-+n[S>>2];D=+n[M+4>>2]-+n[S+4>>2];E=+n[M+8>>2]-+n[S+8>>2];A=+n[M+12>>2]-+n[S+12>>2];G=H+(F*F+D*D+E*E+A*A);M=M+16|0;if(M>>>0>=R>>>0){V=G;break}else{S=S+16|0;H=G}}}else V=0.0;S=O+(Q<<2)|0;if(S>>>0<N>>>0){R=P;H=V;M=S;while(1){G=+n[M>>2]-+n[R>>2];M=M+4|0;A=H+G*G;if(M>>>0>=N>>>0){W=A;break}else{R=R+4|0;H=A}}}else W=V;n[i>>2]=W;R=j+(t<<2)|0;f[R>>2]=f[(+n[R>>2]<W?R:i)>>2];t=t+1|0}while((t|0)!=(d|0));X=I}else X=I}else{f[e+(a<<2)>>2]=f[c+(L<<2)>>2];X=0.0}a=a+1|0;if((a|0)==(b|0)){K=b;break}else r=X}f[g>>2]=K;dYc(j);u=h;return}function pAc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;h=u;u=u+16|0;i=h;j=bYc(d>>>0>1073741823?-1:d<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;o=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(o|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=c+(~~(+(d|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[e>>2]=f[m>>2];l=(d|0)>0;if(l){k=f[a+24>>2]|0;o=f[a+20>>2]|0;p=k+((Y(f[m>>2]|0,o)|0)<<2)|0;m=f[a+16>>2]|0;q=0;do{r=k+((Y(o,f[c+(q<<2)>>2]|0)|0)<<2)|0;s=r+(m<<2)|0;t=s+-12|0;v=((t>>>0<r>>>0?r:t)+12+(3-r)|0)>>>4<<2;w=p+(v<<2)|0;if(r>>>0<t>>>0){x=r;y=p;z=0.0;while(1){A=+n[x>>2]-+n[y>>2];B=+n[x+4>>2]-+n[y+4>>2];C=+n[x+8>>2]-+n[y+8>>2];D=+n[x+12>>2]-+n[y+12>>2];E=z+(A*A+B*B+C*C+D*D);x=x+16|0;if(x>>>0>=t>>>0){F=E;break}else{y=y+16|0;z=E}}}else F=0.0;y=r+(v<<2)|0;if(y>>>0<s>>>0){t=w;z=F;x=y;while(1){E=+n[x>>2]-+n[t>>2];x=x+4|0;D=z+E*E;if(x>>>0>=s>>>0){G=D;break}else{t=t+4|0;z=D}}}else G=F;n[j+(q<<2)>>2]=G;q=q+1|0}while((q|0)!=(d|0))}if((b|0)<=1){H=1;f[g>>2]=H;dYc(j);u=h;return}q=a+24|0;p=a+20|0;m=a+16|0;a=1;do{if(l){G=0.0;o=0;F=-1.0;k=0;while(1){z=+n[j+(k<<2)>>2];if(z>G*1.2999999523162842){t=f[q>>2]|0;s=f[p>>2]|0;x=t+((Y(f[c+(k<<2)>>2]|0,s)|0)<<2)|0;w=f[m>>2]|0;v=0;D=0.0;do{r=t+((Y(s,f[c+(v<<2)>>2]|0)|0)<<2)|0;y=r+(w<<2)|0;I=y+-12|0;K=((I>>>0<r>>>0?r:I)+12+(3-r)|0)>>>4<<2;L=x+(K<<2)|0;if(r>>>0<I>>>0){M=r;N=x;E=0.0;while(1){C=+n[M>>2]-+n[N>>2];B=+n[M+4>>2]-+n[N+4>>2];A=+n[M+8>>2]-+n[N+8>>2];O=+n[M+12>>2]-+n[N+12>>2];P=E+(C*C+B*B+A*A+O*O);M=M+16|0;if(M>>>0>=I>>>0){Q=P;break}else{N=N+16|0;E=P}}}else Q=0.0;N=r+(K<<2)|0;if(N>>>0<y>>>0){I=L;E=Q;M=N;while(1){P=+n[M>>2]-+n[I>>2];M=M+4|0;O=E+P*P;if(M>>>0>=y>>>0){R=O;break}else{I=I+4|0;E=O}}}else R=Q;E=+n[j+(v<<2)>>2];D=D+(E<R?E:R);v=v+1|0}while((v|0)!=(d|0));v=!(F<0.0)&!(D<=F);S=v?G:z;T=v?o:k;U=v?F:D}else{S=G;T=o;U=F}k=k+1|0;if((k|0)==(d|0))break;else{G=S;o=T;F=U}}o=c+(T<<2)|0;f[e+(a<<2)>>2]=f[o>>2];if(l){k=f[q>>2]|0;v=f[p>>2]|0;x=k+((Y(f[o>>2]|0,v)|0)<<2)|0;o=f[m>>2]|0;w=0;do{s=k+((Y(v,f[c+(w<<2)>>2]|0)|0)<<2)|0;t=s+(o<<2)|0;I=t+-12|0;y=((I>>>0<s>>>0?s:I)+12+(3-s)|0)>>>4<<2;M=x+(y<<2)|0;if(s>>>0<I>>>0){L=s;K=x;F=0.0;while(1){G=+n[L>>2]-+n[K>>2];E=+n[L+4>>2]-+n[K+4>>2];O=+n[L+8>>2]-+n[K+8>>2];P=+n[L+12>>2]-+n[K+12>>2];A=F+(G*G+E*E+O*O+P*P);L=L+16|0;if(L>>>0>=I>>>0){V=A;break}else{K=K+16|0;F=A}}}else V=0.0;K=s+(y<<2)|0;if(K>>>0<t>>>0){I=M;F=V;L=K;while(1){D=+n[L>>2]-+n[I>>2];L=L+4|0;z=F+D*D;if(L>>>0>=t>>>0){W=z;break}else{I=I+4|0;F=z}}}else W=V;n[i>>2]=W;I=j+(w<<2)|0;f[I>>2]=f[(+n[I>>2]<W?I:i)>>2];w=w+1|0}while((w|0)!=(d|0))}}else f[e+(a<<2)>>2]=f[c>>2];a=a+1|0}while((a|0)!=(b|0));H=b;f[g>>2]=H;dYc(j);u=h;return}function qAc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=174336;b=a+52|0;c=f[b>>2]|0;a:do if(c|0?(d=a+92|0,e=f[d>>2]|0,(e|0)>0):0){g=0;h=e;e=c;while(1){i=f[e+(g<<2)>>2]|0;if(!i)j=h;else{dYc(i);f[(f[b>>2]|0)+(g<<2)>>2]=0;j=f[d>>2]|0}i=g+1|0;if((i|0)>=(j|0))break a;g=i;h=j;e=f[b>>2]|0}}while(0);j=f[a+48>>2]|0;if(j|0)dYc(j);j=f[b>>2]|0;if(j|0)dYc(j);j=a+64|0;b=f[j>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;kIc(b);f[j>>2]=c}while((c|0)!=0)}Ptc(a+28|0,f[a+32>>2]|0);return}function rAc(a){a=a|0;qAc(a);cYc(a);return}function sAc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=a+88|0;if((f[b>>2]|0)<2){c=af(60)|0;Jtc(c,513040);ig(c|0,22128,1)}c=a+52|0;d=f[c>>2]|0;e=a+92|0;g=f[e>>2]|0;a:do if(!d)h=g;else{if((g|0)>0){i=0;j=d;k=g}else return;while(1){l=f[j+(i<<2)>>2]|0;if(!l)m=k;else{dYc(l);f[(f[c>>2]|0)+(i<<2)>>2]=0;m=f[e>>2]|0}l=i+1|0;if((l|0)>=(m|0)){h=m;break a}i=l;j=f[c>>2]|0;k=m}}while(0);if((h|0)<=0)return;h=a+40|0;m=a+60|0;k=a+80|0;j=f[46249]|0;i=a+64|0;g=a+68|0;d=a+48|0;l=a+76|0;n=0;do{o=f[h>>2]|0;p=bYc(o>>>0>1073741823?-1:o<<2)|0;f[(f[c>>2]|0)+(n<<2)>>2]=p;if(!o)q=0;else{o=f[(f[c>>2]|0)+(n<<2)>>2]|0;p=0;do{f[o+(p<<2)>>2]=p;p=p+1|0;r=f[h>>2]|0}while(p>>>0<r>>>0);q=r}p=f[m>>2]|0;do if((p|0)<32){f[k>>2]=(f[k>>2]|0)+p;o=jIc(8192)|0;if(!o){eKc(513012,27,1,j)|0;s=0;t=f[h>>2]|0;break}else{f[o>>2]=f[i>>2];f[i>>2]=o;f[m>>2]=8188;r=o+4|0;f[g>>2]=r;u=r;v=8188;w=19;break}}else{u=f[g>>2]|0;v=p;w=19}while(0);if((w|0)==19){w=0;f[g>>2]=u+32;f[m>>2]=v+-32;f[l>>2]=(f[l>>2]|0)+32;s=u;t=q}f[(f[d>>2]|0)+(n<<2)>>2]=s;IAc(a,f[(f[d>>2]|0)+(n<<2)>>2]|0,f[(f[c>>2]|0)+(n<<2)>>2]|0,t,f[b>>2]|0,0);n=n+1|0}while((n|0)<(f[e>>2]|0));return}function tAc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;i=u;u=u+48|0;j=i+12|0;k=i;l=j+4|0;m=j+8|0;o=j+20|0;p=j+16|0;q=j+12|0;f[j>>2]=173220;f[j+24>>2]=g;r=j+12|0;f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;if(!(f[c>>2]|0)){s=0;f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}v=c+12|0;w=c+8|0;x=k+11|0;y=k+6|0;z=h+4|0;A=d+12|0;B=d+8|0;d=e+12|0;C=e+8|0;e=(g|0)<0;D=(g|0)!=0;E=0;F=0;while(1){Fuc(r,F);f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;G=(f[v>>2]|0)+((Y(f[w>>2]|0,E)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,G,h);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[x>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[y>>0]=0;G=auc(h,k)|0;if((G|0)==(z|0))H=1;else{I=G+28|0;J=f[I>>2]|0;K=(_i[f[(f[J>>2]|0)+28>>2]&2047](J)|0)+4|0;if((f[K>>2]|0)!=(f[6363]|0)){L=6;break}K=f[I>>2]|0;I=Mi[f[(f[K>>2]|0)+20>>2]&1023](K,G+32|0)|0;H=b[I>>0]|0}if((b[x>>0]|0)<0)cYc(f[k>>2]|0);I=(f[A>>2]|0)+((Y(f[B>>2]|0,E)|0)<<2)|0;G=(f[d>>2]|0)+((Y(f[C>>2]|0,E)|0)<<2)|0;do if(!(H<<24>>24)){K=f[q>>2]|0;if(e){if((K|0)==(p|0))break;else{M=I;N=G;O=K}while(1){f[M>>2]=f[O+20>>2];f[N>>2]=f[O+16>>2];J=f[O+4>>2]|0;if(!J){P=O+8|0;Q=f[P>>2]|0;if((f[Q>>2]|0)==(O|0))R=Q;else{Q=P;do{P=f[Q>>2]|0;Q=P+8|0;S=f[Q>>2]|0}while((f[S>>2]|0)!=(P|0));R=S}}else{Q=J;while(1){S=f[Q>>2]|0;if(!S)break;else Q=S}R=Q}if((R|0)==(p|0))break;else{M=M+4|0;N=N+4|0;O=R}}}else{if(D&(K|0)!=(p|0)){T=0;U=G;V=I;W=K}else break;while(1){f[V>>2]=f[W+20>>2];f[U>>2]=f[W+16>>2];J=f[W+4>>2]|0;if(!J){S=W+8|0;P=f[S>>2]|0;if((f[P>>2]|0)==(W|0))X=P;else{P=S;do{S=f[P>>2]|0;P=S+8|0;Z=f[P>>2]|0}while((f[Z>>2]|0)!=(S|0));X=Z}}else{P=J;while(1){Q=f[P>>2]|0;if(!Q)break;else P=Q}X=P}T=T+1|0;if(!((T|0)<(g|0)&(X|0)!=(p|0)))break;else{U=U+4|0;V=V+4|0;W=X}}}}else ei[f[(f[j>>2]|0)+24>>2]&511](j,I,G,g);while(0);E=E+1|0;G=f[p>>2]|0;if(E>>>0>=(f[c>>2]|0)>>>0){s=G;L=3;break}else F=G}if((L|0)==3){f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}else if((L|0)==6)ig(af(1)|0,22144,0)}function uAc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;eKc(a+88|0,4,1,b)|0;c=a+92|0;eKc(c,4,1,b)|0;eKc(a+96|0,4,1,b)|0;eKc(a+100|0,4,1,b)|0;eKc(a+84|0,4,1,b)|0;if((f[c>>2]|0)<=0)return;d=a+52|0;e=a+40|0;g=a+48|0;h=0;do{eKc(f[(f[d>>2]|0)+(h<<2)>>2]|0,4,f[e>>2]|0,b)|0;HAc(a,b,f[(f[g>>2]|0)+(h<<2)>>2]|0,h);h=h+1|0}while((h|0)<(f[c>>2]|0));return}function vAc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;i=a+52|0;j=f[i>>2]|0;a:do if(j|0?(k=a+92|0,l=f[k>>2]|0,(l|0)>0):0){m=0;n=j;o=l;while(1){l=f[n+(m<<2)>>2]|0;if(!l)p=o;else{dYc(l);f[(f[i>>2]|0)+(m<<2)>>2]=0;p=f[k>>2]|0}l=m+1|0;if((l|0)>=(p|0))break a;m=l;n=f[i>>2]|0;o=p}}while(0);p=a+48|0;j=f[p>>2]|0;if(j|0)dYc(j);j=f[i>>2]|0;if(j|0)dYc(j);j=a+88|0;if((NLc(j,4,1,c)|0)!=1){o=af(60)|0;Jtc(o,511860);ig(o|0,22128,1)}o=a+92|0;if((NLc(o,4,1,c)|0)!=1){n=af(60)|0;Jtc(n,511860);ig(n|0,22128,1)}n=a+96|0;if((NLc(n,4,1,c)|0)!=1){m=af(60)|0;Jtc(m,511860);ig(m|0,22128,1)}m=a+100|0;if((NLc(m,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if((NLc(a+84|0,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=f[o>>2]|0;l=k>>>0>1073741823?-1:k<<2;q=bYc(l)|0;f[i>>2]=q;r=bYc(l)|0;f[p>>2]=r;b:do if((k|0)>0){r=a+40|0;l=0;s=q;while(1){t=f[r>>2]|0;v=bYc(t>>>0>1073741823?-1:t<<2)|0;f[s+(l<<2)>>2]=v;if((NLc(f[(f[i>>2]|0)+(l<<2)>>2]|0,4,t,c)|0)!=(t|0))break;GAc(a,c,(f[p>>2]|0)+(l<<2)|0,l);t=l+1|0;if((t|0)>=(f[o>>2]|0))break b;l=t;s=f[i>>2]|0}s=af(60)|0;Jtc(s,511860);ig(s|0,22128,1)}while(0);i=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=i;i=a+28|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;p=h+11|0;b[p>>0]=9;c=h;q=512094;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[h+9>>0]=0;s=Ntc(i,e,h)|0;l=f[s>>2]|0;if(!l){r=$Xc(36)|0;t=r+16|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];f[t+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;t=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=t;f[s>>2]=r;t=f[f[i>>2]>>2]|0;if(!t)w=r;else{f[i>>2]=t;w=f[s>>2]|0}UQ(f[a+32>>2]|0,w);w=a+36|0;f[w>>2]=(f[w>>2]|0)+1;x=r}else x=l;l=x+28|0;r=f[l>>2]|0;w=x+32|0;mi[f[f[r>>2]>>2]&2047](r,w);f[l>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,w);if((b[p>>0]|0)<0)cYc(f[h>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=9;c=g;q=512667;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[g+9>>0]=0;p=Ntc(i,e,g)|0;w=f[p>>2]|0;if(!w){l=$Xc(36)|0;r=l+16|0;f[r>>2]=f[g>>2];f[r+4>>2]=f[g+4>>2];f[r+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;r=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=r;f[p>>2]=l;r=f[f[i>>2]>>2]|0;if(!r)y=l;else{f[i>>2]=r;y=f[p>>2]|0}UQ(f[a+32>>2]|0,y);y=a+36|0;f[y>>2]=(f[y>>2]|0)+1;z=l}else z=w;w=z+28|0;l=f[w>>2]|0;y=z+32|0;mi[f[f[l>>2]>>2]&2047](l,y);f[w>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,j,y);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=5;b[g>>0]=b[512723]|0;b[g+1>>0]=b[512724]|0;b[g+2>>0]=b[512725]|0;b[g+3>>0]=b[512726]|0;b[g+4>>0]=b[512727]|0;b[g+5>>0]=0;y=Ntc(i,e,g)|0;j=f[y>>2]|0;if(!j){w=$Xc(36)|0;l=w+16|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[l+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[w+28>>2]=172888;f[w+32>>2]=0;l=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=l;f[y>>2]=w;l=f[f[i>>2]>>2]|0;if(!l)A=w;else{f[i>>2]=l;A=f[y>>2]|0}UQ(f[a+32>>2]|0,A);A=a+36|0;f[A>>2]=(f[A>>2]|0)+1;B=w}else B=j;j=B+28|0;w=f[j>>2]|0;A=B+32|0;mi[f[f[w>>2]>>2]&2047](w,A);f[j>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,o,A);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;c=h;q=512677;k=c+12|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[h+12>>0]=0;h=Ntc(i,e,g)|0;A=f[h>>2]|0;if(!A){o=$Xc(36)|0;j=o+16|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[o+28>>2]=172888;f[o+32>>2]=0;j=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=j;f[h>>2]=o;j=f[f[i>>2]>>2]|0;if(!j)C=o;else{f[i>>2]=j;C=f[h>>2]|0}UQ(f[a+32>>2]|0,C);C=a+36|0;f[C>>2]=(f[C>>2]|0)+1;D=o}else D=A;A=D+28|0;o=f[A>>2]|0;C=D+32|0;mi[f[f[o>>2]>>2]&2047](o,C);f[A>>2]=173316;Ti[f[(f[43329]|0)+4>>2]&511](173316,n,C);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;C=g+11|0;b[C>>0]=9;c=g;q=512729;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[g+9>>0]=0;q=Ntc(i,e,g)|0;c=f[q>>2]|0;if(!c){k=$Xc(36)|0;n=k+16|0;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[k+28>>2]=172888;f[k+32>>2]=0;n=f[e>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=n;f[q>>2]=k;n=f[f[i>>2]>>2]|0;if(!n)E=k;else{f[i>>2]=n;E=f[q>>2]|0}UQ(f[a+32>>2]|0,E);E=a+36|0;f[E>>2]=(f[E>>2]|0)+1;F=k}else F=c;c=F+28|0;k=f[c>>2]|0;E=F+32|0;mi[f[f[k>>2]>>2]&2047](k,E);f[c>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,m,E);if((b[C>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function wAc(a){a=a|0;return f[a+40>>2]|0}function xAc(a){a=a|0;return f[a+44>>2]|0}function yAc(a){a=a|0;return (f[a+80>>2]|0)+(f[a+76>>2]|0)+(f[a+84>>2]|0)|0}function zAc(a){a=a|0;return 5}function AAc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+28>>2]|0;i=b+32|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function BAc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+12|0;i=g+24|0;j=g+8|0;k=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;m=auc(e,h)|0;do if((m|0)!=(e+4|0)){n=m+28|0;o=f[n>>2]|0;p=(_i[f[(f[o>>2]|0)+28>>2]&2047](o)|0)+4|0;if((f[p>>2]|0)==(f[6379]|0)){p=f[n>>2]|0;n=Mi[f[(f[p>>2]|0)+20>>2]&1023](p,m+32|0)|0;q=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else q=32;while(0);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(20)|0;l=a+40|0;m=f[l>>2]|0;f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[h+12>>2]=m;CAc(h,m);f[h+16>>2]=0;m=f[l>>2]|0;f[i>>2]=0;l=i+4|0;f[l>>2]=0;n=i+8|0;f[n>>2]=0;if(m|0){if((m|0)<0)kWc(i);p=((m+-1|0)>>>5)+1|0;o=$Xc(p<<2)|0;f[i>>2]=o;f[n>>2]=p;f[l>>2]=m;l=m>>>5;g1c(o|0,0,l<<2|0)|0;p=m-(l<<5)|0;m=o+(l<<2)|0;if(p|0)f[m>>2]=f[m>>2]&~(-1>>>(32-p|0))}f[j>>2]=0;p=a+92|0;if((f[p>>2]|0)>0){m=a+48|0;l=0;do{DAc(a,f[(f[m>>2]|0)+(l<<2)>>2]|0,c,d,j,q,h,i);l=l+1|0}while((l|0)<(f[p>>2]|0))}while(1){if(!(EAc(h,k)|0))break;if((f[j>>2]|0)>=(q|0)?_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0:0)break;DAc(a,f[k>>2]|0,c,d,j,q,h,i)}q=f[h>>2]|0;if(q|0){j=f[e>>2]|0;if((j|0)!=(q|0))f[e>>2]=j+(~((j+-8-q|0)>>>3)<<3);cYc(q)}cYc(h);h=f[i>>2]|0;if(!h){u=g;return}cYc(h);u=g;return}function CAc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function DAc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0;j=u;u=u+16|0;k=j;l=b+8|0;m=f[l>>2]|0;if(!m){if((f[e>>2]|0)>=(g|0)?_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0:0){u=j;return}o=b+4|0;p=f[o>>2]|0;if((p|0)<=0){u=j;return}q=b+12|0;b=a+24|0;r=a+20|0;s=a+44|0;t=0;v=f[i>>2]|0;w=p;while(1){p=f[(f[q>>2]|0)+(t<<2)>>2]|0;x=p>>>5;y=1<<(p&31);if(!(y&f[v+(x<<2)>>2])){z=(f[b>>2]|0)+((Y(f[r>>2]|0,p)|0)<<2)|0;A=z+(f[s>>2]<<2)|0;B=A+-12|0;C=((B>>>0<z>>>0?z:B)+12+(3-z)|0)>>>4<<2;D=d+(C<<2)|0;if(z>>>0<B>>>0){E=z;F=d;G=0.0;while(1){H=+n[E>>2]-+n[F>>2];I=+n[E+4>>2]-+n[F+4>>2];J=+n[E+8>>2]-+n[F+8>>2];K=+n[E+12>>2]-+n[F+12>>2];L=G+(H*H+I*I+J*J+K*K);E=E+16|0;if(E>>>0>=B>>>0){M=L;break}else{F=F+16|0;G=L}}}else M=0.0;F=z+(C<<2)|0;if(F>>>0<A>>>0){B=D;G=M;E=F;while(1){L=+n[E>>2]-+n[B>>2];E=E+4|0;K=G+L*L;if(E>>>0>=A>>>0){N=K;break}else{B=B+4|0;G=K}}}else N=M;Hg[f[(f[c>>2]|0)+12>>2]&15](c,N,p);B=f[i>>2]|0;A=B+(x<<2)|0;f[A>>2]=f[A>>2]|y;f[e>>2]=(f[e>>2]|0)+1;O=B;P=f[o>>2]|0}else{O=v;P=w}t=t+1|0;if((t|0)>=(P|0))break;else{v=O;w=P}}u=j;return}P=a+88|0;w=f[P>>2]|0;O=bYc(w>>>0>1073741823?-1:w<<2)|0;v=f[a+24>>2]|0;t=f[a+20>>2]|0;o=v+((Y(t,f[f[m>>2]>>2]|0)|0)<<2)|0;s=d+(f[a+44>>2]<<2)|0;r=s+-12|0;b=((r>>>0<d>>>0?d:r)+12+(3-d)|0)>>>4<<2;q=o+(b<<2)|0;B=r>>>0>d>>>0;if(B){A=d;E=o;N=0.0;while(1){M=+n[A>>2]-+n[E>>2];G=+n[A+4>>2]-+n[E+4>>2];K=+n[A+8>>2]-+n[E+8>>2];L=+n[A+12>>2]-+n[E+12>>2];J=N+(M*M+G*G+K*K+L*L);A=A+16|0;if(A>>>0>=r>>>0){Q=J;break}else{E=E+16|0;N=J}}}else Q=0.0;E=d+(b<<2)|0;A=E>>>0<s>>>0;if(A){o=q;N=Q;q=E;while(1){J=+n[q>>2]-+n[o>>2];q=q+4|0;L=N+J*J;if(q>>>0>=s>>>0){R=L;break}else{o=o+4|0;N=L}}}else R=Q;n[O>>2]=R;a:do if((w|0)>1){if(B){S=1;T=0}else{if(A){U=1;V=0}else{o=1;q=0;while(1){n[O+(o<<2)>>2]=0.0;D=+n[O+(q<<2)>>2]>0.0?o:q;o=o+1|0;if((o|0)>=(w|0)){W=D;break a}else q=D}}while(1){q=v+((Y(t,f[f[m+(U<<2)>>2]>>2]|0)|0)<<2)+(b<<2)|0;R=0.0;o=E;while(1){Q=+n[o>>2]-+n[q>>2];o=o+4|0;R=R+Q*Q;if(o>>>0>=s>>>0)break;else q=q+4|0}n[O+(U<<2)>>2]=R;q=R<+n[O+(V<<2)>>2]?U:V;U=U+1|0;if((U|0)>=(w|0)){W=q;break a}else V=q}}while(1){q=v+((Y(t,f[f[m+(S<<2)>>2]>>2]|0)|0)<<2)|0;o=d;y=q;Q=0.0;while(1){N=+n[o>>2]-+n[y>>2];L=+n[o+4>>2]-+n[y+4>>2];J=+n[o+8>>2]-+n[y+8>>2];K=+n[o+12>>2]-+n[y+12>>2];Q=Q+(N*N+L*L+J*J+K*K);o=o+16|0;if(o>>>0>=r>>>0)break;else y=y+16|0}if(A){y=q+(b<<2)|0;R=Q;o=E;while(1){K=+n[o>>2]-+n[y>>2];o=o+4|0;J=R+K*K;if(o>>>0>=s>>>0){X=J;break}else{y=y+4|0;R=J}}}else X=Q;n[O+(S<<2)>>2]=X;y=X<+n[O+(T<<2)>>2]?S:T;S=S+1|0;if((S|0)>=(w|0)){W=y;break}else T=y}}else W=0;while(0);if((w|0)>0){T=k+4|0;S=h+16|0;s=h+12|0;E=h+4|0;b=h+8|0;A=0;r=w;while(1){if((A|0)==(W|0))Z=r;else{w=f[O+(A<<2)>>2]|0;f[k>>2]=f[(f[l>>2]|0)+(A<<2)>>2];f[T>>2]=w;if((f[S>>2]|0)==(f[s>>2]|0))_=r;else{w=f[E>>2]|0;if((w|0)==(f[b>>2]|0)){FAc(h,k);$=f[E>>2]|0}else{m=k;t=f[m+4>>2]|0;v=w;f[v>>2]=f[m>>2];f[v+4>>2]=t;t=(f[E>>2]|0)+8|0;f[E>>2]=t;$=t}t=f[h>>2]|0;v=$-t|0;if((v|0)>8?(m=((v>>>3)+-2|0)/2|0,v=$+-8|0,X=+n[$+-4>>2],X<+n[t+(m<<3)+4>>2]):0){w=f[v>>2]|0;V=v;v=m;while(1){m=V;V=t+(v<<3)|0;U=V;B=f[U+4>>2]|0;y=m;f[y>>2]=f[U>>2];f[y+4>>2]=B;if(!v){aa=0;break}B=(v+-1|0)/2|0;if(!(X<+n[t+(B<<3)+4>>2])){aa=v;break}else v=B}f[V>>2]=w;n[t+(aa<<3)+4>>2]=X}f[S>>2]=(f[S>>2]|0)+1;_=f[P>>2]|0}Z=_}A=A+1|0;if((A|0)>=(Z|0))break;else r=Z}}dYc(O);DAc(a,f[(f[l>>2]|0)+(W<<2)>>2]|0,c,d,e,g,h,i);u=j;return}function EAc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0;c=a+16|0;if(!(f[c>>2]|0)){d=0;return d|0}e=f[a>>2]|0;g=f[e+4>>2]|0;h=b;f[h>>2]=f[e>>2];f[h+4>>2]=g;g=f[a>>2]|0;h=a+4|0;a=f[h>>2]|0;e=a-g|0;b=e>>3;if(((e|0)>8?(e=a+-8|0,a=g,i=f[a>>2]|0,j=f[a+4>>2]|0,a=e,k=f[a+4>>2]|0,l=g,f[l>>2]=f[a>>2],f[l+4>>2]=k,k=e,f[k>>2]=i,f[k+4>>2]=j,j=b+-1|0,(b|0)!=2):0)?(k=b+-3|0,b=(k|0)/2|0,(k|0)>=-1):0){k=g+8|0;if((j|0)>2?+n[g+20>>2]<+n[g+12>>2]:0){m=2;o=g+16|0}else{m=1;o=k}p=+n[g+4>>2];if(!(p<+n[o+4>>2])){k=f[g>>2]|0;i=m;m=o;o=g;while(1){e=o;o=m;l=o;a=f[l+4>>2]|0;q=e;f[q>>2]=f[l>>2];f[q+4>>2]=a;if((b|0)<(i|0))break;a=i<<1|1;q=g+(a<<3)|0;l=q;e=a+1|0;if((e|0)<(j|0)?(r=q+8|0,+n[r+4>>2]<+n[g+(a<<3)+4>>2]):0){s=e;t=r}else{s=a;t=l}if(p<+n[t+4>>2])break;else{i=s;m=t}}f[m>>2]=k;n[m+4>>2]=p}}f[h>>2]=(f[h>>2]|0)+-8;f[c>>2]=(f[c>>2]|0)+-1;d=1;return d|0}function FAc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function GAc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;h=a+60|0;i=f[h>>2]|0;do if((i|0)<32){j=a+80|0;f[j>>2]=(f[j>>2]|0)+i;j=jIc(8192)|0;if(!j){eKc(513012,27,1,f[46249]|0)|0;k=0;break}else{l=a+64|0;f[j>>2]=f[l>>2];f[l>>2]=j;f[h>>2]=8188;l=j+4|0;j=a+68|0;f[j>>2]=l;m=j;n=l;o=8156;p=6;break}}else{l=a+68|0;m=l;n=f[l>>2]|0;o=i+-32|0;p=6}while(0);if((p|0)==6){f[m>>2]=n+32;f[h>>2]=o;o=a+76|0;f[o>>2]=(f[o>>2]|0)+32;k=n}f[c>>2]=k;if((NLc(k,20,1,b)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if(!(f[(f[c>>2]|0)+8>>2]|0)){if((NLc(g,4,1,b)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}f[(f[c>>2]|0)+12>>2]=(f[(f[a+52>>2]|0)+(d<<2)>>2]|0)+(f[g>>2]<<2);u=e;return}g=a+88|0;k=(f[g>>2]<<2)+15&-16;n=f[h>>2]|0;do if((k|0)>(n|0)){o=a+80|0;f[o>>2]=(f[o>>2]|0)+n;o=(k|4)+15|0;m=o>>>0>8192?o:8192;o=jIc(m)|0;if(!o){eKc(513012,27,1,f[46249]|0)|0;q=0;break}else{i=a+64|0;f[o>>2]=f[i>>2];f[i>>2]=o;i=m+-4|0;f[h>>2]=i;m=o+4|0;o=a+68|0;f[o>>2]=m;r=o;s=m;t=i;p=18;break}}else{i=a+68|0;r=i;s=f[i>>2]|0;t=n;p=18}while(0);if((p|0)==18){f[r>>2]=s+k;f[h>>2]=t-k;t=a+76|0;f[t>>2]=(f[t>>2]|0)+k;q=s}f[(f[c>>2]|0)+8>>2]=q;if((f[g>>2]|0)>0)v=0;else{u=e;return}do{GAc(a,b,(f[(f[c>>2]|0)+8>>2]|0)+(v<<2)|0,d);v=v+1|0}while((v|0)<(f[g>>2]|0));u=e;return}function HAc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;eKc(c,20,1,b)|0;h=c+8|0;i=f[h>>2]|0;if(!i){f[g>>2]=(f[c+12>>2]|0)-(f[(f[a+52>>2]|0)+(d<<2)>>2]|0)>>2;eKc(g,4,1,b)|0;u=e;return}g=a+88|0;if((f[g>>2]|0)<=0){u=e;return}HAc(a,b,f[i>>2]|0,d);if((f[g>>2]|0)>1)j=1;else{u=e;return}do{HAc(a,b,f[(f[h>>2]|0)+(j<<2)>>2]|0,d);j=j+1|0}while((j|0)<(f[g>>2]|0));u=e;return}function IAc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=u;u=u+32|0;i=h;j=h+20|0;k=h+8|0;l=h+4|0;f[b+4>>2]=d;f[b+16>>2]=g;if((f[a+100>>2]|0)>(d|0)){f[b+12>>2]=c;mMc(c,c+(d<<2)|0,i);f[b+8>>2]=0;u=h;return}f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;do if(e)if(e>>>0>1073741823)kWc(j);else{n=e<<2;o=$Xc(n)|0;f[j>>2]=o;p=o+(e<<2)|0;f[j+8>>2]=p;g1c(o|0,0,n|0)|0;f[m>>2]=p;q=o;break}else q=0;while(0);f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;do if(d|0)if(d>>>0>1073741823)kWc(k);else{p=d<<2;n=$Xc(p)|0;f[k>>2]=n;r=n+(d<<2)|0;f[k+8>>2]=r;g1c(n|0,0,p|0)|0;f[o>>2]=r;break}while(0);r=f[a+4>>2]|0;p=f[a+8>>2]|0;n=a+(p>>1)|0;if(!(p&1))s=r;else s=f[(f[n>>2]|0)+r>>2]|0;Fh[s&255](n,e,c,d,q,l);q=f[l>>2]|0;if((q|0)<(e|0)){f[b+12>>2]=c;mMc(c,c+(d<<2)|0,i);f[b+8>>2]=0}else{JAc(a,c,d,f[j>>2]|0,q,f[k>>2]|0,i);i=(e<<2)+15&-16;q=a+60|0;l=f[q>>2]|0;do if((i|0)>(l|0)){n=a+80|0;f[n>>2]=(f[n>>2]|0)+l;n=(i|4)+15|0;s=n>>>0>8192?n:8192;n=jIc(s)|0;if(!n){eKc(513012,27,1,f[46249]|0)|0;t=0;break}else{r=a+64|0;f[n>>2]=f[r>>2];f[r>>2]=n;r=s+-4|0;f[q>>2]=r;s=n+4|0;n=a+68|0;f[n>>2]=s;v=n;w=s;x=r;y=21;break}}else{r=a+68|0;v=r;w=f[r>>2]|0;x=l;y=21}while(0);if((y|0)==21){f[v>>2]=w+i;f[q>>2]=x-i;x=a+76|0;f[x>>2]=(f[x>>2]|0)+i;t=w}w=b+8|0;f[w>>2]=t;a:do if((e|0)>0){t=a+80|0;b=f[46249]|0;i=a+64|0;x=a+68|0;v=g+1|0;l=a+76|0;if((d|0)>0){z=0;A=0}else{r=0;while(1){s=f[q>>2]|0;do if((s|0)<32){f[t>>2]=(f[t>>2]|0)+s;n=jIc(8192)|0;if(!n){eKc(513012,27,1,b)|0;B=0;break}else{f[n>>2]=f[i>>2];f[i>>2]=n;f[q>>2]=8188;p=n+4|0;f[x>>2]=p;C=p;D=8188;y=41;break}}else{C=f[x>>2]|0;D=s;y=41}while(0);if((y|0)==41){y=0;f[x>>2]=C+32;f[q>>2]=D+-32;f[l>>2]=(f[l>>2]|0)+32;B=C}f[(f[w>>2]|0)+(r<<2)>>2]=B;s=(f[w>>2]|0)+(r<<2)|0;p=f[s>>2]|0;f[p>>2]=f[(f[j>>2]|0)+(r<<2)>>2];f[p+12>>2]=0;IAc(a,f[s>>2]|0,c,0,e,v);r=r+1|0;if((r|0)>=(e|0))break a}}while(1){r=f[k>>2]|0;s=0;p=A;while(1){n=r+(s<<2)|0;if((f[n>>2]|0)==(z|0)){E=c+(s<<2)|0;F=c+(p<<2)|0;G=f[E>>2]|0;f[E>>2]=f[F>>2];f[F>>2]=G;G=r+(p<<2)|0;F=f[n>>2]|0;f[n>>2]=f[G>>2];f[G>>2]=F;H=p+1|0}else H=p;s=s+1|0;if((s|0)==(d|0))break;else p=H}p=f[q>>2]|0;do if((p|0)<32){f[t>>2]=(f[t>>2]|0)+p;s=jIc(8192)|0;if(!s){eKc(513012,27,1,b)|0;I=0;break}else{f[s>>2]=f[i>>2];f[i>>2]=s;f[q>>2]=8188;r=s+4|0;f[x>>2]=r;J=r;K=8188;y=28;break}}else{J=f[x>>2]|0;K=p;y=28}while(0);if((y|0)==28){y=0;f[x>>2]=J+32;f[q>>2]=K+-32;f[l>>2]=(f[l>>2]|0)+32;I=J}f[(f[w>>2]|0)+(z<<2)>>2]=I;p=(f[w>>2]|0)+(z<<2)|0;r=f[p>>2]|0;f[r>>2]=f[(f[j>>2]|0)+(z<<2)>>2];f[r+12>>2]=0;IAc(a,f[p>>2]|0,c+(A<<2)|0,H-A|0,e,v);z=z+1|0;if((z|0)>=(e|0))break;else A=H}}while(0)}H=f[k>>2]|0;if(H|0){k=f[o>>2]|0;if((k|0)!=(H|0))f[o>>2]=k+(~((k+-4-H|0)>>>2)<<2);cYc(H)}H=f[j>>2]|0;if(H|0){j=f[m>>2]|0;if((j|0)!=(H|0))f[m>>2]=j+(~((j+-4-H|0)>>>2)<<2);cYc(H)}u=h;return}function JAc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;n[h>>2]=0.0;if((c|0)<=0)return;i=f[a+24>>2]|0;j=a+20|0;k=a+44|0;a=(e|0)>1;l=0;m=0.0;do{o=f[j>>2]|0;p=i+((Y(o,f[b+(l<<2)>>2]|0)|0)<<2)|0;q=i+((Y(f[d>>2]|0,o)|0)<<2)|0;o=p+(f[k>>2]<<2)|0;r=o+-12|0;s=3-p|0;t=((r>>>0<p>>>0?p:r)+12+s|0)>>>4<<2;u=q+(t<<2)|0;if(p>>>0<r>>>0){v=p;w=q;x=0.0;while(1){y=+n[v>>2]-+n[w>>2];z=+n[v+4>>2]-+n[w+4>>2];A=+n[v+8>>2]-+n[w+8>>2];B=+n[v+12>>2]-+n[w+12>>2];C=x+(y*y+z*z+A*A+B*B);v=v+16|0;if(v>>>0>=r>>>0){D=C;break}else{w=w+16|0;x=C}}}else D=0.0;w=p+(t<<2)|0;if(w>>>0<o>>>0){r=u;x=D;v=w;while(1){C=+n[v>>2]-+n[r>>2];v=v+4|0;B=x+C*C;if(v>>>0>=o>>>0){E=B;break}else{r=r+4|0;x=B}}}else E=D;r=g+(l<<2)|0;f[r>>2]=0;if(a){o=1;x=E;while(1){v=i+((Y(f[j>>2]|0,f[d+(o<<2)>>2]|0)|0)<<2)|0;u=p+(f[k>>2]<<2)|0;t=u+-12|0;w=((t>>>0<p>>>0?p:t)+12+s|0)>>>4<<2;q=v+(w<<2)|0;if(p>>>0<t>>>0){F=p;G=v;B=0.0;while(1){C=+n[F>>2]-+n[G>>2];A=+n[F+4>>2]-+n[G+4>>2];z=+n[F+8>>2]-+n[G+8>>2];y=+n[F+12>>2]-+n[G+12>>2];H=B+(C*C+A*A+z*z+y*y);F=F+16|0;if(F>>>0>=t>>>0){I=H;break}else{G=G+16|0;B=H}}}else I=0.0;G=p+(w<<2)|0;if(G>>>0<u>>>0){t=q;B=I;F=G;while(1){H=+n[F>>2]-+n[t>>2];F=F+4|0;y=B+H*H;if(F>>>0>=u>>>0){J=y;break}else{t=t+4|0;B=y}}}else J=I;if(x>J){f[r>>2]=o;K=J}else K=x;o=o+1|0;if((o|0)==(e|0)){L=K;break}else x=K}}else L=E;m=L+m;n[h>>2]=m;l=l+1|0}while((l|0)!=(c|0));return}function KAc(a){a=a|0;var b=0,c=0;f[a>>2]=174396;b=a+4|0;c=f[b>>2]|0;if(c|0){Yi[f[(f[c>>2]|0)+4>>2]&4095](c);f[b>>2]=0}Ptc(a+20|0,f[a+24>>2]|0);Ptc(a+8|0,f[a+12>>2]|0);return}function LAc(a){a=a|0;var b=0,c=0;f[a>>2]=174396;b=a+4|0;c=f[b>>2]|0;if(c|0){Yi[f[(f[c>>2]|0)+4>>2]&4095](c);f[b>>2]=0}Ptc(a+20|0,f[a+24>>2]|0);Ptc(a+8|0,f[a+12>>2]|0);cYc(a);return}function MAc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0;c=u;u=u+240|0;d=c+72|0;e=c+56|0;g=c+32|0;h=c+24|0;i=c+8|0;j=c+224|0;k=c+88|0;l=k+56|0;m=k+4|0;f[k>>2]=6884;f[l>>2]=6904;XNc(k+56|0,m);f[k+128>>2]=0;f[k+132>>2]=-1;f[k>>2]=36020;f[l>>2]=36040;aOc(m);f[m>>2]=35912;o=k+36|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[k+52>>2]=16;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;AM(m,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);VAc(j,a);p=a+8|0;q=a+12|0;Ptc(p,f[q>>2]|0);f[p>>2]=f[j>>2];r=j+4|0;s=f[r>>2]|0;f[q>>2]=s;t=j+8|0;v=f[t>>2]|0;f[a+16>>2]=v;if(!v){f[p>>2]=q;w=s}else{f[s+8>>2]=q;f[j>>2]=r;f[r>>2]=0;f[t>>2]=0;w=0}Ptc(j,w);Gwc(p,k);Hwc(513494,c)|0;Hwc(513548,i)|0;CM(i,m);w=i+11|0;f[h>>2]=(b[w>>0]|0)<0?f[i>>2]|0:i;Hwc(518975,h)|0;if((b[w>>0]|0)<0)cYc(f[i>>2]|0);Hwc(513494,g)|0;i=Rzc(a+84|0,p,a+116|0)|0;f[a+4>>2]=i;Yi[f[(f[i>>2]|0)+8>>2]&4095](i);i=a+20|0;x=+WAc(a,i);n[a+80>>2]=x;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(m,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);Gwc(i,k);Hwc(513494,c+48|0)|0;Hwc(513571,e)|0;CM(e,m);i=e+11|0;f[d>>2]=(b[i>>0]|0)<0?f[e>>2]|0:e;Hwc(518975,d)|0;if((b[i>>0]|0)<0)cYc(f[e>>2]|0);Hwc(513494,c+80|0)|0;f[k>>2]=36020;f[l>>2]=36040;f[m>>2]=35912;if((b[o+11>>0]|0)>=0){LMc(m);HNc(k,36052);GMc(l);u=c;return}cYc(f[o>>2]|0);LMc(m);HNc(k,36052);GMc(l);u=c;return}function NAc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+12|0;g=d;h=a+4|0;i=f[h>>2]|0;j=_i[f[(f[i>>2]|0)+40>>2]&2047](i)|0;f[e>>2]=j;eKc(e,4,1,c)|0;j=f[h>>2]|0;mi[f[(f[j>>2]|0)+20>>2]&2047](j,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=6;b[g>>0]=b[512787]|0;b[g+1>>0]=b[512788]|0;b[g+2>>0]=b[512789]|0;b[g+3>>0]=b[512790]|0;b[g+4>>0]=b[512791]|0;b[g+5>>0]=b[512792]|0;b[g+6>>0]=0;h=Cwc(a+20|0,g)|0;f[e>>2]=h;eKc(e,4,1,c)|0;if((b[j>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function OAc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+48|0;e=d+32|0;g=d+28|0;h=d+16|0;i=d+12|0;j=d;if((NLc(g,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=h+4|0;f[k>>2]=0;l=h+8|0;f[l>>2]=0;m=h+4|0;f[h>>2]=m;f[i>>2]=f[g>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;g=j+11|0;b[g>>0]=9;n=j;o=512094;p=n+9|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[j+9>>0]=0;o=Ntc(h,e,j)|0;n=f[o>>2]|0;if(!n){p=$Xc(36)|0;q=p+16|0;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[p+28>>2]=172888;f[p+32>>2]=0;q=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=q;f[o>>2]=p;q=f[f[h>>2]>>2]|0;if(!q)r=p;else{f[h>>2]=q;r=f[o>>2]|0}UQ(f[k>>2]|0,r);f[l>>2]=(f[l>>2]|0)+1;s=p}else s=n;n=s+28|0;p=f[n>>2]|0;l=s+32|0;mi[f[f[p>>2]>>2]&2047](p,l);f[n>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,i,l);if((b[g>>0]|0)<0)cYc(f[j>>2]|0);g=Rzc(a+84|0,h,a+116|0)|0;f[a+4>>2]=g;mi[f[(f[g>>2]|0)+24>>2]&2047](g,c);if((NLc(i,4,1,c)|0)!=1){c=af(60)|0;Jtc(c,511860);ig(c|0,22128,1)};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=j+11|0;b[c>>0]=6;b[j>>0]=b[512787]|0;b[j+1>>0]=b[512788]|0;b[j+2>>0]=b[512789]|0;b[j+3>>0]=b[512790]|0;b[j+4>>0]=b[512791]|0;b[j+5>>0]=b[512792]|0;b[j+6>>0]=0;g=a+20|0;l=Ntc(g,e,j)|0;n=f[l>>2]|0;if(!n){p=$Xc(36)|0;s=p+16|0;f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[s+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[p+28>>2]=172888;f[p+32>>2]=0;s=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=s;f[l>>2]=p;s=f[f[g>>2]>>2]|0;if(!s)t=p;else{f[g>>2]=s;t=f[l>>2]|0}UQ(f[a+24>>2]|0,t);t=a+28|0;f[t>>2]=(f[t>>2]|0)+1;v=p}else v=n;n=v+28|0;p=f[n>>2]|0;t=v+32|0;mi[f[f[p>>2]>>2]&2047](p,t);f[n>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,i,t);if((b[c>>0]|0)>=0){w=f[m>>2]|0;Ptc(h,w);u=d;return}cYc(f[j>>2]|0);w=f[m>>2]|0;Ptc(h,w);u=d;return}function PAc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+28>>2]&2047](b)|0}function QAc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&2047](b)|0}function RAc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+36>>2]&2047](b)|0}function SAc(a){a=a|0;return 255}function TAc(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;mi[f[(f[c>>2]|0)+44>>2]&2047](a,c);return}function UAc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;j=auc(e,h)|0;do if((j|0)!=(e+4|0)){k=j+28|0;l=f[k>>2]|0;m=(_i[f[(f[l>>2]|0)+28>>2]&2047](l)|0)+4|0;if((f[m>>2]|0)==(f[6379]|0)){m=f[k>>2]|0;k=Mi[f[(f[m>>2]|0)+20>>2]&1023](m,j+32|0)|0;n=f[k>>2]|0;break}else ig(af(1)|0,22144,0)}else n=-2;while(0);if((b[i>>0]|0)<0)cYc(f[h>>2]|0);h=f[a+4>>2]|0;i=f[(f[h>>2]|0)+48>>2]|0;if((n|0)==-2){ei[i&511](h,c,d,a+20|0);u=g;return}else{ei[i&511](h,c,d,e);u=g;return}}function VAc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0;d=u;u=u+128|0;e=d+48|0;g=d+40|0;h=d+24|0;i=d;j=d+104|0;k=d+92|0;l=d+64|0;m=d+52|0;f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;q=c+84|0;r=f[q>>2]|0;s=~~(+n[c+112>>2]*+(r>>>0));t=(s|0)/10|0;v=(t|0)<1e3?t:1e3;w=+n[c+100>>2];f[i>>2]=r;f[i+4>>2]=s;f[i+8>>2]=v;p[i+16>>3]=w;Hwc(514100,i)|0;if((v|0)<10){Hwc(514197,h)|0;Uwc(h);f[a>>2]=f[h>>2];r=f[h+4>>2]|0;f[a+4>>2]=r;t=h+8|0;x=f[t>>2]|0;f[a+8>>2]=x;y=a+4|0;if(!x){f[a>>2]=y;z=r}else{f[r+8>>2]=y;y=h+4|0;f[h>>2]=y;f[y>>2]=0;f[t>>2]=0;z=0}Ptc(h,z)}else{Jwc(i,q,s);s=c+32|0;f[s>>2]=f[i>>2];f[s+4>>2]=f[i+4>>2];f[s+8>>2]=f[i+8>>2];f[s+12>>2]=f[i+12>>2];Vwc(i,s,v,1);v=c+48|0;f[v>>2]=f[i>>2];f[v+4>>2]=f[i+4>>2];f[v+8>>2]=f[i+8>>2];f[v+12>>2]=f[i+12>>2];Hwc(514233,e)|0;q=f[v>>2]|0;z=bYc(q>>>0>1073741823?-1:q<<2)|0;f[c+64>>2]=q;q=c+68|0;f[q>>2]=1;h=c+72|0;f[h>>2]=1;t=c+76|0;f[t>>2]=z;z=xN()|0;y=J;if(f[v>>2]|0){r=c+60|0;x=c+56|0;A=0;do{B=(f[r>>2]|0)+((Y(f[x>>2]|0,A)|0)<<2)|0;C=(f[t>>2]|0)+((Y(f[h>>2]|0,A)|0)<<2)|0;D=f[q>>2]|0;b[e>>0]=b[i>>0]|0;XAc(s,B,C,D,0,e);A=A+1|0}while(A>>>0<(f[v>>2]|0)>>>0)}v=xN()|0;A=J;w=(+(v>>>0)+4294967296.0*+(A|0)-(+(z>>>0)+4294967296.0*+(y|0)))/+yN()+0.0;y=l+20|0;f[y>>2]=0;z=l+24|0;f[z>>2]=0;A=l+20|0;v=l+16|0;f[v>>2]=A;n[l>>2]=w;n[l+4>>2]=0.0;n[l+8>>2]=0.0;f[i>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;s=j+11|0;b[s>>0]=9;q=j;h=512094;x=q+9|0;do{b[q>>0]=b[h>>0]|0;q=q+1|0;h=h+1|0}while((q|0)<(x|0));b[j+9>>0]=0;h=l+16|0;q=Ntc(h,e,j)|0;x=f[q>>2]|0;if(!x){r=$Xc(36)|0;D=r+16|0;f[D>>2]=f[j>>2];f[D+4>>2]=f[j+4>>2];f[D+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;D=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=D;f[q>>2]=r;D=f[f[h>>2]>>2]|0;if(!D)E=r;else{f[h>>2]=D;E=f[q>>2]|0}UQ(f[y>>2]|0,E);f[z>>2]=(f[z>>2]|0)+1;F=r}else F=x;x=F+28|0;r=f[x>>2]|0;z=F+32|0;mi[f[f[r>>2]>>2]&2047](r,z);f[x>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,i,z);if((b[s>>0]|0)<0)cYc(f[j>>2]|0);s=f[o>>2]|0;if((s|0)==(f[k+8>>2]|0))$Ac(k,l);else{f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];f[s+8>>2]=f[l+8>>2];f[s+12>>2]=f[l+12>>2];z=s+16|0;f[s+20>>2]=0;f[s+24>>2]=0;x=s+20|0;f[z>>2]=x;r=f[v>>2]|0;if((r|0)==(A|0))G=s;else{s=x;x=r;while(1){r=x+16|0;f[i>>2]=s;f[e>>2]=f[i>>2];Qtc(z,e,r,r)|0;r=f[x+4>>2]|0;if(!r){v=x+8|0;F=f[v>>2]|0;if((f[F>>2]|0)==(x|0))H=F;else{F=v;do{v=f[F>>2]|0;F=v+8|0;E=f[F>>2]|0}while((f[E>>2]|0)!=(v|0));H=E}}else{F=r;while(1){E=f[F>>2]|0;if(!E)break;else F=E}H=F}if((H|0)==(A|0))break;else x=H}G=f[o>>2]|0}f[o>>2]=G+28}Hwc(514261,g)|0;aBc(c,k);bBc(c,k);G=f[k>>2]|0;w=+n[G>>2];H=f[o>>2]|0;x=G;if((H|0)!=(x|0)){I=+n[c+104>>2];z=(H-x|0)/28|0;K=+n[G+4>>2]*I+w;L=K<w?K:w;if(z>>>0>1){K=L;x=1;while(1){M=+n[G+(x*28|0)+4>>2]*I+ +n[G+(x*28|0)>>2];N=M<K?M:K;x=x+1|0;if(x>>>0>=z>>>0){O=N;break}else K=N}}else O=L}else O=w;L=w/O;f[m+4>>2]=0;z=m+8|0;f[z>>2]=0;x=m+4|0;f[m>>2]=x;H=f[G+16>>2]|0;s=G+20|0;if((H|0)!=(s|0)){G=x;r=H;while(1){H=r+16|0;f[g>>2]=G;f[e>>2]=f[g>>2];Qtc(m,e,H,H)|0;H=f[r+4>>2]|0;if(!H){E=r+8|0;v=f[E>>2]|0;if((f[v>>2]|0)==(r|0))P=v;else{v=E;do{E=f[v>>2]|0;v=E+8|0;y=f[v>>2]|0}while((f[y>>2]|0)!=(E|0));P=y}}else{v=H;while(1){F=f[v>>2]|0;if(!F)break;else v=F}P=v}if((P|0)==(s|0))break;else r=P}}if(O>0.0?(P=f[o>>2]|0,r=f[k>>2]|0,(P|0)!=(r|0)):0){s=c+104|0;G=c+108|0;H=0;w=L;F=r;r=P;while(1){P=F;L=(+n[P+(H*28|0)+4>>2]*+n[s>>2]+ +n[P+(H*28|0)>>2])/O+ +n[G>>2]*+n[P+(H*28|0)+8>>2];if(L<w){y=P+(H*28|0)+16|0;if((m|0)==(y|0)){Q=r;R=F}else{f[i>>2]=f[y>>2];f[j>>2]=P+(H*28|0)+20;f[g>>2]=f[i>>2];f[e>>2]=f[j>>2];Zwc(m,g,e);Q=f[o>>2]|0;R=f[k>>2]|0}S=L;T=R;U=Q}else{S=w;T=F;U=r}H=H+1|0;if(H>>>0>=((U-T|0)/28|0)>>>0)break;else{w=S;F=T;r=U}}}U=f[t>>2]|0;if(U|0)dYc(U);U=f[c+60>>2]|0;if(U|0)dYc(U);U=f[c+44>>2]|0;if(U|0)dYc(U);f[a>>2]=f[m>>2];U=f[m+4>>2]|0;f[a+4>>2]=U;c=f[z>>2]|0;f[a+8>>2]=c;t=a+4|0;if(!c){f[a>>2]=t;V=U}else{f[U+8>>2]=t;f[m>>2]=x;f[x>>2]=0;f[z>>2]=0;V=0}Ptc(m,V);Ptc(l+16|0,f[A>>2]|0)}A=f[k>>2]|0;if(!A){u=d;return}l=f[o>>2]|0;if((l|0)==(A|0))W=A;else{V=l;do{f[o>>2]=V+-28;Ptc(V+-12|0,f[V+-8>>2]|0);V=f[o>>2]|0}while((V|0)!=(A|0));W=f[k>>2]|0}cYc(W);u=d;return}function WAc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,K=0.0,L=0,M=0;d=u;u=u+96|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d+8|0;j=d;k=d+88|0;l=d+72|0;m=d+56|0;o=a+84|0;q=((f[o>>2]|0)>>>0)/10|0;r=q>>>0<1e3?q:1e3;if((r|0)<=0){s=0.0;u=d;return +s}Jwc(l,o,r);Hwc(513591,e)|0;r=f[l>>2]|0;q=bYc(r>>>0>1073741823?-1:r<<2)|0;f[m>>2]=r;r=m+4|0;f[r>>2]=1;t=m+8|0;v=m+12|0;f[v>>2]=q;f[t>>2]=1;q=xN()|0;w=J;if(f[l>>2]|0){x=l+12|0;y=l+8|0;z=0;do{A=(f[x>>2]|0)+((Y(f[y>>2]|0,z)|0)<<2)|0;B=(f[v>>2]|0)+((Y(f[t>>2]|0,z)|0)<<2)|0;C=f[r>>2]|0;b[e>>0]=b[k>>0]|0;XAc(o,A,B,C,1,e);z=z+1|0}while(z>>>0<(f[l>>2]|0)>>>0)}z=xN()|0;D=+(z>>>0)+4294967296.0*+(J|0)-(+(q>>>0)+4294967296.0*+(w|0));E=D/+yN()+0.0;Hwc(513615,j)|0;w=a+4|0;q=f[w>>2]|0;if((_i[f[(f[q>>2]|0)+40>>2]&2047](q)|0)==2){Hwc(513644,i)|0;i=f[w>>2]|0;n[j>>2]=0.0;q=i+24|0;z=a+100|0;r=a+116|0;n[q>>2]=0.0;D=+YAc(i,o,l,m,+n[z>>2],k,r,1,1);t=f[k>>2]|0;n[j>>2]=.20000000298023224;n[q>>2]=.20000000298023224;F=+YAc(i,o,l,m,+n[z>>2],k,r,1,1);y=D==-1.0|F<D;G=y?F:D;x=y?f[k>>2]|0:t;n[j>>2]=.4000000059604645;n[q>>2]=.4000000059604645;D=+YAc(i,o,l,m,+n[z>>2],k,r,1,1);t=G==-1.0|D<G;F=t?D:G;C=t?f[k>>2]|0:x;n[j>>2]=.6000000238418579;n[q>>2]=.6000000238418579;G=+YAc(i,o,l,m,+n[z>>2],k,r,1,1);x=F==-1.0|G<F;D=x?G:F;B=x?f[k>>2]|0:C;n[j>>2]=.800000011920929;n[q>>2]=.800000011920929;F=+YAc(i,o,l,m,+n[z>>2],k,r,1,1);C=D==-1.0|F<D;G=C?F:D;A=C?f[k>>2]|0:B;n[j>>2]=1.0;n[q>>2]=1.0;D=+YAc(i,o,l,m,+n[z>>2],k,r,1,1);r=G==-1.0|D<G;F=r?D:G;G=r?1.0:C?.800000011920929:x?.6000000238418579:t?.4000000059604645:y?.20000000298023224:0.0;y=r?f[k>>2]|0:A;n[j>>2]=G;f[k>>2]=y;n[q>>2]=G;p[h>>3]=G;Hwc(513696,h)|0;q=a+8|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=h+11|0;b[y>>0]=8;A=h;f[A>>2]=1767858787;f[A+4>>2]=2019910766;b[h+8>>0]=0;A=Ntc(q,e,h)|0;r=f[A>>2]|0;if(!r){t=$Xc(36)|0;x=t+16|0;f[x>>2]=f[h>>2];f[x+4>>2]=f[h+4>>2];f[x+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;x=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=x;f[A>>2]=t;x=f[f[q>>2]>>2]|0;if(!x)H=t;else{f[q>>2]=x;H=f[A>>2]|0}UQ(f[a+12>>2]|0,H);H=a+16|0;f[H>>2]=(f[H>>2]|0)+1;I=t}else I=r;r=I+28|0;t=f[r>>2]|0;H=I+32|0;mi[f[f[t>>2]>>2]&2047](t,H);f[r>>2]=173484;Ti[f[(f[43371]|0)+4>>2]&511](173484,j,H);if((b[y>>0]|0)<0)cYc(f[h>>2]|0);K=F}else K=+YAc(f[w>>2]|0,o,l,m,+n[a+100>>2],k,a+116|0,1,1);f[g>>2]=f[k>>2];Hwc(513718,g)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=g+11|0;b[a>>0]=6;b[g>>0]=b[512787]|0;b[g+1>>0]=b[512788]|0;b[g+2>>0]=b[512789]|0;b[g+3>>0]=b[512790]|0;b[g+4>>0]=b[512791]|0;b[g+5>>0]=b[512792]|0;b[g+6>>0]=0;m=Ntc(c,e,g)|0;o=f[m>>2]|0;if(!o){w=$Xc(36)|0;h=w+16|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[w+28>>2]=172888;f[w+32>>2]=0;h=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=h;f[m>>2]=w;h=f[f[c>>2]>>2]|0;if(!h)L=w;else{f[c>>2]=h;L=f[m>>2]|0}UQ(f[c+4>>2]|0,L);L=c+8|0;f[L>>2]=(f[L>>2]|0)+1;M=w}else M=o;o=M+28|0;w=f[o>>2]|0;L=M+32|0;mi[f[f[w>>2]>>2]&2047](w,L);f[o>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,k,L);if((b[a>>0]|0)<0)cYc(f[g>>2]|0);g=f[v>>2]|0;if(g|0)dYc(g);g=f[l+12>>2]|0;if(g|0)dYc(g);s=E/K;u=d;return +s}function XAc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0;g=u;u=u+32|0;h=g+12|0;i=g;j=e+d|0;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;l=(j|0)==0;do if(!l)if(j>>>0>1073741823)kWc(h);else{m=j<<2;o=$Xc(m)|0;f[h>>2]=o;p=o+(j<<2)|0;f[h+8>>2]=p;g1c(o|0,0,m|0)|0;f[k>>2]=p;q=p;r=o;break}else{q=0;r=0}while(0);f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;if(l){s=0;t=0}else{l=j<<2;p=$Xc(l)|0;f[i>>2]=p;m=p+(j<<2)|0;f[i+8>>2]=m;g1c(p|0,0,l|0)|0;f[o>>2]=m;s=m;t=p}p=f[a+12>>2]|0;m=a+8|0;l=a+4|0;v=p+(f[l>>2]<<2)|0;w=v+-12|0;x=((w>>>0<p>>>0?p:w)+12+(3-p)|0)>>>4<<2;y=b+(x<<2)|0;if(p>>>0<w>>>0){z=p;A=b;B=0.0;while(1){C=+n[z>>2]-+n[A>>2];D=+n[z+4>>2]-+n[A+4>>2];E=+n[z+8>>2]-+n[A+8>>2];F=+n[z+12>>2]-+n[A+12>>2];G=B+(C*C+D*D+E*E+F*F);z=z+16|0;if(z>>>0>=w>>>0){H=G;break}else{A=A+16|0;B=G}}}else H=0.0;A=p+(x<<2)|0;if(A>>>0<v>>>0){x=y;B=H;y=A;while(1){G=+n[y>>2]-+n[x>>2];y=y+4|0;F=B+G*G;if(y>>>0>=v>>>0){I=F;break}else{x=x+4|0;B=F}}}else I=H;n[t>>2]=I;f[r>>2]=0;if((f[a>>2]|0)>>>0>1){x=f[h>>2]|0;v=f[i>>2]|0;i=1;y=1;while(1){A=p+((Y(f[m>>2]|0,y)|0)<<2)|0;w=A+(f[l>>2]<<2)|0;z=w+-12|0;J=((z>>>0<A>>>0?A:z)+12+(3-A)|0)>>>4<<2;K=b+(J<<2)|0;if(A>>>0<z>>>0){L=A;M=b;I=0.0;while(1){H=+n[L>>2]-+n[M>>2];B=+n[L+4>>2]-+n[M+4>>2];F=+n[L+8>>2]-+n[M+8>>2];G=+n[L+12>>2]-+n[M+12>>2];E=I+(H*H+B*B+F*F+G*G);L=L+16|0;if(L>>>0>=z>>>0){N=E;break}else{M=M+16|0;I=E}}}else N=0.0;M=A+(J<<2)|0;if(M>>>0<w>>>0){z=K;I=N;L=M;while(1){E=+n[L>>2]-+n[z>>2];L=L+4|0;G=I+E*E;if(L>>>0>=w>>>0){O=G;break}else{z=z+4|0;I=G}}}else O=N;if((i|0)>=(j|0)){z=i+-1|0;w=v+(z<<2)|0;if(O<+n[w>>2]){n[w>>2]=O;f[x+(z<<2)>>2]=y;P=i}else P=i}else{f[x+(i<<2)>>2]=y;n[v+(i<<2)>>2]=O;P=i+1|0}a:do if((P|0)>1){z=P;do{w=z;z=z+-1|0;L=v+(z<<2)|0;I=+n[L>>2];K=w+-2|0;w=v+(K<<2)|0;G=+n[w>>2];if(!(I<G))break a;n[L>>2]=G;n[w>>2]=I;w=x+(z<<2)|0;L=x+(K<<2)|0;K=f[w>>2]|0;f[w>>2]=f[L>>2];f[L>>2]=K}while((z|0)>1)}while(0);y=y+1|0;if(y>>>0>=(f[a>>2]|0)>>>0){Q=v;R=x;break}else i=P}}else{Q=t;R=r}if((d|0)>0){r=f[h>>2]|0;h=0;do{f[c+(h<<2)>>2]=f[r+(h+e<<2)>>2];h=h+1|0}while((h|0)!=(d|0));S=r}else S=R;if(Q|0){if((s|0)!=(Q|0))f[o>>2]=s+(~((s+-4-Q|0)>>>2)<<2);cYc(Q)}if(!S){u=g;return}if((q|0)!=(S|0))f[k>>2]=q+(~((q+-4-S|0)>>>2)<<2);cYc(S);u=g;return}function YAc(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0;k=u;u=u+48|0;l=k+40|0;m=k+32|0;o=k+24|0;p=k+8|0;q=k;Hwc(513750,q)|0;Hwc(513809,p)|0;r=+ZAc(a,b,c,d,i,1,p,q,h,j);if(r>e){Hwc(513868,k+16|0)|0;s=1;f[g>>2]=s;t=+n[p>>2];u=k;return +t}if(r<e){v=1;while(1){w=v<<1;x=+ZAc(a,b,c,d,i,w,p,q,h,j);if(x<e)v=w;else{y=v;z=x;A=w;break}}}else{y=1;z=r;A=1}if(!(+L(+(z-e))>1.0000000474974513e-03)){Hwc(513916,l)|0;s=A;f[g>>2]=s;t=+n[p>>2];u=k;return +t}Hwc(513891,o)|0;o=y;l=A;v=(y+A|0)/2|0;do{z=+ZAc(a,b,c,d,i,v,p,q,h,j);if(!(+L(+(z-e))>1.0000000474974513e-03)){s=v;B=11;break}A=z<e;l=A?l:v;o=A?v:o;v=(o+l|0)/2|0}while((v|0)!=(o|0));if((B|0)==11){f[g>>2]=s;t=+n[p>>2];u=k;return +t}Hwc(513868,m)|0;s=o;f[g>>2]=s;t=+n[p>>2];u=k;return +t}function ZAc(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,K=0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0;l=u;u=u+96|0;m=l+8|0;o=l;q=l+72|0;r=l+60|0;s=l+48|0;t=f[d+4>>2]|0;if(t>>>0<e>>>0){f[o>>2]=t;f[o+4>>2]=e;Hwc(513947,o)|0;o=af(60)|0;Jtc(o,513971);ig(o|0,22128,1)}o=k+e|0;f[q>>2]=173624;t=q+12|0;f[t>>2]=o;v=q+16|0;f[v>>2]=0;Yvc(r,g,0.0,1);f[s>>2]=0;w=s+4|0;f[w>>2]=0;f[s+8>>2]=0;do if(o)if(o>>>0>1073741823)kWc(s);else{x=o<<2;y=$Xc(x)|0;f[s>>2]=y;z=y+(o<<2)|0;f[s+8>>2]=z;g1c(y|0,0,x|0)|0;f[w>>2]=z;z=o<<2;x=$Xc(z)|0;g1c(x|0,0,z|0)|0;A=x;B=y;C=x;break}else{A=0;B=0;C=0}while(0);o=B+(k<<2)|0;k=q+4|0;B=q+8|0;x=q+20|0;y=c+12|0;z=c+8|0;D=d+12|0;E=d+8|0;d=(e|0)>0;F=c+4|0;G=0;H=0.0;do{G=G+1|0;I=xN()|0;K=J;a:do if(!(f[c>>2]|0)){L=0.0;M=0.0}else{if(d){N=0;O=0.0;P=0}else{Q=0;R=0.0;while(1){f[k>>2]=f[s>>2];f[B>>2]=C;f[v>>2]=0;n[x>>2]=3402823466385288598117041.0e14;n[C+((f[t>>2]|0)+-1<<2)>>2]=3402823466385288598117041.0e14;S=(f[y>>2]|0)+((Y(f[z>>2]|0,Q)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,q,S,r);S=(f[y>>2]|0)+((Y(f[z>>2]|0,Q)|0)<<2)|0;T=(f[D>>2]|0)+((Y(f[E>>2]|0,Q)|0)<<2)|0;U=R+ +_Ac(b,S,o,T,f[F>>2]|0,e,j);Q=Q+1|0;if(Q>>>0>=(f[c>>2]|0)>>>0){L=U;M=0.0;break a}else R=U}}do{f[k>>2]=f[s>>2];f[B>>2]=C;f[v>>2]=0;n[x>>2]=3402823466385288598117041.0e14;n[C+((f[t>>2]|0)+-1<<2)>>2]=3402823466385288598117041.0e14;Q=(f[y>>2]|0)+((Y(f[z>>2]|0,N)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,q,Q,r);Q=(f[D>>2]|0)+((Y(f[E>>2]|0,N)|0)<<2)|0;T=0;S=0;while(1){V=f[o+(T<<2)>>2]|0;W=0;while(1){if((V|0)==(f[Q+(W<<2)>>2]|0)){X=14;break}W=W+1|0;if((W|0)>=(e|0)){Z=S;break}}if((X|0)==14){X=0;Z=S+1|0}T=T+1|0;if((T|0)==(e|0))break;else S=Z}P=Z+P|0;S=(f[y>>2]|0)+((Y(f[z>>2]|0,N)|0)<<2)|0;O=O+ +_Ac(b,S,o,Q,f[F>>2]|0,e,j);N=N+1|0}while(N>>>0<(f[c>>2]|0)>>>0);L=O;M=+(P|0)}while(0);S=xN()|0;T=J;H=H+(+(S>>>0)+4294967296.0*+(T|0)-(+(I>>>0)+4294967296.0*+(K|0)))/+yN()}while(H<.2);n[h>>2]=H/+(G|0);G=f[c>>2]|0;H=+((Y(G,e)|0)>>>0);O=M/H;M=L/H;n[i>>2]=M;H=+n[h>>2];f[m>>2]=g;p[m+8>>3]=O;p[m+16>>3]=H;p[m+24>>3]=H*1.0e3/+(G>>>0);p[m+32>>3]=M;Hwc(514035,m)|0;if(C|0)cYc(A);A=f[s>>2]|0;if(!A){_=r+4|0;$=f[_>>2]|0;Ptc(r,$);u=l;return +O}s=f[w>>2]|0;if((s|0)!=(A|0))f[w>>2]=s+(~((s+-4-A|0)>>>2)<<2);cYc(A);_=r+4|0;$=f[_>>2]|0;Ptc(r,$);u=l;return +O}function _Ac(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;if((g|0)<=0){i=0.0;return +i}h=f[a+12>>2]|0;j=f[a+8>>2]|0;a=0;k=0.0;while(1){l=h+((Y(j,f[d+(a<<2)>>2]|0)|0)<<2)|0;m=l+(e<<2)|0;o=m+-12|0;p=((o>>>0<l>>>0?l:o)+12+(3-l)|0)>>>4<<2;q=b+(p<<2)|0;if(l>>>0<o>>>0){r=l;s=b;t=0.0;while(1){u=+n[r>>2]-+n[s>>2];v=+n[r+4>>2]-+n[s+4>>2];w=+n[r+8>>2]-+n[s+8>>2];x=+n[r+12>>2]-+n[s+12>>2];y=t+(u*u+v*v+w*w+x*x);r=r+16|0;if(r>>>0>=o>>>0){z=y;break}else{s=s+16|0;t=y}}}else z=0.0;s=l+(p<<2)|0;if(s>>>0<m>>>0){o=q;t=z;r=s;while(1){y=+n[r>>2]-+n[o>>2];r=r+4|0;x=t+y*y;if(r>>>0>=m>>>0){A=x;break}else{o=o+4|0;t=x}}}else A=z;o=h+((Y(j,f[c+(a<<2)>>2]|0)|0)<<2)|0;m=o+(e<<2)|0;r=m+-12|0;q=((r>>>0<o>>>0?o:r)+12+(3-o)|0)>>>4<<2;p=b+(q<<2)|0;if(o>>>0<r>>>0){l=o;s=b;t=0.0;while(1){x=+n[l>>2]-+n[s>>2];y=+n[l+4>>2]-+n[s+4>>2];w=+n[l+8>>2]-+n[s+8>>2];v=+n[l+12>>2]-+n[s+12>>2];u=t+(x*x+y*y+w*w+v*v);l=l+16|0;if(l>>>0>=r>>>0){B=u;break}else{s=s+16|0;t=u}}}else B=0.0;s=o+(q<<2)|0;if(s>>>0<m>>>0){r=p;t=B;l=s;while(1){u=+n[l>>2]-+n[r>>2];l=l+4|0;v=t+u*u;if(l>>>0>=m>>>0){C=v;break}else{r=r+4|0;t=v}}}else C=B;t=k+(A==0.0&C==0.0?1.0:C/A);a=a+1|0;if((a|0)==(g|0)){i=t;break}else k=t}return +i}function $Ac(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[a>>2]|0;j=(h-i|0)/28|0;k=j+1|0;l=i;m=h;if(k>>>0>153391689)kWc(a);h=a+8|0;n=((f[h>>2]|0)-i|0)/28|0;i=n<<1;o=n>>>0<76695844?(i>>>0<k>>>0?k:i):153391689;do if(o)if(o>>>0>153391689){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{p=$Xc(o*28|0)|0;break}else p=0;while(0);i=p+(j*28|0)|0;k=i;n=p+(o*28|0)|0;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];o=p+(j*28|0)+16|0;f[p+(j*28|0)+20>>2]=0;f[p+(j*28|0)+24>>2]=0;q=p+(j*28|0)+20|0;f[o>>2]=q;j=f[b+16>>2]|0;p=b+20|0;if((j|0)==(p|0)){r=m;s=l}else{l=q;q=j;while(1){j=q+16|0;f[e>>2]=l;f[d>>2]=f[e>>2];Qtc(o,d,j,j)|0;j=f[q+4>>2]|0;if(!j){m=q+8|0;b=f[m>>2]|0;if((f[b>>2]|0)==(q|0))t=b;else{b=m;do{m=f[b>>2]|0;b=m+8|0;v=f[b>>2]|0}while((f[v>>2]|0)!=(m|0));t=v}}else{b=j;while(1){v=f[b>>2]|0;if(!v)break;else b=v}t=b}if((t|0)==(p|0))break;else q=t}r=f[g>>2]|0;s=f[a>>2]|0}t=i+28|0;if((r|0)==(s|0)){w=k;x=r;y=r}else{q=r;r=k;k=i;do{i=k+-28|0;p=q;q=q+-28|0;f[i>>2]=f[q>>2];f[i+4>>2]=f[q+4>>2];f[i+8>>2]=f[q+8>>2];f[i+12>>2]=f[q+12>>2];i=k+-12|0;d=p+-12|0;f[i>>2]=f[d>>2];o=f[p+-8>>2]|0;f[k+-8>>2]=o;e=p+-4|0;l=f[e>>2]|0;f[k+-4>>2]=l;j=k+-8|0;if(!l)f[i>>2]=j;else{f[o+8>>2]=j;j=p+-8|0;f[d>>2]=j;f[j>>2]=0;f[e>>2]=0}k=r+-28|0;r=k}while((q|0)!=(s|0));w=r;x=f[a>>2]|0;y=f[g>>2]|0}f[a>>2]=w;f[g>>2]=t;f[h>>2]=n;n=x;if((y|0)!=(n|0)){h=y;do{Ptc(h+-12|0,f[h+-8>>2]|0);h=h+-28|0}while((h|0)!=(n|0))}if(!x){u=c;return}cYc(x);u=c;return}function aBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+96|0;e=d;g=d+80|0;h=d+64|0;i=d+44|0;j=d+16|0;k=d+4|0;Hwc(514784,e)|0;f[h>>2]=f[43445];f[h+4>>2]=f[43446];f[h+8>>2]=f[43447];f[h+12>>2]=f[43448];f[i>>2]=f[43449];f[i+4>>2]=f[43450];f[i+8>>2]=f[43451];f[i+12>>2]=f[43452];f[i+16>>2]=f[43453];l=c+4|0;KBc(c,(((f[l>>2]|0)-(f[c>>2]|0)|0)/28|0)+20|0);m=j+20|0;n=j+24|0;o=j+20|0;p=j+16|0;q=j+16|0;r=k+11|0;s=k+9|0;t=k+8|0;v=k+4|0;w=k+11|0;x=g+11|0;y=g+10|0;z=g+11|0;A=g+9|0;B=c+8|0;C=j+16|0;D=0;do{E=h+(D<<2)|0;F=0;do{f[m>>2]=0;f[n>>2]=0;f[p>>2]=o;f[g>>2]=2;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[r>>0]=9;G=k;H=512094;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[s>>0]=0;J=Ntc(q,e,k)|0;K=f[J>>2]|0;if(!K){L=$Xc(36)|0;M=L+16|0;f[M>>2]=f[k>>2];f[M+4>>2]=f[k+4>>2];f[M+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[L+28>>2]=172888;f[L+32>>2]=0;M=f[e>>2]|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=M;f[J>>2]=L;M=f[f[q>>2]>>2]|0;if(!M)N=L;else{f[q>>2]=M;N=f[J>>2]|0}UQ(f[m>>2]|0,N);f[n>>2]=(f[n>>2]|0)+1;O=L}else O=K;K=O+28|0;L=f[K>>2]|0;J=O+32|0;mi[f[f[L>>2]>>2]&2047](L,J);f[K>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,J);if((b[r>>0]|0)<0)cYc(f[k>>2]|0);f[g>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;J=$Xc(16)|0;f[k>>2]=J;f[t>>2]=-2147483632;f[v>>2]=12;G=J;H=512677;I=G+12|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[J+12>>0]=0;K=Ntc(q,e,k)|0;L=f[K>>2]|0;if(!L){M=$Xc(36)|0;P=M+16|0;f[P>>2]=f[k>>2];f[P+4>>2]=f[k+4>>2];f[P+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[M+28>>2]=172888;f[M+32>>2]=0;P=f[e>>2]|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=P;f[K>>2]=M;P=f[f[q>>2]>>2]|0;if(!P)Q=M;else{f[q>>2]=P;Q=f[K>>2]|0}UQ(f[m>>2]|0,Q);f[n>>2]=(f[n>>2]|0)+1;R=M}else R=L;L=R+28|0;M=f[L>>2]|0;K=R+32|0;mi[f[f[M>>2]>>2]&2047](M,K);f[L>>2]=173316;Ti[f[(f[43329]|0)+4>>2]&511](173316,g,K);if((b[w>>0]|0)<0)cYc(f[k>>2]|0);b[x>>0]=10;G=g;H=514827;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[y>>0]=0;J=Ntc(q,e,g)|0;K=f[J>>2]|0;if(!K){L=$Xc(36)|0;M=L+16|0;f[M>>2]=f[g>>2];f[M+4>>2]=f[g+4>>2];f[M+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[L+28>>2]=172888;f[L+32>>2]=0;M=f[e>>2]|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=M;f[J>>2]=L;M=f[f[q>>2]>>2]|0;if(!M)S=L;else{f[q>>2]=M;S=f[J>>2]|0}UQ(f[m>>2]|0,S);f[n>>2]=(f[n>>2]|0)+1;T=L}else T=K;K=T+28|0;L=f[K>>2]|0;J=T+32|0;mi[f[f[L>>2]>>2]&2047](L,J);f[K>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,E,J);if((b[x>>0]|0)<0)cYc(f[g>>2]|0);J=i+(F<<2)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[z>>0]=9;G=g;H=512667;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[A>>0]=0;H=Ntc(q,e,g)|0;G=f[H>>2]|0;if(!G){I=$Xc(36)|0;K=I+16|0;f[K>>2]=f[g>>2];f[K+4>>2]=f[g+4>>2];f[K+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[I+28>>2]=172888;f[I+32>>2]=0;K=f[e>>2]|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=K;f[H>>2]=I;K=f[f[q>>2]>>2]|0;if(!K)U=I;else{f[q>>2]=K;U=f[H>>2]|0}UQ(f[m>>2]|0,U);f[n>>2]=(f[n>>2]|0)+1;V=I}else V=G;G=V+28|0;I=f[G>>2]|0;H=V+32|0;mi[f[f[I>>2]>>2]&2047](I,H);f[G>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,J,H);if((b[z>>0]|0)<0)cYc(f[g>>2]|0);LBc(a,j);H=f[l>>2]|0;if((H|0)==(f[B>>2]|0))$Ac(c,j);else{f[H>>2]=f[j>>2];f[H+4>>2]=f[j+4>>2];f[H+8>>2]=f[j+8>>2];f[H+12>>2]=f[j+12>>2];G=H+16|0;f[H+20>>2]=0;f[H+24>>2]=0;I=H+20|0;f[G>>2]=I;H=f[p>>2]|0;if((H|0)!=(o|0)){K=I;I=H;while(1){H=I+16|0;f[g>>2]=K;f[e>>2]=f[g>>2];Qtc(G,e,H,H)|0;H=f[I+4>>2]|0;if(!H){L=I+8|0;M=f[L>>2]|0;if((f[M>>2]|0)==(I|0))W=M;else{M=L;do{L=f[M>>2]|0;M=L+8|0;P=f[M>>2]|0}while((f[P>>2]|0)!=(L|0));W=P}}else{M=H;while(1){P=f[M>>2]|0;if(!P)break;else M=P}W=M}if((W|0)==(o|0))break;else I=W}}f[l>>2]=(f[l>>2]|0)+28}Ptc(C,f[o>>2]|0);F=F+1|0}while(F>>>0<5);D=D+1|0}while(D>>>0<4);u=d;return}function bBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+80|0;e=d;g=d+64|0;h=d+44|0;i=d+16|0;j=d+4|0;Hwc(514287,e)|0;f[h>>2]=f[43411];f[h+4>>2]=f[43412];f[h+8>>2]=f[43413];f[h+12>>2]=f[43414];f[h+16>>2]=f[43415];k=i+20|0;l=i+24|0;m=i+20|0;n=i+16|0;o=i+16|0;p=j+11|0;q=j+9|0;r=g+11|0;s=g+5|0;t=c+4|0;v=c+8|0;w=i+16|0;x=0;do{f[k>>2]=0;f[l>>2]=0;f[n>>2]=m;f[g>>2]=1;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[p>>0]=9;y=j;z=512094;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[q>>0]=0;z=Ntc(o,e,j)|0;y=f[z>>2]|0;if(!y){A=$Xc(36)|0;B=A+16|0;f[B>>2]=f[j>>2];f[B+4>>2]=f[j+4>>2];f[B+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[A+28>>2]=172888;f[A+32>>2]=0;B=f[e>>2]|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=B;f[z>>2]=A;B=f[f[o>>2]>>2]|0;if(!B)C=A;else{f[o>>2]=B;C=f[z>>2]|0}UQ(f[k>>2]|0,C);f[l>>2]=(f[l>>2]|0)+1;D=A}else D=y;y=D+28|0;A=f[y>>2]|0;z=D+32|0;mi[f[f[A>>2]>>2]&2047](A,z);f[y>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,z);if((b[p>>0]|0)<0)cYc(f[j>>2]|0);z=h+(x<<2)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[r>>0]=5;b[g>>0]=b[512723]|0;b[g+1>>0]=b[512724]|0;b[g+2>>0]=b[512725]|0;b[g+3>>0]=b[512726]|0;b[g+4>>0]=b[512727]|0;b[s>>0]=0;y=Ntc(o,e,g)|0;A=f[y>>2]|0;if(!A){B=$Xc(36)|0;E=B+16|0;f[E>>2]=f[g>>2];f[E+4>>2]=f[g+4>>2];f[E+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[B+28>>2]=172888;f[B+32>>2]=0;E=f[e>>2]|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=E;f[y>>2]=B;E=f[f[o>>2]>>2]|0;if(!E)F=B;else{f[o>>2]=E;F=f[y>>2]|0}UQ(f[k>>2]|0,F);f[l>>2]=(f[l>>2]|0)+1;G=B}else G=A;A=G+28|0;B=f[A>>2]|0;y=G+32|0;mi[f[f[B>>2]>>2]&2047](B,y);f[A>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,z,y);if((b[r>>0]|0)<0)cYc(f[g>>2]|0);cBc(a,i);y=f[t>>2]|0;if((y|0)==(f[v>>2]|0))$Ac(c,i);else{f[y>>2]=f[i>>2];f[y+4>>2]=f[i+4>>2];f[y+8>>2]=f[i+8>>2];f[y+12>>2]=f[i+12>>2];z=y+16|0;f[y+20>>2]=0;f[y+24>>2]=0;A=y+20|0;f[z>>2]=A;y=f[n>>2]|0;if((y|0)!=(m|0)){B=A;A=y;while(1){y=A+16|0;f[g>>2]=B;f[e>>2]=f[g>>2];Qtc(z,e,y,y)|0;y=f[A+4>>2]|0;if(!y){E=A+8|0;H=f[E>>2]|0;if((f[H>>2]|0)==(A|0))I=H;else{H=E;do{E=f[H>>2]|0;H=E+8|0;J=f[H>>2]|0}while((f[J>>2]|0)!=(E|0));I=J}}else{H=y;while(1){J=f[H>>2]|0;if(!J)break;else H=J}I=H}if((I|0)==(m|0))break;else A=I}}f[t>>2]=(f[t>>2]|0)+28}Ptc(w,f[m>>2]|0);x=x+1|0}while(x>>>0<5);u=d;return}function cBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0;d=u;u=u+160|0;e=d+16|0;g=d;h=d+128|0;i=d+132|0;j=d+32|0;k=c+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=i+11|0;b[l>>0]=5;b[i>>0]=b[512723]|0;b[i+1>>0]=b[512724]|0;b[i+2>>0]=b[512725]|0;b[i+3>>0]=b[512726]|0;b[i+4>>0]=b[512727]|0;b[i+5>>0]=0;m=Cwc(k,i)|0;f[e>>2]=m;Hwc(514331,e)|0;if((b[l>>0]|0)<0)cYc(f[i>>2]|0);i=a+32|0;b[e>>0]=b[d+144>>0]|0;Tzc(j,i,k,e);k=xN()|0;l=J;m=j+4|0;if((f[m>>2]|0)>0){o=j+8|0;q=e+8|0;r=e+4|0;s=j+48|0;t=j+64|0;v=0;do{w=q;f[w>>2]=0;f[w+4>>2]=0;f[e>>2]=-2096955388;f[r>>2]=o;SR(e,1.0,0);w=dBc(j,f[o>>2]|0,f[s>>2]|0)|0;f[(f[t>>2]|0)+(v<<2)>>2]=w;v=v+1|0}while((v|0)<(f[m>>2]|0))}m=xN()|0;v=J;x=(+(m>>>0)+4294967296.0*+(v|0)-(+(k>>>0)+4294967296.0*+(l|0)))/+yN()+0.0;y=+YAc(j,i,a+48|0,a+64|0,+n[a+100>>2],h,a+116|0,1,0);z=+((Y(f[i>>2]<<2,f[a+36>>2]|0)|0)>>>0);n[c+8>>2]=(z+ +((f[j+88>>2]|0)+(f[j+84>>2]|0)+(f[j+20>>2]<<2)|0))/z;n[c>>2]=y;n[c+4>>2]=x;p[g>>3]=x;p[g+8>>3]=y;Hwc(514362,g)|0;eBc(j);u=d;return}function dBc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;i=a+68|0;j=f[i>>2]|0;do if((j|0)<16){k=a+88|0;f[k>>2]=(f[k>>2]|0)+j;k=jIc(8192)|0;if(!k){eKc(513012,27,1,f[46249]|0)|0;l=0;break}else{m=a+72|0;f[k>>2]=f[m>>2];f[m>>2]=k;f[i>>2]=8188;m=k+4|0;k=a+76|0;f[k>>2]=m;n=k;o=m;p=8172;q=6;break}}else{m=a+76|0;n=m;o=f[m>>2]|0;p=j+-16|0;q=6}while(0);if((q|0)==6){f[n>>2]=o+16;f[i>>2]=p;p=a+84|0;f[p>>2]=(f[p>>2]|0)+16;l=o}if((c|0)==1){f[l+12>>2]=0;f[l+8>>2]=0;f[l>>2]=f[b>>2];u=d;return l|0}else{HBc(a,b,c,e,g,h);f[l>>2]=f[g>>2];f[l+4>>2]=f[h>>2];h=dBc(a,b,f[e>>2]|0)|0;f[l+8>>2]=h;h=f[e>>2]|0;e=dBc(a,b+(h<<2)|0,c-h|0)|0;f[l+12>>2]=e;u=d;return l|0}return 0}function eBc(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=174456;b=f[a+64>>2]|0;if(b|0)dYc(b);b=f[a+56>>2]|0;if(b|0)dYc(b);b=f[a+60>>2]|0;if(b|0)dYc(b);b=a+72|0;c=f[b>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;kIc(c);f[b>>2]=d}while((d|0)!=0)}Ptc(a+36|0,f[a+40>>2]|0);d=f[a+8>>2]|0;if(!d)return;b=a+12|0;a=f[b>>2]|0;if((a|0)!=(d|0))f[b>>2]=a+(~((a+-4-d|0)>>>2)<<2);cYc(d);return}function fBc(a){a=a|0;eBc(a);cYc(a);return}function gBc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+16|0;c=b;d=a+4|0;if((f[d>>2]|0)<=0){u=b;return}e=a+8|0;g=c+8|0;h=c+4|0;i=a+48|0;j=a+64|0;k=0;do{l=g;f[l>>2]=0;f[l+4>>2]=0;f[c>>2]=-2096955388;f[h>>2]=e;SR(c,1.0,0);l=dBc(a,f[e>>2]|0,f[i>>2]|0)|0;f[(f[j>>2]|0)+(k<<2)>>2]=l;k=k+1|0}while((k|0)<(f[d>>2]|0));u=b;return}function hBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+4|0;eKc(c,4,1,b)|0;if((f[c>>2]|0)<=0)return;d=a+64|0;e=0;do{GBc(a,b,f[(f[d>>2]|0)+(e<<2)>>2]|0);e=e+1|0}while((e|0)<(f[c>>2]|0));return}function iBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;i=a+4|0;if((NLc(i,4,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+64|0;k=f[j>>2]|0;if(k|0)dYc(k);k=f[i>>2]|0;l=bYc(k>>>0>1073741823?-1:k<<2)|0;f[j>>2]=l;if((k|0)>0?(vBc(a,c,l),(f[i>>2]|0)>1):0){l=1;do{vBc(a,c,(f[j>>2]|0)+(l<<2)|0);l=l+1|0}while((l|0)<(f[i>>2]|0))}i=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=i;i=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=9;c=h;k=512094;m=c+9|0;do{b[c>>0]=b[k>>0]|0;c=c+1|0;k=k+1|0}while((c|0)<(m|0));b[h+9>>0]=0;k=Ntc(i,e,h)|0;c=f[k>>2]|0;if(!c){m=$Xc(36)|0;n=m+16|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[m+28>>2]=172888;f[m+32>>2]=0;n=f[e>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=n;f[k>>2]=m;n=f[f[i>>2]>>2]|0;if(!n)o=m;else{f[i>>2]=n;o=f[k>>2]|0}UQ(f[a+40>>2]|0,o);o=a+44|0;f[o>>2]=(f[o>>2]|0)+1;p=m}else p=c;c=p+28|0;m=f[c>>2]|0;o=p+32|0;mi[f[f[m>>2]>>2]&2047](m,o);f[c>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,o);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=5;b[g>>0]=b[512723]|0;b[g+1>>0]=b[512724]|0;b[g+2>>0]=b[512725]|0;b[g+3>>0]=b[512726]|0;b[g+4>>0]=b[512727]|0;b[g+5>>0]=0;l=Ntc(i,e,g)|0;o=f[l>>2]|0;if(!o){c=$Xc(36)|0;m=c+16|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[c+28>>2]=172888;f[c+32>>2]=0;m=f[e>>2]|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=m;f[l>>2]=c;m=f[f[i>>2]>>2]|0;if(!m)q=c;else{f[i>>2]=m;q=f[l>>2]|0}UQ(f[a+40>>2]|0,q);q=a+44|0;f[q>>2]=(f[q>>2]|0)+1;r=c}else r=o;o=r+28|0;c=f[o>>2]|0;q=r+32|0;mi[f[f[c>>2]>>2]&2047](c,q);f[o>>2]=174508;Ti[f[(f[43627]|0)+4>>2]&511](174508,j,q);if((b[h>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function jBc(a){a=a|0;return f[a+48>>2]|0}function kBc(a){a=a|0;return f[a+52>>2]|0}function lBc(a){a=a|0;return (f[a+88>>2]|0)+(f[a+84>>2]|0)+(f[a+20>>2]<<2)|0}function mBc(a){a=a|0;return 1}function nBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+36>>2]|0;i=b+40|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function oBc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0;g=u;u=u+32|0;h=g+12|0;i=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=h+11|0;b[j>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;k=auc(e,h)|0;l=e+4|0;do if((k|0)!=(l|0)){m=k+28|0;o=f[m>>2]|0;p=(_i[f[(f[o>>2]|0)+28>>2]&2047](o)|0)+4|0;if((f[p>>2]|0)==(f[6379]|0)){p=f[m>>2]|0;m=Mi[f[(f[p>>2]|0)+20>>2]&1023](p,k+32|0)|0;q=f[m>>2]|0;break}else ig(af(1)|0,22144,0)}else q=32;while(0);if((b[j>>0]|0)<0)cYc(f[h>>2]|0);h=i+4|0;f[h>>2]=0;f[h+4>>2]=0;h=i+11|0;b[h>>0]=3;b[i>>0]=b[513188]|0;b[i+1>>0]=b[513189]|0;b[i+2>>0]=b[513190]|0;b[i+3>>0]=0;j=auc(e,i)|0;do if((j|0)!=(l|0)){e=j+28|0;k=f[e>>2]|0;m=(_i[f[(f[k>>2]|0)+28>>2]&2047](k)|0)+4|0;if((f[m>>2]|0)==(f[6387]|0)){m=f[e>>2]|0;e=Mi[f[(f[m>>2]|0)+20>>2]&1023](m,j+32|0)|0;r=+n[e>>2]+1.0;break}else ig(af(1)|0,22144,0)}else r=1.0;while(0);if((b[h>>0]|0)<0)cYc(f[i>>2]|0);if((q|0)!=-1){qBc(a,c,d,q,r);u=g;return}q=a+4|0;i=f[q>>2]|0;if((i|0)>1){eKc(514398,68,1,f[46249]|0)|0;s=f[q>>2]|0}else s=i;if((s|0)<=0){u=g;return}pBc(a,c,d,f[f[a+64>>2]>>2]|0,0.0,r);u=g;return}function pBc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;h=d;i=e;while(1){d=h+8|0;j=h+12|0;if((f[d>>2]|0)==0?(f[j>>2]|0)==0:0)break;e=+n[c+(f[h>>2]<<2)>>2]-+n[h+4>>2];k=e<0.0;l=f[(k?j:d)>>2]|0;pBc(a,b,c,f[(k?d:j)>>2]|0,i,g);i=i+e*e;if(!(i*g<=+Vg[f[(f[b>>2]|0)+16>>2]&31](b))){m=10;break}else h=l}if((m|0)==10)return;m=f[h>>2]|0;h=(f[a+32>>2]|0)+((Y(f[a+28>>2]|0,m)|0)<<2)|0;l=h+(f[a+52>>2]<<2)|0;a=l+-12|0;j=((a>>>0<h>>>0?h:a)+12+(3-h)|0)>>>4<<2;d=c+(j<<2)|0;if(h>>>0<a>>>0){k=h;o=c;g=0.0;while(1){i=+n[k>>2]-+n[o>>2];e=+n[k+4>>2]-+n[o+4>>2];p=+n[k+8>>2]-+n[o+8>>2];q=+n[k+12>>2]-+n[o+12>>2];r=g+(i*i+e*e+p*p+q*q);k=k+16|0;if(k>>>0>=a>>>0){s=r;break}else{o=o+16|0;g=r}}}else s=0.0;o=h+(j<<2)|0;if(o>>>0<l>>>0){j=d;g=s;d=o;while(1){r=+n[d>>2]-+n[j>>2];d=d+4|0;q=g+r*r;if(d>>>0>=l>>>0){t=q;break}else{j=j+4|0;g=q}}}else t=s;Hg[f[(f[b>>2]|0)+12>>2]&15](b,t,m);return}function qBc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+24|0;i=g+16|0;j=g;f[i>>2]=0;k=$Xc(20)|0;l=a+48|0;m=f[l>>2]|0;f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;f[k+12>>2]=m;rBc(k,m);f[k+16>>2]=0;m=f[l>>2]|0;f[j>>2]=0;l=j+4|0;f[l>>2]=0;f[j+8>>2]=0;f[j+12>>2]=m;oaa(j,(m>>>5)+1|0);m=f[j>>2]|0;p=(f[l>>2]|0)-m|0;q=p>>>2;if((p|0)>0)g1c(m|0,0,(((q|0)==0?q^1073741823:1073741822)+q<<2)+8|0)|0;q=a+4|0;if((f[q>>2]|0)>0){m=a+64|0;p=0;do{sBc(a,b,c,f[(f[m>>2]|0)+(p<<2)>>2]|0,0.0,i,d,e,k,j);p=p+1|0}while((p|0)<(f[q>>2]|0))}q=h+4|0;while(1){if(!(tBc(k,h)|0))break;if((f[i>>2]|0)>=(d|0)?_i[f[(f[b>>2]|0)+8>>2]&2047](b)|0:0)break;sBc(a,b,c,f[h>>2]|0,+n[q>>2],i,d,e,k,j)}d=f[k>>2]|0;if(d|0){i=f[o>>2]|0;if((i|0)!=(d|0))f[o>>2]=i+(~((i+-8-d|0)>>>3)<<3);cYc(d)}cYc(k);k=f[j>>2]|0;if(!k){u=g;return}j=f[l>>2]|0;if((j|0)!=(k|0))f[l>>2]=j+(~((j+-4-k|0)>>>2)<<2);cYc(k);u=g;return}function rBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function sBc(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0;l=u;u=u+16|0;m=l;if(+Vg[f[(f[b>>2]|0)+16>>2]&31](b)<e){u=l;return}o=d+8|0;p=d+12|0;if((f[o>>2]|0)==0?(f[p>>2]|0)==0:0){q=f[d>>2]|0;r=q>>>5;s=f[k>>2]|0;t=f[s+(r<<2)>>2]|0;v=1<<(q&31);if(t&v|0){u=l;return}do if((f[g>>2]|0)>=(h|0))if(_i[f[(f[b>>2]|0)+8>>2]&2047](b)|0){u=l;return}else{w=f[k>>2]|0;x=w;y=f[w+(r<<2)>>2]|0;break}else{x=s;y=t}while(0);f[x+(r<<2)>>2]=y|v;f[g>>2]=(f[g>>2]|0)+1;v=(f[a+32>>2]|0)+((Y(f[a+28>>2]|0,q)|0)<<2)|0;y=v+(f[a+52>>2]<<2)|0;r=y+-12|0;x=((r>>>0<v>>>0?v:r)+12+(3-v)|0)>>>4<<2;t=c+(x<<2)|0;if(v>>>0<r>>>0){s=v;w=c;z=0.0;while(1){A=+n[s>>2]-+n[w>>2];B=+n[s+4>>2]-+n[w+4>>2];C=+n[s+8>>2]-+n[w+8>>2];D=+n[s+12>>2]-+n[w+12>>2];E=z+(A*A+B*B+C*C+D*D);s=s+16|0;if(s>>>0>=r>>>0){F=E;break}else{w=w+16|0;z=E}}}else F=0.0;w=v+(x<<2)|0;if(w>>>0<y>>>0){x=t;z=F;t=w;while(1){E=+n[t>>2]-+n[x>>2];t=t+4|0;D=z+E*E;if(t>>>0>=y>>>0){G=D;break}else{x=x+4|0;z=D}}}else G=F;Hg[f[(f[b>>2]|0)+12>>2]&15](b,G,q);u=l;return}G=+n[c+(f[d>>2]<<2)>>2]-+n[d+4>>2];d=G<0.0;q=f[(d?o:p)>>2]|0;x=f[(d?p:o)>>2]|0;F=G*G+e;if(!(!(F*i<+Vg[f[(f[b>>2]|0)+16>>2]&31](b))?_i[f[(f[b>>2]|0)+8>>2]&2047](b)|0:0))H=15;if((H|0)==15?(f[m>>2]=x,n[m+4>>2]=F,x=j+16|0,(f[x>>2]|0)!=(f[j+12>>2]|0)):0){H=j+4|0;o=f[H>>2]|0;if((o|0)==(f[j+8>>2]|0)){uBc(j,m);I=f[H>>2]|0}else{p=m;m=f[p+4>>2]|0;d=o;f[d>>2]=f[p>>2];f[d+4>>2]=m;m=(f[H>>2]|0)+8|0;f[H>>2]=m;I=m}m=f[j>>2]|0;H=I-m|0;if((H|0)>8?(d=((H>>>3)+-2|0)/2|0,H=I+-8|0,F=+n[I+-4>>2],F<+n[m+(d<<3)+4>>2]):0){I=f[H>>2]|0;p=H;H=d;while(1){d=p;p=m+(H<<3)|0;o=p;y=f[o+4>>2]|0;t=d;f[t>>2]=f[o>>2];f[t+4>>2]=y;if(!H){J=0;break}y=(H+-1|0)/2|0;if(!(F<+n[m+(y<<3)+4>>2])){J=H;break}else H=y}f[p>>2]=I;n[m+(J<<3)+4>>2]=F}f[x>>2]=(f[x>>2]|0)+1}sBc(a,b,c,q,e,g,h,i,j,k);u=l;return}function tBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0;c=a+16|0;if(!(f[c>>2]|0)){d=0;return d|0}e=f[a>>2]|0;g=f[e+4>>2]|0;h=b;f[h>>2]=f[e>>2];f[h+4>>2]=g;g=f[a>>2]|0;h=a+4|0;a=f[h>>2]|0;e=a-g|0;b=e>>3;if(((e|0)>8?(e=a+-8|0,a=g,i=f[a>>2]|0,j=f[a+4>>2]|0,a=e,k=f[a+4>>2]|0,l=g,f[l>>2]=f[a>>2],f[l+4>>2]=k,k=e,f[k>>2]=i,f[k+4>>2]=j,j=b+-1|0,(b|0)!=2):0)?(k=b+-3|0,b=(k|0)/2|0,(k|0)>=-1):0){k=g+8|0;if((j|0)>2?+n[g+20>>2]<+n[g+12>>2]:0){m=2;o=g+16|0}else{m=1;o=k}p=+n[g+4>>2];if(!(p<+n[o+4>>2])){k=f[g>>2]|0;i=m;m=o;o=g;while(1){e=o;o=m;l=o;a=f[l+4>>2]|0;q=e;f[q>>2]=f[l>>2];f[q+4>>2]=a;if((b|0)<(i|0))break;a=i<<1|1;q=g+(a<<3)|0;l=q;e=a+1|0;if((e|0)<(j|0)?(r=q+8|0,+n[r+4>>2]<+n[g+(a<<3)+4>>2]):0){s=e;t=r}else{s=a;t=l}if(p<+n[t+4>>2])break;else{i=s;m=t}}f[m>>2]=k;n[m+4>>2]=p}}f[h>>2]=(f[h>>2]|0)+-8;f[c>>2]=(f[c>>2]|0)+-1;d=1;return d|0}function uBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function vBc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+68|0;e=a+88|0;g=f[46249]|0;h=a+72|0;i=a+76|0;j=a+84|0;k=c;while(1){c=f[d>>2]|0;do if((c|0)<16){f[e>>2]=(f[e>>2]|0)+c;l=jIc(8192)|0;if(!l){eKc(513012,27,1,g)|0;m=0;break}else{f[l>>2]=f[h>>2];f[h>>2]=l;f[d>>2]=8188;n=l+4|0;f[i>>2]=n;o=n;p=8172;q=7;break}}else{o=f[i>>2]|0;p=c+-16|0;q=7}while(0);if((q|0)==7){q=0;f[i>>2]=o+16;f[d>>2]=p;f[j>>2]=(f[j>>2]|0)+16;m=o}f[k>>2]=m;if((NLc(m,16,1,b)|0)!=1){q=9;break}c=f[k>>2]|0;n=c+8|0;if(!(f[n>>2]|0))r=c;else{vBc(a,b,n);r=f[k>>2]|0}k=r+12|0;if(!(f[k>>2]|0)){q=13;break}}if((q|0)==9){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}else if((q|0)==13)return}function wBc(a,b){a=a|0;b=b|0;return}function xBc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function yBc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function zBc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function ABc(a,b){a=a|0;b=b|0;return b|0}function BBc(a,b){a=a|0;b=b|0;return b|0}function CBc(a){a=a|0;return 4}function DBc(a){a=a|0;return 22824}function EBc(a,b,c){a=a|0;b=b|0;c=c|0;rOc(b,f[c>>2]|0)|0;return}function FBc(a){a=a|0;cYc(a);return}function GBc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=c;do{eKc(d,16,1,b)|0;c=f[d+8>>2]|0;if(c|0)GBc(a,b,c);d=f[d+12>>2]|0}while((d|0)!=0);return}function HBc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+56|0;l=a+52|0;g1c(f[k>>2]|0,0,f[l>>2]<<2|0)|0;m=a+60|0;g1c(f[m>>2]|0,0,f[l>>2]<<2|0)|0;o=(c|0)<101?c:101;p=(c|0)>0;if(p){q=f[a+32>>2]|0;r=f[a+28>>2]|0;t=f[l>>2]|0;if(t|0){v=f[k>>2]|0;w=0;do{x=q+((Y(r,f[b+(w<<2)>>2]|0)|0)<<2)|0;y=0;do{z=v+(y<<2)|0;n[z>>2]=+n[x+(y<<2)>>2]+ +n[z>>2];y=y+1|0}while(y>>>0<t>>>0);w=w+1|0}while((w|0)<(o|0));A=t;B=8}}else{A=f[l>>2]|0;B=8}if((B|0)==8){B=(A|0)==0;if(B){C=0;D=1}else{E=+(o|0);l=f[k>>2]|0;t=0;do{w=l+(t<<2)|0;n[w>>2]=+n[w>>2]/E;t=t+1|0}while(t>>>0<A>>>0);C=A;D=B}if(p?(p=f[a+32>>2]|0,B=f[a+28>>2]|0,!D):0){D=f[k>>2]|0;A=f[m>>2]|0;t=0;do{l=p+((Y(B,f[b+(t<<2)>>2]|0)|0)<<2)|0;w=0;do{E=+n[l+(w<<2)>>2]-+n[D+(w<<2)>>2];v=A+(w<<2)|0;n[v>>2]=+n[v>>2]+E*E;w=w+1|0}while(w>>>0<C>>>0);t=t+1|0}while((t|0)<(o|0))}}o=IBc(a,f[m>>2]|0)|0;f[e>>2]=o;e=f[(f[k>>2]|0)+(o<<2)>>2]|0;f[g>>2]=e;JBc(a,b,c,o,(f[s>>2]=e,+n[s>>2]),i,j);e=f[i>>2]|0;i=(c|0)/2|0;o=f[j>>2]|0;f[d>>2]=(e|0)==(c|0)|(o|0)==0?i:(e|0)>(i|0)?e:(o|0)<(i|0)?o:i;u=h;return}function IBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c;e=f[a+52>>2]|0;if(!e)g=0;else{a=0;h=0;while(1){if((h|0)<5){i=h+1|0;f[d+(h<<2)>>2]=a;if((h|0)>0){j=i;k=7}else l=i}else{i=h+-1|0;if(+n[b+(a<<2)>>2]>+n[b+(f[d+(i<<2)>>2]<<2)>>2]){f[d+(i<<2)>>2]=a;j=h;k=7}else l=h}a:do if((k|0)==7){k=0;i=j;while(1){m=i;i=i+-1|0;o=d+(i<<2)|0;p=f[o>>2]|0;q=d+(m+-2<<2)|0;m=f[q>>2]|0;if(!(+n[b+(p<<2)>>2]>+n[b+(m<<2)>>2])){l=j;break a}f[o>>2]=m;f[q>>2]=p;if((i|0)<=1){l=j;break}}}while(0);a=a+1|0;if(a>>>0>=e>>>0){g=l;break}else h=l}}l=OR()|0;h=l;e=f[h+4>>2]|0;a=x1c(f[h>>2]|0,0,-130063606,0)|0;h=d1c(a|0,J|0,e|0,0)|0;e=l;f[e>>2]=h;f[e+4>>2]=J;u=c;return f[d+(~~(+(g|0)*(+(h&2147483647|0)*4.656612873077393e-10))<<2)>>2]|0}function JBc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+-1|0;c=a+32|0;j=a+28|0;a=i;k=0;a:while(1){b:do if((k|0)>(a|0))l=k;else{m=f[c>>2]|0;o=f[j>>2]|0;p=k;while(1){q=m+((Y(o,f[b+(p<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]<e)){l=p;break b}q=p+1|0;if((p|0)<(a|0))p=q;else{l=q;break}}}while(0);if((l|0)>(a|0))break;p=f[c>>2]|0;o=f[j>>2]|0;m=a;while(1){r=b+(m<<2)|0;s=f[r>>2]|0;q=p+((Y(o,s)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]>=e))break;if((l|0)<(m|0))m=m+-1|0;else break a}o=b+(l<<2)|0;p=f[o>>2]|0;f[o>>2]=s;f[r>>2]=p;a=m+-1|0;k=l+1|0}f[g>>2]=l;g=i;i=l;c:while(1){d:do if((i|0)>(g|0))t=i;else{l=f[c>>2]|0;k=f[j>>2]|0;a=i;while(1){r=l+((Y(k,f[b+(a<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[r>>2]<=e)){t=a;break d}r=a+1|0;if((a|0)<(g|0))a=r;else{t=r;break}}}while(0);if((t|0)>(g|0)){u=21;break}m=f[c>>2]|0;a=f[j>>2]|0;k=g;while(1){v=b+(k<<2)|0;w=f[v>>2]|0;l=m+((Y(a,w)|0)<<2)+(d<<2)|0;if(!(+n[l>>2]>e))break;if((t|0)<(k|0))k=k+-1|0;else{u=21;break c}}a=b+(t<<2)|0;m=f[a>>2]|0;f[a>>2]=w;f[v>>2]=m;g=k+-1|0;i=t+1|0}if((u|0)==21){f[h>>2]=t;return}}function KBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/28|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>153391689){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}h=f[g>>2]|0;i=$Xc(b*28|0)|0;j=i+(((h-d|0)/28|0)*28|0)|0;d=j;k=i+(b*28|0)|0;b=h;if((b|0)==(e|0)){l=d;m=h;n=e}else{h=b;b=d;i=j;do{j=i+-28|0;o=h;h=h+-28|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];j=i+-12|0;p=o+-12|0;f[j>>2]=f[p>>2];q=f[o+-8>>2]|0;f[i+-8>>2]=q;r=o+-4|0;s=f[r>>2]|0;f[i+-4>>2]=s;t=i+-8|0;if(!s)f[j>>2]=t;else{f[q+8>>2]=t;t=o+-8|0;f[p>>2]=t;f[t>>2]=0;f[r>>2]=0}i=b+-28|0;b=i}while((h|0)!=(e|0));l=b;m=f[a>>2]|0;n=f[g>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;k=m;if((n|0)!=(k|0)){c=n;do{Ptc(c+-12|0,f[c+-8>>2]|0);c=c+-28|0}while((c|0)!=(k|0))}if(!m)return;cYc(m);return}function LBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0;d=u;u=u+176|0;e=d+24|0;g=d;h=d+152|0;i=d+156|0;j=d+32|0;k=d+48|0;l=d+168|0;m=c+16|0;o=i+11|0;b[o>>0]=10;q=i;r=514827;s=q+10|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[i+10>>0]=0;t=Cwc(m,i)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=j+11|0;b[v>>0]=9;q=j;r=512667;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[j+9>>0]=0;r=Cwc(m,j)|0;f[e>>2]=t;f[e+4>>2]=r;Hwc(514838,e)|0;if((b[v>>0]|0)<0)cYc(f[j>>2]|0);if((b[o>>0]|0)<0)cYc(f[i>>2]|0);i=a+32|0;b[e>>0]=b[l>>0]|0;Uzc(k,i,m,e);e=xN()|0;m=J;MBc(k);l=xN()|0;o=J;w=(+(l>>>0)+4294967296.0*+(o|0)-(+(e>>>0)+4294967296.0*+(m|0)))/+yN()+0.0;x=+YAc(k,i,a+48|0,a+64|0,+n[a+100>>2],h,a+116|0,1,0);y=+((Y(f[i>>2]<<2,f[a+36>>2]|0)|0)>>>0);n[c+8>>2]=(y+ +((f[k+96>>2]|0)+(f[k+92>>2]|0)+(f[k+100>>2]|0)|0))/y;n[c>>2]=x;n[c+4>>2]=w;y=+n[a+104>>2];p[g>>3]=w;p[g+8>>3]=x;p[g+16>>3]=y;Hwc(514896,g)|0;NBc(k);u=d;return}function MBc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+12|0;if((f[b>>2]|0)<2){c=af(60)|0;Jtc(c,513040);ig(c|0,22128,1)}c=a+56|0;d=f[c>>2]|0;e=bYc(d>>>0>1073741823?-1:d<<2)|0;g=a+68|0;f[g>>2]=e;if(d|0){d=f[c>>2]|0;h=0;do{f[e+(h<<2)>>2]=h;h=h+1|0}while(h>>>0<d>>>0)}d=a+76|0;h=f[d>>2]|0;do if((h|0)<32){e=a+96|0;f[e>>2]=(f[e>>2]|0)+h;e=jIc(8192)|0;if(!e){eKc(513012,27,1,f[46249]|0)|0;i=0;break}else{j=a+80|0;f[e>>2]=f[j>>2];f[j>>2]=e;f[d>>2]=8188;j=e+4|0;e=a+84|0;f[e>>2]=j;k=e;l=j;m=8156;n=10;break}}else{j=a+84|0;k=j;l=f[j>>2]|0;m=h+-32|0;n=10}while(0);if((n|0)==10){f[k>>2]=l+32;f[d>>2]=m;m=a+92|0;f[m>>2]=(f[m>>2]|0)+32;i=l}l=a+64|0;f[l>>2]=i;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;fCc(a,f[l>>2]|0,f[g>>2]|0,f[c>>2]|0);gCc(a,f[l>>2]|0,f[g>>2]|0,f[c>>2]|0,f[b>>2]|0,0);return}function NBc(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=174572;b=f[a+64>>2]|0;if(b|0)OBc(a,b);b=f[a+68>>2]|0;if(b|0)dYc(b);b=a+80|0;c=f[b>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;kIc(c);f[b>>2]=d}while((d|0)!=0)}Ptc(a+44|0,f[a+48>>2]|0);return}function OBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;if(c|0)dYc(c);c=b+20|0;b=f[c>>2]|0;if(!b)return;d=a+12|0;if((f[d>>2]|0)<=0)return;OBc(a,f[b>>2]|0);if((f[d>>2]|0)>1)e=1;else return;do{OBc(a,f[(f[c>>2]|0)+(e<<2)>>2]|0);e=e+1|0}while((e|0)<(f[d>>2]|0));return}function PBc(a){a=a|0;NBc(a);cYc(a);return}function QBc(a,b){a=a|0;b=b|0;eKc(a+12|0,4,1,b)|0;eKc(a+16|0,4,1,b)|0;eKc(a+100|0,4,1,b)|0;eKc(a+24|0,4,1,b)|0;eKc(f[a+68>>2]|0,4,f[a+56>>2]|0,b)|0;eCc(a,b,f[a+64>>2]|0);return}function RBc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+32|0;e=d+24|0;g=d;h=d+12|0;i=a+12|0;if((NLc(i,4,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+16|0;if((NLc(j,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if((NLc(a+100|0,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=a+24|0;if((NLc(k,4,1,c)|0)!=1){l=af(60)|0;Jtc(l,511860);ig(l|0,22128,1)}l=a+68|0;m=f[l>>2]|0;if(m|0)dYc(m);m=f[a+56>>2]|0;n=bYc(m>>>0>1073741823?-1:m<<2)|0;f[l>>2]=n;if((NLc(n,4,m,c)|0)!=(m|0)){m=af(60)|0;Jtc(m,511860);ig(m|0,22128,1)}m=a+64|0;n=f[m>>2]|0;if(n|0)OBc(a,n);dCc(a,c,m);m=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=m;m=a+44|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=h+11|0;b[c>>0]=9;n=h;l=512094;o=n+9|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[h+9>>0]=0;p=Ntc(m,e,h)|0;q=f[p>>2]|0;if(!q){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[s+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[p>>2]=r;s=f[f[m>>2]>>2]|0;if(!s)t=r;else{f[m>>2]=s;t=f[p>>2]|0}UQ(f[a+48>>2]|0,t);t=a+52|0;f[t>>2]=(f[t>>2]|0)+1;v=r}else v=q;q=v+28|0;r=f[q>>2]|0;t=v+32|0;mi[f[f[r>>2]>>2]&2047](r,t);f[q>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,t);if((b[c>>0]|0)<0)cYc(f[h>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=9;n=g;l=512667;o=n+9|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[g+9>>0]=0;c=Ntc(m,e,g)|0;t=f[c>>2]|0;if(!t){q=$Xc(36)|0;r=q+16|0;f[r>>2]=f[g>>2];f[r+4>>2]=f[g+4>>2];f[r+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;r=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=r;f[c>>2]=q;r=f[f[m>>2]>>2]|0;if(!r)w=q;else{f[m>>2]=r;w=f[c>>2]|0}UQ(f[a+48>>2]|0,w);w=a+52|0;f[w>>2]=(f[w>>2]|0)+1;x=q}else x=t;t=x+28|0;q=f[t>>2]|0;w=x+32|0;mi[f[f[q>>2]>>2]&2047](q,w);f[t>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,i,w);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=g+11|0;b[h>>0]=10;n=g;l=514827;o=n+10|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[g+10>>0]=0;w=Ntc(m,e,g)|0;i=f[w>>2]|0;if(!i){t=$Xc(36)|0;q=t+16|0;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];f[q+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[w>>2]=t;q=f[f[m>>2]>>2]|0;if(!q)y=t;else{f[m>>2]=q;y=f[w>>2]|0}UQ(f[a+48>>2]|0,y);y=a+52|0;f[y>>2]=(f[y>>2]|0)+1;z=t}else z=i;i=z+28|0;t=f[i>>2]|0;y=z+32|0;mi[f[f[t>>2]>>2]&2047](t,y);f[i>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,j,y);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;n=h;l=512677;o=n+12|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[h+12>>0]=0;h=Ntc(m,e,g)|0;l=f[h>>2]|0;if(!l){n=$Xc(36)|0;o=n+16|0;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[n+28>>2]=172888;f[n+32>>2]=0;o=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=o;f[h>>2]=n;o=f[f[m>>2]>>2]|0;if(!o)A=n;else{f[m>>2]=o;A=f[h>>2]|0}UQ(f[a+48>>2]|0,A);A=a+52|0;f[A>>2]=(f[A>>2]|0)+1;B=n}else B=l;l=B+28|0;n=f[l>>2]|0;A=B+32|0;mi[f[f[n>>2]>>2]&2047](n,A);f[l>>2]=173316;Ti[f[(f[43329]|0)+4>>2]&511](173316,a+20|0,A);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=g+11|0;b[A>>0]=8;l=g;f[l>>2]=1767858787;f[l+4>>2]=2019910766;b[g+8>>0]=0;l=Ntc(m,e,g)|0;n=f[l>>2]|0;if(!n){B=$Xc(36)|0;h=B+16|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[B+28>>2]=172888;f[B+32>>2]=0;h=f[e>>2]|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=h;f[l>>2]=B;h=f[f[m>>2]>>2]|0;if(!h)C=B;else{f[m>>2]=h;C=f[l>>2]|0}UQ(f[a+48>>2]|0,C);C=a+52|0;f[C>>2]=(f[C>>2]|0)+1;D=B}else D=n;n=D+28|0;B=f[n>>2]|0;C=D+32|0;mi[f[f[B>>2]>>2]&2047](B,C);f[n>>2]=173484;Ti[f[(f[43371]|0)+4>>2]&511](173484,k,C);if((b[A>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function SBc(a){a=a|0;return f[a+56>>2]|0}function TBc(a){a=a|0;return f[a+60>>2]|0}function UBc(a){a=a|0;return (f[a+96>>2]|0)+(f[a+92>>2]|0)+(f[a+100>>2]|0)|0}function VBc(a){a=a|0;return 2}function WBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+44>>2]|0;i=b+48|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function XBc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g+8|0;i=g+20|0;j=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=h+11|0;b[k>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;l=auc(e,h)|0;do if((l|0)!=(e+4|0)){m=l+28|0;n=f[m>>2]|0;o=(_i[f[(f[n>>2]|0)+28>>2]&2047](n)|0)+4|0;if((f[o>>2]|0)==(f[6379]|0)){o=f[m>>2]|0;m=Mi[f[(f[o>>2]|0)+20>>2]&1023](o,l+32|0)|0;p=f[m>>2]|0;break}else ig(af(1)|0,22144,0)}else p=32;while(0);if((b[k>>0]|0)<0)cYc(f[h>>2]|0);if((p|0)==-1){YBc(a,f[a+64>>2]|0,c,d);u=g;return}h=$Xc(20)|0;k=f[a+56>>2]|0;f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;f[h+12>>2]=k;ZBc(h,k);f[h+16>>2]=0;f[i>>2]=0;_Bc(a,f[a+64>>2]|0,c,d,i,p,h);a:do if($Bc(h,j)|0)do{if((f[i>>2]|0)>=(p|0)?_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0:0)break a;_Bc(a,f[j>>2]|0,c,d,i,p,h)}while($Bc(h,j)|0);while(0);j=f[h>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-8-j|0)>>>3)<<3);cYc(j)}cYc(h);u=g;return}function YBc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0.0,B=0.0;e=f[b>>2]|0;g=a+60|0;h=d+(f[g>>2]<<2)|0;i=h+-12|0;j=((i>>>0<d>>>0?d:i)+12+(3-d)|0)>>>4<<2;k=e+(j<<2)|0;if(i>>>0>d>>>0){l=d;m=e;o=0.0;while(1){p=+n[l>>2]-+n[m>>2];q=+n[l+4>>2]-+n[m+4>>2];r=+n[l+8>>2]-+n[m+8>>2];s=+n[l+12>>2]-+n[m+12>>2];t=o+(p*p+q*q+r*r+s*s);l=l+16|0;if(l>>>0>=i>>>0){u=t;break}else{m=m+16|0;o=t}}}else u=0.0;m=d+(j<<2)|0;if(m>>>0<h>>>0){j=k;o=u;k=m;while(1){t=+n[k>>2]-+n[j>>2];k=k+4|0;s=o+t*t;if(k>>>0>=h>>>0){v=s;break}else{j=j+4|0;o=s}}}else v=u;u=+n[b+4>>2];o=+Vg[f[(f[c>>2]|0)+16>>2]&31](c);s=v-u-o;if(!(s>0.0?!(s*s-u*4.0*o>0.0):1))return;j=b+20|0;if(f[j>>2]|0){h=a+12|0;k=f[h>>2]|0;m=bYc(k>>>0>1073741823?-1:k<<2)|0;cCc(a,b,d,m);if((f[h>>2]|0)>0){k=0;do{YBc(a,f[(f[j>>2]|0)+(f[m+(k<<2)>>2]<<2)>>2]|0,c,d);k=k+1|0}while((k|0)<(f[h>>2]|0))}dYc(m);return}m=b+16|0;if((f[m>>2]|0)<=0)return;h=b+24|0;b=a+40|0;k=a+36|0;a=0;do{j=f[(f[h>>2]|0)+(a<<2)>>2]|0;i=(f[b>>2]|0)+((Y(f[k>>2]|0,j)|0)<<2)|0;l=i+(f[g>>2]<<2)|0;e=l+-12|0;w=((e>>>0<i>>>0?i:e)+12+(3-i)|0)>>>4<<2;x=d+(w<<2)|0;if(i>>>0<e>>>0){y=i;z=d;o=0.0;while(1){u=+n[y>>2]-+n[z>>2];s=+n[y+4>>2]-+n[z+4>>2];v=+n[y+8>>2]-+n[z+8>>2];t=+n[y+12>>2]-+n[z+12>>2];r=o+(u*u+s*s+v*v+t*t);y=y+16|0;if(y>>>0>=e>>>0){A=r;break}else{z=z+16|0;o=r}}}else A=0.0;z=i+(w<<2)|0;if(z>>>0<l>>>0){e=x;o=A;y=z;while(1){r=+n[y>>2]-+n[e>>2];y=y+4|0;t=o+r*r;if(y>>>0>=l>>>0){B=t;break}else{e=e+4|0;o=t}}}else B=A;Hg[f[(f[c>>2]|0)+12>>2]&15](c,B,j);a=a+1|0}while((a|0)<(f[m>>2]|0));return}function ZBc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function _Bc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0.0;i=a+60|0;j=3-d|0;k=a+12|0;l=b;while(1){b=f[l>>2]|0;m=d+(f[i>>2]<<2)|0;o=m+-12|0;p=((o>>>0<d>>>0?d:o)+12+j|0)>>>4<<2;q=b+(p<<2)|0;if(o>>>0>d>>>0){r=d;s=b;t=0.0;while(1){u=+n[r>>2]-+n[s>>2];v=+n[r+4>>2]-+n[s+4>>2];w=+n[r+8>>2]-+n[s+8>>2];x=+n[r+12>>2]-+n[s+12>>2];y=t+(u*u+v*v+w*w+x*x);r=r+16|0;if(r>>>0>=o>>>0){z=y;break}else{s=s+16|0;t=y}}}else z=0.0;s=d+(p<<2)|0;if(s>>>0<m>>>0){o=q;t=z;r=s;while(1){y=+n[r>>2]-+n[o>>2];r=r+4|0;x=t+y*y;if(r>>>0>=m>>>0){A=x;break}else{o=o+4|0;t=x}}}else A=z;t=+n[l+4>>2];x=+Vg[f[(f[c>>2]|0)+16>>2]&31](c);y=A-t-x;if(!(y>0.0?!(y*y-t*4.0*x>0.0):1)){B=19;break}o=l+20|0;if(!(f[o>>2]|0))break;m=f[k>>2]|0;r=bYc(m>>>0>1073741823?-1:m<<2)|0;m=aCc(a,l,d,r,h)|0;dYc(r);l=f[(f[o>>2]|0)+(m<<2)>>2]|0}if((B|0)==19)return;B=f[e>>2]|0;do if((B|0)>=(g|0))if(_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0)return;else{C=f[e>>2]|0;break}else C=B;while(0);B=l+16|0;f[e>>2]=C+(f[B>>2]|0);if((f[B>>2]|0)<=0)return;C=l+24|0;l=a+40|0;e=a+36|0;a=0;do{g=f[(f[C>>2]|0)+(a<<2)>>2]|0;h=(f[l>>2]|0)+((Y(f[e>>2]|0,g)|0)<<2)|0;k=h+(f[i>>2]<<2)|0;j=k+-12|0;m=((j>>>0<h>>>0?h:j)+12+(3-h)|0)>>>4<<2;o=d+(m<<2)|0;if(h>>>0<j>>>0){r=h;q=d;A=0.0;while(1){z=+n[r>>2]-+n[q>>2];x=+n[r+4>>2]-+n[q+4>>2];t=+n[r+8>>2]-+n[q+8>>2];y=+n[r+12>>2]-+n[q+12>>2];w=A+(z*z+x*x+t*t+y*y);r=r+16|0;if(r>>>0>=j>>>0){D=w;break}else{q=q+16|0;A=w}}}else D=0.0;q=h+(m<<2)|0;if(q>>>0<k>>>0){j=o;A=D;r=q;while(1){w=+n[r>>2]-+n[j>>2];r=r+4|0;y=A+w*w;if(r>>>0>=k>>>0){E=y;break}else{j=j+4|0;A=y}}}else E=D;Hg[f[(f[c>>2]|0)+12>>2]&15](c,E,g);a=a+1|0}while((a|0)<(f[B>>2]|0));return}function $Bc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0;c=a+16|0;if(!(f[c>>2]|0)){d=0;return d|0}e=f[a>>2]|0;g=f[e+4>>2]|0;h=b;f[h>>2]=f[e>>2];f[h+4>>2]=g;g=f[a>>2]|0;h=a+4|0;a=f[h>>2]|0;e=a-g|0;b=e>>3;if(((e|0)>8?(e=a+-8|0,a=g,i=f[a>>2]|0,j=f[a+4>>2]|0,a=e,k=f[a+4>>2]|0,l=g,f[l>>2]=f[a>>2],f[l+4>>2]=k,k=e,f[k>>2]=i,f[k+4>>2]=j,j=b+-1|0,(b|0)!=2):0)?(k=b+-3|0,b=(k|0)/2|0,(k|0)>=-1):0){k=g+8|0;if((j|0)>2?+n[g+20>>2]<+n[g+12>>2]:0){m=2;o=g+16|0}else{m=1;o=k}p=+n[g+4>>2];if(!(p<+n[o+4>>2])){k=f[g>>2]|0;i=m;m=o;o=g;while(1){e=o;o=m;l=o;a=f[l+4>>2]|0;q=e;f[q>>2]=f[l>>2];f[q+4>>2]=a;if((b|0)<(i|0))break;a=i<<1|1;q=g+(a<<3)|0;l=q;e=a+1|0;if((e|0)<(j|0)?(r=q+8|0,+n[r+4>>2]<+n[g+(a<<3)+4>>2]):0){s=e;t=r}else{s=a;t=l}if(p<+n[t+4>>2])break;else{i=s;m=t}}f[m>>2]=k;n[m+4>>2]=p}}f[h>>2]=(f[h>>2]|0)+-8;f[c>>2]=(f[c>>2]|0)+-1;d=1;return d|0}function aCc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0;g=u;u=u+16|0;h=g;i=b+20|0;b=f[i>>2]|0;j=f[f[b>>2]>>2]|0;k=c+(f[a+60>>2]<<2)|0;l=k+-12|0;m=((l>>>0<c>>>0?c:l)+12+(3-c)|0)>>>4<<2;o=j+(m<<2)|0;p=l>>>0>c>>>0;if(p){q=c;r=j;s=0.0;while(1){t=+n[q>>2]-+n[r>>2];v=+n[q+4>>2]-+n[r+4>>2];w=+n[q+8>>2]-+n[r+8>>2];x=+n[q+12>>2]-+n[r+12>>2];y=s+(t*t+v*v+w*w+x*x);q=q+16|0;if(q>>>0>=l>>>0){z=y;break}else{r=r+16|0;s=y}}}else z=0.0;r=c+(m<<2)|0;q=r>>>0<k>>>0;if(q){j=o;s=z;o=r;while(1){y=+n[o>>2]-+n[j>>2];o=o+4|0;x=s+y*y;if(o>>>0>=k>>>0){A=x;break}else{j=j+4|0;s=x}}}else A=z;n[d>>2]=A;j=a+12|0;o=f[j>>2]|0;a:do if((o|0)>1){if(p){B=1;C=0}else{if(q){D=1;E=0}else{F=1;G=0;while(1){n[d+(F<<2)>>2]=0.0;H=+n[d+(G<<2)>>2]>0.0?F:G;F=F+1|0;if((F|0)>=(o|0)){I=H;break a}else G=H}}while(1){G=(f[f[b+(D<<2)>>2]>>2]|0)+(m<<2)|0;A=0.0;F=r;while(1){z=+n[F>>2]-+n[G>>2];F=F+4|0;A=A+z*z;if(F>>>0>=k>>>0)break;else G=G+4|0}n[d+(D<<2)>>2]=A;G=A<+n[d+(E<<2)>>2]?D:E;D=D+1|0;if((D|0)>=(o|0)){I=G;break a}else E=G}}while(1){G=f[f[b+(B<<2)>>2]>>2]|0;F=c;H=G;z=0.0;while(1){s=+n[F>>2]-+n[H>>2];x=+n[F+4>>2]-+n[H+4>>2];y=+n[F+8>>2]-+n[H+8>>2];w=+n[F+12>>2]-+n[H+12>>2];z=z+(s*s+x*x+y*y+w*w);F=F+16|0;if(F>>>0>=l>>>0)break;else H=H+16|0}if(q){H=G+(m<<2)|0;A=z;F=r;while(1){w=+n[F>>2]-+n[H>>2];F=F+4|0;y=A+w*w;if(F>>>0>=k>>>0){J=y;break}else{H=H+4|0;A=y}}}else J=z;n[d+(B<<2)>>2]=J;H=J<+n[d+(C<<2)>>2]?B:C;B=B+1|0;if((B|0)>=(o|0)){I=H;break}else C=H}}else I=0;while(0);if((o|0)<=0){u=g;return I|0}C=a+24|0;a=h+4|0;B=e+16|0;k=e+12|0;r=e+4|0;m=e+8|0;q=0;l=o;while(1){if((q|0)==(I|0))K=l;else{o=f[(f[i>>2]|0)+(q<<2)>>2]|0;c=d+(q<<2)|0;J=+n[c>>2]-+n[C>>2]*+n[o+12>>2];n[c>>2]=J;f[h>>2]=o;n[a>>2]=J;if((f[B>>2]|0)==(f[k>>2]|0))L=l;else{o=f[r>>2]|0;if((o|0)==(f[m>>2]|0)){bCc(e,h);M=f[r>>2]|0}else{c=h;b=f[c+4>>2]|0;E=o;f[E>>2]=f[c>>2];f[E+4>>2]=b;b=(f[r>>2]|0)+8|0;f[r>>2]=b;M=b}b=f[e>>2]|0;E=M-b|0;if((E|0)>8?(c=((E>>>3)+-2|0)/2|0,E=M+-8|0,J=+n[M+-4>>2],J<+n[b+(c<<3)+4>>2]):0){o=f[E>>2]|0;D=E;E=c;while(1){c=D;D=b+(E<<3)|0;p=D;H=f[p+4>>2]|0;F=c;f[F>>2]=f[p>>2];f[F+4>>2]=H;if(!E){N=0;break}H=(E+-1|0)/2|0;if(!(J<+n[b+(H<<3)+4>>2])){N=E;break}else E=H}f[D>>2]=o;n[b+(N<<3)+4>>2]=J}f[B>>2]=(f[B>>2]|0)+1;L=f[j>>2]|0}K=L}q=q+1|0;if((q|0)>=(K|0))break;else l=K}u=g;return I|0}function bCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function cCc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;e=a+12|0;g=f[e>>2]|0;h=bYc(g>>>0>1073741823?-1:g<<2)|0;if((g|0)<=0){dYc(h);return}g=f[b+20>>2]|0;b=a+60|0;a=3-c|0;i=0;do{j=f[f[g+(i<<2)>>2]>>2]|0;k=c+(f[b>>2]<<2)|0;l=k+-12|0;m=((l>>>0<c>>>0?c:l)+12+a|0)>>>4<<2;o=j+(m<<2)|0;if(l>>>0>c>>>0){p=c;q=j;r=0.0;while(1){s=+n[p>>2]-+n[q>>2];t=+n[p+4>>2]-+n[q+4>>2];u=+n[p+8>>2]-+n[q+8>>2];v=+n[p+12>>2]-+n[q+12>>2];w=r+(s*s+t*t+u*u+v*v);p=p+16|0;if(p>>>0>=l>>>0){x=w;break}else{q=q+16|0;r=w}}}else x=0.0;q=c+(m<<2)|0;if(q>>>0<k>>>0){l=o;r=x;p=q;while(1){w=+n[p>>2]-+n[l>>2];p=p+4|0;v=r+w*w;if(p>>>0>=k>>>0){y=v;break}else{l=l+4|0;r=v}}}else y=x;l=0;while(1){z=h+(l<<2)|0;A=(l|0)<(i|0);if(A&+n[z>>2]<y)l=l+1|0;else break}if(A){k=i;do{p=k;k=k+-1|0;f[h+(p<<2)>>2]=f[h+(k<<2)>>2];f[d+(p<<2)>>2]=f[d+(k<<2)>>2]}while((k|0)>(l|0))}n[z>>2]=y;f[d+(l<<2)>>2]=i;i=i+1|0}while((i|0)<(f[e>>2]|0));dYc(h);return}function dCc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=a+76|0;h=f[g>>2]|0;do if((h|0)<32){i=a+96|0;f[i>>2]=(f[i>>2]|0)+h;i=jIc(8192)|0;if(!i){eKc(513012,27,1,f[46249]|0)|0;j=0;break}else{k=a+80|0;f[i>>2]=f[k>>2];f[k>>2]=i;f[g>>2]=8188;k=i+4|0;i=a+84|0;f[i>>2]=k;l=i;m=k;n=8156;o=6;break}}else{k=a+84|0;l=k;m=f[k>>2]|0;n=h+-32|0;o=6}while(0);if((o|0)==6){f[l>>2]=m+32;f[g>>2]=n;n=a+92|0;f[n>>2]=(f[n>>2]|0)+32;j=m}f[c>>2]=j;if((NLc(j,32,1,b)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=f[a+60>>2]|0;m=bYc(j>>>0>1073741823?-1:j<<2)|0;f[f[c>>2]>>2]=m;if((NLc(f[f[c>>2]>>2]|0,4,j,b)|0)!=(j|0)){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}if(!(f[(f[c>>2]|0)+20>>2]|0)){if((NLc(e,4,1,b)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}f[(f[c>>2]|0)+24>>2]=(f[a+68>>2]|0)+(f[e>>2]<<2);u=d;return}e=a+12|0;j=(f[e>>2]<<2)+15&-16;m=f[g>>2]|0;do if((j|0)>(m|0)){n=a+96|0;f[n>>2]=(f[n>>2]|0)+m;n=(j|4)+15|0;l=n>>>0>8192?n:8192;n=jIc(l)|0;if(!n){eKc(513012,27,1,f[46249]|0)|0;p=0;break}else{h=a+80|0;f[n>>2]=f[h>>2];f[h>>2]=n;h=l+-4|0;f[g>>2]=h;l=n+4|0;n=a+84|0;f[n>>2]=l;q=n;r=l;s=h;o=20;break}}else{h=a+84|0;q=h;r=f[h>>2]|0;s=m;o=20}while(0);if((o|0)==20){f[q>>2]=r+j;f[g>>2]=s-j;s=a+92|0;f[s>>2]=(f[s>>2]|0)+j;p=r}f[(f[c>>2]|0)+20>>2]=p;if((f[e>>2]|0)>0)t=0;else{u=d;return}do{dCc(a,b,(f[(f[c>>2]|0)+20>>2]|0)+(t<<2)|0);t=t+1|0}while((t|0)<(f[e>>2]|0));u=d;return}function eCc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;eKc(c,32,1,b)|0;eKc(f[c>>2]|0,4,f[a+60>>2]|0,b)|0;g=c+20|0;h=f[g>>2]|0;if(!h){f[e>>2]=(f[c+24>>2]|0)-(f[a+68>>2]|0)>>2;eKc(e,4,1,b)|0;u=d;return}e=a+12|0;if((f[e>>2]|0)<=0){u=d;return}eCc(a,b,f[h>>2]|0);if((f[e>>2]|0)>1)i=1;else{u=d;return}do{eCc(a,b,f[(f[g>>2]|0)+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(f[e>>2]|0));u=d;return}function fCc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0.0;e=f[a+60>>2]|0;g=bYc(e>>>0>1073741823?-1:e<<2)|0;h=e<<2;i=a+100|0;f[i>>2]=(f[i>>2]|0)+h;g1c(g|0,0,h|0)|0;h=f[a+56>>2]|0;a:do if(!h){j=0.0;k=0}else{i=f[a+40>>2]|0;l=f[a+36>>2]|0;if(!e){m=0;o=0.0;while(1){p=i+((Y(l,f[c+(m<<2)>>2]|0)|0)<<2)|0;q=p+((p+12+(3-p)|0)>>>4<<2<<2)|0;if(q>>>0<p>>>0){r=0.0;s=q;while(1){t=+n[s>>2];s=s+4|0;u=r+t*t;if(s>>>0>=p>>>0){v=u;break}else r=u}}else v=0.0;r=o+v;m=m+1|0;if(m>>>0>=h>>>0){j=r;k=h;break a}else o=r}}else{w=0;x=0.0}while(1){m=i+((Y(l,f[c+(w<<2)>>2]|0)|0)<<2)|0;p=0;do{s=g+(p<<2)|0;n[s>>2]=+n[m+(p<<2)>>2]+ +n[s>>2];p=p+1|0}while(p>>>0<e>>>0);p=m+(e<<2)|0;s=p+-12|0;q=((s>>>0<m>>>0?m:s)+12+(3-m)|0)>>>4<<2;if(m>>>0<s>>>0){y=m;o=0.0;while(1){r=+n[y>>2];u=+n[y+4>>2];t=+n[y+8>>2];z=+n[y+12>>2];A=o+(r*r+u*u+t*t+z*z);y=y+16|0;if(y>>>0>=s>>>0){B=A;break}else o=A}}else B=0.0;s=m+(q<<2)|0;if(s>>>0<p>>>0){o=B;y=s;while(1){A=+n[y>>2];y=y+4|0;z=o+A*A;if(y>>>0>=p>>>0){C=z;break}else o=z}}else C=B;o=x+C;w=w+1|0;if(w>>>0>=h>>>0){j=o;k=h;break}else x=o}}while(0);x=+(k>>>0);if(!e)D=0;else{k=0;do{h=g+(k<<2)|0;n[h>>2]=+n[h>>2]/x;k=k+1|0}while(k>>>0<e>>>0);D=e}C=j/x;k=g+(D<<2)|0;D=k+-12|0;h=3-g|0;w=((D>>>0<g>>>0?g:D)+12+h|0)>>>4<<2;if(g>>>0<D>>>0){l=g;x=0.0;while(1){j=+n[l>>2];B=+n[l+4>>2];v=+n[l+8>>2];o=+n[l+12>>2];z=x+(j*j+B*B+v*v+o*o);l=l+16|0;if(l>>>0>=D>>>0){E=z;break}else x=z}}else E=0.0;D=g+(w<<2)|0;if(D>>>0<k>>>0){x=E;w=D;while(1){z=+n[w>>2];w=w+4|0;o=x+z*z;if(w>>>0>=k>>>0){F=o;break}else x=o}}else F=E;E=C-F;if((d|0)<=0){G=0.0;H=b+12|0;n[H>>2]=E;I=b+4|0;n[I>>2]=G;f[b>>2]=g;return}k=f[a+40>>2]|0;w=f[a+36>>2]|0;a=g+(e<<2)|0;e=a+-12|0;D=((e>>>0<g>>>0?g:e)+12+h|0)>>>4<<2;h=g+(D<<2)|0;l=h>>>0<a>>>0;if(g>>>0<e>>>0){J=0.0;K=0}else{if(l){L=0.0;M=0}else{G=0.0;H=b+12|0;n[H>>2]=E;I=b+4|0;n[I>>2]=G;f[b>>2]=g;return}while(1){i=k+((Y(w,f[c+(M<<2)>>2]|0)|0)<<2)+(D<<2)|0;F=0.0;p=h;while(1){C=+n[p>>2]-+n[i>>2];p=p+4|0;F=F+C*C;if(p>>>0>=a>>>0)break;else i=i+4|0}C=F>L?F:L;M=M+1|0;if((M|0)==(d|0)){G=C;break}else L=C}H=b+12|0;n[H>>2]=E;I=b+4|0;n[I>>2]=G;f[b>>2]=g;return}while(1){M=k+((Y(w,f[c+(K<<2)>>2]|0)|0)<<2)|0;i=g;p=M;L=0.0;while(1){C=+n[i>>2]-+n[p>>2];x=+n[i+4>>2]-+n[p+4>>2];o=+n[i+8>>2]-+n[p+8>>2];z=+n[i+12>>2]-+n[p+12>>2];L=L+(C*C+x*x+o*o+z*z);i=i+16|0;if(i>>>0>=e>>>0)break;else p=p+16|0}if(l){p=M+(D<<2)|0;F=L;i=h;while(1){z=+n[i>>2]-+n[p>>2];i=i+4|0;o=F+z*z;if(i>>>0>=a>>>0){N=o;break}else{p=p+4|0;F=o}}}else N=L;F=N>J?N:J;K=K+1|0;if((K|0)==(d|0)){G=F;break}else J=F}H=b+12|0;n[H>>2]=E;I=b+4|0;n[I>>2]=G;f[b>>2]=g;return}function gCc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0;i=u;u=u+4400|0;j=i;k=i+3320|0;l=i+3312|0;m=i+3296|0;o=i+3280|0;q=i+2216|0;r=i+1152|0;s=i+4384|0;t=i+1104|0;v=i+1096|0;f[c+16>>2]=e;f[c+28>>2]=h;if((e|0)<(g|0)){f[c+24>>2]=d;mMc(d,d+(e<<2)|0,j);f[c+20>>2]=0;u=i;return}w=k+8|0;f[k>>2]=w;x=k+4|0;y=g>>>0>264;f[x>>2]=g;if(y){z=bYc(g>>>0>1073741823?-1:g<<2)|0;f[k>>2]=z;A=z}else A=w;z=f[a+4>>2]|0;B=f[a+8>>2]|0;C=a+(B>>1)|0;if(!(B&1))D=z;else D=f[(f[C>>2]|0)+z>>2]|0;Fh[D&255](C,g,d,e,A,l);C=f[l>>2]|0;if((C|0)>=(g|0)){l=a+60|0;D=f[l>>2]|0;z=Y(D,g)|0;B=j+8|0;f[j>>2]=B;E=j+4|0;f[E>>2]=z;if(z>>>0>136){F=bYc(z>>>0>536870911?-1:z<<3)|0;f[j>>2]=F;G=F}else G=B;f[m>>2]=g;f[m+4>>2]=D;F=m+8|0;z=m+12|0;f[z>>2]=G;f[F>>2]=D;H=G;if((C|0)>0?(G=f[a+40>>2]|0,I=f[a+36>>2]|0,D|0):0){J=0;do{K=G+((Y(I,f[A+(J<<2)>>2]|0)|0)<<2)|0;L=H+((Y(D,J)|0)<<3)|0;N=0;do{p[L+(N<<3)>>3]=+n[K+(N<<2)>>2];N=N+1|0}while(N>>>0<D>>>0);J=J+1|0}while((J|0)<(C|0))}f[o>>2]=0;C=o+4|0;f[C>>2]=0;f[o+8>>2]=0;do if(g)if(g>>>0>1073741823)kWc(o);else{J=g<<2;D=$Xc(J)|0;f[o>>2]=D;H=D+(g<<2)|0;f[o+8>>2]=H;g1c(D|0,0,J|0)|0;f[C>>2]=H;O=D;break}else O=0;while(0);D=q+8|0;f[q>>2]=D;H=q+4|0;f[H>>2]=g;if(!y)if(!g){P=D;Q=0}else{R=D;S=24}else{y=bYc(g>>>0>1073741823?-1:g<<2)|0;f[q>>2]=y;R=y;S=24}if((S|0)==24){y=0;do{n[O+(y<<2)>>2]=0.0;f[R+(y<<2)>>2]=0;y=y+1|0}while((y|0)!=(g|0));P=R;Q=1}R=r+8|0;f[r>>2]=R;y=r+4|0;f[y>>2]=e;if(e>>>0>264){J=bYc(e>>>0>1073741823?-1:e<<2)|0;f[r>>2]=J;T=J}else T=R;J=(e|0)>0;A=a+40|0;if(J){I=f[A>>2]|0;G=a+36|0;N=f[z>>2]|0;K=(g|0)>1;L=0;do{U=d+(L<<2)|0;V=I+((Y(f[G>>2]|0,f[U>>2]|0)|0)<<2)|0;W=V+(f[l>>2]<<2)|0;X=W+-12|0;Z=((X>>>0<V>>>0?V:X)+12+(3-V)|0)>>>4<<2;_=N+(Z<<3)|0;if(V>>>0<X>>>0){$=V;aa=N;ba=0.0;while(1){ca=+n[$>>2]-+p[aa>>3];da=+n[$+4>>2]-+p[aa+8>>3];ea=+n[$+8>>2]-+p[aa+16>>3];fa=+n[$+12>>2]-+p[aa+24>>3];ga=ba+(ca*ca+da*da+ea*ea+fa*fa);$=$+16|0;if($>>>0>=X>>>0){ha=ga;break}else{aa=aa+32|0;ba=ga}}}else ha=0.0;aa=V+(Z<<2)|0;if(aa>>>0<W>>>0){X=_;ba=ha;$=aa;while(1){ga=+n[$>>2]-+p[X>>3];$=$+4|0;fa=ba+ga*ga;if($>>>0>=W>>>0){ia=fa;break}else{X=X+8|0;ba=fa}}}else ia=ha;X=T+(L<<2)|0;f[X>>2]=0;if(K){W=I+((Y(f[G>>2]|0,f[U>>2]|0)|0)<<2)|0;$=f[F>>2]|0;_=W+(f[l>>2]<<2)|0;Z=_+-12|0;V=((Z>>>0<W>>>0?W:Z)+12+(3-W)|0)>>>4<<2;aa=W>>>0<Z>>>0;ja=W+(V<<2)|0;ka=ja>>>0<_>>>0;la=1;ba=ia;ma=0;while(1){na=N+((Y($,la)|0)<<3)|0;oa=na+(V<<3)|0;if(aa){pa=W;qa=na;fa=0.0;while(1){ga=+n[pa>>2]-+p[qa>>3];ea=+n[pa+4>>2]-+p[qa+8>>3];da=+n[pa+8>>2]-+p[qa+16>>3];ca=+n[pa+12>>2]-+p[qa+24>>3];ra=fa+(ga*ga+ea*ea+da*da+ca*ca);pa=pa+16|0;if(pa>>>0>=Z>>>0){sa=ra;break}else{qa=qa+32|0;fa=ra}}}else sa=0.0;if(ka){qa=oa;fa=sa;pa=ja;while(1){ra=+n[pa>>2]-+p[qa>>3];pa=pa+4|0;ca=fa+ra*ra;if(pa>>>0>=_>>>0){ta=ca;break}else{qa=qa+8|0;fa=ca}}}else ta=sa;if(ba>ta){f[X>>2]=la;ua=ta;va=la}else{ua=ba;va=ma}la=la+1|0;if((la|0)==(g|0)){wa=ua;xa=va;break}else{ba=ua;ma=va}}}else{wa=ia;xa=0}ma=O+(xa<<2)|0;if(wa>+n[ma>>2])n[ma>>2]=wa;ma=P+(xa<<2)|0;f[ma>>2]=(f[ma>>2]|0)+1;L=L+1|0}while((L|0)!=(e|0));ya=G}else ya=a+36|0;b[s>>0]=0;G=a+16|0;L=a+28|0;xa=t+8|0;O=t+12|0;va=t+16|0;N=t+20|0;I=t+24|0;K=t+28|0;ma=t+32|0;la=t+36|0;X=t+40|0;_=v+4|0;ja=0;do{if((ja|0)>=(f[G>>2]|0))break;b[s>>0]=1;ja=ja+1|0;if(Q){ka=0;do{Z=(f[z>>2]|0)+((Y(f[F>>2]|0,ka)|0)<<3)|0;g1c(Z|0,0,f[l>>2]<<3|0)|0;n[(f[o>>2]|0)+(ka<<2)>>2]=0.0;ka=ka+1|0}while((ka|0)!=(g|0))}if(J?(ka=f[A>>2]|0,Z=f[ya>>2]|0,W=f[z>>2]|0,aa=f[F>>2]|0,V=f[l>>2]|0,V|0):0){$=0;do{U=ka+((Y(Z,f[d+($<<2)>>2]|0)|0)<<2)|0;qa=W+((Y(aa,f[T+($<<2)>>2]|0)|0)<<3)|0;pa=0;do{oa=qa+(pa<<3)|0;p[oa>>3]=+p[oa>>3]+ +n[U+(pa<<2)>>2];pa=pa+1|0}while(pa>>>0<V>>>0);$=$+1|0}while(($|0)!=(e|0))}$=f[l>>2]|0;if(Q){V=f[z>>2]|0;aa=f[F>>2]|0;if(!$)za=0;else{W=0;do{wa=+(f[P+(W<<2)>>2]|0);Z=V+((Y(aa,W)|0)<<3)|0;ka=0;do{pa=Z+(ka<<3)|0;p[pa>>3]=+p[pa>>3]/wa;ka=ka+1|0}while(ka>>>0<$>>>0);W=W+1|0}while((W|0)!=(g|0));za=$}}else za=$;f[t>>2]=174632;f[xa>>2]=L;f[O>>2]=g;f[va>>2]=d;f[N>>2]=m;f[I>>2]=za;f[K>>2]=P;f[ma>>2]=T;f[la>>2]=o;f[X>>2]=s;f[v>>2]=0;f[_>>2]=e;h3(v,t,-1.0);if(Q){W=f[z>>2]|0;aa=f[o>>2]|0;V=0;do{ka=P+(V<<2)|0;if(!(f[ka>>2]|0)){Z=V;do{Z=(Z+1|0)%(g|0)|0;Aa=P+(Z<<2)|0}while((f[Aa>>2]|0)<2);a:do if(J){pa=W+((Y(f[F>>2]|0,Z)|0)<<3)|0;U=aa+(Z<<2)|0;qa=0;while(1){Ba=T+(qa<<2)|0;if((f[Ba>>2]|0)==(Z|0)){oa=(f[A>>2]|0)+((Y(f[ya>>2]|0,f[d+(qa<<2)>>2]|0)|0)<<2)|0;na=oa+(f[l>>2]<<2)|0;Ca=na+-12|0;Da=((Ca>>>0<oa>>>0?oa:Ca)+12+(3-oa)|0)>>>4<<2;Ea=pa+(Da<<3)|0;if(oa>>>0<Ca>>>0){Fa=oa;Ga=pa;wa=0.0;while(1){ia=+n[Fa>>2]-+p[Ga>>3];ua=+n[Fa+4>>2]-+p[Ga+8>>3];ta=+n[Fa+8>>2]-+p[Ga+16>>3];sa=+n[Fa+12>>2]-+p[Ga+24>>3];ha=wa+(ia*ia+ua*ua+ta*ta+sa*sa);Fa=Fa+16|0;if(Fa>>>0>=Ca>>>0){Ha=ha;break}else{Ga=Ga+32|0;wa=ha}}}else Ha=0.0;Ga=oa+(Da<<2)|0;if(Ga>>>0<na>>>0){Ca=Ea;wa=Ha;Fa=Ga;while(1){ha=+n[Fa>>2]-+p[Ca>>3];Fa=Fa+4|0;sa=wa+ha*ha;if(Fa>>>0>=na>>>0){Ia=sa;break}else{Ca=Ca+8|0;wa=sa}}}else Ia=Ha;if(Ia==+n[U>>2])break}qa=qa+1|0;if((qa|0)>=(e|0))break a}f[Ba>>2]=V;f[Aa>>2]=(f[Aa>>2]|0)+-1;f[ka>>2]=(f[ka>>2]|0)+1}while(0);b[s>>0]=0}V=V+1|0}while((V|0)!=(g|0))}}while(!(b[s>>0]|0));s=bYc(g>>>0>1073741823?-1:g<<2)|0;if(Q){Aa=a+100|0;Ba=f[z>>2]|0;z=f[F>>2]|0;F=f[l>>2]|0;t=0;v=F;while(1){_=bYc(v>>>0>1073741823?-1:v<<2)|0;f[s+(t<<2)>>2]=_;f[Aa>>2]=(f[Aa>>2]|0)+(v<<2);if(!v)Ja=0;else{X=Ba+((Y(z,t)|0)<<3)|0;la=0;do{n[_+(la<<2)>>2]=+p[X+(la<<3)>>3];la=la+1|0}while(la>>>0<F>>>0);Ja=F}t=t+1|0;if((t|0)>=(g|0))break;else v=Ja}}Ja=(g<<2)+15&-16;v=a+76|0;t=f[v>>2]|0;do if((Ja|0)>(t|0)){F=a+96|0;f[F>>2]=(f[F>>2]|0)+t;F=(Ja|4)+15|0;z=F>>>0>8192?F:8192;F=jIc(z)|0;if(!F){eKc(513012,27,1,f[46249]|0)|0;Ka=0;break}else{Ba=a+80|0;f[F>>2]=f[Ba>>2];f[Ba>>2]=F;Ba=z+-4|0;f[v>>2]=Ba;z=F+4|0;F=a+84|0;f[F>>2]=z;La=F;Ma=z;Na=Ba;S=85;break}}else{Ba=a+84|0;La=Ba;Ma=f[Ba>>2]|0;Na=t;S=85}while(0);if((S|0)==85){f[La>>2]=Ma+Ja;f[v>>2]=Na-Ja;Na=a+92|0;f[Na>>2]=(f[Na>>2]|0)+Ja;Ka=Ma}Ma=c+20|0;f[Ma>>2]=Ka;if(Q){Q=a+96|0;Ka=f[46249]|0;Ja=a+80|0;Na=a+84|0;La=h+1|0;h=a+92|0;t=0;Ba=0;while(1){z=f[P+(t<<2)>>2]|0;if(J){F=0;Ia=0.0;Ha=0.0;Aa=Ba;while(1){la=T+(F<<2)|0;if((f[la>>2]|0)==(t|0)){X=d+(F<<2)|0;_=f[X>>2]|0;ma=(f[A>>2]|0)+((Y(f[ya>>2]|0,_)|0)<<2)|0;K=ma+(f[l>>2]<<2)|0;za=K+-12|0;I=((za>>>0<ma>>>0?ma:za)+12+(3-ma)|0)>>>4<<2;if(ma>>>0<za>>>0){m=ma;wa=0.0;while(1){sa=+n[m>>2];ha=+n[m+4>>2];ta=+n[m+8>>2];ua=+n[m+12>>2];ia=wa+(sa*sa+ha*ha+ta*ta+ua*ua);m=m+16|0;if(m>>>0>=za>>>0){Oa=ia;break}else wa=ia}}else Oa=0.0;za=ma+(I<<2)|0;if(za>>>0<K>>>0){wa=Oa;m=za;while(1){ia=+n[m>>2];m=m+4|0;ua=wa+ia*ia;if(m>>>0>=K>>>0){Pa=ua;break}else wa=ua}}else Pa=Oa;wa=Ia+ +M(+Pa);K=d+(Aa<<2)|0;f[X>>2]=f[K>>2];f[K>>2]=_;K=T+(Aa<<2)|0;m=f[la>>2]|0;f[la>>2]=f[K>>2];f[K>>2]=m;Qa=wa;Ra=Ha+Pa;Sa=Aa+1|0}else{Qa=Ia;Ra=Ha;Sa=Aa}F=F+1|0;if((F|0)==(e|0)){Ta=Qa;Ua=Ra;Va=Sa;break}else{Ia=Qa;Ha=Ra;Aa=Sa}}}else{Ta=0.0;Ua=0.0;Va=Ba}Ha=+(z|0);Ia=Ta/Ha;Aa=s+(t<<2)|0;F=f[Aa>>2]|0;m=F+(f[l>>2]<<2)|0;K=m+-12|0;I=((K>>>0<F>>>0?F:K)+12+(3-F)|0)>>>4<<2;if(F>>>0<K>>>0){ma=F;wa=0.0;while(1){ua=+n[ma>>2];ia=+n[ma+4>>2];ta=+n[ma+8>>2];ha=+n[ma+12>>2];sa=wa+(ua*ua+ia*ia+ta*ta+ha*ha);ma=ma+16|0;if(ma>>>0>=K>>>0){Wa=sa;break}else wa=sa}}else Wa=0.0;K=F+(I<<2)|0;if(K>>>0<m>>>0){wa=Wa;ma=K;while(1){sa=+n[ma>>2];ma=ma+4|0;ha=wa+sa*sa;if(ma>>>0>=m>>>0){Xa=ha;break}else wa=ha}}else Xa=Wa;m=f[v>>2]|0;do if((m|0)<32){f[Q>>2]=(f[Q>>2]|0)+m;ma=jIc(8192)|0;if(!ma){eKc(513012,27,1,Ka)|0;Ya=0;break}else{f[ma>>2]=f[Ja>>2];f[Ja>>2]=ma;f[v>>2]=8188;I=ma+4|0;f[Na>>2]=I;Za=I;_a=8188;S=109;break}}else{Za=f[Na>>2]|0;_a=m;S=109}while(0);if((S|0)==109){S=0;f[Na>>2]=Za+32;f[v>>2]=_a+-32;f[h>>2]=(f[h>>2]|0)+32;Ya=Za}f[(f[Ma>>2]|0)+(t<<2)>>2]=Ya;m=f[(f[Ma>>2]|0)+(t<<2)>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;m=(f[Ma>>2]|0)+(t<<2)|0;I=f[m>>2]|0;f[I+4>>2]=f[(f[o>>2]|0)+(t<<2)>>2];f[I>>2]=f[Aa>>2];I=f[m>>2]|0;n[I+12>>2]=Ua/Ha-Xa;n[I+8>>2]=Ia;gCc(a,I,d+(Ba<<2)|0,Va-Ba|0,g,La);t=t+1|0;if((t|0)>=(g|0))break;else Ba=Va}}dYc(s);s=f[r>>2]|0;if((s|0)!=(R|0)){if(s|0)dYc(s);f[r>>2]=R;f[y>>2]=264}y=f[q>>2]|0;if((y|0)!=(D|0)){if(y|0)dYc(y);f[q>>2]=D;f[H>>2]=264}H=f[o>>2]|0;if(H|0){o=f[C>>2]|0;if((o|0)!=(H|0))f[C>>2]=o+(~((o+-4-H|0)>>>2)<<2);cYc(H)}H=f[j>>2]|0;if((H|0)!=(B|0)){if(H|0)dYc(H);f[j>>2]=B;f[E>>2]=136}}else{f[c+24>>2]=d;mMc(d,d+(e<<2)|0,j);f[c+20>>2]=0}c=f[k>>2]|0;if((c|0)!=(w|0)){if(c|0)dYc(c);f[k>>2]=w;f[x>>2]=264}u=i;return}function hCc(a){a=a|0;cYc(a);return}function iCc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0;d=f[c>>2]|0;e=f[c+4>>2]|0;if((d|0)>=(e|0))return;c=a+8|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+12|0;k=a+36|0;l=a+32|0;m=a+28|0;o=a+40|0;a=d;do{d=f[c>>2]|0;q=(f[d+12>>2]|0)+((Y(f[d+8>>2]|0,f[(f[g>>2]|0)+(a<<2)>>2]|0)|0)<<2)|0;d=f[h>>2]|0;r=f[d+12>>2]|0;s=q+(f[i>>2]<<2)|0;t=s+-12|0;u=((t>>>0<q>>>0?q:t)+12+(3-q)|0)>>>4<<2;v=r+(u<<3)|0;w=q>>>0<t>>>0;if(w){x=q;y=r;z=0.0;while(1){A=+n[x>>2]-+p[y>>3];B=+n[x+4>>2]-+p[y+8>>3];C=+n[x+8>>2]-+p[y+16>>3];D=+n[x+12>>2]-+p[y+24>>3];E=z+(A*A+B*B+C*C+D*D);x=x+16|0;if(x>>>0>=t>>>0){F=E;break}else{y=y+32|0;z=E}}}else F=0.0;y=q+(u<<2)|0;x=y>>>0<s>>>0;if(x){G=v;z=F;H=y;while(1){E=+n[H>>2]-+p[G>>3];H=H+4|0;D=z+E*E;if(H>>>0>=s>>>0){I=D;break}else{G=G+8|0;z=D}}}else I=F;G=f[j>>2]|0;a:do if((G|0)>1){H=f[d+8>>2]|0;if(w){J=1;K=0;L=I}else{v=1;M=0;z=I;while(1){if(x){N=r+((Y(H,v)|0)<<3)+(u<<3)|0;D=0.0;O=y;while(1){E=+n[O>>2]-+p[N>>3];O=O+4|0;C=D+E*E;if(O>>>0>=s>>>0){P=C;break}else{N=N+8|0;D=C}}}else P=0.0;N=z>P;D=N?P:z;O=N?v:M;v=v+1|0;if((v|0)>=(G|0)){Q=O;R=D;break a}else{M=O;z=D}}}while(1){M=r+((Y(H,J)|0)<<3)|0;v=q;O=M;z=0.0;while(1){D=+n[v>>2]-+p[O>>3];C=+n[v+4>>2]-+p[O+8>>3];E=+n[v+8>>2]-+p[O+16>>3];B=+n[v+12>>2]-+p[O+24>>3];z=z+(D*D+C*C+E*E+B*B);v=v+16|0;if(v>>>0>=t>>>0)break;else O=O+32|0}if(x){O=M+(u<<3)|0;B=z;v=y;while(1){E=+n[v>>2]-+p[O>>3];v=v+4|0;C=B+E*E;if(v>>>0>=s>>>0){S=C;break}else{O=O+8|0;B=C}}}else S=z;O=L>S;B=O?S:L;v=O?J:K;J=J+1|0;if((J|0)>=(G|0)){Q=v;R=B;break}else{K=v;L=B}}}else{Q=0;R=I}while(0);G=(f[f[k>>2]>>2]|0)+(Q<<2)|0;if(R>+n[G>>2])n[G>>2]=R;G=f[(f[l>>2]|0)+(a<<2)>>2]|0;if((Q|0)!=(G|0)){s=(f[m>>2]|0)+(G<<2)|0;f[s>>2]=(f[s>>2]|0)+-1;s=(f[m>>2]|0)+(Q<<2)|0;f[s>>2]=(f[s>>2]|0)+1;f[(f[l>>2]|0)+(a<<2)>>2]=Q;b[f[o>>2]>>0]=0}a=a+1|0}while((a|0)!=(e|0));return}function jCc(a){a=a|0;var b=0;f[a>>2]=174652;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);return}function kCc(a){a=a|0;var b=0;f[a>>2]=174652;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);cYc(a);return}function lCc(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;Hwc(515088,b)|0;c=f[a+4>>2]|0;Yi[f[(f[c>>2]|0)+8>>2]&4095](c);Hwc(515113,b+8|0)|0;c=f[a+8>>2]|0;Yi[f[(f[c>>2]|0)+8>>2]&4095](c);u=b;return}function mCc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,b);c=f[a+8>>2]|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,b);return}function nCc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+24>>2]&2047](c,b);c=f[a+8>>2]|0;mi[f[(f[c>>2]|0)+24>>2]&2047](c,b);return}function oCc(a){a=a|0;var b=0;b=f[a+8>>2]|0;return _i[f[(f[b>>2]|0)+28>>2]&2047](b)|0}function pCc(a){a=a|0;var b=0;b=f[a+8>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&2047](b)|0}function qCc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;c=_i[f[(f[b>>2]|0)+36>>2]&2047](b)|0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+36>>2]&2047](b)|0)+c|0}function rCc(a){a=a|0;return 3}function sCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+12>>2]|0;i=b+16|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function tCc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[a+4>>2]|0;ei[f[(f[e>>2]|0)+48>>2]&511](e,b,c,d);e=f[a+8>>2]|0;ei[f[(f[e>>2]|0)+48>>2]&511](e,b,c,d);return}function uCc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0;h=u;u=u+32|0;i=h;jvc(i,d);a:do if((b|0)>0){d=i+16|0;j=f[i>>2]|0;k=a+40|0;l=a+36|0;m=a+32|0;o=f[i+12>>2]|0;p=f[d>>2]|0;q=0;b:while(1){r=e+(q<<2)|0;s=(q|0)>0;if((p|0)==(o|0)){t=q;v=j;w=22;break a}else x=p;while(1){y=x;x=x+1|0;f[d>>2]=x;z=f[j+(y<<2)>>2]|0;if((z|0)<0)break b;y=f[c+(z<<2)>>2]|0;f[r>>2]=y;if(!s)break;z=f[k>>2]|0;A=f[l>>2]|0;B=z+((Y(A,y)|0)<<2)|0;y=B+(f[m>>2]<<2)|0;C=y+-12|0;D=((C>>>0<B>>>0?B:C)+12+(3-B)|0)>>>4<<2;E=B+(D<<2)|0;F=E>>>0<y>>>0;if(B>>>0>=C>>>0){if(F){G=0;H=0;while(1){I=z+((Y(f[e+(G<<2)>>2]|0,A)|0)<<2)+(D<<2)|0;J=0.0;K=E;while(1){L=+n[K>>2]-+n[I>>2];K=K+4|0;J=J+L*L;if(K>>>0>=y>>>0)break;else I=I+4|0}I=J<1.0e-16?1:H;G=G+1|0;if((G|0)==(q|0)){M=I;w=19;break}else H=I}}}else{H=0;G=0;while(1){I=z+((Y(f[e+(H<<2)>>2]|0,A)|0)<<2)|0;K=B;N=I;L=0.0;while(1){O=+n[K>>2]-+n[N>>2];P=+n[K+4>>2]-+n[N+4>>2];Q=+n[K+8>>2]-+n[N+8>>2];R=+n[K+12>>2]-+n[N+12>>2];L=L+(O*O+P*P+Q*Q+R*R);K=K+16|0;if(K>>>0>=C>>>0)break;else N=N+16|0}if(F){N=I+(D<<2)|0;J=L;K=E;while(1){R=+n[K>>2]-+n[N>>2];K=K+4|0;Q=J+R*R;if(K>>>0>=y>>>0){S=Q;break}else{N=N+4|0;J=Q}}}else S=L;N=S<1.0e-16?1:G;H=H+1|0;if((H|0)==(q|0)){M=N;w=19;break}else G=N}}if((w|0)==19?(w=0,(M&1)==0):0)break;if((x|0)==(o|0)){t=q;v=j;w=22;break a}}s=q+1|0;if((s|0)<(b|0)){p=x;q=s}else{t=s;v=j;w=22;break a}}f[g>>2]=q;T=j}else{t=0;v=f[i>>2]|0;w=22}while(0);if((w|0)==22){f[g>>2]=t;if(!v){u=h;return}else T=v}v=i+4|0;i=f[v>>2]|0;if((i|0)!=(T|0))f[v>>2]=i+(~((i+-4-T|0)>>>2)<<2);cYc(T);u=h;return}function vCc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0;h=OR()|0;i=h;j=f[i+4>>2]|0;k=x1c(f[i>>2]|0,0,-130063606,0)|0;i=d1c(k|0,J|0,j|0,0)|0;j=h;f[j>>2]=i;f[j+4>>2]=J;f[e>>2]=f[c+(~~(+(d|0)*(+(i&2147483647|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){l=1;f[g>>2]=l;return}i=(d|0)>0;j=a+40|0;h=a+36|0;k=a+32|0;a=1;while(1){if(!i){l=a;m=18;break}o=f[j>>2]|0;p=f[h>>2]|0;q=o+((Y(p,f[e>>2]|0)|0)<<2)|0;r=f[k>>2]|0;s=q+(r<<2)|0;t=s+-12|0;u=((t>>>0<q>>>0?q:t)+12+(3-q)|0)>>>4<<2;v=q>>>0<t>>>0;w=q+(u<<2)|0;x=w>>>0<s>>>0;y=(a|0)>1;z=0;A=0.0;B=-1;while(1){C=o+((Y(f[c+(z<<2)>>2]|0,p)|0)<<2)|0;D=C+(u<<2)|0;if(v){E=q;F=C;G=0.0;while(1){H=+n[E>>2]-+n[F>>2];I=+n[E+4>>2]-+n[F+4>>2];K=+n[E+8>>2]-+n[F+8>>2];L=+n[E+12>>2]-+n[F+12>>2];M=G+(H*H+I*I+K*K+L*L);E=E+16|0;if(E>>>0>=t>>>0){N=M;break}else{F=F+16|0;G=M}}}else N=0.0;if(x){F=D;G=N;E=w;while(1){M=+n[E>>2]-+n[F>>2];E=E+4|0;L=G+M*M;if(E>>>0>=s>>>0){O=L;break}else{F=F+4|0;G=L}}}else O=N;if(y){F=1;G=O;while(1){E=o+((Y(p,f[e+(F<<2)>>2]|0)|0)<<2)|0;D=E+(r<<2)|0;P=D+-12|0;Q=((P>>>0<E>>>0?E:P)+12+(3-E)|0)>>>4<<2;R=C+(Q<<2)|0;if(E>>>0<P>>>0){S=E;T=C;L=0.0;while(1){M=+n[S>>2]-+n[T>>2];K=+n[S+4>>2]-+n[T+4>>2];I=+n[S+8>>2]-+n[T+8>>2];H=+n[S+12>>2]-+n[T+12>>2];U=L+(M*M+K*K+I*I+H*H);S=S+16|0;if(S>>>0>=P>>>0){V=U;break}else{T=T+16|0;L=U}}}else V=0.0;T=E+(Q<<2)|0;if(T>>>0<D>>>0){P=R;L=V;S=T;while(1){U=+n[S>>2]-+n[P>>2];S=S+4|0;H=L+U*U;if(S>>>0>=D>>>0){W=H;break}else{P=P+4|0;L=H}}}else W=V;L=W<G?W:G;F=F+1|0;if((F|0)==(a|0)){X=L;break}else G=L}}else X=O;F=X>A;B=F?z:B;z=z+1|0;if((z|0)==(d|0))break;else A=F?X:A}if((B|0)==-1){l=a;m=18;break}f[e+(a<<2)>>2]=f[c+(B<<2)>>2];z=a+1|0;if((z|0)<(b|0))a=z;else{l=z;m=18;break}}if((m|0)==18){f[g>>2]=l;return}}function wCc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0;h=u;u=u+16|0;i=h;j=bYc(d>>>0>1073741823?-1:d<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;o=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(o|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=c+(~~(+(d|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[e>>2]=f[m>>2];l=(d|0)>0;if(l){k=f[a+40>>2]|0;o=f[a+36>>2]|0;p=k+((Y(f[m>>2]|0,o)|0)<<2)|0;m=f[a+32>>2]|0;q=0;r=0.0;while(1){s=k+((Y(o,f[c+(q<<2)>>2]|0)|0)<<2)|0;t=s+(m<<2)|0;v=t+-12|0;w=((v>>>0<s>>>0?s:v)+12+(3-s)|0)>>>4<<2;x=p+(w<<2)|0;if(s>>>0<v>>>0){y=s;z=p;A=0.0;while(1){B=+n[y>>2]-+n[z>>2];C=+n[y+4>>2]-+n[z+4>>2];D=+n[y+8>>2]-+n[z+8>>2];E=+n[y+12>>2]-+n[z+12>>2];F=A+(B*B+C*C+D*D+E*E);y=y+16|0;if(y>>>0>=v>>>0){G=F;break}else{z=z+16|0;A=F}}}else G=0.0;z=s+(w<<2)|0;if(z>>>0<t>>>0){v=x;A=G;y=z;while(1){F=+n[y>>2]-+n[v>>2];y=y+4|0;E=A+F*F;if(y>>>0>=t>>>0){H=E;break}else{v=v+4|0;A=E}}}else H=G;n[j+(q<<2)>>2]=H;A=r+H;q=q+1|0;if((q|0)==(d|0)){I=A;break}else r=A}}else I=0.0;if((b|0)<=1){K=1;f[g>>2]=K;dYc(j);u=h;return}q=d+-1|0;p=(d|0)>1;m=a+40|0;o=a+36|0;k=a+32|0;a=1;r=I;while(1){v=OR()|0;t=v;y=f[t+4>>2]|0;x=x1c(f[t>>2]|0,0,-130063606,0)|0;t=d1c(x|0,J|0,y|0,0)|0;y=v;f[y>>2]=t;f[y+4>>2]=J;a:do if(p){y=0;I=r*(+(t&2147483647|0)*4.656612873077393e-10)+0.0;while(1){H=+n[j+(y<<2)>>2];if(I<=H){L=y;break a}v=y+1|0;if((v|0)<(q|0)){y=v;I=I-H}else{L=v;break}}}else L=0;while(0);if(l){t=f[m>>2]|0;y=f[o>>2]|0;v=c+(L<<2)|0;x=f[v>>2]|0;w=t+((Y(x,y)|0)<<2)|0;s=f[k>>2]|0;z=0;I=0.0;do{M=t+((Y(y,f[c+(z<<2)>>2]|0)|0)<<2)|0;N=M+(s<<2)|0;O=N+-12|0;P=((O>>>0<M>>>0?M:O)+12+(3-M)|0)>>>4<<2;Q=w+(P<<2)|0;if(M>>>0<O>>>0){R=M;S=w;H=0.0;while(1){G=+n[R>>2]-+n[S>>2];A=+n[R+4>>2]-+n[S+4>>2];E=+n[R+8>>2]-+n[S+8>>2];F=+n[R+12>>2]-+n[S+12>>2];D=H+(G*G+A*A+E*E+F*F);R=R+16|0;if(R>>>0>=O>>>0){T=D;break}else{S=S+16|0;H=D}}}else T=0.0;S=M+(P<<2)|0;if(S>>>0<N>>>0){O=Q;H=T;R=S;while(1){D=+n[R>>2]-+n[O>>2];R=R+4|0;F=H+D*D;if(R>>>0>=N>>>0){U=F;break}else{O=O+4|0;H=F}}}else U=T;H=+n[j+(z<<2)>>2];I=I+(H<U?H:U);z=z+1|0}while((z|0)!=(d|0));f[e+(a<<2)>>2]=x;if(l){z=f[m>>2]|0;w=f[o>>2]|0;s=z+((Y(f[v>>2]|0,w)|0)<<2)|0;y=f[k>>2]|0;t=0;do{O=z+((Y(w,f[c+(t<<2)>>2]|0)|0)<<2)|0;N=O+(y<<2)|0;R=N+-12|0;Q=((R>>>0<O>>>0?O:R)+12+(3-O)|0)>>>4<<2;P=s+(Q<<2)|0;if(O>>>0<R>>>0){M=O;S=s;H=0.0;while(1){F=+n[M>>2]-+n[S>>2];D=+n[M+4>>2]-+n[S+4>>2];E=+n[M+8>>2]-+n[S+8>>2];A=+n[M+12>>2]-+n[S+12>>2];G=H+(F*F+D*D+E*E+A*A);M=M+16|0;if(M>>>0>=R>>>0){V=G;break}else{S=S+16|0;H=G}}}else V=0.0;S=O+(Q<<2)|0;if(S>>>0<N>>>0){R=P;H=V;M=S;while(1){G=+n[M>>2]-+n[R>>2];M=M+4|0;A=H+G*G;if(M>>>0>=N>>>0){W=A;break}else{R=R+4|0;H=A}}}else W=V;n[i>>2]=W;R=j+(t<<2)|0;f[R>>2]=f[(+n[R>>2]<W?R:i)>>2];t=t+1|0}while((t|0)!=(d|0));X=I}else X=I}else{f[e+(a<<2)>>2]=f[c+(L<<2)>>2];X=0.0}a=a+1|0;if((a|0)==(b|0)){K=b;break}else r=X}f[g>>2]=K;dYc(j);u=h;return}function xCc(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=174712;if(b[a+36>>0]|0?(c=f[a+64>>2]|0,c|0):0)dYc(c);c=a+96|0;d=f[c>>2]|0;if(d|0){e=d;do{d=e;e=f[e>>2]|0;kIc(d);f[c>>2]=e}while((e|0)!=0)}e=f[a+80>>2]|0;if(e|0){c=a+84|0;d=f[c>>2]|0;if((d|0)!=(e|0))f[c>>2]=d+(~((d+-8-e|0)>>>3)<<3);cYc(e)}e=f[a+40>>2]|0;if(e|0){d=a+44|0;c=f[d>>2]|0;if((c|0)!=(e|0))f[d>>2]=c+(~((c+-4-e|0)>>>2)<<2);cYc(e)}Ptc(a+20|0,f[a+24>>2]|0);return}function yCc(a){a=a|0;xCc(a);cYc(a);return}function zCc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+80|0;PCc(a,c);d=a+68|0;e=QCc(a,0,f[d>>2]|0,c)|0;f[a+76>>2]=e;if(!(b[a+36>>0]|0)){e=a+4|0;c=a+52|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];return}e=a+64|0;c=f[e>>2]|0;if(c|0)dYc(c);c=f[d>>2]|0;d=f[a+72>>2]|0;g=Y(d,c)|0;h=bYc(g>>>0>1073741823?-1:g<<2)|0;f[a+52>>2]=c;f[a+56>>2]=d;f[a+60>>2]=d;f[e>>2]=h;if((c|0)==0|(d|0)==0)return;e=f[a+40>>2]|0;g=f[a+16>>2]|0;i=f[a+12>>2]|0;a=0;do{j=g+((Y(i,f[e+(a<<2)>>2]|0)|0)<<2)|0;k=h+((Y(d,a)|0)<<2)|0;l=0;do{f[k+(l<<2)>>2]=f[j+(l<<2)>>2];l=l+1|0}while(l>>>0<d>>>0);a=a+1|0}while(a>>>0<c>>>0);return}function ACc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;f[i>>2]=174024;j=i+12|0;f[j>>2]=e;k=i+16|0;f[k>>2]=0;if(!(f[b>>2]|0)){u=h;return}l=c+12|0;m=c+8|0;c=d+12|0;o=d+8|0;d=i+4|0;p=i+8|0;q=i+20|0;r=b+12|0;s=b+8|0;t=0;v=e;while(1){e=(f[l>>2]|0)+((Y(f[m>>2]|0,t)|0)<<2)|0;w=(f[c>>2]|0)+((Y(f[o>>2]|0,t)|0)<<2)|0;f[d>>2]=e;f[p>>2]=w;f[k>>2]=0;n[q>>2]=3402823466385288598117041.0e14;n[w+(v+-1<<2)>>2]=3402823466385288598117041.0e14;w=(f[r>>2]|0)+((Y(f[s>>2]|0,t)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,i,w,g);w=t+1|0;if(w>>>0>=(f[b>>2]|0)>>>0)break;t=w;v=f[j>>2]|0}u=h;return}function BCc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;eKc(a+68|0,4,1,c)|0;eKc(a+72|0,4,1,c)|0;g=a+80|0;f[e>>2]=(f[a+84>>2]|0)-(f[g>>2]|0)>>3;eKc(e,4,1,c)|0;eKc(f[g>>2]|0,8,f[e>>2]|0,c)|0;g=a+36|0;ILc(b[g>>0]|0,c)|0;eKc(a+32|0,4,1,c)|0;h=a+40|0;f[e>>2]=(f[a+44>>2]|0)-(f[h>>2]|0)>>2;eKc(e,4,1,c)|0;eKc(f[h>>2]|0,4,f[e>>2]|0,c)|0;if(!(b[g>>0]|0)){i=a+76|0;j=f[i>>2]|0;OCc(a,c,j);u=d;return}g=a+52|0;eKc(g,16,1,c)|0;eKc(f[a+64>>2]|0,4,Y(f[a+56>>2]|0,f[g>>2]|0)|0,c)|0;i=a+76|0;j=f[i>>2]|0;OCc(a,c,j);u=d;return}function CCc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;if((NLc(a+68|0,4,1,c)|0)!=1){i=af(60)|0;Jtc(i,511860);ig(i|0,22128,1)}if((NLc(a+72|0,4,1,c)|0)!=1){i=af(60)|0;Jtc(i,511860);ig(i|0,22128,1)}LCc(c,a+80|0);i=a+36|0;if((NLc(i,1,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+32|0;if((NLc(j,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}Lyc(c,a+40|0);if(!(b[i>>0]|0)){k=a+4|0;l=a+52|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2]}else tuc(c,a+52|0);MCc(a,c,a+76|0);c=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=c;c=a+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=h+11|0;b[k>>0]=9;l=h;m=512094;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+9>>0]=0;o=Ntc(c,e,h)|0;p=f[o>>2]|0;if(!p){q=$Xc(36)|0;r=q+16|0;f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;r=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=r;f[o>>2]=q;r=f[f[c>>2]>>2]|0;if(!r)s=q;else{f[c>>2]=r;s=f[o>>2]|0}UQ(f[a+24>>2]|0,s);s=a+28|0;f[s>>2]=(f[s>>2]|0)+1;t=q}else t=p;p=t+28|0;q=f[p>>2]|0;s=t+32|0;mi[f[f[q>>2]>>2]&2047](q,s);f[p>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,s);if((b[k>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=h;m=515181;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+13>>0]=0;h=Ntc(c,e,g)|0;m=f[h>>2]|0;if(!m){l=$Xc(36)|0;n=l+16|0;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;n=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=n;f[h>>2]=l;n=f[f[c>>2]>>2]|0;if(!n)v=l;else{f[c>>2]=n;v=f[h>>2]|0}UQ(f[a+24>>2]|0,v);v=a+28|0;f[v>>2]=(f[v>>2]|0)+1;w=l}else w=m;m=w+28|0;l=f[m>>2]|0;v=w+32|0;mi[f[f[l>>2]>>2]&2047](l,v);f[m>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,j,v);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g+8>>2]=0;v=g+11|0;b[v>>0]=7;b[g>>0]=b[515195]|0;b[g+1>>0]=b[515196]|0;b[g+2>>0]=b[515197]|0;b[g+3>>0]=b[515198]|0;b[g+4>>0]=b[515199]|0;b[g+5>>0]=b[515200]|0;b[g+6>>0]=b[515201]|0;b[g+7>>0]=0;j=Ntc(c,e,g)|0;m=f[j>>2]|0;if(!m){l=$Xc(36)|0;w=l+16|0;f[w>>2]=f[g>>2];f[w+4>>2]=f[g+4>>2];f[w+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;w=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=w;f[j>>2]=l;w=f[f[c>>2]>>2]|0;if(!w)x=l;else{f[c>>2]=w;x=f[j>>2]|0}UQ(f[a+24>>2]|0,x);x=a+28|0;f[x>>2]=(f[x>>2]|0)+1;y=l}else y=m;m=y+28|0;l=f[m>>2]|0;x=y+32|0;mi[f[f[l>>2]>>2]&2047](l,x);f[m>>2]=173488;Ti[f[(f[43372]|0)+4>>2]&511](173488,i,x);if((b[v>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function DCc(a){a=a|0;return f[a+68>>2]|0}function ECc(a){a=a|0;return f[a+72>>2]|0}function FCc(a){a=a|0;return (f[a+112>>2]|0)+(f[a+108>>2]|0)+(f[a+4>>2]<<2)|0}function GCc(a){a=a|0;return 4}function HCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+20>>2]|0;i=b+24|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function ICc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;g=u;u=u+32|0;h=g;i=g+12|0;j=h+4|0;f[j>>2]=0;f[j+4>>2]=0;j=h+11|0;b[j>>0]=3;b[h>>0]=b[513188]|0;b[h+1>>0]=b[513189]|0;b[h+2>>0]=b[513190]|0;b[h+3>>0]=0;k=auc(e,h)|0;do if((k|0)!=(e+4|0)){l=k+28|0;m=f[l>>2]|0;o=(_i[f[(f[m>>2]|0)+28>>2]&2047](m)|0)+4|0;if((f[o>>2]|0)==(f[6387]|0)){o=f[l>>2]|0;l=Mi[f[(f[o>>2]|0)+20>>2]&1023](o,k+32|0)|0;p=+n[l>>2]+1.0;break}else ig(af(1)|0,22144,0)}else p=1.0;while(0);if((b[j>>0]|0)<0)cYc(f[h>>2]|0);h=f[a+72>>2]|0;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;if(!h)q=0.0;else{if(h>>>0>1073741823)kWc(i);k=h<<2;e=$Xc(k)|0;f[i>>2]=e;f[i+8>>2]=e+(h<<2);g1c(e|0,0,k|0)|0;f[j>>2]=e+(h<<2);k=f[a+80>>2]|0;r=0.0;l=0;while(1){o=d+(l<<2)|0;s=+n[o>>2];t=+n[k+(l<<3)>>2];v=s-t;w=v*v;if(s<t){n[e+(l<<2)>>2]=w;x=r+w;y=+n[o>>2]}else{x=r;y=s}s=+n[k+(l<<3)+4>>2];w=y-s;t=w*w;if(y>s){n[e+(l<<2)>>2]=t;z=x+t}else z=x;l=l+1|0;if((l|0)==(h|0)){q=z;break}else r=z}}JCc(a,c,d,f[a+76>>2]|0,q,i,p);a=f[i>>2]|0;if(!a){u=g;return}i=f[j>>2]|0;if((i|0)!=(a|0))f[j>>2]=i+(~((i+-4-a|0)>>>2)<<2);cYc(a);u=g;return}function JCc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=+i;var j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0,u=0;j=f[e+20>>2]|0;k=f[e+24>>2]|0;if(!((j|0)==0&(k|0)==0)){l=f[e+8>>2]|0;m=+n[d+(l<<2)>>2];o=+n[e+12>>2];p=+n[e+16>>2];q=m-o+(m-p)<0.0;r=m-(q?p:o);o=r*r;JCc(a,c,d,q?j:k,g,h,i);s=(f[h>>2]|0)+(l<<2)|0;r=+n[s>>2];p=o+g-r;n[s>>2]=o;if(p*i<=+Vg[f[(f[c>>2]|0)+16>>2]&31](c))JCc(a,c,d,q?k:j,p,h,i);n[(f[h>>2]|0)+(l<<2)>>2]=r;return}r=+Vg[f[(f[c>>2]|0)+16>>2]&31](c);l=f[e>>2]|0;h=e+4|0;if((l|0)>=(f[h>>2]|0))return;e=a+36|0;j=a+40|0;k=a+116|0;q=a+64|0;s=a+60|0;t=a+72|0;a=l;do{if(!(b[e>>0]|0))u=f[(f[j>>2]|0)+(a<<2)>>2]|0;else u=a;l=(f[q>>2]|0)+((Y(f[s>>2]|0,u)|0)<<2)|0;i=+KCc(k,d,l,f[t>>2]|0,r);if(i<r)Hg[f[(f[c>>2]|0)+12>>2]&15](c,i,f[(f[j>>2]|0)+(a<<2)>>2]|0);a=a+1|0}while((a|0)<(f[h>>2]|0));return}function KCc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0,w=0.0,x=0;a=b+(d<<2)|0;d=a+-12|0;a:do if(e>0.0){f=b;g=c;h=0.0;while(1){if(f>>>0>=d>>>0){i=f;j=g;k=h;break a}l=+n[f>>2]-+n[g>>2];m=+n[f+4>>2]-+n[g+4>>2];o=+n[f+8>>2]-+n[g+8>>2];p=+n[f+12>>2]-+n[g+12>>2];q=h+(l*l+m*m+o*o+p*p);if(q>e){r=q;break}else{f=f+16|0;g=g+16|0;h=q}}return +r}else{g=((d>>>0<b>>>0?b:d)+12+(3-b)|0)>>>4<<2;f=c+(g<<2)|0;if(d>>>0>b>>>0){s=b;t=c;h=0.0;while(1){q=+n[s>>2]-+n[t>>2];p=+n[s+4>>2]-+n[t+4>>2];o=+n[s+8>>2]-+n[t+8>>2];m=+n[s+12>>2]-+n[t+12>>2];l=h+(q*q+p*p+o*o+m*m);s=s+16|0;if(s>>>0>=d>>>0){u=l;break}else{t=t+16|0;h=l}}}else u=0.0;i=b+(g<<2)|0;j=f;k=u}while(0);if(i>>>0<a>>>0){v=j;w=k;x=i}else{r=k;return +r}while(1){k=+n[x>>2]-+n[v>>2];x=x+4|0;u=w+k*k;if(x>>>0>=a>>>0){r=u;break}else{v=v+4|0;w=u}}return +r}function LCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;if((NLc(d,4,1,a)|0)!=1){e=af(60)|0;Jtc(e,511860);ig(e|0,22128,1)}e=f[d>>2]|0;d=b+4|0;g=f[d>>2]|0;h=f[b>>2]|0;i=g-h>>3;j=h;k=g;g=h;if(e>>>0<=i>>>0)if(e>>>0<i>>>0?(h=j+(e<<3)|0,(k|0)!=(h|0)):0){f[d>>2]=k+(~((k+-8-h|0)>>>3)<<3);l=g}else l=g;else{NCc(b,e-i|0);l=f[b>>2]|0}if((NLc(l,8,e,a)|0)==(e|0)){u=c;return}else{c=af(60)|0;Jtc(c,511860);ig(c|0,22128,1)}}function MCc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+92|0;e=a+112|0;g=f[46249]|0;h=a+96|0;i=a+100|0;j=a+108|0;k=c;while(1){c=f[d>>2]|0;do if((c|0)<32){f[e>>2]=(f[e>>2]|0)+c;l=jIc(8192)|0;if(!l){eKc(513012,27,1,g)|0;m=0;break}else{f[l>>2]=f[h>>2];f[h>>2]=l;f[d>>2]=8188;n=l+4|0;f[i>>2]=n;o=n;p=8156;q=7;break}}else{o=f[i>>2]|0;p=c+-32|0;q=7}while(0);if((q|0)==7){q=0;f[i>>2]=o+32;f[d>>2]=p;f[j>>2]=(f[j>>2]|0)+32;m=o}f[k>>2]=m;if((NLc(m,28,1,b)|0)!=1){q=9;break}c=f[k>>2]|0;n=c+20|0;if(!(f[n>>2]|0))r=c;else{MCc(a,b,n);r=f[k>>2]|0}k=r+24|0;if(!(f[k>>2]|0)){q=13;break}}if((q|0)==9){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}else if((q|0)==13)return}function NCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){h=b;i=g;do{j=i;f[j>>2]=0;f[j+4>>2]=0;i=(f[e>>2]|0)+8|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>3;g=i+b|0;if(g>>>0>536870911)kWc(a);j=d-h|0;h=j>>2;d=j>>3>>>0<268435455?(h>>>0<g>>>0?g:h):536870911;do if(d)if(d>>>0>536870911){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<3)|0;break}else k=0;while(0);h=k+(i<<3)|0;i=k+(d<<3)|0;d=b;b=h;k=h;do{g=b;f[g>>2]=0;f[g+4>>2]=0;b=k+8|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(0-(b>>3)<<3)|0;if((b|0)>0)o1c(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;cYc(d);return}function OCc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=c;do{eKc(d,28,1,b)|0;c=f[d+20>>2]|0;if(c|0)OCc(a,b,c);d=f[d+24>>2]|0}while((d|0)!=0);return}function PCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0;c=a+72|0;d=f[c>>2]|0;e=b+4|0;g=f[e>>2]|0;h=f[b>>2]|0;i=g-h>>3;j=h;h=g;if(d>>>0<=i>>>0)if(d>>>0<i>>>0?(g=j+(d<<3)|0,(h|0)!=(g|0)):0){f[e>>2]=h+(~((h+-8-g|0)>>>3)<<3);k=d}else k=d;else{NCc(b,d-i|0);k=f[c>>2]|0}c=(k|0)==0;if(!c){i=f[a+16>>2]|0;d=f[b>>2]|0;g=0;do{h=i+(g<<2)|0;f[d+(g<<3)>>2]=f[h>>2];f[d+(g<<3)+4>>2]=f[h>>2];g=g+1|0}while(g>>>0<k>>>0)}g=f[a+4>>2]|0;if(g>>>0<=1)return;d=f[b>>2]|0;if(c)return;c=f[a+16>>2]|0;b=f[a+12>>2]|0;a=1;do{i=c+((Y(b,a)|0)<<2)|0;h=0;do{e=i+(h<<2)|0;l=+n[e>>2];j=d+(h<<3)|0;if(l<+n[j>>2]){n[j>>2]=l;m=+n[e>>2]}else m=l;e=d+(h<<3)+4|0;if(m>+n[e>>2])n[e>>2]=m;h=h+1|0}while(h>>>0<k>>>0);a=a+1|0}while(a>>>0<g>>>0);return}function QCc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;e=u;u=u+48|0;g=e+32|0;h=e+28|0;i=e+24|0;j=e+12|0;k=e;l=a+92|0;m=f[l>>2]|0;do if((m|0)<32){o=a+112|0;f[o>>2]=(f[o>>2]|0)+m;o=jIc(8192)|0;if(!o){eKc(513012,27,1,f[46249]|0)|0;p=0;break}else{q=a+96|0;f[o>>2]=f[q>>2];f[q>>2]=o;f[l>>2]=8188;q=o+4|0;o=a+100|0;f[o>>2]=q;r=o;s=q;t=8188;v=6;break}}else{q=a+100|0;r=q;s=f[q>>2]|0;t=m;v=6}while(0);if((v|0)==6){f[r>>2]=s+32;f[l>>2]=t+-32;t=a+108|0;f[t>>2]=(f[t>>2]|0)+32;p=s}s=c-b|0;if((s|0)>(f[a+32>>2]|0)){RCc(a,(f[a+40>>2]|0)+(b<<2)|0,s,g,h,i,d);f[p+8>>2]=f[h>>2];SCc(j,d);f[(f[j>>2]|0)+(f[h>>2]<<3)+4>>2]=f[i>>2];s=QCc(a,b,(f[g>>2]|0)+b|0,j)|0;f[p+20>>2]=s;SCc(k,d);f[(f[k>>2]|0)+(f[h>>2]<<3)>>2]=f[i>>2];i=QCc(a,(f[g>>2]|0)+b|0,c,k)|0;f[p+24>>2]=i;i=f[h>>2]|0;h=f[j>>2]|0;f[p+12>>2]=f[h+(i<<3)+4>>2];g=f[k>>2]|0;f[p+16>>2]=f[g+(i<<3)>>2];i=f[a+72>>2]|0;if(!i)if(!g)w=h;else v=24;else{s=f[d>>2]|0;t=0;do{l=h+(t<<3)|0;r=g+(t<<3)|0;f[s+(t<<3)>>2]=f[(+n[r>>2]<+n[l>>2]?r:l)>>2];l=h+(t<<3)+4|0;r=g+(t<<3)+4|0;f[s+(t<<3)+4>>2]=f[(+n[l>>2]<+n[r>>2]?r:l)>>2];t=t+1|0}while(t>>>0<i>>>0);v=24}if((v|0)==24){v=k+4|0;k=f[v>>2]|0;if((k|0)!=(g|0))f[v>>2]=k+(~((k+-8-g|0)>>>3)<<3);cYc(g);w=f[j>>2]|0}if(w|0){g=j+4|0;j=f[g>>2]|0;if((j|0)!=(w|0))f[g>>2]=j+(~((j+-8-w|0)>>>3)<<3);cYc(w)}u=e;return p|0}f[p+24>>2]=0;f[p+20>>2]=0;f[p>>2]=b;f[p+4>>2]=c;w=f[a+72>>2]|0;j=(w|0)==0;if(!j){g=(f[a+16>>2]|0)+((Y(f[a+12>>2]|0,f[(f[a+40>>2]|0)+(b<<2)>>2]|0)|0)<<2)|0;k=f[d>>2]|0;v=0;do{i=g+(v<<2)|0;f[k+(v<<3)>>2]=f[i>>2];f[k+(v<<3)+4>>2]=f[i>>2];v=v+1|0}while(v>>>0<w>>>0)}v=b+1|0;if((v|0)>=(c|0)){u=e;return p|0}b=f[d>>2]|0;if(j){u=e;return p|0}j=f[a+40>>2]|0;d=f[a+16>>2]|0;k=f[a+12>>2]|0;a=v;do{v=d+((Y(k,f[j+(a<<2)>>2]|0)|0)<<2)|0;g=0;do{i=b+(g<<3)|0;t=v+(g<<2)|0;x=+n[t>>2];if(+n[i>>2]>x){n[i>>2]=x;y=+n[t>>2]}else y=x;t=b+(g<<3)+4|0;if(+n[t>>2]<y)n[t>>2]=y;g=g+1|0}while(g>>>0<w>>>0);a=a+1|0}while((a|0)!=(c|0));u=e;return p|0}function RCc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0;i=u;u=u+16|0;j=i+4|0;k=i;l=f[h>>2]|0;m=+n[l+4>>2];o=+n[l>>2];p=m-o;h=a+72|0;q=f[h>>2]|0;if(q>>>0>1){r=1;t=p;while(1){v=+n[l+(r<<3)+4>>2]-+n[l+(r<<3)>>2];w=v>t?v:t;r=r+1|0;if(r>>>0>=q>>>0){x=w;break}else t=w}}else x=p;f[e>>2]=0;q=f[h>>2]|0;a:do if(!q){y=a+12|0;z=a+16|0;A=0}else{p=x*.9999899864196777;r=a+16|0;B=a+12|0;if((c|0)>1){C=-1.0;D=0;E=q;F=o;G=m;H=0}else{t=-1.0;I=0;w=o;v=m;J=0;K=q;while(1){if(v-w>p?(L=(f[r>>2]|0)+((Y(f[B>>2]|0,f[b>>2]|0)|0)<<2)+(J<<2)|0,M=+n[L>>2],N=M-M,N>t):0){f[e>>2]=I;O=N;P=f[h>>2]|0;Q=I}else{O=t;P=K;Q=J}L=I+1|0;if(L>>>0>=P>>>0){y=B;z=r;A=Q;break a}t=O;I=L;w=+n[l+(L<<3)>>2];v=+n[l+(L<<3)+4>>2];J=Q;K=P}}while(1){if(G-F>p){K=f[r>>2]|0;J=f[B>>2]|0;I=K+((Y(J,f[b>>2]|0)|0)<<2)+(H<<2)|0;L=f[I>>2]|0;I=1;R=L;S=L;v=(f[s>>2]=L,+n[s>>2]);while(1){L=K+((Y(f[b+(I<<2)>>2]|0,J)|0)<<2)+(H<<2)|0;w=+n[L>>2];L=w<(f[s>>2]=S,+n[s>>2]);T=(n[s>>2]=w,f[s>>2]|0);S=L?T:S;t=L?(f[s>>2]=R,+n[s>>2]):v;L=w>t;R=L?T:R;I=I+1|0;if((I|0)==(c|0))break;else v=L?w:t}v=(f[s>>2]=R,+n[s>>2]);t=v-(f[s>>2]=S,+n[s>>2]);if(t>C){f[e>>2]=D;U=t;V=D;W=f[h>>2]|0}else{U=C;V=H;W=E}}else{U=C;V=H;W=E}I=D+1|0;if(I>>>0>=W>>>0){y=B;z=r;A=V;break a}C=U;D=I;E=W;F=+n[l+(I<<3)>>2];G=+n[l+(I<<3)+4>>2];H=V}}while(0);G=(+n[l+(A<<3)>>2]+ +n[l+(A<<3)+4>>2])*.5;l=f[z>>2]|0;z=f[y>>2]|0;y=l+((Y(z,f[b>>2]|0)|0)<<2)+(A<<2)|0;V=f[y>>2]|0;if((c|0)>1){y=1;H=V;W=V;F=(f[s>>2]=V,+n[s>>2]);while(1){E=l+((Y(f[b+(y<<2)>>2]|0,z)|0)<<2)+(A<<2)|0;U=+n[E>>2];E=U<(f[s>>2]=W,+n[s>>2]);D=(n[s>>2]=U,f[s>>2]|0);h=E?D:W;C=E?(f[s>>2]=H,+n[s>>2]):F;E=U>C;e=E?D:H;y=y+1|0;if((y|0)==(c|0)){X=e;Z=h;break}else{H=e;W=h;F=E?U:C}}}else{X=V;Z=V}F=(f[s>>2]=Z,+n[s>>2]);C=(f[s>>2]=X,+n[s>>2]);U=G<F?F:G>C?C:G;n[g>>2]=U;TCc(a,b,c,A,U,j,k);A=f[j>>2]|0;j=(c|0)/2|0;if((A|0)>(j|0)){_=A;f[d>>2]=_;u=i;return}A=f[k>>2]|0;_=(A|0)<(j|0)?A:j;f[d>>2]=_;u=i;return}function SCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;o1c(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function TCc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+-1|0;c=a+16|0;j=a+12|0;a=i;k=0;a:while(1){b:do if((k|0)>(a|0))l=k;else{m=f[c>>2]|0;o=f[j>>2]|0;p=k;while(1){q=m+((Y(o,f[b+(p<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]<e)){l=p;break b}q=p+1|0;if((p|0)<(a|0))p=q;else{l=q;break}}}while(0);if((l|0)>(a|0))break;p=f[c>>2]|0;o=f[j>>2]|0;m=a;while(1){r=b+(m<<2)|0;s=f[r>>2]|0;q=p+((Y(o,s)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]>=e))break;if((l|0)<(m|0))m=m+-1|0;else break a}o=b+(l<<2)|0;p=f[o>>2]|0;f[o>>2]=s;f[r>>2]=p;a=m+-1|0;k=l+1|0}f[g>>2]=l;g=i;i=l;c:while(1){d:do if((i|0)>(g|0))t=i;else{l=f[c>>2]|0;k=f[j>>2]|0;a=i;while(1){r=l+((Y(k,f[b+(a<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[r>>2]<=e)){t=a;break d}r=a+1|0;if((a|0)<(g|0))a=r;else{t=r;break}}}while(0);if((t|0)>(g|0)){u=21;break}m=f[c>>2]|0;a=f[j>>2]|0;k=g;while(1){v=b+(k<<2)|0;w=f[v>>2]|0;l=m+((Y(a,w)|0)<<2)+(d<<2)|0;if(!(+n[l>>2]>e))break;if((t|0)<(k|0))k=k+-1|0;else{u=21;break c}}a=b+(t<<2)|0;m=f[a>>2]|0;f[a>>2]=w;f[v>>2]=m;g=k+-1|0;i=t+1|0}if((u|0)==21){f[h>>2]=t;return}}function UCc(a){a=a|0;f[a>>2]=174216;Ptc(a+20|0,f[a+24>>2]|0);return}function VCc(a){a=a|0;f[a>>2]=174216;Ptc(a+20|0,f[a+24>>2]|0);cYc(a);return}function WCc(a){a=a|0;return}function XCc(a,b){a=a|0;b=b|0;return}function YCc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+32|0;d=c+16|0;e=c+12|0;g=c;h=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[e>>2]=h;h=a+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=g+11|0;b[i>>0]=9;j=g;k=512094;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[g+9>>0]=0;k=Ntc(h,d,g)|0;j=f[k>>2]|0;if(!j){l=$Xc(36)|0;m=l+16|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;m=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=m;f[k>>2]=l;m=f[f[h>>2]>>2]|0;if(!m)n=l;else{f[h>>2]=m;n=f[k>>2]|0}UQ(f[a+24>>2]|0,n);n=a+28|0;f[n>>2]=(f[n>>2]|0)+1;o=l}else o=j;j=o+28|0;l=f[j>>2]|0;n=o+32|0;mi[f[f[l>>2]>>2]&2047](l,n);f[j>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,e,n);if((b[i>>0]|0)>=0){u=c;return}cYc(f[g>>2]|0);u=c;return}function ZCc(a){a=a|0;return f[a+4>>2]|0}function _Cc(a){a=a|0;return f[a+8>>2]|0}function $Cc(a){a=a|0;return 0}function aDc(a){a=a|0;return 0}function bDc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+20>>2]|0;i=b+24|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function cDc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0;d=a+4|0;if(!(f[d>>2]|0))return;e=a+8|0;g=0;h=f[a+16>>2]|0;a=f[e>>2]|0;while(1){i=h+(a<<2)|0;j=i+-12|0;k=((j>>>0<h>>>0?h:j)+12+(3-h)|0)>>>4<<2;l=c+(k<<2)|0;if(h>>>0<j>>>0){m=h;o=c;p=0.0;while(1){q=+n[m>>2]-+n[o>>2];r=+n[m+4>>2]-+n[o+4>>2];s=+n[m+8>>2]-+n[o+8>>2];t=+n[m+12>>2]-+n[o+12>>2];u=p+(q*q+r*r+s*s+t*t);m=m+16|0;if(m>>>0>=j>>>0){v=u;break}else{o=o+16|0;p=u}}}else v=0.0;o=h+(k<<2)|0;if(o>>>0<i>>>0){j=l;p=v;m=o;while(1){u=+n[m>>2]-+n[j>>2];m=m+4|0;t=p+u*u;if(m>>>0>=i>>>0){w=t;break}else{j=j+4|0;p=t}}}else w=v;Hg[f[(f[b>>2]|0)+12>>2]&15](b,w,g);g=g+1|0;j=f[e>>2]|0;if(g>>>0>=(f[d>>2]|0)>>>0)break;else{h=h+(j<<2)|0;a=j}}return}function dDc(a){a=a|0;var b=0;f[a>>2]=174156;b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);return}function eDc(a){a=a|0;var b=0;f[a>>2]=174156;b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);cYc(a);return}function fDc(a){a=a|0;var c=0;if(b[a+8>>0]|0)return;c=f[a+4>>2]|0;Yi[f[(f[c>>2]|0)+8>>2]&4095](c);return}function gDc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;h=f[a+4>>2]|0;Fh[f[(f[h>>2]|0)+12>>2]&255](h,b,c,d,e,g);return}function hDc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0;h=f[a+4>>2]|0;return uj[f[(f[h>>2]|0)+16>>2]&7](h,b,c,d,e,g)|0}function iDc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,b);return}function jDc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+24>>2]&2047](c,b);return}function kDc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+28>>2]&2047](b)|0}function lDc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&2047](b)|0}function mDc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+36>>2]&2047](b)|0}function nDc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+40>>2]&2047](b)|0}function oDc(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;mi[f[(f[c>>2]|0)+44>>2]&2047](a,c);return}function pDc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[a+4>>2]|0;ei[f[(f[e>>2]|0)+48>>2]&511](e,b,c,d);return}function qDc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+36|0;i=g+12|0;j=g+24|0;k=g;l=g+40|0;f[a>>2]=174772;m=a+12|0;f[a+16>>2]=0;f[a+20>>2]=0;n=a+16|0;f[m>>2]=n;o=f[d>>2]|0;p=d+4|0;if((o|0)!=(p|0)){q=n;n=o;while(1){o=n+16|0;f[i>>2]=q;f[h>>2]=f[i>>2];Qtc(m,h,o,o)|0;o=f[n+4>>2]|0;if(!o){r=n+8|0;s=f[r>>2]|0;if((f[s>>2]|0)==(n|0))t=s;else{s=r;do{r=f[s>>2]|0;s=r+8|0;v=f[s>>2]|0}while((f[v>>2]|0)!=(r|0));t=v}}else{s=o;while(1){v=f[s>>2]|0;if(!v)break;else s=v}t=s}if((t|0)==(p|0))break;else n=t}};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=j+11|0;b[t>>0]=9;n=j;p=512094;m=n+9|0;do{b[n>>0]=b[p>>0]|0;n=n+1|0;p=p+1|0}while((n|0)<(m|0));b[j+9>>0]=0;p=Rtc(d,j)|0;if((b[t>>0]|0)<0)cYc(f[j>>2]|0);j=a+8|0;b[j>>0]=0;if((p|0)!=254){p=sDc(c,d,e)|0;f[a+4>>2]=p;u=g;return};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=k+11|0;b[p>>0]=8;e=k;f[e>>2]=1701603686;f[e+4>>2]=1701667182;b[k+8>>0]=0;Stc(i,d,k);b[h>>0]=b[l>>0]|0;l=rDc(c,i,h)|0;f[a+4>>2]=l;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[p>>0]|0)<0)cYc(f[k>>2]|0);b[j>>0]=1;u=g;return}function rDc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+80|0;g=e+72|0;h=e+24|0;i=e+12|0;j=e;k=iKc((b[c+11>>0]|0)<0?f[c>>2]|0:c,511741)|0;if(!k){l=0;u=e;return l|0}Itc(h,k);if((f[h+32>>2]|0)!=4){oKc(k)|0;c=af(60)|0;Jtc(c,515315);ig(c|0,22128,1)}if((f[h+40>>2]|0)!=(f[a>>2]|0)){oKc(k)|0;m=af(60)|0;Jtc(m,515383);ig(m|0,22128,1)}if((f[h+44>>2]|0)!=(f[a+4>>2]|0)){oKc(k)|0;m=af(60)|0;Jtc(m,515383);ig(m|0,22128,1)}m=i+4|0;f[m>>2]=0;c=i+8|0;f[c>>2]=0;n=i+4|0;f[i>>2]=n;o=h+36|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;h=j+11|0;b[h>>0]=9;p=j;q=512094;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[j+9>>0]=0;q=Ntc(i,g,j)|0;p=f[q>>2]|0;if(!p){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[s+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[g>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[q>>2]=r;s=f[f[i>>2]>>2]|0;if(!s)t=r;else{f[i>>2]=s;t=f[q>>2]|0}UQ(f[m>>2]|0,t);f[c>>2]=(f[c>>2]|0)+1;v=r}else v=p;p=v+28|0;r=f[p>>2]|0;c=v+32|0;mi[f[f[r>>2]>>2]&2047](r,c);f[p>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,o,c);if((b[h>>0]|0)<0)cYc(f[j>>2]|0);j=sDc(a,i,d)|0;mi[f[(f[j>>2]|0)+24>>2]&2047](j,k);oKc(k)|0;Ptc(i,f[n>>2]|0);l=j;u=e;return l|0}function sDc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d;h=d+4|0;i=d+21|0;j=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=h+11|0;b[k>>0]=9;l=h;m=512094;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+9>>0]=0;m=Rtc(c,h)|0;if((b[k>>0]|0)<0)cYc(f[h>>2]|0);switch(m|0){case 0:{m=$Xc(36)|0;f[m>>2]=174832;h=m+4|0;f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];h=m+20|0;k=m+24|0;f[k>>2]=0;f[m+28>>2]=0;f[h>>2]=k;l=f[c>>2]|0;n=c+4|0;if((l|0)==(n|0)){o=m;u=d;return o|0}p=k;k=l;while(1){l=k+16|0;f[g>>2]=p;f[e>>2]=f[g>>2];Qtc(h,e,l,l)|0;l=f[k+4>>2]|0;if(!l){q=k+8|0;r=f[q>>2]|0;if((f[r>>2]|0)==(k|0))s=r;else{r=q;do{q=f[r>>2]|0;r=q+8|0;t=f[r>>2]|0}while((f[t>>2]|0)!=(q|0));s=t}}else{r=l;while(1){t=f[r>>2]|0;if(!t)break;else r=t}s=r}if((s|0)==(n|0)){o=m;break}else k=s}u=d;return o|0}case 5:{s=$Xc(104)|0;b[e>>0]=b[i>>0]|0;tDc(s,a,c,e);o=s;u=d;return o|0}case 6:{s=$Xc(76)|0;b[e>>0]=b[j>>0]|0;uDc(s,a,c,e);o=s;u=d;return o|0}default:{o=af(60)|0;Jtc(o,512104);ig(o|0,22128,1)}}return 0}function tDc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+80|0;g=e+64|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;f[a>>2]=175072;n=a+12|0;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];f[n+8>>2]=f[c+8>>2];f[n+12>>2]=f[c+12>>2];c=a+28|0;f[a+32>>2]=0;f[a+36>>2]=0;o=a+32|0;f[c>>2]=o;p=f[d>>2]|0;q=d+4|0;if((p|0)!=(q|0)){d=o;r=p;while(1){p=r+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,p,p)|0;p=f[r+4>>2]|0;if(!p){s=r+8|0;t=f[s>>2]|0;if((f[t>>2]|0)==(r|0))v=t;else{t=s;do{s=f[t>>2]|0;t=s+8|0;w=f[t>>2]|0}while((f[w>>2]|0)!=(s|0));v=w}}else{t=p;while(1){w=f[t>>2]|0;if(!w)break;else t=w}v=t}if((v|0)==(q|0))break;else r=v}}v=a+48|0;f[v>>2]=0;r=a+52|0;f[r>>2]=0;f[a+72>>2]=8192;f[a+60>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+40>>2]=f[n>>2];f[a+44>>2]=f[a+16>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=i+11|0;b[n>>0]=9;q=i;g=512667;h=q+9|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[i+9>>0]=0;d=auc(c,i)|0;do if((d|0)!=(o|0)){p=d+28|0;w=f[p>>2]|0;s=(_i[f[(f[w>>2]|0)+28>>2]&2047](w)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[p>>2]|0;p=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,d+32|0)|0;x=f[p>>2]|0;break}else ig(af(1)|0,22144,0)}else x=32;while(0);f[a+88>>2]=x;if((b[n>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=$Xc(16)|0;f[j>>2]=i;f[j+8>>2]=-2147483632;f[j+4>>2]=12;q=i;g=512677;h=q+12|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[i+12>>0]=0;i=auc(c,j)|0;do if((i|0)!=(o|0)){n=i+28|0;x=f[n>>2]|0;d=(_i[f[(f[x>>2]|0)+28>>2]&2047](x)|0)+4|0;if((f[d>>2]|0)==512690){d=f[n>>2]|0;n=Mi[f[(f[d>>2]|0)+20>>2]&1023](d,i+32|0)|0;y=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else y=0;while(0);i=a+96|0;f[i>>2]=y;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=k+11|0;b[j>>0]=5;b[k>>0]=b[512723]|0;b[k+1>>0]=b[512724]|0;b[k+2>>0]=b[512725]|0;b[k+3>>0]=b[512726]|0;b[k+4>>0]=b[512727]|0;b[k+5>>0]=0;y=auc(c,k)|0;do if((y|0)!=(o|0)){n=y+28|0;d=f[n>>2]|0;x=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)+4|0;if((f[x>>2]|0)==(f[6379]|0)){x=f[n>>2]|0;n=Mi[f[(f[x>>2]|0)+20>>2]&1023](x,y+32|0)|0;z=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else z=4;while(0);y=a+92|0;f[y>>2]=z;if((b[j>>0]|0)<0)cYc(f[k>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;k=l+11|0;b[k>>0]=9;q=l;g=512729;h=q+9|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[l+9>>0]=0;g=auc(c,l)|0;do if((g|0)!=(o|0)){q=g+28|0;h=f[q>>2]|0;j=(_i[f[(f[h>>2]|0)+28>>2]&2047](h)|0)+4|0;if((f[j>>2]|0)==(f[6379]|0)){j=f[q>>2]|0;q=Mi[f[(f[j>>2]|0)+20>>2]&1023](j,g+32|0)|0;A=f[q>>2]|0;break}else ig(af(1)|0,22144,0)}else A=100;while(0);f[a+100>>2]=A;if((b[k>>0]|0)<0)cYc(f[l>>2]|0);switch(f[i>>2]|0){case 0:{B=185;C=0;break}case 1:{B=186;C=0;break}case 2:{B=187;C=0;break}case 3:{B=188;C=0;break}default:{i=af(60)|0;Jtc(i,512739);ig(i|0,22128,1)}}f[a+4>>2]=B;f[a+8>>2]=C;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;C=m+11|0;b[C>>0]=5;b[m>>0]=b[512723]|0;b[m+1>>0]=b[512724]|0;b[m+2>>0]=b[512725]|0;b[m+3>>0]=b[512726]|0;b[m+4>>0]=b[512727]|0;b[m+5>>0]=0;a=auc(c,m)|0;do if((a|0)!=(o|0)){c=a+28|0;B=f[c>>2]|0;i=(_i[f[(f[B>>2]|0)+28>>2]&2047](B)|0)+4|0;if((f[i>>2]|0)==(f[6379]|0)){i=f[c>>2]|0;c=Mi[f[(f[i>>2]|0)+20>>2]&1023](i,a+32|0)|0;D=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else D=4;while(0);f[y>>2]=D;if((b[C>>0]|0)<0){cYc(f[m>>2]|0);E=f[y>>2]|0}else E=D;D=E>>>0>1073741823?-1:E<<2;y=bYc(D)|0;f[v>>2]=y;m=bYc(D)|0;f[r>>2]=m;if((E|0)<=0){u=e;return}f[y>>2]=0;f[f[r>>2]>>2]=0;if((E|0)==1){u=e;return}else F=1;do{f[(f[v>>2]|0)+(F<<2)>>2]=0;f[(f[r>>2]|0)+(F<<2)>>2]=0;F=F+1|0}while((F|0)!=(E|0));u=e;return}function uDc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+40|0;h=e+36|0;i=e+24|0;j=e;k=e+12|0;f[a>>2]=174892;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;l=a+16|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+36|0;f[a+40>>2]=0;f[a+44>>2]=0;l=a+40|0;f[c>>2]=l;m=f[d>>2]|0;n=d+4|0;if((m|0)!=(n|0)){d=l;o=m;while(1){m=o+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,m,m)|0;m=f[o+4>>2]|0;if(!m){p=o+8|0;q=f[p>>2]|0;if((f[q>>2]|0)==(o|0))r=q;else{q=p;do{p=f[q>>2]|0;q=p+8|0;s=f[q>>2]|0}while((f[s>>2]|0)!=(p|0));r=s}}else{q=m;while(1){s=f[q>>2]|0;if(!s)break;else q=s}r=q}if((r|0)==(n|0))break;else o=r}}r=a+60|0;f[r>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;o=$Xc(16)|0;f[i>>2]=o;f[i+8>>2]=-2147483632;f[i+4>>2]=12;n=o;g=512123;h=n+12|0;do{b[n>>0]=b[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(h|0));b[o+12>>0]=0;o=auc(c,i)|0;do if((o|0)!=(l|0)){d=o+28|0;m=f[d>>2]|0;s=(_i[f[(f[m>>2]|0)+28>>2]&2047](m)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[d>>2]|0;d=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,o+32|0)|0;t=f[d>>2]|0;break}else ig(af(1)|0,22144,0)}else t=12;while(0);f[a+48>>2]=t;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=j+11|0;b[i>>0]=8;t=j;f[t>>2]=1601791339;f[t+4>>2]=1702521203;b[j+8>>0]=0;t=auc(c,j)|0;do if((t|0)!=(l|0)){o=t+28|0;d=f[o>>2]|0;s=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[o>>2]|0;o=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,t+32|0)|0;v=f[o>>2]|0;break}else ig(af(1)|0,22144,0)}else v=20;while(0);t=a+52|0;f[t>>2]=v;if((b[i>>0]|0)<0)cYc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(32)|0;f[k>>2]=j;f[k+8>>2]=-2147483616;f[k+4>>2]=17;n=j;g=512136;h=n+17|0;do{b[n>>0]=b[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(h|0));b[j+17>>0]=0;j=auc(c,k)|0;do if((j|0)!=(l|0)){c=j+28|0;g=f[c>>2]|0;n=(_i[f[(f[g>>2]|0)+28>>2]&2047](g)|0)+4|0;if((f[n>>2]|0)==(f[6379]|0)){n=f[c>>2]|0;c=Mi[f[(f[n>>2]|0)+20>>2]&1023](n,j+32|0)|0;w=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else w=2;while(0);j=a+56|0;f[j>>2]=w;if((b[k+11>>0]|0)>=0){x=w;y=a+20|0;z=f[y>>2]|0;A=a+32|0;f[A>>2]=z;B=f[t>>2]|0;vDc(a,0,B,x,r);u=e;return}cYc(f[k>>2]|0);x=f[j>>2]|0;y=a+20|0;z=f[y>>2]|0;A=a+32|0;f[A>>2]=z;B=f[t>>2]|0;vDc(a,0,B,x,r);u=e;return}function vDc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;f[h>>2]=b;i=e+4|0;j=f[i>>2]|0;if((j|0)==(f[e+8>>2]|0))P3(e,h);else{f[j>>2]=b;f[i>>2]=j+4}if(!((d|0)!=0&(c|0)>0)){u=g;return}j=d+-1|0;d=c;do{c=d;d=d+-1|0;vDc(a,f[h>>2]|1<<d,d,j,e)}while((c|0)>1);u=g;return}function wDc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+36>>2]|0;if(b|0){d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;d=f[b+12>>2]|0;if(d|0){e=b+16|0;g=f[e>>2]|0;if((g|0)!=(d|0))f[e>>2]=g+(~((g+-4-d|0)>>>2)<<2);cYc(d)}cYc(b)}while((c|0)!=0)}c=a+12|0;b=f[c>>2]|0;f[c>>2]=0;if(b|0)cYc(b);b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))h=b;else{g=d;while(1){d=g+-12|0;f[c>>2]=d;e=f[d>>2]|0;if(!e)i=d;else{d=g+-8|0;j=f[d>>2]|0;if((j|0)!=(e|0))f[d>>2]=j+(~((j+-4-e|0)>>>2)<<2);cYc(e);i=f[c>>2]|0}if((i|0)==(b|0))break;else g=i}h=f[a>>2]|0}cYc(h);return}function xDc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=174892;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}Ptc(a+36|0,f[a+40>>2]|0);b=a+4|0;d=f[b>>2]|0;if(!d)return;c=a+8|0;a=f[c>>2]|0;if((a|0)==(d|0))e=d;else{g=a;do{a=g+-72|0;f[c>>2]=a;wDc(a);g=f[c>>2]|0}while((g|0)!=(d|0));e=f[b>>2]|0}cYc(e);return}function yDc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=174892;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}Ptc(a+36|0,f[a+40>>2]|0);b=a+4|0;d=f[b>>2]|0;if(!d){cYc(a);return}c=a+8|0;e=f[c>>2]|0;if((e|0)==(d|0))g=d;else{h=e;do{e=h+-72|0;f[c>>2]=e;wDc(e);h=f[c>>2]|0}while((h|0)!=(d|0));g=f[b>>2]|0}cYc(g);cYc(a);return}function zDc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+80|0;c=b;d=a+4|0;e=a+48|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;j=f[d>>2]|0;k=(i-j|0)/72|0;l=j;j=i;if(g>>>0<=k>>>0){if(g>>>0<k>>>0?(i=l+(g*72|0)|0,(j|0)!=(i|0)):0){l=j;do{j=l+-72|0;f[h>>2]=j;wDc(j);l=f[h>>2]|0}while((l|0)!=(i|0))}}else cEc(d,g-k|0);if(!(f[e>>2]|0)){u=b;return}k=a+32|0;g=a+52|0;i=a+16|0;l=a+24|0;h=a+28|0;a=0;do{j=f[d>>2]|0;m=j+(a*72|0)|0;dEc(c,f[k>>2]|0,f[g>>2]|0);eEc(m,c)|0;wDc(c);n=f[i>>2]|0;o=f[l>>2]|0;p=f[h>>2]|0;Zuc(j+(a*72|0)+12|0,~~(+(((f[j+(a*72|0)+24>>2]|0)+n|0)>>>0)*1.2)>>>0);if(n|0){j=0;do{fEc(m,j,p+(Y(j,o)|0)|0);j=j+1|0}while((j|0)!=(n|0))}gEc(m);a=a+1|0}while(a>>>0<(f[e>>2]|0)>>>0);u=b;return}function ADc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=u;u=u+48|0;j=i+12|0;k=i;l=j+4|0;m=j+8|0;n=j+20|0;o=j+16|0;p=j+12|0;f[j>>2]=175032;f[j+24>>2]=g;q=j+12|0;f[n>>2]=0;f[q>>2]=o;f[o>>2]=0;f[m>>2]=2147483647;b[l>>0]=0;if(!(f[c>>2]|0)){r=0;f[j>>2]=174992;s=j+12|0;NDc(s,r);u=i;return}t=d+12|0;v=d+8|0;d=(g|0)>0;w=c+12|0;x=c+8|0;y=k+11|0;z=k+6|0;A=h+4|0;B=(g|0)<0;C=(g|0)!=0;D=e+12|0;E=e+8|0;e=~g;F=(((e|0)>-2?e:-2)+g<<2)+8|0;e=0;G=0;while(1){NDc(q,G);f[n>>2]=0;f[q>>2]=o;f[o>>2]=0;f[m>>2]=2147483647;b[l>>0]=0;if(d){g1c((f[t>>2]|0)+((Y(f[v>>2]|0,e)|0)<<2)|0,-1,F|0)|0;H=g;I=(f[D>>2]|0)+((Y(f[E>>2]|0,e)|0)<<2)|0;while(1){f[I>>2]=2147483647;if((H|0)>1){H=H+-1|0;I=I+4|0}else break}}I=(f[w>>2]|0)+(Y(f[x>>2]|0,e)|0)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,I,h);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[y>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[z>>0]=0;I=auc(h,k)|0;if((I|0)==(A|0))J=1;else{H=I+28|0;K=f[H>>2]|0;L=(_i[f[(f[K>>2]|0)+28>>2]&2047](K)|0)+4|0;if((f[L>>2]|0)!=(f[6363]|0)){M=9;break}L=f[H>>2]|0;H=Mi[f[(f[L>>2]|0)+20>>2]&1023](L,I+32|0)|0;J=b[H>>0]|0}if((b[y>>0]|0)<0)cYc(f[k>>2]|0);H=(f[t>>2]|0)+((Y(f[v>>2]|0,e)|0)<<2)|0;I=(f[D>>2]|0)+((Y(f[E>>2]|0,e)|0)<<2)|0;do if(!(J<<24>>24)){L=f[p>>2]|0;if(B){if((L|0)==(o|0))break;else{N=H;O=I;P=L}while(1){f[N>>2]=f[P+20>>2];f[O>>2]=f[P+16>>2];K=f[P+4>>2]|0;if(!K){Q=P+8|0;R=f[Q>>2]|0;if((f[R>>2]|0)==(P|0))S=R;else{R=Q;do{Q=f[R>>2]|0;R=Q+8|0;T=f[R>>2]|0}while((f[T>>2]|0)!=(Q|0));S=T}}else{R=K;while(1){T=f[R>>2]|0;if(!T)break;else R=T}S=R}if((S|0)==(o|0))break;else{N=N+4|0;O=O+4|0;P=S}}}else{if(C&(L|0)!=(o|0)){U=0;V=I;W=H;X=L}else break;while(1){f[W>>2]=f[X+20>>2];f[V>>2]=f[X+16>>2];K=f[X+4>>2]|0;if(!K){T=X+8|0;Q=f[T>>2]|0;if((f[Q>>2]|0)==(X|0))Z=Q;else{Q=T;do{T=f[Q>>2]|0;Q=T+8|0;_=f[Q>>2]|0}while((f[_>>2]|0)!=(T|0));Z=_}}else{Q=K;while(1){R=f[Q>>2]|0;if(!R)break;else Q=R}Z=Q}U=U+1|0;if(!((U|0)<(g|0)&(Z|0)!=(o|0)))break;else{V=V+4|0;W=W+4|0;X=Z}}}}else ei[f[(f[j>>2]|0)+24>>2]&511](j,H,I,g);while(0);e=e+1|0;I=f[o>>2]|0;if(e>>>0>=(f[c>>2]|0)>>>0){r=I;M=3;break}else G=I}if((M|0)==3){f[j>>2]=174992;s=j+12|0;NDc(s,r);u=i;return}else if((M|0)==9)ig(af(1)|0,22144,0)}function BDc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+48|0;j=i+12|0;k=i;if((f[c>>2]|0)!=1){eKc(512345,57,1,f[46249]|0)|0;l=-1;u=i;return l|0}m=f[d+4>>2]|0;n=(m|0)==0;o=n?0:f[d+12>>2]|0;d=n?0:f[e+12>>2]|0;f[j+8>>2]=2147483647;f[j+16>>2]=0;e=j+20|0;f[e>>2]=0;n=j+16|0;p=j+12|0;f[p>>2]=n;f[j>>2]=174952;f[j+24>>2]=~~g;b[j+4>>0]=1;q=j+12|0;NDc(q,0);f[e>>2]=0;f[q>>2]=n;f[n>>2]=0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,f[c+12>>2]|0,h);do if((m|0)>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;c=k+11|0;b[c>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[k+6>>0]=0;a=auc(h,k)|0;do if((a|0)!=(h+4|0)){q=a+28|0;r=f[q>>2]|0;s=(_i[f[(f[r>>2]|0)+28>>2]&2047](r)|0)+4|0;if((f[s>>2]|0)==(f[6363]|0)){s=f[q>>2]|0;q=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,a+32|0)|0;t=(b[q>>0]|0)!=0;break}else ig(af(1)|0,22144,0)}else t=1;while(0);if((b[c>>0]|0)<0)cYc(f[k>>2]|0);if(t){ei[f[(f[j>>2]|0)+24>>2]&511](j,o,d,m);break}a=f[p>>2]|0;if((m|0)<0){if((a|0)==(n|0))break;else{v=o;w=d;x=a}while(1){f[v>>2]=f[x+20>>2];f[w>>2]=f[x+16>>2];q=f[x+4>>2]|0;if(!q){s=x+8|0;r=f[s>>2]|0;if((f[r>>2]|0)==(x|0))y=r;else{r=s;do{s=f[r>>2]|0;r=s+8|0;z=f[r>>2]|0}while((f[z>>2]|0)!=(s|0));y=z}}else{r=q;while(1){z=f[r>>2]|0;if(!z)break;else r=z}y=r}if((y|0)==(n|0))break;else{v=v+4|0;w=w+4|0;x=y}}}else{if((m|0)!=0&(a|0)!=(n|0)){A=0;B=d;C=o;D=a}else break;while(1){f[C>>2]=f[D+20>>2];f[B>>2]=f[D+16>>2];c=f[D+4>>2]|0;if(!c){q=D+8|0;z=f[q>>2]|0;if((f[z>>2]|0)==(D|0))E=z;else{z=q;do{q=f[z>>2]|0;z=q+8|0;s=f[z>>2]|0}while((f[s>>2]|0)!=(q|0));E=s}}else{z=c;while(1){r=f[z>>2]|0;if(!r)break;else z=r}E=z}A=A+1|0;if(!((A|0)<(m|0)&(E|0)!=(n|0)))break;else{B=B+4|0;C=C+4|0;D=E}}}}while(0);E=f[e>>2]|0;f[j>>2]=174992;NDc(j+12|0,f[n>>2]|0);l=E;u=i;return l|0}function CDc(a,b){a=a|0;b=b|0;var c=0;eKc(a+48|0,4,1,b)|0;eKc(a+52|0,4,1,b)|0;eKc(a+56|0,4,1,b)|0;c=a+16|0;eKc(c,16,1,b)|0;eKc(f[a+28>>2]|0,1,Y(f[a+20>>2]|0,f[c>>2]|0)|0,b)|0;return}function DDc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+32|0;e=d+24|0;g=d;h=d+12|0;i=a+48|0;if((NLc(i,4,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+52|0;if((NLc(j,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=a+56|0;if((NLc(k,4,1,c)|0)!=1){l=af(60)|0;Jtc(l,511860);ig(l|0,22128,1)}MDc(c,a+16|0);Yi[f[(f[a>>2]|0)+8>>2]&4095](a);c=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=c;c=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=9;m=h;n=512094;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[h+9>>0]=0;p=Ntc(c,e,h)|0;q=f[p>>2]|0;if(!q){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[s+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[p>>2]=r;s=f[f[c>>2]>>2]|0;if(!s)t=r;else{f[c>>2]=s;t=f[p>>2]|0}UQ(f[a+40>>2]|0,t);t=a+44|0;f[t>>2]=(f[t>>2]|0)+1;v=r}else v=q;q=v+28|0;r=f[q>>2]|0;t=v+32|0;mi[f[f[r>>2]>>2]&2047](r,t);f[q>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,t);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;m=h;n=512123;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[h+12>>0]=0;h=Ntc(c,e,g)|0;l=f[h>>2]|0;if(!l){t=$Xc(36)|0;q=t+16|0;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];f[q+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[h>>2]=t;q=f[f[c>>2]>>2]|0;if(!q)w=t;else{f[c>>2]=q;w=f[h>>2]|0}UQ(f[a+40>>2]|0,w);w=a+44|0;f[w>>2]=(f[w>>2]|0)+1;x=t}else x=l;l=x+28|0;t=f[l>>2]|0;w=x+32|0;mi[f[f[t>>2]>>2]&2047](t,w);f[l>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,i,w);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;w=g+11|0;b[w>>0]=8;i=g;f[i>>2]=1601791339;f[i+4>>2]=1702521203;b[g+8>>0]=0;i=Ntc(c,e,g)|0;l=f[i>>2]|0;if(!l){t=$Xc(36)|0;x=t+16|0;f[x>>2]=f[g>>2];f[x+4>>2]=f[g+4>>2];f[x+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;x=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=x;f[i>>2]=t;x=f[f[c>>2]>>2]|0;if(!x)y=t;else{f[c>>2]=x;y=f[i>>2]|0}UQ(f[a+40>>2]|0,y);y=a+44|0;f[y>>2]=(f[y>>2]|0)+1;z=t}else z=l;l=z+28|0;t=f[l>>2]|0;y=z+32|0;mi[f[f[t>>2]>>2]&2047](t,y);f[l>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,j,y);if((b[w>>0]|0)<0)cYc(f[g>>2]|0);w=$Xc(32)|0;f[g>>2]=w;f[g+8>>2]=-2147483616;f[g+4>>2]=17;m=w;n=512136;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[w+17>>0]=0;w=Ntc(c,e,g)|0;n=f[w>>2]|0;if(!n){m=$Xc(36)|0;o=m+16|0;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[m+28>>2]=172888;f[m+32>>2]=0;o=f[e>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=o;f[w>>2]=m;o=f[f[c>>2]>>2]|0;if(!o)A=m;else{f[c>>2]=o;A=f[w>>2]|0}UQ(f[a+40>>2]|0,A);A=a+44|0;f[A>>2]=(f[A>>2]|0)+1;B=m}else B=n;n=B+28|0;m=f[n>>2]|0;A=B+32|0;mi[f[f[m>>2]>>2]&2047](m,A);f[n>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,k,A);if((b[g+11>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function EDc(a){a=a|0;return f[a+16>>2]|0}function FDc(a){a=a|0;return f[a+32>>2]|0}function GDc(a){a=a|0;return f[a+16>>2]<<2|0}function HDc(a){a=a|0;return 6}function IDc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+36>>2]|0;i=b+40|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function JDc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;KDc(a,c,b);return}function KDc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e;i=f[a+4>>2]|0;j=f[a+8>>2]|0;if((i|0)==(j|0)){u=e;return}k=a+64|0;l=a+28|0;m=a+24|0;n=a+20|0;o=a+60|0;a=i;do{i=f[a+56>>2]|0;if(!i)p=0;else{q=a+60|0;r=i+-4|0;s=0;t=1;v=0;w=c;while(1){if(s>>>0>r>>>0){f[g>>2]=0;o1c(g|0,w|0,i-s|0)|0;x=f[g>>2]|0}else x=f[w>>2]|0;y=f[(f[q>>2]|0)+(s>>>2<<2)>>2]|0;if(!y){z=t;A=v}else{B=y;y=v;C=t;while(1){D=B&0-B;E=(D&x|0?C:0)+y|0;B=D^B;D=C<<1;if(!B){z=D;A=E;break}else{y=E;C=D}}}s=s+4|0;if(s>>>0>=i>>>0){p=A;break}else{t=z;v=A;w=w+4|0}}}w=f[o>>2]|0;v=f[k>>2]|0;if((w|0)!=(v|0)){t=w;do{w=LDc(a,f[t>>2]^p)|0;if(w|0?(i=f[w>>2]|0,s=f[w+4>>2]|0,i>>>0<s>>>0):0){w=i;do{i=f[w>>2]|0;q=(f[l>>2]|0)+(Y(f[m>>2]|0,i)|0)|0;r=f[n>>2]|0;if(!r)F=0;else{C=0;y=0;while(1){B=(h[516481+((b[q+y>>0]^b[c+y>>0])&255)>>0]|0)+C|0;y=y+1|0;if((y|0)==(r|0)){F=B;break}else C=B}}Ti[f[(f[d>>2]|0)+12>>2]&511](d,F,i);w=w+4|0}while(w>>>0<s>>>0)}t=t+4|0}while((t|0)!=(v|0))}a=a+72|0}while((a|0)!=(j|0));u=e;return}function LDc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;switch(f[a+32>>2]|0){case 0:{c=(f[a>>2]|0)+(b*12|0)|0;return c|0}case 1:{if(!(f[(f[a+36>>2]|0)+(b>>>5<<2)>>2]&1<<(b&31))){c=0;return c|0}d=f[a+16>>2]|0;a:do if(d){e=d+-1|0;g=(e&d|0)==0;if(!g)if(d>>>0>b>>>0)h=b;else h=(b>>>0)%(d>>>0)|0;else h=e&b;i=f[(f[a+12>>2]|0)+(h<<2)>>2]|0;if((i|0)!=0?(j=f[i>>2]|0,(j|0)!=0):0){if(g){g=j;while(1){i=f[g+4>>2]|0;k=(i|0)==(b|0);if(!(k|(i&e|0)==(h|0))){l=0;break a}if(k?(f[g+8>>2]|0)==(b|0):0){l=g;break a}g=f[g>>2]|0;if(!g){l=0;break a}}}else m=j;while(1){g=f[m+4>>2]|0;if((g|0)==(b|0)){if((f[m+8>>2]|0)==(b|0)){l=m;break a}}else{if(g>>>0<d>>>0)n=g;else n=(g>>>0)%(d>>>0)|0;if((n|0)!=(h|0)){l=0;break a}}m=f[m>>2]|0;if(!m){l=0;break}}}else l=0}else l=0;while(0);c=l+12|0;return c|0}case 2:{l=f[a+16>>2]|0;if(!l){c=0;return c|0}m=l+-1|0;h=(m&l|0)==0;if(!h)if(l>>>0>b>>>0)o=b;else o=(b>>>0)%(l>>>0)|0;else o=m&b;n=f[(f[a+12>>2]|0)+(o<<2)>>2]|0;if(!n){c=0;return c|0}a=f[n>>2]|0;if(!a){c=0;return c|0}b:do if(h){n=a;while(1){d=f[n+4>>2]|0;j=(d|0)==(b|0);if(!(j|(d&m|0)==(o|0))){c=0;p=42;break}if(j?(f[n+8>>2]|0)==(b|0):0){q=n;break b}n=f[n>>2]|0;if(!n){c=0;p=42;break}}if((p|0)==42)return c|0}else{n=a;while(1){j=f[n+4>>2]|0;if((j|0)==(b|0)){if((f[n+8>>2]|0)==(b|0)){q=n;break b}}else{if(j>>>0<l>>>0)r=j;else r=(j>>>0)%(l>>>0)|0;if((r|0)!=(o|0)){c=0;p=42;break}}n=f[n>>2]|0;if(!n){c=0;p=42;break}}if((p|0)==42)return c|0}while(0);c=q+12|0;return c|0}default:{c=0;return c|0}}return 0}function MDc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((NLc(b,16,1,a)|0)!=1){c=af(60)|0;Jtc(c,511860);ig(c|0,22128,1)}c=b+4|0;d=Y(f[c>>2]|0,f[b>>2]|0)|0;e=bYc(d)|0;f[b+12>>2]=e;g=NLc(e,1,d,a)|0;if((g|0)==(Y(f[c>>2]|0,f[b>>2]|0)|0))return;else{b=af(60)|0;Jtc(b,511860);ig(b|0,22128,1)}}function NDc(a,b){a=a|0;b=b|0;if(!b)return;else{NDc(a,f[b>>2]|0);NDc(a,f[b+4>>2]|0);cYc(b);return}}function ODc(a){a=a|0;f[a>>2]=174992;NDc(a+12|0,f[a+16>>2]|0);return}function PDc(a){a=a|0;f[a>>2]=174992;NDc(a+12|0,f[a+16>>2]|0);cYc(a);return}function QDc(a){a=a|0;return (b[a+4>>0]|0)!=0|0}function RDc(a){a=a|0;return f[a+8>>2]|0}function SDc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+12>>2]|0;g=a+16|0;if((d|0)<0){if((e|0)==(g|0))return;else{h=b;i=c;j=e}while(1){f[h>>2]=f[j+20>>2];f[i>>2]=f[j+16>>2];a=f[j+4>>2]|0;if(!a){k=j+8|0;l=f[k>>2]|0;if((f[l>>2]|0)==(j|0))m=l;else{l=k;do{k=f[l>>2]|0;l=k+8|0;n=f[l>>2]|0}while((f[n>>2]|0)!=(k|0));m=n}}else{l=a;while(1){n=f[l>>2]|0;if(!n)break;else l=n}m=l}if((m|0)==(g|0))break;else{h=h+4|0;i=i+4|0;j=m}}return}else{if((e|0)!=(g|0)&(d|0)!=0){o=0;p=c;q=b;r=e}else return;while(1){f[q>>2]=f[r+20>>2];f[p>>2]=f[r+16>>2];e=f[r+4>>2]|0;if(!e){b=r+8|0;c=f[b>>2]|0;if((f[c>>2]|0)==(r|0))s=c;else{c=b;do{b=f[c>>2]|0;c=b+8|0;m=f[c>>2]|0}while((f[m>>2]|0)!=(b|0));s=m}}else{c=e;while(1){l=f[c>>2]|0;if(!l)break;else c=l}s=c}o=o+1|0;if(!((s|0)!=(g|0)&(o|0)<(d|0)))break;else{p=p+4|0;q=q+4|0;r=s}}return}}function TDc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ei[f[(f[a>>2]|0)+24>>2]&511](a,b,c,d);return}function UDc(a){a=a|0;f[a>>2]=174992;NDc(a+12|0,f[a+16>>2]|0);cYc(a);return}function VDc(a){a=a|0;return 1}function WDc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if((f[a+24>>2]|0)<(b|0)){u=d;return}f[e>>2]=b;f[e+4>>2]=c;ZDc(d+8|0,a+12|0,e,e);u=d;return}function XDc(a){a=a|0;return f[a+24>>2]|0}function YDc(a){a=a|0;var b=0,c=0;b=a+12|0;c=a+16|0;NDc(b,f[c>>2]|0);f[a+20>>2]=0;f[b>>2]=c;f[c>>2]=0;return}function ZDc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[d>>2]|0;j=f[d+4>>2]|0;k=d;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c+4|0;n=h;while(1){o=n+16|0;p=f[o>>2]|0;if((i|0)>=(p|0)?!((i|0)==(p|0)?j>>>0<(f[o+4>>2]|0)>>>0:0):0){if((p|0)>=(l|0)){if((p|0)!=(l|0)){q=13;break}if((f[n+20>>2]|0)>>>0>=m>>>0){q=13;break}}r=n+4|0;p=f[r>>2]|0;if(!p){q=12;break}else{s=r;t=p}}else{p=f[n>>2]|0;if(!p){q=7;break}else{s=n;t=p}}k=s;n=t}if((q|0)==7){u=n;v=n;break}else if((q|0)==12){u=n;v=r;break}else if((q|0)==13){u=n;v=k;break}}else{u=g;v=g}while(0);g=f[v>>2]|0;if(g|0){w=g;x=0;y=w;f[a>>2]=y;z=a+4|0;b[z>>0]=x;return}g=$Xc(24)|0;q=e;e=f[q+4>>2]|0;r=g+16|0;f[r>>2]=f[q>>2];f[r+4>>2]=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=u;f[v>>2]=g;u=f[f[c>>2]>>2]|0;if(!u)A=g;else{f[c>>2]=u;A=f[v>>2]|0}UQ(f[c+4>>2]|0,A);A=c+8|0;f[A>>2]=(f[A>>2]|0)+1;w=g;x=1;y=w;f[a>>2]=y;z=a+4|0;b[z>>0]=x;return}function _Dc(a){a=a|0;f[a>>2]=174992;NDc(a+12|0,f[a+16>>2]|0);cYc(a);return}function $Dc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;if((f[h>>2]|0)<=(c|0)){u=e;return}f[g>>2]=c;f[g+4>>2]=d;d=a+12|0;ZDc(e+8|0,d,g,g);g=a+4|0;c=f[a+20>>2]|0;i=f[a+24>>2]|0;if(!(b[g>>0]|0)){if((c|0)!=(i|0)){u=e;return}b[g>>0]=1;g=a+16|0;j=f[g>>2]|0;if(!j){k=g;while(1){g=f[k+8>>2]|0;if((f[g>>2]|0)==(k|0))k=g;else{l=g;break}}}else{k=j;while(1){j=f[k+4>>2]|0;if(!j){l=k;break}else k=j}}f[h>>2]=f[l+16>>2];u=e;return}if(c>>>0<=i>>>0){u=e;return}i=a+16|0;a=f[i>>2]|0;if(!a){c=i;while(1){l=f[c+8>>2]|0;if((f[l>>2]|0)==(c|0))c=l;else{m=l;break}}}else{c=a;while(1){a=f[c+4>>2]|0;if(!a){m=c;break}else c=a}}bEc(d,m+16|0)|0;m=f[i>>2]|0;if(!m){d=i;while(1){i=f[d+8>>2]|0;if((f[i>>2]|0)==(d|0))d=i;else{n=i;break}}}else{d=m;while(1){m=f[d+4>>2]|0;if(!m){n=d;break}else d=m}}f[h>>2]=f[n+16>>2];u=e;return}function aEc(a){a=a|0;var c=0,d=0;c=a+12|0;d=a+16|0;NDc(c,f[d>>2]|0);f[a+20>>2]=0;f[c>>2]=d;f[d>>2]=0;f[a+8>>2]=2147483647;b[a+4>>0]=0;return}function bEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[c>>2]|0;if(!d){e=0;return e|0}g=b;h=f[g>>2]|0;i=f[g+4>>2]|0;g=c;j=d;a:while(1){k=j;while(1){l=f[k+16>>2]|0;if((l|0)>=(h|0)){if((l|0)!=(h|0))break;if((f[k+20>>2]|0)>>>0>=i>>>0)break}l=f[k+4>>2]|0;if(!l){m=g;break a}else k=l}j=f[k>>2]|0;if(!j){m=k;break}else g=k}if((m|0)==(c|0)){e=0;return e|0}c=m+16|0;g=f[c>>2]|0;if((h|0)<(g|0)){e=0;return e|0}if((h|0)==(g|0)?(f[b+4>>2]|0)>>>0<(f[c+4>>2]|0)>>>0:0){e=0;return e|0}c=f[m+4>>2]|0;if(!c){b=m+8|0;g=f[b>>2]|0;if((f[g>>2]|0)==(m|0))n=g;else{g=b;do{b=f[g>>2]|0;g=b+8|0;h=f[g>>2]|0}while((f[h>>2]|0)!=(b|0));n=h}}else{g=c;while(1){c=f[g>>2]|0;if(!c)break;else g=c}n=g}if((f[a>>2]|0)==(m|0))f[a>>2]=n;n=a+8|0;f[n>>2]=(f[n>>2]|0)+-1;XIa(d,m);cYc(m);e=1;return e|0}function cEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/72|0)>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;n[j+28>>2]=1.0;k=j+32|0;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));j=(f[g>>2]|0)+72|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);u=c;return}i=f[a>>2]|0;j=(h-i|0)/72|0;h=j+b|0;if(h>>>0>59652323)kWc(a);g=(e-i|0)/72|0;i=g<<1;e=g>>>0<29826161?(i>>>0<h>>>0?h:i):59652323;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>59652323){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{m=$Xc(e*72|0)|0;break}else m=0;while(0);f[d>>2]=m;i=m+(j*72|0)|0;j=d+8|0;f[j>>2]=i;g=d+4|0;f[g>>2]=i;f[d+12>>2]=m+(e*72|0);e=b;b=i;while(1){f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;n[b+28>>2]=1.0;k=b+32|0;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));e=e+-1|0;if(!e)break;else b=b+72|0}f[j>>2]=m+(h*72|0);hEc(a,d);a=f[g>>2]|0;g=f[j>>2]|0;if((g|0)!=(a|0)){h=g;do{g=h+-72|0;f[j>>2]=g;wDc(g);h=f[j>>2]|0}while((h|0)!=(a|0))}a=f[d>>2]|0;if(a|0)cYc(a);u=c;return}function dEc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;d=u;u=u+48|0;e=d;g=d+32|0;h=d+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;n[a+28>>2]=1.0;i=a+36|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=a+60|0;f[i>>2]=0;j=a+64|0;f[j>>2]=0;f[a+68>>2]=0;f[a+56>>2]=b;if((c+-1|0)>>>0>=31){f[e>>2]=c;f[e+4>>2]=1;f[e+8>>2]=32;DM(g,516863,e);vM(-5,g,516941,516952,274)}f[a+32>>2]=2;e=a+52|0;f[e>>2]=c;c=(b+3|0)>>>2;if(!c){k=0;l=0}else{m=c<<2;o=$Xc(m)|0;g1c(o|0,0,m|0)|0;k=o;l=o+(c<<2)|0}f[i>>2]=k;f[j>>2]=l;f[a+68>>2]=l;l=b<<3;f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;if(l|0){if(l>>>0>1073741823)kWc(g);j=b<<5;b=$Xc(j)|0;f[g>>2]=b;k=b+(l<<2)|0;f[g+8>>2]=k;g1c(b|0,0,j|0)|0;f[a>>2]=k;k=0;do{f[b+(k<<2)>>2]=k;k=k+1|0}while((k|0)!=(l|0))}l=h+8|0;f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=-2096955388;f[h+4>>2]=g;SR(h,1.0,0);h=f[g>>2]|0;if(!(f[e>>2]|0)){if(!h){u=d;return}}else{g=f[i>>2]|0;i=0;do{l=f[h+(i<<2)>>2]|0;k=g+(l>>>5<<2)|0;f[k>>2]=f[k>>2]|1<<(l&31);i=i+1|0}while(i>>>0<(f[e>>2]|0)>>>0)}e=f[a>>2]|0;if((e|0)!=(h|0))f[a>>2]=e+(~((e+-4-h|0)>>>2)<<2);cYc(h);u=d;return}function eEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d+1|0;g=d;h=f[a>>2]|0;if(!h){i=a+4|0;j=a+8|0}else{k=a+4|0;l=f[k>>2]|0;if((l|0)==(h|0))m=h;else{n=l;while(1){l=n+-12|0;f[k>>2]=l;o=f[l>>2]|0;if(!o)p=l;else{l=n+-8|0;q=f[l>>2]|0;if((q|0)!=(o|0))f[l>>2]=q+(~((q+-4-o|0)>>>2)<<2);cYc(o);p=f[k>>2]|0}if((p|0)==(h|0))break;else n=p}m=f[a>>2]|0}cYc(m);m=a+8|0;f[m>>2]=0;f[k>>2]=0;f[a>>2]=0;i=k;j=m}f[a>>2]=f[c>>2];m=c+4|0;f[i>>2]=f[m>>2];i=c+8|0;f[j>>2]=f[i>>2];f[i>>2]=0;f[m>>2]=0;f[c>>2]=0;b[e>>0]=b[g>>0]|0;dvc(a+12|0,c+12|0,e);f[a+32>>2]=f[c+32>>2];e=a+36|0;g=c+36|0;m=f[e>>2]|0;i=a+40|0;if(!m)r=a+44|0;else{j=f[i>>2]|0;if((j|0)!=(m|0))f[i>>2]=j+(~((j+-4-m|0)>>>2)<<2);cYc(m);m=a+44|0;f[m>>2]=0;f[i>>2]=0;f[e>>2]=0;r=m}f[e>>2]=f[g>>2];e=c+40|0;f[i>>2]=f[e>>2];i=c+44|0;f[r>>2]=f[i>>2];f[i>>2]=0;f[e>>2]=0;f[g>>2]=0;f[a+48>>2]=f[c+48>>2];g=c+52|0;e=f[g+4>>2]|0;i=a+52|0;f[i>>2]=f[g>>2];f[i+4>>2]=e;e=a+60|0;i=c+60|0;g=f[e>>2]|0;r=a+64|0;if(!g){s=a+68|0;t=f[i>>2]|0;f[e>>2]=t;v=c+64|0;w=f[v>>2]|0;f[r>>2]=w;x=c+68|0;y=f[x>>2]|0;f[s>>2]=y;f[x>>2]=0;f[v>>2]=0;f[i>>2]=0;u=d;return a|0}m=f[r>>2]|0;if((m|0)!=(g|0))f[r>>2]=m+(~((m+-4-g|0)>>>2)<<2);cYc(g);g=a+68|0;f[g>>2]=0;f[r>>2]=0;f[e>>2]=0;s=g;t=f[i>>2]|0;f[e>>2]=t;v=c+64|0;w=f[v>>2]|0;f[r>>2]=w;x=c+68|0;y=f[x>>2]|0;f[s>>2]=y;f[x>>2]=0;f[v>>2]=0;f[i>>2]=0;u=d;return a|0}function fEc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d+8|0;g=d;h=d+4|0;f[g>>2]=b;i=f[a+56>>2]|0;if(!i)j=0;else{k=a+60|0;l=i+-4|0;m=0;n=1;o=0;p=c;while(1){if(m>>>0>l>>>0){f[e>>2]=0;o1c(e|0,p|0,i-m|0)|0;q=f[e>>2]|0}else q=f[p>>2]|0;c=f[(f[k>>2]|0)+(m>>>2<<2)>>2]|0;if(!c){r=n;s=o}else{t=c;c=o;v=n;while(1){w=t&0-t;x=(w&q|0?v:0)+c|0;t=w^t;w=v<<1;if(!t){r=w;s=x;break}else{c=x;v=w}}}m=m+4|0;if(m>>>0>=i>>>0){j=s;break}else{n=r;o=s;p=p+4|0}}}f[h>>2]=j;switch(f[a+32>>2]|0){case 0:{p=f[a>>2]|0;s=p+(j*12|0)+4|0;o=f[s>>2]|0;if((o|0)==(f[p+(j*12|0)+8>>2]|0)){P3(p+(j*12|0)|0,g);u=d;return}else{f[o>>2]=b;f[s>>2]=o+4;u=d;return}break}case 1:{o=(f[a+36>>2]|0)+(j>>>5<<2)|0;f[o>>2]=f[o>>2]|1<<(j&31);j=bvc(a+12|0,h)|0;o=j+4|0;s=f[o>>2]|0;if((s|0)==(f[j+8>>2]|0)){P3(j,g);u=d;return}else{f[s>>2]=f[g>>2];f[o>>2]=s+4;u=d;return}break}case 2:{s=bvc(a+12|0,h)|0;h=s+4|0;a=f[h>>2]|0;if((a|0)==(f[s+8>>2]|0)){P3(s,g);u=d;return}else{f[a>>2]=f[g>>2];f[h>>2]=a+4;u=d;return}break}default:{u=d;return}}}function gEc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=a+32|0;if(!(f[b>>2]|0))return;c=a+24|0;d=f[c>>2]|0;e=f[a+52>>2]|0;g=1<<e;if(d>>>0<=g>>>1>>>0){h=((f[a+4>>2]|0)-(f[a>>2]|0)|0)/12|0;if(!(e>>>0<33?1:((((d>>>0<h>>>0?h:d)*96|0)>>>0)/10|0)>>>0>=g>>>0)){f[b>>2]=2;d=f[a+36>>2]|0;h=(f[a+40>>2]|0)-d|0;e=h>>>2;if((h|0)<=0)return;g1c(d|0,0,(((e|0)==0?e^1073741823:1073741822)+e<<2)+8|0)|0;return}f[b>>2]=1;e=a+36|0;f[a+48>>2]=g;d=(g>>>5)+1|0;h=a+40|0;i=f[h>>2]|0;j=f[e>>2]|0;k=i-j>>2;l=j;j=i;if(d>>>0<=k>>>0)if(d>>>0<k>>>0?(m=l+(d<<2)|0,(j|0)!=(m|0)):0){n=j+(~((j+-4-m|0)>>>2)<<2)|0;f[h>>2]=n;o=l;p=n}else{o=l;p=i}else{oaa(e,d-k|0);o=f[e>>2]|0;p=f[h>>2]|0}h=p-o|0;p=h>>>2;if((h|0)>0)g1c(o|0,0,(((p|0)==0?p^1073741823:1073741822)+p<<2)+8|0)|0;p=f[a+20>>2]|0;if(!p)return;o=f[e>>2]|0;e=p;do{p=f[e+8>>2]|0;h=o+(p>>>5<<2)|0;f[h>>2]=f[h>>2]|1<<(p&31);e=f[e>>2]|0}while((e|0)!=0);return}f[b>>2]=0;b=a+4|0;e=f[b>>2]|0;o=f[a>>2]|0;p=(e-o|0)/12|0;h=o;o=e;if(g>>>0<=p>>>0){if(g>>>0<p>>>0?(e=h+(g*12|0)|0,(o|0)!=(e|0)):0){h=o;while(1){o=h+-12|0;f[b>>2]=o;k=f[o>>2]|0;if(!k)q=o;else{o=h+-8|0;d=f[o>>2]|0;if((d|0)!=(k|0))f[o>>2]=d+(~((d+-4-k|0)>>>2)<<2);cYc(k);q=f[b>>2]|0}if((q|0)==(e|0))break;else h=q}}}else avc(a,g-p|0);p=a+20|0;g=f[p>>2]|0;if(g|0){q=g;do{g=q;h=g+12|0;e=(f[a>>2]|0)+((f[g+8>>2]|0)*12|0)|0;if((e|0)!=(h|0))paa(e,f[h>>2]|0,f[g+16>>2]|0);q=f[q>>2]|0}while((q|0)!=0)}if(!(f[c>>2]|0))return;q=f[p>>2]|0;if(q|0){g=q;do{q=g;g=f[g>>2]|0;h=f[q+12>>2]|0;if(h|0){e=q+16|0;b=f[e>>2]|0;if((b|0)!=(h|0))f[e>>2]=b+(~((b+-4-h|0)>>>2)<<2);cYc(h)}cYc(q)}while((g|0)!=0)}f[p>>2]=0;p=f[a+16>>2]|0;if(p|0){g=a+12|0;a=0;do{f[(f[g>>2]|0)+(a<<2)>>2]=0;a=a+1|0}while((a|0)!=(p|0))}f[c>>2]=0;return}function hEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;if((e|0)==(c|0)){h=g;i=a;j=f[g>>2]|0;k=c;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}t=e;e=f[g>>2]|0;do{u=e+-72|0;v=t;t=t+-72|0;f[u>>2]=0;w=e+-68|0;f[w>>2]=0;f[e+-64>>2]=0;f[u>>2]=f[t>>2];u=v+-68|0;f[w>>2]=f[u>>2];w=v+-64|0;f[e+-64>>2]=f[w>>2];f[w>>2]=0;f[u>>2]=0;f[t>>2]=0;u=v+-60|0;w=f[u>>2]|0;f[u>>2]=0;u=v+-56|0;x=f[u>>2]|0;f[u>>2]=0;f[e+-60>>2]=w;f[e+-56>>2]=x;u=e+-52|0;y=v+-52|0;z=f[y>>2]|0;f[u>>2]=z;A=v+-48|0;B=f[A>>2]|0;f[e+-48>>2]=B;f[e+-44>>2]=f[v+-44>>2];C=w;if(B|0){B=f[z+4>>2]|0;z=x+-1|0;if(z&x)if(B>>>0<x>>>0)D=B;else D=(B>>>0)%(x>>>0)|0;else D=B&z;f[C+(D<<2)>>2]=u;f[y>>2]=0;f[A>>2]=0}f[e+-40>>2]=f[v+-40>>2];A=e+-36|0;y=v+-36|0;f[A>>2]=0;u=e+-32|0;f[u>>2]=0;f[e+-28>>2]=0;f[A>>2]=f[y>>2];A=v+-32|0;f[u>>2]=f[A>>2];u=v+-28|0;f[e+-28>>2]=f[u>>2];f[u>>2]=0;f[A>>2]=0;f[y>>2]=0;f[e+-24>>2]=f[v+-24>>2];y=v+-20|0;A=f[y+4>>2]|0;u=e+-20|0;f[u>>2]=f[y>>2];f[u+4>>2]=A;A=e+-12|0;u=v+-12|0;f[A>>2]=0;y=e+-8|0;f[y>>2]=0;f[e+-4>>2]=0;f[A>>2]=f[u>>2];A=v+-8|0;f[y>>2]=f[A>>2];y=v+-4|0;f[e+-4>>2]=f[y>>2];f[y>>2]=0;f[A>>2]=0;f[u>>2]=0;e=(f[g>>2]|0)+-72|0;f[g>>2]=e}while((t|0)!=(c|0));h=g;i=a;j=e;k=f[a>>2]|0;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}function iEc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+32|0;k=j;jvc(k,e);a:do if((c|0)>0){e=k+16|0;l=k+12|0;m=a+24|0;n=a+20|0;o=a+16|0;p=0;while(1){q=g+(p<<2)|0;r=f[e>>2]|0;s=f[l>>2]|0;t=(r|0)==(s|0);b:do if((p|0)>0){if(t){v=p;w=k;break a}else x=r;while(1){y=x;x=x+1|0;f[e>>2]=x;z=f[(f[k>>2]|0)+(y<<2)>>2]|0;if((z|0)<0){v=p;w=k;break a}y=f[d+(z<<2)>>2]|0;f[q>>2]=y;z=f[m>>2]|0;A=f[n>>2]|0;B=z+(Y(A,y)|0)|0;y=f[o>>2]|0;if(y|0){C=0;D=0;do{E=z+(Y(f[g+(C<<2)>>2]|0,A)|0)|0;F=0;G=0;do{F=(h[516481+((b[E+G>>0]^b[B+G>>0])&255)>>0]|0)+F|0;G=G+1|0}while((G|0)!=(y|0));D=(F|0)<1?1:D;C=C+1|0}while((C|0)!=(p|0));if(!(D&1))break b}if((x|0)==(s|0)){v=p;w=k;break a}}}else{if(t){v=p;w=k;break a}f[e>>2]=r+1;C=f[(f[k>>2]|0)+(r<<2)>>2]|0;if((C|0)<0){v=p;w=k;break a}f[q>>2]=f[d+(C<<2)>>2]}while(0);q=p+1|0;if((q|0)<(c|0))p=q;else{v=q;w=k;break}}}else{v=0;w=k}while(0);f[i>>2]=v;v=f[w>>2]|0;if(!v){u=j;return}w=k+4|0;k=f[w>>2]|0;if((k|0)!=(v|0))f[w>>2]=k+(~((k+-4-v|0)>>>2)<<2);cYc(v);u=j;return}function jEc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=OR()|0;k=j;l=f[k+4>>2]|0;m=x1c(f[k>>2]|0,0,-130063606,0)|0;k=d1c(m|0,J|0,l|0,0)|0;l=j;f[l>>2]=k;f[l+4>>2]=J;f[g>>2]=f[d+(~~(+(e|0)*(+(k&2147483647|0)*4.656612873077393e-10))<<2)>>2];if((c|0)<=1){n=1;f[i>>2]=n;return}k=(e|0)>0;l=a+24|0;j=a+20|0;m=a+16|0;a=1;while(1){if(!k){n=a;o=17;break}p=f[l>>2]|0;q=f[j>>2]|0;r=p+(Y(q,f[g>>2]|0)|0)|0;s=f[m>>2]|0;t=(a|0)>1;if(!s){u=0;o=5;break}else{v=0;w=0;x=-1;y=s}while(1){z=p+(Y(f[d+(v<<2)>>2]|0,q)|0)|0;A=0;B=0;do{A=(h[516481+((b[z+B>>0]^b[r+B>>0])&255)>>0]|0)+A|0;B=B+1|0}while((B|0)!=(s|0));a:do if(t){if(!y){B=1;C=A;while(1){D=(C|0)<0?C:0;B=B+1|0;if((B|0)==(a|0)){E=D;F=0;break a}else C=D}}else{G=1;H=A}while(1){C=p+(Y(q,f[g+(G<<2)>>2]|0)|0)|0;B=0;D=0;do{B=(h[516481+((b[z+D>>0]^b[C+D>>0])&255)>>0]|0)+B|0;D=D+1|0}while((D|0)!=(y|0));D=(B|0)<(H|0)?B:H;G=G+1|0;if((G|0)==(a|0)){E=D;F=y;break}else H=D}}else{E=A;F=y}while(0);A=(E|0)>(w|0);x=A?v:x;v=v+1|0;if((v|0)==(e|0))break;else{w=A?E:w;y=F}}if((x|0)==-1){n=a;o=17;break}f[g+(a<<2)>>2]=f[d+(x<<2)>>2];q=a+1|0;if((q|0)<(c|0))a=q;else{n=q;o=17;break}}if((o|0)==5){while(1){o=0;u=u+1|0;if((u|0)==(e|0)){n=a;break}else o=5}f[i>>2]=n;return}else if((o|0)==17){f[i>>2]=n;return}}function kEc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,K=0,L=0.0;j=bYc(e>>>0>1073741823?-1:e<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=d+(~~(+(e|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[g>>2]=f[m>>2];l=(e|0)>0;if(l){k=f[a+24>>2]|0;n=f[a+20>>2]|0;o=f[a+16>>2]|0;p=k+(Y(f[m>>2]|0,n)|0)|0;m=(o|0)==0;q=0;r=0.0;while(1){s=k+(Y(n,f[d+(q<<2)>>2]|0)|0)|0;if(m)t=0;else{u=0;v=0;while(1){w=(h[516481+((b[p+v>>0]^b[s+v>>0])&255)>>0]|0)+u|0;v=v+1|0;if((v|0)==(o|0)){t=w;break}else u=w}}u=Y(t,t)|0;f[j+(q<<2)>>2]=u;x=r+ +(u|0);q=q+1|0;if((q|0)==(e|0)){y=x;break}else r=x}}else y=0.0;if((c|0)<=1){z=1;f[i>>2]=z;dYc(j);return}q=e+-1|0;t=(e|0)>1;o=a+24|0;p=a+20|0;m=a+16|0;a=1;r=y;while(1){n=OR()|0;k=n;u=f[k+4>>2]|0;v=x1c(f[k>>2]|0,0,-130063606,0)|0;k=d1c(v|0,J|0,u|0,0)|0;u=n;f[u>>2]=k;f[u+4>>2]=J;a:do if(t){u=0;y=r*(+(k&2147483647|0)*4.656612873077393e-10)+0.0;while(1){x=+(f[j+(u<<2)>>2]|0);if(y<=x){A=u;break a}n=u+1|0;if((n|0)<(q|0)){u=n;y=y-x}else{A=n;break}}}else A=0;while(0);if(l){k=f[o>>2]|0;u=f[p>>2]|0;n=d+(A<<2)|0;v=f[n>>2]|0;s=k+(Y(v,u)|0)|0;w=f[m>>2]|0;if(!w){B=0;y=0.0;while(1){C=f[j+(B<<2)>>2]|0;x=y+ +(((C|0)<0?C:0)|0);B=B+1|0;if((B|0)==(e|0)){D=x;break}else y=x}}else{B=0;y=0.0;while(1){C=k+(Y(u,f[d+(B<<2)>>2]|0)|0)|0;E=0;F=0;do{E=(h[516481+((b[s+F>>0]^b[C+F>>0])&255)>>0]|0)+E|0;F=F+1|0}while((F|0)!=(w|0));F=Y(E,E)|0;C=f[j+(B<<2)>>2]|0;x=y+ +(((C|0)<(F|0)?C:F)|0);B=B+1|0;if((B|0)==(e|0)){D=x;break}else y=x}}f[g+(a<<2)>>2]=v;if(l){B=f[o>>2]|0;w=f[p>>2]|0;s=f[m>>2]|0;u=B+(Y(f[n>>2]|0,w)|0)|0;k=(s|0)==0;F=0;do{C=B+(Y(w,f[d+(F<<2)>>2]|0)|0)|0;if(k)G=0;else{H=0;I=0;while(1){K=(h[516481+((b[u+I>>0]^b[C+I>>0])&255)>>0]|0)+H|0;I=I+1|0;if((I|0)==(s|0)){G=K;break}else H=K}}H=Y(G,G)|0;I=j+(F<<2)|0;C=f[I>>2]|0;f[I>>2]=(C|0)<(H|0)?C:H;F=F+1|0}while((F|0)!=(e|0));L=D}else L=D}else{f[g+(a<<2)>>2]=f[d+(A<<2)>>2];L=0.0}a=a+1|0;if((a|0)==(c|0)){z=c;break}else r=L}f[i>>2]=z;dYc(j);return}function lEc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;j=bYc(e>>>0>1073741823?-1:e<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;n=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(n|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=d+(~~(+(e|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[g>>2]=f[m>>2];l=(e|0)>0;if(l){k=f[a+24>>2]|0;n=f[a+20>>2]|0;o=f[a+16>>2]|0;p=k+(Y(f[m>>2]|0,n)|0)|0;m=(o|0)==0;q=0;do{r=k+(Y(n,f[d+(q<<2)>>2]|0)|0)|0;if(m)s=0;else{t=0;u=0;while(1){v=(h[516481+((b[p+u>>0]^b[r+u>>0])&255)>>0]|0)+t|0;u=u+1|0;if((u|0)==(o|0)){s=v;break}else t=v}}f[j+(q<<2)>>2]=s;q=q+1|0}while((q|0)!=(e|0))}if((c|0)<=1){w=1;f[i>>2]=w;dYc(j);return}q=a+24|0;s=a+20|0;o=a+16|0;a=1;do{if(l){p=0;m=0;x=-1.0;n=0;while(1){k=f[j+(n<<2)>>2]|0;if(+(k|0)>+(p|0)*1.2999999523162842){t=f[q>>2]|0;u=f[s>>2]|0;r=t+(Y(f[d+(n<<2)>>2]|0,u)|0)|0;v=f[o>>2]|0;if(!v){y=0;z=0.0;while(1){A=f[j+(y<<2)>>2]|0;B=z+ +(((A|0)<0?A:0)|0);y=y+1|0;if((y|0)==(e|0)){C=B;break}else z=B}}else{y=0;z=0.0;while(1){A=t+(Y(u,f[d+(y<<2)>>2]|0)|0)|0;D=0;E=0;do{D=(h[516481+((b[r+E>>0]^b[A+E>>0])&255)>>0]|0)+D|0;E=E+1|0}while((E|0)!=(v|0));E=f[j+(y<<2)>>2]|0;B=z+ +(((E|0)<(D|0)?E:D)|0);y=y+1|0;if((y|0)==(e|0)){C=B;break}else z=B}}y=!(x<0.0)&!(C<=x);F=y?p:k;G=y?m:n;H=y?x:C}else{F=p;G=m;H=x}n=n+1|0;if((n|0)==(e|0))break;else{p=F;m=G;x=H}}m=d+(G<<2)|0;f[g+(a<<2)>>2]=f[m>>2];if(l){p=f[q>>2]|0;n=f[s>>2]|0;y=f[o>>2]|0;v=p+(Y(f[m>>2]|0,n)|0)|0;m=(y|0)==0;r=0;do{u=p+(Y(n,f[d+(r<<2)>>2]|0)|0)|0;if(m)I=0;else{t=0;E=0;while(1){A=(h[516481+((b[v+E>>0]^b[u+E>>0])&255)>>0]|0)+t|0;E=E+1|0;if((E|0)==(y|0)){I=A;break}else t=A}}t=j+(r<<2)|0;E=f[t>>2]|0;f[t>>2]=(E|0)<(I|0)?E:I;r=r+1|0}while((r|0)!=(e|0))}}else f[g+(a<<2)>>2]=f[d>>2];a=a+1|0}while((a|0)!=(c|0));w=c;f[i>>2]=w;dYc(j);return}function mEc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=175072;b=a+52|0;c=f[b>>2]|0;a:do if(c|0?(d=a+92|0,e=f[d>>2]|0,(e|0)>0):0){g=0;h=e;e=c;while(1){i=f[e+(g<<2)>>2]|0;if(!i)j=h;else{dYc(i);f[(f[b>>2]|0)+(g<<2)>>2]=0;j=f[d>>2]|0}i=g+1|0;if((i|0)>=(j|0))break a;g=i;h=j;e=f[b>>2]|0}}while(0);j=f[a+48>>2]|0;if(j|0)dYc(j);j=f[b>>2]|0;if(j|0)dYc(j);j=a+64|0;b=f[j>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;kIc(b);f[j>>2]=c}while((c|0)!=0)}Ptc(a+28|0,f[a+32>>2]|0);return}function nEc(a){a=a|0;mEc(a);cYc(a);return}function oEc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=a+88|0;if((f[b>>2]|0)<2){c=af(60)|0;Jtc(c,513040);ig(c|0,22128,1)}c=a+52|0;d=f[c>>2]|0;e=a+92|0;g=f[e>>2]|0;a:do if(!d)h=g;else{if((g|0)>0){i=0;j=d;k=g}else return;while(1){l=f[j+(i<<2)>>2]|0;if(!l)m=k;else{dYc(l);f[(f[c>>2]|0)+(i<<2)>>2]=0;m=f[e>>2]|0}l=i+1|0;if((l|0)>=(m|0)){h=m;break a}i=l;j=f[c>>2]|0;k=m}}while(0);if((h|0)<=0)return;h=a+40|0;m=a+60|0;k=a+80|0;j=f[46249]|0;i=a+64|0;g=a+68|0;d=a+48|0;l=a+76|0;n=0;do{o=f[h>>2]|0;p=bYc(o>>>0>1073741823?-1:o<<2)|0;f[(f[c>>2]|0)+(n<<2)>>2]=p;if(!o)q=0;else{o=f[(f[c>>2]|0)+(n<<2)>>2]|0;p=0;do{f[o+(p<<2)>>2]=p;p=p+1|0;r=f[h>>2]|0}while(p>>>0<r>>>0);q=r}p=f[m>>2]|0;do if((p|0)<32){f[k>>2]=(f[k>>2]|0)+p;o=jIc(8192)|0;if(!o){eKc(513012,27,1,j)|0;s=0;t=f[h>>2]|0;break}else{f[o>>2]=f[i>>2];f[i>>2]=o;f[m>>2]=8188;r=o+4|0;f[g>>2]=r;u=r;v=8188;w=19;break}}else{u=f[g>>2]|0;v=p;w=19}while(0);if((w|0)==19){w=0;f[g>>2]=u+32;f[m>>2]=v+-32;f[l>>2]=(f[l>>2]|0)+32;s=u;t=q}f[(f[d>>2]|0)+(n<<2)>>2]=s;EEc(a,f[(f[d>>2]|0)+(n<<2)>>2]|0,f[(f[c>>2]|0)+(n<<2)>>2]|0,t,f[b>>2]|0,0);n=n+1|0}while((n|0)<(f[e>>2]|0));return}function pEc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;i=u;u=u+48|0;j=i+12|0;k=i;l=j+4|0;m=j+8|0;n=j+20|0;o=j+16|0;p=j+12|0;f[j>>2]=175032;f[j+24>>2]=g;q=j+12|0;f[n>>2]=0;f[q>>2]=o;f[o>>2]=0;f[m>>2]=2147483647;b[l>>0]=0;if(!(f[c>>2]|0)){r=0;f[j>>2]=174992;s=j+12|0;NDc(s,r);u=i;return}t=c+12|0;v=c+8|0;w=k+11|0;x=k+6|0;y=h+4|0;z=d+12|0;A=d+8|0;d=e+12|0;B=e+8|0;e=(g|0)<0;C=(g|0)!=0;D=0;E=0;while(1){NDc(q,E);f[n>>2]=0;f[q>>2]=o;f[o>>2]=0;f[m>>2]=2147483647;b[l>>0]=0;F=(f[t>>2]|0)+(Y(f[v>>2]|0,D)|0)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,F,h);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[w>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[x>>0]=0;F=auc(h,k)|0;if((F|0)==(y|0))G=1;else{H=F+28|0;I=f[H>>2]|0;J=(_i[f[(f[I>>2]|0)+28>>2]&2047](I)|0)+4|0;if((f[J>>2]|0)!=(f[6363]|0)){K=6;break}J=f[H>>2]|0;H=Mi[f[(f[J>>2]|0)+20>>2]&1023](J,F+32|0)|0;G=b[H>>0]|0}if((b[w>>0]|0)<0)cYc(f[k>>2]|0);H=(f[z>>2]|0)+((Y(f[A>>2]|0,D)|0)<<2)|0;F=(f[d>>2]|0)+((Y(f[B>>2]|0,D)|0)<<2)|0;do if(!(G<<24>>24)){J=f[p>>2]|0;if(e){if((J|0)==(o|0))break;else{L=H;M=F;N=J}while(1){f[L>>2]=f[N+20>>2];f[M>>2]=f[N+16>>2];I=f[N+4>>2]|0;if(!I){O=N+8|0;P=f[O>>2]|0;if((f[P>>2]|0)==(N|0))Q=P;else{P=O;do{O=f[P>>2]|0;P=O+8|0;R=f[P>>2]|0}while((f[R>>2]|0)!=(O|0));Q=R}}else{P=I;while(1){R=f[P>>2]|0;if(!R)break;else P=R}Q=P}if((Q|0)==(o|0))break;else{L=L+4|0;M=M+4|0;N=Q}}}else{if(C&(J|0)!=(o|0)){S=0;T=F;U=H;V=J}else break;while(1){f[U>>2]=f[V+20>>2];f[T>>2]=f[V+16>>2];I=f[V+4>>2]|0;if(!I){R=V+8|0;O=f[R>>2]|0;if((f[O>>2]|0)==(V|0))W=O;else{O=R;do{R=f[O>>2]|0;O=R+8|0;X=f[O>>2]|0}while((f[X>>2]|0)!=(R|0));W=X}}else{O=I;while(1){P=f[O>>2]|0;if(!P)break;else O=P}W=O}S=S+1|0;if(!((S|0)<(g|0)&(W|0)!=(o|0)))break;else{T=T+4|0;U=U+4|0;V=W}}}}else ei[f[(f[j>>2]|0)+24>>2]&511](j,H,F,g);while(0);D=D+1|0;F=f[o>>2]|0;if(D>>>0>=(f[c>>2]|0)>>>0){r=F;K=3;break}else E=F}if((K|0)==3){f[j>>2]=174992;s=j+12|0;NDc(s,r);u=i;return}else if((K|0)==6)ig(af(1)|0,22144,0)}function qEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;eKc(a+88|0,4,1,b)|0;c=a+92|0;eKc(c,4,1,b)|0;eKc(a+96|0,4,1,b)|0;eKc(a+100|0,4,1,b)|0;eKc(a+84|0,4,1,b)|0;if((f[c>>2]|0)<=0)return;d=a+52|0;e=a+40|0;g=a+48|0;h=0;do{eKc(f[(f[d>>2]|0)+(h<<2)>>2]|0,4,f[e>>2]|0,b)|0;DEc(a,b,f[(f[g>>2]|0)+(h<<2)>>2]|0,h);h=h+1|0}while((h|0)<(f[c>>2]|0));return}function rEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;i=a+52|0;j=f[i>>2]|0;a:do if(j|0?(k=a+92|0,l=f[k>>2]|0,(l|0)>0):0){m=0;n=j;o=l;while(1){l=f[n+(m<<2)>>2]|0;if(!l)p=o;else{dYc(l);f[(f[i>>2]|0)+(m<<2)>>2]=0;p=f[k>>2]|0}l=m+1|0;if((l|0)>=(p|0))break a;m=l;n=f[i>>2]|0;o=p}}while(0);p=a+48|0;j=f[p>>2]|0;if(j|0)dYc(j);j=f[i>>2]|0;if(j|0)dYc(j);j=a+88|0;if((NLc(j,4,1,c)|0)!=1){o=af(60)|0;Jtc(o,511860);ig(o|0,22128,1)}o=a+92|0;if((NLc(o,4,1,c)|0)!=1){n=af(60)|0;Jtc(n,511860);ig(n|0,22128,1)}n=a+96|0;if((NLc(n,4,1,c)|0)!=1){m=af(60)|0;Jtc(m,511860);ig(m|0,22128,1)}m=a+100|0;if((NLc(m,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if((NLc(a+84|0,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=f[o>>2]|0;l=k>>>0>1073741823?-1:k<<2;q=bYc(l)|0;f[i>>2]=q;r=bYc(l)|0;f[p>>2]=r;b:do if((k|0)>0){r=a+40|0;l=0;s=q;while(1){t=f[r>>2]|0;v=bYc(t>>>0>1073741823?-1:t<<2)|0;f[s+(l<<2)>>2]=v;if((NLc(f[(f[i>>2]|0)+(l<<2)>>2]|0,4,t,c)|0)!=(t|0))break;CEc(a,c,(f[p>>2]|0)+(l<<2)|0,l);t=l+1|0;if((t|0)>=(f[o>>2]|0))break b;l=t;s=f[i>>2]|0}s=af(60)|0;Jtc(s,511860);ig(s|0,22128,1)}while(0);i=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=i;i=a+28|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;p=h+11|0;b[p>>0]=9;c=h;q=512094;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[h+9>>0]=0;s=Ntc(i,e,h)|0;l=f[s>>2]|0;if(!l){r=$Xc(36)|0;t=r+16|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];f[t+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;t=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=t;f[s>>2]=r;t=f[f[i>>2]>>2]|0;if(!t)w=r;else{f[i>>2]=t;w=f[s>>2]|0}UQ(f[a+32>>2]|0,w);w=a+36|0;f[w>>2]=(f[w>>2]|0)+1;x=r}else x=l;l=x+28|0;r=f[l>>2]|0;w=x+32|0;mi[f[f[r>>2]>>2]&2047](r,w);f[l>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,w);if((b[p>>0]|0)<0)cYc(f[h>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=9;c=g;q=512667;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[g+9>>0]=0;p=Ntc(i,e,g)|0;w=f[p>>2]|0;if(!w){l=$Xc(36)|0;r=l+16|0;f[r>>2]=f[g>>2];f[r+4>>2]=f[g+4>>2];f[r+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;r=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=r;f[p>>2]=l;r=f[f[i>>2]>>2]|0;if(!r)y=l;else{f[i>>2]=r;y=f[p>>2]|0}UQ(f[a+32>>2]|0,y);y=a+36|0;f[y>>2]=(f[y>>2]|0)+1;z=l}else z=w;w=z+28|0;l=f[w>>2]|0;y=z+32|0;mi[f[f[l>>2]>>2]&2047](l,y);f[w>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,j,y);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=5;b[g>>0]=b[512723]|0;b[g+1>>0]=b[512724]|0;b[g+2>>0]=b[512725]|0;b[g+3>>0]=b[512726]|0;b[g+4>>0]=b[512727]|0;b[g+5>>0]=0;y=Ntc(i,e,g)|0;j=f[y>>2]|0;if(!j){w=$Xc(36)|0;l=w+16|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[l+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[w+28>>2]=172888;f[w+32>>2]=0;l=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=l;f[y>>2]=w;l=f[f[i>>2]>>2]|0;if(!l)A=w;else{f[i>>2]=l;A=f[y>>2]|0}UQ(f[a+32>>2]|0,A);A=a+36|0;f[A>>2]=(f[A>>2]|0)+1;B=w}else B=j;j=B+28|0;w=f[j>>2]|0;A=B+32|0;mi[f[f[w>>2]>>2]&2047](w,A);f[j>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,o,A);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;c=h;q=512677;k=c+12|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[h+12>>0]=0;h=Ntc(i,e,g)|0;A=f[h>>2]|0;if(!A){o=$Xc(36)|0;j=o+16|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[o+28>>2]=172888;f[o+32>>2]=0;j=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=j;f[h>>2]=o;j=f[f[i>>2]>>2]|0;if(!j)C=o;else{f[i>>2]=j;C=f[h>>2]|0}UQ(f[a+32>>2]|0,C);C=a+36|0;f[C>>2]=(f[C>>2]|0)+1;D=o}else D=A;A=D+28|0;o=f[A>>2]|0;C=D+32|0;mi[f[f[o>>2]>>2]&2047](o,C);f[A>>2]=173316;Ti[f[(f[43329]|0)+4>>2]&511](173316,n,C);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;C=g+11|0;b[C>>0]=9;c=g;q=512729;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[g+9>>0]=0;q=Ntc(i,e,g)|0;c=f[q>>2]|0;if(!c){k=$Xc(36)|0;n=k+16|0;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[k+28>>2]=172888;f[k+32>>2]=0;n=f[e>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=n;f[q>>2]=k;n=f[f[i>>2]>>2]|0;if(!n)E=k;else{f[i>>2]=n;E=f[q>>2]|0}UQ(f[a+32>>2]|0,E);E=a+36|0;f[E>>2]=(f[E>>2]|0)+1;F=k}else F=c;c=F+28|0;k=f[c>>2]|0;E=F+32|0;mi[f[f[k>>2]>>2]&2047](k,E);f[c>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,m,E);if((b[C>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function sEc(a){a=a|0;return f[a+40>>2]|0}function tEc(a){a=a|0;return f[a+44>>2]|0}function uEc(a){a=a|0;return (f[a+80>>2]|0)+(f[a+76>>2]|0)+(f[a+84>>2]|0)|0}function vEc(a){a=a|0;return 5}function wEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+28>>2]|0;i=b+32|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function xEc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+12|0;i=g+24|0;j=g+8|0;k=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;m=auc(e,h)|0;do if((m|0)!=(e+4|0)){n=m+28|0;o=f[n>>2]|0;p=(_i[f[(f[o>>2]|0)+28>>2]&2047](o)|0)+4|0;if((f[p>>2]|0)==(f[6379]|0)){p=f[n>>2]|0;n=Mi[f[(f[p>>2]|0)+20>>2]&1023](p,m+32|0)|0;q=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else q=32;while(0);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(20)|0;l=a+40|0;m=f[l>>2]|0;f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[h+12>>2]=m;yEc(h,m);f[h+16>>2]=0;m=f[l>>2]|0;f[i>>2]=0;l=i+4|0;f[l>>2]=0;n=i+8|0;f[n>>2]=0;if(m|0){if((m|0)<0)kWc(i);p=((m+-1|0)>>>5)+1|0;o=$Xc(p<<2)|0;f[i>>2]=o;f[n>>2]=p;f[l>>2]=m;l=m>>>5;g1c(o|0,0,l<<2|0)|0;p=m-(l<<5)|0;m=o+(l<<2)|0;if(p|0)f[m>>2]=f[m>>2]&~(-1>>>(32-p|0))}f[j>>2]=0;p=a+92|0;if((f[p>>2]|0)>0){m=a+48|0;l=0;do{zEc(a,f[(f[m>>2]|0)+(l<<2)>>2]|0,c,d,j,q,h,i);l=l+1|0}while((l|0)<(f[p>>2]|0))}while(1){if(!(AEc(h,k)|0))break;if((f[j>>2]|0)>=(q|0)?_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0:0)break;zEc(a,f[k>>2]|0,c,d,j,q,h,i)}q=f[h>>2]|0;if(q|0){j=f[e>>2]|0;if((j|0)!=(q|0))f[e>>2]=j+(~((j+-8-q|0)>>>3)<<3);cYc(q)}cYc(h);h=f[i>>2]|0;if(!h){u=g;return}cYc(h);u=g;return}function yEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function zEc(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=u;u=u+16|0;m=l;n=c+8|0;o=f[n>>2]|0;if(!o){if((f[g>>2]|0)>=(i|0)?_i[f[(f[d>>2]|0)+8>>2]&2047](d)|0:0){u=l;return}p=c+4|0;q=f[p>>2]|0;if((q|0)<=0){u=l;return}r=c+12|0;c=a+24|0;s=a+20|0;t=a+44|0;v=0;w=q;q=f[k>>2]|0;while(1){x=f[(f[r>>2]|0)+(v<<2)>>2]|0;y=x>>>5;z=1<<(x&31);if(!(z&f[q+(y<<2)>>2])){A=(f[c>>2]|0)+(Y(f[s>>2]|0,x)|0)|0;B=f[t>>2]|0;if(!B)C=0;else{D=0;E=0;while(1){F=(h[516481+((b[e+E>>0]^b[A+E>>0])&255)>>0]|0)+D|0;E=E+1|0;if((E|0)==(B|0)){C=F;break}else D=F}}Ti[f[(f[d>>2]|0)+12>>2]&511](d,C,x);D=f[k>>2]|0;B=D+(y<<2)|0;f[B>>2]=f[B>>2]|z;f[g>>2]=(f[g>>2]|0)+1;G=D;H=f[p>>2]|0}else{G=q;H=w}v=v+1|0;if((v|0)>=(H|0))break;else{w=H;q=G}}u=l;return}G=a+88|0;q=f[G>>2]|0;H=bYc(q>>>0>1073741823?-1:q<<2)|0;w=f[a+24>>2]|0;v=f[a+20>>2]|0;p=w+(Y(v,f[f[o>>2]>>2]|0)|0)|0;C=f[a+44>>2]|0;t=(C|0)==0;if(t)I=0;else{s=0;c=0;while(1){r=(h[516481+((b[p+c>>0]^b[e+c>>0])&255)>>0]|0)+s|0;c=c+1|0;if((c|0)==(C|0)){I=r;break}else s=r}}f[H>>2]=I;if((q|0)>1){I=1;s=0;while(1){c=w+(Y(v,f[f[o+(I<<2)>>2]>>2]|0)|0)|0;if(t)J=0;else{p=0;r=0;while(1){D=(h[516481+((b[c+r>>0]^b[e+r>>0])&255)>>0]|0)+p|0;r=r+1|0;if((r|0)==(C|0)){J=D;break}else p=D}}f[H+(I<<2)>>2]=J;p=(J|0)<(f[H+(s<<2)>>2]|0)?I:s;I=I+1|0;if((I|0)>=(q|0)){K=p;break}else s=p}}else K=0;if((q|0)>0){s=m+4|0;I=j+16|0;J=j+12|0;C=j+4|0;t=j+8|0;o=0;v=q;while(1){if((o|0)==(K|0))L=v;else{q=f[H+(o<<2)>>2]|0;f[m>>2]=f[(f[n>>2]|0)+(o<<2)>>2];f[s>>2]=q;if((f[I>>2]|0)==(f[J>>2]|0))M=v;else{q=f[C>>2]|0;if((q|0)==(f[t>>2]|0)){BEc(j,m);N=f[C>>2]|0}else{w=m;p=f[w+4>>2]|0;r=q;f[r>>2]=f[w>>2];f[r+4>>2]=p;p=(f[C>>2]|0)+8|0;f[C>>2]=p;N=p}p=f[j>>2]|0;r=N-p|0;if((r|0)>8?(w=((r>>>3)+-2|0)/2|0,(f[N+-4>>2]|0)<(f[p+(w<<3)+4>>2]|0)):0){r=N+-8|0;q=r;c=f[q>>2]|0;z=f[q+4>>2]|0;q=w;w=r;do{r=w;w=p+(q<<3)|0;y=w;x=f[y+4>>2]|0;D=r;f[D>>2]=f[y>>2];f[D+4>>2]=x;if(!q)break;q=(q+-1|0)/2|0}while((z|0)<(f[p+(q<<3)+4>>2]|0));q=w;f[q>>2]=c;f[q+4>>2]=z}f[I>>2]=(f[I>>2]|0)+1;M=f[G>>2]|0}L=M}o=o+1|0;if((o|0)>=(L|0))break;else v=L}}dYc(H);zEc(a,f[(f[n>>2]|0)+(K<<2)>>2]|0,d,e,g,i,j,k);u=l;return}function AEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+16|0;if(!(f[c>>2]|0)){d=0;return d|0}e=f[a>>2]|0;g=f[e+4>>2]|0;h=b;f[h>>2]=f[e>>2];f[h+4>>2]=g;g=f[a>>2]|0;h=a+4|0;a=f[h>>2]|0;e=a-g|0;b=e>>3;if(((e|0)>8?(e=a+-8|0,a=g,i=f[a>>2]|0,j=f[a+4>>2]|0,a=e,k=f[a+4>>2]|0,l=g,f[l>>2]=f[a>>2],f[l+4>>2]=k,k=e,f[k>>2]=i,f[k+4>>2]=j,j=b+-1|0,(b|0)!=2):0)?(k=b+-3|0,b=(k|0)/2|0,(k|0)>=-1):0){k=g+8|0;if((j|0)>2){i=(f[g+20>>2]|0)<(f[g+12>>2]|0);m=i?2:1;n=i?g+16|0:k}else{m=1;n=k}if((f[g+4>>2]|0)>=(f[n+4>>2]|0)){k=g;i=f[k>>2]|0;e=f[k+4>>2]|0;k=m;m=n;n=g;while(1){l=n;n=m;a=n;o=f[a+4>>2]|0;p=l;f[p>>2]=f[a>>2];f[p+4>>2]=o;if((b|0)<(k|0))break;o=k<<1|1;p=g+(o<<3)|0;a=p;l=o+1|0;if((l|0)<(j|0)){q=p+8|0;p=(f[q+4>>2]|0)<(f[g+(o<<3)+4>>2]|0);r=p?l:o;s=p?q:a}else{r=o;s=a}if((e|0)<(f[s+4>>2]|0))break;else{k=r;m=s}}s=n;f[s>>2]=i;f[s+4>>2]=e}}f[h>>2]=(f[h>>2]|0)+-8;f[c>>2]=(f[c>>2]|0)+-1;d=1;return d|0}function BEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function CEc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;h=a+60|0;i=f[h>>2]|0;do if((i|0)<32){j=a+80|0;f[j>>2]=(f[j>>2]|0)+i;j=jIc(8192)|0;if(!j){eKc(513012,27,1,f[46249]|0)|0;k=0;break}else{l=a+64|0;f[j>>2]=f[l>>2];f[l>>2]=j;f[h>>2]=8188;l=j+4|0;j=a+68|0;f[j>>2]=l;m=j;n=l;o=8156;p=6;break}}else{l=a+68|0;m=l;n=f[l>>2]|0;o=i+-32|0;p=6}while(0);if((p|0)==6){f[m>>2]=n+32;f[h>>2]=o;o=a+76|0;f[o>>2]=(f[o>>2]|0)+32;k=n}f[c>>2]=k;if((NLc(k,20,1,b)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if(!(f[(f[c>>2]|0)+8>>2]|0)){if((NLc(g,4,1,b)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}f[(f[c>>2]|0)+12>>2]=(f[(f[a+52>>2]|0)+(d<<2)>>2]|0)+(f[g>>2]<<2);u=e;return}g=a+88|0;k=(f[g>>2]<<2)+15&-16;n=f[h>>2]|0;do if((k|0)>(n|0)){o=a+80|0;f[o>>2]=(f[o>>2]|0)+n;o=(k|4)+15|0;m=o>>>0>8192?o:8192;o=jIc(m)|0;if(!o){eKc(513012,27,1,f[46249]|0)|0;q=0;break}else{i=a+64|0;f[o>>2]=f[i>>2];f[i>>2]=o;i=m+-4|0;f[h>>2]=i;m=o+4|0;o=a+68|0;f[o>>2]=m;r=o;s=m;t=i;p=18;break}}else{i=a+68|0;r=i;s=f[i>>2]|0;t=n;p=18}while(0);if((p|0)==18){f[r>>2]=s+k;f[h>>2]=t-k;t=a+76|0;f[t>>2]=(f[t>>2]|0)+k;q=s}f[(f[c>>2]|0)+8>>2]=q;if((f[g>>2]|0)>0)v=0;else{u=e;return}do{CEc(a,b,(f[(f[c>>2]|0)+8>>2]|0)+(v<<2)|0,d);v=v+1|0}while((v|0)<(f[g>>2]|0));u=e;return}function DEc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;eKc(c,20,1,b)|0;h=c+8|0;i=f[h>>2]|0;if(!i){f[g>>2]=(f[c+12>>2]|0)-(f[(f[a+52>>2]|0)+(d<<2)>>2]|0)>>2;eKc(g,4,1,b)|0;u=e;return}g=a+88|0;if((f[g>>2]|0)<=0){u=e;return}DEc(a,b,f[i>>2]|0,d);if((f[g>>2]|0)>1)j=1;else{u=e;return}do{DEc(a,b,f[(f[h>>2]|0)+(j<<2)>>2]|0,d);j=j+1|0}while((j|0)<(f[g>>2]|0));u=e;return}function EEc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=u;u=u+32|0;i=h;j=h+20|0;k=h+8|0;l=h+4|0;f[b+4>>2]=d;f[b+16>>2]=g;if((f[a+100>>2]|0)>(d|0)){f[b+12>>2]=c;mMc(c,c+(d<<2)|0,i);f[b+8>>2]=0;u=h;return}f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;do if(e)if(e>>>0>1073741823)kWc(j);else{n=e<<2;o=$Xc(n)|0;f[j>>2]=o;p=o+(e<<2)|0;f[j+8>>2]=p;g1c(o|0,0,n|0)|0;f[m>>2]=p;q=o;break}else q=0;while(0);f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;do if(d|0)if(d>>>0>1073741823)kWc(k);else{p=d<<2;n=$Xc(p)|0;f[k>>2]=n;r=n+(d<<2)|0;f[k+8>>2]=r;g1c(n|0,0,p|0)|0;f[o>>2]=r;break}while(0);r=f[a+4>>2]|0;p=f[a+8>>2]|0;n=a+(p>>1)|0;if(!(p&1))s=r;else s=f[(f[n>>2]|0)+r>>2]|0;Fh[s&255](n,e,c,d,q,l);q=f[l>>2]|0;if((q|0)<(e|0)){f[b+12>>2]=c;mMc(c,c+(d<<2)|0,i);f[b+8>>2]=0}else{FEc(a,c,d,f[j>>2]|0,q,f[k>>2]|0,i);i=(e<<2)+15&-16;q=a+60|0;l=f[q>>2]|0;do if((i|0)>(l|0)){n=a+80|0;f[n>>2]=(f[n>>2]|0)+l;n=(i|4)+15|0;s=n>>>0>8192?n:8192;n=jIc(s)|0;if(!n){eKc(513012,27,1,f[46249]|0)|0;t=0;break}else{r=a+64|0;f[n>>2]=f[r>>2];f[r>>2]=n;r=s+-4|0;f[q>>2]=r;s=n+4|0;n=a+68|0;f[n>>2]=s;v=n;w=s;x=r;y=21;break}}else{r=a+68|0;v=r;w=f[r>>2]|0;x=l;y=21}while(0);if((y|0)==21){f[v>>2]=w+i;f[q>>2]=x-i;x=a+76|0;f[x>>2]=(f[x>>2]|0)+i;t=w}w=b+8|0;f[w>>2]=t;a:do if((e|0)>0){t=a+80|0;b=f[46249]|0;i=a+64|0;x=a+68|0;v=g+1|0;l=a+76|0;if((d|0)>0){z=0;A=0}else{r=0;while(1){s=f[q>>2]|0;do if((s|0)<32){f[t>>2]=(f[t>>2]|0)+s;n=jIc(8192)|0;if(!n){eKc(513012,27,1,b)|0;B=0;break}else{f[n>>2]=f[i>>2];f[i>>2]=n;f[q>>2]=8188;p=n+4|0;f[x>>2]=p;C=p;D=8188;y=41;break}}else{C=f[x>>2]|0;D=s;y=41}while(0);if((y|0)==41){y=0;f[x>>2]=C+32;f[q>>2]=D+-32;f[l>>2]=(f[l>>2]|0)+32;B=C}f[(f[w>>2]|0)+(r<<2)>>2]=B;s=(f[w>>2]|0)+(r<<2)|0;p=f[s>>2]|0;f[p>>2]=f[(f[j>>2]|0)+(r<<2)>>2];f[p+12>>2]=0;EEc(a,f[s>>2]|0,c,0,e,v);r=r+1|0;if((r|0)>=(e|0))break a}}while(1){r=f[k>>2]|0;s=0;p=A;while(1){n=r+(s<<2)|0;if((f[n>>2]|0)==(z|0)){E=c+(s<<2)|0;F=c+(p<<2)|0;G=f[E>>2]|0;f[E>>2]=f[F>>2];f[F>>2]=G;G=r+(p<<2)|0;F=f[n>>2]|0;f[n>>2]=f[G>>2];f[G>>2]=F;H=p+1|0}else H=p;s=s+1|0;if((s|0)==(d|0))break;else p=H}p=f[q>>2]|0;do if((p|0)<32){f[t>>2]=(f[t>>2]|0)+p;s=jIc(8192)|0;if(!s){eKc(513012,27,1,b)|0;I=0;break}else{f[s>>2]=f[i>>2];f[i>>2]=s;f[q>>2]=8188;r=s+4|0;f[x>>2]=r;J=r;K=8188;y=28;break}}else{J=f[x>>2]|0;K=p;y=28}while(0);if((y|0)==28){y=0;f[x>>2]=J+32;f[q>>2]=K+-32;f[l>>2]=(f[l>>2]|0)+32;I=J}f[(f[w>>2]|0)+(z<<2)>>2]=I;p=(f[w>>2]|0)+(z<<2)|0;r=f[p>>2]|0;f[r>>2]=f[(f[j>>2]|0)+(z<<2)>>2];f[r+12>>2]=0;EEc(a,f[p>>2]|0,c+(A<<2)|0,H-A|0,e,v);z=z+1|0;if((z|0)>=(e|0))break;else A=H}}while(0)}H=f[k>>2]|0;if(H|0){k=f[o>>2]|0;if((k|0)!=(H|0))f[o>>2]=k+(~((k+-4-H|0)>>>2)<<2);cYc(H)}H=f[j>>2]|0;if(H|0){j=f[m>>2]|0;if((j|0)!=(H|0))f[m>>2]=j+(~((j+-4-H|0)>>>2)<<2);cYc(H)}u=h;return}function FEc(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f[j>>2]=0;if((d|0)<=0)return;k=a+20|0;l=a+44|0;m=f[a+24>>2]|0;if((g|0)>1)n=0;else{a=0;do{o=f[k>>2]|0;p=m+(Y(o,f[c+(a<<2)>>2]|0)|0)|0;q=m+(Y(f[e>>2]|0,o)|0)|0;o=f[l>>2]|0;if(!o)r=0;else{s=0;t=0;while(1){u=(h[516481+((b[q+t>>0]^b[p+t>>0])&255)>>0]|0)+s|0;t=t+1|0;if((t|0)==(o|0)){r=u;break}else s=u}}f[i+(a<<2)>>2]=0;f[j>>2]=(f[j>>2]|0)+r;a=a+1|0}while((a|0)!=(d|0));return}do{a=f[k>>2]|0;r=m+(Y(a,f[c+(n<<2)>>2]|0)|0)|0;s=m+(Y(f[e>>2]|0,a)|0)|0;a=f[l>>2]|0;if(!a)v=0;else{o=0;t=0;while(1){p=(h[516481+((b[s+t>>0]^b[r+t>>0])&255)>>0]|0)+o|0;t=t+1|0;if((t|0)==(a|0)){v=p;break}else o=p}}o=i+(n<<2)|0;f[o>>2]=0;a=1;t=v;while(1){s=m+(Y(f[k>>2]|0,f[e+(a<<2)>>2]|0)|0)|0;p=f[l>>2]|0;if(!p)w=0;else{q=0;u=0;while(1){x=(h[516481+((b[s+u>>0]^b[r+u>>0])&255)>>0]|0)+q|0;u=u+1|0;if((u|0)==(p|0)){w=x;break}else q=x}}if((t|0)>(w|0)){f[o>>2]=a;y=w}else y=t;a=a+1|0;if((a|0)==(g|0))break;else t=y}f[j>>2]=(f[j>>2]|0)+y;n=n+1|0}while((n|0)!=(d|0));return}function GEc(a){a=a|0;f[a>>2]=174832;Ptc(a+20|0,f[a+24>>2]|0);return}function HEc(a){a=a|0;f[a>>2]=174832;Ptc(a+20|0,f[a+24>>2]|0);cYc(a);return}function IEc(a){a=a|0;return}function JEc(a,b){a=a|0;b=b|0;return}function KEc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+32|0;d=c+16|0;e=c+12|0;g=c;h=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[e>>2]=h;h=a+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=g+11|0;b[i>>0]=9;j=g;k=512094;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[g+9>>0]=0;k=Ntc(h,d,g)|0;j=f[k>>2]|0;if(!j){l=$Xc(36)|0;m=l+16|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;m=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=m;f[k>>2]=l;m=f[f[h>>2]>>2]|0;if(!m)n=l;else{f[h>>2]=m;n=f[k>>2]|0}UQ(f[a+24>>2]|0,n);n=a+28|0;f[n>>2]=(f[n>>2]|0)+1;o=l}else o=j;j=o+28|0;l=f[j>>2]|0;n=o+32|0;mi[f[f[l>>2]>>2]&2047](l,n);f[j>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,e,n);if((b[i>>0]|0)>=0){u=c;return}cYc(f[g>>2]|0);u=c;return}function LEc(a){a=a|0;return f[a+4>>2]|0}function MEc(a){a=a|0;return f[a+8>>2]|0}function NEc(a){a=a|0;return 0}function OEc(a){a=a|0;return 0}function PEc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+20>>2]|0;i=b+24|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function QEc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a+4|0;if(!(f[e>>2]|0))return;g=a+8|0;i=0;j=f[a+16>>2]|0;a=f[g>>2]|0;while(1){if(!a)k=0;else{l=0;m=0;while(1){n=(h[516481+((b[d+m>>0]^b[j+m>>0])&255)>>0]|0)+l|0;m=m+1|0;if((m|0)==(a|0)){k=n;break}else l=n}}Ti[f[(f[c>>2]|0)+12>>2]&511](c,k,i);i=i+1|0;l=f[g>>2]|0;if(i>>>0>=(f[e>>2]|0)>>>0)break;else{j=j+l|0;a=l}}return}function REc(a){a=a|0;var b=0;f[a>>2]=174772;b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);return}function SEc(a){a=a|0;var b=0;f[a>>2]=174772;b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);cYc(a);return}function TEc(a){a=a|0;var c=0;if(b[a+8>>0]|0)return;c=f[a+4>>2]|0;Yi[f[(f[c>>2]|0)+8>>2]&4095](c);return}function UEc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;h=f[a+4>>2]|0;Fh[f[(f[h>>2]|0)+12>>2]&255](h,b,c,d,e,g);return}function VEc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0;h=f[a+4>>2]|0;return uj[f[(f[h>>2]|0)+16>>2]&7](h,b,c,d,e,g)|0}function WEc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,b);return}function XEc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+24>>2]&2047](c,b);return}function YEc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+28>>2]&2047](b)|0}function ZEc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&2047](b)|0}function _Ec(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+36>>2]&2047](b)|0}function $Ec(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+40>>2]&2047](b)|0}function aFc(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;mi[f[(f[c>>2]|0)+44>>2]&2047](a,c);return}function bFc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[a+4>>2]|0;ei[f[(f[e>>2]|0)+48>>2]&511](e,b,c,d);return}function cFc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+64|0;k=j;do if(aT(a)|0){do if((eS(a)|0)==65536){l=f[a+4>>2]|0;f[k>>2]=f[l>>2];m=k+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=k+8|0;f[o>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];f[k+20>>2]=f[l+20>>2];f[k+24>>2]=f[l+24>>2];f[k+28>>2]=f[l+28>>2];f[k+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[k+36>>2]=p;f[k+40>>2]=o;o=k+48|0;q=k+44|0;f[q>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;U$(k,l);break}}else bS(k,a,-1);while(0);l=c+36|0;m=f[l>>2]|0;if((k|0)==(c|0)){n=k+36|0;if((m|0)!=0?(o=m+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0){V$(k);r=n}else r=n}else{if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(c);f[l>>2]=0;m=c+16|0;n=c+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){q=f[c+40>>2]|0;o=0;do{f[q+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}f[c>>2]=f[k>>2];o=k+4|0;q=f[o>>2]|0;f[n>>2]=q;p=k+8|0;s=c+8|0;f[s>>2]=f[p>>2];f[c+12>>2]=f[k+12>>2];f[m>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[c+28>>2]=f[k+28>>2];f[c+32>>2]=f[k+32>>2];t=k+36|0;f[l>>2]=f[t>>2];v=c+44|0;w=f[v>>2]|0;x=c+48|0;if((w|0)==(x|0)){y=q;z=w}else{wL(w);f[v>>2]=x;f[c+40>>2]=s;y=f[o>>2]|0;z=x}x=k+44|0;if((y|0)<3){s=f[x>>2]|0;f[z>>2]=f[s>>2];f[z+4>>2]=f[s+4>>2]}else{f[v>>2]=f[x>>2];v=k+40|0;f[c+40>>2]=f[v>>2];f[x>>2]=k+48;f[v>>2]=p}f[k>>2]=1124007936;A=o;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));r=t}f[r>>2]=0;l=k+16|0;m=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[k+40>>2]|0;n=0;do{f[l+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))wL(m);m=f[c>>2]|0;if(((m&20479|0)==16388?(f[c+8>>2]|0)==(e|0):0)?(n=f[c+12>>2]|0,!((n|0)<(g|0)|(n|0)>(h|0))):0)break;if(!(m&16384))vS(a);ZS(a,e,g,4,-1,0,0);do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[k>>2]=f[m>>2];n=k+4|0;l=m+4|0;f[n>>2]=f[l>>2];t=k+8|0;f[t>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];f[k+16>>2]=f[m+16>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];f[k+32>>2]=f[m+32>>2];o=f[m+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=t;t=k+48|0;p=k+44|0;f[p>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(o|0){t=o+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[l>>2]|0)<3){l=f[m+44>>2]|0;t=f[p>>2]|0;f[t>>2]=f[l>>2];f[t+4>>2]=f[l+4>>2];break}else{f[n>>2]=0;U$(k,m);break}}else bS(k,a,-1);while(0);m=c+36|0;n=f[m>>2]|0;if((k|0)==(c|0)){l=k+36|0;if((n|0)!=0?(t=n+12|0,p=f[t>>2]|0,f[t>>2]=p+-1,(p|0)==1):0){V$(k);C=l}else C=l}else{if(n|0?(l=n+12|0,n=f[l>>2]|0,f[l>>2]=n+-1,(n|0)==1):0)V$(c);f[m>>2]=0;n=c+16|0;l=c+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[l>>2]|0)>0){p=f[c+40>>2]|0;t=0;do{f[p+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[l>>2]|0))}f[c>>2]=f[k>>2];t=k+4|0;p=f[t>>2]|0;f[l>>2]=p;o=k+8|0;v=c+8|0;f[v>>2]=f[o>>2];f[c+12>>2]=f[k+12>>2];f[n>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[c+28>>2]=f[k+28>>2];f[c+32>>2]=f[k+32>>2];x=k+36|0;f[m>>2]=f[x>>2];s=c+44|0;w=f[s>>2]|0;q=c+48|0;if((w|0)==(q|0))D=p;else{wL(w);f[s>>2]=q;f[c+40>>2]=v;D=f[t>>2]|0}v=k+44|0;if((D|0)<3){w=f[v>>2]|0;f[q>>2]=f[w>>2];f[c+52>>2]=f[w+4>>2]}else{f[s>>2]=f[v>>2];s=k+40|0;f[c+40>>2]=f[s>>2];f[v>>2]=k+48;f[s>>2]=o}f[k>>2]=1124007936;A=t;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));C=x}f[C>>2]=0;m=k+16|0;n=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){m=f[k+40>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[n>>2]|0))}n=f[k+44>>2]|0;if((n|0)!=(k+48|0))wL(n)}else{if(((((f[c+4>>2]|0)<3?(f[c+8>>2]|0)==(e|0):0)?(f[c+12>>2]|0)==(g|0):0)?(f[c>>2]&4095|0)==4:0)?f[c+16>>2]|0:0)break;f[k>>2]=e;f[k+4>>2]=g;S$(c,2,k,4)}while(0);if(!(aT(b)|0)){c=i&4095;if(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(e|0):0)?(f[d+12>>2]|0)==(g|0):0)?(f[d>>2]&4095|0)==(c|0):0)?f[d+16>>2]|0:0){u=j;return}f[k>>2]=e;f[k+4>>2]=g;S$(d,2,k,c);u=j;return}do if((eS(b)|0)==65536){c=f[b+4>>2]|0;f[k>>2]=f[c>>2];C=k+4|0;D=c+4|0;f[C>>2]=f[D>>2];a=k+8|0;f[a>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];r=f[c+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=a;a=k+48|0;z=k+44|0;f[z>>2]=a;f[a>>2]=0;f[k+52>>2]=0;if(r|0){a=r+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[D>>2]|0)<3){D=f[c+44>>2]|0;a=f[z>>2]|0;f[a>>2]=f[D>>2];f[a+4>>2]=f[D+4>>2];break}else{f[C>>2]=0;U$(k,c);break}}else bS(k,b,-1);while(0);c=d+36|0;C=f[c>>2]|0;if((k|0)==(d|0)){D=k+36|0;if((C|0)!=0?(a=C+12|0,z=f[a>>2]|0,f[a>>2]=z+-1,(z|0)==1):0){V$(k);E=D}else E=D}else{if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)V$(d);f[c>>2]=0;C=d+16|0;D=d+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[D>>2]|0)>0){z=f[d+40>>2]|0;a=0;do{f[z+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[D>>2]|0))}f[d>>2]=f[k>>2];a=k+4|0;z=f[a>>2]|0;f[D>>2]=z;D=k+8|0;r=d+8|0;f[r>>2]=f[D>>2];f[d+12>>2]=f[k+12>>2];f[C>>2]=f[k+16>>2];f[d+20>>2]=f[k+20>>2];f[d+24>>2]=f[k+24>>2];f[d+28>>2]=f[k+28>>2];f[d+32>>2]=f[k+32>>2];C=k+36|0;f[c>>2]=f[C>>2];c=d+44|0;y=f[c>>2]|0;n=d+48|0;if((y|0)==(n|0)){F=z;G=y}else{wL(y);f[c>>2]=n;f[d+40>>2]=r;F=f[a>>2]|0;G=n}n=k+44|0;if((F|0)<3){F=f[n>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2]}else{f[c>>2]=f[n>>2];c=k+40|0;f[d+40>>2]=f[c>>2];f[n>>2]=k+48;f[c>>2]=D}f[k>>2]=1124007936;A=a;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));E=C}f[E>>2]=0;E=k+16|0;C=k+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[k+40>>2]|0;a=0;do{f[E+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[C>>2]|0))}C=f[k+44>>2]|0;if((C|0)!=(k+48|0))wL(C);C=f[d>>2]|0;if(((C&16384|0)!=0&(C&4095|0)==(i|0)?(f[d+8>>2]|0)==(e|0):0)?(C=f[d+12>>2]|0,!((C|0)<(g|0)|(C|0)>(h|0))):0){u=j;return}if(!(tS(b,-1)|0))vS(b);ZS(b,e,g,i,-1,0,0);do if((eS(b)|0)==65536){i=f[b+4>>2]|0;f[k>>2]=f[i>>2];g=k+4|0;e=i+4|0;f[g>>2]=f[e>>2];h=k+8|0;f[h>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[k+16>>2]=f[i+16>>2];f[k+20>>2]=f[i+20>>2];f[k+24>>2]=f[i+24>>2];f[k+28>>2]=f[i+28>>2];f[k+32>>2]=f[i+32>>2];C=f[i+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=h;h=k+48|0;a=k+44|0;f[a>>2]=h;f[h>>2]=0;f[k+52>>2]=0;if(C|0){h=C+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[e>>2]|0)<3){e=f[i+44>>2]|0;h=f[a>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];break}else{f[g>>2]=0;U$(k,i);break}}else bS(k,b,-1);while(0);b=d+36|0;i=f[b>>2]|0;if((k|0)==(d|0)){g=k+36|0;if((i|0)!=0?(e=i+12|0,h=f[e>>2]|0,f[e>>2]=h+-1,(h|0)==1):0){V$(k);H=g}else H=g}else{if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)V$(d);f[b>>2]=0;i=d+16|0;g=d+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[g>>2]|0)>0){h=f[d+40>>2]|0;e=0;do{f[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[g>>2]|0))}f[d>>2]=f[k>>2];e=k+4|0;h=f[e>>2]|0;f[g>>2]=h;g=k+8|0;a=d+8|0;f[a>>2]=f[g>>2];f[d+12>>2]=f[k+12>>2];f[i>>2]=f[k+16>>2];f[d+20>>2]=f[k+20>>2];f[d+24>>2]=f[k+24>>2];f[d+28>>2]=f[k+28>>2];f[d+32>>2]=f[k+32>>2];i=k+36|0;f[b>>2]=f[i>>2];b=d+44|0;C=f[b>>2]|0;E=d+48|0;if((C|0)==(E|0))I=h;else{wL(C);f[b>>2]=E;f[d+40>>2]=a;I=f[e>>2]|0}a=k+44|0;if((I|0)<3){I=f[a>>2]|0;f[E>>2]=f[I>>2];f[d+52>>2]=f[I+4>>2]}else{f[b>>2]=f[a>>2];b=k+40|0;f[d+40>>2]=f[b>>2];f[a>>2]=k+48;f[b>>2]=g}f[k>>2]=1124007936;A=e;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));H=i}f[H>>2]=0;H=k+16|0;i=k+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[i>>2]|0)>0){H=f[k+40>>2]|0;A=0;do{f[H+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[i>>2]|0))}i=f[k+44>>2]|0;if((i|0)!=(k+48|0))wL(i);u=j;return}function dFc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;m=f[c>>2]|0;if(((m&4095|0)==0?(n=f[d>>2]|0,(n&4095|0)==4):0)?(o=f[e>>2]|0,(o&4095|0)==4):0)if(!(m&16384&n&o)){o=$Xc(80)|0;f[j>>2]=o;f[j+8>>2]=-2147483568;f[j+4>>2]=70;p=o;q=517587;r=p+70|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+70>>0]=0;vM(-215,j,517570,511669,515)}else{o=f[c+16>>2]|0;n=f[c+12>>2]|0;f[j>>2]=f[c+8>>2];f[j+4>>2]=n;f[j+12>>2]=o;f[j+8>>2]=n;n=f[d+16>>2]|0;o=f[d+12>>2]|0;f[k>>2]=f[d+8>>2];f[k+4>>2]=o;f[k+12>>2]=n;f[k+8>>2]=o;o=f[e+16>>2]|0;n=f[e+12>>2]|0;f[l>>2]=f[e+8>>2];f[l+4>>2]=n;f[l+12>>2]=o;f[l+8>>2]=n;n=uj[f[(f[a>>2]|0)+16>>2]&7](a,j,k,l,g,f[h>>2]|0)|0;u=i;return n|0}n=$Xc(80)|0;f[j>>2]=n;f[j+8>>2]=-2147483568;f[j+4>>2]=73;p=n;q=517496;r=p+73|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[n+73>>0]=0;vM(-215,j,517570,511669,514);return 0}function eFc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;m=f[c>>2]|0;if(((m&4095|0)==5?(n=f[d>>2]|0,(n&4095|0)==4):0)?(o=f[e>>2]|0,(o&4095|0)==5):0)if(!(m&16384&n&o)){o=$Xc(80)|0;f[j>>2]=o;f[j+8>>2]=-2147483568;f[j+4>>2]=70;p=o;q=517587;r=p+70|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+70>>0]=0;vM(-215,j,517570,511669,515)}else{o=f[c+16>>2]|0;n=f[c+12>>2]|0;f[j>>2]=f[c+8>>2];f[j+4>>2]=n;f[j+12>>2]=o;f[j+8>>2]=n;n=f[d+16>>2]|0;o=f[d+12>>2]|0;f[k>>2]=f[d+8>>2];f[k+4>>2]=o;f[k+12>>2]=n;f[k+8>>2]=o;o=f[e+16>>2]|0;n=f[e+12>>2]|0;f[l>>2]=f[e+8>>2];f[l+4>>2]=n;f[l+12>>2]=o;f[l+8>>2]=n;n=uj[f[(f[a>>2]|0)+16>>2]&7](a,j,k,l,g,f[h>>2]|0)|0;u=i;return n|0}n=$Xc(80)|0;f[j>>2]=n;f[j+8>>2]=-2147483568;f[j+4>>2]=73;p=n;q=517496;r=p+73|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[n+73>>0]=0;vM(-215,j,517570,511669,514);return 0}function fFc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;m=f[c>>2]|0;if(((m&4095|0)==5?(n=f[d>>2]|0,(n&4095|0)==4):0)?(o=f[e>>2]|0,(o&4095|0)==5):0)if(!(m&16384&n&o)){o=$Xc(80)|0;f[j>>2]=o;f[j+8>>2]=-2147483568;f[j+4>>2]=70;p=o;q=517587;r=p+70|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+70>>0]=0;vM(-215,j,517570,511669,515)}else{o=f[c+16>>2]|0;n=f[c+12>>2]|0;f[j>>2]=f[c+8>>2];f[j+4>>2]=n;f[j+12>>2]=o;f[j+8>>2]=n;n=f[d+16>>2]|0;o=f[d+12>>2]|0;f[k>>2]=f[d+8>>2];f[k+4>>2]=o;f[k+12>>2]=n;f[k+8>>2]=o;o=f[e+16>>2]|0;n=f[e+12>>2]|0;f[l>>2]=f[e+8>>2];f[l+4>>2]=n;f[l+12>>2]=o;f[l+8>>2]=n;n=uj[f[(f[a>>2]|0)+16>>2]&7](a,j,k,l,g,f[h>>2]|0)|0;u=i;return n|0}n=$Xc(80)|0;f[j>>2]=n;f[j+8>>2]=-2147483568;f[j+4>>2]=73;p=n;q=517496;r=p+73|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[n+73>>0]=0;vM(-215,j,517570,511669,514);return 0}function gFc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;if((_i[f[(f[a>>2]|0)+28>>2]&2047](a)|0)>>>0<g>>>0){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=29;n=m;o=517668;p=n+29|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+29>>0]=0;vM(-215,j,517698,511669,487)}m=f[c>>2]|0;if(((m&4095|0)==0?(q=f[d>>2]|0,(q&4095|0)==4):0)?(r=f[e>>2]|0,(r&4095|0)==4):0)if(!(m&16384&q&r)){r=$Xc(80)|0;f[j>>2]=r;f[j+8>>2]=-2147483568;f[j+4>>2]=70;n=r;o=517587;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[r+70>>0]=0;vM(-215,j,517698,511669,489)}else{r=f[c+16>>2]|0;q=f[c+12>>2]|0;f[j>>2]=f[c+8>>2];f[j+4>>2]=q;f[j+12>>2]=r;f[j+8>>2]=q;q=f[d+16>>2]|0;r=f[d+12>>2]|0;f[k>>2]=f[d+8>>2];f[k+4>>2]=r;f[k+12>>2]=q;f[k+8>>2]=r;r=f[e+16>>2]|0;q=f[e+12>>2]|0;f[l>>2]=f[e+8>>2];f[l+4>>2]=q;f[l+12>>2]=r;f[l+8>>2]=q;Fh[f[(f[a>>2]|0)+12>>2]&255](a,j,k,l,g,f[h>>2]|0);u=i;return}i=$Xc(80)|0;f[j>>2]=i;f[j+8>>2]=-2147483568;f[j+4>>2]=73;n=i;o=517496;p=n+73|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[i+73>>0]=0;vM(-215,j,517698,511669,488)}function hFc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;if((_i[f[(f[a>>2]|0)+28>>2]&2047](a)|0)>>>0<g>>>0){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=29;n=m;o=517668;p=n+29|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+29>>0]=0;vM(-215,j,517698,511669,487)}m=f[c>>2]|0;if(((m&4095|0)==5?(q=f[d>>2]|0,(q&4095|0)==4):0)?(r=f[e>>2]|0,(r&4095|0)==5):0)if(!(m&16384&q&r)){r=$Xc(80)|0;f[j>>2]=r;f[j+8>>2]=-2147483568;f[j+4>>2]=70;n=r;o=517587;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[r+70>>0]=0;vM(-215,j,517698,511669,489)}else{r=f[c+16>>2]|0;q=f[c+12>>2]|0;f[j>>2]=f[c+8>>2];f[j+4>>2]=q;f[j+12>>2]=r;f[j+8>>2]=q;q=f[d+16>>2]|0;r=f[d+12>>2]|0;f[k>>2]=f[d+8>>2];f[k+4>>2]=r;f[k+12>>2]=q;f[k+8>>2]=r;r=f[e+16>>2]|0;q=f[e+12>>2]|0;f[l>>2]=f[e+8>>2];f[l+4>>2]=q;f[l+12>>2]=r;f[l+8>>2]=q;Fh[f[(f[a>>2]|0)+12>>2]&255](a,j,k,l,g,f[h>>2]|0);u=i;return}i=$Xc(80)|0;f[j>>2]=i;f[j+8>>2]=-2147483568;f[j+4>>2]=73;n=i;o=517496;p=n+73|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[i+73>>0]=0;vM(-215,j,517698,511669,488)}function iFc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;if((_i[f[(f[a>>2]|0)+28>>2]&2047](a)|0)>>>0<g>>>0){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=29;n=m;o=517668;p=n+29|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+29>>0]=0;vM(-215,j,517698,511669,487)}m=f[c>>2]|0;if(((m&4095|0)==5?(q=f[d>>2]|0,(q&4095|0)==4):0)?(r=f[e>>2]|0,(r&4095|0)==5):0)if(!(m&16384&q&r)){r=$Xc(80)|0;f[j>>2]=r;f[j+8>>2]=-2147483568;f[j+4>>2]=70;n=r;o=517587;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[r+70>>0]=0;vM(-215,j,517698,511669,489)}else{r=f[c+16>>2]|0;q=f[c+12>>2]|0;f[j>>2]=f[c+8>>2];f[j+4>>2]=q;f[j+12>>2]=r;f[j+8>>2]=q;q=f[d+16>>2]|0;r=f[d+12>>2]|0;f[k>>2]=f[d+8>>2];f[k+4>>2]=r;f[k+12>>2]=q;f[k+8>>2]=r;r=f[e+16>>2]|0;q=f[e+12>>2]|0;f[l>>2]=f[e+8>>2];f[l+4>>2]=q;f[l+12>>2]=r;f[l+8>>2]=q;Fh[f[(f[a>>2]|0)+12>>2]&255](a,j,k,l,g,f[h>>2]|0);u=i;return}i=$Xc(80)|0;f[j>>2]=i;f[j+8>>2]=-2147483568;f[j+4>>2]=73;n=i;o=517496;p=n+73|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[i+73>>0]=0;vM(-215,j,517698,511669,488)}function jFc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function kFc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+8|0;j=e+36|0;k=f[c>>2]|0;l=k&4095;if(l|0){f[h>>2]=l;DM(g,517718,h);vM(-210,g,517727,511669,315)}if(!(k&16384)){k=$Xc(48)|0;f[g>>2]=k;f[g+8>>2]=-2147483600;f[g+4>>2]=36;h=k;l=517739;m=h+36|0;do{b[h>>0]=b[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));b[k+36>>0]=0;vM(-5,g,517727,511669,317)}else{k=f[c+16>>2]|0;l=f[c+12>>2]|0;f[i>>2]=f[c+8>>2];f[i+4>>2]=l;f[i+12>>2]=k;f[i+8>>2]=l;l=$Xc(24)|0;k=f[d>>2]|0;b[g>>0]=b[j>>0]|0;qDc(l,i,k,g);Yi[f[(f[l>>2]|0)+8>>2]&4095](l);f[a>>2]=l;u=e;return}}function lFc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+8|0;j=e+36|0;k=f[c>>2]|0;l=k&4095;if((l|0)!=5){f[h>>2]=l;DM(g,517718,h);vM(-210,g,517727,511669,315)}if(!(k&16384)){k=$Xc(48)|0;f[g>>2]=k;f[g+8>>2]=-2147483600;f[g+4>>2]=36;h=k;l=517739;m=h+36|0;do{b[h>>0]=b[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));b[k+36>>0]=0;vM(-5,g,517727,511669,317)}else{k=f[c+16>>2]|0;l=f[c+12>>2]|0;f[i>>2]=f[c+8>>2];f[i+4>>2]=l;f[i+12>>2]=k;f[i+8>>2]=l;l=$Xc(24)|0;k=f[d>>2]|0;b[g>>0]=b[j>>0]|0;Pzc(l,i,k,g);Yi[f[(f[l>>2]|0)+8>>2]&4095](l);f[a>>2]=l;u=e;return}}function mFc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+8|0;j=e+36|0;k=f[c>>2]|0;l=k&4095;if((l|0)!=5){f[h>>2]=l;DM(g,517718,h);vM(-210,g,517727,511669,315)}if(!(k&16384)){k=$Xc(48)|0;f[g>>2]=k;f[g+8>>2]=-2147483600;f[g+4>>2]=36;h=k;l=517739;m=h+36|0;do{b[h>>0]=b[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));b[k+36>>0]=0;vM(-5,g,517727,511669,317)}else{k=f[c+16>>2]|0;l=f[c+12>>2]|0;f[i>>2]=f[c+8>>2];f[i+4>>2]=l;f[i+12>>2]=k;f[i+8>>2]=l;l=$Xc(24)|0;k=f[d>>2]|0;b[g>>0]=b[j>>0]|0;Otc(l,i,k,g);Yi[f[(f[l>>2]|0)+8>>2]&4095](l);f[a>>2]=l;u=e;return}}function nFc(){var a=0;if(b[539168]|0)return;a=539168;f[a>>2]=1;f[a+4>>2]=0;return}function oFc(){var a=0;if(b[539192]|0)return;a=539192;f[a>>2]=1;f[a+4>>2]=0;return}function pFc(){var a=0;if(b[539144]|0)return;a=539144;f[a>>2]=1;f[a+4>>2]=0;return}function qFc(){var a=0;if(b[539128]|0)return;a=539128;f[a>>2]=1;f[a+4>>2]=0;return}function rFc(){var a=0;if(b[539120]|0)return;a=539120;f[a>>2]=1;f[a+4>>2]=0;return}function sFc(){var a=0;if(b[539160]|0)return;a=539160;f[a>>2]=1;f[a+4>>2]=0;return}function tFc(){var a=0;if(b[539136]|0)return;a=539136;f[a>>2]=1;f[a+4>>2]=0;return}function uFc(){var a=0;if(b[539152]|0)return;a=539152;f[a>>2]=1;f[a+4>>2]=0;return}function vFc(){var a=0;if(b[539184]|0)return;a=539184;f[a>>2]=1;f[a+4>>2]=0;return}function wFc(){var a=0;if(b[539176]|0)return;a=539176;f[a>>2]=1;f[a+4>>2]=0;return}function xFc(){var a=0;if(b[539104]|0)return;a=539104;f[a>>2]=1;f[a+4>>2]=0;return}function yFc(){var a=0;if(b[539112]|0)return;a=539112;f[a>>2]=1;f[a+4>>2]=0;return}function zFc(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(a|0)cYc(a);f[b>>2]=0;return}function AFc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(8)|0;p[a>>3]=+p[b>>3];f[c>>2]=a;return}function BFc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(8)|0;p[a>>3]=+p[f[b>>2]>>3];f[c>>2]=a;return}function CFc(a,b,c){a=a|0;b=b|0;c=c|0;p[f[c>>2]>>3]=+p[f[b>>2]>>3];return}function DFc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function EFc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function FFc(a){a=a|0;return 8}function GFc(a){a=a|0;return 25552}function HFc(a,b,c){a=a|0;b=b|0;c=c|0;qOc(b,+p[f[c>>2]>>3])|0;return}function IFc(a){a=a|0;cYc(a);return}function JFc(a,c){a=a|0;c=c|0;a=f[c>>2]|0;if(!a){f[c>>2]=0;return}if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(a);f[c>>2]=0;return}function KFc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(12)|0;lYc(a,b);f[c>>2]=a;return}function LFc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(12)|0;lYc(a,f[b>>2]|0);f[c>>2]=a;return}function MFc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a=f[d>>2]|0;if((b[a+11>>0]|0)<0){cYc(f[a>>2]|0);e=f[d>>2]|0}else e=a;oYc(e,f[c>>2]|0)|0;return}function NFc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function OFc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function PFc(a){a=a|0;return 12}function QFc(a){a=a|0;return 4984}function RFc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a=f[d>>2]|0;if((b[a+11>>0]|0)<0)e=f[a>>2]|0;else e=a;BM(c,e,dJc(e)|0)|0;return}function SFc(a){a=a|0;cYc(a);return}function TFc(a,b){a=a|0;b=b|0;return}function UFc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function VFc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function WFc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function XFc(a,b){a=a|0;b=b|0;return b|0}function YFc(a,b){a=a|0;b=b|0;return b|0}function ZFc(a){a=a|0;return 4}function _Fc(a){a=a|0;return 25464}function $Fc(a,b,c){a=a|0;b=b|0;c=c|0;a=f[c>>2]|0;BM(b,a,dJc(a)|0)|0;return}function aGc(a){a=a|0;cYc(a);return}function bGc(a){a=a|0;var b=0;b=f[a>>2]|0;Ptc(b,f[b+4>>2]|0);cYc(b);return}function cGc(a){a=a|0;var b=0,c=0;b=$Xc(12)|0;c=b+4|0;f[c>>2]=0;f[b+8>>2]=0;f[b>>2]=c;f[a>>2]=b;return}function dGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+8|0;g=d;h=f[a>>2]|0;f[g>>2]=b;eGc(e,h,b,1163516,g,d+16|0);g=f[e>>2]|0;e=g+28|0;b=f[e>>2]|0;h=g+32|0;mi[f[f[b>>2]>>2]&2047](b,h);f[e>>2]=175124;Ti[f[(f[43781]|0)+4>>2]&511](175124,c,h);u=d;return}function eGc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;e=h;i=Ntc(c,e,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=h;return}d=$Xc(36)|0;lYc(d+16|0,f[g>>2]|0);f[d+28>>2]=172888;f[d+32>>2]=0;g=f[e>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=g;f[i>>2]=d;g=f[f[c>>2]>>2]|0;if(!g)n=d;else{f[c>>2]=g;n=f[i>>2]|0}UQ(f[c+4>>2]|0,n);n=c+8|0;f[n>>2]=(f[n>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=h;return}function fGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+8|0;g=d+4|0;h=d;f[h>>2]=c;c=f[a>>2]|0;f[g>>2]=b;eGc(e,c,b,1163516,g,d+16|0);g=f[e>>2]|0;e=g+28|0;b=f[e>>2]|0;c=g+32|0;mi[f[f[b>>2]>>2]&2047](b,c);f[e>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,h,c);u=d;return}function gGc(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;p[h>>3]=c;i=f[a>>2]|0;f[g>>2]=b;eGc(e,i,b,1163516,g,d+24|0);g=f[e>>2]|0;e=g+28|0;b=f[e>>2]|0;i=g+32|0;mi[f[f[b>>2]>>2]&2047](b,i);f[e>>2]=175128;Ti[f[(f[43782]|0)+4>>2]&511](175128,h,i);u=d;return}function hGc(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+32|0;e=d+8|0;g=d+4|0;h=d;n[h>>2]=c;i=f[a>>2]|0;f[g>>2]=b;eGc(e,i,b,1163516,g,d+16|0);g=f[e>>2]|0;e=g+28|0;b=f[e>>2]|0;i=g+32|0;mi[f[f[b>>2]>>2]&2047](b,i);f[e>>2]=173484;Ti[f[(f[43371]|0)+4>>2]&511](173484,h,i);u=d;return}function iGc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+8|0;h=e;i=e+16|0;b[i>>0]=d&1;d=f[a>>2]|0;f[h>>2]=c;eGc(g,d,c,1163516,h,e+17|0);h=f[g>>2]|0;g=h+28|0;c=f[g>>2]|0;d=h+32|0;mi[f[f[c>>2]>>2]&2047](c,d);f[g>>2]=173488;Ti[f[(f[43372]|0)+4>>2]&511](173488,i,d);u=e;return}function jGc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+48|0;e=d+24|0;g=d+16|0;h=d+32|0;i=d+4|0;j=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=9;l=i;m=512094;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[i+9>>0]=0;f[j>>2]=c;c=f[a>>2]|0;f[g>>2]=i;eGc(e,c,i,1163516,g,h);h=f[e>>2]|0;e=h+28|0;g=f[e>>2]|0;c=h+32|0;mi[f[f[g>>2]>>2]&2047](g,c);f[e>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,j,c);if((b[k>>0]|0)>=0){u=d;return}cYc(f[i>>2]|0);u=d;return}function kGc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h+8|0;j=h;k=f[c>>2]|0;l=c+4|0;m=f[l>>2]|0;if((m|0)!=(k|0)){n=m;while(1){m=n+-12|0;f[l>>2]=m;if((b[m+11>>0]|0)<0){cYc(f[m>>2]|0);o=f[l>>2]|0}else o=m;if((o|0)==(k|0))break;else n=o}}o=f[d>>2]|0;n=d+4|0;k=f[n>>2]|0;if((k|0)!=(o|0))f[n>>2]=k+(~((k+-4-o|0)>>>2)<<2);o=f[e>>2]|0;k=e+4|0;m=f[k>>2]|0;if((m|0)!=(o|0)){q=m;while(1){m=q+-12|0;f[k>>2]=m;if((b[m+11>>0]|0)<0){cYc(f[m>>2]|0);r=f[k>>2]|0}else r=m;if((r|0)==(o|0))break;else q=r}}r=f[g>>2]|0;q=g+4|0;o=f[q>>2]|0;if((o|0)!=(r|0))f[q>>2]=o+(~((o+-8-r|0)>>>3)<<3);r=f[a>>2]|0;a=f[r>>2]|0;o=r+4|0;if((a|0)==(o|0)){u=h;return}r=c+8|0;m=d+8|0;s=e+8|0;t=g+8|0;v=i+11|0;w=a;while(1){a=w;x=a+16|0;y=f[l>>2]|0;if((y|0)==(f[r>>2]|0))NN(c,x);else{lYc(y,x);f[l>>2]=(f[l>>2]|0)+12}x=a+28|0;y=f[x>>2]|0;z=(_i[f[(f[y>>2]|0)+28>>2]&2047](y)|0)+4|0;if((f[z>>2]|0)!=213802){A=19;break}z=f[x>>2]|0;lYc(i,Mi[f[(f[z>>2]|0)+20>>2]&1023](z,a+32|0)|0);f[j>>2]=7;a=f[n>>2]|0;if(a>>>0<(f[m>>2]|0)>>>0){f[a>>2]=7;f[n>>2]=a+4}else lGc(d,j);a=f[k>>2]|0;if((a|0)==(f[s>>2]|0))NN(e,i);else{lYc(a,i);f[k>>2]=(f[k>>2]|0)+12}p[j>>3]=-1.0;a=f[q>>2]|0;if(a>>>0<(f[t>>2]|0)>>>0){p[a>>3]=-1.0;f[q>>2]=a+8}else HVb(g,j);if((b[v>>0]|0)<0)cYc(f[i>>2]|0);a=w;z=f[a+4>>2]|0;if(!z){x=a+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(a|0))B=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;a=f[y>>2]|0}while((f[a>>2]|0)!=(x|0));B=a}}else{y=z;while(1){a=f[y>>2]|0;if(!a)break;else y=a}B=y}if((B|0)==(o|0)){A=37;break}else w=B}if((A|0)==19)ig(af(1)|0,22144,0);else if((A|0)==37){u=h;return}}function lGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function mGc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+32|0;e=d+28|0;g=d+24|0;h=d+12|0;i=d;f[g>>2]=c;c=$Xc(12)|0;j=c+4|0;f[j>>2]=0;k=c+8|0;f[k>>2]=0;f[c>>2]=j;f[a>>2]=c;f[h>>2]=1;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;a=i+11|0;b[a>>0]=9;l=i;m=512094;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[i+9>>0]=0;m=Ntc(c,e,i)|0;l=f[m>>2]|0;if(!l){n=$Xc(36)|0;o=n+16|0;f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];f[o+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[n+28>>2]=172888;f[n+32>>2]=0;o=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=o;f[m>>2]=n;o=f[f[c>>2]>>2]|0;if(!o)p=n;else{f[c>>2]=o;p=f[m>>2]|0}UQ(f[j>>2]|0,p);f[k>>2]=(f[k>>2]|0)+1;q=n}else q=l;l=q+28|0;n=f[l>>2]|0;p=q+32|0;mi[f[f[n>>2]>>2]&2047](n,p);f[l>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,h,p);if((b[a>>0]|0)<0)cYc(f[i>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=5;b[h>>0]=b[512723]|0;b[h+1>>0]=b[512724]|0;b[h+2>>0]=b[512725]|0;b[h+3>>0]=b[512726]|0;b[h+4>>0]=b[512727]|0;b[h+5>>0]=0;a=Ntc(c,e,h)|0;p=f[a>>2]|0;if(!p){l=$Xc(36)|0;n=l+16|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;n=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=n;f[a>>2]=l;n=f[f[c>>2]>>2]|0;if(!n)r=l;else{f[c>>2]=n;r=f[a>>2]|0}UQ(f[j>>2]|0,r);f[k>>2]=(f[k>>2]|0)+1;s=l}else s=p;p=s+28|0;l=f[p>>2]|0;k=s+32|0;mi[f[f[l>>2]>>2]&2047](l,k);f[p>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,g,k);if((b[i>>0]|0)>=0){u=d;return}cYc(f[h>>2]|0);u=d;return}function nGc(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+32|0;h=g+20|0;i=g+16|0;j=g+12|0;k=g+24|0;l=g;f[i>>2]=c;n[j>>2]=d;b[k>>0]=e&1;e=$Xc(12)|0;c=e+4|0;f[c>>2]=0;m=e+8|0;f[m>>2]=0;f[e>>2]=c;f[a>>2]=e;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;a=l+11|0;b[a>>0]=6;b[l>>0]=b[512787]|0;b[l+1>>0]=b[512788]|0;b[l+2>>0]=b[512789]|0;b[l+3>>0]=b[512790]|0;b[l+4>>0]=b[512791]|0;b[l+5>>0]=b[512792]|0;b[l+6>>0]=0;o=Ntc(e,h,l)|0;p=f[o>>2]|0;if(!p){q=$Xc(36)|0;r=q+16|0;f[r>>2]=f[l>>2];f[r+4>>2]=f[l+4>>2];f[r+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;r=f[h>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=r;f[o>>2]=q;r=f[f[e>>2]>>2]|0;if(!r)s=q;else{f[e>>2]=r;s=f[o>>2]|0}UQ(f[c>>2]|0,s);f[m>>2]=(f[m>>2]|0)+1;t=q}else t=p;p=t+28|0;q=f[p>>2]|0;s=t+32|0;mi[f[f[q>>2]>>2]&2047](q,s);f[p>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,i,s);if((b[a>>0]|0)<0)cYc(f[l>>2]|0);a=l+4|0;f[a>>2]=0;f[a+4>>2]=0;a=l+11|0;b[a>>0]=3;b[l>>0]=b[513188]|0;b[l+1>>0]=b[513189]|0;b[l+2>>0]=b[513190]|0;b[l+3>>0]=0;s=Ntc(e,h,l)|0;i=f[s>>2]|0;if(!i){p=$Xc(36)|0;q=p+16|0;f[q>>2]=f[l>>2];f[q+4>>2]=f[l+4>>2];f[q+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[p+28>>2]=172888;f[p+32>>2]=0;q=f[h>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=q;f[s>>2]=p;q=f[f[e>>2]>>2]|0;if(!q)v=p;else{f[e>>2]=q;v=f[s>>2]|0}UQ(f[c>>2]|0,v);f[m>>2]=(f[m>>2]|0)+1;w=p}else w=i;i=w+28|0;p=f[i>>2]|0;v=w+32|0;mi[f[f[p>>2]>>2]&2047](p,v);f[i>>2]=173484;Ti[f[(f[43371]|0)+4>>2]&511](173484,j,v);if((b[a>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;a=l+11|0;b[a>>0]=6;b[l>>0]=b[512403]|0;b[l+1>>0]=b[512404]|0;b[l+2>>0]=b[512405]|0;b[l+3>>0]=b[512406]|0;b[l+4>>0]=b[512407]|0;b[l+5>>0]=b[512408]|0;b[l+6>>0]=0;v=Ntc(e,h,l)|0;j=f[v>>2]|0;if(!j){i=$Xc(36)|0;p=i+16|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[i+28>>2]=172888;f[i+32>>2]=0;p=f[h>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=p;f[v>>2]=i;p=f[f[e>>2]>>2]|0;if(!p)x=i;else{f[e>>2]=p;x=f[v>>2]|0}UQ(f[c>>2]|0,x);f[m>>2]=(f[m>>2]|0)+1;y=i}else y=j;j=y+28|0;i=f[j>>2]|0;m=y+32|0;mi[f[f[i>>2]>>2]&2047](i,m);f[j>>2]=173488;Ti[f[(f[43372]|0)+4>>2]&511](173488,k,m);if((b[a>>0]|0)>=0){u=g;return}cYc(f[l>>2]|0);u=g;return}function oGc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=172856;f[a+16>>2]=0;f[a+12>>2]=5;f[a+8>>2]=0;f[a+4>>2]=1;Ctc(a,b,c,d);return}function pGc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;m=u;u=u+608|0;o=m+56|0;q=m+552|0;r=m+496|0;s=m+440|0;t=m+384|0;v=m+320|0;w=m+376|0;x=m;y=m+264|0;z=m+208|0;A=m+152|0;B=m+136|0;C=m+120|0;D=m+104|0;E=m+88|0;F=m+72|0;do if((eS(a)|0)==65536){G=f[a+4>>2]|0;f[q>>2]=f[G>>2];H=q+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=q+8|0;f[J>>2]=f[G+8>>2];f[q+12>>2]=f[G+12>>2];f[q+16>>2]=f[G+16>>2];f[q+20>>2]=f[G+20>>2];f[q+24>>2]=f[G+24>>2];f[q+28>>2]=f[G+28>>2];f[q+32>>2]=f[G+32>>2];K=f[G+36>>2]|0;f[q+36>>2]=K;f[q+40>>2]=J;J=q+48|0;L=q+44|0;f[L>>2]=J;f[J>>2]=0;f[q+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;U$(q,G);break}}else bS(q,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[r>>2]=f[a>>2];G=r+4|0;H=a+4|0;f[G>>2]=f[H>>2];I=r+8|0;f[I>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];J=f[a+36>>2]|0;f[r+36>>2]=J;f[r+40>>2]=I;I=r+48|0;L=r+44|0;f[L>>2]=I;f[I>>2]=0;f[r+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;I=f[L>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;U$(r,a);break}}else bS(r,c,-1);while(0);do if((eS(j)|0)==65536){c=f[j+4>>2]|0;f[s>>2]=f[c>>2];a=s+4|0;G=c+4|0;f[a>>2]=f[G>>2];H=s+8|0;f[H>>2]=f[c+8>>2];f[s+12>>2]=f[c+12>>2];f[s+16>>2]=f[c+16>>2];f[s+20>>2]=f[c+20>>2];f[s+24>>2]=f[c+24>>2];f[s+28>>2]=f[c+28>>2];f[s+32>>2]=f[c+32>>2];I=f[c+36>>2]|0;f[s+36>>2]=I;f[s+40>>2]=H;H=s+48|0;L=s+44|0;f[L>>2]=H;f[H>>2]=0;f[s+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[c+44>>2]|0;H=f[L>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[a>>2]=0;U$(s,c);break}}else bS(s,j,-1);while(0);j=f[q>>2]|0;c=j&4095;if((c|0)!=(f[r>>2]&4095|0)){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;M=$Xc(96)|0;f[t>>2]=M;N=t+8|0;f[N>>2]=-2147483552;O=t+4|0;f[O>>2]=82;P=M;Q=518086;R=P+82|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));S=M+82|0;b[S>>0]=0;vM(-215,t,518169,518183,275)}if((f[q+12>>2]|0)!=(f[r+12>>2]|0)){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;M=$Xc(96)|0;f[t>>2]=M;N=t+8|0;f[N>>2]=-2147483552;O=t+4|0;f[O>>2]=82;P=M;Q=518086;R=P+82|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));S=M+82|0;b[S>>0]=0;vM(-215,t,518169,518183,275)}a=(c|0)==5;G=(c|0)==0;switch(j&4095){case 0:case 5:break;default:{f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;M=$Xc(96)|0;f[t>>2]=M;N=t+8|0;f[N>>2]=-2147483552;O=t+4|0;f[O>>2]=82;P=M;Q=518086;R=P+82|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));S=M+82|0;b[S>>0]=0;vM(-215,t,518169,518183,275)}}if((i|0)>0^(aT(g)|0)){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;S=$Xc(32)|0;f[t>>2]=S;f[t+8>>2]=-2147483616;f[t+4>>2]=25;P=S;Q=518259;R=P+25|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));b[S+25>>0]=0;vM(-215,t,518169,518183,276)}S=(e|0)==-1?((h|1|0)==7?4:5):e;e=(S|0)==4;M=(S|0)==5;if(!(M|e&G)){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;O=$Xc(64)|0;f[t>>2]=O;f[t+8>>2]=-2147483584;f[t+4>>2]=53;P=O;Q=518285;R=P+53|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));b[O+53>>0]=0;vM(-215,t,518169,518183,282)}O=f[r+8>>2]|0;N=(O|0)<(i|0)?O:i;i=q+8|0;j=(N|0)>0;ZS(d,f[i>>2]|0,j?N:O,S,-1,0,0);do if((eS(d)|0)==65536){O=f[d+4>>2]|0;f[t>>2]=f[O>>2];H=t+4|0;L=O+4|0;f[H>>2]=f[L>>2];I=t+8|0;f[I>>2]=f[O+8>>2];f[t+12>>2]=f[O+12>>2];f[t+16>>2]=f[O+16>>2];f[t+20>>2]=f[O+20>>2];f[t+24>>2]=f[O+24>>2];f[t+28>>2]=f[O+28>>2];f[t+32>>2]=f[O+32>>2];J=f[O+36>>2]|0;f[t+36>>2]=J;f[t+40>>2]=I;I=t+48|0;K=t+44|0;f[K>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[L>>2]|0)<3){L=f[O+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[L>>2];f[I+4>>2]=f[L+4>>2];break}else{f[H>>2]=0;U$(t,O);break}}else bS(t,d,-1);while(0);f[v>>2]=1124007936;d=v+4|0;O=v+8|0;H=v+40|0;P=d;R=P+36|0;do{f[P>>2]=0;P=P+4|0}while((P|0)<(R|0));f[H>>2]=O;L=v+48|0;I=v+44|0;f[I>>2]=L;f[L>>2]=0;f[v+52>>2]=0;if(aT(g)|0){K=f[t+40>>2]|0;J=f[K>>2]|0;f[w>>2]=f[K+4>>2];f[w+4>>2]=J;wS(g,w,4,-1,0,0);do if((eS(g)|0)==65536){w=f[g+4>>2]|0;f[x>>2]=f[w>>2];J=x+4|0;K=w+4|0;f[J>>2]=f[K>>2];T=x+8|0;f[T>>2]=f[w+8>>2];f[x+12>>2]=f[w+12>>2];f[x+16>>2]=f[w+16>>2];f[x+20>>2]=f[w+20>>2];f[x+24>>2]=f[w+24>>2];f[x+28>>2]=f[w+28>>2];f[x+32>>2]=f[w+32>>2];U=f[w+36>>2]|0;f[x+36>>2]=U;f[x+40>>2]=T;T=x+48|0;V=x+44|0;f[V>>2]=T;f[T>>2]=0;f[x+52>>2]=0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[K>>2]|0)<3){K=f[w+44>>2]|0;T=f[V>>2]|0;f[T>>2]=f[K>>2];f[T+4>>2]=f[K+4>>2];break}else{f[J>>2]=0;U$(x,w);break}}else bS(x,g,-1);while(0);g=v+36|0;w=f[g>>2]|0;if(w|0?(J=w+12|0,w=f[J>>2]|0,f[J>>2]=w+-1,(w|0)==1):0)V$(v);f[g>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){J=f[H>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[d>>2]|0))}f[v>>2]=f[x>>2];K=x+4|0;J=f[K>>2]|0;f[d>>2]=J;T=x+8|0;f[O>>2]=f[T>>2];f[v+12>>2]=f[x+12>>2];V=x+16|0;f[w>>2]=f[V>>2];f[v+20>>2]=f[x+20>>2];f[v+24>>2]=f[x+24>>2];f[v+28>>2]=f[x+28>>2];f[v+32>>2]=f[x+32>>2];w=x+36|0;f[g>>2]=f[w>>2];g=v+44|0;U=f[g>>2]|0;if((U|0)==(L|0))W=J;else{wL(U);f[g>>2]=L;f[H>>2]=O;W=f[K>>2]|0}U=x+44|0;if((W|0)<3){W=f[U>>2]|0;f[L>>2]=f[W>>2];f[v+52>>2]=f[W+4>>2];X=W}else{f[g>>2]=f[U>>2];g=x+40|0;f[v+40>>2]=f[g>>2];W=x+48|0;f[U>>2]=W;f[g>>2]=T;X=W}f[x>>2]=1124007936;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[K+16>>2]=0;f[K+20>>2]=0;f[K+24>>2]=0;f[K+28>>2]=0;f[w>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((X|0)!=(x+48|0))wL(X)}X=(k|0)==0;if(X&j){Z=e?2147483647.0:3402823466385288598117041.0e14;p[x>>3]=Z;p[x+8>>3]=Z;p[x+16>>3]=Z;p[x+24>>3]=Z;lR(t,x)|0;p[x>>3]=-1.0;p[x+8>>3]=-1.0;p[x+16>>3]=-1.0;p[x+24>>3]=-1.0;lR(v,x)|0}if(l){if(!(X&(N|0)==1)){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;_=$Xc(48)|0;f[x>>2]=_;$=x+8|0;f[$>>2]=-2147483600;aa=x+4|0;f[aa>>2]=37;P=_;Q=518339;R=P+37|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));ba=_+37|0;b[ba>>0]=0;vM(-215,x,518169,518183,303)}if(f[s+16>>2]|0){X=f[s+4>>2]|0;if((X|0)<3)ca=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{l=f[s+40>>2]|0;j=0;V=1;while(1){w=Y(f[l+(j<<2)>>2]|0,V)|0;j=j+1|0;if((j|0)==(X|0)){ca=w;break}else V=w}}if(!((X|0)==0|(ca|0)==0)){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;_=$Xc(48)|0;f[x>>2]=_;$=x+8|0;f[$>>2]=-2147483600;aa=x+4|0;f[aa>>2]=37;P=_;Q=518339;R=P+37|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));ba=_+37|0;b[ba>>0]=0;vM(-215,x,518169,518183,303)}}ba=v+16|0;if(!(f[ba>>2]|0)){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;da=$Xc(16)|0;f[x>>2]=da;ea=x+8|0;f[ea>>2]=-2147483632;fa=x+4|0;f[fa>>2]=13;P=da;Q=518377;R=P+13|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));ga=da+13|0;b[ga>>0]=0;vM(-215,x,518169,518183,304)}_=f[d>>2]|0;if((_|0)<3)ha=Y(f[v+12>>2]|0,f[O>>2]|0)|0;else{O=f[H>>2]|0;aa=0;$=1;while(1){ca=Y(f[O+(aa<<2)>>2]|0,$)|0;aa=aa+1|0;if((aa|0)==(_|0)){ha=ca;break}else $=ca}}if((_|0)==0|(ha|0)==0){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;da=$Xc(16)|0;f[x>>2]=da;ea=x+8|0;f[ea>>2]=-2147483632;fa=x+4|0;f[fa>>2]=13;P=da;Q=518377;R=P+13|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));ga=da+13|0;b[ga>>0]=0;vM(-215,x,518169,518183,304)}f[x>>2]=1124007936;ga=x+4|0;da=x+8|0;Q=x+40|0;P=ga;R=P+36|0;do{f[P>>2]=0;P=P+4|0}while((P|0)<(R|0));f[Q>>2]=da;fa=x+48|0;ea=x+44|0;f[ea>>2]=fa;f[fa>>2]=0;f[x+52>>2]=0;f[y>>2]=1124007936;ha=y+4|0;_=y+8|0;$=y+40|0;P=ha;R=P+36|0;do{f[P>>2]=0;P=P+4|0}while((P|0)<(R|0));f[$>>2]=_;_=y+48|0;aa=y+44|0;f[aa>>2]=_;f[_>>2]=0;f[y+52>>2]=0;f[z>>2]=1124007936;O=z+4|0;ca=z+8|0;X=z+40|0;P=O;R=P+36|0;do{f[P>>2]=0;P=P+4|0}while((P|0)<(R|0));f[X>>2]=ca;V=z+48|0;j=z+44|0;f[j>>2]=V;f[V>>2]=0;f[z+52>>2]=0;f[A>>2]=1124007936;l=A+4|0;w=A+8|0;K=A+40|0;P=l;R=P+36|0;do{f[P>>2]=0;P=P+4|0}while((P|0)<(R|0));f[K>>2]=w;w=A+48|0;P=A+44|0;f[P>>2]=w;f[w>>2]=0;f[A+52>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=r;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=q;R=D+8|0;f[R>>2]=0;f[R+4>>2]=0;f[D>>2]=33619968;f[D+4>>2]=x;R=E+8|0;f[R>>2]=0;f[R+4>>2]=0;f[E>>2]=33619968;f[E+4>>2]=y;f[F+8>>2]=0;f[F+12>>2]=0;f[F>>2]=16842752;f[F+4>>2]=s;pGc(B,C,D,S,E,h,1,F,0,0);f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=q;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=r;R=D+8|0;f[R>>2]=0;f[R+4>>2]=0;f[D>>2]=33619968;f[D+4>>2]=z;R=E+8|0;f[R>>2]=0;f[R+4>>2]=0;f[E>>2]=33619968;f[E+4>>2]=A;f[F+8>>2]=0;f[F+12>>2]=0;f[F>>2]=16842752;f[F+4>>2]=s;pGc(B,C,D,S,E,h,1,F,0,0);F=f[da>>2]|0;E=(F|0)>0;if(e){if(E){D=f[y+16>>2]|0;C=f[$>>2]|0;B=C+4|0;R=f[aa>>2]|0;W=y+12|0;T=f[x+16>>2]|0;g=f[Q>>2]|0;U=g+4|0;J=f[ea>>2]|0;ia=x+12|0;ja=f[t+16>>2]|0;ka=f[t+40>>2]|0;la=ka+4|0;ma=f[t+44>>2]|0;na=t+12|0;oa=f[ba>>2]|0;pa=f[H>>2]|0;qa=pa+4|0;ra=f[I>>2]|0;sa=v+12|0;ta=0;ua=F;while(1){do if(!(f[y>>2]&16384)){if((f[C>>2]|0)==1){va=86;break}wa=f[R>>2]|0;if((f[B>>2]|0)==1){xa=D+(Y(wa,ta)|0)|0;break}else{ya=f[W>>2]|0;za=(ta|0)/(ya|0)|0;xa=D+(Y(za,wa)|0)+(ta-(Y(za,ya)|0)<<2)|0;break}}else va=86;while(0);if((va|0)==86){va=0;xa=D+(ta<<2)|0}ya=f[xa>>2]|0;do if(!(f[x>>2]&16384)){if((f[g>>2]|0)==1){va=92;break}za=f[J>>2]|0;if((f[U>>2]|0)==1){Aa=T+(Y(za,ta)|0)|0;break}else{wa=f[ia>>2]|0;Ba=(ta|0)/(wa|0)|0;Aa=T+(Y(Ba,za)|0)+(ta-(Y(Ba,wa)|0)<<2)|0;break}}else va=92;while(0);if((va|0)==92){va=0;Aa=T+(ta<<2)|0}wa=f[Aa>>2]|0;Ba=(f[t>>2]&16384|0)==0;do if(Ba){if((f[ka>>2]|0)==1){va=98;break}za=f[ma>>2]|0;if((f[la>>2]|0)==1){Ca=ja+(Y(za,ya)|0)|0;break}else{Da=f[na>>2]|0;Ea=(ya|0)/(Da|0)|0;Ca=ja+(Y(Ea,za)|0)+(ya-(Y(Ea,Da)|0)<<2)|0;break}}else va=98;while(0);if((va|0)==98){va=0;Ca=ja+(ya<<2)|0}if((wa|0)<(f[Ca>>2]|0)){do if(Ba){if((f[ka>>2]|0)==1){va=105;break}Da=f[ma>>2]|0;if((f[la>>2]|0)==1){Fa=ja+(Y(Da,ya)|0)|0;break}else{Ea=f[na>>2]|0;za=(ya|0)/(Ea|0)|0;Fa=ja+(Y(za,Da)|0)+(ya-(Y(za,Ea)|0)<<2)|0;break}}else va=105;while(0);if((va|0)==105){va=0;Fa=ja+(ya<<2)|0}f[Fa>>2]=wa;do if(!(f[v>>2]&16384)){if((f[pa>>2]|0)==1){va=111;break}Ba=f[ra>>2]|0;if((f[qa>>2]|0)==1){Ga=oa+(Y(Ba,ya)|0)|0;break}else{Ea=f[sa>>2]|0;za=(ya|0)/(Ea|0)|0;Ga=oa+(Y(za,Ba)|0)+(ya-(Y(za,Ea)|0)<<2)|0;break}}else va=111;while(0);if((va|0)==111){va=0;Ga=oa+(ya<<2)|0}f[Ga>>2]=ta;Ha=f[da>>2]|0}else Ha=ua;ta=ta+1|0;if((ta|0)>=(Ha|0))break;else ua=Ha}}}else if(E){E=f[y+16>>2]|0;Ha=f[$>>2]|0;ua=Ha+4|0;ta=f[aa>>2]|0;Ga=y+12|0;oa=f[x+16>>2]|0;sa=f[Q>>2]|0;qa=sa+4|0;ra=f[ea>>2]|0;pa=x+12|0;Fa=f[t+16>>2]|0;ja=f[t+40>>2]|0;na=ja+4|0;la=f[t+44>>2]|0;ma=t+12|0;ka=f[ba>>2]|0;Ca=f[H>>2]|0;Aa=Ca+4|0;T=f[I>>2]|0;ia=v+12|0;U=0;J=F;while(1){do if(!(f[y>>2]&16384)){if((f[Ha>>2]|0)==1){va=119;break}F=f[ta>>2]|0;if((f[ua>>2]|0)==1){Ia=E+(Y(F,U)|0)|0;break}else{g=f[Ga>>2]|0;xa=(U|0)/(g|0)|0;Ia=E+(Y(xa,F)|0)+(U-(Y(xa,g)|0)<<2)|0;break}}else va=119;while(0);if((va|0)==119){va=0;Ia=E+(U<<2)|0}ya=f[Ia>>2]|0;do if(!(f[x>>2]&16384)){if((f[sa>>2]|0)==1){va=125;break}g=f[ra>>2]|0;if((f[qa>>2]|0)==1){Ja=oa+(Y(g,U)|0)|0;break}else{xa=f[pa>>2]|0;F=(U|0)/(xa|0)|0;Ja=oa+(Y(F,g)|0)+(U-(Y(F,xa)|0)<<2)|0;break}}else va=125;while(0);if((va|0)==125){va=0;Ja=oa+(U<<2)|0}Z=+n[Ja>>2];xa=(f[t>>2]&16384|0)==0;do if(xa){if((f[ja>>2]|0)==1){va=131;break}F=f[la>>2]|0;if((f[na>>2]|0)==1){Ka=Fa+(Y(F,ya)|0)|0;break}else{g=f[ma>>2]|0;D=(ya|0)/(g|0)|0;Ka=Fa+(Y(D,F)|0)+(ya-(Y(D,g)|0)<<2)|0;break}}else va=131;while(0);if((va|0)==131){va=0;Ka=Fa+(ya<<2)|0}if(Z<+n[Ka>>2]){do if(xa){if((f[ja>>2]|0)==1){va=138;break}g=f[la>>2]|0;if((f[na>>2]|0)==1){La=Fa+(Y(g,ya)|0)|0;break}else{D=f[ma>>2]|0;F=(ya|0)/(D|0)|0;La=Fa+(Y(F,g)|0)+(ya-(Y(F,D)|0)<<2)|0;break}}else va=138;while(0);if((va|0)==138){va=0;La=Fa+(ya<<2)|0}n[La>>2]=Z;do if(!(f[v>>2]&16384)){if((f[Ca>>2]|0)==1){va=144;break}xa=f[T>>2]|0;if((f[Aa>>2]|0)==1){Ma=ka+(Y(xa,ya)|0)|0;break}else{D=f[ia>>2]|0;F=(ya|0)/(D|0)|0;Ma=ka+(Y(F,xa)|0)+(ya-(Y(F,D)|0)<<2)|0;break}}else va=144;while(0);if((va|0)==144){va=0;Ma=ka+(ya<<2)|0}f[Ma>>2]=U;Na=f[da>>2]|0}else Na=J;U=U+1|0;if((U|0)>=(Na|0))break;else J=Na}}Na=f[ca>>2]|0;if((Na|0)>0){J=f[A+16>>2]|0;U=f[K>>2]|0;da=U+4|0;Ma=f[P>>2]|0;ka=A+12|0;ia=f[y+16>>2]|0;Aa=f[$>>2]|0;T=Aa+4|0;Ca=f[aa>>2]|0;La=y+12|0;Fa=f[ba>>2]|0;ba=f[H>>2]|0;ma=ba+4|0;na=f[I>>2]|0;la=v+12|0;ja=0;Ka=Na;while(1){do if(!(f[A>>2]&16384)){if((f[U>>2]|0)==1){va=185;break}Na=f[Ma>>2]|0;if((f[da>>2]|0)==1){Oa=J+(Y(Na,ja)|0)|0;break}else{Ja=f[ka>>2]|0;oa=(ja|0)/(Ja|0)|0;Oa=J+(Y(oa,Na)|0)+(ja-(Y(oa,Ja)|0)<<2)|0;break}}else va=185;while(0);if((va|0)==185){va=0;Oa=J+(ja<<2)|0}ya=f[Oa>>2]|0;do if(!(f[y>>2]&16384)){if((f[Aa>>2]|0)==1){va=191;break}Ja=f[Ca>>2]|0;if((f[T>>2]|0)==1){Pa=ia+(Y(Ja,ya)|0)|0;break}else{oa=f[La>>2]|0;Na=(ya|0)/(oa|0)|0;Pa=ia+(Y(Na,Ja)|0)+(ya-(Y(Na,oa)|0)<<2)|0;break}}else va=191;while(0);if((va|0)==191){va=0;Pa=ia+(ya<<2)|0}if((f[Pa>>2]|0)==(ja|0))Qa=Ka;else{do if(!(f[v>>2]&16384)){if((f[ba>>2]|0)==1){va=198;break}oa=f[na>>2]|0;if((f[ma>>2]|0)==1){Ra=Fa+(Y(oa,ja)|0)|0;break}else{Na=f[la>>2]|0;Ja=(ja|0)/(Na|0)|0;Ra=Fa+(Y(Ja,oa)|0)+(ja-(Y(Ja,Na)|0)<<2)|0;break}}else va=198;while(0);if((va|0)==198){va=0;Ra=Fa+(ja<<2)|0}f[Ra>>2]=-1;Qa=f[ca>>2]|0}ja=ja+1|0;if((ja|0)>=(Qa|0))break;else Ka=Qa}}Qa=A+36|0;Ka=f[Qa>>2]|0;do if(Ka|0){ja=Ka+12|0;ca=f[ja>>2]|0;f[ja>>2]=ca+-1;if((ca|0)!=1)break;V$(A)}while(0);f[Qa>>2]=0;Qa=A+16|0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[Qa+8>>2]=0;f[Qa+12>>2]=0;if((f[l>>2]|0)>0){Qa=f[K>>2]|0;K=0;do{f[Qa+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[l>>2]|0))}l=f[P>>2]|0;if((l|0)!=(w|0))wL(l);l=z+36|0;w=f[l>>2]|0;do if(w|0){P=w+12|0;K=f[P>>2]|0;f[P>>2]=K+-1;if((K|0)!=1)break;V$(z)}while(0);f[l>>2]=0;l=z+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[O>>2]|0)>0){l=f[X>>2]|0;X=0;do{f[l+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[O>>2]|0))}O=f[j>>2]|0;if((O|0)!=(V|0))wL(O);O=y+36|0;V=f[O>>2]|0;do if(V|0){j=V+12|0;X=f[j>>2]|0;f[j>>2]=X+-1;if((X|0)!=1)break;V$(y)}while(0);f[O>>2]=0;O=y+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[ha>>2]|0)>0){O=f[$>>2]|0;$=0;do{f[O+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[ha>>2]|0))}ha=f[aa>>2]|0;if((ha|0)!=(_|0))wL(ha);ha=x+36|0;_=f[ha>>2]|0;do if(_|0){aa=_+12|0;$=f[aa>>2]|0;f[aa>>2]=$+-1;if(($|0)!=1)break;V$(x)}while(0);f[ha>>2]=0;ha=x+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ga>>2]|0)>0){ha=f[Q>>2]|0;Q=0;do{f[ha+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[ga>>2]|0))}ga=f[ea>>2]|0;if((ga|0)!=(fa|0))wL(ga)}else{a:do if(G){ga=(h|0)==2;if(!(ga&e))if(!(ga&M)){ga=(h|0)==5;if(!(ga&e))if(!(ga&M))if(!((h|0)==4&M))if((h|0)==6&e)Sa=117;else{if((h|0)==7&e){Sa=121;break}f[o>>2]=c;Ta=o+4|0;f[Ta>>2]=S;Ua=o+8|0;f[Ua>>2]=h;DM(x,518391,o);vM(-210,x,518169,518183,382)}else Sa=116;else Sa=115;else Sa=114}else Sa=113;else Sa=112}else{if(!(M&a)){f[o>>2]=c;Ta=o+4|0;f[Ta>>2]=S;Ua=o+8|0;f[Ua>>2]=h;DM(x,518391,o);vM(-210,x,518169,518183,382)}switch(h|0){case 2:{Sa=118;break a;break}case 5:{Sa=119;break a;break}case 4:{Sa=120;break a;break}default:{f[o>>2]=c;Ta=o+4|0;f[Ta>>2]=S;Ua=o+8|0;f[Ua>>2]=h;DM(x,518391,o);vM(-210,x,518169,518183,382)}}}while(0);o=f[i>>2]|0;f[x>>2]=0;f[x+4>>2]=o;f[y>>2]=175244;f[y+4>>2]=q;f[y+8>>2]=r;f[y+12>>2]=t;f[y+16>>2]=v;f[y+24>>2]=N;f[y+20>>2]=s;f[y+28>>2]=k;f[y+32>>2]=Sa;h3(x,y,-1.0)}y=v+36|0;x=f[y>>2]|0;if(x|0?(Sa=x+12|0,x=f[Sa>>2]|0,f[Sa>>2]=x+-1,(x|0)==1):0)V$(v);f[y>>2]=0;y=v+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[d>>2]|0)>0){y=f[H>>2]|0;H=0;do{f[y+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[d>>2]|0))}d=f[I>>2]|0;if((d|0)!=(L|0))wL(d);d=t+36|0;L=f[d>>2]|0;if(L|0?(I=L+12|0,L=f[I>>2]|0,f[I>>2]=L+-1,(L|0)==1):0)V$(t);f[d>>2]=0;d=t+16|0;L=t+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[L>>2]|0)>0){d=f[t+40>>2]|0;I=0;do{f[d+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[L>>2]|0))}L=f[t+44>>2]|0;if((L|0)!=(t+48|0))wL(L);L=s+36|0;t=f[L>>2]|0;if(t|0?(I=t+12|0,t=f[I>>2]|0,f[I>>2]=t+-1,(t|0)==1):0)V$(s);f[L>>2]=0;L=s+16|0;t=s+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[t>>2]|0)>0){L=f[s+40>>2]|0;I=0;do{f[L+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))wL(t);t=r+36|0;s=f[t>>2]|0;do if(s|0){I=s+12|0;L=f[I>>2]|0;f[I>>2]=L+-1;if((L|0)!=1)break;V$(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;L=0;do{f[t+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))wL(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){L=r+12|0;t=f[L>>2]|0;f[L>>2]=t+-1;if((t|0)!=1)break;V$(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)==(q+48|0)){u=m;return}wL(r);u=m;return}function qGc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=(e|0)>0;if(!i){if(j)k=0;else return;do{l=VN(a,c+(Y(k,d)|0)|0,g,2)|0;f[h+(k<<2)>>2]=l;k=k+1|0}while((k|0)!=(e|0));return}if(j)m=0;else return;do{if(!(b[i+m>>0]|0))n=2147483647;else n=VN(a,c+(Y(m,d)|0)|0,g,2)|0;f[h+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(e|0));return}function rGc(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(!d)return;j=f+-4|0;k=f&-4;if((f|0)<4){l=(f|0)>0;m=0;do{o=c+((Y(m,i)|0)<<2)|0;if(l){p=0;q=0.0;while(1){r=q+ +L(+(+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2]));p=p+1|0;if((p|0)==(f|0)){s=r;break}else q=r}}else s=0.0;n[g+(m<<2)>>2]=s;m=m+1|0}while((m|0)!=(e|0));return}m=(k|0)<(f|0);l=0;do{p=c+((Y(l,i)|0)<<2)|0;o=0;s=0.0;do{t=o|1;u=o|2;v=o|3;s=s+(+L(+(+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2]))+ +L(+(+n[a+(t<<2)>>2]-+n[p+(t<<2)>>2]))+ +L(+(+n[a+(u<<2)>>2]-+n[p+(u<<2)>>2]))+ +L(+(+n[a+(v<<2)>>2]-+n[p+(v<<2)>>2])));o=o+4|0}while((o|0)<=(j|0));if(m){o=k;q=s;while(1){r=q+ +L(+(+n[a+(o<<2)>>2]-+n[p+(o<<2)>>2]));o=o+1|0;if((o|0)==(f|0)){w=r;break}else q=r}}else w=s;n[g+(l<<2)>>2]=w;l=l+1|0}while((l|0)!=(e|0));return}if(!d)return;d=f+-4|0;l=f&-4;if((f|0)<4){k=(f|0)>0;m=0;do{if(b[h+m>>0]|0){j=c+((Y(m,i)|0)<<2)|0;if(k){o=0;w=0.0;while(1){q=w+ +L(+(+n[a+(o<<2)>>2]-+n[j+(o<<2)>>2]));o=o+1|0;if((o|0)==(f|0)){x=q;break}else w=q}}else x=0.0}else x=3402823466385288598117041.0e14;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}m=(l|0)<(f|0);k=0;do{if(b[h+k>>0]|0){o=c+((Y(k,i)|0)<<2)|0;j=0;x=0.0;do{p=j|1;v=j|2;u=j|3;x=x+(+L(+(+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2]))+ +L(+(+n[a+(p<<2)>>2]-+n[o+(p<<2)>>2]))+ +L(+(+n[a+(v<<2)>>2]-+n[o+(v<<2)>>2]))+ +L(+(+n[a+(u<<2)>>2]-+n[o+(u<<2)>>2])));j=j+4|0}while((j|0)<=(d|0));if(m){j=l;w=x;while(1){s=w+ +L(+(+n[a+(j<<2)>>2]-+n[o+(j<<2)>>2]));j=j+1|0;if((j|0)==(f|0)){y=s;break}else w=s}}else y=x}else y=3402823466385288598117041.0e14;n[g+(k<<2)>>2]=y;k=k+1|0}while((k|0)!=(e|0));return}function sGc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=(e|0)>0;if(!i){if(j)k=0;else return;do{l=r1(a,c+(Y(k,d)|0)|0,g)|0;f[h+(k<<2)>>2]=l;k=k+1|0}while((k|0)!=(e|0));return}if(j)m=0;else return;do{if(!(b[i+m>>0]|0))n=2147483647;else n=r1(a,c+(Y(m,d)|0)|0,g)|0;f[h+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(e|0));return}function tGc(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(f|0)){u=t;break}else r=t}}else u=0.0;r=+M(+u);n[g+(o<<2)>>2]=r;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;u=0.0;do{r=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);v=p|1;t=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|2;s=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|3;w=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);u=u+(r*r+t*t+s*s+w*w);p=p+4|0}while((p|0)<=(k|0));if(o){p=l;w=u;while(1){s=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);t=w+s*s;p=p+1|0;if((p|0)==(f|0)){x=t;break}else w=t}}else x=u;w=+M(+x);n[g+(m<<2)>>2]=w;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(!(b[i+o>>0]|0))y=3402823466385288598117041.0e14;else{k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){w=+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0);t=x+w*w;p=p+1|0;if((p|0)==(f|0)){z=t;break}else x=t}}else z=0.0;y=+M(+z)}n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(!(b[i+l>>0]|0))A=3402823466385288598117041.0e14;else{p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{z=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);q=k|1;x=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|2;u=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|3;t=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);y=y+(z*z+x*x+u*u+t*t);k=k+4|0}while((k|0)<=(j|0));if(o){k=m;t=y;while(1){u=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);x=t+u*u;k=k+1|0;if((k|0)==(f|0)){B=x;break}else t=x}}else B=y;A=+M(+B)}n[g+(l<<2)>>2]=A;l=l+1|0}while((l|0)!=(e|0));return}function uGc(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(f|0)){u=t;break}else r=t}}else u=0.0;n[g+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;u=0.0;do{r=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);v=p|1;t=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|2;s=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);v=p|3;w=+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0);u=u+(r*r+t*t+s*s+w*w);p=p+4|0}while((p|0)<=(k|0));if(o){p=l;w=u;while(1){s=+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0);t=w+s*s;p=p+1|0;if((p|0)==(f|0)){x=t;break}else w=t}}else x=u;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(b[i+o>>0]|0){k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){w=+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0);t=x+w*w;p=p+1|0;if((p|0)==(f|0)){y=t;break}else x=t}}else y=0.0}else y=3402823466385288598117041.0e14;n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(b[i+l>>0]|0){p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{x=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);q=k|1;u=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|2;t=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);q=k|3;w=+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0);y=y+(x*x+u*u+t*t+w*w);k=k+4|0}while((k|0)<=(j|0));if(o){k=m;w=y;while(1){t=+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0);u=w+t*t;k=k+1|0;if((k|0)==(f|0)){z=u;break}else w=u}}else z=y}else z=3402823466385288598117041.0e14;n[g+(l<<2)>>2]=z;l=l+1|0}while((l|0)!=(e|0));return}function vGc(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=(e|0)>0;if(!j){if(!k)return;l=g+-4|0;m=g&-4;if((g|0)<4){n=(g|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(n){q=0;r=0;while(1){s=(h[a+q>>0]|0)-(h[p+q>>0]|0)|0;t=(Y(s,s)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){u=t;break}else r=t}}else u=0;f[i+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(g|0);u=0;do{n=c+(Y(u,d)|0)|0;r=0;q=0;do{p=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;t=r|1;s=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|2;v=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|3;w=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;q=(Y(p,p)|0)+q+(Y(s,s)|0)+(Y(v,v)|0)+(Y(w,w)|0)|0;r=r+4|0}while((r|0)<=(l|0));if(o){r=m;w=q;while(1){v=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;s=(Y(v,v)|0)+w|0;r=r+1|0;if((r|0)==(g|0)){x=s;break}else w=s}}else x=q;f[i+(u<<2)>>2]=x;u=u+1|0}while((u|0)!=(e|0));return}if(!k)return;k=g+-4|0;u=g&-4;if((g|0)<4){x=(g|0)>0;m=0;do{if(b[j+m>>0]|0){o=c+(Y(m,d)|0)|0;if(x){l=0;w=0;while(1){r=(h[a+l>>0]|0)-(h[o+l>>0]|0)|0;n=(Y(r,r)|0)+w|0;l=l+1|0;if((l|0)==(g|0)){y=n;break}else w=n}}else y=0}else y=2147483647;f[i+(m<<2)>>2]=y;m=m+1|0}while((m|0)!=(e|0));return}m=(u|0)<(g|0);y=0;do{if(b[j+y>>0]|0){x=c+(Y(y,d)|0)|0;w=0;l=0;do{o=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;q=w|1;n=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|2;r=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|3;s=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;l=(Y(o,o)|0)+l+(Y(n,n)|0)+(Y(r,r)|0)+(Y(s,s)|0)|0;w=w+4|0}while((w|0)<=(k|0));if(m){w=u;s=l;while(1){r=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;n=(Y(r,r)|0)+s|0;w=w+1|0;if((w|0)==(g|0)){z=n;break}else s=n}}else z=l}else z=2147483647;f[i+(y<<2)>>2]=z;y=y+1|0}while((y|0)!=(e|0));return}function wGc(a,c,d,e,f,g,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;j=(e|0)>0;if(!i){if(!j)return;k=f+-4|0;l=f&-4;if((f|0)<4){m=(f|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(m){q=0;r=0.0;while(1){s=r+ +L(+(+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0)));q=q+1|0;if((q|0)==(f|0)){t=s;break}else r=s}}else t=0.0;n[g+(o<<2)>>2]=t;o=o+1|0}while((o|0)!=(e|0));return}o=(l|0)<(f|0);m=0;do{q=c+(Y(m,d)|0)|0;p=0;t=0.0;do{u=p|1;v=p|2;w=p|3;t=t+(+L(+(+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0)))+ +L(+(+((h[a+u>>0]|0)-(h[q+u>>0]|0)|0)))+ +L(+(+((h[a+v>>0]|0)-(h[q+v>>0]|0)|0)))+ +L(+(+((h[a+w>>0]|0)-(h[q+w>>0]|0)|0))));p=p+4|0}while((p|0)<=(k|0));if(o){p=l;r=t;while(1){s=r+ +L(+(+((h[a+p>>0]|0)-(h[q+p>>0]|0)|0)));p=p+1|0;if((p|0)==(f|0)){x=s;break}else r=s}}else x=t;n[g+(m<<2)>>2]=x;m=m+1|0}while((m|0)!=(e|0));return}if(!j)return;j=f+-4|0;m=f&-4;if((f|0)<4){l=(f|0)>0;o=0;do{if(b[i+o>>0]|0){k=c+(Y(o,d)|0)|0;if(l){p=0;x=0.0;while(1){r=x+ +L(+(+((h[a+p>>0]|0)-(h[k+p>>0]|0)|0)));p=p+1|0;if((p|0)==(f|0)){y=r;break}else x=r}}else y=0.0}else y=3402823466385288598117041.0e14;n[g+(o<<2)>>2]=y;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(f|0);l=0;do{if(b[i+l>>0]|0){p=c+(Y(l,d)|0)|0;k=0;y=0.0;do{q=k|1;w=k|2;v=k|3;y=y+(+L(+(+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0)))+ +L(+(+((h[a+q>>0]|0)-(h[p+q>>0]|0)|0)))+ +L(+(+((h[a+w>>0]|0)-(h[p+w>>0]|0)|0)))+ +L(+(+((h[a+v>>0]|0)-(h[p+v>>0]|0)|0))));k=k+4|0}while((k|0)<=(j|0));if(o){k=m;x=y;while(1){t=x+ +L(+(+((h[a+k>>0]|0)-(h[p+k>>0]|0)|0)));k=k+1|0;if((k|0)==(f|0)){z=t;break}else x=t}}else z=y}else z=3402823466385288598117041.0e14;n[g+(l<<2)>>2]=z;l=l+1|0}while((l|0)!=(e|0));return}function xGc(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=(e|0)>0;if(!j){if(!k)return;l=g+-4|0;m=g&-4;if((g|0)<4){n=(g|0)>0;o=0;do{p=c+(Y(o,d)|0)|0;if(n){q=0;r=0;while(1){s=(h[a+q>>0]|0)-(h[p+q>>0]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(g|0)){u=t;break}else r=t}}else u=0;f[i+(o<<2)>>2]=u;o=o+1|0}while((o|0)!=(e|0));return}o=(m|0)<(g|0);u=0;do{n=c+(Y(u,d)|0)|0;r=0;q=0;do{p=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;t=r|1;s=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|2;v=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;t=r|3;w=(h[a+t>>0]|0)-(h[n+t>>0]|0)|0;q=((p|0)>-1?p:0-p|0)+q+((s|0)>-1?s:0-s|0)+((v|0)>-1?v:0-v|0)+((w|0)>-1?w:0-w|0)|0;r=r+4|0}while((r|0)<=(l|0));if(o){r=m;w=q;while(1){v=(h[a+r>>0]|0)-(h[n+r>>0]|0)|0;s=((v|0)>-1?v:0-v|0)+w|0;r=r+1|0;if((r|0)==(g|0)){x=s;break}else w=s}}else x=q;f[i+(u<<2)>>2]=x;u=u+1|0}while((u|0)!=(e|0));return}if(!k)return;k=g+-4|0;u=g&-4;if((g|0)<4){x=(g|0)>0;m=0;do{if(b[j+m>>0]|0){o=c+(Y(m,d)|0)|0;if(x){l=0;w=0;while(1){r=(h[a+l>>0]|0)-(h[o+l>>0]|0)|0;n=((r|0)>-1?r:0-r|0)+w|0;l=l+1|0;if((l|0)==(g|0)){y=n;break}else w=n}}else y=0}else y=2147483647;f[i+(m<<2)>>2]=y;m=m+1|0}while((m|0)!=(e|0));return}m=(u|0)<(g|0);y=0;do{if(b[j+y>>0]|0){x=c+(Y(y,d)|0)|0;w=0;l=0;do{o=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;q=w|1;n=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|2;r=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;q=w|3;s=(h[a+q>>0]|0)-(h[x+q>>0]|0)|0;l=((o|0)>-1?o:0-o|0)+l+((n|0)>-1?n:0-n|0)+((r|0)>-1?r:0-r|0)+((s|0)>-1?s:0-s|0)|0;w=w+4|0}while((w|0)<=(k|0));if(m){w=u;s=l;while(1){r=(h[a+w>>0]|0)-(h[x+w>>0]|0)|0;n=((r|0)>-1?r:0-r|0)+s|0;w=w+1|0;if((w|0)==(g|0)){z=n;break}else s=n}}else z=l}else z=2147483647;f[i+(y<<2)>>2]=z;y=y+1|0}while((y|0)!=(e|0));return}function yGc(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(d)j=0;else return;do{k=+M(+(+WN(a,c+((Y(j,i)|0)<<2)|0,f)));n[g+(j<<2)>>2]=k;j=j+1|0}while((j|0)!=(e|0));return}if(d)l=0;else return;do{if(!(b[h+l>>0]|0))m=3402823466385288598117041.0e14;else m=+M(+(+WN(a,c+((Y(l,i)|0)<<2)|0,f)));n[g+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(e|0));return}function zGc(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0.0;i=d>>>2;d=(e|0)>0;if(!h){if(d)j=0;else return;do{k=+WN(a,c+((Y(j,i)|0)<<2)|0,f);n[g+(j<<2)>>2]=k;j=j+1|0}while((j|0)!=(e|0));return}if(d)l=0;else return;do{if(!(b[h+l>>0]|0))m=3402823466385288598117041.0e14;else m=+WN(a,c+((Y(l,i)|0)<<2)|0,f);n[g+(l<<2)>>2]=m;l=l+1|0}while((l|0)!=(e|0));return}function AGc(a){a=a|0;cYc(a);return}function BGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+1072|0;d=c;e=a+8|0;g=f[e>>2]|0;h=f[g+8>>2]|0;i=d+8|0;f[d>>2]=i;j=d+4|0;f[j>>2]=h;if(h>>>0>264){k=bYc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=k;l=k}else l=i;k=f[b>>2]|0;h=b+4|0;if((k|0)<(f[h>>2]|0)){b=a+32|0;m=a+4|0;n=a+24|0;o=a+20|0;p=a+16|0;q=a+12|0;r=a+28|0;a=k;k=g;while(1){g=f[m>>2]|0;s=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0;if((f[n>>2]|0)>0)t=l;else{g=f[q>>2]|0;t=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0}g=f[o>>2]|0;v=f[g+16>>2]|0;if(!v)w=0;else w=v+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0;Ii[f[b>>2]&127](s,f[k+16>>2]|0,f[k+48>>2]|0,f[k+8>>2]|0,f[k+12>>2]|0,t,w);s=f[n>>2]|0;a:do if((s|0)>0?(g=f[p>>2]|0,v=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0,g=f[q>>2]|0,x=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,a)|0)|0,g=(f[e>>2]|0)+8|0,y=f[g>>2]|0,(y|0)>0):0){z=0;A=y;y=s;while(1){B=f[l+(z<<2)>>2]|0;C=y+-1|0;if((B|0)<(f[x+(C<<2)>>2]|0)){D=y+-2|0;b:do if((D|0)>-1){E=D;F=C;while(1){G=x+(E<<2)|0;if((f[G>>2]|0)<=(B|0)){H=F;break b}f[v+(F<<2)>>2]=f[v+(E<<2)>>2];f[x+(F<<2)>>2]=f[G>>2];if((E|0)>0){G=E;E=E+-1|0;F=G}else{H=E;break}}}else H=C;while(0);f[v+(H<<2)>>2]=(f[r>>2]|0)+z;f[x+(H<<2)>>2]=B;I=f[g>>2]|0}else I=A;C=z+1|0;if((C|0)>=(I|0))break a;z=C;A=I;y=f[n>>2]|0}}while(0);s=a+1|0;if((s|0)>=(f[h>>2]|0))break;a=s;k=f[e>>2]|0}J=f[d>>2]|0}else J=l;if((J|0)==(i|0)){u=c;return}if(J|0)dYc(J);f[d>>2]=i;f[j>>2]=264;u=c;return}function CGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!(b&2147483647)){c=b>>31&-822083584;f[a>>2]=c;return}d=(b|0)<0?0-b|0:b;e=d>>>0<65536;g=e?d<<16:d;i=e?16:0;e=g>>>0<16777216;j=((h[518485+((e?g<<8:g)>>>24)>>0]|0)+((e?i|8:i)&255)<<24)+-16777216|0;i=j>>24;e=156-i|0;if((j|0)>100663296&e>>>0<253){c=(d<<i+-7)+(b&-2147483648)+(b|0?e<<23:0)|0;f[a>>2]=c;return}j=d<<i;i=j&127;do if(e>>>0>252){if((e|0)>=0){if(!((e|0)>253|(j+64|0)<0)){k=e;l=i;m=j;break}c=b&-2147483648|2139095040;f[a>>2]=c;return}d=0-e|0;if(d>>>0<31)n=(j<<(e&31)|0)!=0|j>>>d;else n=(j|0)!=0&1;k=0;l=n&127;m=n}else{k=e;l=i;m=j}while(0);j=(m+64|0)>>>7&~(l<<24>>24==64);c=((j|0)==0?0:k<<23)+(j|b&-2147483648)|0;f[a>>2]=c;return}function DGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[b>>2]|0;b=c>>>23;d=c&8388607;a:do switch((b&255)<<24>>24){case -1:{e=c>>>31;if(!d){g=u1c(e|0,0,63)|0;i=g;j=J|2146435072;break a}else{g=u1c(e|0,0,63)|0;e=J;k=u1c(c|0,0,29)|0;i=k|g;j=J|e|2146959360;break a}break}case 0:{if(!d){e=u1c(c>>>31|0,0,63)|0;i=e;j=J;break a}else{e=d>>>0<65536;g=e?c<<16:d;k=e?16:0;e=g>>>0<16777216;l=((h[518485+((e?g<<8:g)>>>24)>>0]|0)+((e?k|8:k)&255)<<24)+-134217728>>24;m=0-l|0;n=d<<l;o=8;break a}break}default:{m=b&255;n=d;o=8}}while(0);if((o|0)==8){o=u1c(c>>>31|0,0,63)|0;c=J;d=u1c(m+896|0,0,52)|0;m=J;b=u1c(n|0,0,29)|0;n=d1c(d|0,m|0,b|o|0,J|c|0)|0;i=n;j=J}n=a;f[n>>2]=i;f[n+4>>2]=j;return}function EGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){FGc(a,d,b);return}else{GGc(a,d,b);return}}function FGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=b>>>23&255;e=b&8388607;g=c>>>23&255;i=c&8388607;j=d-g|0;a:do if(!j){if((d|0)==255){if(!(i|e))k=-4194304;else break;f[a>>2]=k;return}l=e-i|0;if(!l){k=0;f[a>>2]=k;return}m=(d|0)==0?0:d+-1|0;n=(l|0)<0;o=n?0-l|0:l;l=o>>>0<65536;p=l?o<<16:o;q=l?16:0;l=p>>>0<16777216;r=((h[518485+((l?p<<8:p)>>>24)>>0]|0)+((l?q|8:q)&255)&255)+248|0;q=m-(r<<24>>24)|0;l=(q|0)<0;k=(l?0:q<<23)+(((n?(b|0)>-1:(b|0)<0)&1)<<31)+(o<<((l?m:r)<<24>>24))|0;f[a>>2]=k;return}else{r=e<<7;m=i<<7;do if((j|0)<0){if((g|0)!=255){s=(d|0?1073741824:r)+r|0;t=m;u=0-j|0;v=g;w=(b|0)>-1;break}if(i|0)break a;k=(b&-2147483648)+-8388608|0;f[a>>2]=k;return}else{if((d|0)!=255){s=(g|0?1073741824:m)+m|0;t=r;u=j;v=d;w=(b|0)<0;break}if(!e)k=b;else break a;f[a>>2]=k;return}while(0);if(u>>>0<31)x=(s<<(0-u&31)|0)!=0|s>>>u;else x=(s|0)!=0&1;r=(t|1073741824)-x|0;m=r>>>0<65536;l=m?r<<16:r;o=m?16:0;m=l>>>0<16777216;n=(((m?o|8:o)&255)+(h[518485+((m?l<<8:l)>>>24)>>0]|0)<<24)+-16777216|0;l=n>>24;m=v+-1-l|0;if((n|0)>100663296&m>>>0<253){k=(r<<l+-7)+((w&1)<<31)+(r|0?m<<23:0)|0;f[a>>2]=k;return}n=r<<l;l=n&127;do if(m>>>0>252){if((m|0)>=0){if(!((m|0)>253|(n+64|0)<0)){y=m;z=l;A=n;break}k=(w&1)<<31|2139095040;f[a>>2]=k;return}r=0-m|0;if(r>>>0<31)B=(n<<(m&31)|0)!=0|n>>>r;else B=(n|0)!=0&1;y=0;z=B&127;A=B}else{y=m;z=l;A=n}while(0);n=(A+64|0)>>>7&~(z<<24>>24==64);k=((n|0)==0?0:y<<23)+(n|(w&1)<<31)|0;f[a>>2]=k;return}while(0);k=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(e|0)==0?c:b)|4194304;f[a>>2]=k;return}function GGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=b>>>23;e=d&255;g=b&8388607;h=c>>>23;i=h&255;j=c&8388607;k=e-i|0;a:do if(!k)switch((d&255)<<24>>24){case 0:{l=j+b|0;f[a>>2]=l;return}case -1:{if(!(j|g))l=b;else{m=30;break a}f[a>>2]=l;return}default:{n=(g|16777216)+j|0;if(!(e>>>0<254&(c+b&1|0)==0)){o=n<<6;p=e;break a}l=(e<<23|b&-2147483648)+(n>>>1)|0;f[a>>2]=l;return}}else{n=g<<6;q=j<<6;do if((k|0)<0)if((i|0)!=255){r=(e|0?536870912:n)+n|0;s=0-k|0;if(s>>>0<31){t=i;u=(r<<(d-h&31)|0)!=0|r>>>s;v=q;break}else{t=i;u=(r|0)!=0&1;v=q;break}}else{if(j|0){m=30;break a}l=b&-2147483648|2139095040;f[a>>2]=l;return}else{if((e|0)==255){if(!g)l=b;else{m=30;break a}f[a>>2]=l;return}r=(i|0?536870912:q)+q|0;if(k>>>0<31){t=e;u=n;v=(r<<(0-k&31)|0)!=0|r>>>k;break}else{t=e;u=n;v=(r|0)!=0&1;break}}while(0);n=v+536870912+u|0;q=n>>>0<1073741824;o=n<<(q&1);p=(q<<31>>31)+t|0}while(0);if((m|0)==30){l=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(g|0)==0?c:b)|4194304;f[a>>2]=l;return}c=o&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(o+64|0)<0)){w=p;x=c;y=o;break}l=b&-2147483648|2139095040;f[a>>2]=l;return}g=0-p|0;if(g>>>0<31)z=(o<<(p&31)|0)!=0|o>>>g;else z=(o|0)!=0&1;w=0;x=z&127;y=z}else{w=p;x=c;y=o}while(0);o=(y+64|0)>>>7&~(x<<24>>24==64);l=((o|0)==0?0:w<<23)+(o|b&-2147483648)|0;f[a>>2]=l;return}function HGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){GGc(a,d,b);return}else{FGc(a,d,b);return}}function IGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23&255;i=b&8388607;j=b^d;do if((c|0)==255)if((e|0)==0?!((i|0)!=0&(g|0)==255):0){k=g|i;l=24}else l=23;else{if((g|0)==255){if(i|0){l=23;break}k=c|e;l=24;break}if(!c){if(e|0){m=e>>>0<65536;n=m?d<<16:e;o=m?16:0;m=n>>>0<16777216;p=((h[518485+((m?n<<8:n)>>>24)>>0]|0)+((m?o|8:o)&255)<<24)+-134217728>>24;q=1-p|0;r=e<<p;l=11}}else{q=c;r=e;l=11}do if((l|0)==11){if(!g){if(!i)break;p=i>>>0<65536;o=p?b<<16:i;m=p?16:0;p=o>>>0<16777216;n=((h[518485+((p?o<<8:o)>>>24)>>0]|0)+((p?m|8:m)&255)<<24)+-134217728>>24;s=i<<n;t=1-n|0}else{s=i;t=g}n=x1c(s<<8|-2147483648|0,0,r<<7|1073741824|0,0)|0;m=((n&-32768|0)!=0|0!=0)&1|J;n=m>>>0<1073741824;p=t+q+(n?-128:-127)|0;o=m<<(n&1);n=o&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(o+64|0)<0)){u=p;v=n;w=o;break}x=j&-2147483648|2139095040;f[a>>2]=x;return}m=0-p|0;if(m>>>0<31)y=(o<<(p&31)|0)!=0|o>>>m;else y=(o|0)!=0&1;u=0;v=y&127;w=y}else{u=p;v=n;w=o}while(0);o=(w+64|0)>>>7&~(v<<24>>24==64);x=((o|0)==0?0:u<<23)+(o|j&-2147483648)|0;f[a>>2]=x;return}while(0);x=j&-2147483648;f[a>>2]=x;return}while(0);if((l|0)==23){x=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=x;return}else if((l|0)==24){x=(k|0)==0?-4194304:j&-2147483648|2139095040;f[a>>2]=x;return}}function JGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23;i=g&255;j=b&8388607;k=b^d;a:do if((c|0)==255)if(!e)if((i|0)==255)if(!j){l=-4194304;f[a>>2]=l;return}else m=22;else m=23;else m=22;else{b:do switch((g&255)<<24>>24){case -1:{if(j|0){m=22;break a}break}case 0:{if(j|0){n=j>>>0<65536;o=n?b<<16:j;p=n?16:0;n=o>>>0<16777216;q=((h[518485+((n?o<<8:o)>>>24)>>0]|0)+((n?p|8:p)&255)<<24)+-134217728>>24;r=j<<q;s=1-q|0;m=10;break b}if(!(c|e))l=-4194304;else{m=23;break a}f[a>>2]=l;return}default:{r=j;s=i;m=10}}while(0);do if((m|0)==10){if(!c){if(!e)break;q=e>>>0<65536;p=q?d<<16:e;n=q?16:0;q=p>>>0<16777216;o=((h[518485+((q?p<<8:p)>>>24)>>0]|0)+((q?n|8:n)&255)<<24)+-134217728>>24;t=1-o|0;u=e<<o}else{t=c;u=e}o=u|8388608;n=r|8388608;q=o>>>0<n>>>0;p=(q?125:126)+(t-s)|0;v=u1c(o|0,0,(q?31:30)|0)|0;q=J;o=n1c(v|0,q|0,n|0,0)|0;w=x1c(o|0,0,n|0,0)|0;n=(o&63|0)==0&((w|0)!=(v|0)|(J|0)!=(q|0))&1|o;o=n&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(n+64|0)<0)){x=p;y=o;z=n;break}l=k&-2147483648|2139095040;f[a>>2]=l;return}q=0-p|0;if(q>>>0<31)A=(n<<(p&31)|0)!=0|n>>>q;else A=(n|0)!=0&1;x=0;y=A&127;z=A}else{x=p;y=o;z=n}while(0);n=(z+64|0)>>>7&~(y<<24>>24==64);l=((n|0)==0?0:x<<23)+(n|k&-2147483648)|0;f[a>>2]=l;return}while(0);l=k&-2147483648;f[a>>2]=l;return}while(0);if((m|0)==22){l=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=l;return}else if((m|0)==23){l=k&-2147483648|2139095040;f[a>>2]=l;return}}function KGc(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;b=f[a>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((b&2139095040|0)!=2139095040|(b&8388607|0)==0)){d=0;return d|0}a=c>>>31;if((a|0)==(b>>>31|0)){d=(c|0)!=(b|0)&(a|0)!=(c>>>0<b>>>0|0);return d|0}else{d=(c|0)<0&((b|c)&2147483647|0)!=0;return d|0}return 0}function LGc(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a>>2]|0;a=f[b>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((a&2139095040|0)!=2139095040|(a&8388607|0)==0)){d=0;return d|0}b=c>>>31;if((b|0)==(a>>>31|0)){d=(c|0)!=(a|0)&(b|0)!=(c>>>0<a>>>0|0);return d|0}else{d=(c|0)<0&((a|c)&2147483647|0)!=0;return d|0}return 0}function MGc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=(e|0)==0;i=g?32:0;j=g?d:e;g=j>>>0<65536;k=g?i|16:i;i=g?j<<16:j;j=i>>>0<16777216;g=((h[518485+((j?i<<8:i)>>>24)>>0]|0)+((j?k|8:k)&255)<<24)+-16777216|0;k=g>>24;j=c-k|0;if((g|0)>150994944&j>>>0<2045){g=u1c(b&1|0,0,63)|0;c=J;i=(d|0)!=0|(e|0)!=0;l=u1c(j|0,0,52)|0;m=i?J:0;n=u1c(d|0,e|0,k+-10|0)|0;o=d1c(n|0,J|0,g|0,c|0)|0;c=d1c(o|0,J|0,(i?l:0)|0,m|0)|0;p=J;q=c;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}c=u1c(d|0,e|0,k|0)|0;k=J;e=c&1023;do if((j&65535)>>>0>2044){if((j|0)>=0){d1c(c|0,k|0,512,0)|0;if(!((j|0)>2045|(J|0)<0)){v=j;w=e;x=c;y=k;break}d=u1c(b&1|0,0,63)|0;p=J|2146435072;q=d;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}d=0-j|0;if(d>>>0<63){m=l1c(c|0,k|0,d|0)|0;d=J;l=u1c(c|0,k|0,j&63|0)|0;z=d;A=((l|0)!=0|(J|0)!=0)&1|m}else{z=0;A=((c|0)!=0|(k|0)!=0)&1}v=0;w=A&1023;x=A;y=z}else{v=j;w=e;x=c;y=k}while(0);k=d1c(x|0,y|0,512,0)|0;y=l1c(k|0,J|0,10)|0;k=J;x=y&~((w|0)==512);w=(x|0)==0&(k|0)==0;y=u1c(b&1|0,0,63)|0;b=J;c=u1c(v|0,0,52)|0;v=d1c((w?0:c)|0,(w?0:J)|0,x|y|0,k|b|0)|0;p=J;q=v;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}function NGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!b){c=0;d=0;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}k=(b|0)<0?0-b|0:b;l=k>>>0<65536;m=l?k<<16:k;n=l?16:0;l=m>>>0<16777216;o=(h[518485+((l?m<<8:m)>>>24)>>0]|0)+((l?n|8:n)&255)|0;n=u1c(b>>>31|0,0,63)|0;b=J;l=(o<<24)+352321536>>24;o=u1c(1074-l|0,0,52)|0;m=J;p=u1c(k|0,0,l|0)|0;l=d1c(p|0,J|0,n|0,b|0)|0;b=d1c(l|0,J|0,o|0,m|0)|0;c=b;d=J;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}function OGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=(c|0)<0;if((b|0)==0&(c&2147483647|0)==0){k1c(b|0,c|0,63)|0;h=e;f[h>>2]=0;f[h+4>>2]=J&-1008730112}else{h=c1c(0,0,b|0,c|0)|0;MGc(e,g,1084,g?h:b,g?J:c)}if((e|0)==(a|0)){u=d;return}c=e;e=f[c+4>>2]|0;g=a;f[g>>2]=f[c>>2];f[g+4>>2]=e;u=d;return}function PGc(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;a=b>>>23&255;c=158-a|0;if((c|0)>31){d=0;return d|0}if((c|0)<1){d=(b|0)==-822083584?-2147483648:(b&8388607|0)!=0&(a|0)==255?2147483647:(b>>>31)+2147483647|0;return d|0}else{a=(b<<8|-2147483648)>>>c;d=(b|0)<0?0-a|0:a;return d|0}return 0}function QGc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;a=b>>>23&255;c=b&8388607;d=(b|0)<0&((c|0)==0|(a|0)!=255);b=(a|0)==0?c:c|8388608;c=170-a|0;do if((c|0)>0)if(c>>>0<63){a=l1c(0,b|0,c|0)|0;e=J;g=u1c(0,b|0,0-c&63|0)|0;h=((g|0)!=0|(J|0)!=0)&1|a;i=e;break}else{h=(b|0)!=0&1;i=0;break}else{h=0;i=b}while(0);b=d1c(h|0,i|0,2048,0)|0;i=J;if(!(i>>>0>4095|(i|0)==4095&b>>>0>4294967295)){c=l1c(b|0,i|0,12)|0;i=(h&4095|0)==2048&0==0&1;h=d?(i|~c)+1|0:c&~i;if(!h){j=0;return j|0}if((h>>>31|0)==(d&1|0)){j=h;return j|0}}j=d?-2147483648:2147483647;return j|0}function RGc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=l1c(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1063-d|0;do if((b|0)>0)if(b>>>0<63){d=l1c(g|0,a|0,b|0)|0;c=J;h=u1c(g|0,a|0,0-b&63|0)|0;i=((h|0)!=0|(J|0)!=0)&1|d;j=c;break}else{i=((g|0)!=0|(a|0)!=0)&1;j=0;break}else{i=g;j=a}while(0);a=d1c(i|0,j|0,2048,0)|0;j=J;if(!(j>>>0>4095|(j|0)==4095&a>>>0>4294967295)){g=l1c(a|0,j|0,12)|0;j=(i&4095|0)==2048&0==0&1;i=e?(j|~g)+1|0:g&~j;if(!i){k=0;return k|0}if((i>>>31|0)==(e&1|0)){k=i;return k|0}}k=e?-2147483648:2147483647;return k|0}function SGc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=l1c(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1063-d|0;do if((b|0)>0)if(b>>>0<63){d=l1c(g|0,a|0,b|0)|0;c=J;h=u1c(g|0,a|0,0-b&63|0)|0;i=((h|0)!=0|(J|0)!=0)&1|d;j=c;break}else{i=((g|0)!=0|(a|0)!=0)&1;j=0;break}else{i=g;j=a}while(0);a=d1c(i|0,j|0,(e?4095:0)|0,(e?0:0)|0)|0;j=J;if(!(j>>>0>4095|(j|0)==4095&a>>>0>4294967295)){i=l1c(a|0,j|0,12)|0;j=e?0-i|0:i;if(!j){k=0;return k|0}if((j>>>31|0)==(e&1|0)){k=j;return k|0}}k=e?-2147483648:2147483647;return k|0}function TGc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=l1c(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1075-d|0;if((b|0)<1){d=u1c(g|0,a|0,0-b|0)|0;c=J;if((b|0)<-11|(c|0)<0){h=e?-2147483648:2147483647;i=e?0:-1;J=h;return i|0}else{j=c1c(0,0,d|0,c|0)|0;h=e?J:c;i=e?j:d;J=h;return i|0}}if((b|0)>=64){h=0;i=0;J=h;return i|0}d=l1c(g|0,a|0,b|0)|0;j=J;c=u1c(g|0,a|0,0-b&63|0)|0;b=J;if((b|0)<0){a=d1c(d|0,j|0,1,0)|0;g=J;if(!((a|0)==0&(g|0)==0)){k=a&~((c|0)==0&(b&2147483647|0)==0&1);l=g;m=9}}else{k=d;l=j;m=9}if((m|0)==9){m=c1c(0,0,k|0,l|0)|0;j=e?m:k;m=e?J:l;if((k|0)==0&(l|0)==0){h=m;i=j;J=h;return i|0}l=l1c(j|0,m|0,63)|0;if((l|0)==(e&1|0)){h=m;i=j;J=h;return i|0}}h=e?-2147483648:2147483647;i=e?0:-1;J=h;return i|0}function UGc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=b;b=f[c>>2]|0;d=f[c+4>>2]|0;c=l1c(b|0,d|0,52)|0;e=c&2047;g=d&1048575;if((e|0)==2047){h=d&-2147483648;if((b|0)==0&(g|0)==0){i=h|2139095040;f[a>>2]=i;return}else{j=l1c(b|0,d|0,29)|0;i=h|2143289344|j&8388607;f[a>>2]=i;return}}j=l1c(b|0,g|0,22)|0;g=((b&4194303|0)!=0|0!=0)&1|j;if(!(g|e)){i=d&-2147483648;f[a>>2]=i;return}j=e+-897|0;b=g|1073741824;h=g&127;do if(j>>>0>252){if(e>>>0<897){g=897-e|0;k=g>>>0<31?(b<<(c+31&31)|0)!=0|b>>>g:1;l=0;m=k&127;n=k;break}if((j|0)>253|(b+64|0)<0){i=d&-2147483648|2139095040;f[a>>2]=i;return}else{l=j;m=h;n=b}}else{l=j;m=h;n=b}while(0);b=(n+64|0)>>>7&~(m<<24>>24==64);i=((b|0)==0?0:l<<23)+(b|d&-2147483648)|0;f[a>>2]=i;return}function VGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=l1c(b|0,e|0,63)|0;i=l1c(c|0,g|0,63)|0;if((h|0)==(i|0)){WGc(a,b,e,c,g,d);return}else{XGc(a,b,e,c,g,d);return}}function WGc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=l1c(b|0,c|0,52)|0;i=h&2047;j=c&1048575;k=l1c(d|0,e|0,52)|0;l=k&2047;m=e&1048575;n=i-l|0;a:do if(!n)switch(h&2047){case 0:{o=d1c(d|0,m|0,b|0,c|0)|0;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}case 2047:{if((d|b|0)==0&(m|j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}default:{v=i;w=u1c(d1c(b|0,j|2097152|0,d|0,m|0)|0,J|0,9)|0;x=J;break a}}else{y=u1c(b|0,j|0,9)|0;z=J;A=u1c(d|0,m|0,9)|0;B=J;do if((n|0)<0)if((l|0)!=2047){C=(i|0)==0;D=u1c(b|0,j|0,10)|0;E=C?D:y;D=C?J:z|536870912;C=0-n|0;if(C>>>0<63){F=l1c(E|0,D|0,C|0)|0;C=J;G=u1c(E|0,D|0,h-k&63|0)|0;H=l;I=A;K=B;L=((G|0)!=0|(J|0)!=0)&1|F;M=C;break}else{H=l;I=A;K=B;L=((E|0)!=0|(D|0)!=0)&1;M=0;break}}else{if(!((d|0)==0&(m|0)==0)){u=28;break a}D=u1c(g&1|0,0,63)|0;o=D;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}else{if((i|0)==2047){if((b|0)==0&(j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}D=(l|0)==0;E=u1c(d|0,m|0,10)|0;C=D?E:A;E=D?J:B|536870912;if(n>>>0<63){D=l1c(C|0,E|0,n|0)|0;F=J;G=u1c(C|0,E|0,0-n&63|0)|0;H=i;I=((G|0)!=0|(J|0)!=0)&1|D;K=F;L=y;M=z;break}else{H=i;I=((C|0)!=0|(E|0)!=0)&1;K=0;L=y;M=z;break}}while(0);z=d1c(I|0,K|0,0,536870912)|0;y=d1c(z|0,J|0,L|0,M|0)|0;z=J;B=z>>>0<1073741824|(z|0)==1073741824&y>>>0<0;A=u1c(y|0,z|0,B&1|0)|0;v=(B<<31>>31)+H|0;w=A;x=J}while(0);if((u|0)==28){u=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);H=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(j|0)==0;o=u?b:H?d:b;p=(u?c:H?e:c)|524288;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}c=w&1023;do if((v&65535)>>>0>2044){if((v|0)>=0){d1c(w|0,x|0,512,0)|0;if(!((v|0)>2045|(J|0)<0)){N=v;O=c;P=w;Q=x;break}e=u1c(g&1|0,0,63)|0;o=e;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}e=0-v|0;if(e>>>0<63){H=l1c(w|0,x|0,e|0)|0;e=J;u=u1c(w|0,x|0,v&63|0)|0;R=((u|0)!=0|(J|0)!=0)&1|H;S=e}else{R=((w|0)!=0|(x|0)!=0)&1;S=0}N=0;O=R&1023;P=R;Q=S}else{N=v;O=c;P=w;Q=x}while(0);x=d1c(P|0,Q|0,512,0)|0;Q=l1c(x|0,J|0,10)|0;x=J;P=Q&~((O|0)==512);O=(P|0)==0&(x|0)==0;Q=u1c(g&1|0,0,63)|0;g=J;w=u1c(N|0,0,52)|0;N=d1c((O?0:w)|0,(O?0:J)|0,P|Q|0,x|g|0)|0;o=N;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function XGc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=l1c(b|0,c|0,52)|0;j=i&2047;k=c&1048575;l=l1c(d|0,e|0,52)|0;m=l&2047;n=e&1048575;o=j-m|0;a:do if(!o){if((j|0)==2047)if((d|b|0)==0&(n|k|0)==0){p=0;q=-524288;break}else{r=19;break}s=c1c(b|0,k|0,d|0,n|0)|0;t=J;if((s|0)==0&(t|0)==0){p=0;q=0}else{u=(j|0)==0?0:j+-1|0;v=(t|0)<0;w=c1c(0,0,s|0,t|0)|0;x=v?w:s;s=v?J:t;t=(s|0)==0;w=t?32:0;y=t?x:s;t=y>>>0<65536;z=t?w|16:w;w=t?y<<16:y;y=w>>>0<16777216;t=((h[518485+((y?w<<8:w)>>>24)>>0]|0)+((y?z|8:z)&255)&255)+245|0;z=u-(t<<24>>24)|0;y=(z|0)<0;w=u1c((v^g)&1|0,0,63)|0;v=J;A=u1c(z|0,0,52)|0;z=d1c((y?0:A)|0,(y?0:J)|0,w|0,v|0)|0;v=J;w=u1c(x|0,s|0,(y?u:t)<<24>>24|0)|0;t=d1c(z|0,v|0,w|0,J|0)|0;p=t;q=J}}else{t=u1c(b|0,k|0,10)|0;w=J;v=u1c(d|0,n|0,10)|0;z=J;do if((o|0)<0){u=g^1;if((m|0)==2047){if(!((d|0)==0&(n|0)==0)){r=19;break a}y=u1c(u&1|0,0,63)|0;p=y;q=J|2146435072;break a}y=(j|0)!=0;s=d1c((y?0:t)|0,(y?1073741824:w)|0,t|0,w|0)|0;y=J;x=0-o|0;if(x>>>0<63){A=l1c(s|0,y|0,x|0)|0;x=J;B=u1c(s|0,y|0,i-l&63|0)|0;C=m;D=u;E=z;F=v;G=((B|0)!=0|(J|0)!=0)&1|A;H=x;break}else{C=m;D=u;E=z;F=v;G=((s|0)!=0|(y|0)!=0)&1;H=0;break}}else{if((j|0)==2047)if((b|0)==0&(k|0)==0){p=b;q=c;break a}else{r=19;break a}y=(m|0)!=0;s=d1c((y?0:v)|0,(y?1073741824:z)|0,v|0,z|0)|0;y=J;if(o>>>0<63){u=l1c(s|0,y|0,o|0)|0;x=J;A=u1c(s|0,y|0,0-o&63|0)|0;C=j;D=g;E=w;F=t;G=((A|0)!=0|(J|0)!=0)&1|u;H=x;break}else{C=j;D=g;E=w;F=t;G=((s|0)!=0|(y|0)!=0)&1;H=0;break}}while(0);t=c1c(F|0,E|1073741824|0,G|0,H|0)|0;MGc(a,D,C+-1|0,t,J);return}while(0);if((r|0)==19){r=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);C=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(k|0)==0;p=r?b:C?d:b;q=(r?c:C?e:c)|524288}c=a;f[c>>2]=p;f[c+4>>2]=q;return}function YGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=l1c(b|0,e|0,63)|0;i=l1c(c|0,g|0,63)|0;if((h|0)==(i|0)){XGc(a,b,e,c,g,d);return}else{WGc(a,b,e,c,g,d);return}}function ZGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=l1c(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=l1c(c|0,g|0,52)|0;k=j&2047;j=g&1048575;l=g^e;do if((i|0)==2047)if((b|0)==0&(d|0)==0?!(((c|0)!=0|(j|0)!=0)&(k|0)==2047):0){m=k;n=c;o=j;p=22}else p=21;else{if((k|0)==2047)if((c|0)==0&(j|0)==0){m=i;n=b;o=d;p=22;break}else{p=21;break}if(!i){if(!((b|0)==0&(d|0)==0)){q=(d|0)==0;r=q?32:0;s=q?b:d;q=s>>>0<65536;t=q?r|16:r;r=q?s<<16:s;s=r>>>0<16777216;q=((h[518485+((s?r<<8:r)>>>24)>>0]|0)+((s?t|8:t)&255)<<24)+-184549376>>24;t=u1c(b|0,d|0,q|0)|0;u=1-q|0;v=t;w=J;p=9}}else{u=i;v=b;w=d;p=9}do if((p|0)==9){if(!k){if((c|0)==0&(j|0)==0)break;t=(j|0)==0;q=t?32:0;s=t?c:j;t=s>>>0<65536;r=t?q|16:q;q=t?s<<16:s;s=q>>>0<16777216;t=((h[518485+((s?q<<8:q)>>>24)>>0]|0)+((s?r|8:r)&255)<<24)+-184549376>>24;r=u1c(c|0,j|0,t|0)|0;x=1-t|0;y=r;z=J}else{x=k;y=c;z=j}r=u1c(v|0,w|0,10)|0;t=u1c(y|0,z|0,11)|0;s=l1c(v|0,w|0,22)|0;q=s&-1073741825|1073741824;s=l1c(y|0,z|0,21)|0;A=s&2147483647|-2147483648;s=r&-1024;r=t&-2048;t=x1c(r|0,0,s|0,0)|0;B=J;C=x1c(r|0,0,q|0,0)|0;r=J;D=x1c(A|0,0,s|0,0)|0;s=d1c(D|0,J|0,C|0,r|0)|0;D=J;E=x1c(A|0,0,q|0,0)|0;q=d1c(D|0,(D>>>0<r>>>0|(D|0)==(r|0)&s>>>0<C>>>0)&1|0,E|0,J|0)|0;E=J;C=d1c(0,s|0,t|0,B|0)|0;B=J;t=d1c(q|0,E|0,(B>>>0<s>>>0|(B|0)==(s|0)&C>>>0<0)&1|0,0)|0;s=J;E=t|((C|0)!=0|(B|0)!=0)&1;B=s>>>0<1073741824|(s|0)==1073741824&E>>>0<0;C=x+u+(B?-1024:-1023)|0;t=u1c(E|0,s|0,B&1|0)|0;B=J;s=t&1023;do if((C&65535)>>>0>2044){if((C|0)>=0){d1c(t|0,B|0,512,0)|0;if(!((C|0)>2045|(J|0)<0)){F=C;G=s;H=t;I=B;break}K=0;L=l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}E=0-C|0;if(E>>>0<63){q=l1c(t|0,B|0,E|0)|0;E=J;r=u1c(t|0,B|0,C&63|0)|0;Q=((r|0)!=0|(J|0)!=0)&1|q;R=E}else{Q=((t|0)!=0|(B|0)!=0)&1;R=0}F=0;G=Q&1023;H=Q;I=R}else{F=C;G=s;H=t;I=B}while(0);B=d1c(H|0,I|0,512,0)|0;t=l1c(B|0,J|0,10)|0;B=J;s=t&~((G|0)==512);t=(s|0)==0&(B|0)==0;C=u1c(F|0,0,52)|0;E=d1c((t?0:C)|0,(t?0:J)|0,s|0,B|l&-2147483648|0)|0;K=E;L=J;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);K=0;L=l&-2147483648;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);if((p|0)==21){F=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);G=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;K=F?b:G?c:b;L=(F?e:G?g:e)|524288;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}else if((p|0)==22){p=(m|n|0)==0&(o|0)==0;K=p?0:0;L=p?-524288:l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}}function _Gc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=l1c(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=l1c(c|0,g|0,52)|0;k=j&2047;l=g&1048575;m=g^e;a:do if((i|0)==2047)if((b|0)==0&(d|0)==0)if((k|0)==2047)if((c|0)==0&(l|0)==0){n=0;o=-524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else t=26;else t=27;else t=26;else{b:do switch(j&2047){case 2047:{if(!((c|0)==0&(l|0)==0)){t=26;break a}break}case 0:{if(!((c|0)==0&(l|0)==0)){u=(l|0)==0;v=u?32:0;w=u?c:l;u=w>>>0<65536;x=u?v|16:v;v=u?w<<16:w;w=v>>>0<16777216;u=((h[518485+((w?v<<8:v)>>>24)>>0]|0)+((w?x|8:x)&255)<<24)+-184549376>>24;x=u1c(c|0,l|0,u|0)|0;y=1-u|0;z=J;A=x;t=10;break b}if((i|b|0)==0&(d|0)==0){n=0;o=-524288}else{t=27;break a}p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}default:{y=k;z=l;A=c;t=10}}while(0);do if((t|0)==10){if(!i){if((b|0)==0&(d|0)==0)break;x=(d|0)==0;u=x?32:0;w=x?b:d;x=w>>>0<65536;v=x?u|16:u;u=x?w<<16:w;w=u>>>0<16777216;x=((h[518485+((w?u<<8:u)>>>24)>>0]|0)+((w?v|8:v)&255)<<24)+-184549376>>24;v=u1c(b|0,d|0,x|0)|0;B=1-x|0;C=J;D=v}else{B=i;C=d;D=b}v=C|1048576;x=z|1048576;w=v>>>0<x>>>0|(v|0)==(x|0)&D>>>0<A>>>0;u=(w?1021:1022)+(B-y)|0;E=u1c(D|0,v|0,(w?11:10)|0)|0;w=J;v=l1c(A|0,x|0,21)|0;x=n1c(-1,2147483647,v|0,0)|0;F=x+-2|0;x1c(w|0,0,F|0,0)|0;x=J;G=u1c(x|0,0,1)|0;H=G&-2;G=x1c(H|0,0,v|0,0)|0;I=c1c(E|0,w|0,G|0,J|0)|0;G=u1c(I|0,J|0,28)|0;I=J;w=A<<7&268435328;E=x1c(H|0,0,w|0,0)|0;H=c1c(G|0,I|0,E|0,J|0)|0;E=J;x1c(E|0,0,F|0,0)|0;F=d1c(J|0,0,4,0)|0;I=u1c(F|0,J|0,4)|0;G=d1c(I&-16|0,J&15|0,0,x|0)|0;x=J;do if(0<0|0==0&(G&448)>>>0<64){I=G&-128;K=F<<1&-16;L=x1c(K|0,0,v|0,0)|0;M=c1c(H|0,E|0,L|0,J|0)|0;L=u1c(M|0,J|0,28)|0;M=J;N=x1c(K|0,0,w|0,0)|0;K=c1c(L|0,M|0,N|0,J|0)|0;N=J;if((N|0)<0){M=d1c(I|0,x|0,-128,-1)|0;O=M;P=J;break}else{O=((K|0)!=0|(N|0)!=0)&1|I;P=x;break}}else{O=G;P=x}while(0);x=O&1023;do if((u&65535)>>>0>2044){if((u|0)>=0){d1c(O|0,P|0,512,0)|0;if(!((u|0)>2045|(J|0)<0)){Q=u;R=x;S=O;T=P;break}n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}G=0-u|0;if(G>>>0<63){w=l1c(O|0,P|0,G|0)|0;G=J;E=u1c(O|0,P|0,u&63|0)|0;U=((E|0)!=0|(J|0)!=0)&1|w;V=G}else{U=((O|0)!=0|(P|0)!=0)&1;V=0}Q=0;R=U&1023;S=U;T=V}else{Q=u;R=x;S=O;T=P}while(0);x=d1c(S|0,T|0,512,0)|0;u=l1c(x|0,J|0,10)|0;x=J;G=u&~((R|0)==512);u=(G|0)==0&(x|0)==0;w=u1c(Q|0,0,52)|0;E=d1c((u?0:w)|0,(u?0:J)|0,G|0,x|m&-2147483648|0)|0;n=E;o=J;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);n=0;o=m&-2147483648;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);if((t|0)==26){Q=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);R=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;n=Q?b:R?c:b;o=(Q?e:R?g:e)|524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else if((t|0)==27){n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}}function $Gc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}g=(a|0)==(b|0)&(d|0)==(e|0)|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}function aHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}c=l1c(a|0,d|0,63)|0;h=l1c(b|0,e|0,63)|0;if((c|0)==(h|0)){g=(a|0)==(b|0)&(d|0)==(e|0)|(c|0)!=((d>>>0<e>>>0|(d|0)==(e|0)&a>>>0<b>>>0)&1|0);return g|0}else{g=(d|0)<0|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}return 0}function bHc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=f[b>>2]|0;b=f[c>>2]|0;c=f[d>>2]|0;d=e>>>23&255;g=e&8388607;i=b>>>23&255;j=b&8388607;k=c>>>31;l=k&255;m=c>>>23&255;n=c&8388607;o=b^e;p=o>>>31;q=p&255;do if((d|0)==255)if((g|0)==0?!((j|0)!=0&(i|0)==255):0){r=i|j;s=54}else s=53;else{if((i|0)==255){if(j|0){s=53;break}r=d|g;s=54;break}if((m|0)==255){if(!n)t=c;else{u=0;break}f[a>>2]=t;return}if(!d)if(!g)s=59;else{v=g>>>0<65536;w=v?e<<16:g;x=v?16:0;v=w>>>0<16777216;y=((h[518485+((v?w<<8:w)>>>24)>>0]|0)+((v?x|8:x)&255)<<24)+-134217728>>24;z=1-y|0;A=g<<y;s=13}else{z=d;A=g;s=13}a:do if((s|0)==13){if(!i){if(!j){s=59;break}y=j>>>0<65536;x=y?b<<16:j;v=y?16:0;y=x>>>0<16777216;w=((h[518485+((y?x<<8:x)>>>24)>>0]|0)+((y?v|8:v)&255)<<24)+-134217728>>24;B=1-w|0;C=j<<w}else{B=i;C=j}w=x1c(C<<7|1073741824|0,0,A<<7|1073741824|0,0)|0;v=J;y=v>>>0<536870912|(v|0)==536870912&w>>>0<0;x=B+z+(y?-127:-126)|0;D=u1c(w|0,v|0,y&1|0)|0;y=J;do if(!m)if(!n){v=l1c(D|0,y|0,31)|0;E=((D&2147467264|0)!=0|0!=0)&1|v;F=(p|0)!=0;G=x+-1|0;break}else{v=n>>>0<65536;w=v?c<<16:n;H=v?16:0;v=w>>>0<16777216;I=((h[518485+((v?w<<8:w)>>>24)>>0]|0)+((v?H|8:H)&255)<<24)+-134217728>>24;K=n<<I;L=1-I|0;s=20;break}else{K=n;L=m;s=20}while(0);do if((s|0)==20){I=K<<6|536870912;H=x-L|0;if((o^c|0)>-1){if((H|0)<1){v=32-H|0;if(v>>>0<63){w=l1c(D|0,y|0,v|0)|0;M=u1c(D|0,y|0,0-v&63|0)|0;N=((M|0)!=0|(J|0)!=0)&1|w}else N=((D|0)!=0|(y|0)!=0)&1;O=N+I|0;P=L}else{if(H>>>0<63){w=l1c(0,I|0,H|0)|0;M=J;v=u1c(0,I|0,0-H&63|0)|0;Q=((v|0)!=0|(J|0)!=0)&1|w;R=M}else{Q=1;R=0}M=d1c(Q|0,R|0,D|0,y|0)|0;O=((M|0)!=0|0!=0)&1|J;P=x}M=O>>>0<1073741824;E=O<<(M&1);F=(p|0)!=0;G=(M<<31>>31)+P|0;break}do if((H|0)<0){M=0-H|0;if(M>>>0<63){w=l1c(D|0,y|0,M|0)|0;M=J;v=u1c(D|0,y|0,H&63|0)|0;S=((v|0)!=0|(J|0)!=0)&1|w;T=M}else{S=((D|0)!=0|(y|0)!=0)&1;T=0}M=c1c(0,I|0,S|0,T|0)|0;U=l;V=L;W=J;X=M}else{if(!H){M=c1c(D|0,y|0,0,I|0)|0;w=J;if((M|0)==0&(w|0)==0)break a;v=(w|0)<0;Y=c1c(0,0,M|0,w|0)|0;Z=J;_=l1c(M|0,w|0,63)|0;U=_&255^q;V=x;W=v?Z:w;X=v?Y:M;break}if(H>>>0<63){M=l1c(0,I|0,H|0)|0;Y=J;v=u1c(0,I|0,0-H&63|0)|0;$=((v|0)!=0|(J|0)!=0)&1|M;aa=Y}else{$=1;aa=0}Y=c1c(D|0,y|0,$|0,aa|0)|0;U=q;V=x;W=J;X=Y}while(0);H=(W|0)==0;I=H?32:0;Y=H?X:W;H=Y>>>0<65536;M=H?I|16:I;I=H?Y<<16:Y;Y=I>>>0<16777216;H=((Y?M|8:M)&255)+(h[518485+((Y?I<<8:I)>>>24)>>0]|0)<<24;I=V-(H+-16777216>>24)|0;Y=H+-553648128|0;H=Y>>24;if((Y|0)<0){Y=0-H&255;M=l1c(X|0,W|0,Y|0)|0;v=u1c(1,0,Y|0)|0;Y=d1c(v|0,J|0,-1,-1)|0;E=((Y&X|0)!=0|(J&W|0)!=0)&1|M;F=(U&1)!=0;G=I;break}else{E=X<<H;F=(U&1)!=0;G=I;break}}while(0);x=E&127;do if(G>>>0>252){if((G|0)>=0){if(!((G|0)>253|(E+64|0)<0)){ba=G;ca=x;da=E;break}t=(F&1)<<31|2139095040;f[a>>2]=t;return}y=0-G|0;if(y>>>0<31)ea=(E<<(G&31)|0)!=0|E>>>y;else ea=(E|0)!=0&1;ba=0;ca=ea&127;da=ea}else{ba=G;ca=x;da=E}while(0);x=(da+64|0)>>>7&~(ca<<24>>24==64);t=((x|0)==0?0:ba<<23)+(x|(F&1)<<31)|0;f[a>>2]=t;return}while(0);if((s|0)==59?!((o^c|0)<0&(m|n|0)==0):0){t=c;f[a>>2]=t;return}t=0;f[a>>2]=t;return}while(0);if((s|0)==53)u=((e&2143289344|0)==2139095040&(e&4194303|0)!=0?e:(e&2139095040|0)!=2139095040|(g|0)==0?b:e)|4194304;else if((s|0)==54)if(r){r=p<<31|2139095040;if((m|0)!=255){t=r;f[a>>2]=t;return}if(!n)if((p|0)==(k|0)){t=r;f[a>>2]=t;return}else u=-4194304;else u=r}else u=-4194304;t=((u&2143289344|0)==2139095040&(u&4194303|0)!=0?u:(u&2139095040|0)!=2139095040|(u&8388607|0)==0?c:u)|4194304;f[a>>2]=t;return}function cHc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;e=b;b=f[e>>2]|0;g=f[e+4>>2]|0;e=c;c=f[e>>2]|0;i=f[e+4>>2]|0;e=d;d=f[e>>2]|0;j=f[e+4>>2]|0;e=l1c(b|0,g|0,52)|0;k=e&2047;e=g&1048575;l=l1c(c|0,i|0,52)|0;m=l&2047;l=i&1048575;n=l1c(d|0,j|0,63)|0;o=n&255;p=l1c(d|0,j|0,52)|0;q=p&2047;p=j&1048575;r=i^g;s=l1c(c^b|0,r|0,63)|0;t=J;u=s&255;do if((k|0)==2047)if((b|0)==0&(e|0)==0?!(((c|0)!=0|(l|0)!=0)&(m|0)==2047):0){v=m;w=c;x=l;y=54}else y=53;else{if((m|0)==2047)if((c|0)==0&(l|0)==0){v=k;w=b;x=e;y=54;break}else{y=53;break}if((q|0)==2047){if((d|0)==0&(p|0)==0){z=d;A=j}else{B=0;C=0;break}D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}if(!k)if((b|0)==0&(e|0)==0)y=59;else{H=(e|0)==0;I=H?32:0;K=H?b:e;H=K>>>0<65536;L=H?I|16:I;I=H?K<<16:K;K=I>>>0<16777216;H=((h[518485+((K?I<<8:I)>>>24)>>0]|0)+((K?L|8:L)&255)<<24)+-184549376>>24;L=u1c(b|0,e|0,H|0)|0;M=1-H|0;N=L;O=J;y=11}else{M=k;N=b;O=e;y=11}a:do if((y|0)==11){if(!m){if((c|0)==0&(l|0)==0){y=59;break}L=(l|0)==0;H=L?32:0;K=L?c:l;L=K>>>0<65536;I=L?H|16:H;H=L?K<<16:K;K=H>>>0<16777216;L=((h[518485+((K?H<<8:H)>>>24)>>0]|0)+((K?I|8:I)&255)<<24)+-184549376>>24;I=u1c(c|0,l|0,L|0)|0;P=1-L|0;Q=I;R=J}else{P=m;Q=c;R=l}I=u1c(N|0,O|0,10)|0;L=u1c(Q|0,R|0,10)|0;K=l1c(N|0,O|0,22)|0;H=K&-1073741825|1073741824;K=l1c(Q|0,R|0,22)|0;S=K&-1073741825|1073741824;K=I&-1024;I=L&-1024;L=x1c(I|0,0,K|0,0)|0;T=J;U=x1c(I|0,0,H|0,0)|0;I=J;V=x1c(S|0,0,K|0,0)|0;K=d1c(V|0,J|0,U|0,I|0)|0;V=J;W=x1c(S|0,0,H|0,0)|0;H=d1c(V|0,(V>>>0<I>>>0|(V|0)==(I|0)&K>>>0<U>>>0)&1|0,W|0,J|0)|0;W=J;U=d1c(0,K|0,L|0,T|0)|0;T=J;L=d1c(H|0,W|0,(T>>>0<K>>>0|(T|0)==(K|0)&U>>>0<0)&1|0,0)|0;K=J;W=K>>>0<536870912|(K|0)==536870912&L>>>0<0;H=u1c(U|0,T|0,1)|0;I=J;V=u1c(L|0,K|0,1)|0;S=P+M+(W?-1023:-1022)|0;X=W?V|(I>>>0<T>>>0|(I|0)==(T|0)&H>>>0<U>>>0)&1:L;L=W?J:K;K=W?H:U;U=W?I:T;do if(!q)if((d|0)==0&(p|0)==0){T=u1c(X|0,L|0,1)|0;Y=(s|0)!=0|(t|0)!=0;Z=S+-1|0;_=T|((K|0)!=0|(U|0)!=0)&1;$=J;break}else{T=(p|0)==0;I=T?32:0;W=T?d:p;T=W>>>0<65536;H=T?I|16:I;I=T?W<<16:W;W=I>>>0<16777216;T=((h[518485+((W?I<<8:I)>>>24)>>0]|0)+((W?H|8:H)&255)<<24)+-184549376>>24;H=u1c(d|0,p|0,T|0)|0;aa=1-T|0;ba=H;ca=J;y=18;break}else{aa=q;ba=d;ca=p;y=18}while(0);do if((y|0)==18){H=u1c(ba|0,ca|0,9)|0;T=J|536870912;W=S-aa|0;I=(W|0)<0;do if(I){if(!((s|0)==(n|0)|(W|0)!=-1)){V=l1c(X|0,L|0,1)|0;da=J;ea=u1c(X|0,L|0,63)|0;fa=J;ga=l1c(K|0,U|0,1)|0;ha=aa;ia=V;ja=da;ka=0;la=0;ma=ea|ga;na=fa|J;oa=0;pa=0;break}fa=0-W|0;if(fa>>>0<63){ga=l1c(X|0,L|0,fa|0)|0;fa=J;ea=u1c(X|0,L|0,W&63|0)|0;ha=aa;ia=((ea|0)!=0|(J|0)!=0)&1|ga;ja=fa;ka=0;la=0;ma=K;na=U;oa=0;pa=0;break}else{ha=aa;ia=((X|0)!=0|(L|0)!=0)&1;ja=0;ka=0;la=0;ma=K;na=U;oa=0;pa=0;break}}else if(W){if(W>>>0<64){fa=l1c(H|0,T|0,W|0)|0;ga=J;ea=u1c(H|0,T|0,0-W&63|0)|0;ha=S;ia=X;ja=L;ka=ea;la=J;ma=K;na=U;oa=fa;pa=ga;break}if(W>>>0<127){ga=W&63;fa=l1c(H|0,T|0,ga|0)|0;ea=J;da=u1c(1,0,ga|0)|0;ga=d1c(da|0,J|0,-1,-1)|0;ha=S;ia=X;ja=L;ka=((ga&H|0)!=0|(J&T|0)!=0)&1|fa;la=ea;ma=K;na=U;oa=0;pa=0}else{ha=S;ia=X;ja=L;ka=1;la=0;ma=K;na=U;oa=0;pa=0}}else{ha=S;ia=X;ja=L;ka=0;la=0;ma=K;na=U;oa=0;pa=0}while(0);if((s|0)==(n|0)){if((W|0)<1){ea=d1c(ia|0,ja|0,H|0,T|0)|0;qa=ma;ra=na;sa=ea;ta=J}else{ea=d1c(ka|0,la|0,ma|0,na|0)|0;fa=J;ga=d1c(oa|0,pa|0,ia|0,ja|0)|0;da=d1c(ga|0,J|0,(fa>>>0<na>>>0|(fa|0)==(na|0)&ea>>>0<ma>>>0)&1|0,0)|0;qa=ea;ra=fa;sa=da;ta=J}da=((qa|0)!=0|(ra|0)!=0)&1|sa;fa=ta>>>0<1073741824|(ta|0)==1073741824&da>>>0<0;ea=u1c(da|0,ta|0,fa&1|0)|0;Y=(s|0)!=0|(t|0)!=0;Z=(fa<<31>>31)+ha|0;_=ea;$=J;break}do if(I){ea=c1c(0,0,ma|0,na|0)|0;fa=J;da=c1c(H|0,T|0,ia|0,ja|0)|0;ga=((ma|0)!=0|(na|0)!=0)<<31>>31;V=d1c(da|0,J|0,ga|0,((ga|0)<0)<<31>>31|0)|0;ua=o;va=V;wa=J;xa=ea;ya=fa}else{if(W|0){fa=c1c(ma|0,na|0,ka|0,la|0)|0;ea=J;V=c1c(ia|0,ja|0,oa|0,pa|0)|0;ga=(na>>>0<la>>>0|(na|0)==(la|0)&ma>>>0<ka>>>0)<<31>>31;da=d1c(V|0,J|0,ga|0,((ga|0)<0)<<31>>31|0)|0;ua=u;va=da;wa=J;xa=fa;ya=ea;break}ea=c1c(ia|0,ja|0,H|0,T|0)|0;fa=J;if((ea|ma|0)==0&(fa|na|0)==0)break a;da=(fa|0)<0;ga=c1c(0,0,ma|0,na|0)|0;V=J;za=((ma|0)!=0|(na|0)!=0)<<31>>31;Aa=c1c(za|0,((za|0)<0)<<31>>31|0,ea|0,fa|0)|0;za=J;Ba=l1c(ea|0,fa|0,63)|0;ua=(Ba^s)&255;va=da?Aa:ea;wa=da?za:fa;xa=da?ga:ma;ya=da?V:na}while(0);T=(va|0)==0&(wa|0)==0;H=T?xa:va;W=T?ya:wa;I=T?0:xa;V=T?0:ya;da=(W|0)==0;ga=da?32:0;fa=da?H:W;da=fa>>>0<65536;za=da?ga|16:ga;ga=da?fa<<16:fa;fa=ga>>>0<16777216;da=((fa?za|8:za)&255)+(h[518485+((fa?ga<<8:ga)>>>24)>>0]|0)|0;ga=(da<<24)+-16777216|0;fa=ga>>24;if((ga|0)<0){ga=0-fa&255;za=l1c(H|0,W|0,ga|0)|0;ea=J;Aa=u1c(1,0,ga|0)|0;ga=d1c(Aa|0,J|0,-1,-1)|0;Ca=I;Da=V;Ea=((ga&H|0)!=0|(J&W|0)!=0)&1|za;Fa=ea}else{ea=da+255&255;za=u1c(H|0,W|0,ea|0)|0;W=J;H=l1c(I|0,V|0,-63-da&63|0)|0;da=J|W;W=u1c(I|0,V|0,ea|0)|0;Ca=W;Da=J;Ea=H|za;Fa=da}Y=(ua&1)!=0;Z=(T?ha+-64|0:ha)-fa|0;_=((Ca|0)!=0|(Da|0)!=0)&1|Ea;$=Fa}while(0);U=_&1023;do if((Z&65535)>>>0>2044){if((Z|0)>=0){d1c(_|0,$|0,512,0)|0;if(!((Z|0)>2045|(J|0)<0)){Ga=Z;Ha=U;Ia=_;Ja=$;break}K=u1c(Y&1|0,0,63)|0;z=K;A=J|2146435072;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}K=0-Z|0;if(K>>>0<63){L=l1c(_|0,$|0,K|0)|0;K=J;X=u1c(_|0,$|0,Z&63|0)|0;Ka=((X|0)!=0|(J|0)!=0)&1|L;La=K}else{Ka=((_|0)!=0|($|0)!=0)&1;La=0}Ga=0;Ha=Ka&1023;Ia=Ka;Ja=La}else{Ga=Z;Ha=U;Ia=_;Ja=$}while(0);U=d1c(Ia|0,Ja|0,512,0)|0;K=l1c(U|0,J|0,10)|0;U=J;L=K&~((Ha|0)==512);K=(L|0)==0&(U|0)==0;X=u1c(Y&1|0,0,63)|0;S=J;fa=u1c(Ga|0,0,52)|0;T=d1c((K?0:fa)|0,(K?0:J)|0,L|X|0,U|S|0)|0;z=T;A=J;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}while(0);if((y|0)==59){if(!((q|d|0)==0&(p|0)==0)){z=d;A=j;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}if((s|0)==(n|0)){z=d;A=j;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}}z=0;A=0;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}while(0);if((y|0)==53){Ga=0==0&(g&2146959360|0)==2146435072&((b|0)!=0|(g&524287|0)!=0);Y=0!=0|(g&2146435072|0)!=2146435072|(b|0)==0&(e|0)==0;B=(Ga?g:Y?i:g)|524288;C=Ga?b:Y?c:b}else if((y|0)==54)if(!((v|w|0)==0&(x|0)==0)){x=r&-2147483648|2146435072;if((q|0)!=2047){z=0;A=x;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}if((d|0)==0&(p|0)==0)if((s|0)==(n|0)){z=0;A=x;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}else{B=-524288;C=0}else{B=x;C=0}}else{B=-524288;C=0}x=0==0&(B&2146959360|0)==2146435072&((C|0)!=0|(B&524287|0)!=0);n=0!=0|(B&2146435072|0)!=2146435072|(C|0)==0&(B&1048575|0)==0;z=x?C:n?d:C;A=(x?B:n?j:B)|524288;D=a;E=D;f[E>>2]=z;F=D+4|0;G=F;f[G>>2]=A;return}function dHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;e=b;b=f[e+4>>2]|0;g=d;f[g>>2]=f[e>>2];f[g+4>>2]=b;eHc(a,d);u=c;return}function eHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+176|0;e=d+160|0;g=d+144|0;h=d+136|0;i=d+120|0;j=d+104|0;k=d+96|0;l=d+168|0;m=d+152|0;n=d+88|0;o=d+80|0;p=d+128|0;q=d+72|0;r=d+112|0;s=d+64|0;t=d+56|0;v=d+48|0;w=d+40|0;x=d+32|0;y=d+24|0;z=d+16|0;A=d+8|0;B=d;C=c;D=f[C>>2]|0;E=f[C+4>>2]|0;C=E&2147483647;if(C>>>0>2146435072|(C|0)==2146435072&D>>>0>0){F=a;f[F>>2]=-1;f[F+4>>2]=2147483647;u=d;return}if((D|0)==0&(C|0)==2146435072)if((D|0)==0&(E|0)==2146435072&(0!=0|(E&2146435072|0)!=2146435072|(D|0)==0&(E&1048575|0)==0)){E=a;f[E>>2]=0;f[E+4>>2]=2146435072;u=d;return}else{E=a;f[E>>2]=0;f[E+4>>2]=0;u=d;return}if((b[539200]|0)==0?X0c(539200)|0:0){E=e;f[E>>2]=0;f[E+4>>2]=1072693248;_Gc(539208,e,23184)}if((b[539216]|0)==0?X0c(539216)|0:0){e=g;f[e>>2]=-17155599;f[e+4>>2]=1072049730;_Gc(539224,g,23184)}if((b[539232]|0)==0?X0c(539232)|0:0){g=h;f[g>>2]=-8215462;f[g+4>>2]=1070514109;_Gc(539240,h,23184)}if((b[539248]|0)==0?X0c(539248)|0:0){h=i;f[h>>2]=-668996491;f[h+4>>2]=1068264200;_Gc(539256,i,23184)}if((b[539264]|0)==0?X0c(539264)|0:0){i=j;f[i>>2]=726613203;f[i+4>>2]=1065595559;_Gc(539272,j,23184)}if((b[539280]|0)==0?X0c(539280)|0:0){j=k;f[j>>2]=359056036;f[j+4>>2]=1062594474;_Gc(539288,k,23184)}k=l;f[k>>2]=0;f[k+4>>2]=0;k=f[c+4>>2]|0;j=k&2145386496;if(j>>>0>1083179008|(j|0)==1083179008&0>0){j=k&-2147483648|1091006464;k=l;f[k>>2]=0;f[k+4>>2]=j;G=0;H=j}else{ZGc(m,c,23192);c=m;j=f[c>>2]|0;k=f[c+4>>2]|0;c=l;f[c>>2]=j;f[c+4>>2]=k;G=j;H=k}k=l1c(G|0,H|0,52)|0;j=k&2047;k=H&1048575;c=(H|0)<0;i=(G|0)==0&(k|0)==0|(j|0)!=2047;h=c&i;g=(j|0)==0;e=g?G:G;E=g?k:k|1048576;g=1063-j|0;do if((g|0)>0)if(g>>>0<63){D=l1c(e|0,E|0,g|0)|0;C=J;F=u1c(e|0,E|0,0-g&63|0)|0;I=((F|0)!=0|(J|0)!=0)&1|D;K=C;break}else{I=((e|0)!=0|(E|0)!=0)&1;K=0;break}else{I=e;K=E}while(0);E=d1c(I|0,K|0,2048,0)|0;K=J;if(!(K>>>0>4095|(K|0)==4095&E>>>0>4294967295)){e=l1c(E|0,K|0,12)|0;K=(I&4095|0)==2048&0==0&1;I=h?(K|~e)+1|0:e&~K;if(I)if((I>>>31|0)==(h&1|0))L=I;else M=35;else L=0}else M=35;if((M|0)==35)L=h?-2147483648:2147483647;h=L>>6;M=h+1023|0;I=(h|0)<-1023;h=u1c(((M|0)<2047?M:2047)|0,0,52)|0;M=m;f[M>>2]=I?0:h;f[M+4>>2]=I?0:J;do if(j>>>0>=1023){if(j>>>0<=1074){I=u1c(1,0,1075-j|0)|0;M=J;h=d1c(I|0,M|0,-1,-1)|0;K=J;e=l1c(I|0,M|0,1)|0;E=d1c(e|0,J|0,G|0,H|0)|0;e=J;g=(E&h|0)==0&(e&K|0)==0;K=c1c(0,0,I|0,M|0)|0;N=E&K&(g?~I:-1);O=e&J&(g?~M:-1);break}if(i){N=G;O=H}else{M=0==0&(H&2146959360|0)==2146435072&((G|0)!=0|(H&524287|0)!=0);g=0!=0|(H&2146435072|0)!=2146435072;N=M?G:g?0:G;O=(M?H:g?0:H)|524288}}else{g=(G|0)==0&(H&2147483647|0)==0;M=H&-2147483648;e=((G|0)!=0|(k|0)!=0)&(j|0)==1022;N=g?G:e?0:0;O=g?H:e?M|1072693248:M}while(0);j=l1c(G|0,H|0,63)|0;k=l1c(N|0,O|0,63)|0;if((j|0)==(k|0))XGc(n,G,H,N,O,c);else WGc(n,G,H,N,O,c);ZGc(l,n,23200);ZGc(o,m,23184);m=23208+((L&63)<<3)|0;L=f[m+4>>2]|0;n=p;f[n>>2]=f[m>>2];f[n+4>>2]=L;ZGc(q,o,p);ZGc(s,539288,l);p=s;s=f[p>>2]|0;o=f[p+4>>2]|0;p=539272;L=f[p>>2]|0;n=f[p+4>>2]|0;p=(o|0)<0;m=l1c(s|0,o|0,63)|0;c=l1c(L|0,n|0,63)|0;if((m|0)==(c|0))WGc(t,s,o,L,n,p);else XGc(t,s,o,L,n,p);ZGc(v,t,l);t=v;v=f[t>>2]|0;p=f[t+4>>2]|0;t=539256;n=f[t>>2]|0;L=f[t+4>>2]|0;t=(p|0)<0;o=l1c(v|0,p|0,63)|0;s=l1c(n|0,L|0,63)|0;if((o|0)==(s|0))WGc(w,v,p,n,L,t);else XGc(w,v,p,n,L,t);ZGc(x,w,l);w=x;x=f[w>>2]|0;t=f[w+4>>2]|0;w=539240;L=f[w>>2]|0;n=f[w+4>>2]|0;w=(t|0)<0;p=l1c(x|0,t|0,63)|0;v=l1c(L|0,n|0,63)|0;if((p|0)==(v|0))WGc(y,x,t,L,n,w);else XGc(y,x,t,L,n,w);ZGc(z,y,l);y=z;z=f[y>>2]|0;w=f[y+4>>2]|0;y=539224;n=f[y>>2]|0;L=f[y+4>>2]|0;y=(w|0)<0;t=l1c(z|0,w|0,63)|0;x=l1c(n|0,L|0,63)|0;if((t|0)==(x|0))WGc(A,z,w,n,L,y);else XGc(A,z,w,n,L,y);ZGc(B,A,l);l=B;B=f[l>>2]|0;A=f[l+4>>2]|0;l=539208;y=f[l>>2]|0;L=f[l+4>>2]|0;l=(A|0)<0;n=l1c(B|0,A|0,63)|0;w=l1c(y|0,L|0,63)|0;if((n|0)==(w|0))WGc(r,B,A,y,L,l);else XGc(r,B,A,y,L,l);ZGc(a,q,r);u=d;return}function fHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+240|0;e=d+232|0;g=d+224|0;i=d+216|0;j=d+208|0;k=d+200|0;l=d+192|0;m=d+184|0;n=d+176|0;o=d+168|0;p=d+160|0;q=d+152|0;r=d+144|0;s=d+128|0;t=d+136|0;v=d+120|0;w=d+112|0;x=d+96|0;y=d+88|0;z=d+80|0;A=d+72|0;B=d+64|0;C=d+56|0;D=d+48|0;E=d+104|0;F=d+40|0;G=d+32|0;H=d+24|0;I=d+16|0;K=d+8|0;L=d;M=c;N=f[M>>2]|0;O=f[M+4>>2]|0;M=O&2147483647;if(!(M>>>0>2146435072|(M|0)==2146435072&N>>>0>0)?(P=O&2146435072,Q=O&1048575,(N|0)==0&(M|0)==0|((O|0)>-1|(O|0)==-1&N>>>0>4294967295|((N|0)!=0|(Q|0)!=0)&(0==0&(P|0)==2146435072))):0){a:do if(0!=0|(P|0)!=2146435072|(N|0)==0&(Q|0)==0?(N|0)==0:0){if((O|0)<0)switch(O|0){case -2147483648:break;default:break a}else switch(O|0){case 0:break;default:break a}M=a;f[M>>2]=0;f[M+4>>2]=-1048576;u=d;return}while(0);if((b[539296]|0)==0?X0c(539296)|0:0){O=539304;f[O>>2]=0;f[O+4>>2]=1072693248}if((b[539312]|0)==0?X0c(539312)|0:0){O=g;f[O>>2]=0;f[O+4>>2]=-1074790400;O=e;f[O>>2]=0;f[O+4>>2]=1073741824;_Gc(539320,g,e)}if((b[539328]|0)==0?X0c(539328)|0:0){g=i;f[g>>2]=0;f[g+4>>2]=1072693248;g=e;f[g>>2]=0;f[g+4>>2]=1074266112;_Gc(539336,i,e)}if((b[539344]|0)==0?X0c(539344)|0:0){i=j;f[i>>2]=0;f[i+4>>2]=-1074790400;i=e;f[i>>2]=0;f[i+4>>2]=1074790400;_Gc(539352,j,e)}if((b[539360]|0)==0?X0c(539360)|0:0){j=k;f[j>>2]=0;f[j+4>>2]=1072693248;j=e;f[j>>2]=0;f[j+4>>2]=1075052544;_Gc(539368,k,e)}if((b[539376]|0)==0?X0c(539376)|0:0){k=l;f[k>>2]=0;f[k+4>>2]=-1074790400;k=e;f[k>>2]=0;f[k+4>>2]=1075314688;_Gc(539384,l,e)}if((b[539392]|0)==0?X0c(539392)|0:0){l=m;f[l>>2]=0;f[l+4>>2]=1072693248;l=e;f[l>>2]=0;f[l+4>>2]=1075576832;_Gc(539400,m,e)}if((b[539408]|0)==0?X0c(539408)|0:0){m=n;f[m>>2]=0;f[m+4>>2]=-1074790400;m=e;f[m>>2]=0;f[m+4>>2]=1075838976;_Gc(539416,n,e)}n=c;m=f[n>>2]|0;l=f[n+4>>2]|0;n=l1c(m|0,l|0,44)|0;k=n&255;n=l&4095|1072693248;l=o;f[l>>2]=m;f[l+4>>2]=n;XGc(o,m,n,0,1072693248,0);n=k<<1;m=16+(n<<3)|0;l=f[m>>2]|0;j=f[m+4>>2]|0;m=16+((n|1)<<3)|0;n=f[m+4>>2]|0;i=p;f[i>>2]=f[m>>2];f[i+4>>2]=n;ZGc(q,o,p);if((k|0)==255){k=s;f[k>>2]=0;f[k+4>>2]=-1074790400;k=t;f[k>>2]=0;f[k+4>>2]=1082130432;_Gc(r,s,t);s=q;k=f[s>>2]|0;p=f[s+4>>2]|0;s=r;o=f[s>>2]|0;n=f[s+4>>2]|0;s=(p|0)<0;i=l1c(k|0,p|0,63)|0;m=l1c(o|0,n|0,63)|0;if((i|0)==(m|0))WGc(e,k,p,o,n,s);else XGc(e,k,p,o,n,s);s=e;n=f[s+4>>2]|0;o=q;f[o>>2]=f[s>>2];f[o+4>>2]=n}ZGc(e,q,q);n=c;c=l1c(f[n>>2]|0,f[n+4>>2]|0,52)|0;n=c&2047;c=n+-1023|0;if(!c){R=0;S=0}else{o=n>>>0<1023?1023-n|0:c;n=o>>>0<65536;s=n?o<<16:o;p=n?16:0;n=s>>>0<16777216;k=(h[518485+((n?s<<8:s)>>>24)>>0]|0)+((n?p|8:p)&255)|0;p=u1c(c>>>31|0,0,63)|0;c=J;n=(k<<24)+352321536>>24;k=u1c(1074-n|0,0,52)|0;s=J;m=u1c(o|0,0,n|0)|0;n=d1c(m|0,J|0,p|0,c|0)|0;c=d1c(n|0,J|0,k|0,s|0)|0;R=c;S=J}c=r;f[c>>2]=R;f[c+4>>2]=S;ZGc(v,23720,r);r=v;v=f[r>>2]|0;S=f[r+4>>2]|0;r=(S|0)<0;c=l1c(v|0,S|0,63)|0;R=l1c(l|0,j|0,63)|0;if((c|0)==(R|0))WGc(w,v,S,l,j,r);else XGc(w,v,S,l,j,r);ZGc(x,539416,e);r=x;x=f[r>>2]|0;j=f[r+4>>2]|0;r=539384;l=f[r>>2]|0;S=f[r+4>>2]|0;r=(j|0)<0;v=l1c(x|0,j|0,63)|0;R=l1c(l|0,S|0,63)|0;if((v|0)==(R|0))WGc(y,x,j,l,S,r);else XGc(y,x,j,l,S,r);ZGc(z,y,e);y=z;z=f[y>>2]|0;r=f[y+4>>2]|0;y=539352;S=f[y>>2]|0;l=f[y+4>>2]|0;y=(r|0)<0;j=l1c(z|0,r|0,63)|0;x=l1c(S|0,l|0,63)|0;if((j|0)==(x|0))WGc(A,z,r,S,l,y);else XGc(A,z,r,S,l,y);ZGc(B,A,e);A=B;B=f[A>>2]|0;y=f[A+4>>2]|0;A=539320;l=f[A>>2]|0;S=f[A+4>>2]|0;A=(y|0)<0;r=l1c(B|0,y|0,63)|0;z=l1c(l|0,S|0,63)|0;if((r|0)==(z|0))WGc(C,B,y,l,S,A);else XGc(C,B,y,l,S,A);ZGc(t,C,e);C=w;w=f[C>>2]|0;A=f[C+4>>2]|0;C=t;t=f[C>>2]|0;S=f[C+4>>2]|0;C=(A|0)<0;l=l1c(w|0,A|0,63)|0;y=l1c(t|0,S|0,63)|0;if((l|0)==(y|0))WGc(D,w,A,t,S,C);else XGc(D,w,A,t,S,C);ZGc(F,539400,e);C=F;F=f[C>>2]|0;S=f[C+4>>2]|0;C=539368;t=f[C>>2]|0;A=f[C+4>>2]|0;C=(S|0)<0;w=l1c(F|0,S|0,63)|0;y=l1c(t|0,A|0,63)|0;if((w|0)==(y|0))WGc(G,F,S,t,A,C);else XGc(G,F,S,t,A,C);ZGc(H,G,e);G=H;H=f[G>>2]|0;C=f[G+4>>2]|0;G=539336;A=f[G>>2]|0;t=f[G+4>>2]|0;G=(C|0)<0;S=l1c(H|0,C|0,63)|0;F=l1c(A|0,t|0,63)|0;if((S|0)==(F|0))WGc(I,H,C,A,t,G);else XGc(I,H,C,A,t,G);ZGc(K,I,e);e=K;K=f[e>>2]|0;I=f[e+4>>2]|0;e=539304;G=f[e>>2]|0;t=f[e+4>>2]|0;e=(I|0)<0;A=l1c(K|0,I|0,63)|0;C=l1c(G|0,t|0,63)|0;if((A|0)==(C|0))WGc(L,K,I,G,t,e);else XGc(L,K,I,G,t,e);ZGc(E,L,q);q=D;D=f[q>>2]|0;L=f[q+4>>2]|0;q=E;E=f[q>>2]|0;e=f[q+4>>2]|0;q=(L|0)<0;t=l1c(D|0,L|0,63)|0;G=l1c(E|0,e|0,63)|0;if((t|0)==(G|0))WGc(a,D,L,E,e,q);else XGc(a,D,L,E,e,q);u=d;return}q=a;f[q>>2]=-1;f[q+4>>2]=2147483647;u=d;return}function gHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+64|0;g=e+56|0;h=e+48|0;i=e+40|0;j=e+32|0;k=e+8|0;l=e;m=e+24|0;n=e+16|0;o=c;c=f[o+4>>2]|0;p=m;f[p>>2]=f[o>>2];f[p+4>>2]=c;c=d;d=f[c+4>>2]|0;p=n;f[p>>2]=f[c>>2];f[p+4>>2]=d;if((b[539424]|0)==0?X0c(539424)|0:0){d=539432;f[d>>2]=0;f[d+4>>2]=0}if((b[539440]|0)==0?X0c(539440)|0:0){d=539448;f[d>>2]=0;f[d+4>>2]=1072693248}if((b[539456]|0)==0?X0c(539456)|0:0){d=539464;f[d>>2]=0;f[d+4>>2]=2146435072}if((b[539472]|0)==0?X0c(539472)|0:0){d=539480;f[d>>2]=-1;f[d+4>>2]=2147483647}d=m;m=f[d>>2]|0;p=f[d+4>>2]|0;d=p&2147483647;c=(m|0)==0&(d|0)==2146435072;o=n;q=f[o>>2]|0;r=f[o+4>>2]|0;o=r&2147483647;s=(q|0)==0&(o|0)==2146435072;t=d>>>0>2146435072|(d|0)==2146435072&m>>>0>0;v=o>>>0>2146435072|(o|0)==2146435072&q>>>0>0;w=539432;x=f[w>>2]|0;y=f[w+4>>2]|0;w=y&2146435072;z=y&1048575;A=0!=0|(w|0)!=2146435072|(x|0)==0&(z|0)==0;do if(A?0!=0|(r&2146435072|0)!=2146435072|(q|0)==0&(r&1048575|0)==0:0){B=l1c(x|0,y|0,63)|0;C=l1c(q|0,r|0,63)|0;if((B|0)==(C|0)){D=((x|0)!=(q|0)|(y|0)!=(r|0))&(B|0)!=((y>>>0<r>>>0|(y|0)==(r|0)&x>>>0<q>>>0)&1|0);break}else{D=(y|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0);break}}else D=0;while(0);B=539448;C=f[B>>2]|0;E=f[B+4>>2]|0;B=E&2146435072;F=0!=0|(B|0)!=2146435072;G=E&1048575;H=(C|0)==0&(G|0)==0;do if(F|H?0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0:0)if((E|0)>-1|(E|0)==-1&C>>>0>4294967295){I=E>>>0<d>>>0|(E|0)==(d|0)&C>>>0<m>>>0;break}else{I=(C|m|0)!=0|((E|p)&2147483647|0)!=0;break}else I=0;while(0);K=D^I;I=a;f[I>>2]=0;f[I+4>>2]=0;if(v){if((a|0)==539480){u=e;return}v=539480;I=f[v+4>>2]|0;D=a;f[D>>2]=f[v>>2];f[D+4>>2]=I;u=e;return}if(s){if(((m|0)!=0|(p&1048575|0)!=0)&(0==0&(p&2146435072|0)==2146435072)|(F|H)^1){L=t;M=K?539432:539464}else{L=(m|0)==(C|0)&(d|0)==(E|0)|(C|m|0)==0&((E|p)&2147483647|0)==0;M=t?539480:K?539432:539464}K=L?539480:M;if((K|0)==(a|0)){u=e;return}M=K;K=f[M+4>>2]|0;L=a;f[L>>2]=f[M>>2];f[L+4>>2]=K;u=e;return}K=0!=0|(r&2146435072|0)!=2146435072;L=r&1048575;M=(q|0)==0&(L|0)==0;d=K|M;do if(d){if(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((q|0)!=(x|0)|(r|0)!=(y|0))&((x|q|0)!=0|((y|r)&2147483647|0)!=0)){if(((C|0)!=0|(G|0)!=0)&(0==0&(B|0)==2146435072)|((q|0)!=(C|0)|(r|0)!=(E|0))&((C|q|0)!=0|((E|r)&2147483647|0)!=0))break;H=a;f[H>>2]=m;f[H+4>>2]=p;u=e;return}if((a|0)==539448){u=e;return}H=a;f[H>>2]=C;f[H+4>>2]=E;u=e;return}while(0);if(t){if((a|0)==539480){u=e;return}t=539480;E=f[t+4>>2]|0;C=a;f[C>>2]=f[t>>2];f[C+4>>2]=E;u=e;return}if(c){do if(d&A){c=l1c(q|0,r|0,63)|0;E=l1c(x|0,y|0,63)|0;if((c|0)==(E|0)){if(!(((q|0)!=(x|0)|(r|0)!=(y|0))&(E|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0))){N=539464;break}}else if(!((r|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0))){N=539464;break}N=539432}else N=539464;while(0);if((N|0)==(a|0)){u=e;return}E=N;N=f[E+4>>2]|0;c=a;f[c>>2]=f[E>>2];f[c+4>>2]=N;u=e;return}N=l1c(q|0,r|0,52)|0;c=N&2047;do if(c>>>0>=1023){if(c>>>0<=1074){N=u1c(1,0,1075-c|0)|0;E=J;C=d1c(N|0,E|0,-1,-1)|0;t=J;B=l1c(N|0,E|0,1)|0;G=d1c(B|0,J|0,q|0,r|0)|0;B=J;H=(G&C|0)==0&(B&t|0)==0;t=c1c(0,0,N|0,E|0)|0;O=B&J&(H?~E:-1);P=G&t&(H?~N:-1);break}if(M|(c|0)!=2047){O=r;P=q}else{N=0==0&(r&2146959360|0)==2146435072&((q|0)!=0|(r&524287|0)!=0);O=(N?r:K?0:r)|524288;P=N?q:K?0:q}}else{N=(q|0)==0&(o|0)==0;H=r&-2147483648;t=((q|0)!=0|(L|0)!=0)&(c|0)==1022;O=N?r:t?H|1072693248:H;P=N?q:t?0:0}while(0);if(d?!(((P|0)!=0|(O&1048575|0)!=0)&(0==0&(O&2146435072|0)==2146435072)|((q|0)!=(P|0)|(r|0)!=(O|0))&((P|q|0)!=0|((O|r)&2147483647|0)!=0)):0){O=(r|0)<0&(M|(c|0)!=2047);M=(c|0)==0;P=M?q:q;o=M?L:L|1048576;L=1063-c|0;do if((L|0)>0)if(L>>>0<63){c=l1c(P|0,o|0,L|0)|0;M=J;K=u1c(P|0,o|0,0-L&63|0)|0;Q=((K|0)!=0|(J|0)!=0)&1|c;R=M;break}else{Q=((P|0)!=0|(o|0)!=0)&1;R=0;break}else{Q=P;R=o}while(0);o=d1c(Q|0,R|0,2048,0)|0;R=J;if(!(R>>>0>4095|(R|0)==4095&o>>>0>4294967295)){P=l1c(o|0,R|0,12)|0;R=(Q&4095|0)==2048&0==0&1;Q=O?(R|~P)+1|0:P&~R;if(Q)if((Q>>>31|0)==(O&1|0))S=Q;else T=64;else S=0}else T=64;if((T|0)==64)S=O?-2147483648:2147483647;a:do if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0?(m|0)==0:0){if((p|0)<0)switch(p|0){case -2147483648:break;default:{T=69;break a}}else switch(p|0){case 0:break;default:{T=69;break a}}O=(S|0)<0;Q=(S|0)==0;U=O?0:Q?0:0;V=O?2146435072:Q?1072693248:0}else T=69;while(0);if((T|0)==69){T=h;f[T>>2]=0;f[T+4>>2]=1072693248;T=i;f[T>>2]=m;f[T+4>>2]=p;T=(S|0)>-1?S:0-S|0;if((S|0)<0){S=j;f[S>>2]=0;f[S+4>>2]=1072693248;_Gc(g,j,i);j=g;S=f[j+4>>2]|0;Q=i;f[Q>>2]=f[j>>2];f[Q+4>>2]=S}if((T|0)>1){S=T;while(1){if(S&1|0){ZGc(g,h,i);T=g;Q=f[T+4>>2]|0;j=h;f[j>>2]=f[T>>2];f[j+4>>2]=Q}ZGc(g,i,i);Q=g;j=f[Q+4>>2]|0;T=i;f[T>>2]=f[Q>>2];f[T+4>>2]=j;if(S>>>0>3)S=S>>>1;else break}}ZGc(g,h,i);i=g;U=f[i>>2]|0;V=f[i+4>>2]|0}i=a;f[i>>2]=U;f[i+4>>2]=V;u=e;return}if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0){do if(A){V=l1c(m|0,p|0,63)|0;i=l1c(x|0,y|0,63)|0;if((V|0)==(i|0)){if(!(((m|0)!=(x|0)|(p|0)!=(y|0))&(i|0)!=((p>>>0<y>>>0|(p|0)==(y|0)&m>>>0<x>>>0)&1|0)))break}else if(!((p|0)<0&((x|m|0)!=0|((y|p)&2147483647|0)!=0)))break;if((a|0)==539480){u=e;return}i=539480;V=f[i+4>>2]|0;U=a;f[U>>2]=f[i>>2];f[U+4>>2]=V;u=e;return}while(0);if(!(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((m|0)!=(x|0)|(p|0)!=(y|0))&((x|m|0)!=0|((y|p)&2147483647|0)!=0))){do if(d&A){w=l1c(q|0,r|0,63)|0;z=l1c(x|0,y|0,63)|0;if((w|0)!=(z|0)){w=x|q;V=(y|r)&2147483647;if((r|0)<0&((w|0)!=0|(V|0)!=0)){W=539464;break}else{X=w;Y=V}}else{if(((q|0)!=(x|0)|(r|0)!=(y|0))&(z|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0)){W=539464;break}X=x|q;Y=(y|r)&2147483647}W=(q|0)==(x|0)&(r|0)==(y|0)|(X|0)==0&(Y|0)==0?539448:539432}else W=539432;while(0);if((W|0)==(a|0)){u=e;return}Y=W;W=f[Y+4>>2]|0;X=a;f[X>>2]=f[Y>>2];f[X+4>>2]=W;u=e;return}}W=l;f[W>>2]=m;f[W+4>>2]=p;fHc(h,l);ZGc(k,n,h);eHc(g,k);if((g|0)!=(a|0)){k=g;g=f[k+4>>2]|0;h=a;f[h>>2]=f[k>>2];f[h+4>>2]=g}u=e;return}function hHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+160|0;d=c+152|0;e=c+144|0;g=c+136|0;h=c+128|0;i=c+120|0;j=c+112|0;k=c+104|0;l=c+96|0;m=c+88|0;n=c+80|0;o=c+72|0;p=c+64|0;q=c+56|0;r=c+48|0;s=c+40|0;t=c+32|0;v=c+24|0;w=c+16|0;x=c+8|0;y=c;z=f[b>>2]|0;b=z&2147483647;if(b>>>0>2139095040){f[a>>2]=2147483647;u=c;return}if((b|0)==2139095040){f[a>>2]=z;u=c;return}A=(z>>>23&255)+-127|0;B=(A|0)%3|0;C=B+-3-(B>>31&-3)|0;B=u1c(C+1023|0,0,52)|0;D=J;E=u1c(z&8388607|0,0,29)|0;F=d;f[F>>2]=B|E;f[F+4>>2]=D|J;D=e;f[D>>2]=1716763248;f[D+4>>2]=1078370462;D=g;f[D>>2]=1712249633;f[D+4>>2]=1076731424;ZGc(i,e,d);e=i;i=f[e>>2]|0;D=f[e+4>>2]|0;e=(D|0)<0;if((D|0)>-1|(D|0)==-1&i>>>0>4294967295)WGc(j,i,D,1818302176,1080559860,e);else XGc(j,i,D,1818302176,1080559860,e);ZGc(k,j,d);j=k;k=f[j>>2]|0;e=f[j+4>>2]|0;j=(e|0)<0;if((e|0)>-1|(e|0)==-1&k>>>0>4294967295)WGc(l,k,e,1134341652,1079888535,j);else XGc(l,k,e,1134341652,1079888535,j);ZGc(m,l,d);l=m;m=f[l>>2]|0;j=f[l+4>>2]|0;l=(j|0)<0;if((j|0)>-1|(j|0)==-1&m>>>0>4294967295)WGc(n,m,j,-763202304,1076551024,l);else XGc(n,m,j,-763202304,1076551024,l);ZGc(o,n,d);n=o;o=f[n>>2]|0;l=f[n+4>>2]|0;n=(l|0)<0;if((l|0)>-1|(l|0)==-1&o>>>0>4294967295)WGc(p,o,l,-2081071827,1069871455,n);else XGc(p,o,l,-2081071827,1069871455,n);ZGc(r,g,d);g=r;r=f[g>>2]|0;n=f[g+4>>2]|0;g=(n|0)<0;if((n|0)>-1|(n|0)==-1&r>>>0>4294967295)WGc(s,r,n,-1071097835,1080229653,g);else XGc(s,r,n,-1071097835,1080229653,g);ZGc(t,s,d);s=t;t=f[s>>2]|0;g=f[s+4>>2]|0;s=(g|0)<0;if((g|0)>-1|(g|0)==-1&t>>>0>4294967295)WGc(v,t,g,1786843854,1080365264,s);else XGc(v,t,g,1786843854,1080365264,s);ZGc(w,v,d);v=w;w=f[v>>2]|0;s=f[v+4>>2]|0;v=(s|0)<0;if((s|0)>-1|(s|0)==-1&w>>>0>4294967295)WGc(x,w,s,-907885707,1078001355,v);else XGc(x,w,s,-907885707,1078001355,v);ZGc(y,x,d);x=y;y=f[x>>2]|0;v=f[x+4>>2]|0;x=(v|0)<0;if((v|0)>-1|(v|0)==-1&y>>>0>4294967295)WGc(q,y,v,0,1072693248,x);else XGc(q,y,v,0,1072693248,x);_Gc(h,p,q);q=h;h=f[q>>2]|0;p=f[q+4>>2]|0;q=d;f[q>>2]=h;f[q+4>>2]=p;if(!b)G=0;else{b=l1c(h|0,p|0,29)|0;G=b&8388607|(((A-C|0)/3|0)<<23)+(z&-2147483648|1056964608)}f[a>>2]=G;u=c;return}function iHc(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;a=u;u=u+16|0;c=a;if(b[539488]|0){u=a;return}if(!(X0c(539488)|0)){u=a;return}if((b[539496]|0)==0?X0c(539496)|0:0){KN(894412,518741,518758);be(2220,894412,x|0)|0}d=b[894423]|0;e=f[223604]|0;if(((d<<24>>24<0?e:d&255)|0)==8)if(!(LYc(894412,0,-1,518766,8)|0))g=0;else{h=b[894423]|0;i=f[223604]|0;j=9}else{h=d;i=e;j=9}do if((j|0)==9){if(((h<<24>>24<0?i:h&255)|0)==8){if(!(LYc(894412,0,-1,518775,8)|0)){g=0;break}k=b[894423]|0;l=f[223604]|0}else{k=h;l=i}if(((k<<24>>24<0?l:k&255)|0)==1){if(!(LYc(894412,0,-1,518784,1)|0)){g=0;break}m=b[894423]|0;n=f[223604]|0}else{m=k;n=l}if(((m<<24>>24<0?n:m&255)|0)==3){if(!(LYc(894412,0,-1,518786,3)|0)){g=0;break}o=b[894423]|0;p=f[223604]|0}else{o=m;p=n}if(((o<<24>>24<0?p:o&255)|0)==3){if(!(LYc(894412,0,-1,518790,3)|0)){g=0;break}q=b[894423]|0;r=f[223604]|0}else{q=o;r=p}if(((q<<24>>24<0?r:q&255)|0)==5){if(!(LYc(894412,0,-1,518794,5)|0)){g=1;break}s=b[894423]|0;t=f[223604]|0}else{s=q;t=r}if(((s<<24>>24<0?t:s&255)|0)==5){if(!(LYc(894412,0,-1,518800,5)|0)){g=1;break}v=b[894423]|0;w=f[223604]|0}else{v=s;w=t}if(((v<<24>>24<0?w:v&255)|0)==5){if(!(LYc(894412,0,-1,518806,5)|0)){g=2;break}y=b[894423]|0;z=f[223604]|0}else{y=v;z=w}if(((y<<24>>24<0?z:y&255)|0)==5){if(!(LYc(894412,0,-1,518812,5)|0)){g=2;break}A=b[894423]|0;B=f[223604]|0}else{A=y;B=z}if(((A<<24>>24<0?B:A&255)|0)==7){if(!(LYc(894412,0,-1,518758,7)|0)){g=3;break}C=b[894423]|0;D=f[223604]|0}else{C=A;D=B}if(((C<<24>>24<0?D:C&255)|0)==7){if(!(LYc(894412,0,-1,518818,7)|0)){g=3;break}E=f[223604]|0;F=b[894423]|0}else{E=D;F=C}if(((F<<24>>24<0?E:F&255)|0)==8){if(!(LYc(894412,0,-1,518826,8)|0)){g=3;break}G=b[894423]|0;H=f[223604]|0}else{G=F;H=E}if(((G<<24>>24<0?H:G&255)|0)==8){if(!(LYc(894412,0,-1,518835,8)|0)){g=3;break}I=b[894423]|0;J=f[223604]|0}else{I=G;J=H}if(((I<<24>>24<0?J:I&255)|0)==4){if(!(LYc(894412,0,-1,518844,4)|0)){g=3;break}K=b[894423]|0;L=f[223604]|0}else{K=I;L=J}if(((K<<24>>24<0?L:K&255)|0)==4){if(!(LYc(894412,0,-1,518849,4)|0)){g=3;break}M=b[894423]|0;N=f[223604]|0}else{M=K;N=L}if(((M<<24>>24<0?N:M&255)|0)==4){if(!(LYc(894412,0,-1,518854,4)|0)){g=4;break}O=b[894423]|0;P=f[223604]|0}else{O=M;P=N}if(((O<<24>>24<0?P:O&255)|0)==4){if(!(LYc(894412,0,-1,518859,4)|0)){g=4;break}Q=b[894423]|0;R=f[223604]|0}else{Q=O;R=P}if(((Q<<24>>24<0?R:Q&255)|0)==5){if(!(LYc(894412,0,-1,518864,5)|0)){g=5;break}S=b[894423]|0;T=f[223604]|0}else{S=Q;T=R}if(((S<<24>>24<0?T:S&255)|0)==5){if(!(LYc(894412,0,-1,518870,5)|0)){g=5;break}U=b[894423]|0;V=f[223604]|0}else{U=S;V=T}if(((U<<24>>24<0?V:U&255)|0)==7){if(!(LYc(894412,0,-1,518876,7)|0)){g=6;break}W=b[894423]|0;X=f[223604]|0}else{W=U;X=V}if(((W<<24>>24<0?X:W&255)|0)==7?(LYc(894412,0,-1,518884,7)|0)==0:0){g=6;break}e=BM(895384,518892,39)|0;d=(b[894423]|0)<0?f[223603]|0:894412;Y=BM(e,d,dJc(d)|0)|0;ZNc(c,Y+(f[(f[Y>>2]|0)+-12>>2]|0)|0);d=DPc(c,896088)|0;e=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;EPc(c);sOc(Y,e)|0;dOc(Y)|0;g=4}while(0);f[223602]=g;u=a;return}function jHc(){iHc();return f[223602]|0}function kHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+160|0;e=d+136|0;g=d;h=CN()|0;i=g+56|0;j=g+4|0;f[g>>2]=6884;f[i>>2]=6904;XNc(g+56|0,j);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=36020;f[i>>2]=36040;aOc(j);f[j>>2]=35912;k=g+36|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;AM(j,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);switch(a|0){case 1:{l=BM(BM(nOc(BM(g,518932,7)|0,h)|0,518940,2)|0,c,dJc(c)|0)|0;ZNc(e,l+(f[(f[l>>2]|0)+-12>>2]|0)|0);m=DPc(e,896088)|0;n=Mi[f[(f[m>>2]|0)+28>>2]&1023](m,10)|0;EPc(e);sOc(l,n)|0;dOc(l)|0;o=10;break}case 2:{l=BM(BM(nOc(BM(g,518943,7)|0,h)|0,518940,2)|0,c,dJc(c)|0)|0;ZNc(e,l+(f[(f[l>>2]|0)+-12>>2]|0)|0);n=DPc(e,896088)|0;m=Mi[f[(f[n>>2]|0)+28>>2]&1023](n,10)|0;EPc(e);sOc(l,m)|0;dOc(l)|0;o=10;break}case 3:{l=BM(BM(nOc(BM(g,518951,7)|0,h)|0,518940,2)|0,c,dJc(c)|0)|0;ZNc(e,l+(f[(f[l>>2]|0)+-12>>2]|0)|0);m=DPc(e,896088)|0;n=Mi[f[(f[m>>2]|0)+28>>2]&1023](m,10)|0;EPc(e);sOc(l,n)|0;dOc(l)|0;o=10;break}case 4:{l=BM(BM(nOc(BM(g,518959,7)|0,h)|0,518940,2)|0,c,dJc(c)|0)|0;ZNc(e,l+(f[(f[l>>2]|0)+-12>>2]|0)|0);n=DPc(e,896088)|0;m=Mi[f[(f[n>>2]|0)+28>>2]&1023](n,10)|0;EPc(e);sOc(l,m)|0;dOc(l)|0;o=10;break}case 5:{l=BM(BM(nOc(BM(g,518967,7)|0,h)|0,518940,2)|0,c,dJc(c)|0)|0;ZNc(e,l+(f[(f[l>>2]|0)+-12>>2]|0)|0);h=DPc(e,896088)|0;m=Mi[f[(f[h>>2]|0)+28>>2]&1023](h,10)|0;EPc(e);sOc(l,m)|0;dOc(l)|0;o=10;break}case 6:{l=BM(g,c,dJc(c)|0)|0;ZNc(e,l+(f[(f[l>>2]|0)+-12>>2]|0)|0);c=DPc(e,896088)|0;m=Mi[f[(f[c>>2]|0)+28>>2]&1023](c,10)|0;EPc(e);sOc(l,m)|0;dOc(l)|0;o=10;break}default:{}}if((o|0)==10){o=(a|0)<4;a=o?895384:895216;CM(e,j);l=e+11|0;m=(b[l>>0]|0)<0?f[e>>2]|0:e;BM(a,m,dJc(m)|0)|0;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);if(o)dOc(a)|0}f[g>>2]=36020;f[i>>2]=36040;f[j>>2]=35912;if((b[k+11>>0]|0)>=0){LMc(j);HNc(g,36052);GMc(i);u=d;return}cYc(f[k>>2]|0);LMc(j);HNc(g,36052);GMc(i);u=d;return}function lHc(a){a=a|0;var b=0;do if(a)if((f[a+12>>2]|0)==7247){b=vHc(a)|0;break}else{b=AHc(a)|0;break}else b=-2;while(0);return b|0}function mHc(a,b){a=a|0;b=b|0;return nHc(a,-1,b)|0}function nHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e+8|0;h=e;if(!a){i=0;u=e;return i|0}j=jIc(140)|0;if(!j){i=0;u=e;return i|0}f[j+24>>2]=0;f[j+28>>2]=8192;k=j+80|0;f[k>>2]=0;l=j+12|0;f[l>>2]=0;m=j+60|0;f[m>>2]=-1;n=j+64|0;f[n>>2]=0;o=j+40|0;f[o>>2]=0;p=b[d>>0]|0;a:do if(p<<24>>24){q=0;r=d;s=0;t=p;v=0;w=0;b:while(1){x=t<<24>>24;c:do if((t+-48&255)<10){f[m>>2]=x+-48;y=s;z=q;A=w;B=v}else do switch(x|0){case 43:{C=10;break b;break}case 114:{f[l>>2]=7247;y=s;z=q;A=7247;B=v;break c;break}case 119:{f[l>>2]=31153;y=s;z=q;A=31153;B=v;break c;break}case 97:{f[l>>2]=1;y=s;z=q;A=1;B=v;break c;break}case 84:{f[o>>2]=1;y=s;z=q;A=w;B=1;break c;break}case 101:{y=s;z=1;A=w;B=v;break c;break}case 120:{y=1;z=q;A=w;B=v;break c;break}case 102:{f[n>>2]=1;y=s;z=q;A=w;B=v;break c;break}case 104:{f[n>>2]=2;y=s;z=q;A=w;B=v;break c;break}case 82:{f[n>>2]=3;y=s;z=q;A=w;B=v;break c;break}case 70:{f[n>>2]=4;y=s;z=q;A=w;B=v;break c;break}default:{y=s;z=q;A=w;B=v;break c}}while(0);while(0);r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24))break;else{q=z;s=y;v=B;w=A}}if((C|0)==10){kIc(j);i=0;u=e;return i|0}d:do if((A|0)<7247)switch(A|0){case 0:{break a;break}default:{}}else{switch(A|0){case 7247:break;default:break d}if(!B){f[o>>2]=1;break}kIc(j);i=0;u=e;return i|0}while(0);w=(dJc(a)|0)+1|0;v=jIc(w)|0;s=j+20|0;f[s>>2]=v;if(!v){kIc(j);i=0;u=e;return i|0}f[h>>2]=a;oJc(v,w,518975,h)|0;w=f[l>>2]|0;do if((c|0)>-1){f[j+16>>2]=c;D=w;E=c}else{f[g>>2]=438;v=MIc(a,((w|0)==7247?0:((w|0)==31153?512:1024)|(y|0?193:65))|(z|0?557056:32768),g)|0;f[j+16>>2]=v;if((v|0)!=-1){D=f[l>>2]|0;E=v;break}kIc(f[s>>2]|0);kIc(j);i=0;u=e;return i|0}while(0);e:do if((D|0)>=7247){switch(D|0){case 7247:break;default:{F=j;C=35;break e}}s=NIc(E,0,1)|0;f[j+48>>2]=(s|0)==-1?0:s;s=f[l>>2]|0;f[j>>2]=0;if((s|0)==7247){f[j+52>>2]=0;f[j+56>>2]=0;F=j+44|0;C=35}}else{switch(D|0){case 1:break;default:{F=j;C=35;break e}}NIc(E,0,2)|0;f[l>>2]=31153;F=j;C=35}while(0);if((C|0)==35)f[F>>2]=0;f[j+72>>2]=0;s=f[k>>2]|0;w=j+76|0;if(s|0){if((f[w>>2]|0)!=-4)kIc(s);f[k>>2]=0}f[w>>2]=0;f[j+8>>2]=0;f[j+88>>2]=0;i=j;u=e;return i|0}while(0);kIc(j);i=0;u=e;return i|0}function oHc(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=-1;return b|0}c=a+12|0;if((f[c>>2]|0)!=7247){b=-1;return b|0}d=a+76|0;switch(f[d>>2]|0){case -5:case 0:break;default:{b=-1;return b|0}}if((NIc(f[a+16>>2]|0,f[a+48>>2]|0,0)|0)==-1){b=-1;return b|0}f[a>>2]=0;if((f[c>>2]|0)==7247){f[a+52>>2]=0;f[a+56>>2]=0;f[a+44>>2]=0}f[a+72>>2]=0;c=a+80|0;e=f[c>>2]|0;if(e|0){if((f[d>>2]|0)!=-4)kIc(e);f[c>>2]=0}f[d>>2]=0;f[a+8>>2]=0;f[a+88>>2]=0;b=0;return b|0}function pHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+80|0;h=f[g>>2]|0;if(h|0){if((f[a+76>>2]|0)!=-4)kIc(h);f[g>>2]=0}switch(b|0){case 0:case -5:break;default:f[a>>2]=0}h=a+76|0;f[h>>2]=b;if((b|0)==-4|(c|0)==0){u=d;return}b=f[a+20>>2]|0;a=dJc(b)|0;i=jIc(a+3+(dJc(c)|0)|0)|0;f[g>>2]=i;if(!i){f[h>>2]=-4;u=d;return}else{h=dJc(b)|0;g=h+3+(dJc(c)|0)|0;f[e>>2]=b;f[e+4>>2]=518985;f[e+8>>2]=c;oJc(i,g,518978,e)|0;u=d;return}}function qHc(a){a=a|0;var b=0;if((a|0)!=0?(f[a+12>>2]|0)==7247:0)b=f[a+56>>2]|0;else b=0;return b|0}function rHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+44|0;c=a+52|0;d=a+88|0;e=a+24|0;g=a+100|0;h=a+36|0;i=a+96|0;a:while(1){switch(f[b>>2]|0){case 1:{j=5;break a;break}case 0:{if((tHc(a)|0)==-1){k=-1;j=16;break a}if(!(f[b>>2]|0)){k=0;j=16;break a}break}case 2:{f[g>>2]=f[e>>2]<<1;f[i>>2]=f[h>>2];if((sHc(a)|0)==-1){k=-1;j=16;break a}break}default:{}}if(f[a>>2]|0){k=0;j=16;break}if(!(f[c>>2]|0))continue;if(!(f[d>>2]|0)){k=0;j=16;break}}if((j|0)==5){d=f[h>>2]|0;i=f[e>>2]<<1;f[a>>2]=0;e=a+16|0;g=0;do{b=i-g|0;l=hJc(f[e>>2]|0,d+g|0,b>>>0<1073741824?b:1073741824)|0;if((l|0)<1){j=8;break}g=(f[a>>2]|0)+l|0;f[a>>2]=g}while(g>>>0<i>>>0);do if((j|0)==8){if((l|0)>=0){f[c>>2]=1;break}i=vIc()|0;pHc(a,-1,HIc(f[i>>2]|0)|0);k=-1;return k|0}while(0);f[a+4>>2]=f[h>>2];k=0;return k|0}else if((j|0)==16)return k|0;return 0}function sHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=a+84|0;c=a+100|0;d=f[c>>2]|0;e=a+88|0;g=a+76|0;h=a+52|0;i=a+32|0;j=a+24|0;k=a+16|0;l=0;a:while(1){if(!(f[e>>2]|0)){switch(f[g>>2]|0){case -5:case 0:break;default:{m=-1;n=20;break a}}if(f[h>>2]|0){n=12;break}o=f[i>>2]|0;p=f[j>>2]|0;q=0;while(1){r=p-q|0;s=hJc(f[k>>2]|0,o+q|0,r>>>0<1073741824?r:1073741824)|0;if((s|0)<1){n=8;break}r=s+q|0;if(r>>>0<p>>>0)q=r;else{t=r;break}}if((n|0)==8){n=0;if((s|0)<0){n=10;break}f[h>>2]=1;t=q}p=(f[e>>2]|0)+t|0;f[e>>2]=p;f[b>>2]=f[i>>2];if(!p){n=12;break}}p=EHc(b,0)|0;switch(p|0){case 2:case -2:{n=14;break a;break}case -4:{n=15;break a;break}case -3:{n=16;break a;break}default:{}}o=f[c>>2]|0;if((p|0)!=1&(o|0)!=0)l=p;else{u=p;v=o;break}}if((n|0)==10){b=vIc()|0;pHc(a,-1,HIc(f[b>>2]|0)|0);m=-1;return m|0}else if((n|0)==12){pHc(a,-5,518988);u=l;v=f[c>>2]|0}else if((n|0)==14){pHc(a,-2,519011);m=-1;return m|0}else if((n|0)==15){pHc(a,-4,519111);m=-1;return m|0}else if((n|0)==16){c=f[a+108>>2]|0;pHc(a,-3,(c|0)==0?519050:c);m=-1;return m|0}else if((n|0)==20)return m|0;n=d-v|0;f[a>>2]=n;f[a+4>>2]=(f[a+96>>2]|0)+(0-n);if((u|0)!=1){m=0;return m|0}f[a+44>>2]=0;m=0;return m|0}function tHc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+84|0;d=a+24|0;if(!(f[d>>2]|0)){e=f[a+28>>2]|0;g=jIc(e)|0;h=a+32|0;f[h>>2]=g;i=jIc(e<<1)|0;j=a+36|0;f[j>>2]=i;if((g|0)==0|(i|0)==0){kIc(i);kIc(f[h>>2]|0);pHc(a,-4,519111);k=-1;return k|0}f[d>>2]=e;f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;e=a+88|0;f[e>>2]=0;f[c>>2]=0;if(!(DHc(c,31,519125,56)|0))l=e;else{kIc(f[j>>2]|0);kIc(f[h>>2]|0);f[d>>2]=0;pHc(a,-4,519111);k=-1;return k|0}}else l=a+88|0;h=f[l>>2]|0;a:do if(h>>>0<2){switch(f[a+76>>2]|0){case -5:case 0:break;default:{k=-1;return k|0}}j=a+52|0;if(!(f[j>>2]|0)){e=a+32|0;if(!h)m=0;else{b[f[e>>2]>>0]=b[f[c>>2]>>0]|0;m=f[l>>2]|0}i=(f[e>>2]|0)+m|0;g=(f[d>>2]|0)-m|0;n=a+16|0;o=0;while(1){p=g-o|0;q=hJc(f[n>>2]|0,i+o|0,p>>>0<1073741824?p:1073741824)|0;if((q|0)<1){r=15;break}p=q+o|0;if(p>>>0<g>>>0)o=p;else{s=p;break}}do if((r|0)==15){if((q|0)>=0){f[j>>2]=1;s=o;break}g=vIc()|0;pHc(a,-1,HIc(f[g>>2]|0)|0);k=-1;return k|0}while(0);o=(f[l>>2]|0)+s|0;f[l>>2]=o;f[c>>2]=f[e>>2];t=o}else t=h;switch(t|0){case 1:{u=1;break a;break}case 0:{k=0;break}default:{v=t;r=20;break a}}return k|0}else{v=h;r=20}while(0);if((r|0)==20){r=f[c>>2]|0;if((b[r>>0]|0)==31?(b[r+1>>0]|0)==-117:0){BHc(c)|0;f[a+44>>2]=2;f[a+40>>2]=0;k=0;return k|0}else u=v}v=a+40|0;if(!(f[v>>2]|0)){f[l>>2]=0;f[a+52>>2]=1;f[a>>2]=0;k=0;return k|0}else{r=f[a+36>>2]|0;f[a+4>>2]=r;o1c(r|0,f[c>>2]|0,u|0)|0;f[a>>2]=f[l>>2];f[l>>2]=0;f[a+44>>2]=1;f[v>>2]=1;k=0;return k|0}return 0}function uHc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((a|0)==0|(c|0)==0|(d|0)<1){e=0;return e|0}if((f[a+12>>2]|0)!=7247){e=0;return e|0}switch(f[a+76>>2]|0){case -5:case 0:break;default:{e=0;return e|0}}g=a+72|0;a:do if(f[g>>2]|0?(f[g>>2]=0,h=f[a+68>>2]|0,i=a+88|0,j=a+52|0,k=a+4|0,l=a+8|0,h|0):0){m=h;b:while(1){while(1){n=f[a>>2]|0;if(n|0)break;if(f[j>>2]|0?(f[i>>2]|0)==0:0)break a;if((rHc(a)|0)==-1){e=0;break b}}h=(n|0)<0|(n|0)>(m|0)?m:n;f[a>>2]=n-h;f[k>>2]=(f[k>>2]|0)+h;f[l>>2]=(f[l>>2]|0)+h;m=m-h|0;if(!m)break a}return e|0}while(0);n=d+-1|0;if(!n){e=0;return e|0}d=a+4|0;g=a+8|0;m=c;l=n;n=f[a>>2]|0;while(1){if(!n){if((rHc(a)|0)==-1){e=0;o=21;break}k=f[a>>2]|0;if(!k){o=17;break}else p=k}else p=n;k=p>>>0>l>>>0?l:p;i=f[d>>2]|0;j=AJc(i,10,k)|0;h=(j|0)==0;q=h?k:1-i+j|0;o1c(m|0,i|0,q|0)|0;n=(f[a>>2]|0)-q|0;f[a>>2]=n;f[d>>2]=(f[d>>2]|0)+q;f[g>>2]=(f[g>>2]|0)+q;l=l-q|0;i=m+q|0;if(!(h&(l|0)!=0)){r=i;break}else m=i}if((o|0)==17){f[a+56>>2]=1;r=m}else if((o|0)==21)return e|0;if((r|0)==(c|0)){e=0;return e|0}b[r>>0]=0;e=c;return e|0}function vHc(a){a=a|0;var b=0,c=0,d=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=7247){b=-2;return b|0}if(f[a+24>>2]|0){GHc(a+84|0)|0;kIc(f[a+36>>2]|0);kIc(f[a+32>>2]|0)}c=(f[a+76>>2]|0)==-5?-5:0;pHc(a,0,0);kIc(f[a+20>>2]|0);d=LIc(f[a+16>>2]|0)|0;kIc(a);b=d|0?-1:c;return b|0}function wHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if(!c){d=0;return d|0}e=a+24|0;if((f[e>>2]|0)==0?(xHc(a)|0)==-1:0){d=0;return d|0}g=a+72|0;a:do if(f[g>>2]|0){f[g>>2]=0;h=f[a+68>>2]|0;i=a+84|0;j=a+88|0;if(f[j>>2]|0?(yHc(a,0)|0)==-1:0){d=0;return d|0}if(h|0){k=a+32|0;l=a+8|0;m=h;h=0;while(1){n=f[e>>2]|0;o=(n|0)<0|(n|0)>(m|0)?m:n;if(!h)g1c(f[k>>2]|0,0,o|0)|0;f[j>>2]=o;f[i>>2]=f[k>>2];f[l>>2]=(f[l>>2]|0)+o;m=m-o|0;if((yHc(a,0)|0)==-1){d=0;break}if(!m)break a;else h=1}return d|0}}while(0);g=a+88|0;if((f[e>>2]|0)>>>0<=c>>>0){if(!(f[g>>2]|0)){p=a+84|0;f[p>>2]=b;q=a+8|0;f[g>>2]=c;r=f[q>>2]|0;s=r+c|0;f[q>>2]=s;t=yHc(a,0)|0;u=(t|0)==-1;v=u?0:c;return v|0}if((yHc(a,0)|0)==-1){d=0;return d|0}else{p=a+84|0;f[p>>2]=b;q=a+8|0;f[g>>2]=c;r=f[q>>2]|0;s=r+c|0;f[q>>2]=s;t=yHc(a,0)|0;u=(t|0)==-1;v=u?0:c;return v|0}}v=a+32|0;u=a+84|0;t=a+8|0;s=b;b=c;while(1){q=f[g>>2]|0;r=f[v>>2]|0;if(!q){f[u>>2]=r;w=r}else w=f[u>>2]|0;p=w+q|0;q=r-p+(f[e>>2]|0)|0;r=q>>>0>b>>>0?b:q;o1c(p|0,s|0,r|0)|0;f[g>>2]=r+(f[g>>2]|0);f[t>>2]=r+(f[t>>2]|0);b=b-r|0;if(!b){d=c;x=23;break}if((yHc(a,0)|0)==-1){d=0;x=23;break}else s=s+r|0}if((x|0)==23)return d|0;return 0}function xHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+84|0;c=a+28|0;d=f[c>>2]|0;e=jIc(d<<1)|0;g=a+32|0;f[g>>2]=e;if(!e){pHc(a,-4,519111);h=-1;return h|0}i=a+40|0;if(f[i>>2]|0){f[a+24>>2]=d;h=0;return h|0}j=jIc(d)|0;d=a+36|0;f[d>>2]=j;if(!j){kIc(e);pHc(a,-4,519111);h=-1;return h|0}f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;if(PHc(b,f[a+60>>2]|0,8,31,8,f[a+64>>2]|0,519125,56)|0){kIc(f[d>>2]|0);kIc(f[g>>2]|0);pHc(a,-4,519111);h=-1;return h|0}f[b>>2]=0;b=f[c>>2]|0;c=f[i>>2]|0;f[a+24>>2]=b;if(c|0){h=0;return h|0}f[a+100>>2]=b;b=f[a+36>>2]|0;f[a+96>>2]=b;f[a+4>>2]=b;h=0;return h|0}function yHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+84|0;d=a+24|0;if((f[d>>2]|0)==0?(xHc(a)|0)==-1:0){e=-1;return e|0}if(f[a+40>>2]|0){g=a+88|0;h=f[g>>2]|0;if(!h){e=0;return e|0}i=a+16|0;j=h;h=f[c>>2]|0;while(1){k=iJc(f[i>>2]|0,h,j>>>0<1073741824?j:1073741824)|0;if((k|0)<0)break;j=(f[g>>2]|0)-k|0;f[g>>2]=j;h=(f[c>>2]|0)+k|0;f[c>>2]=h;if(!j){e=0;l=41;break}}if((l|0)==41)return e|0;j=vIc()|0;pHc(a,-1,HIc(f[j>>2]|0)|0);e=-1;return e|0}j=a+100|0;h=a+96|0;g=a+4|0;i=a+36|0;k=a+16|0;a:do switch(b|0){case 0:{m=f[j>>2]|0;while(1){do if(!m){n=f[h>>2]|0;o=f[g>>2]|0;if(n>>>0>o>>>0){p=n;n=o;do{o=p-n|0;q=iJc(f[k>>2]|0,n,(o|0)<1073741824?o:1073741824)|0;if((q|0)<0){l=31;break a}n=(f[g>>2]|0)+q|0;f[g>>2]=n;p=f[h>>2]|0}while(p>>>0>n>>>0);n=f[j>>2]|0;if(n|0){r=n;break}}n=f[d>>2]|0;f[j>>2]=n;p=f[i>>2]|0;f[h>>2]=p;f[g>>2]=p;r=n}else r=m;while(0);if((YHc(c,0)|0)==-2){l=37;break a}m=f[j>>2]|0;if((r|0)==(m|0)){l=39;break}}break}case 4:{m=0;n=f[j>>2]|0;while(1){if((n|0)==0|(m|0)==1){p=f[h>>2]|0;q=f[g>>2]|0;if(p>>>0>q>>>0){o=p;p=q;do{q=o-p|0;s=iJc(f[k>>2]|0,p,(q|0)<1073741824?q:1073741824)|0;if((s|0)<0){l=31;break a}p=(f[g>>2]|0)+s|0;f[g>>2]=p;o=f[h>>2]|0}while(o>>>0>p>>>0);t=f[j>>2]|0}else t=n;if(!t){p=f[d>>2]|0;f[j>>2]=p;o=f[i>>2]|0;f[h>>2]=o;f[g>>2]=o;u=p}else u=t}else u=n;m=YHc(c,4)|0;if((m|0)==-2){l=37;break a}n=f[j>>2]|0;if((u|0)==(n|0)){l=39;break}}break}default:while(1){n=f[h>>2]|0;m=f[g>>2]|0;if(n>>>0>m>>>0){p=n;n=m;do{m=p-n|0;o=iJc(f[k>>2]|0,n,(m|0)<1073741824?m:1073741824)|0;if((o|0)<0){l=31;break a}n=(f[g>>2]|0)+o|0;f[g>>2]=n;p=f[h>>2]|0}while(p>>>0>n>>>0)}n=f[j>>2]|0;if(!n){p=f[d>>2]|0;f[j>>2]=p;o=f[i>>2]|0;f[h>>2]=o;f[g>>2]=o;v=p}else v=n;if((YHc(c,b)|0)==-2){l=37;break a}if((v|0)==(f[j>>2]|0)){l=39;break}}}while(0);if((l|0)==31){j=vIc()|0;pHc(a,-1,HIc(f[j>>2]|0)|0);e=-1;return e|0}else if((l|0)==37){pHc(a,-2,519072);e=-1;return e|0}else if((l|0)==39){if((b|0)!=4){e=0;return e|0}XHc(c)|0;e=0;return e|0}return 0}function zHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!a){c=-1;return c|0}if((f[a+12>>2]|0)!=31153){c=-1;return c|0}if(f[a+76>>2]|0){c=-1;return c|0}d=dJc(b)|0;e=wHc(a,b,d)|0;c=(d|0)!=0&(e|0)==0?-1:e;return c|0}function AHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=31153){b=-2;return b|0}c=a+72|0;a:do if(!(f[c>>2]|0))d=0;else{f[c>>2]=0;e=f[a+68>>2]|0;g=a+88|0;if(!((f[g>>2]|0)!=0?(yHc(a,0)|0)==-1:0))h=6;b:do if((h|0)==6){if(!e){d=0;break a}i=a+24|0;j=a+32|0;k=a+84|0;l=a+8|0;m=e;n=0;while(1){o=f[i>>2]|0;p=(o|0)<0|(o|0)>(m|0)?m:o;if(!n)g1c(f[j>>2]|0,0,p|0)|0;f[g>>2]=p;f[k>>2]=f[j>>2];f[l>>2]=(f[l>>2]|0)+p;m=m-p|0;if((yHc(a,0)|0)==-1)break b;if(!m){d=0;break a}else n=1}}while(0);d=f[a+76>>2]|0}while(0);if((yHc(a,4)|0)==-1)q=f[a+76>>2]|0;else q=d;if(f[a+24>>2]|0){if(!(f[a+40>>2]|0)){QHc(a+84|0)|0;kIc(f[a+36>>2]|0)}kIc(f[a+32>>2]|0)}pHc(a,0,0);kIc(f[a+20>>2]|0);d=(LIc(f[a+16>>2]|0)|0)==-1;kIc(a);b=d?-1:q;return b|0}function BHc(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}if(!(f[a+36>>2]|0)){b=-2;return b|0}c=f[a+28>>2]|0;if(!c){b=-2;return b|0}if((f[c>>2]|0)!=(a|0)){b=-2;return b|0}d=c+4|0;if(((f[d>>2]|0)+-16180|0)>>>0>31){b=-2;return b|0}f[c+44>>2]=0;f[c+48>>2]=0;f[c+52>>2]=0;f[c+32>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;e=f[c+12>>2]|0;if(e|0)f[a+48>>2]=e&1;f[d>>2]=16180;f[c+8>>2]=0;f[c+16>>2]=0;f[c+24>>2]=32768;f[c+36>>2]=0;f[c+60>>2]=0;f[c+64>>2]=0;d=c+1332|0;f[c+112>>2]=d;f[c+84>>2]=d;f[c+80>>2]=d;f[c+7108>>2]=1;f[c+7112>>2]=-1;b=0;return b|0}function CHc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(!a){c=-2;return c|0}d=a+32|0;if(!(f[d>>2]|0)){c=-2;return c|0}e=a+36|0;g=f[e>>2]|0;if(!g){c=-2;return c|0}h=a+28|0;i=f[h>>2]|0;if(!i){c=-2;return c|0}if((f[i>>2]|0)!=(a|0)){c=-2;return c|0}if(((f[i+4>>2]|0)+-16180|0)>>>0>31){c=-2;return c|0}if((b|0)<0){j=0;k=0-b|0}else{j=(b>>>4)+5|0;k=(b|0)<48?b&15:b}if(!((k|0)==0|(k&-8|0)==8)){c=-2;return c|0}b=i+56|0;l=f[b>>2]|0;m=i+40|0;if((l|0)!=0?(f[m>>2]|0)!=(k|0):0){mi[g&2047](f[a+40>>2]|0,l);f[b>>2]=0;b=f[d>>2]|0;f[i+12>>2]=j;f[m>>2]=k;if(!b){c=-2;return c|0}}else{f[i+12>>2]=j;f[m>>2]=k}if(!(f[e>>2]|0)){c=-2;return c|0}e=f[h>>2]|0;if(!e){c=-2;return c|0}if((f[e>>2]|0)!=(a|0)){c=-2;return c|0}h=e+4|0;if(((f[h>>2]|0)+-16180|0)>>>0>31){c=-2;return c|0}f[e+44>>2]=0;f[e+48>>2]=0;f[e+52>>2]=0;f[e+32>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;k=f[e+12>>2]|0;if(k|0)f[a+48>>2]=k&1;f[h>>2]=16180;f[e+8>>2]=0;f[e+16>>2]=0;f[e+24>>2]=32768;f[e+36>>2]=0;f[e+60>>2]=0;f[e+64>>2]=0;h=e+1332|0;f[e+112>>2]=h;f[e+84>>2]=h;f[e+80>>2]=h;f[e+7108>>2]=1;f[e+7112>>2]=-1;c=0;return c|0}function DHc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;if(!d){g=-6;return g|0}if((e|0)!=56|(b[d>>0]|0)!=49){g=-6;return g|0}if(!a){g=-2;return g|0}f[a+24>>2]=0;d=a+32|0;e=f[d>>2]|0;if(!e){f[d>>2]=310;f[a+40>>2]=0;h=310}else h=e;e=a+36|0;if(!(f[e>>2]|0))f[e>>2]=1327;d=a+40|0;i=hj[h&511](f[d>>2]|0,1,7120)|0;if(!i){g=-4;return g|0}h=a+28|0;f[h>>2]=i;f[i>>2]=a;f[i+56>>2]=0;f[i+4>>2]=16180;j=CHc(a,c)|0;if(!j){g=0;return g|0}mi[f[e>>2]&2047](f[d>>2]|0,i);f[h>>2]=0;g=j;return g|0}function EHc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0;e=u;u=u+16|0;g=e;if(!a){i=-2;u=e;return i|0}if(!(f[a+32>>2]|0)){i=-2;u=e;return i|0}if(!(f[a+36>>2]|0)){i=-2;u=e;return i|0}k=f[a+28>>2]|0;if(!k){i=-2;u=e;return i|0}if((f[k>>2]|0)!=(a|0)){i=-2;u=e;return i|0}l=k+4|0;m=f[l>>2]|0;if((m+-16180|0)>>>0>31){i=-2;u=e;return i|0}n=a+12|0;o=f[n>>2]|0;if(!o){i=-2;u=e;return i|0}p=f[a>>2]|0;if((p|0)==0?f[a+4>>2]|0:0){i=-2;u=e;return i|0}if((m|0)==16191){f[l>>2]=16192;q=16192}else q=m;m=a+16|0;r=f[m>>2]|0;s=a+4|0;t=f[s>>2]|0;v=k+60|0;w=k+64|0;x=k+12|0;y=k+40|0;z=k+28|0;A=g+1|0;B=k+20|0;C=k+36|0;D=a+24|0;E=k+24|0;F=a+48|0;G=k+68|0;H=k+16|0;I=(c+-5|0)>>>0<2;J=k+8|0;K=k+80|0;L=k+88|0;M=k+84|0;N=k+92|0;O=(c|0)==6;P=k+7112|0;Q=k+76|0;R=k+7116|0;S=k+72|0;T=k+48|0;U=k+7108|0;V=k+52|0;W=k+56|0;X=k+44|0;Y=a+20|0;Z=k+32|0;_=g+2|0;$=g+3|0;aa=k+108|0;ba=k+100|0;ca=k+104|0;da=k+628|0;ea=k+1332|0;fa=k+112|0;ga=k+116|0;ha=k+756|0;ia=k+96|0;ja=0;ka=r;la=t;ma=p;p=r;r=f[w>>2]|0;na=f[v>>2]|0;oa=o;o=q;a:while(1){b:do switch(o|0){case 16208:{pa=r;qa=na;ra=la;sa=ma;ta=1;ua=ka;va=296;break a;break}case 16209:{wa=p;xa=r;ya=na;za=la;Aa=ma;Ba=-3;Ca=ka;break a;break}case 16210:{va=310;break a;break}case 16180:{q=f[x>>2]|0;if(!q){f[l>>2]=16192;Da=ja;Ea=ka;Fa=la;Ga=oa;Ha=ma;Ia=p;Ja=r;Ka=na;break b}if(r>>>0<16){La=la;Ma=ma;Na=r;Oa=na;while(1){if(!La){wa=p;xa=Na;ya=Oa;za=0;Aa=Ma;Ba=ja;Ca=ka;break a}Pa=La+-1|0;Qa=Ma+1|0;Ra=(h[Ma>>0]<<Na)+Oa|0;Sa=Na+8|0;if(Sa>>>0<16){La=Pa;Ma=Qa;Na=Sa;Oa=Ra}else{Ta=Pa;Ua=Qa;Va=Sa;Wa=Ra;break}}}else{Ta=la;Ua=ma;Va=r;Wa=na}if((Wa|0)==35615&(q&2|0)!=0){if(!(f[y>>2]|0))f[y>>2]=15;Oa=OHc(0,0,0)|0;f[z>>2]=Oa;b[g>>0]=31;b[A>>0]=-117;Na=OHc(Oa,g,2)|0;f[z>>2]=Na;f[l>>2]=16181;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=0;Ka=0;break b}f[B>>2]=0;Na=f[C>>2]|0;if(Na|0)f[Na+48>>2]=-1;if(q&1|0?((((Wa<<8&65280)+(Wa>>>8)|0)>>>0)%31|0|0)==0:0){if((Wa&15|0)!=8){f[D>>2]=519155;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va;Ka=Wa;break b}Na=Wa>>>4;Oa=Na&15;Ma=Oa+8|0;La=f[y>>2]|0;if(!La){f[y>>2]=Ma;Xa=Ma}else Xa=La;if(Ma>>>0>15|Ma>>>0>Xa>>>0){f[D>>2]=519182;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va+-4|0;Ka=Na;break b}else{f[E>>2]=256<<Oa;Oa=MHc(0,0,0)|0;f[z>>2]=Oa;f[F>>2]=Oa;f[l>>2]=Wa>>>12&2^16191;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=0;Ka=0;break b}}f[D>>2]=519132;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va;Ka=Wa;break}case 16181:{if(r>>>0<16){Oa=la;Na=ma;Ma=r;La=na;while(1){if(!Oa){wa=p;xa=Ma;ya=La;za=0;Aa=Na;Ba=ja;Ca=ka;break a}Ra=Oa+-1|0;Sa=Na+1|0;Qa=(h[Na>>0]<<Ma)+La|0;Pa=Ma+8|0;if(Pa>>>0<16){Oa=Ra;Na=Sa;Ma=Pa;La=Qa}else{Ya=Ra;Za=Sa;_a=Pa;$a=Qa;break}}}else{Ya=la;Za=ma;_a=r;$a=na}f[B>>2]=$a;if(($a&255|0)!=8){f[D>>2]=519155;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ya;Ga=oa;Ha=Za;Ia=p;Ja=_a;Ka=$a;break b}if($a&57344|0){f[D>>2]=519202;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ya;Ga=oa;Ha=Za;Ia=p;Ja=_a;Ka=$a;break b}La=f[C>>2]|0;if(La|0)f[La>>2]=$a>>>8&1;if($a&512|0?f[x>>2]&4|0:0){b[g>>0]=$a;b[A>>0]=$a>>>8;La=OHc(f[z>>2]|0,g,2)|0;f[z>>2]=La}f[l>>2]=16182;ab=Ya;bb=Za;cb=0;db=0;va=55;break}case 16182:{if(r>>>0<32){ab=la;bb=ma;cb=r;db=na;va=55}else{eb=la;fb=ma;gb=na;va=57}break}case 16183:{if(r>>>0<16){hb=la;ib=ma;jb=r;kb=na;va=64}else{lb=la;mb=ma;nb=na;va=66}break}case 16184:{ob=la;pb=ma;qb=r;rb=na;va=72;break}case 16185:{sb=la;tb=ma;ub=r;vb=na;va=84;break}case 16186:{wb=la;xb=ma;yb=r;zb=na;va=95;break}case 16187:{Ab=r;Bb=na;Cb=la;Db=ma;va=109;break}case 16188:{Eb=r;Fb=na;Gb=la;Hb=ma;va=123;break}case 16189:{if(r>>>0<32){La=r;Ma=na;Na=la;Oa=ma;while(1){if(!Na){wa=p;xa=La;ya=Ma;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}q=Na+-1|0;Qa=Oa+1|0;Pa=(h[Oa>>0]<<La)+Ma|0;La=La+8|0;if(La>>>0>=32){Ib=Pa;Jb=q;Kb=Qa;break}else{Ma=Pa;Na=q;Oa=Qa}}}else{Ib=na;Jb=la;Kb=ma}Oa=s1c(Ib|0)|0;f[z>>2]=Oa;f[F>>2]=Oa;f[l>>2]=16190;Lb=0;Mb=0;Nb=Jb;Ob=Kb;va=136;break}case 16190:{Lb=r;Mb=na;Nb=la;Ob=ma;va=136;break}case 16191:{Pb=r;Qb=na;Rb=la;Sb=ma;va=139;break}case 16192:{Tb=r;Ub=na;Vb=la;Wb=ma;va=140;break}case 16193:{Oa=r&7;Na=na>>>Oa;Ma=r-Oa|0;if(Ma>>>0<32){Oa=Ma;La=Na;Qa=la;q=ma;while(1){if(!Qa){wa=p;xa=Oa;ya=La;za=0;Aa=q;Ba=ja;Ca=ka;break a}Pa=Qa+-1|0;Sa=q+1|0;Ra=(h[q>>0]<<Oa)+La|0;Xb=Oa+8|0;if(Xb>>>0<32){Oa=Xb;La=Ra;Qa=Pa;q=Sa}else{Yb=Xb;Zb=Ra;_b=Pa;$b=Sa;break}}}else{Yb=Ma;Zb=Na;_b=la;$b=ma}q=Zb&65535;if((q|0)==(Zb>>>16^65535|0)){f[G>>2]=q;f[l>>2]=16194;if(O){pa=0;qa=0;ra=_b;sa=$b;ta=ja;ua=ka;va=296;break a}else{ac=0;bc=0;cc=_b;dc=$b;va=159;break b}}else{f[D>>2]=519266;f[l>>2]=16209;Da=ja;Ea=ka;Fa=_b;Ga=oa;Ha=$b;Ia=p;Ja=Yb;Ka=Zb;break b}break}case 16194:{ac=r;bc=na;cc=la;dc=ma;va=159;break}case 16195:{ec=r;fc=na;gc=la;hc=ma;va=160;break}case 16196:{if(r>>>0<14){q=r;Qa=na;La=la;Oa=ma;while(1){if(!La){wa=p;xa=q;ya=Qa;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}Sa=La+-1|0;Pa=Oa+1|0;Ra=(h[Oa>>0]<<q)+Qa|0;Xb=q+8|0;if(Xb>>>0<14){q=Xb;Qa=Ra;La=Sa;Oa=Pa}else{ic=Xb;jc=Ra;kc=Sa;lc=Pa;break}}}else{ic=r;jc=na;kc=la;lc=ma}Oa=(jc&31)+257|0;f[ba>>2]=Oa;La=(jc>>>5&31)+1|0;f[ca>>2]=La;Qa=(jc>>>10&15)+4|0;f[ia>>2]=Qa;q=jc>>>14;Na=ic+-14|0;if(Oa>>>0>286|La>>>0>30){f[D>>2]=519295;f[l>>2]=16209;Da=ja;Ea=ka;Fa=kc;Ga=oa;Ha=lc;Ia=p;Ja=Na;Ka=q;break b}else{f[aa>>2]=0;f[l>>2]=16197;mc=Na;nc=q;oc=kc;pc=lc;qc=Qa;rc=0;va=170;break b}break}case 16197:{Qa=f[aa>>2]|0;q=f[ia>>2]|0;if(Qa>>>0<q>>>0){mc=r;nc=na;oc=la;pc=ma;qc=q;rc=Qa;va=170}else{sc=r;tc=na;uc=la;vc=ma;wc=Qa;va=171}break}case 16198:{xc=ja;yc=r;zc=na;Ac=la;Bc=ma;Cc=f[aa>>2]|0;va=181;break}case 16199:{Dc=ja;Ec=r;Fc=na;Gc=la;Hc=ma;va=214;break}case 16200:{Ic=ja;Jc=r;Kc=na;Lc=la;Mc=ma;va=215;break}case 16201:{Nc=r;Oc=na;Pc=ja;Qc=la;Rc=ma;Sc=f[Q>>2]|0;va=233;break}case 16202:{Tc=r;Uc=na;Vc=la;Wc=ma;Xc=ja;va=240;break}case 16203:{Yc=r;Zc=na;_c=la;$c=ma;ad=ja;bd=f[Q>>2]|0;va=252;break}case 16204:{cd=r;dd=na;ed=la;fd=ma;gd=ja;va=258;break}case 16205:{if(!ka){pa=r;qa=na;ra=la;sa=ma;ta=ja;ua=0;va=296;break a}b[oa>>0]=f[G>>2];f[l>>2]=16200;Da=ja;Ea=ka+-1|0;Fa=la;Ga=oa+1|0;Ha=ma;Ia=p;Ja=r;Ka=na;break}case 16206:{Qa=f[x>>2]|0;if(Qa){if(r>>>0<32){q=na;Na=r;La=la;Oa=ma;while(1){if(!La){wa=p;xa=Na;ya=q;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}Ma=La+-1|0;Pa=Oa+1|0;Sa=(h[Oa>>0]<<Na)+q|0;Ra=Na+8|0;if(Ra>>>0<32){q=Sa;Na=Ra;La=Ma;Oa=Pa}else{hd=Ra;id=Sa;jd=Ma;kd=Pa;break}}}else{hd=r;id=na;jd=la;kd=ma}Oa=p-ka|0;f[Y>>2]=(f[Y>>2]|0)+Oa;f[Z>>2]=(f[Z>>2]|0)+Oa;if((Oa|0)!=0&(Qa&4|0)!=0){La=f[z>>2]|0;Na=oa+(0-Oa)|0;if(!(f[B>>2]|0))ld=MHc(La,Na,Oa)|0;else ld=OHc(La,Na,Oa)|0;f[z>>2]=ld;f[F>>2]=ld;md=f[x>>2]|0}else md=Qa;if((md&4|0)!=0?(Oa=(f[B>>2]|0)==0,Na=s1c(id|0)|0,((Oa?Na:id)|0)!=(f[z>>2]|0)):0){f[D>>2]=519469;f[l>>2]=16209;Da=ja;Ea=ka;Fa=jd;Ga=oa;Ha=kd;Ia=ka;Ja=hd;Ka=id;break b}else{nd=ka;od=0;pd=0;qd=jd;rd=kd;sd=md}}else{nd=p;od=r;pd=na;qd=la;rd=ma;sd=0}f[l>>2]=16207;td=nd;ud=od;vd=pd;wd=qd;xd=rd;yd=sd;va=288;break}case 16207:{td=p;ud=r;vd=na;wd=la;xd=ma;yd=f[x>>2]|0;va=288;break}default:{i=-2;va=311;break a}}while(0);if((va|0)==55)while(1){va=0;if(!ab){wa=p;xa=cb;ya=db;za=0;Aa=bb;Ba=ja;Ca=ka;break a}Na=ab+-1|0;Oa=bb+1|0;La=(h[bb>>0]<<cb)+db|0;cb=cb+8|0;if(cb>>>0>=32){eb=Na;fb=Oa;gb=La;va=57;break}else{ab=Na;bb=Oa;db=La;va=55}}else if((va|0)==136){va=0;if(!(f[H>>2]|0)){va=137;break}La=MHc(0,0,0)|0;f[z>>2]=La;f[F>>2]=La;f[l>>2]=16191;Pb=Lb;Qb=Mb;Rb=Nb;Sb=Ob;va=139}else if((va|0)==159){va=0;f[l>>2]=16195;ec=ac;fc=bc;gc=cc;hc=dc;va=160}else if((va|0)==170){va=0;La=mc;Oa=nc;Na=oc;q=pc;Pa=rc;while(1){if(La>>>0<3){if(!Na){wa=p;xa=La;ya=Oa;za=0;Aa=q;Ba=ja;Ca=ka;break a}zd=La+8|0;Ad=(h[q>>0]<<La)+Oa|0;Bd=Na+-1|0;Cd=q+1|0}else{zd=La;Ad=Oa;Bd=Na;Cd=q}Ma=Pa+1|0;f[aa>>2]=Ma;d[k+116+(j[194700+(Pa<<1)>>1]<<1)>>1]=Ad&7;Sa=Ad>>>3;Ra=zd+-3|0;if(Ma>>>0<qc>>>0){La=Ra;Oa=Sa;Na=Bd;q=Cd;Pa=Ma}else{sc=Ra;tc=Sa;uc=Bd;vc=Cd;wc=Ma;va=171;break}}}else if((va|0)==288){va=0;if(!yd){Dd=ud;Ed=vd;Fd=wd;Gd=xd;va=295;break}if(!(f[B>>2]|0)){Dd=ud;Ed=vd;Fd=wd;Gd=xd;va=295;break}if(ud>>>0<32){Pa=vd;q=ud;Na=xd;Oa=wd;while(1){if(!Oa){wa=td;xa=q;ya=Pa;za=0;Aa=Na;Ba=ja;Ca=ka;break a}La=Oa+-1|0;Ma=Na+1|0;Sa=(h[Na>>0]<<q)+Pa|0;Ra=q+8|0;if(Ra>>>0<32){Pa=Sa;q=Ra;Na=Ma;Oa=La}else{Hd=Ra;Id=Sa;Jd=La;Kd=Ma;break}}}else{Hd=ud;Id=vd;Jd=wd;Kd=xd}if((Id|0)==(f[Z>>2]|0)){Dd=0;Ed=0;Fd=Jd;Gd=Kd;va=295;break}f[D>>2]=519490;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Jd;Ga=oa;Ha=Kd;Ia=td;Ja=Hd;Ka=Id}do if((va|0)==57){va=0;Oa=f[C>>2]|0;if(Oa|0)f[Oa+4>>2]=gb;if(f[B>>2]&512|0?f[x>>2]&4|0:0){b[g>>0]=gb;b[A>>0]=gb>>>8;b[_>>0]=gb>>>16;b[$>>0]=gb>>>24;Oa=OHc(f[z>>2]|0,g,4)|0;f[z>>2]=Oa}f[l>>2]=16183;hb=eb;ib=fb;jb=0;kb=0;va=64}else if((va|0)==139){va=0;if(I){pa=Pb;qa=Qb;ra=Rb;sa=Sb;ta=ja;ua=ka;va=296;break a}else{Tb=Pb;Ub=Qb;Vb=Rb;Wb=Sb;va=140}}else if((va|0)==160){va=0;Oa=f[G>>2]|0;if(!Oa){f[l>>2]=16191;Da=ja;Ea=ka;Fa=gc;Ga=oa;Ha=hc;Ia=p;Ja=ec;Ka=fc;break}Na=Oa>>>0>gc>>>0?gc:Oa;Oa=Na>>>0>ka>>>0?ka:Na;if(!Oa){pa=ec;qa=fc;ra=gc;sa=hc;ta=ja;ua=ka;va=296;break a}o1c(oa|0,hc|0,Oa|0)|0;f[G>>2]=(f[G>>2]|0)-Oa;Da=ja;Ea=ka-Oa|0;Fa=gc-Oa|0;Ga=oa+Oa|0;Ha=hc+Oa|0;Ia=p;Ja=ec;Ka=fc}else if((va|0)==171){va=0;if(wc>>>0<19){Oa=wc;do{d[k+116+(j[194700+(Oa<<1)>>1]<<1)>>1]=0;Oa=Oa+1|0}while((Oa|0)!=19);f[aa>>2]=19}f[fa>>2]=ea;f[K>>2]=ea;f[L>>2]=7;Oa=HHc(0,ga,19,fa,L,ha)|0;if(!Oa){f[aa>>2]=0;f[l>>2]=16198;xc=0;yc=sc;zc=tc;Ac=uc;Bc=vc;Cc=0;va=181;break}else{f[D>>2]=519331;f[l>>2]=16209;Da=Oa;Ea=ka;Fa=uc;Ga=oa;Ha=vc;Ia=p;Ja=sc;Ka=tc;break}}while(0);c:do if((va|0)==64)while(1){va=0;if(!hb){wa=p;xa=jb;ya=kb;za=0;Aa=ib;Ba=ja;Ca=ka;break a}Oa=hb+-1|0;Qa=ib+1|0;Na=(h[ib>>0]<<jb)+kb|0;jb=jb+8|0;if(jb>>>0>=16){lb=Oa;mb=Qa;nb=Na;va=66;break}else{hb=Oa;ib=Qa;kb=Na;va=64}}else if((va|0)==140){va=0;if(f[J>>2]|0){Na=Tb&7;f[l>>2]=16206;Da=ja;Ea=ka;Fa=Vb;Ga=oa;Ha=Wb;Ia=p;Ja=Tb-Na|0;Ka=Ub>>>Na;break}if(Tb>>>0<3){if(!Vb){pa=Tb;qa=Ub;ra=0;sa=Wb;ta=ja;ua=ka;va=296;break a}Ld=Tb+8|0;Md=(h[Wb>>0]<<Tb)+Ub|0;Nd=Vb+-1|0;Od=Wb+1|0}else{Ld=Tb;Md=Ub;Nd=Vb;Od=Wb}f[J>>2]=Md&1;switch(Md>>>1&3){case 0:{Pd=16193;va=151;break}case 1:{f[K>>2]=192524;f[L>>2]=9;f[M>>2]=194572;f[N>>2]=5;f[l>>2]=16199;if(O){va=147;break a}break}case 2:{Pd=16196;va=151;break}case 3:{f[D>>2]=519247;Pd=16209;va=151;break}default:{va=150;break a}}if((va|0)==151){va=0;f[l>>2]=Pd}Da=ja;Ea=ka;Fa=Nd;Ga=oa;Ha=Od;Ia=p;Ja=Ld+-3|0;Ka=Md>>>3}else if((va|0)==181){va=0;Na=f[ba>>2]|0;Qa=f[ca>>2]|0;do if(Cc>>>0<(Qa+Na|0)>>>0){Oa=yc;q=zc;Pa=Ac;Ma=Bc;La=Cc;Sa=Na;Ra=Qa;d:while(1){Xb=f[K>>2]|0;Qd=(1<<f[L>>2])+-1|0;Rd=Qd&q;Sd=h[Xb+(Rd<<2)+1>>0]|0;if(Oa>>>0<Sd>>>0){Td=Oa;Ud=q;Vd=Pa;Wd=Ma;while(1){if(!Vd){wa=p;xa=Td;ya=Ud;za=0;Aa=Wd;Ba=xc;Ca=ka;break a}Xd=Vd+-1|0;Yd=Wd+1|0;Zd=(h[Wd>>0]<<Td)+Ud|0;_d=Td+8|0;$d=Qd&Zd;ae=h[Xb+($d<<2)+1>>0]|0;if(_d>>>0<ae>>>0){Td=_d;Ud=Zd;Vd=Xd;Wd=Yd}else{be=_d;ce=Zd;de=Xd;ee=Yd;fe=ae;ge=$d;break}}}else{be=Oa;ce=q;de=Pa;ee=Ma;fe=Sd;ge=Rd}Wd=d[Xb+(ge<<2)+2>>1]|0;if((Wd&65535)>=16){switch(Wd<<16>>16){case 16:{Vd=fe+2|0;if(be>>>0<Vd>>>0){Ud=be;Td=ce;Qd=de;$d=ee;while(1){if(!Qd){wa=p;xa=Ud;ya=Td;za=0;Aa=$d;Ba=xc;Ca=ka;break a}ae=Qd+-1|0;Yd=$d+1|0;Xd=(h[$d>>0]<<Ud)+Td|0;Zd=Ud+8|0;if(Zd>>>0<Vd>>>0){Ud=Zd;Td=Xd;Qd=ae;$d=Yd}else{he=Zd;ie=Xd;je=ae;ke=Yd;break}}}else{he=be;ie=ce;je=de;ke=ee}$d=ie>>>fe;Qd=he-fe|0;if(!La){le=Qd;me=$d;ne=je;oe=ke;va=205;break d}pe=j[k+116+(La+-1<<1)>>1]|0;qe=Qd+-2|0;re=$d>>>2;se=je;te=ke;ue=($d&3)+3|0;break}case 17:{$d=fe+3|0;if(be>>>0<$d>>>0){Qd=be;Td=ce;Ud=de;Vd=ee;while(1){if(!Ud){wa=p;xa=Qd;ya=Td;za=0;Aa=Vd;Ba=xc;Ca=ka;break a}Xb=Ud+-1|0;Rd=Vd+1|0;Sd=(h[Vd>>0]<<Qd)+Td|0;Yd=Qd+8|0;if(Yd>>>0<$d>>>0){Qd=Yd;Td=Sd;Ud=Xb;Vd=Rd}else{ve=Yd;we=Sd;xe=Xb;ye=Rd;break}}}else{ve=be;we=ce;xe=de;ye=ee}Vd=we>>>fe;pe=0;qe=-3-fe+ve|0;re=Vd>>>3;se=xe;te=ye;ue=(Vd&7)+3|0;break}default:{Vd=fe+7|0;if(be>>>0<Vd>>>0){Ud=be;Td=ce;Qd=de;$d=ee;while(1){if(!Qd){wa=p;xa=Ud;ya=Td;za=0;Aa=$d;Ba=xc;Ca=ka;break a}Rd=Qd+-1|0;Xb=$d+1|0;Sd=(h[$d>>0]<<Ud)+Td|0;Yd=Ud+8|0;if(Yd>>>0<Vd>>>0){Ud=Yd;Td=Sd;Qd=Rd;$d=Xb}else{ze=Yd;Ae=Sd;Be=Rd;Ce=Xb;break}}}else{ze=be;Ae=ce;Be=de;Ce=ee}$d=Ae>>>fe;pe=0;qe=-7-fe+ze|0;re=$d>>>7;se=Be;te=Ce;ue=($d&127)+11|0}}if((La+ue|0)>>>0>(Ra+Sa|0)>>>0){le=qe;me=re;ne=se;oe=te;va=205;break}$d=pe&65535;Qd=ue+-1|0;f[aa>>2]=La+1;d[k+116+(La<<1)>>1]=$d;if(!Qd){De=qe;Ee=re;Fe=se;Ge=te}else{Td=Qd;do{Qd=f[aa>>2]|0;Td=Td+-1|0;f[aa>>2]=Qd+1;d[k+116+(Qd<<1)>>1]=$d}while((Td|0)!=0);De=qe;Ee=re;Fe=se;Ge=te}}else{f[aa>>2]=La+1;d[k+116+(La<<1)>>1]=Wd;De=be-fe|0;Ee=ce>>>fe;Fe=de;Ge=ee}La=f[aa>>2]|0;Sa=f[ba>>2]|0;Ra=f[ca>>2]|0;if(La>>>0>=(Ra+Sa|0)>>>0){va=206;break}else{Oa=De;q=Ee;Pa=Fe;Ma=Ge}}if((va|0)==205){va=0;f[D>>2]=519356;f[l>>2]=16209;Da=xc;Ea=ka;Fa=ne;Ga=oa;Ha=oe;Ia=p;Ja=le;Ka=me;break c}else if((va|0)==206){va=0;if((f[l>>2]|0)==16209){Da=xc;Ea=ka;Fa=Fe;Ga=oa;Ha=Ge;Ia=p;Ja=De;Ka=Ee;break c}else{He=De;Ie=Ee;Je=Fe;Ke=Ge;Le=Sa;break}}}else{He=yc;Ie=zc;Je=Ac;Ke=Bc;Le=Na}while(0);if(!(d[da>>1]|0)){f[D>>2]=519382;f[l>>2]=16209;Da=xc;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}f[fa>>2]=ea;f[K>>2]=ea;f[L>>2]=9;Na=HHc(1,ga,Le,fa,L,ha)|0;if(Na|0){f[D>>2]=519419;f[l>>2]=16209;Da=Na;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}f[M>>2]=f[fa>>2];f[N>>2]=6;Na=HHc(2,k+116+(f[ba>>2]<<1)|0,f[ca>>2]|0,fa,N,ha)|0;if(!Na){f[l>>2]=16199;if(O){pa=He;qa=Ie;ra=Je;sa=Ke;ta=0;ua=ka;va=296;break a}else{Dc=0;Ec=He;Fc=Ie;Gc=Je;Hc=Ke;va=214;break}}else{f[D>>2]=519447;f[l>>2]=16209;Da=Na;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}}while(0);if((va|0)==66){va=0;Na=f[C>>2]|0;if(Na|0){f[Na+8>>2]=nb&255;f[Na+12>>2]=nb>>>8}if(f[B>>2]&512|0?f[x>>2]&4|0:0){b[g>>0]=nb;b[A>>0]=nb>>>8;Na=OHc(f[z>>2]|0,g,2)|0;f[z>>2]=Na}f[l>>2]=16184;ob=lb;pb=mb;qb=0;rb=0;va=72}else if((va|0)==214){va=0;f[l>>2]=16200;Ic=Dc;Jc=Ec;Kc=Fc;Lc=Gc;Mc=Hc;va=215}do if((va|0)==72){va=0;Na=f[B>>2]|0;if(!(Na&1024)){Qa=f[C>>2]|0;if(!Qa){Me=ob;Ne=pb;Oe=qb;Pe=rb}else{f[Qa+16>>2]=0;Me=ob;Ne=pb;Oe=qb;Pe=rb}}else{if(qb>>>0<16){Qa=ob;Ma=pb;Pa=qb;q=rb;while(1){if(!Qa){wa=p;xa=Pa;ya=q;za=0;Aa=Ma;Ba=ja;Ca=ka;break a}Oa=Qa+-1|0;Ra=Ma+1|0;La=(h[Ma>>0]<<Pa)+q|0;Pa=Pa+8|0;if(Pa>>>0>=16){Qe=Oa;Re=Ra;Se=La;break}else{Qa=Oa;Ma=Ra;q=La}}}else{Qe=ob;Re=pb;Se=rb}f[G>>2]=Se;q=f[C>>2]|0;if(q|0)f[q+20>>2]=Se;if((Na&512|0)!=0?(f[x>>2]&4|0)!=0:0){b[g>>0]=Se;b[A>>0]=Se>>>8;q=OHc(f[z>>2]|0,g,2)|0;f[z>>2]=q;Me=Qe;Ne=Re;Oe=0;Pe=0}else{Me=Qe;Ne=Re;Oe=0;Pe=0}}f[l>>2]=16185;sb=Me;tb=Ne;ub=Oe;vb=Pe;va=84}else if((va|0)==215){va=0;if(ka>>>0>257&Lc>>>0>5){f[n>>2]=oa;f[m>>2]=ka;f[a>>2]=Mc;f[s>>2]=Lc;f[v>>2]=Kc;f[w>>2]=Jc;IHc(a,p);q=f[n>>2]|0;Ma=f[m>>2]|0;Qa=f[a>>2]|0;Pa=f[s>>2]|0;La=f[v>>2]|0;Ra=f[w>>2]|0;if((f[l>>2]|0)!=16191){Da=Ic;Ea=Ma;Fa=Pa;Ga=q;Ha=Qa;Ia=p;Ja=Ra;Ka=La;break}f[P>>2]=-1;Da=Ic;Ea=Ma;Fa=Pa;Ga=q;Ha=Qa;Ia=p;Ja=Ra;Ka=La;break}f[P>>2]=0;La=f[K>>2]|0;Ra=(1<<f[L>>2])+-1|0;Qa=Ra&Kc;q=b[La+(Qa<<2)+1>>0]|0;Pa=q&255;if(Pa>>>0>Jc>>>0){Ma=Jc;Oa=Kc;Td=Lc;$d=Mc;while(1){if(!Td){wa=p;xa=Ma;ya=Oa;za=0;Aa=$d;Ba=Ic;Ca=ka;break a}Qd=Td+-1|0;Ud=$d+1|0;Vd=(h[$d>>0]<<Ma)+Oa|0;Xb=Ma+8|0;Rd=Ra&Vd;Sd=b[La+(Rd<<2)+1>>0]|0;Yd=Sd&255;if(Yd>>>0>Xb>>>0){Ma=Xb;Oa=Vd;Td=Qd;$d=Ud}else{Te=Xb;Ue=Vd;Ve=Qd;We=Ud;Xe=Yd;Ye=Rd;Ze=Sd;break}}}else{Te=Jc;Ue=Kc;Ve=Lc;We=Mc;Xe=Pa;Ye=Qa;Ze=q}$d=d[La+(Ye<<2)+2>>1]|0;Td=b[La+(Ye<<2)>>0]|0;Oa=Td&255;if(Td<<24>>24!=0&(Oa&240|0)==0){Ma=$d&65535;Ra=(1<<Xe+Oa)+-1|0;Oa=((Ue&Ra)>>>Xe)+Ma|0;Na=b[La+(Oa<<2)+1>>0]|0;if(((Na&255)+Xe|0)>>>0>Te>>>0){Sd=Te;Rd=Ue;Yd=Ve;Ud=We;while(1){if(!Yd){wa=p;xa=Sd;ya=Rd;za=0;Aa=Ud;Ba=Ic;Ca=ka;break a}Qd=Yd+-1|0;Vd=Ud+1|0;Xb=(h[Ud>>0]<<Sd)+Rd|0;ae=Sd+8|0;Xd=((Xb&Ra)>>>Xe)+Ma|0;Zd=b[La+(Xd<<2)+1>>0]|0;if(((Zd&255)+Xe|0)>>>0>ae>>>0){Sd=ae;Rd=Xb;Yd=Qd;Ud=Vd}else{_e=ae;$e=Xb;af=Qd;bf=Vd;cf=Xd;df=Zd;break}}}else{_e=Te;$e=Ue;af=Ve;bf=We;cf=Oa;df=Na}Ud=d[La+(cf<<2)+2>>1]|0;Yd=b[La+(cf<<2)>>0]|0;f[P>>2]=Xe;ef=_e-Xe|0;ff=$e>>>Xe;gf=af;hf=bf;jf=Yd;kf=df;lf=Ud;mf=Xe}else{ef=Te;ff=Ue;gf=Ve;hf=We;jf=Td;kf=Ze;lf=$d;mf=0}Ud=kf&255;Yd=ff>>>Ud;Rd=ef-Ud|0;f[P>>2]=mf+Ud;f[G>>2]=lf&65535;Ud=jf&255;if(!(jf<<24>>24)){f[l>>2]=16205;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}if(Ud&32|0){f[P>>2]=-1;f[l>>2]=16191;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}if(!(Ud&64)){Sd=Ud&15;f[Q>>2]=Sd;f[l>>2]=16201;Nc=Rd;Oc=Yd;Pc=Ic;Qc=gf;Rc=hf;Sc=Sd;va=233;break}else{f[D>>2]=519513;f[l>>2]=16209;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}}while(0);if((va|0)==84){va=0;Yd=f[B>>2]|0;if(Yd&1024){Rd=f[G>>2]|0;Sd=Rd>>>0>sb>>>0?sb:Rd;if(!Sd){nf=sb;of=tb;pf=Rd}else{Ud=f[C>>2]|0;if((Ud|0)!=0?(Ma=f[Ud+16>>2]|0,(Ma|0)!=0):0){Ra=(f[Ud+20>>2]|0)-Rd|0;Rd=f[Ud+24>>2]|0;o1c(Ma+Ra|0,tb|0,((Ra+Sd|0)>>>0>Rd>>>0?Rd-Ra|0:Sd)|0)|0;qf=f[B>>2]|0}else qf=Yd;if(qf&512|0?f[x>>2]&4|0:0){Yd=OHc(f[z>>2]|0,tb,Sd)|0;f[z>>2]=Yd}Yd=(f[G>>2]|0)-Sd|0;f[G>>2]=Yd;nf=sb-Sd|0;of=tb+Sd|0;pf=Yd}if(!pf){rf=nf;sf=of}else{pa=ub;qa=vb;ra=nf;sa=of;ta=ja;ua=ka;va=296;break}}else{rf=sb;sf=tb}f[G>>2]=0;f[l>>2]=16186;wb=rf;xb=sf;yb=ub;zb=vb;va=95}else if((va|0)==233){va=0;if(!Sc){tf=Nc;uf=Oc;vf=Qc;wf=Rc;xf=f[G>>2]|0}else{if(Nc>>>0<Sc>>>0){Yd=Nc;Sd=Oc;Ra=Qc;Rd=Rc;while(1){if(!Ra){wa=p;xa=Yd;ya=Sd;za=0;Aa=Rd;Ba=Pc;Ca=ka;break a}Ma=Ra+-1|0;Ud=Rd+1|0;q=(h[Rd>>0]<<Yd)+Sd|0;Qa=Yd+8|0;if(Qa>>>0<Sc>>>0){Yd=Qa;Sd=q;Ra=Ma;Rd=Ud}else{yf=Qa;zf=q;Af=Ma;Bf=Ud;break}}}else{yf=Nc;zf=Oc;Af=Qc;Bf=Rc}Rd=(f[G>>2]|0)+(zf&(1<<Sc)+-1)|0;f[G>>2]=Rd;f[P>>2]=(f[P>>2]|0)+Sc;tf=yf-Sc|0;uf=zf>>>Sc;vf=Af;wf=Bf;xf=Rd}f[R>>2]=xf;f[l>>2]=16202;Tc=tf;Uc=uf;Vc=vf;Wc=wf;Xc=Pc;va=240}do if((va|0)==95){va=0;if(!(f[B>>2]&2048)){Rd=f[C>>2]|0;if(!Rd){Cf=wb;Df=xb}else{f[Rd+28>>2]=0;Cf=wb;Df=xb}}else{if(!wb){pa=yb;qa=zb;ra=0;sa=xb;ta=ja;ua=ka;va=296;break a}else Ef=0;do{Rd=Ef;Ef=Ef+1|0;Ra=b[xb+Rd>>0]|0;Rd=f[C>>2]|0;if((Rd|0?(Sd=f[Rd+28>>2]|0,Sd|0):0)?(Yd=f[G>>2]|0,Yd>>>0<(f[Rd+32>>2]|0)>>>0):0){f[G>>2]=Yd+1;b[Sd+Yd>>0]=Ra}Ff=Ra<<24>>24!=0}while(Ff&wb>>>0>Ef>>>0);if(f[B>>2]&512|0?f[x>>2]&4|0:0){$d=OHc(f[z>>2]|0,xb,Ef)|0;f[z>>2]=$d}$d=wb-Ef|0;Td=xb+Ef|0;if(Ff){pa=yb;qa=zb;ra=$d;sa=Td;ta=ja;ua=ka;va=296;break a}else{Cf=$d;Df=Td}}f[G>>2]=0;f[l>>2]=16187;Ab=yb;Bb=zb;Cb=Cf;Db=Df;va=109}else if((va|0)==240){va=0;Td=f[M>>2]|0;$d=(1<<f[N>>2])+-1|0;La=$d&Uc;Na=b[Td+(La<<2)+1>>0]|0;Oa=Na&255;if(Oa>>>0>Tc>>>0){Ra=Tc;Yd=Uc;Sd=Vc;Rd=Wc;while(1){if(!Sd){wa=p;xa=Ra;ya=Yd;za=0;Aa=Rd;Ba=Xc;Ca=ka;break a}Ud=Sd+-1|0;Ma=Rd+1|0;q=(h[Rd>>0]<<Ra)+Yd|0;Qa=Ra+8|0;Pa=$d&q;Zd=b[Td+(Pa<<2)+1>>0]|0;Xd=Zd&255;if(Xd>>>0>Qa>>>0){Ra=Qa;Yd=q;Sd=Ud;Rd=Ma}else{Gf=Qa;Hf=q;If=Ud;Jf=Ma;Kf=Xd;Lf=Pa;Mf=Zd;break}}}else{Gf=Tc;Hf=Uc;If=Vc;Jf=Wc;Kf=Oa;Lf=La;Mf=Na}Rd=d[Td+(Lf<<2)+2>>1]|0;Sd=b[Td+(Lf<<2)>>0]|0;Yd=Sd&255;if(!(Yd&240)){Ra=Rd&65535;$d=(1<<Kf+Yd)+-1|0;Yd=((Hf&$d)>>>Kf)+Ra|0;Zd=b[Td+(Yd<<2)+1>>0]|0;if(((Zd&255)+Kf|0)>>>0>Gf>>>0){Pa=Gf;Xd=Hf;Ma=If;Ud=Jf;while(1){if(!Ma){wa=p;xa=Pa;ya=Xd;za=0;Aa=Ud;Ba=Xc;Ca=ka;break a}q=Ma+-1|0;Qa=Ud+1|0;Vd=(h[Ud>>0]<<Pa)+Xd|0;Qd=Pa+8|0;Xb=((Vd&$d)>>>Kf)+Ra|0;ae=b[Td+(Xb<<2)+1>>0]|0;if(((ae&255)+Kf|0)>>>0>Qd>>>0){Pa=Qd;Xd=Vd;Ma=q;Ud=Qa}else{Nf=Qd;Of=Vd;Pf=q;Qf=Qa;Rf=Xb;Sf=ae;break}}}else{Nf=Gf;Of=Hf;Pf=If;Qf=Jf;Rf=Yd;Sf=Zd}Ud=d[Td+(Rf<<2)+2>>1]|0;Ma=b[Td+(Rf<<2)>>0]|0;Xd=(f[P>>2]|0)+Kf|0;f[P>>2]=Xd;Tf=Nf-Kf|0;Uf=Of>>>Kf;Vf=Pf;Wf=Qf;Xf=Ma;Yf=Sf;Zf=Ud;_f=Xd}else{Tf=Gf;Uf=Hf;Vf=If;Wf=Jf;Xf=Sd;Yf=Mf;Zf=Rd;_f=f[P>>2]|0}Xd=Yf&255;Ud=Uf>>>Xd;Ma=Tf-Xd|0;f[P>>2]=_f+Xd;Xd=Xf&255;if(!(Xd&64)){f[S>>2]=Zf&65535;Pa=Xd&15;f[Q>>2]=Pa;f[l>>2]=16203;Yc=Ma;Zc=Ud;_c=Vf;$c=Wf;ad=Xc;bd=Pa;va=252;break}else{f[D>>2]=519541;f[l>>2]=16209;Da=Xc;Ea=ka;Fa=Vf;Ga=oa;Ha=Wf;Ia=p;Ja=Ma;Ka=Ud;break}}while(0);if((va|0)==109){va=0;if(!(f[B>>2]&4096)){Ud=f[C>>2]|0;if(!Ud){$f=Cb;ag=Db}else{f[Ud+36>>2]=0;$f=Cb;ag=Db}}else{if(!Cb){pa=Ab;qa=Bb;ra=0;sa=Db;ta=ja;ua=ka;va=296;break}else bg=0;do{Ud=bg;bg=bg+1|0;Ma=b[Db+Ud>>0]|0;Ud=f[C>>2]|0;if((Ud|0?(Pa=f[Ud+36>>2]|0,Pa|0):0)?(Xd=f[G>>2]|0,Xd>>>0<(f[Ud+40>>2]|0)>>>0):0){f[G>>2]=Xd+1;b[Pa+Xd>>0]=Ma}cg=Ma<<24>>24!=0}while(cg&Cb>>>0>bg>>>0);if(f[B>>2]&512|0?f[x>>2]&4|0:0){Ma=OHc(f[z>>2]|0,Db,bg)|0;f[z>>2]=Ma}Ma=Cb-bg|0;Xd=Db+bg|0;if(cg){pa=Ab;qa=Bb;ra=Ma;sa=Xd;ta=ja;ua=ka;va=296;break}else{$f=Ma;ag=Xd}}f[l>>2]=16188;Eb=Ab;Fb=Bb;Gb=$f;Hb=ag;va=123}else if((va|0)==252){va=0;if(!bd){dg=Yc;eg=Zc;fg=_c;gg=$c}else{if(Yc>>>0<bd>>>0){Xd=Yc;Ma=Zc;Pa=_c;Ud=$c;while(1){if(!Pa){wa=p;xa=Xd;ya=Ma;za=0;Aa=Ud;Ba=ad;Ca=ka;break a}Ra=Pa+-1|0;$d=Ud+1|0;Na=(h[Ud>>0]<<Xd)+Ma|0;La=Xd+8|0;if(La>>>0<bd>>>0){Xd=La;Ma=Na;Pa=Ra;Ud=$d}else{hg=La;ig=Na;jg=Ra;kg=$d;break}}}else{hg=Yc;ig=Zc;jg=_c;kg=$c}f[S>>2]=(f[S>>2]|0)+(ig&(1<<bd)+-1);f[P>>2]=(f[P>>2]|0)+bd;dg=hg-bd|0;eg=ig>>>bd;fg=jg;gg=kg}f[l>>2]=16204;cd=dg;dd=eg;ed=fg;fd=gg;gd=ad;va=258}do if((va|0)==123){va=0;Ud=f[B>>2]|0;if(Ud&512){if(Eb>>>0<16){Pa=Eb;Ma=Fb;Xd=Gb;$d=Hb;while(1){if(!Xd){wa=p;xa=Pa;ya=Ma;za=0;Aa=$d;Ba=ja;Ca=ka;break a}Ra=Xd+-1|0;Na=$d+1|0;La=(h[$d>>0]<<Pa)+Ma|0;Oa=Pa+8|0;if(Oa>>>0<16){Pa=Oa;Ma=La;Xd=Ra;$d=Na}else{lg=Oa;mg=La;ng=Ra;og=Na;break}}}else{lg=Eb;mg=Fb;ng=Gb;og=Hb}if((f[x>>2]&4|0)!=0?(mg|0)!=(f[z>>2]&65535|0):0){f[D>>2]=519227;f[l>>2]=16209;Da=ja;Ea=ka;Fa=ng;Ga=oa;Ha=og;Ia=p;Ja=lg;Ka=mg;break}else{pg=0;qg=0;rg=ng;sg=og}}else{pg=Eb;qg=Fb;rg=Gb;sg=Hb}$d=f[C>>2]|0;if($d|0){f[$d+44>>2]=Ud>>>9&1;f[$d+48>>2]=1}$d=OHc(0,0,0)|0;f[z>>2]=$d;f[F>>2]=$d;f[l>>2]=16191;Da=ja;Ea=ka;Fa=rg;Ga=oa;Ha=sg;Ia=p;Ja=pg;Ka=qg}else if((va|0)==258){va=0;if(!ka){pa=cd;qa=dd;ra=ed;sa=fd;ta=gd;ua=0;va=296;break a}$d=p-ka|0;Xd=f[S>>2]|0;if(Xd>>>0>$d>>>0){Ma=Xd-$d|0;if(Ma>>>0>(f[T>>2]|0)>>>0?f[U>>2]|0:0){f[D>>2]=519563;f[l>>2]=16209;Da=gd;Ea=ka;Fa=ed;Ga=oa;Ha=fd;Ia=p;Ja=cd;Ka=dd;break}$d=f[V>>2]|0;if(Ma>>>0>$d>>>0){Pa=Ma-$d|0;tg=Pa;ug=(f[X>>2]|0)-Pa|0}else{tg=Ma;ug=$d-Ma|0}Ma=f[G>>2]|0;vg=(f[W>>2]|0)+ug|0;wg=tg>>>0>Ma>>>0?Ma:tg;xg=Ma}else{Ma=f[G>>2]|0;vg=oa+(0-Xd)|0;wg=Ma;xg=Ma}Ma=wg>>>0>ka>>>0?ka:wg;f[G>>2]=xg-Ma;Xd=Ma+1|0;$d=Ma;Pa=oa;Rd=vg;while(1){b[Pa>>0]=b[Rd>>0]|0;$d=$d+-1|0;if(!$d)break;else{Pa=Pa+1|0;Rd=Rd+1|0}}Rd=ka-Ma|0;Pa=oa+-1+Xd|0;if(!(f[G>>2]|0)){f[l>>2]=16200;Da=gd;Ea=Rd;Fa=ed;Ga=Pa;Ha=fd;Ia=p;Ja=cd;Ka=dd}else{Da=gd;Ea=Rd;Fa=ed;Ga=Pa;Ha=fd;Ia=p;Ja=cd;Ka=dd}}while(0);ja=Da;ka=Ea;la=Fa;ma=Ha;p=Ia;r=Ja;na=Ka;oa=Ga;o=f[l>>2]|0}if((va|0)==137){f[n>>2]=oa;f[m>>2]=ka;f[a>>2]=Ob;f[s>>2]=Nb;f[v>>2]=Mb;f[w>>2]=Lb;i=2;u=e;return i|0}else if((va|0)==147){wa=p;xa=Ld+-3|0;ya=Md>>>3;za=Nd;Aa=Od;Ba=ja;Ca=ka}else if((va|0)!=150)if((va|0)==295){f[l>>2]=16208;wa=td;xa=Dd;ya=Ed;za=Fd;Aa=Gd;Ba=1;Ca=ka}else if((va|0)==296){wa=p;xa=pa;ya=qa;za=ra;Aa=sa;Ba=ta;Ca=ua}else if((va|0)==310){i=-4;u=e;return i|0}else if((va|0)==311){u=e;return i|0}f[n>>2]=oa;f[m>>2]=Ca;f[a>>2]=Aa;f[s>>2]=za;f[v>>2]=ya;f[w>>2]=xa;if(!(f[X>>2]|0))if(((wa|0)!=(Ca|0)?(X=f[l>>2]|0,X>>>0<16209):0)?(c|0)!=4|X>>>0<16206:0)va=301;else{yg=za;zg=Ca}else va=301;do if((va|0)==301){if(!(FHc(a,oa,wa-Ca|0)|0)){yg=f[s>>2]|0;zg=f[m>>2]|0;break}f[l>>2]=16210;i=-4;u=e;return i|0}while(0);m=t-yg|0;yg=wa-zg|0;zg=a+8|0;f[zg>>2]=(f[zg>>2]|0)+m;f[Y>>2]=(f[Y>>2]|0)+yg;f[Z>>2]=(f[Z>>2]|0)+yg;if((yg|0)!=0&(f[x>>2]&4|0)!=0){x=f[z>>2]|0;Z=(f[n>>2]|0)+(0-yg)|0;if(!(f[B>>2]|0))Ag=MHc(x,Z,yg)|0;else Ag=OHc(x,Z,yg)|0;f[z>>2]=Ag;f[F>>2]=Ag}Ag=f[l>>2]|0;f[a+44>>2]=(f[J>>2]|0?64:0)+(f[w>>2]|0)+((Ag|0)==16191?128:0)+((Ag|0)==16199|(Ag|0)==16194?256:0);i=(Ba|0)==0&((c|0)==4|(yg|m|0)==0)?-5:Ba;u=e;return i|0}function FHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[a+28>>2]|0;e=d+56|0;g=f[e>>2]|0;if(!g){h=hj[f[a+32>>2]&511](f[a+40>>2]|0,1<<f[d+40>>2],1)|0;f[e>>2]=h;if(!h){i=1;return i|0}else j=h}else j=g;g=d+44|0;h=f[g>>2]|0;if(!h){a=1<<f[d+40>>2];f[g>>2]=a;f[d+52>>2]=0;f[d+48>>2]=0;k=a}else k=h;if(k>>>0<=c>>>0){o1c(j|0,b+(0-k)|0,k|0)|0;f[d+52>>2]=0;f[d+48>>2]=f[g>>2];i=0;return i|0}h=d+52|0;a=f[h>>2]|0;l=k-a|0;k=l>>>0>c>>>0?c:l;o1c(j+a|0,b+(0-c)|0,k|0)|0;a=c-k|0;if(a|0){o1c(f[e>>2]|0,b+(0-a)|0,a|0)|0;f[h>>2]=a;f[d+48>>2]=f[g>>2];i=0;return i|0}a=(f[h>>2]|0)+k|0;b=f[g>>2]|0;f[h>>2]=(a|0)==(b|0)?0:a;a=d+48|0;d=f[a>>2]|0;if(d>>>0>=b>>>0){i=0;return i|0}f[a>>2]=d+k;i=0;return i|0}function GHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}c=a+36|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=a+28|0;g=f[e>>2]|0;if(!g){b=-2;return b|0}if((f[g>>2]|0)!=(a|0)){b=-2;return b|0}if(((f[g+4>>2]|0)+-16180|0)>>>0>31){b=-2;return b|0}h=f[g+56>>2]|0;i=a+40|0;if(!h){j=d;k=g}else{mi[d&2047](f[i>>2]|0,h);j=f[c>>2]|0;k=f[e>>2]|0}mi[j&2047](f[i>>2]|0,k);f[e>>2]=0;b=0;return b|0}function HHc(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=u;u=u+64|0;l=k+32|0;m=k;n=l;o=n+32|0;do{d[n>>1]=0;n=n+2|0}while((n|0)<(o|0));n=(e|0)==0;if(!n){o=0;do{p=l+(j[c+(o<<1)>>1]<<1)|0;d[p>>1]=(d[p>>1]|0)+1<<16>>16;o=o+1|0}while((o|0)!=(e|0));o=d[l+30>>1]|0;p=f[h>>2]|0;if(!(o<<16>>16)){q=p;r=5}else{s=15;t=p;v=o;r=7}}else{q=f[h>>2]|0;r=5}do if((r|0)==5)if(!(d[l+28>>1]|0))if(!(d[l+26>>1]|0))if(!(d[l+24>>1]|0))if(!(d[l+22>>1]|0))if(!(d[l+20>>1]|0))if(!(d[l+18>>1]|0))if(!(d[l+16>>1]|0))if(!(d[l+14>>1]|0))if(!(d[l+12>>1]|0))if(!(d[l+10>>1]|0))if(!(d[l+8>>1]|0))if(!(d[l+6>>1]|0))if(!(d[l+4>>1]|0)){if(d[l+2>>1]|0){w=(q|0)!=0&1;x=1;y=1;z=0;break}o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;f[h>>2]=1;A=0;u=k;return A|0}else{s=2;t=q;v=0;r=7}else{s=3;t=q;v=0;r=7}else{s=4;t=q;v=0;r=7}else{s=5;t=q;v=0;r=7}else{s=6;t=q;v=0;r=7}else{s=7;t=q;v=0;r=7}else{s=8;t=q;v=0;r=7}else{s=9;t=q;v=0;r=7}else{s=10;t=q;v=0;r=7}else{s=11;t=q;v=0;r=7}else{s=12;t=q;v=0;r=7}else{s=13;t=q;v=0;r=7}else{s=14;t=q;v=0;r=7}while(0);a:do if((r|0)==7){q=t>>>0>s>>>0?s:t;o=1;while(1){if(d[l+(o<<1)>>1]|0){w=q;x=s;y=o;z=v;break a}p=o+1|0;if(p>>>0<s>>>0)o=p;else{w=q;x=s;y=p;z=v;break}}}while(0);v=w>>>0<y>>>0?y:w;w=d[l+2>>1]|0;s=w&65535;t=2-s|0;if((t|0)<0){A=-1;u=k;return A|0}q=j[l+4>>1]|0;o=(t<<1)-q|0;if((o|0)<0){A=-1;u=k;return A|0}t=j[l+6>>1]|0;p=(o<<1)-t|0;if((p|0)<0){A=-1;u=k;return A|0}o=j[l+8>>1]|0;B=(p<<1)-o|0;if((B|0)<0){A=-1;u=k;return A|0}p=j[l+10>>1]|0;C=(B<<1)-p|0;if((C|0)<0){A=-1;u=k;return A|0}B=j[l+12>>1]|0;D=(C<<1)-B|0;if((D|0)<0){A=-1;u=k;return A|0}C=j[l+14>>1]|0;E=(D<<1)-C|0;if((E|0)<0){A=-1;u=k;return A|0}D=j[l+16>>1]|0;F=(E<<1)-D|0;if((F|0)<0){A=-1;u=k;return A|0}E=j[l+18>>1]|0;G=(F<<1)-E|0;if((G|0)<0){A=-1;u=k;return A|0}F=j[l+20>>1]|0;H=(G<<1)-F|0;if((H|0)<0){A=-1;u=k;return A|0}G=j[l+22>>1]|0;I=(H<<1)-G|0;if((I|0)<0){A=-1;u=k;return A|0}H=j[l+24>>1]|0;J=(I<<1)-H|0;if((J|0)<0){A=-1;u=k;return A|0}I=j[l+26>>1]|0;K=(J<<1)-I|0;if((K|0)<0){A=-1;u=k;return A|0}J=j[l+28>>1]|0;L=(K<<1)-J|0;if((L|0)<0){A=-1;u=k;return A|0}K=(L<<1)-(z&65535)|0;if((K|0)<0){A=-1;u=k;return A|0}if(K|0?(a|0)==0|(x|0)!=1:0){A=-1;u=k;return A|0}d[m+2>>1]=0;d[m+4>>1]=w;w=q+s|0;d[m+6>>1]=w;d[m+8>>1]=t+w;s=w+t|0;d[m+10>>1]=o+s;t=s+o|0;d[m+12>>1]=p+t;o=t+p|0;d[m+14>>1]=B+o;p=o+B|0;d[m+16>>1]=C+p;B=p+C|0;d[m+18>>1]=D+B;C=B+D|0;d[m+20>>1]=E+C;D=C+E|0;d[m+22>>1]=F+D;E=D+F|0;d[m+24>>1]=G+E;F=E+G|0;d[m+26>>1]=H+F;G=F+H|0;d[m+28>>1]=I+G;d[m+30>>1]=J+(G+I);if(!n){n=0;do{I=d[c+(n<<1)>>1]|0;if(I<<16>>16){G=m+((I&65535)<<1)|0;I=d[G>>1]|0;d[G>>1]=I+1<<16>>16;d[i+((I&65535)<<1)>>1]=n}n=n+1|0}while((n|0)!=(e|0))}switch(a|0){case 0:{M=i;N=i;O=20;P=0;Q=0;break}case 1:{if(v>>>0>9){A=1;u=k;return A|0}else{M=194928;N=194802;O=257;P=0;Q=1}break}default:{e=(a|0)==2;if(e&v>>>0>9){A=1;u=k;return A|0}else{M=194864;N=194738;O=0;P=e;Q=0}}}e=1<<v;a=e+-1|0;n=v&255;m=f[g>>2]|0;I=-1;G=0;J=e;e=0;H=v;F=0;E=y;b:while(1){y=1<<H;R=G;D=F;C=E;while(1){B=C-e|0;S=B&255;p=d[i+(D<<1)>>1]|0;o=p&65535;do if((o+1|0)>>>0<O>>>0){T=p;U=0}else{t=o-O|0;if(o>>>0<O>>>0){T=0;U=96;break}T=d[N+(t<<1)>>1]|0;U=d[M+(t<<1)>>1]&255}while(0);o=1<<B;p=R>>>e;t=y;do{t=t-o|0;s=t+p|0;b[m+(s<<2)>>0]=U;b[m+(s<<2)+1>>0]=S;d[m+(s<<2)+2>>1]=T}while((t|0)!=0);t=1<<C+-1;while(1)if(!(t&R))break;else t=t>>>1;p=R;R=(t|0)==0?0:(t+-1&R)+t|0;p=D;D=D+1|0;p=l+(C<<1)|0;o=(d[p>>1]|0)+-1<<16>>16;d[p>>1]=o;if(!(o<<16>>16)){if((C|0)==(x|0))break b;V=j[c+(j[i+(D<<1)>>1]<<1)>>1]|0}else V=C;if(V>>>0<=v>>>0){R=R;D=D;C=V;continue}W=R&a;if((W|0)!=(I|0))break;else C=V}C=(e|0)==0?v:e;o=m+(y<<2)|0;p=V-C|0;c:do if(V>>>0<x>>>0){B=1<<p;s=p;w=V;while(1){q=B-(j[l+(w<<1)>>1]|0)|0;if((q|0)<1){X=s;break c}K=s+1|0;w=K+C|0;if(w>>>0>=x>>>0){X=K;break}else{B=q<<1;s=K}}}else X=p;while(0);p=(1<<X)+J|0;if(Q&p>>>0>852|P&p>>>0>592){A=1;r=43;break}y=f[g>>2]|0;b[y+(W<<2)>>0]=X;b[y+(W<<2)+1>>0]=n;d[y+(W<<2)+2>>1]=(o-y|0)>>>2;m=o;I=W;G=R;J=p;e=C;H=X;F=D;E=V}if((r|0)==43){u=k;return A|0}if(R|0){b[m+(R<<2)>>0]=64;b[m+(R<<2)+1>>0]=S;d[m+(R<<2)+2>>1]=0}f[g>>2]=(f[g>>2]|0)+(J<<2);f[h>>2]=v;A=0;u=k;return A|0}function IHc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0;e=f[a+28>>2]|0;g=f[a>>2]|0;i=a+4|0;j=g+((f[i>>2]|0)+-5)|0;k=a+12|0;l=f[k>>2]|0;m=a+16|0;n=f[m>>2]|0;o=l+(n+-257)|0;p=f[e+44>>2]|0;q=f[e+48>>2]|0;r=f[e+52>>2]|0;s=f[e+56>>2]|0;t=e+60|0;u=e+64|0;v=f[e+80>>2]|0;w=f[e+84>>2]|0;x=(1<<f[e+88>>2])+-1|0;y=(1<<f[e+92>>2])+-1|0;z=l+(n-c)|0;c=e+7108|0;n=(r|0)==0;A=r+p|0;B=z-r|0;C=g;g=l;l=f[t>>2]|0;D=f[u>>2]|0;a:while(1){if(D>>>0<15){E=C+2|0;F=((h[C>>0]|0)<<D)+l+((h[C+1>>0]|0)<<D+8)|0;G=D+16|0}else{E=C;F=l;G=D}H=F&x;I=b[v+(H<<2)>>0]|0;J=d[v+(H<<2)+2>>1]|0;K=h[v+(H<<2)+1>>0]|0;H=F>>>K;L=G-K|0;do if(I<<24>>24){K=J;M=I&255;N=L;O=H;while(1){if(M&16|0)break;if(M&64|0){P=53;break a}Q=(O&(1<<M)+-1)+(K&65535)|0;R=b[v+(Q<<2)>>0]|0;S=d[v+(Q<<2)+2>>1]|0;T=h[v+(Q<<2)+1>>0]|0;U=O>>>T;V=N-T|0;if(!(R<<24>>24)){P=6;break}else{K=S;M=R&255;N=V;O=U}}if((P|0)==6){P=0;W=V;X=U;Y=S&255;P=7;break}R=K&65535;T=M&15;if(!T){Z=R;_=E;$=O;aa=N}else{if(N>>>0<T>>>0){ba=E+1|0;ca=((h[E>>0]|0)<<N)+O|0;da=N+8|0}else{ba=E;ca=O;da=N}Z=(ca&(1<<T)+-1)+R|0;_=ba;$=ca>>>T;aa=da-T|0}if(aa>>>0<15){ea=_+2|0;fa=((h[_>>0]|0)<<aa)+$+((h[_+1>>0]|0)<<aa+8)|0;ga=aa+16|0}else{ea=_;fa=$;ga=aa}T=fa&y;R=d[w+(T<<2)+2>>1]|0;Q=h[w+(T<<2)+1>>0]|0;ha=fa>>>Q;ia=ga-Q|0;Q=h[w+(T<<2)>>0]|0;if(!(Q&16)){T=R;ja=Q;ka=ha;la=ia;while(1){if(ja&64|0){ma=ea;na=ka;oa=la;pa=519541;P=55;break a}qa=(ka&(1<<ja)+-1)+(T&65535)|0;ra=d[w+(qa<<2)+2>>1]|0;sa=h[w+(qa<<2)+1>>0]|0;ta=ka>>>sa;ua=la-sa|0;sa=h[w+(qa<<2)>>0]|0;if(!(sa&16)){T=ra;ja=sa;ka=ta;la=ua}else{va=sa;wa=ua;xa=ta;ya=ra;break}}}else{va=Q;wa=ia;xa=ha;ya=R}la=ya&65535;ka=va&15;if(wa>>>0<ka>>>0){ja=ea+1|0;T=((h[ea>>0]|0)<<wa)+xa|0;K=wa+8|0;if(K>>>0<ka>>>0){za=ea+2|0;Aa=((h[ja>>0]|0)<<K)+T|0;Ba=wa+16|0}else{za=ja;Aa=T;Ba=K}}else{za=ea;Aa=xa;Ba=wa}K=(Aa&(1<<ka)+-1)+la|0;la=Aa>>>ka;T=Ba-ka|0;ka=g;ja=ka-z|0;if(K>>>0<=ja>>>0){ra=Z;ta=g+(0-K)|0;ua=g;while(1){b[ua>>0]=b[ta>>0]|0;b[ua+1>>0]=b[ta+1>>0]|0;Ca=ta+3|0;Da=ua+3|0;b[ua+2>>0]=b[ta+2>>0]|0;ra=ra+-3|0;if(ra>>>0<=2)break;else{ta=Ca;ua=Da}}if(!ra){Ea=za;Fa=Da;Ga=la;Ha=T;break}R=ua+4|0;b[Da>>0]=b[Ca>>0]|0;if((ra|0)==1){Ea=za;Fa=R;Ga=la;Ha=T;break}b[R>>0]=b[ta+4>>0]|0;Ea=za;Fa=ua+5|0;Ga=la;Ha=T;break}R=K-ja|0;if(R>>>0>q>>>0?f[c>>2]|0:0){ma=za;na=la;oa=T;pa=519563;P=55;break a}do if(n){ha=s+(p-R)|0;if(Z>>>0>R>>>0){ia=Z-R|0;Q=K-ka|0;sa=ha;qa=R;Ia=g;while(1){b[Ia>>0]=b[sa>>0]|0;qa=qa+-1|0;if(!qa)break;else{sa=sa+1|0;Ia=Ia+1|0}}Ia=g+z+Q|0;Ja=ia;Ka=Ia+(0-K)|0;La=Ia}else{Ja=Z;Ka=ha;La=g}}else{if(r>>>0>=R>>>0){Ia=s+(r-R)|0;if(Z>>>0<=R>>>0){Ja=Z;Ka=Ia;La=g;break}sa=Z-R|0;qa=K-ka|0;Ma=Ia;Ia=R;Na=g;while(1){b[Na>>0]=b[Ma>>0]|0;Ia=Ia+-1|0;if(!Ia)break;else{Ma=Ma+1|0;Na=Na+1|0}}Na=g+z+qa|0;Ja=sa;Ka=Na+(0-K)|0;La=Na;break}Na=s+(A-R)|0;Ma=R-r|0;if(Z>>>0>Ma>>>0){Ia=Z-Ma|0;ha=K-ka|0;ia=Na;Q=Ma;Ma=g;while(1){b[Ma>>0]=b[ia>>0]|0;Q=Q+-1|0;if(!Q)break;else{ia=ia+1|0;Ma=Ma+1|0}}Ma=g+B+ha|0;if(Ia>>>0>r>>>0){ia=g+z|0;Q=s;sa=r;qa=Ma;while(1){b[qa>>0]=b[Q>>0]|0;sa=sa+-1|0;if(!sa)break;else{Q=Q+1|0;qa=qa+1|0}}qa=ia+ha|0;Ja=Ia-r|0;Ka=qa+(0-K)|0;La=qa}else{Ja=Ia;Ka=s;La=Ma}}else{Ja=Z;Ka=Na;La=g}}while(0);if(Ja>>>0>2){K=Ja;ka=Ka;R=La;while(1){b[R>>0]=b[ka>>0]|0;b[R+1>>0]=b[ka+1>>0]|0;ja=ka+3|0;ua=R+3|0;b[R+2>>0]=b[ka+2>>0]|0;ta=K+-3|0;if(ta>>>0>2){K=ta;ka=ja;R=ua}else{Oa=ta;Pa=ja;Qa=ua;break}}}else{Oa=Ja;Pa=Ka;Qa=La}if(Oa){R=Qa+1|0;b[Qa>>0]=b[Pa>>0]|0;if((Oa|0)==1){Ea=za;Fa=R;Ga=la;Ha=T}else{b[R>>0]=b[Pa+1>>0]|0;Ea=za;Fa=Qa+2|0;Ga=la;Ha=T}}else{Ea=za;Fa=Qa;Ga=la;Ha=T}}else{W=L;X=H;Y=J&255;P=7}while(0);if((P|0)==7){P=0;b[g>>0]=Y;Ea=E;Fa=g+1|0;Ga=X;Ha=W}if(Fa>>>0<o>>>0&Ea>>>0<j>>>0){C=Ea;g=Fa;l=Ga;D=Ha}else{Ra=Ga;Sa=Ha;Ta=Ea;Ua=Fa;P=57;break}}if((P|0)==53)if(!(M&32)){ma=E;na=O;oa=N;pa=519513;P=55}else{Va=E;Wa=O;Xa=N;Ya=16191}else if((P|0)==57){Za=Sa>>>3;_a=0-Za|0;$a=Ta+_a|0;ab=Za<<3;bb=Sa-ab|0;cb=1<<bb;db=cb+-1|0;eb=db&Ra;f[a>>2]=$a;f[k>>2]=Ua;fb=j;gb=$a;hb=fb+5|0;ib=hb-gb|0;f[i>>2]=ib;jb=o;kb=Ua;lb=jb+257|0;mb=lb-kb|0;f[m>>2]=mb;f[t>>2]=eb;f[u>>2]=bb;return}if((P|0)==55){f[a+24>>2]=pa;Va=ma;Wa=na;Xa=oa;Ya=16209}f[e+4>>2]=Ya;Ra=Wa;Sa=Xa;Ta=Va;Ua=g;Za=Sa>>>3;_a=0-Za|0;$a=Ta+_a|0;ab=Za<<3;bb=Sa-ab|0;cb=1<<bb;db=cb+-1|0;eb=db&Ra;f[a>>2]=$a;f[k>>2]=Ua;fb=j;gb=$a;hb=fb+5|0;ib=hb-gb|0;f[i>>2]=ib;jb=o;kb=Ua;lb=jb+257|0;mb=lb-kb|0;f[m>>2]=mb;f[t>>2]=eb;f[u>>2]=bb;return}function JHc(a,b,c){a=a|0;b=b|0;c=c|0;return jIc(Y(c,b)|0)|0}function KHc(a,b){a=a|0;b=b|0;kIc(b);return}function LHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=a>>>16;e=a&65535;if((c|0)==1){a=(h[b>>0]|0)+e|0;f=a>>>0>65520?a+-65521|0:a;a=f+d|0;g=(a>>>0>65520?a+15|0:a)<<16|f;return g|0}if(!b){g=1;return g|0}if(c>>>0<16){if(!c){i=d;j=e}else{f=c;a=b;k=e;l=d;while(1){f=f+-1|0;m=(h[a>>0]|0)+k|0;n=m+l|0;if(!f){i=n;j=m;break}else{a=a+1|0;k=m;l=n}}}g=((i>>>0)%65521|0)<<16|(j>>>0>65520?j+-65521|0:j);return g|0}if(c>>>0>5551){j=c;i=b;l=d;k=e;do{j=j+-5552|0;a=347;f=i;n=l;m=k;while(1){o=(h[f>>0]|0)+m|0;p=o+(h[f+1>>0]|0)|0;q=p+(h[f+2>>0]|0)|0;r=q+(h[f+3>>0]|0)|0;s=r+(h[f+4>>0]|0)|0;t=s+(h[f+5>>0]|0)|0;u=t+(h[f+6>>0]|0)|0;v=u+(h[f+7>>0]|0)|0;w=v+(h[f+8>>0]|0)|0;x=w+(h[f+9>>0]|0)|0;y=x+(h[f+10>>0]|0)|0;z=y+(h[f+11>>0]|0)|0;A=z+(h[f+12>>0]|0)|0;B=A+(h[f+13>>0]|0)|0;C=B+(h[f+14>>0]|0)|0;m=C+(h[f+15>>0]|0)|0;n=o+n+p+q+r+s+t+u+v+w+x+y+z+A+B+C+m|0;a=a+-1|0;if(!a)break;else f=f+16|0}i=i+5552|0;k=(m>>>0)%65521|0;l=(n>>>0)%65521|0}while(j>>>0>5551);if(j)if(j>>>0>15){D=j;E=i;F=l;G=k;H=14}else{I=j;J=i;K=l;L=k;H=17}else{M=l;N=k}}else{D=c;E=b;F=d;G=e;H=14}if((H|0)==14){e=D+-16|0;d=e&-16;b=d+16|0;c=D;D=E;k=F;F=G;while(1){c=c+-16|0;G=(h[D>>0]|0)+F|0;l=G+(h[D+1>>0]|0)|0;i=l+(h[D+2>>0]|0)|0;j=i+(h[D+3>>0]|0)|0;f=j+(h[D+4>>0]|0)|0;a=f+(h[D+5>>0]|0)|0;C=a+(h[D+6>>0]|0)|0;B=C+(h[D+7>>0]|0)|0;A=B+(h[D+8>>0]|0)|0;z=A+(h[D+9>>0]|0)|0;y=z+(h[D+10>>0]|0)|0;x=y+(h[D+11>>0]|0)|0;w=x+(h[D+12>>0]|0)|0;v=w+(h[D+13>>0]|0)|0;u=v+(h[D+14>>0]|0)|0;F=u+(h[D+15>>0]|0)|0;k=G+k+l+i+j+f+a+C+B+A+z+y+x+w+v+u+F|0;if(c>>>0<=15)break;else D=D+16|0}D=e-d|0;if(!D){O=k;P=F;H=18}else{I=D;J=E+b|0;K=k;L=F;H=17}}if((H|0)==17)while(1){H=0;I=I+-1|0;F=(h[J>>0]|0)+L|0;k=F+K|0;if(!I){O=k;P=F;H=18;break}else{J=J+1|0;K=k;L=F;H=17}}if((H|0)==18){M=(O>>>0)%65521|0;N=(P>>>0)%65521|0}g=M<<16|N;return g|0}function MHc(a,b,c){a=a|0;b=b|0;c=c|0;return LHc(a,b,c)|0}function NHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if(!b){d=0;return d|0}e=~a;a:do if(c){a=e;g=c;i=b;while(1){if(!(i&3))break;j=f[175296+(((h[i>>0]|0)^a&255)<<2)>>2]^a>>>8;k=g+-1|0;if(!k){l=j;break a}else{a=j;g=k;i=i+1|0}}if(g>>>0>31){k=g+-32|0;j=k&-32;m=i+(j+32)|0;n=i;o=a;p=g;while(1){q=f[n>>2]^o;r=f[177344+((q>>>8&255)<<2)>>2]^f[178368+((q&255)<<2)>>2]^f[176320+((q>>>16&255)<<2)>>2]^f[175296+(q>>>24<<2)>>2]^f[n+4>>2];q=f[177344+((r>>>8&255)<<2)>>2]^f[178368+((r&255)<<2)>>2]^f[176320+((r>>>16&255)<<2)>>2]^f[175296+(r>>>24<<2)>>2]^f[n+8>>2];r=f[177344+((q>>>8&255)<<2)>>2]^f[178368+((q&255)<<2)>>2]^f[176320+((q>>>16&255)<<2)>>2]^f[175296+(q>>>24<<2)>>2]^f[n+12>>2];q=f[177344+((r>>>8&255)<<2)>>2]^f[178368+((r&255)<<2)>>2]^f[176320+((r>>>16&255)<<2)>>2]^f[175296+(r>>>24<<2)>>2]^f[n+16>>2];r=f[177344+((q>>>8&255)<<2)>>2]^f[178368+((q&255)<<2)>>2]^f[176320+((q>>>16&255)<<2)>>2]^f[175296+(q>>>24<<2)>>2]^f[n+20>>2];q=f[177344+((r>>>8&255)<<2)>>2]^f[178368+((r&255)<<2)>>2]^f[176320+((r>>>16&255)<<2)>>2]^f[175296+(r>>>24<<2)>>2]^f[n+24>>2];r=f[177344+((q>>>8&255)<<2)>>2]^f[178368+((q&255)<<2)>>2]^f[176320+((q>>>16&255)<<2)>>2]^f[175296+(q>>>24<<2)>>2]^f[n+28>>2];o=f[177344+((r>>>8&255)<<2)>>2]^f[178368+((r&255)<<2)>>2]^f[176320+((r>>>16&255)<<2)>>2]^f[175296+(r>>>24<<2)>>2];p=p+-32|0;if(p>>>0<=31)break;else n=n+32|0}s=m;t=o;u=k-j|0}else{s=i;t=a;u=g}if(u>>>0>3){n=u+-4|0;p=n>>>2;r=p+1|0;q=s;v=u;w=t;while(1){x=f[q>>2]^w;w=f[177344+((x>>>8&255)<<2)>>2]^f[178368+((x&255)<<2)>>2]^f[176320+((x>>>16&255)<<2)>>2]^f[175296+(x>>>24<<2)>>2];v=v+-4|0;if(v>>>0<=3)break;else q=q+4|0}y=s+(r<<2)|0;z=w;A=n-(p<<2)|0}else{y=s;z=t;A=u}if(!A)l=z;else{q=y;v=z;g=A;while(1){a=f[175296+(((h[q>>0]|0)^v&255)<<2)>>2]^v>>>8;g=g+-1|0;if(!g){l=a;break}else{q=q+1|0;v=a}}}}else l=e;while(0);d=~l;return d|0}function OHc(a,b,c){a=a|0;b=b|0;c=c|0;return NHc(a,b,c)|0}function PHc(a,c,e,g,h,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!k){m=-6;return m|0}if((l|0)!=56|(b[k>>0]|0)!=49){m=-6;return m|0}if(!a){m=-2;return m|0}k=a+24|0;f[k>>2]=0;l=a+32|0;n=f[l>>2]|0;if(!n){f[l>>2]=310;f[a+40>>2]=0;o=310}else o=n;n=a+36|0;if(!(f[n>>2]|0))f[n>>2]=1327;n=(c|0)==-1?6:c;if((g|0)<0){p=0;q=0-g|0}else{c=(g|0)>15;p=c?2:1;q=c?g+-16|0:g}if(i>>>0>4|(n>>>0>9|((e|0)!=8|(h+-1|0)>>>0>8|(q&-8|0)!=8))){m=-2;return m|0}e=(q|0)==8;if(e&(p|0)!=1){m=-2;return m|0}g=e?9:q;q=a+40|0;e=hj[o&511](f[q>>2]|0,1,5828)|0;if(!e){m=-4;return m|0}o=a+28|0;f[o>>2]=e;f[e>>2]=a;c=e+4|0;f[c>>2]=42;f[e+24>>2]=p;f[e+28>>2]=0;f[e+48>>2]=g;p=1<<g;g=e+44|0;f[g>>2]=p;f[e+52>>2]=p+-1;r=h+7|0;f[e+80>>2]=r;s=1<<r;r=e+76|0;f[r>>2]=s;f[e+84>>2]=s+-1;f[e+88>>2]=((h+9|0)>>>0)/3|0;s=hj[f[l>>2]&511](f[q>>2]|0,p,2)|0;p=e+56|0;f[p>>2]=s;s=hj[f[l>>2]&511](f[q>>2]|0,f[g>>2]|0,2)|0;g=e+64|0;f[g>>2]=s;s=hj[f[l>>2]&511](f[q>>2]|0,f[r>>2]|0,2)|0;r=e+68|0;f[r>>2]=s;f[e+5824>>2]=0;s=1<<h+6;h=e+5788|0;f[h>>2]=s;t=hj[f[l>>2]&511](f[q>>2]|0,s,4)|0;f[e+8>>2]=t;s=f[h>>2]|0;f[e+12>>2]=s<<2;if((f[p>>2]|0?f[g>>2]|0:0)?!((f[r>>2]|0)==0|(t|0)==0):0){f[e+5796>>2]=t+(s>>>1<<1);f[e+5784>>2]=t+(s*3|0);f[e+132>>2]=n;f[e+136>>2]=i;b[e+36>>0]=8;e=RHc(a)|0;if(e|0){m=e;return m|0}e=f[o>>2]|0;f[e+60>>2]=f[e+44>>2]<<1;o=f[e+68>>2]|0;i=(f[e+76>>2]|0)+-1|0;d[o+(i<<1)>>1]=0;g1c(o|0,0,i<<1|0)|0;i=f[e+132>>2]|0;f[e+128>>2]=j[183488+(i*12|0)+2>>1];f[e+140>>2]=j[183488+(i*12|0)>>1];f[e+144>>2]=j[183488+(i*12|0)+4>>1];f[e+124>>2]=j[183488+(i*12|0)+6>>1];f[e+108>>2]=0;f[e+92>>2]=0;f[e+116>>2]=0;f[e+5812>>2]=0;f[e+120>>2]=2;f[e+96>>2]=2;f[e+104>>2]=0;f[e+72>>2]=0;m=0;return m|0}f[c>>2]=666;f[k>>2]=f[43820];QHc(a)|0;m=-4;return m|0}function QHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}c=a+36|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=a+28|0;g=f[e>>2]|0;if(!g){b=-2;return b|0}if((f[g>>2]|0)!=(a|0)){b=-2;return b|0}h=f[g+4>>2]|0;switch(h|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{b=-2;return b|0}}i=f[g+8>>2]|0;if(!i)j=g;else{mi[d&2047](f[a+40>>2]|0,i);j=f[e>>2]|0}i=f[j+68>>2]|0;if(!i)k=j;else{mi[f[c>>2]&2047](f[a+40>>2]|0,i);k=f[e>>2]|0}i=f[k+64>>2]|0;if(!i)l=k;else{mi[f[c>>2]&2047](f[a+40>>2]|0,i);l=f[e>>2]|0}i=f[l+56>>2]|0;if(!i){m=a+40|0;n=l}else{l=a+40|0;mi[f[c>>2]&2047](f[l>>2]|0,i);m=l;n=f[e>>2]|0}mi[f[c>>2]&2047](f[m>>2]|0,n);f[e>>2]=0;b=(h|0)==113?-3:0;return b|0}function RHc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}if(!(f[a+36>>2]|0)){b=-2;return b|0}c=f[a+28>>2]|0;if(!c){b=-2;return b|0}if((f[c>>2]|0)!=(a|0)){b=-2;return b|0}d=c+4|0;switch(f[d>>2]|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{b=-2;return b|0}}f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;f[a+44>>2]=2;f[c+20>>2]=0;f[c+16>>2]=f[c+8>>2];e=c+24|0;g=f[e>>2]|0;h=0-g|0;if((g|0)<0){f[e>>2]=h;i=h}else i=g;g=(i|0)==2;f[d>>2]=g?57:i|0?42:113;if(g)j=OHc(0,0,0)|0;else j=MHc(0,0,0)|0;f[a+48>>2]=j;f[c+40>>2]=0;ZHc(c);b=0;return b|0}function SHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;d=a+12|0;e=(f[d>>2]|0)+-5|0;g=a+44|0;h=f[g>>2]|0;i=e>>>0>h>>>0?h:e;e=f[a>>2]|0;h=f[e+4>>2]|0;j=a+5820|0;k=a+108|0;l=a+92|0;m=(c|0)!=4;n=(c|0)==0;o=(c|0)==4;p=a+8|0;q=a+20|0;r=a+56|0;s=(f[j>>2]|0)+42>>3;t=f[e+16>>2]|0;a:do if(t>>>0<s>>>0){u=0;v=e}else{w=0;x=s;y=t;z=e;while(1){A=y-x|0;B=(f[k>>2]|0)-(f[l>>2]|0)|0;C=B+(f[z+4>>2]|0)|0;D=C>>>0<65535?C:65535;E=D>>>0>A>>>0?A:D;if(E>>>0<i>>>0?!((E|0)==(C|0)&((n|m&(E|0)==0)^1)):0){u=w;v=z;break a}D=o&(E|0)==(C|0);C=D&1;$Hc(a,0,0,C);b[(f[p>>2]|0)+((f[q>>2]|0)+-4)>>0]=E;b[(f[p>>2]|0)+((f[q>>2]|0)+-3)>>0]=E>>>8;A=~E;b[(f[p>>2]|0)+((f[q>>2]|0)+-2)>>0]=A;b[(f[p>>2]|0)+((f[q>>2]|0)+-1)>>0]=A>>>8;A=f[a>>2]|0;F=f[A+28>>2]|0;aIc(F);G=F+20|0;H=f[G>>2]|0;I=A+16|0;J=f[I>>2]|0;K=H>>>0>J>>>0?J:H;if(K|0?(H=A+12|0,J=F+16|0,o1c(f[H>>2]|0,f[J>>2]|0,K|0)|0,f[H>>2]=(f[H>>2]|0)+K,f[J>>2]=(f[J>>2]|0)+K,H=A+20|0,f[H>>2]=(f[H>>2]|0)+K,f[I>>2]=(f[I>>2]|0)-K,I=(f[G>>2]|0)-K|0,f[G>>2]=I,(I|0)==0):0)f[J>>2]=f[F+8>>2];if(!B)L=E;else{F=B>>>0>E>>>0?E:B;o1c(f[(f[a>>2]|0)+12>>2]|0,(f[r>>2]|0)+(f[l>>2]|0)|0,F|0)|0;B=f[a>>2]|0;J=B+12|0;f[J>>2]=(f[J>>2]|0)+F;J=B+16|0;f[J>>2]=(f[J>>2]|0)-F;J=B+20|0;f[J>>2]=(f[J>>2]|0)+F;f[l>>2]=(f[l>>2]|0)+F;L=E-F|0}if(L|0){F=f[a>>2]|0;E=f[F+12>>2]|0;J=F+4|0;B=f[J>>2]|0;I=B>>>0>L>>>0?L:B;if(!I){M=F;N=E}else{f[J>>2]=B-I;o1c(E|0,f[F>>2]|0,I|0)|0;switch(f[(f[F+28>>2]|0)+24>>2]|0){case 1:{B=F+48|0;O=B;P=MHc(f[B>>2]|0,E,I)|0;Q=14;break}case 2:{B=F+48|0;O=B;P=OHc(f[B>>2]|0,E,I)|0;Q=14;break}default:{}}if((Q|0)==14){Q=0;f[O>>2]=P}f[F>>2]=(f[F>>2]|0)+I;E=F+8|0;f[E>>2]=(f[E>>2]|0)+I;I=f[a>>2]|0;M=I;N=f[I+12>>2]|0}f[M+12>>2]=N+L;I=M+16|0;f[I>>2]=(f[I>>2]|0)-L;I=M+20|0;f[I>>2]=(f[I>>2]|0)+L}I=f[a>>2]|0;if(D){u=C;v=I;break a}x=(f[j>>2]|0)+42>>3;y=f[I+16>>2]|0;if(y>>>0<x>>>0){u=C;v=I;break}else{w=C;z=I}}}while(0);L=h-(f[v+4>>2]|0)|0;if(!L)R=f[k>>2]|0;else{h=f[g>>2]|0;if(L>>>0<h>>>0){M=f[k>>2]|0;if(((f[a+60>>2]|0)-M|0)>>>0<=L>>>0?(N=M-h|0,f[k>>2]=N,M=f[r>>2]|0,o1c(M|0,M+h|0,N|0)|0,N=a+5808|0,M=f[N>>2]|0,M>>>0<2):0)f[N>>2]=M+1;o1c((f[r>>2]|0)+(f[k>>2]|0)|0,(f[f[a>>2]>>2]|0)+(0-L)|0,L|0)|0;M=(f[k>>2]|0)+L|0;f[k>>2]=M;S=M;T=f[g>>2]|0}else{f[a+5808>>2]=2;o1c(f[r>>2]|0,(f[v>>2]|0)+(0-h)|0,h|0)|0;h=f[g>>2]|0;f[k>>2]=h;S=h;T=h}f[l>>2]=S;h=a+5812|0;v=f[h>>2]|0;M=T-v|0;f[h>>2]=(L>>>0>M>>>0?M:L)+v;R=S}S=a+5824|0;if((f[S>>2]|0)>>>0<R>>>0)f[S>>2]=R;if(u|0){U=3;return U|0}u=(c|0)!=0;v=f[a>>2]|0;L=f[v+4>>2]|0;switch(c|0){case 0:case 4:break;default:if((L|0)==0?(R|0)==(f[l>>2]|0):0){U=1;return U|0}}c=(f[a+60>>2]|0)-R+-1|0;if(L>>>0>c>>>0?(M=f[l>>2]|0,h=f[g>>2]|0,(M|0)>=(h|0)):0){f[l>>2]=M-h;M=R-h|0;f[k>>2]=M;R=f[r>>2]|0;o1c(R|0,R+h|0,M|0)|0;M=a+5808|0;h=f[M>>2]|0;if(h>>>0<2)f[M>>2]=h+1;h=f[a>>2]|0;V=(f[g>>2]|0)+c|0;W=f[h+4>>2]|0;X=h}else{V=c;W=L;X=v}v=V>>>0>W>>>0?W:V;if(!v)Y=f[k>>2]|0;else{V=(f[r>>2]|0)+(f[k>>2]|0)|0;f[X+4>>2]=W-v;o1c(V|0,f[X>>2]|0,v|0)|0;switch(f[(f[X+28>>2]|0)+24>>2]|0){case 1:{W=X+48|0;Z=W;_=MHc(f[W>>2]|0,V,v)|0;Q=44;break}case 2:{W=X+48|0;Z=W;_=OHc(f[W>>2]|0,V,v)|0;Q=44;break}default:{}}if((Q|0)==44)f[Z>>2]=_;f[X>>2]=(f[X>>2]|0)+v;_=X+8|0;f[_>>2]=(f[_>>2]|0)+v;_=(f[k>>2]|0)+v|0;f[k>>2]=_;Y=_}if((f[S>>2]|0)>>>0<Y>>>0)f[S>>2]=Y;S=(f[d>>2]|0)-((f[j>>2]|0)+42>>3)|0;j=S>>>0<65535?S:65535;S=f[g>>2]|0;g=f[l>>2]|0;d=Y-g|0;if(d>>>0<(j>>>0>S>>>0?S:j)>>>0)if(u&(o|(d|0)!=0)?!(d>>>0>j>>>0?1:(f[(f[a>>2]|0)+4>>2]|0)!=0):0)Q=51;else $=0;else Q=51;if((Q|0)==51){Q=d>>>0>j>>>0?j:d;if(o)aa=d>>>0<=j>>>0?(f[(f[a>>2]|0)+4>>2]|0)==0:0;else aa=0;j=aa&1;$Hc(a,(f[r>>2]|0)+g|0,Q,j);f[l>>2]=(f[l>>2]|0)+Q;Q=f[a>>2]|0;a=f[Q+28>>2]|0;aIc(a);l=a+20|0;g=f[l>>2]|0;r=Q+16|0;aa=f[r>>2]|0;d=g>>>0>aa>>>0?aa:g;if((d|0)!=0?(g=Q+12|0,aa=a+16|0,o1c(f[g>>2]|0,f[aa>>2]|0,d|0)|0,f[g>>2]=(f[g>>2]|0)+d,f[aa>>2]=(f[aa>>2]|0)+d,g=Q+20|0,f[g>>2]=(f[g>>2]|0)+d,f[r>>2]=(f[r>>2]|0)-d,r=(f[l>>2]|0)-d|0,f[l>>2]=r,(r|0)==0):0){f[aa>>2]=f[a+8>>2];$=j}else $=j}U=$|0?2:0;return U|0}function THc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+44|0;r=a+96|0;s=a+5784|0;t=a+5796|0;u=a+112|0;v=a+5792|0;w=a+5788|0;x=a+128|0;y=a+92|0;while(1){if((f[e>>2]|0)>>>0<262){VHc(a);z=f[e>>2]|0;if(g&z>>>0<262){A=0;B=39;break}if(!z){B=24;break}if(z>>>0<=2)B=9;else B=6}else B=6;if((B|0)==6){B=0;z=f[l>>2]|0;C=((h[(f[k>>2]|0)+(z+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=C;D=(f[n>>2]|0)+(C<<1)|0;C=d[D>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&z)<<1)>>1]=C;E=C&65535;d[D>>1]=z;if(C<<16>>16!=0?(z-E|0)>>>0<=((f[q>>2]|0)+-262|0)>>>0:0){z=WHc(a,E)|0;f[r>>2]=z;F=z}else B=9}if((B|0)==9){B=0;F=f[r>>2]|0}z=f[s>>2]|0;E=f[t>>2]|0;do if(F>>>0>2){C=F+253|0;D=(f[l>>2]|0)-(f[u>>2]|0)|0;G=f[v>>2]|0;d[E+(G<<1)>>1]=D;f[v>>2]=G+1;b[z+G>>0]=C;G=a+148+((h[520221+(C&255)>>0]|0|256)+1<<2)|0;d[G>>1]=(d[G>>1]|0)+1<<16>>16;G=D+65535&65535;D=a+2440+((h[519709+(G>>>0<256?G:(G>>>7)+256|0)>>0]|0)<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;G=f[r>>2]|0;C=(f[e>>2]|0)-G|0;f[e>>2]=C;if(!(C>>>0>2?G>>>0<=(f[x>>2]|0)>>>0:0)){C=(f[l>>2]|0)+G|0;f[l>>2]=C;f[r>>2]=0;H=f[k>>2]|0;I=h[H+C>>0]|0;f[i>>2]=I;f[i>>2]=((h[H+(C+1)>>0]|0)^I<<f[j>>2])&f[m>>2];J=D;K=C;break}C=G+-1|0;f[r>>2]=C;G=f[j>>2]|0;I=f[k>>2]|0;H=f[m>>2]|0;L=f[n>>2]|0;M=f[o>>2]|0;N=f[p>>2]|0;O=f[l>>2]|0;P=f[i>>2]|0;Q=C;while(1){C=O+1|0;f[l>>2]=C;P=((h[I+(O+3)>>0]|0)^P<<G)&H;f[i>>2]=P;R=L+(P<<1)|0;d[M+((N&C)<<1)>>1]=d[R>>1]|0;d[R>>1]=C;Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else O=C}Q=O+2|0;f[l>>2]=Q;J=D;K=Q}else{Q=b[(f[k>>2]|0)+(f[l>>2]|0)>>0]|0;N=f[v>>2]|0;d[E+(N<<1)>>1]=0;f[v>>2]=N+1;b[z+N>>0]=Q;N=a+148+((Q&255)<<2)|0;d[N>>1]=(d[N>>1]|0)+1<<16>>16;N=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;f[e>>2]=(f[e>>2]|0)+-1;Q=(f[l>>2]|0)+1|0;f[l>>2]=Q;J=N;K=Q}while(0);if(!J)continue;z=f[y>>2]|0;if((z|0)>-1)S=(f[k>>2]|0)+z|0;else S=0;cIc(a,S,K-z|0,0);f[y>>2]=f[l>>2];z=f[a>>2]|0;E=f[z+28>>2]|0;aIc(E);Q=E+20|0;N=f[Q>>2]|0;M=z+16|0;P=f[M>>2]|0;L=N>>>0>P>>>0?P:N;if(L|0?(N=z+12|0,P=E+16|0,o1c(f[N>>2]|0,f[P>>2]|0,L|0)|0,f[N>>2]=(f[N>>2]|0)+L,f[P>>2]=(f[P>>2]|0)+L,N=z+20|0,f[N>>2]=(f[N>>2]|0)+L,f[M>>2]=(f[M>>2]|0)-L,M=(f[Q>>2]|0)-L|0,f[Q>>2]=M,(M|0)==0):0)f[P>>2]=f[E+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;B=39;break}}if((B|0)==24){K=f[l>>2]|0;f[a+5812>>2]=K>>>0<2?K:2;if((c|0)==4){c=f[y>>2]|0;if((c|0)>-1)T=(f[k>>2]|0)+c|0;else T=0;cIc(a,T,K-c|0,1);f[y>>2]=f[l>>2];c=f[a>>2]|0;T=f[c+28>>2]|0;aIc(T);S=T+20|0;J=f[S>>2]|0;e=c+16|0;w=f[e>>2]|0;r=J>>>0>w>>>0?w:J;if(r|0?(J=c+12|0,w=T+16|0,o1c(f[J>>2]|0,f[w>>2]|0,r|0)|0,f[J>>2]=(f[J>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,J=c+20|0,f[J>>2]=(f[J>>2]|0)+r,f[e>>2]=(f[e>>2]|0)-r,e=(f[S>>2]|0)-r|0,f[S>>2]=e,(e|0)==0):0)f[w>>2]=f[T+8>>2];A=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return A|0}if(f[v>>2]|0){v=f[y>>2]|0;if((v|0)>-1)U=(f[k>>2]|0)+v|0;else U=0;cIc(a,U,K-v|0,0);f[y>>2]=f[l>>2];l=f[a>>2]|0;y=f[l+28>>2]|0;aIc(y);v=y+20|0;K=f[v>>2]|0;U=l+16|0;k=f[U>>2]|0;T=K>>>0>k>>>0?k:K;if(T|0?(K=l+12|0,k=y+16|0,o1c(f[K>>2]|0,f[k>>2]|0,T|0)|0,f[K>>2]=(f[K>>2]|0)+T,f[k>>2]=(f[k>>2]|0)+T,K=l+20|0,f[K>>2]=(f[K>>2]|0)+T,f[U>>2]=(f[U>>2]|0)-T,U=(f[v>>2]|0)-T|0,f[v>>2]=U,(U|0)==0):0)f[k>>2]=f[y+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;return A|0}}A=1;return A|0}else if((B|0)==39)return A|0;return 0}function UHc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+96|0;r=a+120|0;s=a+112|0;t=a+100|0;u=a+5796|0;v=a+5792|0;w=a+5784|0;x=a+5788|0;y=a+104|0;z=a+92|0;A=a+128|0;B=a+44|0;C=a+136|0;a:while(1){D=f[e>>2]|0;while(1){if(D>>>0<262){VHc(a);E=f[e>>2]|0;if(g&E>>>0<262){F=0;G=55;break a}if(!E){G=38;break a}if(E>>>0<=2){f[r>>2]=f[q>>2];f[t>>2]=f[s>>2];f[q>>2]=2;H=2;G=16}else G=8}else G=8;do if((G|0)==8){G=0;E=f[l>>2]|0;I=((h[(f[k>>2]|0)+(E+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=I;J=(f[n>>2]|0)+(I<<1)|0;I=d[J>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&E)<<1)>>1]=I;K=I&65535;d[J>>1]=E;E=f[q>>2]|0;f[r>>2]=E;f[t>>2]=f[s>>2];f[q>>2]=2;if(I<<16>>16)if(E>>>0<(f[A>>2]|0)>>>0)if(((f[l>>2]|0)-K|0)>>>0<=((f[B>>2]|0)+-262|0)>>>0){I=WHc(a,K)|0;f[q>>2]=I;if(I>>>0<6){if((f[C>>2]|0)!=1){if((I|0)!=3){H=I;G=16;break}if(((f[l>>2]|0)-(f[s>>2]|0)|0)>>>0<=4096){H=3;G=16;break}}f[q>>2]=2;H=2;G=16}else{H=I;G=16}}else{H=2;G=16}else{L=E;M=2}else{H=2;G=16}}while(0);if((G|0)==16){G=0;L=f[r>>2]|0;M=H}if(!(L>>>0<3|M>>>0>L>>>0))break;if(!(f[y>>2]|0)){f[y>>2]=1;f[l>>2]=(f[l>>2]|0)+1;E=(f[e>>2]|0)+-1|0;f[e>>2]=E;D=E;continue}E=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;I=f[v>>2]|0;d[(f[u>>2]|0)+(I<<1)>>1]=0;K=f[w>>2]|0;f[v>>2]=I+1;b[K+I>>0]=E;I=a+148+((E&255)<<2)|0;d[I>>1]=(d[I>>1]|0)+1<<16>>16;if((f[v>>2]|0)==((f[x>>2]|0)+-1|0)){I=f[z>>2]|0;if((I|0)>-1)N=(f[k>>2]|0)+I|0;else N=0;cIc(a,N,(f[l>>2]|0)-I|0,0);f[z>>2]=f[l>>2];I=f[a>>2]|0;E=f[I+28>>2]|0;aIc(E);K=E+20|0;J=f[K>>2]|0;O=I+16|0;P=f[O>>2]|0;Q=J>>>0>P>>>0?P:J;if(Q|0?(J=I+12|0,P=E+16|0,o1c(f[J>>2]|0,f[P>>2]|0,Q|0)|0,f[J>>2]=(f[J>>2]|0)+Q,f[P>>2]=(f[P>>2]|0)+Q,J=I+20|0,f[J>>2]=(f[J>>2]|0)+Q,f[O>>2]=(f[O>>2]|0)-Q,O=(f[K>>2]|0)-Q|0,f[K>>2]=O,(O|0)==0):0)f[P>>2]=f[E+8>>2]}f[l>>2]=(f[l>>2]|0)+1;D=(f[e>>2]|0)+-1|0;f[e>>2]=D;if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break a}}D=f[l>>2]|0;E=D+-3+(f[e>>2]|0)|0;P=L+253|0;O=D+65535-(f[t>>2]|0)|0;D=f[v>>2]|0;d[(f[u>>2]|0)+(D<<1)>>1]=O;K=f[w>>2]|0;f[v>>2]=D+1;b[K+D>>0]=P;D=a+148+((h[520221+(P&255)>>0]|0|256)+1<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=O+65535&65535;O=a+2440+((h[519709+(D>>>0<256?D:(D>>>7)+256|0)>>0]|0)<<2)|0;d[O>>1]=(d[O>>1]|0)+1<<16>>16;O=f[v>>2]|0;D=(f[x>>2]|0)+-1|0;P=f[r>>2]|0;f[e>>2]=1-P+(f[e>>2]|0);K=P+-2|0;f[r>>2]=K;P=f[l>>2]|0;Q=K;while(1){K=P+1|0;f[l>>2]=K;if(K>>>0<=E>>>0){J=((h[(f[k>>2]|0)+(P+3)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=J;I=(f[n>>2]|0)+(J<<1)|0;d[(f[o>>2]|0)+((f[p>>2]&K)<<1)>>1]=d[I>>1]|0;d[I>>1]=K}Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else P=K}f[y>>2]=0;f[q>>2]=2;Q=P+2|0;f[l>>2]=Q;if((O|0)!=(D|0))continue;E=f[z>>2]|0;if((E|0)>-1)R=(f[k>>2]|0)+E|0;else R=0;cIc(a,R,Q-E|0,0);f[z>>2]=f[l>>2];E=f[a>>2]|0;Q=f[E+28>>2]|0;aIc(Q);K=Q+20|0;I=f[K>>2]|0;J=E+16|0;S=f[J>>2]|0;T=I>>>0>S>>>0?S:I;if(T|0?(I=E+12|0,S=Q+16|0,o1c(f[I>>2]|0,f[S>>2]|0,T|0)|0,f[I>>2]=(f[I>>2]|0)+T,f[S>>2]=(f[S>>2]|0)+T,I=E+20|0,f[I>>2]=(f[I>>2]|0)+T,f[J>>2]=(f[J>>2]|0)-T,J=(f[K>>2]|0)-T|0,f[K>>2]=J,(J|0)==0):0)f[S>>2]=f[Q+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break}}if((G|0)==38){if(f[y>>2]|0){R=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;q=f[v>>2]|0;d[(f[u>>2]|0)+(q<<1)>>1]=0;u=f[w>>2]|0;f[v>>2]=q+1;b[u+q>>0]=R;q=a+148+((R&255)<<2)|0;d[q>>1]=(d[q>>1]|0)+1<<16>>16;f[y>>2]=0}y=f[l>>2]|0;f[a+5812>>2]=y>>>0<2?y:2;if((c|0)==4){c=f[z>>2]|0;if((c|0)>-1)U=(f[k>>2]|0)+c|0;else U=0;cIc(a,U,y-c|0,1);f[z>>2]=f[l>>2];c=f[a>>2]|0;U=f[c+28>>2]|0;aIc(U);q=U+20|0;R=f[q>>2]|0;u=c+16|0;w=f[u>>2]|0;r=R>>>0>w>>>0?w:R;if(r|0?(R=c+12|0,w=U+16|0,o1c(f[R>>2]|0,f[w>>2]|0,r|0)|0,f[R>>2]=(f[R>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,R=c+20|0,f[R>>2]=(f[R>>2]|0)+r,f[u>>2]=(f[u>>2]|0)-r,u=(f[q>>2]|0)-r|0,f[q>>2]=u,(u|0)==0):0)f[w>>2]=f[U+8>>2];F=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return F|0}if(f[v>>2]|0){v=f[z>>2]|0;if((v|0)>-1)V=(f[k>>2]|0)+v|0;else V=0;cIc(a,V,y-v|0,0);f[z>>2]=f[l>>2];l=f[a>>2]|0;z=f[l+28>>2]|0;aIc(z);v=z+20|0;y=f[v>>2]|0;V=l+16|0;k=f[V>>2]|0;U=y>>>0>k>>>0?k:y;if(U|0?(y=l+12|0,k=z+16|0,o1c(f[y>>2]|0,f[k>>2]|0,U|0)|0,f[y>>2]=(f[y>>2]|0)+U,f[k>>2]=(f[k>>2]|0)+U,y=l+20|0,f[y>>2]=(f[y>>2]|0)+U,f[V>>2]=(f[V>>2]|0)-U,V=(f[v>>2]|0)-U|0,f[v>>2]=V,(V|0)==0):0)f[k>>2]=f[z+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;return F|0}}F=1;return F|0}else if((G|0)==55)return F|0;return 0}function VHc(a){a=a|0;var b=0,c=0,e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=a+44|0;c=f[b>>2]|0;e=a+60|0;g=a+116|0;i=a+108|0;k=c+-262|0;l=a+56|0;m=a+5812|0;n=a+72|0;o=a+88|0;p=a+84|0;q=a+68|0;r=a+64|0;s=a+52|0;t=a+112|0;u=a+92|0;v=a+76|0;w=f[g>>2]|0;x=c;while(1){y=f[i>>2]|0;z=(f[e>>2]|0)-w-y|0;if(y>>>0<(k+x|0)>>>0){A=z;B=y}else{y=f[l>>2]|0;o1c(y|0,y+c|0,c-z|0)|0;f[t>>2]=(f[t>>2]|0)-c;y=(f[i>>2]|0)-c|0;f[i>>2]=y;f[u>>2]=(f[u>>2]|0)-c;C=f[b>>2]|0;D=f[v>>2]|0;E=D;F=(f[q>>2]|0)+(D<<1)|0;do{F=F+-2|0;D=j[F>>1]|0;d[F>>1]=D>>>0<C>>>0?0:D-C&65535;E=E+-1|0}while((E|0)!=0);E=C;F=(f[r>>2]|0)+(C<<1)|0;do{F=F+-2|0;D=j[F>>1]|0;d[F>>1]=D>>>0<C>>>0?0:D-C&65535;E=E+-1|0}while((E|0)!=0);A=z+c|0;B=y}E=f[a>>2]|0;C=E+4|0;F=f[C>>2]|0;if(!F)break;D=f[g>>2]|0;G=(f[l>>2]|0)+B+D|0;H=F>>>0>A>>>0?A:F;if(!H){I=0;J=D}else{f[C>>2]=F-H;o1c(G|0,f[E>>2]|0,H|0)|0;switch(f[(f[E+28>>2]|0)+24>>2]|0){case 1:{F=E+48|0;K=F;L=MHc(f[F>>2]|0,G,H)|0;M=13;break}case 2:{F=E+48|0;K=F;L=OHc(f[F>>2]|0,G,H)|0;M=13;break}default:{}}if((M|0)==13){M=0;f[K>>2]=L}f[E>>2]=(f[E>>2]|0)+H;G=E+8|0;f[G>>2]=(f[G>>2]|0)+H;I=H;J=f[g>>2]|0}H=J+I|0;f[g>>2]=H;G=f[m>>2]|0;a:do if((G+H|0)>>>0>2){E=(f[i>>2]|0)-G|0;F=f[l>>2]|0;C=h[F+E>>0]|0;f[n>>2]=C;D=f[o>>2]|0;N=f[p>>2]|0;O=((h[F+(E+1)>>0]|0)^C<<D)&N;f[n>>2]=O;C=E;E=G;P=O;while(1){if(!E)break a;P=((h[F+(C+2)>>0]|0)^P<<D)&N;f[n>>2]=P;O=(f[q>>2]|0)+(P<<1)|0;d[(f[r>>2]|0)+((f[s>>2]&C)<<1)>>1]=d[O>>1]|0;d[O>>1]=C;E=E+-1|0;f[m>>2]=E;if((H+E|0)>>>0<3)break;else C=C+1|0}}while(0);if(H>>>0>=262)break;if(!(f[(f[a>>2]|0)+4>>2]|0))break;w=H;x=f[b>>2]|0}b=a+5824|0;a=f[b>>2]|0;x=f[e>>2]|0;if(x>>>0<=a>>>0)return;e=(f[g>>2]|0)+(f[i>>2]|0)|0;do if(a>>>0>=e>>>0){i=e+258|0;if(i>>>0>a>>>0){g=i-a|0;i=x-a|0;w=g>>>0>i>>>0?i:g;g1c((f[l>>2]|0)+a|0,0,w|0)|0;Q=(f[b>>2]|0)+w|0;break}else return}else{w=x-e|0;g=w>>>0<258?w:258;g1c((f[l>>2]|0)+e|0,0,g|0)|0;Q=g+e|0}while(0);f[b>>2]=Q;return}function WHc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=f[a+124>>2]|0;e=f[a+56>>2]|0;g=f[a+108>>2]|0;h=e+g|0;i=f[a+120>>2]|0;k=f[a+144>>2]|0;l=(f[a+44>>2]|0)+-262|0;m=g>>>0>l>>>0?g-l|0:0;l=f[a+64>>2]|0;g=f[a+52>>2]|0;n=f[a+116>>2]|0;o=k>>>0>n>>>0?n:k;k=a+112|0;p=h+1|0;q=h+258|0;r=b[h+i>>0]|0;s=b[h+(i+-1)>>0]|0;t=c;c=i;u=i>>>0<(f[a+140>>2]|0)>>>0?d:d>>>2;while(1){d=e+t|0;if((((b[d+c>>0]|0)==r<<24>>24?(b[d+(c+-1)>>0]|0)==s<<24>>24:0)?(b[d>>0]|0)==(b[h>>0]|0):0)?(a=d+1|0,(b[a>>0]|0)==(b[p>>0]|0)):0){d=2;i=a;while(1){a=h+d|0;v=a+1|0;if((b[v>>0]|0)!=(b[i+2>>0]|0)){w=v;break}v=a+2|0;if((b[v>>0]|0)!=(b[i+3>>0]|0)){w=v;break}v=a+3|0;if((b[v>>0]|0)!=(b[i+4>>0]|0)){w=v;break}v=a+4|0;if((b[v>>0]|0)!=(b[i+5>>0]|0)){w=v;break}v=a+5|0;if((b[v>>0]|0)!=(b[i+6>>0]|0)){w=v;break}v=a+6|0;if((b[v>>0]|0)!=(b[i+7>>0]|0)){w=v;break}v=a+7|0;a=i;i=i+8|0;if((b[v>>0]|0)!=(b[i>>0]|0)){w=v;break}d=d+8|0;v=h+d|0;if(!((d|0)<258?(b[v>>0]|0)==(b[a+9>>0]|0):0)){w=v;break}}d=w-q|0;i=d+258|0;if((i|0)>(c|0)){f[k>>2]=t;if((i|0)>=(o|0)){x=i;y=19;break}z=b[h+i>>0]|0;A=b[h+(d+257)>>0]|0;B=i}else{z=r;A=s;B=c}}else{z=r;A=s;B=c}t=j[l+((t&g)<<1)>>1]|0;if(t>>>0<=m>>>0){x=B;y=19;break}u=u+-1|0;if(!u){x=B;y=19;break}else{r=z;s=A;c=B}}if((y|0)==19)return (x>>>0>n>>>0?n:x)|0;return 0}function XHc(a){a=a|0;var b=0,c=0,e=0;b=RHc(a)|0;if(b|0)return b|0;c=f[a+28>>2]|0;f[c+60>>2]=f[c+44>>2]<<1;a=f[c+68>>2]|0;e=(f[c+76>>2]|0)+-1|0;d[a+(e<<1)>>1]=0;g1c(a|0,0,e<<1|0)|0;e=f[c+132>>2]|0;f[c+128>>2]=j[183488+(e*12|0)+2>>1];f[c+140>>2]=j[183488+(e*12|0)>>1];f[c+144>>2]=j[183488+(e*12|0)+4>>1];f[c+124>>2]=j[183488+(e*12|0)+6>>1];f[c+108>>2]=0;f[c+92>>2]=0;f[c+116>>2]=0;f[c+5812>>2]=0;f[c+120>>2]=2;f[c+96>>2]=2;f[c+104>>2]=0;f[c+72>>2]=0;return b|0}function YHc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;if(!a){e=-2;return e|0}if(!(f[a+32>>2]|0)){e=-2;return e|0}if(!(f[a+36>>2]|0)){e=-2;return e|0}g=a+28|0;i=f[g>>2]|0;if(!i){e=-2;return e|0}if((f[i>>2]|0)!=(a|0)){e=-2;return e|0}j=i+4|0;k=f[j>>2]|0;switch(k|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{e=-2;return e|0}}if(c>>>0>5){e=-2;return e|0}l=a+12|0;do if(f[l>>2]|0){m=a+4|0;n=(f[m>>2]|0)==0;if(!n?(f[a>>2]|0)==0:0)break;o=(c|0)!=4;if(!(o&(k|0)==666)){p=a+16|0;if(!(f[p>>2]|0)){f[a+24>>2]=f[43821];e=-5;return e|0}q=i+40|0;r=f[q>>2]|0;f[q>>2]=c;s=i+20|0;do if(!(f[s>>2]|0))if(n?o&((c<<1)-((c|0)>4?9:0)|0)<=((r<<1)-((r|0)>4?9:0)|0):0){f[a+24>>2]=f[43821];e=-5;return e|0}else{t=0;u=k}else{aIc(i);v=f[s>>2]|0;w=f[p>>2]|0;x=v>>>0>w>>>0?w:v;if(x){y=i+16|0;o1c(f[l>>2]|0,f[y>>2]|0,x|0)|0;f[l>>2]=(f[l>>2]|0)+x;f[y>>2]=(f[y>>2]|0)+x;z=a+20|0;f[z>>2]=(f[z>>2]|0)+x;z=(f[p>>2]|0)-x|0;f[p>>2]=z;A=(f[s>>2]|0)-x|0;f[s>>2]=A;if(!A){f[y>>2]=f[i+8>>2];B=0;C=z}else{B=A;C=z}}else{B=v;C=w}if(C|0){t=B;u=f[j>>2]|0;break}f[q>>2]=-1;e=0;return e|0}while(0);a:do switch(u|0){case 666:{if(!(f[m>>2]|0))D=123;else{f[a+24>>2]=f[43821];e=-5;return e|0}break}case 42:{r=(f[i+48>>2]<<12)+-30720|0;if((f[i+136>>2]|0)<=1?(n=f[i+132>>2]|0,(n|0)>=2):0)E=(n|0)<6?64:(n|0)==6?128:192;else E=0;n=E|r;r=i+108|0;w=(f[r>>2]|0)==0?n:n|32;n=(((w>>>0)%31|0)^31)+w|0;w=i+8|0;v=f[w>>2]|0;f[s>>2]=t+1;b[v+t>>0]=n>>>8;v=f[w>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[v+z>>0]=n;n=a+48|0;if(f[r>>2]|0){r=f[n>>2]|0;z=f[w>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=r>>>24;v=f[w>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[v+z>>0]=r>>>16;r=f[n>>2]|0;z=f[w>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=r>>>8;v=f[w>>2]|0;w=f[s>>2]|0;f[s>>2]=w+1;b[v+w>>0]=r}r=MHc(0,0,0)|0;f[n>>2]=r;f[j>>2]=113;r=f[g>>2]|0;aIc(r);n=r+20|0;w=f[n>>2]|0;v=f[p>>2]|0;z=w>>>0>v>>>0?v:w;if(z|0?(w=r+16|0,o1c(f[l>>2]|0,f[w>>2]|0,z|0)|0,f[l>>2]=(f[l>>2]|0)+z,f[w>>2]=(f[w>>2]|0)+z,v=a+20|0,f[v>>2]=(f[v>>2]|0)+z,f[p>>2]=(f[p>>2]|0)-z,v=(f[n>>2]|0)-z|0,f[n>>2]=v,(v|0)==0):0)f[w>>2]=f[r+8>>2];if(!(f[s>>2]|0)){F=f[j>>2]|0;D=39;break a}f[q>>2]=-1;e=0;return e|0}default:{F=u;D=39}}while(0);if((D|0)==39){do if((F|0)==57){r=OHc(0,0,0)|0;w=a+48|0;f[w>>2]=r;r=i+8|0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=31;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=-117;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=8;n=i+28|0;v=f[n>>2]|0;if(v|0){z=((f[v+44>>2]|0?2:0)|(f[v>>2]|0)!=0|((f[v+16>>2]|0)==0?0:4)|((f[v+28>>2]|0)==0?0:8)|((f[v+36>>2]|0)==0?0:16))&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=f[(f[n>>2]|0)+4>>2]&255;A=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>8&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>16&255;A=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>24&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=f[i+132>>2]|0;if((z|0)==9)G=2;else G=((z|0)<2?1:(f[i+136>>2]|0)>1)?4:0;z=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[z+A>>0]=G;A=f[(f[n>>2]|0)+12>>2]&255;z=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=A;A=f[n>>2]|0;if(!(f[A+16>>2]|0))H=A;else{v=f[A+20>>2]&255;A=f[r>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[A+z>>0]=v;v=(f[(f[n>>2]|0)+20>>2]|0)>>>8&255;z=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[z+A>>0]=v;H=f[n>>2]|0}if(f[H+44>>2]|0){v=OHc(f[w>>2]|0,f[r>>2]|0,f[s>>2]|0)|0;f[w>>2]=v}f[i+32>>2]=0;f[j>>2]=69;I=n;D=59;break}n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=0;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=0;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[i+132>>2]|0;if((v|0)==9)J=2;else J=((v|0)<2?1:(f[i+136>>2]|0)>1)?4:0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=J;n=f[r>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[n+r>>0]=3;f[j>>2]=113;r=f[g>>2]|0;aIc(r);n=r+20|0;v=f[n>>2]|0;w=f[p>>2]|0;A=v>>>0>w>>>0?w:v;if(A|0?(v=r+16|0,o1c(f[l>>2]|0,f[v>>2]|0,A|0)|0,f[l>>2]=(f[l>>2]|0)+A,f[v>>2]=(f[v>>2]|0)+A,w=a+20|0,f[w>>2]=(f[w>>2]|0)+A,f[p>>2]=(f[p>>2]|0)-A,w=(f[n>>2]|0)-A|0,f[n>>2]=w,(w|0)==0):0)f[v>>2]=f[r+8>>2];if(!(f[s>>2]|0)){K=f[j>>2]|0;D=56;break}f[q>>2]=-1;e=0;return e|0}else{K=F;D=56}while(0);b:do if((D|0)==56)switch(K|0){case 69:{I=i+28|0;D=59;break b;break}case 73:{L=i+28|0;D=74;break b;break}case 91:{M=i+28|0;D=93;break b;break}case 103:{N=i+28|0;D=109;break b;break}default:break b}while(0);if((D|0)==59){r=f[I>>2]|0;v=f[r+16>>2]|0;if(v|0){w=f[s>>2]|0;n=i+32|0;A=f[n>>2]|0;z=(f[r+20>>2]&65535)-A|0;r=i+12|0;y=f[r>>2]|0;x=i+8|0;c:do if((w+z|0)>>>0>y>>>0){O=a+48|0;P=a+20|0;Q=z;R=w;S=y;T=v;U=A;while(1){V=S-R|0;o1c((f[x>>2]|0)+R|0,T+U|0,V|0)|0;W=f[r>>2]|0;f[s>>2]=W;if(W>>>0>R>>>0?(f[(f[I>>2]|0)+44>>2]|0)!=0:0){X=OHc(f[O>>2]|0,(f[x>>2]|0)+R|0,W-R|0)|0;f[O>>2]=X}f[n>>2]=(f[n>>2]|0)+V;X=f[g>>2]|0;aIc(X);W=X+20|0;Y=f[W>>2]|0;Z=f[p>>2]|0;_=Y>>>0>Z>>>0?Z:Y;do if(_|0){Y=X+16|0;o1c(f[l>>2]|0,f[Y>>2]|0,_|0)|0;f[l>>2]=(f[l>>2]|0)+_;f[Y>>2]=(f[Y>>2]|0)+_;f[P>>2]=(f[P>>2]|0)+_;f[p>>2]=(f[p>>2]|0)-_;Z=(f[W>>2]|0)-_|0;f[W>>2]=Z;if(Z|0)break;f[Y>>2]=f[X+8>>2]}while(0);if(f[s>>2]|0)break;X=Q-V|0;S=f[r>>2]|0;W=f[(f[I>>2]|0)+16>>2]|0;_=f[n>>2]|0;if(X>>>0<=S>>>0){$=X;aa=0;ba=W;ca=_;break c}else{Q=X;R=0;T=W;U=_}}f[q>>2]=-1;e=0;return e|0}else{$=z;aa=w;ba=v;ca=A}while(0);o1c((f[x>>2]|0)+aa|0,ba+ca|0,$|0)|0;A=(f[s>>2]|0)+$|0;f[s>>2]=A;if(A>>>0>aa>>>0?(f[(f[I>>2]|0)+44>>2]|0)!=0:0){v=a+48|0;w=OHc(f[v>>2]|0,(f[x>>2]|0)+aa|0,A-aa|0)|0;f[v>>2]=w}f[n>>2]=0}f[j>>2]=73;L=I;D=74}if((D|0)==74){if(f[(f[L>>2]|0)+28>>2]|0){w=f[s>>2]|0;v=i+12|0;A=a+48|0;z=i+8|0;r=a+20|0;y=i+32|0;U=w;T=w;while(1){if((T|0)==(f[v>>2]|0)){if(T>>>0>U>>>0?(f[(f[L>>2]|0)+44>>2]|0)!=0:0){w=OHc(f[A>>2]|0,(f[z>>2]|0)+U|0,T-U|0)|0;f[A>>2]=w}w=f[g>>2]|0;aIc(w);R=w+20|0;Q=f[R>>2]|0;S=f[p>>2]|0;P=Q>>>0>S>>>0?S:Q;do if(P|0){Q=w+16|0;o1c(f[l>>2]|0,f[Q>>2]|0,P|0)|0;f[l>>2]=(f[l>>2]|0)+P;f[Q>>2]=(f[Q>>2]|0)+P;f[r>>2]=(f[r>>2]|0)+P;f[p>>2]=(f[p>>2]|0)-P;S=(f[R>>2]|0)-P|0;f[R>>2]=S;if(S|0)break;f[Q>>2]=f[w+8>>2]}while(0);if(!(f[s>>2]|0)){da=0;ea=0}else{D=83;break}}else{da=U;ea=T}w=f[(f[L>>2]|0)+28>>2]|0;R=f[y>>2]|0;f[y>>2]=R+1;P=b[w+R>>0]|0;R=f[z>>2]|0;f[s>>2]=ea+1;b[R+ea>>0]=P;if(!(P<<24>>24))break;U=da;T=f[s>>2]|0}if((D|0)==83){f[q>>2]=-1;e=0;return e|0}if(f[(f[L>>2]|0)+44>>2]|0?(T=f[s>>2]|0,T>>>0>da>>>0):0){U=OHc(f[A>>2]|0,(f[z>>2]|0)+da|0,T-da|0)|0;f[A>>2]=U}f[y>>2]=0}f[j>>2]=91;M=L;D=93}if((D|0)==93){if(f[(f[M>>2]|0)+36>>2]|0){U=f[s>>2]|0;T=i+12|0;r=a+48|0;v=i+8|0;n=a+20|0;x=i+32|0;P=U;R=U;while(1){if((R|0)==(f[T>>2]|0)){if(R>>>0>P>>>0?(f[(f[M>>2]|0)+44>>2]|0)!=0:0){U=OHc(f[r>>2]|0,(f[v>>2]|0)+P|0,R-P|0)|0;f[r>>2]=U}U=f[g>>2]|0;aIc(U);w=U+20|0;Q=f[w>>2]|0;S=f[p>>2]|0;O=Q>>>0>S>>>0?S:Q;do if(O|0){Q=U+16|0;o1c(f[l>>2]|0,f[Q>>2]|0,O|0)|0;f[l>>2]=(f[l>>2]|0)+O;f[Q>>2]=(f[Q>>2]|0)+O;f[n>>2]=(f[n>>2]|0)+O;f[p>>2]=(f[p>>2]|0)-O;S=(f[w>>2]|0)-O|0;f[w>>2]=S;if(S|0)break;f[Q>>2]=f[U+8>>2]}while(0);if(!(f[s>>2]|0)){fa=0;ga=0}else{D=102;break}}else{fa=P;ga=R}U=f[(f[M>>2]|0)+36>>2]|0;w=f[x>>2]|0;f[x>>2]=w+1;O=b[U+w>>0]|0;w=f[v>>2]|0;f[s>>2]=ga+1;b[w+ga>>0]=O;if(!(O<<24>>24))break;P=fa;R=f[s>>2]|0}if((D|0)==102){f[q>>2]=-1;e=0;return e|0}if(f[(f[M>>2]|0)+44>>2]|0?(R=f[s>>2]|0,R>>>0>fa>>>0):0){P=OHc(f[r>>2]|0,(f[v>>2]|0)+fa|0,R-fa|0)|0;f[r>>2]=P}}f[j>>2]=103;N=M;D=109}if((D|0)==109){if(f[(f[N>>2]|0)+44>>2]|0){P=f[s>>2]|0;do if((P+2|0)>>>0>(f[i+12>>2]|0)>>>0){R=f[g>>2]|0;aIc(R);x=R+20|0;n=f[x>>2]|0;T=f[p>>2]|0;y=n>>>0>T>>>0?T:n;do if(y|0){n=R+16|0;o1c(f[l>>2]|0,f[n>>2]|0,y|0)|0;f[l>>2]=(f[l>>2]|0)+y;f[n>>2]=(f[n>>2]|0)+y;T=a+20|0;f[T>>2]=(f[T>>2]|0)+y;f[p>>2]=(f[p>>2]|0)-y;T=(f[x>>2]|0)-y|0;f[x>>2]=T;if(T|0)break;f[n>>2]=f[R+8>>2]}while(0);if(!(f[s>>2]|0)){ha=0;break}f[q>>2]=-1;e=0;return e|0}else ha=P;while(0);P=a+48|0;r=f[P>>2]&255;v=i+8|0;R=f[v>>2]|0;f[s>>2]=ha+1;b[R+ha>>0]=r;r=(f[P>>2]|0)>>>8&255;R=f[v>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[R+v>>0]=r;r=OHc(0,0,0)|0;f[P>>2]=r}f[j>>2]=113;r=f[g>>2]|0;aIc(r);P=r+20|0;v=f[P>>2]|0;R=f[p>>2]|0;x=v>>>0>R>>>0?R:v;if(x|0?(v=r+16|0,o1c(f[l>>2]|0,f[v>>2]|0,x|0)|0,f[l>>2]=(f[l>>2]|0)+x,f[v>>2]=(f[v>>2]|0)+x,R=a+20|0,f[R>>2]=(f[R>>2]|0)+x,f[p>>2]=(f[p>>2]|0)-x,R=(f[P>>2]|0)-x|0,f[P>>2]=R,(R|0)==0):0)f[v>>2]=f[r+8>>2];if(f[s>>2]|0){f[q>>2]=-1;e=0;return e|0}}if(!(f[m>>2]|0))D=123;else D=126}if((D|0)==123)if(!(f[i+116>>2]|0)){if(c|0?(f[j>>2]|0)!=666:0)D=126}else D=126;do if((D|0)==126){r=f[i+132>>2]|0;d:do if(!r){ia=SHc(i,c)|0;D=200}else switch(f[i+136>>2]|0){case 2:{v=i+116|0;R=i+96|0;P=i+56|0;x=i+108|0;y=i+5796|0;n=i+5792|0;T=i+5784|0;A=i+5788|0;z=i+92|0;while(1){if((f[v>>2]|0)==0?(VHc(i),(f[v>>2]|0)==0):0)break;f[R>>2]=0;O=b[(f[P>>2]|0)+(f[x>>2]|0)>>0]|0;w=f[n>>2]|0;d[(f[y>>2]|0)+(w<<1)>>1]=0;U=f[T>>2]|0;f[n>>2]=w+1;b[U+w>>0]=O;w=i+148+((O&255)<<2)|0;d[w>>1]=(d[w>>1]|0)+1<<16>>16;w=(f[n>>2]|0)==((f[A>>2]|0)+-1|0);f[v>>2]=(f[v>>2]|0)+-1;O=(f[x>>2]|0)+1|0;f[x>>2]=O;if(!w)continue;w=f[z>>2]|0;if((w|0)>-1)ja=(f[P>>2]|0)+w|0;else ja=0;cIc(i,ja,O-w|0,0);f[z>>2]=f[x>>2];w=f[i>>2]|0;O=f[w+28>>2]|0;aIc(O);U=O+20|0;Q=f[U>>2]|0;S=w+16|0;_=f[S>>2]|0;W=Q>>>0>_>>>0?_:Q;do if(W|0){Q=w+12|0;_=O+16|0;o1c(f[Q>>2]|0,f[_>>2]|0,W|0)|0;f[Q>>2]=(f[Q>>2]|0)+W;f[_>>2]=(f[_>>2]|0)+W;Q=w+20|0;f[Q>>2]=(f[Q>>2]|0)+W;f[S>>2]=(f[S>>2]|0)-W;Q=(f[U>>2]|0)-W|0;f[U>>2]=Q;if(Q|0)break;f[_>>2]=f[O+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}}if(!c){D=203;break d}f[i+5812>>2]=0;if((c|0)==4){v=f[z>>2]|0;if((v|0)>-1)ka=(f[P>>2]|0)+v|0;else ka=0;cIc(i,ka,(f[x>>2]|0)-v|0,1);f[z>>2]=f[x>>2];v=f[i>>2]|0;A=f[v+28>>2]|0;aIc(A);T=A+20|0;y=f[T>>2]|0;R=v+16|0;V=f[R>>2]|0;O=y>>>0>V>>>0?V:y;do if(O|0){y=v+12|0;V=A+16|0;o1c(f[y>>2]|0,f[V>>2]|0,O|0)|0;f[y>>2]=(f[y>>2]|0)+O;f[V>>2]=(f[V>>2]|0)+O;y=v+20|0;f[y>>2]=(f[y>>2]|0)+O;f[R>>2]=(f[R>>2]|0)-O;y=(f[T>>2]|0)-O|0;f[T>>2]=y;if(y|0)break;f[V>>2]=f[A+8>>2]}while(0);ia=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;D=200;break d}if(!(f[n>>2]|0))break d;A=f[z>>2]|0;if((A|0)>-1)la=(f[P>>2]|0)+A|0;else la=0;cIc(i,la,(f[x>>2]|0)-A|0,0);f[z>>2]=f[x>>2];A=f[i>>2]|0;T=f[A+28>>2]|0;aIc(T);O=T+20|0;R=f[O>>2]|0;v=A+16|0;V=f[v>>2]|0;y=R>>>0>V>>>0?V:R;do if(y|0){R=A+12|0;V=T+16|0;o1c(f[R>>2]|0,f[V>>2]|0,y|0)|0;f[R>>2]=(f[R>>2]|0)+y;f[V>>2]=(f[V>>2]|0)+y;R=A+20|0;f[R>>2]=(f[R>>2]|0)+y;f[v>>2]=(f[v>>2]|0)-y;R=(f[O>>2]|0)-y|0;f[O>>2]=R;if(R|0)break;f[V>>2]=f[T+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}else break d;break}case 3:{T=i+116|0;O=(c|0)==0;y=i+96|0;v=i+108|0;A=i+5784|0;x=i+5796|0;z=i+5792|0;P=i+5788|0;n=i+56|0;V=i+92|0;e:while(1){R=f[T>>2]|0;do if(R>>>0<259){VHc(i);U=f[T>>2]|0;if(O&U>>>0<259){D=203;break d}if(!U)break e;f[y>>2]=0;if(U>>>0>2){ma=U;D=161;break}na=f[v>>2]|0;oa=f[x>>2]|0;pa=f[A>>2]|0;D=177}else{f[y>>2]=0;ma=R;D=161}while(0);f:do if((D|0)==161){D=0;R=f[v>>2]|0;do if(R|0){U=(f[n>>2]|0)+R|0;W=b[U+-1>>0]|0;if(W<<24>>24!=(b[U>>0]|0))break;S=U+1|0;if(W<<24>>24!=(b[S>>0]|0))break;if(W<<24>>24!=(b[S+1>>0]|0))break;S=U+258|0;w=1;while(1){_=U+w|0;Q=_+2|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+3|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+4|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+5|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+6|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+7|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=w;w=w+8|0;_=U+w|0;if(W<<24>>24!=(b[_>>0]|0)){qa=_;break}_=Q+9|0;Q=U+_|0;if(!((_|0)<258?W<<24>>24==(b[Q>>0]|0):0)){qa=Q;break}}W=qa-S+258|0;U=W>>>0>ma>>>0?ma:W;f[y>>2]=U;W=f[A>>2]|0;w=f[x>>2]|0;if(U>>>0<=2){na=R;oa=w;pa=W;D=177;break f}Q=U+253|0;U=f[z>>2]|0;d[w+(U<<1)>>1]=1;f[z>>2]=U+1;b[W+U>>0]=Q;U=i+148+((h[520221+(Q&255)>>0]|256)+1<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=i+2440+(h[519709]<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=(f[z>>2]|0)==((f[P>>2]|0)+-1|0)&1;Q=f[y>>2]|0;f[T>>2]=(f[T>>2]|0)-Q;W=(f[v>>2]|0)+Q|0;f[v>>2]=W;f[y>>2]=0;ra=U;sa=W;break f}while(0);na=R;oa=f[x>>2]|0;pa=f[A>>2]|0;D=177}while(0);if((D|0)==177){D=0;W=b[(f[n>>2]|0)+na>>0]|0;U=f[z>>2]|0;d[oa+(U<<1)>>1]=0;f[z>>2]=U+1;b[pa+U>>0]=W;U=i+148+((W&255)<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=(f[z>>2]|0)==((f[P>>2]|0)+-1|0)&1;f[T>>2]=(f[T>>2]|0)+-1;W=(f[v>>2]|0)+1|0;f[v>>2]=W;ra=U;sa=W}if(!ra)continue;W=f[V>>2]|0;if((W|0)>-1)ta=(f[n>>2]|0)+W|0;else ta=0;cIc(i,ta,sa-W|0,0);f[V>>2]=f[v>>2];W=f[i>>2]|0;U=f[W+28>>2]|0;aIc(U);Q=U+20|0;w=f[Q>>2]|0;_=W+16|0;X=f[_>>2]|0;Y=w>>>0>X>>>0?X:w;do if(Y|0){w=W+12|0;X=U+16|0;o1c(f[w>>2]|0,f[X>>2]|0,Y|0)|0;f[w>>2]=(f[w>>2]|0)+Y;f[X>>2]=(f[X>>2]|0)+Y;w=W+20|0;f[w>>2]=(f[w>>2]|0)+Y;f[_>>2]=(f[_>>2]|0)-Y;w=(f[Q>>2]|0)-Y|0;f[Q>>2]=w;if(w|0)break;f[X>>2]=f[U+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}}f[i+5812>>2]=0;if((c|0)==4){T=f[V>>2]|0;if((T|0)>-1)ua=(f[n>>2]|0)+T|0;else ua=0;cIc(i,ua,(f[v>>2]|0)-T|0,1);f[V>>2]=f[v>>2];T=f[i>>2]|0;P=f[T+28>>2]|0;aIc(P);A=P+20|0;x=f[A>>2]|0;y=T+16|0;O=f[y>>2]|0;U=x>>>0>O>>>0?O:x;do if(U|0){x=T+12|0;O=P+16|0;o1c(f[x>>2]|0,f[O>>2]|0,U|0)|0;f[x>>2]=(f[x>>2]|0)+U;f[O>>2]=(f[O>>2]|0)+U;x=T+20|0;f[x>>2]=(f[x>>2]|0)+U;f[y>>2]=(f[y>>2]|0)-U;x=(f[A>>2]|0)-U|0;f[A>>2]=x;if(x|0)break;f[O>>2]=f[P+8>>2]}while(0);ia=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;D=200;break d}if(!(f[z>>2]|0))break d;P=f[V>>2]|0;if((P|0)>-1)va=(f[n>>2]|0)+P|0;else va=0;cIc(i,va,(f[v>>2]|0)-P|0,0);f[V>>2]=f[v>>2];P=f[i>>2]|0;A=f[P+28>>2]|0;aIc(A);U=A+20|0;y=f[U>>2]|0;T=P+16|0;O=f[T>>2]|0;x=y>>>0>O>>>0?O:y;do if(x|0){y=P+12|0;O=A+16|0;o1c(f[y>>2]|0,f[O>>2]|0,x|0)|0;f[y>>2]=(f[y>>2]|0)+x;f[O>>2]=(f[O>>2]|0)+x;y=P+20|0;f[y>>2]=(f[y>>2]|0)+x;f[T>>2]=(f[T>>2]|0)-x;y=(f[U>>2]|0)-x|0;f[U>>2]=y;if(y|0)break;f[O>>2]=f[A+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}else break d;break}default:{ia=Mi[f[183488+(r*12|0)+8>>2]&1023](i,c)|0;D=200;break d}}while(0);if((D|0)==200){if((ia|1|0)==3)f[j>>2]=666;if((ia|2|0)!=2){if((ia|0)!=1)break}else D=203}if((D|0)==203){if(f[p>>2]|0){e=0;return e|0}f[q>>2]=-1;e=0;return e|0}switch(c|0){case 1:{bIc(i);break}case 5:break;default:{$Hc(i,0,0,0);if((c|0)==3?(r=f[i+68>>2]|0,A=(f[i+76>>2]|0)+-1|0,d[r+(A<<1)>>1]=0,g1c(r|0,0,A<<1|0)|0,(f[i+116>>2]|0)==0):0){f[i+108>>2]=0;f[i+92>>2]=0;f[i+5812>>2]=0}}}A=f[g>>2]|0;aIc(A);r=A+20|0;U=f[r>>2]|0;x=f[p>>2]|0;T=U>>>0>x>>>0?x:U;if(T){U=A+16|0;o1c(f[l>>2]|0,f[U>>2]|0,T|0)|0;f[l>>2]=(f[l>>2]|0)+T;f[U>>2]=(f[U>>2]|0)+T;P=a+20|0;f[P>>2]=(f[P>>2]|0)+T;P=(f[p>>2]|0)-T|0;f[p>>2]=P;v=(f[r>>2]|0)-T|0;f[r>>2]=v;if(!v){f[U>>2]=f[A+8>>2];wa=P}else wa=P}else wa=x;if(!wa){f[q>>2]=-1;e=0;return e|0}}while(0);if(o){e=0;return e|0}q=i+24|0;m=f[q>>2]|0;if((m|0)<1){e=1;return e|0}x=a+48|0;P=f[x>>2]|0;if((m|0)==2){m=i+8|0;A=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[A+U>>0]=P;U=(f[x>>2]|0)>>>8&255;A=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=U;U=(f[x>>2]|0)>>>16&255;v=f[m>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=U;U=(f[x>>2]|0)>>>24&255;A=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=U;U=a+8|0;v=f[U>>2]&255;A=f[m>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[A+r>>0]=v;v=(f[U>>2]|0)>>>8&255;r=f[m>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[r+A>>0]=v;v=(f[U>>2]|0)>>>16&255;A=f[m>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[A+r>>0]=v;v=(f[U>>2]|0)>>>24;U=f[m>>2]|0;m=f[s>>2]|0;f[s>>2]=m+1;xa=v;ya=U+m|0}else{m=i+8|0;U=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[U+v>>0]=P>>>24;v=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[v+U>>0]=P>>>16;P=f[x>>2]|0;x=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[x+U>>0]=P>>>8;U=f[m>>2]|0;m=f[s>>2]|0;f[s>>2]=m+1;xa=P;ya=U+m|0}b[ya>>0]=xa;m=f[g>>2]|0;aIc(m);U=m+20|0;P=f[U>>2]|0;x=f[p>>2]|0;v=P>>>0>x>>>0?x:P;if(v|0?(P=m+16|0,o1c(f[l>>2]|0,f[P>>2]|0,v|0)|0,f[l>>2]=(f[l>>2]|0)+v,f[P>>2]=(f[P>>2]|0)+v,x=a+20|0,f[x>>2]=(f[x>>2]|0)+v,f[p>>2]=(f[p>>2]|0)-v,x=(f[U>>2]|0)-v|0,f[U>>2]=x,(x|0)==0):0)f[P>>2]=f[m+8>>2];m=f[q>>2]|0;if((m|0)>0)f[q>>2]=0-m;e=(f[s>>2]|0)==0&1;return e|0}}while(0);f[a+24>>2]=f[43818];e=-2;return e|0}function ZHc(a){a=a|0;f[a+2840>>2]=a+148;f[a+2848>>2]=183608;f[a+2852>>2]=a+2440;f[a+2860>>2]=183628;f[a+2864>>2]=a+2684;f[a+2872>>2]=183648;d[a+5816>>1]=0;f[a+5820>>2]=0;_Hc(a);return}function _Hc(a){a=a|0;var b=0;b=0;do{d[a+148+(b<<2)>>1]=0;b=b+1|0}while((b|0)!=286);d[a+2440>>1]=0;d[a+2444>>1]=0;d[a+2448>>1]=0;d[a+2452>>1]=0;d[a+2456>>1]=0;d[a+2460>>1]=0;d[a+2464>>1]=0;d[a+2468>>1]=0;d[a+2472>>1]=0;d[a+2476>>1]=0;d[a+2480>>1]=0;d[a+2484>>1]=0;d[a+2488>>1]=0;d[a+2492>>1]=0;d[a+2496>>1]=0;d[a+2500>>1]=0;d[a+2504>>1]=0;d[a+2508>>1]=0;d[a+2512>>1]=0;d[a+2516>>1]=0;d[a+2520>>1]=0;d[a+2524>>1]=0;d[a+2528>>1]=0;d[a+2532>>1]=0;d[a+2536>>1]=0;d[a+2540>>1]=0;d[a+2544>>1]=0;d[a+2548>>1]=0;d[a+2552>>1]=0;d[a+2556>>1]=0;d[a+2684>>1]=0;d[a+2688>>1]=0;d[a+2692>>1]=0;d[a+2696>>1]=0;d[a+2700>>1]=0;d[a+2704>>1]=0;d[a+2708>>1]=0;d[a+2712>>1]=0;d[a+2716>>1]=0;d[a+2720>>1]=0;d[a+2724>>1]=0;d[a+2728>>1]=0;d[a+2732>>1]=0;d[a+2736>>1]=0;d[a+2740>>1]=0;d[a+2744>>1]=0;d[a+2748>>1]=0;d[a+2752>>1]=0;d[a+2756>>1]=0;d[a+1172>>1]=1;f[a+5804>>2]=0;f[a+5800>>2]=0;f[a+5808>>2]=0;f[a+5792>>2]=0;return}function $Hc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=a+5820|0;i=f[h>>2]|0;k=g&65535;g=a+5816|0;l=j[g>>1]|0|k<<i;d[g>>1]=l;if((i|0)>13){m=a+8|0;n=f[m>>2]|0;o=a+20|0;p=f[o>>2]|0;f[o>>2]=p+1;b[n+p>>0]=l;p=(j[g>>1]|0)>>>8&255;n=f[m>>2]|0;m=f[o>>2]|0;f[o>>2]=m+1;b[n+m>>0]=p;p=f[h>>2]|0;m=k>>>(16-p|0);d[g>>1]=m;q=m;r=p+-13|0}else{q=l;r=i+3|0}i=q&255;f[h>>2]=r;if((r|0)<=8){if((r|0)>0){r=f[a+8>>2]|0;q=a+20|0;l=f[q>>2]|0;f[q>>2]=l+1;s=i;t=r+l|0;u=8}}else{l=a+8|0;r=f[l>>2]|0;q=a+20|0;p=f[q>>2]|0;f[q>>2]=p+1;b[r+p>>0]=i;i=(j[g>>1]|0)>>>8&255;p=f[l>>2]|0;l=f[q>>2]|0;f[q>>2]=l+1;s=i;t=p+l|0;u=8}if((u|0)==8)b[t>>0]=s;d[g>>1]=0;f[h>>2]=0;h=a+8|0;g=f[h>>2]|0;s=a+20|0;a=f[s>>2]|0;f[s>>2]=a+1;b[g+a>>0]=e;a=f[h>>2]|0;g=f[s>>2]|0;f[s>>2]=g+1;b[a+g>>0]=e>>>8;g=e&65535^65535;a=f[h>>2]|0;t=f[s>>2]|0;f[s>>2]=t+1;b[a+t>>0]=g;t=f[h>>2]|0;a=f[s>>2]|0;f[s>>2]=a+1;b[t+a>>0]=g>>>8;o1c((f[h>>2]|0)+(f[s>>2]|0)|0,c|0,e|0)|0;f[s>>2]=(f[s>>2]|0)+e;return}function aIc(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;c=a+5820|0;e=f[c>>2]|0;do if((e|0)!=16)if((e|0)>7){g=a+5816|0;h=d[g>>1]&255;i=f[a+8>>2]|0;k=a+20|0;l=f[k>>2]|0;f[k>>2]=l+1;b[i+l>>0]=h;d[g>>1]=(j[g>>1]|0)>>>8;m=(f[c>>2]|0)+-8|0;break}else return;else{g=a+5816|0;h=d[g>>1]&255;l=a+8|0;i=f[l>>2]|0;k=a+20|0;n=f[k>>2]|0;f[k>>2]=n+1;b[i+n>>0]=h;h=(j[g>>1]|0)>>>8&255;n=f[l>>2]|0;l=f[k>>2]|0;f[k>>2]=l+1;b[n+l>>0]=h;d[g>>1]=0;m=0}while(0);f[c>>2]=m;return}function bIc(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+5820|0;e=f[c>>2]|0;g=a+5816|0;h=j[g>>1]|0|2<<e;d[g>>1]=h;if((e|0)>13){i=a+8|0;k=f[i>>2]|0;l=a+20|0;m=f[l>>2]|0;f[l>>2]=m+1;b[k+m>>0]=h;m=(j[g>>1]|0)>>>8&255;k=f[i>>2]|0;i=f[l>>2]|0;f[l>>2]=i+1;b[k+i>>0]=m;m=f[c>>2]|0;i=2>>>(16-m|0);d[g>>1]=i;n=i;o=m+-13|0}else{n=h;o=e+3|0}e=n&255;f[c>>2]=o;if((o|0)>9){n=a+8|0;h=f[n>>2]|0;m=a+20|0;i=f[m>>2]|0;f[m>>2]=i+1;b[h+i>>0]=e;i=(j[g>>1]|0)>>>8&255;h=f[n>>2]|0;n=f[m>>2]|0;f[m>>2]=n+1;b[h+n>>0]=i;i=f[c>>2]|0;d[g>>1]=0;p=0;q=i+-9|0}else{p=e;q=o+7|0}f[c>>2]=q;do if((q|0)!=16)if((q|0)>7){o=f[a+8>>2]|0;e=a+20|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=p;d[g>>1]=(j[g>>1]|0)>>>8;r=(f[c>>2]|0)+-8|0;break}else return;else{i=a+8|0;o=f[i>>2]|0;e=a+20|0;n=f[e>>2]|0;f[e>>2]=n+1;b[o+n>>0]=p;n=(j[g>>1]|0)>>>8&255;o=f[i>>2]|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=n;d[g>>1]=0;r=0}while(0);f[c>>2]=r;return}function cIc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;if((f[a+132>>2]|0)>0){i=(f[a>>2]|0)+44|0;if((f[i>>2]|0)==2){k=-201342849;l=0;while(1){if(k&1|0?d[a+148+(l<<2)>>1]|0:0){m=0;break}l=l+1|0;if((l|0)>=32){n=6;break}else k=k>>>1}a:do if((n|0)==6)if(((d[a+184>>1]|0)==0?(d[a+188>>1]|0)==0:0)?(d[a+200>>1]|0)==0:0){k=32;while(1){if(d[a+148+(k<<2)>>1]|0){m=1;break a}k=k+1|0;if((k|0)>=256){m=0;break}}}else m=1;while(0);f[i>>2]=m}dIc(a,a+2840|0);dIc(a,a+2852|0);m=f[a+2844>>2]|0;i=d[a+150>>1]|0;k=i<<16>>16==0;d[a+148+(m+1<<2)+2>>1]=-1;l=a+2756|0;o=a+2752|0;p=a+2748|0;q=i&65535;i=0;r=-1;s=k?3:4;t=k?138:7;b:while(1){k=0;u=i;do{if((u|0)>(m|0))break b;u=u+1|0;v=d[a+148+(u<<2)+2>>1]|0;w=v&65535;k=k+1|0;x=(q|0)==(w|0)}while((k|0)<(t|0)&x);if((k|0)<(s|0)){y=a+2684+(q<<2)|0;d[y>>1]=(j[y>>1]|0)+k}else{if(q){y=a+2684+(q<<2)|0;if((q|0)==(r|0))z=p;else{d[y>>1]=(d[y>>1]|0)+1<<16>>16;z=p}}else z=(k|0)<11?o:l;d[z>>1]=(d[z>>1]|0)+1<<16>>16}y=v<<16>>16==0;A=q;q=w;i=u;s=y|x?3:4;t=y?138:x?6:7;r=A}r=f[a+2856>>2]|0;x=d[a+2442>>1]|0;t=x<<16>>16==0;d[a+2440+(r+1<<2)+2>>1]=-1;s=x&65535;x=0;i=-1;w=t?3:4;q=t?138:7;c:while(1){t=0;v=x;do{if((v|0)>(r|0))break c;v=v+1|0;B=d[a+2440+(v<<2)+2>>1]|0;C=B&65535;t=t+1|0;D=(s|0)==(C|0)}while((t|0)<(q|0)&D);if((t|0)<(w|0)){u=a+2684+(s<<2)|0;d[u>>1]=(j[u>>1]|0)+t}else{if(s){u=a+2684+(s<<2)|0;if((s|0)==(i|0))E=p;else{d[u>>1]=(d[u>>1]|0)+1<<16>>16;E=p}}else E=(t|0)<11?o:l;d[E>>1]=(d[E>>1]|0)+1<<16>>16}u=B<<16>>16==0;k=s;s=C;x=v;w=u|D?3:4;q=u?138:D?6:7;i=k}dIc(a,a+2864|0);if(!(d[a+2746>>1]|0))if(!(d[a+2690>>1]|0))if(!(d[a+2742>>1]|0))if(!(d[a+2694>>1]|0))if(!(d[a+2738>>1]|0))if(!(d[a+2698>>1]|0))if(!(d[a+2734>>1]|0))if(!(d[a+2702>>1]|0))if(!(d[a+2730>>1]|0))if(!(d[a+2706>>1]|0))if(!(d[a+2726>>1]|0))if(!(d[a+2710>>1]|0))if(!(d[a+2722>>1]|0))if(!(d[a+2714>>1]|0))if(!(d[a+2718>>1]|0))F=(d[a+2686>>1]|0)==0?2:3;else F=4;else F=5;else F=6;else F=7;else F=8;else F=9;else F=10;else F=11;else F=12;else F=13;else F=14;else F=15;else F=16;else F=17;else F=18;i=a+5800|0;D=(F*3|0)+17+(f[i>>2]|0)|0;f[i>>2]=D;i=(D+10|0)>>>3;D=((f[a+5804>>2]|0)+10|0)>>>3;G=D>>>0>i>>>0?i:D;H=D;I=F}else{F=e+5|0;G=F;H=F;I=0}do if((c|0)!=0&(e+4|0)>>>0<=G>>>0)$Hc(a,c,e,g);else{F=a+5820|0;D=f[F>>2]|0;i=(D|0)>13;if((H|0)==(G|0)?1:(f[a+136>>2]|0)==4){q=g+2&65535;w=a+5816|0;x=j[w>>1]|q<<D;d[w>>1]=x;if(i){C=a+8|0;s=f[C>>2]|0;B=a+20|0;E=f[B>>2]|0;f[B>>2]=E+1;b[s+E>>0]=x;x=(j[w>>1]|0)>>>8&255;E=f[C>>2]|0;C=f[B>>2]|0;f[B>>2]=C+1;b[E+C>>0]=x;x=f[F>>2]|0;d[w>>1]=q>>>(16-x|0);J=x+-13|0}else J=D+3|0;f[F>>2]=J;eIc(a,195110,194990);break}x=g+4&65535;q=a+5816|0;w=j[q>>1]|x<<D;d[q>>1]=w;if(i){i=a+8|0;C=f[i>>2]|0;E=a+20|0;B=f[E>>2]|0;f[E>>2]=B+1;b[C+B>>0]=w;B=(j[q>>1]|0)>>>8&255;C=f[i>>2]|0;i=f[E>>2]|0;f[E>>2]=i+1;b[C+i>>0]=B;B=f[F>>2]|0;i=x>>>(16-B|0);d[q>>1]=i;K=i;L=B+-13|0}else{K=w;L=D+3|0}f[F>>2]=L;D=f[a+2844>>2]|0;w=f[a+2856>>2]|0;B=D+65280&65535;i=K&65535|B<<L;d[q>>1]=i;if((L|0)>11){x=a+8|0;C=f[x>>2]|0;E=a+20|0;s=f[E>>2]|0;f[E>>2]=s+1;b[C+s>>0]=i;s=(j[q>>1]|0)>>>8&255;C=f[x>>2]|0;x=f[E>>2]|0;f[E>>2]=x+1;b[C+x>>0]=s;s=f[F>>2]|0;x=B>>>(16-s|0);d[q>>1]=x;M=s+-11|0;N=x}else{M=L+5|0;N=i}f[F>>2]=M;i=w&65535;x=i<<M|N&65535;d[q>>1]=x;if((M|0)>11){s=a+8|0;B=f[s>>2]|0;C=a+20|0;E=f[C>>2]|0;f[C>>2]=E+1;b[B+E>>0]=x;E=(j[q>>1]|0)>>>8&255;B=f[s>>2]|0;s=f[C>>2]|0;f[C>>2]=s+1;b[B+s>>0]=E;E=f[F>>2]|0;s=i>>>(16-E|0);d[q>>1]=s;O=E+-11|0;P=s}else{O=M+5|0;P=x}f[F>>2]=O;x=I+65533&65535;s=x<<O|P&65535;d[q>>1]=s;if((O|0)>12){E=a+8|0;i=f[E>>2]|0;B=a+20|0;C=f[B>>2]|0;f[B>>2]=C+1;b[i+C>>0]=s;C=(j[q>>1]|0)>>>8&255;i=f[E>>2]|0;l=f[B>>2]|0;f[B>>2]=l+1;b[i+l>>0]=C;C=f[F>>2]|0;l=x>>>(16-C|0);d[q>>1]=l;Q=B;R=E;S=l;T=C+-12|0}else{Q=a+20|0;R=a+8|0;S=s;T=O+4|0}f[F>>2]=T;s=0;C=T;l=S;while(1){E=j[a+2684+(h[520477+s>>0]<<2)+2>>1]|0;B=E<<C|l&65535;d[q>>1]=B;if((C|0)>13){x=f[R>>2]|0;i=f[Q>>2]|0;f[Q>>2]=i+1;b[x+i>>0]=B;i=(j[q>>1]|0)>>>8&255;x=f[R>>2]|0;o=f[Q>>2]|0;f[Q>>2]=o+1;b[x+o>>0]=i;i=f[F>>2]|0;o=E>>>(16-i|0);d[q>>1]=o;U=o;V=i+-13|0}else{U=B;V=C+3|0}f[F>>2]=V;if((s|0)==(I|0))break;else{s=s+1|0;C=V;l=U}}l=a+148|0;fIc(a,l,D);C=a+2440|0;fIc(a,C,w);eIc(a,l,C)}while(0);_Hc(a);if(!g)return;g=a+5820|0;U=f[g>>2]|0;if((U|0)<=8){if((U|0)>0){U=d[a+5816>>1]&255;V=f[a+8>>2]|0;I=a+20|0;Q=f[I>>2]|0;f[I>>2]=Q+1;W=U;X=V+Q|0;n=84}}else{Q=a+5816|0;V=d[Q>>1]&255;U=a+8|0;I=f[U>>2]|0;R=a+20|0;S=f[R>>2]|0;f[R>>2]=S+1;b[I+S>>0]=V;V=(j[Q>>1]|0)>>>8&255;Q=f[U>>2]|0;U=f[R>>2]|0;f[R>>2]=U+1;W=V;X=Q+U|0;n=84}if((n|0)==84)b[X>>0]=W;d[a+5816>>1]=0;f[g>>2]=0;return}function dIc(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=u;u=u+32|0;g=e;i=f[c>>2]|0;k=c+8|0;l=f[k>>2]|0;m=f[l>>2]|0;n=f[l+12>>2]|0;l=a+5200|0;f[l>>2]=0;o=a+5204|0;f[o>>2]=573;if((n|0)>0){p=-1;q=0;while(1){if(!(d[i+(q<<2)>>1]|0)){d[i+(q<<2)+2>>1]=0;r=p}else{s=(f[l>>2]|0)+1|0;f[l>>2]=s;f[a+2908+(s<<2)>>2]=q;b[a+5208+q>>0]=0;r=q}q=q+1|0;if((q|0)==(n|0))break;else p=r}p=f[l>>2]|0;if((p|0)<2){t=r;v=p;w=3}else{x=r;y=p}}else{t=-1;v=0;w=3}if((w|0)==3){w=a+5800|0;p=a+5804|0;if(!m){r=t;q=v;while(1){s=(r|0)<2;z=r+1|0;A=s?z:r;B=s?z:0;z=q+1|0;f[l>>2]=z;f[a+2908+(z<<2)>>2]=B;d[i+(B<<2)>>1]=1;b[a+5208+B>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;B=f[l>>2]|0;if((B|0)<2){r=A;q=B}else{x=A;y=B;break}}}else{q=t;t=v;while(1){v=(q|0)<2;r=q+1|0;B=v?r:q;A=v?r:0;r=t+1|0;f[l>>2]=r;f[a+2908+(r<<2)>>2]=A;d[i+(A<<2)>>1]=1;b[a+5208+A>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;f[p>>2]=(f[p>>2]|0)-(j[m+(A<<2)+2>>1]|0);A=f[l>>2]|0;if((A|0)<2){q=B;t=A}else{x=B;y=A;break}}}}t=c+4|0;f[t>>2]=x;q=y>>>1;if(!q)C=y;else{m=q;q=y;while(1){y=f[a+2908+(m<<2)>>2]|0;p=a+5208+y|0;w=m<<1;a:do if((w|0)>(q|0))D=m;else{A=i+(y<<2)|0;B=m;r=w;v=q;while(1){do if((r|0)<(v|0)){z=r|1;s=f[a+2908+(z<<2)>>2]|0;E=d[i+(s<<2)>>1]|0;F=f[a+2908+(r<<2)>>2]|0;G=d[i+(F<<2)>>1]|0;if((E&65535)>=(G&65535)){if(E<<16>>16!=G<<16>>16){H=r;break}if((h[a+5208+s>>0]|0)>(h[a+5208+F>>0]|0)){H=r;break}}H=z}else H=r;while(0);z=d[A>>1]|0;F=f[a+2908+(H<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;if((z&65535)<(s&65535)){D=B;break a}if(z<<16>>16==s<<16>>16?(h[p>>0]|0)<=(h[a+5208+F>>0]|0):0){D=B;break a}f[a+2908+(B<<2)>>2]=F;r=H<<1;v=f[l>>2]|0;if((r|0)>(v|0)){D=H;break}else B=H}}while(0);f[a+2908+(D<<2)>>2]=y;if((m|0)<=1)break;m=m+-1|0;q=f[l>>2]|0}C=f[l>>2]|0}q=a+2912|0;m=n;n=C;do{C=f[q>>2]|0;D=n+-1|0;f[l>>2]=D;H=f[a+2908+(n<<2)>>2]|0;f[q>>2]=H;p=a+5208+H|0;b:do if((n|0)<3)I=1;else{w=i+(H<<2)|0;B=1;v=2;r=D;while(1){do if((v|0)<(r|0)){A=v|1;F=f[a+2908+(A<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;z=f[a+2908+(v<<2)>>2]|0;G=d[i+(z<<2)>>1]|0;if((s&65535)>=(G&65535)){if(s<<16>>16!=G<<16>>16){J=v;break}if((h[a+5208+F>>0]|0)>(h[a+5208+z>>0]|0)){J=v;break}}J=A}else J=v;while(0);A=d[w>>1]|0;z=f[a+2908+(J<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;if((A&65535)<(F&65535)){I=B;break b}if(A<<16>>16==F<<16>>16?(h[p>>0]|0)<=(h[a+5208+z>>0]|0):0){I=B;break b}f[a+2908+(B<<2)>>2]=z;v=J<<1;r=f[l>>2]|0;if((v|0)>(r|0)){I=J;break}else B=J}}while(0);f[a+2908+(I<<2)>>2]=H;p=f[q>>2]|0;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=C;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=p;D=i+(m<<2)|0;d[D>>1]=(j[i+(p<<2)>>1]|0)+(j[i+(C<<2)>>1]|0);y=a+5208+m|0;b[y>>0]=(h[((h[a+5208+C>>0]|0)>=(h[a+5208+p>>0]|0)?C:p)+(a+5208)>>0]|0)+1;B=m&65535;d[i+(p<<2)+2>>1]=B;d[i+(C<<2)+2>>1]=B;f[q>>2]=m;B=f[l>>2]|0;c:do if((B|0)<2)K=1;else{p=1;r=2;v=B;while(1){do if((r|0)<(v|0)){w=r|1;z=f[a+2908+(w<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;A=f[a+2908+(r<<2)>>2]|0;G=d[i+(A<<2)>>1]|0;if((F&65535)>=(G&65535)){if(F<<16>>16!=G<<16>>16){L=r;break}if((h[a+5208+z>>0]|0)>(h[a+5208+A>>0]|0)){L=r;break}}L=w}else L=r;while(0);w=d[D>>1]|0;A=f[a+2908+(L<<2)>>2]|0;z=d[i+(A<<2)>>1]|0;if((w&65535)<(z&65535)){K=p;break c}if(w<<16>>16==z<<16>>16?(h[y>>0]|0)<=(h[a+5208+A>>0]|0):0){K=p;break c}f[a+2908+(p<<2)>>2]=A;r=L<<1;v=f[l>>2]|0;if((r|0)>(v|0)){K=L;break}else p=L}}while(0);f[a+2908+(K<<2)>>2]=m;m=m+1|0;n=f[l>>2]|0}while((n|0)>1);n=f[q>>2]|0;q=(f[o>>2]|0)+-1|0;f[o>>2]=q;f[a+2908+(q<<2)>>2]=n;n=f[c>>2]|0;c=f[t>>2]|0;t=f[k>>2]|0;k=f[t>>2]|0;q=f[t+4>>2]|0;l=f[t+8>>2]|0;m=f[t+16>>2]|0;t=a+2876|0;K=t+32|0;do{d[t>>1]=0;t=t+2|0}while((t|0)<(K|0));t=f[o>>2]|0;d[n+(f[a+2908+(t<<2)>>2]<<2)+2>>1]=0;o=t+1|0;d:do if((o|0)<573){t=a+5800|0;K=a+5804|0;if(!k){L=o;I=0;while(1){J=f[a+2908+(L<<2)>>2]|0;y=n+(J<<2)+2|0;D=j[n+(j[y>>1]<<2)+2>>1]|0;B=(D|0)<(m|0);C=B?D+1|0:m;D=((B^1)&1)+I|0;d[y>>1]=C;if((J|0)<=(c|0)){y=a+2876+(C<<1)|0;d[y>>1]=(d[y>>1]|0)+1<<16>>16;if((J|0)<(l|0))M=0;else M=f[q+(J-l<<2)>>2]|0;y=Y(j[n+(J<<2)>>1]|0,M+C|0)|0;f[t>>2]=y+(f[t>>2]|0)}L=L+1|0;if((L|0)==573){N=D;break}else I=D}}else{I=o;L=0;while(1){D=f[a+2908+(I<<2)>>2]|0;y=n+(D<<2)+2|0;C=j[n+(j[y>>1]<<2)+2>>1]|0;J=(C|0)<(m|0);B=J?C+1|0:m;C=((J^1)&1)+L|0;d[y>>1]=B;if((D|0)<=(c|0)){y=a+2876+(B<<1)|0;d[y>>1]=(d[y>>1]|0)+1<<16>>16;if((D|0)<(l|0))O=0;else O=f[q+(D-l<<2)>>2]|0;y=j[n+(D<<2)>>1]|0;J=Y(y,O+B|0)|0;f[t>>2]=J+(f[t>>2]|0);J=Y((j[k+(D<<2)+2>>1]|0)+O|0,y)|0;f[K>>2]=J+(f[K>>2]|0)}I=I+1|0;if((I|0)==573){N=C;break}else L=C}}if(N|0){L=a+2876+(m<<1)|0;I=N;while(1){K=m;while(1){C=K+-1|0;P=a+2876+(C<<1)|0;Q=d[P>>1]|0;if(!(Q<<16>>16))K=C;else break}d[P>>1]=Q+-1<<16>>16;C=a+2876+(K<<1)|0;d[C>>1]=(j[C>>1]|0)+2;R=(d[L>>1]|0)+-1<<16>>16;d[L>>1]=R;if((I|0)>2)I=I+-2|0;else break}if(m|0){I=573;L=m;C=R;while(1){J=L&65535;if(!(C<<16>>16))S=I;else{y=C&65535;D=I;while(1){B=D;do{B=B+-1|0;T=f[a+2908+(B<<2)>>2]|0}while((T|0)>(c|0));H=n+(T<<2)+2|0;p=j[H>>1]|0;if((L|0)!=(p|0)){v=Y(j[n+(T<<2)>>1]|0,L-p|0)|0;f[t>>2]=v+(f[t>>2]|0);d[H>>1]=J}y=y+-1|0;if(!y){S=B;break}else D=B}}D=L+-1|0;if(!D)break d;I=S;L=D;C=d[a+2876+(D<<1)>>1]|0}}}}while(0);S=0;T=1;do{S=(j[a+2876+(T+-1<<1)>>1]|0)+S<<1;d[g+(T<<1)>>1]=S;T=T+1|0}while((T|0)!=16);if((x|0)<0){u=e;return}else U=0;while(1){T=d[i+(U<<2)+2>>1]|0;S=T&65535;if(T<<16>>16){T=g+(S<<1)|0;a=d[T>>1]|0;d[T>>1]=a+1<<16>>16;T=0;n=S;S=a&65535;while(1){V=T|S&1;if((n|0)>1){T=V<<1;n=n+-1|0;S=S>>>1}else break}d[i+(U<<2)>>1]=V}if((U|0)==(x|0))break;else U=U+1|0}u=e;return}function eIc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=a+5792|0;if(!(f[g>>2]|0)){i=a+5820|0;k=a+5816|0;l=k;m=i;n=f[i>>2]|0;o=d[k>>1]|0}else{k=a+5796|0;i=a+5784|0;p=a+5820|0;q=a+5816|0;r=a+8|0;s=a+20|0;t=0;do{u=d[(f[k>>2]|0)+(t<<1)>>1]|0;v=u&65535;w=h[(f[i>>2]|0)+t>>0]|0;t=t+1|0;do if(!(u<<16>>16)){x=j[c+(w<<2)+2>>1]|0;y=f[p>>2]|0;z=j[c+(w<<2)>>1]|0;A=j[q>>1]|0|z<<y;B=A&65535;d[q>>1]=B;if((y|0)>(16-x|0)){C=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[C+D>>0]=A;A=(j[q>>1]|0)>>>8&255;D=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[D+C>>0]=A;A=f[p>>2]|0;C=z>>>(16-A|0)&65535;d[q>>1]=C;E=C;F=x+-16+A|0;G=23;break}else{E=B;F=y+x|0;G=23;break}}else{x=h[520221+w>>0]|0;y=(x|256)+1|0;B=j[c+(y<<2)+2>>1]|0;A=f[p>>2]|0;C=j[c+(y<<2)>>1]|0;y=j[q>>1]|0|C<<A;z=y&65535;d[q>>1]=z;if((A|0)>(16-B|0)){D=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[D+H>>0]=y;y=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[H+D>>0]=y;y=f[p>>2]|0;D=C>>>(16-y|0)&65535;d[q>>1]=D;I=D;J=B+-16+y|0}else{I=z;J=A+B|0}f[p>>2]=J;B=f[183864+(x<<2)>>2]|0;if((x+-8|0)>>>0<20){A=w-(f[183980+(x<<2)>>2]|0)&65535;x=A<<J|I&65535;z=x&65535;d[q>>1]=z;if((J|0)>(16-B|0)){y=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[y+D>>0]=x;x=(j[q>>1]|0)>>>8&255;D=f[r>>2]|0;y=f[s>>2]|0;f[s>>2]=y+1;b[D+y>>0]=x;x=f[p>>2]|0;y=A>>>(16-x|0)&65535;d[q>>1]=y;K=y;L=B+-16+x|0}else{K=z;L=J+B|0}f[p>>2]=L;M=L;N=K}else{M=J;N=I}B=v+-1|0;z=h[519709+(B>>>0<256?B:(B>>>7)+256|0)>>0]|0;x=j[e+(z<<2)+2>>1]|0;y=j[e+(z<<2)>>1]|0;A=N&65535|y<<M;D=A&65535;d[q>>1]=D;if((M|0)>(16-x|0)){C=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[C+H>>0]=A;A=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[H+C>>0]=A;A=f[p>>2]|0;C=y>>>(16-A|0)&65535;d[q>>1]=C;O=x+-16+A|0;P=C}else{O=M+x|0;P=D}f[p>>2]=O;D=f[183744+(z<<2)>>2]|0;if((z+-4|0)>>>0<26){x=B-(f[184096+(z<<2)>>2]|0)&65535;z=x<<O|P&65535;B=z&65535;d[q>>1]=B;if((O|0)>(16-D|0)){C=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[C+A>>0]=z;z=(j[q>>1]|0)>>>8&255;A=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[A+C>>0]=z;z=f[p>>2]|0;C=x>>>(16-z|0)&65535;d[q>>1]=C;E=C;F=D+-16+z|0;G=23;break}else{E=B;F=O+D|0;G=23;break}}else{Q=P;R=O}}while(0);if((G|0)==23){G=0;f[p>>2]=F;Q=E;R=F}}while(t>>>0<(f[g>>2]|0)>>>0);l=q;m=p;n=R;o=Q}Q=j[c+1026>>1]|0;R=j[c+1024>>1]|0;c=o&65535|R<<n;d[l>>1]=c;if((n|0)>(16-Q|0)){o=a+8|0;p=f[o>>2]|0;q=a+20|0;a=f[q>>2]|0;f[q>>2]=a+1;b[p+a>>0]=c;c=(j[l>>1]|0)>>>8&255;a=f[o>>2]|0;o=f[q>>2]|0;f[q>>2]=o+1;b[a+o>>0]=c;c=f[m>>2]|0;d[l>>1]=R>>>(16-c|0);S=Q+-16+c|0;f[m>>2]=S;return}else{S=n+Q|0;f[m>>2]=S;return}}function fIc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;g=d[c+2>>1]|0;h=g<<16>>16==0;i=a+2754|0;k=a+5820|0;l=a+2752|0;m=a+5816|0;n=a+8|0;o=a+20|0;p=a+2758|0;q=a+2756|0;r=a+2750|0;s=a+2748|0;t=0;u=-1;v=g&65535;g=h?138:7;w=h?3:4;a:while(1){h=t;x=0;while(1){if((h|0)>(e|0))break a;h=h+1|0;y=d[c+(h<<2)+2>>1]|0;z=y&65535;A=x+1|0;B=(v|0)==(z|0);if(!((A|0)<(g|0)&B))break;else x=A}if((A|0)<(w|0)){C=a+2684+(v<<2)+2|0;D=a+2684+(v<<2)|0;E=A;F=f[k>>2]|0;G=d[m>>1]|0;while(1){H=j[C>>1]|0;I=j[D>>1]|0;J=G&65535|I<<F;K=J&65535;d[m>>1]=K;if((F|0)>(16-H|0)){L=f[n>>2]|0;M=f[o>>2]|0;f[o>>2]=M+1;b[L+M>>0]=J;J=(j[m>>1]|0)>>>8&255;M=f[n>>2]|0;L=f[o>>2]|0;f[o>>2]=L+1;b[M+L>>0]=J;J=f[k>>2]|0;L=I>>>(16-J|0)&65535;d[m>>1]=L;N=L;O=H+-16+J|0}else{N=K;O=F+H|0}f[k>>2]=O;E=E+-1|0;if(!E)break;else{F=O;G=N}}}else{do if(!v)if((A|0)<11){G=j[i>>1]|0;F=f[k>>2]|0;E=j[l>>1]|0;D=j[m>>1]|0|E<<F;d[m>>1]=D;if((F|0)>(16-G|0)){C=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[C+H>>0]=D;H=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[C+K>>0]=H;H=f[k>>2]|0;K=E>>>(16-H|0);d[m>>1]=K;P=G+-16+H|0;Q=K}else{P=F+G|0;Q=D}f[k>>2]=P;D=x+65534&65535;G=Q&65535|D<<P;d[m>>1]=G;if((P|0)>13){F=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[F+K>>0]=G;G=(j[m>>1]|0)>>>8&255;K=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[K+F>>0]=G;G=f[k>>2]|0;d[m>>1]=D>>>(16-G|0);R=G+-13|0;break}else{R=P+3|0;break}}else{G=j[p>>1]|0;D=f[k>>2]|0;F=j[q>>1]|0;K=j[m>>1]|0|F<<D;d[m>>1]=K;if((D|0)>(16-G|0)){H=f[n>>2]|0;E=f[o>>2]|0;f[o>>2]=E+1;b[H+E>>0]=K;E=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[H+C>>0]=E;E=f[k>>2]|0;C=F>>>(16-E|0);d[m>>1]=C;S=G+-16+E|0;T=C}else{S=D+G|0;T=K}f[k>>2]=S;K=x+65526&65535;G=T&65535|K<<S;d[m>>1]=G;if((S|0)>9){D=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[D+C>>0]=G;G=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=G;G=f[k>>2]|0;d[m>>1]=K>>>(16-G|0);R=G+-9|0;break}else{R=S+7|0;break}}else{if((v|0)==(u|0)){U=A;V=d[m>>1]|0;W=f[k>>2]|0}else{G=j[a+2684+(v<<2)+2>>1]|0;K=f[k>>2]|0;D=j[a+2684+(v<<2)>>1]|0;C=j[m>>1]|0|D<<K;E=C&65535;d[m>>1]=E;if((K|0)>(16-G|0)){F=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[F+H>>0]=C;C=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[H+F>>0]=C;C=f[k>>2]|0;F=D>>>(16-C|0)&65535;d[m>>1]=F;X=F;Y=G+-16+C|0}else{X=E;Y=K+G|0}f[k>>2]=Y;U=x;V=X;W=Y}G=j[r>>1]|0;K=j[s>>1]|0;E=V&65535|K<<W;d[m>>1]=E;if((W|0)>(16-G|0)){C=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[C+F>>0]=E;F=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=F;F=f[k>>2]|0;D=K>>>(16-F|0);d[m>>1]=D;Z=G+-16+F|0;_=D}else{Z=W+G|0;_=E}f[k>>2]=Z;E=U+65533&65535;G=_&65535|E<<Z;d[m>>1]=G;if((Z|0)>14){D=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[D+F>>0]=G;G=(j[m>>1]|0)>>>8&255;F=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[F+D>>0]=G;G=f[k>>2]|0;d[m>>1]=E>>>(16-G|0);R=G+-14|0;break}else{R=Z+2|0;break}}while(0);f[k>>2]=R}x=y<<16>>16==0;G=v;t=h;v=z;g=x?138:B?6:7;w=x|B?3:4;u=G}return}function gIc(){hIc(0);return}function hIc(a){a=a|0;Nf(25432,529486);te(25448,529491,1,1,0);$e(25456,529260,1,-128,127);$e(25488,529265,1,-128,127);$e(25480,529277,1,0,255);$e(25496,529291,2,-32768,32767);$e(25504,529297,2,0,65535);$e(25512,529496,4,-2147483648,2147483647);$e(25520,529500,4,0,-1);$e(25528,529513,4,-2147483648,2147483647);$e(25536,529518,4,0,-1);ag(25544,529542,4);ag(25552,529654,8);Vd(4984,528869);Vd(23728,520496);Uf(23752,4,520529);xe(4272,520542);Ff(4872,0,520558);Ff(23776,0,520588);Ff(4864,1,520625);Ff(4888,2,520664);Ff(4880,3,520695);Ff(4896,4,520735);Ff(23784,5,520764);Ff(23792,4,520802);Ff(23800,5,520832);Ff(23776,0,520871);Ff(4864,1,520903);Ff(4888,2,520936);Ff(4880,3,520969);Ff(4896,4,521003);Ff(23784,5,521036);Ff(4904,6,521070);Ff(4912,7,521101);Ff(23808,7,521133);return}function iIc(a){a=a|0;return gJc(f[a+4>>2]|0)|0}function jIc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;b=u;u=u+16|0;c=b;do if(a>>>0<245){d=a>>>0<11?16:a+11&-8;e=d>>>3;g=f[223606]|0;h=g>>>e;if(h&3|0){i=(h&1^1)+e|0;j=894464+(i<<1<<2)|0;k=j+8|0;l=f[k>>2]|0;m=l+8|0;n=f[m>>2]|0;if((j|0)==(n|0))f[223606]=g&~(1<<i);else{f[n+12>>2]=j;f[k>>2]=n}n=i<<3;f[l+4>>2]=n|3;i=l+n+4|0;f[i>>2]=f[i>>2]|1;o=m;u=b;return o|0}m=f[223608]|0;if(d>>>0>m>>>0){if(h|0){i=2<<e;n=h<<e&(i|0-i);i=(n&0-n)+-1|0;n=i>>>12&16;e=i>>>n;i=e>>>5&8;h=e>>>i;e=h>>>2&4;l=h>>>e;h=l>>>1&2;k=l>>>h;l=k>>>1&1;j=(i|n|e|h|l)+(k>>>l)|0;l=894464+(j<<1<<2)|0;k=l+8|0;h=f[k>>2]|0;e=h+8|0;n=f[e>>2]|0;if((l|0)==(n|0)){i=g&~(1<<j);f[223606]=i;p=i}else{f[n+12>>2]=l;f[k>>2]=n;p=g}n=(j<<3)-d|0;f[h+4>>2]=d|3;j=h+d|0;f[j+4>>2]=n|1;f[j+n>>2]=n;if(m|0){h=f[223611]|0;k=m>>>3;l=894464+(k<<1<<2)|0;i=1<<k;if(!(p&i)){f[223606]=p|i;q=l;r=l+8|0}else{i=l+8|0;q=f[i>>2]|0;r=i}f[r>>2]=h;f[q+12>>2]=h;f[h+8>>2]=q;f[h+12>>2]=l}f[223608]=n;f[223611]=j;o=e;u=b;return o|0}e=f[223607]|0;if(e){j=(e&0-e)+-1|0;n=j>>>12&16;l=j>>>n;j=l>>>5&8;h=l>>>j;l=h>>>2&4;i=h>>>l;h=i>>>1&2;k=i>>>h;i=k>>>1&1;s=f[894728+((j|n|l|h|i)+(k>>>i)<<2)>>2]|0;i=(f[s+4>>2]&-8)-d|0;k=f[s+16+(((f[s+16>>2]|0)==0&1)<<2)>>2]|0;if(!k){t=s;v=i}else{h=s;s=i;i=k;while(1){k=(f[i+4>>2]&-8)-d|0;l=k>>>0<s>>>0;n=l?k:s;k=l?i:h;i=f[i+16+(((f[i+16>>2]|0)==0&1)<<2)>>2]|0;if(!i){t=k;v=n;break}else{h=k;s=n}}}s=t+d|0;if(t>>>0<s>>>0){h=f[t+24>>2]|0;i=f[t+12>>2]|0;do if((i|0)==(t|0)){n=t+20|0;k=f[n>>2]|0;if(!k){l=t+16|0;j=f[l>>2]|0;if(!j){w=0;break}else{x=j;y=l}}else{x=k;y=n}while(1){n=x+20|0;k=f[n>>2]|0;if(k|0){x=k;y=n;continue}n=x+16|0;k=f[n>>2]|0;if(!k)break;else{x=k;y=n}}f[y>>2]=0;w=x}else{n=f[t+8>>2]|0;f[n+12>>2]=i;f[i+8>>2]=n;w=i}while(0);do if(h|0){i=f[t+28>>2]|0;n=894728+(i<<2)|0;if((t|0)==(f[n>>2]|0)){f[n>>2]=w;if(!w){f[223607]=e&~(1<<i);break}}else{f[h+16+(((f[h+16>>2]|0)!=(t|0)&1)<<2)>>2]=w;if(!w)break}f[w+24>>2]=h;i=f[t+16>>2]|0;if(i|0){f[w+16>>2]=i;f[i+24>>2]=w}i=f[t+20>>2]|0;if(i|0){f[w+20>>2]=i;f[i+24>>2]=w}}while(0);if(v>>>0<16){h=v+d|0;f[t+4>>2]=h|3;e=t+h+4|0;f[e>>2]=f[e>>2]|1}else{f[t+4>>2]=d|3;f[s+4>>2]=v|1;f[s+v>>2]=v;if(m|0){e=f[223611]|0;h=m>>>3;i=894464+(h<<1<<2)|0;n=1<<h;if(!(g&n)){f[223606]=g|n;z=i;A=i+8|0}else{n=i+8|0;z=f[n>>2]|0;A=n}f[A>>2]=e;f[z+12>>2]=e;f[e+8>>2]=z;f[e+12>>2]=i}f[223608]=v;f[223611]=s}o=t+8|0;u=b;return o|0}else B=d}else B=d}else B=d}else if(a>>>0<=4294967231){i=a+11|0;e=i&-8;n=f[223607]|0;if(n){h=0-e|0;k=i>>>8;if(k)if(e>>>0>16777215)C=31;else{i=(k+1048320|0)>>>16&8;l=k<<i;k=(l+520192|0)>>>16&4;j=l<<k;l=(j+245760|0)>>>16&2;D=14-(k|i|l)+(j<<l>>>15)|0;C=e>>>(D+7|0)&1|D<<1}else C=0;D=f[894728+(C<<2)>>2]|0;a:do if(!D){E=0;F=0;G=h;H=57}else{l=0;j=h;i=D;k=e<<((C|0)==31?0:25-(C>>>1)|0);I=0;while(1){J=(f[i+4>>2]&-8)-e|0;if(J>>>0<j>>>0)if(!J){K=i;L=0;M=i;H=61;break a}else{N=i;O=J}else{N=l;O=j}J=f[i+20>>2]|0;i=f[i+16+(k>>>31<<2)>>2]|0;P=(J|0)==0|(J|0)==(i|0)?I:J;J=(i|0)==0;if(J){E=P;F=N;G=O;H=57;break}else{l=N;j=O;k=k<<((J^1)&1);I=P}}}while(0);if((H|0)==57){if((E|0)==0&(F|0)==0){D=2<<C;h=n&(D|0-D);if(!h){B=e;break}D=(h&0-h)+-1|0;h=D>>>12&16;d=D>>>h;D=d>>>5&8;s=d>>>D;d=s>>>2&4;g=s>>>d;s=g>>>1&2;m=g>>>s;g=m>>>1&1;Q=0;R=f[894728+((D|h|d|s|g)+(m>>>g)<<2)>>2]|0}else{Q=F;R=E}if(!R){S=Q;T=G}else{K=Q;L=G;M=R;H=61}}if((H|0)==61)while(1){H=0;g=(f[M+4>>2]&-8)-e|0;m=g>>>0<L>>>0;s=m?g:L;g=m?M:K;M=f[M+16+(((f[M+16>>2]|0)==0&1)<<2)>>2]|0;if(!M){S=g;T=s;break}else{K=g;L=s;H=61}}if((S|0)!=0?T>>>0<((f[223608]|0)-e|0)>>>0:0){s=S+e|0;if(S>>>0>=s>>>0){o=0;u=b;return o|0}g=f[S+24>>2]|0;m=f[S+12>>2]|0;do if((m|0)==(S|0)){d=S+20|0;h=f[d>>2]|0;if(!h){D=S+16|0;I=f[D>>2]|0;if(!I){U=0;break}else{V=I;W=D}}else{V=h;W=d}while(1){d=V+20|0;h=f[d>>2]|0;if(h|0){V=h;W=d;continue}d=V+16|0;h=f[d>>2]|0;if(!h)break;else{V=h;W=d}}f[W>>2]=0;U=V}else{d=f[S+8>>2]|0;f[d+12>>2]=m;f[m+8>>2]=d;U=m}while(0);do if(g){m=f[S+28>>2]|0;d=894728+(m<<2)|0;if((S|0)==(f[d>>2]|0)){f[d>>2]=U;if(!U){d=n&~(1<<m);f[223607]=d;X=d;break}}else{f[g+16+(((f[g+16>>2]|0)!=(S|0)&1)<<2)>>2]=U;if(!U){X=n;break}}f[U+24>>2]=g;d=f[S+16>>2]|0;if(d|0){f[U+16>>2]=d;f[d+24>>2]=U}d=f[S+20>>2]|0;if(d){f[U+20>>2]=d;f[d+24>>2]=U;X=n}else X=n}else X=n;while(0);do if(T>>>0>=16){f[S+4>>2]=e|3;f[s+4>>2]=T|1;f[s+T>>2]=T;n=T>>>3;if(T>>>0<256){g=894464+(n<<1<<2)|0;d=f[223606]|0;m=1<<n;if(!(d&m)){f[223606]=d|m;Y=g;Z=g+8|0}else{m=g+8|0;Y=f[m>>2]|0;Z=m}f[Z>>2]=s;f[Y+12>>2]=s;f[s+8>>2]=Y;f[s+12>>2]=g;break}g=T>>>8;if(g)if(T>>>0>16777215)_=31;else{m=(g+1048320|0)>>>16&8;d=g<<m;g=(d+520192|0)>>>16&4;n=d<<g;d=(n+245760|0)>>>16&2;h=14-(g|m|d)+(n<<d>>>15)|0;_=T>>>(h+7|0)&1|h<<1}else _=0;h=894728+(_<<2)|0;f[s+28>>2]=_;d=s+16|0;f[d+4>>2]=0;f[d>>2]=0;d=1<<_;if(!(X&d)){f[223607]=X|d;f[h>>2]=s;f[s+24>>2]=h;f[s+12>>2]=s;f[s+8>>2]=s;break}d=T<<((_|0)==31?0:25-(_>>>1)|0);n=f[h>>2]|0;while(1){if((f[n+4>>2]&-8|0)==(T|0)){H=97;break}$=n+16+(d>>>31<<2)|0;h=f[$>>2]|0;if(!h){H=96;break}else{d=d<<1;n=h}}if((H|0)==96){f[$>>2]=s;f[s+24>>2]=n;f[s+12>>2]=s;f[s+8>>2]=s;break}else if((H|0)==97){d=n+8|0;h=f[d>>2]|0;f[h+12>>2]=s;f[d>>2]=s;f[s+8>>2]=h;f[s+12>>2]=n;f[s+24>>2]=0;break}}else{h=T+e|0;f[S+4>>2]=h|3;d=S+h+4|0;f[d>>2]=f[d>>2]|1}while(0);o=S+8|0;u=b;return o|0}else B=e}else B=e}else B=-1;while(0);S=f[223608]|0;if(S>>>0>=B>>>0){T=S-B|0;$=f[223611]|0;if(T>>>0>15){_=$+B|0;f[223611]=_;f[223608]=T;f[_+4>>2]=T|1;f[_+T>>2]=T;f[$+4>>2]=B|3}else{f[223608]=0;f[223611]=0;f[$+4>>2]=S|3;T=$+S+4|0;f[T>>2]=f[T>>2]|1}o=$+8|0;u=b;return o|0}$=f[223609]|0;if($>>>0>B>>>0){T=$-B|0;f[223609]=T;S=f[223612]|0;_=S+B|0;f[223612]=_;f[_+4>>2]=T|1;f[S+4>>2]=B|3;o=S+8|0;u=b;return o|0}if(!(f[223724]|0)){f[223726]=4096;f[223725]=4096;f[223727]=-1;f[223728]=-1;f[223729]=0;f[223717]=0;S=c&-16^1431655768;f[c>>2]=S;f[223724]=S;aa=4096}else aa=f[223726]|0;S=B+48|0;c=B+47|0;T=aa+c|0;_=0-aa|0;aa=T&_;if(aa>>>0<=B>>>0){o=0;u=b;return o|0}X=f[223716]|0;if(X|0?(Y=f[223714]|0,Z=Y+aa|0,Z>>>0<=Y>>>0|Z>>>0>X>>>0):0){o=0;u=b;return o|0}b:do if(!(f[223717]&4)){X=f[223612]|0;c:do if(X){Z=894872;while(1){Y=f[Z>>2]|0;if(Y>>>0<=X>>>0?(ba=Z+4|0,(Y+(f[ba>>2]|0)|0)>>>0>X>>>0):0)break;Y=f[Z+8>>2]|0;if(!Y){H=118;break c}else Z=Y}n=T-$&_;if(n>>>0<2147483647){Y=p1c(n|0)|0;if((Y|0)==((f[Z>>2]|0)+(f[ba>>2]|0)|0))if((Y|0)==(-1|0))ca=n;else{da=n;ea=Y;H=135;break b}else{fa=Y;ga=n;H=126}}else ca=0}else H=118;while(0);do if((H|0)==118){X=p1c(0)|0;if((X|0)!=(-1|0)?(e=X,n=f[223725]|0,Y=n+-1|0,U=((Y&e|0)==0?0:(Y+e&0-n)-e|0)+aa|0,e=f[223714]|0,n=U+e|0,U>>>0>B>>>0&U>>>0<2147483647):0){Y=f[223716]|0;if(Y|0?n>>>0<=e>>>0|n>>>0>Y>>>0:0){ca=0;break}Y=p1c(U|0)|0;if((Y|0)==(X|0)){da=U;ea=X;H=135;break b}else{fa=Y;ga=U;H=126}}else ca=0}while(0);do if((H|0)==126){U=0-ga|0;if(!(S>>>0>ga>>>0&(ga>>>0<2147483647&(fa|0)!=(-1|0))))if((fa|0)==(-1|0)){ca=0;break}else{da=ga;ea=fa;H=135;break b}Y=f[223726]|0;X=c-ga+Y&0-Y;if(X>>>0>=2147483647){da=ga;ea=fa;H=135;break b}if((p1c(X|0)|0)==(-1|0)){p1c(U|0)|0;ca=0;break}else{da=X+ga|0;ea=fa;H=135;break b}}while(0);f[223717]=f[223717]|4;ha=ca;H=133}else{ha=0;H=133}while(0);if(((H|0)==133?aa>>>0<2147483647:0)?(ca=p1c(aa|0)|0,aa=p1c(0)|0,fa=aa-ca|0,ga=fa>>>0>(B+40|0)>>>0,!((ca|0)==(-1|0)|ga^1|ca>>>0<aa>>>0&((ca|0)!=(-1|0)&(aa|0)!=(-1|0))^1)):0){da=ga?fa:ha;ea=ca;H=135}if((H|0)==135){ca=(f[223714]|0)+da|0;f[223714]=ca;if(ca>>>0>(f[223715]|0)>>>0)f[223715]=ca;ca=f[223612]|0;do if(ca){ha=894872;while(1){ia=f[ha>>2]|0;ja=ha+4|0;ka=f[ja>>2]|0;if((ea|0)==(ia+ka|0)){H=145;break}fa=f[ha+8>>2]|0;if(!fa)break;else ha=fa}if(((H|0)==145?(f[ha+12>>2]&8|0)==0:0)?ca>>>0<ea>>>0&ca>>>0>=ia>>>0:0){f[ja>>2]=ka+da;fa=ca+8|0;ga=(fa&7|0)==0?0:0-fa&7;fa=ca+ga|0;aa=(f[223609]|0)+(da-ga)|0;f[223612]=fa;f[223609]=aa;f[fa+4>>2]=aa|1;f[fa+aa+4>>2]=40;f[223613]=f[223728];break}if(ea>>>0<(f[223610]|0)>>>0)f[223610]=ea;aa=ea+da|0;fa=894872;while(1){if((f[fa>>2]|0)==(aa|0)){H=153;break}ga=f[fa+8>>2]|0;if(!ga)break;else fa=ga}if((H|0)==153?(f[fa+12>>2]&8|0)==0:0){f[fa>>2]=ea;ha=fa+4|0;f[ha>>2]=(f[ha>>2]|0)+da;ha=ea+8|0;ga=ea+((ha&7|0)==0?0:0-ha&7)|0;ha=aa+8|0;c=aa+((ha&7|0)==0?0:0-ha&7)|0;ha=ga+B|0;S=c-ga-B|0;f[ga+4>>2]=B|3;do if((c|0)!=(ca|0)){if((c|0)==(f[223611]|0)){ba=(f[223608]|0)+S|0;f[223608]=ba;f[223611]=ha;f[ha+4>>2]=ba|1;f[ha+ba>>2]=ba;break}ba=f[c+4>>2]|0;if((ba&3|0)==1){_=ba&-8;$=ba>>>3;d:do if(ba>>>0<256){T=f[c+8>>2]|0;X=f[c+12>>2]|0;if((X|0)==(T|0)){f[223606]=f[223606]&~(1<<$);break}else{f[T+12>>2]=X;f[X+8>>2]=T;break}}else{T=f[c+24>>2]|0;X=f[c+12>>2]|0;do if((X|0)==(c|0)){U=c+16|0;Y=U+4|0;n=f[Y>>2]|0;if(!n){e=f[U>>2]|0;if(!e){la=0;break}else{ma=e;na=U}}else{ma=n;na=Y}while(1){Y=ma+20|0;n=f[Y>>2]|0;if(n|0){ma=n;na=Y;continue}Y=ma+16|0;n=f[Y>>2]|0;if(!n)break;else{ma=n;na=Y}}f[na>>2]=0;la=ma}else{Y=f[c+8>>2]|0;f[Y+12>>2]=X;f[X+8>>2]=Y;la=X}while(0);if(!T)break;X=f[c+28>>2]|0;Y=894728+(X<<2)|0;do if((c|0)!=(f[Y>>2]|0)){f[T+16+(((f[T+16>>2]|0)!=(c|0)&1)<<2)>>2]=la;if(!la)break d}else{f[Y>>2]=la;if(la|0)break;f[223607]=f[223607]&~(1<<X);break d}while(0);f[la+24>>2]=T;X=c+16|0;Y=f[X>>2]|0;if(Y|0){f[la+16>>2]=Y;f[Y+24>>2]=la}Y=f[X+4>>2]|0;if(!Y)break;f[la+20>>2]=Y;f[Y+24>>2]=la}while(0);oa=c+_|0;pa=_+S|0}else{oa=c;pa=S}$=oa+4|0;f[$>>2]=f[$>>2]&-2;f[ha+4>>2]=pa|1;f[ha+pa>>2]=pa;$=pa>>>3;if(pa>>>0<256){ba=894464+($<<1<<2)|0;Z=f[223606]|0;Y=1<<$;if(!(Z&Y)){f[223606]=Z|Y;qa=ba;ra=ba+8|0}else{Y=ba+8|0;qa=f[Y>>2]|0;ra=Y}f[ra>>2]=ha;f[qa+12>>2]=ha;f[ha+8>>2]=qa;f[ha+12>>2]=ba;break}ba=pa>>>8;do if(!ba)sa=0;else{if(pa>>>0>16777215){sa=31;break}Y=(ba+1048320|0)>>>16&8;Z=ba<<Y;$=(Z+520192|0)>>>16&4;X=Z<<$;Z=(X+245760|0)>>>16&2;n=14-($|Y|Z)+(X<<Z>>>15)|0;sa=pa>>>(n+7|0)&1|n<<1}while(0);ba=894728+(sa<<2)|0;f[ha+28>>2]=sa;_=ha+16|0;f[_+4>>2]=0;f[_>>2]=0;_=f[223607]|0;n=1<<sa;if(!(_&n)){f[223607]=_|n;f[ba>>2]=ha;f[ha+24>>2]=ba;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}n=pa<<((sa|0)==31?0:25-(sa>>>1)|0);_=f[ba>>2]|0;while(1){if((f[_+4>>2]&-8|0)==(pa|0)){H=194;break}ta=_+16+(n>>>31<<2)|0;ba=f[ta>>2]|0;if(!ba){H=193;break}else{n=n<<1;_=ba}}if((H|0)==193){f[ta>>2]=ha;f[ha+24>>2]=_;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}else if((H|0)==194){n=_+8|0;ba=f[n>>2]|0;f[ba+12>>2]=ha;f[n>>2]=ha;f[ha+8>>2]=ba;f[ha+12>>2]=_;f[ha+24>>2]=0;break}}else{ba=(f[223609]|0)+S|0;f[223609]=ba;f[223612]=ha;f[ha+4>>2]=ba|1}while(0);o=ga+8|0;u=b;return o|0}ha=894872;while(1){S=f[ha>>2]|0;if(S>>>0<=ca>>>0?(ua=S+(f[ha+4>>2]|0)|0,ua>>>0>ca>>>0):0)break;ha=f[ha+8>>2]|0}ha=ua+-47|0;ga=ha+8|0;S=ha+((ga&7|0)==0?0:0-ga&7)|0;ga=ca+16|0;ha=S>>>0<ga>>>0?ca:S;S=ha+8|0;c=ea+8|0;aa=(c&7|0)==0?0:0-c&7;c=ea+aa|0;fa=da+-40-aa|0;f[223612]=c;f[223609]=fa;f[c+4>>2]=fa|1;f[c+fa+4>>2]=40;f[223613]=f[223728];fa=ha+4|0;f[fa>>2]=27;f[S>>2]=f[223718];f[S+4>>2]=f[223719];f[S+8>>2]=f[223720];f[S+12>>2]=f[223721];f[223718]=ea;f[223719]=da;f[223721]=0;f[223720]=S;S=ha+24|0;do{c=S;S=S+4|0;f[S>>2]=7}while((c+8|0)>>>0<ua>>>0);if((ha|0)!=(ca|0)){S=ha-ca|0;f[fa>>2]=f[fa>>2]&-2;f[ca+4>>2]=S|1;f[ha>>2]=S;c=S>>>3;if(S>>>0<256){aa=894464+(c<<1<<2)|0;ba=f[223606]|0;n=1<<c;if(!(ba&n)){f[223606]=ba|n;va=aa;wa=aa+8|0}else{n=aa+8|0;va=f[n>>2]|0;wa=n}f[wa>>2]=ca;f[va+12>>2]=ca;f[ca+8>>2]=va;f[ca+12>>2]=aa;break}aa=S>>>8;if(aa)if(S>>>0>16777215)xa=31;else{n=(aa+1048320|0)>>>16&8;ba=aa<<n;aa=(ba+520192|0)>>>16&4;c=ba<<aa;ba=(c+245760|0)>>>16&2;Z=14-(aa|n|ba)+(c<<ba>>>15)|0;xa=S>>>(Z+7|0)&1|Z<<1}else xa=0;Z=894728+(xa<<2)|0;f[ca+28>>2]=xa;f[ca+20>>2]=0;f[ga>>2]=0;ba=f[223607]|0;c=1<<xa;if(!(ba&c)){f[223607]=ba|c;f[Z>>2]=ca;f[ca+24>>2]=Z;f[ca+12>>2]=ca;f[ca+8>>2]=ca;break}c=S<<((xa|0)==31?0:25-(xa>>>1)|0);ba=f[Z>>2]|0;while(1){if((f[ba+4>>2]&-8|0)==(S|0)){H=216;break}ya=ba+16+(c>>>31<<2)|0;Z=f[ya>>2]|0;if(!Z){H=215;break}else{c=c<<1;ba=Z}}if((H|0)==215){f[ya>>2]=ca;f[ca+24>>2]=ba;f[ca+12>>2]=ca;f[ca+8>>2]=ca;break}else if((H|0)==216){c=ba+8|0;S=f[c>>2]|0;f[S+12>>2]=ca;f[c>>2]=ca;f[ca+8>>2]=S;f[ca+12>>2]=ba;f[ca+24>>2]=0;break}}}else{S=f[223610]|0;if((S|0)==0|ea>>>0<S>>>0)f[223610]=ea;f[223718]=ea;f[223719]=da;f[223721]=0;f[223615]=f[223724];f[223614]=-1;S=0;do{c=894464+(S<<1<<2)|0;f[c+12>>2]=c;f[c+8>>2]=c;S=S+1|0}while((S|0)!=32);S=ea+8|0;ba=(S&7|0)==0?0:0-S&7;S=ea+ba|0;c=da+-40-ba|0;f[223612]=S;f[223609]=c;f[S+4>>2]=c|1;f[S+c+4>>2]=40;f[223613]=f[223728]}while(0);da=f[223609]|0;if(da>>>0>B>>>0){ea=da-B|0;f[223609]=ea;da=f[223612]|0;ca=da+B|0;f[223612]=ca;f[ca+4>>2]=ea|1;f[da+4>>2]=B|3;o=da+8|0;u=b;return o|0}}da=vIc()|0;f[da>>2]=12;o=0;u=b;return o|0}function kIc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;if(!a)return;b=a+-8|0;c=f[223610]|0;d=f[a+-4>>2]|0;a=d&-8;e=b+a|0;do if(!(d&1)){g=f[b>>2]|0;if(!(d&3))return;h=b+(0-g)|0;i=g+a|0;if(h>>>0<c>>>0)return;if((h|0)==(f[223611]|0)){j=e+4|0;k=f[j>>2]|0;if((k&3|0)!=3){l=h;m=i;n=h;break}f[223608]=i;f[j>>2]=k&-2;f[h+4>>2]=i|1;f[h+i>>2]=i;return}k=g>>>3;if(g>>>0<256){g=f[h+8>>2]|0;j=f[h+12>>2]|0;if((j|0)==(g|0)){f[223606]=f[223606]&~(1<<k);l=h;m=i;n=h;break}else{f[g+12>>2]=j;f[j+8>>2]=g;l=h;m=i;n=h;break}}g=f[h+24>>2]|0;j=f[h+12>>2]|0;do if((j|0)==(h|0)){k=h+16|0;o=k+4|0;p=f[o>>2]|0;if(!p){q=f[k>>2]|0;if(!q){r=0;break}else{s=q;t=k}}else{s=p;t=o}while(1){o=s+20|0;p=f[o>>2]|0;if(p|0){s=p;t=o;continue}o=s+16|0;p=f[o>>2]|0;if(!p)break;else{s=p;t=o}}f[t>>2]=0;r=s}else{o=f[h+8>>2]|0;f[o+12>>2]=j;f[j+8>>2]=o;r=j}while(0);if(g){j=f[h+28>>2]|0;o=894728+(j<<2)|0;if((h|0)==(f[o>>2]|0)){f[o>>2]=r;if(!r){f[223607]=f[223607]&~(1<<j);l=h;m=i;n=h;break}}else{f[g+16+(((f[g+16>>2]|0)!=(h|0)&1)<<2)>>2]=r;if(!r){l=h;m=i;n=h;break}}f[r+24>>2]=g;j=h+16|0;o=f[j>>2]|0;if(o|0){f[r+16>>2]=o;f[o+24>>2]=r}o=f[j+4>>2]|0;if(o){f[r+20>>2]=o;f[o+24>>2]=r;l=h;m=i;n=h}else{l=h;m=i;n=h}}else{l=h;m=i;n=h}}else{l=b;m=a;n=b}while(0);if(n>>>0>=e>>>0)return;b=e+4|0;a=f[b>>2]|0;if(!(a&1))return;if(!(a&2)){r=f[223611]|0;if((e|0)==(f[223612]|0)){s=(f[223609]|0)+m|0;f[223609]=s;f[223612]=l;f[l+4>>2]=s|1;if((l|0)!=(r|0))return;f[223611]=0;f[223608]=0;return}if((e|0)==(r|0)){r=(f[223608]|0)+m|0;f[223608]=r;f[223611]=n;f[l+4>>2]=r|1;f[n+r>>2]=r;return}r=(a&-8)+m|0;s=a>>>3;do if(a>>>0<256){t=f[e+8>>2]|0;c=f[e+12>>2]|0;if((c|0)==(t|0)){f[223606]=f[223606]&~(1<<s);break}else{f[t+12>>2]=c;f[c+8>>2]=t;break}}else{t=f[e+24>>2]|0;c=f[e+12>>2]|0;do if((c|0)==(e|0)){d=e+16|0;o=d+4|0;j=f[o>>2]|0;if(!j){p=f[d>>2]|0;if(!p){u=0;break}else{v=p;w=d}}else{v=j;w=o}while(1){o=v+20|0;j=f[o>>2]|0;if(j|0){v=j;w=o;continue}o=v+16|0;j=f[o>>2]|0;if(!j)break;else{v=j;w=o}}f[w>>2]=0;u=v}else{o=f[e+8>>2]|0;f[o+12>>2]=c;f[c+8>>2]=o;u=c}while(0);if(t|0){c=f[e+28>>2]|0;h=894728+(c<<2)|0;if((e|0)==(f[h>>2]|0)){f[h>>2]=u;if(!u){f[223607]=f[223607]&~(1<<c);break}}else{f[t+16+(((f[t+16>>2]|0)!=(e|0)&1)<<2)>>2]=u;if(!u)break}f[u+24>>2]=t;c=e+16|0;h=f[c>>2]|0;if(h|0){f[u+16>>2]=h;f[h+24>>2]=u}h=f[c+4>>2]|0;if(h|0){f[u+20>>2]=h;f[h+24>>2]=u}}}while(0);f[l+4>>2]=r|1;f[n+r>>2]=r;if((l|0)==(f[223611]|0)){f[223608]=r;return}else x=r}else{f[b>>2]=a&-2;f[l+4>>2]=m|1;f[n+m>>2]=m;x=m}m=x>>>3;if(x>>>0<256){n=894464+(m<<1<<2)|0;a=f[223606]|0;b=1<<m;if(!(a&b)){f[223606]=a|b;y=n;z=n+8|0}else{b=n+8|0;y=f[b>>2]|0;z=b}f[z>>2]=l;f[y+12>>2]=l;f[l+8>>2]=y;f[l+12>>2]=n;return}n=x>>>8;if(n)if(x>>>0>16777215)A=31;else{y=(n+1048320|0)>>>16&8;z=n<<y;n=(z+520192|0)>>>16&4;b=z<<n;z=(b+245760|0)>>>16&2;a=14-(n|y|z)+(b<<z>>>15)|0;A=x>>>(a+7|0)&1|a<<1}else A=0;a=894728+(A<<2)|0;f[l+28>>2]=A;f[l+20>>2]=0;f[l+16>>2]=0;z=f[223607]|0;b=1<<A;do if(z&b){y=x<<((A|0)==31?0:25-(A>>>1)|0);n=f[a>>2]|0;while(1){if((f[n+4>>2]&-8|0)==(x|0)){B=73;break}C=n+16+(y>>>31<<2)|0;m=f[C>>2]|0;if(!m){B=72;break}else{y=y<<1;n=m}}if((B|0)==72){f[C>>2]=l;f[l+24>>2]=n;f[l+12>>2]=l;f[l+8>>2]=l;break}else if((B|0)==73){y=n+8|0;t=f[y>>2]|0;f[t+12>>2]=l;f[y>>2]=l;f[l+8>>2]=t;f[l+12>>2]=n;f[l+24>>2]=0;break}}else{f[223607]=z|b;f[a>>2]=l;f[l+24>>2]=a;f[l+12>>2]=l;f[l+8>>2]=l}while(0);l=(f[223614]|0)+-1|0;f[223614]=l;if(!l)D=894880;else return;while(1){l=f[D>>2]|0;if(!l)break;else D=l+8|0}f[223614]=-1;return}function lIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if(!a){c=jIc(b)|0;return c|0}if(b>>>0>4294967231){d=vIc()|0;f[d>>2]=12;c=0;return c|0}d=mIc(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){c=d+8|0;return c|0}d=jIc(b)|0;if(!d){c=0;return c|0}e=f[a+-4>>2]|0;g=(e&-8)-((e&3|0)==0?8:4)|0;o1c(d|0,a|0,(g>>>0<b>>>0?g:b)|0)|0;kIc(a);c=d;return c|0}function mIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=d&-8;g=a+e|0;if(!(d&3)){if(b>>>0<256){h=0;return h|0}if(e>>>0>=(b+4|0)>>>0?(e-b|0)>>>0<=f[223726]<<1>>>0:0){h=a;return h|0}h=0;return h|0}if(e>>>0>=b>>>0){i=e-b|0;if(i>>>0<=15){h=a;return h|0}j=a+b|0;f[c>>2]=d&1|b|2;f[j+4>>2]=i|3;k=j+i+4|0;f[k>>2]=f[k>>2]|1;nIc(j,i);h=a;return h|0}if((g|0)==(f[223612]|0)){i=(f[223609]|0)+e|0;j=i-b|0;k=a+b|0;if(i>>>0<=b>>>0){h=0;return h|0}f[c>>2]=d&1|b|2;f[k+4>>2]=j|1;f[223612]=k;f[223609]=j;h=a;return h|0}if((g|0)==(f[223611]|0)){j=(f[223608]|0)+e|0;if(j>>>0<b>>>0){h=0;return h|0}k=j-b|0;i=d&1;if(k>>>0>15){l=a+b|0;m=l+k|0;f[c>>2]=i|b|2;f[l+4>>2]=k|1;f[m>>2]=k;n=m+4|0;f[n>>2]=f[n>>2]&-2;o=l;p=k}else{f[c>>2]=i|j|2;i=a+j+4|0;f[i>>2]=f[i>>2]|1;o=0;p=0}f[223608]=p;f[223611]=o;h=a;return h|0}o=f[g+4>>2]|0;if(o&2|0){h=0;return h|0}p=(o&-8)+e|0;if(p>>>0<b>>>0){h=0;return h|0}e=p-b|0;i=o>>>3;do if(o>>>0<256){j=f[g+8>>2]|0;k=f[g+12>>2]|0;if((k|0)==(j|0)){f[223606]=f[223606]&~(1<<i);break}else{f[j+12>>2]=k;f[k+8>>2]=j;break}}else{j=f[g+24>>2]|0;k=f[g+12>>2]|0;do if((k|0)==(g|0)){l=g+16|0;n=l+4|0;m=f[n>>2]|0;if(!m){q=f[l>>2]|0;if(!q){r=0;break}else{s=q;t=l}}else{s=m;t=n}while(1){n=s+20|0;m=f[n>>2]|0;if(m|0){s=m;t=n;continue}n=s+16|0;m=f[n>>2]|0;if(!m)break;else{s=m;t=n}}f[t>>2]=0;r=s}else{n=f[g+8>>2]|0;f[n+12>>2]=k;f[k+8>>2]=n;r=k}while(0);if(j|0){k=f[g+28>>2]|0;n=894728+(k<<2)|0;if((g|0)==(f[n>>2]|0)){f[n>>2]=r;if(!r){f[223607]=f[223607]&~(1<<k);break}}else{f[j+16+(((f[j+16>>2]|0)!=(g|0)&1)<<2)>>2]=r;if(!r)break}f[r+24>>2]=j;k=g+16|0;n=f[k>>2]|0;if(n|0){f[r+16>>2]=n;f[n+24>>2]=r}n=f[k+4>>2]|0;if(n|0){f[r+20>>2]=n;f[n+24>>2]=r}}}while(0);r=d&1;if(e>>>0<16){f[c>>2]=p|r|2;d=a+p+4|0;f[d>>2]=f[d>>2]|1;h=a;return h|0}else{d=a+b|0;f[c>>2]=r|b|2;f[d+4>>2]=e|3;b=d+e+4|0;f[b>>2]=f[b>>2]|1;nIc(d,e);h=a;return h|0}return 0}function nIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+b|0;d=f[a+4>>2]|0;do if(!(d&1)){e=f[a>>2]|0;if(!(d&3))return;g=a+(0-e)|0;h=e+b|0;if((g|0)==(f[223611]|0)){i=c+4|0;j=f[i>>2]|0;if((j&3|0)!=3){k=g;l=h;break}f[223608]=h;f[i>>2]=j&-2;f[g+4>>2]=h|1;f[g+h>>2]=h;return}j=e>>>3;if(e>>>0<256){e=f[g+8>>2]|0;i=f[g+12>>2]|0;if((i|0)==(e|0)){f[223606]=f[223606]&~(1<<j);k=g;l=h;break}else{f[e+12>>2]=i;f[i+8>>2]=e;k=g;l=h;break}}e=f[g+24>>2]|0;i=f[g+12>>2]|0;do if((i|0)==(g|0)){j=g+16|0;m=j+4|0;n=f[m>>2]|0;if(!n){o=f[j>>2]|0;if(!o){p=0;break}else{q=o;r=j}}else{q=n;r=m}while(1){m=q+20|0;n=f[m>>2]|0;if(n|0){q=n;r=m;continue}m=q+16|0;n=f[m>>2]|0;if(!n)break;else{q=n;r=m}}f[r>>2]=0;p=q}else{m=f[g+8>>2]|0;f[m+12>>2]=i;f[i+8>>2]=m;p=i}while(0);if(e){i=f[g+28>>2]|0;m=894728+(i<<2)|0;if((g|0)==(f[m>>2]|0)){f[m>>2]=p;if(!p){f[223607]=f[223607]&~(1<<i);k=g;l=h;break}}else{f[e+16+(((f[e+16>>2]|0)!=(g|0)&1)<<2)>>2]=p;if(!p){k=g;l=h;break}}f[p+24>>2]=e;i=g+16|0;m=f[i>>2]|0;if(m|0){f[p+16>>2]=m;f[m+24>>2]=p}m=f[i+4>>2]|0;if(m){f[p+20>>2]=m;f[m+24>>2]=p;k=g;l=h}else{k=g;l=h}}else{k=g;l=h}}else{k=a;l=b}while(0);b=c+4|0;a=f[b>>2]|0;if(!(a&2)){p=f[223611]|0;if((c|0)==(f[223612]|0)){q=(f[223609]|0)+l|0;f[223609]=q;f[223612]=k;f[k+4>>2]=q|1;if((k|0)!=(p|0))return;f[223611]=0;f[223608]=0;return}if((c|0)==(p|0)){p=(f[223608]|0)+l|0;f[223608]=p;f[223611]=k;f[k+4>>2]=p|1;f[k+p>>2]=p;return}p=(a&-8)+l|0;q=a>>>3;do if(a>>>0<256){r=f[c+8>>2]|0;d=f[c+12>>2]|0;if((d|0)==(r|0)){f[223606]=f[223606]&~(1<<q);break}else{f[r+12>>2]=d;f[d+8>>2]=r;break}}else{r=f[c+24>>2]|0;d=f[c+12>>2]|0;do if((d|0)==(c|0)){m=c+16|0;i=m+4|0;n=f[i>>2]|0;if(!n){j=f[m>>2]|0;if(!j){s=0;break}else{t=j;u=m}}else{t=n;u=i}while(1){i=t+20|0;n=f[i>>2]|0;if(n|0){t=n;u=i;continue}i=t+16|0;n=f[i>>2]|0;if(!n)break;else{t=n;u=i}}f[u>>2]=0;s=t}else{i=f[c+8>>2]|0;f[i+12>>2]=d;f[d+8>>2]=i;s=d}while(0);if(r|0){d=f[c+28>>2]|0;h=894728+(d<<2)|0;if((c|0)==(f[h>>2]|0)){f[h>>2]=s;if(!s){f[223607]=f[223607]&~(1<<d);break}}else{f[r+16+(((f[r+16>>2]|0)!=(c|0)&1)<<2)>>2]=s;if(!s)break}f[s+24>>2]=r;d=c+16|0;h=f[d>>2]|0;if(h|0){f[s+16>>2]=h;f[h+24>>2]=s}h=f[d+4>>2]|0;if(h|0){f[s+20>>2]=h;f[h+24>>2]=s}}}while(0);f[k+4>>2]=p|1;f[k+p>>2]=p;if((k|0)==(f[223611]|0)){f[223608]=p;return}else v=p}else{f[b>>2]=a&-2;f[k+4>>2]=l|1;f[k+l>>2]=l;v=l}l=v>>>3;if(v>>>0<256){a=894464+(l<<1<<2)|0;b=f[223606]|0;p=1<<l;if(!(b&p)){f[223606]=b|p;w=a;x=a+8|0}else{p=a+8|0;w=f[p>>2]|0;x=p}f[x>>2]=k;f[w+12>>2]=k;f[k+8>>2]=w;f[k+12>>2]=a;return}a=v>>>8;if(a)if(v>>>0>16777215)y=31;else{w=(a+1048320|0)>>>16&8;x=a<<w;a=(x+520192|0)>>>16&4;p=x<<a;x=(p+245760|0)>>>16&2;b=14-(a|w|x)+(p<<x>>>15)|0;y=v>>>(b+7|0)&1|b<<1}else y=0;b=894728+(y<<2)|0;f[k+28>>2]=y;f[k+20>>2]=0;f[k+16>>2]=0;x=f[223607]|0;p=1<<y;if(!(x&p)){f[223607]=x|p;f[b>>2]=k;f[k+24>>2]=b;f[k+12>>2]=k;f[k+8>>2]=k;return}p=v<<((y|0)==31?0:25-(y>>>1)|0);y=f[b>>2]|0;while(1){if((f[y+4>>2]&-8|0)==(v|0)){z=69;break}A=y+16+(p>>>31<<2)|0;b=f[A>>2]|0;if(!b){z=68;break}else{p=p<<1;y=b}}if((z|0)==68){f[A>>2]=k;f[k+24>>2]=y;f[k+12>>2]=k;f[k+8>>2]=k;return}else if((z|0)==69){z=y+8|0;A=f[z>>2]|0;f[A+12>>2]=k;f[z>>2]=k;f[k+8>>2]=A;f[k+12>>2]=y;f[k+24>>2]=0;return}}function oIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a>>>0>16?a:16;if(!(c+-1&c))d=c;else{a=16;while(1)if(a>>>0<c>>>0)a=a<<1;else{d=a;break}}if((-64-d|0)>>>0<=b>>>0){a=vIc()|0;f[a>>2]=12;e=0;return e|0}a=b>>>0<11?16:b+11&-8;b=jIc(a+12+d|0)|0;if(!b){e=0;return e|0}c=b+-8|0;do if(b&d+-1){g=(b+d+-1&0-d)+-8|0;h=c;i=(g-h|0)>>>0>15?g:g+d|0;g=i-h|0;h=b+-4|0;j=f[h>>2]|0;k=(j&-8)-g|0;if(!(j&3)){f[i>>2]=(f[c>>2]|0)+g;f[i+4>>2]=k;l=i;m=i;break}else{j=i+4|0;f[j>>2]=k|f[j>>2]&1|2;n=i+k+4|0;f[n>>2]=f[n>>2]|1;f[h>>2]=g|f[h>>2]&1|2;f[j>>2]=f[j>>2]|1;nIc(c,g);l=i;m=i;break}}else{l=c;m=c}while(0);c=l+4|0;l=f[c>>2]|0;if(l&3|0?(b=l&-8,b>>>0>(a+16|0)>>>0):0){d=b-a|0;b=m+a|0;f[c>>2]=a|l&1|2;f[b+4>>2]=d|3;l=b+d+4|0;f[l>>2]=f[l>>2]|1;nIc(b,d)}e=m+8|0;return e|0}function pIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;do if((b|0)!=8){d=b>>>2;if((b&3|0)!=0|(d|0)==0){e=22;return e|0}if(d+1073741823&d|0){e=22;return e|0}if((-64-b|0)>>>0<c>>>0){e=12;return e|0}else{g=oIc(b>>>0>16?b:16,c)|0;break}}else g=jIc(c)|0;while(0);if(!g){e=12;return e|0}f[a>>2]=g;e=0;return e|0}function qIc(){return 894944}function rIc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=zIc(f[a+60>>2]|0)|0;f[c>>2]=d;d=uIc(Ne(6,c|0)|0)|0;u=b;return d|0}function sIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;f[a+36>>2]=228;if((f[a>>2]&64|0)==0?(f[g>>2]=f[a+60>>2],f[g+4>>2]=21523,f[g+8>>2]=e+16,Xe(54,g|0)|0):0)b[a+75>>0]=-1;g=yIc(a,c,d)|0;u=e;return g|0}function tIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=f[a+60>>2];f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;if((uIc(ge(140,e|0)|0)|0)<0){f[g>>2]=-1;h=-1}else h=f[g>>2]|0;u=d;return h|0}function uIc(a){a=a|0;var b=0,c=0;if(a>>>0>4294963200){b=vIc()|0;f[b>>2]=0-a;c=-1}else c=a;return c|0}function vIc(){return (wIc()|0)+64|0}function wIc(){return xIc()|0}function xIc(){return 184620}function yIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;i=a+28|0;j=f[i>>2]|0;f[h>>2]=j;k=a+20|0;l=(f[k>>2]|0)-j|0;f[h+4>>2]=l;f[h+8>>2]=b;f[h+12>>2]=c;b=l+c|0;l=a+60|0;f[g>>2]=f[l>>2];f[g+4>>2]=h;f[g+8>>2]=2;j=uIc(je(146,g|0)|0)|0;a:do if((b|0)!=(j|0)){g=2;m=b;n=h;o=j;while(1){if((o|0)<0)break;m=m-o|0;p=f[n+4>>2]|0;q=o>>>0>p>>>0;r=q?n+8|0:n;s=(q<<31>>31)+g|0;t=o-(q?p:0)|0;f[r>>2]=(f[r>>2]|0)+t;p=r+4|0;f[p>>2]=(f[p>>2]|0)-t;f[e>>2]=f[l>>2];f[e+4>>2]=r;f[e+8>>2]=s;o=uIc(je(146,e|0)|0)|0;if((m|0)==(o|0)){v=3;break a}else{g=s;n=r}}f[a+16>>2]=0;f[i>>2]=0;f[k>>2]=0;f[a>>2]=f[a>>2]|32;if((g|0)==2)w=0;else w=c-(f[n+4>>2]|0)|0}else v=3;while(0);if((v|0)==3){v=f[a+44>>2]|0;f[a+16>>2]=v+(f[a+48>>2]|0);f[i>>2]=v;f[k>>2]=v;w=c}u=d;return w|0}function zIc(a){a=a|0;return a|0}function AIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=e+16|0;f[h>>2]=c;i=h+4|0;j=a+48|0;k=f[j>>2]|0;f[i>>2]=d-((k|0)!=0&1);l=a+44|0;f[h+8>>2]=f[l>>2];f[h+12>>2]=k;f[g>>2]=f[a+60>>2];f[g+4>>2]=h;f[g+8>>2]=2;h=uIc(ie(145,g|0)|0)|0;if((h|0)>=1){g=f[i>>2]|0;if(h>>>0>g>>>0){i=f[l>>2]|0;l=a+4|0;f[l>>2]=i;f[a+8>>2]=i+(h-g);if(!(f[j>>2]|0))m=d;else{f[l>>2]=i+1;b[c+(d+-1)>>0]=b[i>>0]|0;m=d}}else m=h}else{f[a>>2]=f[a>>2]|h&48^16;m=h}u=e;return m|0}function BIc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=0;while(1){if((h[521451+d>>0]|0)==(a|0)){e=2;break}g=d+1|0;if((g|0)==87){i=521539;j=87;e=5;break}else d=g}if((e|0)==2)if(!d)k=521539;else{i=521539;j=d;e=5}if((e|0)==5)while(1){e=0;d=i;do{a=d;d=d+1|0}while((b[a>>0]|0)!=0);j=j+-1|0;if(!j){k=d;break}else{i=d;e=5}}return CIc(k,f[c+20>>2]|0)|0}function CIc(a,b){a=a|0;b=b|0;return DIc(a,b)|0}function DIc(a,b){a=a|0;b=b|0;var c=0;if(!b)c=0;else c=EIc(f[b>>2]|0,f[b+4>>2]|0,a)|0;return (c|0?c:a)|0}function EIc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=(f[a>>2]|0)+1794895138|0;g=FIc(f[a+8>>2]|0,e)|0;h=FIc(f[a+12>>2]|0,e)|0;i=FIc(f[a+16>>2]|0,e)|0;a:do if((g>>>0<c>>>2>>>0?(j=c-(g<<2)|0,h>>>0<j>>>0&i>>>0<j>>>0):0)?((i|h)&3|0)==0:0){j=h>>>2;k=i>>>2;l=0;m=g;while(1){n=m>>>1;o=l+n|0;p=o<<1;q=p+j|0;r=FIc(f[a+(q<<2)>>2]|0,e)|0;s=FIc(f[a+(q+1<<2)>>2]|0,e)|0;if(!(s>>>0<c>>>0&r>>>0<(c-s|0)>>>0)){t=0;break a}if(b[a+(s+r)>>0]|0){t=0;break a}r=GIc(d,a+s|0)|0;if(!r)break;s=(r|0)<0;if((m|0)==1){t=0;break a}else{l=s?l:o;m=s?n:m-n|0}}m=p+k|0;l=FIc(f[a+(m<<2)>>2]|0,e)|0;j=FIc(f[a+(m+1<<2)>>2]|0,e)|0;if(j>>>0<c>>>0&l>>>0<(c-j|0)>>>0)t=(b[a+(j+l)>>0]|0)==0?a+j|0:0;else t=0}else t=0;while(0);return t|0}function FIc(a,b){a=a|0;b=b|0;var c=0;c=s1c(a|0)|0;return ((b|0)==0?a:c)|0}function GIc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=b[a>>0]|0;e=b[c>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=e<<24>>24){f=e;g=d}else{d=c;c=a;do{c=c+1|0;d=d+1|0;a=b[c>>0]|0;e=b[d>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=e<<24>>24));f=e;g=a}return (g&255)-(f&255)|0}function HIc(a){a=a|0;var b=0;b=(IIc()|0)+188|0;return BIc(a,f[b>>2]|0)|0}function IIc(){return xIc()|0}function JIc(a){a=a|0;return 0}function KIc(a){a=a|0;return 0}function LIc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=zIc(a)|0;f[c>>2]=d;d=Ne(6,c|0)|0;c=uIc((d|0)==-4?0:d)|0;u=b;return c|0}function MIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;if(!(b&4194368))i=0;else{f[h>>2]=c;c=(f[h>>2]|0)+(4-1)&~(4-1);j=f[c>>2]|0;f[h>>2]=c+4;i=j}f[g>>2]=a;f[g+4>>2]=b|32768;f[g+8>>2]=i;i=Oe(5,g|0)|0;if(!((b&524288|0)==0|(i|0)<0)){f[e>>2]=i;f[e+4>>2]=2;f[e+8>>2]=1;zd(221,e|0)|0}e=uIc(i)|0;u=d;return e|0}function NIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=a;f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;c=(uIc(ge(140,e|0)|0)|0)!=0;u=d;return (c?-1:f[g>>2]|0)|0}function OIc(a){a=a|0;var b=0;b=(PIc(a)|0)==0;return (b?a:a|32)|0}function PIc(a){a=a|0;return (a+-65|0)>>>0<26|0}function QIc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=RIc(a,b,c)|0;return d|0}function RIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=SIc(a,b,c,-1,-1)|0;return d|0}function SIc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+128|0;h=g;f[h>>2]=0;i=h+4|0;f[i>>2]=a;f[h+44>>2]=a;j=h+8|0;f[j>>2]=(a|0)<0?-1:a+2147483647|0;f[h+76>>2]=-1;TIc(h,0);k=UIc(h,c,1,d,e)|0;if(b|0)f[b>>2]=a+((f[i>>2]|0)+(f[h+108>>2]|0)-(f[j>>2]|0));u=g;return k|0}function TIc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;f[a+104>>2]=b;c=f[a+8>>2]|0;d=f[a+4>>2]|0;e=c-d|0;f[a+108>>2]=e;f[a+100>>2]=(b|0)!=0&(e|0)>(b|0)?d+b|0:c;return}function UIc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;a:do if(c>>>0>36){i=vIc()|0;f[i>>2]=22;j=0;k=0}else{i=a+4|0;l=a+100|0;do{m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;n=h[m>>0]|0}else n=VIc(a)|0}while((WIc(n)|0)!=0);b:do switch(n|0){case 43:case 45:{m=((n|0)==45)<<31>>31;o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;p=m;q=h[o>>0]|0;break b}else{p=m;q=VIc(a)|0;break b}break}default:{p=0;q=n}}while(0);m=(c|0)==0;do if((c|16|0)==16&(q|0)==48){o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;r=h[o>>0]|0}else r=VIc(a)|0;if((r|32|0)!=120)if(m){s=r;t=8;u=46;break}else{v=r;w=c;u=32;break}o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;x=h[o>>0]|0}else x=VIc(a)|0;if((h[523344+x>>0]|0)>15){o=(f[l>>2]|0)!=0;if(o)f[i>>2]=(f[i>>2]|0)+-1;if(!d){TIc(a,0);j=0;k=0;break a}if(!o){j=0;k=0;break a}f[i>>2]=(f[i>>2]|0)+-1;j=0;k=0;break a}else{s=x;t=16;u=46}}else{o=m?10:c;if((h[523344+q>>0]|0)>>>0<o>>>0){v=q;w=o;u=32}else{if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;TIc(a,0);o=vIc()|0;f[o>>2]=22;j=0;k=0;break a}}while(0);c:do if((u|0)==32)if((w|0)==10){m=v+-48|0;if(m>>>0<10){o=0;y=m;do{o=(o*10|0)+y|0;m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;z=h[m>>0]|0}else z=VIc(a)|0;y=z+-48|0}while(y>>>0<10&o>>>0<429496729);A=z;B=o;C=0}else{A=v;B=0;C=0}y=A+-48|0;if(y>>>0<10){m=A;D=B;E=C;F=y;while(1){y=x1c(D|0,E|0,10,0)|0;G=J;H=((F|0)<0)<<31>>31;I=~H;if(G>>>0>I>>>0|(G|0)==(I|0)&y>>>0>~F>>>0){K=10;L=m;M=D;N=E;u=72;break c}D=d1c(y|0,G|0,F|0,H|0)|0;E=J;H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;O=h[H>>0]|0}else O=VIc(a)|0;F=O+-48|0;if(!(F>>>0<10&(E>>>0<429496729|(E|0)==429496729&D>>>0<2576980378)))break;else m=O}if(F>>>0>9){P=p;Q=E;R=D}else{K=10;L=O;M=D;N=E;u=72}}else{P=p;Q=C;R=B}}else{s=v;t=w;u=46}while(0);d:do if((u|0)==46){if(!(t+-1&t)){m=b[523600+((t*23|0)>>>5&7)>>0]|0;o=b[523344+s>>0]|0;H=o&255;if(H>>>0<t>>>0){G=0;y=H;do{G=y|G<<m;H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;S=h[H>>0]|0}else S=VIc(a)|0;T=b[523344+S>>0]|0;y=T&255}while(G>>>0<134217728&y>>>0<t>>>0);U=S;V=T;W=0;X=G}else{U=s;V=o;W=0;X=0}y=l1c(-1,-1,m|0)|0;E=J;if((V&255)>>>0>=t>>>0|(W>>>0>E>>>0|(W|0)==(E|0)&X>>>0>y>>>0)){K=t;L=U;M=X;N=W;u=72;break}else{Z=X;_=W;$=V}while(1){D=u1c(Z|0,_|0,m|0)|0;F=J;H=$&255|D;D=f[i>>2]|0;if(D>>>0<(f[l>>2]|0)>>>0){f[i>>2]=D+1;aa=h[D>>0]|0}else aa=VIc(a)|0;$=b[523344+aa>>0]|0;if(($&255)>>>0>=t>>>0|(F>>>0>E>>>0|(F|0)==(E|0)&H>>>0>y>>>0)){K=t;L=aa;M=H;N=F;u=72;break d}else{Z=H;_=F}}}y=b[523344+s>>0]|0;E=y&255;if(E>>>0<t>>>0){m=0;o=E;do{m=o+(Y(m,t)|0)|0;E=f[i>>2]|0;if(E>>>0<(f[l>>2]|0)>>>0){f[i>>2]=E+1;ba=h[E>>0]|0}else ba=VIc(a)|0;ca=b[523344+ba>>0]|0;o=ca&255}while(m>>>0<119304647&o>>>0<t>>>0);da=ba;ea=ca;fa=m;ga=0}else{da=s;ea=y;fa=0;ga=0}if((ea&255)>>>0<t>>>0){o=n1c(-1,-1,t|0,0)|0;E=J;G=da;F=ga;H=fa;D=ea;while(1){if(F>>>0>E>>>0|(F|0)==(E|0)&H>>>0>o>>>0){K=t;L=G;M=H;N=F;u=72;break d}I=x1c(H|0,F|0,t|0,0)|0;ha=J;ia=D&255;if(ha>>>0>4294967295|(ha|0)==-1&I>>>0>~ia>>>0){K=t;L=G;M=H;N=F;u=72;break d}ja=d1c(ia|0,0,I|0,ha|0)|0;ha=J;I=f[i>>2]|0;if(I>>>0<(f[l>>2]|0)>>>0){f[i>>2]=I+1;ka=h[I>>0]|0}else ka=VIc(a)|0;D=b[523344+ka>>0]|0;if((D&255)>>>0>=t>>>0){K=t;L=ka;M=ja;N=ha;u=72;break}else{G=ka;F=ha;H=ja}}}else{K=t;L=da;M=fa;N=ga;u=72}}while(0);if((u|0)==72)if((h[523344+L>>0]|0)>>>0<K>>>0){do{H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;la=h[H>>0]|0}else la=VIc(a)|0}while((h[523344+la>>0]|0)>>>0<K>>>0);H=vIc()|0;f[H>>2]=34;P=(e&1|0)==0&0==0?p:0;Q=g;R=e}else{P=p;Q=N;R=M}if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;if(!(Q>>>0<g>>>0|(Q|0)==(g|0)&R>>>0<e>>>0)){if(!((e&1|0)!=0|0!=0|(P|0)!=0)){H=vIc()|0;f[H>>2]=34;H=d1c(e|0,g|0,-1,-1)|0;j=J;k=H;break}if(Q>>>0>g>>>0|(Q|0)==(g|0)&R>>>0>e>>>0){H=vIc()|0;f[H>>2]=34;j=g;k=e;break}}H=((P|0)<0)<<31>>31;F=c1c(R^P|0,Q^H|0,P|0,H|0)|0;j=J;k=F}while(0);J=j;return k|0}function VIc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+104|0;d=f[c>>2]|0;if((d|0)!=0?(f[a+108>>2]|0)>=(d|0):0)e=4;else{d=XIc(a)|0;if((d|0)>=0){g=f[c>>2]|0;c=a+8|0;if(g){i=f[c>>2]|0;j=f[a+4>>2]|0;k=a+108|0;l=g-(f[k>>2]|0)|0;g=i;if((i-j|0)<(l|0)){m=k;n=g;o=g;p=j}else{m=k;n=j+(l+-1)|0;o=g;p=j}}else{j=f[c>>2]|0;m=a+108|0;n=j;o=j;p=f[a+4>>2]|0}f[a+100>>2]=n;if(o|0)f[m>>2]=o+1-p+(f[m>>2]|0);m=p+-1|0;if((h[m>>0]|0|0)==(d|0))q=d;else{b[m>>0]=d;q=d}}else e=4}if((e|0)==4){f[a+100>>2]=0;q=-1}return q|0}function WIc(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function XIc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if((YIc(a)|0)==0?(hj[f[a+32>>2]&511](a,c,1)|0)==1:0)d=h[c>>0]|0;else d=-1;u=b;return d|0}function YIc(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=a+20|0;c=a+28|0;if((f[d>>2]|0)>>>0>(f[c>>2]|0)>>>0)hj[f[a+36>>2]&511](a,0,0)|0;f[a+16>>2]=0;f[c>>2]=0;f[d>>2]=0;d=f[a>>2]|0;if(!(d&4)){c=(f[a+44>>2]|0)+(f[a+48>>2]|0)|0;f[a+8>>2]=c;f[a+4>>2]=c;e=d<<27>>31}else{f[a>>2]=d|32;e=-1}return e|0}function ZIc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=_Ic(a,b,c)|0;return d|0}function _Ic(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=SIc(a,b,c,0,-2147483648)|0;return d|0}function $Ic(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=SIc(a,b,c,-1,0)|0;return d|0}function aJc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=SIc(a,b,c,-2147483648,0)|0;return d|0}function bJc(a){a=a|0;var b=0;b=(cJc(a)|0)==0;return (b?a:a&95)|0}function cJc(a){a=a|0;return (a+-97|0)>>>0<26|0}function dJc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a;a:do if(!(c&3)){d=a;e=4}else{g=a;h=c;while(1){if(!(b[g>>0]|0)){i=h;break a}j=g+1|0;h=j;if(!(h&3)){d=j;e=4;break}else g=j}}while(0);if((e|0)==4){e=d;while(1){k=f[e>>2]|0;if(!((k&-2139062144^-2139062144)&k+-16843009))e=e+4|0;else break}if(!((k&255)<<24>>24))l=e;else{k=e;while(1){e=k+1|0;if(!(b[e>>0]|0)){l=e;break}else k=e}}i=l}return i-c|0}function eJc(a,b){a=a|0;b=b|0;fJc(a,b)|0;return a|0}function fJc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c;a:do if(!((d^a)&3)){if(!(d&3)){e=c;g=a}else{h=c;i=a;while(1){j=b[h>>0]|0;b[i>>0]=j;if(!(j<<24>>24)){k=i;break a}j=h+1|0;l=i+1|0;if(!(j&3)){e=j;g=l;break}else{h=j;i=l}}}i=f[e>>2]|0;if(!((i&-2139062144^-2139062144)&i+-16843009)){h=g;l=e;j=i;while(1){i=l+4|0;m=h+4|0;f[h>>2]=j;j=f[i>>2]|0;if((j&-2139062144^-2139062144)&j+-16843009|0){n=i;o=m;break}else{h=m;l=i}}}else{n=e;o=g}p=n;q=o;r=8}else{p=c;q=a;r=8}while(0);if((r|0)==8){r=b[p>>0]|0;b[q>>0]=r;if(!(r<<24>>24))k=q;else{r=q;q=p;while(1){q=q+1|0;p=r+1|0;a=b[q>>0]|0;b[p>>0]=a;if(!(a<<24>>24)){k=p;break}else r=p}}}return k|0}function gJc(a){a=a|0;var b=0,c=0,d=0;b=(dJc(a)|0)+1|0;c=jIc(b)|0;if(!c)d=0;else{o1c(c|0,a|0,b|0)|0;d=c}return d|0}function hJc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=uIc(Ke(3,e|0)|0)|0;u=d;return c|0}function iJc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=uIc(Kf(4,e|0)|0)|0;u=d;return c|0}function jJc(a){a=a|0;return 0}function kJc(a){a=a|0;var b=0;b=a;while(1)if(!(f[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function lJc(a,b){a=a|0;b=b|0;return (a+-48|0)>>>0<10|0}function mJc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c|0){d=c;c=b;b=a;while(1){d=d+-1|0;f[b>>2]=f[c>>2];if(!d)break;else{c=c+4|0;b=b+4|0}}}return a|0}function nJc(a,b){a=a|0;b=b|0;return -1|0}function oJc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=pJc(a,b,c,g)|0;u=e;return d|0}function pJc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+128|0;h=g+124|0;i=g;j=i;k=185124;l=j+124|0;do{f[j>>2]=f[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));if((c+-1|0)>>>0>2147483646)if(!c){m=h;n=1;o=4}else{h=vIc()|0;f[h>>2]=75;p=-1}else{m=a;n=c;o=4}if((o|0)==4){o=-2-m|0;c=n>>>0>o>>>0?o:n;f[i+48>>2]=c;n=i+20|0;f[n>>2]=m;f[i+44>>2]=m;o=m+c|0;m=i+16|0;f[m>>2]=o;f[i+28>>2]=o;o=qJc(i,d,e)|0;if(!c)p=o;else{c=f[n>>2]|0;b[c+(((c|0)==(f[m>>2]|0))<<31>>31)>>0]=0;p=o}}u=g;return p|0}function qJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+224|0;g=e+120|0;h=e+80|0;i=e;j=e+136|0;k=h;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[g>>2]=f[d>>2];if((rJc(0,c,g,i,h)|0)<0)m=-1;else{if((f[a+76>>2]|0)>-1)n=sJc(a)|0;else n=0;d=f[a>>2]|0;k=d&32;if((b[a+74>>0]|0)<1)f[a>>2]=d&-33;d=a+48|0;if(!(f[d>>2]|0)){l=a+44|0;o=f[l>>2]|0;f[l>>2]=j;p=a+28|0;f[p>>2]=j;q=a+20|0;f[q>>2]=j;f[d>>2]=80;r=a+16|0;f[r>>2]=j+80;j=rJc(a,c,g,i,h)|0;if(!o)s=j;else{hj[f[a+36>>2]&511](a,0,0)|0;t=(f[q>>2]|0)==0?-1:j;f[l>>2]=o;f[d>>2]=0;f[r>>2]=0;f[p>>2]=0;f[q>>2]=0;s=t}}else s=rJc(a,c,g,i,h)|0;h=f[a>>2]|0;f[a>>2]=h|k;if(n|0)tJc(a);m=(h&32|0)==0?s:-1}u=e;return m|0}function rJc(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;i=u;u=u+64|0;j=i+16|0;k=i;l=i+24|0;m=i+8|0;n=i+20|0;f[j>>2]=c;o=(a|0)!=0;q=l+40|0;r=q;s=l+39|0;l=m+4|0;t=0;v=0;w=0;x=c;a:while(1){do if((v|0)>-1)if((t|0)>(2147483647-v|0)){c=vIc()|0;f[c>>2]=75;y=-1;break}else{y=t+v|0;break}else y=v;while(0);c=b[x>>0]|0;if(!(c<<24>>24)){z=87;break}else{A=c;B=x}b:while(1){switch(A<<24>>24){case 37:{C=B;D=B;z=9;break b;break}case 0:{E=B;F=B;break b;break}default:{}}c=B+1|0;f[j>>2]=c;A=b[c>>0]|0;B=c}c:do if((z|0)==9)while(1){z=0;if((b[D+1>>0]|0)!=37){E=C;F=D;break c}c=C+1|0;G=D+2|0;f[j>>2]=G;if((b[G>>0]|0)==37){C=c;D=G;z=9}else{E=c;F=G;break}}while(0);G=E-x|0;if(o)uJc(a,x,G);if(G|0){t=G;v=y;x=F;continue}G=F+1|0;c=(b[G>>0]|0)+-48|0;if(c>>>0<10){H=(b[F+2>>0]|0)==36;I=H?c:-1;K=H?1:w;L=H?F+3|0:G}else{I=-1;K=w;L=G}f[j>>2]=L;G=b[L>>0]|0;H=(G<<24>>24)+-32|0;d:do if(H>>>0<32){c=0;M=G;N=H;O=L;while(1){P=1<<N;if(!(P&75913)){Q=c;R=M;S=O;break d}T=P|c;P=O+1|0;f[j>>2]=P;U=b[P>>0]|0;N=(U<<24>>24)+-32|0;if(N>>>0>=32){Q=T;R=U;S=P;break}else{c=T;M=U;O=P}}}else{Q=0;R=G;S=L}while(0);if(R<<24>>24==42){G=S+1|0;H=(b[G>>0]|0)+-48|0;if(H>>>0<10?(b[S+2>>0]|0)==36:0){f[h+(H<<2)>>2]=10;V=f[g+((b[G>>0]|0)+-48<<3)>>2]|0;W=1;X=S+3|0}else{if(K|0){Y=-1;break}if(o){H=(f[e>>2]|0)+(4-1)&~(4-1);O=f[H>>2]|0;f[e>>2]=H+4;V=O;W=0;X=G}else{V=0;W=0;X=G}}f[j>>2]=X;G=(V|0)<0;Z=G?0-V|0:V;_=G?Q|8192:Q;$=W;aa=X}else{G=vJc(j)|0;if((G|0)<0){Y=-1;break}Z=G;_=Q;$=K;aa=f[j>>2]|0}do if((b[aa>>0]|0)==46){if((b[aa+1>>0]|0)!=42){f[j>>2]=aa+1;G=vJc(j)|0;ba=G;ca=f[j>>2]|0;break}G=aa+2|0;O=(b[G>>0]|0)+-48|0;if(O>>>0<10?(b[aa+3>>0]|0)==36:0){f[h+(O<<2)>>2]=10;O=f[g+((b[G>>0]|0)+-48<<3)>>2]|0;H=aa+4|0;f[j>>2]=H;ba=O;ca=H;break}if($|0){Y=-1;break a}if(o){H=(f[e>>2]|0)+(4-1)&~(4-1);O=f[H>>2]|0;f[e>>2]=H+4;da=O}else da=0;f[j>>2]=G;ba=da;ca=G}else{ba=-1;ca=aa}while(0);G=0;O=ca;while(1){if(((b[O>>0]|0)+-65|0)>>>0>57){Y=-1;break a}ea=O+1|0;f[j>>2]=ea;fa=b[(b[O>>0]|0)+-65+(523609+(G*58|0))>>0]|0;ga=fa&255;if((ga+-1|0)>>>0<8){G=ga;O=ea}else break}if(!(fa<<24>>24)){Y=-1;break}H=(I|0)>-1;do if(fa<<24>>24==19)if(H){Y=-1;break a}else z=49;else{if(H){f[h+(I<<2)>>2]=ga;M=g+(I<<3)|0;c=f[M+4>>2]|0;N=k;f[N>>2]=f[M>>2];f[N+4>>2]=c;z=49;break}if(!o){Y=0;break a}wJc(k,ga,e)}while(0);if((z|0)==49?(z=0,!o):0){t=0;v=y;w=$;x=ea;continue}H=b[O>>0]|0;c=(G|0)!=0&(H&15|0)==3?H&-33:H;H=_&-65537;N=(_&8192|0)==0?_:H;e:do switch(c|0){case 110:{switch((G&255)<<24>>24){case 0:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 1:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 2:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=0;v=y;w=$;x=ea;continue a;break}case 3:{d[f[k>>2]>>1]=y;t=0;v=y;w=$;x=ea;continue a;break}case 4:{b[f[k>>2]>>0]=y;t=0;v=y;w=$;x=ea;continue a;break}case 6:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 7:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=0;v=y;w=$;x=ea;continue a;break}default:{t=0;v=y;w=$;x=ea;continue a}}break}case 112:{ha=120;ia=ba>>>0>8?ba:8;ja=N|8;z=61;break}case 88:case 120:{ha=c;ia=ba;ja=N;z=61;break}case 111:{M=k;P=f[M>>2]|0;U=f[M+4>>2]|0;M=yJc(P,U,q)|0;T=r-M|0;ka=M;la=0;ma=524073;na=(N&8|0)==0|(ba|0)>(T|0)?ba:T+1|0;oa=N;pa=P;qa=U;z=67;break}case 105:case 100:{U=k;P=f[U>>2]|0;T=f[U+4>>2]|0;if((T|0)<0){U=c1c(0,0,P|0,T|0)|0;M=J;ra=k;f[ra>>2]=U;f[ra+4>>2]=M;sa=1;ta=524073;ua=U;va=M;z=66;break e}else{sa=(N&2049|0)!=0&1;ta=(N&2048|0)==0?((N&1|0)==0?524073:524075):524074;ua=P;va=T;z=66;break e}break}case 117:{T=k;sa=0;ta=524073;ua=f[T>>2]|0;va=f[T+4>>2]|0;z=66;break}case 99:{b[s>>0]=f[k>>2];wa=s;xa=0;ya=524073;za=q;Aa=1;Ba=H;break}case 109:{T=vIc()|0;Ca=HIc(f[T>>2]|0)|0;z=71;break}case 115:{T=f[k>>2]|0;Ca=T|0?T:524083;z=71;break}case 67:{f[m>>2]=f[k>>2];f[l>>2]=0;f[k>>2]=m;Da=-1;Ea=m;z=75;break}case 83:{T=f[k>>2]|0;if(!ba){BJc(a,32,Z,0,N);Fa=0;z=84}else{Da=ba;Ea=T;z=75}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{t=DJc(a,+p[k>>3],Z,ba,N,c)|0;v=y;w=$;x=ea;continue a;break}default:{wa=x;xa=0;ya=524073;za=q;Aa=ba;Ba=N}}while(0);f:do if((z|0)==61){z=0;c=k;G=f[c>>2]|0;O=f[c+4>>2]|0;c=xJc(G,O,q,ha&32)|0;T=(ja&8|0)==0|(G|0)==0&(O|0)==0;ka=c;la=T?0:2;ma=T?524073:524073+(ha>>4)|0;na=ia;oa=ja;pa=G;qa=O;z=67}else if((z|0)==66){z=0;ka=zJc(ua,va,q)|0;la=sa;ma=ta;na=ba;oa=N;pa=ua;qa=va;z=67}else if((z|0)==71){z=0;O=AJc(Ca,0,ba)|0;G=(O|0)==0;wa=Ca;xa=0;ya=524073;za=G?Ca+ba|0:O;Aa=G?ba:O-Ca|0;Ba=H}else if((z|0)==75){z=0;O=Ea;G=0;T=0;while(1){c=f[O>>2]|0;if(!c){Ga=G;Ha=T;break}P=CJc(n,c)|0;if((P|0)<0|P>>>0>(Da-G|0)>>>0){Ga=G;Ha=P;break}c=P+G|0;if(Da>>>0>c>>>0){O=O+4|0;G=c;T=P}else{Ga=c;Ha=P;break}}if((Ha|0)<0){Y=-1;break a}BJc(a,32,Z,Ga,N);if(!Ga){Fa=0;z=84}else{T=Ea;G=0;while(1){O=f[T>>2]|0;if(!O){Fa=Ga;z=84;break f}P=CJc(n,O)|0;G=P+G|0;if((G|0)>(Ga|0)){Fa=Ga;z=84;break f}uJc(a,n,P);if(G>>>0>=Ga>>>0){Fa=Ga;z=84;break}else T=T+4|0}}}while(0);if((z|0)==67){z=0;H=(pa|0)!=0|(qa|0)!=0;T=(na|0)!=0|H;G=((H^1)&1)+(r-ka)|0;wa=T?ka:q;xa=la;ya=ma;za=q;Aa=T?((na|0)>(G|0)?na:G):na;Ba=(na|0)>-1?oa&-65537:oa}else if((z|0)==84){z=0;BJc(a,32,Z,Fa,N^8192);t=(Z|0)>(Fa|0)?Z:Fa;v=y;w=$;x=ea;continue}G=za-wa|0;T=(Aa|0)<(G|0)?G:Aa;H=T+xa|0;P=(Z|0)<(H|0)?H:Z;BJc(a,32,P,H,Ba);uJc(a,ya,xa);BJc(a,48,P,H,Ba^65536);BJc(a,48,T,G,0);uJc(a,wa,G);BJc(a,32,P,H,Ba^8192);t=P;v=y;w=$;x=ea}g:do if((z|0)==87)if(!a)if(!w)Y=0;else{ea=1;while(1){x=f[h+(ea<<2)>>2]|0;if(!x){Ia=ea;break}wJc(g+(ea<<3)|0,x,e);ea=ea+1|0;if((ea|0)>=10){Y=1;break g}}while(1){if(f[h+(Ia<<2)>>2]|0){Y=-1;break g}Ia=Ia+1|0;if((Ia|0)>=10){Y=1;break}}}else Y=y;while(0);u=i;return Y|0}function sJc(a){a=a|0;return 0}function tJc(a){a=a|0;return}function uJc(a,b,c){a=a|0;b=b|0;c=c|0;if(!(f[a>>2]&32))JJc(b,c,a)|0;return}function vJc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=(b[c>>0]|0)+-48|0;if(d>>>0<10){e=0;g=c;c=d;while(1){d=c+(e*10|0)|0;g=g+1|0;f[a>>2]=g;c=(b[g>>0]|0)+-48|0;if(c>>>0>=10){h=d;break}else e=d}}else h=0;return h|0}function wJc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;f[a>>2]=e;break a;break}case 10:{e=(f[c>>2]|0)+(4-1)&~(4-1);d=f[e>>2]|0;f[c>>2]=e+4;e=a;f[e>>2]=d;f[e+4>>2]=((d|0)<0)<<31>>31;break a;break}case 11:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;d=a;f[d>>2]=e;f[d+4>>2]=0;break a;break}case 12:{d=(f[c>>2]|0)+(8-1)&~(8-1);e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;f[c>>2]=d+8;d=a;f[d>>2]=g;f[d+4>>2]=h;break a;break}case 13:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&65535)<<16>>16;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 14:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&65535;f[h+4>>2]=0;break a;break}case 15:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&255)<<24>>24;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 16:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&255;f[h+4>>2]=0;break a;break}case 17:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}case 18:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}default:break a}while(0);while(0);return}function xJc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;if((a|0)==0&(c|0)==0)f=d;else{g=d;d=c;c=a;while(1){a=g+-1|0;b[a>>0]=h[524121+(c&15)>>0]|0|e;c=l1c(c|0,d|0,4)|0;d=J;if((c|0)==0&(d|0)==0){f=a;break}else g=a}}return f|0}function yJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;if((a|0)==0&(c|0)==0)e=d;else{f=d;d=c;c=a;while(1){a=f+-1|0;b[a>>0]=c&7|48;c=l1c(c|0,d|0,3)|0;d=J;if((c|0)==0&(d|0)==0){e=a;break}else f=a}}return e|0}function zJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;if(c>>>0>0|(c|0)==0&a>>>0>4294967295){e=d;f=a;g=c;while(1){c=r1c(f|0,g|0,10,0)|0;e=e+-1|0;b[e>>0]=c&255|48;c=f;f=n1c(f|0,g|0,10,0)|0;if(!(g>>>0>9|(g|0)==9&c>>>0>4294967295))break;else g=J}h=f;i=e}else{h=a;i=d}if(!h)j=i;else{d=h;h=i;while(1){i=h+-1|0;b[i>>0]=(d>>>0)%10|0|48;if(d>>>0<10){j=i;break}else{d=(d>>>0)/10|0;h=i}}}return j|0}function AJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c&255;g=(d|0)!=0;a:do if(g&(a&3|0)!=0){h=c&255;i=a;j=d;while(1){if((b[i>>0]|0)==h<<24>>24){k=i;l=j;m=6;break a}n=i+1|0;o=j+-1|0;p=(o|0)!=0;if(p&(n&3|0)!=0){i=n;j=o}else{q=n;r=o;s=p;m=5;break}}}else{q=a;r=d;s=g;m=5}while(0);if((m|0)==5)if(s){k=q;l=r;m=6}else{t=q;u=0}b:do if((m|0)==6){q=c&255;if((b[k>>0]|0)==q<<24>>24){t=k;u=l}else{r=Y(e,16843009)|0;c:do if(l>>>0>3){s=k;g=l;while(1){d=f[s>>2]^r;if((d&-2139062144^-2139062144)&d+-16843009|0)break;d=s+4|0;a=g+-4|0;if(a>>>0>3){s=d;g=a}else{v=d;w=a;m=11;break c}}x=s;y=g}else{v=k;w=l;m=11}while(0);if((m|0)==11)if(!w){t=v;u=0;break}else{x=v;y=w}while(1){if((b[x>>0]|0)==q<<24>>24){t=x;u=y;break b}r=x+1|0;y=y+-1|0;if(!y){t=r;u=0;break}else x=r}}}while(0);return (u|0?t:0)|0}function BJc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=u;u=u+256|0;g=f;if((c|0)>(d|0)&(e&73728|0)==0){e=c-d|0;g1c(g|0,b|0,(e>>>0<256?e:256)|0)|0;if(e>>>0>255){b=c-d|0;d=e;do{uJc(a,g,256);d=d+-256|0}while(d>>>0>255);h=b&255}else h=e;uJc(a,g,h)}u=f;return}function CJc(a,b){a=a|0;b=b|0;var c=0;if(!a)c=0;else c=HJc(a,b,0)|0;return c|0}function DJc(a,c,d,e,g,i){a=a|0;c=+c;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;j=u;u=u+560|0;k=j+8|0;l=j;m=j+524|0;n=m;o=j+512|0;f[l>>2]=0;p=o+12|0;EJc(c)|0;if((J|0)<0){q=-c;r=1;s=524090}else{q=c;r=(g&2049|0)!=0&1;s=(g&2048|0)==0?((g&1|0)==0?524091:524096):524093}EJc(q)|0;t=J&2146435072;do if(t>>>0<2146435072|(t|0)==2146435072&0<0){c=+FJc(q,l)*2.0;v=c!=0.0;if(v)f[l>>2]=(f[l>>2]|0)+-1;w=i|32;if((w|0)==97){x=i&32;y=(x|0)==0?s:s+9|0;z=r|2;A=12-e|0;do if(!(e>>>0>11|(A|0)==0)){B=8.0;C=A;do{C=C+-1|0;B=B*16.0}while((C|0)!=0);if((b[y>>0]|0)==45){D=-(B+(-c-B));break}else{D=c+B-B;break}}else D=c;while(0);A=f[l>>2]|0;C=(A|0)<0?0-A|0:A;E=zJc(C,((C|0)<0)<<31>>31,p)|0;if((E|0)==(p|0)){C=o+11|0;b[C>>0]=48;F=C}else F=E;b[F+-1>>0]=(A>>31&2)+43;A=F+-2|0;b[A>>0]=i+15;E=(e|0)<1;C=(g&8|0)==0;G=m;H=D;while(1){I=~~H;K=G+1|0;b[G>>0]=h[524121+I>>0]|x;H=(H-+(I|0))*16.0;if((K-n|0)==1?!(C&(E&H==0.0)):0){b[K>>0]=46;L=G+2|0}else L=K;if(!(H!=0.0))break;else G=L}G=L-n|0;E=p-A|0;C=(e|0)!=0&(G+-2|0)<(e|0)?e+2|0:G;x=E+z+C|0;BJc(a,32,d,x,g);uJc(a,y,z);BJc(a,48,d,x,g^65536);uJc(a,m,G);BJc(a,48,C-G|0,0,0);uJc(a,A,E);BJc(a,32,d,x,g^8192);M=x;break}x=(e|0)<0?6:e;if(v){E=(f[l>>2]|0)+-28|0;f[l>>2]=E;N=c*268435456.0;O=E}else{N=c;O=f[l>>2]|0}E=(O|0)<0?k:k+288|0;G=E;H=N;do{C=~~H>>>0;f[G>>2]=C;G=G+4|0;H=(H-+(C>>>0))*1.0e9}while(H!=0.0);if((O|0)>0){v=E;A=G;z=O;while(1){y=(z|0)<29?z:29;C=A+-4|0;if(C>>>0>=v>>>0){K=C;C=0;do{I=u1c(f[K>>2]|0,0,y|0)|0;P=d1c(I|0,J|0,C|0,0)|0;I=J;Q=r1c(P|0,I|0,1e9,0)|0;f[K>>2]=Q;C=n1c(P|0,I|0,1e9,0)|0;K=K+-4|0}while(K>>>0>=v>>>0);if(C){K=v+-4|0;f[K>>2]=C;R=K}else R=v}else R=v;K=A;while(1){if(K>>>0<=R>>>0)break;I=K+-4|0;if(!(f[I>>2]|0))K=I;else break}C=(f[l>>2]|0)-y|0;f[l>>2]=C;if((C|0)>0){v=R;A=K;z=C}else{S=R;T=K;U=C;break}}}else{S=E;T=G;U=O}if((U|0)<0){z=((x+25|0)/9|0)+1|0;A=(w|0)==102;v=S;C=T;I=U;while(1){P=0-I|0;Q=(P|0)<9?P:9;if(v>>>0<C>>>0){P=(1<<Q)+-1|0;V=1e9>>>Q;W=0;X=v;do{Z=f[X>>2]|0;f[X>>2]=(Z>>>Q)+W;W=Y(Z&P,V)|0;X=X+4|0}while(X>>>0<C>>>0);X=(f[v>>2]|0)==0?v+4|0:v;if(!W){_=X;$=C}else{f[C>>2]=W;_=X;$=C+4|0}}else{_=(f[v>>2]|0)==0?v+4|0:v;$=C}X=A?E:_;V=($-X>>2|0)>(z|0)?X+(z<<2)|0:$;I=(f[l>>2]|0)+Q|0;f[l>>2]=I;if((I|0)>=0){aa=_;ba=V;break}else{v=_;C=V}}}else{aa=S;ba=T}C=E;if(aa>>>0<ba>>>0){v=(C-aa>>2)*9|0;I=f[aa>>2]|0;if(I>>>0<10)ca=v;else{z=v;v=10;while(1){v=v*10|0;A=z+1|0;if(I>>>0<v>>>0){ca=A;break}else z=A}}}else ca=0;z=(w|0)==103;v=(x|0)!=0;I=x-((w|0)!=102?ca:0)+((v&z)<<31>>31)|0;if((I|0)<(((ba-C>>2)*9|0)+-9|0)){A=I+9216|0;I=E+4+(((A|0)/9|0)+-1024<<2)|0;G=((A|0)%9|0)+1|0;if((G|0)<9){A=G;G=10;while(1){V=G*10|0;A=A+1|0;if((A|0)==9){da=V;break}else G=V}}else da=10;G=f[I>>2]|0;A=(G>>>0)%(da>>>0)|0;w=(I+4|0)==(ba|0);if(!(w&(A|0)==0)){B=(((G>>>0)/(da>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;V=(da|0)/2|0;H=A>>>0<V>>>0?.5:w&(A|0)==(V|0)?1.0:1.5;if(!r){ea=H;fa=B}else{V=(b[s>>0]|0)==45;ea=V?-H:H;fa=V?-B:B}V=G-A|0;f[I>>2]=V;if(fa+ea!=fa){A=V+da|0;f[I>>2]=A;if(A>>>0>999999999){A=aa;V=I;while(1){G=V+-4|0;f[V>>2]=0;if(G>>>0<A>>>0){w=A+-4|0;f[w>>2]=0;ga=w}else ga=A;w=(f[G>>2]|0)+1|0;f[G>>2]=w;if(w>>>0>999999999){A=ga;V=G}else{ha=ga;ia=G;break}}}else{ha=aa;ia=I}V=(C-ha>>2)*9|0;A=f[ha>>2]|0;if(A>>>0<10){ja=ia;ka=V;la=ha}else{G=V;V=10;while(1){V=V*10|0;w=G+1|0;if(A>>>0<V>>>0){ja=ia;ka=w;la=ha;break}else G=w}}}else{ja=I;ka=ca;la=aa}}else{ja=I;ka=ca;la=aa}G=ja+4|0;ma=ka;na=ba>>>0>G>>>0?G:ba;oa=la}else{ma=ca;na=ba;oa=aa}G=na;while(1){if(G>>>0<=oa>>>0){pa=0;break}V=G+-4|0;if(!(f[V>>2]|0))G=V;else{pa=1;break}}I=0-ma|0;do if(z){V=((v^1)&1)+x|0;if((V|0)>(ma|0)&(ma|0)>-5){qa=i+-1|0;ra=V+-1-ma|0}else{qa=i+-2|0;ra=V+-1|0}V=g&8;if(!V){if(pa?(A=f[G+-4>>2]|0,(A|0)!=0):0)if(!((A>>>0)%10|0)){w=0;X=10;while(1){X=X*10|0;P=w+1|0;if((A>>>0)%(X>>>0)|0|0){sa=P;break}else w=P}}else sa=0;else sa=9;w=((G-C>>2)*9|0)+-9|0;if((qa|32|0)==102){X=w-sa|0;A=(X|0)>0?X:0;ta=qa;ua=(ra|0)<(A|0)?ra:A;va=0;break}else{A=w+ma-sa|0;w=(A|0)>0?A:0;ta=qa;ua=(ra|0)<(w|0)?ra:w;va=0;break}}else{ta=qa;ua=ra;va=V}}else{ta=i;ua=x;va=g&8}while(0);x=ua|va;C=(x|0)!=0&1;v=(ta|32|0)==102;if(v){wa=0;xa=(ma|0)>0?ma:0}else{z=(ma|0)<0?I:ma;w=zJc(z,((z|0)<0)<<31>>31,p)|0;z=p;if((z-w|0)<2){A=w;while(1){X=A+-1|0;b[X>>0]=48;if((z-X|0)<2)A=X;else{ya=X;break}}}else ya=w;b[ya+-1>>0]=(ma>>31&2)+43;A=ya+-2|0;b[A>>0]=ta;wa=A;xa=z-A|0}A=r+1+ua+C+xa|0;BJc(a,32,d,A,g);uJc(a,s,r);BJc(a,48,d,A,g^65536);if(v){I=oa>>>0>E>>>0?E:oa;X=m+9|0;Q=X;W=m+8|0;P=I;do{K=zJc(f[P>>2]|0,0,X)|0;if((P|0)==(I|0))if((K|0)==(X|0)){b[W>>0]=48;za=W}else za=K;else if(K>>>0>m>>>0){g1c(m|0,48,K-n|0)|0;y=K;while(1){Z=y+-1|0;if(Z>>>0>m>>>0)y=Z;else{za=Z;break}}}else za=K;uJc(a,za,Q-za|0);P=P+4|0}while(P>>>0<=E>>>0);if(x|0)uJc(a,528338,1);if(P>>>0<G>>>0&(ua|0)>0){E=ua;Q=P;while(1){W=zJc(f[Q>>2]|0,0,X)|0;if(W>>>0>m>>>0){g1c(m|0,48,W-n|0)|0;I=W;while(1){v=I+-1|0;if(v>>>0>m>>>0)I=v;else{Aa=v;break}}}else Aa=W;uJc(a,Aa,(E|0)<9?E:9);Q=Q+4|0;I=E+-9|0;if(!(Q>>>0<G>>>0&(E|0)>9)){Ba=I;break}else E=I}}else Ba=ua;BJc(a,48,Ba+9|0,9,0)}else{E=pa?G:oa+4|0;if((ua|0)>-1){Q=m+9|0;X=(va|0)==0;P=Q;x=0-n|0;I=m+8|0;K=ua;v=oa;while(1){C=zJc(f[v>>2]|0,0,Q)|0;if((C|0)==(Q|0)){b[I>>0]=48;Ca=I}else Ca=C;do if((v|0)==(oa|0)){C=Ca+1|0;uJc(a,Ca,1);if(X&(K|0)<1){Da=C;break}uJc(a,528338,1);Da=C}else{if(Ca>>>0<=m>>>0){Da=Ca;break}g1c(m|0,48,Ca+x|0)|0;C=Ca;while(1){z=C+-1|0;if(z>>>0>m>>>0)C=z;else{Da=z;break}}}while(0);W=P-Da|0;uJc(a,Da,(K|0)>(W|0)?W:K);C=K-W|0;v=v+4|0;if(!(v>>>0<E>>>0&(C|0)>-1)){Ea=C;break}else K=C}}else Ea=ua;BJc(a,48,Ea+18|0,18,0);uJc(a,wa,p-wa|0)}BJc(a,32,d,A,g^8192);M=A}else{K=(i&32|0)!=0;E=r+3|0;BJc(a,32,d,E,g&-65537);uJc(a,s,r);uJc(a,q!=q|0.0!=0.0?(K?524261:524117):K?524109:524113,3);BJc(a,32,d,E,g^8192);M=E}while(0);u=j;return ((M|0)<(d|0)?d:M)|0}function EJc(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function FJc(a,b){a=+a;b=b|0;return +(+GJc(a,b))}function GJc(a,b){a=+a;b=b|0;var c=0,d=0,e=0,g=0.0,h=0.0,i=0,j=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;e=l1c(c|0,d|0,52)|0;switch(e&2047){case 0:{if(a!=0.0){g=+GJc(a*18446744073709551616.0,b);h=g;i=(f[b>>2]|0)+-64|0}else{h=a;i=0}f[b>>2]=i;j=h;break}case 2047:{j=a;break}default:{f[b>>2]=(e&2047)+-1022;f[s>>2]=c;f[s+4>>2]=d&-2146435073|1071644672;j=+p[s>>3]}}return +j}function HJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;do if(a){if(c>>>0<128){b[a>>0]=c;e=1;break}d=(IJc()|0)+188|0;if(!(f[f[d>>2]>>2]|0))if((c&-128|0)==57216){b[a>>0]=c;e=1;break}else{d=vIc()|0;f[d>>2]=84;e=-1;break}if(c>>>0<2048){b[a>>0]=c>>>6|192;b[a+1>>0]=c&63|128;e=2;break}if(c>>>0<55296|(c&-8192|0)==57344){b[a>>0]=c>>>12|224;b[a+1>>0]=c>>>6&63|128;b[a+2>>0]=c&63|128;e=3;break}if((c+-65536|0)>>>0<1048576){b[a>>0]=c>>>18|240;b[a+1>>0]=c>>>12&63|128;b[a+2>>0]=c>>>6&63|128;b[a+3>>0]=c&63|128;e=4;break}else{d=vIc()|0;f[d>>2]=84;e=-1;break}}else e=1;while(0);return e|0}function IJc(){return xIc()|0}function JJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+16|0;g=f[e>>2]|0;if(!g)if(!(KJc(d)|0)){h=f[e>>2]|0;i=5}else j=0;else{h=g;i=5}a:do if((i|0)==5){g=d+20|0;e=f[g>>2]|0;k=e;if((h-e|0)>>>0<c>>>0){j=hj[f[d+36>>2]&511](d,a,c)|0;break}b:do if((b[d+75>>0]|0)>-1){e=c;while(1){if(!e){l=0;m=a;n=c;o=k;break b}p=e+-1|0;if((b[a+p>>0]|0)==10)break;else e=p}p=hj[f[d+36>>2]&511](d,a,e)|0;if(p>>>0<e>>>0){j=p;break a}l=e;m=a+e|0;n=c-e|0;o=f[g>>2]|0}else{l=0;m=a;n=c;o=k}while(0);o1c(o|0,m|0,n|0)|0;f[g>>2]=(f[g>>2]|0)+n;j=l+n|0}while(0);return j|0}function KJc(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=f[a>>2]|0;if(!(d&8)){f[a+8>>2]=0;f[a+4>>2]=0;c=f[a+44>>2]|0;f[a+28>>2]=c;f[a+20>>2]=c;f[a+16>>2]=c+(f[a+48>>2]|0);e=0}else{f[a>>2]=d|32;e=-1}return e|0}function LJc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=a+20|0;e=f[d>>2]|0;g=(f[a+16>>2]|0)-e|0;a=g>>>0>c>>>0?c:g;o1c(e|0,b|0,a|0)|0;f[d>>2]=(f[d>>2]|0)+a;return c|0}function MJc(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;RJc();f[d>>2]=a;f[d+4>>2]=b;b=uIc(De(91,d|0)|0)|0;u=c;return b|0}function NJc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!d)e=0;else{f=b[a>>0]|0;g=f&255;h=b[c>>0]|0;i=h&255;a:do if(!(f<<24>>24)){j=i;k=g}else{l=a;m=d;n=c;o=f;p=i;q=g;r=h;while(1){m=m+-1|0;if(!(o<<24>>24==r<<24>>24&((m|0)!=0&r<<24>>24!=0))){j=p;k=q;break a}l=l+1|0;n=n+1|0;o=b[l>>0]|0;s=o&255;r=b[n>>0]|0;t=r&255;if(!(o<<24>>24)){j=t;k=s;break}else{p=t;q=s}}}while(0);e=k-j|0}return e|0}function OJc(a,c){a=a|0;c=c|0;var d=0;d=QJc(a,c)|0;return ((b[d>>0]|0)==(c&255)<<24>>24?d:0)|0}function PJc(a,b){a=a|0;b=b|0;var c=0;c=AJc(a,0,b)|0;return ((c|0)==0?b:c-a|0)|0}function QJc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=c&255;a:do if(!d)e=a+(dJc(a)|0)|0;else{if(!(a&3))g=a;else{h=c&255;i=a;while(1){j=b[i>>0]|0;if(j<<24>>24==0?1:j<<24>>24==h<<24>>24){e=i;break a}j=i+1|0;if(!(j&3)){g=j;break}else i=j}}i=Y(d,16843009)|0;h=f[g>>2]|0;b:do if(!((h&-2139062144^-2139062144)&h+-16843009)){j=g;k=h;while(1){l=k^i;if((l&-2139062144^-2139062144)&l+-16843009|0){m=j;break b}l=j+4|0;k=f[l>>2]|0;if((k&-2139062144^-2139062144)&k+-16843009|0){m=l;break}else j=l}}else m=g;while(0);i=c&255;h=m;while(1){j=b[h>>0]|0;if(j<<24>>24==0?1:j<<24>>24==i<<24>>24){e=h;break}else h=h+1|0}}while(0);return e|0}function RJc(){return}function SJc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return d|0}function TJc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+272|0;e=d+8|0;g=d;do if(!(b[c>>0]|0)){h=jf(524137)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=jf(524144+(a*12|0)|0)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=jf(524216)|0;if(h|0?b[h>>0]|0:0){i=h;break}i=524221}else i=c;while(0);c=0;a:while(1){switch(b[i+c>>0]|0){case 47:case 0:{j=c;break a;break}default:{}}h=c+1|0;if(h>>>0<15)c=h;else{j=h;break}}c=b[i>>0]|0;if(c<<24>>24!=46?(b[i+j>>0]|0)==0:0)if(c<<24>>24==67){k=i;l=15}else{m=i;l=16}else{k=524221;l=15}if((l|0)==15)if(!(b[k+1>>0]|0)){n=k;l=18}else{m=k;l=16}b:do if((l|0)==16)if((GIc(m,524221)|0)!=0?(GIc(m,524229)|0)!=0:0){k=f[223752]|0;if(k|0){i=k;do{if(!(GIc(m,i+8|0)|0)){o=i;break b}i=f[i+24>>2]|0}while((i|0)!=0)}Df(895012);i=f[223752]|0;c:do if(i|0){k=i;while(1){if(!(GIc(m,k+8|0)|0))break;c=f[k+24>>2]|0;if(!c)break c;else k=c}cg(895012);o=k;break b}while(0);d:do if(((f[223738]|0)==0?(i=jf(524235)|0,(i|0)!=0):0)?(b[i>>0]|0)!=0:0){c=254-j|0;h=j+1|0;p=i;while(1){i=QJc(p,58)|0;q=b[i>>0]|0;r=((q<<24>>24!=0)<<31>>31)+(i-p)|0;if(r>>>0<c>>>0){o1c(e|0,p|0,r|0)|0;s=e+r|0;b[s>>0]=47;o1c(s+1|0,m|0,j|0)|0;b[e+(h+r)>>0]=0;t=og(e|0,g|0)|0;if(t|0)break;v=b[i>>0]|0}else v=q;p=i+(v<<24>>24!=0&1)|0;if(!(b[p>>0]|0)){l=41;break d}}p=jIc(28)|0;h=f[g>>2]|0;if(!p){MJc(t,h)|0;l=41;break}else{f[p>>2]=t;f[p+4>>2]=h;h=p+8|0;o1c(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[223752];f[223752]=p;w=p;break}}else l=41;while(0);if((l|0)==41){p=jIc(28)|0;if(!p)w=p;else{f[p>>2]=f[46054];f[p+4>>2]=f[46055];h=p+8|0;o1c(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[223752];f[223752]=p;w=p}}cg(895012);o=(a|0)==0&(w|0)==0?184216:w}else{n=m;l=18}while(0);do if((l|0)==18){if((a|0)==0?(b[n+1>>0]|0)==46:0){o=184216;break}o=0}while(0);u=d;return o|0}function UJc(a,b){a=a|0;b=b|0;return VJc(a)|0}function VJc(a){a=a|0;return ((a+-48|0)>>>0<10|((a|32)+-97|0)>>>0<6)&1|0}function WJc(a){a=a|0;if(XJc(a)|0)kIc(a);return}function XJc(a){a=a|0;return (a|0)!=184264&((a|0)!=0&(a|0)!=894920)&1|0}function YJc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;a:do if(!(XJc(c)|0)){g=(c|0)==0;h=0;i=0;do{j=(1<<i&a|0)!=0;if(g|j)k=TJc(i,j?b:1165591)|0;else k=f[c+(i<<2)>>2]|0;h=((k|0)!=0&1)+h|0;f[e+(i<<2)>>2]=k;i=i+1|0}while((i|0)!=6);switch(h|0){case 0:{l=894920;break a;break}case 1:{if((f[e>>2]|0)==184216){l=184264;break a}break}default:{}}l=c}else{i=0;do{if(1<<i&a|0){g=TJc(i,b)|0;f[c+(i<<2)>>2]=g}i=i+1|0}while((i|0)!=6);l=c}while(0);u=d;return l|0}function ZJc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=(e|0)==0?895020:e;e=f[i>>2]|0;a:do if(!c)if(!e)j=0;else k=17;else{l=(a|0)==0?h:a;if(!d)j=-2;else{if(!e){m=b[c>>0]|0;if(m<<24>>24>-1){f[l>>2]=m&255;j=m<<24>>24!=0&1;break}m=(_Jc()|0)+188|0;n=b[c>>0]|0;if(!(f[f[m>>2]>>2]|0)){f[l>>2]=n<<24>>24&57343;j=1;break}m=(n&255)+-194|0;if(m>>>0>50){k=17;break}n=f[184288+(m<<2)>>2]|0;m=d+-1|0;if(!m)o=n;else{p=c+1|0;q=n;r=m;k=11}}else{p=c;q=e;r=d;k=11}b:do if((k|0)==11){m=b[p>>0]|0;n=(m&255)>>>3;if((n+-16|n+(q>>26))>>>0>7){k=17;break a}else{s=p;t=q;v=r;w=m}while(1){s=s+1|0;t=(w&255)+-128|t<<6;v=v+-1|0;if((t|0)>=0)break;if(!v){o=t;break b}w=b[s>>0]|0;if((w&-64)<<24>>24!=-128){k=17;break a}}f[i>>2]=0;f[l>>2]=t;j=d-v|0;break a}while(0);f[i>>2]=o;j=-2}}while(0);if((k|0)==17){f[i>>2]=0;i=vIc()|0;f[i>>2]=84;j=-1}u=g;return j|0}function _Jc(){return xIc()|0}function $Jc(a){a=a|0;var b=0,c=0;b=(aKc()|0)+188|0;c=f[b>>2]|0;if(a|0)f[b>>2]=(a|0)==(-1|0)?894984:a;return ((c|0)==894984?-1:c)|0}function aKc(){return xIc()|0}function bKc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;a:do if(!c)i=0;else{do if(d|0){j=(a|0)==0?g:a;k=b[c>>0]|0;if(k<<24>>24>-1){f[j>>2]=k&255;i=k<<24>>24!=0&1;break a}k=(cKc()|0)+188|0;l=b[c>>0]|0;if(!(f[f[k>>2]>>2]|0)){f[j>>2]=l<<24>>24&57343;i=1;break a}k=(l&255)+-194|0;if(k>>>0<=50){l=c+1|0;m=f[184288+(k<<2)>>2]|0;if(d>>>0<4?m&-2147483648>>>((d*6|0)+-6|0)|0:0)break;k=h[l>>0]|0;l=k>>>3;if((l+-16|l+(m>>26))>>>0<=7){l=k+-128|m<<6;if((l|0)>=0){f[j>>2]=l;i=2;break a}m=(h[c+2>>0]|0)+-128|0;if(m>>>0<=63){k=m|l<<6;if((k|0)>=0){f[j>>2]=k;i=3;break a}l=(h[c+3>>0]|0)+-128|0;if(l>>>0<=63){f[j>>2]=l|k<<6;i=4;break a}}}}}while(0);k=vIc()|0;f[k>>2]=84;i=-1}while(0);u=e;return i|0}function cKc(){return xIc()|0}function dKc(a,b){a=a|0;b=b|0;var c=0;c=dJc(a)|0;return ((eKc(a,1,c,b)|0)!=(c|0))<<31>>31|0}function eKc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=Y(c,b)|0;g=(b|0)==0?0:c;if((f[d+76>>2]|0)>-1){c=(sJc(d)|0)==0;h=JJc(a,e,d)|0;if(c)i=h;else{tJc(d);i=h}}else i=JJc(a,e,d)|0;if((i|0)==(e|0))j=g;else j=(i>>>0)/(b>>>0)|0;return j|0}function fKc(a){a=a|0;var b=0,c=0,d=0;if(f[a+68>>2]|0){b=f[a+116>>2]|0;c=a+112|0;if(b|0)f[b+112>>2]=f[c>>2];a=f[c>>2]|0;if(!a)d=(gKc()|0)+232|0;else d=a+116|0;f[d>>2]=b}return}function gKc(){return xIc()|0}function hKc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;g=c&255;b[e>>0]=g;i=a+16|0;j=f[i>>2]|0;if(!j)if(!(KJc(a)|0)){k=f[i>>2]|0;l=4}else m=-1;else{k=j;l=4}do if((l|0)==4){j=a+20|0;i=f[j>>2]|0;if(i>>>0<k>>>0?(n=c&255,(n|0)!=(b[a+75>>0]|0)):0){f[j>>2]=i+1;b[i>>0]=g;m=n;break}if((hj[f[a+36>>2]&511](a,e,1)|0)==1)m=h[e>>0]|0;else m=-1}while(0);u=d;return m|0}function iKc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;if(AJc(524248,b[c>>0]|0,4)|0){i=jKc(c)|0;f[h>>2]=a;f[h+4>>2]=i|32768;f[h+8>>2]=438;a=uIc(Oe(5,h|0)|0)|0;if((a|0)>=0){if(i&524288|0){f[g>>2]=a;f[g+4>>2]=2;f[g+8>>2]=1;zd(221,g|0)|0}g=kKc(a,c)|0;if(!g){f[e>>2]=a;Ne(6,e|0)|0;j=0}else j=g}else j=0}else{g=vIc()|0;f[g>>2]=22;j=0}u=d;return j|0}function jKc(a){a=a|0;var c=0,d=0,e=0,f=0;c=(OJc(a,43)|0)==0;d=b[a>>0]|0;e=c?d<<24>>24!=114&1:2;c=(OJc(a,120)|0)==0;f=c?e:e|128;e=(OJc(a,101)|0)==0;a=e?f:f|524288;f=d<<24>>24==114?a:a|64;a=d<<24>>24==119?f|512:f;return (d<<24>>24==97?a|1024:a)|0}function kKc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d+16|0;i=d;j=d+56|0;k=b[c>>0]|0;if(AJc(524248,k<<24>>24,4)|0){l=jIc(1156)|0;if(!l)m=0;else{n=l;o=n+124|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));if(!(OJc(c,43)|0))f[l>>2]=k<<24>>24==114?8:4;if(!(OJc(c,101)|0))p=k;else{f[i>>2]=a;f[i+4>>2]=2;f[i+8>>2]=1;zd(221,i|0)|0;p=b[c>>0]|0}if(p<<24>>24==97){f[h>>2]=a;f[h+4>>2]=3;p=zd(221,h|0)|0;if(!(p&1024)){f[g>>2]=a;f[g+4>>2]=4;f[g+8>>2]=p|1024;zd(221,g|0)|0}g=f[l>>2]|128;f[l>>2]=g;q=g}else q=f[l>>2]|0;f[l+60>>2]=a;f[l+44>>2]=l+132;f[l+48>>2]=1024;g=l+75|0;b[g>>0]=-1;if((q&8|0)==0?(f[e>>2]=a,f[e+4>>2]=21523,f[e+8>>2]=j,(Xe(54,e|0)|0)==0):0)b[g>>0]=10;f[l+32>>2]=227;f[l+36>>2]=228;f[l+40>>2]=226;f[l+12>>2]=888;if(!(f[223737]|0))f[l+76>>2]=-1;lKc(l)|0;m=l}}else{l=vIc()|0;f[l>>2]=22;m=0}u=d;return m|0}function lKc(a){a=a|0;var b=0,c=0;b=mKc()|0;f[a+56>>2]=f[b>>2];c=f[b>>2]|0;if(c|0)f[c+52>>2]=a;f[b>>2]=a;nKc();return a|0}function mKc(){Df(895024);return 895032}function nKc(){cg(895024);return}function oKc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;if((f[a+76>>2]|0)>-1)b=sJc(a)|0;else b=0;fKc(a);c=(f[a>>2]&1|0)!=0;if(!c){d=mKc()|0;e=f[a+52>>2]|0;g=a+56|0;if(e|0)f[e+56>>2]=f[g>>2];h=f[g>>2]|0;if(h|0)f[h+52>>2]=e;if((f[d>>2]|0)==(a|0))f[d>>2]=h;nKc()}h=pKc(a)|0;d=_i[f[a+12>>2]&2047](a)|0|h;h=f[a+92>>2]|0;if(h|0)kIc(h);if(c){if(b|0)tJc(a)}else kIc(a);return d|0}function pKc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;do if(a){if((f[a+76>>2]|0)<=-1){b=qKc(a)|0;break}c=(sJc(a)|0)==0;d=qKc(a)|0;if(c)b=d;else{tJc(a);b=d}}else{if(!(f[46216]|0))e=0;else e=pKc(f[46216]|0)|0;d=mKc()|0;c=f[d>>2]|0;if(!c)g=e;else{d=c;c=e;while(1){if((f[d+76>>2]|0)>-1)h=sJc(d)|0;else h=0;if((f[d+20>>2]|0)>>>0>(f[d+28>>2]|0)>>>0)i=qKc(d)|0|c;else i=c;if(h|0)tJc(d);d=f[d+56>>2]|0;if(!d){g=i;break}else c=i}}nKc();b=g}while(0);return b|0}function qKc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+20|0;c=a+28|0;if((f[b>>2]|0)>>>0>(f[c>>2]|0)>>>0?(hj[f[a+36>>2]&511](a,0,0)|0,(f[b>>2]|0)==0):0)d=-1;else{e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;if(g>>>0<i>>>0)hj[f[a+40>>2]&511](a,g-i|0,1)|0;f[a+16>>2]=0;f[c>>2]=0;f[b>>2]=0;f[h>>2]=0;f[e>>2]=0;d=0}return d|0}function rKc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if((f[d+76>>2]|0)>-1)e=sJc(d)|0;else e=0;g=c+-1|0;i=(g|0)!=0;if((c|0)<2){c=d+74|0;j=b[c>>0]|0;b[c>>0]=j+255|j;if(e|0)tJc(d);if(i)k=0;else{b[a>>0]=0;k=a}}else{a:do if(i){j=d+4|0;c=d+8|0;l=g;m=a;while(1){n=f[j>>2]|0;o=n;p=(f[c>>2]|0)-o|0;q=AJc(n,10,p)|0;r=(q|0)==0;s=r?p:1-o+q|0;q=s>>>0<l>>>0?s:l;o1c(m|0,n|0,q|0)|0;n=(f[j>>2]|0)+q|0;f[j>>2]=n;t=m+q|0;s=l-q|0;if(!(r&(s|0)!=0)){u=t;v=17;break a}if(n>>>0>=(f[c>>2]|0)>>>0){r=XIc(d)|0;if((r|0)<0)break;else w=r}else{f[j>>2]=n+1;w=h[n>>0]|0}l=s+-1|0;s=t+1|0;b[t>>0]=w;if(!((l|0)!=0&(w&255|0)!=10)){u=s;v=17;break a}else m=s}if((t|0)!=(a|0)?(f[d>>2]&16|0)!=0:0){u=t;v=17}else x=0}else{u=a;v=17}while(0);if((v|0)==17)if(!a)x=0;else{b[u>>0]=0;x=a}if(!e)k=x;else{tJc(d);k=x}}return k|0}function sKc(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(sJc(a)|0)==0;c=(f[a>>2]|0)>>>4&1;if(b)d=c;else{tJc(a);d=c}}else d=(f[a>>2]|0)>>>4&1;return d|0}function tKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=xKc(a,b,e)|0;u=d;return c|0}function uKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=vKc(a,b,e)|0;u=d;return c|0}function vKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e+32>>2]=311;f[e+44>>2]=a;f[e+76>>2]=-1;f[e+84>>2]=a;a=xKc(e,b,c)|0;u=d;return a|0}function wKc(a,b,c){a=a|0;b=b|0;c=c|0;return MKc(a,b,c)|0}function xKc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0;e=u;u=u+288|0;g=e+8|0;i=e+17|0;j=e;k=e+16|0;if((f[a+76>>2]|0)>-1)l=sJc(a)|0;else l=0;m=b[c>>0]|0;a:do if(m<<24>>24){o=a+4|0;q=a+100|0;r=a+108|0;s=a+8|0;t=i+10|0;v=i+33|0;w=g+4|0;x=i+46|0;y=i+94|0;z=i+1|0;A=i+1|0;B=c;C=0;D=0;E=0;F=0;G=m;b:while(1){c:do if(!(WIc(G&255)|0)){H=G<<24>>24==37;d:do if(H){I=B+1|0;K=b[I>>0]|0;e:do switch(K<<24>>24){case 37:{break d;break}case 42:{L=0;M=B+2|0;break}default:{N=(K&255)+-48|0;if(N>>>0<10?(b[B+2>>0]|0)==36:0){L=yKc(d,N)|0;M=B+3|0;break e}N=(f[d>>2]|0)+(4-1)&~(4-1);O=f[N>>2]|0;f[d>>2]=N+4;L=O;M=I}}while(0);I=b[M>>0]|0;K=I&255;if((K+-48|0)>>>0<10){O=0;N=M;P=K;while(1){K=(O*10|0)+-48+P|0;Q=N+1|0;R=b[Q>>0]|0;P=R&255;if((P+-48|0)>>>0>=10){S=K;T=Q;U=R;break}else{O=K;N=Q}}}else{S=0;T=M;U=I}N=U<<24>>24==109;O=(L|0)!=0;P=N?0:E;Q=N?0:F;K=N?T+1|0:T;V=O&N;N=K+1|0;switch(b[K>>0]|0){case 104:{R=(b[N>>0]|0)==104;W=R?-2:-1;X=R?K+2|0:N;break}case 108:{R=(b[N>>0]|0)==108;W=R?3:1;X=R?K+2|0:N;break}case 106:{W=3;X=N;break}case 116:case 122:{W=1;X=N;break}case 76:{W=2;X=N;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{W=0;X=K;break}default:{Y=P;Z=Q;_=V;$=137;break b}}K=h[X>>0]|0;N=(K&47|0)==3;R=N?K|32:K;K=N?1:W;N=R&255;switch(N<<24>>24){case 99:{aa=(S|0)>1?S:1;ba=C;break}case 91:{aa=S;ba=C;break}case 110:{zKc(L,K,C,((C|0)<0)<<31>>31);ca=X;da=D;ea=C;fa=P;ga=Q;break c;break}default:{TIc(a,0);do{ha=f[o>>2]|0;if(ha>>>0<(f[q>>2]|0)>>>0){f[o>>2]=ha+1;ia=h[ha>>0]|0}else ia=VIc(a)|0}while((WIc(ia)|0)!=0);if(!(f[q>>2]|0))ja=f[o>>2]|0;else{I=(f[o>>2]|0)+-1|0;f[o>>2]=I;ja=I}aa=S;ba=(f[r>>2]|0)+C+ja-(f[s>>2]|0)|0}}TIc(a,aa);I=f[o>>2]|0;ha=f[q>>2]|0;if(I>>>0<ha>>>0){f[o>>2]=I+1;ka=ha}else{if((VIc(a)|0)<0){Y=P;Z=Q;_=V;$=137;break b}ka=f[q>>2]|0}if(ka|0)f[o>>2]=(f[o>>2]|0)+-1;f:do switch(N<<24>>24){case 91:case 99:case 115:{ha=(R|0)==99;g:do if((R|16|0)==115){g1c(z|0,-1,256)|0;b[i>>0]=0;if((R|0)==115){b[v>>0]=0;b[t>>0]=0;b[t+1>>0]=0;b[t+2>>0]=0;b[t+3>>0]=0;b[t+4>>0]=0;la=X}else la=X}else{I=X+1|0;ma=(b[I>>0]|0)==94;na=ma&1;oa=ma?X+2|0:I;g1c(A|0,ma&1|0,256)|0;b[i>>0]=0;switch(b[oa>>0]|0){case 45:{pa=x;$=64;break}case 93:{pa=y;$=64;break}default:{qa=oa;ra=(na^1)&255}}if(($|0)==64){$=0;ma=(na^1)&255;b[pa>>0]=ma;qa=oa+1|0;ra=ma}ma=qa;while(1){oa=b[ma>>0]|0;h:do switch(oa<<24>>24){case 0:{Y=P;Z=Q;_=V;$=137;break b;break}case 93:{la=ma;break g;break}case 45:{na=ma+1|0;I=b[na>>0]|0;switch(I<<24>>24){case 93:case 0:{sa=ma;ta=45;break h;break}default:{}}ua=b[ma+-1>>0]|0;if((ua&255)<(I&255)){va=ua&255;do{va=va+1|0;b[i+va>>0]=ra;ua=b[na>>0]|0}while((va|0)<(ua&255|0));sa=na;ta=ua}else{sa=na;ta=I}break}default:{sa=ma;ta=oa}}while(0);b[i+((ta&255)+1)>>0]=ra;ma=sa+1|0}}while(0);ma=ha?aa+1|0:31;oa=(K|0)==1;i:do if(oa){if(V){va=jIc(ma<<2)|0;if(!va){Y=0;Z=0;_=1;$=137;break b}else wa=va}else wa=L;f[g>>2]=0;f[w>>2]=0;va=ma;ua=0;xa=wa;j:while(1){ya=(xa|0)==0;za=ua;while(1){k:while(1){Aa=f[o>>2]|0;if(Aa>>>0<(f[q>>2]|0)>>>0){f[o>>2]=Aa+1;Ba=h[Aa>>0]|0}else Ba=VIc(a)|0;if(!(b[i+(Ba+1)>>0]|0))break j;b[k>>0]=Ba;switch(ZJc(j,k,1,g)|0){case -1:{Y=0;Z=xa;_=V;$=137;break b;break}case -2:break;default:break k}}if(ya)Ca=za;else{f[xa+(za<<2)>>2]=f[j>>2];Ca=za+1|0}if(V&(Ca|0)==(va|0))break;else za=Ca}ya=va<<1|1;I=lIc(xa,ya<<2)|0;if(!I){Y=0;Z=xa;_=1;$=137;break b}else{na=va;va=ya;xa=I;ua=na}}if(!(AKc(g)|0)){Y=0;Z=xa;_=V;$=137;break b}else{Da=za;Ea=0;Fa=xa;Ga=xa}}else{if(V){ua=jIc(ma)|0;if(!ua){Y=0;Z=0;_=1;$=137;break b}else{Ha=ma;Ia=0;Ja=ua}while(1){ua=Ia;do{va=f[o>>2]|0;if(va>>>0<(f[q>>2]|0)>>>0){f[o>>2]=va+1;Ka=h[va>>0]|0}else Ka=VIc(a)|0;if(!(b[i+(Ka+1)>>0]|0)){Da=ua;Ea=Ja;Fa=0;Ga=0;break i}b[Ja+ua>>0]=Ka;ua=ua+1|0}while((ua|0)!=(Ha|0));ua=Ha<<1|1;va=lIc(Ja,ua)|0;if(!va){Y=Ja;Z=0;_=1;$=137;break b}else{na=Ha;Ha=ua;Ja=va;Ia=na}}}if(!L){xa=ka;while(1){na=f[o>>2]|0;if(na>>>0<xa>>>0){f[o>>2]=na+1;La=h[na>>0]|0}else La=VIc(a)|0;if(!(b[i+(La+1)>>0]|0)){Da=0;Ea=0;Fa=0;Ga=0;break i}xa=f[q>>2]|0}}else{xa=0;na=ka;while(1){va=f[o>>2]|0;if(va>>>0<na>>>0){f[o>>2]=va+1;Ma=h[va>>0]|0}else Ma=VIc(a)|0;if(!(b[i+(Ma+1)>>0]|0)){Da=xa;Ea=L;Fa=0;Ga=0;break i}b[L+xa>>0]=Ma;xa=xa+1|0;na=f[q>>2]|0}}}while(0);if(!(f[q>>2]|0))Na=f[o>>2]|0;else{ma=(f[o>>2]|0)+-1|0;f[o>>2]=ma;Na=ma}ma=Na-(f[s>>2]|0)+(f[r>>2]|0)|0;if(!ma){Oa=Ea;Pa=Ga;$=139;break b}if(!((ma|0)==(aa|0)|ha^1)){Oa=Ea;Pa=Ga;$=139;break b}do if(V)if(oa){f[L>>2]=Fa;break}else{f[L>>2]=Ea;break}while(0);if(ha){Qa=la;Ra=Ea;Sa=Ga}else{if(Fa|0)f[Fa+(Da<<2)>>2]=0;if(!Ea){Qa=la;Ra=0;Sa=Ga;break f}b[Ea+Da>>0]=0;Qa=la;Ra=Ea;Sa=Ga}break}case 120:case 88:case 112:{Ta=16;$=125;break}case 111:{Ta=8;$=125;break}case 117:case 100:{Ta=10;$=125;break}case 105:{Ta=0;$=125;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{Ua=+BKc(a,K,0);if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=Q;$=139;break b}if(!L){Qa=X;Ra=P;Sa=Q}else switch(K|0){case 0:{n[L>>2]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}case 1:{p[L>>3]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}case 2:{p[L>>3]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}default:{Qa=X;Ra=P;Sa=Q;break f}}break}default:{Qa=X;Ra=P;Sa=Q}}while(0);do if(($|0)==125){$=0;N=UIc(a,Ta,0,-1,-1)|0;if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=Q;$=139;break b}if(O&(R|0)==112){f[L>>2]=N;Qa=X;Ra=P;Sa=Q;break}else{zKc(L,K,N,J);Qa=X;Ra=P;Sa=Q;break}}while(0);ca=Qa;da=(O&1)+D|0;ea=(f[r>>2]|0)+ba+(f[o>>2]|0)-(f[s>>2]|0)|0;fa=Ra;ga=Sa;break c}while(0);Q=B+(H&1)|0;TIc(a,0);P=f[o>>2]|0;if(P>>>0<(f[q>>2]|0)>>>0){f[o>>2]=P+1;Va=h[P>>0]|0}else Va=VIc(a)|0;if((Va|0)!=(h[Q>>0]|0)){$=22;break b}ca=Q;da=D;ea=C+1|0;fa=E;ga=F}else{Q=B;while(1){P=Q+1|0;if(!(WIc(h[P>>0]|0)|0))break;else Q=P}TIc(a,0);do{H=f[o>>2]|0;if(H>>>0<(f[q>>2]|0)>>>0){f[o>>2]=H+1;Wa=h[H>>0]|0}else Wa=VIc(a)|0}while((WIc(Wa)|0)!=0);if(!(f[q>>2]|0))Xa=f[o>>2]|0;else{H=(f[o>>2]|0)+-1|0;f[o>>2]=H;Xa=H}ca=Q;da=D;ea=(f[r>>2]|0)+C+Xa-(f[s>>2]|0)|0;fa=E;ga=F}while(0);B=ca+1|0;G=b[B>>0]|0;if(!(G<<24>>24)){Ya=da;break a}else{C=ea;D=da;E=fa;F=ga}}if(($|0)==22){if(f[q>>2]|0)f[o>>2]=(f[o>>2]|0)+-1;if((D|0)!=0|(Va|0)>-1){Ya=D;break}else{Za=0;_a=E;$a=F;$=138}}else if(($|0)==137){C=_&1;if(!D){Za=C;_a=Y;$a=Z;$=138}else{ab=C;bb=D;cb=Y;db=Z}}else if(($|0)==139){ab=V&1;bb=D;cb=Oa;db=Pa}if(($|0)==138){ab=Za;bb=-1;cb=_a;db=$a}if(!ab)Ya=bb;else{kIc(cb);kIc(db);Ya=bb}}else Ya=0;while(0);if(l|0)tJc(a);u=e;return Ya|0}function yKc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[d>>2]=f[a>>2];a=b;while(1){b=(f[d>>2]|0)+(4-1)&~(4-1);e=f[b>>2]|0;f[d>>2]=b+4;if(a>>>0>1)a=a+-1|0;else break}u=c;return e|0}function zKc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0;a:do if(a|0)switch(c|0){case -2:{b[a>>0]=e;break a;break}case -1:{d[a>>1]=e;break a;break}case 0:{f[a>>2]=e;break a;break}case 1:{f[a>>2]=e;break a;break}case 3:{h=a;f[h>>2]=e;f[h+4>>2]=g;break a;break}default:break a}while(0);return}function AKc(a){a=a|0;var b=0;if(!a)b=1;else b=(f[a>>2]|0)==0;return b&1|0}function BKc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0;switch(c|0){case 0:{e=-149;g=24;i=4;break}case 1:{e=-1074;g=53;i=4;break}case 2:{e=-1074;g=53;i=4;break}default:j=0.0}a:do if((i|0)==4){c=a+4|0;k=a+100|0;do{l=f[c>>2]|0;if(l>>>0<(f[k>>2]|0)>>>0){f[c>>2]=l+1;m=h[l>>0]|0}else m=VIc(a)|0}while((WIc(m)|0)!=0);b:do switch(m|0){case 43:case 45:{l=1-(((m|0)==45&1)<<1)|0;n=f[c>>2]|0;if(n>>>0<(f[k>>2]|0)>>>0){f[c>>2]=n+1;o=h[n>>0]|0;p=l;break b}else{o=VIc(a)|0;p=l;break b}break}default:{o=m;p=1}}while(0);l=0;n=o;while(1){if((n|32|0)!=(b[524252+l>>0]|0)){q=l;r=n;break}do if(l>>>0<7){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;t=h[s>>0]|0;break}else{t=VIc(a)|0;break}}else t=n;while(0);s=l+1|0;if(s>>>0<8){l=s;n=t}else{q=s;r=t;break}}c:do switch(q|0){case 8:break;case 3:{i=23;break}default:{n=(d|0)!=0;if(n&q>>>0>3)if((q|0)==8)break c;else{i=23;break c}d:do if(!q){l=0;s=r;while(1){if((s|32|0)!=(b[524261+l>>0]|0)){u=l;v=s;break d}do if(l>>>0<2){w=f[c>>2]|0;if(w>>>0<(f[k>>2]|0)>>>0){f[c>>2]=w+1;x=h[w>>0]|0;break}else{x=VIc(a)|0;break}}else x=s;while(0);w=l+1|0;if(w>>>0<3){l=w;s=x}else{u=w;v=x;break}}}else{u=q;v=r}while(0);switch(u|0){case 3:{s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;y=h[s>>0]|0}else y=VIc(a)|0;if((y|0)==40)z=1;else{if(!(f[k>>2]|0)){j=C;break a}f[c>>2]=(f[c>>2]|0)+-1;j=C;break a}while(1){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;A=h[s>>0]|0}else A=VIc(a)|0;if(!((A+-48|0)>>>0<10|(A+-65|0)>>>0<26)?!((A|0)==95|(A+-97|0)>>>0<26):0)break;z=z+1|0}if((A|0)==41){j=C;break a}s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!n){l=vIc()|0;f[l>>2]=22;TIc(a,0);j=0.0;break a}if(!z){j=C;break a}else B=z;while(1){B=B+-1|0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!B){j=C;break a}}break}case 0:{if((v|0)==48){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;E=h[s>>0]|0}else E=VIc(a)|0;if((E|32|0)==120){j=+CKc(a,g,e,p,d);break a}if(!(f[k>>2]|0))F=48;else{f[c>>2]=(f[c>>2]|0)+-1;F=48}}else F=v;j=+DKc(a,F,g,e,p,d);break a;break}default:{if(f[k>>2]|0)f[c>>2]=(f[c>>2]|0)+-1;s=vIc()|0;f[s>>2]=22;TIc(a,0);j=0.0;break a}}}}while(0);if((i|0)==23){s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if((d|0)!=0&q>>>0>3){n=q;do{if(!s)f[c>>2]=(f[c>>2]|0)+-1;n=n+-1|0}while(n>>>0>3)}}j=+(p|0)*D}while(0);return +j}function CKc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0.0,S=0,T=0.0,U=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0.0;g=a+4|0;i=f[g>>2]|0;j=a+100|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=0}else{k=VIc(a)|0;l=0}a:while(1){switch(k|0){case 46:{m=8;break a;break}case 48:break;default:{n=0;o=0;p=1.0;q=0.0;r=0;s=k;t=l;u=0;v=0;w=0;x=0;break a}}i=f[g>>2]|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=1;continue}else{k=VIc(a)|0;l=1;continue}}if((m|0)==8){k=f[g>>2]|0;if(k>>>0<(f[j>>2]|0)>>>0){f[g>>2]=k+1;y=h[k>>0]|0}else y=VIc(a)|0;if((y|0)==48){k=0;i=0;while(1){z=f[g>>2]|0;if(z>>>0<(f[j>>2]|0)>>>0){f[g>>2]=z+1;A=h[z>>0]|0}else A=VIc(a)|0;z=d1c(k|0,i|0,-1,-1)|0;B=J;if((A|0)==48){k=z;i=B}else{n=1;o=0;p=1.0;q=0.0;r=0;s=A;t=1;u=B;v=0;w=0;x=z;break}}}else{n=1;o=0;p=1.0;q=0.0;r=0;s=y;t=l;u=0;v=0;w=0;x=0}}while(1){l=s+-48|0;y=(s|0)==46;if(l>>>0>=10?!(y|((s|32)+-97|0)>>>0<6):0){C=s;break}if(y)if(!n){D=1;E=o;F=p;G=q;H=r;I=t;K=w;L=v;M=w;N=v}else{C=46;break}else{y=(s|0)>57?(s|32)+-87|0:l;do if(!((v|0)<0|(v|0)==0&w>>>0<8))if((v|0)<0|(v|0)==0&w>>>0<14){O=p*.0625;P=o;Q=O;R=q+O*+(y|0);S=r;break}else{l=(o|0)!=0|(y|0)==0;P=l?o:1;Q=p;R=l?q:q+p*.5;S=r;break}else{P=o;Q=p;R=q;S=y+(r<<4)|0}while(0);y=d1c(w|0,v|0,1,0)|0;D=n;E=P;F=Q;G=R;H=S;I=1;K=x;L=u;M=y;N=J}y=f[g>>2]|0;if(y>>>0<(f[j>>2]|0)>>>0){f[g>>2]=y+1;n=D;o=E;p=F;q=G;r=H;s=h[y>>0]|0;t=I;u=L;v=N;w=M;x=K;continue}else{n=D;o=E;p=F;q=G;r=H;s=VIc(a)|0;t=I;u=L;v=N;w=M;x=K;continue}}do if(!t){K=f[j>>2]|0;M=(K|0)!=0;if(M)f[g>>2]=(f[g>>2]|0)+-1;if(e){if(M)f[g>>2]=(f[g>>2]|0)+-1;if(!((n|0)==0|(K|0)==0))f[g>>2]=(f[g>>2]|0)+-1}else TIc(a,0);T=+(d|0)*0.0}else{K=(n|0)==0;M=K?w:x;N=K?v:u;if((v|0)<0|(v|0)==0&w>>>0<8){K=r;L=w;I=v;while(1){s=K<<4;L=d1c(L|0,I|0,1,0)|0;I=J;if(!((I|0)<0|(I|0)==0&L>>>0<8)){U=s;break}else K=s}}else U=r;if((C|32|0)==112){K=EKc(a,e)|0;L=J;if((K|0)==0&(L|0)==-2147483648){if(!e){TIc(a,0);T=0.0;break}if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}}else{V=K;W=L}}else if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}L=u1c(M|0,N|0,2)|0;K=d1c(L|0,J|0,-32,-1)|0;L=d1c(K|0,J|0,V|0,W|0)|0;K=J;if(!U){T=+(d|0)*0.0;break}I=0-c|0;s=((I|0)<0)<<31>>31;if((K|0)>(s|0)|(K|0)==(s|0)&L>>>0>I>>>0){I=vIc()|0;f[I>>2]=34;T=+(d|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}I=c+-106|0;s=((I|0)<0)<<31>>31;if((K|0)<(s|0)|(K|0)==(s|0)&L>>>0<I>>>0){I=vIc()|0;f[I>>2]=34;T=+(d|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if((U|0)>-1){G=q;I=U;s=L;H=K;while(1){E=!(G>=.5);o=I<<1|(E^1)&1;F=G+(E?G:G+-1.0);E=d1c(s|0,H|0,-1,-1)|0;D=J;if((o|0)>-1){G=F;I=o;s=E;H=D}else{X=F;Y=o;Z=E;_=D;break}}}else{X=q;Y=U;Z=L;_=K}H=((b|0)<0)<<31>>31;s=c1c(32,0,c|0,((c|0)<0)<<31>>31|0)|0;I=d1c(s|0,J|0,Z|0,_|0)|0;s=J;if((H|0)>(s|0)|(H|0)==(s|0)&b>>>0>I>>>0)if((I|0)>0){$=I;m=59}else{aa=0;ba=84;m=61}else{$=b;m=59}if((m|0)==59)if(($|0)<53){aa=$;ba=84-$|0;m=61}else{ca=0.0;da=$;ea=+(d|0)}if((m|0)==61){G=+(d|0);ca=+GKc(+FKc(1.0,ba),G);da=aa;ea=G}I=(Y&1|0)==0&(X!=0.0&(da|0)<32);G=ea*(I?0.0:X)+(ca+ea*+(((I&1)+Y|0)>>>0))-ca;if(!(G!=0.0)){I=vIc()|0;f[I>>2]=34}T=+IKc(G,Z)}while(0);return +T}function DKc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0;i=u;u=u+512|0;j=i;k=d+c|0;l=0-k|0;m=a+4|0;n=a+100|0;o=b;b=0;a:while(1){switch(o|0){case 46:{p=6;break a;break}case 48:break;default:{q=0;r=o;s=b;t=0;v=0;break a}}w=f[m>>2]|0;if(w>>>0<(f[n>>2]|0)>>>0){f[m>>2]=w+1;o=h[w>>0]|0;b=1;continue}else{o=VIc(a)|0;b=1;continue}}if((p|0)==6){o=f[m>>2]|0;if(o>>>0<(f[n>>2]|0)>>>0){f[m>>2]=o+1;x=h[o>>0]|0}else x=VIc(a)|0;if((x|0)==48){o=0;w=0;while(1){y=d1c(o|0,w|0,-1,-1)|0;z=J;A=f[m>>2]|0;if(A>>>0<(f[n>>2]|0)>>>0){f[m>>2]=A+1;B=h[A>>0]|0}else B=VIc(a)|0;if((B|0)==48){o=y;w=z}else{q=1;r=B;s=1;t=y;v=z;break}}}else{q=1;r=x;s=b;t=0;v=0}}f[j>>2]=0;b=r+-48|0;x=(r|0)==46;b:do if(x|b>>>0<10){B=j+496|0;w=0;o=0;z=0;y=q;A=s;C=r;D=x;E=b;F=t;G=v;H=0;I=0;c:while(1){do if(D)if(!y){K=w;M=o;N=1;O=z;P=A;Q=H;R=I;S=H;T=I}else break c;else{U=d1c(H|0,I|0,1,0)|0;V=J;W=(C|0)!=48;if((o|0)>=125){if(!W){K=w;M=o;N=y;O=z;P=A;Q=F;R=G;S=U;T=V;break}f[B>>2]=f[B>>2]|1;K=w;M=o;N=y;O=z;P=A;Q=F;R=G;S=U;T=V;break}X=j+(o<<2)|0;if(!w)Z=E;else Z=C+-48+((f[X>>2]|0)*10|0)|0;f[X>>2]=Z;X=w+1|0;_=(X|0)==9;K=_?0:X;M=(_&1)+o|0;N=y;O=W?U:z;P=1;Q=F;R=G;S=U;T=V}while(0);V=f[m>>2]|0;if(V>>>0<(f[n>>2]|0)>>>0){f[m>>2]=V+1;$=h[V>>0]|0}else $=VIc(a)|0;E=$+-48|0;D=($|0)==46;if(!(D|E>>>0<10)){aa=K;ba=M;ca=O;da=N;ea=$;fa=P;ga=Q;ha=S;ia=R;ja=T;p=29;break b}else{w=K;o=M;z=O;y=N;A=P;C=$;F=Q;G=R;H=S;I=T}}ka=w;la=o;ma=z;na=H;oa=I;pa=F;qa=G;ra=(A|0)!=0;p=37}else{aa=0;ba=0;ca=0;da=q;ea=r;fa=s;ga=t;ha=0;ia=v;ja=0;p=29}while(0);do if((p|0)==29){v=(da|0)==0;t=v?ha:ga;s=v?ja:ia;v=(fa|0)!=0;if(!(v&(ea|32|0)==101))if((ea|0)>-1){ka=aa;la=ba;ma=ca;na=ha;oa=ja;pa=t;qa=s;ra=v;p=37;break}else{sa=aa;ta=ba;ua=ca;va=ha;wa=ja;xa=v;ya=t;za=s;p=39;break}v=EKc(a,g)|0;r=J;if((v|0)==0&(r|0)==-2147483648){if(!g){TIc(a,0);Aa=0.0;break}if(!(f[n>>2]|0)){Ba=0;Ca=0}else{f[m>>2]=(f[m>>2]|0)+-1;Ba=0;Ca=0}}else{Ba=v;Ca=r}r=d1c(Ba|0,Ca|0,t|0,s|0)|0;Da=aa;Ea=ba;Fa=ca;Ga=r;Ha=ha;Ia=J;Ja=ja;p=41}while(0);if((p|0)==37)if(f[n>>2]|0){f[m>>2]=(f[m>>2]|0)+-1;if(ra){Da=ka;Ea=la;Fa=ma;Ga=pa;Ha=na;Ia=qa;Ja=oa;p=41}else p=40}else{sa=ka;ta=la;ua=ma;va=na;wa=oa;xa=ra;ya=pa;za=qa;p=39}if((p|0)==39)if(xa){Da=sa;Ea=ta;Fa=ua;Ga=ya;Ha=va;Ia=za;Ja=wa;p=41}else p=40;do if((p|0)==40){wa=vIc()|0;f[wa>>2]=22;TIc(a,0);Aa=0.0}else if((p|0)==41){wa=f[j>>2]|0;if(!wa){Aa=+(e|0)*0.0;break}if(((Ja|0)<0|(Ja|0)==0&Ha>>>0<10)&((Ga|0)==(Ha|0)&(Ia|0)==(Ja|0))?(c|0)>30|(wa>>>c|0)==0:0){Aa=+(e|0)*+(wa>>>0);break}wa=(d|0)/-2|0;za=((wa|0)<0)<<31>>31;if((Ia|0)>(za|0)|(Ia|0)==(za|0)&Ga>>>0>wa>>>0){wa=vIc()|0;f[wa>>2]=34;Aa=+(e|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}wa=d+-106|0;za=((wa|0)<0)<<31>>31;if((Ia|0)<(za|0)|(Ia|0)==(za|0)&Ga>>>0<wa>>>0){wa=vIc()|0;f[wa>>2]=34;Aa=+(e|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(!Da)Ka=Ea;else{if((Da|0)<9){wa=j+(Ea<<2)|0;za=Da;va=f[wa>>2]|0;do{va=va*10|0;za=za+1|0}while((za|0)!=9);f[wa>>2]=va}Ka=Ea+1|0}if((Fa|0)<9?(Fa|0)<=(Ga|0)&(Ga|0)<18:0){za=f[j>>2]|0;if((Ga|0)==9){Aa=+(e|0)*+(za>>>0);break}if((Ga|0)<9){Aa=+(e|0)*+(za>>>0)/+(f[185248+(8-Ga<<2)>>2]|0);break}A=c+27+(Y(Ga,-3)|0)|0;if((A|0)>30|(za>>>A|0)==0){Aa=+(e|0)*+(za>>>0)*+(f[185248+(Ga+-10<<2)>>2]|0);break}}za=(Ga|0)%9|0;if(!za){La=0;Ma=Ka;Na=0;Oa=Ga}else{A=(Ga|0)>-1?za:za+9|0;za=f[185248+(8-A<<2)>>2]|0;if(Ka){G=1e9/(za|0)|0;F=0;I=0;H=Ga;z=0;do{o=j+(z<<2)|0;w=f[o>>2]|0;ya=((w>>>0)/(za>>>0)|0)+F|0;f[o>>2]=ya;F=Y(G,(w>>>0)%(za>>>0)|0)|0;w=(z|0)==(I|0)&(ya|0)==0;H=w?H+-9|0:H;I=w?I+1&127:I;z=z+1|0}while((z|0)!=(Ka|0));if(!F){Pa=I;Qa=Ka;Ra=H}else{f[j+(Ka<<2)>>2]=F;Pa=I;Qa=Ka+1|0;Ra=H}}else{Pa=0;Qa=0;Ra=Ga}La=0;Ma=Qa;Na=Pa;Oa=9-A+Ra|0}d:while(1){z=(Oa|0)<18;za=(Oa|0)==18;G=j+(Na<<2)|0;va=La;wa=Ma;while(1){if(!z){if(!za){Sa=va;Ta=Na;Ua=Oa;Va=wa;break d}if((f[G>>2]|0)>>>0>=9007199){Sa=va;Ta=Na;Ua=18;Va=wa;break d}}w=0;Wa=wa;ya=wa+127|0;while(1){o=ya&127;ua=j+(o<<2)|0;ta=u1c(f[ua>>2]|0,0,29)|0;sa=d1c(ta|0,J|0,w|0,0)|0;ta=J;if(ta>>>0>0|(ta|0)==0&sa>>>0>1e9){xa=n1c(sa|0,ta|0,1e9,0)|0;qa=r1c(sa|0,ta|0,1e9,0)|0;Xa=xa;Ya=qa}else{Xa=0;Ya=sa}f[ua>>2]=Ya;ua=(o|0)==(Na|0);Wa=(Ya|0)==0&(((o|0)!=(Wa+127&127|0)|ua)^1)?o:Wa;if(ua)break;else{w=Xa;ya=o+-1|0}}va=va+-29|0;if(Xa|0)break;else wa=Wa}wa=Na+127&127;G=Wa+127&127;za=j+((Wa+126&127)<<2)|0;if((wa|0)==(Wa|0)){f[za>>2]=f[za>>2]|f[j+(G<<2)>>2];Za=G}else Za=Wa;f[j+(wa<<2)>>2]=Xa;La=va;Ma=Za;Na=wa;Oa=Oa+9|0}e:while(1){A=Va+1&127;H=j+((Va+127&127)<<2)|0;I=Sa;F=Ta;wa=Ua;while(1){G=(wa|0)==18;za=(wa|0)>27?9:1;_a=I;$a=F;while(1){z=0;while(1){ya=z+$a&127;if((ya|0)==(Va|0)){ab=2;p=88;break}w=f[j+(ya<<2)>>2]|0;ya=f[185280+(z<<2)>>2]|0;if(w>>>0<ya>>>0){ab=2;p=88;break}if(w>>>0>ya>>>0)break;ya=z+1|0;if((ya|0)<2)z=ya;else{ab=ya;p=88;break}}if((p|0)==88?(p=0,G&(ab|0)==2):0){bb=0.0;cb=0;db=Va;break e}eb=za+_a|0;if(($a|0)==(Va|0)){_a=eb;$a=Va}else break}G=(1<<za)+-1|0;z=1e9>>>za;fb=0;gb=$a;hb=wa;ya=$a;do{w=j+(ya<<2)|0;o=f[w>>2]|0;ua=(o>>>za)+fb|0;f[w>>2]=ua;fb=Y(o&G,z)|0;o=(ya|0)==(gb|0)&(ua|0)==0;hb=o?hb+-9|0:hb;gb=o?gb+1&127:gb;ya=ya+1&127}while((ya|0)!=(Va|0));if(!fb){I=eb;F=gb;wa=hb;continue}if((A|0)!=(gb|0))break;f[H>>2]=f[H>>2]|1;I=eb;F=gb;wa=hb}f[j+(Va<<2)>>2]=fb;Sa=eb;Ta=gb;Ua=hb;Va=A}while(1){wa=cb+$a&127;F=db+1&127;if((wa|0)==(db|0)){f[j+(F+-1<<2)>>2]=0;ib=F}else ib=db;bb=bb*1.0e9+ +((f[j+(wa<<2)>>2]|0)>>>0);cb=cb+1|0;if((cb|0)==2)break;else db=ib}jb=+(e|0);kb=jb*bb;wa=_a+53|0;F=wa-d|0;I=(F|0)<(c|0);H=I?((F|0)>0?F:0):c;if((H|0)<53){lb=+GKc(+FKc(1.0,105-H|0),kb);mb=+HKc(kb,+FKc(1.0,53-H|0));nb=lb;ob=mb;pb=lb+(kb-mb)}else{nb=0.0;ob=0.0;pb=kb}va=$a+2&127;if((va|0)!=(ib|0)){ya=f[j+(va<<2)>>2]|0;do if(ya>>>0>=5e8){if((ya|0)!=5e8){qb=jb*.75+ob;break}if(($a+3&127|0)==(ib|0)){qb=jb*.5+ob;break}else{qb=jb*.75+ob;break}}else{if((ya|0)==0?($a+3&127|0)==(ib|0):0){qb=ob;break}qb=jb*.25+ob}while(0);if((53-H|0)>1?!(+HKc(qb,1.0)!=0.0):0)rb=qb+1.0;else rb=qb}else rb=ob;jb=pb+rb-nb;do if((wa&2147483647|0)>(-2-k|0)){ya=!(+L(+jb)>=9007199254740992.0);va=((ya^1)&1)+_a|0;kb=ya?jb:jb*.5;if((va+50|0)<=(l|0)?!(rb!=0.0&(I&((H|0)!=(F|0)|ya))):0){sb=kb;tb=va;break}ya=vIc()|0;f[ya>>2]=34;sb=kb;tb=va}else{sb=jb;tb=_a}while(0);Aa=+IKc(sb,tb)}while(0);u=i;return +Aa}function EKc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+4|0;d=f[c>>2]|0;e=a+100|0;if(d>>>0<(f[e>>2]|0)>>>0){f[c>>2]=d+1;g=h[d>>0]|0}else g=VIc(a)|0;switch(g|0){case 43:case 45:{d=(g|0)==45&1;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;j=h[i>>0]|0}else j=VIc(a)|0;if((b|0)!=0&(j+-48|0)>>>0>9?(f[e>>2]|0)!=0:0){f[c>>2]=(f[c>>2]|0)+-1;k=d;l=j}else{k=d;l=j}break}default:{k=0;l=g}}if((l+-48|0)>>>0>9)if(!(f[e>>2]|0)){m=-2147483648;n=0}else{f[c>>2]=(f[c>>2]|0)+-1;m=-2147483648;n=0}else{g=0;j=l;while(1){g=j+-48+(g*10|0)|0;l=f[c>>2]|0;if(l>>>0<(f[e>>2]|0)>>>0){f[c>>2]=l+1;o=h[l>>0]|0}else o=VIc(a)|0;if(!((o+-48|0)>>>0<10&(g|0)<214748364))break;else j=o}j=((g|0)<0)<<31>>31;if((o+-48|0)>>>0<10){l=o;d=g;b=j;while(1){i=x1c(d|0,b|0,10,0)|0;p=J;q=d1c(l|0,((l|0)<0)<<31>>31|0,-48,-1)|0;r=d1c(q|0,J|0,i|0,p|0)|0;p=J;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;s=h[i>>0]|0}else s=VIc(a)|0;if((s+-48|0)>>>0<10&((p|0)<21474836|(p|0)==21474836&r>>>0<2061584302)){l=s;d=r;b=p}else{t=s;u=r;v=p;break}}}else{t=o;u=g;v=j}j=f[e>>2]|0;if((t+-48|0)>>>0<10){t=j;while(1){g=f[c>>2]|0;if(g>>>0<t>>>0){f[c>>2]=g+1;w=h[g>>0]|0;x=t}else{g=VIc(a)|0;w=g;x=f[e>>2]|0}if((w+-48|0)>>>0<10)t=x;else{y=x;break}}}else y=j;if(y|0)f[c>>2]=(f[c>>2]|0)+-1;c=(k|0)!=0;k=c1c(0,0,u|0,v|0)|0;m=c?J:v;n=c?k:u}J=m;return n|0}function FKc(a,b){a=+a;b=b|0;var c=0.0,d=0,e=0,g=0,h=0.0,i=0;if((b|0)<=1023)if((b|0)<-1022){c=a*2.2250738585072014e-308;d=b+1022|0;e=(d|0)<-1022;g=b+2044|0;h=e?c*2.2250738585072014e-308:c;i=e?((g|0)>-1022?g:-1022):d}else{h=a;i=b}else{c=a*8988465674311579538646525.0e283;d=b+-1023|0;g=(d|0)>1023;e=b+-2046|0;h=g?c*8988465674311579538646525.0e283:c;i=g?((e|0)<1023?e:1023):d}d=u1c(i+1023|0,0,52)|0;i=J;f[s>>2]=d;f[s+4>>2]=i;return +(h*+p[s>>3])}function GKc(a,b){a=+a;b=+b;return +(+LKc(a,b))}function HKc(a,b){a=+a;b=+b;return +(+JKc(a,b))}function IKc(a,b){a=+a;b=b|0;return +(+FKc(a,b))}function JKc(a,b){a=+a;b=+b;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s>>2]|0;g=f[s+4>>2]|0;h=l1c(c|0,d|0,52)|0;i=h&2047;h=l1c(e|0,g|0,52)|0;j=h&2047;h=d&-2147483648;k=u1c(e|0,g|0,1)|0;l=J;a:do if(!((k|0)==0&(l|0)==0)?(m=KKc(b)|0,n=J&2147483647,!((i|0)==2047|(n>>>0>2146435072|(n|0)==2146435072&m>>>0>0))):0){m=u1c(c|0,d|0,1)|0;n=J;if(!(n>>>0>l>>>0|(n|0)==(l|0)&m>>>0>k>>>0))return +((m|0)==(k|0)&(n|0)==(l|0)?a*0.0:a);if(!i){n=u1c(c|0,d|0,12)|0;m=J;if((m|0)>-1|(m|0)==-1&n>>>0>4294967295){o=0;q=n;n=m;while(1){m=o+-1|0;q=u1c(q|0,n|0,1)|0;n=J;if(!((n|0)>-1|(n|0)==-1&q>>>0>4294967295)){r=m;break}else o=m}}else r=0;o=u1c(c|0,d|0,1-r|0)|0;t=r;u=o;v=J}else{t=i;u=c;v=d&1048575|1048576}if(!j){o=u1c(e|0,g|0,12)|0;q=J;if((q|0)>-1|(q|0)==-1&o>>>0>4294967295){n=0;m=o;o=q;while(1){q=n+-1|0;m=u1c(m|0,o|0,1)|0;o=J;if(!((o|0)>-1|(o|0)==-1&m>>>0>4294967295)){w=q;break}else n=q}}else w=0;n=u1c(e|0,g|0,1-w|0)|0;x=w;y=n;z=J}else{x=j;y=e;z=g&1048575|1048576}n=c1c(u|0,v|0,y|0,z|0)|0;m=J;o=(m|0)>-1|(m|0)==-1&n>>>0>4294967295;b:do if((t|0)>(x|0)){q=t;A=m;B=o;C=u;D=v;E=n;while(1){if(B)if((E|0)==0&(A|0)==0)break;else{F=E;G=A}else{F=C;G=D}H=u1c(F|0,G|0,1)|0;I=J;K=q+-1|0;L=c1c(H|0,I|0,y|0,z|0)|0;M=J;N=(M|0)>-1|(M|0)==-1&L>>>0>4294967295;if((K|0)>(x|0)){q=K;A=M;B=N;C=H;D=I;E=L}else{O=K;P=N;Q=L;R=M;S=H;T=I;break b}}U=a*0.0;break a}else{O=t;P=o;Q=n;R=m;S=u;T=v}while(0);if(P)if((Q|0)==0&(R|0)==0){U=a*0.0;break}else{V=R;W=Q}else{V=T;W=S}if(V>>>0<1048576|(V|0)==1048576&W>>>0<0){m=O;n=W;o=V;while(1){E=u1c(n|0,o|0,1)|0;D=J;C=m+-1|0;if(D>>>0<1048576|(D|0)==1048576&E>>>0<0){m=C;n=E;o=D}else{X=C;Y=E;Z=D;break}}}else{X=O;Y=W;Z=V}if((X|0)>0){o=d1c(Y|0,Z|0,0,-1048576)|0;n=J;m=u1c(X|0,0,52)|0;_=n|J;$=o|m}else{m=l1c(Y|0,Z|0,1-X|0)|0;_=J;$=m}f[s>>2]=$;f[s+4>>2]=_|h;U=+p[s>>3]}else aa=3;while(0);if((aa|0)==3){ba=a*b;U=ba/ba}return +U}function KKc(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function LKc(a,b){a=+a;b=+b;var c=0,d=0,e=0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s+4>>2]&-2147483648|d&2147483647;f[s>>2]=c;f[s+4>>2]=e;return +(+p[s>>3])}function MKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+84|0;e=f[d>>2]|0;g=c+256|0;h=AJc(e,0,g)|0;i=(h|0)==0?g:h-e|0;h=i>>>0<c>>>0?i:c;o1c(b|0,e|0,h|0)|0;f[a+4>>2]=e+h;b=e+i|0;f[a+8>>2]=b;f[d>>2]=b;return h|0}function NKc(a,b,c){a=a|0;b=b|0;c=c|0;return PKc(a,b,c)|0}function OKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=qJc(a,b,e)|0;u=d;return c|0}function PKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((f[a+76>>2]|0)>-1){d=(sJc(a)|0)==0;e=QKc(a,b,c)|0;if(d)g=e;else{tJc(a);g=e}}else g=QKc(a,b,c)|0;return g|0}function QKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((c|0)==1)d=b-(f[a+8>>2]|0)+(f[a+4>>2]|0)|0;else d=b;b=a+20|0;e=a+28|0;if((f[b>>2]|0)>>>0>(f[e>>2]|0)>>>0?(hj[f[a+36>>2]&511](a,0,0)|0,(f[b>>2]|0)==0):0)g=-1;else{f[a+16>>2]=0;f[e>>2]=0;f[b>>2]=0;if((hj[f[a+40>>2]&511](a,d,c)|0)<0)g=-1;else{f[a+8>>2]=0;f[a+4>>2]=0;f[a>>2]=f[a>>2]&-17;g=0}}return g|0}function RKc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=b[c>>0]|0;do if(d<<24>>24){e=OJc(a,d<<24>>24)|0;if(e)if(b[c+1>>0]|0)if(b[e+1>>0]|0){if(!(b[c+2>>0]|0)){f=SKc(e,c)|0;break}if(b[e+2>>0]|0){if(!(b[c+3>>0]|0)){f=TKc(e,c)|0;break}if(b[e+3>>0]|0)if(!(b[c+4>>0]|0)){f=UKc(e,c)|0;break}else{f=VKc(e,c)|0;break}else f=0}else f=0}else f=0;else f=e;else f=0}else f=a;while(0);return f|0}function SKc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=(h[c>>0]|0)<<8|(h[c+1>>0]|0);c=h[a>>0]|0;e=a;while(1){a=e+1|0;f=b[a>>0]|0;if(!(f<<24>>24)){g=0;break}c=f&255|c<<8&65280;if((c|0)==(d|0)){g=e;break}else e=a}return g|0}function TKc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8;c=a+2|0;e=b[c>>0]|0;f=(h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(e&255)<<8;a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=c;i=a}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=(e&255|c)<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=f;i=j;break}else a=f}}return (i?g+-2|0:0)|0}function UKc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8|(h[c+3>>0]|0);c=a+3|0;e=b[c>>0]|0;f=e&255|((h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(h[a+2>>0]|0)<<8);a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=a;i=c}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=e&255|c<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=j;i=f;break}else a=f}}return (g?i+-3|0:0)|0}function VKc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+1056|0;e=d+1024|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=b[c>>0]|0;a:do if(h<<24>>24){i=0;j=h;k=h&255;while(1){if(!(b[a+i>>0]|0)){l=0;break a}m=e+(((j&255)>>>5&255)<<2)|0;f[m>>2]=f[m>>2]|1<<(j&31);i=i+1|0;f[g+(k<<2)>>2]=i;m=b[c+i>>0]|0;if(!(m<<24>>24))break;else{j=m;k=m&255}}k=i>>>0>1;if(k){j=0;m=-1;n=1;b:while(1){o=1;p=j;q=n;while(1){r=p;s=q;c:while(1){t=1;v=s;while(1){w=b[c+(t+m)>>0]|0;x=b[c+v>>0]|0;if(w<<24>>24!=x<<24>>24)break c;if((t|0)==(o|0))break;t=t+1|0;y=t+r|0;if(y>>>0>=i>>>0){z=o;A=m;break b}else v=y}t=o+r|0;s=t+1|0;if(s>>>0>=i>>>0){z=o;A=m;break b}else r=t}s=v-m|0;if((w&255)<=(x&255))break;q=v+1|0;if(q>>>0>=i>>>0){z=s;A=m;break b}else{o=s;p=v}}n=r+2|0;if(n>>>0>=i>>>0){z=1;A=r;break}else{j=r+1|0;m=r}}if(k){m=0;j=-1;n=1;while(1){p=1;o=m;q=n;while(1){B=o;s=q;d:while(1){t=1;C=s;while(1){D=b[c+(t+j)>>0]|0;E=b[c+C>>0]|0;if(D<<24>>24!=E<<24>>24)break d;if((t|0)==(p|0))break;t=t+1|0;y=t+B|0;if(y>>>0>=i>>>0){F=z;G=A;H=i;I=p;J=j;K=27;break a}else C=y}t=p+B|0;s=t+1|0;if(s>>>0>=i>>>0){F=z;G=A;H=i;I=p;J=j;K=27;break a}else B=t}s=C-j|0;if((D&255)>=(E&255))break;q=C+1|0;if(q>>>0>=i>>>0){F=z;G=A;H=i;I=s;J=j;K=27;break a}else{p=s;o=C}}n=B+2|0;if(n>>>0>=i>>>0){F=z;G=A;H=i;I=1;J=B;K=27;break}else{m=B+1|0;j=B}}}else{F=z;G=A;H=i;I=1;J=-1;K=27}}else{F=1;G=-1;H=i;I=1;J=-1;K=27}}else{F=1;G=-1;H=0;I=1;J=-1;K=27}while(0);e:do if((K|0)==27){A=(J+1|0)>>>0>(G+1|0)>>>0;z=A?I:F;B=A?J:G;A=B+1|0;if(!(WKc(c,c+z|0,A)|0)){L=H-z|0;M=z}else{z=H-B+-1|0;L=0;M=(B>>>0>z>>>0?B:z)+1|0}z=H|63;C=H+-1|0;E=(L|0)!=0;D=H-M|0;r=a;v=0;x=a;while(1){w=r;do if((x-w|0)>>>0<H>>>0){h=AJc(x,0,z)|0;if(h)if((h-w|0)>>>0<H>>>0){l=0;break e}else{N=h;break}else{N=x+z|0;break}}else N=x;while(0);w=b[r+C>>0]|0;f:do if(!(1<<(w&31)&f[e+(((w&255)>>>5&255)<<2)>>2])){O=0;P=H}else{h=H-(f[g+((w&255)<<2)>>2]|0)|0;if(h|0){O=0;P=E&(v|0)!=0&h>>>0<M>>>0?D:h;break}h=A>>>0>v>>>0?A:v;j=b[c+h>>0]|0;g:do if(!(j<<24>>24))Q=A;else{m=h;n=j;while(1){if(n<<24>>24!=(b[r+m>>0]|0))break;k=m+1|0;n=b[c+k>>0]|0;if(!(n<<24>>24)){Q=A;break g}else m=k}O=0;P=m-B|0;break f}while(0);while(1){if(Q>>>0<=v>>>0){l=r;break e}Q=Q+-1|0;if((b[c+Q>>0]|0)!=(b[r+Q>>0]|0)){O=L;P=M;break}}}while(0);r=r+P|0;v=O;x=N}}while(0);u=d;return l|0}function WKc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;a:do if(!d)e=0;else{f=a;g=d;h=c;while(1){i=b[f>>0]|0;j=b[h>>0]|0;if(i<<24>>24!=j<<24>>24)break;g=g+-1|0;if(!g){e=0;break a}else{f=f+1|0;h=h+1|0}}e=(i&255)-(j&255)|0}while(0);return e|0}function XKc(a,b){a=a|0;b=b|0;return YKc(a,b,(dJc(a)|0)+1|0)|0}function YKc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=c&255;c=d;while(1){if(!c){f=0;break}c=c+-1|0;d=a+c|0;if((b[d>>0]|0)==e<<24>>24){f=d;break}}return f|0}function ZKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c|0){d=c;c=a;while(1){d=d+-1|0;f[c>>2]=b;if(!d)break;else c=c+4|0}}return a|0}function _Kc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if(a-b>>2>>>0>=c>>>0){if(c|0){d=b;e=a;g=c;while(1){g=g+-1|0;f[e>>2]=f[d>>2];if(!g)break;else{d=d+4|0;e=e+4|0}}}}else{e=c;do{e=e+-1|0;f[a+(e<<2)>>2]=f[b+(e<<2)>>2]}while((e|0)!=0)}return a|0}function $Kc(a){a=a|0;return +(+aLc(a,0))}function aLc(a,b){a=a|0;b=b|0;return +(+bLc(a,b,1))}function bLc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=e+4|0;f[g>>2]=a;h=e+8|0;f[h>>2]=-1;f[e+44>>2]=a;f[e+76>>2]=-1;TIc(e,0);i=+BKc(e,c,1);c=(f[g>>2]|0)-(f[h>>2]|0)+(f[e+108>>2]|0)|0;if(b|0)f[b>>2]=c|0?a+c|0:a;u=d;return +i}function cLc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=dLc(a,b,e)|0;u=d;return c|0}function dLc(a,b,c){a=a|0;b=b|0;c=c|0;return pJc(a,2147483647,b,c)|0}function eLc(a,b){a=a|0;b=b|0;return +(+bLc(a,b,0))}function fLc(a,b){a=a|0;b=b|0;return +(+bLc(a,b,2))}function gLc(a,b,c){a=a|0;b=b|0;c=c|0;return +(+eLc(a,b))}function hLc(a,b,c){a=a|0;b=b|0;c=c|0;return +(+aLc(a,b))}function iLc(a,b,c){a=a|0;b=b|0;c=c|0;return +(+fLc(a,b))}function jLc(a){a=a|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a;while(1){d=b[c>>0]|0;e=d<<24>>24;f=c+1|0;if(!(WIc(e)|0))break;else c=f}switch(e|0){case 45:{g=1;h=5;break}case 43:{g=0;h=5;break}default:{i=0;j=c;k=d}}if((h|0)==5){i=g;j=f;k=b[f>>0]|0}f=(k<<24>>24)+-48|0;if(f>>>0<10){k=0;g=j;j=f;while(1){g=g+1|0;f=(k*10|0)-j|0;j=(b[g>>0]|0)+-48|0;if(j>>>0>=10){l=f;break}else k=f}}else l=0;return (i|0?l:0-l|0)|0}function kLc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(sJc(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=XIc(a)|0;e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=XIc(a)|0;break}}while(0);return e|0}function lLc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;g=f[c>>2]|0;if((e|0)!=0?(i=f[e>>2]|0,(i|0)!=0):0)if(!a){j=i;k=g;l=d;m=25}else{f[e>>2]=0;n=i;o=a;p=d;q=g;m=43}else m=5;a:do if((m|0)==5){i=(mLc()|0)+188|0;e=(a|0)!=0;if(f[f[i>>2]>>2]|0)if(e){r=a;s=d;t=g;m=15;break}else{u=g;v=d;m=14;break}if(!e){w=dJc(g)|0;m=59;break}b:do if(!d)x=g;else{e=g;i=a;y=d;while(1){z=b[e>>0]|0;if(!(z<<24>>24))break;A=e+1|0;f[i>>2]=z<<24>>24&57343;z=y+-1|0;if(!z){x=A;break b}else{e=A;i=i+4|0;y=z}}f[i>>2]=0;f[c>>2]=0;w=d-y|0;m=59;break a}while(0);f[c>>2]=x;w=d;m=59}while(0);c:while(1){d:do if((m|0)==14){m=0;x=u;g=v;while(1){e=b[x>>0]|0;if(((e&255)+-1|0)>>>0<127?(x&3|0)==0:0){z=f[x>>2]|0;A=z&255;if(!((z+-16843009|z)&-2139062144)){z=x;B=g;do{z=z+4|0;B=B+-4|0;C=f[z>>2]|0}while(!((C+-16843009|C)&-2139062144|0));D=z;E=B;F=C&255}else{D=x;E=g;F=A}}else{D=x;E=g;F=e}G=F&255;if((G+-1|0)>>>0>=127)break;x=D+1|0;g=E+-1|0}g=G+-194|0;if(g>>>0>50){H=D;I=a;J=E;m=53}else{j=f[184288+(g<<2)>>2]|0;k=D+1|0;l=E;m=25;continue c}}else if((m|0)==15){m=0;e:do if(!s)K=t;else{g=r;x=s;y=t;while(1){i=b[y>>0]|0;do if(((i&255)+-1|0)>>>0<127?x>>>0>4&(y&3|0)==0:0){L=g;M=x;N=y;while(1){O=f[N>>2]|0;if((O+-16843009|O)&-2139062144|0){m=38;break}f[L>>2]=O&255;f[L+4>>2]=h[N+1>>0];f[L+8>>2]=h[N+2>>0];P=N+4|0;Q=L+16|0;f[L+12>>2]=h[N+3>>0];R=M+-4|0;if(R>>>0>4){L=Q;M=R;N=P}else{m=37;break}}if((m|0)==37){m=0;S=Q;T=R;U=P;V=b[P>>0]|0;break}else if((m|0)==38){m=0;S=L;T=M;U=N;V=O&255;break}}else{S=g;T=x;U=y;V=i}while(0);W=V&255;if((W+-1|0)>>>0>=127)break;i=U+1|0;f[S>>2]=W;x=T+-1|0;if(!x){K=i;break e}else{g=S+4|0;y=i}}y=W+-194|0;if(y>>>0>50){H=U;I=S;J=T;m=53;break d}n=f[184288+(y<<2)>>2]|0;o=S;p=T;q=U+1|0;m=43;continue c}while(0);f[c>>2]=K;w=d;m=59;continue c}else if((m|0)==25){m=0;y=(h[k>>0]|0)>>>3;if((y+-16|y+(j>>26))>>>0>7){X=a;Y=j;Z=k;_=l;m=52}else{y=k+1|0;if(j&33554432){if((b[y>>0]&-64)<<24>>24!=-128){X=a;Y=j;Z=k;_=l;m=52;break}g=k+2|0;if(!(j&524288))$=g;else{if((b[g>>0]&-64)<<24>>24!=-128){X=a;Y=j;Z=k;_=l;m=52;break}$=k+3|0}}else $=y;u=$;v=l+-1|0;m=14;continue c}}else if((m|0)==43){m=0;y=h[q>>0]|0;g=y>>>3;if((g+-16|g+(n>>26))>>>0>7){X=o;Y=n;Z=q;_=p;m=52}else{g=q+1|0;x=y+-128|n<<6;do if((x|0)<0){y=(h[g>>0]|0)+-128|0;if(y>>>0>63){aa=q+-1|0;ba=o;break d}e=q+2|0;A=y|x<<6;if((A|0)<0){y=(h[e>>0]|0)+-128|0;if(y>>>0>63){aa=q+-1|0;ba=o;break d}else{ca=q+3|0;da=y|A<<6;break}}else{ca=e;da=A}}else{ca=g;da=x}while(0);f[o>>2]=da;r=o+4|0;s=p+-1|0;t=ca;m=15;continue c}}else if((m|0)==59){m=0;return w|0}while(0);if((m|0)==52){m=0;x=Z+-1|0;if(!Y){H=x;I=X;J=_;m=53}else{aa=x;ba=X}}if((m|0)==53){m=0;if(!(b[H>>0]|0)){if(I|0){f[I>>2]=0;f[c>>2]=0}w=d-J|0;m=59;continue}else{aa=H;ba=I}}x=vIc()|0;f[x>>2]=84;if(!ba){w=-1;m=59;continue}f[c>>2]=aa;w=-1;m=59}return 0}function mLc(){return xIc()|0}function nLc(a){a=+a;var b=0,c=0,d=0,e=0,g=0.0,h=0.0,i=0,j=0.0,k=0.0,l=0,m=0,n=0.0,o=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2147483647;d=l1c(f[s>>2]|0,b|0,63)|0;do if(c>>>0>1078159481){b=oLc(a)|0;e=J&2147483647;if(!(e>>>0>2146435072|(e|0)==2146435072&b>>>0>0))if(!d)if(a>709.782712893384)g=a*8988465674311579538646525.0e283;else{h=.5;i=12}else g=-1.0;else g=a}else{if(c>>>0<=1071001154)if(c>>>0<1016070144){g=a;break}else{j=a;k=0.0;l=0;i=15;break}b=(d|0)!=0;if(c>>>0>=1072734898){h=b?-.5:.5;i=12;break}if(b){m=-1;n=a+.6931471803691238;o=-1.9082149292705877e-10;i=13;break}else{m=1;n=a+-.6931471803691238;o=1.9082149292705877e-10;i=13;break}}while(0);if((i|0)==12){c=~~(a*1.4426950408889634+h);h=+(c|0);m=c;n=a-h*.6931471803691238;o=h*1.9082149292705877e-10;i=13}if((i|0)==13){h=n-o;j=h;k=n-h-o;l=m;i=15}a:do if((i|0)==15){o=j*.5;h=j*o;n=h*(h*(h*(h*(4.008217827329362e-06-h*2.0109921818362437e-07)+-7.93650757867488e-05)+1.5873015872548146e-03)+-.03333333333333313)+1.0;a=3.0-o*n;o=h*((n-a)/(6.0-j*a));if(!l){g=j-(j*o-h);break}a=j*(o-k)-k-h;switch(l|0){case -1:{g=(j-a)*.5+-.5;break a;break}case 1:{if(j<-.25){g=(a-(j+.5))*-2.0;break a}else{g=(j-a)*2.0+1.0;break a}break}default:{m=u1c(l+1023|0,0,52)|0;c=J;f[s>>2]=m;f[s+4>>2]=c;h=+p[s>>3];if(l>>>0>56){o=j-a+1.0;g=((l|0)==1024?o*2.0*8988465674311579538646525.0e283:h*o)+-1.0;break a}else{c=u1c(1023-l|0,0,52)|0;m=J;d=(l|0)<20;f[s>>2]=c;f[s+4>>2]=m;o=+p[s>>3];g=h*((d?1.0-o:1.0)+(j-(d?a:o+a)));break a}}}}while(0);return +g}function oLc(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function pLc(a){a=+a;var b=0,c=0,d=0,e=0.0,g=0.0,h=0,i=0.0,j=0.0,k=0,l=0,m=0.0,o=0.0;b=(n[s>>2]=a,f[s>>2]|0);c=b&2147483647;d=b>>>31;do if(c>>>0>1100331075)if(c>>>0<=2139095040)if(!d)if(a>88.7216796875)e=a*1701411834604692317316873.0e14;else{g=.5;h=12}else e=-1.0;else e=a;else{if(c>>>0<=1051816472)if(c>>>0<855638016){e=a;break}else{i=a;j=0.0;k=0;h=15;break}b=(d|0)!=0;if(c>>>0>=1065686418){g=b?-.5:.5;h=12;break}if(b){l=-1;m=a+.6931381225585938;o=-9.05800061445916e-06;h=13;break}else{l=1;m=a+-.6931381225585938;o=9.05800061445916e-06;h=13;break}}while(0);if((h|0)==12){c=~~(a*1.4426950216293335+g);g=+(c|0);l=c;m=a-g*.6931381225585938;o=g*9.05800061445916e-06;h=13}if((h|0)==13){g=m-o;i=g;j=m-g-o;k=l;h=15}a:do if((h|0)==15){o=i*.5;g=i*o;m=g*(g*1.5807170420885086e-03+-.03333321213722229)+1.0;a=3.0-o*m;o=g*((m-a)/(6.0-i*a));if(!k){e=i-(i*o-g);break}a=i*(o-j)-j-g;switch(k|0){case -1:{e=(i-a)*.5+-.5;break a;break}case 1:{if(i<-.25){e=(a-(i+.5))*-2.0;break a}else{e=(i-a)*2.0+1.0;break a}break}default:{g=(f[s>>2]=(k<<23)+1065353216,+n[s>>2]);if(k>>>0>56){o=i-a+1.0;e=((k|0)==128?o*2.0*1701411834604692317316873.0e14:g*o)+-1.0;break a}else{l=(k|0)<23;o=(f[s>>2]=127-k<<23,+n[s>>2]);e=g*((l?1.0-o:1.0)+(i-(l?a:o+a)));break a}}}}while(0);return +e}function qLc(){return 185288}function rLc(){return 185292}function sLc(){var a=0;a=(tLc()|0)+188|0;return (f[f[a>>2]>>2]|0?4:1)|0}function tLc(){return xIc()|0}function uLc(){return 186832}function vLc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;b=(n[s>>2]=a,f[s>>2]|0);if((b&2130706432)>>>0<=1249902592){c=(b|0)<0;d=(c?8388608.0:-8388608.0)+((c?-8388608.0:8388608.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function wLc(a){a=+a;var b=0,c=0,d=0,e=0.0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,t=0.0;p[s>>3]=a;b=f[s>>2]|0;c=f[s+4>>2]|0;d=(c|0)<0;do if(d|c>>>0<1048576){if((b|0)==0&(c&2147483647|0)==0){e=-1.0/(a*a);break}if(d){e=(a-a)/0.0;break}else{p[s>>3]=a*18014398509481984.0;g=f[s+4>>2]|0;h=-1077;i=g;j=f[s>>2]|0;k=g;l=9;break}}else if(c>>>0<=2146435071)if((b|0)==0&0==0&(c|0)==1072693248)e=0.0;else{h=-1023;i=c;j=b;k=c;l=9}else e=a;while(0);if((l|0)==9){l=i+614242|0;f[s>>2]=j;f[s+4>>2]=(l&1048575)+1072079006;a=+p[s>>3]+-1.0;m=a*(a*.5);n=a/(a+2.0);o=n*n;q=o*o;p[s>>3]=a-m;j=f[s+4>>2]|0;f[s>>2]=0;f[s+4>>2]=j;r=+p[s>>3];t=a-r-m+n*(m+(q*(q*(q*.15313837699209373+.22222198432149784)+.3999999999940942)+o*(q*(q*(q*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));q=r*.4342944818781689;o=+(h+(l>>>20)|0);m=o*.30102999566361177;n=m+q;e=n+(q+(m-n)+(t*.4342944818781689+(o*3.694239077158931e-13+(r+t)*2.5082946711645275e-11)))}return +e}function xLc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2147483647;f[s>>2]=f[s>>2];f[s+4>>2]=c;a=+p[s>>3];do if(c>>>0>1071748074)if(c>>>0>1077149696){d=1.0-0.0/a;break}else{d=1.0-2.0/(+nLc(a*2.0)+2.0);break}else{if(c>>>0>1070618798){e=+nLc(a*2.0);d=e/(e+2.0);break}if(c>>>0>1048575){e=+nLc(a*-2.0);d=-e/(e+2.0)}else d=a}while(0);return +((b|0)<0?-d:d)}function yLc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){c=(b|0)<0;d=(c?4503599627370496.0:-4503599627370496.0)+((c?-4503599627370496.0:4503599627370496.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function zLc(a){a=+a;var b=0,c=0.0;b=JIc(32)|0;c=+yLc(a);return ~~c|0}function ALc(a){a=+a;return ~~+vLc(a)|0}function BLc(a,b){a=+a;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;e=l1c(c|0,d|0,52)|0;g=e&2047;e=g+-1023|0;if((e|0)>51){p[b>>3]=a;f[s>>2]=0;f[s+4>>2]=d&-2147483648;return +((c|0)==0&(d&1048575|0)==0|(e|0)!=1024?+p[s>>3]:a)}do if(g>>>0>=1023){h=l1c(-1,1048575,e|0)|0;i=J;if((h&c|0)==0&(i&d|0)==0){p[b>>3]=a;f[s>>2]=0;f[s+4>>2]=d&-2147483648;j=+p[s>>3];break}else{k=c&~h;h=d&~i;f[s>>2]=k;f[s+4>>2]=h;l=+p[s>>3];i=b;f[i>>2]=k;f[i+4>>2]=h;j=a-l;break}}else{h=b;f[h>>2]=0;f[h+4>>2]=d&-2147483648;j=a}while(0);return +j}function CLc(a){a=+a;var b=0,c=0,d=0.0,e=0.0;b=(n[s>>2]=a,f[s>>2]|0);c=b&2147483647;a=(f[s>>2]=c,+n[s>>2]);do if(c>>>0>1057791828)if(c>>>0>1092616192){d=0.0/a+1.0;break}else{d=1.0-2.0/(+pLc(a*2.0)+2.0);break}else{if(c>>>0>1048757624){e=+pLc(a*2.0);d=e/(e+2.0);break}if(c>>>0>8388607){e=+pLc(a*-2.0);d=-e/(e+2.0)}else d=a}while(0);return +((b|0)<0?-d:d)}function DLc(a,b,c){a=a|0;b=b|0;c=c|0;return ZJc(0,a,b,c|0?c:895036)|0}function ELc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;a:do if(!a){h=f[c>>2]|0;i=f[h>>2]|0;if(!i)j=0;else{k=h;h=0;l=i;while(1){if(l>>>0>127){i=HJc(g,l,0)|0;if((i|0)==-1){j=-1;break a}else m=i}else m=1;i=m+h|0;k=k+4|0;l=f[k>>2]|0;if(!l){j=i;break}else h=i}}}else{b:do if(d>>>0>3){h=a;l=d;k=f[c>>2]|0;while(1){i=f[k>>2]|0;if((i+-1|0)>>>0>126){if(!i)break;n=HJc(h,i,0)|0;if((n|0)==-1){j=-1;break a}o=h+n|0;p=l-n|0;q=k}else{b[h>>0]=i;o=h+1|0;p=l+-1|0;q=f[c>>2]|0}k=q+4|0;f[c>>2]=k;if(p>>>0<=3){r=o;s=p;break b}else{h=o;l=p}}b[h>>0]=0;f[c>>2]=0;j=d-l|0;break a}else{r=a;s=d}while(0);if(s){k=r;i=s;n=f[c>>2]|0;while(1){t=f[n>>2]|0;if((t+-1|0)>>>0>126){if(!t){v=19;break}w=HJc(g,t,0)|0;if((w|0)==-1){j=-1;break a}if(i>>>0<w>>>0){v=22;break}HJc(k,f[n>>2]|0,0)|0;x=k+w|0;y=i-w|0;z=n}else{b[k>>0]=t;x=k+1|0;y=i+-1|0;z=f[c>>2]|0}n=z+4|0;f[c>>2]=n;if(!y){j=d;break a}else{k=x;i=y}}if((v|0)==19){b[k>>0]=0;f[c>>2]=0;j=d-i|0;break}else if((v|0)==22){j=d-i|0;break}}else j=d}while(0);u=e;return j|0}function FLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+272|0;g=e+8|0;h=e;i=f[b>>2]|0;f[h>>2]=i;j=(a|0)!=0;k=j?d:256;d=j?a:g;a=i;a:do if((k|0)!=0&(i|0)!=0){l=0;m=c;n=k;o=d;p=a;while(1){q=m>>>0>=n>>>0;if(!(q|m>>>0>32)){r=o;s=l;t=m;v=n;w=p;break a}x=q?n:m;y=m-x|0;q=ELc(o,h,x,0)|0;if((q|0)==-1)break;x=(o|0)==(g|0);z=n-(x?0:q)|0;A=x?o:o+q|0;x=q+l|0;q=f[h>>2]|0;if((z|0)!=0&(q|0)!=0){l=x;m=y;n=z;o=A;p=q}else{r=A;s=x;t=y;v=z;w=q;break a}}r=o;s=-1;t=y;v=0;w=f[h>>2]|0}else{r=d;s=0;t=c;v=k;w=a}while(0);b:do if((w|0)!=0?(v|0)!=0&(t|0)!=0:0){a=s;k=t;c=r;d=v;y=w;while(1){B=HJc(c,f[y>>2]|0,0)|0;if((B+1|0)>>>0<2)break;y=(f[h>>2]|0)+4|0;f[h>>2]=y;k=k+-1|0;d=d-B|0;g=B+a|0;if(!((d|0)!=0&(k|0)!=0)){C=g;break b}else{a=g;c=c+B|0}}if(!B){f[h>>2]=0;C=a}else C=-1}else C=s;while(0);if(j)f[b>>2]=f[h>>2];u=e;return C|0}function GLc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+1040|0;h=g+8|0;i=g;j=f[b>>2]|0;f[i>>2]=j;k=(a|0)!=0;l=k?d:256;d=k?a:h;a=j;a:do if((l|0)!=0&(j|0)!=0){m=0;n=c;o=l;p=d;q=a;while(1){r=n>>>2;s=r>>>0>=o>>>0;if(!(n>>>0>131|s)){t=p;v=m;w=n;x=o;y=q;break a}z=s?o:r;A=n-z|0;r=lLc(p,i,z,e)|0;if((r|0)==-1)break;z=(p|0)==(h|0);s=o-(z?0:r)|0;B=z?p:p+(r<<2)|0;z=r+m|0;r=f[i>>2]|0;if((s|0)!=0&(r|0)!=0){m=z;n=A;o=s;p=B;q=r}else{t=B;v=z;w=A;x=s;y=r;break a}}t=p;v=-1;w=A;x=0;y=f[i>>2]|0}else{t=d;v=0;w=c;x=l;y=a}while(0);b:do if((y|0)!=0?(x|0)!=0&(w|0)!=0:0){a=v;l=w;c=t;d=x;A=y;while(1){C=ZJc(c,A,l,e)|0;if((C+2|0)>>>0<3)break;A=(f[i>>2]|0)+C|0;f[i>>2]=A;l=l-C|0;d=d+-1|0;h=a+1|0;if(!((d|0)!=0&(l|0)!=0)){D=h;break b}else{a=h;c=c+4|0}}switch(C|0){case -1:{D=-1;break b;break}case 0:{f[i>>2]=0;D=a;break b;break}default:{f[e>>2]=0;D=a;break b}}}else D=v;while(0);if(k)f[b>>2]=f[i>>2];u=g;return D|0}function HLc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=pJc(0,0,b,e)|0;if((g|0)>=0?(e=g+1|0,g=jIc(e)|0,f[a>>2]=g,(g|0)!=0):0)h=pJc(g,e,b,c)|0;else h=-1;u=d;return h|0}function ILc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a&255;e=a&255;if((f[c+76>>2]|0)>=0?(sJc(c)|0)!=0:0){if((e|0)!=(b[c+75>>0]|0)?(g=c+20|0,h=f[g>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[g>>2]=h+1;b[h>>0]=d;i=e}else i=hKc(c,a)|0;tJc(c);j=i}else k=3;do if((k|0)==3){if((e|0)!=(b[c+75>>0]|0)?(i=c+20|0,h=f[i>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[i>>2]=h+1;b[h>>0]=d;j=e;break}j=hKc(c,a)|0}while(0);return j|0}function JLc(a){a=a|0;var b=0,c=0,d=0;if(!(f[a>>2]&128))b=1;else b=(f[a+20>>2]|0)>>>0>(f[a+28>>2]|0)>>>0?2:1;c=hj[f[a+40>>2]&511](a,0,b)|0;if((c|0)<0)d=c;else d=c-(f[a+8>>2]|0)+(f[a+4>>2]|0)+(f[a+20>>2]|0)-(f[a+28>>2]|0)|0;return d|0}function KLc(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(sJc(a)|0)==0;c=JLc(a)|0;if(b)d=c;else{tJc(a);d=c}}else d=JLc(a)|0;return d|0}function LLc(a){a=a|0;return KLc(a)|0}function MLc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(sJc(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=XIc(a)|0;tJc(a);e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=XIc(a)|0;break}}while(0);return e|0}function NLc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=Y(d,c)|0;h=(c|0)==0?0:d;if((f[e+76>>2]|0)>-1)i=sJc(e)|0;else i=0;d=e+74|0;j=b[d>>0]|0;b[d>>0]=j+255|j;j=e+4|0;d=f[j>>2]|0;k=(f[e+8>>2]|0)-d|0;l=k>>>0<g>>>0?k:g;if((k|0)>0){o1c(a|0,d|0,l|0)|0;f[j>>2]=d+l;m=g-l|0;n=a+l|0}else{m=g;n=a}a:do if(!m)o=13;else{a=e+32|0;l=m;d=n;while(1){if(YIc(e)|0)break;j=hj[f[a>>2]&511](e,d,l)|0;if((j+1|0)>>>0<2)break;k=l-j|0;if(!k){o=13;break a}else{l=k;d=d+j|0}}if(i|0)tJc(e);p=((g-l|0)>>>0)/(c>>>0)|0}while(0);if((o|0)==13)if(!i)p=h;else{tJc(e);p=h}return p|0}function OLc(a){a=a|0;var b=0;if((f[a+76>>2]|0)>-1){b=(sJc(a)|0)==0;QKc(a,0,0)|0;f[a>>2]=f[a>>2]&-33;if(!b)tJc(a)}else{QKc(a,0,0)|0;f[a>>2]=f[a>>2]&-33}return}function PLc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;do if((a|0)!=-1){if((f[c+76>>2]|0)>-1)d=sJc(c)|0;else d=0;e=c+4|0;g=f[e>>2]|0;if(!g){YIc(c)|0;h=f[e>>2]|0;i=(d|0)!=0;if(!h)j=i;else{k=h;l=i;m=7}}else{k=g;l=(d|0)!=0;m=7}if((m|0)==7)if(k>>>0>((f[c+44>>2]|0)+-8|0)>>>0){g=k+-1|0;f[e>>2]=g;b[g>>0]=a;f[c>>2]=f[c>>2]&-17;if(!l){n=a;break}tJc(c);n=a;break}else j=l;if(j){tJc(c);n=-1}else n=-1}else n=-1;while(0);return n|0}function QLc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=c;a:while(1){c=a;f=a+-1|0;g=e;while(1){h=g;b:while(1){i=h;j=c-i|0;k=h+1|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((j|0)<31){l=11;break a}m=h+(j>>>1)|0;if((j|0)>999){n=j>>>2;o=TLc(h,h+n|0,m,m+n|0,f,d)|0}else o=RLc(h,m,f,d)|0;p=b[h>>0]|0;n=b[m>>0]|0;if(p<<24>>24<n<<24>>24){q=f;r=o;break}else s=f;while(1){s=s+-1|0;if((h|0)==(s|0))break;t=b[s>>0]|0;if(t<<24>>24<n<<24>>24){l=28;break b}}n=b[f>>0]|0;if(p<<24>>24<n<<24>>24)u=k;else{j=k;while(1){if((j|0)==(f|0))break a;v=b[j>>0]|0;w=j+1|0;if(p<<24>>24<v<<24>>24)break;else j=w}b[j>>0]=n;b[f>>0]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=b[h>>0]|0;A=y;while(1){B=b[A>>0]|0;C=A+1|0;if(z<<24>>24<B<<24>>24){D=x;break}else A=C}do{D=D+-1|0;E=b[D>>0]|0}while(z<<24>>24<E<<24>>24);if(A>>>0>=D>>>0){h=A;continue b}b[A>>0]=E;b[D>>0]=B;x=D;y=C}}if((l|0)==28){l=0;b[h>>0]=t;b[s>>0]=p;q=s;r=o+1|0}c:do if(k>>>0<q>>>0){n=m;j=q;z=k;F=r;while(1){G=b[n>>0]|0;H=z;while(1){I=b[H>>0]|0;J=H+1|0;if(I<<24>>24<G<<24>>24)H=J;else{K=j;break}}do{K=K+-1|0;L=b[K>>0]|0}while(L<<24>>24>=G<<24>>24);if(H>>>0>K>>>0){M=n;N=F;O=H;break c}b[H>>0]=L;b[K>>0]=I;n=(n|0)==(H|0)?K:n;j=K;z=J;F=F+1|0}}else{M=m;N=r;O=k}while(0);if((O|0)!=(M|0)?(F=b[M>>0]|0,z=b[O>>0]|0,F<<24>>24<z<<24>>24):0){b[O>>0]=F;b[M>>0]=z;P=N+1|0}else P=N;if(!P){Q=VLc(h,O,d)|0;z=O+1|0;if(VLc(z,a,d)|0){l=45;break}if(Q){g=z;continue}else R=z}else R=O+1|0;z=O;if((z-i|0)>=(c-z|0)){l=44;break}QLc(h,O,d);g=R}if((l|0)==44){l=0;QLc(R,a,d);e=h;a=O;continue}else if((l|0)==45){l=0;if(Q)break;else{e=h;a=O;continue}}}if((l|0)==5){O=b[f>>0]|0;e=b[h>>0]|0;if(O<<24>>24<e<<24>>24){b[h>>0]=O;b[f>>0]=e}}else if((l|0)==7)RLc(h,k,f,d)|0;else if((l|0)==8)SLc(h,k,h+2|0,f,d)|0;else if((l|0)==9)TLc(h,k,h+2|0,h+3|0,f,d)|0;else if((l|0)==11)ULc(h,a,d);return}function RLc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=b[c>>0]|0;f=b[a>>0]|0;g=b[d>>0]|0;h=g<<24>>24<e<<24>>24;do if(e<<24>>24<f<<24>>24){if(h){b[a>>0]=g;b[d>>0]=f;i=1;break}b[a>>0]=e;b[c>>0]=f;j=b[d>>0]|0;if(j<<24>>24<f<<24>>24){b[c>>0]=j;b[d>>0]=f;i=2}else i=1}else if(h){b[c>>0]=g;b[d>>0]=e;j=b[c>>0]|0;k=b[a>>0]|0;if(j<<24>>24<k<<24>>24){b[a>>0]=j;b[c>>0]=k;i=2}else i=1}else i=0;while(0);return i|0}function SLc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=RLc(a,c,d,f)|0;f=b[e>>0]|0;h=b[d>>0]|0;if(f<<24>>24<h<<24>>24){b[d>>0]=f;b[e>>0]=h;h=g+1|0;e=b[d>>0]|0;f=b[c>>0]|0;if(e<<24>>24<f<<24>>24){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if(f<<24>>24<d<<24>>24){b[a>>0]=f;b[c>>0]=d;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function TLc(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=SLc(a,c,d,e,g)|0;g=b[f>>0]|0;i=b[e>>0]|0;if(g<<24>>24<i<<24>>24){b[e>>0]=g;b[f>>0]=i;i=h+1|0;f=b[e>>0]|0;g=b[d>>0]|0;if(f<<24>>24<g<<24>>24){b[d>>0]=f;b[e>>0]=g;g=h+2|0;e=b[d>>0]|0;f=b[c>>0]|0;if(e<<24>>24<f<<24>>24){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if(f<<24>>24<d<<24>>24){b[a>>0]=f;b[c>>0]=d;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function ULc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+2|0;RLc(a,a+1|0,e,d)|0;d=a+3|0;f=e;while(1){if((d|0)==(c|0))break;e=b[d>>0]|0;g=b[f>>0]|0;if(e<<24>>24<g<<24>>24){h=f;i=d;j=g;while(1){b[i>>0]=j;if((h|0)==(a|0)){k=a;break}g=h+-1|0;j=b[g>>0]|0;if(e<<24>>24>=j<<24>>24){k=h;break}else{l=h;h=g;i=l}}b[k>>0]=e}i=d;d=d+1|0;f=i}return}function VLc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+2|0;f=c+-1|0;g=a+1|0;switch(c-a|0){case 1:case 0:{h=1;break}case 2:{i=b[f>>0]|0;j=b[a>>0]|0;if(i<<24>>24<j<<24>>24){b[a>>0]=i;b[f>>0]=j;h=1}else h=1;break}case 3:{RLc(a,g,f,d)|0;h=1;break}case 4:{SLc(a,g,e,f,d)|0;h=1;break}case 5:{TLc(a,g,e,a+3|0,f,d)|0;h=1;break}default:{RLc(a,g,e,d)|0;d=a+3|0;g=0;f=e;while(1){if((d|0)==(c|0)){k=1;l=0;break}e=b[d>>0]|0;j=b[f>>0]|0;if(e<<24>>24<j<<24>>24){i=f;m=d;n=j;while(1){b[m>>0]=n;if((i|0)==(a|0)){o=a;break}j=i+-1|0;n=b[j>>0]|0;if(e<<24>>24>=n<<24>>24){o=i;break}else{p=i;i=j;m=p}}b[o>>0]=e;m=g+1|0;if((m|0)==8){k=0;l=(d+1|0)==(c|0);break}else q=m}else q=g;m=d;d=d+1|0;g=q;f=m}h=l|k}}return h|0}function WLc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=c;a:while(1){c=a;f=a+-1|0;g=e;while(1){h=g;b:while(1){i=h;j=c-i|0;k=h+1|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((j|0)<31){l=11;break a}m=h+(j>>>1)|0;if((j|0)>999){n=j>>>2;o=ZLc(h,h+n|0,m,m+n|0,f,d)|0}else o=XLc(h,m,f,d)|0;p=b[h>>0]|0;n=b[m>>0]|0;if((p&255)<(n&255)){q=f;r=o;break}else s=f;while(1){s=s+-1|0;if((h|0)==(s|0))break;t=b[s>>0]|0;if((t&255)<(n&255)){l=28;break b}}n=b[f>>0]|0;if((p&255)<(n&255))u=k;else{j=k;while(1){if((j|0)==(f|0))break a;v=b[j>>0]|0;w=j+1|0;if((p&255)<(v&255))break;else j=w}b[j>>0]=n;b[f>>0]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=b[h>>0]|0;A=y;while(1){B=b[A>>0]|0;C=A+1|0;if((z&255)<(B&255)){D=x;break}else A=C}do{D=D+-1|0;E=b[D>>0]|0}while((z&255)<(E&255));if(A>>>0>=D>>>0){h=A;continue b}b[A>>0]=E;b[D>>0]=B;x=D;y=C}}if((l|0)==28){l=0;b[h>>0]=t;b[s>>0]=p;q=s;r=o+1|0}c:do if(k>>>0<q>>>0){n=m;j=q;z=k;F=r;while(1){G=b[n>>0]|0;H=z;while(1){I=b[H>>0]|0;J=H+1|0;if((I&255)<(G&255))H=J;else{K=j;break}}do{K=K+-1|0;L=b[K>>0]|0}while((L&255)>=(G&255));if(H>>>0>K>>>0){M=n;N=F;O=H;break c}b[H>>0]=L;b[K>>0]=I;n=(n|0)==(H|0)?K:n;j=K;z=J;F=F+1|0}}else{M=m;N=r;O=k}while(0);if((O|0)!=(M|0)?(F=b[M>>0]|0,z=b[O>>0]|0,(F&255)<(z&255)):0){b[O>>0]=F;b[M>>0]=z;P=N+1|0}else P=N;if(!P){Q=$Lc(h,O,d)|0;z=O+1|0;if($Lc(z,a,d)|0){l=45;break}if(Q){g=z;continue}else R=z}else R=O+1|0;z=O;if((z-i|0)>=(c-z|0)){l=44;break}WLc(h,O,d);g=R}if((l|0)==44){l=0;WLc(R,a,d);e=h;a=O;continue}else if((l|0)==45){l=0;if(Q)break;else{e=h;a=O;continue}}}if((l|0)==5){O=b[f>>0]|0;e=b[h>>0]|0;if((O&255)<(e&255)){b[h>>0]=O;b[f>>0]=e}}else if((l|0)==7)XLc(h,k,f,d)|0;else if((l|0)==8)YLc(h,k,h+2|0,f,d)|0;else if((l|0)==9)ZLc(h,k,h+2|0,h+3|0,f,d)|0;else if((l|0)==11)_Lc(h,a,d);return}function XLc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=b[c>>0]|0;f=b[a>>0]|0;g=b[d>>0]|0;h=(g&255)<(e&255);do if((e&255)<(f&255)){if(h){b[a>>0]=g;b[d>>0]=f;i=1;break}b[a>>0]=e;b[c>>0]=f;j=b[d>>0]|0;if((j&255)<(f&255)){b[c>>0]=j;b[d>>0]=f;i=2}else i=1}else if(h){b[c>>0]=g;b[d>>0]=e;j=b[c>>0]|0;k=b[a>>0]|0;if((j&255)<(k&255)){b[a>>0]=j;b[c>>0]=k;i=2}else i=1}else i=0;while(0);return i|0}function YLc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=XLc(a,c,d,f)|0;f=b[e>>0]|0;h=b[d>>0]|0;if((f&255)<(h&255)){b[d>>0]=f;b[e>>0]=h;h=g+1|0;e=b[d>>0]|0;f=b[c>>0]|0;if((e&255)<(f&255)){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if((f&255)<(d&255)){b[a>>0]=f;b[c>>0]=d;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function ZLc(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=YLc(a,c,d,e,g)|0;g=b[f>>0]|0;i=b[e>>0]|0;if((g&255)<(i&255)){b[e>>0]=g;b[f>>0]=i;i=h+1|0;f=b[e>>0]|0;g=b[d>>0]|0;if((f&255)<(g&255)){b[d>>0]=f;b[e>>0]=g;g=h+2|0;e=b[d>>0]|0;f=b[c>>0]|0;if((e&255)<(f&255)){b[c>>0]=e;b[d>>0]=f;f=b[c>>0]|0;d=b[a>>0]|0;if((f&255)<(d&255)){b[a>>0]=f;b[c>>0]=d;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function _Lc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+2|0;XLc(a,a+1|0,e,d)|0;d=a+3|0;f=e;while(1){if((d|0)==(c|0))break;e=b[d>>0]|0;g=b[f>>0]|0;if((e&255)<(g&255)){h=f;i=d;j=g;while(1){b[i>>0]=j;if((h|0)==(a|0)){k=a;break}g=h+-1|0;j=b[g>>0]|0;if((e&255)>=(j&255)){k=h;break}else{l=h;h=g;i=l}}b[k>>0]=e}i=d;d=d+1|0;f=i}return}function $Lc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+2|0;f=c+-1|0;g=a+1|0;switch(c-a|0){case 1:case 0:{h=1;break}case 2:{i=b[f>>0]|0;j=b[a>>0]|0;if((i&255)<(j&255)){b[a>>0]=i;b[f>>0]=j;h=1}else h=1;break}case 3:{XLc(a,g,f,d)|0;h=1;break}case 4:{YLc(a,g,e,f,d)|0;h=1;break}case 5:{ZLc(a,g,e,a+3|0,f,d)|0;h=1;break}default:{XLc(a,g,e,d)|0;d=a+3|0;g=0;f=e;while(1){if((d|0)==(c|0)){k=1;l=0;break}e=b[d>>0]|0;j=b[f>>0]|0;if((e&255)<(j&255)){i=f;m=d;n=j;while(1){b[m>>0]=n;if((i|0)==(a|0)){o=a;break}j=i+-1|0;n=b[j>>0]|0;if((e&255)>=(n&255)){o=i;break}else{p=i;i=j;m=p}}b[o>>0]=e;m=g+1|0;if((m|0)==8){k=0;l=(d+1|0)==(c|0);break}else q=m}else q=g;m=d;d=d+1|0;g=q;f=m}h=l|k}}return h|0}function aMc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=b;a:while(1){b=a;f=a+-2|0;g=e;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>1;l=h+2|0;switch(k|0){case 1:case 0:{break a;break}case 2:{m=5;break a;break}case 3:{m=7;break a;break}case 4:{m=8;break a;break}case 5:{m=9;break a;break}default:{}}if((j|0)<62){m=11;break a}n=h+(((k|0)/2|0)<<1)|0;if((j|0)>1998){j=(k|0)/4|0;o=dMc(h,h+(j<<1)|0,n,n+(j<<1)|0,f,c)|0}else o=bMc(h,n,f,c)|0;p=d[h>>1]|0;j=d[n>>1]|0;if(p<<16>>16<j<<16>>16){q=f;r=o;break}else s=f;while(1){s=s+-2|0;if((h|0)==(s|0))break;t=d[s>>1]|0;if(t<<16>>16<j<<16>>16){m=28;break b}}j=d[f>>1]|0;if(p<<16>>16<j<<16>>16)u=l;else{k=l;while(1){if((k|0)==(f|0))break a;v=d[k>>1]|0;w=k+2|0;if(p<<16>>16<v<<16>>16)break;else k=w}d[k>>1]=j;d[f>>1]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=d[h>>1]|0;A=y;while(1){B=d[A>>1]|0;C=A+2|0;if(z<<16>>16<B<<16>>16){D=x;break}else A=C}do{D=D+-2|0;E=d[D>>1]|0}while(z<<16>>16<E<<16>>16);if(A>>>0>=D>>>0){h=A;continue b}d[A>>1]=E;d[D>>1]=B;x=D;y=C}}if((m|0)==28){m=0;d[h>>1]=t;d[s>>1]=p;q=s;r=o+1|0}c:do if(l>>>0<q>>>0){j=n;k=q;z=l;F=r;while(1){G=d[j>>1]|0;H=z;while(1){I=d[H>>1]|0;J=H+2|0;if(I<<16>>16<G<<16>>16)H=J;else{K=k;break}}do{K=K+-2|0;L=d[K>>1]|0}while(L<<16>>16>=G<<16>>16);if(H>>>0>K>>>0){M=j;N=F;O=H;break c}d[H>>1]=L;d[K>>1]=I;j=(j|0)==(H|0)?K:j;k=K;z=J;F=F+1|0}}else{M=n;N=r;O=l}while(0);if((O|0)!=(M|0)?(F=d[M>>1]|0,z=d[O>>1]|0,F<<16>>16<z<<16>>16):0){d[O>>1]=F;d[M>>1]=z;P=N+1|0}else P=N;if(!P){Q=fMc(h,O,c)|0;z=O+2|0;if(fMc(z,a,c)|0){m=45;break}if(Q){g=z;continue}else R=z}else R=O+2|0;z=O;if((z-i|0)>=(b-z|0)){m=44;break}aMc(h,O,c);g=R}if((m|0)==44){m=0;aMc(R,a,c);e=h;a=O;continue}else if((m|0)==45){m=0;if(Q)break;else{e=h;a=O;continue}}}if((m|0)==5){O=d[f>>1]|0;e=d[h>>1]|0;if(O<<16>>16<e<<16>>16){d[h>>1]=O;d[f>>1]=e}}else if((m|0)==7)bMc(h,l,f,c)|0;else if((m|0)==8)cMc(h,l,h+4|0,f,c)|0;else if((m|0)==9)dMc(h,l,h+4|0,h+6|0,f,c)|0;else if((m|0)==11)eMc(h,a,c);return}function bMc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=d[b>>1]|0;f=d[a>>1]|0;g=d[c>>1]|0;h=g<<16>>16<e<<16>>16;do if(e<<16>>16<f<<16>>16){if(h){d[a>>1]=g;d[c>>1]=f;i=1;break}d[a>>1]=e;d[b>>1]=f;j=d[c>>1]|0;if(j<<16>>16<f<<16>>16){d[b>>1]=j;d[c>>1]=f;i=2}else i=1}else if(h){d[b>>1]=g;d[c>>1]=e;j=d[b>>1]|0;k=d[a>>1]|0;if(j<<16>>16<k<<16>>16){d[a>>1]=j;d[b>>1]=k;i=2}else i=1}else i=0;while(0);return i|0}function cMc(a,b,c,e,f){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=bMc(a,b,c,f)|0;f=d[e>>1]|0;h=d[c>>1]|0;if(f<<16>>16<h<<16>>16){d[c>>1]=f;d[e>>1]=h;h=g+1|0;e=d[c>>1]|0;f=d[b>>1]|0;if(e<<16>>16<f<<16>>16){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if(f<<16>>16<c<<16>>16){d[a>>1]=f;d[b>>1]=c;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function dMc(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=cMc(a,b,c,e,g)|0;g=d[f>>1]|0;i=d[e>>1]|0;if(g<<16>>16<i<<16>>16){d[e>>1]=g;d[f>>1]=i;i=h+1|0;f=d[e>>1]|0;g=d[c>>1]|0;if(f<<16>>16<g<<16>>16){d[c>>1]=f;d[e>>1]=g;g=h+2|0;e=d[c>>1]|0;f=d[b>>1]|0;if(e<<16>>16<f<<16>>16){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if(f<<16>>16<c<<16>>16){d[a>>1]=f;d[b>>1]=c;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function eMc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;bMc(a,a+2|0,e,c)|0;c=a+6|0;f=e;while(1){if((c|0)==(b|0))break;e=d[c>>1]|0;g=d[f>>1]|0;if(e<<16>>16<g<<16>>16){h=f;i=c;j=g;while(1){d[i>>1]=j;if((h|0)==(a|0)){k=a;break}g=h+-2|0;j=d[g>>1]|0;if(e<<16>>16>=j<<16>>16){k=h;break}else{l=h;h=g;i=l}}d[k>>1]=e}i=c;c=c+2|0;f=i}return}function fMc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+4|0;f=a+2|0;g=b+-2|0;switch(b-a>>1|0){case 1:case 0:{h=1;break}case 2:{i=d[g>>1]|0;j=d[a>>1]|0;if(i<<16>>16<j<<16>>16){d[a>>1]=i;d[g>>1]=j;h=1}else h=1;break}case 3:{bMc(a,f,g,c)|0;h=1;break}case 4:{cMc(a,f,e,g,c)|0;h=1;break}case 5:{dMc(a,f,e,a+6|0,g,c)|0;h=1;break}default:{bMc(a,f,e,c)|0;c=a+6|0;f=0;g=e;while(1){if((c|0)==(b|0)){k=1;l=0;break}e=d[c>>1]|0;j=d[g>>1]|0;if(e<<16>>16<j<<16>>16){i=g;m=c;n=j;while(1){d[m>>1]=n;if((i|0)==(a|0)){o=a;break}j=i+-2|0;n=d[j>>1]|0;if(e<<16>>16>=n<<16>>16){o=i;break}else{p=i;i=j;m=p}}d[o>>1]=e;m=f+1|0;if((m|0)==8){k=0;l=(c+2|0)==(b|0);break}else q=m}else q=f;m=c;c=c+2|0;f=q;g=m}h=l|k}}return h|0}function gMc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=a;a=b;a:while(1){b=a;f=a+-2|0;g=e;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>1;l=h+2|0;switch(k|0){case 1:case 0:{break a;break}case 2:{m=5;break a;break}case 3:{m=7;break a;break}case 4:{m=8;break a;break}case 5:{m=9;break a;break}default:{}}if((j|0)<62){m=11;break a}n=h+(((k|0)/2|0)<<1)|0;if((j|0)>1998){j=(k|0)/4|0;o=jMc(h,h+(j<<1)|0,n,n+(j<<1)|0,f,c)|0}else o=hMc(h,n,f,c)|0;p=d[h>>1]|0;j=d[n>>1]|0;if((p&65535)<(j&65535)){q=f;r=o;break}else s=f;while(1){s=s+-2|0;if((h|0)==(s|0))break;t=d[s>>1]|0;if((t&65535)<(j&65535)){m=28;break b}}j=d[f>>1]|0;if((p&65535)<(j&65535))u=l;else{k=l;while(1){if((k|0)==(f|0))break a;v=d[k>>1]|0;w=k+2|0;if((p&65535)<(v&65535))break;else k=w}d[k>>1]=j;d[f>>1]=v;u=w}if((u|0)==(f|0))break a;else{x=f;y=u}while(1){z=d[h>>1]|0;A=y;while(1){B=d[A>>1]|0;C=A+2|0;if((z&65535)<(B&65535)){D=x;break}else A=C}do{D=D+-2|0;E=d[D>>1]|0}while((z&65535)<(E&65535));if(A>>>0>=D>>>0){h=A;continue b}d[A>>1]=E;d[D>>1]=B;x=D;y=C}}if((m|0)==28){m=0;d[h>>1]=t;d[s>>1]=p;q=s;r=o+1|0}c:do if(l>>>0<q>>>0){j=n;k=q;z=l;F=r;while(1){G=d[j>>1]|0;H=z;while(1){I=d[H>>1]|0;J=H+2|0;if((I&65535)<(G&65535))H=J;else{K=k;break}}do{K=K+-2|0;L=d[K>>1]|0}while((L&65535)>=(G&65535));if(H>>>0>K>>>0){M=j;N=F;O=H;break c}d[H>>1]=L;d[K>>1]=I;j=(j|0)==(H|0)?K:j;k=K;z=J;F=F+1|0}}else{M=n;N=r;O=l}while(0);if((O|0)!=(M|0)?(F=d[M>>1]|0,z=d[O>>1]|0,(F&65535)<(z&65535)):0){d[O>>1]=F;d[M>>1]=z;P=N+1|0}else P=N;if(!P){Q=lMc(h,O,c)|0;z=O+2|0;if(lMc(z,a,c)|0){m=45;break}if(Q){g=z;continue}else R=z}else R=O+2|0;z=O;if((z-i|0)>=(b-z|0)){m=44;break}gMc(h,O,c);g=R}if((m|0)==44){m=0;gMc(R,a,c);e=h;a=O;continue}else if((m|0)==45){m=0;if(Q)break;else{e=h;a=O;continue}}}if((m|0)==5){O=d[f>>1]|0;e=d[h>>1]|0;if((O&65535)<(e&65535)){d[h>>1]=O;d[f>>1]=e}}else if((m|0)==7)hMc(h,l,f,c)|0;else if((m|0)==8)iMc(h,l,h+4|0,f,c)|0;else if((m|0)==9)jMc(h,l,h+4|0,h+6|0,f,c)|0;else if((m|0)==11)kMc(h,a,c);return}function hMc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=d[b>>1]|0;f=d[a>>1]|0;g=d[c>>1]|0;h=(g&65535)<(e&65535);do if((e&65535)<(f&65535)){if(h){d[a>>1]=g;d[c>>1]=f;i=1;break}d[a>>1]=e;d[b>>1]=f;j=d[c>>1]|0;if((j&65535)<(f&65535)){d[b>>1]=j;d[c>>1]=f;i=2}else i=1}else if(h){d[b>>1]=g;d[c>>1]=e;j=d[b>>1]|0;k=d[a>>1]|0;if((j&65535)<(k&65535)){d[a>>1]=j;d[b>>1]=k;i=2}else i=1}else i=0;while(0);return i|0}function iMc(a,b,c,e,f){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=hMc(a,b,c,f)|0;f=d[e>>1]|0;h=d[c>>1]|0;if((f&65535)<(h&65535)){d[c>>1]=f;d[e>>1]=h;h=g+1|0;e=d[c>>1]|0;f=d[b>>1]|0;if((e&65535)<(f&65535)){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if((f&65535)<(c&65535)){d[a>>1]=f;d[b>>1]=c;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function jMc(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=iMc(a,b,c,e,g)|0;g=d[f>>1]|0;i=d[e>>1]|0;if((g&65535)<(i&65535)){d[e>>1]=g;d[f>>1]=i;i=h+1|0;f=d[e>>1]|0;g=d[c>>1]|0;if((f&65535)<(g&65535)){d[c>>1]=f;d[e>>1]=g;g=h+2|0;e=d[c>>1]|0;f=d[b>>1]|0;if((e&65535)<(f&65535)){d[b>>1]=e;d[c>>1]=f;f=d[b>>1]|0;c=d[a>>1]|0;if((f&65535)<(c&65535)){d[a>>1]=f;d[b>>1]=c;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function kMc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;hMc(a,a+2|0,e,c)|0;c=a+6|0;f=e;while(1){if((c|0)==(b|0))break;e=d[c>>1]|0;g=d[f>>1]|0;if((e&65535)<(g&65535)){h=f;i=c;j=g;while(1){d[i>>1]=j;if((h|0)==(a|0)){k=a;break}g=h+-2|0;j=d[g>>1]|0;if((e&65535)>=(j&65535)){k=h;break}else{l=h;h=g;i=l}}d[k>>1]=e}i=c;c=c+2|0;f=i}return}function lMc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a+4|0;f=a+2|0;g=b+-2|0;switch(b-a>>1|0){case 1:case 0:{h=1;break}case 2:{i=d[g>>1]|0;j=d[a>>1]|0;if((i&65535)<(j&65535)){d[a>>1]=i;d[g>>1]=j;h=1}else h=1;break}case 3:{hMc(a,f,g,c)|0;h=1;break}case 4:{iMc(a,f,e,g,c)|0;h=1;break}case 5:{jMc(a,f,e,a+6|0,g,c)|0;h=1;break}default:{hMc(a,f,e,c)|0;c=a+6|0;f=0;g=e;while(1){if((c|0)==(b|0)){k=1;l=0;break}e=d[c>>1]|0;j=d[g>>1]|0;if((e&65535)<(j&65535)){i=g;m=c;n=j;while(1){d[m>>1]=n;if((i|0)==(a|0)){o=a;break}j=i+-2|0;n=d[j>>1]|0;if((e&65535)>=(n&65535)){o=i;break}else{p=i;i=j;m=p}}d[o>>1]=e;m=f+1|0;if((m|0)==8){k=0;l=(c+2|0)==(b|0);break}else q=m}else q=f;m=c;c=c+2|0;f=q;g=m}h=l|k}}return h|0}function mMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;l=h+4|0;switch(k|0){case 1:case 0:{break a;break}case 2:{m=5;break a;break}case 3:{m=7;break a;break}case 4:{m=8;break a;break}case 5:{m=9;break a;break}default:{}}if((j|0)<124){m=11;break a}n=h+(((k|0)/2|0)<<2)|0;if((j|0)>3996){j=(k|0)/4|0;o=pMc(h,h+(j<<2)|0,n,n+(j<<2)|0,e,c)|0}else o=nMc(h,n,e,c)|0;p=f[h>>2]|0;j=f[n>>2]|0;if((p|0)<(j|0)){q=e;r=o;break}else s=e;while(1){s=s+-4|0;if((h|0)==(s|0))break;t=f[s>>2]|0;if((t|0)<(j|0)){m=28;break b}}j=f[e>>2]|0;if((p|0)<(j|0))u=l;else{k=l;while(1){if((k|0)==(e|0))break a;v=f[k>>2]|0;w=k+4|0;if((p|0)<(v|0))break;else k=w}f[k>>2]=j;f[e>>2]=v;u=w}if((u|0)==(e|0))break a;else{x=e;y=u}while(1){z=f[h>>2]|0;A=y;while(1){B=f[A>>2]|0;C=A+4|0;if((z|0)<(B|0)){D=x;break}else A=C}do{D=D+-4|0;E=f[D>>2]|0}while((z|0)<(E|0));if(A>>>0>=D>>>0){h=A;continue b}f[A>>2]=E;f[D>>2]=B;x=D;y=C}}if((m|0)==28){m=0;f[h>>2]=t;f[s>>2]=p;q=s;r=o+1|0}c:do if(l>>>0<q>>>0){j=n;k=q;z=l;F=r;while(1){G=f[j>>2]|0;H=z;while(1){I=f[H>>2]|0;J=H+4|0;if((I|0)<(G|0))H=J;else{K=k;break}}do{K=K+-4|0;L=f[K>>2]|0}while((L|0)>=(G|0));if(H>>>0>K>>>0){M=j;N=F;O=H;break c}f[H>>2]=L;f[K>>2]=I;j=(j|0)==(H|0)?K:j;k=K;z=J;F=F+1|0}}else{M=n;N=r;O=l}while(0);if((O|0)!=(M|0)?(F=f[M>>2]|0,z=f[O>>2]|0,(F|0)<(z|0)):0){f[O>>2]=F;f[M>>2]=z;P=N+1|0}else P=N;if(!P){Q=rMc(h,O,c)|0;z=O+4|0;if(rMc(z,a,c)|0){m=45;break}if(Q){g=z;continue}else R=z}else R=O+4|0;z=O;if((z-i|0)>=(b-z|0)){m=44;break}mMc(h,O,c);g=R}if((m|0)==44){m=0;mMc(R,a,c);d=h;a=O;continue}else if((m|0)==45){m=0;if(Q)break;else{d=h;a=O;continue}}}if((m|0)==5){O=f[e>>2]|0;d=f[h>>2]|0;if((O|0)<(d|0)){f[h>>2]=O;f[e>>2]=d}}else if((m|0)==7)nMc(h,l,e,c)|0;else if((m|0)==8)oMc(h,l,h+8|0,e,c)|0;else if((m|0)==9)pMc(h,l,h+8|0,h+12|0,e,c)|0;else if((m|0)==11)qMc(h,a,c);return}function nMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;d=f[b>>2]|0;e=f[a>>2]|0;g=f[c>>2]|0;h=(g|0)<(d|0);do if((d|0)<(e|0)){if(h){f[a>>2]=g;f[c>>2]=e;i=1;break}f[a>>2]=d;f[b>>2]=e;j=f[c>>2]|0;if((j|0)<(e|0)){f[b>>2]=j;f[c>>2]=e;i=2}else i=1}else if(h){f[b>>2]=g;f[c>>2]=d;j=f[b>>2]|0;k=f[a>>2]|0;if((j|0)<(k|0)){f[a>>2]=j;f[b>>2]=k;i=2}else i=1}else i=0;while(0);return i|0}function oMc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=nMc(a,b,c,e)|0;e=f[d>>2]|0;h=f[c>>2]|0;if((e|0)<(h|0)){f[c>>2]=e;f[d>>2]=h;h=g+1|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)<(e|0)){f[b>>2]=d;f[c>>2]=e;e=f[b>>2]|0;c=f[a>>2]|0;if((e|0)<(c|0)){f[a>>2]=e;f[b>>2]=c;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function pMc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=oMc(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;if((g|0)<(i|0)){f[d>>2]=g;f[e>>2]=i;i=h+1|0;e=f[d>>2]|0;g=f[c>>2]|0;if((e|0)<(g|0)){f[c>>2]=e;f[d>>2]=g;g=h+2|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)<(e|0)){f[b>>2]=d;f[c>>2]=e;e=f[b>>2]|0;c=f[a>>2]|0;if((e|0)<(c|0)){f[a>>2]=e;f[b>>2]=c;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function qMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;nMc(a,a+4|0,d,c)|0;c=a+12|0;e=d;while(1){if((c|0)==(b|0))break;d=f[c>>2]|0;g=f[e>>2]|0;if((d|0)<(g|0)){h=e;i=c;j=g;while(1){f[i>>2]=j;if((h|0)==(a|0)){k=a;break}g=h+-4|0;j=f[g>>2]|0;if((d|0)>=(j|0)){k=h;break}else{l=h;h=g;i=l}}f[k>>2]=d}i=c;c=c+4|0;e=i}return}function rMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+4|0;e=b+-4|0;g=a+8|0;switch(b-a>>2|0){case 1:case 0:{h=1;break}case 2:{i=f[e>>2]|0;j=f[a>>2]|0;if((i|0)<(j|0)){f[a>>2]=i;f[e>>2]=j;h=1}else h=1;break}case 3:{nMc(a,d,e,c)|0;h=1;break}case 4:{oMc(a,d,g,e,c)|0;h=1;break}case 5:{pMc(a,d,g,a+12|0,e,c)|0;h=1;break}default:{nMc(a,d,g,c)|0;c=a+12|0;d=0;e=g;while(1){if((c|0)==(b|0)){k=1;l=0;break}g=f[c>>2]|0;j=f[e>>2]|0;if((g|0)<(j|0)){i=e;m=c;n=j;while(1){f[m>>2]=n;if((i|0)==(a|0)){o=a;break}j=i+-4|0;n=f[j>>2]|0;if((g|0)>=(n|0)){o=i;break}else{p=i;i=j;m=p}}f[o>>2]=g;m=d+1|0;if((m|0)==8){k=0;l=(c+4|0)==(b|0);break}else q=m}else q=d;m=c;c=c+4|0;d=q;e=m}h=l|k}}return h|0}function sMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;f=d;while(1){g=f;b:while(1){h=g;i=b-h|0;j=i>>2;k=g+4|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((i|0)<124){l=11;break a}m=g+(((j|0)/2|0)<<2)|0;if((i|0)>3996){i=(j|0)/4|0;o=vMc(g,g+(i<<2)|0,m,m+(i<<2)|0,e,c)|0}else o=tMc(g,m,e,c)|0;p=+n[g>>2];q=+n[m>>2];if(p<q){r=e;s=o;break}else t=e;while(1){t=t+-4|0;if((g|0)==(t|0))break;u=+n[t>>2];if(u<q){l=28;break b}}q=+n[e>>2];if(p<q)v=k;else{i=k;while(1){if((i|0)==(e|0))break a;w=+n[i>>2];x=i+4|0;if(p<w)break;else i=x}n[i>>2]=q;n[e>>2]=w;v=x}if((v|0)==(e|0))break a;else{y=e;z=v}while(1){A=+n[g>>2];j=z;while(1){B=+n[j>>2];C=j+4|0;if(A<B){D=y;break}else j=C}do{D=D+-4|0;E=+n[D>>2]}while(A<E);if(j>>>0>=D>>>0){g=j;continue b}n[j>>2]=E;n[D>>2]=B;y=D;z=C}}if((l|0)==28){l=0;n[g>>2]=u;n[t>>2]=p;r=t;s=o+1|0}c:do if(k>>>0<r>>>0){i=m;F=r;G=k;H=s;while(1){q=+n[i>>2];I=G;while(1){J=+n[I>>2];K=I+4|0;if(J<q)I=K;else{L=F;break}}do{L=L+-4|0;M=+n[L>>2]}while(!(M<q));if(I>>>0>L>>>0){N=i;O=H;P=I;break c}n[I>>2]=M;n[L>>2]=J;i=(i|0)==(I|0)?L:i;F=L;G=K;H=H+1|0}}else{N=m;O=s;P=k}while(0);if((P|0)!=(N|0)?(q=+n[N>>2],A=+n[P>>2],q<A):0){n[P>>2]=q;n[N>>2]=A;Q=O+1|0}else Q=O;if(!Q){R=xMc(g,P,c)|0;H=P+4|0;if(xMc(H,a,c)|0){l=45;break}if(R){f=H;continue}else S=H}else S=P+4|0;H=P;if((H-h|0)>=(b-H|0)){l=44;break}sMc(g,P,c);f=S}if((l|0)==44){l=0;sMc(S,a,c);d=g;a=P;continue}else if((l|0)==45){l=0;if(R)break;else{d=g;a=P;continue}}}if((l|0)==5){J=+n[e>>2];M=+n[g>>2];if(J<M){n[g>>2]=J;n[e>>2]=M}}else if((l|0)==7)tMc(g,k,e,c)|0;else if((l|0)==8)uMc(g,k,g+8|0,e,c)|0;else if((l|0)==9)vMc(g,k,g+8|0,g+12|0,e,c)|0;else if((l|0)==11)wMc(g,a,c);return}function tMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0,i=0.0,j=0.0;e=+n[b>>2];f=+n[a>>2];g=+n[c>>2];d=g<e;do if(e<f){if(d){n[a>>2]=g;n[c>>2]=f;h=1;break}n[a>>2]=e;n[b>>2]=f;i=+n[c>>2];if(i<f){n[b>>2]=i;n[c>>2]=f;h=2}else h=1}else if(d){n[b>>2]=g;n[c>>2]=e;i=+n[b>>2];j=+n[a>>2];if(i<j){n[a>>2]=i;n[b>>2]=j;h=2}else h=1}else h=0;while(0);return h|0}function uMc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0.0,i=0;f=tMc(a,b,c,e)|0;g=+n[d>>2];h=+n[c>>2];if(g<h){n[c>>2]=g;n[d>>2]=h;d=f+1|0;h=+n[c>>2];g=+n[b>>2];if(h<g){n[b>>2]=h;n[c>>2]=g;g=+n[b>>2];h=+n[a>>2];if(g<h){n[a>>2]=g;n[b>>2]=h;i=f+3|0}else i=f+2|0}else i=d}else i=f;return i|0}function vMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0;g=uMc(a,b,c,d,f)|0;h=+n[e>>2];i=+n[d>>2];if(h<i){n[d>>2]=h;n[e>>2]=i;e=g+1|0;i=+n[d>>2];h=+n[c>>2];if(i<h){n[c>>2]=i;n[d>>2]=h;d=g+2|0;h=+n[c>>2];i=+n[b>>2];if(h<i){n[b>>2]=h;n[c>>2]=i;i=+n[b>>2];h=+n[a>>2];if(i<h){n[a>>2]=i;n[b>>2]=h;j=g+4|0}else j=g+3|0}else j=d}else j=e}else j=g;return j|0}function wMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0;d=a+8|0;tMc(a,a+4|0,d,c)|0;c=a+12|0;e=d;while(1){if((c|0)==(b|0))break;g=+n[c>>2];if(g<+n[e>>2]){d=e;h=c;while(1){f[h>>2]=f[d>>2];if((d|0)==(a|0))break;i=d+-4|0;if(g<+n[i>>2]){j=d;d=i;h=j}else break}n[d>>2]=g}h=c;c=c+4|0;e=h}return}function xMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0;d=a+4|0;e=b+-4|0;g=a+8|0;switch(b-a>>2|0){case 1:case 0:{h=1;break}case 2:{i=+n[e>>2];j=+n[a>>2];if(i<j){n[a>>2]=i;n[e>>2]=j;h=1}else h=1;break}case 3:{tMc(a,d,e,c)|0;h=1;break}case 4:{uMc(a,d,g,e,c)|0;h=1;break}case 5:{vMc(a,d,g,a+12|0,e,c)|0;h=1;break}default:{tMc(a,d,g,c)|0;c=a+12|0;d=0;e=g;while(1){if((c|0)==(b|0)){k=1;l=0;break}j=+n[c>>2];if(j<+n[e>>2]){g=e;m=c;while(1){f[m>>2]=f[g>>2];if((g|0)==(a|0))break;o=g+-4|0;if(j<+n[o>>2]){p=g;g=o;m=p}else break}n[g>>2]=j;m=d+1|0;if((m|0)==8){k=0;l=(c+4|0)==(b|0);break}else q=m}else q=d;m=c;c=c+4|0;d=q;e=m}h=l|k}}return h|0}function yMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0;d=a;a=b;a:while(1){b=a;e=a+-8|0;f=d;while(1){g=f;b:while(1){h=g;i=b-h|0;j=i>>3;k=g+8|0;switch(j|0){case 1:case 0:{break a;break}case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=8;break a;break}case 5:{l=9;break a;break}default:{}}if((i|0)<248){l=11;break a}m=g+(((j|0)/2|0)<<3)|0;if((i|0)>7992){i=(j|0)/4|0;n=BMc(g,g+(i<<3)|0,m,m+(i<<3)|0,e,c)|0}else n=zMc(g,m,e,c)|0;o=+p[g>>3];q=+p[m>>3];if(o<q){r=e;s=n;break}else t=e;while(1){t=t+-8|0;if((g|0)==(t|0))break;u=+p[t>>3];if(u<q){l=28;break b}}q=+p[e>>3];if(o<q)v=k;else{i=k;while(1){if((i|0)==(e|0))break a;w=+p[i>>3];x=i+8|0;if(o<w)break;else i=x}p[i>>3]=q;p[e>>3]=w;v=x}if((v|0)==(e|0))break a;else{y=e;z=v}while(1){A=+p[g>>3];j=z;while(1){B=+p[j>>3];C=j+8|0;if(A<B){D=y;break}else j=C}do{D=D+-8|0;E=+p[D>>3]}while(A<E);if(j>>>0>=D>>>0){g=j;continue b}p[j>>3]=E;p[D>>3]=B;y=D;z=C}}if((l|0)==28){l=0;p[g>>3]=u;p[t>>3]=o;r=t;s=n+1|0}c:do if(k>>>0<r>>>0){i=m;F=r;G=k;H=s;while(1){q=+p[i>>3];I=G;while(1){J=+p[I>>3];K=I+8|0;if(J<q)I=K;else{L=F;break}}do{L=L+-8|0;M=+p[L>>3]}while(!(M<q));if(I>>>0>L>>>0){N=i;O=H;P=I;break c}p[I>>3]=M;p[L>>3]=J;i=(i|0)==(I|0)?L:i;F=L;G=K;H=H+1|0}}else{N=m;O=s;P=k}while(0);if((P|0)!=(N|0)?(q=+p[N>>3],A=+p[P>>3],q<A):0){p[P>>3]=q;p[N>>3]=A;Q=O+1|0}else Q=O;if(!Q){R=DMc(g,P,c)|0;H=P+8|0;if(DMc(H,a,c)|0){l=45;break}if(R){f=H;continue}else S=H}else S=P+8|0;H=P;if((H-h|0)>=(b-H|0)){l=44;break}yMc(g,P,c);f=S}if((l|0)==44){l=0;yMc(S,a,c);d=g;a=P;continue}else if((l|0)==45){l=0;if(R)break;else{d=g;a=P;continue}}}if((l|0)==5){J=+p[e>>3];M=+p[g>>3];if(J<M){p[g>>3]=J;p[e>>3]=M}}else if((l|0)==7)zMc(g,k,e,c)|0;else if((l|0)==8)AMc(g,k,g+16|0,e,c)|0;else if((l|0)==9)BMc(g,k,g+16|0,g+24|0,e,c)|0;else if((l|0)==11)CMc(g,a,c);return}function zMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0.0,g=0.0,h=0,i=0.0,j=0.0;e=+p[b>>3];f=+p[a>>3];g=+p[c>>3];d=g<e;do if(e<f){if(d){p[a>>3]=g;p[c>>3]=f;h=1;break}p[a>>3]=e;p[b>>3]=f;i=+p[c>>3];if(i<f){p[b>>3]=i;p[c>>3]=f;h=2}else h=1}else if(d){p[b>>3]=g;p[c>>3]=e;i=+p[b>>3];j=+p[a>>3];if(i<j){p[a>>3]=i;p[b>>3]=j;h=2}else h=1}else h=0;while(0);return h|0}function AMc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0.0,h=0.0,i=0;f=zMc(a,b,c,e)|0;g=+p[d>>3];h=+p[c>>3];if(g<h){p[c>>3]=g;p[d>>3]=h;d=f+1|0;h=+p[c>>3];g=+p[b>>3];if(h<g){p[b>>3]=h;p[c>>3]=g;g=+p[b>>3];h=+p[a>>3];if(g<h){p[a>>3]=g;p[b>>3]=h;i=f+3|0}else i=f+2|0}else i=d}else i=f;return i|0}function BMc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0.0,j=0;g=AMc(a,b,c,d,f)|0;h=+p[e>>3];i=+p[d>>3];if(h<i){p[d>>3]=h;p[e>>3]=i;e=g+1|0;i=+p[d>>3];h=+p[c>>3];if(i<h){p[c>>3]=i;p[d>>3]=h;d=g+2|0;h=+p[c>>3];i=+p[b>>3];if(h<i){p[b>>3]=h;p[c>>3]=i;i=+p[b>>3];h=+p[a>>3];if(i<h){p[a>>3]=i;p[b>>3]=h;j=g+4|0}else j=g+3|0}else j=d}else j=e}else j=g;return j|0}function CMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0.0,g=0.0,h=0,i=0.0,j=0,k=0,l=0;d=a+16|0;zMc(a,a+8|0,d,c)|0;c=a+24|0;e=d;while(1){if((c|0)==(b|0))break;f=+p[c>>3];g=+p[e>>3];if(f<g){d=e;h=c;i=g;while(1){p[h>>3]=i;if((d|0)==(a|0)){j=a;break}k=d+-8|0;i=+p[k>>3];if(!(f<i)){j=d;break}else{l=d;d=k;h=l}}p[j>>3]=f}h=c;c=c+8|0;e=h}return}function DMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0,r=0;d=b+-8|0;e=a+8|0;f=a+16|0;switch(b-a>>3|0){case 1:case 0:{g=1;break}case 2:{h=+p[d>>3];i=+p[a>>3];if(h<i){p[a>>3]=h;p[d>>3]=i;g=1}else g=1;break}case 3:{zMc(a,e,d,c)|0;g=1;break}case 4:{AMc(a,e,f,d,c)|0;g=1;break}case 5:{BMc(a,e,f,a+24|0,d,c)|0;g=1;break}default:{zMc(a,e,f,c)|0;c=a+24|0;e=0;d=f;while(1){if((c|0)==(b|0)){j=1;k=0;break}i=+p[c>>3];h=+p[d>>3];if(i<h){f=d;l=c;m=h;while(1){p[l>>3]=m;if((f|0)==(a|0)){n=a;break}o=f+-8|0;m=+p[o>>3];if(!(i<m)){n=f;break}else{q=f;f=o;l=q}}p[n>>3]=i;l=e+1|0;if((l|0)==8){j=0;k=(c+8|0)==(b|0);break}else r=l}else r=e;l=c;c=c+8|0;e=r;d=l}g=k|j}}return g|0}function EMc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=u;u=u+16|0;c=b;d=b+8|0;e=b+4|0;f[d>>2]=a;do if(a>>>0>=212){g=(a>>>0)/210|0;h=g*210|0;f[e>>2]=a-h;i=0;j=g;g=(FMc(188564,188756,e,c)|0)-188564>>2;k=h;a:while(1){l=(f[188564+(g<<2)>>2]|0)+k|0;h=5;while(1){if(h>>>0>=47){m=211;n=i;o=8;break}p=f[188372+(h<<2)>>2]|0;q=(l>>>0)/(p>>>0)|0;if(q>>>0<p>>>0){o=106;break a}if((l|0)==(Y(q,p)|0)){r=i;break}else h=h+1|0}b:do if((o|0)==8){c:while(1){o=0;h=(l>>>0)/(m>>>0)|0;do if(h>>>0>=m>>>0)if((l|0)!=(Y(h,m)|0)){p=m+10|0;q=(l>>>0)/(p>>>0)|0;if(q>>>0>=p>>>0)if((l|0)!=(Y(q,p)|0)){q=m+12|0;s=(l>>>0)/(q>>>0)|0;if(s>>>0>=q>>>0)if((l|0)!=(Y(s,q)|0)){s=m+16|0;t=(l>>>0)/(s>>>0)|0;if(t>>>0>=s>>>0)if((l|0)!=(Y(t,s)|0)){t=m+18|0;v=(l>>>0)/(t>>>0)|0;if(v>>>0>=t>>>0)if((l|0)!=(Y(v,t)|0)){v=m+22|0;w=(l>>>0)/(v>>>0)|0;if(w>>>0>=v>>>0)if((l|0)!=(Y(w,v)|0)){w=m+28|0;x=(l>>>0)/(w>>>0)|0;if(x>>>0>=w>>>0)if((l|0)==(Y(x,w)|0)){y=w;z=9;A=n}else{x=m+30|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+36|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+40|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+42|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+46|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+52|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+58|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+60|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+66|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+70|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+72|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+78|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+82|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+88|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+96|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+100|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+102|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+106|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+108|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+112|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+120|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+126|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+130|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+136|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+138|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+142|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+148|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+150|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+156|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+162|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+166|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+168|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+172|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+178|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+180|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+186|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+190|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+192|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+196|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+198|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+208|0;B=(l>>>0)/(x>>>0)|0;C=B>>>0<x>>>0;D=(l|0)==(Y(B,x)|0);y=C|D?x:m+210|0;z=C?1:D?9:0;A=C?l:n}else{y=w;z=1;A=l}}else{y=v;z=9;A=n}else{y=v;z=1;A=l}}else{y=t;z=9;A=n}else{y=t;z=1;A=l}}else{y=s;z=9;A=n}else{y=s;z=1;A=l}}else{y=q;z=9;A=n}else{y=q;z=1;A=l}}else{y=p;z=9;A=n}else{y=p;z=1;A=l}}else{y=m;z=9;A=n}else{y=m;z=1;A=l}while(0);switch(z&15){case 9:{r=A;break b;break}case 0:{m=y;n=A;o=8;break}default:break c}}if(!z)r=A;else{o=107;break a}}while(0);h=g+1|0;p=(h|0)==48;q=(p&1)+j|0;i=r;j=q;g=p?0:h;k=q*210|0}if((o|0)==106){f[d>>2]=l;E=l;break}else if((o|0)==107){f[d>>2]=l;E=A;break}}else{k=FMc(188372,188564,d,c)|0;E=f[k>>2]|0}while(0);u=b;return E|0}function FMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;d=f[c>>2]|0;c=a;e=b-a>>2;while(1){if(!e)break;a=(e|0)/2|0;b=c+(a<<2)|0;g=(f[b>>2]|0)>>>0<d>>>0;c=g?b+4|0:c;e=g?e+-1-a|0:a}return c|0}function GMc(a){a=a|0;HMc(a);return}function HMc(a){a=a|0;f[a>>2]=188764;IMc(a,0);EPc(a+28|0);kIc(f[a+32>>2]|0);kIc(f[a+36>>2]|0);kIc(f[a+48>>2]|0);kIc(f[a+60>>2]|0);return}function IMc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+32|0;d=a+36|0;e=f[a+40>>2]|0;while(1){if(!e)break;g=e+-1|0;Ti[f[(f[c>>2]|0)+(g<<2)>>2]&511](b,a,f[(f[d>>2]|0)+(g<<2)>>2]|0);e=g}return}function JMc(a){a=a|0;HMc(a);cYc(a);return}function KMc(a){a=a|0;HMc(a);return}function LMc(a){a=a|0;f[a>>2]=188780;EPc(a+4|0);return}function MMc(a){a=a|0;LMc(a);cYc(a);return}function NMc(a,b){a=a|0;b=b|0;return}function OMc(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function PMc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function QMc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function RMc(a){a=a|0;return 0}function SMc(a){a=a|0;return 0}function TMc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;ZMc()|0;e=a+12|0;g=a+16|0;h=c;c=0;while(1){if((c|0)>=(d|0))break;i=f[e>>2]|0;j=f[g>>2]|0;if(i>>>0<j>>>0){k=j-i|0;j=d-c|0;l=(j|0)<(k|0)?j:k;$Mc(h,i,l)|0;f[e>>2]=(f[e>>2]|0)+l;h=h+l|0;c=l+c|0;continue}l=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;if((l|0)==-1)break;i=aNc(l)|0;b[h>>0]=i;h=h+1|0;c=c+1|0}return c|0}function UMc(a){a=a|0;return ZMc()|0}function VMc(a){a=a|0;var c=0,d=0;c=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;if((c|0)==(ZMc()|0))d=ZMc()|0;else{c=a+12|0;a=f[c>>2]|0;f[c>>2]=a+1;d=_Mc(b[a>>0]|0)|0}return d|0}function WMc(a,b){a=a|0;b=b|0;return ZMc()|0}function XMc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=ZMc()|0;g=a+24|0;h=a+28|0;i=c;c=0;while(1){if((c|0)>=(d|0))break;j=f[g>>2]|0;k=f[h>>2]|0;if(j>>>0<k>>>0){l=k-j|0;k=d-c|0;m=(k|0)<(l|0)?k:l;$Mc(j,i,m)|0;f[g>>2]=(f[g>>2]|0)+m;i=i+m|0;c=m+c|0;continue}m=f[(f[a>>2]|0)+52>>2]|0;j=_Mc(b[i>>0]|0)|0;if((Mi[m&1023](a,j)|0)==(e|0))break;i=i+1|0;c=c+1|0}return c|0}function YMc(a,b){a=a|0;b=b|0;return ZMc()|0}function ZMc(){return -1}function _Mc(a){a=a|0;return a&255|0}function $Mc(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)o1c(a|0,b|0,c|0)|0;return a|0}function aNc(a){a=a|0;return a&255|0}function bNc(a){a=a|0;f[a>>2]=188844;EPc(a+4|0);return}function cNc(a){a=a|0;bNc(a);cYc(a);return}function dNc(a,b){a=a|0;b=b|0;return}function eNc(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function fNc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function gNc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function hNc(a){a=a|0;return 0}function iNc(a){a=a|0;return 0}function jNc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;pNc()|0;d=a+12|0;e=a+16|0;g=b;b=0;while(1){if((b|0)>=(c|0))break;h=f[d>>2]|0;i=f[e>>2]|0;if(h>>>0<i>>>0){j=i-h>>2;i=c-b|0;k=(i|0)<(j|0)?i:j;rNc(g,h,k)|0;f[d>>2]=(f[d>>2]|0)+(k<<2);g=g+(k<<2)|0;b=k+b|0;continue}k=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;if((k|0)==-1)break;h=sNc(k)|0;f[g>>2]=h;g=g+4|0;b=b+1|0}return b|0}function kNc(a){a=a|0;return pNc()|0}function lNc(a){a=a|0;var b=0,c=0;b=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;if((b|0)==(pNc()|0))c=pNc()|0;else{b=a+12|0;a=f[b>>2]|0;f[b>>2]=a+4;c=qNc(f[a>>2]|0)|0}return c|0}function mNc(a,b){a=a|0;b=b|0;return pNc()|0}function nNc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=pNc()|0;e=a+24|0;g=a+28|0;h=b;b=0;while(1){if((b|0)>=(c|0))break;i=f[e>>2]|0;j=f[g>>2]|0;if(i>>>0<j>>>0){k=j-i>>2;j=c-b|0;l=(j|0)<(k|0)?j:k;rNc(i,h,l)|0;f[e>>2]=(f[e>>2]|0)+(l<<2);h=h+(l<<2)|0;b=l+b|0;continue}l=f[(f[a>>2]|0)+52>>2]|0;i=qNc(f[h>>2]|0)|0;if((Mi[l&1023](a,i)|0)==(d|0))break;h=h+4|0;b=b+1|0}return b|0}function oNc(a,b){a=a|0;b=b|0;return pNc()|0}function pNc(){return -1}function qNc(a){a=a|0;return a|0}function rNc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{mJc(a,b,c)|0;d=a}return d|0}function sNc(a){a=a|0;return a|0}function tNc(a){a=a|0;xNc(a,188940);GMc(a+8|0);return}function uNc(a){a=a|0;tNc(a);cYc(a);return}function vNc(a){a=a|0;tNc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function wNc(a){a=a|0;uNc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function xNc(a,b){a=a|0;b=b|0;return}function yNc(a){a=a|0;CNc(a,188988);KMc(a+8|0);return}function zNc(a){a=a|0;yNc(a);cYc(a);return}function ANc(a){a=a|0;yNc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function BNc(a){a=a|0;zNc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function CNc(a,b){a=a|0;b=b|0;return}function DNc(a){a=a|0;HNc(a,188996);GMc(a+4|0);return}function ENc(a){a=a|0;DNc(a);cYc(a);return}function FNc(a){a=a|0;DNc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function GNc(a){a=a|0;ENc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function HNc(a,b){a=a|0;b=b|0;return}function INc(a){a=a|0;MNc(a,189044);KMc(a+4|0);return}function JNc(a){a=a|0;INc(a);cYc(a);return}function KNc(a){a=a|0;INc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function LNc(a){a=a|0;JNc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function MNc(a,b){a=a|0;b=b|0;return}function NNc(a){a=a|0;TNc(a,189112);GMc(a+12|0);return}function ONc(a){a=a|0;NNc(a);cYc(a);return}function PNc(a){a=a|0;NNc(a+-8|0);return}function QNc(a){a=a|0;ONc(a+-8|0);return}function RNc(a){a=a|0;NNc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function SNc(a){a=a|0;ONc(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function TNc(a,b){a=a|0;b=b|0;HNc(a+8|0,b+12|0);xNc(a,b+4|0);return}function UNc(a){a=a|0;return dJc(a)|0}function VNc(a,c){a=a|0;c=c|0;b[a>>0]=b[c>>0]|0;return}function WNc(a,b){a=a|0;b=b|0;f[a+16>>2]=(f[a+24>>2]|0)==0|b;return}function XNc(a,b){a=a|0;b=b|0;var c=0;f[a+24>>2]=b;f[a+16>>2]=(b|0)==0&1;f[a+20>>2]=0;f[a+4>>2]=4098;f[a+12>>2]=0;f[a+8>>2]=6;b=a+28|0;c=a+32|0;a=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(a|0));JXc(b);return}function YNc(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function ZNc(a,b){a=a|0;b=b|0;HXc(a,b+28|0);return}function _Nc(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function $Nc(a,b){a=a|0;b=b|0;return a<<24>>24==b<<24>>24|0}function aOc(a){a=a|0;var b=0;f[a>>2]=188780;JXc(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function bOc(a){a=a|0;var b=0;f[a>>2]=188844;JXc(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function cOc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g;b[a>>0]=0;i=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;j=f[i+16>>2]|0;if(!j){k=f[i+72>>2]|0;if(k|0)dOc(k)|0;do if(!e?(k=c+(f[(f[c>>2]|0)+-12>>2]|0)|0,f[k+4>>2]&4096|0):0){ZNc(h,k);k=DPc(h,896088)|0;EPc(h);l=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0;m=k+8|0;k=l;n=(l|0)==0;o=k+12|0;p=k+16|0;q=l;while(1){if(n){r=0;s=0;break}t=f[o>>2]|0;if((t|0)==(f[p>>2]|0))v=_i[f[(f[q>>2]|0)+36>>2]&2047](k)|0;else v=_Mc(b[t>>0]|0)|0;t=YNc(v,ZMc()|0)|0;w=t?0:l;if(t){r=0;s=0;break}t=w;x=t+12|0;y=f[x>>2]|0;z=t+16|0;if((y|0)==(f[z>>2]|0))A=_i[f[(f[w>>2]|0)+36>>2]&2047](t)|0;else A=_Mc(b[y>>0]|0)|0;if((A&255)<<24>>24<=-1){r=t;s=l;break}if(!(d[(f[m>>2]|0)+(A<<24>>24<<1)>>1]&8192)){r=t;s=l;break}y=f[x>>2]|0;if((y|0)==(f[z>>2]|0)){_i[f[(f[w>>2]|0)+40>>2]&2047](t)|0;continue}else{f[x>>2]=y+1;_Mc(b[y>>0]|0)|0;continue}}if(s|0){l=f[r+12>>2]|0;if((l|0)==(f[r+16>>2]|0))B=_i[f[(f[s>>2]|0)+36>>2]&2047](r)|0;else B=_Mc(b[l>>0]|0)|0;if(!(YNc(B,ZMc()|0)|0))break}l=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;WNc(l,f[l+16>>2]|6)}while(0);b[a>>0]=(f[c+(f[(f[c>>2]|0)+-12>>2]|0)+16>>2]|0)==0&1}else WNc(i,j|4);u=g;return}function dOc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){eOc(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[e>>2]|0)+24>>2]&2047](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(e,f[e+16>>2]|1)}fOc(d)}u=c;return a|0}function eOc(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)dOc(c)|0;b[a>>0]=1}return}function fOc(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(Jd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[a>>2]|0)+24>>2]&2047](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(b,f[b+16>>2]|1)}return}function gOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d+24|0;g=d+20|0;h=d+16|0;i=d+12|0;j=d+28|0;k=d+8|0;l=d+4|0;m=d;cOc(j,a,0);if(b[j>>0]|0){f[k>>2]=0;ZNc(m,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=DPc(m,896112)|0;n=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;o=f[(f[j>>2]|0)+16>>2]|0;f[h>>2]=f[n+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];xg[o&127](j,g,e,n,k,l)|0;EPc(m);f[c>>2]=f[l>>2];l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function hOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d+24|0;k=d+4|0;l=d;cOc(j,a,0);if(b[j>>0]|0){f[k>>2]=0;ZNc(l,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=DPc(l,896112)|0;m=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;n=f[(f[j>>2]|0)+40>>2]|0;f[h>>2]=f[m+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];xg[n&127](j,g,e,m,k,c)|0;EPc(l);l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function iOc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=a+4|0;f[h>>2]=0;cOc(g,a,1);i=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if(b[g>>0]|0){g=f[i+24>>2]|0;j=hj[f[(f[g>>2]|0)+32>>2]&511](g,c,d)|0;f[h>>2]=j;if((j|0)!=(d|0)){d=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(d,f[d+16>>2]|6)}}else WNc(i,f[i+16>>2]|4);u=e;return a|0}function jOc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){kOc(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[e>>2]|0)+24>>2]&2047](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(e,f[e+16>>2]|1)}lOc(d)}u=c;return a|0}function kOc(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)jOc(c)|0;b[a>>0]=1}return}function lOc(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(Jd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(_i[f[(f[a>>2]|0)+24>>2]&2047](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(b,f[b+16>>2]|1)}return}function mOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;eOc(h,a);if(b[h>>0]|0){ZNc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=DPc(e,896144)|0;EPc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ZMc()|0;m=j+76|0;if(YNc(l,f[m>>2]|0)|0){ZNc(e,j);l=DPc(e,896088)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;EPc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+12>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(_h[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(c,f[c+16>>2]|5)}}fOc(h);u=d;return a|0}function nOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;eOc(h,a);if(b[h>>0]|0){ZNc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=DPc(e,896144)|0;EPc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ZMc()|0;m=j+76|0;if(YNc(l,f[m>>2]|0)|0){ZNc(e,j);l=DPc(e,896088)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;EPc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+16>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(_h[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(c,f[c+16>>2]|5)}}fOc(h);u=d;return a|0}function oOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;eOc(h,a);if(b[h>>0]|0){ZNc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=DPc(e,896144)|0;EPc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ZMc()|0;m=j+76|0;if(YNc(l,f[m>>2]|0)|0){ZNc(e,j);l=DPc(e,896088)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;EPc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+24>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(_h[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(c,f[c+16>>2]|5)}}fOc(h);u=d;return a|0}function pOc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;eOc(h,a);if(b[h>>0]|0){ZNc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=DPc(e,896144)|0;EPc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ZMc()|0;m=j+76|0;if(YNc(l,f[m>>2]|0)|0){ZNc(e,j);l=DPc(e,896088)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;EPc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+32>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(ci[m&7](i,e,j,o&255,c)|0)){o=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(o,f[o+16>>2]|5)}}fOc(h);u=d;return a|0}function qOc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;eOc(h,a);if(b[h>>0]|0){ZNc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=DPc(e,896144)|0;EPc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ZMc()|0;m=j+76|0;if(YNc(l,f[m>>2]|0)|0){ZNc(e,j);l=DPc(e,896088)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;EPc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+32>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(ci[m&7](i,e,j,o&255,c)|0)){o=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(o,f[o+16>>2]|5)}}fOc(h);u=d;return a|0}function rOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;eOc(h,a);if(b[h>>0]|0){ZNc(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=DPc(e,896144)|0;EPc(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=ZMc()|0;m=j+76|0;if(YNc(l,f[m>>2]|0)|0){ZNc(e,j);l=DPc(e,896088)|0;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;EPc(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+40>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(_h[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(c,f[c+16>>2]|5)}}fOc(h);u=d;return a|0}function sOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;eOc(e,a);do if(b[e>>0]|0){g=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;h=g;if(g|0){i=h+24|0;j=f[i>>2]|0;if((j|0)==(f[h+28>>2]|0)){k=f[(f[g>>2]|0)+52>>2]|0;g=_Mc(c)|0;l=Mi[k&1023](h,g)|0}else{f[i>>2]=j+1;b[j>>0]=c;l=_Mc(c)|0}if(!(YNc(l,ZMc()|0)|0))break}j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;WNc(j,f[j+16>>2]|1)}while(0);fOc(e);u=d;return a|0}function tOc(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=f[b>>2]|1;return}function uOc(){wOc();return}function vOc(){return}function wOc(){xOc(0);be(2289,1165589,x|0)|0;return}function xOc(a){a=a|0;var b=0;a=f[46217]|0;zOc(895720,a,895776);f[223760]=188912;f[223762]=188932;f[223761]=0;XNc(895048,895720);f[223780]=0;b=ZMc()|0;f[223781]=b;AOc(895784,a,895840);f[223782]=188960;f[223784]=188980;f[223783]=0;XNc(895136,895784);f[223802]=0;a=pNc()|0;f[223803]=a;a=f[46123]|0;BOc(895848,a,895896);f[223804]=4124;f[223805]=4144;XNc(895220,895848);f[223823]=0;b=ZMc()|0;f[223824]=b;COc(895904,a,895952);f[223825]=189016;f[223826]=189036;XNc(895304,895904);f[223844]=0;a=pNc()|0;f[223845]=a;a=f[46249]|0;BOc(895960,a,896008);f[223846]=4124;f[223847]=4144;XNc(895388,895960);f[223865]=0;b=ZMc()|0;f[223866]=b;b=f[895384+(f[(f[223846]|0)+-12>>2]|0)+24>>2]|0;f[223888]=4124;f[223889]=4144;XNc(895556,b);f[223907]=0;b=ZMc()|0;f[223908]=b;COc(896016,a,896064);f[223867]=189016;f[223868]=189036;XNc(895472,896016);f[223886]=0;a=pNc()|0;f[223887]=a;a=f[895468+(f[(f[223867]|0)+-12>>2]|0)+24>>2]|0;f[223909]=189016;f[223910]=189036;XNc(895640,a);f[223928]=0;a=pNc()|0;f[223929]=a;f[895040+(f[(f[223760]|0)+-12>>2]|0)+72>>2]=895216;f[895128+(f[(f[223782]|0)+-12>>2]|0)+72>>2]=895300;a=895384+(f[(f[223846]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;a=895468+(f[(f[223867]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;f[895384+(f[(f[223846]|0)+-12>>2]|0)+72>>2]=895216;f[895468+(f[(f[223867]|0)+-12>>2]|0)+72>>2]=895300;return}function yOc(a){a=a|0;dOc(895216)|0;jOc(895300)|0;dOc(895552)|0;jOc(895636)|0;return}function zOc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;aOc(a);f[a>>2]=189340;f[a+32>>2]=c;f[a+40>>2]=d;d=ZMc()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;HXc(g,a+4|0);mi[d&2047](a,g);EPc(g);u=e;return}function AOc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;bOc(a);f[a>>2]=189276;f[a+32>>2]=c;f[a+40>>2]=d;d=pNc()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;HXc(g,a+4|0);mi[d&2047](a,g);EPc(g);u=e;return}function BOc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;aOc(a);f[a>>2]=189212;f[a+32>>2]=c;HXc(g,a+4|0);c=DPc(g,897880)|0;EPc(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0)&1;b[a+44>>0]=d;u=e;return}function COc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;bOc(a);f[a>>2]=189148;f[a+32>>2]=c;HXc(g,a+4|0);c=DPc(g,897888)|0;EPc(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0)&1;b[a+44>>0]=d;u=e;return}function DOc(a){a=a|0;bNc(a);return}function EOc(a){a=a|0;DOc(a);cYc(a);return}function FOc(a,c){a=a|0;c=c|0;var d=0;_i[f[(f[a>>2]|0)+24>>2]&2047](a)|0;d=DPc(c,897888)|0;f[a+36>>2]=d;c=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)&1;b[a+44>>0]=c;return}function GOc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=_h[f[(f[a>>2]|0)+20>>2]&127](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((eKc(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((pKc(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function HOc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=qNc(f[g>>2]|0)|0;k=Mi[i&1023](a,j)|0;if((k|0)==(pNc()|0)){h=e;break a}e=e+1|0;g=g+4|0}}else h=eKc(c,4,d,f[a+32>>2]|0)|0;while(0);return h|0}function IOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(_Nc(c,pNc()|0)|0)){j=sNc(c)|0;f[g>>2]=j;j=a+32|0;if(b[a+44>>0]|0){if((eKc(g,4,1,f[j>>2]|0)|0)==1){k=15;break}l=pNc()|0;break}f[h>>2]=e;m=g+4|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Gj[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((eKc(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((eKc(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=pNc()|0;break}}else k=15;while(0);if((k|0)==15)l=JOc(c)|0;u=d;return l|0}function JOc(a){a=a|0;var b=0;if(_Nc(a,pNc()|0)|0)b=~(pNc()|0);else b=a;return b|0}function KOc(a){a=a|0;LMc(a);return}function LOc(a){a=a|0;KOc(a);cYc(a);return}function MOc(a,c){a=a|0;c=c|0;var d=0;_i[f[(f[a>>2]|0)+24>>2]&2047](a)|0;d=DPc(c,897880)|0;f[a+36>>2]=d;c=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)&1;b[a+44>>0]=c;return}function NOc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=_h[f[(f[a>>2]|0)+20>>2]&127](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((eKc(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((pKc(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function OOc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=_Mc(b[g>>0]|0)|0;k=Mi[i&1023](a,j)|0;if((k|0)==(ZMc()|0)){h=e;break a}e=e+1|0;g=g+1|0}}else h=eKc(c,1,d,f[a+32>>2]|0)|0;while(0);return h|0}function POc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(YNc(c,ZMc()|0)|0)){j=aNc(c)|0;b[g>>0]=j;j=a+32|0;if(b[a+44>>0]|0){if((eKc(g,1,1,f[j>>2]|0)|0)==1){k=15;break}l=ZMc()|0;break}f[h>>2]=e;m=g+1|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Gj[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((eKc(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((eKc(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=ZMc()|0;break}}else k=15;while(0);if((k|0)==15)l=QOc(c)|0;u=d;return l|0}function QOc(a){a=a|0;var b=0;if(YNc(a,ZMc()|0)|0)b=~(ZMc()|0);else b=a;return b|0}function ROc(a){a=a|0;bNc(a);return}function SOc(a){a=a|0;ROc(a);cYc(a);return}function TOc(a,c){a=a|0;c=c|0;var d=0,e=0;d=DPc(c,897888)|0;c=a+36|0;f[c>>2]=d;e=_i[f[(f[d>>2]|0)+24>>2]&2047](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(_i[f[(f[e>>2]|0)+28>>2]&2047](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)YSc(524751);else return}function UOc(a){a=a|0;return XOc(a,0)|0}function VOc(a){a=a|0;return XOc(a,1)|0}function WOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=_Nc(c,pNc()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((_Nc(o,pNc()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=sNc(f[m>>2]|0)|0;f[h>>2]=o;o=f[a+36>>2]|0;switch(Gj[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+4|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((PLc(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=pNc()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function XOc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=pNc()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=kLc(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=pNc()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+4|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Gj[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=kLc(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)f[g>>2]=b[e>>0];else if((o|0)==18){z=pNc()|0;break}A=s;o=19}else{f[g>>2]=b[e>>0];A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=qNc(f[g>>2]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=qNc(b[e+j>>0]|0)|0}while((PLc(i,f[l>>2]|0)|0)!=-1);z=pNc()|0;break b}while(0);z=qNc(f[g>>2]|0)|0}while(0);q=z}n=q}u=d;return n|0}function YOc(a){a=a|0;LMc(a);return}function ZOc(a){a=a|0;YOc(a);cYc(a);return}function _Oc(a,c){a=a|0;c=c|0;var d=0,e=0;d=DPc(c,897880)|0;c=a+36|0;f[c>>2]=d;e=_i[f[(f[d>>2]|0)+24>>2]&2047](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(_i[f[(f[e>>2]|0)+28>>2]&2047](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)YSc(524751);else return}function $Oc(a){a=a|0;return cPc(a,0)|0}function aPc(a){a=a|0;return cPc(a,1)|0}function bPc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+4|0;h=d+8|0;i=d;j=YNc(c,ZMc()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((YNc(o,ZMc()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=aNc(f[m>>2]|0)|0;b[h>>0]=o;o=f[a+36>>2]|0;switch(Gj[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+1|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((PLc(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=ZMc()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function cPc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=ZMc()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=kLc(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=ZMc()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+1|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Gj[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=kLc(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)b[g>>0]=b[e>>0]|0;else if((o|0)==18){z=ZMc()|0;break}A=s;o=19}else{b[g>>0]=b[e>>0]|0;A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=_Mc(b[g>>0]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=_Mc(b[e+j>>0]|0)|0}while((PLc(i,f[l>>2]|0)|0)!=-1);z=ZMc()|0;break b}while(0);z=_Mc(b[g>>0]|0)|0}while(0);q=z}n=q}u=d;return n|0}function dPc(a){a=a|0;jPc(a);return}function ePc(a){a=a|0;dPc(a);cYc(a);return}function fPc(a){a=a|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function gPc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=e;e=c;while(1){if((a|0)==(f|0)){g=7;break}if((e|0)==(d|0)){h=-1;break}c=b[e>>0]|0;i=b[a>>0]|0;if(c<<24>>24<i<<24>>24){h=-1;break}if(i<<24>>24<c<<24>>24){h=1;break}a=a+1|0;e=e+1|0}if((g|0)==7)h=(e|0)!=(d|0)&1;return h|0}function hPc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d|0;if(h>>>0>4294967279)jYc(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=$Xc(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}k=d;d=i;while(1){if((k|0)==(e|0))break;VNc(d,k);k=k+1|0;d=d+1|0}b[g>>0]=0;VNc(i+h|0,g);u=c;return}function iPc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;a=0;e=c;while(1){if((e|0)==(d|0))break;c=(b[e>>0]|0)+(a<<4)|0;f=c&-268435456;a=(f>>>24|f)^c;e=e+1|0}return a|0}function jPc(a){a=a|0;return}function kPc(a){a=a|0;jPc(a);return}function lPc(a){a=a|0;kPc(a);cYc(a);return}function mPc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=d;d=b;while(1){if((a|0)==(e|0)){g=7;break}if((d|0)==(c|0)){h=-1;break}b=f[d>>2]|0;i=f[a>>2]|0;if((b|0)<(i|0)){h=-1;break}if((i|0)<(b|0)){h=1;break}a=a+4|0;d=d+4|0}if((g|0)==7)h=(d|0)!=(c|0)&1;return h|0}function nPc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d>>2;if(h>>>0>1073741807)jYc(a);do if(h>>>0>=2){i=h+4&-4;if(i>>>0>1073741823)tf();else{j=$Xc(i<<2)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=h;k=d;l=j;break}}else{b[a+8+3>>0]=h;k=d;l=a}while(0);while(1){if((k|0)==(e|0))break;pPc(l,k);k=k+4|0;l=l+4|0}f[g>>2]=0;pPc(l,g);u=c;return}function oPc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=0;d=b;while(1){if((d|0)==(c|0))break;b=(f[d>>2]|0)+(a<<4)|0;e=b&-268435456;a=(e>>>24|e)^b;d=d+4|0}return a|0}function pPc(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function qPc(a){a=a|0;jPc(a);return}function rPc(a){a=a|0;jPc(a);cYc(a);return}function sPc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=xg[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{ZNc(j,e);l=DPc(j,896088)|0;EPc(j);ZNc(j,e);e=DPc(j,896104)|0;EPc(j);mi[f[(f[e>>2]|0)+24>>2]&2047](k,e);mi[f[(f[e>>2]|0)+28>>2]&2047](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(jQc(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;nYc(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function tPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=hQc(a,j,i,d,e,g)|0;u=h;return l|0}function uPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=fQc(a,j,i,d,e,g)|0;u=h;return l|0}function vPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=dQc(a,j,i,d,e,g)|0;u=h;return l|0}function wPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=bQc(a,j,i,d,e,g)|0;u=h;return l|0}function xPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=$Pc(a,j,i,d,e,g)|0;u=h;return l|0}function yPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=XPc(a,j,i,d,e,g)|0;u=h;return l|0}function zPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=VPc(a,j,i,d,e,g)|0;u=h;return l|0}function APc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=TPc(a,j,i,d,e,g)|0;u=h;return l|0}function BPc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=OPc(a,j,i,d,e,g)|0;u=h;return l|0}function CPc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+240|0;i=a;j=a+204|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}ZNc(l,e);e=DPc(l,896088)|0;hh[f[(f[e>>2]|0)+32>>2]&127](e,524899,524925,j)|0;EPc(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;uYc(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=r;r=t;w=t;a:while(1){if(r){t=f[r+12>>2]|0;if((t|0)==(f[r+16>>2]|0))x=_i[f[(f[r>>2]|0)+36>>2]&2047](r)|0;else x=_Mc(b[t>>0]|0)|0;if(YNc(x,ZMc()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=r;z=w;A=0}}else{y=0;z=0;A=1}t=f[d>>2]|0;do if(t){B=f[t+12>>2]|0;if((B|0)==(f[t+16>>2]|0))C=_i[f[(f[t>>2]|0)+36>>2]&2047](t)|0;else C=_Mc(b[B>>0]|0)|0;if(!(YNc(C,ZMc()|0)|0))if(A){D=t;break}else{E=v;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=v;F=0;break}else D=0}t=b[e>>0]|0;B=t<<24>>24<0?f[s>>2]|0:t&255;if((f[m>>2]|0)==(v+B|0)){uYc(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;uYc(l,H,0);t=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=t+B;I=t}else I=v;t=y+12|0;B=f[t>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else K=_Mc(b[B>>0]|0)|0;if(FPc(K&255,16,I,m,p,0,k,n,o,j)|0){E=I;F=D;break}B=f[t>>2]|0;if((B|0)==(f[J>>2]|0)){_i[f[(f[y>>2]|0)+40>>2]&2047](y)|0;v=I;r=y;w=z;continue}else{f[t>>2]=B+1;_Mc(b[B>>0]|0)|0;v=I;r=y;w=z;continue}}uYc(l,(f[m>>2]|0)-E|0,0);E=(b[e>>0]|0)<0?f[l>>2]|0:l;e=GPc()|0;f[i>>2]=h;if((HPc(E,e,524932,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](y)|0;else L=_Mc(b[i>>0]|0)|0;if(YNc(L,ZMc()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(F){L=f[F+12>>2]|0;if((L|0)==(f[F+16>>2]|0))N=_i[f[(f[F>>2]|0)+36>>2]&2047](F)|0;else N=_Mc(b[L>>0]|0)|0;if(!(YNc(N,ZMc()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function DPc(a,b){a=a|0;b=b|0;var c=0;c=f[a>>2]|0;return JPc(c,IPc(b)|0)|0}function EPc(a){a=a|0;RXc(f[a>>2]|0)|0;return}function FPc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(b[l+24>>0]|0)==a<<24>>24;if(!o?(b[l+25>>0]|0)!=a<<24>>24:0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if(a<<24>>24==h<<24>>24?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+26|0;o=0;while(1){s=l+o|0;if((o|0)==26){t=r;break}if((b[s>>0]|0)==a<<24>>24){t=s;break}else o=o+1|0}o=t-l|0;if((o|0)>23)q=-1;else{r=524899+o|0;switch(c|0){case 10:case 8:{if((o|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=22){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function GPc(){var a=0;if((b[539504]|0)==0?X0c(539504)|0:0){a=YJc(2147483647,524935,0)|0;f[224024]=a}return f[224024]|0}function HPc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=$Jc(b)|0;b=vKc(a,c,g)|0;if(d|0)$Jc(d)|0;u=e;return b|0}function IPc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+48|0;c=b+32|0;d=b+24|0;e=b;g=b+16|0;f[g>>2]=2290;f[g+4>>2]=0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];LPc(e,c,a);if((f[a>>2]|0)!=-1){f[c>>2]=e;f[d>>2]=c;_Xc(a,d,2291)}u=b;return (f[a+4>>2]|0)+-1|0}function JPc(a,b){a=a|0;b=b|0;return f[(f[a+8>>2]|0)+(b<<2)>>2]|0}function KPc(a){a=a|0;var b=0;b=f[224025]|0;f[224025]=b+1;f[a+4>>2]=b+1;return}function LPc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b>>2]|0;e=f[b+4>>2]|0;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;return}function MPc(a){a=a|0;NPc(f[f[a>>2]>>2]|0);return}function NPc(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=f[a+8>>2]|0;d=(f[a>>2]|0)+(c>>1)|0;if(!(c&1))e=b;else e=f[(f[d>>2]|0)+b>>2]|0;Yi[e&4095](d);return}function OPc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;PPc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;uYc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else B=_Mc(b[y>>0]|0)|0;if(YNc(B,ZMc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else G=_Mc(b[F>>0]|0)|0;if(!(YNc(G,ZMc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){uYc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;uYc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else O=_Mc(b[F>>0]|0)|0;if(QPc(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&2047](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;_Mc(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+RPc(I,f[n>>2]|0,g);p[h>>3]=P;SPc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&2047](C)|0;else Q=_Mc(b[q>>0]|0)|0;if(YNc(Q,ZMc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&2047](J)|0;else S=_Mc(b[Q>>0]|0)|0;if(!(YNc(S,ZMc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(m);nYc(l);u=a;return g|0}function PPc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;ZNc(i,c);c=DPc(i,896088)|0;hh[f[(f[c>>2]|0)+32>>2]&127](c,524899,524931,d)|0;d=DPc(i,896104)|0;c=_i[f[(f[d>>2]|0)+12>>2]&2047](d)|0;b[e>>0]=c;c=_i[f[(f[d>>2]|0)+16>>2]&2047](d)|0;b[g>>0]=c;mi[f[(f[d>>2]|0)+20>>2]&2047](a,d);EPc(i);u=h;return}function QPc(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if(a<<24>>24==h<<24>>24)if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if(a<<24>>24==i<<24>>24?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+32|0;p=0;while(1){r=n+p|0;if((p|0)==32){s=k;break}if((b[r>>0]|0)==a<<24>>24){s=r;break}else p=p+1|0}p=s-n|0;if((p|0)>31)q=-1;else{k=b[524899+p>>0]|0;switch(p|0){case 24:case 25:{r=f[g>>2]|0;if((r|0)!=(e|0)?(b[r+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}case 23:case 22:{b[d>>0]=80;r=f[g>>2]|0;f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}default:{r=k&95;if((((r|0)==(b[d>>0]|0)?(b[d>>0]=r|128,b[c>>0]|0):0)?(b[c>>0]=0,r=b[j+11>>0]|0,(r<<24>>24<0?f[j+4>>2]|0:r&255)|0):0)?(r=f[l>>2]|0,(r-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=r+4;f[r>>2]=t}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=k;if((p|0)>21){q=0;break a}f[m>>2]=(f[m>>2]|0)+1;q=0;break a}}}}while(0);return q|0}function RPc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=vIc()|0;i=f[h>>2]|0;h=vIc()|0;f[h>>2]=0;j=+iLc(a,e,GPc()|0);a=vIc()|0;h=f[a>>2]|0;if(!h){a=vIc()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function SPc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=b[a+11>>0]|0;h=g<<24>>24<0;i=a+4|0;j=f[i>>2]|0;k=g&255;do if((h?j:k)|0){if((c|0)==(d|0))l=j;else{g=d;m=c;while(1){n=g+-4|0;if(m>>>0>=n>>>0)break;o=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=o;g=n;m=m+4|0}l=f[i>>2]|0}m=h?f[a>>2]|0:a;g=d+-4|0;n=m+(h?l:k)|0;o=c;p=m;while(1){q=b[p>>0]|0;r=q<<24>>24>0&q<<24>>24!=127;if(o>>>0>=g>>>0)break;if(r?(q<<24>>24|0)!=(f[o>>2]|0):0){s=10;break}o=o+4|0;p=(n-p|0)>1?p+1|0:p}if((s|0)==10){f[e>>2]=4;break}if(r?((f[g>>2]|0)+-1|0)>>>0>=q<<24>>24>>>0:0)f[e>>2]=4}while(0);return}function TPc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;PPc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;uYc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else B=_Mc(b[y>>0]|0)|0;if(YNc(B,ZMc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else G=_Mc(b[F>>0]|0)|0;if(!(YNc(G,ZMc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){uYc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;uYc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else O=_Mc(b[F>>0]|0)|0;if(QPc(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&2047](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;_Mc(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+UPc(I,f[n>>2]|0,g);p[h>>3]=P;SPc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&2047](C)|0;else Q=_Mc(b[q>>0]|0)|0;if(YNc(Q,ZMc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&2047](J)|0;else S=_Mc(b[Q>>0]|0)|0;if(!(YNc(S,ZMc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(m);nYc(l);u=a;return g|0}function UPc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=vIc()|0;i=f[h>>2]|0;h=vIc()|0;f[h>>2]=0;j=+hLc(a,e,GPc()|0);a=vIc()|0;h=f[a>>2]|0;if(!h){a=vIc()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function VPc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;PPc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;uYc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else B=_Mc(b[y>>0]|0)|0;if(YNc(B,ZMc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else G=_Mc(b[F>>0]|0)|0;if(!(YNc(G,ZMc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[o>>2]|0)==(z+F|0)){uYc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;uYc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else O=_Mc(b[F>>0]|0)|0;if(QPc(O&255,s,t,M,o,b[j>>0]|0,b[k>>0]|0,l,p,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&2047](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;_Mc(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+WPc(I,f[o>>2]|0,g);n[h>>2]=P;SPc(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&2047](C)|0;else Q=_Mc(b[q>>0]|0)|0;if(YNc(Q,ZMc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&2047](J)|0;else S=_Mc(b[Q>>0]|0)|0;if(!(YNc(S,ZMc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(m);nYc(l);u=a;return g|0}function WPc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=vIc()|0;i=f[h>>2]|0;h=vIc()|0;f[h>>2]=0;j=+gLc(a,e,GPc()|0);a=vIc()|0;h=f[a>>2]|0;if(!h){a=vIc()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function XPc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;ZPc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=_Mc(b[v>>0]|0)|0;if(YNc(y,ZMc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=_Mc(b[C>>0]|0)|0;if(!(YNc(D,ZMc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else M=_Mc(b[C>>0]|0)|0;if(FPc(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+1;_Mc(b[C>>0]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=_Pc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else N=_Mc(b[o>>0]|0)|0;if(YNc(N,ZMc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else P=_Mc(b[N>>0]|0)|0;if(!(YNc(P,ZMc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function YPc(a){a=a|0;var b=0;switch(f[a+4>>2]&74){case 64:{b=8;break}case 8:{b=16;break}case 0:{b=0;break}default:b=10}return b|0}function ZPc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;ZNc(h,c);c=DPc(h,896088)|0;hh[f[(f[c>>2]|0)+32>>2]&127](c,524899,524925,d)|0;d=DPc(h,896104)|0;c=_i[f[(f[d>>2]|0)+16>>2]&2047](d)|0;b[e>>0]=c;mi[f[(f[d>>2]|0)+20>>2]&2047](a,d);EPc(h);u=g;return}function _Pc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0;j=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;j=0;break}k=vIc()|0;l=f[k>>2]|0;k=vIc()|0;f[k>>2]=0;k=QIc(a,h,e,GPc()|0)|0;m=J;n=vIc()|0;o=f[n>>2]|0;if(!o){n=vIc()|0;f[n>>2]=l}if((f[h>>2]|0)==(c|0))if((o|0)==34){p=-1;q=-1;r=8}else{s=k;t=m}else{p=0;q=0;r=8}if((r|0)==8){f[d>>2]=4;s=p;t=q}i=t;j=s}while(0);J=i;u=g;return j|0}function $Pc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;ZPc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=_Mc(b[v>>0]|0)|0;if(YNc(y,ZMc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=_Mc(b[C>>0]|0)|0;if(!(YNc(D,ZMc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else L=_Mc(b[C>>0]|0)|0;if(FPc(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;_Mc(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=aQc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else M=_Mc(b[o>>0]|0)|0;if(YNc(M,ZMc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else O=_Mc(b[M>>0]|0)|0;if(!(YNc(O,ZMc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function aQc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=vIc()|0;k=f[j>>2]|0;j=vIc()|0;f[j>>2]=0;j=QIc(a,h,e,GPc()|0)|0;l=J;m=vIc()|0;n=f[m>>2]|0;if(!n){m=vIc()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function bQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;ZPc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=_Mc(b[v>>0]|0)|0;if(YNc(y,ZMc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=_Mc(b[C>>0]|0)|0;if(!(YNc(D,ZMc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else L=_Mc(b[C>>0]|0)|0;if(FPc(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;_Mc(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=cQc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else M=_Mc(b[o>>0]|0)|0;if(YNc(M,ZMc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else O=_Mc(b[M>>0]|0)|0;if(!(YNc(O,ZMc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function cQc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=vIc()|0;k=f[j>>2]|0;j=vIc()|0;f[j>>2]=0;j=QIc(a,h,e,GPc()|0)|0;l=J;m=vIc()|0;n=f[m>>2]|0;if(!n){m=vIc()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function dQc(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;j=a+198|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=YPc(g)|0;ZPc(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;uYc(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=t;t=w;y=w;a:while(1){if(t){w=f[t+12>>2]|0;if((w|0)==(f[t+16>>2]|0))z=_i[f[(f[t>>2]|0)+36>>2]&2047](t)|0;else z=_Mc(b[w>>0]|0)|0;if(YNc(z,ZMc()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=t;B=y;C=0}}else{A=0;B=0;C=1}w=f[e>>2]|0;do if(w){D=f[w+12>>2]|0;if((D|0)==(f[w+16>>2]|0))E=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else E=_Mc(b[D>>0]|0)|0;if(!(YNc(E,ZMc()|0)|0))if(C){F=w;break}else{G=x;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=x;H=0;break}else F=0}w=b[g>>0]|0;D=w<<24>>24<0?f[v>>2]|0:w&255;if((f[n>>2]|0)==(x+D|0)){uYc(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;uYc(m,J,0);w=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+D;K=w}else K=x;w=A+12|0;D=f[w>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else M=_Mc(b[D>>0]|0)|0;if(FPc(M&255,r,K,n,q,b[k>>0]|0,l,o,p,j)|0){G=K;H=F;break}D=f[w>>2]|0;if((D|0)==(f[L>>2]|0)){_i[f[(f[A>>2]|0)+40>>2]&2047](A)|0;x=K;t=A;y=B;continue}else{f[w>>2]=D+1;_Mc(b[D>>0]|0)|0;x=K;t=A;y=B;continue}}y=b[l+11>>0]|0;if((y<<24>>24<0?f[l+4>>2]|0:y&255)|0?(y=f[p>>2]|0,(y-o|0)<160):0){t=f[q>>2]|0;f[p>>2]=y+4;f[y>>2]=t}t=eQc(G,f[n>>2]|0,h,r)|0;d[i>>1]=t;SPc(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=_i[f[(f[B>>2]|0)+36>>2]&2047](A)|0;else N=_Mc(b[p>>0]|0)|0;if(YNc(N,ZMc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(H){N=f[H+12>>2]|0;if((N|0)==(f[H+16>>2]|0))P=_i[f[(f[H>>2]|0)+36>>2]&2047](H)|0;else P=_Mc(b[N>>0]|0)|0;if(!(YNc(P,ZMc()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;nYc(m);nYc(l);u=a;return h|0}function eQc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=vIc()|0;k=f[j>>2]|0;j=vIc()|0;f[j>>2]=0;j=QIc(a,h,e,GPc()|0)|0;l=J;m=vIc()|0;n=f[m>>2]|0;if(!n){m=vIc()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>65535|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j&65535;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function fQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;ZPc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=_Mc(b[v>>0]|0)|0;if(YNc(y,ZMc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=_Mc(b[C>>0]|0)|0;if(!(YNc(D,ZMc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else M=_Mc(b[C>>0]|0)|0;if(FPc(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+1;_Mc(b[C>>0]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=gQc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else N=_Mc(b[o>>0]|0)|0;if(YNc(N,ZMc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else P=_Mc(b[N>>0]|0)|0;if(!(YNc(P,ZMc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function gQc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0;i=0}else{j=vIc()|0;k=f[j>>2]|0;j=vIc()|0;f[j>>2]=0;j=ZIc(a,g,d,GPc()|0)|0;d=J;a=vIc()|0;l=f[a>>2]|0;if(!l){a=vIc()|0;f[a>>2]=k}if((f[g>>2]|0)==(b|0))if((l|0)==34){f[c>>2]=4;l=(d|0)>0|(d|0)==0&j>>>0>0;m=l?-1:0;n=l?2147483647:-2147483648}else{m=j;n=d}else{f[c>>2]=4;m=0;n=0}h=n;i=m}J=h;u=e;return i|0}function hQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;ZPc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=_Mc(b[v>>0]|0)|0;if(YNc(y,ZMc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=_Mc(b[C>>0]|0)|0;if(!(YNc(D,ZMc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else L=_Mc(b[C>>0]|0)|0;if(FPc(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;_Mc(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=iQc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else M=_Mc(b[o>>0]|0)|0;if(YNc(M,ZMc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else O=_Mc(b[M>>0]|0)|0;if(!(YNc(O,ZMc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function iQc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0}else{i=vIc()|0;j=f[i>>2]|0;i=vIc()|0;f[i>>2]=0;i=ZIc(a,g,d,GPc()|0)|0;d=J;a=vIc()|0;k=f[a>>2]|0;if(!k){a=vIc()|0;f[a>>2]=j}a:do if((f[g>>2]|0)==(b|0)){do if((k|0)==34){f[c>>2]=4;if((d|0)>0|(d|0)==0&i>>>0>0){l=2147483647;break a}}else{if((d|0)<-1|(d|0)==-1&i>>>0<2147483648){f[c>>2]=4;break}if((d|0)>0|(d|0)==0&i>>>0>2147483647){f[c>>2]=4;l=2147483647;break a}else{l=i;break a}}while(0);l=-2147483648}else{f[c>>2]=4;l=0}while(0);h=l}u=e;return h|0}function jQc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=jIc(l)|0;if(!m)eYc();else{n=m;o=m}}else{n=k;o=0}k=l;l=d;m=n;p=0;while(1){if((l|0)==(e|0))break;q=b[l+11>>0]|0;if(q<<24>>24<0)r=f[l+4>>2]|0;else r=q&255;if(!r){b[m>>0]=2;s=k+-1|0;t=p+1|0}else{b[m>>0]=1;s=k;t=p}k=s;l=l+12|0;m=m+1|0;p=t}t=0;m=k;k=p;a:while(1){p=f[a>>2]|0;do if(p){l=f[p+12>>2]|0;if((l|0)==(f[p+16>>2]|0))v=_i[f[(f[p>>2]|0)+36>>2]&2047](p)|0;else v=_Mc(b[l>>0]|0)|0;if(YNc(v,ZMc()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);p=f[c>>2]|0;if(p){l=f[p+12>>2]|0;if((l|0)==(f[p+16>>2]|0))x=_i[f[(f[p>>2]|0)+36>>2]&2047](p)|0;else x=_Mc(b[l>>0]|0)|0;if(YNc(x,ZMc()|0)|0){f[c>>2]=0;y=0;z=1}else{y=p;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((m|0)!=0&(w^z)))break;p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))B=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else B=_Mc(b[p>>0]|0)|0;p=B&255;if(i)C=p;else C=Mi[f[(f[g>>2]|0)+12>>2]&1023](g,p)|0;p=t+1|0;l=d;s=0;r=n;q=k;D=m;while(1){if((l|0)==(e|0))break;do if((b[r>>0]|0)==1){E=l+11|0;if((b[E>>0]|0)<0)F=f[l>>2]|0;else F=l;G=b[F+t>>0]|0;if(i)H=G;else H=Mi[f[(f[g>>2]|0)+12>>2]&1023](g,G)|0;G=D+-1|0;if(C<<24>>24!=H<<24>>24){b[r>>0]=0;I=s;J=q;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[l+4>>2]|0;else M=L&255;if((M|0)==(p|0)){b[r>>0]=2;I=1;J=q+1|0;K=G}else{I=1;J=q;K=D}}else{I=s;J=q;K=D}while(0);l=l+12|0;s=I;r=r+1|0;q=J;D=K}if(!s){t=p;m=D;k=q;continue}r=f[a>>2]|0;l=r+12|0;G=f[l>>2]|0;if((G|0)==(f[r+16>>2]|0))_i[f[(f[r>>2]|0)+40>>2]&2047](r)|0;else{f[l>>2]=G+1;_Mc(b[G>>0]|0)|0}if((q+D|0)>>>0>1){N=d;O=n;P=q}else{t=p;m=D;k=q;continue}while(1){if((N|0)==(e|0)){t=p;m=D;k=P;continue a}if((b[O>>0]|0)==2){G=b[N+11>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(p|0)){b[O>>0]=0;R=P+-1|0}else R=P}else R=P;N=N+12|0;O=O+1|0;P=R}}do if(A){R=f[A+12>>2]|0;if((R|0)==(f[A+16>>2]|0))S=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else S=_Mc(b[R>>0]|0)|0;if(YNc(S,ZMc()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else U=_Mc(b[a>>0]|0)|0;if(!(YNc(U,ZMc()|0)|0))if(T){V=d;W=n;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=n}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=n}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}kIc(o);u=j;return Y|0}function kQc(a){a=a|0;jPc(a);return}function lQc(a){a=a|0;jPc(a);cYc(a);return}function mQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=xg[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{ZNc(j,e);l=DPc(j,896120)|0;EPc(j);ZNc(j,e);e=DPc(j,896128)|0;EPc(j);mi[f[(f[e>>2]|0)+24>>2]&2047](k,e);mi[f[(f[e>>2]|0)+28>>2]&2047](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(KQc(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;NYc(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function nQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=JQc(a,j,i,d,e,g)|0;u=h;return l|0}function oQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=IQc(a,j,i,d,e,g)|0;u=h;return l|0}function pQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=HQc(a,j,i,d,e,g)|0;u=h;return l|0}function qQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=GQc(a,j,i,d,e,g)|0;u=h;return l|0}function rQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=FQc(a,j,i,d,e,g)|0;u=h;return l|0}function sQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=DQc(a,j,i,d,e,g)|0;u=h;return l|0}function tQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=CQc(a,j,i,d,e,g)|0;u=h;return l|0}function uQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=BQc(a,j,i,d,e,g)|0;u=h;return l|0}function vQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=yQc(a,j,i,d,e,g)|0;u=h;return l|0}function wQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+320|0;i=a;j=a+208|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}ZNc(l,e);e=DPc(l,896120)|0;hh[f[(f[e>>2]|0)+48>>2]&127](e,524899,524925,j)|0;EPc(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;uYc(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=r;r=t;w=t;a:while(1){if(r){t=f[r+12>>2]|0;if((t|0)==(f[r+16>>2]|0))x=_i[f[(f[r>>2]|0)+36>>2]&2047](r)|0;else x=qNc(f[t>>2]|0)|0;if(_Nc(x,pNc()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=r;z=w;A=0}}else{y=0;z=0;A=1}t=f[d>>2]|0;do if(t){B=f[t+12>>2]|0;if((B|0)==(f[t+16>>2]|0))C=_i[f[(f[t>>2]|0)+36>>2]&2047](t)|0;else C=qNc(f[B>>2]|0)|0;if(!(_Nc(C,pNc()|0)|0))if(A){D=t;break}else{E=v;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=v;F=0;break}else D=0}t=b[e>>0]|0;B=t<<24>>24<0?f[s>>2]|0:t&255;if((f[m>>2]|0)==(v+B|0)){uYc(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;uYc(l,H,0);t=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=t+B;I=t}else I=v;t=y+12|0;B=f[t>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else K=qNc(f[B>>2]|0)|0;if(xQc(K,16,I,m,p,0,k,n,o,j)|0){E=I;F=D;break}B=f[t>>2]|0;if((B|0)==(f[J>>2]|0)){_i[f[(f[y>>2]|0)+40>>2]&2047](y)|0;v=I;r=y;w=z;continue}else{f[t>>2]=B+4;qNc(f[B>>2]|0)|0;v=I;r=y;w=z;continue}}uYc(l,(f[m>>2]|0)-E|0,0);E=(b[e>>0]|0)<0?f[l>>2]|0:l;e=GPc()|0;f[i>>2]=h;if((HPc(E,e,524932,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](y)|0;else L=qNc(f[i>>2]|0)|0;if(_Nc(L,pNc()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(F){L=f[F+12>>2]|0;if((L|0)==(f[F+16>>2]|0))N=_i[f[(f[F>>2]|0)+36>>2]&2047](F)|0;else N=qNc(f[L>>2]|0)|0;if(!(_Nc(N,pNc()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function xQc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(f[l+96>>2]|0)==(a|0);if(!o?(f[l+100>>2]|0)!=(a|0):0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if((a|0)==(h|0)?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+104|0;o=0;while(1){s=l+(o<<2)|0;if((o|0)==26){t=r;break}if((f[s>>2]|0)==(a|0)){t=s;break}else o=o+1|0}o=t-l|0;r=o>>2;if((o|0)>92)q=-1;else{s=524899+r|0;switch(c|0){case 10:case 8:{if((r|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=88){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function yQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;zQc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;uYc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else B=qNc(f[y>>2]|0)|0;if(_Nc(B,pNc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else G=qNc(f[F>>2]|0)|0;if(!(_Nc(G,pNc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){uYc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;uYc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else O=qNc(f[F>>2]|0)|0;if(AQc(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&2047](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;qNc(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+RPc(I,f[n>>2]|0,g);p[h>>3]=P;SPc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&2047](C)|0;else Q=qNc(f[q>>2]|0)|0;if(_Nc(Q,pNc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&2047](J)|0;else S=qNc(f[Q>>2]|0)|0;if(!(_Nc(S,pNc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(m);nYc(l);u=a;return g|0}function zQc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;ZNc(h,b);b=DPc(h,896120)|0;hh[f[(f[b>>2]|0)+48>>2]&127](b,524899,524931,c)|0;c=DPc(h,896128)|0;b=_i[f[(f[c>>2]|0)+12>>2]&2047](c)|0;f[d>>2]=b;b=_i[f[(f[c>>2]|0)+16>>2]&2047](c)|0;f[e>>2]=b;mi[f[(f[c>>2]|0)+20>>2]&2047](a,c);EPc(h);u=g;return}function AQc(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if((a|0)==(h|0))if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if((a|0)==(i|0)?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+128|0;p=0;while(1){r=n+(p<<2)|0;if((p|0)==32){s=k;break}if((f[r>>2]|0)==(a|0)){s=r;break}else p=p+1|0}p=s-n|0;k=p>>2;if((p|0)<=124){r=b[524899+k>>0]|0;switch(k|0){case 24:case 25:{k=f[g>>2]|0;if((k|0)!=(e|0)?(b[k+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=k+1;b[k>>0]=r;q=0;break a;break}case 23:case 22:{b[d>>0]=80;break}default:{k=r&95;if((((k|0)==(b[d>>0]|0)?(b[d>>0]=k|128,b[c>>0]|0):0)?(b[c>>0]=0,k=b[j+11>>0]|0,(k<<24>>24<0?f[j+4>>2]|0:k&255)|0):0)?(k=f[l>>2]|0,(k-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=t}}}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=r;if((p|0)>84)q=0;else{f[m>>2]=(f[m>>2]|0)+1;q=0}}else q=-1}while(0);return q|0}function BQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;zQc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;uYc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else B=qNc(f[y>>2]|0)|0;if(_Nc(B,pNc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else G=qNc(f[F>>2]|0)|0;if(!(_Nc(G,pNc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){uYc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;uYc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else O=qNc(f[F>>2]|0)|0;if(AQc(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&2047](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;qNc(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+UPc(I,f[n>>2]|0,g);p[h>>3]=P;SPc(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&2047](C)|0;else Q=qNc(f[q>>2]|0)|0;if(_Nc(Q,pNc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&2047](J)|0;else S=qNc(f[Q>>2]|0)|0;if(!(_Nc(S,pNc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(m);nYc(l);u=a;return g|0}function CQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;zQc(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;uYc(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else B=qNc(f[y>>2]|0)|0;if(_Nc(B,pNc()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else G=qNc(f[F>>2]|0)|0;if(!(_Nc(G,pNc()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[o>>2]|0)==(z+F|0)){uYc(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;uYc(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else O=qNc(f[F>>2]|0)|0;if(AQc(O,s,t,M,o,f[j>>2]|0,f[k>>2]|0,l,p,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){_i[f[(f[C>>2]|0)+40>>2]&2047](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;qNc(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+WPc(I,f[o>>2]|0,g);n[h>>2]=P;SPc(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=_i[f[(f[D>>2]|0)+36>>2]&2047](C)|0;else Q=qNc(f[q>>2]|0)|0;if(_Nc(Q,pNc()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=_i[f[(f[J>>2]|0)+36>>2]&2047](J)|0;else S=qNc(f[Q>>2]|0)|0;if(!(_Nc(S,pNc()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(m);nYc(l);u=a;return g|0}function DQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;EQc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=qNc(f[v>>2]|0)|0;if(_Nc(y,pNc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=qNc(f[C>>2]|0)|0;if(!(_Nc(D,pNc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else M=qNc(f[C>>2]|0)|0;if(xQc(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+4;qNc(f[C>>2]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=_Pc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else N=qNc(f[o>>2]|0)|0;if(_Nc(N,pNc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else P=qNc(f[N>>2]|0)|0;if(!(_Nc(P,pNc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function EQc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;ZNc(g,b);b=DPc(g,896120)|0;hh[f[(f[b>>2]|0)+48>>2]&127](b,524899,524925,c)|0;c=DPc(g,896128)|0;b=_i[f[(f[c>>2]|0)+16>>2]&2047](c)|0;f[d>>2]=b;mi[f[(f[c>>2]|0)+20>>2]&2047](a,c);EPc(g);u=e;return}function FQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;EQc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=qNc(f[v>>2]|0)|0;if(_Nc(y,pNc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=qNc(f[C>>2]|0)|0;if(!(_Nc(D,pNc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else L=qNc(f[C>>2]|0)|0;if(xQc(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;qNc(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=aQc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else M=qNc(f[o>>2]|0)|0;if(_Nc(M,pNc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else O=qNc(f[M>>2]|0)|0;if(!(_Nc(O,pNc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function GQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;EQc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=qNc(f[v>>2]|0)|0;if(_Nc(y,pNc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=qNc(f[C>>2]|0)|0;if(!(_Nc(D,pNc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else L=qNc(f[C>>2]|0)|0;if(xQc(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;qNc(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=cQc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else M=qNc(f[o>>2]|0)|0;if(_Nc(M,pNc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else O=qNc(f[M>>2]|0)|0;if(!(_Nc(O,pNc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function HQc(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=YPc(g)|0;EQc(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;uYc(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=t;t=w;y=w;a:while(1){if(t){w=f[t+12>>2]|0;if((w|0)==(f[t+16>>2]|0))z=_i[f[(f[t>>2]|0)+36>>2]&2047](t)|0;else z=qNc(f[w>>2]|0)|0;if(_Nc(z,pNc()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=t;B=y;C=0}}else{A=0;B=0;C=1}w=f[e>>2]|0;do if(w){D=f[w+12>>2]|0;if((D|0)==(f[w+16>>2]|0))E=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else E=qNc(f[D>>2]|0)|0;if(!(_Nc(E,pNc()|0)|0))if(C){F=w;break}else{G=x;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=x;H=0;break}else F=0}w=b[g>>0]|0;D=w<<24>>24<0?f[v>>2]|0:w&255;if((f[n>>2]|0)==(x+D|0)){uYc(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;uYc(m,J,0);w=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+D;K=w}else K=x;w=A+12|0;D=f[w>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else M=qNc(f[D>>2]|0)|0;if(xQc(M,r,K,n,q,f[k>>2]|0,l,o,p,j)|0){G=K;H=F;break}D=f[w>>2]|0;if((D|0)==(f[L>>2]|0)){_i[f[(f[A>>2]|0)+40>>2]&2047](A)|0;x=K;t=A;y=B;continue}else{f[w>>2]=D+4;qNc(f[D>>2]|0)|0;x=K;t=A;y=B;continue}}y=b[l+11>>0]|0;if((y<<24>>24<0?f[l+4>>2]|0:y&255)|0?(y=f[p>>2]|0,(y-o|0)<160):0){t=f[q>>2]|0;f[p>>2]=y+4;f[y>>2]=t}t=eQc(G,f[n>>2]|0,h,r)|0;d[i>>1]=t;SPc(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=_i[f[(f[B>>2]|0)+36>>2]&2047](A)|0;else N=qNc(f[p>>2]|0)|0;if(_Nc(N,pNc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(H){N=f[H+12>>2]|0;if((N|0)==(f[H+16>>2]|0))P=_i[f[(f[H>>2]|0)+36>>2]&2047](H)|0;else P=qNc(f[N>>2]|0)|0;if(!(_Nc(P,pNc()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;nYc(m);nYc(l);u=a;return h|0}function IQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;EQc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=qNc(f[v>>2]|0)|0;if(_Nc(y,pNc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=qNc(f[C>>2]|0)|0;if(!(_Nc(D,pNc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else M=qNc(f[C>>2]|0)|0;if(xQc(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+4;qNc(f[C>>2]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=gQc(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else N=qNc(f[o>>2]|0)|0;if(_Nc(N,pNc()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else P=qNc(f[N>>2]|0)|0;if(!(_Nc(P,pNc()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function JQc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=YPc(e)|0;EQc(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;uYc(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else y=qNc(f[v>>2]|0)|0;if(_Nc(y,pNc()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else D=qNc(f[C>>2]|0)|0;if(!(_Nc(D,pNc()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){uYc(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;uYc(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else L=qNc(f[C>>2]|0)|0;if(xQc(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){_i[f[(f[z>>2]|0)+40>>2]&2047](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;qNc(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=iQc(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;SPc(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=_i[f[(f[A>>2]|0)+36>>2]&2047](z)|0;else M=qNc(f[o>>2]|0)|0;if(_Nc(M,pNc()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=_i[f[(f[G>>2]|0)+36>>2]&2047](G)|0;else O=qNc(f[M>>2]|0)|0;if(!(_Nc(O,pNc()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;nYc(l);nYc(k);u=a;return g|0}function KQc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=jIc(l)|0;if(!m)eYc();else{n=m;o=m}}else{n=k;o=0}k=0;m=l;l=d;p=n;while(1){if((l|0)==(e|0))break;q=b[l+8+3>>0]|0;if(q<<24>>24<0)r=f[l+4>>2]|0;else r=q&255;if(!r){b[p>>0]=2;s=k+1|0;t=m+-1|0}else{b[p>>0]=1;s=k;t=m}k=s;m=t;l=l+12|0;p=p+1|0}p=0;l=k;k=m;a:while(1){m=f[a>>2]|0;do if(m){t=f[m+12>>2]|0;if((t|0)==(f[m+16>>2]|0))v=_i[f[(f[m>>2]|0)+36>>2]&2047](m)|0;else v=qNc(f[t>>2]|0)|0;if(_Nc(v,pNc()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);m=f[c>>2]|0;if(m){t=f[m+12>>2]|0;if((t|0)==(f[m+16>>2]|0))x=_i[f[(f[m>>2]|0)+36>>2]&2047](m)|0;else x=qNc(f[t>>2]|0)|0;if(_Nc(x,pNc()|0)|0){f[c>>2]=0;y=0;z=1}else{y=m;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((k|0)!=0&(w^z)))break;m=f[A+12>>2]|0;if((m|0)==(f[A+16>>2]|0))B=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else B=qNc(f[m>>2]|0)|0;if(i)C=B;else C=Mi[f[(f[g>>2]|0)+28>>2]&1023](g,B)|0;m=p+1|0;t=d;s=0;r=n;q=l;D=k;while(1){if((t|0)==(e|0))break;do if((b[r>>0]|0)==1){E=t+8+3|0;if((b[E>>0]|0)<0)F=f[t>>2]|0;else F=t;G=f[F+(p<<2)>>2]|0;if(i)H=G;else H=Mi[f[(f[g>>2]|0)+28>>2]&1023](g,G)|0;G=D+-1|0;if((C|0)!=(H|0)){b[r>>0]=0;I=s;J=q;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[t+4>>2]|0;else M=L&255;if((M|0)==(m|0)){b[r>>0]=2;I=1;J=q+1|0;K=G}else{I=1;J=q;K=D}}else{I=s;J=q;K=D}while(0);t=t+12|0;s=I;r=r+1|0;q=J;D=K}if(!s){p=m;l=q;k=D;continue}r=f[a>>2]|0;t=r+12|0;G=f[t>>2]|0;if((G|0)==(f[r+16>>2]|0))_i[f[(f[r>>2]|0)+40>>2]&2047](r)|0;else{f[t>>2]=G+4;qNc(f[G>>2]|0)|0}if((q+D|0)>>>0>1){N=d;O=n;P=q}else{p=m;l=q;k=D;continue}while(1){if((N|0)==(e|0)){p=m;l=P;k=D;continue a}if((b[O>>0]|0)==2){G=b[N+8+3>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(m|0)){b[O>>0]=0;R=P+-1|0}else R=P}else R=P;N=N+12|0;O=O+1|0;P=R}}do if(A){R=f[A+12>>2]|0;if((R|0)==(f[A+16>>2]|0))S=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else S=qNc(f[R>>2]|0)|0;if(_Nc(S,pNc()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else U=qNc(f[a>>2]|0)|0;if(!(_Nc(U,pNc()|0)|0))if(T){V=d;W=n;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=n}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=n}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}kIc(o);u=j;return Y|0}function LQc(a){a=a|0;jPc(a);return}function MQc(a){a=a|0;jPc(a);cYc(a);return}function NQc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=_h[k&127](a,i,d,e,g&1)|0}else{ZNc(i,d);d=DPc(i,896104)|0;EPc(i);e=f[d>>2]|0;if(g)mi[f[e+24>>2]&2047](i,d);else mi[f[e+28>>2]&2047](i,d);d=i+11|0;e=b[d>>0]|0;if(e<<24>>24<0){m=e;n=f[i>>2]|0;o=8}else{p=i;q=e}while(1){if((o|0)==8){o=0;p=n;q=m}e=q<<24>>24<0;if((p|0)==((e?f[i>>2]|0:i)+(e?f[i+4>>2]|0:q&255)|0))break;e=b[p>>0]|0;g=f[c>>2]|0;if(g|0){a=g+24|0;k=f[a>>2]|0;if((k|0)==(f[g+28>>2]|0)){j=f[(f[g>>2]|0)+52>>2]|0;r=_Mc(e)|0;s=Mi[j&1023](g,r)|0}else{f[a>>2]=k+1;b[k>>0]=e;s=_Mc(e)|0}if(YNc(s,ZMc()|0)|0)f[c>>2]=0}m=b[d>>0]|0;n=p+1|0;o=8}o=f[c>>2]|0;nYc(i);l=o}u=h;return l|0}function OQc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+39|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[525150]|0;b[i+1>>0]=b[525151]|0;b[i+2>>0]=b[525152]|0;b[i+3>>0]=b[525153]|0;b[i+4>>0]=b[525154]|0;b[i+5>>0]=b[525155]|0;_Qc(i+1|0,529314,1,f[d+4>>2]|0);o=GPc()|0;f[h>>2]=g;g=j+(VQc(j,13,o,i,h)|0)|0;i=WQc(j,g,d)|0;ZNc(h,d);$Qc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=EM(h,k,c,l,d,e)|0;u=a;return n|0}function PQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;_Qc(i+1|0,529319,1,f[c+4>>2]|0);o=GPc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(VQc(j,23,o,i,h)|0)|0;i=WQc(j,g,c)|0;ZNc(h,c);$Qc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=EM(h,k,b,l,c,d)|0;u=a;return n|0}function QQc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+40|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[525150]|0;b[i+1>>0]=b[525151]|0;b[i+2>>0]=b[525152]|0;b[i+3>>0]=b[525153]|0;b[i+4>>0]=b[525154]|0;b[i+5>>0]=b[525155]|0;_Qc(i+1|0,529314,0,f[d+4>>2]|0);o=GPc()|0;f[h>>2]=g;g=j+(VQc(j,12,o,i,h)|0)|0;i=WQc(j,g,d)|0;ZNc(h,d);$Qc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=EM(h,k,c,l,d,e)|0;u=a;return n|0}function RQc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;_Qc(i+1|0,529319,0,f[c+4>>2]|0);o=GPc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(VQc(j,23,o,i,h)|0)|0;i=WQc(j,g,c)|0;ZNc(h,c);$Qc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=EM(h,k,b,l,c,d)|0;u=a;return n|0}function SQc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=XQc(l+1|0,1165591,f[c+4>>2]|0)|0;f[n>>2]=m;v=GPc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=VQc(m,30,v,l,k)|0}else{p[j>>3]=e;w=VQc(m,30,v,l,j)|0}if((w|0)>29){j=GPc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=YQc(n,j,l,i)|0}else{p[h>>3]=e;x=YQc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)eYc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=WQc(A,n,c)|0;if((A|0)!=(m|0)){m=jIc(y<<1)|0;if(!m)eYc();else{B=m;C=m}}else{B=o;C=0}ZNc(g,c);ZQc(A,w,n,B,q,r,g);EPc(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=EM(g,B,b,q,c,d)|0;kIc(C);kIc(z);u=a;return s|0}function TQc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=XQc(l+1|0,525148,f[c+4>>2]|0)|0;f[n>>2]=m;v=GPc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=VQc(m,30,v,l,k)|0}else{p[j>>3]=e;w=VQc(m,30,v,l,j)|0}if((w|0)>29){j=GPc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=YQc(n,j,l,i)|0}else{p[h>>3]=e;x=YQc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)eYc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=WQc(A,n,c)|0;if((A|0)!=(m|0)){m=jIc(y<<1)|0;if(!m)eYc();else{B=m;C=m}}else{B=o;C=0}ZNc(g,c);ZQc(A,w,n,B,q,r,g);EPc(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=EM(g,B,b,q,c,d)|0;kIc(C);kIc(z);u=a;return s|0}function UQc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+80|0;h=a;i=a+68|0;j=a+48|0;k=a+8|0;l=a+4|0;b[i>>0]=b[525142]|0;b[i+1>>0]=b[525143]|0;b[i+2>>0]=b[525144]|0;b[i+3>>0]=b[525145]|0;b[i+4>>0]=b[525146]|0;b[i+5>>0]=b[525147]|0;m=GPc()|0;f[h>>2]=g;g=VQc(j,20,m,i,h)|0;i=j+g|0;m=WQc(j,i,d)|0;ZNc(h,d);n=DPc(h,896088)|0;EPc(h);hh[f[(f[n>>2]|0)+32>>2]&127](n,j,i,k)|0;n=k+g|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=EM(h,k,(m|0)==(i|0)?n:k+(m-j)|0,n,d,e)|0;u=a;return l|0}function VQc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=e;e=$Jc(c)|0;c=pJc(a,b,d,h)|0;if(e|0)$Jc(e)|0;u=g;return c|0}function WQc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;a:do switch((f[d+4>>2]&176)<<24>>24){case 16:{e=b[a>>0]|0;g=a+1|0;switch(e<<24>>24){case 43:case 45:{h=g;break a;break}default:{}}if((c-a|0)>1&e<<24>>24==48){switch(b[g>>0]|0){case 88:case 120:break;default:{i=6;break a}}h=a+2|0}else i=6;break}case 32:{h=c;break}default:i=6}while(0);if((i|0)==6)h=a;return h|0}function XQc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if(!(d&2048))e=a;else{b[a>>0]=43;e=a+1|0}if(!(d&1024))f=e;else{b[e>>0]=35;f=e+1|0}e=d&260;a=(d&16384|0)!=0;d=(e|0)==260;if(d){g=0;h=f}else{b[f>>0]=46;b[f+1>>0]=42;g=1;h=f+2|0}f=c;c=h;while(1){h=b[f>>0]|0;if(!(h<<24>>24))break;b[c>>0]=h;f=f+1|0;c=c+1|0}a:do switch(e&511){case 4:{i=a?70:102;break}case 256:{i=a?69:101;break}default:if(d){i=a?65:97;break a}else{i=a?71:103;break a}}while(0);b[c>>0]=i;return g|0}function YQc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=$Jc(b)|0;b=HLc(a,c,g)|0;if(d|0)$Jc(d)|0;u=e;return b|0}function ZQc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=u;u=u+16|0;k=j;l=DPc(i,896088)|0;m=DPc(i,896104)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+1;b[s>>0]=r;r=o+2|0;s=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(UJc(i,GPc()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(lJc(s,GPc()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=v;w=t;while(1){x=a+-1|0;if(w>>>0>=x>>>0)break d;y=b[w>>0]|0;b[w>>0]=b[x>>0]|0;b[x>>0]=y;a=x;w=w+1|0}}while(0);w=_i[f[(f[m>>2]|0)+16>>2]&2047](m)|0;a=t;x=0;y=0;while(1){if(a>>>0>=v>>>0)break;z=b[((b[p>>0]|0)<0?f[k>>2]|0:k)+y>>0]|0;if(z<<24>>24>0&(x|0)==(z<<24>>24|0)){z=f[h>>2]|0;f[h>>2]=z+1;b[z>>0]=w;z=b[p>>0]|0;A=(y>>>0<((z<<24>>24<0?f[s>>2]|0:z&255)+-1|0)>>>0&1)+y|0;B=0}else{A=y;B=x}z=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[a>>0]|0)|0;C=f[h>>2]|0;f[h>>2]=C+1;b[C>>0]=z;a=a+1|0;x=B+1|0;y=A}y=e+(r-i)|0;x=f[h>>2]|0;if((y|0)==(x|0))D=l;else{a=x;x=y;while(1){y=a+-1|0;if(x>>>0>=y>>>0){D=l;break c}w=b[x>>0]|0;b[x>>0]=b[y>>0]|0;b[y>>0]=w;a=y;x=x+1|0}}}else{hh[f[(f[l>>2]|0)+32>>2]&127](l,t,v,f[h>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(v-r);D=l}while(0);r=v;while(1){if(r>>>0>=d>>>0){E=r;break}v=b[r>>0]|0;F=r+1|0;if(v<<24>>24==46){q=29;break}t=Mi[f[(f[D>>2]|0)+28>>2]&1023](l,v)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=t;r=F}if((q|0)==29){q=_i[f[(f[m>>2]|0)+12>>2]&2047](m)|0;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=q;E=F}hh[f[(f[l>>2]|0)+32>>2]&127](l,E,d,f[h>>2]|0)|0;l=(f[h>>2]|0)+(n-E)|0;f[h>>2]=l;f[g>>2]=(c|0)==(d|0)?l:e+(c-i)|0;nYc(k);u=j;return}function _Qc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(!(e&2048))f=a;else{b[a>>0]=43;f=a+1|0}if(!(e&512)){g=c;h=f}else{b[f>>0]=35;g=c;h=f+1|0}while(1){f=b[g>>0]|0;if(!(f<<24>>24))break;b[h>>0]=f;g=g+1|0;h=h+1|0}switch(e&74){case 64:{i=111;break}case 8:{i=e&16384|0?88:120;break}default:i=d?100:117}b[h>>0]=i;return}function $Qc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+16|0;k=j;l=DPc(i,896088)|0;m=DPc(i,896104)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+1;b[n>>0]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;n=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+1;b[r>>0]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=d;n=t;while(1){r=s+-1|0;if(n>>>0>=r>>>0)break b;v=b[n>>0]|0;b[n>>0]=b[r>>0]|0;b[r>>0]=v;s=r;n=n+1|0}}while(0);n=_i[f[(f[m>>2]|0)+16>>2]&2047](m)|0;m=t;s=0;r=0;while(1){if(m>>>0>=d>>>0)break;v=b[((b[i>>0]|0)<0?f[k>>2]|0:k)+s>>0]|0;if(v<<24>>24!=0&(r|0)==(v<<24>>24|0)){v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;v=b[i>>0]|0;w=(s>>>0<((v<<24>>24<0?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0;x=0}else{w=s;x=r}v=Mi[f[(f[l>>2]|0)+28>>2]&1023](l,b[m>>0]|0)|0;y=f[h>>2]|0;f[h>>2]=y+1;b[y>>0]=v;m=m+1|0;s=w;r=x+1|0}x=e+(t-p)|0;t=f[h>>2]|0;if((x|0)==(t|0))z=x;else{r=t;t=x;while(1){x=r+-1|0;if(t>>>0>=x>>>0)break;w=b[t>>0]|0;b[t>>0]=b[x>>0]|0;b[x>>0]=w;r=x;t=t+1|0}z=f[h>>2]|0}}else{hh[f[(f[l>>2]|0)+32>>2]&127](l,a,d,e)|0;a=e+(q-p)|0;f[h>>2]=a;z=a}f[g>>2]=(c|0)==(d|0)?z:e+(c-p)|0;nYc(k);u=j;return}function aRc(a){a=a|0;jPc(a);return}function bRc(a){a=a|0;jPc(a);cYc(a);return}function cRc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=_h[k&127](a,i,d,e,g&1)|0}else{ZNc(i,d);d=DPc(i,896128)|0;EPc(i);e=f[d>>2]|0;if(g)mi[f[e+24>>2]&2047](i,d);else mi[f[e+28>>2]&2047](i,d);d=i+8+3|0;e=b[d>>0]|0;g=f[i>>2]|0;a=i+4|0;k=e<<24>>24<0?g:i;j=e;e=g;while(1){g=j<<24>>24<0;if((k|0)==((g?e:i)+((g?f[a>>2]|0:j&255)<<2)|0))break;g=f[k>>2]|0;m=f[c>>2]|0;if(m|0){n=m+24|0;o=f[n>>2]|0;if((o|0)==(f[m+28>>2]|0)){p=f[(f[m>>2]|0)+52>>2]|0;q=qNc(g)|0;r=Mi[p&1023](m,q)|0}else{f[n>>2]=o+4;f[o>>2]=g;r=qNc(g)|0}if(_Nc(r,pNc()|0)|0)f[c>>2]=0}k=k+4|0;j=b[d>>0]|0;e=f[i>>2]|0}e=f[c>>2]|0;NYc(i);l=e}u=h;return l|0}function dRc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+122|0;j=a+108|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[525150]|0;b[i+1>>0]=b[525151]|0;b[i+2>>0]=b[525152]|0;b[i+3>>0]=b[525153]|0;b[i+4>>0]=b[525154]|0;b[i+5>>0]=b[525155]|0;_Qc(i+1|0,529314,1,f[d+4>>2]|0);o=GPc()|0;f[h>>2]=g;g=j+(VQc(j,13,o,i,h)|0)|0;i=WQc(j,g,d)|0;ZNc(h,d);nRc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=kRc(h,k,c,l,d,e)|0;u=a;return n|0}function eRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;_Qc(i+1|0,529319,1,f[c+4>>2]|0);o=GPc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(VQc(j,23,o,i,h)|0)|0;i=WQc(j,g,c)|0;ZNc(h,c);nRc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=kRc(h,k,b,l,c,d)|0;u=a;return n|0}function fRc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+112|0;j=a+100|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[525150]|0;b[i+1>>0]=b[525151]|0;b[i+2>>0]=b[525152]|0;b[i+3>>0]=b[525153]|0;b[i+4>>0]=b[525154]|0;b[i+5>>0]=b[525155]|0;_Qc(i+1|0,529314,0,f[d+4>>2]|0);o=GPc()|0;f[h>>2]=g;g=j+(VQc(j,12,o,i,h)|0)|0;i=WQc(j,g,d)|0;ZNc(h,d);nRc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=kRc(h,k,c,l,d,e)|0;u=a;return n|0}function gRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;_Qc(i+1|0,529319,0,f[c+4>>2]|0);o=GPc()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(VQc(j,23,o,i,h)|0)|0;i=WQc(j,g,c)|0;ZNc(h,c);nRc(j,i,g,k,l,m,h);EPc(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=kRc(h,k,b,l,c,d)|0;u=a;return n|0}function hRc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=XQc(l+1|0,1165591,f[c+4>>2]|0)|0;f[n>>2]=m;v=GPc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=VQc(m,30,v,l,k)|0}else{p[j>>3]=e;w=VQc(m,30,v,l,j)|0}if((w|0)>29){j=GPc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=YQc(n,j,l,i)|0}else{p[h>>3]=e;x=YQc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)eYc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=WQc(A,n,c)|0;do if((A|0)!=(m|0)){h=jIc(y<<3)|0;if(!h)eYc();else{B=h;C=0;D=h;break}}else{B=o;C=1;D=0}while(0);ZNc(g,c);mRc(A,w,n,B,q,r,g);EPc(g);f[s>>2]=f[b>>2];n=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=kRc(g,B,n,q,c,d)|0;f[b>>2]=s;if(!C)kIc(D);kIc(z);u=a;return s|0}function iRc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=XQc(l+1|0,525148,f[c+4>>2]|0)|0;f[n>>2]=m;v=GPc()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=VQc(m,30,v,l,k)|0}else{p[j>>3]=e;w=VQc(m,30,v,l,j)|0}if((w|0)>29){j=GPc()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=YQc(n,j,l,i)|0}else{p[h>>3]=e;x=YQc(n,j,l,h)|0}h=f[n>>2]|0;if(!h)eYc();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=WQc(A,n,c)|0;do if((A|0)!=(m|0)){h=jIc(y<<3)|0;if(!h)eYc();else{B=h;C=0;D=h;break}}else{B=o;C=1;D=0}while(0);ZNc(g,c);mRc(A,w,n,B,q,r,g);EPc(g);f[s>>2]=f[b>>2];n=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=kRc(g,B,n,q,c,d)|0;f[b>>2]=s;if(!C)kIc(D);kIc(z);u=a;return s|0}function jRc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+192|0;h=a;i=a+176|0;j=a+156|0;k=a+4|0;l=a+152|0;b[i>>0]=b[525142]|0;b[i+1>>0]=b[525143]|0;b[i+2>>0]=b[525144]|0;b[i+3>>0]=b[525145]|0;b[i+4>>0]=b[525146]|0;b[i+5>>0]=b[525147]|0;m=GPc()|0;f[h>>2]=g;g=VQc(j,20,m,i,h)|0;i=j+g|0;m=WQc(j,i,d)|0;ZNc(h,d);n=DPc(h,896120)|0;EPc(h);hh[f[(f[n>>2]|0)+48>>2]&127](n,j,i,k)|0;n=k+(g<<2)|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=kRc(h,k,(m|0)==(i|0)?n:k+(m-j<<2)|0,n,d,e)|0;u=a;return l|0}function kRc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;i=u;u=u+16|0;j=i+12|0;k=i;l=f[a>>2]|0;a:do if(!l)m=0;else{n=e;o=c;p=n-o>>2;q=g+12|0;r=f[q>>2]|0;s=(r|0)>(p|0)?r-p|0:0;p=d;r=p-o|0;o=r>>2;if((r|0)>0?(hj[f[(f[l>>2]|0)+48>>2]&511](l,c,o)|0)!=(o|0):0){f[a>>2]=0;m=0;break}do if((s|0)>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0>1073741807)jYc(k);do if(s>>>0>=2){o=s+4&2147483644;if(o>>>0>1073741823)tf();else{r=$Xc(o<<2)|0;f[k>>2]=r;t=k+8|0;f[t>>2]=o|-2147483648;f[k+4>>2]=s;v=r;w=t+3|0;x=k;break}}else{t=k+8+3|0;b[t>>0]=s;v=k;w=t;x=k}while(0);lRc(v,s,h)|0;f[j>>2]=0;pPc(v+(s<<2)|0,j);if((hj[f[(f[l>>2]|0)+48>>2]&511](l,(b[w>>0]|0)<0?f[k>>2]|0:x,s)|0)==(s|0)){NYc(k);break}else{f[a>>2]=0;NYc(k);m=0;break a}}while(0);s=n-p|0;t=s>>2;if((s|0)>0?(hj[f[(f[l>>2]|0)+48>>2]&511](l,d,t)|0)!=(t|0):0){f[a>>2]=0;m=0;break}f[q>>2]=0;m=l}while(0);u=i;return m|0}function lRc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!b)d=a;else{ZKc(a,c,b)|0;d=a}return d|0}function mRc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+16|0;k=j;l=DPc(i,896120)|0;m=DPc(i,896128)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+4;f[s>>2]=r;r=o+2|0;s=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(UJc(i,GPc()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(lJc(s,GPc()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=v;w=t;while(1){x=a+-1|0;if(w>>>0>=x>>>0)break d;y=b[w>>0]|0;b[w>>0]=b[x>>0]|0;b[x>>0]=y;a=x;w=w+1|0}}while(0);w=_i[f[(f[m>>2]|0)+16>>2]&2047](m)|0;a=t;x=0;y=0;while(1){if(a>>>0>=v>>>0)break;z=b[p>>0]|0;A=z<<24>>24<0;B=b[(A?f[k>>2]|0:k)+x>>0]|0;if(B<<24>>24>0&(y|0)==(B<<24>>24|0)){B=f[h>>2]|0;f[h>>2]=B+4;f[B>>2]=w;C=(x>>>0<((A?f[s>>2]|0:z&255)+-1|0)>>>0&1)+x|0;D=0}else{C=x;D=y}z=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[a>>0]|0)|0;A=f[h>>2]|0;f[h>>2]=A+4;f[A>>2]=z;a=a+1|0;x=C;y=D+1|0}y=e+(r-i<<2)|0;x=f[h>>2]|0;if((y|0)==(x|0)){E=l;F=y}else{a=x;w=y;while(1){y=a+-4|0;if(w>>>0>=y>>>0){E=l;F=x;break c}z=f[w>>2]|0;f[w>>2]=f[y>>2];f[y>>2]=z;a=y;w=w+4|0}}}else{hh[f[(f[l>>2]|0)+48>>2]&127](l,t,v,f[h>>2]|0)|0;w=(f[h>>2]|0)+(v-r<<2)|0;f[h>>2]=w;E=l;F=w}while(0);r=v;v=F;while(1){if(r>>>0>=d>>>0){G=r;H=v;break}F=b[r>>0]|0;I=r+1|0;if(F<<24>>24==46){q=29;break}t=Mi[f[(f[E>>2]|0)+44>>2]&1023](l,F)|0;F=f[h>>2]|0;D=F+4|0;f[h>>2]=D;f[F>>2]=t;r=I;v=D}if((q|0)==29){q=_i[f[(f[m>>2]|0)+12>>2]&2047](m)|0;m=f[h>>2]|0;v=m+4|0;f[h>>2]=v;f[m>>2]=q;G=I;H=v}hh[f[(f[l>>2]|0)+48>>2]&127](l,G,d,H)|0;H=(f[h>>2]|0)+(n-G<<2)|0;f[h>>2]=H;f[g>>2]=(c|0)==(d|0)?H:e+(c-i<<2)|0;nYc(k);u=j;return}function nRc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;j=u;u=u+16|0;k=j;l=DPc(i,896120)|0;m=DPc(i,896128)|0;mi[f[(f[m>>2]|0)+20>>2]&2047](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+4;f[n>>2]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+4;f[v>>2]=n;n=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+4;f[r>>2]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=d;n=t;while(1){r=s+-1|0;if(n>>>0>=r>>>0)break b;v=b[n>>0]|0;b[n>>0]=b[r>>0]|0;b[r>>0]=v;s=r;n=n+1|0}}while(0);n=_i[f[(f[m>>2]|0)+16>>2]&2047](m)|0;m=t;s=0;r=0;while(1){if(m>>>0>=d>>>0)break;v=b[i>>0]|0;w=v<<24>>24<0;x=b[(w?f[k>>2]|0:k)+s>>0]|0;if(x<<24>>24!=0&(r|0)==(x<<24>>24|0)){x=f[h>>2]|0;f[h>>2]=x+4;f[x>>2]=n;y=(s>>>0<((w?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0;z=0}else{y=s;z=r}v=Mi[f[(f[l>>2]|0)+44>>2]&1023](l,b[m>>0]|0)|0;w=f[h>>2]|0;f[h>>2]=w+4;f[w>>2]=v;m=m+1|0;s=y;r=z+1|0}z=e+(t-p<<2)|0;t=f[h>>2]|0;if((z|0)==(t|0))A=z;else{r=t;t=z;while(1){z=r+-4|0;if(t>>>0>=z>>>0)break;y=f[t>>2]|0;f[t>>2]=f[z>>2];f[z>>2]=y;r=z;t=t+4|0}A=f[h>>2]|0}}else{hh[f[(f[l>>2]|0)+48>>2]&127](l,a,d,e)|0;a=e+(q-p<<2)|0;f[h>>2]=a;A=a}f[g>>2]=(c|0)==(d|0)?A:e+(c-p<<2)|0;nYc(k);u=j;return}function oRc(a){a=a|0;jPc(a);return}function pRc(a){a=a|0;jPc(a);cYc(a);return}function qRc(a){a=a|0;return 2}function rRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=MRc(a,j,i,d,e,g,525673,525681)|0;u=h;return l|0}function sRc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=_i[f[(f[n>>2]|0)+20>>2]&2047](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+11>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+(c?f[o+4>>2]|0:d&255)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=MRc(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function tRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;ZNc(i,d);d=DPc(i,896088)|0;EPc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];KRc(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function uRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;ZNc(i,d);d=DPc(i,896088)|0;EPc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];LRc(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function vRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;ZNc(i,d);d=DPc(i,896088)|0;EPc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];XRc(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function wRc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;ZNc(k,e);S=DPc(k,896088)|0;EPc(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];KRc(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];LRc(a,V,c,k,g,S);Y=26;break}case 99:{Z=_i[f[(f[X>>2]|0)+12>>2]&2047](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+11>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+($?f[Z+4>>2]|0:_&255)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=MRc(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];NRc(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=MRc(a,l,k,e,g,h,525633,525641)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=MRc(a,l,k,e,g,h,525641,525649)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];ORc(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];PRc(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];QRc(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];RRc(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];SRc(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];TRc(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];URc(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=MRc(a,l,k,e,g,h,525649,525660)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=MRc(a,l,k,e,g,h,525660,525665)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];VRc(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=MRc(a,l,k,e,g,h,525665,525673)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];WRc(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=xg[_&127](a,l,k,e,g,h)|0;break}case 88:{_=_i[f[(f[X>>2]|0)+24>>2]&2047](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+11>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+(aa?f[_+4>>2]|0:ba&255)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=MRc(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];XRc(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];YRc(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];ZRc(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function xRc(a){a=a|0;if((b[539576]|0)==0?X0c(539576)|0:0){IRc();f[224240]=896792}return f[224240]|0}function yRc(a){a=a|0;if((b[539560]|0)==0?X0c(539560)|0:0){GRc();f[224197]=896500}return f[224197]|0}function zRc(a){a=a|0;if((b[539544]|0)==0?X0c(539544)|0:0){ERc();f[224124]=896208}return f[224124]|0}function ARc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539536]|0)==0?X0c(539536)|0:0){f[224049]=0;f[224050]=0;f[224051]=0;d=UNc(525391)|0;if(d>>>0>4294967279)jYc(896196);if(d>>>0<11){b[896207]=d;e=896196}else{g=d+16&-16;h=$Xc(g)|0;f[224049]=h;f[224051]=g|-2147483648;f[224050]=d;e=h}$Mc(e,525391,d)|0;b[c>>0]=0;VNc(e+d|0,c);be(2220,896196,x|0)|0}u=a;return 896196}function BRc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539528]|0)==0?X0c(539528)|0:0){f[224046]=0;f[224047]=0;f[224048]=0;d=UNc(525379)|0;if(d>>>0>4294967279)jYc(896184);if(d>>>0<11){b[896195]=d;e=896184}else{g=d+16&-16;h=$Xc(g)|0;f[224046]=h;f[224048]=g|-2147483648;f[224047]=d;e=h}$Mc(e,525379,d)|0;b[c>>0]=0;VNc(e+d|0,c);be(2220,896184,x|0)|0}u=a;return 896184}function CRc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539520]|0)==0?X0c(539520)|0:0){f[224043]=0;f[224044]=0;f[224045]=0;d=UNc(525370)|0;if(d>>>0>4294967279)jYc(896172);if(d>>>0<11){b[896183]=d;e=896172}else{g=d+16&-16;h=$Xc(g)|0;f[224043]=h;f[224045]=g|-2147483648;f[224044]=d;e=h}$Mc(e,525370,d)|0;b[c>>0]=0;VNc(e+d|0,c);be(2220,896172,x|0)|0}u=a;return 896172}function DRc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539512]|0)==0?X0c(539512)|0:0){f[224040]=0;f[224041]=0;f[224042]=0;d=UNc(525361)|0;if(d>>>0>4294967279)jYc(896160);if(d>>>0<11){b[896171]=d;e=896160}else{g=d+16&-16;h=$Xc(g)|0;f[224040]=h;f[224042]=g|-2147483648;f[224041]=d;e=h}$Mc(e,525361,d)|0;b[c>>0]=0;VNc(e+d|0,c);be(2220,896160,x|0)|0}u=a;return 896160}function ERc(){var a=0,c=0;if((b[539552]|0)==0?X0c(539552)|0:0){a=896208;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=896496);be(2292,0,x|0)|0}tYc(896208,525412)|0;tYc(896220,525415)|0;return}function FRc(a){a=a|0;a=896496;do{a=a+-12|0;nYc(a)}while((a|0)!=896208);return}function GRc(){var a=0,c=0;if((b[539568]|0)==0?X0c(539568)|0:0){a=896500;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=896788);be(2293,0,x|0)|0}tYc(896500,525418)|0;tYc(896512,525426)|0;tYc(896524,525435)|0;tYc(896536,525441)|0;tYc(896548,525447)|0;tYc(896560,525451)|0;tYc(896572,525456)|0;tYc(896584,525461)|0;tYc(896596,525468)|0;tYc(896608,525478)|0;tYc(896620,525486)|0;tYc(896632,525495)|0;tYc(896644,525504)|0;tYc(896656,525508)|0;tYc(896668,525512)|0;tYc(896680,525516)|0;tYc(896692,525447)|0;tYc(896704,525520)|0;tYc(896716,525524)|0;tYc(896728,525528)|0;tYc(896740,525532)|0;tYc(896752,525536)|0;tYc(896764,525540)|0;tYc(896776,525544)|0;return}function HRc(a){a=a|0;a=896788;do{a=a+-12|0;nYc(a)}while((a|0)!=896500);return}function IRc(){var a=0,c=0;if((b[539584]|0)==0?X0c(539584)|0:0){a=896792;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=896960);be(2294,0,x|0)|0}tYc(896792,525548)|0;tYc(896804,525555)|0;tYc(896816,525562)|0;tYc(896828,525570)|0;tYc(896840,525580)|0;tYc(896852,525589)|0;tYc(896864,525596)|0;tYc(896876,525605)|0;tYc(896888,525609)|0;tYc(896900,525613)|0;tYc(896912,525617)|0;tYc(896924,525621)|0;tYc(896936,525625)|0;tYc(896948,525629)|0;return}function JRc(a){a=a|0;a=896960;do{a=a+-12|0;nYc(a)}while((a|0)!=896792);return}function KRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[f[k>>2]>>2]&2047](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(jQc(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function LRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[(f[k>>2]|0)+4>>2]&2047](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(jQc(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function MRc(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;l=u;u=u+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;ZNc(m,g);q=DPc(m,896088)|0;EPc(m);f[h>>2]=0;r=q+8|0;s=j;j=0;a:while(1){t=(s|0)!=(k|0);v=j;while(1){w=f[c>>2]|0;if(!(t&(v|0)==0)){x=w;break a}y=w;if(w){z=f[w+12>>2]|0;if((z|0)==(f[w+16>>2]|0))A=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else A=_Mc(b[z>>0]|0)|0;if(YNc(A,ZMc()|0)|0){f[c>>2]=0;B=0;C=1;D=0}else{B=w;C=0;D=y}}else{B=0;C=1;D=y}y=f[e>>2]|0;w=y;do if(y){z=f[y+12>>2]|0;if((z|0)==(f[y+16>>2]|0))E=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else E=_Mc(b[z>>0]|0)|0;if(!(YNc(E,ZMc()|0)|0))if(C){F=y;G=w;break}else{H=61;break a}else{f[e>>2]=0;I=0;H=16;break}}else{I=w;H=16}while(0);if((H|0)==16){H=0;if(C){H=61;break a}else{F=0;G=I}}if((hj[f[(f[q>>2]|0)+36>>2]&511](q,b[s>>0]|0,0)|0)<<24>>24==37){H=19;break}w=b[s>>0]|0;if(w<<24>>24>-1?(J=f[r>>2]|0,d[J+(w<<24>>24<<1)>>1]&8192):0){K=s;H=27;break}L=B+12|0;w=f[L>>2]|0;M=B+16|0;if((w|0)==(f[M>>2]|0))N=_i[f[(f[B>>2]|0)+36>>2]&2047](B)|0;else N=_Mc(b[w>>0]|0)|0;w=Mi[f[(f[q>>2]|0)+12>>2]&1023](q,N&255)|0;if(w<<24>>24==(Mi[f[(f[q>>2]|0)+12>>2]&1023](q,b[s>>0]|0)|0)<<24>>24){H=57;break}f[h>>2]=4;v=4}b:do if((H|0)==19){H=0;v=s+1|0;if((v|0)==(k|0)){H=61;break a}t=hj[f[(f[q>>2]|0)+36>>2]&511](q,b[v>>0]|0,0)|0;switch(t<<24>>24){case 48:case 69:{w=s+2|0;if((w|0)==(k|0)){H=61;break a}O=t;P=hj[f[(f[q>>2]|0)+36>>2]&511](q,b[w>>0]|0,0)|0;Q=v;break}default:{O=0;P=t;Q=s}}t=f[(f[a>>2]|0)+36>>2]|0;f[o>>2]=D;f[p>>2]=G;f[n>>2]=f[o>>2];f[m>>2]=f[p>>2];v=Gj[t&15](a,n,m,g,h,i,P,O)|0;f[c>>2]=v;R=Q+2|0}else if((H|0)==27){while(1){H=0;v=K+1|0;if((v|0)==(k|0)){S=k;break}t=b[v>>0]|0;if(t<<24>>24<=-1){S=v;break}if(!(d[J+(t<<24>>24<<1)>>1]&8192)){S=v;break}else{K=v;H=27}}v=B;t=F;w=F;while(1){if(v){y=f[v+12>>2]|0;if((y|0)==(f[v+16>>2]|0))T=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else T=_Mc(b[y>>0]|0)|0;if(YNc(T,ZMc()|0)|0){f[c>>2]=0;U=1;V=0}else{U=0;V=v}}else{U=1;V=0}do if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))W=_i[f[(f[w>>2]|0)+36>>2]&2047](w)|0;else W=_Mc(b[y>>0]|0)|0;if(!(YNc(W,ZMc()|0)|0))if(U^(t|0)==0){X=t;Y=t;break}else{R=S;break b}else{f[e>>2]=0;Z=0;H=43;break}}else{Z=t;H=43}while(0);if((H|0)==43){H=0;if(U){R=S;break b}else{X=Z;Y=0}}y=V+12|0;z=f[y>>2]|0;_=V+16|0;if((z|0)==(f[_>>2]|0))$=_i[f[(f[V>>2]|0)+36>>2]&2047](V)|0;else $=_Mc(b[z>>0]|0)|0;if(($&255)<<24>>24<=-1){R=S;break b}if(!(d[(f[r>>2]|0)+($<<24>>24<<1)>>1]&8192)){R=S;break b}z=f[y>>2]|0;if((z|0)==(f[_>>2]|0)){_i[f[(f[V>>2]|0)+40>>2]&2047](V)|0;v=V;t=X;w=Y;continue}else{f[y>>2]=z+1;_Mc(b[z>>0]|0)|0;v=V;t=X;w=Y;continue}}}else if((H|0)==57){H=0;w=s+1|0;t=f[L>>2]|0;if((t|0)==(f[M>>2]|0)){_i[f[(f[B>>2]|0)+40>>2]&2047](B)|0;R=w;break}else{f[L>>2]=t+1;_Mc(b[t>>0]|0)|0;R=w;break}}while(0);s=R;j=f[h>>2]|0}if((H|0)==61){f[h>>2]=4;x=B}if(x){B=f[x+12>>2]|0;if((B|0)==(f[x+16>>2]|0))aa=_i[f[(f[x>>2]|0)+36>>2]&2047](x)|0;else aa=_Mc(b[B>>0]|0)|0;if(YNc(aa,ZMc()|0)|0){f[c>>2]=0;ba=0;ca=1}else{ba=x;ca=0}}else{ba=0;ca=1}x=f[e>>2]|0;do if(x){c=f[x+12>>2]|0;if((c|0)==(f[x+16>>2]|0))da=_i[f[(f[x>>2]|0)+36>>2]&2047](x)|0;else da=_Mc(b[c>>0]|0)|0;if(!(YNc(da,ZMc()|0)|0))if(ca)break;else{H=76;break}else{f[e>>2]=0;H=74;break}}else H=74;while(0);if((H|0)==74?ca:0)H=76;if((H|0)==76)f[h>>2]=f[h>>2]|2;u=l;return ba|0}function NRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function ORc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function PRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function QRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function RRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function SRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function TRc(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=h+8|0;a:while(1){h=f[c>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))j=_i[f[(f[h>>2]|0)+36>>2]&2047](h)|0;else j=_Mc(b[i>>0]|0)|0;if(YNc(j,ZMc()|0)|0){f[c>>2]=0;k=1;break}else{k=(f[c>>2]|0)==0;break}}else k=1;while(0);h=f[e>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))l=_i[f[(f[h>>2]|0)+36>>2]&2047](h)|0;else l=_Mc(b[i>>0]|0)|0;if(!(YNc(l,ZMc()|0)|0))if(k){m=h;break}else{n=h;break a}else{f[e>>2]=0;o=15;break}}else o=15;while(0);if((o|0)==15){o=0;if(k){n=0;break}else m=0}h=f[c>>2]|0;i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))p=_i[f[(f[h>>2]|0)+36>>2]&2047](h)|0;else p=_Mc(b[i>>0]|0)|0;if((p&255)<<24>>24<=-1){n=m;break}if(!(d[(f[a>>2]|0)+(p<<24>>24<<1)>>1]&8192)){n=m;break}i=f[c>>2]|0;h=i+12|0;q=f[h>>2]|0;if((q|0)==(f[i+16>>2]|0)){_i[f[(f[i>>2]|0)+40>>2]&2047](i)|0;continue}else{f[h>>2]=q+1;_Mc(b[q>>0]|0)|0;continue}}m=f[c>>2]|0;do if(m){p=f[m+12>>2]|0;if((p|0)==(f[m+16>>2]|0))r=_i[f[(f[m>>2]|0)+36>>2]&2047](m)|0;else r=_Mc(b[p>>0]|0)|0;if(YNc(r,ZMc()|0)|0){f[c>>2]=0;s=1;break}else{s=(f[c>>2]|0)==0;break}}else s=1;while(0);do if(n){c=f[n+12>>2]|0;if((c|0)==(f[n+16>>2]|0))t=_i[f[(f[n>>2]|0)+36>>2]&2047](n)|0;else t=_Mc(b[c>>0]|0)|0;if(!(YNc(t,ZMc()|0)|0))if(s)break;else{o=40;break}else{f[e>>2]=0;o=38;break}}else o=38;while(0);if((o|0)==38?s:0)o=40;if((o|0)==40)f[g>>2]=f[g>>2]|2;return}function URc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=_i[f[(f[l>>2]|0)+8>>2]&2047](l)|0;l=b[a+11>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+12+11>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(jQc(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function VRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function WRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function XRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function YRc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=_Rc(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function ZRc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=f[c>>2]|0;do if(a){h=f[a+12>>2]|0;if((h|0)==(f[a+16>>2]|0))i=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;else i=_Mc(b[h>>0]|0)|0;if(YNc(i,ZMc()|0)|0){f[c>>2]=0;j=1;break}else{j=(f[c>>2]|0)==0;break}}else j=1;while(0);i=f[d>>2]|0;do if(i){a=f[i+12>>2]|0;if((a|0)==(f[i+16>>2]|0))k=_i[f[(f[i>>2]|0)+36>>2]&2047](i)|0;else k=_Mc(b[a>>0]|0)|0;if(!(YNc(k,ZMc()|0)|0))if(j){l=i;m=16;break}else{n=6;m=38;break}else{f[d>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j){n=6;m=38}else{l=0;m=16}a:do if((m|0)==16){j=f[c>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=_i[f[(f[j>>2]|0)+36>>2]&2047](j)|0;else o=_Mc(b[i>>0]|0)|0;if((hj[f[(f[g>>2]|0)+36>>2]&511](g,o&255,0)|0)<<24>>24==37){i=f[c>>2]|0;j=i+12|0;k=f[j>>2]|0;if((k|0)==(f[i+16>>2]|0))_i[f[(f[i>>2]|0)+40>>2]&2047](i)|0;else{f[j>>2]=k+1;_Mc(b[k>>0]|0)|0}k=f[c>>2]|0;do if(k){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))p=_i[f[(f[k>>2]|0)+36>>2]&2047](k)|0;else p=_Mc(b[j>>0]|0)|0;if(YNc(p,ZMc()|0)|0){f[c>>2]=0;q=1;break}else{q=(f[c>>2]|0)==0;break}}else q=1;while(0);do if(l|0){k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))r=_i[f[(f[l>>2]|0)+36>>2]&2047](l)|0;else r=_Mc(b[k>>0]|0)|0;if(!(YNc(r,ZMc()|0)|0))if(q)break a;else{n=2;m=38;break a}else{f[d>>2]=0;break}}while(0);if(q){n=2;m=38}}else{n=4;m=38}}while(0);if((m|0)==38)f[e>>2]=f[e>>2]|n;return}function _Rc(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=f[a>>2]|0;do if(i){j=f[i+12>>2]|0;if((j|0)==(f[i+16>>2]|0))k=_i[f[(f[i>>2]|0)+36>>2]&2047](i)|0;else k=_Mc(b[j>>0]|0)|0;if(YNc(k,ZMc()|0)|0){f[a>>2]=0;l=1;break}else{l=(f[a>>2]|0)==0;break}}else l=1;while(0);k=f[c>>2]|0;do if(k){i=f[k+12>>2]|0;if((i|0)==(f[k+16>>2]|0))m=_i[f[(f[k>>2]|0)+36>>2]&2047](k)|0;else m=_Mc(b[i>>0]|0)|0;if(!(YNc(m,ZMc()|0)|0))if(l){n=k;o=17;break}else{o=16;break}else{f[c>>2]=0;o=14;break}}else o=14;while(0);if((o|0)==14)if(l)o=16;else{n=0;o=17}a:do if((o|0)==16){f[e>>2]=f[e>>2]|6;p=0}else if((o|0)==17){l=f[a>>2]|0;k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))q=_i[f[(f[l>>2]|0)+36>>2]&2047](l)|0;else q=_Mc(b[k>>0]|0)|0;k=q&255;if(k<<24>>24>-1?(l=g+8|0,d[(f[l>>2]|0)+(q<<24>>24<<1)>>1]&2048):0){m=(hj[f[(f[g>>2]|0)+36>>2]&511](g,k,0)|0)<<24>>24;k=f[a>>2]|0;i=k+12|0;j=f[i>>2]|0;if((j|0)==(f[k+16>>2]|0)){_i[f[(f[k>>2]|0)+40>>2]&2047](k)|0;r=m;s=h;t=n;u=n}else{f[i>>2]=j+1;_Mc(b[j>>0]|0)|0;r=m;s=h;t=n;u=n}while(1){v=r+-48|0;m=s+-1|0;j=f[a>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))w=_i[f[(f[j>>2]|0)+36>>2]&2047](j)|0;else w=_Mc(b[i>>0]|0)|0;if(YNc(w,ZMc()|0)|0){f[a>>2]=0;x=1;break}else{x=(f[a>>2]|0)==0;break}}else x=1;while(0);do if(u){j=f[u+12>>2]|0;if((j|0)==(f[u+16>>2]|0))y=_i[f[(f[u>>2]|0)+36>>2]&2047](u)|0;else y=_Mc(b[j>>0]|0)|0;if(YNc(y,ZMc()|0)|0){f[c>>2]=0;z=0;A=1;B=0;break}else{z=t;A=(t|0)==0;B=t;break}}else{z=t;A=1;B=0}while(0);C=f[a>>2]|0;if(!((s|0)>1&(x^A)))break;j=f[C+12>>2]|0;if((j|0)==(f[C+16>>2]|0))D=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else D=_Mc(b[j>>0]|0)|0;j=D&255;if(j<<24>>24<=-1){p=v;break a}if(!(d[(f[l>>2]|0)+(D<<24>>24<<1)>>1]&2048)){p=v;break a}i=((hj[f[(f[g>>2]|0)+36>>2]&511](g,j,0)|0)<<24>>24)+(v*10|0)|0;j=f[a>>2]|0;k=j+12|0;E=f[k>>2]|0;if((E|0)==(f[j+16>>2]|0)){_i[f[(f[j>>2]|0)+40>>2]&2047](j)|0;r=i;s=m;t=z;u=B;continue}else{f[k>>2]=E+1;_Mc(b[E>>0]|0)|0;r=i;s=m;t=z;u=B;continue}}do if(C){l=f[C+12>>2]|0;if((l|0)==(f[C+16>>2]|0))F=_i[f[(f[C>>2]|0)+36>>2]&2047](C)|0;else F=_Mc(b[l>>0]|0)|0;if(YNc(F,ZMc()|0)|0){f[a>>2]=0;G=1;break}else{G=(f[a>>2]|0)==0;break}}else G=1;while(0);do if(z){l=f[z+12>>2]|0;if((l|0)==(f[z+16>>2]|0))H=_i[f[(f[z>>2]|0)+36>>2]&2047](z)|0;else H=_Mc(b[l>>0]|0)|0;if(!(YNc(H,ZMc()|0)|0))if(G){p=v;break a}else break;else{f[c>>2]=0;o=62;break}}else o=62;while(0);if((o|0)==62?!G:0){p=v;break}f[e>>2]=f[e>>2]|2;p=v;break}f[e>>2]=f[e>>2]|4;p=0}while(0);return p|0}function $Rc(a){a=a|0;jPc(a);return}function aSc(a){a=a|0;jPc(a);cYc(a);return}function bSc(a){a=a|0;return 2}function cSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=ySc(a,j,i,d,e,g,191108,191140)|0;u=h;return l|0}function dSc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=_i[f[(f[n>>2]|0)+20>>2]&2047](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+8+3>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+((c?f[o+4>>2]|0:d&255)<<2)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=ySc(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function eSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;ZNc(i,d);d=DPc(i,896120)|0;EPc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];wSc(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function fSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;ZNc(i,d);d=DPc(i,896120)|0;EPc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];xSc(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function gSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;ZNc(i,d);d=DPc(i,896120)|0;EPc(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];JSc(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function hSc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;ZNc(k,e);S=DPc(k,896120)|0;EPc(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];wSc(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];xSc(a,V,c,k,g,S);Y=26;break}case 99:{Z=_i[f[(f[X>>2]|0)+12>>2]&2047](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+8+3>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+(($?f[Z+4>>2]|0:_&255)<<2)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=ySc(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];zSc(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=ySc(a,l,k,e,g,h,190948,190980)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=ySc(a,l,k,e,g,h,190980,191012)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];ASc(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];BSc(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];CSc(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];DSc(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];ESc(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];FSc(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];GSc(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=ySc(a,l,k,e,g,h,191012,191056)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=ySc(a,l,k,e,g,h,191056,191076)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];HSc(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=ySc(a,l,k,e,g,h,191076,191108)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];ISc(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=xg[_&127](a,l,k,e,g,h)|0;break}case 88:{_=_i[f[(f[X>>2]|0)+24>>2]&2047](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+8+3>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+((aa?f[_+4>>2]|0:ba&255)<<2)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=ySc(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];JSc(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];KSc(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];LSc(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function iSc(a){a=a|0;if((b[539656]|0)==0?X0c(539656)|0:0){uSc();f[224443]=897604}return f[224443]|0}function jSc(a){a=a|0;if((b[539640]|0)==0?X0c(539640)|0:0){sSc();f[224400]=897312}return f[224400]|0}function kSc(a){a=a|0;if((b[539624]|0)==0?X0c(539624)|0:0){qSc();f[224327]=897020}return f[224327]|0}function lSc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539616]|0)==0?X0c(539616)|0:0){f[224252]=0;f[224253]=0;f[224254]=0;d=pSc(189980)|0;if(d>>>0>1073741807)jYc(897008);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=$Xc(e<<2)|0;f[224252]=g;f[224254]=e|-2147483648;f[224253]=d;h=g;break}}else{b[897019]=d;h=897008}while(0);rNc(h,189980,d)|0;f[c>>2]=0;pPc(h+(d<<2)|0,c);be(2295,897008,x|0)|0}u=a;return 897008}function mSc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539608]|0)==0?X0c(539608)|0:0){f[224249]=0;f[224250]=0;f[224251]=0;d=pSc(189932)|0;if(d>>>0>1073741807)jYc(896996);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=$Xc(e<<2)|0;f[224249]=g;f[224251]=e|-2147483648;f[224250]=d;h=g;break}}else{b[897007]=d;h=896996}while(0);rNc(h,189932,d)|0;f[c>>2]=0;pPc(h+(d<<2)|0,c);be(2295,896996,x|0)|0}u=a;return 896996}function nSc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539600]|0)==0?X0c(539600)|0:0){f[224246]=0;f[224247]=0;f[224248]=0;d=pSc(189896)|0;if(d>>>0>1073741807)jYc(896984);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=$Xc(e<<2)|0;f[224246]=g;f[224248]=e|-2147483648;f[224247]=d;h=g;break}}else{b[896995]=d;h=896984}while(0);rNc(h,189896,d)|0;f[c>>2]=0;pPc(h+(d<<2)|0,c);be(2295,896984,x|0)|0}u=a;return 896984}function oSc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[539592]|0)==0?X0c(539592)|0:0){f[224243]=0;f[224244]=0;f[224245]=0;d=pSc(189860)|0;if(d>>>0>1073741807)jYc(896972);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)tf();else{g=$Xc(e<<2)|0;f[224243]=g;f[224245]=e|-2147483648;f[224244]=d;h=g;break}}else{b[896983]=d;h=896972}while(0);rNc(h,189860,d)|0;f[c>>2]=0;pPc(h+(d<<2)|0,c);be(2295,896972,x|0)|0}u=a;return 896972}function pSc(a){a=a|0;return kJc(a)|0}function qSc(){var a=0,c=0;if((b[539632]|0)==0?X0c(539632)|0:0){a=897020;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=897308);be(2296,0,x|0)|0}SYc(897020,190064)|0;SYc(897032,190076)|0;return}function rSc(a){a=a|0;a=897308;do{a=a+-12|0;NYc(a)}while((a|0)!=897020);return}function sSc(){var a=0,c=0;if((b[539648]|0)==0?X0c(539648)|0:0){a=897312;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=897600);be(2297,0,x|0)|0}SYc(897312,190088)|0;SYc(897324,190120)|0;SYc(897336,190156)|0;SYc(897348,190180)|0;SYc(897360,190204)|0;SYc(897372,190220)|0;SYc(897384,190240)|0;SYc(897396,190260)|0;SYc(897408,190288)|0;SYc(897420,190328)|0;SYc(897432,190360)|0;SYc(897444,190396)|0;SYc(897456,190432)|0;SYc(897468,190448)|0;SYc(897480,190464)|0;SYc(897492,190480)|0;SYc(897504,190204)|0;SYc(897516,190496)|0;SYc(897528,190512)|0;SYc(897540,190528)|0;SYc(897552,190544)|0;SYc(897564,190560)|0;SYc(897576,190576)|0;SYc(897588,190592)|0;return}function tSc(a){a=a|0;a=897600;do{a=a+-12|0;NYc(a)}while((a|0)!=897312);return}function uSc(){var a=0,c=0;if((b[539664]|0)==0?X0c(539664)|0:0){a=897604;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=897772);be(2298,0,x|0)|0}SYc(897604,190608)|0;SYc(897616,190636)|0;SYc(897628,190664)|0;SYc(897640,190696)|0;SYc(897652,190736)|0;SYc(897664,190772)|0;SYc(897676,190800)|0;SYc(897688,190836)|0;SYc(897700,190852)|0;SYc(897712,190868)|0;SYc(897724,190884)|0;SYc(897736,190900)|0;SYc(897748,190916)|0;SYc(897760,190932)|0;return}function vSc(a){a=a|0;a=897772;do{a=a+-12|0;NYc(a)}while((a|0)!=897604);return}function wSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[f[k>>2]>>2]&2047](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(KQc(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function xSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=_i[f[(f[k>>2]|0)+4>>2]&2047](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(KQc(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function ySc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;j=u;u=u+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;ZNc(k,d);o=DPc(k,896120)|0;EPc(k);f[e>>2]=0;p=h;h=0;a:while(1){q=(p|0)!=(i|0);r=h;while(1){s=f[b>>2]|0;if(!(q&(r|0)==0)){t=s;break a}v=s;if(s){w=f[s+12>>2]|0;if((w|0)==(f[s+16>>2]|0))x=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else x=qNc(f[w>>2]|0)|0;if(_Nc(x,pNc()|0)|0){f[b>>2]=0;y=0;z=1;A=0}else{y=s;z=0;A=v}}else{y=0;z=1;A=v}v=f[c>>2]|0;s=v;do if(v){w=f[v+12>>2]|0;if((w|0)==(f[v+16>>2]|0))B=_i[f[(f[v>>2]|0)+36>>2]&2047](v)|0;else B=qNc(f[w>>2]|0)|0;if(!(_Nc(B,pNc()|0)|0))if(z){C=v;D=s;break}else{E=58;break a}else{f[c>>2]=0;F=0;E=16;break}}else{F=s;E=16}while(0);if((E|0)==16){E=0;if(z){E=58;break a}else{C=0;D=F}}if((hj[f[(f[o>>2]|0)+52>>2]&511](o,f[p>>2]|0,0)|0)<<24>>24==37){E=19;break}if(hj[f[(f[o>>2]|0)+12>>2]&511](o,8192,f[p>>2]|0)|0){G=p;E=26;break}H=y+12|0;s=f[H>>2]|0;I=y+16|0;if((s|0)==(f[I>>2]|0))J=_i[f[(f[y>>2]|0)+36>>2]&2047](y)|0;else J=qNc(f[s>>2]|0)|0;s=Mi[f[(f[o>>2]|0)+28>>2]&1023](o,J)|0;if((s|0)==(Mi[f[(f[o>>2]|0)+28>>2]&1023](o,f[p>>2]|0)|0)){E=54;break}f[e>>2]=4;r=4}b:do if((E|0)==19){E=0;r=p+4|0;if((r|0)==(i|0)){E=58;break a}q=hj[f[(f[o>>2]|0)+52>>2]&511](o,f[r>>2]|0,0)|0;switch(q<<24>>24){case 48:case 69:{s=p+8|0;if((s|0)==(i|0)){E=58;break a}K=q;L=hj[f[(f[o>>2]|0)+52>>2]&511](o,f[s>>2]|0,0)|0;M=r;break}default:{K=0;L=q;M=p}}q=f[(f[a>>2]|0)+36>>2]|0;f[m>>2]=A;f[n>>2]=D;f[l>>2]=f[m>>2];f[k>>2]=f[n>>2];r=Gj[q&15](a,l,k,d,e,g,L,K)|0;f[b>>2]=r;N=M+8|0}else if((E|0)==26){while(1){E=0;r=G+4|0;if((r|0)==(i|0)){O=i;break}if(hj[f[(f[o>>2]|0)+12>>2]&511](o,8192,f[r>>2]|0)|0){G=r;E=26}else{O=r;break}}r=y;q=C;s=C;while(1){if(r){v=f[r+12>>2]|0;if((v|0)==(f[r+16>>2]|0))P=_i[f[(f[r>>2]|0)+36>>2]&2047](r)|0;else P=qNc(f[v>>2]|0)|0;if(_Nc(P,pNc()|0)|0){f[b>>2]=0;Q=1;R=0}else{Q=0;R=r}}else{Q=1;R=0}do if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))S=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else S=qNc(f[v>>2]|0)|0;if(!(_Nc(S,pNc()|0)|0))if(Q^(q|0)==0){T=q;U=q;break}else{N=O;break b}else{f[c>>2]=0;V=0;E=41;break}}else{V=q;E=41}while(0);if((E|0)==41){E=0;if(Q){N=O;break b}else{T=V;U=0}}v=R+12|0;w=f[v>>2]|0;W=R+16|0;if((w|0)==(f[W>>2]|0))X=_i[f[(f[R>>2]|0)+36>>2]&2047](R)|0;else X=qNc(f[w>>2]|0)|0;if(!(hj[f[(f[o>>2]|0)+12>>2]&511](o,8192,X)|0)){N=O;break b}w=f[v>>2]|0;if((w|0)==(f[W>>2]|0)){_i[f[(f[R>>2]|0)+40>>2]&2047](R)|0;r=R;q=T;s=U;continue}else{f[v>>2]=w+4;qNc(f[w>>2]|0)|0;r=R;q=T;s=U;continue}}}else if((E|0)==54){E=0;s=p+4|0;q=f[H>>2]|0;if((q|0)==(f[I>>2]|0)){_i[f[(f[y>>2]|0)+40>>2]&2047](y)|0;N=s;break}else{f[H>>2]=q+4;qNc(f[q>>2]|0)|0;N=s;break}}while(0);p=N;h=f[e>>2]|0}if((E|0)==58){f[e>>2]=4;t=y}if(t){y=f[t+12>>2]|0;if((y|0)==(f[t+16>>2]|0))Y=_i[f[(f[t>>2]|0)+36>>2]&2047](t)|0;else Y=qNc(f[y>>2]|0)|0;if(_Nc(Y,pNc()|0)|0){f[b>>2]=0;Z=0;_=1}else{Z=t;_=0}}else{Z=0;_=1}t=f[c>>2]|0;do if(t){b=f[t+12>>2]|0;if((b|0)==(f[t+16>>2]|0))$=_i[f[(f[t>>2]|0)+36>>2]&2047](t)|0;else $=qNc(f[b>>2]|0)|0;if(!(_Nc($,pNc()|0)|0))if(_)break;else{E=73;break}else{f[c>>2]=0;E=71;break}}else E=71;while(0);if((E|0)==71?_:0)E=73;if((E|0)==73)f[e>>2]=f[e>>2]|2;u=j;return Z|0}function zSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function ASc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function BSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function CSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function DSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function ESc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function FSc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a:while(1){a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;else h=qNc(f[g>>2]|0)|0;if(_Nc(h,pNc()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);a=f[c>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))j=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;else j=qNc(f[g>>2]|0)|0;if(!(_Nc(j,pNc()|0)|0))if(i){k=a;break}else{l=a;break a}else{f[c>>2]=0;m=15;break}}else m=15;while(0);if((m|0)==15){m=0;if(i){l=0;break}else k=0}a=f[b>>2]|0;g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))n=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;else n=qNc(f[g>>2]|0)|0;if(!(hj[f[(f[e>>2]|0)+12>>2]&511](e,8192,n)|0)){l=k;break}g=f[b>>2]|0;a=g+12|0;o=f[a>>2]|0;if((o|0)==(f[g+16>>2]|0)){_i[f[(f[g>>2]|0)+40>>2]&2047](g)|0;continue}else{f[a>>2]=o+4;qNc(f[o>>2]|0)|0;continue}}k=f[b>>2]|0;do if(k){n=f[k+12>>2]|0;if((n|0)==(f[k+16>>2]|0))p=_i[f[(f[k>>2]|0)+36>>2]&2047](k)|0;else p=qNc(f[n>>2]|0)|0;if(_Nc(p,pNc()|0)|0){f[b>>2]=0;q=1;break}else{q=(f[b>>2]|0)==0;break}}else q=1;while(0);do if(l){b=f[l+12>>2]|0;if((b|0)==(f[l+16>>2]|0))r=_i[f[(f[l>>2]|0)+36>>2]&2047](l)|0;else r=qNc(f[b>>2]|0)|0;if(!(_Nc(r,pNc()|0)|0))if(q)break;else{m=39;break}else{f[c>>2]=0;m=37;break}}else m=37;while(0);if((m|0)==37?q:0)m=39;if((m|0)==39)f[d>>2]=f[d>>2]|2;return}function GSc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=_i[f[(f[l>>2]|0)+8>>2]&2047](l)|0;l=b[a+8+3>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+20+3>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(KQc(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function HSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function ISc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function JSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function KSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=MSc(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function LSc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;else h=qNc(f[g>>2]|0)|0;if(_Nc(h,pNc()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);h=f[c>>2]|0;do if(h){a=f[h+12>>2]|0;if((a|0)==(f[h+16>>2]|0))j=_i[f[(f[h>>2]|0)+36>>2]&2047](h)|0;else j=qNc(f[a>>2]|0)|0;if(!(_Nc(j,pNc()|0)|0))if(i){k=h;l=16;break}else{m=6;l=38;break}else{f[c>>2]=0;l=14;break}}else l=14;while(0);if((l|0)==14)if(i){m=6;l=38}else{k=0;l=16}a:do if((l|0)==16){i=f[b>>2]|0;h=f[i+12>>2]|0;if((h|0)==(f[i+16>>2]|0))n=_i[f[(f[i>>2]|0)+36>>2]&2047](i)|0;else n=qNc(f[h>>2]|0)|0;if((hj[f[(f[e>>2]|0)+52>>2]&511](e,n,0)|0)<<24>>24==37){h=f[b>>2]|0;i=h+12|0;j=f[i>>2]|0;if((j|0)==(f[h+16>>2]|0))_i[f[(f[h>>2]|0)+40>>2]&2047](h)|0;else{f[i>>2]=j+4;qNc(f[j>>2]|0)|0}j=f[b>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=_i[f[(f[j>>2]|0)+36>>2]&2047](j)|0;else o=qNc(f[i>>2]|0)|0;if(_Nc(o,pNc()|0)|0){f[b>>2]=0;p=1;break}else{p=(f[b>>2]|0)==0;break}}else p=1;while(0);do if(k|0){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))q=_i[f[(f[k>>2]|0)+36>>2]&2047](k)|0;else q=qNc(f[j>>2]|0)|0;if(!(_Nc(q,pNc()|0)|0))if(p)break a;else{m=2;l=38;break a}else{f[c>>2]=0;break}}while(0);if(p){m=2;l=38}}else{m=4;l=38}}while(0);if((l|0)==38)f[d>>2]=f[d>>2]|m;return}function MSc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[a>>2]|0;do if(g){h=f[g+12>>2]|0;if((h|0)==(f[g+16>>2]|0))i=_i[f[(f[g>>2]|0)+36>>2]&2047](g)|0;else i=qNc(f[h>>2]|0)|0;if(_Nc(i,pNc()|0)|0){f[a>>2]=0;j=1;break}else{j=(f[a>>2]|0)==0;break}}else j=1;while(0);i=f[b>>2]|0;do if(i){g=f[i+12>>2]|0;if((g|0)==(f[i+16>>2]|0))k=_i[f[(f[i>>2]|0)+36>>2]&2047](i)|0;else k=qNc(f[g>>2]|0)|0;if(!(_Nc(k,pNc()|0)|0))if(j){l=i;m=17;break}else{m=16;break}else{f[b>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j)m=16;else{l=0;m=17}a:do if((m|0)==16){f[c>>2]=f[c>>2]|6;n=0}else if((m|0)==17){j=f[a>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=_i[f[(f[j>>2]|0)+36>>2]&2047](j)|0;else o=qNc(f[i>>2]|0)|0;if(!(hj[f[(f[d>>2]|0)+12>>2]&511](d,2048,o)|0)){f[c>>2]=f[c>>2]|4;n=0;break}i=(hj[f[(f[d>>2]|0)+52>>2]&511](d,o,0)|0)<<24>>24;j=f[a>>2]|0;k=j+12|0;g=f[k>>2]|0;if((g|0)==(f[j+16>>2]|0)){_i[f[(f[j>>2]|0)+40>>2]&2047](j)|0;p=i;q=e;r=l;s=l}else{f[k>>2]=g+4;qNc(f[g>>2]|0)|0;p=i;q=e;r=l;s=l}while(1){t=p+-48|0;i=q+-1|0;g=f[a>>2]|0;do if(g){k=f[g+12>>2]|0;if((k|0)==(f[g+16>>2]|0))u=_i[f[(f[g>>2]|0)+36>>2]&2047](g)|0;else u=qNc(f[k>>2]|0)|0;if(_Nc(u,pNc()|0)|0){f[a>>2]=0;v=1;break}else{v=(f[a>>2]|0)==0;break}}else v=1;while(0);do if(s){g=f[s+12>>2]|0;if((g|0)==(f[s+16>>2]|0))w=_i[f[(f[s>>2]|0)+36>>2]&2047](s)|0;else w=qNc(f[g>>2]|0)|0;if(_Nc(w,pNc()|0)|0){f[b>>2]=0;x=0;y=1;z=0;break}else{x=r;y=(r|0)==0;z=r;break}}else{x=r;y=1;z=0}while(0);A=f[a>>2]|0;if(!((q|0)>1&(v^y)))break;g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))B=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else B=qNc(f[g>>2]|0)|0;if(!(hj[f[(f[d>>2]|0)+12>>2]&511](d,2048,B)|0)){n=t;break a}g=((hj[f[(f[d>>2]|0)+52>>2]&511](d,B,0)|0)<<24>>24)+(t*10|0)|0;k=f[a>>2]|0;j=k+12|0;h=f[j>>2]|0;if((h|0)==(f[k+16>>2]|0)){_i[f[(f[k>>2]|0)+40>>2]&2047](k)|0;p=g;q=i;r=x;s=z;continue}else{f[j>>2]=h+4;qNc(f[h>>2]|0)|0;p=g;q=i;r=x;s=z;continue}}do if(A){g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))C=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else C=qNc(f[g>>2]|0)|0;if(_Nc(C,pNc()|0)|0){f[a>>2]=0;D=1;break}else{D=(f[a>>2]|0)==0;break}}else D=1;while(0);do if(x){g=f[x+12>>2]|0;if((g|0)==(f[x+16>>2]|0))E=_i[f[(f[x>>2]|0)+36>>2]&2047](x)|0;else E=qNc(f[g>>2]|0)|0;if(!(_Nc(E,pNc()|0)|0))if(D){n=t;break a}else break;else{f[b>>2]=0;m=60;break}}else m=60;while(0);if((m|0)==60?!D:0){n=t;break}f[c>>2]=f[c>>2]|2;n=t}while(0);return n|0}function NSc(a){a=a|0;SSc(a+8|0);jPc(a);return}function OSc(a){a=a|0;SSc(a+8|0);jPc(a);cYc(a);return}function PSc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;e=u;u=u+112|0;d=e+4|0;j=e;f[j>>2]=d+100;QSc(a+8|0,d,j,g,h,i);i=f[j>>2]|0;j=d;d=f[c>>2]|0;while(1){if((j|0)==(i|0))break;c=b[j>>0]|0;if(!d)k=0;else{h=d+24|0;g=f[h>>2]|0;if((g|0)==(f[d+28>>2]|0)){a=f[(f[d>>2]|0)+52>>2]|0;l=_Mc(c)|0;m=Mi[a&1023](d,l)|0}else{f[h>>2]=g+1;b[g>>0]=c;m=_Mc(c)|0}c=YNc(m,ZMc()|0)|0;k=c?0:d}j=j+1|0;d=k}u=e;return d|0}function QSc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i;b[j>>0]=37;k=j+1|0;b[k>>0]=g;l=j+2|0;b[l>>0]=h;b[j+3>>0]=0;if(h<<24>>24){b[k>>0]=h;b[l>>0]=g}g=RSc(c,f[d>>2]|0)|0;l=c+(Rf(c|0,g|0,j|0,e|0,f[a>>2]|0)|0)|0;f[d>>2]=l;u=i;return}function RSc(a,b){a=a|0;b=b|0;return b-a|0}function SSc(a){a=a|0;var b=0;b=f[a>>2]|0;if((b|0)!=(GPc()|0))WJc(f[a>>2]|0);return}function TSc(a){a=a|0;SSc(a+8|0);jPc(a);return}function USc(a){a=a|0;SSc(a+8|0);jPc(a);cYc(a);return}function VSc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;d=u;u=u+416|0;c=d+8|0;i=d;f[i>>2]=c+400;WSc(a+8|0,c,i,e,g,h);h=f[i>>2]|0;i=c;c=f[b>>2]|0;while(1){if((i|0)==(h|0))break;b=f[i>>2]|0;if(!c)j=0;else{g=c+24|0;e=f[g>>2]|0;if((e|0)==(f[c+28>>2]|0)){a=f[(f[c>>2]|0)+52>>2]|0;k=qNc(b)|0;l=Mi[a&1023](c,k)|0}else{f[g>>2]=e+4;f[e>>2]=b;l=qNc(b)|0}b=_Nc(l,pNc()|0)|0;j=b?0:c}i=i+4|0;c=j}u=d;return c|0}function WSc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+128|0;i=h+16|0;j=h+12|0;k=h;l=h+8|0;f[j>>2]=i+100;QSc(a,i,j,d,e,g);g=k;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=i;i=XSc(b,f[c>>2]|0)|0;g=$Jc(f[a>>2]|0)|0;a=lLc(b,l,i,k)|0;if(g|0)$Jc(g)|0;if((a|0)==-1)YSc(0);else{f[c>>2]=b+(a<<2);u=h;return}}function XSc(a,b){a=a|0;b=b|0;return b-a>>2|0}function YSc(a){a=a|0;tf()}function ZSc(a){a=a|0;jPc(a);return}function _Sc(a){a=a|0;jPc(a);cYc(a);return}function $Sc(a){a=a|0;return 127}function aTc(a){a=a|0;return 127}function bTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function cTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function dTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function eTc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;iTc(a,1,45)|0;b[d>>0]=0;VNc(a+1|0,d);u=c;return}function fTc(a){a=a|0;return 0}function gTc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function hTc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function iTc(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)g1c(a|0,(_Mc(c)|0)&255|0,b|0)|0;return a|0}function jTc(a){a=a|0;jPc(a);return}function kTc(a){a=a|0;jPc(a);cYc(a);return}function lTc(a){a=a|0;return 127}function mTc(a){a=a|0;return 127}function nTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function oTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function pTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function qTc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;iTc(a,1,45)|0;b[d>>0]=0;VNc(a+1|0,d);u=c;return}function rTc(a){a=a|0;return 0}function sTc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function tTc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function uTc(a){a=a|0;jPc(a);return}function vTc(a){a=a|0;jPc(a);cYc(a);return}function wTc(a){a=a|0;return 2147483647}function xTc(a){a=a|0;return 2147483647}function yTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function zTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function ATc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function BTc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;lRc(a,1,45)|0;f[d>>2]=0;pPc(a+4|0,d);u=c;return}function CTc(a){a=a|0;return 0}function DTc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function ETc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function FTc(a){a=a|0;jPc(a);return}function GTc(a){a=a|0;jPc(a);cYc(a);return}function HTc(a){a=a|0;return 2147483647}function ITc(a){a=a|0;return 2147483647}function JTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function KTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function LTc(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function MTc(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;lRc(a,1,45)|0;f[d>>2]=0;pPc(a+4|0,d);u=c;return}function NTc(a){a=a|0;return 0}function OTc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function PTc(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function QTc(a){a=a|0;jPc(a);return}function RTc(a){a=a|0;jPc(a);cYc(a);return}function STc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+240|0;j=a+24|0;k=a;l=a+140|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+136|0;q=a+4|0;r=a+36|0;f[m>>2]=l;s=m+4|0;f[s>>2]=2299;ZNc(o,g);t=DPc(o,896088)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if(VTc(c,j,e,o,v,h,p,t,m,n,l+100|0)|0){hh[f[(f[t>>2]|0)+32>>2]&127](t,526198,526208,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>98){t=jIc(v+2|0)|0;if(!t)eYc();else{w=t;x=t}}else{w=r;x=0}if(!(b[p>>0]|0))y=w;else{b[w>>0]=45;y=w+1|0}w=j+10|0;p=j;t=e;e=y;y=l;while(1){if(t>>>0>=y>>>0)break;l=b[t>>0]|0;v=j;while(1){if((v|0)==(w|0)){z=w;break}if((b[v>>0]|0)==l<<24>>24){z=v;break}v=v+1|0}b[e>>0]=b[526198+(z-p)>>0]|0;t=t+1|0;e=e+1|0;y=f[n>>2]|0}b[e>>0]=0;f[k>>2]=i;if((uKc(r,526209,k)|0)!=1)YSc(0);if(x|0)kIc(x)}x=f[c>>2]|0;do if(x){k=f[x+12>>2]|0;if((k|0)==(f[x+16>>2]|0))A=_i[f[(f[x>>2]|0)+36>>2]&2047](x)|0;else A=_Mc(b[k>>0]|0)|0;if(YNc(A,ZMc()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){x=f[A+12>>2]|0;if((x|0)==(f[A+16>>2]|0))C=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else C=_Mc(b[x>>0]|0)|0;if(!(YNc(C,ZMc()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;EPc(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)Yi[f[s>>2]&4095](o);u=a;return h|0}function TTc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+144|0;j=a+24|0;k=a+32|0;l=a+16|0;m=a+8|0;n=a;o=a+28|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=2299;ZNc(n,g);r=DPc(n,896088)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if(VTc(c,j,e,n,t,h,o,r,l,m,k+100|0)|0){k=i+11|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;b[j>>0]=0;VNc(t,j);f[i+4>>2]=0}else{b[j>>0]=0;VNc(i,j);b[k>>0]=0}if(b[o>>0]|0)BYc(i,Mi[f[(f[r>>2]|0)+28>>2]&1023](r,45)|0);o=Mi[f[(f[r>>2]|0)+28>>2]&1023](r,48)|0;r=f[m>>2]|0;m=r+-1|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((b[k>>0]|0)!=o<<24>>24)break;k=k+1|0}WTc(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=_i[f[(f[r>>2]|0)+36>>2]&2047](r)|0;else v=_Mc(b[k>>0]|0)|0;if(YNc(v,ZMc()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=_i[f[(f[s>>2]|0)+36>>2]&2047](p)|0;else x=_Mc(b[v>>0]|0)|0;if(!(YNc(x,ZMc()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;EPc(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)Yi[f[q>>2]&4095](n);u=a;return h|0}function UTc(a){a=a|0;return}function VTc(a,c,e,g,i,j,k,l,m,n,o){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;p=u;u=u+512|0;q=p+88|0;r=p+96|0;s=p+80|0;t=p+72|0;v=p+68|0;w=p+500|0;x=p+497|0;y=p+496|0;z=p+56|0;A=p+44|0;B=p+32|0;C=p+20|0;D=p+8|0;E=p+4|0;F=p;f[q>>2]=o;f[s>>2]=r;o=s+4|0;f[o>>2]=2299;f[t>>2]=r;f[v>>2]=r+400;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[z+(r<<2)>>2]=0;r=r+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[A+(r<<2)>>2]=0;r=r+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[B+(r<<2)>>2]=0;r=r+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[C+(r<<2)>>2]=0;r=r+1|0}f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[D+(r<<2)>>2]=0;r=r+1|0}YTc(e,g,w,x,y,z,A,B,C,E);f[n>>2]=f[m>>2];g=l+8|0;l=B+11|0;e=B+4|0;r=C+11|0;G=C+4|0;H=(i&512|0)!=0;i=A+11|0;I=A+4|0;J=D+11|0;K=D+4|0;L=w+3|0;M=z+11|0;N=z+4|0;O=0;P=0;a:while(1){Q=(O|0)!=0;if(P>>>0>=4){R=234;break}S=f[a>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))U=_i[f[(f[S>>2]|0)+36>>2]&2047](S)|0;else U=_Mc(b[T>>0]|0)|0;if(YNc(U,ZMc()|0)|0){f[a>>2]=0;V=1;break}else{V=(f[a>>2]|0)==0;break}}else V=1;while(0);S=f[c>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))W=_i[f[(f[S>>2]|0)+36>>2]&2047](S)|0;else W=_Mc(b[T>>0]|0)|0;if(!(YNc(W,ZMc()|0)|0))if(V){X=S;break}else{R=234;break a}else{f[c>>2]=0;R=31;break}}else R=31;while(0);if((R|0)==31){R=0;if(V){R=234;break}else X=0}S=(P|0)!=3;b:do switch(b[w+P>>0]|0){case 1:{if(S){T=f[a>>2]|0;Y=f[T+12>>2]|0;if((Y|0)==(f[T+16>>2]|0))Z=_i[f[(f[T>>2]|0)+36>>2]&2047](T)|0;else Z=_Mc(b[Y>>0]|0)|0;if((Z&255)<<24>>24<=-1){R=44;break a}if(!(d[(f[g>>2]|0)+(Z<<24>>24<<1)>>1]&8192)){R=44;break a}Y=f[a>>2]|0;T=Y+12|0;_=f[T>>2]|0;if((_|0)==(f[Y+16>>2]|0))$=_i[f[(f[Y>>2]|0)+40>>2]&2047](Y)|0;else{f[T>>2]=_+1;$=_Mc(b[_>>0]|0)|0}BYc(D,$&255);aa=X;ba=X;R=46}else ca=O;break}case 0:{if(S){aa=X;ba=X;R=46}else ca=O;break}case 3:{_=b[l>>0]|0;T=_<<24>>24<0?f[e>>2]|0:_&255;_=b[r>>0]|0;Y=_<<24>>24<0?f[G>>2]|0:_&255;if((T|0)==(0-Y|0))ca=O;else{_=(T|0)==0;T=f[a>>2]|0;da=f[T+12>>2]|0;ea=(da|0)==(f[T+16>>2]|0);if(_|(Y|0)==0){if(ea)fa=_i[f[(f[T>>2]|0)+36>>2]&2047](T)|0;else fa=_Mc(b[da>>0]|0)|0;Y=fa&255;if(_){if(Y<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){ca=O;break b}_=f[a>>2]|0;ga=_+12|0;ha=f[ga>>2]|0;if((ha|0)==(f[_+16>>2]|0))_i[f[(f[_>>2]|0)+40>>2]&2047](_)|0;else{f[ga>>2]=ha+1;_Mc(b[ha>>0]|0)|0}b[k>>0]=1;ha=b[r>>0]|0;ca=(ha<<24>>24<0?f[G>>2]|0:ha&255)>>>0>1?C:O;break b}if(Y<<24>>24!=(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){b[k>>0]=1;ca=O;break b}Y=f[a>>2]|0;ha=Y+12|0;ga=f[ha>>2]|0;if((ga|0)==(f[Y+16>>2]|0))_i[f[(f[Y>>2]|0)+40>>2]&2047](Y)|0;else{f[ha>>2]=ga+1;_Mc(b[ga>>0]|0)|0}ga=b[l>>0]|0;ca=(ga<<24>>24<0?f[e>>2]|0:ga&255)>>>0>1?B:O;break b}if(ea)ia=_i[f[(f[T>>2]|0)+36>>2]&2047](T)|0;else ia=_Mc(b[da>>0]|0)|0;da=f[a>>2]|0;T=da+12|0;ea=f[T>>2]|0;ga=(ea|0)==(f[da+16>>2]|0);if((ia&255)<<24>>24==(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){if(ga)_i[f[(f[da>>2]|0)+40>>2]&2047](da)|0;else{f[T>>2]=ea+1;_Mc(b[ea>>0]|0)|0}T=b[l>>0]|0;ca=(T<<24>>24<0?f[e>>2]|0:T&255)>>>0>1?B:O;break b}if(ga)ja=_i[f[(f[da>>2]|0)+36>>2]&2047](da)|0;else ja=_Mc(b[ea>>0]|0)|0;if((ja&255)<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){R=103;break a}ea=f[a>>2]|0;da=ea+12|0;ga=f[da>>2]|0;if((ga|0)==(f[ea+16>>2]|0))_i[f[(f[ea>>2]|0)+40>>2]&2047](ea)|0;else{f[da>>2]=ga+1;_Mc(b[ga>>0]|0)|0}b[k>>0]=1;ga=b[r>>0]|0;ca=(ga<<24>>24<0?f[G>>2]|0:ga&255)>>>0>1?C:O}break}case 2:{if(!(P>>>0<2|Q)?!(H|(P|0)==2&(b[L>>0]|0)!=0):0){ca=0;break b}ga=b[i>>0]|0;da=ga<<24>>24<0;ea=f[A>>2]|0;T=da?ea:A;ha=T;c:do if((P|0)!=0?(h[w+(P+-1)>>0]|0)<2:0){Y=T+(da?f[I>>2]|0:ga&255)|0;_=ha;while(1){ka=_;if((ka|0)==(Y|0))break;la=b[ka>>0]|0;if(la<<24>>24<=-1)break;if(!(d[(f[g>>2]|0)+(la<<24>>24<<1)>>1]&8192))break;_=ka+1|0}Y=_-ha|0;ka=b[J>>0]|0;la=ka<<24>>24<0;ma=la?f[K>>2]|0:ka&255;if(Y>>>0<=ma>>>0){ka=(la?f[D>>2]|0:D)+ma|0;ma=T;la=ka+(0-Y)|0;while(1){if((la|0)==(ka|0)){na=X;oa=_;pa=ga;qa=ea;ra=X;break c}if((b[la>>0]|0)!=(b[ma>>0]|0)){na=X;oa=ha;pa=ga;qa=ea;ra=X;break c}ma=ma+1|0;la=la+1|0}}else{na=X;oa=ha;pa=ga;qa=ea;ra=X}}else{na=X;oa=ha;pa=ga;qa=ea;ra=X}while(0);d:while(1){ea=pa<<24>>24<0;ga=(ea?qa:A)+(ea?f[I>>2]|0:pa&255)|0;ea=oa;if((ea|0)==(ga|0)){sa=ga;break}ga=f[a>>2]|0;do if(ga){ha=f[ga+12>>2]|0;if((ha|0)==(f[ga+16>>2]|0))ta=_i[f[(f[ga>>2]|0)+36>>2]&2047](ga)|0;else ta=_Mc(b[ha>>0]|0)|0;if(YNc(ta,ZMc()|0)|0){f[a>>2]=0;ua=1;break}else{ua=(f[a>>2]|0)==0;break}}else ua=1;while(0);do if(ra){ga=f[ra+12>>2]|0;if((ga|0)==(f[ra+16>>2]|0))va=_i[f[(f[ra>>2]|0)+36>>2]&2047](ra)|0;else va=_Mc(b[ga>>0]|0)|0;if(!(YNc(va,ZMc()|0)|0))if(ua^(na|0)==0){wa=na;xa=na;break}else{sa=ea;break d}else{f[c>>2]=0;ya=0;R=132;break}}else{ya=na;R=132}while(0);if((R|0)==132){R=0;if(ua){sa=ea;break}else{wa=ya;xa=0}}ga=f[a>>2]|0;ha=f[ga+12>>2]|0;if((ha|0)==(f[ga+16>>2]|0))za=_i[f[(f[ga>>2]|0)+36>>2]&2047](ga)|0;else za=_Mc(b[ha>>0]|0)|0;if((za&255)<<24>>24!=(b[ea>>0]|0)){sa=ea;break}ha=f[a>>2]|0;ga=ha+12|0;T=f[ga>>2]|0;if((T|0)==(f[ha+16>>2]|0))_i[f[(f[ha>>2]|0)+40>>2]&2047](ha)|0;else{f[ga>>2]=T+1;_Mc(b[T>>0]|0)|0}na=wa;oa=ea+1|0;pa=b[i>>0]|0;qa=f[A>>2]|0;ra=xa}if(H?(T=b[i>>0]|0,ga=T<<24>>24<0,(sa|0)!=((ga?f[A>>2]|0:A)+(ga?f[I>>2]|0:T&255)|0)):0){R=144;break a}else ca=O;break}case 4:{T=0;ga=X;ha=X;e:while(1){da=f[a>>2]|0;do if(da){la=f[da+12>>2]|0;if((la|0)==(f[da+16>>2]|0))Aa=_i[f[(f[da>>2]|0)+36>>2]&2047](da)|0;else Aa=_Mc(b[la>>0]|0)|0;if(YNc(Aa,ZMc()|0)|0){f[a>>2]=0;Ba=1;break}else{Ba=(f[a>>2]|0)==0;break}}else Ba=1;while(0);do if(ha){da=f[ha+12>>2]|0;if((da|0)==(f[ha+16>>2]|0))Ca=_i[f[(f[ha>>2]|0)+36>>2]&2047](ha)|0;else Ca=_Mc(b[da>>0]|0)|0;if(!(YNc(Ca,ZMc()|0)|0))if(Ba^(ga|0)==0){Da=ga;Ea=ga;break}else{Fa=ga;break e}else{f[c>>2]=0;Ga=0;R=158;break}}else{Ga=ga;R=158}while(0);if((R|0)==158){R=0;if(Ba){Fa=Ga;break}else{Da=Ga;Ea=0}}da=f[a>>2]|0;ea=f[da+12>>2]|0;if((ea|0)==(f[da+16>>2]|0))Ha=_i[f[(f[da>>2]|0)+36>>2]&2047](da)|0;else Ha=_Mc(b[ea>>0]|0)|0;ea=Ha&255;if(ea<<24>>24>-1?(d[(f[g>>2]|0)+(Ha<<24>>24<<1)>>1]&2048)!=0:0){da=f[n>>2]|0;if((da|0)==(f[q>>2]|0)){ZTc(m,n,q);Ia=f[n>>2]|0}else Ia=da;f[n>>2]=Ia+1;b[Ia>>0]=ea;Ja=T+1|0}else{da=b[M>>0]|0;if(!(ea<<24>>24==(b[y>>0]|0)&(T|0?((da<<24>>24<0?f[N>>2]|0:da&255)|0)!=0:0))){Fa=Da;break}da=f[t>>2]|0;if((da|0)==(f[v>>2]|0)){_Tc(s,t,v);Ka=f[t>>2]|0}else Ka=da;f[t>>2]=Ka+4;f[Ka>>2]=T;Ja=0}da=f[a>>2]|0;ea=da+12|0;la=f[ea>>2]|0;if((la|0)==(f[da+16>>2]|0)){_i[f[(f[da>>2]|0)+40>>2]&2047](da)|0;T=Ja;ga=Da;ha=Ea;continue}else{f[ea>>2]=la+1;_Mc(b[la>>0]|0)|0;T=Ja;ga=Da;ha=Ea;continue}}ha=f[t>>2]|0;if(T|0?(f[s>>2]|0)!=(ha|0):0){if((ha|0)==(f[v>>2]|0)){_Tc(s,t,v);La=f[t>>2]|0}else La=ha;f[t>>2]=La+4;f[La>>2]=T}f:do if((f[E>>2]|0)>0){ha=f[a>>2]|0;do if(ha){ga=f[ha+12>>2]|0;if((ga|0)==(f[ha+16>>2]|0))Ma=_i[f[(f[ha>>2]|0)+36>>2]&2047](ha)|0;else Ma=_Mc(b[ga>>0]|0)|0;if(YNc(Ma,ZMc()|0)|0){f[a>>2]=0;Na=1;break}else{Na=(f[a>>2]|0)==0;break}}else Na=1;while(0);do if(Fa){ha=f[Fa+12>>2]|0;if((ha|0)==(f[Fa+16>>2]|0))Oa=_i[f[(f[Fa>>2]|0)+36>>2]&2047](Fa)|0;else Oa=_Mc(b[ha>>0]|0)|0;if(!(YNc(Oa,ZMc()|0)|0))if(Na){Pa=Fa;break}else{R=232;break a}else{f[c>>2]=0;R=193;break}}else R=193;while(0);if((R|0)==193){R=0;if(Na){R=232;break a}else Pa=0}ha=f[a>>2]|0;ga=f[ha+12>>2]|0;if((ga|0)==(f[ha+16>>2]|0))Qa=_i[f[(f[ha>>2]|0)+36>>2]&2047](ha)|0;else Qa=_Mc(b[ga>>0]|0)|0;if((Qa&255)<<24>>24!=(b[x>>0]|0)){R=232;break a}ga=f[a>>2]|0;ha=ga+12|0;la=f[ha>>2]|0;if((la|0)==(f[ga+16>>2]|0)){_i[f[(f[ga>>2]|0)+40>>2]&2047](ga)|0;Ra=Pa;Sa=Pa}else{f[ha>>2]=la+1;_Mc(b[la>>0]|0)|0;Ra=Pa;Sa=Pa}while(1){if((f[E>>2]|0)<=0)break f;la=f[a>>2]|0;do if(la){ha=f[la+12>>2]|0;if((ha|0)==(f[la+16>>2]|0))Ta=_i[f[(f[la>>2]|0)+36>>2]&2047](la)|0;else Ta=_Mc(b[ha>>0]|0)|0;if(YNc(Ta,ZMc()|0)|0){f[a>>2]=0;Ua=1;break}else{Ua=(f[a>>2]|0)==0;break}}else Ua=1;while(0);do if(Sa){la=f[Sa+12>>2]|0;if((la|0)==(f[Sa+16>>2]|0))Va=_i[f[(f[Sa>>2]|0)+36>>2]&2047](Sa)|0;else Va=_Mc(b[la>>0]|0)|0;if(!(YNc(Va,ZMc()|0)|0))if(Ua^(Ra|0)==0){Wa=Ra;Xa=Ra;break}else{R=232;break a}else{f[c>>2]=0;Ya=0;R=216;break}}else{Ya=Ra;R=216}while(0);if((R|0)==216){R=0;if(Ua){R=232;break a}else{Wa=Ya;Xa=0}}la=f[a>>2]|0;ha=f[la+12>>2]|0;if((ha|0)==(f[la+16>>2]|0))Za=_i[f[(f[la>>2]|0)+36>>2]&2047](la)|0;else Za=_Mc(b[ha>>0]|0)|0;if((Za&255)<<24>>24<=-1){R=232;break a}if(!(d[(f[g>>2]|0)+(Za<<24>>24<<1)>>1]&2048)){R=232;break a}if((f[n>>2]|0)==(f[q>>2]|0))ZTc(m,n,q);ha=f[a>>2]|0;la=f[ha+12>>2]|0;if((la|0)==(f[ha+16>>2]|0))_a=_i[f[(f[ha>>2]|0)+36>>2]&2047](ha)|0;else _a=_Mc(b[la>>0]|0)|0;la=f[n>>2]|0;f[n>>2]=la+1;b[la>>0]=_a;f[E>>2]=(f[E>>2]|0)+-1;la=f[a>>2]|0;ha=la+12|0;ga=f[ha>>2]|0;if((ga|0)==(f[la+16>>2]|0)){_i[f[(f[la>>2]|0)+40>>2]&2047](la)|0;Ra=Wa;Sa=Xa;continue}else{f[ha>>2]=ga+1;_Mc(b[ga>>0]|0)|0;Ra=Wa;Sa=Xa;continue}}}while(0);if((f[n>>2]|0)==(f[m>>2]|0)){R=232;break a}else ca=O;break}default:ca=O}while(0);g:do if((R|0)==46)while(1){R=0;S=f[a>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))$a=_i[f[(f[S>>2]|0)+36>>2]&2047](S)|0;else $a=_Mc(b[T>>0]|0)|0;if(YNc($a,ZMc()|0)|0){f[a>>2]=0;ab=1;break}else{ab=(f[a>>2]|0)==0;break}}else ab=1;while(0);do if(ba){S=f[ba+12>>2]|0;if((S|0)==(f[ba+16>>2]|0))bb=_i[f[(f[ba>>2]|0)+36>>2]&2047](ba)|0;else bb=_Mc(b[S>>0]|0)|0;if(!(YNc(bb,ZMc()|0)|0))if(ab^(aa|0)==0){cb=aa;db=aa;break}else{ca=O;break g}else{f[c>>2]=0;eb=0;R=59;break}}else{eb=aa;R=59}while(0);if((R|0)==59){R=0;if(ab){ca=O;break g}else{cb=eb;db=0}}S=f[a>>2]|0;T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))fb=_i[f[(f[S>>2]|0)+36>>2]&2047](S)|0;else fb=_Mc(b[T>>0]|0)|0;if((fb&255)<<24>>24<=-1){ca=O;break g}if(!(d[(f[g>>2]|0)+(fb<<24>>24<<1)>>1]&8192)){ca=O;break g}T=f[a>>2]|0;S=T+12|0;ga=f[S>>2]|0;if((ga|0)==(f[T+16>>2]|0))gb=_i[f[(f[T>>2]|0)+40>>2]&2047](T)|0;else{f[S>>2]=ga+1;gb=_Mc(b[ga>>0]|0)|0}BYc(D,gb&255);aa=cb;ba=db;R=46}while(0);O=ca;P=P+1|0}h:do if((R|0)==44){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==103){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==144){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==232){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==234){i:do if(Q){P=O+11|0;ca=O+4|0;db=1;j:while(1){ba=b[P>>0]|0;if(ba<<24>>24<0)ib=f[ca>>2]|0;else ib=ba&255;if(db>>>0>=ib>>>0)break i;ba=f[a>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))jb=_i[f[(f[ba>>2]|0)+36>>2]&2047](ba)|0;else jb=_Mc(b[cb>>0]|0)|0;if(YNc(jb,ZMc()|0)|0){f[a>>2]=0;kb=1;break}else{kb=(f[a>>2]|0)==0;break}}else kb=1;while(0);ba=f[c>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))lb=_i[f[(f[ba>>2]|0)+36>>2]&2047](ba)|0;else lb=_Mc(b[cb>>0]|0)|0;if(!(YNc(lb,ZMc()|0)|0))if(kb)break;else break j;else{f[c>>2]=0;R=253;break}}else R=253;while(0);if((R|0)==253?(R=0,kb):0)break;ba=f[a>>2]|0;cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))mb=_i[f[(f[ba>>2]|0)+36>>2]&2047](ba)|0;else mb=_Mc(b[cb>>0]|0)|0;if((b[P>>0]|0)<0)nb=f[O>>2]|0;else nb=O;if((mb&255)<<24>>24!=(b[nb+db>>0]|0))break;cb=db+1|0;ba=f[a>>2]|0;aa=ba+12|0;gb=f[aa>>2]|0;if((gb|0)==(f[ba+16>>2]|0)){_i[f[(f[ba>>2]|0)+40>>2]&2047](ba)|0;db=cb;continue}else{f[aa>>2]=gb+1;_Mc(b[gb>>0]|0)|0;db=cb;continue}}f[j>>2]=f[j>>2]|4;hb=0;break h}while(0);db=f[s>>2]|0;P=f[t>>2]|0;if((db|0)!=(P|0)){f[F>>2]=0;SPc(z,db,P,F);if(!(f[F>>2]|0)){hb=1;break}else{f[j>>2]=f[j>>2]|4;hb=0;break}}else hb=1}while(0);nYc(D);nYc(C);nYc(B);nYc(A);nYc(z);z=f[s>>2]|0;f[s>>2]=0;if(z|0)Yi[f[o>>2]&4095](z);u=p;return hb|0}function WTc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=c;h=e+12|0;i=e;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[a+8>>2]&2147483647)+-1|0}else{m=k&255;n=10}o=d-g|0;do if(o|0){if(l){p=f[a>>2]|0;q=p;r=f[a+4>>2]|0;s=p}else{q=a;r=k&255;s=a}if(XTc(c,s,q+r|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(o>>>0>4294967279)jYc(i);if(o>>>0<11){b[i+11>>0]=o;t=i}else{p=o+16&-16;v=$Xc(p)|0;f[i>>2]=v;f[i+8>>2]=p|-2147483648;f[i+4>>2]=o;t=v}v=c;p=t;while(1){if((v|0)==(d|0))break;VNc(p,v);v=v+1|0;p=p+1|0}b[h>>0]=0;VNc(t+o|0,h);p=b[i+11>>0]|0;v=p<<24>>24<0;zYc(a,v?f[i>>2]|0:i,v?f[i+4>>2]|0:p&255)|0;nYc(i);break}p=m+o|0;if((n-m|0)>>>0<o>>>0)wYc(a,n,p-n|0,m,m,0,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;v=d+(m-g)|0;x=w+m|0;y=c;while(1){if((y|0)==(d|0))break;VNc(x,y);x=x+1|0;y=y+1|0}b[h>>0]=0;VNc(w+v|0,h);if((b[j>>0]|0)<0){f[a+4>>2]=p;break}else{b[j>>0]=p;break}}while(0);u=e;return a|0}function XTc(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function YTc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=DPc(c,897808)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;VNc(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;VNc(k,n);b[p>>0]=0;r=k}sYc(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}nYc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);r=j+11|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;b[n>>0]=0;VNc(p,n);f[j+4>>2]=0;s=j}else{b[n>>0]=0;VNc(j,n);b[r>>0]=0;s=j}sYc(j,0);f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];f[s+8>>2]=f[o+8>>2];s=0;while(1){if((s|0)==3)break;f[o+(s<<2)>>2]=0;s=s+1|0}nYc(o);s=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;b[e>>0]=s;s=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;b[g>>0]=s;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);s=h+11|0;if((b[s>>0]|0)<0){r=f[h>>2]|0;b[n>>0]=0;VNc(r,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;VNc(h,n);b[s>>0]=0;t=h}sYc(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}nYc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=i+11|0;if((b[t>>0]|0)<0){s=f[i>>2]|0;b[n>>0]=0;VNc(s,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;VNc(i,n);b[t>>0]=0;v=i}sYc(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}nYc(o);w=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}else{a=DPc(c,897800)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;VNc(d,n);f[k+4>>2]=0;x=k}else{b[n>>0]=0;VNc(k,n);b[c>>0]=0;x=k}sYc(k,0);f[x>>2]=f[o>>2];f[x+4>>2]=f[o+4>>2];f[x+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}nYc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);x=j+11|0;if((b[x>>0]|0)<0){k=f[j>>2]|0;b[n>>0]=0;VNc(k,n);f[j+4>>2]=0;y=j}else{b[n>>0]=0;VNc(j,n);b[x>>0]=0;y=j}sYc(j,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}nYc(o);y=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;b[e>>0]=y;y=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;b[g>>0]=y;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);y=h+11|0;if((b[y>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;VNc(g,n);f[h+4>>2]=0;z=h}else{b[n>>0]=0;VNc(h,n);b[y>>0]=0;z=h}sYc(h,0);f[z>>2]=f[o>>2];f[z+4>>2]=f[o+4>>2];f[z+8>>2]=f[o+8>>2];z=0;while(1){if((z|0)==3)break;f[o+(z<<2)>>2]=0;z=z+1|0}nYc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);z=i+11|0;if((b[z>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;VNc(h,n);f[i+4>>2]=0;A=i}else{b[n>>0]=0;VNc(i,n);b[z>>0]=0;A=i}sYc(i,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}nYc(o);w=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}f[l>>2]=w;u=m;return}function ZTc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=2299;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?1:i;i=(f[b>>2]|0)-g|0;j=lIc(e?g:0,h)|0;if(!j)eYc();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{Yi[f[d>>2]&4095](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=2300;f[b>>2]=k+i;f[c>>2]=(f[a>>2]|0)+h;return}function _Tc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=2299;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=lIc(e?g:0,h)|0;if(!j)eYc();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{Yi[f[d>>2]&4095](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=2300;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function $Tc(a){a=a|0;jPc(a);return}function aUc(a){a=a|0;jPc(a);cYc(a);return}function bUc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+576|0;j=a+424|0;k=a;l=a+24|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+564|0;q=a+4|0;r=a+464|0;f[m>>2]=l;s=m+4|0;f[s>>2]=2299;ZNc(o,g);t=DPc(o,896120)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if(dUc(c,j,e,o,v,h,p,t,m,n,l+400|0)|0){hh[f[(f[t>>2]|0)+48>>2]&127](t,526308,526318,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>392){t=jIc((v>>>2)+2|0)|0;if(!t)eYc();else{w=t;x=t}}else{w=r;x=0}if(!(b[p>>0]|0))y=w;else{b[w>>0]=45;y=w+1|0}w=j+40|0;p=j;t=e;e=y;y=l;while(1){if(t>>>0>=y>>>0)break;l=f[t>>2]|0;v=j;while(1){if((v|0)==(w|0)){z=w;break}if((f[v>>2]|0)==(l|0)){z=v;break}v=v+4|0}b[e>>0]=b[526308+(z-p>>2)>>0]|0;t=t+4|0;e=e+1|0;y=f[n>>2]|0}b[e>>0]=0;f[k>>2]=i;if((uKc(r,526209,k)|0)!=1)YSc(0);if(x|0)kIc(x)}x=f[c>>2]|0;do if(x){k=f[x+12>>2]|0;if((k|0)==(f[x+16>>2]|0))A=_i[f[(f[x>>2]|0)+36>>2]&2047](x)|0;else A=qNc(f[k>>2]|0)|0;if(_Nc(A,pNc()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){x=f[A+12>>2]|0;if((x|0)==(f[A+16>>2]|0))C=_i[f[(f[A>>2]|0)+36>>2]&2047](A)|0;else C=qNc(f[x>>2]|0)|0;if(!(_Nc(C,pNc()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;EPc(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)Yi[f[s>>2]&4095](o);u=a;return h|0}function cUc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+432|0;j=a+424|0;k=a+24|0;l=a+16|0;m=a+8|0;n=a;o=a+428|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=2299;ZNc(n,g);r=DPc(n,896120)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if(dUc(c,j,e,n,t,h,o,r,l,m,k+400|0)|0){k=i+8+3|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;f[j>>2]=0;pPc(t,j);f[i+4>>2]=0}else{f[j>>2]=0;pPc(i,j);b[k>>0]=0}if(b[o>>0]|0)VYc(i,Mi[f[(f[r>>2]|0)+44>>2]&1023](r,45)|0);o=Mi[f[(f[r>>2]|0)+44>>2]&1023](r,48)|0;r=f[m>>2]|0;m=r+-4|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((f[k>>2]|0)!=(o|0))break;k=k+4|0}eUc(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=_i[f[(f[r>>2]|0)+36>>2]&2047](r)|0;else v=qNc(f[k>>2]|0)|0;if(_Nc(v,pNc()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=_i[f[(f[s>>2]|0)+36>>2]&2047](p)|0;else x=qNc(f[v>>2]|0)|0;if(!(_Nc(x,pNc()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;EPc(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)Yi[f[q>>2]&4095](n);u=a;return h|0}function dUc(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0;o=u;u=u+512|0;p=o+96|0;q=o+104|0;r=o+88|0;s=o+80|0;t=o+76|0;v=o+504|0;w=o+72|0;x=o+68|0;y=o+56|0;z=o+44|0;A=o+32|0;B=o+20|0;C=o+8|0;D=o+4|0;E=o;f[p>>2]=n;f[r>>2]=q;n=r+4|0;f[n>>2]=2299;f[s>>2]=q;f[t>>2]=q+400;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[y+(q<<2)>>2]=0;q=q+1|0}f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[z+(q<<2)>>2]=0;q=q+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[A+(q<<2)>>2]=0;q=q+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[B+(q<<2)>>2]=0;q=q+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[C+(q<<2)>>2]=0;q=q+1|0}gUc(d,e,v,w,x,y,z,A,B,D);f[m>>2]=f[l>>2];e=A+8+3|0;d=A+4|0;q=B+8+3|0;F=B+4|0;G=(g&512|0)!=0;g=z+8+3|0;H=z+4|0;I=C+8+3|0;J=C+4|0;K=v+3|0;L=y+11|0;M=y+4|0;N=0;O=0;a:while(1){P=(N|0)!=0;if(O>>>0>=4){Q=229;break}R=f[a>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))T=_i[f[(f[R>>2]|0)+36>>2]&2047](R)|0;else T=qNc(f[S>>2]|0)|0;if(_Nc(T,pNc()|0)|0){f[a>>2]=0;U=1;break}else{U=(f[a>>2]|0)==0;break}}else U=1;while(0);R=f[c>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))V=_i[f[(f[R>>2]|0)+36>>2]&2047](R)|0;else V=qNc(f[S>>2]|0)|0;if(!(_Nc(V,pNc()|0)|0))if(U){W=R;break}else{Q=229;break a}else{f[c>>2]=0;Q=31;break}}else Q=31;while(0);if((Q|0)==31){Q=0;if(U){Q=229;break}else W=0}R=(O|0)!=3;b:do switch(b[v+O>>0]|0){case 1:{if(R){S=f[a>>2]|0;X=f[S+12>>2]|0;if((X|0)==(f[S+16>>2]|0))Y=_i[f[(f[S>>2]|0)+36>>2]&2047](S)|0;else Y=qNc(f[X>>2]|0)|0;if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,8192,Y)|0)){Q=43;break a}X=f[a>>2]|0;S=X+12|0;Z=f[S>>2]|0;if((Z|0)==(f[X+16>>2]|0))_=_i[f[(f[X>>2]|0)+40>>2]&2047](X)|0;else{f[S>>2]=Z+4;_=qNc(f[Z>>2]|0)|0}VYc(C,_);$=W;aa=W;Q=45}else ba=N;break}case 0:{if(R){$=W;aa=W;Q=45}else ba=N;break}case 3:{Z=b[e>>0]|0;S=Z<<24>>24<0?f[d>>2]|0:Z&255;Z=b[q>>0]|0;X=Z<<24>>24<0?f[F>>2]|0:Z&255;if((S|0)==(0-X|0))ba=N;else{Z=(S|0)==0;S=f[a>>2]|0;ca=f[S+12>>2]|0;da=(ca|0)==(f[S+16>>2]|0);if(Z|(X|0)==0){if(da)ea=_i[f[(f[S>>2]|0)+36>>2]&2047](S)|0;else ea=qNc(f[ca>>2]|0)|0;if(Z){if((ea|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){ba=N;break b}Z=f[a>>2]|0;X=Z+12|0;fa=f[X>>2]|0;if((fa|0)==(f[Z+16>>2]|0))_i[f[(f[Z>>2]|0)+40>>2]&2047](Z)|0;else{f[X>>2]=fa+4;qNc(f[fa>>2]|0)|0}b[j>>0]=1;fa=b[q>>0]|0;ba=(fa<<24>>24<0?f[F>>2]|0:fa&255)>>>0>1?B:N;break b}if((ea|0)!=(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){b[j>>0]=1;ba=N;break b}fa=f[a>>2]|0;X=fa+12|0;Z=f[X>>2]|0;if((Z|0)==(f[fa+16>>2]|0))_i[f[(f[fa>>2]|0)+40>>2]&2047](fa)|0;else{f[X>>2]=Z+4;qNc(f[Z>>2]|0)|0}Z=b[e>>0]|0;ba=(Z<<24>>24<0?f[d>>2]|0:Z&255)>>>0>1?A:N;break b}if(da)ga=_i[f[(f[S>>2]|0)+36>>2]&2047](S)|0;else ga=qNc(f[ca>>2]|0)|0;ca=f[a>>2]|0;S=ca+12|0;da=f[S>>2]|0;Z=(da|0)==(f[ca+16>>2]|0);if((ga|0)==(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){if(Z)_i[f[(f[ca>>2]|0)+40>>2]&2047](ca)|0;else{f[S>>2]=da+4;qNc(f[da>>2]|0)|0}S=b[e>>0]|0;ba=(S<<24>>24<0?f[d>>2]|0:S&255)>>>0>1?A:N;break b}if(Z)ha=_i[f[(f[ca>>2]|0)+36>>2]&2047](ca)|0;else ha=qNc(f[da>>2]|0)|0;if((ha|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){Q=101;break a}da=f[a>>2]|0;ca=da+12|0;Z=f[ca>>2]|0;if((Z|0)==(f[da+16>>2]|0))_i[f[(f[da>>2]|0)+40>>2]&2047](da)|0;else{f[ca>>2]=Z+4;qNc(f[Z>>2]|0)|0}b[j>>0]=1;Z=b[q>>0]|0;ba=(Z<<24>>24<0?f[F>>2]|0:Z&255)>>>0>1?B:N}break}case 2:{if(!(O>>>0<2|P)?!(G|(O|0)==2&(b[K>>0]|0)!=0):0){ba=0;break b}Z=b[g>>0]|0;ca=f[z>>2]|0;da=Z<<24>>24<0?ca:z;c:do if((O|0)!=0?(h[v+(O+-1)>>0]|0)<2:0){S=da;X=Z;fa=ca;while(1){ia=X<<24>>24<0;ja=S;if((ja|0)==((ia?fa:z)+((ia?f[H>>2]|0:X&255)<<2)|0)){ka=X;la=fa;break}if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,8192,f[ja>>2]|0)|0)){Q=108;break}S=ja+4|0;X=b[g>>0]|0;fa=f[z>>2]|0}if((Q|0)==108){Q=0;ka=b[g>>0]|0;la=f[z>>2]|0}fa=ka<<24>>24<0?la:z;X=fa;ja=S-X>>2;ia=b[I>>0]|0;ma=ia<<24>>24<0;na=ma?f[J>>2]|0:ia&255;if(ja>>>0>na>>>0){oa=W;pa=X;qa=ka;ra=la;sa=W}else{ia=(ma?f[C>>2]|0:C)+(na<<2)|0;na=fa;fa=ia+(0-ja<<2)|0;while(1){if((fa|0)==(ia|0)){oa=W;pa=S;qa=ka;ra=la;sa=W;break c}if((f[fa>>2]|0)!=(f[na>>2]|0)){oa=W;pa=X;qa=ka;ra=la;sa=W;break c}na=na+4|0;fa=fa+4|0}}}else{oa=W;pa=da;qa=Z;ra=ca;sa=W}while(0);d:while(1){ca=qa<<24>>24<0;Z=(ca?ra:z)+((ca?f[H>>2]|0:qa&255)<<2)|0;ca=pa;if((ca|0)==(Z|0)){ta=Z;break}Z=f[a>>2]|0;do if(Z){da=f[Z+12>>2]|0;if((da|0)==(f[Z+16>>2]|0))ua=_i[f[(f[Z>>2]|0)+36>>2]&2047](Z)|0;else ua=qNc(f[da>>2]|0)|0;if(_Nc(ua,pNc()|0)|0){f[a>>2]=0;va=1;break}else{va=(f[a>>2]|0)==0;break}}else va=1;while(0);do if(sa){Z=f[sa+12>>2]|0;if((Z|0)==(f[sa+16>>2]|0))wa=_i[f[(f[sa>>2]|0)+36>>2]&2047](sa)|0;else wa=qNc(f[Z>>2]|0)|0;if(!(_Nc(wa,pNc()|0)|0))if(va^(oa|0)==0){xa=oa;ya=oa;break}else{ta=ca;break d}else{f[c>>2]=0;za=0;Q=129;break}}else{za=oa;Q=129}while(0);if((Q|0)==129){Q=0;if(va){ta=ca;break}else{xa=za;ya=0}}Z=f[a>>2]|0;da=f[Z+12>>2]|0;if((da|0)==(f[Z+16>>2]|0))Aa=_i[f[(f[Z>>2]|0)+36>>2]&2047](Z)|0;else Aa=qNc(f[da>>2]|0)|0;if((Aa|0)!=(f[ca>>2]|0)){ta=ca;break}da=f[a>>2]|0;Z=da+12|0;fa=f[Z>>2]|0;if((fa|0)==(f[da+16>>2]|0))_i[f[(f[da>>2]|0)+40>>2]&2047](da)|0;else{f[Z>>2]=fa+4;qNc(f[fa>>2]|0)|0}oa=xa;pa=ca+4|0;qa=b[g>>0]|0;ra=f[z>>2]|0;sa=ya}if(G?(fa=b[g>>0]|0,Z=fa<<24>>24<0,(ta|0)!=((Z?f[z>>2]|0:z)+((Z?f[H>>2]|0:fa&255)<<2)|0)):0){Q=141;break a}else ba=N;break}case 4:{fa=0;Z=W;da=W;e:while(1){na=f[a>>2]|0;do if(na){X=f[na+12>>2]|0;if((X|0)==(f[na+16>>2]|0))Ba=_i[f[(f[na>>2]|0)+36>>2]&2047](na)|0;else Ba=qNc(f[X>>2]|0)|0;if(_Nc(Ba,pNc()|0)|0){f[a>>2]=0;Ca=1;break}else{Ca=(f[a>>2]|0)==0;break}}else Ca=1;while(0);do if(da){na=f[da+12>>2]|0;if((na|0)==(f[da+16>>2]|0))Da=_i[f[(f[da>>2]|0)+36>>2]&2047](da)|0;else Da=qNc(f[na>>2]|0)|0;if(!(_Nc(Da,pNc()|0)|0))if(Ca^(Z|0)==0){Ea=Z;Fa=Z;break}else{Ga=Z;break e}else{f[c>>2]=0;Ha=0;Q=155;break}}else{Ha=Z;Q=155}while(0);if((Q|0)==155){Q=0;if(Ca){Ga=Ha;break}else{Ea=Ha;Fa=0}}na=f[a>>2]|0;ca=f[na+12>>2]|0;if((ca|0)==(f[na+16>>2]|0))Ia=_i[f[(f[na>>2]|0)+36>>2]&2047](na)|0;else Ia=qNc(f[ca>>2]|0)|0;if(hj[f[(f[k>>2]|0)+12>>2]&511](k,2048,Ia)|0){ca=f[m>>2]|0;if((ca|0)==(f[p>>2]|0)){hUc(l,m,p);Ja=f[m>>2]|0}else Ja=ca;f[m>>2]=Ja+4;f[Ja>>2]=Ia;Ka=fa+1|0}else{ca=b[L>>0]|0;if(!((Ia|0)==(f[x>>2]|0)&(fa|0?((ca<<24>>24<0?f[M>>2]|0:ca&255)|0)!=0:0))){Ga=Ea;break}ca=f[s>>2]|0;if((ca|0)==(f[t>>2]|0)){_Tc(r,s,t);La=f[s>>2]|0}else La=ca;f[s>>2]=La+4;f[La>>2]=fa;Ka=0}ca=f[a>>2]|0;na=ca+12|0;X=f[na>>2]|0;if((X|0)==(f[ca+16>>2]|0)){_i[f[(f[ca>>2]|0)+40>>2]&2047](ca)|0;fa=Ka;Z=Ea;da=Fa;continue}else{f[na>>2]=X+4;qNc(f[X>>2]|0)|0;fa=Ka;Z=Ea;da=Fa;continue}}da=f[s>>2]|0;if(fa|0?(f[r>>2]|0)!=(da|0):0){if((da|0)==(f[t>>2]|0)){_Tc(r,s,t);Ma=f[s>>2]|0}else Ma=da;f[s>>2]=Ma+4;f[Ma>>2]=fa}f:do if((f[D>>2]|0)>0){da=f[a>>2]|0;do if(da){Z=f[da+12>>2]|0;if((Z|0)==(f[da+16>>2]|0))Na=_i[f[(f[da>>2]|0)+36>>2]&2047](da)|0;else Na=qNc(f[Z>>2]|0)|0;if(_Nc(Na,pNc()|0)|0){f[a>>2]=0;Oa=1;break}else{Oa=(f[a>>2]|0)==0;break}}else Oa=1;while(0);do if(Ga){da=f[Ga+12>>2]|0;if((da|0)==(f[Ga+16>>2]|0))Pa=_i[f[(f[Ga>>2]|0)+36>>2]&2047](Ga)|0;else Pa=qNc(f[da>>2]|0)|0;if(!(_Nc(Pa,pNc()|0)|0))if(Oa){Qa=Ga;break}else{Q=227;break a}else{f[c>>2]=0;Q=189;break}}else Q=189;while(0);if((Q|0)==189){Q=0;if(Oa){Q=227;break a}else Qa=0}da=f[a>>2]|0;Z=f[da+12>>2]|0;if((Z|0)==(f[da+16>>2]|0))Ra=_i[f[(f[da>>2]|0)+36>>2]&2047](da)|0;else Ra=qNc(f[Z>>2]|0)|0;if((Ra|0)!=(f[w>>2]|0)){Q=227;break a}Z=f[a>>2]|0;da=Z+12|0;X=f[da>>2]|0;if((X|0)==(f[Z+16>>2]|0)){_i[f[(f[Z>>2]|0)+40>>2]&2047](Z)|0;Sa=Qa;Ta=Qa}else{f[da>>2]=X+4;qNc(f[X>>2]|0)|0;Sa=Qa;Ta=Qa}while(1){if((f[D>>2]|0)<=0)break f;X=f[a>>2]|0;do if(X){da=f[X+12>>2]|0;if((da|0)==(f[X+16>>2]|0))Ua=_i[f[(f[X>>2]|0)+36>>2]&2047](X)|0;else Ua=qNc(f[da>>2]|0)|0;if(_Nc(Ua,pNc()|0)|0){f[a>>2]=0;Va=1;break}else{Va=(f[a>>2]|0)==0;break}}else Va=1;while(0);do if(Ta){X=f[Ta+12>>2]|0;if((X|0)==(f[Ta+16>>2]|0))Wa=_i[f[(f[Ta>>2]|0)+36>>2]&2047](Ta)|0;else Wa=qNc(f[X>>2]|0)|0;if(!(_Nc(Wa,pNc()|0)|0))if(Va^(Sa|0)==0){Xa=Sa;Ya=Sa;break}else{Q=227;break a}else{f[c>>2]=0;Za=0;Q=212;break}}else{Za=Sa;Q=212}while(0);if((Q|0)==212){Q=0;if(Va){Q=227;break a}else{Xa=Za;Ya=0}}X=f[a>>2]|0;da=f[X+12>>2]|0;if((da|0)==(f[X+16>>2]|0))_a=_i[f[(f[X>>2]|0)+36>>2]&2047](X)|0;else _a=qNc(f[da>>2]|0)|0;if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,2048,_a)|0)){Q=227;break a}if((f[m>>2]|0)==(f[p>>2]|0))hUc(l,m,p);da=f[a>>2]|0;X=f[da+12>>2]|0;if((X|0)==(f[da+16>>2]|0))$a=_i[f[(f[da>>2]|0)+36>>2]&2047](da)|0;else $a=qNc(f[X>>2]|0)|0;X=f[m>>2]|0;f[m>>2]=X+4;f[X>>2]=$a;f[D>>2]=(f[D>>2]|0)+-1;X=f[a>>2]|0;da=X+12|0;Z=f[da>>2]|0;if((Z|0)==(f[X+16>>2]|0)){_i[f[(f[X>>2]|0)+40>>2]&2047](X)|0;Sa=Xa;Ta=Ya;continue}else{f[da>>2]=Z+4;qNc(f[Z>>2]|0)|0;Sa=Xa;Ta=Ya;continue}}}while(0);if((f[m>>2]|0)==(f[l>>2]|0)){Q=227;break a}else ba=N;break}default:ba=N}while(0);g:do if((Q|0)==45)while(1){Q=0;R=f[a>>2]|0;do if(R){fa=f[R+12>>2]|0;if((fa|0)==(f[R+16>>2]|0))ab=_i[f[(f[R>>2]|0)+36>>2]&2047](R)|0;else ab=qNc(f[fa>>2]|0)|0;if(_Nc(ab,pNc()|0)|0){f[a>>2]=0;bb=1;break}else{bb=(f[a>>2]|0)==0;break}}else bb=1;while(0);do if(aa){R=f[aa+12>>2]|0;if((R|0)==(f[aa+16>>2]|0))cb=_i[f[(f[aa>>2]|0)+36>>2]&2047](aa)|0;else cb=qNc(f[R>>2]|0)|0;if(!(_Nc(cb,pNc()|0)|0))if(bb^($|0)==0){db=$;eb=$;break}else{ba=N;break g}else{f[c>>2]=0;fb=0;Q=58;break}}else{fb=$;Q=58}while(0);if((Q|0)==58){Q=0;if(bb){ba=N;break g}else{db=fb;eb=0}}R=f[a>>2]|0;fa=f[R+12>>2]|0;if((fa|0)==(f[R+16>>2]|0))gb=_i[f[(f[R>>2]|0)+36>>2]&2047](R)|0;else gb=qNc(f[fa>>2]|0)|0;if(!(hj[f[(f[k>>2]|0)+12>>2]&511](k,8192,gb)|0)){ba=N;break g}fa=f[a>>2]|0;R=fa+12|0;Z=f[R>>2]|0;if((Z|0)==(f[fa+16>>2]|0))hb=_i[f[(f[fa>>2]|0)+40>>2]&2047](fa)|0;else{f[R>>2]=Z+4;hb=qNc(f[Z>>2]|0)|0}VYc(C,hb);$=db;aa=eb;Q=45}while(0);N=ba;O=O+1|0}h:do if((Q|0)==43){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==101){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==141){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==227){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==229){i:do if(P){O=N+8+3|0;ba=N+4|0;eb=1;j:while(1){aa=b[O>>0]|0;if(aa<<24>>24<0)jb=f[ba>>2]|0;else jb=aa&255;if(eb>>>0>=jb>>>0)break i;aa=f[a>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))kb=_i[f[(f[aa>>2]|0)+36>>2]&2047](aa)|0;else kb=qNc(f[db>>2]|0)|0;if(_Nc(kb,pNc()|0)|0){f[a>>2]=0;lb=1;break}else{lb=(f[a>>2]|0)==0;break}}else lb=1;while(0);aa=f[c>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))mb=_i[f[(f[aa>>2]|0)+36>>2]&2047](aa)|0;else mb=qNc(f[db>>2]|0)|0;if(!(_Nc(mb,pNc()|0)|0))if(lb)break;else break j;else{f[c>>2]=0;Q=248;break}}else Q=248;while(0);if((Q|0)==248?(Q=0,lb):0)break;aa=f[a>>2]|0;db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))nb=_i[f[(f[aa>>2]|0)+36>>2]&2047](aa)|0;else nb=qNc(f[db>>2]|0)|0;if((b[O>>0]|0)<0)ob=f[N>>2]|0;else ob=N;if((nb|0)!=(f[ob+(eb<<2)>>2]|0))break;db=eb+1|0;aa=f[a>>2]|0;$=aa+12|0;hb=f[$>>2]|0;if((hb|0)==(f[aa+16>>2]|0)){_i[f[(f[aa>>2]|0)+40>>2]&2047](aa)|0;eb=db;continue}else{f[$>>2]=hb+4;qNc(f[hb>>2]|0)|0;eb=db;continue}}f[i>>2]=f[i>>2]|4;ib=0;break h}while(0);eb=f[r>>2]|0;O=f[s>>2]|0;if((eb|0)!=(O|0)){f[E>>2]=0;SPc(y,eb,O,E);if(!(f[E>>2]|0)){ib=1;break}else{f[i>>2]=f[i>>2]|4;ib=0;break}}else ib=1}while(0);NYc(C);NYc(B);NYc(A);NYc(z);nYc(y);y=f[r>>2]|0;f[r>>2]=0;if(y|0)Yi[f[n>>2]&4095](y);u=o;return ib|0}function eUc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e+12|0;h=e;i=a+8|0;j=i+3|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[i>>2]&2147483647)+-1|0}else{m=k&255;n=1}i=d-c>>2;do if(i|0){if(l){o=f[a>>2]|0;p=o;q=f[a+4>>2]|0;r=o}else{p=a;q=k&255;r=a}if(fUc(c,r,p+(q<<2)|0)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(i>>>0>1073741807)jYc(h);do if(i>>>0>=2){o=i+4&-4;if(o>>>0>1073741823)tf();else{s=$Xc(o<<2)|0;f[h>>2]=s;f[h+8>>2]=o|-2147483648;f[h+4>>2]=i;t=c;v=s;break}}else{b[h+8+3>>0]=i;t=c;v=h}while(0);while(1){if((t|0)==(d|0))break;pPc(v,t);t=t+4|0;v=v+4|0}f[g>>2]=0;pPc(v,g);s=b[h+8+3>>0]|0;o=s<<24>>24<0;UYc(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:s&255)|0;NYc(h);break}s=m+i|0;if((n-m|0)>>>0<i>>>0)TYc(a,n,s-n|0,m,m,0,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;o=w+(m<<2)|0;x=c;while(1){if((x|0)==(d|0))break;pPc(o,x);o=o+4|0;x=x+4|0}f[g>>2]=0;pPc(o,g);if((b[j>>0]|0)<0){f[a+4>>2]=s;break}else{b[j>>0]=s;break}}while(0);u=e;return a|0}function fUc(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function gUc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=DPc(c,897824)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;pPc(q,n);f[k+4>>2]=0}else{f[n>>2]=0;pPc(k,n);b[p>>0]=0}RYc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}NYc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);p=j+8+3|0;if((b[p>>0]|0)<0){q=f[j>>2]|0;f[n>>2]=0;pPc(q,n);f[j+4>>2]=0}else{f[n>>2]=0;pPc(j,n);b[p>>0]=0}RYc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}NYc(o);p=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;f[e>>2]=p;p=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;f[g>>2]=p;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[n>>0]=0;VNc(q,n);f[h+4>>2]=0;r=h}else{b[n>>0]=0;VNc(h,n);b[p>>0]=0;r=h}sYc(h,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}nYc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);r=i+8+3|0;if((b[r>>0]|0)<0){p=f[i>>2]|0;f[n>>2]=0;pPc(p,n);f[i+4>>2]=0}else{f[n>>2]=0;pPc(i,n);b[r>>0]=0}RYc(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}NYc(o);s=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}else{a=DPc(c,897816)|0;mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;pPc(d,n);f[k+4>>2]=0}else{f[n>>2]=0;pPc(k,n);b[c>>0]=0}RYc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}NYc(o);mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);k=j+8+3|0;if((b[k>>0]|0)<0){c=f[j>>2]|0;f[n>>2]=0;pPc(c,n);f[j+4>>2]=0}else{f[n>>2]=0;pPc(j,n);b[k>>0]=0}RYc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}NYc(o);j=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;f[e>>2]=j;j=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;f[g>>2]=j;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);j=h+11|0;if((b[j>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;VNc(g,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;VNc(h,n);b[j>>0]=0;t=h}sYc(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}nYc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=i+8+3|0;if((b[t>>0]|0)<0){h=f[i>>2]|0;f[n>>2]=0;pPc(h,n);f[i+4>>2]=0}else{f[n>>2]=0;pPc(i,n);b[t>>0]=0}RYc(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];i=0;while(1){if((i|0)==3)break;f[o+(i<<2)>>2]=0;i=i+1|0}NYc(o);s=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}f[l>>2]=s;u=m;return}function hUc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=2299;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=lIc(e?g:0,h)|0;if(!j)eYc();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{Yi[f[d>>2]&4095](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=2300;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function iUc(a){a=a|0;jPc(a);return}function jUc(a){a=a|0;jPc(a);cYc(a);return}function kUc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+384|0;i=a+8|0;j=a;k=a+284|0;l=a+72|0;m=a+184|0;n=a+68|0;o=a+180|0;q=a+177|0;r=a+176|0;s=a+56|0;t=a+44|0;v=a+32|0;w=a+28|0;x=a+76|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=oJc(k,100,526414,i)|0;if(B>>>0>99){k=GPc()|0;p[j>>3]=h;C=YQc(l,k,526414,j)|0;j=f[l>>2]|0;if(!j)eYc();k=jIc(C)|0;if(!k)eYc();else{D=k;E=C;F=k;G=j}}else{D=m;E=B;F=0;G=0}ZNc(n,e);B=DPc(n,896088)|0;m=f[l>>2]|0;hh[f[(f[B>>2]|0)+32>>2]&127](B,m,m+E|0,D)|0;if(!E)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}mUc(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((E|0)>(d|0)){w=b[v+11>>0]|0;l=b[t+11>>0]|0;I=1;J=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(E-d<<1)|0;K=l<<24>>24<0?f[t+4>>2]|0:l&255}else{l=b[v+11>>0]|0;w=b[t+11>>0]|0;I=2;J=w<<24>>24<0?f[t+4>>2]|0:w&255;K=l<<24>>24<0?f[v+4>>2]|0:l&255}l=K+d+J+I|0;if(l>>>0>100){I=jIc(l)|0;if(!I)eYc();else{L=I;M=I}}else{L=x;M=0}nUc(L,y,z,f[e+4>>2]|0,D,D+E|0,B,H,o,b[q>>0]|0,b[r>>0]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=EM(i,L,c,y,e,g)|0;if(M|0)kIc(M);nYc(v);nYc(t);nYc(s);EPc(n);if(F|0)kIc(F);if(G|0)kIc(G);u=a;return A|0}function lUc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+176|0;i=a+56|0;j=a+52|0;k=a+164|0;l=a+161|0;m=a+160|0;n=a+40|0;o=a+28|0;p=a+16|0;q=a+12|0;r=a+60|0;s=a+8|0;t=a+4|0;v=a;ZNc(j,e);w=DPc(j,896088)|0;x=h+11|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=b[(z?f[h>>2]|0:h)>>0]|0;B=y<<24>>24==(Mi[f[(f[w>>2]|0)+28>>2]&1023](w,45)|0)<<24>>24};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}mUc(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+11>>0]|0;A=b[o+11>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+11>>0]|0;q=b[o+11>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=jIc(A)|0;if(!C)eYc();else{F=C;G=C}}else{F=r;G=0}r=x?f[h>>2]|0:h;nUc(F,s,t,f[e+4>>2]|0,r,r+y|0,w,B,k,b[l>>0]|0,b[m>>0]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=EM(i,F,c,s,e,g)|0;if(G|0)kIc(G);nYc(p);nYc(o);nYc(n);EPc(j);u=a;return v|0}function mUc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=DPc(d,897808)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;VNc(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;VNc(k,n);b[p>>0]=0;r=k}sYc(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}nYc(o);s=a}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);r=f[n>>2]|0;b[e>>0]=r;b[e+1>>0]=r>>8;b[e+2>>0]=r>>16;b[e+3>>0]=r>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);r=k+11|0;if((b[r>>0]|0)<0){p=f[k>>2]|0;b[n>>0]=0;VNc(p,n);f[k+4>>2]=0;t=k}else{b[n>>0]=0;VNc(k,n);b[r>>0]=0;t=k}sYc(k,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}nYc(o);s=a}t=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;b[g>>0]=t;t=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;b[h>>0]=t;mi[f[(f[s>>2]|0)+20>>2]&2047](o,a);t=i+11|0;if((b[t>>0]|0)<0){r=f[i>>2]|0;b[n>>0]=0;VNc(r,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;VNc(i,n);b[t>>0]=0;v=i}sYc(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}nYc(o);mi[f[(f[s>>2]|0)+24>>2]&2047](o,a);s=j+11|0;if((b[s>>0]|0)<0){v=f[j>>2]|0;b[n>>0]=0;VNc(v,n);f[j+4>>2]=0;w=j}else{b[n>>0]=0;VNc(j,n);b[s>>0]=0;w=j}sYc(j,0);f[w>>2]=f[o>>2];f[w+4>>2]=f[o+4>>2];f[w+8>>2]=f[o+8>>2];w=0;while(1){if((w|0)==3)break;f[o+(w<<2)>>2]=0;w=w+1|0}nYc(o);x=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}else{a=DPc(d,897800)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;VNc(d,n);f[k+4>>2]=0;y=k}else{b[n>>0]=0;VNc(k,n);b[c>>0]=0;y=k}sYc(k,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}nYc(o);z=a}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);y=f[n>>2]|0;b[e>>0]=y;b[e+1>>0]=y>>8;b[e+2>>0]=y>>16;b[e+3>>0]=y>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);y=k+11|0;if((b[y>>0]|0)<0){e=f[k>>2]|0;b[n>>0]=0;VNc(e,n);f[k+4>>2]=0;A=k}else{b[n>>0]=0;VNc(k,n);b[y>>0]=0;A=k}sYc(k,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}nYc(o);z=a}A=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;b[g>>0]=A;A=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;b[h>>0]=A;mi[f[(f[z>>2]|0)+20>>2]&2047](o,a);A=i+11|0;if((b[A>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;VNc(h,n);f[i+4>>2]=0;B=i}else{b[n>>0]=0;VNc(i,n);b[A>>0]=0;B=i}sYc(i,0);f[B>>2]=f[o>>2];f[B+4>>2]=f[o+4>>2];f[B+8>>2]=f[o+8>>2];B=0;while(1){if((B|0)==3)break;f[o+(B<<2)>>2]=0;B=B+1|0}nYc(o);mi[f[(f[z>>2]|0)+24>>2]&2047](o,a);z=j+11|0;if((b[z>>0]|0)<0){B=f[j>>2]|0;b[n>>0]=0;VNc(B,n);f[j+4>>2]=0;C=j}else{b[n>>0]=0;VNc(j,n);b[z>>0]=0;C=j}sYc(j,0);f[C>>2]=f[o>>2];f[C+4>>2]=f[o+4>>2];f[C+8>>2]=f[o+8>>2];C=0;while(1){if((C|0)==3)break;f[o+(C<<2)>>2]=0;C=C+1|0}nYc(o);x=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}f[l>>2]=x;u=m;return}function nUc(a,c,e,g,h,i,j,k,l,m,n,o,p,q,r){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;f[e>>2]=a;s=q+11|0;t=q+4|0;u=p+11|0;v=p+4|0;w=(g&512|0)==0;x=j+8|0;y=(r|0)>0;z=o+11|0;A=o+4|0;B=0;C=h;while(1){if((B|0)==4)break;a:do switch(b[l+B>>0]|0){case 0:{f[c>>2]=f[e>>2];D=C;break}case 1:{f[c>>2]=f[e>>2];h=Mi[f[(f[j>>2]|0)+28>>2]&1023](j,32)|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=h;D=C;break}case 3:{h=b[s>>0]|0;E=h<<24>>24<0;if(!((E?f[t>>2]|0:h&255)|0))D=C;else{h=b[(E?f[q>>2]|0:q)>>0]|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=h;D=C}break}case 2:{h=b[u>>0]|0;E=h<<24>>24<0;F=E?f[v>>2]|0:h&255;if(w|(F|0)==0)D=C;else{h=E?f[p>>2]|0:p;E=h+F|0;F=f[e>>2]|0;G=h;while(1){if((G|0)==(E|0))break;b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}f[e>>2]=F;D=C}break}case 4:{G=f[e>>2]|0;E=k?C+1|0:C;h=E;while(1){if(h>>>0>=i>>>0)break;H=b[h>>0]|0;if(H<<24>>24<=-1)break;if(!(d[(f[x>>2]|0)+(H<<24>>24<<1)>>1]&2048))break;h=h+1|0}if(y){F=r;H=h;while(1){I=(F|0)>0;if(!(H>>>0>E>>>0&I))break;J=H+-1|0;K=b[J>>0]|0;L=f[e>>2]|0;f[e>>2]=L+1;b[L>>0]=K;F=F+-1|0;H=J}if(I)M=Mi[f[(f[j>>2]|0)+28>>2]&1023](j,48)|0;else M=0;J=F;while(1){N=f[e>>2]|0;f[e>>2]=N+1;if((J|0)<=0)break;b[N>>0]=M;J=J+-1|0}b[N>>0]=m;O=H}else O=h;b:do if((O|0)==(E|0)){J=Mi[f[(f[j>>2]|0)+28>>2]&1023](j,48)|0;F=f[e>>2]|0;f[e>>2]=F+1;b[F>>0]=J}else{J=b[z>>0]|0;F=J<<24>>24<0;if(!((F?f[A>>2]|0:J&255)|0)){P=-1;Q=0;R=0;S=O}else{P=b[(F?f[o>>2]|0:o)>>0]|0;Q=0;R=0;S=O}while(1){if((S|0)==(E|0))break b;if((R|0)==(P|0)){F=f[e>>2]|0;f[e>>2]=F+1;b[F>>0]=n;F=Q+1|0;J=b[z>>0]|0;K=J<<24>>24<0;if(F>>>0<(K?f[A>>2]|0:J&255)>>>0){J=b[(K?f[o>>2]|0:o)+F>>0]|0;T=J<<24>>24==127?-1:J<<24>>24;U=F;V=0}else{T=R;U=F;V=0}}else{T=P;U=Q;V=R}F=S+-1|0;J=b[F>>0]|0;K=f[e>>2]|0;f[e>>2]=K+1;b[K>>0]=J;P=T;Q=U;R=V+1|0;S=F}}while(0);h=f[e>>2]|0;if((G|0)==(h|0))D=E;else{H=h;h=G;while(1){F=H+-1|0;if(h>>>0>=F>>>0){D=E;break a}J=b[h>>0]|0;b[h>>0]=b[F>>0]|0;b[F>>0]=J;H=F;h=h+1|0}}break}default:D=C}while(0);B=B+1|0;C=D}D=b[s>>0]|0;s=D<<24>>24<0;C=s?f[t>>2]|0:D&255;if(C>>>0>1){D=s?f[q>>2]|0:q;q=D+C|0;C=f[e>>2]|0;s=D;while(1){D=s+1|0;if((D|0)==(q|0))break;b[C>>0]=b[D>>0]|0;C=C+1|0;s=D}f[e>>2]=C}switch((g&176)<<24>>24){case 32:{f[c>>2]=f[e>>2];break}case 16:break;default:f[c>>2]=a}return}function oUc(a){a=a|0;jPc(a);return}function pUc(a){a=a|0;jPc(a);cYc(a);return}function qUc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+1008|0;i=a+8|0;j=a;k=a+896|0;l=a+888|0;m=a+488|0;n=a+480|0;o=a+892|0;q=a+476|0;r=a+472|0;s=a+460|0;t=a+448|0;v=a+436|0;w=a+432|0;x=a+32|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=oJc(k,100,526414,i)|0;if(B>>>0>99){k=GPc()|0;p[j>>3]=h;C=YQc(l,k,526414,j)|0;j=f[l>>2]|0;if(!j)eYc();k=jIc(C<<2)|0;if(!k)eYc();else{D=k;E=C;F=k;G=j}}else{D=m;E=B;F=0;G=0}ZNc(n,e);B=DPc(n,896120)|0;m=f[l>>2]|0;hh[f[(f[B>>2]|0)+48>>2]&127](B,m,m+E|0,D)|0;if(!E)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}sUc(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((E|0)>(d|0)){w=b[v+8+3>>0]|0;l=b[t+8+3>>0]|0;I=1;J=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(E-d<<1)|0;K=l<<24>>24<0?f[t+4>>2]|0:l&255}else{l=b[v+8+3>>0]|0;w=b[t+8+3>>0]|0;I=2;J=w<<24>>24<0?f[t+4>>2]|0:w&255;K=l<<24>>24<0?f[v+4>>2]|0:l&255}l=K+d+J+I|0;if(l>>>0>100){I=jIc(l<<2)|0;if(!I)eYc();else{L=I;M=I}}else{L=x;M=0}tUc(L,y,z,f[e+4>>2]|0,D,D+(E<<2)|0,B,H,o,f[q>>2]|0,f[r>>2]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=kRc(i,L,c,y,e,g)|0;if(M|0)kIc(M);NYc(v);NYc(t);nYc(s);EPc(n);if(F|0)kIc(F);if(G|0)kIc(G);u=a;return A|0}function rUc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+480|0;i=a+468|0;j=a+464|0;k=a+472|0;l=a+460|0;m=a+456|0;n=a+444|0;o=a+432|0;p=a+420|0;q=a+416|0;r=a+16|0;s=a+8|0;t=a+4|0;v=a;ZNc(j,e);w=DPc(j,896120)|0;x=h+8+3|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=f[(z?f[h>>2]|0:h)>>2]|0;B=(y|0)==(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,45)|0)};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}sUc(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+8+3>>0]|0;A=b[o+8+3>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+8+3>>0]|0;q=b[o+8+3>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=jIc(A<<2)|0;if(!C)eYc();else{F=C;G=C}}else{F=r;G=0}r=x?f[h>>2]|0:h;tUc(F,s,t,f[e+4>>2]|0,r,r+(y<<2)|0,w,B,k,f[l>>2]|0,f[m>>2]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=kRc(i,F,c,s,e,g)|0;if(G|0)kIc(G);NYc(p);NYc(o);nYc(n);EPc(j);u=a;return v|0}function sUc(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=DPc(d,897824)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;pPc(q,n);f[k+4>>2]=0}else{f[n>>2]=0;pPc(k,n);b[p>>0]=0}RYc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}NYc(o)}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;pPc(q,n);f[k+4>>2]=0}else{f[n>>2]=0;pPc(k,n);b[p>>0]=0}RYc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}NYc(o)}p=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;f[g>>2]=p;p=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;f[h>>2]=p;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);p=i+11|0;if((b[p>>0]|0)<0){q=f[i>>2]|0;b[n>>0]=0;VNc(q,n);f[i+4>>2]=0;r=i}else{b[n>>0]=0;VNc(i,n);b[p>>0]=0;r=i}sYc(i,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}nYc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);r=j+8+3|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;f[n>>2]=0;pPc(p,n);f[j+4>>2]=0}else{f[n>>2]=0;pPc(j,n);b[r>>0]=0}RYc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}NYc(o);s=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}else{a=DPc(d,897816)|0;if(c){mi[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;mi[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;pPc(d,n);f[k+4>>2]=0}else{f[n>>2]=0;pPc(k,n);b[c>>0]=0}RYc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];c=0;while(1){if((c|0)==3)break;f[o+(c<<2)>>2]=0;c=c+1|0}NYc(o)}else{mi[f[(f[a>>2]|0)+40>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;mi[f[(f[a>>2]|0)+28>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){e=f[k>>2]|0;f[n>>2]=0;pPc(e,n);f[k+4>>2]=0}else{f[n>>2]=0;pPc(k,n);b[c>>0]=0}RYc(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}NYc(o)}k=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;f[g>>2]=k;k=_i[f[(f[a>>2]|0)+16>>2]&2047](a)|0;f[h>>2]=k;mi[f[(f[a>>2]|0)+20>>2]&2047](o,a);k=i+11|0;if((b[k>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;VNc(h,n);f[i+4>>2]=0;t=i}else{b[n>>0]=0;VNc(i,n);b[k>>0]=0;t=i}sYc(i,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}nYc(o);mi[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=j+8+3|0;if((b[t>>0]|0)<0){i=f[j>>2]|0;f[n>>2]=0;pPc(i,n);f[j+4>>2]=0}else{f[n>>2]=0;pPc(j,n);b[t>>0]=0}RYc(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}NYc(o);s=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0}f[l>>2]=s;u=m;return}function tUc(a,c,d,e,g,h,i,j,k,l,m,n,o,p,q){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f[d>>2]=a;r=p+8+3|0;s=p+4|0;t=o+8+3|0;u=o+4|0;v=(e&512|0)==0;w=(q|0)>0;x=n+11|0;y=n+4|0;z=0;A=g;while(1){if((z|0)==4)break;a:do switch(b[k+z>>0]|0){case 0:{f[c>>2]=f[d>>2];B=A;break}case 1:{f[c>>2]=f[d>>2];g=Mi[f[(f[i>>2]|0)+44>>2]&1023](i,32)|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=g;B=A;break}case 3:{g=b[r>>0]|0;C=g<<24>>24<0;if(!((C?f[s>>2]|0:g&255)|0))B=A;else{g=f[(C?f[p>>2]|0:p)>>2]|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=g;B=A}break}case 2:{g=b[t>>0]|0;C=g<<24>>24<0;D=C?f[u>>2]|0:g&255;if(v|(D|0)==0)B=A;else{g=C?f[o>>2]|0:o;C=g+(D<<2)|0;E=f[d>>2]|0;F=E;G=g;while(1){if((G|0)==(C|0))break;f[F>>2]=f[G>>2];F=F+4|0;G=G+4|0}f[d>>2]=E+(D<<2);B=A}break}case 4:{G=f[d>>2]|0;F=j?A+4|0:A;C=F;while(1){if(C>>>0>=h>>>0)break;if(!(hj[f[(f[i>>2]|0)+12>>2]&511](i,2048,f[C>>2]|0)|0))break;C=C+4|0}if(w){D=q;E=C;while(1){H=(D|0)>0;if(!(E>>>0>F>>>0&H))break;g=E+-4|0;I=f[g>>2]|0;J=f[d>>2]|0;f[d>>2]=J+4;f[J>>2]=I;D=D+-1|0;E=g}if(H)K=Mi[f[(f[i>>2]|0)+44>>2]&1023](i,48)|0;else K=0;g=D;I=f[d>>2]|0;while(1){L=I+4|0;if((g|0)<=0)break;f[I>>2]=K;g=g+-1|0;I=L}f[d>>2]=L;f[I>>2]=l;M=E}else M=C;if((M|0)==(F|0)){g=Mi[f[(f[i>>2]|0)+44>>2]&1023](i,48)|0;D=f[d>>2]|0;J=D+4|0;f[d>>2]=J;f[D>>2]=g;N=J}else{J=b[x>>0]|0;g=J<<24>>24<0;D=J&255;if(!((g?f[y>>2]|0:D)|0)){O=-1;P=0;Q=0;R=M}else{O=b[(g?f[n>>2]|0:n)>>0]|0;P=0;Q=0;R=M}while(1){if((R|0)==(F|0))break;J=f[d>>2]|0;if((Q|0)==(O|0)){S=J+4|0;f[d>>2]=S;f[J>>2]=m;T=P+1|0;if(T>>>0<(g?f[y>>2]|0:D)>>>0){U=b[(g?f[n>>2]|0:n)+T>>0]|0;V=U<<24>>24==127?-1:U<<24>>24;W=T;X=0;Y=S}else{V=Q;W=T;X=0;Y=S}}else{V=O;W=P;X=Q;Y=J}J=R+-4|0;S=f[J>>2]|0;f[d>>2]=Y+4;f[Y>>2]=S;O=V;P=W;Q=X+1|0;R=J}N=f[d>>2]|0}if((G|0)==(N|0))B=F;else{g=N;D=G;while(1){C=g+-4|0;if(D>>>0>=C>>>0){B=F;break a}E=f[D>>2]|0;f[D>>2]=f[C>>2];f[C>>2]=E;g=C;D=D+4|0}}break}default:B=A}while(0);z=z+1|0;A=B}B=b[r>>0]|0;r=B<<24>>24<0;A=r?f[s>>2]|0:B&255;if(A>>>0>1){B=r?f[p>>2]|0:p;p=B+4|0;r=B+(A<<2)|0;A=f[d>>2]|0;B=r-p|0;s=A;z=p;while(1){if((z|0)==(r|0))break;f[s>>2]=f[z>>2];s=s+4|0;z=z+4|0}f[d>>2]=A+(B>>>2<<2)}switch((e&176)<<24>>24){case 32:{f[c>>2]=f[d>>2];break}case 16:break;default:f[c>>2]=a}return}function uUc(a){a=a|0;jPc(a);return}function vUc(a){a=a|0;jPc(a);cYc(a);return}function wUc(a,c,d){a=a|0;c=c|0;d=d|0;d=nJc((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function xUc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;i=c;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=0;while(1){if((j|0)==3)break;f[i+(j<<2)>>2]=0;j=j+1|0}j=b[h+11>>0]|0;k=j<<24>>24<0;l=k?f[h>>2]|0:h;m=l+(k?f[h+4>>2]|0:j&255)|0;j=l;while(1){if(j>>>0>=m>>>0)break;BYc(i,b[j>>0]|0);j=j+1|0}j=(b[i+11>>0]|0)<0?f[i>>2]|0:i;m=SJc((d|0)==-1?-1:d<<1,e,g,j)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}g=j+(dJc(m)|0)|0;m=j;while(1){if(m>>>0>=g>>>0)break;BYc(a,b[m>>0]|0);m=m+1|0}nYc(i);u=c;return}function yUc(a,b){a=a|0;b=b|0;return}function zUc(a){a=a|0;jPc(a);return}function AUc(a){a=a|0;jPc(a);cYc(a);return}function BUc(a,c,d){a=a|0;c=c|0;d=d|0;d=nJc((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function CUc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+176|0;i=c+168|0;j=c+40|0;k=c+36|0;l=c+32|0;m=c;n=c+24|0;o=c+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=0;while(1){if((p|0)==3)break;f[m+(p<<2)>>2]=0;p=p+1|0}f[n+4>>2]=0;f[n>>2]=191596;p=b[h+8+3>>0]|0;q=p<<24>>24<0;r=q?f[h>>2]|0:h;s=r+((q?f[h+4>>2]|0:p&255)<<2)|0;p=j+32|0;h=r;r=0;while(1){if(!((r|0)!=2&h>>>0<s>>>0))break;f[l>>2]=h;q=Gj[f[(f[n>>2]|0)+12>>2]&15](n,i,h,s,l,j,p,k)|0;if((q|0)==2?1:(f[l>>2]|0)==(h|0)){t=7;break}else v=j;while(1){if(v>>>0>=(f[k>>2]|0)>>>0)break;BYc(m,b[v>>0]|0);v=v+1|0}h=f[l>>2]|0;r=q}if((t|0)==7)YSc(0);jPc(n);n=(b[m+11>>0]|0)<0?f[m>>2]|0:m;r=SJc((d|0)==-1?-1:d<<1,e,g,n)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}f[o+4>>2]=0;f[o>>2]=191644;g=n+(dJc(r)|0)|0;r=g;e=j+128|0;d=n;n=0;while(1){if(!((n|0)!=2&d>>>0<g>>>0)){t=21;break}f[l>>2]=d;h=Gj[f[(f[o>>2]|0)+16>>2]&15](o,i,d,(r-d|0)>32?d+32|0:g,l,j,e,k)|0;if((h|0)==2?1:(f[l>>2]|0)==(d|0)){t=17;break}else w=j;while(1){if(w>>>0>=(f[k>>2]|0)>>>0)break;VYc(a,f[w>>2]|0);w=w+4|0}d=f[l>>2]|0;n=h}if((t|0)==17)YSc(0);else if((t|0)==21){jPc(o);nYc(m);u=c;return}}function DUc(a,b){a=a|0;b=b|0;return}function EUc(a){a=a|0;jPc(a);cYc(a);return}function FUc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=OUc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function GUc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=NUc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function HUc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function IUc(a){a=a|0;return 0}function JUc(a){a=a|0;return 0}function KUc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return MUc(c,d,e,1114111,0)|0}function LUc(a){a=a|0;return 4}function MUc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=0;k=(b[a+2>>0]|0)==-65?a+3|0:a}else{j=0;k=a}a:while(1){if(!(j>>>0<d>>>0&k>>>0<c>>>0)){l=30;break}a=b[k>>0]|0;f=a&255;m=k+1|0;do if(a<<24>>24>-1)if(f>>>0>e>>>0){l=30;break a}else n=m;else{if((a&255)<194){l=30;break a}o=k+2|0;p=k;q=g-p|0;if((a&255)<224){if((q|0)<2){l=30;break a}r=h[m>>0]|0;if((r&192|0)!=128){l=30;break a}if((r&63|f<<6&1984)>>>0>e>>>0){l=30;break a}else{n=o;break}}r=k+3|0;if((a&255)<240){if((q|0)<3){l=30;break a}s=b[o>>0]|0;t=h[m>>0]|0;u=t&224;switch(a<<24>>24){case -32:{if((u|0)!=160){v=p;break a}break}case -19:{if((u|0)!=128){v=p;break a}break}default:if((t&192|0)!=128){v=p;break a}}u=s&255;if((u&192|0)!=128){l=30;break a}if((t<<6&4032|f<<12&61440|u&63)>>>0>e>>>0){l=30;break a}else{n=r;break}}if((q|0)<4|(a&255)>244){l=30;break a}q=b[m>>0]|0;u=b[o>>0]|0;o=b[r>>0]|0;r=q&255;switch(a<<24>>24){case -16:{if((q+112&255)>=48){v=p;break a}break}case -12:{if((r&240|0)!=128){v=p;break a}break}default:if((r&192|0)!=128){v=p;break a}}p=u&255;if((p&192|0)!=128){l=30;break a}u=o&255;if((u&192|0)!=128){l=30;break a}if((r<<12&258048|f<<18&1835008|p<<6&4032|u&63)>>>0>e>>>0){l=30;break a}else n=k+4|0}while(0);j=j+1|0;k=n}if((l|0)==30)v=k;return v-i|0}function NUc(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f[d>>2]=a;f[i>>2]=e;e=c;if((((k&4|0?(k=f[d>>2]|0,(e-k|0)>2):0)?(b[k>>0]|0)==-17:0)?(b[k+1>>0]|0)==-69:0)?(b[k+2>>0]|0)==-65:0)f[d>>2]=k+3;a:while(1){k=f[d>>2]|0;if(k>>>0>=c>>>0){l=0;break}a=f[i>>2]|0;if(a>>>0>=g>>>0){l=1;break}m=b[k>>0]|0;n=m&255;o=k+1|0;do if(m<<24>>24>-1){if(n>>>0>j>>>0){l=2;break a}f[a>>2]=n;p=o}else{if((m&255)<194){l=2;break a}q=k+2|0;r=e-k|0;if((m&255)<224){if((r|0)<2){l=1;break a}s=h[o>>0]|0;if((s&192|0)!=128){l=2;break a}t=s&63|n<<6&1984;if(t>>>0>j>>>0){l=2;break a}f[a>>2]=t;p=q;break}t=k+3|0;if((m&255)<240){if((r|0)<3){l=1;break a}s=b[q>>0]|0;u=h[o>>0]|0;v=u&224;switch(m<<24>>24){case -32:{if((v|0)!=160){l=2;break a}break}case -19:{if((v|0)!=128){l=2;break a}break}default:if((u&192|0)!=128){l=2;break a}}v=s&255;if((v&192|0)!=128){l=2;break a}s=u<<6&4032|n<<12&61440|v&63;if(s>>>0>j>>>0){l=2;break a}f[a>>2]=s;p=t;break}if((m&255)>=245){l=2;break a}if((r|0)<4){l=1;break a}r=b[o>>0]|0;s=b[q>>0]|0;q=b[t>>0]|0;t=r&255;switch(m<<24>>24){case -16:{if((r+112&255)>=48){l=2;break a}break}case -12:{if((t&240|0)!=128){l=2;break a}break}default:if((t&192|0)!=128){l=2;break a}}r=s&255;if((r&192|0)!=128){l=2;break a}s=q&255;if((s&192|0)!=128){l=2;break a}q=t<<12&258048|n<<18&1835008|r<<6&4032|s&63;if(q>>>0>j>>>0){l=2;break a}f[a>>2]=q;p=k+4|0}while(0);f[d>>2]=p;f[i>>2]=(f[i>>2]|0)+4}return l|0}function OUc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[d>>2]=a;f[h>>2]=e;a=g;if(j&2)if((a-e|0)<3)k=1;else{f[h>>2]=e+1;b[e>>0]=-17;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-69;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-65;l=4}else l=4;a:do if((l|0)==4){e=f[d>>2]|0;while(1){if(e>>>0>=c>>>0){k=0;break a}j=f[e>>2]|0;if(j>>>0>i>>>0|(j&-2048|0)==55296){k=2;break a}do if(j>>>0>=128){g=(j&63|128)&255;if(j>>>0<2048){m=f[h>>2]|0;if((a-m|0)<2){k=1;break a}f[h>>2]=m+1;b[m>>0]=j>>>6|192;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=g;break}m=f[h>>2]|0;n=a-m|0;o=m+1|0;p=(j>>>6&63|128)&255;if(j>>>0<65536){if((n|0)<3){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>12|224;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=p;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=g;break}else{if((n|0)<4){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>18|240;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=j>>>12&63|128;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=p;p=f[h>>2]|0;f[h>>2]=p+1;b[p>>0]=g;break}}else{g=f[h>>2]|0;if((a-g|0)<1){k=1;break a}f[h>>2]=g+1;b[g>>0]=j}while(0);j=(f[d>>2]|0)+4|0;f[d>>2]=j;e=j}}while(0);return k|0}function PUc(a){a=a|0;jPc(a);cYc(a);return}function QUc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function RUc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function SUc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function TUc(a){a=a|0;return 1}function UUc(a){a=a|0;return 1}function VUc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return (b>>>0<e>>>0?b:e)|0}function WUc(a){a=a|0;return 1}function XUc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+16|0;l=k;m=k+8|0;n=d;while(1){if((n|0)==(e|0)){o=e;break}if(!(f[n>>2]|0)){o=n;break}n=n+4|0}f[j>>2]=h;f[g>>2]=d;n=i;p=a+8|0;a=d;d=h;h=o;a:while(1){if((d|0)==(i|0)|(a|0)==(e|0)){q=a;r=35;break}o=c;s=f[o+4>>2]|0;t=l;f[t>>2]=f[o>>2];f[t+4>>2]=s;s=$Jc(f[p>>2]|0)|0;t=FLc(d,g,h-a>>2,n-d|0,c)|0;if(s|0)$Jc(s)|0;switch(t|0){case -1:{r=10;break a;break}case 0:{v=1;r=32;break a;break}default:{}}s=(f[j>>2]|0)+t|0;f[j>>2]=s;if((s|0)==(i|0)){r=33;break}if((h|0)==(e|0)){w=e;x=s;y=f[g>>2]|0}else{s=$Jc(f[p>>2]|0)|0;t=HJc(m,0,c)|0;if(s|0)$Jc(s)|0;if((t|0)==-1){z=2;r=31;break}if(t>>>0>(n-(f[j>>2]|0)|0)>>>0){z=1;r=31;break}else{A=m;B=t}while(1){if(!B)break;t=b[A>>0]|0;s=f[j>>2]|0;f[j>>2]=s+1;b[s>>0]=t;A=A+1|0;B=B+-1|0}t=(f[g>>2]|0)+4|0;f[g>>2]=t;s=t;while(1){if((s|0)==(e|0)){C=e;break}if(!(f[s>>2]|0)){C=s;break}s=s+4|0}w=C;x=f[j>>2]|0;y=t}a=y;d=x;h=w}if((r|0)==10){f[j>>2]=d;w=a;a=d;while(1){if((w|0)==(f[g>>2]|0))break;d=f[w>>2]|0;h=$Jc(f[p>>2]|0)|0;x=HJc(a,d,l)|0;if(h|0)$Jc(h)|0;if((x|0)==-1)break;h=(f[j>>2]|0)+x|0;f[j>>2]=h;w=w+4|0;a=h}f[g>>2]=w;v=2;r=32}else if((r|0)==31){v=z;r=32}else if((r|0)==33){q=f[g>>2]|0;r=35}if((r|0)==32)D=v;else if((r|0)==35)D=(q|0)!=(e|0)&1;u=k;return D|0}function YUc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=u;u=u+16|0;l=k;m=d;while(1){if((m|0)==(e|0)){n=e;break}if(!(b[m>>0]|0)){n=m;break}m=m+1|0}f[j>>2]=h;f[g>>2]=d;m=i;o=a+8|0;a=d;d=h;h=n;while(1){if((d|0)==(i|0)|(a|0)==(e|0)){p=a;q=32;break}n=c;r=f[n+4>>2]|0;s=l;f[s>>2]=f[n>>2];f[s+4>>2]=r;t=h;r=$Jc(f[o>>2]|0)|0;s=GLc(d,g,t-a|0,m-d>>2,c)|0;if(r|0)$Jc(r)|0;if((s|0)==-1){v=a;w=d;q=10;break}r=(f[j>>2]|0)+(s<<2)|0;f[j>>2]=r;if((r|0)==(i|0)){q=29;break}s=f[g>>2]|0;if((h|0)==(e|0)){x=e;y=r;z=s}else{n=$Jc(f[o>>2]|0)|0;A=ZJc(r,s,1,c)|0;if(n|0)$Jc(n)|0;if(A|0){B=2;q=28;break}f[j>>2]=(f[j>>2]|0)+4;A=(f[g>>2]|0)+1|0;f[g>>2]=A;n=A;while(1){if((n|0)==(e|0)){C=e;break}if(!(b[n>>0]|0)){C=n;break}n=n+1|0}x=C;y=f[j>>2]|0;z=A}a=z;d=y;h=x}do if((q|0)==10){a:while(1){q=0;f[j>>2]=w;if((v|0)==(f[g>>2]|0)){q=18;break}x=$Jc(f[o>>2]|0)|0;h=ZJc(w,v,t-v|0,l)|0;if(x|0)$Jc(x)|0;switch(h|0){case -1:{q=15;break a;break}case -2:{q=16;break a;break}case 0:{D=1;break}default:D=h}v=v+D|0;w=(f[j>>2]|0)+4|0;q=10}if((q|0)==15){f[g>>2]=v;B=2;q=28;break}else if((q|0)==16){f[g>>2]=v;B=1;q=28;break}else if((q|0)==18){f[g>>2]=v;B=(v|0)!=(e|0)&1;q=28;break}}else if((q|0)==29){p=f[g>>2]|0;q=32}while(0);if((q|0)==28)E=B;else if((q|0)==32)E=(p|0)!=(e|0)&1;u=k;return E|0}function ZUc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;f[g>>2]=d;d=$Jc(f[a+8>>2]|0)|0;a=HJc(i,0,c)|0;if(d|0)$Jc(d)|0;a:do switch(a|0){case 0:case -1:{j=2;break}default:{d=a+-1|0;if(d>>>0>(e-(f[g>>2]|0)|0)>>>0)j=1;else{c=i;k=d;while(1){if(!k){j=0;break a}d=b[c>>0]|0;l=f[g>>2]|0;f[g>>2]=l+1;b[l>>0]=d;c=c+1|0;k=k+-1|0}}}}while(0);u=h;return j|0}function _Uc(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;a=$Jc(f[b>>2]|0)|0;c=bKc(0,0,4)|0;if(a|0)$Jc(a)|0;if(!c){c=f[b>>2]|0;if(!c)d=1;else{b=$Jc(c)|0;c=sLc()|0;if(b|0)$Jc(b)|0;return (c|0)==1|0}}else d=-1;return d|0}function $Uc(a){a=a|0;return 0}function aVc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=d;h=a+8|0;a=0;i=0;j=c;a:while(1){if((j|0)==(d|0)|a>>>0>=e>>>0)break;c=$Jc(f[h>>2]|0)|0;k=DLc(j,g-j|0,b)|0;if(c|0)$Jc(c)|0;switch(k|0){case -2:case -1:{break a;break}case 0:{l=1;break}default:l=k}a=a+1|0;i=l+i|0;j=j+l|0}return i|0}function bVc(a){a=a|0;var b=0,c=0;b=f[a+8>>2]|0;if(b){a=$Jc(b)|0;b=sLc()|0;if(!a)c=b;else{$Jc(a)|0;c=b}}else c=1;return c|0}function cVc(a){a=a|0;var b=0,c=0;f[a>>2]=191692;b=a+8|0;c=f[b>>2]|0;if((c|0)!=(GPc()|0))WJc(f[b>>2]|0);jPc(a);return}function dVc(a){a=a|0;cVc(a);cYc(a);return}function eVc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=nVc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function fVc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=mVc(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function gVc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function hVc(a){a=a|0;return 0}function iVc(a){a=a|0;return 0}function jVc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return lVc(c,d,e,1114111,0)|0}function kVc(a){a=a|0;return 4}function lVc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=0;k=(b[a+2>>0]|0)==-65?a+3|0:a}else{j=0;k=a}a:while(1){if(!(j>>>0<d>>>0&k>>>0<c>>>0)){l=31;break}a=b[k>>0]|0;f=a&255;if(f>>>0>e>>>0){l=31;break}m=k+1|0;do if(a<<24>>24<=-1){if((a&255)<194){l=31;break a}n=k+2|0;o=k;p=g-o|0;if((a&255)<224){if((p|0)<2){l=31;break a}q=h[m>>0]|0;if((q&192|0)!=128){l=31;break a}if((q&63|f<<6&1984)>>>0>e>>>0){l=31;break a}else{r=j;s=n;break}}q=k+3|0;if((a&255)<240){if((p|0)<3){l=31;break a}t=b[n>>0]|0;u=h[m>>0]|0;v=u&224;switch(a<<24>>24){case -32:{if((v|0)!=160){w=o;break a}break}case -19:{if((v|0)!=128){w=o;break a}break}default:if((u&192|0)!=128){w=o;break a}}v=t&255;if((v&192|0)!=128){l=31;break a}if((u<<6&4032|f<<12&61440|v&63)>>>0>e>>>0){l=31;break a}else{r=j;s=q;break}}if((a&255)>=245){l=31;break a}if((d-j|0)>>>0<2|(p|0)<4){l=31;break a}p=b[m>>0]|0;v=b[n>>0]|0;n=b[q>>0]|0;q=p&255;switch(a<<24>>24){case -16:{if((p+112&255)>=48){w=o;break a}break}case -12:{if((q&240|0)!=128){w=o;break a}break}default:if((q&192|0)!=128){w=o;break a}}o=v&255;if((o&192|0)!=128){l=31;break a}v=n&255;if((v&192|0)!=128){l=31;break a}if((q<<12&258048|f<<18&1835008|o<<6&4032|v&63)>>>0>e>>>0){l=31;break a}else{r=j+1|0;s=k+4|0}}else{r=j;s=m}while(0);j=r+1|0;k=s}if((l|0)==31)w=k;return w-i|0}function mVc(a,c,e,g,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[e>>2]=a;f[j>>2]=g;g=c;if((((l&4|0?(l=f[e>>2]|0,(g-l|0)>2):0)?(b[l>>0]|0)==-17:0)?(b[l+1>>0]|0)==-69:0)?(b[l+2>>0]|0)==-65:0)f[e>>2]=l+3;l=i;a:while(1){a=f[e>>2]|0;m=a>>>0<c>>>0;if(!m){n=40;break}o=f[j>>2]|0;if(o>>>0>=i>>>0){n=40;break}p=b[a>>0]|0;q=p&255;if(q>>>0>k>>>0){r=2;break}s=a+1|0;do if(p<<24>>24>-1){d[o>>1]=p&255;t=s}else{if((p&255)<194){r=2;break a}u=g-a|0;v=a+2|0;if((p&255)<224){if((u|0)<2){r=1;break a}w=h[s>>0]|0;if((w&192|0)!=128){r=2;break a}x=w&63|q<<6&1984;if(x>>>0>k>>>0){r=2;break a}d[o>>1]=x;t=v;break}x=a+3|0;if((p&255)<240){if((u|0)<3){r=1;break a}w=b[v>>0]|0;y=h[s>>0]|0;z=y&224;switch(p<<24>>24){case -32:{if((z|0)!=160){r=2;break a}break}case -19:{if((z|0)!=128){r=2;break a}break}default:if((y&192|0)!=128){r=2;break a}}z=w&255;if((z&192|0)!=128){r=2;break a}w=y<<6&4032|q<<12|z&63;if((w&65535)>>>0>k>>>0){r=2;break a}d[o>>1]=w;t=x;break}if((p&255)>=245){r=2;break a}if((u|0)<4){r=1;break a}u=b[s>>0]|0;w=b[v>>0]|0;v=b[x>>0]|0;x=u&255;switch(p<<24>>24){case -16:{if((u+112&255)>=48){r=2;break a}break}case -12:{if((x&240|0)!=128){r=2;break a}break}default:if((x&192|0)!=128){r=2;break a}}u=w&255;if((u&192|0)!=128){r=2;break a}w=v&255;if((w&192|0)!=128){r=2;break a}if((l-o|0)<4){r=1;break a}v=q&7;z=u<<6;y=w&63;if((x<<12&258048|v<<18|z&4032|y)>>>0>k>>>0){r=2;break a}d[o>>1]=x<<2&60|u>>>4&3|((x>>>4&3|v<<2)<<6)+16320|55296;v=o+2|0;f[j>>2]=v;d[v>>1]=y|z&960|56320;t=(f[e>>2]|0)+4|0}while(0);f[e>>2]=t;f[j>>2]=(f[j>>2]|0)+2}if((n|0)==40)r=m&1;return r|0}function nVc(a,c,e,g,h,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[e>>2]=a;f[i>>2]=g;a=h;if(l&2)if((a-g|0)<3)m=1;else{f[i>>2]=g+1;b[g>>0]=-17;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-69;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-65;n=4}else n=4;a:do if((n|0)==4){g=c;l=f[e>>2]|0;while(1){if(l>>>0>=c>>>0){m=0;break a}h=d[l>>1]|0;o=h&65535;if(o>>>0>k>>>0){m=2;break a}do if((h&65535)<128){p=f[i>>2]|0;if((a-p|0)<1){m=1;break a}f[i>>2]=p+1;b[p>>0]=h}else{p=o&63;q=(p|128)&255;if((h&65535)<2048){r=f[i>>2]|0;if((a-r|0)<2){m=1;break a}f[i>>2]=r+1;b[r>>0]=o>>>6|192;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q;break}r=(o>>>12|224)&255;s=(o>>>6&63|128)&255;if((h&65535)<55296){t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=s;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=q;break}if((h&65535)>=56320){if((h&65535)<57344){m=2;break a}t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=s;s=f[i>>2]|0;f[i>>2]=s+1;b[s>>0]=q;break}if((g-l|0)<4){m=1;break a}q=l+2|0;s=j[q>>1]|0;if((s&64512|0)!=56320){m=2;break a}if((a-(f[i>>2]|0)|0)<4){m=1;break a}r=o&960;if(((r<<10)+65536|p<<10|s&1023)>>>0>k>>>0){m=2;break a}f[e>>2]=q;q=(r>>>6)+1|0;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q>>>2|240;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=o>>>2&15|q<<4&48|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=o<<4&48|s>>>6&15|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=s&63|128}while(0);o=(f[e>>2]|0)+2|0;f[e>>2]=o;l=o}}while(0);return m|0}function oVc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=191740;b=a+8|0;c=a+12|0;d=0;while(1){e=f[b>>2]|0;if(d>>>0>=(f[c>>2]|0)-e>>2>>>0)break;g=f[e+(d<<2)>>2]|0;if(g|0)RXc(g)|0;d=d+1|0}nYc(a+144|0);qVc(b);jPc(a);return}function pVc(a){a=a|0;oVc(a);cYc(a);return}function qVc(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;do if(c|0){d=a+4|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}if((a+16|0)==(c|0)){b[a+128>>0]=0;break}else{cYc(c);break}}while(0);return}function rVc(a){a=a|0;var c=0;f[a>>2]=191760;c=f[a+8>>2]|0;if(c|0?b[a+12>>0]|0:0)dYc(c);jPc(a);return}function sVc(a){a=a|0;rVc(a);cYc(a);return}function tVc(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(CVc()|0)+((b&255)<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function uVc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=CVc()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function vVc(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(BVc()|0)+(b<<24>>24<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function wVc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=BVc()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function xVc(a,b){a=a|0;b=b|0;return b|0}function yVc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}return d|0}function zVc(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function AVc(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;a=f;f=c;while(1){if((f|0)==(d|0))break;c=b[f>>0]|0;b[a>>0]=c<<24>>24>-1?c:e;a=a+1|0;f=f+1|0}return d|0}function BVc(){var a=0;a=uLc()|0;return f[a>>2]|0}function CVc(){var a=0;a=rLc()|0;return f[a>>2]|0}function DVc(){var a=0;a=qLc()|0;return f[a>>2]|0}function EVc(a){a=a|0;f[a>>2]=191812;nYc(a+12|0);jPc(a);return}function FVc(a){a=a|0;EVc(a);cYc(a);return}function GVc(a){a=a|0;return b[a+8>>0]|0}function HVc(a){a=a|0;return b[a+9>>0]|0}function IVc(a,b){a=a|0;b=b|0;lYc(a,b+12|0);return}function JVc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=UNc(529255)|0;if(e>>>0>4294967279)jYc(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=$Xc(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}$Mc(g,529255,e)|0;b[d>>0]=0;VNc(g+e|0,d);u=c;return}function KVc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=UNc(529249)|0;if(e>>>0>4294967279)jYc(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=$Xc(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}$Mc(g,529249,e)|0;b[d>>0]=0;VNc(g+e|0,d);u=c;return}function LVc(a){a=a|0;f[a>>2]=191852;nYc(a+16|0);jPc(a);return}function MVc(a){a=a|0;LVc(a);cYc(a);return}function NVc(a){a=a|0;return f[a+8>>2]|0}function OVc(a){a=a|0;return f[a+12>>2]|0}function PVc(a,b){a=a|0;b=b|0;lYc(a,b+16|0);return}function QVc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=pSc(191908)|0;if(e>>>0>1073741807)jYc(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)tf();else{h=$Xc(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);rNc(i,191908,e)|0;f[d>>2]=0;pPc(i+(e<<2)|0,d);u=c;return}function RVc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=pSc(191884)|0;if(e>>>0>1073741807)jYc(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)tf();else{h=$Xc(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);rNc(i,191884,e)|0;f[d>>2]=0;pPc(i+(e<<2)|0,d);u=c;return}function SVc(a){a=a|0;jPc(a);cYc(a);return}function TVc(a){a=a|0;jPc(a);cYc(a);return}function UVc(a,b,c){a=a|0;b=b|0;c=c|0;var e=0;if(c>>>0<128){a=(DVc()|0)+(c<<1)|0;e=(d[a>>1]&b)<<16>>16!=0}else e=0;return e|0}function VVc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=e;e=b;while(1){if((e|0)==(c|0))break;if((f[e>>2]|0)>>>0<128){b=DVc()|0;g=j[b+(f[e>>2]<<1)>>1]|0}else g=0;d[a>>1]=g;a=a+2|0;e=e+4|0}return c|0}function WVc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0<128?(c=DVc()|0,(d[c+(f[a>>2]<<1)>>1]&b)<<16>>16):0){g=a;break}a=a+4|0}return g|0}function XVc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0>=128){g=a;break}c=DVc()|0;if(!((d[c+(f[a>>2]<<1)>>1]&b)<<16>>16)){g=a;break}a=a+4|0}return g|0}function YVc(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(CVc()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function ZVc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=CVc()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function _Vc(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(BVc()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function $Vc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=BVc()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function aWc(a,b){a=a|0;b=b|0;return b<<24>>24|0}function bWc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;f[a>>2]=b[e>>0];a=a+4|0;e=e+1|0}return d|0}function cWc(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function dWc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=(d-c|0)>>>2;h=g;g=c;while(1){if((g|0)==(d|0))break;i=f[g>>2]|0;b[h>>0]=i>>>0<128?i&255:e;h=h+1|0;g=g+4|0}return c+(a<<2)|0}function eWc(a){a=a|0;jPc(a);cYc(a);return}function fWc(a){a=a|0;jPc(a);cYc(a);return}function gWc(a){a=a|0;jPc(a);cYc(a);return}function hWc(a){a=a|0;f[a>>2]=192168;return}function iWc(a){a=a|0;f[a>>2]=192204;return}function jWc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;f[a+4>>2]=e+-1;f[a>>2]=191760;e=a+8|0;f[e>>2]=c;b[a+12>>0]=d&1;if(!c){c=DVc()|0;f[e>>2]=c}return}function kWc(a){a=a|0;tf()}function lWc(a){a=a|0;tf()}function mWc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a+4>>2]=c+-1;f[a>>2]=191740;c=a+8|0;nWc(c,28);g=a+144|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=UNc(524935)|0;if(h>>>0>4294967279)jYc(g);if(h>>>0<11){b[g+11>>0]=h;i=g}else{j=h+16&-16;k=$Xc(j)|0;f[g>>2]=k;f[a+152>>2]=j|-2147483648;f[a+148>>2]=h;i=k}$Mc(i,524935,h)|0;b[e>>0]=0;VNc(i+h|0,e);e=f[c>>2]|0;c=a+12|0;h=f[c>>2]|0;while(1){if((h|0)==(e|0))break;i=h+-4|0;f[c>>2]=i;h=i}oWc();pWc(a,539672);qWc();rWc(a,539680);sWc();tWc(a,539688);uWc();vWc(a,539704);wWc();xWc(a,539712);yWc();zWc(a,539720);AWc();BWc(a,539736);CWc();DWc(a,539744);EWc();FWc(a,539752);GWc();HWc(a,539776);IWc();JWc(a,539808);KWc();LWc(a,539816);MWc();NWc(a,539824);OWc();PWc(a,539832);QWc();RWc(a,539840);SWc();TWc(a,539848);UWc();VWc(a,539856);WWc();XWc(a,539864);YWc();ZWc(a,539872);_Wc();$Wc(a,539880);aXc();bXc(a,539888);cXc();dXc(a,539896);eXc();fXc(a,539904);gXc();hXc(a,539920);iXc();jXc(a,539936);kXc();lXc(a,539952);mXc();nXc(a,539968);oXc();pXc(a,539976);u=d;return}function nWc(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+128>>0]=0;if(c|0){CXc(a,c);tXc(a,c)}return}function oWc(){f[134919]=0;f[134918]=189404;return}function pWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896072)|0);return}function qWc(){f[134921]=0;f[134920]=189436;return}function rWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896080)|0);return}function sWc(){jWc(539688,0,0,1);return}function tWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896088)|0);return}function uWc(){f[134927]=0;f[134926]=191956;return}function vWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896120)|0);return}function wWc(){f[134929]=0;f[134928]=192024;return}function xWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897880)|0);return}function yWc(){BXc(539720,1);return}function zWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897888)|0);return}function AWc(){f[134935]=0;f[134934]=192072;return}function BWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897896)|0);return}function CWc(){f[134937]=0;f[134936]=192120;return}function DWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897904)|0);return}function EWc(){AXc(539752,1);return}function FWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896104)|0);return}function GWc(){zXc(539776,1);return}function HWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896128)|0);return}function IWc(){f[134953]=0;f[134952]=189468;return}function JWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896112)|0);return}function KWc(){f[134955]=0;f[134954]=189532;return}function LWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896136)|0);return}function MWc(){f[134957]=0;f[134956]=189596;return}function NWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896144)|0);return}function OWc(){f[134959]=0;f[134958]=189648;return}function PWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896152)|0);return}function QWc(){f[134961]=0;f[134960]=191196;return}function RWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897800)|0);return}function SWc(){f[134963]=0;f[134962]=191252;return}function TWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897808)|0);return}function UWc(){f[134965]=0;f[134964]=191308;return}function VWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897816)|0);return}function WWc(){f[134967]=0;f[134966]=191364;return}function XWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897824)|0);return}function YWc(){f[134969]=0;f[134968]=191420;return}function ZWc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897832)|0);return}function _Wc(){f[134971]=0;f[134970]=191448;return}function $Wc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897840)|0);return}function aXc(){f[134973]=0;f[134972]=191476;return}function bXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897848)|0);return}function cXc(){f[134975]=0;f[134974]=191504;return}function dXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897856)|0);return}function eXc(){f[134977]=0;f[134976]=191936;hWc(539912);f[134976]=189700;f[134978]=189748;return}function fXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(896964)|0);return}function gXc(){f[134981]=0;f[134980]=191936;iWc(539928);f[134980]=189784;f[134982]=189832;return}function hXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897776)|0);return}function iXc(){var a=0;f[134985]=0;f[134984]=191936;a=GPc()|0;f[134986]=a;f[134984]=191148;return}function jXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897784)|0);return}function kXc(){var a=0;f[134989]=0;f[134988]=191936;a=GPc()|0;f[134990]=a;f[134988]=191172;return}function lXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897792)|0);return}function mXc(){f[134993]=0;f[134992]=191532;return}function nXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897864)|0);return}function oXc(){f[134995]=0;f[134994]=191564;return}function pXc(a,b){a=a|0;b=b|0;qXc(a,b,IPc(897872)|0);return}function qXc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;PXc(b);d=a+8|0;e=f[d>>2]|0;if((f[a+12>>2]|0)-e>>2>>>0>c>>>0){g=d;h=e}else{rXc(d,c+1|0);g=d;h=f[d>>2]|0}d=f[h+(c<<2)>>2]|0;if(d|0)RXc(d)|0;f[(f[g>>2]|0)+(c<<2)>>2]=b;return}function rXc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>2;h=e;e=d;a:do if(g>>>0>=b>>>0){if(g>>>0>b>>>0){d=h+(b<<2)|0;i=e;while(1){if((i|0)==(d|0))break a;j=i+-4|0;f[c>>2]=j;i=j}}}else sXc(a,b-g|0);while(0);return}function sXc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+8|0;g=a+4|0;h=f[g>>2]|0;do if((f[e>>2]|0)-h>>2>>>0<b>>>0){i=(h-(f[a>>2]|0)>>2)+b|0;j=uXc(a)|0;if(j>>>0<i>>>0)kWc(a);else{k=f[a>>2]|0;l=(f[e>>2]|0)-k|0;m=l>>1;vXc(d,l>>2>>>0<j>>>1>>>0?(m>>>0<i>>>0?i:m):j,(f[g>>2]|0)-k>>2,a+16|0);wXc(d,b);xXc(a,d);yXc(d);break}}else tXc(a,b);while(0);u=c;return}function tXc(a,b){a=a|0;b=b|0;var c=0;c=a+4|0;a=b;b=f[c>>2]|0;do{f[b>>2]=0;b=(f[c>>2]|0)+4|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function uXc(a){a=a|0;return 1073741823}function vXc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;f[a+12>>2]=0;f[a+16>>2]=e;do if(c){g=e+112|0;if(c>>>0<29&(b[g>>0]|0)==0){b[g>>0]=1;h=e;break}else{h=$Xc(c<<2)|0;break}}else h=0;while(0);f[a>>2]=h;e=h+(d<<2)|0;f[a+8>>2]=e;f[a+4>>2]=e;f[a+12>>2]=h+(c<<2);return}function wXc(a,b){a=a|0;b=b|0;var c=0;c=a+8|0;a=b;b=f[c>>2]|0;do{f[b>>2]=0;b=(f[c>>2]|0)+4|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function xXc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=(f[d>>2]|0)-c|0;h=(f[e>>2]|0)+(0-(g>>2)<<2)|0;f[e>>2]=h;if((g|0)>0){o1c(h|0,c|0,g|0)|0;i=e;j=f[e>>2]|0}else{i=e;j=h}h=f[a>>2]|0;f[a>>2]=j;f[i>>2]=h;h=b+8|0;j=f[d>>2]|0;f[d>>2]=f[h>>2];f[h>>2]=j;j=a+8|0;a=b+12|0;h=f[j>>2]|0;f[j>>2]=f[a>>2];f[a>>2]=h;f[b>>2]=f[i>>2];return}function yXc(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a+4>>2]|0;d=a+8|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}e=f[a>>2]|0;do if(e|0){d=f[a+16>>2]|0;if((d|0)==(e|0)){b[d+112>>0]=0;break}else{cYc(e);break}}while(0);return}function zXc(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=191852;f[a+8>>2]=46;f[a+12>>2]=44;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function AXc(a,c){a=a|0;c=c|0;f[a+4>>2]=c+-1;f[a>>2]=191812;b[a+8>>0]=46;b[a+9>>0]=44;c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function BXc(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=191692;b=GPc()|0;f[a+8>>2]=b;return}function CXc(a,c){a=a|0;c=c|0;var d=0,e=0;if((uXc(a)|0)>>>0<c>>>0)kWc(a);d=a+128|0;if(c>>>0<29&(b[d>>0]|0)==0){b[d>>0]=1;e=a+16|0}else e=$Xc(c<<2)|0;f[a+4>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(c<<2);return}function DXc(){if((b[539984]|0)==0?X0c(539984)|0:0){EXc()|0;f[224479]=897912}return f[224479]|0}function EXc(){FXc();f[224478]=539992;return 897912}function FXc(){mWc(539992,1);return}function GXc(){HXc(897920,DXc()|0);return 897920}function HXc(a,b){a=a|0;b=b|0;var c=0;c=f[b>>2]|0;f[a>>2]=c;PXc(c);return}function IXc(){if((b[540152]|0)==0?X0c(540152)|0:0){GXc()|0;f[224481]=897920}return f[224481]|0}function JXc(a){a=a|0;var b=0,c=0;b=IXc()|0;c=f[b>>2]|0;f[a>>2]=c;PXc(c);return}function KXc(a,b){a=a|0;b=b|0;var c=0;c=f[a>>2]|0;return LXc(c,IPc(b)|0)|0}function LXc(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a+8>>2]|0;if((f[a+12>>2]|0)-c>>2>>>0>b>>>0)d=(f[c+(b<<2)>>2]|0)!=0;else d=0;return d|0}function MXc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=0;else d=WKc(a,b,c)|0;return d|0}function NXc(a){a=a|0;return}function OXc(a,b){a=a|0;b=b|0;return 0}function PXc(a){a=a|0;QXc(a+4|0);return}function QXc(a){a=a|0;f[a>>2]=(f[a>>2]|0)+1;return}function RXc(a){a=a|0;var b=0;if((SXc(a+4|0)|0)==-1){Yi[f[(f[a>>2]|0)+8>>2]&4095](a);b=1}else b=0;return b|0}function SXc(a){a=a|0;var b=0;b=f[a>>2]|0;f[a>>2]=b+-1;return b+-1|0}function TXc(a){a=a|0;PXc(a);return}function UXc(a){a=a|0;if(RXc(a)|0)VXc(a);return}function VXc(a){a=a|0;var b=0;b=a+8|0;if(!((f[b>>2]|0)!=0?(SXc(b)|0)!=-1:0))Yi[f[(f[a>>2]|0)+16>>2]&4095](a);return}function WXc(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0;b=u;u=u+16|0;c=b;d=eg(c|0)|0;do if(!d){e=Zd(c|0,1)|0;if(e|0){Qf(c|0)|0;f=e;break}e=ng(a|0,c|0)|0;g=Qf(c|0)|0;if(!e)if(!g){u=b;return}else{Zf(a|0)|0;f=g;break}else f=e}else f=d;while(0);WYc(f,527160)}function XXc(a){a=a|0;if(!(Zf(a|0)|0))return;else Id(527195,527082,64,527202)}function YXc(a){a=a|0;var b=0;b=f1c(a|0)|0;if(!b)return;else WYc(b,527219)}function ZXc(a){a=a|0;if(!(e1c(a|0)|0))return;else Id(527195,527082,80,527153)}function _Xc(a,b,c){a=a|0;b=b|0;c=c|0;f1c(897928)|0;while(1){if((f[a>>2]|0)!=1)break;Cf(897956,897928)|0}if(!(f[a>>2]|0)){f[a>>2]=1;e1c(897928)|0;Yi[c&4095](b);f1c(897928)|0;f[a>>2]=-1;e1c(897928)|0;m1c(897956)|0}else e1c(897928)|0;return}function $Xc(a){a=a|0;var b=0,c=0;b=(a|0)==0?1:a;while(1){a=jIc(b)|0;if(a|0){c=a;break}a=_0c()|0;if(!a){c=0;break}Ui[a&255]()}return c|0}function aYc(a,b){a=a|0;b=b|0;return $Xc(a)|0}function bYc(a){a=a|0;return $Xc(a)|0}function cYc(a){a=a|0;kIc(a);return}function dYc(a){a=a|0;cYc(a);return}function eYc(){tf()}function fYc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=dJc(b)|0;d=$Xc(c+13|0)|0;f[d>>2]=c;f[d+4>>2]=c;f[d+8>>2]=0;e=gYc(d)|0;o1c(e|0,b|0,c+1|0)|0;f[a>>2]=e;return}function gYc(a){a=a|0;return a+12|0}function hYc(a,b){a=a|0;b=b|0;f[a>>2]=192328;fYc(a+4|0,b);return}function iYc(a){a=a|0;return 1}function jYc(a){a=a|0;tf()}function kYc(a){a=a|0;tf()}function lYc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)jYc(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=$Xc(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}$Mc(i,g,h)|0;b[e>>0]=0;VNc(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function mYc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c+4>>2]|0:i&255;if(k>>>0<d>>>0)kYc(a);i=(j?f[c>>2]|0:c)+d|0;c=k-d|0;d=c>>>0<e>>>0?c:e;if(d>>>0>4294967279)jYc(a);if(d>>>0<11){b[a+11>>0]=d;l=a}else{e=d+16&-16;c=$Xc(e)|0;f[a>>2]=c;f[a+8>>2]=e|-2147483648;f[a+4>>2]=d;l=c}$Mc(l,i,d)|0;b[h>>0]=0;VNc(l+d|0,h);u=g;return}function nYc(a){a=a|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);return}function oYc(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;pYc(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)|0}return a|0}function pYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;qYc(l,c,d)|0;b[g>>0]=0;VNc(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;rYc(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return a|0}function qYc(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)q1c(a|0,b|0,c|0)|0;return a|0}function rYc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)jYc(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=$Xc(p)|0;if(g|0)$Mc(o,m,g)|0;if(i|0)$Mc(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)$Mc(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)cYc(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;VNc(o+p|0,l);u=k;return}function sYc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(c>>>0>4294967279)jYc(a);d=a+11|0;e=b[d>>0]|0;g=e<<24>>24<0;if(g){h=f[a+4>>2]|0;i=(f[a+8>>2]&2147483647)+-1|0}else{h=e&255;i=10}j=h>>>0>c>>>0?h:c;c=j>>>0<11;k=c?10:(j+16&-16)+-1|0;do if((k|0)!=(i|0)){do if(c){j=f[a>>2]|0;if(g){l=0;m=j;n=a;o=13}else{$Mc(a,j,(e&255)+1|0)|0;cYc(j);o=15}}else{j=$Xc(k+1|0)|0;if(g){l=1;m=f[a>>2]|0;n=j;o=13;break}else{$Mc(j,a,(e&255)+1|0)|0;p=j;o=14;break}}while(0);if((o|0)==13){$Mc(n,m,(f[a+4>>2]|0)+1|0)|0;cYc(m);if(l){p=n;o=14}else o=15}if((o|0)==14){f[a+8>>2]=k+1|-2147483648;f[a+4>>2]=h;f[a>>2]=p;break}else if((o|0)==15){b[d>>0]=h;break}}while(0);return}function tYc(a,b){a=a|0;b=b|0;return pYc(a,b,UNc(b)|0)|0}function uYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=f[a+4>>2]|0;else k=i&255;do if(k>>>0>=c>>>0)if(j){i=(f[a>>2]|0)+c|0;b[g>>0]=0;VNc(i,g);f[a+4>>2]=c;break}else{b[g>>0]=0;VNc(a+c|0,g);b[h>>0]=c;break}else vYc(a,c-k|0,d)|0;while(0);u=e;return}function vYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if(c|0){h=a+11|0;i=b[h>>0]|0;if(i<<24>>24<0){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=i&255;k=10}l=j+c|0;if((k-j|0)>>>0<c>>>0){wYc(a,k,l-k|0,j,j,0,0);m=b[h>>0]|0}else m=i;if(m<<24>>24<0)n=f[a>>2]|0;else n=a;iTc(n+j|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=l;else b[h>>0]=l;b[g>>0]=0;VNc(n+l|0,g)}u=e;return a|0}function wYc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;if((-17-c|0)>>>0<d>>>0)jYc(a);if((b[a+11>>0]|0)<0)j=f[a>>2]|0;else j=a;if(c>>>0<2147483623){k=d+c|0;d=c<<1;l=k>>>0<d>>>0?d:k;m=l>>>0<11?11:l+16&-16}else m=-17;l=$Xc(m)|0;if(g|0)$Mc(l,j,g)|0;k=e-h-g|0;if(k|0)$Mc(l+g+i|0,j+g+h|0,k)|0;if((c|0)!=10)cYc(j);f[a>>2]=l;f[a+8>>2]=m|-2147483648;return}function xYc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=b[a+11>>0]|0;e=d<<24>>24<0;if(e)g=f[a+4>>2]|0;else g=d&255;if(g>>>0<=c>>>0)kYc(a);if(e)h=f[a>>2]|0;else h=a;return h+c|0}function yYc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=b[a+11>>0]|0;e=d<<24>>24<0;if(e)g=f[a+4>>2]|0;else g=d&255;if(g>>>0<=c>>>0)kYc(a);if(e)h=f[a>>2]|0;else h=a;return h+c|0}function zYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;$Mc(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;VNc(m+i|0,g)}}else rYc(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function AYc(a,b){a=a|0;b=b|0;return zYc(a,b,UNc(b)|0)|0}function BYc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=10}if((j|0)==(k|0)){wYc(a,k,1,k,k,0,0);h=k+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=j+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+j|0;VNc(m,e);b[g>>0]=0;VNc(m+1|0,g);u=d;return}function CYc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=b[c+11>>0]|0;h=g<<24>>24<0;i=h?f[c+4>>2]|0:g&255;if(i>>>0<d>>>0)kYc(a);else{g=i-d|0;return zYc(a,(h?f[c>>2]|0:c)+d|0,g>>>0<e>>>0?g:e)|0}return 0}function DYc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=f[a+4>>2]|0;else l=j&255;if(l>>>0<c>>>0)kYc(a);if(k)m=(f[a+8>>2]&2147483647)+-1|0;else m=10;j=l+e|0;if((m-l|0)>>>0>=e>>>0){if(e|0){if(k)n=f[a>>2]|0;else n=a;k=l-c|0;o=n+c|0;if(!k)p=d;else{qYc(o+e|0,o,k)|0;p=o>>>0<=d>>>0&(n+l|0)>>>0>d>>>0?d+e|0:d}qYc(o,p,e)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;b[h>>0]=0;VNc(n+j|0,h)}}else rYc(a,m,j-m|0,l,c,0,e,d);u=g;return a|0}function EYc(a,b,c){a=a|0;b=b|0;c=c|0;return DYc(a,b,c,UNc(c)|0)|0}function FYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=f[a+4>>2]|0;else k=i&255;if(k>>>0<c>>>0)kYc(a);if(d|0){if(j)l=f[a>>2]|0;else l=a;j=k-c|0;m=j>>>0<d>>>0?j:d;d=j-m|0;if(!d)n=i;else{i=l+c|0;qYc(i,i+m|0,d)|0;n=b[h>>0]|0}d=k-m|0;if(n<<24>>24<0)f[a+4>>2]=d;else b[h>>0]=d;b[g>>0]=0;VNc(l+d|0,g)}u=e;return a|0}function GYc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+16|0;i=h;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l)m=f[a+4>>2]|0;else m=k&255;if(m>>>0<c>>>0)kYc(a);k=m-c|0;n=k>>>0<d>>>0?k:d;if(l)o=(f[a+8>>2]&2147483647)+-1|0;else o=10;if((n-m+o|0)>>>0<g>>>0)rYc(a,o,m+g-n-o|0,m,c,n,g,e);else{if(l)p=f[a>>2]|0;else p=a;do if((n|0)!=(g|0)){l=k-n|0;if(!l){q=n;r=c;s=e;t=g;v=21}else{o=p+c|0;if(n>>>0>g>>>0){qYc(o,e,g)|0;qYc(o+g|0,o+n|0,l)|0;w=n;x=g;break}do if(o>>>0<e>>>0&(p+m|0)>>>0>e>>>0)if((o+n|0)>>>0>e>>>0){qYc(o,e,n)|0;y=n+c|0;z=e+g|0;A=g-n|0;B=0;break}else{y=c;z=e+(g-n)|0;A=g;B=n;break}else{y=c;z=e;A=g;B=n}while(0);o=p+y|0;qYc(o+A|0,o+B|0,l)|0;q=B;r=y;s=z;t=A;v=21}}else{q=g;r=c;s=e;t=g;v=21}while(0);if((v|0)==21){qYc(p+r|0,s,t)|0;w=q;x=t}t=x-w+m|0;if((b[j>>0]|0)<0)f[a+4>>2]=t;else b[j>>0]=t;b[i>>0]=0;VNc(p+t|0,i)}u=h;return a|0}function HYc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return GYc(a,b,c,d,UNc(d)|0)|0}function IYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if(!c)e=0;else e=AJc(a,_Mc(b[d>>0]|0)|0,c)|0;return e|0}function JYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=b[a+11>>0]|0;if(h<<24>>24<0){i=f[a+4>>2]|0;j=f[a>>2]|0}else{i=h&255;j=a}b[g>>0]=c;if(i>>>0>d>>>0){c=IYc(j+d|0,i-d|0,g)|0;k=(c|0)==0?-1:c-j|0}else k=-1;u=e;return k|0}function KYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;if(e<<24>>24<0){g=f[a+4>>2]|0;h=f[a>>2]|0}else{g=e&255;h=a}a:do if(!g)i=-1;else{a=h+(g>>>0>d>>>0?d+1|0:g)|0;do{if((a|0)==(h|0)){i=-1;break a}a=a+-1|0}while(!($Nc(b[a>>0]|0,c)|0));i=a-h|0}while(0);return i|0}function LYc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=b[a+11>>0]|0;i=h<<24>>24<0;if(i)j=f[a+4>>2]|0;else j=h&255;if((g|0)==-1|j>>>0<c>>>0)kYc(a);h=j-c|0;j=h>>>0<d>>>0?h:d;if(i)k=f[a>>2]|0;else k=a;a=j>>>0>g>>>0;i=MXc(k+c|0,e,a?g:j)|0;if(!i)return (j>>>0<g>>>0?-1:a&1)|0;else return i|0;return 0}function MYc(a,b){a=a|0;b=b|0;return LYc(a,0,-1,b,UNc(b)|0)|0}function NYc(a){a=a|0;if((b[a+8+3>>0]|0)<0)cYc(f[a>>2]|0);return}function OYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=(f[h>>2]&2147483647)+-1|0;else l=1;do if(l>>>0>=d>>>0){if(k)m=f[a>>2]|0;else m=a;PYc(m,c,d)|0;f[g>>2]=0;pPc(m+(d<<2)|0,g);if((b[i>>0]|0)<0){f[a+4>>2]=d;break}else{b[i>>0]=d;break}}else{if(k)n=f[a+4>>2]|0;else n=j&255;QYc(a,l,d-l|0,n,0,n,d,c)}while(0);u=e;return a|0}function PYc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{_Kc(a,b,c)|0;d=a}return d|0}function QYc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=u;u=u+16|0;l=k;if((1073741806-c|0)>>>0<d>>>0)jYc(a);m=a+8|0;if((b[m+3>>0]|0)<0)n=f[a>>2]|0;else n=a;if(c>>>0<536870887){o=d+c|0;d=c<<1;p=o>>>0<d>>>0?d:o;o=p>>>0<2?2:p+4&-4;if(o>>>0>1073741823)tf();else q=o}else q=1073741807;o=$Xc(q<<2)|0;if(g|0)rNc(o,n,g)|0;if(i|0)rNc(o+(g<<2)|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)rNc(o+(g<<2)+(i<<2)|0,n+(g<<2)+(h<<2)|0,e)|0;if((c|0)!=1)cYc(n);f[a>>2]=o;f[m>>2]=q|-2147483648;q=j+i|0;f[a+4>>2]=q;f[l>>2]=0;pPc(o+(q<<2)|0,l);u=k;return}function RYc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(c>>>0>1073741807)jYc(a);d=a+8|0;e=d+3|0;g=b[e>>0]|0;h=g<<24>>24<0;if(h){i=f[a+4>>2]|0;j=(f[d>>2]&2147483647)+-1|0}else{i=g&255;j=1}k=i>>>0>c>>>0?i:c;c=k>>>0<2;l=c?1:(k+4&-4)+-1|0;do if((l|0)!=(j|0)){do if(c){k=f[a>>2]|0;if(h){m=0;n=k;o=a;p=15}else{rNc(a,k,(g&255)+1|0)|0;cYc(k);p=17}}else{k=l+1|0;if(k>>>0>1073741823)tf();q=$Xc(k<<2)|0;if(h){m=1;n=f[a>>2]|0;o=q;p=15;break}else{rNc(q,a,(g&255)+1|0)|0;r=q;p=16;break}}while(0);if((p|0)==15){rNc(o,n,(f[a+4>>2]|0)+1|0)|0;cYc(n);if(m){r=o;p=16}else p=17}if((p|0)==16){f[d>>2]=l+1|-2147483648;f[a+4>>2]=i;f[a>>2]=r;break}else if((p|0)==17){b[e>>0]=i;break}}while(0);return}function SYc(a,b){a=a|0;b=b|0;return OYc(a,b,pSc(b)|0)|0}function TYc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;if((1073741807-c|0)>>>0<d>>>0)jYc(a);j=a+8|0;if((b[j+3>>0]|0)<0)k=f[a>>2]|0;else k=a;if(c>>>0<536870887){l=d+c|0;d=c<<1;m=l>>>0<d>>>0?d:l;l=m>>>0<2?2:m+4&-4;if(l>>>0>1073741823)tf();else n=l}else n=1073741807;l=$Xc(n<<2)|0;if(g|0)rNc(l,k,g)|0;m=e-h-g|0;if(m|0)rNc(l+(g<<2)+(i<<2)|0,k+(g<<2)+(h<<2)|0,m)|0;if((c|0)!=1)cYc(k);f[a>>2]=l;f[j>>2]=n|-2147483648;return}function UYc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[h>>2]&2147483647)+-1|0}else{l=j&255;m=1}j=l+d|0;if((m-l|0)>>>0>=d>>>0){if(d|0){if(k)n=f[a>>2]|0;else n=a;rNc(n+(l<<2)|0,c,d)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;f[g>>2]=0;pPc(n+(j<<2)|0,g)}}else QYc(a,m,j-m|0,l,l,0,d,c);u=e;return a|0}function VYc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=d+4|0;f[e>>2]=c;c=a+8|0;h=c+3|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[c>>2]&2147483647)+-1|0}else{k=i&255;l=1}if((k|0)==(l|0)){TYc(a,l,1,l,l,0,0);i=l+1|0;if((b[h>>0]|0)<0){m=i;n=8}else{o=i;n=7}}else{i=k+1|0;if(j){m=i;n=8}else{o=i;n=7}}if((n|0)==7){b[h>>0]=o;p=a}else if((n|0)==8){n=f[a>>2]|0;f[a+4>>2]=m;p=n}n=p+(k<<2)|0;pPc(n,e);f[g>>2]=0;pPc(n+4|0,g);u=d;return}function WYc(a,b){a=a|0;b=b|0;tf()}function XYc(){var a=0,b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;b=a+32|0;c=a+24|0;d=a+16|0;e=a;g=a+36|0;a=YYc()|0;if(a|0?(h=f[a>>2]|0,h|0):0){a=h+48|0;i=f[a>>2]|0;j=f[a+4>>2]|0;if(!((i&-256|0)==1126902528&(j|0)==1129074247)){f[c>>2]=f[48059];ZYc(527333,c)}if((i|0)==1126902529&(j|0)==1129074247)k=f[h+44>>2]|0;else k=h+80|0;f[g>>2]=k;k=f[h>>2]|0;h=f[k+4>>2]|0;j=hj[f[(f[6314]|0)+16>>2]&511](25256,k,g)|0;k=f[48059]|0;if(j){j=f[g>>2]|0;g=_i[f[(f[j>>2]|0)+8>>2]&2047](j)|0;f[e>>2]=k;f[e+4>>2]=h;f[e+8>>2]=g;ZYc(527247,e)}else{f[d>>2]=k;f[d+4>>2]=h;ZYc(527292,d)}}ZYc(527371,b)}function YYc(){var a=0,b=0;a=u;u=u+16|0;if(!(Be(898004,180)|0)){b=Bf(f[224502]|0)|0;u=a;return b|0}else ZYc(527522,a);return 0}function ZYc(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=b;b=f[46249]|0;qJc(b,a,d)|0;ILc(10,b)|0;tf()}function _Yc(a){a=a|0;return}function $Yc(a){a=a|0;_Yc(a);cYc(a);return}function aZc(a){a=a|0;return}function bZc(a){a=a|0;return}function cZc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;if(!(gZc(a,b,0)|0))if((b|0)!=0?(g=kZc(b,25280,25264,0)|0,(g|0)!=0):0){b=e+4|0;h=b+52|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[e>>2]=g;f[e+8>>2]=a;f[e+12>>2]=-1;f[e+48>>2]=1;ei[f[(f[g>>2]|0)+28>>2]&511](g,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0;else j=1;u=d;return j|0}function dZc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;if(gZc(a,f[b+8>>2]|0,g)|0)jZc(0,b,c,d,e);return}function eZc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;do if(!(gZc(a,f[c+8>>2]|0,g)|0)){if(gZc(a,f[c>>2]|0,g)|0){h=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(i=c+20|0,(f[i>>2]|0)!=(d|0)):0){f[h>>2]=e;f[i>>2]=d;i=c+40|0;f[i>>2]=(f[i>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0)b[c+54>>0]=1;f[c+44>>2]=4;break}if((e|0)==1)f[h>>2]=1}}else iZc(0,c,d,e);while(0);return}function fZc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(gZc(a,f[b+8>>2]|0,0)|0)hZc(0,b,c,d);return}function gZc(a,b,c){a=a|0;b=b|0;c=c|0;return (a|0)==(b|0)|0}function hZc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=c+16|0;g=f[a>>2]|0;h=c+36|0;i=c+24|0;do if(g){if((g|0)!=(d|0)){f[h>>2]=(f[h>>2]|0)+1;f[i>>2]=2;b[c+54>>0]=1;break}if((f[i>>2]|0)==2)f[i>>2]=e}else{f[a>>2]=d;f[i>>2]=e;f[h>>2]=1}while(0);return}function iZc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((f[b+4>>2]|0)==(c|0)?(c=b+28|0,(f[c>>2]|0)!=1):0)f[c>>2]=d;return}function jZc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;b[c+53>>0]=1;do if((f[c+4>>2]|0)==(e|0)){b[c+52>>0]=1;a=c+16|0;h=f[a>>2]|0;i=c+54|0;j=c+48|0;k=c+24|0;l=c+36|0;if(!h){f[a>>2]=d;f[k>>2]=g;f[l>>2]=1;if(!((f[j>>2]|0)==1&(g|0)==1))break;b[i>>0]=1;break}if((h|0)!=(d|0)){f[l>>2]=(f[l>>2]|0)+1;b[i>>0]=1;break}l=f[k>>2]|0;if((l|0)==2){f[k>>2]=g;m=g}else m=l;if((f[j>>2]|0)==1&(m|0)==1)b[i>>0]=1}while(0);return}function kZc(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+64|0;i=h;j=f[a>>2]|0;k=a+(f[j+-8>>2]|0)|0;l=f[j+-4>>2]|0;f[i>>2]=e;f[i+4>>2]=a;f[i+8>>2]=c;f[i+12>>2]=g;g=i+16|0;c=i+20|0;a=i+24|0;j=i+28|0;m=i+32|0;n=i+40|0;o=g;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));d[g+36>>1]=0;b[g+38>>0]=0;a:do if(gZc(l,e,0)|0){f[i+48>>2]=1;Fh[f[(f[l>>2]|0)+20>>2]&255](l,i,k,k,1,0);q=(f[a>>2]|0)==1?k:0}else{gi[f[(f[l>>2]|0)+24>>2]&255](l,i,k,1,0);switch(f[i+36>>2]|0){case 0:{q=(f[n>>2]|0)==1&(f[j>>2]|0)==1&(f[m>>2]|0)==1?f[c>>2]|0:0;break a;break}case 1:break;default:{q=0;break a}}if((f[a>>2]|0)!=1?!((f[n>>2]|0)==0&(f[j>>2]|0)==1&(f[m>>2]|0)==1):0){q=0;break}q=f[g>>2]|0}while(0);u=h;return q|0}function lZc(a){a=a|0;_Yc(a);cYc(a);return}function mZc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;if(gZc(a,f[b+8>>2]|0,g)|0)jZc(0,b,c,d,e);else{h=f[a+8>>2]|0;Fh[f[(f[h>>2]|0)+20>>2]&255](h,b,c,d,e,g)}return}function nZc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;do if(!(gZc(a,f[c+8>>2]|0,g)|0)){h=a+8|0;if(!(gZc(a,f[c>>2]|0,g)|0)){i=f[h>>2]|0;gi[f[(f[i>>2]|0)+24>>2]&255](i,c,d,e,g);break}i=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(j=c+20|0,(f[j>>2]|0)!=(d|0)):0){f[i>>2]=e;k=c+44|0;if((f[k>>2]|0)==4)break;l=c+52|0;b[l>>0]=0;m=c+53|0;b[m>>0]=0;n=f[h>>2]|0;Fh[f[(f[n>>2]|0)+20>>2]&255](n,c,d,d,1,g);if(b[m>>0]|0)if(!(b[l>>0]|0)){o=3;p=11}else q=3;else{o=4;p=11}if((p|0)==11){f[j>>2]=d;j=c+40|0;f[j>>2]=(f[j>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0){b[c+54>>0]=1;q=o}else q=o}f[k>>2]=q;break}if((e|0)==1)f[i>>2]=1}else iZc(0,c,d,e);while(0);return}function oZc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(gZc(a,f[b+8>>2]|0,0)|0)hZc(0,b,c,d);else{e=f[a+8>>2]|0;ei[f[(f[e>>2]|0)+28>>2]&511](e,b,c,d)}return}function pZc(a){a=a|0;return}function qZc(){var a=0;a=u;u=u+16|0;if(!(nf(898008,2301)|0)){u=a;return}else ZYc(527571,a)}function rZc(a){a=a|0;var b=0;b=u;u=u+16|0;kIc(a);if(!(fg(f[224502]|0,0)|0)){u=b;return}else ZYc(527621,b)}function sZc(){var a=0,b=0;a=YYc()|0;if((a|0?(b=f[a>>2]|0,b|0):0)?(a=b+48|0,(f[a>>2]&-256|0)==1126902528?(f[a+4>>2]|0)==1129074247:0):0)tZc(f[b+12>>2]|0);tZc(uZc()|0)}function tZc(a){a=a|0;var b=0;b=u;u=u+16|0;Ui[a&255]();ZYc(527674,b)}function uZc(){var a=0;a=f[48058]|0;f[48058]=a+0;return a|0}function vZc(a){a=a|0;return}function wZc(a){a=a|0;f[a>>2]=192328;AZc(a+4|0);return}function xZc(a){a=a|0;wZc(a);cYc(a);return}function yZc(a){a=a|0;return zZc(a+4|0)|0}function zZc(a){a=a|0;return f[a>>2]|0}function AZc(a){a=a|0;var b=0,c=0;if(iYc(a)|0?(b=BZc(f[a>>2]|0)|0,a=b+8|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c+-1|0)<0):0)cYc(b);return}function BZc(a){a=a|0;return a+-12|0}function CZc(a){a=a|0;wZc(a);cYc(a);return}function DZc(a){a=a|0;wZc(a);cYc(a);return}function EZc(a){a=a|0;return}function FZc(a){a=a|0;EZc(a);cYc(a);return}function GZc(a){a=a|0;return 527764}function HZc(a){a=a|0;_Yc(a);cYc(a);return}function IZc(a,b,c){a=a|0;b=b|0;c=c|0;return gZc(a,b,0)|0}function JZc(a){a=a|0;_Yc(a);cYc(a);return}function KZc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;f[c>>2]=f[f[c>>2]>>2];if(!(LZc(a,b,0)|0))if(((b|0)!=0?(g=kZc(b,25280,25400,0)|0,(g|0)!=0):0)?(f[g+8>>2]&~f[a+8>>2]|0)==0:0){b=a+12|0;a=g+12|0;if(!(gZc(f[b>>2]|0,f[a>>2]|0,0)|0)?!(gZc(f[b>>2]|0,25432,0)|0):0){g=f[b>>2]|0;if((((g|0)!=0?(b=kZc(g,25280,25264,0)|0,(b|0)!=0):0)?(g=f[a>>2]|0,(g|0)!=0):0)?(a=kZc(g,25280,25264,0)|0,(a|0)!=0):0){g=e+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=a;f[e+8>>2]=b;f[e+12>>2]=-1;f[e+48>>2]=1;ei[f[(f[a>>2]|0)+28>>2]&511](a,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0}else j=1}else j=0;else j=1;u=d;return j|0}function LZc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(gZc(a,b,0)|0)d=1;else d=gZc(b,25440,0)|0;return d|0}function MZc(a){a=a|0;_Yc(a);cYc(a);return}function NZc(a,b,c){a=a|0;b=b|0;c=c|0;return gZc(a,b,0)|0}function OZc(a){a=a|0;_Yc(a);cYc(a);return}function PZc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(gZc(a,f[c+8>>2]|0,h)|0)jZc(0,c,d,e,g);else{i=c+52|0;j=b[i>>0]|0;k=c+53|0;l=b[k>>0]|0;m=f[a+12>>2]|0;n=a+16+(m<<3)|0;b[i>>0]=0;b[k>>0]=0;TZc(a+16|0,c,d,e,g,h);a:do if((m|0)>1){o=c+24|0;p=c+54|0;q=a+8|0;r=a+24|0;do{if(b[p>>0]|0)break a;if(!(b[i>>0]|0)){if(b[k>>0]|0?(f[q>>2]&1|0)==0:0)break a}else{if((f[o>>2]|0)==1)break a;if(!(f[q>>2]&2))break a}b[i>>0]=0;b[k>>0]=0;TZc(r,c,d,e,g,h);r=r+8|0}while(r>>>0<n>>>0)}while(0);b[i>>0]=j;b[k>>0]=l}return}function QZc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a:do if(!(gZc(a,f[c+8>>2]|0,g)|0)){h=a+12|0;i=c+24|0;j=c+36|0;k=c+54|0;l=a+8|0;m=a+16|0;if(!(gZc(a,f[c>>2]|0,g)|0)){n=f[h>>2]|0;o=a+16+(n<<3)|0;UZc(m,c,d,e,g);p=a+24|0;if((n|0)<=1)break;n=f[l>>2]|0;if((n&2|0)==0?(f[j>>2]|0)!=1:0){if(!(n&1)){n=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1)break a;UZc(n,c,d,e,g);n=n+8|0;if(n>>>0>=o>>>0)break a}}else q=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1?(f[i>>2]|0)==1:0)break a;UZc(q,c,d,e,g);q=q+8|0;if(q>>>0>=o>>>0)break a}}else r=p;while(1){if(b[k>>0]|0)break a;UZc(r,c,d,e,g);r=r+8|0;if(r>>>0>=o>>>0)break a}}o=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(p=c+20|0,(f[p>>2]|0)!=(d|0)):0){f[o>>2]=e;n=c+44|0;if((f[n>>2]|0)==4)break;s=a+16+(f[h>>2]<<3)|0;t=c+52|0;u=c+53|0;v=0;w=m;x=0;b:while(1){if(w>>>0>=s>>>0){y=v;z=18;break}b[t>>0]=0;b[u>>0]=0;TZc(w,c,d,d,1,g);if(b[k>>0]|0){y=v;z=18;break}do if(b[u>>0]|0){if(!(b[t>>0]|0))if(!(f[l>>2]&1)){y=1;z=18;break b}else{A=1;B=x;break}if((f[i>>2]|0)==1){z=23;break b}if(!(f[l>>2]&2)){z=23;break b}else{A=1;B=1}}else{A=v;B=x}while(0);v=A;w=w+8|0;x=B}do if((z|0)==18){if((!x?(f[p>>2]=d,w=c+40|0,f[w>>2]=(f[w>>2]|0)+1,(f[j>>2]|0)==1):0)?(f[i>>2]|0)==2:0){b[k>>0]=1;if(y){z=23;break}else{C=4;break}}if(y)z=23;else C=4}while(0);if((z|0)==23)C=3;f[n>>2]=C;break}if((e|0)==1)f[o>>2]=1}else iZc(0,c,d,e);while(0);return}function RZc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(!(gZc(a,f[c+8>>2]|0,0)|0)){g=f[a+12>>2]|0;h=a+16+(g<<3)|0;SZc(a+16|0,c,d,e);if((g|0)>1){g=c+54|0;i=a+24|0;do{SZc(i,c,d,e);if(b[g>>0]|0)break a;i=i+8|0}while(i>>>0<h>>>0)}}else hZc(0,c,d,e);while(0);return}function SZc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a+4>>2]|0;g=e>>8;if(!(e&1))h=g;else h=f[(f[c>>2]|0)+g>>2]|0;g=f[a>>2]|0;ei[f[(f[g>>2]|0)+28>>2]&511](g,b,c+h|0,e&2|0?d:2);return}function TZc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a+4>>2]|0;i=h>>8;if(!(h&1))j=i;else j=f[(f[d>>2]|0)+i>>2]|0;i=f[a>>2]|0;Fh[f[(f[i>>2]|0)+20>>2]&255](i,b,c,d+j|0,h&2|0?e:2,g);return}function UZc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a+4>>2]|0;h=g>>8;if(!(g&1))i=h;else i=f[(f[c>>2]|0)+h>>2]|0;h=f[a>>2]|0;gi[f[(f[h>>2]|0)+24>>2]&255](h,b,c+i|0,g&2|0?d:2,e);return}function VZc(a){a=a|0;f[a>>2]=192388;return}function WZc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+4192|0;h=g+4176|0;i=g;j=g+4112|0;k=(e|0)!=0;if((a|0)!=0?(l=(c|0)!=0,m=(d|0)==0,!(l&m)):0){if(l)n=f[d>>2]|0;else n=0;XZc(i);YZc(j,i);l=j+48|0;o=j+61|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+12>>0]=0;b[o>>0]=1;l=j+32|0;p=j+36|0;q=f[p>>2]|0;if(q>>>0<(f[j+40>>2]|0)>>>0){ZZc(h,i);f[q>>2]=0;f[q+4>>2]=0;r=f[h>>2]|0;f[q+8>>2]=0;f[q+12>>2]=r;f[p>>2]=(f[p>>2]|0)+16}else _Zc(l,i);r=j+62|0;b[r>>0]=0;b[j+63>>0]=1;f[h>>2]=0;q=a+(dJc(a)|0)|0;$Zc(a,q,j,h);s=f[h>>2]|0;do if(!((s|0)!=0|(b[r>>0]|0)==0)){t=f[l>>2]|0;if((t|0)!=(f[p>>2]|0)?(f[t>>2]|0)!=(f[t+4>>2]|0):0){b[r>>0]=0;b[o>>0]=0;t=f[j>>2]|0;v=j+4|0;while(1){w=f[v>>2]|0;if((w|0)==(t|0))break;x=w+-24|0;f[v>>2]=x;a_c(x)}v=f[j+16>>2]|0;t=j+20|0;while(1){x=f[t>>2]|0;if((x|0)==(v|0))break;w=x+-16|0;f[t>>2]=w;b_c(w)}$Zc(a,q,j,h);if(!(b[r>>0]|0)){y=f[h>>2]|0;z=22;break}else{f[h>>2]=-2;A=0;B=-2;break}}else z=23}else{y=s;z=22}while(0);if((z|0)==22)if(!y)z=23;else{A=0;B=y}do if((z|0)==23){y=j+4|0;s=c_c((f[y>>2]|0)+-24|0)|0;r=s+1|0;if(r>>>0>n>>>0){q=lIc(c,r)|0;if(!q){f[h>>2]=-1;A=0;B=-1;break}if(m)C=q;else{f[d>>2]=r;C=q}}else if(!c){A=0;B=0;break}else C=c;q=f[y>>2]|0;r=q+-12|0;a=b[r+11>>0]|0;o=a<<24>>24<0;d_c(q+-24|0,o?f[r>>2]|0:r,o?f[q+-8>>2]|0:a&255)|0;a=(f[y>>2]|0)+-24|0;if((b[a+11>>0]|0)<0)D=f[a>>2]|0;else D=a;o1c(C|0,D|0,s|0)|0;b[C+s>>0]=0;A=C;B=0}while(0);if(k)f[e>>2]=B;e_c(j);f_c(i);E=A}else if(k){f[e>>2]=-3;E=0}else E=0;u=g;return E|0}function XZc(a){a=a|0;f[a+4096>>2]=a;return}function YZc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;T0c(d,b);f[a>>2]=0;f[a+4>>2]=0;e=f[d>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;ZZc(d,b);U0c(a+16|0,d);V0c(d,b);W0c(a+32|0,d);u=c;return}function ZZc(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function _Zc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=t0c(a)|0;if(i>>>0<h>>>0)kWc(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;u0c(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;ZZc(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;v0c(a,e);w0c(e);u=c;return}}function $Zc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(a>>>0<c>>>0){b:do if((b[a>>0]|0)!=95){if((v_c(a,c,d)|0)!=(c|0)){f[e>>2]=-2;break a}}else{if((c-a|0)<=3){f[e>>2]=-2;break a}g=a+2|0;switch(b[a+1>>0]|0){case 90:{h=s_c(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?(b[h>>0]|0)==46:0)i=t_c(h,c,d)|0;else i=h;if((i|0)==(c|0))break b;f[e>>2]=-2;break a;break}case 95:{if((b[g>>0]|0)==95?(b[a+3>>0]|0)==90:0){g=a+4|0;h=s_c(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?(u_c(h,c,d)|0)==(c|0):0)break b;f[e>>2]=-2;break a}break}default:{}}f[e>>2]=-2;break a}while(0);if((f[e>>2]|0)==0?(f[d>>2]|0)==(f[d+4>>2]|0):0)f[e>>2]=-2}else f[e>>2]=-2;while(0);return}function a_c(a){a=a|0;r_c(a+12|0);r_c(a);return}function b_c(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;a_c(e)}c=f[a>>2]|0;q_c(a+12|0,c,((f[a+8>>2]|0)-c|0)/24|0)}return}function c_c(a){a=a|0;var c=0,d=0,e=0;c=b[a+11>>0]|0;if(c<<24>>24<0)d=f[a+4>>2]|0;else d=c&255;c=b[a+12+11>>0]|0;if(c<<24>>24<0)e=f[a+16>>2]|0;else e=c&255;return e+d|0}function d_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;$Mc(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;VNc(m+i|0,g)}}else n_c(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function e_c(a){a=a|0;g_c(a+32|0);h_c(a+16|0);b_c(a);return}function f_c(a){a=a|0;f[a+4096>>2]=0;return}function g_c(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;h_c(e)}c=f[a>>2]|0;m_c(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function h_c(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;b_c(e)}c=f[a>>2]|0;i_c(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function i_c(a,b,c){a=a|0;b=b|0;c=c|0;j_c(f[a>>2]|0,b,c<<4);return}function j_c(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(k_c(a,b)|0){d=b+(l_c(c)|0)|0;c=a+4096|0;if((d|0)==(f[c>>2]|0))f[c>>2]=b}else kIc(b);return}function k_c(a,b){a=a|0;b=b|0;return a>>>0<=b>>>0&(a+4096|0)>>>0>=b>>>0|0}function l_c(a){a=a|0;return a+15&-16|0}function m_c(a,b,c){a=a|0;b=b|0;c=c|0;j_c(f[a>>2]|0,b,c<<4);return}function n_c(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)jYc(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=o_c(p)|0;if(g|0)$Mc(o,m,g)|0;if(i|0)$Mc(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)$Mc(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)p_c(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;VNc(o+p|0,l);u=k;return}function o_c(a){a=a|0;return jIc(a)|0}function p_c(a){a=a|0;kIc(a);return}function q_c(a,b,c){a=a|0;b=b|0;c=c|0;j_c(f[a>>2]|0,b,c*24|0);return}function r_c(a){a=a|0;if((b[a+11>>0]|0)<0)p_c(f[a>>2]|0);return}function s_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+12|0;l=e;if((a|0)!=(c|0)){m=d+56|0;N0c(h,m);f[m>>2]=(f[m>>2]|0)+1;n=d+61|0;O0c(i,n);if((f[m>>2]|0)>>>0>1)b[n>>0]=1;a:do switch(b[a>>0]|0){case 84:case 71:{o=P0c(a,c,d)|0;p=1;break}default:{m=U_c(a,c,d)|0;q=f[d+48>>2]|0;r=f[d+52>>2]|0;b:do if((m|0)!=(a|0))if((m|0)!=(c|0)){switch(b[m>>0]|0){case 46:case 69:{s=m;break b;break}default:{}}O0c(j,n);b[n>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;t=0;while(1){if((t|0)==3)break;f[k+(t<<2)>>2]=0;t=t+1|0}t=d+4|0;v=f[t>>2]|0;c:do if((f[d>>2]|0)!=(v|0)){w=v+-24|0;x=b[w+11>>0]|0;y=x<<24>>24<0;if(y)z=f[v+-20>>2]|0;else z=x&255;if(z){if(!(b[d+60>>0]|0)){if(y){A=f[w>>2]|0;B=f[v+-20>>2]|0}else{A=w;B=x&255}if((b[A+B+-1>>0]|0)==62){if(y){C=f[v+-20>>2]|0;D=f[w>>2]|0}else{C=x&255;D=w}if((b[D+(C+-2)>>0]|0)!=45){if(y){E=f[v+-20>>2]|0;F=f[w>>2]|0}else{E=x&255;F=w}if((b[F+(E+-2)>>0]|0)!=62){w=v_c(m,c,d)|0;if((w|0)==(m|0)){G=a;H=0;break}x=f[t>>2]|0;y=x;if(((x-(f[d>>2]|0)|0)/24|0)>>>0<2){G=a;H=0;break}x=y+-24|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2];f[l+8>>2]=f[x+8>>2];I=0;while(1){if((I|0)==3)break;f[x+(I<<2)>>2]=0;I=I+1|0}I=y+-12|0;x=k+11|0;if((b[x>>0]|0)<0){J=f[k>>2]|0;b[g>>0]=0;VNc(J,g);f[k+4>>2]=0}else{b[g>>0]=0;VNc(k,g);b[x>>0]=0}__c(k);f[k>>2]=f[I>>2];f[k+4>>2]=f[I+4>>2];f[k+8>>2]=f[I+8>>2];J=0;while(1){if((J|0)==3)break;f[I+(J<<2)>>2]=0;J=J+1|0}J=b[x>>0]|0;if(!((J<<24>>24<0?f[k+4>>2]|0:J&255)|0))S$c(l,32);J=f[t>>2]|0;I=J+-24|0;y=J;while(1){if((y|0)==(I|0))break;K=y+-24|0;f[t>>2]=K;a_c(K);y=f[t>>2]|0}y=b[l+11>>0]|0;I=y<<24>>24<0;A0c(J+-48|0,0,I?f[l>>2]|0:l,I?f[l+4>>2]|0:y&255)|0;r_c(l);L=w;M=f[t>>2]|0}else{L=m;M=v}}else{L=m;M=v}}else{L=m;M=v}}else{L=m;M=v}S$c(M+-24|0,40);if((L|0)!=(c|0)?(b[L>>0]|0)==118:0){N=L+1|0;O=f[d>>2]|0;P=f[t>>2]|0}else Q=49;do if((Q|0)==49){y=g+11|0;I=g+4|0;x=l+11|0;K=l+4|0;R=1;S=L;d:while(1){T=S;U=f[d>>2]|0;V=f[t>>2]|0;while(1){W=(V-U|0)/24|0;X=v_c(T,c,d)|0;V=f[t>>2]|0;U=f[d>>2]|0;Y=(V-U|0)/24|0;if((X|0)==(T|0)){Q=72;break d}if(Y>>>0>W>>>0)break;else T=X}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Z=0;while(1){if((Z|0)==3){_=W;break}f[g+(Z<<2)>>2]=0;Z=Z+1|0}while(1){if(_>>>0>=Y>>>0){$=W;break}Z=b[y>>0]|0;if((Z<<24>>24<0?f[I>>2]|0:Z&255)|0)z_c(g,528271)|0;N_c(l,(f[d>>2]|0)+(_*24|0)|0);Z=b[x>>0]|0;aa=Z<<24>>24<0;d_c(g,aa?f[l>>2]|0:l,aa?f[K>>2]|0:Z&255)|0;r_c(l);_=_+1|0}while(1){if($>>>0>=Y>>>0)break;Z=f[t>>2]|0;aa=Z+-24|0;ba=Z;while(1){if((ba|0)==(aa|0))break;Z=ba+-24|0;f[t>>2]=Z;a_c(Z);ba=f[t>>2]|0}$=$+1|0}ba=b[y>>0]|0;aa=f[I>>2]|0;if(!((ba<<24>>24<0?aa:ba&255)|0))ca=R;else{Z=f[t>>2]|0;if((f[d>>2]|0)==(Z|0)){Q=84;break}if(R){da=Z;ea=ba;fa=aa}else{z_c(Z+-24|0,528271)|0;da=f[t>>2]|0;ea=b[y>>0]|0;fa=f[I>>2]|0}Z=ea<<24>>24<0;d_c(da+-24|0,Z?f[g>>2]|0:g,Z?fa:ea&255)|0;ca=0}r_c(g);R=ca;S=X}if((Q|0)==72){N=T;O=U;P=V;break}else if((Q|0)==84){r_c(g);G=a;H=0;break c}}while(0);if((O|0)!=(P|0)){S$c(P+-24|0,41);if(q&1|0)z_c((f[t>>2]|0)+-24|0,527994)|0;if(q&2|0)z_c((f[t>>2]|0)+-24|0,528001)|0;if(q&4|0)z_c((f[t>>2]|0)+-24|0,528011)|0;switch(r|0){case 1:{z_c((f[t>>2]|0)+-24|0,529475)|0;break}case 2:{z_c((f[t>>2]|0)+-24|0,529478)|0;break}default:{}}w=b[k+11>>0]|0;J=w<<24>>24<0;d_c((f[t>>2]|0)+-24|0,J?f[k>>2]|0:k,J?f[k+4>>2]|0:w&255)|0;G=N;H=1}else{G=a;H=0}}else{G=a;H=0}}else{G=a;H=0}while(0);r_c(k);Q0c(j);if(H)s=G;else{o=G;p=0;break a}}else s=c;else s=a;while(0);o=s;p=1}}while(0);Q0c(i);R0c(h);if(p){ga=o;Q=88}else ha=a}else{ga=a;Q=88}if((Q|0)==88)ha=ga;u=e;return ha|0}function t_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((a|0)!=(c|0)?(b[a>>0]|0)==46:0)?(k=d+4|0,(f[d>>2]|0)!=(f[k>>2]|0)):0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=c-a|0;if(d>>>0>4294967279)jYc(j);if(d>>>0<11){b[j+11>>0]=d;l=j}else{m=d+16&-16;n=o_c(m)|0;f[j>>2]=n;f[j+8>>2]=m|-2147483648;f[j+4>>2]=d;l=n}n=a;m=l;while(1){if((n|0)==(c|0))break;VNc(m,n);n=n+1|0;m=m+1|0}b[g>>0]=0;VNc(l+d|0,g);y_c(j,0,528044)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];g=0;while(1){if((g|0)==3)break;f[j+(g<<2)>>2]=0;g=g+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];g=0;while(1){if((g|0)==3)break;f[i+(g<<2)>>2]=0;g=g+1|0}g=b[h+11>>0]|0;d=g<<24>>24<0;d_c((f[k>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:g&255)|0;r_c(h);r_c(i);r_c(j);o=c}else o=a;u=e;return o|0}function u_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if((c-a|0)>12){e=0;g=a;while(1){h=g+1|0;if((e|0)>=13)break;if((b[g>>0]|0)==(b[529680+e>>0]|0)){e=e+1|0;g=h}else{i=a;break a}}b:do if((g|0)==(c|0))j=c;else{if((b[g>>0]|0)==95){if((h|0)==(c|0)){i=a;break a}if(((b[h>>0]|0)+-48|0)>>>0>=10){i=a;break a}k=g+2|0}else k=g;while(1){if((k|0)==(c|0)){j=c;break b}if(((b[k>>0]|0)+-48|0)>>>0>=10){j=k;break b}k=k+1|0}}while(0);g=f[d+4>>2]|0;if((f[d>>2]|0)!=(g|0)){y_c(g+-24|0,0,529694)|0;i=j}else i=a}else i=a;while(0);return i|0}function v_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+144|0;g=e+128|0;h=e+104|0;i=e+40|0;j=e+88|0;k=e+24|0;l=e+76|0;m=e+12|0;n=e;o=e+64|0;a:do if((a|0)!=(c|0)){p=d+16|0;switch(b[a>>0]|0){case 75:case 86:case 114:{f[g>>2]=0;q=w_c(a,c,g)|0;b:do if((q|0)!=(a|0)?(r=(b[q>>0]|0)==70,s=d+4|0,t=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,v=v_c(q,c,d)|0,w=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,(v|0)!=(q|0)):0){s=d+20|0;x=f[s>>2]|0;c:do if(r){y=x+-16|0;z=x;while(1){if((z|0)==(y|0)){A=y;break c}B=z+-16|0;f[s>>2]=B;b_c(B);z=f[s>>2]|0}}else A=x;while(0);f[h>>2]=f[d+12>>2];if(A>>>0<(f[d+24>>2]|0)>>>0){f[A>>2]=0;f[A+4>>2]=0;x=f[h>>2]|0;f[A+8>>2]=0;f[A+12>>2]=x;f[s>>2]=(f[s>>2]|0)+16}else x_c(p,h);x=f[g>>2]|0;z=(x&1|0)==0;y=(x&2|0)==0;B=(x&4|0)==0;x=t;while(1){if(x>>>0>=w>>>0){C=v;break b}if(r){D=f[d>>2]|0;E=D+(x*24|0)+12|0;F=b[E+11>>0]|0;G=F<<24>>24<0;if(G){H=f[D+(x*24|0)+16>>2]|0;I=f[E>>2]|0}else{H=F&255;I=E}J=H+-2|0;if((b[I+J>>0]|0)==38)K=H+-3|0;else{if(G){L=f[E>>2]|0;M=f[D+(x*24|0)+16>>2]|0}else{L=E;M=F&255}K=(b[L+M+-1>>0]|0)==38?J:H}if(z)N=K;else{y_c(E,K,527994)|0;N=K+6|0}if(y)O=N;else{y_c((f[d>>2]|0)+(x*24|0)+12|0,N,528001)|0;O=N+9|0}if(!B)y_c((f[d>>2]|0)+(x*24|0)+12|0,O,528011)|0}else{if(!z)z_c((f[d>>2]|0)+(x*24|0)|0,527994)|0;if(!y)z_c((f[d>>2]|0)+(x*24|0)|0,528001)|0;if(!B)z_c((f[d>>2]|0)+(x*24|0)|0,528011)|0}E=f[s>>2]|0;J=(f[d>>2]|0)+(x*24|0)|0;F=E+-12|0;D=f[F>>2]|0;if((D|0)==(f[E+-8>>2]|0))B_c(E+-16|0,J);else{A_c(D,J);f[F>>2]=(f[F>>2]|0)+24}x=x+1|0}}else C=a;while(0);P=C;break a;break}default:{}}q=C_c(a,c,d)|0;if((q|0)==(a|0)){x=a+1|0;s=(x|0)!=(c|0);d:do switch(b[a>>0]|0){case 65:{B=D_c(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];E_c(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else F_c(p,g);b_c(g);P=B;break a;break}case 67:{B=v_c(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}y=d+4|0;v=f[y>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}z_c(v+-24|0,528021)|0;v=(f[y>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];E_c(g,v,h);v=d+20|0;y=f[v>>2]|0;if(y>>>0<(f[d+24>>2]|0)>>>0){f[y>>2]=0;r=y+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[y+8>>2]=0;f[y+12>>2]=z;f[y>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[y+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(p,g);b_c(g);P=B;break a;break}case 70:{B=G_c(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}v=f[d+4>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}f[h>>2]=f[d+12>>2];E_c(g,v+-24|0,h);v=d+20|0;z=f[v>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;y=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=y;f[z>>2]=f[g>>2];y=g+4|0;f[r>>2]=f[y>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(p,g);b_c(g);P=B;break a;break}case 71:{B=v_c(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}v=d+4|0;y=f[v>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}z_c(y+-24|0,528030)|0;y=(f[v>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];E_c(g,y,h);y=d+20|0;v=f[y>>2]|0;if(v>>>0<(f[d+24>>2]|0)>>>0){f[v>>2]=0;r=v+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[v+8>>2]=0;f[v+12>>2]=z;f[v>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[v+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else F_c(p,g);b_c(g);P=B;break a;break}case 77:{B=H_c(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];E_c(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else F_c(p,g);b_c(g);P=B;break a;break}case 79:{B=d+4|0;y=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;v=v_c(x,c,d)|0;r=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;if((v|0)==(x|0)){P=a;break a}B=f[d+12>>2]|0;f[g>>2]=B;z=d+20|0;w=f[z>>2]|0;if(w>>>0<(f[d+24>>2]|0)>>>0){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=B;f[z>>2]=(f[z>>2]|0)+16}else x_c(p,g);B=g+11|0;w=g+4|0;t=y;while(1){if(t>>>0>=r>>>0){P=v;break a}I_c(g,(f[d>>2]|0)+(t*24|0)+12|0,2);y=UNc(528041)|0;F=b[B>>0]|0;if((y|0)==((F<<24>>24<0?f[w>>2]|0:F&255)|0))Q=(J_c(g,528041,y)|0)==0;else Q=0;r_c(g);y=f[d>>2]|0;if(!Q){F=y+(t*24|0)+12|0;if((b[F+11>>0]|0)<0)R=f[F>>2]|0;else R=F;if((b[R>>0]|0)==40){z_c(y+(t*24|0)|0,528049)|0;y_c((f[d>>2]|0)+(t*24|0)+12|0,0,528047)|0}}else{z_c(y+(t*24|0)|0,528044)|0;y_c((f[d>>2]|0)+(t*24|0)+12|0,0,528047)|0}z_c((f[d>>2]|0)+(t*24|0)|0,528051)|0;y=f[z>>2]|0;F=(f[d>>2]|0)+(t*24|0)|0;J=y+-12|0;D=f[J>>2]|0;if((D|0)==(f[y+-8>>2]|0))B_c(y+-16|0,F);else{A_c(D,F);f[J>>2]=(f[J>>2]|0)+24}t=t+1|0}break}case 80:{t=d+4|0;z=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;w=v_c(x,c,d)|0;B=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;if((w|0)==(x|0)){P=a;break a}t=f[d+12>>2]|0;f[g>>2]=t;v=d+20|0;r=f[v>>2]|0;if(r>>>0<(f[d+24>>2]|0)>>>0){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=t;f[v>>2]=(f[v>>2]|0)+16}else x_c(p,g);t=g+11|0;r=g+4|0;J=g+11|0;F=g+4|0;D=z;while(1){if(D>>>0>=B>>>0){P=w;break a}I_c(g,(f[d>>2]|0)+(D*24|0)+12|0,2);z=UNc(528041)|0;y=b[t>>0]|0;if((z|0)==((y<<24>>24<0?f[r>>2]|0:y&255)|0))S=(J_c(g,528041,z)|0)==0;else S=0;r_c(g);z=f[d>>2]|0;if(!S){y=z+(D*24|0)+12|0;if((b[y+11>>0]|0)<0)T=f[y>>2]|0;else T=y;if((b[T>>0]|0)==40){z_c(z+(D*24|0)|0,528049)|0;y_c((f[d>>2]|0)+(D*24|0)+12|0,0,528047)|0}}else{z_c(z+(D*24|0)|0,528044)|0;y_c((f[d>>2]|0)+(D*24|0)+12|0,0,528047)|0}if((b[x>>0]|0)==85){I_c(g,(f[d>>2]|0)+(D*24|0)|0,12);z=UNc(528054)|0;y=b[J>>0]|0;if((z|0)==((y<<24>>24<0?f[F>>2]|0:y&255)|0))U=(J_c(g,528054,z)|0)!=0;else U=1;r_c(g);z=(f[d>>2]|0)+(D*24|0)|0;if(U){V=z;W=112}else K_c(z)}else{V=(f[d>>2]|0)+(D*24|0)|0;W=112}if((W|0)==112){W=0;z_c(V,528067)|0}z=f[v>>2]|0;y=(f[d>>2]|0)+(D*24|0)|0;E=z+-12|0;G=f[E>>2]|0;if((G|0)==(f[z+-8>>2]|0))B_c(z+-16|0,y);else{A_c(G,y);f[E>>2]=(f[E>>2]|0)+24}D=D+1|0}break}case 82:{D=d+4|0;v=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;F=v_c(x,c,d)|0;J=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((F|0)==(x|0)){P=a;break a}D=f[d+12>>2]|0;f[g>>2]=D;r=d+20|0;t=f[r>>2]|0;if(t>>>0<(f[d+24>>2]|0)>>>0){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=D;f[r>>2]=(f[r>>2]|0)+16}else x_c(p,g);D=g+11|0;t=g+4|0;w=v;while(1){if(w>>>0>=J>>>0){P=F;break a}I_c(g,(f[d>>2]|0)+(w*24|0)+12|0,2);v=UNc(528041)|0;B=b[D>>0]|0;if((v|0)==((B<<24>>24<0?f[t>>2]|0:B&255)|0))X=(J_c(g,528041,v)|0)==0;else X=0;r_c(g);v=f[d>>2]|0;if(!X){B=v+(w*24|0)+12|0;if((b[B+11>>0]|0)<0)Y=f[B>>2]|0;else Y=B;if((b[Y>>0]|0)==40){z_c(v+(w*24|0)|0,528049)|0;y_c((f[d>>2]|0)+(w*24|0)+12|0,0,528047)|0}}else{z_c(v+(w*24|0)|0,528044)|0;y_c((f[d>>2]|0)+(w*24|0)+12|0,0,528047)|0}z_c((f[d>>2]|0)+(w*24|0)|0,528069)|0;v=f[r>>2]|0;B=(f[d>>2]|0)+(w*24|0)|0;E=v+-12|0;y=f[E>>2]|0;if((y|0)==(f[v+-8>>2]|0))B_c(v+-16|0,B);else{A_c(y,B);f[E>>2]=(f[E>>2]|0)+24}w=w+1|0}break}case 84:{w=d+4|0;r=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;t=L_c(a,c,d)|0;D=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;if((t|0)==(a|0)){P=a;break a}F=d+12|0;J=f[F>>2]|0;f[g>>2]=J;E=d+20|0;B=f[E>>2]|0;y=d+24|0;if(B>>>0<(f[y>>2]|0)>>>0){f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=J;f[E>>2]=(f[E>>2]|0)+16}else x_c(p,g);J=r;while(1){if(J>>>0>=D>>>0)break;B=f[E>>2]|0;v=(f[d>>2]|0)+(J*24|0)|0;G=B+-12|0;z=f[G>>2]|0;if((z|0)==(f[B+-8>>2]|0))B_c(B+-16|0,v);else{A_c(z,v);f[G>>2]=(f[G>>2]|0)+24}J=J+1|0}if(!((D|0)==(r+1|0)&(b[d+63>>0]|0)!=0)){P=t;break a}J=M_c(t,c,d)|0;if((J|0)==(t|0)){P=t;break a}N_c(g,(f[w>>2]|0)+-24|0);G=f[w>>2]|0;v=G+-24|0;z=G;while(1){if((z|0)==(v|0))break;B=z+-24|0;f[w>>2]=B;a_c(B);z=f[w>>2]|0}z=b[g+11>>0]|0;v=z<<24>>24<0;d_c(G+-48|0,v?f[g>>2]|0:g,v?f[g+4>>2]|0:z&255)|0;z=(f[w>>2]|0)+-24|0;f[i>>2]=f[F>>2];E_c(h,z,i);z=f[E>>2]|0;if(z>>>0<(f[y>>2]|0)>>>0){f[z>>2]=0;v=z+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=t;f[z>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[z+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else F_c(p,h);b_c(h);r_c(g);P=J;break a;break}case 85:{if(!s){P=a;break a}t=O_c(x,c,d)|0;if((t|0)==(x|0)){P=a;break a}v=v_c(t,c,d)|0;if((v|0)==(t|0)){P=a;break a}t=d+4|0;z=f[t>>2]|0;if(((z-(f[d>>2]|0)|0)/24|0)>>>0<2){P=a;break a}N_c(g,z+-24|0);z=f[t>>2]|0;r=z+-24|0;D=z;while(1){if((D|0)==(r|0))break;B=D+-24|0;f[t>>2]=B;a_c(B);D=f[t>>2]|0}I_c(h,z+-48|0,9);D=UNc(528071)|0;r=b[h+11>>0]|0;if((D|0)==((r<<24>>24<0?f[h+4>>2]|0:r&255)|0)){r=(J_c(h,528071,D)|0)==0;r_c(h);if(r){N_c(h,(f[t>>2]|0)+-24|0);r=f[t>>2]|0;D=r+-24|0;J=r;while(1){if((J|0)==(D|0))break;r=J+-24|0;f[t>>2]=r;a_c(r);J=f[t>>2]|0}J=h+11|0;D=b[J>>0]|0;z=D<<24>>24<0;r=f[h>>2]|0;E=O_c(z?r+9|0:h+9|0,(z?r:h)+(z?f[h+4>>2]|0:D&255)|0,d)|0;if((E|0)==(((b[J>>0]|0)<0?f[h>>2]|0:h)+9|0)){P_c(k,g,528081);E=b[J>>0]|0;J=E<<24>>24<0;d_c(k,J?f[h>>2]|0:h,J?f[h+4>>2]|0:E&255)|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}Q_c(i,o);E=f[t>>2]|0;if(E>>>0<(f[d+8>>2]|0)>>>0){S_c(E,i);f[t>>2]=(f[t>>2]|0)+24}else T_c(d,i);a_c(i);r_c(o);r_c(k)}else{P_c(m,g,528083);N_c(n,(f[t>>2]|0)+-24|0);E=b[n+11>>0]|0;J=E<<24>>24<0;d_c(m,J?f[n>>2]|0:n,J?f[n+4>>2]|0:E&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];E=0;while(1){if((E|0)==3)break;f[m+(E<<2)>>2]=0;E=E+1|0}z_c(k,528085)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}Q_c(i,l);R_c((f[t>>2]|0)+-24|0,i);a_c(i);r_c(l);r_c(k);r_c(n);r_c(m)}r_c(h)}else W=166}else{r_c(h);W=166}if((W|0)==166){P_c(i,g,528081);N_c(k,(f[t>>2]|0)+-24|0);E=b[k+11>>0]|0;J=E<<24>>24<0;d_c(i,J?f[k>>2]|0:k,J?f[k+4>>2]|0:E&255)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}Q_c(h,j);R_c((f[t>>2]|0)+-24|0,h);a_c(h);r_c(j);r_c(k);r_c(i)}E=(f[t>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];E_c(h,E,i);E=d+20|0;J=f[E>>2]|0;if(J>>>0<(f[d+24>>2]|0)>>>0){f[J>>2]=0;D=J+4|0;f[D>>2]=0;z=f[h+12>>2]|0;f[J+8>>2]=0;f[J+12>>2]=z;f[J>>2]=f[h>>2];z=h+4|0;f[D>>2]=f[z>>2];D=h+8|0;f[J+8>>2]=f[D>>2];f[D>>2]=0;f[z>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else F_c(p,h);b_c(h);r_c(g);P=v;break a;break}case 83:{if(s?(b[x>>0]|0)==116:0){E=U_c(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=f[d+4>>2]|0;if((f[d>>2]|0)==(z|0)){P=a;break a}f[h>>2]=f[d+12>>2];E_c(g,z+-24|0,h);z=d+20|0;D=f[z>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;J=D+4|0;f[J>>2]=0;r=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=r;f[D>>2]=f[g>>2];r=g+4|0;f[J>>2]=f[r>>2];J=g+8|0;f[D+8>>2]=f[J>>2];f[J>>2]=0;f[r>>2]=0;f[g>>2]=0;f[z>>2]=(f[z>>2]|0)+16}else F_c(p,g);b_c(g);P=E;break a}E=V_c(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=M_c(E,c,d)|0;if((z|0)==(E|0)){P=E;break a}r=d+4|0;J=f[r>>2]|0;if(((J-(f[d>>2]|0)|0)/24|0)>>>0<2){P=E;break a}N_c(g,J+-24|0);J=f[r>>2]|0;E=J+-24|0;D=J;while(1){if((D|0)==(E|0))break;y=D+-24|0;f[r>>2]=y;a_c(y);D=f[r>>2]|0}D=b[g+11>>0]|0;E=D<<24>>24<0;d_c(J+-48|0,E?f[g>>2]|0:g,E?f[g+4>>2]|0:D&255)|0;D=(f[r>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];E_c(h,D,i);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;v=E+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=t;f[E>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[E+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else F_c(p,h);b_c(h);r_c(g);P=z;break a;break}case 68:{if(s)switch(b[x>>0]|0){case 112:{D=d+4|0;t=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;v=a+2|0;E=v_c(v,c,d)|0;y=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((E|0)==(v|0))break d;v=f[d+12>>2]|0;f[g>>2]=v;D=d+20|0;F=f[D>>2]|0;if(F>>>0<(f[d+24>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=v;f[D>>2]=(f[D>>2]|0)+16}else x_c(p,g);v=t;while(1){if(v>>>0>=y>>>0){P=E;break a}t=f[D>>2]|0;F=(f[d>>2]|0)+(v*24|0)|0;w=t+-12|0;G=f[w>>2]|0;if((G|0)==(f[t+-8>>2]|0))B_c(t+-16|0,F);else{A_c(G,F);f[w>>2]=(f[w>>2]|0)+24}v=v+1|0}break}case 84:case 116:{v=W_c(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];E_c(g,D+-24|0,h);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;y=E+4|0;f[y>>2]=0;z=f[g+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=z;f[E>>2]=f[g>>2];z=g+4|0;f[y>>2]=f[z>>2];y=g+8|0;f[E+8>>2]=f[y>>2];f[y>>2]=0;f[z>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else F_c(p,g);b_c(g);P=v;break a;break}case 118:{v=X_c(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];E_c(g,D+-24|0,h);D=d+20|0;z=f[D>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;y=z+4|0;f[y>>2]=0;E=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=E;f[z>>2]=f[g>>2];E=g+4|0;f[y>>2]=f[E>>2];y=g+8|0;f[z+8>>2]=f[y>>2];f[y>>2]=0;f[E>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else F_c(p,g);b_c(g);P=v;break a;break}default:break d}break}default:{}}while(0);x=C_c(a,c,d)|0;if((x|0)==(a|0)){s=U_c(a,c,d)|0;if((s|0)!=(a|0)?(v=f[d+4>>2]|0,(f[d>>2]|0)!=(v|0)):0){f[h>>2]=f[d+12>>2];E_c(g,v+-24|0,h);v=d+20|0;D=f[v>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;E=D+4|0;f[E>>2]=0;y=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=y;f[D>>2]=f[g>>2];y=g+4|0;f[E>>2]=f[y>>2];E=g+8|0;f[D+8>>2]=f[E>>2];f[E>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(p,g);b_c(g);P=s}else P=a}else P=x}else P=q}else P=a;while(0);u=e;return P|0}function w_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[d>>2]=0;if((a|0)!=(c|0)){c=b[a>>0]|0;if(c<<24>>24==114){f[d>>2]=4;e=a+1|0;g=e;h=4;i=b[e>>0]|0}else{g=a;h=0;i=c}if(i<<24>>24==86){c=h|2;f[d>>2]=c;e=g+1|0;j=e;k=b[e>>0]|0;l=c}else{j=g;k=i;l=h}if(k<<24>>24==75){f[d>>2]=l|1;m=j+1|0}else m=j}else m=a;return m|0}function x_c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=B0c(a)|0;if(h>>>0<g>>>0)kWc(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;C0c(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;f[e+4>>2]=0;h=f[b>>2]|0;f[e+8>>2]=0;f[e+12>>2]=h;f[i>>2]=e+16;D0c(a,d);E0c(d);u=c;return}}function y_c(a,b,c){a=a|0;b=b|0;c=c|0;return A0c(a,b,c,UNc(c)|0)|0}function z_c(a,b){a=a|0;b=b|0;return d_c(a,b,UNc(b)|0)|0}function A_c(a,b){a=a|0;b=b|0;W$c(a,b);W$c(a+12|0,b+12|0);return}function B_c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=_$c(a)|0;if(h>>>0<g>>>0)kWc(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;$$c(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;A_c(e,b);f[i>>2]=e+24;a0c(a,d);b0c(d);u=c;return}}function C_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e;a:do if((a|0)==(c|0))h=a;else{i=a+1|0;do switch(b[a>>0]|0){case 118:{f0c(g,529486);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 119:{I0c(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 98:{f0c(g,529491);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 99:{f0c(g,529260);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 97:{O$c(g,529265);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 104:{j0c(g,529277);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 115:{y$c(g,529291);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 116:{P$c(g,529297);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 105:{J0c(g,529496);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 106:{Q$c(g,529500);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 108:{f0c(g,529513);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 109:{j0c(g,529518);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 120:{L$c(g,529532);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 121:{K0c(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 110:{L0c(g,529326);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 111:{M$c(g,529335);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 102:{y$c(g,529542);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 100:{M0c(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 101:{O$c(g,529548);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 103:{K$c(g,529560);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 122:{J0c(g,529571);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);h=i;break a;break}case 117:{j=O_c(i,c,d)|0;h=(j|0)==(i|0)?a:j;break a;break}case 68:{if((i|0)==(c|0)){h=a;break a}j=a+2|0;switch(b[i>>0]|0){case 100:{L$c(g,529575);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}case 101:{K$c(g,529585);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}case 102:{L$c(g,529596);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}case 104:{L$c(g,529606);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}case 105:{L0c(g,529616);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}case 115:{L0c(g,529625);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}case 97:{f0c(g,529634);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}case 110:{P$c(g,529639);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);h=j;break a;break}default:{h=a;break a}}break}default:{h=a;break a}}while(0)}while(0);u=e;return h|0}function D_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;do if(((a|0)!=(c|0)?(b[a>>0]|0)==65:0)?(n=a+1|0,(n|0)!=(c|0)):0){o=b[n>>0]|0;if(o<<24>>24==95){p=a+2|0;q=v_c(p,c,d)|0;if((q|0)==(p|0)){r=a;break}p=d+4|0;s=f[p>>2]|0;if((f[d>>2]|0)==(s|0)){r=a;break}I_c(g,s+-12|0,2);s=UNc(528041)|0;t=b[g+11>>0]|0;if((s|0)==((t<<24>>24<0?f[g+4>>2]|0:t&255)|0)){t=(J_c(g,528041,s)|0)==0;r_c(g);if(t)H0c((f[p>>2]|0)+-12|0)}else r_c(g);y_c((f[p>>2]|0)+-12|0,0,529482)|0;r=q;break}if((o+-49&255)<9){o=Y_c(n,c)|0;if((o|0)==(c|0)){r=a;break}if((b[o>>0]|0)!=95){r=a;break}q=o+1|0;p=v_c(q,c,d)|0;if((p|0)==(q|0)){r=a;break}q=d+4|0;t=f[q>>2]|0;if((f[d>>2]|0)==(t|0)){r=a;break}I_c(g,t+-12|0,2);t=UNc(528041)|0;s=b[g+11>>0]|0;if((t|0)==((s<<24>>24<0?f[g+4>>2]|0:s&255)|0)){s=(J_c(g,528041,t)|0)==0;r_c(g);if(s)H0c((f[q>>2]|0)+-12|0)}else r_c(g);s=(f[q>>2]|0)+-12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;q=o-n|0;if(q>>>0>4294967279)jYc(j);if(q>>>0<11){b[j+11>>0]=q;v=j}else{t=q+16&-16;w=o_c(t)|0;f[j>>2]=w;f[j+8>>2]=t|-2147483648;f[j+4>>2]=q;v=w}w=n;t=v;while(1){if((w|0)==(o|0))break;VNc(t,w);w=w+1|0;t=t+1|0}b[g>>0]=0;VNc(v+q|0,g);y_c(j,0,528041)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];t=0;while(1){if((t|0)==3)break;f[j+(t<<2)>>2]=0;t=t+1|0}z_c(i,528096)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];t=0;while(1){if((t|0)==3)break;f[i+(t<<2)>>2]=0;t=t+1|0}t=b[h+11>>0]|0;q=t<<24>>24<0;A0c(s,0,q?f[h>>2]|0:h,q?f[h+4>>2]|0:t&255)|0;r_c(h);r_c(i);r_c(j);r=p;break}t=Z_c(n,c,d)|0;if(((!((t|0)==(n|0)|(t|0)==(c|0))?(b[t>>0]|0)==95:0)?(q=t+1|0,t=v_c(q,c,d)|0,(t|0)!=(q|0)):0)?(q=d+4|0,w=f[q>>2]|0,((w-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){S_c(h,w+-24|0);w=f[q>>2]|0;o=w+-24|0;x=w;while(1){if((x|0)==(o|0))break;y=x+-24|0;f[q>>2]=y;a_c(y);x=f[q>>2]|0}S_c(i,w+-48|0);x=f[q>>2]|0;o=x+-24|0;n=o+11|0;if((b[n>>0]|0)<0){p=f[o>>2]|0;b[g>>0]=0;VNc(p,g);f[x+-20>>2]=0}else{b[g>>0]=0;VNc(o,g);b[n>>0]=0}__c(o);f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];o=0;while(1){if((o|0)==3)break;f[h+(o<<2)>>2]=0;o=o+1|0}o=h+12|0;I_c(g,o,2);w=UNc(528041)|0;n=b[g+11>>0]|0;if((w|0)==((n<<24>>24<0?f[g+4>>2]|0:n&255)|0)){n=(J_c(g,528041,w)|0)==0;r_c(g);if(n)H0c(o)}else r_c(g);N_c(m,i);y_c(m,0,528041)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];n=0;while(1){if((n|0)==3)break;f[m+(n<<2)>>2]=0;n=n+1|0}z_c(l,528096)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];n=0;while(1){if((n|0)==3)break;f[l+(n<<2)>>2]=0;n=n+1|0}n=b[o+11>>0]|0;w=n<<24>>24<0;d_c(k,w?f[o>>2]|0:o,w?f[h+16>>2]|0:n&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}n=f[q>>2]|0;o=n+-12|0;w=o+11|0;if((b[w>>0]|0)<0){x=f[o>>2]|0;b[g>>0]=0;VNc(x,g);f[n+-8>>2]=0}else{b[g>>0]=0;VNc(o,g);b[w>>0]=0}__c(o);f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[o+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}r_c(j);r_c(k);r_c(l);r_c(m);a_c(i);a_c(h);r=t}else r=a}else r=a;while(0);u=e;return r|0}function E_c(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;e=f[c>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;G0c(a);A_c(f[d>>2]|0,b);f[d>>2]=(f[d>>2]|0)+24;return}function F_c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=B0c(a)|0;if(h>>>0<g>>>0)kWc(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;C0c(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;k=f[b+12>>2]|0;f[e+8>>2]=0;f[e+12>>2]=k;f[e>>2]=f[b>>2];k=b+4|0;f[h>>2]=f[k>>2];h=b+8|0;f[e+8>>2]=f[h>>2];f[h>>2]=0;f[k>>2]=0;f[b>>2]=0;f[i>>2]=e+16;D0c(a,d);E0c(d);u=c;return}}function G_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((a|0)!=(c|0)?(b[a>>0]|0)==70:0)?(i=a+1|0,(i|0)!=(c|0)):0){if((b[i>>0]|0)==89){j=a+2|0;if((j|0)==(c|0)){k=a;break}else l=j}else l=i;i=v_c(l,c,d)|0;if((i|0)!=(l|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=UNc(528049)|0;if(j>>>0>4294967279)jYc(h);if(j>>>0<11){m=h+11|0;b[m>>0]=j;n=h;o=m;p=h+4|0}else{m=j+16&-16;q=o_c(m)|0;f[h>>2]=q;f[h+8>>2]=m|-2147483648;m=h+4|0;f[m>>2]=j;n=q;o=h+11|0;p=m}$Mc(n,528049,j)|0;b[g>>0]=0;VNc(n+j|0,g);j=d+4|0;m=g+11|0;q=g+4|0;r=0;s=i;b:while(1){i=s;c:while(1){if((i|0)==(c|0)){t=15;break b}v=b[i>>0]|0;w=i+1|0;switch(v<<24>>24){case 69:{t=19;break b;break}case 118:{i=w;continue c;break}default:{}}x=(w|0)==(c|0);if(!(x|v<<24>>24!=82)?(b[w>>0]|0)==69:0){r=1;s=w;continue b}if(!(x|v<<24>>24!=79)?(b[w>>0]|0)==69:0){r=2;s=w;continue b}v=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;x=v_c(i,c,d)|0;y=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;if((x|0)==(i|0)|(x|0)==(c|0))break b;else z=v;while(1){if(z>>>0>=y>>>0){A=v;break}B=b[o>>0]|0;if((B<<24>>24<0?f[p>>2]|0:B&255)>>>0>1)z_c(h,528271)|0;N_c(g,(f[d>>2]|0)+(z*24|0)|0);B=b[m>>0]|0;C=B<<24>>24<0;d_c(h,C?f[g>>2]|0:g,C?f[q>>2]|0:B&255)|0;r_c(g);z=z+1|0}while(1){if(A>>>0>=y>>>0){i=x;continue c}v=f[j>>2]|0;B=v+-24|0;C=v;while(1){if((C|0)==(B|0))break;v=C+-24|0;f[j>>2]=v;a_c(v);C=f[j>>2]|0}A=A+1|0}}}d:do if((t|0)==15){q=f[j>>2]|0;m=q+-24|0;s=q;while(1){if((s|0)==(m|0))break d;q=s+-24|0;f[j>>2]=q;a_c(q);s=f[j>>2]|0}}else if((t|0)==19){z_c(h,528047)|0;switch(r&3){case 1:{z_c(h,529475)|0;break}case 2:{z_c(h,529478)|0;break}default:{}}s=f[j>>2]|0;if((f[d>>2]|0)!=(s|0)){z_c(s+-24|0,528081)|0;s=b[o>>0]|0;m=s<<24>>24<0;A0c((f[j>>2]|0)+-12|0,0,m?f[h>>2]|0:h,m?f[p>>2]|0:s&255)|0;r_c(h);k=w;break a}}while(0);r_c(h);k=a}else k=a}else k=a;while(0);u=e;return k|0}function H_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;if(((((a|0)!=(c|0)?(b[a>>0]|0)==77:0)?(n=a+1|0,o=v_c(n,c,d)|0,(o|0)!=(n|0)):0)?(n=v_c(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){S_c(h,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;a_c(q);p=f[o>>2]|0}S_c(i,c+-48|0);c=h+12|0;a:do if((b[((b[c+11>>0]|0)<0?f[c>>2]|0:c)>>0]|0)==40){z_c(h,528049)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];p=0;while(1){if((p|0)==3)break;f[h+(p<<2)>>2]=0;p=p+1|0}N_c(m,i);p=b[m+11>>0]|0;d=p<<24>>24<0;d_c(l,d?f[m>>2]|0:m,d?f[m+4>>2]|0:p&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];p=0;while(1){if((p|0)==3)break;f[l+(p<<2)>>2]=0;p=p+1|0}z_c(k,529471)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}p=f[o>>2]|0;d=p+-24|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;VNc(r,g);f[p+-20>>2]=0}else{b[g>>0]=0;VNc(d,g);b[q>>0]=0}__c(d);f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];f[d+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}r_c(j);r_c(k);r_c(m);r_c(l);y_c(c,0,528047)|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break;f[c+(d<<2)>>2]=0;d=d+1|0}d=f[o>>2]|0;q=d+-12|0;p=q+11|0;if((b[p>>0]|0)<0){r=f[q>>2]|0;b[g>>0]=0;VNc(r,g);f[d+-8>>2]=0}else{b[g>>0]=0;VNc(q,g);b[p>>0]=0}__c(q);f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];q=0;while(1){if((q|0)==3)break;f[j+(q<<2)>>2]=0;q=q+1|0}r_c(j)}else{z_c(h,528081)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];q=0;while(1){if((q|0)==3)break;f[h+(q<<2)>>2]=0;q=q+1|0}N_c(m,i);q=b[m+11>>0]|0;p=q<<24>>24<0;d_c(l,p?f[m>>2]|0:m,p?f[m+4>>2]|0:q&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];q=0;while(1){if((q|0)==3)break;f[l+(q<<2)>>2]=0;q=q+1|0}z_c(k,529471)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}q=f[o>>2]|0;p=q+-24|0;d=p+11|0;if((b[d>>0]|0)<0){r=f[p>>2]|0;b[g>>0]=0;VNc(r,g);f[q+-20>>2]=0}else{b[g>>0]=0;VNc(p,g);b[d>>0]=0}__c(p);f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];p=0;while(1){if((p|0)==3)break;f[j+(p<<2)>>2]=0;p=p+1|0}r_c(j);r_c(k);r_c(m);r_c(l);p=f[o>>2]|0;d=p+-12|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;VNc(r,g);f[p+-8>>2]=0}else{b[g>>0]=0;VNc(d,g);b[q>>0]=0}__c(d);f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];f[d+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break a;f[c+(d<<2)>>2]=0;d=d+1|0}}while(0);a_c(i);a_c(h);s=n}else s=a;u=e;return s|0}function I_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c+4>>2]|0:h&255;h=i?f[c>>2]|0:c;c=j>>>0<d>>>0?j:d;if(c>>>0>4294967279)jYc(a);if(c>>>0<11){b[a+11>>0]=c;k=a}else{d=c+16&-16;j=o_c(d)|0;f[a>>2]=j;f[a+8>>2]=d|-2147483648;f[a+4>>2]=c;k=j}$Mc(k,h,c)|0;b[g>>0]=0;VNc(k+c|0,g);u=e;return}function J_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;g=e<<24>>24<0;if(g)h=f[a+4>>2]|0;else h=e&255;if((d|0)==-1)kYc(a);if(g)i=f[a>>2]|0;else i=a;a=h>>>0>d>>>0;g=MXc(i,c,a?d:h)|0;if(!g)return (h>>>0<d>>>0?-1:a&1)|0;else return g|0;return 0}function K_c(a){a=a|0;z0c(a,UNc(529468)|0);return}function L_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+64|0;g=e+40|0;h=e;i=e+24|0;j=a;a:do if((c-j|0)>1?(b[a>>0]|0)==84:0){k=b[a+1>>0]|0;l=d+62|0;m=d+32|0;if(k<<24>>24==95){n=f[d+36>>2]|0;if((f[m>>2]|0)==(n|0)){o=a;break}p=f[n+-16>>2]|0;q=a+2|0;if((p|0)==(f[n+-12>>2]|0)){y0c(g);n=d+4|0;r=f[n>>2]|0;if(r>>>0<(f[d+8>>2]|0)>>>0){S_c(r,g);f[n>>2]=(f[n>>2]|0)+24}else T_c(d,g);a_c(g);b[l>>0]=1;o=q;break}n=f[p+4>>2]|0;r=d+4|0;s=d+8|0;t=f[p>>2]|0;while(1){if((t|0)==(n|0)){o=q;break a}p=f[r>>2]|0;if((p|0)==(f[s>>2]|0))B_c(d,t);else{A_c(p,t);f[r>>2]=(f[r>>2]|0)+24}t=t+24|0}}t=(k<<24>>24)+-48|0;if(t>>>0<10){r=t;t=a+2|0;while(1){v=t+1|0;if((t|0)==(c|0)){o=a;break a}w=b[t>>0]|0;s=(w<<24>>24)+-48|0;if(s>>>0>=10)break;r=s+(r*10|0)|0;t=v}if(w<<24>>24==95?(t=f[d+36>>2]|0,(f[m>>2]|0)!=(t|0)):0){k=r+1|0;s=f[t+-16>>2]|0;q=s;if(k>>>0<(f[t+-12>>2]|0)-s>>4>>>0){s=f[q+(k<<4)+4>>2]|0;t=d+4|0;n=d+8|0;p=f[q+(k<<4)>>2]|0;while(1){if((p|0)==(s|0)){o=v;break a}k=f[t>>2]|0;if((k|0)==(f[n>>2]|0))B_c(d,p);else{A_c(k,p);f[t>>2]=(f[t>>2]|0)+24}p=p+24|0}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=v-j|0;if(p>>>0>4294967279)jYc(i);if(p>>>0<11){b[i+11>>0]=p;x=i}else{t=p+16&-16;n=o_c(t)|0;f[i>>2]=n;f[i+8>>2]=t|-2147483648;f[i+4>>2]=p;x=n}n=a;t=x;while(1){if((n|0)==(v|0))break;VNc(t,n);n=n+1|0;t=t+1|0}b[g>>0]=0;VNc(x+p|0,g);Q_c(h,i);t=d+4|0;n=f[t>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){S_c(n,h);f[t>>2]=(f[t>>2]|0)+24}else T_c(d,h);a_c(h);r_c(i);b[l>>0]=1;o=v}else o=a}else o=a}else o=a;while(0);u=e;return o|0}function M_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+64|0;g=e+32|0;h=e+16|0;i=e;j=e+4|0;do if((c-a|0)>1?(b[a>>0]|0)==73:0){k=d+61|0;l=d+32|0;a:do if(b[k>>0]|0){m=f[d+36>>2]|0;n=f[m+-16>>2]|0;o=m+-12|0;while(1){m=f[o>>2]|0;if((m|0)==(n|0))break a;p=m+-16|0;f[o>>2]=p;b_c(p)}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=UNc(528083)|0;if(o>>>0>4294967279)jYc(h);if(o>>>0<11){n=h+11|0;b[n>>0]=o;q=h;r=n;s=h+4|0}else{n=o+16&-16;p=o_c(n)|0;f[h>>2]=p;f[h+8>>2]=n|-2147483648;n=h+4|0;f[n>>2]=o;q=p;r=h+11|0;s=n}$Mc(q,528083,o)|0;b[g>>0]=0;VNc(q+o|0,g);o=d+4|0;n=d+36|0;p=d+12|0;m=g+11|0;t=g+4|0;v=d+40|0;w=a+1|0;b:while(1){if((b[w>>0]|0)==69)break;if(b[k>>0]|0){f[i>>2]=f[p>>2];x=f[n>>2]|0;if(x>>>0<(f[v>>2]|0)>>>0){q0c(g,i);f[x>>2]=0;f[x+4>>2]=0;y=f[g>>2]|0;f[x+8>>2]=0;f[x+12>>2]=y;f[n>>2]=(f[n>>2]|0)+16}else r0c(l,i)}y=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;x=s0c(w,c,d)|0;z=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;c:do if(b[k>>0]|0){A=f[n>>2]|0;B=A+-16|0;C=A;while(1){if((C|0)==(B|0))break c;A=C+-16|0;f[n>>2]=A;h_c(A);C=f[n>>2]|0}}while(0);if((x|0)==(w|0)|(x|0)==(c|0)){D=53;break}d:do if(!(b[k>>0]|0))E=y;else{C=f[n>>2]|0;B=f[p>>2]|0;f[g>>2]=B;A=C+-12|0;F=f[A>>2]|0;if(F>>>0<(f[C+-8>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=B;f[A>>2]=(f[A>>2]|0)+16}else x_c(C+-16|0,g);C=y;while(1){if(C>>>0>=z>>>0){E=y;break d}A=f[(f[n>>2]|0)+-12>>2]|0;B=(f[d>>2]|0)+(C*24|0)|0;F=A+-12|0;G=f[F>>2]|0;if((G|0)==(f[A+-8>>2]|0))B_c(A+-16|0,B);else{A_c(G,B);f[F>>2]=(f[F>>2]|0)+24}C=C+1|0}}while(0);while(1){if(E>>>0>=z>>>0){H=z;break}C=b[r>>0]|0;if((C<<24>>24<0?f[s>>2]|0:C&255)>>>0>1)z_c(h,528271)|0;N_c(g,(f[d>>2]|0)+(E*24|0)|0);C=b[m>>0]|0;F=C<<24>>24<0;d_c(h,F?f[g>>2]|0:g,F?f[t>>2]|0:C&255)|0;r_c(g);E=E+1|0}while(1){if((H|0)==(y|0)){w=x;continue b}z=f[o>>2]|0;C=z+-24|0;F=z;while(1){if((F|0)==(C|0))break;z=F+-24|0;f[o>>2]=z;a_c(z);F=f[o>>2]|0}H=H+-1|0}}if((D|0)==53){r_c(h);I=a;break}t=w+1|0;m=b[r>>0]|0;n=m<<24>>24<0;if((b[(n?f[h>>2]|0:h)+(n?f[s>>2]|0:m&255)+-1>>0]|0)==62)z_c(h,529462)|0;else z_c(h,528085)|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}Q_c(g,j);m=f[o>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){S_c(m,g);f[o>>2]=(f[o>>2]|0)+24}else T_c(d,g);a_c(g);r_c(j);r_c(h);I=t}else I=a;while(0);u=e;return I|0}function N_c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=c+12|0;e=b[d+11>>0]|0;g=e<<24>>24<0;d_c(c,g?f[d>>2]|0:d,g?f[c+16>>2]|0:e&255)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function O_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;a:do if(((a|0)!=(c|0)?(j=(b[a>>0]|0)+-48|0,j>>>0<10):0)?(k=a+1|0,(k|0)!=(c|0)):0){l=j;j=k;while(1){k=(b[j>>0]|0)+-48|0;if(k>>>0>=10)break;m=j+1|0;if((m|0)==(c|0)){n=a;break a}l=k+(l*10|0)|0;j=m}if((c-j|0)>>>0>=l>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(l>>>0>4294967279)jYc(h);if(l>>>0<11){b[h+11>>0]=l;o=h}else{m=l+16&-16;k=o_c(m)|0;f[h>>2]=k;f[h+8>>2]=m|-2147483648;f[h+4>>2]=l;o=k}$Mc(o,j,l)|0;b[g>>0]=0;VNc(o+l|0,g);I_c(g,h,10);k=UNc(529429)|0;m=b[g+11>>0]|0;if((k|0)==((m<<24>>24<0?f[g+4>>2]|0:m&255)|0))p=(J_c(g,529429,k)|0)==0;else p=0;r_c(g);if(p){p0c(g);k=d+4|0;m=f[k>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){S_c(m,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g)}else{f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}Q_c(g,i);k=d+4|0;m=f[k>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){S_c(m,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);r_c(i)}r_c(h);n=j+l|0}else n=a}else n=a;while(0);u=e;return n|0}function P_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;i=UNc(d)|0;k=(b[h>>0]|0)<0?f[c>>2]|0:c;c=j+i|0;if(c>>>0>4294967279)jYc(a);if(c>>>0<11){b[a+11>>0]=j;l=a}else{h=c+16&-16;c=o_c(h)|0;f[a>>2]=c;f[a+8>>2]=h|-2147483648;f[a+4>>2]=j;l=c}$Mc(l,k,j)|0;b[g>>0]=0;VNc(l+j|0,g);d_c(a,d,i)|0;u=e;return}function Q_c(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function R_c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+11|0;if((b[g>>0]|0)<0){h=f[a>>2]|0;b[e>>0]=0;VNc(h,e);f[a+4>>2]=0}else{b[e>>0]=0;VNc(a,e);b[g>>0]=0}__c(a);f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];g=0;while(1){if((g|0)==3)break;f[c+(g<<2)>>2]=0;g=g+1|0}g=a+12|0;h=c+12|0;c=g+11|0;if((b[c>>0]|0)<0){i=f[g>>2]|0;b[e>>0]=0;VNc(i,e);f[a+16>>2]=0}else{b[e>>0]=0;VNc(g,e);b[c>>0]=0}__c(g);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];g=0;while(1){if((g|0)==3)break;f[h+(g<<2)>>2]=0;g=g+1|0}u=d;return}function S_c(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;a=b+12|0;f[c>>2]=f[a>>2];f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}return}function T_c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=_$c(a)|0;if(h>>>0<g>>>0)kWc(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;$$c(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;S_c(e,b);f[i>>2]=e+24;a0c(a,d);b0c(d);u=c;return}}function U_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((c-a|0)>1){i=(b[a>>0]|0)==76?a+1|0:a;switch(b[i>>0]|0){case 78:{j=k0c(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}case 90:{j=l0c(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}default:{j=m0c(i,c,d)|0;if((j|0)==(i|0)){l=V_c(i,c,d)|0;if((l|0)==(i|0)|(l|0)==(c|0)){k=a;break a}if((b[l>>0]|0)!=73){k=a;break a}i=M_c(l,c,d)|0;if((i|0)==(l|0)){k=a;break a}l=d+4|0;m=f[l>>2]|0;if(((m-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}N_c(g,m+-24|0);m=f[l>>2]|0;n=m+-24|0;o=m;while(1){if((o|0)==(n|0))break;p=o+-24|0;f[l>>2]=p;a_c(p);o=f[l>>2]|0}l=b[g+11>>0]|0;o=l<<24>>24<0;d_c(m+-48|0,o?f[g>>2]|0:g,o?f[g+4>>2]|0:l&255)|0;r_c(g);k=i;break a}if((j|0)==(c|0)){k=c;break a}if((b[j>>0]|0)!=73){k=j;break a}l=d+4|0;o=f[l>>2]|0;if((f[d>>2]|0)==(o|0)){k=a;break a}f[h>>2]=f[d+12>>2];E_c(g,o+-24|0,h);o=d+20|0;n=f[o>>2]|0;if(n>>>0<(f[d+24>>2]|0)>>>0){f[n>>2]=0;p=n+4|0;f[p>>2]=0;q=f[g+12>>2]|0;f[n+8>>2]=0;f[n+12>>2]=q;f[n>>2]=f[g>>2];q=g+4|0;f[p>>2]=f[q>>2];p=g+8|0;f[n+8>>2]=f[p>>2];f[p>>2]=0;f[q>>2]=0;f[g>>2]=0;f[o>>2]=(f[o>>2]|0)+16}else F_c(d+16|0,g);b_c(g);o=M_c(j,c,d)|0;if((o|0)==(j|0)){k=a;break a}q=f[l>>2]|0;if(((q-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}N_c(g,q+-24|0);q=f[l>>2]|0;p=q+-24|0;n=q;while(1){if((n|0)==(p|0))break;r=n+-24|0;f[l>>2]=r;a_c(r);n=f[l>>2]|0}l=b[g+11>>0]|0;n=l<<24>>24<0;d_c(q+-48|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:l&255)|0;r_c(g);k=o;break a}}}else k=a;while(0);u=e;return k|0}function V_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1?(b[a>>0]|0)==83:0){h=b[a+1>>0]|0;i=a+2|0;j=d+16|0;switch(h|0){case 97:{P$c(g,529375);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);m=i;break a;break}case 98:{M$c(g,529390);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);m=i;break a;break}case 115:{O$c(g,528869);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);m=i;break a;break}case 105:{Q$c(g,528965);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);m=i;break a;break}case 111:{Q$c(g,529042);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);m=i;break a;break}case 100:{j0c(g,529119);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);m=i;break a;break}case 95:{k=f[j>>2]|0;if((k|0)==(f[d+20>>2]|0)){m=a;break a}l=f[k+4>>2]|0;n=d+4|0;o=d+8|0;p=f[k>>2]|0;while(1){if((p|0)==(l|0)){m=i;break a}k=f[n>>2]|0;if((k|0)==(f[o>>2]|0))B_c(d,p);else{A_c(k,p);f[n>>2]=(f[n>>2]|0)+24}p=p+24|0}break}default:{p=(h+-48|0)>>>0<10;if(!p?(PIc(h)|0)==0:0){m=a;break a}n=i;o=(p?-48:-55)+h|0;while(1){q=n+1|0;if((n|0)==(c|0)){m=a;break a}r=b[n>>0]|0;p=r<<24>>24;l=(p+-48|0)>>>0<10;if(!l?(PIc(p)|0)==0:0)break;n=q;o=p+(o*36|0)+(l?-48:-55)|0}if(r<<24>>24!=95){m=a;break a}n=o+1|0;h=f[j>>2]|0;i=h;if(n>>>0>=(f[d+20>>2]|0)-h>>4>>>0){m=a;break a}h=f[i+(n<<4)+4>>2]|0;l=d+4|0;p=d+8|0;k=f[i+(n<<4)>>2]|0;while(1){if((k|0)==(h|0)){m=q;break a}n=f[l>>2]|0;if((n|0)==(f[p>>2]|0))B_c(d,k);else{A_c(n,k);f[l>>2]=(f[l>>2]|0)+24}k=k+24|0}}}}else m=a;while(0);u=e;return m|0}function W_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>3?(b[a>>0]|0)==68:0){switch(b[a+1>>0]|0){case 84:case 116:break;default:{k=a;break a}}l=a+2|0;m=Z_c(l,c,d)|0;if((!((m|0)==(l|0)|(m|0)==(c|0))?(b[m>>0]|0)==69:0)?(l=d+4|0,n=f[l>>2]|0,(f[d>>2]|0)!=(n|0)):0){N_c(j,n+-24|0);y_c(j,0,529365)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];n=0;while(1){if((n|0)==3)break;f[i+(n<<2)>>2]=0;n=n+1|0}Q_c(g,h);R_c((f[l>>2]|0)+-24|0,g);a_c(g);r_c(h);r_c(i);r_c(j);k=m+1|0}else k=a}else k=a;while(0);u=e;return k|0}function X_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+80|0;g=e+60|0;h=e+24|0;i=e+12|0;j=e;k=e+48|0;a:do if(((c-a|0)>3?(b[a>>0]|0)==68:0)?(b[a+1>>0]|0)==118:0){l=a+2|0;m=b[l>>0]|0;if((m+-49&255)>=9){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;n=0;while(1){if((n|0)==3)break;f[h+(n<<2)>>2]=0;n=n+1|0}b:do if(m<<24>>24!=95?(n=Z_c(l,c,d)|0,(n|0)!=(l|0)):0){o=d+4|0;p=f[o>>2]|0;if((f[d>>2]|0)!=(p|0)){N_c(i,p+-24|0);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[g>>0]=0;VNc(q,g);f[h+4>>2]=0}else{b[g>>0]=0;VNc(h,g);b[p>>0]=0}__c(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];p=0;while(1){if((p|0)==3)break;f[i+(p<<2)>>2]=0;p=p+1|0}r_c(i);p=f[o>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0)){s=n;t=53;break b}p=r+-24|0;f[o>>2]=p;a_c(p);r=f[o>>2]|0}}}else{s=l;t=53}while(0);do if((t|0)==53){if((((s|0)!=(c|0)?(b[s>>0]|0)==95:0)?(m=s+1|0,(m|0)!=(c|0)):0)?(o=v_c(m,c,d)|0,(o|0)!=(m|0)):0){m=d+4|0;if((f[d>>2]|0)==(f[m>>2]|0))break;$_c(i,528087,h);z_c(i,528096)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[g+11>>0]|0;n=r<<24>>24<0;d_c((f[m>>2]|0)+-24|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:r&255)|0;r_c(g);r_c(i);v=o}else v=a;r_c(h);w=v;break a}while(0);r_c(h);w=a;break}r=Y_c(l,c)|0;if(((r|0)!=(c|0)?(b[r>>0]|0)==95:0)?(n=r-l|0,q=r+1|0,(q|0)!=(c|0)):0){if((b[q>>0]|0)!=112){p=v_c(q,c,d)|0;if((p|0)==(q|0)){w=a;break}q=d+4|0;if((f[d>>2]|0)==(f[q>>2]|0)){w=a;break};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)jYc(j);if(n>>>0<11){b[j+11>>0]=n;x=j}else{y=n+16&-16;z=o_c(y)|0;f[j>>2]=z;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;x=z}$Mc(x,l,n)|0;b[g>>0]=0;VNc(x+n|0,g);y_c(j,0,528087)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];z=0;while(1){if((z|0)==3)break;f[j+(z<<2)>>2]=0;z=z+1|0}z_c(i,528096)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];z=0;while(1){if((z|0)==3)break;f[i+(z<<2)>>2]=0;z=z+1|0}z=b[h+11>>0]|0;y=z<<24>>24<0;d_c((f[q>>2]|0)+-24|0,y?f[h>>2]|0:h,y?f[h+4>>2]|0:z&255)|0;r_c(h);r_c(i);r_c(j);w=p;break}z=r+2|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)jYc(j);if(n>>>0<11){b[j+11>>0]=n;A=j}else{y=n+16&-16;B=o_c(y)|0;f[j>>2]=B;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;A=B}$Mc(A,l,n)|0;b[g>>0]=0;VNc(A+n|0,g);y_c(j,0,528098)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];B=0;while(1){if((B|0)==3)break;f[j+(B<<2)>>2]=0;B=B+1|0}z_c(i,528096)|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];B=0;while(1){if((B|0)==3)break;f[i+(B<<2)>>2]=0;B=B+1|0}Q_c(h,k);B=d+4|0;n=f[B>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){S_c(n,h);f[B>>2]=(f[B>>2]|0)+24}else T_c(d,h);a_c(h);r_c(k);r_c(i);r_c(j);w=z}else w=a}else w=a;while(0);u=e;return w|0}function Y_c(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;a:do if((a|0)!=(c|0)?(d=(b[a>>0]|0)==110?a+1|0:a,(d|0)!=(c|0)):0){e=b[d>>0]|0;f=d+1|0;if(e<<24>>24!=48)if((e+-49&255)<9){e=f;while(1){if((e|0)==(c|0)){g=c;break a}if(((b[e>>0]|0)+-48|0)>>>0>=10){g=e;break a}e=e+1|0}}else g=a;else g=f}else g=a;while(0);return g|0}function Z_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;e=u;u=u+208|0;g=e+176|0;h=e+112|0;i=e+88|0;j=e+64|0;k=e+48|0;l=e+160|0;m=e+36|0;n=e+148|0;o=e+136|0;p=e+124|0;q=e+24|0;r=e+12|0;s=e;t=c;v=t-a|0;a:do if((v|0)>1){w=a+2|0;if((v|0)>3?(b[a>>0]|0)==103:0){x=(b[a+1>>0]|0)==115;y=x?w:a;z=x}else{y=a;z=0}x=y+1|0;A=a+3|0;B=(w|0)!=(c|0);C=y+2|0;do switch(b[y>>0]|0){case 76:{D=a$c(a,c,d)|0;break a;break}case 84:{D=L_c(a,c,d)|0;break a;break}case 102:{D=b$c(a,c,d)|0;break a;break}case 97:{switch(b[x>>0]|0){case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=UNc(528051)|0;if(E>>>0>4294967279)jYc(h);if(E>>>0<11){b[h+11>>0]=E;F=h}else{G=E+16&-16;H=o_c(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;F=H}$Mc(F,528051,E)|0;b[g>>0]=0;VNc(F+E|0,g);E=c$c(w,c,h,d)|0;r_c(h);D=(E|0)==(w|0)?a:E;break a;break}case 100:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=UNc(528069)|0;if(E>>>0>4294967279)jYc(h);if(E>>>0<11){b[h+11>>0]=E;I=h}else{H=E+16&-16;G=o_c(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;I=G}$Mc(I,528069,E)|0;b[g>>0]=0;VNc(I+E|0,g);E=d$c(w,c,h,d)|0;r_c(h);D=(E|0)==(w|0)?a:E;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=UNc(528069)|0;if(E>>>0>4294967279)jYc(h);if(E>>>0<11){b[h+11>>0]=E;J=h}else{G=E+16&-16;H=o_c(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;J=H}$Mc(J,528069,E)|0;b[g>>0]=0;VNc(J+E|0,g);E=c$c(w,c,h,d)|0;r_c(h);D=(E|0)==(w|0)?a:E;break a;break}case 78:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=UNc(528112)|0;if(E>>>0>4294967279)jYc(h);if(E>>>0<11){b[h+11>>0]=E;K=h}else{H=E+16&-16;G=o_c(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;K=G}$Mc(K,528112,E)|0;b[g>>0]=0;VNc(K+E|0,g);E=c$c(w,c,h,d)|0;r_c(h);D=(E|0)==(w|0)?a:E;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=UNc(528115)|0;if(E>>>0>4294967279)jYc(h);if(E>>>0<11){b[h+11>>0]=E;L=h}else{G=E+16&-16;H=o_c(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;L=H}$Mc(L,528115,E)|0;b[g>>0]=0;VNc(L+E|0,g);E=c$c(w,c,h,d)|0;r_c(h);D=(E|0)==(w|0)?a:E;break a;break}case 116:{D=e$c(a,c,d)|0;break a;break}case 122:{D=f$c(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 99:{switch(b[x>>0]|0){case 99:{D=g$c(a,c,d)|0;break a;break}case 108:{D=h$c(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=UNc(528117)|0;if(E>>>0>4294967279)jYc(h);if(E>>>0<11){b[h+11>>0]=E;M=h}else{H=E+16&-16;G=o_c(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;M=G}$Mc(M,528117,E)|0;b[g>>0]=0;VNc(M+E|0,g);E=c$c(w,c,h,d)|0;r_c(h);D=(E|0)==(w|0)?a:E;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=UNc(528119)|0;if(E>>>0>4294967279)jYc(h);if(E>>>0<11){b[h+11>>0]=E;N=h}else{G=E+16&-16;H=o_c(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;N=H}$Mc(N,528119,E)|0;b[g>>0]=0;VNc(N+E|0,g);E=d$c(w,c,h,d)|0;r_c(h);D=(E|0)==(w|0)?a:E;break a;break}case 118:{D=i$c(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 100:{switch(b[x>>0]|0){case 97:{E=Z_c(C,c,d)|0;if((E|0)==(C|0)){D=a;break a}H=d+4|0;if((f[d>>2]|0)==(f[H>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b:do if(z){G=UNc(528121)|0;if(G>>>0>4294967279)jYc(j);if(G>>>0<11){b[j+11>>0]=G;O=j}else{P=G+16&-16;Q=o_c(P)|0;f[j>>2]=Q;f[j+8>>2]=P|-2147483648;f[j+4>>2]=G;O=Q}$Mc(O,528121,G)|0;b[g>>0]=0;VNc(O+G|0,g)}else{G=0;while(1){if((G|0)==3)break b;f[j+(G<<2)>>2]=0;G=G+1|0}}while(0);z_c(j,528124)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];G=0;while(1){if((G|0)==3)break;f[j+(G<<2)>>2]=0;G=G+1|0}N_c(k,(f[H>>2]|0)+-24|0);G=b[k+11>>0]|0;Q=G<<24>>24<0;d_c(i,Q?f[k>>2]|0:k,Q?f[k+4>>2]|0:G&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}G=f[H>>2]|0;Q=G+-24|0;P=Q+11|0;if((b[P>>0]|0)<0){R=f[Q>>2]|0;b[g>>0]=0;VNc(R,g);f[G+-20>>2]=0}else{b[g>>0]=0;VNc(Q,g);b[P>>0]=0}__c(Q);f[Q>>2]=f[h>>2];f[Q+4>>2]=f[h+4>>2];f[Q+8>>2]=f[h+8>>2];Q=0;while(1){if((Q|0)==3)break;f[h+(Q<<2)>>2]=0;Q=Q+1|0}r_c(h);r_c(k);r_c(i);r_c(j);D=E;break a;break}case 99:{D=j$c(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528067)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;S=h}else{H=Q+16&-16;P=o_c(H)|0;f[h>>2]=P;f[h+8>>2]=H|-2147483648;f[h+4>>2]=Q;S=P}$Mc(S,528067,Q)|0;b[g>>0]=0;VNc(S+Q|0,g);Q=d$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{Q=Z_c(C,c,d)|0;if((Q|0)==(C|0)){D=a;break a}P=d+4|0;if((f[d>>2]|0)==(f[P>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c:do if(z){H=UNc(528121)|0;if(H>>>0>4294967279)jYc(j);if(H>>>0<11){b[j+11>>0]=H;T=j}else{G=H+16&-16;R=o_c(G)|0;f[j>>2]=R;f[j+8>>2]=G|-2147483648;f[j+4>>2]=H;T=R}$Mc(T,528121,H)|0;b[g>>0]=0;VNc(T+H|0,g)}else{H=0;while(1){if((H|0)==3)break c;f[j+(H<<2)>>2]=0;H=H+1|0}}while(0);z_c(j,528134)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];E=0;while(1){if((E|0)==3)break;f[j+(E<<2)>>2]=0;E=E+1|0}N_c(k,(f[P>>2]|0)+-24|0);E=b[k+11>>0]|0;H=E<<24>>24<0;d_c(i,H?f[k>>2]|0:k,H?f[k+4>>2]|0:E&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}E=f[P>>2]|0;H=E+-24|0;R=H+11|0;if((b[R>>0]|0)<0){G=f[H>>2]|0;b[g>>0]=0;VNc(G,g);f[E+-20>>2]=0}else{b[g>>0]=0;VNc(H,g);b[R>>0]=0}__c(H);f[H>>2]=f[h>>2];f[H+4>>2]=f[h+4>>2];f[H+8>>2]=f[h+8>>2];H=0;while(1){if((H|0)==3)break;f[h+(H<<2)>>2]=0;H=H+1|0}r_c(h);r_c(k);r_c(i);r_c(j);D=Q;break a;break}case 110:{D=k$c(a,c,d)|0;break a;break}case 115:{D=l$c(a,c,d)|0;break a;break}case 116:{D=m$c(a,c,d)|0;break a;break}case 118:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528142)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;U=h}else{P=H+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;U=R}$Mc(U,528142,H)|0;b[g>>0]=0;VNc(U+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}case 86:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528144)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;V=h}else{R=H+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;V=P}$Mc(V,528144,H)|0;b[g>>0]=0;VNc(V+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 101:{switch(b[x>>0]|0){case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528147)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;W=h}else{P=H+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;W=R}$Mc(W,528147,H)|0;b[g>>0]=0;VNc(W+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}case 79:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528149)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;X=h}else{R=H+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;X=P}$Mc(X,528149,H)|0;b[g>>0]=0;VNc(X+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}case 113:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528152)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;Y=h}else{P=H+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;Y=R}$Mc(Y,528152,H)|0;b[g>>0]=0;VNc(Y+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 103:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528155)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;Z=h}else{R=H+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;Z=P}$Mc(Z,528155,H)|0;b[g>>0]=0;VNc(Z+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528085)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;_=h}else{P=H+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;_=R}$Mc(_,528085,H)|0;b[g>>0]=0;VNc(_+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 105:{if((b[x>>0]|0)!=120){D=a;break a}H=Z_c(w,c,d)|0;if((H|0)==(w|0)){D=a;break a}R=Z_c(H,c,d)|0;P=d+4|0;if((R|0)==(H|0)){H=f[P>>2]|0;E=H+-24|0;G=H;while(1){if((G|0)==(E|0)){D=a;break a}H=G+-24|0;f[P>>2]=H;a_c(H);G=f[P>>2]|0}}G=f[P>>2]|0;if(((G-(f[d>>2]|0)|0)/24|0)>>>0<2){D=a;break a}N_c(g,G+-24|0);G=f[P>>2]|0;E=G+-24|0;Q=G;while(1){if((Q|0)==(E|0))break;H=Q+-24|0;f[P>>2]=H;a_c(H);Q=f[P>>2]|0}N_c(h,G+-48|0);$_c(m,528049,h);z_c(m,528158)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];Q=0;while(1){if((Q|0)==3)break;f[m+(Q<<2)>>2]=0;Q=Q+1|0}Q=b[g+11>>0]|0;G=Q<<24>>24<0;d_c(k,G?f[g>>2]|0:g,G?f[g+4>>2]|0:Q&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];Q=0;while(1){if((Q|0)==3)break;f[k+(Q<<2)>>2]=0;Q=Q+1|0}z_c(j,528096)|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];Q=0;while(1){if((Q|0)==3)break;f[j+(Q<<2)>>2]=0;Q=Q+1|0}Q_c(i,l);R_c((f[P>>2]|0)+-24|0,i);a_c(i);r_c(l);r_c(j);r_c(k);r_c(m);r_c(h);r_c(g);D=R;break a;break}case 108:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528161)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;$=h}else{G=Q+16&-16;E=o_c(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;$=E}$Mc($,528161,Q)|0;b[g>>0]=0;VNc($+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528164)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;aa=h}else{E=Q+16&-16;G=o_c(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;aa=G}$Mc(aa,528164,Q)|0;b[g>>0]=0;VNc(aa+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528167)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;ba=h}else{G=Q+16&-16;E=o_c(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ba=E}$Mc(ba,528167,Q)|0;b[g>>0]=0;VNc(ba+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528083)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;ca=h}else{E=Q+16&-16;G=o_c(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ca=G}$Mc(ca,528083,Q)|0;b[g>>0]=0;VNc(ca+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}default:{D=a;break a}}break}case 109:{switch(b[x>>0]|0){case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528171)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;da=h}else{G=Q+16&-16;E=o_c(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;da=E}$Mc(da,528171,Q)|0;b[g>>0]=0;VNc(da+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 73:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528173)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;ea=h}else{E=Q+16&-16;G=o_c(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ea=G}$Mc(ea,528173,Q)|0;b[g>>0]=0;VNc(ea+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528067)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;fa=h}else{G=Q+16&-16;E=o_c(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;fa=E}$Mc(fa,528067,Q)|0;b[g>>0]=0;VNc(fa+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528176)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;ga=h}else{E=Q+16&-16;G=o_c(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ga=G}$Mc(ga,528176,Q)|0;b[g>>0]=0;VNc(ga+Q|0,g);Q=c$c(w,c,h,d)|0;r_c(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 109:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=UNc(528179)|0;if(Q>>>0>4294967279)jYc(h);if(Q>>>0<11){b[h+11>>0]=Q;ha=h}else{G=Q+16&-16;E=o_c(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ha=E}$Mc(ha,528179,Q)|0;b[g>>0]=0;VNc(ha+Q|0,g);Q=d$c(A,c,h,d)|0;r_c(h);D=(Q|0)==(A|0)?a:Q;break a}Q=Z_c(w,c,d)|0;if((Q|0)==(w|0)){D=a;break a}E=d+4|0;G=f[E>>2]|0;if((f[d>>2]|0)==(G|0)){D=a;break a}N_c(i,G+-24|0);y_c(i,0,528049)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}z_c(h,528182)|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];G=0;while(1){if((G|0)==3)break;f[h+(G<<2)>>2]=0;G=G+1|0}Q_c(g,n);R_c((f[E>>2]|0)+-24|0,g);a_c(g);r_c(n);r_c(h);r_c(i);D=Q;break a;break}default:{D=a;break a}}break}case 110:{switch(b[x>>0]|0){case 119:case 97:{D=n$c(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528186)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;ia=h}else{R=G+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ia=P}$Mc(ia,528186,G)|0;b[g>>0]=0;VNc(ia+G|0,g);G=c$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 103:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528171)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;ja=h}else{P=G+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ja=R}$Mc(ja,528171,G)|0;b[g>>0]=0;VNc(ja+G|0,g);G=d$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528189)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;ka=h}else{R=G+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ka=P}$Mc(ka,528189,G)|0;b[g>>0]=0;VNc(ka+G|0,g);G=d$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 120:{G=o$c(w,c,d)|0;D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 111:{switch(b[x>>0]|0){case 110:{D=k$c(a,c,d)|0;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528191)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;la=h}else{P=G+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;la=R}$Mc(la,528191,G)|0;b[g>>0]=0;VNc(la+G|0,g);G=c$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 114:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528194)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;ma=h}else{R=G+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ma=P}$Mc(ma,528194,G)|0;b[g>>0]=0;VNc(ma+G|0,g);G=c$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 82:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528196)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;na=h}else{P=G+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;na=R}$Mc(na,528196,G)|0;b[g>>0]=0;VNc(na+G|0,g);G=c$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 112:{switch(b[x>>0]|0){case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528199)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;oa=h}else{R=G+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;oa=P}$Mc(oa,528199,G)|0;b[g>>0]=0;VNc(oa+G|0,g);G=c$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528203)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;pa=h}else{P=G+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;pa=R}$Mc(pa,528203,G)|0;b[g>>0]=0;VNc(pa+G|0,g);G=c$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528205)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;qa=h}else{R=G+16&-16;P=o_c(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;qa=P}$Mc(qa,528205,G)|0;b[g>>0]=0;VNc(qa+G|0,g);G=c$c(w,c,h,d)|0;r_c(h);D=(G|0)==(w|0)?a:G;break a;break}case 112:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=UNc(528208)|0;if(G>>>0>4294967279)jYc(h);if(G>>>0<11){b[h+11>>0]=G;ra=h}else{P=G+16&-16;R=o_c(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ra=R}$Mc(ra,528208,G)|0;b[g>>0]=0;VNc(ra+G|0,g);G=d$c(A,c,h,d)|0;r_c(h);D=(G|0)==(A|0)?a:G;break a}G=Z_c(w,c,d)|0;if((G|0)==(w|0)){D=a;break a}R=d+4|0;P=f[R>>2]|0;if((f[d>>2]|0)==(P|0)){D=a;break a}N_c(i,P+-24|0);y_c(i,0,528049)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];P=0;while(1){if((P|0)==3)break;f[i+(P<<2)>>2]=0;P=P+1|0}z_c(h,528211)|0;f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];P=0;while(1){if((P|0)==3)break;f[h+(P<<2)>>2]=0;P=P+1|0}Q_c(g,o);R_c((f[R>>2]|0)+-24|0,g);a_c(g);r_c(o);r_c(h);r_c(i);D=G;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;P=UNc(528203)|0;if(P>>>0>4294967279)jYc(h);if(P>>>0<11){b[h+11>>0]=P;sa=h}else{Q=P+16&-16;E=o_c(Q)|0;f[h>>2]=E;f[h+8>>2]=Q|-2147483648;f[h+4>>2]=P;sa=E}$Mc(sa,528203,P)|0;b[g>>0]=0;VNc(sa+P|0,g);P=d$c(w,c,h,d)|0;r_c(h);D=(P|0)==(w|0)?a:P;break a;break}case 116:{D=p$c(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 113:{if((b[x>>0]|0)!=117){D=a;break a}P=Z_c(w,c,d)|0;if((P|0)==(w|0)){D=a;break a}E=Z_c(P,c,d)|0;if((E|0)==(P|0)){P=d+4|0;Q=f[P>>2]|0;H=Q+-24|0;ta=Q;while(1){if((ta|0)==(H|0)){D=a;break a}Q=ta+-24|0;f[P>>2]=Q;a_c(Q);ta=f[P>>2]|0}}P=Z_c(E,c,d)|0;ta=d+4|0;if((P|0)==(E|0)){H=f[ta>>2]|0;G=H+-24|0;R=H;while(1){if((R|0)==(G|0))break;Q=R+-24|0;f[ta>>2]=Q;a_c(Q);R=f[ta>>2]|0}R=H+-48|0;E=G;while(1){if((E|0)==(R|0)){D=a;break a}Q=E+-24|0;f[ta>>2]=Q;a_c(Q);E=f[ta>>2]|0}}E=f[ta>>2]|0;if(((E-(f[d>>2]|0)|0)/24|0)>>>0<3){D=a;break a}N_c(g,E+-24|0);E=f[ta>>2]|0;R=E+-24|0;G=E;while(1){if((G|0)==(R|0))break;H=G+-24|0;f[ta>>2]=H;a_c(H);G=f[ta>>2]|0}N_c(h,E+-48|0);G=f[ta>>2]|0;R=G+-24|0;H=G;while(1){if((H|0)==(R|0))break;Q=H+-24|0;f[ta>>2]=Q;a_c(Q);H=f[ta>>2]|0}N_c(i,G+-48|0);$_c(s,528049,i);z_c(s,528215)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];H=0;while(1){if((H|0)==3)break;f[s+(H<<2)>>2]=0;H=H+1|0}H=b[h+11>>0]|0;G=H<<24>>24<0;d_c(r,G?f[h>>2]|0:h,G?f[h+4>>2]|0:H&255)|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];H=0;while(1){if((H|0)==3)break;f[r+(H<<2)>>2]=0;H=H+1|0}z_c(q,528221)|0;f[m>>2]=f[q>>2];f[m+4>>2]=f[q+4>>2];f[m+8>>2]=f[q+8>>2];H=0;while(1){if((H|0)==3)break;f[q+(H<<2)>>2]=0;H=H+1|0}H=b[g+11>>0]|0;G=H<<24>>24<0;d_c(m,G?f[g>>2]|0:g,G?f[g+4>>2]|0:H&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];H=0;while(1){if((H|0)==3)break;f[m+(H<<2)>>2]=0;H=H+1|0}z_c(k,528047)|0;f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];f[p+8>>2]=f[k+8>>2];H=0;while(1){if((H|0)==3)break;f[k+(H<<2)>>2]=0;H=H+1|0}Q_c(j,p);R_c((f[ta>>2]|0)+-24|0,j);a_c(j);r_c(p);r_c(k);r_c(m);r_c(q);r_c(r);r_c(s);r_c(i);r_c(h);r_c(g);D=P;break a;break}case 114:{switch(b[x>>0]|0){case 99:{D=q$c(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528227)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;ua=h}else{G=H+16&-16;R=o_c(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;ua=R}$Mc(ua,528227,H)|0;b[g>>0]=0;VNc(ua+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}case 77:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528229)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;va=h}else{R=H+16&-16;G=o_c(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;va=G}$Mc(va,528229,H)|0;b[g>>0]=0;VNc(va+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528232)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;wa=h}else{G=H+16&-16;R=o_c(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;wa=R}$Mc(wa,528232,H)|0;b[g>>0]=0;VNc(wa+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=UNc(528235)|0;if(H>>>0>4294967279)jYc(h);if(H>>>0<11){b[h+11>>0]=H;xa=h}else{R=H+16&-16;G=o_c(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;xa=G}$Mc(xa,528235,H)|0;b[g>>0]=0;VNc(xa+H|0,g);H=c$c(w,c,h,d)|0;r_c(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 115:{switch(b[x>>0]|0){case 99:{D=r$c(a,c,d)|0;break a;break}case 112:{D=s$c(a,c,d)|0;break a;break}case 114:{D=k$c(a,c,d)|0;break a;break}case 116:{D=t$c(a,c,d)|0;break a;break}case 122:{D=u$c(a,c,d)|0;break a;break}case 90:{if((t-y|0)<=2){D=a;break a}switch(b[C>>0]|0){case 84:{D=v$c(a,c,d)|0;break a;break}case 102:{D=w$c(a,c,d)|0;break a;break}default:{D=a;break a}}break}default:{D=a;break a}}break}case 116:{switch(b[x>>0]|0){case 105:case 101:{D=x$c(a,c,d)|0;break a;break}case 114:{y$c(g,528239);H=d+4|0;G=f[H>>2]|0;if(G>>>0<(f[d+8>>2]|0)>>>0){S_c(G,g);f[H>>2]=(f[H>>2]|0)+24}else T_c(d,g);a_c(g);D=w;break a;break}case 119:{D=z$c(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{D=k$c(a,c,d)|0;break a;break}default:{D=a;break a}}while(0)}else D=a;while(0);u=e;return D|0}function __c(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+11|0;d=b[c>>0]|0;if(d<<24>>24<0){e=f[a+4>>2]|0;g=(f[a+8>>2]&2147483647)+-1|0}else{e=d&255;g=10}h=e>>>0<11;i=h?10:(e+16&-16)+-1|0;a:do if((i|0)!=(g|0)){do if(h){j=f[a>>2]|0;if(d<<24>>24<0){k=0;l=j;m=a;n=12}else{$Mc(a,j,(d&255)+1|0)|0;p_c(j);n=14}}else{j=o_c(i+1|0)|0;if(i>>>0<=g>>>0&(j|0)==0)break a;o=b[c>>0]|0;if(o<<24>>24<0){k=1;l=f[a>>2]|0;m=j;n=12;break}else{$Mc(j,a,(o&255)+1|0)|0;p=j;n=13;break}}while(0);if((n|0)==12){$Mc(m,l,(f[a+4>>2]|0)+1|0)|0;p_c(l);if(k){p=m;n=13}else n=14}if((n|0)==13){f[a+8>>2]=i+1|-2147483648;f[a+4>>2]=e;f[a>>2]=p;break}else if((n|0)==14){b[c>>0]=e;break}}while(0);return}function $_c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=UNc(c)|0;i=d+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+h|0;if(j>>>0>4294967279)jYc(a);if(j>>>0<11){b[a+11>>0]=h;l=a}else{m=j+16&-16;j=o_c(m)|0;f[a>>2]=j;f[a+8>>2]=m|-2147483648;f[a+4>>2]=h;l=j}$Mc(l,c,h)|0;b[g>>0]=0;VNc(l+h|0,g);d_c(a,(b[i>>0]|0)<0?f[d>>2]|0:d,k)|0;u=e;return}function a$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+112|0;g=e+88|0;h=e+48|0;i=e+72|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;a:do if((c-a|0)>3?(b[a>>0]|0)==76:0){n=a+1|0;o=a+3|0;p=a+2|0;do switch(b[n>>0]|0){case 84:{q=a;break a;break}case 119:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529241)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;s=h}else{t=r+16&-16;v=o_c(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;s=v}$Mc(s,529241,r)|0;b[g>>0]=0;VNc(s+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 98:{if((b[o>>0]|0)!=69){q=a;break a}r=a+4|0;switch(b[p>>0]|0){case 48:{y$c(g,529249);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){S_c(t,g);f[v>>2]=(f[v>>2]|0)+24}else T_c(d,g);a_c(g);q=r;break a;break}case 49:{f0c(g,529255);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){S_c(t,g);f[v>>2]=(f[v>>2]|0)+24}else T_c(d,g);a_c(g);q=r;break a;break}default:{q=a;break a}}break}case 99:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529260)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;w=h}else{v=r+16&-16;t=o_c(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;w=t}$Mc(w,529260,r)|0;b[g>>0]=0;VNc(w+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529265)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;x=h}else{t=r+16&-16;v=o_c(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;x=v}$Mc(x,529265,r)|0;b[g>>0]=0;VNc(x+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 104:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529277)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;y=h}else{v=r+16&-16;t=o_c(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;y=t}$Mc(y,529277,r)|0;b[g>>0]=0;VNc(y+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529291)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;z=h}else{t=r+16&-16;v=o_c(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;z=v}$Mc(z,529291,r)|0;b[g>>0]=0;VNc(z+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529297)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;A=h}else{v=r+16&-16;t=o_c(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;A=t}$Mc(A,529297,r)|0;b[g>>0]=0;VNc(A+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(1165591)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;B=h}else{t=r+16&-16;v=o_c(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;B=v}$Mc(B,1165591,r)|0;b[g>>0]=0;VNc(B+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 106:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529312)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;C=h}else{v=r+16&-16;t=o_c(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;C=t}$Mc(C,529312,r)|0;b[g>>0]=0;VNc(C+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529314)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;D=h}else{t=r+16&-16;v=o_c(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;D=v}$Mc(D,529314,r)|0;b[g>>0]=0;VNc(D+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529316)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;E=h}else{v=r+16&-16;t=o_c(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;E=t}$Mc(E,529316,r)|0;b[g>>0]=0;VNc(E+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 120:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529319)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;F=h}else{t=r+16&-16;v=o_c(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;F=v}$Mc(F,529319,r)|0;b[g>>0]=0;VNc(F+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 121:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529322)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;G=h}else{v=r+16&-16;t=o_c(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;G=t}$Mc(G,529322,r)|0;b[g>>0]=0;VNc(G+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529326)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;H=h}else{t=r+16&-16;v=o_c(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;H=v}$Mc(H,529326,r)|0;b[g>>0]=0;VNc(H+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=UNc(529335)|0;if(r>>>0>4294967279)jYc(h);if(r>>>0<11){b[h+11>>0]=r;I=h}else{v=r+16&-16;t=o_c(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;I=t}$Mc(I,529335,r)|0;b[g>>0]=0;VNc(I+r|0,g);r=e0c(p,c,h,d)|0;r_c(h);q=(r|0)==(p|0)?a:r;break a;break}case 102:{r=g0c(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 100:{r=h0c(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 101:{r=i0c(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 95:{if((b[p>>0]|0)!=90){q=a;break a}r=s_c(o,c,d)|0;if((r|0)==(o|0)|(r|0)==(c|0)){q=a;break a}q=(b[r>>0]|0)==69?r+1|0:a;break a;break}default:{r=v_c(n,c,d)|0;if((r|0)==(n|0)|(r|0)==(c|0)){q=a;break a}if((b[r>>0]|0)==69){q=r+1|0;break a}else J=r;while(1){K=J+1|0;if((J|0)==(c|0)){q=a;break a}L=b[J>>0]|0;if(((L<<24>>24)+-48|0)>>>0<10)J=K;else break}if(!((J|0)!=(r|0)&L<<24>>24==69)){q=a;break a}t=d+4|0;v=f[t>>2]|0;if((f[d>>2]|0)==(v|0)){q=a;break a}N_c(l,v+-24|0);y_c(l,0,528049)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];v=0;while(1){if((v|0)==3)break;f[l+(v<<2)>>2]=0;v=v+1|0}z_c(k,528047)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];v=0;while(1){if((v|0)==3)break;f[k+(v<<2)>>2]=0;v=v+1|0}f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;v=J-r|0;if(v>>>0>4294967279)jYc(m);if(v>>>0<11){b[m+11>>0]=v;M=m}else{N=v+16&-16;O=o_c(N)|0;f[m>>2]=O;f[m+8>>2]=N|-2147483648;f[m+4>>2]=v;M=O}O=r;N=M;while(1){if((O|0)==(J|0))break;VNc(N,O);O=O+1|0;N=N+1|0}b[g>>0]=0;VNc(M+v|0,g);N=b[m+11>>0]|0;O=N<<24>>24<0;d_c(j,O?f[m>>2]|0:m,O?f[m+4>>2]|0:N&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];N=0;while(1){if((N|0)==3)break;f[j+(N<<2)>>2]=0;N=N+1|0}Q_c(h,i);R_c((f[t>>2]|0)+-24|0,h);a_c(h);r_c(i);r_c(m);r_c(j);r_c(k);r_c(l);q=K;break a}}while(0)}else q=a;while(0);u=e;return q|0}function b$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e+64|0;h=e+60|0;i=e+24|0;j=e+48|0;k=e+12|0;l=e;a:do if((c-a|0)>2?(b[a>>0]|0)==102:0){m=a+2|0;switch(b[a+1>>0]|0){case 112:{n=w_c(m,c,h)|0;o=Y_c(n,c)|0;if((o|0)!=(c|0)?(b[o>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=o-n|0;if(p>>>0>4294967279)jYc(k);if(p>>>0<11){b[k+11>>0]=p;q=k}else{r=p+16&-16;s=o_c(r)|0;f[k>>2]=s;f[k+8>>2]=r|-2147483648;f[k+4>>2]=p;q=s}s=n;n=q;while(1){if((s|0)==(o|0))break;VNc(n,s);s=s+1|0;n=n+1|0}b[g>>0]=0;VNc(q+p|0,g);y_c(k,0,529238)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}Q_c(i,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){S_c(p,i);f[n>>2]=(f[n>>2]|0)+24}else T_c(d,i);a_c(i);r_c(j);r_c(k);t=o+1|0}else t=a;v=t;break a;break}case 76:break;default:{v=a;break a}}n=Y_c(m,c)|0;if((((n|0)!=(c|0)?(b[n>>0]|0)==112:0)?(p=w_c(n+1|0,c,h)|0,n=Y_c(p,c)|0,(n|0)!=(c|0)):0)?(b[n>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=n-p|0;if(s>>>0>4294967279)jYc(k);if(s>>>0<11){b[k+11>>0]=s;w=k}else{r=s+16&-16;x=o_c(r)|0;f[k>>2]=x;f[k+8>>2]=r|-2147483648;f[k+4>>2]=s;w=x}x=p;p=w;while(1){if((x|0)==(n|0))break;VNc(p,x);x=x+1|0;p=p+1|0}b[g>>0]=0;VNc(w+s|0,g);y_c(k,0,529238)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}Q_c(i,l);p=d+4|0;s=f[p>>2]|0;if(s>>>0<(f[d+8>>2]|0)>>>0){S_c(s,i);f[p>>2]=(f[p>>2]|0)+24}else T_c(d,i);a_c(i);r_c(l);r_c(k);y=n+1|0}else y=a;v=y}else v=a;while(0);u=e;return v|0}function c$c(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+96|0;h=g+84|0;i=g+72|0;j=g+60|0;k=g+48|0;l=g+36|0;m=g+24|0;n=g+12|0;o=g;p=Z_c(a,c,e)|0;a:do if((p|0)!=(a|0)){q=Z_c(p,c,e)|0;r=e+4|0;if((q|0)==(p|0)){s=f[r>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0)){w=a;break a}s=v+-24|0;f[r>>2]=s;a_c(s);v=f[r>>2]|0}}v=f[r>>2]|0;if(((v-(f[e>>2]|0)|0)/24|0)>>>0>=2){N_c(i,v+-24|0);v=f[r>>2]|0;t=v+-24|0;s=v;while(1){if((s|0)==(t|0))break;x=s+-24|0;f[r>>2]=x;a_c(x);s=f[r>>2]|0}N_c(j,v+-48|0);s=f[r>>2]|0;t=s+-24|0;x=t+11|0;if((b[x>>0]|0)<0){y=f[t>>2]|0;b[h>>0]=0;VNc(y,h);f[s+-20>>2]=0}else{b[h>>0]=0;VNc(t,h);b[x>>0]=0}x=UNc(528085)|0;s=d+11|0;y=b[s>>0]|0;z=d+4|0;if((x|0)==((y<<24>>24<0?f[z>>2]|0:y&255)|0)?(J_c(d,528085,x)|0)==0:0)S$c(t,40);$_c(o,528049,j);z_c(o,528335)|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}x=b[s>>0]|0;r=x<<24>>24<0;d_c(n,r?f[d>>2]|0:d,r?f[z>>2]|0:x&255)|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];x=0;while(1){if((x|0)==3)break;f[n+(x<<2)>>2]=0;x=x+1|0}z_c(m,528044)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];x=0;while(1){if((x|0)==3)break;f[m+(x<<2)>>2]=0;x=x+1|0}x=b[i+11>>0]|0;r=x<<24>>24<0;d_c(l,r?f[i>>2]|0:i,r?f[i+4>>2]|0:x&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];x=0;while(1){if((x|0)==3)break;f[l+(x<<2)>>2]=0;x=x+1|0}z_c(k,528047)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];x=0;while(1){if((x|0)==3)break;f[k+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;r=x<<24>>24<0;d_c(t,r?f[h>>2]|0:h,r?f[h+4>>2]|0:x&255)|0;r_c(h);r_c(k);r_c(l);r_c(m);r_c(n);r_c(o);x=UNc(528085)|0;r=b[s>>0]|0;if((x|0)==((r<<24>>24<0?f[z>>2]|0:r&255)|0)?(J_c(d,528085,x)|0)==0:0)S$c(t,41);r_c(j);r_c(i);w=q}else w=a}else w=a;while(0);u=g;return w|0}function d$c(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+64|0;h=g+48|0;i=g+36|0;j=g+24|0;k=g+12|0;l=g;m=Z_c(a,c,e)|0;if((m|0)!=(a|0)?(c=e+4|0,(f[e>>2]|0)!=(f[c>>2]|0)):0){P_c(k,d,528049);N_c(l,(f[c>>2]|0)+-24|0);d=b[l+11>>0]|0;e=d<<24>>24<0;d_c(k,e?f[l>>2]|0:l,e?f[l+4>>2]|0:d&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];d=0;while(1){if((d|0)==3)break;f[k+(d<<2)>>2]=0;d=d+1|0}z_c(j,528047)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}d=f[c>>2]|0;c=d+-24|0;e=c+11|0;if((b[e>>0]|0)<0){n=f[c>>2]|0;b[h>>0]=0;VNc(n,h);f[d+-20>>2]=0}else{b[h>>0]=0;VNc(c,h);b[e>>0]=0}__c(c);f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}r_c(i);r_c(j);r_c(l);r_c(k);o=m}else o=a;u=g;return o|0}function e$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=v_c(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){N_c(j,c+-24|0);y_c(j,0,529228)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;VNc(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;VNc(k,g);b[d>>0]=0}__c(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}r_c(h);r_c(i);r_c(j);n=l}else n=a;u=e;return n|0}function f$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=Z_c(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){N_c(j,c+-24|0);y_c(j,0,529228)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;VNc(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;VNc(k,g);b[d>>0]=0}__c(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}r_c(h);r_c(i);r_c(j);n=l}else n=a;u=e;return n|0}function g$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=v_c(n,c,d)|0,(o|0)!=(n|0)):0)?(n=Z_c(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){N_c(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;a_c(q);p=f[o>>2]|0}N_c(m,c+-48|0);y_c(m,0,529216)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}z_c(l,528296)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;d_c(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}z_c(j,528047)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Q_c(h,i);R_c((f[o>>2]|0)+-24|0,h);a_c(h);r_c(i);r_c(j);r_c(k);r_c(l);r_c(m);r_c(g);r=n}else r=a;u=e;return r|0}function h$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((((c-a|0)>3?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==108:0)?(i=a+2|0,j=Z_c(i,c,d)|0,!((j|0)==(i|0)|(j|0)==(c|0))):0)?(i=d+4|0,k=f[i>>2]|0,(f[d>>2]|0)!=(k|0)):0){l=k+-12|0;m=b[l+11>>0]|0;n=m<<24>>24<0;d_c(k+-24|0,n?f[l>>2]|0:l,n?f[k+-8>>2]|0:m&255)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}m=f[i>>2]|0;k=m+-12|0;n=k+11|0;if((b[n>>0]|0)<0){l=f[k>>2]|0;b[g>>0]=0;VNc(l,g);f[m+-8>>2]=0}else{b[g>>0]=0;VNc(k,g);b[n>>0]=0}__c(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}r_c(h);z_c((f[i>>2]|0)+-24|0,528049)|0;k=g+11|0;n=g+4|0;m=j;while(1){if((b[m>>0]|0)==69)break;l=Z_c(m,c,d)|0;if((l|0)==(m|0)|(l|0)==(c|0)){o=a;break a}p=f[i>>2]|0;if((f[d>>2]|0)==(p|0)){o=a;break a}N_c(g,p+-24|0);p=f[i>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0))break;s=r+-24|0;f[i>>2]=s;a_c(s);r=f[i>>2]|0}r=b[k>>0]|0;s=r<<24>>24<0;t=s?f[n>>2]|0:r&255;if(t|0){if((f[d>>2]|0)==(q|0)){v=26;break}d_c(p+-48|0,s?f[g>>2]|0:g,t)|0}r_c(g);m=l}if((v|0)==26){r_c(g);o=a;break}n=f[i>>2]|0;if((f[d>>2]|0)!=(n|0)){z_c(n+-24|0,528047)|0;o=m+1|0}else o=a}else o=a;while(0);u=e;return o|0}function i$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;a:do if((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==118:0)?(n=d+63|0,o=b[n>>0]|0,b[n>>0]=0,p=a+2|0,q=v_c(p,c,d)|0,b[n>>0]=o,!((q|0)==(p|0)|(q|0)==(c|0))):0){if((b[q>>0]|0)!=95){p=Z_c(q,c,d)|0;if((p|0)==(q|0)){r=a;break}else s=p}else{p=q+1|0;if((p|0)==(c|0)){r=a;break}q=b[p>>0]|0;b:do if(q<<24>>24==69){o=d+4|0;n=f[o>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;Y$c(n);f[o>>2]=(f[o>>2]|0)+24;t=p;break}else{Z$c(d);t=p;break}}else{o=p;n=q;while(1){if(n<<24>>24==69){t=o;break b}v=Z_c(o,c,d)|0;w=(v|0)==(o|0)|(v|0)==(c|0);if(w){r=a;break a}x=b[(w?o:v)>>0]|0;o=v;n=x}}while(0);s=t+1|0}q=d+4|0;p=f[q>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0>=2){N_c(g,p+-24|0);p=f[q>>2]|0;n=p+-24|0;o=p;while(1){if((o|0)==(n|0))break;x=o+-24|0;f[q>>2]=x;a_c(x);o=f[q>>2]|0}N_c(m,p+-48|0);y_c(m,0,528049)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];o=0;while(1){if((o|0)==3)break;f[m+(o<<2)>>2]=0;o=o+1|0}z_c(l,529213)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];o=0;while(1){if((o|0)==3)break;f[l+(o<<2)>>2]=0;o=o+1|0}o=b[g+11>>0]|0;p=o<<24>>24<0;d_c(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:o&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];o=0;while(1){if((o|0)==3)break;f[k+(o<<2)>>2]=0;o=o+1|0}z_c(j,528047)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}Q_c(h,i);R_c((f[q>>2]|0)+-24|0,h);a_c(h);r_c(i);r_c(j);r_c(k);r_c(l);r_c(m);r_c(g);r=s}else r=a}else r=a;while(0);u=e;return r|0}function j$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=v_c(n,c,d)|0,(o|0)!=(n|0)):0)?(n=Z_c(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){N_c(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;a_c(q);p=f[o>>2]|0}N_c(m,c+-48|0);y_c(m,0,529199)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}z_c(l,528296)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;d_c(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}z_c(j,528047)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Q_c(h,i);R_c((f[o>>2]|0)+-24|0,h);a_c(h);r_c(i);r_c(j);r_c(k);r_c(l);r_c(m);r_c(g);r=n}else r=a;u=e;return r|0}function k$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+32|0;g=e+12|0;h=e;i=c;a:do if((i-a|0)>2){if((b[a>>0]|0)==103){j=(b[a+1>>0]|0)==115;k=j;l=j?a+2|0:a}else{k=0;l=a}j=C$c(l,c,d)|0;if((j|0)!=(l|0)){if(!k){m=j;break}n=f[d+4>>2]|0;if((f[d>>2]|0)==(n|0)){m=a;break}y_c(n+-24|0,0,528121)|0;m=j;break}if(((i-l|0)>2?(b[l>>0]|0)==115:0)?(b[l+1>>0]|0)==114:0){j=l+2|0;if((b[j>>0]|0)==78){n=l+3|0;o=D$c(n,c,d)|0;if((o|0)==(n|0)|(o|0)==(c|0)){m=a;break}n=M_c(o,c,d)|0;p=d+4|0;do if((n|0)==(o|0)){q=o;r=d}else{s=f[p>>2]|0;if(((s-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}N_c(g,s+-24|0);s=f[p>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0))break;w=v+-24|0;f[p>>2]=w;a_c(w);v=f[p>>2]|0}v=b[g+11>>0]|0;t=v<<24>>24<0;d_c(s+-48|0,t?f[g>>2]|0:g,t?f[g+4>>2]|0:v&255)|0;if((n|0)!=(c|0)){r_c(g);q=n;r=d;break}v=f[p>>2]|0;t=v+-24|0;w=v;while(1){if((w|0)==(t|0))break;v=w+-24|0;f[p>>2]=v;a_c(v);w=f[p>>2]|0}r_c(g);m=a;break a}while(0);n=h+11|0;o=h+4|0;w=q;while(1){if((b[w>>0]|0)==69)break;t=E$c(w,c,d)|0;if((t|0)==(w|0)|(t|0)==(c|0)){m=a;break a}s=f[p>>2]|0;if(((s-(f[r>>2]|0)|0)/24|0)>>>0<2){m=a;break a}N_c(g,s+-24|0);s=f[p>>2]|0;v=s+-24|0;x=s;while(1){if((x|0)==(v|0))break;s=x+-24|0;f[p>>2]=s;a_c(s);x=f[p>>2]|0}y_c(g,0,528121)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[n>>0]|0;v=x<<24>>24<0;d_c((f[p>>2]|0)+-24|0,v?f[h>>2]|0:h,v?f[o>>2]|0:x&255)|0;r_c(h);r_c(g);w=t}o=w+1|0;n=C$c(o,c,d)|0;if((n|0)==(o|0)){o=f[p>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}x=o+-24|0;v=o;while(1){if((v|0)==(x|0)){m=a;break a}o=v+-24|0;f[p>>2]=o;a_c(o);v=f[p>>2]|0}}v=f[p>>2]|0;if(((v-(f[r>>2]|0)|0)/24|0)>>>0<2){m=a;break}N_c(g,v+-24|0);v=f[p>>2]|0;x=v+-24|0;w=v;while(1){if((w|0)==(x|0))break;v=w+-24|0;f[p>>2]=v;a_c(v);w=f[p>>2]|0}y_c(g,0,528121)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];w=0;while(1){if((w|0)==3)break;f[g+(w<<2)>>2]=0;w=w+1|0}w=b[h+11>>0]|0;x=w<<24>>24<0;d_c((f[p>>2]|0)+-24|0,x?f[h>>2]|0:h,x?f[h+4>>2]|0:w&255)|0;r_c(h);r_c(g);m=n;break}w=D$c(j,c,d)|0;if((w|0)!=(j|0)){x=M_c(w,c,d)|0;if((x|0)==(w|0))y=w;else{w=d+4|0;v=f[w>>2]|0;if(((v-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}N_c(g,v+-24|0);v=f[w>>2]|0;o=v+-24|0;s=v;while(1){if((s|0)==(o|0))break;z=s+-24|0;f[w>>2]=z;a_c(z);s=f[w>>2]|0}w=b[g+11>>0]|0;s=w<<24>>24<0;d_c(v+-48|0,s?f[g>>2]|0:g,s?f[g+4>>2]|0:w&255)|0;r_c(g);y=x}w=C$c(y,c,d)|0;if((w|0)==(y|0)){s=d+4|0;o=f[s>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}n=o+-24|0;p=o;while(1){if((p|0)==(n|0)){m=a;break a}o=p+-24|0;f[s>>2]=o;a_c(o);p=f[s>>2]|0}}s=d+4|0;p=f[s>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}N_c(g,p+-24|0);p=f[s>>2]|0;n=p+-24|0;x=p;while(1){if((x|0)==(n|0))break;p=x+-24|0;f[s>>2]=p;a_c(p);x=f[s>>2]|0}y_c(g,0,528121)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;n=x<<24>>24<0;d_c((f[s>>2]|0)+-24|0,n?f[h>>2]|0:h,n?f[h+4>>2]|0:x&255)|0;r_c(h);r_c(g);m=w;break}x=E$c(j,c,d)|0;if(!((x|0)==(j|0)|(x|0)==(c|0))){if(k){n=d+4|0;p=f[n>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}y_c(p+-24|0,0,528121)|0;A=n}else A=d+4|0;n=h+11|0;p=h+4|0;v=x;while(1){if((b[v>>0]|0)==69)break;x=E$c(v,c,d)|0;if((x|0)==(v|0)|(x|0)==(c|0)){m=a;break a}o=f[A>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}N_c(g,o+-24|0);o=f[A>>2]|0;z=o+-24|0;B=o;while(1){if((B|0)==(z|0))break;o=B+-24|0;f[A>>2]=o;a_c(o);B=f[A>>2]|0}y_c(g,0,528121)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];B=0;while(1){if((B|0)==3)break;f[g+(B<<2)>>2]=0;B=B+1|0}B=b[n>>0]|0;z=B<<24>>24<0;d_c((f[A>>2]|0)+-24|0,z?f[h>>2]|0:h,z?f[p>>2]|0:B&255)|0;r_c(h);r_c(g);v=x}p=v+1|0;n=C$c(p,c,d)|0;if((n|0)==(p|0)){p=f[A>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}j=p+-24|0;w=p;while(1){if((w|0)==(j|0)){m=a;break a}p=w+-24|0;f[A>>2]=p;a_c(p);w=f[A>>2]|0}}w=f[A>>2]|0;if(((w-(f[d>>2]|0)|0)/24|0)>>>0>=2){N_c(g,w+-24|0);w=f[A>>2]|0;j=w+-24|0;v=w;while(1){if((v|0)==(j|0))break;w=v+-24|0;f[A>>2]=w;a_c(w);v=f[A>>2]|0}y_c(g,0,528121)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];v=0;while(1){if((v|0)==3)break;f[g+(v<<2)>>2]=0;v=v+1|0}v=b[h+11>>0]|0;j=v<<24>>24<0;d_c((f[A>>2]|0)+-24|0,j?f[h>>2]|0:h,j?f[h+4>>2]|0:v&255)|0;r_c(h);r_c(g);m=n}else m=a}else m=a}else m=a}else m=a;while(0);u=e;return m|0}function l$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==115:0)?(i=a+2|0,j=Z_c(i,c,d)|0,(j|0)!=(i|0)):0)?(i=Z_c(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){N_c(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;a_c(c);k=f[j>>2]|0}$_c(h,528340,g);k=b[h+11>>0]|0;d=k<<24>>24<0;d_c((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;r_c(h);r_c(g);l=i}else l=a;u=e;return l|0}function m$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==116:0)?(i=a+2|0,j=Z_c(i,c,d)|0,(j|0)!=(i|0)):0)?(i=k$c(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){N_c(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;a_c(c);k=f[j>>2]|0}$_c(h,528338,g);k=b[h+11>>0]|0;d=k<<24>>24<0;d_c((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;r_c(h);r_c(g);l=i}else l=a;u=e;return l|0}function n$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+112|0;g=e+88|0;h=e+76|0;i=e+64|0;j=e+40|0;k=e+16|0;l=e;m=e+52|0;n=c;a:do if((n-a|0)>3){o=b[a>>0]|0;if(o<<24>>24==103){p=(b[a+1>>0]|0)==115;q=p?a+2|0:a;r=p;s=q;t=b[q>>0]|0}else{r=0;s=a;t=o}if(t<<24>>24==110){o=b[s+1>>0]|0;q=o<<24>>24==97;switch(o<<24>>24){case 97:case 119:break;default:{v=a;break a}}o=s+2|0;b:do if((o|0)!=(c|0)){p=0;w=o;while(1){if((b[w>>0]|0)==95)break;x=Z_c(w,c,d)|0;y=(x|0)==(w|0);z=(x|0)==(c|0);if(y|z)break b;else{p=p|(y|z)^1;w=x}}x=w+1|0;z=v_c(x,c,d)|0;if(!((z|0)==(x|0)|(z|0)==(c|0))){x=b[z>>0]|0;c:do if(!((n-z|0)>2&x<<24>>24==112))if(x<<24>>24==69){A=0;B=z}else break b;else{if((b[z+1>>0]|0)!=105)break b;y=z+2|0;while(1){if((b[y>>0]|0)==69){A=1;B=y;break c}C=y;y=Z_c(y,c,d)|0;if((y|0)==(C|0)|(y|0)==(c|0))break b}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[h+(z<<2)>>2]=0;z=z+1|0}d:do if(A){z=d+4|0;x=f[z>>2]|0;if((f[d>>2]|0)==(x|0)){D=a;E=1}else{N_c(i,x+-24|0);x=h+11|0;if((b[x>>0]|0)<0){w=f[h>>2]|0;b[g>>0]=0;VNc(w,g);f[h+4>>2]=0}else{b[g>>0]=0;VNc(h,g);b[x>>0]=0}__c(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];x=0;while(1){if((x|0)==3)break;f[i+(x<<2)>>2]=0;x=x+1|0}r_c(i);x=f[z>>2]|0;w=x+-24|0;y=x;while(1){if((y|0)==(w|0)){F=z;G=d;H=w;I=31;break d}x=y+-24|0;f[z>>2]=x;a_c(x);y=f[z>>2]|0}}}else{z=d+4|0;F=z;G=d;H=f[z>>2]|0;I=31}while(0);if((I|0)==31)if((f[G>>2]|0)==(H|0)){D=a;E=1}else{N_c(i,H+-24|0);z=f[F>>2]|0;y=z+-24|0;w=z;while(1){if((w|0)==(y|0))break;x=w+-24|0;f[F>>2]=x;a_c(x);w=f[F>>2]|0}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}e:do if(p)if((f[G>>2]|0)==(y|0)){J=a;K=1}else{N_c(k,z+-48|0);w=j+11|0;if((b[w>>0]|0)<0){x=f[j>>2]|0;b[g>>0]=0;VNc(x,g);f[j+4>>2]=0}else{b[g>>0]=0;VNc(j,g);b[w>>0]=0}__c(j);f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}r_c(k);w=f[F>>2]|0;x=w+-24|0;C=w;while(1){if((C|0)==(x|0)){I=49;break e}w=C+-24|0;f[F>>2]=w;a_c(w);C=f[F>>2]|0}}else I=49;while(0);if((I|0)==49){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}if(r)A$c(g,528121);if(q)z_c(g,528331)|0;else z_c(g,528081)|0;if(p){$_c(l,528049,j);z_c(l,528335)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;d_c(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;r_c(k);r_c(l)}z=b[i+11>>0]|0;p=z<<24>>24<0;d_c(g,p?f[i>>2]|0:i,p?f[i+4>>2]|0:z&255)|0;if(A){$_c(l,528044,h);z_c(l,528047)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;d_c(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;r_c(k);r_c(l)};f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}Q_c(k,m);z=f[F>>2]|0;if(z>>>0<(f[d+8>>2]|0)>>>0){S_c(z,k);f[F>>2]=(f[F>>2]|0)+24}else T_c(d,k);a_c(k);r_c(m);r_c(g);J=B+1|0;K=0}r_c(j);r_c(i);D=J;E=K}r_c(h);if(!E){v=D;break a}}}while(0);v=a}else v=a}else v=a;while(0);u=e;return v|0}function o$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;k=Z_c(a,c,d)|0;if((k|0)!=(a|0)?(c=d+4|0,l=f[c>>2]|0,(f[d>>2]|0)!=(l|0)):0){N_c(j,l+-24|0);y_c(j,0,528320)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];l=0;while(1){if((l|0)==3)break;f[i+(l<<2)>>2]=0;l=l+1|0}l=f[c>>2]|0;c=l+-24|0;d=c+11|0;if((b[d>>0]|0)<0){m=f[c>>2]|0;b[g>>0]=0;VNc(m,g);f[l+-20>>2]=0}else{b[g>>0]=0;VNc(c,g);b[d>>0]=0}__c(c);f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];c=0;while(1){if((c|0)==3)break;f[h+(c<<2)>>2]=0;c=c+1|0}r_c(h);r_c(i);r_c(j);n=k}else n=a;u=e;return n|0}function p$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((((((c-a|0)>2?(b[a>>0]|0)==112:0)?(b[a+1>>0]|0)==116:0)?(h=a+2|0,i=Z_c(h,c,d)|0,(i|0)!=(h|0)):0)?(h=Z_c(i,c,d)|0,(h|0)!=(i|0)):0)?(i=d+4|0,c=f[i>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){N_c(g,c+-24|0);c=f[i>>2]|0;d=c+-24|0;j=c;while(1){if((j|0)==(d|0))break;k=j+-24|0;f[i>>2]=k;a_c(k);j=f[i>>2]|0}z_c(c+-48|0,528317)|0;c=b[g+11>>0]|0;j=c<<24>>24<0;d_c((f[i>>2]|0)+-24|0,j?f[g>>2]|0:g,j?f[g+4>>2]|0:c&255)|0;r_c(g);l=h}else l=a;u=e;return l|0}function q$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==114:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=v_c(n,c,d)|0,(o|0)!=(n|0)):0)?(n=Z_c(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){N_c(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;a_c(q);p=f[o>>2]|0}N_c(m,c+-48|0);y_c(m,0,528299)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}z_c(l,528296)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;d_c(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}z_c(j,528047)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Q_c(h,i);R_c((f[o>>2]|0)+-24|0,h);a_c(h);r_c(i);r_c(j);r_c(k);r_c(l);r_c(m);r_c(g);r=n}else r=a;u=e;return r|0}function r$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=v_c(n,c,d)|0,(o|0)!=(n|0)):0)?(n=Z_c(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){N_c(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;a_c(q);p=f[o>>2]|0}N_c(m,c+-48|0);y_c(m,0,528283)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}z_c(l,528296)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;d_c(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}z_c(j,528047)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}Q_c(h,i);R_c((f[o>>2]|0)+-24|0,h);a_c(h);r_c(i);r_c(j);r_c(k);r_c(l);r_c(m);r_c(g);r=n}else r=a;u=e;return r|0}function s$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;if(((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==112:0){e=a+2|0;f=Z_c(e,c,d)|0;g=(f|0)==(e|0)?a:f}else g=a;return g|0}function t$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=v_c(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){N_c(j,c+-24|0);y_c(j,0,528274)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}Q_c(g,h);R_c((f[k>>2]|0)+-24|0,g);a_c(g);r_c(h);r_c(i);r_c(j);m=l}else m=a;u=e;return m|0}function u$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=Z_c(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){N_c(j,c+-24|0);y_c(j,0,528274)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}Q_c(g,h);R_c((f[k>>2]|0)+-24|0,g);a_c(g);r_c(h);r_c(i);r_c(j);m=l}else m=a;u=e;return m|0}function v$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==84):0)?(l=d+4|0,m=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,n=L_c(k,c,d)|0,c=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,(n|0)!=(k|0)):0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=UNc(528260)|0;if(k>>>0>4294967279)jYc(h);if(k>>>0<11){b[h+11>>0]=k;o=h}else{p=k+16&-16;q=o_c(p)|0;f[h>>2]=q;f[h+8>>2]=p|-2147483648;f[h+4>>2]=k;o=q}$Mc(o,528260,k)|0;b[g>>0]=0;VNc(o+k|0,g);a:do if((m|0)!=(c|0)){N_c(g,(f[d>>2]|0)+(m*24|0)|0);k=b[g+11>>0]|0;o=k<<24>>24<0;d_c(h,o?f[g>>2]|0:g,o?f[g+4>>2]|0:k&255)|0;r_c(g);k=g+11|0;o=g+4|0;q=m;while(1){p=q+1|0;if((p|0)==(c|0))break a;N_c(i,(f[d>>2]|0)+(p*24|0)|0);y_c(i,0,528271)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[k>>0]|0;s=r<<24>>24<0;d_c(h,s?f[g>>2]|0:g,s?f[o>>2]|0:r&255)|0;r_c(g);r_c(i);q=p}}while(0);z_c(h,528047)|0;i=c;while(1){if((i|0)==(m|0))break;c=f[l>>2]|0;q=c+-24|0;o=c;while(1){if((o|0)==(q|0))break;c=o+-24|0;f[l>>2]=c;a_c(c);o=f[l>>2]|0}i=i+-1|0}f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];i=0;while(1){if((i|0)==3)break;f[h+(i<<2)>>2]=0;i=i+1|0}Q_c(g,j);i=f[l>>2]|0;if(i>>>0<(f[d+8>>2]|0)>>>0){S_c(i,g);f[l>>2]=(f[l>>2]|0)+24}else T_c(d,g);a_c(g);r_c(j);r_c(h);t=n}else t=a;u=e;return t|0}function w$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==102):0)?(l=b$c(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){N_c(j,c+-24|0);y_c(j,0,528260)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}Q_c(g,h);R_c((f[k>>2]|0)+-24|0,g);a_c(g);r_c(h);r_c(i);r_c(j);m=l}else m=a;u=e;return m|0}function x$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>2?(b[a>>0]|0)==116:0){k=b[a+1>>0]|0;switch(k<<24>>24){case 101:case 105:break;default:{l=a;break a}}m=a+2|0;if(k<<24>>24==101)n=Z_c(m,c,d)|0;else n=v_c(m,c,d)|0;if((n|0)!=(m|0)?(m=d+4|0,k=f[m>>2]|0,(f[d>>2]|0)!=(k|0)):0){N_c(j,k+-24|0);y_c(j,0,528252)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];k=0;while(1){if((k|0)==3)break;f[j+(k<<2)>>2]=0;k=k+1|0}z_c(i,528047)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];k=0;while(1){if((k|0)==3)break;f[i+(k<<2)>>2]=0;k=k+1|0}Q_c(g,h);R_c((f[m>>2]|0)+-24|0,g);a_c(g);r_c(h);r_c(i);r_c(j);l=n}else l=a}else l=a;while(0);u=e;return l|0}function y$c(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=5;$Mc(a,c,5)|0;b[e>>0]=0;VNc(a+5|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function z$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==116:0)?(b[a+1>>0]|0)==119:0)?(j=a+2|0,k=Z_c(j,c,d)|0,(k|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,(f[d>>2]|0)!=(c|0)):0){N_c(i,c+-24|0);y_c(i,0,528245)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}Q_c(g,h);R_c((f[j>>2]|0)+-24|0,g);a_c(g);r_c(h);r_c(i);l=k}else l=a;u=e;return l|0}function A$c(a,b){a=a|0;b=b|0;B$c(a,b,UNc(b)|0);return}function B$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;qYc(l,c,d)|0;b[g>>0]=0;VNc(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;n_c(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return}function C$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e;a:do if((c-a|0)>1){h=b[a>>0]|0;i=h<<24>>24==111;switch(h<<24>>24){case 100:case 111:{if((b[a+1>>0]|0)==110){h=a+2|0;if(!i){i=X$c(h,c,d)|0;j=(i|0)==(h|0)?a:i;break a}i=J$c(h,c,d)|0;if((i|0)==(h|0)){j=a;break a}h=M_c(i,c,d)|0;if((h|0)==(i|0)){j=i;break a}i=d+4|0;k=f[i>>2]|0;if(((k-(f[d>>2]|0)|0)/24|0)>>>0<2){j=h;break a}N_c(g,k+-24|0);k=f[i>>2]|0;l=k+-24|0;m=k;while(1){if((m|0)==(l|0))break;n=m+-24|0;f[i>>2]=n;a_c(n);m=f[i>>2]|0}i=b[g+11>>0]|0;m=i<<24>>24<0;d_c(k+-48|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:i&255)|0;r_c(g);j=h;break a}break}default:{}}i=F$c(a,c,d)|0;if((i|0)==(a|0)){m=J$c(a,c,d)|0;if((m|0)!=(a|0)){l=M_c(m,c,d)|0;if((l|0)!=(m|0)){n=d+4|0;o=f[n>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2)j=l;else{N_c(g,o+-24|0);o=f[n>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0))break;r=q+-24|0;f[n>>2]=r;a_c(r);q=f[n>>2]|0}n=b[g+11>>0]|0;q=n<<24>>24<0;d_c(o+-48|0,q?f[g>>2]|0:g,q?f[g+4>>2]|0:n&255)|0;r_c(g);j=l}}else j=m}else j=a}else j=i}else j=a;while(0);u=e;return j|0}function D$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((a|0)==(c|0))i=a;else{j=d+16|0;switch(b[a>>0]|0){case 84:{k=d+4|0;l=((f[k>>2]|0)-(f[d>>2]|0)|0)/24|0;m=L_c(a,c,d)|0;n=f[k>>2]|0;o=(n-(f[d>>2]|0)|0)/24|0;p=n;if((m|0)!=(a|0)&(o|0)==(l+1|0)){f[h>>2]=f[d+12>>2];E_c(g,p+-24|0,h);n=d+20|0;q=f[n>>2]|0;if(q>>>0<(f[d+24>>2]|0)>>>0){f[q>>2]=0;r=q+4|0;f[r>>2]=0;s=f[g+12>>2]|0;f[q+8>>2]=0;f[q+12>>2]=s;f[q>>2]=f[g>>2];s=g+4|0;f[r>>2]=f[s>>2];r=g+8|0;f[q+8>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else F_c(j,g);b_c(g);i=m;break a}else{t=o;v=p}while(1){if((t|0)==(l|0)){i=a;break a}p=v+-24|0;o=v;while(1){if((o|0)==(p|0))break;m=o+-24|0;f[k>>2]=m;a_c(m);o=f[k>>2]|0}t=t+-1|0;v=p}break}case 68:{k=W_c(a,c,d)|0;if((k|0)==(a|0)){i=a;break a}l=f[d+4>>2]|0;if((f[d>>2]|0)==(l|0)){i=a;break a}f[h>>2]=f[d+12>>2];E_c(g,l+-24|0,h);l=d+20|0;o=f[l>>2]|0;if(o>>>0<(f[d+24>>2]|0)>>>0){f[o>>2]=0;m=o+4|0;f[m>>2]=0;n=f[g+12>>2]|0;f[o+8>>2]=0;f[o+12>>2]=n;f[o>>2]=f[g>>2];n=g+4|0;f[m>>2]=f[n>>2];m=g+8|0;f[o+8>>2]=f[m>>2];f[m>>2]=0;f[n>>2]=0;f[g>>2]=0;f[l>>2]=(f[l>>2]|0)+16}else F_c(j,g);b_c(g);i=k;break a;break}case 83:{k=V_c(a,c,d)|0;if((k|0)!=(a|0)){i=k;break a}if((c-a|0)<=2){i=a;break a}if((b[a+1>>0]|0)!=116){i=a;break a}k=a+2|0;l=G$c(k,c,d)|0;if((l|0)==(k|0)){i=a;break a}k=d+4|0;n=f[k>>2]|0;if((f[d>>2]|0)==(n|0)){i=a;break a}y_c(n+-24|0,0,528343)|0;n=(f[k>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];E_c(g,n,h);n=d+20|0;k=f[n>>2]|0;if(k>>>0<(f[d+24>>2]|0)>>>0){f[k>>2]=0;m=k+4|0;f[m>>2]=0;o=f[g+12>>2]|0;f[k+8>>2]=0;f[k+12>>2]=o;f[k>>2]=f[g>>2];o=g+4|0;f[m>>2]=f[o>>2];m=g+8|0;f[k+8>>2]=f[m>>2];f[m>>2]=0;f[o>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else F_c(j,g);b_c(g);i=l;break a;break}default:{i=a;break a}}}while(0);u=e;return i|0}function E$c(a,b,c){a=a|0;b=b|0;c=c|0;return F$c(a,b,c)|0}function F$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;if((a|0)!=(c|0)?(h=O_c(a,c,d)|0,(h|0)!=(a|0)):0){i=M_c(h,c,d)|0;if((i|0)!=(h|0)){c=d+4|0;j=f[c>>2]|0;if(((j-(f[d>>2]|0)|0)/24|0)>>>0<2)k=a;else{N_c(g,j+-24|0);j=f[c>>2]|0;d=j+-24|0;l=j;while(1){if((l|0)==(d|0))break;m=l+-24|0;f[c>>2]=m;a_c(m);l=f[c>>2]|0}c=b[g+11>>0]|0;l=c<<24>>24<0;d_c(j+-48|0,l?f[g>>2]|0:g,l?f[g+4>>2]|0:c&255)|0;r_c(g);k=i}}else k=h}else k=a;u=e;return k|0}function G$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a:do if((a|0)==(c|0))e=a;else switch(b[a>>0]|0){case 68:case 67:{e=H$c(a,c,d)|0;break a;break}case 85:{e=I$c(a,c,d)|0;break a;break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{e=O_c(a,c,d)|0;break a;break}default:return J$c(a,c,d)|0}while(0);return e|0}function H$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;a:do if((c-a|0)>1?(k=d+4|0,l=f[k>>2]|0,(f[d>>2]|0)!=(l|0)):0){m=a+2|0;n=d+60|0;o=a+1|0;switch(b[a>>0]|0){case 67:{switch(b[o>>0]|0){case 53:case 51:case 50:case 49:break;default:{p=a;break a}}V$c(h,l+-24|0);Q_c(g,h);q=f[k>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){S_c(q,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);r_c(h);b[n>>0]=1;p=m;break a;break}case 68:break;default:{p=a;break a}}switch(b[o>>0]|0){case 53:case 50:case 49:case 48:break;default:{p=a;break a}}V$c(j,l+-24|0);y_c(j,0,528119)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}Q_c(g,i);l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){S_c(l,g);f[k>>2]=(f[k>>2]|0)+24}else T_c(d,g);a_c(g);r_c(i);r_c(j);b[n>>0]=1;p=m}else p=a;while(0);u=e;return p|0}function I$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+80|0;g=e+68|0;h=e+16|0;i=e+56|0;j=e+44|0;k=e;l=e+40|0;a:do if((c-a|0)>2?(b[a>>0]|0)==85:0){m=a+2|0;switch(b[a+1>>0]|0){case 116:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=UNc(528850)|0;if(n>>>0>4294967279)jYc(i);if(n>>>0<11){b[i+11>>0]=n;o=i}else{p=n+16&-16;q=o_c(p)|0;f[i>>2]=q;f[i+8>>2]=p|-2147483648;f[i+4>>2]=n;o=q}$Mc(o,528850,n)|0;b[g>>0]=0;VNc(o+n|0,g);Q_c(h,i);n=d+4|0;q=f[n>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){S_c(q,h);f[n>>2]=(f[n>>2]|0)+24}else T_c(d,h);a_c(h);r_c(i);if((m|0)==(c|0)){q=f[n>>2]|0;p=q+-24|0;r=q;while(1){if((r|0)==(p|0)){s=a;break a}q=r+-24|0;f[n>>2]=q;a_c(q);r=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){r=a+3|0;while(1){if((r|0)==(c|0)){t=c;break}if(((b[r>>0]|0)+-48|0)>>>0>=10){t=r;break}r=r+1|0}R$c((f[n>>2]|0)+-24|0,m,t);v=t}else v=m;S$c((f[n>>2]|0)+-24|0,39);if((v|0)!=(c|0)?(b[v>>0]|0)==95:0){s=v+1|0;break a}r=f[n>>2]|0;p=r+-24|0;q=r;while(1){if((q|0)==(p|0)){s=a;break a}r=q+-24|0;f[n>>2]=r;a_c(r);q=f[n>>2]|0}break}case 108:break;default:{s=a;break a}}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;n=UNc(528859)|0;if(n>>>0>4294967279)jYc(j);if(n>>>0<11){b[j+11>>0]=n;w=j}else{q=n+16&-16;p=o_c(q)|0;f[j>>2]=p;f[j+8>>2]=q|-2147483648;f[j+4>>2]=n;w=p}$Mc(w,528859,n)|0;b[g>>0]=0;VNc(w+n|0,g);Q_c(h,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){S_c(p,h);f[n>>2]=(f[n>>2]|0)+24}else T_c(d,h);a_c(h);r_c(j);do if((b[m>>0]|0)!=118){p=v_c(m,c,d)|0;if((p|0)==(m|0)){q=f[n>>2]|0;r=q+-24|0;x=q;while(1){if((x|0)==(r|0)){s=a;break a}q=x+-24|0;f[n>>2]=q;a_c(q);x=f[n>>2]|0}}x=f[n>>2]|0;if(((x-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}N_c(h,x+-24|0);x=f[n>>2]|0;r=x+-24|0;q=x;while(1){if((q|0)==(r|0))break;y=q+-24|0;f[n>>2]=y;a_c(y);q=f[n>>2]|0}q=h+11|0;r=b[q>>0]|0;y=r<<24>>24<0;z=h+4|0;d_c(x+-48|0,y?f[h>>2]|0:h,y?f[z>>2]|0:r&255)|0;r=p;while(1){y=v_c(r,c,d)|0;if((y|0)==(r|0)){A=60;break}B=f[n>>2]|0;if(((B-(f[d>>2]|0)|0)/24|0)>>>0<2){A=85;break}N_c(k,B+-24|0);if((b[q>>0]|0)<0){B=f[h>>2]|0;b[g>>0]=0;VNc(B,g);f[z>>2]=0}else{b[g>>0]=0;VNc(h,g);b[q>>0]=0}__c(h);f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];B=0;while(1){if((B|0)==3)break;f[k+(B<<2)>>2]=0;B=B+1|0}r_c(k);B=f[n>>2]|0;C=B+-24|0;D=B;while(1){if((D|0)==(C|0))break;E=D+-24|0;f[n>>2]=E;a_c(E);D=f[n>>2]|0}D=b[q>>0]|0;if(!((D<<24>>24<0?f[z>>2]|0:D&255)|0)){r=y;continue}z_c(B+-48|0,528271)|0;D=b[q>>0]|0;C=D<<24>>24<0;d_c((f[n>>2]|0)+-24|0,C?f[h>>2]|0:h,C?f[z>>2]|0:D&255)|0;r=y}if((A|0)==60){z_c((f[n>>2]|0)+-24|0,528047)|0;r_c(h);F=r;break}else if((A|0)==85){r_c(h);s=a;break a}}else{S$c((f[n>>2]|0)+-24|0,41);F=a+3|0}while(0);if((F|0)!=(c|0)?(b[F>>0]|0)==69:0){m=F+1|0;if((m|0)==(c|0)){z=f[n>>2]|0;q=z+-24|0;p=z;while(1){if((p|0)==(q|0)){s=a;break a}z=p+-24|0;f[n>>2]=z;a_c(z);p=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){p=F+2|0;while(1){if((p|0)==(c|0)){G=c;break}if(((b[p>>0]|0)+-48|0)>>>0>=10){G=p;break}p=p+1|0}p=(f[n>>2]|0)+-24|0;if((b[p+11>>0]|0)<0)H=f[p>>2]|0;else H=p;f[l>>2]=H+7;f[g>>2]=f[l>>2];T$c(p,g,m,G)|0;I=G}else I=m;if((I|0)!=(c|0)?(b[I>>0]|0)==95:0){s=I+1|0;break}p=f[n>>2]|0;q=p+-24|0;z=p;while(1){if((z|0)==(q|0)){s=a;break a}p=z+-24|0;f[n>>2]=p;a_c(p);z=f[n>>2]|0}}z=f[n>>2]|0;q=z+-24|0;m=z;while(1){if((m|0)==(q|0)){s=a;break a}z=m+-24|0;f[n>>2]=z;a_c(z);m=f[n>>2]|0}}else s=a;while(0);u=e;return s|0}function J$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1){h=a+2|0;i=a+1|0;do switch(b[a>>0]|0){case 97:{switch(b[i>>0]|0){case 97:{K$c(g,528349);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 110:case 100:{L$c(g,528360);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 78:{K$c(g,528370);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 83:{L$c(g,528381);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 99:{switch(b[i>>0]|0){case 108:{K$c(g,528391);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 109:{L$c(g,528402);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 111:{L$c(g,528412);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[j>>2]=(f[j>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 118:{j=d+63|0;k=b[j>>0]|0;b[j>>0]=0;m=v_c(h,c,d)|0;b[j>>0]=k;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}y_c(k+-24|0,0,528422)|0;b[d+60>>0]=1;l=m;break a;break}default:{l=a;break a}}break}case 100:{switch(b[i>>0]|0){case 97:{M$c(g,528432);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 101:{L$c(g,528450);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 108:{N$c(g);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 118:{L$c(g,528460);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 86:{K$c(g,528470);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 101:{switch(b[i>>0]|0){case 111:{L$c(g,528481);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 79:{K$c(g,528491);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 113:{K$c(g,528502);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 103:{switch(b[i>>0]|0){case 101:{K$c(g,528513);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 116:{L$c(g,528524);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 105:{if((b[i>>0]|0)!=120){l=a;break a}K$c(g,528534);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 108:{switch(b[i>>0]|0){case 101:{K$c(g,528545);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 105:{m=O_c(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}y_c(k+-24|0,0,528556)|0;l=m;break a;break}case 115:{K$c(g,528568);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 83:{O$c(g,528579);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 116:{L$c(g,528591);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 109:{switch(b[i>>0]|0){case 105:{L$c(g,528601);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 73:{K$c(g,528611);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 108:{L$c(g,528450);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 76:{K$c(g,528622);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 109:{K$c(g,528633);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 110:{switch(b[i>>0]|0){case 97:{P$c(g,528644);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 101:{K$c(g,528659);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 103:{L$c(g,528601);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 116:{L$c(g,528670);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 119:{Q$c(g,528680);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 111:{switch(b[i>>0]|0){case 111:{K$c(g,528693);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 114:{L$c(g,528704);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 82:{K$c(g,528714);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 112:{switch(b[i>>0]|0){case 109:{O$c(g,528725);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 108:{L$c(g,528737);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 76:{K$c(g,528747);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 112:{K$c(g,528758);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 115:{L$c(g,528737);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 116:{K$c(g,528769);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 113:{if((b[i>>0]|0)!=117){l=a;break a}L$c(g,528780);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 114:{switch(b[i>>0]|0){case 109:{L$c(g,528790);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 77:{K$c(g,528800);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 115:{K$c(g,528811);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}case 83:{O$c(g,528822);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){S_c(k,g);f[m>>2]=(f[m>>2]|0)+24}else T_c(d,g);a_c(g);l=h;break a;break}default:{l=a;break a}}break}case 118:{if(((b[i>>0]|0)+-48|0)>>>0>=10){l=a;break a}m=O_c(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}y_c(k+-24|0,0,528422)|0;l=m;break a;break}default:{l=a;break a}}while(0)}else l=a;while(0);u=e;return l|0}function K$c(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=10;$Mc(a,c,10)|0;b[e>>0]=0;VNc(a+10|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function L$c(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=9;$Mc(a,c,9)|0;b[e>>0]=0;VNc(a+9|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function M$c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=o_c(32)|0;f[a>>2]=g;f[a+8>>2]=-2147483616;f[a+4>>2]=17;$Mc(g,c,17)|0;b[e>>0]=0;VNc(g+17|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function N$c(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=o_c(16)|0;f[a>>2]=e;f[a+8>>2]=-2147483632;f[a+4>>2]=15;$Mc(e,528834,15)|0;b[d>>0]=0;VNc(e+15|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function O$c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=o_c(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=11;$Mc(g,c,11)|0;b[e>>0]=0;VNc(g+11|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function P$c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=o_c(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=14;$Mc(g,c,14)|0;b[e>>0]=0;VNc(g+14|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function Q$c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=o_c(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=12;$Mc(g,c,12)|0;b[e>>0]=0;VNc(g+12|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function R$c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=c;h=e+12|0;i=e;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[a+8>>2]&2147483647)+-1|0}else{m=k&255;n=10}o=d-g|0;do if(o|0){if(l){p=f[a>>2]|0;q=p;r=f[a+4>>2]|0;s=p}else{q=a;r=k&255;s=a}if(XTc(c,s,q+r|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(o>>>0>4294967279)jYc(i);if(o>>>0<11){b[i+11>>0]=o;t=i}else{p=o+16&-16;v=o_c(p)|0;f[i>>2]=v;f[i+8>>2]=p|-2147483648;f[i+4>>2]=o;t=v}v=c;p=t;while(1){if((v|0)==(d|0))break;VNc(p,v);v=v+1|0;p=p+1|0}b[h>>0]=0;VNc(t+o|0,h);p=b[i+11>>0]|0;v=p<<24>>24<0;d_c(a,v?f[i>>2]|0:i,v?f[i+4>>2]|0:p&255)|0;r_c(i);break}p=m+o|0;if((n-m|0)>>>0<o>>>0)U$c(a,n,p-n|0,m,m,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;v=d+(m-g)|0;x=w+m|0;y=c;while(1){if((y|0)==(d|0))break;VNc(x,y);x=x+1|0;y=y+1|0}b[h>>0]=0;VNc(w+v|0,h);if((b[j>>0]|0)<0){f[a+4>>2]=p;break}else{b[j>>0]=p;break}}while(0);u=e;return}function S$c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=10}if((j|0)==(k|0)){U$c(a,k,1,k,k,0);h=k+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=j+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+j|0;VNc(m,e);b[g>>0]=0;VNc(m+1|0,g);u=d;return}function T$c(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+32|0;h=g+16|0;i=g;j=g+12|0;k=a+11|0;l=b[k>>0]|0;m=l<<24>>24<0;if(m)n=f[a>>2]|0;else n=a;o=f[c>>2]|0;c=o-n|0;n=e-d|0;do if(!n){p=l;q=35}else{if(m){r=f[a>>2]|0;s=r;t=f[a+4>>2]|0;v=r}else{s=a;t=l&255;v=a}if(XTc(d,v,s+t|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(n>>>0>4294967279)jYc(i);if(n>>>0<11){b[i+11>>0]=n;w=i}else{r=n+16&-16;x=o_c(r)|0;f[i>>2]=x;f[i+8>>2]=r|-2147483648;f[i+4>>2]=n;w=x}x=d;r=w;while(1){if((x|0)==(e|0))break;VNc(r,x);x=x+1|0;r=r+1|0}b[h>>0]=0;VNc(w+n|0,h);f[j>>2]=o;r=b[i+11>>0]|0;x=r<<24>>24<0;y=x?f[i>>2]|0:i;z=y+(x?f[i+4>>2]|0:r&255)|0;f[h>>2]=f[j>>2];r=T$c(a,h,y,z)|0;r_c(i);A=r;break}r=b[k>>0]|0;z=r<<24>>24<0;if(z){B=f[a+4>>2]|0;C=(f[a+8>>2]&2147483647)+-1|0}else{B=r&255;C=10}r=B+n|0;if((C-B|0)>>>0>=n>>>0){if(z)D=f[a>>2]|0;else D=a;z=B-c|0;if(!z)E=D;else{y=D+c|0;qYc(y+n|0,y,z)|0;E=D}}else{U$c(a,C,r-C|0,B,c,n);E=f[a>>2]|0}if((b[k>>0]|0)<0)f[a+4>>2]=r;else b[k>>0]=r;b[h>>0]=0;VNc(E+r|0,h);r=d;z=E+c|0;while(1){if((r|0)==(e|0))break;VNc(z,r);r=r+1|0;z=z+1|0}p=b[k>>0]|0;q=35}while(0);if((q|0)==35){if(p<<24>>24<0)F=f[a>>2]|0;else F=a;A=F+c|0}u=g;return A|0}function U$c(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;if((-17-c|0)>>>0<d>>>0)jYc(a);if((b[a+11>>0]|0)<0)i=f[a>>2]|0;else i=a;if(c>>>0<2147483623){j=d+c|0;d=c<<1;k=j>>>0<d>>>0?d:j;l=k>>>0<11?11:k+16&-16}else l=-17;k=o_c(l)|0;if(g|0)$Mc(k,i,g)|0;j=e-g|0;if(j|0)$Mc(k+g+h|0,i+g|0,j)|0;if((c|0)!=10)p_c(i);f[a>>2]=k;f[a+8>>2]=l|-2147483648;return}
function yV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0;d=u;u=u+144|0;e=d+88|0;g=d;h=d+32|0;if((oS(a,-1)|0)>=3){i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=14;j=i;k=235109;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+14>>0]=0;vM(-215,e,235124,234941,189)}do if((eS(a)|0)==65536){i=f[a+4>>2]|0;f[e>>2]=f[i>>2];k=e+4|0;j=i+4|0;f[k>>2]=f[j>>2];l=e+8|0;f[l>>2]=f[i+8>>2];m=e+12|0;f[m>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];o=f[i+36>>2]|0;f[e+36>>2]=o;f[e+40>>2]=l;q=e+48|0;r=e+44|0;f[r>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(o|0){q=o+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[j>>2]|0)<3){j=f[i+44>>2]|0;q=f[r>>2]|0;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];s=m;t=e;v=l;break}else{f[k>>2]=0;U$(e,i);s=m;t=e;v=l;break}}else{bS(e,a,-1);s=e+12|0;t=e;v=e+8|0}while(0);a=f[v>>2]|0;v=f[s>>2]|0;a:do switch(f[t>>2]&4095){case 5:{s=f[e+16>>2]|0;w=+p[c>>3];l=(f[e+48>>2]|0)>>>2;if((a|0)>0){if((v|0)<=0){m=0;i=s;while(1){if((m|0)<(v|0))n[i+(m<<2)>>2]=w;m=m+1|0;if((m|0)==(a|0))break a;else i=i+(l<<2)|0}}i=v<<2;m=0;k=s;while(1){g1c(s+((Y(l,m)|0)<<2)|0,0,i|0)|0;if((m|0)<(v|0))n[k+(m<<2)>>2]=w;m=m+1|0;if((m|0)==(a|0))break;else k=k+(l<<2)|0}}break}case 6:{w=+p[c>>3];l=(f[e+48>>2]|0)>>>3;if((a|0)>0&(v|0)>0){k=0;m=f[e+16>>2]|0;while(1){i=0;do{p[m+(i<<3)>>3]=(i|0)==(k|0)?w:0.0;i=i+1|0}while((i|0)!=(v|0));k=k+1|0;if((k|0)==(a|0))break;else m=m+(l<<3)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;lR(e,g)|0;b0(h,e,0);lR(h,c)|0;l=h+36|0;m=f[l>>2]|0;if(m|0?(k=m+12|0,m=f[k>>2]|0,f[k>>2]=m+-1,(m|0)==1):0)V$(h);f[l>>2]=0;l=h+16|0;m=h+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[h+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[m>>2]|0))}m=f[h+44>>2]|0;if((m|0)!=(h+48|0))wL(m)}}while(0);h=e+36|0;c=f[h>>2]|0;if(c|0?(g=c+12|0,c=f[g>>2]|0,f[g>>2]=c+-1,(c|0)==1):0)V$(e);f[h>>2]=0;h=e+16|0;c=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[c>>2]|0)>0){h=f[e+40>>2]|0;g=0;do{f[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[c>>2]|0))}c=f[e+44>>2]|0;if((c|0)==(e+48|0)){u=d;return}wL(c);u=d;return}function zV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0.0;d=u;u=u+128|0;e=d+72|0;g=d+56|0;h=d;do if((eS(c)|0)==65536){i=f[c+4>>2]|0;f[e>>2]=f[i>>2];j=e+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=l;l=e+48|0;o=e+44|0;f[o>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];q=j;break}else{f[j>>2]=0;U$(e,i);q=j;break}}else{bS(e,c,-1);q=e+4|0}while(0);if((f[q>>2]|0)>=3){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=$Xc(16)|0;f[g>>2]=c;f[g+8>>2]=-2147483632;f[g+4>>2]=11;j=c;i=241710;k=j+11|0;do{b[j>>0]=b[i>>0]|0;j=j+1|0;i=i+1|0}while((j|0)<(k|0));b[c+11>>0]=0;vM(-215,g,235136,234941,237)}c=f[e+12>>2]|0;i=f[e+8>>2]|0;j=(c|0)<(i|0)?c:i;switch(f[e>>2]&4095){case 5:{i=f[e+16>>2]|0;c=((f[e+48>>2]|0)>>>2)+1|0;if((j|0)>0){k=0;r=0.0;while(1){l=i+((Y(k,c)|0)<<2)|0;s=r+ +n[l>>2];k=k+1|0;if((k|0)>=(j|0)){t=s;break}else r=s}}else t=0.0;p[a>>3]=t;k=a+8|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;break}case 6:{k=f[e+16>>2]|0;c=((f[e+48>>2]|0)>>>3)+1|0;if((j|0)>0){t=0.0;i=0;while(1){l=k+((Y(i,c)|0)<<3)|0;r=t+ +p[l>>3];i=i+1|0;if((i|0)>=(j|0)){v=r;break}else t=r}}else v=0.0;p[a>>3]=v;j=a+8|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;break}default:{b0(h,e,0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=h;iV(a,g);g=h+36|0;a=f[g>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;a=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[a>>2]|0)>0){g=f[h+40>>2]|0;j=0;do{f[g+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))wL(a)}}a=e+36|0;h=f[a>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)V$(e);f[a>>2]=0;a=e+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){a=f[e+40>>2]|0;h=0;do{f[a+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)==(e+48|0)){u=d;return}wL(q);u=d;return}function AV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+144|0;e=d+80|0;g=d+24|0;h=d;i=d+16|0;j=dS(a,-1)|0;k=Y(675553809>>>(j<<2&28)&15,(j>>>3&511)+1|0)|0;if(!((oS(a,-1)|0)<3&k>>>0<33)){j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=29;l=j;m=235142;n=l+29|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+29>>0]=0;vM(-215,e,235172,234941,503)}do if((eS(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];o=e+4|0;p=j+4|0;f[o>>2]=f[p>>2];q=e+8|0;f[q>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];r=e+16|0;f[r>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];s=f[j+36>>2]|0;f[e+36>>2]=s;f[e+40>>2]=q;q=e+48|0;t=e+44|0;f[t>>2]=q;f[q>>2]=0;f[e+52>>2]=0;if(s|0){q=s+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[j+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=r;break}else{f[o>>2]=0;U$(e,j);v=r;break}}else{bS(e,a,-1);v=e+16|0}while(0);if(f[v>>2]|0){a=f[e+4>>2]|0;if((a|0)<3)w=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{r=f[e+40>>2]|0;j=0;o=1;while(1){p=Y(f[r+(j<<2)>>2]|0,o)|0;j=j+1|0;if((j|0)==(a|0)){w=p;break}else o=p}}if(!((a|0)==0|(w|0)==0)){w=e+12|0;a=e+8|0;ZS(c,f[w>>2]|0,f[a>>2]|0,f[e>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){o=f[c+4>>2]|0;f[g>>2]=f[o>>2];j=g+4|0;r=o+4|0;f[j>>2]=f[r>>2];p=g+8|0;f[p>>2]=f[o+8>>2];q=g+12|0;f[q>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[g+36>>2]=t;f[g+40>>2]=p;p=g+48|0;s=g+44|0;f[s>>2]=p;f[p>>2]=0;f[g+52>>2]=0;if(t|0){p=t+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[r>>2]|0)<3){r=f[o+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[r>>2];f[p+4>>2]=f[r+4>>2];x=q;break}else{f[j>>2]=0;U$(g,o);x=q;break}}else{bS(g,c,-1);x=g+12|0}while(0);q=f[a>>2]|0;do if((q|0)==(f[x>>2]|0)?(a=f[w>>2]|0,(a|0)==(f[g+8>>2]|0)):0){o=f[g+16>>2]|0;j=f[v>>2]|0;if((o|0)!=(j|0)){r=f[37472+(k<<2)>>2]|0;if(!r){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=9;l=h;m=264557;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+9>>0]=0;vM(-215,h,235172,234941,538)}else{p=f[e+48>>2]|0;s=f[g+48>>2]|0;t=f[e+40>>2]|0;y=f[t>>2]|0;f[i>>2]=f[t+4>>2];f[i+4>>2]=y;gi[r&255](j,p,o,s,i);break}}s=f[37340+(k<<2)>>2]|0;if(!s){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=9;l=h;m=264557;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+9>>0]=0;vM(-215,h,235172,234941,531)}if((q|0)==(a|0)){Ti[s&511](o,f[g+48>>2]|0,q);break}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=20;l=j;m=472768;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+20>>0]=0;vM(-215,h,235172,234941,532)}}else z=26;while(0);do if((z|0)==26){k=f[e+40>>2]|0;i=f[g+40>>2]|0;if(!((f[k>>2]|0)==(f[i>>2]|0)?(f[k+4>>2]|0)==(f[i+4>>2]|0):0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;A=$Xc(64)|0;f[h>>2]=A;B=h+8|0;f[B>>2]=-2147483584;C=h+4|0;f[C>>2]=60;l=A;m=235182;n=l+60|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));D=A+60|0;b[D>>0]=0;vM(-215,h,235172,234941,521)}if((f[w>>2]|0)==1|(q|0)==1){j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;jR(e,h);break}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;A=$Xc(64)|0;f[h>>2]=A;B=h+8|0;f[B>>2]=-2147483584;C=h+4|0;f[C>>2]=60;l=A;m=235182;n=l+60|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));D=A+60|0;b[D>>0]=0;vM(-215,h,235172,234941,521)}}while(0);h=g+36|0;D=f[h>>2]|0;if(D|0?(A=D+12|0,D=f[A>>2]|0,f[A>>2]=D+-1,(D|0)==1):0)V$(g);f[h>>2]=0;h=g+16|0;D=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[D>>2]|0)>0){h=f[g+40>>2]|0;A=0;do{f[h+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[D>>2]|0))}D=f[g+44>>2]|0;if((D|0)!=(g+48|0))wL(D)}else z=16}else z=16;if((z|0)==16)vS(c);c=e+36|0;z=f[c>>2]|0;if(z|0?(D=z+12|0,z=f[D>>2]|0,f[D>>2]=z+-1,(z|0)==1):0)V$(e);f[c>>2]=0;c=e+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[c>>2]|0)>0){v=f[e+40>>2]|0;z=0;do{f[v+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=f[e+44>>2]|0;if((c|0)==(e+48|0)){u=d;return}wL(c);u=d;return}function BV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+l|0;r=0;do{s=q+(Y(r,c)|0)|0;b[m+r>>0]=b[s>>0]|0;b[n+r>>0]=b[s+1>>0]|0;b[o+r>>0]=b[s+2>>0]|0;b[p+r>>0]=b[s+3>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;s=a+p|0;t=0;do{u=s+(Y(t,c)|0)|0;v=t|1;w=s+(Y(v,c)|0)|0;x=t|2;y=s+(Y(x,c)|0)|0;z=t|3;A=s+(Y(z,c)|0)|0;b[o+t>>0]=b[u>>0]|0;b[o+v>>0]=b[w>>0]|0;b[o+x>>0]=b[y>>0]|0;b[o+z>>0]=b[A>>0]|0;b[n+t>>0]=b[u+1>>0]|0;b[n+v>>0]=b[w+1>>0]|0;b[n+x>>0]=b[y+1>>0]|0;b[n+z>>0]=b[A+1>>0]|0;b[m+t>>0]=b[u+2>>0]|0;b[m+v>>0]=b[w+2>>0]|0;b[m+x>>0]=b[y+2>>0]|0;b[m+z>>0]=b[A+2>>0]|0;b[q+t>>0]=b[u+3>>0]|0;b[q+v>>0]=b[w+3>>0]|0;b[q+x>>0]=b[y+3>>0]|0;b[q+z>>0]=b[A+3>>0]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,c)|0)|0;b[o+t>>0]=b[A>>0]|0;b[n+t>>0]=b[A+1>>0]|0;b[m+t>>0]=b[A+2>>0]|0;b[q+t>>0]=b[A+3>>0]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=d+(Y(B,e)|0)|0;l=a+B|0;r=0;do{k=l+(Y(r,c)|0)|0;b[p+r>>0]=b[k>>0]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+r|0;l=0;do{k=p+(Y(l,c)|0)|0;t=l|1;q=p+(Y(t,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;s=p+(Y(o,c)|0)|0;b[j+l>>0]=b[k>>0]|0;b[j+t>>0]=b[q>>0]|0;b[j+m>>0]=b[n>>0]|0;b[j+o>>0]=b[s>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(C,e)|0)|0;l=a+C|0;j=0;do{p=l+(Y(j,c)|0)|0;s=j|1;o=l+(Y(s,c)|0)|0;n=j|2;m=l+(Y(n,c)|0)|0;q=j|3;t=l+(Y(q,c)|0)|0;b[r+j>>0]=b[p>>0]|0;b[r+s>>0]=b[o>>0]|0;b[r+n>>0]=b[m>>0]|0;b[r+q>>0]=b[t>>0]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,c)|0)|0;b[r+D>>0]=b[j>>0]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}function CV(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l<<1)|0;r=0;do{s=q+(Y(r,b)|0)|0;d[m+(r<<1)>>1]=d[s>>1]|0;d[n+(r<<1)>>1]=d[s+2>>1]|0;d[o+(r<<1)>>1]=d[s+4>>1]|0;d[p+(r<<1)>>1]=d[s+6>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;s=a+(p<<1)|0;t=0;do{u=s+(Y(t,b)|0)|0;v=t|1;w=s+(Y(v,b)|0)|0;x=t|2;y=s+(Y(x,b)|0)|0;z=t|3;A=s+(Y(z,b)|0)|0;d[o+(t<<1)>>1]=d[u>>1]|0;d[o+(v<<1)>>1]=d[w>>1]|0;d[o+(x<<1)>>1]=d[y>>1]|0;d[o+(z<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[u+2>>1]|0;d[n+(v<<1)>>1]=d[w+2>>1]|0;d[n+(x<<1)>>1]=d[y+2>>1]|0;d[n+(z<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[u+4>>1]|0;d[m+(v<<1)>>1]=d[w+4>>1]|0;d[m+(x<<1)>>1]=d[y+4>>1]|0;d[m+(z<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[u+6>>1]|0;d[q+(v<<1)>>1]=d[w+6>>1]|0;d[q+(x<<1)>>1]=d[y+6>>1]|0;d[q+(z<<1)>>1]=d[A+6>>1]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,b)|0)|0;d[o+(t<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[A+6>>1]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=c+(Y(B,e)|0)|0;l=a+(B<<1)|0;r=0;do{k=l+(Y(r,b)|0)|0;d[p+(r<<1)>>1]=d[k>>1]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r<<1)|0;l=0;do{k=p+(Y(l,b)|0)|0;t=l|1;q=p+(Y(t,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;s=p+(Y(o,b)|0)|0;d[j+(l<<1)>>1]=d[k>>1]|0;d[j+(t<<1)>>1]=d[q>>1]|0;d[j+(m<<1)>>1]=d[n>>1]|0;d[j+(o<<1)>>1]=d[s>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(C,e)|0)|0;l=a+(C<<1)|0;j=0;do{p=l+(Y(j,b)|0)|0;s=j|1;o=l+(Y(s,b)|0)|0;n=j|2;m=l+(Y(n,b)|0)|0;q=j|3;t=l+(Y(q,b)|0)|0;d[r+(j<<1)>>1]=d[p>>1]|0;d[r+(s<<1)>>1]=d[o>>1]|0;d[r+(n<<1)>>1]=d[m>>1]|0;d[r+(q<<1)>>1]=d[t>>1]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,b)|0)|0;d[r+(D<<1)>>1]=d[j>>1]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}function DV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+(l*3|0)|0;r=0;do{s=q+(Y(r,c)|0)|0;t=m+(r*3|0)|0;b[t>>0]=b[s>>0]|0;b[t+1>>0]=b[s+1>>0]|0;b[t+2>>0]=b[s+2>>0]|0;t=s+3|0;u=n+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+6|0;u=o+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+9|0;s=p+(r*3|0)|0;b[s>>0]=b[t>>0]|0;b[s+1>>0]=b[t+1>>0]|0;b[s+2>>0]=b[t+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;t=a+(p*3|0)|0;s=0;do{u=t+(Y(s,c)|0)|0;v=s|1;w=t+(Y(v,c)|0)|0;x=s|2;y=t+(Y(x,c)|0)|0;z=s|3;A=t+(Y(z,c)|0)|0;B=o+(s*3|0)|0;b[B>>0]=b[u>>0]|0;b[B+1>>0]=b[u+1>>0]|0;b[B+2>>0]=b[u+2>>0]|0;B=o+(v*3|0)|0;b[B>>0]=b[w>>0]|0;b[B+1>>0]=b[w+1>>0]|0;b[B+2>>0]=b[w+2>>0]|0;B=o+(x*3|0)|0;b[B>>0]=b[y>>0]|0;b[B+1>>0]=b[y+1>>0]|0;b[B+2>>0]=b[y+2>>0]|0;B=o+(z*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;B=u+3|0;C=n+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+3|0;C=n+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+3|0;C=n+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+3|0;C=n+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+6|0;C=m+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+6|0;C=m+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+6|0;C=m+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+6|0;C=m+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+9|0;u=q+(s*3|0)|0;b[u>>0]=b[B>>0]|0;b[u+1>>0]=b[B+1>>0]|0;b[u+2>>0]=b[B+2>>0]|0;B=w+9|0;w=q+(v*3|0)|0;b[w>>0]=b[B>>0]|0;b[w+1>>0]=b[B+1>>0]|0;b[w+2>>0]=b[B+2>>0]|0;B=y+9|0;y=q+(x*3|0)|0;b[y>>0]=b[B>>0]|0;b[y+1>>0]=b[B+1>>0]|0;b[y+2>>0]=b[B+2>>0]|0;B=A+9|0;A=q+(z*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,c)|0)|0;A=o+(s*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;A=B+3|0;z=n+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+6|0;z=m+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+9|0;B=q+(s*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=d+(Y(D,e)|0)|0;l=a+(D*3|0)|0;r=0;do{k=l+(Y(r,c)|0)|0;s=p+(r*3|0)|0;b[s>>0]=b[k>>0]|0;b[s+1>>0]=b[k+1>>0]|0;b[s+2>>0]=b[k+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+(r*3|0)|0;l=0;do{k=p+(Y(l,c)|0)|0;s=l|1;q=p+(Y(s,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;t=p+(Y(o,c)|0)|0;A=j+(l*3|0)|0;b[A>>0]=b[k>>0]|0;b[A+1>>0]=b[k+1>>0]|0;b[A+2>>0]=b[k+2>>0]|0;k=j+(s*3|0)|0;b[k>>0]=b[q>>0]|0;b[k+1>>0]=b[q+1>>0]|0;b[k+2>>0]=b[q+2>>0]|0;q=j+(m*3|0)|0;b[q>>0]=b[n>>0]|0;b[q+1>>0]=b[n+1>>0]|0;b[q+2>>0]=b[n+2>>0]|0;n=j+(o*3|0)|0;b[n>>0]=b[t>>0]|0;b[n+1>>0]=b[t+1>>0]|0;b[n+2>>0]=b[t+2>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(E,e)|0)|0;l=a+(E*3|0)|0;j=0;do{p=l+(Y(j,c)|0)|0;t=j|1;n=l+(Y(t,c)|0)|0;o=j|2;q=l+(Y(o,c)|0)|0;m=j|3;k=l+(Y(m,c)|0)|0;s=r+(j*3|0)|0;b[s>>0]=b[p>>0]|0;b[s+1>>0]=b[p+1>>0]|0;b[s+2>>0]=b[p+2>>0]|0;p=r+(t*3|0)|0;b[p>>0]=b[n>>0]|0;b[p+1>>0]=b[n+1>>0]|0;b[p+2>>0]=b[n+2>>0]|0;n=r+(o*3|0)|0;b[n>>0]=b[q>>0]|0;b[n+1>>0]=b[q+1>>0]|0;b[n+2>>0]=b[q+2>>0]|0;q=r+(m*3|0)|0;b[q>>0]=b[k>>0]|0;b[q+1>>0]=b[k+1>>0]|0;b[q+2>>0]=b[k+2>>0]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,c)|0)|0;k=r+(F*3|0)|0;b[k>>0]=b[j>>0]|0;b[k+1>>0]=b[j+1>>0]|0;b[k+2>>0]=b[j+2>>0]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function EV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<2)|0;q=0;do{r=p+(Y(q,b)|0)|0;f[l+(q<<2)>>2]=f[r>>2];f[m+(q<<2)>>2]=f[r+4>>2];f[n+(q<<2)>>2]=f[r+8>>2];f[o+(q<<2)>>2]=f[r+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<2)|0;s=0;do{t=r+(Y(s,b)|0)|0;u=s|1;v=r+(Y(u,b)|0)|0;w=s|2;x=r+(Y(w,b)|0)|0;y=s|3;z=r+(Y(y,b)|0)|0;f[n+(s<<2)>>2]=f[t>>2];f[n+(u<<2)>>2]=f[v>>2];f[n+(w<<2)>>2]=f[x>>2];f[n+(y<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[t+4>>2];f[m+(u<<2)>>2]=f[v+4>>2];f[m+(w<<2)>>2]=f[x+4>>2];f[m+(y<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[t+8>>2];f[l+(u<<2)>>2]=f[v+8>>2];f[l+(w<<2)>>2]=f[x+8>>2];f[l+(y<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[t+12>>2];f[p+(u<<2)>>2]=f[v+12>>2];f[p+(w<<2)>>2]=f[x+12>>2];f[p+(y<<2)>>2]=f[z+12>>2];s=s+4|0}while((s|0)<=(j|0));if(q){s=k;do{z=r+(Y(s,b)|0)|0;f[n+(s<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[z+12>>2];s=s+1|0}while((s|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)A=i;else return;do{o=c+(Y(A,d)|0)|0;k=a+(A<<2)|0;q=0;do{j=k+(Y(q,b)|0)|0;f[o+(q<<2)>>2]=f[j>>2];q=q+1|0}while((q|0)!=(h|0));A=A+1|0}while((A|0)!=(g|0));return}A=h&-4;if((A|0)<(h|0))B=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<2)|0;k=0;do{j=o+(Y(k,b)|0)|0;s=k|1;p=o+(Y(s,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;r=o+(Y(n,b)|0)|0;f[i+(k<<2)>>2]=f[j>>2];f[i+(s<<2)>>2]=f[p>>2];f[i+(l<<2)>>2]=f[m>>2];f[i+(n<<2)>>2]=f[r>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(B,d)|0)|0;k=a+(B<<2)|0;i=0;do{o=k+(Y(i,b)|0)|0;r=i|1;n=k+(Y(r,b)|0)|0;m=i|2;l=k+(Y(m,b)|0)|0;p=i|3;s=k+(Y(p,b)|0)|0;f[q+(i<<2)>>2]=f[o>>2];f[q+(r<<2)>>2]=f[n>>2];f[q+(m<<2)>>2]=f[l>>2];f[q+(p<<2)>>2]=f[s>>2];i=i+4|0}while((i|0)<=(e|0));C=A;do{i=k+(Y(C,b)|0)|0;f[q+(C<<2)>>2]=f[i>>2];C=C+1|0}while((C|0)!=(h|0));B=B+1|0}while((B|0)!=(g|0));return}function FV(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l*6|0)|0;r=0;do{s=q+(Y(r,b)|0)|0;t=m+(r*6|0)|0;d[t>>1]=d[s>>1]|0;d[t+2>>1]=d[s+2>>1]|0;d[t+4>>1]=d[s+4>>1]|0;t=s+6|0;u=n+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+12|0;u=o+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+18|0;s=p+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;t=a+(p*6|0)|0;s=0;do{u=t+(Y(s,b)|0)|0;v=s|1;w=t+(Y(v,b)|0)|0;x=s|2;y=t+(Y(x,b)|0)|0;z=s|3;A=t+(Y(z,b)|0)|0;B=o+(s*6|0)|0;d[B>>1]=d[u>>1]|0;d[B+2>>1]=d[u+2>>1]|0;d[B+4>>1]=d[u+4>>1]|0;B=o+(v*6|0)|0;d[B>>1]=d[w>>1]|0;d[B+2>>1]=d[w+2>>1]|0;d[B+4>>1]=d[w+4>>1]|0;B=o+(x*6|0)|0;d[B>>1]=d[y>>1]|0;d[B+2>>1]=d[y+2>>1]|0;d[B+4>>1]=d[y+4>>1]|0;B=o+(z*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;B=u+6|0;C=n+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+6|0;C=n+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+6|0;C=n+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+6|0;C=n+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+12|0;C=m+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+12|0;C=m+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+12|0;C=m+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+12|0;C=m+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+18|0;u=q+(s*6|0)|0;d[u>>1]=d[B>>1]|0;d[u+2>>1]=d[B+2>>1]|0;d[u+4>>1]=d[B+4>>1]|0;B=w+18|0;w=q+(v*6|0)|0;d[w>>1]=d[B>>1]|0;d[w+2>>1]=d[B+2>>1]|0;d[w+4>>1]=d[B+4>>1]|0;B=y+18|0;y=q+(x*6|0)|0;d[y>>1]=d[B>>1]|0;d[y+2>>1]=d[B+2>>1]|0;d[y+4>>1]=d[B+4>>1]|0;B=A+18|0;A=q+(z*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,b)|0)|0;A=o+(s*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;A=B+6|0;z=n+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+12|0;z=m+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+18|0;B=q+(s*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=c+(Y(D,e)|0)|0;l=a+(D*6|0)|0;r=0;do{k=l+(Y(r,b)|0)|0;s=p+(r*6|0)|0;d[s>>1]=d[k>>1]|0;d[s+2>>1]=d[k+2>>1]|0;d[s+4>>1]=d[k+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r*6|0)|0;l=0;do{k=p+(Y(l,b)|0)|0;s=l|1;q=p+(Y(s,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;t=p+(Y(o,b)|0)|0;A=j+(l*6|0)|0;d[A>>1]=d[k>>1]|0;d[A+2>>1]=d[k+2>>1]|0;d[A+4>>1]=d[k+4>>1]|0;k=j+(s*6|0)|0;d[k>>1]=d[q>>1]|0;d[k+2>>1]=d[q+2>>1]|0;d[k+4>>1]=d[q+4>>1]|0;q=j+(m*6|0)|0;d[q>>1]=d[n>>1]|0;d[q+2>>1]=d[n+2>>1]|0;d[q+4>>1]=d[n+4>>1]|0;n=j+(o*6|0)|0;d[n>>1]=d[t>>1]|0;d[n+2>>1]=d[t+2>>1]|0;d[n+4>>1]=d[t+4>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(E,e)|0)|0;l=a+(E*6|0)|0;j=0;do{p=l+(Y(j,b)|0)|0;t=j|1;n=l+(Y(t,b)|0)|0;o=j|2;q=l+(Y(o,b)|0)|0;m=j|3;k=l+(Y(m,b)|0)|0;s=r+(j*6|0)|0;d[s>>1]=d[p>>1]|0;d[s+2>>1]=d[p+2>>1]|0;d[s+4>>1]=d[p+4>>1]|0;p=r+(t*6|0)|0;d[p>>1]=d[n>>1]|0;d[p+2>>1]=d[n+2>>1]|0;d[p+4>>1]=d[n+4>>1]|0;n=r+(o*6|0)|0;d[n>>1]=d[q>>1]|0;d[n+2>>1]=d[q+2>>1]|0;d[n+4>>1]=d[q+4>>1]|0;q=r+(m*6|0)|0;d[q>>1]=d[k>>1]|0;d[q+2>>1]=d[k+2>>1]|0;d[q+4>>1]=d[k+4>>1]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,b)|0)|0;k=r+(F*6|0)|0;d[k>>1]=d[j>>1]|0;d[k+2>>1]=d[j+2>>1]|0;d[k+4>>1]=d[j+4>>1]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function GV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<3)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=r;t=f[s+4>>2]|0;u=l+(q<<3)|0;f[u>>2]=f[s>>2];f[u+4>>2]=t;t=r+8|0;u=f[t+4>>2]|0;s=m+(q<<3)|0;f[s>>2]=f[t>>2];f[s+4>>2]=u;u=r+16|0;s=f[u+4>>2]|0;t=n+(q<<3)|0;f[t>>2]=f[u>>2];f[t+4>>2]=s;s=r+24|0;r=f[s+4>>2]|0;t=o+(q<<3)|0;f[t>>2]=f[s>>2];f[t+4>>2]=r;q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<3)|0;t=0;do{s=r+(Y(t,b)|0)|0;u=t|1;v=r+(Y(u,b)|0)|0;w=t|2;x=r+(Y(w,b)|0)|0;y=t|3;z=r+(Y(y,b)|0)|0;A=s;B=f[A+4>>2]|0;C=n+(t<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=v;C=f[B+4>>2]|0;A=n+(u<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=x;A=f[C+4>>2]|0;B=n+(w<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=z;B=f[A+4>>2]|0;C=n+(y<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=s+8|0;C=f[B+4>>2]|0;A=m+(t<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=v+8|0;A=f[C+4>>2]|0;B=m+(u<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=x+8|0;B=f[A+4>>2]|0;C=m+(w<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=z+8|0;C=f[B+4>>2]|0;A=m+(y<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=s+16|0;A=f[C+4>>2]|0;B=l+(t<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=v+16|0;B=f[A+4>>2]|0;C=l+(u<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=x+16|0;C=f[B+4>>2]|0;A=l+(w<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=z+16|0;A=f[C+4>>2]|0;B=l+(y<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=s+24|0;s=f[A+4>>2]|0;B=p+(t<<3)|0;f[B>>2]=f[A>>2];f[B+4>>2]=s;s=v+24|0;v=f[s+4>>2]|0;B=p+(u<<3)|0;f[B>>2]=f[s>>2];f[B+4>>2]=v;v=x+24|0;x=f[v+4>>2]|0;B=p+(w<<3)|0;f[B>>2]=f[v>>2];f[B+4>>2]=x;x=z+24|0;z=f[x+4>>2]|0;B=p+(y<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=z;t=t+4|0}while((t|0)<=(j|0));if(q){t=k;do{z=r+(Y(t,b)|0)|0;B=z;x=f[B+4>>2]|0;y=n+(t<<3)|0;f[y>>2]=f[B>>2];f[y+4>>2]=x;x=z+8|0;y=f[x+4>>2]|0;B=m+(t<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=y;y=z+16|0;B=f[y+4>>2]|0;x=l+(t<<3)|0;f[x>>2]=f[y>>2];f[x+4>>2]=B;B=z+24|0;z=f[B+4>>2]|0;x=p+(t<<3)|0;f[x>>2]=f[B>>2];f[x+4>>2]=z;t=t+1|0}while((t|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)D=i;else return;do{o=c+(Y(D,d)|0)|0;k=a+(D<<3)|0;q=0;do{j=k+(Y(q,b)|0)|0;t=f[j+4>>2]|0;p=o+(q<<3)|0;f[p>>2]=f[j>>2];f[p+4>>2]=t;q=q+1|0}while((q|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}D=h&-4;if((D|0)<(h|0))E=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<3)|0;k=0;do{t=k|1;p=o+(Y(t,b)|0)|0;j=k|2;l=o+(Y(j,b)|0)|0;m=k|3;n=o+(Y(m,b)|0)|0;r=o+(Y(k,b)|0)|0;z=f[r+4>>2]|0;x=i+(k<<3)|0;f[x>>2]=f[r>>2];f[x+4>>2]=z;z=p;p=f[z+4>>2]|0;x=i+(t<<3)|0;f[x>>2]=f[z>>2];f[x+4>>2]=p;p=l;l=f[p+4>>2]|0;x=i+(j<<3)|0;f[x>>2]=f[p>>2];f[x+4>>2]=l;l=n;n=f[l+4>>2]|0;x=i+(m<<3)|0;f[x>>2]=f[l>>2];f[x+4>>2]=n;k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(E,d)|0)|0;k=a+(E<<3)|0;i=0;do{o=i|1;n=k+(Y(o,b)|0)|0;x=i|2;l=k+(Y(x,b)|0)|0;m=i|3;p=k+(Y(m,b)|0)|0;j=k+(Y(i,b)|0)|0;z=f[j+4>>2]|0;t=q+(i<<3)|0;f[t>>2]=f[j>>2];f[t+4>>2]=z;z=n;n=f[z+4>>2]|0;t=q+(o<<3)|0;f[t>>2]=f[z>>2];f[t+4>>2]=n;n=l;l=f[n+4>>2]|0;t=q+(x<<3)|0;f[t>>2]=f[n>>2];f[t+4>>2]=l;l=p;p=f[l+4>>2]|0;t=q+(m<<3)|0;f[t>>2]=f[l>>2];f[t+4>>2]=p;i=i+4|0}while((i|0)<=(e|0));F=D;do{i=k+(Y(F,b)|0)|0;p=f[i+4>>2]|0;t=q+(F<<3)|0;f[t>>2]=f[i>>2];f[t+4>>2]=p;F=F+1|0}while((F|0)!=(h|0));E=E+1|0}while((E|0)!=(g|0));return}function HV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*12|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*12|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];s=r+12|0;t=m+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+24|0;t=n+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+36|0;r=o+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*12|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*12|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];A=n+(u*12|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];A=n+(w*12|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];A=n+(y*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];A=t+12|0;B=m+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+12|0;B=m+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+12|0;B=m+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+12|0;B=m+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+24|0;B=l+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+24|0;B=l+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+24|0;B=l+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+24|0;B=l+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+36|0;t=p+(r*12|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];A=v+36|0;v=p+(u*12|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];A=x+36|0;x=p+(w*12|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];A=z+36|0;z=p+(y*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];z=A+12|0;y=m+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+24|0;y=l+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+36|0;A=p+(r*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*12|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*12|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*12|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*12|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];j=i+(r*12|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];p=i+(l*12|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];m=i+(n*12|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*12|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*12|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];o=q+(s*12|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];m=q+(n*12|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];p=q+(l*12|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*12|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function IV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<4)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<4)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];s=r+16|0;t=m+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+32|0;t=n+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+48|0;r=o+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<4)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<4)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];A=n+(u<<4)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];A=n+(w<<4)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];A=n+(y<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];A=t+16|0;B=m+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+16|0;B=m+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+16|0;B=m+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+16|0;B=m+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+32|0;B=l+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+32|0;B=l+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+32|0;B=l+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+32|0;B=l+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+48|0;t=p+(r<<4)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];A=v+48|0;v=p+(u<<4)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];A=x+48|0;x=p+(w<<4)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];A=z+48|0;z=p+(y<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];z=A+16|0;y=m+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+32|0;y=l+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+48|0;A=p+(r<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<4)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<4)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<4)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<4)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];j=i+(r<<4)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];p=i+(l<<4)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];m=i+(n<<4)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<4)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<4)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];o=q+(s<<4)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];m=q+(n<<4)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];p=q+(l<<4)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<4)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function JV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*24|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*24|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];s=r+24|0;t=m+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+48|0;t=n+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+72|0;r=o+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*24|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*24|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];A=n+(u*24|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];A=n+(w*24|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];A=n+(y*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];A=t+24|0;B=m+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+24|0;B=m+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+24|0;B=m+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+24|0;B=m+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+48|0;B=l+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+48|0;B=l+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+48|0;B=l+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+48|0;B=l+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+72|0;t=p+(r*24|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];A=v+72|0;v=p+(u*24|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];A=x+72|0;x=p+(w*24|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];A=z+72|0;z=p+(y*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];z=A+24|0;y=m+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+48|0;y=l+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+72|0;A=p+(r*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*24|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*24|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*24|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*24|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];j=i+(r*24|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];p=i+(l*24|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];m=i+(n*24|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*24|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*24|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];o=q+(s*24|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];m=q+(n*24|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];p=q+(l*24|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*24|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function KV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<5)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<5)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];s=r+32|0;t=m+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+64|0;t=n+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+96|0;r=o+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<5)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<5)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];f[A+24>>2]=f[t+24>>2];f[A+28>>2]=f[t+28>>2];A=n+(u<<5)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];f[A+24>>2]=f[v+24>>2];f[A+28>>2]=f[v+28>>2];A=n+(w<<5)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];f[A+24>>2]=f[x+24>>2];f[A+28>>2]=f[x+28>>2];A=n+(y<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];A=t+32|0;B=m+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+32|0;B=m+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+32|0;B=m+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+32|0;B=m+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+64|0;B=l+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+64|0;B=l+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+64|0;B=l+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+64|0;B=l+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+96|0;t=p+(r<<5)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];f[t+24>>2]=f[A+24>>2];f[t+28>>2]=f[A+28>>2];A=v+96|0;v=p+(u<<5)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];f[v+24>>2]=f[A+24>>2];f[v+28>>2]=f[A+28>>2];A=x+96|0;x=p+(w<<5)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];f[x+24>>2]=f[A+24>>2];f[x+28>>2]=f[A+28>>2];A=z+96|0;z=p+(y<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];z=A+32|0;y=m+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+64|0;y=l+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+96|0;A=p+(r<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<5)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<5)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];f[r+24>>2]=f[j+24>>2];f[r+28>>2]=f[j+28>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<5)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<5)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];f[z+24>>2]=f[j+24>>2];f[z+28>>2]=f[j+28>>2];j=i+(r<<5)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];p=i+(l<<5)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];f[p+24>>2]=f[m+24>>2];f[p+28>>2]=f[m+28>>2];m=i+(n<<5)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<5)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<5)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];f[r+24>>2]=f[o+24>>2];f[r+28>>2]=f[o+28>>2];o=q+(s<<5)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];m=q+(n<<5)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];p=q+(l<<5)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];f[p+24>>2]=f[j+24>>2];f[p+28>>2]=f[j+28>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<5)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function LV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+e|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=f+h|0;j=g+(Y(h,c)|0)|0;k=b[i>>0]|0;b[i>>0]=b[j>>0]|0;b[j>>0]=k;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function MV(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e<<1)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h<<1)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;d[i>>1]=d[j>>1]|0;d[j>>1]=k;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function NV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+(e*3|0)|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=g+(Y(h,c)|0)|0;j=f+(h*3|0)|0;k=b[j>>0]|0;l=b[f+(h*3|0)+1>>0]|0;m=b[f+(h*3|0)+2>>0]|0;b[j>>0]=b[i>>0]|0;b[j+1>>0]=b[i+1>>0]|0;b[j+2>>0]=b[i+2>>0]|0;b[i>>0]=k;b[i+1>>0]=l;b[i+2>>0]=m;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function OV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<2)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<2)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function PV(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e*6|0)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h*6|0)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;l=d[f+(h*6|0)+2>>1]|0;m=d[f+(h*6|0)+4>>1]|0;d[i>>1]=d[j>>1]|0;d[i+2>>1]=d[j+2>>1]|0;d[i+4>>1]=d[j+4>>1]|0;d[j>>1]=k;d[j+2>>1]=l;d[j+4>>1]=m;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function QV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<3)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<3)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<3)+4>>2]|0;m=j;n=f[m+4>>2]|0;o=i;f[o>>2]=f[m>>2];f[o+4>>2]=n;n=j;f[n>>2]=k;f[n+4>>2]=l;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function RV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*12|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*12|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*12|0)+4>>2]|0;m=f[e+(h*12|0)+8>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function SV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<4)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<4)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<4)+4>>2]|0;m=f[e+(h<<4)+8>>2]|0;n=f[e+(h<<4)+12>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function TV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*24|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*24|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*24|0)+4>>2]|0;m=f[e+(h*24|0)+8>>2]|0;n=f[e+(h*24|0)+12>>2]|0;o=f[e+(h*24|0)+16>>2]|0;p=f[e+(h*24|0)+20>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function UV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<5)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<5)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<5)+4>>2]|0;m=f[e+(h<<5)+8>>2]|0;n=f[e+(h<<5)+12>>2]|0;o=f[e+(h<<5)+16>>2]|0;p=f[e+(h<<5)+20>>2]|0;q=f[e+(h<<5)+24>>2]|0;r=f[e+(h<<5)+28>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;f[j+24>>2]=q;f[j+28>>2]=r;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function VV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+80|0;e=d+16|0;g=d;do if((eS(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){n=l+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;n=f[m>>2]|0;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];o=i;p=k;break}else{f[i>>2]=0;U$(e,h);o=i;p=k;break}}else{bS(e,a,-1);o=e+4|0;p=e+48|0}while(0);a=f[p>>2]|0;k=f[o>>2]|0;if((k|0)>0)if((k|0)<3)q=f[(f[e+44>>2]|0)+(k+-1<<2)>>2]|0;else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;r=$Xc(32)|0;f[g>>2]=r;s=g+8|0;f[s>>2]=-2147483616;t=g+4|0;f[t>>2]=31;v=r;w=235243;x=v+31|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+31|0;b[y>>0]=0;vM(-215,g,235275,234941,552)}else q=0;k=f[e+8>>2]|0;if((k|0)!=(f[e+12>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;r=$Xc(32)|0;f[g>>2]=r;s=g+8|0;f[s>>2]=-2147483616;t=g+4|0;f[t>>2]=31;v=r;w=235243;x=v+31|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+31|0;b[y>>0]=0;vM(-215,g,235275,234941,552)}g=e+16|0;y=f[g>>2]|0;r=e+44|0;if((k|0)>0)if(c){c=0;do{w=c;c=c+1|0;if((c|0)<(k|0)){v=Y(w,a)|0;x=Y(w,q)|0;w=c;do{o1c(y+((Y(w,q)|0)+v)|0,y+((Y(w,a)|0)+x)|0,q|0)|0;w=w+1|0}while((w|0)!=(k|0))}}while((c|0)!=(k|0))}else{c=0;do{if((c|0)>0){w=Y(c,a)|0;x=Y(c,q)|0;v=0;do{o1c(y+((Y(v,q)|0)+w)|0,y+((Y(v,a)|0)+x)|0,q|0)|0;v=v+1|0}while((v|0)!=(c|0))}c=c+1|0}while((c|0)!=(k|0))}k=e+36|0;c=f[k>>2]|0;if(c|0?(q=c+12|0,c=f[q>>2]|0,f[q>>2]=c+-1,(c|0)==1):0)V$(e);f[k>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[o>>2]|0)>0){g=f[e+40>>2]|0;e=0;do{f[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[o>>2]|0))}o=f[r>>2]|0;if((o|0)==(p|0)){u=d;return}wL(o);u=d;return}function WV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;h=u;u=u+272|0;i=h+216|0;j=h+168|0;k=h+112|0;l=h+56|0;m=h;if((oS(a,-1)|0)>=3){n=$Xc(32)|0;f[i>>2]=n;f[i+8>>2]=-2147483616;f[i+4>>2]=16;o=n;p=235288;q=o+16|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+16>>0]=0;vM(-215,i,235305,234941,974)}n=dS(a,-1)|0;r=n&7;s=n&4088;if((g|0)<0)if(YS(c)|0)t=dS(c,-1)|0;else t=n;else t=g;g=(t|0)>-1?t:n;t=g&7;v=t|s;w=(e|0)==1;if(e>>>0>=4){x=$Xc(96)|0;f[i>>2]=x;f[i+8>>2]=-2147483552;f[i+4>>2]=88;o=x;p=235312;q=o+88|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[x+88>>0]=0;vM(-215,i,235305,234941,984)}f[j>>2]=1124007936;x=j+4|0;y=j+8|0;z=j+20|0;A=j+24|0;B=j+28|0;C=j+32|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[C>>2]=y;D=j+40|0;f[j+36>>2]=D;f[j+44>>2]=0;f[D>>2]=0;if((eS(a)|0)==655360){fS(i,a,-1);E=f[A>>2]|0;if(E|0?(F=E+8|0,E=f[F>>2]|0,f[F>>2]=E+-1,(E|0)==1):0)FQ(j);if((f[x>>2]|0)>0){E=f[C>>2]|0;F=0;do{f[E+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[x>>2]|0))}f[j>>2]=f[i>>2];F=i+4|0;E=f[F>>2]|0;f[x>>2]=E;x=i+8|0;f[y>>2]=f[x>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[z>>2]=f[i+20>>2];z=i+24|0;f[A>>2]=f[z>>2];A=i+28|0;f[B>>2]=f[A>>2];B=j+36|0;G=f[B>>2]|0;if((G|0)==(D|0))H=E;else{wL(G);f[B>>2]=D;f[C>>2]=y;H=f[F>>2]|0}y=i+36|0;if((H|0)<3){H=f[y>>2]|0;f[D>>2]=f[H>>2];f[j+44>>2]=f[H+4>>2]}else{f[B>>2]=f[y>>2];B=i+32|0;f[j+32>>2]=f[B>>2];f[y>>2]=i+40;f[B>>2]=x}f[i>>2]=1124007936;f[z>>2]=0;f[A>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;EQ(i)}do if((eS(a)|0)==65536){F=f[a+4>>2]|0;f[k>>2]=f[F>>2];A=k+4|0;z=F+4|0;f[A>>2]=f[z>>2];x=k+8|0;f[x>>2]=f[F+8>>2];B=k+12|0;f[B>>2]=f[F+12>>2];f[k+16>>2]=f[F+16>>2];f[k+20>>2]=f[F+20>>2];f[k+24>>2]=f[F+24>>2];f[k+28>>2]=f[F+28>>2];f[k+32>>2]=f[F+32>>2];y=f[F+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=x;H=k+48|0;D=k+44|0;f[D>>2]=H;f[H>>2]=0;f[k+52>>2]=0;if(y|0){H=y+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[z>>2]|0)<3){z=f[F+44>>2]|0;H=f[D>>2]|0;f[H>>2]=f[z>>2];f[H+4>>2]=f[z+4>>2];I=B;J=x;break}else{f[A>>2]=0;U$(k,F);I=B;J=x;break}}else{bS(k,a,-1);I=k+12|0;J=k+8|0}while(0);a=(d|0)==0;ZS(c,a?1:f[J>>2]|0,a?f[I>>2]|0:1,v,-1,0,0);do if((eS(c)|0)==65536){v=f[c+4>>2]|0;f[l>>2]=f[v>>2];d=l+4|0;x=v+4|0;f[d>>2]=f[x>>2];B=l+8|0;f[B>>2]=f[v+8>>2];F=l+12|0;f[F>>2]=f[v+12>>2];A=l+16|0;f[A>>2]=f[v+16>>2];z=l+20|0;f[z>>2]=f[v+20>>2];H=l+24|0;f[H>>2]=f[v+24>>2];D=l+28|0;f[D>>2]=f[v+28>>2];y=l+32|0;f[y>>2]=f[v+32>>2];C=l+36|0;G=f[v+36>>2]|0;f[C>>2]=G;f[l+40>>2]=B;E=l+48|0;K=l+44|0;f[K>>2]=E;f[E>>2]=0;f[l+52>>2]=0;if(G|0){E=G+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;E=f[K>>2]|0;f[E>>2]=f[x>>2];f[E+4>>2]=f[x+4>>2];L=l;M=d;N=B;O=F;P=A;Q=A;R=z;S=H;T=D;U=y;V=C;W=C;break}else{f[d>>2]=0;U$(l,v);L=l;M=d;N=B;O=F;P=A;Q=A;R=z;S=H;T=D;U=y;V=C;W=C;break}}else{bS(l,c,-1);C=l+16|0;y=l+36|0;L=l;M=l+4|0;N=l+8|0;O=l+12|0;P=C;Q=C;R=l+20|0;S=l+24|0;T=l+28|0;U=l+32|0;V=y;W=y}while(0);f[m>>2]=f[L>>2];c=m+4|0;y=f[M>>2]|0;f[c>>2]=y;C=m+8|0;f[C>>2]=f[N>>2];D=m+12|0;f[D>>2]=f[O>>2];H=m+16|0;f[H>>2]=f[Q>>2];f[m+20>>2]=f[R>>2];f[m+24>>2]=f[S>>2];f[m+28>>2]=f[T>>2];f[m+32>>2]=f[U>>2];U=m+36|0;T=f[W>>2]|0;f[U>>2]=T;W=m+40|0;f[W>>2]=C;S=m+48|0;R=m+44|0;f[R>>2]=S;f[S>>2]=0;f[m+52>>2]=0;if(!T)X=y;else{y=T+12|0;f[y>>2]=(f[y>>2]|0)+1;X=f[M>>2]|0}if((X|0)<3){X=f[l+44>>2]|0;y=f[R>>2]|0;f[y>>2]=f[X>>2];f[y+4>>2]=f[X+4>>2]}else{f[c>>2]=0;U$(m,l)}do if(w)if(!((g|n)&4)){X=f[N>>2]|0;y=f[O>>2]|0;T=s|4;if(((f[c>>2]|0)<3?(f[C>>2]|0)==(X|0):0)&(f[D>>2]|0)==(y|0)?!((f[H>>2]|0)==0?1:(f[m>>2]&4095|0)!=(T|0)):0){Y=4;Z=0;break}f[i>>2]=X;f[i+4>>2]=y;S$(m,2,i,T);Y=4;Z=0}else{Y=t;Z=0}else{Y=t;Z=e}while(0);e=(Z|0)==0;a:do if(a){if(e){t=(r|0)==0;if(t&(Y|0)==4){_=1247;break}D=(Y|0)==5;if(t&D){_=1248;break}C=(Y|0)==6;if(t&C){_=1249;break}t=(r|0)==2;if(t&D){_=1250;break}if(t&C){_=1251;break}t=(r|0)==3;if(t&D){_=1252;break}if(t&C){_=1253;break}t=(r|0)==5;if(t&D){_=1254;break}if(t&C){_=1255;break}else{$=(r|0)==6&C?1241:0;aa=84;break}}switch(Z|0){case 2:{if(!(Y|r)){_=1256;break a}if((r|0)==2&(Y|0)==2){_=1257;break a}if((r|0)==3&(Y|0)==3){_=1258;break a}if((r|0)==5&(Y|0)==5){_=1259;break a}else{$=(r|0)==6&(Y|0)==6?1242:0;aa=84;break a}break}case 3:{if(!(Y|r)){_=1260;break a}if((r|0)==2&(Y|0)==2){_=1261;break a}if((r|0)==3&(Y|0)==3){_=1262;break a}if((r|0)==5&(Y|0)==5){_=1263;break a}else{$=(r|0)==6&(Y|0)==6?1243:0;aa=84;break a}break}default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ba=$Xc(64)|0;f[i>>2]=ba;ca=i+8|0;f[ca>>2]=-2147483584;da=i+4|0;f[da>>2]=57;o=ba;p=235401;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));ea=ba+57|0;b[ea>>0]=0;vM(-210,i,235305,234941,1116)}}}else{if(e){C=(r|0)==0;if(C&(Y|0)==4){_=1264;break}t=(Y|0)==5;if(C&t){_=1265;break}D=(Y|0)==6;if(C&D){_=1266;break}C=(r|0)==2;if(C&t){_=1267;break}if(C&D){_=1268;break}C=(r|0)==3;if(C&t){_=1269;break}if(C&D){_=1270;break}C=(r|0)==5;if(C&t){_=1271;break}if(C&D){_=1272;break}else{$=(r|0)==6&D?1244:0;aa=84;break}}switch(Z|0){case 2:{if(!(Y|r)){_=1273;break a}if((r|0)==2&(Y|0)==2){_=1274;break a}if((r|0)==3&(Y|0)==3){_=1275;break a}if((r|0)==5&(Y|0)==5){_=1276;break a}else{$=(r|0)==6&(Y|0)==6?1245:0;aa=84;break a}break}case 3:{if(!(Y|r)){_=1277;break a}if((r|0)==2&(Y|0)==2){_=1278;break a}if((r|0)==3&(Y|0)==3){_=1279;break a}if((r|0)==5&(Y|0)==5){_=1280;break a}else{$=(r|0)==6&(Y|0)==6?1246:0;aa=84;break a}break}default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ba=$Xc(64)|0;f[i>>2]=ba;ca=i+8|0;f[ca>>2]=-2147483584;da=i+4|0;f[da>>2]=57;o=ba;p=235401;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));ea=ba+57|0;b[ea>>0]=0;vM(-210,i,235305,234941,1116)}}}while(0);if((aa|0)==84)if(!$){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ba=$Xc(64)|0;f[i>>2]=ba;ca=i+8|0;f[ca>>2]=-2147483584;da=i+4|0;f[da>>2]=57;o=ba;p=235401;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));ea=ba+57|0;b[ea>>0]=0;vM(-210,i,235305,234941,1116)}else _=$;mi[_&2047](k,m);if(w){w=i+8|0;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;dY(m,i,f[L>>2]&4095,1.0/+((a?f[J>>2]|0:f[I>>2]|0)|0),0.0)}I=f[U>>2]|0;if(I|0?(J=I+12|0,I=f[J>>2]|0,f[J>>2]=I+-1,(I|0)==1):0)V$(m);f[U>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[c>>2]|0)>0){H=f[W>>2]|0;W=0;do{f[H+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[c>>2]|0))}c=f[R>>2]|0;if((c|0)!=(S|0))wL(c);c=f[V>>2]|0;if(c|0?(S=c+12|0,c=f[S>>2]|0,f[S>>2]=c+-1,(c|0)==1):0)V$(l);f[V>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[M>>2]|0)>0){P=f[l+40>>2]|0;V=0;do{f[P+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[M>>2]|0))}M=f[l+44>>2]|0;if((M|0)!=(l+48|0))wL(M);M=k+36|0;l=f[M>>2]|0;if(l|0?(V=l+12|0,l=f[V>>2]|0,f[V>>2]=l+-1,(l|0)==1):0)V$(k);f[M>>2]=0;M=k+16|0;l=k+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[l>>2]|0)>0){M=f[k+40>>2]|0;V=0;do{f[M+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)==(k+48|0)){EQ(j);u=h;return}wL(l);EQ(j);u=h;return}function XV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=bYc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;p[r>>3]=+p[r>>3]+ +p[n+(q<<3)>>3];q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;s=0;do{t=k+(s<<3)|0;v=s|1;w=k+(v<<3)|0;x=+p[w>>3]+ +p[q+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[q+(s<<3)>>3];p[w>>3]=x;w=s|2;t=k+(w<<3)|0;v=s|3;y=k+(v<<3)|0;x=+p[y>>3]+ +p[q+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[q+(w<<3)>>3];p[y>>3]=x;s=s+4|0}while((s|0)<=(g|0));if(n){s=o;do{y=k+(s<<3)|0;p[y>>3]=+p[y>>3]+ +p[q+(s<<3)>>3];s=s+1|0}while((s|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}dYc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function YV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=bYc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[n+(q<<3)>>3];p[r>>3]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[q+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[q+(x<<3)>>3];p[w>>3]=s<t?t:s;p[y>>3]=z<A?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[q+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[q+(y<<3)>>3];p[w>>3]=z<A?A:z;p[x>>3]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(n){v=o;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[q+(v<<3)>>3];p[x>>3]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}dYc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function ZV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=bYc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[n+(q<<3)>>3];p[r>>3]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[q+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[q+(x<<3)>>3];p[w>>3]=t<s?t:s;p[y>>3]=A<z?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[q+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[q+(y<<3)>>3];p[w>>3]=A<z?A:z;p[x>>3]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(n){v=o;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[q+(v<<3)>>3];p[x>>3]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}dYc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function _V(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=u;x=j;while(1){y=w+ +p[r+(x+t<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;p[s+(t<<3)>>3]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+p[r+(A+e<<3)>>3];y=+p[r+(A<<3)>>3];t=j;do{x=t+A|0;y=y+ +p[r+(x<<3)>>3]+ +p[r+(x+j<<3)>>3];w=w+ +p[r+(x+e<<3)>>3]+ +p[r+(x+n<<3)>>3];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=y;x=t;while(1){u=v+ +p[r+(x+A<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=y;p[s+(A<<3)>>3]=w+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function $V(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=j;x=u;while(1){y=+p[r+(w+t<<3)>>3];z=x<y?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;p[s+(t<<3)>>3]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+p[r+(B+e<<3)>>3];z=+p[r+(B<<3)>>3];t=j;do{w=t+B|0;y=+p[r+(w<<3)>>3];C=z<y?y:z;y=+p[r+(w+e<<3)>>3];D=x<y?y:x;y=+p[r+(w+j<<3)>>3];z=C<y?y:C;C=+p[r+(w+n<<3)>>3];x=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+p[r+(w+B<<3)>>3];D=v<u?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;p[s+(B<<3)>>3]=E<x?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function aW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=j;x=u;while(1){y=+p[r+(w+t<<3)>>3];z=y<x?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;p[s+(t<<3)>>3]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+p[r+(B+e<<3)>>3];z=+p[r+(B<<3)>>3];t=j;do{w=t+B|0;y=+p[r+(w<<3)>>3];C=y<z?y:z;y=+p[r+(w+e<<3)>>3];D=y<x?y:x;y=+p[r+(w+j<<3)>>3];z=y<C?y:C;C=+p[r+(w+n<<3)>>3];x=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+p[r+(w+B<<3)>>3];D=u<v?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;p[s+(B<<3)>>3]=x<E?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function bW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=j;x=u;while(1){y=+n[r+(w+t<<2)>>2];z=y<x?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;n[s+(t<<2)>>2]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+n[r+(B+e<<2)>>2];z=+n[r+(B<<2)>>2];t=j;do{w=t+B|0;y=+n[r+(w<<2)>>2];C=y<z?y:z;y=+n[r+(w+e<<2)>>2];D=y<x?y:x;y=+n[r+(w+j<<2)>>2];z=y<C?y:C;C=+n[r+(w+o<<2)>>2];x=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+n[r+(w+B<<2)>>2];D=u<v?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;n[s+(B<<2)>>2]=x<E?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function cW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=y<<16>>16<x<<16>>16?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=v<<16>>16<A<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=y<<16>>16<x<<16>>16?y:x;y=d[r+(z+g<<1)>>1]|0;D=y<<16>>16<t<<16>>16?y:t;y=d[r+(z+k<<1)>>1]|0;x=y<<16>>16<C<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;t=C<<16>>16<D<<16>>16?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=D<<16>>16<u<<16>>16?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=t<<16>>16<E<<16>>16?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function dW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=(y&65535)<(x&65535)?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=(v&65535)<(A&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=(y&65535)<(x&65535)?y:x;y=d[r+(z+g<<1)>>1]|0;D=(y&65535)<(t&65535)?y:t;y=d[r+(z+k<<1)>>1]|0;x=(y&65535)<(C&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;t=(C&65535)<(D&65535)?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=(D&65535)<(u&65535)?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=(t&65535)<(E&65535)?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function eW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=z-(h[246515+((z|256)-(h[s+(y+u)>>0]|0))>>0]|0)&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=x-(h[246515+((x|256)-(w&255))>>0]|0);u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+(C+g)>>0]|0;x=b[s+C>>0]|0;y=l;while(1){A=y+C|0;z=x&255;D=z-(h[246515+((z|256)-(h[s+A>>0]|0))>>0]|0)|0;z=u&255;E=z-(h[246515+((z|256)-(h[s+(A+g)>>0]|0))>>0]|0)|0;F=D-(h[246515+((D&255|256)-(h[s+(A+l)>>0]|0))>>0]|0)|0;G=E-(h[246515+((E&255|256)-(h[s+(A+p)>>0]|0))>>0]|0)|0;y=y+m|0;if((y|0)>(n|0))break;else{u=G&255;x=F&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=w-(h[246515+((w|256)-(h[s+(u+C)>>0]|0))>>0]|0)|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=H-(h[246515+((H&255|256)-(G&255))>>0]|0);C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function fW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=j;x=u;while(1){y=+n[r+(w+t<<2)>>2];z=x<y?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;n[s+(t<<2)>>2]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+n[r+(B+e<<2)>>2];z=+n[r+(B<<2)>>2];t=j;do{w=t+B|0;y=+n[r+(w<<2)>>2];C=z<y?y:z;y=+n[r+(w+e<<2)>>2];D=x<y?y:x;y=+n[r+(w+j<<2)>>2];z=C<y?y:C;C=+n[r+(w+o<<2)>>2];x=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+n[r+(w+B<<2)>>2];D=v<u?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;n[s+(B<<2)>>2]=E<x?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function gW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=x<<16>>16<y<<16>>16?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=A<<16>>16<v<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=x<<16>>16<y<<16>>16?y:x;y=d[r+(z+g<<1)>>1]|0;D=t<<16>>16<y<<16>>16?y:t;y=d[r+(z+k<<1)>>1]|0;x=C<<16>>16<y<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;t=D<<16>>16<C<<16>>16?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=u<<16>>16<D<<16>>16?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=E<<16>>16<t<<16>>16?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function hW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=(x&65535)<(y&65535)?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=(A&65535)<(v&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=(x&65535)<(y&65535)?y:x;y=d[r+(z+g<<1)>>1]|0;D=(t&65535)<(y&65535)?y:t;y=d[r+(z+k<<1)>>1]|0;x=(C&65535)<(y&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;t=(D&65535)<(C&65535)?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=(u&65535)<(D&65535)?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=(E&65535)<(t&65535)?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function iW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=(h[246515+(256-z+(h[s+(y+u)>>0]|0))>>0]|0)+z&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=(h[246515+((w&255|256)-x)>>0]|0)+x;u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+(C+g)>>0]|0;x=b[s+C>>0]|0;y=l;while(1){A=y+C|0;z=x&255;D=(h[246515+(256-z+(h[s+A>>0]|0))>>0]|0)+z|0;z=u&255;E=(h[246515+(256-z+(h[s+(A+g)>>0]|0))>>0]|0)+z|0;F=(h[246515+(256-(D&255)+(h[s+(A+l)>>0]|0))>>0]|0)+D|0;G=(h[246515+(256-(E&255)+(h[s+(A+p)>>0]|0))>>0]|0)+E|0;y=y+m|0;if((y|0)>(n|0))break;else{u=G&255;x=F&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=(h[246515+(256-w+(h[s+(u+C)>>0]|0))>>0]|0)+w|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=(h[246515+((G&255|256)-(H&255))>>0]|0)+H;C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function jW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;q=(j|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+n[s+(u<<2)>>2];u=u+1|0}while((u|0)!=(e|0))}else{if(m){u=0;while(1){v=+n[s+(u<<2)>>2];w=+n[s+(u+e<<2)>>2];if(q){x=v;y=j;while(1){z=x+ +n[s+(y+u<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+n[s+(B+e<<2)>>2];z=+n[s+(B<<2)>>2];u=j;do{y=u+B|0;z=z+ +n[s+(y<<2)>>2]+ +n[s+(y+j<<2)>>2];x=x+ +n[s+(y+e<<2)>>2]+ +n[s+(y+o<<2)>>2];u=u+k|0}while((u|0)<=(l|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +n[s+(y+B<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function kW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=u;x=j;while(1){y=w+ +n[r+(x+t<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;n[s+(t<<2)>>2]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+n[r+(A+e<<2)>>2];y=+n[r+(A<<2)>>2];t=j;do{x=t+A|0;y=y+ +n[r+(x<<2)>>2]+ +n[r+(x+j<<2)>>2];w=w+ +n[r+(x+e<<2)>>2]+ +n[r+(x+o<<2)>>2];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=y;x=t;while(1){u=v+ +n[r+(x+A<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=y;n[s+(A<<2)>>2]=w+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function lW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(n){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B+g<<1)>>1]|0);z=+(d[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);x=x+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=z;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function mW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;o=(k|0)>(m|0);p=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B+g<<1)>>1]|0);z=+(d[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);x=x+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=z;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=z;n[t+(B<<2)>>2]=x+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function nW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;n=(k|0)>(m|0);o=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(n){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B+e<<1)>>1]|0);z=+(j[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);x=x+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function oW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;o=(k|0)>(m|0);p=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(o){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B+e<<1)>>1]|0);z=+(j[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);x=x+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;n[t+(B<<2)>>2]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function pW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=n+(Y(o,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{p[t+(u<<3)>>3]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+(B+e)>>0]|0;x=h[s+B>>0]|0;y=i;do{z=y+B|0;x=(h[s+z>>0]|0)+x+(h[s+(z+i)>>0]|0)|0;u=(h[s+(z+e)>>0]|0)+u+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=x;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=x;p[t+(B<<3)>>3]=+(C+u|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function qW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;o=f[a+16>>2]|0;p=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=o+(Y(p,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{n[t+(u<<2)>>2]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+(B+e)>>0]|0;x=h[s+B>>0]|0;y=i;do{z=y+B|0;x=(h[s+z>>0]|0)+x+(h[s+(z+i)>>0]|0)|0;u=(h[s+(z+e)>>0]|0)+u+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=x;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=x;n[t+(B<<2)>>2]=+(C+u|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function rW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[a+44>>2]|0;a=f[b+16>>2]|0;p=f[b+44>>2]|0;b=(i|0)<(g|0);q=0;do{r=n+(Y(f[o>>2]|0,q)|0)|0;s=a+(Y(f[p>>2]|0,q)|0)|0;a:do if(c){t=0;do{f[s+(t<<2)>>2]=h[r+t>>0];t=t+1|0}while((t|0)!=(e|0))}else{if(l){t=0;while(1){u=h[r+t>>0]|0;v=h[r+(t+e)>>0]|0;if(b){w=u;x=i;while(1){y=(h[r+(x+t)>>0]|0)+w|0;x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;f[s+(t<<2)>>2]=z+v;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{t=h[r+(A+e)>>0]|0;w=h[r+A>>0]|0;x=i;do{y=x+A|0;w=(h[r+y>>0]|0)+w+(h[r+(y+i)>>0]|0)|0;t=(h[r+(y+e)>>0]|0)+t+(h[r+(y+m)>>0]|0)|0;x=x+j|0}while((x|0)<=(k|0));if((x|0)<(g|0)){v=w;u=x;while(1){y=(h[r+(u+A)>>0]|0)+v|0;u=u+e|0;if((u|0)>=(g|0)){B=y;break}else v=y}}else B=w;f[s+(A<<2)>>2]=B+t;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function sW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=bYc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[o+(q<<2)>>2];n[r>>2]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[q+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[q+(x<<2)>>2];n[w>>2]=t<s?t:s;n[y>>2]=A<z?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[q+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[q+(y<<2)>>2];n[w>>2]=A<z?A:z;n[x>>2]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=p;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[q+(v<<2)>>2];n[x>>2]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}dYc(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function tW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=bYc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=t<<16>>16<s<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=w<<16>>16<v<<16>>16?w:v;d[y>>1]=A<<16>>16<z<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=v<<16>>16<y<<16>>16?v:y;d[w>>1]=x<<16>>16<r<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=w<<16>>16<x<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}dYc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function uW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=bYc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=(t&65535)<(s&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=(w&65535)<(v&65535)?w:v;d[y>>1]=(A&65535)<(z&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=(v&65535)<(y&65535)?v:y;d[w>>1]=(x&65535)<(r&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=(w&65535)<(x&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}dYc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function vW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=bYc(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=c;q=o;while(1){p=p+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=t-(h[246515+((t|256)-(h[p+r>>0]|0))>>0]|0);r=r+1|0}while((r|0)!=(j|0))}q=q+-1|0;if(!q)break a}}q=j&-4;p=(q|0)<(j|0);r=c;t=o;do{r=r+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=z-(h[246515+((z|256)-(h[r+x>>0]|0))>>0]|0)&255;b[v>>0]=w-(h[246515+((w|256)-(h[r+s>>0]|0))>>0]|0);b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;x=m+v|0;z=h[x>>0]|0;B=z-(h[246515+((z|256)-(h[r+v>>0]|0))>>0]|0)&255;b[y>>0]=w-(h[246515+((w|256)-(h[r+A>>0]|0))>>0]|0);b[x>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(p){s=q;do{B=m+s|0;x=h[B>>0]|0;b[B>>0]=x-(h[246515+((x|256)-(h[r+s>>0]|0))>>0]|0);s=s+1|0}while((s|0)!=(j|0))}t=t+-1|0}while((t|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)dYc(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function wW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=bYc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[o+(q<<2)>>2];n[r>>2]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[q+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[q+(x<<2)>>2];n[w>>2]=s<t?t:s;n[y>>2]=z<A?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[q+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[q+(y<<2)>>2];n[w>>2]=z<A?A:z;n[x>>2]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=p;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[q+(v<<2)>>2];n[x>>2]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}dYc(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function xW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=bYc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=s<<16>>16<t<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=v<<16>>16<w<<16>>16?w:v;d[y>>1]=z<<16>>16<A<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=y<<16>>16<v<<16>>16?v:y;d[w>>1]=r<<16>>16<x<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=x<<16>>16<w<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}dYc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function yW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=bYc(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=(s&65535)<(t&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=(v&65535)<(w&65535)?w:v;d[y>>1]=(z&65535)<(A&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=(y&65535)<(v&65535)?v:y;d[w>>1]=(r&65535)<(x&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=(x&65535)<(w&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}dYc(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function zW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=bYc(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=c;q=o;while(1){p=p+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=(h[246515+(256-t+(h[p+r>>0]|0))>>0]|0)+t;r=r+1|0}while((r|0)!=(j|0))}q=q+-1|0;if(!q)break a}}q=j&-4;p=(q|0)<(j|0);r=c;t=o;do{r=r+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=(h[246515+(256-z+(h[r+x>>0]|0))>>0]|0)+z&255;b[v>>0]=(h[246515+(256-w+(h[r+s>>0]|0))>>0]|0)+w;b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;z=m+v|0;x=h[z>>0]|0;B=(h[246515+(256-x+(h[r+v>>0]|0))>>0]|0)+x&255;b[y>>0]=(h[246515+(256-w+(h[r+A>>0]|0))>>0]|0)+w;b[z>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(p){s=q;do{B=m+s|0;z=h[B>>0]|0;b[B>>0]=(h[246515+(256-z+(h[r+s>>0]|0))>>0]|0)+z;s=s+1|0}while((s|0)!=(j|0))}t=t+-1|0}while((t|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)dYc(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function AW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=bYc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+n[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;q=m;while(1){o=o+(l<<2)|0;if(a){r=0;do{s=k+(r<<3)|0;p[s>>3]=+p[s>>3]+ +n[o+(r<<2)>>2];r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;o=(q|0)<(h|0);r=b;s=m;do{r=r+(l<<2)|0;t=0;do{v=k+(t<<3)|0;w=t|1;x=k+(w<<3)|0;y=+p[x>>3]+ +n[r+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[r+(t<<2)>>2];p[x>>3]=y;x=t|2;v=k+(x<<3)|0;w=t|3;z=k+(w<<3)|0;y=+p[z>>3]+ +n[r+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[r+(x<<2)>>2];p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=k+(t<<3)|0;p[z>>3]=+p[z>>3]+ +n[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}dYc(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function BW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=bYc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;n[r>>2]=+n[r>>2]+ +n[o+(q<<2)>>2];q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;s=0;do{t=k+(s<<2)|0;v=s|1;w=k+(v<<2)|0;x=+n[w>>2]+ +n[q+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[q+(s<<2)>>2];n[w>>2]=x;w=s|2;t=k+(w<<2)|0;v=s|3;y=k+(v<<2)|0;x=+n[y>>2]+ +n[q+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[q+(w<<2)>>2];n[y>>2]=x;s=s+4|0}while((s|0)<=(g|0));if(o){s=p;do{y=k+(s<<2)|0;n[y>>2]=+n[y>>2]+ +n[q+(s<<2)>>2];s=s+1|0}while((s|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}dYc(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function CW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>136){k=bYc(i>>>0>536870911?-1:i<<3)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(d[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;q=n;while(1){o=o+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(d[o+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;o=(q|0)<(i|0);r=b;s=n;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(d[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[r+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(d[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[r+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(h|0));if(o){t=q;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(d[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}dYc(l);f[e>>2]=g;f[j>>2]=136;u=c;return}function DW(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>264){k=bYc(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(d[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(i|0))}o=h+-1|0;a:do if(o|0){h=i+-4|0;if((i|0)<4){p=b;q=o;while(1){p=p+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(d[p+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;p=(q|0)<(i|0);r=b;s=o;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(d[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[r+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(d[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[r+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(h|0));if(p){t=q;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(d[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}dYc(l);f[e>>2]=g;f[j>>2]=264;u=c;return}function EW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){k=bYc(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(j[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(h|0))}n=g+-1|0;a:do if(n|0){g=h+-4|0;if((h|0)<4){o=b;q=n;while(1){o=o+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(j[o+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;o=(q|0)<(h|0);r=b;s=n;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(j[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[r+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(j[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[r+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(j[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}dYc(l);f[d>>2]=e;f[i>>2]=136;u=c;return}function FW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){k=bYc(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(j[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(h|0))}o=g+-1|0;a:do if(o|0){g=h+-4|0;if((h|0)<4){p=b;q=o;while(1){p=p+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(j[p+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;p=(q|0)<(h|0);r=b;s=o;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(j[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[r+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(j[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[r+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(g|0));if(p){t=q;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(j[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}dYc(l);f[d>>2]=e;f[i>>2]=264;u=c;return}function GW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=bYc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=b;q=n;while(1){o=o+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[o+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;o=(q|0)<(i|0);r=b;s=n;do{r=r+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[r+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[r+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[r+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[r+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=l+(t<<2)|0;f[z>>2]=(h[r+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}dYc(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function HW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=bYc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){o=0;do{f[l+(o<<2)>>2]=h[b+o>>0];o=o+1|0}while((o|0)!=(i|0))}o=g+-1|0;a:do if(o|0){g=i+-4|0;if((i|0)<4){p=b;q=o;while(1){p=p+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[p+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;p=(q|0)<(i|0);r=b;s=o;do{r=r+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[r+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[r+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[r+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[r+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(p){t=q;do{z=l+(t<<2)|0;f[z>>2]=(h[r+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{n[k+(a<<2)>>2]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}dYc(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function IW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=bYc(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+m|0;if(a){q=0;do{r=l+(q<<2)|0;f[r>>2]=(h[o+q>>0]|0)+(f[r>>2]|0);q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;r=n;do{q=q+m|0;s=0;do{t=l+(s<<2)|0;v=s|1;w=l+(v<<2)|0;x=(h[q+v>>0]|0)+(f[w>>2]|0)|0;f[t>>2]=(h[q+s>>0]|0)+(f[t>>2]|0);f[w>>2]=x;x=s|2;w=l+(x<<2)|0;t=s|3;v=l+(t<<2)|0;y=(h[q+t>>0]|0)+(f[v>>2]|0)|0;f[w>>2]=(h[q+x>>0]|0)+(f[w>>2]|0);f[v>>2]=y;s=s+4|0}while((s|0)<=(g|0));if(o){s=p;do{y=l+(s<<2)|0;f[y>>2]=(h[q+s>>0]|0)+(f[y>>2]|0);s=s+1|0}while((s|0)!=(i|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}dYc(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function JW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+144|0;g=e+80|0;h=e+24|0;i=e+16|0;j=e;do if((eS(a)|0)==65536){k=f[a+4>>2]|0;f[g>>2]=f[k>>2];l=g+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=g+8|0;f[n>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=n;n=g+48|0;p=g+44|0;f[p>>2]=n;f[n>>2]=0;f[g+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];q=l;break}else{f[l>>2]=0;U$(g,k);q=l;break}}else{bS(g,a,-1);q=g+4|0}while(0);if((f[q>>2]|0)>=3){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=$Xc(48)|0;f[h>>2]=r;s=h+8|0;f[s>>2]=-2147483600;t=h+4|0;f[t>>2]=36;v=r;w=235459;x=v+36|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+36|0;b[y>>0]=0;vM(-215,h,235496,234941,1415)}a=f[g>>2]|0;if(a&4088|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=$Xc(48)|0;f[h>>2]=r;s=h+8|0;f[s>>2]=-2147483600;t=h+4|0;f[t>>2]=36;v=r;w=235459;x=v+36|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+36|0;b[y>>0]=0;vM(-215,h,235496,234941,1415)}y=g+40|0;r=f[y>>2]|0;t=f[r>>2]|0;f[i>>2]=f[r+4>>2];f[i+4>>2]=t;wS(c,i,a&4095,-1,0,0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];i=h+4|0;t=a+4|0;f[i>>2]=f[t>>2];r=h+8|0;f[r>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=r;r=h+48|0;l=h+44|0;f[l>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;r=f[l>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2];break}else{f[i>>2]=0;U$(h,a);break}}else bS(h,c,-1);while(0);c=f[g>>2]&7;if((c|0)==7){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=9;v=j;w=264557;x=v+9|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[j+9>>0]=0;vM(-215,j,235496,234941,1426)}Ti[f[37604+(c<<2)>>2]&511](g,h,d);d=h+36|0;c=f[d>>2]|0;if(c|0?(j=c+12|0,c=f[j>>2]|0,f[j>>2]=c+-1,(c|0)==1):0)V$(h);f[d>>2]=0;d=h+16|0;c=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[h+40>>2]|0;j=0;do{f[d+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))wL(c);c=g+36|0;h=f[c>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[y>>2]|0;y=0;do{f[c+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[q>>2]|0))}q=f[g+44>>2]|0;if((q|0)==(g+48|0)){u=e;return}wL(q);u=e;return}function KW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=1032;k=(d&1|0)==0;l=a+16|0;m=c+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(d&16|0)==0;d=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>1032){r=bYc(q)|0;f[h>>2]=r;s=d;t=q;v=r}else{s=d;t=q;v=i}}else{s=q;t=d;v=i}a:do if((s|0)>0){d=c+44|0;q=a+44|0;r=(t|0)>0;w=(t|0)/2|0;x=(t|0)>1;y=t+-1|0;if(k){z=p|x^1;A=0;B=n;while(1){C=B+(Y(f[f[d>>2]>>2]|0,A)|0)|0;if(!o)o1c(C|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,A)|0)|0,t|0)|0;WLc(C,C+t|0,g);if(!z){D=0;do{E=C+D|0;F=C+(y-D)|0;G=b[E>>0]|0;b[E>>0]=b[F>>0]|0;b[F>>0]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(s|0))break a;A=D;B=f[m>>2]|0}}B=v+t|0;A=p|x^1;z=0;do{if(r){D=f[l>>2]|0;C=f[q>>2]|0;G=0;do{F=D+(Y(f[C>>2]|0,G)|0)+z|0;b[v+G>>0]=b[F>>0]|0;G=G+1|0}while((G|0)!=(t|0))}WLc(v,B,g);if(!A){G=0;do{C=v+G|0;D=v+(y-G)|0;F=b[C>>0]|0;b[C>>0]=b[D>>0]|0;b[D>>0]=F;G=G+1|0}while((G|0)<(w|0))}if(r){G=0;do{F=(f[m>>2]|0)+(Y(f[f[d>>2]>>2]|0,G)|0)+z|0;b[F>>0]=b[v+G>>0]|0;G=G+1|0}while((G|0)!=(t|0))}z=z+1|0}while((z|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)dYc(s);f[h>>2]=i;f[j>>2]=1032;u=e;return}function LW(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=1032;k=(d&1|0)==0;l=a+16|0;m=c+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(d&16|0)==0;d=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>1032){r=bYc(q)|0;f[h>>2]=r;s=d;t=q;v=r}else{s=d;t=q;v=i}}else{s=q;t=d;v=i}a:do if((s|0)>0){d=c+44|0;q=a+44|0;r=(t|0)>0;w=(t|0)/2|0;x=(t|0)>1;y=t+-1|0;if(k){z=p|x^1;A=0;B=n;while(1){C=B+(Y(f[f[d>>2]>>2]|0,A)|0)|0;if(!o)o1c(C|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,A)|0)|0,t|0)|0;QLc(C,C+t|0,g);if(!z){D=0;do{E=C+D|0;F=C+(y-D)|0;G=b[E>>0]|0;b[E>>0]=b[F>>0]|0;b[F>>0]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(s|0))break a;A=D;B=f[m>>2]|0}}B=v+t|0;A=p|x^1;z=0;do{if(r){D=f[l>>2]|0;C=f[q>>2]|0;G=0;do{F=D+(Y(f[C>>2]|0,G)|0)+z|0;b[v+G>>0]=b[F>>0]|0;G=G+1|0}while((G|0)!=(t|0))}QLc(v,B,g);if(!A){G=0;do{C=v+G|0;D=v+(y-G)|0;F=b[C>>0]|0;b[C>>0]=b[D>>0]|0;b[D>>0]=F;G=G+1|0}while((G|0)<(w|0))}if(r){G=0;do{F=(f[m>>2]|0)+(Y(f[f[d>>2]>>2]|0,G)|0)+z|0;b[F>>0]=b[v+G>>0]|0;G=G+1|0}while((G|0)!=(t|0))}z=z+1|0}while((z|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)dYc(s);f[h>>2]=i;f[j>>2]=1032;u=e;return}function MW(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=520;k=(c&1|0)==0;l=a+16|0;m=b+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(c&16|0)==0;c=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>520){r=bYc(q>>>0>2147483647?-1:q<<1)|0;f[h>>2]=r;s=c;t=q;v=r}else{s=c;t=q;v=i}}else{s=q;t=c;v=i}a:do if((s|0)>0){c=b+44|0;q=a+44|0;r=t<<1;w=(t|0)>0;x=(t|0)/2|0;y=(t|0)>1;z=t+-1|0;if(k){A=p|y^1;B=0;C=n;while(1){D=C+(Y(f[f[c>>2]>>2]|0,B)|0)|0;if(!o)o1c(D|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,B)|0)|0,r|0)|0;gMc(D,D+(t<<1)|0,g);if(!A){E=0;do{F=D+(E<<1)|0;G=D+(z-E<<1)|0;H=d[F>>1]|0;d[F>>1]=d[G>>1]|0;d[G>>1]=H;E=E+1|0}while((E|0)<(x|0))}E=B+1|0;if((E|0)>=(s|0))break a;B=E;C=f[m>>2]|0}}C=v+(t<<1)|0;B=p|y^1;A=0;do{if(w){r=f[l>>2]|0;E=f[f[q>>2]>>2]|0;D=0;do{H=r+(Y(E,D)|0)+(A<<1)|0;d[v+(D<<1)>>1]=d[H>>1]|0;D=D+1|0}while((D|0)!=(t|0))}gMc(v,C,g);if(!B){D=0;do{E=v+(D<<1)|0;r=v+(z-D<<1)|0;H=d[E>>1]|0;d[E>>1]=d[r>>1]|0;d[r>>1]=H;D=D+1|0}while((D|0)<(x|0))}if(w){D=f[m>>2]|0;H=f[f[c>>2]>>2]|0;r=0;do{E=D+(Y(H,r)|0)+(A<<1)|0;d[E>>1]=d[v+(r<<1)>>1]|0;r=r+1|0}while((r|0)!=(t|0))}A=A+1|0}while((A|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)dYc(s);f[h>>2]=i;f[j>>2]=520;u=e;return}function NW(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1056|0;g=e;h=e+8|0;i=h+8|0;f[h>>2]=i;j=h+4|0;f[j>>2]=520;k=(c&1|0)==0;l=a+16|0;m=b+16|0;n=f[m>>2]|0;o=(f[l>>2]|0)==(n|0);p=(c&16|0)==0;c=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!k){f[j>>2]=q;if(q>>>0>520){r=bYc(q>>>0>2147483647?-1:q<<1)|0;f[h>>2]=r;s=c;t=q;v=r}else{s=c;t=q;v=i}}else{s=q;t=c;v=i}a:do if((s|0)>0){c=b+44|0;q=a+44|0;r=t<<1;w=(t|0)>0;x=(t|0)/2|0;y=(t|0)>1;z=t+-1|0;if(k){A=p|y^1;B=0;C=n;while(1){D=C+(Y(f[f[c>>2]>>2]|0,B)|0)|0;if(!o)o1c(D|0,(f[l>>2]|0)+(Y(f[f[q>>2]>>2]|0,B)|0)|0,r|0)|0;aMc(D,D+(t<<1)|0,g);if(!A){E=0;do{F=D+(E<<1)|0;G=D+(z-E<<1)|0;H=d[F>>1]|0;d[F>>1]=d[G>>1]|0;d[G>>1]=H;E=E+1|0}while((E|0)<(x|0))}E=B+1|0;if((E|0)>=(s|0))break a;B=E;C=f[m>>2]|0}}C=v+(t<<1)|0;B=p|y^1;A=0;do{if(w){r=f[l>>2]|0;E=f[f[q>>2]>>2]|0;D=0;do{H=r+(Y(E,D)|0)+(A<<1)|0;d[v+(D<<1)>>1]=d[H>>1]|0;D=D+1|0}while((D|0)!=(t|0))}aMc(v,C,g);if(!B){D=0;do{E=v+(D<<1)|0;r=v+(z-D<<1)|0;H=d[E>>1]|0;d[E>>1]=d[r>>1]|0;d[r>>1]=H;D=D+1|0}while((D|0)<(x|0))}if(w){D=f[m>>2]|0;H=f[f[c>>2]>>2]|0;r=0;do{E=D+(Y(H,r)|0)+(A<<1)|0;d[E>>1]=d[v+(r<<1)>>1]|0;r=r+1|0}while((r|0)!=(t|0))}A=A+1|0}while((A|0)<(s|0))}while(0);s=f[h>>2]|0;if((s|0)==(i|0)){u=e;return}if(s|0)dYc(s);f[h>>2]=i;f[j>>2]=520;u=e;return}function OW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+1072|0;e=d;g=d+8|0;h=g+8|0;f[g>>2]=h;i=g+4|0;f[i>>2]=264;j=(c&1|0)==0;k=a+16|0;l=b+16|0;m=f[l>>2]|0;n=(f[k>>2]|0)==(m|0);o=(c&16|0)==0;c=f[a+12>>2]|0;p=f[a+8>>2]|0;if(!j){f[i>>2]=p;if(p>>>0>264){q=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=q;r=c;s=p;t=q}else{r=c;s=p;t=h}}else{r=p;s=c;t=h}a:do if((r|0)>0){c=b+44|0;p=a+44|0;q=s<<2;v=(s|0)>0;w=(s|0)/2|0;x=(s|0)>1;y=s+-1|0;if(j){z=o|x^1;A=0;B=m;while(1){C=B+(Y(f[f[c>>2]>>2]|0,A)|0)|0;if(!n)o1c(C|0,(f[k>>2]|0)+(Y(f[f[p>>2]>>2]|0,A)|0)|0,q|0)|0;mMc(C,C+(s<<2)|0,e);if(!z){D=0;do{E=C+(D<<2)|0;F=C+(y-D<<2)|0;G=f[E>>2]|0;f[E>>2]=f[F>>2];f[F>>2]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(r|0))break a;A=D;B=f[l>>2]|0}}B=t+(s<<2)|0;A=o|x^1;z=0;do{if(v){q=f[k>>2]|0;D=f[p>>2]|0;C=0;do{G=q+(Y(f[D>>2]|0,C)|0)+(z<<2)|0;f[t+(C<<2)>>2]=f[G>>2];C=C+1|0}while((C|0)!=(s|0))}mMc(t,B,e);if(!A){C=0;do{D=t+(C<<2)|0;q=t+(y-C<<2)|0;G=f[D>>2]|0;f[D>>2]=f[q>>2];f[q>>2]=G;C=C+1|0}while((C|0)<(w|0))}if(v){C=f[l>>2]|0;G=f[c>>2]|0;q=0;do{D=C+(Y(f[G>>2]|0,q)|0)+(z<<2)|0;f[D>>2]=f[t+(q<<2)>>2];q=q+1|0}while((q|0)!=(s|0))}z=z+1|0}while((z|0)<(r|0))}while(0);r=f[g>>2]|0;if((r|0)==(h|0)){u=d;return}if(r|0)dYc(r);f[g>>2]=h;f[i>>2]=264;u=d;return}function PW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+1072|0;e=d;g=d+8|0;h=g+8|0;f[g>>2]=h;i=g+4|0;f[i>>2]=264;j=(c&1|0)==0;k=a+16|0;l=b+16|0;m=f[l>>2]|0;n=(f[k>>2]|0)==(m|0);o=(c&16|0)==0;c=f[a+12>>2]|0;p=f[a+8>>2]|0;if(!j){f[i>>2]=p;if(p>>>0>264){q=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=q;r=c;s=p;t=q}else{r=c;s=p;t=h}}else{r=p;s=c;t=h}a:do if((r|0)>0){c=b+44|0;p=a+44|0;q=s<<2;v=(s|0)>0;w=(s|0)/2|0;x=(s|0)>1;y=s+-1|0;if(j){z=o|x^1;A=0;B=m;while(1){C=B+(Y(f[f[c>>2]>>2]|0,A)|0)|0;if(!n)o1c(C|0,(f[k>>2]|0)+(Y(f[f[p>>2]>>2]|0,A)|0)|0,q|0)|0;sMc(C,C+(s<<2)|0,e);if(!z){D=0;do{E=C+(D<<2)|0;F=C+(y-D<<2)|0;G=f[E>>2]|0;f[E>>2]=f[F>>2];f[F>>2]=G;D=D+1|0}while((D|0)<(w|0))}D=A+1|0;if((D|0)>=(r|0))break a;A=D;B=f[l>>2]|0}}B=t+(s<<2)|0;A=o|x^1;z=0;do{if(v){q=f[k>>2]|0;D=f[f[p>>2]>>2]|0;C=0;do{G=q+(Y(D,C)|0)+(z<<2)|0;f[t+(C<<2)>>2]=f[G>>2];C=C+1|0}while((C|0)!=(s|0))}sMc(t,B,e);if(!A){C=0;do{D=t+(C<<2)|0;q=t+(y-C<<2)|0;G=f[D>>2]|0;f[D>>2]=f[q>>2];f[q>>2]=G;C=C+1|0}while((C|0)<(w|0))}if(v){C=f[l>>2]|0;G=f[f[c>>2]>>2]|0;q=0;do{D=C+(Y(G,q)|0)+(z<<2)|0;f[D>>2]=f[t+(q<<2)>>2];q=q+1|0}while((q|0)!=(s|0))}z=z+1|0}while((z|0)<(r|0))}while(0);r=f[g>>2]|0;if((r|0)==(h|0)){u=d;return}if(r|0)dYc(r);f[g>>2]=h;f[i>>2]=264;u=d;return}function QW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0;d=u;u=u+1104|0;e=d+1096|0;g=d;h=g+8|0;f[g>>2]=h;i=g+4|0;f[i>>2]=136;j=(c&1|0)==0;k=a+16|0;l=b+16|0;m=f[l>>2]|0;n=(f[k>>2]|0)==(m|0);o=(c&16|0)==0;c=f[a+12>>2]|0;q=f[a+8>>2]|0;if(!j){f[i>>2]=q;if(q>>>0>136){r=bYc(q>>>0>536870911?-1:q<<3)|0;f[g>>2]=r;s=c;t=q;v=r}else{s=c;t=q;v=h}}else{s=q;t=c;v=h}a:do if((s|0)>0){c=b+44|0;q=a+44|0;r=t<<3;w=(t|0)>0;x=(t|0)/2|0;y=(t|0)>1;z=t+-1|0;if(j){A=o|y^1;B=0;C=m;while(1){D=C+(Y(f[f[c>>2]>>2]|0,B)|0)|0;if(!n)o1c(D|0,(f[k>>2]|0)+(Y(f[f[q>>2]>>2]|0,B)|0)|0,r|0)|0;yMc(D,D+(t<<3)|0,e);if(!A){E=0;do{F=D+(E<<3)|0;G=D+(z-E<<3)|0;H=+p[F>>3];p[F>>3]=+p[G>>3];p[G>>3]=H;E=E+1|0}while((E|0)<(x|0))}E=B+1|0;if((E|0)>=(s|0))break a;B=E;C=f[l>>2]|0}}C=v+(t<<3)|0;B=o|y^1;A=0;do{if(w){r=f[k>>2]|0;E=f[f[q>>2]>>2]|0;D=0;do{G=r+(Y(E,D)|0)+(A<<3)|0;p[v+(D<<3)>>3]=+p[G>>3];D=D+1|0}while((D|0)!=(t|0))}yMc(v,C,e);if(!B){D=0;do{E=v+(D<<3)|0;r=v+(z-D<<3)|0;H=+p[E>>3];p[E>>3]=+p[r>>3];p[r>>3]=H;D=D+1|0}while((D|0)<(x|0))}if(w){D=f[l>>2]|0;r=f[f[c>>2]>>2]|0;E=0;do{G=D+(Y(r,E)|0)+(A<<3)|0;p[G>>3]=+p[v+(E<<3)>>3];E=E+1|0}while((E|0)!=(t|0))}A=A+1|0}while((A|0)<(s|0))}while(0);s=f[g>>2]|0;if((s|0)==(h|0)){u=d;return}if(s|0)dYc(s);f[g>>2]=h;f[i>>2]=136;u=d;return}function RW(){var a=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;a=$Xc(48)|0;f[c>>2]=a;f[c+8>>2]=-2147483600;f[c+4>>2]=46;d=a;e=235501;g=d+46|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));b[a+46>>0]=0;vM(-218,c,235548,235561,64)}function SW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;RW()}function TW(a){a=a|0;return}function UW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0;if((c|0)>0)d=0;else return;do{e=j[a+(d<<1)>>1]|0;g=e<<13;h=g&268427264;i=h+939524096|0;k=e<<16&-2147483648;l=e&31744;a:do if(l<<16>>16<31744){switch(l<<16>>16){case 0:break;default:{m=i;break a}}m=(n[s>>2]=(f[s>>2]=h+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(l<<16>>16){case 31744:break;default:{m=i;break a}}m=g|1879048192}while(0);f[b+(d<<2)>>2]=m|k;d=d+1|0}while((d|0)!=(c|0));return}function VW(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0,i=0,j=0;if((c|0)>0)e=0;else return;do{g=f[a+(e<<2)>>2]|0;h=g&-2147483648;i=h^g;do if(i>>>0<=1199570943)if(i>>>0<947912704){j=(n[s>>2]=(f[s>>2]=i,+n[s>>2])+.5,f[s>>2]|0);break}else{j=(g+134221823+(g>>>13&1)|0)>>>13;break}else j=i>>>0>2139095040?32256:31744;while(0);d[b+(e<<1)>>1]=j|h>>>16;e=e+1|0}while((e|0)!=(c|0));return}function WW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if((c|0)>0)d=0;else return;do{e=a+(d<<2)|0;n[e>>2]=+n[b+((d<<1|1)<<2)>>2]+ +n[e>>2];d=d+1|0}while((d|0)!=(c|0));return}function XW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;if((c|0)>0)d=0;else return;do{e=a+(d<<3)|0;p[e>>3]=+p[b+((d<<1|1)<<3)>>3]+ +p[e>>3];d=d+1|0}while((d|0)!=(c|0));return}function YW(a,b){a=a|0;b=b|0;return f[37636+((b&7)<<5)+((a&7)<<2)>>2]|0}function ZW(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;if((d|0)>0){j=a;k=e;l=0}else return;while(1){o1c(k|0,j|0,i|0)|0;l=l+1|0;if((l|0)==(d|0))break;else{j=j+b|0;k=k+g|0}}return}function _W(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=b[m+a>>0]|0;b[l+a>>0]=(g|0)>0?g:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+c|0}}return}function $W(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=j[n+(a<<1)>>1]|0;b[m+a>>0]=g>>>0<255?g:255;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+h|0;n=n+(i<<1)|0}}return}function aX(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{h=d[n+(a<<1)>>1]|0;b[m+a>>0]=(h&65535)<256?h&65535:h<<16>>16>0?255:0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+i|0;n=n+(j<<1)|0}}return}function bX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;b[l+a>>0]=g>>>0<256?g:(g|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function cX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=ALc(+n[m+(a<<2)>>2])|0;b[l+a>>0]=g>>>0<256?g:(g|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function dX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=zLc(+p[m+(a<<3)>>3])|0;b[l+a>>0]=g>>>0<256?g:(g|0)>0?255:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<3)|0}}return}function eX(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,t=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;o=a}else return;while(1){a=0;do{g=j[o+(a<<1)>>1]|0;c=g<<13;d=c&268427264;p=d+939524096|0;q=g<<16&-2147483648;r=g&31744;a:do if(r<<16>>16<31744){switch(r<<16>>16){case 0:break;default:{t=p;break a}}t=(n[s>>2]=(f[s>>2]=d+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(r<<16>>16){case 31744:break;default:{t=p;break a}}t=c|1879048192}while(0);c=ALc((f[s>>2]=t|q,+n[s>>2]))|0;b[m+a>>0]=c>>>0<256?c:(c|0)>0?255:0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+h|0;o=o+(i<<1)|0}}return}function fX(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;e=f[j+4>>2]|0;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=h[n+a>>0]|0;b[m+a>>0]=g>>>0<127?g:127;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+i|0;n=n+c|0}}return}function gX(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=j[n+(a<<1)>>1]|0;b[m+a>>0]=g>>>0<127?g:127;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+h|0;n=n+(i<<1)|0}}return}function hX(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{h=d[n+(a<<1)>>1]|0;c=h<<16>>16;b[m+a>>0]=(c+128|0)>>>0<256?c:h<<16>>16>0?127:128;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+i|0;n=n+(j<<1)|0}}return}function iX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;b[l+a>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function jX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=ALc(+n[m+(a<<2)>>2])|0;b[l+a>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<2)|0}}return}function kX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=zLc(+p[m+(a<<3)>>3])|0;b[l+a>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+h|0;m=m+(i<<3)|0}}return}function lX(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,t=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;o=a}else return;while(1){a=0;do{g=j[o+(a<<1)>>1]|0;c=g<<13;d=c&268427264;p=d+939524096|0;q=g<<16&-2147483648;r=g&31744;a:do if(r<<16>>16<31744){switch(r<<16>>16){case 0:break;default:{t=p;break a}}t=(n[s>>2]=(f[s>>2]=d+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(r<<16>>16){case 31744:break;default:{t=p;break a}}t=c|1879048192}while(0);c=ALc((f[s>>2]=t|q,+n[s>>2]))|0;b[m+a>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+h|0;o=o+(i<<1)|0}}return}function mX(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{d[m+(a<<1)>>1]=h[n+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(j<<1)|0;n=n+b|0}}return}function nX(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{h=b[n+a>>0]|0;d[m+(a<<1)>>1]=(h|0)>0?h:0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+(j<<1)|0;n=n+c|0}}return}function oX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=f[h>>2]<<1;if((i|0)<=0)return;h=a;a=e;e=0;while(1){o1c(a|0,h|0,d|0)|0;e=e+1|0;if((e|0)==(i|0))break;else{h=h+b|0;a=a+g|0}}return}function pX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=d[m+(a<<1)>>1]|0;d[l+(a<<1)>>1]=(g|0)>0?g:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<1)|0}}return}function qX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;d[l+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function rX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=ALc(+n[m+(a<<2)>>2])|0;d[l+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function sX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=zLc(+p[m+(a<<3)>>3])|0;d[l+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<3)|0}}return}function tX(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,t=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((k|0)>0&(e|0)>0){l=0;m=g;o=a}else return;while(1){a=0;do{g=j[o+(a<<1)>>1]|0;h=g<<13;c=h&268427264;p=c+939524096|0;q=g<<16&-2147483648;r=g&31744;a:do if(r<<16>>16<31744){switch(r<<16>>16){case 0:break;default:{t=p;break a}}t=(n[s>>2]=(f[s>>2]=c+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(r<<16>>16){case 31744:break;default:{t=p;break a}}t=h|1879048192}while(0);h=ALc((f[s>>2]=t|q,+n[s>>2]))|0;d[m+(a<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(b<<1)|0;o=o+(i<<1)|0}}return}function uX(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{d[m+(a<<1)>>1]=h[n+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(j<<1)|0;n=n+b|0}}return}function vX(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;n=a}else return;while(1){a=0;do{d[m+(a<<1)>>1]=b[n+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+(j<<1)|0;n=n+c|0}}return}function wX(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((k|0)>0&(e|0)>0){l=0;m=g;n=a}else return;while(1){a=0;do{g=j[n+(a<<1)>>1]|0;d[m+(a<<1)>>1]=g>>>0<32767?g:32767;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(b<<1)|0;n=n+(i<<1)|0}}return}function xX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;d[l+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function yX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=ALc(+n[m+(a<<2)>>2])|0;d[l+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function zX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=zLc(+p[m+(a<<3)>>3])|0;d[l+(a<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<3)|0}}return}function AX(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,t=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((k|0)>0&(e|0)>0){l=0;m=g;o=a}else return;while(1){a=0;do{g=j[o+(a<<1)>>1]|0;h=g<<13;c=h&268427264;p=c+939524096|0;q=g<<16&-2147483648;r=g&31744;a:do if(r<<16>>16<31744){switch(r<<16>>16){case 0:break;default:{t=p;break a}}t=(n[s>>2]=(f[s>>2]=c+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(r<<16>>16){case 31744:break;default:{t=p;break a}}t=h|1879048192}while(0);h=ALc((f[s>>2]=t|q,+n[s>>2]))|0;d[m+(a<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(b<<1)|0;o=o+(i<<1)|0}}return}function BX(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if((d|0)>0&(j|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=h[m+a>>0];a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(i<<2)|0;m=m+b|0}}return}function CX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=b[m+a>>0];a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(i<<2)|0;m=m+c|0}}return}function DX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if((d|0)>0&(i|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=j[m+(a<<1)>>1];a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}function EX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{f[l+(a<<2)>>2]=d[m+(a<<1)>>1];a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<2)|0;m=m+(i<<1)|0}}return}function FX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=f[h>>2]<<2;if((i|0)<=0)return;h=a;a=e;e=0;while(1){o1c(a|0,h|0,d|0)|0;e=e+1|0;if((e|0)==(i|0))break;else{h=h+b|0;a=a+g|0}}return}function GX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if((d|0)>0&(i|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{e=ALc(+n[l+(a<<2)>>2])|0;f[k+(a<<2)>>2]=e;a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<2)|0}}return}function HX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;if((d|0)>0&(i|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{e=zLc(+p[l+(a<<3)>>3])|0;f[k+(a<<2)>>2]=e;a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<3)|0}}return}function IX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if((d|0)>0&(i|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{e=j[m+(a<<1)>>1]|0;g=e<<13;c=g&268427264;o=c+939524096|0;p=e<<16&-2147483648;q=e&31744;a:do if(q<<16>>16<31744){switch(q<<16>>16){case 0:break;default:{r=o;break a}}r=(n[s>>2]=(f[s>>2]=c+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(q<<16>>16){case 31744:break;default:{r=o;break a}}r=g|1879048192}while(0);g=ALc((f[s>>2]=r|p,+n[s>>2]))|0;f[l+(a<<2)>>2]=g;a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}function JX(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if((d|0)>0&(j|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(h[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(i<<2)|0;m=m+b|0}}return}function KX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(b[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(i<<2)|0;m=m+c|0}}return}function LX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if((i|0)>0&(d|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(j[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}function MX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{n[l+(a<<2)>>2]=+(d[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<2)|0;m=m+(i<<1)|0}}return}function NX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{n[k+(a<<2)>>2]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<2)|0}}return}function OX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{n[k+(a<<2)>>2]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<2)|0;l=l+(h<<3)|0}}return}function PX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if((i|0)>0&(d|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{e=j[m+(a<<1)>>1]|0;g=e<<13;c=g&268427264;o=c+939524096|0;p=e<<16&-2147483648;q=e&31744;a:do if(q<<16>>16<31744){switch(q<<16>>16){case 0:break;default:{r=o;break a}}r=(n[s>>2]=(f[s>>2]=c+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(q<<16>>16){case 31744:break;default:{r=o;break a}}r=g|1879048192}while(0);f[l+(a<<2)>>2]=r|p;a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<2)|0;m=m+(h<<1)|0}}return}function QX(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>3;if((d|0)>0&(j|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(h[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(i<<3)|0;m=m+b|0}}return}function RX(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>3;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(b[m+a>>0]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(i<<3)|0;m=m+c|0}}return}function SX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>3;if((i|0)>0&(d|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(j[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<3)|0;m=m+(h<<1)|0}}return}function TX(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>3;if((j|0)>0&(e|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{p[l+(a<<3)>>3]=+(d[m+(a<<1)>>1]|0);a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<3)|0;m=m+(i<<1)|0}}return}function UX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{p[k+(a<<3)>>3]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<3)|0;l=l+(h<<2)|0}}return}function VX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;if((i|0)>0&(d|0)>0){j=0;k=e;l=a}else return;while(1){a=0;do{p[k+(a<<3)>>3]=+n[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0));j=j+1|0;if((j|0)==(d|0))break;else{k=k+(b<<3)|0;l=l+(h<<2)|0}}return}function WX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=f[h>>2]<<3;if((i|0)<=0)return;h=a;a=e;e=0;while(1){o1c(a|0,h|0,d|0)|0;e=e+1|0;if((e|0)==(i|0))break;else{h=h+b|0;a=a+g|0}}return}function XX(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,t=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>3;if((i|0)>0&(d|0)>0){k=0;l=e;m=a}else return;while(1){a=0;do{e=j[m+(a<<1)>>1]|0;g=e<<13;c=g&268427264;o=c+939524096|0;q=e<<16&-2147483648;r=e&31744;a:do if(r<<16>>16<31744){switch(r<<16>>16){case 0:break;default:{t=o;break a}}t=(n[s>>2]=(f[s>>2]=c+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(r<<16>>16){case 31744:break;default:{t=o;break a}}t=g|1879048192}while(0);p[l+(a<<3)>>3]=(f[s>>2]=t|q,+n[s>>2]);a=a+1|0}while((a|0)!=(i|0));k=k+1|0;if((k|0)==(d|0))break;else{l=l+(b<<3)|0;m=m+(h<<1)|0}}return}function YX(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;o=a}else return;while(1){a=0;do{g=(n[s>>2]=+(h[o+a>>0]|0),f[s>>2]|0);i=g&-2147483648;c=i^g;do if(c>>>0<=1199570943)if(c>>>0<947912704){p=(n[s>>2]=(f[s>>2]=c,+n[s>>2])+.5,f[s>>2]|0);break}else{p=(g+134221823+(g>>>13&1)|0)>>>13;break}else p=c>>>0>2139095040?32256:31744;while(0);d[m+(a<<1)>>1]=p|i>>>16;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(j<<1)|0;o=o+b|0}}return}function ZX(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if((g|0)>0&(k|0)>0){l=0;m=h;o=a}else return;while(1){a=0;do{h=(n[s>>2]=+(b[o+a>>0]|0),f[s>>2]|0);i=h&-2147483648;e=i^h;do if(e>>>0<=1199570943)if(e>>>0<947912704){p=(n[s>>2]=(f[s>>2]=e,+n[s>>2])+.5,f[s>>2]|0);break}else{p=(h+134221823+(h>>>13&1)|0)>>>13;break}else p=e>>>0>2139095040?32256:31744;while(0);d[m+(a<<1)>>1]=p|i>>>16;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(g|0))break;else{m=m+(j<<1)|0;o=o+c|0}}return}function _X(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,p=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((e|0)>0&(k|0)>0){l=0;m=g;o=a}else return;while(1){a=0;do{g=(n[s>>2]=+(j[o+(a<<1)>>1]|0),f[s>>2]|0);h=g&-2147483648;c=h^g;do if(c>>>0<=1199570943)if(c>>>0<947912704){p=(n[s>>2]=(f[s>>2]=c,+n[s>>2])+.5,f[s>>2]|0);break}else{p=(g+134221823+(g>>>13&1)|0)>>>13;break}else p=c>>>0>2139095040?32256:31744;while(0);d[m+(a<<1)>>1]=p|h>>>16;a=a+1|0}while((a|0)!=(k|0));l=l+1|0;if((l|0)==(e|0))break;else{m=m+(b<<1)|0;o=o+(i<<1)|0}}return}function $X(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=(n[s>>2]=+(d[m+(a<<1)>>1]|0),f[s>>2]|0);h=g&-2147483648;c=h^g;do if(c>>>0<=1199570943)if(c>>>0<947912704){o=(n[s>>2]=(f[s>>2]=c,+n[s>>2])+.5,f[s>>2]|0);break}else{o=(g+134221823+(g>>>13&1)|0)>>>13;break}else o=c>>>0>2139095040?32256:31744;while(0);d[l+(a<<1)>>1]=o|h>>>16;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<1)|0}}return}function aY(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=(n[s>>2]=+(f[m+(a<<2)>>2]|0),f[s>>2]|0);h=g&-2147483648;c=h^g;do if(c>>>0<=1199570943)if(c>>>0<947912704){o=(n[s>>2]=(f[s>>2]=c,+n[s>>2])+.5,f[s>>2]|0);break}else{o=(g+134221823+(g>>>13&1)|0)>>>13;break}else o=c>>>0>2139095040?32256:31744;while(0);d[l+(a<<1)>>1]=o|h>>>16;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function bY(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=f[m+(a<<2)>>2]|0;h=g&-2147483648;c=h^g;do if(c>>>0<=1199570943)if(c>>>0<947912704){o=(n[s>>2]=(f[s>>2]=c,+n[s>>2])+.5,f[s>>2]|0);break}else{o=(g+134221823+(g>>>13&1)|0)>>>13;break}else o=c>>>0>2139095040?32256:31744;while(0);d[l+(a<<1)>>1]=o|h>>>16;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}function cY(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;if((e|0)>0&(j|0)>0){k=0;l=g;m=a}else return;while(1){a=0;do{g=(n[s>>2]=+p[m+(a<<3)>>3],f[s>>2]|0);h=g&-2147483648;c=h^g;do if(c>>>0<=1199570943)if(c>>>0<947912704){o=(n[s>>2]=(f[s>>2]=c,+n[s>>2])+.5,f[s>>2]|0);break}else{o=(g+134221823+(g>>>13&1)|0)>>>13;break}else o=c>>>0>2139095040?32256:31744;while(0);d[l+(a<<1)>>1]=o|h>>>16;a=a+1|0}while((a|0)!=(j|0));k=k+1|0;if((k|0)==(e|0))break;else{l=l+(b<<1)|0;m=m+(i<<3)|0}}return}function dY(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+208|0;i=h+152|0;j=h+88|0;k=h+96|0;l=h+8|0;m=h+72|0;n=h+64|0;o=h;q=h+32|0;r=h+24|0;s=a+16|0;if(f[s>>2]|0){t=a+4|0;v=f[t>>2]|0;if((v|0)<3)w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{x=f[a+40>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if(!((v|0)==0|(w|0)==0)){if(+L(+(e+-1.0))<2.220446049250313e-16)B=+L(+g)<2.220446049250313e-16;else B=0;do if((d|0)<0)if(YS(c)|0){w=dS(c,-1)|0;C=w;D=a;E=f[a>>2]|0;break}else{w=f[a>>2]|0;C=w&4095;D=a;E=w;break}else{w=f[a>>2]|0;C=w&4088|d&7;D=a;E=w}while(0);d=E&7;E=C&7;if(!((d|0)!=(E|0)|B^1)){jR(a,c);u=h;return}f[i>>2]=f[D>>2];w=i+4|0;v=f[t>>2]|0;f[w>>2]=v;z=i+8|0;f[z>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];y=i+16|0;f[y>>2]=f[s>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];s=i+36|0;x=f[a+36>>2]|0;f[s>>2]=x;A=i+40|0;f[A>>2]=z;z=i+48|0;F=i+44|0;f[F>>2]=z;f[z>>2]=0;f[i+52>>2]=0;if(!x)G=v;else{v=x+12|0;f[v>>2]=(f[v>>2]|0)+1;G=f[t>>2]|0}if((G|0)<3){G=f[a+44>>2]|0;v=f[F>>2]|0;f[v>>2]=f[G>>2];f[v+4>>2]=f[G+4>>2]}else{f[w>>2]=0;U$(i,a)}G=f[t>>2]|0;v=f[a+40>>2]|0;if((G|0)<3){a=f[v>>2]|0;f[j>>2]=f[v+4>>2];f[j+4>>2]=a;wS(c,j,C,-1,0,0)}else xS(c,G,v,C,-1,0,0);do if((eS(c)|0)==65536){C=f[c+4>>2]|0;f[k>>2]=f[C>>2];v=k+4|0;G=C+4|0;f[v>>2]=f[G>>2];j=k+8|0;f[j>>2]=f[C+8>>2];f[k+12>>2]=f[C+12>>2];f[k+16>>2]=f[C+16>>2];f[k+20>>2]=f[C+20>>2];f[k+24>>2]=f[C+24>>2];f[k+28>>2]=f[C+28>>2];f[k+32>>2]=f[C+32>>2];a=f[C+36>>2]|0;f[k+36>>2]=a;f[k+40>>2]=j;j=k+48|0;x=k+44|0;f[x>>2]=j;f[j>>2]=0;f[k+52>>2]=0;if(a|0){j=a+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[G>>2]|0)<3){G=f[C+44>>2]|0;j=f[x>>2]|0;f[j>>2]=f[G>>2];f[j+4>>2]=f[G+4>>2];break}else{f[v>>2]=0;U$(k,C);break}}else bS(k,c,-1);while(0);if(B)H=f[37636+(E<<5)+(d<<2)>>2]|0;else H=IT(d,E)|0;p[l>>3]=e;p[l+8>>3]=g;E=((f[D>>2]|0)>>>3&511)+1|0;if(!H){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=9;D=m;d=264557;B=D+9|0;do{b[D>>0]=b[d>>0]|0;D=D+1|0;d=d+1|0}while((D|0)<(B|0));b[m+9>>0]=0;vM(-215,m,235629,235639,448)}if((f[t>>2]|0)<3){m0(m,i,k,E);t=f[y>>2]|0;d=f[z>>2]|0;D=f[k+16>>2]|0;B=f[k+48>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];wi[H&255](t,d,0,0,D,B,n,l)}else{f[m>>2]=i;f[m+4>>2]=k;f[m+8>>2]=0;n=o;f[n>>2]=0;f[n+4>>2]=0;BL(q,m,o,-1);m=Y(f[q+20>>2]|0,E)|0;E=q+16|0;n=o+4|0;B=r+4|0;D=0;while(1){if(D>>>0>=(f[E>>2]|0)>>>0)break;d=f[o>>2]|0;t=f[n>>2]|0;f[r>>2]=m;f[B>>2]=1;wi[H&255](d,1,0,0,t,1,r,l);CL(q)|0;D=D+1|0}}D=k+36|0;q=f[D>>2]|0;if(q|0?(l=q+12|0,q=f[l>>2]|0,f[l>>2]=q+-1,(q|0)==1):0)V$(k);f[D>>2]=0;D=k+16|0;q=k+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[q>>2]|0)>0){D=f[k+40>>2]|0;l=0;do{f[D+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))wL(q);q=f[s>>2]|0;if(q|0?(k=q+12|0,q=f[k>>2]|0,f[k>>2]=q+-1,(q|0)==1):0)V$(i);f[s>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[w>>2]|0)>0){y=f[A>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[w>>2]|0))}w=f[F>>2]|0;if((w|0)!=(z|0))wL(w);u=h;return}}vS(c);u=h;return}function eY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+192|0;e=d+128|0;g=d+64|0;h=d+48|0;i=d+120|0;j=d;k=d+8|0;l=d+40|0;switch(qS(a,-1)|0){case 5:{m=2;break}case 7:case 3:{n=133;o=5;break}default:{p=$Xc(32)|0;f[e>>2]=p;f[e+8>>2]=-2147483616;f[e+4>>2]=23;q=p;r=235792;s=q+23|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[p+23>>0]=0;vM(-210,e,235745,235639,495)}}if((m|0)==2)if(YS(c)|0){m=qS(c,-1)|0;if((m|4|0)!=7){p=$Xc(48)|0;f[e>>2]=p;f[e+8>>2]=-2147483600;f[e+4>>2]=36;q=p;r=235708;s=q+36|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[p+36>>0]=0;vM(-215,e,235745,235639,482)}p=rS(c,-1)|0;if((p|0)==(rS(a,-1)|0)){n=147;o=m}else{m=$Xc(48)|0;f[e>>2]=m;f[e+8>>2]=-2147483600;f[e+4>>2]=34;q=m;r=235757;s=q+34|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[m+34>>0]=0;vM(-215,e,235745,235639,483)}}else{n=147;o=3}do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[e>>2]=f[m>>2];r=e+4|0;q=m+4|0;f[r>>2]=f[q>>2];s=e+8|0;f[s>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[e+32>>2]=f[m+32>>2];p=f[m+36>>2]|0;f[e+36>>2]=p;t=e+40|0;f[t>>2]=s;s=e+48|0;v=e+44|0;f[v>>2]=s;f[s>>2]=0;f[e+52>>2]=0;if(p|0){s=p+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[q>>2]|0)<3){q=f[m+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[q>>2];f[s+4>>2]=f[q+4>>2];w=r;x=t;y=e;break}else{f[r>>2]=0;U$(e,m);w=r;x=t;y=e;break}}else{bS(e,a,-1);w=e+4|0;x=e+40|0;y=e}while(0);xS(c,f[w>>2]|0,f[x>>2]|0,f[y>>2]&4088|o&7,-1,0,0);do if((eS(c)|0)==65536){o=f[c+4>>2]|0;f[g>>2]=f[o>>2];a=g+4|0;t=o+4|0;f[a>>2]=f[t>>2];r=g+8|0;f[r>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];m=f[o+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=r;r=g+48|0;q=g+44|0;f[q>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(m|0){r=m+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[t>>2]|0)<3){t=f[o+44>>2]|0;r=f[q>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2];break}else{f[a>>2]=0;U$(g,o);break}}else bS(g,c,-1);while(0);c=((f[y>>2]|0)>>>3&511)+1|0;if((f[w>>2]|0)<3){m0(h,e,g,c);y=f[e+16>>2]|0;o=f[e+48>>2]|0;a=f[g+16>>2]|0;t=f[g+48>>2]|0;f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];wi[n&255](y,o,0,0,a,t,i,0)}else{f[h>>2]=e;f[h+4>>2]=g;f[h+8>>2]=0;i=j;f[i>>2]=0;f[i+4>>2]=0;BL(k,h,j,-1);h=Y(f[k+20>>2]|0,c)|0;c=k+16|0;i=j+4|0;t=l+4|0;a=0;while(1){if(a>>>0>=(f[c>>2]|0)>>>0)break;o=f[j>>2]|0;y=f[i>>2]|0;f[l>>2]=h;f[t>>2]=1;wi[n&255](o,0,0,0,y,0,l,0);CL(k)|0;a=a+1|0}}a=g+36|0;k=f[a>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)V$(g);f[a>>2]=0;a=g+16|0;k=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[k>>2]|0)>0){a=f[g+40>>2]|0;l=0;do{f[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[g+44>>2]|0;if((k|0)!=(g+48|0))wL(k);k=e+36|0;g=f[k>>2]|0;if(g|0?(l=g+12|0,g=f[l>>2]|0,f[l>>2]=g+-1,(g|0)==1):0)V$(e);f[k>>2]=0;k=e+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[w>>2]|0)>0){k=f[x>>2]|0;x=0;do{f[k+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[w>>2]|0))}w=f[e+44>>2]|0;if((w|0)==(e+48|0)){u=d;return}wL(w);u=d;return}function fY(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[c>>2]|0;a:do if((h|0)==1){if((e|0)==1){o1c(g|0,a|0,d|0)|0;i=1;break}if((d|0)>0){j=0;k=0;while(1){b[g+j>>0]=b[a+k>>0]|0;j=j+1|0;if((j|0)==(d|0)){i=1;break}else k=k+e|0}}else return}else{k=f[c+4>>2]|0;if((h|0)==2)if((d|0)>0){j=0;l=0;while(1){b[g+l>>0]=b[a+j>>0]|0;b[k+l>>0]=b[a+(j+1)>>0]|0;l=l+1|0;if((l|0)==(d|0)){i=2;break a}else j=j+e|0}}else return;j=f[c+8>>2]|0;if((h|0)==3)if((d|0)>0){l=0;m=0;while(1){b[g+m>>0]=b[a+l>>0]|0;b[k+m>>0]=b[a+(l+1)>>0]|0;b[j+m>>0]=b[a+(l+2)>>0]|0;m=m+1|0;if((m|0)==(d|0)){i=3;break}else l=l+e|0}}else return;else{l=f[c+12>>2]|0;if((d|0)>0){m=0;n=0;while(1){b[g+n>>0]=b[a+m>>0]|0;b[k+n>>0]=b[a+(m+1)>>0]|0;b[j+n>>0]=b[a+(m+2)>>0]|0;b[l+n>>0]=b[a+(m+3)>>0]|0;n=n+1|0;if((n|0)==(d|0)){i=h;break}else m=m+e|0}}else return}}while(0);if((d|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[c+(o<<2)>>2]|0;h=f[c+(o+1<<2)>>2]|0;g=f[c+(o+2<<2)>>2]|0;m=f[c+(o+3<<2)>>2]|0;n=o;l=0;while(1){b[i+l>>0]=b[a+n>>0]|0;b[h+l>>0]=b[a+(n+1)>>0]|0;b[g+l>>0]=b[a+(n+2)>>0]|0;b[m+l>>0]=b[a+(n+3)>>0]|0;l=l+1|0;if((l|0)==(d|0))break;else n=n+e|0}o=o+4|0}while((o|0)<(e|0));return}function gY(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[b>>2]|0;a:do if((h|0)==1){if((e|0)==1){o1c(g|0,a|0,c<<1|0)|0;i=1;break}if((c|0)>0){j=0;k=0;while(1){d[g+(j<<1)>>1]=d[a+(k<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0)){i=1;break}else k=k+e|0}}else return}else{k=f[b+4>>2]|0;if((h|0)==2)if((c|0)>0){j=0;l=0;while(1){d[g+(l<<1)>>1]=d[a+(j<<1)>>1]|0;d[k+(l<<1)>>1]=d[a+(j+1<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0)){i=2;break a}else j=j+e|0}}else return;j=f[b+8>>2]|0;if((h|0)==3)if((c|0)>0){l=0;m=0;while(1){d[g+(m<<1)>>1]=d[a+(l<<1)>>1]|0;d[k+(m<<1)>>1]=d[a+(l+1<<1)>>1]|0;d[j+(m<<1)>>1]=d[a+(l+2<<1)>>1]|0;m=m+1|0;if((m|0)==(c|0)){i=3;break}else l=l+e|0}}else return;else{l=f[b+12>>2]|0;if((c|0)>0){m=0;n=0;while(1){d[g+(n<<1)>>1]=d[a+(m<<1)>>1]|0;d[k+(n<<1)>>1]=d[a+(m+1<<1)>>1]|0;d[j+(n<<1)>>1]=d[a+(m+2<<1)>>1]|0;d[l+(n<<1)>>1]=d[a+(m+3<<1)>>1]|0;n=n+1|0;if((n|0)==(c|0)){i=h;break}else m=m+e|0}}else return}}while(0);if((c|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[b+(o<<2)>>2]|0;h=f[b+(o+1<<2)>>2]|0;g=f[b+(o+2<<2)>>2]|0;m=f[b+(o+3<<2)>>2]|0;n=o;l=0;while(1){d[i+(l<<1)>>1]=d[a+(n<<1)>>1]|0;d[h+(l<<1)>>1]=d[a+(n+1<<1)>>1]|0;d[g+(l<<1)>>1]=d[a+(n+2<<1)>>1]|0;d[m+(l<<1)>>1]=d[a+(n+3<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0))break;else n=n+e|0}o=o+4|0}while((o|0)<(e|0));return}function hY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){o1c(e|0,a|0,c<<2|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){f[e+(i<<2)>>2]=f[a+(j<<2)>>2];i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;k=0;while(1){f[e+(k<<2)>>2]=f[a+(i<<2)>>2];f[j+(k<<2)>>2]=f[a+(i+1<<2)>>2];k=k+1|0;if((k|0)==(c|0)){h=2;break a}else i=i+d|0}}else return;i=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){k=0;l=0;while(1){f[e+(l<<2)>>2]=f[a+(k<<2)>>2];f[j+(l<<2)>>2]=f[a+(k+1<<2)>>2];f[i+(l<<2)>>2]=f[a+(k+2<<2)>>2];l=l+1|0;if((l|0)==(c|0)){h=3;break}else k=k+d|0}}else return;else{k=f[b+12>>2]|0;if((c|0)>0){l=0;m=0;while(1){f[e+(m<<2)>>2]=f[a+(l<<2)>>2];f[j+(m<<2)>>2]=f[a+(l+1<<2)>>2];f[i+(m<<2)>>2]=f[a+(l+2<<2)>>2];f[k+(m<<2)>>2]=f[a+(l+3<<2)>>2];m=m+1|0;if((m|0)==(c|0)){h=g;break}else l=l+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))n=h;else return;do{h=f[b+(n<<2)>>2]|0;g=f[b+(n+1<<2)>>2]|0;e=f[b+(n+2<<2)>>2]|0;l=f[b+(n+3<<2)>>2]|0;m=n;k=0;while(1){f[h+(k<<2)>>2]=f[a+(m<<2)>>2];f[g+(k<<2)>>2]=f[a+(m+1<<2)>>2];f[e+(k<<2)>>2]=f[a+(m+2<<2)>>2];f[l+(k<<2)>>2]=f[a+(m+3<<2)>>2];k=k+1|0;if((k|0)==(c|0))break;else m=m+d|0}n=n+4|0}while((n|0)<(d|0));return}function iY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){o1c(e|0,a|0,c<<3|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){k=a+(j<<3)|0;l=f[k+4>>2]|0;m=e+(i<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=l;i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;l=0;while(1){m=a+(i<<3)|0;k=f[m+4>>2]|0;n=e+(l<<3)|0;f[n>>2]=f[m>>2];f[n+4>>2]=k;k=a+(i+1<<3)|0;n=f[k+4>>2]|0;m=j+(l<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=n;l=l+1|0;if((l|0)==(c|0)){h=2;break a}else i=i+d|0}}else return;i=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){l=0;n=0;while(1){m=a+(l<<3)|0;k=f[m+4>>2]|0;o=e+(n<<3)|0;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=a+(l+1<<3)|0;o=f[k+4>>2]|0;m=j+(n<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=o;o=a+(l+2<<3)|0;m=f[o+4>>2]|0;k=i+(n<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=m;n=n+1|0;if((n|0)==(c|0)){h=3;break}else l=l+d|0}}else return;else{l=f[b+12>>2]|0;if((c|0)>0){n=0;m=0;while(1){k=a+(n<<3)|0;o=f[k+4>>2]|0;p=e+(m<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;o=a+(n+1<<3)|0;p=f[o+4>>2]|0;k=j+(m<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=p;p=a+(n+2<<3)|0;k=f[p+4>>2]|0;o=i+(m<<3)|0;f[o>>2]=f[p>>2];f[o+4>>2]=k;k=a+(n+3<<3)|0;o=f[k+4>>2]|0;p=l+(m<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;m=m+1|0;if((m|0)==(c|0)){h=g;break}else n=n+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))q=h;else return;do{h=f[b+(q<<2)>>2]|0;g=f[b+(q+1<<2)>>2]|0;e=f[b+(q+2<<2)>>2]|0;n=f[b+(q+3<<2)>>2]|0;m=q;l=0;while(1){i=a+(m<<3)|0;j=f[i+4>>2]|0;o=h+(l<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=j;j=a+(m+1<<3)|0;o=f[j+4>>2]|0;i=g+(l<<3)|0;f[i>>2]=f[j>>2];f[i+4>>2]=o;o=a+(m+2<<3)|0;i=f[o+4>>2]|0;j=e+(l<<3)|0;f[j>>2]=f[o>>2];f[j+4>>2]=i;i=a+(m+3<<3)|0;j=f[i+4>>2]|0;o=n+(l<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=j;l=l+1|0;if((l|0)==(c|0))break;else m=m+d|0}q=q+4|0}while((q|0)<(d|0));return}function jY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=u;u=u+1104|0;d=c+1080|0;e=c+40|0;g=c+8|0;h=c;i=f[a>>2]|0;j=i&7;k=i>>>3&511;i=k+1|0;if(!k){l=d+8|0;f[l>>2]=0;f[l+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;jR(a,d);u=c;return}l=a+4|0;m=a+40|0;n=0;do{S$(b+(n*56|0)|0,f[l>>2]|0,f[m>>2]|0,j);n=n+1|0}while((n|0)!=(i|0));n=f[37892+(j<<2)>>2]|0;j=f[l>>2]|0;if((j|0)>0)o=f[(f[a+44>>2]|0)+(j+-1<<2)>>2]|0;else o=0;j=675553809>>>(f[a>>2]<<2&28)&15;f[d>>2]=((o+1023|0)>>>0)/(o>>>0)|0;l=k+2|0;k=(l<<3)+16|0;m=e+8|0;f[e>>2]=m;p=e+4|0;f[p>>2]=k;if(k>>>0>1032){q=bYc(k)|0;f[e>>2]=q;r=q}else r=m;q=r+(i<<2)+4+15&-16;k=q;f[r>>2]=a;a=0;do{s=a;a=a+1|0;f[r+(a<<2)>>2]=b+(s*56|0)}while((a|0)!=(i|0));a=q;BL(g,r,a,l);l=f[g+20>>2]|0;f[h>>2]=l;r=536870911/(i>>>0)|0;if(i>>>0<5)t=l;else{q=f[d>>2]|0;t=q>>>0<l>>>0?q:f[h>>2]|0}q=t>>>0<r>>>0?t:r;r=g+16|0;t=k+4|0;d=l;b=l;l=0;while(1){if(l>>>0>=(f[r>>2]|0)>>>0)break;if(!d){v=0;w=b}else{s=d;x=b;y=0;while(1){z=s-y|0;A=q>>>0<z>>>0?q:z;ei[n&511](f[a>>2]|0,t,A,i);y=y+q|0;if(y>>>0<x>>>0){z=Y(o,A)|0;f[a>>2]=(f[a>>2]|0)+z;z=Y(j,A)|0;A=0;do{A=A+1|0;B=k+(A<<2)|0;f[B>>2]=(f[B>>2]|0)+z}while((A|0)!=(i|0));C=f[h>>2]|0}else C=x;if(C>>>0<=y>>>0){v=C;w=C;break}else{s=C;x=C}}}CL(g)|0;d=v;b=w;l=l+1|0}l=f[e>>2]|0;if((l|0)!=(m|0)){if(l|0)dYc(l);f[e>>2]=m;f[p>>2]=1032}u=c;return}function kY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+80|0;e=d+16|0;g=d;do if((eS(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];l=e+16|0;f[l>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];m=f[h+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=k;k=e+48|0;n=e+44|0;f[n>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(m|0){k=m+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=l;break}else{f[i>>2]=0;U$(e,h);o=l;break}}else{bS(e,a,-1);o=e+16|0}while(0);if(f[o>>2]|0){a=e+4|0;l=f[a>>2]|0;if((l|0)<3)p=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{h=f[e+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(l|0)){p=k;break}else j=k}}if(!((l|0)==0|(p|0)==0)){if((YS(c)|0?!(sS(c)|0):0)?(p=dS(c,-1)|0,(p|0)!=(f[e>>2]&7|0)):0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;p=$Xc(64)|0;f[g>>2]=p;f[g+8>>2]=-2147483584;f[g+4>>2]=58;l=p;j=235816;i=l+58|0;do{b[l>>0]=b[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(i|0));b[p+58>>0]=0;vM(-215,g,375209,235875,404)}p=f[e>>2]|0;j=p&7;l=p>>>3&511;ZS(c,l+1|0,1,j,-1,0,0);p=e+40|0;i=0;while(1){xS(c,f[a>>2]|0,f[p>>2]|0,j,i,0,0);if((i|0)<(l|0))i=i+1|0;else break}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;gS(c,g);jY(e,f[g>>2]|0);hx(g)}else q=14}else q=14;if((q|0)==14)vS(c);c=e+36|0;q=f[c>>2]|0;if(q|0?(g=q+12|0,q=f[g>>2]|0,f[g>>2]=q+-1,(q|0)==1):0)V$(e);f[c>>2]=0;c=e+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[c>>2]|0)>0){o=f[e+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[c>>2]|0))}c=f[e+44>>2]|0;if((c|0)==(e+48|0)){u=d;return}wL(c);u=d;return}function lY(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){Tj(v,l,m,p,a,b);b=r+36|0;a=f[b>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)V$(r);f[b>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){m=f[H>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[C>>2]|0))}f[r>>2]=f[v>>2];l=v+4|0;m=f[l>>2]|0;f[C>>2]=m;U=v+8|0;f[G>>2]=f[U>>2];f[r+12>>2]=f[v+12>>2];V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=v+36|0;f[b>>2]=f[a>>2];b=r+44|0;W=f[b>>2]|0;if((W|0)==(K|0))X=m;else{wL(W);f[b>>2]=K;f[H>>2]=G;X=f[l>>2]|0}W=v+44|0;if((X|0)<3){X=f[W>>2]|0;f[K>>2]=f[X>>2];f[r+52>>2]=f[X+4>>2];Y=X}else{f[b>>2]=f[W>>2];b=v+40|0;f[r+40>>2]=f[b>>2];X=v+48|0;f[W>>2]=X;f[b>>2]=U;Y=X}f[v>>2]=1124007936;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[a>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((Y|0)!=(v+48|0))wL(Y)}if(c|0){Tj(v,B,E,p,c,d);d=s+36|0;c=f[d>>2]|0;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)V$(s);f[d>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){E=f[O>>2]|0;B=0;do{f[E+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[M>>2]|0))}f[s>>2]=f[v>>2];B=v+4|0;E=f[B>>2]|0;f[M>>2]=E;Y=v+8|0;f[N>>2]=f[Y>>2];f[s+12>>2]=f[v+12>>2];V=v+16|0;f[c>>2]=f[V>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=v+36|0;f[d>>2]=f[c>>2];d=s+44|0;a=f[d>>2]|0;if((a|0)==(P|0))Z=E;else{wL(a);f[d>>2]=P;f[O>>2]=N;Z=f[B>>2]|0}a=v+44|0;if((Z|0)<3){Z=f[a>>2]|0;f[P>>2]=f[Z>>2];f[s+52>>2]=f[Z+4>>2];_=Z}else{f[d>>2]=f[a>>2];d=v+40|0;f[s+40>>2]=f[d>>2];Z=v+48|0;f[a>>2]=Z;f[d>>2]=Y;_=Z}f[v>>2]=1124007936;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;f[B+24>>2]=0;f[B+28>>2]=0;f[c>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((_|0)!=(v+48|0))wL(_)}if((g|0)!=0&i!=0.0){Tj(v,A,F,p,g,h);h=t+36|0;g=f[h>>2]|0;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)V$(t);f[h>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){F=f[T>>2]|0;A=0;do{f[F+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[R>>2]|0))}f[t>>2]=f[v>>2];A=v+4|0;F=f[A>>2]|0;f[R>>2]=F;_=v+8|0;f[S>>2]=f[_>>2];f[t+12>>2]=f[v+12>>2];V=v+16|0;f[g>>2]=f[V>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=v+36|0;f[h>>2]=f[g>>2];h=t+44|0;c=f[h>>2]|0;if((c|0)==(I|0))$=F;else{wL(c);f[h>>2]=I;f[T>>2]=S;$=f[A>>2]|0}c=v+44|0;if(($|0)<3){$=f[c>>2]|0;f[I>>2]=f[$>>2];f[t+52>>2]=f[$+4>>2];aa=$}else{f[h>>2]=f[c>>2];h=v+40|0;f[t+40>>2]=f[h>>2];$=v+48|0;f[c>>2]=$;f[h>>2]=_;aa=$}f[v>>2]=1124007936;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+20>>2]=0;f[A+24>>2]=0;f[A+28>>2]=0;f[g>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((aa|0)!=(v+48|0))wL(aa)}Tj(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;aa=r+36|0;V=f[aa>>2]|0;f[D>>2]=V;g=w+40|0;f[g>>2]=p;p=w+48|0;A=w+44|0;f[A>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!V)ba=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;ba=f[C>>2]|0}if((ba|0)<3){ba=f[L>>2]|0;j=f[A>>2]|0;f[j>>2]=f[ba>>2];f[j+4>>2]=f[ba+4>>2]}else{f[k>>2]=0;U$(w,r)}f[x>>2]=f[s>>2];ba=x+4|0;j=f[M>>2]|0;f[ba>>2]=j;V=x+8|0;f[V>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;$=s+16|0;f[N>>2]=f[$>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];_=x+36|0;h=s+36|0;c=f[h>>2]|0;f[_>>2]=c;F=x+40|0;f[F>>2]=V;V=x+48|0;B=x+44|0;f[B>>2]=V;f[V>>2]=0;f[x+52>>2]=0;if(!c)ca=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;ca=f[M>>2]|0}if((ca|0)<3){ca=f[Q>>2]|0;j=f[B>>2]|0;f[j>>2]=f[ca>>2];f[j+4>>2]=f[ca+4>>2]}else{f[ba>>2]=0;U$(x,s)}f[y>>2]=f[t>>2];ca=y+4|0;j=f[R>>2]|0;f[ca>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;Z=t+16|0;f[S>>2]=f[Z>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];Y=y+36|0;d=t+36|0;a=f[d>>2]|0;f[Y>>2]=a;E=y+40|0;f[E>>2]=c;c=y+48|0;l=y+44|0;f[l>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!a)da=j;else{j=a+12|0;f[j>>2]=(f[j>>2]|0)+1;da=f[R>>2]|0}if((da|0)<3){da=f[J>>2]|0;j=f[l>>2]|0;f[j>>2]=f[da>>2];f[j+4>>2]=f[da+4>>2]}else{f[ca>>2]=0;U$(y,t)}f[z>>2]=f[v>>2];da=z+4|0;j=v+4|0;a=f[j>>2]|0;f[da>>2]=a;X=z+8|0;f[X>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];U=z+16|0;b=v+16|0;f[U>>2]=f[b>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];W=z+36|0;m=v+36|0;ea=f[m>>2]|0;f[W>>2]=ea;fa=z+40|0;f[fa>>2]=X;X=z+48|0;ga=z+44|0;f[ga>>2]=X;f[X>>2]=0;f[z+52>>2]=0;if(!ea)ha=a;else{a=ea+12|0;f[a>>2]=(f[a>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;a=f[ga>>2]|0;f[a>>2]=f[ha>>2];f[a+4>>2]=f[ha+4>>2]}else{f[da>>2]=0;U$(z,v)}mY(w,x,e,y,i,z,o);o=f[W>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)V$(z);f[W>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[da>>2]|0)>0){U=f[fa>>2]|0;fa=0;do{f[U+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[da>>2]|0))}da=f[ga>>2]|0;if((da|0)!=(X|0))wL(da);da=f[Y>>2]|0;if(da|0?(X=da+12|0,da=f[X>>2]|0,f[X>>2]=da+-1,(da|0)==1):0)V$(y);f[Y>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[ca>>2]|0)>0){S=f[E>>2]|0;E=0;do{f[S+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[ca>>2]|0))}ca=f[l>>2]|0;if((ca|0)!=(c|0))wL(ca);ca=f[_>>2]|0;if(ca|0?(c=ca+12|0,ca=f[c>>2]|0,f[c>>2]=ca+-1,(ca|0)==1):0)V$(x);f[_>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[ba>>2]|0)>0){N=f[F>>2]|0;F=0;do{f[N+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[ba>>2]|0))}ba=f[B>>2]|0;if((ba|0)!=(V|0))wL(ba);ba=f[D>>2]|0;do if(ba|0){V=ba+12|0;B=f[V>>2]|0;f[V>>2]=B+-1;if((B|0)!=1)break;V$(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[g>>2]|0;g=0;do{f[G+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[k>>2]|0))}k=f[A>>2]|0;if((k|0)!=(p|0))wL(k);k=f[m>>2]|0;do if(k|0){p=k+12|0;A=f[p>>2]|0;f[p>>2]=A+-1;if((A|0)!=1)break;V$(v)}while(0);f[m>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){b=f[v+40>>2]|0;m=0;do{f[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))wL(j);j=f[d>>2]|0;do if(j|0){v=j+12|0;m=f[v>>2]|0;f[v>>2]=m+-1;if((m|0)!=1)break;V$(t)}while(0);f[d>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[R>>2]|0)>0){Z=f[T>>2]|0;T=0;do{f[Z+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))wL(R);R=f[h>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;V$(s)}while(0);f[h>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[M>>2]|0)>0){$=f[O>>2]|0;O=0;do{f[$+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))wL(M);M=f[aa>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;V$(r)}while(0);f[aa>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}wL(C);u=q;return}function mY(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0;j=u;u=u+1120|0;k=j+72|0;l=j+56|0;m=j+48|0;o=j+40|0;q=j+32|0;r=j+24|0;s=j+16|0;t=j+8|0;v=j;w=f[a+40>>2]|0;x=f[w+4>>2]|0;y=f[w>>2]|0;w=f[a>>2]|0;z=w&4095;switch(i&3){case 0:{A=c+8|0;B=c+12|0;C=y;break}case 1:{A=c+8|0;B=c+12|0;C=x;break}case 2:{A=c+12|0;B=c+8|0;C=y;break}case 3:{A=c+12|0;B=c+8|0;C=x;break}default:{}}D=f[B>>2]|0;B=f[A>>2]|0;a:do if((i|0)==0&(B+-2|0)>>>0<3?(B|0)==(D|0)|(B|0)==(C|0):0){switch(w&4095){case 5:{A=f[h+16>>2]|0;E=f[a+16>>2]|0;F=f[c+16>>2]|0;G=f[e+16>>2]|0;H=f[h+48>>2]|0;I=H>>>2;J=f[a+48>>2]|0;K=J>>>2;L=f[c+48>>2]|0;M=L>>>2;if(!G)N=0;else N=(f[e+48>>2]|0)>>>2;O=(G|0)==0?544700:G;switch(B|0){case 2:{if(!((D|0)!=2|(F|0)==(A|0))){if((C|0)<=0){u=j;return}P=F+(M<<2)|0;Q=F+4|0;R=F+(M+1<<2)|0;S=0;T=A;U=E;V=O;while(1){W=+n[U>>2];X=+n[U+4>>2];Z=W*+n[Q>>2]+X*+n[R>>2];n[T>>2]=(W*+n[F>>2]+X*+n[P>>2])*d+ +n[V>>2]*g;n[T+4>>2]=Z*d+ +n[V+4>>2]*g;S=S+1|0;if((S|0)==(C|0))break;else{T=T+(I<<2)|0;U=U+(K<<2)|0;V=V+(N<<2)|0}}u=j;return}if((E|0)!=(A|0)){V=(O|0)==544700;U=(V^1)&1;T=V?1:N;if((D|0)<=0){u=j;return}V=E+4|0;S=E+(K<<2)|0;P=E+(K+1<<2)|0;R=F;Q=0;_=A;$=O;while(1){Z=+n[R>>2];X=+n[R+(M<<2)>>2];W=Z*+n[S>>2]+X*+n[P>>2];n[_>>2]=(+n[E>>2]*Z+ +n[V>>2]*X)*d+ +n[$>>2]*g;n[_+(I<<2)>>2]=W*d+ +n[$+(T<<2)>>2]*g;Q=Q+1|0;if((Q|0)==(D|0))break;else{R=R+4|0;_=_+4|0;$=$+(U<<2)|0}}u=j;return}break}case 3:{if(!((D|0)!=3|(F|0)==(A|0))){if((C|0)<=0){u=j;return}U=F+(M<<2)|0;$=M<<1;_=F+($<<2)|0;R=F+4|0;Q=F+(M+1<<2)|0;T=F+(($|1)<<2)|0;V=F+8|0;P=F+(M+2<<2)|0;S=F+($+2<<2)|0;$=E;aa=0;ba=A;ca=O;while(1){W=+n[$>>2];X=+n[$+4>>2];Z=+n[$+8>>2];da=W*+n[R>>2]+X*+n[Q>>2]+Z*+n[T>>2];ea=W*+n[V>>2]+X*+n[P>>2]+Z*+n[S>>2];n[ba>>2]=(W*+n[F>>2]+X*+n[U>>2]+Z*+n[_>>2])*d+ +n[ca>>2]*g;n[ba+4>>2]=da*d+ +n[ca+4>>2]*g;n[ba+8>>2]=ea*d+ +n[ca+8>>2]*g;aa=aa+1|0;if((aa|0)==(C|0))break;else{$=$+(K<<2)|0;ba=ba+(I<<2)|0;ca=ca+(N<<2)|0}}u=j;return}if((E|0)!=(A|0)){ca=(O|0)==544700;ba=(ca^1)&1;$=ca?1:N;if((D|0)<=0){u=j;return}ca=E+4|0;aa=E+8|0;_=M<<1;U=E+(K<<2)|0;S=E+(K+1<<2)|0;P=E+(K+2<<2)|0;V=K<<1;T=E+(V<<2)|0;Q=E+((V|1)<<2)|0;R=E+(V+2<<2)|0;V=$<<1;fa=I<<1;ga=F;ha=0;ia=A;ja=O;while(1){ea=+n[ga>>2];da=+n[ga+(M<<2)>>2];Z=+n[ga+(_<<2)>>2];X=ea*+n[U>>2]+da*+n[S>>2]+Z*+n[P>>2];W=ea*+n[T>>2]+da*+n[Q>>2]+Z*+n[R>>2];n[ia>>2]=(+n[E>>2]*ea+ +n[ca>>2]*da+ +n[aa>>2]*Z)*d+ +n[ja>>2]*g;n[ia+(I<<2)>>2]=X*d+ +n[ja+($<<2)>>2]*g;n[ia+(fa<<2)>>2]=W*d+ +n[ja+(V<<2)>>2]*g;ha=ha+1|0;if((ha|0)==(D|0))break;else{ga=ga+4|0;ia=ia+4|0;ja=ja+(ba<<2)|0}}u=j;return}break}case 4:{if(!((D|0)!=4|(F|0)==(A|0))){if((C|0)<=0){u=j;return}ba=F+(M<<2)|0;ja=M<<1;ia=F+(ja<<2)|0;ga=M*3|0;ha=F+(ga<<2)|0;V=F+4|0;fa=F+(M+1<<2)|0;$=F+((ja|1)<<2)|0;aa=F+(ga+1<<2)|0;ca=F+8|0;R=F+(M+2<<2)|0;Q=F+(ja+2<<2)|0;T=F+(ga+2<<2)|0;P=F+12|0;S=F+(M+3<<2)|0;U=F+(ja+3<<2)|0;ja=F+(ga+3<<2)|0;ga=E;_=0;ka=A;la=O;while(1){W=+n[ga>>2];X=+n[ga+4>>2];Z=+n[ga+8>>2];da=+n[ga+12>>2];ea=W*+n[V>>2]+X*+n[fa>>2]+Z*+n[$>>2]+da*+n[aa>>2];ma=W*+n[ca>>2]+X*+n[R>>2]+Z*+n[Q>>2]+da*+n[T>>2];na=W*+n[P>>2]+X*+n[S>>2]+Z*+n[U>>2]+da*+n[ja>>2];n[ka>>2]=(W*+n[F>>2]+X*+n[ba>>2]+Z*+n[ia>>2]+da*+n[ha>>2])*d+ +n[la>>2]*g;n[ka+4>>2]=ea*d+ +n[la+4>>2]*g;n[ka+8>>2]=ma*d+ +n[la+8>>2]*g;n[ka+12>>2]=na*d+ +n[la+12>>2]*g;_=_+1|0;if((_|0)==(C|0))break;else{ga=ga+(K<<2)|0;ka=ka+(I<<2)|0;la=la+(N<<2)|0}}u=j;return}if((E|0)!=(A|0)){la=(O|0)==544700;ka=(la^1)&1;ga=la?1:N;if((D|0)<=0){u=j;return}la=E+4|0;_=E+8|0;ha=M<<1;ia=E+12|0;ba=M*3|0;ja=E+(K<<2)|0;U=E+(K+1<<2)|0;S=E+(K+2<<2)|0;P=E+(K+3<<2)|0;T=K<<1;Q=E+(T<<2)|0;R=E+((T|1)<<2)|0;ca=E+(T+2<<2)|0;aa=E+(T+3<<2)|0;T=K*3|0;$=E+(T<<2)|0;fa=E+(T+1<<2)|0;V=E+(T+2<<2)|0;oa=E+(T+3<<2)|0;T=ga<<1;pa=I<<1;qa=ga*3|0;ra=I*3|0;sa=F;ta=0;ua=A;va=O;while(1){na=+n[sa>>2];ma=+n[sa+(M<<2)>>2];ea=+n[sa+(ha<<2)>>2];da=+n[sa+(ba<<2)>>2];Z=na*+n[ja>>2]+ma*+n[U>>2]+ea*+n[S>>2]+da*+n[P>>2];X=na*+n[Q>>2]+ma*+n[R>>2]+ea*+n[ca>>2]+da*+n[aa>>2];W=na*+n[$>>2]+ma*+n[fa>>2]+ea*+n[V>>2]+da*+n[oa>>2];n[ua>>2]=(+n[E>>2]*na+ +n[la>>2]*ma+ +n[_>>2]*ea+ +n[ia>>2]*da)*d+ +n[va>>2]*g;n[ua+(I<<2)>>2]=Z*d+ +n[va+(ga<<2)>>2]*g;n[ua+(pa<<2)>>2]=X*d+ +n[va+(T<<2)>>2]*g;n[ua+(ra<<2)>>2]=W*d+ +n[va+(qa<<2)>>2]*g;ta=ta+1|0;if((ta|0)==(D|0))break;else{sa=sa+4|0;ua=ua+4|0;va=va+(ka<<2)|0}}u=j;return}break}default:{}}if((z|0)==6){wa=H;xa=J;ya=L;za=G;Aa=G;Ba=F;Ca=A;Da=E}else break a;break}case 6:{ka=f[e+16>>2]|0;wa=f[h+48>>2]|0;xa=f[a+48>>2]|0;ya=f[c+48>>2]|0;za=ka;Aa=ka;Ba=f[c+16>>2]|0;Ca=f[h+16>>2]|0;Da=f[a+16>>2]|0;break}default:break a}ka=wa>>>3;va=xa>>>3;ua=ya>>>3;if(!za)Ea=0;else Ea=(f[e+48>>2]|0)>>>3;sa=(Aa|0)==0?53e4:Aa;switch(B|0){case 2:{if(!((D|0)!=2|(Ba|0)==(Ca|0))){if((C|0)<=0){u=j;return}ta=Ba+(ua<<3)|0;qa=Ba+8|0;ra=Ba+(ua+1<<3)|0;T=Ca;pa=Da;ga=sa;I=0;while(1){W=+p[pa>>3];X=+p[pa+8>>3];Z=W*+p[qa>>3]+X*+p[ra>>3];p[T>>3]=(W*+p[Ba>>3]+X*+p[ta>>3])*d+ +p[ga>>3]*g;p[T+8>>3]=Z*d+ +p[ga+8>>3]*g;I=I+1|0;if((I|0)==(C|0))break;else{T=T+(ka<<3)|0;pa=pa+(va<<3)|0;ga=ga+(Ea<<3)|0}}u=j;return}if((Da|0)==(Ca|0))break a;ga=(sa|0)==53e4;pa=(ga^1)&1;T=ga?1:Ea;if((D|0)<=0){u=j;return}ga=Da+8|0;I=Da+(va<<3)|0;ta=Da+(va+1<<3)|0;ra=Ba;qa=Ca;E=sa;A=0;while(1){Z=+p[ra>>3];X=+p[ra+(ua<<3)>>3];W=Z*+p[I>>3]+X*+p[ta>>3];p[qa>>3]=(+p[Da>>3]*Z+ +p[ga>>3]*X)*d+ +p[E>>3]*g;p[qa+(ka<<3)>>3]=W*d+ +p[E+(T<<3)>>3]*g;A=A+1|0;if((A|0)==(D|0))break;else{ra=ra+8|0;qa=qa+8|0;E=E+(pa<<3)|0}}u=j;return}case 3:{if(!((D|0)!=3|(Ba|0)==(Ca|0))){if((C|0)<=0){u=j;return}pa=Ba+(ua<<3)|0;E=ua<<1;qa=Ba+(E<<3)|0;ra=Ba+8|0;A=Ba+(ua+1<<3)|0;T=Ba+((E|1)<<3)|0;ga=Ba+16|0;ta=Ba+(ua+2<<3)|0;I=Ba+(E+2<<3)|0;E=Da;F=Ca;G=sa;L=0;while(1){W=+p[E>>3];X=+p[E+8>>3];Z=+p[E+16>>3];da=W*+p[ra>>3]+X*+p[A>>3]+Z*+p[T>>3];ea=W*+p[ga>>3]+X*+p[ta>>3]+Z*+p[I>>3];p[F>>3]=(W*+p[Ba>>3]+X*+p[pa>>3]+Z*+p[qa>>3])*d+ +p[G>>3]*g;p[F+8>>3]=da*d+ +p[G+8>>3]*g;p[F+16>>3]=ea*d+ +p[G+16>>3]*g;L=L+1|0;if((L|0)==(C|0))break;else{E=E+(va<<3)|0;F=F+(ka<<3)|0;G=G+(Ea<<3)|0}}u=j;return}if((Da|0)==(Ca|0))break a;G=(sa|0)==53e4;F=(G^1)&1;E=G?1:Ea;if((D|0)<=0){u=j;return}G=Da+8|0;L=Da+16|0;qa=ua<<1;pa=Da+(va<<3)|0;I=Da+(va+1<<3)|0;ta=Da+(va+2<<3)|0;ga=va<<1;T=Da+(ga<<3)|0;A=Da+((ga|1)<<3)|0;ra=Da+(ga+2<<3)|0;ga=E<<1;J=ka<<1;H=Ba;ia=Ca;_=sa;la=0;while(1){ea=+p[H>>3];da=+p[H+(ua<<3)>>3];Z=+p[H+(qa<<3)>>3];X=ea*+p[pa>>3]+da*+p[I>>3]+Z*+p[ta>>3];W=ea*+p[T>>3]+da*+p[A>>3]+Z*+p[ra>>3];p[ia>>3]=(+p[Da>>3]*ea+ +p[G>>3]*da+ +p[L>>3]*Z)*d+ +p[_>>3]*g;p[ia+(ka<<3)>>3]=X*d+ +p[_+(E<<3)>>3]*g;p[ia+(J<<3)>>3]=W*d+ +p[_+(ga<<3)>>3]*g;la=la+1|0;if((la|0)==(D|0))break;else{H=H+8|0;ia=ia+8|0;_=_+(F<<3)|0}}u=j;return}case 4:{if(!((D|0)!=4|(Ba|0)==(Ca|0))){if((C|0)<=0){u=j;return}F=Ba+(ua<<3)|0;_=ua<<1;ia=Ba+(_<<3)|0;H=ua*3|0;la=Ba+(H<<3)|0;ga=Ba+8|0;J=Ba+(ua+1<<3)|0;E=Ba+((_|1)<<3)|0;L=Ba+(H+1<<3)|0;G=Ba+16|0;ra=Ba+(ua+2<<3)|0;A=Ba+(_+2<<3)|0;T=Ba+(H+2<<3)|0;ta=Ba+24|0;I=Ba+(ua+3<<3)|0;pa=Ba+(_+3<<3)|0;_=Ba+(H+3<<3)|0;H=0;qa=Da;oa=Ca;V=sa;while(1){W=+p[qa>>3];X=+p[qa+8>>3];Z=+p[qa+16>>3];da=+p[qa+24>>3];ea=W*+p[ga>>3]+X*+p[J>>3]+Z*+p[E>>3]+da*+p[L>>3];ma=W*+p[G>>3]+X*+p[ra>>3]+Z*+p[A>>3]+da*+p[T>>3];na=W*+p[ta>>3]+X*+p[I>>3]+Z*+p[pa>>3]+da*+p[_>>3];p[oa>>3]=(W*+p[Ba>>3]+X*+p[F>>3]+Z*+p[ia>>3]+da*+p[la>>3])*d+ +p[V>>3]*g;p[oa+8>>3]=ea*d+ +p[V+8>>3]*g;p[oa+16>>3]=ma*d+ +p[V+16>>3]*g;p[oa+24>>3]=na*d+ +p[V+24>>3]*g;H=H+1|0;if((H|0)==(C|0))break;else{qa=qa+(va<<3)|0;oa=oa+(ka<<3)|0;V=V+(Ea<<3)|0}}u=j;return}if((D|0)>16|(Da|0)==(Ca|0))break a;V=(sa|0)==53e4;oa=V?1:Ea;qa=(V^1)&1;if((D|0)<=0){u=j;return}V=Da+8|0;H=Da+16|0;la=ua<<1;ia=Da+24|0;F=ua*3|0;_=Da+(va<<3)|0;pa=Da+(va+1<<3)|0;I=Da+(va+2<<3)|0;ta=Da+(va+3<<3)|0;T=va<<1;A=Da+(T<<3)|0;ra=Da+((T|1)<<3)|0;G=Da+(T+2<<3)|0;L=Da+(T+3<<3)|0;T=va*3|0;E=Da+(T<<3)|0;J=Da+(T+1<<3)|0;ga=Da+(T+2<<3)|0;fa=Da+(T+3<<3)|0;T=oa<<1;$=ka<<1;aa=oa*3|0;ca=ka*3|0;R=0;Q=Ba;P=Ca;S=sa;while(1){na=+p[Q>>3];ma=+p[Q+(ua<<3)>>3];ea=+p[Q+(la<<3)>>3];da=+p[Q+(F<<3)>>3];Z=na*+p[_>>3]+ma*+p[pa>>3]+ea*+p[I>>3]+da*+p[ta>>3];X=na*+p[A>>3]+ma*+p[ra>>3]+ea*+p[G>>3]+da*+p[L>>3];W=na*+p[E>>3]+ma*+p[J>>3]+ea*+p[ga>>3]+da*+p[fa>>3];p[P>>3]=(+p[Da>>3]*na+ +p[V>>3]*ma+ +p[H>>3]*ea+ +p[ia>>3]*da)*d+ +p[S>>3]*g;p[P+(ka<<3)>>3]=Z*d+ +p[S+(oa<<3)>>3]*g;p[P+($<<3)>>3]=X*d+ +p[S+(T<<3)>>3]*g;p[P+(ca<<3)>>3]=W*d+ +p[S+(aa<<3)>>3]*g;R=R+1|0;if((R|0)==(D|0))break;else{Q=Q+8|0;P=P+8|0;S=S+(qa<<3)|0}}u=j;return}default:break a}}while(0);Da=f[c+48>>2]|0;Ca=f[e+16>>2]|0;Ba=(Ca|0)==0;if(Ba)Fa=0;else Fa=f[e+48>>2]|0;Ea=k+8|0;f[k>>2]=Ea;Aa=k+4|0;f[Aa>>2]=1032;switch(w&4095){case 5:{Ga=2;Ha=101;Ia=1;break}case 6:{Ga=3;Ha=102;Ia=2;break}case 13:{Ga=4;Ha=103;Ia=3;break}case 14:{Ga=5;Ha=104;Ia=4;break}default:{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;za=$Xc(32)|0;f[l>>2]=za;f[l+8>>2]=-2147483616;f[l+4>>2]=16;ya=za;xa=235942;wa=ya+16|0;do{b[ya>>0]=b[xa>>0]|0;ya=ya+1|0;xa=xa+1|0}while((ya|0)<(wa|0));b[za+16>>0]=0;vM(-215,l,235959,235968,1218)}}l=(D|0)==1;if((i&2|0)==0&(l|(B|0)==1)?(f[c>>2]&16384|0)!=0:0){if(l)Ja=0;else Ja=Y(675553809>>>(z<<2&28)&15,(w>>>3&511)+1|0)|0;Ka=i|2;La=Ja}else{Ka=i;La=Da}if((C|0)<65)if((B|0)<10001)Ma=83;else Ma=81;else if((B|0)<11|(D|0)<65&(B|0)<10001)Ma=83;else Ma=81;do if((Ma|0)==81){if((D|0)<129?(C|0)<129&(B|0)<129:0){Ma=83;break}Da=w&7;i=Y(675553809>>>(Da<<2)&15,(w>>>3&511)+1|0)|0;Ja=i<<((Da|0)==5&1);Da=(Ka&1|0)!=0;z=a+48|0;l=f[z>>2]|0;za=Da?i:l;xa=Da?l:i;l=(Ka&2|0)!=0;ya=l?i:La;wa=l?La:i;if(!Ba){N=f[e+4>>2]|0;if((N|0)<3)Na=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{qa=f[e+40>>2]|0;S=0;P=1;while(1){Q=Y(f[qa+(S<<2)>>2]|0,P)|0;S=S+1|0;if((S|0)==(N|0)){Na=Q;break}else P=Q}}if(!((N|0)==0|(Na|0)==0)){P=(Ka&4|0)==0;S=f[e+48>>2]|0;Oa=P?i:S;Pa=P?S:i;Qa=Ka}else Ma=90}else Ma=90;if((Ma|0)==90){Oa=0;Pa=0;Qa=Ka&-5}S=(C|0)<128?C:128;P=(D|0)<128?D:128;qa=16384/(S|0)|0;Q=16384/(P|0)|0;R=(Q|0)<(qa|0)?Q:qa;qa=(B|0)<(R|0)?B:R;if((Y(qa,S)|0)>16384)Ra=16384/(qa|0)|0;else Ra=S;if((Y(qa,P)|0)>16384)Sa=16384/(qa|0)|0;else Sa=P;P=((qa|0)/8|0)+qa|0;S=Y(Sa+2+((Sa|0)/8|0)&-2,P+1|0)|0;Q=Y(S,i)|0;aa=Y(S,Ja)|0;if(Da){Ta=Y(Y(P+2&-2,i)|0,Ra+1+((Ra|0)/8|0)|0)|0;Ua=Qa&-2}else{Ta=0;Ua=Qa}P=aa+Q+Ta|0;f[Aa>>2]=P;if(P>>>0>1032){S=bYc(P)|0;f[k>>2]=S;Va=S}else Va=Ea;S=Va+aa|0;aa=S+Q|0;Q=Da?aa:0;if((C|0)>0){P=C<<3;ca=(D|0)>0;T=h+16|0;$=h+44|0;oa=h+48|0;ka=D<<3;ia=(B|0)>(R|0);R=(B|0)>0;H=v+4|0;V=a+16|0;fa=c+16|0;ga=B<<3;J=Da&(Q|0)!=0;E=(i|0)==4;L=i&65535;G=i>>>2;ra=q+4|0;A=r+4|0;ta=s+4|0;I=t+4|0;pa=0;_=Ua;while(1){F=pa+Ra|0;if((F|0)<(C|0)?((F<<3)+Ra|0)<=(P|0):0)Wa=Ra;else Wa=C-pa|0;if(ca){F=Ca+(Y(pa,Pa)|0)|0;la=Y(pa,za)|0;ua=0;sa=_;while(1){va=f[oa>>2]|0;U=Y(ua,i)|0;ja=(f[T>>2]|0)+(Y(va,pa)|0)+U|0;ba=F+(Y(ua,Oa)|0)|0;ha=ua+Sa|0;if((ha|0)<(D|0)?((ha<<3)+Sa|0)<=(ka|0):0)Xa=Sa;else Xa=D-ua|0;ha=sa&15;M=Y(Xa,Ja)|0;O=ia?Va:ja;ja=ia?M:va;if(R){va=Y(ua,wa)|0;M=(Xa|0)<(D|0);K=0;Ya=ha;while(1){Za=(f[V>>2]|0)+la+(Y(K,xa)|0)|0;_a=f[z>>2]|0;$a=(f[fa>>2]|0)+(Y(K,ya)|0)+va|0;ab=K+qa|0;if((ab|0)<(B|0)?((ab<<3)+qa|0)<=(ga|0):0)bb=qa;else bb=B-K|0;ab=Da?Wa:bb;cb=Da?bb:Wa;b:do if(J){db=Y(bb,i)|0;if((ab|0)<=0){eb=db;fb=aa;gb=cb;hb=ab;break}ib=(cb|0)>0;if(E){if(ib){jb=Za;kb=aa;lb=0}else{eb=db;fb=Q;gb=cb;hb=ab;break}while(1){mb=0;nb=jb;while(1){f[kb+(mb<<2)>>2]=f[nb>>2];mb=mb+1|0;if((mb|0)==(cb|0))break;else nb=nb+_a|0}lb=lb+1|0;if((lb|0)==(ab|0)){eb=db;fb=Q;gb=cb;hb=ab;break b}else{jb=jb+4|0;kb=kb+db|0}}}nb=cb<<2;mb=cb<<1;switch(L&16383){case 16:{ob=Za;pb=aa;qb=0;while(1){if(ib){rb=ob;sb=0;while(1){tb=f[rb+4>>2]|0;f[pb+(sb<<2)>>2]=f[rb>>2];f[pb+((sb|1)<<2)>>2]=tb;tb=f[rb+12>>2]|0;f[pb+((sb|2)<<2)>>2]=f[rb+8>>2];f[pb+((sb|3)<<2)>>2]=tb;sb=sb+4|0;if((sb|0)>=(nb|0))break;else rb=rb+_a|0}}qb=qb+1|0;if((qb|0)==(ab|0)){eb=db;fb=Q;gb=cb;hb=ab;break}else{ob=ob+i|0;pb=pb+db|0}}break}case 8:{pb=Za;ob=aa;qb=0;while(1){if(ib){nb=pb;rb=0;while(1){sb=f[nb+4>>2]|0;f[ob+(rb<<2)>>2]=f[nb>>2];f[ob+((rb|1)<<2)>>2]=sb;rb=rb+2|0;if((rb|0)>=(mb|0))break;else nb=nb+_a|0}}qb=qb+1|0;if((qb|0)==(ab|0)){eb=db;fb=Q;gb=cb;hb=ab;break}else{pb=pb+i|0;ob=ob+db|0}}break}default:{eb=db;fb=aa;gb=cb;hb=ab;break b}}}else{eb=_a;fb=Za;gb=ab;hb=cb}while(0);c:do if(M){cb=l?bb:Xa;ab=l?Xa:bb;Za=Y(cb,i)|0;_a=Y(cb,G)|0;if(!ab){ub=Za;vb=S;break}cb=_a+-4|0;if((_a|0)<4){ob=(_a|0)>0;pb=S;qb=$a;mb=ab;while(1){mb=mb+-1|0;if(ob){ib=0;do{f[pb+(ib<<2)>>2]=f[qb+(ib<<2)>>2];ib=ib+1|0}while((ib|0)!=(_a|0))}if(!mb){ub=Za;vb=S;break c}else{pb=pb+Za|0;qb=qb+La|0}}}qb=_a&-4;pb=(qb|0)<(_a|0);mb=S;ob=$a;db=ab;while(1){ib=0;do{nb=ib|1;rb=f[ob+(nb<<2)>>2]|0;f[mb+(ib<<2)>>2]=f[ob+(ib<<2)>>2];f[mb+(nb<<2)>>2]=rb;rb=ib|2;nb=ib|3;sb=f[ob+(nb<<2)>>2]|0;f[mb+(rb<<2)>>2]=f[ob+(rb<<2)>>2];f[mb+(nb<<2)>>2]=sb;ib=ib+4|0}while((ib|0)<=(cb|0));db=db+-1|0;if(pb){ib=qb;do{f[mb+(ib<<2)>>2]=f[ob+(ib<<2)>>2];ib=ib+1|0}while((ib|0)!=(_a|0))}if(!db){ub=Za;vb=S;break}else{mb=mb+Za|0;ob=ob+La|0}}}else{ub=La;vb=$a}while(0);if(ia){f[q>>2]=gb;f[ra>>2]=hb;f[r>>2]=Xa;f[A>>2]=Wa;Li[Ha&127](fb,eb,vb,ub,O,ja,q,r,Ya)}else{f[s>>2]=gb;f[ta>>2]=hb;f[t>>2]=Xa;f[I>>2]=Wa;wh[Ia&7](fb,eb,vb,ub,ba,Fa,O,ja,s,t,d,g,Ya)}$a=Ya|16;K=bb+K|0;if((B|0)<=(K|0)){wb=$a;break}else Ya=$a}}else wb=ha;if(ia){Ya=(f[T>>2]|0)+(Y(f[f[$>>2]>>2]|0,pa)|0)+U|0;K=f[oa>>2]|0;f[v>>2]=Xa;f[H>>2]=Wa;$i[Ga&7](ba,Fa,O,ja,Ya,K,v,d,g,wb)}ua=Xa+ua|0;if((D|0)<=(ua|0)){xb=wb;break}else sa=wb}}else xb=_;pa=Wa+pa|0;if((C|0)<=(pa|0))break;else _=xb}}}while(0);if((Ma|0)==83){Ma=f[a+16>>2]|0;xb=f[a+48>>2]|0;a=f[c+16>>2]|0;c=f[h+16>>2]|0;Wa=f[h+48>>2]|0;f[m>>2]=x;f[m+4>>2]=y;f[o>>2]=D;f[o+4>>2]=C;wh[Ia&7](Ma,xb,a,La,Ca,Fa,c,Wa,m,o,d,g,Ka)}Ka=f[k>>2]|0;if((Ka|0)!=(Ea|0)){if(Ka|0)dYc(Ka);f[k>>2]=Ea;f[Aa>>2]=1032}u=j;return}function nY(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;o=u;u=u+2192|0;q=o+1096|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;f[q>>2]=k;w=q+4|0;f[w>>2]=136;x=b>>>3;y=d>>>3;z=g>>>3;g=i>>>3;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>15&(t|0)>1){f[w>>2]=t;if(t>>>0>136){z=bYc(t>>>0>536870911?-1:t<<3)|0;f[q>>2]=z;D=x;E=1;F=z;G=t;H=43}else{D=x;E=1;F=k;G=t;H=43}}else{I=x;J=1;K=t;H=5}else{I=1;J=x;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;f[r>>2]=s;z=r+4|0;f[z>>2]=136;if(b>>>0>15&(t|0)>1){f[w>>2]=v;if(v>>>0>136){t=bYc(v>>>0>536870911?-1:v<<3)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<3)|0;p[L+(t<<3)>>3]=+p[b>>3];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>15){f[z>>2]=j;if(j>>>0>136){d=bYc(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<3)|0;p[N+(d<<3)>>3]=+p[L>>3];d=d+1|0}while((d|0)!=(j|0));O=N;P=N}else{O=N;P=N}}else{O=c;P=s}a:do if((v|0)>0){N=C<<1;if((j|0)<2){if((j|0)==1){Q=h;R=0;S=e}else break;while(1){T=+p[M+(R<<3)>>3]*l*+p[O>>3];if(!S)U=T;else U=T+ +p[S>>3]*m;p[Q>>3]=U;R=R+1|0;if((R|0)==(v|0))break a;else{Q=Q+(g<<3)|0;S=S+(B<<3)|0}}}d=j+-2|0;L=((d|0)>1?d:1)>>>1;t=Y(L,N)|0;x=(L<<1)+2|0;if((x|0)>=(j|0)){L=h;b=0;A=e;while(1){T=+p[M+(b<<3)>>3]*l;i=A;V=0;while(1){W=T*+p[O+(V<<3)>>3];X=V|1;Z=T*+p[O+(X<<3)>>3];if(!i){p[L+(V<<3)>>3]=W;_=Z}else{p[L+(V<<3)>>3]=W+ +p[i>>3]*m;_=Z+ +p[i+(C<<3)>>3]*m}p[L+(X<<3)>>3]=_;V=V+2|0;if((V|0)>(d|0))break;else i=i+(N<<3)|0}b=b+1|0;if((b|0)==(v|0))break a;else{L=L+(g<<3)|0;A=A+(B<<3)|0}}}A=h;L=0;b=e;i=e+(N<<3)|0;while(1){T=+p[M+(L<<3)>>3]*l;V=b;X=0;while(1){Z=T*+p[O+(X<<3)>>3];$=X|1;W=T*+p[O+($<<3)>>3];if(!V){p[A+(X<<3)>>3]=Z;aa=W}else{p[A+(X<<3)>>3]=Z+ +p[V>>3]*m;aa=W+ +p[V+(C<<3)>>3]*m}p[A+($<<3)>>3]=aa;X=X+2|0;if((X|0)>(d|0))break;else V=V+(N<<3)|0}V=i+(t<<3)|0;X=x;while(1){W=T*+p[O+(X<<3)>>3];if(!V)ba=W;else ba=W+ +p[V>>3]*m;p[A+(X<<3)>>3]=ba;X=X+1|0;if((X|0)==(j|0))break;else V=V+(C<<3)|0}L=L+1|0;if((L|0)==(v|0))break;else{A=A+(g<<3)|0;b=b+(B<<3)|0;i=i+(B<<3)|0}}}while(0);if((P|0)!=(s|0)){dYc(P);f[r>>2]=s;f[z>>2]=136}}else{D=I;E=J;F=0;G=K;H=43}b:do if((H|0)==43){if(n&2|0){if((v|0)<=0)break;K=(F|0)==0;J=(j|0)>0;I=G+-4|0;z=(G|0)<4;s=G&-4;P=K|(G|0)<1;O=(G|0)>0;M=(s|0)<(G|0);ba=l*0.0;S=a;Q=h;R=0;i=e;while(1){if(P)ca=K?S:F;else{b=0;do{A=S+((Y(b,D)|0)<<3)|0;p[F+(b<<3)>>3]=+p[A>>3];b=b+1|0}while((b|0)!=(G|0));ca=F}c:do if(J){if(z){if(O){da=c;ea=i;fa=0}else{b=i;A=0;while(1){if(!b)ga=ba;else ga=ba+ +p[b>>3]*m;p[Q+(A<<3)>>3]=ga;A=A+1|0;if((A|0)==(j|0))break c;else b=b+(C<<3)|0}}while(1){aa=0.0;b=0;do{aa=aa+ +p[ca+(b<<3)>>3]*+p[da+(b<<3)>>3];b=b+1|0}while((b|0)!=(G|0));_=(aa+0.0)*l;if(!ea)ha=_;else ha=_+ +p[ea>>3]*m;p[Q+(fa<<3)>>3]=ha;fa=fa+1|0;if((fa|0)==(j|0))break c;else{da=da+(y<<3)|0;ea=ea+(C<<3)|0}}}if(M){ia=c;ja=i;ka=0}else{b=c;A=i;L=0;while(1){_=0.0;U=0.0;T=0.0;W=0.0;x=0;do{W=W+ +p[ca+(x<<3)>>3]*+p[b+(x<<3)>>3];t=x|1;T=T+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];t=x|2;U=U+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];t=x|3;_=_+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];x=x+4|0}while((x|0)<=(I|0));aa=(_+(U+(T+W)))*l;if(!A)la=aa;else la=aa+ +p[A>>3]*m;p[Q+(L<<3)>>3]=la;L=L+1|0;if((L|0)==(j|0))break c;else{b=b+(y<<3)|0;A=A+(C<<3)|0}}}while(1){aa=0.0;Z=0.0;ma=0.0;na=0.0;A=0;while(1){oa=na+ +p[ca+(A<<3)>>3]*+p[ia+(A<<3)>>3];b=A|1;ma=ma+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];b=A|2;Z=Z+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];b=A|3;aa=aa+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];A=A+4|0;if((A|0)>(I|0)){pa=oa;qa=s;break}else na=oa}do{pa=pa+ +p[ca+(qa<<3)>>3]*+p[ia+(qa<<3)>>3];qa=qa+1|0}while((qa|0)!=(G|0));na=(aa+(Z+(ma+pa)))*l;if(!ja)ra=na;else ra=na+ +p[ja>>3]*m;p[Q+(ka<<3)>>3]=ra;ka=ka+1|0;if((ka|0)==(j|0))break;else{ia=ia+(y<<3)|0;ja=ja+(C<<3)|0}}}while(0);R=R+1|0;if((R|0)==(v|0))break b;else{S=S+(E<<3)|0;Q=Q+(g<<3)|0;i=i+(B<<3)|0}}}i=j<<3;if(i>>>0<1601){if((v|0)<=0)break;Q=(F|0)==0;S=j+-4|0;R=(j|0)<4;s=(G|0)>0;I=C<<2;M=C<<1;O=C*3|0;z=S>>>2;J=(z<<2)+4|0;K=Q|(G|0)<1;ba=l*0.0;P=a;A=h;b=0;L=e;x=e+(Y((z<<5)+32|0,C)|0)|0;while(1){if(K)sa=Q?P:F;else{z=0;do{t=P+((Y(z,D)|0)<<3)|0;p[F+(z<<3)>>3]=+p[t>>3];z=z+1|0}while((z|0)!=(G|0));sa=F}d:do if(R){ta=L;ua=0}else{if(s){va=L;wa=0}else{z=L;t=0;while(1){N=t|1;d=t|2;if(!z){p[A+(t<<3)>>3]=ba;p[A+(N<<3)>>3]=ba;p[A+(d<<3)>>3]=ba;xa=ba}else{p[A+(t<<3)>>3]=ba+ +p[z>>3]*m;p[A+(N<<3)>>3]=ba+ +p[z+(C<<3)>>3]*m;p[A+(d<<3)>>3]=ba+ +p[z+(M<<3)>>3]*m;xa=ba+ +p[z+(O<<3)>>3]*m}p[A+((t|3)<<3)>>3]=xa;t=t+4|0;if((t|0)>(S|0)){ta=x;ua=J;break d}else z=z+(I<<3)|0}}while(1){na=0.0;W=0.0;T=0.0;U=0.0;z=c+(wa<<3)|0;t=0;while(1){_=+p[sa+(t<<3)>>3];U=U+_*+p[z>>3];T=T+_*+p[z+8>>3];W=W+_*+p[z+16>>3];na=na+_*+p[z+24>>3];t=t+1|0;if((t|0)==(G|0))break;else z=z+(y<<3)|0}ma=U*l;z=wa|1;Z=W*l;aa=na*l;_=T*l;t=wa|2;if(!va){p[A+(wa<<3)>>3]=ma;p[A+(z<<3)>>3]=_;p[A+(t<<3)>>3]=Z;ya=aa}else{p[A+(wa<<3)>>3]=ma+ +p[va>>3]*m;p[A+(z<<3)>>3]=_+ +p[va+(C<<3)>>3]*m;p[A+(t<<3)>>3]=Z+ +p[va+(M<<3)>>3]*m;ya=aa+ +p[va+(O<<3)>>3]*m}p[A+((wa|3)<<3)>>3]=ya;wa=wa+4|0;if((wa|0)>(S|0)){ta=x;ua=J;break}else va=va+(I<<3)|0}}while(0);e:do if((ua|0)<(j|0)){if(s){za=ta;Aa=ua}else{t=ta;z=ua;while(1){if(!t)Ba=ba;else Ba=ba+ +p[t>>3]*m;p[A+(z<<3)>>3]=Ba;z=z+1|0;if((z|0)==(j|0))break e;else t=t+(C<<3)|0}}while(1){aa=0.0;t=c+(Aa<<3)|0;z=0;while(1){aa=aa+ +p[sa+(z<<3)>>3]*+p[t>>3];z=z+1|0;if((z|0)==(G|0))break;else t=t+(y<<3)|0}T=aa*l;if(!za)Ca=T;else Ca=T+ +p[za>>3]*m;p[A+(Aa<<3)>>3]=Ca;Aa=Aa+1|0;if((Aa|0)==(j|0))break;else za=za+(C<<3)|0}}while(0);b=b+1|0;if((b|0)==(v|0))break b;else{P=P+(E<<3)|0;A=A+(g<<3)|0;L=L+(B<<3)|0;x=x+(B<<3)|0}}}x=r+8|0;f[r>>2]=x;L=r+4|0;f[L>>2]=j;if(j>>>0>136){A=bYc(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=A;Da=A;Ea=A}else{Da=x;Ea=x}if((v|0)>0){A=(F|0)==0;P=(j|0)>0;b=(G|0)>0;s=j+-4|0;I=(j|0)<4;J=j&-4;S=A|(G|0)<1;O=(J|0)<(j|0);M=a;R=h;Q=0;K=e;while(1){if(S)Fa=A?M:F;else{t=0;do{z=M+((Y(t,D)|0)<<3)|0;p[F+(t<<3)>>3]=+p[z>>3];t=t+1|0}while((t|0)!=(G|0));Fa=F}if(P)g1c(Ea|0,0,i|0)|0;f:do if(b){if(I){if(P){Ga=c;Ha=0}else break;while(1){ba=+p[Fa+(Ha<<3)>>3];t=0;do{z=Ea+(t<<3)|0;p[z>>3]=+p[z>>3]+ba*+p[Ga+(t<<3)>>3];t=t+1|0}while((t|0)!=(j|0));Ha=Ha+1|0;if((Ha|0)==(G|0))break f;else Ga=Ga+(y<<3)|0}}if(O){Ia=c;Ja=0}else{t=c;z=0;while(1){ba=+p[Fa+(z<<3)>>3];d=0;do{N=Ea+(d<<3)|0;V=d|1;X=Ea+(V<<3)|0;aa=+p[X>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(d<<3)>>3];p[X>>3]=aa;X=d|2;N=Ea+(X<<3)|0;V=d|3;$=Ea+(V<<3)|0;aa=+p[$>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(X<<3)>>3];p[$>>3]=aa;d=d+4|0}while((d|0)<=(s|0));z=z+1|0;if((z|0)==(G|0))break f;else t=t+(y<<3)|0}}while(1){ba=+p[Fa+(Ja<<3)>>3];t=0;do{z=Ea+(t<<3)|0;d=t|1;$=Ea+(d<<3)|0;aa=+p[$>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+(t<<3)>>3];p[$>>3]=aa;$=t|2;z=Ea+($<<3)|0;d=t|3;X=Ea+(d<<3)|0;aa=+p[X>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+($<<3)>>3];p[X>>3]=aa;t=t+4|0}while((t|0)<=(s|0));Ka=J;do{t=Ea+(Ka<<3)|0;p[t>>3]=+p[t>>3]+ba*+p[Ia+(Ka<<3)>>3];Ka=Ka+1|0}while((Ka|0)!=(j|0));Ja=Ja+1|0;if((Ja|0)==(G|0))break;else Ia=Ia+(y<<3)|0}}while(0);if(!K){if(P){t=0;do{p[R+(t<<3)>>3]=+p[Ea+(t<<3)>>3]*l;t=t+1|0}while((t|0)!=(j|0))}}else if(P){t=0;X=K;while(1){p[R+(t<<3)>>3]=+p[Ea+(t<<3)>>3]*l+ +p[X>>3]*m;t=t+1|0;if((t|0)==(j|0))break;else X=X+(C<<3)|0}}Q=Q+1|0;if((Q|0)==(v|0)){La=Da;break}else{M=M+(E<<3)|0;R=R+(g<<3)|0;K=K+(B<<3)|0}}}else La=Ea;if((La|0)!=(x|0)){dYc(La);f[r>>2]=x;f[L>>2]=136}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)dYc(r);f[q>>2]=k;f[w>>2]=136;u=o;return}function oY(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;q=u;u=u+2256|0;r=q+1160|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;g1c(k|0,0,1088)|0;f[r>>2]=k;x=r+4|0;f[x>>2]=136;y=b>>>3;z=d>>>3;A=g>>>3;g=i>>>3;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>15&(v|0)>1){f[x>>2]=v;if(v>>>0>136){A=bYc(v>>>0>536870911?-1:v<<3)|0;g1c(A|0,0,v<<3|0)|0;f[r>>2]=A;E=y;F=1;G=A;H=v;I=33}else{E=y;F=1;G=k;H=v;I=33}}else{J=y;K=1;L=v;I=5}else{J=1;K=y;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;g1c(t|0,0,1088)|0;f[s>>2]=t;A=s+4|0;f[A>>2]=136;if(b>>>0>15&(v|0)>1){f[x>>2]=w;if(w>>>0>136){v=bYc(w>>>0>536870911?-1:w<<3)|0;g1c(v|0,0,w<<3|0)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<3)|0;B=f[b+4>>2]|0;i=M+(v<<3)|0;f[i>>2]=f[b>>2];f[i+4>>2]=B;v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>15){f[A>>2]=j;if(j>>>0>136){d=bYc(j>>>0>536870911?-1:j<<3)|0;g1c(d|0,0,j<<3|0)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<3)|0;v=f[M+4>>2]|0;y=O+(d<<3)|0;f[y>>2]=f[M>>2];f[y+4>>2]=v;d=d+1|0}while((d|0)<(j|0));P=O}else P=O}else P=c;if((w|0)>0){O=D<<1;d=(j|0)<2;v=j+-2|0;y=v>>>1;M=(y<<1)+2|0;B=e;i=0;b=h;Q=e+(Y(D,(y<<4)+16|0)|0)|0;while(1){R=+n[N+(i<<3)>>2]*l;S=+n[N+(i<<3)+4>>2]*l;if(d){T=B;U=0}else{y=B;V=0;while(1){W=+n[P+(V<<3)>>2];X=+n[P+(V<<3)+4>>2];Z=R*W-S*X;_=S*W+R*X;$=V|1;X=+n[P+($<<3)>>2];W=+n[P+($<<3)+4>>2];aa=R*X-S*W;ba=S*X+R*W;if(!y){n[b+(V<<3)>>2]=Z;n[b+(V<<3)+4>>2]=_;ca=ba;da=aa}else{W=_+ +n[y+4>>2]*m;n[b+(V<<3)>>2]=Z+ +n[y>>2]*m;n[b+(V<<3)+4>>2]=W;ca=ba+ +n[y+(D<<3)+4>>2]*m;da=aa+ +n[y+(D<<3)>>2]*m}n[b+($<<3)>>2]=da;n[b+($<<3)+4>>2]=ca;V=V+2|0;if((V|0)>(v|0)){T=Q;U=M;break}else y=y+(O<<3)|0}}if((U|0)<(j|0)){y=T;V=U;while(1){aa=+n[P+(V<<3)>>2];ba=+n[P+(V<<3)+4>>2];W=R*aa-S*ba;Z=S*aa+R*ba;if(!y){ea=W;fa=Z}else{ea=W+ +n[y>>2]*m;fa=Z+ +n[y+4>>2]*m}n[b+(V<<3)>>2]=ea;n[b+(V<<3)+4>>2]=fa;V=V+1|0;if((V|0)==(j|0))break;else y=y+(D<<3)|0}}i=i+1|0;if((i|0)==(w|0))break;else{B=B+(C<<3)|0;b=b+(g<<3)|0;Q=Q+(C<<3)|0}}}Q=f[s>>2]|0;if((Q|0)!=(t|0)){if(Q|0)dYc(Q);f[s>>2]=t;f[A>>2]=136}}else{E=J;F=K;G=0;H=L;I=33}a:do if((I|0)==33){if(o&2|0){if((w|0)<=0)break;L=(G|0)==0;K=H+-4|0;J=(H|0)<4;A=H&-4;t=L|(H|0)<1;Q=(j|0)>0;b=a;B=e;i=0;P=h;while(1){if(t)ga=L?b:G;else{U=0;do{T=b+((Y(U,E)|0)<<3)|0;O=f[T+4>>2]|0;M=G+(U<<3)|0;f[M>>2]=f[T>>2];f[M+4>>2]=O;U=U+1|0}while((U|0)!=(H|0));ga=G}if(Q){U=c;O=B;M=0;while(1){if(J){ha=0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0;pa=0.0}else{T=0;fa=0.0;ea=0.0;ca=0.0;da=0.0;R=0.0;S=0.0;Z=0.0;W=0.0;while(1){ba=+n[ga+(T<<3)>>2];aa=+n[ga+(T<<3)+4>>2];_=+n[U+(T<<3)>>2];X=+n[U+(T<<3)+4>>2];qa=da+(ba*_-aa*X);ra=R+(aa*_+ba*X);v=T|1;X=+n[ga+(v<<3)>>2];ba=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];aa=+n[U+(v<<3)+4>>2];sa=ca+(X*_-ba*aa);ta=W+(ba*_+X*aa);v=T|2;aa=+n[ga+(v<<3)>>2];X=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];ba=+n[U+(v<<3)+4>>2];ua=ea+(aa*_-X*ba);va=Z+(X*_+aa*ba);v=T|3;ba=+n[ga+(v<<3)>>2];aa=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];X=+n[U+(v<<3)+4>>2];wa=fa+(ba*_-aa*X);xa=S+(aa*_+ba*X);T=T+4|0;if((T|0)>(K|0)){ha=A;ia=wa;ja=ua;ka=sa;la=qa;ma=ra;na=xa;oa=va;pa=ta;break}else{fa=wa;ea=ua;ca=sa;da=qa;R=ra;S=xa;Z=va;W=ta}}}if((ha|0)<(H|0)){T=ha;W=la;Z=ma;while(1){S=+n[ga+(T<<3)>>2];R=+n[ga+(T<<3)+4>>2];da=+n[U+(T<<3)>>2];ca=+n[U+(T<<3)+4>>2];ea=W+(S*da-R*ca);fa=Z+(R*da+S*ca);T=T+1|0;if((T|0)==(H|0)){ya=ea;za=fa;break}else{W=ea;Z=fa}}}else{ya=la;za=ma}Z=(ia+(ja+(ka+ya)))*l;W=(na+(oa+(pa+za)))*l;if(!O){Aa=W;Ba=Z}else{Aa=W+ +n[O+4>>2]*m;Ba=Z+ +n[O>>2]*m}n[P+(M<<3)>>2]=Ba;n[P+(M<<3)+4>>2]=Aa;M=M+1|0;if((M|0)==(j|0))break;else{U=U+(z<<3)|0;O=O+(D<<3)|0}}}i=i+1|0;if((i|0)==(w|0))break a;else{b=b+(F<<3)|0;B=B+(C<<3)|0;P=P+(g<<3)|0}}}if(j<<3>>>0<1601){if((w|0)<=0)break;P=(G|0)==0;B=j+-4|0;b=(j|0)<4;i=(H|0)>0;A=D<<2;K=D<<1;J=D*3|0;Q=B>>>2;L=(Q<<2)+4|0;t=P|(H|0)<1;Z=l*0.0;O=a;U=e;M=0;T=h;v=e+(Y((Q<<5)+32|0,D)|0)|0;while(1){if(t)Ca=P?O:G;else{Q=0;do{d=O+((Y(Q,E)|0)<<3)|0;N=f[d+4>>2]|0;y=G+(Q<<3)|0;f[y>>2]=f[d>>2];f[y+4>>2]=N;Q=Q+1|0}while((Q|0)!=(H|0));Ca=G}if(b){Da=U;Ea=0}else{Q=U;N=0;while(1){if(i){y=c+(N<<3)|0;d=0;W=0.0;fa=0.0;ea=0.0;ca=0.0;S=0.0;da=0.0;R=0.0;ta=0.0;while(1){va=+n[Ca+(d<<3)>>2];xa=+n[Ca+(d<<3)+4>>2];ra=+n[y>>2];qa=+n[y+4>>2];sa=ca+(va*ra-xa*qa);ua=ta+(xa*ra+va*qa);qa=+n[y+8>>2];ra=+n[y+12>>2];wa=ea+(va*qa-xa*ra);X=R+(xa*qa+va*ra);ra=+n[y+16>>2];qa=+n[y+20>>2];ba=fa+(va*ra-xa*qa);_=da+(xa*ra+va*qa);qa=+n[y+24>>2];ra=+n[y+28>>2];aa=W+(va*qa-xa*ra);Fa=S+(xa*qa+va*ra);d=d+1|0;if((d|0)==(H|0)){Ga=aa;Ha=ba;Ia=wa;Ja=sa;Ka=Fa;La=_;Ma=X;Na=ua;break}else{y=y+(z<<3)|0;W=aa;fa=ba;ea=wa;ca=sa;S=Fa;da=_;R=X;ta=ua}}}else{Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0;Ma=0.0;Na=0.0}ta=Ja*l;R=Na*l;if(!Q){n[T+(N<<3)>>2]=ta;n[T+(N<<3)+4>>2]=R;y=N|1;n[T+(y<<3)>>2]=Ia*l;n[T+(y<<3)+4>>2]=Ma*l;y=N|2;n[T+(y<<3)>>2]=Ha*l;n[T+(y<<3)+4>>2]=La*l;Oa=Ka*l;Pa=Ga*l}else{da=R+ +n[Q+4>>2]*m;n[T+(N<<3)>>2]=ta+ +n[Q>>2]*m;n[T+(N<<3)+4>>2]=da;da=Ma*l+ +n[Q+(D<<3)+4>>2]*m;y=N|1;n[T+(y<<3)>>2]=Ia*l+ +n[Q+(D<<3)>>2]*m;n[T+(y<<3)+4>>2]=da;da=La*l+ +n[Q+(K<<3)+4>>2]*m;y=N|2;n[T+(y<<3)>>2]=Ha*l+ +n[Q+(K<<3)>>2]*m;n[T+(y<<3)+4>>2]=da;Oa=Ka*l+ +n[Q+(J<<3)+4>>2]*m;Pa=Ga*l+ +n[Q+(J<<3)>>2]*m}y=N|3;n[T+(y<<3)>>2]=Pa;n[T+(y<<3)+4>>2]=Oa;N=N+4|0;if((N|0)>(B|0)){Da=v;Ea=L;break}else Q=Q+(A<<3)|0}}b:do if((Ea|0)<(j|0)){if(i){Qa=Da;Ra=Ea}else{Q=Da;N=Ea;while(1){if(!Q){Sa=Z;Ta=Z}else{Sa=Z+ +n[Q+4>>2]*m;Ta=Z+ +n[Q>>2]*m}n[T+(N<<3)>>2]=Ta;n[T+(N<<3)+4>>2]=Sa;N=N+1|0;if((N|0)==(j|0))break b;else Q=Q+(D<<3)|0}}while(1){Q=c+(Ra<<3)|0;N=0;da=0.0;ta=0.0;while(1){R=+n[Ca+(N<<3)>>2];S=+n[Ca+(N<<3)+4>>2];ca=+n[Q>>2];ea=+n[Q+4>>2];da=da+(R*ca-S*ea);ta=ta+(S*ca+R*ea);N=N+1|0;if((N|0)==(H|0))break;else Q=Q+(z<<3)|0}ea=da*l;R=ta*l;if(!Qa){Ua=R;Va=ea}else{Ua=R+ +n[Qa+4>>2]*m;Va=ea+ +n[Qa>>2]*m}n[T+(Ra<<3)>>2]=Va;n[T+(Ra<<3)+4>>2]=Ua;Ra=Ra+1|0;if((Ra|0)==(j|0))break;else Qa=Qa+(D<<3)|0}}while(0);M=M+1|0;if((M|0)==(w|0))break a;else{O=O+(F<<3)|0;U=U+(C<<3)|0;T=T+(g<<3)|0;v=v+(C<<3)|0}}}v=s+8|0;g1c(v|0,0,1152)|0;f[s>>2]=v;T=s+4|0;f[T>>2]=j;if(j>>>0>72){U=bYc(j>>>0>268435455?-1:j<<4)|0;g1c(U|0,0,j<<4|0)|0;f[s>>2]=U;Wa=U}else Wa=v;if((w|0)>0){U=(G|0)==0;O=(j|0)>0;M=(H|0)>0;i=j+-4|0;A=(j|0)<4;L=j<<4;B=j&-4;J=U|(H|0)<1;K=a;b=e;P=0;t=h;while(1){if(J)Xa=U?K:G;else{Q=0;do{N=K+((Y(Q,E)|0)<<3)|0;y=f[N+4>>2]|0;d=G+(Q<<3)|0;f[d>>2]=f[N>>2];f[d+4>>2]=y;Q=Q+1|0}while((Q|0)!=(H|0));Xa=G}if(O)g1c(Wa|0,0,L|0)|0;if(M){Q=c;y=0;while(1){Z=+n[Xa+(y<<3)>>2];ea=+n[Xa+(y<<3)+4>>2];if(A)Ya=0;else{d=0;do{R=+n[Q+(d<<3)>>2];ca=+n[Q+(d<<3)+4>>2];N=Wa+(d<<4)|0;V=Wa+(d<<4)+8|0;S=+p[V>>3]+(ea*R+Z*ca);$=d|1;fa=+n[Q+($<<3)>>2];W=+n[Q+($<<3)+4>>2];Za=Wa+($<<4)|0;_a=Wa+($<<4)+8|0;ua=+p[Za>>3]+(Z*fa-ea*W);X=+p[_a>>3]+(ea*fa+Z*W);p[N>>3]=+p[N>>3]+(Z*R-ea*ca);p[V>>3]=S;p[Za>>3]=ua;p[_a>>3]=X;_a=d|2;X=+n[Q+(_a<<3)>>2];ua=+n[Q+(_a<<3)+4>>2];Za=Wa+(_a<<4)|0;V=Wa+(_a<<4)+8|0;S=+p[V>>3]+(ea*X+Z*ua);_a=d|3;ca=+n[Q+(_a<<3)>>2];R=+n[Q+(_a<<3)+4>>2];N=Wa+(_a<<4)|0;$=Wa+(_a<<4)+8|0;W=+p[N>>3]+(Z*ca-ea*R);fa=+p[$>>3]+(ea*ca+Z*R);p[Za>>3]=+p[Za>>3]+(Z*X-ea*ua);p[V>>3]=S;p[N>>3]=W;p[$>>3]=fa;d=d+4|0}while((d|0)<=(i|0));Ya=B}if((Ya|0)<(j|0)){d=Ya;do{fa=+n[Q+(d<<3)>>2];W=+n[Q+(d<<3)+4>>2];$=Wa+(d<<4)|0;p[$>>3]=+p[$>>3]+(Z*fa-ea*W);$=Wa+(d<<4)+8|0;p[$>>3]=+p[$>>3]+(ea*fa+Z*W);d=d+1|0}while((d|0)!=(j|0))}y=y+1|0;if((y|0)==(H|0))break;else Q=Q+(z<<3)|0}}if(!b){if(O){Q=0;do{Z=+p[Wa+(Q<<4)+8>>3]*l;n[t+(Q<<3)>>2]=+p[Wa+(Q<<4)>>3]*l;n[t+(Q<<3)+4>>2]=Z;Q=Q+1|0}while((Q|0)!=(j|0))}}else if(O){Q=0;y=b;while(1){Z=+p[Wa+(Q<<4)+8>>3]*l+ +n[y+4>>2]*m;n[t+(Q<<3)>>2]=+p[Wa+(Q<<4)>>3]*l+ +n[y>>2]*m;n[t+(Q<<3)+4>>2]=Z;Q=Q+1|0;if((Q|0)==(j|0))break;else y=y+(D<<3)|0}}P=P+1|0;if((P|0)==(w|0))break;else{K=K+(F<<3)|0;b=b+(C<<3)|0;t=t+(g<<3)|0}}$a=f[s>>2]|0}else $a=Wa;if(($a|0)!=(v|0)){if($a|0)dYc($a);f[s>>2]=v;f[T>>2]=72}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)dYc(s);f[r>>2]=k;f[x>>2]=136;u=q;return}function pY(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;o=u;u=u+2320|0;q=o+1160|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;g1c(k|0,0,1152)|0;f[q>>2]=k;w=q+4|0;f[w>>2]=72;x=b>>>4;y=d>>>4;z=g>>>4;g=i>>>4;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>31&(t|0)>1){f[w>>2]=t;if(t>>>0>72){z=bYc(t>>>0>268435455?-1:t<<4)|0;g1c(z|0,0,t<<4|0)|0;f[q>>2]=z;D=x;E=1;F=z;G=t;H=40}else{D=x;E=1;F=k;G=t;H=40}}else{I=x;J=1;K=t;H=5}else{I=1;J=x;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;g1c(s|0,0,1152)|0;f[r>>2]=s;z=r+4|0;f[z>>2]=72;if(b>>>0>31&(t|0)>1){f[w>>2]=v;if(v>>>0>72){t=bYc(v>>>0>268435455?-1:v<<4)|0;g1c(t|0,0,v<<4|0)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<4)|0;A=L+(t<<4)|0;f[A>>2]=f[b>>2];f[A+4>>2]=f[b+4>>2];f[A+8>>2]=f[b+8>>2];f[A+12>>2]=f[b+12>>2];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>31){f[z>>2]=j;if(j>>>0>72){d=bYc(j>>>0>268435455?-1:j<<4)|0;g1c(d|0,0,j<<4|0)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<4)|0;t=N+(d<<4)|0;f[t>>2]=f[L>>2];f[t+4>>2]=f[L+4>>2];f[t+8>>2]=f[L+8>>2];f[t+12>>2]=f[L+12>>2];d=d+1|0}while((d|0)<(j|0));O=N}else O=N}else O=c;a:do if((v|0)>0){N=C<<1;d=j+-2|0;if((j|0)<2){L=(j|0)==1;t=e;x=0;b=h;while(1){P=+p[M+(x<<4)>>3]*l;Q=+p[M+(x<<4)+8>>3]*l;if(L){A=t;i=0;while(1){R=+p[O+(i<<4)>>3];S=+p[O+(i<<4)+8>>3];T=P*R-Q*S;U=Q*R+P*S;if(!A){V=U;W=T}else{V=U+ +p[A+8>>3]*m;W=T+ +p[A>>3]*m}p[b+(i<<4)>>3]=W;p[b+(i<<4)+8>>3]=V;i=i+1|0;if((i|0)==(j|0))break;else A=A+(C<<4)|0}}x=x+1|0;if((x|0)==(v|0))break a;else{t=t+(B<<4)|0;b=b+(g<<4)|0}}}b=d>>>1;t=(b<<1)+2|0;x=(t|0)<(j|0);L=e;A=0;i=h;X=e+(Y(C,(b<<5)+32|0)|0)|0;while(1){P=+p[M+(A<<4)>>3]*l;Q=+p[M+(A<<4)+8>>3]*l;b=L;Z=0;while(1){T=+p[O+(Z<<4)>>3];U=+p[O+(Z<<4)+8>>3];S=P*T-Q*U;R=Q*T+P*U;_=Z|1;U=+p[O+(_<<4)>>3];T=+p[O+(_<<4)+8>>3];$=P*U-Q*T;aa=Q*U+P*T;if(!b){p[i+(Z<<4)>>3]=S;p[i+(Z<<4)+8>>3]=R;ba=aa;ca=$}else{T=R+ +p[b+8>>3]*m;p[i+(Z<<4)>>3]=S+ +p[b>>3]*m;p[i+(Z<<4)+8>>3]=T;ba=aa+ +p[b+(C<<4)+8>>3]*m;ca=$+ +p[b+(C<<4)>>3]*m}p[i+(_<<4)>>3]=ca;p[i+(_<<4)+8>>3]=ba;Z=Z+2|0;if((Z|0)>(d|0))break;else b=b+(N<<4)|0}if(x){b=X;Z=t;while(1){$=+p[O+(Z<<4)>>3];aa=+p[O+(Z<<4)+8>>3];T=P*$-Q*aa;S=Q*$+P*aa;if(!b){da=S;ea=T}else{da=S+ +p[b+8>>3]*m;ea=T+ +p[b>>3]*m}p[i+(Z<<4)>>3]=ea;p[i+(Z<<4)+8>>3]=da;Z=Z+1|0;if((Z|0)==(j|0))break;else b=b+(C<<4)|0}}A=A+1|0;if((A|0)==(v|0))break;else{L=L+(B<<4)|0;i=i+(g<<4)|0;X=X+(B<<4)|0}}}while(0);O=f[r>>2]|0;if((O|0)!=(s|0)){if(O|0)dYc(O);f[r>>2]=s;f[z>>2]=72}}else{D=I;E=J;F=0;G=K;H=40}b:do if((H|0)==40){if(n&2|0){if((v|0)<=0)break;K=(F|0)==0;J=G+-4|0;I=(G|0)<4;z=G&-4;s=K|(G|0)<1;O=(j|0)>0;M=a;X=e;i=0;L=h;while(1){if(s)fa=K?M:F;else{A=0;do{t=M+((Y(A,D)|0)<<4)|0;x=F+(A<<4)|0;f[x>>2]=f[t>>2];f[x+4>>2]=f[t+4>>2];f[x+8>>2]=f[t+8>>2];f[x+12>>2]=f[t+12>>2];A=A+1|0}while((A|0)!=(G|0));fa=F}if(O){A=c;t=X;x=0;while(1){if(I){ga=0;ha=0.0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0}else{N=0;da=0.0;ea=0.0;ba=0.0;ca=0.0;V=0.0;W=0.0;P=0.0;Q=0.0;while(1){T=+p[fa+(N<<4)>>3];S=+p[fa+(N<<4)+8>>3];aa=+p[A+(N<<4)>>3];$=+p[A+(N<<4)+8>>3];R=ca+(T*aa-S*$);U=V+(S*aa+T*$);d=N|1;$=+p[fa+(d<<4)>>3];T=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];S=+p[A+(d<<4)+8>>3];pa=ba+($*aa-T*S);qa=Q+(T*aa+$*S);d=N|2;S=+p[fa+(d<<4)>>3];$=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];T=+p[A+(d<<4)+8>>3];ra=ea+(S*aa-$*T);sa=P+($*aa+S*T);d=N|3;T=+p[fa+(d<<4)>>3];S=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];$=+p[A+(d<<4)+8>>3];ta=da+(T*aa-S*$);ua=W+(S*aa+T*$);N=N+4|0;if((N|0)>(J|0)){ga=z;ha=ta;ia=ra;ja=pa;ka=R;la=U;ma=ua;na=sa;oa=qa;break}else{da=ta;ea=ra;ba=pa;ca=R;V=U;W=ua;P=sa;Q=qa}}}if((ga|0)<(G|0)){N=ga;Q=ka;P=la;while(1){W=+p[fa+(N<<4)>>3];V=+p[fa+(N<<4)+8>>3];ca=+p[A+(N<<4)>>3];ba=+p[A+(N<<4)+8>>3];ea=Q+(W*ca-V*ba);da=P+(V*ca+W*ba);N=N+1|0;if((N|0)==(G|0)){va=ea;wa=da;break}else{Q=ea;P=da}}}else{va=ka;wa=la}P=(ha+(ia+(ja+va)))*l;Q=(ma+(na+(oa+wa)))*l;if(!t){xa=Q;ya=P}else{xa=Q+ +p[t+8>>3]*m;ya=P+ +p[t>>3]*m}p[L+(x<<4)>>3]=ya;p[L+(x<<4)+8>>3]=xa;x=x+1|0;if((x|0)==(j|0))break;else{A=A+(y<<4)|0;t=t+(C<<4)|0}}}i=i+1|0;if((i|0)==(v|0))break b;else{M=M+(E<<4)|0;X=X+(B<<4)|0;L=L+(g<<4)|0}}}L=j<<4;if(L>>>0<1601){if((v|0)<=0)break;X=(F|0)==0;M=j+-4|0;i=(j|0)<4;z=(G|0)>0;J=C<<2;I=C<<1;O=C*3|0;K=M>>>2;s=(K<<2)+4|0;t=X|(G|0)<1;P=l*0.0;A=a;x=e;N=0;d=h;b=e+(Y((K<<6)+64|0,C)|0)|0;while(1){if(t)za=X?A:F;else{K=0;do{Z=A+((Y(K,D)|0)<<4)|0;_=F+(K<<4)|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2];f[_+8>>2]=f[Z+8>>2];f[_+12>>2]=f[Z+12>>2];K=K+1|0}while((K|0)!=(G|0));za=F}if(i){Aa=x;Ba=0}else{K=x;Z=0;while(1){if(z){_=c+(Z<<4)|0;Ca=0;Q=0.0;da=0.0;ea=0.0;ba=0.0;W=0.0;ca=0.0;V=0.0;qa=0.0;while(1){sa=+p[za+(Ca<<4)>>3];ua=+p[za+(Ca<<4)+8>>3];U=+p[_>>3];R=+p[_+8>>3];pa=da+(sa*U-ua*R);ra=V+(ua*U+sa*R);R=+p[_+16>>3];U=+p[_+24>>3];ta=Q+(sa*R-ua*U);$=ca+(ua*R+sa*U);U=+p[_+32>>3];R=+p[_+40>>3];T=ba+(sa*U-ua*R);aa=W+(ua*U+sa*R);R=+p[_+48>>3];U=+p[_+56>>3];S=ea+(sa*R-ua*U);Da=qa+(ua*R+sa*U);Ca=Ca+1|0;if((Ca|0)==(G|0)){Ea=ta;Fa=pa;Ga=S;Ha=T;Ia=aa;Ja=$;Ka=ra;La=Da;break}else{_=_+(y<<4)|0;Q=ta;da=pa;ea=S;ba=T;W=aa;ca=$;V=ra;qa=Da}}}else{Ea=0.0;Fa=0.0;Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0}qa=Fa*l;V=Ka*l;if(!K){p[d+(Z<<4)>>3]=qa;p[d+(Z<<4)+8>>3]=V;_=Z|1;p[d+(_<<4)>>3]=Ea*l;p[d+(_<<4)+8>>3]=Ja*l;_=Z|2;p[d+(_<<4)>>3]=Ha*l;p[d+(_<<4)+8>>3]=Ia*l;Ma=La*l;Na=Ga*l}else{ca=V+ +p[K+8>>3]*m;p[d+(Z<<4)>>3]=qa+ +p[K>>3]*m;p[d+(Z<<4)+8>>3]=ca;ca=Ja*l+ +p[K+(C<<4)+8>>3]*m;_=Z|1;p[d+(_<<4)>>3]=Ea*l+ +p[K+(C<<4)>>3]*m;p[d+(_<<4)+8>>3]=ca;ca=Ia*l+ +p[K+(I<<4)+8>>3]*m;_=Z|2;p[d+(_<<4)>>3]=Ha*l+ +p[K+(I<<4)>>3]*m;p[d+(_<<4)+8>>3]=ca;Ma=La*l+ +p[K+(O<<4)+8>>3]*m;Na=Ga*l+ +p[K+(O<<4)>>3]*m}_=Z|3;p[d+(_<<4)>>3]=Na;p[d+(_<<4)+8>>3]=Ma;Z=Z+4|0;if((Z|0)>(M|0)){Aa=b;Ba=s;break}else K=K+(J<<4)|0}}c:do if((Ba|0)<(j|0)){if(z){Oa=Aa;Pa=Ba}else{K=Aa;Z=Ba;while(1){if(!K){Qa=P;Ra=P}else{Qa=P+ +p[K+8>>3]*m;Ra=P+ +p[K>>3]*m}p[d+(Z<<4)>>3]=Ra;p[d+(Z<<4)+8>>3]=Qa;Z=Z+1|0;if((Z|0)==(j|0))break c;else K=K+(C<<4)|0}}while(1){K=c+(Pa<<4)|0;Z=0;ca=0.0;qa=0.0;while(1){V=+p[za+(Z<<4)>>3];W=+p[za+(Z<<4)+8>>3];ba=+p[K>>3];ea=+p[K+8>>3];ca=ca+(V*ba-W*ea);qa=qa+(W*ba+V*ea);Z=Z+1|0;if((Z|0)==(G|0))break;else K=K+(y<<4)|0}ea=ca*l;V=qa*l;if(!Oa){Sa=V;Ta=ea}else{Sa=V+ +p[Oa+8>>3]*m;Ta=ea+ +p[Oa>>3]*m}p[d+(Pa<<4)>>3]=Ta;p[d+(Pa<<4)+8>>3]=Sa;Pa=Pa+1|0;if((Pa|0)==(j|0))break;else Oa=Oa+(C<<4)|0}}while(0);N=N+1|0;if((N|0)==(v|0))break b;else{A=A+(E<<4)|0;x=x+(B<<4)|0;d=d+(g<<4)|0;b=b+(B<<4)|0}}}b=r+8|0;g1c(b|0,0,1152)|0;f[r>>2]=b;d=r+4|0;f[d>>2]=j;if(j>>>0>72){x=bYc(j>>>0>268435455?-1:j<<4)|0;g1c(x|0,0,L|0)|0;f[r>>2]=x;Ua=x}else Ua=b;if((v|0)>0){x=(F|0)==0;A=(j|0)>0;N=(G|0)>0;z=j+-4|0;J=(j|0)<4;s=j&-4;M=x|(G|0)<1;O=a;I=e;i=0;X=h;while(1){if(M)Va=x?O:F;else{t=0;do{K=O+((Y(t,D)|0)<<4)|0;Z=F+(t<<4)|0;f[Z>>2]=f[K>>2];f[Z+4>>2]=f[K+4>>2];f[Z+8>>2]=f[K+8>>2];f[Z+12>>2]=f[K+12>>2];t=t+1|0}while((t|0)!=(G|0));Va=F}if(A)g1c(Ua|0,0,L|0)|0;if(N){t=c;K=0;while(1){P=+p[Va+(K<<4)>>3];ea=+p[Va+(K<<4)+8>>3];if(J)Wa=0;else{Z=0;do{V=+p[t+(Z<<4)>>3];ba=+p[t+(Z<<4)+8>>3];_=Ua+(Z<<4)|0;Ca=Ua+(Z<<4)+8|0;W=+p[Ca>>3]+(ea*V+P*ba);Xa=Z|1;da=+p[t+(Xa<<4)>>3];Q=+p[t+(Xa<<4)+8>>3];Ya=Ua+(Xa<<4)|0;Za=Ua+(Xa<<4)+8|0;Da=+p[Ya>>3]+(P*da-ea*Q);ra=+p[Za>>3]+(ea*da+P*Q);p[_>>3]=+p[_>>3]+(P*V-ea*ba);p[Ca>>3]=W;p[Ya>>3]=Da;p[Za>>3]=ra;Za=Z|2;ra=+p[t+(Za<<4)>>3];Da=+p[t+(Za<<4)+8>>3];Ya=Ua+(Za<<4)|0;Ca=Ua+(Za<<4)+8|0;W=+p[Ca>>3]+(ea*ra+P*Da);Za=Z|3;ba=+p[t+(Za<<4)>>3];V=+p[t+(Za<<4)+8>>3];_=Ua+(Za<<4)|0;Xa=Ua+(Za<<4)+8|0;Q=+p[_>>3]+(P*ba-ea*V);da=+p[Xa>>3]+(ea*ba+P*V);p[Ya>>3]=+p[Ya>>3]+(P*ra-ea*Da);p[Ca>>3]=W;p[_>>3]=Q;p[Xa>>3]=da;Z=Z+4|0}while((Z|0)<=(z|0));Wa=s}if((Wa|0)<(j|0)){Z=Wa;do{da=+p[t+(Z<<4)>>3];Q=+p[t+(Z<<4)+8>>3];Xa=Ua+(Z<<4)|0;p[Xa>>3]=+p[Xa>>3]+(P*da-ea*Q);Xa=Ua+(Z<<4)+8|0;p[Xa>>3]=ea*da+P*Q+ +p[Xa>>3];Z=Z+1|0}while((Z|0)!=(j|0))}K=K+1|0;if((K|0)==(G|0))break;else t=t+(y<<4)|0}}if(!I){if(A){t=0;do{P=+p[Ua+(t<<4)+8>>3]*l;p[X+(t<<4)>>3]=+p[Ua+(t<<4)>>3]*l;p[X+(t<<4)+8>>3]=P;t=t+1|0}while((t|0)!=(j|0))}}else if(A){t=0;K=I;while(1){P=+p[Ua+(t<<4)+8>>3]*l+ +p[K+8>>3]*m;p[X+(t<<4)>>3]=+p[Ua+(t<<4)>>3]*l+ +p[K>>3]*m;p[X+(t<<4)+8>>3]=P;t=t+1|0;if((t|0)==(j|0))break;else K=K+(C<<4)|0}}i=i+1|0;if((i|0)==(v|0))break;else{O=O+(E<<4)|0;I=I+(B<<4)|0;X=X+(g<<4)|0}}_a=f[r>>2]|0}else _a=Ua;if((_a|0)!=(b|0)){if(_a|0)dYc(_a);f[r>>2]=b;f[d>>2]=72}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)dYc(r);f[q>>2]=k;f[w>>2]=72;u=o;return}function qY(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;q=u;u=u+2160|0;r=q+1096|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;f[r>>2]=k;x=r+4|0;f[x>>2]=264;y=b>>>2;z=d>>>2;A=g>>>2;g=i>>>2;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>7&(v|0)>1){f[x>>2]=v;if(v>>>0>264){A=bYc(v>>>0>1073741823?-1:v<<2)|0;f[r>>2]=A;E=y;F=1;G=A;H=v;I=43}else{E=y;F=1;G=k;H=v;I=43}}else{J=y;K=1;L=v;I=5}else{J=1;K=y;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;f[s>>2]=t;A=s+4|0;f[A>>2]=264;if(b>>>0>7&(v|0)>1){f[x>>2]=w;if(w>>>0>264){v=bYc(w>>>0>1073741823?-1:w<<2)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<2)|0;f[M+(v<<2)>>2]=f[b>>2];v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>7){f[A>>2]=j;if(j>>>0>264){d=bYc(j>>>0>1073741823?-1:j<<2)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<2)|0;f[O+(d<<2)>>2]=f[M>>2];d=d+1|0}while((d|0)!=(j|0));P=O;Q=O}else{P=O;Q=O}}else{P=c;Q=t}a:do if((w|0)>0){O=D<<1;if((j|0)<2){if((j|0)==1){R=h;S=0;T=e}else break;while(1){U=+n[N+(S<<2)>>2]*l*+n[P>>2];if(!T)V=U;else V=U+ +n[T>>2]*m;n[R>>2]=V;S=S+1|0;if((S|0)==(w|0))break a;else{R=R+(g<<2)|0;T=T+(C<<2)|0}}}d=j+-2|0;M=((d|0)>1?d:1)>>>1;v=Y(M,O)|0;y=(M<<1)+2|0;if((y|0)>=(j|0)){M=h;b=0;B=e;while(1){U=+n[N+(b<<2)>>2]*l;i=B;W=0;while(1){X=U*+n[P+(W<<2)>>2];Z=W|1;_=U*+n[P+(Z<<2)>>2];if(!i){n[M+(W<<2)>>2]=X;$=_}else{n[M+(W<<2)>>2]=X+ +n[i>>2]*m;$=_+ +n[i+(D<<2)>>2]*m}n[M+(Z<<2)>>2]=$;W=W+2|0;if((W|0)>(d|0))break;else i=i+(O<<2)|0}b=b+1|0;if((b|0)==(w|0))break a;else{M=M+(g<<2)|0;B=B+(C<<2)|0}}}B=h;M=0;b=e;i=e+(O<<2)|0;while(1){U=+n[N+(M<<2)>>2]*l;W=b;Z=0;while(1){_=U*+n[P+(Z<<2)>>2];aa=Z|1;X=U*+n[P+(aa<<2)>>2];if(!W){n[B+(Z<<2)>>2]=_;ba=X}else{n[B+(Z<<2)>>2]=_+ +n[W>>2]*m;ba=X+ +n[W+(D<<2)>>2]*m}n[B+(aa<<2)>>2]=ba;Z=Z+2|0;if((Z|0)>(d|0))break;else W=W+(O<<2)|0}W=i+(v<<2)|0;Z=y;while(1){X=U*+n[P+(Z<<2)>>2];if(!W)ca=X;else ca=X+ +n[W>>2]*m;n[B+(Z<<2)>>2]=ca;Z=Z+1|0;if((Z|0)==(j|0))break;else W=W+(D<<2)|0}M=M+1|0;if((M|0)==(w|0))break;else{B=B+(g<<2)|0;b=b+(C<<2)|0;i=i+(C<<2)|0}}}while(0);if((Q|0)!=(t|0)){dYc(Q);f[s>>2]=t;f[A>>2]=264}}else{E=J;F=K;G=0;H=L;I=43}b:do if((I|0)==43){if(o&2|0){if((w|0)<=0)break;L=(G|0)==0;K=(j|0)>0;J=H+-4|0;A=(H|0)<4;t=H&-4;Q=L|(H|0)<1;P=(H|0)>0;N=(t|0)<(H|0);ca=l*0.0;T=a;R=h;S=0;i=e;while(1){if(Q)da=L?T:G;else{b=0;do{B=T+((Y(b,E)|0)<<2)|0;f[G+(b<<2)>>2]=f[B>>2];b=b+1|0}while((b|0)!=(H|0));da=G}c:do if(K){if(!A){b=c;B=i;M=0;while(1){ba=0.0;$=0.0;V=0.0;U=0.0;y=0;do{U=U+ +n[da+(y<<2)>>2]*+n[b+(y<<2)>>2];v=y|1;V=V+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];v=y|2;$=$+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];v=y|3;ba=ba+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];y=y+4|0}while((y|0)<=(J|0));if(N){X=U;y=t;while(1){_=X+ +n[da+(y<<2)>>2]*+n[b+(y<<2)>>2];y=y+1|0;if((y|0)==(H|0)){ea=_;break}else X=_}}else ea=U;X=(ba+($+(V+ea)))*l;if(!B)fa=X;else fa=X+ +n[B>>2]*m;n[R+(M<<2)>>2]=fa;M=M+1|0;if((M|0)==(j|0))break c;else{b=b+(z<<2)|0;B=B+(D<<2)|0}}}if(P){ga=c;ha=i;ia=0}else{B=i;b=0;while(1){if(!B)ja=ca;else ja=ca+ +n[B>>2]*m;n[R+(b<<2)>>2]=ja;b=b+1|0;if((b|0)==(j|0))break c;else B=B+(D<<2)|0}}while(1){X=0.0;B=0;do{X=X+ +n[da+(B<<2)>>2]*+n[ga+(B<<2)>>2];B=B+1|0}while((B|0)!=(H|0));V=(X+0.0)*l;if(!ha)ka=V;else ka=V+ +n[ha>>2]*m;n[R+(ia<<2)>>2]=ka;ia=ia+1|0;if((ia|0)==(j|0))break;else{ga=ga+(z<<2)|0;ha=ha+(D<<2)|0}}}while(0);S=S+1|0;if((S|0)==(w|0))break b;else{T=T+(F<<2)|0;R=R+(g<<2)|0;i=i+(C<<2)|0}}}if(j<<2>>>0<1601){if((w|0)<=0)break;i=(G|0)==0;R=j+-4|0;T=(j|0)<4;S=(H|0)>0;P=D<<2;t=D<<1;N=D*3|0;J=R>>>2;A=(J<<2)+4|0;K=i|(H|0)<1;ca=l*0.0;V=ca;L=a;Q=h;B=0;b=e;M=e+(Y((J<<4)+16|0,D)|0)|0;while(1){if(K)la=i?L:G;else{J=0;do{y=L+((Y(J,E)|0)<<2)|0;f[G+(J<<2)>>2]=f[y>>2];J=J+1|0}while((J|0)!=(H|0));la=G}d:do if(T){ma=b;na=0}else{if(S){oa=b;pa=0}else{J=b;y=0;while(1){v=y|2;O=y|1;if(!J){n[Q+(y<<2)>>2]=V;n[Q+(O<<2)>>2]=V;n[Q+(v<<2)>>2]=V;qa=ca}else{n[Q+(y<<2)>>2]=ca+ +n[J>>2]*m;n[Q+(O<<2)>>2]=ca+ +n[J+(D<<2)>>2]*m;n[Q+(v<<2)>>2]=ca+ +n[J+(t<<2)>>2]*m;qa=ca+ +n[J+(N<<2)>>2]*m}n[Q+((y|3)<<2)>>2]=qa;y=y+4|0;if((y|0)>(R|0)){ma=M;na=A;break d}else J=J+(P<<2)|0}}while(1){$=0.0;ba=0.0;U=0.0;_=0.0;J=c+(pa<<2)|0;y=0;while(1){ra=+n[la+(y<<2)>>2];_=_+ra*+n[J>>2];U=U+ra*+n[J+4>>2];ba=ba+ra*+n[J+8>>2];$=$+ra*+n[J+12>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}X=_*l;J=pa|2;ra=U*l;y=pa|1;sa=ba*l;ta=$*l;if(!oa){n[Q+(pa<<2)>>2]=X;n[Q+(y<<2)>>2]=ra;n[Q+(J<<2)>>2]=sa;ua=ta}else{n[Q+(pa<<2)>>2]=X+ +n[oa>>2]*m;n[Q+(y<<2)>>2]=ra+ +n[oa+(D<<2)>>2]*m;n[Q+(J<<2)>>2]=sa+ +n[oa+(t<<2)>>2]*m;ua=ta+ +n[oa+(N<<2)>>2]*m}n[Q+((pa|3)<<2)>>2]=ua;pa=pa+4|0;if((pa|0)>(R|0)){ma=M;na=A;break}else oa=oa+(P<<2)|0}}while(0);e:do if((na|0)<(j|0)){if(S){va=ma;wa=na}else{J=ma;y=na;while(1){if(!J)xa=ca;else xa=ca+ +n[J>>2]*m;n[Q+(y<<2)>>2]=xa;y=y+1|0;if((y|0)==(j|0))break e;else J=J+(D<<2)|0}}while(1){ta=0.0;J=c+(wa<<2)|0;y=0;while(1){ta=ta+ +n[la+(y<<2)>>2]*+n[J>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}$=ta*l;if(!va)ya=$;else ya=$+ +n[va>>2]*m;n[Q+(wa<<2)>>2]=ya;wa=wa+1|0;if((wa|0)==(j|0))break;else va=va+(D<<2)|0}}while(0);B=B+1|0;if((B|0)==(w|0))break b;else{L=L+(F<<2)|0;Q=Q+(g<<2)|0;b=b+(C<<2)|0;M=M+(C<<2)|0}}}M=s+8|0;f[s>>2]=M;b=s+4|0;f[b>>2]=j;if(j>>>0>136){Q=bYc(j>>>0>536870911?-1:j<<3)|0;f[s>>2]=Q;za=Q;Aa=Q}else{za=M;Aa=M}if((w|0)>0){Q=(G|0)==0;L=(j|0)>0;B=(H|0)>0;S=j+-4|0;P=(j|0)<4;A=j<<3;R=j&-4;N=Q|(H|0)<1;t=(R|0)<(j|0);T=a;i=h;K=0;J=e;while(1){if(N)Ba=Q?T:G;else{y=0;do{v=T+((Y(y,E)|0)<<2)|0;f[G+(y<<2)>>2]=f[v>>2];y=y+1|0}while((y|0)!=(H|0));Ba=G}if(L)g1c(Aa|0,0,A|0)|0;f:do if(B){if(P){if(L){Ca=c;Da=0}else break;while(1){ca=+n[Ba+(Da<<2)>>2];y=0;do{v=Aa+(y<<3)|0;p[v>>3]=+p[v>>3]+ca*+n[Ca+(y<<2)>>2];y=y+1|0}while((y|0)!=(j|0));Da=Da+1|0;if((Da|0)==(H|0))break f;else Ca=Ca+(z<<2)|0}}if(t){Ea=c;Fa=0}else{y=c;v=0;while(1){ca=+n[Ba+(v<<2)>>2];O=0;do{d=Aa+(O<<3)|0;W=O|1;Z=Aa+(W<<3)|0;ta=+p[Z>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(O<<2)>>2];p[Z>>3]=ta;Z=O|2;d=Aa+(Z<<3)|0;W=O|3;aa=Aa+(W<<3)|0;ta=+p[aa>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(Z<<2)>>2];p[aa>>3]=ta;O=O+4|0}while((O|0)<=(S|0));v=v+1|0;if((v|0)==(H|0))break f;else y=y+(z<<2)|0}}while(1){ca=+n[Ba+(Fa<<2)>>2];y=0;do{v=Aa+(y<<3)|0;O=y|1;aa=Aa+(O<<3)|0;ta=+p[aa>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(y<<2)>>2];p[aa>>3]=ta;aa=y|2;v=Aa+(aa<<3)|0;O=y|3;Z=Aa+(O<<3)|0;ta=+p[Z>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(aa<<2)>>2];p[Z>>3]=ta;y=y+4|0}while((y|0)<=(S|0));Ga=R;do{y=Aa+(Ga<<3)|0;p[y>>3]=+p[y>>3]+ca*+n[Ea+(Ga<<2)>>2];Ga=Ga+1|0}while((Ga|0)!=(j|0));Fa=Fa+1|0;if((Fa|0)==(H|0))break;else Ea=Ea+(z<<2)|0}}while(0);if(!J){if(L){y=0;do{n[i+(y<<2)>>2]=+p[Aa+(y<<3)>>3]*l;y=y+1|0}while((y|0)!=(j|0))}}else if(L){y=0;Z=J;while(1){n[i+(y<<2)>>2]=+p[Aa+(y<<3)>>3]*l+ +n[Z>>2]*m;y=y+1|0;if((y|0)==(j|0))break;else Z=Z+(D<<2)|0}}K=K+1|0;if((K|0)==(w|0)){Ha=za;break}else{T=T+(F<<2)|0;i=i+(g<<2)|0;J=J+(C<<2)|0}}}else Ha=Aa;if((Ha|0)!=(M|0)){dYc(Ha);f[s>>2]=M;f[b>>2]=136}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)dYc(s);f[r>>2]=k;f[x>>2]=264;u=q;return}function rY(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;q=l+4|0;f[q>>2]=136;r=j&16;s=b>>>3;b=d>>>3;d=g>>>3;if(j&1){f[q>>2]=n;if(n>>>0>136){g=bYc(n>>>0>536870911?-1:n<<3)|0;f[l>>2]=g;t=s;v=1;w=g;x=n;y=g}else{t=s;v=1;w=i;x=n;y=i}}else{t=1;v=s;w=0;x=m;y=i}m=(o|0)>0;if(!(j&2)){if(m){j=(w|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;z=(x|0)>0;A=h&-4;B=(x|0)<1|j;C=(s>>>2<<5)+32|0;D=e;E=0;F=a;while(1){G=e+((Y(d,E)|0)<<3)|0;if(B)H=j?F:w;else{I=0;do{J=F+((Y(I,t)|0)<<3)|0;p[w+(I<<3)>>3]=+p[J>>3];I=I+1|0}while((I|0)!=(x|0));H=w}a:do if(!n)if(g){if(z)K=0;else{g1c(G|0,0,C|0)|0;L=A;break}do{I=c+(K<<3)|0;M=0.0;N=0.0;O=0.0;P=0.0;J=0;while(1){Q=+p[H+(J<<3)>>3];P=P+Q*+p[I>>3];O=O+Q*+p[I+8>>3];N=N+Q*+p[I+16>>3];M=M+Q*+p[I+24>>3];J=J+1|0;if((J|0)==(x|0))break;else I=I+(b<<3)|0}p[D+(K<<3)>>3]=P;p[D+((K|1)<<3)>>3]=O;p[D+((K|2)<<3)>>3]=N;p[D+((K|3)<<3)>>3]=M;K=K+4|0}while((K|0)<=(s|0));L=A}else{if(z)R=0;else{I=0;while(1){I=I+4|0;if((I|0)>(s|0)){L=A;break a}}}do{I=D+((R|3)<<3)|0;J=D+((R|2)<<3)|0;S=D+((R|1)<<3)|0;T=D+(R<<3)|0;U=c+(R<<3)|0;Q=+p[I>>3];V=+p[J>>3];W=+p[S>>3];X=+p[T>>3];Z=0;while(1){_=+p[H+(Z<<3)>>3];X=X+_*+p[U>>3];W=W+_*+p[U+8>>3];V=V+_*+p[U+16>>3];Q=Q+_*+p[U+24>>3];Z=Z+1|0;if((Z|0)==(x|0))break;else U=U+(b<<3)|0}p[T>>3]=X;p[S>>3]=W;p[J>>3]=V;p[I>>3]=Q;R=R+4|0}while((R|0)<=(s|0));L=A}else L=0;while(0);b:do if((h|0)>(L|0)){if(!g){if(z)$=L;else break;while(1){U=D+($<<3)|0;Z=c+($<<3)|0;M=+p[U>>3];aa=0;while(1){M=M+ +p[H+(aa<<3)>>3]*+p[Z>>3];aa=aa+1|0;if((aa|0)==(x|0))break;else Z=Z+(b<<3)|0}p[U>>3]=M;$=$+1|0;if(($|0)==(h|0))break b}}if(z)ba=L;else{g1c(G+(L<<3)|0,0,h-L<<3|0)|0;break}do{Z=c+(ba<<3)|0;Q=0.0;aa=0;while(1){Q=Q+ +p[H+(aa<<3)>>3]*+p[Z>>3];aa=aa+1|0;if((aa|0)==(x|0))break;else Z=Z+(b<<3)|0}p[D+(ba<<3)>>3]=Q;ba=ba+1|0}while((ba|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(o|0))break;else{D=D+(d<<3)|0;F=F+(v<<3)|0}}}}else if(m){m=(w|0)==0;F=(h|0)>0;D=(r|0)==0;r=x+-2|0;E=(x|0)<2;ba=x&-2;H=(x|0)<1|m;L=(x|0)>0;z=(ba|0)<(x|0);$=(x|0)>0;g=(ba|0)<(x|0);A=e;e=0;s=a;while(1){if(H)ca=m?s:w;else{a=0;do{R=s+((Y(a,t)|0)<<3)|0;p[w+(a<<3)>>3]=+p[R>>3];a=a+1|0}while((a|0)!=(x|0));ca=w}c:do if(F)if(D){if(E){a=c;R=0;while(1){if(L){M=0.0;K=0;while(1){V=M+ +p[ca+(K<<3)>>3]*+p[a+(K<<3)>>3];K=K+1|0;if((K|0)==(x|0)){da=V;break}else M=V}}else da=0.0;p[A+(R<<3)>>3]=da+0.0;R=R+1|0;if((R|0)==(h|0))break c;else a=a+(b<<3)|0}}else{ea=c;fa=0}while(1){M=0.0;Q=0.0;a=0;do{Q=Q+ +p[ca+(a<<3)>>3]*+p[ea+(a<<3)>>3];R=a|1;M=M+ +p[ca+(R<<3)>>3]*+p[ea+(R<<3)>>3];a=a+2|0}while((a|0)<=(r|0));if(z){V=Q;a=ba;while(1){W=V+ +p[ca+(a<<3)>>3]*+p[ea+(a<<3)>>3];a=a+1|0;if((a|0)==(x|0)){ga=W;break}else V=W}}else ga=Q;p[A+(fa<<3)>>3]=M+ga;fa=fa+1|0;if((fa|0)==(h|0))break;else ea=ea+(b<<3)|0}}else{if(E){a=c;R=0;while(1){K=A+(R<<3)|0;V=+p[K>>3];if($){W=V;C=0;while(1){X=W+ +p[ca+(C<<3)>>3]*+p[a+(C<<3)>>3];C=C+1|0;if((C|0)==(x|0)){ha=X;break}else W=X}}else ha=V;p[K>>3]=ha+0.0;R=R+1|0;if((R|0)==(h|0))break c;else a=a+(b<<3)|0}}else{ia=c;ja=0}while(1){a=A+(ja<<3)|0;W=0.0;M=+p[a>>3];R=0;do{M=M+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];C=R|1;W=W+ +p[ca+(C<<3)>>3]*+p[ia+(C<<3)>>3];R=R+2|0}while((R|0)<=(r|0));if(g){V=M;R=ba;while(1){Q=V+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];R=R+1|0;if((R|0)==(x|0)){ka=Q;break}else V=Q}}else ka=M;p[a>>3]=W+ka;ja=ja+1|0;if((ja|0)==(h|0))break;else ia=ia+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{A=A+(d<<3)|0;s=s+(v<<3)|0}}}if((y|0)==(i|0)){u=k;return}dYc(y);f[l>>2]=i;f[q>>2]=136;u=k;return}function sY(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0.0,Ja=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;g1c(i|0,0,1088)|0;f[l>>2]=i;r=l+4|0;f[r>>2]=136;s=j&16;t=b>>>3;b=d>>>3;d=g>>>4;if(j&1){f[r>>2]=o;if(o>>>0>136){g=bYc(o>>>0>536870911?-1:o<<3)|0;g1c(g|0,0,o<<3|0)|0;f[l>>2]=g;v=t;w=1;x=g;y=o}else{v=t;w=1;x=i;y=o}}else{v=1;w=t;x=0;y=m}m=(q|0)>0;if(!(j&2)){if(m){j=(x|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;z=(y|0)>0;A=h&-4;B=(y|0)<1|j;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(B)G=j?C:x;else{H=0;do{I=C+((Y(H,v)|0)<<3)|0;J=f[I+4>>2]|0;K=x+(H<<3)|0;f[K>>2]=f[I>>2];f[K+4>>2]=J;H=H+1|0}while((H|0)!=(y|0));G=x}if(o)L=0;else{H=0;do{if(g){M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0}else{J=H|1;K=H|2;I=H|3;M=+p[D+(K<<4)>>3];N=+p[D+(J<<4)>>3];O=+p[D+(H<<4)>>3];P=+p[D+(I<<4)>>3];Q=+p[D+(I<<4)+8>>3];R=+p[D+(K<<4)+8>>3];S=+p[D+(J<<4)+8>>3];T=+p[D+(H<<4)+8>>3]}if(z){J=c+(H<<3)|0;K=0;U=M;V=N;W=O;X=P;Z=Q;_=R;$=S;aa=T;while(1){ba=+n[G+(K<<3)>>2];ca=+n[G+(K<<3)+4>>2];da=+n[J>>2];ea=+n[J+4>>2];fa=W+(ba*da-ca*ea);ga=aa+(ca*da+ba*ea);ea=+n[J+8>>2];da=+n[J+12>>2];ha=V+(ba*ea-ca*da);ia=$+(ca*ea+ba*da);da=+n[J+16>>2];ea=+n[J+20>>2];ja=U+(ba*da-ca*ea);ka=_+(ca*da+ba*ea);ea=+n[J+24>>2];da=+n[J+28>>2];la=X+(ba*ea-ca*da);ma=Z+(ca*ea+ba*da);K=K+1|0;if((K|0)==(y|0)){na=ja;oa=ha;pa=fa;qa=la;ra=ma;sa=ka;ta=ia;ua=ga;break}else{J=J+(b<<3)|0;U=ja;V=ha;W=fa;X=la;Z=ma;_=ka;$=ia;aa=ga}}}else{na=M;oa=N;pa=O;qa=P;ra=Q;sa=R;ta=S;ua=T}p[D+(H<<4)>>3]=pa;p[D+(H<<4)+8>>3]=ua;J=H|1;p[D+(J<<4)>>3]=oa;p[D+(J<<4)+8>>3]=ta;J=H|2;p[D+(J<<4)>>3]=na;p[D+(J<<4)+8>>3]=sa;J=H|3;p[D+(J<<4)>>3]=qa;p[D+(J<<4)+8>>3]=ra;H=H+4|0}while((H|0)<=(t|0));L=A}a:do if((h|0)>(L|0))if(g){if(z)va=L;else{g1c(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{H=c+(va<<3)|0;J=0;aa=0.0;$=0.0;while(1){_=+n[G+(J<<3)>>2];Z=+n[G+(J<<3)+4>>2];X=+n[H>>2];W=+n[H+4>>2];aa=aa+(_*X-Z*W);$=$+(Z*X+_*W);J=J+1|0;if((J|0)==(y|0))break;else H=H+(b<<3)|0}p[D+(va<<4)>>3]=aa;p[D+(va<<4)+8>>3]=$;va=va+1|0}while((va|0)!=(h|0))}else{if(z)wa=L;else{H=L;while(1){H=H+1|0;if((H|0)==(h|0))break a}}do{H=D+(wa<<4)+8|0;J=D+(wa<<4)|0;K=c+(wa<<3)|0;I=0;W=+p[J>>3];_=+p[H>>3];while(1){X=+n[G+(I<<3)>>2];Z=+n[G+(I<<3)+4>>2];V=+n[K>>2];U=+n[K+4>>2];W=W+(X*V-Z*U);_=_+(Z*V+X*U);I=I+1|0;if((I|0)==(y|0))break;else K=K+(b<<3)|0}p[J>>3]=W;p[H>>3]=_;wa=wa+1|0}while((wa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(q|0))break;else{C=C+(w<<3)|0;D=D+(d<<4)|0}}}}else if(m){m=(x|0)==0;D=(s|0)==0;s=y+-2|0;C=(y|0)<2;E=y&-2;wa=(y|0)<1|m;G=(h|0)>0;L=(y|0)>0;z=(E|0)<(y|0);va=(y|0)>0;g=(E|0)<(y|0);A=a;a=e;e=0;while(1){if(wa)xa=m?A:x;else{t=0;do{o=A+((Y(t,v)|0)<<3)|0;j=f[o+4>>2]|0;B=x+(t<<3)|0;f[B>>2]=f[o>>2];f[B+4>>2]=j;t=t+1|0}while((t|0)!=(y|0));xa=x}b:do if(G)if(D){if(C){t=c;j=0;while(1){if(L){B=0;ra=0.0;qa=0.0;while(1){sa=+n[xa+(B<<3)>>2];na=+n[xa+(B<<3)+4>>2];ta=+n[t+(B<<3)>>2];oa=+n[t+(B<<3)+4>>2];ua=ra+(sa*ta-na*oa);pa=qa+(na*ta+sa*oa);B=B+1|0;if((B|0)==(y|0)){ya=ua;za=pa;break}else{ra=ua;qa=pa}}}else{ya=0.0;za=0.0}p[a+(j<<4)>>3]=ya+0.0;p[a+(j<<4)+8>>3]=za+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Aa=c;Ba=0}while(1){t=0;qa=0.0;ra=0.0;_=0.0;W=0.0;do{pa=+n[xa+(t<<3)>>2];ua=+n[xa+(t<<3)+4>>2];oa=+n[Aa+(t<<3)>>2];sa=+n[Aa+(t<<3)+4>>2];ra=ra+(pa*oa-ua*sa);_=_+(ua*oa+pa*sa);j=t|1;sa=+n[xa+(j<<3)>>2];pa=+n[xa+(j<<3)+4>>2];oa=+n[Aa+(j<<3)>>2];ua=+n[Aa+(j<<3)+4>>2];qa=qa+(sa*oa-pa*ua);W=W+(pa*oa+sa*ua);t=t+2|0}while((t|0)<=(s|0));if(z){t=E;ua=ra;sa=_;while(1){oa=+n[xa+(t<<3)>>2];pa=+n[xa+(t<<3)+4>>2];ta=+n[Aa+(t<<3)>>2];na=+n[Aa+(t<<3)+4>>2];T=ua+(oa*ta-pa*na);S=sa+(pa*ta+oa*na);t=t+1|0;if((t|0)==(y|0)){Ca=T;Da=S;break}else{ua=T;sa=S}}}else{Ca=ra;Da=_}p[a+(Ba<<4)>>3]=qa+Ca;p[a+(Ba<<4)+8>>3]=W+Da;Ba=Ba+1|0;if((Ba|0)==(h|0))break;else Aa=Aa+(b<<3)|0}}else{if(C){t=c;j=0;while(1){B=a+(j<<4)+8|0;H=a+(j<<4)|0;sa=+p[H>>3];ua=+p[B>>3];if(va){J=0;S=sa;T=ua;while(1){na=+n[xa+(J<<3)>>2];oa=+n[xa+(J<<3)+4>>2];ta=+n[t+(J<<3)>>2];pa=+n[t+(J<<3)+4>>2];R=S+(na*ta-oa*pa);Q=T+(oa*ta+na*pa);J=J+1|0;if((J|0)==(y|0)){Ea=R;Fa=Q;break}else{S=R;T=Q}}}else{Ea=sa;Fa=ua}p[H>>3]=Ea+0.0;p[B>>3]=Fa+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Ga=c;Ha=0}while(1){t=a+(Ha<<4)+8|0;j=a+(Ha<<4)|0;J=0;T=0.0;S=+p[j>>3];W=+p[t>>3];qa=0.0;do{_=+n[xa+(J<<3)>>2];ra=+n[xa+(J<<3)+4>>2];Q=+n[Ga+(J<<3)>>2];R=+n[Ga+(J<<3)+4>>2];S=S+(_*Q-ra*R);W=W+(ra*Q+_*R);o=J|1;R=+n[xa+(o<<3)>>2];_=+n[xa+(o<<3)+4>>2];Q=+n[Ga+(o<<3)>>2];ra=+n[Ga+(o<<3)+4>>2];T=T+(R*Q-_*ra);qa=qa+(_*Q+R*ra);J=J+2|0}while((J|0)<=(s|0));if(g){J=E;ua=S;sa=W;while(1){ra=+n[xa+(J<<3)>>2];R=+n[xa+(J<<3)+4>>2];Q=+n[Ga+(J<<3)>>2];_=+n[Ga+(J<<3)+4>>2];pa=ua+(ra*Q-R*_);na=sa+(R*Q+ra*_);J=J+1|0;if((J|0)==(y|0)){Ia=pa;Ja=na;break}else{ua=pa;sa=na}}}else{Ia=S;Ja=W}p[j>>3]=T+Ia;p[t>>3]=qa+Ja;Ha=Ha+1|0;if((Ha|0)==(h|0))break;else Ga=Ga+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{A=A+(w<<3)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)dYc(d);f[l>>2]=i;f[r>>2]=136;u=k;return}function tY(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0.0,Ba=0.0;k=u;u=u+1168|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;g1c(i|0,0,1152)|0;f[l>>2]=i;q=l+4|0;f[q>>2]=72;r=j&16;s=b>>>4;b=d>>>4;d=g>>>4;if(j&1){f[q>>2]=n;if(n>>>0>72){g=bYc(n>>>0>268435455?-1:n<<4)|0;g1c(g|0,0,n<<4|0)|0;f[l>>2]=g;t=s;v=1;w=g;x=n}else{t=s;v=1;w=i;x=n}}else{t=1;v=s;w=0;x=m}m=(o|0)>0;if(!(j&2)){if(m){j=(w|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;y=(x|0)>0;z=h&-4;A=(x|0)<1|j;B=(s>>>2<<6)+64|0;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(A)G=j?C:w;else{H=0;do{I=C+((Y(H,t)|0)<<4)|0;J=w+(H<<4)|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];f[J+8>>2]=f[I+8>>2];f[J+12>>2]=f[I+12>>2];H=H+1|0}while((H|0)!=(x|0));G=w}a:do if(!n)if(g){if(y)K=0;else{g1c(F|0,0,B|0)|0;L=z;break}do{H=c+(K<<4)|0;I=0;M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;while(1){U=+p[G+(I<<4)>>3];V=+p[G+(I<<4)+8>>3];W=+p[H>>3];X=+p[H+8>>3];N=N+(U*W-V*X);T=T+(V*W+U*X);X=+p[H+16>>3];W=+p[H+24>>3];M=M+(U*X-V*W);R=R+(V*X+U*W);W=+p[H+32>>3];X=+p[H+40>>3];P=P+(U*W-V*X);S=S+(V*W+U*X);X=+p[H+48>>3];W=+p[H+56>>3];O=O+(U*X-V*W);Q=Q+(V*X+U*W);I=I+1|0;if((I|0)==(x|0))break;else H=H+(b<<4)|0}p[D+(K<<4)>>3]=N;p[D+(K<<4)+8>>3]=T;H=K|1;p[D+(H<<4)>>3]=M;p[D+(H<<4)+8>>3]=R;H=K|2;p[D+(H<<4)>>3]=P;p[D+(H<<4)+8>>3]=S;H=K|3;p[D+(H<<4)>>3]=O;p[D+(H<<4)+8>>3]=Q;K=K+4|0}while((K|0)<=(s|0));L=z}else{if(y)Z=0;else{H=0;while(1){H=H+4|0;if((H|0)>(s|0)){L=z;break a}}}do{H=D+(Z<<4)|0;I=D+(Z<<4)+8|0;J=Z|1;_=D+(J<<4)|0;$=D+(J<<4)+8|0;J=Z|2;aa=D+(J<<4)|0;ba=D+(J<<4)+8|0;J=Z|3;ca=D+(J<<4)|0;da=D+(J<<4)+8|0;J=c+(Z<<4)|0;ea=0;W=+p[_>>3];U=+p[H>>3];X=+p[ca>>3];V=+p[aa>>3];fa=+p[da>>3];ga=+p[$>>3];ha=+p[ba>>3];ia=+p[I>>3];while(1){ja=+p[G+(ea<<4)>>3];ka=+p[G+(ea<<4)+8>>3];la=+p[J>>3];ma=+p[J+8>>3];U=U+(ja*la-ka*ma);ia=ia+(ka*la+ja*ma);ma=+p[J+16>>3];la=+p[J+24>>3];W=W+(ja*ma-ka*la);ga=ga+(ka*ma+ja*la);la=+p[J+32>>3];ma=+p[J+40>>3];V=V+(ja*la-ka*ma);ha=ha+(ka*la+ja*ma);ma=+p[J+48>>3];la=+p[J+56>>3];X=X+(ja*ma-ka*la);fa=fa+(ka*ma+ja*la);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[H>>3]=U;p[I>>3]=ia;p[_>>3]=W;p[$>>3]=ga;p[aa>>3]=V;p[ba>>3]=ha;p[ca>>3]=X;p[da>>3]=fa;Z=Z+4|0}while((Z|0)<=(s|0));L=z}else L=0;while(0);b:do if((h|0)>(L|0))if(g){if(y)na=L;else{g1c(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{J=c+(na<<4)|0;ea=0;Q=0.0;O=0.0;while(1){S=+p[G+(ea<<4)>>3];P=+p[G+(ea<<4)+8>>3];R=+p[J>>3];M=+p[J+8>>3];Q=Q+(S*R-P*M);O=O+(P*R+S*M);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[D+(na<<4)>>3]=Q;p[D+(na<<4)+8>>3]=O;na=na+1|0}while((na|0)!=(h|0))}else{if(y)oa=L;else{J=L;while(1){J=J+1|0;if((J|0)==(h|0))break b}}do{J=D+(oa<<4)+8|0;ea=D+(oa<<4)|0;da=c+(oa<<4)|0;ca=0;fa=+p[ea>>3];X=+p[J>>3];while(1){ha=+p[G+(ca<<4)>>3];V=+p[G+(ca<<4)+8>>3];ga=+p[da>>3];W=+p[da+8>>3];fa=fa+(ha*ga-V*W);X=X+(V*ga+ha*W);ca=ca+1|0;if((ca|0)==(x|0))break;else da=da+(b<<4)|0}p[ea>>3]=fa;p[J>>3]=X;oa=oa+1|0}while((oa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(o|0))break;else{C=C+(v<<4)|0;D=D+(d<<4)|0}}}}else if(m){m=(w|0)==0;D=(r|0)==0;r=x+-2|0;C=(x|0)<2;E=x&-2;oa=(x|0)<1|m;G=(h|0)>0;L=(x|0)>0;y=(E|0)<(x|0);na=(x|0)>0;g=(E|0)<(x|0);z=a;a=e;e=0;while(1){if(oa)pa=m?z:w;else{s=0;do{Z=z+((Y(s,t)|0)<<4)|0;K=w+(s<<4)|0;f[K>>2]=f[Z>>2];f[K+4>>2]=f[Z+4>>2];f[K+8>>2]=f[Z+8>>2];f[K+12>>2]=f[Z+12>>2];s=s+1|0}while((s|0)!=(x|0));pa=w}c:do if(G)if(D){if(C){s=c;Z=0;while(1){if(L){K=0;O=0.0;Q=0.0;while(1){W=+p[pa+(K<<4)>>3];ha=+p[pa+(K<<4)+8>>3];ga=+p[s+(K<<4)>>3];V=+p[s+(K<<4)+8>>3];ia=O+(W*ga-ha*V);U=Q+(ha*ga+W*V);K=K+1|0;if((K|0)==(x|0)){qa=ia;ra=U;break}else{O=ia;Q=U}}}else{qa=0.0;ra=0.0}p[a+(Z<<4)>>3]=qa+0.0;p[a+(Z<<4)+8>>3]=ra+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{sa=c;ta=0}while(1){s=0;Q=0.0;O=0.0;X=0.0;fa=0.0;do{U=+p[pa+(s<<4)>>3];ia=+p[pa+(s<<4)+8>>3];V=+p[sa+(s<<4)>>3];W=+p[sa+(s<<4)+8>>3];O=O+(U*V-ia*W);X=X+(ia*V+U*W);Z=s|1;W=+p[pa+(Z<<4)>>3];U=+p[pa+(Z<<4)+8>>3];V=+p[sa+(Z<<4)>>3];ia=+p[sa+(Z<<4)+8>>3];Q=Q+(W*V-U*ia);fa=fa+(U*V+W*ia);s=s+2|0}while((s|0)<=(r|0));if(y){s=E;ia=O;W=X;while(1){V=+p[pa+(s<<4)>>3];U=+p[pa+(s<<4)+8>>3];ga=+p[sa+(s<<4)>>3];ha=+p[sa+(s<<4)+8>>3];M=ia+(V*ga-U*ha);S=W+(U*ga+V*ha);s=s+1|0;if((s|0)==(x|0)){ua=M;va=S;break}else{ia=M;W=S}}}else{ua=O;va=X}p[a+(ta<<4)>>3]=Q+ua;p[a+(ta<<4)+8>>3]=fa+va;ta=ta+1|0;if((ta|0)==(h|0))break;else sa=sa+(b<<4)|0}}else{if(C){s=c;Z=0;while(1){K=a+(Z<<4)+8|0;J=a+(Z<<4)|0;W=+p[J>>3];ia=+p[K>>3];if(na){ea=0;S=W;M=ia;while(1){ha=+p[pa+(ea<<4)>>3];V=+p[pa+(ea<<4)+8>>3];ga=+p[s+(ea<<4)>>3];U=+p[s+(ea<<4)+8>>3];R=S+(ha*ga-V*U);P=M+(V*ga+ha*U);ea=ea+1|0;if((ea|0)==(x|0)){wa=R;xa=P;break}else{S=R;M=P}}}else{wa=W;xa=ia}p[J>>3]=wa+0.0;p[K>>3]=xa+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{ya=c;za=0}while(1){s=a+(za<<4)+8|0;Z=a+(za<<4)|0;ea=0;M=0.0;S=+p[Z>>3];fa=+p[s>>3];Q=0.0;do{X=+p[pa+(ea<<4)>>3];O=+p[pa+(ea<<4)+8>>3];P=+p[ya+(ea<<4)>>3];R=+p[ya+(ea<<4)+8>>3];S=S+(X*P-O*R);fa=fa+(O*P+X*R);B=ea|1;R=+p[pa+(B<<4)>>3];X=+p[pa+(B<<4)+8>>3];P=+p[ya+(B<<4)>>3];O=+p[ya+(B<<4)+8>>3];M=M+(R*P-X*O);Q=Q+(X*P+R*O);ea=ea+2|0}while((ea|0)<=(r|0));if(g){ea=E;ia=S;W=fa;while(1){O=+p[pa+(ea<<4)>>3];R=+p[pa+(ea<<4)+8>>3];P=+p[ya+(ea<<4)>>3];X=+p[ya+(ea<<4)+8>>3];U=ia+(O*P-R*X);ha=W+(R*P+O*X);ea=ea+1|0;if((ea|0)==(x|0)){Aa=U;Ba=ha;break}else{ia=U;W=ha}}}else{Aa=S;Ba=fa}p[Z>>3]=M+Aa;p[s>>3]=Q+Ba;za=za+1|0;if((za|0)==(h|0))break;else ya=ya+(b<<4)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{z=z+(v<<4)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)dYc(d);f[l>>2]=i;f[q>>2]=72;u=k;return}function uY(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0;k=u;u=u+1072|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;r=l+4|0;f[r>>2]=264;s=j&16;t=b>>>2;b=d>>>2;d=g>>>3;if(j&1){f[r>>2]=o;if(o>>>0>264){g=bYc(o>>>0>1073741823?-1:o<<2)|0;f[l>>2]=g;v=t;w=1;x=g;y=o;z=g}else{v=t;w=1;x=i;y=o;z=i}}else{v=1;w=t;x=0;y=m;z=i}m=(q|0)>0;if(!(j&2)){if(m){j=(x|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;A=(y|0)>0;B=h&-4;C=(y|0)<1|j;D=(t>>>2<<5)+32|0;E=e;F=0;G=a;while(1){H=e+((Y(d,F)|0)<<3)|0;if(C)I=j?G:x;else{J=0;do{K=G+((Y(J,v)|0)<<2)|0;f[x+(J<<2)>>2]=f[K>>2];J=J+1|0}while((J|0)!=(y|0));I=x}a:do if(!o)if(g){if(A)L=0;else{g1c(H|0,0,D|0)|0;M=B;break}do{J=c+(L<<2)|0;N=0.0;O=0.0;P=0.0;Q=0.0;K=0;while(1){R=+n[I+(K<<2)>>2];Q=Q+R*+n[J>>2];P=P+R*+n[J+4>>2];O=O+R*+n[J+8>>2];N=N+R*+n[J+12>>2];K=K+1|0;if((K|0)==(y|0))break;else J=J+(b<<2)|0}p[E+(L<<3)>>3]=Q;p[E+((L|1)<<3)>>3]=P;p[E+((L|2)<<3)>>3]=O;p[E+((L|3)<<3)>>3]=N;L=L+4|0}while((L|0)<=(t|0));M=B}else{if(A)S=0;else{J=0;while(1){J=J+4|0;if((J|0)>(t|0)){M=B;break a}}}do{J=E+((S|3)<<3)|0;K=E+((S|2)<<3)|0;T=E+((S|1)<<3)|0;U=E+(S<<3)|0;V=c+(S<<2)|0;R=+p[J>>3];W=+p[K>>3];X=+p[T>>3];Z=+p[U>>3];_=0;while(1){$=+n[I+(_<<2)>>2];Z=Z+$*+n[V>>2];X=X+$*+n[V+4>>2];W=W+$*+n[V+8>>2];R=R+$*+n[V+12>>2];_=_+1|0;if((_|0)==(y|0))break;else V=V+(b<<2)|0}p[U>>3]=Z;p[T>>3]=X;p[K>>3]=W;p[J>>3]=R;S=S+4|0}while((S|0)<=(t|0));M=B}else M=0;while(0);b:do if((h|0)>(M|0)){if(!g){if(A)aa=M;else break;while(1){V=E+(aa<<3)|0;_=c+(aa<<2)|0;N=+p[V>>3];ba=0;while(1){N=N+ +n[I+(ba<<2)>>2]*+n[_>>2];ba=ba+1|0;if((ba|0)==(y|0))break;else _=_+(b<<2)|0}p[V>>3]=N;aa=aa+1|0;if((aa|0)==(h|0))break b}}if(A)ca=M;else{g1c(H+(M<<3)|0,0,h-M<<3|0)|0;break}do{_=c+(ca<<2)|0;R=0.0;ba=0;while(1){R=R+ +n[I+(ba<<2)>>2]*+n[_>>2];ba=ba+1|0;if((ba|0)==(y|0))break;else _=_+(b<<2)|0}p[E+(ca<<3)>>3]=R;ca=ca+1|0}while((ca|0)!=(h|0))}while(0);F=F+1|0;if((F|0)==(q|0))break;else{E=E+(d<<3)|0;G=G+(w<<2)|0}}}}else if(m){m=(x|0)==0;G=(h|0)>0;E=(s|0)==0;s=y+-2|0;F=(y|0)<2;ca=y&-2;I=(y|0)<1|m;M=(y|0)>0;A=(ca|0)<(y|0);aa=(y|0)>0;g=(ca|0)<(y|0);B=e;e=0;t=a;while(1){if(I)da=m?t:x;else{a=0;do{S=t+((Y(a,v)|0)<<2)|0;f[x+(a<<2)>>2]=f[S>>2];a=a+1|0}while((a|0)!=(y|0));da=x}c:do if(G)if(E){if(F){a=c;S=0;while(1){if(M){N=0.0;L=0;while(1){W=N+ +n[da+(L<<2)>>2]*+n[a+(L<<2)>>2];L=L+1|0;if((L|0)==(y|0)){ea=W;break}else N=W}}else ea=0.0;p[B+(S<<3)>>3]=ea+0.0;S=S+1|0;if((S|0)==(h|0))break c;else a=a+(b<<2)|0}}else{fa=c;ga=0}while(1){N=0.0;R=0.0;a=0;do{R=R+ +n[da+(a<<2)>>2]*+n[fa+(a<<2)>>2];S=a|1;N=N+ +n[da+(S<<2)>>2]*+n[fa+(S<<2)>>2];a=a+2|0}while((a|0)<=(s|0));if(A){W=R;a=ca;while(1){X=W+ +n[da+(a<<2)>>2]*+n[fa+(a<<2)>>2];a=a+1|0;if((a|0)==(y|0)){ha=X;break}else W=X}}else ha=R;p[B+(ga<<3)>>3]=N+ha;ga=ga+1|0;if((ga|0)==(h|0))break;else fa=fa+(b<<2)|0}}else{if(F){a=c;S=0;while(1){L=B+(S<<3)|0;W=+p[L>>3];if(aa){X=W;D=0;while(1){Z=X+ +n[da+(D<<2)>>2]*+n[a+(D<<2)>>2];D=D+1|0;if((D|0)==(y|0)){ia=Z;break}else X=Z}}else ia=W;p[L>>3]=ia+0.0;S=S+1|0;if((S|0)==(h|0))break c;else a=a+(b<<2)|0}}else{ja=c;ka=0}while(1){a=B+(ka<<3)|0;X=0.0;N=+p[a>>3];S=0;do{N=N+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];D=S|1;X=X+ +n[da+(D<<2)>>2]*+n[ja+(D<<2)>>2];S=S+2|0}while((S|0)<=(s|0));if(g){W=N;S=ca;while(1){R=W+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];S=S+1|0;if((S|0)==(y|0)){la=R;break}else W=R}}else la=N;p[a>>3]=X+la;ka=ka+1|0;if((ka|0)==(h|0))break;else ja=ja+(b<<2)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{B=B+(d<<3)|0;t=t+(w<<2)|0}}}if((z|0)==(i|0)){u=k;return}dYc(z);f[l>>2]=i;f[r>>2]=264;u=k;return}function vY(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>3;d=g>>>3;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=(r|0)>3?r:3;t=(s&2147483644)+4|0;u=s>>>2;s=Y(u,g)|0;v=(u<<2)+4|0;u=c;c=e;e=a;w=m;m=a+(g<<3)|0;while(1){w=w+-1|0;if(!e){if(q)x=0;else{a=0;do{y=a|1;z=+p[u+(y<<3)>>3]*i;p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i;p[c+(y<<3)>>3]=z;y=a|2;A=a|3;z=+p[u+(A<<3)>>3]*i;p[c+(y<<3)>>3]=+p[u+(y<<3)>>3]*i;p[c+(A<<3)>>3]=z;a=a+4|0}while((a|0)<=(r|0));x=t}if((x|0)<(l|0)){a=x;do{p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(q){B=e;C=0}else{a=0;A=e;while(1){y=a|1;z=+p[u+(y<<3)>>3]*i+ +p[A+(o<<3)>>3]*j;p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i+ +p[A>>3]*j;p[c+(y<<3)>>3]=z;y=a|2;D=a|3;z=+p[u+(D<<3)>>3]*i+ +p[A+(n<<3)>>3]*j;p[c+(y<<3)>>3]=+p[u+(y<<3)>>3]*i+ +p[A+(h<<3)>>3]*j;p[c+(D<<3)>>3]=z;a=a+4|0;if((a|0)>(r|0))break;else A=A+(g<<3)|0}B=m+(s<<3)|0;C=v}if((C|0)<(l|0)){A=C;a=B;while(1){p[c+(A<<3)>>3]=+p[u+(A<<3)>>3]*i+ +p[a>>3]*j;A=A+1|0;if((A|0)==(l|0))break;else a=a+(o<<3)|0}}}if(!w)break;else{u=u+(b<<3)|0;c=c+(d<<3)|0;e=e+(k<<3)|0;m=m+(k<<3)|0}}return}function wY(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>4;d=g>>>3;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=s>>>2;u=(t<<2)+4|0;v=c;c=e;e=a;w=m;m=a+(Y(q,(t<<5)+32|0)|0)|0;while(1){w=w+-1|0;if(!e){if(r)x=0;else{t=0;do{a=t|1;y=+p[v+(a<<4)>>3]*i;z=+p[v+(a<<4)+8>>3]*i;A=+p[v+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[v+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=t|2;B=t|3;z=+p[v+(B<<4)>>3]*i;y=+p[v+(B<<4)+8>>3]*i;A=+p[v+(a<<4)+8>>3]*i;n[c+(a<<3)>>2]=+p[v+(a<<4)>>3]*i;n[c+(a<<3)+4>>2]=A;n[c+(B<<3)>>2]=z;n[c+(B<<3)+4>>2]=y;t=t+4|0}while((t|0)<=(s|0));x=u}if((x|0)<(l|0)){t=x;do{y=+p[v+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[v+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=y;t=t+1|0}while((t|0)!=(l|0))}}else{if(r){C=e;D=0}else{t=e;B=0;while(1){a=B|1;y=+p[v+(a<<4)>>3]*i+ +n[t+(q<<3)>>2]*j;z=+p[v+(a<<4)+8>>3]*i+ +n[t+(q<<3)+4>>2]*j;A=+p[v+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[v+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=B|2;E=B|3;z=+p[v+(E<<4)>>3]*i+ +n[t+(o<<3)>>2]*j;y=+p[v+(E<<4)+8>>3]*i+ +n[t+(o<<3)+4>>2]*j;A=+p[v+(a<<4)+8>>3]*i+ +n[t+(h<<3)+4>>2]*j;n[c+(a<<3)>>2]=+p[v+(a<<4)>>3]*i+ +n[t+(h<<3)>>2]*j;n[c+(a<<3)+4>>2]=A;n[c+(E<<3)>>2]=z;n[c+(E<<3)+4>>2]=y;B=B+4|0;if((B|0)>(s|0)){C=m;D=u;break}else t=t+(g<<3)|0}}if((D|0)<(l|0)){t=C;B=D;while(1){y=+p[v+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[v+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=y;B=B+1|0;if((B|0)==(l|0))break;else t=t+(q<<3)|0}}}if(!w)break;else{v=v+(b<<4)|0;c=c+(d<<3)|0;e=e+(k<<3)|0;m=m+(k<<3)|0}}return}function xY(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>4;b=d>>>4;d=g>>>4;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=r>>>2;t=(s<<2)+4|0;u=a;v=c;c=e;e=m;m=a+(Y(o,(s<<6)+64|0)|0)|0;while(1){e=e+-1|0;if(!u){if(q)w=0;else{s=0;do{x=+p[v+(s<<4)+8>>3]*i;a=s|1;y=+p[v+(a<<4)>>3]*i;z=+p[v+(a<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=s|2;z=+p[v+(a<<4)+8>>3]*i;A=s|3;y=+p[v+(A<<4)>>3]*i;x=+p[v+(A<<4)+8>>3]*i;p[c+(a<<4)>>3]=+p[v+(a<<4)>>3]*i;p[c+(a<<4)+8>>3]=z;p[c+(A<<4)>>3]=y;p[c+(A<<4)+8>>3]=x;s=s+4|0}while((s|0)<=(r|0));w=t}if((w|0)<(l|0)){s=w;do{x=+p[v+(s<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;s=s+1|0}while((s|0)!=(l|0))}}else{if(q){B=0;C=u}else{s=0;A=u;while(1){a=s|1;x=+p[v+(s<<4)+8>>3]*i+ +p[A+8>>3]*j;y=+p[v+(a<<4)>>3]*i+ +p[A+(o<<4)>>3]*j;z=+p[v+(a<<4)+8>>3]*i+ +p[A+(o<<4)+8>>3]*j;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i+ +p[A>>3]*j;p[c+(s<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=s|2;D=s|3;z=+p[v+(a<<4)+8>>3]*i+ +p[A+(h<<4)+8>>3]*j;y=+p[v+(D<<4)>>3]*i+ +p[A+(n<<4)>>3]*j;x=+p[v+(D<<4)+8>>3]*i+ +p[A+(n<<4)+8>>3]*j;p[c+(a<<4)>>3]=+p[v+(a<<4)>>3]*i+ +p[A+(h<<4)>>3]*j;p[c+(a<<4)+8>>3]=z;p[c+(D<<4)>>3]=y;p[c+(D<<4)+8>>3]=x;s=s+4|0;if((s|0)>(r|0)){B=t;C=m;break}else A=A+(g<<4)|0}}if((B|0)<(l|0)){A=C;s=B;while(1){x=+p[v+(s<<4)+8>>3]*i+ +p[A+8>>3]*j;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i+ +p[A>>3]*j;p[c+(s<<4)+8>>3]=x;s=s+1|0;if((s|0)==(l|0))break;else A=A+(o<<4)|0}}}if(!e)break;else{u=u+(k<<4)|0;v=v+(b<<4)|0;c=c+(d<<4)|0;m=m+(k<<4)|0}}return}function yY(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>2;b=d>>>3;d=g>>>2;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=(s|0)>3?s:3;u=(t&2147483644)+4|0;v=t>>>2;t=Y(v,g)|0;w=(v<<2)+4|0;v=c;c=e;e=a;x=m;m=a+(g<<2)|0;while(1){x=x+-1|0;if(!e){if(r)y=0;else{a=0;do{z=a|1;A=+p[v+(z<<3)>>3]*i;n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i;n[c+(z<<2)>>2]=A;z=a|2;B=a|3;A=+p[v+(B<<3)>>3]*i;n[c+(z<<2)>>2]=+p[v+(z<<3)>>3]*i;n[c+(B<<2)>>2]=A;a=a+4|0}while((a|0)<=(s|0));y=u}if((y|0)<(l|0)){a=y;do{n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(r){C=e;D=0}else{a=0;B=e;while(1){z=a|1;A=+p[v+(z<<3)>>3]*i+ +n[B+(q<<2)>>2]*j;n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i+ +n[B>>2]*j;n[c+(z<<2)>>2]=A;z=a|2;E=a|3;A=+p[v+(E<<3)>>3]*i+ +n[B+(o<<2)>>2]*j;n[c+(z<<2)>>2]=+p[v+(z<<3)>>3]*i+ +n[B+(h<<2)>>2]*j;n[c+(E<<2)>>2]=A;a=a+4|0;if((a|0)>(s|0))break;else B=B+(g<<2)|0}C=m+(t<<2)|0;D=w}if((D|0)<(l|0)){B=D;a=C;while(1){n[c+(B<<2)>>2]=+p[v+(B<<3)>>3]*i+ +n[a>>2]*j;B=B+1|0;if((B|0)==(l|0))break;else a=a+(q<<2)|0}}}if(!x)break;else{v=v+(b<<3)|0;c=c+(d<<2)|0;e=e+(k<<2)|0;m=m+(k<<2)|0}}return}function zY(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){Tj(v,l,m,p,a,b);b=r+36|0;a=f[b>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)V$(r);f[b>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){m=f[H>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[C>>2]|0))}f[r>>2]=f[v>>2];l=v+4|0;m=f[l>>2]|0;f[C>>2]=m;U=v+8|0;f[G>>2]=f[U>>2];f[r+12>>2]=f[v+12>>2];V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=v+36|0;f[b>>2]=f[a>>2];b=r+44|0;W=f[b>>2]|0;if((W|0)==(K|0))X=m;else{wL(W);f[b>>2]=K;f[H>>2]=G;X=f[l>>2]|0}W=v+44|0;if((X|0)<3){X=f[W>>2]|0;f[K>>2]=f[X>>2];f[r+52>>2]=f[X+4>>2];Y=X}else{f[b>>2]=f[W>>2];b=v+40|0;f[r+40>>2]=f[b>>2];X=v+48|0;f[W>>2]=X;f[b>>2]=U;Y=X}f[v>>2]=1124007936;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[a>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((Y|0)!=(v+48|0))wL(Y)}if(c|0){Tj(v,B,E,p,c,d);d=s+36|0;c=f[d>>2]|0;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)V$(s);f[d>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){E=f[O>>2]|0;B=0;do{f[E+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[M>>2]|0))}f[s>>2]=f[v>>2];B=v+4|0;E=f[B>>2]|0;f[M>>2]=E;Y=v+8|0;f[N>>2]=f[Y>>2];f[s+12>>2]=f[v+12>>2];V=v+16|0;f[c>>2]=f[V>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=v+36|0;f[d>>2]=f[c>>2];d=s+44|0;a=f[d>>2]|0;if((a|0)==(P|0))Z=E;else{wL(a);f[d>>2]=P;f[O>>2]=N;Z=f[B>>2]|0}a=v+44|0;if((Z|0)<3){Z=f[a>>2]|0;f[P>>2]=f[Z>>2];f[s+52>>2]=f[Z+4>>2];_=Z}else{f[d>>2]=f[a>>2];d=v+40|0;f[s+40>>2]=f[d>>2];Z=v+48|0;f[a>>2]=Z;f[d>>2]=Y;_=Z}f[v>>2]=1124007936;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;f[B+24>>2]=0;f[B+28>>2]=0;f[c>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((_|0)!=(v+48|0))wL(_)}if((g|0)!=0&i!=0.0){Tj(v,A,F,p,g,h);h=t+36|0;g=f[h>>2]|0;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)V$(t);f[h>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){F=f[T>>2]|0;A=0;do{f[F+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[R>>2]|0))}f[t>>2]=f[v>>2];A=v+4|0;F=f[A>>2]|0;f[R>>2]=F;_=v+8|0;f[S>>2]=f[_>>2];f[t+12>>2]=f[v+12>>2];V=v+16|0;f[g>>2]=f[V>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=v+36|0;f[h>>2]=f[g>>2];h=t+44|0;c=f[h>>2]|0;if((c|0)==(I|0))$=F;else{wL(c);f[h>>2]=I;f[T>>2]=S;$=f[A>>2]|0}c=v+44|0;if(($|0)<3){$=f[c>>2]|0;f[I>>2]=f[$>>2];f[t+52>>2]=f[$+4>>2];aa=$}else{f[h>>2]=f[c>>2];h=v+40|0;f[t+40>>2]=f[h>>2];$=v+48|0;f[c>>2]=$;f[h>>2]=_;aa=$}f[v>>2]=1124007936;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+20>>2]=0;f[A+24>>2]=0;f[A+28>>2]=0;f[g>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((aa|0)!=(v+48|0))wL(aa)}Tj(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;aa=r+36|0;V=f[aa>>2]|0;f[D>>2]=V;g=w+40|0;f[g>>2]=p;p=w+48|0;A=w+44|0;f[A>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!V)ba=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;ba=f[C>>2]|0}if((ba|0)<3){ba=f[L>>2]|0;j=f[A>>2]|0;f[j>>2]=f[ba>>2];f[j+4>>2]=f[ba+4>>2]}else{f[k>>2]=0;U$(w,r)}f[x>>2]=f[s>>2];ba=x+4|0;j=f[M>>2]|0;f[ba>>2]=j;V=x+8|0;f[V>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;$=s+16|0;f[N>>2]=f[$>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];_=x+36|0;h=s+36|0;c=f[h>>2]|0;f[_>>2]=c;F=x+40|0;f[F>>2]=V;V=x+48|0;B=x+44|0;f[B>>2]=V;f[V>>2]=0;f[x+52>>2]=0;if(!c)ca=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;ca=f[M>>2]|0}if((ca|0)<3){ca=f[Q>>2]|0;j=f[B>>2]|0;f[j>>2]=f[ca>>2];f[j+4>>2]=f[ca+4>>2]}else{f[ba>>2]=0;U$(x,s)}f[y>>2]=f[t>>2];ca=y+4|0;j=f[R>>2]|0;f[ca>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;Z=t+16|0;f[S>>2]=f[Z>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];Y=y+36|0;d=t+36|0;a=f[d>>2]|0;f[Y>>2]=a;E=y+40|0;f[E>>2]=c;c=y+48|0;l=y+44|0;f[l>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!a)da=j;else{j=a+12|0;f[j>>2]=(f[j>>2]|0)+1;da=f[R>>2]|0}if((da|0)<3){da=f[J>>2]|0;j=f[l>>2]|0;f[j>>2]=f[da>>2];f[j+4>>2]=f[da+4>>2]}else{f[ca>>2]=0;U$(y,t)}f[z>>2]=f[v>>2];da=z+4|0;j=v+4|0;a=f[j>>2]|0;f[da>>2]=a;X=z+8|0;f[X>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];U=z+16|0;b=v+16|0;f[U>>2]=f[b>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];W=z+36|0;m=v+36|0;ea=f[m>>2]|0;f[W>>2]=ea;fa=z+40|0;f[fa>>2]=X;X=z+48|0;ga=z+44|0;f[ga>>2]=X;f[X>>2]=0;f[z+52>>2]=0;if(!ea)ha=a;else{a=ea+12|0;f[a>>2]=(f[a>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;a=f[ga>>2]|0;f[a>>2]=f[ha>>2];f[a+4>>2]=f[ha+4>>2]}else{f[da>>2]=0;U$(z,v)}mY(w,x,e,y,i,z,o);o=f[W>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)V$(z);f[W>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[da>>2]|0)>0){U=f[fa>>2]|0;fa=0;do{f[U+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[da>>2]|0))}da=f[ga>>2]|0;if((da|0)!=(X|0))wL(da);da=f[Y>>2]|0;if(da|0?(X=da+12|0,da=f[X>>2]|0,f[X>>2]=da+-1,(da|0)==1):0)V$(y);f[Y>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[ca>>2]|0)>0){S=f[E>>2]|0;E=0;do{f[S+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[ca>>2]|0))}ca=f[l>>2]|0;if((ca|0)!=(c|0))wL(ca);ca=f[_>>2]|0;if(ca|0?(c=ca+12|0,ca=f[c>>2]|0,f[c>>2]=ca+-1,(ca|0)==1):0)V$(x);f[_>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[ba>>2]|0)>0){N=f[F>>2]|0;F=0;do{f[N+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[ba>>2]|0))}ba=f[B>>2]|0;if((ba|0)!=(V|0))wL(ba);ba=f[D>>2]|0;do if(ba|0){V=ba+12|0;B=f[V>>2]|0;f[V>>2]=B+-1;if((B|0)!=1)break;V$(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[g>>2]|0;g=0;do{f[G+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[k>>2]|0))}k=f[A>>2]|0;if((k|0)!=(p|0))wL(k);k=f[m>>2]|0;do if(k|0){p=k+12|0;A=f[p>>2]|0;f[p>>2]=A+-1;if((A|0)!=1)break;V$(v)}while(0);f[m>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){b=f[v+40>>2]|0;m=0;do{f[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))wL(j);j=f[d>>2]|0;do if(j|0){v=j+12|0;m=f[v>>2]|0;f[v>>2]=m+-1;if((m|0)!=1)break;V$(t)}while(0);f[d>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[R>>2]|0)>0){Z=f[T>>2]|0;T=0;do{f[Z+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))wL(R);R=f[h>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;V$(s)}while(0);f[h>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[M>>2]|0)>0){$=f[O>>2]|0;O=0;do{f[$+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))wL(M);M=f[aa>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;V$(r)}while(0);f[aa>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}wL(C);u=q;return}function AY(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;j=u;u=u+352|0;k=j+336|0;l=j+280|0;m=j+224|0;n=j+168|0;o=j+112|0;p=j+56|0;q=j;do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[l>>2]=f[r>>2];s=l+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=l+8|0;f[v>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];f[l+16>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[l+36>>2]=w;f[l+40>>2]=v;v=l+48|0;x=l+44|0;f[x>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;U$(l,r);break}}else bS(l,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];r=m+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=m+8|0;f[t>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=t;t=m+48|0;x=m+44|0;f[x>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;U$(m,a);break}}else bS(m,c,-1);while(0);do if(g!=0.0){if((eS(e)|0)!=65536){bS(n,e,-1);break}c=f[e+4>>2]|0;f[n>>2]=f[c>>2];a=n+4|0;r=c+4|0;f[a>>2]=f[r>>2];s=n+8|0;f[s>>2]=f[c+8>>2];f[n+12>>2]=f[c+12>>2];f[n+16>>2]=f[c+16>>2];f[n+20>>2]=f[c+20>>2];f[n+24>>2]=f[c+24>>2];f[n+28>>2]=f[c+28>>2];f[n+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[n+36>>2]=t;f[n+40>>2]=s;s=n+48|0;x=n+44|0;f[x>>2]=s;f[s>>2]=0;f[n+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[c+44>>2]|0;s=f[x>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[a>>2]=0;U$(n,c);break}}else{f[n>>2]=1124007936;c=n+8|0;a=n+40|0;y=n+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[a>>2]=c;r=n+48|0;f[n+44>>2]=r;f[r>>2]=0;f[n+52>>2]=0}while(0);e=l+40|0;r=f[e>>2]|0;s=f[r+4>>2]|0;x=f[r>>2]|0;r=f[l>>2]|0;t=r&4095;if((t|0)!=(f[m>>2]&4095|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;v=$Xc(32)|0;f[k>>2]=v;f[k+8>>2]=-2147483616;f[k+4>>2]=16;y=v;A=236036;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));b[v+16>>0]=0;vM(-215,k,236053,235968,1558)}if(((r&4087)+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;v=$Xc(224)|0;f[k>>2]=v;f[k+8>>2]=-2147483424;f[k+4>>2]=210;o1c(v|0,236058,210)|0;b[v+210>>0]=0;vM(-215,k,236053,235968,1558)}switch(i&3){case 0:{if((s|0)==(f[m+8>>2]|0)){B=f[m+12>>2]|0;C=x}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;v=$Xc(32)|0;f[k>>2]=v;f[k+8>>2]=-2147483616;f[k+4>>2]=19;y=v;A=236269;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));b[v+19>>0]=0;vM(-215,k,236053,235968,1565)}break}case 1:{if((x|0)==(f[m+8>>2]|0)){B=f[m+12>>2]|0;C=s}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;v=$Xc(32)|0;f[k>>2]=v;f[k+8>>2]=-2147483616;f[k+4>>2]=20;y=v;A=236289;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));b[v+20>>0]=0;vM(-215,k,236053,235968,1570)}break}case 2:{if((s|0)==(f[m+12>>2]|0)){B=f[m+8>>2]|0;C=x}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;v=$Xc(32)|0;f[k>>2]=v;f[k+8>>2]=-2147483616;f[k+4>>2]=19;y=v;A=236269;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));b[v+19>>0]=0;vM(-215,k,236053,235968,1575)}break}case 3:{if((x|0)==(f[m+12>>2]|0)){B=f[m+8>>2]|0;C=s}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;v=$Xc(32)|0;f[k>>2]=v;f[k+8>>2]=-2147483616;f[k+4>>2]=20;y=v;A=236289;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));b[v+20>>0]=0;vM(-215,k,236053,235968,1580)}break}default:{}}v=n+16|0;do if(f[v>>2]|0){w=f[n+4>>2]|0;if((w|0)<3)D=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{E=f[n+40>>2]|0;F=0;G=1;while(1){H=Y(f[E+(F<<2)>>2]|0,G)|0;F=F+1|0;if((F|0)==(w|0)){D=H;break}else G=H}}if(!((w|0)==0|(D|0)==0)){if((f[n>>2]&4095|0)!=(t|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;G=$Xc(32)|0;f[k>>2]=G;f[k+8>>2]=-2147483616;f[k+4>>2]=16;y=G;A=236310;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));b[G+16>>0]=0;vM(-215,k,236053,235968,1588)}w=f[n+8>>2]|0;if(!(i&4)){if((w|0)!=(C|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(160)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483488;K=k+4|0;f[K>>2]=158;o1c(I|0,236327,158)|0;L=I+158|0;b[L>>0]=0;vM(-215,k,236053,235968,1588)}if((f[n+12>>2]|0)==(B|0))break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(160)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483488;K=k+4|0;f[K>>2]=158;o1c(I|0,236327,158)|0;L=I+158|0;b[L>>0]=0;vM(-215,k,236053,235968,1588)}else{if((w|0)!=(B|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(160)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483488;K=k+4|0;f[K>>2]=158;o1c(I|0,236327,158)|0;L=I+158|0;b[L>>0]=0;vM(-215,k,236053,235968,1588)}if((f[n+12>>2]|0)==(C|0))break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(160)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483488;K=k+4|0;f[K>>2]=158;o1c(I|0,236327,158)|0;L=I+158|0;b[L>>0]=0;vM(-215,k,236053,235968,1588)}}}while(0);ZS(h,C,B,t,-1,0,0);do if((eS(h)|0)==65536){t=f[h+4>>2]|0;f[o>>2]=f[t>>2];L=o+4|0;I=t+4|0;f[L>>2]=f[I>>2];K=o+8|0;f[K>>2]=f[t+8>>2];f[o+12>>2]=f[t+12>>2];f[o+16>>2]=f[t+16>>2];f[o+20>>2]=f[t+20>>2];f[o+24>>2]=f[t+24>>2];f[o+28>>2]=f[t+28>>2];f[o+32>>2]=f[t+32>>2];J=f[t+36>>2]|0;f[o+36>>2]=J;f[o+40>>2]=K;K=o+48|0;D=o+44|0;f[D>>2]=K;f[K>>2]=0;f[o+52>>2]=0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[I>>2]|0)<3){I=f[t+44>>2]|0;K=f[D>>2]|0;f[K>>2]=f[I>>2];f[K+4>>2]=f[I+4>>2];break}else{f[L>>2]=0;U$(o,t);break}}else bS(o,h,-1);while(0);if(i&4){h=o+16|0;if((f[v>>2]|0)==(f[h>>2]|0)){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=n;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=n;AV(k,p);M=i&-5;N=h}else{M=i;N=h}}else{M=i;N=o+16|0}f[p>>2]=1124007936;i=p+4|0;h=p+8|0;t=p+40|0;y=i;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[t>>2]=h;L=p+48|0;I=p+44|0;f[I>>2]=L;f[L>>2]=0;f[p+52>>2]=0;K=f[N>>2]|0;D=l+16|0;if((K|0)!=(f[D>>2]|0)?(K|0)!=(f[m+16>>2]|0):0)O=o;else{K=f[o>>2]&4095;f[q>>2]=1124007936;J=q+4|0;w=q+8|0;F=q+40|0;y=J;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[F>>2]=w;E=q+48|0;f[q+44>>2]=E;f[E>>2]=0;f[q+52>>2]=0;f[k>>2]=C;f[k+4>>2]=B;S$(q,2,k,K);K=p+36|0;B=f[K>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)V$(p);f[K>>2]=0;B=p+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[i>>2]|0)>0){C=f[t>>2]|0;c=0;do{f[C+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}f[p>>2]=f[q>>2];c=f[J>>2]|0;f[i>>2]=c;f[h>>2]=f[w>>2];f[p+12>>2]=f[q+12>>2];C=q+16|0;f[B>>2]=f[C>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2];f[p+32>>2]=f[q+32>>2];B=q+36|0;f[K>>2]=f[B>>2];K=p+44|0;a=f[K>>2]|0;if((a|0)==(L|0))P=c;else{wL(a);f[K>>2]=L;f[t>>2]=h;P=f[J>>2]|0}h=q+44|0;if((P|0)<3){P=f[h>>2]|0;f[L>>2]=f[P>>2];f[p+52>>2]=f[P+4>>2];Q=P}else{f[K>>2]=f[h>>2];f[p+40>>2]=f[F>>2];f[h>>2]=E;f[F>>2]=w;Q=E}f[q>>2]=1124007936;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;f[J+16>>2]=0;f[J+20>>2]=0;f[J+24>>2]=0;f[J+28>>2]=0;f[B>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((Q|0)!=(E|0))wL(Q);O=p}switch(r&4095){case 5:{lY(f[D>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[O+16>>2]|0,f[O+48>>2]|0,x,s,f[O+12>>2]|0,M,5);break}case 6:{zY(f[D>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[O+16>>2]|0,f[O+48>>2]|0,x,s,f[O+12>>2]|0,M,6);break}case 13:{lY(f[D>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[O+16>>2]|0,f[O+48>>2]|0,x,s,f[O+12>>2]|0,M,13);break}case 14:{zY(f[D>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[N>>2]|0,f[o+48>>2]|0,x,s,f[O+12>>2]|0,M,14);break}default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;M=$Xc(32)|0;f[k>>2]=M;f[k+8>>2]=-2147483616;f[k+4>>2]=16;y=M;A=235942;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));b[M+16>>0]=0;vM(-215,k,236053,235968,1623)}}if((O|0)!=(o|0)){M=k+8|0;f[M>>2]=0;f[M+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=o;jR(O,k)}k=p+36|0;O=f[k>>2]|0;if(O|0?(M=O+12|0,O=f[M>>2]|0,f[M>>2]=O+-1,(O|0)==1):0)V$(p);f[k>>2]=0;k=p+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[t>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}i=f[I>>2]|0;if((i|0)!=(L|0))wL(i);i=o+36|0;L=f[i>>2]|0;if(L|0?(I=L+12|0,L=f[I>>2]|0,f[I>>2]=L+-1,(L|0)==1):0)V$(o);f[i>>2]=0;i=o+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[i>>2]|0)>0){N=f[o+40>>2]|0;L=0;do{f[N+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[i>>2]|0))}i=f[o+44>>2]|0;if((i|0)!=(o+48|0))wL(i);i=n+36|0;o=f[i>>2]|0;if(o|0?(L=o+12|0,o=f[L>>2]|0,f[L>>2]=o+-1,(o|0)==1):0)V$(n);f[i>>2]=0;i=n+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[i>>2]|0)>0){v=f[n+40>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))wL(i);i=m+36|0;n=f[i>>2]|0;do if(n|0){o=n+12|0;v=f[o>>2]|0;f[o>>2]=v+-1;if((v|0)!=1)break;V$(m)}while(0);f[i>>2]=0;i=m+16|0;n=m+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[m+40>>2]|0;v=0;do{f[i+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))wL(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){v=m+12|0;i=f[v>>2]|0;f[v>>2]=i+-1;if((i|0)!=1)break;V$(l)}while(0);f[n>>2]=0;n=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[n>>2]|0)>0){D=f[e>>2]|0;e=0;do{f[D+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){u=j;return}wL(n);u=j;return}function BY(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0;e=u;u=u+1408|0;g=e+1392|0;h=e+1096|0;i=e+1336|0;j=e+1280|0;k=e+1272|0;l=e+1216|0;m=e;o=e+1160|0;q=e+1104|0;do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[i>>2]=f[r>>2];s=i+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=i+8|0;f[v>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[i+28>>2]=f[r+28>>2];f[i+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=v;v=i+48|0;x=i+44|0;f[x>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;U$(i,r);break}}else bS(i,a,-1);while(0);do if((eS(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];r=j+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[a+8>>2];v=j+12|0;f[v>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=t;w=j+48|0;y=j+44|0;f[y>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[s>>2];f[w+4>>2]=f[s+4>>2];z=v;A=t;break}else{f[r>>2]=0;U$(j,a);z=v;A=t;break}}else{bS(j,d,-1);z=j+12|0;A=j+8|0}while(0);d=f[i>>2]|0;t=d&7;v=d>>>3&511;d=v+1|0;a=f[A>>2]|0;r=f[z>>2]|0;s=v+2|0;if(!((d|0)==(r|0)|(s|0)==(r|0))){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;r=$Xc(48)|0;f[g>>2]=r;f[g+8>>2]=-2147483600;f[g+4>>2]=34;B=r;C=236486;D=B+34|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[r+34>>0]=0;vM(-215,g,236521,235968,2090)}r=i+40|0;w=f[r>>2]|0;y=f[w>>2]|0;f[k>>2]=f[w+4>>2];f[k+4>>2]=y;wS(c,k,(a<<3)+-8|t,-1,0,0);do if((eS(c)|0)==65536){k=f[c+4>>2]|0;f[l>>2]=f[k>>2];y=l+4|0;w=k+4|0;f[y>>2]=f[w>>2];x=l+8|0;f[x>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];E=f[k+36>>2]|0;f[l+36>>2]=E;f[l+40>>2]=x;x=l+48|0;F=l+44|0;f[F>>2]=x;f[x>>2]=0;f[l+52>>2]=0;if(E|0){x=E+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[k+44>>2]|0;x=f[F>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[y>>2]=0;U$(l,k);break}}else bS(l,c,-1);while(0);c=(t|2|0)==6;k=c?6:5;y=m+8|0;f[m>>2]=y;w=m+4|0;f[w>>2]=136;x=f[j>>2]|0;if((f[z>>2]|0)==(s|0)&((x&16384|0)!=0&(x&4095|0)==(k|0)))G=f[j+16>>2]|0;else{x=Y(s,a)|0;f[w>>2]=x;if(x>>>0>136){F=bYc(x>>>0>536870911?-1:x<<3)|0;f[m>>2]=F;H=F}else H=y;Tj(o,a,s,k,H,0);F=o+16|0;x=f[F>>2]|0;E=o+44|0;I=o+4|0;J=f[I>>2]|0;if((J|0)<3)K=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{M=f[o+40>>2]|0;N=0;O=1;while(1){P=Y(f[M+(N<<2)>>2]|0,O)|0;N=N+1|0;if((N|0)==(J|0)){K=P;break}else O=P}}if((J|0)>0)Q=f[(f[E>>2]|0)+(J+-1<<2)>>2]|0;else Q=0;g1c(x|0,0,Y(Q,K)|0)|0;K=f[z>>2]|0;if((K|0)!=(s|0)){f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=K;W$(q,o,g,h);K=g+8|0;f[K>>2]=0;f[K+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=q;dY(j,g,k,1.0,0.0);K=q+36|0;s=f[K>>2]|0;if(s|0?(Q=s+12|0,s=f[Q>>2]|0,f[Q>>2]=s+-1,(s|0)==1):0)V$(q);f[K>>2]=0;K=q+16|0;s=q+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[s>>2]|0)>0){K=f[q+40>>2]|0;Q=0;do{f[K+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)!=(q+48|0))wL(s)}else{s=g+8|0;f[s>>2]=0;f[s+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;dY(j,g,k,1.0,0.0)}k=o+36|0;s=f[k>>2]|0;if(s|0){q=s+12|0;f[q>>2]=(f[q>>2]|0)+1}q=j+36|0;s=f[q>>2]|0;if(s|0?(Q=s+12|0,s=f[Q>>2]|0,f[Q>>2]=s+-1,(s|0)==1):0)V$(j);f[q>>2]=0;s=j+16|0;Q=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[Q>>2]|0)>0){K=f[j+40>>2]|0;x=0;do{f[K+(x<<2)>>2]=0;x=x+1|0;R=f[Q>>2]|0}while((x|0)<(R|0));f[j>>2]=f[o>>2];if((R|0)<3)S=54;else S=56}else{f[j>>2]=f[o>>2];S=54}if((S|0)==54){R=f[I>>2]|0;if((R|0)<3){f[Q>>2]=R;f[A>>2]=f[o+8>>2];f[z>>2]=f[o+12>>2];A=f[E>>2]|0;R=f[j+44>>2]|0;f[R>>2]=f[A>>2];f[R+4>>2]=f[A+4>>2]}else S=56}if((S|0)==56)U$(j,o);f[s>>2]=f[F>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];s=f[k>>2]|0;f[q>>2]=s;if(s|0?(q=s+12|0,s=f[q>>2]|0,f[q>>2]=s+-1,(s|0)==1):0)V$(o);f[k>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[I>>2]|0)>0){F=f[o+40>>2]|0;k=0;do{f[F+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[I>>2]|0))}I=f[E>>2]|0;if((I|0)!=(o+48|0))wL(I);G=H}a:do if((d|0)==(a|0)){T=c?2.220446049250313e-16:1.1920928955078125e-07;H=f[j+16>>2]|0;if(v|0){I=f[f[j+44>>2]>>2]|0;if(c){E=0;while(1){k=H+(Y(I,E)|0)|0;F=0;while(1){if((E|0)!=(F|0)?+L(+(+p[k+(F<<3)>>3]))>T:0){U=37924;S=96;break a}if((F|0)<(v|0))F=F+1|0;else break}if((E|0)<(v|0))E=E+1|0;else{U=37956;S=96;break a}}}else{E=0;while(1){F=H+(Y(I,E)|0)|0;k=0;while(1){if((E|0)!=(k|0)?+L(+(+n[F+(k<<2)>>2]))>T:0){U=37924;S=96;break a}if((k|0)<(v|0))k=k+1|0;else break}if((E|0)<(v|0))E=E+1|0;else{U=37956;S=96;break a}}}}if(c){T=+p[H>>3];do if((f[j>>2]&16384|0)==0?(E=f[j+40>>2]|0,(f[E>>2]|0)!=1):0){I=f[f[j+44>>2]>>2]|0;if((f[E+4>>2]|0)==1){V=H+I|0;break}else{E=f[z>>2]|0;k=(E+1|0)>>>0<3?E:0;V=H+(Y(k,I)|0)+(1-(Y(k,E)|0)<<3)|0;break}}else S=85;while(0);if((S|0)==85)V=H+8|0;W=+p[V>>3];X=T}else{Z=+n[H>>2];do if((f[j>>2]&16384|0)==0?(E=f[j+40>>2]|0,(f[E>>2]|0)!=1):0){k=f[f[j+44>>2]>>2]|0;if((f[E+4>>2]|0)==1){_=H+k|0;break}else{E=f[z>>2]|0;I=(E+1|0)>>>0<3?E:0;_=H+(Y(I,k)|0)+(1-(Y(I,E)|0)<<2)|0;break}}else S=78;while(0);if((S|0)==78)_=H+4|0;W=+n[_>>2];X=Z}E=g+8|0;f[E>>2]=0;f[E+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;dY(i,g,f[l>>2]&4095,X,W)}else{U=37924;S=96}while(0);if((S|0)==96){S=f[U+(t<<2)>>2]|0;if(!S){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=9;B=g;C=264557;D=B+9|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[g+9>>0]=0;vM(-215,g,236521,235968,2146)}f[g>>2]=i;f[g+4>>2]=l;f[g+8>>2]=0;C=h;f[C>>2]=0;f[C+4>>2]=0;BL(o,g,h,-1);g=f[o+20>>2]|0;C=o+16|0;B=h+4|0;D=0;while(1){if(D>>>0>=(f[C>>2]|0)>>>0)break;Fh[S&255](f[h>>2]|0,f[B>>2]|0,G,g,d,a);CL(o)|0;D=D+1|0}}D=f[m>>2]|0;if((D|0)!=(y|0)){if(D|0)dYc(D);f[m>>2]=y;f[w>>2]=136}w=l+36|0;y=f[w>>2]|0;if(y|0?(m=y+12|0,y=f[m>>2]|0,f[m>>2]=y+-1,(y|0)==1):0)V$(l);f[w>>2]=0;w=l+16|0;y=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[y>>2]|0)>0){w=f[l+40>>2]|0;m=0;do{f[w+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[y>>2]|0))}y=f[l+44>>2]|0;if((y|0)!=(l+48|0))wL(y);y=j+36|0;l=f[y>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)V$(j);f[y>>2]=0;y=j+16|0;l=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[l>>2]|0)>0){y=f[j+40>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))wL(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(m=j+12|0,j=f[m>>2]|0,f[m>>2]=j+-1,(j|0)==1):0)V$(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[r>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=e;return}wL(j);u=e;return}function CY(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;i=d+8|0;j=d+16|0;k=d+20|0;l=0;do{m=ALc(+n[i>>2]+ +n[d>>2]*+(h[a+l>>0]|0))|0;o=l|1;p=ALc(+n[k>>2]+ +n[j>>2]*+(h[a+o>>0]|0))|0;b[c+l>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+o>>0]=p>>>0<256?p:(p|0)>0?255:0;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;l=d+12|0;j=d+20|0;k=d+28|0;i=d+40|0;p=d+44|0;o=0;do{m=ALc(+n[l>>2]+ +n[d>>2]*+(h[a+o>>0]|0))|0;q=o+1|0;r=ALc(+n[k>>2]+ +n[j>>2]*+(h[a+q>>0]|0))|0;s=o+2|0;t=ALc(+n[p>>2]+ +n[i>>2]*+(h[a+s>>0]|0))|0;b[c+o>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+q>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+s>>0]=t>>>0<256?t:(t|0)>0?255:0;o=o+3|0}while((o|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;o=d+16|0;i=d+24|0;p=d+36|0;j=d+48|0;k=d+56|0;l=d+72|0;t=d+76|0;s=0;do{r=ALc(+n[o>>2]+ +n[d>>2]*+(h[a+s>>0]|0))|0;q=s|1;m=ALc(+n[p>>2]+ +n[i>>2]*+(h[a+q>>0]|0))|0;b[c+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+q>>0]=m>>>0<256?m:(m|0)>0?255:0;m=s|2;q=ALc(+n[k>>2]+ +n[j>>2]*+(h[a+m>>0]|0))|0;r=s|3;u=ALc(+n[t>>2]+ +n[l>>2]*+(h[a+r>>0]|0))|0;b[c+m>>0]=q>>>0<256?q:(q|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;s=s+4|0}while((s|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){v=a;w=c;x=0}else return;while(1){c=d;a=0;while(1){s=ALc(+(h[v+a>>0]|0)*+n[c+(a<<2)>>2]+ +n[c+(f<<2)>>2])|0;b[w+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0;if((a|0)==(f|0))break;else c=c+(g<<2)|0}x=x+1|0;if((x|0)==(e|0))break;else{v=v+f|0;w=w+f|0}}return}}}function DY(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=d+8|0;i=d+16|0;j=d+20|0;k=0;do{l=ALc(+n[h>>2]+ +n[d>>2]*+(b[a+k>>0]|0))|0;m=k|1;o=ALc(+n[j>>2]+ +n[i>>2]*+(b[a+m>>0]|0))|0;b[c+k>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+m>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;k=k+2|0}while((k|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=d+12|0;i=d+20|0;j=d+28|0;h=d+40|0;o=d+44|0;m=0;do{l=ALc(+n[k>>2]+ +n[d>>2]*+(b[a+m>>0]|0))|0;p=m+1|0;q=ALc(+n[j>>2]+ +n[i>>2]*+(b[a+p>>0]|0))|0;r=m+2|0;s=ALc(+n[o>>2]+ +n[h>>2]*+(b[a+r>>0]|0))|0;b[c+m>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;m=d+16|0;h=d+24|0;o=d+36|0;i=d+48|0;j=d+56|0;k=d+72|0;s=d+76|0;r=0;do{q=ALc(+n[m>>2]+ +n[d>>2]*+(b[a+r>>0]|0))|0;p=r|1;l=ALc(+n[o>>2]+ +n[h>>2]*+(b[a+p>>0]|0))|0;b[c+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+p>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;l=r|2;p=ALc(+n[j>>2]+ +n[i>>2]*+(b[a+l>>0]|0))|0;q=r|3;t=ALc(+n[s>>2]+ +n[k>>2]*+(b[a+q>>0]|0))|0;b[c+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;r=r+4|0}while((r|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){u=a;v=c;w=0}else return;while(1){c=d;a=0;while(1){r=ALc(+(b[u+a>>0]|0)*+n[c+(a<<2)>>2]+ +n[c+(f<<2)>>2])|0;b[v+a>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;a=a+1|0;if((a|0)==(f|0))break;else c=c+(g<<2)|0}w=w+1|0;if((w|0)==(e|0))break;else{u=u+f|0;v=v+f|0}}return}}}function EY(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];k=+n[c+16>>2];l=+n[c+20>>2];m=0;do{o=ALc(i+h*+(j[a+(m<<1)>>1]|0))|0;p=m|1;q=ALc(l+k*+(j[a+(p<<1)>>1]|0))|0;d[b+(m<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;m=m+2|0}while((m|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=+n[c>>2];l=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];r=+n[c+40>>2];s=+n[c+44>>2];m=0;do{q=ALc(l+k*+(j[a+(m<<1)>>1]|0))|0;p=m+1|0;o=ALc(i+h*+(j[a+(p<<1)>>1]|0))|0;t=m+2|0;u=ALc(s+r*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[b+(p<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(t<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;r=+n[c>>2];s=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];k=+n[c+48>>2];l=+n[c+56>>2];v=+n[c+72>>2];w=+n[c+76>>2];m=0;do{u=ALc(s+r*+(j[a+(m<<1)>>1]|0))|0;t=m|1;o=ALc(i+h*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(t<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=m|2;t=ALc(l+k*+(j[a+(o<<1)>>1]|0))|0;u=m|3;p=ALc(w+v*+(j[a+(u<<1)>>1]|0))|0;d[b+(o<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[b+(u<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;m=m+4|0}while((m|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){x=a;y=b;z=0}else return;while(1){b=c;a=0;while(1){m=ALc(+(j[x+(a<<1)>>1]|0)*+n[b+(a<<2)>>2]+ +n[b+(f<<2)>>2])|0;d[y+(a<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;a=a+1|0;if((a|0)==(f|0))break;else b=b+(g<<2)|0}z=z+1|0;if((z|0)==(e|0))break;else{x=x+(f<<1)|0;y=y+(f<<1)|0}}return}}}function FY(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];j=+n[c+16>>2];k=+n[c+20>>2];l=0;do{m=ALc(i+h*+(d[a+(l<<1)>>1]|0))|0;o=l|1;p=ALc(k+j*+(d[a+(o<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;j=+n[c>>2];k=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];q=+n[c+40>>2];r=+n[c+44>>2];l=0;do{p=ALc(k+j*+(d[a+(l<<1)>>1]|0))|0;o=l+1|0;m=ALc(i+h*+(d[a+(o<<1)>>1]|0))|0;s=l+2|0;t=ALc(r+q*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[b+(o<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;q=+n[c>>2];r=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];j=+n[c+48>>2];k=+n[c+56>>2];u=+n[c+72>>2];v=+n[c+76>>2];l=0;do{t=ALc(r+q*+(d[a+(l<<1)>>1]|0))|0;s=l|1;m=ALc(i+h*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(s<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=l|2;s=ALc(k+j*+(d[a+(m<<1)>>1]|0))|0;t=l|3;o=ALc(v+u*+(d[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+(t<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;l=l+4|0}while((l|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){w=a;x=b;y=0}else return;while(1){b=c;a=0;while(1){l=ALc(+(d[w+(a<<1)>>1]|0)*+n[b+(a<<2)>>2]+ +n[b+(f<<2)>>2])|0;d[x+(a<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break;else b=b+(g<<2)|0}y=y+1|0;if((y|0)==(e|0))break;else{w=w+(f<<1)|0;x=x+(f<<1)|0}}return}}}function GY(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(e|0){case 2:{g=d<<1;if((d|0)<=0)return;h=+p[c>>3];i=+p[c+16>>3];j=+p[c+32>>3];k=+p[c+40>>3];l=0;do{m=zLc(i+h*+(f[a+(l<<2)>>2]|0))|0;n=l|1;o=zLc(k+j*+(f[a+(n<<2)>>2]|0))|0;f[b+(l<<2)>>2]=m;f[b+(n<<2)>>2]=o;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=d*3|0;if((d|0)<=0)return;j=+p[c>>3];k=+p[c+24>>3];h=+p[c+40>>3];i=+p[c+56>>3];q=+p[c+80>>3];r=+p[c+88>>3];l=0;do{o=zLc(k+j*+(f[a+(l<<2)>>2]|0))|0;n=l+1|0;m=zLc(i+h*+(f[a+(n<<2)>>2]|0))|0;s=l+2|0;t=zLc(r+q*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=o;f[b+(n<<2)>>2]=m;f[b+(s<<2)>>2]=t;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=d<<2;if((d|0)<=0)return;q=+p[c>>3];r=+p[c+32>>3];h=+p[c+48>>3];i=+p[c+72>>3];j=+p[c+96>>3];k=+p[c+112>>3];u=+p[c+144>>3];v=+p[c+152>>3];l=0;do{t=zLc(r+q*+(f[a+(l<<2)>>2]|0))|0;s=l|1;m=zLc(i+h*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=t;f[b+(s<<2)>>2]=m;m=l|2;s=zLc(k+j*+(f[a+(m<<2)>>2]|0))|0;t=l|3;n=zLc(v+u*+(f[a+(t<<2)>>2]|0))|0;f[b+(m<<2)>>2]=s;f[b+(t<<2)>>2]=n;l=l+4|0}while((l|0)<(g|0));return}default:{if((d|0)<=0)return;g=e+1|0;if((e|0)>0){w=a;x=b;y=0}else return;while(1){b=c;a=0;while(1){l=zLc(+(f[w+(a<<2)>>2]|0)*+p[b+(a<<3)>>3]+ +p[b+(e<<3)>>3])|0;f[x+(a<<2)>>2]=l;a=a+1|0;if((a|0)==(e|0))break;else b=b+(g<<3)|0}y=y+1|0;if((y|0)==(d|0))break;else{w=w+(e<<2)|0;x=x+(e<<2)|0}}return}}}function HY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+8|0;h=c+16|0;i=c+20|0;j=0;do{k=j|1;l=+n[h>>2]*+n[a+(k<<2)>>2]+ +n[i>>2];n[b+(j<<2)>>2]=+n[c>>2]*+n[a+(j<<2)>>2]+ +n[g>>2];n[b+(k<<2)>>2]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+12|0;g=c+20|0;i=c+28|0;h=c+40|0;k=c+44|0;m=0;do{o=m+1|0;l=+n[g>>2]*+n[a+(o<<2)>>2]+ +n[i>>2];p=m+2|0;q=+n[h>>2]*+n[a+(p<<2)>>2]+ +n[k>>2];n[b+(m<<2)>>2]=+n[c>>2]*+n[a+(m<<2)>>2]+ +n[j>>2];n[b+(o<<2)>>2]=l;n[b+(p<<2)>>2]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+16|0;j=c+24|0;k=c+36|0;h=c+48|0;i=c+56|0;g=c+72|0;p=c+76|0;o=0;do{r=o|1;q=+n[j>>2]*+n[a+(r<<2)>>2]+ +n[k>>2];n[b+(o<<2)>>2]=+n[c>>2]*+n[a+(o<<2)>>2]+ +n[m>>2];n[b+(r<<2)>>2]=q;r=o|2;s=o|3;q=+n[g>>2]*+n[a+(s<<2)>>2]+ +n[p>>2];n[b+(r<<2)>>2]=+n[h>>2]*+n[a+(r<<2)>>2]+ +n[i>>2];n[b+(s<<2)>>2]=q;o=o+4|0}while((o|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=a;u=b;v=0}else return;while(1){b=c;a=0;while(1){n[u+(a<<2)>>2]=+n[t+(a<<2)>>2]*+n[b+(a<<2)>>2]+ +n[b+(e<<2)>>2];a=a+1|0;if((a|0)==(e|0))break;else b=b+(f<<2)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<2)|0;u=u+(e<<2)|0}}return}}}function IY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+16|0;h=c+32|0;i=c+40|0;j=0;do{k=j|1;l=+p[h>>3]*+p[a+(k<<3)>>3]+ +p[i>>3];p[b+(j<<3)>>3]=+p[c>>3]*+p[a+(j<<3)>>3]+ +p[g>>3];p[b+(k<<3)>>3]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+24|0;g=c+40|0;i=c+56|0;h=c+80|0;k=c+88|0;m=0;do{n=m+1|0;l=+p[g>>3]*+p[a+(n<<3)>>3]+ +p[i>>3];o=m+2|0;q=+p[h>>3]*+p[a+(o<<3)>>3]+ +p[k>>3];p[b+(m<<3)>>3]=+p[c>>3]*+p[a+(m<<3)>>3]+ +p[j>>3];p[b+(n<<3)>>3]=l;p[b+(o<<3)>>3]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+32|0;j=c+48|0;k=c+72|0;h=c+96|0;i=c+112|0;g=c+144|0;o=c+152|0;n=0;do{r=n|1;q=+p[j>>3]*+p[a+(r<<3)>>3]+ +p[k>>3];p[b+(n<<3)>>3]=+p[c>>3]*+p[a+(n<<3)>>3]+ +p[m>>3];p[b+(r<<3)>>3]=q;r=n|2;s=n|3;q=+p[g>>3]*+p[a+(s<<3)>>3]+ +p[o>>3];p[b+(r<<3)>>3]=+p[h>>3]*+p[a+(r<<3)>>3]+ +p[i>>3];p[b+(s<<3)>>3]=q;n=n+4|0}while((n|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=a;u=b;v=0}else return;while(1){b=c;a=0;while(1){p[u+(a<<3)>>3]=+p[t+(a<<3)>>3]*+p[b+(a<<3)>>3]+ +p[b+(e<<3)>>3];a=a+1|0;if((a|0)==(e|0))break;else b=b+(f<<3)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<3)|0;u=u+(e<<3)|0}}return}}}function JY(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0;if((f|0)==2&(g|0)==2){i=e<<1;if((e|0)<=0)return;j=d+4|0;k=d+8|0;l=d+12|0;m=d+16|0;o=d+20|0;p=0;do{q=+(h[a+p>>0]|0);r=p|1;s=+(h[a+r>>0]|0);t=ALc(+n[k>>2]+(q*+n[d>>2]+s*+n[j>>2]))|0;u=ALc(+n[o>>2]+(q*+n[l>>2]+s*+n[m>>2]))|0;b[c+p>>0]=t>>>0<256?t:(t|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;p=p+2|0}while((p|0)<(i|0));return}i=(f|0)==3;if(i&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=d+4|0;l=d+8|0;o=d+12|0;j=d+16|0;k=d+20|0;u=d+24|0;r=d+28|0;t=d+32|0;v=d+36|0;w=d+40|0;x=d+44|0;y=0;do{s=+(h[a+y>>0]|0);z=y+1|0;q=+(h[a+z>>0]|0);A=y+2|0;B=+(h[a+A>>0]|0);C=ALc(+n[o>>2]+(s*+n[d>>2]+q*+n[m>>2]+B*+n[l>>2]))|0;D=ALc(+n[r>>2]+(s*+n[j>>2]+q*+n[k>>2]+B*+n[u>>2]))|0;E=ALc(+n[x>>2]+(s*+n[t>>2]+q*+n[v>>2]+B*+n[w>>2]))|0;b[c+y>>0]=C>>>0<256?C:(C|0)>0?255:0;b[c+z>>0]=D>>>0<256?D:(D|0)>0?255:0;b[c+A>>0]=E>>>0<256?E:(E|0)>0?255:0;y=y+3|0}while((y|0)<(p|0));return}if(i&(g|0)==1){if((e|0)<=0)return;i=d+4|0;p=d+8|0;y=d+12|0;w=a;v=0;while(1){t=ALc(+n[y>>2]+(+n[d>>2]*+(h[w>>0]|0)+ +n[i>>2]*+(h[w+1>>0]|0)+ +n[p>>2]*+(h[w+2>>0]|0)))|0;b[c+v>>0]=t>>>0<256?t:(t|0)>0?255:0;v=v+1|0;if((v|0)==(e|0))break;else w=w+3|0}return}if((f|0)==4&(g|0)==4){w=e<<2;if((e|0)<=0)return;v=d+4|0;p=d+8|0;i=d+12|0;y=d+16|0;t=d+20|0;x=d+24|0;u=d+28|0;k=d+32|0;j=d+36|0;r=d+40|0;l=d+44|0;m=d+48|0;o=d+52|0;E=d+56|0;A=d+60|0;D=d+64|0;z=d+68|0;C=d+72|0;F=d+76|0;G=0;do{B=+(h[a+G>>0]|0);H=G|1;q=+(h[a+H>>0]|0);I=G|2;s=+(h[a+I>>0]|0);J=G|3;K=+(h[a+J>>0]|0);L=ALc(+n[y>>2]+(B*+n[d>>2]+q*+n[v>>2]+s*+n[p>>2]+K*+n[i>>2]))|0;M=ALc(+n[j>>2]+(B*+n[t>>2]+q*+n[x>>2]+s*+n[u>>2]+K*+n[k>>2]))|0;b[c+G>>0]=L>>>0<256?L:(L|0)>0?255:0;b[c+H>>0]=M>>>0<256?M:(M|0)>0?255:0;M=ALc(+n[E>>2]+(B*+n[r>>2]+q*+n[l>>2]+s*+n[m>>2]+K*+n[o>>2]))|0;H=ALc(+n[F>>2]+(B*+n[A>>2]+q*+n[D>>2]+s*+n[z>>2]+K*+n[C>>2]))|0;b[c+I>>0]=M>>>0<256?M:(M|0)>0?255:0;b[c+J>>0]=H>>>0<256?H:(H|0)>0?255:0;G=G+4|0}while((G|0)<(w|0));return}if((e|0)<=0)return;w=f+1|0;if((g|0)<=0)return;if((f|0)>0){N=c;O=a;P=0}else{a=c;c=0;while(1){G=0;C=d;while(1){z=ALc(+n[C+(f<<2)>>2])|0;b[a+G>>0]=z>>>0<256?z:(z|0)>0?255:0;G=G+1|0;if((G|0)==(g|0))break;else C=C+(w<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=0;c=d;while(1){C=0;K=+n[c+(f<<2)>>2];do{K=K+ +n[c+(C<<2)>>2]*+(h[O+C>>0]|0);C=C+1|0}while((C|0)!=(f|0));C=ALc(K)|0;b[N+a>>0]=C>>>0<256?C:(C|0)>0?255:0;a=a+1|0;if((a|0)==(g|0))break;else c=c+(w<<2)|0}P=P+1|0;if((P|0)==(e|0))break;else{N=N+g|0;O=O+f|0}}return}function KY(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=d+4|0;j=d+8|0;k=d+12|0;l=d+16|0;m=d+20|0;o=0;do{p=+(b[a+o>>0]|0);q=o|1;r=+(b[a+q>>0]|0);s=ALc(+n[j>>2]+(p*+n[d>>2]+r*+n[i>>2]))|0;t=ALc(+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]))|0;b[c+o>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;o=o+2|0}while((o|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){o=e*3|0;if((e|0)<=0)return;l=d+4|0;k=d+8|0;m=d+12|0;i=d+16|0;j=d+20|0;t=d+24|0;q=d+28|0;s=d+32|0;u=d+36|0;v=d+40|0;w=d+44|0;x=0;do{r=+(b[a+x>>0]|0);y=x+1|0;p=+(b[a+y>>0]|0);z=x+2|0;A=+(b[a+z>>0]|0);B=ALc(+n[m>>2]+(r*+n[d>>2]+p*+n[l>>2]+A*+n[k>>2]))|0;C=ALc(+n[q>>2]+(r*+n[i>>2]+p*+n[j>>2]+A*+n[t>>2]))|0;D=ALc(+n[w>>2]+(r*+n[s>>2]+p*+n[u>>2]+A*+n[v>>2]))|0;b[c+x>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;b[c+y>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;b[c+z>>0]=(D+128|0)>>>0<256?D:(D|0)>0?127:128;x=x+3|0}while((x|0)<(o|0));return}if(h&(g|0)==1){if((e|0)<=0)return;h=d+4|0;o=d+8|0;x=d+12|0;v=a;u=0;while(1){s=ALc(+n[x>>2]+(+n[d>>2]*+(b[v>>0]|0)+ +n[h>>2]*+(b[v+1>>0]|0)+ +n[o>>2]*+(b[v+2>>0]|0)))|0;b[c+u>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;u=u+1|0;if((u|0)==(e|0))break;else v=v+3|0}return}if((f|0)==4&(g|0)==4){v=e<<2;if((e|0)<=0)return;u=d+4|0;o=d+8|0;h=d+12|0;x=d+16|0;s=d+20|0;w=d+24|0;t=d+28|0;j=d+32|0;i=d+36|0;q=d+40|0;k=d+44|0;l=d+48|0;m=d+52|0;D=d+56|0;z=d+60|0;C=d+64|0;y=d+68|0;B=d+72|0;E=d+76|0;F=0;do{A=+(b[a+F>>0]|0);G=F|1;p=+(b[a+G>>0]|0);H=F|2;r=+(b[a+H>>0]|0);I=F|3;J=+(b[a+I>>0]|0);K=ALc(+n[x>>2]+(A*+n[d>>2]+p*+n[u>>2]+r*+n[o>>2]+J*+n[h>>2]))|0;L=ALc(+n[i>>2]+(A*+n[s>>2]+p*+n[w>>2]+r*+n[t>>2]+J*+n[j>>2]))|0;b[c+F>>0]=(K+128|0)>>>0<256?K:(K|0)>0?127:128;b[c+G>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;L=ALc(+n[D>>2]+(A*+n[q>>2]+p*+n[k>>2]+r*+n[l>>2]+J*+n[m>>2]))|0;G=ALc(+n[E>>2]+(A*+n[z>>2]+p*+n[C>>2]+r*+n[y>>2]+J*+n[B>>2]))|0;b[c+H>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;b[c+I>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;F=F+4|0}while((F|0)<(v|0));return}if((e|0)<=0)return;v=f+1|0;if((g|0)<=0)return;if((f|0)>0){M=c;N=a;O=0}else{a=c;c=0;while(1){F=0;B=d;while(1){y=ALc(+n[B+(f<<2)>>2])|0;b[a+F>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;F=F+1|0;if((F|0)==(g|0))break;else B=B+(v<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=0;c=d;while(1){B=0;J=+n[c+(f<<2)>>2];do{J=J+ +n[c+(B<<2)>>2]*+(b[N+B>>0]|0);B=B+1|0}while((B|0)!=(f|0));B=ALc(J)|0;b[M+a>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;a=a+1|0;if((a|0)==(g|0))break;else c=c+(v<<2)|0}O=O+1|0;if((O|0)==(e|0))break;else{M=M+g|0;N=N+f|0}}return}function LY(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];k=+n[c+4>>2];l=+n[c+8>>2];m=+n[c+12>>2];o=+n[c+16>>2];p=+n[c+20>>2];q=0;do{r=+(j[a+(q<<1)>>1]|0);s=q|1;t=+(j[a+(s<<1)>>1]|0);u=ALc(l+(i*r+k*t))|0;v=ALc(p+(m*r+o*t))|0;d[b+(q<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(s<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+2|0}while((q|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){q=e*3|0;if((e|0)<=0)return;o=+n[c>>2];m=+n[c+4>>2];p=+n[c+8>>2];k=+n[c+12>>2];i=+n[c+16>>2];l=+n[c+20>>2];t=+n[c+24>>2];r=+n[c+28>>2];w=+n[c+32>>2];x=+n[c+36>>2];y=+n[c+40>>2];z=+n[c+44>>2];v=0;do{A=+(j[a+(v<<1)>>1]|0);s=v+1|0;B=+(j[a+(s<<1)>>1]|0);u=v+2|0;C=+(j[a+(u<<1)>>1]|0);D=ALc(k+(o*A+m*B+p*C))|0;E=ALc(r+(i*A+l*B+t*C))|0;F=ALc(z+(w*A+x*B+y*C))|0;d[b+(v<<1)>>1]=D>>>0<65536?D:(D|0)>0?65535:0;d[b+(s<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(u<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;v=v+3|0}while((v|0)<(q|0));return}if(h&(g|0)==1){if((e|0)<=0)return;y=+n[c>>2];x=+n[c+4>>2];w=+n[c+8>>2];z=+n[c+12>>2];h=a;q=0;while(1){v=ALc(z+(y*+(j[h>>1]|0)+x*+(j[h+2>>1]|0)+w*+(j[h+4>>1]|0)))|0;d[b+(q<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+1|0;if((q|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;w=+n[c>>2];x=+n[c+4>>2];y=+n[c+8>>2];z=+n[c+12>>2];t=+n[c+16>>2];l=+n[c+20>>2];i=+n[c+24>>2];r=+n[c+28>>2];p=+n[c+32>>2];m=+n[c+36>>2];o=+n[c+40>>2];k=+n[c+44>>2];C=+n[c+48>>2];B=+n[c+52>>2];A=+n[c+56>>2];G=+n[c+60>>2];H=+n[c+64>>2];I=+n[c+68>>2];J=+n[c+72>>2];K=+n[c+76>>2];q=0;do{L=+(j[a+(q<<1)>>1]|0);v=q|1;M=+(j[a+(v<<1)>>1]|0);F=q|2;N=+(j[a+(F<<1)>>1]|0);u=q|3;O=+(j[a+(u<<1)>>1]|0);E=ALc(t+(w*L+x*M+y*N+z*O))|0;s=ALc(m+(l*L+i*M+r*N+p*O))|0;d[b+(q<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(v<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=ALc(A+(o*L+k*M+C*N+B*O))|0;v=ALc(K+(G*L+H*M+I*N+J*O))|0;d[b+(F<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[b+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+4|0}while((q|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){P=b;Q=a;R=0}else{a=b;b=0;while(1){q=0;v=c;while(1){u=ALc(+n[v+(f<<2)>>2])|0;d[a+(q<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;q=q+1|0;if((q|0)==(g|0))break;else v=v+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=0;b=c;while(1){v=0;J=+n[b+(f<<2)>>2];do{J=J+ +n[b+(v<<2)>>2]*+(j[Q+(v<<1)>>1]|0);v=v+1|0}while((v|0)!=(f|0));v=ALc(J)|0;d[P+(a<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<2)|0}R=R+1|0;if((R|0)==(e|0))break;else{P=P+(g<<1)|0;Q=Q+(f<<1)|0}}return}function MY(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];j=+n[c+4>>2];k=+n[c+8>>2];l=+n[c+12>>2];m=+n[c+16>>2];o=+n[c+20>>2];p=0;do{q=+(d[a+(p<<1)>>1]|0);r=p|1;s=+(d[a+(r<<1)>>1]|0);t=ALc(k+(i*q+j*s))|0;u=ALc(o+(l*q+m*s))|0;d[b+(p<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(r<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+2|0}while((p|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=+n[c>>2];l=+n[c+4>>2];o=+n[c+8>>2];j=+n[c+12>>2];i=+n[c+16>>2];k=+n[c+20>>2];s=+n[c+24>>2];q=+n[c+28>>2];v=+n[c+32>>2];w=+n[c+36>>2];x=+n[c+40>>2];y=+n[c+44>>2];u=0;do{z=+(d[a+(u<<1)>>1]|0);r=u+1|0;A=+(d[a+(r<<1)>>1]|0);t=u+2|0;B=+(d[a+(t<<1)>>1]|0);C=ALc(j+(m*z+l*A+o*B))|0;D=ALc(q+(i*z+k*A+s*B))|0;E=ALc(y+(v*z+w*A+x*B))|0;d[b+(u<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[b+(r<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(t<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;u=u+3|0}while((u|0)<(p|0));return}if(h&(g|0)==1){if((e|0)<=0)return;x=+n[c>>2];w=+n[c+4>>2];v=+n[c+8>>2];y=+n[c+12>>2];h=a;p=0;while(1){u=ALc(y+(x*+(d[h>>1]|0)+w*+(d[h+2>>1]|0)+v*+(d[h+4>>1]|0)))|0;d[b+(p<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+1|0;if((p|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;v=+n[c>>2];w=+n[c+4>>2];x=+n[c+8>>2];y=+n[c+12>>2];s=+n[c+16>>2];k=+n[c+20>>2];i=+n[c+24>>2];q=+n[c+28>>2];o=+n[c+32>>2];l=+n[c+36>>2];m=+n[c+40>>2];j=+n[c+44>>2];B=+n[c+48>>2];A=+n[c+52>>2];z=+n[c+56>>2];F=+n[c+60>>2];G=+n[c+64>>2];H=+n[c+68>>2];I=+n[c+72>>2];J=+n[c+76>>2];p=0;do{K=+(d[a+(p<<1)>>1]|0);u=p|1;L=+(d[a+(u<<1)>>1]|0);E=p|2;M=+(d[a+(E<<1)>>1]|0);t=p|3;N=+(d[a+(t<<1)>>1]|0);D=ALc(s+(v*K+w*L+x*M+y*N))|0;r=ALc(l+(k*K+i*L+q*M+o*N))|0;d[b+(p<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(u<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=ALc(z+(m*K+j*L+B*M+A*N))|0;u=ALc(J+(F*K+G*L+H*M+I*N))|0;d[b+(E<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[b+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+4|0}while((p|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){p=0;u=c;while(1){t=ALc(+n[u+(f<<2)>>2])|0;d[a+(p<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;p=p+1|0;if((p|0)==(g|0))break;else u=u+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=0;b=c;while(1){u=0;I=+n[b+(f<<2)>>2];do{I=I+ +n[b+(u<<2)>>2]*+(d[P+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(f|0));u=ALc(I)|0;d[O+(a<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<2)|0}Q=Q+1|0;if((Q|0)==(e|0))break;else{O=O+(g<<1)|0;P=P+(f<<1)|0}}return}function NY(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=+p[c>>3];j=+p[c+8>>3];k=+p[c+16>>3];l=+p[c+24>>3];m=+p[c+32>>3];n=+p[c+40>>3];o=0;do{q=+(f[a+(o<<2)>>2]|0);r=o|1;s=+(f[a+(r<<2)>>2]|0);t=zLc(k+(i*q+j*s))|0;u=zLc(n+(l*q+m*s))|0;f[b+(o<<2)>>2]=t;f[b+(r<<2)>>2]=u;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;m=+p[c>>3];l=+p[c+8>>3];n=+p[c+16>>3];j=+p[c+24>>3];i=+p[c+32>>3];k=+p[c+40>>3];s=+p[c+48>>3];q=+p[c+56>>3];v=+p[c+64>>3];w=+p[c+72>>3];x=+p[c+80>>3];y=+p[c+88>>3];u=0;do{z=+(f[a+(u<<2)>>2]|0);r=u+1|0;A=+(f[a+(r<<2)>>2]|0);t=u+2|0;B=+(f[a+(t<<2)>>2]|0);C=zLc(j+(m*z+l*A+n*B))|0;D=zLc(q+(i*z+k*A+s*B))|0;E=zLc(y+(v*z+w*A+x*B))|0;f[b+(u<<2)>>2]=C;f[b+(r<<2)>>2]=D;f[b+(t<<2)>>2]=E;u=u+3|0}while((u|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;x=+p[c>>3];w=+p[c+8>>3];v=+p[c+16>>3];y=+p[c+24>>3];h=a;o=0;while(1){u=zLc(y+(x*+(f[h>>2]|0)+w*+(f[h+4>>2]|0)+v*+(f[h+8>>2]|0)))|0;f[b+(o<<2)>>2]=u;o=o+1|0;if((o|0)==(d|0))break;else h=h+12|0}return}if((e|0)==4&(g|0)==4){h=d<<2;if((d|0)<=0)return;v=+p[c>>3];w=+p[c+8>>3];x=+p[c+16>>3];y=+p[c+24>>3];s=+p[c+32>>3];k=+p[c+40>>3];i=+p[c+48>>3];q=+p[c+56>>3];n=+p[c+64>>3];l=+p[c+72>>3];m=+p[c+80>>3];j=+p[c+88>>3];B=+p[c+96>>3];A=+p[c+104>>3];z=+p[c+112>>3];F=+p[c+120>>3];G=+p[c+128>>3];H=+p[c+136>>3];I=+p[c+144>>3];J=+p[c+152>>3];o=0;do{K=+(f[a+(o<<2)>>2]|0);u=o|1;L=+(f[a+(u<<2)>>2]|0);E=o|2;M=+(f[a+(E<<2)>>2]|0);t=o|3;N=+(f[a+(t<<2)>>2]|0);D=zLc(s+(v*K+w*L+x*M+y*N))|0;r=zLc(l+(k*K+i*L+q*M+n*N))|0;f[b+(o<<2)>>2]=D;f[b+(u<<2)>>2]=r;r=zLc(z+(m*K+j*L+B*M+A*N))|0;u=zLc(J+(F*K+G*L+H*M+I*N))|0;f[b+(E<<2)>>2]=r;f[b+(t<<2)>>2]=u;o=o+4|0}while((o|0)<(h|0));return}if((d|0)<=0)return;h=e+1|0;if((g|0)<=0)return;if((e|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){o=0;u=c;while(1){t=zLc(+p[u+(e<<3)>>3])|0;f[a+(o<<2)>>2]=t;o=o+1|0;if((o|0)==(g|0))break;else u=u+(h<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=0;b=c;while(1){u=0;I=+p[b+(e<<3)>>3];do{I=I+ +p[b+(u<<3)>>3]*+(f[P+(u<<2)>>2]|0);u=u+1|0}while((u|0)!=(e|0));u=zLc(I)|0;f[O+(a<<2)>>2]=u;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<3)|0}Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(g<<2)|0;P=P+(e<<2)|0}}return}function OY(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=c+4|0;j=c+8|0;k=c+12|0;l=c+16|0;m=c+20|0;o=0;do{p=+n[a+(o<<2)>>2];q=o|1;r=+n[a+(q<<2)>>2];s=+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]);n[b+(o<<2)>>2]=+n[j>>2]+(p*+n[c>>2]+r*+n[i>>2]);n[b+(q<<2)>>2]=s;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;i=c+4|0;j=c+8|0;l=c+12|0;k=c+16|0;m=c+20|0;q=c+24|0;t=c+28|0;u=c+32|0;v=c+36|0;w=c+40|0;x=c+44|0;y=0;do{s=+n[a+(y<<2)>>2];z=y+1|0;r=+n[a+(z<<2)>>2];A=y+2|0;p=+n[a+(A<<2)>>2];B=+n[t>>2]+(s*+n[k>>2]+r*+n[m>>2]+p*+n[q>>2]);C=+n[x>>2]+(s*+n[u>>2]+r*+n[v>>2]+p*+n[w>>2]);n[b+(y<<2)>>2]=+n[l>>2]+(s*+n[c>>2]+r*+n[i>>2]+p*+n[j>>2]);n[b+(z<<2)>>2]=B;n[b+(A<<2)>>2]=C;y=y+3|0}while((y|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;h=c+4|0;o=c+8|0;y=c+12|0;j=a;i=0;while(1){n[b+(i<<2)>>2]=+n[y>>2]+(+n[c>>2]*+n[j>>2]+ +n[h>>2]*+n[j+4>>2]+ +n[o>>2]*+n[j+8>>2]);i=i+1|0;if((i|0)==(d|0))break;else j=j+12|0}return}if((e|0)==4&(g|0)==4){j=d<<2;if((d|0)<=0)return;i=c+4|0;o=c+8|0;h=c+12|0;y=c+16|0;l=c+20|0;w=c+24|0;v=c+28|0;u=c+32|0;x=c+36|0;q=c+40|0;m=c+44|0;k=c+48|0;t=c+52|0;A=c+56|0;z=c+60|0;D=c+64|0;E=c+68|0;F=c+72|0;G=c+76|0;H=0;do{C=+n[a+(H<<2)>>2];I=H|1;B=+n[a+(I<<2)>>2];J=H|2;p=+n[a+(J<<2)>>2];K=H|3;r=+n[a+(K<<2)>>2];s=+n[x>>2]+(C*+n[l>>2]+B*+n[w>>2]+p*+n[v>>2]+r*+n[u>>2]);n[b+(H<<2)>>2]=+n[y>>2]+(C*+n[c>>2]+B*+n[i>>2]+p*+n[o>>2]+r*+n[h>>2]);n[b+(I<<2)>>2]=s;s=+n[G>>2]+(C*+n[z>>2]+B*+n[D>>2]+p*+n[E>>2]+r*+n[F>>2]);n[b+(J<<2)>>2]=+n[A>>2]+(C*+n[q>>2]+B*+n[m>>2]+p*+n[k>>2]+r*+n[t>>2]);n[b+(K<<2)>>2]=s;H=H+4|0}while((H|0)<(j|0));return}if((d|0)<=0)return;j=e+1|0;if((g|0)<=0)return;if((e|0)>0){L=b;M=a;N=0}else{a=b;b=0;while(1){H=0;t=c;while(1){f[a+(H<<2)>>2]=f[t+(e<<2)>>2];H=H+1|0;if((H|0)==(g|0))break;else t=t+(j<<2)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=0;b=c;while(1){t=0;s=+n[b+(e<<2)>>2];do{s=s+ +n[b+(t<<2)>>2]*+n[M+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0));n[L+(a<<2)>>2]=s;a=a+1|0;if((a|0)==(g|0))break;else b=b+(j<<2)|0}N=N+1|0;if((N|0)==(d|0))break;else{L=L+(g<<2)|0;M=M+(e<<2)|0}}return}function PY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;if((e|0)==2&(f|0)==2){g=d<<1;if((d|0)<=0)return;h=c+8|0;i=c+16|0;j=c+24|0;k=c+32|0;l=c+40|0;m=0;do{n=+p[a+(m<<3)>>3];o=m|1;q=+p[a+(o<<3)>>3];r=+p[l>>3]+(n*+p[j>>3]+q*+p[k>>3]);p[b+(m<<3)>>3]=+p[i>>3]+(n*+p[c>>3]+q*+p[h>>3]);p[b+(o<<3)>>3]=r;m=m+2|0}while((m|0)<(g|0));return}g=(e|0)==3;if(g&(f|0)==3){m=d*3|0;if((d|0)<=0)return;h=c+8|0;i=c+16|0;k=c+24|0;j=c+32|0;l=c+40|0;o=c+48|0;s=c+56|0;t=c+64|0;u=c+72|0;v=c+80|0;w=c+88|0;x=0;do{r=+p[a+(x<<3)>>3];y=x+1|0;q=+p[a+(y<<3)>>3];z=x+2|0;n=+p[a+(z<<3)>>3];A=+p[s>>3]+(r*+p[j>>3]+q*+p[l>>3]+n*+p[o>>3]);B=+p[w>>3]+(r*+p[t>>3]+q*+p[u>>3]+n*+p[v>>3]);p[b+(x<<3)>>3]=+p[k>>3]+(r*+p[c>>3]+q*+p[h>>3]+n*+p[i>>3]);p[b+(y<<3)>>3]=A;p[b+(z<<3)>>3]=B;x=x+3|0}while((x|0)<(m|0));return}if(g&(f|0)==1){if((d|0)<=0)return;g=c+8|0;m=c+16|0;x=c+24|0;i=a;h=0;while(1){p[b+(h<<3)>>3]=+p[x>>3]+(+p[c>>3]*+p[i>>3]+ +p[g>>3]*+p[i+8>>3]+ +p[m>>3]*+p[i+16>>3]);h=h+1|0;if((h|0)==(d|0))break;else i=i+24|0}return}if((e|0)==4&(f|0)==4){i=d<<2;if((d|0)<=0)return;h=c+8|0;m=c+16|0;g=c+24|0;x=c+32|0;k=c+40|0;v=c+48|0;u=c+56|0;t=c+64|0;w=c+72|0;o=c+80|0;l=c+88|0;j=c+96|0;s=c+104|0;z=c+112|0;y=c+120|0;C=c+128|0;D=c+136|0;E=c+144|0;F=c+152|0;G=0;do{B=+p[a+(G<<3)>>3];H=G|1;A=+p[a+(H<<3)>>3];I=G|2;n=+p[a+(I<<3)>>3];J=G|3;q=+p[a+(J<<3)>>3];r=+p[w>>3]+(B*+p[k>>3]+A*+p[v>>3]+n*+p[u>>3]+q*+p[t>>3]);p[b+(G<<3)>>3]=+p[x>>3]+(B*+p[c>>3]+A*+p[h>>3]+n*+p[m>>3]+q*+p[g>>3]);p[b+(H<<3)>>3]=r;r=+p[F>>3]+(B*+p[y>>3]+A*+p[C>>3]+n*+p[D>>3]+q*+p[E>>3]);p[b+(I<<3)>>3]=+p[z>>3]+(B*+p[o>>3]+A*+p[l>>3]+n*+p[j>>3]+q*+p[s>>3]);p[b+(J<<3)>>3]=r;G=G+4|0}while((G|0)<(i|0));return}if((d|0)<=0)return;i=e+1|0;if((f|0)<=0)return;if((e|0)>0){K=b;L=a;M=0}else{a=b;b=0;while(1){G=0;s=c;while(1){p[a+(G<<3)>>3]=+p[s+(e<<3)>>3];G=G+1|0;if((G|0)==(f|0))break;else s=s+(i<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(f<<3)|0}return}while(1){a=0;b=c;while(1){s=0;r=+p[b+(e<<3)>>3];do{r=r+ +p[b+(s<<3)>>3]*+p[L+(s<<3)>>3];s=s+1|0}while((s|0)!=(e|0));p[K+(a<<3)>>3]=r;a=a+1|0;if((a|0)==(f|0))break;else b=b+(i<<3)|0}M=M+1|0;if((M|0)==(d|0))break;else{K=K+(f<<3)|0;L=L+(e<<3)|0}}return}function QY(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+1376|0;g=e+1320|0;h=e+1264|0;i=e+1208|0;j=e+1200|0;k=e+16|0;l=e+1144|0;m=e;n=e+1112|0;do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[g>>2]=f[o>>2];p=g+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[g+36>>2]=s;f[g+40>>2]=r;r=g+48|0;t=g+44|0;f[t>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(g,o);break}}else bS(g,a,-1);while(0);do if((eS(d)|0)==65536){a=f[d+4>>2]|0;f[h>>2]=f[a>>2];o=h+4|0;p=a+4|0;f[o>>2]=f[p>>2];q=h+8|0;f[q>>2]=f[a+8>>2];r=h+12|0;f[r>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=q;s=h+48|0;v=h+44|0;f[v>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[p>>2]|0)<3){p=f[a+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[p>>2];f[s+4>>2]=f[p+4>>2];w=q;x=r;break}else{f[o>>2]=0;U$(h,a);w=q;x=r;break}}else{bS(h,d,-1);w=h+8|0;x=h+12|0}while(0);d=f[g>>2]|0;r=d&7;q=d>>>3&511;d=q+1|0;a=f[w>>2]|0;o=a+-1|0;p=q+2|0;if((p|0)!=(f[x>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=$Xc(32)|0;f[i>>2]=q;f[i+8>>2]=-2147483616;f[i+4>>2]=17;y=q;z=236531;A=y+17|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[q+17>>0]=0;vM(-215,i,236549,235968,2270)}q=(r|0)==5;if((r+-5|0)>>>0>=2){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;s=$Xc(48)|0;f[i>>2]=s;f[i+8>>2]=-2147483600;f[i+4>>2]=34;y=s;z=236570;A=y+34|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[s+34>>0]=0;vM(-215,i,236549,235968,2271)}s=g+40|0;z=f[s>>2]|0;y=f[z>>2]|0;f[j>>2]=f[z+4>>2];f[j+4>>2]=y;wS(c,j,(a<<3)+-16|r,-1,0,0);do if((eS(c)|0)==65536){r=f[c+4>>2]|0;f[i>>2]=f[r>>2];j=i+4|0;y=r+4|0;f[j>>2]=f[y>>2];z=i+8|0;f[z>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[i+28>>2]=f[r+28>>2];f[i+32>>2]=f[r+32>>2];A=f[r+36>>2]|0;f[i+36>>2]=A;f[i+40>>2]=z;z=i+48|0;v=i+44|0;f[v>>2]=z;f[z>>2]=0;f[i+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[r+44>>2]|0;z=f[v>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[j>>2]=0;U$(i,r);break}}else bS(i,c,-1);while(0);c=k+8|0;f[k>>2]=c;r=k+4|0;f[r>>2]=136;j=h+16|0;y=h+44|0;if((f[h>>2]&20479|0)==16390)B=f[j>>2]|0;else{z=Y(p,a)|0;f[r>>2]=z;if(z>>>0>136){v=bYc(z>>>0>536870911?-1:z<<3)|0;f[k>>2]=v;C=v}else C=c;f[l>>2]=1124007942;v=l+4|0;f[v>>2]=2;A=l+8|0;f[A>>2]=a;a=l+12|0;f[a>>2]=p;t=l+16|0;f[t>>2]=C;D=l+20|0;f[D>>2]=C;E=l+24|0;F=l+28|0;G=l+40|0;H=E+8|0;f[H>>2]=0;f[H+4>>2]=0;f[G>>2]=A;H=l+48|0;I=l+44|0;f[I>>2]=H;J=p<<3;f[H>>2]=J;f[l+52>>2]=8;p=C+(z<<3)|0;f[F>>2]=p;f[E>>2]=p+(0-J)+J;R$(l);J=m+8|0;f[J>>2]=0;f[J+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;dY(h,m,6,1.0,0.0);J=l+36|0;p=f[J>>2]|0;if(p|0){z=p+12|0;f[z>>2]=(f[z>>2]|0)+1}z=h+36|0;p=f[z>>2]|0;if(p|0?(K=p+12|0,p=f[K>>2]|0,f[K>>2]=p+-1,(p|0)==1):0)V$(h);f[z>>2]=0;p=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[p>>2]|0)>0){K=f[h+40>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0;M=f[p>>2]|0}while((L|0)<(M|0));f[h>>2]=f[l>>2];if((M|0)<3)N=39;else N=41}else{f[h>>2]=f[l>>2];N=39}if((N|0)==39){M=f[v>>2]|0;if((M|0)<3){f[p>>2]=M;f[w>>2]=f[A>>2];f[x>>2]=f[a>>2];a=f[I>>2]|0;x=f[y>>2]|0;f[x>>2]=f[a>>2];f[x+4>>2]=f[a+4>>2]}else N=41}if((N|0)==41)U$(h,l);f[j>>2]=f[t>>2];f[h+20>>2]=f[D>>2];f[h+24>>2]=f[E>>2];f[h+28>>2]=f[F>>2];f[h+32>>2]=f[l+32>>2];F=f[J>>2]|0;f[z>>2]=F;if(F|0?(z=F+12|0,F=f[z>>2]|0,f[z>>2]=F+-1,(F|0)==1):0)V$(l);f[J>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[v>>2]|0)>0){t=f[G>>2]|0;G=0;do{f[t+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[v>>2]|0))}v=f[I>>2]|0;if((v|0)!=(H|0))wL(v);B=C}C=q?170:169;f[l>>2]=g;f[l+4>>2]=i;f[l+8>>2]=0;q=m;f[q>>2]=0;f[q+4>>2]=0;BL(n,l,m,-1);l=f[n+20>>2]|0;q=n+16|0;v=m+4|0;H=0;while(1){if(H>>>0>=(f[q>>2]|0)>>>0)break;Fh[C&255](f[m>>2]|0,f[v>>2]|0,B,l,d,o);CL(n)|0;H=H+1|0}H=f[k>>2]|0;if((H|0)!=(c|0)){if(H|0)dYc(H);f[k>>2]=c;f[r>>2]=136}r=i+36|0;c=f[r>>2]|0;if(c|0?(k=c+12|0,c=f[k>>2]|0,f[k>>2]=c+-1,(c|0)==1):0)V$(i);f[r>>2]=0;r=i+16|0;c=i+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[i+40>>2]|0;k=0;do{f[r+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)!=(i+48|0))wL(c);c=h+36|0;i=f[c>>2]|0;if(i|0?(k=i+12|0,i=f[k>>2]|0,f[k>>2]=i+-1,(i|0)==1):0)V$(h);f[c>>2]=0;c=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[c>>2]|0)>0){j=f[h+40>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[y>>2]|0;if((c|0)!=(h+48|0))wL(c);c=g+36|0;h=f[c>>2]|0;if(h|0?(y=h+12|0,h=f[y>>2]|0,f[y>>2]=h+-1,(h|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;h=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){c=f[s>>2]|0;s=0;do{f[c+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}wL(h);u=e;return}function RY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=+p[c+48>>3];j=+p[c+56>>3];k=+p[c+64>>3];l=c+8|0;m=c+16|0;o=c+24|0;q=c+32|0;r=c+40|0;s=0;do{t=s|1;u=+n[a+(s<<2)>>2];v=+n[a+(t<<2)>>2];w=k+(i*u+j*v);if(+L(+w)>1.1920928955078125e-07){x=1.0/w;n[b+(s<<2)>>2]=x*(+p[m>>3]+(u*+p[c>>3]+v*+p[l>>3]));y=t;z=x*(+p[r>>3]+(u*+p[o>>3]+v*+p[q>>3]))}else{n[b+(t<<2)>>2]=0.0;y=s;z=0.0}n[b+(y<<2)>>2]=z;s=s+2|0}while((s|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){s=d*3|0;if((d|0)<=0)return;z=+p[c+96>>3];j=+p[c+104>>3];i=+p[c+112>>3];k=+p[c+120>>3];y=c+8|0;q=c+16|0;o=c+24|0;r=c+32|0;l=c+40|0;m=c+48|0;t=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{F=E+1|0;G=E+2|0;v=+n[a+(E<<2)>>2];u=+n[a+(F<<2)>>2];x=+n[a+(G<<2)>>2];w=k+(z*v+j*u+i*x);if(+L(+w)>1.1920928955078125e-07){H=1.0/w;n[b+(E<<2)>>2]=H*(+p[o>>3]+(v*+p[c>>3]+u*+p[y>>3]+x*+p[q>>3]));I=G;J=H*(+p[t>>3]+(v*+p[r>>3]+u*+p[l>>3]+x*+p[m>>3]));K=H*(+p[D>>3]+(v*+p[A>>3]+u*+p[B>>3]+x*+p[C>>3]))}else{n[b+(G<<2)>>2]=0.0;I=E;J=0.0;K=0.0}n[b+(F<<2)>>2]=J;n[b+(I<<2)>>2]=K;E=E+3|0}while((E|0)<(s|0));return}s=(d|0)>0;if(h&g){if(!s)return;K=+p[c+64>>3];J=+p[c+72>>3];i=+p[c+80>>3];j=+p[c+88>>3];g=c+8|0;h=c+16|0;E=c+24|0;I=c+32|0;C=c+40|0;B=c+48|0;A=c+56|0;D=a;m=b;l=0;while(1){z=+n[D>>2];k=+n[D+4>>2];x=+n[D+8>>2];u=j+(K*z+J*k+i*x);if(+L(+u)>1.1920928955078125e-07){v=1.0/u;n[m>>2]=v*(+p[E>>3]+(z*+p[c>>3]+k*+p[g>>3]+x*+p[h>>3]));M=m+4|0;N=v*(+p[A>>3]+(z*+p[I>>3]+k*+p[C>>3]+x*+p[B>>3]))}else{n[m+4>>2]=0.0;M=m;N=0.0}n[M>>2]=N;l=l+1|0;if((l|0)==(d|0))break;else{D=D+12|0;m=m+8|0}}return}if(!s)return;s=e+1|0;m=c+((Y(s,f)|0)<<3)|0;N=+p[m+(e<<3)>>3];D=(f|0)>0;l=f<<2;if((e|0)>0){if(D){O=a;P=b;Q=0}else return;while(1){a=b+((Y(Q,f)|0)<<2)|0;M=0;i=N;do{i=i+ +p[m+(M<<3)>>3]*+n[O+(M<<2)>>2];M=M+1|0}while((M|0)!=(e|0));if(+L(+i)>1.1920928955078125e-07){M=0;B=c;while(1){J=+p[B+(e<<3)>>3];C=0;do{J=J+ +p[B+(C<<3)>>3]*+n[O+(C<<2)>>2];C=C+1|0}while((C|0)!=(e|0));n[P+(M<<2)>>2]=i*J;M=M+1|0;if((M|0)==(f|0))break;else B=B+(s<<3)|0}}else g1c(a|0,0,l|0)|0;Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(e<<2)|0;P=P+(f<<2)|0}}return}else{if(!(+L(+N)>1.1920928955078125e-07)){if(D)R=0;else return;do{g1c(b+((Y(R,f)|0)<<2)|0,0,l|0)|0;R=R+1|0}while((R|0)!=(d|0));return}if(D){S=b;T=0}else return;while(1){b=0;D=c;while(1){n[S+(b<<2)>>2]=N*+p[D+(e<<3)>>3];b=b+1|0;if((b|0)==(f|0))break;else D=D+(s<<3)|0}T=T+1|0;if((T|0)==(d|0))break;else S=S+(f<<2)|0}return}}function SY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,M=0,N=0,O=0,P=0,Q=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=c+48|0;j=c+56|0;k=c+64|0;l=c+8|0;m=c+16|0;n=c+24|0;o=c+32|0;q=c+40|0;r=0;do{s=+p[a+(r<<3)>>3];t=r|1;u=+p[a+(t<<3)>>3];v=+p[k>>3]+(s*+p[i>>3]+u*+p[j>>3]);if(+L(+v)>1.1920928955078125e-07){w=1.0/v;p[b+(r<<3)>>3]=w*(+p[m>>3]+(s*+p[c>>3]+u*+p[l>>3]));x=t;y=w*(+p[q>>3]+(s*+p[n>>3]+u*+p[o>>3]))}else{p[b+(t<<3)>>3]=0.0;x=r;y=0.0}p[b+(x<<3)>>3]=y;r=r+2|0}while((r|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){r=d*3|0;if((d|0)<=0)return;x=c+96|0;o=c+104|0;n=c+112|0;q=c+120|0;l=c+8|0;m=c+16|0;j=c+24|0;i=c+32|0;k=c+40|0;t=c+48|0;z=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{y=+p[a+(E<<3)>>3];F=E+1|0;u=+p[a+(F<<3)>>3];G=E+2|0;s=+p[a+(G<<3)>>3];w=+p[q>>3]+(y*+p[x>>3]+u*+p[o>>3]+s*+p[n>>3]);if(+L(+w)>1.1920928955078125e-07){v=1.0/w;p[b+(E<<3)>>3]=v*(+p[j>>3]+(y*+p[c>>3]+u*+p[l>>3]+s*+p[m>>3]));p[b+(F<<3)>>3]=v*(+p[z>>3]+(y*+p[i>>3]+u*+p[k>>3]+s*+p[t>>3]));H=G;I=v*(+p[D>>3]+(y*+p[A>>3]+u*+p[B>>3]+s*+p[C>>3]))}else{p[b+(G<<3)>>3]=0.0;p[b+(F<<3)>>3]=0.0;H=E;I=0.0}p[b+(H<<3)>>3]=I;E=E+3|0}while((E|0)<(r|0));return}r=(d|0)>0;if(h&g){if(!r)return;g=c+64|0;h=c+72|0;E=c+80|0;H=c+88|0;C=c+8|0;B=c+16|0;A=c+24|0;D=c+32|0;t=c+40|0;k=c+48|0;i=c+56|0;z=a;m=b;l=0;while(1){I=+p[z>>3];s=+p[z+8>>3];u=+p[z+16>>3];y=+p[H>>3]+(I*+p[g>>3]+s*+p[h>>3]+u*+p[E>>3]);if(+L(+y)>1.1920928955078125e-07){v=1.0/y;p[m>>3]=v*(+p[A>>3]+(I*+p[c>>3]+s*+p[C>>3]+u*+p[B>>3]));J=m+8|0;K=v*(+p[i>>3]+(I*+p[D>>3]+s*+p[t>>3]+u*+p[k>>3]))}else{p[m+8>>3]=0.0;J=m;K=0.0}p[J>>3]=K;l=l+1|0;if((l|0)==(d|0))break;else{z=z+24|0;m=m+16|0}}return}if(!r)return;r=e+1|0;m=c+((Y(r,f)|0)<<3)|0;z=m+(e<<3)|0;l=(f|0)>0;J=f<<3;if((e|0)<=0){if(l){M=b;N=0}else return;while(1){K=+p[z>>3];if(+L(+K)>1.1920928955078125e-07){k=0;t=c;while(1){p[M+(k<<3)>>3]=K*+p[t+(e<<3)>>3];k=k+1|0;if((k|0)==(f|0))break;else t=t+(r<<3)|0}}else g1c(b+((Y(N,f)|0)<<3)|0,0,J|0)|0;N=N+1|0;if((N|0)==(d|0))break;else M=M+(f<<3)|0}return}if(l){O=a;P=b;Q=0}else return;while(1){a=b+((Y(Q,f)|0)<<3)|0;l=0;K=+p[z>>3];do{K=K+ +p[m+(l<<3)>>3]*+p[O+(l<<3)>>3];l=l+1|0}while((l|0)!=(e|0));if(+L(+K)>1.1920928955078125e-07){l=0;M=c;while(1){u=+p[M+(e<<3)>>3];N=0;do{u=u+ +p[M+(N<<3)>>3]*+p[O+(N<<3)>>3];N=N+1|0}while((N|0)!=(e|0));p[P+(l<<3)>>3]=K*u;l=l+1|0;if((l|0)==(f|0))break;else M=M+(r<<3)|0}}else g1c(a|0,0,J|0)|0;Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(e<<3)|0;P=P+(f<<3)|0}}return}function TY(a,c,d,e){a=a|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+256|0;h=g;i=g+192|0;j=g+136|0;k=g+80|0;l=g+72|0;m=g+56|0;o=g+40|0;q=g+8|0;p[h>>3]=c;r=dS(a,-1)|0;s=r&7;t=(r>>>3&511)+1|0;if((r|0)!=(dS(d,-1)|0)){v=$Xc(32)|0;f[i>>2]=v;f[i+8>>2]=-2147483616;f[i+4>>2]=20;w=v;x=236605;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[v+20>>0]=0;vM(-215,i,236626,235968,2400)}if(s>>>0<5){L1(a,c,d,1.0,0.0,e,s);u=g;return}do if((eS(a)|0)==65536){v=f[a+4>>2]|0;f[i>>2]=f[v>>2];z=i+4|0;A=v+4|0;f[z>>2]=f[A>>2];B=i+8|0;f[B>>2]=f[v+8>>2];f[i+12>>2]=f[v+12>>2];f[i+16>>2]=f[v+16>>2];f[i+20>>2]=f[v+20>>2];f[i+24>>2]=f[v+24>>2];f[i+28>>2]=f[v+28>>2];f[i+32>>2]=f[v+32>>2];C=f[v+36>>2]|0;f[i+36>>2]=C;f[i+40>>2]=B;B=i+48|0;D=i+44|0;f[D>>2]=B;f[B>>2]=0;f[i+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[v+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;U$(i,v);break}}else bS(i,a,-1);while(0);do if((eS(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];v=j+4|0;z=a+4|0;f[v>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[j+36>>2]=B;D=j+40|0;f[D>>2]=A;A=j+48|0;C=j+44|0;f[C>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];E=D;break}else{f[v>>2]=0;U$(j,a);E=D;break}}else{bS(j,d,-1);E=j+40|0}while(0);d=i+40|0;D=f[d>>2]|0;a=f[D+-4>>2]|0;v=f[E>>2]|0;if((a|0)!=(f[v+-4>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=$Xc(32)|0;f[k>>2]=F;G=k+8|0;f[G>>2]=-2147483616;H=k+4|0;f[H>>2]=22;w=F;x=236635;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));I=F+22|0;b[I>>0]=0;vM(-215,k,236626,235968,2412)}a:do if((a|0)==2){if((f[D>>2]|0)!=(f[v>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=$Xc(32)|0;f[k>>2]=F;G=k+8|0;f[G>>2]=-2147483616;H=k+4|0;f[H>>2]=22;w=F;x=236635;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));I=F+22|0;b[I>>0]=0;vM(-215,k,236626,235968,2412)}if((f[D+4>>2]|0)!=(f[v+4>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=$Xc(32)|0;f[k>>2]=F;G=k+8|0;f[G>>2]=-2147483616;H=k+4|0;f[H>>2]=22;w=F;x=236635;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));I=F+22|0;b[I>>0]=0;vM(-215,k,236626,235968,2412)}}else if((a|0)>0){z=0;while(1){if((f[D+(z<<2)>>2]|0)!=(f[v+(z<<2)>>2]|0))break;z=z+1|0;if((z|0)>=(a|0))break a}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=$Xc(32)|0;f[k>>2]=F;G=k+8|0;f[G>>2]=-2147483616;H=k+4|0;f[H>>2]=22;w=F;x=236635;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));I=F+22|0;b[I>>0]=0;vM(-215,k,236626,235968,2412)}while(0);I=i+4|0;xS(e,f[I>>2]|0,D,r,-1,0,0);do if((eS(e)|0)==65536){r=f[e+4>>2]|0;f[k>>2]=f[r>>2];D=k+4|0;F=r+4|0;f[D>>2]=f[F>>2];x=k+8|0;f[x>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[k+16>>2]=f[r+16>>2];f[k+20>>2]=f[r+20>>2];f[k+24>>2]=f[r+24>>2];f[k+28>>2]=f[r+28>>2];f[k+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[k+36>>2]=w;f[k+40>>2]=x;x=k+48|0;y=k+44|0;f[y>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(w|0){x=w+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[F>>2]|0)<3){F=f[r+44>>2]|0;x=f[y>>2]|0;f[x>>2]=f[F>>2];f[x+4>>2]=f[F+4>>2];break}else{f[D>>2]=0;U$(k,r);break}}else bS(k,e,-1);while(0);n[l>>2]=+p[h>>3];e=(s|0)==5;s=e?l:h;h=e?148:147;if(((f[i>>2]&16384|0)!=0?(f[j>>2]&16384|0)!=0:0)?(f[k>>2]&16384|0)!=0:0){e=f[I>>2]|0;if((e|0)<3)J=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{l=f[d>>2]|0;r=0;D=1;while(1){F=Y(f[l+(r<<2)>>2]|0,D)|0;r=r+1|0;if((r|0)==(e|0)){J=F;break}else D=F}}D=Y(J,t)|0;gi[h&255](f[i+16>>2]|0,f[j+16>>2]|0,f[k+16>>2]|0,D,s)}else{f[m>>2]=i;f[m+4>>2]=j;f[m+8>>2]=k;f[m+12>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;BL(q,m,o,-1);m=Y(f[q+20>>2]|0,t)|0;t=q+16|0;D=o+4|0;J=o+8|0;e=0;while(1){if(e>>>0>=(f[t>>2]|0)>>>0)break;gi[h&255](f[o>>2]|0,f[D>>2]|0,f[J>>2]|0,m,s);CL(q)|0;e=e+1|0}}e=k+36|0;q=f[e>>2]|0;if(q|0?(s=q+12|0,q=f[s>>2]|0,f[s>>2]=q+-1,(q|0)==1):0)V$(k);f[e>>2]=0;e=k+16|0;q=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){e=f[k+40>>2]|0;s=0;do{f[e+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))wL(q);q=j+36|0;k=f[q>>2]|0;if(k|0?(s=k+12|0,k=f[s>>2]|0,f[s>>2]=k+-1,(k|0)==1):0)V$(j);f[q>>2]=0;q=j+16|0;k=j+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[k>>2]|0)>0){q=f[E>>2]|0;E=0;do{f[q+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(E=j+12|0,j=f[E>>2]|0,f[E>>2]=j+-1,(j|0)==1):0)V$(i);f[k>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[I>>2]|0)>0){k=f[d>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[I>>2]|0))}I=f[i+44>>2]|0;if((I|0)!=(i+48|0))wL(I);u=g;return}function UY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0;f=+n[e>>2];if((d|0)>0)g=0;else return;do{n[c+(g<<2)>>2]=f*+n[a+(g<<2)>>2]+ +n[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(d|0));return}function VY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0;f=+p[e>>3];if((d|0)>0)g=0;else return;do{p[c+(g<<3)>>3]=f*+p[a+(g<<3)>>3]+ +p[b+(g<<3)>>3];g=g+1|0}while((g|0)!=(d|0));return}function WY(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+352|0;j=i+288|0;k=i+232|0;l=i+176|0;m=i+120|0;n=i+104|0;o=i+88|0;p=i+72|0;q=i+16|0;r=i;do if((eS(a)|0)==65536){s=f[a+4>>2]|0;f[j>>2]=f[s>>2];t=j+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=j+8|0;f[w>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];f[j+16>>2]=f[s+16>>2];f[j+20>>2]=f[s+20>>2];f[j+24>>2]=f[s+24>>2];f[j+28>>2]=f[s+28>>2];f[j+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=w;w=j+48|0;y=j+44|0;f[y>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;U$(j,s);break}}else bS(j,a,-1);while(0);do if((eS(e)|0)==65536){a=f[e+4>>2]|0;f[k>>2]=f[a>>2];s=k+4|0;t=a+4|0;f[s>>2]=f[t>>2];v=k+8|0;f[v>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];w=f[a+36>>2]|0;f[k+36>>2]=w;f[k+40>>2]=v;v=k+48|0;y=k+44|0;f[y>>2]=v;f[v>>2]=0;f[k+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=k;break}else{f[s>>2]=0;U$(k,a);z=k;break}}else{bS(k,e,-1);z=k}while(0);e=f[j>>2]|0;a=e&4095;s=((h|0)>-1?h:e)&7;h=f[z>>2]|0;z=h&7;t=s>>>0<z>>>0?z:s;s=(t|0)>5?t:5;if(e&4088|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=$Xc(32)|0;f[l>>2]=e;f[l+8>>2]=-2147483616;f[l+4>>2]=19;A=e;B=236658;C=A+19|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[e+19>>0]=0;vM(-215,l,236678,235968,2873)}e=k+16|0;if(f[e>>2]|0){z=f[k+4>>2]|0;if((z|0)<3)D=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{v=f[k+40>>2]|0;y=0;w=1;while(1){x=Y(f[v+(y<<2)>>2]|0,w)|0;y=y+1|0;if((y|0)==(z|0)){D=x;break}else w=x}}if(!((z|0)==0|(D|0)==0)){if(h&4088|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(32)|0;f[l>>2]=D;f[l+8>>2]=-2147483616;f[l+4>>2]=21;A=D;B=236692;C=A+21|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[D+21>>0]=0;vM(-215,l,236678,235968,2879)}D=f[k+8>>2]|0;if(!((D|0)==1?1:(D|0)==(f[j+8>>2]|0))){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(48)|0;f[l>>2]=D;f[l+8>>2]=-2147483600;f[l+4>>2]=43;A=D;B=236714;C=A+43|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[D+43>>0]=0;vM(-215,l,236678,235968,2879)}D=f[k+12>>2]|0;if(!((D|0)==1?1:(D|0)==(f[j+12>>2]|0))){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(48)|0;f[l>>2]=D;f[l+8>>2]=-2147483600;f[l+4>>2]=43;A=D;B=236758;C=A+43|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[D+43>>0]=0;vM(-215,l,236678,235968,2879)}if((h&4095|0)!=(s|0)){h=l+8|0;f[h>>2]=0;f[h+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;dY(k,l,s,1.0,0.0)}}}h=j+8|0;D=j+12|0;B=d?f[D>>2]|0:f[h>>2]|0;ZS(c,B,B,s,-1,0,0);do if((eS(c)|0)==65536){B=f[c+4>>2]|0;f[l>>2]=f[B>>2];z=l+4|0;w=B+4|0;f[z>>2]=f[w>>2];y=l+8|0;f[y>>2]=f[B+8>>2];f[l+12>>2]=f[B+12>>2];v=l+16|0;f[v>>2]=f[B+16>>2];f[l+20>>2]=f[B+20>>2];f[l+24>>2]=f[B+24>>2];f[l+28>>2]=f[B+28>>2];f[l+32>>2]=f[B+32>>2];x=f[B+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=y;y=l+48|0;E=l+44|0;f[E>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(x|0){y=x+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[w>>2]|0)<3){w=f[B+44>>2]|0;y=f[E>>2]|0;f[y>>2]=f[w>>2];f[y+4>>2]=f[w+4>>2];F=v;break}else{f[z>>2]=0;U$(l,B);F=v;break}}else{bS(l,c,-1);F=l+16|0}while(0);c=j+16|0;do if((f[c>>2]|0)==(f[F>>2]|0))G=42;else{if(((a|0)==(s|0)?(f[l+12>>2]|0)>99:0)?((f[D>>2]|0)>99?(f[l+8>>2]|0)>99:0)&(f[h>>2]|0)>99:0){G=42;break}v=(a|0)==0;B=(t|0)<6;do if(!(v&B)){z=(s|0)==6;if(v&z){H=d?26:25;break}w=(a|0)==2;if(w&B){H=d?28:27;break}if(w&z){H=d?30:29;break}w=(a|0)==3;if(w&B){H=d?32:31;break}if(w&z){H=d?34:33;break}w=(a|0)==5;if(w&B){H=d?36:35;break}if(w&z){H=d?38:37;break}if((a|0)==6&z)H=d?40:39;else{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;vM(-210,m,236678,235968,2974)}}else H=d?24:23;while(0);$h[H&63](j,l,k,g);B=m+8|0;f[B>>2]=0;f[B+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=l;VV(m,0)}while(0);if((G|0)==42){f[m>>2]=1124007936;G=m+4|0;H=m+8|0;a=m+40|0;A=G;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[a>>2]=H;H=m+48|0;s=m+44|0;f[s>>2]=H;f[H>>2]=0;f[m+52>>2]=0;do if(f[e>>2]|0){t=f[k+4>>2]|0;if((t|0)<3)I=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{B=f[k+40>>2]|0;v=0;z=1;while(1){w=Y(f[B+(v<<2)>>2]|0,z)|0;v=v+1|0;if((v|0)==(t|0)){I=w;break}else z=w}}if(!((t|0)==0|(I|0)==0)){z=f[k+40>>2]|0;v=f[j+40>>2]|0;if((f[z>>2]|0)==(f[v>>2]|0)?(f[z+4>>2]|0)==(f[v+4>>2]|0):0){f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=j;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;v=p+8|0;f[v>>2]=0;f[v+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=m;G1(n,o,p,fT()|0,-1);J=m;break}else{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=k;v=f[h>>2]|0;z=f[k+8>>2]|0;B=f[D>>2]|0;w=f[k+12>>2]|0;y=o+8|0;f[y>>2]=0;f[y+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;pR(n,(v|0)/(z|0)|0,(B|0)/(w|0)|0,o);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=j;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=m;w=p+8|0;f[w>>2]=0;f[w+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=m;G1(n,o,p,fT()|0,-1);J=m;break}}else J=j}else J=j;while(0);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=J;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=J;f[q>>2]=1124007936;J=q+4|0;D=q+8|0;h=q+40|0;A=J;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[h>>2]=D;D=q+48|0;A=q+44|0;f[A>>2]=D;f[D>>2]=0;f[q+52>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=q;C=r+8|0;f[C>>2]=0;f[C+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=l;AY(n,o,g,p,0.0,r,d?1:2);d=q+36|0;r=f[d>>2]|0;if(r|0?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)V$(q);f[d>>2]=0;d=q+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[J>>2]|0)>0){d=f[h>>2]|0;h=0;do{f[d+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[J>>2]|0))}J=f[A>>2]|0;if((J|0)!=(D|0))wL(J);J=m+36|0;D=f[J>>2]|0;if(D|0?(A=D+12|0,D=f[A>>2]|0,f[A>>2]=D+-1,(D|0)==1):0)V$(m);f[J>>2]=0;J=m+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[G>>2]|0)>0){J=f[a>>2]|0;a=0;do{f[J+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[s>>2]|0;if((G|0)!=(H|0))wL(G)}G=l+36|0;H=f[G>>2]|0;if(H|0?(s=H+12|0,H=f[s>>2]|0,f[s>>2]=H+-1,(H|0)==1):0)V$(l);f[G>>2]=0;G=l+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[G>>2]|0)>0){F=f[l+40>>2]|0;H=0;do{f[F+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[G>>2]|0))}G=f[l+44>>2]|0;if((G|0)!=(l+48|0))wL(G);G=k+36|0;l=f[G>>2]|0;if(l|0?(H=l+12|0,l=f[H>>2]|0,f[H>>2]=l+-1,(l|0)==1):0)V$(k);f[G>>2]=0;G=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[G>>2]|0)>0){e=f[k+40>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[G>>2]|0))}G=f[k+44>>2]|0;if((G|0)!=(k+48|0))wL(G);G=j+36|0;k=f[G>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)V$(j);f[G>>2]=0;G=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[G>>2]|0)>0){c=f[j+40>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[G>>2]|0))}G=f[j+44>>2]|0;if((G|0)==(j+48|0)){u=i;return}wL(G);u=i;return}function XY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=bYc(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=j;H=0;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+H)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(h[J>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+H)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(h[t>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=i+M|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(h[K>>0]|0)-+n[I>>2]);P=P+R*(+(h[K+1>>0]|0)-+n[I+4>>2]);O=O+R*(+(h[K+2>>0]|0)-+n[I+8>>2]);N=N+R*(+(h[K+3>>0]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+l|0}}n[G+(M<<2)>>2]=Q*d;n[G+(M+1<<2)>>2]=P*d;n[G+(M+2<<2)>>2]=O*d;n[G+(M+3<<2)>>2]=N*d;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=i+K|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(h[I>>0]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+l|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+K|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(h[t>>0]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+l|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j)|0;n[v+(L<<2)>>2]=+(h[y>>0]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+T|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(h[L>>0]|0);O=O+Q*+(h[L+1>>0]|0);R=R+Q*+(h[L+2>>0]|0);F=F+Q*+(h[L+3>>0]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+l|0}n[x+(T<<2)>>2]=P*d;n[x+(T+1<<2)>>2]=O*d;n[x+(T+2<<2)>>2]=R*d;n[x+(T+3<<2)>>2]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+U|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(h[L>>0]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+l|0}n[x+(U<<2)>>2]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}dYc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function YY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;i=e;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+(Y(x,m)|0)|0;if(r){A=x;do{B=j+(Y(A,m)|0)|0;if(v){C=0;D=0.0;while(1){E=D+ +(h[z+C>>0]|0)*+(h[B+C>>0]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+(Y(A,m)|0)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(h[z+B>>0]|0)*+(h[C+B>>0]|0)+ +(h[z+G>>0]|0)*+(h[C+G>>0]|0)+ +(h[z+H>>0]|0)*+(h[C+H>>0]|0)+ +(h[z+I>>0]|0)*+(h[C+I>>0]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(h[z+B>>0]|0)*+(h[C+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=bYc(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=k;k=l+C|0;while(1){C=j+(Y(H,m)|0)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(h[C+N>>0]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(h[C+N>>0]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=j+(Y(P,m)|0)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[g>>2]=C;a:do if(z){S=0.0;T=g;U=0}else{K=0.0;M=g;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(h[N+V>>0]|0)-F)+ +n[L+(W<<2)>>2]*(+(h[N+W>>0]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(h[N+X>>0]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[N+Z>>0]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(h[N+V>>0]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=j+(Y(Q,m)|0)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(h[C+V>>0]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(h[C+M>>0]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(h[C+X>>0]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[C+Z>>0]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(h[C+V>>0]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){dYc(L);f[i>>2]=t;f[w>>2]=1032}u=e;return}function ZY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=bYc(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=j;H=0;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+H)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(h[J>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+H)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(h[t>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=i+M|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(h[K>>0]|0)-+p[I>>3]);P=P+R*(+(h[K+1>>0]|0)-+p[I+8>>3]);O=O+R*(+(h[K+2>>0]|0)-+p[I+16>>3]);N=N+R*(+(h[K+3>>0]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+l|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=i+K|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(h[I>>0]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+l|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+K|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(h[t>>0]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+l|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j)|0;p[v+(L<<3)>>3]=+(h[y>>0]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+T|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(h[L>>0]|0);O=O+Q*+(h[L+1>>0]|0);R=R+Q*+(h[L+2>>0]|0);F=F+Q*+(h[L+3>>0]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+l|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+U|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(h[L>>0]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+l|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}dYc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function _Y(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;i=e+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+(Y(w,m)|0)|0;if(r){z=w;do{A=j+(Y(z,m)|0)|0;if(t){B=0;C=0.0;while(1){D=C+ +(h[y+B>>0]|0)*+(h[A+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+(Y(z,m)|0)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(h[y+A>>0]|0)*+(h[B+A>>0]|0)+ +(h[y+F>>0]|0)*+(h[B+F>>0]|0)+ +(h[y+G>>0]|0)*+(h[B+G>>0]|0)+ +(h[y+H>>0]|0)*+(h[B+H>>0]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(h[y+A>>0]|0)*+(h[B+A>>0]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=bYc(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=k;k=l+H|0;while(1){H=j+(Y(G,m)|0)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(h[H+M>>0]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(h[H+M>>0]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=j+(Y(O,m)|0)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(h[M+H>>0]|0)-D)+ +p[K+(U<<3)>>3]*(+(h[M+U>>0]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(h[M+V>>0]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(h[M+W>>0]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(h[M+L>>0]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=j+(Y(P,m)|0)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(h[H+L>>0]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(h[H+V>>0]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(h[H+W>>0]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(h[H+U>>0]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(h[H+L>>0]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){dYc(K);f[i>>2]=s;f[v>>2]=1032}u=e;return}function $Y(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=bYc(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(B){if(o){I=0;do{J=h+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(j[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=h+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(j[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=h+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(j[K>>1]|0)-+n[I>>2]);P=P+R*(+(j[K+2>>1]|0)-+n[I+4>>2]);O=O+R*(+(j[K+4>>1]|0)-+n[I+8>>2]);N=N+R*(+(j[K+6>>1]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+(l<<1)|0}}n[G+(M<<2)>>2]=Q*d;n[G+(M+1<<2)>>2]=P*d;n[G+(M+2<<2)>>2]=O*d;n[G+(M+3<<2)>>2]=N*d;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=h+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(j[I>>1]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+(l<<1)|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<1)|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(j[t>>1]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+(l<<1)|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,l)|0)+i<<1)|0;n[v+(L<<2)>>2]=+(j[y>>1]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(j[L>>1]|0);O=O+Q*+(j[L+2>>1]|0);R=R+Q*+(j[L+4>>1]|0);F=F+Q*+(j[L+6>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(T<<2)>>2]=P*d;n[x+(T+1<<2)>>2]=O*d;n[x+(T+2<<2)>>2]=R*d;n[x+(T+3<<2)>>2]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(j[L>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(U<<2)>>2]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}dYc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function aZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=i+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=i+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(j[z+(C<<1)>>1]|0)*+(j[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=i+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0)+ +(j[z+(G<<1)>>1]|0)*+(j[C+(G<<1)>>1]|0)+ +(j[z+(H<<1)>>1]|0)*+(j[C+(H<<1)>>1]|0)+ +(j[z+(I<<1)>>1]|0)*+(j[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=h+8|0;f[h>>2]=t;w=h+4|0;f[w>>2]=x;if(x>>>0>1032){c=bYc(x)|0;f[h>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=k;k=l+C|0;while(1){C=i+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(j[C+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(j[C+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=i+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[g>>2]=C;a:do if(z){S=0.0;T=g;U=0}else{K=0.0;M=g;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(j[N+(V<<1)>>1]|0)-F)+ +n[L+(W<<2)>>2]*(+(j[N+(W<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(j[N+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[N+(Z<<1)>>1]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(j[N+(V<<1)>>1]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=i+((Y(Q,m)|0)<<1)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(j[C+(V<<1)>>1]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(j[C+(M<<1)>>1]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(j[C+(X<<1)>>1]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[C+(Z<<1)>>1]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(j[C+(V<<1)>>1]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){dYc(L);f[h>>2]=t;f[w>>2]=1032}u=e;return}function bZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=bYc(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(n){if(C){I=0;do{J=h+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(j[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(j[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=h+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(j[K>>1]|0)-+p[I>>3]);P=P+R*(+(j[K+2>>1]|0)-+p[I+8>>3]);O=O+R*(+(j[K+4>>1]|0)-+p[I+16>>3]);N=N+R*(+(j[K+6>>1]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(l<<1)|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=h+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(j[I>>1]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(l<<1)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<1)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(j[t>>1]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(l<<1)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,l)|0)+i<<1)|0;p[v+(L<<3)>>3]=+(j[y>>1]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(j[L>>1]|0);O=O+Q*+(j[L+2>>1]|0);R=R+Q*+(j[L+4>>1]|0);F=F+Q*+(j[L+6>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(j[L>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}dYc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function cZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=i+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=i+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(j[y+(B<<1)>>1]|0)*+(j[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0)+ +(j[y+(F<<1)>>1]|0)*+(j[B+(F<<1)>>1]|0)+ +(j[y+(G<<1)>>1]|0)*+(j[B+(G<<1)>>1]|0)+ +(j[y+(H<<1)>>1]|0)*+(j[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=bYc(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=k;k=l+H|0;while(1){H=i+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(j[H+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(j[H+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(j[M+(H<<1)>>1]|0)-D)+ +p[K+(U<<3)>>3]*(+(j[M+(U<<1)>>1]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(j[M+(V<<1)>>1]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(j[M+(W<<1)>>1]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(j[M+(L<<1)>>1]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=i+((Y(P,m)|0)<<1)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(j[H+(L<<1)>>1]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(j[H+(V<<1)>>1]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(j[H+(W<<1)>>1]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(j[H+(U<<1)>>1]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(j[H+(L<<1)>>1]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){dYc(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function dZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=bYc(o)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=e*0.0;E=e*0.0;F=e*0.0;G=j;H=0;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(d[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(d[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=i+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(d[K>>1]|0)-+n[I>>2]);P=P+R*(+(d[K+2>>1]|0)-+n[I+4>>2]);O=O+R*(+(d[K+4>>1]|0)-+n[I+8>>2]);N=N+R*(+(d[K+6>>1]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+(l<<1)|0}}n[G+(M<<2)>>2]=Q*e;n[G+(M+1<<2)>>2]=P*e;n[G+(M+2<<2)>>2]=O*e;n[G+(M+3<<2)>>2]=N*e;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=i+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(d[I>>1]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+(l<<1)|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*e;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+(K<<1)|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(d[t>>1]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+(l<<1)|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*e;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=e*0.0;D=e*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j<<1)|0;n[v+(L<<2)>>2]=+(d[y>>1]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(d[L>>1]|0);O=O+Q*+(d[L+2>>1]|0);R=R+Q*+(d[L+4>>1]|0);F=F+Q*+(d[L+6>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(T<<2)>>2]=P*e;n[x+(T+1<<2)>>2]=O*e;n[x+(T+2<<2)>>2]=R*e;n[x+(T+3<<2)>>2]=F*e;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(d[L>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(U<<2)>>2]=Q*e;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=g;return}dYc(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function eZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;g=u;u=u+1056|0;h=g+1040|0;i=g;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=j+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(d[z+(C<<1)>>1]|0)*+(d[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*e;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0)+ +(d[z+(G<<1)>>1]|0)*+(d[C+(G<<1)>>1]|0)+ +(d[z+(H<<1)>>1]|0)*+(d[C+(H<<1)>>1]|0)+ +(d[z+(I<<1)>>1]|0)*+(d[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*e;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=g;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=bYc(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=h+12|0;v=h+8|0;r=h+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=h+C|0;H=0;G=k;k=l+C|0;while(1){C=j+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(d[C+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(d[C+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=j+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[h>>2]=C;a:do if(z){S=0.0;T=h;U=0}else{K=0.0;M=h;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(d[N+(V<<1)>>1]|0)-F)+ +n[L+(W<<2)>>2]*(+(d[N+(W<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(d[N+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[N+(Z<<1)>>1]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(d[N+(V<<1)>>1]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*e;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=j+((Y(Q,m)|0)<<1)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(d[C+(V<<1)>>1]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(d[C+(M<<1)>>1]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(d[C+(X<<1)>>1]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[C+(Z<<1)>>1]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(d[C+(V<<1)>>1]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*e;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){dYc(L);f[i>>2]=t;f[w>>2]=1032}u=g;return}function fZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=bYc(n)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=e*0.0;E=e*0.0;F=e*0.0;G=j;H=0;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(d[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(d[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=i+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(d[K>>1]|0)-+p[I>>3]);P=P+R*(+(d[K+2>>1]|0)-+p[I+8>>3]);O=O+R*(+(d[K+4>>1]|0)-+p[I+16>>3]);N=N+R*(+(d[K+6>>1]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(l<<1)|0}}p[G+(M<<3)>>3]=Q*e;p[G+(M+1<<3)>>3]=P*e;p[G+(M+2<<3)>>3]=O*e;p[G+(M+3<<3)>>3]=N*e;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=i+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(d[I>>1]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(l<<1)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*e;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+(K<<1)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(d[t>>1]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(l<<1)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*e;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=e*0.0;B=e*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j<<1)|0;p[v+(L<<3)>>3]=+(d[y>>1]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(d[L>>1]|0);O=O+Q*+(d[L+2>>1]|0);R=R+Q*+(d[L+4>>1]|0);F=F+Q*+(d[L+6>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(T<<3)>>3]=P*e;p[x+(T+1<<3)>>3]=O*e;p[x+(T+2<<3)>>3]=R*e;p[x+(T+3<<3)>>3]=F*e;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(d[L>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(U<<3)>>3]=Q*e;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=g;return}dYc(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function gZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;g=u;u=u+1072|0;h=g;i=g+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=j+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(d[y+(B<<1)>>1]|0)*+(d[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*e;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0)+ +(d[y+(F<<1)>>1]|0)*+(d[B+(F<<1)>>1]|0)+ +(d[y+(G<<1)>>1]|0)*+(d[B+(G<<1)>>1]|0)+ +(d[y+(H<<1)>>1]|0)*+(d[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*e;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=g;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=bYc(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=h+24|0;t=h+16|0;r=h+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=h+H|0;G=0;F=k;k=l+H|0;while(1){H=j+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(d[H+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(d[H+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=j+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[h>>3]=J;a:do if(y){R=0.0;S=h;T=0}else{E=0.0;L=h;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(d[M+(H<<1)>>1]|0)-D)+ +p[K+(U<<3)>>3]*(+(d[M+(U<<1)>>1]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(d[M+(V<<1)>>1]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(d[M+(W<<1)>>1]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(d[M+(L<<1)>>1]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*e;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=j+((Y(P,m)|0)<<1)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(d[H+(L<<1)>>1]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(d[H+(V<<1)>>1]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(d[H+(W<<1)>>1]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(d[H+(U<<1)>>1]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(d[H+(L<<1)>>1]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*e;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){dYc(K);f[i>>2]=s;f[v>>2]=1032}u=g;return}function hZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;p=g+4|0;f[p>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?o*20|0:o<<2;f[p>>2]=m;if(m>>>0>1032){s=bYc(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(o<<2)|0;if((o|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<2)|0;A=f[m>>2]|0;m=z<<2;f[s+((m|3)<<2)>>2]=A;f[s+((m|2)<<2)>>2]=A;f[s+((m|1)<<2)>>2]=A;f[s+(m<<2)>>2]=A;z=z+1|0}while((z|0)!=(o|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){A=(x|0)!=0;m=(o|0)>0;B=a+-4|0;C=d*0.0;D=d*0.0;E=d*0.0;F=i;G=0;while(1){if(A){if(m){H=0;do{I=h+((Y(H,k)|0)+G<<2)|0;J=x+((Y(H,y)|0)<<2)|0;n[t+(H<<2)>>2]=+n[I>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}}else if(m){H=0;do{s=h+((Y(H,k)|0)+G<<2)|0;J=w+((Y(H,y)|0)+G<<2)|0;n[t+(H<<2)>>2]=+n[s>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}b:do if((G|0)>(B|0))K=G;else{if(m)L=G;else{H=G;while(1){n[F+(H<<2)>>2]=E;n[F+(H+1<<2)>>2]=E;n[F+(H+2<<2)>>2]=E;n[F+(H+3<<2)>>2]=E;J=H+4|0;if((J|0)>(B|0)){K=J;break b}else H=J}}while(1){H=A?x:w+(L<<2)|0;J=h+(L<<2)|0;M=0.0;N=0.0;O=0.0;P=0.0;s=0;while(1){Q=+n[t+(s<<2)>>2];P=P+Q*(+n[J>>2]-+n[H>>2]);O=O+Q*(+n[J+4>>2]-+n[H+4>>2]);N=N+Q*(+n[J+8>>2]-+n[H+8>>2]);M=M+Q*(+n[J+12>>2]-+n[H+12>>2]);s=s+1|0;if((s|0)==(o|0))break;else{H=H+(y<<2)|0;J=J+(k<<2)|0}}n[F+(L<<2)>>2]=P*d;n[F+(L+1<<2)>>2]=O*d;n[F+(L+2<<2)>>2]=N*d;n[F+(L+3<<2)>>2]=M*d;J=L+4|0;if((J|0)>(B|0)){K=J;break}else L=J}}while(0);c:do if((K|0)<(a|0)){if(!m)if(A){J=K;while(1){n[F+(J<<2)>>2]=C;J=J+1|0;if((J|0)==(a|0))break c}}else{J=K;while(1){n[F+(J<<2)>>2]=D;J=J+1|0;if((J|0)==(a|0))break c}}if(A){J=K;do{H=h+(J<<2)|0;Q=0.0;s=x;I=0;while(1){Q=Q+ +n[t+(I<<2)>>2]*(+n[H>>2]-+n[s>>2]);I=I+1|0;if((I|0)==(o|0))break;else{H=H+(k<<2)|0;s=s+(y<<2)|0}}n[F+(J<<2)>>2]=Q*d;J=J+1|0}while((J|0)!=(a|0))}else{J=K;do{s=h+(J<<2)|0;M=0.0;H=w+(J<<2)|0;I=0;while(1){M=M+ +n[t+(I<<2)>>2]*(+n[s>>2]-+n[H>>2]);I=I+1|0;if((I|0)==(o|0))break;else{s=s+(k<<2)|0;H=H+(y<<2)|0}}n[F+(J<<2)>>2]=M*d;J=J+1|0}while((J|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else F=F+(l<<2)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(o|0)>0;y=a+-4|0;D=d*0.0;C=d*0.0;w=i;i=0;while(1){if(v){K=0;do{x=h+((Y(K,k)|0)+i<<2)|0;f[t+(K<<2)>>2]=f[x>>2];K=K+1|0}while((K|0)!=(o|0))}d:do if((i|0)>(y|0))R=i;else{if(v)S=i;else{K=i;while(1){n[w+(K<<2)>>2]=C;n[w+(K+1<<2)>>2]=C;n[w+(K+2<<2)>>2]=C;n[w+(K+3<<2)>>2]=C;x=K+4|0;if((x|0)>(y|0)){R=x;break d}else K=x}}while(1){K=h+(S<<2)|0;E=0.0;Q=0.0;N=0.0;O=0.0;x=0;while(1){P=+n[t+(x<<2)>>2];O=O+P*+n[K>>2];N=N+P*+n[K+4>>2];Q=Q+P*+n[K+8>>2];E=E+P*+n[K+12>>2];x=x+1|0;if((x|0)==(o|0))break;else K=K+(k<<2)|0}n[w+(S<<2)>>2]=O*d;n[w+(S+1<<2)>>2]=N*d;n[w+(S+2<<2)>>2]=Q*d;n[w+(S+3<<2)>>2]=E*d;K=S+4|0;if((K|0)>(y|0)){R=K;break}else S=K}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{K=R;while(1){n[w+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break e}}do{K=h+(T<<2)|0;P=0.0;x=0;while(1){P=P+ +n[t+(x<<2)>>2]*+n[K>>2];x=x+1|0;if((x|0)==(o|0))break;else K=K+(k<<2)|0}n[w+(T<<2)>>2]=P*d;T=T+1|0}while((T|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else w=w+(l<<2)|0}}if((t|0)==(c|0)){u=e;return}dYc(t);f[g>>2]=c;f[p>>2]=1032;u=e;return}function iZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0.0,$=0,aa=0,ba=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;if(!k){if((p|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;t=(a|0)>0;v=(r|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(q){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;n[x+(z<<2)>>2]=E*d;z=z+1|0}while((z|0)!=(p|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=r;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;n[x+(z<<2)>>2]=J*d;z=z+1|0}while((z|0)!=(p|0))}w=w+1|0;if((w|0)==(p|0))break;else x=x+(m<<2)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<2;r=h+8|0;f[h>>2]=r;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=bYc(w)|0;f[h>>2]=c;K=c}else K=r;if((p|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+12|0;t=g+8|0;q=g+4|0;z=a+-4|0;y=(a|0)<4;A=a&-4;B=Y(x,A)|0;H=g+B|0;G=0;F=j;j=k+B|0;while(1){B=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<2)|0;if(c)if(o){M=0;do{n[K+(M<<2)>>2]=+n[B+(M<<2)>>2]-+n[L>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{n[K+(M<<2)>>2]=+n[B+(M<<2)>>2]-+n[L+(M<<2)>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=j;N=31}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=j;N=31}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<2)|0;B=f[L>>2]|0;f[w>>2]=B;f[t>>2]=B;f[q>>2]=B;f[g>>2]=B;a:do if(y){R=0.0;S=g;T=0}else{J=0.0;L=g;U=0;E=(f[s>>2]=B,+n[s>>2]);while(1){V=U|1;W=U|2;X=U|3;D=J+(+n[K+(U<<2)>>2]*(+n[M+(U<<2)>>2]-E)+ +n[K+(V<<2)>>2]*(+n[M+(V<<2)>>2]-+n[L+4>>2])+ +n[K+(W<<2)>>2]*(+n[M+(W<<2)>>2]-+n[L+8>>2])+ +n[K+(X<<2)>>2]*(+n[M+(X<<2)>>2]-+n[L+12>>2]));X=U+4|0;W=L+(x<<2)|0;if((X|0)>(z|0)){R=D;S=H;T=A;break a}J=D;L=W;U=X;E=+n[W>>2]}}while(0);if((T|0)<(a|0)){C=R;B=S;U=T;while(1){E=C+ +n[K+(U<<2)>>2]*(+n[M+(U<<2)>>2]-+n[B>>2]);U=U+1|0;if((U|0)==(a|0)){Z=E;break}else{C=E;B=B+4|0}}}else Z=R;n[F+(O<<2)>>2]=Z*d;O=O+1|0;if((O|0)==(p|0))break;else N=22}else if((N|0)==31)while(1){N=0;B=i+((Y(P,l)|0)<<2)|0;U=k+((Y(P,b)|0)<<2)|0;if(y){_=0.0;$=U;aa=0}else{C=0.0;M=U;U=0;while(1){L=U|1;W=U|2;X=U|3;E=C+(+n[K+(U<<2)>>2]*(+n[B+(U<<2)>>2]-+n[M>>2])+ +n[K+(L<<2)>>2]*(+n[B+(L<<2)>>2]-+n[M+4>>2])+ +n[K+(W<<2)>>2]*(+n[B+(W<<2)>>2]-+n[M+8>>2])+ +n[K+(X<<2)>>2]*(+n[B+(X<<2)>>2]-+n[M+12>>2]));U=U+4|0;if((U|0)>(z|0)){_=E;$=Q;aa=A;break}else{C=E;M=M+(x<<2)|0}}}if((aa|0)<(a|0)){C=_;M=$;U=aa;while(1){E=C+ +n[K+(U<<2)>>2]*(+n[B+(U<<2)>>2]-+n[M>>2]);U=U+1|0;if((U|0)==(a|0)){ba=E;break}else{C=E;M=M+4|0}}}else ba=_;n[F+(P<<2)>>2]=ba*d;P=P+1|0;if((P|0)==(p|0))break;else{Q=Q+(b<<2)|0;N=31}}G=G+1|0;if((G|0)==(p|0))break;else{F=F+(m<<2)|0;j=j+(b<<2)|0}}}if((K|0)!=(r|0)){dYc(K);f[h>>2]=r;f[v>>2]=1032}u=e;return}function jZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(j|0)!=0;s=(m|0)<(a|0);m=r&s?o*40|0:o<<3;f[q>>2]=m;if(m>>>0>1032){t=bYc(m)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{m=j+((Y(A,b)|0)<<3)|0;B=+p[m>>3];m=A<<2;p[t+((m|3)<<3)>>3]=B;p[t+((m|2)<<3)>>3]=B;p[t+((m|1)<<3)>>3]=B;p[t+(m<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=j;y=0;z=b}while(0);if((a|0)>0){m=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(m){if(C){I=0;do{J=h+((Y(I,k)|0)+H<<2)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+n[J>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,k)|0)+H<<2)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+n[t>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=m?y:x+(M<<3)|0;K=h+(M<<2)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+n[K>>2]-+p[I>>3]);P=P+R*(+n[K+4>>2]-+p[I+8>>3]);O=O+R*(+n[K+8>>2]-+p[I+16>>3]);N=N+R*(+n[K+12>>2]-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(k<<2)|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(m){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(m){K=L;do{I=h+(K<<2)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+n[I>>2]-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(k<<2)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<2)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+n[t>>2]-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(k<<2)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(l<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,k)|0)+i<<2)|0;p[v+(L<<3)>>3]=+n[y>>2];L=L+1|0}while((L|0)!=(o|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<2)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+n[L>>2];O=O+Q*+n[L+4>>2];R=R+Q*+n[L+8>>2];F=F+Q*+n[L+12>>2];y=y+1|0;if((y|0)==(o|0))break;else L=L+(k<<2)|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<2)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+n[L>>2];y=y+1|0;if((y|0)==(o|0))break;else L=L+(k<<2)|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(l<<3)|0}}if((v|0)==(c|0)){u=e;return}dYc(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function kZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!k){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(r){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(m<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=bYc(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=j;j=k+H|0;while(1){H=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+n[H+(M<<2)>>2]-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+n[H+(M<<2)>>2]-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=j;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=j;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+n[M+(H<<2)>>2]-D)+ +p[K+(U<<3)>>3]*(+n[M+(U<<2)>>2]-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+n[M+(V<<2)>>2]-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+n[M+(W<<2)>>2]-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+n[M+(L<<2)>>2]-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=i+((Y(P,l)|0)<<2)|0;L=k+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+n[H+(L<<2)>>2]-+p[M>>3])+ +p[K+(V<<3)>>3]*(+n[H+(V<<2)>>2]-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+n[H+(W<<2)>>2]-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+n[H+(U<<2)>>2]-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+n[H+(L<<2)>>2]-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(m<<3)|0;j=j+(b<<3)|0}}}if((K|0)!=(s|0)){dYc(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function lZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>3;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;n=f[c>>2]|0;c=g+8|0;f[g>>2]=c;o=g+4|0;f[o>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?n*40|0:n<<3;f[o>>2]=m;if(m>>>0>1032){s=bYc(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(n<<3)|0;if((n|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<3)|0;A=+p[m>>3];m=z<<2;p[s+((m|3)<<3)>>3]=A;p[s+((m|2)<<3)>>3]=A;p[s+((m|1)<<3)>>3]=A;p[s+(m<<3)>>3]=A;z=z+1|0}while((z|0)!=(n|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){m=(x|0)!=0;B=(n|0)>0;C=a+-4|0;A=d*0.0;D=d*0.0;E=d*0.0;F=i;G=0;while(1){if(m){if(B){H=0;do{I=h+((Y(H,k)|0)+G<<3)|0;J=x+((Y(H,y)|0)<<3)|0;p[t+(H<<3)>>3]=+p[I>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}}else if(B){H=0;do{s=h+((Y(H,k)|0)+G<<3)|0;J=w+((Y(H,y)|0)+G<<3)|0;p[t+(H<<3)>>3]=+p[s>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}b:do if((G|0)>(C|0))K=G;else{if(B)L=G;else{H=G;while(1){p[F+(H<<3)>>3]=E;p[F+(H+1<<3)>>3]=E;p[F+(H+2<<3)>>3]=E;p[F+(H+3<<3)>>3]=E;J=H+4|0;if((J|0)>(C|0)){K=J;break b}else H=J}}while(1){H=m?x:w+(L<<3)|0;J=h+(L<<3)|0;M=0.0;N=0.0;O=0.0;P=0.0;s=0;while(1){Q=+p[t+(s<<3)>>3];P=P+Q*(+p[J>>3]-+p[H>>3]);O=O+Q*(+p[J+8>>3]-+p[H+8>>3]);N=N+Q*(+p[J+16>>3]-+p[H+16>>3]);M=M+Q*(+p[J+24>>3]-+p[H+24>>3]);s=s+1|0;if((s|0)==(n|0))break;else{H=H+(y<<3)|0;J=J+(k<<3)|0}}p[F+(L<<3)>>3]=P*d;p[F+(L+1<<3)>>3]=O*d;p[F+(L+2<<3)>>3]=N*d;p[F+(L+3<<3)>>3]=M*d;J=L+4|0;if((J|0)>(C|0)){K=J;break}else L=J}}while(0);c:do if((K|0)<(a|0)){if(!B)if(m){J=K;while(1){p[F+(J<<3)>>3]=A;J=J+1|0;if((J|0)==(a|0))break c}}else{J=K;while(1){p[F+(J<<3)>>3]=D;J=J+1|0;if((J|0)==(a|0))break c}}if(m){J=K;do{H=h+(J<<3)|0;Q=0.0;s=x;I=0;while(1){Q=Q+ +p[t+(I<<3)>>3]*(+p[H>>3]-+p[s>>3]);I=I+1|0;if((I|0)==(n|0))break;else{H=H+(k<<3)|0;s=s+(y<<3)|0}}p[F+(J<<3)>>3]=Q*d;J=J+1|0}while((J|0)!=(a|0))}else{J=K;do{s=h+(J<<3)|0;M=0.0;H=w+(J<<3)|0;I=0;while(1){M=M+ +p[t+(I<<3)>>3]*(+p[s>>3]-+p[H>>3]);I=I+1|0;if((I|0)==(n|0))break;else{s=s+(k<<3)|0;H=H+(y<<3)|0}}p[F+(J<<3)>>3]=M*d;J=J+1|0}while((J|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else F=F+(l<<3)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(n|0)>0;y=a+-4|0;D=d*0.0;A=d*0.0;w=i;i=0;while(1){if(v){K=0;do{x=h+((Y(K,k)|0)+i<<3)|0;p[t+(K<<3)>>3]=+p[x>>3];K=K+1|0}while((K|0)!=(n|0))}d:do if((i|0)>(y|0))R=i;else{if(v)S=i;else{K=i;while(1){p[w+(K<<3)>>3]=A;p[w+(K+1<<3)>>3]=A;p[w+(K+2<<3)>>3]=A;p[w+(K+3<<3)>>3]=A;x=K+4|0;if((x|0)>(y|0)){R=x;break d}else K=x}}while(1){K=h+(S<<3)|0;E=0.0;Q=0.0;N=0.0;O=0.0;x=0;while(1){P=+p[t+(x<<3)>>3];O=O+P*+p[K>>3];N=N+P*+p[K+8>>3];Q=Q+P*+p[K+16>>3];E=E+P*+p[K+24>>3];x=x+1|0;if((x|0)==(n|0))break;else K=K+(k<<3)|0}p[w+(S<<3)>>3]=O*d;p[w+(S+1<<3)>>3]=N*d;p[w+(S+2<<3)>>3]=Q*d;p[w+(S+3<<3)>>3]=E*d;K=S+4|0;if((K|0)>(y|0)){R=K;break}else S=K}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{K=R;while(1){p[w+(K<<3)>>3]=D;K=K+1|0;if((K|0)==(a|0))break e}}do{K=h+(T<<3)|0;P=0.0;x=0;while(1){P=P+ +p[t+(x<<3)>>3]*+p[K>>3];x=x+1|0;if((x|0)==(n|0))break;else K=K+(k<<3)|0}p[w+(T<<3)>>3]=P*d;T=T+1|0}while((T|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else w=w+(l<<3)|0}}if((t|0)==(c|0)){u=e;return}dYc(t);f[g>>2]=c;f[o>>2]=1032;u=e;return}function mZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>3;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;if(!k){if((o|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;s=(a|0)>0;t=(r|0)<(a|0);v=0;w=j;while(1){x=i+((Y(v,l)|0)<<3)|0;if(q){y=v;do{z=i+((Y(y,l)|0)<<3)|0;if(s){A=0;B=0.0;while(1){C=B+ +p[x+(A<<3)>>3]*+p[z+(A<<3)>>3];A=A+1|0;if((A|0)==(a|0)){D=C;break}else B=C}}else D=0.0;p[w+(y<<3)>>3]=D*d;y=y+1|0}while((y|0)!=(o|0))}else{y=v;do{A=i+((Y(y,l)|0)<<3)|0;z=0;B=0.0;do{E=z|1;F=z|2;G=z|3;B=B+(+p[x+(z<<3)>>3]*+p[A+(z<<3)>>3]+ +p[x+(E<<3)>>3]*+p[A+(E<<3)>>3]+ +p[x+(F<<3)>>3]*+p[A+(F<<3)>>3]+ +p[x+(G<<3)>>3]*+p[A+(G<<3)>>3]);z=z+4|0}while((z|0)<=(c|0));if(t){z=r;C=B;while(1){H=C+ +p[x+(z<<3)>>3]*+p[A+(z<<3)>>3];z=z+1|0;if((z|0)==(a|0)){I=H;break}else C=H}}else I=B;p[w+(y<<3)>>3]=I*d;y=y+1|0}while((y|0)!=(o|0))}v=v+1|0;if((v|0)==(o|0))break;else w=w+(m<<3)|0}u=e;return}w=(n|0)==(a|0)?4:0;v=a<<3;r=h+8|0;f[h>>2]=r;t=h+4|0;f[t>>2]=v;if(v>>>0>1032){c=bYc(v)|0;f[h>>2]=c;J=c}else J=r;if((o|0)>0){c=(n|0)<(a|0);n=(a|0)>0;v=g+24|0;s=g+16|0;q=g+8|0;y=a+-4|0;x=(a|0)<4;z=y>>>2;A=(z<<2)+4|0;G=Y(w,(z<<3)+8|0)|0;z=g+G|0;F=0;E=j;j=k+G|0;while(1){G=i+((Y(F,l)|0)<<3)|0;K=k+((Y(F,b)|0)<<3)|0;if(c)if(n){L=0;do{p[J+(L<<3)>>3]=+p[G+(L<<3)>>3]-+p[K>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{N=F;M=22}else if(n){L=0;do{p[J+(L<<3)>>3]=+p[G+(L<<3)>>3]-+p[K+(L<<3)>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{O=F;P=j;M=30}if((M|0)==21){M=0;if(c){N=F;M=22}else{O=F;P=j;M=30}}if((M|0)==22)while(1){M=0;L=i+((Y(N,l)|0)<<3)|0;K=k+((Y(N,b)|0)<<3)|0;I=+p[K>>3];p[v>>3]=I;p[s>>3]=I;p[q>>3]=I;p[g>>3]=I;a:do if(x){Q=0.0;R=g;S=0}else{D=0.0;K=g;G=0;C=I;while(1){T=G|1;U=G|2;V=G|3;H=D+(+p[J+(G<<3)>>3]*(+p[L+(G<<3)>>3]-C)+ +p[J+(T<<3)>>3]*(+p[L+(T<<3)>>3]-+p[K+8>>3])+ +p[J+(U<<3)>>3]*(+p[L+(U<<3)>>3]-+p[K+16>>3])+ +p[J+(V<<3)>>3]*(+p[L+(V<<3)>>3]-+p[K+24>>3]));V=G+4|0;U=K+(w<<3)|0;if((V|0)>(y|0)){Q=H;R=z;S=A;break a}D=H;K=U;G=V;C=+p[U>>3]}}while(0);if((S|0)<(a|0)){I=Q;G=R;K=S;while(1){B=I+ +p[J+(K<<3)>>3]*(+p[L+(K<<3)>>3]-+p[G>>3]);K=K+1|0;if((K|0)==(a|0)){W=B;break}else{I=B;G=G+8|0}}}else W=Q;p[E+(N<<3)>>3]=W*d;N=N+1|0;if((N|0)==(o|0))break;else M=22}else if((M|0)==30)while(1){M=0;G=i+((Y(O,l)|0)<<3)|0;K=k+((Y(O,b)|0)<<3)|0;if(x){X=0.0;Z=K;_=0}else{I=0.0;L=K;K=0;while(1){U=K|1;V=K|2;T=K|3;B=I+(+p[J+(K<<3)>>3]*(+p[G+(K<<3)>>3]-+p[L>>3])+ +p[J+(U<<3)>>3]*(+p[G+(U<<3)>>3]-+p[L+8>>3])+ +p[J+(V<<3)>>3]*(+p[G+(V<<3)>>3]-+p[L+16>>3])+ +p[J+(T<<3)>>3]*(+p[G+(T<<3)>>3]-+p[L+24>>3]));K=K+4|0;if((K|0)>(y|0)){X=B;Z=P;_=A;break}else{I=B;L=L+(w<<3)|0}}}if((_|0)<(a|0)){I=X;L=Z;K=_;while(1){B=I+ +p[J+(K<<3)>>3]*(+p[G+(K<<3)>>3]-+p[L>>3]);K=K+1|0;if((K|0)==(a|0)){$=B;break}else{I=B;L=L+8|0}}}else $=X;p[E+(O<<3)>>3]=$*d;O=O+1|0;if((O|0)==(o|0))break;else{P=P+(b<<3)|0;M=30}}F=F+1|0;if((F|0)==(o|0))break;else{E=E+(m<<3)|0;j=j+(b<<3)|0}}}if((J|0)!=(r|0)){dYc(J);f[h>>2]=r;f[t>>2]=1032}u=e;return}function nZ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;d=u;u=u+112|0;e=d+56|0;g=d+40|0;h=d;i=d+8|0;do if((eS(c)|0)==65536){j=f[c+4>>2]|0;f[e>>2]=f[j>>2];k=e+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[e+16>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[e+36>>2]=n;f[e+40>>2]=m;m=e+48|0;o=e+44|0;f[o>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];p=e;break}else{f[k>>2]=0;U$(e,j);p=e;break}}else{bS(e,c,-1);p=e}while(0);c=f[a>>2]|0;j=(c>>>3&511)+1|0;k=c&7;l=f[37988+(k<<2)>>2]|0;m=f[p>>2]|0;if((m^c)&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;p=$Xc(32)|0;f[g>>2]=p;f[g+8>>2]=-2147483616;f[g+4>>2]=20;q=p;r=236802;s=q+20|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[p+20>>0]=0;vM(-215,g,236823,235968,3274)}p=e+40|0;o=f[p>>2]|0;n=f[o+-4>>2]|0;t=f[a+40>>2]|0;a:do if((n|0)==(f[t+-4>>2]|0)){if((n|0)==2){if((f[o>>2]|0)!=(f[t>>2]|0))break;if((f[o+4>>2]|0)!=(f[t+4>>2]|0))break}else if((n|0)>0){v=0;do{if((f[o+(v<<2)>>2]|0)!=(f[t+(v<<2)>>2]|0))break a;v=v+1|0}while((v|0)<(n|0))}if((k|0)==7){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=9;q=g;r=264557;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[g+9>>0]=0;vM(-215,g,236823,235968,3274)}if(!(c&m&16384)){f[g>>2]=a;f[g+4>>2]=e;f[g+8>>2]=0;v=h;f[v>>2]=0;f[v+4>>2]=0;BL(i,g,h,-1);v=Y(f[i+20>>2]|0,j)|0;w=i+16|0;x=h+4|0;y=0;z=0.0;while(1){if(y>>>0>=(f[w>>2]|0)>>>0)break;A=z+ +Sh[l&31](f[h>>2]|0,f[x>>2]|0,v);CL(i)|0;y=y+1|0;z=A}B=z}else{y=f[a+4>>2]|0;if((y|0)<3)C=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{v=0;x=1;while(1){w=Y(f[t+(v<<2)>>2]|0,x)|0;v=v+1|0;if((v|0)==(y|0)){C=w;break}else x=w}}x=Y(C,j)|0;B=+Sh[l&31](f[a+16>>2]|0,f[e+16>>2]|0,x)}x=e+36|0;y=f[x>>2]|0;if(y|0?(v=y+12|0,y=f[v>>2]|0,f[v>>2]=y+-1,(y|0)==1):0)V$(e);f[x>>2]=0;x=e+16|0;y=e+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){x=f[p>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[y>>2]|0))}y=f[e+44>>2]|0;if((y|0)==(e+48|0)){u=d;return +B}wL(y);u=d;return +B}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=16;q=d;r=236827;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[d+16>>0]=0;vM(-215,g,236823,235968,3274);return +(0.0)}function oZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;i=0.0;do{j=g|1;k=g|2;l=g|3;i=i+(+(h[a+g>>0]|0)*+(h[b+g>>0]|0)+ +(h[a+j>>0]|0)*+(h[b+j>>0]|0)+ +(h[a+k>>0]|0)*+(h[b+k>>0]|0)+ +(h[a+l>>0]|0)*+(h[b+l>>0]|0));g=g+4|0}while((g|0)<=(d|0));e=i;f=c&-4}if((f|0)<(c|0)){m=f;n=e}else{o=e;p=o+0.0;return +p}while(1){e=n+ +(h[a+m>>0]|0)*+(h[b+m>>0]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}p=o+0.0;return +p}function pZ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=d+-4|0;if((d|0)<4){f=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(b[a+h>>0]|0)*+(b[c+h>>0]|0)+ +(b[a+j>>0]|0)*+(b[c+j>>0]|0)+ +(b[a+k>>0]|0)*+(b[c+k>>0]|0)+ +(b[a+l>>0]|0)*+(b[c+l>>0]|0));h=h+4|0}while((h|0)<=(e|0));f=i;g=d&-4}if((g|0)<(d|0)){m=g;n=f}else{o=f;p=o+0.0;return +p}while(1){f=n+ +(b[a+m>>0]|0)*+(b[c+m>>0]|0);m=m+1|0;if((m|0)==(d|0)){o=f;break}else n=f}p=o+0.0;return +p}function qZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;k=g|2;l=g|3;h=h+(+(j[a+(g<<1)>>1]|0)*+(j[b+(g<<1)>>1]|0)+ +(j[a+(i<<1)>>1]|0)*+(j[b+(i<<1)>>1]|0)+ +(j[a+(k<<1)>>1]|0)*+(j[b+(k<<1)>>1]|0)+ +(j[a+(l<<1)>>1]|0)*+(j[b+(l<<1)>>1]|0));g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){m=f;n=e}else{o=e;return +o}while(1){e=n+ +(j[a+(m<<1)>>1]|0)*+(j[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}return +o}function rZ(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;e=c+-4|0;if((c|0)<4){f=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(d[a+(h<<1)>>1]|0)*+(d[b+(h<<1)>>1]|0)+ +(d[a+(j<<1)>>1]|0)*+(d[b+(j<<1)>>1]|0)+ +(d[a+(k<<1)>>1]|0)*+(d[b+(k<<1)>>1]|0)+ +(d[a+(l<<1)>>1]|0)*+(d[b+(l<<1)>>1]|0));h=h+4|0}while((h|0)<=(e|0));f=i;g=c&-4}if((g|0)<(c|0)){m=g;n=f}else{o=f;return +o}while(1){f=n+ +(d[a+(m<<1)>>1]|0)*+(d[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=f;break}else n=f}return +o}function sZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(f[a+(h<<2)>>2]|0)*+(f[b+(h<<2)>>2]|0)+ +(f[a+(j<<2)>>2]|0)*+(f[b+(j<<2)>>2]|0)+ +(f[a+(k<<2)>>2]|0)*+(f[b+(k<<2)>>2]|0)+ +(f[a+(l<<2)>>2]|0)*+(f[b+(l<<2)>>2]|0));h=h+4|0}while((h|0)<=(d|0));e=i;g=c&-4}if((g|0)<(c|0)){m=g;n=e}else{o=e;return +o}while(1){e=n+ +(f[a+(m<<2)>>2]|0)*+(f[b+(m<<2)>>2]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}return +o}function tZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+n[a+(g<<2)>>2]*+n[b+(g<<2)>>2]+ +n[a+(i<<2)>>2]*+n[b+(i<<2)>>2]+ +n[a+(j<<2)>>2]*+n[b+(j<<2)>>2]+ +n[a+(k<<2)>>2]*+n[b+(k<<2)>>2]);g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){l=f;m=e}else{o=e;p=o+0.0;return +p}while(1){e=m+ +n[a+(l<<2)>>2]*+n[b+(l<<2)>>2];l=l+1|0;if((l|0)==(c|0)){o=e;break}else m=e}p=o+0.0;return +p}function uZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,n=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+p[a+(g<<3)>>3]*+p[b+(g<<3)>>3]+ +p[a+(i<<3)>>3]*+p[b+(i<<3)>>3]+ +p[a+(j<<3)>>3]*+p[b+(j<<3)>>3]+ +p[a+(k<<3)>>3]*+p[b+(k<<3)>>3]);g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){l=f;m=e}else{n=e;return +n}while(1){e=m+ +p[a+(l<<3)>>3]*+p[b+(l<<3)>>3];l=l+1|0;if((l|0)==(c|0)){n=e;break}else m=e}return +n}function vZ(a){a=a|0;return}function wZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;g=u;u=u+656|0;h=g+312|0;i=g+256|0;j=g+592|0;k=g+32|0;l=g+536|0;m=g;if(!(Mi[f[(f[a>>2]|0)+8>>2]&1023](a,b)|0)){f[j>>2]=1124007936;a=j+4|0;n=j+8|0;o=j+40|0;q=a;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;n=j+48|0;s=j+44|0;f[s>>2]=n;f[n>>2]=0;f[j+52>>2]=0;t=f[b>>2]|0;ei[f[(f[t>>2]|0)+12>>2]&511](t,b,j,-1);t=c;v=f[t>>2]|0;w=f[t+4>>2]|0;t=d;x=f[t+4>>2]|0;y=h;f[y>>2]=f[t>>2];f[y+4>>2]=x;x=i;f[x>>2]=v;f[x+4>>2]=w;W$(l,j,i,h);f[h>>2]=1124007936;w=h+4|0;x=h+8|0;v=h+40|0;q=w;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=x;x=h+48|0;y=h+44|0;f[y>>2]=x;f[x>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;t=i+4|0;z=i+8|0;A=i+40|0;q=t;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=z;z=i+48|0;B=i+44|0;f[B>>2]=z;f[z>>2]=0;f[i+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;UZ(k,38140,0,l,h,i,1.0,1.0,m);m=k;C=f[m+4>>2]|0;D=e;f[D>>2]=f[m>>2];f[D+4>>2]=C;C=e+8|0;D=(k|0)==(e|0);if(!D){m=e+44|0;E=f[m>>2]|0;if(E|0?(F=E+12|0,E=f[F>>2]|0,f[F>>2]=E+-1,(E|0)==1):0)V$(C);f[m>>2]=0;E=e+24|0;F=e+12|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[F>>2]|0)>0){G=f[e+48>>2]|0;H=0;do{f[G+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[F>>2]|0))}H=k+8|0;f[C>>2]=f[H>>2];C=k+12|0;G=f[C>>2]|0;f[F>>2]=G;F=k+16|0;I=e+16|0;f[I>>2]=f[F>>2];f[e+20>>2]=f[k+20>>2];f[E>>2]=f[k+24>>2];f[e+28>>2]=f[k+28>>2];f[e+32>>2]=f[k+32>>2];f[e+36>>2]=f[k+36>>2];f[e+40>>2]=f[k+40>>2];f[m>>2]=f[k+44>>2];m=e+52|0;E=f[m>>2]|0;J=e+56|0;if((E|0)==(J|0)){K=G;L=E}else{wL(E);f[m>>2]=J;f[e+48>>2]=I;K=f[C>>2]|0;L=J}J=k+52|0;if((K|0)<3){K=f[J>>2]|0;f[L>>2]=f[K>>2];f[L+4>>2]=f[K+4>>2]}else{f[m>>2]=f[J>>2];m=k+48|0;f[e+48>>2]=f[m>>2];f[J>>2]=k+56;f[m>>2]=F}f[H>>2]=1124007936;q=C;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));C=e+64|0;if(!D){H=e+100|0;F=f[H>>2]|0;if(F|0?(m=F+12|0,F=f[m>>2]|0,f[m>>2]=F+-1,(F|0)==1):0)V$(C);f[H>>2]=0;F=e+80|0;m=e+68|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[m>>2]|0)>0){J=f[e+104>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[m>>2]|0))}K=k+64|0;f[C>>2]=f[K>>2];C=k+68|0;J=f[C>>2]|0;f[m>>2]=J;m=k+72|0;L=e+72|0;f[L>>2]=f[m>>2];f[e+76>>2]=f[k+76>>2];f[F>>2]=f[k+80>>2];f[e+84>>2]=f[k+84>>2];f[e+88>>2]=f[k+88>>2];f[e+92>>2]=f[k+92>>2];f[e+96>>2]=f[k+96>>2];f[H>>2]=f[k+100>>2];H=e+108|0;F=f[H>>2]|0;I=e+112|0;if((F|0)==(I|0)){M=J;N=F}else{wL(F);f[H>>2]=I;f[e+104>>2]=L;M=f[C>>2]|0;N=I}I=k+108|0;if((M|0)<3){M=f[I>>2]|0;f[N>>2]=f[M>>2];f[N+4>>2]=f[M+4>>2]}else{f[H>>2]=f[I>>2];H=k+104|0;f[e+104>>2]=f[H>>2];f[I>>2]=k+112;f[H>>2]=m}f[K>>2]=1124007936;q=C;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));C=e+120|0;if(!D){D=e+156|0;K=f[D>>2]|0;if(K|0?(m=K+12|0,K=f[m>>2]|0,f[m>>2]=K+-1,(K|0)==1):0)V$(C);f[D>>2]=0;K=e+136|0;m=e+124|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[m>>2]|0)>0){H=f[e+160>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[m>>2]|0))}I=k+120|0;f[C>>2]=f[I>>2];C=k+124|0;H=f[C>>2]|0;f[m>>2]=H;m=k+128|0;M=e+128|0;f[M>>2]=f[m>>2];f[e+132>>2]=f[k+132>>2];f[K>>2]=f[k+136>>2];f[e+140>>2]=f[k+140>>2];f[e+144>>2]=f[k+144>>2];f[e+148>>2]=f[k+148>>2];f[e+152>>2]=f[k+152>>2];f[D>>2]=f[k+156>>2];D=e+164|0;K=f[D>>2]|0;N=e+168|0;if((K|0)==(N|0)){O=H;P=K}else{wL(K);f[D>>2]=N;f[e+160>>2]=M;O=f[C>>2]|0;P=N}N=k+164|0;if((O|0)<3){O=f[N>>2]|0;f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2]}else{f[D>>2]=f[N>>2];D=k+160|0;f[e+160>>2]=f[D>>2];f[N>>2]=k+168;f[D>>2]=m}f[I>>2]=1124007936;q=C;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0))}}}C=e+176|0;I=k+176|0;f[C>>2]=f[I>>2];f[C+4>>2]=f[I+4>>2];f[C+8>>2]=f[I+8>>2];f[C+12>>2]=f[I+12>>2];p[e+192>>3]=+p[k+192>>3];p[e+200>>3]=+p[k+200>>3];p[e+208>>3]=+p[k+208>>3];p[e+216>>3]=+p[k+216>>3];Zj(k);I=i+36|0;C=f[I>>2]|0;if(C|0?(m=C+12|0,C=f[m>>2]|0,f[m>>2]=C+-1,(C|0)==1):0)V$(i);f[I>>2]=0;I=i+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[t>>2]|0)>0){I=f[A>>2]|0;A=0;do{f[I+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[t>>2]|0))}t=f[B>>2]|0;if((t|0)!=(z|0))wL(t);t=h+36|0;z=f[t>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)V$(h);f[t>>2]=0;t=h+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){t=f[v>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[y>>2]|0;if((w|0)!=(x|0))wL(w);w=l+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)V$(l);f[w>>2]=0;w=l+16|0;x=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[l+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[l+44>>2]|0;if((x|0)!=(l+48|0))wL(x);x=j+36|0;l=f[x>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)V$(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[a>>2]|0)>0){x=f[o>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[s>>2]|0;if((a|0)!=(n|0))wL(a);u=g;return}a=f[b>>2]|0;n=f[b+4>>2]|0;f[i>>2]=1124007936;s=i+4|0;o=i+8|0;x=i+40|0;q=s;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=o;o=i+48|0;l=i+44|0;f[l>>2]=o;f[o>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;y=j+4|0;w=j+8|0;v=j+40|0;q=y;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=w;w=j+48|0;t=j+44|0;f[t>>2]=w;f[w>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;z=k+4|0;B=k+8|0;A=k+40|0;q=z;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=B;B=k+48|0;I=k+44|0;f[I>>2]=B;f[B>>2]=0;f[k+52>>2]=0;UZ(h,a,n,i,j,k,+p[b+176>>3],+p[b+184>>3],b+192|0);n=h;a=f[n+4>>2]|0;C=e;f[C>>2]=f[n>>2];f[C+4>>2]=a;a=e+8|0;C=(h|0)==(e|0);if(!C){n=e+44|0;m=f[n>>2]|0;if(m|0?(D=m+12|0,m=f[D>>2]|0,f[D>>2]=m+-1,(m|0)==1):0)V$(a);f[n>>2]=0;m=e+24|0;D=e+12|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[D>>2]|0)>0){N=f[e+48>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[D>>2]|0))}O=h+8|0;f[a>>2]=f[O>>2];N=h+12|0;P=f[N>>2]|0;f[D>>2]=P;D=h+16|0;M=e+16|0;f[M>>2]=f[D>>2];f[e+20>>2]=f[h+20>>2];f[m>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];f[e+36>>2]=f[h+36>>2];f[e+40>>2]=f[h+40>>2];f[n>>2]=f[h+44>>2];n=e+52|0;m=f[n>>2]|0;K=e+56|0;if((m|0)==(K|0))Q=P;else{wL(m);f[n>>2]=K;f[e+48>>2]=M;Q=f[N>>2]|0}M=h+52|0;if((Q|0)<3){Q=f[M>>2]|0;f[K>>2]=f[Q>>2];f[e+60>>2]=f[Q+4>>2]}else{f[n>>2]=f[M>>2];n=h+48|0;f[e+48>>2]=f[n>>2];f[M>>2]=h+56;f[n>>2]=D}f[O>>2]=1124007936;q=N;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));N=e+64|0;if(!C){O=e+100|0;D=f[O>>2]|0;if(D|0?(n=D+12|0,D=f[n>>2]|0,f[n>>2]=D+-1,(D|0)==1):0)V$(N);f[O>>2]=0;D=e+80|0;n=e+68|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[n>>2]|0)>0){M=f[e+104>>2]|0;Q=0;do{f[M+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[n>>2]|0))}Q=h+64|0;f[N>>2]=f[Q>>2];M=h+68|0;K=f[M>>2]|0;f[n>>2]=K;n=h+72|0;m=e+72|0;f[m>>2]=f[n>>2];f[e+76>>2]=f[h+76>>2];f[D>>2]=f[h+80>>2];f[e+84>>2]=f[h+84>>2];f[e+88>>2]=f[h+88>>2];f[e+92>>2]=f[h+92>>2];f[e+96>>2]=f[h+96>>2];f[O>>2]=f[h+100>>2];O=e+108|0;D=f[O>>2]|0;P=e+112|0;if((D|0)==(P|0))R=K;else{wL(D);f[O>>2]=P;f[e+104>>2]=m;R=f[M>>2]|0}m=h+108|0;if((R|0)<3){R=f[m>>2]|0;f[P>>2]=f[R>>2];f[e+116>>2]=f[R+4>>2]}else{f[O>>2]=f[m>>2];O=h+104|0;f[e+104>>2]=f[O>>2];f[m>>2]=h+112;f[O>>2]=n}f[Q>>2]=1124007936;q=M;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));M=e+120|0;if(C){S=N;T=M}else{C=e+156|0;Q=f[C>>2]|0;if(Q|0?(n=Q+12|0,Q=f[n>>2]|0,f[n>>2]=Q+-1,(Q|0)==1):0)V$(M);f[C>>2]=0;Q=e+136|0;n=e+124|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[n>>2]|0)>0){O=f[e+160>>2]|0;m=0;do{f[O+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[n>>2]|0))}m=h+120|0;f[M>>2]=f[m>>2];O=h+124|0;R=f[O>>2]|0;f[n>>2]=R;n=h+128|0;P=e+128|0;f[P>>2]=f[n>>2];f[e+132>>2]=f[h+132>>2];f[Q>>2]=f[h+136>>2];f[e+140>>2]=f[h+140>>2];f[e+144>>2]=f[h+144>>2];f[e+148>>2]=f[h+148>>2];f[e+152>>2]=f[h+152>>2];f[C>>2]=f[h+156>>2];C=e+164|0;Q=f[C>>2]|0;D=e+168|0;if((Q|0)==(D|0))U=R;else{wL(Q);f[C>>2]=D;f[e+160>>2]=P;U=f[O>>2]|0}P=h+164|0;if((U|0)<3){U=f[P>>2]|0;f[D>>2]=f[U>>2];f[e+172>>2]=f[U+4>>2]}else{f[C>>2]=f[P>>2];C=h+160|0;f[e+160>>2]=f[C>>2];f[P>>2]=h+168;f[C>>2]=n}f[m>>2]=1124007936;q=O;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));S=N;T=M}}else{V=N;W=27}}else{V=e+64|0;W=27}if((W|0)==27){S=V;T=e+120|0}V=e+176|0;W=h+176|0;f[V>>2]=f[W>>2];f[V+4>>2]=f[W+4>>2];f[V+8>>2]=f[W+8>>2];f[V+12>>2]=f[W+12>>2];p[e+192>>3]=+p[h+192>>3];p[e+200>>3]=+p[h+200>>3];p[e+208>>3]=+p[h+208>>3];p[e+216>>3]=+p[h+216>>3];Zj(h);W=k+36|0;V=f[W>>2]|0;if(V|0?(N=V+12|0,V=f[N>>2]|0,f[N>>2]=V+-1,(V|0)==1):0)V$(k);f[W>>2]=0;W=k+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[z>>2]|0)>0){W=f[A>>2]|0;A=0;do{f[W+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[I>>2]|0;if((z|0)!=(B|0))wL(z);z=j+36|0;B=f[z>>2]|0;if(B|0?(I=B+12|0,B=f[I>>2]|0,f[I>>2]=B+-1,(B|0)==1):0)V$(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[v>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[y>>2]|0))}y=f[t>>2]|0;if((y|0)!=(w|0))wL(y);y=i+36|0;w=f[y>>2]|0;if(w|0?(t=w+12|0,w=f[t>>2]|0,f[t>>2]=w+-1,(w|0)==1):0)V$(i);f[y>>2]=0;y=i+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[s>>2]|0)>0){y=f[x>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[l>>2]|0;if((s|0)!=(o|0))wL(s);if(f[b+24>>2]|0){s=c;o=f[s>>2]|0;l=f[s+4>>2]|0;s=d;x=f[s+4>>2]|0;y=h;f[y>>2]=f[s>>2];f[y+4>>2]=x;x=i;f[x>>2]=o;f[x+4>>2]=l;W$(j,b+8|0,i,h);if((a|0)==(j|0)){l=j+36|0;x=f[l>>2]|0;if((x|0)!=0?(o=x+12|0,x=f[o>>2]|0,f[o>>2]=x+-1,(x|0)==1):0){V$(j);X=l}else X=l}else{l=e+44|0;x=f[l>>2]|0;if(x|0?(o=x+12|0,x=f[o>>2]|0,f[o>>2]=x+-1,(x|0)==1):0)V$(a);f[l>>2]=0;x=e+24|0;o=e+12|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[o>>2]|0)>0){y=f[e+48>>2]|0;s=0;do{f[y+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[o>>2]|0))}f[a>>2]=f[j>>2];a=j+4|0;s=f[a>>2]|0;f[o>>2]=s;o=j+8|0;y=e+16|0;f[y>>2]=f[o>>2];f[e+20>>2]=f[j+12>>2];f[x>>2]=f[j+16>>2];f[e+28>>2]=f[j+20>>2];f[e+32>>2]=f[j+24>>2];f[e+36>>2]=f[j+28>>2];f[e+40>>2]=f[j+32>>2];x=j+36|0;f[l>>2]=f[x>>2];l=e+52|0;w=f[l>>2]|0;t=e+56|0;if((w|0)==(t|0))Y=s;else{wL(w);f[l>>2]=t;f[e+48>>2]=y;Y=f[a>>2]|0}y=j+44|0;if((Y|0)<3){Y=f[y>>2]|0;f[t>>2]=f[Y>>2];f[e+60>>2]=f[Y+4>>2]}else{f[l>>2]=f[y>>2];l=j+40|0;f[e+48>>2]=f[l>>2];f[y>>2]=j+48;f[l>>2]=o}f[j>>2]=1124007936;q=a;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));X=x}f[X>>2]=0;X=j+16|0;x=j+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[x>>2]|0)>0){X=f[j+40>>2]|0;a=0;do{f[X+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))wL(x)}if(f[b+80>>2]|0){x=c;a=f[x>>2]|0;X=f[x+4>>2]|0;x=d;o=f[x+4>>2]|0;l=h;f[l>>2]=f[x>>2];f[l+4>>2]=o;o=i;f[o>>2]=a;f[o+4>>2]=X;W$(j,b+64|0,i,h);if((S|0)==(j|0)){X=j+36|0;o=f[X>>2]|0;if((o|0)!=0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0){V$(j);Z=X}else Z=X}else{X=e+100|0;o=f[X>>2]|0;if(o|0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)V$(S);f[X>>2]=0;o=e+80|0;a=e+68|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[a>>2]|0)>0){l=f[e+104>>2]|0;x=0;do{f[l+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}f[S>>2]=f[j>>2];S=j+4|0;x=f[S>>2]|0;f[a>>2]=x;a=j+8|0;l=e+72|0;f[l>>2]=f[a>>2];f[e+76>>2]=f[j+12>>2];f[o>>2]=f[j+16>>2];f[e+84>>2]=f[j+20>>2];f[e+88>>2]=f[j+24>>2];f[e+92>>2]=f[j+28>>2];f[e+96>>2]=f[j+32>>2];o=j+36|0;f[X>>2]=f[o>>2];X=e+108|0;y=f[X>>2]|0;Y=e+112|0;if((y|0)==(Y|0))_=x;else{wL(y);f[X>>2]=Y;f[e+104>>2]=l;_=f[S>>2]|0}l=j+44|0;if((_|0)<3){_=f[l>>2]|0;f[Y>>2]=f[_>>2];f[e+116>>2]=f[_+4>>2]}else{f[X>>2]=f[l>>2];X=j+40|0;f[e+104>>2]=f[X>>2];f[l>>2]=j+48;f[X>>2]=a}f[j>>2]=1124007936;q=S;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));Z=o}f[Z>>2]=0;Z=j+16|0;o=j+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[o>>2]|0)>0){Z=f[j+40>>2]|0;S=0;do{f[Z+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[o>>2]|0))}o=f[j+44>>2]|0;if((o|0)!=(j+48|0))wL(o)}if(!(f[b+136>>2]|0)){u=g;return}o=c;c=f[o>>2]|0;S=f[o+4>>2]|0;o=d;d=f[o+4>>2]|0;Z=h;f[Z>>2]=f[o>>2];f[Z+4>>2]=d;d=i;f[d>>2]=c;f[d+4>>2]=S;W$(j,b+120|0,i,h);if((T|0)==(j|0)){h=j+36|0;i=f[h>>2]|0;if((i|0)!=0?(b=i+12|0,i=f[b>>2]|0,f[b>>2]=i+-1,(i|0)==1):0){V$(j);$=h}else $=h}else{h=e+156|0;i=f[h>>2]|0;if(i|0?(b=i+12|0,i=f[b>>2]|0,f[b>>2]=i+-1,(i|0)==1):0)V$(T);f[h>>2]=0;T=e+136|0;i=e+124|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[i>>2]|0)>0){b=f[e+160>>2]|0;S=0;do{f[b+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[i>>2]|0))}f[e+120>>2]=f[j>>2];S=j+4|0;b=f[S>>2]|0;f[i>>2]=b;i=j+8|0;d=e+128|0;f[d>>2]=f[i>>2];f[e+132>>2]=f[j+12>>2];f[T>>2]=f[j+16>>2];f[e+140>>2]=f[j+20>>2];f[e+144>>2]=f[j+24>>2];f[e+148>>2]=f[j+28>>2];f[e+152>>2]=f[j+32>>2];T=j+36|0;f[h>>2]=f[T>>2];h=e+164|0;c=f[h>>2]|0;Z=e+168|0;if((c|0)==(Z|0))aa=b;else{wL(c);f[h>>2]=Z;f[e+160>>2]=d;aa=f[S>>2]|0}d=j+44|0;if((aa|0)<3){aa=f[d>>2]|0;f[Z>>2]=f[aa>>2];f[e+172>>2]=f[aa+4>>2]}else{f[h>>2]=f[d>>2];h=j+40|0;f[e+160>>2]=f[h>>2];f[d>>2]=j+48;f[h>>2]=i}f[j>>2]=1124007936;q=S;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));$=T}f[$>>2]=0;$=j+16|0;T=j+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[T>>2]|0)>0){$=f[j+40>>2]|0;q=0;do{f[$+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[T>>2]|0))}T=f[j+44>>2]|0;if((T|0)!=(j+48|0))wL(T);u=g;return}function xZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=u;u=u+656|0;g=e+256|0;h=e+32|0;i=e+592|0;j=e+536|0;k=e+480|0;l=e;if(!(Mi[f[(f[a>>2]|0)+8>>2]&1023](a,b)|0)){f[g>>2]=1124007936;a=g+4|0;m=g+8|0;n=g+40|0;o=a;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;m=g+48|0;r=g+44|0;f[r>>2]=m;f[m>>2]=0;f[g+52>>2]=0;s=f[b>>2]|0;ei[f[(f[s>>2]|0)+12>>2]&511](s,b,g,-1);b0(i,g,c);f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[v>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;x=k+4|0;y=k+8|0;z=k+40|0;o=x;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[z>>2]=y;y=k+48|0;A=k+44|0;f[A>>2]=y;f[y>>2]=0;f[k+52>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;UZ(h,38140,0,i,j,k,1.0,1.0,l);l=h;B=f[l+4>>2]|0;C=d;f[C>>2]=f[l>>2];f[C+4>>2]=B;B=d+8|0;C=(h|0)==(d|0);if(!C){l=d+44|0;D=f[l>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)V$(B);f[l>>2]=0;D=d+24|0;E=d+12|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[E>>2]|0)>0){F=f[d+48>>2]|0;G=0;do{f[F+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}G=h+8|0;f[B>>2]=f[G>>2];B=h+12|0;F=f[B>>2]|0;f[E>>2]=F;E=h+16|0;H=d+16|0;f[H>>2]=f[E>>2];f[d+20>>2]=f[h+20>>2];f[D>>2]=f[h+24>>2];f[d+28>>2]=f[h+28>>2];f[d+32>>2]=f[h+32>>2];f[d+36>>2]=f[h+36>>2];f[d+40>>2]=f[h+40>>2];f[l>>2]=f[h+44>>2];l=d+52|0;D=f[l>>2]|0;I=d+56|0;if((D|0)==(I|0)){J=F;K=D}else{wL(D);f[l>>2]=I;f[d+48>>2]=H;J=f[B>>2]|0;K=I}I=h+52|0;if((J|0)<3){J=f[I>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2]}else{f[l>>2]=f[I>>2];l=h+48|0;f[d+48>>2]=f[l>>2];f[I>>2]=h+56;f[l>>2]=E}f[G>>2]=1124007936;o=B;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));B=d+64|0;if(!C){G=d+100|0;E=f[G>>2]|0;if(E|0?(l=E+12|0,E=f[l>>2]|0,f[l>>2]=E+-1,(E|0)==1):0)V$(B);f[G>>2]=0;E=d+80|0;l=d+68|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[l>>2]|0)>0){I=f[d+104>>2]|0;J=0;do{f[I+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[l>>2]|0))}J=h+64|0;f[B>>2]=f[J>>2];B=h+68|0;I=f[B>>2]|0;f[l>>2]=I;l=h+72|0;K=d+72|0;f[K>>2]=f[l>>2];f[d+76>>2]=f[h+76>>2];f[E>>2]=f[h+80>>2];f[d+84>>2]=f[h+84>>2];f[d+88>>2]=f[h+88>>2];f[d+92>>2]=f[h+92>>2];f[d+96>>2]=f[h+96>>2];f[G>>2]=f[h+100>>2];G=d+108|0;E=f[G>>2]|0;H=d+112|0;if((E|0)==(H|0)){L=I;M=E}else{wL(E);f[G>>2]=H;f[d+104>>2]=K;L=f[B>>2]|0;M=H}H=h+108|0;if((L|0)<3){L=f[H>>2]|0;f[M>>2]=f[L>>2];f[M+4>>2]=f[L+4>>2]}else{f[G>>2]=f[H>>2];G=h+104|0;f[d+104>>2]=f[G>>2];f[H>>2]=h+112;f[G>>2]=l}f[J>>2]=1124007936;o=B;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));B=d+120|0;if(!C){C=d+156|0;J=f[C>>2]|0;if(J|0?(l=J+12|0,J=f[l>>2]|0,f[l>>2]=J+-1,(J|0)==1):0)V$(B);f[C>>2]=0;J=d+136|0;l=d+124|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[l>>2]|0)>0){G=f[d+160>>2]|0;H=0;do{f[G+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[l>>2]|0))}H=h+120|0;f[B>>2]=f[H>>2];B=h+124|0;G=f[B>>2]|0;f[l>>2]=G;l=h+128|0;L=d+128|0;f[L>>2]=f[l>>2];f[d+132>>2]=f[h+132>>2];f[J>>2]=f[h+136>>2];f[d+140>>2]=f[h+140>>2];f[d+144>>2]=f[h+144>>2];f[d+148>>2]=f[h+148>>2];f[d+152>>2]=f[h+152>>2];f[C>>2]=f[h+156>>2];C=d+164|0;J=f[C>>2]|0;M=d+168|0;if((J|0)==(M|0)){N=G;O=J}else{wL(J);f[C>>2]=M;f[d+160>>2]=L;N=f[B>>2]|0;O=M}M=h+164|0;if((N|0)<3){N=f[M>>2]|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2]}else{f[C>>2]=f[M>>2];C=h+160|0;f[d+160>>2]=f[C>>2];f[M>>2]=h+168;f[C>>2]=l}f[H>>2]=1124007936;o=B;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0))}}}B=d+176|0;H=h+176|0;f[B>>2]=f[H>>2];f[B+4>>2]=f[H+4>>2];f[B+8>>2]=f[H+8>>2];f[B+12>>2]=f[H+12>>2];p[d+192>>3]=+p[h+192>>3];p[d+200>>3]=+p[h+200>>3];p[d+208>>3]=+p[h+208>>3];p[d+216>>3]=+p[h+216>>3];Zj(h);H=k+36|0;B=f[H>>2]|0;if(B|0?(l=B+12|0,B=f[l>>2]|0,f[l>>2]=B+-1,(B|0)==1):0)V$(k);f[H>>2]=0;H=k+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[x>>2]|0)>0){H=f[z>>2]|0;z=0;do{f[H+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[A>>2]|0;if((x|0)!=(y|0))wL(x);x=j+36|0;y=f[x>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)V$(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[v>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[w>>2]|0;if((s|0)!=(t|0))wL(s);s=i+36|0;t=f[s>>2]|0;if(t|0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)V$(i);f[s>>2]=0;s=i+16|0;t=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[i+40>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[i+44>>2]|0;if((t|0)!=(i+48|0))wL(t);t=g+36|0;w=f[t>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)V$(g);f[t>>2]=0;t=g+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[a>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(m|0))wL(a);u=e;return}a=f[b>>2]|0;m=f[b+4>>2]|0;f[h>>2]=1124007936;r=h+4|0;n=h+8|0;t=h+40|0;o=r;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[t>>2]=n;n=h+48|0;w=h+44|0;f[w>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;s=i+4|0;v=i+8|0;x=i+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[x>>2]=v;v=i+48|0;y=i+44|0;f[y>>2]=v;f[v>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;A=j+4|0;z=j+8|0;H=j+40|0;o=A;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[H>>2]=z;z=j+48|0;k=j+44|0;f[k>>2]=z;f[z>>2]=0;f[j+52>>2]=0;UZ(g,a,m,h,i,j,+p[b+176>>3],+p[b+184>>3],b+192|0);m=g;a=f[m+4>>2]|0;B=d;f[B>>2]=f[m>>2];f[B+4>>2]=a;a=d+8|0;B=(g|0)==(d|0);if(!B){m=d+44|0;l=f[m>>2]|0;if(l|0?(C=l+12|0,l=f[C>>2]|0,f[C>>2]=l+-1,(l|0)==1):0)V$(a);f[m>>2]=0;l=d+24|0;C=d+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[C>>2]|0)>0){M=f[d+48>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[C>>2]|0))}N=g+8|0;f[a>>2]=f[N>>2];M=g+12|0;O=f[M>>2]|0;f[C>>2]=O;C=g+16|0;L=d+16|0;f[L>>2]=f[C>>2];f[d+20>>2]=f[g+20>>2];f[l>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];f[d+36>>2]=f[g+36>>2];f[d+40>>2]=f[g+40>>2];f[m>>2]=f[g+44>>2];m=d+52|0;l=f[m>>2]|0;J=d+56|0;if((l|0)==(J|0))P=O;else{wL(l);f[m>>2]=J;f[d+48>>2]=L;P=f[M>>2]|0}L=g+52|0;if((P|0)<3){P=f[L>>2]|0;f[J>>2]=f[P>>2];f[d+60>>2]=f[P+4>>2]}else{f[m>>2]=f[L>>2];m=g+48|0;f[d+48>>2]=f[m>>2];f[L>>2]=g+56;f[m>>2]=C}f[N>>2]=1124007936;o=M;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));M=d+64|0;if(!B){N=d+100|0;C=f[N>>2]|0;if(C|0?(m=C+12|0,C=f[m>>2]|0,f[m>>2]=C+-1,(C|0)==1):0)V$(M);f[N>>2]=0;C=d+80|0;m=d+68|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[m>>2]|0)>0){L=f[d+104>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[m>>2]|0))}P=g+64|0;f[M>>2]=f[P>>2];L=g+68|0;J=f[L>>2]|0;f[m>>2]=J;m=g+72|0;l=d+72|0;f[l>>2]=f[m>>2];f[d+76>>2]=f[g+76>>2];f[C>>2]=f[g+80>>2];f[d+84>>2]=f[g+84>>2];f[d+88>>2]=f[g+88>>2];f[d+92>>2]=f[g+92>>2];f[d+96>>2]=f[g+96>>2];f[N>>2]=f[g+100>>2];N=d+108|0;C=f[N>>2]|0;O=d+112|0;if((C|0)==(O|0))Q=J;else{wL(C);f[N>>2]=O;f[d+104>>2]=l;Q=f[L>>2]|0}l=g+108|0;if((Q|0)<3){Q=f[l>>2]|0;f[O>>2]=f[Q>>2];f[d+116>>2]=f[Q+4>>2]}else{f[N>>2]=f[l>>2];N=g+104|0;f[d+104>>2]=f[N>>2];f[l>>2]=g+112;f[N>>2]=m}f[P>>2]=1124007936;o=L;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));L=d+120|0;if(B){R=M;S=L}else{B=d+156|0;P=f[B>>2]|0;if(P|0?(m=P+12|0,P=f[m>>2]|0,f[m>>2]=P+-1,(P|0)==1):0)V$(L);f[B>>2]=0;P=d+136|0;m=d+124|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[m>>2]|0)>0){N=f[d+160>>2]|0;l=0;do{f[N+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}l=g+120|0;f[L>>2]=f[l>>2];N=g+124|0;Q=f[N>>2]|0;f[m>>2]=Q;m=g+128|0;O=d+128|0;f[O>>2]=f[m>>2];f[d+132>>2]=f[g+132>>2];f[P>>2]=f[g+136>>2];f[d+140>>2]=f[g+140>>2];f[d+144>>2]=f[g+144>>2];f[d+148>>2]=f[g+148>>2];f[d+152>>2]=f[g+152>>2];f[B>>2]=f[g+156>>2];B=d+164|0;P=f[B>>2]|0;C=d+168|0;if((P|0)==(C|0))T=Q;else{wL(P);f[B>>2]=C;f[d+160>>2]=O;T=f[N>>2]|0}O=g+164|0;if((T|0)<3){T=f[O>>2]|0;f[C>>2]=f[T>>2];f[d+172>>2]=f[T+4>>2]}else{f[B>>2]=f[O>>2];B=g+160|0;f[d+160>>2]=f[B>>2];f[O>>2]=g+168;f[B>>2]=m}f[l>>2]=1124007936;o=N;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));R=M;S=L}}else{U=M;V=27}}else{U=d+64|0;V=27}if((V|0)==27){R=U;S=d+120|0}U=d+176|0;V=g+176|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2];f[U+8>>2]=f[V+8>>2];f[U+12>>2]=f[V+12>>2];p[d+192>>3]=+p[g+192>>3];p[d+200>>3]=+p[g+200>>3];p[d+208>>3]=+p[g+208>>3];p[d+216>>3]=+p[g+216>>3];Zj(g);V=j+36|0;U=f[V>>2]|0;if(U|0?(M=U+12|0,U=f[M>>2]|0,f[M>>2]=U+-1,(U|0)==1):0)V$(j);f[V>>2]=0;V=j+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[A>>2]|0)>0){V=f[H>>2]|0;H=0;do{f[V+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[A>>2]|0))}A=f[k>>2]|0;if((A|0)!=(z|0))wL(A);A=i+36|0;z=f[A>>2]|0;if(z|0?(k=z+12|0,z=f[k>>2]|0,f[k>>2]=z+-1,(z|0)==1):0)V$(i);f[A>>2]=0;A=i+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[s>>2]|0)>0){A=f[x>>2]|0;x=0;do{f[A+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[y>>2]|0;if((s|0)!=(v|0))wL(s);s=h+36|0;v=f[s>>2]|0;if(v|0?(y=v+12|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)V$(h);f[s>>2]=0;s=h+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[t>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[w>>2]|0;if((r|0)!=(n|0))wL(r);if(f[b+24>>2]|0){b0(g,b+8|0,c);if((a|0)==(g|0)){r=g+36|0;n=f[r>>2]|0;if((n|0)!=0?(w=n+12|0,n=f[w>>2]|0,f[w>>2]=n+-1,(n|0)==1):0){V$(g);W=r}else W=r}else{r=d+44|0;n=f[r>>2]|0;if(n|0?(w=n+12|0,n=f[w>>2]|0,f[w>>2]=n+-1,(n|0)==1):0)V$(a);f[r>>2]=0;n=d+24|0;w=d+12|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[w>>2]|0)>0){t=f[d+48>>2]|0;s=0;do{f[t+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[w>>2]|0))}f[a>>2]=f[g>>2];a=g+4|0;s=f[a>>2]|0;f[w>>2]=s;w=g+8|0;t=d+16|0;f[t>>2]=f[w>>2];f[d+20>>2]=f[g+12>>2];f[n>>2]=f[g+16>>2];f[d+28>>2]=f[g+20>>2];f[d+32>>2]=f[g+24>>2];f[d+36>>2]=f[g+28>>2];f[d+40>>2]=f[g+32>>2];n=g+36|0;f[r>>2]=f[n>>2];r=d+52|0;h=f[r>>2]|0;v=d+56|0;if((h|0)==(v|0))X=s;else{wL(h);f[r>>2]=v;f[d+48>>2]=t;X=f[a>>2]|0}t=g+44|0;if((X|0)<3){X=f[t>>2]|0;f[v>>2]=f[X>>2];f[d+60>>2]=f[X+4>>2]}else{f[r>>2]=f[t>>2];r=g+40|0;f[d+48>>2]=f[r>>2];f[t>>2]=g+48;f[r>>2]=w}f[g>>2]=1124007936;o=a;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));W=n}f[W>>2]=0;W=g+16|0;n=g+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[n>>2]|0)>0){W=f[g+40>>2]|0;a=0;do{f[W+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[n>>2]|0))}n=f[g+44>>2]|0;if((n|0)!=(g+48|0))wL(n)}if(f[b+80>>2]|0){b0(g,b+64|0,c);if((R|0)==(g|0)){n=g+36|0;a=f[n>>2]|0;if((a|0)!=0?(W=a+12|0,a=f[W>>2]|0,f[W>>2]=a+-1,(a|0)==1):0){V$(g);Y=n}else Y=n}else{n=d+100|0;a=f[n>>2]|0;if(a|0?(W=a+12|0,a=f[W>>2]|0,f[W>>2]=a+-1,(a|0)==1):0)V$(R);f[n>>2]=0;a=d+80|0;W=d+68|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[W>>2]|0)>0){w=f[d+104>>2]|0;r=0;do{f[w+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[W>>2]|0))}f[R>>2]=f[g>>2];R=g+4|0;r=f[R>>2]|0;f[W>>2]=r;W=g+8|0;w=d+72|0;f[w>>2]=f[W>>2];f[d+76>>2]=f[g+12>>2];f[a>>2]=f[g+16>>2];f[d+84>>2]=f[g+20>>2];f[d+88>>2]=f[g+24>>2];f[d+92>>2]=f[g+28>>2];f[d+96>>2]=f[g+32>>2];a=g+36|0;f[n>>2]=f[a>>2];n=d+108|0;t=f[n>>2]|0;X=d+112|0;if((t|0)==(X|0))Z=r;else{wL(t);f[n>>2]=X;f[d+104>>2]=w;Z=f[R>>2]|0}w=g+44|0;if((Z|0)<3){Z=f[w>>2]|0;f[X>>2]=f[Z>>2];f[d+116>>2]=f[Z+4>>2]}else{f[n>>2]=f[w>>2];n=g+40|0;f[d+104>>2]=f[n>>2];f[w>>2]=g+48;f[n>>2]=W}f[g>>2]=1124007936;o=R;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));Y=a}f[Y>>2]=0;Y=g+16|0;a=g+4|0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[a>>2]|0)>0){Y=f[g+40>>2]|0;R=0;do{f[Y+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))wL(a)}if(!(f[b+136>>2]|0)){u=e;return}b0(g,b+120|0,c);if((S|0)==(g|0)){c=g+36|0;b=f[c>>2]|0;if((b|0)!=0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0){V$(g);_=c}else _=c}else{c=d+156|0;b=f[c>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)V$(S);f[c>>2]=0;S=d+136|0;b=d+124|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[b>>2]|0)>0){a=f[d+160>>2]|0;R=0;do{f[a+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[b>>2]|0))}f[d+120>>2]=f[g>>2];R=g+4|0;a=f[R>>2]|0;f[b>>2]=a;b=g+8|0;Y=d+128|0;f[Y>>2]=f[b>>2];f[d+132>>2]=f[g+12>>2];f[S>>2]=f[g+16>>2];f[d+140>>2]=f[g+20>>2];f[d+144>>2]=f[g+24>>2];f[d+148>>2]=f[g+28>>2];f[d+152>>2]=f[g+32>>2];S=g+36|0;f[c>>2]=f[S>>2];c=d+164|0;W=f[c>>2]|0;n=d+168|0;if((W|0)==(n|0))$=a;else{wL(W);f[c>>2]=n;f[d+160>>2]=Y;$=f[R>>2]|0}Y=g+44|0;if(($|0)<3){$=f[Y>>2]|0;f[n>>2]=f[$>>2];f[d+172>>2]=f[$+4>>2]}else{f[c>>2]=f[Y>>2];c=g+40|0;f[d+160>>2]=f[c>>2];f[Y>>2]=g+48;f[c>>2]=b}f[g>>2]=1124007936;o=R;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));_=S}f[_>>2]=0;_=g+16|0;S=g+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[S>>2]|0)>0){_=f[g+40>>2]|0;o=0;do{f[_+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[S>>2]|0))}S=f[g+44>>2]|0;if((S|0)!=(g+48|0))wL(S);u=e;return}function yZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;E1(d,e,g,fT()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function zZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;G1(d,e,g,fT()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function AZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=u;u=u+176|0;d=a+160|0;e=a+144|0;g=a+128|0;h=a+72|0;i=a+56|0;j=a;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;p=j+44|0;f[p>>2]=l;f[l>>2]=0;f[j+52>>2]=0;q=f[b>>2]|0;ei[f[(f[q>>2]|0)+12>>2]&511](q,b,j,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=j;f[h>>2]=1124007936;b=h+4|0;q=h+8|0;r=h+40|0;n=b;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[r>>2]=q;q=h+48|0;n=h+44|0;f[n>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=h;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;AY(d,e,1.0,g,0.0,i,0);i=h+36|0;g=f[i>>2]|0;if(g|0?(e=g+12|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)V$(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[b>>2]|0)>0){i=f[r>>2]|0;r=0;do{f[i+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[b>>2]|0))}b=f[n>>2]|0;if((b|0)!=(q|0))wL(b);b=j+36|0;q=f[b>>2]|0;if(q|0?(n=q+12|0,q=f[n>>2]|0,f[n>>2]=q+-1,(q|0)==1):0)V$(j);f[b>>2]=0;b=j+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[k>>2]|0)>0){b=f[m>>2]|0;m=0;do{f[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[p>>2]|0;if((k|0)==(l|0)){u=a;return}wL(k);u=a;return}function BZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;J1(d,e,g,1.0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function CZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;v1(d,e,g,fT()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function DZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;x1(d,e,g,fT()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function EZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;y1(d,e,g,fT()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function FZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0;e=u;u=u+144|0;g=e;h=e+88|0;i=e+32|0;j=f[c>>2]|0;if((j|0)!=(a|0)){ei[f[(f[j>>2]|0)+52>>2]&511](j,b,c,d);u=e;return};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[h>>2]=1124007936;j=h+4|0;a=h+8|0;k=h+40|0;l=j;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=a;n=h+48|0;o=h+44|0;f[o>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=i+48|0;m=i+44|0;f[m>>2]=l;f[l>>2]=0;f[i+52>>2]=0;t=f[b>>2]|0;do if((t|0)==38384){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){v=21;break}w=b+8|0;if((h|0)!=(w|0)){x=b+44|0;y=f[x>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){V$(h);B=z}else B=z}else B=h+36|0;f[B>>2]=0;z=h+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[k>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;C=f[j>>2]|0}while((A|0)<(C|0));f[h>>2]=f[w>>2];if((C|0)<3)v=16;else v=18}else{f[h>>2]=f[w>>2];v=16}if((v|0)==16){A=f[b+12>>2]|0;if((A|0)<3){f[j>>2]=A;f[a>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];A=f[b+52>>2]|0;y=f[o>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2]}else v=18}if((v|0)==18)U$(h,w);f[z>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[B>>2]=f[x>>2]}D=+p[b+176>>3];p[g>>3]=+p[b+192>>3];p[g+8>>3]=+p[b+200>>3];p[g+16>>3]=+p[b+208>>3];p[g+24>>3]=+p[b+216>>3];E=D}else v=21;while(0);if((v|0)==21){ei[f[(f[t>>2]|0)+12>>2]&511](t,b,h,-1);E=1.0}b=f[c>>2]|0;do if((b|0)==38384){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=41;break}t=c+8|0;if((i|0)!=(t|0)){B=c+44|0;a=f[B>>2]|0;if(a|0){C=a+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;a=f[C>>2]|0;if(a|0?(A=a+12|0,a=f[A>>2]|0,f[A>>2]=a+-1,(a|0)==1):0)V$(i);f[C>>2]=0;a=i+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){A=f[s>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0;F=f[q>>2]|0}while((y|0)<(F|0));f[i>>2]=f[t>>2];if((F|0)<3)v=36;else v=38}else{f[i>>2]=f[t>>2];v=36}if((v|0)==36){y=f[c+12>>2]|0;if((y|0)<3){f[q>>2]=y;f[r>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];y=f[c+52>>2]|0;A=f[m>>2]|0;f[A>>2]=f[y>>2];f[A+4>>2]=f[y+4>>2]}else v=38}if((v|0)==38)U$(i,t);f[a>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[C>>2]=f[B>>2]}D=+p[c+176>>3];p[g>>3]=+p[c+192>>3]+ +p[g>>3];y=g+8|0;p[y>>3]=+p[c+200>>3]+ +p[y>>3];y=g+16|0;p[y>>3]=+p[c+208>>3]+ +p[y>>3];y=g+24|0;p[y>>3]=+p[c+216>>3]+ +p[y>>3];G=D}else v=41;while(0);if((v|0)==41){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);G=1.0}E_(d,h,i,E,G,g);g=i+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[m>>2]|0;if((q|0)!=(l|0))wL(q);q=h+36|0;l=f[q>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)V$(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[k>>2]|0;k=0;do{f[q+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(n|0))wL(j);u=e;return}function GZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+56|0;g=a;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[b>>2]|0;ei[f[(f[n>>2]|0)+12>>2]&511](n,b,e,-1);f[g>>2]=1124007936;b=g+4|0;n=g+8|0;o=g+40|0;k=b;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;E_(d,e,g,1.0,0.0,c);c=g+36|0;d=f[c>>2]|0;if(d|0?(l=d+12|0,d=f[l>>2]|0,f[l>>2]=d+-1,(d|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[o>>2]|0;o=0;do{f[c+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[b>>2]|0))}b=f[k>>2]|0;if((b|0)!=(n|0))wL(b);b=e+36|0;n=f[b>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)V$(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[h>>2]|0)>0){b=f[j>>2]|0;j=0;do{f[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)==(i|0)){u=a;return}wL(h);u=a;return}function HZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0;e=u;u=u+144|0;g=e;h=e+88|0;i=e+32|0;j=f[c>>2]|0;if((j|0)!=(a|0)){ei[f[(f[j>>2]|0)+60>>2]&511](j,b,c,d);u=e;return};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[h>>2]=1124007936;j=h+4|0;a=h+8|0;k=h+40|0;l=j;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=a;n=h+48|0;o=h+44|0;f[o>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=i+48|0;m=i+44|0;f[m>>2]=l;f[l>>2]=0;f[i+52>>2]=0;t=f[b>>2]|0;do if((t|0)==38384){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){v=21;break}w=b+8|0;if((h|0)!=(w|0)){x=b+44|0;y=f[x>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){V$(h);B=z}else B=z}else B=h+36|0;f[B>>2]=0;z=h+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[k>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;C=f[j>>2]|0}while((A|0)<(C|0));f[h>>2]=f[w>>2];if((C|0)<3)v=16;else v=18}else{f[h>>2]=f[w>>2];v=16}if((v|0)==16){A=f[b+12>>2]|0;if((A|0)<3){f[j>>2]=A;f[a>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];A=f[b+52>>2]|0;y=f[o>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2]}else v=18}if((v|0)==18)U$(h,w);f[z>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[B>>2]=f[x>>2]}D=+p[b+176>>3];p[g>>3]=+p[b+192>>3];p[g+8>>3]=+p[b+200>>3];p[g+16>>3]=+p[b+208>>3];p[g+24>>3]=+p[b+216>>3];E=D}else v=21;while(0);if((v|0)==21){ei[f[(f[t>>2]|0)+12>>2]&511](t,b,h,-1);E=1.0}b=f[c>>2]|0;do if((b|0)==38384){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=41;break}t=c+8|0;if((i|0)!=(t|0)){B=c+44|0;a=f[B>>2]|0;if(a|0){C=a+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;a=f[C>>2]|0;if(a|0?(A=a+12|0,a=f[A>>2]|0,f[A>>2]=a+-1,(a|0)==1):0)V$(i);f[C>>2]=0;a=i+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){A=f[s>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0;F=f[q>>2]|0}while((y|0)<(F|0));f[i>>2]=f[t>>2];if((F|0)<3)v=36;else v=38}else{f[i>>2]=f[t>>2];v=36}if((v|0)==36){y=f[c+12>>2]|0;if((y|0)<3){f[q>>2]=y;f[r>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];y=f[c+52>>2]|0;A=f[m>>2]|0;f[A>>2]=f[y>>2];f[A+4>>2]=f[y+4>>2]}else v=38}if((v|0)==38)U$(i,t);f[a>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[C>>2]=f[B>>2]}D=-+p[c+176>>3];p[g>>3]=+p[g>>3]-+p[c+192>>3];y=g+8|0;p[y>>3]=+p[y>>3]-+p[c+200>>3];y=g+16|0;p[y>>3]=+p[y>>3]-+p[c+208>>3];y=g+24|0;p[y>>3]=+p[y>>3]-+p[c+216>>3];G=D}else v=41;while(0);if((v|0)==41){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);G=-1.0}E_(d,h,i,E,G,g);g=i+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[m>>2]|0;if((q|0)!=(l|0))wL(q);q=h+36|0;l=f[q>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)V$(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[k>>2]|0;k=0;do{f[q+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(n|0))wL(j);u=e;return}function IZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+56|0;g=a;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[c>>2]|0;ei[f[(f[n>>2]|0)+12>>2]&511](n,c,e,-1);f[g>>2]=1124007936;c=g+4|0;n=g+8|0;o=g+40|0;k=c;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;E_(d,e,g,-1.0,0.0,b);b=g+36|0;d=f[b>>2]|0;if(d|0?(l=d+12|0,d=f[l>>2]|0,f[l>>2]=d+-1,(d|0)==1):0)V$(g);f[b>>2]=0;b=g+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[o>>2]|0;o=0;do{f[b+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[c>>2]|0))}c=f[k>>2]|0;if((c|0)!=(n|0))wL(c);c=e+36|0;n=f[c>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){c=f[j>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)==(i|0)){u=a;return}wL(h);u=a;return}function JZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0;g=u;u=u+112|0;h=g+56|0;i=g;j=f[c>>2]|0;if((j|0)!=(a|0)){ni[f[(f[j>>2]|0)+68>>2]&31](j,b,c,d,e);u=g;return}f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;r=i+4|0;s=i+8|0;t=i+40|0;m=r;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[t>>2]=s;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;v=f[b>>2]|0;do if(!((v|0)==38624?(f[b+4>>2]|0)==47:0))if((v|0)==38384){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){w=52;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){x=b+8|0;if((h|0)!=(x|0)){y=b+44|0;z=f[y>>2]|0;if(z){A=z+12|0;f[A>>2]=(f[A>>2]|0)+1;A=h+36|0;z=f[A>>2]|0;if((z|0)!=0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0){V$(h);C=A}else C=A}else C=h+36|0;f[C>>2]=0;A=h+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;B=0;do{f[z+(B<<2)>>2]=0;B=B+1|0;D=f[j>>2]|0}while((B|0)<(D|0));f[h>>2]=f[x>>2];if((D|0)<3)w=47;else w=49}else{f[h>>2]=f[x>>2];w=47}if((w|0)==47){B=f[b+12>>2]|0;if((B|0)<3){f[j>>2]=B;f[k>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];B=f[b+52>>2]|0;z=f[q>>2]|0;f[z>>2]=f[B>>2];f[z+4>>2]=f[B+4>>2]}else w=49}if((w|0)==49)U$(h,x);f[A>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[C>>2]=f[y>>2]}E=+p[b+176>>3]*e;w=53}else w=52}else w=52;else{if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){w=52;break}do if((a|0)==38384){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){w=27;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){F=+p[c+176>>3]*e;B=c+8|0;if((i|0)==(B|0))G=F;else{z=c+44|0;H=f[z>>2]|0;if(H){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1;I=i+36|0;H=f[I>>2]|0;if((H|0)!=0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0){V$(i);K=I}else K=I}else K=i+36|0;f[K>>2]=0;I=i+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[r>>2]|0)>0){H=f[t>>2]|0;J=0;do{f[H+(J<<2)>>2]=0;J=J+1|0;L=f[r>>2]|0}while((J|0)<(L|0));f[i>>2]=f[B>>2];if((L|0)<3)w=23;else w=25}else{f[i>>2]=f[B>>2];w=23}if((w|0)==23){J=f[c+12>>2]|0;if((J|0)<3){f[r>>2]=J;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];J=f[c+52>>2]|0;H=f[n>>2]|0;f[H>>2]=f[J>>2];f[H+4>>2]=f[J+4>>2]}else w=25}if((w|0)==25)U$(i,B);f[I>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[K>>2]=f[z>>2];G=F}}else w=27}else w=27;while(0);if((w|0)==27){ei[f[(f[a>>2]|0)+12>>2]&511](a,c,i,-1);G=e}y_(d,47,i,b+8|0,G/+p[b+176>>3])}while(0);if((w|0)==52){ei[f[(f[v>>2]|0)+12>>2]&511](v,b,h,-1);E=e;w=53}if((w|0)==53){b=f[c>>2]|0;do if((b|0)==38384){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){w=95;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){v=c+8|0;if((i|0)!=(v|0)){a=c+44|0;K=f[a>>2]|0;if(K|0){L=K+12|0;f[L>>2]=(f[L>>2]|0)+1}L=i+36|0;K=f[L>>2]|0;if(K|0?(C=K+12|0,K=f[C>>2]|0,f[C>>2]=K+-1,(K|0)==1):0)V$(i);f[L>>2]=0;K=i+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[r>>2]|0)>0){C=f[t>>2]|0;k=0;do{f[C+(k<<2)>>2]=0;k=k+1|0;M=f[r>>2]|0}while((k|0)<(M|0));f[i>>2]=f[v>>2];if((M|0)<3)w=71;else w=73}else{f[i>>2]=f[v>>2];w=71}if((w|0)==71){k=f[c+12>>2]|0;if((k|0)<3){f[r>>2]=k;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];k=f[c+52>>2]|0;C=f[n>>2]|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2]}else w=73}if((w|0)==73)U$(i,v);f[K>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[L>>2]=f[a>>2]}N=42;O=E*+p[c+176>>3]}else w=95}else if((b|0)==38624?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){w=95;break}k=c+8|0;if((i|0)!=(k|0)){C=c+44|0;D=f[C>>2]|0;if(D|0){y=D+12|0;f[y>>2]=(f[y>>2]|0)+1}y=i+36|0;D=f[y>>2]|0;if(D|0?(A=D+12|0,D=f[A>>2]|0,f[A>>2]=D+-1,(D|0)==1):0)V$(i);f[y>>2]=0;D=i+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[r>>2]|0)>0){A=f[t>>2]|0;x=0;do{f[A+(x<<2)>>2]=0;x=x+1|0;P=f[r>>2]|0}while((x|0)<(P|0));f[i>>2]=f[k>>2];if((P|0)<3)w=90;else w=92}else{f[i>>2]=f[k>>2];w=90}if((w|0)==90){x=f[c+12>>2]|0;if((x|0)<3){f[r>>2]=x;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];x=f[c+52>>2]|0;A=f[n>>2]|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2]}else w=92}if((w|0)==92)U$(i,k);f[D>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[y>>2]=f[C>>2]}N=47;O=E*+p[c+176>>3]}else w=95;while(0);if((w|0)==95){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);N=42;O=E}y_(d,N,h,i,O)}N=i+36|0;d=f[N>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(i);f[N>>2]=0;N=i+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[r>>2]|0)>0){N=f[t>>2]|0;t=0;do{f[N+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[n>>2]|0;if((r|0)!=(m|0))wL(r);r=h+36|0;m=f[r>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(h);f[r>>2]=0;r=h+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[l>>2]|0;l=0;do{f[r+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(o|0))wL(j);u=g;return}function KZ(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+144|0;e=a+88|0;g=a+32|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;n=e+44|0;f[n>>2]=j;f[j>>2]=0;f[e+52>>2]=0;o=f[b>>2]|0;ei[f[(f[o>>2]|0)+12>>2]&511](o,b,e,-1);f[g>>2]=1124007936;b=g+4|0;o=g+8|0;p=g+40|0;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=g+48|0;l=g+44|0;f[l>>2]=o;f[o>>2]=0;f[g+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;E_(d,e,g,c,0.0,h);h=g+36|0;d=f[h>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)V$(g);f[h>>2]=0;h=g+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[b>>2]|0)>0){h=f[p>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[b>>2]|0))}b=f[l>>2]|0;if((b|0)!=(o|0))wL(b);b=e+36|0;o=f[b>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)V$(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function LZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0.0,H=0,I=0;g=u;u=u+112|0;h=g+56|0;i=g;j=f[c>>2]|0;if((j|0)!=(a|0)){ni[f[(f[j>>2]|0)+76>>2]&31](j,b,c,d,e);u=g;return}j=f[b>>2]|0;do if((j|0)==38624?(f[b+4>>2]|0)==47:0){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if((a|0)==38624?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;y_(d,47,c+8|0,b+8|0,+p[b+176>>3]/+p[c+176>>3]);u=g;return}}while(0);f[h>>2]=1124007936;a=h+4|0;k=h+8|0;l=h+40|0;m=a;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;r=i+4|0;s=i+8|0;t=i+40|0;m=r;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[t>>2]=s;m=i+48|0;n=i+44|0;f[n>>2]=m;f[m>>2]=0;f[i+52>>2]=0;do if((j|0)==38384){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){v=32;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){w=b+8|0;if((h|0)!=(w|0)){x=b+44|0;y=f[x>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){V$(h);B=z}else B=z}else B=h+36|0;f[B>>2]=0;z=h+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[a>>2]|0)>0){y=f[l>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;C=f[a>>2]|0}while((A|0)<(C|0));f[h>>2]=f[w>>2];if((C|0)<3)v=27;else v=29}else{f[h>>2]=f[w>>2];v=27}if((v|0)==27){A=f[b+12>>2]|0;if((A|0)<3){f[a>>2]=A;f[k>>2]=f[b+16>>2];f[h+12>>2]=f[b+20>>2];A=f[b+52>>2]|0;y=f[q>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2]}else v=29}if((v|0)==29)U$(h,w);f[z>>2]=f[b+24>>2];f[h+20>>2]=f[b+28>>2];f[h+24>>2]=f[b+32>>2];f[h+28>>2]=f[b+36>>2];f[h+32>>2]=f[b+40>>2];f[B>>2]=f[x>>2]}D=+p[b+176>>3]*e}else v=32}else v=32;while(0);if((v|0)==32){ei[f[(f[j>>2]|0)+12>>2]&511](j,b,h,-1);D=e}b=f[c>>2]|0;do if((b|0)==38384){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=75;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){j=c+8|0;if((i|0)!=(j|0)){B=c+44|0;k=f[B>>2]|0;if(k|0){C=k+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;k=f[C>>2]|0;if(k|0?(A=k+12|0,k=f[A>>2]|0,f[A>>2]=k+-1,(k|0)==1):0)V$(i);f[C>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[r>>2]|0)>0){A=f[t>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0;E=f[r>>2]|0}while((y|0)<(E|0));f[i>>2]=f[j>>2];if((E|0)<3)v=51;else v=53}else{f[i>>2]=f[j>>2];v=51}if((v|0)==51){y=f[c+12>>2]|0;if((y|0)<3){f[r>>2]=y;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];y=f[c+52>>2]|0;A=f[n>>2]|0;f[A>>2]=f[y>>2];f[A+4>>2]=f[y+4>>2]}else v=53}if((v|0)==53)U$(i,j);f[k>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[C>>2]=f[B>>2]}F=47;G=D/+p[c+176>>3]}else v=75}else if((b|0)==38624?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){v=75;break}y=c+8|0;if((i|0)!=(y|0)){A=c+44|0;x=f[A>>2]|0;if(x|0){z=x+12|0;f[z>>2]=(f[z>>2]|0)+1}z=i+36|0;x=f[z>>2]|0;if(x|0?(w=x+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0)V$(i);f[z>>2]=0;x=i+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[r>>2]|0)>0){w=f[t>>2]|0;H=0;do{f[w+(H<<2)>>2]=0;H=H+1|0;I=f[r>>2]|0}while((H|0)<(I|0));f[i>>2]=f[y>>2];if((I|0)<3)v=70;else v=72}else{f[i>>2]=f[y>>2];v=70}if((v|0)==70){H=f[c+12>>2]|0;if((H|0)<3){f[r>>2]=H;f[s>>2]=f[c+16>>2];f[i+12>>2]=f[c+20>>2];H=f[c+52>>2]|0;w=f[n>>2]|0;f[w>>2]=f[H>>2];f[w+4>>2]=f[H+4>>2]}else v=72}if((v|0)==72)U$(i,y);f[x>>2]=f[c+24>>2];f[i+20>>2]=f[c+28>>2];f[i+24>>2]=f[c+32>>2];f[i+28>>2]=f[c+36>>2];f[i+32>>2]=f[c+40>>2];f[z>>2]=f[A>>2]}F=42;G=D/+p[c+176>>3]}else v=75;while(0);if((v|0)==75){ei[f[(f[b>>2]|0)+12>>2]&511](b,c,i,-1);F=47;G=D}y_(d,F,h,i,G);F=i+36|0;d=f[F>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(i);f[F>>2]=0;F=i+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[r>>2]|0)>0){F=f[t>>2]|0;t=0;do{f[F+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[n>>2]|0;if((r|0)!=(m|0))wL(r);r=h+36|0;m=f[r>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(h);f[r>>2]=0;r=h+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[a>>2]|0)>0){r=f[l>>2]|0;l=0;do{f[r+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[a>>2]|0))}a=f[q>>2]|0;if((a|0)!=(o|0))wL(a);u=g;return}function MZ(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+112|0;e=a+56|0;g=a;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[c>>2]|0;ei[f[(f[n>>2]|0)+12>>2]&511](n,c,e,-1);f[g>>2]=1124007936;c=g+4|0;n=g+8|0;o=g+40|0;k=c;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;y_(d,47,e,g,b);d=g+36|0;l=f[d>>2]|0;if(l|0?(p=l+12|0,l=f[p>>2]|0,f[p>>2]=l+-1,(l|0)==1):0)V$(g);f[d>>2]=0;d=g+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[o>>2]|0;o=0;do{f[d+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[c>>2]|0))}c=f[k>>2]|0;if((c|0)!=(n|0))wL(c);c=e+36|0;n=f[c>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[h>>2]|0)>0){c=f[j>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)==(i|0)){u=a;return}wL(h);u=a;return}function NZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;d=a+56|0;e=a;f[d>>2]=1124007936;g=d+4|0;h=d+8|0;i=d+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=d+48|0;l=d+44|0;f[l>>2]=h;f[h>>2]=0;f[d+52>>2]=0;m=f[b>>2]|0;ei[f[(f[m>>2]|0)+12>>2]&511](m,b,d,-1);f[e>>2]=1124007936;b=e+4|0;m=e+8|0;n=e+40|0;j=b;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[n>>2]=m;m=e+48|0;j=e+44|0;f[j>>2]=m;f[m>>2]=0;f[e+52>>2]=0;y_(c,97,d,e,1.0);c=e+36|0;k=f[c>>2]|0;if(k|0?(o=k+12|0,k=f[o>>2]|0,f[o>>2]=k+-1,(k|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[n>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[b>>2]|0))}b=f[j>>2]|0;if((b|0)!=(m|0))wL(b);b=d+36|0;m=f[b>>2]|0;if(m|0?(j=m+12|0,m=f[j>>2]|0,f[j>>2]=m+-1,(m|0)==1):0)V$(d);f[b>>2]=0;b=d+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[g>>2]|0)>0){b=f[i>>2]|0;i=0;do{f[b+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[l>>2]|0;if((g|0)==(h|0)){u=a;return}wL(g);u=a;return}function OZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;a=u;u=u+64|0;d=a;f[d>>2]=1124007936;e=d+4|0;g=d+8|0;h=d+40|0;i=e;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=d+48|0;i=d+44|0;f[i>>2]=g;f[g>>2]=0;f[d+52>>2]=0;j=f[b>>2]|0;ei[f[(f[j>>2]|0)+12>>2]&511](j,b,d,-1);w_(c,d,1.0);c=d+36|0;b=f[c>>2]|0;if(b|0?(j=b+12|0,b=f[j>>2]|0,f[j>>2]=b+-1,(b|0)==1):0)V$(d);f[c>>2]=0;c=d+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){c=f[h>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[e>>2]|0))}e=f[i>>2]|0;if((e|0)==(g|0)){u=a;return}wL(e);u=a;return}function PZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0;e=u;u=u+176|0;g=e+112|0;h=e+56|0;i=e;j=f[c>>2]|0;if((j|0)!=(a|0)){ei[f[(f[j>>2]|0)+92>>2]&511](j,b,c,d);u=e;return}f[g>>2]=1124007936;j=g+4|0;a=g+8|0;k=g+40|0;l=j;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=a;n=g+48|0;o=g+44|0;f[o>>2]=n;f[n>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;q=h+4|0;r=h+8|0;s=h+40|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;t=h+48|0;v=h+44|0;f[v>>2]=t;f[t>>2]=0;f[h+52>>2]=0;w=f[b>>2]|0;a:do if((w|0)==38380){x=+p[b+176>>3];y=b+8|0;if((g|0)==(y|0)){z=1;A=x}else{B=b+44|0;C=f[B>>2]|0;if(C){D=C+12|0;f[D>>2]=(f[D>>2]|0)+1;D=g+36|0;C=f[D>>2]|0;if((C|0)!=0?(E=C+12|0,C=f[E>>2]|0,f[E>>2]=C+-1,(C|0)==1):0){V$(g);F=D}else F=D}else F=g+36|0;f[F>>2]=0;D=g+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[j>>2]|0)>0){C=f[k>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0;G=f[j>>2]|0}while((E|0)<(G|0));f[g>>2]=f[y>>2];if((G|0)<3)H=14;else H=16}else{f[g>>2]=f[y>>2];H=14}if((H|0)==14){E=f[b+12>>2]|0;if((E|0)<3){f[j>>2]=E;f[a>>2]=f[b+16>>2];f[g+12>>2]=f[b+20>>2];E=f[b+52>>2]|0;C=f[o>>2]|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2]}else H=16}if((H|0)==16)U$(g,y);f[D>>2]=f[b+24>>2];f[g+20>>2]=f[b+28>>2];f[g+24>>2]=f[b+32>>2];f[g+28>>2]=f[b+36>>2];f[g+32>>2]=f[b+40>>2];f[F>>2]=f[B>>2];z=1;A=x}}else{do if((w|0)==38384){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){I=+p[b+176>>3];E=b+8|0;if((g|0)==(E|0)){z=0;A=I;break a}C=b+44|0;J=f[C>>2]|0;if(J){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1;K=g+36|0;J=f[K>>2]|0;if((J|0)!=0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0){V$(g);M=K}else M=K}else M=g+36|0;f[M>>2]=0;K=g+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[j>>2]|0)>0){J=f[k>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;N=f[j>>2]|0}while((L|0)<(N|0));f[g>>2]=f[E>>2];if((N|0)<3)H=36;else H=38}else{f[g>>2]=f[E>>2];H=36}if((H|0)==36){L=f[b+12>>2]|0;if((L|0)<3){f[j>>2]=L;f[a>>2]=f[b+16>>2];f[g+12>>2]=f[b+20>>2];L=f[b+52>>2]|0;J=f[o>>2]|0;f[J>>2]=f[L>>2];f[J+4>>2]=f[L+4>>2]}else H=38}if((H|0)==38)U$(g,E);f[K>>2]=f[b+24>>2];f[g+20>>2]=f[b+28>>2];f[g+24>>2]=f[b+32>>2];f[g+28>>2]=f[b+36>>2];f[g+32>>2]=f[b+40>>2];f[M>>2]=f[C>>2];z=0;A=I;break a}}while(0);ei[f[(f[w>>2]|0)+12>>2]&511](w,b,g,-1);z=0;A=1.0}while(0);b=f[c>>2]|0;b:do if((b|0)==38380){w=z|2;x=A*+p[c+176>>3];M=c+8|0;if((h|0)==(M|0)){O=w;P=x}else{a=c+44|0;N=f[a>>2]|0;if(N|0){F=N+12|0;f[F>>2]=(f[F>>2]|0)+1}F=h+36|0;N=f[F>>2]|0;if(N|0?(G=N+12|0,N=f[G>>2]|0,f[G>>2]=N+-1,(N|0)==1):0)V$(h);f[F>>2]=0;N=h+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[q>>2]|0)>0){G=f[s>>2]|0;B=0;do{f[G+(B<<2)>>2]=0;B=B+1|0;Q=f[q>>2]|0}while((B|0)<(Q|0));f[h>>2]=f[M>>2];if((Q|0)<3)H=53;else H=55}else{f[h>>2]=f[M>>2];H=53}if((H|0)==53){B=f[c+12>>2]|0;if((B|0)<3){f[q>>2]=B;f[r>>2]=f[c+16>>2];f[h+12>>2]=f[c+20>>2];B=f[c+52>>2]|0;G=f[v>>2]|0;f[G>>2]=f[B>>2];f[G+4>>2]=f[B+4>>2]}else H=55}if((H|0)==55)U$(h,M);f[N>>2]=f[c+24>>2];f[h+20>>2]=f[c+28>>2];f[h+24>>2]=f[c+32>>2];f[h+28>>2]=f[c+36>>2];f[h+32>>2]=f[c+40>>2];f[F>>2]=f[a>>2];O=w;P=x}}else{do if((b|0)==38384){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){R=A*+p[c+176>>3];B=c+8|0;if((h|0)==(B|0)){O=z;P=R;break b}G=c+44|0;D=f[G>>2]|0;if(D|0){y=D+12|0;f[y>>2]=(f[y>>2]|0)+1}y=h+36|0;D=f[y>>2]|0;if(D|0?(L=D+12|0,D=f[L>>2]|0,f[L>>2]=D+-1,(D|0)==1):0)V$(h);f[y>>2]=0;D=h+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[q>>2]|0)>0){L=f[s>>2]|0;J=0;do{f[L+(J<<2)>>2]=0;J=J+1|0;S=f[q>>2]|0}while((J|0)<(S|0));f[h>>2]=f[B>>2];if((S|0)<3)H=75;else H=77}else{f[h>>2]=f[B>>2];H=75}if((H|0)==75){J=f[c+12>>2]|0;if((J|0)<3){f[q>>2]=J;f[r>>2]=f[c+16>>2];f[h+12>>2]=f[c+20>>2];J=f[c+52>>2]|0;L=f[v>>2]|0;f[L>>2]=f[J>>2];f[L+4>>2]=f[J+4>>2]}else H=77}if((H|0)==77)U$(h,B);f[D>>2]=f[c+24>>2];f[h+20>>2]=f[c+28>>2];f[h+24>>2]=f[c+32>>2];f[h+28>>2]=f[c+36>>2];f[h+32>>2]=f[c+40>>2];f[y>>2]=f[G>>2];O=z;P=R;break b}}while(0);ei[f[(f[b>>2]|0)+12>>2]&511](b,c,h,-1);O=z;P=A}while(0);f[i>>2]=1124007936;z=i+4|0;c=i+8|0;b=i+40|0;l=z;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[b>>2]=c;c=i+48|0;l=i+44|0;f[l>>2]=c;f[c>>2]=0;f[i+52>>2]=0;e_(d,O,g,h,P,i,1.0);O=i+36|0;d=f[O>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)V$(i);f[O>>2]=0;O=i+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[z>>2]|0)>0){O=f[b>>2]|0;b=0;do{f[O+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[z>>2]|0))}z=f[l>>2]|0;if((z|0)!=(c|0))wL(z);z=h+36|0;c=f[z>>2]|0;if(c|0?(l=c+12|0,c=f[l>>2]|0,f[l>>2]=c+-1,(c|0)==1):0)V$(h);f[z>>2]=0;z=h+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[q>>2]|0)>0){z=f[s>>2]|0;s=0;do{f[z+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[v>>2]|0;if((q|0)!=(t|0))wL(q);q=g+36|0;t=f[q>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)V$(g);f[q>>2]=0;q=g+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[k>>2]|0;k=0;do{f[q+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(n|0))wL(j);u=e;return}function QZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+64|0;e=a;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;j=e+44|0;f[j>>2]=h;f[h>>2]=0;f[e+52>>2]=0;k=f[b>>2]|0;ei[f[(f[k>>2]|0)+12>>2]&511](k,b,e,-1);TZ(d,c,e);c=e+36|0;d=f[c>>2]|0;if(d|0?(b=d+12|0,d=f[b>>2]|0,f[b>>2]=d+-1,(d|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[i>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[j>>2]|0;if((g|0)==(h|0)){u=a;return}wL(g);u=a;return}function RZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(f[c+24>>2]|0){b=f[c+12>>2]|0;if((b|0)<3)d=Y(f[c+20>>2]|0,f[c+16>>2]|0)|0;else{e=f[c+48>>2]|0;g=0;h=1;while(1){i=Y(f[e+(g<<2)>>2]|0,h)|0;g=g+1|0;if((g|0)==(b|0)){d=i;break}else h=i}}if(!((b|0)==0|(d|0)==0))j=c+48|0;else k=8}else k=8;do if((k|0)==8){if(f[c+80>>2]|0){d=f[c+68>>2]|0;if((d|0)<3)l=Y(f[c+76>>2]|0,f[c+72>>2]|0)|0;else{b=f[c+104>>2]|0;h=0;g=1;while(1){e=Y(f[b+(h<<2)>>2]|0,g)|0;h=h+1|0;if((h|0)==(d|0)){l=e;break}else g=e}}if(!((d|0)==0|(l|0)==0)){j=c+160|0;break}}j=c+104|0}while(0);c=f[j>>2]|0;j=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=j;return}function SZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=b+8|0;if(f[b+24>>2]|0){c=f[b+12>>2]|0;if((c|0)<3)d=Y(f[b+20>>2]|0,f[b+16>>2]|0)|0;else{e=f[b+48>>2]|0;g=0;h=1;while(1){i=Y(f[e+(g<<2)>>2]|0,h)|0;g=g+1|0;if((g|0)==(c|0)){d=i;break}else h=i}}if(!((c|0)==0|(d|0)==0)){j=a;k=f[j>>2]|0;l=k&4095;return l|0}}a=b+64|0;if(f[b+80>>2]|0){d=f[b+68>>2]|0;if((d|0)<3)m=Y(f[b+76>>2]|0,f[b+72>>2]|0)|0;else{c=f[b+104>>2]|0;h=0;g=1;while(1){e=Y(f[c+(h<<2)>>2]|0,g)|0;h=h+1|0;if((h|0)==(d|0)){m=e;break}else g=e}}if(!((d|0)==0|(m|0)==0)){j=b+120|0;k=f[j>>2]|0;l=k&4095;return l|0}}j=a;k=f[j>>2]|0;l=k&4095;return l|0}function TZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;q=h+4|0;r=h+8|0;s=h+40|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;r=h+48|0;t=h+44|0;f[t>>2]=r;f[r>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;UZ(e,38020,b,c,g,h,1.0,0.0,i);i=e;c=f[i+4>>2]|0;b=a;f[b>>2]=f[i>>2];f[b+4>>2]=c;c=a+8|0;b=(e|0)==(a|0);if(!b){i=a+44|0;v=f[i>>2]|0;if(v|0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0)V$(c);f[i>>2]=0;v=a+24|0;w=a+12|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){x=f[a+48>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}y=e+8|0;f[c>>2]=f[y>>2];c=e+12|0;x=f[c>>2]|0;f[w>>2]=x;w=e+16|0;z=a+16|0;f[z>>2]=f[w>>2];f[a+20>>2]=f[e+20>>2];f[v>>2]=f[e+24>>2];f[a+28>>2]=f[e+28>>2];f[a+32>>2]=f[e+32>>2];f[a+36>>2]=f[e+36>>2];f[a+40>>2]=f[e+40>>2];f[i>>2]=f[e+44>>2];i=a+52|0;v=f[i>>2]|0;A=a+56|0;if((v|0)==(A|0)){B=x;C=v}else{wL(v);f[i>>2]=A;f[a+48>>2]=z;B=f[c>>2]|0;C=A}A=e+52|0;if((B|0)<3){B=f[A>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2]}else{f[i>>2]=f[A>>2];i=e+48|0;f[a+48>>2]=f[i>>2];f[A>>2]=e+56;f[i>>2]=w}f[y>>2]=1124007936;m=c;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));c=a+64|0;if(!b){y=a+100|0;w=f[y>>2]|0;if(w|0?(i=w+12|0,w=f[i>>2]|0,f[i>>2]=w+-1,(w|0)==1):0)V$(c);f[y>>2]=0;w=a+80|0;i=a+68|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[i>>2]|0)>0){A=f[a+104>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[i>>2]|0))}B=e+64|0;f[c>>2]=f[B>>2];c=e+68|0;A=f[c>>2]|0;f[i>>2]=A;i=e+72|0;C=a+72|0;f[C>>2]=f[i>>2];f[a+76>>2]=f[e+76>>2];f[w>>2]=f[e+80>>2];f[a+84>>2]=f[e+84>>2];f[a+88>>2]=f[e+88>>2];f[a+92>>2]=f[e+92>>2];f[a+96>>2]=f[e+96>>2];f[y>>2]=f[e+100>>2];y=a+108|0;w=f[y>>2]|0;z=a+112|0;if((w|0)==(z|0)){D=A;E=w}else{wL(w);f[y>>2]=z;f[a+104>>2]=C;D=f[c>>2]|0;E=z}z=e+108|0;if((D|0)<3){D=f[z>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[y>>2]=f[z>>2];y=e+104|0;f[a+104>>2]=f[y>>2];f[z>>2]=e+112;f[y>>2]=i}f[B>>2]=1124007936;m=c;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));c=a+120|0;if(!b){b=a+156|0;B=f[b>>2]|0;if(B|0?(i=B+12|0,B=f[i>>2]|0,f[i>>2]=B+-1,(B|0)==1):0)V$(c);f[b>>2]=0;B=a+136|0;i=a+124|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[i>>2]|0)>0){y=f[a+160>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[i>>2]|0))}z=e+120|0;f[c>>2]=f[z>>2];c=e+124|0;y=f[c>>2]|0;f[i>>2]=y;i=e+128|0;D=a+128|0;f[D>>2]=f[i>>2];f[a+132>>2]=f[e+132>>2];f[B>>2]=f[e+136>>2];f[a+140>>2]=f[e+140>>2];f[a+144>>2]=f[e+144>>2];f[a+148>>2]=f[e+148>>2];f[a+152>>2]=f[e+152>>2];f[b>>2]=f[e+156>>2];b=a+164|0;B=f[b>>2]|0;E=a+168|0;if((B|0)==(E|0)){F=y;G=B}else{wL(B);f[b>>2]=E;f[a+160>>2]=D;F=f[c>>2]|0;G=E}E=e+164|0;if((F|0)<3){F=f[E>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2]}else{f[b>>2]=f[E>>2];b=e+160|0;f[a+160>>2]=f[b>>2];f[E>>2]=e+168;f[b>>2]=i}f[z>>2]=1124007936;m=c;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0))}}}m=a+176|0;n=e+176|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];p[a+192>>3]=+p[e+192>>3];p[a+200>>3]=+p[e+200>>3];p[a+208>>3]=+p[e+208>>3];p[a+216>>3]=+p[e+216>>3];Zj(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)V$(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;s=0;do{f[e+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[t>>2]|0;if((q|0)!=(r|0))wL(q);q=g+36|0;r=f[q>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)V$(g);f[q>>2]=0;q=g+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[l>>2]|0;l=0;do{f[q+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}wL(j);u=d;return}function UZ(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0.0,B=0;f[a>>2]=b;f[a+4>>2]=c;c=a+8|0;f[c>>2]=f[d>>2];b=a+12|0;k=d+4|0;f[b>>2]=f[k>>2];l=a+16|0;f[l>>2]=f[d+8>>2];f[a+20>>2]=f[d+12>>2];f[a+24>>2]=f[d+16>>2];f[a+28>>2]=f[d+20>>2];f[a+32>>2]=f[d+24>>2];f[a+36>>2]=f[d+28>>2];f[a+40>>2]=f[d+32>>2];m=f[d+36>>2]|0;f[a+44>>2]=m;f[a+48>>2]=l;l=a+56|0;n=a+52|0;f[n>>2]=l;f[l>>2]=0;f[a+60>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[d+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[b>>2]=0;U$(c,d)}d=a+64|0;f[d>>2]=f[e>>2];c=a+68|0;b=e+4|0;f[c>>2]=f[b>>2];k=a+72|0;f[k>>2]=f[e+8>>2];f[a+76>>2]=f[e+12>>2];f[a+80>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[a+100>>2]=l;f[a+104>>2]=k;k=a+112|0;n=a+108|0;f[n>>2]=k;f[k>>2]=0;f[a+116>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[b>>2]|0)<3){b=f[e+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2]}else{f[c>>2]=0;U$(d,e)}e=a+120|0;f[e>>2]=f[g>>2];d=a+124|0;c=g+4|0;f[d>>2]=f[c>>2];b=a+128|0;f[b>>2]=f[g+8>>2];f[a+132>>2]=f[g+12>>2];f[a+136>>2]=f[g+16>>2];f[a+140>>2]=f[g+20>>2];f[a+144>>2]=f[g+24>>2];f[a+148>>2]=f[g+28>>2];f[a+152>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[a+156>>2]=k;f[a+160>>2]=b;b=a+168|0;n=a+164|0;f[n>>2]=b;f[b>>2]=0;f[a+172>>2]=0;if(k|0){b=k+12|0;f[b>>2]=(f[b>>2]|0)+1}if((f[c>>2]|0)<3){c=f[g+44>>2]|0;b=f[n>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}else{f[d>>2]=0;U$(e,g);o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}}function VZ(a){a=a|0;cYc(a);return}function WZ(a,b){a=a|0;b=b|0;return 0}function XZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;+gM(g,h,f[b+4>>2]|0);if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dY(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)V$(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function YZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[c>>2]|0;if((f[b>>2]|0)==38020&(e|0)==38140){ZZ(d,f[b+4>>2]|0,b+8|0,c+8|0);return}if((a|0)==(e|0)){PZ(e,b,c,d);return}else{ei[f[(f[e>>2]|0)+92>>2]&511](e,b,c,d);return}}function ZZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+320|0;g=e+32|0;h=e+256|0;i=e;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;o=h+44|0;f[o>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;UZ(g,38144,b,c,d,h,1.0,1.0,i);i=g;d=f[i+4>>2]|0;c=a;f[c>>2]=f[i>>2];f[c+4>>2]=d;d=a+8|0;c=(g|0)==(a|0);if(!c){i=a+44|0;b=f[i>>2]|0;if(b|0?(q=b+12|0,b=f[q>>2]|0,f[q>>2]=b+-1,(b|0)==1):0)V$(d);f[i>>2]=0;b=a+24|0;q=a+12|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[q>>2]|0)>0){r=f[a+48>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}s=g+8|0;f[d>>2]=f[s>>2];d=g+12|0;r=f[d>>2]|0;f[q>>2]=r;q=g+16|0;t=a+16|0;f[t>>2]=f[q>>2];f[a+20>>2]=f[g+20>>2];f[b>>2]=f[g+24>>2];f[a+28>>2]=f[g+28>>2];f[a+32>>2]=f[g+32>>2];f[a+36>>2]=f[g+36>>2];f[a+40>>2]=f[g+40>>2];f[i>>2]=f[g+44>>2];i=a+52|0;b=f[i>>2]|0;v=a+56|0;if((b|0)==(v|0)){w=r;x=b}else{wL(b);f[i>>2]=v;f[a+48>>2]=t;w=f[d>>2]|0;x=v}v=g+52|0;if((w|0)<3){w=f[v>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2]}else{f[i>>2]=f[v>>2];i=g+48|0;f[a+48>>2]=f[i>>2];f[v>>2]=g+56;f[i>>2]=q}f[s>>2]=1124007936;m=d;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));d=a+64|0;if(!c){s=a+100|0;q=f[s>>2]|0;if(q|0?(i=q+12|0,q=f[i>>2]|0,f[i>>2]=q+-1,(q|0)==1):0)V$(d);f[s>>2]=0;q=a+80|0;i=a+68|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[i>>2]|0)>0){v=f[a+104>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}w=g+64|0;f[d>>2]=f[w>>2];d=g+68|0;v=f[d>>2]|0;f[i>>2]=v;i=g+72|0;x=a+72|0;f[x>>2]=f[i>>2];f[a+76>>2]=f[g+76>>2];f[q>>2]=f[g+80>>2];f[a+84>>2]=f[g+84>>2];f[a+88>>2]=f[g+88>>2];f[a+92>>2]=f[g+92>>2];f[a+96>>2]=f[g+96>>2];f[s>>2]=f[g+100>>2];s=a+108|0;q=f[s>>2]|0;t=a+112|0;if((q|0)==(t|0)){y=v;z=q}else{wL(q);f[s>>2]=t;f[a+104>>2]=x;y=f[d>>2]|0;z=t}t=g+108|0;if((y|0)<3){y=f[t>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2]}else{f[s>>2]=f[t>>2];s=g+104|0;f[a+104>>2]=f[s>>2];f[t>>2]=g+112;f[s>>2]=i}f[w>>2]=1124007936;m=d;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));d=a+120|0;if(!c){c=a+156|0;w=f[c>>2]|0;if(w|0?(i=w+12|0,w=f[i>>2]|0,f[i>>2]=w+-1,(w|0)==1):0)V$(d);f[c>>2]=0;w=a+136|0;i=a+124|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[i>>2]|0)>0){s=f[a+160>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}t=g+120|0;f[d>>2]=f[t>>2];d=g+124|0;s=f[d>>2]|0;f[i>>2]=s;i=g+128|0;y=a+128|0;f[y>>2]=f[i>>2];f[a+132>>2]=f[g+132>>2];f[w>>2]=f[g+136>>2];f[a+140>>2]=f[g+140>>2];f[a+144>>2]=f[g+144>>2];f[a+148>>2]=f[g+148>>2];f[a+152>>2]=f[g+152>>2];f[c>>2]=f[g+156>>2];c=a+164|0;w=f[c>>2]|0;z=a+168|0;if((w|0)==(z|0)){A=s;B=w}else{wL(w);f[c>>2]=z;f[a+160>>2]=y;A=f[d>>2]|0;B=z}z=g+164|0;if((A|0)<3){A=f[z>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2]}else{f[c>>2]=f[z>>2];c=g+160|0;f[a+160>>2]=f[c>>2];f[z>>2]=g+168;f[c>>2]=i}f[t>>2]=1124007936;m=d;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0))}}}m=a+176|0;n=g+176|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];p[a+192>>3]=+p[g+192>>3];p[a+200>>3]=+p[g+200>>3];p[a+208>>3]=+p[g+208>>3];p[a+216>>3]=+p[g+216>>3];Zj(g);g=h+36|0;a=f[g>>2]|0;if(a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)V$(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[j>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=e;return}wL(j);u=e;return}function _Z(a){a=a|0;cYc(a);return}function $Z(a,b){a=a|0;b=b|0;return 0}function a_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;n=i+8|0;f[n>>2]=0;f[n+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;pM(g,h,i,f[b+4>>2]|0)|0;if((f[o+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dY(o,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)V$(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}wL(j);u=a;return}function b_(a){a=a|0;cYc(a);return}function c_(a,b){a=a|0;b=b|0;return 1}function d_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;g=a;h=c+8|0;if((e|0)!=-1?(i=f[h>>2]|0,(i&4095|0)!=(e|0)):0){if((i^e)&4088|0){i=$Xc(48)|0;f[g>>2]=i;f[g+8>>2]=-2147483600;f[g+4>>2]=34;j=i;k=236863;l=j+34|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+34>>0]=0;vM(-215,g,236898,236905,1201)}i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=d;dY(h,g,e,1.0,0.0);u=a;return}if((h|0)==(d|0)){u=a;return}e=c+44|0;g=f[e>>2]|0;if(g|0){i=g+12|0;f[i>>2]=(f[i>>2]|0)+1}i=d+36|0;g=f[i>>2]|0;if(g|0?(k=g+12|0,g=f[k>>2]|0,f[k>>2]=g+-1,(g|0)==1):0)V$(d);f[i>>2]=0;g=d+16|0;k=d+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[k>>2]|0)>0){j=f[d+40>>2]|0;l=0;do{f[j+(l<<2)>>2]=0;l=l+1|0;m=f[k>>2]|0}while((l|0)<(m|0));f[d>>2]=f[c+8>>2];if((m|0)<3)n=14;else n=16}else{f[d>>2]=f[c+8>>2];n=14}if((n|0)==14){m=f[c+12>>2]|0;if((m|0)<3){f[k>>2]=m;f[d+8>>2]=f[c+16>>2];f[d+12>>2]=f[c+20>>2];m=f[c+52>>2]|0;k=f[d+44>>2]|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2]}else n=16}if((n|0)==16)U$(d,h);f[g>>2]=f[c+24>>2];f[d+20>>2]=f[c+28>>2];f[d+24>>2]=f[c+32>>2];f[d+28>>2]=f[c+36>>2];f[d+32>>2]=f[c+40>>2];f[i>>2]=f[e>>2];u=a;return}function e_(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+256|0;j=i+32|0;k=i;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;UZ(j,38388,b,c,d,g,e,h,k);k=j;g=f[k+4>>2]|0;d=a;f[d>>2]=f[k>>2];f[d+4>>2]=g;g=a+8|0;d=(j|0)==(a|0);if(!d){k=a+44|0;c=f[k>>2]|0;if(c|0?(b=c+12|0,c=f[b>>2]|0,f[b>>2]=c+-1,(c|0)==1):0)V$(g);f[k>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){l=f[a+48>>2]|0;m=0;do{f[l+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[b>>2]|0))}m=j+8|0;f[g>>2]=f[m>>2];g=j+12|0;l=f[g>>2]|0;f[b>>2]=l;b=j+16|0;n=a+16|0;f[n>>2]=f[b>>2];f[a+20>>2]=f[j+20>>2];f[c>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];f[a+36>>2]=f[j+36>>2];f[a+40>>2]=f[j+40>>2];f[k>>2]=f[j+44>>2];k=a+52|0;c=f[k>>2]|0;o=a+56|0;if((c|0)==(o|0)){q=l;r=c}else{wL(c);f[k>>2]=o;f[a+48>>2]=n;q=f[g>>2]|0;r=o}o=j+52|0;if((q|0)<3){q=f[o>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2]}else{f[k>>2]=f[o>>2];k=j+48|0;f[a+48>>2]=f[k>>2];f[o>>2]=j+56;f[k>>2]=b}f[m>>2]=1124007936;m=g;g=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(g|0));b=a+64|0;if(!d){k=a+100|0;o=f[k>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)V$(b);f[k>>2]=0;o=a+80|0;q=a+68|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[q>>2]|0)>0){r=f[a+104>>2]|0;n=0;do{f[r+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[q>>2]|0))}n=j+64|0;f[b>>2]=f[n>>2];b=j+68|0;r=f[b>>2]|0;f[q>>2]=r;q=j+72|0;c=a+72|0;f[c>>2]=f[q>>2];f[a+76>>2]=f[j+76>>2];f[o>>2]=f[j+80>>2];f[a+84>>2]=f[j+84>>2];f[a+88>>2]=f[j+88>>2];f[a+92>>2]=f[j+92>>2];f[a+96>>2]=f[j+96>>2];f[k>>2]=f[j+100>>2];k=a+108|0;o=f[k>>2]|0;l=a+112|0;if((o|0)==(l|0)){s=r;t=o}else{wL(o);f[k>>2]=l;f[a+104>>2]=c;s=f[b>>2]|0;t=l}l=j+108|0;if((s|0)<3){s=f[l>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[k>>2]=f[l>>2];k=j+104|0;f[a+104>>2]=f[k>>2];f[l>>2]=j+112;f[k>>2]=q}f[n>>2]=1124007936;m=b;g=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(g|0));b=a+120|0;if(!d){d=a+156|0;n=f[d>>2]|0;if(n|0?(q=n+12|0,n=f[q>>2]|0,f[q>>2]=n+-1,(n|0)==1):0)V$(b);f[d>>2]=0;n=a+136|0;q=a+124|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[q>>2]|0)>0){k=f[a+160>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[q>>2]|0))}l=j+120|0;f[b>>2]=f[l>>2];b=j+124|0;k=f[b>>2]|0;f[q>>2]=k;q=j+128|0;s=a+128|0;f[s>>2]=f[q>>2];f[a+132>>2]=f[j+132>>2];f[n>>2]=f[j+136>>2];f[a+140>>2]=f[j+140>>2];f[a+144>>2]=f[j+144>>2];f[a+148>>2]=f[j+148>>2];f[a+152>>2]=f[j+152>>2];f[d>>2]=f[j+156>>2];d=a+164|0;n=f[d>>2]|0;t=a+168|0;if((n|0)==(t|0)){v=k;w=n}else{wL(n);f[d>>2]=t;f[a+160>>2]=s;v=f[b>>2]|0;w=t}t=j+164|0;if((v|0)<3){v=f[t>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2]}else{f[d>>2]=f[t>>2];d=j+160|0;f[a+160>>2]=f[d>>2];f[t>>2]=j+168;f[d>>2]=q}f[l>>2]=1124007936;m=b;g=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(g|0))}}}m=a+176|0;g=j+176|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[m+12>>2]=f[g+12>>2];p[a+192>>3]=+p[j+192>>3];p[a+200>>3]=+p[j+200>>3];p[a+208>>3]=+p[j+208>>3];p[a+216>>3]=+p[j+216>>3];Zj(j);u=i;return}function f_(a){a=a|0;cYc(a);return}function g_(a,b){a=a|0;b=b|0;return 0}function h_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0;a=u;u=u+128|0;e=a+64|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[e>>2]=1124007936;k=e+4|0;l=e+8|0;m=e+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)q=e;else q=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;r=+p[b+176>>3];f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b+120;s=+p[b+184>>3];o=j+8|0;f[o>>2]=0;f[o+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;AY(g,h,r,i,s,j,f[b+4>>2]|0);if((f[q+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dY(q,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)V$(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[m>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=a;return}wL(k);u=a;return}function i_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;e=f[b>>2]|0;g=(e|0)==38140;h=f[c>>2]|0;i=(h|0)==38140;j=g?1.0:+p[b+176>>3];k=i?1.0:+p[c+176>>3];l=+p[b+184>>3];a:do if(!((e|0)!=38388|(f[b+136>>2]|0)!=0&l!=0.0)){do if(!i){if((h|0)!=38384)if((h|0)==38380)break;else break a;if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break a;if(!(+p[c+192>>3]==0.0))break a;if(!(+p[c+200>>3]==0.0))break a;if(!(+p[c+208>>3]==0.0))break a;if(!(+p[c+216>>3]==0.0))break a}while(0);e_(d,((h|0)==38380?4:0)|f[b+4>>2]&-5,b+8|0,b+64|0,j,c+8|0,k);return}while(0);b:do if(!((h|0)!=38388|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!g){if((e|0)!=38384)if((e|0)==38380)break;else break b;if(!((f[b+80>>2]|0)==0|l==0.0))break b;if(!(+p[b+192>>3]==0.0))break b;if(!(+p[b+200>>3]==0.0))break b;if(!(+p[b+208>>3]==0.0))break b;if(!(+p[b+216>>3]==0.0))break b}while(0);e_(d,((e|0)==38380?4:0)|f[c+4>>2]&-5,c+8|0,c+64|0,k,b+8|0,j);return}while(0);if((a|0)==(h|0)){FZ(h,b,c,d);return}else{ei[f[(f[h>>2]|0)+52>>2]&511](h,b,c,d);return}}function j_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;e=f[b>>2]|0;g=(e|0)==38140;h=f[c>>2]|0;i=(h|0)==38140;j=g?1.0:+p[b+176>>3];k=i?1.0:+p[c+176>>3];l=+p[b+184>>3];a:do if(!((e|0)!=38388|(f[b+136>>2]|0)!=0&l!=0.0)){do if(!i){if((h|0)!=38384)if((h|0)==38380)break;else break a;if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break a;if(!(+p[c+192>>3]==0.0))break a;if(!(+p[c+200>>3]==0.0))break a;if(!(+p[c+208>>3]==0.0))break a;if(!(+p[c+216>>3]==0.0))break a}while(0);e_(d,((h|0)==38380?4:0)|f[b+4>>2]&-5,b+8|0,b+64|0,j,c+8|0,-k);return}while(0);b:do if(!((h|0)!=38388|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!g){if((e|0)!=38384)if((e|0)==38380)break;else break b;if(!((f[b+80>>2]|0)==0|l==0.0))break b;if(!(+p[b+192>>3]==0.0))break b;if(!(+p[b+200>>3]==0.0))break b;if(!(+p[b+208>>3]==0.0))break b;if(!(+p[b+216>>3]==0.0))break b}while(0);e_(d,((e|0)==38380?4:0)|f[c+4>>2]&-5,c+8|0,c+64|0,-k,b+8|0,j);return}while(0);if((a|0)==(h|0)){HZ(h,b,c,d);return}else{ei[f[(f[h>>2]|0)+60>>2]&511](h,b,c,d);return}}function k_(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;m_(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;return}function l_(a,b,c){a=a|0;b=b|0;c=c|0;m_(c,b)|0;a=f[b+4>>2]|0;f[c+4>>2]=(a<<1&2|a&4|a>>>1&1)^7;tV(c+8|0,c+64|0);return}function m_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;c=b;d=f[c+4>>2]|0;e=a;f[e>>2]=f[c>>2];f[e+4>>2]=d;d=a+8|0;e=b+8|0;c=(a|0)==(b|0);if(!c){g=b+44|0;h=f[g>>2]|0;if(h|0){i=h+12|0;f[i>>2]=(f[i>>2]|0)+1}i=a+44|0;h=f[i>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)V$(d);f[i>>2]=0;h=a+24|0;j=a+12|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){k=f[a+48>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[j>>2]|0}while((l|0)<(m|0));f[d>>2]=f[e>>2];if((m|0)<3)n=12;else n=14}else{f[d>>2]=f[e>>2];n=12}if((n|0)==12){m=f[b+12>>2]|0;if((m|0)<3){f[j>>2]=m;f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];m=f[b+52>>2]|0;j=f[a+52>>2]|0;f[j>>2]=f[m>>2];f[j+4>>2]=f[m+4>>2]}else n=14}if((n|0)==14)U$(d,e);f[h>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];f[i>>2]=f[g>>2];g=a+64|0;i=b+64|0;if(!c){h=b+100|0;e=f[h>>2]|0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}d=a+100|0;e=f[d>>2]|0;if(e|0?(m=e+12|0,e=f[m>>2]|0,f[m>>2]=e+-1,(e|0)==1):0)V$(g);f[d>>2]=0;e=a+80|0;m=a+68|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){j=f[a+104>>2]|0;l=0;do{f[j+(l<<2)>>2]=0;l=l+1|0;o=f[m>>2]|0}while((l|0)<(o|0));f[g>>2]=f[i>>2];if((o|0)<3)n=26;else n=28}else{f[g>>2]=f[i>>2];n=26}if((n|0)==26){o=f[b+68>>2]|0;if((o|0)<3){f[m>>2]=o;f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];o=f[b+108>>2]|0;m=f[a+108>>2]|0;f[m>>2]=f[o>>2];f[m+4>>2]=f[o+4>>2]}else n=28}if((n|0)==28)U$(g,i);f[e>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];f[a+92>>2]=f[b+92>>2];f[a+96>>2]=f[b+96>>2];f[d>>2]=f[h>>2];h=a+120|0;d=b+120|0;if(!c){c=b+156|0;e=f[c>>2]|0;if(e|0){i=e+12|0;f[i>>2]=(f[i>>2]|0)+1}i=a+156|0;e=f[i>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(h);f[i>>2]=0;e=a+136|0;g=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){o=f[a+160>>2]|0;m=0;do{f[o+(m<<2)>>2]=0;m=m+1|0;q=f[g>>2]|0}while((m|0)<(q|0));f[h>>2]=f[d>>2];if((q|0)<3)n=40;else n=42}else{f[h>>2]=f[d>>2];n=40}if((n|0)==40){q=f[b+124>>2]|0;if((q|0)<3){f[g>>2]=q;f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];q=f[b+164>>2]|0;g=f[a+164>>2]|0;f[g>>2]=f[q>>2];f[g+4>>2]=f[q+4>>2]}else n=42}if((n|0)==42)U$(h,d);f[e>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];f[a+148>>2]=f[b+148>>2];f[a+152>>2]=f[b+152>>2];f[i>>2]=f[c>>2]}}}c=a+176|0;i=b+176|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];p[a+192>>3]=+p[b+192>>3];p[a+200>>3]=+p[b+200>>3];p[a+208>>3]=+p[b+208>>3];p[a+216>>3]=+p[b+216>>3];return a|0}function n_(a){a=a|0;cYc(a);return}function o_(a,b){a=a|0;b=b|0;return 1}function p_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0.0,x=0.0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;n=b+64|0;q=b+192|0;a:do if(!(f[b+80>>2]|0)){do if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){r=+p[b+176>>3];if((f[o+16>>2]|0)==(f[c+16>>2]|0)?!(+L(+r)!=1.0):0)break;s=g+8|0;f[s>>2]=0;f[s+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dY(b+8|0,g,d,r,+p[q>>3]);break a}while(0);r=+p[b+176>>3];if(r==1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;E1(g,h,i,fT()|0,-1);t=38;break}if(r==-1.0){f[g>>2]=-1056833530;f[g+4>>2]=q;f[g+8>>2]=1;f[g+12>>2]=4;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;G1(g,h,i,fT()|0,-1);t=38;break}else{s=b+8|0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;dY(s,g,f[s>>2]&4095,r,0.0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;E1(g,h,i,fT()|0,-1);t=38;break}}else{r=+p[q>>3];w=+p[b+200>>3];if(r==0.0&w==0.0?+p[b+208>>3]==0.0:0){if(w==0.0?+p[b+216>>3]!=0.0:0)t=9}else t=8;if((t|0)==8?w==0.0:0)t=9;if(((t|0)==9?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;w=+p[b+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;x=+p[b+184>>3];s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;L1(g,w,h,x,r,i,-1);t=38;break}r=+p[b+176>>3];x=+p[b+184>>3];s=x==1.0;do if(r==1.0){if(s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;E1(g,h,i,fT()|0,-1);break}if(x==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;G1(g,h,i,fT()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;TY(g,x,h,i);break}}else{if(!s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;L1(g,r,h,x,0.0,i,-1);break}if(r==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;G1(g,h,i,fT()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;TY(g,r,h,i);break}}while(0);if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){t=38;break}f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;E1(g,h,i,fT()|0,-1);t=38}while(0);if((t|0)==38?(f[o+16>>2]|0)!=(f[c+16>>2]|0):0){t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dY(o,g,f[c>>2]&4095,1.0,0.0)}c=e+36|0;g=f[c>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[j>>2]|0)>0){c=f[l>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}wL(j);u=a;return}function q_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;m_(d,b)|0;b=d+192|0;p[b>>3]=+p[c>>3]+ +p[b>>3];b=d+200|0;p[b>>3]=+p[c+8>>3]+ +p[b>>3];b=d+208|0;p[b>>3]=+p[c+16>>3]+ +p[b>>3];b=d+216|0;p[b>>3]=+p[c+24>>3]+ +p[b>>3];return}function r_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0,f=0,g=0.0,h=0,i=0.0;m_(d,c)|0;c=d+176|0;p[c>>3]=-+p[c>>3];c=d+184|0;p[c>>3]=-+p[c>>3];c=d+192|0;a=d+200|0;e=+p[b+8>>3]-+p[a>>3];f=d+208|0;g=+p[b+16>>3]-+p[f>>3];h=d+216|0;i=+p[b+24>>3]-+p[h>>3];p[c>>3]=+p[b>>3]-+p[c>>3];p[a>>3]=e;p[f>>3]=g;p[h>>3]=i;return}function s_(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;m_(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;b=d+192|0;p[b>>3]=+p[b>>3]*c;b=d+200|0;p[b>>3]=+p[b>>3]*c;b=d+208|0;p[b>>3]=+p[b>>3]*c;b=d+216|0;p[b>>3]=+p[b>>3]*c;return}function t_(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;e=a;do if((f[c>>2]|0)==38384){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){g=c+8|0;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;k=e+48|0;l=e+44|0;f[l>>2]=k;f[k>>2]=0;f[e+52>>2]=0;y_(d,47,g,e,b/+p[c+176>>3]);m=e+36|0;n=f[m>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)V$(e);f[m>>2]=0;m=e+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[h>>2]|0)>0){m=f[j>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[h>>2]|0))}h=f[l>>2]|0;if((h|0)!=(k|0))wL(h);u=a;return}}while(0);MZ(0,b,c,d);u=a;return}function u_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0;a=u;u=u+32|0;d=a;e=b+64|0;g=(f[b+80>>2]|0)!=0;if(g?(h=+p[b+184>>3],!(h==0.0)):0){i=h;j=+p[b+176>>3];k=8}else k=4;do if((k|0)==4){h=+p[b+176>>3];if(+L(+h)==1.0){l=-(+p[b+200>>3]*h);m=-(+p[b+208>>3]*h);n=-(+p[b+216>>3]*h);p[d>>3]=-(+p[b+192>>3]*h);p[d+8>>3]=l;p[d+16>>3]=m;p[d+24>>3]=n;x_(c,97,b+8|0,d);u=a;return}else{if(!g)break;i=+p[b+184>>3];j=h;k=8;break}}while(0);if((k|0)==8?j+i==0.0&j*i==-1.0:0){y_(c,97,b+8|0,e,1.0);u=a;return}NZ(0,b,c);u=a;return}function v_(a,b,c){a=a|0;b=b|0;c=c|0;do if((f[b>>2]|0)==38384){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){w_(c,b+8|0,+p[b+176>>3]);return}}while(0);OZ(0,b,c);return}function w_(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;q=h+4|0;r=h+8|0;s=h+40|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;r=h+48|0;t=h+44|0;f[t>>2]=r;f[r>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;UZ(e,38380,0,b,g,h,c,0.0,i);i=e;b=f[i+4>>2]|0;v=a;f[v>>2]=f[i>>2];f[v+4>>2]=b;b=a+8|0;v=(e|0)==(a|0);if(!v){i=a+44|0;w=f[i>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)V$(b);f[i>>2]=0;w=a+24|0;x=a+12|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){y=f[a+48>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}z=e+8|0;f[b>>2]=f[z>>2];b=e+12|0;y=f[b>>2]|0;f[x>>2]=y;x=e+16|0;A=a+16|0;f[A>>2]=f[x>>2];f[a+20>>2]=f[e+20>>2];f[w>>2]=f[e+24>>2];f[a+28>>2]=f[e+28>>2];f[a+32>>2]=f[e+32>>2];f[a+36>>2]=f[e+36>>2];f[a+40>>2]=f[e+40>>2];f[i>>2]=f[e+44>>2];i=a+52|0;w=f[i>>2]|0;B=a+56|0;if((w|0)==(B|0)){C=y;D=w}else{wL(w);f[i>>2]=B;f[a+48>>2]=A;C=f[b>>2]|0;D=B}B=e+52|0;if((C|0)<3){C=f[B>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2]}else{f[i>>2]=f[B>>2];i=e+48|0;f[a+48>>2]=f[i>>2];f[B>>2]=e+56;f[i>>2]=x}f[z>>2]=1124007936;m=b;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));b=a+64|0;if(!v){z=a+100|0;x=f[z>>2]|0;if(x|0?(i=x+12|0,x=f[i>>2]|0,f[i>>2]=x+-1,(x|0)==1):0)V$(b);f[z>>2]=0;x=a+80|0;i=a+68|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[i>>2]|0)>0){B=f[a+104>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[i>>2]|0))}C=e+64|0;f[b>>2]=f[C>>2];b=e+68|0;B=f[b>>2]|0;f[i>>2]=B;i=e+72|0;D=a+72|0;f[D>>2]=f[i>>2];f[a+76>>2]=f[e+76>>2];f[x>>2]=f[e+80>>2];f[a+84>>2]=f[e+84>>2];f[a+88>>2]=f[e+88>>2];f[a+92>>2]=f[e+92>>2];f[a+96>>2]=f[e+96>>2];f[z>>2]=f[e+100>>2];z=a+108|0;x=f[z>>2]|0;A=a+112|0;if((x|0)==(A|0)){E=B;F=x}else{wL(x);f[z>>2]=A;f[a+104>>2]=D;E=f[b>>2]|0;F=A}A=e+108|0;if((E|0)<3){E=f[A>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2]}else{f[z>>2]=f[A>>2];z=e+104|0;f[a+104>>2]=f[z>>2];f[A>>2]=e+112;f[z>>2]=i}f[C>>2]=1124007936;m=b;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));b=a+120|0;if(!v){v=a+156|0;C=f[v>>2]|0;if(C|0?(i=C+12|0,C=f[i>>2]|0,f[i>>2]=C+-1,(C|0)==1):0)V$(b);f[v>>2]=0;C=a+136|0;i=a+124|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[i>>2]|0)>0){z=f[a+160>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[i>>2]|0))}A=e+120|0;f[b>>2]=f[A>>2];b=e+124|0;z=f[b>>2]|0;f[i>>2]=z;i=e+128|0;E=a+128|0;f[E>>2]=f[i>>2];f[a+132>>2]=f[e+132>>2];f[C>>2]=f[e+136>>2];f[a+140>>2]=f[e+140>>2];f[a+144>>2]=f[e+144>>2];f[a+148>>2]=f[e+148>>2];f[a+152>>2]=f[e+152>>2];f[v>>2]=f[e+156>>2];v=a+164|0;C=f[v>>2]|0;F=a+168|0;if((C|0)==(F|0)){G=z;H=C}else{wL(C);f[v>>2]=F;f[a+160>>2]=E;G=f[b>>2]|0;H=F}F=e+164|0;if((G|0)<3){G=f[F>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2]}else{f[v>>2]=f[F>>2];v=e+160|0;f[a+160>>2]=f[v>>2];f[F>>2]=e+168;f[v>>2]=i}f[A>>2]=1124007936;m=b;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0))}}}m=a+176|0;n=e+176|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];p[a+192>>3]=+p[e+192>>3];p[a+200>>3]=+p[e+200>>3];p[a+208>>3]=+p[e+208>>3];p[a+216>>3]=+p[e+216>>3];Zj(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)V$(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;s=0;do{f[e+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[t>>2]|0;if((q|0)!=(r|0))wL(q);q=g+36|0;r=f[q>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)V$(g);f[q>>2]=0;q=g+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[l>>2]|0;l=0;do{f[q+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}wL(j);u=d;return}function x_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+336|0;g=e;h=e+280|0;i=e+224|0;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;o=h+44|0;f[o>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;r=i+48|0;t=i+44|0;f[t>>2]=r;f[r>>2]=0;f[i+52>>2]=0;UZ(g,38624,b<<24>>24,c,h,i,1.0,0.0,d);d=g;c=f[d+4>>2]|0;b=a;f[b>>2]=f[d>>2];f[b+4>>2]=c;c=a+8|0;b=(g|0)==(a|0);if(!b){d=a+44|0;v=f[d>>2]|0;if(v|0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0)V$(c);f[d>>2]=0;v=a+24|0;w=a+12|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){x=f[a+48>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}y=g+8|0;f[c>>2]=f[y>>2];c=g+12|0;x=f[c>>2]|0;f[w>>2]=x;w=g+16|0;z=a+16|0;f[z>>2]=f[w>>2];f[a+20>>2]=f[g+20>>2];f[v>>2]=f[g+24>>2];f[a+28>>2]=f[g+28>>2];f[a+32>>2]=f[g+32>>2];f[a+36>>2]=f[g+36>>2];f[a+40>>2]=f[g+40>>2];f[d>>2]=f[g+44>>2];d=a+52|0;v=f[d>>2]|0;A=a+56|0;if((v|0)==(A|0)){B=x;C=v}else{wL(v);f[d>>2]=A;f[a+48>>2]=z;B=f[c>>2]|0;C=A}A=g+52|0;if((B|0)<3){B=f[A>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2]}else{f[d>>2]=f[A>>2];d=g+48|0;f[a+48>>2]=f[d>>2];f[A>>2]=g+56;f[d>>2]=w}f[y>>2]=1124007936;m=c;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));c=a+64|0;if(!b){y=a+100|0;w=f[y>>2]|0;if(w|0?(d=w+12|0,w=f[d>>2]|0,f[d>>2]=w+-1,(w|0)==1):0)V$(c);f[y>>2]=0;w=a+80|0;d=a+68|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){A=f[a+104>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[d>>2]|0))}B=g+64|0;f[c>>2]=f[B>>2];c=g+68|0;A=f[c>>2]|0;f[d>>2]=A;d=g+72|0;C=a+72|0;f[C>>2]=f[d>>2];f[a+76>>2]=f[g+76>>2];f[w>>2]=f[g+80>>2];f[a+84>>2]=f[g+84>>2];f[a+88>>2]=f[g+88>>2];f[a+92>>2]=f[g+92>>2];f[a+96>>2]=f[g+96>>2];f[y>>2]=f[g+100>>2];y=a+108|0;w=f[y>>2]|0;z=a+112|0;if((w|0)==(z|0)){D=A;E=w}else{wL(w);f[y>>2]=z;f[a+104>>2]=C;D=f[c>>2]|0;E=z}z=g+108|0;if((D|0)<3){D=f[z>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[y>>2]=f[z>>2];y=g+104|0;f[a+104>>2]=f[y>>2];f[z>>2]=g+112;f[y>>2]=d}f[B>>2]=1124007936;m=c;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));c=a+120|0;if(!b){b=a+156|0;B=f[b>>2]|0;if(B|0?(d=B+12|0,B=f[d>>2]|0,f[d>>2]=B+-1,(B|0)==1):0)V$(c);f[b>>2]=0;B=a+136|0;d=a+124|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[d>>2]|0)>0){y=f[a+160>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[d>>2]|0))}z=g+120|0;f[c>>2]=f[z>>2];c=g+124|0;y=f[c>>2]|0;f[d>>2]=y;d=g+128|0;D=a+128|0;f[D>>2]=f[d>>2];f[a+132>>2]=f[g+132>>2];f[B>>2]=f[g+136>>2];f[a+140>>2]=f[g+140>>2];f[a+144>>2]=f[g+144>>2];f[a+148>>2]=f[g+148>>2];f[a+152>>2]=f[g+152>>2];f[b>>2]=f[g+156>>2];b=a+164|0;B=f[b>>2]|0;E=a+168|0;if((B|0)==(E|0)){F=y;G=B}else{wL(B);f[b>>2]=E;f[a+160>>2]=D;F=f[c>>2]|0;G=E}E=g+164|0;if((F|0)<3){F=f[E>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2]}else{f[b>>2]=f[E>>2];b=g+160|0;f[a+160>>2]=f[b>>2];f[E>>2]=g+168;f[b>>2]=d}f[z>>2]=1124007936;m=c;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0))}}}m=a+176|0;n=g+176|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];p[a+192>>3]=+p[g+192>>3];p[a+200>>3]=+p[g+200>>3];p[a+208>>3]=+p[g+208>>3];p[a+216>>3]=+p[g+216>>3];Zj(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)V$(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[t>>2]|0;if((q|0)!=(r|0))wL(q);q=h+36|0;r=f[q>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)V$(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[l>>2]|0;l=0;do{f[q+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=e;return}wL(j);u=e;return}function y_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+320|0;h=g+32|0;i=g+256|0;j=g;f[i>>2]=1124007936;k=i+4|0;l=i+8|0;m=i+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=i+48|0;q=i+44|0;f[q>>2]=l;f[l>>2]=0;f[i+52>>2]=0;r=f[d+16>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;UZ(h,38624,b<<24>>24,c,d,i,e,+((r|0)!=0&1),j);j=h;r=f[j+4>>2]|0;d=a;f[d>>2]=f[j>>2];f[d+4>>2]=r;r=a+8|0;d=(h|0)==(a|0);if(!d){j=a+44|0;c=f[j>>2]|0;if(c|0?(b=c+12|0,c=f[b>>2]|0,f[b>>2]=c+-1,(c|0)==1):0)V$(r);f[j>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){s=f[a+48>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[b>>2]|0))}t=h+8|0;f[r>>2]=f[t>>2];r=h+12|0;s=f[r>>2]|0;f[b>>2]=s;b=h+16|0;v=a+16|0;f[v>>2]=f[b>>2];f[a+20>>2]=f[h+20>>2];f[c>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];f[a+36>>2]=f[h+36>>2];f[a+40>>2]=f[h+40>>2];f[j>>2]=f[h+44>>2];j=a+52|0;c=f[j>>2]|0;w=a+56|0;if((c|0)==(w|0)){x=s;y=c}else{wL(c);f[j>>2]=w;f[a+48>>2]=v;x=f[r>>2]|0;y=w}w=h+52|0;if((x|0)<3){x=f[w>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2]}else{f[j>>2]=f[w>>2];j=h+48|0;f[a+48>>2]=f[j>>2];f[w>>2]=h+56;f[j>>2]=b}f[t>>2]=1124007936;n=r;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));r=a+64|0;if(!d){t=a+100|0;b=f[t>>2]|0;if(b|0?(j=b+12|0,b=f[j>>2]|0,f[j>>2]=b+-1,(b|0)==1):0)V$(r);f[t>>2]=0;b=a+80|0;j=a+68|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){w=f[a+104>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[j>>2]|0))}x=h+64|0;f[r>>2]=f[x>>2];r=h+68|0;w=f[r>>2]|0;f[j>>2]=w;j=h+72|0;y=a+72|0;f[y>>2]=f[j>>2];f[a+76>>2]=f[h+76>>2];f[b>>2]=f[h+80>>2];f[a+84>>2]=f[h+84>>2];f[a+88>>2]=f[h+88>>2];f[a+92>>2]=f[h+92>>2];f[a+96>>2]=f[h+96>>2];f[t>>2]=f[h+100>>2];t=a+108|0;b=f[t>>2]|0;v=a+112|0;if((b|0)==(v|0)){z=w;A=b}else{wL(b);f[t>>2]=v;f[a+104>>2]=y;z=f[r>>2]|0;A=v}v=h+108|0;if((z|0)<3){z=f[v>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2]}else{f[t>>2]=f[v>>2];t=h+104|0;f[a+104>>2]=f[t>>2];f[v>>2]=h+112;f[t>>2]=j}f[x>>2]=1124007936;n=r;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));r=a+120|0;if(!d){d=a+156|0;x=f[d>>2]|0;if(x|0?(j=x+12|0,x=f[j>>2]|0,f[j>>2]=x+-1,(x|0)==1):0)V$(r);f[d>>2]=0;x=a+136|0;j=a+124|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[j>>2]|0)>0){t=f[a+160>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[j>>2]|0))}v=h+120|0;f[r>>2]=f[v>>2];r=h+124|0;t=f[r>>2]|0;f[j>>2]=t;j=h+128|0;z=a+128|0;f[z>>2]=f[j>>2];f[a+132>>2]=f[h+132>>2];f[x>>2]=f[h+136>>2];f[a+140>>2]=f[h+140>>2];f[a+144>>2]=f[h+144>>2];f[a+148>>2]=f[h+148>>2];f[a+152>>2]=f[h+152>>2];f[d>>2]=f[h+156>>2];d=a+164|0;x=f[d>>2]|0;A=a+168|0;if((x|0)==(A|0)){B=t;C=x}else{wL(x);f[d>>2]=A;f[a+160>>2]=z;B=f[r>>2]|0;C=A}A=h+164|0;if((B|0)<3){B=f[A>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2]}else{f[d>>2]=f[A>>2];d=h+160|0;f[a+160>>2]=f[d>>2];f[A>>2]=h+168;f[d>>2]=j}f[v>>2]=1124007936;n=r;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0))}}}n=a+176|0;o=h+176|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];p[a+192>>3]=+p[h+192>>3];p[a+200>>3]=+p[h+200>>3];p[a+208>>3]=+p[h+208>>3];p[a+216>>3]=+p[h+216>>3];Zj(h);h=i+36|0;a=f[h>>2]|0;if(a|0?(o=a+12|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)V$(i);f[h>>2]=0;h=i+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[m>>2]|0;m=0;do{f[h+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(l|0)){u=g;return}wL(k);u=g;return}function z_(a){a=a|0;cYc(a);return}function A_(a,b){a=a|0;b=b|0;return 1}function B_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0;a=u;u=u+112|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=g+48|0;q=g+44|0;f[q>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if((e|0)!=-1?(f[c+8>>2]&4095|0)!=(e|0):0)r=g;else r=d;a:do switch(f[c+4>>2]|0){case 42:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;I1(h,i,j,+p[c+176>>3],-1);break}case 47:{if(!(f[c+80>>2]|0)){t=+p[c+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;K1(t,h,i,-1);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;J1(h,i,j,+p[c+176>>3],-1);break a}break}case 38:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;v1(h,i,j,fT()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;v1(h,i,j,fT()|0);break a}break}case 124:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;x1(h,i,j,fT()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;x1(h,i,j,fT()|0);break a}break}case 94:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;y1(h,i,j,fT()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;y1(h,i,j,fT()|0);break a}break}case 126:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;z1(h,i,fT()|0);break a}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(32)|0;f[h>>2]=v;w=h+8|0;f[w>>2]=-2147483616;x=h+4|0;f[x>>2]=17;n=v;y=237045;o=n+17|0;do{b[n>>0]=b[y>>0]|0;n=n+1|0;y=y+1|0}while((n|0)<(o|0));z=v+17|0;b[z>>0]=0;vM(-2,h,236898,236905,1371)}break}case 109:{D1(c+8|0,c+64|0,r);break}case 110:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;B1(h,i,j);break}case 77:{C1(c+8|0,c+64|0,r);break}case 78:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;A1(h,i,j);break}case 97:{if(f[c+80>>2]|0){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;H1(h,i,j);break a}if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;H1(h,i,j);break a}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(32)|0;f[h>>2]=v;w=h+8|0;f[w>>2]=-2147483616;x=h+4|0;f[x>>2]=17;n=v;y=237045;o=n+17|0;do{b[n>>0]=b[y>>0]|0;n=n+1|0;y=y+1|0}while((n|0)<(o|0));z=v+17|0;b[z>>0]=0;vM(-2,h,236898,236905,1371)}break}default:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(32)|0;f[h>>2]=v;w=h+8|0;f[w>>2]=-2147483616;x=h+4|0;f[x>>2]=17;n=v;y=237045;o=n+17|0;do{b[n>>0]=b[y>>0]|0;n=n+1|0;y=y+1|0}while((n|0)<(o|0));z=v+17|0;b[z>>0]=0;vM(-2,h,236898,236905,1371)}}while(0);if((f[r+16>>2]|0)!=(f[d+16>>2]|0)){z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;dY(r,h,e,1.0,0.0)}e=g+36|0;h=f[e>>2]|0;if(h|0?(r=h+12|0,h=f[r>>2]|0,f[r>>2]=h+-1,(h|0)==1):0)V$(g);f[e>>2]=0;e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[k>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(l|0)){u=a;return}wL(k);u=a;return}function C_(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;switch(f[b+4>>2]|0){case 47:case 42:{m_(d,b)|0;a=d+176|0;p[a>>3]=+p[a>>3]*c;return}default:{KZ(0,b,c,d);return}}}function D_(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0;a=u;u=u+96|0;e=a+32|0;g=a;do if((f[c+4>>2]|0)==47){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;k=e+48|0;l=e+44|0;f[l>>2]=k;f[k>>2]=0;f[e+52>>2]=0;m=+p[c+176>>3];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;E_(d,c+8|0,e,b/m,0.0,g);n=e+36|0;o=f[n>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)V$(e);f[n>>2]=0;n=e+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[h>>2]|0)>0){n=f[j>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[h>>2]|0))}h=f[l>>2]|0;if((h|0)!=(k|0))wL(h);u=a;return}while(0);MZ(0,b,c,d);u=a;return}function E_(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+288|0;i=h;j=h+224|0;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;q=j+44|0;f[q>>2]=l;f[l>>2]=0;f[j+52>>2]=0;UZ(i,38384,0,b,c,j,d,e,g);g=i;c=f[g+4>>2]|0;b=a;f[b>>2]=f[g>>2];f[b+4>>2]=c;c=a+8|0;b=(i|0)==(a|0);if(!b){g=a+44|0;r=f[g>>2]|0;if(r|0?(s=r+12|0,r=f[s>>2]|0,f[s>>2]=r+-1,(r|0)==1):0)V$(c);f[g>>2]=0;r=a+24|0;s=a+12|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){t=f[a+48>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}v=i+8|0;f[c>>2]=f[v>>2];c=i+12|0;t=f[c>>2]|0;f[s>>2]=t;s=i+16|0;w=a+16|0;f[w>>2]=f[s>>2];f[a+20>>2]=f[i+20>>2];f[r>>2]=f[i+24>>2];f[a+28>>2]=f[i+28>>2];f[a+32>>2]=f[i+32>>2];f[a+36>>2]=f[i+36>>2];f[a+40>>2]=f[i+40>>2];f[g>>2]=f[i+44>>2];g=a+52|0;r=f[g>>2]|0;x=a+56|0;if((r|0)==(x|0)){y=t;z=r}else{wL(r);f[g>>2]=x;f[a+48>>2]=w;y=f[c>>2]|0;z=x}x=i+52|0;if((y|0)<3){y=f[x>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2]}else{f[g>>2]=f[x>>2];g=i+48|0;f[a+48>>2]=f[g>>2];f[x>>2]=i+56;f[g>>2]=s}f[v>>2]=1124007936;n=c;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));c=a+64|0;if(!b){v=a+100|0;s=f[v>>2]|0;if(s|0?(g=s+12|0,s=f[g>>2]|0,f[g>>2]=s+-1,(s|0)==1):0)V$(c);f[v>>2]=0;s=a+80|0;g=a+68|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[g>>2]|0)>0){x=f[a+104>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[g>>2]|0))}y=i+64|0;f[c>>2]=f[y>>2];c=i+68|0;x=f[c>>2]|0;f[g>>2]=x;g=i+72|0;z=a+72|0;f[z>>2]=f[g>>2];f[a+76>>2]=f[i+76>>2];f[s>>2]=f[i+80>>2];f[a+84>>2]=f[i+84>>2];f[a+88>>2]=f[i+88>>2];f[a+92>>2]=f[i+92>>2];f[a+96>>2]=f[i+96>>2];f[v>>2]=f[i+100>>2];v=a+108|0;s=f[v>>2]|0;w=a+112|0;if((s|0)==(w|0)){A=x;B=s}else{wL(s);f[v>>2]=w;f[a+104>>2]=z;A=f[c>>2]|0;B=w}w=i+108|0;if((A|0)<3){A=f[w>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2]}else{f[v>>2]=f[w>>2];v=i+104|0;f[a+104>>2]=f[v>>2];f[w>>2]=i+112;f[v>>2]=g}f[y>>2]=1124007936;n=c;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));c=a+120|0;if(!b){b=a+156|0;y=f[b>>2]|0;if(y|0?(g=y+12|0,y=f[g>>2]|0,f[g>>2]=y+-1,(y|0)==1):0)V$(c);f[b>>2]=0;y=a+136|0;g=a+124|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[g>>2]|0)>0){v=f[a+160>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[g>>2]|0))}w=i+120|0;f[c>>2]=f[w>>2];c=i+124|0;v=f[c>>2]|0;f[g>>2]=v;g=i+128|0;A=a+128|0;f[A>>2]=f[g>>2];f[a+132>>2]=f[i+132>>2];f[y>>2]=f[i+136>>2];f[a+140>>2]=f[i+140>>2];f[a+144>>2]=f[i+144>>2];f[a+148>>2]=f[i+148>>2];f[a+152>>2]=f[i+152>>2];f[b>>2]=f[i+156>>2];b=a+164|0;y=f[b>>2]|0;B=a+168|0;if((y|0)==(B|0)){C=v;D=y}else{wL(y);f[b>>2]=B;f[a+160>>2]=A;C=f[c>>2]|0;D=B}B=i+164|0;if((C|0)<3){C=f[B>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2]}else{f[b>>2]=f[B>>2];b=i+160|0;f[a+160>>2]=f[b>>2];f[B>>2]=i+168;f[b>>2]=g}f[w>>2]=1124007936;n=c;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0))}}}n=a+176|0;o=i+176|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];p[a+192>>3]=+p[i+192>>3];p[a+200>>3]=+p[i+200>>3];p[a+208>>3]=+p[i+208>>3];p[a+216>>3]=+p[i+216>>3];Zj(i);i=j+36|0;a=f[i>>2]|0;if(a|0?(o=a+12|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)V$(j);f[i>>2]=0;i=j+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[k>>2]|0)>0){i=f[m>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(l|0)){u=h;return}wL(k);u=h;return}function F_(a){a=a|0;cYc(a);return}function G_(a,b){a=a|0;b=b|0;return 0}function H_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;AV(g,h);o=+p[b+176>>3];if(o!=1.0?1:(f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dY(n,g,d,o,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)V$(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}wL(i);u=a;return}function I_(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;m_(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;return}function J_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0,k=0,l=0;a=u;u=u+96|0;d=a+32|0;e=a;g=+p[b+176>>3];h=b+8|0;if(g==1.0){K_(c,h);u=a;return}f[d>>2]=1124007936;b=d+4|0;i=d+8|0;j=d+40|0;k=b;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=d+48|0;k=d+44|0;f[k>>2]=i;f[i>>2]=0;f[d+52>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;E_(c,h,d,g,0.0,e);e=d+36|0;h=f[e>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)V$(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[j>>2]|0;j=0;do{f[e+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[b>>2]|0))}b=f[k>>2]|0;if((b|0)!=(i|0))wL(b);u=a;return}function K_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+368|0;d=c+32|0;e=c+312|0;g=c+256|0;h=c;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;n=e+44|0;f[n>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[g>>2]=1124007936;o=g+4|0;q=g+8|0;r=g+40|0;l=o;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[r>>2]=q;q=g+48|0;s=g+44|0;f[s>>2]=q;f[q>>2]=0;f[g+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;UZ(d,38140,0,b,e,g,1.0,0.0,h);h=d;b=f[h+4>>2]|0;t=a;f[t>>2]=f[h>>2];f[t+4>>2]=b;b=a+8|0;t=(d|0)==(a|0);if(!t){h=a+44|0;v=f[h>>2]|0;if(v|0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0)V$(b);f[h>>2]=0;v=a+24|0;w=a+12|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){x=f[a+48>>2]|0;y=0;do{f[x+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}y=d+8|0;f[b>>2]=f[y>>2];b=d+12|0;x=f[b>>2]|0;f[w>>2]=x;w=d+16|0;z=a+16|0;f[z>>2]=f[w>>2];f[a+20>>2]=f[d+20>>2];f[v>>2]=f[d+24>>2];f[a+28>>2]=f[d+28>>2];f[a+32>>2]=f[d+32>>2];f[a+36>>2]=f[d+36>>2];f[a+40>>2]=f[d+40>>2];f[h>>2]=f[d+44>>2];h=a+52|0;v=f[h>>2]|0;A=a+56|0;if((v|0)==(A|0)){B=x;C=v}else{wL(v);f[h>>2]=A;f[a+48>>2]=z;B=f[b>>2]|0;C=A}A=d+52|0;if((B|0)<3){B=f[A>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2]}else{f[h>>2]=f[A>>2];h=d+48|0;f[a+48>>2]=f[h>>2];f[A>>2]=d+56;f[h>>2]=w}f[y>>2]=1124007936;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));b=a+64|0;if(!t){y=a+100|0;w=f[y>>2]|0;if(w|0?(h=w+12|0,w=f[h>>2]|0,f[h>>2]=w+-1,(w|0)==1):0)V$(b);f[y>>2]=0;w=a+80|0;h=a+68|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[h>>2]|0)>0){A=f[a+104>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[h>>2]|0))}B=d+64|0;f[b>>2]=f[B>>2];b=d+68|0;A=f[b>>2]|0;f[h>>2]=A;h=d+72|0;C=a+72|0;f[C>>2]=f[h>>2];f[a+76>>2]=f[d+76>>2];f[w>>2]=f[d+80>>2];f[a+84>>2]=f[d+84>>2];f[a+88>>2]=f[d+88>>2];f[a+92>>2]=f[d+92>>2];f[a+96>>2]=f[d+96>>2];f[y>>2]=f[d+100>>2];y=a+108|0;w=f[y>>2]|0;z=a+112|0;if((w|0)==(z|0)){D=A;E=w}else{wL(w);f[y>>2]=z;f[a+104>>2]=C;D=f[b>>2]|0;E=z}z=d+108|0;if((D|0)<3){D=f[z>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[y>>2]=f[z>>2];y=d+104|0;f[a+104>>2]=f[y>>2];f[z>>2]=d+112;f[y>>2]=h}f[B>>2]=1124007936;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));b=a+120|0;if(!t){t=a+156|0;B=f[t>>2]|0;if(B|0?(h=B+12|0,B=f[h>>2]|0,f[h>>2]=B+-1,(B|0)==1):0)V$(b);f[t>>2]=0;B=a+136|0;h=a+124|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[h>>2]|0)>0){y=f[a+160>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[h>>2]|0))}z=d+120|0;f[b>>2]=f[z>>2];b=d+124|0;y=f[b>>2]|0;f[h>>2]=y;h=d+128|0;D=a+128|0;f[D>>2]=f[h>>2];f[a+132>>2]=f[d+132>>2];f[B>>2]=f[d+136>>2];f[a+140>>2]=f[d+140>>2];f[a+144>>2]=f[d+144>>2];f[a+148>>2]=f[d+148>>2];f[a+152>>2]=f[d+152>>2];f[t>>2]=f[d+156>>2];t=a+164|0;B=f[t>>2]|0;E=a+168|0;if((B|0)==(E|0)){F=y;G=B}else{wL(B);f[t>>2]=E;f[a+160>>2]=D;F=f[b>>2]|0;G=E}E=d+164|0;if((F|0)<3){F=f[E>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2]}else{f[t>>2]=f[E>>2];t=d+160|0;f[a+160>>2]=f[t>>2];f[E>>2]=d+168;f[t>>2]=h}f[z>>2]=1124007936;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0))}}}l=a+176|0;m=d+176|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];f[l+12>>2]=f[m+12>>2];p[a+192>>3]=+p[d+192>>3];p[a+200>>3]=+p[d+200>>3];p[a+208>>3]=+p[d+208>>3];p[a+216>>3]=+p[d+216>>3];Zj(d);d=g+36|0;a=f[d>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)V$(g);f[d>>2]=0;d=g+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[o>>2]|0)>0){d=f[r>>2]|0;r=0;do{f[d+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)!=(q|0))wL(o);o=e+36|0;q=f[o>>2]|0;if(q|0?(s=q+12|0,q=f[s>>2]|0,f[s>>2]=q+-1,(q|0)==1):0)V$(e);f[o>>2]=0;o=e+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[i>>2]|0)>0){o=f[k>>2]|0;k=0;do{f[o+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)==(j|0)){u=c;return}wL(i);u=c;return}function L_(a){a=a|0;cYc(a);return}function M_(a,b){a=a|0;b=b|0;return 1}function N_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;n=(d|0)==-1|(d|0)==0?c:e;if(!(f[b+80>>2]|0)){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=b+176;f[h+8>>2]=1;f[h+12>>2]=1;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;M1(g,h,i,f[b+4>>2]|0)}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;M1(g,h,i,f[b+4>>2]|0)}if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dY(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)V$(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}wL(j);u=a;return}function O_(a){a=a|0;cYc(a);return}function P_(a,b){a=a|0;b=b|0;return 0}function Q_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+64|0;g=a+32|0;h=a;i=(e|0)==-1?f[c+8>>2]&4095:e;e=c+12|0;j=f[e>>2]|0;k=f[c+48>>2]|0;do if((j|0)<3){l=f[k+4>>2]|0;m=f[k>>2]|0;n=i&4095;if(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(m|0):0)?(f[d+12>>2]|0)==(l|0):0)?(f[d>>2]&4095|0)==(n|0):0)?f[d+16>>2]|0:0)break;f[g>>2]=m;f[g+4>>2]=l;S$(d,2,g,n)}else S$(d,j,k,i);while(0);i=f[c+4>>2]|0;if((i|0)==73&(f[e>>2]|0)<3){e=g+8|0;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=d;p[h>>3]=+p[c+176>>3];e=h+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;yV(g,h);u=a;return}switch(i|0){case 48:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;lR(d,g)|0;u=a;return}case 49:{p[g>>3]=+p[c+176>>3];c=g+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;lR(d,g)|0;u=a;return}default:{a=$Xc(32)|0;f[g>>2]=a;f[g+8>>2]=-2147483616;f[g+4>>2]=31;d=a;c=237140;i=d+31|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(i|0));b[a+31>>0]=0;vM(-2,g,236898,236905,1606)}}}function R_(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;m_(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;return}function S_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=38140;f[a+4>>2]=0;c=a+8|0;f[c>>2]=f[b>>2];d=a+12|0;e=b+4|0;f[d>>2]=f[e>>2];g=a+16|0;f[g>>2]=f[b+8>>2];f[a+20>>2]=f[b+12>>2];f[a+24>>2]=f[b+16>>2];f[a+28>>2]=f[b+20>>2];f[a+32>>2]=f[b+24>>2];f[a+36>>2]=f[b+28>>2];f[a+40>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[a+44>>2]=h;f[a+48>>2]=g;g=a+56|0;i=a+52|0;f[i>>2]=g;f[g>>2]=0;f[a+60>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[d>>2]=0;U$(c,b)}f[a+64>>2]=1124007936;b=a+72|0;c=a+104|0;d=a+68|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+112|0;f[a+108>>2]=b;f[b>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;b=a+128|0;c=a+160|0;d=a+124|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+168|0;f[a+164>>2]=b;f[b>>2]=0;f[a+172>>2]=0;p[a+176>>3]=1.0;d=a+184|0;e=d+40|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function T_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;E_(a,c,e,1.0,0.0,b);b=e+36|0;c=f[b>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)V$(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[g>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}wL(g);u=d;return}function U_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ei[f[(f[g>>2]|0)+56>>2]&511](g,b,c,a);return}function V_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ei[f[(f[g>>2]|0)+52>>2]&511](g,b,c,a);return}function W_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;E_(a,b,c,1.0,-1.0,e);u=d;return}function X_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;E_(a,c,e,-1.0,0.0,b);b=e+36|0;c=f[b>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)V$(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[g>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}wL(g);u=d;return}function Y_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+224|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+60>>2]|0;S_(e,c);ei[j&511](i,b,e,a);Zj(e);u=d;return}function Z_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+56>>2]|0;k=-+p[c+8>>3];l=-+p[c+16>>3];m=-+p[c+24>>3];p[e>>3]=-+p[c>>3];p[e+8>>3]=k;p[e+16>>3]=l;p[e+24>>3]=m;ei[j&511](i,b,e,a);u=d;return}function __(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ei[f[(f[g>>2]|0)+60>>2]&511](g,b,c,a);return}function $_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+96|0;d=c+32|0;e=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[d>>2]=1124007936;g=d+4|0;h=d+8|0;k=d+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=d+48|0;i=d+44|0;f[i>>2]=h;f[h>>2]=0;f[d+52>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;E_(a,b,d,-1.0,0.0,e);e=d+36|0;b=f[e>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)V$(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[k>>2]|0;k=0;do{f[e+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=c;return}wL(g);u=c;return}function a$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));h=f[b>>2]|0;i=f[(f[h>>2]|0)+64>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;ei[i&511](h,d,b,a);u=c;return}function b$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;e_(a,0,b,c,1.0,e,1.0);c=e+36|0;b=f[c>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}wL(g);u=d;return}function c$(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;E_(a,b,e,c,0.0,g);g=e+36|0;b=f[g>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)V$(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}wL(h);u=d;return}function d$(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;E_(a,c,e,b,0.0,g);g=e+36|0;c=f[g>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)V$(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}wL(h);u=d;return}function e$(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;ri[f[(f[g>>2]|0)+72>>2]&15](g,b,c,a);return}function f$(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;y_(a,47,c,e,b);c=e+36|0;a=f[c>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}wL(g);u=d;return}function g$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+368|0;g=e+32|0;h=e+312|0;i=e+256|0;j=e;f[h>>2]=1124007936;k=h+4|0;l=h+8|0;m=h+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=h+48|0;q=h+44|0;f[q>>2]=l;f[l>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;r=i+4|0;s=i+8|0;t=i+40|0;n=r;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[t>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;UZ(g,39092,b,c,h,i,d,1.0,j);j=g;c=f[j+4>>2]|0;b=a;f[b>>2]=f[j>>2];f[b+4>>2]=c;c=a+8|0;b=(g|0)==(a|0);if(!b){j=a+44|0;w=f[j>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)V$(c);f[j>>2]=0;w=a+24|0;x=a+12|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){y=f[a+48>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}z=g+8|0;f[c>>2]=f[z>>2];c=g+12|0;y=f[c>>2]|0;f[x>>2]=y;x=g+16|0;A=a+16|0;f[A>>2]=f[x>>2];f[a+20>>2]=f[g+20>>2];f[w>>2]=f[g+24>>2];f[a+28>>2]=f[g+28>>2];f[a+32>>2]=f[g+32>>2];f[a+36>>2]=f[g+36>>2];f[a+40>>2]=f[g+40>>2];f[j>>2]=f[g+44>>2];j=a+52|0;w=f[j>>2]|0;B=a+56|0;if((w|0)==(B|0)){C=y;D=w}else{wL(w);f[j>>2]=B;f[a+48>>2]=A;C=f[c>>2]|0;D=B}B=g+52|0;if((C|0)<3){C=f[B>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2]}else{f[j>>2]=f[B>>2];j=g+48|0;f[a+48>>2]=f[j>>2];f[B>>2]=g+56;f[j>>2]=x}f[z>>2]=1124007936;n=c;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));c=a+64|0;if(!b){z=a+100|0;x=f[z>>2]|0;if(x|0?(j=x+12|0,x=f[j>>2]|0,f[j>>2]=x+-1,(x|0)==1):0)V$(c);f[z>>2]=0;x=a+80|0;j=a+68|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[j>>2]|0)>0){B=f[a+104>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}C=g+64|0;f[c>>2]=f[C>>2];c=g+68|0;B=f[c>>2]|0;f[j>>2]=B;j=g+72|0;D=a+72|0;f[D>>2]=f[j>>2];f[a+76>>2]=f[g+76>>2];f[x>>2]=f[g+80>>2];f[a+84>>2]=f[g+84>>2];f[a+88>>2]=f[g+88>>2];f[a+92>>2]=f[g+92>>2];f[a+96>>2]=f[g+96>>2];f[z>>2]=f[g+100>>2];z=a+108|0;x=f[z>>2]|0;A=a+112|0;if((x|0)==(A|0)){E=B;F=x}else{wL(x);f[z>>2]=A;f[a+104>>2]=D;E=f[c>>2]|0;F=A}A=g+108|0;if((E|0)<3){E=f[A>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2]}else{f[z>>2]=f[A>>2];z=g+104|0;f[a+104>>2]=f[z>>2];f[A>>2]=g+112;f[z>>2]=j}f[C>>2]=1124007936;n=c;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));c=a+120|0;if(!b){b=a+156|0;C=f[b>>2]|0;if(C|0?(j=C+12|0,C=f[j>>2]|0,f[j>>2]=C+-1,(C|0)==1):0)V$(c);f[b>>2]=0;C=a+136|0;j=a+124|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[j>>2]|0)>0){z=f[a+160>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[j>>2]|0))}A=g+120|0;f[c>>2]=f[A>>2];c=g+124|0;z=f[c>>2]|0;f[j>>2]=z;j=g+128|0;E=a+128|0;f[E>>2]=f[j>>2];f[a+132>>2]=f[g+132>>2];f[C>>2]=f[g+136>>2];f[a+140>>2]=f[g+140>>2];f[a+144>>2]=f[g+144>>2];f[a+148>>2]=f[g+148>>2];f[a+152>>2]=f[g+152>>2];f[b>>2]=f[g+156>>2];b=a+164|0;C=f[b>>2]|0;F=a+168|0;if((C|0)==(F|0)){G=z;H=C}else{wL(C);f[b>>2]=F;f[a+160>>2]=E;G=f[c>>2]|0;H=F}F=g+164|0;if((G|0)<3){G=f[F>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2]}else{f[b>>2]=f[F>>2];b=g+160|0;f[a+160>>2]=f[b>>2];f[F>>2]=g+168;f[b>>2]=j}f[A>>2]=1124007936;n=c;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0))}}}n=a+176|0;o=g+176|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];p[a+192>>3]=+p[g+192>>3];p[a+200>>3]=+p[g+200>>3];p[a+208>>3]=+p[g+208>>3];p[a+216>>3]=+p[g+216>>3];Zj(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(o=a+12|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)V$(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){g=f[t>>2]|0;t=0;do{f[g+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[v>>2]|0;if((r|0)!=(s|0))wL(r);r=h+36|0;s=f[r>>2]|0;if(s|0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0)V$(h);f[r>>2]=0;r=h+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(l|0)){u=e;return}wL(k);u=e;return}function h$(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g$(a,0,b,c);return}function i$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));y_(a,38,b,c,1.0);return}function j$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;x_(a,97,b,d);u=c;return}function k$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;if((c|0)==38380|(c|0)==38020){d=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=d;return}if((c|0)==38388){d=f[b+16>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if((c|0)==38144){d=f[b+20>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if(!(f[136179]|0)){d=cN()|0;YXc(d);if(!(f[136179]|0)){e=$Xc(4)|0;f[e>>2]=38984;f[136179]=e}ZXc(d)}if((f[136179]|0)==(c|0)){c=f[b+48>>2]|0;d=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=d;return}d=f[b>>2]|0;if(!d){f[a>>2]=0;f[a+4>>2]=0;return}else{Ti[f[(f[d>>2]|0)+100>>2]&511](a,d,b);return}}function l$(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(!(f[136179]|0)){c=cN()|0;YXc(c);if(!(f[136179]|0)){d=$Xc(4)|0;f[d>>2]=38984;f[136179]=d}ZXc(c)}if((f[136179]|0)==(b|0)){e=f[a+8>>2]&4095;return e|0}b=f[a>>2]|0;if((b|0)==39092){e=0;return e|0}if(!b){e=-1;return e|0}e=Mi[f[(f[b>>2]|0)+104>>2]&1023](b,a)|0;return e|0}function m$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;c=a+16|0;d=a+48|0;e=a+12|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+56|0;f[a+52>>2]=c;f[c>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;c=a+72|0;d=a+104|0;e=a+68|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+112|0;f[a+108>>2]=c;f[c>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;c=a+128|0;d=a+160|0;e=a+124|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+168|0;f[a+164>>2]=c;e=c;g=e+56|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));w_(a,b,1.0);return}function n$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));TZ(a,c,b);return}function o$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+224|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((eS(c)|0)==393216){j=f[c+4>>2]|0;k=f[j>>2]|0;h=f[(f[k>>2]|0)+68>>2]|0;S_(g,b);ni[h&31](k,g,j,a,d);Zj(g);u=e;return}do if((eS(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;h=j+4|0;f[k>>2]=f[h>>2];i=g+8|0;f[i>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];l=f[j+36>>2]|0;f[g+36>>2]=l;f[g+40>>2]=i;i=g+48|0;m=g+44|0;f[m>>2]=i;f[i>>2]=0;f[g+52>>2]=0;if(l|0){i=l+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[h>>2]|0)<3){h=f[j+44>>2]|0;i=f[m>>2]|0;f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];break}else{f[k>>2]=0;U$(g,j);break}}else bS(g,c,-1);while(0);y_(a,42,b,g,d);b=g+36|0;a=f[b>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)V$(g);f[b>>2]=0;b=g+16|0;a=g+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[a>>2]|0)>0){b=f[g+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))wL(a);u=e;return}function p$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=c;f[g+4>>2]=b;q$(a,48,g,d,1.0);u=e;return}function q$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+432|0;h=g+32|0;i=g+376|0;j=g+312|0;k=g+320|0;l=g+256|0;m=g;if(!(f[136179]|0)){n=cN()|0;YXc(n);if(!(f[136179]|0)){o=$Xc(4)|0;f[o>>2]=38984;f[136179]=o}ZXc(n)}n=f[136179]|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];cM(i,j,d,-286331154,0);f[k>>2]=1124007936;d=k+4|0;j=k+8|0;c=k+40|0;o=d;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[c>>2]=j;j=k+48|0;r=k+44|0;f[r>>2]=j;f[j>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;s=l+4|0;t=l+8|0;v=l+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[v>>2]=t;t=l+48|0;w=l+44|0;f[w>>2]=t;f[t>>2]=0;f[l+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;UZ(h,n,b,i,k,l,e,0.0,m);m=h;b=f[m+4>>2]|0;n=a;f[n>>2]=f[m>>2];f[n+4>>2]=b;b=a+8|0;n=(h|0)==(a|0);if(!n){m=a+44|0;x=f[m>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)V$(b);f[m>>2]=0;x=a+24|0;y=a+12|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){z=f[a+48>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[y>>2]|0))}A=h+8|0;f[b>>2]=f[A>>2];b=h+12|0;z=f[b>>2]|0;f[y>>2]=z;y=h+16|0;B=a+16|0;f[B>>2]=f[y>>2];f[a+20>>2]=f[h+20>>2];f[x>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];f[a+36>>2]=f[h+36>>2];f[a+40>>2]=f[h+40>>2];f[m>>2]=f[h+44>>2];m=a+52|0;x=f[m>>2]|0;C=a+56|0;if((x|0)==(C|0)){D=z;E=x}else{wL(x);f[m>>2]=C;f[a+48>>2]=B;D=f[b>>2]|0;E=C}C=h+52|0;if((D|0)<3){D=f[C>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[m>>2]=f[C>>2];m=h+48|0;f[a+48>>2]=f[m>>2];f[C>>2]=h+56;f[m>>2]=y}f[A>>2]=1124007936;o=b;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));b=a+64|0;if(!n){A=a+100|0;y=f[A>>2]|0;if(y|0?(m=y+12|0,y=f[m>>2]|0,f[m>>2]=y+-1,(y|0)==1):0)V$(b);f[A>>2]=0;y=a+80|0;m=a+68|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[m>>2]|0)>0){C=f[a+104>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[m>>2]|0))}D=h+64|0;f[b>>2]=f[D>>2];b=h+68|0;C=f[b>>2]|0;f[m>>2]=C;m=h+72|0;E=a+72|0;f[E>>2]=f[m>>2];f[a+76>>2]=f[h+76>>2];f[y>>2]=f[h+80>>2];f[a+84>>2]=f[h+84>>2];f[a+88>>2]=f[h+88>>2];f[a+92>>2]=f[h+92>>2];f[a+96>>2]=f[h+96>>2];f[A>>2]=f[h+100>>2];A=a+108|0;y=f[A>>2]|0;B=a+112|0;if((y|0)==(B|0)){F=C;G=y}else{wL(y);f[A>>2]=B;f[a+104>>2]=E;F=f[b>>2]|0;G=B}B=h+108|0;if((F|0)<3){F=f[B>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2]}else{f[A>>2]=f[B>>2];A=h+104|0;f[a+104>>2]=f[A>>2];f[B>>2]=h+112;f[A>>2]=m}f[D>>2]=1124007936;o=b;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));b=a+120|0;if(!n){n=a+156|0;D=f[n>>2]|0;if(D|0?(m=D+12|0,D=f[m>>2]|0,f[m>>2]=D+-1,(D|0)==1):0)V$(b);f[n>>2]=0;D=a+136|0;m=a+124|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){A=f[a+160>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[m>>2]|0))}B=h+120|0;f[b>>2]=f[B>>2];b=h+124|0;A=f[b>>2]|0;f[m>>2]=A;m=h+128|0;F=a+128|0;f[F>>2]=f[m>>2];f[a+132>>2]=f[h+132>>2];f[D>>2]=f[h+136>>2];f[a+140>>2]=f[h+140>>2];f[a+144>>2]=f[h+144>>2];f[a+148>>2]=f[h+148>>2];f[a+152>>2]=f[h+152>>2];f[n>>2]=f[h+156>>2];n=a+164|0;D=f[n>>2]|0;G=a+168|0;if((D|0)==(G|0)){H=A;I=D}else{wL(D);f[n>>2]=G;f[a+160>>2]=F;H=f[b>>2]|0;I=G}G=h+164|0;if((H|0)<3){H=f[G>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2]}else{f[n>>2]=f[G>>2];n=h+160|0;f[a+160>>2]=f[n>>2];f[G>>2]=h+168;f[n>>2]=m}f[B>>2]=1124007936;o=b;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0))}}}o=a+176|0;q=h+176|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2];f[o+8>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];p[a+192>>3]=+p[h+192>>3];p[a+200>>3]=+p[h+200>>3];p[a+208>>3]=+p[h+208>>3];p[a+216>>3]=+p[h+216>>3];Zj(h);h=l+36|0;a=f[h>>2]|0;if(a|0?(q=a+12|0,a=f[q>>2]|0,f[q>>2]=a+-1,(a|0)==1):0)V$(l);f[h>>2]=0;h=l+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[s>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[w>>2]|0;if((s|0)!=(t|0))wL(s);s=k+36|0;t=f[s>>2]|0;if(t|0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)V$(k);f[s>>2]=0;s=k+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[d>>2]|0)>0){s=f[c>>2]|0;c=0;do{f[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[r>>2]|0;if((d|0)!=(j|0))wL(d);d=i+36|0;j=f[d>>2]|0;if(j|0?(r=j+12|0,j=f[r>>2]|0,f[r>>2]=j+-1,(j|0)==1):0)V$(i);f[d>>2]=0;d=i+16|0;j=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[i+40>>2]|0;r=0;do{f[d+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=g;return}wL(j);u=g;return}function r$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];q$(a,48,e,c,1.0);u=d;return}function s$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=c;f[g+4>>2]=b;q$(a,49,g,d,1.0);u=e;return}function t$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];q$(a,49,e,c,1.0);u=d;return}function u$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=c;f[g+4>>2]=b;q$(a,73,g,d,1.0);u=e;return}function v$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];q$(a,73,e,c,1.0);u=d;return}function w$(a){a=a|0;return}function x$(a,b,c){a=a|0;b=b|0;c=c|0;return}function y$(a,b){a=a|0;b=b|0;if(f[b+8>>2]|0)return;if(f[b+12>>2]|0)return;mi[f[(f[a>>2]|0)+16>>2]&2047](a,b);return}function z$(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;if(!h){r=0;while(1){s=f[g+(r<<2)>>2]|0;if((s|0)<=-1)break;if(!s)break a;f[k+(r<<2)>>2]=s;r=r+1|0;if((r|0)>=(e|0)){t=q;v=13;break a}}w=$Xc(32)|0;f[l>>2]=w;x=l+8|0;f[x>>2]=-2147483616;y=l+4|0;f[y>>2]=24;z=w;A=237230;B=z+24|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+24|0;b[C>>0]=0;vM(-215,l,237563,237260,33)}else{D=q;E=0}while(1){r=f[g+(E<<2)>>2]|0;if((r|0)<=-1)break;if(!r)break a;if((E|0)>(c|0))F=1;else F=f[i+(E<<2)>>2]|0;s=D+(Y(F,f[h+(E<<2)>>2]|0)|0)|0;f[k+(E<<2)>>2]=r;E=E+1|0;if((E|0)>=(e|0)){t=s;v=13;break a}else D=s}w=$Xc(32)|0;f[l>>2]=w;x=l+8|0;f[x>>2]=-2147483616;y=l+4|0;f[y>>2]=24;z=w;A=237230;B=z+24|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+24|0;b[C>>0]=0;vM(-215,l,237563,237260,33)}else{t=q;v=13}while(0);if((v|0)==13){v=l+4|0;q=l+8|0;C=l+16|0;w=l+20|0;A=l+40|0;z=v;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[A>>2]=q;q=l+48|0;y=l+44|0;f[y>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[C>>2]=t;f[w>>2]=t;J$(l,e,k,i,1);K$(l);i=m+4|0;t=m+8|0;w=m+16|0;x=m+20|0;D=m+40|0;z=i;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[D>>2]=t;t=m+48|0;z=m+44|0;f[z>>2]=t;f[m+52>>2]=0;f[t>>2]=0;f[m>>2]=1124007936;f[w>>2]=d;f[x>>2]=d;J$(m,e,k,j,1);K$(m);f[n>>2]=l;f[n+4>>2]=m;BL(p,n,o,2);n=f[p+20>>2]|0;j=p+16|0;k=o+4|0;e=0;while(1){if(e>>>0>=(f[j>>2]|0)>>>0)break;o1c(f[k>>2]|0,f[o>>2]|0,n|0)|0;CL(p)|0;e=e+1|0}e=m+36|0;p=f[e>>2]|0;if((p|0?(n=p+12|0,p=f[n>>2]|0,f[n>>2]=p+-1,(p|0)==1):0)?(p=f[e>>2]|0,p|0):0){f[e>>2]=0;n=f[p+4>>2]|0;if(!n){o=f[m+32>>2]|0;if(!o)G=L$()|0;else G=o}else G=n;mi[f[(f[G>>2]|0)+24>>2]&2047](G,p)}f[e>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[i>>2]|0)>0){w=f[D>>2]|0;D=0;do{f[w+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[i>>2]|0))}i=f[z>>2]|0;if((i|0)!=(t|0))wL(i);i=l+36|0;t=f[i>>2]|0;if((t|0?(z=t+12|0,t=f[z>>2]|0,f[z>>2]=t+-1,(t|0)==1):0)?(t=f[i>>2]|0,t|0):0){f[i>>2]=0;z=f[t+4>>2]|0;if(!z){D=f[l+32>>2]|0;if(!D)H=L$()|0;else H=D}else H=z;mi[f[(f[H>>2]|0)+24>>2]&2047](H,t)}f[i>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[A>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[v>>2]|0))}v=f[y>>2]|0;if((v|0)!=(q|0))wL(v)}u=a;return}function A$(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;if(!h){r=0;while(1){s=f[g+(r<<2)>>2]|0;if((s|0)<=-1)break;if(!s)break a;f[k+(r<<2)>>2]=s;r=r+1|0;if((r|0)>=(e|0)){t=q;v=13;break a}}w=$Xc(32)|0;f[l>>2]=w;x=l+8|0;f[x>>2]=-2147483616;y=l+4|0;f[y>>2]=24;z=w;A=237230;B=z+24|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+24|0;b[C>>0]=0;vM(-215,l,237556,237260,64)}else{D=q;E=0}while(1){r=f[g+(E<<2)>>2]|0;if((r|0)<=-1)break;if(!r)break a;if((E|0)>(c|0))F=1;else F=f[i+(E<<2)>>2]|0;s=D+(Y(F,f[h+(E<<2)>>2]|0)|0)|0;f[k+(E<<2)>>2]=r;E=E+1|0;if((E|0)>=(e|0)){t=s;v=13;break a}else D=s}w=$Xc(32)|0;f[l>>2]=w;x=l+8|0;f[x>>2]=-2147483616;y=l+4|0;f[y>>2]=24;z=w;A=237230;B=z+24|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+24|0;b[C>>0]=0;vM(-215,l,237556,237260,64)}else{t=q;v=13}while(0);if((v|0)==13){v=l+4|0;q=l+8|0;C=l+16|0;w=l+20|0;A=l+40|0;z=v;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[A>>2]=q;q=l+48|0;y=l+44|0;f[y>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[C>>2]=d;f[w>>2]=d;J$(l,e,k,j,1);K$(l);j=m+4|0;d=m+8|0;w=m+16|0;x=m+20|0;D=m+40|0;z=j;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[D>>2]=d;d=m+48|0;z=m+44|0;f[z>>2]=d;f[m+52>>2]=0;f[d>>2]=0;f[m>>2]=1124007936;f[w>>2]=t;f[x>>2]=t;J$(m,e,k,i,1);K$(m);f[n>>2]=l;f[n+4>>2]=m;BL(p,n,o,2);n=f[p+20>>2]|0;i=p+16|0;k=o+4|0;e=0;while(1){if(e>>>0>=(f[i>>2]|0)>>>0)break;o1c(f[k>>2]|0,f[o>>2]|0,n|0)|0;CL(p)|0;e=e+1|0}e=m+36|0;p=f[e>>2]|0;if((p|0?(n=p+12|0,p=f[n>>2]|0,f[n>>2]=p+-1,(p|0)==1):0)?(p=f[e>>2]|0,p|0):0){f[e>>2]=0;n=f[p+4>>2]|0;if(!n){o=f[m+32>>2]|0;if(!o)G=L$()|0;else G=o}else G=n;mi[f[(f[G>>2]|0)+24>>2]&2047](G,p)}f[e>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[j>>2]|0)>0){w=f[D>>2]|0;D=0;do{f[w+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[j>>2]|0))}j=f[z>>2]|0;if((j|0)!=(d|0))wL(j);j=l+36|0;d=f[j>>2]|0;if((d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)?(d=f[j>>2]|0,d|0):0){f[j>>2]=0;z=f[d+4>>2]|0;if(!z){D=f[l+32>>2]|0;if(!D)H=L$()|0;else H=D}else H=z;mi[f[(f[H>>2]|0)+24>>2]&2047](H,d)}f[j>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[A>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[v>>2]|0))}v=f[y>>2]|0;if((v|0)!=(q|0))wL(v)}u=a;return}function B$(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=u;u=u+288|0;a=l+160|0;m=l+104|0;n=l+48|0;o=l+40|0;p=l+32|0;q=l;if(!((c|0)!=0&(d|0)!=0)){u=l;return}r=f[c+16>>2]|0;c=f[d+16>>2]|0;a:do if((e|0)>0){d=(j|0)==0;s=e+-2|0;if(h|0){t=r;v=0;w=c;while(1){x=f[g+(v<<2)>>2]|0;if((x|0)<=-1)break;if(!x)break a;y=(v|0)>(s|0);if(y)z=1;else z=f[i+(v<<2)>>2]|0;A=t+(Y(z,f[h+(v<<2)>>2]|0)|0)|0;if(d)B=w;else{if(y)C=1;else C=f[k+(v<<2)>>2]|0;B=w+(Y(C,f[j+(v<<2)>>2]|0)|0)|0}f[a+(v<<2)>>2]=x;v=v+1|0;if((v|0)>=(e|0)){D=A;E=B;F=23;break a}else{t=A;w=B}}G=$Xc(32)|0;f[m>>2]=G;H=m+8|0;f[H>>2]=-2147483616;I=m+4|0;f[I>>2]=24;J=G;K=237230;L=J+24|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));M=G+24|0;b[M>>0]=0;vM(-215,m,237255,237260,97)}if(d){w=0;while(1){t=f[g+(w<<2)>>2]|0;if((t|0)<=-1)break;if(!t)break a;f[a+(w<<2)>>2]=t;w=w+1|0;if((w|0)>=(e|0)){D=r;E=c;F=23;break a}}G=$Xc(32)|0;f[m>>2]=G;H=m+8|0;f[H>>2]=-2147483616;I=m+4|0;f[I>>2]=24;J=G;K=237230;L=J+24|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));M=G+24|0;b[M>>0]=0;vM(-215,m,237255,237260,97)}else{N=0;O=c}while(1){w=f[g+(N<<2)>>2]|0;if((w|0)<=-1)break;if(!w)break a;if((N|0)>(s|0))P=1;else P=f[k+(N<<2)>>2]|0;d=O+(Y(P,f[j+(N<<2)>>2]|0)|0)|0;f[a+(N<<2)>>2]=w;N=N+1|0;if((N|0)>=(e|0)){D=r;E=d;F=23;break a}else O=d}G=$Xc(32)|0;f[m>>2]=G;H=m+8|0;f[H>>2]=-2147483616;I=m+4|0;f[I>>2]=24;J=G;K=237230;L=J+24|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));M=G+24|0;b[M>>0]=0;vM(-215,m,237255,237260,97)}else{D=r;E=c;F=23}while(0);if((F|0)==23){F=m+4|0;c=m+8|0;r=m+16|0;M=m+20|0;G=m+40|0;J=F;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[G>>2]=c;c=m+48|0;K=m+44|0;f[K>>2]=c;f[m+52>>2]=0;f[c>>2]=0;f[m>>2]=1124007936;f[r>>2]=D;f[M>>2]=D;J$(m,e,a,i,1);K$(m);i=n+4|0;D=n+8|0;M=n+16|0;I=n+20|0;H=n+40|0;J=i;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[H>>2]=D;D=n+48|0;J=n+44|0;f[J>>2]=D;f[n+52>>2]=0;f[D>>2]=0;f[n>>2]=1124007936;f[M>>2]=E;f[I>>2]=E;J$(n,e,a,k,1);K$(n);f[o>>2]=m;f[o+4>>2]=n;BL(q,o,p,2);o=f[q+20>>2]|0;k=q+16|0;a=p+4|0;e=0;while(1){if(e>>>0>=(f[k>>2]|0)>>>0)break;o1c(f[a>>2]|0,f[p>>2]|0,o|0)|0;CL(q)|0;e=e+1|0}e=n+36|0;q=f[e>>2]|0;if((q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)?(q=f[e>>2]|0,q|0):0){f[e>>2]=0;o=f[q+4>>2]|0;if(!o){p=f[n+32>>2]|0;if(!p)Q=L$()|0;else Q=p}else Q=o;mi[f[(f[Q>>2]|0)+24>>2]&2047](Q,q)}f[e>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[i>>2]|0)>0){M=f[H>>2]|0;H=0;do{f[M+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[i>>2]|0))}i=f[J>>2]|0;if((i|0)!=(D|0))wL(i);i=m+36|0;D=f[i>>2]|0;if((D|0?(J=D+12|0,D=f[J>>2]|0,f[J>>2]=D+-1,(D|0)==1):0)?(D=f[i>>2]|0,D|0):0){f[i>>2]=0;J=f[D+4>>2]|0;if(!J){H=f[m+32>>2]|0;if(!H)R=L$()|0;else R=H}else R=J;mi[f[(f[R>>2]|0)+24>>2]&2047](R,D)}f[i>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[F>>2]|0)>0){r=f[G>>2]|0;G=0;do{f[r+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[F>>2]|0))}F=f[K>>2]|0;if((F|0)!=(c|0))wL(F)}u=l;return}function C$(a,c){a=a|0;c=c|0;if((b[530032]|0)==0?X0c(530032)|0:0)f[136180]=39104;return 544720}function D$(a){a=a|0;return -1}function E$(a){a=a|0;return -1}function F$(a,b){a=a|0;b=b|0;return}function G$(a){a=a|0;return}function H$(a){a=a|0;return}function I$(a){a=a|0;cYc(a);return}function J$(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){j=$Xc(48)|0;f[i>>2]=j;f[i+8>>2]=-2147483600;f[i+4>>2]=33;k=j;l=237423;m=k+33|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+33>>0]=0;vM(-215,i,237457,237260,209)}j=a+4|0;if((f[j>>2]|0)!=(c|0)){n=a+44|0;o=f[n>>2]|0;p=a+48|0;if((o|0)!=(p|0)){wL(o);f[n>>2]=p;f[a+40>>2]=a+8}if((c|0)>2){p=vL(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+40>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[j>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=675553809>>>(n<<2&28)&15;o=Y(p,(n>>>3&511)+1|0)|0;n=c+-1|0;if((c|0)<=0){u=h;return}q=f[a+40>>2]|0;r=f[a+44>>2]|0;a:do if(!e){s=n;t=o;while(1){v=f[d+(s<<2)>>2]|0;if((v|0)<=-1){w=18;break}f[q+(s<<2)>>2]=v;if(g){f[r+(s<<2)>>2]=t;x=x1c(v|0,((v|0)<0)<<31>>31|0,t|0,0)|0;if(!((x|0)==(x|0)&(J|0)==0)){w=22;break}y=x}else y=t;if((s|0)>0){s=s+-1|0;t=y}else break a}if((w|0)==18){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;z=i+11|0;b[z>>0]=6;b[i>>0]=b[237465]|0;b[i+1>>0]=b[237466]|0;b[i+2>>0]=b[237467]|0;b[i+3>>0]=b[237468]|0;b[i+4>>0]=b[237469]|0;b[i+5>>0]=b[237470]|0;A=i+6|0;b[A>>0]=0;vM(-215,i,237457,237260,235)}else if((w|0)==22){t=$Xc(64)|0;f[i>>2]=t;f[i+8>>2]=-2147483584;f[i+4>>2]=51;k=t;l=237504;m=k+51|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[t+51>>0]=0;vM(-211,i,237457,237260,252)}}else{s=n;while(1){x=f[d+(s<<2)>>2]|0;if((x|0)<=-1){w=18;break}f[q+(s<<2)>>2]=x;x=f[e+(s<<2)>>2]|0;if((x>>>0)%(p>>>0)|0|0){w=20;break}f[r+(s<<2)>>2]=(s|0)<(n|0)?x:o;if((s|0)>0)s=s+-1|0;else break a}if((w|0)==18){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;z=i+11|0;b[z>>0]=6;b[i>>0]=b[237465]|0;b[i+1>>0]=b[237466]|0;b[i+2>>0]=b[237467]|0;b[i+3>>0]=b[237468]|0;b[i+4>>0]=b[237469]|0;b[i+5>>0]=b[237470]|0;A=i+6|0;b[A>>0]=0;vM(-215,i,237457,237260,235)}else if((w|0)==20){s=$Xc(32)|0;f[i>>2]=s;f[i+8>>2]=-2147483616;f[i+4>>2]=31;k=s;l=237472;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[s+31>>0]=0;vM(-13,i,237457,237260,242)}}while(0);if((c|0)!=1){u=h;return}f[j>>2]=2;f[a+12>>2]=1;f[(f[a+44>>2]|0)+4>>2]=o;u=h;return}function K$(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=f[a>>2]|0;c=f[a+4>>2]|0;d=f[a+40>>2]|0;e=f[a+44>>2]|0;a:do if((c|0)>0){g=0;while(1){if((f[d+(g<<2)>>2]|0)>1){h=g;break a}i=g+1|0;if((i|0)<(c|0))g=i;else{h=i;break}}}else h=0;while(0);g=c+-1|0;i=f[d+(((g|0)<(h|0)?g:h)<<2)>>2]|0;j=x1c(i|0,((i|0)<0)<<31>>31|0,(b>>>3&511)+1|0,0)|0;i=g;k=j;j=J;while(1){if((i|0)<=(h|0)){l=7;break}m=f[d+(i<<2)>>2]|0;n=x1c(m|0,((m|0)<0)<<31>>31|0,k|0,j|0)|0;o=Y(f[e+(i<<2)>>2]|0,m)|0;i=i+-1|0;if(o>>>0<(f[e+(i<<2)>>2]|0)>>>0){l=9;break}else{k=n;j=J}}if((l|0)==7){i=k1c(0,k|0,32)|0;if((k|0)==(i|0)&(j|0)==(J|0))p=b|16384;else l=9}if((l|0)==9)p=b&-16385;f[a>>2]=p;if((c|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}p=f[a+36>>2]|0;if(!p)q=a+16|0;else{b=f[p+16>>2]|0;p=a+16|0;f[p>>2]=b;f[a+20>>2]=b;q=p}p=f[q>>2]|0;if(!p){f[a+28>>2]=0;f[a+24>>2]=0;return}q=f[d>>2]|0;b=f[e>>2]|0;l=(f[a+20>>2]|0)+(Y(b,q)|0)|0;f[a+28>>2]=l;if((q|0)<=0){f[a+24>>2]=l;return}l=p+(Y(f[e+(g<<2)>>2]|0,f[d+(g<<2)>>2]|0)|0)|0;p=a+24|0;f[p>>2]=l;if((c|0)<=1)return;c=l+(Y(b,q+-1|0)|0)|0;if((g|0)==1)r=c;else{q=1;b=c;while(1){c=b+(Y(f[e+(q<<2)>>2]|0,(f[d+(q<<2)>>2]|0)+-1|0)|0)|0;q=q+1|0;if((q|0)==(g|0)){r=c;break}else b=c}}f[p>>2]=r;return}function L$(){var a=0,b=0,c=0,d=0;if(f[136181]|0){a=f[136181]|0;return a|0}b=cN()|0;YXc(b);if(!(f[136181]|0)){if(!(f[136182]|0)){c=cN()|0;YXc(c);if(!(f[136182]|0)){d=$Xc(4)|0;f[d>>2]=39136;f[136182]=d}ZXc(c)}f[136181]=f[136182]}ZXc(b);a=f[136181]|0;return a|0}function M$(a){a=a|0;cYc(a);return}function N$(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=u;u=u+16|0;i=j;k=Y(675553809>>>(e<<2&28)&15,(e>>>3&511)+1|0)|0;e=c+-1|0;a:do if((c|0)>0){if(!h){l=e;m=k;while(1){n=Y(f[d+(l<<2)>>2]|0,m)|0;if((l|0)>0){l=l+-1|0;m=n}else{o=n;break a}}}if(!g){m=e;l=k;while(1){f[h+(m<<2)>>2]=l;n=Y(f[d+(m<<2)>>2]|0,l)|0;if((m|0)>0){m=m+-1|0;l=n}else{o=n;break a}}}else{p=e;q=k}while(1){l=h+(p<<2)|0;m=f[l>>2]|0;if((m|0)!=2147483647)if(q>>>0>m>>>0)break;else r=m;else{f[l>>2]=q;r=q}l=Y(f[d+(p<<2)>>2]|0,r)|0;if((p|0)>0){p=p+-1|0;q=l}else{o=l;break a}}l=$Xc(32)|0;f[i>>2]=l;f[i+8>>2]=-2147483616;f[i+4>>2]=16;m=l;n=237374;s=m+16|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(s|0));b[l+16>>0]=0;vM(-215,i,237391,237260,139)}else o=k;while(0);k=(g|0)!=0;if(k)t=g;else t=vL(o)|0;g=$Xc(52)|0;qQ(g,a);f[g+20>>2]=t;f[g+16>>2]=t;f[g+24>>2]=o;if(!k){u=j;return g|0}k=g+28|0;f[k>>2]=f[k>>2]|32;u=j;return g|0}function O$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (b|0)!=0|0}function P$(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;a=u;u=u+16|0;d=a;if(!c){u=a;return}if(f[c+8>>2]|0){e=$Xc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=17;g=e;h=237328;i=g+17|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+17>>0]=0;vM(-215,d,237346,237260,168)}if(f[c+12>>2]|0){e=$Xc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=16;g=e;h=237357;i=g+16|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+16>>0]=0;vM(-215,d,237346,237260,169)}if(!(f[c+28>>2]&32)){d=c+20|0;wL(f[d>>2]|0);f[d>>2]=0}rQ(c);cYc(c);u=a;return}function Q$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a:do if((b|0)>0){e=0;while(1){if((f[c+(e<<2)>>2]|0)>1){g=e;break a}h=e+1|0;if((h|0)<(b|0))e=h;else{g=h;break}}}else g=0;while(0);e=b+-1|0;b=f[c+(((e|0)<(g|0)?e:g)<<2)>>2]|0;h=x1c(b|0,((b|0)<0)<<31>>31|0,(a>>>3&511)+1|0,0)|0;b=e;e=h;h=J;while(1){if((b|0)<=(g|0)){i=7;break}j=f[c+(b<<2)>>2]|0;k=x1c(j|0,((j|0)<0)<<31>>31|0,e|0,h|0)|0;l=Y(f[d+(b<<2)>>2]|0,j)|0;b=b+-1|0;if(l>>>0<(f[d+(b<<2)>>2]|0)>>>0)break;else{e=k;h=J}}if((i|0)==7?(i=k1c(0,e|0,32)|0,(e|0)==(i|0)&(h|0)==(J|0)):0){m=a|16384;return m|0}m=a&-16385;return m|0}function R$(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a>>2]|0;c=f[a+4>>2]|0;d=f[a+40>>2]|0;e=f[a+44>>2]|0;a:do if((c|0)>0){g=0;while(1){if((f[d+(g<<2)>>2]|0)>1){h=g;break a}i=g+1|0;if((i|0)<(c|0))g=i;else{h=i;break}}}else h=0;while(0);g=c+-1|0;c=f[d+(((g|0)<(h|0)?g:h)<<2)>>2]|0;i=x1c(c|0,((c|0)<0)<<31>>31|0,(b>>>3&511)+1|0,0)|0;c=g;g=i;i=J;while(1){if((c|0)<=(h|0)){j=7;break}k=f[d+(c<<2)>>2]|0;l=x1c(k|0,((k|0)<0)<<31>>31|0,g|0,i|0)|0;m=Y(f[e+(c<<2)>>2]|0,k)|0;c=c+-1|0;if(m>>>0<(f[e+(c<<2)>>2]|0)>>>0)break;else{g=l;i=J}}if((j|0)==7?(j=k1c(0,g|0,32)|0,(g|0)==(j|0)&(i|0)==(J|0)):0){n=b|16384;f[a>>2]=n;return}n=b&-16385;f[a>>2]=n;return}function S$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+144|0;h=g+16|0;i=g;if(!(c>>>0<33&(d|0)!=0)){j=$Xc(48)|0;f[h>>2]=j;f[h+8>>2]=-2147483600;f[h+4>>2]=35;k=j;l=237592;m=k+35|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+35>>0]=0;vM(-215,h,467262,237260,321)}j=e&4095;e=a+16|0;do if(f[e>>2]|0){n=f[a+4>>2]|0;if((n|0)!=(c|0)?!((c|0)==1&(n|0)<3):0)break;if((j|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=g;return}else o=11;else if((c|0)>0)o=11;else p=0;a:do if((o|0)==11){n=f[a+40>>2]|0;q=0;while(1){if((f[n+(q<<2)>>2]|0)!=(f[d+(q<<2)>>2]|0)){p=q;break a}r=q+1|0;if((r|0)<(c|0))q=r;else{p=r;break}}}while(0);if((p|0)==(c|0)){if((c|0)>1){u=g;return}if((f[(f[a+40>>2]|0)+4>>2]|0)==1){u=g;return}}}}while(0);p=a+40|0;if((f[p>>2]|0)==(d|0)){if((c|0)>0)o1c(h|0,d|0,c<<2|0)|0;s=h}else s=d;d=a+36|0;h=f[d>>2]|0;if((h|0?(o=h+12|0,h=f[o>>2]|0,f[o>>2]=h+-1,(h|0)==1):0)?(h=f[d>>2]|0,h|0):0){f[d>>2]=0;o=f[h+4>>2]|0;if(!o){q=f[a+32>>2]|0;if(!q)t=L$()|0;else t=q}else t=o;mi[f[(f[t>>2]|0)+24>>2]&2047](t,h)}f[d>>2]=0;h=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[h>>2]|0)>0){e=f[p>>2]|0;t=0;do{f[e+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[h>>2]|0))}if(c|0){f[a>>2]=j|1124007936;J$(a,c,s,0,1);s=f[h>>2]|0;if((s|0)<3)v=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[p>>2]|0;t=0;e=1;while(1){o=Y(f[c+(t<<2)>>2]|0,e)|0;t=t+1|0;if((t|0)==(s|0)){v=o;break}else e=o}}if(v|0){v=f[a+32>>2]|0;e=L$()|0;s=(v|0)==0?e:v;v=a+44|0;e=Gj[f[(f[s>>2]|0)+8>>2]&15](s,f[h>>2]|0,f[p>>2]|0,j,0,f[v>>2]|0,50331648,0)|0;f[d>>2]=e;if(!e){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=6;b[i>>0]=b[237628]|0;b[i+1>>0]=b[237629]|0;b[i+2>>0]=b[237630]|0;b[i+3>>0]=b[237631]|0;b[i+4>>0]=b[237632]|0;b[i+5>>0]=b[237633]|0;b[i+6>>0]=0;vM(-215,i,467262,237260,361)}e=f[a>>2]|0;if((f[(f[v>>2]|0)+((f[h>>2]|0)+-1<<2)>>2]|0)!=(Y(675553809>>>(e<<2&28)&15,(e>>>3&511)+1|0)|0)){e=$Xc(48)|0;f[i>>2]=e;f[i+8>>2]=-2147483600;f[i+4>>2]=43;k=e;l=237635;m=k+43|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[e+43>>0]=0;vM(-215,i,467262,237260,370)}}i=f[d>>2]|0;if(i|0){d=i+12|0;f[d>>2]=(f[d>>2]|0)+1}K$(a)}u=g;return}function T$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;S$(a,(f[b+4>>2]|0)-d>>2,d,c);return}function U$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;J$(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+40>>2]|0;e=f[a+40>>2]|0;g=f[b+44>>2]|0;b=f[a+44>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function V$(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+36|0;c=f[b>>2]|0;if(!c)return;f[b>>2]=0;b=f[c+4>>2]|0;if(!b){d=f[a+32>>2]|0;if(!d)e=L$()|0;else e=d}else e=b;mi[f[(f[e>>2]|0)+24>>2]&2047](e,c);return}function W$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;g=u;u=u+1152|0;h=g+56|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+32|0;r=a+36|0;s=a+40|0;t=j;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=k;w=a+44|0;x=a+48|0;f[w>>2]=x;f[a+52>>2]=0;f[x>>2]=0;y=c+4|0;z=f[y>>2]|0;if((z|0)<=1){A=$Xc(16)|0;f[h>>2]=A;f[h+8>>2]=-2147483632;f[h+4>>2]=11;t=A;B=237679;v=t+11|0;do{b[t>>0]=b[B>>0]|0;t=t+1|0;B=B+1|0}while((t|0)<(v|0));b[A+11>>0]=0;vM(-215,h,470343,237260,406)}if((z|0)!=2){A=h+8|0;g1c(A|0,0,1088)|0;f[h>>2]=A;C=h+4|0;f[C>>2]=z;if(z>>>0>136){D=bYc(z>>>0>536870911?-1:z<<3)|0;g1c(D|0,0,z<<3|0)|0;f[h>>2]=D;E=D}else E=A;D=d;z=f[D+4>>2]|0;F=E;f[F>>2]=f[D>>2];f[F+4>>2]=z;z=f[h>>2]|0;F=e;D=f[F+4>>2]|0;E=z+8|0;f[E>>2]=f[F>>2];f[E+4>>2]=D;if((f[y>>2]|0)>2){D=2;E=z;while(1){F=E+(D<<3)|0;f[F>>2]=-2147483648;f[F+4>>2]=2147483647;D=D+1|0;F=f[h>>2]|0;if((D|0)>=(f[y>>2]|0)){G=F;break}else E=F}}else G=z;X$(i,c,G);G=f[r>>2]|0;if((i|0)==(a|0)){z=i+36|0;if(((G|0)!=0?(E=G+12|0,y=f[E>>2]|0,f[E>>2]=y+-1,(y|0)==1):0)?(y=f[z>>2]|0,(y|0)!=0):0){f[z>>2]=0;E=f[y+4>>2]|0;if(!E){D=f[i+32>>2]|0;if(!D)H=L$()|0;else H=D}else H=E;mi[f[(f[H>>2]|0)+24>>2]&2047](H,y);I=z}else I=z}else{if((G|0?(z=G+12|0,G=f[z>>2]|0,f[z>>2]=G+-1,(G|0)==1):0)?(G=f[r>>2]|0,G|0):0){f[r>>2]=0;z=f[G+4>>2]|0;if(!z){y=f[q>>2]|0;if(!y)K=L$()|0;else K=y}else K=z;mi[f[(f[K>>2]|0)+24>>2]&2047](K,G)}f[r>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){G=f[a+40>>2]|0;K=0;do{f[G+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[j>>2]|0))}f[a>>2]=f[i>>2];K=i+4|0;G=f[K>>2]|0;f[j>>2]=G;z=i+8|0;f[k>>2]=f[z>>2];f[l>>2]=f[i+12>>2];f[m>>2]=f[i+16>>2];f[n>>2]=f[i+20>>2];f[o>>2]=f[i+24>>2];f[p>>2]=f[i+28>>2];f[q>>2]=f[i+32>>2];p=i+36|0;f[r>>2]=f[p>>2];o=f[w>>2]|0;if((o|0)==(x|0))L=G;else{wL(o);f[w>>2]=x;f[a+40>>2]=k;L=f[K>>2]|0}o=i+44|0;if((L|0)<3){L=f[o>>2]|0;f[x>>2]=f[L>>2];f[a+52>>2]=f[L+4>>2]}else{f[w>>2]=f[o>>2];w=i+40|0;f[s>>2]=f[w>>2];f[o>>2]=i+48;f[w>>2]=z}f[i>>2]=1124007936;t=K;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));I=p}f[I>>2]=0;I=i+16|0;p=i+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[p>>2]|0)>0){I=f[i+40>>2]|0;K=0;do{f[I+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[p>>2]|0))}p=f[i+44>>2]|0;if((p|0)!=(i+48|0))wL(p);p=f[h>>2]|0;if((p|0)!=(A|0)){if(p|0)dYc(p);f[h>>2]=A;f[C>>2]=136}u=g;return}Y$(a,c)|0;C=f[d>>2]|0;A=f[d+4>>2]|0;do if((C|0)!=-2147483648|(A|0)!=2147483647?(C|0?1:(A|0)!=(f[k>>2]|0)):0){if((C|0)<0|(A|0)<(C|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(96)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483552;O=h+4|0;f[O>>2]=83;t=M;B=237691;v=t+83|0;do{b[t>>0]=b[B>>0]|0;t=t+1|0;B=B+1|0}while((t|0)<(v|0));P=M+83|0;b[P>>0]=0;vM(-215,h,470343,237260,424)}if((A|0)>(f[c+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(96)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483552;O=h+4|0;f[O>>2]=83;t=M;B=237691;v=t+83|0;do{b[t>>0]=b[B>>0]|0;t=t+1|0;B=B+1|0}while((t|0)<(v|0));P=M+83|0;b[P>>0]=0;vM(-215,h,470343,237260,424)}else{f[k>>2]=A-C;d=Y(C,f[x>>2]|0)|0;f[m>>2]=(f[m>>2]|0)+d;f[a>>2]=f[a>>2]|32768;break}}while(0);x=f[e>>2]|0;C=f[e+4>>2]|0;if((x|0)!=-2147483648|(C|0)!=2147483647?(x|0?1:(C|0)!=(f[l>>2]|0)):0){if((x|0)<0|(C|0)<(x|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=$Xc(96)|0;f[h>>2]=Q;R=h+8|0;f[R>>2]=-2147483552;S=h+4|0;f[S>>2]=83;t=Q;B=237775;v=t+83|0;do{b[t>>0]=b[B>>0]|0;t=t+1|0;B=B+1|0}while((t|0)<(v|0));T=Q+83|0;b[T>>0]=0;vM(-215,h,470343,237260,433)}if((C|0)>(f[c+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=$Xc(96)|0;f[h>>2]=Q;R=h+8|0;f[R>>2]=-2147483552;S=h+4|0;f[S>>2]=83;t=Q;B=237775;v=t+83|0;do{b[t>>0]=b[B>>0]|0;t=t+1|0;B=B+1|0}while((t|0)<(v|0));T=Q+83|0;b[T>>0]=0;vM(-215,h,470343,237260,433)}f[l>>2]=C-x;C=f[j>>2]|0;if((C|0)>0)U=f[(f[a+44>>2]|0)+(C+-1<<2)>>2]|0;else U=0;C=Y(U,x)|0;f[m>>2]=(f[m>>2]|0)+C;f[a>>2]=f[a>>2]|32768}C=f[a>>2]|0;x=f[j>>2]|0;U=a+40|0;h=f[U>>2]|0;T=f[a+44>>2]|0;a:do if((x|0)>0){Q=0;while(1){if((f[h+(Q<<2)>>2]|0)>1){V=Q;break a}B=Q+1|0;if((B|0)<(x|0))Q=B;else{V=B;break}}}else V=0;while(0);Q=x+-1|0;x=f[h+(((Q|0)<(V|0)?Q:V)<<2)>>2]|0;B=x1c(x|0,((x|0)<0)<<31>>31|0,(C>>>3&511)+1|0,0)|0;x=Q;Q=B;B=J;while(1){if((x|0)<=(V|0)){W=62;break}t=f[h+(x<<2)>>2]|0;v=x1c(t|0,((t|0)<0)<<31>>31|0,Q|0,B|0)|0;S=Y(f[T+(x<<2)>>2]|0,t)|0;x=x+-1|0;if(S>>>0<(f[T+(x<<2)>>2]|0)>>>0){W=64;break}else{Q=v;B=J}}if((W|0)==62){x=k1c(0,Q|0,32)|0;if((Q|0)==(x|0)&(B|0)==(J|0))X=C|16384;else W=64}if((W|0)==64)X=C&-16385;f[a>>2]=X;if((f[k>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=g;return}X=f[r>>2]|0;if((X|0?(a=X+12|0,X=f[a>>2]|0,f[a>>2]=X+-1,(X|0)==1):0)?(X=f[r>>2]|0,X|0):0){f[r>>2]=0;a=f[X+4>>2]|0;if(!a){C=f[q>>2]|0;if(!C)Z=L$()|0;else Z=C}else Z=a;mi[f[(f[Z>>2]|0)+24>>2]&2047](Z,X)}f[r>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){m=f[U>>2]|0;U=0;do{f[m+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[j>>2]|0))}f[l>>2]=0;f[k>>2]=0;u=g;return}function X$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+16|0;k=a+40|0;l=h;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=i;i=a+48|0;n=a+44|0;f[n>>2]=i;f[a+52>>2]=0;f[i>>2]=0;i=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=6;b[g>>0]=b[237859]|0;b[g+1>>0]=b[237860]|0;b[g+2>>0]=b[237861]|0;b[g+3>>0]=b[237862]|0;b[g+4>>0]=b[237863]|0;b[g+5>>0]=b[237864]|0;b[g+6>>0]=0;vM(-215,g,470343,237260,511)}o=(i|0)>0;do if(o){p=f[c+40>>2]|0;q=0;while(1){r=d+(q<<3)|0;s=f[r>>2]|0;t=f[r+4>>2]|0;if(!((s|0)==-2147483648&(t|0)==2147483647)){if(!((s|0)>-1&(s|0)<(t|0))){v=10;break}if((t|0)>(f[p+(q<<2)>>2]|0)){v=10;break}}q=q+1|0;if((q|0)>=(i|0)){v=6;break}}if((v|0)==6){Y$(a,c)|0;if(o)w=0;else break;do{q=d+(w<<3)|0;p=f[q>>2]|0;t=f[q+4>>2]|0;if((p|0)!=-2147483648|(t|0)!=2147483647?(q=(f[k>>2]|0)+(w<<2)|0,p|0?1:(t|0)!=(f[q>>2]|0)):0){f[q>>2]=t-p;t=Y(f[(f[n>>2]|0)+(w<<2)>>2]|0,p)|0;f[j>>2]=(f[j>>2]|0)+t;f[a>>2]=f[a>>2]|32768}w=w+1|0}while((w|0)!=(i|0))}else if((v|0)==10){t=$Xc(80)|0;f[g>>2]=t;f[g+8>>2]=-2147483568;f[g+4>>2]=76;l=t;p=237866;m=l+76|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(m|0));b[t+76>>0]=0;vM(-215,g,470343,237260,515)}}else Y$(a,c)|0;while(0);c=f[a>>2]|0;g=f[h>>2]|0;h=f[k>>2]|0;k=f[n>>2]|0;a:do if((g|0)>0){n=0;while(1){if((f[h+(n<<2)>>2]|0)>1){x=n;break a}l=n+1|0;if((l|0)<(g|0))n=l;else{x=l;break}}}else x=0;while(0);n=g+-1|0;g=f[h+(((n|0)<(x|0)?n:x)<<2)>>2]|0;t=x1c(g|0,((g|0)<0)<<31>>31|0,(c>>>3&511)+1|0,0)|0;g=n;n=t;t=J;while(1){if((g|0)<=(x|0)){v=18;break}l=f[h+(g<<2)>>2]|0;m=x1c(l|0,((l|0)<0)<<31>>31|0,n|0,t|0)|0;i=Y(f[k+(g<<2)>>2]|0,l)|0;g=g+-1|0;if(i>>>0<(f[k+(g<<2)>>2]|0)>>>0)break;else{n=m;t=J}}if((v|0)==18?(v=k1c(0,n|0,32)|0,(n|0)==(v|0)&(t|0)==(J|0)):0){y=c|16384;f[a>>2]=y;u=e;return}y=c&-16385;f[a>>2]=y;u=e;return}function Y$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if((a|0)==(b|0))return a|0;c=b+36|0;d=f[c>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+36|0;d=f[e>>2]|0;if((d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)?(d=f[e>>2]|0,d|0):0){f[e>>2]=0;g=f[d+4>>2]|0;if(!g){h=f[a+32>>2]|0;if(!h)i=L$()|0;else i=h}else i=g;mi[f[(f[i>>2]|0)+24>>2]&2047](i,d)}f[e>>2]=0;d=a+16|0;i=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){g=f[a+40>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;j=f[i>>2]|0}while((h|0)<(j|0));f[a>>2]=f[b>>2];if((j|0)<3)k=17;else{l=f[b+4>>2]|0;k=19}}else{f[a>>2]=f[b>>2];k=17}if((k|0)==17){j=f[b+4>>2]|0;if((j|0)<3){f[i>>2]=j;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+44>>2]|0;g=f[a+44>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{l=j;k=19}}if((k|0)==19?(J$(a,l,0,0,0),(f[i>>2]|0)>0):0){l=f[b+40>>2]|0;k=f[a+40>>2]|0;j=f[b+44>>2]|0;h=f[a+44>>2]|0;g=0;do{f[k+(g<<2)>>2]=f[l+(g<<2)>>2];f[h+(g<<2)>>2]=f[j+(g<<2)>>2];g=g+1|0}while((g|0)<(f[i>>2]|0))}f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[e>>2]=f[c>>2];return a|0}function Z$(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];n=a+16|0;o=d+4|0;p=c+44|0;q=(f[c+16>>2]|0)+(Y(f[f[p>>2]>>2]|0,f[o>>2]|0)|0)|0;f[n>>2]=q;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];r=a+32|0;f[r>>2]=f[c+32>>2];s=a+36|0;t=f[c+36>>2]|0;f[s>>2]=t;v=a+40|0;f[v>>2]=j;w=a+48|0;x=a+44|0;f[x>>2]=w;f[a+52>>2]=0;f[w>>2]=0;w=t;if((f[c+4>>2]|0)>=3){y=$Xc(16)|0;f[g>>2]=y;f[g+8>>2]=-2147483632;f[g+4>>2]=11;z=y;A=241710;B=z+11|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+11>>0]=0;vM(-215,g,470343,237260,461)}y=Y(675553809>>>(h<<2&28)&15,(h>>>3&511)+1|0)|0;h=f[d>>2]|0;d=q+(Y(y,h)|0)|0;f[n>>2]=d;if((((((h|0)>-1?(d=f[m>>2]|0,(d|0)>-1):0)?(q=c+12|0,C=f[q>>2]|0,(d+h|0)<=(C|0)):0)?(h=f[o>>2]|0,(h|0)>-1):0)?(o=f[k>>2]|0,(o|0)>-1):0)?(D=c+8|0,(o+h|0)<=(f[D>>2]|0)):0){if(!t){E=d;F=C}else{C=w+12|0;f[C>>2]=(f[C>>2]|0)+1;E=f[m>>2]|0;F=f[q>>2]|0}if(!((E|0)>=(F|0)?(f[k>>2]|0)>=(f[D>>2]|0):0))f[a>>2]=f[a>>2]|32768;D=f[x>>2]|0;f[D>>2]=f[f[p>>2]>>2];f[D+4>>2]=y;y=f[a>>2]|0;p=f[i>>2]|0;x=f[v>>2]|0;a:do if((p|0)>0){k=0;while(1){if((f[x+(k<<2)>>2]|0)>1){G=k;break a}F=k+1|0;if((F|0)<(p|0))k=F;else{G=F;break}}}else G=0;while(0);k=p+-1|0;p=f[x+(((k|0)<(G|0)?k:G)<<2)>>2]|0;F=x1c(p|0,((p|0)<0)<<31>>31|0,(y>>>3&511)+1|0,0)|0;p=k;k=F;F=J;while(1){if((p|0)<=(G|0)){H=21;break}E=f[x+(p<<2)>>2]|0;q=x1c(E|0,((E|0)<0)<<31>>31|0,k|0,F|0)|0;m=Y(f[D+(p<<2)>>2]|0,E)|0;p=p+-1|0;if(m>>>0<(f[D+(p<<2)>>2]|0)>>>0){H=23;break}else{k=q;F=J}}if((H|0)==21){p=k1c(0,k|0,32)|0;if((k|0)==(p|0)&(F|0)==(J|0))I=y|16384;else H=23}if((H|0)==23)I=y&-16385;f[a>>2]=I;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}I=f[s>>2]|0;if((I|0?(a=I+12|0,I=f[a>>2]|0,f[a>>2]=I+-1,(I|0)==1):0)?(I=f[s>>2]|0,I|0):0){f[s>>2]=0;a=f[I+4>>2]|0;if(!a){y=f[r>>2]|0;if(!y)K=L$()|0;else K=y}else K=a;mi[f[(f[K>>2]|0)+24>>2]&2047](K,I)}f[s>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[v>>2]|0;v=0;do{f[n+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[i>>2]|0))}f[l>>2]=0;f[j>>2]=0;u=e;return}e=$Xc(128)|0;f[g>>2]=e;f[g+8>>2]=-2147483520;f[g+4>>2]=124;z=e;A=237943;B=z+124|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[e+124>>0]=0;vM(-215,g,470343,237260,466)}function _$(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=h;h=a+48|0;f[a+44>>2]=h;f[a+52>>2]=0;f[h>>2]=0;f[a>>2]=d&4095|1124007936;f[i>>2]=e;f[j>>2]=e;J$(a,b,c,g,1);K$(a);return}function $$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=a+8|0;h=a+16|0;i=a+20|0;j=a+40|0;k=a+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=g;g=a+48|0;f[a+44>>2]=g;f[a+52>>2]=0;f[g>>2]=0;f[a>>2]=c&4095|1124007936;f[h>>2]=d;f[i>>2]=d;d=f[b>>2]|0;J$(a,(f[b+4>>2]|0)-d>>2,d,e,1);K$(a);return}function a0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+16|0;k=a+40|0;l=h;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=i;i=a+48|0;n=a+44|0;f[n>>2]=i;f[a+52>>2]=0;f[i>>2]=0;i=f[c+4>>2]|0;o=f[d>>2]|0;p=o;if(((f[d+4>>2]|0)-o>>3|0)!=(i|0)){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=23;l=o;q=238068;m=l+23|0;do{b[l>>0]=b[q>>0]|0;l=l+1|0;q=q+1|0}while((l|0)<(m|0));b[o+23>>0]=0;vM(-215,g,470343,237260,537)}o=(i|0)>0;do if(o){r=f[c+40>>2]|0;s=0;while(1){t=p+(s<<3)|0;v=f[t>>2]|0;w=f[t+4>>2]|0;if(!((v|0)==-2147483648&(w|0)==2147483647)){if(!((v|0)>-1&(v|0)<(w|0))){x=11;break}if((w|0)>(f[r+(s<<2)>>2]|0)){x=11;break}}s=s+1|0;if((s|0)>=(i|0)){x=6;break}}if((x|0)==6){Y$(a,c)|0;if(!o)break;s=f[d>>2]|0;r=0;do{w=s+(r<<3)|0;v=f[w>>2]|0;t=f[w+4>>2]|0;if((v|0)!=-2147483648|(t|0)!=2147483647?(w=(f[k>>2]|0)+(r<<2)|0,v|0?1:(t|0)!=(f[w>>2]|0)):0){f[w>>2]=t-v;t=Y(f[(f[n>>2]|0)+(r<<2)>>2]|0,v)|0;f[j>>2]=(f[j>>2]|0)+t;f[a>>2]=f[a>>2]|32768}r=r+1|0}while((r|0)!=(i|0))}else if((x|0)==11){r=$Xc(80)|0;f[g>>2]=r;f[g+8>>2]=-2147483568;f[g+4>>2]=76;l=r;q=237866;m=l+76|0;do{b[l>>0]=b[q>>0]|0;l=l+1|0;q=q+1|0}while((l|0)<(m|0));b[r+76>>0]=0;vM(-215,g,470343,237260,541)}}else Y$(a,c)|0;while(0);c=f[a>>2]|0;g=f[h>>2]|0;h=f[k>>2]|0;k=f[n>>2]|0;a:do if((g|0)>0){n=0;while(1){if((f[h+(n<<2)>>2]|0)>1){y=n;break a}q=n+1|0;if((q|0)<(g|0))n=q;else{y=q;break}}}else y=0;while(0);n=g+-1|0;g=f[h+(((n|0)<(y|0)?n:y)<<2)>>2]|0;r=x1c(g|0,((g|0)<0)<<31>>31|0,(c>>>3&511)+1|0,0)|0;g=n;n=r;r=J;while(1){if((g|0)<=(y|0)){x=19;break}q=f[h+(g<<2)>>2]|0;l=x1c(q|0,((q|0)<0)<<31>>31|0,n|0,r|0)|0;m=Y(f[k+(g<<2)>>2]|0,q)|0;g=g+-1|0;if(m>>>0<(f[k+(g<<2)>>2]|0)>>>0)break;else{n=l;r=J}}if((x|0)==19?(x=k1c(0,n|0,32)|0,(n|0)==(x|0)&(r|0)==(J|0)):0){z=c|16384;f[a>>2]=z;u=e;return}z=c&-16385;f[a>>2]=z;u=e;return}function b0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;h=c+4|0;i=f[h>>2]|0;if((i|0)>=3){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=9;j=g;k=238092;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[g+9>>0]=0;vM(-215,g,238102,237260,560)}f[a>>2]=f[c>>2];g=a+4|0;f[g>>2]=i;i=a+8|0;k=c+8|0;f[i>>2]=f[k>>2];j=a+12|0;l=c+12|0;f[j>>2]=f[l>>2];m=a+16|0;f[m>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+36>>2]=n;o=a+40|0;f[o>>2]=i;p=a+48|0;q=a+44|0;f[q>>2]=p;f[p>>2]=0;f[a+52>>2]=0;if((n|0)!=0?(p=n+12|0,f[p>>2]=(f[p>>2]|0)+1,p=f[h>>2]|0,(p|0)>=3):0){f[g>>2]=0;J$(a,p,0,0,0);if((f[g>>2]|0)>0){p=f[c+40>>2]|0;n=f[o>>2]|0;r=f[c+44>>2]|0;s=f[q>>2]|0;t=0;do{f[n+(t<<2)>>2]=f[p+(t<<2)>>2];f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)<(f[g>>2]|0))}}else{t=f[c+44>>2]|0;r=f[q>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2]}t=f[h>>2]|0;if((t|0)>0)v=f[(f[c+44>>2]|0)+(t+-1<<2)>>2]|0;else v=0;if((d|0)>-1){t=(f[l>>2]|0)-d|0;h=f[k>>2]|0;r=Y(v,d)|0;w=(h|0)<(t|0)?h:t;x=(f[m>>2]|0)+r|0}else{r=(f[k>>2]|0)+d|0;k=f[l>>2]|0;w=(k|0)<(r|0)?k:r;x=(f[m>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,0-d|0)|0)|0}f[m>>2]=x;f[i>>2]=w;i=f[o>>2]|0;f[i>>2]=w;f[j>>2]=1;f[i+4>>2]=1;j=f[q>>2]|0;f[j>>2]=(f[j>>2]|0)+((w|0)>1?v:0);v=f[a>>2]|0;w=f[g>>2]|0;a:do if((w|0)>0){g=0;while(1){if((f[i+(g<<2)>>2]|0)>1){y=g;break a}q=g+1|0;if((q|0)<(w|0))g=q;else{y=q;break}}}else y=0;while(0);g=w+-1|0;w=f[i+(((g|0)<(y|0)?g:y)<<2)>>2]|0;q=x1c(w|0,((w|0)<0)<<31>>31|0,(v>>>3&511)+1|0,0)|0;w=g;g=q;q=J;while(1){if((w|0)<=(y|0)){z=20;break}o=f[i+(w<<2)>>2]|0;x=x1c(o|0,((o|0)<0)<<31>>31|0,g|0,q|0)|0;m=Y(f[j+(w<<2)>>2]|0,o)|0;w=w+-1|0;if(m>>>0<(f[j+(w<<2)>>2]|0)>>>0){z=22;break}else{g=x;q=J}}if((z|0)==20){w=k1c(0,g|0,32)|0;if((g|0)==(w|0)&(q|0)==(J|0))A=v|16384;else z=22}if((z|0)==22)A=v&-16385;f[a>>2]=A;v=f[c+40>>2]|0;if(!((f[v>>2]|0)!=1?1:(f[v+4>>2]|0)!=1)){u=e;return}f[a>>2]=A|32768;u=e;return}function c0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+144|0;e=d+120|0;g=d+112|0;h=d+56|0;i=d;if((c|0)<=-1){j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=16;k=j;l=238107;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+16>>0]=0;vM(-215,e,238124,237260,626)}if((f[a>>2]&32768|0)==0?(j=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,c)|0)|0,j>>>0<=(f[a+28>>2]|0)>>>0):0){u=d;return}j=a+40|0;l=f[j>>2]|0;n=f[l>>2]|0;if(n>>>0>=c>>>0){u=d;return}f[l>>2]=c;l=a+4|0;o=f[l>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[j>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if((o|0)>0)v=f[(f[a+44>>2]|0)+(o+-1<<2)>>2]|0;else v=0;s=Y(v,p)|0;if(s>>>0<64){p=((Y(s+63|0,c)|0)>>>0)/(s>>>0)|0;f[f[j>>2]>>2]=p;w=f[l>>2]|0}else w=o;o=f[j>>2]|0;l=f[a>>2]&4095;f[h>>2]=1124007936;p=h+4|0;s=h+8|0;c=h+40|0;k=p;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[c>>2]=s;s=h+48|0;k=h+44|0;f[k>>2]=s;f[s>>2]=0;f[h+52>>2]=0;S$(h,w,o,l);f[f[j>>2]>>2]=n;if((n|0)>0){f[e>>2]=0;f[e+4>>2]=n;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;W$(i,h,e,g);g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=i;jR(a,e);e=i+36|0;g=f[e>>2]|0;if((g|0?(l=g+12|0,g=f[l>>2]|0,f[l>>2]=g+-1,(g|0)==1):0)?(g=f[e>>2]|0,g|0):0){f[e>>2]=0;l=f[g+4>>2]|0;if(!l){o=f[i+32>>2]|0;if(!o)x=L$()|0;else x=o}else x=l;mi[f[(f[x>>2]|0)+24>>2]&2047](x,g)}f[e>>2]=0;e=i+16|0;g=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[i+40>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[g>>2]|0))}g=f[i+44>>2]|0;if((g|0)!=(i+48|0))wL(g)}Y$(a,h)|0;f[f[j>>2]>>2]=n;j=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,n)|0)|0;f[a+24>>2]=j;j=h+36|0;a=f[j>>2]|0;if((a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)?(a=f[j>>2]|0,a|0):0){f[j>>2]=0;n=f[a+4>>2]|0;if(!n){g=f[h+32>>2]|0;if(!g)y=L$()|0;else y=g}else y=n;mi[f[(f[y>>2]|0)+24>>2]&2047](y,a)}f[j>>2]=0;j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[p>>2]|0)>0){j=f[c>>2]|0;c=0;do{f[j+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[p>>2]|0))}p=f[k>>2]|0;if((p|0)!=(s|0))wL(p);u=d;return}function d0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=a+40|0;h=f[g>>2]|0;i=f[h>>2]|0;if((i|0)==(c|0)){u=d;return}if((c|0)<=-1){j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=16;k=j;l=238107;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+16>>0]=0;vM(-215,e,264464,237260,687)}if(!(f[a>>2]&32768)){e=a+44|0;j=f[e>>2]|0;l=(f[a+16>>2]|0)+(Y(f[j>>2]|0,c)|0)|0;if(l>>>0>(f[a+28>>2]|0)>>>0){n=e;o=7}else{p=h;q=j}}else{n=a+44|0;o=7}if((o|0)==7){c0(a,c);p=f[g>>2]|0;q=f[n>>2]|0}f[p>>2]=c;p=Y(f[q>>2]|0,c-i|0)|0;i=a+24|0;f[i>>2]=(f[i>>2]|0)+p;u=d;return}function e0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;if((h|0)<3?(i=a+44|0,j=f[i>>2]|0,k=f[j>>2]|0,k|0):0){if((h|0)>0)l=f[j+(h+-1<<2)>>2]|0;else l=0;h=f[a+20>>2]|0;m=(f[a+16>>2]|0)-h|0;n=(f[a+24>>2]|0)-h|0;if(!m){f[d+4>>2]=0;o=0;p=0}else{h=(m>>>0)/(k>>>0)|0;f[d+4>>2]=h;o=((m-(Y(f[j>>2]|0,h)|0)|0)>>>0)/(l>>>0)|0;p=h}f[d>>2]=o;d=(f[a+12>>2]|0)+o|0;o=n-(Y(d,l)|0)|0;h=((o>>>0)/((f[f[i>>2]>>2]|0)>>>0)|0)+1|0;i=(f[a+8>>2]|0)+p|0;p=(h|0)<(i|0)?i:h;f[c+4>>2]=p;h=((n-(Y(p+-1|0,f[a+48>>2]|0)|0)|0)>>>0)/(l>>>0)|0;f[c>>2]=(h|0)<(d|0)?d:h;u=e;return}e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=24;h=e;d=238132;c=h+24|0;do{b[h>>0]=b[d>>0]|0;h=h+1|0;d=d+1|0}while((h|0)<(c|0));b[e+24>>0]=0;vM(-215,g,238157,237260,757)}function f0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+32|0;i=h+8|0;j=h;k=a+4|0;l=f[k>>2]|0;if((l|0)>=3){m=$Xc(32)|0;f[i>>2]=m;n=i+8|0;f[n>>2]=-2147483616;o=i+4|0;f[o>>2]=24;p=m;q=238132;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));s=m+24|0;b[s>>0]=0;vM(-215,i,238167,237260,778)}t=a+44|0;v=f[t>>2]|0;if(!(f[v>>2]|0)){m=$Xc(32)|0;f[i>>2]=m;n=i+8|0;f[n>>2]=-2147483616;o=i+4|0;f[o>>2]=24;p=m;q=238132;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));s=m+24|0;b[s>>0]=0;vM(-215,i,238167,237260,778)}f[i>>2]=0;s=i+4|0;f[s>>2]=0;f[j>>2]=0;m=j+4|0;f[m>>2]=0;if((l|0)>0)w=f[v+(l+-1<<2)>>2]|0;else w=0;e0(a,i,j);l=f[m>>2]|0;m=l-c|0;c=f[s>>2]|0;s=(m|0)>0?m:0;m=(c|0)<(s|0)?c:s;s=a+8|0;v=l+d+(f[s>>2]|0)|0;d=(c|0)<(v|0)?c:v;v=(d|0)>0?d:0;d=f[j>>2]|0;j=d-e|0;e=f[i>>2]|0;i=(j|0)>0?j:0;j=(e|0)<(i|0)?e:i;i=a+12|0;c=d+g+(f[i>>2]|0)|0;g=(e|0)<(c|0)?e:c;c=(g|0)>0?g:0;g=(m|0)>(v|0);e=g?v:m;q=(j|0)>(c|0);p=q?c:j;r=(Y(p-d|0,w)|0)+(Y(e-l|0,f[a+48>>2]|0)|0)|0;l=a+16|0;f[l>>2]=(f[l>>2]|0)+r;r=(g?m:v)-e|0;f[s>>2]=r;f[i>>2]=(q?j:c)-p;p=f[a+40>>2]|0;f[p>>2]=r;f[p+4>>2]=f[i>>2];i=f[a>>2]|0;c=f[k>>2]|0;k=f[t>>2]|0;a:do if((c|0)<1|(r|0)>1)x=0;else{t=0;while(1){j=t+1|0;if((j|0)>=(c|0)){x=j;break a}if((f[p+(j<<2)>>2]|0)>1){x=j;break}else t=j}}while(0);r=c+-1|0;c=f[p+(((r|0)<(x|0)?r:x)<<2)>>2]|0;t=x1c(c|0,((c|0)<0)<<31>>31|0,(i>>>3&511)+1|0,0)|0;c=r;r=t;t=J;while(1){if((c|0)<=(x|0)){y=12;break}j=f[p+(c<<2)>>2]|0;q=x1c(j|0,((j|0)<0)<<31>>31|0,r|0,t|0)|0;s=Y(f[k+(c<<2)>>2]|0,j)|0;c=c+-1|0;if(s>>>0<(f[k+(c<<2)>>2]|0)>>>0)break;else{r=q;t=J}}if((y|0)==12?(y=k1c(0,r|0,32)|0,(r|0)==(y|0)&(t|0)==(J|0)):0){z=i|16384;f[a>>2]=z;u=h;return a|0}z=i&-16385;f[a>>2]=z;u=h;return a|0}function g0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+80|0;h=g+16|0;i=g;j=f[c>>2]|0;k=(j>>>3&511)+1|0;f[h>>2]=j;j=h+4|0;l=c+4|0;m=f[l>>2]|0;f[j>>2]=m;n=h+8|0;o=c+8|0;f[n>>2]=f[o>>2];p=h+12|0;q=c+12|0;f[p>>2]=f[q>>2];r=h+16|0;f[r>>2]=f[c+16>>2];s=h+20|0;f[s>>2]=f[c+20>>2];t=h+24|0;f[t>>2]=f[c+24>>2];v=h+28|0;f[v>>2]=f[c+28>>2];w=h+32|0;f[w>>2]=f[c+32>>2];x=h+36|0;y=f[c+36>>2]|0;f[x>>2]=y;z=h+40|0;f[z>>2]=n;A=h+48|0;B=h+44|0;f[B>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(!y)C=m;else{m=y+12|0;f[m>>2]=(f[m>>2]|0)+1;C=f[l>>2]|0}if((C|0)>=3){f[j>>2]=0;J$(h,C,0,0,0);if((f[j>>2]|0)>0){C=f[c+40>>2]|0;m=f[z>>2]|0;y=f[c+44>>2]|0;D=f[B>>2]|0;E=0;do{f[m+(E<<2)>>2]=f[C+(E<<2)>>2];f[D+(E<<2)>>2]=f[y+(E<<2)>>2];E=E+1|0}while((E|0)<(f[j>>2]|0))}}else{E=f[c+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[E>>2];f[y+4>>2]=f[E+4>>2]}E=f[l>>2]|0;do if((E|0)>2){if((d|0)!=0&(e|0)==0){y=E+-1|0;if((Y(f[(f[c+40>>2]|0)+(y<<2)>>2]|0,k)|0)%(d|0)|0|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;F=i+11|0;b[F>>0]=9;G=i;H=238092;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));J=i+9|0;b[J>>0]=0;vM(-215,i,238177,237260,817)}D=f[h>>2]|0;C=(d<<3)+-8|0;f[h>>2]=D&-4089|C;m=Y(675553809>>>(D<<2&28)&15,(C>>>3&511)+1|0)|0;C=h+44|0;D=f[C>>2]|0;f[D+(y<<2)>>2]=m;m=f[z>>2]|0;K=m+((f[l>>2]|0)+-1<<2)|0;L=(Y(f[K>>2]|0,k)|0)/(d|0)|0;f[K>>2]=L;f[a>>2]=f[h>>2];L=f[j>>2]|0;f[a+4>>2]=L;K=a+8|0;f[K>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];f[a+36>>2]=f[x>>2];M=a+40|0;f[M>>2]=K;K=a+44|0;N=a+48|0;f[K>>2]=N;O=a+52|0;f[O>>2]=0;f[N>>2]=0;if((L|0)<3){f[N>>2]=f[D>>2];f[O>>2]=f[D+4>>2]}else{f[K>>2]=D;f[M>>2]=m;f[C>>2]=A;f[z>>2]=n}f[h>>2]=1124007936;G=j;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));break}if((e|0)<=0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;F=i+11|0;b[F>>0]=9;G=i;H=238092;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));J=i+9|0;b[J>>0]=0;vM(-215,i,238177,237260,817)}f[i>>2]=e;y=f[c+40>>2]|0;C=0;m=1;do{m=Y(f[y+(C<<2)>>2]|0,m)|0;C=C+1|0}while((C|0)!=(E|0));f[i+4>>2]=(m>>>0)/(e>>>0)|0;h0(a,c,d,2,i);C=f[x>>2]|0;if((C|0?(y=C+12|0,C=f[y>>2]|0,f[y>>2]=C+-1,(C|0)==1):0)?(C=f[x>>2]|0,C|0):0){f[x>>2]=0;y=f[C+4>>2]|0;if(!y){M=f[w>>2]|0;if(!M)P=L$()|0;else P=M}else P=y;mi[f[(f[P>>2]|0)+24>>2]&2047](P,C)}}else{C=(d|0)==0?k:d;y=Y(f[q>>2]|0,k)|0;M=(e|0)==0;if((C|0)>(y|0))if(M)Q=23;else{R=e;Q=25}else if(M&((y|0)%(C|0)|0|0)!=0)Q=23;else{S=e;Q=24}if((Q|0)==23){S=(Y(f[o>>2]|0,y)|0)/(C|0)|0;Q=24}if((Q|0)==24)if(!S)T=y;else{R=S;Q=25}do if((Q|0)==25){M=f[o>>2]|0;if((R|0)!=(M|0)){D=Y(M,y)|0;M=f[c>>2]|0;if(!(M&16384)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;K=$Xc(80)|0;f[i>>2]=K;f[i+8>>2]=-2147483568;f[i+4>>2]=72;G=K;H=243382;I=G+72|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[K+72>>0]=0;vM(-13,i,238177,237260,832)}if(R>>>0>D>>>0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;O=$Xc(32)|0;f[i>>2]=O;f[i+8>>2]=-2147483616;f[i+4>>2]=22;G=O;H=243455;I=G+22|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[O+22>>0]=0;vM(-211,i,238177,237260,835)}K=(D|0)/(R|0)|0;if((Y(K,R)|0)==(D|0)){f[n>>2]=R;N=Y(675553809>>>(M<<2&28)&15,K)|0;f[f[B>>2]>>2]=N;T=K;break}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;K=$Xc(80)|0;f[i>>2]=K;f[i+8>>2]=-2147483568;f[i+4>>2]=78;G=K;H=243272;I=G+78|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[K+78>>0]=0;vM(-5,i,238177,237260,841)}}else T=y}while(0);y=(T|0)/(C|0)|0;if((Y(y,C)|0)!=(T|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;m=$Xc(64)|0;f[i>>2]=m;f[i+8>>2]=-2147483584;f[i+4>>2]=62;G=m;H=243478;I=G+62|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[m+62>>0]=0;vM(-15,i,238177,237260,851)}f[p>>2]=y;M=f[h>>2]|0;D=(C<<3)+-8|0;O=M&-4089|D;f[h>>2]=O;N=Y(675553809>>>(M<<2&28)&15,(D>>>3&511)+1|0)|0;D=h+44|0;M=f[D>>2]|0;L=M+4|0;f[L>>2]=N;f[a>>2]=O;O=f[j>>2]|0;f[a+4>>2]=O;N=a+8|0;f[N>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];f[a+36>>2]=f[x>>2];U=a+40|0;f[U>>2]=N;N=a+44|0;V=a+48|0;f[N>>2]=V;W=a+52|0;f[W>>2]=0;f[V>>2]=0;if((O|0)<3){f[V>>2]=f[M>>2];f[W>>2]=f[L>>2]}else{f[N>>2]=M;f[U>>2]=f[z>>2];f[D>>2]=A;f[z>>2]=n}f[h>>2]=1124007936;G=j;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0))}while(0);f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[z>>2]|0;z=0;do{f[r+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[j>>2]|0))}j=f[B>>2]|0;if((j|0)==(A|0)){u=g;return}wL(j);u=g;return}function h0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+48|0;i=h+16|0;j=h;k=c+4|0;l=f[k>>2]|0;if((l|0)==(e|0)){if(!g){g0(a,c,d,0);u=h;return}if((e|0)==2){g0(a,c,d,f[g>>2]|0);u=h;return}}m=f[c>>2]|0;if(!(m&16384)){n=$Xc(80)|0;f[i>>2]=n;f[i+8>>2]=-2147483568;f[i+4>>2]=71;o=n;p=238412;q=o+71|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+71>>0]=0;vM(-213,i,238177,237260,907)}if(!((g|0)!=0&((d|0)>-1&(e+-1|0)>>>0<32))){n=$Xc(64)|0;f[i>>2]=n;f[i+8>>2]=-2147483584;f[i+4>>2]=62;o=n;p=238185;q=o+62|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+62>>0]=0;vM(-215,i,238177,237260,871)}if(d)if((d|0)<513)r=d;else{d=$Xc(32)|0;f[i>>2]=d;f[i+8>>2]=-2147483616;f[i+4>>2]=16;o=d;p=238248;q=o+16|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+16>>0]=0;vM(-215,i,238177,237260,876)}else r=(m>>>3&511)+1|0;if((l|0)<3)s=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{d=f[c+40>>2]|0;n=0;t=1;while(1){v=Y(f[d+(n<<2)>>2]|0,t)|0;n=n+1|0;if((n|0)==(l|0)){s=v;break}else t=v}}t=Y((m>>>3&511)+1|0,s)|0;s=i+8|0;f[i>>2]=s;m=i+4|0;f[m>>2]=e;if(e>>>0>4){l=bYc(e>>>0>1073741823?-1:e<<2)|0;f[i>>2]=l;w=l}else w=s;a:do if((e|0)>0){l=c+40|0;n=r;d=0;while(1){v=f[g+(d<<2)>>2]|0;if((v|0)<=-1){x=23;break}if(!v){if((d|0)>=(f[k>>2]|0)){x=27;break}y=f[(f[l>>2]|0)+(d<<2)>>2]|0}else y=v;f[w+(d<<2)>>2]=y;v=Y(y,n)|0;d=d+1|0;if((d|0)>=(e|0)){z=v;break a}else n=v}if((x|0)==23){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;n=$Xc(16)|0;f[j>>2]=n;f[j+8>>2]=-2147483632;f[j+4>>2]=14;o=n;p=238265;q=o+14|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+14>>0]=0;vM(-215,j,238177,237260,885)}else if((x|0)==27){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=$Xc(80)|0;f[j>>2]=d;f[j+8>>2]=-2147483568;f[j+4>>2]=68;o=d;p=238280;q=o+68|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+68>>0]=0;vM(-211,j,238177,237260,892)}}else z=r;while(0);if((z|0)!=(t|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=$Xc(64)|0;f[j>>2]=t;f[j+8>>2]=-2147483584;f[j+4>>2]=62;o=t;p=238349;q=o+62|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+62>>0]=0;vM(-209,j,238177,237260,898)}f[a>>2]=f[c>>2];j=a+4|0;t=f[k>>2]|0;f[j>>2]=t;p=a+8|0;f[p>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+36>>2]=o;q=a+40|0;f[q>>2]=p;p=a+48|0;z=a+44|0;f[z>>2]=p;f[p>>2]=0;f[a+52>>2]=0;if(!o)A=t;else{t=o+12|0;f[t>>2]=(f[t>>2]|0)+1;A=f[k>>2]|0}if((A|0)>=3){f[j>>2]=0;J$(a,A,0,0,0);if((f[j>>2]|0)>0){A=f[c+40>>2]|0;k=f[q>>2]|0;q=f[c+44>>2]|0;t=f[z>>2]|0;o=0;do{f[k+(o<<2)>>2]=f[A+(o<<2)>>2];f[t+(o<<2)>>2]=f[q+(o<<2)>>2];o=o+1|0}while((o|0)<(f[j>>2]|0))}}else{j=f[c+44>>2]|0;c=f[z>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2]}f[a>>2]=f[a>>2]&-4089|(r<<3)+-8;J$(a,e,f[i>>2]|0,0,1);e=f[i>>2]|0;if((e|0)!=(s|0)){if(e|0)dYc(e);f[i>>2]=s;f[m>>2]=4}u=h;return}function i0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=f[e>>2]|0;j=f[e+4>>2]|0;if((i|0)!=(j|0)){h0(a,c,d,j-i>>2,i);u=g;return}i=f[c+16>>2]|0;j=i;d=c+4|0;e=f[d>>2]|0;if(i|0){if((e|0)<3)k=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{i=f[c+40>>2]|0;l=0;m=1;while(1){n=Y(f[i+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(e|0)){k=n;break}else m=n}}if(!((e|0)==0|(k|0)==0)){f[h+8>>2]=0;b[h+11>>0]=7;b[h>>0]=b[238484]|0;b[h+1>>0]=b[238485]|0;b[h+2>>0]=b[238486]|0;b[h+3>>0]=b[238487]|0;b[h+4>>0]=b[238488]|0;b[h+5>>0]=b[238489]|0;b[h+6>>0]=b[238490]|0;b[h+7>>0]=0;vM(-215,h,238177,237260,915)}}f[a>>2]=f[c>>2];h=a+4|0;f[h>>2]=e;k=a+8|0;f[k>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=j;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];j=f[c+36>>2]|0;f[a+36>>2]=j;m=a+40|0;f[m>>2]=k;k=a+48|0;l=a+44|0;f[l>>2]=k;f[k>>2]=0;f[a+52>>2]=0;if(!j)o=e;else{e=j+12|0;f[e>>2]=(f[e>>2]|0)+1;o=f[d>>2]|0}if((o|0)<3){d=f[c+44>>2]|0;e=f[l>>2]|0;f[e>>2]=f[d>>2];f[e+4>>2]=f[d+4>>2];u=g;return}f[h>>2]=0;J$(a,o,0,0,0);if((f[h>>2]|0)<=0){u=g;return}o=f[c+40>>2]|0;a=f[m>>2]|0;m=f[c+44>>2]|0;c=f[l>>2]|0;l=0;do{f[a+(l<<2)>>2]=f[o+(l<<2)>>2];f[c+(l<<2)>>2]=f[m+(l<<2)>>2];l=l+1|0}while((l|0)<(f[h>>2]|0));u=g;return}function j0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+112|0;e=d+48|0;g=d;h=d+32|0;i=c+12|0;j=f[i>>2]|0;k=f[c+8>>2]|0;if(!((j|0)==1|(k|0)==1)){l=$Xc(32)|0;f[e>>2]=l;f[e+8>>2]=-2147483616;f[e+4>>2]=26;m=l;n=238492;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+26>>0]=0;vM(-215,e,238102,237260,924)}l=j+-1+k|0;k=f[c>>2]&4095;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[a>>2]=1124007936;j=a+8|0;n=a+40|0;m=a+4|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[n>>2]=j;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;f[e>>2]=l;f[e+4>>2]=l;S$(a,2,e,k);lR(a,g)|0;b0(e,a,0);if((f[i>>2]|0)==1){i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;jR(c,g)}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;c=h+8|0;f[c>>2]=0;f[c+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=e;AV(g,h)}h=e+36|0;g=f[h>>2]|0;if((g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)?(g=f[h>>2]|0,g|0):0){f[h>>2]=0;c=f[g+4>>2]|0;if(!c){i=f[e+32>>2]|0;if(!i)p=L$()|0;else p=i}else p=c;mi[f[(f[p>>2]|0)+24>>2]&2047](p,g)}f[h>>2]=0;h=e+16|0;g=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[g>>2]|0)>0){h=f[e+40>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)==(e+48|0)){u=d;return}wL(g);u=d;return}function k0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;if(!(f[a+16>>2]|0)){e=-1;return e|0}g=f[a>>2]|0;if(!((c|0)<1|(g&7|0)==(c|0))){e=-1;return e|0}c=g&16384;if(!((c|0)!=0|d^1)){e=-1;return e|0}d=f[a+4>>2]|0;switch(d|0){case 2:{if((f[a+8>>2]|0)!=1?(h=f[a+12>>2]|0,(h|0)!=1):0){i=h;j=9}else j=7;if((j|0)==7?((g>>>3&511)+1|0)!=(b|0):0){i=f[a+12>>2]|0;j=9}if((j|0)==9?!((i|0)==(b|0)&(g&4088|0)==0):0){e=-1;return e|0}k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;break}case 3:{if(g&4088|0){e=-1;return e|0}i=f[a+40>>2]|0;if((f[i+8>>2]|0)!=(b|0)){e=-1;return e|0}if((f[i>>2]|0)!=1?(f[i+4>>2]|0)!=1:0){e=-1;return e|0}if((c|0)==0?(c=f[a+44>>2]|0,(f[c+4>>2]|0)!=(Y(f[c+8>>2]|0,b)|0)):0){e=-1;return e|0}c=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[c+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(d|0)){k=j;break}else i=j}break}default:{e=-1;return e|0}}e=((Y((g>>>3&511)+1|0,k)|0)>>>0)/(b>>>0)|0;return e|0}function l0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[b+4>>2]|0;if((d|0)<3){e=f[b>>2]|0;g=f[b+12>>2]|0;h=f[b+8>>2]|0;b=x1c(g|0,((g|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;i=x1c(b|0,J|0,h|0,((h|0)<0)<<31>>31|0)|0;b=J;j=(e&16384|0)==0|((b|0)>0|(b|0)==0&i>>>0>2147483646);b=Y(g,c)|0;f[a>>2]=j?b:i;f[a+4>>2]=j?h:1;return}else mV(d,2,39180)}function m0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=u;u=u+64|0;h=g;i=c+4|0;j=f[i>>2]|0;if((j|0)>=3)mV(j,2,39208);j=d+4|0;k=f[j>>2]|0;if((k|0)>=3)mV(k,2,39236);k=c+40|0;l=f[k>>2]|0;m=d+40|0;n=f[m>>2]|0;if(!((f[l>>2]|0)!=(f[n>>2]|0)?1:(f[l+4>>2]|0)!=(f[n+4>>2]|0))){n=f[c>>2]|0;l=f[d>>2]|0;o=f[c+12>>2]|0;p=f[c+8>>2]|0;q=x1c(o|0,((o|0)<0)<<31>>31|0,e|0,((e|0)<0)<<31>>31|0)|0;r=x1c(q|0,J|0,p|0,((p|0)<0)<<31>>31|0)|0;q=J;s=(n&16384&l|0)==0|((q|0)>0|(q|0)==0&r>>>0>2147483646);q=Y(o,e)|0;t=s?p:1;v=s?q:r;f[a>>2]=v;w=a+4|0;f[w>>2]=t;u=g;return}r=c+8|0;q=f[r>>2]|0;s=c+12|0;p=f[s>>2]|0;o=Y(p,q)|0;if((o|0)!=(Y(f[d+12>>2]|0,f[d+8>>2]|0)|0))nV(o,Vk(d)|0,39264);l=d+12|0;n=d+8|0;if(!((p|0)==1|(q|0)==1)){q=$Xc(16)|0;f[h>>2]=q;f[h+8>>2]=-2147483632;f[h+4>>2]=12;x=q;y=238574;z=x+12|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[q+12>>0]=0;vM(-215,h,238587,237260,974)}if(!((f[l>>2]|0)==1|(f[n>>2]|0)==1)){q=$Xc(16)|0;f[h>>2]=q;f[h+8>>2]=-2147483632;f[h+4>>2]=12;x=q;y=238607;z=x+12|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[q+12>>0]=0;vM(-215,h,238587,237260,974)}q=(f[c>>2]&16384&f[d>>2]|0)==0;p=x1c(o|0,0,e|0,((e|0)<0)<<31>>31|0)|0;A=J;B=(A|0)>0|(A|0)==0&p>>>0>2147483646|q?o:1;g0(h,c,0,B);o=c+36|0;q=f[o>>2]|0;if((h|0)==(c|0)){p=h+36|0;if(((q|0)!=0?(A=q+12|0,C=f[A>>2]|0,f[A>>2]=C+-1,(C|0)==1):0)?(C=f[p>>2]|0,(C|0)!=0):0){f[p>>2]=0;A=f[C+4>>2]|0;if(!A){D=f[h+32>>2]|0;if(!D)E=L$()|0;else E=D}else E=A;mi[f[(f[E>>2]|0)+24>>2]&2047](E,C);F=p}else F=p}else{if((q|0?(p=q+12|0,q=f[p>>2]|0,f[p>>2]=q+-1,(q|0)==1):0)?(q=f[o>>2]|0,q|0):0){f[o>>2]=0;p=f[q+4>>2]|0;if(!p){C=f[c+32>>2]|0;if(!C)G=L$()|0;else G=C}else G=p;mi[f[(f[G>>2]|0)+24>>2]&2047](G,q)}f[o>>2]=0;q=c+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[i>>2]|0)>0){G=f[c+40>>2]|0;p=0;do{f[G+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[i>>2]|0))}f[c>>2]=f[h>>2];p=h+4|0;G=f[p>>2]|0;f[i>>2]=G;i=h+8|0;f[r>>2]=f[i>>2];f[s>>2]=f[h+12>>2];f[q>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];f[c+28>>2]=f[h+28>>2];f[c+32>>2]=f[h+32>>2];q=h+36|0;f[o>>2]=f[q>>2];o=c+44|0;C=f[o>>2]|0;E=c+48|0;if((C|0)==(E|0)){H=G;I=C}else{wL(C);f[o>>2]=E;f[c+40>>2]=r;H=f[p>>2]|0;I=E}E=h+44|0;if((H|0)<3){H=f[E>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2]}else{f[o>>2]=f[E>>2];o=h+40|0;f[k>>2]=f[o>>2];f[E>>2]=h+48;f[o>>2]=i}f[h>>2]=1124007936;x=p;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));F=q}f[F>>2]=0;F=h+16|0;q=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[q>>2]|0)>0){F=f[h+40>>2]|0;p=0;do{f[F+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[q>>2]|0))}q=f[h+44>>2]|0;if((q|0)!=(h+48|0))wL(q);g0(h,d,0,B);B=d+36|0;q=f[B>>2]|0;if((h|0)==(d|0)){p=h+36|0;if(((q|0)!=0?(F=q+12|0,i=f[F>>2]|0,f[F>>2]=i+-1,(i|0)==1):0)?(i=f[p>>2]|0,(i|0)!=0):0){f[p>>2]=0;F=f[i+4>>2]|0;if(!F){o=f[h+32>>2]|0;if(!o)K=L$()|0;else K=o}else K=F;mi[f[(f[K>>2]|0)+24>>2]&2047](K,i);L=p}else L=p}else{if((q|0?(p=q+12|0,q=f[p>>2]|0,f[p>>2]=q+-1,(q|0)==1):0)?(q=f[B>>2]|0,q|0):0){f[B>>2]=0;p=f[q+4>>2]|0;if(!p){i=f[d+32>>2]|0;if(!i)M=L$()|0;else M=i}else M=p;mi[f[(f[M>>2]|0)+24>>2]&2047](M,q)}f[B>>2]=0;q=d+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){M=f[d+40>>2]|0;p=0;do{f[M+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}f[d>>2]=f[h>>2];p=h+4|0;M=f[p>>2]|0;f[j>>2]=M;j=h+8|0;f[n>>2]=f[j>>2];f[l>>2]=f[h+12>>2];f[q>>2]=f[h+16>>2];f[d+20>>2]=f[h+20>>2];f[d+24>>2]=f[h+24>>2];f[d+28>>2]=f[h+28>>2];f[d+32>>2]=f[h+32>>2];q=h+36|0;f[B>>2]=f[q>>2];B=d+44|0;i=f[B>>2]|0;K=d+48|0;if((i|0)==(K|0)){N=M;O=i}else{wL(i);f[B>>2]=K;f[d+40>>2]=n;N=f[p>>2]|0;O=K}K=h+44|0;if((N|0)<3){N=f[K>>2]|0;f[O>>2]=f[N>>2];f[O+4>>2]=f[N+4>>2]}else{f[B>>2]=f[K>>2];B=h+40|0;f[m>>2]=f[B>>2];f[K>>2]=h+48;f[B>>2]=j}f[h>>2]=1124007936;x=p;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));L=q}f[L>>2]=0;L=h+16|0;q=h+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[q>>2]|0)>0){L=f[h+40>>2]|0;p=0;do{f[L+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[q>>2]|0))}q=f[h+44>>2]|0;if((q|0)!=(h+48|0))wL(q);q=f[s>>2]|0;if((q|0)!=(f[l>>2]|0)){P=$Xc(48)|0;f[h>>2]=P;Q=h+8|0;f[Q>>2]=-2147483600;R=h+4|0;f[R>>2]=40;x=P;y=238620;z=x+40|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));S=P+40|0;b[S>>0]=0;vM(-215,h,238587,237260,982)}l=f[r>>2]|0;if((l|0)!=(f[n>>2]|0)){P=$Xc(48)|0;f[h>>2]=P;Q=h+8|0;f[Q>>2]=-2147483600;R=h+4|0;f[R>>2]=40;x=P;y=238620;z=x+40|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));S=P+40|0;b[S>>0]=0;vM(-215,h,238587,237260,982)}t=l;v=Y(q,e)|0;f[a>>2]=v;w=a+4|0;f[w>>2]=t;u=g;return}function n0(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;h=u;u=u+64|0;i=h;j=c+4|0;k=f[j>>2]|0;if((k|0)>=3)mV(k,2,39292);k=d+4|0;l=f[k>>2]|0;if((l|0)>=3)mV(l,2,39320);l=e+4|0;m=f[l>>2]|0;if((m|0)>=3)mV(m,2,39348);m=c+40|0;n=f[m>>2]|0;o=f[n+4>>2]|0;p=f[n>>2]|0;n=d+40|0;q=f[n>>2]|0;if(!((p|0)!=(f[q>>2]|0)?1:(o|0)!=(f[q+4>>2]|0))?(q=f[e+40>>2]|0,!((p|0)!=(f[q>>2]|0)?1:(o|0)!=(f[q+4>>2]|0))):0){q=f[c>>2]|0;o=f[d>>2]|0;p=f[e>>2]|0;r=f[c+12>>2]|0;s=f[c+8>>2]|0;t=x1c(r|0,((r|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;v=x1c(t|0,J|0,s|0,((s|0)<0)<<31>>31|0)|0;t=J;w=(q&16384&o&p|0)==0|((t|0)>0|(t|0)==0&v>>>0>2147483646);t=Y(r,g)|0;x=w?s:1;y=w?t:v;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=h;return}v=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;if((v|0)!=(Y(f[d+12>>2]|0,f[d+8>>2]|0)|0))nV(v,Vk(d)|0,39376);if((v|0)!=(Y(f[e+12>>2]|0,f[e+8>>2]|0)|0))nV(v,Vk(e)|0,39404);t=c+12|0;w=c+8|0;s=d+12|0;r=d+8|0;p=e+12|0;o=e+8|0;q=(f[p>>2]|0)==1|(f[o>>2]|0)==1;if(!((f[t>>2]|0)==1|(f[w>>2]|0)==1)){A=$Xc(16)|0;f[i>>2]=A;f[i+8>>2]=-2147483632;f[i+4>>2]=12;B=A;C=238574;D=B+12|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[A+12>>0]=0;vM(-215,i,238587,237260,1003)}if(!((f[s>>2]|0)==1|(f[r>>2]|0)==1)){A=$Xc(16)|0;f[i>>2]=A;f[i+8>>2]=-2147483632;f[i+4>>2]=12;B=A;C=238607;D=B+12|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[A+12>>0]=0;vM(-215,i,238587,237260,1003)}if(!q){q=$Xc(16)|0;f[i>>2]=q;f[i+8>>2]=-2147483632;f[i+4>>2]=12;B=q;C=238745;D=B+12|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[q+12>>0]=0;vM(-215,i,238587,237260,1003)}q=(f[c>>2]&16384&f[d>>2]&f[e>>2]|0)==0;A=x1c(v|0,0,g|0,((g|0)<0)<<31>>31|0)|0;E=J;F=(E|0)>0|(E|0)==0&A>>>0>2147483646|q?v:1;g0(i,c,0,F);v=c+36|0;q=f[v>>2]|0;if((i|0)==(c|0)){A=i+36|0;if(((q|0)!=0?(E=q+12|0,G=f[E>>2]|0,f[E>>2]=G+-1,(G|0)==1):0)?(G=f[A>>2]|0,(G|0)!=0):0){f[A>>2]=0;E=f[G+4>>2]|0;if(!E){H=f[i+32>>2]|0;if(!H)I=L$()|0;else I=H}else I=E;mi[f[(f[I>>2]|0)+24>>2]&2047](I,G);K=A}else K=A}else{if((q|0?(A=q+12|0,q=f[A>>2]|0,f[A>>2]=q+-1,(q|0)==1):0)?(q=f[v>>2]|0,q|0):0){f[v>>2]=0;A=f[q+4>>2]|0;if(!A){G=f[c+32>>2]|0;if(!G)L=L$()|0;else L=G}else L=A;mi[f[(f[L>>2]|0)+24>>2]&2047](L,q)}f[v>>2]=0;q=c+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){L=f[c+40>>2]|0;A=0;do{f[L+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[j>>2]|0))}f[c>>2]=f[i>>2];A=i+4|0;L=f[A>>2]|0;f[j>>2]=L;j=i+8|0;f[w>>2]=f[j>>2];f[t>>2]=f[i+12>>2];f[q>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[c+28>>2]=f[i+28>>2];f[c+32>>2]=f[i+32>>2];q=i+36|0;f[v>>2]=f[q>>2];v=c+44|0;G=f[v>>2]|0;I=c+48|0;if((G|0)==(I|0)){M=L;N=G}else{wL(G);f[v>>2]=I;f[c+40>>2]=w;M=f[A>>2]|0;N=I}I=i+44|0;if((M|0)<3){M=f[I>>2]|0;f[N>>2]=f[M>>2];f[N+4>>2]=f[M+4>>2]}else{f[v>>2]=f[I>>2];v=i+40|0;f[m>>2]=f[v>>2];f[I>>2]=i+48;f[v>>2]=j}f[i>>2]=1124007936;B=A;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));K=q}f[K>>2]=0;K=i+16|0;q=i+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[q>>2]|0)>0){K=f[i+40>>2]|0;A=0;do{f[K+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))wL(q);g0(i,d,0,F);q=d+36|0;A=f[q>>2]|0;if((i|0)==(d|0)){K=i+36|0;if(((A|0)!=0?(j=A+12|0,v=f[j>>2]|0,f[j>>2]=v+-1,(v|0)==1):0)?(v=f[K>>2]|0,(v|0)!=0):0){f[K>>2]=0;j=f[v+4>>2]|0;if(!j){I=f[i+32>>2]|0;if(!I)O=L$()|0;else O=I}else O=j;mi[f[(f[O>>2]|0)+24>>2]&2047](O,v);P=K}else P=K}else{if((A|0?(K=A+12|0,A=f[K>>2]|0,f[K>>2]=A+-1,(A|0)==1):0)?(A=f[q>>2]|0,A|0):0){f[q>>2]=0;K=f[A+4>>2]|0;do if(!K){v=f[d+32>>2]|0;if(v|0){Q=v;break}Q=L$()|0}else Q=K;while(0);mi[f[(f[Q>>2]|0)+24>>2]&2047](Q,A)}f[q>>2]=0;A=d+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[k>>2]|0)>0){Q=f[d+40>>2]|0;K=0;do{f[Q+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[k>>2]|0))}f[d>>2]=f[i>>2];K=i+4|0;Q=f[K>>2]|0;f[k>>2]=Q;k=i+8|0;f[r>>2]=f[k>>2];f[s>>2]=f[i+12>>2];f[A>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];f[d+28>>2]=f[i+28>>2];f[d+32>>2]=f[i+32>>2];A=i+36|0;f[q>>2]=f[A>>2];q=d+44|0;v=f[q>>2]|0;O=d+48|0;if((v|0)==(O|0)){R=Q;S=v}else{wL(v);f[q>>2]=O;f[d+40>>2]=r;R=f[K>>2]|0;S=O}O=i+44|0;if((R|0)<3){R=f[O>>2]|0;f[S>>2]=f[R>>2];f[S+4>>2]=f[R+4>>2]}else{f[q>>2]=f[O>>2];q=i+40|0;f[n>>2]=f[q>>2];f[O>>2]=i+48;f[q>>2]=k}f[i>>2]=1124007936;B=K;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));P=A}f[P>>2]=0;P=i+16|0;A=i+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[A>>2]|0)>0){P=f[i+40>>2]|0;K=0;do{f[P+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)!=(i+48|0))wL(A);g0(i,e,0,F);F=e+36|0;A=f[F>>2]|0;if((i|0)==(e|0)){K=i+36|0;if(((A|0)!=0?(P=A+12|0,k=f[P>>2]|0,f[P>>2]=k+-1,(k|0)==1):0)?(k=f[K>>2]|0,(k|0)!=0):0){f[K>>2]=0;P=f[k+4>>2]|0;do if(!P){q=f[i+32>>2]|0;if(q|0){T=q;break}T=L$()|0}else T=P;while(0);mi[f[(f[T>>2]|0)+24>>2]&2047](T,k);U=K}else U=K}else{do if(A|0?(K=A+12|0,k=f[K>>2]|0,f[K>>2]=k+-1,(k|0)==1):0){k=f[F>>2]|0;if(!k)break;f[F>>2]=0;K=f[k+4>>2]|0;do if(!K){T=f[e+32>>2]|0;if(T|0){V=T;break}V=L$()|0}else V=K;while(0);mi[f[(f[V>>2]|0)+24>>2]&2047](V,k)}while(0);f[F>>2]=0;V=e+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[l>>2]|0)>0){A=f[e+40>>2]|0;K=0;do{f[A+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[l>>2]|0))}f[e>>2]=f[i>>2];K=i+4|0;A=f[K>>2]|0;f[l>>2]=A;l=i+8|0;f[o>>2]=f[l>>2];f[p>>2]=f[i+12>>2];f[V>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];V=i+36|0;f[F>>2]=f[V>>2];F=e+44|0;T=f[F>>2]|0;P=e+48|0;if((T|0)==(P|0)){W=A;X=T}else{wL(T);f[F>>2]=P;f[e+40>>2]=o;W=f[K>>2]|0;X=P}P=i+44|0;if((W|0)<3){W=f[P>>2]|0;f[X>>2]=f[W>>2];f[X+4>>2]=f[W+4>>2]}else{f[F>>2]=f[P>>2];F=i+40|0;f[e+40>>2]=f[F>>2];f[P>>2]=i+48;f[F>>2]=l}f[i>>2]=1124007936;B=K;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));U=V}f[U>>2]=0;U=i+16|0;V=i+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[V>>2]|0)>0){U=f[i+40>>2]|0;K=0;do{f[U+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[V>>2]|0))}V=f[i+44>>2]|0;if((V|0)!=(i+48|0))wL(V);V=f[t>>2]|0;if((V|0)!=(f[s>>2]|0)){Z=$Xc(96)|0;f[i>>2]=Z;_=i+8|0;f[_>>2]=-2147483552;$=i+4|0;f[$>>2]=84;B=Z;C=238758;D=B+84|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));aa=Z+84|0;b[aa>>0]=0;vM(-215,i,238587,237260,1012)}s=f[w>>2]|0;if(!(((s|0)==(f[r>>2]|0)?(V|0)==(f[p>>2]|0):0)&(s|0)==(f[o>>2]|0))){Z=$Xc(96)|0;f[i>>2]=Z;_=i+8|0;f[_>>2]=-2147483552;$=i+4|0;f[$>>2]=84;B=Z;C=238758;D=B+84|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));aa=Z+84|0;b[aa>>0]=0;vM(-215,i,238587,237260,1012)}x=s;y=Y(V,g)|0;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=h;return}function o0(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=$Xc(12)|0;f[j>>2]=39440;f[j+4>>2]=0;b[j+8>>0]=0;p0(j);cYc(j);j=$Xc(2296)|0;f[j>>2]=39460;k=j+8|0;b[j+48>>0]=0;f[j+44>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;d[k+32>>1]=0;b[k+34>>0]=0;k=(fN(4)|0)&1;b[j+43>>0]=k;f[j+192>>2]=j+200;f[j+196>>2]=1032;f[j+1232>>2]=j+1240;f[j+1236>>2]=264;f[j+12>>2]=j+56;q0(j,c,e,g,h,i);f[a>>2]=j;i=$Xc(16)|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=39480;f[i+12>>2]=j;f[a+4>>2]=i;return}function p0(a){a=a|0;f[a>>2]=39440;return}function q0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0;i=a+8|0;j=a+36|0;k=f[j>>2]|0;l=(g&128|0)==0;m=(e|0)==5?8:16;n=a+40|0;o=g&1;b[n>>0]=o;q=(g&32|0)!=0;b[a+42>>0]=(g&144|0)==16&1;r=a+16|0;p[r>>3]=1.0;f[a+32>>2]=c;f[j>>2]=c;b[a+48>>0]=0;s=(k|0)!=(c|0);k=a+12|0;t=f[k>>2]|0;if(s){if((c|0)>=6){u=(c+-1^c)+1>>1;if((u|0)>1){f[t>>2]=u;if((u|0)!=(c|0)?(v=(c>>>0)/(u>>>0)|0,(v|0)>1):0){w=3;x=v;y=1;z=8}else A=1}else{w=3;x=c;y=0;z=8}a:do if((z|0)==8){b:while(1){z=0;v=w;while(1){B=(x|0)/(v|0)|0;if((Y(B,v)|0)==(x|0))break;u=v+2|0;if((Y(u,u)|0)>(x|0))break b;else v=u}u=y+1|0;f[t+(y<<2)>>2]=v;if((B|0)>1){w=v;x=B;y=u;z=8}else{A=u;break a}}f[t+(y<<2)>>2]=x;A=y+1|0}while(0);y=f[t>>2]&1^1;x=(y+A|0)/2|0;if((y|0)<(x|0)){B=A+-1+y|0;w=y;do{y=t+(w<<2)|0;u=f[y>>2]|0;C=t+(B-w<<2)|0;f[y>>2]=f[C>>2];f[C>>2]=u;w=w+1|0}while((w|0)!=(x|0));D=A}else D=A}else{f[t>>2]=c;D=1}f[i>>2]=D;A=(f[t>>2]|0)==(f[t+(D+-1<<2)>>2]|0);if(!s)if(A)E=1;else{F=i;z=18}else{G=i;H=A;z=19}}else if((f[t>>2]|0)==(f[t+((f[i>>2]|0)+-1<<2)>>2]|0))E=1;else{F=i;z=18}if((z|0)==18)if(o<<24>>24==0|q^1)E=0;else{G=F;H=0;z=19}if((z|0)==19){F=a+192|0;o=Y(f[j>>2]|0,m)|0;i=a+196|0;if((f[i>>2]|0)>>>0<o>>>0){t=f[F>>2]|0;A=a+200|0;if((t|0)==(A|0))I=t;else{if(t|0)dYc(t);f[F>>2]=A;f[i>>2]=1032;I=A}f[i>>2]=o;if(o>>>0>1032){A=bYc(o)|0;f[F>>2]=A;J=A}else J=I}else{f[i>>2]=o;J=f[F>>2]|0}F=a+28|0;f[F>>2]=J;J=a+1232|0;o=f[j>>2]|0;i=a+1236|0;if((f[i>>2]|0)>>>0<o>>>0){I=f[J>>2]|0;A=a+1240|0;if((I|0)==(A|0))K=I;else{if(I|0)dYc(I);f[J>>2]=A;f[i>>2]=264;K=A}f[i>>2]=o;if(o>>>0>264){A=bYc(o>>>0>1073741823?-1:o<<2)|0;f[J>>2]=A;L=A}else L=K}else{f[i>>2]=o;L=f[J>>2]|0}f[a+24>>2]=L;if(l)M=q&(b[n>>0]|0)!=0;else M=0;v0(f[j>>2]|0,f[G>>2]|0,f[k>>2]|0,L,m,f[F>>2]|0,M&1);E=H}do if(!h)z=44;else{if(l){if(E|(b[h>>0]|0)==0?(c&1|0)==0|q^1:0){z=44;break}}else if(E){N=0;O=1;break}b[h>>0]=1;z=44}while(0);if((z|0)==44){z=l^1;if(z|q^1){N=0;O=z}else{N=(b[n>>0]|0)==0?1:2;O=0}}f[a+44>>2]=f[39500+(((e|0)==6?N+3|0:N)<<2)>>2];if((g&66|0)!=2)return;P=1.0/+(Y((g&4|0)==0|O?d:1,c)|0);p[r>>3]=P;return}function r0(a){a=a|0;NXc(a);cYc(a);return}function s0(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+8>>2]&4095](b);return}function t0(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==238929?a+12|0:0)|0}function u0(a){a=a|0;cYc(a);return}function v0(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,N=0.0,O=0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0;j=u;u=u+272|0;k=j+136|0;l=j;m=f[c>>2]|0;do if((a|0)<6){f[d>>2]=0;o=a+-1|0;f[d+(o<<2)>>2]=o;if((a|0)==4){f[d+4>>2]=2;f[d+8>>2]=1;q=2;break}if((o|0)>1)r=1;else{u=j;return}do{f[d+(r<<2)>>2]=r;r=r+1|0}while((r|0)!=(o|0));if((a|0)!=5){u=j;return}if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;u=j;return}else{f[g>>2]=1065353216;f[g+4>>2]=0;u=j;return}}else{f[l+(b<<2)>>2]=1;f[k+(b<<2)>>2]=0;if((b|0)>0){g1c(k|0,0,b<<2|0)|0;o=0;do{s=b-o|0;t=s+-1|0;v=Y(f[c+(t<<2)>>2]|0,f[l+(s<<2)>>2]|0)|0;f[l+(t<<2)>>2]=v;o=o+1|0}while((o|0)!=(b|0))}if(!i)w=d;else w=(m|0)==(f[c+(b+-1<<2)>>2]|0)?d:g;a:do if(!(m&1)){o=f[l+4>>2]|0;v=Y(o,m)|0;t=v>>1;s=0;while(1)if(1<<s>>>0<m>>>0)s=s+1|0;else break;x=v>>2;do if((m|0)>=3)if((m|0)<257){y=10-s|0;z=m+-4|0;if((m|0)<4)break;else A=0;do{B=Y((h[239181+(A>>2)>>0]|0)>>>y,o)|0;f[w+(A<<2)>>2]=B;C=B+t|0;f[w+((A|1)<<2)>>2]=C;f[w+((A|2)<<2)>>2]=B+x;f[w+((A|3)<<2)>>2]=C+x;A=A+4|0}while((A|0)<=(z|0))}else{z=34-s|0;y=0;do{C=Y(((h[239181+(y>>>10&255)>>0]|0)<<16|(h[239181+(y>>>2&255)>>0]|0)<<24|(h[239181+(y>>>18&255)>>0]|0)<<8|(h[239181+(y>>26)>>0]|0))>>>z,o)|0;f[w+(y<<2)>>2]=C;B=C+t|0;f[w+((y|1)<<2)>>2]=B;f[w+((y|2)<<2)>>2]=C+x;f[w+((y|3)<<2)>>2]=B+x;y=y+4|0}while((y|0)<(m|0))}else{f[w>>2]=0;f[w+4>>2]=t}while(0);t=k+4|0;f[t>>2]=(f[t>>2]|0)+1;if((b|0)>1?(x=f[l+8>>2]|0,(m|0)<(a|0)):0){o=c+4|0;if((m|0)>0){v=x;y=m;b:while(1){z=0;do{f[w+(z+y<<2)>>2]=(f[w+(z<<2)>>2]|0)+v;z=z+1|0}while((z|0)!=(m|0));z=y+m|0;if((z|0)>=(a|0)){D=s;break a}B=x+v|0;C=(f[t>>2]|0)+1|0;f[t>>2]=C;if((C|0)<(f[o>>2]|0)){v=B;y=z;continue}else{E=B;F=1;G=t}while(1){f[G>>2]=0;B=(f[l+(F+2<<2)>>2]|0)+E-(f[l+(F<<2)>>2]|0)|0;C=F+1|0;H=k+(C<<2)|0;I=(f[H>>2]|0)+1|0;f[H>>2]=I;if((I|0)<(f[c+(C<<2)>>2]|0)){v=B;y=z;continue b}else{E=B;F=C;G=H}}}}else{y=m<<1;if((y|0)>=(a|0)){D=s;break}v=f[o>>2]|0;x=y;do{y=(f[t>>2]|0)+1|0;f[t>>2]=y;if((y|0)>=(v|0)){y=1;z=t;do{f[z>>2]=0;y=y+1|0;z=k+(y<<2)|0;H=(f[z>>2]|0)+1|0;f[z>>2]=H}while((H|0)>=(f[c+(y<<2)>>2]|0))}x=x+m|0}while((x|0)<(a|0));D=s}}else D=s}else{f[w>>2]=0;if((a|0)>1){x=f[l+4>>2]|0;t=0;v=1;while(1){o=x+t|0;y=(f[k>>2]|0)+1|0;f[k>>2]=y;if((y|0)<(f[c>>2]|0))J=o;else{y=0;z=o;o=k;while(1){f[o>>2]=0;H=(f[l+(y+2<<2)>>2]|0)+z-(f[l+(y<<2)>>2]|0)|0;y=y+1|0;o=k+(y<<2)|0;C=(f[o>>2]|0)+1|0;f[o>>2]=C;if((C|0)<(f[c+(y<<2)>>2]|0)){J=H;break}else z=H}}f[w+(v<<2)>>2]=J;v=v+1|0;if((v|0)==(a|0)){D=0;break}else t=J}}else D=0}while(0);if((w|0)!=(d|0)?(f[d>>2]=0,t=a&1,(t|0)<(a|0)):0){v=t;do{t=v+1|0;x=f[w+(t<<2)>>2]|0;f[d+(f[w+(v<<2)>>2]<<2)>>2]=v;f[d+(x<<2)>>2]=t;v=v+2|0}while((v|0)<(a|0));q=D}else q=D}while(0);if(!(a+-1&a)){K=+p[7272+(q<<4)>>3];L=-+p[7272+(q<<4)+8>>3]}else{N=+P(+(-6.283185307179586/+(a|0)));K=+M(+(1.0-N*N));L=N}q=(a+1|0)/2|0;D=(a&1|0)==0;if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;if(D){p[g+(q<<4)>>3]=-1.0;p[g+(q<<4)+8>>3]=0.0}if((a|0)>2){O=1;Q=K;R=L}else{u=j;return}while(1){p[g+(O<<4)>>3]=Q;p[g+(O<<4)+8>>3]=R;e=a-O|0;p[g+(e<<4)>>3]=Q;p[g+(e<<4)+8>>3]=-R;N=K*R+L*Q;O=O+1|0;if((O|0)>=(q|0))break;else{Q=K*Q-L*R;R=N}}u=j;return}else{n[g>>2]=1.0;n[g+4>>2]=0.0;if(D){n[g+(q<<3)>>2]=-1.0;n[g+(q<<3)+4>>2]=0.0}if((a|0)>2){S=1;T=K;U=L}else{u=j;return}while(1){R=T;n[g+(S<<3)>>2]=R;Q=U;n[g+(S<<3)+4>>2]=Q;D=a-S|0;n[g+(D<<3)>>2]=R;n[g+(D<<3)+4>>2]=-Q;Q=K*U+L*T;S=S+1|0;if((S|0)>=(q|0))break;else{T=K*T-L*U;U=Q}}u=j;return}}function w0(a,b,c){a=a|0;b=b|0;c=c|0;G0(a,b,c);return}function x0(a,b,c){a=a|0;b=b|0;c=c|0;H0(a,b,c);return}function y0(a,b,c){a=a|0;b=b|0;c=c|0;F0(a,b,c);return}function z0(a,b,c){a=a|0;b=b|0;c=c|0;D0(a,b,c);return}function A0(a,b,c){a=a|0;b=b|0;c=c|0;E0(a,b,c);return}function B0(a,b,c){a=a|0;b=b|0;c=c|0;C0(a,b,c);return}function C0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0.0,P=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+8|0;l=+p[k>>3];m=+p[c>>3];p[k>>3]=m;n=k;o=l;q=m}else{n=c;o=0.0;q=+p[c>>3]}a:do switch(h|0){case 1:{p[d>>3]=j*q;break}case 2:{m=+p[n+8>>3];p[d+8>>3]=j*(q-m);p[d>>3]=j*(q+m);break}default:{c=h+1>>1;if(h&1|0){k=n+-8|0;p[d>>3]=q;p[d+8>>3]=0.0;if((c|0)>1){r=f[a+16>>2]|0;s=1;do{t=f[r+(s<<2)>>2]|0;v=f[r+(h-s<<2)>>2]|0;m=+p[k+(s<<4)>>3];l=+p[k+(s<<4)+8>>3];p[d+(t<<4)>>3]=m;p[d+(t<<4)+8>>3]=-l;p[d+(v<<4)>>3]=m;p[d+(v<<4)+8>>3]=l;s=s+1|0}while((s|0)!=(c|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;D0(g,d,d);p[d>>3]=j*+p[d>>3];if((h|0)>1){s=1;do{k=s<<1;l=j*+p[d+(k+2<<3)>>3];p[d+(s<<3)>>3]=j*+p[d+(k<<3)>>3];p[d+(s+1<<3)>>3]=l;s=s+2|0}while((s|0)<(h|0))}break a}s=(n|0)==(d|0);k=f[a+20>>2]|0;l=+p[n+8>>3];m=+p[n+(h+-1<<3)>>3];p[d>>3]=q+m;p[d+8>>3]=m-q;r=k+16|0;do if((c|0)>2){if(s){v=r;m=l;t=2;z=k;while(1){A=h-t|0;B=+p[d+(A+-1<<3)>>3];C=m+B;D=d+(t<<3)|0;E=+p[D>>3];F=d+(A<<3)|0;G=+p[F>>3];H=E-G;I=m-B;B=E+G;G=+p[v>>3];E=+p[z+24>>3];J=I*G+B*E;K=B*G-I*E;L=d+((t|1)<<3)|0;m=+p[L>>3];p[D>>3]=C-K;p[L>>3]=-H-J;p[F>>3]=C+K;p[d+(A+1<<3)>>3]=H-J;t=t+2|0;if((t|0)>=(c|0))break;else{A=v;v=v+16|0;z=A}}M=m;N=c+1&-2;break}z=f[a+16>>2]|0;v=r;J=l;t=2;A=k;while(1){F=h-t|0;H=+p[n+(F+-1<<3)>>3];K=J+H;C=+p[n+(t<<3)>>3];E=+p[n+(F<<3)>>3];I=C-E;G=J-H;H=C+E;E=+p[v>>3];C=+p[A+24>>3];B=G*E+H*C;O=H*E-G*C;J=+p[n+((t|1)<<3)>>3];F=t>>1;L=f[z+(F<<2)>>2]|0;p[d+(L<<3)>>3]=K-O;p[d+(L+1<<3)>>3]=-I-B;L=f[z+(c-F<<2)>>2]|0;p[d+(L<<3)>>3]=K+O;p[d+(L+1<<3)>>3]=I-B;t=t+2|0;if((t|0)>=(c|0))break;else{L=v;v=v+16|0;A=L}}M=J;N=c+1&-2}else{M=l;N=2}while(0);if((N|0)<=(c|0)){l=+p[n+(c<<3)>>3]*2.0;if(s)P=c;else P=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;p[d+(P<<3)>>3]=M*2.0;p[d+(P+1<<3)>>3]=l}k=a+4|0;r=f[k>>2]|0;A=f[r>>2]>>1;f[r>>2]=A;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));r=(A|0)==1&1;v=g+4|0;f[v>>2]=(f[v>>2]|0)+(r<<2);f[g>>2]=(f[g>>2]|0)-r;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(s^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;D0(g,d,d);r=f[k>>2]|0;f[r>>2]=f[r>>2]<<1;if((h|0)>0){r=0;do{v=d+(r<<3)|0;t=d+((r|1)<<3)|0;l=-(j*+p[t>>3]);p[v>>3]=j*+p[v>>3];p[t>>3]=l;r=r+2|0}while((r|0)<(h|0))}}}while(0);if(!i){u=e;return}p[n>>3]=o;u=e;return}function D0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+1168|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;n=f[m>>2]|0;o=+p[a+8>>3];if((n|0)!=(k|0))if((n|0)==(k<<1|0))q=2;else q=(n|0)/(k|0)|0;else q=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){r=f[a+4>>2]|0;s=f[a>>2]|0;if((f[r>>2]|0)!=(f[r+(s+-1<<2)>>2]|0)){r=$Xc(48)|0;f[g>>2]=r;f[g+8>>2]=-2147483600;f[g+4>>2]=33;t=r;v=239078;w=t+33|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[r+33>>0]=0;vM(-215,g,239112,239116,657)}if((s|0)!=1){if((k|0)>0){x=0;y=i}else break;while(1){v=f[y>>2]|0;if((v|0)>(x|0)){t=d+(x<<4)|0;z=+p[t>>3];A=+p[d+(x<<4)+8>>3];w=d+(v<<4)|0;f[t>>2]=f[w>>2];f[t+4>>2]=f[w+4>>2];f[t+8>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];p[w>>3]=z;p[d+(v<<4)+8>>3]=A}x=x+1|0;if((x|0)==(k|0))break a;else y=y+(q<<2)|0}}if((k&3|0)==0?(s=(k|0)/2|0,r=d+(s<<4)|0,(k|0)>1):0){v=q<<1;w=0;t=i;while(1){B=f[t>>2]|0;C=w|1;D=d+(C<<4)|0;A=+p[D>>3];z=+p[d+(C<<4)+8>>3];E=r+(B<<4)|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2];f[D+8>>2]=f[E+8>>2];f[D+12>>2]=f[E+12>>2];p[E>>3]=A;p[E+8>>3]=z;if((B|0)>(w|0)){E=d+(w<<4)|0;z=+p[E>>3];A=+p[d+(w<<4)+8>>3];D=d+(B<<4)|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];f[E+8>>2]=f[D+8>>2];f[E+12>>2]=f[D+12>>2];p[D>>3]=z;p[d+(B<<4)+8>>3]=A;D=r+(C<<4)|0;A=+p[D>>3];z=+p[D+8>>3];C=r+(B+1<<4)|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];f[D+8>>2]=f[C+8>>2];f[D+12>>2]=f[C+12>>2];p[C>>3]=A;p[C+8>>3]=z}w=w+2|0;if((w|0)>=(s|0))break;else t=t+(v<<2)|0}}}while(0);if(l){v=k+-2|0;if((k|0)<2)F=0;else{t=0;do{s=d+(t<<4)+8|0;w=d+((t|1)<<4)+8|0;z=-+p[w>>3];p[s>>3]=-+p[s>>3];p[w>>3]=z;t=t+2|0}while((t|0)<=(v|0));F=k&-2}v=d+(k+-1<<4)+8|0;if((F|0)<(k|0))p[v>>3]=-+p[v>>3]}}else{v=k+-2|0;t=(k|0)<2;if(l){if(t)G=0;else{w=q<<1;s=0;r=i;while(1){C=f[r>>2]|0;D=f[r+(q<<2)>>2]|0;z=-+p[c+(C<<4)+8>>3];p[d+(s<<4)>>3]=+p[c+(C<<4)>>3];p[d+(s<<4)+8>>3]=z;z=-+p[c+(D<<4)+8>>3];C=s|1;p[d+(C<<4)>>3]=+p[c+(D<<4)>>3];p[d+(C<<4)+8>>3]=z;s=s+2|0;if((s|0)>(v|0))break;else r=r+(w<<2)|0}G=k&-2}if((G|0)>=(k|0))break;w=k+-1|0;z=-+p[c+(w<<4)+8>>3];p[d+(G<<4)>>3]=+p[c+(w<<4)>>3];p[d+(G<<4)+8>>3]=z;break}else{if(t)H=0;else{w=q<<1;r=0;s=i;while(1){C=f[s+(q<<2)>>2]|0;D=c+(f[s>>2]<<4)|0;B=d+(r<<4)|0;f[B>>2]=f[D>>2];f[B+4>>2]=f[D+4>>2];f[B+8>>2]=f[D+8>>2];f[B+12>>2]=f[D+12>>2];D=c+(C<<4)|0;C=d+((r|1)<<4)|0;f[C>>2]=f[D>>2];f[C+4>>2]=f[D+4>>2];f[C+8>>2]=f[D+8>>2];f[C+12>>2]=f[D+12>>2];r=r+2|0;if((r|0)>(v|0))break;else s=s+(w<<2)|0}H=k&-2}w=k+-1|0;if((H|0)>=(k|0))break;s=c+(w<<4)|0;v=d+(w<<4)|0;f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2];f[v+8>>2]=f[s+8>>2];f[v+12>>2]=f[s+12>>2];break}}while(0);c=a+4|0;k=f[c>>2]|0;H=f[k>>2]|0;q=H&1;if(!q){if((H|0)<4){I=1;J=n}else{i=f[j>>2]|0;G=(i|0)>0;F=1;y=n;x=4;while(1){s=(y|0)/4|0;if(G){v=F<<1;w=(F|0)>1;r=0;do{t=d+(r<<4)|0;D=t+(v<<4)|0;z=+p[D>>3];C=D+8|0;A=+p[C>>3];B=D+(F<<4)|0;K=+p[B>>3];E=B+8|0;L=+p[E>>3];M=z+K;N=A+L;O=A-L;L=K-z;z=+p[t>>3];P=d+(r<<4)+8|0;K=+p[P>>3];Q=t+(F<<4)|0;A=+p[Q>>3];R=Q+8|0;S=+p[R>>3];T=z+A;U=K+S;V=z-A;A=K-S;p[t>>3]=M+T;p[P>>3]=N+U;p[D>>3]=T-M;p[C>>3]=U-N;p[Q>>3]=O+V;p[R>>3]=L+A;p[B>>3]=V-O;p[E>>3]=A-L;if(w){E=s;B=1;while(1){R=t+(B<<4)|0;Q=R+(v<<4)|0;C=R+(F<<4)|0;L=+p[C>>3];D=E<<1;A=+p[h+(D<<4)>>3];P=C+8|0;O=+p[P>>3];V=+p[h+(D<<4)+8>>3];N=L*A-O*V;U=A*O+L*V;V=+p[Q>>3];L=+p[h+(E<<4)+8>>3];D=Q+8|0;O=+p[D>>3];A=+p[h+(E<<4)>>3];M=V*L+O*A;T=V*A-L*O;W=Q+(F<<4)|0;O=+p[W>>3];X=E*3|0;L=+p[h+(X<<4)+8>>3];Z=W+8|0;A=+p[Z>>3];V=+p[h+(X<<4)>>3];S=O*L+A*V;K=O*V-L*A;A=T+K;L=M+S;V=M-S;S=K-T;T=+p[R>>3];X=R+8|0;K=+p[X>>3];M=N+T;O=U+K;z=T-N;N=K-U;p[R>>3]=M+A;p[X>>3]=O+L;p[Q>>3]=M-A;p[D>>3]=O-L;p[C>>3]=z+V;p[P>>3]=N+S;p[W>>3]=z-V;p[Z>>3]=N-S;B=B+1|0;if((B|0)==(F|0))break;else E=E+s|0}}r=r+x|0}while((r|0)<(i|0))}r=x<<2;if((r|0)>(H|0)){I=x;J=s;break}else{v=x;y=s;x=r;F=v}}}if((I|0)<(H|0)){F=f[j>>2]|0;x=(F|0)>0;y=I;i=J;while(1){G=y<<1;v=(i|0)/2|0;b:do if(x){if((y|0)>1)_=0;else{r=0;while(1){w=d+(r<<4)|0;S=+p[w>>3];E=w+(y<<4)|0;N=+p[E>>3];B=d+(r<<4)+8|0;V=+p[B>>3];t=E+8|0;z=+p[t>>3];p[w>>3]=S+N;p[B>>3]=V+z;p[E>>3]=S-N;p[t>>3]=V-z;r=r+G|0;if((r|0)>=(F|0))break b}}do{r=d+(_<<4)|0;z=+p[r>>3];t=r+(y<<4)|0;V=+p[t>>3];E=d+(_<<4)+8|0;N=+p[E>>3];B=t+8|0;S=+p[B>>3];p[r>>3]=z+V;p[E>>3]=N+S;p[t>>3]=z-V;p[B>>3]=N-S;B=v;t=1;while(1){E=r+(t<<4)|0;w=E+(y<<4)|0;S=+p[w>>3];N=+p[h+(B<<4)>>3];Z=w+8|0;V=+p[Z>>3];z=+p[h+(B<<4)+8>>3];L=S*N-V*z;O=N*V+S*z;z=+p[E>>3];W=E+8|0;S=+p[W>>3];p[E>>3]=z+L;p[W>>3]=S+O;p[w>>3]=z-L;p[Z>>3]=S-O;t=t+1|0;if((t|0)==(y|0))break;else B=B+v|0}_=_+G|0}while((_|0)<(F|0))}while(0);if((G|0)<(H|0)){y=G;i=v}else{$=G;aa=v;break}}}else{$=I;aa=J}}else{$=1;aa=n}n=q^1;c:do if((n|0)<(f[a>>2]|0)){q=g+8|0;J=g+4|0;I=n;i=$;y=aa;H=k;while(1){F=f[H+(I<<2)>>2]|0;_=Y(F,i)|0;x=(y|0)/(F|0)|0;d:do switch(F|0){case 3:{s=f[j>>2]|0;if((s|0)>0){B=i<<1;if((i|0)>1)ba=0;else{t=0;while(1){r=d+(t<<4)|0;Z=r+(i<<4)|0;O=+p[Z>>3];w=r+(B<<4)|0;S=+p[w>>3];L=O+S;W=Z+8|0;z=+p[W>>3];E=w+8|0;V=+p[E>>3];N=z+V;A=+p[r>>3];P=d+(t<<4)+8|0;M=+p[P>>3];U=(z-V)*.8660254037844386;V=(S-O)*.8660254037844386;p[r>>3]=L+A;p[P>>3]=N+M;O=A-L*.5;L=M-N*.5;p[Z>>3]=O+U;p[W>>3]=V+L;p[w>>3]=O-U;p[E>>3]=L-V;t=t+_|0;if((t|0)>=(s|0))break d}}do{t=d+(ba<<4)|0;E=t+(i<<4)|0;V=+p[E>>3];w=t+(B<<4)|0;L=+p[w>>3];U=V+L;W=E+8|0;O=+p[W>>3];Z=w+8|0;N=+p[Z>>3];M=O+N;A=+p[t>>3];P=d+(ba<<4)+8|0;S=+p[P>>3];z=(O-N)*.8660254037844386;N=(L-V)*.8660254037844386;p[t>>3]=U+A;p[P>>3]=M+S;V=A-U*.5;U=S-M*.5;p[E>>3]=V+z;p[W>>3]=N+U;p[w>>3]=V-z;p[Z>>3]=U-N;Z=x;w=1;while(1){W=t+(w<<4)|0;E=W+(i<<4)|0;N=+p[E>>3];U=+p[h+(Z<<4)>>3];P=E+8|0;z=+p[P>>3];V=+p[h+(Z<<4)+8>>3];M=N*U-z*V;S=U*z+N*V;r=W+(B<<4)|0;V=+p[r>>3];C=Z<<1;N=+p[h+(C<<4)>>3];D=r+8|0;z=+p[D>>3];U=+p[h+(C<<4)+8>>3];A=V*N-z*U;L=N*z+V*U;U=M+A;V=S+L;z=(S-L)*.8660254037844386;L=(A-M)*.8660254037844386;M=+p[W>>3];C=W+8|0;A=+p[C>>3];p[W>>3]=M+U;p[C>>3]=A+V;S=M-U*.5;U=A-V*.5;p[E>>3]=z+S;p[P>>3]=L+U;p[r>>3]=S-z;p[D>>3]=U-L;w=w+1|0;if((w|0)==(i|0))break;else Z=Z+x|0}ba=ba+_|0}while((ba|0)<(s|0))}break}case 5:{s=f[j>>2]|0;if((s|0)>0){B=(i|0)>0;Z=i<<1;w=0;do{if(B){t=d+(w<<4)|0;D=0;r=0;while(1){P=t+(r<<4)|0;E=P+(Z<<4)|0;C=E+(Z<<4)|0;W=P+(i<<4)|0;L=+p[W>>3];U=+p[h+(D<<4)>>3];Q=W+8|0;z=+p[Q>>3];S=+p[h+(D<<4)+8>>3];V=L*U-z*S;A=U*z+L*S;S=+p[C>>3];X=D<<2;L=+p[h+(X<<4)>>3];R=C+8|0;z=+p[R>>3];U=+p[h+(X<<4)+8>>3];M=S*L-z*U;N=L*z+S*U;U=V+M;S=A+N;z=V-M;M=A-N;X=E+(i<<4)|0;N=+p[X>>3];ca=D*3|0;A=+p[h+(ca<<4)>>3];da=X+8|0;V=+p[da>>3];L=+p[h+(ca<<4)+8>>3];O=N*A-V*L;K=A*V+N*L;L=+p[E>>3];ca=D<<1;N=+p[h+(ca<<4)>>3];ea=E+8|0;V=+p[ea>>3];A=+p[h+(ca<<4)+8>>3];T=L*N-V*A;fa=N*V+L*A;A=O+T;L=K+fa;V=O-T;T=K-fa;fa=+p[P>>3];ca=P+8|0;K=+p[ca>>3];O=U+A;N=S+L;p[P>>3]=fa+O;p[ca>>3]=K+N;ga=fa-O*.25;O=K-N*.25;N=(U-A)*.5590169943749475;A=(S-L)*.5590169943749475;L=(M+T)*.9510565162951535;S=(z+V)*-.9510565162951535;U=L-M*.36327126400268045;M=z*.36327126400268045+S;z=L-T*1.5388417685876268;T=V*1.5388417685876268+S;S=N+ga;V=A+O;L=ga-N;N=O-A;p[W>>3]=z+S;p[Q>>3]=T+V;p[C>>3]=S-z;p[R>>3]=V-T;p[E>>3]=U+L;p[ea>>3]=M+N;p[X>>3]=L-U;p[da>>3]=N-M;r=r+1|0;if((r|0)==(i|0))break;else D=D+x|0}}w=w+_|0}while((w|0)<(s|0))}break}default:{s=F+-1|0;w=(s|0)/2|0;Z=(f[m>>2]|0)/(F|0)|0;B=w<<1;g1c(q|0,0,1152)|0;f[g>>2]=q;f[J>>2]=B;if(B>>>0>72){D=bYc(B>>>0>268435455?-1:B<<4)|0;g1c(D|0,0,w<<5|0)|0;f[g>>2]=D;ha=D}else ha=q;D=ha+(w<<4)|0;B=f[j>>2]|0;if((B|0)>0){r=(i|0)>0;t=(F|0)<3;da=(s|0)>1;s=0;X=B;while(1){if(r){B=d+(s<<4)|0;ea=0;E=0;while(1){R=B+(ea<<4)|0;M=+p[R>>3];C=R+8|0;N=+p[C>>3];if(!ea){if(!t){Q=i;W=1;U=M;L=N;while(1){ca=R+(Q<<4)|0;T=+p[ca>>3];P=R+(_-Q<<4)|0;V=+p[P>>3];z=T+V;S=+p[ca+8>>3];A=+p[P+8>>3];O=S+A;ga=U+z;K=L+O;P=W+-1|0;p[ha+(P<<4)>>3]=z;p[ha+(P<<4)+8>>3]=S-A;ca=D+(P<<4)|0;p[ca>>3]=T-V;p[ca+8>>3]=O;if((W|0)<(w|0)){Q=Q+i|0;W=W+1|0;U=ga;L=K}else{ia=ga;ja=K;ka=82;break}}}}else{W=h+((Y(E,F)|0)<<4)|0;if(!t){Q=E;ca=i;P=1;L=M;U=N;while(1){la=R+(ca<<4)|0;K=+p[la>>3];ga=+p[h+(Q<<4)>>3];O=+p[la+8>>3];V=+p[h+(Q<<4)+8>>3];T=K*ga-O*V;A=ga*O+K*V;la=R+(_-ca<<4)|0;V=+p[la>>3];ma=W+(0-Q<<4)|0;K=+p[ma>>3];O=+p[la+8>>3];ga=+p[ma+8>>3];S=V*K-O*ga;z=K*O+V*ga;ga=T+S;V=A+z;O=L+ga;K=U+V;ma=P+-1|0;p[ha+(ma<<4)>>3]=ga;p[ha+(ma<<4)+8>>3]=A-z;la=D+(ma<<4)|0;p[la>>3]=T-S;p[la+8>>3]=V;if((P|0)<(w|0)){Q=Q+E|0;ca=ca+i|0;P=P+1|0;L=O;U=K}else{ia=O;ja=K;ka=82;break}}}}e:do if((ka|0)==82?(ka=0,p[R>>3]=ia,p[C>>3]=ja,!t):0){if(da){na=i;oa=1}else{P=i;ca=1;while(1){Q=R+(P<<4)|0;p[Q>>3]=M;p[Q+8>>3]=N;Q=R+(_-P<<4)|0;p[Q>>3]=M;p[Q+8>>3]=N;if((ca|0)<(w|0)){P=P+i|0;ca=ca+1|0}else break e}}while(1){ca=Y(oa,Z)|0;P=f[m>>2]|0;Q=0;W=ca;U=M;L=M;K=N;O=N;while(1){V=+p[h+(W<<4)>>3];S=V*+p[ha+(Q<<4)>>3];T=+p[h+(W<<4)+8>>3];z=T*+p[ha+(Q<<4)+8>>3];la=D+(Q<<4)|0;A=V*+p[la+8>>3];V=T*+p[la>>3];U=U+(S+z);L=L+(S-z);K=K+(A-V);O=O+(A+V);la=W+ca|0;Q=Q+1|0;if((Q|0)>=(w|0))break;else W=la-((la|0)>=(P|0)?P:0)|0}P=R+(na<<4)|0;p[P>>3]=L;p[P+8>>3]=O;P=R+(_-na<<4)|0;p[P>>3]=U;p[P+8>>3]=K;if((oa|0)<(w|0)){na=na+i|0;oa=oa+1|0}else break}}while(0);ea=ea+1|0;if((ea|0)==(i|0))break;else E=E+x|0}pa=f[j>>2]|0}else pa=X;s=s+_|0;if((s|0)>=(pa|0))break;else X=pa}}if((ha|0)!=(q|0)){dYc(ha);f[g>>2]=q;f[J>>2]=72}}}while(0);F=I+1|0;if((F|0)>=(f[a>>2]|0))break c;I=F;i=_;y=x;H=f[c>>2]|0}}while(0);if(o!=1.0){ja=l?-o:o;c=f[j>>2]|0;if((c|0)>0)qa=0;else{u=e;return}do{a=d+(qa<<4)|0;g=d+(qa<<4)+8|0;ia=ja*+p[g>>3];p[a>>3]=o*+p[a>>3];p[g>>3]=ia;qa=qa+1|0}while((qa|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)ra=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;qa=0;do{g=d+(qa<<4)+8|0;a=d+((qa|1)<<4)+8|0;o=-+p[a>>3];p[g>>3]=-+p[g>>3];p[a>>3]=o;qa=qa+2|0}while((qa|0)<=(j|0));ra=c+2|0}c=d+(l+-1<<4)+8|0;if((ra|0)>=(l|0)){u=e;return}p[c>>3]=-+p[c>>3];u=e;return}function E0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<3)|0;d=(h|0)==1;do if(d){p[i>>3]=l*+p[c>>3];m=i}else{if((h|0)==2){n=+p[c>>3];o=+p[c+8>>3];p[i+8>>3]=l*(n-o);p[i>>3]=l*(n+o);m=i;break}if(h&1|0){q=i+(0-k<<3)|0;p[q>>3]=l*+p[c>>3];r=q+8|0;p[r>>3]=0.0;if((h|0)>1){s=f[a+16>>2]|0;t=1;do{v=t+1|0;o=l*+p[c+(f[s+(v<<2)>>2]<<3)>>3];p[q+(t<<4)>>3]=l*+p[c+(f[s+(t<<2)>>2]<<3)>>3];p[q+(t<<4)+8>>3]=0.0;p[q+(v<<4)>>3]=o;p[q+(v<<4)+8>>3]=0.0;t=t+2|0}while((t|0)<(h|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;D0(g,q,q);if(!j)p[r>>3]=+p[q>>3];m=q;break}o=l*.5;t=h>>1;s=a+4|0;v=f[s>>2]|0;z=f[v>>2]>>1;f[v>>2]=z;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));q=(z|0)==1&1;r=g+4|0;f[r>>2]=(f[r>>2]|0)+(q<<2);f[g>>2]=(f[g>>2]|0)-q;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=t;D0(g,c,i);q=f[s>>2]|0;f[q>>2]=f[q>>2]<<1;n=+p[i>>3];q=i+8|0;A=+p[q>>3];p[i>>3]=l*(n+A);B=l*(n-A);p[q>>3]=B;q=i+(t<<3)|0;A=+p[q>>3];r=i+(h+-1<<3)|0;n=+p[r>>3];p[r>>3]=B;if((t|0)>2){B=n;r=f[a+20>>2]|0;v=2;do{C=r;r=r+16|0;D=+p[i+((v|1)<<3)>>3];E=o*(B+D);F=h-v|0;G=i+(F<<3)|0;H=+p[G>>3];I=i+(v<<3)|0;J=+p[I>>3];K=o*(H-J);L=o*(H+J);J=o*(D-B);D=+p[r>>3];H=+p[C+24>>3];M=E*D-K*H;N=E*H+D*K;C=i+(F+-1<<3)|0;B=+p[C>>3];p[i+(v+-1<<3)>>3]=L+M;p[C>>3]=L-M;p[I>>3]=J+N;p[G>>3]=N-J;v=v+2|0}while((v|0)<(t|0));O=B;P=t+1&-2}else{O=n;P=2}if((P|0)<=(t|0)){p[i+(t+-1<<3)>>3]=l*A;p[q>>3]=-(l*O)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}p[m+-8>>3]=+p[m>>3];p[m>>3]=0.0;if((h|0)<=1){u=e;return}p[m+(h<<3)>>3]=0.0;u=e;return}function F0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,o=0,q=0.0,r=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0.0,R=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+4|0;l=+n[k>>2];m=f[c>>2]|0;f[k>>2]=m;o=k;q=l;r=(f[s>>2]=m,+n[s>>2])}else{o=c;q=0.0;r=+n[c>>2]}a:do switch(h|0){case 1:{n[d>>2]=j*r;break}case 2:{l=+n[o+4>>2];n[d+4>>2]=j*(r-l);n[d>>2]=j*(r+l);break}default:{c=h+1>>1;if(h&1|0){m=o+-4|0;n[d>>2]=r;n[d+4>>2]=0.0;if((c|0)>1){k=f[a+16>>2]|0;t=1;do{v=f[k+(t<<2)>>2]|0;w=f[k+(h-t<<2)>>2]|0;x=f[m+(t<<3)>>2]|0;l=+n[m+(t<<3)+4>>2];f[d+(v<<3)>>2]=x;n[d+(v<<3)+4>>2]=-l;f[d+(w<<3)>>2]=x;n[d+(w<<3)+4>>2]=l;t=t+1|0}while((t|0)!=(c|0))}y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;G0(g,d,d);n[d>>2]=j*+n[d>>2];if((h|0)>1){t=1;do{m=t<<1;l=j*+n[d+(m+2<<2)>>2];n[d+(t<<2)>>2]=j*+n[d+(m<<2)>>2];n[d+(t+1<<2)>>2]=l;t=t+2|0}while((t|0)<(h|0))}break a}t=(o|0)==(d|0);m=f[a+20>>2]|0;l=+n[o+4>>2];B=+n[o+(h+-1<<2)>>2];n[d>>2]=r+B;n[d+4>>2]=B-r;k=m+8|0;do if((c|0)>2){if(t){w=k;B=l;x=2;v=m;while(1){C=h-x|0;D=+n[d+(C+-1<<2)>>2];E=B+D;F=d+(x<<2)|0;G=+n[F>>2];H=d+(C<<2)|0;I=+n[H>>2];J=G-I;K=B-D;D=G+I;I=+n[w>>2];G=+n[v+12>>2];L=K*I+D*G;M=D*I-K*G;N=d+((x|1)<<2)|0;B=+n[N>>2];n[F>>2]=E-M;n[N>>2]=-J-L;n[H>>2]=E+M;n[d+(C+1<<2)>>2]=J-L;x=x+2|0;if((x|0)>=(c|0))break;else{C=w;w=w+8|0;v=C}}O=B;P=c+1&-2;break}v=f[a+16>>2]|0;w=k;L=l;x=2;C=m;while(1){H=h-x|0;J=+n[o+(H+-1<<2)>>2];M=L+J;E=+n[o+(x<<2)>>2];G=+n[o+(H<<2)>>2];K=E-G;I=L-J;J=E+G;G=+n[w>>2];E=+n[C+12>>2];D=I*G+J*E;Q=J*G-I*E;L=+n[o+((x|1)<<2)>>2];H=x>>1;N=f[v+(H<<2)>>2]|0;n[d+(N<<2)>>2]=M-Q;n[d+(N+1<<2)>>2]=-K-D;N=f[v+(c-H<<2)>>2]|0;n[d+(N<<2)>>2]=M+Q;n[d+(N+1<<2)>>2]=K-D;x=x+2|0;if((x|0)>=(c|0))break;else{N=w;w=w+8|0;C=N}}O=L;P=c+1&-2}else{O=l;P=2}while(0);if((P|0)<=(c|0)){l=+n[o+(c<<2)>>2]*2.0;if(t)R=c;else R=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;n[d+(R<<2)>>2]=O*2.0;n[d+(R+1<<2)>>2]=l}m=a+4|0;k=f[m>>2]|0;C=f[k>>2]>>1;f[k>>2]=C;y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));k=(C|0)==1&1;w=g+4|0;f[w>>2]=(f[w>>2]|0)+(k<<2);f[g>>2]=(f[g>>2]|0)-k;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(t^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;G0(g,d,d);k=f[m>>2]|0;f[k>>2]=f[k>>2]<<1;if((h|0)>0){k=0;do{w=d+(k<<2)|0;x=d+((k|1)<<2)|0;l=-(j*+n[x>>2]);n[w>>2]=j*+n[w>>2];n[x>>2]=l;k=k+2|0}while((k|0)<(h|0))}}}while(0);if(!i){u=e;return}n[o>>2]=q;u=e;return}function G0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+1104|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;o=f[m>>2]|0;q=+p[a+8>>3];if((o|0)!=(k|0))if((o|0)==(k<<1|0))r=2;else r=(o|0)/(k|0)|0;else r=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){s=f[a+4>>2]|0;t=f[a>>2]|0;if((f[s>>2]|0)!=(f[s+(t+-1<<2)>>2]|0)){s=$Xc(48)|0;f[g>>2]=s;f[g+8>>2]=-2147483600;f[g+4>>2]=33;v=s;w=239078;x=v+33|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[s+33>>0]=0;vM(-215,g,239112,239116,657)}if((t|0)!=1){if((k|0)>0){y=0;z=i}else break;while(1){w=f[z>>2]|0;if((w|0)>(y|0)){v=d+(y<<3)|0;x=f[v>>2]|0;A=f[d+(y<<3)+4>>2]|0;B=d+(w<<3)|0;C=B;D=f[C+4>>2]|0;E=v;f[E>>2]=f[C>>2];f[E+4>>2]=D;f[B>>2]=x;f[d+(w<<3)+4>>2]=A}y=y+1|0;if((y|0)==(k|0))break a;else z=z+(r<<2)|0}}if((k&3|0)==0?(t=(k|0)/2|0,s=d+(t<<3)|0,(k|0)>1):0){A=r<<1;w=0;x=i;while(1){B=f[x>>2]|0;D=w|1;E=d+(D<<3)|0;C=f[E>>2]|0;v=f[d+(D<<3)+4>>2]|0;F=s+(B<<3)|0;G=F;H=f[G+4>>2]|0;I=E;f[I>>2]=f[G>>2];f[I+4>>2]=H;f[F>>2]=C;f[F+4>>2]=v;if((B|0)>(w|0)){v=d+(w<<3)|0;F=f[v>>2]|0;C=f[d+(w<<3)+4>>2]|0;H=d+(B<<3)|0;I=H;G=f[I+4>>2]|0;E=v;f[E>>2]=f[I>>2];f[E+4>>2]=G;f[H>>2]=F;f[d+(B<<3)+4>>2]=C;C=s+(D<<3)|0;D=f[C>>2]|0;F=f[C+4>>2]|0;H=s+(B+1<<3)|0;B=H;G=f[B+4>>2]|0;E=C;f[E>>2]=f[B>>2];f[E+4>>2]=G;f[H>>2]=D;f[H+4>>2]=F}w=w+2|0;if((w|0)>=(t|0))break;else x=x+(A<<2)|0}}}while(0);if(l){A=k+-2|0;if((k|0)<2)J=0;else{x=0;do{t=d+(x<<3)+4|0;w=d+((x|1)<<3)+4|0;K=-+n[w>>2];n[t>>2]=-+n[t>>2];n[w>>2]=K;x=x+2|0}while((x|0)<=(A|0));J=k&-2}A=d+(k+-1<<3)+4|0;if((J|0)<(k|0))n[A>>2]=-+n[A>>2]}}else{A=k+-2|0;x=(k|0)<2;if(l){if(x)L=0;else{w=r<<1;t=0;s=i;while(1){F=f[s>>2]|0;H=f[s+(r<<2)>>2]|0;K=-+n[c+(F<<3)+4>>2];f[d+(t<<3)>>2]=f[c+(F<<3)>>2];n[d+(t<<3)+4>>2]=K;K=-+n[c+(H<<3)+4>>2];F=t|1;f[d+(F<<3)>>2]=f[c+(H<<3)>>2];n[d+(F<<3)+4>>2]=K;t=t+2|0;if((t|0)>(A|0))break;else s=s+(w<<2)|0}L=k&-2}if((L|0)>=(k|0))break;w=k+-1|0;K=-+n[c+(w<<3)+4>>2];f[d+(L<<3)>>2]=f[c+(w<<3)>>2];n[d+(L<<3)+4>>2]=K;break}else{if(x)M=0;else{w=r<<1;s=0;t=i;while(1){F=f[t+(r<<2)>>2]|0;H=c+(f[t>>2]<<3)|0;D=f[H+4>>2]|0;G=d+(s<<3)|0;f[G>>2]=f[H>>2];f[G+4>>2]=D;D=c+(F<<3)|0;F=f[D+4>>2]|0;G=d+((s|1)<<3)|0;f[G>>2]=f[D>>2];f[G+4>>2]=F;s=s+2|0;if((s|0)>(A|0))break;else t=t+(w<<2)|0}M=k&-2}w=k+-1|0;if((M|0)>=(k|0))break;t=c+(w<<3)|0;A=f[t+4>>2]|0;s=d+(w<<3)|0;f[s>>2]=f[t>>2];f[s+4>>2]=A;break}}while(0);c=a+4|0;k=f[c>>2]|0;M=f[k>>2]|0;r=M&1;if(!r){if((M|0)<4){N=1;O=o}else{i=f[j>>2]|0;L=(i|0)>0;J=1;z=o;y=4;while(1){A=(z|0)/4|0;if(L){s=J<<1;t=(J|0)>1;w=0;do{x=d+(w<<3)|0;F=x+(s<<3)|0;K=+n[F>>2];G=F+4|0;P=+n[G>>2];D=F+(J<<3)|0;Q=+n[D>>2];H=D+4|0;R=+n[H>>2];S=K+Q;T=P+R;U=P-R;R=Q-K;K=+n[x>>2];E=d+(w<<3)+4|0;Q=+n[E>>2];B=x+(J<<3)|0;P=+n[B>>2];C=B+4|0;V=+n[C>>2];W=K+P;X=Q+V;Z=K-P;P=Q-V;n[x>>2]=S+W;n[E>>2]=T+X;n[F>>2]=W-S;n[G>>2]=X-T;n[B>>2]=U+Z;n[C>>2]=R+P;n[D>>2]=Z-U;n[H>>2]=P-R;if(t){H=A;D=1;while(1){C=x+(D<<3)|0;B=C+(s<<3)|0;G=C+(J<<3)|0;R=+n[G>>2];F=H<<1;P=+n[h+(F<<3)>>2];E=G+4|0;U=+n[E>>2];Z=+n[h+(F<<3)+4>>2];T=R*P-U*Z;X=P*U+R*Z;Z=+n[B>>2];R=+n[h+(H<<3)+4>>2];F=B+4|0;U=+n[F>>2];P=+n[h+(H<<3)>>2];S=Z*R+U*P;W=Z*P-R*U;I=B+(J<<3)|0;U=+n[I>>2];v=H*3|0;R=+n[h+(v<<3)+4>>2];_=I+4|0;P=+n[_>>2];Z=+n[h+(v<<3)>>2];V=U*R+P*Z;Q=U*Z-R*P;P=W+Q;R=S+V;Z=S-V;V=Q-W;W=+n[C>>2];v=C+4|0;Q=+n[v>>2];S=T+W;U=X+Q;K=W-T;T=Q-X;n[C>>2]=S+P;n[v>>2]=U+R;n[B>>2]=S-P;n[F>>2]=U-R;n[G>>2]=K+Z;n[E>>2]=T+V;n[I>>2]=K-Z;n[_>>2]=T-V;D=D+1|0;if((D|0)==(J|0))break;else H=H+A|0}}w=w+y|0}while((w|0)<(i|0))}w=y<<2;if((w|0)>(M|0)){N=y;O=A;break}else{s=y;z=A;y=w;J=s}}}if((N|0)<(M|0)){J=f[j>>2]|0;y=(J|0)>0;z=N;i=O;while(1){L=z<<1;s=(i|0)/2|0;b:do if(y){if((z|0)>1)$=0;else{w=0;while(1){t=d+(w<<3)|0;V=+n[t>>2];H=t+(z<<3)|0;T=+n[H>>2];D=d+(w<<3)+4|0;Z=+n[D>>2];x=H+4|0;K=+n[x>>2];n[t>>2]=V+T;n[D>>2]=Z+K;n[H>>2]=V-T;n[x>>2]=Z-K;w=w+L|0;if((w|0)>=(J|0))break b}}do{w=d+($<<3)|0;K=+n[w>>2];x=w+(z<<3)|0;Z=+n[x>>2];H=d+($<<3)+4|0;T=+n[H>>2];D=x+4|0;V=+n[D>>2];n[w>>2]=K+Z;n[H>>2]=T+V;n[x>>2]=K-Z;n[D>>2]=T-V;D=s;x=1;while(1){H=w+(x<<3)|0;t=H+(z<<3)|0;V=+n[t>>2];T=+n[h+(D<<3)>>2];_=t+4|0;Z=+n[_>>2];K=+n[h+(D<<3)+4>>2];R=V*T-Z*K;U=T*Z+V*K;K=+n[H>>2];I=H+4|0;V=+n[I>>2];n[H>>2]=K+R;n[I>>2]=V+U;n[t>>2]=K-R;n[_>>2]=V-U;x=x+1|0;if((x|0)==(z|0))break;else D=D+s|0}$=$+L|0}while(($|0)<(J|0))}while(0);if((L|0)<(M|0)){z=L;i=s}else{aa=L;ba=s;break}}}else{aa=N;ba=O}}else{aa=1;ba=o}o=r^1;c:do if((o|0)<(f[a>>2]|0)){r=g+8|0;O=g+4|0;N=o;i=aa;z=ba;M=k;while(1){J=f[M+(N<<2)>>2]|0;$=Y(J,i)|0;y=(z|0)/(J|0)|0;d:do switch(J|0){case 3:{A=f[j>>2]|0;if((A|0)>0){D=i<<1;if((i|0)>1)ca=0;else{x=0;while(1){w=d+(x<<3)|0;_=w+(i<<3)|0;U=+n[_>>2];t=w+(D<<3)|0;V=+n[t>>2];R=U+V;I=_+4|0;K=+n[I>>2];H=t+4|0;Z=+n[H>>2];T=K+Z;P=+n[w>>2];E=d+(x<<3)+4|0;S=+n[E>>2];X=(K-Z)*.8660253882408142;Z=(V-U)*.8660253882408142;n[w>>2]=R+P;n[E>>2]=T+S;U=P-R*.5;R=S-T*.5;n[_>>2]=U+X;n[I>>2]=Z+R;n[t>>2]=U-X;n[H>>2]=R-Z;x=x+$|0;if((x|0)>=(A|0))break d}}do{x=d+(ca<<3)|0;H=x+(i<<3)|0;Z=+n[H>>2];t=x+(D<<3)|0;R=+n[t>>2];X=Z+R;I=H+4|0;U=+n[I>>2];_=t+4|0;T=+n[_>>2];S=U+T;P=+n[x>>2];E=d+(ca<<3)+4|0;V=+n[E>>2];K=(U-T)*.8660253882408142;T=(R-Z)*.8660253882408142;n[x>>2]=X+P;n[E>>2]=S+V;Z=P-X*.5;X=V-S*.5;n[H>>2]=Z+K;n[I>>2]=T+X;n[t>>2]=Z-K;n[_>>2]=X-T;_=y;t=1;while(1){I=x+(t<<3)|0;H=I+(i<<3)|0;T=+n[H>>2];X=+n[h+(_<<3)>>2];E=H+4|0;K=+n[E>>2];Z=+n[h+(_<<3)+4>>2];S=T*X-K*Z;V=X*K+T*Z;w=I+(D<<3)|0;Z=+n[w>>2];G=_<<1;T=+n[h+(G<<3)>>2];F=w+4|0;K=+n[F>>2];X=+n[h+(G<<3)+4>>2];P=Z*T-K*X;R=T*K+Z*X;X=S+P;Z=V+R;K=(V-R)*.8660253882408142;R=(P-S)*.8660253882408142;S=+n[I>>2];G=I+4|0;P=+n[G>>2];n[I>>2]=S+X;n[G>>2]=P+Z;V=S-X*.5;X=P-Z*.5;n[H>>2]=K+V;n[E>>2]=R+X;n[w>>2]=V-K;n[F>>2]=X-R;t=t+1|0;if((t|0)==(i|0))break;else _=_+y|0}ca=ca+$|0}while((ca|0)<(A|0))}break}case 5:{A=f[j>>2]|0;if((A|0)>0){D=(i|0)>0;_=i<<1;t=0;do{if(D){x=d+(t<<3)|0;F=0;w=0;while(1){E=x+(w<<3)|0;H=E+(_<<3)|0;G=H+(_<<3)|0;I=E+(i<<3)|0;R=+n[I>>2];X=+n[h+(F<<3)>>2];B=I+4|0;K=+n[B>>2];V=+n[h+(F<<3)+4>>2];Z=R*X-K*V;P=X*K+R*V;V=+n[G>>2];v=F<<2;R=+n[h+(v<<3)>>2];C=G+4|0;K=+n[C>>2];X=+n[h+(v<<3)+4>>2];S=V*R-K*X;T=R*K+V*X;X=Z+S;V=P+T;K=Z-S;S=P-T;v=H+(i<<3)|0;T=+n[v>>2];da=F*3|0;P=+n[h+(da<<3)>>2];ea=v+4|0;Z=+n[ea>>2];R=+n[h+(da<<3)+4>>2];U=T*P-Z*R;Q=P*Z+T*R;R=+n[H>>2];da=F<<1;T=+n[h+(da<<3)>>2];fa=H+4|0;Z=+n[fa>>2];P=+n[h+(da<<3)+4>>2];W=R*T-Z*P;ga=T*Z+R*P;P=U+W;R=Q+ga;Z=U-W;W=Q-ga;ga=+n[E>>2];da=E+4|0;Q=+n[da>>2];U=X+P;T=V+R;n[E>>2]=ga+U;n[da>>2]=Q+T;ha=ga-U*.25;U=Q-T*.25;T=(X-P)*.55901700258255;P=(V-R)*.55901700258255;R=(S+W)*.9510565400123596;V=(K+Z)*-.9510565400123596;X=R-S*.3632712662220001;S=K*.3632712662220001+V;K=R-W*1.538841724395752;W=Z*1.538841724395752+V;V=T+ha;Z=P+U;R=ha-T;T=U-P;n[I>>2]=K+V;n[B>>2]=W+Z;n[G>>2]=V-K;n[C>>2]=Z-W;n[H>>2]=X+R;n[fa>>2]=S+T;n[v>>2]=R-X;n[ea>>2]=T-S;w=w+1|0;if((w|0)==(i|0))break;else F=F+y|0}}t=t+$|0}while((t|0)<(A|0))}break}default:{A=J+-1|0;t=(A|0)/2|0;_=(f[m>>2]|0)/(J|0)|0;D=t<<1;g1c(r|0,0,1088)|0;f[g>>2]=r;f[O>>2]=D;if(D>>>0>136){F=bYc(D>>>0>536870911?-1:D<<3)|0;g1c(F|0,0,t<<4|0)|0;f[g>>2]=F;ia=F}else ia=r;F=ia+(t<<3)|0;D=f[j>>2]|0;if((D|0)>0){w=(i|0)>0;x=(J|0)<3;ea=(A|0)>1;A=0;v=D;while(1){if(w){D=d+(A<<3)|0;fa=0;H=0;while(1){C=D+(fa<<3)|0;S=+n[C>>2];G=C+4|0;T=+n[G>>2];if(!fa){if(!x){B=i;I=1;X=S;R=T;while(1){da=C+(B<<3)|0;W=+n[da>>2];E=C+($-B<<3)|0;Z=+n[E>>2];K=W+Z;V=+n[da+4>>2];P=+n[E+4>>2];U=V+P;ha=X+K;Q=R+U;E=I+-1|0;n[ia+(E<<3)>>2]=K;n[ia+(E<<3)+4>>2]=V-P;da=F+(E<<3)|0;n[da>>2]=W-Z;n[da+4>>2]=U;if((I|0)<(t|0)){B=B+i|0;I=I+1|0;X=ha;R=Q}else{ja=ha;ka=Q;la=82;break}}}}else{I=h+((Y(H,J)|0)<<3)|0;if(!x){B=H;da=i;E=1;R=S;X=T;while(1){ma=C+(da<<3)|0;Q=+n[ma>>2];ha=+n[h+(B<<3)>>2];U=+n[ma+4>>2];Z=+n[h+(B<<3)+4>>2];W=Q*ha-U*Z;P=ha*U+Q*Z;ma=C+($-da<<3)|0;Z=+n[ma>>2];na=I+(0-B<<3)|0;Q=+n[na>>2];U=+n[ma+4>>2];ha=+n[na+4>>2];V=Z*Q-U*ha;K=Q*U+Z*ha;ha=W+V;Z=P+K;U=R+ha;Q=X+Z;na=E+-1|0;n[ia+(na<<3)>>2]=ha;n[ia+(na<<3)+4>>2]=P-K;ma=F+(na<<3)|0;n[ma>>2]=W-V;n[ma+4>>2]=Z;if((E|0)<(t|0)){B=B+H|0;da=da+i|0;E=E+1|0;R=U;X=Q}else{ja=U;ka=Q;la=82;break}}}}e:do if((la|0)==82?(la=0,n[C>>2]=ja,n[G>>2]=ka,!x):0){if(ea){oa=i;pa=1}else{E=i;da=1;while(1){B=C+(E<<3)|0;n[B>>2]=S;n[B+4>>2]=T;B=C+($-E<<3)|0;n[B>>2]=S;n[B+4>>2]=T;if((da|0)<(t|0)){E=E+i|0;da=da+1|0}else break e}}while(1){da=Y(pa,_)|0;E=f[m>>2]|0;B=0;I=da;X=S;R=S;Q=T;U=T;while(1){Z=+n[h+(I<<3)>>2];V=Z*+n[ia+(B<<3)>>2];W=+n[h+(I<<3)+4>>2];K=W*+n[ia+(B<<3)+4>>2];ma=F+(B<<3)|0;P=Z*+n[ma+4>>2];Z=W*+n[ma>>2];X=X+(V+K);R=R+(V-K);Q=Q+(P-Z);U=U+(P+Z);ma=I+da|0;B=B+1|0;if((B|0)>=(t|0))break;else I=ma-((ma|0)>=(E|0)?E:0)|0}E=C+(oa<<3)|0;n[E>>2]=R;n[E+4>>2]=U;E=C+($-oa<<3)|0;n[E>>2]=X;n[E+4>>2]=Q;if((pa|0)<(t|0)){oa=oa+i|0;pa=pa+1|0}else break}}while(0);fa=fa+1|0;if((fa|0)==(i|0))break;else H=H+y|0}qa=f[j>>2]|0}else qa=v;A=A+$|0;if((A|0)>=(qa|0))break;else v=qa}}if((ia|0)!=(r|0)){dYc(ia);f[g>>2]=r;f[O>>2]=136}}}while(0);J=N+1|0;if((J|0)>=(f[a>>2]|0))break c;N=J;i=$;z=y;M=f[c>>2]|0}}while(0);if(q!=1.0){ka=l?-q:q;c=f[j>>2]|0;if((c|0)>0)ra=0;else{u=e;return}do{a=d+(ra<<3)|0;g=d+(ra<<3)+4|0;ja=ka*+n[g>>2];n[a>>2]=q*+n[a>>2];n[g>>2]=ja;ra=ra+1|0}while((ra|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)sa=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;ra=0;do{g=d+(ra<<3)+4|0;a=d+((ra|1)<<3)+4|0;q=-+n[a>>2];n[g>>2]=-+n[g>>2];n[a>>2]=q;ra=ra+2|0}while((ra|0)<=(j|0));sa=c+2|0}c=d+(l+-1<<3)+4|0;if((sa|0)>=(l|0)){u=e;return}n[c>>2]=-+n[c>>2];u=e;return}function H0(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<2)|0;d=(h|0)==1;do if(d){n[i>>2]=l*+n[c>>2];m=i}else{if((h|0)==2){o=+n[c>>2];q=+n[c+4>>2];n[i+4>>2]=l*(o-q);n[i>>2]=l*(o+q);m=i;break}if(h&1|0){r=i+(0-k<<2)|0;n[r>>2]=l*+n[c>>2];s=r+4|0;n[s>>2]=0.0;if((h|0)>1){t=f[a+16>>2]|0;v=1;do{w=v+1|0;q=l*+n[c+(f[t+(w<<2)>>2]<<2)>>2];n[r+(v<<3)>>2]=l*+n[c+(f[t+(v<<2)>>2]<<2)>>2];n[r+(v<<3)+4>>2]=0.0;n[r+(w<<3)>>2]=q;n[r+(w<<3)+4>>2]=0.0;v=v+2|0}while((v|0)<(h|0))}x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;G0(g,r,r);if(!j)f[s>>2]=f[r>>2];m=r;break}q=l*.5;v=h>>1;t=a+4|0;w=f[t>>2]|0;A=f[w>>2]>>1;f[w>>2]=A;x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));r=(A|0)==1&1;s=g+4|0;f[s>>2]=(f[s>>2]|0)+(r<<2);f[g>>2]=(f[g>>2]|0)-r;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=v;G0(g,c,i);r=f[t>>2]|0;f[r>>2]=f[r>>2]<<1;o=+n[i>>2];r=i+4|0;B=+n[r>>2];n[i>>2]=l*(o+B);C=l*(o-B);n[r>>2]=C;r=i+(v<<2)|0;B=+n[r>>2];s=i+(h+-1<<2)|0;o=+n[s>>2];n[s>>2]=C;if((v|0)>2){C=o;s=f[a+20>>2]|0;w=2;do{D=s;s=s+8|0;E=+n[i+((w|1)<<2)>>2];F=q*(C+E);G=h-w|0;H=i+(G<<2)|0;I=+n[H>>2];J=i+(w<<2)|0;K=+n[J>>2];L=q*(I-K);M=q*(I+K);K=q*(E-C);E=+n[s>>2];I=+n[D+12>>2];N=F*E-L*I;O=F*I+E*L;D=i+(G+-1<<2)|0;C=+n[D>>2];n[i+(w+-1<<2)>>2]=M+N;n[D>>2]=M-N;n[J>>2]=K+O;n[H>>2]=O-K;w=w+2|0}while((w|0)<(v|0));P=C;Q=v+1&-2}else{P=o;Q=2}if((Q|0)<=(v|0)){n[i+(v+-1<<2)>>2]=l*B;n[r>>2]=-(l*P)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}f[m+-4>>2]=f[m>>2];n[m>>2]=0.0;if((h|0)<=1){u=e;return}n[m+(h<<2)>>2]=0.0;u=e;return}function I0(a,b,c){a=a|0;b=b|0;c=c|0;Ti[f[a+44>>2]&511](a+8|0,b,c);return}function J0(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=39460;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)dYc(c);f[b>>2]=d;f[a+1236>>2]=264}d=a+192|0;b=f[d>>2]|0;c=a+200|0;if((b|0)==(c|0))return;if(b|0)dYc(b);f[d>>2]=c;f[a+196>>2]=1032;return}function K0(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=39460;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)dYc(c);f[b>>2]=d;f[a+1236>>2]=264}d=f[a+192>>2]|0;if((d|0)==(a+200|0)|(d|0)==0){cYc(a);return}dYc(d);cYc(a);return}function L0(a,b,c){a=a|0;b=b|0;c=c|0;return}function M0(a){a=a|0;cYc(a);return}function N0(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=$Xc(12)|0;f[m>>2]=39532;f[m+4>>2]=0;b[m+8>>0]=0;O0(m);cYc(m);if((c|0)==1&(j|0)>0){m=$Xc(192)|0;f[l>>2]=m;f[l+8>>2]=-2147483456;f[l+4>>2]=190;o1c(m|0,239500,190)|0;b[m+190>>0]=0;vM(-213,l,467262,239116,3303)}else{l=$Xc(4244)|0;f[l>>2]=39552;m=l+4|0;f[l+60>>2]=0;f[l+64>>2]=0;f[l+68>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[l+84>>2]=l+92;f[l+88>>2]=1032;f[l+1124>>2]=l+1132;f[l+1128>>2]=1032;f[l+2164>>2]=l+2172;f[l+2168>>2]=1032;f[l+3204>>2]=l+3212;f[l+3208>>2]=1032;b[l+20>>0]=0;b[l+21>>0]=0;b[l+22>>0]=0;m=l+24|0;f[l+52>>2]=0;b[l+56>>0]=0;b[l+57>>0]=0;b[l+72>>0]=0;f[l+76>>2]=0;f[l+80>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;b[m+24>>0]=0;P0(l,c,d,e,g,h,i,j);f[a>>2]=l;j=$Xc(16)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=39572;f[j+12>>2]=l;f[a+4>>2]=j;u=k;return}}function O0(a){a=a|0;f[a>>2]=39532;return}function P0(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;l=u;u=u+16|0;m=l;n=(g|0)!=(i|0);f[a+52>>2]=k;k=a+24|0;f[k>>2]=c;o=a+28|0;f[o>>2]=d;p=a+44|0;f[p>>2]=e;f[a+76>>2]=g;f[a+80>>2]=i;q=j&1;r=q&255;s=(g|0)==1;t=(i|0)==1;v=s&t;if(!q)if(!v){q=(i|0)==2;if(!(s&q))if((g|0)==2&q)w=3;else x=8;else w=2}else w=1;else if(!v){v=(g|0)==2;if(!(v&t))if(v&(i|0)==2)w=6;else x=8;else w=5}else w=4;if((x|0)==8)w=0;i=a+32|0;f[i>>2]=w;v=a+22|0;b[v>>0]=r;r=a+56|0;t=j>>>2&1;b[r>>0]=t;g=a+57|0;b[g>>0]=j>>>1&1;q=a+20|0;b[q>>0]=0;s=a+21|0;b[s>>0]=0;y=a+48|0;b[y>>0]=(w|0)!=6&(w|0)!=3&1;z=(e|0)==5?4:8;e=a+36|0;f[e>>2]=z;A=z<<1;z=a+40|0;f[z>>2]=A;switch(w&7){case 3:case 6:{f[e>>2]=A;break}default:{}}do if(!(t<<24>>24)){A=(d|0)>1;if(A&(c|0)==1){B=2-(j>>>9&1)|0;x=15;break}if((d|0)!=1){e=a+60|0;if(A&(c|0)>1){A=a+64|0;C=f[A>>2]|0;D=f[e>>2]|0;E=C-D>>2;F=D;G=C;if(E>>>0>=2)if((E|0)!=2?(C=F+8|0,(G|0)!=(C|0)):0){f[A>>2]=G+(~((G+-4-C|0)>>>2)<<2);H=D;I=w;J=F}else{H=D;I=w;J=F}else{CS(e,2-E|0);E=f[e>>2]|0;H=E;I=f[i>>2]|0;J=E}E=(I&-2|0)==4;f[J>>2]=E&1;f[J+4>>2]=(E^1)&1;K=e;L=H}else{M=e;N=0;x=23}}else{B=1;x=15}}else{B=1;x=15}while(0);if((x|0)==15){M=a+60|0;N=B;x=23}if((x|0)==23){x=a+64|0;B=f[x>>2]|0;H=f[M>>2]|0;J=B;switch(B-H>>2|0){case 0:{CS(M,1);break}case 1:break;default:{B=H+4|0;if((J|0)!=(B|0))f[x>>2]=J+(~((J+-4-B|0)>>>2)<<2)}}f[f[a+60>>2]>>2]=(N|0)==2&1;K=M;L=f[M>>2]|0}M=K+4|0;N=(f[M>>2]|0)-L>>2;if(!N){u=l;return}L=a+4|0;B=m+4|0;J=a+8|0;x=a+88|0;H=a+84|0;I=a+92|0;i=a+12|0;w=m+4|0;c=a+16|0;d=a+2168|0;t=a+2164|0;e=a+2172|0;E=a+3208|0;F=a+3204|0;D=a+3212|0;C=a+1128|0;G=a+1124|0;A=a+1132|0;a=n;n=(j&1024|0)!=0;j=0;O=f[K>>2]|0;P=N;do{N=(j|0)==1;n=N|n;a=a&(N^1);N=j;j=j+1|0;Q=h[v>>0]|0;R=(b[g>>0]|0)==0?Q:Q|2;Q=(b[r>>0]|0)==0;S=Q?R:R|4;R=a?S|16:S;S=(b[y>>0]|0)==0?R:R|32;R=(j|0)==(P|0)?S:S|64;S=f[k>>2]|0;T=f[o>>2]|0;do if(!(f[O+(N<<2)>>2]|0)){U=(S|0)!=1|Q^1;V=U?S:T;b[q>>0]=n&1;o0(m,V,U?T:1,f[p>>2]|0,R,q);U=f[m>>2]|0;W=f[B>>2]|0;X=(W|0)==0;if(!X)TXc(W);f[L>>2]=U;U=f[J>>2]|0;f[J>>2]=W;if(U|0)UXc(U);if(!X)UXc(W);if(b[q>>0]|0){W=Y(f[z>>2]|0,V)|0;if((f[x>>2]|0)>>>0>=W>>>0){f[x>>2]=W;break}V=f[H>>2]|0;if((V|0)!=(I|0)){if(V|0)dYc(V);f[H>>2]=I;f[x>>2]=1032}f[x>>2]=W;if(W>>>0>1032){V=bYc(W)|0;f[H>>2]=V}}}else{b[s>>0]=n&1;o0(m,T,S,f[p>>2]|0,R|128,s);V=f[m>>2]|0;W=f[w>>2]|0;X=(W|0)==0;if(!X)TXc(W);f[i>>2]=V;V=f[c>>2]|0;f[c>>2]=W;if(V|0)UXc(V);if(!X)UXc(W);do if(b[s>>0]|0){W=Y(f[z>>2]|0,T)|0;if((f[C>>2]|0)>>>0>=W>>>0){f[C>>2]=W;break}X=f[G>>2]|0;if((X|0)!=(A|0)){if(X|0)dYc(X);f[G>>2]=A;f[C>>2]=1032}f[C>>2]=W;if(W>>>0>1032){X=bYc(W)|0;f[G>>2]=X}}while(0);X=Y(f[z>>2]|0,T)|0;if((f[d>>2]|0)>>>0<X>>>0){W=f[t>>2]|0;if((W|0)!=(e|0)){if(W|0)dYc(W);f[t>>2]=e;f[d>>2]=1032}f[d>>2]=X;if(X>>>0>1032){W=bYc(X)|0;f[t>>2]=W}}else f[d>>2]=X;X=Y(f[z>>2]|0,T)|0;if((f[E>>2]|0)>>>0>=X>>>0){f[E>>2]=X;break}W=f[F>>2]|0;if((W|0)!=(D|0)){if(W|0)dYc(W);f[F>>2]=D;f[E>>2]=1032}f[E>>2]=X;if(X>>>0>1032){W=bYc(X)|0;f[F>>2]=W}}while(0);O=f[K>>2]|0;P=(f[M>>2]|0)-O>>2}while(j>>>0<P>>>0);u=l;return}function Q0(a){a=a|0;NXc(a);cYc(a);return}function R0(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+8>>2]&4095](b);return}function S0(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==239691?a+12|0:0)|0}function T0(a){a=a|0;cYc(a);return}function U0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=a+60|0;h=a+64|0;i=f[g>>2]|0;j=(f[h>>2]|0)-i>>2;if(!j)return;k=a+76|0;l=a+80|0;m=c;c=0;n=b;b=i;i=j;do{j=f[l>>2]|0;o=(c|0)==1;p=o?j:f[k>>2]|0;m=o?e:m;n=o?d:n;o=c;c=c+1|0;q=(c|0)==(i|0);if(!(f[b+(o<<2)>>2]|0))X0(a,n,m,d,e,(p|0)!=(j|0),q);else Y0(a,n,m,d,e,p,j,q);b=f[g>>2]|0;i=(f[h>>2]|0)-b>>2}while(c>>>0<i>>>0);return}function V0(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=39552;b=a+3204|0;c=f[b>>2]|0;d=a+3212|0;if((c|0)!=(d|0)){if(c|0)dYc(c);f[b>>2]=d;f[a+3208>>2]=1032}d=a+2164|0;b=f[d>>2]|0;c=a+2172|0;if((b|0)!=(c|0)){if(b|0)dYc(b);f[d>>2]=c;f[a+2168>>2]=1032}c=a+1124|0;d=f[c>>2]|0;b=a+1132|0;if((d|0)!=(b|0)){if(d|0)dYc(d);f[c>>2]=b;f[a+1128>>2]=1032}b=a+84|0;c=f[b>>2]|0;d=a+92|0;if((c|0)!=(d|0)){if(c|0)dYc(c);f[b>>2]=d;f[a+88>>2]=1032}d=f[a+60>>2]|0;if(d|0){b=a+64|0;c=f[b>>2]|0;if((c|0)!=(d|0))f[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);cYc(d)}d=f[a+16>>2]|0;if(d|0)UXc(d);d=f[a+8>>2]|0;if(!d)return;UXc(d);return}function W0(a){a=a|0;V0(a);cYc(a);return}function X0(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=f[a+24>>2]|0;k=f[a+28>>2]|0;if((j|0)==1?(b[a+56>>0]|0)==0:0){l=k;m=1}else{l=j;m=k}k=a+36|0;j=f[k>>2]|0;o=Y(j,l)|0;q=a+20|0;r=b[q>>0]|0;if(!(r<<24>>24))s=0;else s=(l|0)>1&(l&1|0)!=0&(f[a+32>>2]|0)==1?j:0;if((b[a+22>>0]|0)!=0|h^1)t=o;else t=(f[(l&1|0?k:a+40|0)>>2]|0)+o|0;o=f[a+52>>2]|0;k=(o|0)<1|(o|0)>(m|0)?m:o;o=(k|0)>0;a:do if(o){h=a+4|0;j=a+84|0;u=0;v=r;while(1){w=c+(Y(u,d)|0)|0;x=e+(Y(u,g)|0)|0;if(!(v<<24>>24))y=x;else y=f[j>>2]|0;z=f[h>>2]|0;Ti[f[f[z>>2]>>2]&511](z,w,y);if(b[q>>0]|0)o1c(x|0,y+s|0,t|0)|0;x=u+1|0;if((x|0)==(k|0)){A=k;break a}u=x;v=b[q>>0]|0}}else A=0;while(0);if((A|0)<(m|0)){q=A;do{g1c(e+(Y(q,g)|0)|0,0,t|0)|0;q=q+1|0}while((q|0)!=(m|0))}if(!i)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if(!o)return;i=(l+1|0)/2|0;if((l|0)>2)B=0;else return;do{m=e+((Y(B,a)|0)<<2)|0;q=1;do{t=q<<1;A=l-q<<1;f[m+(A<<2)>>2]=f[m+(t<<2)>>2];n[m+((A|1)<<2)>>2]=-+n[m+((t|1)<<2)>>2];q=q+1|0}while((q|0)<(i|0));B=B+1|0}while((B|0)!=(k|0));return}else{B=g>>>3;if(!o)return;o=(l+1|0)/2|0;if((l|0)>2)C=0;else return;do{g=e+((Y(C,B)|0)<<3)|0;i=1;do{a=i<<1;q=l-i<<1;p[g+(q<<3)>>3]=+p[g+(a<<3)>>3];p[g+((q|1)<<3)>>3]=-+p[g+((a|1)<<3)>>3];i=i+1|0}while((i|0)<(o|0));C=C+1|0}while((C|0)!=(k|0));return}}function Y0(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;k=f[a+28>>2]|0;l=f[a+24>>2]|0;m=a+2164|0;o=f[m>>2]|0;q=a+3204|0;r=f[q>>2]|0;if(!(b[a+21>>0]|0)){s=r;t=o}else{s=f[a+1124>>2]|0;t=r}if(!(b[a+48>>0]|0)){u=0;v=l;w=e;x=c}else{y=(l&1|0)==0;z=(l+1|0)/2|0;A=a+22|0;a:do if(!(b[A>>0]|0)){B=a+40|0;g1c(o|0,0,Y(f[B>>2]|0,k)|0)|0;C=f[m>>2]|0;D=a+36|0;E=d>>>2;F=(f[B>>2]|0)>>>2;switch(f[D>>2]|0){case 4:{if((k|0)>0){G=c;H=0;I=C;while(1){f[I>>2]=f[G>>2];H=H+1|0;if((H|0)==(k|0))break;else{G=G+(E<<2)|0;I=I+(F<<2)|0}}}break}case 8:{if((k|0)>0){I=c;G=0;H=C;while(1){J=f[I+4>>2]|0;f[H>>2]=f[I>>2];f[H+4>>2]=J;G=G+1|0;if((G|0)==(k|0))break;else{I=I+(E<<2)|0;H=H+(F<<2)|0}}}break}case 16:{if((k|0)>0){H=c;I=0;G=C;while(1){J=f[H+4>>2]|0;f[G>>2]=f[H>>2];f[G+4>>2]=J;J=f[H+12>>2]|0;f[G+8>>2]=f[H+8>>2];f[G+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{H=H+(E<<2)|0;G=G+(F<<2)|0}}}break}default:{}}F=c+(Y(f[D>>2]|0,i)|0)|0;if(y){g1c(f[q>>2]|0,0,Y(f[B>>2]|0,k)|0)|0;G=f[D>>2]|0;H=F+(Y(G,l+-2|0)|0)|0;I=f[q>>2]|0;C=(f[B>>2]|0)>>>2;switch(G|0){case 4:{if((k|0)>0){K=H;L=0;M=I}else{N=F;O=I;P=56;break a}while(1){f[M>>2]=f[K>>2];L=L+1|0;if((L|0)==(k|0)){Q=F;P=54;break}else{K=K+(E<<2)|0;M=M+(C<<2)|0}}break}case 8:{if((k|0)>0){R=H;S=0;T=I}else{N=F;O=I;P=56;break a}while(1){B=f[R+4>>2]|0;f[T>>2]=f[R>>2];f[T+4>>2]=B;S=S+1|0;if((S|0)==(k|0)){Q=F;P=54;break}else{R=R+(E<<2)|0;T=T+(C<<2)|0}}break}case 16:{if((k|0)>0){U=H;V=0;W=I}else{N=F;O=I;P=56;break a}while(1){B=f[U+4>>2]|0;f[W>>2]=f[U>>2];f[W+4>>2]=B;B=f[U+12>>2]|0;f[W+8>>2]=f[U+8>>2];f[W+12>>2]=B;V=V+1|0;if((V|0)==(k|0)){Q=F;P=54;break}else{U=U+(E<<2)|0;W=W+(C<<2)|0}}break}default:{N=F;O=I;P=56;break a}}}else X=F}else{if((h|0)!=1){C=a+40|0;E=f[C>>2]|0;H=d>>>2;B=E>>>2;switch(E|0){case 4:{if((k|0)>0){E=c;D=0;G=o;while(1){f[G>>2]=f[E>>2];D=D+1|0;if((D|0)==(k|0))break;else{E=E+(H<<2)|0;G=G+(B<<2)|0}}}break}case 8:{if((k|0)>0){G=c;E=0;D=o;while(1){F=f[G+4>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=F;E=E+1|0;if((E|0)==(k|0))break;else{G=G+(H<<2)|0;D=D+(B<<2)|0}}}break}case 16:{if((k|0)>0){D=c;G=0;E=o;while(1){F=f[D+4>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=F;F=f[D+12>>2]|0;f[E+8>>2]=f[D+8>>2];f[E+12>>2]=F;G=G+1|0;if((G|0)==(k|0))break;else{D=D+(H<<2)|0;E=E+(B<<2)|0}}}break}default:{}}b:do if(y){B=f[C>>2]|0;E=c+(Y(B,z)|0)|0;D=B>>>2;switch(B|0){case 4:{if((k|0)>0){Z=E;_=0;$=r}else break b;while(1){f[$>>2]=f[Z>>2];_=_+1|0;if((_|0)==(k|0))break;else{Z=Z+(H<<2)|0;$=$+(D<<2)|0}}break}case 8:{if((k|0)>0){aa=E;ba=0;ca=r}else break b;while(1){B=f[aa+4>>2]|0;f[ca>>2]=f[aa>>2];f[ca+4>>2]=B;ba=ba+1|0;if((ba|0)==(k|0))break;else{aa=aa+(H<<2)|0;ca=ca+(D<<2)|0}}break}case 16:{if((k|0)>0){da=E;ea=0;fa=r}else break b;while(1){B=f[da+4>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=B;B=f[da+12>>2]|0;f[fa+8>>2]=f[da+8>>2];f[fa+12>>2]=B;ea=ea+1|0;if((ea|0)==(k|0))break;else{da=da+(H<<2)|0;fa=fa+(D<<2)|0}}break}default:break b}}while(0);Q=c+(f[C>>2]|0)|0;P=54;break}H=a+36|0;D=f[H>>2]|0;E=d>>>2;B=D>>>2;switch(D|0){case 4:{if((k|0)>0){D=c;G=0;F=o;while(1){f[F>>2]=f[D>>2];G=G+1|0;if((G|0)==(k|0))break;else{D=D+(E<<2)|0;F=F+(B<<2)|0}}}break}case 8:{if((k|0)>0){F=c;D=0;G=o;while(1){C=f[F+4>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=C;D=D+1|0;if((D|0)==(k|0))break;else{F=F+(E<<2)|0;G=G+(B<<2)|0}}}break}case 16:{if((k|0)>0){G=c;F=0;D=o;while(1){C=f[G+4>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=C;C=f[G+12>>2]|0;f[D+8>>2]=f[G+8>>2];f[D+12>>2]=C;F=F+1|0;if((F|0)==(k|0))break;else{G=G+(E<<2)|0;D=D+(B<<2)|0}}}break}default:{}}Z0(o,k,f[H>>2]|0);if(y){B=f[H>>2]|0;D=c+(Y(B,l+-1|0)|0)|0;G=f[q>>2]|0;F=B>>>2;switch(B|0){case 4:{if((k|0)>0){B=D;C=0;I=G;while(1){f[I>>2]=f[B>>2];C=C+1|0;if((C|0)==(k|0))break;else{B=B+(E<<2)|0;I=I+(F<<2)|0}}}break}case 8:{if((k|0)>0){I=D;B=0;C=G;while(1){J=f[I+4>>2]|0;f[C>>2]=f[I>>2];f[C+4>>2]=J;B=B+1|0;if((B|0)==(k|0))break;else{I=I+(E<<2)|0;C=C+(F<<2)|0}}}break}case 16:{if((k|0)>0){C=D;I=0;B=G;while(1){J=f[C+4>>2]|0;f[B>>2]=f[C>>2];f[B+4>>2]=J;J=f[C+12>>2]|0;f[B+8>>2]=f[C+8>>2];f[B+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{C=C+(E<<2)|0;B=B+(F<<2)|0}}}break}default:{}}Z0(G,k,f[H>>2]|0)}Q=c+(f[H>>2]|0)|0;P=54}while(0);if((P|0)==54)if(y){N=Q;O=f[q>>2]|0;P=56}else X=Q;if((P|0)==56){P=f[a+12>>2]|0;Ti[f[f[P>>2]>>2]&511](P,O,s);X=N}N=f[a+12>>2]|0;Ti[f[f[N>>2]>>2]&511](N,f[m>>2]|0,t);c:do if((i|0)==1)if(!(b[A>>0]|0)){N=a+36|0;O=f[N>>2]|0;o1c(t+O|0,t|0,O|0)|0;O=f[N>>2]|0;P=t+O|0;Q=O>>>2;c=g>>>2;switch(O|0){case 4:{if((k|0)>0){O=P;o=0;fa=e;while(1){f[fa>>2]=f[O>>2];o=o+1|0;if((o|0)==(k|0))break;else{O=O+(Q<<2)|0;fa=fa+(c<<2)|0}}}break}case 8:{if((k|0)>0){fa=P;O=0;o=e;while(1){H=f[fa+4>>2]|0;f[o>>2]=f[fa>>2];f[o+4>>2]=H;O=O+1|0;if((O|0)==(k|0))break;else{fa=fa+(Q<<2)|0;o=o+(c<<2)|0}}}break}case 16:{if((k|0)>0){o=P;fa=0;O=e;while(1){H=f[o+4>>2]|0;f[O>>2]=f[o>>2];f[O+4>>2]=H;H=f[o+12>>2]|0;f[O+8>>2]=f[o+8>>2];f[O+12>>2]=H;fa=fa+1|0;if((fa|0)==(k|0))break;else{o=o+(Q<<2)|0;O=O+(c<<2)|0}}}break}default:{}}if(!y){ga=N;break}O=f[N>>2]|0;o1c(s+O|0,s|0,O|0)|0;O=f[N>>2]|0;Q=s+O|0;o=e+(Y(O,l+-1|0)|0)|0;fa=O>>>2;switch(O|0){case 4:{if((k|0)>0){ha=Q;ia=0;ja=o}else{ga=N;break c}while(1){f[ja>>2]=f[ha>>2];ia=ia+1|0;if((ia|0)==(k|0)){ga=N;break}else{ha=ha+(fa<<2)|0;ja=ja+(c<<2)|0}}break}case 8:{if((k|0)>0){ka=Q;la=0;ma=o}else{ga=N;break c}while(1){O=f[ka+4>>2]|0;f[ma>>2]=f[ka>>2];f[ma+4>>2]=O;la=la+1|0;if((la|0)==(k|0)){ga=N;break}else{ka=ka+(fa<<2)|0;ma=ma+(c<<2)|0}}break}case 16:{if((k|0)>0){na=Q;oa=0;pa=o}else{ga=N;break c}while(1){O=f[na+4>>2]|0;f[pa>>2]=f[na>>2];f[pa+4>>2]=O;O=f[na+12>>2]|0;f[pa+8>>2]=f[na+8>>2];f[pa+12>>2]=O;oa=oa+1|0;if((oa|0)==(k|0)){ga=N;break}else{na=na+(fa<<2)|0;pa=pa+(c<<2)|0}}break}default:{ga=N;break c}}}else{c=a+40|0;fa=a+36|0;o=(f[c>>2]|0)>>>2;Q=g>>>2;switch(f[fa>>2]|0){case 4:{if((k|0)>0){O=t;P=0;H=e;while(1){f[H>>2]=f[O>>2];P=P+1|0;if((P|0)==(k|0))break;else{O=O+(o<<2)|0;H=H+(Q<<2)|0}}}break}case 8:{if((k|0)>0){H=t;O=0;P=e;while(1){N=f[H+4>>2]|0;f[P>>2]=f[H>>2];f[P+4>>2]=N;O=O+1|0;if((O|0)==(k|0))break;else{H=H+(o<<2)|0;P=P+(Q<<2)|0}}}break}case 16:{if((k|0)>0){P=t;H=0;O=e;while(1){N=f[P+4>>2]|0;f[O>>2]=f[P>>2];f[O+4>>2]=N;N=f[P+12>>2]|0;f[O+8>>2]=f[P+8>>2];f[O+12>>2]=N;H=H+1|0;if((H|0)==(k|0))break;else{P=P+(o<<2)|0;O=O+(Q<<2)|0}}}break}default:{}}if(!y){ga=fa;break}O=f[fa>>2]|0;o=e+(Y(O,l+-1|0)|0)|0;P=(f[c>>2]|0)>>>2;switch(O|0){case 4:{if((k|0)>0){qa=s;ra=0;sa=o}else{ga=fa;break c}while(1){f[sa>>2]=f[qa>>2];ra=ra+1|0;if((ra|0)==(k|0)){ga=fa;break}else{qa=qa+(P<<2)|0;sa=sa+(Q<<2)|0}}break}case 8:{if((k|0)>0){ta=s;ua=0;va=o}else{ga=fa;break c}while(1){c=f[ta+4>>2]|0;f[va>>2]=f[ta>>2];f[va+4>>2]=c;ua=ua+1|0;if((ua|0)==(k|0)){ga=fa;break}else{ta=ta+(P<<2)|0;va=va+(Q<<2)|0}}break}case 16:{if((k|0)>0){wa=s;xa=0;ya=o}else{ga=fa;break c}while(1){c=f[wa+4>>2]|0;f[ya>>2]=f[wa>>2];f[ya+4>>2]=c;c=f[wa+12>>2]|0;f[ya+8>>2]=f[wa+8>>2];f[ya+12>>2]=c;xa=xa+1|0;if((xa|0)==(k|0)){ga=fa;break}else{wa=wa+(P<<2)|0;ya=ya+(Q<<2)|0}}break}default:{ga=fa;break c}}}else{Q=a+40|0;P=f[Q>>2]|0;o=P>>>2;c=g>>>2;switch(P|0){case 4:{if((k|0)>0){P=t;O=0;H=e;while(1){f[H>>2]=f[P>>2];O=O+1|0;if((O|0)==(k|0))break;else{P=P+(o<<2)|0;H=H+(c<<2)|0}}}break}case 8:{if((k|0)>0){H=t;P=0;O=e;while(1){fa=f[H+4>>2]|0;f[O>>2]=f[H>>2];f[O+4>>2]=fa;P=P+1|0;if((P|0)==(k|0))break;else{H=H+(o<<2)|0;O=O+(c<<2)|0}}}break}case 16:{if((k|0)>0){O=t;H=0;P=e;while(1){fa=f[O+4>>2]|0;f[P>>2]=f[O>>2];f[P+4>>2]=fa;fa=f[O+12>>2]|0;f[P+8>>2]=f[O+8>>2];f[P+12>>2]=fa;H=H+1|0;if((H|0)==(k|0))break;else{O=O+(o<<2)|0;P=P+(c<<2)|0}}}break}default:{}}if(y){P=f[Q>>2]|0;o=e+(Y(P,z)|0)|0;O=P>>>2;switch(P|0){case 4:{if((k|0)>0){za=s;Aa=0;Ba=o}else{ga=Q;break c}while(1){f[Ba>>2]=f[za>>2];Aa=Aa+1|0;if((Aa|0)==(k|0)){ga=Q;break}else{za=za+(O<<2)|0;Ba=Ba+(c<<2)|0}}break}case 8:{if((k|0)>0){Ca=s;Da=0;Ea=o}else{ga=Q;break c}while(1){P=f[Ca+4>>2]|0;f[Ea>>2]=f[Ca>>2];f[Ea+4>>2]=P;Da=Da+1|0;if((Da|0)==(k|0)){ga=Q;break}else{Ca=Ca+(O<<2)|0;Ea=Ea+(c<<2)|0}}break}case 16:{if((k|0)>0){Fa=s;Ga=0;Ha=o}else{ga=Q;break c}while(1){P=f[Fa+4>>2]|0;f[Ha>>2]=f[Fa>>2];f[Ha+4>>2]=P;P=f[Fa+12>>2]|0;f[Ha+8>>2]=f[Fa+8>>2];f[Ha+12>>2]=P;Ga=Ga+1|0;if((Ga|0)==(k|0)){ga=Q;break}else{Fa=Fa+(O<<2)|0;Ha=Ha+(c<<2)|0}}break}default:{ga=Q;break c}}}else ga=Q}while(0);u=1;v=z;w=e+(f[ga>>2]|0)|0;x=X}if((u|0)<(v|0)){X=a+40|0;ga=d>>>2;d=a+12|0;z=(k|0)>0;Ha=k<<1;Fa=k<<2;Ga=g>>>2;Ea=u;u=x;x=w;while(1){w=(Ea+1|0)<(v|0);Ca=f[m>>2]|0;d:do if(w){Da=f[q>>2]|0;switch(f[X>>2]|0){case 4:{if(z){Ba=u;za=0;while(1){Aa=f[Ba+4>>2]|0;f[Ca+(za<<2)>>2]=f[Ba>>2];f[Da+(za<<2)>>2]=Aa;za=za+1|0;if((za|0)==(k|0))break;else Ba=Ba+(ga<<2)|0}}break}case 8:{if(z){Ba=u;za=0;while(1){Aa=f[Ba+4>>2]|0;f[Ca+(za<<2)>>2]=f[Ba>>2];y=za|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[Ba+12>>2]|0;f[Da+(za<<2)>>2]=f[Ba+8>>2];f[Da+(y<<2)>>2]=Aa;za=za+2|0;if((za|0)>=(Ha|0))break;else Ba=Ba+(ga<<2)|0}}break}case 16:{if(z){Ba=0;za=u;while(1){Aa=f[za+4>>2]|0;f[Ca+(Ba<<2)>>2]=f[za>>2];y=Ba|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[za+12>>2]|0;ya=Ba|2;f[Ca+(ya<<2)>>2]=f[za+8>>2];wa=Ba|3;f[Ca+(wa<<2)>>2]=Aa;Aa=f[za+20>>2]|0;f[Da+(Ba<<2)>>2]=f[za+16>>2];f[Da+(y<<2)>>2]=Aa;Aa=f[za+28>>2]|0;f[Da+(ya<<2)>>2]=f[za+24>>2];f[Da+(wa<<2)>>2]=Aa;Ba=Ba+4|0;if((Ba|0)>=(Fa|0))break;else za=za+(ga<<2)|0}}break}default:{}}za=f[d>>2]|0;Ti[f[f[za>>2]>>2]&511](za,Da,s);Ia=f[m>>2]|0}else{za=f[X>>2]|0;Ba=za>>>2;switch(za|0){case 4:{if(z){Ja=u;Ka=0;La=Ca}else{Ia=Ca;break d}while(1){f[La>>2]=f[Ja>>2];Ka=Ka+1|0;if((Ka|0)==(k|0)){Ia=Ca;break}else{Ja=Ja+(ga<<2)|0;La=La+(Ba<<2)|0}}break}case 8:{if(z){Ma=u;Na=0;Oa=Ca}else{Ia=Ca;break d}while(1){Da=f[Ma+4>>2]|0;f[Oa>>2]=f[Ma>>2];f[Oa+4>>2]=Da;Na=Na+1|0;if((Na|0)==(k|0)){Ia=Ca;break}else{Ma=Ma+(ga<<2)|0;Oa=Oa+(Ba<<2)|0}}break}case 16:{if(z){Pa=u;Qa=0;Ra=Ca}else{Ia=Ca;break d}while(1){Da=f[Pa+4>>2]|0;f[Ra>>2]=f[Pa>>2];f[Ra+4>>2]=Da;Da=f[Pa+12>>2]|0;f[Ra+8>>2]=f[Pa+8>>2];f[Ra+12>>2]=Da;Qa=Qa+1|0;if((Qa|0)==(k|0)){Ia=Ca;break}else{Pa=Pa+(ga<<2)|0;Ra=Ra+(Ba<<2)|0}}break}default:{Ia=Ca;break d}}}while(0);Ca=f[d>>2]|0;Ti[f[f[Ca>>2]>>2]&511](Ca,Ia,t);Ca=f[X>>2]|0;e:do if(w)switch(Ca|0){case 4:{if(z){Sa=0;Ta=x}else break e;while(1){Q=f[s+(Sa<<2)>>2]|0;f[Ta>>2]=f[t+(Sa<<2)>>2];f[Ta+4>>2]=Q;Sa=Sa+1|0;if((Sa|0)==(k|0))break;else Ta=Ta+(Ga<<2)|0}break}case 8:{if(z){Ua=0;Va=x}else break e;while(1){Q=Ua|1;Ba=f[t+(Q<<2)>>2]|0;f[Va>>2]=f[t+(Ua<<2)>>2];f[Va+4>>2]=Ba;Ba=f[s+(Q<<2)>>2]|0;f[Va+8>>2]=f[s+(Ua<<2)>>2];f[Va+12>>2]=Ba;Ua=Ua+2|0;if((Ua|0)>=(Ha|0))break;else Va=Va+(Ga<<2)|0}break}case 16:{if(z){Wa=x;Xa=0}else break e;while(1){Ba=Xa|1;Q=f[t+(Ba<<2)>>2]|0;f[Wa>>2]=f[t+(Xa<<2)>>2];f[Wa+4>>2]=Q;Q=Xa|2;Da=Xa|3;za=f[t+(Da<<2)>>2]|0;f[Wa+8>>2]=f[t+(Q<<2)>>2];f[Wa+12>>2]=za;za=f[s+(Ba<<2)>>2]|0;f[Wa+16>>2]=f[s+(Xa<<2)>>2];f[Wa+20>>2]=za;za=f[s+(Da<<2)>>2]|0;f[Wa+24>>2]=f[s+(Q<<2)>>2];f[Wa+28>>2]=za;Xa=Xa+4|0;if((Xa|0)>=(Fa|0))break;else Wa=Wa+(Ga<<2)|0}break}default:break e}else{za=Ca>>>2;switch(Ca|0){case 4:{if(z){Ya=t;Za=0;_a=x}else break e;while(1){f[_a>>2]=f[Ya>>2];Za=Za+1|0;if((Za|0)==(k|0))break;else{Ya=Ya+(za<<2)|0;_a=_a+(Ga<<2)|0}}break}case 8:{if(z){$a=t;ab=0;bb=x}else break e;while(1){Q=f[$a+4>>2]|0;f[bb>>2]=f[$a>>2];f[bb+4>>2]=Q;ab=ab+1|0;if((ab|0)==(k|0))break;else{$a=$a+(za<<2)|0;bb=bb+(Ga<<2)|0}}break}case 16:{if(z){cb=t;db=0;eb=x}else break e;while(1){Q=f[cb+4>>2]|0;f[eb>>2]=f[cb>>2];f[eb+4>>2]=Q;Q=f[cb+12>>2]|0;f[eb+8>>2]=f[cb+8>>2];f[eb+12>>2]=Q;db=db+1|0;if((db|0)==(k|0))break;else{cb=cb+(za<<2)|0;eb=eb+(Ga<<2)|0}}break}default:break e}}while(0);Ca=f[X>>2]<<1;Ea=Ea+2|0;if((Ea|0)>=(v|0))break;else{u=u+Ca|0;x=x+Ca|0}}}if(!j)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if((k|0)<=0)return;j=(l+1|0)/2|0;if((l|0)>2)fb=0;else return;do{x=e+((Y(fb,a)|0)<<2)|0;u=e+((Y(k-fb|0,a)|0)<<2)|0;v=(fb|0)==0|(fb<<1|0)==(k|0)?x:u;u=1;do{Ea=u<<1;X=l-u<<1;f[x+(X<<2)>>2]=f[v+(Ea<<2)>>2];n[x+((X|1)<<2)>>2]=-+n[v+((Ea|1)<<2)>>2];u=u+1|0}while((u|0)<(j|0));fb=fb+1|0}while((fb|0)!=(k|0));return}else{fb=g>>>3;if((k|0)<=0)return;g=(l+1|0)/2|0;if((l|0)>2)gb=0;else return;do{j=e+((Y(gb,fb)|0)<<3)|0;a=e+((Y(k-gb|0,fb)|0)<<3)|0;u=(gb|0)==0|(gb<<1|0)==(k|0)?j:a;a=1;do{v=a<<1;x=l-a<<1;p[j+(x<<3)>>3]=+p[u+(v<<3)>>3];p[j+((x|1)<<3)>>3]=-+p[u+((v|1)<<3)>>3];a=a+1|0}while((a|0)<(g|0));gb=gb+1|0}while((gb|0)!=(k|0));return}}function Z0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if((c|0)==4){c=b+1|0;d=(c|0)/2|0;if((b|0)>2){e=1;do{g=e<<1;h=b-e<<1;f[a+(h<<2)>>2]=f[a+(g+-1<<2)>>2];n[a+((h|1)<<2)>>2]=-+n[a+(g<<2)>>2];e=e+1|0}while((e|0)<(d|0))}d=b+-1|0;if(!(b&1)){f[a+(b<<2)>>2]=f[a+(d<<2)>>2];n[a+(c<<2)>>2]=0.0;i=d}else i=b;if((i|0)>1){d=i;do{i=d;d=d+-1|0;f[a+(i<<2)>>2]=f[a+(d<<2)>>2]}while((d|0)>1)}n[a+4>>2]=0.0;return}else{d=b+1|0;i=(d|0)/2|0;if((b|0)>2){c=1;do{e=c<<1;g=b-c<<1;p[a+(g<<3)>>3]=+p[a+(e+-1<<3)>>3];p[a+((g|1)<<3)>>3]=-+p[a+(e<<3)>>3];c=c+1|0}while((c|0)<(i|0))}i=b+-1|0;if(!(b&1)){p[a+(b<<3)>>3]=+p[a+(i<<3)>>3];p[a+(d<<3)>>3]=0.0;j=i}else j=b;if((j|0)>1){b=j;do{j=b;b=b+-1|0;p[a+(j<<3)>>3]=+p[a+(b<<3)>>3]}while((b|0)>1)}p[a+8>>3]=0.0;return}}function _0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function $0(a){a=a|0;cYc(a);return}function a1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=u;u=u+208|0;h=g+144|0;i=g+88|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g;n=g+8|0;do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[h>>2]=f[o>>2];p=h+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[o+8>>2];s=h+12|0;f[s>>2]=f[o+12>>2];t=h+16|0;f[t>>2]=f[o+16>>2];v=h+20|0;f[v>>2]=f[o+20>>2];w=h+24|0;f[w>>2]=f[o+24>>2];x=h+28|0;f[x>>2]=f[o+28>>2];y=h+32|0;f[y>>2]=f[o+32>>2];z=h+36|0;A=f[o+36>>2]|0;f[z>>2]=A;f[h+40>>2]=r;B=h+48|0;C=h+44|0;f[C>>2]=B;f[B>>2]=0;f[h+52>>2]=0;if(A|0){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;B=f[C>>2]|0;f[B>>2]=f[q>>2];f[B+4>>2]=f[q+4>>2];D=r;E=s;F=t;G=t;H=v;I=w;J=x;K=y;L=z;M=z;N=p;O=h;break}else{f[p>>2]=0;U$(h,o);D=r;E=s;F=t;G=t;H=v;I=w;J=x;K=y;L=z;M=z;N=p;O=h;break}}else{bS(h,a,-1);p=h+16|0;z=h+36|0;D=h+8|0;E=h+12|0;F=p;G=p;H=h+20|0;I=h+24|0;J=h+28|0;K=h+32|0;L=z;M=z;N=h+4|0;O=h}while(0);f[i>>2]=f[O>>2];O=i+4|0;a=f[N>>2]|0;f[O>>2]=a;z=i+8|0;f[z>>2]=f[D>>2];D=i+12|0;f[D>>2]=f[E>>2];E=i+16|0;f[E>>2]=f[G>>2];f[i+20>>2]=f[H>>2];f[i+24>>2]=f[I>>2];f[i+28>>2]=f[J>>2];f[i+32>>2]=f[K>>2];K=i+36|0;J=f[M>>2]|0;f[K>>2]=J;M=i+40|0;f[M>>2]=z;I=i+48|0;H=i+44|0;f[H>>2]=I;f[I>>2]=0;f[i+52>>2]=0;if(!J)P=a;else{a=J+12|0;f[a>>2]=(f[a>>2]|0)+1;P=f[N>>2]|0}if((P|0)<3){P=f[h+44>>2]|0;a=f[H>>2]|0;f[a>>2]=f[P>>2];f[a+4>>2]=f[P+4>>2]}else{f[O>>2]=0;U$(i,h)}P=(d&1|0)==0;a=f[i>>2]|0;J=a&4095;G=a&7;switch(a&4095){case 5:case 6:case 13:case 14:break;default:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=$Xc(80)|0;f[j>>2]=p;f[j+8>>2]=-2147483568;f[j+4>>2]=76;Q=p;R=239888;S=Q+76|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[p+76>>0]=0;vM(-215,j,239965,239116,3335)}}if(!((d&64|0)==0|(a&4088|0)==8)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=$Xc(64)|0;f[j>>2]=p;f[j+8>>2]=-2147483584;f[j+4>>2]=53;Q=p;R=239969;S=Q+53|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[p+53>>0]=0;vM(-215,j,239965,239116,3338)}p=a>>>3&511;if(P)if((d&16|0)==0|(p|0)!=0)T=22;else{P=f[M>>2]|0;a=f[P>>2]|0;f[k>>2]=f[P+4>>2];f[k+4>>2]=a;wS(c,k,G|8,-1,0,0)}else if((d&32|0)==0|(p|0)!=1)T=22;else{p=f[M>>2]|0;k=f[p>>2]|0;f[l>>2]=f[p+4>>2];f[l+4>>2]=k;wS(c,l,G,-1,0,0)}if((T|0)==22){T=f[M>>2]|0;l=f[T>>2]|0;f[m>>2]=f[T+4>>2];f[m+4>>2]=l;wS(c,m,J,-1,0,0)}do if((eS(c)|0)==65536){J=f[c+4>>2]|0;f[j>>2]=f[J>>2];m=j+4|0;l=J+4|0;f[m>>2]=f[l>>2];T=j+8|0;f[T>>2]=f[J+8>>2];f[j+12>>2]=f[J+12>>2];f[j+16>>2]=f[J+16>>2];f[j+20>>2]=f[J+20>>2];f[j+24>>2]=f[J+24>>2];f[j+28>>2]=f[J+28>>2];f[j+32>>2]=f[J+32>>2];k=f[J+36>>2]|0;f[j+36>>2]=k;f[j+40>>2]=T;T=j+48|0;p=j+44|0;f[p>>2]=T;f[T>>2]=0;f[j+52>>2]=0;if(k|0){T=k+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[l>>2]|0)<3){l=f[J+44>>2]|0;T=f[p>>2]|0;f[T>>2]=f[l>>2];f[T+4>>2]=f[l+4>>2];break}else{f[m>>2]=0;U$(j,J);break}}else bS(j,c,-1);while(0);c=f[i>>2]|0;J=f[j>>2]|0;m=d&7|((c&16384|0)==0?0:J>>>5&512);d=j+16|0;N0(n,f[D>>2]|0,f[z>>2]|0,G,(c>>>3&511)+1|0,(J>>>3&511)+1|0,(f[E>>2]|0)==(f[d>>2]|0)?m|1024:m,e);e=f[n>>2]|0;m=j+48|0;gi[f[f[e>>2]>>2]&255](e,f[E>>2]|0,f[I>>2]|0,f[d>>2]|0,f[m>>2]|0);e=f[n+4>>2]|0;if(e|0)UXc(e);e=j+36|0;n=f[e>>2]|0;if(n|0?(J=n+12|0,n=f[J>>2]|0,f[J>>2]=n+-1,(n|0)==1):0)V$(j);f[e>>2]=0;e=j+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[j+40>>2]|0;n=0;do{f[d+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(m|0))wL(e);e=f[K>>2]|0;if(e|0?(m=e+12|0,e=f[m>>2]|0,f[m>>2]=e+-1,(e|0)==1):0)V$(i);f[K>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[O>>2]|0)>0){E=f[M>>2]|0;M=0;do{f[E+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[O>>2]|0))}O=f[H>>2]|0;if((O|0)!=(I|0))wL(O);O=f[L>>2]|0;if(O|0?(I=O+12|0,O=f[I>>2]|0,f[I>>2]=O+-1,(O|0)==1):0)V$(h);f[L>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[N>>2]|0)>0){F=f[h+40>>2]|0;L=0;do{f[F+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[N>>2]|0))}N=f[h+44>>2]|0;if((N|0)==(h+48|0)){u=g;return}wL(N);u=g;return}function b1(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;h=u;u=u+240|0;i=h+224|0;j=h+168|0;k=h+112|0;l=h+56|0;m=h;do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[j>>2]=f[o>>2];q=j+4|0;r=o+4|0;f[q>>2]=f[r>>2];s=j+8|0;f[s>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[j+16>>2]=f[o+16>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[j+36>>2]=t;f[j+40>>2]=s;s=j+48|0;v=j+44|0;f[v>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[o+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;U$(j,o);break}}else bS(j,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];o=k+4|0;q=a+4|0;f[o>>2]=f[q>>2];r=k+8|0;f[r>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=r;r=k+48|0;v=k+44|0;f[v>>2]=r;f[r>>2]=0;f[k+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=k;break}else{f[o>>2]=0;U$(k,a);w=k;break}}else{bS(k,c,-1);w=k}while(0);c=f[j>>2]|0;a=c&7;o=c>>>3&511;q=o+1|0;r=c&4095;v=f[j+8>>2]|0;s=f[j+12>>2]|0;if((r|0)!=(f[w>>2]&4095|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;x=$Xc(64)|0;f[i>>2]=x;y=i+8|0;f[y>>2]=-2147483584;z=i+4|0;f[z>>2]=49;A=x;B=240023;C=A+49|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+49|0;b[D>>0]=0;vM(-215,i,240073,239116,3541)}t=j+40|0;E=f[t>>2]|0;F=k+40|0;G=f[F>>2]|0;if(!((f[E>>2]|0)==(f[G>>2]|0)?(f[E+4>>2]|0)==(f[G+4>>2]|0):0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;x=$Xc(64)|0;f[i>>2]=x;y=i+8|0;f[y>>2]=-2147483584;z=i+4|0;f[z>>2]=49;A=x;B=240023;C=A+49|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+49|0;b[D>>0]=0;vM(-215,i,240073,239116,3541)}switch(c&4095){case 5:case 6:case 13:case 14:break;default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;c=$Xc(80)|0;f[i>>2]=c;f[i+8>>2]=-2147483568;f[i+4>>2]=76;A=c;B=239888;C=A+76|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[c+76>>0]=0;vM(-215,i,240073,239116,3542)}}ZS(d,v,s,r,-1,0,0);do if((eS(d)|0)==65536){r=f[d+4>>2]|0;f[l>>2]=f[r>>2];c=l+4|0;B=r+4|0;f[c>>2]=f[B>>2];D=l+8|0;f[D>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];x=l+16|0;f[x>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];z=f[r+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=D;D=l+48|0;y=l+44|0;f[y>>2]=D;f[D>>2]=0;f[l+52>>2]=0;if(z|0){D=z+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[r+44>>2]|0;D=f[y>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];H=x;break}else{f[c>>2]=0;U$(l,r);H=x;break}}else{bS(l,d,-1);H=l+16|0}while(0);d=k+16|0;if((f[H>>2]|0)==(f[d>>2]|0)){f[m>>2]=1124007936;x=m+4|0;r=m+8|0;c=m+40|0;A=x;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[c>>2]=r;A=m+48|0;f[m+44>>2]=A;f[A>>2]=0;f[m+52>>2]=0;C=i+8|0;f[C>>2]=0;f[C+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;jR(k,i);i=k+36|0;C=f[i>>2]|0;if(C|0?(B=C+12|0,C=f[B>>2]|0,f[B>>2]=C+-1,(C|0)==1):0)V$(k);f[i>>2]=0;C=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[C>>2]|0)>0){B=f[F>>2]|0;D=0;do{f[B+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[C>>2]|0))}f[w>>2]=f[m>>2];D=f[x>>2]|0;f[C>>2]=D;C=k+8|0;f[C>>2]=f[r>>2];f[k+12>>2]=f[m+12>>2];B=m+16|0;f[d>>2]=f[B>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];f[k+32>>2]=f[m+32>>2];y=m+36|0;f[i>>2]=f[y>>2];i=k+44|0;z=f[i>>2]|0;G=k+48|0;if((z|0)==(G|0))I=D;else{wL(z);f[i>>2]=G;f[F>>2]=C;I=f[x>>2]|0}C=m+44|0;if((I|0)<3){I=f[C>>2]|0;f[G>>2]=f[I>>2];f[k+52>>2]=f[I+4>>2];J=I}else{f[i>>2]=f[C>>2];f[k+40>>2]=f[c>>2];f[C>>2]=A;f[c>>2]=r;J=A}f[m>>2]=1124007936;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;f[y>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((J|0)!=(A|0))wL(J)}J=(e&4|0)!=0;if(!(J|(v|0)==1))if(((s|0)==1?(f[j>>2]&16384|0)!=0:0)?(f[w>>2]&16384|0)!=0:0)K=(f[l>>2]&16384|0)!=0;else K=0;else K=1;w=J|K^1;J=s+(w?0:v+-1|0)|0;s=w?v:1;v=(o|0)==0;w=v&1;e=J&1;A=(e|0)==0;B=(Y(J,q)|0)-((e|o|0)==0&1)|0;o=j+16|0;e=f[o>>2]|0;a:do if((a|0)==5){q=f[d>>2]|0;y=f[H>>2]|0;x=f[j+48>>2]|0;m=f[k+48>>2]|0;r=f[l+48>>2]|0;c=(e|0)==(y|0);C=K|v^1;if(g)if(c){do if(!C){n[e>>2]=+n[e>>2]*+n[q>>2];i=s+-2|0;I=(i|0)==0;if(!I){G=1;do{z=e+(Y(G,r)|0)|0;L=+n[z>>2];D=G+1|0;E=e+(Y(D,r)|0)|0;M=+n[E>>2];N=q+(Y(G,m)|0)|0;O=+n[N>>2];N=q+(Y(D,m)|0)|0;P=-+n[N>>2];n[z>>2]=L*O-M*P;n[E>>2]=M*O+L*P;G=G+2|0}while(G>>>0<=i>>>0);if(!(s&1)){Q=s+-1|0;R=109}}else{Q=1;R=109}if((R|0)==109){G=e+(Y(Q,r)|0)|0;E=q+(Y(Q,m)|0)|0;n[G>>2]=+n[G>>2]*+n[E>>2]}if(A){E=q+(J<<2)+-4|0;G=e+(J<<2)+-4|0;n[G>>2]=+n[G>>2]*+n[E>>2];if(!I){z=1;do{N=G+(Y(z,r)|0)|0;P=+n[N>>2];D=z+1|0;S=G+(Y(D,r)|0)|0;L=+n[S>>2];T=E+(Y(z,m)|0)|0;O=+n[T>>2];T=E+(Y(D,m)|0)|0;M=-+n[T>>2];n[N>>2]=P*O-L*M;n[S>>2]=L*O+P*M;z=z+2|0}while(z>>>0<=i>>>0);if(!(s&1))U=s+-1|0;else break}else U=1;i=G+(Y(U,r)|0)|0;z=E+(Y(U,m)|0)|0;n[i>>2]=+n[i>>2]*+n[z>>2]}}while(0);z=v&K;i=s+-1|0;if(!s)break;I=w>>>0<B>>>0;S=z&A;if(!z){if(I){V=e;W=q;X=i}else break;while(1){z=w;do{N=V+(z<<2)|0;M=+n[N>>2];T=z+1|0;D=V+(T<<2)|0;P=+n[D>>2];O=+n[W+(z<<2)>>2];L=-+n[W+(T<<2)>>2];n[N>>2]=M*O-P*L;n[D>>2]=P*O+M*L;z=z+2|0}while(z>>>0<B>>>0);if(!X)break a;else{V=V+r|0;W=W+m|0;X=X+-1|0}}}if(!I)if(S){z=e;E=q;G=e;D=i;while(1){n[G>>2]=+n[z>>2]*+n[E>>2];n[G+(B<<2)>>2]=+n[z+(B<<2)>>2]*+n[E+(B<<2)>>2];if(!D)break a;else{z=z+x|0;E=E+m|0;G=G+r|0;D=D+-1|0}}}else{D=e;G=q;E=e;z=i;while(1){n[E>>2]=+n[D>>2]*+n[G>>2];if(!z)break a;else{D=D+x|0;G=G+m|0;E=E+r|0;z=z+-1|0}}}if(S){z=e;E=q;G=e;D=i;while(1){n[G>>2]=+n[z>>2]*+n[E>>2];I=w;do{N=G+(I<<2)|0;L=+n[N>>2];T=I+1|0;Z=G+(T<<2)|0;M=+n[Z>>2];O=+n[E+(I<<2)>>2];P=-+n[E+(T<<2)>>2];n[N>>2]=L*O-M*P;n[Z>>2]=M*O+L*P;I=I+2|0}while(I>>>0<B>>>0);n[G+(B<<2)>>2]=+n[z+(B<<2)>>2]*+n[E+(B<<2)>>2];if(!D)break;else{z=z+x|0;E=E+m|0;G=G+r|0;D=D+-1|0}}}else{D=e;G=q;E=e;z=i;while(1){n[E>>2]=+n[D>>2]*+n[G>>2];S=w;do{I=E+(S<<2)|0;P=+n[I>>2];Z=S+1|0;N=E+(Z<<2)|0;L=+n[N>>2];O=+n[G+(S<<2)>>2];M=-+n[G+(Z<<2)>>2];n[I>>2]=P*O-L*M;n[N>>2]=L*O+P*M;S=S+2|0}while(S>>>0<B>>>0);if(!z)break;else{D=D+x|0;G=G+m|0;E=E+r|0;z=z+-1|0}}}}else{do if(!C){n[y>>2]=+n[e>>2]*+n[q>>2];z=s+-2|0;E=(z|0)==0;if(!E){G=1;do{D=e+(Y(G,x)|0)|0;M=+n[D>>2];D=G+1|0;i=e+(Y(D,x)|0)|0;P=+n[i>>2];i=q+(Y(G,m)|0)|0;O=+n[i>>2];i=q+(Y(D,m)|0)|0;L=-+n[i>>2];i=y+(Y(G,r)|0)|0;n[i>>2]=M*O-P*L;i=y+(Y(D,r)|0)|0;n[i>>2]=P*O+M*L;G=G+2|0}while(G>>>0<=z>>>0);if(!(s&1)){_=s+-1|0;R=136}}else{_=1;R=136}if((R|0)==136){G=y+(Y(_,r)|0)|0;i=q+(Y(_,m)|0)|0;D=e+(Y(_,x)|0)|0;n[G>>2]=+n[D>>2]*+n[i>>2]}if(A){i=e+(J<<2)+-4|0;D=q+(J<<2)+-4|0;G=y+(J<<2)+-4|0;n[G>>2]=+n[i>>2]*+n[D>>2];if(!E){S=1;do{N=i+(Y(S,x)|0)|0;L=+n[N>>2];N=S+1|0;I=i+(Y(N,x)|0)|0;M=+n[I>>2];I=D+(Y(S,m)|0)|0;O=+n[I>>2];I=D+(Y(N,m)|0)|0;P=-+n[I>>2];I=G+(Y(S,r)|0)|0;n[I>>2]=L*O-M*P;I=G+(Y(N,r)|0)|0;n[I>>2]=M*O+L*P;S=S+2|0}while(S>>>0<=z>>>0);if(!(s&1))$=s+-1|0;else break}else $=1;z=G+(Y($,r)|0)|0;S=D+(Y($,m)|0)|0;E=i+(Y($,x)|0)|0;n[z>>2]=+n[E>>2]*+n[S>>2]}}while(0);S=v&K;E=s+-1|0;if(!s)break;z=w>>>0<B>>>0;I=S&A;if(!S){if(z){aa=e;ba=q;ca=y;da=E}else break;while(1){S=w;do{P=+n[aa+(S<<2)>>2];N=S+1|0;L=+n[aa+(N<<2)>>2];O=+n[ba+(S<<2)>>2];M=-+n[ba+(N<<2)>>2];n[ca+(S<<2)>>2]=P*O-L*M;n[ca+(N<<2)>>2]=L*O+P*M;S=S+2|0}while(S>>>0<B>>>0);if(!da)break a;else{aa=aa+x|0;ba=ba+m|0;ca=ca+r|0;da=da+-1|0}}}if(!z)if(I){S=e;i=q;D=y;G=E;while(1){n[D>>2]=+n[S>>2]*+n[i>>2];n[D+(B<<2)>>2]=+n[S+(B<<2)>>2]*+n[i+(B<<2)>>2];if(!G)break a;else{S=S+x|0;i=i+m|0;D=D+r|0;G=G+-1|0}}}else{G=e;D=q;i=y;S=E;while(1){n[i>>2]=+n[G>>2]*+n[D>>2];if(!S)break a;else{G=G+x|0;D=D+m|0;i=i+r|0;S=S+-1|0}}}if(I){S=e;i=q;D=y;G=E;while(1){n[D>>2]=+n[S>>2]*+n[i>>2];z=w;do{M=+n[S+(z<<2)>>2];N=z+1|0;P=+n[S+(N<<2)>>2];O=+n[i+(z<<2)>>2];L=-+n[i+(N<<2)>>2];n[D+(z<<2)>>2]=M*O-P*L;n[D+(N<<2)>>2]=P*O+M*L;z=z+2|0}while(z>>>0<B>>>0);n[D+(B<<2)>>2]=+n[S+(B<<2)>>2]*+n[i+(B<<2)>>2];if(!G)break;else{S=S+x|0;i=i+m|0;D=D+r|0;G=G+-1|0}}}else{G=e;D=q;i=y;S=E;while(1){n[i>>2]=+n[G>>2]*+n[D>>2];I=w;do{L=+n[G+(I<<2)>>2];z=I+1|0;M=+n[G+(z<<2)>>2];O=+n[D+(I<<2)>>2];P=-+n[D+(z<<2)>>2];n[i+(I<<2)>>2]=L*O-M*P;n[i+(z<<2)>>2]=M*O+L*P;I=I+2|0}while(I>>>0<B>>>0);if(!S)break;else{G=G+x|0;D=D+m|0;i=i+r|0;S=S+-1|0}}}}else if(c){do if(!C){n[e>>2]=+n[e>>2]*+n[q>>2];S=s+-2|0;i=(S|0)==0;if(!i){D=1;do{G=e+(Y(D,r)|0)|0;P=+n[G>>2];E=D+1|0;I=e+(Y(E,r)|0)|0;L=+n[I>>2];z=q+(Y(D,m)|0)|0;O=+n[z>>2];z=q+(Y(E,m)|0)|0;M=+n[z>>2];n[G>>2]=P*O-L*M;n[I>>2]=L*O+P*M;D=D+2|0}while(D>>>0<=S>>>0);if(!(s&1)){ea=s+-1|0;R=54}}else{ea=1;R=54}if((R|0)==54){D=e+(Y(ea,r)|0)|0;I=q+(Y(ea,m)|0)|0;n[D>>2]=+n[D>>2]*+n[I>>2]}if(A){I=q+(J<<2)+-4|0;D=e+(J<<2)+-4|0;n[D>>2]=+n[D>>2]*+n[I>>2];if(!i){G=1;do{z=D+(Y(G,r)|0)|0;M=+n[z>>2];E=G+1|0;N=D+(Y(E,r)|0)|0;P=+n[N>>2];Z=I+(Y(G,m)|0)|0;O=+n[Z>>2];Z=I+(Y(E,m)|0)|0;L=+n[Z>>2];n[z>>2]=M*O-P*L;n[N>>2]=P*O+M*L;G=G+2|0}while(G>>>0<=S>>>0);if(!(s&1))fa=s+-1|0;else break}else fa=1;S=D+(Y(fa,r)|0)|0;G=I+(Y(fa,m)|0)|0;n[S>>2]=+n[S>>2]*+n[G>>2]}}while(0);c=v&K;G=s+-1|0;if(!s)break;S=w>>>0<B>>>0;i=c&A;if(!c){if(S){ga=e;ha=q;ia=G}else break;while(1){c=w;do{N=ga+(c<<2)|0;L=+n[N>>2];z=c+1|0;Z=ga+(z<<2)|0;M=+n[Z>>2];O=+n[ha+(c<<2)>>2];P=+n[ha+(z<<2)>>2];n[N>>2]=L*O-M*P;n[Z>>2]=M*O+L*P;c=c+2|0}while(c>>>0<B>>>0);if(!ia)break a;else{ga=ga+r|0;ha=ha+m|0;ia=ia+-1|0}}}if(!S)if(i){c=e;I=q;D=e;Z=G;while(1){n[D>>2]=+n[c>>2]*+n[I>>2];n[D+(B<<2)>>2]=+n[c+(B<<2)>>2]*+n[I+(B<<2)>>2];if(!Z)break a;else{c=c+x|0;I=I+m|0;D=D+r|0;Z=Z+-1|0}}}else{Z=e;D=q;I=e;c=G;while(1){n[I>>2]=+n[Z>>2]*+n[D>>2];if(!c)break a;else{Z=Z+x|0;D=D+m|0;I=I+r|0;c=c+-1|0}}}if(i){c=e;I=q;D=e;Z=G;while(1){n[D>>2]=+n[c>>2]*+n[I>>2];S=w;do{N=D+(S<<2)|0;P=+n[N>>2];z=S+1|0;E=D+(z<<2)|0;L=+n[E>>2];O=+n[I+(S<<2)>>2];M=+n[I+(z<<2)>>2];n[N>>2]=P*O-L*M;n[E>>2]=L*O+P*M;S=S+2|0}while(S>>>0<B>>>0);n[D+(B<<2)>>2]=+n[c+(B<<2)>>2]*+n[I+(B<<2)>>2];if(!Z)break;else{c=c+x|0;I=I+m|0;D=D+r|0;Z=Z+-1|0}}}else{Z=e;D=q;I=e;c=G;while(1){n[I>>2]=+n[Z>>2]*+n[D>>2];i=w;do{S=I+(i<<2)|0;M=+n[S>>2];E=i+1|0;N=I+(E<<2)|0;P=+n[N>>2];O=+n[D+(i<<2)>>2];L=+n[D+(E<<2)>>2];n[S>>2]=M*O-P*L;n[N>>2]=P*O+M*L;i=i+2|0}while(i>>>0<B>>>0);if(!c)break;else{Z=Z+x|0;D=D+m|0;I=I+r|0;c=c+-1|0}}}}else{do if(!C){n[y>>2]=+n[e>>2]*+n[q>>2];c=s+-2|0;I=(c|0)==0;if(!I){D=1;do{Z=e+(Y(D,x)|0)|0;L=+n[Z>>2];Z=D+1|0;G=e+(Y(Z,x)|0)|0;M=+n[G>>2];G=q+(Y(D,m)|0)|0;O=+n[G>>2];G=q+(Y(Z,m)|0)|0;P=+n[G>>2];G=y+(Y(D,r)|0)|0;n[G>>2]=L*O-M*P;G=y+(Y(Z,r)|0)|0;n[G>>2]=M*O+L*P;D=D+2|0}while(D>>>0<=c>>>0);if(!(s&1)){ja=s+-1|0;R=81}}else{ja=1;R=81}if((R|0)==81){D=y+(Y(ja,r)|0)|0;G=q+(Y(ja,m)|0)|0;Z=e+(Y(ja,x)|0)|0;n[D>>2]=+n[Z>>2]*+n[G>>2]}if(A){G=e+(J<<2)+-4|0;Z=q+(J<<2)+-4|0;D=y+(J<<2)+-4|0;n[D>>2]=+n[G>>2]*+n[Z>>2];if(!I){i=1;do{N=G+(Y(i,x)|0)|0;P=+n[N>>2];N=i+1|0;S=G+(Y(N,x)|0)|0;L=+n[S>>2];S=Z+(Y(i,m)|0)|0;O=+n[S>>2];S=Z+(Y(N,m)|0)|0;M=+n[S>>2];S=D+(Y(i,r)|0)|0;n[S>>2]=P*O-L*M;S=D+(Y(N,r)|0)|0;n[S>>2]=L*O+P*M;i=i+2|0}while(i>>>0<=c>>>0);if(!(s&1))ka=s+-1|0;else break}else ka=1;c=D+(Y(ka,r)|0)|0;i=Z+(Y(ka,m)|0)|0;I=G+(Y(ka,x)|0)|0;n[c>>2]=+n[I>>2]*+n[i>>2]}}while(0);C=v&K;i=s+-1|0;if(!s)break;I=w>>>0<B>>>0;c=C&A;if(!C){if(I){la=e;ma=q;na=y;oa=i}else break;while(1){C=w;do{M=+n[la+(C<<2)>>2];S=C+1|0;P=+n[la+(S<<2)>>2];O=+n[ma+(C<<2)>>2];L=+n[ma+(S<<2)>>2];n[na+(C<<2)>>2]=M*O-P*L;n[na+(S<<2)>>2]=P*O+M*L;C=C+2|0}while(C>>>0<B>>>0);if(!oa)break a;else{la=la+x|0;ma=ma+m|0;na=na+r|0;oa=oa+-1|0}}}if(!I)if(c){C=e;G=q;Z=y;D=i;while(1){n[Z>>2]=+n[C>>2]*+n[G>>2];n[Z+(B<<2)>>2]=+n[C+(B<<2)>>2]*+n[G+(B<<2)>>2];if(!D)break a;else{C=C+x|0;G=G+m|0;Z=Z+r|0;D=D+-1|0}}}else{D=e;Z=q;G=y;C=i;while(1){n[G>>2]=+n[D>>2]*+n[Z>>2];if(!C)break a;else{D=D+x|0;Z=Z+m|0;G=G+r|0;C=C+-1|0}}}if(c){C=e;G=q;Z=y;D=i;while(1){n[Z>>2]=+n[C>>2]*+n[G>>2];I=w;do{L=+n[C+(I<<2)>>2];S=I+1|0;M=+n[C+(S<<2)>>2];O=+n[G+(I<<2)>>2];P=+n[G+(S<<2)>>2];n[Z+(I<<2)>>2]=L*O-M*P;n[Z+(S<<2)>>2]=M*O+L*P;I=I+2|0}while(I>>>0<B>>>0);n[Z+(B<<2)>>2]=+n[C+(B<<2)>>2]*+n[G+(B<<2)>>2];if(!D)break;else{C=C+x|0;G=G+m|0;Z=Z+r|0;D=D+-1|0}}}else{D=e;Z=q;G=y;C=i;while(1){n[G>>2]=+n[D>>2]*+n[Z>>2];c=w;do{P=+n[D+(c<<2)>>2];I=c+1|0;L=+n[D+(I<<2)>>2];O=+n[Z+(c<<2)>>2];M=+n[Z+(I<<2)>>2];n[G+(c<<2)>>2]=P*O-L*M;n[G+(I<<2)>>2]=L*O+P*M;c=c+2|0}while(c>>>0<B>>>0);if(!C)break;else{D=D+x|0;Z=Z+m|0;G=G+r|0;C=C+-1|0}}}}}else{C=f[d>>2]|0;r=f[H>>2]|0;G=f[j+48>>2]|0;m=f[k+48>>2]|0;Z=f[l+48>>2]|0;x=(e|0)==(r|0);D=K|v^1;if(g)if(x){do if(!D){p[e>>3]=+p[e>>3]*+p[C>>3];i=s+-2|0;y=(i|0)==0;if(!y){q=1;do{c=e+(Y(q,Z)|0)|0;M=+p[c>>3];I=q+1|0;S=e+(Y(I,Z)|0)|0;P=+p[S>>3];N=C+(Y(q,m)|0)|0;O=+p[N>>3];N=C+(Y(I,m)|0)|0;L=-+p[N>>3];p[c>>3]=M*O-P*L;p[S>>3]=P*O+M*L;q=q+2|0}while(q>>>0<=i>>>0);if(!(s&1)){pa=s+-1|0;R=220}}else{pa=1;R=220}if((R|0)==220){q=e+(Y(pa,Z)|0)|0;S=C+(Y(pa,m)|0)|0;p[q>>3]=+p[q>>3]*+p[S>>3]}if(A){S=C+(J<<3)+-8|0;q=e+(J<<3)+-8|0;p[q>>3]=+p[q>>3]*+p[S>>3];if(!y){c=1;do{N=q+(Y(c,Z)|0)|0;L=+p[N>>3];I=c+1|0;E=q+(Y(I,Z)|0)|0;M=+p[E>>3];z=S+(Y(c,m)|0)|0;O=+p[z>>3];z=S+(Y(I,m)|0)|0;P=-+p[z>>3];p[N>>3]=L*O-M*P;p[E>>3]=M*O+L*P;c=c+2|0}while(c>>>0<=i>>>0);if(!(s&1))qa=s+-1|0;else break}else qa=1;i=q+(Y(qa,Z)|0)|0;c=S+(Y(qa,m)|0)|0;p[i>>3]=+p[i>>3]*+p[c>>3]}}while(0);c=v&K;i=s+-1|0;if(!s)break;y=w>>>0<B>>>0;E=c&A;if(!c){if(y){ra=e;sa=C;ta=i}else break;while(1){c=w;do{N=ra+(c<<3)|0;P=+p[N>>3];z=c+1|0;I=ra+(z<<3)|0;L=+p[I>>3];O=+p[sa+(c<<3)>>3];M=-+p[sa+(z<<3)>>3];p[N>>3]=P*O-L*M;p[I>>3]=L*O+P*M;c=c+2|0}while(c>>>0<B>>>0);if(!ta)break a;else{ra=ra+Z|0;sa=sa+m|0;ta=ta+-1|0}}}if(!y)if(E){c=e;S=C;q=e;I=i;while(1){p[q>>3]=+p[c>>3]*+p[S>>3];p[q+(B<<3)>>3]=+p[c+(B<<3)>>3]*+p[S+(B<<3)>>3];if(!I)break a;else{c=c+G|0;S=S+m|0;q=q+Z|0;I=I+-1|0}}}else{I=e;q=C;S=e;c=i;while(1){p[S>>3]=+p[I>>3]*+p[q>>3];if(!c)break a;else{I=I+G|0;q=q+m|0;S=S+Z|0;c=c+-1|0}}}if(E){c=e;S=C;q=e;I=i;while(1){p[q>>3]=+p[c>>3]*+p[S>>3];y=w;do{N=q+(y<<3)|0;M=+p[N>>3];z=y+1|0;T=q+(z<<3)|0;P=+p[T>>3];O=+p[S+(y<<3)>>3];L=-+p[S+(z<<3)>>3];p[N>>3]=M*O-P*L;p[T>>3]=P*O+M*L;y=y+2|0}while(y>>>0<B>>>0);p[q+(B<<3)>>3]=+p[c+(B<<3)>>3]*+p[S+(B<<3)>>3];if(!I)break;else{c=c+G|0;S=S+m|0;q=q+Z|0;I=I+-1|0}}}else{I=e;q=C;S=e;c=i;while(1){p[S>>3]=+p[I>>3]*+p[q>>3];E=w;do{y=S+(E<<3)|0;L=+p[y>>3];T=E+1|0;N=S+(T<<3)|0;M=+p[N>>3];O=+p[q+(E<<3)>>3];P=-+p[q+(T<<3)>>3];p[y>>3]=L*O-M*P;p[N>>3]=M*O+L*P;E=E+2|0}while(E>>>0<B>>>0);if(!c)break;else{I=I+G|0;q=q+m|0;S=S+Z|0;c=c+-1|0}}}}else{do if(!D){p[r>>3]=+p[e>>3]*+p[C>>3];c=s+-2|0;S=(c|0)==0;if(!S){q=1;do{I=e+(Y(q,G)|0)|0;P=+p[I>>3];I=q+1|0;i=e+(Y(I,G)|0)|0;L=+p[i>>3];i=C+(Y(q,m)|0)|0;O=+p[i>>3];i=C+(Y(I,m)|0)|0;M=-+p[i>>3];i=r+(Y(q,Z)|0)|0;p[i>>3]=P*O-L*M;i=r+(Y(I,Z)|0)|0;p[i>>3]=L*O+P*M;q=q+2|0}while(q>>>0<=c>>>0);if(!(s&1)){ua=s+-1|0;R=247}}else{ua=1;R=247}if((R|0)==247){q=r+(Y(ua,Z)|0)|0;i=C+(Y(ua,m)|0)|0;I=e+(Y(ua,G)|0)|0;p[q>>3]=+p[I>>3]*+p[i>>3]}if(A){i=e+(J<<3)+-8|0;I=C+(J<<3)+-8|0;q=r+(J<<3)+-8|0;p[q>>3]=+p[i>>3]*+p[I>>3];if(!S){E=1;do{N=i+(Y(E,G)|0)|0;M=+p[N>>3];N=E+1|0;y=i+(Y(N,G)|0)|0;P=+p[y>>3];y=I+(Y(E,m)|0)|0;O=+p[y>>3];y=I+(Y(N,m)|0)|0;L=-+p[y>>3];y=q+(Y(E,Z)|0)|0;p[y>>3]=M*O-P*L;y=q+(Y(N,Z)|0)|0;p[y>>3]=P*O+M*L;E=E+2|0}while(E>>>0<=c>>>0);if(!(s&1))va=s+-1|0;else break}else va=1;c=q+(Y(va,Z)|0)|0;E=I+(Y(va,m)|0)|0;S=i+(Y(va,G)|0)|0;p[c>>3]=+p[S>>3]*+p[E>>3]}}while(0);E=v&K;S=s+-1|0;if(!s)break;c=w>>>0<B>>>0;y=E&A;if(!E){if(c){wa=e;xa=C;ya=r;za=S}else break;while(1){E=w;do{L=+p[wa+(E<<3)>>3];N=E+1|0;M=+p[wa+(N<<3)>>3];O=+p[xa+(E<<3)>>3];P=-+p[xa+(N<<3)>>3];p[ya+(E<<3)>>3]=L*O-M*P;p[ya+(N<<3)>>3]=M*O+L*P;E=E+2|0}while(E>>>0<B>>>0);if(!za)break a;else{wa=wa+G|0;xa=xa+m|0;ya=ya+Z|0;za=za+-1|0}}}if(!c)if(y){E=e;i=C;I=r;q=S;while(1){p[I>>3]=+p[E>>3]*+p[i>>3];p[I+(B<<3)>>3]=+p[E+(B<<3)>>3]*+p[i+(B<<3)>>3];if(!q)break a;else{E=E+G|0;i=i+m|0;I=I+Z|0;q=q+-1|0}}}else{q=e;I=C;i=r;E=S;while(1){p[i>>3]=+p[q>>3]*+p[I>>3];if(!E)break a;else{q=q+G|0;I=I+m|0;i=i+Z|0;E=E+-1|0}}}if(y){E=e;i=C;I=r;q=S;while(1){p[I>>3]=+p[E>>3]*+p[i>>3];c=w;do{P=+p[E+(c<<3)>>3];N=c+1|0;L=+p[E+(N<<3)>>3];O=+p[i+(c<<3)>>3];M=-+p[i+(N<<3)>>3];p[I+(c<<3)>>3]=P*O-L*M;p[I+(N<<3)>>3]=L*O+P*M;c=c+2|0}while(c>>>0<B>>>0);p[I+(B<<3)>>3]=+p[E+(B<<3)>>3]*+p[i+(B<<3)>>3];if(!q)break;else{E=E+G|0;i=i+m|0;I=I+Z|0;q=q+-1|0}}}else{q=e;I=C;i=r;E=S;while(1){p[i>>3]=+p[q>>3]*+p[I>>3];y=w;do{M=+p[q+(y<<3)>>3];c=y+1|0;P=+p[q+(c<<3)>>3];O=+p[I+(y<<3)>>3];L=-+p[I+(c<<3)>>3];p[i+(y<<3)>>3]=M*O-P*L;p[i+(c<<3)>>3]=P*O+M*L;y=y+2|0}while(y>>>0<B>>>0);if(!E)break;else{q=q+G|0;I=I+m|0;i=i+Z|0;E=E+-1|0}}}}else if(x){do if(!D){p[e>>3]=+p[e>>3]*+p[C>>3];E=s+-2|0;i=(E|0)==0;if(!i){I=1;do{q=e+(Y(I,Z)|0)|0;L=+p[q>>3];S=I+1|0;y=e+(Y(S,Z)|0)|0;M=+p[y>>3];c=C+(Y(I,m)|0)|0;O=+p[c>>3];c=C+(Y(S,m)|0)|0;P=+p[c>>3];p[q>>3]=L*O-M*P;p[y>>3]=M*O+L*P;I=I+2|0}while(I>>>0<=E>>>0);if(!(s&1)){Aa=s+-1|0;R=165}}else{Aa=1;R=165}if((R|0)==165){I=e+(Y(Aa,Z)|0)|0;y=C+(Y(Aa,m)|0)|0;p[I>>3]=+p[I>>3]*+p[y>>3]}if(A){y=C+(J<<3)+-8|0;I=e+(J<<3)+-8|0;p[I>>3]=+p[I>>3]*+p[y>>3];if(!i){q=1;do{c=I+(Y(q,Z)|0)|0;P=+p[c>>3];S=q+1|0;N=I+(Y(S,Z)|0)|0;L=+p[N>>3];T=y+(Y(q,m)|0)|0;O=+p[T>>3];T=y+(Y(S,m)|0)|0;M=+p[T>>3];p[c>>3]=P*O-L*M;p[N>>3]=L*O+P*M;q=q+2|0}while(q>>>0<=E>>>0);if(!(s&1))Ba=s+-1|0;else break}else Ba=1;E=I+(Y(Ba,Z)|0)|0;q=y+(Y(Ba,m)|0)|0;p[E>>3]=+p[E>>3]*+p[q>>3]}}while(0);x=v&K;q=s+-1|0;if(!s)break;E=w>>>0<B>>>0;i=x&A;if(!x){if(E){Ca=e;Da=C;Ea=q}else break;while(1){x=w;do{N=Ca+(x<<3)|0;M=+p[N>>3];c=x+1|0;T=Ca+(c<<3)|0;P=+p[T>>3];O=+p[Da+(x<<3)>>3];L=+p[Da+(c<<3)>>3];p[N>>3]=M*O-P*L;p[T>>3]=P*O+M*L;x=x+2|0}while(x>>>0<B>>>0);if(!Ea)break a;else{Ca=Ca+Z|0;Da=Da+m|0;Ea=Ea+-1|0}}}if(!E)if(i){x=e;y=C;I=e;T=q;while(1){p[I>>3]=+p[x>>3]*+p[y>>3];p[I+(B<<3)>>3]=+p[x+(B<<3)>>3]*+p[y+(B<<3)>>3];if(!T)break a;else{x=x+G|0;y=y+m|0;I=I+Z|0;T=T+-1|0}}}else{T=e;I=C;y=e;x=q;while(1){p[y>>3]=+p[T>>3]*+p[I>>3];if(!x)break a;else{T=T+G|0;I=I+m|0;y=y+Z|0;x=x+-1|0}}}if(i){x=e;y=C;I=e;T=q;while(1){p[I>>3]=+p[x>>3]*+p[y>>3];E=w;do{N=I+(E<<3)|0;L=+p[N>>3];c=E+1|0;S=I+(c<<3)|0;M=+p[S>>3];O=+p[y+(E<<3)>>3];P=+p[y+(c<<3)>>3];p[N>>3]=L*O-M*P;p[S>>3]=M*O+L*P;E=E+2|0}while(E>>>0<B>>>0);p[I+(B<<3)>>3]=+p[x+(B<<3)>>3]*+p[y+(B<<3)>>3];if(!T)break;else{x=x+G|0;y=y+m|0;I=I+Z|0;T=T+-1|0}}}else{T=e;I=C;y=e;x=q;while(1){p[y>>3]=+p[T>>3]*+p[I>>3];i=w;do{E=y+(i<<3)|0;P=+p[E>>3];S=i+1|0;N=y+(S<<3)|0;L=+p[N>>3];O=+p[I+(i<<3)>>3];M=+p[I+(S<<3)>>3];p[E>>3]=P*O-L*M;p[N>>3]=L*O+P*M;i=i+2|0}while(i>>>0<B>>>0);if(!x)break;else{T=T+G|0;I=I+m|0;y=y+Z|0;x=x+-1|0}}}}else{do if(!D){p[r>>3]=+p[e>>3]*+p[C>>3];x=s+-2|0;y=(x|0)==0;if(!y){I=1;do{T=e+(Y(I,G)|0)|0;M=+p[T>>3];T=I+1|0;q=e+(Y(T,G)|0)|0;P=+p[q>>3];q=C+(Y(I,m)|0)|0;O=+p[q>>3];q=C+(Y(T,m)|0)|0;L=+p[q>>3];q=r+(Y(I,Z)|0)|0;p[q>>3]=M*O-P*L;q=r+(Y(T,Z)|0)|0;p[q>>3]=P*O+M*L;I=I+2|0}while(I>>>0<=x>>>0);if(!(s&1)){Fa=s+-1|0;R=192}}else{Fa=1;R=192}if((R|0)==192){I=r+(Y(Fa,Z)|0)|0;q=C+(Y(Fa,m)|0)|0;T=e+(Y(Fa,G)|0)|0;p[I>>3]=+p[T>>3]*+p[q>>3]}if(A){q=e+(J<<3)+-8|0;T=C+(J<<3)+-8|0;I=r+(J<<3)+-8|0;p[I>>3]=+p[q>>3]*+p[T>>3];if(!y){i=1;do{N=q+(Y(i,G)|0)|0;L=+p[N>>3];N=i+1|0;E=q+(Y(N,G)|0)|0;M=+p[E>>3];E=T+(Y(i,m)|0)|0;O=+p[E>>3];E=T+(Y(N,m)|0)|0;P=+p[E>>3];E=I+(Y(i,Z)|0)|0;p[E>>3]=L*O-M*P;E=I+(Y(N,Z)|0)|0;p[E>>3]=M*O+L*P;i=i+2|0}while(i>>>0<=x>>>0);if(!(s&1))Ga=s+-1|0;else break}else Ga=1;x=I+(Y(Ga,Z)|0)|0;i=T+(Y(Ga,m)|0)|0;y=q+(Y(Ga,G)|0)|0;p[x>>3]=+p[y>>3]*+p[i>>3]}}while(0);D=v&K;i=s+-1|0;if(!s)break;y=w>>>0<B>>>0;x=D&A;if(!D){if(y){Ha=e;Ia=C;Ja=r;Ka=i}else break;while(1){D=w;do{P=+p[Ha+(D<<3)>>3];E=D+1|0;L=+p[Ha+(E<<3)>>3];O=+p[Ia+(D<<3)>>3];M=+p[Ia+(E<<3)>>3];p[Ja+(D<<3)>>3]=P*O-L*M;p[Ja+(E<<3)>>3]=L*O+P*M;D=D+2|0}while(D>>>0<B>>>0);if(!Ka)break a;else{Ha=Ha+G|0;Ia=Ia+m|0;Ja=Ja+Z|0;Ka=Ka+-1|0}}}if(!y)if(x){D=e;q=C;T=r;I=i;while(1){p[T>>3]=+p[D>>3]*+p[q>>3];p[T+(B<<3)>>3]=+p[D+(B<<3)>>3]*+p[q+(B<<3)>>3];if(!I)break a;else{D=D+G|0;q=q+m|0;T=T+Z|0;I=I+-1|0}}}else{I=e;T=C;q=r;D=i;while(1){p[q>>3]=+p[I>>3]*+p[T>>3];if(!D)break a;else{I=I+G|0;T=T+m|0;q=q+Z|0;D=D+-1|0}}}if(x){D=e;q=C;T=r;I=i;while(1){p[T>>3]=+p[D>>3]*+p[q>>3];y=w;do{M=+p[D+(y<<3)>>3];E=y+1|0;P=+p[D+(E<<3)>>3];O=+p[q+(y<<3)>>3];L=+p[q+(E<<3)>>3];p[T+(y<<3)>>3]=M*O-P*L;p[T+(E<<3)>>3]=P*O+M*L;y=y+2|0}while(y>>>0<B>>>0);p[T+(B<<3)>>3]=+p[D+(B<<3)>>3]*+p[q+(B<<3)>>3];if(!I)break;else{D=D+G|0;q=q+m|0;T=T+Z|0;I=I+-1|0}}}else{I=e;T=C;q=r;D=i;while(1){p[q>>3]=+p[I>>3]*+p[T>>3];x=w;do{L=+p[I+(x<<3)>>3];y=x+1|0;M=+p[I+(y<<3)>>3];O=+p[T+(x<<3)>>3];P=+p[T+(y<<3)>>3];p[q+(x<<3)>>3]=L*O-M*P;p[q+(y<<3)>>3]=M*O+L*P;x=x+2|0}while(x>>>0<B>>>0);if(!D)break;else{I=I+G|0;T=T+m|0;q=q+Z|0;D=D+-1|0}}}}}while(0);B=l+36|0;w=f[B>>2]|0;if(w|0?(e=w+12|0,w=f[e>>2]|0,f[e>>2]=w+-1,(w|0)==1):0)V$(l);f[B>>2]=0;B=l+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[B>>2]|0)>0){H=f[l+40>>2]|0;w=0;do{f[H+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[B>>2]|0))}B=f[l+44>>2]|0;if((B|0)!=(l+48|0))wL(B);B=k+36|0;l=f[B>>2]|0;if(l|0?(w=l+12|0,l=f[w>>2]|0,f[w>>2]=l+-1,(l|0)==1):0)V$(k);f[B>>2]=0;B=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[B>>2]|0)>0){d=f[F>>2]|0;F=0;do{f[d+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[B>>2]|0))}B=f[k+44>>2]|0;if((B|0)!=(k+48|0))wL(B);B=j+36|0;k=f[B>>2]|0;if(k|0?(F=k+12|0,k=f[F>>2]|0,f[F>>2]=k+-1,(k|0)==1):0)V$(j);f[B>>2]=0;B=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[B>>2]|0)>0){o=f[t>>2]|0;t=0;do{f[o+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[B>>2]|0))}B=f[j+44>>2]|0;if((B|0)==(j+48|0)){u=h;return}wL(B);u=h;return}function c1(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if(a>>>0>2125763999){b=-1;return b|0}else{c=1650;d=0}do{e=c+d>>1;g=(f[39592+(e<<2)>>2]|0)<(a|0);d=g?e+1|0:d;c=g?c:e}while((d|0)<(c|0));b=f[39592+(c<<2)>>2]|0;return b|0}function d1(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+1072|0;j=i+32|0;k=i;if(!h){u=i;return}if(!((a|0)!=0&(c|0)!=0&(d|0)!=0&(e|0)!=0&(g|0)!=0)){l=$Xc(64)|0;f[j>>2]=l;f[j+8>>2]=-2147483584;f[j+4>>2]=60;m=l;n=240086;o=m+60|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+60>>0]=0;vM(-215,j,240147,240159,101)}l=f[d>>2]|0;p=675553809>>>(l<<2&28)&15;q=l&7;l=e+c|0;r=(l<<3)+8+(h<<5)|0;s=j+8|0;f[j>>2]=s;t=j+4|0;f[t>>2]=r;if(r>>>0>1032){v=bYc(r)|0;f[j>>2]=v;w=v}else w=s;v=w+(c<<2)+(e<<2)|0;r=v+(c<<2)+(e<<2)+4|0;x=r+(h<<2)|0;y=x+(h<<2)|0;z=y+(h<<2<<2)|0;A=z+(h<<2)|0;B=0;do{f[w+(B<<2)>>2]=a+(B*56|0);B=B+1|0}while((B|0)!=(c|0));C=0;do{f[w+(C+c<<2)>>2]=d+(C*56|0);C=C+1|0}while((C|0)!=(e|0));f[v+(l<<2)>>2]=0;C=0;a:while(1){B=C<<1;D=f[g+(B<<2)>>2]|0;E=f[g+((B|1)<<2)>>2]|0;if((D|0)>-1){B=D;D=0;while(1){F=a+(D*56|0)|0;G=f[F>>2]|0;H=G>>>3&511;if((B|0)<=(H|0))break;I=D+1|0;if(I>>>0<c>>>0){B=B+-1-H|0;D=I}else{J=21;break a}}if((G&7|0)!=(q|0)){J=21;break}I=C<<2;f[y+(I<<2)>>2]=D;H=Y(B,p)|0;f[y+((I|1)<<2)>>2]=H;K=((f[F>>2]|0)>>>3&511)+1|0}else{H=C<<2;f[y+(H<<2)>>2]=l;f[y+((H|1)<<2)>>2]=0;K=0}f[z+(C<<2)>>2]=K;H=E;I=0;while(1){L=d+(I*56|0)|0;M=f[L>>2]|0;N=M>>>3&511;if((H|0)<=(N|0))break;O=I+1|0;if(O>>>0<e>>>0){H=H+-1-N|0;I=O}else{J=22;break a}}if(!((H|0)>-1&(M&7|0)==(q|0))){J=22;break}E=C<<2;f[y+((E|2)<<2)>>2]=I+c;B=Y(H,p)|0;f[y+((E|3)<<2)>>2]=B;f[A+(C<<2)>>2]=((f[L>>2]|0)>>>3&511)+1;C=C+1|0;if(C>>>0>=h>>>0){J=23;break}}if((J|0)==21){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;C=$Xc(48)|0;f[k>>2]=C;f[k+8>>2]=-2147483600;f[k+4>>2]=36;m=C;n=240229;o=m+36|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[C+36>>0]=0;vM(-215,k,240147,240159,128)}else if((J|0)==22){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;C=$Xc(48)|0;f[k>>2]=C;f[k+8>>2]=-2147483600;f[k+4>>2]=47;m=C;n=240266;o=m+47|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[C+47>>0]=0;vM(-215,k,240147,240159,141)}else if((J|0)==23){BL(k,w,v,l);l=f[k+20>>2]|0;w=((p+1023|0)>>>0)/(p>>>0)|0;J=(w|0)<(l|0)?w:l;w=f[46196+(q<<2)>>2]|0;q=k+16|0;C=(l|0)>0;n=Y(J,p)|0;p=0;while(1){if(p>>>0<(f[q>>2]|0)>>>0)P=0;else break;do{m=P<<2;f[r+(P<<2)>>2]=(f[v+(f[y+(m<<2)>>2]<<2)>>2]|0)+(f[y+((m|1)<<2)>>2]|0);f[x+(P<<2)>>2]=(f[v+(f[y+((m|2)<<2)>>2]<<2)>>2]|0)+(f[y+((m|3)<<2)>>2]|0);P=P+1|0}while((P|0)!=(h|0));b:do if(C){H=0;do{I=l-H|0;Fh[w&255](r,z,x,A,(J|0)<(I|0)?J:I,h);H=H+J|0;I=(H|0)<(l|0);if(I)Q=0;else break b;do{m=Y(n,f[z+(Q<<2)>>2]|0)|0;o=r+(Q<<2)|0;f[o>>2]=(f[o>>2]|0)+m;m=Y(n,f[A+(Q<<2)>>2]|0)|0;o=x+(Q<<2)|0;f[o>>2]=(f[o>>2]|0)+m;Q=Q+1|0}while((Q|0)!=(h|0))}while(I)}while(0);CL(k)|0;p=p+1|0}p=f[j>>2]|0;if((p|0)!=(s|0)){if(p|0)dYc(p);f[j>>2]=s;f[t>>2]=1032}u=i;return}}function e1(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=b[k>>0]|0;b[f[d+(j<<2)>>2]>>0]=l;j=j+1|0}while((j|0)!=(h|0));return}j=g&-2;if((j|0)<(g|0))m=0;else{g=0;do{l=f[a+(g<<2)>>2]|0;k=f[d+(g<<2)>>2]|0;n=f[c+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!l){p=o<<1;q=k;r=0;while(1){b[q+o>>0]=0;b[q>>0]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+p|0}}else{p=n<<1;q=o<<1;r=l;s=k;t=0;while(1){u=b[r+n>>0]|0;b[s>>0]=b[r>>0]|0;b[s+o>>0]=u;t=t+2|0;if((t|0)>(i|0))break;else{r=r+p|0;s=s+q|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;q=f[d+(m<<2)>>2]|0;s=f[c+(m<<2)>>2]|0;p=f[e+(m<<2)>>2]|0;if(!g){r=p<<1;t=q;o=0;while(1){b[t+p>>0]=0;b[t>>0]=0;o=o+2|0;if((o|0)>(i|0))break;else t=t+r|0}r=q+(Y(p,j)|0)|0;b[r>>0]=0}else{r=s<<1;t=p<<1;o=Y(s,j)|0;n=g;k=q;l=0;while(1){u=b[n+s>>0]|0;b[k>>0]=b[n>>0]|0;b[k+p>>0]=u;l=l+2|0;if((l|0)>(i|0))break;else{n=n+r|0;k=k+t|0}}t=q+(Y(p,j)|0)|0;b[t>>0]=b[g+o>>0]|0}m=m+1|0}while((m|0)!=(h|0));return}function f1(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=d[k>>1]|0;d[f[c+(j<<2)>>2]>>1]=l;j=j+1|0}while((j|0)!=(h|0));return}j=i>>>1;l=(j<<2)+4|0;if(((j<<1)+2|0)<(g|0))m=0;else{g=0;do{j=f[a+(g<<2)>>2]|0;k=f[c+(g<<2)>>2]|0;n=f[b+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!j){p=o<<1;q=k;r=0;while(1){d[q+(o<<1)>>1]=0;d[q>>1]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+(p<<1)|0}}else{p=n<<1;q=o<<1;r=j;s=k;t=0;while(1){u=d[r+(n<<1)>>1]|0;d[s>>1]=d[r>>1]|0;d[s+(o<<1)>>1]=u;t=t+2|0;if((t|0)>(i|0))break;else{r=r+(p<<1)|0;s=s+(q<<1)|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;q=f[c+(m<<2)>>2]|0;s=f[b+(m<<2)>>2]|0;p=f[e+(m<<2)>>2]|0;if(!g){r=p<<1;t=Y(p,l)|0;o=q;n=0;while(1){d[o+(p<<1)>>1]=0;d[o>>1]=0;n=n+2|0;if((n|0)>(i|0))break;else o=o+(r<<1)|0}d[q+t>>1]=0}else{r=s<<1;o=p<<1;n=Y(s,l)|0;k=Y(p,l)|0;j=g;u=q;v=0;while(1){w=d[j+(s<<1)>>1]|0;d[u>>1]=d[j>>1]|0;d[u+(p<<1)>>1]=w;v=v+2|0;if((v|0)>(i|0))break;else{j=j+(r<<1)|0;u=u+(o<<1)|0}}d[q+k>>1]=d[g+n>>1]|0}m=m+1|0}while((m|0)!=(h|0));return}function g1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j)k=0;else k=f[j>>2]|0;f[f[c+(i<<2)>>2]>>2]=k;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;k=(i<<3)+8|0;if(((i<<1)+2|0)<(e|0))l=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;j=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;n=f[d+(e<<2)>>2]|0;if(!i){o=n<<1;p=j;q=0;while(1){f[p+(n<<2)>>2]=0;f[p>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<2)|0}}else{o=m<<1;p=n<<1;q=i;r=j;s=0;while(1){t=f[q+(m<<2)>>2]|0;f[r>>2]=f[q>>2];f[r+(n<<2)>>2]=t;s=s+2|0;if((s|0)>(h|0))break;else{q=q+(o<<2)|0;r=r+(p<<2)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(l<<2)>>2]|0;p=f[c+(l<<2)>>2]|0;r=f[b+(l<<2)>>2]|0;o=f[d+(l<<2)>>2]|0;if(!e){q=o<<1;s=Y(o,k)|0;n=p;m=0;while(1){f[n+(o<<2)>>2]=0;f[n>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else n=n+(q<<2)|0}f[p+s>>2]=0}else{q=r<<1;n=o<<1;m=Y(r,k)|0;j=Y(o,k)|0;i=e;t=p;u=0;while(1){v=f[i+(r<<2)>>2]|0;f[t>>2]=f[i>>2];f[t+(o<<2)>>2]=v;u=u+2|0;if((u|0)>(h|0))break;else{i=i+(q<<2)|0;t=t+(n<<2)|0}}f[p+j>>2]=f[e+m>>2]}l=l+1|0}while((l|0)!=(g|0));return}function h1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j){k=0;l=0}else{m=j;k=f[m>>2]|0;l=f[m+4>>2]|0}m=f[c+(i<<2)>>2]|0;f[m>>2]=k;f[m+4>>2]=l;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;l=(i<<4)+16|0;if(((i<<1)+2|0)<(e|0))n=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;k=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;j=f[d+(e<<2)>>2]|0;if(!i){o=j<<1;p=k;q=0;while(1){r=p+(j<<3)|0;f[r>>2]=0;f[r+4>>2]=0;r=p;f[r>>2]=0;f[r+4>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<3)|0}}else{o=m<<1;p=j<<1;q=i;r=k;s=0;while(1){t=q;u=f[t+4>>2]|0;v=q+(m<<3)|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=r;f[v>>2]=f[t>>2];f[v+4>>2]=u;u=r+(j<<3)|0;f[u>>2]=w;f[u+4>>2]=x;s=s+2|0;if((s|0)>(h|0))break;else{q=q+(o<<3)|0;r=r+(p<<3)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(n<<2)>>2]|0;p=f[c+(n<<2)>>2]|0;r=f[b+(n<<2)>>2]|0;o=f[d+(n<<2)>>2]|0;if(!e){q=o<<1;s=Y(o,l)|0;j=p;m=0;while(1){k=j+(o<<3)|0;f[k>>2]=0;f[k+4>>2]=0;k=j;f[k>>2]=0;f[k+4>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else j=j+(q<<3)|0}q=p+s|0;f[q>>2]=0;f[q+4>>2]=0}else{q=r<<1;j=o<<1;m=Y(r,l)|0;k=Y(o,l)|0;i=e;x=p;u=0;while(1){w=i;v=f[w+4>>2]|0;t=i+(r<<3)|0;y=f[t>>2]|0;z=f[t+4>>2]|0;t=x;f[t>>2]=f[w>>2];f[t+4>>2]=v;v=x+(o<<3)|0;f[v>>2]=y;f[v+4>>2]=z;u=u+2|0;if((u|0)>(h|0))break;else{i=i+(q<<3)|0;x=x+(j<<3)|0}}j=e+m|0;x=f[j+4>>2]|0;q=p+k|0;f[q>>2]=f[j>>2];f[q+4>>2]=x}n=n+1|0}while((n|0)!=(g|0));return}function i1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=0;do{f[a+8+(d*56|0)>>2]=1124007936;e=a+8+(d*56|0)+8|0;g=a+8+(d*56|0)+40|0;h=a+8+(d*56|0)+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;j=a+8+(d*56|0)+48|0;f[a+8+(d*56|0)+44>>2]=j;f[j>>2]=0;f[a+8+(d*56|0)+52>>2]=0;d=d+1|0}while((d|0)!=26);f[a>>2]=c;c=a+4|0;f[c>>2]=26;if(b>>>0<=26){f[c>>2]=b;return}j1(a);f[c>>2]=b;c=b*56|0;d=bYc(b>>>0>76695844|c>>>0>4294967291?-1:c+4|0)|0;f[d>>2]=b;c=d+4|0;d=c+(b*56|0)|0;b=c;do{f[b>>2]=1124007936;j=b+8|0;k=b+40|0;h=b+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[k>>2]=j;e=b+48|0;f[b+44>>2]=e;f[e>>2]=0;f[b+52>>2]=0;b=b+56|0}while((b|0)!=(d|0));f[a>>2]=c;return}function j1(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;c=a+8|0;if((b|0)==(c|0))return;if(b|0){d=b+-4|0;e=f[d>>2]|0;if(e|0){g=b+(e*56|0)|0;do{e=g;g=g+-56|0;h=e+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)V$(g);f[h>>2]=0;h=e+-40|0;i=e+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[e+-16>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[e+-12>>2]|0;if((i|0)!=(e+-8|0))wL(i)}while((g|0)!=(b|0))}dYc(d)}f[a>>2]=c;f[a+4>>2]=26;return}function k1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+1520|0;g=e+56|0;h=e;i=d+4|0;if((f[d>>2]|0)==(f[i>>2]|0)){u=e;return}if(((eS(a)|0)!=327680?(eS(a)|0)!=983040:0)?(eS(a)|0)!=262144:0)j=(eS(a)|0)!=720896;else j=0;if(((eS(c)|0)!=327680?(eS(c)|0)!=983040:0)?(eS(c)|0)!=262144:0)k=(eS(c)|0)!=720896;else k=0;if(j)l=1;else l=pS(a,-1)|0;if(k)m=1;else m=pS(c,-1)|0;if(!((m|0)>0&((l|0)>0?((f[i>>2]|0)-(f[d>>2]|0)&4|0)==0:0))){n=$Xc(48)|0;f[g>>2]=n;f[g+8>>2]=-2147483600;f[g+4>>2]=44;o=n;p=240314;q=o+44|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+44>>0]=0;vM(-215,g,240147,240159,328)}i1(g,m+l|0);n=f[g>>2]|0;p=a+4|0;r=h+4|0;s=h+8|0;t=h+12|0;v=h+16|0;w=h+20|0;x=h+24|0;y=h+28|0;z=h+32|0;A=h+36|0;B=h+40|0;C=h+48|0;D=h+44|0;E=h+52|0;F=h+44|0;G=0;do{H=j?-1:G;do if((H|0)<0&(eS(a)|0)==65536){I=f[p>>2]|0;f[h>>2]=f[I>>2];J=I+4|0;f[r>>2]=f[J>>2];f[s>>2]=f[I+8>>2];f[t>>2]=f[I+12>>2];f[v>>2]=f[I+16>>2];f[w>>2]=f[I+20>>2];f[x>>2]=f[I+24>>2];f[y>>2]=f[I+28>>2];f[z>>2]=f[I+32>>2];K=f[I+36>>2]|0;f[A>>2]=K;f[B>>2]=s;f[D>>2]=C;f[C>>2]=0;f[E>>2]=0;if(K|0){L=K+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[J>>2]|0)<3){J=f[I+44>>2]|0;L=f[D>>2]|0;f[L>>2]=f[J>>2];f[L+4>>2]=f[J+4>>2];break}else{f[r>>2]=0;U$(h,I);break}}else bS(h,a,H);while(0);H=n+(G*56|0)|0;if((H|0)==(h|0)){I=f[A>>2]|0;if(I|0?(J=I+12|0,I=f[J>>2]|0,f[J>>2]=I+-1,(I|0)==1):0)V$(h)}else{I=n+(G*56|0)+36|0;J=f[I>>2]|0;if(J|0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0)V$(H);f[I>>2]=0;J=n+(G*56|0)+16|0;L=n+(G*56|0)+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[L>>2]|0)>0){K=f[n+(G*56|0)+40>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[L>>2]|0))}f[H>>2]=f[h>>2];f[L>>2]=f[r>>2];M=n+(G*56|0)+8|0;f[M>>2]=f[s>>2];f[n+(G*56|0)+12>>2]=f[t>>2];f[J>>2]=f[v>>2];f[n+(G*56|0)+20>>2]=f[w>>2];f[n+(G*56|0)+24>>2]=f[x>>2];f[n+(G*56|0)+28>>2]=f[y>>2];f[n+(G*56|0)+32>>2]=f[z>>2];f[I>>2]=f[A>>2];K=n+(G*56|0)+44|0;N=f[K>>2]|0;O=n+(G*56|0)+48|0;if((N|0)==(O|0))P=N;else{wL(N);f[K>>2]=O;f[n+(G*56|0)+40>>2]=M;P=O}if((f[r>>2]|0)<3){O=f[F>>2]|0;f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2]}else{f[K>>2]=f[F>>2];f[n+(G*56|0)+40>>2]=f[B>>2];f[F>>2]=C;f[B>>2]=s}f[h>>2]=1124007936;o=r;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0))}f[A>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[r>>2]|0)>0){I=f[B>>2]|0;J=0;do{f[I+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[r>>2]|0))}J=f[D>>2]|0;if((J|0)!=(C|0))wL(J);G=G+1|0}while((G|0)<(l|0));G=c+4|0;C=h+4|0;D=h+8|0;r=h+12|0;B=h+16|0;v=h+20|0;A=h+24|0;s=h+28|0;F=h+32|0;P=h+36|0;z=h+40|0;y=h+48|0;x=h+44|0;w=h+52|0;t=h+44|0;a=0;do{E=k?-1:a;do if((E|0)<0&(eS(c)|0)==65536){p=f[G>>2]|0;f[h>>2]=f[p>>2];j=p+4|0;f[C>>2]=f[j>>2];f[D>>2]=f[p+8>>2];f[r>>2]=f[p+12>>2];f[B>>2]=f[p+16>>2];f[v>>2]=f[p+20>>2];f[A>>2]=f[p+24>>2];f[s>>2]=f[p+28>>2];f[F>>2]=f[p+32>>2];J=f[p+36>>2]|0;f[P>>2]=J;f[z>>2]=D;f[x>>2]=y;f[y>>2]=0;f[w>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[j>>2]|0)<3){j=f[p+44>>2]|0;I=f[x>>2]|0;f[I>>2]=f[j>>2];f[I+4>>2]=f[j+4>>2];break}else{f[C>>2]=0;U$(h,p);break}}else bS(h,c,E);while(0);E=a+l|0;p=n+(E*56|0)|0;if((p|0)==(h|0)){j=f[P>>2]|0;if(j|0?(I=j+12|0,j=f[I>>2]|0,f[I>>2]=j+-1,(j|0)==1):0)V$(h)}else{j=n+(E*56|0)+36|0;I=f[j>>2]|0;if(I|0?(J=I+12|0,I=f[J>>2]|0,f[J>>2]=I+-1,(I|0)==1):0)V$(p);f[j>>2]=0;I=n+(E*56|0)+16|0;J=n+(E*56|0)+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[J>>2]|0)>0){L=f[n+(E*56|0)+40>>2]|0;H=0;do{f[L+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[J>>2]|0))}f[p>>2]=f[h>>2];f[J>>2]=f[C>>2];H=n+(E*56|0)+8|0;f[H>>2]=f[D>>2];f[n+(E*56|0)+12>>2]=f[r>>2];f[I>>2]=f[B>>2];f[n+(E*56|0)+20>>2]=f[v>>2];f[n+(E*56|0)+24>>2]=f[A>>2];f[n+(E*56|0)+28>>2]=f[s>>2];f[n+(E*56|0)+32>>2]=f[F>>2];f[j>>2]=f[P>>2];L=n+(E*56|0)+44|0;K=f[L>>2]|0;O=n+(E*56|0)+48|0;if((K|0)==(O|0))Q=K;else{wL(K);f[L>>2]=O;f[n+(E*56|0)+40>>2]=H;Q=O}if((f[C>>2]|0)<3){O=f[t>>2]|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2]}else{f[L>>2]=f[t>>2];f[n+(E*56|0)+40>>2]=f[z>>2];f[t>>2]=y;f[z>>2]=D}f[h>>2]=1124007936;o=C;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0))}f[P>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){E=f[z>>2]|0;j=0;do{f[E+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[C>>2]|0))}j=f[x>>2]|0;if((j|0)!=(y|0))wL(j);a=a+1|0}while((a|0)<(m|0));a=f[d>>2]|0;d1(n,l,n+(l*56|0)|0,m,a,(f[i>>2]|0)-a>>2>>>1);j1(g);a=g+8|0;i=g+1464|0;do{g=i;i=i+-56|0;m=g+-20|0;l=f[m>>2]|0;if(l|0?(n=l+12|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)V$(i);f[m>>2]=0;m=g+-40|0;l=g+-52|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[g+-16>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[g+-12>>2]|0;if((l|0)!=(g+-8|0))wL(l)}while((i|0)!=(a|0));u=e;return}function l1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+128|0;g=e+112|0;h=e+56|0;i=e;j=dS(a,-1)|0;k=j&7;if((d|0)<=-1){l=$Xc(32)|0;f[g>>2]=l;m=g+8|0;f[m>>2]=-2147483616;n=g+4|0;f[n>>2]=20;o=l;p=240359;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));r=l+20|0;b[r>>0]=0;vM(-215,g,240380,240159,425)}if((j>>>3&511|0)<(d|0)){l=$Xc(32)|0;f[g>>2]=l;m=g+8|0;f[m>>2]=-2147483616;n=g+4|0;f[n>>2]=20;o=l;p=240359;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));r=l+20|0;b[r>>0]=0;vM(-215,g,240380,240159,425)}f[g>>2]=d;f[g+4>>2]=0;do if((eS(a)|0)==65536){d=f[a+4>>2]|0;f[h>>2]=f[d>>2];r=h+4|0;l=d+4|0;f[r>>2]=f[l>>2];p=h+8|0;f[p>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];f[h+16>>2]=f[d+16>>2];f[h+20>>2]=f[d+20>>2];f[h+24>>2]=f[d+24>>2];f[h+28>>2]=f[d+28>>2];f[h+32>>2]=f[d+32>>2];o=f[d+36>>2]|0;f[h+36>>2]=o;q=h+40|0;f[q>>2]=p;p=h+48|0;n=h+44|0;f[n>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(o|0){p=o+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;p=f[n>>2]|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];s=q;t=r;break}else{f[r>>2]=0;U$(h,d);s=q;t=r;break}}else{bS(h,a,-1);s=h+40|0;t=h+4|0}while(0);xS(c,f[t>>2]|0,f[s>>2]|0,k,-1,0,0);do if((eS(c)|0)==65536){k=f[c+4>>2]|0;f[i>>2]=f[k>>2];a=i+4|0;r=k+4|0;f[a>>2]=f[r>>2];q=i+8|0;f[q>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[i+16>>2]=f[k+16>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[i+32>>2]=f[k+32>>2];d=f[k+36>>2]|0;f[i+36>>2]=d;f[i+40>>2]=q;q=i+48|0;l=i+44|0;f[l>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(d|0){q=d+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[r>>2]|0)<3){r=f[k+44>>2]|0;q=f[l>>2]|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];break}else{f[a>>2]=0;U$(i,k);break}}else bS(i,c,-1);while(0);d1(h,1,i,1,g,1);g=i+36|0;c=f[g>>2]|0;if(c|0?(k=c+12|0,c=f[k>>2]|0,f[k>>2]=c+-1,(c|0)==1):0)V$(i);f[g>>2]=0;g=i+16|0;c=i+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[c>>2]|0)>0){g=f[i+40>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)!=(i+48|0))wL(c);c=h+36|0;i=f[c>>2]|0;if(i|0?(k=i+12|0,i=f[k>>2]|0,f[k>>2]=i+-1,(i|0)==1):0)V$(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[t>>2]|0)>0){c=f[s>>2]|0;s=0;do{f[c+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[t>>2]|0))}t=f[h+44>>2]|0;if((t|0)==(h+48|0)){u=e;return}wL(t);u=e;return}function m1(){var a=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;a=$Xc(48)|0;f[c>>2]=a;f[c+8>>2]=-2147483600;f[c+4>>2]=44;d=a;e=242606;g=d+44|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));b[a+44>>0]=0;vM(-216,c,242651,242665,107)}function n1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;m1()}function o1(a){a=a|0;return}function p1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+-4|0;if((d|0)<4){f=0;g=0}else{i=0;j=0;do{k=i|1;l=i|2;m=i|3;j=(h[226874+((b[c+i>>0]^b[a+i>>0])&255)>>0]|0)+j+(h[226874+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+(h[226874+((b[c+l>>0]^b[a+l>>0])&255)>>0]|0)+(h[226874+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)|0;i=i+4|0}while((i|0)<=(e|0));f=j;g=d&-4}if((g|0)<(d|0)){n=g;o=f}else{p=f;return p|0}while(1){f=(h[226874+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+o|0;n=n+1|0;if((n|0)==(d|0)){p=f;break}else o=f}return p|0}function q1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(h[226874+(h[a+f>>0]|0)>>0]|0)+g+(h[226874+(h[a+(f|1)>>0]|0)>>0]|0)+(h[226874+(h[a+(f|2)>>0]|0)>>0]|0)+(h[226874+(h[a+(f|3)>>0]|0)>>0]|0)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){i=e;j=d}else{k=d;return k|0}while(1){d=(h[226874+(h[a+i>>0]|0)>>0]|0)+j|0;i=i+1|0;if((i|0)==(b|0)){k=d;break}else j=d}return k|0}function r1(a,b,c){a=a|0;b=b|0;c=c|0;return p1(a,b,c)|0}function s1(){var a=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;a=$Xc(48)|0;f[c>>2]=a;f[c+8>>2]=-2147483600;f[c+4>>2]=44;d=a;e=242606;g=d+44|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));b[a+44>>0]=0;vM(-216,c,242651,242665,107)}function t1(){s1();return 0}function u1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g+16|0;i=g;j=f[a+4>>2]|0;if((j|0)<3)k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{l=f[a+40>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(j|0)){k=o;break}else n=o}}n=c>>>3&511;j=n+1|0;m=675553809>>>(c<<2&28)&15;l=Y(m,j)|0;o=YW(f[a>>2]&7,c)|0;c=f[a+16>>2]|0;a=(k|0)<=(n|0);f[h>>2]=a?k:j;f[h+4>>2]=1;wi[o&255](c,1,0,1,d,1,h,0);if(a){if((k|0)!=1){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=8;k=i;f[k>>2]=544105331;f[k+4>>2]=824196413;b[i+8>>0]=0;vM(-215,i,240395,240418,68)}if(m>>>0<l>>>0){i=m;do{b[d+i>>0]=b[d+(i-m)>>0]|0;i=i+1|0}while((i|0)!=(l|0))}}i=Y(l,e)|0;if(l>>>0<i>>>0)p=l;else{u=g;return}do{b[d+p>>0]=b[d+(p-l)>>0]|0;p=p+1|0}while((p|0)!=(i|0));u=g;return}function v1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=105;w1(a,b,c,d,g,1,9);u=e;return}function w1(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;j=u;u=u+1440|0;k=j+1376|0;l=j+1368|0;m=j+1352|0;n=j+1360|0;o=j+312|0;q=j+256|0;r=j;s=j+184|0;t=j+128|0;v=j+104|0;w=j+88|0;x=j+56|0;y=j+248|0;z=j+240|0;A=a;B=c;C=eS(a)|0;D=eS(c)|0;E=dS(a,-1)|0;F=E&7;G=(E>>>3&511)+1|0;H=dS(c,-1)|0;I=H&7;J=(H>>>3&511)+1|0;K=oS(a,-1)|0;L=oS(c,-1)|0;M=(K|0)<3;if(M)cS(l,a,-1);else{f[l>>2]=0;f[l+4>>2]=0}K=(L|0)<3;if(K)cS(m,c,-1);else{f[m>>2]=0;f[m+4>>2]=0}L=sS(e)|0;do if(((C|0)==(D|0)&(M&K)?(N=f[l>>2]|0,O=f[l+4>>2]|0,(N|0)==(f[m>>2]|0)?(O|0)==(f[m+4>>2]|0):0):0)?!((E|0)!=(H|0)|L^1):0){f[n>>2]=N;f[n+4>>2]=O;wS(d,n,E,-1,0,0);if(h){P=g;Q=Y(675553809>>>(E<<2&28)&15,G)|0}else{P=g+(F<<2)|0;Q=G}O=f[P>>2]|0;do if((eS(a)|0)==65536){N=f[a+4>>2]|0;f[k>>2]=f[N>>2];R=k+4|0;S=N+4|0;f[R>>2]=f[S>>2];T=k+8|0;f[T>>2]=f[N+8>>2];f[k+12>>2]=f[N+12>>2];f[k+16>>2]=f[N+16>>2];f[k+20>>2]=f[N+20>>2];f[k+24>>2]=f[N+24>>2];f[k+28>>2]=f[N+28>>2];f[k+32>>2]=f[N+32>>2];U=f[N+36>>2]|0;f[k+36>>2]=U;f[k+40>>2]=T;T=k+48|0;V=k+44|0;f[V>>2]=T;f[T>>2]=0;f[k+52>>2]=0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[N+44>>2]|0;T=f[V>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];break}else{f[R>>2]=0;U$(k,N);break}}else bS(k,a,-1);while(0);do if((eS(c)|0)==65536){N=f[c+4>>2]|0;f[o>>2]=f[N>>2];R=o+4|0;S=N+4|0;f[R>>2]=f[S>>2];T=o+8|0;f[T>>2]=f[N+8>>2];f[o+12>>2]=f[N+12>>2];f[o+16>>2]=f[N+16>>2];f[o+20>>2]=f[N+20>>2];f[o+24>>2]=f[N+24>>2];f[o+28>>2]=f[N+28>>2];f[o+32>>2]=f[N+32>>2];V=f[N+36>>2]|0;f[o+36>>2]=V;f[o+40>>2]=T;T=o+48|0;U=o+44|0;f[U>>2]=T;f[T>>2]=0;f[o+52>>2]=0;if(V|0){T=V+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[N+44>>2]|0;T=f[U>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];break}else{f[R>>2]=0;U$(o,N);break}}else bS(o,c,-1);while(0);do if((eS(d)|0)==65536){N=f[d+4>>2]|0;f[q>>2]=f[N>>2];R=q+4|0;S=N+4|0;f[R>>2]=f[S>>2];T=q+8|0;f[T>>2]=f[N+8>>2];f[q+12>>2]=f[N+12>>2];f[q+16>>2]=f[N+16>>2];f[q+20>>2]=f[N+20>>2];f[q+24>>2]=f[N+24>>2];f[q+28>>2]=f[N+28>>2];f[q+32>>2]=f[N+32>>2];U=f[N+36>>2]|0;f[q+36>>2]=U;f[q+40>>2]=T;T=q+48|0;V=q+44|0;f[V>>2]=T;f[T>>2]=0;f[q+52>>2]=0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[N+44>>2]|0;T=f[V>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];break}else{f[R>>2]=0;U$(q,N);break}}else bS(q,d,-1);while(0);n0(r,k,o,q,1);N=Y(f[r>>2]|0,Q)|0;if(N>>>0>=2147483647){R=q+36|0;S=f[R>>2]|0;if(S|0?(T=S+12|0,S=f[T>>2]|0,f[T>>2]=S+-1,(S|0)==1):0)V$(q);f[R>>2]=0;R=q+16|0;S=q+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[S>>2]|0)>0){R=f[q+40>>2]|0;T=0;do{f[R+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[S>>2]|0))}S=f[q+44>>2]|0;if((S|0)!=(q+48|0))wL(S);S=o+36|0;T=f[S>>2]|0;if(T|0?(R=T+12|0,T=f[R>>2]|0,f[R>>2]=T+-1,(T|0)==1):0)V$(o);f[S>>2]=0;S=o+16|0;T=o+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[T>>2]|0)>0){S=f[o+40>>2]|0;R=0;do{f[S+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[T>>2]|0))}T=f[o+44>>2]|0;if((T|0)!=(o+48|0))wL(T);T=k+36|0;R=f[T>>2]|0;do if(R|0){S=R+12|0;V=f[S>>2]|0;f[S>>2]=V+-1;if((V|0)!=1)break;V$(k)}while(0);f[T>>2]=0;R=k+16|0;V=k+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[V>>2]|0)>0){R=f[k+40>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[V>>2]|0))}V=f[k+44>>2]|0;if((V|0)!=(k+48|0))wL(V);W=Q;break}f[r>>2]=N;V=k+16|0;S=k+44|0;R=k+48|0;T=o+16|0;U=o+44|0;X=o+48|0;Z=q+16|0;_=q+44|0;$=q+48|0;Li[O&127](f[V>>2]|0,f[R>>2]|0,f[T>>2]|0,f[X>>2]|0,f[Z>>2]|0,f[$>>2]|0,N,f[r+4>>2]|0,0);aa=q+36|0;ba=f[aa>>2]|0;if(ba|0?(ca=ba+12|0,ba=f[ca>>2]|0,f[ca>>2]=ba+-1,(ba|0)==1):0)V$(q);f[aa>>2]=0;aa=q+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[aa>>2]|0)>0){Z=f[q+40>>2]|0;ba=0;do{f[Z+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[aa>>2]|0))}aa=f[_>>2]|0;if((aa|0)!=($|0))wL(aa);aa=o+36|0;ba=f[aa>>2]|0;if(ba|0?(Z=ba+12|0,ba=f[Z>>2]|0,f[Z>>2]=ba+-1,(ba|0)==1):0)V$(o);f[aa>>2]=0;aa=o+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[aa>>2]|0)>0){ba=f[o+40>>2]|0;Z=0;do{f[ba+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[aa>>2]|0))}aa=f[U>>2]|0;if((aa|0)!=(X|0))wL(aa);aa=k+36|0;Z=f[aa>>2]|0;if(Z|0?(ba=Z+12|0,Z=f[ba>>2]|0,f[ba>>2]=Z+-1,(Z|0)==1):0)V$(k);f[aa>>2]=0;aa=k+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[aa>>2]|0)>0){Z=f[k+40>>2]|0;ba=0;do{f[Z+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[aa>>2]|0))}aa=f[S>>2]|0;if((aa|0)!=(R|0))wL(aa);u=j;return}else W=G;while(0);a:do if((i|0)==12){da=1;ea=F;fa=E;ga=W;ha=B;ia=A}else{Q=(C|0)==131072;P=(D|0)==131072;if(((P&1)+(Q&1)|0)!=1?(E|0)==(H|0)&(nS(a,c)|0):0){if(nS(a,c)|0){da=0;ea=F;fa=E;ga=W;ha=B;ia=A;break}n=$Xc(48)|0;f[k>>2]=n;f[k+8>>2]=-2147483600;f[k+4>>2]=41;ja=n;ka=240627;la=ja+41|0;do{b[ja>>0]=b[ka>>0]|0;ja=ja+1|0;ka=ka+1|0}while((ja|0)<(la|0));b[n+41>>0]=0;vM(-215,k,240617,240418,234)}b:do if((oS(a,-1)|0)<=2?tS(a,-1)|0:0){cS(k,a,-1);R=f[k>>2]|0;S=(R|0)==1;if(S){if(!((C|0)!=131072&P)){ma=f[k+4>>2]|0;na=70}}else if(!((C|0)!=131072&P|(f[k+4>>2]|0)!=1)){ma=1;na=70}do if((na|0)==70){K=(ma|0)==1;if(!((R|0)==(J|0)&K|S&(K|(ma|0)==(J|0)))){if(!(S&(ma|0)==4))break;if(!(J>>>0<5&(dS(a,-1)|0)==6))break b}K=f[l>>2]|0;M=l+4|0;aa=f[M>>2]|0;f[l>>2]=f[m>>2];ba=m+4|0;f[M>>2]=f[ba>>2];f[m>>2]=K;f[ba>>2]=aa;da=1;ea=I;fa=H;ga=J;ha=A;ia=B;break a}while(0)}while(0);if((oS(c,-1)|0)>2){oa=$Xc(144)|0;f[k>>2]=oa;pa=k+8|0;f[pa>>2]=-2147483504;qa=k+4|0;f[qa>>2]=130;o1c(oa|0,240486,130)|0;ra=oa+130|0;b[ra>>0]=0;vM(-209,k,240617,240418,229)}if(!(tS(c,-1)|0)){oa=$Xc(144)|0;f[k>>2]=oa;pa=k+8|0;f[pa>>2]=-2147483504;qa=k+4|0;f[qa>>2]=130;o1c(oa|0,240486,130)|0;ra=oa+130|0;b[ra>>0]=0;vM(-209,k,240617,240418,229)}cS(k,c,-1);P=f[k>>2]|0;n=(P|0)==1;if(n){if(!(Q&(D|0)!=131072)){sa=f[k+4>>2]|0;na=82}}else if(!(Q&(D|0)!=131072|(f[k+4>>2]|0)!=1)){sa=1;na=82}if((na|0)==82){S=(sa|0)==1;if((P|0)==(G|0)&S|n&(S|(sa|0)==(G|0))){da=1;ea=F;fa=E;ga=W;ha=B;ia=A;break}if(n&(sa|0)==4){if(G>>>0<5&(dS(c,-1)|0)==6){da=1;ea=F;fa=E;ga=W;ha=B;ia=A;break}oa=$Xc(144)|0;f[k>>2]=oa;pa=k+8|0;f[pa>>2]=-2147483504;qa=k+4|0;f[qa>>2]=130;o1c(oa|0,240486,130)|0;ra=oa+130|0;b[ra>>0]=0;vM(-209,k,240617,240418,229)}}oa=$Xc(144)|0;f[k>>2]=oa;pa=k+8|0;f[pa>>2]=-2147483504;qa=k+4|0;f[qa>>2]=130;o1c(oa|0,240486,130)|0;ra=oa+130|0;b[ra>>0]=0;vM(-209,k,240617,240418,229)}while(0);ra=Y(675553809>>>(fa<<2&28)&15,(fa>>>3&511)+1|0)|0;f[k>>2]=ra;oa=((ra+1023|0)>>>0)/(ra>>>0)|0;if(!L){if((dS(e,-1)|0|1|0)!=1){ta=$Xc(64)|0;f[o>>2]=ta;ua=o+8|0;f[ua>>2]=-2147483584;va=o+4|0;f[va>>2]=60;ja=ta;ka=240669;la=ja+60|0;do{b[ja>>0]=b[ka>>0]|0;ja=ja+1|0;ka=ka+1|0}while((ja|0)<(la|0));wa=ta+60|0;b[wa>>0]=0;vM(-215,o,240617,240418,245)}ra=ia;if(!(nS(e,ra)|0)){ta=$Xc(64)|0;f[o>>2]=ta;ua=o+8|0;f[ua>>2]=-2147483584;va=o+4|0;f[va>>2]=60;ja=ta;ka=240669;la=ja+60|0;do{b[ja>>0]=b[ka>>0]|0;ja=ja+1|0;ka=ka+1|0}while((ja|0)<(la|0));wa=ta+60|0;b[wa>>0]=0;vM(-215,o,240617,240418,245)}wa=hR(f[k>>2]|0)|0;if(nS(d,ra)|0){xa=(dS(d,-1)|0)!=(fa|0);ya=wa;za=ra}else{xa=1;ya=wa;za=ra}}else{xa=0;ya=0;za=ia}ia=o+8|0;f[o>>2]=ia;ra=o+4|0;f[ra>>2]=1032;_S(d,za,fa);if(!(L|xa^1)){p[r>>3]=0.0;f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;bT(d,q,s)}do if((eS(za)|0)==65536){xa=f[za+4>>2]|0;f[q>>2]=f[xa>>2];fa=q+4|0;wa=xa+4|0;f[fa>>2]=f[wa>>2];ta=q+8|0;f[ta>>2]=f[xa+8>>2];f[q+12>>2]=f[xa+12>>2];f[q+16>>2]=f[xa+16>>2];f[q+20>>2]=f[xa+20>>2];f[q+24>>2]=f[xa+24>>2];f[q+28>>2]=f[xa+28>>2];f[q+32>>2]=f[xa+32>>2];ka=f[xa+36>>2]|0;f[q+36>>2]=ka;f[q+40>>2]=ta;ta=q+48|0;ja=q+44|0;f[ja>>2]=ta;f[ta>>2]=0;f[q+52>>2]=0;if(ka|0){ta=ka+12|0;f[ta>>2]=(f[ta>>2]|0)+1}if((f[wa>>2]|0)<3){wa=f[xa+44>>2]|0;ta=f[ja>>2]|0;f[ta>>2]=f[wa>>2];f[ta+4>>2]=f[wa+4>>2];break}else{f[fa>>2]=0;U$(q,xa);break}}else bS(q,za,-1);while(0);za=ha;do if((eS(za)|0)==65536){ha=f[za+4>>2]|0;f[r>>2]=f[ha>>2];xa=r+4|0;fa=ha+4|0;f[xa>>2]=f[fa>>2];wa=r+8|0;f[wa>>2]=f[ha+8>>2];f[r+12>>2]=f[ha+12>>2];f[r+16>>2]=f[ha+16>>2];f[r+20>>2]=f[ha+20>>2];f[r+24>>2]=f[ha+24>>2];f[r+28>>2]=f[ha+28>>2];f[r+32>>2]=f[ha+32>>2];ta=f[ha+36>>2]|0;f[r+36>>2]=ta;f[r+40>>2]=wa;wa=r+48|0;ja=r+44|0;f[ja>>2]=wa;f[wa>>2]=0;f[r+52>>2]=0;if(ta|0){wa=ta+12|0;f[wa>>2]=(f[wa>>2]|0)+1}if((f[fa>>2]|0)<3){fa=f[ha+44>>2]|0;wa=f[ja>>2]|0;f[wa>>2]=f[fa>>2];f[wa+4>>2]=f[fa+4>>2];break}else{f[xa>>2]=0;U$(r,ha);break}}else bS(r,za,-1);while(0);do if((eS(d)|0)==65536){za=f[d+4>>2]|0;f[s>>2]=f[za>>2];ha=s+4|0;xa=za+4|0;f[ha>>2]=f[xa>>2];fa=s+8|0;f[fa>>2]=f[za+8>>2];f[s+12>>2]=f[za+12>>2];f[s+16>>2]=f[za+16>>2];f[s+20>>2]=f[za+20>>2];f[s+24>>2]=f[za+24>>2];f[s+28>>2]=f[za+28>>2];f[s+32>>2]=f[za+32>>2];wa=f[za+36>>2]|0;f[s+36>>2]=wa;f[s+40>>2]=fa;fa=s+48|0;ja=s+44|0;f[ja>>2]=fa;f[fa>>2]=0;f[s+52>>2]=0;if(wa|0){fa=wa+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[xa>>2]|0)<3){xa=f[za+44>>2]|0;fa=f[ja>>2]|0;f[fa>>2]=f[xa>>2];f[fa+4>>2]=f[xa+4>>2];break}else{f[ha>>2]=0;U$(s,za);break}}else bS(s,d,-1);while(0);do if((eS(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];za=t+4|0;ha=d+4|0;f[za>>2]=f[ha>>2];xa=t+8|0;f[xa>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];fa=f[d+36>>2]|0;f[t+36>>2]=fa;f[t+40>>2]=xa;xa=t+48|0;ja=t+44|0;f[ja>>2]=xa;f[xa>>2]=0;f[t+52>>2]=0;if(fa|0){xa=fa+12|0;f[xa>>2]=(f[xa>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[d+44>>2]|0;xa=f[ja>>2]|0;f[xa>>2]=f[ha>>2];f[xa+4>>2]=f[ha+4>>2];break}else{f[za>>2]=0;U$(t,d);break}}else bS(t,e,-1);while(0);e=h?f[k>>2]|0:ga;ga=f[(h?g:g+(ea<<2)|0)>>2]|0;if(da){f[v>>2]=q;f[v+4>>2]=s;f[v+8>>2]=t;f[v+12>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;BL(x,v,w,-1);da=f[x+20>>2]|0;ea=oa>>>0<da>>>0?oa:da;g=(Y(Y(f[k>>2]|0,L?1:2)|0,ea)|0)+32|0;if((f[ra>>2]|0)>>>0<g>>>0){h=f[o>>2]|0;if((h|0)!=(ia|0)){if(h|0)dYc(h);f[o>>2]=ia;f[ra>>2]=1032}f[ra>>2]=g;if(g>>>0>1032){h=bYc(g)|0;f[o>>2]=h;Aa=h}else Aa=ia}else{f[ra>>2]=g;Aa=f[o>>2]|0}g=Aa+(Y(f[k>>2]|0,ea)|0)+15&-16;u1(r,f[q>>2]&4095,Aa,ea);h=x+16|0;d=w+4|0;za=w+8|0;ha=z+4|0;c:do if(!da){xa=0;while(1){if(xa>>>0>=(f[h>>2]|0)>>>0)break c;CL(x)|0;xa=xa+1|0}}else{xa=0;while(1){if(xa>>>0>=(f[h>>2]|0)>>>0)break c;Q=f[w>>2]|0;if(L){ja=0;fa=Q;wa=f[d>>2]|0;do{ta=da-ja|0;ka=ta>>>0>ea>>>0?ea:ta;ta=Y(ka,e)|0;Li[ga&127](fa,0,Aa,0,wa,0,ta,1,0);ta=Y(f[k>>2]|0,ka)|0;fa=(f[w>>2]|0)+ta|0;f[w>>2]=fa;wa=(f[d>>2]|0)+ta|0;f[d>>2]=wa;ja=ja+ea|0}while(da>>>0>ja>>>0)}else{ja=0;wa=Q;do{fa=da-ja|0;ta=fa>>>0>ea>>>0?ea:fa;fa=Y(ta,e)|0;Li[ga&127](wa,0,Aa,0,g,0,fa,1,0);fa=f[za>>2]|0;ka=f[d>>2]|0;f[z>>2]=ta;f[ha>>2]=1;wi[ya&255](g,0,fa,0,ka,0,z,k);f[za>>2]=(f[za>>2]|0)+ta;ka=Y(f[k>>2]|0,ta)|0;wa=(f[w>>2]|0)+ka|0;f[w>>2]=wa;f[d>>2]=(f[d>>2]|0)+ka;ja=ja+ea|0}while(da>>>0>ja>>>0)}CL(x)|0;xa=xa+1|0}}while(0)}else{f[v>>2]=q;f[v+4>>2]=r;f[v+8>>2]=s;f[v+12>>2]=t;f[v+16>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;BL(x,v,w,-1);v=f[x+20>>2]|0;if((Y(v,e)|0)<0)Ba=2147483647/(e|0)|0;else Ba=v;do if(!L){da=oa>>>0<Ba>>>0?oa:Ba;ea=Y(f[k>>2]|0,da)|0;if((f[ra>>2]|0)>>>0>=ea>>>0){f[ra>>2]=ea;Ca=f[o>>2]|0;Da=da;break}d=f[o>>2]|0;if((d|0)!=(ia|0)){if(d|0)dYc(d);f[o>>2]=ia;f[ra>>2]=1032}f[ra>>2]=ea;if(ea>>>0>1032){d=bYc(ea)|0;f[o>>2]=d;Ca=d;Da=da}else{Ca=ia;Da=da}}else{Ca=0;Da=Ba}while(0);Ba=x+16|0;oa=(v|0)==0;da=w+4|0;d=w+8|0;ea=w+12|0;za=y+4|0;z=0;while(1){if(z>>>0>=(f[Ba>>2]|0)>>>0)break;d:do if(!oa){g=f[w>>2]|0;ha=f[da>>2]|0;if(!L){Aa=0;h=g;xa=ha;while(1){ja=v-Aa|0;wa=ja>>>0>Da>>>0?Da:ja;ja=Y(wa,e)|0;Li[ga&127](h,0,xa,0,Ca,0,ja,1,0);ja=f[ea>>2]|0;Q=f[d>>2]|0;f[y>>2]=wa;f[za>>2]=1;wi[ya&255](Ca,0,ja,0,Q,0,y,k);f[ea>>2]=(f[ea>>2]|0)+wa;Q=Y(f[k>>2]|0,wa)|0;h=(f[w>>2]|0)+Q|0;f[w>>2]=h;xa=(f[da>>2]|0)+Q|0;f[da>>2]=xa;f[d>>2]=(f[d>>2]|0)+Q;Aa=Aa+Da|0;if(v>>>0<=Aa>>>0)break d}}Aa=0;xa=g;h=ha;Q=f[d>>2]|0;do{wa=v-Aa|0;ja=wa>>>0>Da>>>0?Da:wa;wa=Y(ja,e)|0;Li[ga&127](xa,0,h,0,Q,0,wa,1,0);wa=Y(f[k>>2]|0,ja)|0;xa=(f[w>>2]|0)+wa|0;f[w>>2]=xa;h=(f[da>>2]|0)+wa|0;f[da>>2]=h;Q=(f[d>>2]|0)+wa|0;f[d>>2]=Q;Aa=Aa+Da|0}while(v>>>0>Aa>>>0)}while(0);CL(x)|0;z=z+1|0}}z=t+36|0;x=f[z>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)V$(t);f[z>>2]=0;z=t+16|0;x=t+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[x>>2]|0)>0){z=f[t+40>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[t+44>>2]|0;if((x|0)!=(t+48|0))wL(x);x=s+36|0;t=f[x>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)V$(s);f[x>>2]=0;x=s+16|0;t=s+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[t>>2]|0)>0){x=f[s+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))wL(t);t=r+36|0;s=f[t>>2]|0;if(s|0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0)V$(r);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))wL(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){v=r+12|0;t=f[v>>2]|0;f[v>>2]=t+-1;if((t|0)!=1)break;V$(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))wL(r);r=f[o>>2]|0;if((r|0)!=(ia|0)){if(r|0)dYc(r);f[o>>2]=ia;f[ra>>2]=1032}u=j;return}function x1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=106;w1(a,b,c,d,g,1,10);u=e;return}function y1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=107;w1(a,b,c,d,g,1,11);u=e;return}function z1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=108;w1(a,a,b,c,e,1,12);u=d;return}function A1(a,b,c){a=a|0;b=b|0;c=c|0;w1(a,b,c,fT()|0,46228,0,14);return}function B1(a,b,c){a=a|0;b=b|0;c=c|0;w1(a,b,c,fT()|0,46260,0,13);return}function C1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;w1(g,h,e,fT()|0,46228,0,14);u=d;return}function D1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;w1(g,h,e,fT()|0,46260,0,13);u=d;return}function E1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;F1(a,b,c,d,e,46292,0,0,0);return}function F1(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;k=u;u=u+1504|0;l=k+1448|0;m=k+1440|0;n=k+1432|0;o=k+1424|0;q=k;r=k+1368|0;s=k+1312|0;t=k+1168|0;v=k+128|0;w=k+104|0;x=k+88|0;y=k+56|0;z=k+1304|0;A=k+1296|0;B=k+1288|0;C=k+1280|0;D=k+1272|0;E=k+1264|0;F=k+1256|0;G=k+1248|0;H=k+1240|0;I=k+1232|0;J=k+1224|0;K=a;L=c;M=eS(a)|0;N=eS(c)|0;O=sS(e)|0;P=O^1;Q=dS(a,-1)|0;R=Q&7;S=Q>>>3&511;T=S+1|0;U=dS(c,-1)|0;V=U&7;f[m>>2]=V;W=(U>>>3&511)+1|0;X=oS(a,-1)|0;Z=oS(c,-1)|0;_=(X|0)<3;if(_)cS(n,a,-1);else{f[n>>2]=0;f[n+4>>2]=0}$=(Z|0)<3;if($)cS(o,c,-1);else{f[o>>2]=0;f[o+4>>2]=0}if((oS(a,-1)|0)<=2?tS(a,-1)|0:0){cS(l,a,-1);aa=f[l>>2]|0;ba=(aa|0)==1;if(!ba?(f[l+4>>2]|0)!=1:0)ca=0;else if(!((M|0)!=131072&(N|0)==131072)){da=f[l+4>>2]|0;ea=(da|0)==1;if(!((aa|0)==(W|0)&ea|ba&(ea|(da|0)==(W|0))))if(ba&(da|0)==4)ca=W>>>0<5&(dS(a,-1)|0)==6;else ca=0;else ca=1}else ca=0;fa=ca}else fa=0;if((oS(c,-1)|0)<=2?tS(c,-1)|0:0){cS(l,c,-1);ca=f[l>>2]|0;da=(ca|0)==1;if(!da?(f[l+4>>2]|0)!=1:0)ga=0;else if(!((M|0)==131072&(N|0)!=131072)){ba=f[l+4>>2]|0;ea=(ba|0)==1;if(!((ca|0)==(T|0)&ea|da&(ea|(ba|0)==(T|0))))if(da&(ba|0)==4)ga=T>>>0<5&(dS(c,-1)|0)==6;else ga=0;else ga=1}else ga=0;ha=ga}else ha=0;do if((M|0)==(N|0)|(S|0)==0?!((Q|0)!=(U|0)|P|$&(_&((f[n>>2]|0)==(f[o>>2]|0)?(f[n+4>>2]|0)==(f[o+4>>2]|0):0))^1):0){if(!(YS(d)|0)?(g|0)<0|(g&7|0)==(R|0):0){if(fa^ha)break}else{if(!(YS(d)|0))break;if(fa^ha|(dS(d,-1)|0)!=(Q|0))break}_S(d,a,Q);do if((eS(a)|0)==65536){ga=f[a+4>>2]|0;f[l>>2]=f[ga>>2];ba=l+4|0;da=ga+4|0;f[ba>>2]=f[da>>2];ea=l+8|0;f[ea>>2]=f[ga+8>>2];f[l+12>>2]=f[ga+12>>2];f[l+16>>2]=f[ga+16>>2];f[l+20>>2]=f[ga+20>>2];f[l+24>>2]=f[ga+24>>2];f[l+28>>2]=f[ga+28>>2];f[l+32>>2]=f[ga+32>>2];ca=f[ga+36>>2]|0;f[l+36>>2]=ca;f[l+40>>2]=ea;ea=l+48|0;aa=l+44|0;f[aa>>2]=ea;f[ea>>2]=0;f[l+52>>2]=0;if(ca|0){ea=ca+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ga+44>>2]|0;ea=f[aa>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];break}else{f[ba>>2]=0;U$(l,ga);break}}else bS(l,a,-1);while(0);do if((eS(c)|0)==65536){ga=f[c+4>>2]|0;f[q>>2]=f[ga>>2];ba=q+4|0;da=ga+4|0;f[ba>>2]=f[da>>2];ea=q+8|0;f[ea>>2]=f[ga+8>>2];f[q+12>>2]=f[ga+12>>2];f[q+16>>2]=f[ga+16>>2];f[q+20>>2]=f[ga+20>>2];f[q+24>>2]=f[ga+24>>2];f[q+28>>2]=f[ga+28>>2];f[q+32>>2]=f[ga+32>>2];aa=f[ga+36>>2]|0;f[q+36>>2]=aa;f[q+40>>2]=ea;ea=q+48|0;ca=q+44|0;f[ca>>2]=ea;f[ea>>2]=0;f[q+52>>2]=0;if(aa|0){ea=aa+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ga+44>>2]|0;ea=f[ca>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];break}else{f[ba>>2]=0;U$(q,ga);break}}else bS(q,c,-1);while(0);do if((eS(d)|0)==65536){ga=f[d+4>>2]|0;f[r>>2]=f[ga>>2];ba=r+4|0;da=ga+4|0;f[ba>>2]=f[da>>2];ea=r+8|0;f[ea>>2]=f[ga+8>>2];f[r+12>>2]=f[ga+12>>2];f[r+16>>2]=f[ga+16>>2];f[r+20>>2]=f[ga+20>>2];f[r+24>>2]=f[ga+24>>2];f[r+28>>2]=f[ga+28>>2];f[r+32>>2]=f[ga+32>>2];ca=f[ga+36>>2]|0;f[r+36>>2]=ca;f[r+40>>2]=ea;ea=r+48|0;aa=r+44|0;f[aa>>2]=ea;f[ea>>2]=0;f[r+52>>2]=0;if(ca|0){ea=ca+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ga+44>>2]|0;ea=f[aa>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];break}else{f[ba>>2]=0;U$(r,ga);break}}else bS(r,d,-1);while(0);n0(s,l,q,r,((f[l>>2]|0)>>>3&511)+1|0);ga=l+16|0;ba=l+44|0;da=l+48|0;ea=q+16|0;aa=q+44|0;ca=q+48|0;ia=r+16|0;ja=r+44|0;ka=r+48|0;Li[f[h+(R<<2)>>2]&127](f[ga>>2]|0,f[da>>2]|0,f[ea>>2]|0,f[ca>>2]|0,f[ia>>2]|0,f[ka>>2]|0,f[s>>2]|0,f[s+4>>2]|0,j);la=r+36|0;ma=f[la>>2]|0;if(ma|0?(na=ma+12|0,ma=f[na>>2]|0,f[na>>2]=ma+-1,(ma|0)==1):0)V$(r);f[la>>2]=0;la=r+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[la>>2]|0)>0){ia=f[r+40>>2]|0;ma=0;do{f[ia+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[la>>2]|0))}la=f[ja>>2]|0;if((la|0)!=(ka|0))wL(la);la=q+36|0;ma=f[la>>2]|0;if(ma|0?(ia=ma+12|0,ma=f[ia>>2]|0,f[ia>>2]=ma+-1,(ma|0)==1):0)V$(q);f[la>>2]=0;la=q+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[la>>2]|0)>0){ma=f[q+40>>2]|0;ia=0;do{f[ma+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[la>>2]|0))}la=f[aa>>2]|0;if((la|0)!=(ca|0))wL(la);la=l+36|0;ia=f[la>>2]|0;if(ia|0?(ma=ia+12|0,ia=f[ma>>2]|0,f[ma>>2]=ia+-1,(ia|0)==1):0)V$(l);f[la>>2]=0;la=l+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[la>>2]|0)>0){ia=f[l+40>>2]|0;ma=0;do{f[ia+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[la>>2]|0))}la=f[ba>>2]|0;if((la|0)!=(da|0))wL(la);u=k;return}while(0);do if((X|0)==(Z|0)?(ha=f[n>>2]|0,fa=f[n+4>>2]|0,(T|0)==(W|0)&((ha|0)==(f[o>>2]|0)?(fa|0)==(f[o+4>>2]|0):0)):0){if((M|0)==131072?(ha|0)==1&((fa|0)==4|(fa|0)==1):0){oa=84;break}if((N|0)==131072?(ha|0)==1&((fa|0)==4|(fa|0)==1):0)oa=84;else{pa=0;qa=0;ra=Q;sa=R;ta=T;ua=U;va=L;wa=K}}else oa=84;while(0);do if((oa|0)==84){a:do if((oS(a,-1)|0)<=2?tS(a,-1)|0:0){cS(l,a,-1);Z=f[l>>2]|0;X=(Z|0)==1;if(!(!X?(f[l+4>>2]|0)!=1:0))oa=88;do if((oa|0)==88?!((M|0)!=131072&(N|0)==131072):0){fa=f[l+4>>2]|0;ha=(fa|0)==1;if(!((Z|0)==(W|0)&ha|X&(ha|(fa|0)==(W|0)))){if(!(X&(fa|0)==4))break;if(!(W>>>0<5&(dS(a,-1)|0)==6)){oa=95;break a}}fa=f[n>>2]|0;ha=n+4|0;_=f[ha>>2]|0;f[n>>2]=f[o>>2];$=o+4|0;f[ha>>2]=f[$>>2];f[o>>2]=fa;f[$>>2]=_;f[m>>2]=R;xa=1;ya=U;za=V;Aa=W;Ba=Q;Ca=T;Da=K;Ea=L;break a}while(0);oa=95}else oa=95;while(0);do if((oa|0)==95){if((oS(c,-1)|0)>2){Fa=$Xc(160)|0;f[l>>2]=Fa;Ga=l+8|0;f[Ga>>2]=-2147483488;Ha=l+4|0;f[Ha>>2]=153;o1c(Fa|0,240730,153)|0;Ia=Fa+153|0;b[Ia>>0]=0;vM(-209,l,240884,240418,663)}if(!(tS(c,-1)|0)){Fa=$Xc(160)|0;f[l>>2]=Fa;Ga=l+8|0;f[Ga>>2]=-2147483488;Ha=l+4|0;f[Ha>>2]=153;o1c(Fa|0,240730,153)|0;Ia=Fa+153|0;b[Ia>>0]=0;vM(-209,l,240884,240418,663)}cS(l,c,-1);da=f[l>>2]|0;ba=(da|0)==1;if(!(!ba?(f[l+4>>2]|0)!=1:0))oa=99;if((oa|0)==99?!((M|0)==131072&(N|0)!=131072):0){X=f[l+4>>2]|0;Z=(X|0)==1;if((da|0)==(T|0)&Z|ba&(Z|(X|0)==(T|0))){xa=0;ya=Q;za=R;Aa=T;Ba=U;Ca=W;Da=L;Ea=K;break}if(ba&(X|0)==4){if(T>>>0<5&(dS(c,-1)|0)==6){xa=0;ya=Q;za=R;Aa=T;Ba=U;Ca=W;Da=L;Ea=K;break}Fa=$Xc(160)|0;f[l>>2]=Fa;Ga=l+8|0;f[Ga>>2]=-2147483488;Ha=l+4|0;f[Ha>>2]=153;o1c(Fa|0,240730,153)|0;Ia=Fa+153|0;b[Ia>>0]=0;vM(-209,l,240884,240418,663)}}Fa=$Xc(160)|0;f[l>>2]=Fa;Ga=l+8|0;f[Ga>>2]=-2147483488;Ha=l+4|0;f[Ha>>2]=153;o1c(Fa|0,240730,153)|0;Ia=Fa+153|0;b[Ia>>0]=0;vM(-209,l,240884,240418,663)}while(0);if((Ba|0)!=6){Ja=$Xc(64)|0;f[l>>2]=Ja;Ka=l+8|0;f[Ka>>2]=-2147483584;La=l+4|0;f[La>>2]=55;Ma=Ja;Na=240894;Oa=Ma+55|0;do{b[Ma>>0]=b[Na>>0]|0;Ma=Ma+1|0;Na=Na+1|0}while((Ma|0)<(Oa|0));Pa=Ja+55|0;b[Pa>>0]=0;vM(-215,l,240884,240418,665)}X=o+4|0;switch(f[X>>2]|0){case 4:case 1:break;default:{Ja=$Xc(64)|0;f[l>>2]=Ja;Ka=l+8|0;f[Ka>>2]=-2147483584;La=l+4|0;f[La>>2]=55;Ma=Ja;Na=240894;Oa=Ma+55|0;do{b[Ma>>0]=b[Na>>0]|0;Ma=Ma+1|0;Na=Na+1|0}while((Ma|0)<(Oa|0));Pa=Ja+55|0;b[Pa>>0]=0;vM(-215,l,240884,240418,665)}}if(i){f[m>>2]=6;pa=1;qa=xa<<24>>24!=0;ra=ya;sa=za;ta=Aa;ua=6;va=Da;wa=Ea;break}ba=Da;do if((eS(ba)|0)==65536){Z=f[ba+4>>2]|0;f[l>>2]=f[Z>>2];da=l+4|0;_=Z+4|0;f[da>>2]=f[_>>2];$=l+8|0;f[$>>2]=f[Z+8>>2];f[l+12>>2]=f[Z+12>>2];fa=l+16|0;f[fa>>2]=f[Z+16>>2];f[l+20>>2]=f[Z+20>>2];f[l+24>>2]=f[Z+24>>2];f[l+28>>2]=f[Z+28>>2];f[l+32>>2]=f[Z+32>>2];ha=f[Z+36>>2]|0;f[l+36>>2]=ha;f[l+40>>2]=$;$=l+48|0;S=l+44|0;f[S>>2]=$;f[$>>2]=0;f[l+52>>2]=0;if(ha|0){$=ha+12|0;f[$>>2]=(f[$>>2]|0)+1}if((f[_>>2]|0)<3){_=f[Z+44>>2]|0;$=f[S>>2]|0;f[$>>2]=f[_>>2];f[$+4>>2]=f[_+4>>2];Qa=S;Ra=fa;break}else{f[da>>2]=0;U$(l,Z);Qa=S;Ra=fa;break}}else{bS(l,ba,-1);Qa=l+44|0;Ra=l+16|0}while(0);ba=f[Ra>>2]|0;fa=(f[o>>2]|0)==1&(f[X>>2]|0)==1?Ca:Aa;S=0;Z=-2147483648;da=2147483647;while(1){Sa=+p[ba+(S<<3)>>3];_=zLc(Sa)|0;if(+(_|0)!=Sa){oa=123;break}Z=(Z|0)<(_|0)?_:Z;da=(da|0)>(_|0)?_:da;S=S+1|0;if((S|0)>=(fa|0)){oa=120;break}}if((oa|0)==120){fa=(da|0)>-1;if(!(fa&(Z|0)<256))if((da|0)>-129&(Z|0)<128)Ta=1;else Ta=fa&(Z|0)<65536?2:(da|0)>-32769&(Z|0)<32768?3:4;else Ta=0}else if((oa|0)==123){f[m>>2]=6;Ta=za>>>0<4|(za|0)==5?5:6}f[m>>2]=Ta;fa=l+36|0;S=f[fa>>2]|0;if(S|0?(ba=S+12|0,S=f[ba>>2]|0,f[ba>>2]=S+-1,(S|0)==1):0)V$(l);f[fa>>2]=0;fa=l+4|0;f[Ra>>2]=0;f[Ra+4>>2]=0;f[Ra+8>>2]=0;f[Ra+12>>2]=0;if((f[fa>>2]|0)>0){S=f[l+40>>2]|0;ba=0;do{f[S+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[fa>>2]|0))}fa=f[Qa>>2]|0;if((fa|0)!=(l+48|0))wL(fa);pa=1;qa=xa<<24>>24!=0;ra=ya;sa=za;ta=Aa;ua=6;va=Da;wa=Ea}while(0);do if((g|0)<0){if(YS(d)|0){Ua=dS(d,-1)|0;break}if((ra|0)==(ua|0)|pa)Ua=ra;else{Ea=$Xc(144)|0;f[l>>2]=Ea;f[l+8>>2]=-2147483504;f[l+4>>2]=136;o1c(Ea|0,240950,136)|0;b[Ea+136>>0]=0;vM(-5,l,240884,240418,687)}}else Ua=g;while(0);g=Ua&7;Ea=f[m>>2]|0;do if(!((sa|0)==(Ea|0)&(g|0)==(sa|0))){if(i){m=(Ea|0)>5?Ea:5;Da=(sa|0)<(m|0)?m:sa;Va=(Da|0)<(g|0)?g:Da;break}if((sa|0)<2&(Ea|0)<2)Wa=3;else Wa=(sa|0)<5&(Ea|0)<5?4:(sa|0)<(Ea|0)?Ea:sa;Da=(Wa|0)<(g|0)?g:Wa;if(g>>>0<5)Va=(sa|0)<5|(Ea|0)<5?4:Da;else Va=Da}else Va=sa;while(0);sa=(ta<<3)+-8|0;Ea=g|sa;g=Va&7;Wa=g|sa;do if(O)_S(d,wa,Ea);else{if((dS(e,-1)|0|1|0)!=1){Xa=$Xc(80)|0;f[l>>2]=Xa;Ya=l+8|0;f[Ya>>2]=-2147483568;Za=l+4|0;f[Za>>2]=64;Ma=Xa;Na=241087;Oa=Ma+64|0;do{b[Ma>>0]=b[Na>>0]|0;Ma=Ma+1|0;Na=Na+1|0}while((Ma|0)<(Oa|0));_a=Xa+64|0;b[_a>>0]=0;vM(-215,l,240884,240418,719)}i=wa;if(!(nS(e,i)|0)){Xa=$Xc(80)|0;f[l>>2]=Xa;Ya=l+8|0;f[Ya>>2]=-2147483568;Za=l+4|0;f[Za>>2]=64;Ma=Xa;Na=241087;Oa=Ma+64|0;do{b[Ma>>0]=b[Na>>0]|0;Ma=Ma+1|0;Na=Na+1|0}while((Ma|0)<(Oa|0));_a=Xa+64|0;b[_a>>0]=0;vM(-215,l,240884,240418,719)}if(nS(d,i)|0){Da=(dS(d,-1)|0)==(Ea|0);_S(d,i,Ea);if(Da)break}else _S(d,i,Ea);p[q>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=q;f[l+8>>2]=1;f[l+12>>2]=1;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;bT(d,l,r)}while(0);if((ra|0)==(Wa|0))$a=0;else $a=YW(ra,Wa)|0;if((ua|0)!=(ra|0))if((ua|0)==(Wa|0))ab=0;else ab=YW(ua,Wa)|0;else ab=$a;if((Ea|0)==(Wa|0))bb=0;else bb=YW(Wa,Ea)|0;Ea=Y(675553809>>>(ra<<2&28)&15,(ra>>>3&511)+1|0)|0;ra=Y(675553809>>>(ua<<2&28)&15,(ua>>>3&511)+1|0)|0;ua=(sa>>>3&511)+1|0;sa=Y(675553809>>>(Ua<<2&28)&15,ua)|0;f[l>>2]=sa;Ua=Y(675553809>>>(Va<<2&28)&15,ua)|0;ua=((Ua+1023|0)>>>0)/(Ua>>>0)|0;Va=hR(sa)|0;sa=wa;do if((eS(sa)|0)==65536){wa=f[sa+4>>2]|0;f[q>>2]=f[wa>>2];_a=q+4|0;Xa=wa+4|0;f[_a>>2]=f[Xa>>2];Na=q+8|0;f[Na>>2]=f[wa+8>>2];f[q+12>>2]=f[wa+12>>2];f[q+16>>2]=f[wa+16>>2];f[q+20>>2]=f[wa+20>>2];f[q+24>>2]=f[wa+24>>2];f[q+28>>2]=f[wa+28>>2];f[q+32>>2]=f[wa+32>>2];Ma=f[wa+36>>2]|0;f[q+36>>2]=Ma;f[q+40>>2]=Na;Na=q+48|0;Oa=q+44|0;f[Oa>>2]=Na;f[Na>>2]=0;f[q+52>>2]=0;if(Ma|0){Na=Ma+12|0;f[Na>>2]=(f[Na>>2]|0)+1}if((f[Xa>>2]|0)<3){Xa=f[wa+44>>2]|0;Na=f[Oa>>2]|0;f[Na>>2]=f[Xa>>2];f[Na+4>>2]=f[Xa+4>>2];break}else{f[_a>>2]=0;U$(q,wa);break}}else bS(q,sa,-1);while(0);sa=va;do if((eS(sa)|0)==65536){va=f[sa+4>>2]|0;f[r>>2]=f[va>>2];wa=r+4|0;_a=va+4|0;f[wa>>2]=f[_a>>2];Xa=r+8|0;f[Xa>>2]=f[va+8>>2];f[r+12>>2]=f[va+12>>2];f[r+16>>2]=f[va+16>>2];f[r+20>>2]=f[va+20>>2];f[r+24>>2]=f[va+24>>2];f[r+28>>2]=f[va+28>>2];f[r+32>>2]=f[va+32>>2];Na=f[va+36>>2]|0;f[r+36>>2]=Na;f[r+40>>2]=Xa;Xa=r+48|0;Oa=r+44|0;f[Oa>>2]=Xa;f[Xa>>2]=0;f[r+52>>2]=0;if(Na|0){Xa=Na+12|0;f[Xa>>2]=(f[Xa>>2]|0)+1}if((f[_a>>2]|0)<3){_a=f[va+44>>2]|0;Xa=f[Oa>>2]|0;f[Xa>>2]=f[_a>>2];f[Xa+4>>2]=f[_a+4>>2];break}else{f[wa>>2]=0;U$(r,va);break}}else bS(r,sa,-1);while(0);do if((eS(d)|0)==65536){sa=f[d+4>>2]|0;f[s>>2]=f[sa>>2];va=s+4|0;wa=sa+4|0;f[va>>2]=f[wa>>2];_a=s+8|0;f[_a>>2]=f[sa+8>>2];f[s+12>>2]=f[sa+12>>2];f[s+16>>2]=f[sa+16>>2];f[s+20>>2]=f[sa+20>>2];f[s+24>>2]=f[sa+24>>2];f[s+28>>2]=f[sa+28>>2];f[s+32>>2]=f[sa+32>>2];Xa=f[sa+36>>2]|0;f[s+36>>2]=Xa;f[s+40>>2]=_a;_a=s+48|0;Oa=s+44|0;f[Oa>>2]=_a;f[_a>>2]=0;f[s+52>>2]=0;if(Xa|0){_a=Xa+12|0;f[_a>>2]=(f[_a>>2]|0)+1}if((f[wa>>2]|0)<3){wa=f[sa+44>>2]|0;_a=f[Oa>>2]|0;f[_a>>2]=f[wa>>2];f[_a+4>>2]=f[wa+4>>2];break}else{f[va>>2]=0;U$(s,sa);break}}else bS(s,d,-1);while(0);do if((eS(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];sa=t+4|0;va=d+4|0;f[sa>>2]=f[va>>2];wa=t+8|0;f[wa>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];_a=f[d+36>>2]|0;f[t+36>>2]=_a;f[t+40>>2]=wa;wa=t+48|0;Oa=t+44|0;f[Oa>>2]=wa;f[wa>>2]=0;f[t+52>>2]=0;if(_a|0){wa=_a+12|0;f[wa>>2]=(f[wa>>2]|0)+1}if((f[va>>2]|0)<3){va=f[d+44>>2]|0;wa=f[Oa>>2]|0;f[wa>>2]=f[va>>2];f[wa+4>>2]=f[va+4>>2];break}else{f[sa>>2]=0;U$(t,d);break}}else bS(t,e,-1);while(0);e=v+8|0;f[v>>2]=e;d=v+4|0;f[d>>2]=1032;sa=($a|0)!=0;va=(ab|0)!=0;wa=(bb|0)!=0;Oa=(pa|va?Ua:0)+(sa?Ua:0)+(wa?Ua:0)+(O?0:f[l>>2]|0)|0;_a=f[h+(g<<2)>>2]|0;if(pa){f[w>>2]=q;f[w+4>>2]=s;f[w+8>>2]=t;f[w+12>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;BL(y,w,x,-1);pa=f[y+20>>2]|0;g=ua>>>0<pa>>>0?ua:pa;h=(Y(g,Oa)|0)+64|0;do if((f[d>>2]|0)>>>0<h>>>0){Xa=f[v>>2]|0;if((Xa|0)!=(e|0)){if(Xa|0)dYc(Xa);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=h;if(h>>>0<=1032){cb=e;break}Xa=bYc(h)|0;f[v>>2]=Xa;cb=Xa}else{f[d>>2]=h;cb=f[v>>2]|0}while(0);h=Y(g,Ua)|0;Xa=sa?cb+h+15&-16:cb;Na=sa?cb:0;cb=Xa+h+15&-16;Ma=O?cb:wa?cb+h+15&-16:cb;u1(r,Wa,Xa,g);Wa=y+16|0;h=(pa|0)==0;Za=Xa;Xa=x+4|0;Ya=F+4|0;Da=Na;m=wa|P;Aa=G+4|0;za=I+4|0;ya=x+8|0;xa=J+4|0;Qa=H+4|0;Ra=0;while(1){if(Ra>>>0>=(f[Wa>>2]|0)>>>0)break;if(!h){Ta=0;oa=f[x>>2]|0;Ca=f[Xa>>2]|0;do{o=pa-Ta|0;Pa=o>>>0>g>>>0?g:o;o=Y(Pa,ta)|0;if(sa){f[F>>2]=o;f[Ya>>2]=1;wi[$a&255](oa,1,0,1,Na,1,F,0);db=Da}else db=oa;Ja=qa?Za:db;La=qa?db:Za;do if(m){Li[_a&127](Ja,1,La,1,cb,1,o,1,j);if(O){f[G>>2]=o;f[Aa>>2]=1;wi[bb&255](cb,1,0,1,Ca,1,G,0);break}if(wa){f[I>>2]=o;f[za>>2]=1;wi[bb&255](cb,1,0,1,Ma,1,I,0);Ka=f[ya>>2]|0;f[J>>2]=Pa;f[xa>>2]=1;wi[Va&255](Ma,1,Ka,1,Ca,1,J,l)}else{Ka=f[ya>>2]|0;f[H>>2]=Pa;f[Qa>>2]=1;wi[Va&255](cb,1,Ka,1,Ca,1,H,l)}f[ya>>2]=(f[ya>>2]|0)+Pa}else Li[_a&127](Ja,1,La,1,Ca,1,o,1,j);while(0);o=Y(Pa,Ea)|0;oa=(f[x>>2]|0)+o|0;f[x>>2]=oa;o=Y(f[l>>2]|0,Pa)|0;Ca=(f[Xa>>2]|0)+o|0;f[Xa>>2]=Ca;Ta=Ta+g|0}while(pa>>>0>Ta>>>0)}CL(y)|0;Ra=Ra+1|0}}else{f[w>>2]=q;f[w+4>>2]=r;f[w+8>>2]=s;f[w+12>>2]=t;f[w+16>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;BL(y,w,x,-1);w=f[y+20>>2]|0;Ra=(sa|P|va|wa)&ua>>>0<w>>>0?ua:w;ua=(Y(Ra,Oa)|0)+64|0;do if((f[d>>2]|0)>>>0<ua>>>0){Oa=f[v>>2]|0;if((Oa|0)!=(e|0)){if(Oa|0)dYc(Oa);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=ua;if(ua>>>0<=1032){eb=e;break}Oa=bYc(ua)|0;f[v>>2]=Oa;eb=Oa}else{f[d>>2]=ua;eb=f[v>>2]|0}while(0);ua=Y(Ra,Ua)|0;Ua=sa?eb+ua+15&-16:eb;Oa=sa?eb:0;pa=va?Ua+ua+15&-16:Ua;g=va?Ua:0;Ua=O?pa:wa?pa+ua+15&-16:pa;ua=y+16|0;Xa=(w|0)==0;ya=x+4|0;H=x+8|0;cb=z+4|0;Qa=va^1;va=wa|P;P=B+4|0;J=D+4|0;Ma=x+12|0;xa=E+4|0;I=C+4|0;za=A+4|0;G=0;while(1){if(G>>>0>=(f[ua>>2]|0)>>>0)break;if(!Xa){Aa=0;m=f[x>>2]|0;Za=f[ya>>2]|0;db=f[H>>2]|0;do{qa=w-Aa|0;Da=qa>>>0>Ra>>>0?Ra:qa;qa=Y(Da,ta)|0;if(sa){f[z>>2]=qa;f[cb>>2]=1;wi[$a&255](m,1,0,1,Oa,1,z,0);fb=eb;gb=f[x>>2]|0;hb=f[ya>>2]|0}else{fb=m;gb=m;hb=Za}F=(gb|0)==(hb|0);if(F|Qa)ib=F?fb:Za;else{f[A>>2]=qa;f[za>>2]=1;wi[ab&255](Za,1,0,1,g,1,A,0);ib=g}do if(va){Li[_a&127](fb,1,ib,1,pa,0,qa,1,j);if(O){f[B>>2]=qa;f[P>>2]=1;wi[bb&255](pa,1,0,1,db,1,B,0);break}if(wa){f[D>>2]=qa;f[J>>2]=1;wi[bb&255](pa,1,0,1,Ua,1,D,0);F=f[Ma>>2]|0;f[E>>2]=Da;f[xa>>2]=1;wi[Va&255](Ua,1,F,1,db,1,E,l)}else{F=f[Ma>>2]|0;f[C>>2]=Da;f[I>>2]=1;wi[Va&255](pa,1,F,1,db,1,C,l)}f[Ma>>2]=(f[Ma>>2]|0)+Da}else Li[_a&127](fb,1,ib,1,db,1,qa,1,j);while(0);qa=Y(Da,Ea)|0;m=(f[x>>2]|0)+qa|0;f[x>>2]=m;qa=Y(ra,Da)|0;Za=(f[ya>>2]|0)+qa|0;f[ya>>2]=Za;qa=Y(f[l>>2]|0,Da)|0;db=(f[H>>2]|0)+qa|0;f[H>>2]=db;Aa=Aa+Ra|0}while(w>>>0>Aa>>>0)}CL(y)|0;G=G+1|0}}G=f[v>>2]|0;if((G|0)!=(e|0)){if(G|0)dYc(G);f[v>>2]=e;f[d>>2]=1032}d=t+36|0;e=f[d>>2]|0;do if(e|0){v=e+12|0;G=f[v>>2]|0;f[v>>2]=G+-1;if((G|0)!=1)break;V$(t)}while(0);f[d>>2]=0;d=t+16|0;e=t+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[t+40>>2]|0;G=0;do{f[d+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[e>>2]|0))}e=f[t+44>>2]|0;if((e|0)!=(t+48|0))wL(e);e=s+36|0;t=f[e>>2]|0;do if(t|0){G=t+12|0;d=f[G>>2]|0;f[G>>2]=d+-1;if((d|0)!=1)break;V$(s)}while(0);f[e>>2]=0;e=s+16|0;t=s+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[t>>2]|0)>0){e=f[s+40>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))wL(t);t=r+36|0;s=f[t>>2]|0;do if(s|0){d=s+12|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1)break;V$(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;e=0;do{f[t+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))wL(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){e=r+12|0;t=f[e>>2]|0;f[e>>2]=t+-1;if((t|0)!=1)break;V$(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))wL(r);u=k;return}function G1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;F1(a,b,c,d,e,46324,0,0,1);return}function H1(a,b,c){a=a|0;b=b|0;c=c|0;F1(a,b,c,fT()|0,-1,46356,0,0,3);return}function I1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0,h=0,i=0;f=u;u=u+16|0;g=f;p[g>>3]=d;h=fT()|0;i=+L(+(d+-1.0))<2.220446049250313e-16;F1(a,b,c,h,e,46388,1,g,i?4:5);u=f;return}function J1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var f=0,g=0;f=u;u=u+16|0;g=f;p[g>>3]=d;F1(a,b,c,fT()|0,e,46420,1,g,6);u=f;return}function K1(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+16|0;f=e;p[f>>3]=a;F1(b,b,c,fT()|0,d,46452,1,f,7);u=e;return}function L1(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,i=0;h=u;u=u+32|0;i=h;p[i>>3]=b;p[i+8>>3]=d;p[i+16>>3]=e;F1(a,c,f,fT()|0,g,46484,1,i,8);u=h;return}function M1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0;g=u;u=u+1440|0;h=g+1376|0;i=g+1368|0;j=g+1304|0;k=g+1360|0;l=g+1248|0;m=g+1192|0;n=g+96|0;o=g+1152|0;q=g+112|0;r=g+88|0;s=g+1184|0;t=g+56|0;v=g;f[i>>2]=e;if(e>>>0>=6){e=$Xc(96)|0;f[h>>2]=e;f[h+8>>2]=-2147483552;f[h+4>>2]=92;w=e;x=241152;y=w+92|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[e+92>>0]=0;vM(-215,h,241245,240418,1192)}e=sS(a)|0;if(e^(sS(c)|0)){e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=30;w=e;x=241253;y=w+30|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[e+30>>0]=0;vM(-215,h,241245,240418,1194)}if(sS(a)|0?sS(c)|0:0){vS(d);u=g;return}e=(eS(a)|0)==131072&1;if(((((eS(c)|0)==131072&1)+e|0)!=1?nS(a,c)|0:0)?(e=dS(a,-1)|0,(e|0)==(dS(c,-1)|0)):0)z=0;else A=11;do if((A|0)==11){e=dS(c,-1)|0;x=eS(a)|0;w=eS(c)|0;if((oS(a,-1)|0)<=2?tS(a,-1)|0:0){cS(h,a,-1);y=f[h>>2]|0;B=(y|0)==1;if(!B?(f[h+4>>2]|0)!=1:0)C=0;else{D=(e>>>3&511)+1|0;if(!((x|0)!=131072&(w|0)==131072)){w=f[h+4>>2]|0;x=(w|0)==1;if(!((y|0)==(D|0)&x|B&(x|(w|0)==(D|0))))if(B&(w|0)==4)C=D>>>0<5&(dS(a,-1)|0)==6;else C=0;else C=1}else C=0}E=C}else E=0;D=dS(a,-1)|0;w=eS(c)|0;B=eS(a)|0;if((oS(c,-1)|0)<=2?tS(c,-1)|0:0){cS(h,c,-1);x=f[h>>2]|0;y=(x|0)==1;if(!y?(f[h+4>>2]|0)!=1:0)F=0;else{e=(D>>>3&511)+1|0;if(!((w|0)!=131072&(B|0)==131072)){B=f[h+4>>2]|0;w=(B|0)==1;if(!((x|0)==(e|0)&w|y&(w|(B|0)==(e|0))))if(y&(B|0)==4)F=e>>>0<5&(dS(c,-1)|0)==6;else F=0;else F=1}else F=0}G=F}else G=0;if(G|E^1){if(E^G){z=1;break}e=$Xc(144)|0;f[h>>2]=e;f[h+8>>2]=-2147483504;f[h+4>>2]=139;o1c(e|0,241284,139)|0;b[e+139>>0]=0;vM(-209,h,241245,240418,1221)}e=f[i>>2]|0;switch(e|0){case 3:{H=1;break}case 4:{H=2;break}case 2:{H=4;break}default:H=(e|0)==1?3:e}f[i>>2]=H;M1(c,a,d,H);u=g;return}while(0);H=eS(a)|0;G=eS(c)|0;do if((eS(a)|0)==65536){E=f[a+4>>2]|0;f[h>>2]=f[E>>2];F=h+4|0;C=E+4|0;f[F>>2]=f[C>>2];e=h+8|0;f[e>>2]=f[E+8>>2];f[h+12>>2]=f[E+12>>2];f[h+16>>2]=f[E+16>>2];f[h+20>>2]=f[E+20>>2];f[h+24>>2]=f[E+24>>2];f[h+28>>2]=f[E+28>>2];f[h+32>>2]=f[E+32>>2];B=f[E+36>>2]|0;f[h+36>>2]=B;f[h+40>>2]=e;e=h+48|0;y=h+44|0;f[y>>2]=e;f[e>>2]=0;f[h+52>>2]=0;if(B|0){e=B+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[C>>2]|0)<3){C=f[E+44>>2]|0;e=f[y>>2]|0;f[e>>2]=f[C>>2];f[e+4>>2]=f[C+4>>2];break}else{f[F>>2]=0;U$(h,E);break}}else bS(h,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];E=j+4|0;F=a+4|0;f[E>>2]=f[F>>2];C=j+8|0;f[C>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];e=f[a+36>>2]|0;f[j+36>>2]=e;f[j+40>>2]=C;C=j+48|0;y=j+44|0;f[y>>2]=C;f[C>>2]=0;f[j+52>>2]=0;if(e|0){C=e+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[F>>2]|0)<3){F=f[a+44>>2]|0;C=f[y>>2]|0;f[C>>2]=f[F>>2];f[C+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;U$(j,a);break}}else bS(j,c,-1);while(0);c=h+4|0;a=f[c>>2]|0;do if(((H|0)==(G|0)&(a|0)<3?(f[j+4>>2]|0)<3:0)?(E=f[h+40>>2]|0,F=f[E+4>>2]|0,C=f[E>>2]|0,y=f[j+40>>2]|0,(C|0)==(f[y>>2]|0)?(F|0)==(f[y+4>>2]|0):0):0){y=f[h>>2]|0;e=f[j>>2]|0;B=(y>>>3&511)+1|0;if((e^y)&4095|0){I=j;J=h+40|0;K=y;L=e;M=B;N=E;O=h;A=73;break}f[k>>2]=F;f[k+4>>2]=C;wS(d,k,(B<<3)+-8|0,-1,0,0);do if((eS(d)|0)==65536){B=f[d+4>>2]|0;f[l>>2]=f[B>>2];C=l+4|0;F=B+4|0;f[C>>2]=f[F>>2];E=l+8|0;f[E>>2]=f[B+8>>2];f[l+12>>2]=f[B+12>>2];f[l+16>>2]=f[B+16>>2];f[l+20>>2]=f[B+20>>2];f[l+24>>2]=f[B+24>>2];f[l+28>>2]=f[B+28>>2];f[l+32>>2]=f[B+32>>2];e=f[B+36>>2]|0;f[l+36>>2]=e;f[l+40>>2]=E;E=l+48|0;y=l+44|0;f[y>>2]=E;f[E>>2]=0;f[l+52>>2]=0;if(e|0){E=e+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[F>>2]|0)<3){F=f[B+44>>2]|0;E=f[y>>2]|0;f[E>>2]=f[F>>2];f[E+4>>2]=f[F+4>>2];break}else{f[C>>2]=0;U$(l,B);break}}else bS(l,d,-1);while(0);n0(m,h,j,l,((f[h>>2]|0)>>>3&511)+1|0);B=l+16|0;C=l+44|0;F=l+48|0;Li[f[46516+((f[h>>2]&7)<<2)>>2]&127](f[h+16>>2]|0,f[h+48>>2]|0,f[j+16>>2]|0,f[j+48>>2]|0,f[B>>2]|0,f[F>>2]|0,f[m>>2]|0,f[m+4>>2]|0,i);E=l+36|0;y=f[E>>2]|0;if(y|0?(e=y+12|0,y=f[e>>2]|0,f[e>>2]=y+-1,(y|0)==1):0)V$(l);f[E>>2]=0;E=l+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[E>>2]|0)>0){B=f[l+40>>2]|0;y=0;do{f[B+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[E>>2]|0))}E=f[C>>2]|0;if((E|0)!=(F|0))wL(E);P=j+36|0}else A=54;while(0);if((A|0)==54){k=f[h>>2]|0;G=h+40|0;I=j;J=G;K=k;L=f[j>>2]|0;M=(k>>>3&511)+1|0;N=f[G>>2]|0;O=h;A=73}if((A|0)==73){G=K&7;K=L&7;xS(d,a,N,(M<<3)+-8|0,-1,0,0);g0(l,h,1,0);M=h+36|0;N=f[M>>2]|0;if(N|0?(a=N+12|0,N=f[a>>2]|0,f[a>>2]=N+-1,(N|0)==1):0)V$(h);f[M>>2]=0;N=h+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[c>>2]|0)>0){a=f[h+40>>2]|0;L=0;do{f[a+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[c>>2]|0))}f[O>>2]=f[l>>2];O=l+4|0;L=f[O>>2]|0;f[c>>2]=L;a=l+8|0;k=h+8|0;f[k>>2]=f[a>>2];f[h+12>>2]=f[l+12>>2];H=l+16|0;f[N>>2]=f[H>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];N=l+36|0;f[M>>2]=f[N>>2];M=h+44|0;E=f[M>>2]|0;y=h+48|0;if((E|0)==(y|0))Q=L;else{wL(E);f[M>>2]=y;f[h+40>>2]=k;Q=f[O>>2]|0}k=l+44|0;if((Q|0)<3){Q=f[k>>2]|0;f[y>>2]=f[Q>>2];f[h+52>>2]=f[Q+4>>2];R=Q}else{f[M>>2]=f[k>>2];M=l+40|0;f[J>>2]=f[M>>2];J=l+48|0;f[k>>2]=J;f[M>>2]=a;R=J}f[l>>2]=1124007936;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;f[O+24>>2]=0;f[O+28>>2]=0;f[N>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((R|0)!=(l+48|0))wL(R);g0(l,j,1,0);R=j+36|0;H=f[R>>2]|0;if(H|0?(N=H+12|0,H=f[N>>2]|0,f[N>>2]=H+-1,(H|0)==1):0)V$(j);f[R>>2]=0;H=j+16|0;N=j+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[N>>2]|0)>0){O=f[j+40>>2]|0;J=0;do{f[O+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[N>>2]|0))}f[I>>2]=f[l>>2];I=l+4|0;J=f[I>>2]|0;f[N>>2]=J;N=l+8|0;O=j+8|0;f[O>>2]=f[N>>2];f[j+12>>2]=f[l+12>>2];a=l+16|0;f[H>>2]=f[a>>2];f[j+20>>2]=f[l+20>>2];f[j+24>>2]=f[l+24>>2];f[j+28>>2]=f[l+28>>2];f[j+32>>2]=f[l+32>>2];M=l+36|0;f[R>>2]=f[M>>2];k=j+44|0;Q=f[k>>2]|0;y=j+48|0;if((Q|0)==(y|0))S=J;else{wL(Q);f[k>>2]=y;f[j+40>>2]=O;S=f[I>>2]|0}O=l+44|0;if((S|0)<3){S=f[O>>2]|0;f[y>>2]=f[S>>2];f[j+52>>2]=f[S+4>>2];T=S}else{f[k>>2]=f[O>>2];k=l+40|0;f[j+40>>2]=f[k>>2];S=l+48|0;f[O>>2]=S;f[k>>2]=N;T=S}f[l>>2]=1124007936;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[I+16>>2]=0;f[I+20>>2]=0;f[I+24>>2]=0;f[I+28>>2]=0;f[M>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((T|0)!=(l+48|0))wL(T);do if((eS(d)|0)==65536){T=f[d+4>>2]|0;f[m>>2]=f[T>>2];a=m+4|0;M=T+4|0;f[a>>2]=f[M>>2];I=m+8|0;f[I>>2]=f[T+8>>2];f[m+12>>2]=f[T+12>>2];f[m+16>>2]=f[T+16>>2];f[m+20>>2]=f[T+20>>2];f[m+24>>2]=f[T+24>>2];f[m+28>>2]=f[T+28>>2];f[m+32>>2]=f[T+32>>2];S=f[T+36>>2]|0;f[m+36>>2]=S;f[m+40>>2]=I;I=m+48|0;N=m+44|0;f[N>>2]=I;f[I>>2]=0;f[m+52>>2]=0;if(S|0){I=S+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[M>>2]|0)<3){M=f[T+44>>2]|0;I=f[N>>2]|0;f[I>>2]=f[M>>2];f[I+4>>2]=f[M+4>>2];break}else{f[a>>2]=0;U$(m,T);break}}else bS(m,d,-1);while(0);g0(l,m,1,0);d=m+36|0;T=f[d>>2]|0;do if(T|0){a=T+12|0;M=f[a>>2]|0;f[a>>2]=M+-1;if((M|0)!=1)break;V$(m)}while(0);f[d>>2]=0;d=m+16|0;T=m+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[T>>2]|0)>0){d=f[m+40>>2]|0;M=0;do{f[d+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[T>>2]|0))}T=f[m+44>>2]|0;if((T|0)!=(m+48|0))wL(T);T=f[c>>2]|0;if((T|0)>0)U=f[(f[h+44>>2]|0)+(T+-1<<2)>>2]|0;else U=0;T=(U|0)==0?1:U;U=((T+1023|0)>>>0)/(T>>>0)|0;c=f[46516+(G<<2)>>2]|0;if(z){f[m>>2]=h;f[m+4>>2]=l;f[m+8>>2]=0;z=n;f[z>>2]=0;f[z+4>>2]=0;BL(o,m,n,-1);z=f[o+20>>2]|0;M=U>>>0<z>>>0?U:z;U=Y(M,T)|0;d=q+8|0;f[q>>2]=d;a=q+4|0;f[a>>2]=U;if(U>>>0>1032){I=bYc(U)|0;f[q>>2]=I;V=I}else V=d;a:do if(G>>>0>4){u1(j,G,V,M);A=144}else{p[r>>3]=0.0;I=YW(K,6)|0;U=f[H>>2]|0;f[s>>2]=1;f[s+4>>2]=1;wi[I&255](U,1,0,1,r,1,s,0);W=+p[r>>3];do if(W<+p[7880+(G<<3)>>3]){U=f[i>>2]|0;X=(U|0)==5|(U+-1|0)>>>0<2?255.0:0.0;p[t>>3]=X;p[t+8>>3]=X;p[t+16>>3]=X;p[t+24>>3]=X;lR(l,t)|0}else{if(W>+p[7944+(G<<3)>>3]){X=((f[i>>2]|0)+-3|0)>>>0<3?255.0:0.0;p[t>>3]=X;p[t+8>>3]=X;p[t+16>>3]=X;p[t+24>>3]=X;lR(l,t)|0;break}U=zLc(W)|0;f[t>>2]=U;b:do if(W!=+(U|0)){I=f[i>>2]|0;if((I|1|0)==3){N=~~W;f[t>>2]=(+(N|0)<W&1)+N;break}switch(I|0){case 1:case 4:{N=~~W;f[t>>2]=N-(+(N|0)>W&1);break b;break}default:{X=(I|0)==5?255.0:0.0;p[v>>3]=X;p[v+8>>3]=X;p[v+16>>3]=X;p[v+24>>3]=X;lR(l,v)|0;break a}}}while(0);f[v>>2]=1124007940;U=v+4|0;f[U>>2]=2;I=v+8|0;f[I>>2]=1;f[v+12>>2]=1;N=v+16|0;f[N>>2]=t;f[v+20>>2]=t;S=v+24|0;k=v+40|0;O=S+8|0;f[O>>2]=0;f[O+4>>2]=0;f[k>>2]=I;I=v+48|0;O=v+44|0;f[O>>2]=I;f[I>>2]=4;f[v+52>>2]=4;y=t+4|0;f[v+28>>2]=y;f[S>>2]=y;R$(v);u1(v,G,V,M);y=v+36|0;S=f[y>>2]|0;do if(S|0){Q=S+12|0;J=f[Q>>2]|0;f[Q>>2]=J+-1;if((J|0)!=1)break;V$(v)}while(0);f[y>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[U>>2]|0)>0){S=f[k>>2]|0;J=0;do{f[S+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[U>>2]|0))}U=f[O>>2]|0;if((U|0)!=(I|0))wL(U);A=144;break a}while(0)}while(0);c:do if((A|0)==144){v=o+16|0;G=n+4|0;if(!z){t=0;while(1){if(t>>>0>=(f[v>>2]|0)>>>0)break c;CL(o)|0;t=t+1|0}}else Z=0;while(1){if(Z>>>0>=(f[v>>2]|0)>>>0)break c;t=0;r=f[n>>2]|0;s=f[G>>2]|0;do{H=z-t|0;K=H>>>0>M>>>0?M:H;Li[c&127](r,0,V,0,s,0,K,1,i);H=Y(K,T)|0;r=(f[n>>2]|0)+H|0;f[n>>2]=r;s=(f[G>>2]|0)+K|0;f[G>>2]=s;t=t+M|0}while(z>>>0>t>>>0);CL(o)|0;Z=Z+1|0}}while(0);Z=f[q>>2]|0;if((Z|0)!=(d|0)){if(Z|0)dYc(Z);f[q>>2]=d;f[a>>2]=1032}}else{f[m>>2]=h;f[m+4>>2]=j;f[m+8>>2]=l;f[m+12>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;BL(o,m,n,-1);m=f[o+20>>2]|0;a=o+16|0;d=n+4|0;q=n+8|0;Z=0;while(1){if(Z>>>0>=(f[a>>2]|0)>>>0)break;Li[c&127](f[n>>2]|0,0,f[d>>2]|0,0,f[q>>2]|0,0,m,1,i);CL(o)|0;Z=Z+1|0}}Z=l+36|0;o=f[Z>>2]|0;do if(o|0){i=o+12|0;m=f[i>>2]|0;f[i>>2]=m+-1;if((m|0)!=1)break;V$(l)}while(0);f[Z>>2]=0;Z=l+16|0;o=l+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[o>>2]|0)>0){Z=f[l+40>>2]|0;m=0;do{f[Z+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))wL(o);P=R}R=f[P>>2]|0;if(R|0?(o=R+12|0,R=f[o>>2]|0,f[o>>2]=R+-1,(R|0)==1):0)V$(j);f[P>>2]=0;P=j+16|0;R=j+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[R>>2]|0)>0){P=f[j+40>>2]|0;o=0;do{f[P+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[R>>2]|0))}R=f[j+44>>2]|0;if((R|0)!=(j+48|0))wL(R);R=h+36|0;j=f[R>>2]|0;if(j|0?(o=j+12|0,j=f[o>>2]|0,f[o>>2]=j+-1,(j|0)==1):0)V$(h);f[R>>2]=0;R=h+16|0;j=h+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[j>>2]|0)>0){R=f[h+40>>2]|0;o=0;do{f[R+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)!=(h+48|0))wL(j);u=g;return}function N1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;g=u;u=u+1488|0;h=g+1432|0;i=g+1376|0;j=g+1320|0;k=g+1264|0;l=g+1208|0;m=g+1192|0;n=g+1160|0;o=g+1136|0;q=g+1104|0;r=g+56|0;s=g+1184|0;t=g+1152|0;v=g;w=g+1096|0;if(sS(a)|0){x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=14;y=x;z=241424;A=y+14|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[x+14>>0]=0;vM(-215,h,241439,240418,1720)}x=eS(a)|0;B=eS(c)|0;C=eS(d)|0;do if((eS(a)|0)==65536){D=f[a+4>>2]|0;f[i>>2]=f[D>>2];E=i+4|0;F=D+4|0;f[E>>2]=f[F>>2];G=i+8|0;f[G>>2]=f[D+8>>2];f[i+12>>2]=f[D+12>>2];f[i+16>>2]=f[D+16>>2];f[i+20>>2]=f[D+20>>2];f[i+24>>2]=f[D+24>>2];f[i+28>>2]=f[D+28>>2];f[i+32>>2]=f[D+32>>2];H=f[D+36>>2]|0;f[i+36>>2]=H;f[i+40>>2]=G;G=i+48|0;I=i+44|0;f[I>>2]=G;f[G>>2]=0;f[i+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[D+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;U$(i,D);break}}else bS(i,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];D=j+4|0;E=a+4|0;f[D>>2]=f[E>>2];F=j+8|0;f[F>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];G=f[a+36>>2]|0;f[j+36>>2]=G;f[j+40>>2]=F;F=j+48|0;I=j+44|0;f[I>>2]=F;f[F>>2]=0;f[j+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[a+44>>2]|0;F=f[I>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[D>>2]=0;U$(j,a);break}}else bS(j,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[k>>2]=f[c>>2];a=k+4|0;D=c+4|0;f[a>>2]=f[D>>2];E=k+8|0;f[E>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];F=f[c+36>>2]|0;f[k+36>>2]=F;f[k+40>>2]=E;E=k+48|0;I=k+44|0;f[I>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[c+44>>2]|0;E=f[I>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];break}else{f[a>>2]=0;U$(k,c);break}}else bS(k,d,-1);while(0);d=(x|0)!=131072;a:do if(!(d&(B|0)==131072)?(c=f[i+40>>2]|0,a=f[c+-4>>2]|0,D=f[j+40>>2]|0,(a|0)==(f[D+-4>>2]|0)):0){if((a|0)==2){if((f[c>>2]|0)!=(f[D>>2]|0)){J=33;break}if((f[c+4>>2]|0)!=(f[D+4>>2]|0)){J=33;break}}else if((a|0)>0){E=0;do{if((f[c+(E<<2)>>2]|0)!=(f[D+(E<<2)>>2]|0)){J=33;break a}E=E+1|0}while((E|0)<(a|0))}a=f[i>>2]|0;if(!((f[j>>2]^a)&4095)){K=0;L=a}else J=33}else J=33;while(0);if((J|0)==33){a=f[i>>2]|0;if((f[j+4>>2]|0)>2){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(96)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483552;O=h+4|0;f[O>>2]=90;y=M;z=241447;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));P=M+90|0;b[P>>0]=0;vM(-209,h,241439,240418,1736)}E=f[j>>2]|0;if(!(E&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(96)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483552;O=h+4|0;f[O>>2]=90;y=M;z=241447;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));P=M+90|0;b[P>>0]=0;vM(-209,h,241439,240418,1736)}D=f[j+40>>2]|0;c=f[D+4>>2]|0;I=f[D>>2]|0;D=(c|0)==1;F=(I|0)==1;if(!(D|F)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(96)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483552;O=h+4|0;f[O>>2]=90;y=M;z=241447;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));P=M+90|0;b[P>>0]=0;vM(-209,h,241439,240418,1736)}G=(a>>>3&511)+1|0;if((x|0)==131072&(B|0)!=131072){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(96)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483552;O=h+4|0;f[O>>2]=90;y=M;z=241447;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));P=M+90|0;b[P>>0]=0;vM(-209,h,241439,240418,1736)}if(!((c|0)==(G|0)&F|D&(F|(I|0)==(G|0)))?G>>>0>4|(E&4095|0)!=6|D&(I|0)==4^1:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=$Xc(96)|0;f[h>>2]=M;N=h+8|0;f[N>>2]=-2147483552;O=h+4|0;f[O>>2]=90;y=M;z=241447;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));P=M+90|0;b[P>>0]=0;vM(-209,h,241439,240418,1736)}else{K=1;L=a}}b:do if(!(d&(C|0)==131072)?(a=f[i+40>>2]|0,P=f[a+-4>>2]|0,M=f[k+40>>2]|0,(P|0)==(f[M+-4>>2]|0)):0){if((P|0)==2){if((f[a>>2]|0)!=(f[M>>2]|0)){J=49;break}if((f[a+4>>2]|0)!=(f[M+4>>2]|0)){J=49;break}}else if((P|0)>0){O=0;do{if((f[a+(O<<2)>>2]|0)!=(f[M+(O<<2)>>2]|0)){J=49;break b}O=O+1|0}while((O|0)<(P|0))}if(!((f[k>>2]^L)&4095))if(K){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=$Xc(32)|0;f[h>>2]=Q;R=h+8|0;f[R>>2]=-2147483616;S=h+4|0;f[S>>2]=20;y=Q;z=241629;A=y+20|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));T=Q+20|0;b[T>>0]=0;vM(-215,h,241439,240418,1749)}else{P=L>>>3;O=P&511;U=0;V=P;W=O;X=O+1|0;Z=i;_=0;$=0;break}else J=49}else J=49;while(0);if((J|0)==49){if((f[k+4>>2]|0)>2){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;aa=$Xc(96)|0;f[h>>2]=aa;ba=h+8|0;f[ba>>2]=-2147483552;ca=h+4|0;f[ca>>2]=90;y=aa;z=241538;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));da=aa+90|0;b[da>>0]=0;vM(-209,h,241439,240418,1745)}J=f[k>>2]|0;if(!(J&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;aa=$Xc(96)|0;f[h>>2]=aa;ba=h+8|0;f[ba>>2]=-2147483552;ca=h+4|0;f[ca>>2]=90;y=aa;z=241538;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));da=aa+90|0;b[da>>0]=0;vM(-209,h,241439,240418,1745)}d=f[k+40>>2]|0;O=f[d+4>>2]|0;P=f[d>>2]|0;d=(O|0)==1;M=(P|0)==1;if(!(d|M)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;aa=$Xc(96)|0;f[h>>2]=aa;ba=h+8|0;f[ba>>2]=-2147483552;ca=h+4|0;f[ca>>2]=90;y=aa;z=241538;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));da=aa+90|0;b[da>>0]=0;vM(-209,h,241439,240418,1745)}a=L>>>3;N=a&511;I=N+1|0;if((x|0)==131072&(C|0)!=131072){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;aa=$Xc(96)|0;f[h>>2]=aa;ba=h+8|0;f[ba>>2]=-2147483552;ca=h+4|0;f[ca>>2]=90;y=aa;z=241538;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));da=aa+90|0;b[da>>0]=0;vM(-209,h,241439,240418,1745)}if(!((O|0)==(I|0)&M|d&(M|(P|0)==(I|0)))?I>>>0>4|(J&4095|0)!=6|d&(P|0)==4^1:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;aa=$Xc(96)|0;f[h>>2]=aa;ba=h+8|0;f[ba>>2]=-2147483552;ca=h+4|0;f[ca>>2]=90;y=aa;z=241538;A=y+90|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));da=aa+90|0;b[da>>0]=0;vM(-209,h,241439,240418,1745)}if(K){U=1;V=a;W=N;X=I;Z=i;_=1;$=K&1}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=$Xc(32)|0;f[h>>2]=Q;R=h+8|0;f[R>>2]=-2147483616;S=h+4|0;f[S>>2]=20;y=Q;z=241629;A=y+20|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));T=Q+20|0;b[T>>0]=0;vM(-215,h,241439,240418,1749)}}T=L&7;L=i+4|0;Q=f[L>>2]|0;if((Q|0)>0)ea=f[(f[i+44>>2]|0)+(Q+-1<<2)>>2]|0;else ea=0;S=((ea+1023|0)>>>0)/(ea>>>0)|0;R=i+40|0;xS(e,Q,f[R>>2]|0,0,-1,0,0);do if((eS(e)|0)==65536){Q=f[e+4>>2]|0;f[l>>2]=f[Q>>2];I=l+4|0;N=Q+4|0;f[I>>2]=f[N>>2];a=l+8|0;f[a>>2]=f[Q+8>>2];f[l+12>>2]=f[Q+12>>2];f[l+16>>2]=f[Q+16>>2];f[l+20>>2]=f[Q+20>>2];f[l+24>>2]=f[Q+24>>2];f[l+28>>2]=f[Q+28>>2];f[l+32>>2]=f[Q+32>>2];da=f[Q+36>>2]|0;f[l+36>>2]=da;f[l+40>>2]=a;a=l+48|0;aa=l+44|0;f[aa>>2]=a;f[a>>2]=0;f[l+52>>2]=0;if(da|0){a=da+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[N>>2]|0)<3){N=f[Q+44>>2]|0;a=f[aa>>2]|0;f[a>>2]=f[N>>2];f[a+4>>2]=f[N+4>>2];break}else{f[I>>2]=0;U$(l,Q);break}}else bS(l,e,-1);while(0);e=f[46548+(T<<2)>>2]|0;f[m>>2]=i;f[m+4>>2]=l;f[m+8>>2]=0;f[n>>2]=i;f[n+4>>2]=l;f[n+8>>2]=j;f[n+12>>2]=k;f[n+16>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;Q=K&U;BL(q,Q?m:n,o,-1);n=f[q+20>>2]|0;m=S>>>0<n>>>0?S:n;S=(X<<3)+128+(Y(m,(Y(ea,$+_|0)|0)+X|0)|0)|0;_=r+8|0;f[r>>2]=_;$=r+4|0;f[$>>2]=S;if(S>>>0>1032){I=bYc(S)|0;f[r>>2]=I;fa=I}else fa=_;I=fa+(Y(m,X)|0)+15&-16;if(Q){Q=Y(m,ea)|0;S=I+Q+15&-16;N=f[j>>2]|0;if((f[k>>2]^N)&4095|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=$Xc(32)|0;f[h>>2]=a;f[h+8>>2]=-2147483616;f[h+4>>2]=22;y=a;z=241650;A=y+22|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[a+22>>0]=0;vM(-215,h,241439,240418,1776)}a=N&7;if(T>>>0<4&(a|0)!=(T|0)){N=S+Q+15&-16;Q=N;aa=N;da=aa+(X<<2)|0;ca=YW(a,4)|0;a=j+16|0;ba=f[a>>2]|0;f[s>>2]=X;f[s+4>>2]=1;wi[ca&255](ba,1,0,1,Q,1,s,0);s=k+16|0;ba=f[s>>2]|0;f[t>>2]=X;f[t+4>>2]=1;wi[ca&255](ba,1,0,1,da,1,t,0);t=zLc(+p[7880+(T<<3)>>3])|0;ba=zLc(+p[7944+(T<<3)>>3])|0;T=t+1|0;ca=0;do{P=aa+(ca<<2)|0;d=f[P>>2]|0;J=da+(ca<<2)|0;M=f[J>>2]|0;if((M|0)<(t|0)|((d|0)>(ba|0)|(d|0)>(M|0))){f[P>>2]=T;f[J>>2]=t}ca=ca+1|0}while((ca|0)!=(X|0));f[v>>2]=1124007940;ca=v+4|0;f[ca>>2]=2;t=v+8|0;f[t>>2]=X;T=v+12|0;f[T>>2]=1;ba=v+16|0;f[ba>>2]=Q;aa=v+20|0;f[aa>>2]=Q;J=v+24|0;P=v+28|0;M=v+40|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;f[M>>2]=t;d=v+48|0;f[v+44>>2]=d;O=v+52|0;f[O>>2]=0;f[d>>2]=0;if(!N){N=$Xc(32)|0;f[h>>2]=N;f[h+8>>2]=-2147483616;f[h+4>>2]=28;y=N;z=470314;A=y+28|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[N+28>>0]=0;vM(-215,h,470343,470347,548)}f[d>>2]=4;f[O>>2]=4;O=Q+(X<<2)|0;f[P>>2]=O;f[J>>2]=O+-4+4;R$(v);O=j+36|0;Q=f[O>>2]|0;if(Q|0?(N=Q+12|0,Q=f[N>>2]|0,f[N>>2]=Q+-1,(Q|0)==1):0)V$(j);f[O>>2]=0;Q=j+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[Q>>2]|0)>0){N=f[j+40>>2]|0;z=0;do{f[N+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[Q>>2]|0))}f[j>>2]=f[v>>2];z=f[ca>>2]|0;f[Q>>2]=z;Q=j+8|0;f[Q>>2]=f[t>>2];f[j+12>>2]=f[T>>2];f[a>>2]=f[ba>>2];f[j+20>>2]=f[aa>>2];f[j+24>>2]=f[J>>2];f[j+28>>2]=f[P>>2];f[j+32>>2]=f[v+32>>2];P=v+36|0;f[O>>2]=f[P>>2];O=j+44|0;J=f[O>>2]|0;aa=j+48|0;if((J|0)==(aa|0))ga=z;else{wL(J);f[O>>2]=aa;f[j+40>>2]=Q;ga=f[ca>>2]|0}Q=v+44|0;if((ga|0)<3){ga=f[Q>>2]|0;f[aa>>2]=f[ga>>2];f[j+52>>2]=f[ga+4>>2];ha=ga}else{f[O>>2]=f[Q>>2];f[j+40>>2]=f[M>>2];f[Q>>2]=d;f[M>>2]=t;ha=d}f[v>>2]=1124007936;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;f[ca+16>>2]=0;f[ca+20>>2]=0;f[ca+24>>2]=0;f[ca+28>>2]=0;f[P>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((ha|0)!=(d|0))wL(ha);f[h>>2]=1124007940;ha=h+4|0;f[ha>>2]=2;d=h+8|0;f[d>>2]=X;ba=h+12|0;f[ba>>2]=1;P=h+16|0;f[P>>2]=da;ca=h+20|0;f[ca>>2]=da;v=h+24|0;t=h+28|0;M=h+40|0;Q=v+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[M>>2]=d;Q=h+48|0;f[h+44>>2]=Q;f[Q>>2]=4;f[h+52>>2]=4;O=da+(X<<2)|0;f[t>>2]=O;f[v>>2]=O+-4+4;R$(h);O=k+36|0;da=f[O>>2]|0;do if(da|0){ga=da+12|0;aa=f[ga>>2]|0;f[ga>>2]=aa+-1;if((aa|0)!=1)break;V$(k)}while(0);f[O>>2]=0;da=k+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[da>>2]|0)>0){aa=f[k+40>>2]|0;ga=0;do{f[aa+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[da>>2]|0))}f[k>>2]=f[h>>2];ga=f[ha>>2]|0;f[da>>2]=ga;da=k+8|0;f[da>>2]=f[d>>2];f[k+12>>2]=f[ba>>2];f[s>>2]=f[P>>2];f[k+20>>2]=f[ca>>2];f[k+24>>2]=f[v>>2];f[k+28>>2]=f[t>>2];f[k+32>>2]=f[h+32>>2];t=h+36|0;f[O>>2]=f[t>>2];O=k+44|0;v=f[O>>2]|0;ca=k+48|0;if((v|0)==(ca|0))ia=ga;else{wL(v);f[O>>2]=ca;f[k+40>>2]=da;ia=f[ha>>2]|0}da=h+44|0;if((ia|0)<3){ia=f[da>>2]|0;f[ca>>2]=f[ia>>2];f[k+52>>2]=f[ia+4>>2];ja=ia}else{f[O>>2]=f[da>>2];f[k+40>>2]=f[M>>2];f[da>>2]=Q;f[M>>2]=d;ja=Q}f[h>>2]=1124007936;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;f[ha+16>>2]=0;f[ha+20>>2]=0;f[ha+24>>2]=0;f[ha+28>>2]=0;f[t>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((ja|0)!=(Q|0))wL(ja)}u1(j,f[Z>>2]&4095,I,m);u1(k,f[Z>>2]&4095,S,m);ka=I;la=S}else{ka=0;la=0}S=q+16|0;I=(n|0)==0;Z=o+((K?2:3)<<2)|0;ja=(W|0)==0;Q=o+4|0;P=w+4|0;t=V+1&3;V=(t|0)==0?4:t;t=V&255;ha=V>>>0>=X>>>0;h=o+8|0;d=0;while(1){if(d>>>0>=(f[S>>2]|0)>>>0)break;if(!I){M=0;do{da=n-M|0;O=da>>>0>m>>>0?m:da;da=Y(O,ea)|0;if(K)ma=ka;else{ia=f[h>>2]|0;f[h>>2]=ia+da;ma=ia}if(U)na=la;else{ia=f[Z>>2]|0;f[Z>>2]=ia+da;na=ia}ia=f[o>>2]|0;ca=ja?f[Q>>2]|0:fa;v=Y(O,X)|0;f[w>>2]=v;f[P>>2]=1;Li[e&127](ia,0,ma,0,na,0,ca,0,w);c:do if(!ja){ca=f[Q>>2]|0;switch(t&7){case 1:{if(!O)break c;else{oa=0;pa=0}while(1){b[ca+oa>>0]=b[fa+pa>>0]|0;oa=oa+1|0;if((oa|0)==(O|0))break;else pa=pa+X|0}break}case 2:{if(!O)break c;else{qa=0;ra=0}while(1){b[ca+ra>>0]=b[fa+(qa+1)>>0]&b[fa+qa>>0];ra=ra+1|0;if((ra|0)==(O|0))break;else qa=qa+X|0}break}case 3:{if(!O)break c;else{sa=0;ta=0}while(1){b[ca+ta>>0]=b[fa+(sa+1)>>0]&b[fa+sa>>0]&b[fa+(sa+2)>>0];ta=ta+1|0;if((ta|0)==(O|0))break;else sa=sa+X|0}break}default:{if(!O)break c;else{ua=0;va=0}while(1){b[ca+ua>>0]=b[fa+(va+1)>>0]&b[fa+va>>0]&b[fa+(va+2)>>0]&b[fa+(va+3)>>0];ua=ua+1|0;if((ua|0)==(O|0))break;else va=va+X|0}}}if(!(ha|(O|0)==0)){ia=V;do{v=0;ga=ia;while(1){s=ca+v|0;b[s>>0]=b[fa+(ga+1)>>0]&b[fa+ga>>0]&b[fa+(ga+2)>>0]&b[fa+(ga+3)>>0]&b[s>>0];v=v+1|0;if((v|0)==(O|0))break;else ga=ga+X|0}ia=ia+4|0}while((ia|0)<=(W|0))}}while(0);f[o>>2]=(f[o>>2]|0)+da;f[Q>>2]=(f[Q>>2]|0)+O;M=M+m|0}while(n>>>0>M>>>0)}CL(q)|0;d=d+1|0}d=f[r>>2]|0;if((d|0)!=(_|0)){if(d|0)dYc(d);f[r>>2]=_;f[$>>2]=1032}$=l+36|0;_=f[$>>2]|0;if(_|0?(r=_+12|0,_=f[r>>2]|0,f[r>>2]=_+-1,(_|0)==1):0)V$(l);f[$>>2]=0;$=l+16|0;_=l+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[_>>2]|0)>0){$=f[l+40>>2]|0;r=0;do{f[$+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[_>>2]|0))}_=f[l+44>>2]|0;if((_|0)!=(l+48|0))wL(_);_=k+36|0;l=f[_>>2]|0;if(l|0?(r=l+12|0,l=f[r>>2]|0,f[r>>2]=l+-1,(l|0)==1):0)V$(k);f[_>>2]=0;_=k+16|0;l=k+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[l>>2]|0)>0){_=f[k+40>>2]|0;r=0;do{f[_+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))wL(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(r=k+12|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)V$(j);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[j+40>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=i+36|0;j=f[k>>2]|0;do if(j|0){r=j+12|0;l=f[r>>2]|0;f[r>>2]=l+-1;if((l|0)!=1)break;V$(i)}while(0);f[k>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[L>>2]|0)>0){k=f[R>>2]|0;R=0;do{f[k+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[L>>2]|0))}L=f[i+44>>2]|0;if((L|0)==(i+48|0)){u=g;return}wL(L);u=g;return}function O1(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!n)return;l=m+-4|0;if((m|0)<4){o=(m|0)>0;p=a;q=j;r=g;s=d;t=n;while(1){t=t+-1|0;if(o){u=0;do{v=b[p+u>>0]|0;if((h[s+u>>0]|0)>(v&255))w=0;else w=(v&255)<=(h[r+u>>0]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!t)break;else{p=p+c|0;q=q+k|0;r=r+i|0;s=s+e|0}}return}s=m&-4;r=(s|0)<(m|0);q=a;a=j;j=g;g=d;d=n;while(1){n=0;do{p=b[q+n>>0]|0;if((h[g+n>>0]|0)>(p&255))x=0;else x=(p&255)<=(h[j+n>>0]|0);p=n|1;t=b[q+p>>0]|0;if((h[g+p>>0]|0)>(t&255))y=0;else y=(t&255)<=(h[j+p>>0]|0);b[a+n>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=n|2;t=b[q+p>>0]|0;if((h[g+p>>0]|0)>(t&255))z=0;else z=(t&255)<=(h[j+p>>0]|0);t=n|3;w=b[q+t>>0]|0;if((h[g+t>>0]|0)>(w&255))A=0;else A=(w&255)<=(h[j+t>>0]|0);b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;n=n+4|0}while((n|0)<=(l|0));d=d+-1|0;if(r){n=s;do{t=b[q+n>>0]|0;if((h[g+n>>0]|0)>(t&255))B=0;else B=(t&255)<=(h[j+n>>0]|0);b[a+n>>0]=B<<31>>31;n=n+1|0}while((n|0)!=(m|0))}if(!d)break;else{q=q+c|0;a=a+k|0;j=j+i|0;g=g+e|0}}return}function P1(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;if(!m)return;k=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;p=i;q=g;r=d;s=m;while(1){s=s+-1|0;if(n){t=0;do{u=b[o+t>>0]|0;if((b[r+t>>0]|0)>u<<24>>24)v=0;else v=u<<24>>24<=(b[q+t>>0]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!s)break;else{o=o+c|0;p=p+j|0;q=q+h|0;r=r+e|0}}return}r=l&-4;q=(r|0)<(l|0);p=a;a=i;i=g;g=d;d=m;while(1){m=0;do{o=b[p+m>>0]|0;if((b[g+m>>0]|0)>o<<24>>24)w=0;else w=o<<24>>24<=(b[i+m>>0]|0);o=m|1;s=b[p+o>>0]|0;if((b[g+o>>0]|0)>s<<24>>24)x=0;else x=s<<24>>24<=(b[i+o>>0]|0);b[a+m>>0]=w<<31>>31;b[a+o>>0]=x<<31>>31;o=m|2;s=b[p+o>>0]|0;if((b[g+o>>0]|0)>s<<24>>24)y=0;else y=s<<24>>24<=(b[i+o>>0]|0);s=m|3;v=b[p+s>>0]|0;if((b[g+s>>0]|0)>v<<24>>24)z=0;else z=v<<24>>24<=(b[i+s>>0]|0);b[a+o>>0]=y<<31>>31;b[a+s>>0]=z<<31>>31;m=m+4|0}while((m|0)<=(k|0));d=d+-1|0;if(q){m=r;do{s=b[p+m>>0]|0;if((b[g+m>>0]|0)>s<<24>>24)A=0;else A=s<<24>>24<=(b[i+m>>0]|0);b[a+m>>0]=A<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{p=p+c|0;a=a+j|0;i=i+h|0;g=g+e|0}}return}function Q1(a,c,e,g,h,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c>>>1;c=g>>>1;g=i>>>1;if(!o)return;i=n+-4|0;if((n|0)<4){p=(n|0)>0;q=a;r=k;s=h;t=e;u=o;while(1){u=u+-1|0;if(p){v=0;do{w=d[q+(v<<1)>>1]|0;if((j[t+(v<<1)>>1]|0)>(w&65535))x=0;else x=(w&65535)<=(j[s+(v<<1)>>1]|0);b[r+v>>0]=x<<31>>31;v=v+1|0}while((v|0)!=(n|0))}if(!u)break;else{q=q+(m<<1)|0;r=r+l|0;s=s+(g<<1)|0;t=t+(c<<1)|0}}return}t=n&-4;s=(t|0)<(n|0);r=a;a=k;k=h;h=e;e=o;while(1){o=0;do{q=d[r+(o<<1)>>1]|0;if((j[h+(o<<1)>>1]|0)>(q&65535))y=0;else y=(q&65535)<=(j[k+(o<<1)>>1]|0);q=o|1;u=d[r+(q<<1)>>1]|0;if((j[h+(q<<1)>>1]|0)>(u&65535))z=0;else z=(u&65535)<=(j[k+(q<<1)>>1]|0);b[a+o>>0]=y<<31>>31;b[a+q>>0]=z<<31>>31;q=o|2;u=d[r+(q<<1)>>1]|0;if((j[h+(q<<1)>>1]|0)>(u&65535))A=0;else A=(u&65535)<=(j[k+(q<<1)>>1]|0);u=o|3;x=d[r+(u<<1)>>1]|0;if((j[h+(u<<1)>>1]|0)>(x&65535))B=0;else B=(x&65535)<=(j[k+(u<<1)>>1]|0);b[a+q>>0]=A<<31>>31;b[a+u>>0]=B<<31>>31;o=o+4|0}while((o|0)<=(i|0));e=e+-1|0;if(s){o=t;do{u=d[r+(o<<1)>>1]|0;if((j[h+(o<<1)>>1]|0)>(u&65535))C=0;else C=(u&65535)<=(j[k+(o<<1)>>1]|0);b[a+o>>0]=C<<31>>31;o=o+1|0}while((o|0)!=(n|0))}if(!e)break;else{r=r+(m<<1)|0;a=a+l|0;k=k+(g<<1)|0;h=h+(c<<1)|0}}return}function R1(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=c>>>1;c=g>>>1;g=i>>>1;if(!n)return;i=m+-4|0;if((m|0)<4){o=(m|0)>0;p=a;q=j;r=h;s=e;t=n;while(1){t=t+-1|0;if(o){u=0;do{v=d[p+(u<<1)>>1]|0;if((d[s+(u<<1)>>1]|0)>v<<16>>16)w=0;else w=v<<16>>16<=(d[r+(u<<1)>>1]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!t)break;else{p=p+(l<<1)|0;q=q+k|0;r=r+(g<<1)|0;s=s+(c<<1)|0}}return}s=m&-4;r=(s|0)<(m|0);q=a;a=j;j=h;h=e;e=n;while(1){n=0;do{p=d[q+(n<<1)>>1]|0;if((d[h+(n<<1)>>1]|0)>p<<16>>16)x=0;else x=p<<16>>16<=(d[j+(n<<1)>>1]|0);p=n|1;t=d[q+(p<<1)>>1]|0;if((d[h+(p<<1)>>1]|0)>t<<16>>16)y=0;else y=t<<16>>16<=(d[j+(p<<1)>>1]|0);b[a+n>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=n|2;t=d[q+(p<<1)>>1]|0;if((d[h+(p<<1)>>1]|0)>t<<16>>16)z=0;else z=t<<16>>16<=(d[j+(p<<1)>>1]|0);t=n|3;w=d[q+(t<<1)>>1]|0;if((d[h+(t<<1)>>1]|0)>w<<16>>16)A=0;else A=w<<16>>16<=(d[j+(t<<1)>>1]|0);b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;n=n+4|0}while((n|0)<=(i|0));e=e+-1|0;if(r){n=s;do{t=d[q+(n<<1)>>1]|0;if((d[h+(n<<1)>>1]|0)>t<<16>>16)B=0;else B=t<<16>>16<=(d[j+(n<<1)>>1]|0);b[a+n>>0]=B<<31>>31;n=n+1|0}while((n|0)!=(m|0))}if(!e)break;else{q=q+(l<<1)|0;a=a+k|0;j=j+(g<<1)|0;h=h+(c<<1)|0}}return}function S1(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;p=i;q=g;r=d;s=m;while(1){s=s+-1|0;if(n){t=0;do{u=f[o+(t<<2)>>2]|0;if((f[r+(t<<2)>>2]|0)>(u|0))v=0;else v=(u|0)<=(f[q+(t<<2)>>2]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!s)break;else{o=o+(k<<2)|0;p=p+j|0;q=q+(e<<2)|0;r=r+(c<<2)|0}}return}r=l&-4;q=(r|0)<(l|0);p=a;a=i;i=g;g=d;d=m;while(1){m=0;do{o=f[p+(m<<2)>>2]|0;if((f[g+(m<<2)>>2]|0)>(o|0))w=0;else w=(o|0)<=(f[i+(m<<2)>>2]|0);o=m|1;s=f[p+(o<<2)>>2]|0;if((f[g+(o<<2)>>2]|0)>(s|0))x=0;else x=(s|0)<=(f[i+(o<<2)>>2]|0);b[a+m>>0]=w<<31>>31;b[a+o>>0]=x<<31>>31;o=m|2;s=f[p+(o<<2)>>2]|0;if((f[g+(o<<2)>>2]|0)>(s|0))y=0;else y=(s|0)<=(f[i+(o<<2)>>2]|0);s=m|3;v=f[p+(s<<2)>>2]|0;if((f[g+(s<<2)>>2]|0)>(v|0))z=0;else z=(v|0)<=(f[i+(s<<2)>>2]|0);b[a+o>>0]=y<<31>>31;b[a+s>>0]=z<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(q){m=r;do{s=f[p+(m<<2)>>2]|0;if((f[g+(m<<2)>>2]|0)>(s|0))A=0;else A=(s|0)<=(f[i+(m<<2)>>2]|0);b[a+m>>0]=A<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{p=p+(k<<2)|0;a=a+j|0;i=i+(e<<2)|0;g=g+(c<<2)|0}}return}function T1(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){o=(l|0)>0;p=a;q=i;r=g;s=d;t=m;while(1){t=t+-1|0;if(o){u=0;do{v=+n[p+(u<<2)>>2];if(!(+n[s+(u<<2)>>2]<=v))w=0;else w=v<=+n[r+(u<<2)>>2];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!t)break;else{p=p+(k<<2)|0;q=q+j|0;r=r+(e<<2)|0;s=s+(c<<2)|0}}return}s=l&-4;r=(s|0)<(l|0);q=a;a=i;i=g;g=d;d=m;while(1){m=0;do{v=+n[q+(m<<2)>>2];if(!(+n[g+(m<<2)>>2]<=v))x=0;else x=v<=+n[i+(m<<2)>>2];p=m|1;v=+n[q+(p<<2)>>2];if(!(+n[g+(p<<2)>>2]<=v))y=0;else y=v<=+n[i+(p<<2)>>2];b[a+m>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=m|2;v=+n[q+(p<<2)>>2];if(!(+n[g+(p<<2)>>2]<=v))z=0;else z=v<=+n[i+(p<<2)>>2];t=m|3;v=+n[q+(t<<2)>>2];if(!(+n[g+(t<<2)>>2]<=v))A=0;else A=v<=+n[i+(t<<2)>>2];b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(r){m=s;do{v=+n[q+(m<<2)>>2];if(!(+n[g+(m<<2)>>2]<=v))B=0;else B=v<=+n[i+(m<<2)>>2];b[a+m>>0]=B<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{q=q+(k<<2)|0;a=a+j|0;i=i+(e<<2)|0;g=g+(c<<2)|0}}return}function U1(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>3;c=e>>>3;e=h>>>3;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;q=i;r=g;s=d;t=m;while(1){t=t+-1|0;if(n){u=0;do{v=+p[o+(u<<3)>>3];if(!(+p[s+(u<<3)>>3]<=v))w=0;else w=v<=+p[r+(u<<3)>>3];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!t)break;else{o=o+(k<<3)|0;q=q+j|0;r=r+(e<<3)|0;s=s+(c<<3)|0}}return}s=l&-4;r=(s|0)<(l|0);q=a;a=i;i=g;g=d;d=m;while(1){m=0;do{v=+p[q+(m<<3)>>3];if(!(+p[g+(m<<3)>>3]<=v))x=0;else x=v<=+p[i+(m<<3)>>3];o=m|1;v=+p[q+(o<<3)>>3];if(!(+p[g+(o<<3)>>3]<=v))y=0;else y=v<=+p[i+(o<<3)>>3];b[a+m>>0]=x<<31>>31;b[a+o>>0]=y<<31>>31;o=m|2;v=+p[q+(o<<3)>>3];if(!(+p[g+(o<<3)>>3]<=v))z=0;else z=v<=+p[i+(o<<3)>>3];t=m|3;v=+p[q+(t<<3)>>3];if(!(+p[g+(t<<3)>>3]<=v))A=0;else A=v<=+p[i+(t<<3)>>3];b[a+o>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(r){m=s;do{v=+p[q+(m<<3)>>3];if(!(+p[g+(m<<3)>>3]<=v))B=0;else B=v<=+p[i+(m<<3)>>3];b[a+m>>0]=B<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{q=q+(k<<3)|0;a=a+j|0;i=i+(e<<3)|0;g=g+(c<<3)|0}}return}function V1(a){a=a|0;return}function W1(a,b){a=a|0;b=b|0;var c=0,d=0;switch(b|0){case 0:{c=46756;d=46588;break}case 1:{c=46936;d=46728;break}case 2:{c=46900;d=46700;break}case 3:{c=46864;d=46672;break}case 4:{c=46828;d=46644;break}case 5:{c=46792;d=46616;break}default:{c=46756;d=46588}}b=$Xc(32)|0;f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=d;d=b+12|0;f[b+16>>2]=4;f[b+20>>2]=8;f[b+24>>2]=16;f[b+28>>2]=1;f[d>>2]=c;f[a>>2]=d;f[a+4>>2]=b;return}function X1(a){a=a|0;cYc(a);return}function Y1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+8|0;h=e+18|0;i=e;j=e+17|0;k=e+16|0;b[h>>0]=b[241705]|0;b[h+1>>0]=b[241706]|0;b[h+2>>0]=b[241707]|0;b[h+3>>0]=b[241708]|0;b[h+4>>0]=b[241709]|0;f[i>>2]=h;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+16>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=1;b2(g,1165591,1165591,d,i,j,k,(f[d>>2]&7|0)==6?c+12|0:c+8|0);c=f[g+4>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=c;u=e;return}function Z1(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function _1(a,b){a=a|0;b=b|0;f[a+8>>2]=b;return}function $1(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function a2(a,b){a=a|0;b=b|0;f[a+16>>2]=b&1;return}function b2(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;k=u;u=u+80|0;l=k+68|0;m=k+56|0;n=k;o=$Xc(176)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=46972;p=o+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=dJc(c)|0;if(q>>>0>4294967279)jYc(l);if(q>>>0<11){b[l+11>>0]=q;if(!q)r=l;else{s=l;t=6}}else{v=q+16&-16;w=$Xc(v)|0;f[l>>2]=w;f[l+8>>2]=v|-2147483648;f[l+4>>2]=q;s=w;t=6}if((t|0)==6){o1c(s|0,c|0,q|0)|0;r=s}b[r+q>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;q=dJc(d)|0;if(q>>>0>4294967279)jYc(m);if(q>>>0<11){b[m+11>>0]=q;if(!q)x=m;else{y=m;t=12}}else{r=q+16&-16;s=$Xc(r)|0;f[m>>2]=s;f[m+8>>2]=r|-2147483648;f[m+4>>2]=q;y=s;t=12}if((t|0)==12){o1c(y|0,d|0,q|0)|0;x=y}b[x+q>>0]=0;f[n>>2]=f[e>>2];q=n+4|0;x=e+4|0;y=f[x>>2]|0;f[q>>2]=y;d=n+8|0;f[d>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];t=n+16|0;f[t>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];s=n+36|0;r=f[e+36>>2]|0;f[s>>2]=r;c=n+40|0;f[c>>2]=d;d=n+48|0;w=n+44|0;f[w>>2]=d;f[d>>2]=0;f[n+52>>2]=0;if(!r)z=y;else{y=r+12|0;f[y>>2]=(f[y>>2]|0)+1;z=f[x>>2]|0}if((z|0)<3){z=f[e+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2]}else{f[q>>2]=0;U$(n,e)}c2(p,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=f[s>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)V$(n);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[q>>2]|0)>0){t=f[c>>2]|0;c=0;do{f[t+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[q>>2]|0))}q=f[w>>2]|0;if((q|0)!=(d|0))wL(q);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[l+11>>0]|0)>=0){A=a+4|0;f[a>>2]=p;f[A>>2]=o;u=k;return}cYc(f[l>>2]|0);A=a+4|0;f[a>>2]=p;f[A>>2]=o;u=k;return}function c2(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+16|0;l=k;m=k+4|0;n=h&1;h=i&1;f[a>>2]=47e3;i=a+44|0;f[i>>2]=1124007936;o=a+48|0;p=a+52|0;q=a+84|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;t=a+92|0;v=a+88|0;f[v>>2]=t;f[t>>2]=0;f[a+96>>2]=0;t=a+124|0;w=a+136|0;x=e+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;if((f[x>>2]|0)>=3){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;y=$Xc(16)|0;f[m>>2]=y;f[m+8>>2]=-2147483632;f[m+4>>2]=11;r=y;z=241710;s=r+11|0;do{b[r>>0]=b[z>>0]|0;r=r+1|0;z=z+1|0}while((r|0)<(s|0));b[y+11>>0]=0;vM(-215,m,241722,241736,87)}oYc(t,c)|0;oYc(w,d)|0;if((i|0)!=(e|0)){d=e+36|0;w=f[d>>2]|0;if(w|0){c=w+12|0;f[c>>2]=(f[c>>2]|0)+1}c=a+80|0;w=f[c>>2]|0;if(w|0?(t=w+12|0,w=f[t>>2]|0,f[t>>2]=w+-1,(w|0)==1):0)V$(i);f[c>>2]=0;w=a+60|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[o>>2]|0)>0){t=f[q>>2]|0;q=0;do{f[t+(q<<2)>>2]=0;q=q+1|0;A=f[o>>2]|0}while((q|0)<(A|0));f[i>>2]=f[e>>2];if((A|0)<3)B=14;else B=16}else{f[i>>2]=f[e>>2];B=14}if((B|0)==14){A=f[x>>2]|0;if((A|0)<3){f[o>>2]=A;f[p>>2]=f[e+8>>2];f[a+56>>2]=f[e+12>>2];p=f[e+44>>2]|0;A=f[v>>2]|0;f[A>>2]=f[p>>2];f[A+4>>2]=f[p+4>>2]}else B=16}if((B|0)==16)U$(i,e);f[w>>2]=f[e+16>>2];f[a+64>>2]=f[e+20>>2];f[a+68>>2]=f[e+24>>2];f[a+72>>2]=f[e+28>>2];f[a+76>>2]=f[e+32>>2];f[c>>2]=f[d>>2]}f[a+100>>2]=((f[e>>2]|0)>>>3&511)+1;e=a+148|0;b[e>>0]=b[g>>0]|0;b[e+1>>0]=b[g+1>>0]|0;b[e+2>>0]=b[g+2>>0]|0;b[e+3>>0]=b[g+3>>0]|0;b[e+4>>0]=b[g+4>>0]|0;f[a+108>>2]=0;b[a+104>>0]=n;b[a+105>>0]=h;f[a+120>>2]=0;f[a+116>>2]=0;f[a+112>>2]=0;h=a+4|0;if((j|0)<0){b[h>>0]=37;b[a+5>>0]=97;b[a+6>>0]=0}else{f[l>>2]=(j|0)<20?j:20;yM(h,8,241801,l)|0}switch(f[i>>2]&7){case 0:{C=2224;D=0;break}case 1:{C=2223;D=0;break}case 2:{C=2225;D=0;break}case 3:{C=2226;D=0;break}case 4:{C=2227;D=0;break}case 5:{C=2228;D=0;break}case 6:{C=2229;D=0;break}default:{C=2230;D=0}}f[a+156>>2]=C;f[a+160>>2]=D;u=k;return}function d2(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;p[c>>3]=+p[g+(f[a+120>>2]<<3)>>3];cLc(a+12|0,a+4|0,c)|0;u=b;return}function e2(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;p[c>>3]=+n[g+(f[a+120>>2]<<2)>>2];cLc(a+12|0,a+4|0,c)|0;u=b;return}function f2(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=f[g+(f[a+120>>2]<<2)>>2];cLc(a+12|0,505729,c)|0;u=b;return}function g2(a){a=a|0;var b=0,c=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;e=f[a+88>>2]|0;g=(f[a+60>>2]|0)+(Y(f[e>>2]|0,f[a+112>>2]|0)|0)|0;h=g+(Y(f[e+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=d[h+(f[a+120>>2]<<1)>>1];cLc(a+12|0,505729,c)|0;u=b;return}function h2(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=j[g+(f[a+120>>2]<<1)>>1];cLc(a+12|0,505729,c)|0;u=b;return}function i2(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[a+88>>2]|0;e=(f[a+60>>2]|0)+(Y(f[d>>2]|0,f[a+112>>2]|0)|0)|0;g=e+(Y(f[d+4>>2]|0,f[a+116>>2]|0)|0)|0;f[c>>2]=h[g+(f[a+120>>2]|0)>>0];cLc(a+12|0,241808,c)|0;u=b;return}function j2(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=f[a+88>>2]|0;g=(f[a+60>>2]|0)+(Y(f[e>>2]|0,f[a+112>>2]|0)|0)|0;h=g+(Y(f[e+4>>2]|0,f[a+116>>2]|0)|0)|0;f[d>>2]=b[h+(f[a+120>>2]|0)>>0];cLc(a+12|0,241808,d)|0;u=c;return}function k2(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b;d=a+12|0;e=a+4|0;g=f[a+88>>2]|0;h=(f[a+60>>2]|0)+(Y(f[g>>2]|0,f[a+112>>2]|0)|0)|0;i=h+(Y(f[g+4>>2]|0,f[a+116>>2]|0)|0)|0;g=j[i+(f[a+120>>2]<<1)>>1]|0;a=g<<13;i=a&268427264;h=i+939524096|0;k=g<<16&-2147483648;l=g&31744;a:do if(l<<16>>16<31744){switch(l<<16>>16){case 0:break;default:{m=h;break a}}m=(n[s>>2]=(f[s>>2]=i+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(l<<16>>16){case 31744:break;default:{m=h;break a}}m=a|1879048192}while(0);p[c>>3]=(f[s>>2]=m|k,+n[s>>2]);cLc(d,e,c)|0;u=b;return}function l2(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=u;u=u+16|0;d=c+8|0;e=c;g=a+108|0;h=a+116|0;i=a+112|0;j=a+148|0;k=a+124|0;l=k+11|0;m=a+128|0;n=a+149|0;o=a+150|0;p=a+52|0;q=a+105|0;r=a+120|0;s=a+100|0;t=a+151|0;v=a+56|0;w=a+152|0;a:while(1){x=f[g>>2]|0;b:while(1){switch(x|0){case 0:{y=4;break a;break}case 2:{y=14;break a;break}case 1:{y=19;break a;break}case 7:{y=46;break a;break}case 11:{y=58;break a;break}case 10:{y=57;break a;break}case 3:{y=22;break b;break}case 4:{y=33;break b;break}case 5:{y=38;break b;break}case 6:{z=(f[h>>2]|0)+1|0;f[h>>2]=z;A=(z|0)>=(f[v>>2]|0)?4:10;f[g>>2]=A;if((f[s>>2]|0)>1){y=44;break b}else{x=A;continue b}break}case 9:break;default:{B=0;y=32;break a}}if((f[i>>2]|0)<(f[p>>2]|0)){y=56;break a}A=b[q>>0]|0?2:1;f[g>>2]=A;x=A}if((y|0)==22){y=0;f[h>>2]=0;f[g>>2]=5;c:do if((f[i>>2]|0)>0){x=0;while(1){A=b[l>>0]|0;if(A<<24>>24<0)C=f[m>>2]|0;else C=A&255;if(!(x>>>0<30&x>>>0<C>>>0)){D=x;break c}b[a+12+x>>0]=32;x=x+1|0}}else D=0;while(0);x=b[j>>0]|0;if(!(x<<24>>24))E=D;else{b[a+12+D>>0]=x;E=D+1|0}if(!E)continue;else{y=31;break}}else if((y|0)==33){y=0;f[g>>2]=9;F=(f[i>>2]|0)+1|0;f[i>>2]=F;G=b[n>>0]|0;if(G<<24>>24){y=34;break}H=b[o>>0]|0;if(!(H<<24>>24))continue;if((F|0)<(f[p>>2]|0)){y=37;break}else continue}else if((y|0)==38){y=0;f[g>>2]=7;if(!(b[q>>0]|0))f[r>>2]=0;if((f[s>>2]|0)<=1)continue;I=b[t>>0]|0;if(!(I<<24>>24))continue;else{y=42;break}}else if((y|0)==44){y=0;J=b[w>>0]|0;if(!(J<<24>>24))continue;else{y=45;break}}}switch(y|0){case 4:{f[i>>2]=0;if(f[a+60>>2]|0){y=f[a+48>>2]|0;if((y|0)<3)K=Y(f[v>>2]|0,f[p>>2]|0)|0;else{v=f[a+84>>2]|0;w=0;t=1;while(1){o=Y(f[v+(w<<2)>>2]|0,t)|0;w=w+1|0;if((w|0)==(y|0)){K=o;break}else t=o}}if(!((y|0)==0|(K|0)==0))L=b[q>>0]|0?2:3;else L=1}else L=1;f[g>>2]=L;if((b[l>>0]|0)<0){B=f[k>>2]|0;u=c;return B|0}else{B=k;u=c;return B|0}break}case 14:{f[g>>2]=3;if((f[i>>2]|0)<(f[p>>2]|0)){k=a+12|0;f[d>>2]=(f[r>>2]|0)+1;cLc(k,241828,d)|0;B=k;u=c;return B|0}k=f[r>>2]|0;d=k+1|0;f[r>>2]=d;if((d|0)<(f[s>>2]|0)){f[i>>2]=0;i=a+12|0;f[e>>2]=k+2;cLc(i,241812,e)|0;B=i;u=c;return B|0}else{f[g>>2]=1;i=a+12|0;b[i>>0]=0;B=i;u=c;return B|0}break}case 19:{f[g>>2]=8;i=a+136|0;if((b[i+11>>0]|0)<0){B=f[i>>2]|0;u=c;return B|0}else{B=i;u=c;return B|0}break}case 31:{b[a+12+E>>0]=0;B=a+12|0;u=c;return B|0}case 32:{u=c;return B|0}case 34:{E=a+12|0;b[E>>0]=G;b[a+13>>0]=(F|0)<(f[p>>2]|0)?44:0;b[a+14>>0]=0;B=E;u=c;return B|0}case 37:{E=a+12|0;b[E>>0]=H;b[a+13>>0]=0;B=E;u=c;return B|0}case 42:{E=a+12|0;b[E>>0]=I;b[a+13>>0]=0;B=E;u=c;return B|0}case 45:{E=a+12|0;b[E>>0]=J;b[a+13>>0]=0;B=E;u=c;return B|0}case 46:{E=f[a+156>>2]|0;J=f[a+160>>2]|0;I=a+(J>>1)|0;if(!(J&1))M=E;else M=f[(f[I>>2]|0)+E>>2]|0;Yi[M&4095](I);f[g>>2]=6;if(b[q>>0]|0){B=a+12|0;u=c;return B|0}q=(f[r>>2]|0)+1|0;f[r>>2]=q;if((q|0)<(f[s>>2]|0))f[g>>2]=11;B=a+12|0;u=c;return B|0}case 56:{f[g>>2]=3;s=a+12|0;b[s>>0]=b[a+104>>0]|0?32:10;b[a+13>>0]=0;B=s;u=c;return B|0}case 57:{f[g>>2]=5;s=a+12|0;b[s>>0]=44;b[a+13>>0]=32;b[a+14>>0]=0;B=s;u=c;return B|0}case 58:{f[g>>2]=7;g=a+12|0;b[g>>0]=44;b[a+13>>0]=32;b[a+14>>0]=0;B=g;u=c;return B|0}}return 0}function m2(a){a=a|0;f[a+108>>2]=0;return}function n2(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=47e3;c=a+136|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+124|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+44|0;d=a+80|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[d>>2]=0;d=a+60|0;c=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[a+84>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+88>>2]|0;if((c|0)==(a+92|0))return;wL(c);return}function o2(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=47e3;c=a+136|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+124|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+44|0;d=a+80|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[d>>2]=0;d=a+60|0;c=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[a+84>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+88>>2]|0;if((c|0)==(a+92|0)){cYc(a);return}wL(c);cYc(a);return}function p2(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=46972;f[a+12>>2]=47e3;c=a+148|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+136|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+56|0;d=a+92|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[d>>2]=0;d=a+72|0;c=a+60|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[a+96>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+100>>2]|0;if((c|0)==(a+104|0)){NXc(a);return}wL(c);NXc(a);return}function q2(a){a=a|0;p2(a);cYc(a);return}function r2(a){a=a|0;var c=0,d=0,e=0,g=0;f[a+12>>2]=47e3;c=a+148|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+136|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+56|0;d=a+92|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[d>>2]=0;d=a+72|0;c=a+60|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[a+96>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+100>>2]|0;if((c|0)==(a+104|0))return;wL(c);return}function s2(a){a=a|0;cYc(a);return}function t2(a){a=a|0;cYc(a);return}function u2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+48|0;g=e+32|0;h=e+42|0;i=e+16|0;j=e+4|0;k=e;l=e+41|0;m=e+40|0;b[h>>0]=0;b[h+1>>0]=0;b[h+2>>0]=0;b[h+3>>0]=0;b[h+4>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=f[d+8>>2]|0;if((n|0)<=1){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[k>>2]=h;if((n|0)==1){o=1;p=k}else{q=k;r=4}}else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=1;b[j>>0]=10;b[j+1>>0]=0;f[k>>2]=h;q=k;r=4}if((r|0)==4){o=(f[c+16>>2]|0)==0&1;p=q}b[l>>0]=o;b[m>>0]=0;v2(g,i,j,d,k,l,m,(f[d>>2]&7|0)==6?c+12|0:c+8|0);c=f[g+4>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=c;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[i+11>>0]|0)>=0){u=e;return}cYc(f[i>>2]|0);u=e;return}function v2(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;k=u;u=u+80|0;l=k+68|0;m=k+56|0;n=k;o=$Xc(176)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=46972;p=o+12|0;lYc(l,c);lYc(m,d);f[n>>2]=f[e>>2];d=n+4|0;c=e+4|0;q=f[c>>2]|0;f[d>>2]=q;r=n+8|0;f[r>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];s=n+16|0;f[s>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];t=n+36|0;v=f[e+36>>2]|0;f[t>>2]=v;w=n+40|0;f[w>>2]=r;r=n+48|0;x=n+44|0;f[x>>2]=r;f[r>>2]=0;f[n+52>>2]=0;if(!v)y=q;else{q=v+12|0;f[q>>2]=(f[q>>2]|0)+1;y=f[c>>2]|0}if((y|0)<3){y=f[e+44>>2]|0;c=f[x>>2]|0;f[c>>2]=f[y>>2];f[c+4>>2]=f[y+4>>2]}else{f[d>>2]=0;U$(n,e)}c2(p,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=f[t>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)V$(n);f[t>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[d>>2]|0)>0){s=f[w>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[d>>2]|0))}d=f[x>>2]|0;if((d|0)!=(r|0))wL(d);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[l+11>>0]|0)>=0){z=a+4|0;f[a>>2]=p;f[z>>2]=o;u=k;return}cYc(f[l>>2]|0);z=a+4|0;f[a>>2]=p;f[z>>2]=o;u=k;return}function w2(a){a=a|0;cYc(a);return}function x2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+8|0;h=e+18|0;i=e;j=e+17|0;k=e+16|0;b[h>>0]=b[242e3]|0;b[h+1>>0]=b[242001]|0;b[h+2>>0]=b[242002]|0;b[h+3>>0]=b[242003]|0;b[h+4>>0]=b[242004]|0;if((f[d+12>>2]|0)==1){b[h+1>>0]=0;b[h>>0]=0}f[i>>2]=h;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+16>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=0;y2(g,505467,528096,d,i,j,k,(f[d>>2]&7|0)==6?c+12|0:c+8|0);c=f[g+4>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=c;u=e;return}function y2(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;k=u;u=u+80|0;l=k+68|0;m=k+56|0;n=k;o=$Xc(176)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=46972;p=o+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=dJc(c)|0;if(q>>>0>4294967279)jYc(l);if(q>>>0<11){b[l+11>>0]=q;if(!q)r=l;else{s=l;t=6}}else{v=q+16&-16;w=$Xc(v)|0;f[l>>2]=w;f[l+8>>2]=v|-2147483648;f[l+4>>2]=q;s=w;t=6}if((t|0)==6){o1c(s|0,c|0,q|0)|0;r=s}b[r+q>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;q=dJc(d)|0;if(q>>>0>4294967279)jYc(m);if(q>>>0<11){b[m+11>>0]=q;if(!q)x=m;else{y=m;t=12}}else{r=q+16&-16;s=$Xc(r)|0;f[m>>2]=s;f[m+8>>2]=r|-2147483648;f[m+4>>2]=q;y=s;t=12}if((t|0)==12){o1c(y|0,d|0,q|0)|0;x=y}b[x+q>>0]=0;f[n>>2]=f[e>>2];q=n+4|0;x=e+4|0;y=f[x>>2]|0;f[q>>2]=y;d=n+8|0;f[d>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];t=n+16|0;f[t>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];s=n+36|0;r=f[e+36>>2]|0;f[s>>2]=r;c=n+40|0;f[c>>2]=d;d=n+48|0;w=n+44|0;f[w>>2]=d;f[d>>2]=0;f[n+52>>2]=0;if(!r)z=y;else{y=r+12|0;f[y>>2]=(f[y>>2]|0)+1;z=f[x>>2]|0}if((z|0)<3){z=f[e+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2]}else{f[q>>2]=0;U$(n,e)}c2(p,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=f[s>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)V$(n);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[q>>2]|0)>0){t=f[c>>2]|0;c=0;do{f[t+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[q>>2]|0))}q=f[w>>2]|0;if((q|0)!=(d|0))wL(q);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[l+11>>0]|0)>=0){A=a+4|0;f[a>>2]=p;f[A>>2]=o;u=k;return}cYc(f[l>>2]|0);A=a+4|0;f[a>>2]=p;f[A>>2]=o;u=k;return}function z2(a){a=a|0;cYc(a);return}function A2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=e+26|0;i=e+12|0;j=e+8|0;k=e+25|0;l=e+24|0;b[h>>0]=b[242e3]|0;b[h+1>>0]=b[242001]|0;b[h+2>>0]=b[242002]|0;b[h+3>>0]=b[242003]|0;b[h+4>>0]=b[242004]|0;if((f[d+12>>2]|0)==1){b[h+1>>0]=0;b[h>>0]=0}f[g>>2]=f[47016+((f[d>>2]&7)<<2)>>2];DM(i,242028,g);f[j>>2]=h;if((f[d+8>>2]|0)==1)m=1;else m=(f[c+16>>2]|0)==0&1;b[k>>0]=m;b[l>>0]=0;B2(g,242043,i,d,j,k,l,(f[d>>2]&7|0)==6?c+12|0:c+8|0);c=f[g+4>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=c;if((b[i+11>>0]|0)>=0){u=e;return}cYc(f[i>>2]|0);u=e;return}function B2(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;k=u;u=u+80|0;l=k+68|0;m=k+56|0;n=k;o=$Xc(176)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=46972;p=o+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q=dJc(c)|0;if(q>>>0>4294967279)jYc(l);if(q>>>0<11){b[l+11>>0]=q;if(!q)r=l;else{s=l;t=6}}else{v=q+16&-16;w=$Xc(v)|0;f[l>>2]=w;f[l+8>>2]=v|-2147483648;f[l+4>>2]=q;s=w;t=6}if((t|0)==6){o1c(s|0,c|0,q|0)|0;r=s}b[r+q>>0]=0;lYc(m,d);f[n>>2]=f[e>>2];d=n+4|0;q=e+4|0;r=f[q>>2]|0;f[d>>2]=r;s=n+8|0;f[s>>2]=f[e+8>>2];f[n+12>>2]=f[e+12>>2];c=n+16|0;f[c>>2]=f[e+16>>2];f[n+20>>2]=f[e+20>>2];f[n+24>>2]=f[e+24>>2];f[n+28>>2]=f[e+28>>2];f[n+32>>2]=f[e+32>>2];t=n+36|0;w=f[e+36>>2]|0;f[t>>2]=w;v=n+40|0;f[v>>2]=s;s=n+48|0;x=n+44|0;f[x>>2]=s;f[s>>2]=0;f[n+52>>2]=0;if(!w)y=r;else{r=w+12|0;f[r>>2]=(f[r>>2]|0)+1;y=f[q>>2]|0}if((y|0)<3){y=f[e+44>>2]|0;q=f[x>>2]|0;f[q>>2]=f[y>>2];f[q+4>>2]=f[y+4>>2]}else{f[d>>2]=0;U$(n,e)}c2(p,l,m,n,f[g>>2]|0,(b[h>>0]|0)!=0,(b[i>>0]|0)!=0,f[j>>2]|0);j=f[t>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)V$(n);f[t>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[v>>2]|0;v=0;do{f[c+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[d>>2]|0))}d=f[x>>2]|0;if((d|0)!=(s|0))wL(d);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[l+11>>0]|0)>=0){z=a+4|0;f[a>>2]=p;f[z>>2]=o;u=k;return}cYc(f[l>>2]|0);z=a+4|0;f[a>>2]=p;f[z>>2]=o;u=k;return}function C2(a){a=a|0;cYc(a);return}function D2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+8|0;h=e+18|0;i=e;j=e+17|0;k=e+16|0;b[h>>0]=b[242121]|0;b[h+1>>0]=b[242122]|0;b[h+2>>0]=b[242123]|0;b[h+3>>0]=b[242124]|0;b[h+4>>0]=b[242125]|0;f[i>>2]=h;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+16>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=0;y2(g,242126,506651,d,i,j,k,(f[d>>2]&7|0)==6?c+12|0:c+8|0);c=f[g+4>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=c;u=e;return}function E2(a){a=a|0;cYc(a);return}function F2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+8|0;h=e+18|0;i=e;j=e+17|0;k=e+16|0;b[h>>0]=b[241705]|0;b[h+1>>0]=b[241706]|0;b[h+2>>0]=b[241707]|0;b[h+3>>0]=b[241708]|0;b[h+4>>0]=b[241709]|0;f[i>>2]=h;if((f[d+8>>2]|0)==1)l=1;else l=(f[c+16>>2]|0)==0&1;b[j>>0]=l;b[k>>0]=0;y2(g,505467,528096,d,i,j,k,(f[d>>2]&7|0)==6?c+12|0:c+8|0);c=f[g+4>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=c;u=e;return}function G2(a){a=a|0;NXc(a);return}function H2(a){a=a|0;NXc(a);cYc(a);return}function I2(a){a=a|0;return}function J2(a){a=a|0;cYc(a);return}function K2(a){a=a|0;NXc(a);return}function L2(a){a=a|0;NXc(a);cYc(a);return}function M2(a){a=a|0;return}function N2(a){a=a|0;cYc(a);return}function O2(a){a=a|0;NXc(a);return}function P2(a){a=a|0;NXc(a);cYc(a);return}function Q2(a){a=a|0;return}function R2(a){a=a|0;cYc(a);return}function S2(a){a=a|0;NXc(a);return}function T2(a){a=a|0;NXc(a);cYc(a);return}function U2(a){a=a|0;return}function V2(a){a=a|0;cYc(a);return}function W2(a){a=a|0;NXc(a);return}function X2(a){a=a|0;NXc(a);cYc(a);return}function Y2(a){a=a|0;return}function Z2(a){a=a|0;cYc(a);return}function _2(a){a=a|0;NXc(a);return}function $2(a){a=a|0;NXc(a);cYc(a);return}function a3(a){a=a|0;return}function b3(a){a=a|0;cYc(a);return}function c3(){var a=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;a=$Xc(48)|0;f[c>>2]=a;f[c+8>>2]=-2147483600;f[c+4>>2]=44;d=a;e=242606;g=d+44|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));b[a+44>>0]=0;vM(-216,c,242651,242665,107)}function d3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c3()}function e3(a){a=a|0;return}function f3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c3();return 0}function g3(a){a=a|0;return}function h3(a,b,c){a=a|0;b=b|0;c=+c;if((f[a>>2]|0)==(f[a+4>>2]|0))return;mi[f[(f[b>>2]|0)+8>>2]&2047](b,a);return}function i3(){return 1}function j3(){return 1}function k3(){return 0}function l3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;cYc(d);return}function m3(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i;if(!a){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;vM(-27,j,242847,242780,147)}if((d|c|0)<0){k=$Xc(32)|0;f[j>>2]=k;f[j+8>>2]=-2147483616;f[j+4>>2]=25;l=k;m=242863;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+25>>0]=0;vM(-201,j,242847,242780,153)}k=e&4095|1111621632;f[a>>2]=k;f[a+20>>2]=c;f[a+24>>2]=d;f[a+16>>2]=g;f[a+8>>2]=0;f[a+12>>2]=0;g=Y(Y(675553809>>>(e<<2&28)&15,(e>>>3&511)+1|0)|0,d)|0;if((h|0)<2147483647)switch(h|0){case 0:{o=g;break}default:p=6}else switch(h|0){case 2147483647:{o=g;break}default:p=6}if((p|0)==6)if((g|0)>(h|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;vM(-13,j,242847,242780,169)}else o=h;f[a+4>>2]=o;h=x1c(c|0,((c|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;j=J;f[a>>2]=k|((j|0)>0|(j|0)==0&h>>>0>2147483647?0:(o|0)==(g|0)|(c|0)==1?16384:0);u=i;return a|0}function n3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g;if(!((a|0)!=0&(c|0)!=0)){i=$Xc(32)|0;f[h>>2]=i;f[h+8>>2]=-2147483616;f[h+4>>2]=28;j=i;k=242889;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+28>>0]=0;vM(-27,h,243024,242780,2390)}i=f[a>>2]|0;m=i&-65536;if(((m|0)==1111621632?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0)if(!(f[a+16>>2]|0)){n=$Xc(48)|0;f[h>>2]=n;f[h+8>>2]=-2147483600;f[h+4>>2]=32;j=n;k=242918;l=j+32|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[n+32>>0]=0;vM(-27,h,243024,242780,2395)}else{o=a;p=0}else q=8;do if((q|0)==8){if((i|0)!=112){if(!((e|0)!=0&(m|0)==1111687168)){n=$Xc(48)|0;f[h>>2]=n;f[h+8>>2]=-2147483600;f[h+4>>2]=38;j=n;k=242951;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[n+38>>0]=0;vM(-206,h,243024,242780,2492)}r=a+20|0;s=f[r>>2]|0;t=a+16|0;if(!(f[t>>2]|0)){v=$Xc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=33;j=v;k=242990;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[v+33>>0]=0;vM(-27,h,243024,242780,2465)}if(!(i&16384)){n=$Xc(48)|0;f[h>>2]=n;f[h+8>>2]=-2147483600;f[h+4>>2]=44;j=n;k=243227;l=j+44|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[n+44>>0]=0;vM(-5,h,243024,242780,2468)}v=f[a+4>>2]|0;if((v|0)<=2)if((v|0)==1)w=1;else w=f[a+28>>2]|0;else{x=1;y=1;while(1){z=Y(f[r+(y<<3)>>2]|0,x)|0;y=y+1|0;if((y|0)==(v|0)){w=z;break}else x=z}}f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=f[t>>2];f[c+20>>2]=s;f[c+24>>2]=w;x=f[a>>2]|0;v=x&4095;f[c>>2]=v|1111638016;y=Y(Y((x>>>3&511)+1|0,w)|0,675553809>>>(x<<2&28)&15)|0;x=(s|0)>1?y:0;f[c+4>>2]=x;y=x1c(x|0,((x|0)<0)<<31>>31|0,s|0,((s|0)<0)<<31>>31|0)|0;x=J;if(!((x|0)>0|(x|0)==0&y>>>0>2147483647)){o=c;p=0;break}f[c>>2]=v|1111621632;o=c;p=0;break}v=f[a+68>>2]|0;if(!v){y=$Xc(32)|0;f[h>>2]=y;f[h+8>>2]=-2147483616;f[h+4>>2]=31;j=y;k=243033;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[y+31>>0]=0;vM(-27,h,243024,242780,2405)}s=f[a+16>>2]|0;t=1125516576>>>((s>>>2&60)+(s>>31&20)|0);s=t&7;x=f[a+8>>2]|0;r=(x|0)>1?f[a+28>>2]|0:0;n=f[a+48>>2]|0;if(!n)if(!r){m3(c,f[a+44>>2]|0,f[a+40>>2]|0,s|(x<<3)+-8,v,f[a+72>>2]|0)|0;o=c;p=0;break}else{z=$Xc(48)|0;f[h>>2]=z;f[h+8>>2]=-2147483600;f[h+4>>2]=40;j=z;k=243186;l=j+40|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[z+40>>0]=0;vM(-206,h,243024,242780,2451)}y=f[n>>2]|0;if((r|0)==1)if(!y){A=$Xc(64)|0;f[h>>2]=A;f[h+8>>2]=-2147483584;f[h+4>>2]=63;j=A;k=243065;l=j+63|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[A+63>>0]=0;vM(-206,h,243024,242780,2421)}else{r=v+(Y(f[a+64>>2]|0,y+-1|0)|0)|0;z=f[a+72>>2]|0;B=r+(Y(z,f[n+8>>2]|0)|0)|0;m3(c,f[n+16>>2]|0,f[n+12>>2]|0,s,B+(Y(f[n+4>>2]|0,675553809>>>(t<<2&28)&15)|0)|0,z)|0;o=c;p=0;break}else{z=(x<<3)+-8|0;if((x|0)>512){B=$Xc(64)|0;f[h>>2]=B;f[h+8>>2]=-2147483584;f[h+4>>2]=56;j=B;k=243129;l=j+56|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[B+56>>0]=0;vM(-15,h,243024,242780,2437)}else{x=f[a+72>>2]|0;A=v+(Y(x,f[n+8>>2]|0)|0)|0;m3(c,f[n+16>>2]|0,f[n+12>>2]|0,s|z,A+(Y(Y(675553809>>>(t<<2&28)&15,(z>>>3&511)+1|0)|0,f[n+4>>2]|0)|0)|0,x)|0;o=c;p=y;break}}}while(0);if(!d){u=g;return o|0}f[d>>2]=p;u=g;return o|0}function o3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+32|0;h=g+12|0;i=g;if(!c){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;vM(-27,h,243351,242780,2718)}if(((((a|0)!=0?(f[a>>2]&-65536|0)==1111621632:0)?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0)?(f[a+16>>2]|0)!=0:0)j=a;else k=8;do if((k|0)==8){f[h>>2]=0;l=n3(a,c,h,1)|0;if(!(f[h>>2]|0)){j=l;break}else{l=$Xc(32)|0;f[i>>2]=l;f[i+8>>2]=-2147483616;f[i+4>>2]=20;m=l;n=243361;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+20>>0]=0;vM(-24,i,243351,242780,2725)}}while(0);if(d)if((d+-1|0)>>>0>3){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;vM(-15,h,243351,242780,2731)}else p=d;else p=((f[j>>2]|0)>>>3&511)+1|0;if((j|0)!=(c|0)){d=c+12|0;i=f[d>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+8>>2]=0;f[d>>2]=i}i=f[j>>2]|0;d=Y((i>>>3&511)+1|0,f[j+24>>2]|0)|0;a=(e|0)==0;if((p|0)>(d|0))if(a)k=20;else{q=e;k=23}else if(a&((d|0)%(p|0)|0|0)!=0)k=20;else{r=e;k=21}if((k|0)==20){r=(Y(f[j+20>>2]|0,d)|0)/(p|0)|0;k=21}if((k|0)==21)if(!r){s=f[j+20>>2]|0;k=24}else{q=r;k=23}do if((k|0)==23){r=f[j+20>>2]|0;if((q|0)!=(r|0)){e=Y(r,d)|0;if(!(i&16384)){r=$Xc(80)|0;f[h>>2]=r;f[h+8>>2]=-2147483568;f[h+4>>2]=72;m=r;n=243382;o=m+72|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[r+72>>0]=0;vM(-13,h,243351,242780,2756)}if(q>>>0>e>>>0){l=$Xc(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=22;m=l;n=243455;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+22>>0]=0;vM(-211,h,243351,242780,2759)}r=(e|0)/(q|0)|0;if((Y(r,q)|0)==(e|0)){f[c+20>>2]=q;t=r;v=Y(675553809>>>(f[j>>2]<<2&28)&15,r)|0;break}else{r=$Xc(80)|0;f[h>>2]=r;f[h+8>>2]=-2147483568;f[h+4>>2]=78;m=r;n=243272;o=m+78|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[r+78>>0]=0;vM(-5,h,243351,242780,2765)}}else{s=q;k=24}}while(0);if((k|0)==24){f[c+20>>2]=s;t=d;v=f[j+4>>2]|0}f[c+4>>2]=v;v=(t|0)/(p|0)|0;if((Y(v,p)|0)==(t|0)){f[c+24>>2]=v;v=f[j>>2]|0;f[c>>2]=v&7|(p<<3)+-8|v&-4096;u=g;return c|0}else{c=$Xc(64)|0;f[h>>2]=c;f[h+8>>2]=-2147483584;f[h+4>>2]=62;m=c;n=243478;o=m+62|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[c+62>>0]=0;vM(-15,h,243351,242780,2775)}return 0}function p3(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;jT(c);u=a;return}function q3(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0;h=u;u=u+16|0;i=h;j=(e>>>3&511)+1|0;if(j>>>0>=5){f[i+8>>2]=0;b[i+11>>0]=7;b[i>>0]=b[243541]|0;b[i+1>>0]=b[243542]|0;b[i+2>>0]=b[243543]|0;b[i+3>>0]=b[243544]|0;b[i+4>>0]=b[243545]|0;b[i+5>>0]=b[243546]|0;b[i+6>>0]=b[243547]|0;b[i+7>>0]=0;vM(-215,i,243549,242780,3229)}switch(e&7){case 0:{e=0;do{i=zLc(+p[a+(e<<3)>>3])|0;b[c+e>>0]=i>>>0<256?i:(i|0)>0?255:0;e=e+1|0}while((e|0)!=(j|0));if((j|0)<(g|0))k=j;else{u=h;return}do{b[c+k>>0]=b[c+(k-j)>>0]|0;k=k+1|0}while((k|0)!=(g|0));u=h;return}case 1:{k=0;do{e=zLc(+p[a+(k<<3)>>3])|0;b[c+k>>0]=(e+128|0)>>>0<256?e:(e|0)>0?127:128;k=k+1|0}while((k|0)!=(j|0));if((j|0)<(g|0))l=j;else{u=h;return}do{b[c+l>>0]=b[c+(l-j)>>0]|0;l=l+1|0}while((l|0)!=(g|0));u=h;return}case 2:{l=0;do{k=zLc(+p[a+(l<<3)>>3])|0;d[c+(l<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;l=l+1|0}while((l|0)!=(j|0));if((j|0)<(g|0))m=j;else{u=h;return}do{d[c+(m<<1)>>1]=d[c+(m-j<<1)>>1]|0;m=m+1|0}while((m|0)!=(g|0));u=h;return}case 3:{m=0;do{l=zLc(+p[a+(m<<3)>>3])|0;d[c+(m<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;m=m+1|0}while((m|0)!=(j|0));if((j|0)<(g|0))o=j;else{u=h;return}do{d[c+(o<<1)>>1]=d[c+(o-j<<1)>>1]|0;o=o+1|0}while((o|0)!=(g|0));u=h;return}case 4:{o=0;do{m=zLc(+p[a+(o<<3)>>3])|0;f[c+(o<<2)>>2]=m;o=o+1|0}while((o|0)!=(j|0));if((j|0)<(g|0))q=j;else{u=h;return}do{f[c+(q<<2)>>2]=f[c+(q-j<<2)>>2];q=q+1|0}while((q|0)!=(g|0));u=h;return}case 5:{q=0;do{n[c+(q<<2)>>2]=+p[a+(q<<3)>>3];q=q+1|0}while((q|0)!=(j|0));if((j|0)<(g|0))r=j;else{u=h;return}do{f[c+(r<<2)>>2]=f[c+(r-j<<2)>>2];r=r+1|0}while((r|0)!=(g|0));u=h;return}case 6:{r=0;do{p[c+(r<<3)>>3]=+p[a+(r<<3)>>3];r=r+1|0}while((r|0)!=(j|0));if((j|0)<(g|0))t=j;else{u=h;return}do{p[c+(t<<3)>>3]=+p[c+(t-j<<3)>>3];t=t+1|0}while((t|0)!=(g|0));u=h;return}case 7:{t=0;do{r=(n[s>>2]=+p[a+(t<<3)>>3],f[s>>2]|0);q=r&-2147483648;o=q^r;do if(o>>>0<=1199570943)if(o>>>0<947912704){v=(n[s>>2]=(f[s>>2]=o,+n[s>>2])+.5,f[s>>2]|0);break}else{v=(r+134221823+(r>>>13&1)|0)>>>13;break}else v=o>>>0>2139095040?32256:31744;while(0);d[c+(t<<1)>>1]=v|q>>>16;t=t+1|0}while((t|0)!=(j|0));if((j|0)<(g|0))w=j;else{u=h;return}do{d[c+(w<<1)>>1]=d[c+(w-j<<1)>>1]|0;w=w+1|0}while((w|0)!=(g|0));u=h;return}default:{}}}function r3(a){a=a|0;var c=0,d=0;f[a>>2]=47056;f[a+20>>2]=0;c=a+24|0;d=f[c>>2]|0;f[c>>2]=0;if(d|0?(UXc(d),d=f[c>>2]|0,d|0):0)UXc(d);d=a+8|0;if((b[d+11>>0]|0)>=0)return;cYc(f[d>>2]|0);return}function s3(a){a=a|0;var c=0,d=0;f[a>>2]=47056;f[a+20>>2]=0;c=a+24|0;d=f[c>>2]|0;f[c>>2]=0;if(d|0?(UXc(d),d=f[c>>2]|0,d|0):0)UXc(d);d=a+8|0;if((b[d+11>>0]|0)>=0){cYc(a);return}cYc(f[d>>2]|0);cYc(a);return}function t3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;g=B3(f[a+20>>2]|0,(b[c+11>>0]|0)<0?f[c>>2]|0:c,d,(b[e+11>>0]|0)<0?f[e>>2]|0:e)|0;if(!g)return g|0;f[a+4>>2]=6;return g|0}function u3(a){a=a|0;return (b[(f[a+20>>2]|0)+36>>0]|0)!=0|0}function v3(a){a=a|0;var c=0;c=f[a+20>>2]|0;if(!(b[c+36>>0]|0))return;a:do if(b[c+38>>0]|0){a=c+76|0;if((f[a>>2]|0)>>>0>1)do y3(c);while((f[a>>2]|0)>>>0>1);_i[f[(f[c>>2]|0)+56>>2]&2047](c)|0;switch(f[c+40>>2]|0){case 8:{mi[f[(f[c>>2]|0)+12>>2]&2047](c,243565);break a;break}case 24:{mi[f[(f[c>>2]|0)+12>>2]&2047](c,505406);break a;break}default:break a}}while(0);Yi[f[(f[c>>2]|0)+28>>2]&4095](c);z3(c);return}function w3(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;x3(f[b+20>>2]|0,a);return}function x3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;if(!(b[a+36>>0]|0)){u=d;return}g=(c|0)!=0;do if(g){h=c+11|0;if((b[h>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[h>>0]=0;break}}while(0);a:do if(b[a+38>>0]|0){h=a+76|0;if((f[h>>2]|0)>>>0>1)do y3(a);while((f[h>>2]|0)>>>0>1);_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0;switch(f[a+40>>2]|0){case 8:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,243565);break a;break}case 24:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,505406);break a;break}default:break a}}while(0);Yi[f[(f[a>>2]|0)+28>>2]&4095](a);if(g&(b[a+39>>0]|0)!=0){g=f[a+100>>2]|0;h=f[a+112>>2]|0;i=g+(h>>>12<<2)|0;if((f[a+104>>2]|0)==(g|0)){j=0;k=0;l=g+((h+(f[a+116>>2]|0)|0)>>>12<<2)|0}else{m=h+(f[a+116>>2]|0)|0;n=g+(m>>>12<<2)|0;j=(f[n>>2]|0)+(m&4095)|0;k=(f[i>>2]|0)+(h&4095)|0;l=n};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;n=i;h=j;m=k;if((h|0)==(m|0)){b[e+11>>0]=0;o=e}else{g=(l-n<<10)-k+j-(f[l>>2]|0)+(f[i>>2]|0)|0;if(g>>>0>4294967279)jYc(e);if(g>>>0<11){b[e+11>>0]=g;p=e;q=m;r=n;s=k}else{i=g+16&-16;l=$Xc(i)|0;f[e>>2]=l;f[e+8>>2]=i|-2147483648;f[e+4>>2]=g;p=l;q=m;r=n;s=k}while(1){b[p>>0]=b[q>>0]|0;k=s+1|0;n=k;if((n-(f[r>>2]|0)|0)==4096){m=r+4|0;l=f[m>>2]|0;t=l;v=m;w=l}else{t=k;v=r;w=n}n=p+1|0;if((t|0)==(h|0)){o=n;break}else{p=n;q=t;r=v;s=w}}}b[o>>0]=0;o=c+11|0;if((b[o>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[o>>0]=0}sYc(c,0);f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2]}z3(a);u=d;return}function y3(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c;if(!(b[a+38>>0]|0)){b[d+11>>0]=10;e=d;g=243584;h=e+10|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+10>>0]=0;vM(-215,d,250401,243595,975)}i=a+76|0;j=f[i>>2]|0;if(!j){k=$Xc(32)|0;f[d>>2]=k;f[d+8>>2]=-2147483616;f[d+4>>2]=20;e=k;g=243668;h=e+20|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[k+20>>0]=0;vM(-215,d,250401,243595,976)}d=a+72|0;k=f[d>>2]|0;g=j+-1+k|0;e=a+60|0;h=f[e>>2]|0;l=f[h+(((g>>>0)/204|0)<<2)>>2]|0;m=(g>>>0)%204|0;g=l+(m*20|0)|0;if((f[a+40>>2]|0)==24?(j>>>0>1?(f[l+(m*20|0)+12>>2]&8|0)==0:0):0){n=j+-2+k|0;f[l+(m*20|0)+16>>2]=f[(f[h+(((n>>>0)/204|0)<<2)>>2]|0)+(((n>>>0)%204|0)*20|0)+16>>2]}n=f[a+120>>2]|0;mi[f[(f[n>>2]|0)+12>>2]&2047](n,g);g=f[i>>2]|0;n=f[d>>2]|0;h=g+-1+n|0;m=f[e>>2]|0;l=(f[m+(((h>>>0)/204|0)<<2)>>2]|0)+(((h>>>0)%204|0)*20|0)|0;if((b[l+11>>0]|0)<0){cYc(f[l>>2]|0);o=f[i>>2]|0;p=f[e>>2]|0;q=f[d>>2]|0}else{o=g;p=m;q=n}n=o+-1|0;f[i>>2]=n;m=a+64|0;a=f[m>>2]|0;g=a-p>>2;if((1-o-q+((g|0)==0?0:(g*204|0)+-1|0)|0)>>>0>407){cYc(f[a+-4>>2]|0);f[m>>2]=(f[m>>2]|0)+-4;r=f[i>>2]|0}else r=n;if(!r){u=c;return}n=r+-1+(f[d>>2]|0)|0;d=(f[(f[e>>2]|0)+(((n>>>0)/204|0)<<2)>>2]|0)+(((n>>>0)%204|0)*20|0)+12|0;f[d>>2]=f[d>>2]&-17;u=c;return}function z3(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+80>>2]|0;d=a+84|0;if((f[d>>2]|0)!=(c|0))f[d>>2]=c;f[a+92>>2]=0;c=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;b[a+24>>0]=1;c=f[a+272>>2]|0;d=a+276|0;if((f[d>>2]|0)!=(c|0))f[d>>2]=c;f[a+284>>2]=0;f[a+292>>2]=0;f[a+288>>2]=0;c=f[a+188>>2]|0;d=a+192|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~(((e+-12-c|0)>>>0)/12|0)*12|0);c=f[a+200>>2]|0;e=a+204|0;d=f[e>>2]|0;if((d|0)!=(c|0)){g=d;while(1){d=g+-8|0;f[e>>2]=d;h=f[g+-4>>2]|0;if(!h)i=d;else{UXc(h);i=f[e>>2]|0}if((i|0)==(c|0))break;else g=i}}i=f[a+212>>2]|0;g=a+216|0;c=f[g>>2]|0;if((c|0)!=(i|0))f[g>>2]=c+(~((c+-4-i|0)>>>2)<<2);i=f[a+224>>2]|0;c=a+228|0;g=f[c>>2]|0;if((g|0)!=(i|0))f[c>>2]=g+(~((g+-4-i|0)>>>2)<<2);f[a+236>>2]=0;i=a+252|0;if(f[i>>2]|0){g=a+248|0;c=f[g>>2]|0;if(c|0){e=c;do{c=e;e=f[e>>2]|0;h=c+8|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(c)}while((e|0)!=0)}f[g>>2]=0;g=f[a+244>>2]|0;if(g|0){e=a+240|0;c=0;do{f[(f[e>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(g|0))}f[i>>2]=0}i=a+260|0;g=f[i>>2]|0;c=a+264|0;e=f[c>>2]|0;h=g;if((e|0)==(g|0))j=e;else{f[c>>2]=g;j=h}switch(j-h|0){case 0:{A3(i,1);k=f[i>>2]|0;break}case 1:{k=g;break}default:{i=g+1|0;if((j|0)==(i|0))k=g;else{f[c>>2]=i;k=g}}}b[k>>0]=0;k=a+8|0;g=k+11|0;if((b[g>>0]|0)<0){b[f[k>>2]>>0]=0;f[a+12>>2]=0;l=a+296|0;f[l>>2]=0;return}else{b[k>>0]=0;b[g>>0]=0;l=a+296|0;f[l>>2]=0;return}}function A3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if((e-h|0)>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;j=(f[g>>2]|0)+1|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i|0;h=j+c|0;if((h|0)<0)kWc(a);k=e-i|0;i=k<<1;e=k>>>0<1073741823?(i>>>0<h>>>0?h:i):2147483647;if(!e)l=0;else l=$Xc(e)|0;i=l+j|0;j=l+e|0;e=c;c=i;l=i;do{b[l>>0]=0;l=c+1|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(0-l)|0;if((l|0)>0)o1c(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;cYc(e);return}function B3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0;g=u;u=u+1200|0;i=g;j=g+80|0;k=g+68|0;l=g+56|0;m=g+1184|0;n=g+44|0;o=g+32|0;p=g+8|0;q=d&-65;r=a+36|0;s=a+38|0;if(b[r>>0]|0){a:do if(b[s>>0]|0){t=a+76|0;if((f[t>>2]|0)>>>0>1)do y3(a);while((f[t>>2]|0)>>>0>1);_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0;switch(f[a+40>>2]|0){case 8:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,243565);break a;break}case 24:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,505406);break a;break}default:break a}}while(0);Yi[f[(f[a>>2]|0)+28>>2]&4095](a);z3(a)}t=d&3;v=(t|0)==2;w=a+39|0;b[w>>0]=d>>>2&1;b[s>>0]=(t|0)!=0&1;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=dJc(c)|0;if(d>>>0>4294967279)jYc(j);if(d>>>0<11){b[j+11>>0]=d;if(!d)x=j;else{y=j;z=14}}else{A=d+16&-16;B=$Xc(A)|0;f[j>>2]=B;f[j+8>>2]=A|-2147483648;f[j+4>>2]=d;y=B;z=14}if((z|0)==14){o1c(y|0,c|0,d|0)|0;x=y}b[x+d>>0]=0;C3(a,j,l);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);d=f[l>>2]|0;x=a+8|0;if((d|0)!=(f[t>>2]|0))oYc(x,d)|0;d=x+11|0;y=b[d>>0]|0;B=y<<24>>24<0;if(B)C=f[a+12>>2]|0;else C=y&255;A=b[w>>0]|0;D=A<<24>>24!=0;if(!((C|0)!=0|D)?(b[s>>0]|0)==0:0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;C=$Xc(32)|0;f[j>>2]=C;f[j+8>>2]=-2147483616;f[j+4>>2]=22;E=C;F=243689;G=E+22|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[C+22>>0]=0;vM(-27,j,243712,243595,482)}if(v&D){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;D=$Xc(80)|0;f[j>>2]=D;f[j+8>>2]=-2147483568;f[j+4>>2]=72;E=D;F=243717;G=E+72|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[D+72>>0]=0;vM(-206,j,243712,243595,485)}D=a+20|0;f[D>>2]=q;b:do if(!(A<<24>>24)){if(B)H=f[a+8>>2]|0;else H=x;q=XKc(H,46)|0;do if((q|0?(b[q+1>>0]|0)==103:0)?(b[q+2>>0]|0)==122:0){C=q+3|0;I=b[C>>0]|0;J=I<<24>>24==0;if(!J){if((I+-48&255)>=10)break;if(b[q+4>>0]|0)break}if(v){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;K=$Xc(64)|0;f[j>>2]=K;f[j+8>>2]=-2147483584;f[j+4>>2]=52;E=K;F=243790;G=E+52|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[K+52>>0]=0;vM(-213,j,243712,243595,499)}if(J){L=0;M=y}else{b[C>>0]=0;L=I;M=b[d>>0]|0}b[j>>0]=b[s>>0]|0?119:114;b[j+1>>0]=98;b[j+2>>0]=L<<24>>24?L:51;b[j+3>>0]=0;if(M<<24>>24<0)N=f[a+8>>2]|0;else N=x;O=mHc(N,j)|0;f[a+32>>2]=O;if(!O){P=0;break b}else{Q=1;z=49;break b}}while(0);if(B)R=f[a+8>>2]|0;else R=x;q=iKc(R,(b[s>>0]|0)==0?243850:v?243843:243847)|0;f[a+28>>2]=q;if(!q)P=0;else{Q=0;z=49}}else{Q=0;z=49}while(0);do if((z|0)==49){R=a+188|0;B=f[R>>2]|0;N=a+192|0;M=f[N>>2]|0;if((M|0)!=(B|0))f[N>>2]=M+(~(((M+-12-B|0)>>>0)/12|0)*12|0);B=f[a+200>>2]|0;M=a+204|0;L=f[M>>2]|0;if((L|0)!=(B|0)){y=L;while(1){L=y+-8|0;f[M>>2]=L;H=f[y+-4>>2]|0;if(!H)S=L;else{UXc(H);S=f[M>>2]|0}if((S|0)==(B|0))break;else y=S}}f[a+52>>2]=71;y=a+40|0;f[y>>2]=0;B=(b[w>>0]|0)!=0;if(!(b[s>>0]|0)){if(B){f[a+284>>2]=c;M=dJc(c)|0;f[a+288>>2]=M}F3(a,m,14)|0;if((b[m>>0]|0)==-17?(b[m+1>>0]|0)==-69:0)T=(b[m+2>>0]|0)==-65?m+3|0:m;else T=m;M=T-m|0;if(NJc(T,249211,5)|0)if((b[T>>0]|0)!=123)if(NJc(T,247886,5)|0)if((f[a+288>>2]|0)==(M|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;H=$Xc(32)|0;f[j>>2]=H;f[j+8>>2]=-2147483616;f[j+4>>2]=19;E=H;F=244252;G=E+19|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[H+19>>0]=0;vM(-49,j,243712,243595,722)}else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;L=$Xc(32)|0;f[j>>2]=L;f[j+8>>2]=-2147483616;f[j+4>>2]=31;E=L;F=244272;G=E+31|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[L+31>>0]=0;vM(-49,j,243712,243595,724)}else U=8;else U=24;else U=16;f[y>>2]=U;if(Q)V=1048576;else{if(!(b[w>>0]|0)){H=a+28|0;NKc(f[H>>2]|0,0,2)|0;W=LLc(f[H>>2]|0)|0}else W=f[a+288>>2]|0;H=W>>>0<1048576?W:1048576;V=H>>>0>25600?H:25600}Yi[f[(f[a>>2]|0)+32>>2]&4095](a);f[a+292>>2]=M;H=a+80|0;A=V+256|0;q=a+88|0;O=f[H>>2]|0;X=O;Y=a+84|0;do if(((f[q>>2]|0)-O|0)>>>0<A>>>0){Z=(f[Y>>2]|0)-O|0;_=$Xc(A)|0;$=_+Z|0;aa=$+(0-Z)|0;ba=aa;if((Z|0)>0)o1c(aa|0,X|0,Z|0)|0;f[H>>2]=ba;f[Y>>2]=$;f[q>>2]=_+A;if(!O){ca=ba;break}cYc(X);ca=f[H>>2]|0}else ca=O;while(0);O=f[Y>>2]|0;X=O-ca|0;A=ca;M=O;do if(V>>>0>X>>>0)A3(H,V-X|0);else{if(V>>>0>=X>>>0)break;O=A+V|0;if((M|0)==(O|0))break;f[Y>>2]=O}while(0);M=a+92|0;f[M>>2]=0;A=_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0;b[A+2>>0]=0;b[A+1>>0]=0;b[A>>0]=0;X=a+4|0;f[n>>2]=f[X>>2];f[n+4>>2]=0;f[n+8>>2]=0;O=G3(a,n,9)|0;b[O>>0]=4;b[O+1>>0]=4;L=O+2|0;b[L>>0]=0;b[L+1>>0]=0;b[L+2>>0]=0;b[L+3>>0]=0;b[L+4>>0]=0;b[L+5>>0]=0;b[L+6>>0]=0;L=f[R>>2]|0;O=f[N>>2]|0;if((O|0)!=(L|0))f[N>>2]=O+(~(((O+-12-L|0)>>>0)/12|0)*12|0);c:do switch(f[y>>2]|0){case 8:{e6(j,a);L=f[j>>2]|0;O=j+4|0;ba=f[O>>2]|0;if(ba|0)TXc(ba);f[a+128>>2]=L;L=a+132|0;_=f[L>>2]|0;f[L>>2]=ba;if(_|0)UXc(_);_=f[O>>2]|0;if(_|0)UXc(_);break}case 16:{E6(j,a);_=f[j>>2]|0;O=j+4|0;ba=f[O>>2]|0;if(ba|0)TXc(ba);f[a+128>>2]=_;_=a+132|0;L=f[_>>2]|0;f[_>>2]=ba;if(L|0)UXc(L);L=f[O>>2]|0;if(L|0)UXc(L);break}case 24:{baa(j,a);L=f[j>>2]|0;O=j+4|0;ba=f[O>>2]|0;if(ba|0)TXc(ba);f[a+128>>2]=L;L=a+132|0;_=f[L>>2]|0;f[L>>2]=ba;if(_|0)UXc(_);_=f[O>>2]|0;if(_|0)UXc(_);break}default:{f[a+128>>2]=0;_=a+132|0;O=f[_>>2]|0;f[_>>2]=0;if(!O)break c;UXc(O)}}while(0);O=f[a+128>>2]|0;do if(!O)da=1;else{if(!(Mi[f[(f[O>>2]|0)+8>>2]&1023](O,A)|0)){da=0;break}mi[f[(f[a>>2]|0)+80>>2]&2047](a,n);if((f[a+212>>2]|0)==(f[a+216>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;_=$Xc(32)|0;f[j>>2]=_;f[j+8>>2]=-2147483616;f[j+4>>2]=21;E=_;F=244304;G=E+21|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[_+21>>0]=0;vM(-215,j,243712,243595,773)}I=f[X>>2]|0;f[o>>2]=I;f[o+4>>2]=0;f[o+8>>2]=0;do if(I){C=H3(f[I+20>>2]|0,0,0)|0;if(!C){ea=0;break}J=h[C>>0]|0;K=J&7;if((K|1|0)==5){ba=(J&32|0)==0?C:C+4|0;ea=h[ba+6>>0]<<8|h[ba+5>>0]|h[ba+7>>0]<<16|h[ba+8>>0]<<24;break}else{ea=(K|0)!=0&1;break}}else ea=0;while(0);I3(p,o,0);d:do if(ea|0){I=p+20|0;_=p+16|0;K=p+4|0;ba=p+8|0;C=j+4|0;J=j+8|0;L=a+196|0;$=k+4|0;Z=k+8|0;aa=p+12|0;fa=0;e:while(1){ga=(f[I>>2]|0)>>>0<(f[_>>2]|0)>>>0?f[p>>2]|0:0;ha=f[K>>2]|0;ia=f[ba>>2]|0;f[j>>2]=ga;f[C>>2]=ha;f[J>>2]=ia;ja=f[N>>2]|0;if(ja>>>0<(f[L>>2]|0)>>>0){f[ja>>2]=ga;f[ja+4>>2]=ha;f[ja+8>>2]=ia;f[N>>2]=ja+12}else J3(R,j);fa=fa+1|0;ja=f[I>>2]|0;do if((ja|0)!=(f[_>>2]|0)){ia=f[p>>2]|0;if(!ia)break;f[I>>2]=ja+1;ha=f[K>>2]|0;ga=f[ba>>2]|0;f[k>>2]=ia;f[$>>2]=ha;f[Z>>2]=ga;ga=K3(k)|0;ha=(f[ba>>2]|0)+ga|0;f[ba>>2]=ha;if(ha>>>0>=(f[aa>>2]|0)>>>0){ga=f[(f[p>>2]|0)+20>>2]|0;ia=f[K>>2]|0;ka=f[ga+224>>2]|0;la=f[ka+(ia<<2)>>2]|0;f:do if(ha>>>0<la>>>0)ma=la;else{na=((f[ga+228>>2]|0)-ka>>2)+-1|0;oa=ia;pa=ha;qa=la;while(1){if((oa|0)==(na|0))break;ra=pa-qa|0;f[ba>>2]=ra;oa=oa+1|0;f[K>>2]=oa;sa=f[ka+(oa<<2)>>2]|0;if(ra>>>0<sa>>>0){ma=sa;break f}else{pa=ra;qa=sa}}if((pa|0)!=(qa|0))break e;ma=f[ka+(na<<2)>>2]|0}while(0);f[aa>>2]=ma}}while(0);if(fa>>>0>=ea>>>0)break d}fa=$Xc(32)|0;f[j>>2]=fa;f[j+8>>2]=-2147483616;f[j+4>>2]=30;E=fa;F=244326;G=E+30|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[fa+30>>0]=0;vM(-215,j,244357,243595,1459)}while(0);da=1}while(0);Yi[f[(f[a>>2]|0)+28>>2]&4095](a);b[r>>0]=1;R=f[H>>2]|0;f[H>>2]=0;f[Y>>2]=0;f[q>>2]=0;f[M>>2]=0;if(R|0)cYc(R);P=da;break}R=f[D>>2]&56;f[y>>2]=R;if(B){N=a+100|0;X=f[N>>2]|0;A=a+112|0;O=f[A>>2]|0;aa=X+(O>>>12<<2)|0;K=a+104|0;ba=f[K>>2]|0;Z=ba;$=X;if((ba|0)==(X|0)){ta=0;ua=a+116|0;va=0}else{ba=a+116|0;I=(f[ba>>2]|0)+O|0;ta=(f[X+(I>>>12<<2)>>2]|0)+(I&4095)|0;ua=ba;va=(f[aa>>2]|0)+(O&4095)|0}O=aa;aa=va;g:while(1){ba=aa;do{I=ba;if((I|0)==(ta|0))break g;ba=I+1|0}while((ba-(f[O>>2]|0)|0)!=4096);ba=O+4|0;O=ba;aa=f[ba>>2]|0}f[ua>>2]=0;aa=Z-$>>2;if(aa>>>0>2){O=X;do{cYc(f[O>>2]|0);O=(f[N>>2]|0)+4|0;f[N>>2]=O;B=(f[K>>2]|0)-O>>2}while(B>>>0>2);wa=B}else wa=aa;switch(wa|0){case 1:{xa=2048;z=69;break}case 2:{xa=4096;z=69;break}default:{}}if((z|0)==69)f[A>>2]=xa;ya=f[y>>2]|0}else ya=R;if(!ya){O=b[d>>0]|0;K=O<<24>>24<0;if(K)za=f[a+12>>2]|0;else za=O&255;h:do if(!za)Aa=8;else{if(K){Ba=0;Ca=0;Da=f[a+8>>2]|0}else{Ba=0;Ca=0;Da=x}i:while(1){switch(b[Da>>0]|0){case 0:{break i;break}case 46:{Ea=Da;Fa=Ba;break}default:{Ea=Ba;Fa=Ca}}Ba=Ea;Ca=Fa;Da=Da+1|0}O=(Ba|0)==0?1165591:Ba;N=dJc(O)|0;X=N>>>0>3;$=X?3:N;j:do if(!$)z=83;else{Z=0;while(1){B=OIc(b[O+Z>>0]|0)|0;M=B-(OIc(b[243853+Z>>0]|0)|0)|0;Z=Z+1|0;if(M|0){Ga=M;break j}if(Z>>>0>=$>>>0){z=83;break}}}while(0);if((z|0)==83)Ga=N>>>0<3?-1:X&1;$=(Ca|0)!=0&(Ga|0)==0?Ca:Ba;O=($|0)==0?1165591:$;$=dJc(O)|0;Z=$>>>0>4;fa=Z?4:$;k:do if(!fa)z=89;else{M=0;while(1){B=OIc(b[O+M>>0]|0)|0;if((B|0)!=(OIc(b[243857+M>>0]|0)|0))break k;M=M+1|0;if(M>>>0>=fa>>>0){z=89;break}}}while(0);if((z|0)==89?$>>>0>3&(Z^1):0){Aa=8;break}fa=dJc(O)|0;X=fa>>>0>7;N=X?7:fa;l:do if(!N)z=93;else{M=0;while(1){B=OIc(b[O+M>>0]|0)|0;if((B|0)!=(OIc(b[243862+M>>0]|0)|0))break l;M=M+1|0;if(M>>>0>=N>>>0){z=93;break}}}while(0);if((z|0)==93?fa>>>0>6&(X^1):0){Aa=8;break}N=dJc(O)|0;Z=N>>>0>5;$=Z?5:N;m:do if(!$)z=97;else{M=0;while(1){B=OIc(b[O+M>>0]|0)|0;if((B|0)!=(OIc(b[243870+M>>0]|0)|0)){z=98;break m}M=M+1|0;if(M>>>0>=$>>>0){z=97;break}}}while(0);if((z|0)==97?!(N>>>0>4&(Z^1)):0)z=98;if((z|0)==98){$=dJc(O)|0;X=$>>>0>8;fa=X?8:$;if(fa|0){M=0;do{B=OIc(b[O+M>>0]|0)|0;if((B|0)!=(OIc(b[243876+M>>0]|0)|0)){Aa=16;break h}M=M+1|0}while(M>>>0<fa>>>0)}if(!($>>>0>7&(X^1))){Aa=16;break}}Aa=24}while(0);f[y>>2]=Aa;Ha=Aa}else Ha=ya;K=(Ha|0)==8?25600:17408;if(v){R=a+28|0;NKc(f[R>>2]|0,0,2)|0;Ia=(LLc(f[R>>2]|0)|0)!=0}else Ia=0;R=a+56|0;D3(R);b[a+24>>0]=1;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;oYc(j,k)|0;A=j+12|0;f[A>>2]=21;f[j+16>>2]=0;aa=a+64|0;fa=f[aa>>2]|0;M=a+60|0;O=f[M>>2]|0;Z=fa-O>>2;N=a+72|0;B=f[N>>2]|0;q=a+76|0;Y=f[q>>2]|0;if((((Z|0)==0?0:(Z*204|0)+-1|0)|0)==(Y+B|0)){E3(R);Ja=f[N>>2]|0;Ka=f[q>>2]|0;La=f[aa>>2]|0;Ma=f[M>>2]|0}else{Ja=B;Ka=Y;La=fa;Ma=O}O=Ka+Ja|0;if((La|0)==(Ma|0))Na=0;else Na=(f[Ma+(((O>>>0)/204|0)<<2)>>2]|0)+(((O>>>0)%204|0)*20|0)|0;f[Na>>2]=f[j>>2];f[Na+4>>2]=f[j+4>>2];f[Na+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;O=A;A=f[O+4>>2]|0;fa=Na+12|0;f[fa>>2]=f[O>>2];f[fa+4>>2]=A;f[q>>2]=(f[q>>2]|0)+1;if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);A=a+80|0;fa=K+1024|0;O=a+88|0;Y=f[A>>2]|0;B=Y;aa=a+84|0;do if(((f[O>>2]|0)-Y|0)>>>0<fa>>>0){R=(f[aa>>2]|0)-Y|0;Z=$Xc(fa)|0;H=Z+R|0;ba=H+(0-R)|0;I=ba;if((R|0)>0)o1c(ba|0,B|0,R|0)|0;f[A>>2]=I;f[aa>>2]=H;f[O>>2]=Z+fa;if(!Y){Oa=I;break}cYc(B);Oa=f[A>>2]|0}else Oa=Y;while(0);Y=f[aa>>2]|0;B=Y-Oa|0;fa=Oa;O=Y;do if(K>>>0>B>>>0)A3(A,K-B|0);else{if(K>>>0>=B>>>0)break;Y=fa+K|0;if((O|0)==(Y|0))break;f[aa>>2]=Y}while(0);f[a+92>>2]=0;switch(f[y>>2]|0){case 8:{aa=a+28|0;O=f[aa>>2]|0;do if(O){K=LLc(O)|0;if((K|0)==0|Ia^1){z=125;break}fa=(K|0)<1024?K:1024;NKc(f[aa>>2]|0,0-fa|0,2)|0;K=fa+2|0;f[j>>2]=0;B=j+4|0;f[B>>2]=0;f[j+8>>2]=0;if(!K)Pa=-1;else{if((fa|0)<-2)kWc(j);A=$Xc(K)|0;f[B>>2]=A;f[j>>2]=A;f[j+8>>2]=A+K;Y=K;K=A;do{b[K>>0]=0;K=(f[B>>2]|0)+1|0;f[B>>2]=K;Y=Y+-1|0}while((Y|0)!=0);Pa=-1}n:while(1){while(1){Qa=LLc(f[aa>>2]|0)|0;Ra=F3(a,f[j>>2]|0,fa)|0;if(!Ra)break n;Y=RKc(Ra,244052)|0;if(Y|0){Sa=Y;break}}while(1){Y=RKc(Sa+17|0,244052)|0;if(!Y)break;else Sa=Y}Pa=Qa-Ra+Sa|0}if((Pa|0)<0){if(!(b[r>>0]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;Ta=$Xc(64)|0;f[k>>2]=Ta;Ua=k+8|0;f[Ua>>2]=-2147483584;Va=k+4|0;f[Va>>2]=53;E=Ta;F=244070;G=E+53|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));Wa=Ta+53|0;b[Wa>>0]=0;vM(-2,k,243712,243595,634)}o:do if(b[s>>0]|0){if((f[q>>2]|0)>>>0>1)do y3(a);while((f[q>>2]|0)>>>0>1);_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0;switch(f[y>>2]|0){case 8:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,243565);break o;break}case 24:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,505406);break o;break}default:break o}}while(0);Yi[f[(f[a>>2]|0)+28>>2]&4095](a);z3(a);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;Ta=$Xc(64)|0;f[k>>2]=Ta;Ua=k+8|0;f[Ua>>2]=-2147483584;Va=k+4|0;f[Va>>2]=53;E=Ta;F=244070;G=E+53|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));Wa=Ta+53|0;b[Wa>>0]=0;vM(-2,k,243712,243595,634)}else{Yi[f[(f[a>>2]|0)+28>>2]&4095](a);if((b[d>>0]|0)<0)Xa=f[a+8>>2]|0;else Xa=x;fa=iKc(Xa,244124)|0;f[aa>>2]=fa;if(!fa){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=9;E=k;F=244128;G=E+9|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[k+9>>0]=0;vM(-215,k,243712,243595,638)}NKc(fa,Pa,0)|0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,244138);NKc(f[aa>>2]|0,0,2)|0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,505563);Y=f[j>>2]|0;if(Y|0){if((f[B>>2]|0)!=(Y|0))f[B>>2]=Y;cYc(Y)}break}}else z=125;while(0);if((z|0)==125){do if(e){aa=b[e>>0]|0;if(!(aa<<24>>24)){z=144;break}O=dJc(e)|0;Y=O>>>0>6;K=Y?6:O;p:do if(!K)z=131;else{X=OIc(aa<<24>>24)|0;if((X|0)==(OIc(85)|0))Ya=1;else break;while(1){if(Ya>>>0>=K>>>0){z=131;break p}X=OIc(b[e+Ya>>0]|0)|0;if((X|0)==(OIc(b[243885+Ya>>0]|0)|0))Ya=Ya+1|0;else break}}while(0);do if((z|0)==131){if(!(O>>>0>5&(Y^1)))break;if(!(b[r>>0]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Za=$Xc(64)|0;f[j>>2]=Za;_a=j+8|0;f[_a>>2]=-2147483584;$a=j+4|0;f[$a>>2]=57;E=Za;F=243892;G=E+57|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));ab=Za+57|0;b[ab>>0]=0;vM(-5,j,243712,243595,594)}q:do if(b[s>>0]|0){if((f[q>>2]|0)>>>0>1)do y3(a);while((f[q>>2]|0)>>>0>1);_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0;switch(f[y>>2]|0){case 8:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,243565);break q;break}case 24:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,505406);break q;break}default:break q}}while(0);Yi[f[(f[a>>2]|0)+28>>2]&4095](a);z3(a);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Za=$Xc(64)|0;f[j>>2]=Za;_a=j+8|0;f[_a>>2]=-2147483584;$a=j+4|0;f[$a>>2]=57;E=Za;F=243892;G=E+57|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));ab=Za+57|0;b[ab>>0]=0;vM(-5,j,243712,243595,594)}while(0);if((dJc(e)|0)>>>0<1e3){f[i>>2]=e;cLc(j,243974,i)|0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,j);bb=a;break}else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Y=$Xc(32)|0;f[j>>2]=Y;f[j+8>>2]=-2147483616;f[j+4>>2]=23;E=Y;F=243950;G=E+23|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[Y+23>>0]=0;vM(-215,j,243712,243595,597)}}else z=144;while(0);if((z|0)==144){mi[f[(f[a>>2]|0)+12>>2]&2047](a,244011);bb=a}mi[f[(f[bb>>2]|0)+12>>2]&2047](a,244034)}Q5(j,a);y=f[j>>2]|0;O=j+4|0;K=f[O>>2]|0;if(K|0)TXc(K);f[a+120>>2]=y;y=a+124|0;aa=f[y>>2]|0;f[y>>2]=K;if(aa|0)UXc(aa);aa=f[O>>2]|0;if(aa|0)UXc(aa);break}case 16:{aa=f[(f[a>>2]|0)+12>>2]|0;if(Ia)mi[aa&2047](a,244171);else mi[aa&2047](a,244156);q6(j,a);aa=f[j>>2]|0;O=j+4|0;K=f[O>>2]|0;if(K|0)TXc(K);f[a+120>>2]=aa;aa=a+124|0;y=f[aa>>2]|0;f[aa>>2]=K;if(y|0)UXc(y);y=f[O>>2]|0;if(y|0)UXc(y);break}case 24:{do if(Ia){y=a+28|0;if(!(NKc(f[y>>2]|0,0,2)|0))cb=0;else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;db=$Xc(48)|0;f[j>>2]=db;eb=j+8|0;f[eb>>2]=-2147483600;fb=j+4|0;f[fb>>2]=39;E=db;F=244212;G=E+39|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));gb=db+39|0;b[gb>>0]=0;vM(-2,j,243712,243595,689)}while(1){if((MLc(f[y>>2]|0)|0)==125)break;Y=cb+-1|0;if(!(NKc(f[y>>2]|0,Y,2)|0))cb=Y;else{z=205;break}}if((z|0)==205){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;db=$Xc(48)|0;f[j>>2]=db;eb=j+8|0;f[eb>>2]=-2147483600;fb=j+4|0;f[fb>>2]=39;E=db;F=244212;G=E+39|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));gb=db+39|0;b[gb>>0]=0;vM(-2,j,243712,243595,689)}NKc(f[y>>2]|0,cb,2)|0;Yi[f[(f[a>>2]|0)+28>>2]&4095](a);if((b[d>>0]|0)<0)hb=f[a+8>>2]|0;else hb=x;Y=iKc(hb,244124)|0;f[y>>2]=Y;if(!Y){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=9;E=j;F=244128;G=E+9|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[j+9>>0]=0;vM(-215,j,243712,243595,683)}else{NKc(Y,cb,2)|0;ILc(44,f[y>>2]|0)|0;break}}else mi[f[(f[a>>2]|0)+12>>2]&2047](a,484824);while(0);O=(f[q>>2]|0)+-1+(f[N>>2]|0)|0;f[(f[(f[M>>2]|0)+(((O>>>0)/204|0)<<2)>>2]|0)+(((O>>>0)%204|0)*20|0)+16>>2]=4;P9(j,a);O=f[j>>2]|0;K=j+4|0;aa=f[K>>2]|0;if(aa|0)TXc(aa);f[a+120>>2]=O;O=a+124|0;B=f[O>>2]|0;f[O>>2]=aa;if(B|0)UXc(B);B=f[K>>2]|0;if(B|0)UXc(B);break}default:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;B=$Xc(32)|0;f[j>>2]=B;f[j+8>>2]=-2147483616;f[j+4>>2]=31;E=B;F=244180;G=E+31|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[B+31>>0]=0;vM(-215,j,243712,243595,659)}}b[r>>0]=1;P=1}while(0);r=f[l>>2]|0;if(!r){u=g;return P|0}j=f[t>>2]|0;if((j|0)==(r|0))ib=r;else{F=j;while(1){j=F+-12|0;f[t>>2]=j;if((b[j+11>>0]|0)<0){cYc(f[j>>2]|0);jb=f[t>>2]|0}else jb=j;if((jb|0)==(r|0))break;else F=jb}ib=f[l>>2]|0}cYc(ib);u=g;return P|0}function C3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+16|0;e=a;g=f[d>>2]|0;h=d+4|0;i=f[h>>2]|0;if((i|0)!=(g|0)){j=i;while(1){i=j+-12|0;f[h>>2]=i;if((b[i+11>>0]|0)<0){cYc(f[i>>2]|0);k=f[h>>2]|0}else k=i;if((k|0)==(g|0))break;else j=k}}if((JYc(c,10,0)|0)!=-1){u=a;return}k=KYc(c,63,-1)|0;mYc(e,c,0,k,c);j=f[h>>2]|0;g=d+8|0;if(j>>>0>=(f[g>>2]|0)>>>0){QA(d,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0)}else{f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[h>>2]=(f[h>>2]|0)+12}if((k|0)==-1){u=a;return}j=b[c+11>>0]|0;i=j<<24>>24<0?f[c+4>>2]|0:j&255;j=k+1|0;if(j>>>0>=i>>>0){u=a;return}k=e+11|0;l=j;while(1){j=JYc(c,38,l)|0;if((l+1|0)>>>0<i>>>0&((j|0)!=(l|0)|(j|0)==-1)){mYc(e,c,l,j-l|0,c);m=f[h>>2]|0;if(m>>>0>=(f[g>>2]|0)>>>0){QA(d,e);if((b[k>>0]|0)<0)cYc(f[e>>2]|0)}else{f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[h>>2]=(f[h>>2]|0)+12}}if(j>>>0<i>>>0)l=j+1|0;else break}u=a;return}function D3(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=a+16|0;g=f[e>>2]|0;h=d+(((g>>>0)/204|0)<<2)|0;i=a+8|0;if((f[i>>2]|0)==(d|0)){j=0;k=a+20|0;l=0}else{m=a+20|0;a=g+(f[m>>2]|0)|0;j=(f[d+(((a>>>0)/204|0)<<2)>>2]|0)+(((a>>>0)%204|0)*20|0)|0;k=m;l=(f[h>>2]|0)+(((g>>>0)%204|0)*20|0)|0}g=h;h=l;a:while(1){l=h;do{m=l;if((m|0)==(j|0))break a;if((b[l+11>>0]|0)<0)cYc(f[m>>2]|0);l=m+20|0}while((l-(f[g>>2]|0)|0)!=4080);l=g+4|0;g=l;h=f[l>>2]|0}f[k>>2]=0;k=f[c>>2]|0;h=(f[i>>2]|0)-k>>2;if(h>>>0>2){g=k;do{cYc(f[g>>2]|0);k=(f[c>>2]|0)+4|0;f[c>>2]=k;g=k;k=(f[i>>2]|0)-g>>2}while(k>>>0>2);n=k}else n=h;switch(n|0){case 1:{o=102;break}case 2:{o=204;break}default:return}f[e>>2]=o;return}function E3(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=u;u=u+32|0;c=b+4|0;d=b;e=a+16|0;g=f[e>>2]|0;if(g>>>0>203){f[e>>2]=g+-204;g=a+4|0;e=f[g>>2]|0;h=f[e>>2]|0;i=e+4|0;f[g>>2]=i;e=a+8|0;j=f[e>>2]|0;k=a+12|0;l=f[k>>2]|0;m=l;n=j;do if((j|0)==(l|0)){o=f[a>>2]|0;p=o;if(i>>>0>o>>>0){q=i;r=((q-p>>2)+1|0)/-2|0;s=i+(r<<2)|0;t=n-q|0;q=t>>2;if(!q)v=i;else{q1c(s|0,i|0,t|0)|0;v=f[g>>2]|0}t=s+(q<<2)|0;f[e>>2]=t;f[g>>2]=v+(r<<2);w=t;break}t=m-p>>1;p=(t|0)==0?1:t;if(p>>>0>1073741823){t=af(8)|0;hYc(t,512536);f[t>>2]=192348;ig(t|0,25336,2140)}t=$Xc(p<<2)|0;r=t;q=t+(p>>>2<<2)|0;s=q;x=t+(p<<2)|0;if((i|0)==(j|0)){y=s;z=o}else{o=q;q=s;p=i;do{f[o>>2]=f[p>>2];o=q+4|0;q=o;p=p+4|0}while((p|0)!=(j|0));y=q;z=f[a>>2]|0}f[a>>2]=r;f[g>>2]=s;f[e>>2]=y;f[k>>2]=x;if(!z)w=y;else{cYc(z);w=f[e>>2]|0}}else w=j;while(0);f[w>>2]=h;f[e>>2]=(f[e>>2]|0)+4;u=b;return}e=a+8|0;h=f[e>>2]|0;w=a+4|0;j=h-(f[w>>2]|0)|0;z=a+12|0;y=f[z>>2]|0;k=y-(f[a>>2]|0)|0;if(j>>>0>=k>>>0){g=k>>1;k=(g|0)==0?1:g;f[c+12>>2]=0;f[c+16>>2]=a+12;if(k>>>0>1073741823){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=$Xc(k<<2)|0;f[c>>2]=g;i=g+(j>>2<<2)|0;j=c+8|0;f[j>>2]=i;m=c+4|0;f[m>>2]=i;i=c+12|0;f[i>>2]=g+(k<<2);k=$Xc(4080)|0;f[d>>2]=k;W3(c,d);d=f[e>>2]|0;while(1){A=f[w>>2]|0;if((d|0)==(A|0))break;k=d+-4|0;X3(c,k);d=k}k=A;A=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=A;f[w>>2]=f[m>>2];f[m>>2]=k;m=f[e>>2]|0;f[e>>2]=f[j>>2];f[j>>2]=m;g=f[z>>2]|0;f[z>>2]=f[i>>2];f[i>>2]=g;g=m;if((g|0)!=(d|0))f[j>>2]=g+(~((g+-4-k|0)>>>2)<<2);if(A|0)cYc(A);u=b;return}if((y|0)!=(h|0)){h=$Xc(4080)|0;f[c>>2]=h;U3(a,c);u=b;return}h=$Xc(4080)|0;f[c>>2]=h;V3(a,c);c=f[w>>2]|0;h=f[c>>2]|0;y=c+4|0;f[w>>2]=y;c=f[e>>2]|0;A=f[z>>2]|0;k=A;g=c;do if((c|0)==(A|0)){j=f[a>>2]|0;d=j;if(y>>>0>j>>>0){m=y;i=((m-d>>2)+1|0)/-2|0;v=y+(i<<2)|0;n=g-m|0;m=n>>2;if(!m)B=y;else{q1c(v|0,y|0,n|0)|0;B=f[w>>2]|0}n=v+(m<<2)|0;f[e>>2]=n;f[w>>2]=B+(i<<2);C=n;break}n=k-d>>1;d=(n|0)==0?1:n;if(d>>>0>1073741823){n=af(8)|0;hYc(n,512536);f[n>>2]=192348;ig(n|0,25336,2140)}n=$Xc(d<<2)|0;i=n;m=n+(d>>>2<<2)|0;v=m;l=n+(d<<2)|0;if((y|0)==(c|0)){D=v;E=j}else{j=m;m=v;d=y;do{f[j>>2]=f[d>>2];j=m+4|0;m=j;d=d+4|0}while((d|0)!=(c|0));D=m;E=f[a>>2]|0}f[a>>2]=i;f[w>>2]=v;f[e>>2]=D;f[z>>2]=l;if(!E)C=D;else{cYc(E);C=f[e>>2]|0}}else C=c;while(0);f[C>>2]=h;f[e>>2]=(f[e>>2]|0)+4;u=b;return}function F3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;h=f[a+284>>2]|0;if(h|0){i=a+292|0;j=f[a+288>>2]|0;k=d+-1|0;l=f[i>>2]|0;m=0;while(1){if(!((m|0)<(k|0)&l>>>0<j>>>0)){n=l;o=m;break}p=l+1|0;q=b[h+l>>0]|0;r=m+1|0;if(!(q<<24>>24)){n=p;o=m;break}b[c+m>>0]=q;if(q<<24>>24==10){n=p;o=r;break}else{l=p;m=r}}b[c+o>>0]=0;f[i>>2]=n;if((d|0)>256?!((o+1|0)<(k|0)?1:(f[a+20>>2]&64|0)!=0):0){k=$Xc(80)|0;f[g>>2]=k;f[g+8>>2]=-2147483568;f[g+4>>2]=72;s=k;t=244649;v=s+72|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[k+72>>0]=0;vM(-215,g,244722,243595,834)}w=(o|0)>0?c:0;u=e;return w|0}o=f[a+28>>2]|0;if(o|0){k=rKc(c,d,o)|0;if(!((d|0)>256&(k|0)!=0)){w=k;u=e;return w|0}if(f[a+20>>2]&64|0){w=k;u=e;return w|0}if((PJc(k,d)|0)>>>0<(d+-1|0)>>>0){w=k;u=e;return w|0}else{k=$Xc(96)|0;f[g>>2]=k;f[g+8>>2]=-2147483552;f[g+4>>2]=83;s=k;t=244727;v=s+83|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[k+83>>0]=0;vM(-215,g,244722,243595,843)}}k=f[a+32>>2]|0;if(!k){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=25;s=o;t=244811;v=s+25|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[o+25>>0]=0;vM(-2,g,244722,243595,859)}o=uHc(k,c,d)|0;if(!((d|0)>256&(o|0)!=0)){w=o;u=e;return w|0}if(f[a+20>>2]&64|0){w=o;u=e;return w|0}if((PJc(o,d)|0)>>>0<(d+-1|0)>>>0){w=o;u=e;return w|0}else{w=$Xc(96)|0;f[g>>2]=w;f[g+8>>2]=-2147483552;f[g+4>>2]=83;s=w;t=244727;v=s+83|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[w+83>>0]=0;vM(-215,g,244722,243595,854)}return 0}function G3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+32|0;g=e+12|0;h=e+8|0;i=e;j=a+212|0;k=f[j>>2]|0;l=a+216|0;m=f[l>>2]|0;if((k|0)==(m|0)){n=0;o=0}else{p=f[c+4>>2]|0;q=f[c+8>>2]|0;if((p|0)!=((m-k>>2)+-1|0)){m=$Xc(48)|0;f[g>>2]=m;f[g+8>>2]=-2147483600;f[g+4>>2]=33;r=m;s=244493;t=r+33|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[m+33>>0]=0;vM(-215,g,244527,243595,1319)}m=a+224|0;v=f[m>>2]|0;w=f[v+(p<<2)>>2]|0;if(q>>>0>w>>>0){x=$Xc(32)|0;f[g>>2]=x;f[g+8>>2]=-2147483616;f[g+4>>2]=30;r=x;s=244544;t=r+30|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[x+30>>0]=0;vM(-215,g,244527,243595,1320)}x=f[k+(p<<2)>>2]|0;k=x+q|0;s=x+w|0;if((k+d|0)>>>0<=s>>>0){f[a+236>>2]=q+d;y=k;u=e;return y|0}w=f[(f[a+200>>2]|0)+(p<<3)>>2]|0;x=w+4|0;r=f[x>>2]|0;t=f[w>>2]|0;z=r-t|0;A=t;t=r;if(q>>>0<=z>>>0)if(q>>>0<z>>>0?(r=A+q|0,(t|0)!=(r|0)):0){f[x>>2]=r;B=v}else B=v;else{zS(w,q-z|0);B=f[m>>2]|0}f[B+(p<<2)>>2]=q;n=k;o=s}f[h>>2]=(d>>>0>16128?d:16128)+256;M3(g,h);s=f[g>>2]|0;f[i>>2]=s;k=i+4|0;q=f[g+4>>2]|0;f[k>>2]=q;p=a+204|0;B=f[p>>2]|0;m=q;if((B|0)==(f[a+208>>2]|0))N3(a+200|0,i);else{f[B>>2]=s;f[B+4>>2]=m;if(!q)C=B;else{TXc(m);C=f[p>>2]|0}f[p>>2]=C+8}C=f[i>>2]|0;i=f[C>>2]|0;if((f[C+4>>2]|0)==(i|0))lWc(C);f[g>>2]=i;C=f[l>>2]|0;if((C|0)==(f[a+220>>2]|0))O3(j,g);else{f[C>>2]=i;f[l>>2]=(f[l>>2]|0)+4}i=a+228|0;C=f[i>>2]|0;if((C|0)==(f[a+232>>2]|0))P3(a+224|0,h);else{f[C>>2]=f[h>>2];f[i>>2]=C+4}f[c+4>>2]=((f[l>>2]|0)-(f[j>>2]|0)>>2)+-1;f[c+8>>2]=0;f[a+236>>2]=d;if(!((n|0)==0|(n+5|0)>>>0>o>>>0)?(b[f[g>>2]>>0]=b[n>>0]|0,b[n>>0]&32):0){b[(f[g>>2]|0)+1>>0]=b[n+1>>0]|0;b[(f[g>>2]|0)+2>>0]=b[n+2>>0]|0;b[(f[g>>2]|0)+3>>0]=b[n+3>>0]|0;b[(f[g>>2]|0)+4>>0]=b[n+4>>0]|0}n=f[g>>2]|0;g=f[k>>2]|0;if(g|0)UXc(g);y=n;u=e;return y|0}function H3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[a+212>>2]|0;i=h;if((f[a+216>>2]|0)-h>>2>>>0<=c>>>0){h=$Xc(32)|0;f[g>>2]=h;f[g+8>>2]=-2147483616;f[g+4>>2]=30;j=h;k=244421;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[h+30>>0]=0;vM(-215,g,244452,243595,1711)}if((f[(f[a+224>>2]|0)+(c<<2)>>2]|0)>>>0>d>>>0){u=e;return (f[i+(c<<2)>>2]|0)+d|0}else{d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=29;j=d;k=244463;l=j+29|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[d+29>>0]=0;vM(-215,g,244452,243595,1712)}return 0}function I3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=f[c>>2]|0;f[a>>2]=e;g=a+20|0;f[g>>2]=0;if(!e){i=a+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;return}i=c+4|0;j=f[i>>2]|0;k=a+4|0;f[k>>2]=j;l=c+8|0;m=f[l>>2]|0;n=a+8|0;f[n>>2]=m;o=H3(f[e+20>>2]|0,j,m)|0;if((o|0)!=0?(b[o>>0]&7)==4:0){p=1;q=8}else{o=f[c>>2]|0;if(o){m=H3(f[o+20>>2]|0,f[i>>2]|0,f[l>>2]|0)|0;if(!m){p=0;q=8}else{p=(b[m>>0]&7)==5;q=8}}else q=11}do if((q|0)==8){m=f[c>>2]|0;if(((m|0)!=0?(o=H3(f[m+20>>2]|0,f[i>>2]|0,f[l>>2]|0)|0,(o|0)!=0):0)?(b[o>>0]&7)!=0:0){if(!p){f[a+16>>2]=1;if(!d)break;f[g>>2]=1;o=K3(c)|0;f[n>>2]=(f[n>>2]|0)+o;break}o=f[c>>2]|0;do if((o|0)!=0?(m=H3(f[o+20>>2]|0,f[i>>2]|0,f[l>>2]|0)|0,(m|0)!=0):0){j=h[m>>0]|0;e=j&7;if((e|1|0)==5){r=(j&32|0)==0?m:m+4|0;s=(h[r+6>>0]|0)<<8|(h[r+5>>0]|0)|(h[r+7>>0]|0)<<16|(h[r+8>>0]|0)<<24;break}else{s=(e|0)!=0&1;break}}else s=0;while(0);o=a+16|0;f[o>>2]=s;e=f[c>>2]|0;if(!e)t=0;else t=H3(f[e+20>>2]|0,f[i>>2]|0,f[l>>2]|0)|0;e=(b[t>>0]&32)==0?t+1|0:t+5|0;if(d){f[n>>2]=4-t+e+(f[n>>2]|0)+((h[e+1>>0]|0)<<8|(h[e>>0]|0)|(h[e+2>>0]|0)<<16|(h[e+3>>0]|0)<<24);f[g>>2]=f[o>>2];break}else{f[n>>2]=8-t+e+(f[n>>2]|0);break}}else q=11}while(0);if((q|0)==11)f[a+16>>2]=0;L3(f[(f[a>>2]|0)+20>>2]|0,k,n);f[a+12>>2]=f[(f[(f[(f[a>>2]|0)+20>>2]|0)+224>>2]|0)+(f[k>>2]<<2)>>2];return}function J3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)kWc(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/12|0;e=l<<1;m=l>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(m)if(m>>>0>357913941){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);e=n+(g*12|0)|0;h=e;l=n+(m*12|0)|0;f[e>>2]=f[b>>2];f[n+(g*12|0)+4>>2]=f[b+4>>2];f[n+(g*12|0)+8>>2]=f[b+8>>2];b=e+12|0;if((j|0)==(i|0)){o=h;p=d}else{d=j;j=h;h=e;do{e=d;d=d+-12|0;f[h+-12>>2]=f[d>>2];f[h+-8>>2]=f[e+-8>>2];f[h+-4>>2]=f[e+-4>>2];h=j+-12|0;j=h}while((d|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;f[c>>2]=b;f[k>>2]=l;if(!p)return;cYc(p);return}function K3(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;if(!e){g=0;u=c;return g|0}i=H3(f[e+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!i){g=0;u=c;return g|0}a=b[i>>0]|0;e=a&255;j=(e&32|0)==0?i+1|0:i+5|0;k=j-i|0;switch(a&7){case 1:{g=k+4|0;u=c;return g|0}case 2:{g=k+8|0;u=c;return g|0}case 0:{g=k;u=c;return g|0}default:{if(((e&7)+-3|0)>>>0>=3){e=$Xc(48)|0;f[d>>2]=e;f[d+8>>2]=-2147483600;f[d+4>>2]=38;a=e;i=244374;l=a+38|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(l|0));b[e+38>>0]=0;vM(-215,d,244413,243595,2255)}g=k+4+((h[j+1>>0]|0)<<8|(h[j>>0]|0)|(h[j+2>>0]|0)<<16|(h[j+3>>0]|0)<<24)|0;u=c;return g|0}}return 0}function L3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=f[d>>2]|0;i=f[c>>2]|0;j=f[a+224>>2]|0;k=f[j+(i<<2)>>2]|0;if(h>>>0<k>>>0){u=e;return}l=((f[a+228>>2]|0)-j>>2)+-1|0;a=i;i=h;h=k;while(1){if((a|0)==(l|0))break;f[d>>2]=i-h;a=(f[c>>2]|0)+1|0;f[c>>2]=a;k=f[d>>2]|0;m=f[j+(a<<2)>>2]|0;if(k>>>0<m>>>0){n=7;break}else{i=k;h=m}}if((n|0)==7){u=e;return}if((i|0)==(h|0)){u=e;return}else{e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=30;h=e;i=244326;n=h+30|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(n|0));b[e+30>>0]=0;vM(-215,g,244357,243595,1459)}}function M3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=$Xc(24)|0;f[d+4>>2]=0;f[d+8>>2]=0;f[d>>2]=47088;e=d+12|0;g=f[c>>2]|0;f[e>>2]=0;c=d+16|0;f[c>>2]=0;h=d+20|0;f[h>>2]=0;if(!g){i=a+4|0;f[a>>2]=e;f[i>>2]=d;return}if((g|0)<0)kWc(e);j=$Xc(g)|0;f[c>>2]=j;f[e>>2]=j;f[h>>2]=j+g;h=g;g=j;do{b[g>>0]=0;g=(f[c>>2]|0)+1|0;f[c>>2]=g;h=h+-1|0}while((h|0)!=0);i=a+4|0;f[a>>2]=e;f[i>>2]=d;return}function N3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;f[e>>2]=f[b>>2];l=f[b+4>>2]|0;f[m+(g<<3)+4>>2]=l;if(!l){n=j;o=i}else{TXc(l);n=f[c>>2]|0;o=f[a>>2]|0}l=e+8|0;if((n|0)==(o|0)){p=h;q=o;r=n}else{i=n;n=h;h=e;do{e=i;i=i+-8|0;f[h+-8>>2]=f[i>>2];j=e+-4|0;f[h+-4>>2]=f[j>>2];f[i>>2]=0;f[j>>2]=0;h=n+-8|0;n=h}while((i|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=l;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=f[d+-4>>2]|0;d=d+-8|0;if(r|0)UXc(r)}while((d|0)!=(k|0))}if(!q)return;cYc(q);return}function O3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function P3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function Q3(a){a=a|0;var b=0,c=0;f[a>>2]=47088;b=f[a+12>>2]|0;if(!b){NXc(a);return}c=a+16|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;cYc(b);NXc(a);return}function R3(a){a=a|0;var b=0,c=0;f[a>>2]=47088;b=f[a+12>>2]|0;if(b|0){c=a+16|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;cYc(b)}NXc(a);cYc(a);return}function S3(a){a=a|0;var b=0,c=0;b=f[a+12>>2]|0;if(!b)return;c=a+16|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;cYc(b);return}function T3(a){a=a|0;cYc(a);return}function U3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;i=d;do if((d|0)==(g|0)){j=a+4|0;k=f[j>>2]|0;l=f[a>>2]|0;m=l;if(k>>>0>l>>>0){n=k;o=((n-m>>2)+1|0)/-2|0;p=k+(o<<2)|0;q=i-n|0;n=q>>2;if(!n)r=k;else{q1c(p|0,k|0,q|0)|0;r=f[j>>2]|0}q=p+(n<<2)|0;f[c>>2]=q;f[j>>2]=r+(o<<2);s=q;break}q=h-m>>1;m=(q|0)==0?1:q;if(m>>>0>1073741823){q=af(8)|0;hYc(q,512536);f[q>>2]=192348;ig(q|0,25336,2140)}q=$Xc(m<<2)|0;o=q;n=q+(m>>>2<<2)|0;p=n;t=q+(m<<2)|0;if((k|0)==(d|0)){u=p;v=l}else{l=n;n=p;m=k;do{f[l>>2]=f[m>>2];l=n+4|0;n=l;m=m+4|0}while((m|0)!=(d|0));u=n;v=f[a>>2]|0}f[a>>2]=o;f[j>>2]=p;f[c>>2]=u;f[e>>2]=t;if(!v)s=u;else{cYc(v);s=f[c>>2]|0}}else s=d;while(0);f[s>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+4;return}function V3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{q1c(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}m=$Xc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{cYc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function W3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;i=d;do if((d|0)==(g|0)){j=a+4|0;k=f[j>>2]|0;l=f[a>>2]|0;m=l;if(k>>>0>l>>>0){n=k;o=((n-m>>2)+1|0)/-2|0;p=k+(o<<2)|0;q=i-n|0;n=q>>2;if(!n)r=k;else{q1c(p|0,k|0,q|0)|0;r=f[j>>2]|0}q=p+(n<<2)|0;f[c>>2]=q;f[j>>2]=r+(o<<2);s=q;break}q=h-m>>1;m=(q|0)==0?1:q;if(m>>>0>1073741823){q=af(8)|0;hYc(q,512536);f[q>>2]=192348;ig(q|0,25336,2140)}q=$Xc(m<<2)|0;o=q;n=q+(m>>>2<<2)|0;p=n;t=q+(m<<2)|0;if((k|0)==(d|0)){u=p;v=l}else{l=n;n=p;m=k;do{f[l>>2]=f[m>>2];l=n+4|0;n=l;m=m+4|0}while((m|0)!=(d|0));u=n;v=f[a>>2]|0}f[a>>2]=o;f[j>>2]=p;f[c>>2]=u;f[e>>2]=t;if(!v)s=u;else{cYc(v);s=f[c>>2]|0}}else s=d;while(0);f[s>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+4;return}function X3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{q1c(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}m=$Xc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{cYc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function Y3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;d=c+23|0;b[d>>0]=0;c=d;d=(a|0)>-1?a:0-a|0;while(1){e=d;d=(d>>>0)/10|0;f=e+48+(Y(d,-10)|0)&255;g=c+-1|0;b[g>>0]=f;if(e>>>0<=9)break;else c=g}if((a|0)>=0){h=g;return h|0}g=c+-2|0;b[g>>0]=45;h=g;return h|0}function Z3(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;p[s>>3]=c;j=f[s+4>>2]|0;if((j&2146435072|0)==2146435072)if(((j&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){b[a>>0]=b[244894]|0;b[a+1>>0]=b[244895]|0;b[a+2>>0]=b[244896]|0;b[a+3>>0]=b[244897]|0;b[a+4>>0]=b[244898]|0;u=e;return a|0}else{eJc(a,(j|0)<0?244899:244905)|0;u=e;return a|0}j=zLc(c)|0;if(+(j|0)==c)if(d){f[i>>2]=j;cLc(a,244879,i)|0;u=e;return a|0}else{f[h>>2]=j;cLc(a,244884,h)|0;u=e;return a|0}p[g>>3]=c;cLc(a,244888,g)|0;switch(b[a>>0]|0){case 45:case 43:{k=a+1|0;break}default:k=a}while(1){l=b[k>>0]|0;if((l+-48&255)<10)k=k+1|0;else break}if(l<<24>>24!=44){u=e;return a|0}b[k>>0]=46;u=e;return a|0}function _3(a,c,d,e){a=a|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=(n[s>>2]=c,f[s>>2]|0);if((k&2139095040|0)==2139095040)if((k&2147483647|0)==2139095040){eJc(a,(k|0)<0?244899:244905)|0;u=g;return a|0}else{b[a>>0]=b[244894]|0;b[a+1>>0]=b[244895]|0;b[a+2>>0]=b[244896]|0;b[a+3>>0]=b[244897]|0;b[a+4>>0]=b[244898]|0;u=g;return a|0}k=ALc(c)|0;if(+(k|0)==c)if(e){f[j>>2]=k;cLc(a,244879,j)|0;u=g;return a|0}else{f[i>>2]=k;cLc(a,244884,i)|0;u=g;return a|0}if((b[530040]|0)==0?X0c(530040)|0:0)f[136183]=d?244910:244915;d=f[136183]|0;p[h>>3]=c;cLc(a,d,h)|0;switch(b[a>>0]|0){case 45:case 43:{l=a+1|0;break}default:l=a}while(1){m=b[l>>0]|0;if((m+-48&255)<10)l=l+1|0;else break}if(m<<24>>24!=44){u=g;return a|0}b[l>>0]=46;u=g;return a|0}function $3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+16|0;g=e;if(!a){h=0;u=e;return h|0}i=dJc(a)|0;if(!i){h=0;u=e;return h|0}f[c>>2]=0;j=d<<1;a:do if((i|0)>0){d=~a;k=0;l=0;m=0;b:while(1){n=a+k|0;o=b[n>>0]|0;p=o<<24>>24;do if((o+-48&255)<10){if(((b[a+(k+1)>>0]|0)+-48&255)<10){f[g>>2]=0;q=aJc(n,g,10)|0;r=q;s=(f[g>>2]|0)+d|0}else{r=p+-48|0;s=k}if((r|0)<1){t=9;break b}else{v=l;w=s;x=r}}else{q=AJc(244920,p,9)|0;if(!q){t=11;break b}y=o<<24>>24==114?56:q-244920|0;if(!m){f[c+(l<<2)>>2]=1;z=1}else z=m;f[c+(l+1<<2)>>2]=y;if((l|0)>0?(y|0)==(f[c+(l+-1<<2)>>2]|0):0){y=c+(l+-2<<2)|0;f[y>>2]=(f[y>>2]|0)+z;v=l;w=k;x=0;break}y=l+2|0;if((y|0)<(j|0)){v=y;w=k;x=0}else{t=18;break b}}while(0);f[c+(v<<2)>>2]=x;k=w+1|0;if((k|0)>=(i|0)){A=v;break a}else{l=v;m=x}}if((t|0)==9){m=$Xc(32)|0;f[g>>2]=m;f[g+8>>2]=-2147483616;f[g+4>>2]=31;B=m;C=244929;D=B+31|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[m+31>>0]=0;vM(-5,g,244961,243595,193)}else if((t|0)==11){l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=31;B=l;C=244929;D=B+31|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[l+31>>0]=0;vM(-5,g,244974,243595,152)}else if((t|0)==18){m=$Xc(48)|0;f[g>>2]=m;f[g+8>>2]=-2147483600;f[g+4>>2]=32;B=m;C=244987;D=B+32|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[m+32>>0]=0;vM(-5,g,244961,243595,209)}}else A=0;while(0);h=(A|0)/2|0;u=e;return h|0}function a4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+512|0;e=d;g=$3(a,e,128)|0;h=g<<1;if((g|0)>0){g=c;i=0;while(1){j=f[e+((i|1)<<2)>>2]|0;k=Y(675553809>>>(j<<2&28)&15,(j>>>3&511)+1|0)|0;j=(g+-1+k&0-k)+(Y(k,f[e+(i<<2)>>2]|0)|0)|0;i=i+2|0;if((i|0)>=(h|0)){l=j;break}else g=j}}else l=c;if(!c){c=f[e+4>>2]|0;e=Y(675553809>>>(c<<2&28)&15,(c>>>3&511)+1|0)|0;m=l+-1+e&0-e}else m=l;l=b[a>>0]|0;if(!(l<<24>>24)){n=0;o=m+-1|0;p=o+n|0;q=0-n|0;r=p&q;u=d;return r|0}else{s=0;t=a;v=l}while(1){switch(v<<24>>24|0){case 117:{w=(s|0)==0?1:s;break}case 99:{w=(s|0)==0?1:s;break}case 119:{w=s>>>0>2?s:2;break}case 115:{w=s>>>0>2?s:2;break}case 105:{w=s>>>0>4?s:4;break}case 102:{w=s>>>0>4?s:4;break}case 100:{w=s>>>0>8?s:8;break}default:w=s}t=t+1|0;v=b[t>>0]|0;if(!(v<<24>>24)){n=w;break}else s=w}o=m+-1|0;p=o+n|0;q=0-n|0;r=p&q;u=d;return r|0}function b4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=47144;d=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;d=a+96|0;e=a+184|0;g=a+56|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=d;h=g+88|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));b[e>>0]=1;e=a+240|0;d=a+256|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;g=a+188|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));n[d>>2]=1.0;d=a+260|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[a+4>>2]=c;z3(a);return}function c4(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=a+4|0;c=f[b>>2]|0;d=a+16|0;e=f[d>>2]|0;g=c+(e>>>12<<2)|0;h=a+8|0;i=f[h>>2]|0;j=i;k=c;if((i|0)==(c|0)){l=0;m=a+20|0;n=0}else{i=a+20|0;o=(f[i>>2]|0)+e|0;l=(f[c+(o>>>12<<2)>>2]|0)+(o&4095)|0;m=i;n=(f[g>>2]|0)+(e&4095)|0}e=g;g=n;a:while(1){n=g;do{i=n;if((i|0)==(l|0))break a;n=i+1|0}while((n-(f[e>>2]|0)|0)!=4096);n=e+4|0;e=n;g=f[n>>2]|0}f[m>>2]=0;m=j-k>>2;if(m>>>0>2){k=c;do{cYc(f[k>>2]|0);k=(f[b>>2]|0)+4|0;f[b>>2]=k;c=(f[h>>2]|0)-k>>2}while(c>>>0>2);p=c}else p=m;switch(p|0){case 1:{q=2048;r=13;break}case 2:{q=4096;r=13;break}default:{}}if((r|0)==13)f[d>>2]=q;q=f[b>>2]|0;d=f[h>>2]|0;if((q|0)!=(d|0)){r=q;do{cYc(f[r>>2]|0);r=r+4|0}while((r|0)!=(d|0));d=f[b>>2]|0;b=f[h>>2]|0;if((b|0)!=(d|0))f[h>>2]=b+(~((b+-4-d|0)>>>2)<<2)}d=f[a>>2]|0;if(!d)return;cYc(d);return}function d4(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=47144;if(b[a+36>>0]|0){a:do if(b[a+38>>0]|0){c=a+76|0;if((f[c>>2]|0)>>>0>1){do y3(a);while((f[c>>2]|0)>>>0>1);d=f[a>>2]|0}else d=47144;_i[f[d+56>>2]&2047](a)|0;switch(f[a+40>>2]|0){case 8:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,243565);break a;break}case 24:{mi[f[(f[a>>2]|0)+12>>2]&2047](a,505406);break a;break}default:break a}}while(0);Yi[f[(f[a>>2]|0)+28>>2]&4095](a);z3(a)}d=f[a+272>>2]|0;if(d|0){c=a+276|0;if((f[c>>2]|0)!=(d|0))f[c>>2]=d;cYc(d)}d=f[a+260>>2]|0;if(d|0){c=a+264|0;if((f[c>>2]|0)!=(d|0))f[c>>2]=d;cYc(d)}d=f[a+248>>2]|0;if(d|0){c=d;do{d=c;c=f[c>>2]|0;e=d+8|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(d)}while((c|0)!=0)}c=a+240|0;d=f[c>>2]|0;f[c>>2]=0;if(d|0)cYc(d);d=f[a+224>>2]|0;if(d|0){c=a+228|0;e=f[c>>2]|0;if((e|0)!=(d|0))f[c>>2]=e+(~((e+-4-d|0)>>>2)<<2);cYc(d)}d=f[a+212>>2]|0;if(d|0){e=a+216|0;c=f[e>>2]|0;if((c|0)!=(d|0))f[e>>2]=c+(~((c+-4-d|0)>>>2)<<2);cYc(d)}d=a+200|0;c=f[d>>2]|0;if(c|0){e=a+204|0;g=f[e>>2]|0;if((g|0)==(c|0))h=c;else{i=g;while(1){g=i+-8|0;f[e>>2]=g;j=f[i+-4>>2]|0;if(!j)k=g;else{UXc(j);k=f[e>>2]|0}if((k|0)==(c|0))break;else i=k}h=f[d>>2]|0}cYc(h)}h=f[a+188>>2]|0;if(h|0){d=a+192|0;k=f[d>>2]|0;if((k|0)!=(h|0))f[d>>2]=k+(~(((k+-12-h|0)>>>0)/12|0)*12|0);cYc(h)}h=f[a+164>>2]|0;if(h|0){k=a+168|0;if((f[k>>2]|0)!=(h|0))f[k>>2]=h;cYc(h)}h=f[a+152>>2]|0;if(h|0){k=a+156|0;if((f[k>>2]|0)!=(h|0))f[k>>2]=h;cYc(h)}h=f[a+140>>2]|0;if(h|0)UXc(h);h=f[a+132>>2]|0;if(h|0)UXc(h);h=f[a+124>>2]|0;if(h|0)UXc(h);c4(a+96|0);h=f[a+80>>2]|0;if(h|0){k=a+84|0;if((f[k>>2]|0)!=(h|0))f[k>>2]=h;cYc(h)}h=a+56|0;D3(h);k=a+60|0;d=f[k>>2]|0;i=a+64|0;c=f[i>>2]|0;if((d|0)!=(c|0)){e=d;do{cYc(f[e>>2]|0);e=e+4|0}while((e|0)!=(c|0));c=f[k>>2]|0;k=f[i>>2]|0;if((k|0)!=(c|0))f[i>>2]=k+(~((k+-4-c|0)>>>2)<<2)}c=f[h>>2]|0;if(c|0)cYc(c);c=a+8|0;if((b[c+11>>0]|0)>=0)return;cYc(f[c>>2]|0);return}function e4(a){a=a|0;d4(a);cYc(a);return}function f4(a){a=a|0;return f[a+4>>2]|0}function g4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;if(!(b[a+38>>0]|0)){b[e+11>>0]=10;g=e;h=243584;i=g+10|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+10>>0]=0;vM(-215,e,245908,243595,802)}if(!(b[a+39>>0]|0)){j=f[a+28>>2]|0;if(j|0){dKc(c,j)|0;u=d;return}j=f[a+32>>2]|0;if(!j){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=25;g=k;h=244811;i=g+25|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[k+25>>0]=0;vM(-2,e,245908,243595,812)}zHc(j,c)|0;u=d;return}else{j=dJc(c)|0;e=c+j|0;k=a+96|0;if(!j){u=d;return}j=a+116|0;h=a+104|0;g=a+100|0;i=a+112|0;a=c;c=f[j>>2]|0;do{l=f[g>>2]|0;m=(f[h>>2]|0)-l|0;n=f[i>>2]|0;if((((m|0)==0?0:(m<<10)+-1|0)|0)==(n+c|0)){I4(k);o=f[i>>2]|0;p=f[j>>2]|0;q=f[g>>2]|0}else{o=n;p=c;q=l}l=p+o|0;b[(f[q+(l>>>12<<2)>>2]|0)+(l&4095)>>0]=b[a>>0]|0;c=(f[j>>2]|0)+1|0;f[j>>2]=c;a=a+1|0}while((a|0)!=(e|0));u=d;return}}function h4(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;e=_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0;g=_i[f[(f[a>>2]|0)+48>>2]&2047](a)|0;h=F3(a,e,g-(_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0)|0)|0;if(!h){g=_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0;b[g>>0]=0;Yi[f[(f[a>>2]|0)+24>>2]&4095](a);i=0;u=c;return i|0}g=dJc(h)|0;a:do if((g|0)>0){switch(b[h+(g+-1)>>0]|0){case 13:case 10:{break a;break}default:{}}if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0)){e=f[(f[a>>2]|0)+92>>2]|0;j=$Xc(48)|0;f[d>>2]=j;f[d+8>>2]=-2147483600;f[d+4>>2]=44;k=j;l=249119;m=k+44|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+44>>0]=0;gi[e&255](a,244722,d,243595,877);if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0)}}while(0);d=a+296|0;f[d>>2]=(f[d>>2]|0)+1;i=h;u=c;return i|0}function i4(a){a=a|0;var c=0,d=0;if(b[a+37>>0]|0){c=1;return c|0}if(f[a+284>>2]|0){c=(f[a+292>>2]|0)>>>0>=(f[a+288>>2]|0)>>>0;return c|0}d=f[a+28>>2]|0;if(d|0){c=(sKc(d)|0)!=0;return c|0}d=f[a+32>>2]|0;if(!d){c=0;return c|0}c=(qHc(d)|0)!=0;return c|0}function j4(a){a=a|0;b[a+37>>0]=1;return}function k4(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+28|0;d=f[c>>2]|0;if(!d){e=a+32|0;g=f[e>>2]|0;if(!g)h=e;else{lHc(g)|0;h=e}}else{oKc(d)|0;h=a+32|0}f[c>>2]=0;f[h>>2]=0;f[a+284>>2]=0;f[a+292>>2]=0;b[a+36>>0]=0;return}function l4(a){a=a|0;var b=0,c=0;b=f[a+28>>2]|0;if(!b){c=f[a+32>>2]|0;if(c|0)oHc(c)|0}else OLc(b);f[a+292>>2]=0;return}function m4(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+80|0;i=f[h>>2]|0;j=a+84|0;k=f[j>>2]|0;l=i;m=k-l|0;if((c+d|0)>>>0<(i+m|0)>>>0){n=c;u=e;return n|0}o=c-l|0;if((o|0)>(m|0)){c=$Xc(48)|0;f[g>>2]=c;f[g+8>>2]=-2147483600;f[g+4>>2]=33;p=c;q=245856;r=p+33|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+33>>0]=0;vM(-215,g,245890,243595,938)}g=(m*3|0)/2|0;c=o+d|0;d=(c|0)<(g|0)?g:c;c=d+256|0;g=a+88|0;if(((f[g>>2]|0)-l|0)>>>0<c>>>0){q=$Xc(c)|0;p=q+m|0;r=p;s=p+(0-m)|0;p=s;if((m|0)>0)o1c(s|0,i|0,m|0)|0;f[h>>2]=p;f[j>>2]=r;f[g>>2]=q+c;if(!i){t=p;v=r;w=s}else{cYc(i);s=f[h>>2]|0;t=s;v=f[j>>2]|0;w=s}}else{t=l;v=k;w=i}i=v-t|0;k=t;t=v;if(d>>>0<=i>>>0)if(d>>>0<i>>>0?(v=k+d|0,(t|0)!=(v|0)):0){f[j>>2]=v;x=w}else x=w;else{A3(h,d-i|0);x=f[h>>2]|0}f[a+92>>2]=o;n=x+o|0;u=e;return n|0}function n4(a){a=a|0;return (f[a+80>>2]|0)+(f[a+92>>2]|0)|0}function o4(a){a=a|0;return f[a+80>>2]|0}function p4(a){a=a|0;var b=0;b=f[a+80>>2]|0;return b+((f[a+84>>2]|0)-b)|0}function q4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0;if(g>>>0<=c>>>0?(_i[f[(f[a>>2]|0)+48>>2]&2047](a)|0)>>>0>=c>>>0:0){f[a+92>>2]=c-g;u=d;return}d=$Xc(48)|0;f[e>>2]=d;f[e+8>>2]=-2147483600;f[e+4>>2]=40;g=d;c=245802;a=g+40|0;do{b[g>>0]=b[c>>0]|0;g=g+1|0;c=c+1|0}while((g|0)<(a|0));b[d+40>>0]=0;vM(-215,e,245843,243595,1180)}function r4(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+80>>2]|0;d=a+92|0;e=f[d>>2]|0;g=c+e|0;h=a+48|0;i=f[h>>2]|0;if((e|0)>(i|0)){b[g>>0]=10;b[g+1>>0]=0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,c);f[d>>2]=0;j=f[h>>2]|0}else j=i;i=(f[a+76>>2]|0)+-1+(f[a+72>>2]|0)|0;g=f[(f[(f[a+60>>2]|0)+(((i>>>0)/204|0)<<2)>>2]|0)+(((i>>>0)%204|0)*20|0)+16>>2]|0;if((j|0)==(g|0)){k=j;f[d>>2]=k;l=c+k|0;return l|0}g1c(c|0,32,g|0)|0;f[h>>2]=g;k=g;f[d>>2]=k;l=c+k|0;return l|0}function s4(a){a=a|0;b[a+24>>0]=0;return}function t4(a){a=a|0;return f[a+52>>2]|0}function u4(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=f[a+76>>2]|0;if(!e){g=$Xc(32)|0;f[d>>2]=g;f[d+8>>2]=-2147483616;f[d+4>>2]=20;h=g;i=243668;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+20>>0]=0;vM(-215,d,245785,243595,1187)}else{d=e+-1+(f[a+72>>2]|0)|0;u=c;return (f[(f[a+60>>2]|0)+(((d>>>0)/204|0)<<2)>>2]|0)+(((d>>>0)%204|0)*20|0)|0}return 0}function v4(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+64|0;g=e+8|0;i=e+48|0;j=e;k=e+36|0;l=e+24|0;m=e+12|0;n=(c|0)==4;if((c|1|0)!=5){o=$Xc(48)|0;f[i>>2]=o;f[i+8>>2]=-2147483600;f[i+4>>2]=46;q=o;r=245642;s=q+46|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[o+46>>0]=0;vM(-215,i,245689,243595,1246)}o=f[d>>2]|0;if((o|0)!=0?(t=H3(f[o+20>>2]|0,f[d+4>>2]|0,f[d+8>>2]|0)|0,(t|0)!=0):0)v=b[t>>0]&7;else v=0;if((v|0)==(c|0)){u=e;return}t=f[d>>2]|0;if(t){o=d+4|0;w=d+8|0;x=H3(f[t+20>>2]|0,f[o>>2]|0,f[w>>2]|0)|0;if(!x)y=0;else y=(b[x>>0]&32)!=0;x=f[d>>2]|0;if(!x){z=y;A=0}else{z=y;A=H3(f[x+20>>2]|0,f[o>>2]|0,f[w>>2]|0)|0}}else{z=0;A=0}w=z?4:0;o=A+1+w|0;f[i>>2]=0;p[j>>3]=0.0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;a:do if(!v)B=0;else{if(!n){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;A=$Xc(32)|0;f[l>>2]=A;f[l+8>>2]=-2147483616;f[l+4>>2]=21;q=A;r=245709;s=q+21|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[A+21>>0]=0;vM(-215,l,245689,243595,1267)}switch((v&255)<<24>>24){case 1:{f[i>>2]=h[o+1>>0]<<8|h[o>>0]|h[o+2>>0]<<16|h[o+3>>0]<<24;B=1;break a;break}case 2:{x=h[o+5>>0]<<8|h[o+4>>0]|h[o+6>>0]<<16|h[o+7>>0]<<24;y=j;f[y>>2]=h[o+1>>0]<<8|h[o>>0]|h[o+2>>0]<<16|h[o+3>>0]<<24;f[y+4>>2]=x;B=1;break a;break}case 3:{H4(l,d);x=k+11|0;if((b[x>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0}else{b[k>>0]=0;b[x>>0]=0}sYc(k,0);f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];B=1;break a;break}default:{f[g>>2]=v;DM(l,245731,g);vM(-2,l,245689,243595,1284)}}}while(0);g=G3(a,d,w|9)|0;b[g>>0]=(z?32:0)|c;c=z?g+5|0:g+1|0;b[c>>0]=4;g=c+1|0;b[g>>0]=0;b[g+1>>0]=0;b[g+2>>0]=0;b[g+3>>0]=0;b[g+4>>0]=0;b[g+5>>0]=0;b[g+6>>0]=0;if(B){B=f[(f[a>>2]|0)+76>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;switch((v&255)<<24>>24){case 1:{C=i;break}case 2:{C=j;break}case 3:{if((b[k+11>>0]|0)<0)C=f[k>>2]|0;else C=k;break}default:C=0}Ii[B&127](m,a,d,l,v,C,-1);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0)}if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);u=e;return}function w4(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;k=u;u=u+16|0;l=k;m=e+11|0;o=b[m>>0]|0;p=o<<24>>24<0;q=e+4|0;if((p?f[q>>2]|0:o&255)|0)if((f[c+40>>2]|0)==8)r=(GIc(p?f[e>>2]|0:e,388677)|0)==0;else r=0;else r=1;Ti[f[(f[c>>2]|0)+72>>2]&511](c,r?4:5,d);p=f[d>>2]|0;if((p|0)!=0?(o=H3(f[p+20>>2]|0,f[d+4>>2]|0,f[d+8>>2]|0)|0,(o|0)!=0):0)if(r^(b[o>>0]&7)==4)s=8;else s=11;else if(r)s=8;else s=12;if((s|0)==8){o=f[(f[c>>2]|0)+92>>2]|0;p=r?30:51;t=p+16&96;v=$Xc(t)|0;f[l>>2]=v;f[l+8>>2]=t|-2147483648;f[l+4>>2]=p;o1c(v|0,(r?245429:245460)|0,p|0)|0;b[v+p>>0]=0;gi[o&255](c,245512,l,243595,1377);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);s=11}if((s|0)==11)if(r)w=0;else s=12;do if((s|0)==12){o=D4(c+240|0,e)|0;if(o|0?(p=f[o+20>>2]|0,p|0):0){w=p;break}p=c+260|0;o=c+264|0;v=f[o>>2]|0;t=f[p>>2]|0;x=v-t|0;y=b[m>>0]|0;z=(y<<24>>24<0?f[q>>2]|0:y&255)+1|0;A=z+x|0;B=t;t=v;if(A>>>0<=x>>>0)if(A>>>0<x>>>0?(v=B+A|0,(t|0)!=(v|0)):0){f[o>>2]=v;C=B;D=y}else{C=B;D=y}else{A3(p,z);C=f[p>>2]|0;D=b[m>>0]|0}o1c(C+x|0,(D<<24>>24<0?f[e>>2]|0:e)|0,z|0)|0;z=c+240|0;lYc(l,e);f[l+12>>2]=x;p=l+11|0;y=b[p>>0]|0;B=y<<24>>24<0;v=B?f[l>>2]|0:l;o=B?f[l+4>>2]|0:y&255;if(o>>>0>3){B=v;t=o;A=o;while(1){E=Y(h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24,1540483477)|0;t=(Y(E>>>24^E,1540483477)|0)^(Y(t,1540483477)|0);A=A+-4|0;if(A>>>0<=3)break;else B=B+4|0}B=o+-4|0;A=B&-4;F=B-A|0;G=v+(A+4)|0;H=t}else{F=o;G=v;H=o}switch(F|0){case 3:{I=h[G+2>>0]<<16^H;s=24;break}case 2:{I=H;s=24;break}case 1:{J=H;s=25;break}default:K=H}if((s|0)==24){J=h[G+1>>0]<<8^I;s=25}if((s|0)==25)K=Y(h[G>>0]^J,1540483477)|0;A=Y(K>>>13^K,1540483477)|0;B=A>>>15^A;A=c+244|0;E=f[A>>2]|0;L=(E|0)==0;a:do if(!L){M=E+-1|0;N=(M&E|0)==0;if(!N)if(B>>>0<E>>>0)O=B;else O=(B>>>0)%(E>>>0)|0;else O=B&M;P=f[(f[z>>2]|0)+(O<<2)>>2]|0;if((P|0)!=0?(Q=f[P>>2]|0,(Q|0)!=0):0){P=(o|0)==0;if(N){if(P){N=Q;while(1){R=f[N+4>>2]|0;if(!((R|0)==(B|0)|(R&M|0)==(O|0))){S=O;s=66;break a}R=b[N+8+11>>0]|0;if(!((R<<24>>24<0?f[N+12>>2]|0:R&255)|0)){T=y;break a}N=f[N>>2]|0;if(!N){S=O;s=66;break a}}}else U=Q;while(1){N=f[U+4>>2]|0;if(!((N|0)==(B|0)|(N&M|0)==(O|0))){S=O;s=66;break a}N=U+8|0;R=b[N+11>>0]|0;V=R<<24>>24<0;W=R&255;do if(((V?f[U+12>>2]|0:W)|0)==(o|0)){R=f[N>>2]|0;if(V)if(!(WKc(R,v,o)|0)){T=y;break a}else break;if((R&255)<<24>>24==(b[v>>0]|0)){R=N;Z=W;_=v;do{Z=Z+-1|0;R=R+1|0;if(!Z){T=y;break a}_=_+1|0}while((b[R>>0]|0)==(b[_>>0]|0))}}while(0);U=f[U>>2]|0;if(!U){S=O;s=66;break a}}}if(P){M=Q;while(1){W=f[M+4>>2]|0;if((W|0)!=(B|0)){if(W>>>0<E>>>0)$=W;else $=(W>>>0)%(E>>>0)|0;if(($|0)!=(O|0)){S=O;s=66;break a}}W=b[M+8+11>>0]|0;if(!((W<<24>>24<0?f[M+12>>2]|0:W&255)|0)){T=y;break a}M=f[M>>2]|0;if(!M){S=O;s=66;break a}}}else aa=Q;while(1){M=f[aa+4>>2]|0;if((M|0)!=(B|0)){if(M>>>0<E>>>0)ba=M;else ba=(M>>>0)%(E>>>0)|0;if((ba|0)!=(O|0)){S=O;s=66;break a}}M=aa+8|0;P=b[M+11>>0]|0;W=P<<24>>24<0;N=P&255;do if(((W?f[aa+12>>2]|0:N)|0)==(o|0)){P=f[M>>2]|0;if(W)if(!(WKc(P,v,o)|0)){T=y;break a}else break;if((P&255)<<24>>24==(b[v>>0]|0)){P=M;V=N;_=v;do{V=V+-1|0;P=P+1|0;if(!V){T=y;break a}_=_+1|0}while((b[P>>0]|0)==(b[_>>0]|0))}}while(0);aa=f[aa>>2]|0;if(!aa){S=O;s=66;break}}}else{S=O;s=66}}else{S=0;s=66}while(0);if((s|0)==66){y=$Xc(24)|0;v=y+8|0;f[v>>2]=f[l>>2];f[v+4>>2]=f[l+4>>2];f[v+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[y+20>>2]=x;f[y+4>>2]=B;f[y>>2]=0;v=c+252|0;ca=+(((f[v>>2]|0)+1|0)>>>0);da=+n[c+256>>2];do if(L|ca>+(E>>>0)*da){o=(E>>>0<3|(E+-1&E|0)!=0)&1|E<<1;t=~~+X(+(ca/da))>>>0;E4(z,o>>>0<t>>>0?t:o);o=f[A>>2]|0;t=o+-1|0;if(!(t&o)){ea=o;fa=t&B;break}if(B>>>0<o>>>0){ea=o;fa=B}else{ea=o;fa=(B>>>0)%(o>>>0)|0}}else{ea=E;fa=S}while(0);E=(f[z>>2]|0)+(fa<<2)|0;B=f[E>>2]|0;if(!B){A=c+248|0;f[y>>2]=f[A>>2];f[A>>2]=y;f[E>>2]=A;A=f[y>>2]|0;if(A|0){E=f[A+4>>2]|0;A=ea+-1|0;if(A&ea)if(E>>>0<ea>>>0)ga=E;else ga=(E>>>0)%(ea>>>0)|0;else ga=E&A;ha=(f[z>>2]|0)+(ga<<2)|0;s=79}}else{f[y>>2]=f[B>>2];ha=B;s=79}if((s|0)==79)f[ha>>2]=y;f[v>>2]=(f[v>>2]|0)+1;T=b[p>>0]|0}if(T<<24>>24<0)cYc(f[l>>2]|0);w=x}while(0);l=f[d>>2]|0;if(!l)ia=0;else ia=H3(f[l+20>>2]|0,f[d+4>>2]|0,f[d+8>>2]|0)|0;l=((f[c+216>>2]|0)-(f[c+212>>2]|0)>>2)+-1|0;T=c+236|0;ha=f[T>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=l;f[a+8>>2]=ha;ha=G3(c,a,r?9:13)|0;c=ha+1|0;b[ha>>0]=(r?0:32)|g;if(!g)f[T>>2]=(f[T>>2]|0)+-8;if(r)ja=c;else{b[c>>0]=w;b[ha+2>>0]=w>>>8;b[ha+3>>0]=w>>>16;b[ha+4>>0]=w>>>24;ja=ha+5|0}if((g|1|0)==5){b[ja>>0]=0;b[ja+1>>0]=0;b[ja+2>>0]=0;b[ja+3>>0]=0}if(i|0)F4(a,g,i,j);j=f[d>>2]|0;if(!j){ka=ia;la=ka+5|0;ma=b[la>>0]|0;na=ma&255;oa=ka+6|0;pa=b[oa>>0]|0;qa=pa&255;ra=qa<<8;sa=ra|na;ta=ka+7|0;ua=b[ta>>0]|0;va=ua&255;wa=va<<16;xa=sa|wa;ya=ka+8|0;za=b[ya>>0]|0;Aa=za&255;Ba=Aa<<24;Ca=xa|Ba;Da=Ca+1|0;Ea=Da&255;b[la>>0]=Ea;Fa=Da>>>8;Ga=Fa&255;b[oa>>0]=Ga;Ha=Da>>>16;Ia=Ha&255;b[ta>>0]=Ia;Ja=Da>>>24;Ka=Ja&255;b[ya>>0]=Ka;u=k;return}i=H3(f[j+20>>2]|0,f[d+4>>2]|0,f[d+8>>2]|0)|0;if(!i){ka=ia;la=ka+5|0;ma=b[la>>0]|0;na=ma&255;oa=ka+6|0;pa=b[oa>>0]|0;qa=pa&255;ra=qa<<8;sa=ra|na;ta=ka+7|0;ua=b[ta>>0]|0;va=ua&255;wa=va<<16;xa=sa|wa;ya=ka+8|0;za=b[ya>>0]|0;Aa=za&255;Ba=Aa<<24;Ca=xa|Ba;Da=Ca+1|0;Ea=Da&255;b[la>>0]=Ea;Fa=Da>>>8;Ga=Fa&255;b[oa>>0]=Ga;Ha=Da>>>16;Ia=Ha&255;b[ta>>0]=Ia;Ja=Da>>>24;Ka=Ja&255;b[ya>>0]=Ka;u=k;return}ka=b[i>>0]&32?ia+4|0:ia;la=ka+5|0;ma=b[la>>0]|0;na=ma&255;oa=ka+6|0;pa=b[oa>>0]|0;qa=pa&255;ra=qa<<8;sa=ra|na;ta=ka+7|0;ua=b[ta>>0]|0;va=ua&255;wa=va<<16;xa=sa|wa;ya=ka+8|0;za=b[ya>>0]|0;Aa=za&255;Ba=Aa<<24;Ca=xa|Ba;Da=Ca+1|0;Ea=Da&255;b[la>>0]=Ea;Fa=Da>>>8;Ga=Fa&255;b[oa>>0]=Ga;Ha=Da>>>16;Ia=Ha&255;b[ta>>0]=Ia;Ja=Da>>>24;Ka=Ja&255;b[ya>>0]=Ka;u=k;return}function x4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;d=f[c>>2]|0;if(!d)return;e=c+4|0;g=c+8|0;i=H3(f[d+20>>2]|0,f[e>>2]|0,f[g>>2]|0)|0;if(!((i|0)!=0?(b[i>>0]&7)==4:0)){i=f[c>>2]|0;if(!i)return;d=H3(f[i+20>>2]|0,f[e>>2]|0,f[g>>2]|0)|0;if(!d)return;if((b[d>>0]&7)!=5)return}d=f[c>>2]|0;if(!d)j=0;else j=H3(f[d+20>>2]|0,f[e>>2]|0,f[g>>2]|0)|0;d=(b[j>>0]&32)==0?j+1|0:j+5|0;c=d+8-j+(f[g>>2]|0)|0;if(((h[d+5>>0]|0)<<8|(h[d+4>>0]|0)|(h[d+6>>0]|0)<<16|(h[d+7>>0]|0)<<24|0)!=0?(g=f[e>>2]|0,e=((f[a+216>>2]|0)-(f[a+212>>2]|0)>>2)+-1|0,g>>>0<e>>>0):0){j=f[a+224>>2]|0;i=g;g=4;k=c;while(1){l=g-k+(f[j+(i<<2)>>2]|0)|0;i=i+1|0;if((i|0)==(e|0)){m=l;n=0;break}else{g=l;k=0}}}else{m=4;n=c}c=(f[a+236>>2]|0)-n+m|0;b[d>>0]=c;b[d+1>>0]=c>>>8;b[d+2>>0]=c>>>16;b[d+3>>0]=c>>>24;return}function y4(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0,k=0,l=0.0;e=u;u=u+16|0;g=e;h=+aLc(c,d);p[g>>3]=h;i=f[d>>2]|0;do if((b[i>>0]|0)==46){b[i>>0]=44;h=+aLc(c,d);b[i>>0]=46;j=f[d>>2]|0;if(j>>>0>i>>>0){p[g>>3]=h;k=j;break}else{f[d>>2]=i;k=i;break}}else k=i;while(0);if((k|0)!=(c|0)?((b[k>>0]&-33)+-65&255)>=26:0){l=+p[g>>3];u=e;return +l}C4(a,c,g,d);l=+p[g>>3];u=e;return +l}function z4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+1104|0;i=g+1064|0;j=g+40|0;k=g+32|0;l=g;m=g+20|0;o=g+8|0;q=i;r=q+25|0;do{b[q>>0]=0;q=q+1|0}while((q|0)<(r|0));t=a+136|0;v=f[a+128>>2]|0;w=f[a+132>>2]|0;if(w|0)TXc(w);f[t>>2]=v;v=a+140|0;x=f[v>>2]|0;f[v>>2]=w;if(x|0)UXc(x);x=a+144|0;f[x>>2]=c;f[a+148>>2]=d;d=f[a+152>>2]|0;c=a+156|0;if((f[c>>2]|0)!=(d|0))f[c>>2]=d;d=f[a+164>>2]|0;c=a+168|0;w=f[c>>2]|0;v=d;if((w|0)==(d|0))y=w;else{f[c>>2]=d;y=v}d=a+176|0;f[d>>2]=0;f[a+180>>2]=0;w=a+184|0;b[w>>0]=0;z=a+164|0;A=0;B=v;v=y;y=0;while(1){if(y>>>0>=(v-B|0)>>>0)if(B4(t,1)|0){C=f[d>>2]|0;D=f[z>>2]|0;E=14}else F=0;else{C=y;D=B;E=14}if((E|0)==14){E=0;f[d>>2]=C+1;F=b[D+C>>0]|0}b[i+A>>0]=F;G=A+1|0;if((G|0)==24){H=0;break}A=G;B=f[z>>2]|0;v=f[c>>2]|0;y=f[d>>2]|0}while(1){if(WIc(b[i+H>>0]|0)|0){I=H;break}y=H+1|0;if((y|0)<24)H=y;else{I=y;break}}b[i+I>>0]=0;if(b[w>>0]|0){I=$Xc(32)|0;f[j>>2]=I;f[j+8>>2]=-2147483616;f[j+4>>2]=28;q=I;J=245031;r=q+28|0;do{b[q>>0]=b[J>>0]|0;q=q+1|0;J=J+1|0}while((q|0)<(r|0));b[I+28>>0]=0;vM(-215,j,245060,243595,1635)}I=$3(i,j,128)|0;f[k>>2]=0;p[l>>3]=0.0;i=(I|0)>0;H=m+11|0;a:while(1){if(i){y=0;do{v=y<<1;B=f[j+((v|1)<<2)>>2]|0;A=f[j+(v<<2)>>2]|0;b:do if((A|0)>0){v=0;while(1){switch(B|0){case 0:{F=f[z>>2]|0;C=f[d>>2]|0;if(C>>>0>=((f[c>>2]|0)-F|0)>>>0)if(B4(t,1)|0){K=f[d>>2]|0;L=f[z>>2]|0;E=29}else M=0;else{K=C;L=F;E=29}if((E|0)==29){E=0;f[d>>2]=K+1;M=b[L+K>>0]|0}f[k>>2]=M&255;N=1;break}case 1:{F=f[z>>2]|0;C=f[d>>2]|0;if(C>>>0>=((f[c>>2]|0)-F|0)>>>0)if(B4(t,1)|0){O=f[d>>2]|0;P=f[z>>2]|0;E=35}else Q=0;else{O=C;P=F;E=35}if((E|0)==35){E=0;f[d>>2]=O+1;Q=b[P+O>>0]|0}f[k>>2]=Q<<24>>24;N=1;break}case 2:{F=f[z>>2]|0;C=f[d>>2]|0;if((C+2|0)>>>0>((f[c>>2]|0)-F|0)>>>0)if(B4(t,2)|0){R=f[z>>2]|0;S=f[d>>2]|0;E=41}else T=0;else{R=F;S=C;E=41}if((E|0)==41){E=0;C=h[R+(S+1)>>0]<<8|h[R+S>>0];f[d>>2]=S+2;T=C}f[k>>2]=T&65535;N=1;break}case 3:{C=f[z>>2]|0;F=f[d>>2]|0;if((F+2|0)>>>0>((f[c>>2]|0)-C|0)>>>0)if(B4(t,2)|0){U=f[z>>2]|0;V=f[d>>2]|0;E=47}else W=0;else{U=C;V=F;E=47}if((E|0)==47){E=0;F=h[U+(V+1)>>0]<<8|h[U+V>>0];f[d>>2]=V+2;W=F}f[k>>2]=W<<16>>16;N=1;break}case 4:{F=f[z>>2]|0;C=f[d>>2]|0;if((C+4|0)>>>0>((f[c>>2]|0)-F|0)>>>0)if(B4(t,4)|0){X=f[z>>2]|0;Y=f[d>>2]|0;E=53}else Z=0;else{X=F;Y=C;E=53}if((E|0)==53){E=0;C=X+Y|0;F=h[C+1>>0]<<8|h[C>>0]|h[C+2>>0]<<16|h[C+3>>0]<<24;f[d>>2]=Y+4;Z=F}f[k>>2]=Z;N=1;break}case 5:{F=f[z>>2]|0;C=f[d>>2]|0;if((C+4|0)>>>0>((f[c>>2]|0)-F|0)>>>0)if(B4(t,4)|0){_=f[z>>2]|0;$=f[d>>2]|0;E=59}else aa=0;else{_=F;$=C;E=59}if((E|0)==59){E=0;C=_+$|0;F=h[C+1>>0]<<8|h[C>>0]|h[C+2>>0]<<16|h[C+3>>0]<<24;f[d>>2]=$+4;aa=F}p[l>>3]=(f[s>>2]=aa,+n[s>>2]);N=2;break}case 6:{F=f[z>>2]|0;C=f[d>>2]|0;if((C+8|0)>>>0>((f[c>>2]|0)-F|0)>>>0)if(B4(t,8)|0){ba=f[z>>2]|0;ca=f[d>>2]|0;E=65}else da=0.0;else{ba=F;ca=C;E=65}if((E|0)==65){E=0;C=ba+ca|0;f[s>>2]=h[C+1>>0]<<8|h[C>>0]|h[C+2>>0]<<16|h[C+3>>0]<<24;f[s+4>>2]=h[C+5>>0]<<8|h[C+4>>0]|h[C+6>>0]<<16|h[C+7>>0]<<24;ea=+p[s>>3];f[d>>2]=ca+8;da=ea}p[l>>3]=da;N=2;break}case 7:{C=f[z>>2]|0;F=f[d>>2]|0;if((F+2|0)>>>0>((f[c>>2]|0)-C|0)>>>0)if(B4(t,2)|0){fa=f[z>>2]|0;ga=f[d>>2]|0;E=71}else ha=0;else{fa=C;ga=F;E=71}if((E|0)==71){E=0;F=h[fa+(ga+1)>>0]<<8|h[fa+ga>>0];f[d>>2]=ga+2;ha=F}F=ha&65535;C=F<<13;D=C&268427264;G=D+939524096|0;ia=F<<16&-2147483648;F=ha&31744;c:do if(F<<16>>16<31744){switch(F<<16>>16){case 0:break;default:{ja=G;break c}}ja=(n[s>>2]=(f[s>>2]=D+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(F<<16>>16){case 31744:break;default:{ja=G;break c}}ja=C|1879048192}while(0);p[l>>3]=(f[s>>2]=ja|ia,+n[s>>2]);N=2;break}default:{E=76;break a}}if(b[w>>0]|0)break b;C=f[(f[a>>2]|0)+76>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;Ii[C&127](o,a,e,m,N,(N|0)==1?k:l,-1);if((b[H>>0]|0)<0)cYc(f[m>>2]|0);v=v+1|0;if((v|0)>=(A|0))break b}}while(0);y=y+1|0}while((y|0)<(I|0))}if(b[w>>0]|0){E=83;break}}if((E|0)==76){w=$Xc(32)|0;f[m>>2]=w;f[m+8>>2]=-2147483616;f[m+4>>2]=16;q=w;J=272170;r=q+16|0;do{b[q>>0]=b[J>>0]|0;q=q+1|0;J=J+1|0}while((q|0)<(r|0));b[w+16>>0]=0;vM(-210,m,245060,243595,1686)}else if((E|0)==83){mi[f[(f[a>>2]|0)+80>>2]&2047](a,e);u=g;return f[x>>2]|0}return 0}function A4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+32|0;i=h;j=h+12|0;h=a+8|0;if((b[h+11>>0]|0)<0)k=f[h>>2]|0;else k=h;h=f[a+296>>2]|0;a=(b[d+11>>0]|0)<0?f[d>>2]|0:d;f[i>>2]=k;f[i+4>>2]=h;f[i+8>>2]=a;DM(j,245020,i);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;a=dJc(c)|0;if(a>>>0>4294967279)jYc(i);if(a>>>0<11){b[i+11>>0]=a;if(!a)l=i;else{m=i;n=9}}else{h=a+16&-16;k=$Xc(h)|0;f[i>>2]=k;f[i+8>>2]=h|-2147483648;f[i+4>>2]=a;m=k;n=9}if((n|0)==9){o1c(m|0,c|0,a|0)|0;l=m}b[l+a>>0]=0;vM(-212,i,(b[j+11>>0]|0)<0?f[j>>2]|0:j,e,g)}function B4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+16|0;e=d+4|0;g=d;i=a+48|0;if(b[i>>0]|0){j=0;u=d;return j|0}k=a+28|0;l=a+32|0;m=f[l>>2]|0;n=f[k>>2]|0;o=m-n|0;p=a+40|0;q=f[p>>2]|0;r=n;if(o>>>0<q>>>0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=9;s=e;t=245072;v=s+9|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[e+9>>0]=0;vM(-215,e,245082,243595,1509)}w=o-q|0;if(!w){x=n;y=m}else{b[r>>0]=b[r+q>>0]|0;if((w|0)!=1){q=1;do{r=f[k>>2]|0;b[r+q>>0]=b[r+((f[p>>2]|0)+q)>>0]|0;q=q+1|0}while((q|0)!=(w|0))}x=f[k>>2]|0;y=f[l>>2]|0}q=y-x|0;r=x;x=y;if(w>>>0<=q>>>0){if(w>>>0<q>>>0?(y=r+w|0,(x|0)!=(y|0)):0)f[l>>2]=y}else zS(k,w-q|0);f[p>>2]=0;p=f[a>>2]|0;if(!p){z=$Xc(32)|0;f[e>>2]=z;A=e+8|0;f[A>>2]=-2147483616;B=e+4|0;f[B>>2]=22;s=z;t=245091;v=s+22|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));C=z+22|0;b[C>>0]=0;vM(-215,e,245082,243595,1517)}q=a+8|0;w=f[q>>2]|0;if(!w){z=$Xc(32)|0;f[e>>2]=z;A=e+8|0;f[A>>2]=-2147483616;B=e+4|0;f[B>>2]=22;s=z;t=245091;v=s+22|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));C=z+22|0;b[C>>0]=0;vM(-215,e,245082,243595,1517)}f[e>>2]=0;f[g>>2]=0;C=_h[f[(f[p>>2]|0)+12>>2]&127](p,w,f[a+12>>2]|0,e,g)|0;w=f[g>>2]|0;f[q>>2]=w;q=f[e>>2]|0;p=w;z=a+16|0;do if((q|0)!=(p|0)){t=a+20|0;s=a+24|0;v=q;while(1){B=f[t>>2]|0;A=f[s>>2]|0;y=A;if((B|0)==(A|0)){A=f[z>>2]|0;x=B-A|0;r=x+1|0;m=A;if((r|0)<0){D=22;break}n=y-A|0;y=n<<1;o=n>>>0<1073741823?(y>>>0<r>>>0?r:y):2147483647;if(!o)E=0;else E=$Xc(o)|0;y=E+x|0;b[y>>0]=b[v>>0]|0;r=y+(0-x)|0;if((x|0)>0)o1c(r|0,m|0,x|0)|0;f[z>>2]=r;f[t>>2]=y+1;f[s>>2]=E+o;if(A|0)cYc(m)}else{b[B>>0]=b[v>>0]|0;f[t>>2]=(f[t>>2]|0)+1}v=v+1|0;if((v|0)==(p|0)){D=30;break}}if((D|0)==22)kWc(z);else if((D|0)==30){v=f[g>>2]|0;t=f[e>>2]|0;F=t;G=v;H=t;I=v;break}}else{F=q;G=q;H=q;I=w}while(0);w=a+44|0;q=I-H+(f[w>>2]|0)|0;f[w>>2]=q;a:do if((F|0)==(G|0)|C^1?(b[i>>0]=1,q&3|0):0){w=a+20|0;H=a+24|0;I=q;while(1){e=f[w>>2]|0;g=f[H>>2]|0;p=g;if(e>>>0>=g>>>0){g=f[z>>2]|0;E=e-g|0;v=E+1|0;t=g;if((v|0)<0)break;s=p-g|0;p=s<<1;B=s>>>0<1073741823?(p>>>0<v>>>0?v:p):2147483647;if(!B)J=0;else J=$Xc(B)|0;p=J+E|0;b[p>>0]=61;v=p+(0-E)|0;if((E|0)>0)o1c(v|0,t|0,E|0)|0;f[z>>2]=v;f[w>>2]=p+1;f[H>>2]=J+B;if(g|0)cYc(t)}else{b[e>>0]=61;f[w>>2]=(f[w>>2]|0)+1}I=I+1|0;if(!(I&3))break a}kWc(z)}while(0);J=a+20|0;q=f[z>>2]|0;i=(f[J>>2]|0)-q|0;C=q;do if((i|0)>0?(q=i+-4|0,(i|0)>=4):0){G=a+36|0;F=0;while(1){I=b[245114+(h[C+(F|2)>>0]|0)>>0]|0;w=b[245114+(h[C+(F|3)>>0]|0)>>0]|0;H=h[245114+(h[C+(F|1)>>0]|0)>>0]|0;e=(H>>>4|h[245114+(h[C+F>>0]|0)>>0]<<2)&255;t=f[l>>2]|0;g=f[G>>2]|0;B=g;if(t>>>0>=g>>>0){g=f[k>>2]|0;p=t-g|0;v=p+1|0;E=g;if((v|0)<0){D=51;break}s=B-g|0;B=s<<1;m=s>>>0<1073741823?(B>>>0<v>>>0?v:B):2147483647;if(!m)K=0;else K=$Xc(m)|0;B=K+p|0;b[B>>0]=e;v=B+1|0;s=B+(0-p)|0;if((p|0)>0)o1c(s|0,E|0,p|0)|0;f[k>>2]=s;f[l>>2]=v;f[G>>2]=K+m;if(!g)L=v;else{cYc(E);L=f[l>>2]|0}}else{b[t>>0]=e;e=(f[l>>2]|0)+1|0;f[l>>2]=e;L=e}e=I&255;I=(e>>>2|H<<4)&255;H=f[G>>2]|0;t=H;if(L>>>0>=H>>>0){H=f[k>>2]|0;E=L-H|0;v=E+1|0;g=H;if((v|0)<0){D=61;break}m=t-H|0;t=m<<1;s=m>>>0<1073741823?(t>>>0<v>>>0?v:t):2147483647;if(!s)M=0;else M=$Xc(s)|0;t=M+E|0;b[t>>0]=I;v=t+1|0;m=t+(0-E)|0;if((E|0)>0)o1c(m|0,g|0,E|0)|0;f[k>>2]=m;f[l>>2]=v;f[G>>2]=M+s;if(!H)N=v;else{cYc(g);N=f[l>>2]|0}}else{b[L>>0]=I;I=(f[l>>2]|0)+1|0;f[l>>2]=I;N=I}I=(w&255|e<<6)&255;e=f[G>>2]|0;w=e;if(N>>>0>=e>>>0){e=f[k>>2]|0;g=N-e|0;v=g+1|0;H=e;if((v|0)<0){D=71;break}s=w-e|0;w=s<<1;m=s>>>0<1073741823?(w>>>0<v>>>0?v:w):2147483647;if(!m)O=0;else O=$Xc(m)|0;w=O+g|0;b[w>>0]=I;v=w+(0-g)|0;if((g|0)>0)o1c(v|0,H|0,g|0)|0;f[k>>2]=v;f[l>>2]=w+1;f[G>>2]=O+m;if(e|0)cYc(H)}else{b[N>>0]=I;f[l>>2]=(f[l>>2]|0)+1}P=F+4|0;if((P|0)>(q|0)){D=79;break}else F=P}if((D|0)==51)kWc(k);else if((D|0)==61)kWc(k);else if((D|0)==71)kWc(k);else if((D|0)==79){if((F|0)<=-4){Q=P;break}q=f[z>>2]|0;if((b[q+(F|3)>>0]|0)!=61){Q=P;break}if(((P|0)>1?(b[q+(F|2)>>0]|0)==61:0)?(q=f[l>>2]|0,(f[k>>2]|0)!=(q|0)):0)f[l>>2]=q+-1;q=f[l>>2]|0;if((f[k>>2]|0)==(q|0)){Q=P;break}f[l>>2]=q+-1;Q=P;break}}else Q=0;while(0);P=i-Q|0;if((P|0)>0){i=0;do{D=f[z>>2]|0;b[D+i>>0]=b[D+(i+Q)>>0]|0;i=i+1|0}while((i|0)!=(P|0))}i=f[J>>2]|0;Q=f[z>>2]|0;D=i-Q|0;N=Q;Q=i;if(P>>>0<=D>>>0){if(P>>>0<D>>>0?(i=N+P|0,(Q|0)!=(i|0)):0)f[J>>2]=i}else A3(z,P-D|0);j=((f[l>>2]|0)-(f[k>>2]|0)|0)>=(c|0);u=d;return j|0}function C4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0;g=u;u=u+16|0;h=g;i=b[c>>0]|0;switch(i<<24>>24){case 43:case 45:{j=c+1|0;k=i<<24>>24==45?-D:D;l=b[j>>0]|0;m=j;break}default:{k=D;l=i;m=c}}if(l<<24>>24!=46){l=f[(f[a>>2]|0)+92>>2]|0;c=$Xc(48)|0;f[h>>2]=c;f[h+8>>2]=-2147483600;f[h+4>>2]=37;n=c;o=245370;q=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[c+37>>0]=0;gi[l&255](a,245408,h,243595,1209);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}l=b[m+1>>0]|0;if(((bJc(l)|0)==73?(bJc(b[m+2>>0]|0)|0)==78:0)?(bJc(b[m+3>>0]|0)|0)==70:0){r=k;p[d>>3]=r;s=m+4|0;f[e>>2]=s;u=g;return}if(((bJc(l)|0)==78?(bJc(b[m+2>>0]|0)|0)==65:0)?(bJc(b[m+3>>0]|0)|0)==78:0){r=C;p[d>>3]=r;s=m+4|0;f[e>>2]=s;u=g;return}l=f[(f[a>>2]|0)+92>>2]|0;c=$Xc(48)|0;f[h>>2]=c;f[h+8>>2]=-2147483600;f[h+4>>2]=37;n=c;o=245370;q=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[c+37>>0]=0;gi[l&255](a,245408,h,243595,1218);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);r=0.0;p[d>>3]=r;s=m+4|0;f[e>>2]=s;u=g;return}function D4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;i=e?f[c+4>>2]|0:d&255;if(i>>>0>3){d=g;c=i;e=i;while(1){j=Y(h[d>>0]|h[d+1>>0]<<8|h[d+2>>0]<<16|h[d+3>>0]<<24,1540483477)|0;c=(Y(j>>>24^j,1540483477)|0)^(Y(c,1540483477)|0);e=e+-4|0;if(e>>>0<=3)break;else d=d+4|0}d=i+-4|0;e=d&-4;k=d-e|0;l=g+(e+4)|0;m=c}else{k=i;l=g;m=i}switch(k|0){case 3:{n=h[l+2>>0]<<16^m;o=6;break}case 2:{n=m;o=6;break}case 1:{p=m;o=7;break}default:q=m}if((o|0)==6){p=h[l+1>>0]<<8^n;o=7}if((o|0)==7)q=Y(h[l>>0]^p,1540483477)|0;p=Y(q>>>13^q,1540483477)|0;q=p>>>15^p;p=f[a+4>>2]|0;if(!p){r=0;return r|0}l=p+-1|0;n=(l&p|0)==0;if(!n)if(q>>>0<p>>>0)s=q;else s=(q>>>0)%(p>>>0)|0;else s=q&l;m=f[(f[a>>2]|0)+(s<<2)>>2]|0;if(!m){r=0;return r|0}a=f[m>>2]|0;if(!a){r=0;return r|0}m=(i|0)==0;if(n){n=a;a:while(1){k=f[n+4>>2]|0;c=(k|0)==(q|0);if(!(c|(k&l|0)==(s|0))){r=0;o=41;break}do if(c?(k=n+8|0,e=b[k+11>>0]|0,d=e<<24>>24<0,j=e&255,((d?f[n+12>>2]|0:j)|0)==(i|0)):0){e=f[k>>2]|0;t=d?e:k;if(d){if(m){r=n;o=41;break a}if(!(WKc(t,g,i)|0)){r=n;o=41;break a}else break}if(m){r=n;o=41;break a}if((e&255)<<24>>24==(b[g>>0]|0)){e=k;k=j;j=g;do{k=k+-1|0;e=e+1|0;if(!k){r=n;o=41;break a}j=j+1|0}while((b[e>>0]|0)==(b[j>>0]|0))}}while(0);n=f[n>>2]|0;if(!n){r=0;o=41;break}}if((o|0)==41)return r|0}else u=a;b:while(1){a=f[u+4>>2]|0;n=(a|0)==(q|0);if(!n){if(a>>>0<p>>>0)v=a;else v=(a>>>0)%(p>>>0)|0;if((v|0)!=(s|0)){r=0;o=41;break}if(n)o=33}else o=33;do if((o|0)==33?(o=0,n=u+8|0,a=b[n+11>>0]|0,l=a<<24>>24<0,c=a&255,((l?f[u+12>>2]|0:c)|0)==(i|0)):0){a=f[n>>2]|0;j=l?a:n;if(l){if(m){r=u;o=41;break b}if(!(WKc(j,g,i)|0)){r=u;o=41;break b}else break}if(m){r=u;o=41;break b}if((a&255)<<24>>24==(b[g>>0]|0)){a=n;n=c;c=g;do{n=n+-1|0;a=a+1|0;if(!n){r=u;o=41;break b}c=c+1|0}while((b[a>>0]|0)==(b[c>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){r=0;o=41;break}}if((o|0)==41)return r|0;return 0}function E4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){G4(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;G4(a,d);return}function F4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+16|0;i=g;j=f[a>>2]|0;if(!j){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=6;b[i>>0]=b[245520]|0;b[i+1>>0]=b[245521]|0;b[i+2>>0]=b[245522]|0;b[i+3>>0]=b[245523]|0;b[i+4>>0]=b[245524]|0;b[i+5>>0]=b[245525]|0;l=i+6|0;b[l>>0]=0;vM(-215,i,245527,243595,2272)}m=H3(f[j+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!m){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=6;b[i>>0]=b[245520]|0;b[i+1>>0]=b[245521]|0;b[i+2>>0]=b[245522]|0;b[i+3>>0]=b[245523]|0;b[i+4>>0]=b[245524]|0;b[i+5>>0]=b[245525]|0;l=i+6|0;b[l>>0]=0;vM(-215,i,245527,243595,2272)}l=h[m>>0]|0;m=l&7;if(!((m|0)==0|(m|0)==(c|0))){m=$Xc(48)|0;f[i>>2]=m;f[i+8>>2]=-2147483600;f[i+4>>2]=44;n=m;o=245536;p=n+44|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+44>>0]=0;vM(-215,i,245527,243595,2276)}m=l&32;l=(m|0)!=0;k=m>>>3;j=k|1;q=(c|0)==1;a:do if(q){r=e;s=j+4|0}else switch(c|0){case 2:{r=e;s=k|9;break a;break}case 3:{if((e|0)<0)t=dJc(d)|0;else t=e;r=t;s=j+5+t|0;break a;break}default:{v=$Xc(64)|0;f[i>>2]=v;f[i+8>>2]=-2147483584;f[i+4>>2]=60;n=v;o=245581;p=n+60|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[v+60>>0]=0;vM(-213,i,245527,243595,2295)}}while(0);i=G3(f[(f[a>>2]|0)+20>>2]|0,a,s)|0;b[i>>0]=m|c;m=l?i+5|0:i+1|0;b:do if(q){i=f[d>>2]|0;b[m>>0]=i;b[m+1>>0]=i>>>8;b[m+2>>0]=i>>>16;w=i>>>24&255;x=3}else switch(c|0){case 2:{i=d;l=f[i>>2]|0;s=f[i+4>>2]|0;b[m>>0]=l;i=l1c(l|0,s|0,8)|0;b[m+1>>0]=i;i=l1c(l|0,s|0,16)|0;b[m+2>>0]=i;i=l1c(l|0,s|0,24)|0;b[m+3>>0]=i;b[m+4>>0]=s;i=l1c(l|0,s|0,40)|0;b[m+5>>0]=i;i=l1c(l|0,s|0,48)|0;b[m+6>>0]=i;w=(l1c(l|0,s|0,56)|0)&255;x=7;break b;break}case 3:{s=r+1|0;b[m>>0]=s;b[m+1>>0]=s>>>8;b[m+2>>0]=s>>>16;b[m+3>>0]=s>>>24;o1c(m+4|0,d|0,r|0)|0;w=0;x=r+4|0;break b;break}default:{u=g;return}}while(0);b[m+x>>0]=w;u=g;return}function G4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=a+4|0;if(!c){e=f[a>>2]|0;f[a>>2]=0;if(e|0)cYc(e);f[d>>2]=0;return}if(c>>>0>1073741823){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}e=$Xc(c<<2)|0;g=f[a>>2]|0;f[a>>2]=e;if(g|0)cYc(g);f[d>>2]=c;d=0;do{f[(f[a>>2]|0)+(d<<2)>>2]=0;d=d+1|0}while((d|0)!=(c|0));d=a+8|0;g=f[d>>2]|0;if(!g)return;e=f[g+4>>2]|0;h=c+-1|0;i=(h&c|0)==0;if(!i)if(e>>>0<c>>>0)j=e;else j=(e>>>0)%(c>>>0)|0;else j=e&h;f[(f[a>>2]|0)+(j<<2)>>2]=d;d=f[g>>2]|0;if(!d)return;else{k=j;l=g;m=d;n=g}a:while(1){g=l;d=m;j=n;b:while(1){o=d;while(1){e=f[o+4>>2]|0;if(!i)if(e>>>0<c>>>0)p=e;else p=(e>>>0)%(c>>>0)|0;else p=e&h;if((p|0)==(k|0))break;q=(f[a>>2]|0)+(p<<2)|0;if(!(f[q>>2]|0))break b;e=f[o>>2]|0;c:do if(!e)r=o;else{s=o+8|0;t=b[s+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[o+12>>2]|0:v;w=(t|0)==0;if(u){u=o;x=e;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){r=u;break c}if(!w?WKc(f[s>>2]|0,A?f[y>>2]|0:y,t)|0:0){r=u;break c}y=f[x>>2]|0;if(!y){r=x;break c}else{A=x;x=y;u=A}}}if(w){u=o;x=e;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){r=u;break c}A=f[x>>2]|0;if(!A){r=x;break c}else{y=x;x=A;u=y}}}u=o;x=e;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){r=u;break c}y=A?f[w>>2]|0:w;if((f[s>>2]&255)<<24>>24==(b[y>>0]|0)){B=s;C=v;D=y}else{r=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){r=u;break c}}y=f[x>>2]|0;if(!y){r=x;break}else{w=x;x=y;u=w}}}while(0);f[j>>2]=f[r>>2];f[r>>2]=f[f[(f[a>>2]|0)+(p<<2)>>2]>>2];f[f[(f[a>>2]|0)+(p<<2)>>2]>>2]=o;e=f[g>>2]|0;if(!e){E=43;break a}else o=e}d=f[o>>2]|0;if(!d){E=43;break a}else{g=o;j=o}}f[q>>2]=j;m=f[o>>2]|0;if(!m){E=43;break}else{k=p;l=o;n=o}}if((E|0)==43)return}function H4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=f[c>>2]|0;if((d|0?(e=H3(f[d+20>>2]|0,f[c+4>>2]|0,f[c+8>>2]|0)|0,e|0):0)?(c=h[e>>0]|0,(c&7|0)==3):0){d=e+(c>>>3&4|1)|0;c=(h[d+1>>0]|0)<<8|(h[d>>0]|0)|(h[d+2>>0]|0)<<16|(h[d+3>>0]|0)<<24;e=d+4|0;d=c+-1|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(d>>>0>4294967279)jYc(a);if(d>>>0<11){b[a+11>>0]=d;if(!d)g=a;else{i=a;j=10}}else{k=c+15&-16;c=$Xc(k)|0;f[a>>2]=c;f[a+8>>2]=k|-2147483648;f[a+4>>2]=d;i=c;j=10}if((j|0)==10){o1c(i|0,e|0,d|0)|0;g=i}b[g+d>>0]=0;return};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function I4(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=u;u=u+32|0;c=b+4|0;d=b;e=a+16|0;g=f[e>>2]|0;if(g>>>0>4095){f[e>>2]=g+-4096;g=a+4|0;e=f[g>>2]|0;h=f[e>>2]|0;i=e+4|0;f[g>>2]=i;e=a+8|0;j=f[e>>2]|0;k=a+12|0;l=f[k>>2]|0;m=l;n=j;do if((j|0)==(l|0)){o=f[a>>2]|0;p=o;if(i>>>0>o>>>0){q=i;r=((q-p>>2)+1|0)/-2|0;s=i+(r<<2)|0;t=n-q|0;q=t>>2;if(!q)v=i;else{q1c(s|0,i|0,t|0)|0;v=f[g>>2]|0}t=s+(q<<2)|0;f[e>>2]=t;f[g>>2]=v+(r<<2);w=t;break}t=m-p>>1;p=(t|0)==0?1:t;if(p>>>0>1073741823){t=af(8)|0;hYc(t,512536);f[t>>2]=192348;ig(t|0,25336,2140)}t=$Xc(p<<2)|0;r=t;q=t+(p>>>2<<2)|0;s=q;x=t+(p<<2)|0;if((i|0)==(j|0)){y=s;z=o}else{o=q;q=s;p=i;do{f[o>>2]=f[p>>2];o=q+4|0;q=o;p=p+4|0}while((p|0)!=(j|0));y=q;z=f[a>>2]|0}f[a>>2]=r;f[g>>2]=s;f[e>>2]=y;f[k>>2]=x;if(!z)w=y;else{cYc(z);w=f[e>>2]|0}}else w=j;while(0);f[w>>2]=h;f[e>>2]=(f[e>>2]|0)+4;u=b;return}e=a+8|0;h=f[e>>2]|0;w=a+4|0;j=h-(f[w>>2]|0)|0;z=a+12|0;y=f[z>>2]|0;k=y-(f[a>>2]|0)|0;if(j>>>0>=k>>>0){g=k>>1;k=(g|0)==0?1:g;f[c+12>>2]=0;f[c+16>>2]=a+12;if(k>>>0>1073741823){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=$Xc(k<<2)|0;f[c>>2]=g;i=g+(j>>2<<2)|0;j=c+8|0;f[j>>2]=i;m=c+4|0;f[m>>2]=i;i=c+12|0;f[i>>2]=g+(k<<2);k=$Xc(4096)|0;f[d>>2]=k;L4(c,d);d=f[e>>2]|0;while(1){A=f[w>>2]|0;if((d|0)==(A|0))break;k=d+-4|0;M4(c,k);d=k}k=A;A=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=A;f[w>>2]=f[m>>2];f[m>>2]=k;m=f[e>>2]|0;f[e>>2]=f[j>>2];f[j>>2]=m;g=f[z>>2]|0;f[z>>2]=f[i>>2];f[i>>2]=g;g=m;if((g|0)!=(d|0))f[j>>2]=g+(~((g+-4-k|0)>>>2)<<2);if(A|0)cYc(A);u=b;return}if((y|0)!=(h|0)){h=$Xc(4096)|0;f[c>>2]=h;J4(a,c);u=b;return}h=$Xc(4096)|0;f[c>>2]=h;K4(a,c);c=f[w>>2]|0;h=f[c>>2]|0;y=c+4|0;f[w>>2]=y;c=f[e>>2]|0;A=f[z>>2]|0;k=A;g=c;do if((c|0)==(A|0)){j=f[a>>2]|0;d=j;if(y>>>0>j>>>0){m=y;i=((m-d>>2)+1|0)/-2|0;v=y+(i<<2)|0;n=g-m|0;m=n>>2;if(!m)B=y;else{q1c(v|0,y|0,n|0)|0;B=f[w>>2]|0}n=v+(m<<2)|0;f[e>>2]=n;f[w>>2]=B+(i<<2);C=n;break}n=k-d>>1;d=(n|0)==0?1:n;if(d>>>0>1073741823){n=af(8)|0;hYc(n,512536);f[n>>2]=192348;ig(n|0,25336,2140)}n=$Xc(d<<2)|0;i=n;m=n+(d>>>2<<2)|0;v=m;l=n+(d<<2)|0;if((y|0)==(c|0)){D=v;E=j}else{j=m;m=v;d=y;do{f[j>>2]=f[d>>2];j=m+4|0;m=j;d=d+4|0}while((d|0)!=(c|0));D=m;E=f[a>>2]|0}f[a>>2]=i;f[w>>2]=v;f[e>>2]=D;f[z>>2]=l;if(!E)C=D;else{cYc(E);C=f[e>>2]|0}}else C=c;while(0);f[C>>2]=h;f[e>>2]=(f[e>>2]|0)+4;u=b;return}function J4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;i=d;do if((d|0)==(g|0)){j=a+4|0;k=f[j>>2]|0;l=f[a>>2]|0;m=l;if(k>>>0>l>>>0){n=k;o=((n-m>>2)+1|0)/-2|0;p=k+(o<<2)|0;q=i-n|0;n=q>>2;if(!n)r=k;else{q1c(p|0,k|0,q|0)|0;r=f[j>>2]|0}q=p+(n<<2)|0;f[c>>2]=q;f[j>>2]=r+(o<<2);s=q;break}q=h-m>>1;m=(q|0)==0?1:q;if(m>>>0>1073741823){q=af(8)|0;hYc(q,512536);f[q>>2]=192348;ig(q|0,25336,2140)}q=$Xc(m<<2)|0;o=q;n=q+(m>>>2<<2)|0;p=n;t=q+(m<<2)|0;if((k|0)==(d|0)){u=p;v=l}else{l=n;n=p;m=k;do{f[l>>2]=f[m>>2];l=n+4|0;n=l;m=m+4|0}while((m|0)!=(d|0));u=n;v=f[a>>2]|0}f[a>>2]=o;f[j>>2]=p;f[c>>2]=u;f[e>>2]=t;if(!v)s=u;else{cYc(v);s=f[c>>2]|0}}else s=d;while(0);f[s>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+4;return}function K4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{q1c(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}m=$Xc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{cYc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function L4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;i=d;do if((d|0)==(g|0)){j=a+4|0;k=f[j>>2]|0;l=f[a>>2]|0;m=l;if(k>>>0>l>>>0){n=k;o=((n-m>>2)+1|0)/-2|0;p=k+(o<<2)|0;q=i-n|0;n=q>>2;if(!n)r=k;else{q1c(p|0,k|0,q|0)|0;r=f[j>>2]|0}q=p+(n<<2)|0;f[c>>2]=q;f[j>>2]=r+(o<<2);s=q;break}q=h-m>>1;m=(q|0)==0?1:q;if(m>>>0>1073741823){q=af(8)|0;hYc(q,512536);f[q>>2]=192348;ig(q|0,25336,2140)}q=$Xc(m<<2)|0;o=q;n=q+(m>>>2<<2)|0;p=n;t=q+(m<<2)|0;if((k|0)==(d|0)){u=p;v=l}else{l=n;n=p;m=k;do{f[l>>2]=f[m>>2];l=n+4|0;n=l;m=m+4|0}while((m|0)!=(d|0));u=n;v=f[a>>2]|0}f[a>>2]=o;f[j>>2]=p;f[c>>2]=u;f[e>>2]=t;if(!v)s=u;else{cYc(v);s=f[c>>2]|0}}else s=d;while(0);f[s>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+4;return}function M4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{q1c(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}m=$Xc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{cYc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function N4(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;cYc(b);return}function O4(a){a=a|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;e=c+8|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(c)}while((d|0)!=0)}d=f[a>>2]|0;f[a>>2]=0;if(!d)return;cYc(d);return}function P4(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function Q4(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function R4(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;while(1){d=g+-8|0;f[c>>2]=d;h=f[g+-4>>2]|0;if(!h)i=d;else{UXc(h);i=f[c>>2]|0}if((i|0)==(b|0))break;else g=i}e=f[a>>2]|0}cYc(e);return}function S4(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~(((a+-12-b|0)>>>0)/12|0)*12|0);cYc(b);return}function T4(a){a=a|0;var b=0,c=0;b=f[a+28>>2]|0;if(b|0){c=a+32|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;cYc(b)}b=f[a+16>>2]|0;if(b|0){c=a+20|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;cYc(b)}b=f[a+4>>2]|0;if(!b)return;UXc(b);return}function U4(a){a=a|0;var b=0;b=f[a+4>>2]|0;if(!b)return;UXc(b);return}function V4(a){a=a|0;var b=0;b=f[a+4>>2]|0;if(!b)return;UXc(b);return}function W4(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;D3(a);b=a+4|0;c=f[b>>2]|0;d=a+8|0;e=f[d>>2]|0;if((c|0)!=(e|0)){g=c;do{cYc(f[g>>2]|0);g=g+4|0}while((g|0)!=(e|0));e=f[b>>2]|0;b=f[d>>2]|0;if((b|0)!=(e|0))f[d>>2]=b+(~((b+-4-e|0)>>>2)<<2)}e=f[a>>2]|0;if(!e)return;cYc(e);return}function X4(a){a=a|0;f[a>>2]=47116;d4(a+12|0);NXc(a);return}function Y4(a){a=a|0;f[a>>2]=47116;d4(a+12|0);NXc(a);cYc(a);return}function Z4(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function _4(a){a=a|0;cYc(a);return}function $4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;f[a>>2]=47056;g=a+8|0;h=a+20|0;i=a+24|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;g=$Xc(312)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=47116;j=g+12|0;b4(j,a);TXc(g);f[h>>2]=j;j=f[i>>2]|0;f[i>>2]=g;if(j|0)UXc(j);UXc(g);if(!(B3(f[h>>2]|0,(b[c+11>>0]|0)<0?f[c>>2]|0:c,d,(b[e+11>>0]|0)<0?f[e>>2]|0:e)|0))return;f[a+4>>2]=6;return}function a5(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+32|0;h=g;if(!(b[a+38>>0]|0)){b[h+11>>0]=10;i=h;j=243584;k=i+10|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+10>>0]=0;vM(-215,h,250489,243595,992)}l=d&15|16;if((d&6|1|0)!=5){m=$Xc(80)|0;f[h>>2]=m;f[h+8>>2]=-2147483568;f[h+4>>2]=70;i=m;j=246012;k=i+70|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[m+70>>0]=0;vM(-5,h,250489,243595,997)}if(!e)n=0;else n=(b[e>>0]|0)==0?0:e;e=a+120|0;m=f[e>>2]|0;j=a+76|0;i=a+72|0;k=(f[j>>2]|0)+-1+(f[i>>2]|0)|0;o=a+60|0;Fh[f[(f[m>>2]|0)+8>>2]&255](h,m,(f[(f[o>>2]|0)+(((k>>>0)/204|0)<<2)>>2]|0)+(((k>>>0)%204|0)*20|0)|0,c,l,n);l=a+64|0;c=f[l>>2]|0;k=f[o>>2]|0;m=c-k>>2;p=f[i>>2]|0;q=f[j>>2]|0;if((((m|0)==0?0:(m*204|0)+-1|0)|0)==(q+p|0)){E3(a+56|0);r=f[i>>2]|0;s=f[j>>2]|0;t=f[l>>2]|0;v=f[o>>2]|0}else{r=p;s=q;t=c;v=k}k=s+r|0;if((t|0)==(v|0))w=0;else w=(f[v+(((k>>>0)/204|0)<<2)>>2]|0)+(((k>>>0)%204|0)*20|0)|0;lYc(w,h);k=h+12|0;v=k;t=f[v+4>>2]|0;r=w+12|0;f[r>>2]=f[v>>2];f[r+4>>2]=t;t=f[j>>2]|0;r=t+1|0;f[j>>2]=r;if(r>>>0>1){r=t+-1+(f[i>>2]|0)|0;i=(f[(f[o>>2]|0)+(((r>>>0)/204|0)<<2)>>2]|0)+(((r>>>0)%204|0)*20|0)+12|0;f[i>>2]=f[i>>2]&-17}if(!(f[k>>2]&8))_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0;if((n|0?(f[a+40>>2]|0)==24:0)?(d&7|0)==5&(b[n>>0]|0)!=0:0){d=f[e>>2]|0;ei[f[(f[d>>2]|0)+24>>2]&511](d,247727,n,0)}if((b[h+11>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function b5(a){a=a|0;return (a&7|0)==5|0}function c5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+64|0;d=c+48|0;e=c+24|0;g=c;h=f[b+20>>2]|0;if(((h|0)!=0?(b=f[h+188>>2]|0,i=f[h+192>>2]|0,(b|0)!=(i|0)):0)?(i-b|0)>0:0){f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2]}else{f[d>>2]=0;f[d+8>>2]=0;f[d+4>>2]=0}I3(e,d,0);I3(g,d,1);d=f[e>>2]|0;b=f[e+4>>2]|0;if(((((d|0)==(f[g>>2]|0)?(b|0)==(f[g+4>>2]|0):0)?(f[e+8>>2]|0)==(f[g+8>>2]|0):0)?(f[e+20>>2]|0)==(f[g+20>>2]|0):0)?(f[e+16>>2]|0)==(f[g+16>>2]|0):0){f[a>>2]=0;f[a+8>>2]=0;f[a+4>>2]=0;u=c;return}g=f[e+8>>2]|0;f[a>>2]=(f[e+20>>2]|0)>>>0<(f[e+16>>2]|0)>>>0?d:0;f[a+4>>2]=b;f[a+8>>2]=g;u=c;return}function d5(a,b){a=a|0;b=b|0;I3(a,b,0);return}function e5(a,b){a=a|0;b=b|0;var c=0;if((f[a>>2]|0)!=(f[b>>2]|0)){c=1;return c|0}if((f[a+4>>2]|0)!=(f[b+4>>2]|0)){c=1;return c|0}if((f[a+8>>2]|0)!=(f[b+8>>2]|0)){c=1;return c|0}if((f[a+20>>2]|0)!=(f[b+20>>2]|0)){c=1;return c|0}c=(f[a+16>>2]|0)!=(f[b+16>>2]|0);return c|0}function f5(a,b){a=a|0;b=b|0;I3(a,b,1);return}function g5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((f[b+20>>2]|0)>>>0<(f[b+16>>2]|0)>>>0)c=f[b>>2]|0;else c=0;d=f[b+4>>2]|0;e=f[b+8>>2]|0;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;return}function h5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+1056|0;e=d+16|0;g=d;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c>>2]|0:c;k=i?f[c+4>>2]|0:h&255;h=j+k|0;c=k+1|0;k=e+8|0;f[e>>2]=k;i=e+4|0;f[i>>2]=c;if(c>>>0>1032){l=bYc(c)|0;f[e>>2]=l;m=l}else m=k;l=h+-1|0;a:do if(l>>>0>=j>>>0){c=l;n=h;b:while(1){o=c;p=n;c:while(1){switch(b[o>>0]|0){case 58:case 47:case 92:{q=p;break b;break}case 46:{if(!(b[n>>0]|0))break c;if(!(NJc(n,243853,3)|0))break c;break}default:{}}r=o+-1|0;if(r>>>0<j>>>0){q=o;break b}else{s=o;o=r;p=s}}c=o+-1|0;if(c>>>0<j>>>0)break a;else n=o}if((q|0)!=(n|0)){c=b[q>>0]|0;if(((c&-33)+-65&255)<26|c<<24>>24==95)t=m;else{b[m>>0]=95;t=m+1|0}if(q>>>0<n>>>0){c=t;p=q;while(1){s=b[p>>0]|0;p=p+1|0;r=c+1|0;b[c>>0]=s<<24>>24==95|(s<<24>>24==45|((s+-48&255)<10|((s&-33)+-65&255)<26))?s:95;if((p|0)==(n|0)){v=r;break}else c=r}}else v=t;b[v>>0]=0;c=f[e>>2]|0;if(!(GIc(c,388677)|0)){n=c;p=n;b[p>>0]=117;b[p+1>>0]=110;b[p+2>>0]=110;b[p+3>>0]=97;p=n+4|0;b[p>>0]=109;b[p+1>>0]=101;b[p+2>>0]=100;b[p+3>>0]=0};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;p=dJc(c)|0;if(p>>>0>4294967279)jYc(a);if(p>>>0<11){b[a+11>>0]=p;if(!p)w=a;else{x=a;y=23}}else{n=p+16&-16;r=$Xc(n)|0;f[a>>2]=r;f[a+8>>2]=n|-2147483648;f[a+4>>2]=p;x=r;y=23}if((y|0)==23){o1c(x|0,c|0,p|0)|0;w=x}b[w+p>>0]=0;p=f[e>>2]|0;if((p|0)==(k|0)){u=d;return}if(p|0)dYc(p);f[e>>2]=k;f[i>>2]=1032;u=d;return}}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=16;i=d;k=246083;e=i+16|0;do{b[i>>0]=b[k>>0]|0;i=i+1|0;k=k+1|0}while((i|0)<(e|0));b[d+16>>0]=0;vM(-5,g,246100,243595,1851)}function i5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=dJc(d)|0;if(h>>>0>4294967279)jYc(g);if(h>>>0<11){b[g+11>>0]=h;if(!h)i=g;else{j=g;k=6}}else{l=h+16&-16;m=$Xc(l)|0;f[g>>2]=m;f[g+8>>2]=l|-2147483648;f[g+4>>2]=h;j=m;k=6}if((k|0)==6){o1c(j|0,d|0,h|0)|0;i=j}b[i+h>>0]=0;j5(a,c,g);if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function j5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+48|0;g=e+36|0;i=e+24|0;j=e;k=f[c>>2]|0;if(!k){f[a>>2]=0;f[a+8>>2]=0;f[a+4>>2]=0;u=e;return}l=c+4|0;m=c+8|0;n=H3(f[k+20>>2]|0,f[l>>2]|0,f[m>>2]|0)|0;if(!n){o=g+8|0;f[o>>2]=0;p=g+11|0;b[p>>0]=7;b[g>>0]=b[246121]|0;b[g+1>>0]=b[246122]|0;b[g+2>>0]=b[246123]|0;b[g+3>>0]=b[246124]|0;b[g+4>>0]=b[246125]|0;b[g+5>>0]=b[246126]|0;b[g+6>>0]=b[246127]|0;q=g+7|0;b[q>>0]=0;vM(-215,g,528534,243595,2047)}if((b[n>>0]&7)!=5){o=g+8|0;f[o>>2]=0;p=g+11|0;b[p>>0]=7;b[g>>0]=b[246121]|0;b[g+1>>0]=b[246122]|0;b[g+2>>0]=b[246123]|0;b[g+3>>0]=b[246124]|0;b[g+4>>0]=b[246125]|0;b[g+5>>0]=b[246126]|0;b[g+6>>0]=b[246127]|0;q=g+7|0;b[q>>0]=0;vM(-215,g,528534,243595,2047)}q=D4((f[(f[c>>2]|0)+20>>2]|0)+240|0,d)|0;if(!q)r=0;else r=f[q+20>>2]|0;q=f[c>>2]|0;do if((q|0)!=0?(d=H3(f[q+20>>2]|0,f[l>>2]|0,f[m>>2]|0)|0,(d|0)!=0):0){p=h[d>>0]|0;o=p&7;if((o|1|0)==5){n=(p&32|0)==0?d:d+4|0;s=(h[n+6>>0]|0)<<8|(h[n+5>>0]|0)|(h[n+7>>0]|0)<<16|(h[n+8>>0]|0)<<24;break}else{s=(o|0)!=0&1;break}}else s=0;while(0);I3(j,c,0);a:do if(s){m=j+20|0;l=j+16|0;q=j+4|0;o=j+8|0;n=a+4|0;d=a+8|0;p=i+4|0;k=i+8|0;t=j+12|0;v=0;b:while(1){w=(f[m>>2]|0)>>>0<(f[l>>2]|0)>>>0?f[j>>2]|0:0;x=f[q>>2]|0;y=f[o>>2]|0;f[a>>2]=w;f[n>>2]=x;f[d>>2]=y;z=H3(f[w+20>>2]|0,x,y)|0;y=(h[z+2>>0]|0)<<8|(h[z+1>>0]|0)|(h[z+3>>0]|0)<<16|(h[z+4>>0]|0)<<24;z=f[(f[c>>2]|0)+20>>2]|0;if(y>>>0>=((f[z+264>>2]|0)-(f[z+260>>2]|0)|0)>>>0){A=17;break}if((r|0)==(y|0))break a;v=v+1|0;y=f[m>>2]|0;if(((y|0)!=(f[l>>2]|0)?(z=f[j>>2]|0,z|0):0)?(f[m>>2]=y+1,y=f[q>>2]|0,x=f[o>>2]|0,f[i>>2]=z,f[p>>2]=y,f[k>>2]=x,x=K3(i)|0,y=(f[o>>2]|0)+x|0,f[o>>2]=y,y>>>0>=(f[t>>2]|0)>>>0):0){x=f[(f[j>>2]|0)+20>>2]|0;z=f[q>>2]|0;w=f[x+224>>2]|0;B=f[w+(z<<2)>>2]|0;c:do if(y>>>0<B>>>0)C=B;else{D=((f[x+228>>2]|0)-w>>2)+-1|0;E=z;F=y;G=B;while(1){if((E|0)==(D|0))break;H=F-G|0;f[o>>2]=H;E=E+1|0;f[q>>2]=E;I=f[w+(E<<2)>>2]|0;if(H>>>0<I>>>0){C=I;break c}else{F=H;G=I}}if((F|0)!=(G|0)){A=28;break b}C=f[w+(D<<2)>>2]|0}while(0);f[t>>2]=C}if(v>>>0>=s>>>0){J=d;K=n;L=a;A=32;break a}}if((A|0)==17){n=$Xc(48)|0;f[g>>2]=n;f[g+8>>2]=-2147483600;f[g+4>>2]=34;M=n;N=246129;O=M+34|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[n+34>>0]=0;vM(-215,g,528534,243595,2058)}else if((A|0)==28){d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=30;M=d;N=244326;O=M+30|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[d+30>>0]=0;vM(-215,g,244357,243595,1459)}}else{J=a+8|0;K=a+4|0;L=a;A=32}while(0);if((A|0)==32){f[L>>2]=0;f[J>>2]=0;f[K>>2]=0}u=e;return}function k5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b+20>>2]|0;b=f[d+188>>2]|0;if((b|0)==(f[d+192>>2]|0)){f[a>>2]=0;f[a+8>>2]=0;f[a+4>>2]=0;return}else{j5(a,b,c);return}}function l5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;m5(f[a+20>>2]|0,b,c,d);return}function m5(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;i=u;u=u+1296|0;k=i+16|0;l=i+1040|0;m=i;if(!(b[a+38>>0]|0)){b[k+11>>0]=10;o=k;q=243584;r=o+10|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[k+10>>0]=0;vM(-215,k,246164,243595,1058)}t=c+11|0;v=a4((b[t>>0]|0)<0?f[c>>2]|0:c,0)|0;if((g>>>0)%(v>>>0)|0|0){w=$Xc(32)|0;f[k>>2]=w;f[k+8>>2]=-2147483616;f[k+4>>2]=19;o=w;q=246177;r=o+19|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[w+19>>0]=0;vM(-215,k,246164,243595,1061)}w=(g>>>0)/(v>>>0)|0;x=(f[a+40>>2]|0)==24;g1c(l|0,0,256)|0;y=$3((b[t>>0]|0)<0?f[c>>2]|0:c,k,128)|0;if(v>>>0>g>>>0){u=i;return}if(!e){c=$Xc(32)|0;f[m>>2]=c;f[m+8>>2]=-2147483616;f[m+4>>2]=17;o=c;q=246197;r=o+17|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[c+17>>0]=0;vM(-27,m,246164,243595,1075)}if((y|0)!=1)if(v>>>0>g>>>0){u=i;return}else z=w;else{g=Y(f[k>>2]|0,w)|0;f[k>>2]=g;z=1}g=(y|0)>0;w=l+23|0;c=a+120|0;a=e;e=z;a:while(1){e=e+-1|0;if(g){z=a;t=0;A=0;while(1){B=A<<1;C=f[k+(B<<2)>>2]|0;D=f[k+((B|1)<<2)>>2]|0;B=Y(675553809>>>(D<<2&28)&15,(D>>>3&511)+1|0)|0;E=a+(t+-1+B&0-B)|0;b:do if((C|0)>0){B=E;F=0;while(1){switch(D|0){case 0:{G=h[B>>0]|0;b[w>>0]=0;H=w;I=G;while(1){G=I;I=(I>>>0)/10|0;J=G+48+(Y(I,-10)|0)&255;K=H+-1|0;b[K>>0]=J;if(G>>>0<=9){L=K;M=1;break}else H=K}break}case 1:{H=b[B>>0]|0;I=H<<24>>24;b[w>>0]=0;K=w;G=H<<24>>24>-1?I:0-I|0;while(1){I=G;G=(G>>>0)/10|0;J=I+48+(Y(G,-10)|0)&255;N=K+-1|0;b[N>>0]=J;if(I>>>0<=9)break;else K=N}if(H<<24>>24<0){G=K+-2|0;b[G>>0]=45;L=G;M=1}else{L=N;M=1}break}case 2:{G=j[B>>1]|0;b[w>>0]=0;I=w;J=G;while(1){G=J;J=(J>>>0)/10|0;O=G+48+(Y(J,-10)|0)&255;P=I+-1|0;b[P>>0]=O;if(G>>>0<=9){L=P;M=2;break}else I=P}break}case 3:{I=d[B>>1]|0;J=I<<16>>16;b[w>>0]=0;K=w;H=I<<16>>16>-1?J:0-J|0;while(1){J=H;H=(H>>>0)/10|0;P=J+48+(Y(H,-10)|0)&255;Q=K+-1|0;b[Q>>0]=P;if(J>>>0<=9)break;else K=Q}if(I<<16>>16<0){H=K+-2|0;b[H>>0]=45;L=H;M=2}else{L=Q;M=2}break}case 4:{H=f[B>>2]|0;b[w>>0]=0;J=w;P=(H|0)>-1?H:0-H|0;while(1){G=P;P=(P>>>0)/10|0;O=G+48+(Y(P,-10)|0)&255;R=J+-1|0;b[R>>0]=O;if(G>>>0<=9)break;else J=R}if((H|0)<0){P=J+-2|0;b[P>>0]=45;L=P;M=4}else{L=R;M=4}break}case 5:{_3(l,+n[B>>2],0,x)|0;L=l;M=4;break}case 6:{Z3(l,+p[B>>3],x)|0;L=l;M=8;break}case 7:{P=j[B>>1]|0;K=P<<13;I=K&268427264;G=I+939524096|0;O=P<<16&-2147483648;S=P&31744;c:do if(S<<16>>16<31744){switch(S<<16>>16){case 0:break;default:{T=G;break c}}T=(n[s>>2]=(f[s>>2]=I+947912704,+n[s>>2])+-.00006103515625,f[s>>2]|0)}else{switch(S<<16>>16){case 31744:break;default:{T=G;break c}}T=K|1879048192}while(0);_3(l,(f[s>>2]=T|O,+n[s>>2]),1,x)|0;L=l;M=2;break}default:{U=38;break a}}K=B+M|0;G=f[c>>2]|0;Ti[f[(f[G>>2]|0)+28>>2]&511](G,0,L);F=F+1|0;if((F|0)>=(C|0)){V=K;break b}else B=K}}else V=E;while(0);A=A+1|0;if((A|0)>=(y|0))break;else t=V-z|0}}if(!e){U=42;break}else a=a+v|0}if((U|0)==38){v=$Xc(32)|0;f[m>>2]=v;f[m+8>>2]=-2147483616;f[m+4>>2]=16;o=v;q=272170;r=o+16|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[v+16>>0]=0;vM(-210,m,246164,243595,1133)}else if((U|0)==42){u=i;return}}function n5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d+12|0;g=d;h=f[a+20>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(!(b[h+38>>0]|0)){b[e+11>>0]=10;a=e;i=243584;j=a+10|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(j|0));b[e+10>>0]=0;vM(-215,e,250327,243595,1040)}e=f[h+120>>2]|0;Ti[f[(f[e>>2]|0)+16>>2]&511](e,g,c);if((b[g+11>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function o5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a+20>>2]|0;if(!(b[h+38>>0]|0)){b[g+11>>0]=10;a=g;i=243584;j=a+10|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(j|0));b[g+10>>0]=0;vM(-215,g,250327,243595,1040)}else{g=f[h+120>>2]|0;Ti[f[(f[g>>2]|0)+16>>2]&511](g,(b[c+11>>0]|0)<0?f[c>>2]|0:c,d);u=e;return}}function p5(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a+20>>2]|0;if(!(b[h+38>>0]|0)){b[g+11>>0]=10;a=g;i=243584;j=a+10|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(j|0));b[g+10>>0]=0;vM(-215,g,250327,243595,1046)}else{g=f[h+120>>2]|0;Vi[f[(f[g>>2]|0)+20>>2]&63](g,(b[c+11>>0]|0)<0?f[c>>2]|0:c,d);u=e;return}}function q5(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a+20>>2]|0;if(!(b[h+38>>0]|0)){b[g+11>>0]=10;a=g;i=243584;j=a+10|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(j|0));b[g+10>>0]=0;vM(-215,g,250327,243595,1046)}else{g=f[h+120>>2]|0;Vi[f[(f[g>>2]|0)+20>>2]&63](g,(b[c+11>>0]|0)<0?f[c>>2]|0:c,d);u=e;return}}function r5(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;e=c;g=f[a>>2]|0;a=g+20|0;y3(f[a>>2]|0);h=f[a>>2]|0;a=f[h+76>>2]|0;if(!a)i=6;else{j=a+-1+(f[h+72>>2]|0)|0;i=(f[(f[(f[h+60>>2]|0)+(((j>>>0)/204|0)<<2)>>2]|0)+(((j>>>0)%204|0)*20|0)+12>>2]&7|0)==5?6:1}f[g+4>>2]=i;f[e>>2]=0;d[e+4>>1]=0;b[e+6>>0]=0;i=g+8|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[g+12>>2]=0}else{b[i>>0]=0;b[j>>0]=0}sYc(i,0);f[g+8>>2]=0;i=g+12|0;f[i>>2]=f[e>>2];d[i+4>>1]=d[e+4>>1]|0;b[i+6>>0]=b[e+6>>0]|0;b[g+19>>0]=0;u=c;return}function s5(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+32|0;k=e+20|0;l=(b[c+11>>0]|0)<0?f[c>>2]|0:c;if(!((l|0)!=0&(_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0))){u=e;return a|0}m=a+20|0;n=b[l>>0]|0;o=n<<24>>24;switch(n<<24>>24){case 93:case 125:{p=f[m>>2]|0;q=f[p+76>>2]|0;if(!q){f[i>>2]=o;DM(j,246215,i);vM(-2,j,528568,243595,1973)}i=q+-1+(f[p+72>>2]|0)|0;q=(f[(f[(f[p+60>>2]|0)+(((i>>>0)/204|0)<<2)>>2]|0)+(((i>>>0)%204|0)*20|0)+12>>2]&7|0)==5?125:93;if((o|0)!=(q|0)){f[h>>2]=o;f[h+4>>2]=q;DM(j,246234,h);vM(-2,j,528568,243595,1978)}y3(p);p=f[m>>2]|0;h=f[p+76>>2]|0;if(!h){q=$Xc(32)|0;f[j>>2]=q;f[j+8>>2]=-2147483616;f[j+4>>2]=29;r=q;s=246283;t=r+29|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[q+29>>0]=0;vM(-215,j,528568,243595,1980)}q=h+-1+(f[p+72>>2]|0)|0;f[a+4>>2]=(f[(f[(f[p+60>>2]|0)+(((q>>>0)/204|0)<<2)>>2]|0)+(((q>>>0)%204|0)*20|0)+12>>2]&7|0)==5?6:1;f[j>>2]=0;d[j+4>>1]=0;b[j+6>>0]=0;q=a+8|0;p=q+11|0;if((b[p>>0]|0)<0){b[f[q>>2]>>0]=0;f[a+12>>2]=0}else{b[q>>0]=0;b[p>>0]=0}sYc(q,0);f[a+8>>2]=0;q=a+12|0;f[q>>2]=f[j>>2];d[q+4>>1]=d[j+4>>1]|0;b[q+6>>0]=b[j+6>>0]|0;b[a+19>>0]=0;u=e;return a|0}default:{}}q=a+4|0;p=f[q>>2]|0;if((p|0)==6){if(!(n<<24>>24==95|((n&-33)+-65&255)<26)){f[g>>2]=l;DM(j,246313,g);vM(-2,j,528568,243595,1988)}oYc(a+8|0,c)|0;f[q>>2]=5;u=e;return a|0}if((p&3|0)!=1){p=$Xc(32)|0;f[j>>2]=p;f[j+8>>2]=-2147483616;f[j+4>>2]=16;r=p;s=246374;t=r+16|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[p+16>>0]=0;vM(-2,j,528568,243595,2017)}p=n<<24>>24==123;switch(n<<24>>24){case 91:case 123:{g=p?5:4;f[q>>2]=p?6:1;p=l+1|0;h=b[p>>0]|0;o=l+2|0;if(h<<24>>24==58){i=b[o>>0]|0;v=i<<24>>24==0?g|8:g;w=o;x=i}else{v=g;w=p;x=h}h=f[m>>2]|0;m=a+8|0;p=m+11|0;g=b[p>>0]|0;i=g<<24>>24<0;o=a+12|0;do if((i?f[o>>2]|0:g&255)|0)if(i){y=f[m>>2]|0;break}else{y=m;break}else y=0;while(0);a5(h,y,v,x<<24>>24?w:0);f[j>>2]=0;d[j+4>>1]=0;b[j+6>>0]=0;if((b[p>>0]|0)<0){b[f[m>>2]>>0]=0;f[o>>2]=0}else{b[m>>0]=0;b[p>>0]=0}sYc(m,0);f[a+8>>2]=0;f[o>>2]=f[j>>2];d[o+4>>1]=d[j+4>>1]|0;b[o+6>>0]=b[j+6>>0]|0;b[a+19>>0]=0;u=e;return a|0}default:{}}o=a+8|0;a:do if(n<<24>>24==92){m=l+1|0;switch(b[m>>0]|0){case 93:case 91:case 125:case 123:break;default:{z=38;break a}}f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=dJc(m)|0;if(p>>>0>4294967279)jYc(k);if(p>>>0<11){b[k+11>>0]=p;if(!p)A=k;else{B=k;z=36}}else{w=p+16&-16;x=$Xc(w)|0;f[k>>2]=x;f[k+8>>2]=w|-2147483648;f[k+4>>2]=p;B=x;z=36}if((z|0)==36){o1c(B|0,m|0,p|0)|0;A=B}b[A+p>>0]=0}else z=38;while(0);if((z|0)==38)lYc(k,c);c=f[a+20>>2]|0;if(!(b[c+38>>0]|0)){b[j+11>>0]=10;r=j;s=243584;t=r+10|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[j+10>>0]=0;vM(-215,j,250327,243595,1052)}j=f[c+120>>2]|0;c=k+11|0;ei[f[(f[j>>2]|0)+24>>2]&511](j,(b[o+11>>0]|0)<0?f[o>>2]|0:o,(b[c>>0]|0)<0?f[k>>2]|0:k,0);if((b[c>>0]|0)<0)cYc(f[k>>2]|0);if((f[q>>2]|0)!=5){u=e;return a|0}f[q>>2]=6;u=e;return a|0}function t5(a){a=a|0;f[a>>2]=0;f[a+8>>2]=0;f[a+4>>2]=0;return}function u5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=b;f[a+4>>2]=c;f[a+8>>2]=d;return}function v5(a){a=a|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=0;return d|0}e=H3(f[c+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!e){d=0;return d|0}d=(b[e>>0]&7)==5;return d|0}function w5(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(!b){c=0;return c|0}d=H3(f[b+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!d){c=0;return c|0}a=h[d>>0]|0;b=a&7;if((b|1|0)==5){e=(a&32|0)==0?d:d+4|0;c=(h[e+6>>0]|0)<<8|(h[e+5>>0]|0)|(h[e+7>>0]|0)<<16|(h[e+8>>0]|0)<<24;return c|0}else{c=(b|0)!=0&1;return c|0}return 0}function x5(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=u;u=u+16|0;c=b;d=a+20|0;e=f[d>>2]|0;if((e|0)==(f[a+16>>2]|0)){u=b;return a|0}g=f[a>>2]|0;if(!g){u=b;return a|0}f[d>>2]=e+1;e=a+4|0;d=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;f[c>>2]=g;f[c+4>>2]=d;f[c+8>>2]=i;i=K3(c)|0;c=(f[h>>2]|0)+i|0;f[h>>2]=c;i=a+12|0;if(c>>>0>=(f[i>>2]|0)>>>0){L3(f[(f[a>>2]|0)+20>>2]|0,e,h);f[i>>2]=f[(f[(f[(f[a>>2]|0)+20>>2]|0)+224>>2]|0)+(f[e>>2]<<2)>>2]}u=b;return a|0}function y5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+32|0;g=e;i=f[c>>2]|0;if(!i){f[a>>2]=0;f[a+8>>2]=0;f[a+4>>2]=0;u=e;return}j=c+4|0;k=c+8|0;l=H3(f[i+20>>2]|0,f[j>>2]|0,f[k>>2]|0)|0;if(!l){m=g+8|0;f[m>>2]=0;n=g+11|0;b[n>>0]=7;b[g>>0]=b[246391]|0;b[g+1>>0]=b[246392]|0;b[g+2>>0]=b[246393]|0;b[g+3>>0]=b[246394]|0;b[g+4>>0]=b[246395]|0;b[g+5>>0]=b[246396]|0;b[g+6>>0]=b[246397]|0;o=g+7|0;b[o>>0]=0;vM(-215,g,528534,243595,2075)}if((b[l>>0]&7)!=4){m=g+8|0;f[m>>2]=0;n=g+11|0;b[n>>0]=7;b[g>>0]=b[246391]|0;b[g+1>>0]=b[246392]|0;b[g+2>>0]=b[246393]|0;b[g+3>>0]=b[246394]|0;b[g+4>>0]=b[246395]|0;b[g+5>>0]=b[246396]|0;b[g+6>>0]=b[246397]|0;o=g+7|0;b[o>>0]=0;vM(-215,g,528534,243595,2075)}o=f[c>>2]|0;do if((o|0)!=0?(n=H3(f[o+20>>2]|0,f[j>>2]|0,f[k>>2]|0)|0,(n|0)!=0):0){m=h[n>>0]|0;l=m&7;if((l|1|0)==5){i=(m&32|0)==0?n:n+4|0;p=(h[i+6>>0]|0)<<8|(h[i+5>>0]|0)|(h[i+7>>0]|0)<<16|(h[i+8>>0]|0)<<24;break}else{p=(l|0)!=0&1;break}}else p=0;while(0);if(!((d|0)>-1&(p|0)>(d|0))){p=$Xc(32)|0;f[g>>2]=p;f[g+8>>2]=-2147483616;f[g+4>>2]=16;k=p;j=246399;o=k+16|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(o|0));b[p+16>>0]=0;vM(-215,g,528534,243595,2078)}I3(g,c,0);z5(g,d)|0;d=f[g+4>>2]|0;c=f[g+8>>2]|0;f[a>>2]=(f[g+20>>2]|0)>>>0<(f[g+16>>2]|0)>>>0?f[g>>2]|0:0;f[a+4>>2]=d;f[a+8>>2]=c;u=e;return}function z5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;if((c|0)<=-1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=9;g=e;h=246416;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+9>>0]=0;vM(-215,e,528747,243595,2415)}if(!c){u=d;return a|0}h=a+20|0;g=a+16|0;i=a+4|0;j=a+8|0;k=e+4|0;l=e+8|0;m=a+12|0;n=c;while(1){c=f[h>>2]|0;if(((c|0)!=(f[g>>2]|0)?(o=f[a>>2]|0,o|0):0)?(f[h>>2]=c+1,c=f[i>>2]|0,p=f[j>>2]|0,f[e>>2]=o,f[k>>2]=c,f[l>>2]=p,p=K3(e)|0,c=(f[j>>2]|0)+p|0,f[j>>2]=c,c>>>0>=(f[m>>2]|0)>>>0):0){L3(f[(f[a>>2]|0)+20>>2]|0,i,j);f[m>>2]=f[(f[(f[(f[a>>2]|0)+20>>2]|0)+224>>2]|0)+(f[i>>2]<<2)>>2]}if((n|0)>1)n=n+-1|0;else break}u=d;return a|0}function A5(a){a=a|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=0;return d|0}e=H3(f[c+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!e){d=0;return d|0}d=(b[e>>0]&7)==4;return d|0}function B5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[a>>2]|0;g=e;if((((f[d>>2]|0)-e|0)/12|0)>>>0>=c>>>0)return;h=a+4|0;if(c>>>0>357913941){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}i=f[h>>2]|0;j=$Xc(c*12|0)|0;k=j+(((i-e|0)/12|0)*12|0)|0;l=k;m=j+(c*12|0)|0;c=i;if((c|0)==(g|0)){n=l;o=e;p=g}else{e=c;c=l;i=k;do{k=i+-12|0;e=e+-12|0;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[k+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=c+-12|0;c=i}while((e|0)!=(g|0));n=c;o=f[a>>2]|0;p=f[h>>2]|0}f[a>>2]=n;f[h>>2]=l;f[d>>2]=m;m=o;if((p|0)!=(m|0)){d=p;do{d=d+-12|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0)}while((d|0)!=(m|0))}if(!o)return;cYc(o);return}function C5(a){a=a|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=0;return d|0}e=H3(f[c+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!e){d=0;return d|0}d=b[e>>0]&7;return d|0}function D5(a){a=a|0;return (a&6|1|0)==5|0}function E5(a){a=a|0;return (a&8|0)!=0|0}function F5(a){a=a|0;return (a&16|0)!=0|0}function G5(a){a=a|0;return (f[a>>2]|0)==0|0}function H5(a){a=a|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=0;return d|0}e=H3(f[c+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!e){d=0;return d|0}a=b[e>>0]|0;c=e+((a&255)>>>3&4|1)|0;switch(a&7){case 1:{d=(h[c+1>>0]|0)<<8|(h[c>>0]|0)|(h[c+2>>0]|0)<<16|(h[c+3>>0]|0)<<24;return d|0}case 2:{f[s>>2]=(h[c+1>>0]|0)<<8|(h[c>>0]|0)|(h[c+2>>0]|0)<<16|(h[c+3>>0]|0)<<24;f[s+4>>2]=(h[c+5>>0]|0)<<8|(h[c+4>>0]|0)|(h[c+6>>0]|0)<<16|(h[c+7>>0]|0)<<24;d=zLc(+p[s>>3])|0;return d|0}default:{d=2147483647;return d|0}}return 0}function I5(a){a=a|0;var c=0,d=0.0,e=0;c=f[a>>2]|0;if(!c){d=0.0;return +d}e=H3(f[c+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!e){d=0.0;return +d}a=b[e>>0]|0;c=e+((a&255)>>>3&4|1)|0;switch(a&7){case 1:{d=+((h[c+1>>0]|0)<<8|(h[c>>0]|0)|(h[c+2>>0]|0)<<16|(h[c+3>>0]|0)<<24|0);return +d}case 2:{f[s>>2]=(h[c+1>>0]|0)<<8|(h[c>>0]|0)|(h[c+2>>0]|0)<<16|(h[c+3>>0]|0)<<24;f[s+4>>2]=(h[c+5>>0]|0)<<8|(h[c+4>>0]|0)|(h[c+6>>0]|0)<<16|(h[c+7>>0]|0)<<24;d=+p[s>>3];return +d}default:{d=3402823466385288598117041.0e14;return +d}}return +(0.0)}function J5(a){a=a|0;var c=0,d=0.0,e=0;c=f[a>>2]|0;if(!c){d=0.0;return +d}e=H3(f[c+20>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0)|0;if(!e){d=0.0;return +d}a=b[e>>0]|0;c=e+((a&255)>>>3&4|1)|0;switch(a&7){case 1:{d=+((h[c+1>>0]|0)<<8|(h[c>>0]|0)|(h[c+2>>0]|0)<<16|(h[c+3>>0]|0)<<24|0);return +d}case 2:{f[s>>2]=(h[c+1>>0]|0)<<8|(h[c>>0]|0)|(h[c+2>>0]|0)<<16|(h[c+3>>0]|0)<<24;f[s+4>>2]=(h[c+5>>0]|0)<<8|(h[c+4>>0]|0)|(h[c+6>>0]|0)<<16|(h[c+7>>0]|0)<<24;d=+p[s>>3];return +d}default:{d=1797693134862315708145274.0e284;return +d}}return +(0.0)}function K5(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h=u;u=u+1056|0;i=h+1040|0;j=h+16|0;k=h;if(!(f[a>>2]|0)){u=h;return a|0}l=a+20|0;m=a+16|0;if((f[l>>2]|0)>>>0>=(f[m>>2]|0)>>>0){u=h;return a|0}o=c+11|0;q=$3((b[o>>0]|0)<0?f[c>>2]|0:c,j,128)|0;r=a4((b[o>>0]|0)<0?f[c>>2]|0:c,0)|0;if((g>>>0)%(r>>>0)|0|0){c=$Xc(32)|0;f[i>>2]=c;f[i+8>>2]=-2147483616;f[i+4>>2]=16;t=c;v=246426;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[c+16>>0]=0;vM(-215,i,246443,243595,2430)}a:do if(r>>>0<=g>>>0){c=(q|0)>0;o=a+4|0;x=a+8|0;y=i+4|0;z=i+8|0;A=i+4|0;B=i+8|0;C=a+12|0;D=e;E=(g>>>0)/(r>>>0)|0;b:while(1){if(c){F=D;G=0;H=0;while(1){I=H<<1;J=f[j+((I|1)<<2)>>2]|0;K=Y(675553809>>>(J<<2&28)&15,(J>>>3&511)+1|0)|0;L=f[j+(I<<2)>>2]|0;I=D+(G+-1+K&0-K)|0;if((L|0)>0){K=0;M=I;while(1){if((f[l>>2]|0)>>>0>=(f[m>>2]|0)>>>0){N=13;break b}O=f[a>>2]|0;P=f[o>>2]|0;Q=f[x>>2]|0;f[i>>2]=O;f[y>>2]=P;f[z>>2]=Q;if(!O){N=49;break b}R=O+20|0;O=H3(f[R>>2]|0,P,Q)|0;c:do if((O|0)!=0?(b[O>>0]&7)==1:0){S=H5(i)|0;switch(J|0){case 0:{b[M>>0]=S>>>0<256?S:(S|0)>0?255:0;T=1;break c;break}case 1:{b[M>>0]=(S+128|0)>>>0<256?S:(S|0)>0?127:128;T=1;break c;break}case 2:{d[M>>1]=S>>>0<65536?S:(S|0)>0?65535:0;T=2;break c;break}case 3:{d[M>>1]=(S+32768|0)>>>0<65536?S:(S|0)>0?32767:32768;T=2;break c;break}case 4:{f[M>>2]=S;T=4;break c;break}case 5:{n[M>>2]=+(S|0);T=4;break c;break}case 6:{p[M>>3]=+(S|0);T=8;break c;break}case 7:{U=(n[s>>2]=+(S|0),f[s>>2]|0);S=U&-2147483648;V=S^U;do if(V>>>0<=1199570943)if(V>>>0<947912704){W=(n[s>>2]=(f[s>>2]=V,+n[s>>2])+.5,f[s>>2]|0);break}else{W=(U+134221823+(U>>>13&1)|0)>>>13;break}else W=V>>>0>2139095040?32256:31744;while(0);d[M>>1]=W|S>>>16;T=2;break c;break}default:{N=31;break b}}}else N=32;while(0);d:do if((N|0)==32){N=0;O=H3(f[R>>2]|0,P,Q)|0;if(!O){N=49;break b}if((b[O>>0]&7)!=2){N=49;break b}X=+J5(i);switch(J|0){case 0:{O=zLc(X)|0;b[M>>0]=O>>>0<256?O:(O|0)>0?255:0;T=1;break d;break}case 1:{O=zLc(X)|0;b[M>>0]=(O+128|0)>>>0<256?O:(O|0)>0?127:128;T=1;break d;break}case 2:{O=zLc(X)|0;d[M>>1]=O>>>0<65536?O:(O|0)>0?65535:0;T=2;break d;break}case 3:{O=zLc(X)|0;d[M>>1]=(O+32768|0)>>>0<65536?O:(O|0)>0?32767:32768;T=2;break d;break}case 4:{O=zLc(X)|0;f[M>>2]=O;T=4;break d;break}case 5:{n[M>>2]=X;T=4;break d;break}case 6:{p[M>>3]=X;T=8;break d;break}case 7:{O=(n[s>>2]=X,f[s>>2]|0);V=O&-2147483648;U=V^O;do if(U>>>0<=1199570943)if(U>>>0<947912704){Z=(n[s>>2]=(f[s>>2]=U,+n[s>>2])+.5,f[s>>2]|0);break}else{Z=(O+134221823+(O>>>13&1)|0)>>>13;break}else Z=U>>>0>2139095040?32256:31744;while(0);d[M>>1]=Z|V>>>16;T=2;break d;break}default:{N=48;break b}}}while(0);Q=M+T|0;K=K+1|0;P=f[l>>2]|0;if(((P|0)!=(f[m>>2]|0)?(R=f[a>>2]|0,R|0):0)?(f[l>>2]=P+1,P=f[o>>2]|0,U=f[x>>2]|0,f[i>>2]=R,f[A>>2]=P,f[B>>2]=U,U=K3(i)|0,P=(f[x>>2]|0)+U|0,f[x>>2]=P,P>>>0>=(f[C>>2]|0)>>>0):0){L3(f[(f[a>>2]|0)+20>>2]|0,o,x);f[C>>2]=f[(f[(f[(f[a>>2]|0)+20>>2]|0)+224>>2]|0)+(f[o>>2]<<2)>>2]}if((K|0)>=(L|0)){_=Q;break}else M=Q}}else _=I;H=H+1|0;if((H|0)>=(q|0))break;else G=_-F|0}}E=E+-1|0;if(!E)break a;else D=D+r|0}if((N|0)==13){D=f[o>>2]|0;E=f[x>>2]|0;f[i>>2]=0;f[y>>2]=D;f[z>>2]=E;$=$Xc(64)|0;f[k>>2]=$;aa=k+8|0;f[aa>>2]=-2147483584;ba=k+4|0;f[ba>>2]=63;t=$;v=246451;w=t+63|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));ca=$+63|0;b[ca>>0]=0;vM(-2,k,246443,243595,2532)}else if((N|0)==31){z=$Xc(32)|0;f[k>>2]=z;f[k+8>>2]=-2147483616;f[k+4>>2]=16;t=z;v=272170;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[z+16>>0]=0;vM(-210,k,246443,243595,2486)}else if((N|0)==48){y=$Xc(32)|0;f[k>>2]=y;f[k+8>>2]=-2147483616;f[k+4>>2]=16;t=y;v=272170;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[y+16>>0]=0;vM(-210,k,246443,243595,2528)}else if((N|0)==49){$=$Xc(64)|0;f[k>>2]=$;aa=k+8|0;f[aa>>2]=-2147483584;ba=k+4|0;f[ba>>2]=63;t=$;v=246451;w=t+63|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));ca=$+63|0;b[ca>>0]=0;vM(-2,k,246443,243595,2532)}}while(0);u=h;return a|0}function L5(a){a=a|0;return (f[a+16>>2]|0)-(f[a+20>>2]|0)|0}function M5(a,b,c){a=a|0;b=b|0;c=c|0;f[b>>2]=c;if(!(f[a>>2]|0))return;c=H5(a)|0;f[b>>2]=c;return}function N5(a,b,c){a=a|0;b=b|0;c=+c;p[b>>3]=c;if(!(f[a>>2]|0))return;c=+J5(a);p[b>>3]=c;return}function O5(a,b,c){a=a|0;b=b|0;c=+c;n[b>>2]=c;if(!(f[a>>2]|0))return;c=+I5(a);n[b>>2]=c;return}function P5(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[a>>2]=c;a5(f[c+20>>2]|0,(b[e+11>>0]|0)<0?f[e>>2]|0:e,g,(b[h+11>>0]|0)<0?f[h>>2]|0:h);f[j>>2]=0;d[j+4>>1]=0;b[j+6>>0]=0;h=c+8|0;e=h+11|0;if((b[e>>0]|0)<0){b[f[h>>2]>>0]=0;f[c+12>>2]=0}else{b[h>>0]=0;b[e>>0]=0}sYc(h,0);f[c+8>>2]=0;h=c+12|0;f[h>>2]=f[j>>2];d[h+4>>1]=d[j+4>>1]|0;b[h+6>>0]=b[j+6>>0]|0;b[c+19>>0]=0;f[c+4>>2]=(g&7|0)==4?1:6;u=i;return}function Q5(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(20)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=48784;d=c+12|0;f[d>>2]=48812;f[c+16>>2]=b;f[a>>2]=d;f[a+4>>2]=c;return}function R5(a){a=a|0;return}function S5(a){a=a|0;cYc(a);return}function T5(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+32|0;j=i+12|0;k=i;f[j>>2]=0;l=j+4|0;f[l>>2]=0;f[j+8>>2]=0;if(h|0?b[h>>0]|0:0){f[k+8>>2]=0;m=k+11|0;b[m>>0]=7;b[k>>0]=b[247727]|0;b[k+1>>0]=b[247728]|0;b[k+2>>0]=b[247729]|0;b[k+3>>0]=b[247730]|0;b[k+4>>0]=b[247731]|0;b[k+5>>0]=b[247732]|0;b[k+6>>0]=b[247733]|0;b[k+7>>0]=0;n=j+8|0;QA(j,k);if((b[m>>0]|0)<0)cYc(f[k>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;m=dJc(h)|0;if(m>>>0>4294967279)jYc(k);if(m>>>0<11){b[k+11>>0]=m;if(!m)o=k;else{p=k;q=10}}else{r=m+16&-16;s=$Xc(r)|0;f[k>>2]=s;f[k+8>>2]=r|-2147483648;f[k+4>>2]=m;p=s;q=10}if((q|0)==10){o1c(p|0,h|0,m|0)|0;o=p}b[o+m>>0]=0;m=f[l>>2]|0;if(m>>>0>=(f[n>>2]|0)>>>0){QA(j,k);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0)}else{f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];f[m+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[l>>2]=(f[l>>2]|0)+12}}$5(c,e,1,j);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;if(e){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;c=dJc(e)|0;if(c>>>0>4294967279)jYc(k);if(c>>>0<11){b[k+11>>0]=c;if(!c)t=k;else{v=k;q=22}}else{m=c+16&-16;n=$Xc(m)|0;f[k>>2]=n;f[k+8>>2]=m|-2147483648;f[k+4>>2]=c;v=n;q=22}if((q|0)==22){o1c(v|0,e|0,c|0)|0;t=v}b[t+c>>0]=0;c=a+11|0;if((b[c>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0;w=a}else{x=c;y=a;q=26}}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;x=a+11|0;y=a;q=26}if((q|0)==26){b[a>>0]=0;b[x>>0]=0;w=y}sYc(w,0);f[a>>2]=f[k>>2];f[a+4>>2]=f[k+4>>2];f[a+8>>2]=f[k+8>>2];k=f[j>>2]|0;w=(f[d+16>>2]|0)+2|0;f[a+12>>2]=g;f[a+16>>2]=w;if(!k){u=i;return}w=f[l>>2]|0;if((w|0)==(k|0))z=k;else{a=w;while(1){w=a+-12|0;f[l>>2]=w;if((b[w+11>>0]|0)<0){cYc(f[w>>2]|0);A=f[l>>2]|0}else A=w;if((A|0)==(k|0))break;else a=A}z=f[j>>2]|0}cYc(z);u=i;return}function U5(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=(b[c+11>>0]|0)<0?f[c>>2]|0:c;f[e>>2]=0;c=e+4|0;f[c>>2]=0;f[e+8>>2]=0;$5(a,g,2,e);g=f[e>>2]|0;if(!g){u=d;return}a=f[c>>2]|0;if((a|0)==(g|0))h=g;else{i=a;while(1){a=i+-12|0;f[c>>2]=a;if((b[a+11>>0]|0)<0){cYc(f[a>>2]|0);j=f[c>>2]|0}else j=a;if((j|0)==(g|0))break;else i=j}h=f[e>>2]|0}cYc(h);u=d;return}function V5(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+128|0;e=Y3(c,d,10)|0;Ti[f[(f[a>>2]|0)+28>>2]&511](a,b,e);u=d;return}function W5(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+128|0;e=f[(f[a>>2]|0)+28>>2]|0;g=Z3(d,c,0)|0;Ti[e&511](a,b,g);u=d;return}function X5(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+24608|0;h=g;i=g+16|0;j=g+4|0;if(!d){k=$Xc(32)|0;f[j>>2]=k;f[j+8>>2]=-2147483616;f[j+4>>2]=19;l=k;m=250307;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+19>>0]=0;vM(-27,j,250327,247307,161)}k=dJc(d)|0;if((k|0)>4096){o=$Xc(32)|0;f[j>>2]=o;f[j+8>>2]=-2147483616;f[j+4>>2]=30;l=o;m=250333;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+30>>0]=0;vM(-5,j,250327,247307,165)}j=(k|0)==0|e;if((!j?(b[d>>0]|0)==34:0)?(b[d+(k+-1)>>0]|0)==34:0){p=d;q=f[a>>2]|0;r=q+28|0;s=f[r>>2]|0;Ti[s&511](a,c,p);u=g;return}e=i+1|0;b[i>>0]=34;if((k|0)>0){o=j;m=0;l=e;while(1){n=b[d+m>>0]|0;t=n&255;a:do if(n<<24>>24<0|n<<24>>24==32){b[l>>0]=n;v=l;w=1}else{b:do if((n&255)>=32){switch(n<<24>>24){case 34:case 38:case 39:case 60:case 62:{break b;break}default:{}}b[l>>0]=n;v=l;w=o;break a}while(0);x=l+1|0;b[l>>0]=38;switch(n<<24>>24){case 60:{b[x>>0]=108;b[x+1>>0]=116;y=3;break}case 62:{b[x>>0]=103;b[x+1>>0]=116;y=3;break}case 38:{b[x>>0]=b[247716]|0;b[x+1>>0]=b[247717]|0;b[x+2>>0]=b[247718]|0;y=4;break}case 39:{b[x>>0]=97;b[x+1>>0]=112;b[x+2>>0]=111;b[x+3>>0]=115;y=5;break}case 34:{b[x>>0]=113;b[x+1>>0]=117;b[x+2>>0]=111;b[x+3>>0]=116;y=5;break}default:{f[h>>2]=t;cLc(x,247720,h)|0;y=5}}x=l+y|0;b[x>>0]=59;v=x;w=1}while(0);t=v+1|0;m=m+1|0;if((m|0)==(k|0)){z=t;A=w;break}else{o=w;l=t}}}else{z=e;A=j}if(!A?(A=b[d>>0]|0,(A+-48&255)>=10):0)switch(A<<24>>24){case 46:case 45:case 43:{B=26;break}default:{C=1;D=z}}else B=26;if((B|0)==26){b[z>>0]=34;C=0;D=z+1|0}b[D>>0]=0;p=i+C|0;q=f[a>>2]|0;r=q+28|0;s=f[r>>2]|0;Ti[s&511](a,c,p);u=g;return}function Y5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=dJc(d)|0;if(!c)i=0;else i=(b[c>>0]|0)==0?0:c;c=a+4|0;j=f[c>>2]|0;k=_i[f[(f[j>>2]|0)+68>>2]&2047](j)|0;j=k+12|0;l=f[j>>2]|0;if(!(b5(l)|0)?(m=(i|0)!=0,!(m&((D5(l)|0)^1))):0){l=f[c>>2]|0;n=_i[f[(f[l>>2]|0)+40>>2]&2047](l)|0;l=f[c>>2]|0;o=n-(_i[f[(f[l>>2]|0)+44>>2]&2047](l)|0)+h|0;if(m){m=$Xc(64)|0;f[g>>2]=m;f[g+8>>2]=-2147483584;f[g+4>>2]=49;l=m;p=247451;q=l+49|0;do{b[l>>0]=b[p>>0]|0;l=l+1|0;p=p+1|0}while((l|0)<(q|0));b[m+49>>0]=0;vM(-5,g,250074,247307,258)}f[j>>2]=4;j=f[c>>2]|0;if((o|0)>(_i[f[(f[j>>2]|0)+64>>2]&2047](j)|0)?(o-(f[k+16>>2]|0)|0)>10:0)r=26;else r=24;do if((r|0)==24){o=f[c>>2]|0;if(n>>>0>(_i[f[(f[o>>2]|0)+44>>2]&2047](o)|0)>>>0?(b[n+-1>>0]|0)==62:0){r=26;break}o=f[c>>2]|0;j=_i[f[(f[o>>2]|0)+44>>2]&2047](o)|0;if(n>>>0>(j+(f[k+16>>2]|0)|0)>>>0?(b[n+-1>>0]|0)!=62:0){b[n>>0]=32;s=n+1|0}else s=n}while(0);if((r|0)==26){r=f[c>>2]|0;s=_i[f[(f[r>>2]|0)+56>>2]&2047](r)|0}o1c(s|0,d|0,h|0)|0;r=f[c>>2]|0;mi[f[(f[r>>2]|0)+52>>2]&2047](r,s+h|0);u=e;return}f[g>>2]=0;s=g+4|0;f[s>>2]=0;f[g+8>>2]=0;$5(a,i,1,g);r=f[g>>2]|0;if(r|0){n=f[s>>2]|0;if((n|0)==(r|0))t=r;else{k=n;while(1){n=k+-12|0;f[s>>2]=n;if((b[n+11>>0]|0)<0){cYc(f[n>>2]|0);v=f[s>>2]|0}else v=n;if((v|0)==(r|0))break;else k=v}t=f[g>>2]|0}cYc(t)}t=f[c>>2]|0;v=f[t>>2]|0;k=f[v+36>>2]|0;r=_i[f[v+40>>2]&2047](t)|0;v=hj[k&511](t,r,h)|0;o1c(v|0,d|0,h|0)|0;d=f[c>>2]|0;mi[f[(f[d>>2]|0)+52>>2]&2047](d,v+h|0);f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;$5(a,i,2,g);i=f[g>>2]|0;if(i|0){a=f[h>>2]|0;if((a|0)==(i|0))w=i;else{v=a;while(1){a=v+-12|0;f[h>>2]=a;if((b[a+11>>0]|0)<0){cYc(f[a>>2]|0);x=f[h>>2]|0}else x=a;if((x|0)==(i|0))break;else v=x}w=f[g>>2]|0}cYc(w)}u=e;return}function Z5(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;h=e+4|0;i=a+4|0;a=f[i>>2]|0;j=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;if(!c){a=$Xc(16)|0;f[h>>2]=a;f[h+8>>2]=-2147483632;f[h+4>>2]=12;k=a;l=249950;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[a+12>>0]=0;vM(-27,h,249963,247307,284)}if(RKc(c,528179)|0){a=$Xc(64)|0;f[h>>2]=a;f[h+8>>2]=-2147483584;f[h+4>>2]=49;k=a;l=247384;m=k+49|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[a+49>>0]=0;vM(-5,h,249963,247307,287)}h=dJc(c)|0;a=OJc(c,10)|0;l=(a|0)!=0;k=f[i>>2]|0;m=_i[f[(f[k>>2]|0)+40>>2]&2047](k)|0;if(!(l|d^1)?(d=f[i>>2]|0,((_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0)-m|0)>=(h+5|0)):0){d=f[i>>2]|0;k=_i[f[(f[d>>2]|0)+44>>2]&2047](d)|0;if(m>>>0>(k+(f[j+16>>2]|0)|0)>>>0){b[m>>0]=32;n=m+1|0}else n=m}else{m=f[i>>2]|0;n=_i[f[(f[m>>2]|0)+56>>2]&2047](m)|0}if(l){b[n>>0]=b[247446]|0;b[n+1>>0]=b[247447]|0;b[n+2>>0]=b[247448]|0;b[n+3>>0]=b[247449]|0;b[n+4>>0]=b[247450]|0;o=4;p=n}else{m=f[i>>2]|0;j=hj[f[(f[m>>2]|0)+36>>2]&511](m,n,h+9|0)|0;f[g>>2]=c;cLc(j,247434,g)|0;o=dJc(j)|0;p=j}j=f[i>>2]|0;mi[f[(f[j>>2]|0)+52>>2]&2047](j,p+o|0);o=f[i>>2]|0;p=_i[f[(f[o>>2]|0)+56>>2]&2047](o)|0;if(l){q=a;r=c;s=p}else{u=e;return}while(1){if(!q){p=dJc(r)|0;c=f[i>>2]|0;a=hj[f[(f[c>>2]|0)+36>>2]&511](c,s,p)|0;o1c(a|0,r|0,p|0)|0;t=0;v=0;w=a+p|0}else{p=f[i>>2]|0;a=q-r|0;c=a+1|0;l=hj[f[(f[p>>2]|0)+36>>2]&511](p,s,c)|0;o1c(l|0,r|0,c|0)|0;c=q+1|0;t=OJc(c,10)|0;v=c;w=l+a|0}a=f[i>>2]|0;mi[f[(f[a>>2]|0)+52>>2]&2047](a,w);a=f[i>>2]|0;s=_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0;if(!v)break;else{q=t;r=v}}b[s>>0]=45;b[s+1>>0]=45;b[s+2>>0]=62;b[s+3>>0]=0;v=f[i>>2]|0;mi[f[(f[v>>2]|0)+52>>2]&2047](v,s+3|0);s=f[i>>2]|0;_i[f[(f[s>>2]|0)+56>>2]&2047](s)|0;u=e;return}function _5(a){a=a|0;var b=0;b=f[a+4>>2]|0;mi[f[(f[b>>2]|0)+12>>2]&2047](b,247284);return}function $5(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+16|0;h=g;i=a+4|0;a=f[i>>2]|0;j=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;a=f[i>>2]|0;k=(_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0)+12|0;a=f[k>>2]|0;if(!c)l=0;else l=(b[c>>0]|0)==0?0:c;c=(d|0)==3;if((d|2|0)==3){if(D5(a)|0)if((l|0)!=0^(b5(a)|0)){m=$Xc(96)|0;f[h>>2]=m;f[h+8>>2]=-2147483552;f[h+4>>2]=85;n=m;o=250106;p=n+85|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+85>>0]=0;vM(-5,h,247501,247307,49)}else q=a;else q=l|0?21:20;if(F5(q)|0){r=j;s=q}else{m=f[i>>2]|0;r=_i[f[(f[m>>2]|0)+56>>2]&2047](m)|0;s=q}}else{r=j;s=a}if(l)if((b[l>>0]|0)==95?(b[l+1>>0]|0)==0:0){a=$Xc(48)|0;f[h>>2]=a;f[h+8>>2]=-2147483600;f[h+4>>2]=33;n=a;o=247510;p=n+33|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[a+33>>0]=0;vM(-5,h,247501,247307,64)}else t=l;else t=388677;l=dJc(t)|0;a=r+1|0;b[r>>0]=60;do if((d|0)==2)if((f[e>>2]|0)==(f[e+4>>2]|0)){b[a>>0]=47;v=r+2|0;break}else{j=$Xc(48)|0;f[h>>2]=j;f[h+8>>2]=-2147483600;f[h+4>>2]=45;n=j;o=247544;p=n+45|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[j+45>>0]=0;vM(-5,h,247501,247307,71)}else v=a;while(0);a=b[t>>0]|0;if(!(((a&-33)+-65&255)<26|a<<24>>24==95)){a=$Xc(48)|0;f[h>>2]=a;f[h+8>>2]=-2147483600;f[h+4>>2]=35;n=a;o=247590;p=n+35|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[a+35>>0]=0;vM(-5,h,247501,247307,76)}a=f[i>>2]|0;r=hj[f[(f[a>>2]|0)+36>>2]&511](a,v,l)|0;a:do if((l|0)>0){v=0;b:while(1){a=b[t+v>>0]|0;if(!((a+-48&255)<10|((a&-33)+-65&255)<26))switch(a<<24>>24){case 45:case 95:break;default:break b}b[r+v>>0]=a;v=v+1|0;if((v|0)>=(l|0))break a}v=$Xc(80)|0;f[h>>2]=v;f[h+8>>2]=-2147483568;f[h+4>>2]=74;n=v;o=247626;p=n+74|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[v+74>>0]=0;vM(-5,h,247501,247307,83)}while(0);t=f[e>>2]|0;j=(f[e+4>>2]|0)-t|0;a=(j|0)/12|0;d=t;if(a&1|0){t=$Xc(16)|0;f[h>>2]=t;f[h+8>>2]=-2147483632;f[h+4>>2]=14;n=t;o=247701;p=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[t+14>>0]=0;vM(-215,h,247501,247307,89)}t=r+l|0;c:do if((j|0)>0){l=0;r=t;o=d;while(1){n=b[o+(l*12|0)+11>>0]|0;if(n<<24>>24<0)w=f[o+(l*12|0)+4>>2]|0;else w=n&255;n=l|1;p=b[o+(n*12|0)+11>>0]|0;if(p<<24>>24<0)x=f[o+(n*12|0)+4>>2]|0;else x=p&255;if(!w)break;p=f[i>>2]|0;q=hj[f[(f[p>>2]|0)+36>>2]&511](p,r,w+4+x|0)|0;p=q+1|0;b[q>>0]=32;q=(f[e>>2]|0)+(l*12|0)|0;if((b[q+11>>0]|0)<0)y=f[q>>2]|0;else y=q;o1c(p|0,y|0,w|0)|0;q=p+w|0;p=q+1|0;b[q>>0]=61;q=p+1|0;b[p>>0]=34;if(x|0){p=(f[e>>2]|0)+(n*12|0)|0;if((b[p+11>>0]|0)<0)z=f[p>>2]|0;else z=p;o1c(q|0,z|0,x|0)|0}p=q+x|0;q=p+1|0;b[p>>0]=34;p=l+2|0;if((p|0)>=(a|0)){A=q;break c}l=p;r=q;o=f[e>>2]|0}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=8;o=h;f[o>>2]=812541292;f[o+4>>2]=807419424;b[h+8>>0]=0;vM(-215,h,247501,247307,95)}else A=t;while(0);if(!c){B=A;C=B+1|0;b[B>>0]=62;D=f[i>>2]|0;E=f[D>>2]|0;F=E+52|0;G=f[F>>2]|0;mi[G&2047](D,C);H=s&-17;f[k>>2]=H;u=g;return}b[A>>0]=47;B=A+1|0;C=B+1|0;b[B>>0]=62;D=f[i>>2]|0;E=f[D>>2]|0;F=E+52|0;G=f[F>>2]|0;mi[G&2047](D,C);H=s&-17;f[k>>2]=H;u=g;return}function a6(a){a=a|0;NXc(a);return}function b6(a){a=a|0;NXc(a);cYc(a);return}function c6(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function d6(a){a=a|0;cYc(a);return}function e6(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(4132)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=48860;d=c+12|0;f[d>>2]=48888;f[c+16>>2]=b;f[a>>2]=d;f[a+4>>2]=c;return}function f6(a){a=a|0;return}function g6(a){a=a|0;cYc(a);return}function h6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+80|0;e=d+64|0;g=d+52|0;h=d+40|0;i=d+36|0;j=d+24|0;k=d+12|0;l=d;m=a+4|0;if(!(f[m>>2]|0)){f[e+8>>2]=0;b[e+11>>0]=7;b[e>>0]=b[247878]|0;b[e+1>>0]=b[247879]|0;b[e+2>>0]=b[247880]|0;b[e+3>>0]=b[247881]|0;b[e+4>>0]=b[247882]|0;b[e+5>>0]=b[247883]|0;b[e+6>>0]=b[247884]|0;b[e+7>>0]=0;vM(-215,e,477096,247307,776)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;n=j6(a,c,2)|0;if(WKc(n,247886,5)|0){c=f[m>>2]|0;o=f[(f[c>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=$Xc(48)|0;f[j>>2]=p;f[j+8>>2]=-2147483600;f[j+4>>2]=41;q=p;r=247892;s=q+41|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[p+41>>0]=0;gi[o&255](c,477096,j,247307,786);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}c=k6(a,n,e,h,i)|0;n=f[m>>2]|0;u5(j,_i[f[(f[n>>2]|0)+8>>2]&2047](n)|0,0,0);n=e+11|0;o=e+4|0;p=l+11|0;t=g+11|0;v=g+4|0;w=l+8|0;x=l+4|0;y=l+11|0;z=k+8|0;A=k+4|0;B=k+11|0;C=0;D=c;a:while(1){c=D;do{if(!c)break a;if(!(b[c>>0]|0))break a;c=j6(a,c,0)|0}while(!(b[c>>0]|0));E=k6(a,c,e,h,i)|0;if(!(((f[i>>2]|0)==1?(F=b[n>>0]|0,((F<<24>>24<0?f[o>>2]|0:F&255)|0)==14):0)?!(LYc(e,0,-1,247934,14)|0):0)){F=f[m>>2]|0;G=f[(f[F>>2]|0)+92>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;H=$Xc(32)|0;f[k>>2]=H;f[z>>2]=-2147483616;f[A>>2]=31;q=H;r=247949;s=q+31|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[H+31>>0]=0;gi[G&255](F,477096,k,247307,799);if((b[B>>0]|0)<0)cYc(f[k>>2]|0)}c=f[m>>2]|0;I=f[(f[c>>2]|0)+76>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Ii[I&127](k,c,j,l,5,0,-1);if((b[p>>0]|0)<0)cYc(f[l>>2]|0);c=k6(a,l6(a,E,k)|0,g,h,i)|0;b:do if((f[i>>2]|0)==2?(I=b[n>>0]|0,J=I<<24>>24<0,K=I&255,I=J?f[o>>2]|0:K,L=b[t>>0]|0,M=L<<24>>24<0,(I|0)==((M?f[v>>2]|0:L&255)|0)):0){L=f[e>>2]|0;N=J?L:e;O=M?f[g>>2]|0:g;M=(I|0)==0;if(J){if(M)break;if(!(WKc(N,O,I)|0))break;else{P=29;break}}if(!M)if((L&255)<<24>>24==(b[O>>0]|0)){L=e;M=K;K=O;while(1){M=M+-1|0;L=L+1|0;if(!M)break b;K=K+1|0;if((b[L>>0]|0)!=(b[K>>0]|0)){P=29;break}}}else P=29}else P=29;while(0);if((P|0)==29){P=0;E=f[m>>2]|0;F=f[(f[E>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;G=$Xc(48)|0;f[l>>2]=G;f[w>>2]=-2147483600;f[x>>2]=32;q=G;r=247981;s=q+32|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[G+32>>0]=0;gi[F&255](E,477096,l,247307,804);if((b[y>>0]|0)<0)cYc(f[l>>2]|0)}C=1;D=j6(a,c,0)|0}a=f[m>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=9;q=k;r=248014;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[k+9>>0]=0;vM(-215,k,477096,247307,809)}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[t>>0]|0)<0)cYc(f[g>>2]|0);if((b[n>>0]|0)>=0){u=d;return C|0}cYc(f[e>>2]|0);u=d;return C|0}function i6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;h=d;i=j6(a,c,2)|0;f[g>>2]=i;f[e>>2]=i;if(!i){j=0;u=d;return j|0}e=b[i>>0]|0;switch(e<<24>>24){case 60:case 0:{j=0;u=d;return j|0}default:{}}if((e&255)>31){c=i;while(1){k=c+1|0;l=b[k>>0]|0;if((l&255)>31)c=k;else{m=k;n=l;break}}}else{m=i;n=e}if(!(n<<24>>24)){n=f[a+4>>2]|0;a=f[(f[n>>2]|0)+92>>2]|0;e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=22;i=e;c=249074;l=i+22|0;do{b[i>>0]=b[c>>0]|0;i=i+1|0;c=c+1|0}while((i|0)<(l|0));b[e+22>>0]=0;gi[a&255](n,250654,h,247307,436);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}f[g>>2]=m;j=1;u=d;return j|0}function j6(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+16|0;g=e;h=a+4|0;a=g+8|0;i=g+4|0;j=g+11|0;k=g+8|0;l=g+4|0;m=g+11|0;n=0;o=d;d=c;a:while(1){c=d+-1|0;b:do switch(o|0){case 1:{p=b[d>>0]|0;c:do if((p&255)>31|p<<24>>24==9){q=c;r=p;s=d;while(1){if((r<<24>>24==45?(b[q+2>>0]|0)==45:0)?(b[q+3>>0]|0)==62:0){t=q;v=45;w=s;break c}x=s+1|0;y=b[x>>0]|0;if((y&255)>31|y<<24>>24==9){z=s;r=y;s=x;q=z}else{t=s;v=y;w=x;break}}}else{t=c;v=p;w=d}while(0);p=v<<24>>24==45;A=(p^1)&1;B=n;C=p?t+4|0:w;break}case 3:{p=n;s=c;while(1){q=s+1|0;r=b[q>>0]|0;x=(r<<24>>24==60&1)+p+((r<<24>>24==62)<<31>>31)|0;if((x|0)<0){D=q;E=28;break a}if((r&255)>31|r<<24>>24==9){p=x;s=q}else{A=3;B=x;C=q;break}}break}default:{s=c;d:while(1){F=s+1|0;G=b[F>>0]|0;switch(G<<24>>24){case 9:case 32:{s=F;break}case 60:{break d;break}default:{E=20;break d}}}if((E|0)==20){E=0;if((G&255)>31){D=F;E=28;break a}else{A=o;B=n;C=F;break b}}if((b[s+2>>0]|0)!=33){D=F;E=28;break a}if((b[s+3>>0]|0)!=45){D=F;E=28;break a}if((b[s+4>>0]|0)!=45){D=F;E=28;break a}if(o|0){p=f[h>>2]|0;q=f[(f[p>>2]|0)+92>>2]|0;x=$Xc(32)|0;f[g>>2]=x;f[k>>2]=-2147483616;f[l>>2]=29;H=x;I=247848;J=H+29|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[x+29>>0]=0;gi[q&255](p,251383,g,247307,402);if((b[m>>0]|0)<0)cYc(f[g>>2]|0)}A=1;B=n;C=s+5|0}}while(0);c=b[C>>0]|0;if((c&255)>31){n=B;o=A;d=C;continue}switch(c<<24>>24){case 13:case 10:case 0:break;default:{c=f[h>>2]|0;r=f[(f[c>>2]|0)+92>>2]|0;y=$Xc(32)|0;f[g>>2]=y;f[a>>2]=-2147483616;f[i>>2]=31;H=y;I=251394;J=H+31|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[y+31>>0]=0;gi[r&255](c,251383,g,247307,413);if((b[j>>0]|0)<0)cYc(f[g>>2]|0)}}z=f[h>>2]|0;K=_i[f[(f[z>>2]|0)+16>>2]&2047](z)|0;if(!K){D=0;E=28;break}if(!(b[K>>0]|0)){D=K;E=28;break}else{n=B;o=A;d=K}}if((E|0)==28){u=e;return D|0}return 0}function k6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;h=u;u=u+32|0;i=h+12|0;j=h;k=b[c>>0]|0;if(!(k<<24>>24)){l=f[a+4>>2]|0;m=f[(f[l>>2]|0)+92>>2]|0;n=$Xc(32)|0;f[i>>2]=n;f[i+8>>2]=-2147483616;f[i+4>>2]=28;o=n;p=248404;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+28>>0]=0;gi[m&255](l,248433,i,247307,649);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);r=b[c>>0]|0}else r=k;if(r<<24>>24!=60){r=f[a+4>>2]|0;k=f[(f[r>>2]|0)+92>>2]|0;l=$Xc(32)|0;f[i>>2]=l;f[i+8>>2]=-2147483616;f[i+4>>2]=25;o=l;p=248442;q=o+25|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+25>>0]=0;gi[k&255](r,248433,i,247307,652);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}r=c+1|0;k=b[r>>0]|0;if(!(k<<24>>24)){l=a+4|0;m=f[l>>2]|0;if((r|0)==((_i[f[(f[m>>2]|0)+48>>2]&2047](m)|0)+-1|0)){m=f[l>>2]|0;l=f[(f[m>>2]|0)+92>>2]|0;n=$Xc(64)|0;f[i>>2]=n;f[i+8>>2]=-2147483584;f[i+4>>2]=50;o=n;p=250984;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+50>>0]=0;gi[l&255](m,248433,i,247307,655);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}s=b[r>>0]|0}else s=k;a:do if((s+-48&255)<10|((s&-33)+-65&255)<26)t=17;else switch(s<<24>>24){case 95:{t=17;break a;break}case 47:{f[g>>2]=2;v=c+2|0;break a;break}case 63:{f[g>>2]=4;v=c+2|0;break a;break}case 33:{f[g>>2]=5;v=c+2|0;break a;break}default:{k=f[a+4>>2]|0;m=f[(f[k>>2]|0)+92>>2]|0;l=$Xc(32)|0;f[i>>2]=l;f[i+8>>2]=-2147483616;f[i+4>>2]=16;o=l;p=248468;q=o+16|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+16>>0]=0;gi[m&255](k,248433,i,247307,676);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);v=r;break a}}while(0);if((t|0)==17){f[g>>2]=1;v=r}r=d+11|0;if((b[r>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0}else{b[d>>0]=0;b[r>>0]=0}c=e+11|0;if((b[c>>0]|0)<0){b[f[e>>2]>>0]=0;s=e+4|0;f[s>>2]=0;w=e;x=e;y=s}else{b[e>>0]=0;b[c>>0]=0;w=e;x=e;y=e+4|0}s=i+11|0;n=a+4|0;z=j+8|0;A=j+4|0;B=j+11|0;C=d+4|0;D=j+8|0;E=j+4|0;F=j+11|0;G=j+8|0;H=j+4|0;I=j+11|0;J=j+8|0;K=j+4|0;L=j+11|0;M=j+8|0;N=j+4|0;O=j+11|0;P=j+8|0;Q=j+4|0;R=j+11|0;S=i+4|0;T=j+11|0;U=j+8|0;V=j+4|0;W=j+8|0;X=j+4|0;Y=j+11|0;Z=j+8|0;_=j+4|0;$=j+11|0;aa=i+8|0;ba=i+8|0;ca=i+4|0;da=i+11|0;ea=v;while(1){v=b[ea>>0]|0;if(!(((v&-33)+-65&255)<26|v<<24>>24==95)){v=f[n>>2]|0;fa=f[(f[v>>2]|0)+92>>2]|0;ga=$Xc(48)|0;f[i>>2]=ga;f[ba>>2]=-2147483600;f[ca>>2]=45;o=ga;p=248485;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[ga+45>>0]=0;gi[fa&255](v,248433,i,247307,685);if((b[da>>0]|0)<0)cYc(f[i>>2]|0)}k=ea+-1|0;b:while(1){ha=k+1|0;m=b[ha>>0]|0;if((m+-48&255)<10|((m&-33)+-65&255)<26){k=ha;continue}switch(m<<24>>24){case 45:case 95:{k=ha;break}default:break b}}k=ha-ea|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(k>>>0>4294967279){t=39;break}if(k>>>0<11){b[s>>0]=k;if(!k)ia=i;else{ja=i;t=43}}else{v=k+16&-16;fa=$Xc(v)|0;f[i>>2]=fa;f[aa>>2]=v|-2147483648;f[S>>2]=k;ja=fa;t=43}if((t|0)==43){t=0;o1c(ja|0,ea|0,k|0)|0;ia=ja}b[ia+k>>0]=0;if((b[ha>>0]|0)==0?(k=f[n>>2]|0,(ha|0)==((_i[f[(f[k>>2]|0)+48>>2]&2047](k)|0)+-1|0)):0){k=f[n>>2]|0;fa=f[(f[k>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=$Xc(64)|0;f[j>>2]=v;f[z>>2]=-2147483584;f[A>>2]=50;o=v;p=250984;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[v+50>>0]=0;gi[fa&255](k,248433,j,247307,693);if((b[B>>0]|0)<0)cYc(f[j>>2]|0)}ga=b[r>>0]|0;if((ga<<24>>24<0?f[C>>2]|0:ga&255)|0){if((f[g>>2]|0)==2){ga=f[n>>2]|0;m=f[(f[ga>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;l=$Xc(48)|0;f[j>>2]=l;f[M>>2]=-2147483600;f[N>>2]=45;o=l;p=248531;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+45>>0]=0;gi[m&255](ga,248433,j,247307,700);if((b[O>>0]|0)<0)cYc(f[j>>2]|0)}if((b[ha>>0]|0)!=61){k=j6(a,ha,2)|0;if((b[k>>0]|0)==61)ka=k;else{fa=f[n>>2]|0;v=f[(f[fa>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;la=$Xc(48)|0;f[j>>2]=la;f[Z>>2]=-2147483600;f[_>>2]=40;o=la;p=248577;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[la+40>>0]=0;gi[v&255](fa,248433,j,247307,706);if((b[$>>0]|0)<0)cYc(f[j>>2]|0);ka=k}}else ka=ha;ga=ka+1|0;m=b[ga>>0]|0;c:do switch(m<<24>>24){case 39:case 34:{ma=ga;na=m;break}default:{l=j6(a,ga,2)|0;oa=b[l>>0]|0;switch(oa<<24>>24){case 39:case 34:{ma=l;na=oa;break c;break}default:{}}oa=f[n>>2]|0;pa=f[(f[oa>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;qa=$Xc(64)|0;f[j>>2]=qa;f[P>>2]=-2147483584;f[Q>>2]=58;o=qa;p=248618;q=o+58|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[qa+58>>0]=0;gi[pa&255](oa,248433,j,247307,714);if((b[R>>0]|0)<0)cYc(f[j>>2]|0);ma=l;na=b[l>>0]|0}}while(0);ga=ma+1|0;m=ma+2|0;k=b[ga>>0]|0;if(k<<24>>24==na<<24>>24){ra=ga;sa=m}else{fa=k;k=m;while(1){if(!(fa<<24>>24)){m=f[n>>2]|0;v=f[(f[m>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;la=$Xc(32)|0;f[j>>2]=la;f[W>>2]=-2147483616;f[X>>2]=22;o=la;p=249074;q=o+22|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[la+22>>0]=0;gi[v&255](m,248433,j,247307,725);if((b[Y>>0]|0)<0)cYc(f[j>>2]|0)}l=k+1|0;fa=b[k>>0]|0;if(fa<<24>>24==na<<24>>24){ra=k;sa=l;break}else k=l}}k=b[s>>0]|0;if(((k<<24>>24<0?f[S>>2]|0:k&255)|0)==7?(LYc(i,0,-1,247727,7)|0)==0:0){k=b[c>>0]|0;if((k<<24>>24<0?f[y>>2]|0:k&255)|0){t=74;break}k=ra-ga|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(k>>>0>4294967279){t=76;break}if(k>>>0<11){b[T>>0]=k;if(!k)ta=j;else{ua=j;t=80}}else{fa=k+16&-16;l=$Xc(fa)|0;f[j>>2]=l;f[U>>2]=fa|-2147483648;f[V>>2]=k;ua=l;t=80}if((t|0)==80){t=0;o1c(ua|0,ga|0,k|0)|0;ta=ua}b[ta+k>>0]=0;if((b[c>>0]|0)<0){b[f[w>>2]>>0]=0;f[y>>2]=0}else{b[x>>0]=0;b[c>>0]=0}sYc(e,0);f[x>>2]=f[j>>2];f[x+4>>2]=f[j+4>>2];f[x+8>>2]=f[j+8>>2];va=sa}else va=sa}else{oYc(d,i)|0;va=ha}k=b[va>>0]|0;d:do if(k<<24>>24==62){wa=va;t=87}else{l=j6(a,va,2)|0;switch(b[l>>0]|0){case 62:{wa=l;t=87;break d;break}case 63:{if((f[g>>2]|0)==4){if((b[l+1>>0]|0)!=62){fa=f[n>>2]|0;oa=f[(f[fa>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;pa=$Xc(48)|0;f[j>>2]=pa;f[J>>2]=-2147483600;f[K>>2]=33;o=pa;p=248695;q=o+33|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[pa+33>>0]=0;gi[oa&255](fa,248433,j,247307,756);if((b[L>>0]|0)<0)cYc(f[j>>2]|0)}xa=0;ya=l+2|0;break d}break}case 47:{if((b[l+1>>0]|0)==62&(f[g>>2]|0)==1){f[g>>2]=3;xa=0;ya=l+2|0;break d}break}default:{}}switch(k<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{xa=1;ya=l;break d;break}default:{}}m=f[n>>2]|0;v=f[(f[m>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;la=$Xc(48)|0;f[j>>2]=la;f[G>>2]=-2147483600;f[H>>2]=40;o=la;p=248729;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[la+40>>0]=0;gi[v&255](m,248433,j,247307,768);if((b[I>>0]|0)<0)cYc(f[j>>2]|0);xa=1;ya=l}while(0);if((t|0)==87){t=0;if((f[g>>2]|0)==4){k=f[n>>2]|0;ga=f[(f[k>>2]|0)+92>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;fa=$Xc(48)|0;f[j>>2]=fa;f[D>>2]=-2147483600;f[E>>2]=33;o=fa;p=248695;q=o+33|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[fa+33>>0]=0;gi[ga&255](k,248433,j,247307,749);if((b[F>>0]|0)<0)cYc(f[j>>2]|0)}xa=0;ya=wa+1|0}if((b[s>>0]|0)<0)cYc(f[i>>2]|0);if(xa)ea=ya;else{t=107;break}}if((t|0)==39)jYc(i);else if((t|0)==74){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=$Xc(32)|0;f[j>>2]=i;f[j+8>>2]=-2147483616;f[j+4>>2]=17;o=i;p=248677;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[i+17>>0]=0;vM(-215,j,248433,247307,730)}else if((t|0)==76)jYc(j);else if((t|0)==107){u=h;return ya|0}return 0}function l6(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0;e=u;u=u+80|0;g=e+64|0;h=e+52|0;i=e+40|0;j=e+28|0;k=e+24|0;l=e;m=e+12|0;t5(g);n=C5(d)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;o=(n|0)==3;q=a+8|0;r=a+4|0;s=l+8|0;t=l+4|0;v=l+11|0;w=l+8|0;x=l+4|0;y=l+11|0;z=l+8|0;A=l+4|0;B=l+11|0;C=l+8|0;D=l+4|0;E=l+11|0;F=l+8|0;G=l+4|0;H=l+11|0;I=l+8|0;J=l+4|0;K=l+11|0;L=l+8|0;M=l+4|0;N=l+11|0;O=l+8|0;P=l+4|0;Q=l+11|0;R=l+8|0;S=l+4|0;T=l+11|0;U=l+8|0;V=l+4|0;W=l+11|0;X=m+11|0;Y=l+8|0;Z=l+4|0;_=l+11|0;$=m+8|0;aa=m+4|0;ba=m+11|0;ca=m+8|0;da=m+4|0;ea=m+11|0;fa=j+11|0;ga=j+4|0;ha=i+11|0;ia=i+4|0;ja=h+11|0;ka=h+4|0;la=m+8|0;ma=m+4|0;na=m+11|0;oa=c;c=1;a:while(1){pa=b[oa>>0]|0;switch(pa<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{qa=5;break}case 60:{ra=b[oa+1>>0]|0;if(ra<<24>>24==33)if((b[oa+2>>0]|0)==45)qa=5;else{sa=60;ta=oa;ua=33;qa=7}else{sa=60;ta=oa;ua=ra;qa=7}break}default:{va=pa;wa=oa;xa=c;qa=6}}if((qa|0)==5){qa=0;pa=j6(a,oa,0)|0;va=b[pa>>0]|0;wa=pa;xa=1;qa=6}b:do if((qa|0)==6){qa=0;pa=b[wa+1>>0]|0;switch(va<<24>>24){case 0:case 60:{sa=va;ta=wa;ua=pa;qa=7;break b;break}default:{}}if(!xa){ra=f[r>>2]|0;ya=f[(f[ra>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;za=$Xc(48)|0;f[l>>2]=za;f[Y>>2]=-2147483600;f[Z>>2]=38;Aa=za;Ba=248143;Ca=Aa+38|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[za+38>>0]=0;gi[ya&255](ra,250838,l,247307,515);if((b[_>>0]|0)<0)cYc(f[l>>2]|0)}if(!(C5(d)|0))Da=d;else{Ea=f[r>>2]|0;Ti[f[(f[Ea>>2]|0)+72>>2]&511](Ea,4,d);Ea=f[r>>2]|0;Fa=f[(f[Ea>>2]|0)+76>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;Ii[Fa&127](l,Ea,d,m,0,0,-1);f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];if((b[X>>0]|0)<0)cYc(f[m>>2]|0);Da=g}c:do if(o)if(va<<24>>24==34){Ga=0;Ha=wa;qa=72}else qa=71;else{d:do if((va+-48&255)<10)Ia=va;else switch(va<<24>>24){case 34:{Ga=0;Ha=wa;qa=72;break c;break}case 43:case 45:{if(pa<<24>>24==46|(pa+-48&255)<10){Ia=va;break d}else{qa=71;break c}break}case 46:{if((pa+-48&255)<10|((pa&-33)+-65&255)<26){Ia=46;break d}else{qa=71;break c}break}default:{qa=71;break c}}while(0);Ea=wa+((va<<24>>24==43|Ia<<24>>24==45)&1)|0;while(1){f[k>>2]=Ea;Ja=b[Ea>>0]|0;if((Ja+-48&255)<10)Ea=Ea+1|0;else break}switch(Ja<<24>>24){case 101:case 46:{Ea=f[r>>2]|0;Ka=+Sh[f[(f[Ea>>2]|0)+84>>2]&31](Ea,wa,k);p[l>>3]=Ka;F4(Da,2,l,-1);break}default:{Ea=aJc(wa,k,0)|0;f[l>>2]=Ea;F4(Da,1,l,-1)}}Ea=f[k>>2]|0;if((Ea|0)==(wa|0)){Fa=f[r>>2]|0;La=f[(f[Fa>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Ma=$Xc(80)|0;f[l>>2]=Ma;f[R>>2]=-2147483568;f[S>>2]=65;Aa=Ma;Ba=251035;Ca=Aa+65|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[Ma+65>>0]=0;gi[La&255](Fa,250838,l,247307,544);if((b[T>>0]|0)<0)cYc(f[l>>2]|0);Na=f[k>>2]|0}else Na=Ea;if((b[Na>>0]|0)==0?(Oa=f[r>>2]|0,(Na|0)==((_i[f[(f[Oa>>2]|0)+48>>2]&2047](Oa)|0)+-1|0)):0){Oa=f[r>>2]|0;Pa=f[(f[Oa>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Qa=$Xc(64)|0;f[l>>2]=Qa;f[U>>2]=-2147483584;f[V>>2]=50;Aa=Qa;Ba=250984;Ca=Aa+50|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[Qa+50>>0]=0;gi[Pa&255](Oa,250838,l,247307,547);if((b[W>>0]|0)<0)cYc(f[l>>2]|0);Ra=Na}else Ra=Na}while(0);if((qa|0)==71){qa=0;Ga=1;Ha=wa+-1|0;qa=72}if((qa|0)==72){qa=0;b[q>>0]=0;pa=0;ra=Ha;e:while(1){Sa=ra+1|0;ya=b[Sa>>0]|0;if(ya<<24>>24==0?(za=f[r>>2]|0,(Sa|0)==((_i[f[(f[za>>2]|0)+48>>2]&2047](za)|0)+-1|0)):0){za=f[r>>2]|0;Ea=f[(f[za>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Fa=$Xc(64)|0;f[l>>2]=Fa;f[s>>2]=-2147483584;f[t>>2]=50;Aa=Fa;Ba=250984;Ca=Aa+50|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[Fa+50>>0]=0;gi[Ea&255](za,250838,l,247307,562);if((b[v>>0]|0)<0)cYc(f[l>>2]|0)}f:do if(!((ya+-48&255)<10|((ya&-33)+-65&255)<26)){if(ya<<24>>24==34){qa=80;break e}if((ya&255)<32|ya<<24>>24==60){qa=88;break e}if(Ga)switch(ya<<24>>24){case 9:case 10:case 11:case 12:case 13:case 32:{Ta=Sa;break e;break}case 62:case 39:{qa=93;break}case 38:break;default:{Ua=pa;Va=ya;Wa=Sa;break f}}else switch(ya<<24>>24){case 62:case 39:{qa=93;break}case 38:break;default:{Ua=pa;Va=ya;Wa=Sa;break f}}if((qa|0)==93){qa=0;Oa=f[r>>2]|0;Pa=f[(f[Oa>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Qa=$Xc(64)|0;f[l>>2]=Qa;f[z>>2]=-2147483584;f[A>>2]=50;Aa=Qa;Ba=248257;Ca=Aa+50|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[Qa+50>>0]=0;gi[Pa&255](Oa,250838,l,247307,581);if((b[B>>0]|0)<0)cYc(f[l>>2]|0);Ua=pa;Va=ya;Wa=Sa;break}La=ra+2|0;g:do if((b[La>>0]|0)==35){Ma=ra+3|0;Xa=(b[Ma>>0]|0)==120;Ya=aJc(Xa?ra+4|0:Ma,k,Xa?16:10)|0;Xa=f[k>>2]|0;if(Ya>>>0<256&(Xa|0)!=0?(b[Xa>>0]|0)==59:0)Za=Xa;else{Xa=f[r>>2]|0;Ma=f[(f[Xa>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;_a=$Xc(48)|0;f[l>>2]=_a;f[C>>2]=-2147483600;f[D>>2]=35;Aa=_a;Ba=248308;Ca=Aa+35|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[_a+35>>0]=0;gi[Ma&255](Xa,250838,l,247307,597);if((b[E>>0]|0)<0)cYc(f[l>>2]|0);Za=f[k>>2]|0}$a=pa;ab=Ya&255;bb=Za}else{f[k>>2]=La;cb=La;do{cb=cb+1|0;f[k>>2]=cb;db=b[cb>>0]|0}while((db+-48&255)<10|((db&-33)+-65&255)<26);if(db<<24>>24==59){eb=cb;fb=cb}else{Ya=f[r>>2]|0;Xa=f[(f[Ya>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Ma=$Xc(48)|0;f[l>>2]=Ma;f[I>>2]=-2147483600;f[J>>2]=43;Aa=Ma;Ba=248344;Ca=Aa+43|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[Ma+43>>0]=0;gi[Xa&255](Ya,250838,l,247307,606);if((b[K>>0]|0)<0)cYc(f[l>>2]|0);cb=f[k>>2]|0;eb=cb;fb=cb}cb=eb-La|0;switch(cb|0){case 2:{if(!(WKc(La,248388,2)|0)){$a=pa;ab=60;bb=fb;break g}if(!(WKc(La,248391,2)|0)){$a=pa;ab=62;bb=fb;break g}break}case 3:{if(!(WKc(La,247716,3)|0)){$a=pa;ab=38;bb=fb;break g}break}case 4:{if(!(WKc(La,248394,4)|0)){$a=pa;ab=39;bb=fb;break g}if(!(WKc(La,248399,4)|0)){$a=pa;ab=34;bb=fb;break g}break}default:{}}_a=cb+2|0;o1c(a+8+pa|0,Sa|0,_a|0)|0;$a=_a+pa|0;ab=db;bb=fb}while(0);if((b[bb>>0]|0)==0?(La=f[r>>2]|0,(bb|0)==((_i[f[(f[La>>2]|0)+48>>2]&2047](La)|0)+-1|0)):0){La=f[r>>2]|0;Oa=f[(f[La>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Pa=$Xc(64)|0;f[l>>2]=Pa;f[F>>2]=-2147483584;f[G>>2]=50;Aa=Pa;Ba=250984;Ca=Aa+50|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[Pa+50>>0]=0;gi[Oa&255](La,250838,l,247307,625);if((b[H>>0]|0)<0)cYc(f[l>>2]|0);Ua=$a;Va=ab;Wa=bb}else{Ua=$a;Va=ab;Wa=bb}}else{Ua=pa;Va=ya;Wa=Sa}while(0);ya=Ua+1|0;b[a+8+Ua>>0]=Va;if((Ua|0)<=4094){pa=ya;ra=Wa;continue}za=f[r>>2]|0;Ea=f[(f[za>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Fa=$Xc(32)|0;f[l>>2]=Fa;f[w>>2]=-2147483616;f[x>>2]=23;Aa=Fa;Ba=249482;Ca=Aa+23|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[Fa+23>>0]=0;gi[Ea&255](za,250838,l,247307,630);if((b[y>>0]|0)<0)cYc(f[l>>2]|0);pa=ya;ra=Wa}if((qa|0)==80){qa=0;if(Ga){Qa=f[r>>2]|0;_a=f[(f[Qa>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;cb=$Xc(64)|0;f[l>>2]=cb;f[L>>2]=-2147483584;f[M>>2]=52;Aa=cb;Ba=248182;Ca=Aa+52|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[cb+52>>0]=0;gi[_a&255](Qa,250838,l,247307,569);if((b[N>>0]|0)<0)cYc(f[l>>2]|0)}Ta=ra+2|0}else if((qa|0)==88){qa=0;if(Ga)Ta=Sa;else{gb=f[r>>2]|0;hb=f[(f[gb>>2]|0)+92>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ib=$Xc(32)|0;f[l>>2]=ib;f[O>>2]=-2147483616;f[P>>2]=21;Aa=ib;Ba=248235;Ca=Aa+21|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[ib+21>>0]=0;gi[hb&255](gb,250838,l,247307,576);if((b[Q>>0]|0)<0)cYc(f[l>>2]|0);Ta=Sa}}F4(Da,3,q,pa);Ra=Ta}switch(n|0){case 0:case 4:case 5:{jb=Ra;kb=0;break}default:{lb=Ra;break a}}}while(0);if((qa|0)==7){qa=0;f[l>>2]=0;if(ua<<24>>24==47|sa<<24>>24==0){qa=42;break}ra=k6(a,ta,h,j,l)|0;Qa=f[l>>2]|0;if((Qa|0)==5){_a=f[r>>2]|0;cb=f[(f[_a>>2]|0)+92>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;mb=$Xc(48)|0;f[m>>2]=mb;f[$>>2]=-2147483600;f[aa>>2]=35;Aa=mb;Ba=248024;Ca=Aa+35|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[mb+35>>0]=0;gi[cb&255](_a,250838,m,247307,476);if((b[ba>>0]|0)<0)cYc(f[m>>2]|0);nb=f[l>>2]|0}else nb=Qa;if((nb|0)==3){ob=f[r>>2]|0;pb=f[(f[ob>>2]|0)+92>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;qb=$Xc(32)|0;f[m>>2]=qb;f[ca>>2]=-2147483616;f[da>>2]=28;Aa=qb;Ba=248060;Ca=Aa+28|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[qb+28>>0]=0;gi[pb&255](ob,250838,m,247307,478);if((b[ea>>0]|0)<0)cYc(f[m>>2]|0);rb=f[l>>2]|0}else rb=nb;if((rb|0)!=1){qa=17;break}Qa=b[fa>>0]|0;_a=Qa<<24>>24<0;do if((_a?f[ga>>2]|0:Qa&255)|0){cb=_a?f[j>>2]|0:j;if(!(GIc(cb,249470)|0)){mb=f[r>>2]|0;Ii[f[(f[mb>>2]|0)+76>>2]&127](m,mb,d,h,3,0,-1);f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];qa=27;break}if(!(GIc(cb,249478)|0)){mb=f[r>>2]|0;Ii[f[(f[mb>>2]|0)+76>>2]&127](m,mb,d,h,5,0,-1);f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];qa=27;break}if(!(GIc(cb,249474)|0)){mb=f[r>>2]|0;Ii[f[(f[mb>>2]|0)+76>>2]&127](m,mb,d,h,4,0,-1);f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];qa=27;break}mb=(GIc(cb,250506)|0)==0;cb=f[r>>2]|0;Ii[f[(f[cb>>2]|0)+76>>2]&127](m,cb,d,h,0,0,-1);f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];if(mb){mb=f[r>>2]|0;sb=j6(a,hh[f[(f[mb>>2]|0)+88>>2]&127](mb,ra,0,g)|0,0)|0}else qa=27}else{mb=f[r>>2]|0;Ii[f[(f[mb>>2]|0)+76>>2]&127](m,mb,d,h,0,0,-1);f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];qa=27}while(0);if((qa|0)==27){qa=0;sb=l6(a,ra,g)|0}_a=k6(a,sb,i,j,l)|0;h:do if((f[l>>2]|0)==2?(Qa=b[ha>>0]|0,ob=Qa<<24>>24<0,pb=Qa&255,Qa=ob?f[ia>>2]|0:pb,qb=b[ja>>0]|0,mb=qb<<24>>24<0,(Qa|0)==((mb?f[ka>>2]|0:qb&255)|0)):0){qb=f[i>>2]|0;cb=ob?qb:i;tb=mb?f[h>>2]|0:h;mb=(Qa|0)==0;if(ob){if(mb)break;if(!(WKc(cb,tb,Qa)|0))break;else{qa=38;break}}if(!mb)if((qb&255)<<24>>24==(b[tb>>0]|0)){qb=i;mb=pb;pb=tb;while(1){mb=mb+-1|0;qb=qb+1|0;if(!mb)break h;pb=pb+1|0;if((b[qb>>0]|0)!=(b[pb>>0]|0)){qa=38;break}}}else qa=38}else qa=38;while(0);if((qa|0)==38){qa=0;ra=f[r>>2]|0;pb=f[(f[ra>>2]|0)+92>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;qb=$Xc(32)|0;f[m>>2]=qb;f[la>>2]=-2147483616;f[ma>>2]=22;Aa=qb;Ba=248120;Ca=Aa+22|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[qb+22>>0]=0;gi[pb&255](ra,250838,m,247307,509);if((b[na>>0]|0)<0)cYc(f[m>>2]|0)}jb=_a;kb=1}oa=jb;c=kb}if((qa|0)==17){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;kb=$Xc(32)|0;f[m>>2]=kb;f[m+8>>2]=-2147483616;f[m+4>>2]=30;Aa=kb;Ba=248089;Ca=Aa+30|0;do{b[Aa>>0]=b[Ba>>0]|0;Aa=Aa+1|0;Ba=Ba+1|0}while((Aa|0)<(Ca|0));b[kb+30>>0]=0;vM(-215,m,250838,247307,480)}else if((qa|0)==42)lb=ta;ta=f[r>>2]|0;mi[f[(f[ta>>2]|0)+80>>2]&2047](ta,d);if((b[fa>>0]|0)<0)cYc(f[j>>2]|0);if((b[ha>>0]|0)<0)cYc(f[i>>2]|0);if((b[ja>>0]|0)>=0){u=e;return lb|0}cYc(f[h>>2]|0);u=e;return lb|0}function m6(a){a=a|0;NXc(a);return}function n6(a){a=a|0;NXc(a);cYc(a);return}function o6(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function p6(a){a=a|0;cYc(a);return}function q6(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(20)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=48912;d=c+12|0;f[d>>2]=48940;f[c+16>>2]=b;f[a>>2]=d;f[a+4>>2]=c;return}function r6(a){a=a|0;cYc(a);return}function s6(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;i=u;u=u+5152|0;j=i+8|0;k=i;l=i+24|0;m=i+12|0;if(!h)n=0;else n=(b[h>>0]|0)==0?0:h;h=g&15;g=h|16;if(!(D5(g)|0)){o=$Xc(80)|0;f[m>>2]=o;f[m+8>>2]=-2147483568;f[m+4>>2]=72;p=o;q=250416;r=p+72|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+72>>0]=0;vM(-5,m,250489,248878,37)}m=(n|0)!=0;if(m?(WKc(n,250506,6)|0)==0:0){p=l;q=248961;r=p+11|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));s=4;t=l}else v=8;do if((v|0)==8){if(!(E5(g)|0)){if(!m){s=g;t=0;break}f[j>>2]=n;cLc(l,248980,j)|0;s=g;t=l;break}q=b5(g)|0;p=q?123:91;q=h|24;if(m){f[k>>2]=n;f[k+4>>2]=p&255;cLc(l,248972,k)|0;s=q;t=l;break}else{b[l>>0]=p;b[l+1>>0]=0;s=q;t=l;break}}while(0);Ti[f[(f[c>>2]|0)+28>>2]&511](c,e,t);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;t=f[d+16>>2]|0;e=a+16|0;f[e>>2]=t;f[a+12>>2]=s;if(E5(f[d+12>>2]|0)|0){u=i;return}d=E5(s)|0;f[e>>2]=t+(d?4:3);u=i;return}function t6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[c+12>>2]|0;if(!(E5(d)|0)){if(!(F5(d)|0))return;e=a+4|0;g=f[e>>2]|0;h=_i[f[(f[g>>2]|0)+56>>2]&2047](g)|0;g=b5(d)|0;i=g?32123:23899;b[h>>0]=i;b[h+1>>0]=i>>8;i=f[e>>2]|0;mi[f[(f[i>>2]|0)+52>>2]&2047](i,h+2|0);return}h=a+4|0;a=f[h>>2]|0;i=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;a=f[h>>2]|0;e=_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0;if(i>>>0>(e+(f[c+16>>2]|0)|0)>>>0?!(F5(d)|0):0){b[i>>0]=32;j=i+1|0}else j=i;i=b5(d)|0;b[j>>0]=i?125:93;i=f[h>>2]|0;mi[f[(f[i>>2]|0)+52>>2]&2047](i,j+1|0);return}function u6(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+128|0;e=f[(f[a>>2]|0)+28>>2]|0;g=Y3(c,d,10)|0;Ti[e&511](a,b,g);u=d;return}function v6(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+128|0;e=f[(f[a>>2]|0)+28>>2]|0;g=Z3(d,c,0)|0;Ti[e&511](a,b,g);u=d;return}function w6(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+16416|0;h=g;i=g+16|0;j=g+4|0;if(!d){k=$Xc(32)|0;f[j>>2]=k;f[j+8>>2]=-2147483616;f[j+4>>2]=19;l=k;m=250307;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+19>>0]=0;vM(-27,j,250327,248878,123)}k=dJc(d)|0;if((k|0)>4096){o=$Xc(32)|0;f[j>>2]=o;f[j+8>>2]=-2147483616;f[j+4>>2]=30;l=o;m=250333;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+30>>0]=0;vM(-5,j,250327,248878,127)}if((k|0)==0|e)p=1;else{e=b[d>>0]|0;a:do if(e<<24>>24==(b[d+(k+-1)>>0]|0)){switch(e<<24>>24){case 39:case 34:{q=d;break}default:break a}r=f[a>>2]|0;s=r+28|0;t=f[s>>2]|0;Ti[t&511](a,c,q);u=g;return}while(0);p=e<<24>>24==32}e=p&1;j=i+1|0;b[i>>0]=34;if((k|0)>0){o=j;m=e;l=0;n=p;while(1){v=b[d+l>>0]|0;w=v+-48<<24>>24;b:do if(!n){x=(v&-33)+-65<<24>>24;if((w&255)<10|(x&255)<26){y=0;z=x}else{switch(v<<24>>24){case 32:case 40:case 41:case 43:case 45:case 47:case 59:case 95:{y=0;z=x;break b;break}default:{}}y=1;z=x}}else{y=m;z=(v&-33)+-65<<24>>24}while(0);c:do if((w&255)<10|(z&255)<26)A=24;else{if((v&255)>31){switch(v<<24>>24){case 34:case 39:case 92:break;default:{A=24;break c}}b[o>>0]=92;b[o+1>>0]=v;B=o+2|0;break}x=o+1|0;b[o>>0]=92;switch(v<<24>>24){case 10:{b[x>>0]=110;B=o+2|0;break c;break}case 13:{b[x>>0]=114;B=o+2|0;break c;break}case 9:{b[x>>0]=116;B=o+2|0;break c;break}default:{f[h>>2]=v<<24>>24;cLc(x,248955,h)|0;B=o+4|0;break c}}}while(0);if((A|0)==24){A=0;b[o>>0]=v;B=o+1|0}l=l+1|0;w=(y|0)!=0;if((l|0)==(k|0)){C=B;D=y;E=w;break}else{o=B;m=y;n=w}}}else{C=j;D=e;E=p}if(!E){E=b[d>>0]|0;if((E+-48&255)<10){F=1;A=29}else switch(E<<24>>24){case 46:case 45:case 43:{F=1;A=29;break}default:{G=C;H=1}}}else{F=D;A=29}if((A|0)==29){b[C>>0]=34;G=C+1|0;H=(F|0)==0}b[G>>0]=0;q=i+(H&1)|0;r=f[a>>2]|0;s=r+28|0;t=f[s>>2]|0;Ti[t&511](a,c,q);u=g;return}function x6(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+16|0;g=e;h=a+4|0;a=f[h>>2]|0;i=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;a=i+12|0;j=f[a>>2]|0;if(!c)k=0;else k=(b[c>>0]|0)==0?0:c;if(D5(j)|0)if((k|0)!=0^(b5(j)|0)){c=$Xc(96)|0;f[g>>2]=c;f[g+8>>2]=-2147483552;f[g+4>>2]=85;l=c;m=250106;n=l+85|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[c+85>>0]=0;vM(-5,g,250074,248878,192)}else o=j;else{j=f[h>>2]|0;Yi[f[(f[j>>2]|0)+60>>2]&4095](j);o=k|0?21:20}j=(k|0)!=0;if(j){c=dJc(k)|0;if(!c){p=$Xc(32)|0;f[g>>2]=p;f[g+8>>2]=-2147483616;f[g+4>>2]=19;l=p;m=250054;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[p+19>>0]=0;vM(-5,g,250074,248878,204)}if((c|0)>4096){p=$Xc(32)|0;f[g>>2]=p;f[g+8>>2]=-2147483616;f[g+4>>2]=19;l=p;m=250086;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[p+19>>0]=0;vM(-5,g,250074,248878,207)}else q=c}else q=0;c=(d|0)!=0;if(c)r=dJc(d)|0;else r=0;p=E5(o)|0;s=f[h>>2]|0;t=f[s>>2]|0;do if(!p){v=_i[f[t+56>>2]&2047](s)|0;if(!(b5(o)|0)){w=v+1|0;b[v>>0]=45;if(c){b[w>>0]=32;x=v+2|0}else x=w}else x=v}else{v=_i[f[t+40>>2]&2047](s)|0;if(F5(o)|0)y=v;else{b[v>>0]=44;y=v+1|0}v=f[h>>2]|0;w=r+q+y-(_i[f[(f[v>>2]|0)+44>>2]&2047](v)|0)|0;v=f[h>>2]|0;if((w|0)>(_i[f[(f[v>>2]|0)+64>>2]&2047](v)|0)?(w-(f[i+16>>2]|0)|0)>10:0){w=f[h>>2]|0;mi[f[(f[w>>2]|0)+52>>2]&2047](w,y);w=f[h>>2]|0;x=_i[f[(f[w>>2]|0)+56>>2]&2047](w)|0;break}b[y>>0]=32;x=y+1|0}while(0);if(j){j=b[k>>0]|0;if(!(((j&-33)+-65&255)<26|j<<24>>24==95)){j=$Xc(48)|0;f[g>>2]=j;f[g+8>>2]=-2147483600;f[g+4>>2]=33;l=j;m=250192;n=l+33|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+33>>0]=0;vM(-5,g,250074,248878,241)}j=f[h>>2]|0;y=hj[f[(f[j>>2]|0)+36>>2]&511](j,x,q)|0;a:do if((q|0)>0){j=0;b:while(1){i=b[k+j>>0]|0;b[y+j>>0]=i;if(!((i+-48&255)<10|((i&-33)+-65&255)<26))switch(i<<24>>24){case 32:case 45:case 95:break;default:break b}j=j+1|0;if((j|0)>=(q|0))break a}j=$Xc(96)|0;f[g>>2]=j;f[g+8>>2]=-2147483552;f[g+4>>2]=80;l=j;m=250226;n=l+80|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+80>>0]=0;vM(-5,g,250074,248878,251)}while(0);g=y+q|0;q=g+1|0;b[g>>0]=58;if(c&((E5(o)|0)^1)){b[q>>0]=32;z=q+1|0}else z=q}else z=x;if(!c){A=z;B=f[h>>2]|0;C=f[B>>2]|0;D=C+52|0;E=f[D>>2]|0;mi[E&2047](B,A);F=f[a>>2]|0;G=F&-17;f[a>>2]=G;u=e;return}c=f[h>>2]|0;x=hj[f[(f[c>>2]|0)+36>>2]&511](c,z,r)|0;o1c(x|0,d|0,r|0)|0;A=x+r|0;B=f[h>>2]|0;C=f[B>>2]|0;D=C+52|0;E=f[D>>2]|0;mi[E&2047](B,A);F=f[a>>2]|0;G=F&-17;f[a>>2]=G;u=e;return}function y6(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;if(!c){h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;i=h;j=249950;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+12>>0]=0;vM(-27,g,249963,248878,274)}g=dJc(c)|0;h=OJc(c,10)|0;j=a+4|0;a=f[j>>2]|0;i=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;if(((h|0)==0&d?(d=f[j>>2]|0,((_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0)-i|0)>=(g|0)):0)?(g=f[j>>2]|0,(i|0)!=(_i[f[(f[g>>2]|0)+44>>2]&2047](g)|0)):0){b[i>>0]=32;l=c;m=0;n=i+1|0}else{i=f[j>>2]|0;l=c;m=h;n=_i[f[(f[i>>2]|0)+56>>2]&2047](i)|0}while(1){b[n>>0]=35;i=n+2|0;b[n+1>>0]=32;if(!m){h=dJc(l)|0;c=f[j>>2]|0;g=hj[f[(f[c>>2]|0)+36>>2]&511](c,i,h)|0;o1c(g|0,l|0,h|0)|0;c=f[j>>2]|0;mi[f[(f[c>>2]|0)+52>>2]&2047](c,g+h|0);o=0;p=0}else{h=f[j>>2]|0;g=m-l|0;c=g+1|0;d=hj[f[(f[h>>2]|0)+36>>2]&511](h,i,c)|0;o1c(d|0,l|0,c|0)|0;c=f[j>>2]|0;mi[f[(f[c>>2]|0)+52>>2]&2047](c,d+g|0);g=m+1|0;o=g;p=OJc(g,10)|0}g=f[j>>2]|0;n=_i[f[(f[g>>2]|0)+56>>2]&2047](g)|0;if(!o)break;else{l=o;m=p}}u=e;return}function z6(a){a=a|0;var b=0;b=a+4|0;a=f[b>>2]|0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,249940);a=f[b>>2]|0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,249945);return}function A6(a){a=a|0;NXc(a);return}function B6(a){a=a|0;NXc(a);cYc(a);return}function C6(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function D6(a){a=a|0;cYc(a);return}function E6(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(5140)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=48988;d=c+12|0;f[d>>2]=49016;f[c+16>>2]=b;f[a>>2]=d;f[a+4>>2]=c;return}function F6(a){a=a|0;cYc(a);return}function G6(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=a+4|0;j=f[i>>2]|0;u5(e,_i[f[(f[j>>2]|0)+8>>2]&2047](j)|0,0,0);j=h+11|0;k=h+8|0;l=h+4|0;m=h+11|0;n=g+8|0;o=g+4|0;p=g+11|0;q=g+8|0;r=g+4|0;s=g+11|0;t=g+8|0;v=g+4|0;w=g+11|0;x=1;y=1;z=c;while(1){c=I6(a,z,0,2147483647)|0;a:do if(c){A=c;b:while(1){B=b[A>>0]|0;switch(B<<24>>24){case 0:{C=A;D=4;break a;break}case 37:{if(((WKc(A,249211,5)|0)==0?WKc(A,249217,8)|0:0)?WKc(A,249226,8)|0:0){E=f[i>>2]|0;F=f[(f[E>>2]|0)+92>>2]|0;G=$Xc(48)|0;f[g>>2]=G;f[q>>2]=-2147483600;f[r>>2]=41;H=G;I=249235;J=H+41|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[G+41>>0]=0;gi[F&255](E,477096,g,248878,771);if((b[s>>0]|0)<0)cYc(f[g>>2]|0)}b[A>>0]=0;break}case 45:{if(!(WKc(A,249277,3)|0)){D=13;break b}if(y){K=x;L=A;break a}break}default:{if((B+-48&255)<10|((B&-33)+-65&255)<26|B<<24>>24==95)break b;M=f[i>>2]|0;if(_i[f[(f[M>>2]|0)+20>>2]&2047](M)|0){K=x;L=A;break a}M=f[i>>2]|0;N=f[(f[M>>2]|0)+92>>2]|0;O=$Xc(32)|0;f[g>>2]=O;f[n>>2]=-2147483616;f[o>>2]=29;H=O;I=249342;J=H+29|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[O+29>>0]=0;gi[N&255](M,477096,g,248878,793);if((b[p>>0]|0)<0)cYc(f[g>>2]|0)}}B=I6(a,A,0,2147483647)|0;if(!B){C=0;D=4;break a}else A=B}if((D|0)==13){D=0;K=x;L=A+3|0;break}if(y){K=x;L=A}else{B=f[i>>2]|0;E=f[(f[B>>2]|0)+92>>2]|0;F=$Xc(64)|0;f[g>>2]=F;f[t>>2]=-2147483584;f[v>>2]=60;H=F;I=249281;J=H+60|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[F+60>>0]=0;gi[E&255](B,477096,g,248878,787);if((b[w>>0]|0)<0)cYc(f[g>>2]|0);P=x;Q=A;D=25}}else{C=0;D=4}while(0);if((D|0)==4){D=0;P=y^1;Q=C;D=25}if((D|0)==25){D=0;if(!Q){R=P;D=38;break}else{K=P;L=Q}}c=I6(a,L,0,2147483647)|0;if(!c){R=K;D=38;break}if(!(b[c>>0]|0)){R=K;D=38;break}if(WKc(c,529571,3)|0){G=f[i>>2]|0;S=f[(f[G>>2]|0)+76>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Ii[S&127](g,G,e,h,0,0,-1);if((b[j>>0]|0)<0)cYc(f[h>>2]|0);G=J6(a,c,g,0,0)|0;if(!(v5(g)|0)?!(A5(g)|0):0){S=f[i>>2]|0;T=f[(f[S>>2]|0)+92>>2]|0;U=$Xc(64)|0;f[h>>2]=U;f[k>>2]=-2147483584;f[l>>2]=61;H=U;I=249372;J=H+61|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[U+61>>0]=0;gi[T&255](S,477096,h,248878,807);if((b[m>>0]|0)<0)cYc(f[h>>2]|0)}V=I6(a,G,0,2147483647)|0;if(!V){R=K;D=38;break}else W=V}else W=c;V=f[i>>2]|0;if(_i[f[(f[V>>2]|0)+20>>2]&2047](V)|0){R=K;D=38;break}else{x=K;y=0;z=W+3|0}}if((D|0)==38){u=d;return R|0}return 0}function H6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=I6(a,c,0,2147483647)|0;f[g>>2]=j;f[e>>2]=j;if(!j){k=0;u=h;return k|0}if(!(b[j>>0]|0)){k=0;u=h;return k|0}e=a+4|0;a=f[e>>2]|0;if((j-(_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0)|0)==(d|0))l=j;else{k=0;u=h;return k|0}while(1){m=b[l>>0]|0;if((m&255)>31)l=l+1|0;else break}if(!(m<<24>>24)){m=f[e>>2]|0;e=f[(f[m>>2]|0)+92>>2]|0;j=$Xc(32)|0;f[i>>2]=j;f[i+8>>2]=-2147483616;f[i+4>>2]=22;d=j;a=249074;c=d+22|0;do{b[d>>0]=b[a>>0]|0;d=d+1|0;a=a+1|0}while((d|0)<(c|0));b[j+22>>0]=0;gi[e&255](m,250654,i,248878,388);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}f[g>>2]=l;k=1;u=h;return k|0}function I6(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+16|0;h=g;i=a+4|0;a=h+8|0;j=h+4|0;k=h+11|0;l=h+8|0;m=h+4|0;n=h+11|0;o=c;a:while(1){p=o;b:while(1){q=b[p>>0]|0;switch(q<<24>>24){case 35:{r=5;break b;break}case 32:break;default:break b}p=p+1|0}if((r|0)==5){r=0;c=f[i>>2]|0;if((p-(_i[f[(f[c>>2]|0)+44>>2]&2047](c)|0)|0)>(e|0)){s=p;r=23;break}b[p>>0]=0;o=p;continue}if((q&255)>31){r=8;break}switch(q<<24>>24){case 13:case 10:case 0:break;default:{c=f[i>>2]|0;t=f[(f[c>>2]|0)+92>>2]|0;v=q<<24>>24==9;w=v?28:17;x=$Xc(32)|0;f[h>>2]=x;f[a>>2]=-2147483616;f[j>>2]=w;o1c(x|0,(v?249164:249193)|0,w|0)|0;b[x+w>>0]=0;gi[t&255](c,251383,h,248878,369);if((b[k>>0]|0)<0)cYc(f[h>>2]|0);o=p;continue a}}c=f[i>>2]|0;t=_i[f[(f[c>>2]|0)+16>>2]&2047](c)|0;if(!t){r=14;break}c=t+((dJc(t)|0)+-1)|0;switch(b[c>>0]|0){case 13:case 10:{o=t;continue a;break}default:{}}c=f[i>>2]|0;if(_i[f[(f[c>>2]|0)+20>>2]&2047](c)|0){o=t;continue}c=f[i>>2]|0;w=f[(f[c>>2]|0)+92>>2]|0;x=$Xc(48)|0;f[h>>2]=x;f[l>>2]=-2147483600;f[m>>2]=44;y=x;z=249119;A=y+44|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[x+44>>0]=0;gi[w&255](c,251383,h,248878,365);if((b[n>>0]|0)<0)cYc(f[h>>2]|0);o=t}if((r|0)==8){o=f[i>>2]|0;if((p-(_i[f[(f[o>>2]|0)+44>>2]&2047](o)|0)|0)>=(d|0)){s=p;u=g;return s|0}d=f[i>>2]|0;o=f[(f[d>>2]|0)+92>>2]|0;n=$Xc(32)|0;f[h>>2]=n;f[h+8>>2]=-2147483616;f[h+4>>2]=21;y=n;z=249097;A=y+21|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[n+21>>0]=0;gi[o&255](d,251383,h,248878,346);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);s=p;u=g;return s|0}else if((r|0)==14){p=f[i>>2]|0;h=_i[f[(f[p>>2]|0)+44>>2]&2047](p)|0;b[h+2>>0]=46;b[h+1>>0]=46;b[h>>0]=46;b[h+3>>0]=0;p=f[i>>2]|0;Yi[f[(f[p>>2]|0)+24>>2]&4095](p);s=h;u=g;return s|0}else if((r|0)==23){u=g;return s|0}return 0}function J6(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;h=u;u=u+48|0;i=h+36|0;j=h;k=h+24|0;l=h+12|0;f[i>>2]=0;m=b[c>>0]|0;n=c+1|0;o=b[n>>0]|0;a:do if(m<<24>>24==33){switch(o<<24>>24){case 94:case 33:{q=n;r=1;break}default:{q=c;r=0}}b:do if(o<<24>>24==60){s=q+1|0;t=s;c:while(1){v=t+1|0;w=b[v>>0]|0;if((w&255)<32){x=s;y=r;break b}switch(w<<24>>24){case 32:{x=s;y=r;break b;break}case 62:{break c;break}default:t=v}}if((v-s|0)>>>0>19?(WKc(s,249434,19)|0)==0:0){b[v>>0]=32;x=q+19|0;y=1}else{x=s;y=r}}else{x=q;y=r}while(0);f[i>>2]=x;t=x;do{t=t+1|0;f[i>>2]=t;z=b[t>>0]|0}while((z&255)>=33);w=x+1|0;A=t-w|0;if(!A){B=f[a+4>>2]|0;C=f[(f[B>>2]|0)+92>>2]|0;D=$Xc(16)|0;f[j>>2]=D;f[j+8>>2]=-2147483632;f[j+4>>2]=15;E=D;F=249454;G=E+15|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[D+15>>0]=0;gi[C&255](B,250838,j,248878,467);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);H=f[i>>2]|0;I=H;J=b[H>>0]|0}else{I=t;J=z}b[I>>0]=0;do if(y|(A|0)!=3){if(!(y|(A|0)!=5)){H=(WKc(w,529542,5)|0)==0;K=J;L=H?2:0;M=0;break}if(!((A|0)!=6|y^1)?(WKc(w,250506,6)|0)==0:0){b[f[i>>2]>>0]=J;H=f[i>>2]|0;while(1){N=H+1|0;f[i>>2]=N;if((b[N>>0]|0)==32)H=N;else break}s=H+2|0;f[i>>2]=s;N=b[s>>0]|0;b[s>>0]=0;K=N;L=4;M=1}else{K=J;L=0;M=0}}else if(WKc(w,249470,3)|0)if(WKc(w,529496,3)|0)if(!(WKc(w,249474,3)|0)){K=J;L=4;M=0}else{N=(WKc(w,249478,3)|0)==0;K=J;L=N?5:0;M=0}else{K=J;L=1;M=0}else{K=J;L=3;M=0}while(0);b[f[i>>2]>>0]=K;w=I6(a,f[i>>2]|0,e,2147483647)|0;A=b[w>>0]|0;d:do if(!y){switch(L&7){case 1:{O=w;P=44;break a;break}case 2:{Q=w;P=43;break a;break}case 3:break;default:{P=33;break d}}switch(A<<24>>24){case 34:case 39:break;default:{R=w;S=3;P=118;break a}}if(!M){T=A;U=K;V=3;W=w;P=35;break a}}else P=33;while(0);if((P|0)==33?!M:0){T=A;U=K;V=L;W=w;P=35;break}t=a+4|0;B=f[t>>2]|0;C=w-(_i[f[(f[B>>2]|0)+44>>2]&2047](B)|0)|0;B=f[t>>2]|0;X=hh[f[(f[B>>2]|0)+88>>2]&127](B,w,C,d)|0;u=h;return X|0}else{T=m;U=o;V=0;W=c;P=35}while(0);e:do if((P|0)==35){f:do if((T+-48&255)<10)Y=T;else{g:do switch(T<<24>>24){case 43:case 45:{if(U<<24>>24==46|(U+-48&255)<10){Y=T;break f}else P=87;break}case 46:{if((U+-48&255)<10|((U&-33)+-65&255)<26){Y=46;break f}else Z=46;break}case 39:{c=a+4|0;o=j+8|0;m=j+4|0;L=j+11|0;K=0;M=W;while(1){y=M+1|0;J=b[y>>0]|0;h:do if(!((J+-48&255)<10|((J&-33)+-65&255)<26)){I=M;z=J;x=y;while(1){if(z<<24>>24!=39&(z&255)>31){_=x;$=z;break h}if(z<<24>>24==39)break;r=f[c>>2]|0;q=f[(f[r>>2]|0)+92>>2]|0;v=$Xc(32)|0;f[j>>2]=v;f[o>>2]=-2147483616;f[m>>2]=17;E=v;F=249193;G=E+17|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[v+17>>0]=0;gi[q&255](r,250838,j,248878,572);if((b[L>>0]|0)<0)cYc(f[j>>2]|0);n=x+1|0;C=b[n>>0]|0;if((C+-48&255)<10|((C&-33)+-65&255)<26){_=n;$=C;break h}else{B=x;z=C;x=n;I=B}}x=I+2|0;if((b[x>>0]|0)==39){_=x;$=39}else{aa=x;ba=K;P=86;break g}}else{_=y;$=J}while(0);J=K+1|0;b[a+8+K>>0]=$;if((J|0)<4096){K=J;M=_}else{ca=_;da=J;ea=c;P=83;break}}break}case 34:{c=a+4|0;M=j+8|0;K=j+4|0;L=j+11|0;m=0;o=W;i:while(1){J=o+1|0;y=b[J>>0]|0;j:do if((y+-48&255)<10|((y&-33)+-65&255)<26)P=66;else{switch(y<<24>>24){case 34:{break i;break}case 92:break;default:{if((y&255)>31){P=66;break j}x=f[c>>2]|0;z=f[(f[x>>2]|0)+92>>2]|0;B=$Xc(32)|0;f[j>>2]=B;f[M>>2]=-2147483616;f[K>>2]=17;E=B;F=249193;G=E+17|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[B+17>>0]=0;gi[z&255](x,250838,j,248878,615);if((b[L>>0]|0)<0)cYc(f[j>>2]|0);fa=m;ga=J;break j}}I=o+2|0;n=b[I>>0]|0;switch(n<<24>>24){case 39:{b[a+8+m>>0]=39;fa=m+1|0;ga=I;break j;break}case 92:case 34:{b[a+8+m>>0]=n;fa=m+1|0;ga=I;break j;break}case 110:{b[a+8+m>>0]=10;fa=m+1|0;ga=I;break j;break}case 114:{b[a+8+m>>0]=13;fa=m+1|0;ga=I;break j;break}case 116:{b[a+8+m>>0]=9;fa=m+1|0;ga=I;break j;break}default:{C=n<<24>>24==120;if(!C?!(n<<24>>24<56&(n+-48&255)<10):0){fa=m;ga=I;break j}n=o+5|0;t=b[n>>0]|0;b[n>>0]=0;D=I+(C&1)|0;N=aJc(D,i,C?8:16)|0;b[n>>0]=t;t=f[i>>2]|0;n=m+1|0;if((t|0)==(D|0)){b[a+8+m>>0]=120;fa=n;ga=I;break j}else{b[a+8+m>>0]=N;fa=n;ga=t;break j}}}}while(0);if((P|0)==66){P=0;b[a+8+m>>0]=y;fa=m+1|0;ga=J}if((fa|0)<4096){m=fa;o=ga}else{ca=ga;da=fa;ea=c;P=83;break g}}aa=o+2|0;ba=m;P=86;break}default:P=87}while(0);k:do if((P|0)==83){H=f[ea>>2]|0;c=f[(f[H>>2]|0)+92>>2]|0;L=$Xc(32)|0;f[j>>2]=L;f[j+8>>2]=-2147483616;f[j+4>>2]=23;E=L;F=249482;G=E+23|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[L+23>>0]=0;gi[c&255](H,250838,j,248878,619);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);aa=ca;ba=da;P=86}else if((P|0)==87){m=T<<24>>24==91;o=T<<24>>24==123;switch(T<<24>>24){case 91:case 123:break;default:if(T<<24>>24==45&(g^1)){ha=4;ia=W;break e}else{Z=T;break k}}K=((g^1)&1)+e|0;M=a+4|0;t=f[M>>2]|0;Ti[f[(f[t>>2]|0)+72>>2]&511](t,o?5:4,d);t=l+11|0;n=k+8|0;N=k+4|0;I=k+11|0;D=0;C=W+1|0;l:while(1){t5(j);ja=I6(a,C,K,2147483647)|0;ka=b[ja>>0]|0;switch(ka<<24>>24){case 93:case 125:{P=90;break l;break}default:{}}if(!D)la=ja;else{if(ka<<24>>24!=44){s=f[M>>2]|0;ma=f[(f[s>>2]|0)+92>>2]|0;na=$Xc(32)|0;f[k>>2]=na;f[n>>2]=-2147483616;f[N>>2]=30;E=na;F=249532;G=E+30|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[na+30>>0]=0;gi[ma&255](s,250838,k,248878,648);if((b[I>>0]|0)<0)cYc(f[k>>2]|0)}la=I6(a,ja+1|0,K,2147483647)|0}if(o)oa=I6(a,K6(a,la,d,j)|0,K,2147483647)|0;else{if((b[la>>0]|0)==93){pa=la;break}J=f[M>>2]|0;y=f[(f[J>>2]|0)+76>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Ii[y&127](k,J,d,l,0,0,-1);f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];if((b[t>>0]|0)<0)cYc(f[l>>2]|0);oa=la}D=D+1|0;C=J6(a,oa,j,K,1)|0}if((P|0)==90){if((ka<<24>>24|0)!=((m?93:125)|0)){K=f[M>>2]|0;C=f[(f[K>>2]|0)+92>>2]|0;D=$Xc(32)|0;f[k>>2]=D;f[k+8>>2]=-2147483616;f[k+4>>2]=25;E=D;F=249506;G=E+25|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[D+25>>0]=0;gi[C&255](K,250838,k,248878,640);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0)}pa=ja+1|0}m=f[M>>2]|0;mi[f[(f[m>>2]|0)+80>>2]&2047](m,d);X=pa;u=h;return X|0}while(0);if((P|0)==86){F4(d,3,a+8|0,ba);X=aa;u=h;return X|0}if(g){R=W;S=V;P=118;break e}switch(Z<<24>>24){case 63:{m=f[a+4>>2]|0;t=f[(f[m>>2]|0)+92>>2]|0;o=$Xc(32)|0;f[j>>2]=o;f[j+8>>2]=-2147483616;f[j+4>>2]=30;E=o;F=249563;G=E+30|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[o+30>>0]=0;gi[t&255](m,250838,j,248878,677);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);R=W;S=V;P=118;break e;break}case 62:case 124:{I=f[a+4>>2]|0;N=f[(f[I>>2]|0)+92>>2]|0;n=$Xc(48)|0;f[j>>2]=n;f[j+8>>2]=-2147483600;f[j+4>>2]=42;E=n;F=249594;G=E+42|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[n+42>>0]=0;gi[N&255](I,250838,j,248878,679);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);R=W;S=V;P=118;break e;break}default:{R=W;S=V;P=118;break e}}}while(0);w=W+((Y<<24>>24==45|Y<<24>>24==43)&1)|0;while(1){f[i>>2]=w;qa=b[w>>0]|0;if((qa+-48&255)<10)w=w+1|0;else break}switch(qa<<24>>24){case 101:case 46:{Q=W;P=43;break}default:{O=W;P=44}}}while(0);if((P|0)==43){W=f[a+4>>2]|0;ra=+Sh[f[(f[W>>2]|0)+84>>2]&31](W,Q,i);p[j>>3]=ra;F4(d,2,j,-1);sa=Q;P=45}else if((P|0)==44){Q=aJc(O,i,0)|0;f[j>>2]=Q;F4(d,1,j,-1);sa=O;P=45}else if((P|0)==118){f[i>>2]=R;O=b[R>>0]|0;if((O&255)>31){m:do if(g){Q=O;W=R;while(1){switch(Q<<24>>24){case 93:case 125:case 44:{ta=Q;ua=W;break m;break}default:{}}qa=W+1|0;f[i>>2]=qa;Y=b[qa>>0]|0;if((Y&255)>31){Q=Y;W=qa}else{ta=Y;ua=qa;break m}}}else{if((S|0)==3){W=R;while(1){Q=W+1|0;f[i>>2]=Q;qa=b[Q>>0]|0;if((qa&255)>31)W=Q;else{ta=qa;ua=Q;break m}}}else{va=O;wa=R}while(1){if(va<<24>>24==58){ta=58;ua=wa;break m}W=wa+1|0;f[i>>2]=W;Q=b[W>>0]|0;if((Q&255)>31){va=Q;wa=W}else{ta=Q;ua=W;break}}}while(0);if((ua|0)==(R|0)){xa=ta;P=127}else ya=ta}else{xa=O;P=127}if((P|0)==127){O=f[a+4>>2]|0;ta=f[(f[O>>2]|0)+92>>2]|0;ua=$Xc(32)|0;f[j>>2]=ua;f[j+8>>2]=-2147483616;f[j+4>>2]=17;E=ua;F=249193;G=E+17|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[ua+17>>0]=0;gi[ta&255](O,250838,j,248878,691);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);ya=xa}if(ya<<24>>24==58&(g^1)){ha=5;ia=R}else{g=f[i>>2]|0;while(1){ya=g+-1|0;if(ya>>>0<=R>>>0)break;if((b[ya>>0]|0)==32)g=ya;else break}F4(d,3,R,g-R|0);X=f[i>>2]|0;u=h;return X|0}}if((P|0)==45){R=f[i>>2]|0;if((R|0)==0|(R|0)==(sa|0)){sa=f[a+4>>2]|0;g=f[(f[sa>>2]|0)+92>>2]|0;ya=$Xc(80)|0;f[j>>2]=ya;f[j+8>>2]=-2147483568;f[j+4>>2]=65;E=ya;F=251035;G=E+65|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[ya+65>>0]=0;gi[g&255](sa,250838,j,248878,551);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);za=f[i>>2]|0}else za=R;if(b[za>>0]|0){X=za;u=h;return X|0}R=a+4|0;i=f[R>>2]|0;if((za|0)!=((_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0)+-1|0)){X=za;u=h;return X|0}i=f[R>>2]|0;R=f[(f[i>>2]|0)+92>>2]|0;sa=$Xc(64)|0;f[j>>2]=sa;f[j+8>>2]=-2147483584;f[j+4>>2]=50;E=sa;F=250984;G=E+50|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[sa+50>>0]=0;gi[R&255](i,250838,j,248878,554);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);X=za;u=h;return X|0}za=a+4|0;i=f[za>>2]|0;Ti[f[(f[i>>2]|0)+72>>2]&511](i,ha,d);i=f[za>>2]|0;R=ia-(_i[f[(f[i>>2]|0)+44>>2]&2047](i)|0)|0;i=(ha|0)==5;ha=R+1|0;sa=k+8|0;g=k+4|0;ya=k+11|0;xa=l+11|0;O=k+8|0;ta=k+4|0;ua=k+11|0;wa=ia;do{t5(j);if(i)Aa=K6(a,wa,d,j)|0;else{ia=wa+1|0;if((b[wa>>0]|0)!=45){va=f[za>>2]|0;S=f[(f[va>>2]|0)+92>>2]|0;W=$Xc(64)|0;f[k>>2]=W;f[O>>2]=-2147483584;f[ta>>2]=49;E=W;F=249637;G=E+49|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[W+49>>0]=0;gi[S&255](va,250838,k,248878,724);if((b[ua>>0]|0)<0)cYc(f[k>>2]|0)}Q=f[za>>2]|0;qa=f[(f[Q>>2]|0)+76>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Ii[qa&127](k,Q,d,l,0,0,-1);f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];if((b[xa>>0]|0)<0)cYc(f[l>>2]|0);Aa=ia}wa=I6(a,J6(a,I6(a,Aa,ha,2147483647)|0,j,ha,0)|0,0,2147483647)|0;Q=f[za>>2]|0;qa=wa;if((qa-(_i[f[(f[Q>>2]|0)+44>>2]&2047](Q)|0)|0)!=(R|0)){Q=f[za>>2]|0;if((qa-(_i[f[(f[Q>>2]|0)+44>>2]&2047](Q)|0)|0)<(R|0)){P=151;break}Q=f[za>>2]|0;qa=f[(f[Q>>2]|0)+92>>2]|0;Y=$Xc(32)|0;f[k>>2]=Y;f[sa>>2]=-2147483616;f[g>>2]=21;E=Y;F=249097;G=E+21|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[Y+21>>0]=0;gi[qa&255](Q,250838,k,248878,736);if((b[ya>>0]|0)<0)cYc(f[k>>2]|0)}}while((WKc(wa,529571,3)|0)!=0);k=f[za>>2]|0;mi[f[(f[k>>2]|0)+80>>2]&2047](k,d);X=wa;u=h;return X|0}function K6(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+32|0;h=g+12|0;i=g;j=c+-1|0;if((b[c>>0]|0)==45){k=f[a+4>>2]|0;l=f[(f[k>>2]|0)+92>>2]|0;m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=m;o=249687;p=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+26>>0]=0;gi[l&255](k,251274,h,248878,401);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);q=j}else q=j;while(1){r=q+1|0;j=b[r>>0]|0;s=j<<24>>24!=58;if((j&255)<32|s^1)break;else q=r}if(s){s=f[a+4>>2]|0;j=f[(f[s>>2]|0)+92>>2]|0;k=$Xc(16)|0;f[h>>2]=k;f[h+8>>2]=-2147483632;f[h+4>>2]=11;n=k;o=249714;p=n+11|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[k+11>>0]=0;gi[j&255](s,251274,h,248878,407);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);t=r}else t=r;while(1){r=t+-1|0;if((b[r>>0]|0)==32)t=r;else break}r=q+2|0;q=a+4|0;if((t|0)==(c|0)){a=f[q>>2]|0;s=f[(f[a>>2]|0)+92>>2]|0;j=$Xc(16)|0;f[h>>2]=j;f[h+8>>2]=-2147483632;f[h+4>>2]=12;n=j;o=249726;p=n+12|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[j+12>>0]=0;gi[s&255](a,251274,h,248878,415);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}a=f[q>>2]|0;q=f[(f[a>>2]|0)+76>>2]|0;s=t-c|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(s>>>0>4294967279)jYc(i);if(s>>>0<11){b[i+11>>0]=s;if(!s)v=i;else{w=i;x=20}}else{t=s+16&-16;j=$Xc(t)|0;f[i>>2]=j;f[i+8>>2]=t|-2147483648;f[i+4>>2]=s;w=j;x=20}if((x|0)==20){o1c(w|0,c|0,s|0)|0;v=w}b[v+s>>0]=0;Ii[q&127](h,a,d,i,0,0,-1);f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];if((b[i+11>>0]|0)>=0){u=g;return r|0}cYc(f[i>>2]|0);u=g;return r|0}function L6(a){a=a|0;NXc(a);return}function M6(a){a=a|0;NXc(a);cYc(a);return}function N6(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function O6(a){a=a|0;cYc(a);return}function P6(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{b[m+p>>0]=b[246515+((h[n+p>>0]|0|256)+(h[l+p>>0]|0))>>0]|0;p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;if((o|0)<(i|0)){q=d;r=f;s=a;t=k}else{n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=b[246515+((h[f+m>>0]|0|256)+(h[n+m>>0]|0))>>0]|0;b[d+k>>0]=b[246515+((h[f+k>>0]|0|256)+(h[n+k>>0]|0))>>0]|0;b[d+m>>0]=l;l=k|2;m=k|3;p=b[246515+((h[f+m>>0]|0|256)+(h[n+m>>0]|0))>>0]|0;b[d+l>>0]=b[246515+((h[f+l>>0]|0|256)+(h[n+l>>0]|0))>>0]|0;b[d+m>>0]=p;k=k+4|0}while((k|0)<=(j|0));if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[246515+((h[s+f>>0]|0|256)+(h[q+f>>0]|0))>>0]|0;b[r+a>>0]=b[246515+((h[s+a>>0]|0|256)+(h[q+a>>0]|0))>>0]|0;b[r+f>>0]=d;d=a|2;f=a|3;n=b[246515+((h[s+f>>0]|0|256)+(h[q+f>>0]|0))>>0]|0;b[r+d>>0]=b[246515+((h[s+d>>0]|0|256)+(h[q+d>>0]|0))>>0]|0;b[r+f>>0]=n;a=a+4|0}while((a|0)<=(j|0));u=o;do{b[r+u>>0]=b[246515+((h[s+u>>0]|0|256)+(h[q+u>>0]|0))>>0]|0;u=u+1|0}while((u|0)!=(i|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function Q6(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=(b[k+o>>0]|0)+(b[m+o>>0]|0)|0;b[l+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){q=d;r=f;s=a;t=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=(b[m+j>>0]|0)+(b[f+j>>0]|0)|0;k=j|1;o=(b[m+k>>0]|0)+(b[f+k>>0]|0)|0;b[d+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[d+k>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=j|2;k=(b[m+o>>0]|0)+(b[f+o>>0]|0)|0;l=j|3;p=(b[m+l>>0]|0)+(b[f+l>>0]|0)|0;b[d+o>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=(b[q+a>>0]|0)+(b[s+a>>0]|0)|0;d=a|1;m=(b[q+d>>0]|0)+(b[s+d>>0]|0)|0;b[r+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[r+d>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;m=a|2;d=(b[q+m>>0]|0)+(b[s+m>>0]|0)|0;f=a|3;j=(b[q+f>>0]|0)+(b[s+f>>0]|0)|0;b[r+m>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[r+f>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;a=a+4|0}while((a|0)<=(i|0));u=n;do{a=(b[q+u>>0]|0)+(b[s+u>>0]|0)|0;b[r+u>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;u=u+1|0}while((u|0)!=(h|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function R6(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){l=c;m=f;n=a;o=g}else return;while(1){p=0;do{q=(j[l+(p<<1)>>1]|0)+(j[n+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=q>>>0<65536?q:q|0?65535:0;p=p+1|0}while((p|0)!=(h|0));if(!o)break;else{l=l+(b<<1)|0;m=m+(e<<1)|0;n=n+(k<<1)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=g;while(1){g=0;do{l=(j[m+(g<<1)>>1]|0)+(j[f+(g<<1)>>1]|0)|0;p=g|1;q=(j[m+(p<<1)>>1]|0)+(j[f+(p<<1)>>1]|0)|0;d[c+(g<<1)>>1]=l>>>0<65536?l:l|0?65535:0;d[c+(p<<1)>>1]=q>>>0<65536?q:q|0?65535:0;q=g|2;p=(j[m+(q<<1)>>1]|0)+(j[f+(q<<1)>>1]|0)|0;l=g|3;r=(j[m+(l<<1)>>1]|0)+(j[f+(l<<1)>>1]|0)|0;d[c+(q<<1)>>1]=p>>>0<65536?p:p|0?65535:0;d[c+(l<<1)>>1]=r>>>0<65536?r:r|0?65535:0;g=g+4|0}while((g|0)<=(i|0));if(n){g=o;do{r=(j[m+(g<<1)>>1]|0)+(j[f+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=r>>>0<65536?r:r|0?65535:0;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0;a=a+-1|0}}return}function S6(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=(d[k+(o<<1)>>1]|0)+(d[m+(o<<1)>>1]|0)|0;d[l+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=c;c=f;f=a;a=g;while(1){g=0;do{k=(d[l+(g<<1)>>1]|0)+(d[f+(g<<1)>>1]|0)|0;o=g|1;p=(d[l+(o<<1)>>1]|0)+(d[f+(o<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=g|2;o=(d[l+(p<<1)>>1]|0)+(d[f+(p<<1)>>1]|0)|0;k=g|3;q=(d[l+(k<<1)>>1]|0)+(d[f+(k<<1)>>1]|0)|0;d[c+(p<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[c+(k<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+4|0}while((g|0)<=(i|0));if(m){g=n;do{q=(d[l+(g<<1)>>1]|0)+(d[f+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}function T6(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{f[l+(o<<2)>>2]=(f[k+(o<<2)>>2]|0)+(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=c;q=e;r=a;s=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=g|1;k=(f[m+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[c+(g<<2)>>2]=(f[m+(g<<2)>>2]|0)+(f[e+(g<<2)>>2]|0);f[c+(l<<2)>>2]=k;k=g|2;l=g|3;o=(f[m+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[c+(k<<2)>>2]=(f[m+(k<<2)>>2]|0)+(f[e+(k<<2)>>2]|0);f[c+(l<<2)>>2]=o;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;c=(f[p+(e<<2)>>2]|0)+(f[r+(e<<2)>>2]|0)|0;f[q+(a<<2)>>2]=(f[p+(a<<2)>>2]|0)+(f[r+(a<<2)>>2]|0);f[q+(e<<2)>>2]=c;c=a|2;e=a|3;m=(f[p+(e<<2)>>2]|0)+(f[r+(e<<2)>>2]|0)|0;f[q+(c<<2)>>2]=(f[p+(c<<2)>>2]|0)+(f[r+(c<<2)>>2]|0);f[q+(e<<2)>>2]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{f[q+(t<<2)>>2]=(f[p+(t<<2)>>2]|0)+(f[r+(t<<2)>>2]|0);t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(j<<2)|0;s=s+-1|0}}return}function U6(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{n[k+(o<<2)>>2]=+n[l+(o<<2)>>2]+ +n[j+(o<<2)>>2];o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){p=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+n[e+(k<<2)>>2]+ +n[l+(k<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]+ +n[l+(f<<2)>>2];n[c+(k<<2)>>2]=t;k=f|2;j=f|3;t=+n[e+(j<<2)>>2]+ +n[l+(j<<2)>>2];n[c+(k<<2)>>2]=+n[e+(k<<2)>>2]+ +n[l+(k<<2)>>2];n[c+(j<<2)>>2]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+n[r+(e<<2)>>2]+ +n[p+(e<<2)>>2];n[q+(a<<2)>>2]=+n[r+(a<<2)>>2]+ +n[p+(a<<2)>>2];n[q+(e<<2)>>2]=t;e=a|2;c=a|3;t=+n[r+(c<<2)>>2]+ +n[p+(c<<2)>>2];n[q+(e<<2)>>2]=+n[r+(e<<2)>>2]+ +n[p+(e<<2)>>2];n[q+(c<<2)>>2]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{n[q+(u<<2)>>2]=+n[r+(u<<2)>>2]+ +n[p+(u<<2)>>2];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(i<<2)|0;s=s+-1|0}}return}function V6(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{p[k+(n<<3)>>3]=+p[l+(n<<3)>>3]+ +p[j+(n<<3)>>3];n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){o=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+p[e+(k<<3)>>3]+ +p[l+(k<<3)>>3];p[c+(f<<3)>>3]=+p[e+(f<<3)>>3]+ +p[l+(f<<3)>>3];p[c+(k<<3)>>3]=t;k=f|2;j=f|3;t=+p[e+(j<<3)>>3]+ +p[l+(j<<3)>>3];p[c+(k<<3)>>3]=+p[e+(k<<3)>>3]+ +p[l+(k<<3)>>3];p[c+(j<<3)>>3]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+p[r+(e<<3)>>3]+ +p[o+(e<<3)>>3];p[q+(a<<3)>>3]=+p[r+(a<<3)>>3]+ +p[o+(a<<3)>>3];p[q+(e<<3)>>3]=t;e=a|2;c=a|3;t=+p[r+(c<<3)>>3]+ +p[o+(c<<3)>>3];p[q+(e<<3)>>3]=+p[r+(e<<3)>>3]+ +p[o+(e<<3)>>3];p[q+(c<<3)>>3]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{p[q+(u<<3)>>3]=+p[r+(u<<3)>>3]+ +p[o+(u<<3)>>3];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{o=o+(b<<3)|0;q=q+(d<<3)|0;r=r+(i<<3)|0;s=s+-1|0}}return}
function ZDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0,Ra=0.0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0.0,hb=0;d=u;u=u+3376|0;e=d+3312|0;g=d+3256|0;h=d+3240|0;i=d+3224|0;j=d+2160|0;k=d+1096|0;l=d+32|0;m=d;o=d+24|0;p=d+20|0;q=d+16|0;f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;s=a+32|0;t=f[s>>2]|0;v=a+28|0;w=a+36|0;x=+n[w>>2];y=ALc(+(t-(f[v>>2]|0)|0)/x*10.0)|0;z=j+8|0;f[j>>2]=z;A=j+4|0;f[A>>2]=y;if(y>>>0>264){B=bYc(y>>>0>1073741823?-1:y<<2)|0;f[j>>2]=B}B=f[a+8>>2]|0;C=k+8|0;f[k>>2]=C;D=k+4|0;E=B>>>0>264;f[D>>2]=B;if(E){F=bYc(B>>>0>1073741823?-1:B<<2)|0;f[k>>2]=F;G=F}else G=C;F=l+8|0;f[l>>2]=F;H=l+4|0;f[H>>2]=B;if(E){E=bYc(B>>>0>1073741823?-1:B<<2)|0;f[l>>2]=E;I=E}else I=F;E=f[c>>2]|0;B=c+4|0;c=f[B>>2]|0;J=(E|0)==0?(c|0)==(f[a+40>>2]|0):0;do if((E|0)<(c|0)){K=a+12|0;L=a+20|0;M=a+4|0;N=a+44|0;O=a+48|0;P=e+4|0;Q=e+8|0;R=e+12|0;S=e+16|0;T=e+20|0;U=e+24|0;V=e+40|0;W=e+48|0;X=e+44|0;Z=e+52|0;_=e+28|0;$=g+4|0;aa=g+8|0;ba=g+12|0;ca=g+16|0;da=g+20|0;ea=g+24|0;fa=g+40|0;ga=g+48|0;ha=g+44|0;ia=g+52|0;ja=g+28|0;ka=h+8|0;la=h+12|0;ma=h+4|0;na=m+8|0;oa=m+4|0;pa=y+-1|0;qa=(y|0)>1;ra=g+36|0;sa=e+36|0;ta=a+24|0;ua=e+4|0;va=e+8|0;wa=e+12|0;xa=i+8|0;ya=U+8|0;za=ea+8|0;Aa=E;Ba=t;Ca=x;while(1){Da=f[(f[f[K>>2]>>2]|0)+(Aa<<2)>>2]|0;Ea=f[L>>2]|0;Fa=(Da|0)/(Ea|0)|0;Ga=Ca*(+(Da-(Y(Fa,Ea)|0)|0)+.5);Ha=Ca*(+(Fa|0)+.5);Fa=f[M>>2]|0;Ia=+(Ba+1|0);Ea=~~(Ga-Ia);Da=(Ea|0)>0?Ea:0;Ea=~~(Ga+Ia);Ja=f[Fa+12>>2]|0;Ka=(Ja|0)<(Ea|0)?Ja:Ea;Ea=~~(Ha-Ia);Ja=(Ea|0)>0?Ea:0;Ea=~~(Ha+Ia);La=f[Fa+8>>2]|0;Ma=(La|0)<(Ea|0)?La:Ea;if((Ja|0)<(Ma|0)&(Da|0)<(Ka|0)){Ea=f[Fa+16>>2]|0;La=f[f[Fa+44>>2]>>2]|0;Fa=Ja;Ja=0;while(1){Na=Ea+(Y(Fa,La)|0)|0;Ia=Ha-+(Fa|0);Oa=Ia*Ia;Pa=Da;Qa=Ja;while(1){if(((b[Na+Pa>>0]|0)!=0?(Ia=Ga-+(Pa|0),Ra=Oa+Ia*Ia,+n[N>>2]<=Ra):0)?Ra<=+n[O>>2]:0){n[G+(Qa<<2)>>2]=Ra;Sa=Qa+1|0}else Sa=Qa;Pa=Pa+1|0;if((Pa|0)>=(Ka|0))break;else Qa=Sa}Fa=Fa+1|0;if((Fa|0)>=(Ma|0))break;else Ja=Sa}if(Sa){f[e>>2]=1124007941;f[P>>2]=2;f[Q>>2]=1;f[R>>2]=Sa;f[S>>2]=G;f[T>>2]=G;Ja=ya;f[Ja>>2]=0;f[Ja+4>>2]=0;f[V>>2]=Q;f[X>>2]=W;Ja=Sa<<2;f[W>>2]=Ja;f[Z>>2]=4;Ma=G+(Sa<<2)|0;f[_>>2]=Ma;Fa=0-Ja|0;f[U>>2]=Ma+Fa+Ja;R$(e);f[g>>2]=1124007941;f[$>>2]=2;f[aa>>2]=1;f[ba>>2]=Sa;f[ca>>2]=I;f[da>>2]=I;Ma=za;f[Ma>>2]=0;f[Ma+4>>2]=0;f[fa>>2]=aa;f[ha>>2]=ga;f[ga>>2]=Ja;f[ia>>2]=4;Ma=I+(Sa<<2)|0;f[ja>>2]=Ma;f[ea>>2]=Ma+Fa+Ja;R$(g);f[ka>>2]=0;f[la>>2]=0;f[h>>2]=-2130640891;f[ma>>2]=e;Ja=na;f[Ja>>2]=0;f[Ja+4>>2]=0;f[m>>2]=-2113863675;f[oa>>2]=g;YL(h,m);g1c(f[j>>2]|0,0,f[A>>2]<<2|0)|0;if((Sa|0)>0){Oa=+n[w>>2];Ja=f[j>>2]|0;Fa=0;do{Ma=ALc((+n[I+(Fa<<2)>>2]-+(f[v>>2]|0))/Oa*10.0)|0;Ka=(Ma|0)<(pa|0)?Ma:pa;Ma=Ja+(((Ka|0)>0?Ka:0)<<2)|0;f[Ma>>2]=(f[Ma>>2]|0)+1;Fa=Fa+1|0}while((Fa|0)!=(Sa|0))}a:do if(qa){Fa=f[j>>2]|0;Ja=y;Ma=0;Oa=0.0;while(1){Ka=Ja+-1|0;Ra=+(Ma|0);b:do if(!(Oa<1.1920928955078125e-07)){Da=Ja;La=Ka;while(1){Ea=f[Fa+(La<<2)>>2]|0;if(Ea){do if((La|0)>-1){Qa=Da+-10|0;Pa=La+-1|0;if((La|0)>(Qa|0)&(La|0)!=0){Ta=Pa;Ua=Ea}else{Va=Ea;Wa=Pa;break}while(1){Pa=(f[Fa+(Ta<<2)>>2]|0)+Ua|0;Na=Ta+-1|0;if((Ta|0)>(Qa|0)&(Ta|0)>0){Ta=Na;Ua=Pa}else{Va=Pa;Wa=Na;break}}}else{Va=0;Wa=La}while(0);Ia=+(Wa+La|0)*.5/10.0*+n[w>>2]+ +(f[v>>2]|0);if(!(Oa*+(Va|0)>=Ra*Ia))Xa=Wa;else{Ya=Va;Za=Wa;_a=Ia;break b}}else Xa=La;if((Xa|0)>1){Da=Xa;La=Xa+-1|0}else{$a=Ma;ab=Oa;break a}}}else{La=Ja;Da=Ka;while(1){Ea=f[Fa+(Da<<2)>>2]|0;if(Ea){do if((Da|0)>-1){Qa=La+-10|0;Na=Da+-1|0;if((Da|0)>(Qa|0)&(Da|0)!=0){bb=Na;cb=Ea}else{db=Ea;eb=Na;break}while(1){Na=(f[Fa+(bb<<2)>>2]|0)+cb|0;Pa=bb+-1|0;if((bb|0)>(Qa|0)&(bb|0)>0){bb=Pa;cb=Na}else{db=Na;eb=Pa;break}}}else{db=0;eb=Da}while(0);Ia=+(eb+Da|0)*.5/10.0*+n[w>>2]+ +(f[v>>2]|0);if((db|0)<(Ma|0)?!(Oa*+(db|0)>=Ra*Ia):0)fb=eb;else{Ya=db;Za=eb;_a=Ia;break b}}else fb=Da;if((fb|0)>1){La=fb;Da=fb+-1|0}else{$a=Ma;ab=Oa;break a}}}while(0);if((Za|0)>1){Ja=Za;Ma=Ya;Oa=_a}else{$a=Ya;ab=_a;break}}}else{$a=0;ab=0.0}while(0);Ma=f[ra>>2]|0;if(Ma|0?(Ja=Ma+12|0,Ma=f[Ja>>2]|0,f[Ja>>2]=Ma+-1,(Ma|0)==1):0)V$(g);f[ra>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[$>>2]|0)>0){Ma=f[fa>>2]|0;Ja=0;do{f[Ma+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[$>>2]|0))}Ja=f[ha>>2]|0;if((Ja|0)!=(ga|0))wL(Ja);Ja=f[sa>>2]|0;if(Ja|0?(Ma=Ja+12|0,Ja=f[Ma>>2]|0,f[Ma>>2]=Ja+-1,(Ja|0)==1):0)V$(e);f[sa>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[P>>2]|0)>0){Ja=f[V>>2]|0;Ma=0;do{f[Ja+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[P>>2]|0))}Ma=f[X>>2]|0;if((Ma|0)!=(W|0))wL(Ma);gb=ab;hb=$a}else{gb=0.0;hb=0}}else{gb=0.0;hb=0}if((hb|0)>(f[ta>>2]|0)){n[e>>2]=Ga;n[ua>>2]=Ha;n[va>>2]=gb;f[wa>>2]=hb;Ma=f[r>>2]|0;if(Ma>>>0<(f[xa>>2]|0)>>>0){n[Ma>>2]=Ga;f[Ma+4>>2]=f[ua>>2];f[Ma+8>>2]=f[va>>2];f[Ma+12>>2]=hb;f[r>>2]=Ma+16}else _Da(i,e)}Ma=Aa+1|0;if((Ma|0)>=(f[B>>2]|0))break;Aa=Ma;Ba=f[s>>2]|0;Ca=+n[w>>2]}Ba=f[i>>2]|0;Aa=f[r>>2]|0;if((Ba|0)!=(Aa|0)){f[e>>2]=618;QDa(Ba,Aa,e);if(J){Aa=f[a+16>>2]|0;Ba=f[Aa>>2]|0;f[Aa>>2]=f[i>>2];f[i>>2]=Ba;Ba=Aa+4|0;va=f[Ba>>2]|0;f[Ba>>2]=f[r>>2];f[r>>2]=va;va=Aa+8|0;Aa=i+8|0;Ba=f[va>>2]|0;f[va>>2]=f[Aa>>2];f[Aa>>2]=Ba;break}Ba=f[a+52>>2]|0;YXc(Ba);Aa=f[a+16>>2]|0;va=f[Aa>>2]|0;ua=Aa+4|0;xa=f[ua>>2]|0;wa=xa;if((va|0)==(xa|0)){f[Aa>>2]=f[i>>2];f[i>>2]=va;f[ua>>2]=f[r>>2];f[r>>2]=wa;ua=Aa+8|0;va=i+8|0;xa=f[ua>>2]|0;f[ua>>2]=f[va>>2];f[va>>2]=xa}else{f[o>>2]=wa;f[p>>2]=f[i>>2];f[q>>2]=f[r>>2];f[h>>2]=f[o>>2];f[g>>2]=f[p>>2];f[e>>2]=f[q>>2];$Da(Aa,h,g,e)|0}ZXc(Ba)}}while(0);e=f[l>>2]|0;if((e|0)!=(F|0)){if(e|0)dYc(e);f[l>>2]=F;f[H>>2]=264}H=f[k>>2]|0;if((H|0)!=(C|0)){if(H|0)dYc(H);f[k>>2]=C;f[D>>2]=264}D=f[j>>2]|0;if((D|0)!=(z|0)){if(D|0)dYc(D);f[j>>2]=z;f[A>>2]=264}A=f[i>>2]|0;if(!A){u=d;return}i=f[r>>2]|0;if((i|0)!=(A|0))f[r>>2]=i+(~((i+-16-A|0)>>>4)<<4);cYc(A);u=d;return}function _Da(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;do{m=j;j=j+-16|0;k=n;n=n+-16|0;f[j>>2]=f[n>>2];f[m+-12>>2]=f[k+-12>>2];f[m+-8>>2]=f[k+-8>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function $Da(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=h>>4;i=e+(b<<4)|0;j=f[c>>2]|0;k=f[d>>2]|0;d=k-j|0;l=d>>4;m=k;if((d|0)<=0){n=i;return n|0}d=a+8|0;o=f[d>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((l|0)<=(o-r>>4|0)){s=i;t=r-s|0;u=t>>4;if((l|0)>(u|0)){v=j+(u<<4)|0;u=v;if((v|0)==(m|0))w=q;else{x=m+-16-u|0;y=v;v=q;while(1){f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];f[v+8>>2]=f[y+8>>2];f[v+12>>2]=f[y+12>>2];y=y+16|0;if((y|0)==(m|0))break;else v=v+16|0}v=q+((x>>>4)+1<<4)|0;f[p>>2]=v;w=v}if((t|0)>0){z=u;A=w}else{n=i;return n|0}}else{z=k;A=q}k=A-(i+(l<<4))|0;w=k>>4;u=i+(w<<4)|0;if(u>>>0<q>>>0){t=(q+(0-w<<4)+~s|0)>>>4;s=u;u=A;while(1){f[u>>2]=f[s>>2];f[u+4>>2]=f[s+4>>2];f[u+8>>2]=f[s+8>>2];f[u+12>>2]=f[s+12>>2];s=s+16|0;if(s>>>0>=q>>>0)break;else u=u+16|0}f[p>>2]=A+(t+1<<4)}if(!w)B=j;else{q1c(A+(0-w<<4)|0,i|0,k|0)|0;B=f[c>>2]|0}c=z-B|0;if(!c){n=i;return n|0}q1c(i|0,B|0,c|0)|0;n=i;return n|0}c=(r-g>>4)+l|0;if(c>>>0>268435455)kWc(a);l=o-g|0;o=l>>3;r=l>>4>>>0<134217727?(o>>>0<c>>>0?c:o):268435455;o=i;c=h>>4;do if(r)if(r>>>0>268435455){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{C=$Xc(r<<4)|0;break}else C=0;while(0);h=C+(c<<4)|0;c=C+(r<<4)|0;r=j;if((r|0)==(m|0))D=h;else{C=((m+-16-j|0)>>>4)+1|0;j=r;r=h;while(1){f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];j=j+16|0;if((j|0)==(m|0))break;else r=r+16|0}D=h+(C<<4)|0}if(!b)E=h;else{b=i+-16-g|0;g=i;C=h;do{r=C;C=C+-16|0;m=g;g=g+-16|0;f[C>>2]=f[g>>2];f[r+-12>>2]=f[m+-12>>2];f[r+-8>>2]=f[m+-8>>2];f[r+-4>>2]=f[m+-4>>2]}while((g|0)!=(e|0));E=h+(~(b>>>4)<<4)|0}b=E;if((q|0)==(i|0))F=D;else{E=q+-16-o|0;o=i;i=D;while(1){f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];o=o+16|0;if((o|0)==(q|0))break;else i=i+16|0}F=D+((E>>>4)+1<<4)|0}f[a>>2]=b;f[p>>2]=F;f[d>>2]=c;if(!e){n=h;return n|0}cYc(e);n=h;return n|0}function aEa(a){a=a|0;cYc(a);return}function bEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0.0,hb=0;c=u;u=u+3376|0;d=c+3312|0;e=c+3256|0;g=c+3240|0;h=c+3224|0;i=c+2160|0;j=c+1096|0;k=c+32|0;l=c;m=c+24|0;o=c+20|0;p=c+16|0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;r=a+28|0;s=a+36|0;t=+n[s>>2];v=ALc(+((f[a+32>>2]|0)-(f[r>>2]|0)|0)/t*10.0)|0;w=i+8|0;f[i>>2]=w;x=i+4|0;f[x>>2]=v;if(v>>>0>264){y=bYc(v>>>0>1073741823?-1:v<<2)|0;f[i>>2]=y}y=a+8|0;z=f[y>>2]|0;A=j+8|0;f[j>>2]=A;B=j+4|0;C=z>>>0>264;f[B>>2]=z;if(C){D=bYc(z>>>0>1073741823?-1:z<<2)|0;f[j>>2]=D;E=D}else E=A;D=k+8|0;f[k>>2]=D;F=k+4|0;f[F>>2]=z;if(C){C=bYc(z>>>0>1073741823?-1:z<<2)|0;f[k>>2]=C;G=C}else G=D;C=f[b>>2]|0;H=b+4|0;b=f[H>>2]|0;I=(C|0)==0?(b|0)==(f[a+40>>2]|0):0;do if((C|0)<(b|0)){J=a+12|0;K=a+20|0;L=a+4|0;M=a+44|0;N=a+48|0;O=d+4|0;P=d+8|0;Q=d+12|0;R=d+16|0;S=d+20|0;T=d+24|0;U=d+40|0;V=d+48|0;W=d+44|0;X=d+52|0;Z=d+28|0;_=e+4|0;$=e+8|0;aa=e+12|0;ba=e+16|0;ca=e+20|0;da=e+24|0;ea=e+40|0;fa=e+48|0;ga=e+44|0;ha=e+52|0;ia=e+28|0;ja=g+8|0;ka=g+12|0;la=g+4|0;ma=l+8|0;na=l+4|0;oa=v+-1|0;pa=(v|0)>1;qa=e+36|0;ra=d+36|0;sa=a+24|0;ta=d+4|0;ua=d+8|0;va=d+12|0;wa=h+8|0;xa=T+8|0;ya=da+8|0;za=C;Aa=z;Ba=t;while(1){Ca=f[(f[f[J>>2]>>2]|0)+(za<<2)>>2]|0;Da=f[K>>2]|0;Ea=(Ca|0)/(Da|0)|0;Fa=Ba*(+(Ca-(Y(Ea,Da)|0)|0)+.5);Ga=Ba*(+(Ea|0)+.5);Ea=f[f[L>>2]>>2]|0;if((Aa|0)>0){Ha=+n[M>>2];Da=0;Ca=0;while(1){Ia=Fa-+(f[Ea+(Da<<3)>>2]|0);Ja=Ga-+(f[Ea+(Da<<3)+4>>2]|0);Ka=Ia*Ia+Ja*Ja;if(Ha<=Ka?Ka<=+n[N>>2]:0){n[E+(Ca<<2)>>2]=Ka;La=Ca+1|0}else La=Ca;Da=Da+1|0;if((Da|0)==(Aa|0))break;else Ca=La}if(La){f[d>>2]=1124007941;f[O>>2]=2;f[P>>2]=1;f[Q>>2]=La;f[R>>2]=E;f[S>>2]=E;Ca=xa;f[Ca>>2]=0;f[Ca+4>>2]=0;f[U>>2]=P;f[W>>2]=V;Ca=La<<2;f[V>>2]=Ca;f[X>>2]=4;Da=E+(La<<2)|0;f[Z>>2]=Da;Ea=0-Ca|0;f[T>>2]=Da+Ea+Ca;R$(d);f[e>>2]=1124007941;f[_>>2]=2;f[$>>2]=1;f[aa>>2]=La;f[ba>>2]=G;f[ca>>2]=G;Da=ya;f[Da>>2]=0;f[Da+4>>2]=0;f[ea>>2]=$;f[ga>>2]=fa;f[fa>>2]=Ca;f[ha>>2]=4;Da=G+(La<<2)|0;f[ia>>2]=Da;f[da>>2]=Da+Ea+Ca;R$(e);f[ja>>2]=0;f[ka>>2]=0;f[g>>2]=-2130640891;f[la>>2]=d;Ca=ma;f[Ca>>2]=0;f[Ca+4>>2]=0;f[l>>2]=-2113863675;f[na>>2]=e;YL(g,l);g1c(f[i>>2]|0,0,f[x>>2]<<2|0)|0;if((La|0)>0){Ha=+n[s>>2];Ca=f[i>>2]|0;Ea=0;do{Da=ALc((+n[G+(Ea<<2)>>2]-+(f[r>>2]|0))/Ha*10.0)|0;Ma=(Da|0)<(oa|0)?Da:oa;Da=Ca+(((Ma|0)>0?Ma:0)<<2)|0;f[Da>>2]=(f[Da>>2]|0)+1;Ea=Ea+1|0}while((Ea|0)!=(La|0))}a:do if(pa){Ea=f[i>>2]|0;Ca=v;Da=0;Ha=0.0;while(1){Ma=Ca+-1|0;Ka=+(Da|0);b:do if(!(Ha<1.1920928955078125e-07)){Na=Ca;Oa=Ma;while(1){Pa=f[Ea+(Oa<<2)>>2]|0;if(Pa){do if((Oa|0)>-1){Qa=Na+-10|0;Ra=Oa+-1|0;if((Oa|0)>(Qa|0)&(Oa|0)!=0){Sa=Ra;Ta=Pa}else{Ua=Pa;Va=Ra;break}while(1){Ra=(f[Ea+(Sa<<2)>>2]|0)+Ta|0;Wa=Sa+-1|0;if((Sa|0)>(Qa|0)&(Sa|0)>0){Sa=Wa;Ta=Ra}else{Ua=Ra;Va=Wa;break}}}else{Ua=0;Va=Oa}while(0);Ja=+(Va+Oa|0)*.5/10.0*+n[s>>2]+ +(f[r>>2]|0);if(!(Ha*+(Ua|0)>=Ka*Ja))Xa=Va;else{Ya=Ua;Za=Va;_a=Ja;break b}}else Xa=Oa;if((Xa|0)>1){Na=Xa;Oa=Xa+-1|0}else{$a=Da;ab=Ha;break a}}}else{Oa=Ca;Na=Ma;while(1){Pa=f[Ea+(Na<<2)>>2]|0;if(Pa){do if((Na|0)>-1){Qa=Oa+-10|0;Wa=Na+-1|0;if((Na|0)>(Qa|0)&(Na|0)!=0){bb=Wa;cb=Pa}else{db=Pa;eb=Wa;break}while(1){Wa=(f[Ea+(bb<<2)>>2]|0)+cb|0;Ra=bb+-1|0;if((bb|0)>(Qa|0)&(bb|0)>0){bb=Ra;cb=Wa}else{db=Wa;eb=Ra;break}}}else{db=0;eb=Na}while(0);Ja=+(eb+Na|0)*.5/10.0*+n[s>>2]+ +(f[r>>2]|0);if((db|0)<(Da|0)?!(Ha*+(db|0)>=Ka*Ja):0)fb=eb;else{Ya=db;Za=eb;_a=Ja;break b}}else fb=Na;if((fb|0)>1){Oa=fb;Na=fb+-1|0}else{$a=Da;ab=Ha;break a}}}while(0);if((Za|0)>1){Ca=Za;Da=Ya;Ha=_a}else{$a=Ya;ab=_a;break}}}else{$a=0;ab=0.0}while(0);Da=f[qa>>2]|0;if(Da|0?(Ca=Da+12|0,Da=f[Ca>>2]|0,f[Ca>>2]=Da+-1,(Da|0)==1):0)V$(e);f[qa>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[_>>2]|0)>0){Da=f[ea>>2]|0;Ca=0;do{f[Da+(Ca<<2)>>2]=0;Ca=Ca+1|0}while((Ca|0)<(f[_>>2]|0))}Ca=f[ga>>2]|0;if((Ca|0)!=(fa|0))wL(Ca);Ca=f[ra>>2]|0;if(Ca|0?(Da=Ca+12|0,Ca=f[Da>>2]|0,f[Da>>2]=Ca+-1,(Ca|0)==1):0)V$(d);f[ra>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[O>>2]|0)>0){Ca=f[U>>2]|0;Da=0;do{f[Ca+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[O>>2]|0))}Da=f[W>>2]|0;if((Da|0)!=(V|0))wL(Da);gb=ab;hb=$a}else{gb=0.0;hb=0}}else{gb=0.0;hb=0}if((hb|0)>(f[sa>>2]|0)){n[d>>2]=Fa;n[ta>>2]=Ga;n[ua>>2]=gb;f[va>>2]=hb;Da=f[q>>2]|0;if(Da>>>0<(f[wa>>2]|0)>>>0){n[Da>>2]=Fa;f[Da+4>>2]=f[ta>>2];f[Da+8>>2]=f[ua>>2];f[Da+12>>2]=hb;f[q>>2]=Da+16}else _Da(h,d)}Da=za+1|0;if((Da|0)>=(f[H>>2]|0))break;za=Da;Aa=f[y>>2]|0;Ba=+n[s>>2]}Aa=f[h>>2]|0;za=f[q>>2]|0;if((Aa|0)!=(za|0)){f[d>>2]=618;QDa(Aa,za,d);if(I){za=f[a+16>>2]|0;Aa=f[za>>2]|0;f[za>>2]=f[h>>2];f[h>>2]=Aa;Aa=za+4|0;ua=f[Aa>>2]|0;f[Aa>>2]=f[q>>2];f[q>>2]=ua;ua=za+8|0;za=h+8|0;Aa=f[ua>>2]|0;f[ua>>2]=f[za>>2];f[za>>2]=Aa;break}Aa=f[a+52>>2]|0;YXc(Aa);za=f[a+16>>2]|0;ua=f[za>>2]|0;ta=za+4|0;wa=f[ta>>2]|0;va=wa;if((ua|0)==(wa|0)){f[za>>2]=f[h>>2];f[h>>2]=ua;f[ta>>2]=f[q>>2];f[q>>2]=va;ta=za+8|0;ua=h+8|0;wa=f[ta>>2]|0;f[ta>>2]=f[ua>>2];f[ua>>2]=wa}else{f[m>>2]=va;f[o>>2]=f[h>>2];f[p>>2]=f[q>>2];f[g>>2]=f[m>>2];f[e>>2]=f[o>>2];f[d>>2]=f[p>>2];$Da(za,g,e,d)|0}ZXc(Aa)}}while(0);d=f[k>>2]|0;if((d|0)!=(D|0)){if(d|0)dYc(d);f[k>>2]=D;f[F>>2]=264}F=f[j>>2]|0;if((F|0)!=(A|0)){if(F|0)dYc(F);f[j>>2]=A;f[B>>2]=264}B=f[i>>2]|0;if((B|0)!=(w|0)){if(B|0)dYc(B);f[i>>2]=w;f[x>>2]=264}x=f[h>>2]|0;if(!x){u=c;return}h=f[q>>2]|0;if((h|0)!=(x|0))f[q>>2]=h+(~((h+-16-x|0)>>>4)<<4);cYc(x);u=c;return}function cEa(a){a=a|0;cYc(a);return}function dEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+32|0;e=c+28|0;g=c+24|0;h=c+12|0;i=c+8|0;j=c+4|0;k=c;l=f[b>>2]|0;m=f[b+4>>2]|0;f[h>>2]=0;b=h+4|0;f[b>>2]=0;f[h+8>>2]=0;n=(l|0)==1?(m|0)==((f[(f[a+4>>2]|0)+8>>2]|0)+-1|0):0;o=(l|0)>1?l:1;l=(f[a+20>>2]|0)+-1|0;p=(m|0)<(l|0)?m:l;do if((o|0)<(p|0)){l=a+16|0;m=a+24|0;q=a+12|0;r=h+8|0;s=o;t=f[l>>2]|0;while(1){v=Y(t,s)|0;w=v+1|0;f[d>>2]=w;if((t+-1|0)>1){x=1;y=t;z=v;v=w;while(1){w=f[m>>2]|0;A=f[w+(v<<2)>>2]|0;do if(((((A|0)>(f[q>>2]|0)?(A|0)>(f[w+(z<<2)>>2]|0):0)?(A|0)>=(f[w+(z+2<<2)>>2]|0):0)?(A|0)>(f[w+(v-y<<2)>>2]|0):0)?(A|0)>=(f[w+(y+v<<2)>>2]|0):0){B=f[b>>2]|0;if((B|0)==(f[r>>2]|0)){Tv(h,d);break}else{f[B>>2]=v;f[b>>2]=B+4;break}}while(0);x=x+1|0;z=f[d>>2]|0;v=z+1|0;f[d>>2]=v;w=f[l>>2]|0;if((x|0)>=(w+-1|0)){C=w;break}else y=w}}else C=t;s=s+1|0;if((s|0)>=(p|0))break;else t=C}t=f[h>>2]|0;s=f[b>>2]|0;if((t|0)!=(s|0)){if(!n){l=f[a+28>>2]|0;YXc(l);r=f[a+8>>2]|0;f[i>>2]=f[r+4>>2];f[j>>2]=f[h>>2];f[k>>2]=f[b>>2];f[g>>2]=f[i>>2];f[e>>2]=f[j>>2];f[d>>2]=f[k>>2];fEa(r,g,e,d)|0;ZXc(l);D=19;break}l=f[a+8>>2]|0;if((l|0)==(h|0))D=19;else{eEa(l,t,s);D=19}}else E=t}else D=19;while(0);if((D|0)==19)E=f[h>>2]|0;if(!E){u=c;return}h=f[b>>2]|0;if((h|0)!=(E|0))f[b>>2]=h+(~((h+-4-E|0)>>>2)<<2);cYc(E);u=c;return}function eEa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)q1c(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;o1c(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);cYc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)kWc(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)kWc(a);j=$Xc(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;o1c(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function fEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(h>>2<<2)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=d>>2;l=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;p=f[o>>2]|0;q=p;if((k|0)<=(n-q>>2|0)){r=b;s=q-r|0;t=s>>2;if((k|0)>(t|0)){u=i+(t<<2)|0;t=u;if((u|0)==(l|0))v=p;else{w=l+-4-t|0;x=u;u=p;while(1){f[u>>2]=f[x>>2];x=x+4|0;if((x|0)==(l|0))break;else u=u+4|0}u=p+((w>>>2)+1<<2)|0;f[o>>2]=u;v=u}if((s|0)>0){y=t;z=v}else{m=b;return m|0}}else{y=j;z=p}j=z-(b+(k<<2))|0;v=j>>2;t=b+(v<<2)|0;if(t>>>0<p>>>0){s=(p+(0-v<<2)+~r|0)>>>2;r=t;t=z;while(1){f[t>>2]=f[r>>2];r=r+4|0;if(r>>>0>=p>>>0)break;else t=t+4|0}f[o>>2]=z+(s+1<<2)}if(!v)A=i;else{q1c(z+(0-v<<2)|0,b|0,j|0)|0;A=f[c>>2]|0}c=y-A|0;if(!c){m=b;return m|0}q1c(b|0,A|0,c|0)|0;m=b;return m|0}c=(q-g>>2)+k|0;if(c>>>0>1073741823)kWc(a);k=n-g|0;g=k>>1;n=k>>2>>>0<536870911?(g>>>0<c>>>0?c:g):1073741823;g=b;c=h>>2;do if(n)if(n>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{B=$Xc(n<<2)|0;break}else B=0;while(0);k=B+(c<<2)|0;A=B+(n<<2)|0;n=i;if((n|0)==(l|0))C=k;else{B=((l+-4-i|0)>>>2)+1|0;i=n;n=k;while(1){f[n>>2]=f[i>>2];i=i+4|0;if((i|0)==(l|0))break;else n=n+4|0}C=k+(B<<2)|0}B=k+(0-c<<2)|0;if((h|0)>0)o1c(B|0,e|0,h|0)|0;h=q-g|0;if((h|0)>0){o1c(C|0,b|0,h|0)|0;D=C+(h>>>2<<2)|0}else D=C;f[a>>2]=B;f[o>>2]=D;f[d>>2]=A;if(!e){m=k;return m|0}cYc(e);m=k;return m|0}function gEa(a){a=a|0;cYc(a);return}function hEa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+176|0;g=e+160|0;h=e;i=e+144|0;j=e+88|0;k=e+32|0;l=a+40|0;m=(f[l>>2]|0)+2|0;o=a+36|0;p=(f[o>>2]|0)+2|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=1124007936;q=j+4|0;r=j+8|0;s=j+40|0;t=q;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;t=j+48|0;v=j+44|0;f[v>>2]=t;f[t>>2]=0;f[j+52>>2]=0;f[g>>2]=m;f[g+4>>2]=p;S$(j,2,g,4);lR(j,h)|0;p=j+16|0;m=f[p>>2]|0;w=a+32|0;x=f[w>>2]|0;LDa(k,f[x+8>>2]|0,f[x+12>>2]|0);x=f[c>>2]|0;y=f[c+4>>2]|0;c=a+4|0;z=f[c>>2]|0;A=f[z+12>>2]|0;if((f[z>>2]&16384|0)!=0?(f[f[a+8>>2]>>2]&16384|0)!=0:0){B=(f[f[a+12>>2]>>2]&16384|0)!=0;C=Y(B?y-x|0:1,A)|0;D=B?x+1|0:y;E=C}else{D=y;E=A}a:do if((x|0)<(D|0)){A=a+8|0;y=a+12|0;C=(E|0)>0;B=k+16|0;F=k+44|0;G=a+24|0;H=a+16|0;I=a+20|0;J=a+44|0;K=x;L=z;while(1){N=(f[L+16>>2]|0)+(Y(f[f[L+44>>2]>>2]|0,K)|0)|0;O=f[A>>2]|0;P=(f[O+16>>2]|0)+(Y(f[f[O+44>>2]>>2]|0,K)|0)|0;O=f[y>>2]|0;Q=(f[O+16>>2]|0)+(Y(f[f[O+44>>2]>>2]|0,K)|0)|0;if(C){O=0;do{b:do if((O|0)<(E|0)){R=O;while(1){if(b[N+R>>0]|0){S=R;break b}T=R+1|0;if((T|0)<(E|0))R=T;else{S=T;break}}}else S=O;while(0);c:do if(((S|0)!=(E|0)?(R=d[P+(S<<1)>>1]|0,U=+(R<<16>>16),T=d[Q+(S<<1)>>1]|0,V=+(T<<16>>16),(T|R)<<16>>16):0)?(W=+M(+(U*U+V*V)),!(W<1.0)):0){R=f[(f[c>>2]|0)+12>>2]|0;T=(S|0)%(R|0)|0;X=((S|0)/(R|0)|0)+K|0;R=(f[B>>2]|0)+(Y(f[f[F>>2]>>2]|0,X)|0)+T|0;b[R>>0]=1;Z=+n[G>>2];R=ALc(U*Z*1024.0/W)|0;_=ALc(V*Z*1024.0/W)|0;$=ALc(+(T|0)*Z*1024.0)|0;T=ALc(+(X|0)*Z*1024.0)|0;X=f[H>>2]|0;aa=f[I>>2]|0;if((X|0)>(aa|0)){ba=X;ca=aa}else{da=X;ea=(Y(X,_)|0)+T|0;fa=(Y(X,R)|0)+$|0;X=aa;while(1){aa=fa>>10;ga=ea>>10;if(aa>>>0>=(f[o>>2]|0)>>>0){ha=X;break}if(ga>>>0>=(f[l>>2]|0)>>>0){ha=X;break}ia=m+((Y(f[J>>2]|0,ga)|0)+aa<<2)|0;f[ia>>2]=(f[ia>>2]|0)+1;ia=f[I>>2]|0;if((da|0)<(ia|0)){da=da+1|0;ea=ea+_|0;fa=fa+R|0;X=ia}else{ha=ia;break}}ba=f[H>>2]|0;ca=ha}if((ba|0)<=(ca|0)){X=ba;fa=(Y(ba,0-_|0)|0)+T|0;ea=(Y(ba,0-R|0)|0)+$|0;while(1){da=ea>>10;ia=fa>>10;if(da>>>0>=(f[o>>2]|0)>>>0)break c;if(ia>>>0>=(f[l>>2]|0)>>>0)break c;aa=m+((Y(f[J>>2]|0,ia)|0)+da<<2)|0;f[aa>>2]=(f[aa>>2]|0)+1;if((X|0)<(f[I>>2]|0)){X=X+1|0;fa=fa-_|0;ea=ea-R|0}else break}}}while(0);O=S+1|0}while((O|0)<(E|0))}O=K+1|0;if((O|0)==(D|0))break a;K=O;L=f[c>>2]|0}}while(0);c=f[a+48>>2]|0;YXc(c);D=f[a+28>>2]|0;a=D+4|0;E=f[a>>2]|0;if((E|0)==(f[D+8>>2]|0))bx(D,j);else{f[E>>2]=f[j>>2];D=E+4|0;f[D>>2]=f[q>>2];S=E+8|0;f[S>>2]=f[r>>2];f[E+12>>2]=f[j+12>>2];f[E+16>>2]=f[p>>2];f[E+20>>2]=f[j+20>>2];f[E+24>>2]=f[j+24>>2];f[E+28>>2]=f[j+28>>2];f[E+32>>2]=f[j+32>>2];r=f[j+36>>2]|0;f[E+36>>2]=r;f[E+40>>2]=S;S=E+48|0;m=E+44|0;f[m>>2]=S;f[S>>2]=0;f[E+52>>2]=0;if(r|0){S=r+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[q>>2]|0)<3){S=f[v>>2]|0;r=f[m>>2]|0;f[r>>2]=f[S>>2];f[r+4>>2]=f[S+4>>2]}else{f[D>>2]=0;U$(E,j)}f[a>>2]=(f[a>>2]|0)+56}a=f[w>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=-2130640896;f[g+4>>2]=k;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=-2130640896;f[h+4>>2]=a;w=i+8|0;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=-2113863680;f[i+4>>2]=a;x1(g,h,i,fT()|0);ZXc(c);c=k+36|0;i=f[c>>2]|0;if(i|0?(h=i+12|0,i=f[h>>2]|0,f[h>>2]=i+-1,(i|0)==1):0)V$(k);f[c>>2]=0;c=k+16|0;i=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[i>>2]|0)>0){c=f[k+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[i>>2]|0))}i=f[k+44>>2]|0;if((i|0)!=(k+48|0))wL(i);i=j+36|0;k=f[i>>2]|0;if(k|0?(h=k+12|0,k=f[h>>2]|0,f[h>>2]=k+-1,(k|0)==1):0)V$(j);f[i>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){p=f[s>>2]|0;s=0;do{f[p+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[v>>2]|0;if((q|0)==(t|0)){u=e;return}wL(q);u=e;return}function iEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(c|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-27,e,367985,368008,60)}if((f[a+28>>2]|0)!=1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-201,e,367985,368008,63)}if((f[a+4>>2]|0)<64){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-201,e,367985,368008,63)}else{tT(a,c,0);e=a+56|0;a=f[e+4>>2]|0;g=c+36|0;f[g>>2]=f[e>>2];f[g+4>>2]=a;b[c+44>>0]=1;b[c+45>>0]=0;b[c+46>>0]=1;b[c+47>>0]=-1;b[c+48>>0]=0;a=c+49|0;b[a>>0]=-1;b[a+1>>0]=-1>>8;b[a+2>>0]=-1>>16;b[a+3>>0]=-1>>24;b[c+53>>0]=0;b[c+54>>0]=-1;b[c+55>>0]=1;b[c+56>>0]=0;b[c+57>>0]=1;b[c+58>>0]=1;b[c+59>>0]=1;u=d;return}}function jEa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=u;u=u+48|0;l=k+12|0;m=k;if(!c){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;vM(-27,l,368081,368008,184)}n=n3(a,l,0,0)|0;l=f[n>>2]|0;a=(l&4095|0)==4;o=(e|0)==2&a?4:e;if(!((l&4094|0)==0&(o|0)<4|a&(o|0)==4)){a=$Xc(128)|0;f[m>>2]=a;f[m+8>>2]=-2147483520;f[m+4>>2]=119;p=a;q=368106;r=p+119|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[a+119>>0]=0;vM(-210,m,368081,368008,195)}a=f[n+24>>2]|0;l=f[n+20>>2]|0;e=f[n+4>>2]|0;s=f[n+16>>2]|0;if(g>>>0>4){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;vM(-211,m,368081,368008,202)}t=(g|0)==0;if(((t?64:88)|0)>(d|0)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;vM(-201,m,368081,368008,205)}v=xL(788)|0;g1c(v+8|0,0,780)|0;w=v+4|0;f[w>>2]=c;f[v>>2]=c;f[v+40>>2]=s;x=s+e|0;f[v+44>>2]=x;f[v+48>>2]=e;y=a+-1|0;f[v+52>>2]=y;z=l+-1|0;f[v+56>>2]=z;f[v+244>>2]=o;A=v+60|0;f[A>>2]=h;f[A+4>>2]=i;f[v+72>>2]=1;f[v+68>>2]=1;f[v+76>>2]=0;f[v+80>>2]=1;f[v+84>>2]=2;i=v+180|0;f[v+148>>2]=i;f[v+176>>2]=1;f[v+140>>2]=0;f[v+144>>2]=0;f[v+152>>2]=0;f[v+156>>2]=0;f[v+160>>2]=a;f[v+164>>2]=l;f[v+88>>2]=0;f[v+248>>2]=0;f[i>>2]=32768;i=v+236|0;f[i>>2]=g;f[v+240>>2]=g;do if((g+-3|0)>>>0>=2){A=v+252|0;if(t){f[A>>2]=20480;B=d;C=1;D=0;E=20480;F=A;break}else{f[A>>2]=20492;B=d;C=8;D=g;E=20492;F=A;break}}else{f[i>>2]=0;A=v+252|0;f[A>>2]=20480;B=64;C=1;D=g;E=20480;F=A}while(0);f[v+256>>2]=B;f[v+260>>2]=C;f[v+268>>2]=d;d=(D|0)==0;D=v+264|0;f[D>>2]=d?E:20492;f[v+272>>2]=d?C:8;f[F>>2]=E;f[D>>2]=t?20480:20492;lT(c,v+16|0);if((g|0)>2){g=iT(f[w>>2]|0)|0;f[v>>2]=g}if((o|0)>1){o=iT(f[w>>2]|0)|0;f[v+8>>2]=o;w=CT(0,64,44,o)|0;f[v+12>>2]=w}if((e|0)<=-1){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;b[m+11>>0]=9;p=m;q=368226;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[m+9>>0]=0;vM(-215,m,368081,368008,285)}if((l|0)<=0){l=$Xc(32)|0;f[m>>2]=l;f[m+8>>2]=-2147483616;f[m+4>>2]=16;p=l;q=368236;r=p+16|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[l+16>>0]=0;vM(-215,m,368081,368008,286)}if((j|0?(j=f[n>>2]|0,m=Y(675553809>>>(j<<2&28)&15,(j>>>3&511)+1|0)|0,j=Y(m,a)|0,g1c(s|0,0,j|0)|0,g1c(s+(Y(e,z)|0)|0,0,j|0)|0,(z|0)>1):0)?(j=Y(m,y)|0,m|0):0){y=1;s=x;while(1){x=0;do{b[s+(x+j)>>0]=0;b[s+x>>0]=0;x=x+1|0}while((x|0)!=(m|0));y=y+1|0;if((y|0)==(z|0))break;else s=s+e|0}}if((f[n>>2]&4095|0)==4){u=k;return v|0}+eoa(n,n,0.0,1.0,0);u=k;return v|0}function kEa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0;c=u;u=u+128|0;d=c+104|0;e=c+88|0;g=c+84|0;h=c+72|0;i=c+8|0;j=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-27,d,368253,368008,1007)}k=a+48|0;l=f[k>>2]|0;if((l|0)<=-1){m=$Xc(32)|0;f[d>>2]=m;f[d+8>>2]=-2147483616;f[d+4>>2]=22;n=m;o=368271;p=n+22|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+22>>0]=0;vM(-215,d,368253,368008,1013)}m=a+88|0;q=f[m>>2]|0;if(!q)r=l;else{l=a+248|0;if(f[l>>2]|0){s=a+4|0;lT(f[s>>2]|0,d);if((f[d>>2]|0)==(f[a+32>>2]|0)?(f[d+4>>2]|0)==(f[a+36>>2]|0):0)mT(f[s>>2]|0,a+24|0);f[l>>2]=0}l=f[q+12>>2]|0;if(l|0)HT(l,f[(f[q+8>>2]|0)+12>>2]|0,a+180|0);f[m>>2]=0;r=f[k>>2]|0}k=f[a+40>>2]|0;q=a+44|0;l=f[q>>2]|0;s=r>>>2;t=a+68|0;v=f[t>>2]|0;w=a+72|0;x=f[w>>2]|0;y=f[a+52>>2]|0;z=f[a+56>>2]|0;A=f[a+244>>2]|0;B=a+76|0;C=a+84|0;D=v+-1|0;E=(A|0)==4;if(E){F=-1073741824;G=f[l+(D<<2)>>2]|0}else{F=-2;G=b[l+D>>0]|0}if((x|0)>=(z|0)){H=0;u=c;return H|0}D=~F;I=(A|0)==0;J=a+136|0;K=a+4|0;L=a+24|0;M=a+252|0;N=a+256|0;O=a+260|0;P=a+92|0;Q=a+60|0;R=a+64|0;S=a+236|0;T=0-r|0;U=1-r|0;V=i+4|0;W=i+8|0;X=~r;Z=i+12|0;_=i+16|0;$=r+-1|0;aa=i+20|0;ba=i+24|0;ca=r+1|0;da=i+28|0;ea=i+32|0;fa=d+12|0;ga=d+20|0;ha=a+240|0;ia=a+32|0;ja=a+268|0;ka=a+12|0;la=0-s|0;ma=1-s|0;na=~s;oa=s+-1|0;pa=s+1|0;qa=d+12|0;ra=d+20|0;sa=d+12|0;ta=d+20|0;ua=(A|0)<2;va=E?k:0;wa=(va|0)!=0;xa=G;G=f[C>>2]|0;ya=l;l=x;x=v;v=f[B>>2]|0;za=f[a+80>>2]|0;a:while(1){Aa=E?ya:0;b:do if((x|0)<(y|0)){Ba=(Aa|0)!=0;Ca=Y(za,r)|0;Da=Y(za,s)|0;Ea=0;Fa=xa;Ga=G;Ha=x;Ia=v;while(1){Ja=(Ha|0)<(y|0);c:do if(Ba)if(Ja){Ka=Fa;La=Ha;while(1){Ma=f[Aa+(La<<2)>>2]|0;if((Ma|0)!=(Ka|0)?(Ma^Ka)&D|0:0){Na=Ma;Oa=Ka;Pa=La;break c}Qa=La+1|0;if((Qa|0)<(y|0)){Ka=Ma;La=Qa}else{Na=Ma;Oa=Ma;Pa=Qa;break}}}else{Na=Ea;Oa=Fa;Pa=Ha}else if(Ja){La=Ha;while(1){Ka=b[ya+La>>0]|0;if((Ka|0)!=(Fa|0)){Na=Ka;Oa=Fa;Pa=La;break c}Ka=La+1|0;if((Ka|0)<(y|0))La=Ka;else{Na=Fa;Oa=Fa;Pa=Ka;break}}}else{Na=Ea;Oa=Fa;Pa=Ha}while(0);if((Pa|0)>=(y|0)){Ra=Ga;break b}if(Ba){Ja=(Oa&F|0)!=0;La=(Na&F|0)==0;if(!(((Oa|0)==0|Ja)&La))if(La&(Ja^1))if(Ja)Sa=36;else{Ta=1;Ua=Ia;Sa=37}else{Va=Ga;Wa=Na;Xa=Ia}else{Ta=0;Ua=Ia;Sa=37}}else if(!((Oa|0)==0&(Na|0)==1))if(!((Oa|0)<1|(Na|0)!=0))if(!(Oa&F)){Ta=1;Ua=Ia;Sa=37}else Sa=36;else{Va=Ga;Wa=Na;Xa=Ia}else{Ta=0;Ua=Ia;Sa=37}if((Sa|0)==36){Sa=0;Ta=1;Ua=Pa+-1|0;Sa=37}d:do if((Sa|0)==37){Sa=0;e:do if(I){if(Ta|0){Va=Ga;Wa=Na;Xa=Ua;break d}if((b[k+(Ua+Ca)>>0]|0)>0){Va=Ga;Wa=Na;Xa=Ua;break d}else{Ya=J;Za=Pa;_a=1}}else{Ja=Pa-Ta|0;if(!ua){if(!Ta)switch(A|0){case 2:case 4:{Ya=J;Za=Ja;_a=0;break e;break}default:{}}if((Ua|0)>=1){if(wa)$a=f[va+(Ua+Da<<2)>>2]|0;else $a=b[k+(Ua+Ca)>>0]|0;La=f[a+276+(($a&127)<<2)>>2]|0;if(!La){Sa=81;break a}Ka=Aa+(Ua<<2)|0;Qa=ya+Ua|0;Ma=La;La=0;f:while(1){do if((Ua-(f[Ma+16>>2]|0)|0)>>>0<(f[Ma+24>>2]|0)>>>0){if((za-(f[Ma+20>>2]|0)|0)>>>0>=(f[Ma+28>>2]|0)>>>0){ab=La;break}if(!La){ab=Ma;break}bb=f[La+36>>2]|0;if(!wa){cb=k+(Y(bb,r)|0)|0;db=cb+(f[La+32>>2]|0)|0;cb=f[La+40>>2]|0;f[i>>2]=1;f[V>>2]=U;f[W>>2]=T;f[Z>>2]=X;f[_>>2]=-1;f[aa>>2]=$;f[ba>>2]=r;f[da>>2]=ca;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];eb=cb|0?0:4;cb=eb;do{cb=cb+7&7;fb=db+(f[i+(cb<<2)>>2]|0)|0;gb=(cb|0)==(eb|0)}while(!((b[fb>>0]|0)!=0|gb));g:do if(gb)hb=db;else{eb=db;ib=cb;while(1){jb=ib;while(1){kb=jb+1|0;lb=eb+(f[i+(kb<<2)>>2]|0)|0;if(!lb){Sa=72;break a}if((kb|0)<15&(b[lb>>0]|0)==0)jb=kb;else break}if((eb|0)==(Qa|0)){Sa=75;break f}if((eb|0)==(fb|0)&(lb|0)==(db|0)){hb=fb;break g}eb=lb;ib=jb+5&7}}while(0);if((hb|0)==(Qa|0)){mb=La;break f}else{ab=Ma;break}}db=va+((Y(bb,s)|0)<<2)|0;cb=db+(f[La+32>>2]<<2)|0;if(!cb){Sa=54;break a}db=f[La+40>>2]|0;ib=f[cb>>2]&1073741823;f[i>>2]=1;f[V>>2]=ma;f[W>>2]=la;f[Z>>2]=na;f[_>>2]=-1;f[aa>>2]=oa;f[ba>>2]=s;f[da>>2]=pa;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];eb=db|0?0:4;db=eb;do{db=db+7&7;nb=cb+(f[i+(db<<2)>>2]<<2)|0;ob=(db|0)==(eb|0)}while(!(ob|(f[nb>>2]&1073741823|0)==(ib|0)));h:do if(ob)pb=cb;else{eb=cb;bb=db;while(1){kb=bb;while(1){qb=kb+1|0;rb=eb+(f[i+(qb<<2)>>2]<<2)|0;if(!rb){Sa=60;break a}if((qb|0)<15?(f[rb>>2]&1073741823|0)!=(ib|0):0)kb=qb;else break}if((eb|0)==(Ka|0)){Sa=63;break f}if((eb|0)==(nb|0)&(rb|0)==(cb|0)){pb=nb;break h}eb=rb;bb=kb+5&7}}while(0);if((pb|0)==(Ka|0)){mb=La;break f}else ab=Ma}else ab=La;while(0);Ma=f[Ma+4>>2]|0;if(!Ma){mb=ab;break}else La=ab}if((Sa|0)==63){Sa=0;mb=La}else if((Sa|0)==75){Sa=0;mb=La}if(!mb){Sa=81;break a}if((f[mb+40>>2]|0)==(Ta|0)){Ma=f[mb+8>>2]|0;sb=(Ma|0)==0?J:Ma}else sb=mb;if(!(f[sb+12>>2]|0)){Va=Ga;Wa=Na;Xa=Ua;break d}else{Ya=sb;Za=Ja;_a=0}}else{Ya=J;Za=Ja;_a=0}}else{Ya=J;Za=Ja;_a=1}}while(0);lT(f[K>>2]|0,L);Ma=pT(f[M>>2]|0,f[N>>2]|0,f[O>>2]|0,f[a>>2]|0)|0;f[Ma>>2]=f[Ma>>2]|(Ta|0?32768:0);f[j>>2]=0;if(_a){f[j>>2]=P;Ka=ya+Pa+(0-Ta)|0;Qa=(f[Q>>2]|0)+Za|0;cb=(f[R>>2]|0)+l|0;ib=f[S>>2]|0;f[i>>2]=1;f[V>>2]=U;f[W>>2]=T;f[Z>>2]=X;f[_>>2]=-1;f[aa>>2]=$;f[ba>>2]=r;f[da>>2]=ca;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];vT(Ma,d);db=(ib|0)<1;if(db){bb=Ma+56|0;f[bb>>2]=Qa;f[bb+4>>2]=cb}bb=(f[Ma>>2]|0)>>>13&4^4;eb=bb;do{eb=eb+7&7;tb=Ka+(f[i+(eb<<2)>>2]|0)|0;ub=(eb|0)==(bb|0)}while(!((b[tb>>0]|0)!=0|ub));i:do if(ub){b[Ka>>0]=-126;if((ib|0)>0){bb=f[fa>>2]|0;if(bb>>>0<(f[ga>>2]|0)>>>0)vb=bb;else{zT(d);vb=f[fa>>2]|0}bb=vb;jb=bb;b[jb>>0]=Qa;b[jb+1>>0]=Qa>>8;b[jb+2>>0]=Qa>>16;b[jb+3>>0]=Qa>>24;jb=bb+4|0;b[jb>>0]=cb;b[jb+1>>0]=cb>>8;b[jb+2>>0]=cb>>16;b[jb+3>>0]=cb>>24;f[fa>>2]=(f[fa>>2]|0)+8;yT(d)|0;Sa=133}else Sa=132}else{if(db){jb=Ka;bb=eb;while(1){qb=bb;while(1){wb=qb+1|0;xb=jb+(f[i+(wb<<2)>>2]|0)|0;if(!xb){Sa=121;break a}if((wb|0)<15&(b[xb>>0]|0)==0)qb=wb;else break}yb=wb&7;if((yb+-1|0)>>>0>=bb>>>0){if((b[jb>>0]|0)==1){zb=2;Sa=114}}else{zb=-126;Sa=114}if((Sa|0)==114){Sa=0;b[jb>>0]=zb}Ab=f[fa>>2]|0;if(Ab>>>0<(f[ga>>2]|0)>>>0)Bb=Ab;else{zT(d);Bb=f[fa>>2]|0}b[Bb>>0]=yb;f[fa>>2]=(f[fa>>2]|0)+1;if((jb|0)==(tb|0)&(xb|0)==(Ka|0)){Sa=132;break i}jb=xb;bb=qb+5&7}}if((ib|0)==1){bb=Ka;jb=eb;Ja=Qa;La=cb;while(1){yb=jb;while(1){Cb=yb+1|0;Db=bb+(f[i+(Cb<<2)>>2]|0)|0;if(!Db){Sa=121;break a}if((Cb|0)<15&(b[Db>>0]|0)==0)yb=Cb;else break}qb=Cb&7;if((qb+-1|0)>>>0>=jb>>>0){if((b[bb>>0]|0)==1){Eb=2;Sa=104}}else{Eb=-126;Sa=104}if((Sa|0)==104){Sa=0;b[bb>>0]=Eb}Ab=f[fa>>2]|0;if(Ab>>>0<(f[ga>>2]|0)>>>0)Fb=Ab;else{zT(d);Fb=f[fa>>2]|0}Ab=Fb;Gb=Ab;b[Gb>>0]=Ja;b[Gb+1>>0]=Ja>>8;b[Gb+2>>0]=Ja>>16;b[Gb+3>>0]=Ja>>24;Gb=Ab+4|0;b[Gb>>0]=La;b[Gb+1>>0]=La>>8;b[Gb+2>>0]=La>>16;b[Gb+3>>0]=La>>24;f[fa>>2]=(f[fa>>2]|0)+8;if((bb|0)==(tb|0)&(Db|0)==(Ka|0)){Sa=132;break i}bb=Db;jb=yb+5&7;Ja=(f[78892+(qb<<3)>>2]|0)+Ja|0;La=(f[78892+(qb<<3)+4>>2]|0)+La|0}}La=Ka;Ja=eb^4;jb=eb;bb=Qa;qb=cb;while(1){Gb=jb;while(1){Hb=Gb+1|0;Ib=La+(f[i+(Hb<<2)>>2]|0)|0;if(!Ib){Sa=121;break a}if((Hb|0)<15&(b[Ib>>0]|0)==0)Gb=Hb;else break}yb=Hb&7;if((yb+-1|0)>>>0>=jb>>>0){if((b[La>>0]|0)==1){Jb=2;Sa=125}}else{Jb=-126;Sa=125}if((Sa|0)==125){Sa=0;b[La>>0]=Jb}if((yb|0)==(Ja|0))Kb=Ja;else{Ab=f[fa>>2]|0;if(Ab>>>0<(f[ga>>2]|0)>>>0)Lb=Ab;else{zT(d);Lb=f[fa>>2]|0}Ab=Lb;Mb=Ab;b[Mb>>0]=bb;b[Mb+1>>0]=bb>>8;b[Mb+2>>0]=bb>>16;b[Mb+3>>0]=bb>>24;Mb=Ab+4|0;b[Mb>>0]=qb;b[Mb+1>>0]=qb>>8;b[Mb+2>>0]=qb>>16;b[Mb+3>>0]=qb>>24;f[fa>>2]=(f[fa>>2]|0)+8;Kb=yb}if((La|0)==(tb|0)&(Ib|0)==(Ka|0)){Sa=132;break i}La=Ib;Ja=Kb;jb=Gb+5&7;bb=(f[78892+(yb<<3)>>2]|0)+bb|0;qb=(f[78892+(yb<<3)+4>>2]|0)+qb|0}}while(0);if((Sa|0)==132?(Sa=0,yT(d)|0,ib|0):0)Sa=133;if((Sa|0)==133){Sa=0;ooa(e,Ma,1)}Nb=Ga;Ob=f[j>>2]|0}else{DT(f[ka>>2]|0,0,j)|0;Ka=f[j>>2]|0;if(!Ka){Sa=136;break a}cb=0-Ta|0;if(Ba){Qa=f[Aa+(Za<<2)>>2]&127;eb=Aa+(Pa<<2)+(cb<<2)|0;db=(f[Q>>2]|0)+Za|0;qb=(f[R>>2]|0)+l|0;bb=f[S>>2]|0;if(!eb){Sa=139;break a}f[e>>2]=0;f[g>>2]=0;jb=f[eb>>2]|0;Ja=jb&1073741823;La=Ja|1073741824;yb=jb|-1073741824;f[i>>2]=1;f[V>>2]=ma;f[W>>2]=la;f[Z>>2]=na;f[_>>2]=-1;f[aa>>2]=oa;f[ba>>2]=s;f[da>>2]=pa;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];vT(Ma,d);jb=(bb|0)<1;if(jb){Mb=Ma+56|0;f[Mb>>2]=db;f[Mb+4>>2]=qb}f[g>>2]=db;f[e>>2]=db;Mb=(f[Ma>>2]|0)>>>13&4^4;Ab=Mb;do{Ab=Ab+7&7;Pb=eb+(f[i+(Ab<<2)>>2]<<2)|0;Qb=(Ab|0)==(Mb|0)}while(!(Qb|(f[Pb>>2]&1073741823|0)==(Ja|0)));j:do if(Qb){f[eb>>2]=yb;if((bb|0)<=0){Rb=qb;Sb=qb;break}Mb=f[qa>>2]|0;if(Mb>>>0<(f[ra>>2]|0)>>>0)Tb=Mb;else{zT(d);Tb=f[qa>>2]|0}Mb=Tb;ib=Mb;b[ib>>0]=db;b[ib+1>>0]=db>>8;b[ib+2>>0]=db>>16;b[ib+3>>0]=db>>24;ib=Mb+4|0;b[ib>>0]=qb;b[ib+1>>0]=qb>>8;b[ib+2>>0]=qb>>16;b[ib+3>>0]=qb>>24;f[qa>>2]=(f[qa>>2]|0)+8;Rb=qb;Sb=qb}else{ib=Ab^4;if(jb){Mb=eb;Ub=ib;Vb=Ab;Wb=db;Xb=qb;Yb=qb;Zb=qb;while(1){_b=Vb;while(1){$b=_b+1|0;ac=Mb+(f[i+($b<<2)>>2]<<2)|0;if(!ac){Sa=184;break a}if(($b|0)<15?(f[ac>>2]&1073741823|0)!=(Ja|0):0)_b=$b;else break}Gb=$b&7;if((Gb+-1|0)>>>0>=Vb>>>0){if((f[Mb>>2]|0)==(Ja|0)){bc=La;Sa=172}}else{bc=yb;Sa=172}if((Sa|0)==172){Sa=0;f[Mb>>2]=bc}cc=f[qa>>2]|0;if(cc>>>0<(f[ra>>2]|0)>>>0)dc=cc;else{zT(d);dc=f[qa>>2]|0}b[dc>>0]=Gb;f[qa>>2]=(f[qa>>2]|0)+1;if((Gb|0)==(Ub|0)){ec=Xb;fc=Yb}else{if((Wb|0)>=(f[e>>2]|0)){if((Wb|0)>(f[g>>2]|0)){gc=g;Sa=178}}else{gc=e;Sa=178}if((Sa|0)==178){Sa=0;f[gc>>2]=Wb}cc=(Zb|0)<(Xb|0);ec=cc?Zb:Xb;fc=cc?Yb:(Zb|0)>(Yb|0)?Zb:Yb}if((Mb|0)==(Pb|0)&(ac|0)==(eb|0)){Rb=ec;Sb=fc;break j}Mb=ac;Ub=Gb;Vb=_b+5&7;Wb=(f[78892+(Gb<<3)>>2]|0)+Wb|0;Xb=ec;Yb=fc;Zb=(f[78892+(Gb<<3)+4>>2]|0)+Zb|0}}if((bb|0)==1){Zb=eb;Yb=ib;Xb=Ab;Wb=db;Vb=qb;Ub=qb;Mb=qb;while(1){Gb=Xb;while(1){hc=Gb+1|0;ic=Zb+(f[i+(hc<<2)>>2]<<2)|0;if(!ic){Sa=184;break a}if((hc|0)<15?(f[ic>>2]&1073741823|0)!=(Ja|0):0)Gb=hc;else break}_b=hc&7;if((_b+-1|0)>>>0>=Xb>>>0){if((f[Zb>>2]|0)==(Ja|0)){jc=La;Sa=157}}else{jc=yb;Sa=157}if((Sa|0)==157){Sa=0;f[Zb>>2]=jc}cc=f[qa>>2]|0;if(cc>>>0<(f[ra>>2]|0)>>>0)kc=cc;else{zT(d);kc=f[qa>>2]|0}cc=kc;lc=cc;b[lc>>0]=Wb;b[lc+1>>0]=Wb>>8;b[lc+2>>0]=Wb>>16;b[lc+3>>0]=Wb>>24;lc=cc+4|0;b[lc>>0]=Mb;b[lc+1>>0]=Mb>>8;b[lc+2>>0]=Mb>>16;b[lc+3>>0]=Mb>>24;f[qa>>2]=(f[qa>>2]|0)+8;if((_b|0)==(Yb|0)){mc=Vb;nc=Ub}else{if((Wb|0)>=(f[e>>2]|0)){if((Wb|0)>(f[g>>2]|0)){oc=g;Sa=163}}else{oc=e;Sa=163}if((Sa|0)==163){Sa=0;f[oc>>2]=Wb}lc=(Mb|0)<(Vb|0);mc=lc?Mb:Vb;nc=lc?Ub:(Mb|0)>(Ub|0)?Mb:Ub}if((Zb|0)==(Pb|0)&(ic|0)==(eb|0)){Rb=mc;Sb=nc;break j}Zb=ic;Yb=_b;Xb=Gb+5&7;Wb=(f[78892+(_b<<3)>>2]|0)+Wb|0;Vb=mc;Ub=nc;Mb=(f[78892+(_b<<3)+4>>2]|0)+Mb|0}}else{pc=eb;qc=ib;rc=Ab;sc=db;tc=qb;uc=qb;vc=qb}while(1){Mb=rc;while(1){wc=Mb+1|0;xc=pc+(f[i+(wc<<2)>>2]<<2)|0;if(!xc){Sa=184;break a}if((wc|0)<15?(f[xc>>2]&1073741823|0)!=(Ja|0):0)Mb=wc;else break}Gb=wc&7;if((Gb+-1|0)>>>0>=rc>>>0){if((f[pc>>2]|0)==(Ja|0)){yc=La;Sa=188}}else{yc=yb;Sa=188}if((Sa|0)==188){Sa=0;f[pc>>2]=yc}Ub=(Gb|0)==(qc|0);do if(Ub){zc=tc;Ac=uc}else{Vb=f[qa>>2]|0;if(Vb>>>0<(f[ra>>2]|0)>>>0)Bc=Vb;else{zT(d);Bc=f[qa>>2]|0}Vb=Bc;Wb=Vb;b[Wb>>0]=sc;b[Wb+1>>0]=sc>>8;b[Wb+2>>0]=sc>>16;b[Wb+3>>0]=sc>>24;Wb=Vb+4|0;b[Wb>>0]=vc;b[Wb+1>>0]=vc>>8;b[Wb+2>>0]=vc>>16;b[Wb+3>>0]=vc>>24;f[qa>>2]=(f[qa>>2]|0)+8;if(Ub){zc=tc;Ac=uc;break}if((sc|0)>=(f[e>>2]|0)){if((sc|0)>(f[g>>2]|0)){Cc=g;Sa=195}}else{Cc=e;Sa=195}if((Sa|0)==195){Sa=0;f[Cc>>2]=sc}Wb=(vc|0)<(tc|0);zc=Wb?vc:tc;Ac=Wb?uc:(vc|0)>(uc|0)?vc:uc}while(0);if((pc|0)==(Pb|0)&(xc|0)==(eb|0)){Rb=zc;Sb=Ac;break j}pc=xc;qc=Gb;rc=Mb+5&7;sc=(f[78892+(Gb<<3)>>2]|0)+sc|0;tc=zc;uc=Ac;vc=(f[78892+(Gb<<3)+4>>2]|0)+vc|0}}while(0);eb=f[e>>2]|0;yb=1-eb+(f[g>>2]|0)|0;f[g>>2]=yb;La=1-Rb+Sb|0;yT(d)|0;if(bb|0){f[Ma+56>>2]=eb;f[Ma+60>>2]=Rb;f[Ma+64>>2]=yb;f[Ma+68>>2]=La}f[Ka+16>>2]=eb;f[Ka+20>>2]=Rb;f[Ka+24>>2]=yb;f[Ka+28>>2]=La;Dc=Qa;Ec=Ga}else{La=Ga+1&127;yb=((La|0)==0?3:0)+La|0;La=ya+Pa+cb|0;eb=(f[Q>>2]|0)+Za|0;Ja=(f[R>>2]|0)+l|0;qb=f[S>>2]|0;f[e>>2]=0;f[g>>2]=0;f[i>>2]=1;f[V>>2]=U;f[W>>2]=T;f[Z>>2]=X;f[_>>2]=-1;f[aa>>2]=$;f[ba>>2]=r;f[da>>2]=ca;f[ea>>2]=f[i>>2];f[ea+4>>2]=f[i+4>>2];f[ea+8>>2]=f[i+8>>2];f[ea+12>>2]=f[i+12>>2];f[ea+16>>2]=f[i+16>>2];f[ea+20>>2]=f[i+20>>2];f[ea+24>>2]=f[i+24>>2];f[ea+28>>2]=f[i+28>>2];vT(Ma,d);db=(qb|0)<1;if(db){Ab=Ma+56|0;f[Ab>>2]=eb;f[Ab+4>>2]=Ja}f[g>>2]=eb;f[e>>2]=eb;Ab=(f[Ma>>2]|0)>>>13&4^4;jb=Ab;do{jb=jb+7&7;Fc=La+(f[i+(jb<<2)>>2]|0)|0;Gc=(jb|0)==(Ab|0)}while(!((b[Fc>>0]|0)!=0|Gc));k:do if(Gc){b[La>>0]=Ga|128;if((qb|0)<=0){Hc=Ja;Ic=Ja;break}Ab=f[sa>>2]|0;if(Ab>>>0<(f[ta>>2]|0)>>>0)Jc=Ab;else{zT(d);Jc=f[sa>>2]|0}Ab=Jc;cb=Ab;b[cb>>0]=eb;b[cb+1>>0]=eb>>8;b[cb+2>>0]=eb>>16;b[cb+3>>0]=eb>>24;cb=Ab+4|0;b[cb>>0]=Ja;b[cb+1>>0]=Ja>>8;b[cb+2>>0]=Ja>>16;b[cb+3>>0]=Ja>>24;f[sa>>2]=(f[sa>>2]|0)+8;Hc=Ja;Ic=Ja}else{cb=jb^4;Ab=Ga|128;if(db){Qa=La;bb=cb;ib=jb;Ub=eb;Wb=Ja;Vb=Ja;Xb=Ja;while(1){Yb=ib;while(1){Kc=Yb+1|0;Lc=Qa+(f[i+(Kc<<2)>>2]|0)|0;if(!Lc){Sa=246;break a}if((Kc|0)<15&(b[Lc>>0]|0)==0)Yb=Kc;else break}Gb=Kc&7;if((Gb+-1|0)>>>0>=ib>>>0){if((b[Qa>>0]|0)==1){Mc=Ga;Sa=234}}else{Mc=Ab;Sa=234}if((Sa|0)==234){Sa=0;b[Qa>>0]=Mc}Mb=f[sa>>2]|0;if(Mb>>>0<(f[ta>>2]|0)>>>0)Nc=Mb;else{zT(d);Nc=f[sa>>2]|0}b[Nc>>0]=Gb;f[sa>>2]=(f[sa>>2]|0)+1;if((Gb|0)==(bb|0)){Oc=Wb;Pc=Vb}else{if((Ub|0)>=(f[e>>2]|0)){if((Ub|0)>(f[g>>2]|0)){Qc=g;Sa=240}}else{Qc=e;Sa=240}if((Sa|0)==240){Sa=0;f[Qc>>2]=Ub}Mb=(Xb|0)<(Wb|0);Oc=Mb?Xb:Wb;Pc=Mb?Vb:(Xb|0)>(Vb|0)?Xb:Vb}if((Qa|0)==(Fc|0)&(Lc|0)==(La|0)){Hc=Oc;Ic=Pc;break k}Qa=Lc;bb=Gb;ib=Yb+5&7;Ub=(f[78892+(Gb<<3)>>2]|0)+Ub|0;Wb=Oc;Vb=Pc;Xb=(f[78892+(Gb<<3)+4>>2]|0)+Xb|0}}if((qb|0)==1){Xb=La;Vb=cb;Wb=jb;Ub=eb;ib=Ja;bb=Ja;Qa=Ja;while(1){Gb=Wb;while(1){Rc=Gb+1|0;Sc=Xb+(f[i+(Rc<<2)>>2]|0)|0;if(!Sc){Sa=246;break a}if((Rc|0)<15&(b[Sc>>0]|0)==0)Gb=Rc;else break}Yb=Rc&7;if((Yb+-1|0)>>>0>=Wb>>>0){if((b[Xb>>0]|0)==1){Tc=Ga;Sa=219}}else{Tc=Ab;Sa=219}if((Sa|0)==219){Sa=0;b[Xb>>0]=Tc}Mb=f[sa>>2]|0;if(Mb>>>0<(f[ta>>2]|0)>>>0)Uc=Mb;else{zT(d);Uc=f[sa>>2]|0}Mb=Uc;Zb=Mb;b[Zb>>0]=Ub;b[Zb+1>>0]=Ub>>8;b[Zb+2>>0]=Ub>>16;b[Zb+3>>0]=Ub>>24;Zb=Mb+4|0;b[Zb>>0]=Qa;b[Zb+1>>0]=Qa>>8;b[Zb+2>>0]=Qa>>16;b[Zb+3>>0]=Qa>>24;f[sa>>2]=(f[sa>>2]|0)+8;if((Yb|0)==(Vb|0)){Vc=ib;Wc=bb}else{if((Ub|0)>=(f[e>>2]|0)){if((Ub|0)>(f[g>>2]|0)){Xc=g;Sa=225}}else{Xc=e;Sa=225}if((Sa|0)==225){Sa=0;f[Xc>>2]=Ub}Zb=(Qa|0)<(ib|0);Vc=Zb?Qa:ib;Wc=Zb?bb:(Qa|0)>(bb|0)?Qa:bb}if((Xb|0)==(Fc|0)&(Sc|0)==(La|0)){Hc=Vc;Ic=Wc;break k}Xb=Sc;Vb=Yb;Wb=Gb+5&7;Ub=(f[78892+(Yb<<3)>>2]|0)+Ub|0;ib=Vc;bb=Wc;Qa=(f[78892+(Yb<<3)+4>>2]|0)+Qa|0}}else{Yc=La;Zc=cb;_c=jb;$c=eb;ad=Ja;bd=Ja;cd=Ja}while(1){Qa=_c;while(1){dd=Qa+1|0;ed=Yc+(f[i+(dd<<2)>>2]|0)|0;if(!ed){Sa=246;break a}if((dd|0)<15&(b[ed>>0]|0)==0)Qa=dd;else break}Gb=dd&7;if((Gb+-1|0)>>>0>=_c>>>0){if((b[Yc>>0]|0)==1){fd=Ga;Sa=250}}else{fd=Ab;Sa=250}if((Sa|0)==250){Sa=0;b[Yc>>0]=fd}bb=(Gb|0)==(Zc|0);do if(bb){gd=ad;hd=bd}else{ib=f[sa>>2]|0;if(ib>>>0<(f[ta>>2]|0)>>>0)id=ib;else{zT(d);id=f[sa>>2]|0}ib=id;Ub=ib;b[Ub>>0]=$c;b[Ub+1>>0]=$c>>8;b[Ub+2>>0]=$c>>16;b[Ub+3>>0]=$c>>24;Ub=ib+4|0;b[Ub>>0]=cd;b[Ub+1>>0]=cd>>8;b[Ub+2>>0]=cd>>16;b[Ub+3>>0]=cd>>24;f[sa>>2]=(f[sa>>2]|0)+8;if(bb){gd=ad;hd=bd;break}if(($c|0)>=(f[e>>2]|0)){if(($c|0)>(f[g>>2]|0)){jd=g;Sa=257}}else{jd=e;Sa=257}if((Sa|0)==257){Sa=0;f[jd>>2]=$c}Ub=(cd|0)<(ad|0);gd=Ub?cd:ad;hd=Ub?bd:(cd|0)>(bd|0)?cd:bd}while(0);if((Yc|0)==(Fc|0)&(ed|0)==(La|0)){Hc=gd;Ic=hd;break k}Yc=ed;Zc=Gb;_c=Qa+5&7;$c=(f[78892+(Gb<<3)>>2]|0)+$c|0;ad=gd;bd=hd;cd=(f[78892+(Gb<<3)+4>>2]|0)+cd|0}}while(0);La=f[e>>2]|0;Ja=1-La+(f[g>>2]|0)|0;f[g>>2]=Ja;eb=1-Hc+Ic|0;yT(d)|0;if(qb|0){f[Ma+56>>2]=La;f[Ma+60>>2]=Hc;f[Ma+64>>2]=Ja;f[Ma+68>>2]=eb}f[Ka+16>>2]=La;f[Ka+20>>2]=Hc;f[Ka+24>>2]=Ja;f[Ka+28>>2]=eb;Dc=Ga;Ec=yb}eb=f[j>>2]|0;Ja=eb+16|0;f[Ja>>2]=(f[Ja>>2]|0)-(f[Q>>2]|0);Ja=eb+20|0;f[Ja>>2]=(f[Ja>>2]|0)-(f[R>>2]|0);Ja=a+276+(Dc<<2)|0;f[eb+4>>2]=f[Ja>>2];f[Ja>>2]=eb;Nb=Ec;Ob=eb}f[Ob+40>>2]=Ta;f[Ob+12>>2]=Ma;eb=Ob+32|0;f[eb>>2]=Za;f[eb+4>>2]=l;f[Ob+8>>2]=Ya;eb=f[ha>>2]|0;if((f[S>>2]|0)==(eb|0)){kd=Ya;ld=Ma;md=Ob}else{Ja=Rra(Ma,f[ja>>2]|0,f[K>>2]|0,eb)|0;f[(f[j>>2]|0)+12>>2]=Ja;kT(f[a>>2]|0);Ja=f[j>>2]|0;kd=f[Ja+8>>2]|0;ld=f[Ja+12>>2]|0;md=Ja}f[ld+16>>2]=f[kd+12>>2];nd=f[K>>2]|0;if(f[Ya+12>>2]|0){Sa=274;break a}f[md+12>>2]=0;Ja=f[a>>2]|0;if((Ja|0)==(nd|0))mT(nd,L);else kT(Ja);Va=Nb;Wa=b[ya+Pa>>0]|0;Xa=Za}while(0);Ha=Pa+1|0;if((Ha|0)>=(y|0)){Ra=Va;break}else{Ea=Wa;Fa=Wa;Ga=Va;Ia=Wa>>>0>1?Pa:Xa}}}else Ra=G;while(0);Aa=l+1|0;if((Aa|0)<(z|0)){xa=0;G=Ra;ya=ya+r|0;l=Aa;x=1;v=0;za=Aa}else{H=0;Sa=275;break}}switch(Sa|0){case 54:{Sa=$Xc(16)|0;f[d>>2]=Sa;f[d+8>>2]=-2147483632;f[d+4>>2]=11;n=Sa;o=368294;p=n+11|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[Sa+11>>0]=0;vM(-215,d,368306,368008,816);break}case 60:{b[d+11>>0]=10;n=d;o=368326;p=n+10|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[d+10>>0]=0;vM(-215,d,368306,368008,852);break}case 72:{b[d+11>>0]=10;n=d;o=368326;p=n+10|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[d+10>>0]=0;vM(-215,d,368337,368008,664);break}case 81:{Sa=$Xc(16)|0;f[d>>2]=Sa;f[d+8>>2]=-2147483632;f[d+4>>2]=13;n=Sa;o=368353;p=n+13|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[Sa+13>>0]=0;vM(-215,d,368253,368008,1176);break}case 121:{b[e+11>>0]=10;n=e;o=368326;p=n+10|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[e+10>>0]=0;vM(-215,e,368367,368008,568);break}case 136:{f[d+8>>2]=0;b[d+11>>0]=7;b[d>>0]=b[368383]|0;b[d+1>>0]=b[368384]|0;b[d+2>>0]=b[368385]|0;b[d+3>>0]=b[368386]|0;b[d+4>>0]=b[368387]|0;b[d+5>>0]=b[368388]|0;b[d+6>>0]=b[368389]|0;b[d+7>>0]=0;vM(-215,d,368253,368008,1218);break}case 139:{e=$Xc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=11;n=e;o=368294;p=n+11|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[e+11>>0]=0;vM(-215,d,368391,368008,876);break}case 184:{b[h+11>>0]=10;n=h;o=368326;p=n+10|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+10>>0]=0;vM(-215,h,368391,368008,936);break}case 246:{b[h+11>>0]=10;n=h;o=368326;p=n+10|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+10>>0]=0;vM(-215,h,368413,368008,745);break}case 274:{lT(nd,ia);ia=f[j>>2]|0;f[m>>2]=ia;f[t>>2]=Pa+1+(Ba?0-Ta|0:0);f[w>>2]=l;l=B;f[l>>2]=Za;f[l+4>>2]=za;f[q>>2]=ya;f[C>>2]=Nb;H=f[ia+12>>2]|0;u=c;return H|0}case 275:{u=c;return H|0}}return 0}function lEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-27,c,368431,368008,1321)}d=f[a>>2]|0;if(!d){e=0;u=b;return e|0}g=d+88|0;h=f[g>>2]|0;if(h|0){i=d+248|0;if(f[i>>2]|0){j=d+4|0;lT(f[j>>2]|0,c);if((f[c>>2]|0)==(f[d+32>>2]|0)?(f[c+4>>2]|0)==(f[d+36>>2]|0):0)mT(f[j>>2]|0,d+24|0);f[i>>2]=0}i=f[h+12>>2]|0;if(i|0)HT(i,f[(f[h+8>>2]|0)+12>>2]|0,d+180|0);f[g>>2]=0}if((f[d>>2]|0)!=(f[d+4>>2]|0))jT(d);g=d+8|0;if(f[g>>2]|0)jT(g);g=f[d+200>>2]|0;yL(f[a>>2]|0);f[a>>2]=0;e=g;u=b;return e|0}function mEa(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;m=u;u=u+160|0;n=m;o=m+128|0;p=m+104|0;q=m+80|0;r=m+48|0;s=m+32|0;t=m+28|0;f[t>>2]=0;if(!d){v=$Xc(32)|0;f[n>>2]=v;f[n+8>>2]=-2147483616;f[n+4>>2]=25;w=v;x=368449;y=w+25|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[v+25>>0]=0;vM(-27,n,368475,368008,1810)}f[d>>2]=0;if((i|0)!=5){v=jEa(a,c,e,g,i,j,k,l)|0;f[t>>2]=v;l=-1;i=v;while(1){z=l+1|0;if(!(kEa(i)|0))break;l=z;i=f[t>>2]|0}i=lEa(t)|0;f[d>>2]=i;A=z;u=m;return A|0}if(k|j|0){j=$Xc(64)|0;f[n>>2]=j;f[n+8>>2]=-2147483584;f[n+4>>2]=51;w=j;x=368495;y=w+51|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[j+51>>0]=0;vM(-211,n,368475,368008,1818)}if(!c){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;j=$Xc(32)|0;f[n>>2]=j;f[n+8>>2]=-2147483616;f[n+4>>2]=20;w=j;x=368547;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[j+20>>0]=0;vM(-27,n,368568,368008,1501)}if((e|0)<88){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;j=$Xc(64)|0;f[n>>2]=j;f[n+8>>2]=-2147483584;f[n+4>>2]=48;w=j;x=368594;y=w+48|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[j+48>>0]=0;vM(-201,n,368568,368008,1507)}j=iT(c)|0;k=$Xc(16)|0;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=78964;f[k+12>>2]=j;z=iT(c)|0;i=$Xc(16)|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=78964;f[i+12>>2]=z;t=n3(a,n,0,0)|0;if(f[t>>2]&4094|0){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;n=$Xc(48)|0;f[s>>2]=n;f[s+8>>2]=-2147483600;f[s+4>>2]=32;w=n;x=368643;y=w+32|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[n+32>>0]=0;vM(-5,s,368568,368008,1518)}n=f[t+16>>2]|0;x=f[t+4>>2]|0;a=f[t+20>>2]|0;l=f[t+24>>2]|0;t=pT(0,56,16,j)|0;vT(t,q);wT(0,56,4,z,o);wT(0,56,4,z,p);z=q+12|0;j=f[z>>2]|0;v=q+20|0;if(j>>>0<(f[v>>2]|0)>>>0)B=j;else{zT(q);B=f[z>>2]|0}w=B;y=w+16|0;do{b[w>>0]=0;w=w+1|0}while((w|0)<(y|0));w=(f[z>>2]|0)+16|0;f[z>>2]=w;y=q+4|0;B=w+(0-(f[(f[y>>2]|0)+28>>2]|0))|0;w=(l|0)>0;a:do if(w){j=o+12|0;g=o+20|0;C=0;D=B;while(1){E=C;while(1){if(b[n+E>>0]|0){F=E;break}G=E+1|0;if((G|0)<(l|0))E=G;else{F=G;break}}if((F|0)==(l|0)){H=D;break a}E=f[z>>2]|0;if(E>>>0<(f[v>>2]|0)>>>0)I=E;else{zT(q);I=f[z>>2]|0}b[I>>0]=0;b[I+1>>0]=0;b[I+2>>0]=0;b[I+3>>0]=0;E=I+4|0;b[E>>0]=0;b[E+1>>0]=0;b[E+2>>0]=0;b[E+3>>0]=0;E=I+8|0;b[E>>0]=F;b[E+1>>0]=F>>8;b[E+2>>0]=F>>16;b[E+3>>0]=F>>24;E=I+12|0;b[E>>0]=0;b[E+1>>0]=0;b[E+2>>0]=0;b[E+3>>0]=0;E=(f[z>>2]|0)+16|0;f[z>>2]=E;G=E+(0-(f[(f[y>>2]|0)+28>>2]|0))|0;f[D+4>>2]=G;J=F+1|0;b:do if((l|0)>(J|0)){K=J;while(1){if(!(b[n+K>>0]|0)){L=K;break b}M=K+1|0;if((M|0)<(l|0))K=M;else{L=M;break}}}else L=J;while(0);J=L+-1|0;if(E>>>0<(f[v>>2]|0)>>>0)N=E;else{zT(q);N=f[z>>2]|0}b[N>>0]=0;b[N+1>>0]=0;b[N+2>>0]=0;b[N+3>>0]=0;K=N+4|0;b[K>>0]=0;b[K+1>>0]=0;b[K+2>>0]=0;b[K+3>>0]=0;K=N+8|0;b[K>>0]=J;b[K+1>>0]=J>>8;b[K+2>>0]=J>>16;b[K+3>>0]=J>>24;J=N+12|0;b[J>>0]=0;b[J+1>>0]=0;b[J+2>>0]=0;b[J+3>>0]=0;J=(f[z>>2]|0)+16|0;f[z>>2]=J;K=J+(0-(f[(f[y>>2]|0)+28>>2]|0))|0;J=G+4|0;f[J>>2]=K;f[G>>2]=K;K=f[j>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0)O=K;else{zT(o);O=f[j>>2]|0}b[O>>0]=G;b[O+1>>0]=G>>8;b[O+2>>0]=G>>16;b[O+3>>0]=G>>24;f[j>>2]=(f[j>>2]|0)+4;K=f[J>>2]|0;if((L|0)<(l|0)){C=L;D=K}else{H=K;break}}}else H=B;while(0);xT(q);L=f[B+4>>2]|0;B=t+24|0;t=f[B>>2]|0;O=t+-1|0;f[H+4>>2]=0;c:do if((a|0)>1){N=o+12|0;F=o+20|0;I=p+12|0;D=p+20|0;C=1;j=n;g=0;K=L;J=O;M=H;P=t;while(1){Q=j+x|0;d:do if(w){R=0;S=M;while(1){T=R;while(1){if(b[Q+T>>0]|0){U=T;break}V=T+1|0;if((V|0)<(l|0))T=V;else{U=V;break}}if((U|0)==(l|0)){W=S;break d}T=f[z>>2]|0;if(T>>>0<(f[v>>2]|0)>>>0)X=T;else{zT(q);X=f[z>>2]|0}b[X>>0]=0;b[X+1>>0]=0;b[X+2>>0]=0;b[X+3>>0]=0;T=X+4|0;b[T>>0]=0;b[T+1>>0]=0;b[T+2>>0]=0;b[T+3>>0]=0;T=X+8|0;b[T>>0]=U;b[T+1>>0]=U>>8;b[T+2>>0]=U>>16;b[T+3>>0]=U>>24;T=X+12|0;b[T>>0]=C;b[T+1>>0]=C>>8;b[T+2>>0]=C>>16;b[T+3>>0]=C>>24;T=(f[z>>2]|0)+16|0;f[z>>2]=T;V=T+(0-(f[(f[y>>2]|0)+28>>2]|0))|0;f[S+4>>2]=V;Y=U+1|0;e:do if((l|0)>(Y|0)){Z=Y;while(1){if(!(b[Q+Z>>0]|0)){_=Z;break e}$=Z+1|0;if(($|0)<(l|0))Z=$;else{_=$;break}}}else _=Y;while(0);Y=_+-1|0;if(T>>>0<(f[v>>2]|0)>>>0)aa=T;else{zT(q);aa=f[z>>2]|0}b[aa>>0]=0;b[aa+1>>0]=0;b[aa+2>>0]=0;b[aa+3>>0]=0;Z=aa+4|0;b[Z>>0]=0;b[Z+1>>0]=0;b[Z+2>>0]=0;b[Z+3>>0]=0;Z=aa+8|0;b[Z>>0]=Y;b[Z+1>>0]=Y>>8;b[Z+2>>0]=Y>>16;b[Z+3>>0]=Y>>24;Y=aa+12|0;b[Y>>0]=C;b[Y+1>>0]=C>>8;b[Y+2>>0]=C>>16;b[Y+3>>0]=C>>24;Y=(f[z>>2]|0)+16|0;f[z>>2]=Y;Z=Y+(0-(f[(f[y>>2]|0)+28>>2]|0))|0;f[V+4>>2]=Z;if((_|0)<(l|0)){R=_;S=Z}else{W=Z;break}}}else W=M;while(0);xT(q);G=f[M+4>>2]|0;E=(f[B>>2]|0)-P|0;f[W+4>>2]=0;S=(J|0)/2|0;R=(E|0)/2|0;f:do if((J|0)>1&(E|0)>1){Z=0;Y=0;$=G;ba=K;ca=0;da=g;while(1){g:do switch(ca|0){case 0:{ea=f[ba+4>>2]|0;fa=f[ea+8>>2]|0;ga=$+4|0;ha=f[ga>>2]|0;ia=f[ha+8>>2]|0;if((fa|0)<(ia|0)){ja=(fa|0)<((f[$+8>>2]|0)+-1|0);f[(ja?ea:$)>>2]=ba;ka=Z+1|0;la=Y;ma=$;na=f[ea+4>>2]|0;oa=(ja^1)&1;pa=ja?da:ea;break g}if((f[ba+8>>2]|0)>(ia+1|0)){f[$>>2]=ha;ia=f[N>>2]|0;if(ia>>>0<(f[F>>2]|0)>>>0)qa=ia;else{zT(o);qa=f[N>>2]|0}b[qa>>0]=$;b[qa+1>>0]=$>>8;b[qa+2>>0]=$>>16;b[qa+3>>0]=$>>24;f[N>>2]=(f[N>>2]|0)+4;ra=0;sa=da;ta=f[ga>>2]|0}else{f[$>>2]=ba;ra=-1;sa=ha;ta=ha}ka=Z;la=Y+1|0;ma=f[ta+4>>2]|0;na=ba;oa=ra;pa=sa;break}case 1:{ha=f[$+4>>2]|0;ga=f[ha+8>>2]|0;if((f[ba+8>>2]|0)>(ga+1|0)){f[da>>2]=ha;ka=Z;la=Y+1|0;ma=f[ha+4>>2]|0;na=ba;oa=0;pa=da;break g}f[da>>2]=ba;ia=f[ba+4>>2]|0;if((f[ia+8>>2]|0)<(ga|0)){ka=Z+1|0;la=Y;ma=$;na=f[ia+4>>2]|0;oa=1;pa=ia;break g}else{ka=Z;la=Y+1|0;ma=f[ha+4>>2]|0;na=ba;oa=-1;pa=ha;break g}break}case -1:{ha=ba+4|0;ia=f[ha>>2]|0;if((f[$+8>>2]|0)>((f[ia+8>>2]|0)+1|0)){f[ia>>2]=da;ka=Z+1|0;la=Y;ma=$;na=f[ia+4>>2]|0;oa=0;pa=da;break g}ia=f[I>>2]|0;if(ia>>>0<(f[D>>2]|0)>>>0)ua=ia;else{zT(p);ua=f[I>>2]|0}b[ua>>0]=$;b[ua+1>>0]=$>>8;b[ua+2>>0]=$>>16;b[ua+3>>0]=$>>24;f[I>>2]=(f[I>>2]|0)+4;f[$>>2]=da;ia=f[$+4>>2]|0;ga=f[ha>>2]|0;if((f[ia+8>>2]|0)<(f[ga+8>>2]|0)){ka=Z;la=Y+1|0;ma=f[ia+4>>2]|0;na=ba;oa=-1;pa=ia;break g}else{ka=Z+1|0;la=Y;ma=$;na=f[ga+4>>2]|0;oa=1;pa=ga;break g}break}default:{ka=Z;la=Y;ma=$;na=ba;oa=ca;pa=da}}while(0);if((la|0)<(R|0)&(ka|0)<(S|0)){Z=ka;Y=la;$=ma;ba=na;ca=oa;da=pa}else{va=ka;wa=la;xa=ma;ya=na;za=oa;Aa=pa;break f}}}else{va=0;wa=0;xa=G;ya=K;za=0;Aa=g}while(0);if((wa|0)<(R|0)){da=wa;ca=xa;ba=za;while(1){$=ca+4|0;Y=f[$>>2]|0;if(!ba){f[ca>>2]=Y;Z=f[N>>2]|0;if(Z>>>0<(f[F>>2]|0)>>>0)Ba=Z;else{zT(o);Ba=f[N>>2]|0}b[Ba>>0]=ca;b[Ba+1>>0]=ca>>8;b[Ba+2>>0]=ca>>16;b[Ba+3>>0]=ca>>24;f[N>>2]=(f[N>>2]|0)+4;Ca=f[$>>2]|0}else{f[Aa>>2]=Y;Ca=Y}da=da+1|0;if((da|0)>=(R|0)){Da=0;break}else{ca=f[Ca+4>>2]|0;ba=0}}}else Da=za;if((va|0)<(S|0)){ba=va;ca=ya;R=Da;while(1){da=f[ca+4>>2]|0;Y=ca;ca=f[da+4>>2]|0;f[da>>2]=(R|0)==0?Y:Aa;ba=ba+1|0;if((ba|0)==(S|0))break;else R=0}}R=C+1|0;if((R|0)>=(a|0)){Ea=G;Fa=E;break c}C=R;j=Q;g=Aa;K=G;J=E;M=W;P=f[B>>2]|0}}else{Ea=L;Fa=O}while(0);O=(Fa|0)/2|0;if((Fa|0)>1){Fa=0;L=Ea;while(1){Ea=f[L+4>>2]|0;f[Ea>>2]=L;Fa=Fa+1|0;if((Fa|0)>=(O|0))break;else L=f[Ea+4>>2]|0}}L=yT(o)|0;o=yT(p)|0;p=r+12|0;O=r+20|0;Fa=0;Ea=0;B=0;W=0;while(1){Aa=(W|0)==0;a=Aa?L:o;tT(a,r,0);Da=a+24|0;if((f[Da>>2]|0)>0)if(Aa){Aa=Ea;a=B;ya=Fa;va=0;while(1){za=f[p>>2]|0;Ca=h[za>>0]|h[za+1>>0]<<8|h[za+2>>0]<<16|h[za+3>>0]<<24;Ba=za+4|0;f[p>>2]=Ba;if(Ba>>>0>=(f[O>>2]|0)>>>0)BT(r,1);if(f[Ca>>2]|0){wT(20492,e,8,c,q);Ba=Ca;za=f[z>>2]|0;do{if(za>>>0<(f[v>>2]|0)>>>0)Ga=za;else{zT(q);Ga=f[z>>2]|0}xa=Ba+8|0;wa=xa;pa=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;wa=xa+4|0;xa=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;wa=Ga;oa=wa;b[oa>>0]=pa;b[oa+1>>0]=pa>>8;b[oa+2>>0]=pa>>16;b[oa+3>>0]=pa>>24;pa=wa+4|0;b[pa>>0]=xa;b[pa+1>>0]=xa>>8;b[pa+2>>0]=xa>>16;b[pa+3>>0]=xa>>24;za=(f[z>>2]|0)+8|0;f[z>>2]=za;xa=Ba;Ba=f[Ba>>2]|0;f[xa>>2]=0}while((Ba|0)!=(Ca|0));Ca=yT(q)|0;ooa(s,Ca,1);if(!Aa){Ha=Ca;Ia=Ca}else{f[Ca+8>>2]=a;f[a+12>>2]=Ca;Ha=Aa;Ia=Ca}}else{Ha=Aa;Ia=a}va=va+1|0;Ca=ya+1|0;if((va|0)>=(f[Da>>2]|0)){Ja=Ca;Ka=Ha;La=Ia;break}else{Aa=Ha;a=Ia;ya=Ca}}}else{ya=Ea;a=B;Aa=Fa;va=0;while(1){Ca=f[p>>2]|0;Ba=h[Ca>>0]|h[Ca+1>>0]<<8|h[Ca+2>>0]<<16|h[Ca+3>>0]<<24;za=Ca+4|0;f[p>>2]=za;if(za>>>0>=(f[O>>2]|0)>>>0)BT(r,1);if(f[Ba>>2]|0){wT(20492,e,8,c,q);za=Ba;Ca=f[z>>2]|0;do{if(Ca>>>0<(f[v>>2]|0)>>>0)Ma=Ca;else{zT(q);Ma=f[z>>2]|0}E=za+8|0;G=E;Q=h[G>>0]|h[G+1>>0]<<8|h[G+2>>0]<<16|h[G+3>>0]<<24;G=E+4|0;E=h[G>>0]|h[G+1>>0]<<8|h[G+2>>0]<<16|h[G+3>>0]<<24;G=Ma;xa=G;b[xa>>0]=Q;b[xa+1>>0]=Q>>8;b[xa+2>>0]=Q>>16;b[xa+3>>0]=Q>>24;Q=G+4|0;b[Q>>0]=E;b[Q+1>>0]=E>>8;b[Q+2>>0]=E>>16;b[Q+3>>0]=E>>24;Ca=(f[z>>2]|0)+8|0;f[z>>2]=Ca;E=za;za=f[za>>2]|0;f[E>>2]=0}while((za|0)!=(Ba|0));Ba=yT(q)|0;ooa(s,Ba,1);f[Ba>>2]=f[Ba>>2]|32768;if(!ya){Na=Ba;Oa=Ba}else{f[Ba+8>>2]=a;f[a+12>>2]=Ba;Na=ya;Oa=Ba}}else{Na=ya;Oa=a}va=va+1|0;Ba=Aa+1|0;if((va|0)>=(f[Da>>2]|0)){Ja=Ba;Ka=Na;La=Oa;break}else{ya=Na;a=Oa;Aa=Ba}}}else{Ja=Fa;Ka=Ea;La=B}W=W+1|0;if((W|0)>=2)break;else{Fa=Ja;Ea=Ka;B=La}}f[d>>2]=Ka;UXc(i);UXc(k);A=(Ka|0)==0?-1:Ja;u=m;return A|0}function nEa(a){a=a|0;NXc(a);cYc(a);return}function oEa(a){a=a|0;var b=0;b=a+12|0;p3(b,f[b>>2]|0);return}function pEa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==368676?a+12|0:0)|0}function qEa(a){a=a|0;cYc(a);return}function rEa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;i=u;u=u+336|0;j=i+32|0;k=i+272|0;l=i+216|0;m=i+180|0;n=i;o=i+144|0;p=i+88|0;q=i+208|0;if(((eS(c)|0)!=262144?(eS(c)|0)!=327680:0)?(eS(c)|0)!=720896:0){r=$Xc(160)|0;f[j>>2]=r;f[j+8>>2]=-2147483488;f[j+4>>2]=155;o1c(r|0,368807,155)|0;b[r+155>>0]=0;vM(-215,j,368963,368008,1885)}if(!(sS(c)|0)){if((rS(c,-1)|0)!=2){s=$Xc(80)|0;f[j>>2]=s;t=j+8|0;f[t>>2]=-2147483568;v=j+4|0;f[v>>2]=79;w=s;x=368976;y=w+79|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+79|0;b[z>>0]=0;vM(-215,j,368963,368008,1887)}if((qS(c,-1)|0)!=4){s=$Xc(80)|0;f[j>>2]=s;t=j+8|0;f[t>>2]=-2147483568;v=j+4|0;f[v>>2]=79;w=s;x=368976;y=w+79|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+79|0;b[z>>0]=0;vM(-215,j,368963,368008,1887)}}do if((eS(a)|0)==65536){z=f[a+4>>2]|0;f[k>>2]=f[z>>2];s=k+4|0;v=z+4|0;f[s>>2]=f[v>>2];t=k+8|0;f[t>>2]=f[z+8>>2];f[k+12>>2]=f[z+12>>2];f[k+16>>2]=f[z+16>>2];f[k+20>>2]=f[z+20>>2];f[k+24>>2]=f[z+24>>2];f[k+28>>2]=f[z+28>>2];f[k+32>>2]=f[z+32>>2];r=f[z+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=t;t=k+48|0;A=k+44|0;f[A>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(r|0){t=r+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[v>>2]|0)<3){v=f[z+44>>2]|0;t=f[A>>2]|0;f[t>>2]=f[v>>2];f[t+4>>2]=f[v+4>>2];break}else{f[s>>2]=0;U$(k,z);break}}else bS(k,a,-1);while(0);f[l>>2]=1124007936;a=l+4|0;z=l+8|0;s=l+40|0;w=a;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[s>>2]=z;v=l+48|0;t=l+44|0;f[t>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if((g|0)==5){A=k+36|0;r=f[A>>2]|0;if(r){B=r+12|0;f[B>>2]=(f[B>>2]|0)+1;B=l+36|0;r=f[B>>2]|0;if((r|0)!=0?(C=r+12|0,r=f[C>>2]|0,f[C>>2]=r+-1,(r|0)==1):0){V$(l);D=B}else D=B}else D=l+36|0;f[D>>2]=0;B=l+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){r=f[s>>2]|0;C=0;do{f[r+(C<<2)>>2]=0;C=C+1|0;E=f[a>>2]|0}while((C|0)<(E|0));f[l>>2]=f[k>>2];if((E|0)<3)F=28;else F=30}else{f[l>>2]=f[k>>2];F=28}if((F|0)==28){E=f[k+4>>2]|0;if((E|0)<3){f[a>>2]=E;f[z>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];E=f[k+44>>2]|0;C=f[t>>2]|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2]}else F=30}if((F|0)==30)U$(l,k);f[B>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];f[D>>2]=f[A>>2];G=0}else{f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=k;A=m+8|0;f[A>>2]=0;f[A+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[n+28>>2]=0;rR(j,m,1,1,1,1,16,n);G=-1}A=hT(0)|0;D=$Xc(16)|0;f[D+4>>2]=0;f[D+8>>2]=0;f[D>>2]=78964;f[D+12>>2]=A;B=f[z>>2]|0;z=(f[a>>2]|0)==1?1:f[l+12>>2]|0;F=f[l>>2]|0;E=l+16|0;C=f[E>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=C;f[m+20>>2]=B;f[m+24>>2]=z;f[m+4>>2]=f[f[t>>2]>>2];f[m>>2]=F&20479|1111621632;f[n>>2]=0;if(aT(d)|0)$S(d);mEa(m,A,n,88,e,g,(f[h>>2]|0)+G|0,(f[h+4>>2]|0)+G|0,0)|0;G=f[n>>2]|0;if(G){n=ET(G,56,A)|0;do if(n)if((f[n+28>>2]|0)==4){H=f[n+24>>2]|0;break}else{A=$Xc(48)|0;f[j>>2]=A;f[j+8>>2]=-2147483600;f[j+4>>2]=39;w=A;x=369056;y=w+39|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[A+39>>0]=0;vM(-215,j,369096,369100,2915)}else H=0;while(0);ZS(c,H,1,0,-1,1,0);tT(n,o,0);G=o+32|0;f[G>>2]=0;h=(H|0)>0;a:do if(h){g=o+12|0;e=p+4|0;m=p+16|0;F=p+36|0;z=p+40|0;B=p+48|0;C=p+44|0;r=q+4|0;I=o+20|0;J=o+4|0;K=0;while(1){L=f[f[g>>2]>>2]|0;f[L+72>>2]=K;ZS(c,f[L+24>>2]|0,1,12,K,1,0);bS(p,c,K);if(!(f[p>>2]&16384))break;M=f[m>>2]|0;f[q>>2]=0;f[r>>2]=1073741823;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2];rT(L,M,j)|0;M=f[F>>2]|0;if(M|0?(L=M+12|0,M=f[L>>2]|0,f[L>>2]=M+-1,(M|0)==1):0)V$(p);f[F>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[e>>2]|0)>0){M=f[z>>2]|0;L=0;do{f[M+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[e>>2]|0))}L=f[C>>2]|0;if((L|0)!=(B|0))wL(L);K=K+1|0;L=(f[g>>2]|0)+4|0;f[g>>2]=L;if(L>>>0>=(f[I>>2]|0)>>>0)BT(o,1);L=(f[G>>2]|0)+1|0;f[G>>2]=L;f[G>>2]=(L|0)<(f[(f[J>>2]|0)+24>>2]<<1|0)?L:0;if((K|0)>=(H|0))break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;K=$Xc(32)|0;f[j>>2]=K;f[j+8>>2]=-2147483616;f[j+4>>2]=17;w=K;x=369183;y=w+17|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[K+17>>0]=0;vM(-215,j,368963,368008,1921)}while(0);if(aT(d)|0){ZS(d,1,H,28,-1,1,0);do if((eS(d)|0)==65536){p=f[d+4>>2]|0;f[j>>2]=f[p>>2];q=j+4|0;J=p+4|0;f[q>>2]=f[J>>2];I=j+8|0;f[I>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];g=j+16|0;f[g>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];f[j+32>>2]=f[p+32>>2];B=j+36|0;C=f[p+36>>2]|0;f[B>>2]=C;f[j+40>>2]=I;I=j+48|0;e=j+44|0;f[e>>2]=I;f[I>>2]=0;f[j+52>>2]=0;if(C|0){I=C+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[J>>2]|0)<3){J=f[p+44>>2]|0;I=f[e>>2]|0;f[I>>2]=f[J>>2];f[I+4>>2]=f[J+4>>2];N=g;O=e;P=B;break}else{f[q>>2]=0;U$(j,p);N=g;O=e;P=B;break}}else{bS(j,d,-1);N=j+16|0;O=j+44|0;P=j+36|0}while(0);d=f[N>>2]|0;B=f[P>>2]|0;if(B|0?(e=B+12|0,B=f[e>>2]|0,f[e>>2]=B+-1,(B|0)==1):0)V$(j);f[P>>2]=0;P=j+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[P>>2]|0)>0){N=f[j+40>>2]|0;B=0;do{f[N+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[P>>2]|0))}P=f[O>>2]|0;if((P|0)!=(j+48|0))wL(P);tT(n,j,0);f[j+32>>2]=0;w=o;x=j;y=w+36|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));if(h){h=o+12|0;x=o+20|0;w=o+4|0;y=0;do{j=f[f[h>>2]>>2]|0;n=f[j+12>>2]|0;if(!n)Q=-1;else Q=f[n+72>>2]|0;n=f[j+8>>2]|0;if(!n)R=-1;else R=f[n+72>>2]|0;n=f[j+20>>2]|0;if(!n)S=-1;else S=f[n+72>>2]|0;n=f[j+16>>2]|0;if(!n)T=-1;else T=f[n+72>>2]|0;f[d+(y<<4)>>2]=Q;f[d+(y<<4)+4>>2]=R;f[d+(y<<4)+8>>2]=S;f[d+(y<<4)+12>>2]=T;y=y+1|0;n=(f[h>>2]|0)+4|0;f[h>>2]=n;if(n>>>0>=(f[x>>2]|0)>>>0)BT(o,1);n=(f[G>>2]|0)+1|0;f[G>>2]=n;f[G>>2]=(n|0)<(f[(f[w>>2]|0)+24>>2]<<1|0)?n:0}while((y|0)<(H|0))}}}else $S(c);UXc(D);D=l+36|0;c=f[D>>2]|0;if(c|0?(H=c+12|0,c=f[H>>2]|0,f[H>>2]=c+-1,(c|0)==1):0)V$(l);f[D>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[a>>2]|0)>0){E=f[s>>2]|0;s=0;do{f[E+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[a>>2]|0))}a=f[t>>2]|0;if((a|0)!=(v|0))wL(a);a=k+36|0;v=f[a>>2]|0;if(v|0?(t=v+12|0,v=f[t>>2]|0,f[t>>2]=v+-1,(v|0)==1):0)V$(k);f[a>>2]=0;a=k+16|0;v=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[v>>2]|0)>0){a=f[k+40>>2]|0;t=0;do{f[a+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[k+44>>2]|0;if((v|0)==(k+48|0)){u=i;return}wL(v);u=i;return}function sEa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0.0,Ra=0,Sa=0;i=u;u=u+1584|0;j=i+536|0;k=i+472|0;l=i+224|0;m=i+408|0;o=i+352|0;p=i+528|0;q=i+296|0;r=i+464|0;s=i+272|0;t=i;v=i+256|0;do if((eS(a)|0)==65536){w=f[a+4>>2]|0;f[m>>2]=f[w>>2];x=m+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[w+8>>2];f[m+12>>2]=f[w+12>>2];f[m+16>>2]=f[w+16>>2];f[m+20>>2]=f[w+20>>2];f[m+24>>2]=f[w+24>>2];f[m+28>>2]=f[w+28>>2];f[m+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(m,w);break}}else bS(m,a,-1);while(0);f[o>>2]=1124007936;a=o+4|0;w=o+8|0;x=o+40|0;y=a;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=w;B=o+48|0;A=o+44|0;f[A>>2]=B;f[B>>2]=0;f[o+52>>2]=0;C=aT(d)|0;if(f[m>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;D=$Xc(32)|0;f[j>>2]=D;f[j+8>>2]=-2147483616;f[j+4>>2]=21;y=D;E=369201;z=y+21|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));b[D+21>>0]=0;vM(-215,j,369223,369241,724)}D=m+40|0;F=f[D>>2]|0;G=f[F>>2]|0;f[p>>2]=f[F+4>>2];f[p+4>>2]=G;wS(c,p,5,-1,0,0);do if((eS(c)|0)==65536){p=f[c+4>>2]|0;f[q>>2]=f[p>>2];G=q+4|0;F=p+4|0;f[G>>2]=f[F>>2];H=q+8|0;f[H>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2];f[q+24>>2]=f[p+24>>2];f[q+28>>2]=f[p+28>>2];f[q+32>>2]=f[p+32>>2];I=f[p+36>>2]|0;f[q+36>>2]=I;f[q+40>>2]=H;H=q+48|0;J=q+44|0;f[J>>2]=H;f[H>>2]=0;f[q+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[F>>2]|0)<3){F=f[p+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[F>>2];f[H+4>>2]=f[F+4>>2];break}else{f[G>>2]=0;U$(q,p);break}}else bS(q,c,-1);while(0);a:do if(C){if((h|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=$Xc(64)|0;f[j>>2]=c;f[j+8>>2]=-2147483584;f[j+4>>2]=62;y=c;E=369318;z=y+62|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));b[c+62>>0]=0;vM(-215,j,369223,369241,731)}p=f[D>>2]|0;G=f[p>>2]|0;f[r>>2]=f[p+4>>2];f[r+4>>2]=G;wS(d,r,4,-1,0,0);do if((eS(d)|0)==65536){G=f[d+4>>2]|0;f[j>>2]=f[G>>2];p=j+4|0;F=G+4|0;f[p>>2]=f[F>>2];H=j+8|0;f[H>>2]=f[G+8>>2];f[j+12>>2]=f[G+12>>2];f[j+16>>2]=f[G+16>>2];f[j+20>>2]=f[G+20>>2];f[j+24>>2]=f[G+24>>2];f[j+28>>2]=f[G+28>>2];f[j+32>>2]=f[G+32>>2];J=f[G+36>>2]|0;f[j+36>>2]=J;f[j+40>>2]=H;H=j+48|0;I=j+44|0;f[I>>2]=H;f[H>>2]=0;f[j+52>>2]=0;if(J|0){H=J+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[F>>2]|0)<3){F=f[G+44>>2]|0;H=f[I>>2]|0;f[H>>2]=f[F>>2];f[H+4>>2]=f[F+4>>2];break}else{f[p>>2]=0;U$(j,G);break}}else bS(j,d,-1);while(0);c=o+36|0;G=f[c>>2]|0;if(G|0?(p=G+12|0,G=f[p>>2]|0,f[p>>2]=G+-1,(G|0)==1):0)V$(o);f[c>>2]=0;G=o+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){p=f[x>>2]|0;F=0;do{f[p+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[a>>2]|0))}f[o>>2]=f[j>>2];F=j+4|0;p=f[F>>2]|0;f[a>>2]=p;H=j+8|0;f[w>>2]=f[H>>2];f[o+12>>2]=f[j+12>>2];I=j+16|0;f[G>>2]=f[I>>2];f[o+20>>2]=f[j+20>>2];f[o+24>>2]=f[j+24>>2];f[o+28>>2]=f[j+28>>2];f[o+32>>2]=f[j+32>>2];J=j+36|0;f[c>>2]=f[J>>2];K=o+44|0;L=f[K>>2]|0;if((L|0)==(B|0))M=p;else{wL(L);f[K>>2]=B;f[x>>2]=w;M=f[F>>2]|0}L=j+44|0;if((M|0)<3){p=f[L>>2]|0;f[B>>2]=f[p>>2];f[o+52>>2]=f[p+4>>2];N=p}else{f[K>>2]=f[L>>2];K=j+40|0;f[o+40>>2]=f[K>>2];p=j+48|0;f[L>>2]=p;f[K>>2]=H;N=p}f[j>>2]=1124007936;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;f[F+16>>2]=0;f[F+20>>2]=0;f[F+24>>2]=0;f[F+28>>2]=0;f[J>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((N|0)!=(j+48|0))wL(N);f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;O=5;P=s}else{f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;switch(g|0){case 0:case 3:case 5:{O=g;P=s;break a;break}default:{}}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;I=$Xc(48)|0;f[j>>2]=I;f[j+8>>2]=-2147483600;f[j+4>>2]=41;y=I;E=369381;z=y+41|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));b[I+41>>0]=0;vM(-201,j,369223,369241,741)}while(0);P=(e|0)==1;if((e|2|0)!=3){g=(e|0)==2&C?5:O;if(!g){O=f[D>>2]|0;N=f[q+40>>2]|0;if(!((f[O>>2]|0)==(f[N>>2]|0)?(f[O+4>>2]|0)==(f[N+4>>2]|0):0)){N=$Xc(32)|0;f[j>>2]=N;f[j+8>>2]=-2147483616;f[j+4>>2]=24;y=N;E=369423;z=y+24|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));b[N+24>>0]=0;vM(-215,j,369448,369241,564)}if(f[m>>2]&4095|0){Q=$Xc(48)|0;f[j>>2]=Q;R=j+8|0;f[R>>2]=-2147483600;S=j+4|0;f[S>>2]=47;y=Q;E=369462;z=y+47|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));T=Q+47|0;b[T>>0]=0;vM(-215,j,369448,369241,566)}if((f[q>>2]&4095|0)!=5){Q=$Xc(48)|0;f[j>>2]=Q;R=j+8|0;f[R>>2]=-2147483600;S=j+4|0;f[S>>2]=47;y=Q;E=369462;z=y+47|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));T=Q+47|0;b[T>>0]=0;vM(-215,j,369448,369241,566)}T=m+8|0;Q=f[T>>2]|0;S=m+12|0;R=f[S>>2]|0;N=Q<<1;O=Q*3|0;M=(Q*12|0)+4+(Q<<3)|0;w=R<<3;d=M>>>0<w>>>0?w:M;M=j+8|0;f[j>>2]=M;w=j+4|0;f[w>>2]=d;if(d>>>0>1032){r=bYc(d)|0;f[j>>2]=r;U=r}else U=M;r=U+(N<<2)+3&-4;d=r;c=r;r=(Q|0)>0;if(r){G=0;do{V=+(Y(G,G)|0);n[U+(G<<2)>>2]=V;G=G+1|0}while((G|0)!=(Q|0))}if((Q|0)<(N|0)){G=Q;do{n[U+(G<<2)>>2]=999999986991104.0;G=G+1|0}while((G|0)!=(N|0))}if(r){r=(N|0)>1?N:1;g1c(c|0,0,r<<2|0)|0;W=r}else W=0;if((W|0)<=(O|0)){r=W;while(1){f[d+(r<<2)>>2]=r-N;if((r|0)<(O|0))r=r+1|0;else break}}f[k>>2]=0;f[k+4>>2]=R;f[l>>2]=78992;f[l+4>>2]=m;f[l+8>>2]=q;r=f[T>>2]|0;f[l+12>>2]=d+(r<<1<<2)+4;f[l+16>>2]=U;d=f[m+4>>2]|0;if((d|0)<3)X=Y(f[S>>2]|0,r)|0;else{r=f[D>>2]|0;S=0;T=1;while(1){O=Y(f[r+(S<<2)>>2]|0,T)|0;S=S+1|0;if((S|0)==(d|0)){X=O;break}else T=O}}h3(k,l,+(X>>>0)*.0000152587890625);X=U+(R<<2)|0;n[U>>2]=0.0;n[X>>2]=0.0;if((R|0)>1){T=1;do{n[X+(T<<2)>>2]=.5/+(T|0);V=+(Y(T,T)|0);n[U+(T<<2)>>2]=V;T=T+1|0}while((T|0)!=(R|0))}f[k>>2]=0;f[k+4>>2]=Q;f[l>>2]=79012;f[l+4>>2]=q;f[l+8>>2]=U;f[l+12>>2]=X;h3(k,l,-1.0);X=f[j>>2]|0;if((X|0)!=(M|0)){if(X|0)dYc(X);f[j>>2]=M;f[w>>2]=1032}}else{Z=g;_=72}}else{Z=C?5:3;_=72}if((_|0)==72){switch(e|0){case 3:{$=0;break}case 2:case 1:{$=P?1:2;break}default:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;P=$Xc(80)|0;f[j>>2]=P;f[j+8>>2]=-2147483568;f[j+4>>2]=73;y=P;E=369510;z=y+73|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));b[P+73>>0]=0;vM(-215,j,369223,369241,784)}}switch($+(Z*10|0)|0){case 30:{n[s>>2]=1.0;aa=1.0;ba=1;break}case 31:{n[s>>2]=1.0;aa=2.0;ba=1;break}case 32:{n[s>>2]=.9549999833106995;aa=1.3693000078201294;ba=1;break}case 50:{n[s>>2]=1.0;n[s+4>>2]=1.0;aa=2.0;ba=2;break}case 51:{n[s>>2]=1.0;n[s+4>>2]=2.0;aa=3.0;ba=2;break}case 52:{n[s>>2]=1.0;n[s+4>>2]=1.399999976158142;aa=2.196899890899658;ba=2;break}default:{$=$Xc(32)|0;f[j>>2]=$;f[j+8>>2]=-2147483616;f[j+4>>2]=19;y=$;E=369584;z=y+19|0;do{b[y>>0]=b[E>>0]|0;y=y+1|0;E=E+1|0}while((y|0)<(z|0));b[$+19>>0]=0;vM(-5,j,369604,369241,445)}}n[s+(ba<<2)>>2]=aa;ba=f[D>>2]|0;$=(Z|0)==3;Z=$?2:4;E=(f[ba>>2]|0)+Z|0;P=(f[ba+4>>2]|0)+Z|0;f[k>>2]=1124007936;Z=k+4|0;ba=k+8|0;e=k+40|0;y=Z;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[e>>2]=ba;ba=k+48|0;_=k+44|0;f[_>>2]=ba;f[ba>>2]=0;f[k+52>>2]=0;f[j>>2]=E;f[j+4>>2]=P;S$(k,2,j,4);b:do if(C){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=l;f[j+8>>2]=1;f[j+12>>2]=4;mR(o,j,fT()|0)|0;if(!h){h$(t,m,0.0);f[j>>2]=1124007936;P=j+4|0;E=j+8|0;g=j+40|0;y=P;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[g>>2]=E;I=j+48|0;w=j+44|0;f[w>>2]=I;f[I>>2]=0;f[j+52>>2]=0;M=f[t>>2]|0;ei[f[(f[M>>2]|0)+12>>2]&511](M,t,j,-1);Zj(t);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;M=v+8|0;f[M>>2]=0;f[M+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=o;Vva(l,v,8,4,0)|0;M=j+36|0;X=f[M>>2]|0;if(X|0?(U=X+12|0,X=f[U>>2]|0,f[U>>2]=X+-1,(X|0)==1):0)V$(j);f[M>>2]=0;M=j+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[P>>2]|0)>0){M=f[g>>2]|0;X=0;do{f[M+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[P>>2]|0))}P=f[w>>2]|0;if((P|0)!=(I|0))wL(P)}else{P=m+8|0;if((f[P>>2]|0)>0){X=m+12|0;M=f[m+16>>2]|0;g=f[m+44>>2]|0;E=f[o+16>>2]|0;U=f[A>>2]|0;Q=0;R=1;T=f[X>>2]|0;while(1){d=M+(Y(f[g>>2]|0,Q)|0)|0;S=E+(Y(f[U>>2]|0,Q)|0)|0;if((T|0)>0){r=0;O=R;N=T;while(1){if(!(b[d+r>>0]|0)){f[S+(r<<2)>>2]=O;ca=O+1|0;da=f[X>>2]|0}else{ca=O;da=N}r=r+1|0;if((r|0)>=(da|0)){ea=ca;fa=da;break}else{O=ca;N=da}}}else{ea=R;fa=T}Q=Q+1|0;if((Q|0)>=(f[P>>2]|0))break;else{R=ea;T=fa}}}}aa=+n[s+4>>2];V=+n[s+8>>2];T=ALc(+n[s>>2]*65536.0)|0;R=ALc(aa*65536.0)|0;P=ALc(V*65536.0)|0;Q=f[m+16>>2]|0;X=f[k+16>>2]|0;U=f[_>>2]|0;E=f[q+16>>2]|0;g=f[o+16>>2]|0;M=f[m+48>>2]|0;I=(f[ba>>2]|0)>>>2;w=(f[q+48>>2]|0)>>>2;N=(f[B>>2]|0)>>>2;O=f[D>>2]|0;r=f[O+4>>2]|0;S=f[O>>2]|0;O=f[e>>2]|0;d=f[O+4>>2]|0;W=f[O>>2]|0;if((d|0)>0){O=X+(Y(f[U>>2]|0,W+-1|0)|0)|0;c=0;do{f[X+(c<<2)>>2]=2147483647;f[O+(c<<2)>>2]=2147483647;c=c+1|0}while((c|0)!=(d|0));c=f[U>>2]|0;O=X+c|0;G=X+(Y(c,W+-2|0)|0)|0;c=0;do{f[O+(c<<2)>>2]=2147483647;f[G+(c<<2)>>2]=2147483647;c=c+1|0}while((c|0)!=(d|0))}if((S|0)>0){d=(r|0)>0;c=I<<1;G=N<<1;O=~G;W=1-G|0;U=-2-N|0;J=~N;F=1-N|0;p=2-N|0;H=r+1|0;K=0;do{L=Y(K,M)|0;ga=X+((Y(K+2|0,I)|0)<<2)+8|0;ha=Y(K,N)|0;f[ga+(r<<2)>>2]=2147483647;f[ga+-4>>2]=2147483647;f[ga+(H<<2)>>2]=2147483647;f[ga+-8>>2]=2147483647;ia=Q+L|0;L=g+(ha<<2)|0;if(d){ha=0;do{if(!(b[ia+ha>>0]|0)){ja=0;ka=ga}else{la=ha-c|0;ma=(f[ga+(la+-1<<2)>>2]|0)+P|0;if(ma>>>0<2147483647){na=ma;oa=f[L+(ha+O<<2)>>2]|0}else{na=2147483647;oa=0}ma=(f[ga+(la+1<<2)>>2]|0)+P|0;if(na>>>0>ma>>>0){pa=ma;qa=f[L+(W+ha<<2)>>2]|0}else{pa=na;qa=oa}ma=ha-I|0;la=(f[ga+(ma+-2<<2)>>2]|0)+P|0;if(pa>>>0>la>>>0){ra=la;sa=f[L+(U+ha<<2)>>2]|0}else{ra=pa;sa=qa}la=(f[ga+(ma+-1<<2)>>2]|0)+R|0;if(ra>>>0>la>>>0){ta=la;ua=f[L+(ha+J<<2)>>2]|0}else{ta=ra;ua=sa}la=(f[ga+(ma<<2)>>2]|0)+T|0;if(ta>>>0>la>>>0){va=la;wa=f[L+(ha-N<<2)>>2]|0}else{va=ta;wa=ua}la=(f[ga+(ma+1<<2)>>2]|0)+R|0;if(va>>>0>la>>>0){xa=la;ya=f[L+(F+ha<<2)>>2]|0}else{xa=va;ya=wa}la=(f[ga+(ma+2<<2)>>2]|0)+P|0;if(xa>>>0>la>>>0){za=la;Aa=f[L+(p+ha<<2)>>2]|0}else{za=xa;Aa=ya}la=ha+-1|0;ma=(f[ga+(la<<2)>>2]|0)+T|0;if(za>>>0>ma>>>0){Ba=ma;Ca=f[L+(la<<2)>>2]|0}else{Ba=za;Ca=Aa}f[ga+(ha<<2)>>2]=Ba;ja=Ca;ka=L}f[ka+(ha<<2)>>2]=ja;ha=ha+1|0}while((ha|0)!=(r|0))}K=K+1|0}while((K|0)!=(S|0));K=c+-1|0;p=G+-1|0;F=N+2|0;J=S;do{U=J;J=J+-1|0;W=E+((Y(J,w)|0)<<2)|0;O=X+((Y(U+1|0,I)|0)<<2)+8|0;Q=g+((Y(J,N)|0)<<2)|0;if(d){H=r;do{M=H;H=H+-1|0;ha=O+(H<<2)|0;L=f[ha>>2]|0;ga=Q+(H<<2)|0;if(L>>>0>T>>>0){ia=(f[O+(M+c<<2)>>2]|0)+P|0;la=L>>>0>ia>>>0;ma=la?ia:L;ia=(f[O+(K+H<<2)>>2]|0)+P|0;Da=ma>>>0>ia>>>0;Ea=Da?ia:ma;ma=H+I|0;ia=(f[O+(ma+2<<2)>>2]|0)+P|0;Fa=Ea>>>0>ia>>>0;Ga=Fa?ia:Ea;Ea=(f[O+(M+I<<2)>>2]|0)+R|0;ia=Ga>>>0>Ea>>>0;Ha=ia?Ea:Ga;Ga=(f[O+(ma<<2)>>2]|0)+T|0;Ea=Ha>>>0>Ga>>>0;Ia=H+N|0;Ja=Ea?Ga:Ha;Ha=(f[O+(ma+-1<<2)>>2]|0)+R|0;Ga=Ja>>>0>Ha>>>0;Ka=Ga?Ha:Ja;Ja=(f[O+(ma+-2<<2)>>2]|0)+P|0;ma=Ka>>>0>Ja>>>0;Ha=ma?Ja:Ka;Ka=(f[O+(M<<2)>>2]|0)+T|0;Ja=Ha>>>0>Ka>>>0;La=Ja?Ka:Ha;Ha=f[(Ja?Q+(M<<2)|0:ma?Q+(Ia+-2<<2)|0:Ga?Q+(Ia+-1<<2)|0:Ea?Q+(Ia<<2)|0:ia?Q+(M+N<<2)|0:Fa?Q+(F+H<<2)|0:Da?Q+(p+H<<2)|0:la?Q+(M+G<<2)|0:ga)>>2]|0;f[ha>>2]=La;f[ga>>2]=Ha;Ma=La}else Ma=L;n[W+(H<<2)>>2]=+((Ma>>>0<536870911?Ma:536870911)>>>0)*.0000152587890625}while((M|0)>1)}}while((U|0)>1)}}else{V=+n[s>>2];aa=+n[s+4>>2];if($){G=ALc(V*65536.0)|0;p=ALc(aa*65536.0)|0;F=f[m+16>>2]|0;N=f[k+16>>2]|0;T=f[q+16>>2]|0;P=f[m+48>>2]|0;R=(f[ba>>2]|0)>>>2;I=(f[q+48>>2]|0)>>>2;K=f[D>>2]|0;c=f[K+4>>2]|0;r=f[K>>2]|0;K=f[e>>2]|0;d=f[K+4>>2]|0;if((d|0)>0){J=N+(Y(f[f[_>>2]>>2]|0,(f[K>>2]|0)+-1|0)|0)|0;K=0;do{f[N+(K<<2)>>2]=2147483647;f[J+(K<<2)>>2]=2147483647;K=K+1|0}while((K|0)!=(d|0))}if((r|0)<=0)break;d=(c|0)>0;if(d){K=0;do{J=Y(K,P)|0;K=K+1|0;g=N+((Y(K,R)|0)<<2)+4|0;f[g+(c<<2)>>2]=2147483647;f[g+-4>>2]=2147483647;X=F+J|0;J=0;w=2147483647;while(1){if(!(b[X+J>>0]|0))Na=0;else{E=J-R|0;S=(f[g+(E+-1<<2)>>2]|0)+p|0;H=(f[g+(E<<2)>>2]|0)+G|0;W=S>>>0>H>>>0?H:S;S=(f[g+(E+1<<2)>>2]|0)+p|0;E=W>>>0>S>>>0?S:W;W=w+G|0;Na=E>>>0>W>>>0?W:E}f[g+(J<<2)>>2]=Na;J=J+1|0;if((J|0)==(c|0))break;else w=Na}}while((K|0)!=(r|0))}else{K=0;do{K=K+1|0;F=N+((Y(K,R)|0)<<2)+4|0;f[F+(c<<2)>>2]=2147483647;f[F+-4>>2]=2147483647}while((K|0)!=(r|0))}if(d)Oa=r;else break;while(1){K=Oa;Oa=Oa+-1|0;F=T+((Y(Oa,I)|0)<<2)|0;P=N+((Y(K,R)|0)<<2)+4|0;w=c;do{J=w;w=w+-1|0;g=P+(w<<2)|0;X=f[g>>2]|0;if(X>>>0>G>>>0){U=w+R|0;E=(f[P+(J+R<<2)>>2]|0)+p|0;W=X>>>0>E>>>0?E:X;E=(f[P+(U<<2)>>2]|0)+G|0;S=W>>>0>E>>>0?E:W;W=(f[P+(U+-1<<2)>>2]|0)+p|0;U=S>>>0>W>>>0?W:S;S=(f[P+(J<<2)>>2]|0)+G|0;W=U>>>0>S>>>0?S:U;f[g>>2]=W;Pa=W}else Pa=X;n[F+(w<<2)>>2]=+((Pa>>>0<536870911?Pa:536870911)>>>0)*.0000152587890625}while((J|0)>1);if((K|0)<=1)break b}}Qa=+n[s+8>>2];G=ALc(V*65536.0)|0;p=ALc(aa*65536.0)|0;R=ALc(Qa*65536.0)|0;c=f[m+16>>2]|0;N=f[k+16>>2]|0;I=f[_>>2]|0;T=f[q+16>>2]|0;r=f[m+48>>2]|0;d=(f[ba>>2]|0)>>>2;w=(f[q+48>>2]|0)>>>2;F=f[D>>2]|0;P=f[F+4>>2]|0;J=f[F>>2]|0;F=f[e>>2]|0;X=f[F+4>>2]|0;W=f[F>>2]|0;if((X|0)>0){F=N+(Y(f[I>>2]|0,W+-1|0)|0)|0;g=0;do{f[N+(g<<2)>>2]=2147483647;f[F+(g<<2)>>2]=2147483647;g=g+1|0}while((g|0)!=(X|0));g=f[I>>2]|0;F=N+g|0;U=N+(Y(g,W+-2|0)|0)|0;g=0;do{f[F+(g<<2)>>2]=2147483647;f[U+(g<<2)>>2]=2147483647;g=g+1|0}while((g|0)!=(X|0))}if((J|0)>0){X=(P|0)>0;g=d<<1;U=P+1|0;if(X){F=0;do{W=Y(F,r)|0;I=N+((Y(F+2|0,d)|0)<<2)+8|0;f[I+(P<<2)>>2]=2147483647;f[I+-4>>2]=2147483647;f[I+(U<<2)>>2]=2147483647;f[I+-8>>2]=2147483647;S=c+W|0;W=0;do{if(!(b[S+W>>0]|0))Ra=0;else{E=W-g|0;H=(f[I+(E+-1<<2)>>2]|0)+R|0;Q=(f[I+(E+1<<2)>>2]|0)+R|0;E=H>>>0>Q>>>0?Q:H;H=W-d|0;Q=(f[I+(H+-2<<2)>>2]|0)+R|0;O=E>>>0>Q>>>0?Q:E;E=(f[I+(H+-1<<2)>>2]|0)+p|0;Q=O>>>0>E>>>0?E:O;O=(f[I+(H<<2)>>2]|0)+G|0;E=Q>>>0>O>>>0?O:Q;Q=(f[I+(H+1<<2)>>2]|0)+p|0;O=E>>>0>Q>>>0?Q:E;E=(f[I+(H+2<<2)>>2]|0)+R|0;H=O>>>0>E>>>0?E:O;O=(f[I+(W+-1<<2)>>2]|0)+G|0;Ra=H>>>0>O>>>0?O:H}f[I+(W<<2)>>2]=Ra;W=W+1|0}while((W|0)!=(P|0));F=F+1|0}while((F|0)!=(J|0))}else{F=0;do{c=N+((Y(F+2|0,d)|0)<<2)+8|0;f[c+(P<<2)>>2]=2147483647;f[c+-4>>2]=2147483647;f[c+(U<<2)>>2]=2147483647;f[c+-8>>2]=2147483647;F=F+1|0}while((F|0)!=(J|0))}F=g+-1|0;if(X){U=J;do{c=U;U=U+-1|0;r=T+((Y(U,w)|0)<<2)|0;W=N+((Y(c+1|0,d)|0)<<2)+8|0;I=P;do{S=I;I=I+-1|0;K=W+(I<<2)|0;H=f[K>>2]|0;if(H>>>0>G>>>0){O=(f[W+(S+g<<2)>>2]|0)+R|0;E=H>>>0>O>>>0?O:H;O=(f[W+(F+I<<2)>>2]|0)+R|0;Q=E>>>0>O>>>0?O:E;E=I+d|0;O=(f[W+(E+2<<2)>>2]|0)+R|0;M=Q>>>0>O>>>0?O:Q;Q=(f[W+(S+d<<2)>>2]|0)+p|0;O=M>>>0>Q>>>0?Q:M;M=(f[W+(E<<2)>>2]|0)+G|0;Q=O>>>0>M>>>0?M:O;O=(f[W+(E+-1<<2)>>2]|0)+p|0;M=Q>>>0>O>>>0?O:Q;Q=(f[W+(E+-2<<2)>>2]|0)+R|0;E=M>>>0>Q>>>0?Q:M;M=(f[W+(S<<2)>>2]|0)+G|0;Q=E>>>0>M>>>0?M:E;f[K>>2]=Q;Sa=Q}else Sa=H;n[r+(I<<2)>>2]=+((Sa>>>0<536870911?Sa:536870911)>>>0)*.0000152587890625}while((S|0)>1)}while((c|0)>1)}}}while(0);Sa=k+36|0;Ra=f[Sa>>2]|0;if(Ra|0?(s=Ra+12|0,Ra=f[s>>2]|0,f[s>>2]=Ra+-1,(Ra|0)==1):0)V$(k);f[Sa>>2]=0;Sa=k+16|0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[Z>>2]|0)>0){Sa=f[e>>2]|0;e=0;do{f[Sa+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[Z>>2]|0))}Z=f[_>>2]|0;if((Z|0)!=(ba|0))wL(Z)}Z=q+36|0;ba=f[Z>>2]|0;if(ba|0?(_=ba+12|0,ba=f[_>>2]|0,f[_>>2]=ba+-1,(ba|0)==1):0)V$(q);f[Z>>2]=0;Z=q+16|0;ba=q+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[ba>>2]|0)>0){Z=f[q+40>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[ba>>2]|0))}ba=f[q+44>>2]|0;if((ba|0)!=(q+48|0))wL(ba);ba=o+36|0;q=f[ba>>2]|0;if(q|0?(_=q+12|0,q=f[_>>2]|0,f[_>>2]=q+-1,(q|0)==1):0)V$(o);f[ba>>2]=0;ba=o+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[a>>2]|0)>0){ba=f[x>>2]|0;x=0;do{f[ba+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[A>>2]|0;if((a|0)!=(B|0))wL(a);a=m+36|0;B=f[a>>2]|0;if(B|0?(A=B+12|0,B=f[A>>2]|0,f[A>>2]=B+-1,(B|0)==1):0)V$(m);f[a>>2]=0;a=m+16|0;B=m+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[B>>2]|0)>0){a=f[D>>2]|0;D=0;do{f[a+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)==(m+48|0)){u=i;return}wL(B);u=i;return}function tEa(a){a=a|0;cYc(a);return}function uEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;c=u;u=u+1040|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;b=f[a+4>>2]|0;h=f[b+12>>2]|0;i=(h*12|0)+24|0;j=d+8|0;f[d>>2]=j;k=d+4|0;f[k>>2]=i;if(i>>>0>1032){l=bYc(i)|0;f[d>>2]=l;m=l}else m=j;l=m+(h<<2)|0;i=l+(h<<2)+4+3&-4;a:do if((e|0)<(g|0)){o=f[b+16>>2]|0;p=f[b+44>>2]|0;q=l+4|0;r=(h|0)>0;s=a+8|0;if((h|0)<=1){t=e;while(1){v=o+(Y(f[p>>2]|0,t)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];if(r){w=f[s>>2]|0;x=0;y=0;while(1){z=+(x|0);A=y;while(1){B=A+1|0;if(+n[l+(B<<2)>>2]<z)A=B;else break}B=f[i+(A<<2)>>2]|0;C=x-B|0;z=+M(+(+n[w+(((C|0)>-1?C:0-C|0)<<2)>>2]+ +n[m+(B<<2)>>2]));n[v+(x<<2)>>2]=z;x=x+1|0;if((x|0)==(h|0))break;else y=A}}t=t+1|0;if((t|0)==(g|0))break a}}t=f[s>>2]|0;y=f[a+12>>2]|0;x=e;do{v=o+(Y(f[p>>2]|0,x)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];w=0;B=1;do{z=+n[v+(B<<2)>>2];n[m+(B<<2)>>2]=z;D=z+ +n[t+(B<<2)>>2];C=w;while(1){E=f[i+(C<<2)>>2]|0;F=(D-+n[v+(E<<2)>>2]-+n[t+(E<<2)>>2])*+n[y+(B-E<<2)>>2];if(F>+n[l+(C<<2)>>2])break;else C=C+-1|0}w=C+1|0;f[i+(w<<2)>>2]=B;n[l+(w<<2)>>2]=F;n[l+(C+2<<2)>>2]=999999986991104.0;B=B+1|0}while((B|0)!=(h|0));if(r){B=0;w=0;while(1){D=+(B|0);A=w;while(1){E=A+1|0;if(+n[l+(E<<2)>>2]<D)A=E;else break}C=f[i+(A<<2)>>2]|0;E=B-C|0;D=+M(+(+n[t+(((E|0)>-1?E:0-E|0)<<2)>>2]+ +n[m+(C<<2)>>2]));n[v+(B<<2)>>2]=D;B=B+1|0;if((B|0)==(h|0))break;else w=A}}x=x+1|0}while((x|0)!=(g|0))}while(0);if((m|0)==(j|0)){u=c;return}dYc(m);f[d>>2]=j;f[k>>2]=1032;u=c;return}function vEa(a){a=a|0;cYc(a);return}function wEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+1072|0;e=d;g=f[c>>2]|0;h=f[c+4>>2]|0;c=f[a+4>>2]|0;i=f[c+8>>2]|0;j=f[c+48>>2]|0;k=f[a+8>>2]|0;l=(f[k+48>>2]|0)>>>2;m=e+8|0;f[e>>2]=m;n=e+4|0;f[n>>2]=i;if(i>>>0>264){o=bYc(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=o;p=o}else p=m;if((g|0)<(h|0)?(o=i+-1|0,q=a+12|0,r=a+16|0,a=0-j|0,(i|0)>0):0){j=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[k+16>>2]|0;k=g;do{g=o;t=j+(Y(f[s>>2]|0,o)|0)+k|0;v=o;while(1){v=b[t>>0]|0?v+1|0:0;f[p+(g<<2)>>2]=v;if((g|0)<=0)break;else{g=g+-1|0;t=t+a|0}}t=f[q>>2]|0;g=f[r>>2]|0;v=c+(k<<2)|0;w=0;x=o;while(1){y=p+(w<<2)|0;x=x+1-(f[t+(x-(f[y>>2]|0)<<2)>>2]|0)|0;f[y>>2]=x;f[v>>2]=f[g+(x<<2)>>2];w=w+1|0;if((w|0)==(i|0))break;else v=v+(l<<2)|0}k=k+1|0}while((k|0)!=(h|0))}if((p|0)==(m|0)){u=d;return}dYc(p);f[e>>2]=m;f[n>>2]=264;u=d;return}function xEa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;i=u;u=u+400|0;j=i+136|0;k=i+120|0;l=i+64|0;m=i+56|0;n=i;if(!((d|0)==1&(g|0)==0)){sEa(a,c,fT()|0,d,e,1);u=i;return}do if((eS(a)|0)==65536){e=f[a+4>>2]|0;f[l>>2]=f[e>>2];d=l+4|0;g=e+4|0;f[d>>2]=f[g>>2];o=l+8|0;f[o>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];f[l+16>>2]=f[e+16>>2];f[l+20>>2]=f[e+20>>2];f[l+24>>2]=f[e+24>>2];f[l+28>>2]=f[e+28>>2];f[l+32>>2]=f[e+32>>2];p=f[e+36>>2]|0;f[l+36>>2]=p;f[l+40>>2]=o;o=l+48|0;q=l+44|0;f[q>>2]=o;f[o>>2]=0;f[l+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[g>>2]|0)<3){g=f[e+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];r=l;break}else{f[d>>2]=0;U$(l,e);r=l;break}}else{bS(l,a,-1);r=l}while(0);if(f[r>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;a=$Xc(32)|0;f[j>>2]=a;f[j+8>>2]=-2147483616;f[j+4>>2]=21;s=a;t=369201;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[a+21>>0]=0;vM(-215,j,369672,369241,692)}a=l+40|0;e=f[a>>2]|0;d=f[e>>2]|0;f[m>>2]=f[e+4>>2];f[m+4>>2]=d;wS(c,m,0,-1,0,0);do if((eS(c)|0)==65536){m=f[c+4>>2]|0;f[n>>2]=f[m>>2];d=n+4|0;e=m+4|0;f[d>>2]=f[e>>2];g=n+8|0;f[g>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];o=n+16|0;f[o>>2]=f[m+16>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[n+36>>2]=q;f[n+40>>2]=g;g=n+48|0;p=n+44|0;f[p>>2]=g;f[g>>2]=0;f[n+52>>2]=0;if(q|0){w=q+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[e>>2]|0)<3){e=f[m+44>>2]|0;w=f[p>>2]|0;f[w>>2]=f[e>>2];f[w+4>>2]=f[e+4>>2];x=o;y=g;break}else{f[d>>2]=0;U$(n,m);x=o;y=g;break}}else{bS(n,c,-1);x=n+16|0;y=n+48|0}while(0);c=f[l+12>>2]|0;g=f[l+8>>2]|0;o=l+16|0;m=f[o>>2]|0;d=f[x>>2]|0;e=l+48|0;w=f[e>>2]|0;p=f[y>>2]|0;if(f[r>>2]&4095|0){z=$Xc(48)|0;f[k>>2]=z;A=k+8|0;f[A>>2]=-2147483600;B=k+4|0;f[B>>2]=46;s=z;t=369696;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));C=z+46|0;b[C>>0]=0;vM(-215,k,369743,369241,621)}if(f[n>>2]&4095|0){z=$Xc(48)|0;f[k>>2]=z;A=k+8|0;f[A>>2]=-2147483600;B=k+4|0;f[B>>2]=46;s=z;t=369696;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));C=z+46|0;b[C>>0]=0;vM(-215,k,369743,369241,621)}C=f[a>>2]|0;z=n+40|0;B=f[z>>2]|0;if((f[C>>2]|0)==(f[B>>2]|0)?(f[C+4>>2]|0)==(f[B+4>>2]|0):0)D=0;else{B=$Xc(32)|0;f[k>>2]=B;f[k+8>>2]=-2147483616;f[k+4>>2]=24;s=B;t=369423;v=s+24|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[B+24>>0]=0;vM(-215,k,369743,369241,622)}do{k=D;D=D+1|0;b[j+k>>0]=D>>>0<256?D:(k>>>31)+255|0}while((D|0)!=256);D=((b[m>>0]|0)!=0)<<31>>31;b[d>>0]=D;k=(c|0)>1;if(k){B=1;t=D;do{if(!(b[m+B>>0]|0))E=0;else E=h[j+(t&255)>>0]|0;t=E&255;b[d+B>>0]=t;B=B+1|0}while((B|0)!=(c|0))}do if((g|0)>1){B=0-p|0;t=Y(p,g+-1|0)|0;if(k){F=1;G=d;H=m}else{E=1;D=d;s=m;do{s=s+w|0;D=D+p|0;if(!(b[s>>0]|0))I=0;else I=h[j+(h[D+B>>0]|0)>>0]|0;b[D>>0]=I;E=E+1|0}while((E|0)!=(g|0));J=d+t|0;break}do{H=H+w|0;G=G+p|0;if(!(b[H>>0]|0))K=0;else K=h[j+(h[G+B>>0]|0)>>0]|0;b[G>>0]=K;E=K;D=1;while(1){if(!(b[H+D>>0]|0))L=0;else{s=h[G+(D-p)>>0]|0;L=h[j+((E|0)>(s|0)?s:E)>>0]|0}b[G+D>>0]=L;D=D+1|0;if((D|0)==(c|0))break;else E=L}F=F+1|0}while((F|0)!=(g|0));J=d+t|0}else J=d;while(0);d=c+-1|0;F=c+-2|0;c=(F|0)>-1;if(c){L=h[J+d>>0]|0;G=F;while(1){H=h[j+L>>0]|0;K=J+G|0;w=H-(h[K>>0]|0)+256|0;if(w>>>0<769)M=h[274204+w>>0]|0;else M=0;L=H-M|0;b[K>>0]=L;if((G|0)<=0)break;else G=G+-1|0}}G=g+-2|0;a:do if((G|0)>-1){g=0-p|0;L=p+d|0;if(c){N=G;O=J}else{M=G;K=J;while(1){K=K+g|0;H=b[j+(h[K+L>>0]|0)>>0]|0;w=K+d|0;I=b[w>>0]|0;b[w>>0]=(H&255)>(I&255)?I:H;if((M|0)<=0)break a;else M=M+-1|0}}while(1){O=O+g|0;M=b[j+(h[O+L>>0]|0)>>0]|0;K=O+d|0;t=b[K>>0]|0;H=(M&255)>(t&255)?t:M;b[K>>0]=H;K=H&255;H=F;while(1){M=h[O+(H+p)>>0]|0;t=b[j+(K>>>0>M>>>0?M:K)>>0]|0;M=O+H|0;I=b[M>>0]|0;w=(t&255)>(I&255)?I:t;b[M>>0]=w;if((H|0)>0){K=w&255;H=H+-1|0}else break}if((N|0)<=0)break;else N=N+-1|0}}while(0);N=n+36|0;O=f[N>>2]|0;if(O|0?(j=O+12|0,O=f[j>>2]|0,f[j>>2]=O+-1,(O|0)==1):0)V$(n);f[N>>2]=0;N=n+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[N>>2]|0)>0){x=f[z>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[N>>2]|0))}N=f[n+44>>2]|0;if((N|0)!=(y|0))wL(N);N=l+36|0;y=f[N>>2]|0;if(y|0?(n=y+12|0,y=f[n>>2]|0,f[n>>2]=y+-1,(y|0)==1):0)V$(l);f[N>>2]=0;N=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[N>>2]|0)>0){o=f[a>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[N>>2]|0))}N=f[l+44>>2]|0;if((N|0)!=(e|0))wL(N);u=i;return}function yEa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=u;u=u+80|0;n=m+64|0;o=m+32|0;p=m;q=k?2:0;switch(i|0){case 0:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;i=p+12|0;r=l?79024:79044;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];if(!k){r=p+20|0;s=f[i>>2]|0;f[i>>2]=f[r>>2];f[r>>2]=s}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=79072;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;h3(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}case 2:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;s=p+12|0;r=l?79084:79104;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];if(!k){r=p+20|0;i=f[s>>2]|0;f[s>>2]=f[r>>2];f[r>>2]=i}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=79132;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;h3(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}default:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;q=p+12|0;j=l?79144:79164;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];f[q+12>>2]=f[j+12>>2];f[q+16>>2]=f[j+16>>2];if(!k){k=p+20|0;j=f[q>>2]|0;f[q>>2]=f[k>>2];f[k>>2]=j}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=79192;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;h3(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}}}function zEa(a){a=a|0;cYc(a);return}function AEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;d=f[c>>2]|0;e=f[c+4>>2]|0;if((d|0)>=(e|0))return;c=f[a+8>>2]|0;g=f[a+16>>2]|0;h=a+24|0;i=f[a+20>>2]|0;j=i*3|0;if((i|0)<=0){i=d;do i=i+1|0;while((i|0)<(e|0));return}i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;k=i;i=(f[a+4>>2]|0)+(Y(c,d)|0)|0;a=d;while(1){d=f[h>>2]|0;l=f[d>>2]|0;m=f[d+4>>2]|0;o=(b[d+8>>0]^1)&255;p=+n[d+12>>2];q=+n[d+16>>2];r=+n[d+20>>2];s=+n[d+24>>2];t=+n[d+28>>2];d=m^2;u=o+1|0;v=2-o|0;o=0;w=i;while(1){x=p*+n[w>>2]+q*+n[w+4>>2]+r*+n[w+8>>2];y=s*(+n[w+(d<<2)>>2]-x)+.5;z=t*(+n[w+(m<<2)>>2]-x)+.5;n[k+(o<<2)>>2]=x;n[k+(u+o<<2)>>2]=y;n[k+(v+o<<2)>>2]=z;o=o+3|0;if((o|0)>=(j|0))break;else w=w+(l<<2)|0}a=a+1|0;if((a|0)>=(e|0))break;else{k=k+g|0;i=i+c|0}}return}function BEa(a){a=a|0;cYc(a);return}function CEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){DEa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function DEa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;p=f[a+28>>2]|0;a=g*3|0;if((g|0)<=0)return;g=i^2;q=k+1|0;r=2-k|0;k=0;s=c;while(1){c=Y(j[s>>1]|0,l)|0;t=Y(j[s+2>>1]|0,m)|0;u=c+8192+t+(Y(j[s+4>>1]|0,n)|0)>>14;t=(Y((j[s+(g<<1)>>1]|0)-u|0,o)|0)+536879104>>14;c=(Y((j[s+(i<<1)>>1]|0)-u|0,p)|0)+536879104>>14;d[e+(k<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+(q+k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[e+(r+k<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;k=k+3|0;if((k|0)>=(a|0))break;else s=s+(h<<1)|0}return}function EEa(a){a=a|0;cYc(a);return}function FEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){GEa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function GEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;a=e*3|0;if((e|0)<=0)return;e=i^2;p=j+1|0;q=2-j|0;j=0;r=c;while(1){c=Y(h[r>>0]|0,k)|0;s=Y(h[r+1>>0]|0,l)|0;t=c+8192+s+(Y(h[r+2>>0]|0,m)|0)>>14;s=(Y((h[r+e>>0]|0)-t|0,n)|0)+2105344>>14;c=(Y((h[r+i>>0]|0)-t|0,o)|0)+2105344>>14;b[d+j>>0]=t>>>0<256?t:(t|0)>0?255:0;b[d+(p+j)>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(q+j)>>0]=c>>>0<256?c:(c|0)>0?255:0;j=j+3|0;if((j|0)>=(a|0))break;else r=r+g|0}return}function HEa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0;m=u;u=u+64|0;n=m+56|0;o=m+28|0;p=m;q=k?2:0;switch(i|0){case 0:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;i=p+12|0;k=l?79204:79220;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];f[i+8>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=79244;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;h3(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}case 2:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;k=p+12|0;i=l?79256:79272;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=79296;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;h3(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}default:{f[p>>2]=j;f[p+4>>2]=q;b[p+8>>0]=l&1;q=p+12|0;j=l?79308:79324;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];f[q+12>>2]=f[j+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=79348;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=p;h3(n,o,+(Y(h,g)|0)*.0000152587890625);u=m;return}}}function IEa(a){a=a|0;cYc(a);return}function JEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){KEa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function KEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(b[a+8>>0]^1)&255;j=+n[a+12>>2];k=+n[a+16>>2];l=+n[a+20>>2];m=+n[a+24>>2];a=e*3|0;if((e|0)<=0)return;e=i+1|0;o=2-i|0;i=h^2;if((g|0)==4){p=0;q=d;while(1){r=+n[c+(p<<2)>>2];s=+n[c+(o+p<<2)>>2]+-.5;t=+n[c+(e+p<<2)>>2]+-.5;n[q+(h<<2)>>2]=r+m*s;n[q+4>>2]=k*t+(r+l*s);n[q+(i<<2)>>2]=r+j*t;n[q+12>>2]=1.0;p=p+3|0;if((p|0)>=(a|0))break;else q=q+16|0}return}else{q=0;p=d;while(1){t=+n[c+(q<<2)>>2];r=+n[c+(o+q<<2)>>2]+-.5;s=+n[c+(e+q<<2)>>2]+-.5;n[p+(h<<2)>>2]=t+m*r;n[p+4>>2]=k*s+(t+l*r);n[p+(i<<2)>>2]=t+j*s;q=q+3|0;if((q|0)>=(a|0))break;else p=p+(g<<2)|0}return}}function LEa(a){a=a|0;cYc(a);return}function MEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){NEa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function NEa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;a=g*3|0;if((g|0)<=0)return;g=k+1|0;p=2-k|0;k=i^2;if((h|0)==4){q=0;r=e;while(1){s=j[c+(q<<1)>>1]|0;t=(j[c+(p+q<<1)>>1]|0)+-32768|0;u=((Y(t,o)|0)+8192>>14)+s|0;v=(j[c+(g+q<<1)>>1]|0)+-32768|0;w=((Y(v,m)|0)+8192+(Y(t,n)|0)>>14)+s|0;t=((Y(v,l)|0)+8192>>14)+s|0;d[r+(i<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[r+2>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[r+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[r+6>>1]=-1;q=q+3|0;if((q|0)>=(a|0))break;else r=r+8|0}return}else{r=0;q=e;while(1){e=j[c+(r<<1)>>1]|0;t=(j[c+(p+r<<1)>>1]|0)+-32768|0;w=((Y(t,o)|0)+8192>>14)+e|0;u=(j[c+(g+r<<1)>>1]|0)+-32768|0;s=((Y(u,m)|0)+8192+(Y(t,n)|0)>>14)+e|0;t=((Y(u,l)|0)+8192>>14)+e|0;d[q+(i<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[q+2>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[q+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else q=q+(h<<1)|0}return}}function OEa(a){a=a|0;cYc(a);return}function PEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){QEa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function QEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;a=e*3|0;if((e|0)<=0)return;e=j+1|0;o=2-j|0;j=i^2;if((g|0)==4){p=0;q=d;while(1){r=h[c+p>>0]|0;s=(h[c+(o+p)>>0]|0)+-128|0;t=((Y(s,n)|0)+8192>>14)+r|0;u=(h[c+(e+p)>>0]|0)+-128|0;v=((Y(u,l)|0)+8192+(Y(s,m)|0)>>14)+r|0;s=((Y(u,k)|0)+8192>>14)+r|0;b[q+i>>0]=t>>>0<256?t:(t|0)>0?255:0;b[q+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[q+j>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;p=p+3|0;if((p|0)>=(a|0))break;else q=q+4|0}return}else{q=0;p=d;while(1){d=h[c+q>>0]|0;s=(h[c+(o+q)>>0]|0)+-128|0;v=((Y(s,n)|0)+8192>>14)+d|0;t=(h[c+(e+q)>>0]|0)+-128|0;r=((Y(t,l)|0)+8192+(Y(s,m)|0)>>14)+d|0;s=((Y(t,k)|0)+8192>>14)+d|0;b[p+i>>0]=v>>>0<256?v:(v|0)>0?255:0;b[p+1>>0]=r>>>0<256?r:(r|0)>0?255:0;b[p+j>>0]=s>>>0<256?s:(s|0)>0?255:0;q=q+3|0;if((q|0)>=(a|0))break;else p=p+g|0}return}}function REa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+48|0;n=m+8|0;o=m;switch((k?20:0)+(j*100|0)+l|0){case 300:{f[n>>2]=79368;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;SEa(n,o)}u=m;return}case 301:{f[n>>2]=79388;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;TEa(n,o)}u=m;return}case 320:{f[n>>2]=79408;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;UEa(n,o)}u=m;return}case 321:{f[n>>2]=79428;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;VEa(n,o)}u=m;return}case 400:{f[n>>2]=79448;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;WEa(n,o)}u=m;return}case 401:{f[n>>2]=79468;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;XEa(n,o)}u=m;return}case 420:{f[n>>2]=79488;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;YEa(n,o)}u=m;return}case 421:{f[n>>2]=79508;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;ZEa(n,o)}u=m;return}default:{m=$Xc(48)|0;f[n>>2]=m;f[n+8>>2]=-2147483600;f[n+4>>2]=41;o=m;i=370061;h=o+41|0;do{b[o>>0]=b[i>>0]|0;o=o+1|0;i=i+1|0}while((o|0)<(h|0));b[m+41>>0]=0;vM(-206,n,370103,370123,2404)}}}function SEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function TEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+3>>0]=s>>>0<256?s:(s|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function UEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function VEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function WEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+3>>0]=-1;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+7>>0]=-1;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function XEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+6>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+7>>0]=-1;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+6>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function YEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+3>>0]=-1;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+7>>0]=-1;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function ZEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+6>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+7>>0]=-1;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+6>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function _Ea(a){a=a|0;cYc(a);return}function $Ea(a){a=a|0;cYc(a);return}function aFa(a){a=a|0;cYc(a);return}function bFa(a){a=a|0;cYc(a);return}function cFa(a){a=a|0;cYc(a);return}function dFa(a){a=a|0;cYc(a);return}function eFa(a){a=a|0;cYc(a);return}function fFa(a){a=a|0;cYc(a);return}function gFa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=u;u=u+48|0;m=l+8|0;n=l;o=a+(Y(h,c)|0)|0;p=(h|0)%4|0;q=a+(Y(((h|0)/4|0)+h|0,c)|0)+(Y((p|0)/2|0,(g|0)/2|0)|0)|0;r=(p|0)==2;p=(k|0)==1;k=p?q:o;s=p?o:q;q=r&p&1;o=r&(p^1)&1;switch(((i*10|0)+-30+(j?2:0)|0)>>>1&2147483647|0){case 0:{f[m>>2]=79528;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;h3(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;hFa(m,n)}u=l;return}case 1:{f[m>>2]=79548;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;h3(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;iFa(m,n)}u=l;return}case 5:{f[m>>2]=79568;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;h3(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;jFa(m,n)}u=l;return}case 6:{f[m>>2]=79588;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=s;f[m+28>>2]=c;f[m+32>>2]=q;f[m+36>>2]=o;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;h3(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;kFa(m,n)}u=l;return}default:{l=$Xc(48)|0;f[m>>2]=l;f[m+8>>2]=-2147483600;f[m+4>>2]=41;n=l;h=370061;g=n+41|0;do{b[n>>0]=b[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(g|0));b[l+41>>0]=0;vM(-206,m,370525,370123,2431)}}}function hFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+3>>0]=q>>>0<256?q:(q|0)>0?255:0;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+6|0;o=o+6|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function iFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+6|0;o=o+6|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function jFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+7>>0]=-1;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+8|0;o=o+8|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function kFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+7>>0]=-1;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+8|0;o=o+8|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function lFa(a){a=a|0;cYc(a);return}function mFa(a){a=a|0;cYc(a);return}function nFa(a){a=a|0;cYc(a);return}function oFa(a){a=a|0;cYc(a);return}function pFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=f[a+24>>2]|0;e=f[a+32>>2]|0;g=f[c>>2]|0;i=c+4|0;c=f[i>>2]|0;if((g|0)>=(c|0))return;j=a+4|0;k=a+8|0;l=a+36|0;m=a+12|0;n=a+20|0;o=a+38|0;p=a+16|0;q=(d|0)/2|0;r=(f[a+28>>2]|0)/2|0;s=a+37|0;a=Y(e,d)|0;d=(a|0)>0;t=e<<1;u=g;g=c;while(1){c=f[j>>2]|0;v=f[k>>2]|0;w=u<<1;x=c+(Y(v,w)|0)|0;y=x;z=x+1|0;A=x+2|0;x=c+(Y(v,w|1)|0)|0;v=x;c=x+1|0;B=x+2|0;x=(b[l>>0]|0)==0;C=f[n>>2]|0;D=(f[m>>2]|0)+(Y(C,w)|0)|0;w=f[p>>2]|0;if(!(b[o>>0]|0)){E=u+r|0;F=w+(Y(C,(u|0)/2|0)|0)+(Y((u|0)%2|0,q)|0)|0;G=w+(Y(C,(E|0)/2|0)|0)+(Y((E|0)%2|0,q)|0)|0}else{E=w+(Y(C,u)|0)|0;F=E;G=E+1|0}E=F;C=G;w=(b[s>>0]|0)==0;if(d){H=x?A:y;I=x?y:A;A=x?B:v;y=x?v:B;B=w?E:C;v=w?C:E;E=0;C=0;while(1){w=h[H+E>>0]|0;x=h[z+E>>0]|0;J=h[I+E>>0]|0;K=E+e|0;L=(w*269484|0)+17301504+(x*528482|0)+(J*102760|0)|0;M=((h[H+K>>0]|0)*269484|0)+17301504+((h[z+K>>0]|0)*528482|0)+((h[I+K>>0]|0)*102760|0)|0;N=((h[A+E>>0]|0)*269484|0)+17301504+((h[c+E>>0]|0)*528482|0)+((h[y+E>>0]|0)*102760|0)|0;O=((h[A+K>>0]|0)*269484|0)+17301504+((h[c+K>>0]|0)*528482|0)+((h[y+K>>0]|0)*102760|0)|0;K=L>>>20;P=C<<1;b[D+P>>0]=L>>>0<268435456?K:K|0?255:0;K=M>>>20;L=P|1;b[D+L>>0]=M>>>0<268435456?K:K|0?255:0;K=N>>>20;b[D+((f[n>>2]|0)+P)>>0]=N>>>0<268435456?K:K|0?255:0;K=O>>>20;b[D+(L+(f[n>>2]|0))>>0]=O>>>0<268435456?K:K|0?255:0;K=(Y(w,-155188)|0)+134742016+(Y(x,-305135)|0)+(J*460324|0)|0;O=(w*460324|0)+134742016+(Y(x,-385875)|0)+(Y(J,-74448)|0)|0;J=K>>20;K=O>>20;O=(b[o>>0]|0)==0?C:P;b[B+O>>0]=J>>>0<256?J:(J|0)>0?255:0;b[v+O>>0]=K>>>0<256?K:(K|0)>0?255:0;E=E+t|0;if((E|0)>=(a|0))break;else C=C+1|0}Q=f[i>>2]|0}else Q=g;u=u+1|0;if((u|0)>=(Q|0))break;else g=Q}return}function qFa(a){a=a|0;cYc(a);return}function rFa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=u;u=u+32|0;n=m+8|0;o=m;do switch((j?200:0)+(i*1e3|0)+(k*10|0)+l|0){case 3e3:{f[n>>2]=79628;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;sFa(n,o)}u=m;return}case 3001:{f[n>>2]=79648;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;tFa(n,o)}u=m;return}case 3010:{f[n>>2]=79668;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;uFa(n,o)}u=m;return}case 3200:{f[n>>2]=79688;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;vFa(n,o)}u=m;return}case 3201:{f[n>>2]=79708;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;wFa(n,o)}u=m;return}case 3210:{f[n>>2]=79728;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;xFa(n,o)}u=m;return}case 4e3:{f[n>>2]=79748;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;yFa(n,o)}u=m;return}case 4001:{f[n>>2]=79768;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;zFa(n,o)}u=m;return}case 4010:{f[n>>2]=79788;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;AFa(n,o)}u=m;return}case 4200:{f[n>>2]=79808;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;BFa(n,o)}u=m;return}case 4201:{f[n>>2]=79828;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;CFa(n,o)}u=m;return}case 4210:{f[n>>2]=79848;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;h3(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;DFa(n,o)}u=m;return}default:{p=$Xc(48)|0;f[n>>2]=p;f[n+8>>2]=-2147483600;f[n+4>>2]=41;q=p;r=370061;s=q+41|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[p+41>>0]=0;vM(-206,n,370721,370123,2481)}}while(0)}function sFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function tFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function uFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function vFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function wFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function xFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function yFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function zFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function AFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function BFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function CFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function DFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function EFa(a){a=a|0;cYc(a);return}function FFa(a){a=a|0;cYc(a);return}function GFa(a){a=a|0;cYc(a);return}function HFa(a){a=a|0;cYc(a);return}function IFa(a){a=a|0;cYc(a);return}function JFa(a){a=a|0;cYc(a);return}function KFa(a){a=a|0;cYc(a);return}function LFa(a){a=a|0;cYc(a);return}function MFa(a){a=a|0;cYc(a);return}function NFa(a){a=a|0;cYc(a);return}function OFa(a){a=a|0;cYc(a);return}function PFa(a){a=a|0;cYc(a);return}function QFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;rDa(g,a,b,3);yEa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d);sDa(g);u=e;return}function RFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;uDa(h,a,b,i);HEa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,e);vDa(h);u=g;return}function SFa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+128|0;i=h;Lxa(i,a,b,c);rFa(f[i+16>>2]|0,f[i+48>>2]|0,f[i+72>>2]|0,f[i+104>>2]|0,f[i+12>>2]|0,f[i+8>>2]|0,c,d,e,g);Mxa(i);u=h;return}function TFa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;if((rS(a,-1)|0)==2?(qS(a,-1)|0)==0:0){l1(a,c,d);u=e;return}e=$Xc(48)|0;f[g>>2]=e;f[g+8>>2]=-2147483600;f[g+4>>2]=45;d=e;c=371269;a=d+45|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(a|0));b[e+45>>0]=0;vM(-215,g,371315,370123,2641)}function UFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+176|0;h=g+168|0;i=g+128|0;j=g;VFa(j,a,c,1);c=f[j+16>>2]|0;a=f[j+48>>2]|0;k=f[j+72>>2]|0;l=f[j+104>>2]|0;m=f[j+12>>2]|0;n=f[j+8>>2]|0;o=f[j+116>>2]|0;p=k+(Y(n,l)|0)|0;f[i>>2]=79608;f[i+4>>2]=c;f[i+8>>2]=a;f[i+12>>2]=k;f[i+16>>2]=p;f[i+20>>2]=l;f[i+24>>2]=m;f[i+28>>2]=n;f[i+32>>2]=o;b[i+36>>0]=d&1;b[i+37>>0]=(e|0)==2&1;b[i+38>>0]=0;if((Y(n,m)|0)>76799){f[h>>2]=0;f[h+4>>2]=(n|0)/2|0;h3(h,i,-1.0);WFa(j);u=g;return}else{f[h>>2]=0;f[h+4>>2]=(n|0)/2|0;pFa(i,h);WFa(j);u=g;return}}function VFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;z=x>>>3;A=(z&511)+1|0;f[a+116>>2]=A;B=x&7;x=a+112|0;f[x>>2]=B;if((z&510|0)!=2)sV(A,79860);if((e|0)!=1)sV(e,79888);if(B|0)pV(B,79916);B=c+4|0;e=d+4|0;if((f[B>>2]|0)!=(f[e>>2]|0)){do if((eS(c)|0)==65536){A=f[B>>2]|0;f[h>>2]=f[A>>2];z=h+4|0;C=A+4|0;f[z>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[A+8>>2];f[h+12>>2]=f[A+12>>2];f[h+16>>2]=f[A+16>>2];f[h+20>>2]=f[A+20>>2];f[h+24>>2]=f[A+24>>2];f[h+28>>2]=f[A+28>>2];f[h+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[z>>2]=0;U$(h,A);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){B=h+36|0;A=f[B>>2]|0;if((A|0)!=0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0){V$(h);G=B}else G=B}else{B=a+36|0;A=f[B>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)V$(a);f[B>>2]=0;A=a+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];C=h+4|0;z=f[C>>2]|0;f[j>>2]=z;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[A>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];A=h+36|0;f[B>>2]=f[A>>2];B=a+44|0;D=f[B>>2]|0;if((D|0)==(o|0))H=z;else{wL(D);f[B>>2]=o;f[l>>2]=k;H=f[C>>2]|0}k=h+44|0;if((H|0)<3){H=f[k>>2]|0;f[o>>2]=f[H>>2];f[a+52>>2]=f[H+4>>2]}else{f[B>>2]=f[k>>2];B=h+40|0;f[a+40>>2]=f[B>>2];f[k>>2]=h+48;f[B>>2]=j}f[h>>2]=1124007936;m=C;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));G=A}f[G>>2]=0;G=h+16|0;A=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){G=f[h+40>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[h+44>>2]|0;if((A|0)!=(h+48|0))wL(A)}else{A=h+8|0;f[A>>2]=0;f[A+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;A=f[c>>2]|0;if((A|l)&1|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=$Xc(48)|0;f[h>>2]=c;f[h+8>>2]=-2147483600;f[h+4>>2]=39;m=c;y=371429;n=m+39|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[c+39>>0]=0;vM(-215,h,371349,371359,271)}c=((A|0)/2|0)*3|0;f[v>>2]=l;f[w>>2]=c;f[i>>2]=l;f[i+4>>2]=c;wS(d,i,f[x>>2]&7,-1,0,0);do if((eS(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;c=x+4|0;f[i>>2]=f[c>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[c>>2]|0)<3){c=f[x+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];break}else{f[i>>2]=0;U$(h,x);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;e=f[d>>2]|0;if((e|0)!=0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0){V$(h);I=d}else I=d}else{d=a+92|0;e=f[d>>2]|0;if(e|0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0)V$(p);f[d>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){x=f[s>>2]|0;i=0;do{f[x+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];e=h+36|0;f[d>>2]=f[e>>2];d=a+100|0;x=f[d>>2]|0;if((x|0)==(t|0))J=i;else{wL(x);f[d>>2]=t;f[s>>2]=r;J=f[p>>2]|0}r=h+44|0;if((J|0)<3){J=f[r>>2]|0;f[t>>2]=f[J>>2];f[a+108>>2]=f[J+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));I=e}f[I>>2]=0;I=h+16|0;e=h+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[e>>2]|0)>0){I=f[h+40>>2]|0;m=0;do{f[I+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function WFa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function XFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+208|0;d=c+8|0;e=c;g=c+80|0;h=c+24|0;YFa(g,a,b,1);b=f[g+124>>2]|0;f[d>>2]=-2147483648;f[d+4>>2]=2147483647;f[e>>2]=0;f[e+4>>2]=b;W$(h,g,e,d);e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=g+56;jR(h,d);d=h+36|0;e=f[d>>2]|0;if(e|0?(b=e+12|0,e=f[b>>2]|0,f[b>>2]=e+-1,(e|0)==1):0)V$(h);f[d>>2]=0;d=h+16|0;e=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[h+40>>2]|0;b=0;do{f[d+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){ZFa(g);u=c;return}wL(e);ZFa(g);u=c;return}function YFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;z=x>>>3&511;A=z+1|0;f[a+116>>2]=A;B=x&7;x=a+112|0;f[x>>2]=B;if(z|0)sV(A,79944);if((e|0)!=1)sV(e,79972);if(B|0)pV(B,8e4);B=c+4|0;e=d+4|0;if((f[B>>2]|0)!=(f[e>>2]|0)){do if((eS(c)|0)==65536){A=f[B>>2]|0;f[h>>2]=f[A>>2];z=h+4|0;C=A+4|0;f[z>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[A+8>>2];f[h+12>>2]=f[A+12>>2];f[h+16>>2]=f[A+16>>2];f[h+20>>2]=f[A+20>>2];f[h+24>>2]=f[A+24>>2];f[h+28>>2]=f[A+28>>2];f[h+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[z>>2]=0;U$(h,A);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){B=h+36|0;A=f[B>>2]|0;if((A|0)!=0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0){V$(h);G=B}else G=B}else{B=a+36|0;A=f[B>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)V$(a);f[B>>2]=0;A=a+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];C=h+4|0;z=f[C>>2]|0;f[j>>2]=z;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[A>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];A=h+36|0;f[B>>2]=f[A>>2];B=a+44|0;D=f[B>>2]|0;if((D|0)==(o|0))H=z;else{wL(D);f[B>>2]=o;f[l>>2]=k;H=f[C>>2]|0}k=h+44|0;if((H|0)<3){H=f[k>>2]|0;f[o>>2]=f[H>>2];f[a+52>>2]=f[H+4>>2]}else{f[B>>2]=f[k>>2];B=h+40|0;f[a+40>>2]=f[B>>2];f[k>>2]=h+48;f[B>>2]=j}f[h>>2]=1124007936;m=C;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));G=A}f[G>>2]=0;G=h+16|0;A=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){G=f[h+40>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[h+44>>2]|0;if((A|0)!=(h+48|0))wL(A)}else{A=h+8|0;f[A>>2]=0;f[A+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;A=f[c>>2]|0;if((A|0)%3|0|l&1|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=$Xc(48)|0;f[h>>2]=c;f[h+8>>2]=-2147483600;f[h+4>>2]=39;m=c;y=371923;n=m+39|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[c+39>>0]=0;vM(-215,h,371349,371359,275)}c=(A<<1|0)/3|0;f[v>>2]=l;f[w>>2]=c;f[i>>2]=l;f[i+4>>2]=c;wS(d,i,f[x>>2]&7,-1,0,0);do if((eS(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;c=x+4|0;f[i>>2]=f[c>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[c>>2]|0)<3){c=f[x+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];break}else{f[i>>2]=0;U$(h,x);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;e=f[d>>2]|0;if((e|0)!=0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0){V$(h);I=d}else I=d}else{d=a+92|0;e=f[d>>2]|0;if(e|0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0)V$(p);f[d>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){x=f[s>>2]|0;i=0;do{f[x+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];e=h+36|0;f[d>>2]=f[e>>2];d=a+100|0;x=f[d>>2]|0;if((x|0)==(t|0))J=i;else{wL(x);f[d>>2]=t;f[s>>2]=r;J=f[p>>2]|0}r=h+44|0;if((J|0)<3){J=f[r>>2]|0;f[t>>2]=f[J>>2];f[a+108>>2]=f[J+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));I=e}f[I>>2]=0;I=h+16|0;e=h+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[e>>2]|0)>0){I=f[h+40>>2]|0;m=0;do{f[I+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function ZFa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function _Fa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;$Fa(h,a,b,i);gFa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+68>>2]|0,f[h+64>>2]|0,i,d,e);aGa(h);u=g;return}function $Fa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;z=x>>>3&511;A=z+1|0;f[a+116>>2]=A;B=x&7;x=a+112|0;f[x>>2]=B;if(z|0)sV(A,80028);if((e+-3|0)>>>0>=2)sV(e,80056);if(B|0)pV(B,80084);B=c+4|0;A=d+4|0;if((f[B>>2]|0)!=(f[A>>2]|0)){do if((eS(c)|0)==65536){z=f[B>>2]|0;f[h>>2]=f[z>>2];C=h+4|0;D=z+4|0;f[C>>2]=f[D>>2];E=h+8|0;f[E>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];F=f[z+36>>2]|0;f[h+36>>2]=F;f[h+40>>2]=E;E=h+48|0;G=h+44|0;f[G>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[z+44>>2]|0;E=f[G>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];break}else{f[C>>2]=0;U$(h,z);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){B=h+36|0;z=f[B>>2]|0;if((z|0)!=0?(C=z+12|0,z=f[C>>2]|0,f[C>>2]=z+-1,(z|0)==1):0){V$(h);H=B}else H=B}else{B=a+36|0;z=f[B>>2]|0;if(z|0?(C=z+12|0,z=f[C>>2]|0,f[C>>2]=z+-1,(z|0)==1):0)V$(a);f[B>>2]=0;z=a+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){C=f[l>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];D=h+4|0;C=f[D>>2]|0;f[j>>2]=C;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[z>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];z=h+36|0;f[B>>2]=f[z>>2];B=a+44|0;E=f[B>>2]|0;if((E|0)==(o|0))I=C;else{wL(E);f[B>>2]=o;f[l>>2]=k;I=f[D>>2]|0}k=h+44|0;if((I|0)<3){I=f[k>>2]|0;f[o>>2]=f[I>>2];f[a+52>>2]=f[I+4>>2]}else{f[B>>2]=f[k>>2];B=h+40|0;f[a+40>>2]=f[B>>2];f[k>>2]=h+48;f[B>>2]=j}f[h>>2]=1124007936;m=D;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=z}f[H>>2]=0;H=h+16|0;z=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[z>>2]|0)>0){H=f[h+40>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[z>>2]|0))}z=f[h+44>>2]|0;if((z|0)!=(h+48|0))wL(z)}else{z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;z=f[c>>2]|0;if((z|0)%3|0|l&1|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=$Xc(48)|0;f[h>>2]=c;f[h+8>>2]=-2147483600;f[h+4>>2]=39;m=c;y=371923;n=m+39|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[c+39>>0]=0;vM(-215,h,371349,371359,275)}c=(z<<1|0)/3|0;f[v>>2]=l;f[w>>2]=c;f[i>>2]=l;f[i+4>>2]=c;wS(d,i,f[x>>2]&7|(e<<3)+-8,-1,0,0);do if((eS(d)|0)==65536){e=f[A>>2]|0;f[h>>2]=f[e>>2];x=h+4|0;i=e+4|0;f[x>>2]=f[i>>2];c=h+8|0;f[c>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=c;c=h+48|0;w=h+44|0;f[w>>2]=c;f[c>>2]=0;f[h+52>>2]=0;if(l|0){c=l+12|0;f[c>>2]=(f[c>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;c=f[w>>2]|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];break}else{f[x>>2]=0;U$(h,e);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;A=f[d>>2]|0;if((A|0)!=0?(e=A+12|0,A=f[e>>2]|0,f[e>>2]=A+-1,(A|0)==1):0){V$(h);J=d}else J=d}else{d=a+92|0;A=f[d>>2]|0;if(A|0?(e=A+12|0,A=f[e>>2]|0,f[e>>2]=A+-1,(A|0)==1):0)V$(p);f[d>>2]=0;A=a+72|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;x=f[p>>2]|0;f[q>>2]=x;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[A>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];A=h+36|0;f[d>>2]=f[A>>2];d=a+100|0;e=f[d>>2]|0;if((e|0)==(t|0))K=x;else{wL(e);f[d>>2]=t;f[s>>2]=r;K=f[p>>2]|0}r=h+44|0;if((K|0)<3){K=f[r>>2]|0;f[t>>2]=f[K>>2];f[a+108>>2]=f[K+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));J=A}f[J>>2]=0;J=h+16|0;A=h+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[A>>2]|0)>0){J=f[h+40>>2]|0;m=0;do{f[J+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[A>>2]|0))}A=f[h+44>>2]|0;if((A|0)==(h+48|0)){u=g;return}wL(A);u=g;return}function aGa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function bGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;$Fa(h,a,b,i);b=f[h+16>>2]|0;a=f[h+48>>2]|0;c=f[h+64>>2]|0;REa(b,b+(Y(c,a)|0)|0,a,f[h+72>>2]|0,f[h+104>>2]|0,f[h+68>>2]|0,c,i,d,e);aGa(h);u=g;return}function cGa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0;o=u;u=u+64|0;p=o+44|0;q=o+16|0;r=o;s=(i|0)==5?360:l?256:180;l=k?2:0;k=(i|0)==0;if(!m)if(k){f[r>>2]=j;f[r+4>>2]=3;f[r+8>>2]=l;n[r+12>>2]=+(s|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=80160;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;h3(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}else{f[r>>2]=j;f[r+4>>2]=l;n[r+8>>2]=+(s|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=80180;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;h3(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}if(!k){f[r>>2]=j;f[r+4>>2]=l;n[r+8>>2]=+(s|0);f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=80140;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;h3(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}f[r>>2]=j;f[r+4>>2]=l;f[r+8>>2]=s;switch(s&511){case 256:case 180:break;default:{s=$Xc(32)|0;f[p>>2]=s;f[p+8>>2]=-2147483616;f[p+4>>2]=30;l=s;j=372489;k=l+30|0;do{b[l>>0]=b[j>>0]|0;l=l+1|0;j=j+1|0}while((l|0)<(k|0));b[s+30>>0]=0;vM(-215,p,372520,372530,21)}}f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=80120;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=r;h3(p,q,+(Y(h,g)|0)*.0000152587890625);u=o;return}function dGa(a){a=a|0;cYc(a);return}function eGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;i=h*3|0;if((h|0)<=0){h=c;do h=h+1|0;while((h|0)<(d|0));return}h=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=h;h=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c+4>>2]|0;l=f[c>>2]|0;m=k^2;o=c+8|0;c=h;p=0;while(1){q=+n[c+(k<<2)>>2];r=+n[c+4>>2];s=+n[c+(m<<2)>>2];t=s<r?r:s;u=t<q?q:t;t=s>r?r:s;v=t>q?q:t;t=u-v;w=u+v;x=w*.5;if(t>1.1920928955078125e-07){y=t/(x<.5?w:2.0-u-v);v=60.0/t;do if(!(u==s))if(u==r){z=(q-s)*v+120.0;break}else{z=(s-r)*v+240.0;break}else z=(r-q)*v;while(0);if(z<0.0){A=y;B=z+360.0}else{A=y;B=z}}else{A=0.0;B=0.0}n[j+(p<<2)>>2]=B*+n[o>>2];n[j+(p+1<<2)>>2]=x;n[j+(p+2<<2)>>2]=A;p=p+3|0;if((p|0)>=(i|0))break;else c=c+(l<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;h=h+b|0}}return}function fGa(a){a=a|0;cYc(a);return}function gGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){hGa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function hGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+8|0;l=a+4|0;m=a+12|0;a=d;d=0;o=c;while(1){c=e-d|0;p=((c|0)<256?c:256)*3|0;q=(c|0)>0;if(q){c=0;r=o;do{n[i+(c<<2)>>2]=+(h[r>>0]|0)*.003921568859368563;n[i+(c+1<<2)>>2]=+(h[r+1>>0]|0)*.003921568859368563;n[i+(c+2<<2)>>2]=+(h[r+2>>0]|0)*.003921568859368563;c=c+3|0;r=r+j|0}while((c|0)<(p|0));c=f[k>>2]|0;s=f[l>>2]|0;if(q){t=c^2;v=i;w=0;while(1){x=+n[v+(c<<2)>>2];y=+n[v+4>>2];z=+n[v+(t<<2)>>2];A=z<y?y:z;B=A<x?x:A;A=z>y?y:z;C=A>x?x:A;A=B-C;D=B+C;E=D*.5;if(A>1.1920928955078125e-07){F=A/(E<.5?D:2.0-B-C);C=60.0/A;do if(!(B==z))if(B==y){G=(x-z)*C+120.0;break}else{G=(z-y)*C+240.0;break}else G=(y-x)*C;while(0);if(G<0.0){H=F;I=G+360.0}else{H=F;I=G}}else{H=0.0;I=0.0}n[i+(w<<2)>>2]=I*+n[m>>2];n[i+(w+1<<2)>>2]=E;n[i+(w+2<<2)>>2]=H;w=w+3|0;if((w|0)>=(p|0))break;else v=v+(s<<2)|0}if(q){s=0;do{v=ALc(+n[i+(s<<2)>>2])|0;b[a+s>>0]=v>>>0<256?v:(v|0)>0?255:0;v=s+1|0;w=ALc(+n[i+(v<<2)>>2]*255.0)|0;b[a+v>>0]=w>>>0<256?w:(w|0)>0?255:0;w=s+2|0;v=ALc(+n[i+(w<<2)>>2]*255.0)|0;b[a+w>>0]=v>>>0<256?v:(v|0)>0?255:0;s=s+3|0}while((s|0)<(p|0));J=r}else J=r}else J=r}else J=o;d=d+256|0;if((d|0)>=(e|0))break;else{a=a+768|0;o=J}}u=g;return}function iGa(a){a=a|0;cYc(a);return}function jGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;i=h*3|0;if((h|0)<=0){h=c;do h=h+1|0;while((h|0)<(d|0));return}h=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=h;h=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c+4>>2]|0;l=f[c>>2]|0;m=+n[c+8>>2]*2.7777778450399637e-03;c=k^2;o=h;p=0;while(1){q=+n[o+(k<<2)>>2];r=+n[o+4>>2];s=+n[o+(c<<2)>>2];t=s<r?r:s;u=t<q?q:t;t=s>r?r:s;v=u-(t>q?q:t);t=v/(+L(+u)+1.1920928955078125e-07);w=60.0/(v+1.1920928955078125e-07);do if(!(u==s))if(u==r){x=(q-s)*w+120.0;break}else{x=(s-r)*w+240.0;break}else x=(r-q)*w;while(0);n[j+(p<<2)>>2]=m*(x<0.0?x+360.0:x);n[j+(p+1<<2)>>2]=t;n[j+(p+2<<2)>>2]=u;p=p+3|0;if((p|0)>=(i|0))break;else o=o+(l<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;h=h+b|0}}return}function kGa(a){a=a|0;cYc(a);return}function lGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){mGa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function mGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=f[a+4>>2]|0;i=f[a>>2]|0;j=f[a+8>>2]|0;a=(j|0)==180?888980:890004;k=e*3|0;if(!(b[1163508]|0)){f[222501]=0;f[222245]=0;f[222757]=0;l=1;do{m=+(l|0);n=zLc(1044480.0/m)|0;f[891028+(l<<2)>>2]=n;o=m*6.0;n=zLc(737280.0/o)|0;f[888980+(l<<2)>>2]=n;n=zLc(1048576.0/o)|0;f[890004+(l<<2)>>2]=n;l=l+1|0}while((l|0)!=256);b[1163508]=1}if((e|0)<=0)return;e=g^2;l=c;c=0;while(1){n=h[l+g>>0]|0;p=h[l+1>>0]|0;q=h[l+e>>0]|0;r=p-n|0;s=r+256|0;if(s>>>0<769)t=h[274204+s>>0]|0;else t=0;s=t+n|0;u=q-s+256|0;if(u>>>0<769)v=h[274204+u>>0]|0;else v=0;u=v+s|0;s=n-p+256|0;if(s>>>0<769)w=h[274204+s>>0]|0;else w=0;s=n-w|0;x=s-q+256|0;if(x>>>0<769)y=h[274204+x>>0]|0;else y=0;x=y-s+u|0;s=(x>>>0<256?x:(x|0)>0?255:0)&255;x=((Y(s,f[891028+(u<<2)>>2]|0)|0)+2048|0)>>>12;z=(Y((u|0)==(q|0)?r:(u|0)==(p|0)?n-q+(s<<1)|0:q-p+(s<<2)|0,f[a+(s<<2)>>2]|0)|0)+2048>>12;s=((z|0)<0?j:0)+z|0;b[d+c>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(c+1)>>0]=x;b[d+(c+2)>>0]=u;c=c+3|0;if((c|0)>=(k|0))break;else l=l+i|0}return}function nGa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0;m=u;u=u+64|0;o=m+48|0;p=m+16|0;q=m;r=(h|0)==5?360:k?255:180;k=j?2:0;j=(h|0)==0;if(l)if(j){f[q>>2]=i;f[q+4>>2]=k;n[q+8>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=80200;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;h3(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}else{f[q>>2]=i;f[q+4>>2]=k;n[q+8>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=80220;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;h3(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}else if(j){f[q>>2]=i;f[q+4>>2]=3;f[q+8>>2]=k;n[q+12>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=80240;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;h3(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}else{f[q>>2]=i;f[q+4>>2]=k;n[q+8>>2]=6.0/+(r|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=80260;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=q;h3(o,p,+(Y(g,e)|0)*.0000152587890625);u=m;return}}function oGa(a){a=a|0;cYc(a);return}function pGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){qGa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function qGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=f[a>>2]|0;j=d*3|0;if((d|0)<=0){u=e;return}d=h^2;k=a+8|0;a=g+4|0;l=g+8|0;m=g+12|0;if((i|0)==4){o=0;p=c;while(1){q=+n[b+(o<<2)>>2];r=+n[b+(o+1<<2)>>2];s=+n[b+(o+2<<2)>>2];if(s==0.0){t=r;v=r;w=r}else{if(!(r<=.5))x=r+s-r*s;else x=r*(s+1.0);s=r*2.0-x;r=q*+n[k>>2];if(!(r<0.0))if(!(r>=6.0))y=r;else{q=r;while(1){z=q+-6.0;if(!(z>=6.0)){y=z;break}else q=z}}else{q=r;while(1){z=q+6.0;if(z<0.0)q=z;else{y=z;break}}}A=~~y;B=A-(+(A|0)>y&1)|0;q=y-+(B|0);n[g>>2]=x;n[a>>2]=s;r=x-s;n[l>>2]=s+r*(1.0-q);n[m>>2]=s+r*q;t=+n[g+(f[80272+(B*12|0)+8>>2]<<2)>>2];v=+n[g+(f[80272+(B*12|0)+4>>2]<<2)>>2];w=+n[g+(f[80272+(B*12|0)>>2]<<2)>>2]}n[p+(h<<2)>>2]=w;n[p+4>>2]=v;n[p+(d<<2)>>2]=t;n[p+12>>2]=1.0;o=o+3|0;if((o|0)>=(j|0))break;else p=p+16|0}u=e;return}else{p=0;o=c;while(1){t=+n[b+(p<<2)>>2];v=+n[b+(p+1<<2)>>2];w=+n[b+(p+2<<2)>>2];if(w==0.0){C=v;D=v;E=v}else{if(!(v<=.5))F=v+w-v*w;else F=v*(w+1.0);w=v*2.0-F;v=t*+n[k>>2];if(!(v<0.0))if(!(v>=6.0))G=v;else{t=v;while(1){x=t+-6.0;if(!(x>=6.0)){G=x;break}else t=x}}else{t=v;while(1){s=t+6.0;if(s<0.0)t=s;else{G=s;break}}}c=~~G;B=c-(+(c|0)>G&1)|0;t=G-+(B|0);n[g>>2]=F;n[a>>2]=w;v=F-w;n[l>>2]=w+v*(1.0-t);n[m>>2]=w+v*t;C=+n[g+(f[80272+(B*12|0)+8>>2]<<2)>>2];D=+n[g+(f[80272+(B*12|0)+4>>2]<<2)>>2];E=+n[g+(f[80272+(B*12|0)>>2]<<2)>>2]}n[o+(h<<2)>>2]=E;n[o+4>>2]=D;n[o+(d<<2)>>2]=C;p=p+3|0;if((p|0)>=(j|0))break;else o=o+(i<<2)|0}u=e;return}}function rGa(a){a=a|0;cYc(a);return}function sGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){tGa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function tGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+4|0;a=(j|0)==4;l=d;d=0;m=c;while(1){c=e-d|0;o=(c|0)<256?c:256;p=o*3|0;q=(c|0)>0;if(q){c=0;do{n[i+(c<<2)>>2]=+(h[m+c>>0]|0);r=c+1|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;r=c+2|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;c=c+3|0}while((c|0)<(p|0));qGa(k,i,i,o);if(q)if(a){c=0;r=l;while(1){s=ALc(+n[i+(c<<2)>>2]*255.0)|0;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=ALc(+n[i+(c+1<<2)>>2]*255.0)|0;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=ALc(+n[i+(c+2<<2)>>2]*255.0)|0;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;c=c+3|0;s=r+4|0;if((c|0)>=(p|0)){t=s;break}else r=s}}else{r=0;c=l;while(1){q=ALc(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=q>>>0<256?q:(q|0)>0?255:0;q=ALc(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=ALc(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=q>>>0<256?q:(q|0)>0?255:0;r=r+3|0;q=c+j|0;if((r|0)>=(p|0)){t=q;break}else c=q}}else t=l}else{qGa(k,i,i,o);t=l}d=d+256|0;if((d|0)>=(e|0))break;else{l=t;m=m+768|0}}u=g;return}function uGa(a){a=a|0;cYc(a);return}function vGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0;c=u;u=u+16|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;if((e|0)>=(g|0)){u=c;return}b=f[a+16>>2]|0;h=(f[a+12>>2]|0)+(Y(b,e)|0)|0;i=f[a+8>>2]|0;j=(f[a+4>>2]|0)+(Y(i,e)|0)|0;k=a+24|0;l=d+4|0;m=d+8|0;o=d+12|0;p=d+4|0;q=d+8|0;r=d+12|0;s=f[a+20>>2]|0;a=s*3|0;t=(s|0)>0;s=h;h=j;j=e;while(1){e=f[k>>2]|0;v=f[e+4>>2]|0;w=f[e>>2]|0;if((w|0)==3){if(t){x=e+8|0;y=v^2;z=0;A=s;while(1){B=h+(z<<2)|0;C=+n[B+4>>2];D=+n[B+8>>2];if(C==0.0){E=D;F=D;G=D}else{H=+n[x>>2]*+n[B>>2];if(!(H<0.0))if(!(H>=6.0))I=H;else{J=H;while(1){K=J+-6.0;if(!(K>=6.0)){I=K;break}else J=K}}else{J=H;while(1){K=J+6.0;if(K<0.0)J=K;else{I=K;break}}}B=~~I;L=B-(+(B|0)>I&1)|0;B=L>>>0>5;J=B?0.0:I-+(L|0);M=B?0:L;n[d>>2]=D;n[l>>2]=D*(1.0-C);n[m>>2]=D*(1.0-C*J);n[o>>2]=D*(1.0-C*(1.0-J));E=+n[d+(f[80344+(M*12|0)+8>>2]<<2)>>2];F=+n[d+(f[80344+(M*12|0)+4>>2]<<2)>>2];G=+n[d+(f[80344+(M*12|0)>>2]<<2)>>2]}n[A+(v<<2)>>2]=G;n[A+4>>2]=F;n[A+(y<<2)>>2]=E;z=z+3|0;if((z|0)>=(a|0))break;else A=A+12|0}}}else if(t){A=e+8|0;z=v^2;y=0;x=s;while(1){M=h+(y<<2)|0;J=+n[M+4>>2];H=+n[M+8>>2];if(J==0.0){N=H;O=H;P=H}else{K=+n[A>>2]*+n[M>>2];if(!(K<0.0))if(!(K>=6.0))Q=K;else{R=K;while(1){S=R+-6.0;if(!(S>=6.0)){Q=S;break}else R=S}}else{R=K;while(1){C=R+6.0;if(C<0.0)R=C;else{Q=C;break}}}M=~~Q;L=M-(+(M|0)>Q&1)|0;M=L>>>0>5;R=M?0.0:Q-+(L|0);B=M?0:L;n[d>>2]=H;n[p>>2]=H*(1.0-J);n[q>>2]=H*(1.0-J*R);n[r>>2]=H*(1.0-J*(1.0-R));N=+n[d+(f[80344+(B*12|0)+8>>2]<<2)>>2];O=+n[d+(f[80344+(B*12|0)+4>>2]<<2)>>2];P=+n[d+(f[80344+(B*12|0)>>2]<<2)>>2]}n[x+(v<<2)>>2]=P;n[x+4>>2]=O;n[x+(z<<2)>>2]=N;n[x+12>>2]=1.0;y=y+3|0;if((y|0)>=(a|0))break;else x=x+(w<<2)|0}}j=j+1|0;if((j|0)>=(g|0))break;else{s=s+b|0;h=h+i|0}}u=c;return}function wGa(a){a=a|0;cYc(a);return}function xGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){yGa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function yGa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0;g=u;u=u+48|0;i=g+24|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}e=j+4|0;m=j+8|0;o=j+12|0;p=a+4|0;q=j+16|0;r=j+20|0;s=(k|0)==4;t=a+8|0;a=i+4|0;v=i+8|0;w=i+12|0;x=0;y=d;while(1){z=+(h[c+x>>0]|0);n[j>>2]=z;A=+(h[c+(x+1)>>0]|0)*.003921568859368563;n[e>>2]=A;B=+(h[c+(x+2)>>0]|0)*.003921568859368563;n[m>>2]=B;d=f[p>>2]|0;if(A==0.0){C=B;D=B;E=B}else{F=+n[t>>2]*z;if(!(F<0.0))if(!(F>=6.0))G=F;else{z=F;while(1){H=z+-6.0;if(!(H>=6.0)){G=H;break}else z=H}}else{z=F;while(1){H=z+6.0;if(H<0.0)z=H;else{G=H;break}}}I=~~G;J=I-(+(I|0)>G&1)|0;I=J>>>0>5;z=I?0.0:G-+(J|0);K=I?0:J;n[i>>2]=B;n[a>>2]=B*(1.0-A);n[v>>2]=B*(1.0-A*z);n[w>>2]=B*(1.0-A*(1.0-z));C=+n[i+(f[80344+(K*12|0)+8>>2]<<2)>>2];D=+n[i+(f[80344+(K*12|0)+4>>2]<<2)>>2];E=+n[i+(f[80344+(K*12|0)>>2]<<2)>>2]}n[o+(d<<2)>>2]=E;n[q>>2]=D;n[o+((d^2)<<2)>>2]=C;K=ALc(+n[o>>2]*255.0)|0;b[y>>0]=K>>>0<256?K:(K|0)>0?255:0;K=ALc(+n[q>>2]*255.0)|0;b[y+1>>0]=K>>>0<256?K:(K|0)>0?255:0;K=ALc(+n[r>>2]*255.0)|0;b[y+2>>0]=K>>>0<256?K:(K|0)>0?255:0;if(s)b[y+3>>0]=-1;x=x+3|0;if((x|0)>=(l|0))break;else y=y+k|0}u=g;return}function zGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;jDa(g,a,b,3);cGa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d,0);kDa(g);u=e;return}function AGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;jDa(g,a,b,3);cGa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d,1);kDa(g);u=e;return}function BGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;nDa(h,a,b,i);nGa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,e,0);oDa(h);u=g;return}function CGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;nDa(h,a,b,i);nGa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,e,1);oDa(h);u=g;return}function DGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+240|0;g=e+8|0;h=e;i=b[c+11>>0]|0;j=f[c>>2]|0;k=(b[d+11>>0]|0)<0?f[d>>2]|0:d;Kjb(g);d=g+104|0;Kjb(d);f[g+208>>2]=0;l=g+212|0;f[l>>2]=0;f[g+216>>2]=0;f[g+224>>2]=0;f[g+228>>2]=0;m=g+224|0;f[g+220>>2]=m;hIa(i<<24>>24<0?j:c,g);if(k|0?b[k>>0]|0:0)jIa(k,d);oOa(a);f[h>>2]=f[a>>2];k=f[a+4>>2]|0;f[h+4>>2]=k;if(k|0)TXc(k);FGa(g,h);ROa(h);EGa(g+220|0,f[m>>2]|0);m=g+208|0;h=f[m>>2]|0;if(!h){Qjb(d);Qjb(g);u=e;return}k=f[l>>2]|0;if((k|0)==(h|0))n=h;else{a=k;while(1){k=a+-20|0;f[l>>2]=k;if((b[k+11>>0]|0)<0){cYc(f[k>>2]|0);o=f[l>>2]|0}else o=k;if((o|0)==(h|0))break;else a=o}n=f[m>>2]|0}cYc(n);Qjb(d);Qjb(g);u=e;return}function EGa(a,c){a=a|0;c=c|0;if(!c)return;EGa(a,f[c>>2]|0);EGa(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function FGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0.0,Nb=0,Ob=0,Pb=0,Qb=0;d=u;u=u+304|0;e=d+248|0;g=d+200|0;h=d+144|0;i=d+128|0;j=d+112|0;k=d+96|0;l=d+84|0;m=d+72|0;o=d+24|0;q=d;r=d+12|0;s=f[a+80>>2]|0;t=a+220|0;v=a+224|0;EGa(t,f[v>>2]|0);f[a+228>>2]=0;f[t>>2]=v;f[v>>2]=0;v=a+208|0;w=f[v>>2]|0;x=a+212|0;y=f[x>>2]|0;if((y|0)==(w|0)){z=y;A=v;B=w}else{C=y;while(1){y=C+-20|0;f[x>>2]=y;if((b[y+11>>0]|0)<0){cYc(f[y>>2]|0);D=f[x>>2]|0}else D=y;if((D|0)==(w|0))break;else C=D}z=D;A=v;B=f[v>>2]|0}D=z;C=s+1|0;w=a+216|0;y=B;if((((f[w>>2]|0)-B|0)/20|0)>>>0<C>>>0){if(C>>>0>214748364){E=af(8)|0;hYc(E,512536);f[E>>2]=192348;ig(E|0,25336,2140)}E=$Xc(C*20|0)|0;F=E+(((D-B|0)/20|0)*20|0)|0;B=F;G=E+(C*20|0)|0;if((z|0)==(y|0)){H=B;I=D;K=y}else{D=z;z=B;C=F;do{F=C+-20|0;E=D;D=D+-20|0;f[F>>2]=f[D>>2];f[F+4>>2]=f[D+4>>2];f[F+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;F=E+-8|0;E=f[F+4>>2]|0;L=C+-8|0;f[L>>2]=f[F>>2];f[L+4>>2]=E;C=z+-20|0;z=C}while((D|0)!=(y|0));H=z;I=f[A>>2]|0;K=f[x>>2]|0}f[A>>2]=H;f[x>>2]=B;f[w>>2]=G;G=I;if((K|0)!=(G|0)){B=K;do{B=B+-20|0;if((b[B+11>>0]|0)<0)cYc(f[B>>2]|0)}while((B|0)!=(G|0))}if(I|0)cYc(I)}I=a+36|0;GGa(k,f[I>>2]|0);a:do if((f[I>>2]|0)>0){G=a+44|0;B=e+12|0;K=e+16|0;H=e+11|0;z=0;while(1){lYc(e,f[(f[G>>2]|0)+4+(z<<2)>>2]|0);f[B>>2]=0;f[K>>2]=z;y=f[x>>2]|0;D=f[w>>2]|0;C=D;if(y>>>0>=D>>>0){D=y;E=f[A>>2]|0;L=(D-E|0)/20|0;F=L+1|0;M=E;if(F>>>0>214748364){N=26;break}O=(C-E|0)/20|0;E=O<<1;C=O>>>0<107374182?(E>>>0<F>>>0?F:E):214748364;if(!C)P=0;else{if(C>>>0>214748364){N=29;break}P=$Xc(C*20|0)|0}E=P+(L*20|0)|0;F=E;O=P+(C*20|0)|0;f[E>>2]=f[e>>2];f[E+4>>2]=f[e+4>>2];f[E+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;C=B;Q=f[C+4>>2]|0;R=P+(L*20|0)+12|0;f[R>>2]=f[C>>2];f[R+4>>2]=Q;Q=E+20|0;if((y|0)==(M|0)){S=F;T=D;U=y}else{D=y;R=F;F=E;do{E=F+-20|0;C=D;D=D+-20|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];f[E+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;E=C+-8|0;C=f[E+4>>2]|0;L=F+-8|0;f[L>>2]=f[E>>2];f[L+4>>2]=C;F=R+-20|0;R=F}while((D|0)!=(M|0));S=R;T=f[A>>2]|0;U=f[x>>2]|0}f[A>>2]=S;f[x>>2]=Q;f[w>>2]=O;M=T;if((U|0)!=(M|0)){D=U;do{D=D+-20|0;if((b[D+11>>0]|0)<0)cYc(f[D>>2]|0)}while((D|0)!=(M|0))}if(T|0)cYc(T)}else{f[y>>2]=f[e>>2];f[y+4>>2]=f[e+4>>2];f[y+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;M=B;D=f[M+4>>2]|0;O=y+12|0;f[O>>2]=f[M>>2];f[O+4>>2]=D;f[x>>2]=(f[x>>2]|0)+20}if((b[H>>0]|0)<0)cYc(f[e>>2]|0);oYc((f[k>>2]|0)+(z*12|0)|0,f[(f[G>>2]|0)+4+(z<<2)>>2]|0)|0;z=z+1|0;if((z|0)>=(f[I>>2]|0))break a}if((N|0)==26)kWc(v);else if((N|0)==29){z=af(8)|0;hYc(z,512536);f[z>>2]=192348;ig(z|0,25336,2140)}}while(0);b:do if((s|0)>0){I=a+88|0;T=o+4|0;U=o+8|0;w=o+4|0;S=o+12|0;A=a+184|0;P=a+192|0;z=o+12|0;G=g+4|0;H=g+8|0;B=g+8|0;K=e+11|0;D=e+4|0;O=i+8|0;M=i+12|0;Q=i+4|0;R=j+8|0;F=j+4|0;C=h+36|0;L=h+16|0;E=h+4|0;V=h+40|0;W=h+44|0;X=h+48|0;Z=h+8|0;_=h+4|0;$=e+36|0;aa=e+16|0;ba=e+4|0;ca=e+40|0;da=e+44|0;ea=e+48|0;fa=m+11|0;ga=m+4|0;ha=k+4|0;ia=k+8|0;ja=o+36|0;ka=ja+11|0;la=o+24|0;ma=la+11|0;na=o+12|0;oa=l+11|0;pa=g+8|0;qa=g+4|0;ra=g+11|0;sa=g+4|0;ta=g+8|0;ua=g+4|0;va=g+12|0;wa=h+11|0;xa=h+3|0;ya=j+11|0;za=j+3|0;Aa=j+11|0;Ba=j+3|0;Ca=j+8|0;Da=j+12|0;Ea=j+4|0;Fa=j+8|0;Ga=j+12|0;Ha=j+4|0;Ia=h+11|0;Ja=g+36|0;Ka=Ja+11|0;La=g+24|0;Ma=La+11|0;Na=g+12|0;Oa=q+11|0;Pa=q+1|0;Qa=r+11|0;Ra=r+4|0;Sa=j+11|0;Ta=j+4|0;Ua=h+11|0;Va=h+1|0;Wa=i+11|0;Xa=i+4|0;Ya=g+11|0;Za=g+4|0;_a=h+4|0;$a=j+4|0;ab=j+4|0;bb=0;c:while(1){cb=f[(f[I>>2]|0)+4+(bb<<2)>>2]|0;db=cb+136|0;lYc(l,f[db>>2]|0);lYc(m,f[cb+140>>2]|0);f[T>>2]=0;f[U>>2]=0;f[o>>2]=w;eb=S;fb=eb+36|0;do{f[eb>>2]=0;eb=eb+4|0}while((eb|0)<(fb|0));HGa(cb,o,0);y=f[db>>2]|0;gb=f[A>>2]|0;d:do if(gb){hb=f[P>>2]|0;ib=b[y+11>>0]|0;jb=ib<<24>>24<0;kb=jb?f[y+4>>2]|0:ib&255;ib=(kb|0)==0;if(jb){if(ib){jb=0;while(1){lb=f[hb+4+(jb<<2)>>2]|0;mb=f[lb+136>>2]|0;nb=b[mb+11>>0]|0;if(((nb<<24>>24<0?f[mb+4>>2]|0:nb&255)|0)==0?f[lb+80>>2]|0:0){ob=jb;N=72;break d}jb=jb+1|0;if((jb|0)==(gb|0))break d}}else pb=0;do{jb=f[hb+4+(pb<<2)>>2]|0;lb=f[jb+136>>2]|0;nb=b[lb+11>>0]|0;mb=nb<<24>>24<0;qb=nb&255;e:do if(((mb?f[lb+4>>2]|0:qb)|0)==(kb|0)){nb=f[lb>>2]|0;rb=f[y>>2]|0;f:do if(mb){if(WKc(nb,rb,kb)|0)break e}else{if((nb&255)<<24>>24!=(b[rb>>0]|0))break e;sb=lb;tb=qb;ub=rb;while(1){tb=tb+-1|0;sb=sb+1|0;if(!tb)break f;ub=ub+1|0;if((b[sb>>0]|0)!=(b[ub>>0]|0))break e}}while(0);if(f[jb+80>>2]|0){ob=pb;N=72;break d}}while(0);pb=pb+1|0}while((pb|0)!=(gb|0))}else{if(ib){jb=0;while(1){qb=f[hb+4+(jb<<2)>>2]|0;lb=f[qb+136>>2]|0;mb=b[lb+11>>0]|0;if(((mb<<24>>24<0?f[lb+4>>2]|0:mb&255)|0)==0?f[qb+80>>2]|0:0){ob=jb;N=72;break d}jb=jb+1|0;if((jb|0)==(gb|0))break d}}else vb=0;do{jb=f[hb+4+(vb<<2)>>2]|0;ib=f[jb+136>>2]|0;qb=b[ib+11>>0]|0;mb=qb<<24>>24<0;lb=qb&255;g:do if(((mb?f[ib+4>>2]|0:lb)|0)==(kb|0)){qb=f[ib>>2]|0;h:do if(mb){if(WKc(qb,y,kb)|0)break g}else{if((qb&255)<<24>>24!=(b[y>>0]|0))break g;rb=ib;nb=lb;ub=y;while(1){nb=nb+-1|0;rb=rb+1|0;if(!nb)break h;ub=ub+1|0;if((b[rb>>0]|0)!=(b[ub>>0]|0))break g}}while(0);if(f[jb+80>>2]|0){ob=vb;N=72;break d}}while(0);vb=vb+1|0}while((vb|0)!=(gb|0))}}else{ob=0;N=72}while(0);i:do if((N|0)==72?(N=0,(ob|0)!=(gb|0)):0){y=f[(f[P>>2]|0)+4+(ob<<2)>>2]|0;db=y+80|0;kb=f[db>>2]|0;hS(z,kb);hb=(kb|0)>0;jb=y+88|0;if(hb){y=0;do{lb=f[(f[jb>>2]|0)+4+(y<<2)>>2]|0;ib=f[z>>2]|0;mb=ib+(y*56|0)|0;f[g>>2]=0;f[G>>2]=0;f[H>>2]=0;qb=f[lb+8>>2]|0;j:do if(!(qb&60)){if(!(qb&2)){f[e>>2]=1;Uv(g,1,e);break}ub=f[lb+84>>2]|0;rb=ub|0?ub:531296;ub=rb+16|0;if((f[ub>>2]|0)>0){nb=rb+24|0;rb=0;sb=0;tb=0;while(1){wb=f[(f[nb>>2]|0)+8+(rb<<3)>>2]|0;f[e>>2]=wb;if(sb>>>0<tb>>>0){f[sb>>2]=wb;f[G>>2]=sb+4}else LA(g,e);wb=rb+1|0;if((wb|0)>=(f[ub>>2]|0))break j;rb=wb;sb=f[G>>2]|0;tb=f[B>>2]|0}}}else{f[e>>2]=f[lb+88>>2];LA(g,e);tb=f[G>>2]|0;sb=f[B>>2]|0;rb=f[lb+92>>2]|0;f[e>>2]=rb;if(tb>>>0<sb>>>0){f[tb>>2]=rb;rb=tb+4|0;f[G>>2]=rb;xb=rb;yb=sb}else{LA(g,e);xb=f[G>>2]|0;yb=f[B>>2]|0}sb=f[lb+96>>2]|0;f[e>>2]=sb;if(xb>>>0<yb>>>0){f[xb>>2]=sb;sb=xb+4|0;f[G>>2]=sb;zb=sb;Ab=yb}else{LA(g,e);zb=f[G>>2]|0;Ab=f[B>>2]|0}sb=f[lb+100>>2]|0;f[e>>2]=sb;if(zb>>>0<Ab>>>0){f[zb>>2]=sb;f[G>>2]=zb+4}else LA(g,e)}while(0);qb=f[g>>2]|0;S$(mb,(f[G>>2]|0)-qb>>2,qb,5);qb=f[lb+16>>2]|0;if(!qb){if((f[lb+104>>2]|0)!=2){N=119;break c}lYc(e,f[lb+80>>2]|0);sb=b[K>>0]|0;rb=sb<<24>>24<0;tb=rb?f[D>>2]|0:sb&255;sb=f[ib+(y*56|0)+4>>2]|0;if((sb|0)<3)Bb=Y(f[ib+(y*56|0)+12>>2]|0,f[ib+(y*56|0)+8>>2]|0)|0;else{ub=f[ib+(y*56|0)+40>>2]|0;nb=0;wb=1;while(1){Cb=Y(f[ub+(nb<<2)>>2]|0,wb)|0;nb=nb+1|0;if((nb|0)==(sb|0)){Bb=Cb;break}else wb=Cb}}if((tb>>>1|0)!=(Bb|0)){N=125;break c}wb=f[g>>2]|0;_$(h,(f[G>>2]|0)-wb>>2,wb,3,rb?f[e>>2]|0:e,0);f[O>>2]=0;f[M>>2]=0;f[i>>2]=16842752;f[Q>>2]=h;wb=R;f[wb>>2]=0;f[wb+4>>2]=0;f[j>>2]=33619968;f[F>>2]=mb;eY(i,j);wb=f[C>>2]|0;do if(wb|0){sb=wb+12|0;nb=f[sb>>2]|0;f[sb>>2]=nb+-1;if((nb|0)!=1)break;V$(h)}while(0);f[C>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[E>>2]|0)>0){wb=f[V>>2]|0;rb=0;do{f[wb+(rb<<2)>>2]=0;rb=rb+1|0}while((rb|0)<(f[E>>2]|0))}rb=f[W>>2]|0;if((rb|0)!=(X|0))wL(rb);if((b[K>>0]|0)<0)cYc(f[e>>2]|0)}else{rb=f[ib+(y*56|0)+4>>2]|0;if((rb|0)<3)Db=Y(f[ib+(y*56|0)+12>>2]|0,f[ib+(y*56|0)+8>>2]|0)|0;else{wb=f[ib+(y*56|0)+40>>2]|0;tb=0;nb=1;while(1){sb=Y(f[wb+(tb<<2)>>2]|0,nb)|0;tb=tb+1|0;if((tb|0)==(rb|0)){Db=sb;break}else nb=sb}}if((qb|0)!=(Db|0)){N=108;break c}nb=f[lb+24>>2]|0;_$(e,rb,f[ib+(y*56|0)+40>>2]|0,5,(nb|0)==0?0:nb+4|0,0);nb=Z;f[nb>>2]=0;f[nb+4>>2]=0;f[h>>2]=33619968;f[_>>2]=mb;jR(e,h);nb=f[$>>2]|0;if(nb|0?(tb=nb+12|0,nb=f[tb>>2]|0,f[tb>>2]=nb+-1,(nb|0)==1):0)V$(e);f[$>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[ba>>2]|0)>0){nb=f[ca>>2]|0;tb=0;do{f[nb+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[ba>>2]|0))}tb=f[da>>2]|0;if((tb|0)!=(ea|0))wL(tb)}tb=f[g>>2]|0;if(tb|0){nb=f[G>>2]|0;if((nb|0)!=(tb|0))f[G>>2]=nb+(~((nb+-4-tb|0)>>>2)<<2);cYc(tb)}y=y+1|0}while((y|0)<(kb|0))}y=f[db>>2]|0;if((y|0)>0){tb=f[jb>>2]|0;nb=0;do{d0a(f[tb+4+(nb<<2)>>2]|0);nb=nb+1|0}while((nb|0)!=(y|0));f[db>>2]=0;Eb=0}else Eb=y;nb=f[jb>>2]|0;if(!nb)Fb=0;else Fb=(f[nb>>2]|0)-Eb|0;if((kb|0)!=(Fb|0)){N=142;break c}if(hb){tb=0;mb=nb;while(1){nb=(f[mb>>2]|0)+-1|0;f[mb>>2]=nb;ib=f[mb+4+(nb<<2)>>2]|0;if(ib|0)Yi[f[(f[ib>>2]|0)+4>>2]&4095](ib);ib=tb+1|0;if((ib|0)==(kb|0))break i;tb=ib;mb=f[jb>>2]|0}}}while(0);gb=IGa(t,l)|0;jb=f[gb>>2]|0;f[gb>>2]=jb+1;f[e>>2]=jb;if(jb|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Ua>>0]=1;b[h>>0]=95;b[Va>>0]=0;JGa(i,e);jb=b[Wa>>0]|0;gb=jb<<24>>24<0;mb=zYc(h,gb?f[i>>2]|0:i,gb?f[Xa>>2]|0:jb&255)|0;f[g>>2]=f[mb>>2];f[g+4>>2]=f[mb+4>>2];f[g+8>>2]=f[mb+8>>2];f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;mb=b[Ya>>0]|0;jb=mb<<24>>24<0;zYc(l,jb?f[g>>2]|0:g,jb?f[Za>>2]|0:mb&255)|0;if((b[Ya>>0]|0)<0)cYc(f[g>>2]|0);if((b[Wa>>0]|0)<0)cYc(f[i>>2]|0);if((b[Ua>>0]|0)<0)cYc(f[h>>2]|0)}mb=b[fa>>0]|0;jb=f[ga>>2]|0;do if(((mb<<24>>24<0?jb:mb&255)|0)==5){if(LYc(m,0,-1,373249,5)|0){Gb=b[fa>>0]|0;Hb=f[ga>>2]|0;N=164;break}gb=cb+36|0;if((f[gb>>2]|0)>0){tb=cb+20|0;kb=cb+28|0;hb=cb+44|0;y=0;do{KGa(a,f[tb>>2]|0,f[kb>>2]|0,f[hb>>2]|0,0,y);db=f[ha>>2]|0;ib=f[x>>2]|0;f[ib+-4>>2]=(db-(f[k>>2]|0)|0)/12|0;nb=ib+-20|0;ib=db;if((ib|0)==(f[ia>>2]|0))NN(k,nb);else{lYc(ib,nb);f[ha>>2]=(f[ha>>2]|0)+12}y=y+1|0}while((y|0)<(f[gb>>2]|0))}}else{Gb=mb;Hb=jb;N=164}while(0);k:do if((N|0)==164){N=0;do if(((Gb<<24>>24<0?Hb:Gb&255)|0)==9){if(LYc(m,0,-1,429107,9)|0){Ib=b[fa>>0]|0;Jb=f[ga>>2]|0;N=199;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;jb=$Xc(32)|0;f[g>>2]=jb;f[pa>>2]=-2147483616;f[qa>>2]=16;eb=jb;Kb=444594;fb=eb+16|0;do{b[eb>>0]=b[Kb>>0]|0;eb=eb+1|0;Kb=Kb+1|0}while((eb|0)<(fb|0));b[jb+16>>0]=0;mb=LGa(o,g)|0;if((mb|0)==(w|0))Lb=1;else{gb=MGa(mb+28|0,-1)|0;Lb=(gb|0)!=0|(J|0)!=0}if((b[ra>>0]|0)<0)cYc(f[g>>2]|0);if(!Lb){gb=cb+20|0;if((f[gb>>2]|0)!=1){N=173;break c}if((f[cb+36>>2]|0)!=1){N=175;break c}f[sa>>2]=0;f[ta>>2]=0;f[g>>2]=ua;eb=va;fb=eb+36|0;do{f[eb>>2]=0;eb=eb+4|0}while((eb|0)<(fb|0));jb=_a;f[jb>>2]=0;f[jb+4>>2]=0;b[wa>>0]=3;b[h>>0]=b[513188]|0;b[h+1>>0]=b[513189]|0;b[h+2>>0]=b[513190]|0;b[xa>>0]=0;jb=$a;f[jb>>2]=0;f[jb+4>>2]=0;b[ya>>0]=3;b[j>>0]=b[513188]|0;b[j+1>>0]=b[513189]|0;b[j+2>>0]=b[513190]|0;b[za>>0]=0;jb=LGa(o,j)|0;if((jb|0)==(w|0))Mb=9.999999747378752e-06;else Mb=+NGa(jb+28|0,-1);n[i>>2]=Mb;OGa(g,h,i)|0;if((b[ya>>0]|0)<0)cYc(f[j>>2]|0);if((b[wa>>0]|0)<0)cYc(f[h>>2]|0);AN(h,l,373302);jb=IGa(t,h)|0;mb=f[jb>>2]|0;f[jb>>2]=mb+1;f[i>>2]=mb;if(mb|0){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;b[Oa>>0]=1;b[q>>0]=95;b[Pa>>0]=0;JGa(r,i);mb=b[Qa>>0]|0;jb=mb<<24>>24<0;y=zYc(q,jb?f[r>>2]|0:r,jb?f[Ra>>2]|0:mb&255)|0;f[j>>2]=f[y>>2];f[j+4>>2]=f[y+4>>2];f[j+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;y=b[Sa>>0]|0;mb=y<<24>>24<0;zYc(h,mb?f[j>>2]|0:j,mb?f[Ta>>2]|0:y&255)|0;if((b[Sa>>0]|0)<0)cYc(f[j>>2]|0);if((b[Qa>>0]|0)<0)cYc(f[r>>2]|0);if((b[Oa>>0]|0)<0)cYc(f[q>>2]|0)}y=ab;f[y>>2]=0;f[y+4>>2]=0;b[Aa>>0]=3;b[j>>0]=b[396591]|0;b[j+1>>0]=b[396592]|0;b[j+2>>0]=b[396593]|0;b[Ba>>0]=0;y=SOa(c,h,j,g)|0;if((b[Aa>>0]|0)<0)cYc(f[j>>2]|0);mb=cb+28|0;PGa(a,f[(f[mb>>2]|0)+4>>2]|0,y,0,c);jb=cb+44|0;KGa(a,f[gb>>2]|0,f[mb>>2]|0,f[jb>>2]|0,y,0);oYc(f[(f[(f[(f[I>>2]|0)+4+(bb<<2)>>2]|0)+28>>2]|0)+4>>2]|0,f[(f[jb>>2]|0)+4>>2]|0)|0;jb=f[S>>2]|0;p[q>>3]=0.0;f[j>>2]=-1056833530;f[Ea>>2]=q;f[Ca>>2]=1;f[Da>>2]=1;mR(jb,j,fT()|0)|0;jb=f[S>>2]|0;p[q>>3]=1.0;f[j>>2]=-1056833530;f[Ha>>2]=q;f[Fa>>2]=1;f[Ga>>2]=1;mR(jb+56|0,j,fT()|0)|0;if((b[Ia>>0]|0)<0)cYc(f[h>>2]|0);if((b[Ka>>0]|0)<0)cYc(f[Ja>>2]|0);if((b[Ma>>0]|0)<0)cYc(f[La>>2]|0);hx(Na);QGa(g,f[ua>>2]|0)}}else{Ib=Gb;Jb=Hb;N=199}while(0);if(((N|0)==199?(N=0,((Ib<<24>>24<0?Jb:Ib&255)|0)==20):0)?(LYc(m,0,-1,373307,20)|0)==0:0)tYc(m,429163)|0;jb=SOa(c,l,m,o)|0;y=cb+20|0;mb=f[y>>2]|0;if((mb|0)>0){hb=cb+28|0;kb=0;do{PGa(a,f[(f[hb>>2]|0)+4+(kb<<2)>>2]|0,jb,kb,c);kb=kb+1|0;tb=f[y>>2]|0}while((kb|0)<(tb|0));Nb=tb}else Nb=mb;kb=cb+36|0;if((f[kb>>2]|0)>0){hb=cb+28|0;tb=cb+44|0;nb=0;ib=Nb;while(1){KGa(a,ib,f[hb>>2]|0,f[tb>>2]|0,jb,nb);db=nb+1|0;if((db|0)>=(f[kb>>2]|0))break k;nb=db;ib=f[y>>2]|0}}}while(0);if((b[ka>>0]|0)<0)cYc(f[ja>>2]|0);if((b[ma>>0]|0)<0)cYc(f[la>>2]|0);hx(na);QGa(o,f[w>>2]|0);if((b[fa>>0]|0)<0)cYc(f[m>>2]|0);if((b[oa>>0]|0)<0)cYc(f[l>>2]|0);bb=bb+1|0;if((bb|0)>=(s|0))break b}if((N|0)==108){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;bb=$Xc(48)|0;f[e>>2]=bb;f[e+8>>2]=-2147483600;f[e+4>>2]=42;eb=bb;Kb=372956;fb=eb+42|0;do{b[eb>>0]=b[Kb>>0]|0;eb=eb+1|0;Kb=Kb+1|0}while((eb|0)<(fb|0));b[bb+42>>0]=0;vM(-215,e,372999,373013,256)}else if((N|0)==119){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;oa=$Xc(48)|0;f[e>>2]=oa;f[e+8>>2]=-2147483600;f[e+4>>2]=40;eb=oa;Kb=373094;fb=eb+40|0;do{b[eb>>0]=b[Kb>>0]|0;eb=eb+1|0;Kb=Kb+1|0}while((eb|0)<(fb|0));b[oa+40>>0]=0;vM(-215,e,372999,373013,264)}else if((N|0)==125){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;bb=$Xc(48)|0;f[h>>2]=bb;f[h+8>>2]=-2147483600;f[h+4>>2]=43;eb=bb;Kb=373135;fb=eb+43|0;do{b[eb>>0]=b[Kb>>0]|0;eb=eb+1|0;Kb=Kb+1|0}while((eb|0)<(fb|0));b[bb+43>>0]=0;vM(-215,h,372999,373013,267)}else if((N|0)==142){oa=$Xc(48)|0;f[e>>2]=oa;f[e+8>>2]=-2147483600;f[e+4>>2]=44;eb=oa;Kb=373179;fb=eb+44|0;do{b[eb>>0]=b[Kb>>0]|0;eb=eb+1|0;Kb=Kb+1|0}while((eb|0)<(fb|0));b[oa+44>>0]=0;vM(-215,e,373224,373013,298)}else if((N|0)==173){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;bb=$Xc(32)|0;f[g>>2]=bb;f[g+8>>2]=-2147483616;f[g+4>>2]=24;eb=bb;Kb=373255;fb=eb+24|0;do{b[eb>>0]=b[Kb>>0]|0;eb=eb+1|0;Kb=Kb+1|0}while((eb|0)<(fb|0));b[bb+24>>0]=0;vM(-215,g,390369,373013,364)}else if((N|0)==175){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;oa=$Xc(32)|0;f[g>>2]=oa;f[g+8>>2]=-2147483616;f[g+4>>2]=21;eb=oa;Kb=373280;fb=eb+21|0;do{b[eb>>0]=b[Kb>>0]|0;eb=eb+1|0;Kb=Kb+1|0}while((eb|0)<(fb|0));b[oa+21>>0]=0;vM(-215,g,390369,373013,364)}}while(0);lQa(c,k);c=f[v>>2]|0;v=f[x>>2]|0;if((v|0)!=(c|0)){g=v;while(1){v=g+-20|0;f[x>>2]=v;if((b[v+11>>0]|0)<0){cYc(f[v>>2]|0);Ob=f[x>>2]|0}else Ob=v;if((Ob|0)==(c|0))break;else g=Ob}}Ob=f[k>>2]|0;if(!Ob){u=d;return}g=k+4|0;c=f[g>>2]|0;if((c|0)==(Ob|0))Pb=Ob;else{x=c;while(1){c=x+-12|0;f[g>>2]=c;if((b[c+11>>0]|0)<0){cYc(f[c>>2]|0);Qb=f[g>>2]|0}else Qb=c;if((Qb|0)==(Ob|0))break;else x=Qb}Pb=f[k>>2]|0}cYc(Pb);u=d;return}function GGa(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)kWc(a);d=$Xc(b*12|0)|0;f[c>>2]=d;f[a>>2]=d;f[a+8>>2]=d+(b*12|0);a=b;b=d;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=(f[c>>2]|0)+12|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function HGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+64|0;g=e;i=e+48|0;j=e+44|0;k=e+32|0;l=e+28|0;m=e+16|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);o=f[g>>2]|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);q=f[g+4>>2]|0;r=o+52|0;if((f[r>>2]|0)<=0){u=e;return}s=o+20|0;o=g+4|0;t=g+4|0;v=g+4|0;w=g+4|0;y=g+4|0;z=g+4|0;A=g+4|0;B=g+4|0;C=g+11|0;D=i+4|0;E=g+4|0;F=g+8|0;G=g+12|0;H=g+4|0;I=g+8|0;J=g+12|0;K=i+11|0;L=g+11|0;M=0;a:while(1){N=f[s>>2]|0;O=N+(M*88|0)|0;if(!d){P=f[O>>2]|0;if((b[530528]|0)==0?X0c(530528)|0:0){f[223013]=0;f[223014]=0;f[223015]=0;b[892063]=6;b[892052]=b[373469]|0;b[892053]=b[373470]|0;b[892054]=b[373471]|0;b[892055]=b[373472]|0;b[892056]=b[373473]|0;b[892057]=b[373474]|0;b[892058]=0;be(2220,892052,x|0)|0}Q=b[P+11>>0]|0;R=Q<<24>>24<0?f[P+4>>2]|0:Q&255;Q=b[892063]|0;S=Q<<24>>24<0;T=S?f[223014]|0:Q&255;if(R>>>0>=T>>>0?(LYc(P,R-T|0,T,S?f[223013]|0:892052,T)|0)==0:0)U=10}else U=10;b:do if((U|0)==10){U=0;T=Mi[f[(f[q>>2]|0)+8>>2]&1023](q,a)|0;S=N+(M*88|0)+32|0;R=f[S>>2]|0;switch(R|0){case 2:break;case 1:{if(!(hj[f[(f[q>>2]|0)+20>>2]&511](q,a,O)|0)){V=f[S>>2]|0;U=13}break}default:{V=R;U=13}}do if((U|0)==13){U=0;if((V|0)==3?(hj[f[(f[q>>2]|0)+24>>2]&511](q,a,O)|0)>0:0)break;if(!(f[T>>2]|0))break b}while(0);R=f[T>>2]|0;c:do if(R|0?(P=f[R>>2]|0,Q=(f[R+4>>2]|0)-P|0,W=Q>>4,X=P,(Q|0)>0):0){if((f[X+4>>2]|0)==4){Y=0;Z=X}else{U=19;break a}while(1){X=Z+(Y<<4)+8|0;lYc(g,f[(f[f[f[X>>2]>>2]>>2]|0)+8>>2]|0);lYc(i,f[(f[f[f[X>>2]>>2]>>2]|0)+24>>2]|0);_Ga(c,g,i)|0;if((b[K>>0]|0)<0)cYc(f[i>>2]|0);if((b[L>>0]|0)<0)cYc(f[g>>2]|0);Y=Y+1|0;if((Y|0)>=(W|0))break c;Z=f[f[T>>2]>>2]|0;if((f[Z+(Y<<4)+4>>2]|0)!=4){U=19;break a}}}while(0);_=N+(M*88|0)+24|0;T=f[_>>2]|0;if(T|0?(f[T>>2]|0)!=2:0){f[g>>2]=80424;f[H>>2]=2231;b[I>>0]=0;f[J>>2]=O;J_b(T,g)}$=N+(M*88|0)+28|0;if((f[165644+(f[$>>2]<<2)>>2]|0)==10)if((f[S>>2]|0)==3){HGa(hh[f[(f[q>>2]|0)+208>>2]&127](q,a,O,0)|0,c,1);break}else{HGa(hh[f[(f[q>>2]|0)+108>>2]&127](q,a,O,0)|0,c,1);break}mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);T=f[o>>2]|0;R=f[_>>2]|0;if(R|0?(f[R>>2]|0)!=2:0){f[g>>2]=80424;f[E>>2]=2231;b[F>>0]=0;f[G>>2]=O;J_b(R,g)}R=(f[S>>2]|0)==3;W=f[O>>2]|0;d:do switch(f[165644+(f[$>>2]<<2)>>2]|0){case 1:{if(!R){X=hj[f[(f[T>>2]|0)+68>>2]&511](T,a,O)|0;f[g>>2]=X;aHa(c,W,g)|0;break d}X=moc(T,a,O)|0;Q=f[X+8>>2]|0;P=f[X>>2]|0;X=$Xc(16)|0;aa=X+8|0;f[X>>2]=aa;f[X+4>>2]=P;if(P>>>0>1){ba=bYc(P>>>0>536870911?-1:P<<3)|0;f[X>>2]=ba;ca=ba}else ca=aa;f[g>>2]=0;f[t>>2]=X;if((P|0)>0){X=(Q|0)==0?0:Q+4|0;Q=0;while(1){aa=f[X>>2]|0;ba=ca+(Q<<3)|0;f[ba>>2]=aa;f[ba+4>>2]=((aa|0)<0)<<31>>31;Q=Q+1|0;if((Q|0)==(P|0))break;else X=X+4|0}}$Ga(c,W,g)|0;RGa(g);break}case 3:{if(!R){X=hj[f[(f[T>>2]|0)+76>>2]&511](T,a,O)|0;f[g>>2]=X;bHa(c,W,g)|0;break d}X=ooc(T,a,O)|0;P=f[X+8>>2]|0;Q=f[X>>2]|0;X=$Xc(16)|0;aa=X+8|0;f[X>>2]=aa;f[X+4>>2]=Q;if(Q>>>0>1){ba=bYc(Q>>>0>536870911?-1:Q<<3)|0;f[X>>2]=ba;da=ba}else da=aa;f[g>>2]=0;f[v>>2]=X;if((Q|0)>0){X=(P|0)==0?0:P+4|0;P=0;while(1){aa=da+(P<<3)|0;f[aa>>2]=f[X>>2];f[aa+4>>2]=0;P=P+1|0;if((P|0)==(Q|0))break;else X=X+4|0}}$Ga(c,W,g)|0;RGa(g);break}case 2:{if(!R){X=hj[f[(f[T>>2]|0)+68>>2]&511](T,a,O)|0;f[g>>2]=X;aHa(c,W,g)|0;break d}X=noc(T,a,O)|0;Q=f[X+8>>2]|0;P=f[X>>2]|0;X=$Xc(16)|0;aa=X+8|0;f[X>>2]=aa;f[X+4>>2]=P;if(P>>>0>1){ba=bYc(P>>>0>536870911?-1:P<<3)|0;f[X>>2]=ba;ea=ba}else ea=aa;f[g>>2]=0;f[w>>2]=X;if((P|0)>0){X=(Q|0)==0?0:Q+8|0;Q=0;while(1){aa=X;ba=f[aa+4>>2]|0;fa=ea+(Q<<3)|0;f[fa>>2]=f[aa>>2];f[fa+4>>2]=ba;Q=Q+1|0;if((Q|0)==(P|0))break;else X=X+8|0}}$Ga(c,W,g)|0;RGa(g);break}case 4:{if(!R){X=hj[f[(f[T>>2]|0)+76>>2]&511](T,a,O)|0;f[g>>2]=X;bHa(c,W,g)|0;break d}X=poc(T,a,O)|0;P=f[X+8>>2]|0;Q=f[X>>2]|0;X=$Xc(16)|0;ba=X+8|0;f[X>>2]=ba;f[X+4>>2]=Q;if(Q>>>0>1){fa=bYc(Q>>>0>536870911?-1:Q<<3)|0;f[X>>2]=fa;ga=fa}else ga=ba;f[g>>2]=0;f[y>>2]=X;if((Q|0)>0){X=(P|0)==0?0:P+8|0;P=0;while(1){ba=X;fa=f[ba+4>>2]|0;aa=ga+(P<<3)|0;f[aa>>2]=f[ba>>2];f[aa+4>>2]=fa;P=P+1|0;if((P|0)==(Q|0))break;else X=X+8|0}}$Ga(c,W,g)|0;RGa(g);break}case 7:{if(!R){X=(hj[f[(f[T>>2]|0)+92>>2]&511](T,a,O)|0)&1;b[g>>0]=X;cHa(c,W,g)|0;break d}X=soc(T,a,O)|0;Q=f[X+8>>2]|0;P=f[X>>2]|0;X=$Xc(16)|0;fa=X+8|0;f[X>>2]=fa;f[X+4>>2]=P;if(P>>>0>1){aa=bYc(P>>>0>536870911?-1:P<<3)|0;f[X>>2]=aa;ha=aa}else ha=fa;f[g>>2]=0;f[z>>2]=X;if((P|0)>0){X=(Q|0)==0?0:Q+4|0;Q=0;while(1){fa=ha+(Q<<3)|0;f[fa>>2]=h[X>>0];f[fa+4>>2]=0;Q=Q+1|0;if((Q|0)==(P|0))break;else X=X+1|0}}$Ga(c,W,g)|0;RGa(g);break}case 5:{if(!R){ia=+Sh[f[(f[T>>2]|0)+88>>2]&31](T,a,O);p[g>>3]=ia;dHa(c,W,g)|0;break d}X=roc(T,a,O)|0;P=f[X+8>>2]|0;Q=f[X>>2]|0;X=$Xc(16)|0;fa=X+8|0;f[X>>2]=fa;f[X+4>>2]=Q;if(Q>>>0>1){aa=bYc(Q>>>0>536870911?-1:Q<<3)|0;f[X>>2]=aa;ja=aa}else ja=fa;f[g>>2]=2;f[A>>2]=X;if((Q|0)>0){X=(P|0)==0?0:P+8|0;P=0;while(1){p[ja+(P<<3)>>3]=+p[X>>3];P=P+1|0;if((P|0)==(Q|0))break;else X=X+8|0}}$Ga(c,W,g)|0;RGa(g);break}case 6:{if(!R){ia=+Sh[f[(f[T>>2]|0)+84>>2]&31](T,a,O);n[g>>2]=ia;OGa(c,W,g)|0;break d}X=qoc(T,a,O)|0;Q=f[X+8>>2]|0;P=f[X>>2]|0;X=$Xc(16)|0;fa=X+8|0;f[X>>2]=fa;f[X+4>>2]=P;if(P>>>0>1){aa=bYc(P>>>0>536870911?-1:P<<3)|0;f[X>>2]=aa;ka=aa}else ka=fa;f[g>>2]=2;f[B>>2]=X;if((P|0)>0){X=(Q|0)==0?0:Q+4|0;Q=0;while(1){p[ka+(Q<<3)>>3]=+n[X>>2];Q=Q+1|0;if((Q|0)==(P|0))break;else X=X+4|0}}$Ga(c,W,g)|0;RGa(g);break}case 9:{if(R){X=toc(T,a,O,1)|0;P=f[X+12>>2]|0;f[j>>2]=(P|0)==0?0:P+4|0;P=f[X+4>>2]|0;f[g>>2]=f[j>>2];eHa(i,g,P);$Ga(c,W,i)|0;RGa(i);break d}ei[f[(f[T>>2]|0)+96>>2]&511](g,T,a,O);_Ga(c,W,g)|0;if((b[C>>0]|0)<0)cYc(f[g>>2]|0);break}case 8:{if(!R){P=hj[f[(f[T>>2]|0)+100>>2]&511](T,a,O)|0;_Ga(c,W,f[P>>2]|0)|0;break d}P=hj[f[(f[T>>2]|0)+24>>2]&511](T,a,O)|0;GGa(i,P);if((P|0)>0){X=0;do{Q=hh[f[(f[T>>2]|0)+200>>2]&127](T,a,O,X)|0;oYc((f[i>>2]|0)+(X*12|0)|0,f[Q>>2]|0)|0;X=X+1|0}while((X|0)<(P|0))}f[l>>2]=f[i>>2];f[g>>2]=f[l>>2];fHa(k,g,P);$Ga(c,W,k)|0;RGa(k);X=f[i>>2]|0;if(X|0){Q=f[D>>2]|0;if((Q|0)==(X|0))la=X;else{fa=Q;while(1){Q=fa+-12|0;f[D>>2]=Q;if((b[Q+11>>0]|0)<0){cYc(f[Q>>2]|0);ma=f[D>>2]|0}else ma=Q;if((ma|0)==(X|0))break;else fa=ma}la=f[i>>2]|0}cYc(la)}break}default:{U=104;break a}}while(0)}while(0);M=M+1|0;if((M|0)>=(f[r>>2]|0)){U=3;break}}if((U|0)==3){u=e;return}else if((U|0)==19){e=$Xc(64)|0;f[g>>2]=e;f[g+8>>2]=-2147483584;f[g+4>>2]=58;r=e;M=373476;la=r+58|0;do{b[r>>0]=b[M>>0]|0;r=r+1|0;M=M+1|0}while((r|0)<(la|0));b[e+58>>0]=0;vM(-215,g,373535,373013,112)}else if((U|0)==104){U=f[_>>2]|0;if(U|0?(f[U>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=O;J_b(U,g)}g=f[165720+(f[$>>2]<<2)>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;$=dJc(g)|0;if($>>>0>4294967279)jYc(m);if($>>>0<11){b[m+11>>0]=$;if(!$){na=m;oa=na+$|0;b[oa>>0]=0;pa=EYc(m,0,388249)|0;f[k>>2]=f[pa>>2];f[k+4>>2]=f[pa+4>>2];f[k+8>>2]=f[pa+8>>2];f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;qa=AYc(k,373555)|0;f[i>>2]=f[qa>>2];f[i+4>>2]=f[qa+4>>2];f[i+8>>2]=f[qa+8>>2];f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;vM(-2,i,373569,373013,180)}else ra=m}else{U=$+16&-16;O=$Xc(U)|0;f[m>>2]=O;f[m+8>>2]=U|-2147483648;f[m+4>>2]=$;ra=O}o1c(ra|0,g|0,$|0)|0;na=ra;oa=na+$|0;b[oa>>0]=0;pa=EYc(m,0,388249)|0;f[k>>2]=f[pa>>2];f[k+4>>2]=f[pa+4>>2];f[k+8>>2]=f[pa+8>>2];f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;qa=AYc(k,373555)|0;f[i>>2]=f[qa>>2];f[i+4>>2]=f[qa+4>>2];f[i+8>>2]=f[qa+8>>2];f[qa>>2]=0;f[qa+4>>2]=0;f[qa+8>>2]=0;vM(-2,i,373569,373013,180)}}function IGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=ZGa(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=$Xc(32)|0;lYc(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}UQ(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function JGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+160|0;e=d+136|0;g=d;h=g+56|0;i=g+4|0;f[g>>2]=6884;f[h>>2]=6904;XNc(g+56|0,i);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=36020;f[h>>2]=36040;aOc(i);f[i>>2]=35912;j=g+36|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;AM(i,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);nOc(g,f[c>>2]|0)|0;CM(a,i);f[g>>2]=36020;f[h>>2]=36040;f[i>>2]=35912;if((b[j+11>>0]|0)>=0){LMc(i);HNc(g,36052);GMc(h);u=d;return}cYc(f[j>>2]|0);LMc(i);HNc(g,36052);GMc(h);u=d;return}function KGa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i;k=f[e+4+(h<<2)>>2]|0;e=a+208|0;l=a+212|0;m=f[e>>2]|0;n=(f[l>>2]|0)-m|0;o=((n|0)/20|0)+-1|0;p=m;a:do if((n|0)>0){m=b[k+11>>0]|0;q=m<<24>>24<0;r=q?f[k+4>>2]|0:m&255;m=(r|0)==0;b:do if(q){s=o;while(1){t=p+(s*20|0)|0;v=b[t+11>>0]|0;w=v<<24>>24<0;x=v&255;do if(((w?f[p+(s*20|0)+4>>2]|0:x)|0)==(r|0)){v=f[t>>2]|0;y=w?v:t;z=f[k>>2]|0;if(w){if(m)break b;if(!(WKc(y,z,r)|0))break b;else break}if(m)break b;if((v&255)<<24>>24==(b[z>>0]|0)){v=t;y=x;A=z;do{y=y+-1|0;v=v+1|0;if(!y)break b;A=A+1|0}while((b[v>>0]|0)==(b[A>>0]|0))}}while(0);if((s|0)>0)s=s+-1|0;else break a}}else{s=o;while(1){x=p+(s*20|0)|0;t=b[x+11>>0]|0;w=t<<24>>24<0;A=t&255;do if(((w?f[p+(s*20|0)+4>>2]|0:A)|0)==(r|0)){t=f[x>>2]|0;v=w?t:x;if(w){if(m)break b;if(!(WKc(v,k,r)|0))break b;else break}if(m)break b;if((t&255)<<24>>24==(b[k>>0]|0)){t=x;v=A;y=k;do{v=v+-1|0;t=t+1|0;if(!v)break b;y=y+1|0}while((b[t>>0]|0)==(b[y>>0]|0))}}while(0);if((s|0)>0)s=s+-1|0;else break a}}while(0);do if((c|0)>(h|0)?(m=f[d+4+(h<<2)>>2]|0,s=b[m+11>>0]|0,A=s<<24>>24<0,x=s&255,((A?f[m+4>>2]|0:x)|0)==(r|0)):0){s=f[m>>2]|0;w=A?s:m;y=q?f[k>>2]|0:k;t=(r|0)==0;if(A){if(t)break a;if(!(WKc(w,y,r)|0))break a;else break}if(t)break a;if((s&255)<<24>>24==(b[y>>0]|0)){s=m;m=x;x=y;do{m=m+-1|0;s=s+1|0;if(!m)break a;x=x+1|0}while((b[s>>0]|0)==(b[x>>0]|0))}}while(0);r=$Xc(48)|0;f[j>>2]=r;f[j+8>>2]=-2147483600;f[j+4>>2]=44;q=r;x=391194;s=q+44|0;do{b[q>>0]=b[x>>0]|0;q=q+1|0;x=x+1|0}while((q|0)<(s|0));b[r+44>>0]=0;vM(-5,j,391239,373013,418)}while(0);lYc(j,k);k=j+12|0;f[k>>2]=g;f[j+16>>2]=h;h=f[l>>2]|0;g=a+216|0;a=f[g>>2]|0;d=a;if(h>>>0>=a>>>0){a=h;c=f[e>>2]|0;p=(a-c|0)/20|0;o=p+1|0;n=c;if(o>>>0>214748364)kWc(e);x=(d-c|0)/20|0;c=x<<1;d=x>>>0<107374182?(c>>>0<o>>>0?o:c):214748364;do if(d)if(d>>>0>214748364){c=af(8)|0;hYc(c,512536);f[c>>2]=192348;ig(c|0,25336,2140)}else{B=$Xc(d*20|0)|0;break}else B=0;while(0);c=B+(p*20|0)|0;o=c;x=B+(d*20|0)|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=k;q=f[d+4>>2]|0;s=B+(p*20|0)+12|0;f[s>>2]=f[d>>2];f[s+4>>2]=q;q=c+20|0;if((h|0)==(n|0)){C=o;D=a;E=h}else{a=h;s=o;o=c;do{c=o+-20|0;d=a;a=a+-20|0;f[c>>2]=f[a>>2];f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=d+-8|0;d=f[c+4>>2]|0;p=o+-8|0;f[p>>2]=f[c>>2];f[p+4>>2]=d;o=s+-20|0;s=o}while((a|0)!=(n|0));C=s;D=f[e>>2]|0;E=f[l>>2]|0}f[e>>2]=C;f[l>>2]=q;f[g>>2]=x;x=D;if((E|0)!=(x|0)){g=E;do{g=g+-20|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}while((g|0)!=(x|0))}if(D|0)cYc(D)}else{f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;D=k;k=f[D+4>>2]|0;x=h+12|0;f[x>>2]=f[D>>2];f[x+4>>2]=k;f[l>>2]=(f[l>>2]|0)+20}if((b[j+11>>0]|0)>=0){u=i;return}cYc(f[j>>2]|0);u=i;return}function LGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function MGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;d=u;u=u+48|0;e=d+24|0;g=d+16|0;h=d;i=d+28|0;j=(c|0)==-1;if(j){k=f[a>>2]|0;switch(k|0){case 0:{l=f[a+4>>2]|0;m=l+4|0;n=l;o=l;q=l;break}case 3:{l=f[a+4>>2]|0;m=l+4|0;n=l;o=l;q=l;break}case 2:{l=f[a+4>>2]|0;m=l+4|0;n=l;o=l;q=l;break}default:{f[g>>2]=k;DM(h,455363,g);vM(-3,h,470867,455383,297)}}if((f[m>>2]|0)==1){r=k;s=n;t=o;v=q}else w=15}else if((c|0)>-1){q=f[a>>2]|0;switch(q|0){case 0:{o=f[a+4>>2]|0;x=o+4|0;y=o;z=o;A=o;break}case 3:{o=f[a+4>>2]|0;x=o+4|0;y=o;z=o;A=o;break}case 2:{o=f[a+4>>2]|0;x=o+4|0;y=o;z=o;A=o;break}default:{f[e>>2]=q;DM(h,455363,e);vM(-3,h,470867,455383,297)}}if((f[x>>2]|0)>(c|0)){r=q;s=y;t=z;v=A}else w=15}else w=15;if((w|0)==15){w=$Xc(64)|0;f[h>>2]=w;f[h+8>>2]=-2147483584;f[h+4>>2]=56;B=w;C=373328;D=B+56|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[w+56>>0]=0;vM(-215,h,379488,455383,88)}w=j?0:c;switch(r|0){case 0:{c=(f[s>>2]|0)+(w<<3)|0;E=f[c+4>>2]|0;F=f[c>>2]|0;J=E;u=d;return F|0}case 2:{G=+p[(f[t>>2]|0)+(w<<3)>>3];if(!(+BLc(G,h)==0.0)){t=$Xc(16)|0;f[i>>2]=t;f[i+8>>2]=-2147483632;f[i+4>>2]=15;B=t;C=373419;D=B+15|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[t+15>>0]=0;vM(-215,i,379488,455383,101)}E=+L(G)>=1.0?(G>0.0?~~+Z(+K(G/4294967296.0),4294967295.0)>>>0:~~+X((G-+(~~G>>>0))/4294967296.0)>>>0):0;F=~~G>>>0;J=E;u=d;return F|0}case 3:{i=(f[v>>2]|0)+(w*12|0)|0;if((b[i+11>>0]|0)<0)H=f[i>>2]|0;else H=i;i=jLc(H)|0;E=((i|0)<0)<<31>>31;F=i;J=E;u=d;return F|0}default:if((r|2|0)==2){E=0;F=0;J=E;u=d;return F|0}else{F=$Xc(48)|0;f[h>>2]=F;f[h+8>>2]=-2147483600;f[h+4>>2]=33;B=F;C=373435;D=B+33|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[F+33>>0]=0;vM(-215,h,379488,455383,111)}}return 0}function NGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0;d=u;u=u+32|0;e=d+8|0;g=d;h=d+12|0;i=(c|0)==-1;if(i){j=f[a>>2]|0;switch(j|0){case 0:{k=f[a+4>>2]|0;l=k+4|0;m=k;n=k;o=k;break}case 3:{k=f[a+4>>2]|0;l=k+4|0;m=k;n=k;o=k;break}case 2:{k=f[a+4>>2]|0;l=k+4|0;m=k;n=k;o=k;break}default:{f[g>>2]=j;DM(h,455363,g);vM(-3,h,470867,455383,297)}}if((f[l>>2]|0)==1){q=j;r=m;s=n;t=o}else v=15}else if((c|0)>-1){o=f[a>>2]|0;switch(o|0){case 0:{n=f[a+4>>2]|0;w=n+4|0;x=n;y=n;z=n;break}case 3:{n=f[a+4>>2]|0;w=n+4|0;x=n;y=n;z=n;break}case 2:{n=f[a+4>>2]|0;w=n+4|0;x=n;y=n;z=n;break}default:{f[e>>2]=o;DM(h,455363,e);vM(-3,h,470867,455383,297)}}if((f[w>>2]|0)>(c|0)){q=o;r=x;s=y;t=z}else v=15}else v=15;if((v|0)==15){v=$Xc(64)|0;f[h>>2]=v;f[h+8>>2]=-2147483584;f[h+4>>2]=56;A=v;B=373328;C=A+56|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[v+56>>0]=0;vM(-215,h,379488,455383,142)}v=i?0:c;switch(q|0){case 2:{D=+p[(f[r>>2]|0)+(v<<3)>>3];u=d;return +D}case 0:{r=(f[s>>2]|0)+(v<<3)|0;D=+((f[r>>2]|0)>>>0)+4294967296.0*+(f[r+4>>2]|0);u=d;return +D}case 3:{r=(f[t>>2]|0)+(v*12|0)|0;if((b[r+11>>0]|0)<0)E=f[r>>2]|0;else E=r;D=+$Kc(E);u=d;return +D}default:{d=$Xc(48)|0;f[h>>2]=d;f[h+8>>2]=-2147483600;f[h+4>>2]=33;A=d;B=373385;C=A+33|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[d+33>>0]=0;vM(-215,h,379488,455383,159)}}return +(0.0)}function OGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,q=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){l=+n[d>>2];f[g>>2]=2;m=$Xc(16)|0;o=m+8|0;f[m>>2]=o;f[m+4>>2]=1;f[g+4>>2]=m;p[o>>3]=l;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}l=+n[d>>2];f[j>>2]=2;k=$Xc(16)|0;o=k+8|0;f[k>>2]=o;f[k+4>>2]=1;f[j+4>>2]=k;p[o>>3]=l;lYc(i,c);c=i+12|0;VGa(c,j);o=WGa(a,g,i)|0;if(!(f[o>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[o>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)q=g;else{f[a>>2]=k;q=f[o>>2]|0}UQ(f[a+4>>2]|0,q);q=a+8|0;f[q>>2]=(f[q>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function PGa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h+12|0;j=h;k=f[a+208>>2]|0;l=(f[a+212>>2]|0)-k|0;a=k;a:do if((l|0)>0){k=b[c+11>>0]|0;m=k<<24>>24<0;n=m?f[c+4>>2]|0:k&255;k=m?f[c>>2]|0:c;m=(n|0)==0;o=(l>>>0)/20|0;b:while(1){p=o+-1|0;q=a+(p*20|0)|0;r=b[q+11>>0]|0;s=r<<24>>24<0;t=r&255;do if(((s?f[a+(p*20|0)+4>>2]|0:t)|0)==(n|0)){r=f[q>>2]|0;v=s?r:q;if(s){if(m)break b;if(!(WKc(v,k,n)|0))break b;else break}if(m)break b;if((r&255)<<24>>24==(b[k>>0]|0)){r=q;v=t;w=k;do{v=v+-1|0;r=r+1|0;if(!v){x=12;break b}w=w+1|0}while((b[r>>0]|0)==(b[w>>0]|0))}}while(0);if((o|0)>1)o=p;else break a}if((x|0)==12?(o|0)<1:0)break;YOa(g,f[a+(p*20|0)+12>>2]|0,f[a+(p*20|0)+16>>2]|0,d,e);u=h;return}while(0);SGa(j,391160,c);c=AYc(j,505469)|0;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-204,i,391185,373013,435)}function QGa(a,c){a=a|0;c=c|0;if(!c)return;QGa(a,f[c>>2]|0);QGa(a,f[c+4>>2]|0);a=c+16|0;RGa(c+28|0);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function RGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;switch(f[a>>2]|0){case 0:{c=f[a+4>>2]|0;if(!c)return;d=f[c>>2]|0;if(!((d|0)==(c+8|0)|(d|0)==0))dYc(d);cYc(c);return}case 3:{c=f[a+4>>2]|0;if(!c)return;d=f[c>>2]|0;e=c+8|0;if((d|0)!=(e|0)){if(d|0){g=d+-4|0;h=f[g>>2]|0;if(h|0){i=d+(h*12|0)|0;do{i=i+-12|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}while((i|0)!=(d|0))}dYc(g)}f[c>>2]=e;f[c+4>>2]=1}if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(c);return}case 2:{c=f[a+4>>2]|0;if(!c)return;a=f[c>>2]|0;if(!((a|0)==(c+8|0)|(a|0)==0))dYc(a);cYc(c);return}default:return}}function SGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=dJc(c)|0;g=b[d+11>>0]|0;h=g<<24>>24<0;i=h?f[d+4>>2]|0:g&255;g=i+e|0;if(g>>>0>4294967279)jYc(a);if(g>>>0<11){b[a+11>>0]=e;j=a}else{k=g+16&-16;g=$Xc(k)|0;f[a>>2]=g;f[a+8>>2]=k|-2147483648;f[a+4>>2]=e;j=g}if(e|0)o1c(j|0,c|0,e|0)|0;b[j+e>>0]=0;zYc(a,h?f[d>>2]|0:d,i)|0;return}function TGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function UGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((b|0)==(a|0))return a|0;switch(f[b>>2]|0){case 0:{c=$Xc(16)|0;d=f[b+4>>2]|0;e=c+8|0;f[c>>2]=e;g=c+4|0;f[g>>2]=1;h=f[d+4>>2]|0;f[g>>2]=h;if(h>>>0<=1){if(h|0){i=e;j=6}}else{e=bYc(h>>>0>536870911?-1:h<<3)|0;f[c>>2]=e;i=e;j=6}if((j|0)==6){e=f[d>>2]|0;d=0;do{g=e+(d<<3)|0;k=f[g+4>>2]|0;l=i+(d<<3)|0;f[l>>2]=f[g>>2];f[l+4>>2]=k;d=d+1|0}while(d>>>0<h>>>0)}RGa(a);f[a+4>>2]=c;break}case 3:{c=$Xc(20)|0;h=f[b+4>>2]|0;d=c+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[c>>2]=d;d=c+4|0;f[d>>2]=1;YGa(c,f[h+4>>2]|0);if(f[d>>2]|0){i=0;do{oYc((f[c>>2]|0)+(i*12|0)|0,(f[h>>2]|0)+(i*12|0)|0)|0;i=i+1|0}while(i>>>0<(f[d>>2]|0)>>>0)}RGa(a);f[a+4>>2]=c;break}case 2:{c=$Xc(16)|0;d=f[b+4>>2]|0;i=c+8|0;f[c>>2]=i;h=c+4|0;f[h>>2]=1;e=f[d+4>>2]|0;f[h>>2]=e;if(e>>>0<=1){if(e|0){m=i;j=16}}else{i=bYc(e>>>0>536870911?-1:e<<3)|0;f[c>>2]=i;m=i;j=16}if((j|0)==16){j=f[d>>2]|0;d=0;do{p[m+(d<<3)>>3]=+p[j+(d<<3)>>3];d=d+1|0}while(d>>>0<e>>>0)}RGa(a);f[a+4>>2]=c;break}default:{}}f[a>>2]=f[b>>2];return a|0}function VGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=f[b>>2];switch(f[b>>2]|0){case 0:{c=$Xc(16)|0;d=f[b+4>>2]|0;e=c+8|0;f[c>>2]=e;g=c+4|0;f[g>>2]=1;h=f[d+4>>2]|0;f[g>>2]=h;if(h>>>0<=1){if(h|0){i=e;j=5}}else{e=bYc(h>>>0>536870911?-1:h<<3)|0;f[c>>2]=e;i=e;j=5}if((j|0)==5){e=f[d>>2]|0;d=0;do{g=e+(d<<3)|0;k=f[g+4>>2]|0;l=i+(d<<3)|0;f[l>>2]=f[g>>2];f[l+4>>2]=k;d=d+1|0}while(d>>>0<h>>>0)}f[a+4>>2]=c;return}case 3:{c=$Xc(20)|0;h=f[b+4>>2]|0;d=c+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[c>>2]=d;d=c+4|0;f[d>>2]=1;YGa(c,f[h+4>>2]|0);if(f[d>>2]|0){i=0;do{oYc((f[c>>2]|0)+(i*12|0)|0,(f[h>>2]|0)+(i*12|0)|0)|0;i=i+1|0}while(i>>>0<(f[d>>2]|0)>>>0)}f[a+4>>2]=c;return}case 2:{c=$Xc(16)|0;d=f[b+4>>2]|0;b=c+8|0;f[c>>2]=b;i=c+4|0;f[i>>2]=1;h=f[d+4>>2]|0;f[i>>2]=h;if(h>>>0<=1){if(h|0){m=b;j=15}}else{b=bYc(h>>>0>536870911?-1:h<<3)|0;f[c>>2]=b;m=b;j=15}if((j|0)==15){j=f[d>>2]|0;d=0;do{p[m+(d<<3)>>3]=+p[j+(d<<3)>>3];d=d+1|0}while(d>>>0<h>>>0)}f[a+4>>2]=c;return}default:return}}function WGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function XGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;e=$Xc(36)|0;f[a>>2]=e;f[a+4>>2]=c+4;c=a+8|0;b[c>>0]=0;a=e+16|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;VGa(e+28|0,d+12|0);b[c>>0]=1;return}function YGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;if((f[d>>2]|0)>>>0>=c>>>0){f[d>>2]=c;return}e=f[a>>2]|0;g=a+8|0;if((e|0)!=(g|0)){if(e|0){h=e+-4|0;i=f[h>>2]|0;if(i|0){j=e+(i*12|0)|0;do{j=j+-12|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(e|0))}dYc(h)}f[a>>2]=g;f[d>>2]=1}f[d>>2]=c;if(c>>>0<=1)return;d=c*12|0;g=bYc(c>>>0>357913941|d>>>0>4294967291?-1:d+4|0)|0;f[g>>2]=c;c=g+4|0;g=d+-12|0;g1c(c|0,0,g-((g>>>0)%12|0)+12|0)|0;f[a>>2]=c;return}function ZGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function _Ga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;oYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;oYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function $Ga(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){VGa(g,d);UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}VGa(j,d);lYc(i,c);c=i+12|0;VGa(c,j);k=WGa(a,g,i)|0;if(!(f[k>>2]|0)){XGa(h,a,i);l=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=l;f[k>>2]=g;l=f[f[a>>2]>>2]|0;if(!l)m=g;else{f[a>>2]=l;m=f[k>>2]|0}UQ(f[a+4>>2]|0,m);m=a+8|0;f[m>>2]=(f[m>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function aHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){l=f[d>>2]|0;f[g>>2]=0;m=$Xc(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[g+4>>2]=m;m=n;f[m>>2]=l;f[m+4>>2]=((l|0)<0)<<31>>31;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}k=f[d>>2]|0;f[j>>2]=0;l=$Xc(16)|0;m=l+8|0;f[l>>2]=m;f[l+4>>2]=1;f[j+4>>2]=l;l=m;f[l>>2]=k;f[l+4>>2]=((k|0)<0)<<31>>31;lYc(i,c);c=i+12|0;VGa(c,j);k=WGa(a,g,i)|0;if(!(f[k>>2]|0)){XGa(h,a,i);l=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=l;f[k>>2]=g;l=f[f[a>>2]>>2]|0;if(!l)o=g;else{f[a>>2]=l;o=f[k>>2]|0}UQ(f[a+4>>2]|0,o);o=a+8|0;f[o>>2]=(f[o>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function bHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){l=f[d>>2]|0;f[g>>2]=0;m=$Xc(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[g+4>>2]=m;m=n;f[m>>2]=l;f[m+4>>2]=0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}k=f[d>>2]|0;f[j>>2]=0;m=$Xc(16)|0;l=m+8|0;f[m>>2]=l;f[m+4>>2]=1;f[j+4>>2]=m;m=l;f[m>>2]=k;f[m+4>>2]=0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)o=g;else{f[a>>2]=k;o=f[m>>2]|0}UQ(f[a+4>>2]|0,o);o=a+8|0;f[o>>2]=(f[o>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function cHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){l=b[d>>0]|0;f[g>>2]=0;m=$Xc(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[g+4>>2]=m;m=n;f[m>>2]=l&255;f[m+4>>2]=0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}k=b[d>>0]|0;f[j>>2]=0;m=$Xc(16)|0;l=m+8|0;f[m>>2]=l;f[m+4>>2]=1;f[j+4>>2]=m;m=l;f[m>>2]=k&255;f[m+4>>2]=0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)o=g;else{f[a>>2]=k;o=f[m>>2]|0}UQ(f[a+4>>2]|0,o);o=a+8|0;f[o>>2]=(f[o>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function dHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){l=+p[d>>3];f[g>>2]=2;m=$Xc(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[g+4>>2]=m;p[n>>3]=l;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}l=+p[d>>3];f[j>>2]=2;k=$Xc(16)|0;n=k+8|0;f[k>>2]=n;f[k+4>>2]=1;f[j+4>>2]=k;p[n>>3]=l;lYc(i,c);c=i+12|0;VGa(c,j);n=WGa(a,g,i)|0;if(!(f[n>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[n>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)o=g;else{f[a>>2]=k;o=f[n>>2]|0}UQ(f[a+4>>2]|0,o);o=a+8|0;f[o>>2]=(f[o>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function eHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=$Xc(20)|0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=e;f[d+4>>2]=1;YGa(d,c);f[a>>2]=3;e=a+4|0;f[e>>2]=d;if((c|0)<=0)return;a=f[b>>2]|0;g=0;h=d;d=a;i=a;while(1){oYc((f[h>>2]|0)+(g*12|0)|0,f[i>>2]|0)|0;a=d+4|0;f[b>>2]=a;j=g+1|0;if((j|0)>=(c|0))break;g=j;h=f[e>>2]|0;d=a;i=a}return}function fHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=$Xc(20)|0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=e;f[d+4>>2]=1;YGa(d,c);f[a>>2]=3;e=a+4|0;f[e>>2]=d;if((c|0)<=0)return;a=0;g=f[b>>2]|0;h=d;while(1){oYc((f[h>>2]|0)+(a*12|0)|0,g)|0;d=g+12|0;f[b>>2]=d;i=a+1|0;if((i|0)>=(c|0))break;a=i;g=d;h=f[e>>2]|0}return}function gHa(a){a=a|0;cYc(a);return}function hHa(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&4095](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function iHa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+240|0;i=h+8|0;j=h;Kjb(i);k=i+104|0;Kjb(k);f[i+208>>2]=0;l=i+212|0;f[l>>2]=0;f[i+216>>2]=0;f[i+224>>2]=0;f[i+228>>2]=0;m=i+224|0;f[i+220>>2]=m;iIa(c,d,i);if((e|0)!=0&(g|0)!=0)kIa(e,g,k);oOa(a);f[j>>2]=f[a>>2];g=f[a+4>>2]|0;f[j+4>>2]=g;if(g|0)TXc(g);FGa(i,j);ROa(j);EGa(i+220|0,f[m>>2]|0);m=i+208|0;j=f[m>>2]|0;if(!j){Qjb(k);Qjb(i);u=h;return}g=f[l>>2]|0;if((g|0)==(j|0))n=j;else{a=g;while(1){g=a+-20|0;f[l>>2]=g;if((b[g+11>>0]|0)<0){cYc(f[g>>2]|0);o=f[l>>2]|0}else o=g;if((o|0)==(j|0))break;else a=o}n=f[m>>2]|0}cYc(n);Qjb(k);Qjb(i);u=h;return}function jHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[b>>2]|0;e=f[c>>2]|0;g=f[c+4>>2]|0;iHa(a,d,(f[b+4>>2]|0)-d|0,(e|0)==(g|0)?0:e,g-e|0);return}function kHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+112|0;e=d;Kjb(e);lHa(a,e);Ujb(c);a=e+8|0;do if(f[a>>2]&1|0){g=f[e+92>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;h=c+92|0;i=f[h>>2]|0;if((i|0)==537368){mHa(h,g);break}else{oYc(i,g)|0;break}}while(0);g=e+20|0;if((f[g>>2]|0)>0){i=e+28|0;h=0;j=1;while(1){k=f[(f[i>>2]|0)+4+(h<<2)>>2]|0;l=j&(oHa(k,nHa(c)|0)|0);h=h+1|0;if((h|0)>=(f[g>>2]|0)){m=l;break}else j=l}}else m=1;j=e+36|0;if((f[j>>2]|0)>0){g=e+44|0;h=c+32|0;i=0;do{l=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;oYc(pHa(h)|0,l)|0;i=i+1|0}while((i|0)<(f[j>>2]|0))}j=e+48|0;if((f[j>>2]|0)>0){i=e+56|0;h=c+48|0;g=c+52|0;l=c+56|0;k=0;do{n=f[(f[i>>2]|0)+4+(k<<2)>>2]|0;o=f[h>>2]|0;if((o|0)==(f[g>>2]|0)){qHa(h,o+1|0);p=f[h>>2]|0}else p=o;o=f[l>>2]|0;f[h>>2]=p+1;f[o+4+(p<<2)>>2]=n;k=k+1|0}while((k|0)<(f[j>>2]|0))}if(!(f[a>>2]&4)){Qjb(e);u=d;return m|0}a=b[e+100>>0]|0;j=c+8|0;f[j>>2]=f[j>>2]|4;b[c+100>>0]=a;Qjb(e);u=d;return m|0}function lHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;d=u;u=u+192|0;e=d+168|0;g=d;Ujb(c);alb(c,a);h=c+20|0;i=f[h>>2]|0;if((i|0)>0){j=f[c+28>>2]|0;k=0;do{A0a(f[j+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)!=(i|0));f[h>>2]=0}f[e+4>>2]=0;f[e+8>>2]=0;i=e+4|0;f[e>>2]=i;k=a+36|0;if((f[k>>2]|0)>0){j=a+44|0;l=0;do{m=IGa(e,f[(f[j>>2]|0)+4+(l<<2)>>2]|0)|0;f[m>>2]=-1;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=a+20|0;if((f[k>>2]|0)<=0){n=e;o=f[i>>2]|0;EGa(n,o);u=d;return}l=a+28|0;a=g+21|0;j=g+32|0;m=g+24|0;p=g+88|0;q=g+36|0;r=g+68|0;s=r+11|0;t=g+21|0;v=g+32|0;w=g+24|0;x=g+88|0;y=g+36|0;z=g+68|0;A=z+11|0;B=g+21|0;C=g+32|0;D=g+24|0;E=g+88|0;F=g+36|0;G=g+68|0;H=G+11|0;I=g+21|0;J=g+32|0;K=g+24|0;L=g+88|0;M=g+36|0;N=g+68|0;O=N+11|0;P=g+21|0;Q=g+32|0;R=g+24|0;S=g+88|0;T=g+36|0;U=g+68|0;V=U+11|0;W=c+28|0;X=0;do{Y=f[(f[l>>2]|0)+4+(X<<2)>>2]|0;Z=f[Y+164>>2]|0;_=(Z|0?Z:534768)+60|0;Z=f[_>>2]|0;$=b[Z+11>>0]|0;if(!((($<<24>>24<0?f[Z+4>>2]|0:$&255)|0)==7?!(LYc(Z,0,-1,435010,7)|0):0))Jlb(nHa(c)|0,Y);Z=Y+20|0;if((f[Z>>2]|0)>0){$=Y+28|0;aa=0;do{ba=f[(f[$>>2]|0)+4+(aa<<2)>>2]|0;if((CHa(e,ba)|0)==(i|0)){vHa(g,373703,375255,235,518794,0,1);ca=ba+11|0;da=ba+4|0;while(1){if(!(b[a>>0]|0))break;ea=BM(j,375278,19)|0;fa=b[ca>>0]|0;ga=fa<<24>>24<0;nOc(BM(BM(ea,ga?f[ba>>2]|0:ba,ga?f[da>>2]|0:fa&255)|0,375298,10)|0,aa)|0;wHa(g)}f[m>>2]=35856;f[p>>2]=35896;f[j>>2]=35876;f[q>>2]=35912;if((b[s>>0]|0)<0)cYc(f[r>>2]|0);LMc(q);TNc(m,35972);GMc(p)}da=IGa(e,ba)|0;ca=f[da>>2]|0;if(((ca|0)!=-1?(da=f[(f[l>>2]|0)+4+(ca<<2)>>2]|0,ca=da+164|0,fa=f[ca>>2]|0,ga=f[(fa|0?fa:534768)+60>>2]|0,fa=b[ga+11>>0]|0,((fa<<24>>24<0?f[ga+4>>2]|0:fa&255)|0)==7):0)?(LYc(ga,0,-1,435010,7)|0)==0:0){ga=f[_>>2]|0;fa=b[ga+11>>0]|0;ea=f[ga+4>>2]|0;if(((fa<<24>>24<0?ea:fa&255)|0)==4)if(!(LYc(ga,0,-1,373778,4)|0))ha=1;else{ia=f[_>>2]|0;ja=b[ia+11>>0]|0;ka=f[ia+4>>2]|0;la=ia;ma=32}else{ja=fa;ka=ea;la=ga;ma=32}if((ma|0)==32){ma=0;if(((ja<<24>>24<0?ka:ja&255)|0)==4)ha=(LYc(la,0,-1,373978,4)|0)==0;else ha=0}vHa(g,373703,375255,247,427598,375309,ha);while(1){if(!(b[t>>0]|0))break;ga=BM(v,375407,66)|0;ea=f[_>>2]|0;fa=b[ea+11>>0]|0;ia=fa<<24>>24<0;BM(ga,ia?f[ea>>2]|0:ea,ia?f[ea+4>>2]|0:fa&255)|0;wHa(g)}f[w>>2]=35856;f[x>>2]=35896;f[v>>2]=35876;f[y>>2]=35912;if((b[A>>0]|0)<0)cYc(f[z>>2]|0);LMc(y);TNc(w,35972);GMc(x);vHa(g,373703,375255,251,427598,375374,(f[Z>>2]|0)==1);while(1){if(!(b[B>>0]|0))break;BM(C,375503,40)|0;wHa(g)}f[D>>2]=35856;f[E>>2]=35896;f[C>>2]=35876;f[F>>2]=35912;if((b[H>>0]|0)<0)cYc(f[G>>2]|0);LMc(F);TNc(D,35972);GMc(E);vHa(g,373703,375255,253,427598,375474,(f[da+20>>2]|0)==1);while(1){if(!(b[I>>0]|0))break;BM(J,375570,43)|0;wHa(g)}f[K>>2]=35856;f[L>>2]=35896;f[J>>2]=35876;f[M>>2]=35912;if((b[O>>0]|0)<0)cYc(f[N>>2]|0);LMc(M);TNc(K,35972);GMc(L);vHa(g,373703,375255,255,427598,375544,(f[da+36>>2]|0)==1);while(1){if(!(b[P>>0]|0))break;BM(Q,375614,47)|0;wHa(g)}f[R>>2]=35856;f[S>>2]=35896;f[Q>>2]=35876;f[T>>2]=35912;if((b[V>>0]|0)<0)cYc(f[U>>2]|0);LMc(T);TNc(R,35972);GMc(S);ba=(f[h>>2]|0)+-1|0;fa=f[(f[W>>2]|0)+4+(ba<<2)>>2]|0;ea=fa+8|0;f[ea>>2]=f[ea>>2]|2;ea=fa+164|0;ia=f[ea>>2]|0;if(!ia){ga=$Xc(196)|0;r0a(ga);f[ea>>2]=ga;na=ga;oa=f[(f[W>>2]|0)+4+(ba<<2)>>2]|0}else{na=ia;oa=fa}fa=f[ca>>2]|0;ia=f[(fa|0?fa:534768)+92>>2]|0;fa=na+8|0;f[fa>>2]=f[fa>>2]|512;f[na+92>>2]=ia;oYc(f[(f[oa+28>>2]|0)+4+(aa<<2)>>2]|0,f[(f[da+28>>2]|0)+4>>2]|0)|0}aa=aa+1|0}while((aa|0)<(f[Z>>2]|0))}Z=Y+36|0;if((f[Z>>2]|0)>0){aa=Y+44|0;_=0;do{$=IGa(e,f[(f[aa>>2]|0)+4+(_<<2)>>2]|0)|0;f[$>>2]=X;_=_+1|0}while((_|0)<(f[Z>>2]|0))}X=X+1|0}while((X|0)<(f[k>>2]|0));n=e;o=f[i>>2]|0;EGa(n,o);u=d;return}function mHa(a,b){a=a|0;b=b|0;var c=0;c=$Xc(12)|0;lYc(c,b);f[a>>2]=c;return}function nHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+16|0;c=a+28|0;d=f[c>>2]|0;do if(!d){e=a+20|0;g=f[a+24>>2]|0;h=6}else{i=a+20|0;j=f[i>>2]|0;k=f[d>>2]|0;if((j|0)>=(k|0))if((k|0)==(f[a+24>>2]|0)){e=i;g=k;h=6;break}else{l=i;m=k;n=d;break}f[i>>2]=j+1;o=f[d+4+(j<<2)>>2]|0;return o|0}while(0);if((h|0)==6){XZb(b,g+1|0);g=f[c>>2]|0;l=e;m=f[g>>2]|0;n=g}f[n>>2]=m+1;m=f[b>>2]|0;if(!m){b=$Xc(296)|0;Iab(b);p=b}else{if(f[m+64>>2]|0)SXb(m,15824,296);b=RXb(m,296,2232)|0;Iab(b);p=b}b=f[c>>2]|0;c=f[l>>2]|0;f[l>>2]=c+1;f[b+4+(c<<2)>>2]=p;o=p;return o|0}function oHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0;d=u;u=u+176|0;e=d;if(!a){g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=28;h=g;i=373650;j=h+28|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+28>>0]=0;vM(-215,e,373679,373703,273)}A0a(c);g=a+20|0;if((f[g>>2]|0)>0){i=a+28|0;h=c+16|0;j=0;do{k=f[(f[i>>2]|0)+4+(j<<2)>>2]|0;oYc(pHa(h)|0,k)|0;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=a+36|0;if((f[g>>2]|0)>0){j=a+44|0;h=c+32|0;i=0;do{k=f[(f[j>>2]|0)+4+(i<<2)>>2]|0;oYc(pHa(h)|0,k)|0;i=i+1|0}while((i|0)<(f[g>>2]|0))}if(!(f[a+8>>2]&2)){l=1;u=d;return l|0}g=f[a+164>>2]|0;i=g|0?g:534768;g=i+8|0;do if(f[g>>2]&1|0){h=f[i+56>>2]|0;j=c+8|0;f[j>>2]=f[j>>2]|1;j=c+160|0;k=f[j>>2]|0;if((k|0)==537368){mHa(j,h);break}else{oYc(k,h)|0;break}}while(0);h=f[i+60>>2]|0;if(f[g>>2]&2|0){k=sHa(h)|0;j=c+12|0;f[j>>2]=f[j>>2]|1;f[c+288>>2]=k}k=c+48|0;j=a+48|0;do if((c|0)!=(a|0))if((f[j>>2]|0)==(f[k>>2]|0)){m=c+60|0;n=a+60|0;o=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=o;o=c+52|0;n=a+52|0;m=f[o>>2]|0;f[o>>2]=f[n>>2];f[n>>2]=m;m=c+56|0;n=a+56|0;o=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=o;break}else{tHa(k,j);break}while(0);j=i+32|0;if((f[j>>2]|0)>0){k=i+40|0;a=c+64|0;o=c+68|0;n=c+72|0;m=0;p=f[a>>2]|0;do{q=f[(f[k>>2]|0)+4+(m<<2)>>2]|0;if((p|0)==(f[o>>2]|0)){uHa(a,p+1|0);r=f[a>>2]|0}else r=p;s=f[n>>2]|0;p=r+1|0;f[a>>2]=p;f[s+4+(r<<2)>>2]=q;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=i+44|0;if((f[j>>2]|0)>0){m=i+52|0;r=c+76|0;p=c+80|0;a=c+84|0;n=0;o=f[r>>2]|0;do{k=f[(f[m>>2]|0)+4+(n<<2)>>2]|0;if((o|0)==(f[p>>2]|0)){uHa(r,o+1|0);t=f[r>>2]|0}else t=o;q=f[a>>2]|0;o=t+1|0;f[r>>2]=o;f[q+4+(t<<2)>>2]=k;n=n+1|0}while((n|0)<(f[j>>2]|0))}a:do if(!(f[g>>2]&256))v=1;else{j=h+11|0;n=b[j>>0]|0;t=h+4|0;o=f[t>>2]|0;do if(((n<<24>>24<0?o:n&255)|0)==4){if(LYc(h,0,-1,373778,4)|0){w=b[j>>0]|0;x=f[t>>2]|0;break}r=c+8|0;f[r>>2]=f[r>>2]|8;r=c+172|0;a=f[r>>2]|0;if(!a){p=$Xc(120)|0;O0a(p);f[r>>2]=p;y=p}else y=a;a=f[i+88>>2]|0;p=y+8|0;f[p>>2]=f[p>>2]|4;f[y+72>>2]=a;v=1;break a}else{w=n;x=o}while(0);if(((w<<24>>24<0?x:w&255)|0)==12?(LYc(h,0,-1,373783,12)|0)==0:0){o=c+8|0;f[o>>2]=f[o>>2]|1024;o=c+200|0;n=f[o>>2]|0;if(!n){a=$Xc(36)|0;Y0a(a);f[o>>2]=a;z=a}else z=n;n=f[i+88>>2]|0;a=z+8|0;f[a>>2]=f[a>>2]|4;f[z+24>>2]=n;v=1;break}vHa(e,373703,373679,307,518806,0,1);n=e+21|0;a=e+32|0;while(1){if(!(b[n>>0]|0))break;o=BM(a,373796,44)|0;p=b[j>>0]|0;r=p<<24>>24<0;BM(o,r?f[h>>2]|0:h,r?f[t>>2]|0:p&255)|0;wHa(e)}t=e+24|0;f[t>>2]=35856;j=e+88|0;f[j>>2]=35896;f[a>>2]=35876;n=e+36|0;f[n>>2]=35912;p=e+68|0;if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);LMc(n);TNc(t,35972);GMc(j);v=0}while(0);b:do if(!(f[g>>2]&8388608))A=v;else{z=h+11|0;w=b[z>>0]|0;x=h+4|0;y=f[x>>2]|0;do if(((w<<24>>24<0?y:w&255)|0)==4){if(LYc(h,0,-1,373778,4)|0){B=b[z>>0]|0;C=f[x>>2]|0;break}j=c+8|0;f[j>>2]=f[j>>2]|8;j=c+172|0;t=f[j>>2]|0;if(!t){n=$Xc(120)|0;O0a(n);f[j>>2]=n;D=n}else D=t;t=b[i+144>>0]|0;n=D+8|0;f[n>>2]=f[n>>2]|4096;b[D+112>>0]=t;A=v;break b}else{B=w;C=y}while(0);if(((B<<24>>24<0?C:B&255)|0)==12?(LYc(h,0,-1,373783,12)|0)==0:0){y=c+8|0;f[y>>2]=f[y>>2]|1024;y=c+200|0;w=f[y>>2]|0;if(!w){a=$Xc(36)|0;Y0a(a);f[y>>2]=a;E=a}else E=w;w=b[i+144>>0]|0;a=E+8|0;f[a>>2]=f[a>>2]|16;b[E+29>>0]=w;A=v;break}vHa(e,373703,373679,319,518806,0,1);w=e+21|0;a=e+32|0;while(1){if(!(b[w>>0]|0))break;y=BM(a,373841,42)|0;t=b[z>>0]|0;n=t<<24>>24<0;BM(y,n?f[h>>2]|0:h,n?f[x>>2]|0:t&255)|0;wHa(e)}x=e+24|0;f[x>>2]=35856;z=e+88|0;f[z>>2]=35896;f[a>>2]=35876;w=e+36|0;f[w>>2]=35912;t=e+68|0;if((b[t+11>>0]|0)<0)cYc(f[t>>2]|0);LMc(w);TNc(x,35972);GMc(z);A=0}while(0);c:do if(!(f[g>>2]&32))F=A;else{v=h+11|0;E=b[v>>0]|0;B=h+4|0;C=f[B>>2]|0;do if(((E<<24>>24<0?C:E&255)|0)==4){if(LYc(h,0,-1,373778,4)|0){G=b[v>>0]|0;H=f[B>>2]|0;break}D=c+8|0;f[D>>2]=f[D>>2]|8;D=c+172|0;z=f[D>>2]|0;if(!z){x=$Xc(120)|0;O0a(x);f[D>>2]=x;I=x}else I=z;z=I+8|0;f[z>>2]=f[z>>2]|1;z=I+64|0;x=f[z>>2]|0;if(!x){D=$Xc(48)|0;__a(D);f[z>>2]=D;J=D}else J=x;x=f[i+76>>2]|0;Zkb(J,x|0?x:531776);F=A;break c}else{G=E;H=C}while(0);if(((G<<24>>24<0?H:G&255)|0)==12?(LYc(h,0,-1,373783,12)|0)==0:0){C=c+8|0;f[C>>2]=f[C>>2]|1024;C=c+200|0;E=f[C>>2]|0;if(!E){a=$Xc(36)|0;Y0a(a);f[C>>2]=a;K=a}else K=E;E=K+8|0;f[E>>2]=f[E>>2]|1;E=K+16|0;a=f[E>>2]|0;if(!a){C=$Xc(48)|0;__a(C);f[E>>2]=C;L=C}else L=a;a=f[i+76>>2]|0;Zkb(L,a|0?a:531776);F=A;break}vHa(e,373703,373679,331,518806,0,1);a=e+21|0;C=e+32|0;while(1){if(!(b[a>>0]|0))break;E=BM(C,373884,47)|0;x=b[v>>0]|0;D=x<<24>>24<0;BM(E,D?f[h>>2]|0:h,D?f[B>>2]|0:x&255)|0;wHa(e)}B=e+24|0;f[B>>2]=35856;v=e+88|0;f[v>>2]=35896;f[C>>2]=35876;a=e+36|0;f[a>>2]=35912;x=e+68|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);LMc(a);TNc(B,35972);GMc(v);F=0}while(0);d:do if(!(f[g>>2]&64))M=F;else{A=h+11|0;L=b[A>>0]|0;K=h+4|0;G=f[K>>2]|0;do if(((L<<24>>24<0?G:L&255)|0)==4){if(LYc(h,0,-1,373778,4)|0){N=b[A>>0]|0;O=f[K>>2]|0;break}H=c+8|0;f[H>>2]=f[H>>2]|8;H=c+172|0;J=f[H>>2]|0;if(!J){I=$Xc(120)|0;O0a(I);f[H>>2]=I;P=I}else P=J;J=P+8|0;f[J>>2]=f[J>>2]|2;J=P+68|0;I=f[J>>2]|0;if(!I){H=$Xc(48)|0;__a(H);f[J>>2]=H;Q=H}else Q=I;I=f[i+80>>2]|0;Zkb(Q,I|0?I:531776);M=F;break d}else{N=L;O=G}while(0);if(((N<<24>>24<0?O:N&255)|0)==12?(LYc(h,0,-1,373783,12)|0)==0:0){G=c+8|0;f[G>>2]=f[G>>2]|1024;G=c+200|0;L=f[G>>2]|0;if(!L){C=$Xc(36)|0;Y0a(C);f[G>>2]=C;R=C}else R=L;L=R+8|0;f[L>>2]=f[L>>2]|2;L=R+20|0;C=f[L>>2]|0;if(!C){G=$Xc(48)|0;__a(G);f[L>>2]=G;S=G}else S=C;C=f[i+80>>2]|0;Zkb(S,C|0?C:531776);M=F;break}vHa(e,373703,373679,343,518806,0,1);C=e+21|0;G=e+32|0;while(1){if(!(b[C>>0]|0))break;L=BM(G,373932,45)|0;I=b[A>>0]|0;H=I<<24>>24<0;BM(L,H?f[h>>2]|0:h,H?f[K>>2]|0:I&255)|0;wHa(e)}K=e+24|0;f[K>>2]=35856;A=e+88|0;f[A>>2]=35896;f[G>>2]=35876;C=e+36|0;f[C>>2]=35912;I=e+68|0;if((b[I+11>>0]|0)<0)cYc(f[I>>2]|0);LMc(C);TNc(K,35972);GMc(A);M=0}while(0);e:do if(!(f[g>>2]&512))T=M;else{F=h+11|0;S=b[F>>0]|0;R=h+4|0;N=f[R>>2]|0;do if(((S<<24>>24<0?N:S&255)|0)==4){if(LYc(h,0,-1,373778,4)|0){U=b[F>>0]|0;V=f[R>>2]|0;break}O=c+8|0;f[O>>2]=f[O>>2]|8;O=c+172|0;Q=f[O>>2]|0;if(!Q){P=$Xc(120)|0;O0a(P);f[O>>2]=P;W=P}else W=Q;Q=f[i+92>>2]|0;P=W+16|0;O=f[P>>2]|0;if((O|0)==(f[W+20>>2]|0)){xHa(P,O+1|0);X=f[P>>2]|0}else X=O;O=f[W+24>>2]|0;f[P>>2]=X+1;f[O+4+(X<<2)>>2]=Q;T=M;break e}else{U=S;V=N}while(0);if(((U<<24>>24<0?V:U&255)|0)==4?(LYc(h,0,-1,373978,4)|0)==0:0){N=c+8|0;f[N>>2]=f[N>>2]|4096;N=c+208|0;S=f[N>>2]|0;if(!S){G=$Xc(68)|0;a1a(G);f[N>>2]=G;Y=G}else Y=S;S=f[i+92>>2]|0;G=Y+8|0;f[G>>2]=f[G>>2]|4;f[Y+24>>2]=S;T=M;break}vHa(e,373703,373679,353,518806,0,1);S=e+21|0;G=e+32|0;while(1){if(!(b[S>>0]|0))break;N=BM(G,373983,37)|0;Q=b[F>>0]|0;O=Q<<24>>24<0;BM(N,O?f[h>>2]|0:h,O?f[R>>2]|0:Q&255)|0;wHa(e)}R=e+24|0;f[R>>2]=35856;F=e+88|0;f[F>>2]=35896;f[G>>2]=35876;S=e+36|0;f[S>>2]=35912;Q=e+68|0;if((b[Q+11>>0]|0)<0)cYc(f[Q>>2]|0);LMc(S);TNc(R,35972);GMc(F);T=0}while(0);f:do if(!(f[g>>2]&1024))Z=T;else{M=h+11|0;Y=b[M>>0]|0;U=h+4|0;V=f[U>>2]|0;do if(((Y<<24>>24<0?V:Y&255)|0)==4){if(LYc(h,0,-1,373778,4)|0){_=b[M>>0]|0;$=f[U>>2]|0;break}X=c+8|0;f[X>>2]=f[X>>2]|8;X=c+172|0;W=f[X>>2]|0;if(!W){F=$Xc(120)|0;O0a(F);f[X>>2]=F;aa=F}else aa=W;W=f[i+96>>2]|0;F=aa+28|0;X=f[F>>2]|0;if((X|0)==(f[aa+32>>2]|0)){xHa(F,X+1|0);ba=f[F>>2]|0}else ba=X;X=f[aa+36>>2]|0;f[F>>2]=ba+1;f[X+4+(ba<<2)>>2]=W;Z=T;break f}else{_=Y;$=V}while(0);if(((_<<24>>24<0?$:_&255)|0)==4?(LYc(h,0,-1,373978,4)|0)==0:0){V=c+8|0;f[V>>2]=f[V>>2]|4096;V=c+208|0;Y=f[V>>2]|0;if(!Y){G=$Xc(68)|0;a1a(G);f[V>>2]=G;ca=G}else ca=Y;Y=f[i+96>>2]|0;G=ca+8|0;f[G>>2]=f[G>>2]|2;f[ca+20>>2]=Y;Z=T;break}vHa(e,373703,373679,365,518806,0,1);Y=e+21|0;G=e+32|0;while(1){if(!(b[Y>>0]|0))break;V=BM(G,374021,44)|0;W=b[M>>0]|0;X=W<<24>>24<0;BM(V,X?f[h>>2]|0:h,X?f[U>>2]|0:W&255)|0;wHa(e)}U=e+24|0;f[U>>2]=35856;M=e+88|0;f[M>>2]=35896;f[G>>2]=35876;Y=e+36|0;f[Y>>2]=35912;W=e+68|0;if((b[W+11>>0]|0)<0)cYc(f[W>>2]|0);LMc(Y);TNc(U,35972);GMc(M);Z=0}while(0);do if(!(f[g>>2]&16777216))da=Z;else{T=h+11|0;ca=b[T>>0]|0;_=h+4|0;if(((ca<<24>>24<0?f[_>>2]|0:ca&255)|0)==4?(LYc(h,0,-1,373778,4)|0)==0:0){ca=c+8|0;f[ca>>2]=f[ca>>2]|8;ca=c+172|0;$=f[ca>>2]|0;if(!$){ba=$Xc(120)|0;O0a(ba);f[ca>>2]=ba;ea=ba}else ea=$;$=f[i+148>>2]|0;ba=ea+8|0;f[ba>>2]=f[ba>>2]|8192;f[ea+116>>2]=$;da=Z;break}vHa(e,373703,373679,374,518806,0,1);$=e+21|0;ba=e+32|0;while(1){if(!(b[$>>0]|0))break;ca=BM(ba,374066,39)|0;aa=b[T>>0]|0;M=aa<<24>>24<0;BM(ca,M?f[h>>2]|0:h,M?f[_>>2]|0:aa&255)|0;wHa(e)}_=e+24|0;f[_>>2]=35856;T=e+88|0;f[T>>2]=35896;f[ba>>2]=35876;$=e+36|0;f[$>>2]=35912;G=e+68|0;if((b[G+11>>0]|0)<0)cYc(f[G>>2]|0);LMc($);TNc(_,35972);GMc(T);da=0}while(0);g:do if(!(f[g>>2]&33554432))fa=da;else{Z=h+11|0;ea=b[Z>>0]|0;T=h+4|0;_=f[T>>2]|0;do if(((ea<<24>>24<0?_:ea&255)|0)==4){if(LYc(h,0,-1,373778,4)|0){ga=b[Z>>0]|0;ha=f[T>>2]|0;break}$=c+8|0;f[$>>2]=f[$>>2]|8;$=c+172|0;G=f[$>>2]|0;if(!G){aa=$Xc(120)|0;O0a(aa);f[$>>2]=aa;ia=aa}else ia=G;G=f[i+152>>2]|0;aa=ia+40|0;$=f[aa>>2]|0;if(($|0)==(f[ia+44>>2]|0)){xHa(aa,$+1|0);ja=f[aa>>2]|0}else ja=$;$=f[ia+48>>2]|0;f[aa>>2]=ja+1;f[$+4+(ja<<2)>>2]=G;fa=da;break g}else{ga=ea;ha=_}while(0);do if(((ga<<24>>24<0?ha:ga&255)|0)==4){if(LYc(h,0,-1,373978,4)|0)break;_=c+8|0;f[_>>2]=f[_>>2]|4096;_=c+208|0;ea=f[_>>2]|0;if(!ea){ba=$Xc(68)|0;a1a(ba);f[_>>2]=ba;ka=ba}else ka=ea;ea=f[i+152>>2]|0;ba=ka+8|0;f[ba>>2]=f[ba>>2]|2048;f[ka+60>>2]=ea;fa=da;break g}while(0);vHa(e,373703,373679,386,518806,0,1);ea=e+21|0;ba=e+32|0;while(1){if(!(b[ea>>0]|0))break;_=BM(ba,374106,40)|0;G=b[Z>>0]|0;$=G<<24>>24<0;BM(_,$?f[h>>2]|0:h,$?f[T>>2]|0:G&255)|0;wHa(e)}T=e+24|0;f[T>>2]=35856;Z=e+88|0;f[Z>>2]=35896;f[ba>>2]=35876;ea=e+36|0;f[ea>>2]=35912;G=e+68|0;if((b[G+11>>0]|0)<0)cYc(f[G>>2]|0);LMc(ea);TNc(T,35972);GMc(Z);fa=0}while(0);h:do if(!(f[g>>2]&2048))la=fa;else{da=h+11|0;ka=b[da>>0]|0;ga=h+4|0;do if(((ka<<24>>24<0?f[ga>>2]|0:ka&255)|0)==4){if(LYc(h,0,-1,373978,4)|0)break;ha=f[i+100>>2]|0;switch(ha|0){case 0:{ja=c+8|0;f[ja>>2]=f[ja>>2]|4096;ja=c+208|0;ia=f[ja>>2]|0;if(!ia){Z=$Xc(68)|0;a1a(Z);f[ja>>2]=Z;ma=Z}else ma=ia;ia=ma+8|0;f[ia>>2]=f[ia>>2]|1;f[ma+16>>2]=0;la=fa;break h;break}case 1:{ia=c+8|0;f[ia>>2]=f[ia>>2]|4096;ia=c+208|0;Z=f[ia>>2]|0;if(!Z){ja=$Xc(68)|0;a1a(ja);f[ia>>2]=ja;na=ja}else na=Z;Z=na+8|0;f[Z>>2]=f[Z>>2]|1;f[na+16>>2]=1;la=fa;break h;break}case 2:{Z=c+8|0;f[Z>>2]=f[Z>>2]|4096;Z=c+208|0;ja=f[Z>>2]|0;if(!ja){ia=$Xc(68)|0;a1a(ia);f[Z>>2]=ia;oa=ia}else oa=ja;ja=oa+8|0;f[ja>>2]=f[ja>>2]|1;f[oa+16>>2]=2;la=fa;break h;break}default:{vHa(e,373703,373679,407,518806,0,1);ja=e+21|0;ia=e+32|0;while(1){if(!(b[ja>>0]|0))break;nOc(BM(ia,374147,20)|0,ha)|0;wHa(e)}ha=e+24|0;f[ha>>2]=35856;ja=e+88|0;f[ja>>2]=35896;f[ia>>2]=35876;Z=e+36|0;f[Z>>2]=35912;T=e+68|0;if((b[T+11>>0]|0)<0)cYc(f[T>>2]|0);LMc(Z);TNc(ha,35972);GMc(ja);la=0;break h}}}while(0);vHa(e,373703,373679,411,518806,0,1);ka=e+21|0;ba=e+32|0;while(1){if(!(b[ka>>0]|0))break;ja=BM(ba,374168,38)|0;ha=b[da>>0]|0;Z=ha<<24>>24<0;BM(ja,Z?f[h>>2]|0:h,Z?f[ga>>2]|0:ha&255)|0;wHa(e)}ga=e+24|0;f[ga>>2]=35856;da=e+88|0;f[da>>2]=35896;f[ba>>2]=35876;ka=e+36|0;f[ka>>2]=35912;ha=e+68|0;if((b[ha+11>>0]|0)<0)cYc(f[ha>>2]|0);LMc(ka);TNc(ga,35972);GMc(da);la=0}while(0);i:do if(!(f[g>>2]&67108864))pa=la;else{fa=h+11|0;oa=b[fa>>0]|0;na=h+4|0;do if(((oa<<24>>24<0?f[na>>2]|0:oa&255)|0)==7){if(LYc(h,0,-1,374207,7)|0)break;ma=c+8|0;f[ma>>2]=f[ma>>2]|32;ma=c+180|0;da=f[ma>>2]|0;if(!da){ga=$Xc(24)|0;S0a(ga);f[ma>>2]=ga;qa=ga}else qa=da;da=f[i+156>>2]|0;ga=qa+8|0;f[ga>>2]=f[ga>>2]|1;f[qa+16>>2]=da;pa=la;break i}while(0);vHa(e,373703,373679,420,518806,0,1);oa=e+21|0;ba=e+32|0;while(1){if(!(b[oa>>0]|0))break;da=BM(ba,374215,47)|0;ga=b[fa>>0]|0;ma=ga<<24>>24<0;BM(da,ma?f[h>>2]|0:h,ma?f[na>>2]|0:ga&255)|0;wHa(e)}na=e+24|0;f[na>>2]=35856;fa=e+88|0;f[fa>>2]=35896;f[ba>>2]=35876;oa=e+36|0;f[oa>>2]=35912;ga=e+68|0;if((b[ga+11>>0]|0)<0)cYc(f[ga>>2]|0);LMc(oa);TNc(na,35972);GMc(fa);pa=0}while(0);j:do if(!(f[g>>2]&134217728))ra=pa;else{la=h+11|0;qa=b[la>>0]|0;fa=h+4|0;do if(((qa<<24>>24<0?f[fa>>2]|0:qa&255)|0)==3){if(LYc(h,0,-1,374263,3)|0)break;na=c+8|0;f[na>>2]=f[na>>2]|2048;na=c+204|0;oa=f[na>>2]|0;if(!oa){ga=$Xc(40)|0;_0a(ga);f[na>>2]=ga;sa=ga}else sa=oa;oa=f[i+160>>2]|0;ga=sa+8|0;f[ga>>2]=f[ga>>2]|4;f[sa+24>>2]=oa;ra=pa;break j}while(0);vHa(e,373703,373679,429,518806,0,1);qa=e+21|0;ba=e+32|0;while(1){if(!(b[qa>>0]|0))break;oa=BM(ba,374267,44)|0;ga=b[la>>0]|0;na=ga<<24>>24<0;BM(oa,na?f[h>>2]|0:h,na?f[fa>>2]|0:ga&255)|0;wHa(e)}fa=e+24|0;f[fa>>2]=35856;la=e+88|0;f[la>>2]=35896;f[ba>>2]=35876;qa=e+36|0;f[qa>>2]=35912;ga=e+68|0;if((b[ga+11>>0]|0)<0)cYc(f[ga>>2]|0);LMc(qa);TNc(fa,35972);GMc(la);ra=0}while(0);k:do if(!(f[g>>2]&268435456))ta=ra;else{pa=h+11|0;sa=b[pa>>0]|0;la=h+4|0;do if(((sa<<24>>24<0?f[la>>2]|0:sa&255)|0)==3){if(LYc(h,0,-1,374263,3)|0)break;fa=c+8|0;f[fa>>2]=f[fa>>2]|2048;fa=c+204|0;qa=f[fa>>2]|0;if(!qa){ga=$Xc(40)|0;_0a(ga);f[fa>>2]=ga;ua=ga}else ua=qa;qa=f[i+164>>2]|0;ga=ua+8|0;f[ga>>2]=f[ga>>2]|8;f[ua+28>>2]=qa;ta=ra;break k}while(0);vHa(e,373703,373679,437,518806,0,1);sa=e+21|0;ba=e+32|0;while(1){if(!(b[sa>>0]|0))break;qa=BM(ba,374312,39)|0;ga=b[pa>>0]|0;fa=ga<<24>>24<0;BM(qa,fa?f[h>>2]|0:h,fa?f[la>>2]|0:ga&255)|0;wHa(e)}la=e+24|0;f[la>>2]=35856;pa=e+88|0;f[pa>>2]=35896;f[ba>>2]=35876;sa=e+36|0;f[sa>>2]=35912;ga=e+68|0;if((b[ga+11>>0]|0)<0)cYc(f[ga>>2]|0);LMc(sa);TNc(la,35972);GMc(pa);ta=0}while(0);ra=f[g>>2]|0;if(!(ra&536870912)){va=ta;wa=ra}else{ra=h+11|0;ua=b[ra>>0]|0;pa=h+4|0;do if(((ua<<24>>24<0?f[pa>>2]|0:ua&255)|0)==3){if(LYc(h,0,-1,374263,3)|0){xa=249;break}la=c+8|0;f[la>>2]=f[la>>2]|2048;la=c+204|0;sa=f[la>>2]|0;if(!sa){ga=$Xc(40)|0;_0a(ga);f[la>>2]=ga;ya=ga}else ya=sa;sa=f[i+168>>2]|0;ga=ya+8|0;f[ga>>2]=f[ga>>2]|16;f[ya+32>>2]=sa;za=ta}else xa=249;while(0);if((xa|0)==249){vHa(e,373703,373679,445,518806,0,1);xa=e+21|0;ta=e+32|0;while(1){if(!(b[xa>>0]|0))break;ya=BM(ta,374352,38)|0;ua=b[ra>>0]|0;sa=ua<<24>>24<0;BM(ya,sa?f[h>>2]|0:h,sa?f[pa>>2]|0:ua&255)|0;wHa(e)}pa=e+24|0;f[pa>>2]=35856;ra=e+88|0;f[ra>>2]=35896;f[ta>>2]=35876;ta=e+36|0;f[ta>>2]=35912;xa=e+68|0;if((b[xa+11>>0]|0)<0)cYc(f[xa>>2]|0);LMc(ta);TNc(pa,35972);GMc(ra);za=0}va=za;wa=f[g>>2]|0}l:do if((wa|0)<0){za=h+11|0;ra=b[za>>0]|0;pa=h+4|0;do if(((ra<<24>>24<0?f[pa>>2]|0:ra&255)|0)==3){if(LYc(h,0,-1,374263,3)|0)break;ta=c+8|0;f[ta>>2]=f[ta>>2]|2048;ta=c+204|0;xa=f[ta>>2]|0;if(!xa){ua=$Xc(40)|0;_0a(ua);f[ta>>2]=ua;Aa=ua}else Aa=xa;xa=f[i+176>>2]|0;ua=Aa+8|0;f[ua>>2]=f[ua>>2]|32;f[Aa+36>>2]=xa;Ba=va;break l}while(0);vHa(e,373703,373679,453,518806,0,1);ra=e+21|0;ba=e+32|0;while(1){if(!(b[ra>>0]|0))break;xa=BM(ba,374391,35)|0;ua=b[za>>0]|0;ta=ua<<24>>24<0;BM(xa,ta?f[h>>2]|0:h,ta?f[pa>>2]|0:ua&255)|0;wHa(e)}pa=e+24|0;f[pa>>2]=35856;za=e+88|0;f[za>>2]=35896;f[ba>>2]=35876;ra=e+36|0;f[ra>>2]=35912;ua=e+68|0;if((b[ua+11>>0]|0)<0)cYc(f[ua>>2]|0);LMc(ra);TNc(pa,35972);GMc(za);Ba=0}else Ba=va;while(0);m:do if(!(f[g>>2]&4))Ca=Ba;else{va=h+11|0;Aa=b[va>>0]|0;wa=h+4|0;za=f[wa>>2]|0;do if(((Aa<<24>>24<0?za:Aa&255)|0)==4){if(LYc(h,0,-1,374427,4)|0){Da=b[va>>0]|0;Ea=f[wa>>2]|0;break}pa=c+8|0;f[pa>>2]=f[pa>>2]|16;pa=c+176|0;ra=f[pa>>2]|0;if(!ra){ua=$Xc(52)|0;Q0a(ua);f[pa>>2]=ua;Fa=ua}else Fa=ra;ra=f[i+64>>2]|0;ua=Fa+8|0;f[ua>>2]=f[ua>>2]|1;ua=Fa+16|0;pa=f[ua>>2]|0;if((pa|0)==537368){mHa(ua,ra);Ca=Ba;break m}else{oYc(pa,ra)|0;Ca=Ba;break m}}else{Da=Aa;Ea=za}while(0);do if(((Da<<24>>24<0?Ea:Da&255)|0)==9){if(LYc(h,0,-1,374432,9)|0){Ga=b[va>>0]|0;Ha=f[wa>>2]|0;break}za=c+8|0;f[za>>2]=f[za>>2]|64;za=c+184|0;Aa=f[za>>2]|0;if(!Aa){ba=$Xc(28)|0;T0a(ba);f[za>>2]=ba;Ia=ba}else Ia=Aa;Aa=f[i+64>>2]|0;ba=Ia+8|0;f[ba>>2]=f[ba>>2]|1;ba=Ia+16|0;za=f[ba>>2]|0;if((za|0)==537368){mHa(ba,Aa);Ca=Ba;break m}else{oYc(za,Aa)|0;Ca=Ba;break m}}else{Ga=Da;Ha=Ea}while(0);do if(((Ga<<24>>24<0?Ha:Ga&255)|0)==6){if(LYc(h,0,-1,374442,6)|0){Ja=b[va>>0]|0;Ka=f[wa>>2]|0;break}Aa=c+8|0;f[Aa>>2]=f[Aa>>2]|256;Aa=c+192|0;za=f[Aa>>2]|0;if(!za){ba=$Xc(60)|0;V0a(ba);f[Aa>>2]=ba;La=ba}else La=za;za=f[i+64>>2]|0;ba=La+8|0;f[ba>>2]=f[ba>>2]|1;ba=La+16|0;Aa=f[ba>>2]|0;if((Aa|0)==537368){mHa(ba,za);Ca=Ba;break m}else{oYc(Aa,za)|0;Ca=Ba;break m}}else{Ja=Ga;Ka=Ha}while(0);do if(((Ja<<24>>24<0?Ka:Ja&255)|0)==11){if(LYc(h,0,-1,374449,11)|0){Ma=b[va>>0]|0;Na=f[wa>>2]|0;break}za=c+8|0;f[za>>2]=f[za>>2]|8192;za=c+212|0;Aa=f[za>>2]|0;if(!Aa){ba=$Xc(64)|0;c1a(ba);f[za>>2]=ba;Oa=ba}else Oa=Aa;Aa=f[i+64>>2]|0;ba=Oa+8|0;f[ba>>2]=f[ba>>2]|1;ba=Oa+16|0;za=f[ba>>2]|0;if((za|0)==537368){mHa(ba,Aa);Ca=Ba;break m}else{oYc(za,Aa)|0;Ca=Ba;break m}}else{Ma=Ja;Na=Ka}while(0);do if(((Ma<<24>>24<0?Na:Ma&255)|0)==13){if(LYc(h,0,-1,374461,13)|0)break;Aa=c+8|0;f[Aa>>2]=f[Aa>>2]|512;Aa=c+196|0;za=f[Aa>>2]|0;if(!za){ba=$Xc(20)|0;X0a(ba);f[Aa>>2]=ba;Pa=ba}else Pa=za;za=f[i+64>>2]|0;ba=Pa+8|0;f[ba>>2]=f[ba>>2]|1;ba=Pa+16|0;Aa=f[ba>>2]|0;if((Aa|0)==537368){mHa(ba,za);Ca=Ba;break m}else{oYc(Aa,za)|0;Ca=Ba;break m}}while(0);vHa(e,373703,373679,473,518806,0,1);za=e+21|0;Aa=e+32|0;while(1){if(!(b[za>>0]|0))break;ba=BM(Aa,374475,40)|0;ra=b[va>>0]|0;pa=ra<<24>>24<0;BM(ba,pa?f[h>>2]|0:h,pa?f[wa>>2]|0:ra&255)|0;wHa(e)}wa=e+24|0;f[wa>>2]=35856;va=e+88|0;f[va>>2]=35896;f[Aa>>2]=35876;za=e+36|0;f[za>>2]=35912;ra=e+68|0;if((b[ra+11>>0]|0)<0)cYc(f[ra>>2]|0);LMc(za);TNc(wa,35972);GMc(va);Ca=0}while(0);Ba=f[g>>2]|0;if(!(Ba&1073741824))Qa=Ba;else{Ba=c+8|0;f[Ba>>2]=f[Ba>>2]|33554432;Ba=c+260|0;Pa=f[Ba>>2]|0;if(!Pa){Ma=$Xc(44)|0;s1a(Ma);f[Ba>>2]=Ma;Ra=Ma}else Ra=Pa;Pa=f[i+172>>2]|0;Ma=Ra+8|0;f[Ma>>2]=f[Ma>>2]|32;f[Ra+40>>2]=Pa;Qa=f[g>>2]|0}do if(Qa&8|0){Pa=c+8|0;f[Pa>>2]=f[Pa>>2]|33554432;Pa=c+260|0;Ra=f[Pa>>2]|0;if(!Ra){Ma=$Xc(44)|0;s1a(Ma);f[Pa>>2]=Ma;Sa=Ma}else Sa=Ra;Ra=f[i+68>>2]|0;Ma=Sa+8|0;f[Ma>>2]=f[Ma>>2]|1;Ma=Sa+28|0;Pa=f[Ma>>2]|0;if((Pa|0)==537368){mHa(Ma,Ra);break}else{oYc(Pa,Ra)|0;break}}while(0);n:do if(!(f[g>>2]&4096))Ta=Ca;else{Sa=h+11|0;Qa=b[Sa>>0]|0;Ra=h+4|0;Pa=f[Ra>>2]|0;do if(((Qa<<24>>24<0?Pa:Qa&255)|0)==4){if(LYc(h,0,-1,374427,4)|0){Ua=b[Sa>>0]|0;Va=f[Ra>>2]|0;break}Ma=c+8|0;f[Ma>>2]=f[Ma>>2]|16;Ma=c+176|0;Ba=f[Ma>>2]|0;if(!Ba){Na=$Xc(52)|0;Q0a(Na);f[Ma>>2]=Na;Wa=Na}else Wa=Ba;Ba=f[i+104>>2]|0;Na=Wa+8|0;f[Na>>2]=f[Na>>2]|4;f[Wa+24>>2]=Ba;Ta=Ca;break n}else{Ua=Qa;Va=Pa}while(0);do if(((Ua<<24>>24<0?Va:Ua&255)|0)==9){if(LYc(h,0,-1,374432,9)|0){Xa=b[Sa>>0]|0;Ya=f[Ra>>2]|0;break}Pa=c+8|0;f[Pa>>2]=f[Pa>>2]|64;Pa=c+184|0;Qa=f[Pa>>2]|0;if(!Qa){Aa=$Xc(28)|0;T0a(Aa);f[Pa>>2]=Aa;Za=Aa}else Za=Qa;Qa=f[i+104>>2]|0;Aa=Za+8|0;f[Aa>>2]=f[Aa>>2]|2;f[Za+20>>2]=Qa;Ta=Ca;break n}else{Xa=Ua;Ya=Va}while(0);do if(((Xa<<24>>24<0?Ya:Xa&255)|0)==6){if(LYc(h,0,-1,374442,6)|0){_a=b[Sa>>0]|0;$a=f[Ra>>2]|0;break}Qa=c+8|0;f[Qa>>2]=f[Qa>>2]|256;Qa=c+192|0;Aa=f[Qa>>2]|0;if(!Aa){Pa=$Xc(60)|0;V0a(Pa);f[Qa>>2]=Pa;ab=Pa}else ab=Aa;Aa=f[i+104>>2]|0;Pa=ab+8|0;f[Pa>>2]=f[Pa>>2]|2048;f[ab+56>>2]=Aa;Ta=Ca;break n}else{_a=Xa;$a=Ya}while(0);do if(((_a<<24>>24<0?$a:_a&255)|0)==11){if(LYc(h,0,-1,374449,11)|0)break;Aa=c+8|0;f[Aa>>2]=f[Aa>>2]|8192;Aa=c+212|0;Pa=f[Aa>>2]|0;if(!Pa){Qa=$Xc(64)|0;c1a(Qa);f[Aa>>2]=Qa;bb=Qa}else bb=Pa;Pa=f[i+104>>2]|0;Qa=bb+8|0;f[Qa>>2]=f[Qa>>2]|16;f[bb+32>>2]=Pa;Ta=Ca;break n}while(0);vHa(e,373703,373679,499,518806,0,1);Pa=e+21|0;Qa=e+32|0;while(1){if(!(b[Pa>>0]|0))break;Aa=BM(Qa,374516,43)|0;Ba=b[Sa>>0]|0;Na=Ba<<24>>24<0;BM(Aa,Na?f[h>>2]|0:h,Na?f[Ra>>2]|0:Ba&255)|0;wHa(e)}Ra=e+24|0;f[Ra>>2]=35856;Sa=e+88|0;f[Sa>>2]=35896;f[Qa>>2]=35876;Pa=e+36|0;f[Pa>>2]=35912;Ba=e+68|0;if((b[Ba+11>>0]|0)<0)cYc(f[Ba>>2]|0);LMc(Pa);TNc(Ra,35972);GMc(Sa);Ta=0}while(0);Ca=f[g>>2]|0;if(!(Ca&8192))cb=Ca;else{Ca=c+8|0;f[Ca>>2]=f[Ca>>2]|33554432;Ca=c+260|0;bb=f[Ca>>2]|0;if(!bb){_a=$Xc(44)|0;s1a(_a);f[Ca>>2]=_a;db=_a}else db=bb;bb=f[i+108>>2]|0;_a=db+8|0;f[_a>>2]=f[_a>>2]|2;f[db+32>>2]=bb;cb=f[g>>2]|0}if(!(cb&32768))eb=cb;else{cb=c+8|0;f[cb>>2]=f[cb>>2]|33554432;cb=c+260|0;bb=f[cb>>2]|0;if(!bb){db=$Xc(44)|0;s1a(db);f[cb>>2]=db;fb=db}else fb=bb;bb=b[i+116>>0]|0;db=fb+8|0;f[db>>2]=f[db>>2]|4;b[fb+36>>0]=bb;eb=f[g>>2]|0}o:do if(!(eb&131072))gb=Ta;else{bb=h+11|0;fb=b[bb>>0]|0;db=h+4|0;cb=f[db>>2]|0;do if(((fb<<24>>24<0?cb:fb&255)|0)==4){if(LYc(h,0,-1,374427,4)|0){hb=b[bb>>0]|0;ib=f[db>>2]|0;break}_a=c+8|0;f[_a>>2]=f[_a>>2]|16;_a=c+176|0;Ca=f[_a>>2]|0;if(!Ca){$a=$Xc(52)|0;Q0a($a);f[_a>>2]=$a;jb=$a}else jb=Ca;Ca=f[i+120>>2]|0;$a=jb+8|0;f[$a>>2]=f[$a>>2]|16;f[jb+32>>2]=Ca;gb=Ta;break o}else{hb=fb;ib=cb}while(0);do if(((hb<<24>>24<0?ib:hb&255)|0)==6){if(LYc(h,0,-1,374442,6)|0)break;cb=c+8|0;f[cb>>2]=f[cb>>2]|256;cb=c+192|0;fb=f[cb>>2]|0;if(!fb){Qa=$Xc(60)|0;V0a(Qa);f[cb>>2]=Qa;kb=Qa}else kb=fb;fb=f[i+120>>2]|0;Qa=kb+8|0;f[Qa>>2]=f[Qa>>2]|16;f[kb+32>>2]=fb;gb=Ta;break o}while(0);vHa(e,373703,373679,519,518806,0,1);fb=e+21|0;Qa=e+32|0;while(1){if(!(b[fb>>0]|0))break;cb=BM(Qa,374560,43)|0;Ca=b[bb>>0]|0;$a=Ca<<24>>24<0;BM(cb,$a?f[h>>2]|0:h,$a?f[db>>2]|0:Ca&255)|0;wHa(e)}db=e+24|0;f[db>>2]=35856;bb=e+88|0;f[bb>>2]=35896;f[Qa>>2]=35876;fb=e+36|0;f[fb>>2]=35912;Ca=e+68|0;if((b[Ca+11>>0]|0)<0)cYc(f[Ca>>2]|0);LMc(fb);TNc(db,35972);GMc(bb);gb=0}while(0);p:do if(!(f[g>>2]&65536))lb=gb;else{Ta=h+11|0;kb=b[Ta>>0]|0;hb=h+4|0;do if(((kb<<24>>24<0?f[hb>>2]|0:kb&255)|0)==6){if(LYc(h,0,-1,374442,6)|0)break;ib=c+8|0;f[ib>>2]=f[ib>>2]|256;ib=c+192|0;jb=f[ib>>2]|0;if(!jb){eb=$Xc(60)|0;V0a(eb);f[ib>>2]=eb;mb=eb}else mb=jb;jb=b[i+117>>0]|0;eb=mb+8|0;f[eb>>2]=f[eb>>2]|32;b[mb+36>>0]=jb;lb=gb;break p}while(0);vHa(e,373703,373679,528,518806,0,1);kb=e+21|0;Qa=e+32|0;while(1){if(!(b[kb>>0]|0))break;jb=BM(Qa,374604,41)|0;eb=b[Ta>>0]|0;ib=eb<<24>>24<0;BM(jb,ib?f[h>>2]|0:h,ib?f[hb>>2]|0:eb&255)|0;wHa(e)}hb=e+24|0;f[hb>>2]=35856;Ta=e+88|0;f[Ta>>2]=35896;f[Qa>>2]=35876;kb=e+36|0;f[kb>>2]=35912;eb=e+68|0;if((b[eb+11>>0]|0)<0)cYc(f[eb>>2]|0);LMc(kb);TNc(hb,35972);GMc(Ta);lb=0}while(0);q:do if(!(f[g>>2]&2097152))nb=lb;else{gb=h+11|0;mb=b[gb>>0]|0;Ta=h+4|0;do if(((mb<<24>>24<0?f[Ta>>2]|0:mb&255)|0)==6){if(LYc(h,0,-1,374442,6)|0)break;hb=c+8|0;f[hb>>2]=f[hb>>2]|256;hb=c+192|0;kb=f[hb>>2]|0;if(!kb){eb=$Xc(60)|0;V0a(eb);f[hb>>2]=eb;ob=eb}else ob=kb;kb=f[i+136>>2]|0;eb=ob+8|0;f[eb>>2]=f[eb>>2]|128;f[ob+40>>2]=kb;nb=lb;break q}while(0);vHa(e,373703,373679,537,518806,0,1);mb=e+21|0;Qa=e+32|0;while(1){if(!(b[mb>>0]|0))break;kb=BM(Qa,374646,44)|0;eb=b[gb>>0]|0;hb=eb<<24>>24<0;BM(kb,hb?f[h>>2]|0:h,hb?f[Ta>>2]|0:eb&255)|0;wHa(e)}Ta=e+24|0;f[Ta>>2]=35856;gb=e+88|0;f[gb>>2]=35896;f[Qa>>2]=35876;mb=e+36|0;f[mb>>2]=35912;eb=e+68|0;if((b[eb+11>>0]|0)<0)cYc(f[eb>>2]|0);LMc(mb);TNc(Ta,35972);GMc(gb);nb=0}while(0);r:do if(!(f[g>>2]&16384))pb=nb;else{lb=h+11|0;ob=b[lb>>0]|0;gb=h+4|0;do if(((ob<<24>>24<0?f[gb>>2]|0:ob&255)|0)==6){if(LYc(h,0,-1,374442,6)|0)break;Ta=c+8|0;f[Ta>>2]=f[Ta>>2]|256;Ta=c+192|0;mb=f[Ta>>2]|0;if(!mb){eb=$Xc(60)|0;V0a(eb);f[Ta>>2]=eb;qb=eb}else qb=mb;mb=f[i+112>>2]|0;eb=qb+8|0;f[eb>>2]=f[eb>>2]|256;f[qb+44>>2]=mb;pb=nb;break r}while(0);vHa(e,373703,373679,546,518806,0,1);ob=e+21|0;Qa=e+32|0;while(1){if(!(b[ob>>0]|0))break;mb=BM(Qa,374691,43)|0;eb=b[lb>>0]|0;Ta=eb<<24>>24<0;BM(mb,Ta?f[h>>2]|0:h,Ta?f[gb>>2]|0:eb&255)|0;wHa(e)}gb=e+24|0;f[gb>>2]=35856;lb=e+88|0;f[lb>>2]=35896;f[Qa>>2]=35876;ob=e+36|0;f[ob>>2]=35912;eb=e+68|0;if((b[eb+11>>0]|0)<0)cYc(f[eb>>2]|0);LMc(ob);TNc(gb,35972);GMc(lb);pb=0}while(0);s:do if(!(f[g>>2]&4194304))rb=pb;else{nb=h+11|0;qb=b[nb>>0]|0;lb=h+4|0;do if(((qb<<24>>24<0?f[lb>>2]|0:qb&255)|0)==6){if(LYc(h,0,-1,374735,6)|0)break;gb=c+8|0;f[gb>>2]=f[gb>>2]|4;gb=c+168|0;ob=f[gb>>2]|0;if(!ob){eb=$Xc(24)|0;N0a(eb);f[gb>>2]=eb;sb=eb}else sb=ob;ob=f[i+140>>2]|0;eb=sb+8|0;f[eb>>2]=f[eb>>2]|1;f[sb+16>>2]=ob;rb=pb;break s}while(0);vHa(e,373703,373679,555,518806,0,1);qb=e+21|0;Qa=e+32|0;while(1){if(!(b[qb>>0]|0))break;ob=BM(Qa,374742,44)|0;eb=b[nb>>0]|0;gb=eb<<24>>24<0;BM(ob,gb?f[h>>2]|0:h,gb?f[lb>>2]|0:eb&255)|0;wHa(e)}lb=e+24|0;f[lb>>2]=35856;nb=e+88|0;f[nb>>2]=35896;f[Qa>>2]=35876;qb=e+36|0;f[qb>>2]=35912;eb=e+68|0;if((b[eb+11>>0]|0)<0)cYc(f[eb>>2]|0);LMc(qb);TNc(lb,35972);GMc(nb);rb=0}while(0);pb=i+12|0;t:do if(!(f[pb>>2]&1))tb=rb;else{sb=h+11|0;nb=b[sb>>0]|0;lb=h+4|0;do if(((nb<<24>>24<0?f[lb>>2]|0:nb&255)|0)==11){if(LYc(h,0,-1,374449,11)|0)break;qb=c+8|0;f[qb>>2]=f[qb>>2]|8192;qb=c+212|0;eb=f[qb>>2]|0;if(!eb){gb=$Xc(64)|0;c1a(gb);f[qb>>2]=gb;ub=gb}else ub=eb;eb=f[i+180>>2]|0;gb=ub+8|0;f[gb>>2]=f[gb>>2]|1024;f[ub+52>>2]=eb;tb=rb;break t}while(0);vHa(e,373703,373679,564,518806,0,1);nb=e+21|0;Qa=e+32|0;while(1){if(!(b[nb>>0]|0))break;eb=BM(Qa,374787,50)|0;gb=b[sb>>0]|0;qb=gb<<24>>24<0;BM(eb,qb?f[h>>2]|0:h,qb?f[lb>>2]|0:gb&255)|0;wHa(e)}lb=e+24|0;f[lb>>2]=35856;sb=e+88|0;f[sb>>2]=35896;f[Qa>>2]=35876;nb=e+36|0;f[nb>>2]=35912;gb=e+68|0;if((b[gb+11>>0]|0)<0)cYc(f[gb>>2]|0);LMc(nb);TNc(lb,35972);GMc(sb);tb=0}while(0);u:do if(!(f[pb>>2]&2))vb=tb;else{rb=h+11|0;ub=b[rb>>0]|0;sb=h+4|0;do if(((ub<<24>>24<0?f[sb>>2]|0:ub&255)|0)==11){if(LYc(h,0,-1,374449,11)|0)break;lb=c+8|0;f[lb>>2]=f[lb>>2]|8192;lb=c+212|0;nb=f[lb>>2]|0;if(!nb){gb=$Xc(64)|0;c1a(gb);f[lb>>2]=gb;wb=gb}else wb=nb;nb=f[i+184>>2]|0;gb=wb+8|0;f[gb>>2]=f[gb>>2]|2048;f[wb+56>>2]=nb;vb=tb;break u}while(0);vHa(e,373703,373679,574,518806,0,1);ub=e+21|0;Qa=e+32|0;while(1){if(!(b[ub>>0]|0))break;nb=BM(Qa,374838,50)|0;gb=b[rb>>0]|0;lb=gb<<24>>24<0;BM(nb,lb?f[h>>2]|0:h,lb?f[sb>>2]|0:gb&255)|0;wHa(e)}sb=e+24|0;f[sb>>2]=35856;rb=e+88|0;f[rb>>2]=35896;f[Qa>>2]=35876;ub=e+36|0;f[ub>>2]=35912;gb=e+68|0;if((b[gb+11>>0]|0)<0)cYc(f[gb>>2]|0);LMc(ub);TNc(sb,35972);GMc(rb);vb=0}while(0);v:do if(!(f[pb>>2]&4))xb=vb;else{tb=h+11|0;wb=b[tb>>0]|0;rb=h+4|0;do if(((wb<<24>>24<0?f[rb>>2]|0:wb&255)|0)==11){if(LYc(h,0,-1,374449,11)|0)break;sb=c+8|0;f[sb>>2]=f[sb>>2]|8192;sb=c+212|0;ub=f[sb>>2]|0;if(!ub){gb=$Xc(64)|0;c1a(gb);f[sb>>2]=gb;yb=gb}else yb=ub;ub=f[i+188>>2]|0;gb=yb+8|0;f[gb>>2]=f[gb>>2]|4096;f[yb+60>>2]=ub;xb=vb;break v}while(0);vHa(e,373703,373679,584,518806,0,1);wb=e+21|0;Qa=e+32|0;while(1){if(!(b[wb>>0]|0))break;ub=BM(Qa,374889,49)|0;gb=b[tb>>0]|0;sb=gb<<24>>24<0;BM(ub,sb?f[h>>2]|0:h,sb?f[rb>>2]|0:gb&255)|0;wHa(e)}rb=e+24|0;f[rb>>2]=35856;tb=e+88|0;f[tb>>2]=35896;f[Qa>>2]=35876;wb=e+36|0;f[wb>>2]=35912;gb=e+68|0;if((b[gb+11>>0]|0)<0)cYc(f[gb>>2]|0);LMc(wb);TNc(rb,35972);GMc(tb);xb=0}while(0);w:do if(!(f[g>>2]&262144))zb=xb;else{vb=h+11|0;yb=b[vb>>0]|0;pb=h+4|0;do if(((yb<<24>>24<0?f[pb>>2]|0:yb&255)|0)==11){if(LYc(h,0,-1,374449,11)|0)break;tb=c+8|0;f[tb>>2]=f[tb>>2]|8192;tb=c+212|0;rb=f[tb>>2]|0;if(!rb){wb=$Xc(64)|0;c1a(wb);f[tb>>2]=wb;Ab=wb}else Ab=rb;rb=f[i+124>>2]|0;wb=Ab+8|0;f[wb>>2]=f[wb>>2]|256;f[Ab+44>>2]=rb;zb=xb;break w}while(0);vHa(e,373703,373679,594,518806,0,1);yb=e+21|0;Qa=e+32|0;while(1){if(!(b[yb>>0]|0))break;rb=BM(Qa,374939,49)|0;wb=b[vb>>0]|0;tb=wb<<24>>24<0;BM(rb,tb?f[h>>2]|0:h,tb?f[pb>>2]|0:wb&255)|0;wHa(e)}pb=e+24|0;f[pb>>2]=35856;vb=e+88|0;f[vb>>2]=35896;f[Qa>>2]=35876;yb=e+36|0;f[yb>>2]=35912;wb=e+68|0;if((b[wb+11>>0]|0)<0)cYc(f[wb>>2]|0);LMc(yb);TNc(pb,35972);GMc(vb);zb=0}while(0);x:do if(!(f[g>>2]&16))Bb=zb;else{xb=h+11|0;Ab=b[xb>>0]|0;vb=h+4|0;do if(((Ab<<24>>24<0?f[vb>>2]|0:Ab&255)|0)==11){if(LYc(h,0,-1,374449,11)|0)break;pb=c+8|0;f[pb>>2]=f[pb>>2]|8192;pb=c+212|0;yb=f[pb>>2]|0;if(!yb){wb=$Xc(64)|0;c1a(wb);f[pb>>2]=wb;Cb=wb}else Cb=yb;yb=f[i+72>>2]|0;wb=Cb+8|0;f[wb>>2]=f[wb>>2]|4;wb=Cb+24|0;pb=f[wb>>2]|0;if((pb|0)==535216){mHa(wb,yb);Bb=zb;break x}else{oYc(pb,yb)|0;Bb=zb;break x}}while(0);vHa(e,373703,373679,604,518806,0,1);Ab=e+21|0;Qa=e+32|0;while(1){if(!(b[Ab>>0]|0))break;yb=BM(Qa,374989,47)|0;pb=b[xb>>0]|0;wb=pb<<24>>24<0;BM(yb,wb?f[h>>2]|0:h,wb?f[vb>>2]|0:pb&255)|0;wHa(e)}vb=e+24|0;f[vb>>2]=35856;xb=e+88|0;f[xb>>2]=35896;f[Qa>>2]=35876;Ab=e+36|0;f[Ab>>2]=35912;pb=e+68|0;if((b[pb+11>>0]|0)<0)cYc(f[pb>>2]|0);LMc(Ab);TNc(vb,35972);GMc(xb);Bb=0}while(0);y:do if(!(f[g>>2]&128))Db=Bb;else{zb=h+11|0;Cb=b[zb>>0]|0;xb=h+4|0;do if(((Cb<<24>>24<0?f[xb>>2]|0:Cb&255)|0)==11){if(LYc(h,0,-1,375037,11)|0)break;vb=c+8|0;f[vb>>2]=f[vb>>2]|128;vb=c+188|0;Ab=f[vb>>2]|0;if(!Ab){pb=$Xc(20)|0;I$a(pb);f[vb>>2]=pb;Eb=pb}else Eb=Ab;Ab=f[i+84>>2]|0;slb(Eb,Ab|0?Ab:533560);Db=Bb;break y}while(0);vHa(e,373703,373679,614,518806,0,1);Cb=e+21|0;Qa=e+32|0;while(1){if(!(b[Cb>>0]|0))break;Ab=BM(Qa,375049,51)|0;pb=b[zb>>0]|0;vb=pb<<24>>24<0;BM(Ab,vb?f[h>>2]|0:h,vb?f[xb>>2]|0:pb&255)|0;wHa(e)}xb=e+24|0;f[xb>>2]=35856;zb=e+88|0;f[zb>>2]=35896;f[Qa>>2]=35876;Cb=e+36|0;f[Cb>>2]=35912;pb=e+68|0;if((b[pb+11>>0]|0)<0)cYc(f[pb>>2]|0);LMc(Cb);TNc(xb,35972);GMc(zb);Db=0}while(0);l=(Db&1)!=0;u=d;return l|0}function pHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=f[a+8>>2]|0;e=6}else{g=a+4|0;h=f[g>>2]|0;i=f[c>>2]|0;if((h|0)>=(i|0))if((i|0)==(f[a+8>>2]|0)){d=i;e=6;break}else{j=i;k=c;break}f[g>>2]=h+1;l=f[c+4+(h<<2)>>2]|0;return l|0}while(0);if((e|0)==6){XZb(a,d+1|0);d=f[b>>2]|0;j=f[d>>2]|0;k=d}f[k>>2]=j+1;j=f[a>>2]|0;if(!j){d=$Xc(12)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;m=d;n=k}else{if(f[j+64>>2]|0)SXb(j,4984,16);k=RXb(j,16,2233)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;m=k;n=f[b>>2]|0}b=a+4|0;a=f[b>>2]|0;f[b>>2]=a+1;f[n+4+(a<<2)>>2]=m;l=m;return l|0}function qHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<2;if(!i)k=$Xc(d+4|0)|0;else{b=d+11&-8;if(f[i+64>>2]|0)SXb(i,25456,b);k=QXb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)o1c(k+4|0,g+4|0,j<<2|0)|0;if(h)return;if(f[g>>2]|0)return;cYc(g);return}function rHa(a){a=a|0;if((b[a+11>>0]|0)>=0)return;cYc(f[a>>2]|0);return}function sHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;c=u;u=u+176|0;d=c;e=a+11|0;g=b[e>>0]|0;h=a+4|0;i=f[h>>2]|0;do if(((g<<24>>24<0?i:g&255)|0)==8)if(!(LYc(a,0,-1,375113,8)|0)){j=1;u=c;return j|0}else{k=b[e>>0]|0;l=f[h>>2]|0;break}else{k=g;l=i}while(0);do if(((k<<24>>24<0?l:k&255)|0)==4)if(!(LYc(a,0,-1,375122,4)|0)){j=2;u=c;return j|0}else{m=b[e>>0]|0;n=f[h>>2]|0;break}else{m=k;n=l}while(0);do if(((m<<24>>24<0?n:m&255)|0)==6)if(!(LYc(a,0,-1,374735,6)|0)){j=3;u=c;return j|0}else{o=b[e>>0]|0;p=f[h>>2]|0;break}else{o=m;p=n}while(0);do if(((o<<24>>24<0?p:o&255)|0)==4)if(!(LYc(a,0,-1,373778,4)|0)){j=4;u=c;return j|0}else{q=b[e>>0]|0;r=f[h>>2]|0;break}else{q=o;r=p}while(0);do if(((q<<24>>24<0?r:q&255)|0)==4)if(!(LYc(a,0,-1,374427,4)|0)){j=5;u=c;return j|0}else{s=b[e>>0]|0;t=f[h>>2]|0;break}else{s=q;t=r}while(0);do if(((s<<24>>24<0?t:s&255)|0)==7)if(!(LYc(a,0,-1,374207,7)|0)){j=6;u=c;return j|0}else{v=b[e>>0]|0;w=f[h>>2]|0;break}else{v=s;w=t}while(0);do if(((v<<24>>24<0?w:v&255)|0)==14)if(!(LYc(a,0,-1,375127,14)|0)){j=7;u=c;return j|0}else{x=b[e>>0]|0;y=f[h>>2]|0;break}else{x=v;y=w}while(0);do if(((x<<24>>24<0?y:x&255)|0)==7)if(!(LYc(a,0,-1,375142,7)|0)){j=8;u=c;return j|0}else{z=b[e>>0]|0;A=f[h>>2]|0;break}else{z=x;A=y}while(0);do if(((z<<24>>24<0?A:z&255)|0)==9)if(!(LYc(a,0,-1,374432,9)|0)){j=9;u=c;return j|0}else{B=b[e>>0]|0;C=f[h>>2]|0;break}else{B=z;C=A}while(0);do if(((B<<24>>24<0?C:B&255)|0)==11)if(!(LYc(a,0,-1,375037,11)|0)){j=10;u=c;return j|0}else{D=b[e>>0]|0;E=f[h>>2]|0;break}else{D=B;E=C}while(0);do if(((D<<24>>24<0?E:D&255)|0)==6)if(!(LYc(a,0,-1,375150,6)|0)){j=11;u=c;return j|0}else{F=b[e>>0]|0;G=f[h>>2]|0;break}else{F=D;G=E}while(0);do if(((F<<24>>24<0?G:F&255)|0)==6)if(!(LYc(a,0,-1,374442,6)|0)){j=12;u=c;return j|0}else{H=b[e>>0]|0;I=f[h>>2]|0;break}else{H=F;I=G}while(0);do if(((H<<24>>24<0?I:H&255)|0)==13)if(!(LYc(a,0,-1,374461,13)|0)){j=13;u=c;return j|0}else{J=b[e>>0]|0;K=f[h>>2]|0;break}else{J=H;K=I}while(0);do if(((J<<24>>24<0?K:J&255)|0)==12)if(!(LYc(a,0,-1,373783,12)|0)){j=14;u=c;return j|0}else{L=b[e>>0]|0;M=f[h>>2]|0;break}else{L=J;M=K}while(0);do if(((L<<24>>24<0?M:L&255)|0)==3)if(!(LYc(a,0,-1,374263,3)|0)){j=15;u=c;return j|0}else{N=b[e>>0]|0;O=f[h>>2]|0;break}else{N=L;O=M}while(0);do if(((N<<24>>24<0?O:N&255)|0)==25)if(!(LYc(a,0,-1,375157,25)|0)){j=16;u=c;return j|0}else{P=b[e>>0]|0;Q=f[h>>2]|0;break}else{P=N;Q=O}while(0);do if(((P<<24>>24<0?Q:P&255)|0)==4)if(!(LYc(a,0,-1,373978,4)|0)){j=17;u=c;return j|0}else{R=b[e>>0]|0;S=f[h>>2]|0;break}else{R=P;S=Q}while(0);do if(((R<<24>>24<0?S:R&255)|0)==4)if(!(LYc(a,0,-1,375183,4)|0)){j=18;u=c;return j|0}else{T=b[e>>0]|0;U=f[h>>2]|0;break}else{T=R;U=S}while(0);do if(((T<<24>>24<0?U:T&255)|0)==7)if(!(LYc(a,0,-1,375188,7)|0)){j=19;u=c;return j|0}else{V=b[e>>0]|0;W=f[h>>2]|0;break}else{V=T;W=U}while(0);do if(((V<<24>>24<0?W:V&255)|0)==7)if(!(LYc(a,0,-1,438926,7)|0)){j=20;u=c;return j|0}else{X=b[e>>0]|0;Y=f[h>>2]|0;break}else{X=V;Y=W}while(0);do if(((X<<24>>24<0?Y:X&255)|0)==12)if(!(LYc(a,0,-1,375196,12)|0)){j=21;u=c;return j|0}else{Z=b[e>>0]|0;_=f[h>>2]|0;break}else{Z=X;_=Y}while(0);do if(((Z<<24>>24<0?_:Z&255)|0)==5)if(!(LYc(a,0,-1,375209,5)|0)){j=22;u=c;return j|0}else{$=b[e>>0]|0;aa=f[h>>2]|0;break}else{$=Z;aa=_}while(0);do if((($<<24>>24<0?aa:$&255)|0)==4)if(!(LYc(a,0,-1,455031,4)|0)){j=23;u=c;return j|0}else{ba=b[e>>0]|0;ca=f[h>>2]|0;break}else{ba=$;ca=aa}while(0);do if(((ba<<24>>24<0?ca:ba&255)|0)==11){if(!(LYc(a,0,-1,374449,11)|0))j=24;else break;u=c;return j|0}while(0);vHa(d,373703,375215,673,518794,0,1);ba=d+21|0;ca=d+32|0;while(1){if(!(b[ba>>0]|0))break;aa=BM(ca,375234,20)|0;$=b[e>>0]|0;_=$<<24>>24<0;BM(aa,_?f[a>>2]|0:a,_?f[h>>2]|0:$&255)|0;wHa(d)}h=d+24|0;f[h>>2]=35856;a=d+88|0;f[a>>2]=35896;f[ca>>2]=35876;ca=d+36|0;f[ca>>2]=35912;e=d+68|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(ca);TNc(h,35972);GMc(a);j=0;u=c;return j|0}function tHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;yHa(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{d0a(f[k+4+(l<<2)>>2]|0);l=l+1|0}while((l|0)!=(j|0));f[i>>2]=0}yHa(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{d0a(f[l+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)!=(i|0));f[a>>2]=0;m=0}else m=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=m;m=b+8|0;b=f[m>>2]|0;f[m>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{m=f[b+4+(g<<2)>>2]|0;if(m|0)Yi[f[(f[m>>2]|0)+4>>2]&4095](m);g=g+1|0}while((g|0)!=(i|0));n=f[h>>2]|0}else n=d;cYc(n);u=c;return}function uHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<2;if(!i)k=$Xc(d+4|0)|0;else{b=d+11&-8;if(f[i+64>>2]|0)SXb(i,25456,b);k=QXb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)o1c(k+4|0,g+4|0,j<<2|0)|0;if(h)return;if(f[g>>2]|0)return;cYc(g);return}function vHa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=g;f[a+12>>2]=h;f[a+16>>2]=e;b[a+20>>0]=i&1;b[a+21>>0]=1;i=a+24|0;e=a+88|0;h=a+32|0;f[h>>2]=35876;g=a+36|0;f[i>>2]=6740;f[e>>2]=6760;f[a+28>>2]=0;XNc(a+88|0,g);f[a+160>>2]=0;f[a+164>>2]=-1;f[i>>2]=35856;f[e>>2]=35896;f[h>>2]=35876;aOc(g);f[g>>2]=35912;h=a+68|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[a+84>>2]=24;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;AM(g,k);if((b[k+11>>0]|0)>=0){u=j;return}cYc(f[k>>2]|0);u=j;return}function wHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c+48|0;e=c+36|0;g=c+24|0;h=c+12|0;i=c;b[a+21>>0]=0;j=f[a+12>>2]|0;if(!j){u=c;return}if(b[a+20>>0]|0){u=c;return};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=dJc(j)|0;if(c>>>0>4294967279)jYc(h);if(c>>>0<11){b[h+11>>0]=c;if(!c)k=h;else{l=h;m=8}}else{n=c+16&-16;o=$Xc(n)|0;f[h>>2]=o;f[h+8>>2]=n|-2147483648;f[h+4>>2]=c;l=o;m=8}if((m|0)==8){o1c(l|0,j|0,c|0)|0;k=l}b[k+c>>0]=0;c=EYc(h,0,375101)|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=AYc(g,375110)|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;CM(i,a+36|0);c=b[i+11>>0]|0;g=c<<24>>24<0;h=zYc(e,g?f[i>>2]|0:i,g?f[i+4>>2]|0:c&255)|0;f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];f[d+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;vM(-2,d,f[a+4>>2]|0,f[a>>2]|0,f[a+16>>2]|0)}function xHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<2;if(!i)k=$Xc(d+4|0)|0;else{b=d+11&-8;if(f[i+64>>2]|0)SXb(i,25456,b);k=QXb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)o1c(k+4|0,g+4|0,j<<2|0)|0;if(h)return;if(f[g>>2]|0)return;cYc(g);return}function yHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{zHa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(108)|0;_$a(l);zHa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15808,112);l=RXb(i,112,2234)|0;_$a(l);zHa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function zHa(a,b){a=a|0;b=b|0;o0a(b,a);return}function AHa(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function BHa(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function CHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function DHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;b=u;u=u+64|0;c=b;d=a+20|0;if((f[d>>2]|0)<=0){e=0;u=b;return e|0}g=a+28|0;a=c+8|0;h=c+8|0;i=c+8|0;j=0;while(1){k=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;l=f[k+288>>2]|0;if((l|0)==5){m=f[k+176>>2]|0;clb(c,m|0?m:533120);m=f[a>>2]|0;if(!(m&258))n=m&8|0?1:m>>>5&1;else n=1;u9a(c);if(n|0){e=1;o=18;break}m=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;p=f[m+288>>2]|0;q=m}else{p=l;q=k}if((p|0)==12){k=f[q+192>>2]|0;dlb(c,k|0?k:533608);k=f[h>>2]|0;if(!(k&1026))r=k&8|0?1:k>>>6&1;else r=1;z8a(c);if(r|0){e=1;o=18;break}k=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;s=f[k+288>>2]|0;t=k}else{s=p;t=q}if((s|0)==24){k=f[t+212>>2]|0;elb(c,k|0?k:534376);k=f[i>>2]|0;if(!(k&514))v=k&32|0?1:k>>>6&1;else v=1;_6a(c);if(v|0){e=1;o=18;break}}j=j+1|0;if((j|0)>=(f[d>>2]|0)){e=0;o=18;break}}if((o|0)==18){u=b;return e|0}return 0}function EHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=a+20|0;if((f[c>>2]|0)<=0)return;d=a+28|0;a=0;do{e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[e+288>>2]|0)==5){g=e+8|0;h=f[g>>2]|16;f[g>>2]=h;g=e+176|0;i=f[g>>2]|0;if(!i){j=$Xc(52)|0;Q0a(j);f[g>>2]=j;g=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;k=g;l=f[g+8>>2]|0;m=j}else{k=e;l=h;m=i}f[k+8>>2]=l|33554432;i=k+260|0;h=f[i>>2]|0;if(!h){e=$Xc(44)|0;s1a(e);f[i>>2]=e;o=e}else o=h;h=m+8|0;e=f[h>>2]|0;if(!(e&256))p=e;else{e=m+44|0;i=f[e>>2]|0;j=o+8|0;f[j>>2]=f[j>>2]|32;f[o+40>>2]=i;n[e>>2]=1.0;e=f[h>>2]&-257;f[h>>2]=e;p=e}if(!(p&2))q=p;else{e=m+20|0;i=f[e>>2]|0;j=o+8|0;f[j>>2]=f[j>>2]|1;j=o+28|0;g=f[j>>2]|0;if((g|0)==537368)mHa(j,i);else oYc(g,i)|0;i=f[e>>2]|0;do if((i|0)!=537368){e=i+11|0;if((b[e>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[e>>0]=0;break}}while(0);i=f[h>>2]&-3;f[h>>2]=i;q=i}if(!(q&8))r=q;else{i=m+28|0;e=f[i>>2]|0;g=o+8|0;f[g>>2]=f[g>>2]|2;f[o+32>>2]=e;f[i>>2]=0;i=f[h>>2]&-9;f[h>>2]=i;r=i}if(r&32|0){i=m+36|0;e=b[i>>0]|0;g=o+8|0;f[g>>2]=f[g>>2]|4;b[o+36>>0]=e;b[i>>0]=0;f[h>>2]=f[h>>2]&-33}}i=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[i+288>>2]|0)==12){e=i+8|0;g=f[e>>2]|256;f[e>>2]=g;e=i+192|0;j=f[e>>2]|0;if(!j){s=$Xc(60)|0;V0a(s);f[e>>2]=s;e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;t=s;u=e;v=f[e+8>>2]|0}else{t=j;u=i;v=g}f[u+8>>2]=v|33554432;g=u+260|0;i=f[g>>2]|0;if(!i){j=$Xc(44)|0;s1a(j);f[g>>2]=j;w=j}else w=i;i=t+8|0;j=f[i>>2]|0;if(!(j&1024))x=j;else{j=t+52|0;g=f[j>>2]|0;e=w+8|0;f[e>>2]=f[e>>2]|32;f[w+40>>2]=g;n[j>>2]=1.0;j=f[i>>2]&-1025;f[i>>2]=j;x=j}if(!(x&2))y=x;else{j=t+20|0;g=f[j>>2]|0;e=w+8|0;f[e>>2]=f[e>>2]|1;e=w+28|0;s=f[e>>2]|0;if((s|0)==537368)mHa(e,g);else oYc(s,g)|0;g=f[j>>2]|0;do if((g|0)!=537368){j=g+11|0;if((b[j>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[j>>0]=0;break}}while(0);g=f[i>>2]&-3;f[i>>2]=g;y=g}if(!(y&8))z=y;else{g=t+28|0;h=f[g>>2]|0;j=w+8|0;f[j>>2]=f[j>>2]|2;f[w+32>>2]=h;f[g>>2]=0;g=f[i>>2]&-9;f[i>>2]=g;z=g}if(z&64|0){g=t+37|0;h=b[g>>0]|0;j=w+8|0;f[j>>2]=f[j>>2]|4;b[w+36>>0]=h;b[g>>0]=0;f[i>>2]=f[i>>2]&-65}}g=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[g+288>>2]|0)==24){h=g+8|0;j=f[h>>2]|8192;f[h>>2]=j;h=g+212|0;s=f[h>>2]|0;if(!s){e=$Xc(64)|0;c1a(e);f[h>>2]=e;h=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;A=h;B=f[h+8>>2]|0;C=e}else{A=g;B=j;C=s}f[A+8>>2]=B|33554432;s=A+260|0;j=f[s>>2]|0;if(!j){g=$Xc(44)|0;s1a(g);f[s>>2]=g;D=g}else D=j;j=C+8|0;g=f[j>>2]|0;if(!(g&512))E=g;else{g=C+48|0;s=f[g>>2]|0;e=D+8|0;f[e>>2]=f[e>>2]|32;f[D+40>>2]=s;n[g>>2]=1.0;g=f[j>>2]&-513;f[j>>2]=g;E=g}if(!(E&2))F=E;else{g=C+20|0;s=f[g>>2]|0;e=D+8|0;f[e>>2]=f[e>>2]|1;e=D+28|0;h=f[e>>2]|0;if((h|0)==537368)mHa(e,s);else oYc(h,s)|0;s=f[g>>2]|0;do if((s|0)!=537368){g=s+11|0;if((b[g>>0]|0)<0){b[f[s>>2]>>0]=0;f[s+4>>2]=0;break}else{b[s>>0]=0;b[g>>0]=0;break}}while(0);s=f[j>>2]&-3;f[j>>2]=s;F=s}if(!(F&32))G=F;else{s=C+36|0;i=f[s>>2]|0;g=D+8|0;f[g>>2]=f[g>>2]|2;f[D+32>>2]=i;f[s>>2]=0;s=f[j>>2]&-33;f[j>>2]=s;G=s}if(G&64|0){s=C+40|0;i=b[s>>0]|0;g=D+8|0;f[g>>2]=f[g>>2]|4;b[D+36>>0]=i;b[s>>0]=0;f[j>>2]=f[j>>2]&-65}}a=a+1|0}while((a|0)<(f[c>>2]|0));return}function FHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+336|0;e=d+168|0;g=d;h=c+20|0;i=f[h>>2]|0;a:do if((i|0)>0){j=f[c+28>>2]|0;k=0;while(1){if(f[(f[j+4+(k<<2)>>2]|0)+8>>2]&2|0)break;k=k+1|0;if((k|0)>=(i|0)){l=1;break a}}vHa(e,373703,375662,744,518806,0,1);k=e+21|0;j=e+32|0;m=a+11|0;n=a+4|0;while(1){if(!(b[k>>0]|0))break;o=BM(BM(j,375681,60)|0,375742,18)|0;p=b[m>>0]|0;q=p<<24>>24<0;BM(o,q?f[a>>2]|0:a,q?f[n>>2]|0:p&255)|0;wHa(e)}n=e+24|0;f[n>>2]=35856;m=e+88|0;f[m>>2]=35896;f[j>>2]=35876;k=e+36|0;f[k>>2]=35912;p=e+68|0;if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);LMc(k);TNc(n,35972);GMc(m);_kb(e,c);if(kHa(e,c)|0){vHa(g,373703,375662,752,518854,0,1);m=g+21|0;n=g+32|0;while(1){if(!(b[m>>0]|0))break;BM(BM(n,375869,54)|0,375924,16)|0;wHa(g)}m=g+24|0;f[m>>2]=35856;j=g+88|0;f[j>>2]=35896;f[n>>2]=35876;k=g+36|0;f[k>>2]=35912;p=g+68|0;if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);LMc(k);TNc(m,35972);GMc(j);r=1}else{vHa(g,373703,375662,749,518806,0,1);j=g+21|0;m=g+32|0;while(1){if(!(b[j>>0]|0))break;BM(BM(m,375761,44)|0,375806,62)|0;wHa(g)}j=g+24|0;f[j>>2]=35856;n=g+88|0;f[n>>2]=35896;f[m>>2]=35876;k=g+36|0;f[k>>2]=35912;p=g+68|0;if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);LMc(k);TNc(j,35972);GMc(n);r=0}vHa(g,373703,375662,755,518806,0,1);n=g+21|0;j=g+32|0;while(1){if(!(b[n>>0]|0))break;BM(BM(BM(BM(j,375941,49)|0,375991,61)|0,376053,62)|0,376116,64)|0;wHa(g)}n=g+24|0;f[n>>2]=35856;m=g+88|0;f[m>>2]=35896;f[j>>2]=35876;k=g+36|0;f[k>>2]=35912;p=g+68|0;if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);LMc(k);TNc(n,35972);GMc(m);Qjb(e);l=r}else l=1;while(0);if(DHa(c)|0){vHa(e,373703,375662,762,518806,0,1);r=e+21|0;g=e+32|0;i=a+11|0;m=a+4|0;while(1){if(!(b[r>>0]|0))break;n=BM(BM(g,375681,60)|0,376181,27)|0;k=b[i>>0]|0;p=k<<24>>24<0;BM(n,p?f[a>>2]|0:a,p?f[m>>2]|0:k&255)|0;wHa(e)}m=e+24|0;f[m>>2]=35856;i=e+88|0;f[i>>2]=35896;f[g>>2]=35876;g=e+36|0;f[g>>2]=35912;r=e+68|0;if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);LMc(g);TNc(m,35972);GMc(i);EHa(c);vHa(e,373703,375662,765,518854,0,1);i=e+21|0;m=e+32|0;while(1){if(!(b[i>>0]|0))break;BM(BM(m,375869,54)|0,376209,31)|0;wHa(e)}i=e+24|0;f[i>>2]=35856;g=e+88|0;f[g>>2]=35896;f[m>>2]=35876;m=e+36|0;f[m>>2]=35912;r=e+68|0;if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);LMc(m);TNc(i,35972);GMc(g);vHa(e,373703,375662,767,518806,0,1);g=e+21|0;i=e+32|0;while(1){if(!(b[g>>0]|0))break;BM(BM(i,376241,50)|0,376292,51)|0;wHa(e)}g=e+24|0;f[g>>2]=35856;m=e+88|0;f[m>>2]=35896;f[i>>2]=35876;i=e+36|0;f[i>>2]=35912;r=e+68|0;if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);LMc(i);TNc(g,35972);GMc(m)}do if((f[h>>2]|0)>0){vHa(e,373703,375662,771,518806,0,1);m=e+21|0;g=e+32|0;i=a+11|0;r=a+4|0;while(1){if(!(b[m>>0]|0))break;k=BM(BM(g,375681,60)|0,376344,18)|0;p=b[i>>0]|0;n=p<<24>>24<0;BM(k,n?f[a>>2]|0:a,n?f[r>>2]|0:p&255)|0;wHa(e)}r=e+24|0;f[r>>2]=35856;i=e+88|0;f[i>>2]=35896;f[g>>2]=35876;m=e+36|0;f[m>>2]=35912;j=e+68|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);LMc(m);TNc(r,35972);GMc(i);if(GHa(c)|0){vHa(e,373703,375662,778,518854,0,1);i=e+21|0;r=e+32|0;while(1){if(!(b[i>>0]|0))break;BM(BM(r,375869,54)|0,376412,16)|0;wHa(e)}i=e+24|0;f[i>>2]=35856;g=e+88|0;f[g>>2]=35896;f[r>>2]=35876;m=e+36|0;f[m>>2]=35912;j=e+68|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);LMc(m);TNc(i,35972);GMc(g);s=l;break}else{vHa(e,373703,375662,775,518806,0,1);g=e+21|0;i=e+32|0;while(1){if(!(b[g>>0]|0))break;BM(BM(i,375761,44)|0,376363,48)|0;wHa(e)}g=e+24|0;f[g>>2]=35856;r=e+88|0;f[r>>2]=35896;f[i>>2]=35876;m=e+36|0;f[m>>2]=35912;j=e+68|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);LMc(m);TNc(g,35972);GMc(r);s=0;break}}else s=l;while(0);l=c+80|0;if((f[l>>2]|0)<=0){u=d;return s|0}h=c+88|0;r=0;while(1){g=f[(f[(f[h>>2]|0)+4+(r<<2)>>2]|0)+140>>2]|0;m=b[g+11>>0]|0;if((((m<<24>>24<0?f[g+4>>2]|0:m&255)|0)==9?(LYc(g,0,-1,429107,9)|0)==0:0)?(f[(f[(f[h>>2]|0)+4+(r<<2)>>2]|0)+64>>2]|0)==3:0)break;r=r+1|0;if((r|0)>=(f[l>>2]|0)){t=82;break}}if((t|0)==82){u=d;return s|0}vHa(e,373703,375662,784,518854,0,1);t=e+21|0;l=e+32|0;r=a+11|0;h=a+4|0;while(1){if(!(b[t>>0]|0))break;g=BM(BM(l,376429,57)|0,376487,8)|0;m=b[r>>0]|0;j=m<<24>>24<0;BM(g,j?f[a>>2]|0:a,j?f[h>>2]|0:m&255)|0;wHa(e)}h=e+24|0;f[h>>2]=35856;a=e+88|0;f[a>>2]=35896;f[l>>2]=35876;l=e+36|0;f[l>>2]=35912;r=e+68|0;if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);LMc(l);TNc(h,35972);GMc(a);HHa(c);vHa(e,373703,375662,787,518854,0,1);c=e+21|0;a=e+32|0;while(1){if(!(b[c>>0]|0))break;BM(BM(a,376496,57)|0,376554,7)|0;wHa(e)}c=e+24|0;f[c>>2]=35856;h=e+88|0;f[h>>2]=35896;f[a>>2]=35876;a=e+36|0;f[a>>2]=35912;l=e+68|0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);LMc(a);TNc(c,35972);GMc(h);u=d;return s|0}function GHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;c=u;u=u+176|0;d=c;if(!a){e=$Xc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=17;g=e;h=376562;i=g+17|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+17>>0]=0;vM(-215,d,376580,373703,795)}e=a+80|0;if((f[e>>2]|0)>0){vHa(d,373703,376580,798,518806,0,1);h=d+21|0;g=d+32|0;while(1){if(!(b[h>>0]|0))break;BM(BM(g,376593,60)|0,376654,46)|0;wHa(d)}h=d+24|0;f[h>>2]=35856;i=d+88|0;f[i>>2]=35896;f[g>>2]=35876;g=d+36|0;f[g>>2]=35912;j=d+68|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);LMc(g);TNc(h,35972);GMc(i);i=f[e>>2]|0;if((i|0)>0){h=f[a+88>>2]|0;g=0;do{Kgb(f[h+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(i|0));f[e>>2]=0;k=0}else k=0}else k=1;i=a+20|0;if((f[i>>2]|0)<=0){l=k;u=c;return l|0}g=a+28|0;h=a+76|0;j=a+88|0;m=a+84|0;n=d+21|0;o=d+32|0;p=d+24|0;q=d+88|0;r=d+36|0;s=d+68|0;t=s+11|0;v=0;w=k;while(1){k=f[(f[g>>2]|0)+4+(v<<2)>>2]|0;x=f[j>>2]|0;do if(x){y=f[e>>2]|0;z=f[x>>2]|0;if((y|0)>=(z|0))if((z|0)==(f[m>>2]|0)){A=z;B=25;break}else{C=z;D=x;B=26;break}else{f[e>>2]=y+1;E=f[x+4+(y<<2)>>2]|0;break}}else{A=f[m>>2]|0;B=25}while(0);if((B|0)==25){B=0;XZb(h,A+1|0);x=f[j>>2]|0;C=f[x>>2]|0;D=x;B=26}if((B|0)==26){B=0;f[D>>2]=C+1;x=f[h>>2]|0;if(!x){y=$Xc(368)|0;Gib(y);F=y}else{if(f[x+64>>2]|0)SXb(x,16608,368);y=RXb(x,368,2235)|0;Gib(y);F=y}y=f[j>>2]|0;x=f[e>>2]|0;f[e>>2]=x+1;f[y+4+(x<<2)>>2]=F;E=F}if(JHa(k,E)|0)G=w;else{vHa(d,373703,376580,806,518806,0,1);while(1){if(!(b[n>>0]|0))break;BM(nOc(BM(o,376701,23)|0,v)|0,376725,8)|0;wHa(d)}f[p>>2]=35856;f[q>>2]=35896;f[o>>2]=35876;f[r>>2]=35912;if((b[t>>0]|0)<0)cYc(f[s>>2]|0);LMc(r);TNc(p,35972);GMc(q);G=0}v=v+1|0;H=f[i>>2]|0;if((v|0)>=(H|0))break;else w=G}if((H|0)<=0){l=G;u=c;return l|0}w=f[a+28>>2]|0;a=0;do{A0a(f[w+4+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(H|0));f[i>>2]=0;l=G;u=c;return l|0}function HHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+80|0;if((f[c>>2]|0)<=0)return;d=a+88|0;a=0;do{e=f[(f[(f[d>>2]|0)+4+(a<<2)>>2]|0)+140>>2]|0;g=b[e+11>>0]|0;if((((g<<24>>24<0?f[e+4>>2]|0:g&255)|0)==9?(LYc(e,0,-1,429107,9)|0)==0:0)?(e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0,g=e+64|0,(f[g>>2]|0)==3):0){h=f[e+72>>2]|0;tib(f[h+4>>2]|0);tib(f[h+8>>2]|0);tib(f[h+12>>2]|0);f[g>>2]=0}a=a+1|0}while((a|0)<(f[c>>2]|0));return}function IHa(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function JHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;d=u;u=u+176|0;e=d;g=d+8|0;if(!a){h=$Xc(32)|0;f[g>>2]=h;f[g+8>>2]=-2147483616;f[g+4>>2]=23;i=h;j=376734;k=i+23|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+23>>0]=0;vM(-215,g,376758,373703,839)}Kgb(c);h=a+20|0;if((f[h>>2]|0)>0){j=a+28|0;i=c+16|0;k=0;do{l=f[(f[j>>2]|0)+4+(k<<2)>>2]|0;oYc(pHa(i)|0,l)|0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=a+36|0;if((f[h>>2]|0)>0){k=a+44|0;i=c+32|0;j=0;do{l=f[(f[k>>2]|0)+4+(j<<2)>>2]|0;oYc(pHa(i)|0,l)|0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=a+8|0;do if(f[h>>2]&1|0){j=f[a+160>>2]|0;i=c+8|0;f[i>>2]=f[i>>2]|1;i=c+136|0;k=f[i>>2]|0;if((k|0)==537368){mHa(i,j);break}else{oYc(k,j)|0;break}}while(0);j=a+92|0;if((f[j>>2]|0)>0){k=c+92|0;i=a+100|0;l=0;do{m=KHa(k)|0;blb(m,f[(f[i>>2]|0)+4+(l<<2)>>2]|0);l=l+1|0}while((l|0)<(f[j>>2]|0))}j=a+108|0;if((f[j>>2]|0)>0){l=c+108|0;i=a+116|0;k=0;do{m=KHa(l)|0;blb(m,f[(f[i>>2]|0)+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)<(f[j>>2]|0))}if(f[a+12>>2]&1|0)MHa(c,LHa(f[a+288>>2]|0)|0);j=c+76|0;k=a+48|0;do if((j|0)!=(k|0))if((f[k>>2]|0)==(f[j>>2]|0)){i=c+88|0;l=a+60|0;m=f[i>>2]|0;f[i>>2]=f[l>>2];f[l>>2]=m;m=c+80|0;l=a+52|0;i=f[m>>2]|0;f[m>>2]=f[l>>2];f[l>>2]=i;i=c+84|0;l=a+56|0;m=f[i>>2]|0;f[i>>2]=f[l>>2];f[l>>2]=m;break}else{tHa(j,k);break}while(0);k=a+136|0;if((f[k>>2]|0)>0){j=c+64|0;m=c+72|0;l=a+144|0;i=0;do{if((f[j>>2]|0)<=(i|0))do NHa(c)|0;while((f[j>>2]|0)<=(i|0));n=f[(f[m>>2]|0)+4+(i<<2)>>2]|0;o=f[(f[l>>2]|0)+4+(i<<2)>>2]|0;p=n+8|0;f[p>>2]=f[p>>2]|1;p=n+16|0;n=f[p>>2]|0;if((n|0)==537368)mHa(p,o);else oYc(n,o)|0;i=i+1|0}while((i|0)<(f[k>>2]|0))}k=a+148|0;a:do if((f[k>>2]|0)>0){i=c+64|0;l=a+156|0;m=c+72|0;j=0;while(1){if((f[i>>2]|0)<=(j|0))do NHa(c)|0;while((f[i>>2]|0)<=(j|0));o=f[(f[l>>2]|0)+4+(j<<2)>>2]|0;if(o>>>0>=2)break;n=f[(f[m>>2]|0)+4+(j<<2)>>2]|0;p=n+8|0;f[p>>2]=f[p>>2]|2;f[n+20>>2]=o;o=j+1|0;if((o|0)<(f[k>>2]|0))j=o;else break a}vHa(g,373703,376758,877,518794,0,1);m=g+21|0;i=g+32|0;while(1){if(!(b[m>>0]|0))break;o=BM(i,376810,25)|0;nOc(o,f[(f[l>>2]|0)+4+(j<<2)>>2]|0)|0;wHa(g)}m=g+24|0;f[m>>2]=35856;o=g+88|0;f[o>>2]=35896;f[i>>2]=35876;n=g+36|0;f[n>>2]=35912;p=g+68|0;if((b[p+11>>0]|0)>=0){LMc(n);TNc(m,35972);GMc(o);q=f[l>>2]|0;r=q+4+(j<<2)|0;s=f[r>>2]|0;f[e>>2]=s;DM(g,376782,e);vM(-2,g,376758,373703,879)}cYc(f[p>>2]|0);LMc(n);TNc(m,35972);GMc(o);q=f[l>>2]|0;r=q+4+(j<<2)|0;s=f[r>>2]|0;f[e>>2]=s;DM(g,376782,e);vM(-2,g,376758,373703,879)}while(0);e=a+64|0;if((f[e>>2]|0)>0){s=c+64|0;r=c+72|0;q=a+72|0;k=0;do{if((f[s>>2]|0)<=(k|0))do NHa(c)|0;while((f[s>>2]|0)<=(k|0));j=f[(f[r>>2]|0)+4+(k<<2)>>2]|0;l=f[(f[q>>2]|0)+4+(k<<2)>>2]|0;i=j+8|0;f[i>>2]=f[i>>2]|4;f[j+24>>2]=l;k=k+1|0}while((k|0)<(f[e>>2]|0))}e=a+76|0;if((f[e>>2]|0)>0){k=c+64|0;q=c+72|0;r=a+84|0;s=0;do{if((f[k>>2]|0)<=(s|0))do NHa(c)|0;while((f[k>>2]|0)<=(s|0));l=f[(f[q>>2]|0)+4+(s<<2)>>2]|0;j=f[(f[r>>2]|0)+4+(s<<2)>>2]|0;i=l+8|0;f[i>>2]=f[i>>2]|8;f[l+28>>2]=j;s=s+1|0}while((s|0)<(f[e>>2]|0))}e=a+120|0;if((f[e>>2]|0)>0){s=a+128|0;r=c+48|0;q=c+52|0;k=c+56|0;j=0;l=f[r>>2]|0;do{i=f[(f[s>>2]|0)+4+(j<<2)>>2]|0;if((l|0)==(f[q>>2]|0)){uHa(r,l+1|0);t=f[r>>2]|0}else t=l;o=f[k>>2]|0;l=t+1|0;f[r>>2]=l;f[o+4+(t<<2)>>2]=i;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[h>>2]|0;if(!(e&1048576))v=e;else{e=c+8|0;f[e>>2]=f[e>>2]|16;e=c+152|0;j=f[e>>2]|0;if(!j){t=$Xc(28)|0;m1a(t);f[e>>2]=t;w=t}else w=j;j=f[a+240>>2]|0;hlb(w,j|0?j:532792);v=f[h>>2]|0}if(!(v&65536))x=v;else{v=c+8|0;f[v>>2]=f[v>>2]|32;v=c+156|0;j=f[v>>2]|0;if(!j){w=$Xc(28)|0;g1a(w);f[v>>2]=w;y=w}else y=j;j=f[a+224>>2]|0;ilb(y,j|0?j:532824);x=f[h>>2]|0}if(!(x&4))z=x;else{x=c+8|0;f[x>>2]=f[x>>2]|64;x=c+160|0;j=f[x>>2]|0;if(!j){y=$Xc(24)|0;N0a(y);f[x>>2]=y;A=y}else A=j;j=f[a+168>>2]|0;jlb(A,j|0?j:532856);z=f[h>>2]|0}if(!(z&536870912))B=z;else{z=c+8|0;f[z>>2]=f[z>>2]|128;z=c+164|0;j=f[z>>2]|0;if(!j){A=$Xc(24)|0;x1a(A);f[z>>2]=A;C=A}else C=j;j=f[a+276>>2]|0;klb(C,j|0?j:532944);B=f[h>>2]|0}if(!(B&8))D=B;else{B=c+8|0;f[B>>2]=f[B>>2]|256;B=c+168|0;j=f[B>>2]|0;if(!j){C=$Xc(120)|0;O0a(C);f[B>>2]=C;E=C}else E=j;j=f[a+172>>2]|0;llb(E,j|0?j:532968);D=f[h>>2]|0}if(!(D&16))F=D;else{D=c+8|0;f[D>>2]=f[D>>2]|512;D=c+172|0;j=f[D>>2]|0;if(!j){E=$Xc(52)|0;Q0a(E);f[D>>2]=E;G=E}else G=j;j=f[a+176>>2]|0;mlb(G,j|0?j:533120);F=f[h>>2]|0}if(!(F&32))H=F;else{F=c+8|0;f[F>>2]=f[F>>2]|1024;F=c+176|0;j=f[F>>2]|0;if(!j){G=$Xc(24)|0;S0a(G);f[F>>2]=G;I=G}else I=j;j=f[a+180>>2]|0;nlb(I,j|0?j:533248);H=f[h>>2]|0}if(!(H&524288))J=H;else{H=c+8|0;f[H>>2]=f[H>>2]|2048;H=c+180|0;j=f[H>>2]|0;if(!j){I=$Xc(96)|0;k1a(I);f[H>>2]=I;K=I}else K=j;j=f[a+236>>2]|0;olb(K,j|0?j:533272);J=f[h>>2]|0}if(!(J&131072))L=J;else{J=c+8|0;f[J>>2]=f[J>>2]|4096;J=c+184|0;j=f[J>>2]|0;if(!j){K=$Xc(36)|0;h1a(K);f[J>>2]=K;M=K}else M=j;j=f[a+228>>2]|0;plb(M,j|0?j:533368);L=f[h>>2]|0}if(!(L&1073741824))N=L;else{L=c+8|0;f[L>>2]=f[L>>2]|8192;L=c+188|0;j=f[L>>2]|0;if(!j){M=$Xc(28)|0;y1a(M);f[L>>2]=M;O=M}else O=j;j=f[a+280>>2]|0;qlb(O,j|0?j:533472);N=f[h>>2]|0}if(!(N&64))P=N;else{N=c+8|0;f[N>>2]=f[N>>2]|16384;N=c+192|0;j=f[N>>2]|0;if(!j){O=$Xc(28)|0;T0a(O);f[N>>2]=O;Q=O}else Q=j;j=f[a+184>>2]|0;rlb(Q,j|0?j:533528);P=f[h>>2]|0}if(!(P&128))R=P;else{P=c+8|0;f[P>>2]=f[P>>2]|32768;P=c+196|0;j=f[P>>2]|0;if(!j){Q=$Xc(20)|0;I$a(Q);f[P>>2]=Q;S=Q}else S=j;j=f[a+188>>2]|0;slb(S,j|0?j:533560);R=f[h>>2]|0}if(!(R&2097152))T=R;else{R=c+8|0;f[R>>2]=f[R>>2]|65536;R=c+200|0;j=f[R>>2]|0;if(!j){S=$Xc(20)|0;n1a(S);f[R>>2]=S;U=S}else U=j;j=f[a+244>>2]|0;tlb(U,j|0?j:533584);T=f[h>>2]|0}if(!(T&256))V=T;else{T=c+8|0;f[T>>2]=f[T>>2]|131072;T=c+204|0;j=f[T>>2]|0;if(!j){U=$Xc(60)|0;V0a(U);f[T>>2]=U;W=U}else W=j;j=f[a+192>>2]|0;ulb(W,j|0?j:533608);V=f[h>>2]|0}if(!(V&512))X=V;else{V=c+8|0;f[V>>2]=f[V>>2]|262144;V=c+208|0;j=f[V>>2]|0;if(!j){W=$Xc(20)|0;X0a(W);f[V>>2]=W;Y=W}else Y=j;j=f[a+196>>2]|0;vlb(Y,j|0?j:533672);X=f[h>>2]|0}if(!(X&1024))Z=X;else{X=c+8|0;f[X>>2]=f[X>>2]|524288;X=c+212|0;j=f[X>>2]|0;if(!j){Y=$Xc(36)|0;Y0a(Y);f[X>>2]=Y;_=Y}else _=j;j=f[a+200>>2]|0;wlb(_,j|0?j:533696);Z=f[h>>2]|0}if(!(Z&2048))$=Z;else{Z=c+8|0;f[Z>>2]=f[Z>>2]|1048576;Z=c+216|0;j=f[Z>>2]|0;if(!j){_=$Xc(40)|0;_0a(_);f[Z>>2]=_;aa=_}else aa=j;j=f[a+204>>2]|0;xlb(aa,j|0?j:533800);$=f[h>>2]|0}if(!($&32768))ba=$;else{$=c+8|0;f[$>>2]=f[$>>2]|2097152;$=c+220|0;j=f[$>>2]|0;if(!j){aa=$Xc(32)|0;f1a(aa);f[$>>2]=aa;ca=aa}else ca=j;j=f[a+220>>2]|0;ylb(ca,j|0?j:533840);ba=f[h>>2]|0}if(!(ba&16777216))da=ba;else{ba=c+8|0;f[ba>>2]=f[ba>>2]|4194304;ba=c+224|0;j=f[ba>>2]|0;if(!j){ca=$Xc(24)|0;r1a(ca);f[ba>>2]=ca;ea=ca}else ea=j;j=f[a+256>>2]|0;zlb(ea,j|0?j:533872);da=f[h>>2]|0}if(!(da&4096))fa=da;else{da=c+8|0;f[da>>2]=f[da>>2]|8388608;da=c+228|0;j=f[da>>2]|0;if(!j){ea=$Xc(68)|0;a1a(ea);f[da>>2]=ea;ga=ea}else ga=j;j=f[a+208>>2]|0;Alb(ga,j|0?j:533920);fa=f[h>>2]|0}if(!(fa&16384))ha=fa;else{fa=c+8|0;f[fa>>2]=f[fa>>2]|16777216;fa=c+232|0;j=f[fa>>2]|0;if(!j){ga=$Xc(28)|0;e1a(ga);f[fa>>2]=ga;ia=ga}else ia=j;j=f[a+216>>2]|0;Blb(ia,j|0?j:533992);ha=f[h>>2]|0}if(!(ha&4194304))ja=ha;else{ha=c+8|0;f[ha>>2]=f[ha>>2]|33554432;ha=c+236|0;j=f[ha>>2]|0;if(!j){ia=$Xc(24)|0;o1a(ia);f[ha>>2]=ia;ka=ia}else ka=j;j=f[a+248>>2]|0;Clb(ka,j|0?j:534120);ja=f[h>>2]|0}if(!(ja&134217728))la=ja;else{ja=c+8|0;f[ja>>2]=f[ja>>2]|67108864;ja=c+240|0;j=f[ja>>2]|0;if(!j){ka=$Xc(20)|0;v1a(ka);f[ja>>2]=ka;ma=ka}else ma=j;j=f[a+268>>2]|0;Dlb(ma,j|0?j:534216);la=f[h>>2]|0}if(!(la&268435456))na=la;else{la=c+8|0;f[la>>2]=f[la>>2]|134217728;la=c+244|0;j=f[la>>2]|0;if(!j){ma=$Xc(24)|0;w1a(ma);f[la>>2]=ma;oa=ma}else oa=j;j=f[a+272>>2]|0;Flb(oa,j|0?j:534280);na=f[h>>2]|0}if(!(na&8388608))pa=na;else{na=c+8|0;f[na>>2]=f[na>>2]|268435456;na=c+248|0;j=f[na>>2]|0;if(!j){oa=$Xc(36)|0;p1a(oa);f[na>>2]=oa;qa=oa}else qa=j;j=f[a+252>>2]|0;Elb(qa,j|0?j:534240);pa=f[h>>2]|0}if(!(pa&67108864))ra=pa;else{pa=c+8|0;f[pa>>2]=f[pa>>2]|536870912;pa=c+252|0;j=f[pa>>2]|0;if(!j){qa=$Xc(20)|0;u1a(qa);f[pa>>2]=qa;sa=qa}else sa=j;j=f[a+264>>2]|0;Glb(sa,j|0?j:534304);ra=f[h>>2]|0}if(!(ra&262144))ta=ra;else{ra=c+8|0;f[ra>>2]=f[ra>>2]|1073741824;ra=c+256|0;j=f[ra>>2]|0;if(!j){sa=$Xc(20)|0;j1a(sa);f[ra>>2]=sa;ua=sa}else ua=j;j=f[a+232>>2]|0;Hlb(ua,j|0?j:534352);ta=f[h>>2]|0}if(!(ta&8192))va=ta;else{ta=c+8|0;f[ta>>2]=f[ta>>2]|-2147483648;ta=c+260|0;j=f[ta>>2]|0;if(!j){ua=$Xc(64)|0;c1a(ua);f[ta>>2]=ua;wa=ua}else wa=j;j=f[a+212>>2]|0;Ilb(wa,j|0?j:534376);va=f[h>>2]|0}if(!(va&33554432))xa=va;else{va=c+8|0;f[va>>2]=f[va>>2]|4;va=c+144|0;j=f[va>>2]|0;if(!j){wa=$Xc(44)|0;s1a(wa);f[va>>2]=wa;ya=wa}else ya=j;j=f[a+260>>2]|0;flb(ya,j|0?j:532712);xa=f[h>>2]|0}if((xa|0)<0){j=c+8|0;f[j>>2]=f[j>>2]|8;j=c+148|0;c=f[j>>2]|0;if(!c){ya=$Xc(28)|0;z1a(ya);f[j>>2]=ya;za=ya}else za=c;c=f[a+284>>2]|0;glb(za,c|0?c:532760);Aa=f[h>>2]|0}else Aa=xa;if(!(Aa&2)){Ba=1;u=d;return Ba|0}vHa(g,373703,376758,1016,518806,0,1);Aa=g+21|0;xa=g+32|0;while(1){if(!(b[Aa>>0]|0))break;BM(xa,376836,44)|0;wHa(g)}Aa=g+24|0;f[Aa>>2]=35856;h=g+88|0;f[h>>2]=35896;f[xa>>2]=35876;xa=g+36|0;f[xa>>2]=35912;c=g+68|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);LMc(xa);TNc(Aa,35972);GMc(h);Ba=0;u=d;return Ba|0}function KHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(60)|0;oab(a);o=a}else{if(f[l+64>>2]|0)SXb(l,16304,64);a=RXb(l,64,2236)|0;oab(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function LHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+176|0;d=c;do switch(a|0){case 0:{e=1165591;break}case 35:{e=396633;break}case 1:{e=377151;break}case 30:{e=377144;break}case 2:{e=377139;break}case 3:{e=428960;break}case 37:{e=377123;break}case 4:{e=429163;break}case 39:{e=396536;break}case 5:{e=377118;break}case 6:{e=396650;break}case 32:{e=377108;break}case 7:{e=377094;break}case 25:{e=428856;break}case 38:{e=384213;break}case 8:{e=396507;break}case 9:{e=377085;break}case 10:{e=377074;break}case 28:{e=377064;break}case 11:{e=377057;break}case 12:{e=377047;break}case 13:{e=377034;break}case 14:{e=396578;break}case 15:{e=396574;break}case 29:{e=377023;break}case 16:{e=376999;break}case 34:{e=396591;break}case 17:{e=429057;break}case 26:{e=439430;break}case 18:{e=429133;break}case 19:{e=396621;break}case 27:{e=376975;break}case 36:{e=396658;break}case 20:{e=429025;break}case 21:{e=376959;break}case 22:{e=396493;break}case 33:{e=396487;break}case 23:{e=394925;break}case 24:{e=376948;break}case 31:{e=376938;break}default:{vHa(d,373703,376881,1105,518794,0,1);g=d+21|0;h=d+32|0;while(1){if(!(b[g>>0]|0))break;nOc(BM(h,376900,37)|0,a)|0;wHa(d)}g=d+24|0;f[g>>2]=35856;i=d+88|0;f[i>>2]=35896;f[h>>2]=35876;j=d+36|0;f[j>>2]=35912;k=d+68|0;if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);LMc(j);TNc(g,35972);GMc(i);e=1165591}}while(0);u=c;return e|0}function MHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+140|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=dJc(c)|0;if(a>>>0>4294967279)jYc(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=$Xc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==537368){h=$Xc(12)|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=h;u=d;return}h=a+11|0;if((b[h>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0}else{b[a>>0]=0;b[h>>0]=0}sYc(a,0);f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];f[a+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;u=d;return}function NHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+60|0;c=a+72|0;d=f[c>>2]|0;do if(!d){e=a+64|0;g=f[a+68>>2]|0;h=6}else{i=a+64|0;j=f[i>>2]|0;k=f[d>>2]|0;if((j|0)>=(k|0))if((k|0)==(f[a+68>>2]|0)){e=i;g=k;h=6;break}else{l=i;m=k;n=d;break}f[i>>2]=j+1;o=f[d+4+(j<<2)>>2]|0;return o|0}while(0);if((h|0)==6){XZb(b,g+1|0);g=f[c>>2]|0;l=e;m=f[g>>2]|0;n=g}f[n>>2]=m+1;m=f[b>>2]|0;if(!m){b=$Xc(32)|0;mib(b);p=b}else{if(f[m+64>>2]|0)SXb(m,16688,32);b=RXb(m,32,2237)|0;mib(b);p=b}b=f[c>>2]|0;c=f[l>>2]|0;f[l>>2]=c+1;f[b+4+(c<<2)>>2]=p;o=p;return o|0}function OHa(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function PHa(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function QHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+384|0;e=d+188|0;g=d;h=d+168|0;i=e+108|0;j=e+8|0;f[e>>2]=14364;f[i>>2]=14384;f[e+4>>2]=0;XNc(e+108|0,j);f[e+180>>2]=0;f[e+184>>2]=-1;f[e>>2]=80448;f[i>>2]=80468;RHa(j);k=e+72|0;if((f[k>>2]|0)==0?(l=iKc(a,391014)|0,f[k>>2]=l,(l|0)!=0):0){f[e+96>>2]=8;m=l}else{l=e+(f[(f[e>>2]|0)+-12>>2]|0)|0;WNc(l,f[l+16>>2]|4);m=f[k>>2]|0}vHa(g,373703,377160,1121,427598,377182,(m|0)!=0);m=g+21|0;k=g+32|0;while(1){if(!(b[m>>0]|0))break;l=BM(k,377195,12)|0;BM(BM(l,a,dJc(a)|0)|0,505469,1)|0;wHa(g)}a=g+24|0;f[a>>2]=35856;m=g+88|0;f[m>>2]=35896;f[k>>2]=35876;k=g+36|0;f[k>>2]=35912;l=g+68|0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);LMc(k);TNc(a,35972);GMc(m);Kjc(g,e,-1);Kpc(h,1);m=Mpc(h,g,c)|0;Lpc(h);f[g>>2]=171524;xZb(g+16|0);Hjc(g+4|0);f[e>>2]=80448;f[i>>2]=80468;SHa(j);xNc(e,80480);GMc(i);u=d;return m|0}function RHa(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;e=c;aOc(a);f[a>>2]=80500;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;g=a+52|0;h=a+68|0;i=a+98|0;j=g;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d[g+44>>1]=0;b[g+46>>0]=0;g=a+4|0;HXc(e,g);j=KXc(e,897880)|0;EPc(e);if(!j){l=f[a>>2]|0;m=l+12|0;n=f[m>>2]|0;hj[n&511](a,0,4096)|0;u=c;return}HXc(e,g);g=DPc(e,897880)|0;f[h>>2]=g;EPc(e);e=f[h>>2]|0;h=(_i[f[(f[e>>2]|0)+28>>2]&2047](e)|0)&1;b[i>>0]=h;l=f[a>>2]|0;m=l+12|0;n=f[m>>2]|0;hj[n&511](a,0,4096)|0;u=c;return}function SHa(a){a=a|0;var c=0,d=0;f[a>>2]=80500;c=a+64|0;d=f[c>>2]|0;if(d|0?(THa(a)|0,(oKc(d)|0)==0):0)f[c>>2]=0;if(b[a+96>>0]|0?(c=f[a+32>>2]|0,c|0):0)dYc(c);if(b[a+97>>0]|0?(c=f[a+56>>2]|0,c|0):0)dYc(c);LMc(a);return}function THa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;e=a+64|0;if(!(f[e>>2]|0)){g=0;u=c;return g|0}h=a+68|0;i=f[h>>2]|0;if(!i){j=af(4)|0;VZc(j);ig(j|0,25368,2144)}j=a+92|0;k=f[j>>2]|0;do if(!(k&16)){if(k&8|0){l=a+80|0;m=f[l+4>>2]|0;n=d;f[n>>2]=f[l>>2];f[n+4>>2]=m;do if(!(b[a+98>>0]|0)){m=_i[f[(f[i>>2]|0)+24>>2]&2047](i)|0;n=a+36|0;l=f[n>>2]|0;o=(f[a+40>>2]|0)-l|0;if((m|0)>0){p=0;q=(Y((f[a+16>>2]|0)-(f[a+12>>2]|0)|0,m)|0)+o|0;break}m=f[a+12>>2]|0;if((m|0)==(f[a+16>>2]|0)){p=0;q=o}else{r=f[h>>2]|0;s=a+32|0;t=_h[f[(f[r>>2]|0)+32>>2]&127](r,d,f[s>>2]|0,l,m-(f[a+8>>2]|0)|0)|0;p=1;q=o-t+(f[n>>2]|0)-(f[s>>2]|0)|0}}else{p=0;q=(f[a+16>>2]|0)-(f[a+12>>2]|0)|0}while(0);if(PKc(f[e>>2]|0,0-q|0,1)|0){g=-1;u=c;return g|0}if(p){s=d;n=f[s+4>>2]|0;t=a+72|0;f[t>>2]=f[s>>2];f[t+4>>2]=n}n=f[a+32>>2]|0;f[a+40>>2]=n;f[a+36>>2]=n;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[j>>2]=0}}else{if((f[a+24>>2]|0)!=(f[a+20>>2]|0)?(Mi[f[(f[a>>2]|0)+52>>2]&1023](a,-1)|0)==-1:0){g=-1;u=c;return g|0}n=a+72|0;t=a+32|0;s=a+52|0;a:while(1){o=f[h>>2]|0;m=f[t>>2]|0;l=_h[f[(f[o>>2]|0)+20>>2]&127](o,n,m,m+(f[s>>2]|0)|0,d)|0;m=f[t>>2]|0;o=(f[d>>2]|0)-m|0;if((eKc(m,1,o,f[e>>2]|0)|0)!=(o|0)){g=-1;v=24;break}switch(l|0){case 1:break;case 2:{g=-1;v=24;break a;break}default:{v=10;break a}}}if((v|0)==10){if(!(pKc(f[e>>2]|0)|0))break;else g=-1;u=c;return g|0}else if((v|0)==24){u=c;return g|0}}while(0);g=0;u=c;return g|0}function UHa(a){a=a|0;SHa(a);cYc(a);return}function VHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;_i[f[(f[a>>2]|0)+24>>2]&2047](a)|0;d=DPc(c,897880)|0;f[a+68>>2]=d;c=a+98|0;e=b[c>>0]|0;g=_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0;b[c>>0]=g&1;if((e&255|0)==(g&1|0))return;e=a+8|0;c=a+96|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;e=(b[c>>0]|0)!=0;if(g){g=a+32|0;if(e?(d=f[g>>2]|0,d|0):0)dYc(d);d=a+97|0;b[c>>0]=b[d>>0]|0;h=a+60|0;f[a+52>>2]=f[h>>2];i=a+56|0;f[g>>2]=f[i>>2];f[h>>2]=0;f[i>>2]=0;b[d>>0]=0;return}d=f[a+52>>2]|0;f[a+60>>2]=d;if(!e?(e=a+32|0,i=f[e>>2]|0,(i|0)!=(a+44|0)):0){f[a+56>>2]=i;b[a+97>>0]=0;i=bYc(d)|0;f[e>>2]=i;b[c>>0]=1;return}c=bYc(d)|0;f[a+56>>2]=c;b[a+97>>0]=1;return}function WHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=a+8|0;g=a+96|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;if(b[g>>0]|0?(e=f[a+32>>2]|0,e|0):0)dYc(e);e=a+97|0;if(b[e>>0]|0?(h=f[a+56>>2]|0,h|0):0)dYc(h);h=a+52|0;f[h>>2]=d;if(d>>>0>8){i=b[a+98>>0]|0;if((c|0)!=0&i<<24>>24!=0){j=0;k=c}else{j=1;k=bYc(d)|0}f[a+32>>2]=k;l=j;m=i}else{f[a+32>>2]=a+44;f[h>>2]=8;l=0;m=b[a+98>>0]|0}b[g>>0]=l;if(m<<24>>24){f[a+60>>2]=0;n=0;o=0;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}m=(d|0)>8?d:8;f[a+60>>2]=m;if((c|0)!=0&m>>>0>7){n=0;o=c;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}n=1;o=bYc(m)|0;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}function XHa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=f[b+68>>2]|0;if(!g){h=af(4)|0;VZc(h);ig(h|0,25368,2144)}h=_i[f[(f[g>>2]|0)+24>>2]&2047](g)|0;g=b+64|0;if((((f[g>>2]|0)!=0?!(((c|0)!=0|(d|0)!=0)&(h|0)<1):0)?e>>>0<3&(_i[f[(f[b>>2]|0)+24>>2]&2047](b)|0)==0:0)?(i=f[g>>2]|0,j=x1c(h|0,((h|0)<0)<<31>>31|0,c|0,d|0)|0,(PKc(i,(h|0)>0?j:0,e)|0)==0):0){e=KLc(f[g>>2]|0)|0;g=b+72|0;k=f[g>>2]|0;l=f[g+4>>2]|0;m=e;n=((e|0)<0)<<31>>31}else{k=0;l=0;m=-1;n=-1}e=a;f[e>>2]=k;f[e+4>>2]=l;l=a+8|0;f[l>>2]=m;f[l+4>>2]=n;return}function YHa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;d=b+64|0;if(f[d>>2]|0?(_i[f[(f[b>>2]|0)+24>>2]&2047](b)|0)==0:0)if(!(PKc(f[d>>2]|0,f[c+8>>2]|0,0)|0)){d=c;e=f[d+4>>2]|0;g=b+72|0;f[g>>2]=f[d>>2];f[g+4>>2]=e;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];return}else{c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=-1;f[c+4>>2]=-1;return}c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=-1;f[c+4>>2]=-1;return}function ZHa(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+64|0;if(!(f[g>>2]|0)){i=-1;u=c;return i|0}j=a+92|0;if(!(f[j>>2]&8)){f[a+24>>2]=0;f[a+20>>2]=0;f[a+28>>2]=0;k=(b[a+98>>0]|0)==0;l=f[(k?a+56|0:a+32|0)>>2]|0;m=l+(f[(k?a+60|0:a+52|0)>>2]|0)|0;f[a+8>>2]=l;l=a+12|0;f[l>>2]=m;f[a+16>>2]=m;f[j>>2]=8;n=1;o=l;p=m}else{m=a+12|0;n=0;o=m;p=f[m>>2]|0}if(!p){m=d+1|0;f[a+8>>2]=d;f[o>>2]=m;f[a+16>>2]=m;q=m}else q=p;p=a+16|0;if(n){r=f[p>>2]|0;s=0}else{n=f[p>>2]|0;m=(n-(f[a+8>>2]|0)|0)/2|0;r=n;s=m>>>0<4?m:4}do if((q|0)==(r|0)){m=a+8|0;q1c(f[m>>2]|0,q+(0-s)|0,s|0)|0;if(b[a+98>>0]|0){n=f[m>>2]|0;l=NLc(n+s|0,1,(f[p>>2]|0)-s-n|0,f[g>>2]|0)|0;if(!l){t=-1;v=m;break}n=(f[m>>2]|0)+s|0;f[o>>2]=n;f[p>>2]=n+l;t=h[n>>0]|0;v=m;break}n=a+40|0;l=f[n>>2]|0;j=a+36|0;k=f[j>>2]|0;w=l;x=k;if((l|0)==(k|0)){y=a+32|0;z=x;A=w}else{l=a+32|0;q1c(f[l>>2]|0,k|0,w-x|0)|0;y=l;z=f[j>>2]|0;A=f[n>>2]|0}l=f[y>>2]|0;x=l+(A-z)|0;f[j>>2]=x;if((l|0)==(a+44|0))B=8;else B=f[a+52>>2]|0;w=l+B|0;f[n>>2]=w;l=a+60|0;k=(f[l>>2]|0)-s|0;C=w-x|0;w=a+72|0;D=w;E=f[D+4>>2]|0;F=a+80|0;f[F>>2]=f[D>>2];f[F+4>>2]=E;E=NLc(x,1,C>>>0<k>>>0?C:k,f[g>>2]|0)|0;if(!E){t=-1;v=m}else{k=f[a+68>>2]|0;if(!k){C=af(4)|0;VZc(C);ig(C|0,25368,2144)}C=(f[j>>2]|0)+E|0;f[n>>2]=C;E=f[m>>2]|0;if((Gj[f[(f[k>>2]|0)+16>>2]&15](k,w,f[y>>2]|0,C,j,E+s|0,E+(f[l>>2]|0)|0,e)|0)!=3){l=f[e>>2]|0;E=(f[m>>2]|0)+s|0;if((l|0)==(E|0))G=-1;else{H=l;I=E;J=25}}else{E=f[y>>2]|0;l=f[n>>2]|0;f[m>>2]=E;H=l;I=E;J=25}if((J|0)==25){f[o>>2]=I;f[p>>2]=H;G=h[I>>0]|0}t=G;v=m}}else{t=h[q>>0]|0;v=a+8|0}while(0);if((f[v>>2]|0)==(d|0)){f[v>>2]=0;f[o>>2]=0;f[p>>2]=0}i=t;u=c;return i|0}function _Ha(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+64>>2]|0)){d=-1;return d|0}e=a+12|0;g=f[e>>2]|0;if((f[a+8>>2]|0)>>>0>=g>>>0){d=-1;return d|0}if((c|0)==-1){f[e>>2]=g+-1;d=0;return d|0}if(!(f[a+88>>2]&16)){a=c&255;h=g+-1|0;if(a<<24>>24==(b[h>>0]|0)){i=a;j=h}else{d=-1;return d|0}}else{i=c&255;j=g+-1|0}f[e>>2]=j;b[j>>0]=i;d=c;return d|0}function $Ha(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;i=a+64|0;if(!(f[i>>2]|0)){j=-1;u=d;return j|0}k=a+92|0;if(!(f[k>>2]&16)){f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;l=f[a+52>>2]|0;do if(l>>>0>8)if(!(b[a+98>>0]|0)){m=f[a+56>>2]|0;n=m+((f[a+60>>2]|0)+-1)|0;o=m;break}else{m=f[a+32>>2]|0;n=m+(l+-1)|0;o=m;break}else{n=0;o=0}while(0);f[a+24>>2]=o;l=a+20|0;f[l>>2]=o;m=a+28|0;f[m>>2]=n;f[k>>2]=16;p=l;q=m;r=m;s=l;t=o;v=n;w=o}else{o=a+20|0;n=f[o>>2]|0;l=a+28|0;p=o;q=l;r=l;s=o;t=n;v=f[l>>2]|0;w=n}n=(c|0)==-1;l=a+24|0;o=f[l>>2]|0;if(n){x=o;y=w}else{if(!o){f[l>>2]=e;f[s>>2]=e;f[q>>2]=e+1;z=e}else z=o;b[z>>0]=c;z=(f[l>>2]|0)+1|0;f[l>>2]=z;x=z;y=f[s>>2]|0}a:do if((x|0)==(y|0))A=32;else{b:do if(!(b[a+98>>0]|0)){z=a+32|0;o=f[z>>2]|0;f[g>>2]=o;e=a+68|0;w=f[e>>2]|0;if(!w){B=af(4)|0;VZc(B);ig(B|0,25368,2144)}m=o;o=a+72|0;k=a+52|0;C=Gj[f[(f[w>>2]|0)+12>>2]&15](w,o,y,x,h,m,m+(f[k>>2]|0)|0,g)|0;m=f[s>>2]|0;c:do if((f[h>>2]|0)!=(m|0)){w=C;D=m;while(1){if((w|0)==3){A=21;break}if((w|1|0)!=1)break c;E=f[z>>2]|0;F=(f[g>>2]|0)-E|0;if((eKc(E,1,F,f[i>>2]|0)|0)!=(F|0))break c;if((w|0)!=1){A=28;break}F=f[h>>2]|0;E=f[l>>2]|0;f[p>>2]=F;f[q>>2]=E;G=F;H=G+(E-F)|0;f[l>>2]=H;F=f[e>>2]|0;if(!F){A=19;break}E=f[z>>2]|0;w=Gj[f[(f[F>>2]|0)+12>>2]&15](F,o,G,H,h,E,E+(f[k>>2]|0)|0,g)|0;E=f[s>>2]|0;if((f[h>>2]|0)==(E|0))break c;else D=E}if((A|0)==19){B=af(4)|0;VZc(B);ig(B|0,25368,2144)}else if((A|0)==21){w=(f[l>>2]|0)-D|0;if((eKc(D,1,w,f[i>>2]|0)|0)!=(w|0))break}I=l;break b}while(0);J=-1;break a}else{k=x-y|0;if((eKc(y,1,k,f[i>>2]|0)|0)!=(k|0)){J=-1;break a}I=l}while(0);f[I>>2]=t;f[p>>2]=t;f[r>>2]=v;A=32}while(0);if((A|0)==32)J=n?0:c;j=J;u=d;return j|0}function aIa(a){a=a|0;var b=0;f[a>>2]=80448;b=a+108|0;f[b>>2]=80468;SHa(a+8|0);xNc(a,80480);GMc(b);return}function bIa(a){a=a|0;var b=0;f[a>>2]=80448;b=a+108|0;f[b>>2]=80468;SHa(a+8|0);xNc(a,80480);GMc(b);cYc(a);return}function cIa(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[b>>2]=80448;a=b+108|0;f[a>>2]=80468;SHa(b+8|0);xNc(b,80480);GMc(a);return}function dIa(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[b>>2]=80448;a=b+108|0;f[a>>2]=80468;SHa(b+8|0);xNc(b,80480);GMc(a);cYc(b);return}function eIa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+416|0;g=e+248|0;h=e+56|0;i=e;j=h+108|0;k=h+8|0;f[h>>2]=14364;f[j>>2]=14384;f[h+4>>2]=0;XNc(h+108|0,k);f[h+180>>2]=0;f[h+184>>2]=-1;f[h>>2]=80448;f[j>>2]=80468;RHa(k);l=h+72|0;if((f[l>>2]|0)==0?(m=iKc(a,511741)|0,f[l>>2]=m,(m|0)!=0):0){f[h+96>>2]=12;n=m}else{m=h+(f[(f[h>>2]|0)+-12>>2]|0)|0;WNc(m,f[m+16>>2]|4);n=f[l>>2]|0}vHa(g,373703,377303,1132,427598,377182,(n|0)!=0);n=g+21|0;l=g+32|0;while(1){if(!(b[n>>0]|0))break;m=BM(l,377195,12)|0;BM(BM(m,a,dJc(a)|0)|0,505469,1)|0;wHa(g)}a=g+24|0;f[a>>2]=35856;n=g+88|0;f[n>>2]=35896;f[l>>2]=35876;l=g+36|0;f[l>>2]=35912;m=g+68|0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);LMc(l);TNc(a,35972);GMc(n);Kjc(i,h,-1);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=i;n=g+12|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;d[n+12>>1]=0;f[g+28>>2]=2147483647;f[g+32>>2]=0;f[g+36>>2]=2147483647;n=f[41322]|0;f[g+40>>2]=n;f[g+44>>2]=n;b[g+48>>0]=1;f[g+52>>2]=0;f[g+56>>2]=0;MYb(g)|0;QYb(g,2147483647,536870912);n=LZb(c,g)|0;GYb(g);f[i>>2]=171524;xZb(i+16|0);Hjc(i+4|0);f[h>>2]=80448;f[j>>2]=80468;SHa(k);xNc(h,80480);GMc(j);u=e;return n|0}function fIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;FZb(e,a,b,-1);b=kqc(e,c)|0;u=d;return b|0}function gIa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+96|0;h=g+24|0;i=g;FZb(i,a,c,-1);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=i;i=h+12|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d[i+12>>1]=0;f[h+28>>2]=2147483647;f[h+32>>2]=0;f[h+36>>2]=2147483647;i=f[41322]|0;f[h+40>>2]=i;f[h+44>>2]=i;b[h+48>>0]=1;f[h+52>>2]=0;f[h+56>>2]=0;MYb(h)|0;QYb(h,2147483647,536870912);i=LZb(e,h)|0;GYb(h);u=g;return i|0}function hIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+176|0;e=d;vHa(e,373703,377327,1151,427598,427825,QHa(a,c)|0);g=e+21|0;h=e+32|0;while(1){if(!(b[g>>0]|0))break;i=BM(h,391016,35)|0;BM(i,a,dJc(a)|0)|0;wHa(e)}g=e+24|0;f[g>>2]=35856;i=e+88|0;f[i>>2]=35896;f[h>>2]=35876;h=e+36|0;f[h>>2]=35912;j=e+68|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);LMc(h);TNc(g,35972);GMc(i);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=dJc(a)|0;if(i>>>0>4294967279)jYc(e);if(i>>>0<11){b[e+11>>0]=i;if(!i)k=e;else{l=e;m=10}}else{g=i+16&-16;h=$Xc(g)|0;f[e>>2]=h;f[e+8>>2]=g|-2147483648;f[e+4>>2]=i;l=h;m=10}if((m|0)==10){o1c(l|0,a|0,i|0)|0;k=l}b[k+i>>0]=0;FHa(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function iIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+192|0;g=e+168|0;h=e;FZb(g,a,c,-1);vHa(h,373703,377358,1158,427598,427901,kqc(g,d)|0);c=h+21|0;a=h+32|0;while(1){if(!(b[c>>0]|0))break;BM(a,377405,35)|0;wHa(h)}c=h+24|0;f[c>>2]=35856;i=h+88|0;f[i>>2]=35896;f[a>>2]=35876;a=h+36|0;f[a>>2]=35912;j=h+68|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);LMc(a);TNc(c,35972);GMc(i);i=$Xc(16)|0;f[g>>2]=i;f[g+8>>2]=-2147483632;f[g+4>>2]=13;c=i;a=377391;j=c+13|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(j|0));b[i+13>>0]=0;FHa(g,d)|0;if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function jIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+176|0;e=d;vHa(e,373703,377441,1165,427598,427604,eIa(a,c)|0);g=e+21|0;h=e+32|0;while(1){if(!(b[g>>0]|0))break;i=BM(h,391016,35)|0;BM(i,a,dJc(a)|0)|0;wHa(e)}g=e+24|0;f[g>>2]=35856;i=e+88|0;f[i>>2]=35896;f[h>>2]=35876;h=e+36|0;f[h>>2]=35912;j=e+68|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);LMc(h);TNc(g,35972);GMc(i);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=dJc(a)|0;if(i>>>0>4294967279)jYc(e);if(i>>>0<11){b[e+11>>0]=i;if(!i)k=e;else{l=e;m=10}}else{g=i+16&-16;h=$Xc(g)|0;f[e>>2]=h;f[e+8>>2]=g|-2147483648;f[e+4>>2]=i;l=h;m=10}if((m|0)==10){o1c(l|0,a|0,i|0)|0;k=l}b[k+i>>0]=0;FHa(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function kIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+176|0;g=e;vHa(g,373703,377474,1172,427598,427716,gIa(a,c,d)|0);c=g+21|0;a=g+32|0;while(1){if(!(b[c>>0]|0))break;BM(a,377405,35)|0;wHa(g)}c=g+24|0;f[c>>2]=35856;h=g+88|0;f[h>>2]=35896;f[a>>2]=35876;a=g+36|0;f[a>>2]=35912;i=g+68|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);LMc(a);TNc(c,35972);GMc(h);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=13;c=h;a=377391;i=c+13|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(i|0));b[h+13>>0]=0;FHa(g,d)|0;if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function lIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+112|0;g=e+8|0;h=e;i=(b[c+11>>0]|0)<0?f[c>>2]|0:c;c=(b[d+11>>0]|0)<0?f[d>>2]|0:d;IWa(g);d=g+40|0;IWa(d);f[g+80>>2]=0;j=g+84|0;f[j>>2]=0;f[g+88>>2]=0;if(i|0?b[i>>0]|0:0)irb(i,g);if(c|0?b[c>>0]|0:0)krb(c,d);oOa(a);f[h>>2]=f[a>>2];c=f[a+4>>2]|0;f[h+4>>2]=c;if(c|0)TXc(c);mIa(g,h);ROa(h);h=g+80|0;c=f[h>>2]|0;if(!c){UUa(d);UUa(g);u=e;return}a=f[j>>2]|0;if((a|0)==(c|0))k=c;else{i=a;while(1){a=i+-12|0;f[j>>2]=a;if((b[a+11>>0]|0)<0){cYc(f[a>>2]|0);l=f[j>>2]|0}else l=a;if((l|0)==(c|0))break;else i=l}k=f[h>>2]|0}cYc(k);UUa(d);UUa(g);u=e;return}function mIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0,Hl=0,Il=0,Jl=0,Kl=0,Ll=0,Ml=0,Nl=0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0,$l=0,am=0,bm=0,cm=0,dm=0,em=0,fm=0,gm=0,hm=0,im=0,jm=0,km=0,lm=0,mm=0,nm=0,om=0,pm=0,qm=0,rm=0,sm=0,tm=0,um=0,vm=0,wm=0,xm=0,ym=0,zm=0,Am=0,Bm=0,Cm=0,Dm=0,Em=0,Fm=0,Gm=0,Hm=0,Im=0,Jm=0,Km=0,Lm=0,Mm=0,Nm=0,Om=0,Pm=0,Qm=0,Rm=0,Sm=0,Tm=0,Um=0,Vm=0,Wm=0,Xm=0,Ym=0,Zm=0,_m=0,$m=0,an=0,bn=0,cn=0,dn=0,en=0,fn=0,gn=0,hn=0,jn=0,kn=0,ln=0,mn=0,nn=0,on=0,pn=0,qn=0,rn=0,sn=0,tn=0,un=0,vn=0,wn=0,xn=0,yn=0,zn=0,An=0,Bn=0,Cn=0,Dn=0,En=0,Fn=0,Gn=0,Hn=0,In=0,Jn=0,Kn=0,Ln=0,Mn=0,Nn=0,On=0,Pn=0,Qn=0,Rn=0,Sn=0,Tn=0,Un=0,Vn=0,Wn=0,Xn=0,Yn=0,Zn=0,_n=0,$n=0,ao=0,bo=0,co=0,eo=0,fo=0,go=0,ho=0,io=0,jo=0,ko=0,lo=0,mo=0,no=0,oo=0,po=0,qo=0,ro=0,so=0,to=0,uo=0,vo=0,wo=0,xo=0,yo=0,zo=0,Ao=0,Bo=0,Co=0,Do=0,Eo=0,Fo=0,Go=0,Ho=0,Io=0,Jo=0,Ko=0,Lo=0,Mo=0,No=0,Oo=0,Po=0,Qo=0,Ro=0,So=0,To=0,Uo=0,Vo=0,Wo=0,Xo=0,Yo=0,Zo=0,_o=0,$o=0,ap=0,bp=0,cp=0,dp=0,ep=0,fp=0,gp=0,hp=0,ip=0,jp=0,kp=0,lp=0,mp=0,np=0,op=0,pp=0,qp=0,rp=0,sp=0,tp=0,up=0,vp=0,wp=0,xp=0,yp=0,zp=0,Ap=0,Bp=0,Cp=0,Dp=0,Ep=0,Fp=0,Gp=0,Hp=0,Ip=0,Jp=0,Kp=0,Lp=0,Mp=0,Np=0,Op=0,Pp=0,Qp=0,Rp=0,Sp=0,Tp=0,Up=0,Vp=0,Wp=0,Xp=0,Yp=0,Zp=0,_p=0,$p=0,aq=0,bq=0,cq=0,dq=0,eq=0,fq=0,gq=0,hq=0,iq=0,jq=0,kq=0,lq=0,mq=0,nq=0,oq=0,pq=0,qq=0,rq=0,sq=0,tq=0,uq=0,vq=0,wq=0,xq=0,yq=0,zq=0,Aq=0,Bq=0,Cq=0,Dq=0,Eq=0,Fq=0,Gq=0,Hq=0,Iq=0,Jq=0,Kq=0,Lq=0,Mq=0,Nq=0,Oq=0,Pq=0,Qq=0,Rq=0,Sq=0,Tq=0,Uq=0,Vq=0,Wq=0,Xq=0,Yq=0,Zq=0,_q=0,$q=0,ar=0,br=0,cr=0,dr=0,er=0,fr=0,gr=0,hr=0,ir=0,jr=0,kr=0,lr=0,mr=0,nr=0,or=0,pr=0,qr=0,rr=0,sr=0,tr=0,ur=0,vr=0,wr=0,xr=0,yr=0,zr=0,Ar=0,Br=0,Cr=0,Dr=0,Er=0,Fr=0,Gr=0,Hr=0,Ir=0,Jr=0,Kr=0,Lr=0,Mr=0,Nr=0,Or=0,Pr=0,Qr=0,Rr=0,Sr=0,Tr=0,Ur=0,Vr=0,Wr=0,Xr=0,Yr=0,Zr=0,_r=0,$r=0,as=0,bs=0,cs=0,ds=0,es=0,fs=0,gs=0,hs=0,is=0,js=0,ks=0,ls=0,ms=0,ns=0,os=0,ps=0,qs=0,rs=0,ss=0,ts=0,us=0,vs=0,ws=0,xs=0,ys=0,zs=0,As=0,Bs=0,Cs=0,Ds=0,Es=0,Fs=0,Gs=0,Hs=0,Is=0,Js=0,Ks=0,Ls=0,Ms=0,Ns=0,Os=0,Ps=0,Qs=0,Rs=0,Ss=0,Ts=0,Us=0,Vs=0,Ws=0,Xs=0,Ys=0,Zs=0,_s=0,$s=0,at=0,bt=0,ct=0,dt=0,et=0,ft=0,gt=0,ht=0,it=0,jt=0,kt=0,lt=0,mt=0,nt=0,ot=0,pt=0,qt=0,rt=0,st=0,tt=0,ut=0,vt=0,wt=0,xt=0,yt=0,zt=0,At=0,Bt=0,Ct=0,Dt=0,Et=0,Ft=0,Gt=0,Ht=0,It=0,Jt=0,Kt=0,Lt=0,Mt=0,Nt=0,Ot=0,Pt=0,Qt=0,Rt=0,St=0,Tt=0,Ut=0,Vt=0,Wt=0,Xt=0,Yt=0,Zt=0,_t=0,$t=0,au=0,bu=0,cu=0,du=0,eu=0,fu=0,gu=0,hu=0,iu=0,ju=0,ku=0,lu=0,mu=0,nu=0,ou=0,pu=0,qu=0,ru=0,su=0,tu=0,uu=0,vu=0,wu=0,xu=0,yu=0,zu=0,Au=0,Bu=0,Cu=0,Du=0,Eu=0,Fu=0,Gu=0,Hu=0,Iu=0,Ju=0,Ku=0,Lu=0,Mu=0,Nu=0,Ou=0,Pu=0,Qu=0,Ru=0,Su=0,Tu=0,Uu=0,Vu=0,Wu=0,Xu=0,Yu=0,Zu=0,_u=0,$u=0,av=0,bv=0,cv=0,dv=0,ev=0,fv=0,gv=0,hv=0,iv=0,jv=0,kv=0,lv=0,mv=0,nv=0,ov=0,pv=0,qv=0,rv=0,sv=0,tv=0,uv=0,vv=0,wv=0,xv=0,yv=0,zv=0,Av=0,Bv=0,Cv=0,Dv=0,Ev=0,Fv=0,Gv=0,Hv=0,Iv=0,Jv=0,Kv=0,Lv=0,Mv=0,Nv=0,Ov=0,Pv=0,Qv=0,Rv=0,Sv=0,Tv=0,Uv=0,Vv=0,Wv=0,Xv=0,Yv=0,Zv=0,_v=0,$v=0,aw=0,bw=0,cw=0,dw=0,ew=0,fw=0,gw=0,hw=0,iw=0,jw=0,kw=0,lw=0,mw=0,nw=0,ow=0,pw=0,qw=0,rw=0,sw=0,tw=0,uw=0,vw=0,ww=0,xw=0,yw=0,zw=0,Aw=0,Bw=0,Cw=0,Dw=0,Ew=0,Fw=0,Gw=0,Hw=0,Iw=0,Jw=0,Kw=0,Lw=0,Mw=0,Nw=0,Ow=0,Pw=0,Qw=0,Rw=0,Sw=0,Tw=0,Uw=0,Vw=0,Ww=0,Xw=0,Yw=0,_w=0,$w=0,ax=0,cx=0,dx=0,ex=0,fx=0,gx=0,ix=0,jx=0,kx=0,lx=0,mx=0,nx=0,ox=0,px=0,qx=0,rx=0,sx=0,tx=0,ux=0,vx=0,wx=0,xx=0,yx=0,zx=0,Ax=0,Bx=0,Cx=0,Dx=0,Ex=0,Fx=0,Gx=0,Hx=0,Ix=0,Jx=0,Kx=0,Lx=0,Mx=0,Nx=0,Ox=0,Px=0,Qx=0,Rx=0,Sx=0,Tx=0,Ux=0,Vx=0,Wx=0,Xx=0,Yx=0,Zx=0,_x=0,$x=0,ay=0,by=0,cy=0,dy=0,ey=0,fy=0,gy=0,hy=0,iy=0,jy=0,ky=0,ly=0,my=0,ny=0,oy=0,py=0,qy=0,ry=0,sy=0,ty=0,uy=0,vy=0,wy=0,xy=0,yy=0,zy=0,Ay=0,By=0,Cy=0,Dy=0,Ey=0,Fy=0,Gy=0,Hy=0,Iy=0,Jy=0,Ky=0,Ly=0,My=0,Ny=0,Oy=0,Py=0,Qy=0,Ry=0,Sy=0,Ty=0,Uy=0,Vy=0,Wy=0,Xy=0,Yy=0,Zy=0,_y=0,$y=0,az=0,bz=0,cz=0,dz=0,ez=0,fz=0,gz=0,hz=0,iz=0,jz=0,kz=0,lz=0,mz=0,nz=0,oz=0,pz=0,qz=0,rz=0,sz=0,tz=0,uz=0,vz=0,wz=0,xz=0,yz=0,zz=0,Az=0,Bz=0,Cz=0,Dz=0,Ez=0,Fz=0,Gz=0,Hz=0,Iz=0,Jz=0,Kz=0,Lz=0,Mz=0,Nz=0,Oz=0,Pz=0,Qz=0,Rz=0,Sz=0,Tz=0,Uz=0,Vz=0,Wz=0,Xz=0,Yz=0,Zz=0,_z=0,$z=0,aA=0,bA=0,cA=0,dA=0,eA=0,fA=0.0,gA=0,hA=0,iA=0,jA=0,kA=0,lA=0,mA=0,nA=0,oA=0,pA=0,qA=0,rA=0,sA=0,tA=0,uA=0,vA=0,wA=0,xA=0,yA=0,zA=0,AA=0,BA=0,CA=0,DA=0,EA=0,FA=0,GA=0,HA=0,IA=0,JA=0,KA=0,LA=0,MA=0,NA=0,OA=0,PA=0,QA=0,RA=0,SA=0,TA=0,UA=0,VA=0,WA=0,XA=0,YA=0,ZA=0,_A=0,$A=0,aB=0,bB=0,cB=0,dB=0,eB=0,fB=0,gB=0,hB=0,iB=0,jB=0,kB=0,lB=0,mB=0,nB=0,oB=0,pB=0,qB=0,rB=0,sB=0,tB=0,uB=0,vB=0,wB=0,xB=0,yB=0,zB=0,AB=0,BB=0,CB=0,DB=0,EB=0,FB=0,GB=0,HB=0,IB=0,JB=0,KB=0,LB=0,MB=0,NB=0,OB=0,PB=0,QB=0,RB=0,SB=0.0,TB=0,UB=0,VB=0,WB=0,XB=0,YB=0,ZB=0,_B=0,$B=0,aC=0,bC=0,cC=0,dC=0,eC=0,fC=0,gC=0,hC=0,iC=0,jC=0,kC=0,lC=0,mC=0,nC=0,oC=0,pC=0,qC=0,rC=0,sC=0,tC=0,uC=0,vC=0,wC=0,xC=0,yC=0,zC=0,AC=0,BC=0,CC=0,DC=0,EC=0,FC=0,GC=0,HC=0,IC=0,JC=0,KC=0,LC=0,MC=0,NC=0,OC=0,PC=0,QC=0,RC=0,SC=0,TC=0,UC=0,VC=0,WC=0,XC=0,YC=0,ZC=0,_C=0,$C=0,aD=0,bD=0,cD=0,dD=0,eD=0,fD=0,gD=0,hD=0,iD=0,jD=0,kD=0,lD=0,mD=0,nD=0,oD=0,pD=0,qD=0,rD=0,sD=0,tD=0,uD=0,vD=0,wD=0,xD=0,yD=0,zD=0,AD=0,BD=0,CD=0,DD=0,ED=0,FD=0,GD=0,HD=0,ID=0,JD=0,KD=0,LD=0,MD=0,ND=0,OD=0,PD=0,QD=0,RD=0,SD=0,TD=0,UD=0,VD=0,WD=0,XD=0,YD=0,ZD=0,_D=0,$D=0,aE=0,bE=0,cE=0,dE=0,eE=0,fE=0,gE=0,hE=0,iE=0,jE=0,kE=0,lE=0,mE=0,nE=0,oE=0,pE=0,qE=0,rE=0,sE=0,tE=0,uE=0,vE=0,wE=0,xE=0,yE=0,zE=0;d=u;u=u+1792|0;e=d+632|0;g=d+400|0;h=d+344|0;i=d+280|0;j=d+1220|0;k=d+1208|0;l=d+1196|0;m=d+1184|0;o=d+1172|0;q=d+1096|0;r=d+1084|0;s=d+1072|0;t=d+1024|0;v=d+224|0;w=d+968|0;x=d+912|0;y=d+1772|0;z=d;A=d+1760|0;B=d+1748|0;C=d+1736|0;D=d+1724|0;E=d+1704|0;F=d+1684|0;G=d+1664|0;H=d+1652|0;I=d+1640|0;J=d+1628|0;K=d+1616|0;L=d+408|0;M=d+1596|0;N=d+1576|0;O=d+1556|0;P=d+1544|0;Q=d+1532|0;R=d+1520|0;S=d+1508|0;T=d+1496|0;U=d+1484|0;V=d+1472|0;W=d+1460|0;X=d+1448|0;Z=d+1436|0;_=d+1424|0;$=d+1412|0;aa=d+1400|0;ba=d+1388|0;ca=d+1376|0;da=d+1364|0;ea=d+1352|0;fa=d+856|0;ga=d+1340|0;ha=d+1328|0;ia=d+1316|0;ja=d+1304|0;ka=d+1292|0;la=d+1280|0;ma=d+1268|0;na=d+1256|0;oa=d+1244|0;pa=d+1232|0;zLa(a);qa=a+40|0;zLa(qa);if(!(_i[f[(f[qa>>2]|0)+48>>2]&2047](qa)|0))CJa(a);f[j+4>>2]=0;f[j+8>>2]=0;ra=j+4|0;f[j>>2]=ra;sa=(_i[f[(f[qa>>2]|0)+48>>2]&2047](qa)|0)!=0;ta=sa?qa:a;sa=f[ta+12>>2]|0;f[k+4>>2]=0;f[k+8>>2]=0;ua=k+4|0;f[k>>2]=ua;va=(sa|0)>0;if(va){wa=ta+20|0;xa=e+11|0;ya=e+4|0;za=sa;do{Aa=za;za=za+-1|0;Ba=f[(f[wa>>2]|0)+4+(za<<2)>>2]|0;lYc(e,f[Ba+60>>2]|0);Ca=oIa(Ba)|0;Da=CHa(k,e)|0;do if((Da|0)!=(ua|0)){Ea=Da+28|0;Fa=f[Ea>>2]|0;if((Ca|0)!=2){if((Fa|0)==2){f[Ea>>2]=Ca;Ga=Ca;break}if((Fa|0)==(Ca|0))Ga=Ca;else{f[Ea>>2]=2;Ga=2}}else Ga=Fa}else{Fa=IGa(k,e)|0;f[Fa>>2]=Ca;Ga=Ca}while(0);Ca=Ba+12|0;a:do if((f[Ca>>2]|0)>0){Da=Ba+20|0;if((Ga|0)==2){Fa=0;while(1){Ea=f[(f[Da>>2]|0)+4+(Fa<<2)>>2]|0;mYc(h,Ea,0,KYc(Ea,58,-1)|0,Ea);if((b[xa>>0]|0)<0){b[f[e>>2]>>0]=0;f[ya>>2]=0}else{b[e>>0]=0;b[xa>>0]=0}sYc(e,0);f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];if((CHa(k,e)|0)==(ua|0)){Ea=IGa(k,e)|0;f[Ea>>2]=2}Fa=Fa+1|0;if((Fa|0)>=(f[Ca>>2]|0))break a}}else Ha=0;do{Fa=f[(f[Da>>2]|0)+4+(Ha<<2)>>2]|0;mYc(h,Fa,0,KYc(Fa,58,-1)|0,Fa);if((b[xa>>0]|0)<0){b[f[e>>2]>>0]=0;f[ya>>2]=0}else{b[e>>0]=0;b[xa>>0]=0}sYc(e,0);f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];Fa=CHa(k,e)|0;do if((Fa|0)!=(ua|0)){Ea=Fa+28|0;Ia=f[Ea>>2]|0;if((Ia|0)==2){f[Ea>>2]=Ga;break}if((Ia|0)!=(Ga|0))f[Ea>>2]=2}else{Ea=IGa(k,e)|0;f[Ea>>2]=Ga}while(0);Ha=Ha+1|0}while((Ha|0)<(f[Ca>>2]|0))}while(0);if((b[xa>>0]|0)<0)cYc(f[e>>2]|0)}while((Aa|0)>1)}f[l+4>>2]=0;f[l+8>>2]=0;xa=l+4|0;f[l>>2]=xa;f[m+4>>2]=0;f[m+8>>2]=0;Ha=m+4|0;f[m>>2]=Ha;nIa(a,l,j);nIa(qa,l,j);f[o+4>>2]=0;f[o+8>>2]=0;qa=o+4|0;f[o>>2]=qa;if(!va){Ja=a+80|0;lQa(c,Ja);Ka=f[qa>>2]|0;EGa(o,Ka);La=f[Ha>>2]|0;SIa(m,La);Ma=f[xa>>2]|0;EGa(l,Ma);Na=f[ua>>2]|0;EGa(k,Na);Oa=f[ra>>2]|0;RQ(j,Oa);u=d;return}va=ta+20|0;Ga=q+60|0;ya=q+64|0;za=t+4|0;wa=t+8|0;Ca=t+4|0;Ba=t+12|0;Da=q+12|0;Fa=q+20|0;Ea=e+11|0;Ia=s+11|0;Pa=s+4|0;Qa=h+11|0;Ra=h+6|0;Sa=e+4|0;Ta=h+8|0;Ua=h+4|0;Va=e+4|0;Wa=e+8|0;Xa=y+4|0;Ya=y+8|0;Za=y+4|0;_a=e+4|0;$a=e+8|0;ab=h+16|0;bb=h+4|0;cb=h+8|0;db=h+12|0;eb=x+4|0;fb=h+36|0;gb=h+40|0;hb=h+44|0;ib=h+48|0;jb=x+4|0;kb=e+11|0;lb=e+10|0;mb=e+11|0;nb=e+10|0;ob=z+4|0;pb=z+8|0;qb=z+40|0;rb=z+48|0;sb=z+44|0;tb=z+52|0;ub=A+4|0;vb=A+8|0;wb=A+4|0;xb=e+4|0;yb=e+8|0;zb=h+4|0;Ab=h+8|0;Bb=h+12|0;Cb=z+12|0;Db=z+16|0;Eb=h+16|0;Fb=h+36|0;Gb=h+40|0;Hb=h+44|0;Ib=h+48|0;Jb=e+11|0;Kb=e+5|0;Lb=e+11|0;Mb=e+5|0;Nb=z+36|0;Ob=wb;Pb=Za;Qb=i+8|0;Rb=i+4|0;Sb=q+24|0;Tb=q+48|0;Ub=h+8|0;Vb=i+11|0;Wb=e+11|0;Xb=e+9|0;Yb=t+12|0;Zb=h+11|0;_b=h+7|0;$b=e+4|0;ac=e+11|0;bc=e+9|0;cc=C+4|0;dc=C+8|0;ec=C+4|0;fc=ec;gc=D+4|0;hc=D+8|0;ic=D+4|0;jc=h+4|0;kc=h+8|0;lc=h+40|0;mc=h+48|0;nc=h+44|0;oc=h+52|0;pc=e+8|0;qc=e+4|0;rc=h+16|0;sc=h+36|0;tc=h+4|0;uc=h+8|0;vc=h+12|0;wc=h+16|0;xc=h+20|0;yc=h+24|0;zc=h+40|0;Ac=h+48|0;Bc=h+44|0;Cc=h+52|0;Dc=h+28|0;Ec=i+4|0;Fc=i+8|0;Gc=i+12|0;Hc=i+16|0;Ic=i+20|0;Jc=i+24|0;Kc=i+40|0;Lc=i+48|0;Mc=i+44|0;Nc=i+52|0;Oc=i+28|0;Pc=E+4|0;Qc=E+8|0;Rc=E+12|0;Sc=E+16|0;Tc=F+4|0;Uc=F+8|0;Vc=F+12|0;Wc=F+16|0;Xc=G+4|0;Yc=G+8|0;Zc=G+12|0;_c=G+16|0;$c=i+36|0;ad=h+36|0;bd=e+11|0;cd=e+8|0;dd=e+11|0;ed=e+8|0;fd=e+11|0;gd=e+10|0;hd=e+11|0;id=e+5|0;jd=h+11|0;kd=h+5|0;ld=h+8|0;md=h+4|0;nd=e+4|0;od=e+8|0;pd=e+8|0;qd=e+4|0;rd=e+11|0;sd=e+11|0;td=e+11|0;ud=z+11|0;vd=ic;wd=e+8|0;xd=e+4|0;yd=e+11|0;zd=v+11|0;Ad=B+4|0;Bd=B+8|0;Cd=B+4|0;Dd=i+4|0;Ed=i+8|0;Fd=i+12|0;Gd=i+16|0;Hd=i+40|0;Id=i+44|0;Jd=e+11|0;Kd=e+8|0;Ld=h+4|0;Md=e+11|0;Nd=e+7|0;Od=e+11|0;Pd=i+36|0;Qd=i+48|0;Rd=e+11|0;Sd=e+5|0;Td=e+11|0;Ud=e+5|0;Vd=Cd;Wd=e+11|0;Xd=H+4|0;Yd=H+8|0;Zd=H+4|0;_d=i+4|0;$d=i+8|0;ae=i+12|0;be=e+11|0;ce=e+5|0;de=i+16|0;ee=e+11|0;fe=e+5|0;ge=e+11|0;he=i+36|0;ie=i+40|0;je=i+44|0;ke=i+48|0;le=e+11|0;me=e+5|0;ne=Zd;oe=e+11|0;pe=e+9|0;qe=e+11|0;re=e+7|0;se=e+11|0;te=e+11|0;ue=I+4|0;ve=I+8|0;we=I+4|0;xe=e+8|0;ye=e+4|0;ze=i+4|0;Ae=i+8|0;Be=i+12|0;Ce=e+11|0;De=e+5|0;Ee=i+16|0;Fe=e+11|0;Ge=e+5|0;He=e+11|0;Ie=i+36|0;Je=i+40|0;Ke=i+44|0;Le=i+48|0;Me=e+11|0;Ne=e+5|0;Oe=we;Pe=i+8|0;Qe=i+4|0;Re=h+8|0;Se=i+11|0;Te=e+11|0;Ue=e+9|0;Ve=e+11|0;We=e+7|0;Xe=i+4|0;Ye=h+11|0;Ze=h+3|0;_e=i+8|0;$e=e+4|0;af=e+8|0;bf=e+11|0;cf=e+9|0;df=J+4|0;ef=J+8|0;ff=J+4|0;gf=ff;hf=K+4|0;jf=K+8|0;kf=K+4|0;lf=h+4|0;mf=h+8|0;nf=h+40|0;of=h+48|0;pf=h+44|0;qf=h+52|0;rf=w+4|0;sf=w+8|0;tf=w+40|0;uf=w+48|0;vf=w+44|0;wf=w+52|0;xf=e+8|0;yf=e+4|0;zf=w+36|0;Af=w+16|0;Bf=h+36|0;Cf=h+16|0;Df=w+12|0;Ef=w+20|0;Ff=w+24|0;Gf=w+28|0;Hf=w+32|0;If=w+44|0;Jf=e+11|0;Kf=e+10|0;Lf=e+4|0;Mf=h+4|0;Nf=e+4|0;Of=h+4|0;Pf=M+4|0;Qf=w+4|0;Rf=w+44|0;Sf=M+8|0;Tf=M+12|0;Uf=M+16|0;Vf=N+4|0;Wf=N+8|0;Xf=N+12|0;Yf=N+16|0;Zf=w+8|0;_f=w+12|0;$f=O+4|0;ag=x+4|0;bg=x+44|0;cg=O+8|0;dg=O+12|0;eg=O+16|0;fg=x+36|0;gg=x+16|0;hg=x+40|0;ig=x+48|0;jg=w+36|0;kg=w+16|0;lg=w+40|0;mg=w+48|0;ng=x+8|0;og=x+12|0;pg=e+8|0;qg=e+4|0;rg=e+11|0;sg=e+11|0;tg=kf;ug=e+8|0;vg=e+4|0;wg=e+11|0;xg=e+11|0;yg=e+11|0;zg=e+7|0;Ag=e+11|0;Bg=i+11|0;Cg=P+4|0;Dg=P+8|0;Eg=P+4|0;Fg=v+4|0;Gg=v+8|0;Hg=v+12|0;Ig=e+4|0;Jg=e+8|0;Kg=e+4|0;Lg=e+12|0;Mg=h+11|0;Ng=h+5|0;Og=w+4|0;Pg=w+11|0;Qg=w+7|0;Rg=w+12|0;Sg=i+4|0;Tg=i+12|0;Ug=h+11|0;Vg=e+36|0;Wg=Vg+11|0;Xg=e+24|0;Yg=Xg+11|0;Zg=e+12|0;_g=e+11|0;$g=e+3|0;ah=v+16|0;bh=v+44|0;ch=h+4|0;dh=e+11|0;eh=e+7|0;fh=v+36|0;gh=v+40|0;hh=v+48|0;ih=Eg;jh=e+11|0;kh=v+8|0;lh=v+4|0;mh=h+8|0;nh=v+11|0;oh=e+8|0;ph=e+4|0;qh=e+11|0;rh=e+4|0;sh=e+8|0;th=e+4|0;uh=e+12|0;vh=h+11|0;wh=h+5|0;xh=v+4|0;yh=v+11|0;zh=v+7|0;Ah=v+12|0;Bh=i+11|0;Ch=i+4|0;Dh=i+12|0;Eh=h+11|0;Fh=e+36|0;Gh=Fh+11|0;Hh=e+24|0;Ih=Hh+11|0;Jh=e+12|0;Kh=e+11|0;Lh=e+7|0;Mh=Q+4|0;Nh=Q+8|0;Oh=Q+4|0;Ph=i+16|0;Qh=i+4|0;Rh=i+8|0;Sh=i+12|0;Th=e+11|0;Uh=e+11|0;Vh=e+8|0;Wh=e+11|0;Xh=i+36|0;Yh=i+40|0;Zh=i+44|0;_h=i+48|0;$h=e+11|0;ai=e+5|0;bi=h+4|0;ci=e+11|0;di=e+7|0;fi=e+11|0;gi=Oh;hi=i+11|0;ii=i+5|0;ji=h+8|0;ki=i+11|0;li=i+4|0;mi=h+8|0;ni=i+8|0;oi=i+4|0;pi=h+8|0;qi=i+11|0;ri=i+11|0;si=i+4|0;ti=h+8|0;ui=e+8|0;vi=e+4|0;wi=e+11|0;xi=e+11|0;yi=e+3|0;zi=e+11|0;Ai=e+11|0;Bi=e+4|0;Ci=i+11|0;Di=i+4|0;Ei=e+8|0;Fi=e+4|0;Gi=e+11|0;Hi=e+11|0;Ii=e+10|0;Ji=e+11|0;Ki=e+4|0;Li=i+11|0;Mi=i+4|0;Ni=e+11|0;Oi=e+5|0;Pi=i+11|0;Qi=i+5|0;Ri=R+4|0;Si=R+8|0;Ti=R+4|0;Ui=e+11|0;Vi=e+11|0;Wi=e+4|0;Xi=e+11|0;Yi=e+6|0;Zi=e+11|0;$i=Ti;aj=e+11|0;bj=e+4|0;cj=e+11|0;dj=e+7|0;ej=e+11|0;fj=e+11|0;gj=e+4|0;hj=e+8|0;ij=e+4|0;jj=e+11|0;kj=e+11|0;lj=e+7|0;mj=e+11|0;nj=i+11|0;oj=i+5|0;pj=h+8|0;qj=a+84|0;rj=a+88|0;sj=a+80|0;tj=e+11|0;uj=e+5|0;vj=S+4|0;wj=S+8|0;xj=S+4|0;yj=h+11|0;zj=h+4|0;Aj=e+11|0;Bj=e+5|0;Cj=e+11|0;Dj=xj;Ej=T+4|0;Fj=T+8|0;Gj=T+4|0;Hj=U+4|0;Ij=U+8|0;Jj=U+4|0;Kj=i+16|0;Lj=i+4|0;Mj=i+8|0;Nj=i+12|0;Oj=v+16|0;Pj=v+4|0;Qj=v+8|0;Rj=v+12|0;Sj=e+11|0;Tj=i+44|0;Uj=v+44|0;Vj=e+11|0;Wj=e+5|0;Xj=h+4|0;Yj=e+11|0;_j=e+4|0;$j=h+4|0;ak=e+11|0;bk=e+5|0;ck=e+11|0;dk=v+36|0;ek=v+40|0;fk=v+48|0;gk=i+36|0;hk=i+40|0;ik=i+48|0;jk=Jj;kk=Gj;lk=e+11|0;mk=V+4|0;nk=V+8|0;ok=V+4|0;pk=i+4|0;qk=i+8|0;rk=i+12|0;sk=e+11|0;tk=e+7|0;uk=h+4|0;vk=e+11|0;wk=e+5|0;xk=i+16|0;yk=e+11|0;zk=e+5|0;Ak=r+11|0;Bk=r+4|0;Ck=e+8|0;Dk=e+4|0;Ek=e+11|0;Fk=e+11|0;Gk=e+4|0;Hk=h+11|0;Ik=e+11|0;Jk=i+36|0;Kk=i+40|0;Lk=i+44|0;Mk=i+48|0;Nk=h+11|0;Ok=e+11|0;Pk=e+3|0;Qk=v+4|0;Rk=w+11|0;Sk=w+4|0;Tk=h+8|0;Uk=e+11|0;Vk=e+5|0;Wk=e+11|0;Xk=e+4|0;Yk=w+11|0;Zk=w+4|0;_k=e+11|0;$k=e+9|0;al=W+4|0;bl=W+8|0;cl=W+4|0;dl=t+16|0;el=cl;fl=ok;gl=e+11|0;hl=e+9|0;il=e+11|0;jl=e+7|0;kl=e+11|0;ll=v+8|0;ml=v+4|0;nl=h+8|0;ol=v+11|0;pl=X+4|0;ql=X+8|0;rl=X+4|0;sl=e+11|0;tl=e+10|0;ul=Z+4|0;vl=Z+8|0;wl=Z+4|0;xl=e+11|0;yl=e+8|0;zl=v+4|0;Al=v+8|0;Bl=v+40|0;Cl=v+48|0;Dl=v+44|0;El=v+52|0;Fl=w+4|0;Gl=w+8|0;Hl=w+40|0;Il=w+48|0;Jl=w+44|0;Kl=w+52|0;Ll=e+4|0;Ml=e+8|0;Nl=e+4|0;Ol=e+12|0;Pl=x+11|0;Ql=x+3|0;Rl=x+12|0;Sl=i+11|0;Tl=i+4|0;Ul=i+12|0;Vl=h+11|0;Wl=e+36|0;Xl=Wl+11|0;Yl=e+24|0;Zl=Yl+11|0;_l=e+12|0;$l=x+11|0;am=x+7|0;bm=h+8|0;cm=e+11|0;dm=e+9|0;em=w+36|0;fm=w+16|0;gm=v+36|0;hm=v+16|0;im=e+11|0;jm=e+3|0;km=x+11|0;lm=x+7|0;mm=w+12|0;nm=w+20|0;om=w+24|0;pm=w+28|0;qm=w+32|0;rm=v+12|0;sm=v+20|0;tm=v+24|0;um=v+28|0;vm=v+32|0;wm=_+4|0;xm=_+8|0;ym=_+4|0;zm=$+4|0;Am=$+8|0;Bm=$+4|0;Cm=Bm;Dm=ym;Em=e+11|0;Fm=e+8|0;Gm=wl;Hm=e+11|0;Im=e+10|0;Jm=rl;Km=e+8|0;Lm=e+4|0;Mm=e+11|0;Nm=e+11|0;Om=e+9|0;Pm=e+11|0;Qm=e+7|0;Rm=i+4|0;Sm=e+11|0;Tm=e+9|0;Um=aa+4|0;Vm=aa+8|0;Wm=aa+4|0;Xm=Wm;Ym=ba+4|0;Zm=ba+8|0;_m=ba+4|0;$m=e+11|0;an=e+8|0;bn=e+11|0;cn=e+8|0;dn=e+11|0;en=e+10|0;fn=e+11|0;gn=e+8|0;hn=e+11|0;jn=e+8|0;kn=ca+4|0;ln=ca+8|0;mn=ca+4|0;nn=x+16|0;on=x+40|0;pn=x+44|0;qn=x+12|0;rn=h+11|0;sn=h+8|0;tn=e+11|0;un=e+4|0;vn=e+11|0;wn=e+5|0;xn=e+11|0;yn=e+5|0;zn=e+8|0;An=e+4|0;Bn=e+11|0;Cn=e+11|0;Dn=x+36|0;En=x+4|0;Fn=x+48|0;Gn=h+11|0;Hn=h+8|0;In=e+11|0;Jn=e+4|0;Kn=e+11|0;Ln=e+5|0;Mn=e+11|0;Nn=e+5|0;On=mn;Pn=_m;Qn=i+8|0;Rn=i+4|0;Sn=h+8|0;Tn=i+11|0;Un=i+8|0;Vn=i+4|0;Wn=h+8|0;Xn=i+11|0;Yn=i+4|0;Zn=i+8|0;_n=i+40|0;$n=i+48|0;ao=i+44|0;bo=i+52|0;co=v+4|0;eo=v+8|0;fo=v+40|0;go=v+48|0;ho=v+44|0;io=v+52|0;jo=w+4|0;ko=w+8|0;lo=w+40|0;mo=w+48|0;no=w+44|0;oo=w+52|0;po=x+4|0;qo=x+8|0;ro=x+40|0;so=x+48|0;to=x+44|0;uo=x+52|0;vo=da+4|0;wo=da+8|0;xo=da+4|0;yo=ea+4|0;zo=ea+8|0;Ao=ea+4|0;Bo=i+12|0;Co=i+16|0;Do=e+4|0;Eo=h+4|0;Fo=fa+36|0;Go=fa+16|0;Ho=fa+4|0;Io=fa+40|0;Jo=fa+44|0;Ko=fa+48|0;Lo=e+4|0;Mo=h+4|0;No=fa+36|0;Oo=fa+16|0;Po=fa+4|0;Qo=fa+40|0;Ro=fa+44|0;So=fa+48|0;To=z+8|0;Uo=z+4|0;Vo=h+8|0;Wo=z+11|0;Xo=e+11|0;Yo=e+4|0;Zo=e+11|0;_o=x+36|0;$o=x+16|0;ap=w+36|0;bp=w+16|0;cp=v+36|0;dp=v+16|0;ep=i+36|0;fp=e+8|0;gp=e+4|0;hp=e+11|0;ip=e+8|0;jp=e+4|0;kp=e+11|0;lp=z+4|0;mp=z+8|0;np=z+40|0;op=z+48|0;pp=z+44|0;qp=z+52|0;rp=ga+4|0;sp=ga+8|0;tp=ga+4|0;up=z+12|0;vp=z+36|0;wp=z+16|0;xp=e+4|0;yp=e+8|0;zp=e+12|0;Ap=e+16|0;Bp=e+20|0;Cp=z+20|0;Dp=e+24|0;Ep=z+24|0;Fp=e+28|0;Gp=z+28|0;Hp=e+32|0;Ip=z+32|0;Jp=e+36|0;Kp=z+44|0;Lp=e+44|0;Mp=e+40|0;Np=e+48|0;Op=e+4|0;Pp=e+8|0;Qp=e+12|0;Rp=e+16|0;Sp=e+20|0;Tp=e+24|0;Up=e+28|0;Vp=e+32|0;Wp=e+36|0;Xp=e+44|0;Yp=e+40|0;Zp=e+48|0;_p=z+40|0;$p=tp;aq=x+12|0;bq=x+20|0;cq=x+24|0;dq=x+28|0;eq=x+32|0;fq=w+12|0;gq=w+20|0;hq=w+24|0;iq=w+28|0;jq=w+32|0;kq=v+12|0;lq=v+20|0;mq=v+24|0;nq=v+28|0;oq=v+32|0;pq=Ao;qq=xo;rq=h+11|0;sq=h+9|0;tq=h+8|0;uq=h+4|0;vq=h+11|0;wq=h+11|0;xq=h+9|0;yq=e+8|0;zq=e+4|0;Aq=i+8|0;Bq=i+4|0;Cq=i+11|0;Dq=e+11|0;Eq=ha+4|0;Fq=ha+8|0;Gq=ha+4|0;Hq=i+4|0;Iq=i+8|0;Jq=i+12|0;Kq=e+11|0;Lq=e+6|0;Mq=i+16|0;Nq=i+44|0;Oq=e+11|0;Pq=e+5|0;Qq=i+36|0;Rq=i+40|0;Sq=i+48|0;Tq=Gq;Uq=e+8|0;Vq=e+4|0;Wq=e+11|0;Xq=i+8|0;Yq=i+4|0;Zq=h+8|0;_q=i+11|0;$q=e+11|0;ar=e+6|0;br=e+11|0;cr=e+8|0;dr=e+4|0;er=i+8|0;fr=i+4|0;gr=i+11|0;hr=e+11|0;ir=e+8|0;jr=e+4|0;kr=e+11|0;lr=ia+4|0;mr=ia+8|0;nr=ia+4|0;or=ja+4|0;pr=ja+8|0;qr=ja+4|0;rr=i+4|0;sr=i+8|0;tr=i+12|0;ur=v+4|0;vr=v+8|0;wr=v+12|0;xr=e+8|0;yr=e+4|0;zr=v+16|0;Ar=e+11|0;Br=e+8|0;Cr=e+4|0;Dr=i+16|0;Er=e+11|0;Fr=v+36|0;Gr=v+40|0;Hr=v+44|0;Ir=v+48|0;Jr=i+36|0;Kr=i+40|0;Lr=i+44|0;Mr=i+48|0;Nr=qr;Or=nr;Pr=ka+4|0;Qr=ka+8|0;Rr=ka+4|0;Sr=i+4|0;Tr=i+8|0;Ur=i+12|0;Vr=e+11|0;Wr=e+8|0;Xr=e+12|0;Yr=e+4|0;Zr=h+8|0;_r=h+4|0;$r=i+16|0;as=i+40|0;bs=i+44|0;cs=e+11|0;ds=e+10|0;es=e+11|0;fs=e+8|0;gs=e+11|0;hs=e+9|0;is=e+11|0;js=i+36|0;ks=i+48|0;ls=Rr;ms=i+11|0;ns=i+8|0;os=h+8|0;ps=i+11|0;qs=i+8|0;rs=h+8|0;ss=i+11|0;ts=i+4|0;us=h+8|0;vs=i+11|0;ws=i+4|0;xs=h+8|0;ys=i+11|0;zs=i+6|0;As=h+8|0;Bs=i+11|0;Cs=i+4|0;Ds=h+8|0;Es=i+11|0;Fs=i+8|0;Gs=i+12|0;Hs=i+20|0;Is=i+16|0;Js=i+24|0;Ks=Js+11|0;Ls=Js+6|0;Ms=i+36|0;Ns=Ms+11|0;Os=Ms+5|0;Ps=i+48|0;Qs=Ps+11|0;Rs=Ps+6|0;Ss=h+8|0;Ts=e+16|0;Us=e+4|0;Vs=e+8|0;Ws=e+12|0;Xs=h+4|0;Ys=e+36|0;Zs=e+40|0;_s=e+44|0;$s=e+48|0;at=e+11|0;bt=e+8|0;ct=e+11|0;dt=e+11|0;et=e+11|0;ft=e+4|0;gt=i+11|0;ht=i+4|0;it=e+11|0;jt=e+6|0;kt=i+11|0;lt=i+6|0;mt=e+11|0;nt=e+4|0;ot=i+11|0;pt=i+4|0;qt=e+11|0;rt=e+4|0;st=i+11|0;tt=i+4|0;ut=e+11|0;vt=e+8|0;wt=i+11|0;xt=i+8|0;yt=e+11|0;zt=e+8|0;At=i+11|0;Bt=i+8|0;Ct=i+11|0;Dt=i+4|0;Et=h+8|0;Ft=e+11|0;Gt=e+7|0;Ht=e+11|0;It=e+11|0;Jt=e+4|0;Kt=i+11|0;Lt=i+4|0;Mt=la+4|0;Nt=la+8|0;Ot=la+4|0;Pt=i+4|0;Qt=i+8|0;Rt=i+12|0;St=e+11|0;Tt=e+6|0;Ut=i+16|0;Vt=e+11|0;Wt=e+5|0;Xt=i+40|0;Yt=i+44|0;Zt=e+8|0;_t=e+4|0;$t=e+11|0;au=e+11|0;bu=e+11|0;cu=i+36|0;du=i+48|0;eu=Ot;fu=ma+4|0;gu=ma+8|0;hu=ma+4|0;iu=i+4|0;ju=i+8|0;ku=i+12|0;lu=i+16|0;mu=i+40|0;nu=i+44|0;ou=e+11|0;pu=e+4|0;qu=e+8|0;ru=e+4|0;su=e+11|0;tu=e+11|0;uu=e+7|0;vu=e+11|0;wu=v+11|0;xu=v+8|0;yu=h+8|0;zu=v+11|0;Au=v+9|0;Bu=h+8|0;Cu=e+11|0;Du=e+9|0;Eu=e+4|0;Fu=e+8|0;Gu=e+4|0;Hu=e+12|0;Iu=v+11|0;Ju=v+7|0;Ku=v+12|0;Lu=v+11|0;Mu=h+11|0;Nu=e+36|0;Ou=Nu+11|0;Pu=e+24|0;Qu=Pu+11|0;Ru=e+12|0;Su=i+36|0;Tu=i+48|0;Uu=e+11|0;Vu=e+8|0;Wu=hu;Xu=na+4|0;Yu=na+8|0;Zu=na+4|0;_u=oa+4|0;$u=oa+8|0;av=oa+4|0;bv=i+4|0;cv=i+8|0;dv=i+12|0;ev=v+4|0;fv=v+8|0;gv=v+12|0;hv=e+11|0;iv=e+9|0;jv=i+16|0;kv=e+11|0;lv=e+9|0;mv=v+16|0;nv=e+11|0;ov=e+5|0;pv=e+11|0;qv=v+36|0;rv=v+40|0;sv=v+44|0;tv=v+48|0;uv=i+36|0;vv=i+40|0;wv=i+44|0;xv=i+48|0;yv=av;zv=Zu;Av=h+11|0;Bv=e+11|0;Cv=i+8|0;Dv=e+4|0;Ev=e+8|0;Fv=v+4|0;Gv=v+8|0;Hv=v+8|0;Iv=pa+4|0;Jv=pa+8|0;Kv=pa+4|0;Lv=t+20|0;Mv=w+36|0;Nv=w+16|0;Ov=w+4|0;Pv=w+40|0;Qv=w+44|0;Rv=w+48|0;Sv=w+8|0;Tv=w+12|0;Uv=w+20|0;Vv=w+24|0;Wv=w+28|0;Xv=w+32|0;Yv=Kv;Zv=e+11|0;_v=t+36|0;$v=_v+11|0;aw=t+24|0;bw=aw+11|0;cw=t+12|0;dw=h+8|0;ew=e+8|0;fw=e+8|0;gw=e+8|0;hw=h+4|0;iw=e+8|0;jw=w+8|0;kw=e+4|0;lw=e+8|0;mw=v+8|0;nw=e+8|0;ow=e+8|0;pw=e+4|0;qw=e+8|0;rw=e+8|0;sw=e+8|0;tw=e+4|0;uw=e+8|0;vw=x+4|0;ww=x+8|0;xw=e+4|0;yw=x+8|0;zw=e+8|0;Aw=z+52|0;Bw=z+52|0;Cw=i+48|0;Dw=Cw+11|0;Ew=i+36|0;Fw=Ew+11|0;Gw=i+24|0;Hw=Gw+11|0;Iw=i+12|0;Jw=Iw+11|0;Kw=i+11|0;Lw=e+8|0;Mw=e+8|0;Nw=v+8|0;Ow=0;b:while(1){MWa(q,f[(f[va>>2]|0)+4+(Ow<<2)>>2]|0);lYc(r,f[Ga>>2]|0);lYc(s,f[ya>>2]|0);f[za>>2]=0;f[wa>>2]=0;f[t>>2]=Ca;Pw=Ba;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));c:do if((pIa(j,r)|0)==(ra|0)){Aa=oIa(q)|0;d:do if((Aa|0)==2){Rw=f[Da>>2]|0;if((Rw|0)>0){Sw=2;Tw=0;while(1){Uw=f[(f[Fa>>2]|0)+4+(Tw<<2)>>2]|0;mYc(e,Uw,0,KYc(Uw,58,-1)|0,Uw);Uw=qIa(k,e)|0;if((b[Ea>>0]|0)<0)cYc(f[e>>2]|0);if((Uw|0)!=(ua|0)){Vw=f[Uw+28>>2]|0;if((Sw|0)!=2)if((Vw|0)==(Sw|0)|(Vw|0)==2)Ww=Sw;else{Xw=2;break d}else Ww=Vw}else Ww=Sw;Tw=Tw+1|0;if((Tw|0)>=(Rw|0))break;else Sw=Ww}if((Ww|0)!=2){Xw=Ww;break}}Sw=qIa(k,f[Ga>>2]|0)|0;if((Sw|0)==(ua|0)){Yw=48;break b}Xw=f[Sw+28>>2]|0}else Xw=Aa;while(0);Aa=IGa(k,r)|0;f[Aa>>2]=Xw;Aa=b[Ia>>0]|0;Sw=f[Pa>>2]|0;if(((Aa<<24>>24<0?Sw:Aa&255)|0)==6){if(LYc(s,0,-1,377641,6)|0){_w=b[Ia>>0]|0;$w=f[Pa>>2]|0;Yw=53}}else{_w=Aa;$w=Sw;Yw=53}do if((Yw|0)==53){Yw=0;if(((_w<<24>>24<0?$w:_w&255)|0)==14){if(!(LYc(s,0,-1,377648,14)|0))break;ax=b[Ia>>0]|0;cx=f[Pa>>2]|0}else{ax=_w;cx=$w}if(((ax<<24>>24<0?cx:ax&255)|0)==21){if(!(LYc(s,0,-1,377663,21)|0))break;dx=b[Ia>>0]|0;ex=f[Pa>>2]|0}else{dx=ax;ex=cx}if(((dx<<24>>24<0?ex:dx&255)|0)==3){if(!(LYc(s,0,-1,390079,3)|0))break;fx=b[Ia>>0]|0;gx=f[Pa>>2]|0}else{fx=dx;gx=ex}if(((fx<<24>>24<0?gx:fx&255)|0)==7){if(LYc(s,0,-1,377936,7)|0){ix=b[Ia>>0]|0;jx=f[Pa>>2]|0;Yw=533}}else{ix=fx;jx=gx;Yw=533}do if((Yw|0)==533){Yw=0;if(((ix<<24>>24<0?jx:ix&255)|0)==3){if(!(LYc(s,0,-1,390465,3)|0))break;kx=b[Ia>>0]|0;lx=f[Pa>>2]|0}else{kx=ix;lx=jx}do if(((kx<<24>>24<0?lx:kx&255)|0)==3){if(!(LYc(s,0,-1,390473,3)|0))mx=0;else{nx=b[Ia>>0]|0;ox=f[Pa>>2]|0;break}while(1){if((mx|0)>=(f[Da>>2]|0)){Yw=593;break b}vIa(e,f[(f[Fa>>2]|0)+4+(mx<<2)>>2]|0);Sw=(CHa(l,e)|0)==(xa|0);if((b[te>>0]|0)<0)cYc(f[e>>2]|0);if(Sw)mx=mx+1|0;else break}f[ue>>2]=0;f[ve>>2]=0;f[I>>2]=we;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Aa=Sw;while(1){Sw=Aa+16|0;f[h>>2]=Oe;f[e>>2]=f[h>>2];sIa(I,e,Sw,Sw)|0;Sw=f[Aa+4>>2]|0;do if(!Sw){Rw=Aa+8|0;Tw=f[Rw>>2]|0;if((f[Tw>>2]|0)==(Aa|0)){px=Tw;break}else qx=Rw;do{Rw=f[qx>>2]|0;qx=Rw+8|0;Tw=f[qx>>2]|0}while((f[Tw>>2]|0)!=(Rw|0));px=Tw}else{Tw=Sw;while(1){Rw=f[Tw>>2]|0;if(!Rw)break;else Tw=Rw}px=Tw}while(0);if((px|0)==(xa|0))break;else Aa=px}}nKa(i,tIa(a,q,I,-1,0)|0);EGa(I,f[we>>2]|0);if((f[i>>2]&4095|0)!=5){Yw=602;break b}Aa=xe;f[Aa>>2]=0;f[Aa+4>>2]=0;f[e>>2]=33619968;f[ye>>2]=i;dY(i,e,-1,-1.0,0.0);Aa=f[ze>>2]|0;if((Aa|0)<3)rx=Y(f[Be>>2]|0,f[Ae>>2]|0)|0;else{Sw=f[Je>>2]|0;Rw=0;Vw=1;while(1){Uw=Y(f[Sw+(Rw<<2)>>2]|0,Vw)|0;Rw=Rw+1|0;if((Rw|0)==(Aa|0)){rx=Uw;break}else Vw=Uw}}if((rx|0)==1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Ce>>0]=5;b[e>>0]=b[431960]|0;b[e+1>>0]=b[431961]|0;b[e+2>>0]=b[431962]|0;b[e+3>>0]=b[431963]|0;b[e+4>>0]=b[431964]|0;b[De>>0]=0;OGa(t,e,f[Ee>>2]|0)|0;if((b[Ce>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Fe>>0]=5;b[e>>0]=b[439430]|0;b[e+1>>0]=b[439431]|0;b[e+2>>0]=b[439432]|0;b[e+3>>0]=b[439433]|0;b[e+4>>0]=b[439434]|0;b[Ge>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[Fe>>0]|0)<0)cYc(f[e>>2]|0);sx=Vw}else{Zw(Yb,1,i);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Me>>0]=5;b[e>>0]=b[396723]|0;b[e+1>>0]=b[396724]|0;b[e+2>>0]=b[396725]|0;b[e+3>>0]=b[396726]|0;b[e+4>>0]=b[396727]|0;b[Ne>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[Me>>0]|0)<0)cYc(f[e>>2]|0);sx=Vw}Vw=IGa(o,r)|0;f[Vw>>2]=sx;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,sx,0);if((b[He>>0]|0)<0)cYc(f[e>>2]|0);Vw=f[Ie>>2]|0;do if(Vw|0){Aa=Vw+12|0;Rw=f[Aa>>2]|0;f[Aa>>2]=Rw+-1;if((Rw|0)!=1)break;V$(i)}while(0);f[Ie>>2]=0;f[Ee>>2]=0;f[Ee+4>>2]=0;f[Ee+8>>2]=0;f[Ee+12>>2]=0;if((f[ze>>2]|0)>0){Vw=f[Je>>2]|0;Rw=0;do{f[Vw+(Rw<<2)>>2]=0;Rw=Rw+1|0}while((Rw|0)<(f[ze>>2]|0))}Rw=f[Ke>>2]|0;if((Rw|0)!=(Le|0))wL(Rw);break c}else{nx=kx;ox=lx}while(0);do if(((nx<<24>>24<0?ox:nx&255)|0)==6){if(LYc(s,0,-1,390685,6)|0){tx=b[Ia>>0]|0;ux=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=2){Yw=631;break b};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Rw=$Xc(32)|0;f[i>>2]=Rw;f[Pe>>2]=-2147483616;f[Qe>>2]=19;Pw=Rw;vx=447527;Qw=Pw+19|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Rw+19>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Re>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if(Vw)wx=0;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Vw=$Xc(32)|0;f[e>>2]=Vw;f[ug>>2]=-2147483616;f[vg>>2]=19;Pw=Vw;vx=447527;Qw=Pw+19|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+19>>0]=0;elc(Sb);Rw=AIa(Tb,e)|0;Aa=b[Rw+8>>0]|0?(f[Rw+20>>2]|0)==5:0;if((b[wg>>0]|0)<0)cYc(f[e>>2]|0);wx=Aa}if((b[Se>>0]|0)<0)cYc(f[i>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Te>>0]=9;Pw=e;vx=445999;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ue>>0]=0;b[h>>0]=0;cHa(t,e,h)|0;if((b[Te>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,1);f[gw>>2]=0;b[Ve>>0]=7;b[e>>0]=b[377936]|0;b[e+1>>0]=b[377937]|0;b[e+2>>0]=b[377938]|0;b[e+3>>0]=b[377939]|0;b[e+4>>0]=b[377940]|0;b[e+5>>0]=b[377941]|0;b[e+6>>0]=b[377942]|0;b[We>>0]=0;rIa(i,ta,r,e);Vw=f[i>>2]|0;Aa=f[Xe>>2]|0;Rw=Aa;Sw=Vw;if((Vw|0)==(Aa|0)){Aa=hw;f[Aa>>2]=0;f[Aa+4>>2]=0;b[Ye>>0]=3;b[h>>0]=b[390465]|0;b[h+1>>0]=b[390466]|0;b[h+2>>0]=b[390467]|0;b[Ze>>0]=0;rIa(e,ta,r,h);Aa=f[i>>2]|0;if(Aa|0){Vw=f[Xe>>2]|0;if((Vw|0)==(Aa|0))xx=Aa;else{Uw=Vw;while(1){Vw=Uw+-16|0;f[Xe>>2]=Vw;if((b[Vw+11>>0]|0)<0){cYc(f[Vw>>2]|0);yx=f[Xe>>2]|0}else yx=Vw;if((yx|0)==(Aa|0))break;else Uw=yx}xx=f[i>>2]|0}cYc(xx);f[_e>>2]=0;f[Xe>>2]=0;f[i>>2]=0}Uw=f[e>>2]|0;f[i>>2]=Uw;Aa=f[$e>>2]|0;f[Xe>>2]=Aa;f[_e>>2]=f[af>>2];zx=Uw;Ax=Aa}else{zx=Sw;Ax=Rw}do if((Ax-zx|0)==16){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[bf>>0]=9;Pw=e;vx=445999;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[cf>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[bf>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,2);Aa=f[(f[i>>2]|0)+12>>2]|0;Uw=f[(f[va>>2]|0)+4+(Aa<<2)>>2]|0;f[df>>2]=0;f[ef>>2]=0;f[J>>2]=ff;Vw=f[l>>2]|0;if((Vw|0)!=(xa|0)){Bx=Vw;while(1){Vw=Bx+16|0;f[h>>2]=gf;f[e>>2]=f[h>>2];sIa(J,e,Vw,Vw)|0;Vw=f[Bx+4>>2]|0;do if(!Vw){Cx=Bx+8|0;Dx=f[Cx>>2]|0;if((f[Dx>>2]|0)==(Bx|0)){Ex=Dx;break}else Fx=Cx;do{Cx=f[Fx>>2]|0;Fx=Cx+8|0;Dx=f[Fx>>2]|0}while((f[Dx>>2]|0)!=(Cx|0));Ex=Dx}else{Dx=Vw;while(1){Cx=f[Dx>>2]|0;if(!Cx)break;else Dx=Cx}Ex=Dx}while(0);if((Ex|0)==(xa|0))break;else Bx=Ex}}Bx=tIa(a,Uw,J,-1,0)|0;BIa(Bx,(f[Yb>>2]|0)+56|0);EGa(J,f[ff>>2]|0);CIa(ta,Aa,0);Bx=f[i>>2]|0;SQ(e,j,Bx,Bx);if(!wx){Gx=0;break}Bx=f[Yb>>2]|0;Vw=f[Bx+60>>2]|0;if((Vw|0)<3)Hx=Y(f[Bx+68>>2]|0,f[Bx+64>>2]|0)|0;else{Tw=f[Bx+96>>2]|0;Cx=0;Ix=1;while(1){Jx=Y(f[Tw+(Cx<<2)>>2]|0,Ix)|0;Cx=Cx+1|0;if((Cx|0)==(Vw|0)){Hx=Jx;break}else Ix=Jx}}Ix=f[Bx+72>>2]|0;if(Hx&3|0){Yw=666;break b}if((Hx|0)>0)Kx=0;else{Gx=1;break}do{Vw=Ix+(Kx<<2)|0;Cx=Ix+((Kx|1)<<2)|0;Tw=f[Vw>>2]|0;f[Vw>>2]=f[Cx>>2];f[Cx>>2]=Tw;Kx=Kx+2|0}while((Kx|0)<(Hx|0));Gx=1}else Gx=wx;while(0);f[v>>2]=-1;f[hf>>2]=0;f[jf>>2]=0;f[K>>2]=kf;Rw=f[l>>2]|0;if((Rw|0)!=(xa|0)){Sw=Rw;while(1){Rw=Sw+16|0;f[h>>2]=tg;f[e>>2]=f[h>>2];sIa(K,e,Rw,Rw)|0;Rw=f[Sw+4>>2]|0;do if(!Rw){Ix=Sw+8|0;Bx=f[Ix>>2]|0;if((f[Bx>>2]|0)==(Sw|0)){Lx=Bx;break}else Mx=Ix;do{Ix=f[Mx>>2]|0;Mx=Ix+8|0;Bx=f[Mx>>2]|0}while((f[Bx>>2]|0)!=(Ix|0));Lx=Bx}else{Bx=Rw;while(1){Ix=f[Bx>>2]|0;if(!Ix)break;else Bx=Ix}Lx=Bx}while(0);if((Lx|0)==(xa|0))break;else Sw=Lx}}Sw=tIa(a,q,K,-1,v)|0;EGa(K,f[kf>>2]|0);BIa(Sw,f[Yb>>2]|0);ELa(Sw);if((f[v>>2]|0)==1){m$(L,f[Yb>>2]|0);f[h>>2]=1124007936;Pw=lf;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[nf>>2]=mf;f[pf>>2]=of;f[of>>2]=0;f[qf>>2]=0;Sw=f[L>>2]|0;ei[f[(f[Sw>>2]|0)+12>>2]&511](Sw,L,h,-1);Zj(L);f[w>>2]=1124007936;Pw=rf;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[tf>>2]=sf;f[vf>>2]=uf;f[uf>>2]=0;f[wf>>2]=0;Sw=xf;f[Sw>>2]=0;f[Sw+4>>2]=0;f[e>>2]=33619968;f[yf>>2]=w;jR(h,e);Sw=f[Yb>>2]|0;do if((Sw|0)==(w|0)){Rw=f[zf>>2]|0;if(!Rw)break;Ix=Rw+12|0;Rw=f[Ix>>2]|0;f[Ix>>2]=Rw+-1;if((Rw|0)!=1)break;V$(w)}else{Rw=Sw+36|0;Ix=f[Rw>>2]|0;do if(Ix|0){Tw=Ix+12|0;Cx=f[Tw>>2]|0;f[Tw>>2]=Cx+-1;if((Cx|0)!=1)break;V$(Sw)}while(0);f[Rw>>2]=0;Ix=Sw+16|0;Cx=Sw+4|0;f[Ix>>2]=0;f[Ix+4>>2]=0;f[Ix+8>>2]=0;f[Ix+12>>2]=0;if((f[Cx>>2]|0)>0){Tw=f[Sw+40>>2]|0;Vw=0;do{f[Tw+(Vw<<2)>>2]=0;Vw=Vw+1|0}while((Vw|0)<(f[Cx>>2]|0))}f[Sw>>2]=f[w>>2];f[Cx>>2]=f[rf>>2];Vw=Sw+8|0;f[Vw>>2]=f[sf>>2];f[Sw+12>>2]=f[Df>>2];f[Ix>>2]=f[Af>>2];f[Sw+20>>2]=f[Ef>>2];f[Sw+24>>2]=f[Ff>>2];f[Sw+28>>2]=f[Gf>>2];f[Sw+32>>2]=f[Hf>>2];f[Rw>>2]=f[zf>>2];Tw=Sw+44|0;Aa=f[Tw>>2]|0;Uw=Sw+48|0;if((Aa|0)==(Uw|0))Nx=Aa;else{wL(Aa);f[Tw>>2]=Uw;f[Sw+40>>2]=Vw;Nx=Uw}if((f[rf>>2]|0)<3){Uw=f[If>>2]|0;f[Nx>>2]=f[Uw>>2];f[Nx+4>>2]=f[Uw+4>>2]}else{f[Tw>>2]=f[If>>2];f[Sw+40>>2]=f[tf>>2];f[If>>2]=uf;f[tf>>2]=sf}f[w>>2]=1124007936;Pw=rf;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0))}while(0);f[zf>>2]=0;f[Af>>2]=0;f[Af+4>>2]=0;f[Af+8>>2]=0;f[Af+12>>2]=0;if((f[rf>>2]|0)>0){Sw=f[tf>>2]|0;Rw=0;do{f[Sw+(Rw<<2)>>2]=0;Rw=Rw+1|0}while((Rw|0)<(f[rf>>2]|0))}Rw=f[vf>>2]|0;if((Rw|0)!=(uf|0))wL(Rw);Rw=f[Bf>>2]|0;do if(Rw|0){Sw=Rw+12|0;Ix=f[Sw>>2]|0;f[Sw>>2]=Ix+-1;if((Ix|0)!=1)break;V$(h)}while(0);f[Bf>>2]=0;f[Cf>>2]=0;f[Cf+4>>2]=0;f[Cf+8>>2]=0;f[Cf+12>>2]=0;if((f[lf>>2]|0)>0){Rw=f[nf>>2]|0;Ix=0;do{f[Rw+(Ix<<2)>>2]=0;Ix=Ix+1|0}while((Ix|0)<(f[lf>>2]|0))}Ix=f[pf>>2]|0;if((Ix|0)!=(of|0))wL(Ix)}b[Jf>>0]=10;Pw=e;vx=453228;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Kf>>0]=0;aHa(t,e,f[(f[Yb>>2]|0)+40>>2]|0)|0;if((b[Jf>>0]|0)<0)cYc(f[e>>2]|0);do if(Gx){Ix=f[Yb>>2]|0;if((f[Ix+4>>2]|0)!=2){Yw=711;break b}if((f[f[Ix+40>>2]>>2]|0)>0){Ox=0;Px=Ix}else break;do{Ix=Ox|1;f[e>>2]=Ox;f[Lf>>2]=Ix;f[h>>2]=-2147483648;f[Mf>>2]=2147483647;W$(w,Px,e,h);Rw=f[Yb>>2]|0;f[e>>2]=Ix;f[Nf>>2]=Ix+1;f[h>>2]=-2147483648;f[Of>>2]=2147483647;W$(x,Rw,e,h);f[M>>2]=w;Rw=f[Qf>>2]|0;if((Rw|0)>0)Qx=f[(f[Rf>>2]|0)+(Rw+-1<<2)>>2]|0;else Qx=0;f[Pf>>2]=Qx;f[Sf>>2]=0;f[Tf>>2]=0;f[Uf>>2]=0;if(f[w>>2]&16384|0){Ix=f[kg>>2]|0;f[Tf>>2]=Ix;if((Rw|0)<3)Rx=Y(f[_f>>2]|0,f[Zf>>2]|0)|0;else{Sw=f[lg>>2]|0;Cx=0;Tw=1;while(1){Uw=Y(f[Sw+(Cx<<2)>>2]|0,Tw)|0;Cx=Cx+1|0;if((Cx|0)==(Rw|0)){Rx=Uw;break}else Tw=Uw}}Tw=Ix+(Y(Rx,Qx)|0)|0;f[Uf>>2]=Tw}EL(M,0,0);f[N>>2]=w;Tw=f[Qf>>2]|0;if((Tw|0)>0)Sx=f[(f[Rf>>2]|0)+(Tw+-1<<2)>>2]|0;else Sx=0;f[Vf>>2]=Sx;f[Wf>>2]=0;f[Xf>>2]=0;f[Yf>>2]=0;if(f[w>>2]&16384|0){Rw=f[kg>>2]|0;f[Xf>>2]=Rw;if((Tw|0)<3)Tx=Y(f[_f>>2]|0,f[Zf>>2]|0)|0;else{Cx=f[lg>>2]|0;Sw=0;Bx=1;while(1){Uw=Y(f[Cx+(Sw<<2)>>2]|0,Bx)|0;Sw=Sw+1|0;if((Sw|0)==(Tw|0)){Tx=Uw;break}else Bx=Uw}}Bx=Rw+(Y(Tx,Sx)|0)|0;f[Yf>>2]=Bx}EL(N,0,0);Bx=f[Qf>>2]|0;if((Bx|0)<3)Ux=Y(f[_f>>2]|0,f[Zf>>2]|0)|0;else{Tw=f[lg>>2]|0;Sw=0;Cx=1;while(1){Ix=Y(f[Tw+(Sw<<2)>>2]|0,Cx)|0;Sw=Sw+1|0;if((Sw|0)==(Bx|0)){Ux=Ix;break}else Cx=Ix}}do if(!((Ux|0)==0|(f[N>>2]|0)==0)){Cx=Y(f[Vf>>2]|0,Ux)|0;Bx=(f[Wf>>2]|0)+Cx|0;f[Wf>>2]=Bx;if(Bx>>>0>=(f[Xf>>2]|0)>>>0?(f[Yf>>2]|0)>>>0>Bx>>>0:0)break;f[Wf>>2]=Bx+(0-Cx);DL(N,Ux,1)}while(0);f[O>>2]=x;Cx=f[ag>>2]|0;if((Cx|0)>0)Vx=f[(f[bg>>2]|0)+(Cx+-1<<2)>>2]|0;else Vx=0;f[$f>>2]=Vx;f[cg>>2]=0;f[dg>>2]=0;f[eg>>2]=0;if(f[x>>2]&16384|0){Bx=f[gg>>2]|0;f[dg>>2]=Bx;if((Cx|0)<3)Wx=Y(f[og>>2]|0,f[ng>>2]|0)|0;else{Sw=f[hg>>2]|0;Tw=0;Rw=1;while(1){Ix=Y(f[Sw+(Tw<<2)>>2]|0,Rw)|0;Tw=Tw+1|0;if((Tw|0)==(Cx|0)){Wx=Ix;break}else Rw=Ix}}Rw=Bx+(Y(Wx,Vx)|0)|0;f[eg>>2]=Rw}EL(O,0,0);while(1){Rw=f[M>>2]|0;if((Rw|0)==(f[N>>2]|0)){Cx=f[Sf>>2]|0;if((Cx|0)==(f[Wf>>2]|0))break;else{Xx=Cx;Yx=Cx}}else{Cx=f[Sf>>2]|0;Xx=Cx;Yx=Cx}Cx=f[cg>>2]|0;Tw=f[Xx>>2]|0;f[Xx>>2]=f[Cx>>2];f[Cx>>2]=Tw;do if(Rw|0){Tw=f[Pf>>2]|0;Cx=Yx+Tw|0;f[Sf>>2]=Cx;if(Cx>>>0<(f[Uf>>2]|0)>>>0)break;f[Sf>>2]=Cx+(0-Tw);DL(M,1,1)}while(0);if(!(f[O>>2]|0))continue;Rw=f[$f>>2]|0;Dx=(f[cg>>2]|0)+Rw|0;f[cg>>2]=Dx;if(Dx>>>0<(f[eg>>2]|0)>>>0)continue;f[cg>>2]=Dx+(0-Rw);DL(O,1,1)}Bx=f[fg>>2]|0;do if(Bx|0){Rw=Bx+12|0;Dx=f[Rw>>2]|0;f[Rw>>2]=Dx+-1;if((Dx|0)!=1)break;V$(x)}while(0);f[fg>>2]=0;f[gg>>2]=0;f[gg+4>>2]=0;f[gg+8>>2]=0;f[gg+12>>2]=0;if((f[ag>>2]|0)>0){Bx=f[hg>>2]|0;Dx=0;do{f[Bx+(Dx<<2)>>2]=0;Dx=Dx+1|0}while((Dx|0)<(f[ag>>2]|0))}Dx=f[bg>>2]|0;if((Dx|0)!=(ig|0))wL(Dx);Dx=f[jg>>2]|0;do if(Dx|0){Bx=Dx+12|0;Rw=f[Bx>>2]|0;f[Bx>>2]=Rw+-1;if((Rw|0)!=1)break;V$(w)}while(0);f[jg>>2]=0;f[kg>>2]=0;f[kg+4>>2]=0;f[kg+8>>2]=0;f[kg+12>>2]=0;if((f[Qf>>2]|0)>0){Dx=f[lg>>2]|0;Rw=0;do{f[Dx+(Rw<<2)>>2]=0;Rw=Rw+1|0}while((Rw|0)<(f[Qf>>2]|0))}Rw=f[Rf>>2]|0;if((Rw|0)!=(mg|0))wL(Rw);Ox=Ox+2|0;Px=f[Yb>>2]|0}while((Ox|0)<(f[f[Px+40>>2]>>2]|0))}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Rw=$Xc(16)|0;f[e>>2]=Rw;f[pg>>2]=-2147483632;f[qg>>2]=12;Pw=Rw;vx=396578;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Rw+12>>0]=0;Dx=SOa(c,r,e,t)|0;if((b[rg>>0]|0)<0)cYc(f[e>>2]|0);Bx=IGa(o,r)|0;f[Bx>>2]=Dx;vIa(e,f[(f[Fa>>2]|0)+4+(((f[v>>2]|0)==0&1)<<2)>>2]|0);wIa(a,o,c,e,Dx,0);if((b[sg>>0]|0)<0)cYc(f[e>>2]|0);Dx=IGa(k,r)|0;f[Dx>>2]=3;Dx=f[i>>2]|0;if(Dx|0){Bx=f[Xe>>2]|0;if((Bx|0)==(Dx|0))Zx=Dx;else{Tw=Bx;while(1){Bx=Tw+-16|0;f[Xe>>2]=Bx;if((b[Bx+11>>0]|0)<0){cYc(f[Bx>>2]|0);_x=f[Xe>>2]|0}else _x=Bx;if((_x|0)==(Dx|0))break;else Tw=_x}Zx=f[i>>2]|0}cYc(Zx)}break c}else{tx=nx;ux=ox}while(0);do if(((tx<<24>>24<0?ux:tx&255)|0)==7){if(LYc(s,0,-1,396499,7)|0){$x=b[Ia>>0]|0;ay=f[Pa>>2]|0;break}vIa(i,f[(f[Fa>>2]|0)+4>>2]|0);Tw=f[(f[Fa>>2]|0)+4>>2]|0;mYc(e,Tw,0,KYc(Tw,58,-1)|0,Tw);Tw=qIa(k,e)|0;if((b[xg>>0]|0)<0)cYc(f[e>>2]|0);if((Tw|0)==(ua|0))by=2;else by=f[Tw+28>>2]|0;if((CHa(l,f[(f[Fa>>2]|0)+8>>2]|0)|0)!=(xa|0)){f[Cg>>2]=0;f[Dg>>2]=0;f[P>>2]=Eg;Tw=f[l>>2]|0;if((Tw|0)!=(xa|0)){Dx=Tw;while(1){Tw=Dx+16|0;f[h>>2]=ih;f[e>>2]=f[h>>2];sIa(P,e,Tw,Tw)|0;Tw=f[Dx+4>>2]|0;do if(!Tw){Rw=Dx+8|0;Bx=f[Rw>>2]|0;if((f[Bx>>2]|0)==(Dx|0)){cy=Bx;break}else dy=Rw;do{Rw=f[dy>>2]|0;dy=Rw+8|0;Bx=f[dy>>2]|0}while((f[Bx>>2]|0)!=(Rw|0));cy=Bx}else{Bx=Tw;while(1){Rw=f[Bx>>2]|0;if(!Rw)break;else Bx=Rw}cy=Bx}while(0);if((cy|0)==(xa|0))break;else Dx=cy}}nKa(v,tIa(a,q,P,1,0)|0);EGa(P,f[Eg>>2]|0);Dx=f[Fg>>2]|0;Tw=(Dx|0)<3;if(Tw)ey=Y(f[Hg>>2]|0,f[Gg>>2]|0)|0;else{Rw=f[gh>>2]|0;Cx=0;Sw=1;while(1){Ix=Y(f[Rw+(Cx<<2)>>2]|0,Sw)|0;Cx=Cx+1|0;if((Cx|0)==(Dx|0)){ey=Ix;break}else Sw=Ix}}Sw=(by|0)==0;do if(Sw&(ey|0)!=4){f[Ig>>2]=0;f[Jg>>2]=0;f[e>>2]=Kg;Pw=Lg;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Mg>>0]=5;b[h>>0]=b[450562]|0;b[h+1>>0]=b[450563]|0;b[h+2>>0]=b[450564]|0;b[h+3>>0]=b[450565]|0;b[h+4>>0]=b[450566]|0;b[Ng>>0]=0;Cx=$Xc(16)|0;f[Cx>>2]=Cx+8;f[Cx+4>>2]=4;Rw=bYc(32)|0;f[Cx>>2]=Rw;f[w>>2]=0;f[Og>>2]=Cx;Cx=Rw;f[Cx>>2]=0;f[Cx+4>>2]=0;Cx=Rw+8|0;f[Cx>>2]=2;f[Cx+4>>2]=0;Cx=Rw+16|0;f[Cx>>2]=3;f[Cx+4>>2]=0;Cx=Rw+24|0;f[Cx>>2]=1;f[Cx+4>>2]=0;$Ga(e,h,w)|0;RGa(w);if((b[Mg>>0]|0)<0)cYc(f[h>>2]|0);AN(h,r,378120);if((CHa(o,h)|0)!=(qa|0)){Yw=805;break b}f[jw>>2]=0;b[Pg>>0]=7;b[w>>0]=b[428903]|0;b[w+1>>0]=b[428904]|0;b[w+2>>0]=b[428905]|0;b[w+3>>0]=b[428906]|0;b[w+4>>0]=b[428907]|0;b[w+5>>0]=b[428908]|0;b[w+6>>0]=b[428909]|0;b[Qg>>0]=0;Cx=SOa(c,h,w,e)|0;if((b[Pg>>0]|0)<0)cYc(f[w>>2]|0);Rw=IGa(o,h)|0;f[Rw>>2]=Cx;wIa(a,o,c,i,Cx,0);lYc(w,h);f[Rg>>2]=0;if((b[Bg>>0]|0)<0){b[f[i>>2]>>0]=0;f[Sg>>2]=0}else{b[i>>0]=0;b[Bg>>0]=0}sYc(i,0);f[i>>2]=f[w>>2];f[i+4>>2]=f[w+4>>2];f[i+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[Tg>>2]=f[Rg>>2];if((b[Ug>>0]|0)<0)cYc(f[h>>2]|0);if((b[Wg>>0]|0)<0)cYc(f[Vg>>2]|0);if((b[Yg>>0]|0)<0)cYc(f[Xg>>2]|0);hx(Zg);QGa(e,f[Kg>>2]|0);fy=1}else{if(Tw)gy=Y(f[Hg>>2]|0,f[Gg>>2]|0)|0;else{Cx=f[gh>>2]|0;Rw=0;Ix=1;while(1){Uw=Y(f[Cx+(Rw<<2)>>2]|0,Ix)|0;Rw=Rw+1|0;if((Rw|0)==(Dx|0)){gy=Uw;break}else Ix=Uw}}if(!(Sw&(gy|0)==4)){fy=by;break}Ix=f[ah>>2]|0;Rw=(f[bh>>2]|0)+4|0;Cx=f[Rw>>2]|0;Uw=Ix+(Cx<<1)|0;Vw=Ix+(Cx*3|0)|0;Cx=f[Uw>>2]|0;f[Uw>>2]=f[Vw>>2];f[Vw>>2]=Cx;Cx=f[Rw>>2]|0;Rw=Ix+Cx|0;Vw=Ix+(Cx<<1)|0;Cx=f[Rw>>2]|0;f[Rw>>2]=f[Vw>>2];f[Vw>>2]=Cx;fy=0}while(0);Sw=kw;f[Sw>>2]=0;f[Sw+4>>2]=0;b[_g>>0]=3;b[e>>0]=b[515177]|0;b[e+1>>0]=b[515178]|0;b[e+2>>0]=b[515179]|0;b[$g>>0]=0;Sw=f[ah>>2]|0;Dx=f[Fg>>2]|0;if((Dx|0)<3)hy=Y(f[Hg>>2]|0,f[Gg>>2]|0)|0;else{Tw=f[gh>>2]|0;Cx=0;Vw=1;while(1){Rw=Y(f[Tw+(Cx<<2)>>2]|0,Vw)|0;Cx=Cx+1|0;if((Cx|0)==(Dx|0)){hy=Rw;break}else Vw=Rw}}Vw=$Xc(16)|0;Dx=Vw+8|0;f[Vw>>2]=Dx;f[Vw+4>>2]=hy;if(hy>>>0>1){Cx=bYc(hy>>>0>536870911?-1:hy<<3)|0;f[Vw>>2]=Cx;iy=Cx}else iy=Dx;f[h>>2]=0;f[ch>>2]=Vw;if((hy|0)>0){Vw=Sw;Dx=0;while(1){Cx=f[Vw>>2]|0;Tw=iy+(Dx<<3)|0;f[Tw>>2]=Cx;f[Tw+4>>2]=((Cx|0)<0)<<31>>31;Dx=Dx+1|0;if((Dx|0)==(hy|0))break;else Vw=Vw+4|0}}$Ga(t,e,h)|0;RGa(h);if((b[_g>>0]|0)<0)cYc(f[e>>2]|0);f[lw>>2]=0;b[dh>>0]=7;b[e>>0]=b[396499]|0;b[e+1>>0]=b[396500]|0;b[e+2>>0]=b[396501]|0;b[e+3>>0]=b[396502]|0;b[e+4>>0]=b[396503]|0;b[e+5>>0]=b[396504]|0;b[e+6>>0]=b[396505]|0;b[eh>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[dh>>0]|0)<0)cYc(f[e>>2]|0);Dx=IGa(o,r)|0;f[Dx>>2]=Vw;wIa(a,o,c,i,Vw,0);Vw=f[Fg>>2]|0;if((Vw|0)<3)jy=Y(f[Hg>>2]|0,f[Gg>>2]|0)|0;else{Dx=f[gh>>2]|0;Sw=0;Cx=1;while(1){Tw=Y(f[Dx+(Sw<<2)>>2]|0,Cx)|0;Sw=Sw+1|0;if((Sw|0)==(Vw|0)){jy=Tw;break}else Cx=Tw}}Cx=IGa(k,r)|0;f[Cx>>2]=(jy|0)==2?3:fy;Cx=f[fh>>2]|0;do if(Cx|0){Vw=Cx+12|0;Sw=f[Vw>>2]|0;f[Vw>>2]=Sw+-1;if((Sw|0)!=1)break;V$(v)}while(0);f[fh>>2]=0;f[ah>>2]=0;f[ah+4>>2]=0;f[ah+8>>2]=0;f[ah+12>>2]=0;if((f[Fg>>2]|0)>0){Cx=f[gh>>2]|0;Sw=0;do{f[Cx+(Sw<<2)>>2]=0;Sw=Sw+1|0}while((Sw|0)<(f[Fg>>2]|0))}Sw=f[bh>>2]|0;if((Sw|0)!=(hh|0))wL(Sw)}else{f[iw>>2]=0;b[yg>>0]=7;b[e>>0]=b[396499]|0;b[e+1>>0]=b[396500]|0;b[e+2>>0]=b[396501]|0;b[e+3>>0]=b[396502]|0;b[e+4>>0]=b[396503]|0;b[e+5>>0]=b[396504]|0;b[e+6>>0]=b[396505]|0;b[zg>>0]=0;Sw=SOa(c,r,e,t)|0;if((b[yg>>0]|0)<0)cYc(f[e>>2]|0);Cx=IGa(o,r)|0;f[Cx>>2]=Sw;wIa(a,o,c,i,Sw,0);vIa(e,f[(f[Fa>>2]|0)+8>>2]|0);wIa(a,o,c,e,Sw,1);if((b[Ag>>0]|0)<0)cYc(f[e>>2]|0);Sw=IGa(k,r)|0;f[Sw>>2]=by}if((b[Bg>>0]|0)<0)cYc(f[i>>2]|0);break c}else{$x=tx;ay=ux}while(0);do if((($x<<24>>24<0?ay:$x&255)|0)==7){if(!(LYc(s,0,-1,396507,7)|0))break;ky=b[Ia>>0]|0;ly=f[Pa>>2]|0;Yw=860}else{ky=$x;ly=ay;Yw=860}while(0);do if((Yw|0)==860){Yw=0;if(((ky<<24>>24<0?ly:ky&255)|0)==7){if(!(LYc(s,0,-1,378168,7)|0))break;my=b[Ia>>0]|0;ny=f[Pa>>2]|0}else{my=ky;ny=ly}do if(((my<<24>>24<0?ny:my&255)|0)==9){if(LYc(s,0,-1,390744,9)|0){oy=b[Ia>>0]|0;py=f[Pa>>2]|0;break}f[Mh>>2]=0;f[Nh>>2]=0;f[Q>>2]=Oh;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Cx=Sw;while(1){Sw=Cx+16|0;f[h>>2]=gi;f[e>>2]=f[h>>2];sIa(Q,e,Sw,Sw)|0;Sw=f[Cx+4>>2]|0;do if(!Sw){Vw=Cx+8|0;Dx=f[Vw>>2]|0;if((f[Dx>>2]|0)==(Cx|0)){qy=Dx;break}else ry=Vw;do{Vw=f[ry>>2]|0;ry=Vw+8|0;Dx=f[ry>>2]|0}while((f[Dx>>2]|0)!=(Vw|0));qy=Dx}else{Dx=Sw;while(1){Vw=f[Dx>>2]|0;if(!Vw)break;else Dx=Vw}qy=Dx}while(0);if((qy|0)==(xa|0))break;else Cx=qy}}nKa(i,tIa(a,q,Q,1,0)|0);EGa(Q,f[Oh>>2]|0);if((f[i>>2]&4095|0)!=4){Yw=918;break b}Cx=f[Ph>>2]|0;Sw=f[Qh>>2]|0;Bx=(Sw|0)<3;if(Bx)sy=Y(f[Sh>>2]|0,f[Rh>>2]|0)|0;else{Vw=f[Yh>>2]|0;Tw=0;Rw=1;while(1){Ix=Y(f[Vw+(Tw<<2)>>2]|0,Rw)|0;Tw=Tw+1|0;if((Tw|0)==(Sw|0)){sy=Ix;break}else Rw=Ix}}if((sy|0)==4){Rw=f[(f[Fa>>2]|0)+4>>2]|0;mYc(e,Rw,0,KYc(Rw,58,-1)|0,Rw);Rw=qIa(k,e)|0;if((b[Th>>0]|0)<0)cYc(f[e>>2]|0);e:do if((Rw|0)!=(ua|0))switch(f[Rw+28>>2]|0){case 0:{if(f[Cx>>2]|0){Yw=936;break b}switch(f[Cx+4>>2]|0){case 3:{if((f[Cx+8>>2]|0)!=1){Yw=936;break b}if((f[Cx+12>>2]|0)!=2){Yw=936;break b}Tw=IGa(k,r)|0;f[Tw>>2]=1;break e;break}case 1:{if((f[Cx+8>>2]|0)!=2){Yw=936;break b}if((f[Cx+12>>2]|0)!=3){Yw=936;break b}Tw=IGa(k,r)|0;f[Tw>>2]=0;break e;break}default:{Yw=936;break b}}break}case 1:{if(f[Cx>>2]|0){Yw=945;break b}switch(f[Cx+4>>2]|0){case 2:{if((f[Cx+8>>2]|0)!=3){Yw=945;break b}if((f[Cx+12>>2]|0)!=1){Yw=945;break b}Tw=IGa(k,r)|0;f[Tw>>2]=0;break e;break}case 1:{if((f[Cx+8>>2]|0)!=2){Yw=945;break b}if((f[Cx+12>>2]|0)!=3){Yw=945;break b}Tw=IGa(k,r)|0;f[Tw>>2]=1;break e;break}default:{Yw=945;break b}}break}default:break e}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Uh>>0]=8;Rw=e;f[Rw>>2]=1852138569;f[Rw+4>>2]=2037672308;b[Vh>>0]=0;Rw=SOa(c,r,e,t)|0;if((b[Uh>>0]|0)<0)cYc(f[e>>2]|0);Tw=IGa(o,r)|0;f[Tw>>2]=Rw;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Rw,0);if((b[Wh>>0]|0)<0)cYc(f[e>>2]|0)}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[$h>>0]=5;b[e>>0]=b[450562]|0;b[e+1>>0]=b[450563]|0;b[e+2>>0]=b[450564]|0;b[e+3>>0]=b[450565]|0;b[e+4>>0]=b[450566]|0;b[ai>>0]=0;if(Bx)ty=Y(f[Sh>>2]|0,f[Rh>>2]|0)|0;else{Rw=f[Yh>>2]|0;Tw=0;Vw=1;while(1){Ix=Y(f[Rw+(Tw<<2)>>2]|0,Vw)|0;Tw=Tw+1|0;if((Tw|0)==(Sw|0)){ty=Ix;break}else Vw=Ix}}Vw=$Xc(16)|0;Sw=Vw+8|0;f[Vw>>2]=Sw;f[Vw+4>>2]=ty;if(ty>>>0>1){Tw=bYc(ty>>>0>536870911?-1:ty<<3)|0;f[Vw>>2]=Tw;uy=Tw}else uy=Sw;f[h>>2]=0;f[bi>>2]=Vw;if((ty|0)>0){Vw=Cx;Sw=0;while(1){Tw=f[Vw>>2]|0;Rw=uy+(Sw<<3)|0;f[Rw>>2]=Tw;f[Rw+4>>2]=((Tw|0)<0)<<31>>31;Sw=Sw+1|0;if((Sw|0)==(ty|0))break;else Vw=Vw+4|0}}$Ga(t,e,h)|0;RGa(h);if((b[$h>>0]|0)<0)cYc(f[e>>2]|0);f[ow>>2]=0;b[ci>>0]=7;b[e>>0]=b[428903]|0;b[e+1>>0]=b[428904]|0;b[e+2>>0]=b[428905]|0;b[e+3>>0]=b[428906]|0;b[e+4>>0]=b[428907]|0;b[e+5>>0]=b[428908]|0;b[e+6>>0]=b[428909]|0;b[di>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[ci>>0]|0)<0)cYc(f[e>>2]|0);Sw=IGa(o,r)|0;f[Sw>>2]=Vw;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Vw,0);if((b[fi>>0]|0)<0)cYc(f[e>>2]|0);Vw=IGa(k,r)|0;f[Vw>>2]=2}Vw=f[Xh>>2]|0;do if(Vw|0){Sw=Vw+12|0;Cx=f[Sw>>2]|0;f[Sw>>2]=Cx+-1;if((Cx|0)!=1)break;V$(i)}while(0);f[Xh>>2]=0;f[Ph>>2]=0;f[Ph+4>>2]=0;f[Ph+8>>2]=0;f[Ph+12>>2]=0;if((f[Qh>>2]|0)>0){Vw=f[Yh>>2]|0;Cx=0;do{f[Vw+(Cx<<2)>>2]=0;Cx=Cx+1|0}while((Cx|0)<(f[Qh>>2]|0))}Cx=f[Zh>>2]|0;if((Cx|0)!=(_h|0))wL(Cx);break c}else{oy=my;py=ny}while(0);if(((oy<<24>>24<0?py:oy&255)|0)==5){if(!(LYc(s,0,-1,381538,5)|0))break c;vy=b[Ia>>0]|0;wy=f[Pa>>2]|0}else{vy=oy;wy=py}do if(((vy<<24>>24<0?wy:vy&255)|0)==3){if(LYc(s,0,-1,396574,3)|0){xy=b[Ia>>0]|0;yy=f[Pa>>2]|0;break};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[hi>>0]=5;b[i>>0]=b[441815]|0;b[i+1>>0]=b[441816]|0;b[i+2>>0]=b[441817]|0;b[i+3>>0]=b[441818]|0;b[i+4>>0]=b[441819]|0;b[ii>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[ji>>2]|0,i,0);Cx=(f[e>>2]|0)==0;zIa(h);if((b[hi>>0]|0)<0)cYc(f[i>>2]|0);if(!Cx){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Ni>>0]=5;b[e>>0]=b[441815]|0;b[e+1>>0]=b[441816]|0;b[e+2>>0]=b[441817]|0;b[e+3>>0]=b[441818]|0;b[e+4>>0]=b[441819]|0;b[Oi>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Pi>>0]=5;b[i>>0]=b[441815]|0;b[i+1>>0]=b[441816]|0;b[i+2>>0]=b[441817]|0;b[i+3>>0]=b[441818]|0;b[i+4>>0]=b[441819]|0;b[Qi>>0]=0;elc(Sb);Cx=AIa(Tb,i)|0;n[h>>2]=(f[Cx+20>>2]|0)==4?+n[Cx+8>>2]:0.0;OGa(t,e,h)|0;if((b[Pi>>0]|0)<0)cYc(f[i>>2]|0);if((b[Ni>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ki>>0]=4;f[i>>2]=1635018082;b[li>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[mi>>2]|0,i,0);Cx=(f[e>>2]|0)==0;zIa(h);if((b[ki>>0]|0)<0)cYc(f[i>>2]|0);if(!Cx){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Ji>>0]=4;f[e>>2]=1635018082;b[Ki>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Li>>0]=4;f[i>>2]=1635018082;b[Mi>>0]=0;elc(Sb);Cx=AIa(Tb,i)|0;n[h>>2]=(f[Cx+20>>2]|0)==4?+n[Cx+8>>2]:0.0;OGa(t,e,h)|0;if((b[Li>>0]|0)<0)cYc(f[i>>2]|0);if((b[Ji>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Cx=$Xc(16)|0;f[i>>2]=Cx;f[ni>>2]=-2147483632;f[oi>>2]=12;Pw=Cx;vx=378328;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Cx+12>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[pi>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[qi>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Vw=$Xc(16)|0;f[e>>2]=Vw;f[Ei>>2]=-2147483632;f[Fi>>2]=12;Pw=Vw;vx=378328;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+12>>0]=0;elc(Sb);Cx=AIa(Tb,e)|0;Sw=(f[Cx+20>>2]|0)==3;Tw=f[Cx+8>>2]|0;if((b[Gi>>0]|0)<0)cYc(f[e>>2]|0);b[Hi>>0]=10;Pw=e;vx=441745;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ii>>0]=0;f[h>>2]=Sw?Tw<<1|1:1;aHa(t,e,h)|0;if((b[Hi>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ri>>0]=4;f[i>>2]=1935763810;b[si>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[ti>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[ri>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Ai>>0]=4;f[e>>2]=1935763810;b[Bi>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Ci>>0]=4;f[i>>2]=1935763810;b[Di>>0]=0;elc(Sb);Vw=AIa(Tb,i)|0;n[h>>2]=(f[Vw+20>>2]|0)==4?+n[Vw+8>>2]:0.0;OGa(t,e,h)|0;if((b[Ci>>0]|0)<0)cYc(f[i>>2]|0);if((b[Ai>>0]|0)<0)cYc(f[e>>2]|0)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Vw=$Xc(16)|0;f[e>>2]=Vw;f[ui>>2]=-2147483632;f[vi>>2]=12;Pw=Vw;vx=441821;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+12>>0]=0;b[h>>0]=0;cHa(t,e,h)|0;if((b[wi>>0]|0)<0)cYc(f[e>>2]|0);Tw=pw;f[Tw>>2]=0;f[Tw+4>>2]=0;b[xi>>0]=3;b[e>>0]=b[396574]|0;b[e+1>>0]=b[396575]|0;b[e+2>>0]=b[396576]|0;b[yi>>0]=0;Tw=SOa(c,r,e,t)|0;if((b[xi>>0]|0)<0)cYc(f[e>>2]|0);Sw=IGa(o,r)|0;f[Sw>>2]=Tw;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);Sw=f[Da>>2]|0;if((Sw|0)>0){Cx=0;do{wIa(a,o,c,e,Tw,Cx);Cx=Cx+1|0}while((Cx|0)!=(Sw|0))}if((b[zi>>0]|0)<0)cYc(f[e>>2]|0);break c}else{xy=vy;yy=wy}while(0);do if(((xy<<24>>24<0?yy:xy&255)|0)==6){if(!(LYc(s,0,-1,428960,6)|0))break;zy=b[Ia>>0]|0;Ay=f[Pa>>2]|0;Yw=1025}else{zy=xy;Ay=yy;Yw=1025}while(0);do if((Yw|0)==1025){Yw=0;if(((zy<<24>>24<0?Ay:zy&255)|0)==8){if(!(LYc(s,0,-1,378341,8)|0))break;By=b[Ia>>0]|0;Cy=f[Pa>>2]|0}else{By=zy;Cy=Ay}do if(((By<<24>>24<0?Cy:By&255)|0)==7){if(LYc(s,0,-1,390411,7)|0){Dy=b[Ia>>0]|0;Ey=f[Pa>>2]|0;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[aj>>0]=4;f[e>>2]=1819242352;b[bj>>0]=0;JIa(t,e,443327)|0;if((b[aj>>0]|0)<0)cYc(f[e>>2]|0);KIa(t,q);GIa(t,q);IIa(t,q);f[qw>>2]=0;b[cj>>0]=7;b[e>>0]=b[429057]|0;b[e+1>>0]=b[429058]|0;b[e+2>>0]=b[429059]|0;b[e+3>>0]=b[429060]|0;b[e+4>>0]=b[429061]|0;b[e+5>>0]=b[429062]|0;b[e+6>>0]=b[429063]|0;b[dj>>0]=0;Sw=SOa(c,r,e,t)|0;if((b[cj>>0]|0)<0)cYc(f[e>>2]|0);Cx=IGa(o,r)|0;f[Cx>>2]=Sw;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);Cx=f[Da>>2]|0;if((Cx|0)>0){Tw=0;do{wIa(a,o,c,e,Sw,Tw);Tw=Tw+1|0}while((Tw|0)!=(Cx|0))}if((b[ej>>0]|0)<0)cYc(f[e>>2]|0);break c}else{Dy=By;Ey=Cy}while(0);do if(((Dy<<24>>24<0?Ey:Dy&255)|0)==7){if(LYc(s,0,-1,378378,7)|0){Fy=b[Ia>>0]|0;Gy=f[Pa>>2]|0;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[fj>>0]=4;f[e>>2]=1819242352;b[gj>>0]=0;JIa(t,e,443331)|0;if((b[fj>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Cx=$Xc(32)|0;f[e>>2]=Cx;f[hj>>2]=-2147483616;f[ij>>2]=20;Pw=Cx;vx=443543;Qw=Pw+20|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Cx+20>>0]=0;b[h>>0]=0;cHa(t,e,h)|0;if((b[jj>>0]|0)<0)cYc(f[e>>2]|0);KIa(t,q);GIa(t,q);IIa(t,q);f[rw>>2]=0;b[kj>>0]=7;b[e>>0]=b[429057]|0;b[e+1>>0]=b[429058]|0;b[e+2>>0]=b[429059]|0;b[e+3>>0]=b[429060]|0;b[e+4>>0]=b[429061]|0;b[e+5>>0]=b[429062]|0;b[e+6>>0]=b[429063]|0;b[lj>>0]=0;Tw=SOa(c,r,e,t)|0;if((b[kj>>0]|0)<0)cYc(f[e>>2]|0);Sw=IGa(o,r)|0;f[Sw>>2]=Tw;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);Sw=f[Da>>2]|0;if((Sw|0)>0){Vw=0;do{wIa(a,o,c,e,Tw,Vw);Vw=Vw+1|0}while((Vw|0)!=(Sw|0))}if((b[mj>>0]|0)<0)cYc(f[e>>2]|0);break c}else{Fy=Dy;Gy=Ey}while(0);do if(((Fy<<24>>24<0?Gy:Fy&255)|0)==11){if(LYc(s,0,-1,378386,11)|0){Hy=b[Ia>>0]|0;Iy=f[Pa>>2]|0;break};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[nj>>0]=5;b[i>>0]=b[378398]|0;b[i+1>>0]=b[378399]|0;b[i+2>>0]=b[378400]|0;b[i+3>>0]=b[378401]|0;b[i+4>>0]=b[378402]|0;b[oj>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[pj>>2]|0,i,0);Sw=(f[e>>2]|0)==0;zIa(h);if(Sw)Jy=1;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[tj>>0]=5;b[e>>0]=b[378398]|0;b[e+1>>0]=b[378399]|0;b[e+2>>0]=b[378400]|0;b[e+3>>0]=b[378401]|0;b[e+4>>0]=b[378402]|0;b[uj>>0]=0;elc(Sb);Sw=AIa(Tb,e)|0;Vw=(f[Sw+20>>2]|0)!=6?1:(f[Sw+8>>2]|0)!=10;if((b[tj>>0]|0)<0)cYc(f[e>>2]|0);Jy=Vw}if((b[nj>>0]|0)<0)cYc(f[i>>2]|0);if(!Jy)break c;Vw=f[qj>>2]|0;if((Vw|0)==(f[rj>>2]|0))NN(sj,r);else{lYc(Vw,r);f[qj>>2]=(f[qj>>2]|0)+12}Vw=IGa(o,r)|0;f[Vw>>2]=0;break c}else{Hy=Fy;Iy=Gy}while(0);do if(((Hy<<24>>24<0?Iy:Hy&255)|0)==5){if(LYc(s,0,-1,396493,5)|0){Ky=b[Ia>>0]|0;Ly=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=2){Yw=1110;break b}f[vj>>2]=0;f[wj>>2]=0;f[S>>2]=xj;Vw=f[l>>2]|0;if((Vw|0)!=(xa|0)){Sw=Vw;while(1){Vw=Sw+16|0;f[h>>2]=Dj;f[e>>2]=f[h>>2];sIa(S,e,Vw,Vw)|0;Vw=f[Sw+4>>2]|0;do if(!Vw){Tw=Sw+8|0;Cx=f[Tw>>2]|0;if((f[Cx>>2]|0)==(Sw|0)){My=Cx;break}else Ny=Tw;do{Tw=f[Ny>>2]|0;Ny=Tw+8|0;Cx=f[Ny>>2]|0}while((f[Cx>>2]|0)!=(Tw|0));My=Cx}else{Cx=Vw;while(1){Tw=f[Cx>>2]|0;if(!Tw)break;else Cx=Tw}My=Cx}while(0);if((My|0)==(xa|0))break;else Sw=My}}Sw=(tIa(a,q,S,0,0)|0)+48|0;Vw=f[(f[Sw>>2]|0)+4>>2]|0;EGa(S,f[xj>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[yj>>0]=4;f[h>>2]=1936291937;b[zj>>0]=0;Sw=Vw+4|0;if(Sw>>>0>=8){Yw=1119;break b}do if(Vw)if((Vw|0)>0){Oy=((Vw>>>0)%3|0)+1|0;break}else{Oy=((Sw>>>0)%3|0)+1|0;break}else Oy=0;while(0);f[i>>2]=Oy;aHa(t,h,i)|0;if((b[yj>>0]|0)<0)cYc(f[h>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Aj>>0]=5;b[e>>0]=b[396487]|0;b[e+1>>0]=b[396488]|0;b[e+2>>0]=b[396489]|0;b[e+3>>0]=b[396490]|0;b[e+4>>0]=b[396491]|0;b[Bj>>0]=0;Sw=SOa(c,r,e,t)|0;if((b[Aj>>0]|0)<0)cYc(f[e>>2]|0);Vw=IGa(o,r)|0;f[Vw>>2]=Sw;vIa(e,f[(f[Fa>>2]|0)+8>>2]|0);wIa(a,o,c,e,Sw,0);if((b[Cj>>0]|0)<0)cYc(f[e>>2]|0);break c}else{Ky=Hy;Ly=Iy}while(0);do if(((Ky<<24>>24<0?Ly:Ky&255)|0)==5){if(LYc(s,0,-1,396487,5)|0){Py=b[Ia>>0]|0;Qy=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=3){Yw=1135;break b}f[Ej>>2]=0;f[Fj>>2]=0;f[T>>2]=Gj;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Vw=Sw;while(1){Sw=Vw+16|0;f[h>>2]=kk;f[e>>2]=f[h>>2];sIa(T,e,Sw,Sw)|0;Sw=f[Vw+4>>2]|0;do if(!Sw){Dx=Vw+8|0;Tw=f[Dx>>2]|0;if((f[Tw>>2]|0)==(Vw|0)){Ry=Tw;break}else Sy=Dx;do{Dx=f[Sy>>2]|0;Sy=Dx+8|0;Tw=f[Sy>>2]|0}while((f[Tw>>2]|0)!=(Dx|0));Ry=Tw}else{Cx=Sw;while(1){Tw=f[Cx>>2]|0;if(!Tw)break;else Cx=Tw}Ry=Cx}while(0);if((Ry|0)==(xa|0))break;else Vw=Ry}}nKa(i,tIa(a,q,T,1,0)|0);EGa(T,f[Gj>>2]|0);f[Hj>>2]=0;f[Ij>>2]=0;f[U>>2]=Jj;Vw=f[l>>2]|0;if((Vw|0)!=(xa|0)){Sw=Vw;while(1){Vw=Sw+16|0;f[h>>2]=jk;f[e>>2]=f[h>>2];sIa(U,e,Vw,Vw)|0;Vw=f[Sw+4>>2]|0;do if(!Vw){Tw=Sw+8|0;Dx=f[Tw>>2]|0;if((f[Dx>>2]|0)==(Sw|0)){Ty=Dx;break}else Uy=Tw;do{Tw=f[Uy>>2]|0;Uy=Tw+8|0;Dx=f[Uy>>2]|0}while((f[Dx>>2]|0)!=(Tw|0));Ty=Dx}else{Cx=Vw;while(1){Dx=f[Cx>>2]|0;if(!Dx)break;else Cx=Dx}Ty=Cx}while(0);if((Ty|0)==(xa|0))break;else Sw=Ty}}nKa(v,tIa(a,q,U,2,0)|0);EGa(U,f[Jj>>2]|0);if(!(f[Kj>>2]|0)){Yw=1156;break b}Sw=f[Lj>>2]|0;Vw=(Sw|0)<3;if(Vw)Vy=Y(f[Nj>>2]|0,f[Mj>>2]|0)|0;else{Dx=f[hk>>2]|0;Tw=0;Rw=1;while(1){Bx=Y(f[Dx+(Tw<<2)>>2]|0,Rw)|0;Tw=Tw+1|0;if((Tw|0)==(Sw|0)){Vy=Bx;break}else Rw=Bx}}if((Sw|0)==0|(Vy|0)==0){Yw=1156;break b}if(!(f[Oj>>2]|0)){Yw=1163;break b}Rw=f[Pj>>2]|0;if((Rw|0)<3)Wy=Y(f[Rj>>2]|0,f[Qj>>2]|0)|0;else{Tw=f[ek>>2]|0;Dx=0;Bx=1;while(1){Ix=Y(f[Tw+(Dx<<2)>>2]|0,Bx)|0;Dx=Dx+1|0;if((Dx|0)==(Rw|0)){Wy=Ix;break}else Bx=Ix}}if((Rw|0)==0|(Wy|0)==0){Yw=1163;break b}Xy=f[i>>2]&4095;if((Xy|0)!=4){Yw=1165;break b}Yy=f[v>>2]&4095;if((Yy|0)!=4){Yw=1167;break b}if(Vw)Zy=Y(f[Nj>>2]|0,f[Mj>>2]|0)|0;else{Bx=f[hk>>2]|0;Dx=0;Tw=1;while(1){Ix=Y(f[Bx+(Dx<<2)>>2]|0,Tw)|0;Dx=Dx+1|0;if((Dx|0)==(Sw|0)){Zy=Ix;break}else Tw=Ix}}do if((Zy|0)==4){mYc(e,r,0,KYc(r,58,-1)|0,r);Tw=qIa(k,e)|0;if((b[Sj>>0]|0)<0)cYc(f[e>>2]|0);if((Tw|0)==(ua|0))break;if(f[Tw+28>>2]|0)break;Tw=f[Kj>>2]|0;Sw=(f[Tj>>2]|0)+4|0;Dx=f[Sw>>2]|0;Bx=Tw+(Dx<<1)|0;Vw=Tw+(Dx*3|0)|0;Dx=f[Bx>>2]|0;f[Bx>>2]=f[Vw>>2];f[Vw>>2]=Dx;Dx=f[Sw>>2]|0;Sw=Tw+Dx|0;Vw=Tw+(Dx<<1)|0;Dx=f[Sw>>2]|0;f[Sw>>2]=f[Vw>>2];f[Vw>>2]=Dx;Dx=f[Oj>>2]|0;Vw=(f[Uj>>2]|0)+4|0;Sw=f[Vw>>2]|0;Tw=Dx+(Sw<<1)|0;Bx=Dx+(Sw*3|0)|0;Sw=f[Tw>>2]|0;f[Tw>>2]=f[Bx>>2];f[Bx>>2]=Sw;Sw=f[Vw>>2]|0;Vw=Dx+Sw|0;Bx=Dx+(Sw<<1)|0;Sw=f[Vw>>2]|0;f[Vw>>2]=f[Bx>>2];f[Bx>>2]=Sw}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Vj>>0]=5;b[e>>0]=b[448895]|0;b[e+1>>0]=b[448896]|0;b[e+2>>0]=b[448897]|0;b[e+3>>0]=b[448898]|0;b[e+4>>0]=b[448899]|0;b[Wj>>0]=0;Sw=f[Kj>>2]|0;Bx=f[Lj>>2]|0;if((Bx|0)<3)_y=Y(f[Nj>>2]|0,f[Mj>>2]|0)|0;else{Vw=f[hk>>2]|0;Dx=0;Tw=1;while(1){Rw=Y(f[Vw+(Dx<<2)>>2]|0,Tw)|0;Dx=Dx+1|0;if((Dx|0)==(Bx|0)){_y=Rw;break}else Tw=Rw}}Tw=$Xc(16)|0;Bx=Tw+8|0;f[Tw>>2]=Bx;f[Tw+4>>2]=_y;if(_y>>>0>1){Dx=bYc(_y>>>0>536870911?-1:_y<<3)|0;f[Tw>>2]=Dx;$y=Dx}else $y=Bx;f[h>>2]=0;f[Xj>>2]=Tw;if((_y|0)>0){Tw=Sw;Bx=0;while(1){Dx=f[Tw>>2]|0;Vw=$y+(Bx<<3)|0;f[Vw>>2]=Dx;f[Vw+4>>2]=((Dx|0)<0)<<31>>31;Bx=Bx+1|0;if((Bx|0)==(_y|0))break;else Tw=Tw+4|0}}$Ga(t,e,h)|0;RGa(h);if((b[Vj>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Yj>>0]=4;f[e>>2]=1702521203;b[_j>>0]=0;Tw=f[Oj>>2]|0;Bx=f[Pj>>2]|0;if((Bx|0)<3)az=Y(f[Rj>>2]|0,f[Qj>>2]|0)|0;else{Sw=f[ek>>2]|0;Dx=0;Vw=1;while(1){Rw=Y(f[Sw+(Dx<<2)>>2]|0,Vw)|0;Dx=Dx+1|0;if((Dx|0)==(Bx|0)){az=Rw;break}else Vw=Rw}}Vw=$Xc(16)|0;Bx=Vw+8|0;f[Vw>>2]=Bx;f[Vw+4>>2]=az;if(az>>>0>1){Dx=bYc(az>>>0>536870911?-1:az<<3)|0;f[Vw>>2]=Dx;bz=Dx}else bz=Bx;f[h>>2]=0;f[$j>>2]=Vw;if((az|0)>0){Vw=Tw;Bx=0;while(1){Dx=f[Vw>>2]|0;Sw=bz+(Bx<<3)|0;f[Sw>>2]=Dx;f[Sw+4>>2]=((Dx|0)<0)<<31>>31;Bx=Bx+1|0;if((Bx|0)==(az|0))break;else Vw=Vw+4|0}}$Ga(t,e,h)|0;RGa(h);if((b[Yj>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ak>>0]=5;b[e>>0]=b[396487]|0;b[e+1>>0]=b[396488]|0;b[e+2>>0]=b[396489]|0;b[e+3>>0]=b[396490]|0;b[e+4>>0]=b[396491]|0;b[bk>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[ak>>0]|0)<0)cYc(f[e>>2]|0);Bx=IGa(o,r)|0;f[Bx>>2]=Vw;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Vw,0);if((b[ck>>0]|0)<0)cYc(f[e>>2]|0);Vw=f[dk>>2]|0;do if(Vw|0){Bx=Vw+12|0;Tw=f[Bx>>2]|0;f[Bx>>2]=Tw+-1;if((Tw|0)!=1)break;V$(v)}while(0);f[dk>>2]=0;f[Oj>>2]=0;f[Oj+4>>2]=0;f[Oj+8>>2]=0;f[Oj+12>>2]=0;if((f[Pj>>2]|0)>0){Vw=f[ek>>2]|0;Tw=0;do{f[Vw+(Tw<<2)>>2]=0;Tw=Tw+1|0}while((Tw|0)<(f[Pj>>2]|0))}Tw=f[Uj>>2]|0;if((Tw|0)!=(fk|0))wL(Tw);Tw=f[gk>>2]|0;do if(Tw|0){Vw=Tw+12|0;Bx=f[Vw>>2]|0;f[Vw>>2]=Bx+-1;if((Bx|0)!=1)break;V$(i)}while(0);f[gk>>2]=0;f[Kj>>2]=0;f[Kj+4>>2]=0;f[Kj+8>>2]=0;f[Kj+12>>2]=0;if((f[Lj>>2]|0)>0){Tw=f[hk>>2]|0;Bx=0;do{f[Tw+(Bx<<2)>>2]=0;Bx=Bx+1|0}while((Bx|0)<(f[Lj>>2]|0))}Bx=f[Tj>>2]|0;if((Bx|0)!=(ik|0))wL(Bx);break c}else{Py=Ky;Qy=Ly}while(0);do if(((Py<<24>>24<0?Qy:Py&255)|0)==3){if(LYc(s,0,-1,390721,3)|0){cz=b[Ia>>0]|0;dz=f[Pa>>2]|0;break}Bx=0;Tw=f[Da>>2]|0;while(1){if((Bx|0)>=(Tw|0)){Yw=1319;break}vIa(e,f[(f[Fa>>2]|0)+4+(Bx<<2)>>2]|0);Vw=(CHa(l,e)|0)==(xa|0);if((b[lk>>0]|0)<0)cYc(f[e>>2]|0);Tw=f[Da>>2]|0;if(!Vw)break;else Bx=Bx+1|0}if((Yw|0)==1319){Yw=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[gl>>0]=9;Pw=e;vx=437378;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[hl>>0]=0;MIa(t,e,437388)|0;if((b[gl>>0]|0)<0)cYc(f[e>>2]|0);f[uw>>2]=0;b[il>>0]=7;b[e>>0]=b[428856]|0;b[e+1>>0]=b[428857]|0;b[e+2>>0]=b[428858]|0;b[e+3>>0]=b[428859]|0;b[e+4>>0]=b[428860]|0;b[e+5>>0]=b[428861]|0;b[e+6>>0]=b[428862]|0;b[jl>>0]=0;Bx=SOa(c,r,e,t)|0;if((b[il>>0]|0)<0)cYc(f[e>>2]|0);Vw=IGa(o,r)|0;f[Vw>>2]=Bx;if((f[Da>>2]|0)>0)ez=0;else break c;while(1){vIa(e,f[(f[Fa>>2]|0)+4+(ez<<2)>>2]|0);if((CHa(o,e)|0)==(qa|0)){Yw=1325;break b}wIa(a,o,c,e,Bx,ez);if((b[kl>>0]|0)<0)cYc(f[e>>2]|0);ez=ez+1|0;if((ez|0)>=(f[Da>>2]|0))break c}}if((Tw|0)!=2){Yw=1228;break b}f[mk>>2]=0;f[nk>>2]=0;f[V>>2]=ok;Bx=f[l>>2]|0;if((Bx|0)!=(xa|0)){Vw=Bx;while(1){Bx=Vw+16|0;f[h>>2]=fl;f[e>>2]=f[h>>2];sIa(V,e,Bx,Bx)|0;Bx=f[Vw+4>>2]|0;do if(!Bx){Dx=Vw+8|0;Sw=f[Dx>>2]|0;if((f[Sw>>2]|0)==(Vw|0)){fz=Sw;break}else gz=Dx;do{Dx=f[gz>>2]|0;gz=Dx+8|0;Sw=f[gz>>2]|0}while((f[Sw>>2]|0)!=(Dx|0));fz=Sw}else{Cx=Bx;while(1){Sw=f[Cx>>2]|0;if(!Sw)break;else Cx=Sw}fz=Cx}while(0);if((fz|0)==(xa|0))break;else Vw=fz}}nKa(i,tIa(a,q,V,-1,0)|0);EGa(V,f[ok>>2]|0);if((f[i>>2]&4095|0)!=5){Yw=1237;break b}Vw=f[pk>>2]|0;if((Vw|0)<3)hz=Y(f[rk>>2]|0,f[qk>>2]|0)|0;else{Tw=f[Kk>>2]|0;Bx=0;Sw=1;while(1){Dx=Y(f[Tw+(Bx<<2)>>2]|0,Sw)|0;Bx=Bx+1|0;if((Bx|0)==(Vw|0)){hz=Dx;break}else Sw=Dx}}if((hz|0)==1){f[sw>>2]=0;b[sk>>0]=7;b[e>>0]=b[383435]|0;b[e+1>>0]=b[383436]|0;b[e+2>>0]=b[383437]|0;b[e+3>>0]=b[383438]|0;b[e+4>>0]=b[383439]|0;b[e+5>>0]=b[383440]|0;b[e+6>>0]=b[383441]|0;b[tk>>0]=0;rIa(h,ta,r,e);Sw=f[h>>2]|0;if((Sw|0)==(f[uk>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[vk>>0]=5;b[e>>0]=b[439436]|0;b[e+1>>0]=b[439437]|0;b[e+2>>0]=b[439438]|0;b[e+3>>0]=b[439439]|0;b[e+4>>0]=b[439440]|0;b[wk>>0]=0;OGa(t,e,f[xk>>2]|0)|0;if((b[vk>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[yk>>0]=5;b[e>>0]=b[439430]|0;b[e+1>>0]=b[439431]|0;b[e+2>>0]=b[439432]|0;b[e+3>>0]=b[439433]|0;b[e+4>>0]=b[439434]|0;b[zk>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[yk>>0]|0)<0)cYc(f[e>>2]|0);iz=Vw}else{Vw=f[Sw+12>>2]|0;Sw=f[(f[va>>2]|0)+4+(Vw<<2)>>2]|0;if((f[Sw+12>>2]|0)!=2){Yw=1245;break b}Bx=f[(f[Sw+20>>2]|0)+4>>2]|0;Sw=b[Bx+11>>0]|0;Tw=Sw<<24>>24<0;Dx=Sw&255;Sw=Tw?f[Bx+4>>2]|0:Dx;Rw=b[Ak>>0]|0;Ix=Rw<<24>>24<0;f:do if((Sw|0)==((Ix?f[Bk>>2]|0:Rw&255)|0)){Uw=f[Bx>>2]|0;Aa=Tw?Uw:Bx;Jx=Ix?f[r>>2]|0:r;jz=(Sw|0)==0;if(Tw){if(jz){kz=1;break}kz=(WKc(Aa,Jx,Sw)|0)==0;break}if(jz){kz=1;break}if((Uw&255)<<24>>24==(b[Jx>>0]|0)){lz=Bx;mz=Dx;nz=Jx}else{kz=0;break}while(1){mz=mz+-1|0;lz=lz+1|0;if(!mz){kz=1;break f}nz=nz+1|0;if((b[lz>>0]|0)!=(b[nz>>0]|0)){kz=0;break}}}else kz=0;while(0);CIa(ta,Vw,(kz^1)&1);Dx=f[h>>2]|0;SQ(e,j,Dx,Dx);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Dx=$Xc(16)|0;f[e>>2]=Dx;f[Ck>>2]=-2147483632;f[Dk>>2]=14;Pw=Dx;vx=429299;Qw=Pw+14|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Dx+14>>0]=0;OGa(t,e,f[xk>>2]|0)|0;if((b[Ek>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Fk>>0]=4;f[e>>2]=1431070034;b[Gk>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[Fk>>0]|0)<0)cYc(f[e>>2]|0);iz=Vw}Vw=f[h>>2]|0;if(Vw|0){Bx=f[uk>>2]|0;if((Bx|0)==(Vw|0))oz=Vw;else{Sw=Bx;while(1){Bx=Sw+-16|0;f[uk>>2]=Bx;if((b[Bx+11>>0]|0)<0){cYc(f[Bx>>2]|0);pz=f[uk>>2]|0}else pz=Bx;if((pz|0)==(Vw|0))break;else Sw=pz}oz=f[h>>2]|0}cYc(oz)}qz=iz}else{Zw(Yb,1,i);Sw=tw;f[Sw>>2]=0;f[Sw+4>>2]=0;b[Ok>>0]=3;b[e>>0]=b[390465]|0;b[e+1>>0]=b[390466]|0;b[e+2>>0]=b[390467]|0;b[Pk>>0]=0;rIa(v,ta,r,e);if((f[v>>2]|0)!=(f[Qk>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[_k>>0]=9;Pw=e;vx=445999;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[$k>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[_k>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,2);Sw=f[(f[v>>2]|0)+12>>2]|0;Vw=f[(f[va>>2]|0)+4+(Sw<<2)>>2]|0;f[al>>2]=0;f[bl>>2]=0;f[W>>2]=cl;Dx=f[l>>2]|0;if((Dx|0)!=(xa|0)){Bx=Dx;while(1){Dx=Bx+16|0;f[h>>2]=el;f[e>>2]=f[h>>2];sIa(W,e,Dx,Dx)|0;Dx=f[Bx+4>>2]|0;do if(!Dx){Tw=Bx+8|0;Ix=f[Tw>>2]|0;if((f[Ix>>2]|0)==(Bx|0)){rz=Ix;break}else sz=Tw;do{Tw=f[sz>>2]|0;sz=Tw+8|0;Ix=f[sz>>2]|0}while((f[Ix>>2]|0)!=(Tw|0));rz=Ix}else{Cx=Dx;while(1){Ix=f[Cx>>2]|0;if(!Ix)break;else Cx=Ix}rz=Cx}while(0);if((rz|0)==(xa|0))break;else Bx=rz}}Bx=tIa(a,Vw,W,-1,0)|0;BIa(Bx,(f[dl>>2]|0)+-56|0);EGa(W,f[cl>>2]|0);CIa(ta,Sw,0);Bx=f[v>>2]|0;SQ(e,j,Bx,Bx)};f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[Rk>>0]=4;f[w>>2]=1936291937;b[Sk>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Tk>>2]|0,w,0);Bx=(f[e>>2]|0)==0;zIa(h);if((b[Rk>>0]|0)<0)cYc(f[w>>2]|0);if(!Bx){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Wk>>0]=4;f[e>>2]=1936291937;b[Xk>>0]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[Yk>>0]=4;f[w>>2]=1936291937;b[Zk>>0]=0;elc(Sb);Bx=AIa(Tb,w)|0;Dx=(f[Bx+20>>2]|0)==3;Ix=Bx+8|0;Bx=Dx?f[Ix+4>>2]|0:0;Tw=h;f[Tw>>2]=Dx?f[Ix>>2]|0:0;f[Tw+4>>2]=Bx;LIa(t,e,h)|0;if((b[Yk>>0]|0)<0)cYc(f[w>>2]|0);if((b[Wk>>0]|0)<0)cYc(f[e>>2]|0)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Uk>>0]=5;b[e>>0]=b[446585]|0;b[e+1>>0]=b[446586]|0;b[e+2>>0]=b[446587]|0;b[e+3>>0]=b[446588]|0;b[e+4>>0]=b[446589]|0;b[Vk>>0]=0;Bx=SOa(c,r,e,t)|0;if((b[Uk>>0]|0)<0)cYc(f[e>>2]|0);Tw=f[v>>2]|0;if(Tw|0){Ix=f[Qk>>2]|0;if((Ix|0)==(Tw|0))tz=Tw;else{Dx=Ix;while(1){Ix=Dx+-16|0;f[Qk>>2]=Ix;if((b[Ix+11>>0]|0)<0){cYc(f[Ix>>2]|0);uz=f[Qk>>2]|0}else uz=Ix;if((uz|0)==(Tw|0))break;else Dx=uz}tz=f[v>>2]|0}cYc(tz)}qz=Bx}Dx=IGa(o,r)|0;f[Dx>>2]=qz;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);if((CHa(o,e)|0)==(qa|0)){vIa(h,f[(f[Fa>>2]|0)+8>>2]|0);wIa(a,o,c,h,qz,0);if((b[Hk>>0]|0)<0)cYc(f[h>>2]|0)}else{vIa(h,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,h,qz,0);if((b[Nk>>0]|0)<0)cYc(f[h>>2]|0)}if((b[Ik>>0]|0)<0)cYc(f[e>>2]|0);Dx=f[Jk>>2]|0;do if(Dx|0){Tw=Dx+12|0;Sw=f[Tw>>2]|0;f[Tw>>2]=Sw+-1;if((Sw|0)!=1)break;V$(i)}while(0);f[Jk>>2]=0;f[xk>>2]=0;f[xk+4>>2]=0;f[xk+8>>2]=0;f[xk+12>>2]=0;if((f[pk>>2]|0)>0){Dx=f[Kk>>2]|0;Bx=0;do{f[Dx+(Bx<<2)>>2]=0;Bx=Bx+1|0}while((Bx|0)<(f[pk>>2]|0))}Bx=f[Lk>>2]|0;if((Bx|0)!=(Mk|0))wL(Bx);break c}else{cz=Py;dz=Qy}while(0);do if(((cz<<24>>24<0?dz:cz&255)|0)==14){if(LYc(s,0,-1,384959,14)|0){vz=b[Ia>>0]|0;wz=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=5){Yw=1333;break b}vIa(i,f[(f[Fa>>2]|0)+4>>2]|0);f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;Bx=$Xc(16)|0;f[v>>2]=Bx;f[ll>>2]=-2147483632;f[ml>>2]=11;Pw=Bx;vx=378542;Qw=Pw+11|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Bx+11>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[nl>>2]|0,v,0);Dx=(f[e>>2]|0)==0;zIa(h);if(Dx)xz=0;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Dx=$Xc(16)|0;f[e>>2]=Dx;f[Km>>2]=-2147483632;f[Lm>>2]=11;Pw=Dx;vx=378542;Qw=Pw+11|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Dx+11>>0]=0;elc(Sb);Bx=AIa(Tb,e)|0;Sw=b[Bx+8>>0]|0?(f[Bx+20>>2]|0)==5:0;if((b[Mm>>0]|0)<0)cYc(f[e>>2]|0);xz=Sw}if((b[ol>>0]|0)<0)cYc(f[v>>2]|0);hS(Yb,2);f[pl>>2]=0;f[ql>>2]=0;f[X>>2]=rl;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Bx=Sw;while(1){Sw=Bx+16|0;f[h>>2]=Jm;f[e>>2]=f[h>>2];sIa(X,e,Sw,Sw)|0;Sw=f[Bx+4>>2]|0;do if(!Sw){Tw=Bx+8|0;Vw=f[Tw>>2]|0;if((f[Vw>>2]|0)==(Bx|0)){yz=Vw;break}else zz=Tw;do{Tw=f[zz>>2]|0;zz=Tw+8|0;Vw=f[zz>>2]|0}while((f[Vw>>2]|0)!=(Tw|0));yz=Vw}else{Cx=Sw;while(1){Vw=f[Cx>>2]|0;if(!Vw)break;else Cx=Vw}yz=Cx}while(0);if((yz|0)==(xa|0))break;else Bx=yz}}Bx=tIa(a,q,X,1,0)|0;EGa(X,f[rl>>2]|0);Dx=f[Bx+152>>2]|0;Sw=b[Dx+11>>0]|0;if(Sw<<24>>24<0)Az=f[Dx+4>>2]|0;else Az=Sw&255;if(!Az){b[sl>>0]=10;Pw=e;vx=444583;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[tl>>0]=0;b[h>>0]=0;cHa(t,e,h)|0;if((b[sl>>0]|0)<0)cYc(f[e>>2]|0)}else{hS(Yb,(((f[dl>>2]|0)-(f[Yb>>2]|0)|0)/56|0)+1|0);b[Hm>>0]=10;Pw=e;vx=444583;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Im>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[Hm>>0]|0)<0)cYc(f[e>>2]|0);BIa(Bx,(f[dl>>2]|0)+-56|0)}f[ul>>2]=0;f[vl>>2]=0;f[Z>>2]=wl;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Dx=Sw;while(1){Sw=Dx+16|0;f[h>>2]=Gm;f[e>>2]=f[h>>2];sIa(Z,e,Sw,Sw)|0;Sw=f[Dx+4>>2]|0;do if(!Sw){Vw=Dx+8|0;Tw=f[Vw>>2]|0;if((f[Tw>>2]|0)==(Dx|0)){Bz=Tw;break}else Cz=Vw;do{Vw=f[Cz>>2]|0;Cz=Vw+8|0;Tw=f[Cz>>2]|0}while((f[Tw>>2]|0)!=(Vw|0));Bz=Tw}else{Cx=Sw;while(1){Tw=f[Cx>>2]|0;if(!Tw)break;else Cx=Tw}Bz=Cx}while(0);if((Bz|0)==(xa|0))break;else Dx=Bz}}Dx=tIa(a,q,Z,2,0)|0;EGa(Z,f[wl>>2]|0);Bx=f[Dx+152>>2]|0;Sw=b[Bx+11>>0]|0;if(Sw<<24>>24<0)Dz=f[Bx+4>>2]|0;else Dz=Sw&255;if(!Dz){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[xl>>0]=8;Sw=e;f[Sw>>2]=1601397096;f[Sw+4>>2]=1935763810;b[yl>>0]=0;b[h>>0]=0;cHa(t,e,h)|0;if((b[xl>>0]|0)<0)cYc(f[e>>2]|0)}else{hS(Yb,(((f[dl>>2]|0)-(f[Yb>>2]|0)|0)/56|0)+1|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Em>>0]=8;Sw=e;f[Sw>>2]=1601397096;f[Sw+4>>2]=1935763810;b[Fm>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[Em>>0]|0)<0)cYc(f[e>>2]|0);BIa(Dx,(f[dl>>2]|0)+-56|0)}f[v>>2]=1124007936;Pw=zl;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[Bl>>2]=Al;f[Dl>>2]=Cl;f[Cl>>2]=0;f[El>>2]=0;f[w>>2]=1124007936;Pw=Fl;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[Hl>>2]=Gl;f[Jl>>2]=Il;f[Il>>2]=0;f[Kl>>2]=0;if(xz){Dx=f[Yb>>2]|0;Sw=Dx;if(((f[dl>>2]|0)-Dx|0)==112){Yw=1376;break b}Dx=f[Sw+172>>2]|0;if((Dx|0)<3)Ez=Y(f[Sw+180>>2]|0,f[Sw+176>>2]|0)|0;else{Bx=f[Sw+208>>2]|0;Sw=0;Tw=1;while(1){Vw=Y(f[Bx+(Sw<<2)>>2]|0,Tw)|0;Sw=Sw+1|0;if((Sw|0)==(Dx|0)){Ez=Vw;break}else Tw=Vw}}p$(e,1,Ez,5);Tw=f[e>>2]|0;ei[f[(f[Tw>>2]|0)+12>>2]&511](Tw,e,v,-1);Zj(e);Tw=f[Yb>>2]|0;Dx=f[Tw+172>>2]|0;if((Dx|0)<3)Fz=Y(f[Tw+180>>2]|0,f[Tw+176>>2]|0)|0;else{Sw=f[Tw+208>>2]|0;Tw=0;Bx=1;while(1){Vw=Y(f[Sw+(Tw<<2)>>2]|0,Bx)|0;Tw=Tw+1|0;if((Tw|0)==(Dx|0)){Fz=Vw;break}else Bx=Vw}}s$(e,1,Fz,5);Bx=f[e>>2]|0;ei[f[(f[Bx>>2]|0)+12>>2]&511](Bx,e,w,-1);Zj(e);f[Ll>>2]=0;f[Ml>>2]=0;f[e>>2]=Nl;Pw=Ol;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));AN(h,r,378623);if((CHa(o,h)|0)!=(qa|0)){Yw=1386;break b}Bx=vw;f[Bx>>2]=0;f[Bx+4>>2]=0;b[Pl>>0]=3;b[x>>0]=b[396591]|0;b[x+1>>0]=b[396592]|0;b[x+2>>0]=b[396593]|0;b[Ql>>0]=0;Bx=SOa(c,h,x,e)|0;if((b[Pl>>0]|0)<0)cYc(f[x>>2]|0);Dx=IGa(o,h)|0;f[Dx>>2]=Bx;wIa(a,o,c,i,Bx,0);lYc(x,h);f[Rl>>2]=0;if((b[Sl>>0]|0)<0){b[f[i>>2]>>0]=0;f[Tl>>2]=0}else{b[i>>0]=0;b[Sl>>0]=0}sYc(i,0);f[i>>2]=f[x>>2];f[i+4>>2]=f[x+4>>2];f[i+8>>2]=f[x+8>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[Ul>>2]=f[Rl>>2];if((b[Vl>>0]|0)<0)cYc(f[h>>2]|0);if((b[Xl>>0]|0)<0)cYc(f[Wl>>2]|0);if((b[Zl>>0]|0)<0)cYc(f[Yl>>2]|0);hx(_l);QGa(e,f[Nl>>2]|0)}else{f[wm>>2]=0;f[xm>>2]=0;f[_>>2]=ym;Bx=f[l>>2]|0;if((Bx|0)!=(xa|0)){Dx=Bx;while(1){Bx=Dx+16|0;f[h>>2]=Dm;f[e>>2]=f[h>>2];sIa(_,e,Bx,Bx)|0;Bx=f[Dx+4>>2]|0;do if(!Bx){Tw=Dx+8|0;Sw=f[Tw>>2]|0;if((f[Sw>>2]|0)==(Dx|0)){Gz=Sw;break}else Hz=Tw;do{Tw=f[Hz>>2]|0;Hz=Tw+8|0;Sw=f[Hz>>2]|0}while((f[Sw>>2]|0)!=(Tw|0));Gz=Sw}else{Cx=Bx;while(1){Sw=f[Cx>>2]|0;if(!Sw)break;else Cx=Sw}Gz=Cx}while(0);if((Gz|0)==(xa|0))break;else Dx=Gz}}BIa(tIa(a,q,_,3,0)|0,v);EGa(_,f[ym>>2]|0);f[zm>>2]=0;f[Am>>2]=0;f[$>>2]=Bm;Dx=f[l>>2]|0;if((Dx|0)!=(xa|0)){Bx=Dx;while(1){Dx=Bx+16|0;f[h>>2]=Cm;f[e>>2]=f[h>>2];sIa($,e,Dx,Dx)|0;Dx=f[Bx+4>>2]|0;do if(!Dx){Sw=Bx+8|0;Tw=f[Sw>>2]|0;if((f[Tw>>2]|0)==(Bx|0)){Iz=Tw;break}else Jz=Sw;do{Sw=f[Jz>>2]|0;Jz=Sw+8|0;Tw=f[Jz>>2]|0}while((f[Tw>>2]|0)!=(Sw|0));Iz=Tw}else{Cx=Dx;while(1){Tw=f[Cx>>2]|0;if(!Tw)break;else Cx=Tw}Iz=Cx}while(0);if((Iz|0)==(xa|0))break;else Bx=Iz}}BIa(tIa(a,q,$,4,0)|0,w);EGa($,f[Bm>>2]|0)}Bx=f[Yb>>2]|0;if((Bx|0)==(v|0))Kz=v;else{Dx=f[gm>>2]|0;if(Dx|0){Tw=Dx+12|0;f[Tw>>2]=(f[Tw>>2]|0)+1}Tw=Bx+36|0;Dx=f[Tw>>2]|0;do if(Dx|0){Sw=Dx+12|0;Vw=f[Sw>>2]|0;f[Sw>>2]=Vw+-1;if((Vw|0)!=1)break;V$(Bx)}while(0);f[Tw>>2]=0;Dx=Bx+16|0;Vw=Bx+4|0;f[Dx>>2]=0;f[Dx+4>>2]=0;f[Dx+8>>2]=0;f[Dx+12>>2]=0;if((f[Vw>>2]|0)>0){Sw=f[Bx+40>>2]|0;Ix=0;do{f[Sw+(Ix<<2)>>2]=0;Ix=Ix+1|0;Lz=f[Vw>>2]|0}while((Ix|0)<(Lz|0));f[Bx>>2]=f[v>>2];if((Lz|0)<3)Yw=1425;else Yw=1427}else{f[Bx>>2]=f[v>>2];Yw=1425}do if((Yw|0)==1425){Yw=0;Ix=f[zl>>2]|0;if((Ix|0)>=3){Yw=1427;break}f[Vw>>2]=Ix;f[Bx+8>>2]=f[Al>>2];f[Bx+12>>2]=f[rm>>2];Ix=f[Dl>>2]|0;Sw=f[Bx+44>>2]|0;f[Sw>>2]=f[Ix>>2];f[Sw+4>>2]=f[Ix+4>>2]}while(0);if((Yw|0)==1427){Yw=0;U$(Bx,v)}f[Dx>>2]=f[hm>>2];f[Bx+20>>2]=f[sm>>2];f[Bx+24>>2]=f[tm>>2];f[Bx+28>>2]=f[um>>2];f[Bx+32>>2]=f[vm>>2];f[Tw>>2]=f[gm>>2];Kz=f[Yb>>2]|0}Vw=Kz+56|0;if((Vw|0)!=(w|0)){Ix=f[em>>2]|0;if(Ix|0){Sw=Ix+12|0;f[Sw>>2]=(f[Sw>>2]|0)+1}Sw=Kz+92|0;Ix=f[Sw>>2]|0;do if(Ix|0){Rw=Ix+12|0;Jx=f[Rw>>2]|0;f[Rw>>2]=Jx+-1;if((Jx|0)!=1)break;V$(Vw)}while(0);f[Sw>>2]=0;Ix=Kz+72|0;Tw=Kz+60|0;f[Ix>>2]=0;f[Ix+4>>2]=0;f[Ix+8>>2]=0;f[Ix+12>>2]=0;if((f[Tw>>2]|0)>0){Bx=f[Kz+96>>2]|0;Dx=0;do{f[Bx+(Dx<<2)>>2]=0;Dx=Dx+1|0;Mz=f[Tw>>2]|0}while((Dx|0)<(Mz|0));f[Vw>>2]=f[w>>2];if((Mz|0)<3)Yw=1440;else Yw=1442}else{f[Vw>>2]=f[w>>2];Yw=1440}do if((Yw|0)==1440){Yw=0;Dx=f[Fl>>2]|0;if((Dx|0)>=3){Yw=1442;break}f[Tw>>2]=Dx;f[Kz+64>>2]=f[Gl>>2];f[Kz+68>>2]=f[mm>>2];Dx=f[Jl>>2]|0;Bx=f[Kz+100>>2]|0;f[Bx>>2]=f[Dx>>2];f[Bx+4>>2]=f[Dx+4>>2]}while(0);if((Yw|0)==1442){Yw=0;U$(Vw,w)}f[Ix>>2]=f[fm>>2];f[Kz+76>>2]=f[nm>>2];f[Kz+80>>2]=f[om>>2];f[Kz+84>>2]=f[pm>>2];f[Kz+88>>2]=f[qm>>2];f[Sw>>2]=f[em>>2]}f[ww>>2]=0;b[$l>>0]=7;b[x>>0]=b[390628]|0;b[x+1>>0]=b[390629]|0;b[x+2>>0]=b[390630]|0;b[x+3>>0]=b[390631]|0;b[x+4>>0]=b[390632]|0;b[x+5>>0]=b[390633]|0;b[x+6>>0]=b[390634]|0;b[am>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[bm>>2]|0,x,0);Tw=(f[e>>2]|0)==0;zIa(h);if((b[$l>>0]|0)<0)cYc(f[x>>2]|0);if(!Tw){Tw=xw;f[Tw>>2]=0;f[Tw+4>>2]=0;b[im>>0]=3;b[e>>0]=b[513188]|0;b[e+1>>0]=b[513189]|0;b[e+2>>0]=b[513190]|0;b[jm>>0]=0;f[yw>>2]=0;b[km>>0]=7;b[x>>0]=b[390628]|0;b[x+1>>0]=b[390629]|0;b[x+2>>0]=b[390630]|0;b[x+3>>0]=b[390631]|0;b[x+4>>0]=b[390632]|0;b[x+5>>0]=b[390633]|0;b[x+6>>0]=b[390634]|0;b[lm>>0]=0;elc(Sb);Tw=AIa(Tb,x)|0;n[h>>2]=(f[Tw+20>>2]|0)==4?+n[Tw+8>>2]:0.0;OGa(t,e,h)|0;if((b[km>>0]|0)<0)cYc(f[x>>2]|0);if((b[im>>0]|0)<0)cYc(f[e>>2]|0)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[cm>>0]=9;Pw=e;vx=429107;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[dm>>0]=0;Sw=SOa(c,r,e,t)|0;if((b[cm>>0]|0)<0)cYc(f[e>>2]|0);Ix=IGa(o,r)|0;f[Ix>>2]=Sw;wIa(a,o,c,i,Sw,0);Sw=f[em>>2]|0;do if(Sw|0){Ix=Sw+12|0;Vw=f[Ix>>2]|0;f[Ix>>2]=Vw+-1;if((Vw|0)!=1)break;V$(w)}while(0);f[em>>2]=0;f[fm>>2]=0;f[fm+4>>2]=0;f[fm+8>>2]=0;f[fm+12>>2]=0;if((f[Fl>>2]|0)>0){Sw=f[Hl>>2]|0;Vw=0;do{f[Sw+(Vw<<2)>>2]=0;Vw=Vw+1|0}while((Vw|0)<(f[Fl>>2]|0))}Vw=f[Jl>>2]|0;if((Vw|0)!=(Il|0))wL(Vw);Vw=f[gm>>2]|0;do if(Vw|0){Sw=Vw+12|0;Ix=f[Sw>>2]|0;f[Sw>>2]=Ix+-1;if((Ix|0)!=1)break;V$(v)}while(0);f[gm>>2]=0;f[hm>>2]=0;f[hm+4>>2]=0;f[hm+8>>2]=0;f[hm+12>>2]=0;if((f[zl>>2]|0)>0){Vw=f[Bl>>2]|0;Ix=0;do{f[Vw+(Ix<<2)>>2]=0;Ix=Ix+1|0}while((Ix|0)<(f[zl>>2]|0))}Ix=f[Dl>>2]|0;if((Ix|0)!=(Cl|0))wL(Ix);if((b[Sl>>0]|0)<0)cYc(f[i>>2]|0);break c}else{vz=cz;wz=dz}while(0);do if(((vz<<24>>24<0?wz:vz&255)|0)==19){if(LYc(s,0,-1,382793,19)|0){Nz=b[Ia>>0]|0;Oz=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=3){Yw=1477;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Nm>>0]=9;Pw=e;vx=445999;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Om>>0]=0;b[h>>0]=0;cHa(t,e,h)|0;if((b[Nm>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,1);f[zw>>2]=0;b[Pm>>0]=7;b[e>>0]=b[377936]|0;b[e+1>>0]=b[377937]|0;b[e+2>>0]=b[377938]|0;b[e+3>>0]=b[377939]|0;b[e+4>>0]=b[377940]|0;b[e+5>>0]=b[377941]|0;b[e+6>>0]=b[377942]|0;b[Qm>>0]=0;rIa(i,ta,r,e);if(((f[Rm>>2]|0)-(f[i>>2]|0)|0)==16){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Sm>>0]=9;Pw=e;vx=445999;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Tm>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[Sm>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,2);Ix=f[(f[i>>2]|0)+12>>2]|0;Vw=f[(f[va>>2]|0)+4+(Ix<<2)>>2]|0;f[Um>>2]=0;f[Vm>>2]=0;f[aa>>2]=Wm;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Tw=Sw;while(1){Sw=Tw+16|0;f[h>>2]=Xm;f[e>>2]=f[h>>2];sIa(aa,e,Sw,Sw)|0;Sw=f[Tw+4>>2]|0;do if(!Sw){Dx=Tw+8|0;Bx=f[Dx>>2]|0;if((f[Bx>>2]|0)==(Tw|0)){Pz=Bx;break}else Qz=Dx;do{Dx=f[Qz>>2]|0;Qz=Dx+8|0;Bx=f[Qz>>2]|0}while((f[Bx>>2]|0)!=(Dx|0));Pz=Bx}else{Cx=Sw;while(1){Bx=f[Cx>>2]|0;if(!Bx)break;else Cx=Bx}Pz=Cx}while(0);if((Pz|0)==(xa|0))break;else Tw=Pz}}Tw=tIa(a,Vw,aa,-1,0)|0;BIa(Tw,(f[Yb>>2]|0)+56|0);EGa(aa,f[Wm>>2]|0);CIa(ta,Ix,0);Tw=f[i>>2]|0;SQ(e,j,Tw,Tw)}f[Ym>>2]=0;f[Zm>>2]=0;f[ba>>2]=_m;Tw=f[l>>2]|0;if((Tw|0)!=(xa|0)){Sw=Tw;while(1){Tw=Sw+16|0;f[h>>2]=Pn;f[e>>2]=f[h>>2];sIa(ba,e,Tw,Tw)|0;Tw=f[Sw+4>>2]|0;do if(!Tw){Bx=Sw+8|0;Dx=f[Bx>>2]|0;if((f[Dx>>2]|0)==(Sw|0)){Rz=Dx;break}else Sz=Bx;do{Bx=f[Sz>>2]|0;Sz=Bx+8|0;Dx=f[Sz>>2]|0}while((f[Dx>>2]|0)!=(Bx|0));Rz=Dx}else{Cx=Tw;while(1){Dx=f[Cx>>2]|0;if(!Dx)break;else Cx=Dx}Rz=Cx}while(0);if((Rz|0)==(xa|0))break;else Sw=Rz}}Sw=tIa(a,q,ba,1,0)|0;EIa(Sw,f[Yb>>2]|0);EGa(ba,f[_m>>2]|0);Sw=f[(f[Yb>>2]|0)+40>>2]|0;f[v>>2]=f[Sw+8>>2];f[w>>2]=f[Sw+12>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[$m>>0]=8;Ix=e;f[Ix>>2]=1852990827;f[Ix+4>>2]=1751084133;b[an>>0]=0;aHa(t,e,v)|0;if((b[$m>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[bn>>0]=8;Ix=e;f[Ix>>2]=1852990827;f[Ix+4>>2]=2002742373;b[cn>>0]=0;aHa(t,e,w)|0;if((b[bn>>0]|0)<0)cYc(f[e>>2]|0);b[dn>>0]=10;Pw=e;vx=453228;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[en>>0]=0;aHa(t,e,Sw+4|0)|0;if((b[dn>>0]|0)<0)cYc(f[e>>2]|0);GIa(t,q);IIa(t,q);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[fn>>0]=8;Ix=e;f[Ix>>2]=1769108595;f[Ix+4>>2]=1751082340;b[gn>>0]=0;Ix=MGa(NIa(t,e)|0,-1)|0;if((b[fn>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[hn>>0]=8;Vw=e;f[Vw>>2]=1769108595;f[Vw+4>>2]=2002740580;b[jn>>0]=0;Vw=MGa(NIa(t,e)|0,-1)|0;if((b[hn>>0]|0)<0)cYc(f[e>>2]|0);f[kn>>2]=0;f[ln>>2]=0;f[ca>>2]=mn;Tw=f[l>>2]|0;if((Tw|0)!=(xa|0)){Dx=Tw;while(1){Tw=Dx+16|0;f[h>>2]=On;f[e>>2]=f[h>>2];sIa(ca,e,Tw,Tw)|0;Tw=f[Dx+4>>2]|0;do if(!Tw){Bx=Dx+8|0;Jx=f[Bx>>2]|0;if((f[Jx>>2]|0)==(Dx|0)){Tz=Jx;break}else Uz=Bx;do{Bx=f[Uz>>2]|0;Uz=Bx+8|0;Jx=f[Uz>>2]|0}while((f[Jx>>2]|0)!=(Bx|0));Tz=Jx}else{Cx=Tw;while(1){Jx=f[Cx>>2]|0;if(!Jx)break;else Cx=Jx}Tz=Cx}while(0);if((Tz|0)==(xa|0))break;else Dx=Tz}}nKa(x,tIa(a,q,ca,0,0)|0);EGa(ca,f[mn>>2]|0);Dx=f[nn>>2]|0;do if(!(f[x>>2]&16384)){Sw=f[on>>2]|0;do if((f[Sw>>2]|0)!=1){Tw=f[f[pn>>2]>>2]|0;if((f[Sw+4>>2]|0)==1){Vz=Dx+Tw|0;break}else{Jx=f[qn>>2]|0;Bx=(Jx+1|0)>>>0<3?Jx:0;Vz=Dx+(Y(Bx,Tw)|0)+(1-(Y(Bx,Jx)|0)<<2)|0;break}}else Vz=Dx+4|0;while(0);Sw=f[Vz>>2]|0;Jx=f[on>>2]|0;if((f[Jx>>2]|0)==1){Wz=Sw;Yw=1523;break}Bx=f[f[pn>>2]>>2]|0;if((f[Jx+4>>2]|0)==1){Xz=Dx+(Bx<<1)|0;Yz=Sw;break}else{Jx=f[qn>>2]|0;Tw=2/(Jx|0)|0;Xz=Dx+(Y(Tw,Bx)|0)+(2-(Y(Tw,Jx)|0)<<2)|0;Yz=Sw;break}}else{Wz=f[Dx+4>>2]|0;Yw=1523}while(0);if((Yw|0)==1523){Yw=0;Xz=Dx+8|0;Yz=Wz}Sw=f[Xz>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[rn>>0]=8;Jx=h;f[Jx>>2]=1600414064;f[Jx+4>>2]=1701080941;b[sn>>0]=0;OIa(e,NIa(t,h)|0,-1);Jx=b[tn>>0]|0;if(((Jx<<24>>24<0?f[un>>2]|0:Jx&255)|0)==4){Tw=(LYc(e,0,-1,453591,4)|0)==0;Zz=Tw;_z=b[tn>>0]|0}else{Zz=0;_z=Jx}if(_z<<24>>24<0)cYc(f[e>>2]|0);if((b[rn>>0]|0)<0)cYc(f[h>>2]|0);do if(Zz){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[vn>>0]=5;b[e>>0]=b[453245]|0;b[e+1>>0]=b[453246]|0;b[e+2>>0]=b[453247]|0;b[e+3>>0]=b[453248]|0;b[e+4>>0]=b[453249]|0;b[wn>>0]=0;f[h>>2]=(Sw+-1|0)%(Vw|0)|0;aHa(t,e,h)|0;if((b[vn>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[xn>>0]=5;b[e>>0]=b[453239]|0;b[e+1>>0]=b[453240]|0;b[e+2>>0]=b[453241]|0;b[e+3>>0]=b[453242]|0;b[e+4>>0]=b[453243]|0;b[yn>>0]=0;f[h>>2]=(Yz+-1|0)%(Ix|0)|0;aHa(t,e,h)|0;if((b[xn>>0]|0)<0)cYc(f[e>>2]|0)}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Gn>>0]=8;Jx=h;f[Jx>>2]=1600414064;f[Jx+4>>2]=1701080941;b[Hn>>0]=0;OIa(e,NIa(t,h)|0,-1);Jx=b[In>>0]|0;if(((Jx<<24>>24<0?f[Jn>>2]|0:Jx&255)|0)==5){Tw=(LYc(e,0,-1,453585,5)|0)==0;$z=Tw;aA=b[In>>0]|0}else{$z=0;aA=Jx}if(aA<<24>>24<0)cYc(f[e>>2]|0);if((b[Gn>>0]|0)<0)cYc(f[h>>2]|0);if(!$z)break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Kn>>0]=5;b[e>>0]=b[453245]|0;b[e+1>>0]=b[453246]|0;b[e+2>>0]=b[453247]|0;b[e+3>>0]=b[453248]|0;b[e+4>>0]=b[453249]|0;b[Ln>>0]=0;f[h>>2]=(Sw-(f[w>>2]|0)|0)%(Vw|0)|0;aHa(t,e,h)|0;if((b[Kn>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Mn>>0]=5;b[e>>0]=b[453239]|0;b[e+1>>0]=b[453240]|0;b[e+2>>0]=b[453241]|0;b[e+3>>0]=b[453242]|0;b[e+4>>0]=b[453243]|0;b[Nn>>0]=0;f[h>>2]=(Yz-(f[v>>2]|0)|0)%(Ix|0)|0;aHa(t,e,h)|0;if((b[Mn>>0]|0)<0)cYc(f[e>>2]|0)}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ix=$Xc(16)|0;f[e>>2]=Ix;f[zn>>2]=-2147483632;f[An>>2]=13;Pw=Ix;vx=396536;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ix+13>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[Bn>>0]|0)<0)cYc(f[e>>2]|0);Sw=IGa(o,r)|0;f[Sw>>2]=Vw;vIa(e,f[(f[Fa>>2]|0)+12>>2]|0);wIa(a,o,c,e,Vw,0);if((b[Cn>>0]|0)<0)cYc(f[e>>2]|0);Vw=f[Dn>>2]|0;do if(Vw|0){Sw=Vw+12|0;Dx=f[Sw>>2]|0;f[Sw>>2]=Dx+-1;if((Dx|0)!=1)break;V$(x)}while(0);f[Dn>>2]=0;f[nn>>2]=0;f[nn+4>>2]=0;f[nn+8>>2]=0;f[nn+12>>2]=0;if((f[En>>2]|0)>0){Vw=f[on>>2]|0;Ix=0;do{f[Vw+(Ix<<2)>>2]=0;Ix=Ix+1|0}while((Ix|0)<(f[En>>2]|0))}Ix=f[pn>>2]|0;if((Ix|0)!=(Fn|0))wL(Ix);Ix=f[i>>2]|0;if(Ix|0){Vw=f[Rm>>2]|0;if((Vw|0)==(Ix|0))bA=Ix;else{Dx=Vw;while(1){Vw=Dx+-16|0;f[Rm>>2]=Vw;if((b[Vw+11>>0]|0)<0){cYc(f[Vw>>2]|0);cA=f[Rm>>2]|0}else cA=Vw;if((cA|0)==(Ix|0))break;else Dx=cA}bA=f[i>>2]|0}cYc(bA)}break c}else{Nz=vz;Oz=wz}while(0);do if(((Nz<<24>>24<0?Oz:Nz&255)|0)==9){if(LYc(s,0,-1,378716,9)|0){dA=b[Ia>>0]|0;eA=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=9){Yw=1575;break b};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Dx=$Xc(16)|0;f[i>>2]=Dx;f[Qn>>2]=-2147483632;f[Rn>>2]=11;Pw=Dx;vx=454443;Qw=Pw+11|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Dx+11>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Sn>>2]|0,i,0);Ix=(f[e>>2]|0)==0;zIa(h);if((b[Tn>>0]|0)<0)cYc(f[i>>2]|0);if(!Ix){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ix=$Xc(16)|0;f[e>>2]=Ix;f[yq>>2]=-2147483632;f[zq>>2]=11;Pw=Ix;vx=454443;Qw=Pw+11|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ix+11>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Dx=$Xc(16)|0;f[i>>2]=Dx;f[Aq>>2]=-2147483632;f[Bq>>2]=11;Pw=Dx;vx=454443;Qw=Pw+11|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Dx+11>>0]=0;elc(Sb);Ix=AIa(Tb,i)|0;n[h>>2]=(f[Ix+20>>2]|0)==4?+n[Ix+8>>2]:0.0;OGa(t,e,h)|0;if((b[Cq>>0]|0)<0)cYc(f[i>>2]|0);if((b[Dq>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Ix=$Xc(16)|0;f[i>>2]=Ix;f[Un>>2]=-2147483632;f[Vn>>2]=11;Pw=Ix;vx=454443;Qw=Pw+11|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ix+11>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Wn>>2]|0,i,0);Dx=(f[e>>2]|0)==0;zIa(h);if((b[Xn>>0]|0)<0)cYc(f[i>>2]|0);if(!Dx){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[rq>>0]=9;Pw=h;vx=454455;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[sq>>0]=0;elc(Sb);Ix=AIa(Tb,h)|0;fA=(f[Ix+20>>2]|0)==4?+n[Ix+8>>2]:0.0;if((b[rq>>0]|0)<0)cYc(f[h>>2]|0);n[e>>2]=fA;if(fA>=0.0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Ix=$Xc(16)|0;f[h>>2]=Ix;f[tq>>2]=-2147483632;f[uq>>2]=13;Pw=Ix;vx=454465;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ix+13>>0]=0;b[i>>0]=1;cHa(t,h,i)|0;if((b[vq>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[wq>>0]=9;Pw=h;vx=454455;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[xq>>0]=0;OGa(t,h,e)|0;if((b[wq>>0]|0)<0)cYc(f[h>>2]|0)}}f[i>>2]=1124007936;Pw=Yn;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[_n>>2]=Zn;f[ao>>2]=$n;f[$n>>2]=0;f[bo>>2]=0;f[v>>2]=1124007936;Pw=co;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[fo>>2]=eo;f[ho>>2]=go;f[go>>2]=0;f[io>>2]=0;f[w>>2]=1124007936;Pw=jo;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[lo>>2]=ko;f[no>>2]=mo;f[mo>>2]=0;f[oo>>2]=0;f[x>>2]=1124007936;Pw=po;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[ro>>2]=qo;f[to>>2]=so;f[so>>2]=0;f[uo>>2]=0;f[vo>>2]=0;f[wo>>2]=0;f[da>>2]=xo;Ix=f[l>>2]|0;if((Ix|0)!=(xa|0)){Dx=Ix;while(1){Ix=Dx+16|0;f[h>>2]=qq;f[e>>2]=f[h>>2];sIa(da,e,Ix,Ix)|0;Ix=f[Dx+4>>2]|0;do if(!Ix){Vw=Dx+8|0;Sw=f[Vw>>2]|0;if((f[Sw>>2]|0)==(Dx|0)){gA=Sw;break}else hA=Vw;do{Vw=f[hA>>2]|0;hA=Vw+8|0;Sw=f[hA>>2]|0}while((f[Sw>>2]|0)!=(Vw|0));gA=Sw}else{Cx=Ix;while(1){Sw=f[Cx>>2]|0;if(!Sw)break;else Cx=Sw}gA=Cx}while(0);if((gA|0)==(xa|0))break;else Dx=gA}}BIa(tIa(a,q,da,4,0)|0,i);EGa(da,f[xo>>2]|0);f[yo>>2]=0;f[zo>>2]=0;f[ea>>2]=Ao;Dx=f[l>>2]|0;if((Dx|0)!=(xa|0)){Ix=Dx;while(1){Dx=Ix+16|0;f[h>>2]=pq;f[e>>2]=f[h>>2];sIa(ea,e,Dx,Dx)|0;Dx=f[Ix+4>>2]|0;do if(!Dx){Sw=Ix+8|0;Vw=f[Sw>>2]|0;if((f[Vw>>2]|0)==(Ix|0)){iA=Vw;break}else jA=Sw;do{Sw=f[jA>>2]|0;jA=Sw+8|0;Vw=f[jA>>2]|0}while((f[Vw>>2]|0)!=(Sw|0));iA=Vw}else{Cx=Dx;while(1){Vw=f[Cx>>2]|0;if(!Vw)break;else Cx=Vw}iA=Cx}while(0);if((iA|0)==(xa|0))break;else Ix=iA}}BIa(tIa(a,q,ea,8,0)|0,x);EGa(ea,f[Ao>>2]|0);Ix=f[Bo>>2]|0;Dx=(Ix|0)/4|0;Vw=f[Co>>2]|0;Sw=f[Zn>>2]|0;do if((Sw|0)>0){Jx=Dx<<1;Tw=Dx*3|0;if((Ix|0)>3)kA=0;else break;do{Bx=Y(Ix,kA)|0;Rw=0;do{Uw=Vw+(Rw+Dx+Bx<<2)|0;jz=Vw+(Rw+Jx+Bx<<2)|0;Aa=f[Uw>>2]|0;f[Uw>>2]=f[jz>>2];f[jz>>2]=Aa;Uw=Vw+(Rw+Tw+Bx<<2)|0;f[jz>>2]=f[Uw>>2];f[Uw>>2]=Aa;Rw=Rw+1|0}while((Rw|0)<(Dx|0));kA=kA+1|0}while((kA|0)<(Sw|0))}while(0);f[e>>2]=0;f[Do>>2]=Sw-Dx;f[h>>2]=-2147483648;f[Eo>>2]=2147483647;W$(fa,i,e,h);m$(z,fa);Vw=f[z>>2]|0;ei[f[(f[Vw>>2]|0)+12>>2]&511](Vw,z,w,-1);Zj(z);Vw=f[Fo>>2]|0;do if(Vw|0){Ix=Vw+12|0;Tw=f[Ix>>2]|0;f[Ix>>2]=Tw+-1;if((Tw|0)!=1)break;V$(fa)}while(0);f[Fo>>2]=0;f[Go>>2]=0;f[Go+4>>2]=0;f[Go+8>>2]=0;f[Go+12>>2]=0;if((f[Ho>>2]|0)>0){Vw=f[Io>>2]|0;Sw=0;do{f[Vw+(Sw<<2)>>2]=0;Sw=Sw+1|0}while((Sw|0)<(f[Ho>>2]|0))}Sw=f[Jo>>2]|0;if((Sw|0)!=(Ko|0))wL(Sw);Sw=f[Zn>>2]|0;f[e>>2]=Sw-Dx;f[Lo>>2]=Sw;f[h>>2]=-2147483648;f[Mo>>2]=2147483647;W$(fa,i,e,h);m$(z,fa);Sw=f[z>>2]|0;ei[f[(f[Sw>>2]|0)+12>>2]&511](Sw,z,v,-1);Zj(z);Sw=f[No>>2]|0;do if(Sw|0){Vw=Sw+12|0;Tw=f[Vw>>2]|0;f[Vw>>2]=Tw+-1;if((Tw|0)!=1)break;V$(fa)}while(0);f[No>>2]=0;f[Oo>>2]=0;f[Oo+4>>2]=0;f[Oo+8>>2]=0;f[Oo+12>>2]=0;if((f[Po>>2]|0)>0){Sw=f[Qo>>2]|0;Dx=0;do{f[Sw+(Dx<<2)>>2]=0;Dx=Dx+1|0}while((Dx|0)<(f[Po>>2]|0))}Dx=f[Ro>>2]|0;if((Dx|0)!=(So|0))wL(Dx);hS(Yb,3);Dx=f[Yb>>2]|0;if((Dx|0)==(v|0))lA=v;else{Sw=f[cp>>2]|0;if(Sw|0){Tw=Sw+12|0;f[Tw>>2]=(f[Tw>>2]|0)+1}Tw=Dx+36|0;Sw=f[Tw>>2]|0;do if(Sw|0){Vw=Sw+12|0;Ix=f[Vw>>2]|0;f[Vw>>2]=Ix+-1;if((Ix|0)!=1)break;V$(Dx)}while(0);f[Tw>>2]=0;Sw=Dx+16|0;Ix=Dx+4|0;f[Sw>>2]=0;f[Sw+4>>2]=0;f[Sw+8>>2]=0;f[Sw+12>>2]=0;if((f[Ix>>2]|0)>0){Vw=f[Dx+40>>2]|0;Jx=0;do{f[Vw+(Jx<<2)>>2]=0;Jx=Jx+1|0;mA=f[Ix>>2]|0}while((Jx|0)<(mA|0));f[Dx>>2]=f[v>>2];if((mA|0)<3)Yw=1642;else Yw=1644}else{f[Dx>>2]=f[v>>2];Yw=1642}do if((Yw|0)==1642){Yw=0;Jx=f[co>>2]|0;if((Jx|0)>=3){Yw=1644;break}f[Ix>>2]=Jx;f[Dx+8>>2]=f[eo>>2];f[Dx+12>>2]=f[kq>>2];Jx=f[ho>>2]|0;Vw=f[Dx+44>>2]|0;f[Vw>>2]=f[Jx>>2];f[Vw+4>>2]=f[Jx+4>>2]}while(0);if((Yw|0)==1644){Yw=0;U$(Dx,v)}f[Sw>>2]=f[dp>>2];f[Dx+20>>2]=f[lq>>2];f[Dx+24>>2]=f[mq>>2];f[Dx+28>>2]=f[nq>>2];f[Dx+32>>2]=f[oq>>2];f[Tw>>2]=f[cp>>2];lA=f[Yb>>2]|0}Ix=lA+56|0;if((Ix|0)==(w|0))nA=lA;else{Jx=f[ap>>2]|0;if(Jx|0){Vw=Jx+12|0;f[Vw>>2]=(f[Vw>>2]|0)+1}Vw=lA+92|0;Jx=f[Vw>>2]|0;do if(Jx|0){Rw=Jx+12|0;Bx=f[Rw>>2]|0;f[Rw>>2]=Bx+-1;if((Bx|0)!=1)break;V$(Ix)}while(0);f[Vw>>2]=0;Jx=lA+72|0;Tw=lA+60|0;f[Jx>>2]=0;f[Jx+4>>2]=0;f[Jx+8>>2]=0;f[Jx+12>>2]=0;if((f[Tw>>2]|0)>0){Dx=f[lA+96>>2]|0;Sw=0;do{f[Dx+(Sw<<2)>>2]=0;Sw=Sw+1|0;oA=f[Tw>>2]|0}while((Sw|0)<(oA|0));f[Ix>>2]=f[w>>2];if((oA|0)<3)Yw=1657;else Yw=1659}else{f[Ix>>2]=f[w>>2];Yw=1657}do if((Yw|0)==1657){Yw=0;Sw=f[jo>>2]|0;if((Sw|0)>=3){Yw=1659;break}f[Tw>>2]=Sw;f[lA+64>>2]=f[ko>>2];f[lA+68>>2]=f[fq>>2];Sw=f[no>>2]|0;Dx=f[lA+100>>2]|0;f[Dx>>2]=f[Sw>>2];f[Dx+4>>2]=f[Sw+4>>2]}while(0);if((Yw|0)==1659){Yw=0;U$(Ix,w)}f[Jx>>2]=f[bp>>2];f[lA+76>>2]=f[gq>>2];f[lA+80>>2]=f[hq>>2];f[lA+84>>2]=f[iq>>2];f[lA+88>>2]=f[jq>>2];f[Vw>>2]=f[ap>>2];nA=f[Yb>>2]|0}Tw=nA+112|0;if((Tw|0)!=(x|0)){Sw=f[_o>>2]|0;if(Sw|0){Dx=Sw+12|0;f[Dx>>2]=(f[Dx>>2]|0)+1}Dx=nA+148|0;Sw=f[Dx>>2]|0;do if(Sw|0){Bx=Sw+12|0;Rw=f[Bx>>2]|0;f[Bx>>2]=Rw+-1;if((Rw|0)!=1)break;V$(Tw)}while(0);f[Dx>>2]=0;Sw=nA+128|0;Vw=nA+116|0;f[Sw>>2]=0;f[Sw+4>>2]=0;f[Sw+8>>2]=0;f[Sw+12>>2]=0;if((f[Vw>>2]|0)>0){Jx=f[nA+152>>2]|0;Ix=0;do{f[Jx+(Ix<<2)>>2]=0;Ix=Ix+1|0;pA=f[Vw>>2]|0}while((Ix|0)<(pA|0));f[Tw>>2]=f[x>>2];if((pA|0)<3)Yw=1672;else Yw=1674}else{f[Tw>>2]=f[x>>2];Yw=1672}do if((Yw|0)==1672){Yw=0;Ix=f[po>>2]|0;if((Ix|0)>=3){Yw=1674;break}f[Vw>>2]=Ix;f[nA+120>>2]=f[qo>>2];f[nA+124>>2]=f[aq>>2];Ix=f[to>>2]|0;Jx=f[nA+156>>2]|0;f[Jx>>2]=f[Ix>>2];f[Jx+4>>2]=f[Ix+4>>2]}while(0);if((Yw|0)==1674){Yw=0;U$(Tw,x)}f[Sw>>2]=f[$o>>2];f[nA+132>>2]=f[bq>>2];f[nA+136>>2]=f[cq>>2];f[nA+140>>2]=f[dq>>2];f[nA+144>>2]=f[eq>>2];f[Dx>>2]=f[_o>>2]};f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;Vw=$Xc(16)|0;f[z>>2]=Vw;f[To>>2]=-2147483632;f[Uo>>2]=12;Pw=Vw;vx=454479;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+12>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Vo>>2]|0,z,0);Dx=(f[e>>2]|0)==0;zIa(h);if((b[Wo>>0]|0)<0)cYc(f[z>>2]|0);do if(!Dx){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Sw=$Xc(16)|0;f[e>>2]=Sw;f[fp>>2]=-2147483632;f[gp>>2]=12;Pw=Sw;vx=454479;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Sw+12>>0]=0;elc(Sb);Tw=AIa(Tb,e)|0;Ix=b[Tw+8>>0]|0?(f[Tw+20>>2]|0)==5:0;if((b[hp>>0]|0)<0)cYc(f[e>>2]|0);if(!Ix)break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ix=$Xc(16)|0;f[e>>2]=Ix;f[ip>>2]=-2147483632;f[jp>>2]=12;Pw=Ix;vx=454479;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ix+12>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[kp>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,6);Sw=0;do{f[z>>2]=1124007936;Pw=lp;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[np>>2]=mp;f[pp>>2]=op;f[op>>2]=0;f[qp>>2]=0;f[rp>>2]=0;f[sp>>2]=0;f[ga>>2]=tp;Tw=f[l>>2]|0;if((Tw|0)!=(xa|0)){Jx=Tw;while(1){Tw=Jx+16|0;f[h>>2]=$p;f[e>>2]=f[h>>2];sIa(ga,e,Tw,Tw)|0;Tw=f[Jx+4>>2]|0;do if(!Tw){Rw=Jx+8|0;Bx=f[Rw>>2]|0;if((f[Bx>>2]|0)==(Jx|0)){qA=Bx;break}else rA=Rw;do{Rw=f[rA>>2]|0;rA=Rw+8|0;Bx=f[rA>>2]|0}while((f[Bx>>2]|0)!=(Rw|0));qA=Bx}else{Bx=Tw;while(1){Rw=f[Bx>>2]|0;if(!Rw)break;else Bx=Rw}qA=Bx}while(0);if((qA|0)==(xa|0))break;else Jx=qA}}BIa(tIa(a,q,ga,Sw+5|0,0)|0,z);EGa(ga,f[tp>>2]|0);Jx=f[lp>>2]|0;if((Jx|0)<3)sA=Y(f[up>>2]|0,f[mp>>2]|0)|0;else{Tw=f[np>>2]|0;Rw=0;Cx=1;while(1){Aa=Y(f[Tw+(Rw<<2)>>2]|0,Cx)|0;Rw=Rw+1|0;if((Rw|0)==(Jx|0)){sA=Aa;break}else Cx=Aa}}g0(e,z,1,sA);Cx=f[vp>>2]|0;do if(Cx|0){Jx=Cx+12|0;Rw=f[Jx>>2]|0;f[Jx>>2]=Rw+-1;if((Rw|0)!=1)break;V$(z)}while(0);f[vp>>2]=0;f[wp>>2]=0;f[wp+4>>2]=0;f[wp+8>>2]=0;f[wp+12>>2]=0;if((f[lp>>2]|0)>0){Cx=f[np>>2]|0;Rw=0;do{f[Cx+(Rw<<2)>>2]=0;Rw=Rw+1|0}while((Rw|0)<(f[lp>>2]|0))}f[z>>2]=f[e>>2];Rw=f[xp>>2]|0;f[lp>>2]=Rw;f[mp>>2]=f[yp>>2];f[up>>2]=f[zp>>2];f[wp>>2]=f[Ap>>2];f[Cp>>2]=f[Bp>>2];f[Ep>>2]=f[Dp>>2];f[Gp>>2]=f[Fp>>2];f[Ip>>2]=f[Hp>>2];f[vp>>2]=f[Jp>>2];Cx=f[Kp>>2]|0;if((Cx|0)==(op|0))tA=Rw;else{wL(Cx);f[Kp>>2]=op;f[np>>2]=mp;tA=f[xp>>2]|0}if((tA|0)<3){Cx=f[Lp>>2]|0;f[op>>2]=f[Cx>>2];f[Aw>>2]=f[Cx+4>>2];uA=Cx}else{f[Kp>>2]=f[Lp>>2];f[_p>>2]=f[Mp>>2];f[Lp>>2]=Np;f[Mp>>2]=yp;uA=Np}f[e>>2]=1124007936;f[xp>>2]=0;f[xp+4>>2]=0;f[xp+8>>2]=0;f[xp+12>>2]=0;f[xp+16>>2]=0;f[xp+20>>2]=0;f[xp+24>>2]=0;f[xp+28>>2]=0;f[Jp>>2]=0;f[Ap>>2]=0;f[Ap+4>>2]=0;f[Ap+8>>2]=0;f[Ap+12>>2]=0;if((uA|0)!=(Np|0))wL(uA);j0(e,z);Cx=f[vp>>2]|0;do if(Cx|0){Rw=Cx+12|0;Jx=f[Rw>>2]|0;f[Rw>>2]=Jx+-1;if((Jx|0)!=1)break;V$(z)}while(0);f[vp>>2]=0;f[wp>>2]=0;f[wp+4>>2]=0;f[wp+8>>2]=0;f[wp+12>>2]=0;if((f[lp>>2]|0)>0){Cx=f[np>>2]|0;Jx=0;do{f[Cx+(Jx<<2)>>2]=0;Jx=Jx+1|0}while((Jx|0)<(f[lp>>2]|0))}f[z>>2]=f[e>>2];Jx=f[Op>>2]|0;f[lp>>2]=Jx;f[mp>>2]=f[Pp>>2];f[up>>2]=f[Qp>>2];f[wp>>2]=f[Rp>>2];f[Cp>>2]=f[Sp>>2];f[Ep>>2]=f[Tp>>2];f[Gp>>2]=f[Up>>2];f[Ip>>2]=f[Vp>>2];f[vp>>2]=f[Wp>>2];Cx=f[Kp>>2]|0;if((Cx|0)==(op|0))vA=Jx;else{wL(Cx);f[Kp>>2]=op;f[np>>2]=mp;vA=f[Op>>2]|0}if((vA|0)<3){Cx=f[Xp>>2]|0;f[op>>2]=f[Cx>>2];f[Bw>>2]=f[Cx+4>>2];wA=Cx}else{f[Kp>>2]=f[Xp>>2];f[_p>>2]=f[Yp>>2];f[Xp>>2]=Zp;f[Yp>>2]=Pp;wA=Zp}f[e>>2]=1124007936;f[Op>>2]=0;f[Op+4>>2]=0;f[Op+8>>2]=0;f[Op+12>>2]=0;f[Op+16>>2]=0;f[Op+20>>2]=0;f[Op+24>>2]=0;f[Op+28>>2]=0;f[Wp>>2]=0;f[Rp>>2]=0;f[Rp+4>>2]=0;f[Rp+8>>2]=0;f[Rp+12>>2]=0;if((wA|0)!=(Zp|0))wL(wA);Cx=Sw+3|0;Jx=f[Yb>>2]|0;Rw=Jx+(Cx*56|0)|0;if((Rw|0)!=(z|0)){Tw=f[vp>>2]|0;if(Tw|0){Aa=Tw+12|0;f[Aa>>2]=(f[Aa>>2]|0)+1}Aa=Jx+(Cx*56|0)+36|0;Tw=f[Aa>>2]|0;do if(Tw|0){Uw=Tw+12|0;jz=f[Uw>>2]|0;f[Uw>>2]=jz+-1;if((jz|0)!=1)break;V$(Rw)}while(0);f[Aa>>2]=0;Tw=Jx+(Cx*56|0)+16|0;jz=Jx+(Cx*56|0)+4|0;f[Tw>>2]=0;f[Tw+4>>2]=0;f[Tw+8>>2]=0;f[Tw+12>>2]=0;if((f[jz>>2]|0)>0){Uw=f[Jx+(Cx*56|0)+40>>2]|0;xA=0;do{f[Uw+(xA<<2)>>2]=0;xA=xA+1|0;yA=f[jz>>2]|0}while((xA|0)<(yA|0));f[Rw>>2]=f[z>>2];if((yA|0)<3)Yw=1733;else Yw=1735}else{f[Rw>>2]=f[z>>2];Yw=1733}do if((Yw|0)==1733){Yw=0;xA=f[lp>>2]|0;if((xA|0)>=3){Yw=1735;break}f[jz>>2]=xA;f[Jx+(Cx*56|0)+8>>2]=f[mp>>2];f[Jx+(Cx*56|0)+12>>2]=f[up>>2];xA=f[pp>>2]|0;Uw=f[Jx+(Cx*56|0)+44>>2]|0;f[Uw>>2]=f[xA>>2];f[Uw+4>>2]=f[xA+4>>2]}while(0);if((Yw|0)==1735){Yw=0;U$(Rw,z)}f[Tw>>2]=f[wp>>2];f[Jx+(Cx*56|0)+20>>2]=f[Cp>>2];f[Jx+(Cx*56|0)+24>>2]=f[Ep>>2];f[Jx+(Cx*56|0)+28>>2]=f[Gp>>2];f[Jx+(Cx*56|0)+32>>2]=f[Ip>>2];f[Aa>>2]=f[vp>>2]}jz=f[vp>>2]|0;do if(jz|0){xA=jz+12|0;Uw=f[xA>>2]|0;f[xA>>2]=Uw+-1;if((Uw|0)!=1)break;V$(z)}while(0);f[vp>>2]=0;f[wp>>2]=0;f[wp+4>>2]=0;f[wp+8>>2]=0;f[wp+12>>2]=0;if((f[lp>>2]|0)>0){jz=f[np>>2]|0;Aa=0;do{f[jz+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[lp>>2]|0))}Aa=f[pp>>2]|0;if((Aa|0)!=(op|0))wL(Aa);Sw=Sw+1|0}while((Sw|0)<3)}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Xo>>0]=4;f[e>>2]=1297371980;b[Yo>>0]=0;Dx=SOa(c,r,e,t)|0;if((b[Xo>>0]|0)<0)cYc(f[e>>2]|0);Vw=IGa(o,r)|0;f[Vw>>2]=Dx;vIa(e,f[(f[Fa>>2]|0)+8>>2]|0);wIa(a,o,c,e,Dx,0);if((b[Zo>>0]|0)<0)cYc(f[e>>2]|0);Dx=IGa(k,r)|0;f[Dx>>2]=2;Dx=f[_o>>2]|0;do if(Dx|0){Vw=Dx+12|0;Sw=f[Vw>>2]|0;f[Vw>>2]=Sw+-1;if((Sw|0)!=1)break;V$(x)}while(0);f[_o>>2]=0;f[$o>>2]=0;f[$o+4>>2]=0;f[$o+8>>2]=0;f[$o+12>>2]=0;if((f[po>>2]|0)>0){Dx=f[ro>>2]|0;Sw=0;do{f[Dx+(Sw<<2)>>2]=0;Sw=Sw+1|0}while((Sw|0)<(f[po>>2]|0))}Sw=f[to>>2]|0;if((Sw|0)!=(so|0))wL(Sw);Sw=f[ap>>2]|0;do if(Sw|0){Dx=Sw+12|0;Vw=f[Dx>>2]|0;f[Dx>>2]=Vw+-1;if((Vw|0)!=1)break;V$(w)}while(0);f[ap>>2]=0;f[bp>>2]=0;f[bp+4>>2]=0;f[bp+8>>2]=0;f[bp+12>>2]=0;if((f[jo>>2]|0)>0){Sw=f[lo>>2]|0;Vw=0;do{f[Sw+(Vw<<2)>>2]=0;Vw=Vw+1|0}while((Vw|0)<(f[jo>>2]|0))}Vw=f[no>>2]|0;if((Vw|0)!=(mo|0))wL(Vw);Vw=f[cp>>2]|0;do if(Vw|0){Sw=Vw+12|0;Dx=f[Sw>>2]|0;f[Sw>>2]=Dx+-1;if((Dx|0)!=1)break;V$(v)}while(0);f[cp>>2]=0;f[dp>>2]=0;f[dp+4>>2]=0;f[dp+8>>2]=0;f[dp+12>>2]=0;if((f[co>>2]|0)>0){Vw=f[fo>>2]|0;Dx=0;do{f[Vw+(Dx<<2)>>2]=0;Dx=Dx+1|0}while((Dx|0)<(f[co>>2]|0))}Dx=f[ho>>2]|0;if((Dx|0)!=(go|0))wL(Dx);Dx=f[ep>>2]|0;do if(Dx|0){Vw=Dx+12|0;Sw=f[Vw>>2]|0;f[Vw>>2]=Sw+-1;if((Sw|0)!=1)break;V$(i)}while(0);f[ep>>2]=0;f[Co>>2]=0;f[Co+4>>2]=0;f[Co+8>>2]=0;f[Co+12>>2]=0;if((f[Yn>>2]|0)>0){Dx=f[_n>>2]|0;Sw=0;do{f[Dx+(Sw<<2)>>2]=0;Sw=Sw+1|0}while((Sw|0)<(f[Yn>>2]|0))}Sw=f[ao>>2]|0;if((Sw|0)!=($n|0))wL(Sw);break c}else{dA=Nz;eA=Oz}while(0);do if(((dA<<24>>24<0?eA:dA&255)|0)==21){if(!(LYc(s,0,-1,381940,21)|0))break;zA=b[Ia>>0]|0;AA=f[Pa>>2]|0;Yw=1786}else{zA=dA;AA=eA;Yw=1786}while(0);do if((Yw|0)==1786){Yw=0;if(((zA<<24>>24<0?AA:zA&255)|0)==14){if(!(LYc(s,0,-1,382509,14)|0))break;BA=b[Ia>>0]|0;CA=f[Pa>>2]|0}else{BA=zA;CA=AA}do if(((BA<<24>>24<0?CA:BA&255)|0)==11){if(LYc(s,0,-1,383449,11)|0){DA=b[Ia>>0]|0;EA=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=2){Yw=1907;break b}f[Pr>>2]=0;f[Qr>>2]=0;f[ka>>2]=Rr;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Dx=Sw;while(1){Sw=Dx+16|0;f[h>>2]=ls;f[e>>2]=f[h>>2];sIa(ka,e,Sw,Sw)|0;Sw=f[Dx+4>>2]|0;do if(!Sw){Vw=Dx+8|0;Ix=f[Vw>>2]|0;if((f[Ix>>2]|0)==(Dx|0)){FA=Ix;break}else GA=Vw;do{Vw=f[GA>>2]|0;GA=Vw+8|0;Ix=f[GA>>2]|0}while((f[Ix>>2]|0)!=(Vw|0));FA=Ix}else{Ix=Sw;while(1){Vw=f[Ix>>2]|0;if(!Vw)break;else Ix=Vw}FA=Ix}while(0);if((FA|0)==(xa|0))break;else Dx=FA}}nKa(i,tIa(a,q,ka,1,0)|0);EGa(ka,f[Rr>>2]|0);if((f[i>>2]&4095|0)!=4){Yw=1916;break b}Dx=f[Sr>>2]|0;if((Dx|0)<3)HA=Y(f[Ur>>2]|0,f[Tr>>2]|0)|0;else{Sw=f[as>>2]|0;Vw=0;Aa=1;while(1){jz=Y(f[Sw+(Vw<<2)>>2]|0,Aa)|0;Vw=Vw+1|0;if((Vw|0)==(Dx|0)){HA=jz;break}else Aa=jz}}mYc(e,r,0,KYc(r,58,-1)|0,r);Aa=qIa(k,e)|0;if((b[Vr>>0]|0)<0)cYc(f[e>>2]|0);do if((Aa|0)!=(ua|0)){if(!((f[Aa+28>>2]|0)==0&(HA|0)>0))break;Dx=f[$r>>2]|0;Vw=f[as>>2]|0;Sw=Vw+4|0;jz=f[bs>>2]|0;Cx=0;do{Jx=(f[i>>2]&16384|0)==0;do if(Jx){if((f[Vw>>2]|0)==1){Yw=1928;break}Tw=f[jz>>2]|0;if((f[Sw>>2]|0)==1){IA=Dx+(Y(Tw,Cx)|0)|0;break}else{Rw=f[Ur>>2]|0;Uw=(Cx|0)/(Rw|0)|0;IA=Dx+(Y(Uw,Tw)|0)+(Cx-(Y(Uw,Rw)|0)<<2)|0;break}}else Yw=1928;while(0);if((Yw|0)==1928){Yw=0;IA=Dx+(Cx<<2)|0}Ix=f[IA>>2]|0;Rw=Ix+4|0;if(Rw>>>0>=8){Yw=1933;break b}do if(Ix)if((Ix|0)>0){JA=((Ix>>>0)%3|0)+1|0;break}else{JA=((Rw>>>0)%3|0)+1|0;break}else JA=0;while(0);do if(Jx){if((f[Vw>>2]|0)==1){Yw=1940;break}Rw=f[jz>>2]|0;if((f[Sw>>2]|0)==1){KA=Dx+(Y(Rw,Cx)|0)|0;break}else{Ix=f[Ur>>2]|0;Uw=(Cx|0)/(Ix|0)|0;KA=Dx+(Y(Uw,Rw)|0)+(Cx-(Y(Uw,Ix)|0)<<2)|0;break}}else Yw=1940;while(0);if((Yw|0)==1940){Yw=0;KA=Dx+(Cx<<2)|0}f[KA>>2]=JA;Cx=Cx+1|0}while((Cx|0)<(HA|0))}while(0);f[Wr>>2]=0;f[Xr>>2]=0;f[e>>2]=16842752;f[Yr>>2]=i;Aa=Zr;f[Aa>>2]=0;f[Aa+4>>2]=0;f[h>>2]=33619968;f[_r>>2]=i;JW(e,h,0);g:do if((HA|0)>1){Aa=f[$r>>2]|0;Cx=f[as>>2]|0;Dx=Cx+4|0;Sw=f[bs>>2]|0;jz=f[Ur>>2]|0;if(f[i>>2]&16384|0){Vw=1;while(1){Jx=f[Aa+(Vw<<2)>>2]|0;Ix=Vw+-1|0;if((Jx|0)!=((f[Aa+(Ix<<2)>>2]|0)+1|0)){Yw=1975;break b}Vw=Vw+1|0;if((Y(f[Aa+(Ix<<2)>>2]|0,Jx)|0)<=-1){Yw=1977;break b}if((Vw|0)>=(HA|0)){LA=Aa;break g}}}Vw=1;Jx=f[Cx>>2]|0;while(1){do if((Jx|0)!=1){Ix=f[Sw>>2]|0;if((f[Dx>>2]|0)==1){MA=Aa+(Y(Ix,Vw)|0)|0;break}else{Uw=(Vw|0)/(jz|0)|0;MA=Aa+(Y(Uw,Ix)|0)+(Vw-(Y(Uw,jz)|0)<<2)|0;break}}else MA=Aa+(Vw<<2)|0;while(0);Uw=f[MA>>2]|0;Ix=Vw+-1|0;do if((Jx|0)!=1){Rw=f[Sw>>2]|0;if((f[Dx>>2]|0)==1){NA=Aa+(Y(Rw,Ix)|0)|0;break}else{Tw=(Ix|0)/(jz|0)|0;NA=Aa+(Y(Tw,Rw)|0)+(Ix-(Y(Tw,jz)|0)<<2)|0;break}}else NA=Aa+(Ix<<2)|0;while(0);if((Uw|0)!=((f[NA>>2]|0)+1|0)){Yw=1975;break b}do if((Jx|0)!=1){Tw=f[Sw>>2]|0;if((f[Dx>>2]|0)==1){OA=Aa+(Y(Tw,Vw)|0)|0;break}else{Rw=(Vw|0)/(jz|0)|0;OA=Aa+(Y(Rw,Tw)|0)+(Vw-(Y(Rw,jz)|0)<<2)|0;break}}else OA=Aa+(Vw<<2)|0;while(0);Uw=f[OA>>2]|0;do if((Jx|0)!=1){Rw=f[Sw>>2]|0;if((f[Dx>>2]|0)==1){PA=Aa+(Y(Rw,Ix)|0)|0;QA=Jx;break}else{Tw=(Ix|0)/(jz|0)|0;PA=Aa+(Y(Tw,Rw)|0)+(Ix-(Y(Tw,jz)|0)<<2)|0;QA=Jx;break}}else{PA=Aa+(Ix<<2)|0;QA=1}while(0);Vw=Vw+1|0;if((Y(f[PA>>2]|0,Uw)|0)<=-1){Yw=1977;break b}if((Vw|0)>=(HA|0)){LA=Aa;break}else Jx=QA}}else LA=f[$r>>2]|0;while(0);b[cs>>0]=10;Pw=e;vx=445445;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[ds>>0]=0;aHa(t,e,LA)|0;if((b[cs>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[es>>0]=8;Jx=e;f[Jx>>2]=1600417381;f[Jx+4>>2]=1936291937;b[fs>>0]=0;Jx=HA+-1|0;Aa=f[$r>>2]|0;do if(!(f[i>>2]&16384)){Vw=f[as>>2]|0;if((f[Vw>>2]|0)==1){Yw=1981;break}jz=f[f[bs>>2]>>2]|0;if((f[Vw+4>>2]|0)==1){RA=Aa+(Y(jz,Jx)|0)|0;break}else{Vw=f[Ur>>2]|0;Dx=(Jx|0)/(Vw|0)|0;RA=Aa+(Y(Dx,jz)|0)+(Jx-(Y(Dx,Vw)|0)<<2)|0;break}}else Yw=1981;while(0);if((Yw|0)==1981){Yw=0;RA=Aa+(Jx<<2)|0}aHa(t,e,RA)|0;if((b[es>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[gs>>0]=9;Pw=e;vx=396713;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[hs>>0]=0;Jx=SOa(c,r,e,t)|0;if((b[gs>>0]|0)<0)cYc(f[e>>2]|0);Aa=IGa(o,r)|0;f[Aa>>2]=Jx;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Jx,0);if((b[is>>0]|0)<0)cYc(f[e>>2]|0);Jx=f[js>>2]|0;do if(Jx|0){Aa=Jx+12|0;Vw=f[Aa>>2]|0;f[Aa>>2]=Vw+-1;if((Vw|0)!=1)break;V$(i)}while(0);f[js>>2]=0;f[$r>>2]=0;f[$r+4>>2]=0;f[$r+8>>2]=0;f[$r+12>>2]=0;if((f[Sr>>2]|0)>0){Jx=f[as>>2]|0;Vw=0;do{f[Jx+(Vw<<2)>>2]=0;Vw=Vw+1|0}while((Vw|0)<(f[Sr>>2]|0))}Vw=f[bs>>2]|0;if((Vw|0)!=(ks|0))wL(Vw);break c}else{DA=BA;EA=CA}while(0);do if(((DA<<24>>24<0?EA:DA&255)|0)==8){if(LYc(s,0,-1,378980,8)|0){SA=b[Ia>>0]|0;TA=f[Pa>>2]|0;break};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ms>>0]=8;Vw=i;f[Vw>>2]=1601071469;f[Vw+4>>2]=1702521203;b[ns>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[os>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[ms>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[yt>>0]=8;Vw=e;f[Vw>>2]=1601071469;f[Vw+4>>2]=1702521203;b[zt>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[At>>0]=8;Vw=i;f[Vw>>2]=1601071469;f[Vw+4>>2]=1702521203;b[Bt>>0]=0;elc(Sb);Vw=AIa(Tb,i)|0;Jx=(f[Vw+20>>2]|0)==3;Aa=Vw+8|0;Vw=Jx?f[Aa+4>>2]|0:0;Dx=h;f[Dx>>2]=Jx?f[Aa>>2]|0:0;f[Dx+4>>2]=Vw;LIa(t,e,h)|0;if((b[At>>0]|0)<0)cYc(f[i>>2]|0);if((b[yt>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ps>>0]=8;Vw=i;f[Vw>>2]=1601724781;f[Vw+4>>2]=1702521203;b[qs>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[rs>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[ps>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ut>>0]=8;Vw=e;f[Vw>>2]=1601724781;f[Vw+4>>2]=1702521203;b[vt>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[wt>>0]=8;Vw=i;f[Vw>>2]=1601724781;f[Vw+4>>2]=1702521203;b[xt>>0]=0;elc(Sb);Vw=AIa(Tb,i)|0;Dx=(f[Vw+20>>2]|0)==3;Aa=Vw+8|0;Vw=Dx?f[Aa+4>>2]|0:0;Jx=h;f[Jx>>2]=Dx?f[Aa>>2]|0:0;f[Jx+4>>2]=Vw;LIa(t,e,h)|0;if((b[wt>>0]|0)<0)cYc(f[i>>2]|0);if((b[ut>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ss>>0]=4;f[i>>2]=1885957222;b[ts>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[us>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[ss>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[qt>>0]=4;f[e>>2]=1885957222;b[rt>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[st>>0]=4;f[i>>2]=1885957222;b[tt>>0]=0;elc(Sb);Vw=AIa(Tb,i)|0;b[h>>0]=(b[Vw+8>>0]|0?(f[Vw+20>>2]|0)==5:0)&1;cHa(t,e,h)|0;if((b[st>>0]|0)<0)cYc(f[i>>2]|0);if((b[qt>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[vs>>0]=4;f[i>>2]=1885957219;b[ws>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[xs>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[vs>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[mt>>0]=4;f[e>>2]=1885957219;b[nt>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ot>>0]=4;f[i>>2]=1885957219;b[pt>>0]=0;elc(Sb);Vw=AIa(Tb,i)|0;b[h>>0]=(b[Vw+8>>0]|0?(f[Vw+20>>2]|0)==5:0)&1;cHa(t,e,h)|0;if((b[ot>>0]|0)<0)cYc(f[i>>2]|0);if((b[mt>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[ys>>0]=6;b[i>>0]=b[455356]|0;b[i+1>>0]=b[455357]|0;b[i+2>>0]=b[455358]|0;b[i+3>>0]=b[455359]|0;b[i+4>>0]=b[455360]|0;b[i+5>>0]=b[455361]|0;b[zs>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[As>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[ys>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[it>>0]=6;b[e>>0]=b[455356]|0;b[e+1>>0]=b[455357]|0;b[e+2>>0]=b[455358]|0;b[e+3>>0]=b[455359]|0;b[e+4>>0]=b[455360]|0;b[e+5>>0]=b[455361]|0;b[jt>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[kt>>0]=6;b[i>>0]=b[455356]|0;b[i+1>>0]=b[455357]|0;b[i+2>>0]=b[455358]|0;b[i+3>>0]=b[455359]|0;b[i+4>>0]=b[455360]|0;b[i+5>>0]=b[455361]|0;b[lt>>0]=0;elc(Sb);Vw=AIa(Tb,i)|0;n[h>>2]=(f[Vw+20>>2]|0)==4?+n[Vw+8>>2]:0.0;OGa(t,e,h)|0;if((b[kt>>0]|0)<0)cYc(f[i>>2]|0);if((b[it>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Bs>>0]=4;f[i>>2]=1885697139;b[Cs>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Ds>>2]|0,i,0);Vw=(f[e>>2]|0)==0;zIa(h);if((b[Bs>>0]|0)<0)cYc(f[i>>2]|0);if(!Vw){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[et>>0]=4;f[e>>2]=1885697139;b[ft>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[gt>>0]=4;f[i>>2]=1885697139;b[ht>>0]=0;elc(Sb);Vw=AIa(Tb,i)|0;n[h>>2]=(f[Vw+20>>2]|0)==4?+n[Vw+8>>2]:0.0;OGa(t,e,h)|0;if((b[gt>>0]|0)<0)cYc(f[i>>2]|0);if((b[et>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Es>>0]=8;Vw=i;f[Vw>>2]=1769103734;f[Vw+4>>2]=1701015137;b[Fs>>0]=0;f[Gs>>2]=0;f[Gs+4>>2]=0;f[Gs+8>>2]=0;Vw=$Xc(16)|0;f[Gs>>2]=Vw;f[Hs>>2]=-2147483632;f[Is>>2]=12;Pw=Vw;vx=442693;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+12>>0]=0;f[Js>>2]=0;f[Js+4>>2]=0;f[Js+8>>2]=0;b[Ks>>0]=6;b[Js>>0]=b[378989]|0;b[Js+1>>0]=b[378990]|0;b[Js+2>>0]=b[378991]|0;b[Js+3>>0]=b[378992]|0;b[Js+4>>0]=b[378993]|0;b[Js+5>>0]=b[378994]|0;b[Ls>>0]=0;f[Ms>>2]=0;f[Ms+4>>2]=0;f[Ms+8>>2]=0;b[Ns>>0]=5;b[Ms>>0]=b[471037]|0;b[Ms+1>>0]=b[471038]|0;b[Ms+2>>0]=b[471039]|0;b[Ms+3>>0]=b[471040]|0;b[Ms+4>>0]=b[471041]|0;b[Os>>0]=0;f[Ps>>2]=0;f[Ps+4>>2]=0;f[Ps+8>>2]=0;b[Qs>>0]=6;b[Ps>>0]=b[471030]|0;b[Ps+1>>0]=b[471031]|0;b[Ps+2>>0]=b[471032]|0;b[Ps+3>>0]=b[471033]|0;b[Ps+4>>0]=b[471034]|0;b[Ps+5>>0]=b[471035]|0;b[Rs>>0]=0;Jx=0;do{Aa=i+(Jx*12|0)|0;elc(Sb);xIa(h,Tb);yIa(e,f[Ss>>2]|0,Aa,0);Dx=(f[e>>2]|0)==0;zIa(h);if(!Dx){elc(Sb);Dx=AIa(Tb,Aa)|0;nKa(e,(f[Dx+20>>2]|0)==8?f[Dx+8>>2]|0:530864);Dx=f[Ts>>2]|0;jz=f[Us>>2]|0;if((jz|0)<3)UA=Y(f[Ws>>2]|0,f[Vs>>2]|0)|0;else{Sw=f[Zs>>2]|0;Cx=0;Ix=1;while(1){Tw=Y(f[Sw+(Cx<<2)>>2]|0,Ix)|0;Cx=Cx+1|0;if((Cx|0)==(jz|0)){UA=Tw;break}else Ix=Tw}}Ix=$Xc(16)|0;jz=Ix+8|0;f[Ix>>2]=jz;f[Ix+4>>2]=UA;if(UA>>>0>1){Cx=bYc(UA>>>0>536870911?-1:UA<<3)|0;f[Ix>>2]=Cx;VA=Cx}else VA=jz;f[h>>2]=2;f[Xs>>2]=Ix;if((UA|0)>0){Ix=Dx;jz=0;while(1){p[VA+(jz<<3)>>3]=+n[Ix>>2];jz=jz+1|0;if((jz|0)==(UA|0))break;else Ix=Ix+4|0}}$Ga(t,Aa,h)|0;RGa(h);Ix=f[Ys>>2]|0;do if(Ix|0){jz=Ix+12|0;Dx=f[jz>>2]|0;f[jz>>2]=Dx+-1;if((Dx|0)!=1)break;V$(e)}while(0);f[Ys>>2]=0;f[Ts>>2]=0;f[Ts+4>>2]=0;f[Ts+8>>2]=0;f[Ts+12>>2]=0;if((f[Us>>2]|0)>0){Ix=f[Zs>>2]|0;Aa=0;do{f[Ix+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[Us>>2]|0))}Aa=f[_s>>2]|0;if((Aa|0)!=($s|0))wL(Aa)}Jx=Jx+1|0}while((Jx|0)<5);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[at>>0]=8;Jx=e;f[Jx>>2]=1869181520;f[Jx+4>>2]=2020557426;b[bt>>0]=0;Jx=SOa(c,r,e,t)|0;if((b[at>>0]|0)<0)cYc(f[e>>2]|0);Vw=IGa(o,r)|0;f[Vw>>2]=Jx;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Jx,0);if((b[ct>>0]|0)<0)cYc(f[e>>2]|0);vIa(e,f[(f[Fa>>2]|0)+8>>2]|0);wIa(a,o,c,e,Jx,1);if((b[dt>>0]|0)<0)cYc(f[e>>2]|0);Jx=IGa(k,r)|0;f[Jx>>2]=2;if((b[Dw>>0]|0)<0)cYc(f[Cw>>2]|0);if((b[Fw>>0]|0)<0)cYc(f[Ew>>2]|0);if((b[Hw>>0]|0)<0)cYc(f[Gw>>2]|0);if((b[Jw>>0]|0)<0)cYc(f[Iw>>2]|0);if((b[Kw>>0]|0)<0)cYc(f[i>>2]|0);break c}else{SA=DA;TA=EA}while(0);do if(((SA<<24>>24<0?TA:SA&255)|0)==7){if(LYc(s,0,-1,429025,7)|0){WA=b[Ia>>0]|0;XA=f[Pa>>2]|0;break};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Ct>>0]=4;f[i>>2]=1936291937;b[Dt>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Et>>2]|0,i,0);Jx=(f[e>>2]|0)==0;zIa(h);if((b[Ct>>0]|0)<0)cYc(f[i>>2]|0);if(!Jx){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[It>>0]=4;f[e>>2]=1936291937;b[Jt>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Kt>>0]=4;f[i>>2]=1936291937;b[Lt>>0]=0;elc(Sb);Jx=AIa(Tb,i)|0;Vw=(f[Jx+20>>2]|0)==3;Aa=Jx+8|0;Jx=Vw?f[Aa+4>>2]|0:0;Ix=h;f[Ix>>2]=Vw?f[Aa>>2]|0:0;f[Ix+4>>2]=Jx;LIa(t,e,h)|0;if((b[Kt>>0]|0)<0)cYc(f[i>>2]|0);if((b[It>>0]|0)<0)cYc(f[e>>2]|0)}f[Lw>>2]=0;b[Ft>>0]=7;b[e>>0]=b[429025]|0;b[e+1>>0]=b[429026]|0;b[e+2>>0]=b[429027]|0;b[e+3>>0]=b[429028]|0;b[e+4>>0]=b[429029]|0;b[e+5>>0]=b[429030]|0;b[e+6>>0]=b[429031]|0;b[Gt>>0]=0;Jx=SOa(c,r,e,t)|0;if((b[Ft>>0]|0)<0)cYc(f[e>>2]|0);Ix=IGa(o,r)|0;f[Ix>>2]=Jx;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);Ix=f[Da>>2]|0;if((Ix|0)>0){Aa=0;do{wIa(a,o,c,e,Jx,Aa);Aa=Aa+1|0}while((Aa|0)!=(Ix|0))}if((b[Ht>>0]|0)<0)cYc(f[e>>2]|0);break c}else{WA=SA;XA=TA}while(0);do if(((WA<<24>>24<0?XA:WA&255)|0)==13){if(LYc(s,0,-1,396522,13)|0){YA=b[Ia>>0]|0;ZA=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=3){Yw=2102;break b}f[Mt>>2]=0;f[Nt>>2]=0;f[la>>2]=Ot;Ix=f[l>>2]|0;if((Ix|0)!=(xa|0)){Aa=Ix;while(1){Ix=Aa+16|0;f[h>>2]=eu;f[e>>2]=f[h>>2];sIa(la,e,Ix,Ix)|0;Ix=f[Aa+4>>2]|0;do if(!Ix){Jx=Aa+8|0;Vw=f[Jx>>2]|0;if((f[Vw>>2]|0)==(Aa|0)){_A=Vw;break}else $A=Jx;do{Jx=f[$A>>2]|0;$A=Jx+8|0;Vw=f[$A>>2]|0}while((f[Vw>>2]|0)!=(Jx|0));_A=Vw}else{Uw=Ix;while(1){Vw=f[Uw>>2]|0;if(!Vw)break;else Uw=Vw}_A=Uw}while(0);if((_A|0)==(xa|0))break;else Aa=_A}}nKa(i,tIa(a,q,la,2,0)|0);EGa(la,f[Ot>>2]|0);aB=f[i>>2]&4095;if((aB|0)!=4){Yw=2111;break b}bB=f[Pt>>2]|0;cB=(bB|0)<3;if(cB)dB=Y(f[Rt>>2]|0,f[Qt>>2]|0)|0;else{Aa=f[Xt>>2]|0;Ix=0;Vw=1;while(1){Jx=Y(f[Aa+(Ix<<2)>>2]|0,Vw)|0;Ix=Ix+1|0;if((Ix|0)==(bB|0)){dB=Jx;break}else Vw=Jx}}if((dB|0)!=2){Yw=2117;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[St>>0]=6;b[e>>0]=b[471030]|0;b[e+1>>0]=b[471031]|0;b[e+2>>0]=b[471032]|0;b[e+3>>0]=b[471033]|0;b[e+4>>0]=b[471034]|0;b[e+5>>0]=b[471035]|0;b[Tt>>0]=0;aHa(t,e,f[Ut>>2]|0)|0;if((b[St>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Vt>>0]=5;b[e>>0]=b[471037]|0;b[e+1>>0]=b[471038]|0;b[e+2>>0]=b[471039]|0;b[e+3>>0]=b[471040]|0;b[e+4>>0]=b[471041]|0;b[Wt>>0]=0;Vw=f[Ut>>2]|0;do if(!(f[i>>2]&16384)){Ix=f[Xt>>2]|0;if((f[Ix>>2]|0)==1){Yw=2126;break}Aa=f[f[Yt>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){eB=Vw+Aa|0;break}else{Ix=f[Rt>>2]|0;Jx=(Ix+1|0)>>>0<3?Ix:0;eB=Vw+(Y(Jx,Aa)|0)+(1-(Y(Jx,Ix)|0)<<2)|0;break}}else Yw=2126;while(0);if((Yw|0)==2126){Yw=0;eB=Vw+4|0}aHa(t,e,eB)|0;if((b[Vt>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ix=$Xc(16)|0;f[e>>2]=Ix;f[Zt>>2]=-2147483632;f[_t>>2]=13;Pw=Ix;vx=396522;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ix+13>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[$t>>0]|0)<0)cYc(f[e>>2]|0);Jx=IGa(o,r)|0;f[Jx>>2]=Vw;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Vw,0);if((b[au>>0]|0)<0)cYc(f[e>>2]|0);vIa(e,f[(f[Fa>>2]|0)+8>>2]|0);wIa(a,o,c,e,Vw,1);if((b[bu>>0]|0)<0)cYc(f[e>>2]|0);Vw=f[cu>>2]|0;do if(Vw|0){Jx=Vw+12|0;Aa=f[Jx>>2]|0;f[Jx>>2]=Aa+-1;if((Aa|0)!=1)break;V$(i)}while(0);f[cu>>2]=0;f[Ut>>2]=0;f[Ut+4>>2]=0;f[Ut+8>>2]=0;f[Ut+12>>2]=0;if((f[Pt>>2]|0)>0){Vw=f[Xt>>2]|0;Ix=0;do{f[Vw+(Ix<<2)>>2]=0;Ix=Ix+1|0}while((Ix|0)<(f[Pt>>2]|0))}Ix=f[Yt>>2]|0;if((Ix|0)!=(du|0))wL(Ix);break c}else{YA=WA;ZA=XA}while(0);do if(((YA<<24>>24<0?ZA:YA&255)|0)==4){if(LYc(s,0,-1,378996,4)|0){fB=b[Ia>>0]|0;gB=f[Pa>>2]|0;break}f[fu>>2]=0;f[gu>>2]=0;f[ma>>2]=hu;Ix=f[l>>2]|0;if((Ix|0)!=(xa|0)){Vw=Ix;while(1){Ix=Vw+16|0;f[h>>2]=Wu;f[e>>2]=f[h>>2];sIa(ma,e,Ix,Ix)|0;Ix=f[Vw+4>>2]|0;do if(!Ix){Aa=Vw+8|0;Jx=f[Aa>>2]|0;if((f[Jx>>2]|0)==(Vw|0)){hB=Jx;break}else iB=Aa;do{Aa=f[iB>>2]|0;iB=Aa+8|0;Jx=f[iB>>2]|0}while((f[Jx>>2]|0)!=(Aa|0));hB=Jx}else{Uw=Ix;while(1){Jx=f[Uw>>2]|0;if(!Jx)break;else Uw=Jx}hB=Uw}while(0);if((hB|0)==(xa|0))break;else Vw=hB}}nKa(i,tIa(a,q,ma,1,0)|0);EGa(ma,f[hu>>2]|0);Vw=f[i>>2]|0;if((Vw&4095|0)!=4){Yw=2158;break b}Ix=f[iu>>2]|0;if((Ix|0)<3)jB=Y(f[ku>>2]|0,f[ju>>2]|0)|0;else{Jx=f[mu>>2]|0;Aa=0;Dx=1;while(1){jz=Y(f[Jx+(Aa<<2)>>2]|0,Dx)|0;Aa=Aa+1|0;if((Aa|0)==(Ix|0)){jB=jz;break}else Dx=jz}}if((jB|0)!=2){Yw=2172;break b}Dx=f[lu>>2]|0;if((f[Dx>>2]|0)!=1){Yw=2172;break b}do if(!(Vw&16384)){Ix=f[mu>>2]|0;if((f[Ix>>2]|0)==1){Yw=2167;break}Aa=f[f[nu>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){kB=Dx+Aa|0;break}else{Ix=f[ku>>2]|0;Jx=(Ix+1|0)>>>0<3?Ix:0;kB=Dx+(Y(Jx,Aa)|0)+(1-(Y(Jx,Ix)|0)<<2)|0;break}}else Yw=2167;while(0);if((Yw|0)==2167){Yw=0;kB=Dx+4|0}if((f[kB>>2]|0)!=2){Yw=2172;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ou>>0]=4;f[e>>2]=1819242352;b[pu>>0]=0;JIa(t,e,443331)|0;if((b[ou>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Vw=$Xc(16)|0;f[e>>2]=Vw;f[qu>>2]=-2147483632;f[ru>>2]=14;Pw=Vw;vx=446919;Qw=Pw+14|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+14>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[su>>0]|0)<0)cYc(f[e>>2]|0);f[Mw>>2]=0;b[tu>>0]=7;b[e>>0]=b[429057]|0;b[e+1>>0]=b[429058]|0;b[e+2>>0]=b[429059]|0;b[e+3>>0]=b[429060]|0;b[e+4>>0]=b[429061]|0;b[e+5>>0]=b[429062]|0;b[e+6>>0]=b[429063]|0;b[uu>>0]=0;Dx=SOa(c,r,e,t)|0;if((b[tu>>0]|0)<0)cYc(f[e>>2]|0);Ix=IGa(o,r)|0;f[Ix>>2]=Dx;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Dx,0);if((b[vu>>0]|0)<0)cYc(f[e>>2]|0);f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;b[wu>>0]=8;Dx=v;f[Dx>>2]=1885693291;f[Dx+4>>2]=1936550244;b[xu>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[yu>>2]|0,v,0);Dx=(f[e>>2]|0)==0;zIa(h);if((b[wu>>0]|0)<0)cYc(f[v>>2]|0);do if(Dx){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;b[zu>>0]=9;Pw=v;vx=379071;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Au>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Bu>>2]|0,v,0);Ix=(f[e>>2]|0)==0;zIa(h);if((b[zu>>0]|0)<0)cYc(f[v>>2]|0);if(Ix){Yw=2193;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Cu>>0]=9;Pw=e;vx=379071;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Du>>0]=0;elc(Sb);Ix=AIa(Tb,e)|0;Jx=b[Ix+8>>0]|0?(f[Ix+20>>2]|0)==5:0;if((b[Cu>>0]|0)<0)cYc(f[e>>2]|0);if(!Jx)Yw=2193}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Uu>>0]=8;Jx=e;f[Jx>>2]=1885693291;f[Jx+4>>2]=1936550244;b[Vu>>0]=0;elc(Sb);Jx=AIa(Tb,e)|0;Ix=b[Jx+8>>0]|0?(f[Jx+20>>2]|0)==5:0;if((b[Uu>>0]|0)<0)cYc(f[e>>2]|0);if(!Ix)Yw=2193}while(0);if((Yw|0)==2193){Yw=0;f[Eu>>2]=0;f[Fu>>2]=0;f[e>>2]=Gu;Pw=Hu;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));AN(h,r,379081);if((CHa(o,h)|0)!=(qa|0)){Yw=2194;break b}f[Nw>>2]=0;b[Iu>>0]=7;b[v>>0]=b[396507]|0;b[v+1>>0]=b[396508]|0;b[v+2>>0]=b[396509]|0;b[v+3>>0]=b[396510]|0;b[v+4>>0]=b[396511]|0;b[v+5>>0]=b[396512]|0;b[v+6>>0]=b[396513]|0;b[Ju>>0]=0;Dx=SOa(c,h,v,e)|0;if((b[Iu>>0]|0)<0)cYc(f[v>>2]|0);Vw=IGa(o,h)|0;f[Vw>>2]=Dx;lYc(v,r);f[Ku>>2]=0;wIa(a,o,c,v,Dx,0);if((b[Lu>>0]|0)<0)cYc(f[v>>2]|0);if((b[Mu>>0]|0)<0)cYc(f[h>>2]|0);if((b[Ou>>0]|0)<0)cYc(f[Nu>>2]|0);if((b[Qu>>0]|0)<0)cYc(f[Pu>>2]|0);hx(Ru);QGa(e,f[Gu>>2]|0)}Dx=f[Su>>2]|0;do if(Dx|0){Vw=Dx+12|0;Ix=f[Vw>>2]|0;f[Vw>>2]=Ix+-1;if((Ix|0)!=1)break;V$(i)}while(0);f[Su>>2]=0;f[lu>>2]=0;f[lu+4>>2]=0;f[lu+8>>2]=0;f[lu+12>>2]=0;if((f[iu>>2]|0)>0){Dx=f[mu>>2]|0;Ix=0;do{f[Dx+(Ix<<2)>>2]=0;Ix=Ix+1|0}while((Ix|0)<(f[iu>>2]|0))}Ix=f[nu>>2]|0;if((Ix|0)!=(Tu|0))wL(Ix);break c}else{fB=YA;gB=ZA}while(0);do if(((fB<<24>>24<0?gB:fB&255)|0)==11){if(LYc(s,0,-1,379135,11)|0){lB=b[Ia>>0]|0;mB=f[Pa>>2]|0;break}if((f[Da>>2]|0)!=3){Yw=2219;break b}f[Xu>>2]=0;f[Yu>>2]=0;f[na>>2]=Zu;Ix=f[l>>2]|0;if((Ix|0)!=(xa|0)){Dx=Ix;while(1){Ix=Dx+16|0;f[h>>2]=zv;f[e>>2]=f[h>>2];sIa(na,e,Ix,Ix)|0;Ix=f[Dx+4>>2]|0;do if(!Ix){Vw=Dx+8|0;Jx=f[Vw>>2]|0;if((f[Jx>>2]|0)==(Dx|0)){nB=Jx;break}else oB=Vw;do{Vw=f[oB>>2]|0;oB=Vw+8|0;Jx=f[oB>>2]|0}while((f[Jx>>2]|0)!=(Vw|0));nB=Jx}else{Uw=Ix;while(1){Jx=f[Uw>>2]|0;if(!Jx)break;else Uw=Jx}nB=Uw}while(0);if((nB|0)==(xa|0))break;else Dx=nB}}nKa(i,tIa(a,q,na,1,0)|0);EGa(na,f[Zu>>2]|0);f[_u>>2]=0;f[$u>>2]=0;f[oa>>2]=av;Dx=f[l>>2]|0;if((Dx|0)!=(xa|0)){Ix=Dx;while(1){Dx=Ix+16|0;f[h>>2]=yv;f[e>>2]=f[h>>2];sIa(oa,e,Dx,Dx)|0;Dx=f[Ix+4>>2]|0;do if(!Dx){Jx=Ix+8|0;Vw=f[Jx>>2]|0;if((f[Vw>>2]|0)==(Ix|0)){pB=Vw;break}else qB=Jx;do{Jx=f[qB>>2]|0;qB=Jx+8|0;Vw=f[qB>>2]|0}while((f[Vw>>2]|0)!=(Jx|0));pB=Vw}else{Uw=Dx;while(1){Vw=f[Uw>>2]|0;if(!Vw)break;else Uw=Vw}pB=Uw}while(0);if((pB|0)==(xa|0))break;else Ix=pB}}nKa(v,tIa(a,q,oa,2,0)|0);EGa(oa,f[av>>2]|0);rB=f[bv>>2]|0;sB=(rB|0)<3;if(sB)tB=Y(f[dv>>2]|0,f[cv>>2]|0)|0;else{Ix=f[vv>>2]|0;Dx=0;Vw=1;while(1){Jx=Y(f[Ix+(Dx<<2)>>2]|0,Vw)|0;Dx=Dx+1|0;if((Dx|0)==(rB|0)){tB=Jx;break}else Vw=Jx}}if((tB|0)!=1){Yw=2239;break b}uB=f[i>>2]&4095;if((uB|0)!=5){Yw=2245;break b}vB=f[ev>>2]|0;wB=(vB|0)<3;if(wB)xB=Y(f[gv>>2]|0,f[fv>>2]|0)|0;else{Vw=f[rv>>2]|0;Dx=0;Ix=1;while(1){Jx=Y(f[Vw+(Dx<<2)>>2]|0,Ix)|0;Dx=Dx+1|0;if((Dx|0)==(vB|0)){xB=Jx;break}else Ix=Jx}}if((xB|0)!=1){Yw=2251;break b}yB=f[v>>2]&4095;if((yB|0)!=5){Yw=2257;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[hv>>0]=9;Pw=e;vx=429854;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[iv>>0]=0;OGa(t,e,f[jv>>2]|0)|0;if((b[hv>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[kv>>0]=9;Pw=e;vx=429864;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[lv>>0]=0;OGa(t,e,f[mv>>2]|0)|0;if((b[kv>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[nv>>0]=5;b[e>>0]=b[396595]|0;b[e+1>>0]=b[396596]|0;b[e+2>>0]=b[396597]|0;b[e+3>>0]=b[396598]|0;b[e+4>>0]=b[396599]|0;b[ov>>0]=0;Ix=SOa(c,r,e,t)|0;if((b[nv>>0]|0)<0)cYc(f[e>>2]|0);Dx=IGa(o,r)|0;f[Dx>>2]=Ix;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Ix,0);if((b[pv>>0]|0)<0)cYc(f[e>>2]|0);Ix=f[qv>>2]|0;do if(Ix|0){Dx=Ix+12|0;Vw=f[Dx>>2]|0;f[Dx>>2]=Vw+-1;if((Vw|0)!=1)break;V$(v)}while(0);f[qv>>2]=0;f[mv>>2]=0;f[mv+4>>2]=0;f[mv+8>>2]=0;f[mv+12>>2]=0;if((f[ev>>2]|0)>0){Ix=f[rv>>2]|0;Vw=0;do{f[Ix+(Vw<<2)>>2]=0;Vw=Vw+1|0}while((Vw|0)<(f[ev>>2]|0))}Vw=f[sv>>2]|0;if((Vw|0)!=(tv|0))wL(Vw);Vw=f[uv>>2]|0;do if(Vw|0){Ix=Vw+12|0;Dx=f[Ix>>2]|0;f[Ix>>2]=Dx+-1;if((Dx|0)!=1)break;V$(i)}while(0);f[uv>>2]=0;f[jv>>2]=0;f[jv+4>>2]=0;f[jv+8>>2]=0;f[jv+12>>2]=0;if((f[bv>>2]|0)>0){Vw=f[vv>>2]|0;Dx=0;do{f[Vw+(Dx<<2)>>2]=0;Dx=Dx+1|0}while((Dx|0)<(f[bv>>2]|0))}Dx=f[wv>>2]|0;if((Dx|0)!=(xv|0))wL(Dx);break c}else{lB=fB;mB=gB}while(0);do if(((lB<<24>>24<0?mB:lB&255)|0)==3){if(!(LYc(s,0,-1,379147,3)|0))break;zB=b[Ia>>0]|0;AB=f[Pa>>2]|0;Yw=2286}else{zB=lB;AB=mB;Yw=2286}while(0);do if((Yw|0)==2286){Yw=0;if(((zB<<24>>24<0?AB:zB&255)|0)==4){if(!(LYc(s,0,-1,386173,4)|0))break;BB=b[Ia>>0]|0;CB=f[Pa>>2]|0}else{BB=zB;CB=AB}if(((BB<<24>>24<0?CB:BB&255)|0)==7){if(!(LYc(s,0,-1,396621,7)|0))break;DB=b[Ia>>0]|0;EB=f[Pa>>2]|0}else{DB=BB;EB=CB}if(((DB<<24>>24<0?EB:DB&255)|0)==4){if(!(LYc(s,0,-1,379151,4)|0))break;FB=b[Ia>>0]|0;GB=f[Pa>>2]|0}else{FB=DB;GB=EB}if(((FB<<24>>24<0?GB:FB&255)|0)==3){if(!(LYc(s,0,-1,379156,3)|0))break;HB=b[Ia>>0]|0;IB=f[Pa>>2]|0}else{HB=FB;IB=GB}if(((HB<<24>>24<0?IB:HB&255)|0)==8){if(!(LYc(s,0,-1,428991,8)|0))break;JB=b[Ia>>0]|0;KB=f[Pa>>2]|0}else{JB=HB;KB=IB}if(((JB<<24>>24<0?KB:JB&255)|0)==5?(LYc(s,0,-1,383958,5)|0)==0:0)break;elc(Sb);xIa(i,Tb);Dx=f[Cv>>2]|0;Vw=f[Dx+12>>2]|0;Ix=f[Dx+4>>2]|0;h:do if(Ix>>>0>Vw>>>0){Jx=f[Dx+16>>2]|0;Aa=Vw;while(1){LB=f[Jx+(Aa<<2)>>2]|0;if(LB|0)break;jz=Aa+1|0;if(jz>>>0<Ix>>>0)Aa=jz;else{MB=0;NB=jz;break h}}if((LB|0)==(f[Jx+((Aa^1)<<2)>>2]|0)){MB=f[(f[LB>>2]|0)+16>>2]|0;NB=Aa;break}else{MB=LB;NB=Aa;break}}else{MB=0;NB=Vw}while(0);f[e>>2]=MB;f[Dv>>2]=Dx;f[Ev>>2]=NB;if(MB|0){Vw=MB;do{Ix=f[Vw+12>>2]|0;if((f[Ix+36>>2]|0)==2){_Ga(t,Ix,f[Ix+24>>2]|0)|0;OB=f[e>>2]|0}else OB=Vw;Ix=f[OB+12>>2]|0;if((f[Ix+36>>2]|0)==3){jz=f[OB+12>>2]|0;if((f[jz+36>>2]|0)==3){Cx=jz+24|0;PB=f[Cx>>2]|0;QB=f[Cx+4>>2]|0}else{PB=0;QB=0}Cx=h;f[Cx>>2]=PB;f[Cx+4>>2]=QB;LIa(t,Ix,h)|0;RB=f[e>>2]|0}else RB=OB;Ix=f[RB+12>>2]|0;if((f[Ix+36>>2]|0)==4){Cx=f[RB+12>>2]|0;if((f[Cx+36>>2]|0)==4)SB=+n[Cx+24>>2];else SB=0.0;n[h>>2]=SB;OGa(t,Ix,h)|0;TB=f[e>>2]|0}else TB=RB;Ix=f[TB+12>>2]|0;if((f[Ix+36>>2]|0)==5){Cx=f[TB+12>>2]|0;if((f[Cx+36>>2]|0)==5)UB=(b[Cx+24>>0]|0)!=0;else UB=0;b[h>>0]=UB&1;cHa(t,Ix,h)|0}RIa(e)|0;Vw=f[e>>2]|0}while((Vw|0)!=0)}f[v>>2]=0;f[Fv>>2]=0;f[Gv>>2]=0;if((f[Da>>2]|0)>0){Vw=0;do{do if((CHa(l,f[(f[Fa>>2]|0)+4+(Vw<<2)>>2]|0)|0)==(xa|0)){Dx=f[(f[Fa>>2]|0)+4+(Vw<<2)>>2]|0;Ix=f[Fv>>2]|0;if((Ix|0)==(f[Hv>>2]|0)){NN(v,Dx);break}else{lYc(Ix,Dx);f[Fv>>2]=(f[Fv>>2]|0)+12;break}}else{f[Iv>>2]=0;f[Jv>>2]=0;f[pa>>2]=Kv;Dx=f[l>>2]|0;if((Dx|0)!=(xa|0)){Ix=Dx;while(1){Dx=Ix+16|0;f[h>>2]=Yv;f[e>>2]=f[h>>2];sIa(pa,e,Dx,Dx)|0;Dx=f[Ix+4>>2]|0;do if(!Dx){Cx=Ix+8|0;jz=f[Cx>>2]|0;if((f[jz>>2]|0)==(Ix|0)){VB=jz;break}else WB=Cx;do{Cx=f[WB>>2]|0;WB=Cx+8|0;jz=f[WB>>2]|0}while((f[jz>>2]|0)!=(Cx|0));VB=jz}else{jz=Dx;while(1){Cx=f[jz>>2]|0;if(!Cx)break;else jz=Cx}VB=jz}while(0);if((VB|0)==(xa|0))break;else Ix=VB}}nKa(w,tIa(a,q,pa,Vw,0)|0);EGa(pa,f[Kv>>2]|0);Ix=f[dl>>2]|0;if((Ix|0)==(f[Lv>>2]|0))bx(Yb,w);else{f[Ix>>2]=f[w>>2];Uw=Ix+4|0;f[Uw>>2]=f[Ov>>2];Dx=Ix+8|0;f[Dx>>2]=f[Sv>>2];f[Ix+12>>2]=f[Tv>>2];f[Ix+16>>2]=f[Nv>>2];f[Ix+20>>2]=f[Uv>>2];f[Ix+24>>2]=f[Vv>>2];f[Ix+28>>2]=f[Wv>>2];f[Ix+32>>2]=f[Xv>>2];Bx=f[Mv>>2]|0;f[Ix+36>>2]=Bx;f[Ix+40>>2]=Dx;Dx=Ix+48|0;Cx=Ix+44|0;f[Cx>>2]=Dx;f[Dx>>2]=0;f[Ix+52>>2]=0;if(Bx|0){Dx=Bx+12|0;f[Dx>>2]=(f[Dx>>2]|0)+1}if((f[Ov>>2]|0)<3){Dx=f[Qv>>2]|0;Bx=f[Cx>>2]|0;f[Bx>>2]=f[Dx>>2];f[Bx+4>>2]=f[Dx+4>>2]}else{f[Uw>>2]=0;U$(Ix,w)}f[dl>>2]=(f[dl>>2]|0)+56}Ix=f[Mv>>2]|0;do if(Ix|0){Uw=Ix+12|0;Dx=f[Uw>>2]|0;f[Uw>>2]=Dx+-1;if((Dx|0)!=1)break;V$(w)}while(0);f[Mv>>2]=0;f[Nv>>2]=0;f[Nv+4>>2]=0;f[Nv+8>>2]=0;f[Nv+12>>2]=0;if((f[Ov>>2]|0)>0){Ix=f[Pv>>2]|0;Dx=0;do{f[Ix+(Dx<<2)>>2]=0;Dx=Dx+1|0}while((Dx|0)<(f[Ov>>2]|0))}Dx=f[Qv>>2]|0;if((Dx|0)!=(Rv|0))wL(Dx)}while(0);Vw=Vw+1|0}while((Vw|0)<(f[Da>>2]|0))}Vw=SOa(c,r,s,t)|0;Aa=IGa(o,r)|0;f[Aa>>2]=Vw;Aa=f[Fv>>2]|0;Jx=f[v>>2]|0;Dx=Jx;if((Aa|0)==(Jx|0)){XB=Aa;YB=Dx}else{Aa=0;Jx=Dx;while(1){vIa(e,Jx+(Aa*12|0)|0);wIa(a,o,c,e,Vw,Aa);if((b[Zv>>0]|0)<0)cYc(f[e>>2]|0);Aa=Aa+1|0;Dx=f[Fv>>2]|0;Ix=f[v>>2]|0;Uw=Ix;if(Aa>>>0>=((Dx-Ix|0)/12|0)>>>0){XB=Dx;YB=Uw;break}else Jx=Uw}}Jx=XB;if(YB|0){if((Jx|0)==(YB|0))ZB=YB;else{Aa=Jx;while(1){Jx=Aa+-12|0;f[Fv>>2]=Jx;if((b[Jx+11>>0]|0)<0){cYc(f[Jx>>2]|0);_B=f[Fv>>2]|0}else _B=Jx;if((_B|0)==(YB|0))break;else Aa=_B}ZB=f[v>>2]|0}cYc(ZB)}zIa(i);break c}while(0);lYc(e,s);Aa=b[Ia>>0]|0;Jx=f[Pa>>2]|0;do if(((Aa<<24>>24<0?Jx:Aa&255)|0)==3)if(!(LYc(s,0,-1,379147,3)|0)){tYc(e,396633)|0;break}else{$B=b[Ia>>0]|0;aC=f[Pa>>2]|0;Yw=2307;break}else{$B=Aa;aC=Jx;Yw=2307}while(0);i:do if((Yw|0)==2307){Yw=0;do if((($B<<24>>24<0?aC:$B&255)|0)==4)if(!(LYc(s,0,-1,386173,4)|0)){tYc(e,394925)|0;break i}else{bC=b[Ia>>0]|0;cC=f[Pa>>2]|0;break}else{bC=$B;cC=aC}while(0);do if(((bC<<24>>24<0?cC:bC&255)|0)==4)if(!(LYc(s,0,-1,379151,4)|0)){tYc(e,429133)|0;break i}else{dC=b[Ia>>0]|0;eC=f[Pa>>2]|0;break}else{dC=bC;eC=cC}while(0);do if(((dC<<24>>24<0?eC:dC&255)|0)==5)if(!(LYc(s,0,-1,383958,5)|0)){tYc(e,396595)|0;break i}else{fC=b[Ia>>0]|0;gC=f[Pa>>2]|0;break}else{fC=dC;gC=eC}while(0);if(((fC<<24>>24<0?gC:fC&255)|0)!=3)break;if(LYc(s,0,-1,379156,3)|0)break;tYc(e,396629)|0}while(0);Jx=SOa(c,r,e,t)|0;Aa=IGa(o,r)|0;f[Aa>>2]=Jx;vIa(h,f[(f[Fa>>2]|0)+4>>2]|0);Aa=f[Da>>2]|0;if((Aa|0)>0){Vw=0;do{wIa(a,o,c,h,Jx,Vw);Vw=Vw+1|0}while((Vw|0)!=(Aa|0))}if((b[Av>>0]|0)<0)cYc(f[h>>2]|0);if((b[Bv>>0]|0)<0)cYc(f[e>>2]|0);break c}while(0);switch(f[Da>>2]|0){case 2:{f[Eq>>2]=0;f[Fq>>2]=0;f[ha>>2]=Gq;Aa=f[l>>2]|0;if((Aa|0)!=(xa|0)){Vw=Aa;while(1){Aa=Vw+16|0;f[h>>2]=Tq;f[e>>2]=f[h>>2];sIa(ha,e,Aa,Aa)|0;Aa=f[Vw+4>>2]|0;do if(!Aa){Jx=Vw+8|0;Uw=f[Jx>>2]|0;if((f[Uw>>2]|0)==(Vw|0)){hC=Uw;break}else iC=Jx;do{Jx=f[iC>>2]|0;iC=Jx+8|0;Uw=f[iC>>2]|0}while((f[Uw>>2]|0)!=(Jx|0));hC=Uw}else{Uw=Aa;while(1){Jx=f[Uw>>2]|0;if(!Jx)break;else Uw=Jx}hC=Uw}while(0);if((hC|0)==(xa|0))break;else Vw=hC}}nKa(i,tIa(a,q,ha,1,0)|0);EGa(ha,f[Gq>>2]|0);jC=f[i>>2]&4095;if((jC|0)!=4){Yw=1798;break b}kC=f[Hq>>2]|0;lC=(kC|0)<3;if(lC)mC=Y(f[Jq>>2]|0,f[Iq>>2]|0)|0;else{Vw=f[Rq>>2]|0;Aa=0;Jx=1;while(1){Dx=Y(f[Vw+(Aa<<2)>>2]|0,Jx)|0;Aa=Aa+1|0;if((Aa|0)==(kC|0)){mC=Dx;break}else Jx=Dx}}if((mC|0)!=2){Yw=1804;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Kq>>0]=6;b[e>>0]=b[471030]|0;b[e+1>>0]=b[471031]|0;b[e+2>>0]=b[471032]|0;b[e+3>>0]=b[471033]|0;b[e+4>>0]=b[471034]|0;b[e+5>>0]=b[471035]|0;b[Lq>>0]=0;aHa(t,e,f[Mq>>2]|0)|0;if((b[Kq>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Oq>>0]=5;b[e>>0]=b[471037]|0;b[e+1>>0]=b[471038]|0;b[e+2>>0]=b[471039]|0;b[e+3>>0]=b[471040]|0;b[e+4>>0]=b[471041]|0;b[Pq>>0]=0;aHa(t,e,(f[Mq>>2]|0)+4|0)|0;if((b[Oq>>0]|0)<0)cYc(f[e>>2]|0);Jx=f[Qq>>2]|0;do if(Jx|0){Aa=Jx+12|0;Vw=f[Aa>>2]|0;f[Aa>>2]=Vw+-1;if((Vw|0)!=1)break;V$(i)}while(0);f[Qq>>2]=0;f[Mq>>2]=0;f[Mq+4>>2]=0;f[Mq+8>>2]=0;f[Mq+12>>2]=0;if((f[Hq>>2]|0)>0){Jx=f[Rq>>2]|0;Vw=0;do{f[Jx+(Vw<<2)>>2]=0;Vw=Vw+1|0}while((Vw|0)<(f[Hq>>2]|0))}Vw=f[Nq>>2]|0;if((Vw|0)!=(Sq|0))wL(Vw);break}case 3:{f[lr>>2]=0;f[mr>>2]=0;f[ia>>2]=nr;Vw=f[l>>2]|0;if((Vw|0)!=(xa|0)){Jx=Vw;while(1){Vw=Jx+16|0;f[h>>2]=Or;f[e>>2]=f[h>>2];sIa(ia,e,Vw,Vw)|0;Vw=f[Jx+4>>2]|0;do if(!Vw){Aa=Jx+8|0;Dx=f[Aa>>2]|0;if((f[Dx>>2]|0)==(Jx|0)){nC=Dx;break}else oC=Aa;do{Aa=f[oC>>2]|0;oC=Aa+8|0;Dx=f[oC>>2]|0}while((f[Dx>>2]|0)!=(Aa|0));nC=Dx}else{Uw=Vw;while(1){Dx=f[Uw>>2]|0;if(!Dx)break;else Uw=Dx}nC=Uw}while(0);if((nC|0)==(xa|0))break;else Jx=nC}}nKa(i,tIa(a,q,ia,1,0)|0);EGa(ia,f[nr>>2]|0);f[or>>2]=0;f[pr>>2]=0;f[ja>>2]=qr;Jx=f[l>>2]|0;if((Jx|0)!=(xa|0)){Vw=Jx;while(1){Jx=Vw+16|0;f[h>>2]=Nr;f[e>>2]=f[h>>2];sIa(ja,e,Jx,Jx)|0;Jx=f[Vw+4>>2]|0;do if(!Jx){Dx=Vw+8|0;Aa=f[Dx>>2]|0;if((f[Aa>>2]|0)==(Vw|0)){pC=Aa;break}else qC=Dx;do{Dx=f[qC>>2]|0;qC=Dx+8|0;Aa=f[qC>>2]|0}while((f[Aa>>2]|0)!=(Dx|0));pC=Aa}else{Uw=Jx;while(1){Aa=f[Uw>>2]|0;if(!Aa)break;else Uw=Aa}pC=Uw}while(0);if((pC|0)==(xa|0))break;else Vw=pC}}nKa(v,tIa(a,q,ja,2,0)|0);EGa(ja,f[qr>>2]|0);rC=f[i>>2]&4095;if((rC|0)!=4){Yw=1837;break b}sC=f[rr>>2]|0;tC=(sC|0)<3;if(tC)uC=Y(f[tr>>2]|0,f[sr>>2]|0)|0;else{Vw=f[Kr>>2]|0;Jx=0;Aa=1;while(1){Dx=Y(f[Vw+(Jx<<2)>>2]|0,Aa)|0;Jx=Jx+1|0;if((Jx|0)==(sC|0)){uC=Dx;break}else Aa=Dx}}if((uC|0)!=1){Yw=1843;break b}vC=f[v>>2]&4095;if((vC|0)!=4){Yw=1849;break b}wC=f[ur>>2]|0;xC=(wC|0)<3;if(xC)yC=Y(f[wr>>2]|0,f[vr>>2]|0)|0;else{Aa=f[Gr>>2]|0;Jx=0;Vw=1;while(1){Dx=Y(f[Aa+(Jx<<2)>>2]|0,Vw)|0;Jx=Jx+1|0;if((Jx|0)==(wC|0)){yC=Dx;break}else Vw=Dx}}if((yC|0)!=1){Yw=1855;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Vw=$Xc(16)|0;f[e>>2]=Vw;f[xr>>2]=-2147483632;f[yr>>2]=13;Pw=Vw;vx=435706;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+13>>0]=0;aHa(t,e,f[zr>>2]|0)|0;if((b[Ar>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Jx=$Xc(16)|0;f[e>>2]=Jx;f[Br>>2]=-2147483632;f[Cr>>2]=13;Pw=Jx;vx=435720;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Jx+13>>0]=0;aHa(t,e,f[Dr>>2]|0)|0;if((b[Er>>0]|0)<0)cYc(f[e>>2]|0);Vw=f[Fr>>2]|0;do if(Vw|0){Aa=Vw+12|0;Dx=f[Aa>>2]|0;f[Aa>>2]=Dx+-1;if((Dx|0)!=1)break;V$(v)}while(0);f[Fr>>2]=0;f[zr>>2]=0;f[zr+4>>2]=0;f[zr+8>>2]=0;f[zr+12>>2]=0;if((f[ur>>2]|0)>0){Vw=f[Gr>>2]|0;Jx=0;do{f[Vw+(Jx<<2)>>2]=0;Jx=Jx+1|0}while((Jx|0)<(f[ur>>2]|0))}Jx=f[Hr>>2]|0;if((Jx|0)!=(Ir|0))wL(Jx);Jx=f[Jr>>2]|0;do if(Jx|0){Vw=Jx+12|0;Dx=f[Vw>>2]|0;f[Vw>>2]=Dx+-1;if((Dx|0)!=1)break;V$(i)}while(0);f[Jr>>2]=0;f[Dr>>2]=0;f[Dr+4>>2]=0;f[Dr+8>>2]=0;f[Dr+12>>2]=0;if((f[rr>>2]|0)>0){Jx=f[Kr>>2]|0;Dx=0;do{f[Jx+(Dx<<2)>>2]=0;Dx=Dx+1|0}while((Dx|0)<(f[rr>>2]|0))}Dx=f[Lr>>2]|0;if((Dx|0)!=(Mr|0))wL(Dx);break}default:{Yw=1881;break b}}Dx=b[Ia>>0]|0;do if(((Dx<<24>>24<0?f[Pa>>2]|0:Dx&255)|0)==21){if(LYc(s,0,-1,381940,21)|0){Yw=1887;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Jx=$Xc(16)|0;f[e>>2]=Jx;f[Uq>>2]=-2147483632;f[Vq>>2]=13;Pw=Jx;vx=435950;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Jx+13>>0]=0;PIa(t,e,435964)|0;if((b[Wq>>0]|0)<0)cYc(f[e>>2]|0)}else Yw=1887;while(0);if((Yw|0)==1887){Yw=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Dx=$Xc(16)|0;f[e>>2]=Dx;f[ir>>2]=-2147483632;f[jr>>2]=13;Pw=Dx;vx=435950;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Dx+13>>0]=0;QIa(t,e,435972)|0;if((b[kr>>0]|0)<0)cYc(f[e>>2]|0)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Vw=$Xc(16)|0;f[i>>2]=Vw;f[Xq>>2]=-2147483632;f[Yq>>2]=13;Pw=Vw;vx=436039;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+13>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Zq>>2]|0,i,0);Dx=(f[e>>2]|0)==0;zIa(h);if((b[_q>>0]|0)<0)cYc(f[i>>2]|0);if(!Dx){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Dx=$Xc(16)|0;f[e>>2]=Dx;f[cr>>2]=-2147483632;f[dr>>2]=13;Pw=Dx;vx=436039;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Dx+13>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Vw=$Xc(16)|0;f[i>>2]=Vw;f[er>>2]=-2147483632;f[fr>>2]=13;Pw=Vw;vx=436039;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+13>>0]=0;elc(Sb);Dx=AIa(Tb,i)|0;b[h>>0]=(b[Dx+8>>0]|0?(f[Dx+20>>2]|0)==5:0)&1;cHa(t,e,h)|0;if((b[gr>>0]|0)<0)cYc(f[i>>2]|0);if((b[hr>>0]|0)<0)cYc(f[e>>2]|0)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[$q>>0]=6;b[e>>0]=b[428823]|0;b[e+1>>0]=b[428824]|0;b[e+2>>0]=b[428825]|0;b[e+3>>0]=b[428826]|0;b[e+4>>0]=b[428827]|0;b[e+5>>0]=b[428828]|0;b[ar>>0]=0;Dx=SOa(c,r,e,t)|0;if((b[$q>>0]|0)<0)cYc(f[e>>2]|0);Aa=IGa(o,r)|0;f[Aa>>2]=Dx;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,Dx,0);if((b[br>>0]|0)<0)cYc(f[e>>2]|0);break c}while(0);Dx=b[Ia>>0]|0;if(((Dx<<24>>24<0?f[Pa>>2]|0:Dx&255)|0)==6?(LYc(s,0,-1,428960,6)|0)==0:0)zC=0;else zC=(f[Da>>2]|0)+-1|0;f[Ri>>2]=0;f[Si>>2]=0;f[R>>2]=Ti;Dx=f[l>>2]|0;if((Dx|0)!=(xa|0)){Aa=Dx;while(1){Dx=Aa+16|0;f[h>>2]=$i;f[e>>2]=f[h>>2];sIa(R,e,Dx,Dx)|0;Dx=f[Aa+4>>2]|0;do if(!Dx){Ix=Aa+8|0;Bx=f[Ix>>2]|0;if((f[Bx>>2]|0)==(Aa|0)){AC=Bx;break}else BC=Ix;do{Ix=f[BC>>2]|0;BC=Ix+8|0;Bx=f[BC>>2]|0}while((f[Bx>>2]|0)!=(Ix|0));AC=Bx}else{Jx=Dx;while(1){Bx=f[Jx>>2]|0;if(!Bx)break;else Jx=Bx}AC=Jx}while(0);if((AC|0)==(xa|0))break;else Aa=AC}}Aa=(tIa(a,q,R,zC,0)|0)+48|0;Dx=f[(f[Aa>>2]|0)+4>>2]|0;EGa(R,f[Ti>>2]|0);f[i>>2]=Dx;mYc(e,r,0,KYc(r,58,-1)|0,r);Dx=qIa(k,e)|0;if((b[Ui>>0]|0)<0)cYc(f[e>>2]|0);do if((Dx|0)!=(ua|0)){if(f[Dx+28>>2]|0)break;Aa=f[i>>2]|0;Vw=Aa+4|0;if(Vw>>>0>=8){Yw=1043;break b}do if(Aa)if((Aa|0)>0){CC=((Aa>>>0)%3|0)+1|0;break}else{CC=((Vw>>>0)%3|0)+1|0;break}else CC=0;while(0);f[i>>2]=CC}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Vi>>0]=4;f[e>>2]=1936291937;b[Wi>>0]=0;aHa(t,e,i)|0;if((b[Vi>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Xi>>0]=6;b[e>>0]=b[428960]|0;b[e+1>>0]=b[428961]|0;b[e+2>>0]=b[428962]|0;b[e+3>>0]=b[428963]|0;b[e+4>>0]=b[428964]|0;b[e+5>>0]=b[428965]|0;b[Yi>>0]=0;Dx=SOa(c,r,e,t)|0;if((b[Xi>>0]|0)<0)cYc(f[e>>2]|0);Vw=IGa(o,r)|0;f[Vw>>2]=Dx;Vw=b[Ia>>0]|0;Aa=f[Pa>>2]|0;if(((Vw<<24>>24<0?Aa:Vw&255)|0)==6){Bx=(LYc(s,0,-1,428960,6)|0)==0;DC=Bx;EC=b[Ia>>0]|0;FC=f[Pa>>2]|0}else{DC=0;EC=Vw;FC=Aa}Aa=DC&1;do if(((EC<<24>>24<0?FC:EC&255)|0)==6){if(LYc(s,0,-1,428960,6)|0){Yw=1058;break}GC=f[Da>>2]|0}else Yw=1058;while(0);if((Yw|0)==1058){Yw=0;GC=(f[Da>>2]|0)+-1|0}if((Aa|0)<(GC|0)){Vw=Aa;do{vIa(e,f[(f[Fa>>2]|0)+4+(Vw<<2)>>2]|0);if((CHa(o,e)|0)==(qa|0)){Yw=1062;break b}wIa(a,o,c,e,Dx,Vw-Aa|0);if((b[Zi>>0]|0)<0)cYc(f[e>>2]|0);Vw=Vw+1|0}while((Vw|0)<(GC|0))}break c}while(0);vIa(i,f[(f[Fa>>2]|0)+4>>2]|0);Vw=f[(f[Fa>>2]|0)+4>>2]|0;mYc(e,Vw,0,KYc(Vw,58,-1)|0,Vw);Vw=qIa(k,e)|0;if((b[jh>>0]|0)<0)cYc(f[e>>2]|0);if((Vw|0)==(ua|0))HC=2;else HC=f[Vw+28>>2]|0;Vw=b[Ia>>0]|0;j:do if(((Vw<<24>>24<0?f[Pa>>2]|0:Vw&255)|0)==7){if(LYc(s,0,-1,378168,7)|0){Yw=885;break};f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;Aa=$Xc(16)|0;f[v>>2]=Aa;f[kh>>2]=-2147483632;f[lh>>2]=12;Pw=Aa;vx=378176;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Aa+12>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[mh>>2]|0,v,0);Dx=(f[e>>2]|0)==0;zIa(h);if((b[nh>>0]|0)<0)cYc(f[v>>2]|0);if(Dx){Yw=872;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Dx=$Xc(16)|0;f[e>>2]=Dx;f[oh>>2]=-2147483632;f[ph>>2]=12;Pw=Dx;vx=378176;Qw=Pw+12|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Dx+12>>0]=0;elc(Sb);Aa=AIa(Tb,e)|0;if((b[qh>>0]|0)<0)cYc(f[e>>2]|0);switch(HC|0){case 0:{Bx=(f[Aa+20>>2]|0)==1?f[Aa+8>>2]|0:530552;if((f[Bx+24>>2]|0)!=2){Yw=879;break b}Ix=f[Bx+32>>2]|0;Bx=Ix+8|0;if(!((f[Bx>>2]|0)==1&(f[Bx+4>>2]|0)==0)){Yw=879;break b}Bx=Ix+16|0;if((f[Bx>>2]|0)==2&(f[Bx+4>>2]|0)==0){Yw=886;break j}else{Yw=879;break b}break}case 1:{Bx=(f[Aa+20>>2]|0)==1?f[Aa+8>>2]|0:530552;if((f[Bx+24>>2]|0)!=2){Yw=883;break b}Aa=f[Bx+32>>2]|0;Bx=Aa+8|0;if(!((f[Bx>>2]|0)==2&(f[Bx+4>>2]|0)==0)){Yw=883;break b}Bx=Aa+16|0;if((f[Bx>>2]|0)==3&(f[Bx+4>>2]|0)==0)break j;else{Yw=883;break b}break}default:{Yw=884;break b}}}else Yw=885;while(0);if((Yw|0)==885?(Yw=0,(HC|0)==0):0)Yw=886;if((Yw|0)==886){Yw=0;f[rh>>2]=0;f[sh>>2]=0;f[e>>2]=th;Pw=uh;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[vh>>0]=5;b[h>>0]=b[450562]|0;b[h+1>>0]=b[450563]|0;b[h+2>>0]=b[450564]|0;b[h+3>>0]=b[450565]|0;b[h+4>>0]=b[450566]|0;b[wh>>0]=0;Vw=$Xc(16)|0;f[Vw>>2]=Vw+8;f[Vw+4>>2]=4;Bx=bYc(32)|0;f[Vw>>2]=Bx;f[v>>2]=0;f[xh>>2]=Vw;Vw=Bx;f[Vw>>2]=0;f[Vw+4>>2]=0;Vw=Bx+8|0;f[Vw>>2]=2;f[Vw+4>>2]=0;Vw=Bx+16|0;f[Vw>>2]=3;f[Vw+4>>2]=0;Vw=Bx+24|0;f[Vw>>2]=1;f[Vw+4>>2]=0;$Ga(e,h,v)|0;RGa(v);if((b[vh>>0]|0)<0)cYc(f[h>>2]|0);AN(h,r,378120);if((CHa(o,h)|0)!=(qa|0)){Yw=889;break b}f[mw>>2]=0;b[yh>>0]=7;b[v>>0]=b[428903]|0;b[v+1>>0]=b[428904]|0;b[v+2>>0]=b[428905]|0;b[v+3>>0]=b[428906]|0;b[v+4>>0]=b[428907]|0;b[v+5>>0]=b[428908]|0;b[v+6>>0]=b[428909]|0;b[zh>>0]=0;Vw=SOa(c,h,v,e)|0;if((b[yh>>0]|0)<0)cYc(f[v>>2]|0);Bx=IGa(o,h)|0;f[Bx>>2]=Vw;wIa(a,o,c,i,Vw,0);lYc(v,h);f[Ah>>2]=0;if((b[Bh>>0]|0)<0){b[f[i>>2]>>0]=0;f[Ch>>2]=0}else{b[i>>0]=0;b[Bh>>0]=0}sYc(i,0);f[i>>2]=f[v>>2];f[i+4>>2]=f[v+4>>2];f[i+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[Dh>>2]=f[Ah>>2];if((b[Eh>>0]|0)<0)cYc(f[h>>2]|0);if((b[Gh>>0]|0)<0)cYc(f[Fh>>2]|0);if((b[Ih>>0]|0)<0)cYc(f[Hh>>2]|0);hx(Jh);QGa(e,f[th>>2]|0)}f[nw>>2]=0;b[Kh>>0]=7;b[e>>0]=b[396507]|0;b[e+1>>0]=b[396508]|0;b[e+2>>0]=b[396509]|0;b[e+3>>0]=b[396510]|0;b[e+4>>0]=b[396511]|0;b[e+5>>0]=b[396512]|0;b[e+6>>0]=b[396513]|0;b[Lh>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[Kh>>0]|0)<0)cYc(f[e>>2]|0);Bx=IGa(o,r)|0;f[Bx>>2]=Vw;wIa(a,o,c,i,Vw,0);Vw=IGa(k,r)|0;f[Vw>>2]=3;if((b[Bh>>0]|0)<0)cYc(f[i>>2]|0);break c}while(0);Vw=0;Bx=f[Da>>2]|0;while(1){if((Vw|0)>=(Bx|0)){Yw=576;break}vIa(e,f[(f[Fa>>2]|0)+4+(Vw<<2)>>2]|0);Aa=(CHa(l,e)|0)==(xa|0);if((b[Wd>>0]|0)<0)cYc(f[e>>2]|0);Bx=f[Da>>2]|0;if(!Aa)break;else Vw=Vw+1|0}if((Yw|0)==576){Yw=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[oe>>0]=9;Pw=e;vx=437378;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[pe>>0]=0;JIa(t,e,437393)|0;if((b[oe>>0]|0)<0)cYc(f[e>>2]|0);f[fw>>2]=0;b[qe>>0]=7;b[e>>0]=b[428856]|0;b[e+1>>0]=b[428857]|0;b[e+2>>0]=b[428858]|0;b[e+3>>0]=b[428859]|0;b[e+4>>0]=b[428860]|0;b[e+5>>0]=b[428861]|0;b[e+6>>0]=b[428862]|0;b[re>>0]=0;Vw=SOa(c,r,e,t)|0;if((b[qe>>0]|0)<0)cYc(f[e>>2]|0);Aa=IGa(o,r)|0;f[Aa>>2]=Vw;if((f[Da>>2]|0)>0)IC=0;else break c;while(1){vIa(e,f[(f[Fa>>2]|0)+4+(IC<<2)>>2]|0);if((CHa(o,e)|0)==(qa|0)){Yw=582;break b}wIa(a,o,c,e,Vw,IC);if((b[se>>0]|0)<0)cYc(f[e>>2]|0);IC=IC+1|0;if((IC|0)>=(f[Da>>2]|0))break c}}if((Bx|0)!=2){Yw=542;break b}f[Xd>>2]=0;f[Yd>>2]=0;f[H>>2]=Zd;Vw=f[l>>2]|0;if((Vw|0)!=(xa|0)){Aa=Vw;while(1){Vw=Aa+16|0;f[h>>2]=ne;f[e>>2]=f[h>>2];sIa(H,e,Vw,Vw)|0;Vw=f[Aa+4>>2]|0;if(!Vw){Ix=Aa+8|0;Cx=f[Ix>>2]|0;if((f[Cx>>2]|0)==(Aa|0))JC=Cx;else{Cx=Ix;do{Ix=f[Cx>>2]|0;Cx=Ix+8|0;Sw=f[Cx>>2]|0}while((f[Sw>>2]|0)!=(Ix|0));JC=Sw}}else{Cx=Vw;while(1){Sw=f[Cx>>2]|0;if(!Sw)break;else Cx=Sw}JC=Cx}if((JC|0)==(xa|0))break;else Aa=JC}}nKa(i,tIa(a,q,H,-1,0)|0);EGa(H,f[Zd>>2]|0);if((f[i>>2]&4095|0)!=5){Yw=551;break b}Aa=f[_d>>2]|0;if((Aa|0)<3)KC=Y(f[ae>>2]|0,f[$d>>2]|0)|0;else{Bx=f[ie>>2]|0;Vw=0;Sw=1;while(1){Ix=Y(f[Bx+(Vw<<2)>>2]|0,Sw)|0;Vw=Vw+1|0;if((Vw|0)==(Aa|0)){KC=Ix;break}else Sw=Ix}}if((KC|0)==1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[be>>0]=5;b[e>>0]=b[431960]|0;b[e+1>>0]=b[431961]|0;b[e+2>>0]=b[431962]|0;b[e+3>>0]=b[431963]|0;b[e+4>>0]=b[431964]|0;b[ce>>0]=0;OGa(t,e,f[de>>2]|0)|0;if((b[be>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ee>>0]=5;b[e>>0]=b[439430]|0;b[e+1>>0]=b[439431]|0;b[e+2>>0]=b[439432]|0;b[e+3>>0]=b[439433]|0;b[e+4>>0]=b[439434]|0;b[fe>>0]=0;Sw=SOa(c,r,e,t)|0;if((b[ee>>0]|0)<0)cYc(f[e>>2]|0);LC=Sw}else{Zw(Yb,1,i);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[le>>0]=5;b[e>>0]=b[396723]|0;b[e+1>>0]=b[396724]|0;b[e+2>>0]=b[396725]|0;b[e+3>>0]=b[396726]|0;b[e+4>>0]=b[396727]|0;b[me>>0]=0;Sw=SOa(c,r,e,t)|0;if((b[le>>0]|0)<0)cYc(f[e>>2]|0);LC=Sw}Sw=IGa(o,r)|0;f[Sw>>2]=LC;vIa(e,f[(f[Fa>>2]|0)+4>>2]|0);wIa(a,o,c,e,LC,0);if((b[ge>>0]|0)<0)cYc(f[e>>2]|0);Sw=f[he>>2]|0;do if(Sw|0){Aa=Sw+12|0;Vw=f[Aa>>2]|0;f[Aa>>2]=Vw+-1;if((Vw|0)!=1)break;V$(i)}while(0);f[he>>2]=0;f[de>>2]=0;f[de+4>>2]=0;f[de+8>>2]=0;f[de+12>>2]=0;if((f[_d>>2]|0)>0){Sw=f[ie>>2]|0;Vw=0;do{f[Sw+(Vw<<2)>>2]=0;Vw=Vw+1|0}while((Vw|0)<(f[_d>>2]|0))}Vw=f[je>>2]|0;if((Vw|0)!=(ke|0))wL(Vw);break c}while(0);lYc(v,f[(f[Fa>>2]|0)+4>>2]|0);f[w>>2]=0;Vw=b[Ia>>0]|0;Sw=f[Pa>>2]|0;if(((Vw<<24>>24<0?Sw:Vw&255)|0)==14)if(!(LYc(s,0,-1,377648,14)|0))Yw=67;else{MC=b[Ia>>0]|0;NC=f[Pa>>2]|0;Yw=65}else{MC=Vw;NC=Sw;Yw=65}if((Yw|0)==65){Yw=0;if(((MC<<24>>24<0?NC:MC&255)|0)==3?(LYc(s,0,-1,390079,3)|0)==0:0)Yw=67;else{OC=0;PC=0}}if((Yw|0)==67){Yw=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Qa>>0]=6;b[h>>0]=b[377641]|0;b[h+1>>0]=b[377642]|0;b[h+2>>0]=b[377643]|0;b[h+3>>0]=b[377644]|0;b[h+4>>0]=b[377645]|0;b[h+5>>0]=b[377646]|0;b[Ra>>0]=0;rIa(e,ta,r,h);Sw=f[e>>2]|0;Vw=f[Sa>>2]|0;f[w>>2]=Vw;Aa=Vw;if((Sw|0)==(Aa|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Vw=$Xc(32)|0;f[h>>2]=Vw;f[Ta>>2]=-2147483616;f[Ua>>2]=21;Pw=Vw;vx=377663;Qw=Pw+21|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Vw+21>>0]=0;rIa(e,ta,r,h);if(Sw|0){cYc(Sw);f[w>>2]=0}Bx=f[e>>2]|0;Ix=f[Va>>2]|0;f[w>>2]=Ix;f[Wa>>2]=0;f[Va>>2]=0;f[e>>2]=0;cYc(Vw);OC=Bx;PC=Ix}else{OC=Sw;PC=Aa}}Ix=b[Ia>>0]|0;Bx=f[Pa>>2]|0;do if(((Ix<<24>>24<0?Bx:Ix&255)|0)==14){if(LYc(s,0,-1,377648,14)|0){QC=b[Ia>>0]|0;RC=f[Pa>>2]|0;Yw=189;break}if((f[Da>>2]|0)!=3){Yw=75;break b}f[Xa>>2]=0;f[Ya>>2]=0;f[y>>2]=Za;Tw=f[l>>2]|0;if((Tw|0)!=(xa|0)){Rw=Tw;while(1){Tw=Rw+16|0;f[h>>2]=Pb;f[e>>2]=f[h>>2];sIa(y,e,Tw,Tw)|0;Tw=f[Rw+4>>2]|0;if(!Tw){xA=Rw+8|0;SC=f[xA>>2]|0;if((f[SC>>2]|0)==(Rw|0))TC=SC;else{SC=xA;do{xA=f[SC>>2]|0;SC=xA+8|0;UC=f[SC>>2]|0}while((f[UC>>2]|0)!=(xA|0));TC=UC}}else{SC=Tw;while(1){Cx=f[SC>>2]|0;if(!Cx)break;else SC=Cx}TC=SC}if((TC|0)==(xa|0))break;else Rw=TC}}Rw=tIa(a,q,y,1,0)|0;f[e>>2]=0;f[_a>>2]=0;f[$a>>2]=0;uIa(Rw,e);if((f[Rw+160>>2]|0)!=3){Yw=84;break b}if(((f[_a>>2]|0)-(f[e>>2]|0)|0)!=4){Yw=86;break b}nKa(h,Rw);if((f[h>>2]&4095|0)!=4){Yw=88;break b}Rw=f[ab>>2]|0;Tw=f[bb>>2]|0;if((Tw|0)<3)VC=Y(f[db>>2]|0,f[cb>>2]|0)|0;else{Cx=f[gb>>2]|0;UC=0;xA=1;while(1){WC=Y(f[Cx+(UC<<2)>>2]|0,xA)|0;UC=UC+1|0;if((UC|0)==(Tw|0)){VC=WC;break}else xA=WC}}xA=$Xc(16)|0;Tw=xA+8|0;f[xA>>2]=Tw;f[xA+4>>2]=VC;if(VC>>>0>1){UC=bYc(VC>>>0>536870911?-1:VC<<3)|0;f[xA>>2]=UC;XC=UC}else XC=Tw;f[x>>2]=0;f[eb>>2]=xA;if((VC|0)>0){xA=Rw;Tw=0;while(1){UC=f[xA>>2]|0;Cx=XC+(Tw<<3)|0;f[Cx>>2]=UC;f[Cx+4>>2]=((UC|0)<0)<<31>>31;Tw=Tw+1|0;if((Tw|0)==(VC|0))break;else xA=xA+4|0}}xA=f[fb>>2]|0;do if(xA|0){Tw=xA+12|0;Rw=f[Tw>>2]|0;f[Tw>>2]=Rw+-1;if((Rw|0)!=1)break;V$(h)}while(0);f[fb>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[bb>>2]|0)>0){xA=f[gb>>2]|0;Rw=0;do{f[xA+(Rw<<2)>>2]=0;Rw=Rw+1|0}while((Rw|0)<(f[bb>>2]|0))}Rw=f[hb>>2]|0;if((Rw|0)!=(ib|0))wL(Rw);Rw=f[e>>2]|0;if(Rw|0){xA=f[_a>>2]|0;if((xA|0)!=(Rw|0))f[_a>>2]=xA+(~((xA+-4-Rw|0)>>>2)<<2);cYc(Rw)}EGa(y,f[Za>>2]|0);YC=f[x>>2]|0;switch(YC|0){case 0:{ZC=(f[jb>>2]|0)+4|0;break}case 3:{ZC=(f[eb>>2]|0)+4|0;break}case 2:{ZC=(f[eb>>2]|0)+4|0;break}default:{Yw=113;break b}}if((f[ZC>>2]|0)!=2){Yw=115;break b}b[kb>>0]=10;Pw=e;vx=390194;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[lb>>0]=0;Rw=MGa(x,0)|0;f[h>>2]=Rw;aHa(t,e,h)|0;if((b[kb>>0]|0)<0)cYc(f[e>>2]|0);b[mb>>0]=10;Pw=e;vx=390205;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[nb>>0]=0;Rw=MGa(x,1)|0;f[h>>2]=Rw;aHa(t,e,h)|0;if((b[mb>>0]|0)<0)cYc(f[e>>2]|0);f[z>>2]=1124007936;Pw=ob;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[qb>>2]=pb;f[sb>>2]=rb;f[rb>>2]=0;f[tb>>2]=0;f[ub>>2]=0;f[vb>>2]=0;f[A>>2]=wb;Rw=f[l>>2]|0;if((Rw|0)!=(xa|0)){xA=Rw;while(1){Rw=xA+16|0;f[h>>2]=Ob;f[e>>2]=f[h>>2];sIa(A,e,Rw,Rw)|0;Rw=f[xA+4>>2]|0;do if(!Rw){Tw=xA+8|0;UC=f[Tw>>2]|0;if((f[UC>>2]|0)==(xA|0)){_C=UC;break}else $C=Tw;do{Tw=f[$C>>2]|0;$C=Tw+8|0;UC=f[$C>>2]|0}while((f[UC>>2]|0)!=(Tw|0));_C=UC}else{Dx=Rw;while(1){UC=f[Dx>>2]|0;if(!UC)break;else Dx=UC}_C=Dx}while(0);if((_C|0)==(xa|0))break;else xA=_C}}xA=tIa(a,q,A,2,0)|0;f[e>>2]=0;f[xb>>2]=0;f[yb>>2]=0;uIa(xA,e);Rw=f[e>>2]|0;SC=((f[xb>>2]|0)-Rw|0)==16;UC=Rw;if(SC){Rw=UC+8|0;Tw=UC+12|0;Cx=f[Tw>>2]|0;f[Tw>>2]=f[Rw>>2];Tw=UC+4|0;UC=f[Tw>>2]|0;f[Tw>>2]=Cx;f[Rw>>2]=UC}T$(z,e,5);nKa(h,xA);xA=f[zb>>2]|0;if((xA|0)<3)aD=Y(f[Bb>>2]|0,f[Ab>>2]|0)|0;else{UC=f[Gb>>2]|0;Rw=0;Cx=1;while(1){Tw=Y(f[UC+(Rw<<2)>>2]|0,Cx)|0;Rw=Rw+1|0;if((Rw|0)==(xA|0)){aD=Tw;break}else Cx=Tw}}Cx=f[ob>>2]|0;if((Cx|0)<3)bD=Y(f[Cb>>2]|0,f[pb>>2]|0)|0;else{xA=f[qb>>2]|0;Rw=0;UC=1;while(1){Tw=Y(f[xA+(Rw<<2)>>2]|0,UC)|0;Rw=Rw+1|0;if((Rw|0)==(Cx|0)){bD=Tw;break}else UC=Tw}}if((aD|0)!=(bD|0)){Yw=138;break b}UC=f[Db>>2]|0;Cx=f[Eb>>2]|0;do if(SC){Rw=f[e>>2]|0;xA=f[Rw>>2]|0;Tw=f[Rw+4>>2]|0;WC=f[Rw+8>>2]|0;cD=f[Rw+12>>2]|0;Rw=Y(Y(Y(Tw,xA)|0,WC)|0,cD)|0;if((xA|0)<=0)break;dD=Y(Y(WC,Tw)|0,cD)|0;eD=(Tw|0)>0;fD=(WC|0)>0;gD=(cD|0)>0;hD=0;do{do if(eD){iD=Y(dD,hD)|0;if(fD)jD=0;else break;do{kD=Y(jD,WC)|0;lD=jD+iD|0;if(gD){mD=0;do{nD=(Y(mD+kD|0,cD)|0)+iD|0;oD=Y(mD,cD)|0;pD=0;do{qD=nD+pD|0;rD=lD+(Y(pD+oD|0,Tw)|0)|0;if((qD|0)>=(Rw|0)){Yw=153;break b}if((rD|0)>=(Rw|0)){Yw=154;break b}n[UC+(qD<<2)>>2]=+(f[Cx+(rD<<2)>>2]|0);pD=pD+1|0}while((pD|0)<(cD|0));mD=mD+1|0}while((mD|0)<(WC|0))}jD=jD+1|0}while((jD|0)<(Tw|0))}while(0);hD=hD+1|0}while((hD|0)<(xA|0))}else{if((aD|0)>0)sD=0;else break;do{n[UC+(sD<<2)>>2]=+(f[Cx+(sD<<2)>>2]|0);sD=sD+1|0}while((sD|0)!=(aD|0))}while(0);Cx=f[Fb>>2]|0;do if(Cx|0){UC=Cx+12|0;SC=f[UC>>2]|0;f[UC>>2]=SC+-1;if((SC|0)!=1)break;V$(h)}while(0);f[Fb>>2]=0;f[Eb>>2]=0;f[Eb+4>>2]=0;f[Eb+8>>2]=0;f[Eb+12>>2]=0;if((f[zb>>2]|0)>0){Cx=f[Gb>>2]|0;SC=0;do{f[Cx+(SC<<2)>>2]=0;SC=SC+1|0}while((SC|0)<(f[zb>>2]|0))}SC=f[Hb>>2]|0;if((SC|0)!=(Ib|0))wL(SC);SC=f[e>>2]|0;if(SC|0){Cx=f[xb>>2]|0;if((Cx|0)!=(SC|0))f[xb>>2]=Cx+(~((Cx+-4-SC|0)>>>2)<<2);cYc(SC)}EGa(A,f[wb>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Jb>>0]=5;b[e>>0]=b[390333]|0;b[e+1>>0]=b[390334]|0;b[e+2>>0]=b[390335]|0;b[e+3>>0]=b[390336]|0;b[e+4>>0]=b[390337]|0;b[Kb>>0]=0;OGa(t,e,f[Db>>2]|0)|0;if((b[Jb>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Lb>>0]=5;b[e>>0]=b[390339]|0;b[e+1>>0]=b[390340]|0;b[e+2>>0]=b[390341]|0;b[e+3>>0]=b[390342]|0;b[e+4>>0]=b[390343]|0;b[Mb>>0]=0;SC=f[Db>>2]|0;do if(!(f[z>>2]&16384)){Cx=f[qb>>2]|0;if((f[Cx>>2]|0)==1){Yw=172;break}UC=f[f[sb>>2]>>2]|0;if((f[Cx+4>>2]|0)==1){tD=SC+(UC<<1)|0;break}else{Cx=f[Cb>>2]|0;xA=2/(Cx|0)|0;tD=SC+(Y(xA,UC)|0)+(2-(Y(xA,Cx)|0)<<2)|0;break}}else Yw=172;while(0);if((Yw|0)==172){Yw=0;tD=SC+8|0}OGa(t,e,tD)|0;if((b[Lb>>0]|0)<0)cYc(f[e>>2]|0);if(((f[w>>2]|0)-OC|0)!=16){Yw=179;break b}Cx=OC;NWa(q,f[(f[va>>2]|0)+4+(f[Cx+12>>2]<<2)>>2]|0);SQ(e,j,Cx,Cx);oYc(r,f[Ga>>2]|0)|0;oYc(s,f[ya>>2]|0)|0;Cx=f[Nb>>2]|0;do if(Cx|0){xA=Cx+12|0;UC=f[xA>>2]|0;f[xA>>2]=UC+-1;if((UC|0)!=1)break;V$(z)}while(0);f[Nb>>2]=0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;if((f[ob>>2]|0)>0){Cx=f[qb>>2]|0;SC=0;do{f[Cx+(SC<<2)>>2]=0;SC=SC+1|0}while((SC|0)<(f[ob>>2]|0))}SC=f[sb>>2]|0;if((SC|0)!=(rb|0))wL(SC);RGa(x);Yw=329}else{QC=Ix;RC=Bx;Yw=189}while(0);if((Yw|0)==189){Yw=0;if(((QC<<24>>24<0?RC:QC&255)|0)==3?(LYc(s,0,-1,390079,3)|0)==0:0){f[Ad>>2]=0;f[Bd>>2]=0;f[B>>2]=Cd;Bx=f[l>>2]|0;if((Bx|0)!=(xa|0)){Ix=Bx;while(1){Bx=Ix+16|0;f[h>>2]=Vd;f[e>>2]=f[h>>2];sIa(B,e,Bx,Bx)|0;Bx=f[Ix+4>>2]|0;if(!Bx){Aa=Ix+8|0;Sw=f[Aa>>2]|0;if((f[Sw>>2]|0)==(Ix|0))uD=Sw;else{Sw=Aa;do{Aa=f[Sw>>2]|0;Sw=Aa+8|0;Vw=f[Sw>>2]|0}while((f[Vw>>2]|0)!=(Aa|0));uD=Vw}}else{Sw=Bx;while(1){Vw=f[Sw>>2]|0;if(!Vw)break;else Sw=Vw}uD=Sw}if((uD|0)==(xa|0))break;else Ix=uD}}nKa(i,tIa(a,q,B,1,0)|0);EGa(B,f[Cd>>2]|0);Ix=f[i>>2]|0;if((Ix&4095|0)!=4){Yw=199;break b}Bx=f[Dd>>2]|0;if((Bx|0)<3)vD=Y(f[Fd>>2]|0,f[Ed>>2]|0)|0;else{Vw=f[Hd>>2]|0;Aa=0;SC=1;while(1){Cx=Y(f[Vw+(Aa<<2)>>2]|0,SC)|0;Aa=Aa+1|0;if((Aa|0)==(Bx|0)){vD=Cx;break}else SC=Cx}}if((vD|0)==8){SC=f[Gd>>2]|0;do if(!(Ix&16384)){Bx=f[Hd>>2]|0;do if((f[Bx>>2]|0)!=1){Aa=f[f[Id>>2]>>2]|0;if((f[Bx+4>>2]|0)==1){wD=SC+(Aa<<1)|0;break}else{Vw=f[Fd>>2]|0;Cx=2/(Vw|0)|0;wD=SC+(Y(Cx,Aa)|0)+(2-(Y(Cx,Vw)|0)<<2)|0;break}}else wD=SC+8|0;while(0);Bx=f[Hd>>2]|0;if((f[Bx>>2]|0)==1){xD=wD;Yw=213;break}Sw=f[f[Id>>2]>>2]|0;if((f[Bx+4>>2]|0)==1){yD=wD;zD=SC+(Sw*6|0)|0;break}else{Bx=f[Fd>>2]|0;Vw=6/(Bx|0)|0;yD=wD;zD=SC+(Y(Vw,Sw)|0)+(6-(Y(Vw,Bx)|0)<<2)|0;break}}else{xD=SC+8|0;Yw=213}while(0);if((Yw|0)==213){Yw=0;yD=xD;zD=SC+24|0}Ix=f[yD>>2]|0;f[yD>>2]=f[zD>>2];f[zD>>2]=Ix;do if(!(f[i>>2]&16384)){Ix=f[Hd>>2]|0;do if((f[Ix>>2]|0)!=1){Bx=f[f[Id>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){AD=SC+(Bx*3|0)|0;break}else{Vw=f[Fd>>2]|0;Sw=3/(Vw|0)|0;AD=SC+(Y(Sw,Bx)|0)+(3-(Y(Sw,Vw)|0)<<2)|0;break}}else AD=SC+12|0;while(0);Ix=f[Hd>>2]|0;if((f[Ix>>2]|0)==1){BD=AD;Yw=225;break}Vw=f[f[Id>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){CD=AD;DD=SC+(Vw*7|0)|0;break}else{Ix=f[Fd>>2]|0;Sw=7/(Ix|0)|0;CD=AD;DD=SC+(Y(Sw,Vw)|0)+(7-(Y(Sw,Ix)|0)<<2)|0;break}}else{BD=SC+12|0;Yw=225}while(0);if((Yw|0)==225){Yw=0;CD=BD;DD=SC+28|0}Ix=f[CD>>2]|0;f[CD>>2]=f[DD>>2];f[DD>>2]=Ix;do if(!(f[i>>2]&16384)){Ix=f[Hd>>2]|0;do if((f[Ix>>2]|0)!=1){Sw=f[f[Id>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){ED=SC+(Sw<<2)|0;break}else{Vw=f[Fd>>2]|0;Bx=4/(Vw|0)|0;ED=SC+(Y(Bx,Sw)|0)+(4-(Y(Bx,Vw)|0)<<2)|0;break}}else ED=SC+16|0;while(0);Ix=f[Hd>>2]|0;if((f[Ix>>2]|0)==1){FD=ED;Yw=237;break}Vw=f[f[Id>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){GD=ED;HD=SC+(Vw*6|0)|0;break}else{Ix=f[Fd>>2]|0;Bx=6/(Ix|0)|0;GD=ED;HD=SC+(Y(Bx,Vw)|0)+(6-(Y(Bx,Ix)|0)<<2)|0;break}}else{FD=SC+16|0;Yw=237}while(0);if((Yw|0)==237){Yw=0;GD=FD;HD=SC+24|0}Ix=f[GD>>2]|0;f[GD>>2]=f[HD>>2];f[HD>>2]=Ix;do if(!(f[i>>2]&16384)){Ix=f[Hd>>2]|0;do if((f[Ix>>2]|0)!=1){Bx=f[f[Id>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){ID=SC+(Bx*5|0)|0;break}else{Vw=f[Fd>>2]|0;Sw=5/(Vw|0)|0;ID=SC+(Y(Sw,Bx)|0)+(5-(Y(Sw,Vw)|0)<<2)|0;break}}else ID=SC+20|0;while(0);Ix=f[Hd>>2]|0;if((f[Ix>>2]|0)==1){JD=ID;Yw=249;break}Vw=f[f[Id>>2]>>2]|0;if((f[Ix+4>>2]|0)==1){KD=ID;LD=SC+(Vw*7|0)|0;break}else{Ix=f[Fd>>2]|0;Sw=7/(Ix|0)|0;KD=ID;LD=SC+(Y(Sw,Vw)|0)+(7-(Y(Sw,Ix)|0)<<2)|0;break}}else{JD=SC+20|0;Yw=249}while(0);if((Yw|0)==249){Yw=0;KD=JD;LD=SC+28|0}Ix=f[KD>>2]|0;f[KD>>2]=f[LD>>2];f[LD>>2]=Ix}Ix=OC;Sw=PC;Vw=f[Dd>>2]|0;do if((Ix|0)==(PC|0))Yw=286;else{if((Vw|0)<3)MD=Y(f[Fd>>2]|0,f[Ed>>2]|0)|0;else{Bx=f[Hd>>2]|0;Cx=0;Aa=1;while(1){UC=Y(f[Bx+(Cx<<2)>>2]|0,Aa)|0;Cx=Cx+1|0;if((Cx|0)==(Vw|0)){MD=UC;break}else Aa=UC}}if((MD|0)!=8){Yw=286;break}Aa=(f[i>>2]&16384|0)==0;Cx=f[Gd>>2]|0;do if(Aa){Bx=f[Hd>>2]|0;do if((f[Bx>>2]|0)!=1){UC=f[f[Id>>2]>>2]|0;if((f[Bx+4>>2]|0)==1){ND=Cx+(UC<<2)|0;break}else{xA=f[Fd>>2]|0;hD=4/(xA|0)|0;ND=Cx+(Y(hD,UC)|0)+(4-(Y(hD,xA)|0)<<2)|0;break}}else ND=Cx+16|0;while(0);Bx=f[ND>>2]|0;xA=f[Hd>>2]|0;if((f[xA>>2]|0)==1){OD=Bx;Yw=268;break}hD=f[f[Id>>2]>>2]|0;if((f[xA+4>>2]|0)==1){PD=Cx+(hD*5|0)|0;QD=Bx;break}else{xA=f[Fd>>2]|0;UC=5/(xA|0)|0;PD=Cx+(Y(UC,hD)|0)+(5-(Y(UC,xA)|0)<<2)|0;QD=Bx;break}}else{OD=f[Cx+16>>2]|0;Yw=268}while(0);if((Yw|0)==268){Yw=0;PD=Cx+20|0;QD=OD}if((QD|0)!=(f[PD>>2]|0)){Yw=286;break}do if(Aa){Bx=f[Hd>>2]|0;do if((f[Bx>>2]|0)!=1){xA=f[f[Id>>2]>>2]|0;if((f[Bx+4>>2]|0)==1){RD=Cx+(xA*6|0)|0;break}else{UC=f[Fd>>2]|0;hD=6/(UC|0)|0;RD=Cx+(Y(hD,xA)|0)+(6-(Y(hD,UC)|0)<<2)|0;break}}else RD=Cx+24|0;while(0);Bx=f[RD>>2]|0;UC=f[Hd>>2]|0;if((f[UC>>2]|0)==1){SD=Bx;Yw=281;break}hD=f[f[Id>>2]>>2]|0;if((f[UC+4>>2]|0)==1){TD=Cx+(hD*7|0)|0;UD=Bx;break}else{UC=f[Fd>>2]|0;xA=7/(UC|0)|0;TD=Cx+(Y(xA,hD)|0)+(7-(Y(xA,UC)|0)<<2)|0;UD=Bx;break}}else{SD=f[Cx+24>>2]|0;Yw=281}while(0);if((Yw|0)==281){Yw=0;TD=Cx+28|0;UD=SD}if((UD|0)!=(f[TD>>2]|0)){Yw=286;break}if((Sw-OC|0)!=16){Yw=302;break b};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Rd>>0]=5;b[e>>0]=b[390333]|0;b[e+1>>0]=b[390334]|0;b[e+2>>0]=b[390335]|0;b[e+3>>0]=b[390336]|0;b[e+4>>0]=b[390337]|0;b[Sd>>0]=0;do if(Aa){Bx=f[Hd>>2]|0;if((f[Bx>>2]|0)==1){Yw=305;break}UC=f[f[Id>>2]>>2]|0;if((f[Bx+4>>2]|0)==1){VD=Cx+(UC<<2)|0;break}else{Bx=f[Fd>>2]|0;xA=4/(Bx|0)|0;VD=Cx+(Y(xA,UC)|0)+(4-(Y(xA,Bx)|0)<<2)|0;break}}else Yw=305;while(0);if((Yw|0)==305){Yw=0;VD=Cx+16|0}aHa(t,e,VD)|0;if((b[Rd>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Td>>0]=5;b[e>>0]=b[390339]|0;b[e+1>>0]=b[390340]|0;b[e+2>>0]=b[390341]|0;b[e+3>>0]=b[390342]|0;b[e+4>>0]=b[390343]|0;b[Ud>>0]=0;Aa=f[Gd>>2]|0;do if(!(f[i>>2]&16384)){Bx=f[Hd>>2]|0;if((f[Bx>>2]|0)==1){Yw=313;break}xA=f[f[Id>>2]>>2]|0;if((f[Bx+4>>2]|0)==1){WD=Aa+(xA*6|0)|0;break}else{Bx=f[Fd>>2]|0;UC=6/(Bx|0)|0;WD=Aa+(Y(UC,xA)|0)+(6-(Y(UC,Bx)|0)<<2)|0;break}}else Yw=313;while(0);if((Yw|0)==313){Yw=0;WD=Aa+24|0}aHa(t,e,WD)|0;if((b[Td>>0]|0)<0)cYc(f[e>>2]|0);NWa(q,f[(f[va>>2]|0)+4+(f[Ix+12>>2]<<2)>>2]|0);SQ(e,j,Ix,Ix);oYc(r,f[Ga>>2]|0)|0;oYc(s,f[ya>>2]|0)|0;XD=0}while(0);if((Yw|0)==286){Yw=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Jd>>0]=8;Ix=e;f[Ix>>2]=1684300144;f[Ix+4>>2]=1936158313;b[Kd>>0]=0;Ix=f[Gd>>2]|0;if((Vw|0)<3)YD=Y(f[Fd>>2]|0,f[Ed>>2]|0)|0;else{Sw=f[Hd>>2]|0;SC=0;Cx=1;while(1){Bx=Y(f[Sw+(SC<<2)>>2]|0,Cx)|0;SC=SC+1|0;if((SC|0)==(Vw|0)){YD=Bx;break}else Cx=Bx}}Cx=$Xc(16)|0;Vw=Cx+8|0;f[Cx>>2]=Vw;f[Cx+4>>2]=YD;if(YD>>>0>1){SC=bYc(YD>>>0>536870911?-1:YD<<3)|0;f[Cx>>2]=SC;ZD=SC}else ZD=Vw;f[h>>2]=0;f[Ld>>2]=Cx;if((YD|0)>0){Cx=Ix;Vw=0;while(1){SC=f[Cx>>2]|0;Sw=ZD+(Vw<<3)|0;f[Sw>>2]=SC;f[Sw+4>>2]=((SC|0)<0)<<31>>31;Vw=Vw+1|0;if((Vw|0)==(YD|0))break;else Cx=Cx+4|0}}$Ga(t,e,h)|0;RGa(h);if((b[Jd>>0]|0)<0)cYc(f[e>>2]|0);f[ew>>2]=0;b[Md>>0]=7;b[e>>0]=b[396729]|0;b[e+1>>0]=b[396730]|0;b[e+2>>0]=b[396731]|0;b[e+3>>0]=b[396732]|0;b[e+4>>0]=b[396733]|0;b[e+5>>0]=b[396734]|0;b[e+6>>0]=b[396735]|0;b[Nd>>0]=0;Cx=SOa(c,r,e,t)|0;if((b[Md>>0]|0)<0)cYc(f[e>>2]|0);Vw=IGa(o,r)|0;f[Vw>>2]=Cx;vIa(e,v);wIa(a,o,c,e,Cx,0);if((b[Od>>0]|0)<0)cYc(f[e>>2]|0);XD=10}Cx=f[Pd>>2]|0;do if(Cx|0){Vw=Cx+12|0;Ix=f[Vw>>2]|0;f[Vw>>2]=Ix+-1;if((Ix|0)!=1)break;V$(i)}while(0);f[Pd>>2]=0;f[Gd>>2]=0;f[Gd+4>>2]=0;f[Gd+8>>2]=0;f[Gd+12>>2]=0;if((f[Dd>>2]|0)>0){Cx=f[Hd>>2]|0;Ix=0;do{f[Cx+(Ix<<2)>>2]=0;Ix=Ix+1|0}while((Ix|0)<(f[Dd>>2]|0))}Ix=f[Id>>2]|0;if((Ix|0)!=(Qd|0))wL(Ix);if(XD)_D=OC;else Yw=329}else Yw=329}if((Yw|0)==329){Yw=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Ix=$Xc(32)|0;f[i>>2]=Ix;f[Qb>>2]=-2147483616;f[Rb>>2]=19;Pw=Ix;vx=447527;Qw=Pw+19|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Ix+19>>0]=0;elc(Sb);xIa(h,Tb);yIa(e,f[Ub>>2]|0,i,0);Cx=(f[e>>2]|0)==0;zIa(h);if(Cx)$D=0;else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Cx=$Xc(32)|0;f[e>>2]=Cx;f[wd>>2]=-2147483616;f[xd>>2]=19;Pw=Cx;vx=447527;Qw=Pw+19|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Cx+19>>0]=0;elc(Sb);Ix=AIa(Tb,e)|0;Vw=b[Ix+8>>0]|0?(f[Ix+20>>2]|0)==5:0;if((b[yd>>0]|0)<0)cYc(f[e>>2]|0);$D=Vw}if((b[Vb>>0]|0)<0)cYc(f[i>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Wb>>0]=9;Pw=e;vx=445999;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Xb>>0]=0;b[h>>0]=0;cHa(t,e,h)|0;if((b[Wb>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,1);f[dw>>2]=0;b[Zb>>0]=7;b[h>>0]=b[377936]|0;b[h+1>>0]=b[377937]|0;b[h+2>>0]=b[377938]|0;b[h+3>>0]=b[377939]|0;b[h+4>>0]=b[377940]|0;b[h+5>>0]=b[377941]|0;b[h+6>>0]=b[377942]|0;b[_b>>0]=0;rIa(e,ta,r,h);Cx=OC;if(OC|0){Vw=f[w>>2]|0;if((Vw|0)!=(Cx|0)){Ix=Vw;do{Ix=Ix+-16|0;f[w>>2]=Ix;if((b[Ix+11>>0]|0)<0)cYc(f[Ix>>2]|0)}while((Ix|0)!=(Cx|0))}cYc(OC);f[w>>2]=0}Cx=f[e>>2]|0;Ix=f[$b>>2]|0;f[w>>2]=Ix;do if((Ix-Cx|0)==16){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ac>>0]=9;Pw=e;vx=445999;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[bc>>0]=0;b[h>>0]=1;cHa(t,e,h)|0;if((b[ac>>0]|0)<0)cYc(f[e>>2]|0);hS(Yb,2);Aa=Cx;Vw=f[Aa+12>>2]|0;SC=f[(f[va>>2]|0)+4+(Vw<<2)>>2]|0;f[cc>>2]=0;f[dc>>2]=0;f[C>>2]=ec;Sw=f[l>>2]|0;if((Sw|0)!=(xa|0)){Bx=Sw;while(1){Sw=Bx+16|0;f[h>>2]=fc;f[e>>2]=f[h>>2];sIa(C,e,Sw,Sw)|0;Sw=f[Bx+4>>2]|0;do if(!Sw){UC=Bx+8|0;xA=f[UC>>2]|0;if((f[xA>>2]|0)==(Bx|0)){aE=xA;break}else bE=UC;do{UC=f[bE>>2]|0;bE=UC+8|0;xA=f[bE>>2]|0}while((f[xA>>2]|0)!=(UC|0));aE=xA}else{xA=Sw;while(1){UC=f[xA>>2]|0;if(!UC)break;else xA=UC}aE=xA}while(0);if((aE|0)==(xa|0))break;else Bx=aE}}Bx=tIa(a,SC,C,-1,0)|0;BIa(Bx,(f[Yb>>2]|0)+56|0);EGa(C,f[ec>>2]|0);CIa(ta,Vw,0);SQ(e,j,Aa,Aa);if($D){Bx=f[Yb>>2]|0;Sw=f[Bx+60>>2]|0;if((Sw|0)<3)cE=Y(f[Bx+68>>2]|0,f[Bx+64>>2]|0)|0;else{UC=f[Bx+96>>2]|0;hD=0;Tw=1;while(1){WC=Y(f[UC+(hD<<2)>>2]|0,Tw)|0;hD=hD+1|0;if((hD|0)==(Sw|0)){cE=WC;break}else Tw=WC}}Tw=f[Bx+72>>2]|0;if(cE&3|0){Yw=360;break b}if((cE|0)>0)dE=0;else{eE=1;break}do{Sw=Tw+(dE<<2)|0;hD=Tw+((dE|1)<<2)|0;UC=f[Sw>>2]|0;f[Sw>>2]=f[hD>>2];f[hD>>2]=UC;dE=dE+2|0}while((dE|0)<(cE|0));eE=1}else eE=0}else eE=$D;while(0);f[x>>2]=-1;f[gc>>2]=0;f[hc>>2]=0;f[D>>2]=ic;Ix=f[l>>2]|0;if((Ix|0)!=(xa|0)){Tw=Ix;while(1){Ix=Tw+16|0;f[h>>2]=vd;f[e>>2]=f[h>>2];sIa(D,e,Ix,Ix)|0;Ix=f[Tw+4>>2]|0;do if(!Ix){Bx=Tw+8|0;UC=f[Bx>>2]|0;if((f[UC>>2]|0)==(Tw|0)){fE=UC;break}else gE=Bx;do{Bx=f[gE>>2]|0;gE=Bx+8|0;UC=f[gE>>2]|0}while((f[UC>>2]|0)!=(Bx|0));fE=UC}else{UC=Ix;while(1){Bx=f[UC>>2]|0;if(!Bx)break;else UC=Bx}fE=UC}while(0);if((fE|0)==(xa|0))break;else Tw=fE}}Tw=tIa(a,q,D,-1,x)|0;EGa(D,f[ic>>2]|0);lYc(z,f[(f[Fa>>2]|0)+4+(f[x>>2]<<2)>>2]|0);Ix=DIa(m,z)|0;do if((Ix|0)!=(Ha|0)){Bx=Ix+28|0;hD=f[Yb>>2]|0;if((hD|0)!=(Bx|0)){Sw=Ix+64|0;Aa=f[Sw>>2]|0;if(Aa|0){Vw=Aa+12|0;f[Vw>>2]=(f[Vw>>2]|0)+1}Vw=hD+36|0;Aa=f[Vw>>2]|0;do if(Aa|0){SC=Aa+12|0;WC=f[SC>>2]|0;f[SC>>2]=WC+-1;if((WC|0)!=1)break;V$(hD)}while(0);f[Vw>>2]=0;Aa=hD+16|0;WC=hD+4|0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[WC>>2]|0)>0){SC=f[hD+40>>2]|0;cD=0;do{f[SC+(cD<<2)>>2]=0;cD=cD+1|0;hE=f[WC>>2]|0}while((cD|0)<(hE|0));f[hD>>2]=f[Bx>>2];if((hE|0)<3)Yw=481;else Yw=483}else{f[hD>>2]=f[Bx>>2];Yw=481}do if((Yw|0)==481){Yw=0;cD=f[Ix+32>>2]|0;if((cD|0)>=3){Yw=483;break}f[WC>>2]=cD;f[hD+8>>2]=f[Ix+36>>2];f[hD+12>>2]=f[Ix+40>>2];cD=f[Ix+72>>2]|0;SC=f[hD+44>>2]|0;f[SC>>2]=f[cD>>2];f[SC+4>>2]=f[cD+4>>2]}while(0);if((Yw|0)==483){Yw=0;U$(hD,Bx)}f[Aa>>2]=f[Ix+44>>2];f[hD+20>>2]=f[Ix+48>>2];f[hD+24>>2]=f[Ix+52>>2];f[hD+28>>2]=f[Ix+56>>2];f[hD+32>>2]=f[Ix+60>>2];f[Vw>>2]=f[Sw>>2]}}else{EIa(Tw,f[Yb>>2]|0);ELa(Tw);WC=f[(f[Yb>>2]|0)+40>>2]|0;cD=f[WC>>2]|0;SC=WC+4|0;Rw=f[SC>>2]|0;gD=f[WC+8>>2]|0;fD=f[WC+12>>2]|0;dD=b[Ia>>0]|0;do if(((dD<<24>>24<0?f[Pa>>2]|0:dD&255)|0)==21){if(LYc(s,0,-1,377663,21)|0)break;if(eE){Yw=373;break b}eD=f[WC>>2]|0;Dx=f[Yb>>2]|0;f[h>>2]=1124007936;Pw=jc;Qw=Pw+36|0;do{f[Pw>>2]=0;Pw=Pw+4|0}while((Pw|0)<(Qw|0));f[lc>>2]=kc;f[nc>>2]=mc;f[mc>>2]=0;f[oc>>2]=0;UC=pc;f[UC>>2]=0;f[UC+4>>2]=0;f[e>>2]=33619968;f[qc>>2]=h;jR(Dx,e);UC=f[rc>>2]|0;iD=f[Yb>>2]|0;mD=f[iD+16>>2]|0;do if((eD|0)>0){lD=Y(fD,gD)|0;kD=(lD|0)>0;if((Rw|0)>0)iE=0;else break;do{Jx=Y(iE,Rw)|0;if(kD){pD=0;do{oD=Y(lD,pD+Jx|0)|0;nD=Y(lD,(Y(pD,eD)|0)+iE|0)|0;Uw=0;do{f[mD+(Uw+nD<<2)>>2]=f[UC+(Uw+oD<<2)>>2];Uw=Uw+1|0}while((Uw|0)!=(lD|0));pD=pD+1|0}while((pD|0)!=(Rw|0))}iE=iE+1|0}while((iE|0)!=(eD|0))}while(0);UC=Y(eD,Rw)|0;f[WC>>2]=UC;f[SC>>2]=1;UC=f[iD+44>>2]|0;f[UC>>2]=f[UC+4>>2];UC=f[sc>>2]|0;do if(UC|0){mD=UC+12|0;Dx=f[mD>>2]|0;f[mD>>2]=Dx+-1;if((Dx|0)!=1)break;V$(h)}while(0);f[sc>>2]=0;f[rc>>2]=0;f[rc+4>>2]=0;f[rc+8>>2]=0;f[rc+12>>2]=0;if((f[jc>>2]|0)>0){UC=f[lc>>2]|0;iD=0;do{f[UC+(iD<<2)>>2]=0;iD=iD+1|0}while((iD|0)<(f[jc>>2]|0))}iD=f[nc>>2]|0;if((iD|0)!=(mc|0))wL(iD)}while(0);do if(eE){SC=Y(Y(gD,Rw)|0,fD)|0;if((cD|0)<=0)break;WC=(SC|0)!=0;dD=SC<<2;Sw=0-dD|0;Vw=0;do{hD=f[Yb>>2]|0;Aa=(f[hD+16>>2]|0)+(Y(f[f[hD+44>>2]>>2]|0,Vw)|0)|0;f[h>>2]=1124007941;f[tc>>2]=2;f[uc>>2]=1;f[vc>>2]=SC;f[wc>>2]=Aa;f[xc>>2]=Aa;f[yc>>2]=0;f[yc+4>>2]=0;f[yc+8>>2]=0;f[yc+12>>2]=0;f[zc>>2]=uc;f[Bc>>2]=Ac;f[Cc>>2]=0;f[Ac>>2]=0;if(WC&(Aa|0)==0){Yw=394;break b}f[Ac>>2]=dD;f[Cc>>2]=4;hD=Aa+dD|0;f[Dc>>2]=hD;f[yc>>2]=hD+Sw+dD;R$(h);hD=f[Yb>>2]|0;Aa=(f[hD+16>>2]|0)+(Y(f[f[hD+44>>2]>>2]|0,Vw|1)|0)|0;f[i>>2]=1124007941;f[Ec>>2]=2;f[Fc>>2]=1;f[Gc>>2]=SC;f[Hc>>2]=Aa;f[Ic>>2]=Aa;f[Jc>>2]=0;f[Jc+4>>2]=0;f[Jc+8>>2]=0;f[Jc+12>>2]=0;f[Kc>>2]=Fc;f[Mc>>2]=Lc;f[Nc>>2]=0;f[Lc>>2]=0;if(WC&(Aa|0)==0){Yw=396;break b}f[Lc>>2]=dD;f[Nc>>2]=4;hD=Aa+dD|0;f[Oc>>2]=hD;f[Jc>>2]=hD+Sw+dD;R$(i);f[E>>2]=h;hD=f[tc>>2]|0;if((hD|0)>0)jE=f[(f[Bc>>2]|0)+(hD+-1<<2)>>2]|0;else jE=0;f[Pc>>2]=jE;f[Qc>>2]=0;f[Rc>>2]=0;f[Sc>>2]=0;if(f[h>>2]&16384|0){Aa=f[wc>>2]|0;f[Rc>>2]=Aa;if((hD|0)<3)kE=Y(f[vc>>2]|0,f[uc>>2]|0)|0;else{Bx=f[zc>>2]|0;iD=0;UC=1;while(1){eD=Y(f[Bx+(iD<<2)>>2]|0,UC)|0;iD=iD+1|0;if((iD|0)==(hD|0)){kE=eD;break}else UC=eD}}UC=Aa+(Y(kE,jE)|0)|0;f[Sc>>2]=UC}EL(E,0,0);f[F>>2]=h;UC=f[tc>>2]|0;if((UC|0)>0)lE=f[(f[Bc>>2]|0)+(UC+-1<<2)>>2]|0;else lE=0;f[Tc>>2]=lE;f[Uc>>2]=0;f[Vc>>2]=0;f[Wc>>2]=0;if(f[h>>2]&16384|0){hD=f[wc>>2]|0;f[Vc>>2]=hD;if((UC|0)<3)mE=Y(f[vc>>2]|0,f[uc>>2]|0)|0;else{iD=f[zc>>2]|0;Bx=0;eD=1;while(1){Dx=Y(f[iD+(Bx<<2)>>2]|0,eD)|0;Bx=Bx+1|0;if((Bx|0)==(UC|0)){mE=Dx;break}else eD=Dx}}eD=hD+(Y(mE,lE)|0)|0;f[Wc>>2]=eD}EL(F,0,0);eD=f[tc>>2]|0;if((eD|0)<3)nE=Y(f[vc>>2]|0,f[uc>>2]|0)|0;else{UC=f[zc>>2]|0;Bx=0;iD=1;while(1){Aa=Y(f[UC+(Bx<<2)>>2]|0,iD)|0;Bx=Bx+1|0;if((Bx|0)==(eD|0)){nE=Aa;break}else iD=Aa}}do if(!((nE|0)==0|(f[F>>2]|0)==0)){iD=Y(f[Tc>>2]|0,nE)|0;eD=(f[Uc>>2]|0)+iD|0;f[Uc>>2]=eD;if(eD>>>0>=(f[Vc>>2]|0)>>>0?(f[Wc>>2]|0)>>>0>eD>>>0:0)break;f[Uc>>2]=eD+(0-iD);DL(F,nE,1)}while(0);f[G>>2]=i;iD=f[Ec>>2]|0;if((iD|0)>0)oE=f[(f[Mc>>2]|0)+(iD+-1<<2)>>2]|0;else oE=0;f[Xc>>2]=oE;f[Yc>>2]=0;f[Zc>>2]=0;f[_c>>2]=0;if(f[i>>2]&16384|0){eD=f[Hc>>2]|0;f[Zc>>2]=eD;if((iD|0)<3)pE=Y(f[Gc>>2]|0,f[Fc>>2]|0)|0;else{Bx=f[Kc>>2]|0;UC=0;hD=1;while(1){Aa=Y(f[Bx+(UC<<2)>>2]|0,hD)|0;UC=UC+1|0;if((UC|0)==(iD|0)){pE=Aa;break}else hD=Aa}}hD=eD+(Y(pE,oE)|0)|0;f[_c>>2]=hD}EL(G,0,0);while(1){hD=f[E>>2]|0;if((hD|0)==(f[F>>2]|0)){iD=f[Qc>>2]|0;if((iD|0)==(f[Uc>>2]|0))break;else{qE=iD;rE=iD}}else{iD=f[Qc>>2]|0;qE=iD;rE=iD}iD=f[Yc>>2]|0;UC=f[qE>>2]|0;f[qE>>2]=f[iD>>2];f[iD>>2]=UC;do if(hD|0){UC=f[Pc>>2]|0;iD=rE+UC|0;f[Qc>>2]=iD;if(iD>>>0<(f[Sc>>2]|0)>>>0)break;f[Qc>>2]=iD+(0-UC);DL(E,1,1)}while(0);if(!(f[G>>2]|0))continue;hD=f[Xc>>2]|0;UC=(f[Yc>>2]|0)+hD|0;f[Yc>>2]=UC;if(UC>>>0<(f[_c>>2]|0)>>>0)continue;f[Yc>>2]=UC+(0-hD);DL(G,1,1)}eD=f[$c>>2]|0;do if(eD|0){hD=eD+12|0;UC=f[hD>>2]|0;f[hD>>2]=UC+-1;if((UC|0)!=1)break;V$(i)}while(0);f[$c>>2]=0;f[Hc>>2]=0;f[Hc+4>>2]=0;f[Hc+8>>2]=0;f[Hc+12>>2]=0;if((f[Ec>>2]|0)>0){eD=f[Kc>>2]|0;UC=0;do{f[eD+(UC<<2)>>2]=0;UC=UC+1|0}while((UC|0)<(f[Ec>>2]|0))}UC=f[Mc>>2]|0;if((UC|0)!=(Lc|0))wL(UC);UC=f[ad>>2]|0;do if(UC|0){eD=UC+12|0;hD=f[eD>>2]|0;f[eD>>2]=hD+-1;if((hD|0)!=1)break;V$(h)}while(0);f[ad>>2]=0;f[wc>>2]=0;f[wc+4>>2]=0;f[wc+8>>2]=0;f[wc+12>>2]=0;if((f[tc>>2]|0)>0){UC=f[zc>>2]|0;hD=0;do{f[UC+(hD<<2)>>2]=0;hD=hD+1|0}while((hD|0)<(f[tc>>2]|0))}hD=f[Bc>>2]|0;if((hD|0)!=(Ac|0))wL(hD);Vw=Vw+2|0}while((Vw|0)<(cD|0))}while(0);cD=f[Yb>>2]|0;f[h>>2]=z;FIa(e,m,z,1163509,h,i);fD=f[e>>2]|0;Rw=fD+28|0;if((Rw|0)==(cD|0))break;gD=cD+36|0;Vw=f[gD>>2]|0;if(Vw|0){dD=Vw+12|0;f[dD>>2]=(f[dD>>2]|0)+1}dD=fD+64|0;Vw=f[dD>>2]|0;do if(Vw|0){Sw=Vw+12|0;WC=f[Sw>>2]|0;f[Sw>>2]=WC+-1;if((WC|0)!=1)break;V$(Rw)}while(0);f[dD>>2]=0;Vw=fD+44|0;WC=fD+32|0;f[Vw>>2]=0;f[Vw+4>>2]=0;f[Vw+8>>2]=0;f[Vw+12>>2]=0;if((f[WC>>2]|0)>0){Sw=f[fD+68>>2]|0;SC=0;do{f[Sw+(SC<<2)>>2]=0;SC=SC+1|0;sE=f[WC>>2]|0}while((SC|0)<(sE|0));f[Rw>>2]=f[cD>>2];if((sE|0)<3)Yw=466;else Yw=468}else{f[Rw>>2]=f[cD>>2];Yw=466}do if((Yw|0)==466){Yw=0;SC=f[cD+4>>2]|0;if((SC|0)>=3){Yw=468;break}f[WC>>2]=SC;f[fD+36>>2]=f[cD+8>>2];f[fD+40>>2]=f[cD+12>>2];SC=f[cD+44>>2]|0;Sw=f[fD+72>>2]|0;f[Sw>>2]=f[SC>>2];f[Sw+4>>2]=f[SC+4>>2]}while(0);if((Yw|0)==468){Yw=0;U$(Rw,cD)}f[Vw>>2]=f[cD+16>>2];f[fD+48>>2]=f[cD+20>>2];f[fD+52>>2]=f[cD+24>>2];f[fD+56>>2]=f[cD+28>>2];f[fD+60>>2]=f[cD+32>>2];f[dD>>2]=f[gD>>2]}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[bd>>0]=8;Tw=e;f[Tw>>2]=1852990827;f[Tw+4>>2]=1751084133;b[cd>>0]=0;aHa(t,e,(f[(f[Yb>>2]|0)+40>>2]|0)+8|0)|0;if((b[bd>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[dd>>0]=8;Tw=e;f[Tw>>2]=1852990827;f[Tw+4>>2]=2002742373;b[ed>>0]=0;aHa(t,e,(f[(f[Yb>>2]|0)+40>>2]|0)+12|0)|0;if((b[dd>>0]|0)<0)cYc(f[e>>2]|0);b[fd>>0]=10;Pw=e;vx=453228;Qw=Pw+10|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[gd>>0]=0;aHa(t,e,f[(f[Yb>>2]|0)+40>>2]|0)|0;if((b[fd>>0]|0)<0)cYc(f[e>>2]|0);GIa(t,q);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[hd>>0]=5;b[e>>0]=b[390339]|0;b[e+1>>0]=b[390340]|0;b[e+2>>0]=b[390341]|0;b[e+3>>0]=b[390342]|0;b[e+4>>0]=b[390343]|0;b[id>>0]=0;if(!(HIa(t,e)|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[jd>>0]=5;b[h>>0]=b[390333]|0;b[h+1>>0]=b[390334]|0;b[h+2>>0]=b[390335]|0;b[h+3>>0]=b[390336]|0;b[h+4>>0]=b[390337]|0;b[kd>>0]=0;Tw=(HIa(t,h)|0)==0;if((b[jd>>0]|0)<0)cYc(f[h>>2]|0);tE=Tw}else tE=0;if((b[hd>>0]|0)<0)cYc(f[e>>2]|0);if(tE)IIa(t,q);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Tw=$Xc(16)|0;f[h>>2]=Tw;f[ld>>2]=-2147483632;f[md>>2]=14;Pw=Tw;vx=377983;Qw=Pw+14|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Tw+14>>0]=0;rIa(e,ta,r,h);Ix=Cx;if(Cx|0){WC=f[w>>2]|0;if((WC|0)!=(Ix|0)){SC=WC;do{SC=SC+-16|0;f[w>>2]=SC;if((b[SC+11>>0]|0)<0)cYc(f[SC>>2]|0)}while((SC|0)!=(Ix|0))}cYc(Cx);f[w>>2]=0}Ix=f[e>>2]|0;SC=f[nd>>2]|0;f[w>>2]=SC;f[od>>2]=0;f[nd>>2]=0;f[e>>2]=0;cYc(Tw);WC=Ix;if((WC|0)!=(SC|0)){if((SC-Ix|0)!=16){Yw=507;break b}CIa(ta,f[WC+12>>2]|0,0);SQ(e,j,WC,WC)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;WC=$Xc(16)|0;f[e>>2]=WC;f[pd>>2]=-2147483632;f[qd>>2]=11;Pw=WC;vx=429163;Qw=Pw+11|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[WC+11>>0]=0;Tw=SOa(c,r,e,t)|0;if((b[rd>>0]|0)<0)cYc(f[e>>2]|0);Cx=IGa(o,r)|0;f[Cx>>2]=Tw;vIa(e,v);wIa(a,o,c,e,Tw,0);if((b[sd>>0]|0)<0)cYc(f[e>>2]|0);mYc(e,r,0,KYc(r,58,-1)|0,r);Tw=qIa(k,e)|0;if((b[td>>0]|0)<0)cYc(f[e>>2]|0);if(!((Tw|0)!=(ua|0)?(f[Tw+28>>2]|0)!=2:0)){Tw=IGa(k,r)|0;f[Tw>>2]=0}if((b[ud>>0]|0)<0)cYc(f[z>>2]|0);_D=Ix}Tw=_D;if(_D|0){Cx=f[w>>2]|0;if((Cx|0)!=(Tw|0)){SC=Cx;do{SC=SC+-16|0;f[w>>2]=SC;if((b[SC+11>>0]|0)<0)cYc(f[SC>>2]|0)}while((SC|0)!=(Tw|0))}cYc(_D)}if((b[zd>>0]|0)<0)cYc(f[v>>2]|0)}while(0);if((b[$v>>0]|0)<0)cYc(f[_v>>2]|0);if((b[bw>>0]|0)<0)cYc(f[aw>>2]|0);hx(cw);QGa(t,f[Ca>>2]|0);if((b[Ia>>0]|0)<0)cYc(f[s>>2]|0);if((b[Ak>>0]|0)<0)cYc(f[r>>2]|0);bWa(q);Ow=Ow+1|0;if((Ow|0)>=(sa|0)){Ja=sj;Yw=36;break}}switch(Yw|0){case 36:{lQa(c,Ja);Ka=f[qa>>2]|0;EGa(o,Ka);La=f[Ha>>2]|0;SIa(m,La);Ma=f[xa>>2]|0;EGa(l,Ma);Na=f[ua>>2]|0;EGa(k,Na);Oa=f[ra>>2]|0;RQ(j,Oa);u=d;return}case 48:{d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=24;Pw=d;vx=377509;Qw=Pw+24|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[d+24>>0]=0;vM(-215,e,377534,377558,654);break}case 75:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=d;vx=377685;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[d+23>>0]=0;vM(-215,e,390369,377558,760);break}case 84:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=$Xc(48)|0;f[h>>2]=d;f[h+8>>2]=-2147483600;f[h+4>>2]=38;Pw=d;vx=377709;Qw=Pw+38|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[d+38>>0]=0;vM(-215,h,377748,377558,307);break}case 86:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=9;Pw=h;vx=377758;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[h+9>>0]=0;vM(-215,h,377748,377558,308);break}case 88:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=$Xc(32)|0;f[i>>2]=d;f[i+8>>2]=-2147483616;f[i+4>>2]=25;Pw=d;vx=377768;Qw=Pw+25|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[d+25>>0]=0;vM(-215,i,377748,377558,311);break}case 113:{f[g>>2]=YC;DM(e,455363,g);vM(-3,e,470867,455383,297);break}case 115:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=20;Pw=g;vx=377794;Qw=Pw+20|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[g+20>>0]=0;vM(-215,e,390369,377558,763);break}case 138:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;g=$Xc(32)|0;f[i>>2]=g;f[i+8>>2]=-2147483616;f[i+4>>2]=28;Pw=g;vx=377815;Qw=Pw+28|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[g+28>>0]=0;vM(-215,i,377844,377558,113);break}case 153:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;g=$Xc(16)|0;f[i>>2]=g;f[i+8>>2]=-2147483632;f[i+4>>2]=13;Pw=g;vx=377856;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[g+13>>0]=0;vM(-215,i,377844,377558,129);break}case 154:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;g=$Xc(16)|0;f[i>>2]=g;f[i+8>>2]=-2147483632;f[i+4>>2]=13;Pw=g;vx=377870;Qw=Pw+13|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[g+13>>0]=0;vM(-215,i,377844,377558,130);break}case 179:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=i;vx=377884;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+23>>0]=0;vM(-215,e,390369,377558,774);break}case 199:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=27;Pw=i;vx=377908;Qw=Pw+27|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+27>>0]=0;vM(-215,e,390369,377558,783);break}case 302:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=i;vx=377884;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+23>>0]=0;vM(-215,e,390369,377558,814);break}case 360:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=19;Pw=i;vx=377944;Qw=Pw+19|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+19>>0]=0;vM(-215,e,390369,377558,852);break}case 373:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=18;Pw=i;vx=377964;Qw=Pw+18|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+18>>0]=0;vM(-215,e,390369,377558,876);break}case 394:{i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=28;Pw=i;vx=470314;Qw=Pw+28|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+28>>0]=0;vM(-215,e,470343,470347,548);break}case 396:{i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=28;Pw=i;vx=470314;Qw=Pw+28|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+28>>0]=0;vM(-215,e,470343,470347,548);break}case 507:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=i;vx=377884;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+23>>0]=0;vM(-215,e,390369,377558,927);break}case 542:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(48)|0;f[e>>2]=i;f[e+8>>2]=-2147483600;f[e+4>>2]=37;Pw=i;vx=377998;Qw=Pw+37|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+37>>0]=0;vM(-215,e,390369,377558,950);break}case 551:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=25;Pw=i;vx=378036;Qw=Pw+25|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+25>>0]=0;vM(-215,e,390369,377558,955);break}case 582:{SGa(h,378062,e);vM(-2,h,390369,377558,983);break}case 593:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=9;Pw=e;vx=378086;Qw=Pw+9|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[e+9>>0]=0;vM(-215,e,390369,377558,996);break}case 602:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=25;Pw=i;vx=378036;Qw=Pw+25|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+25>>0]=0;vM(-215,e,390369,377558,999);break}case 631:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=i;vx=378096;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+23>>0]=0;vM(-215,e,390369,377558,1020);break}case 666:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=19;Pw=i;vx=377944;Qw=Pw+19|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+19>>0]=0;vM(-215,e,390369,377558,1050);break}case 711:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=$Xc(32)|0;f[e>>2]=i;f[e+8>>2]=-2147483616;f[e+4>>2]=30;Pw=i;vx=385966;Qw=Pw+30|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+30>>0]=0;vM(-215,e,390369,377558,1071);break}case 805:{f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;i=$Xc(48)|0;f[w>>2]=i;f[w+8>>2]=-2147483600;f[w+4>>2]=41;Pw=i;vx=378126;Qw=Pw+41|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[i+41>>0]=0;vM(-215,w,390369,377558,1105);break}case 872:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=35;Pw=w;vx=378189;Qw=Pw+35|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+35>>0]=0;vM(-215,e,390369,377558,1142);break}case 879:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=33;Pw=w;vx=378225;Qw=Pw+33|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+33>>0]=0;vM(-213,e,390369,377558,1147);break}case 883:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=33;Pw=w;vx=378225;Qw=Pw+33|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+33>>0]=0;vM(-213,e,390369,377558,1152);break}case 884:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=33;Pw=w;vx=378225;Qw=Pw+33|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+33>>0]=0;vM(-213,e,390369,377558,1155);break}case 889:{f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;w=$Xc(48)|0;f[v>>2]=w;f[v+8>>2]=-2147483600;f[v+4>>2]=41;Pw=w;vx=378126;Qw=Pw+41|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+41>>0]=0;vM(-215,v,390369,377558,1164);break}case 918:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(32)|0;f[e>>2]=w;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=w;vx=378259;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+23>>0]=0;vM(-215,e,390369,377558,1178);break}case 936:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=44;Pw=w;vx=378283;Qw=Pw+44|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+44>>0]=0;vM(-212,e,390369,377558,1200);break}case 945:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=44;Pw=w;vx=378283;Qw=Pw+44|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+44>>0]=0;vM(-212,e,390369,377558,1217);break}case 1043:{w=$Xc(32)|0;f[e>>2]=w;f[e+8>>2]=-2147483616;f[e+4>>2]=20;Pw=w;vx=378350;Qw=Pw+20|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+20>>0]=0;vM(-215,e,378371,377558,43);break}case 1062:{SGa(h,378062,e);vM(-2,h,390369,377558,1281);break}case 1110:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(32)|0;f[e>>2]=w;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=w;vx=378096;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+23>>0]=0;vM(-215,e,390369,377558,1326);break}case 1119:{w=$Xc(32)|0;f[e>>2]=w;f[e+8>>2]=-2147483616;f[e+4>>2]=20;Pw=w;vx=378350;Qw=Pw+20|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+20>>0]=0;vM(-215,e,378371,377558,43);break}case 1135:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(32)|0;f[e>>2]=w;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=w;vx=377685;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+23>>0]=0;vM(-215,e,390369,377558,1344);break}case 1156:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(16)|0;f[e>>2]=w;f[e+8>>2]=-2147483632;f[e+4>>2]=15;Pw=w;vx=378404;Qw=Pw+15|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+15>>0]=0;vM(-215,e,390369,377558,1347);break}case 1163:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(16)|0;f[e>>2]=w;f[e+8>>2]=-2147483632;f[e+4>>2]=14;Pw=w;vx=378420;Qw=Pw+14|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[w+14>>0]=0;vM(-215,e,390369,377558,1347);break}case 1165:{kV(Xy,4,80556);break}case 1167:{kV(Yy,4,80584);break}case 1228:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Yy=$Xc(48)|0;f[e>>2]=Yy;f[e+8>>2]=-2147483600;f[e+4>>2]=37;Pw=Yy;vx=377998;Qw=Pw+37|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Yy+37>>0]=0;vM(-215,e,390369,377558,1375);break}case 1237:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Yy=$Xc(32)|0;f[e>>2]=Yy;f[e+8>>2]=-2147483616;f[e+4>>2]=27;Pw=Yy;vx=378435;Qw=Pw+27|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Yy+27>>0]=0;vM(-215,e,390369,377558,1382);break}case 1245:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Yy=$Xc(48)|0;f[e>>2]=Yy;f[e+8>>2]=-2147483600;f[e+4>>2]=43;Pw=Yy;vx=378463;Qw=Pw+43|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[Yy+43>>0]=0;vM(-215,e,390369,377558,1405);break}case 1325:{SGa(h,378062,e);vM(-2,h,390369,377558,1463);break}case 1333:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=$Xc(48)|0;f[e>>2]=h;f[e+8>>2]=-2147483600;f[e+4>>2]=34;Pw=h;vx=378507;Qw=Pw+34|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[h+34>>0]=0;vM(-213,e,390369,377558,1478);break}case 1376:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=$Xc(80)|0;f[e>>2]=h;f[e+8>>2]=-2147483568;f[e+4>>2]=68;Pw=h;vx=378554;Qw=Pw+68|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[h+68>>0]=0;vM(-213,e,390369,377558,1510);break}case 1386:{f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;h=$Xc(48)|0;f[x>>2]=h;f[x+8>>2]=-2147483600;f[x+4>>2]=40;Pw=h;vx=378628;Qw=Pw+40|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[h+40>>0]=0;vM(-215,x,390369,377558,1517);break}case 1477:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;x=$Xc(48)|0;f[e>>2]=x;f[e+8>>2]=-2147483600;f[e+4>>2]=46;Pw=x;vx=378669;Qw=Pw+46|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[x+46>>0]=0;vM(-213,e,390369,377558,1548);break}case 1575:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;x=$Xc(48)|0;f[e>>2]=x;f[e+8>>2]=-2147483600;f[e+4>>2]=32;Pw=x;vx=378726;Qw=Pw+32|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[x+32>>0]=0;vM(-213,e,390369,377558,1624);break}case 1798:{kV(jC,4,80612);break}case 1804:{if(lC){uE=Y(f[Jq>>2]|0,f[Iq>>2]|0)|0;nV(uE,2,80640)}Iq=f[Rq>>2]|0;Rq=0;Jq=1;while(1){lC=Y(f[Iq+(Rq<<2)>>2]|0,Jq)|0;Rq=Rq+1|0;if((Rq|0)==(kC|0)){uE=lC;break}else Jq=lC}nV(uE,2,80640);break}case 1837:{kV(rC,4,80668);break}case 1843:{if(tC){vE=Y(f[tr>>2]|0,f[sr>>2]|0)|0;nV(vE,1,80696)}sr=f[Kr>>2]|0;Kr=0;tr=1;while(1){tC=Y(f[sr+(Kr<<2)>>2]|0,tr)|0;Kr=Kr+1|0;if((Kr|0)==(sC|0)){vE=tC;break}else tr=tC}nV(vE,1,80696);break}case 1849:{kV(vC,4,80724);break}case 1855:{if(xC){wE=Y(f[wr>>2]|0,f[vr>>2]|0)|0;nV(wE,1,80752)}vr=f[Gr>>2]|0;Gr=0;wr=1;while(1){xC=Y(f[vr+(Gr<<2)>>2]|0,wr)|0;Gr=Gr+1|0;if((Gr|0)==(wC|0)){wE=xC;break}else wr=xC}nV(wE,1,80752);break}case 1881:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;wE=$Xc(64)|0;f[e>>2]=wE;f[e+8>>2]=-2147483584;f[e+4>>2]=50;Pw=wE;vx=378759;Qw=Pw+50|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[wE+50>>0]=0;vM(-215,e,390369,377558,1707);break}case 1907:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;wE=$Xc(32)|0;f[e>>2]=wE;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=wE;vx=378096;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[wE+23>>0]=0;vM(-215,e,390369,377558,1727);break}case 1916:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;wE=$Xc(48)|0;f[e>>2]=wE;f[e+8>>2]=-2147483600;f[e+4>>2]=35;Pw=wE;vx=378810;Qw=Pw+35|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[wE+35>>0]=0;vM(-215,e,390369,377558,1729);break}case 1933:{wE=$Xc(32)|0;f[e>>2]=wE;f[e+8>>2]=-2147483616;f[e+4>>2]=20;Pw=wE;vx=378350;Qw=Pw+20|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[wE+20>>0]=0;vM(-215,e,378371,377558,43);break}case 1975:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;wE=$Xc(80)|0;f[e>>2]=wE;f[e+8>>2]=-2147483568;f[e+4>>2]=66;Pw=wE;vx=378846;Qw=Pw+66|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[wE+66>>0]=0;vM(-215,e,390369,377558,1739);break}case 1977:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;wE=$Xc(80)|0;f[e>>2]=wE;f[e+8>>2]=-2147483568;f[e+4>>2]=66;Pw=wE;vx=378913;Qw=Pw+66|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[wE+66>>0]=0;vM(-215,e,390369,377558,1741);break}case 2102:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;wE=$Xc(32)|0;f[e>>2]=wE;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=wE;vx=377685;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[wE+23>>0]=0;vM(-215,e,390369,377558,1797);break}case 2111:{kV(aB,4,80780);break}case 2117:{if(cB){xE=Y(f[Rt>>2]|0,f[Qt>>2]|0)|0;nV(xE,2,80808)}Qt=f[Xt>>2]|0;Xt=0;Rt=1;while(1){cB=Y(f[Qt+(Xt<<2)>>2]|0,Rt)|0;Xt=Xt+1|0;if((Xt|0)==(bB|0)){xE=cB;break}else Rt=cB}nV(xE,2,80808);break}case 2158:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;xE=$Xc(32)|0;f[e>>2]=xE;f[e+8>>2]=-2147483616;f[e+4>>2]=26;Pw=xE;vx=379001;Qw=Pw+26|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[xE+26>>0]=0;vM(-215,e,390369,377558,1814);break}case 2172:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;xE=$Xc(48)|0;f[e>>2]=xE;f[e+8>>2]=-2147483600;f[e+4>>2]=42;Pw=xE;vx=379028;Qw=Pw+42|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[xE+42>>0]=0;vM(-213,e,390369,377558,1817);break}case 2194:{f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;xE=$Xc(48)|0;f[v>>2]=xE;f[v+8>>2]=-2147483600;f[v+4>>2]=44;Pw=xE;vx=379090;Qw=Pw+44|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[xE+44>>0]=0;vM(-215,v,390369,377558,1838);break}case 2219:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;v=$Xc(32)|0;f[e>>2]=v;f[e+8>>2]=-2147483616;f[e+4>>2]=23;Pw=v;vx=377685;Qw=Pw+23|0;do{b[Pw>>0]=b[vx>>0]|0;Pw=Pw+1|0;vx=vx+1|0}while((Pw|0)<(Qw|0));b[v+23>>0]=0;vM(-215,e,390369,377558,1850);break}case 2239:{if(sB){yE=Y(f[dv>>2]|0,f[cv>>2]|0)|0;nV(yE,1,80836)}cv=f[vv>>2]|0;vv=0;dv=1;while(1){sB=Y(f[cv+(vv<<2)>>2]|0,dv)|0;vv=vv+1|0;if((vv|0)==(rB|0)){yE=sB;break}else dv=sB}nV(yE,1,80836);break}case 2245:{kV(uB,5,80864);break}case 2251:{if(wB){zE=Y(f[gv>>2]|0,f[fv>>2]|0)|0;nV(zE,1,80892)}fv=f[rv>>2]|0;rv=0;gv=1;while(1){wB=Y(f[fv+(rv<<2)>>2]|0,gv)|0;rv=rv+1|0;if((rv|0)==(vB|0)){zE=wB;break}else gv=wB}nV(zE,1,80892);break}case 2257:{kV(yB,5,80920);break}}}function nIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;e=u;u=u+224|0;g=e+208|0;h=e+152|0;i=e+140|0;j=e+128|0;k=e+72|0;l=e+16|0;m=e;o=a+12|0;if((f[o>>2]|0)<=0){u=e;return}p=a+20|0;a=j+11|0;q=j+4|0;r=c+4|0;s=k+11|0;t=k+4|0;v=h+8|0;w=g+11|0;x=g+5|0;y=g+11|0;z=g+5|0;A=g+11|0;B=g+5|0;C=h+4|0;D=h+8|0;E=h+12|0;F=k+4|0;G=k+8|0;H=k+12|0;I=h+16|0;J=k+16|0;K=g+8|0;L=g+4|0;M=l+16|0;N=l+4|0;O=l+8|0;P=l+12|0;Q=m+12|0;R=c+4|0;S=c+8|0;T=m+11|0;U=l+36|0;V=l+40|0;W=l+44|0;X=l+48|0;Z=k+36|0;_=k+40|0;$=k+44|0;aa=k+48|0;ba=h+36|0;ca=h+40|0;da=h+44|0;ea=h+48|0;fa=g+11|0;ga=g+4|0;ha=i+11|0;ia=h+11|0;ja=h+5|0;ka=h+12|0;la=h+11|0;ma=0;a:while(1){na=f[(f[p>>2]|0)+4+(ma<<2)>>2]|0;lYc(i,f[na+60>>2]|0);lYc(j,f[na+64>>2]|0);oa=b[a>>0]|0;pa=f[q>>2]|0;do if(((oa<<24>>24<0?pa:oa&255)|0)==10){if(LYc(j,0,-1,380625,10)|0){qa=b[a>>0]|0;ra=f[q>>2]|0;sa=90;break}if((f[na+12>>2]|0)!=3){sa=9;break a}ta=na+20|0;if((CHa(c,f[(f[ta>>2]|0)+4>>2]|0)|0)==(r|0)){sa=11;break a}if((CHa(c,f[(f[ta>>2]|0)+8>>2]|0)|0)==(r|0)){sa=11;break a}if((CHa(c,f[(f[ta>>2]|0)+12>>2]|0)|0)==(r|0)){sa=11;break a};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[s>>0]=4;f[k>>2]=1701080941;b[t>>0]=0;ua=na+24|0;elc(ua);va=na+48|0;xIa(h,va);yIa(g,f[v>>2]|0,k,0);wa=(f[g>>2]|0)==0;zIa(h);if(wa)xa=0;else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[fa>>0]=4;f[g>>2]=1701080941;b[ga>>0]=0;elc(ua);ua=AIa(va,g)|0;va=(f[ua+20>>2]|0)==2?f[ua+8>>2]|0:537368;ua=b[va+11>>0]|0;if(((ua<<24>>24<0?f[va+4>>2]|0:ua&255)|0)==9)ya=(LYc(va,0,-1,380706,9)|0)==0;else ya=0;if((b[fa>>0]|0)<0)cYc(f[g>>2]|0);xa=ya}if((b[s>>0]|0)<0)cYc(f[k>>2]|0);if(!xa){sa=20;break a}va=IGa(c,f[(f[ta>>2]|0)+4>>2]|0)|0;ua=f[va>>2]|0;va=IGa(c,f[(f[ta>>2]|0)+8>>2]|0)|0;wa=f[va>>2]|0;va=IGa(c,f[(f[ta>>2]|0)+12>>2]|0)|0;ta=f[va>>2]|0;va=f[(f[p>>2]|0)+4+(ua<<2)>>2]|0;za=va+24|0;elc(za);dlc(za);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[w>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[x>>0]=0;za=vJa(uJa(va+48|0,g)|0)|0;if((b[w>>0]|0)<0)cYc(f[g>>2]|0);va=za+160|0;if((f[va>>2]|0)!=12){sa=24;break a}Aa=f[(f[p>>2]|0)+4+(wa<<2)>>2]|0;elc(Aa+24|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[y>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[z>>0]=0;wa=AIa(Aa+48|0,g)|0;nKa(h,(f[wa+20>>2]|0)==8?f[wa+8>>2]|0:530864);if((b[y>>0]|0)<0)cYc(f[g>>2]|0);wa=f[(f[p>>2]|0)+4+(ta<<2)>>2]|0;elc(wa+24|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[A>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[B>>0]=0;ta=AIa(wa+48|0,g)|0;nKa(k,(f[ta+20>>2]|0)==8?f[ta+8>>2]|0:530864);if((b[A>>0]|0)<0)cYc(f[g>>2]|0);ta=f[C>>2]|0;if((ta|0)<3)Ba=Y(f[E>>2]|0,f[D>>2]|0)|0;else{wa=f[ca>>2]|0;Aa=0;Ca=1;while(1){Da=Y(f[wa+(Aa<<2)>>2]|0,Ca)|0;Aa=Aa+1|0;if((Aa|0)==(ta|0)){Ba=Da;break}else Ca=Da}}if((Ba|0)!=1){sa=34;break a}if((f[h>>2]&4095|0)!=5){sa=36;break a}Ca=f[F>>2]|0;if((Ca|0)<3)Ea=Y(f[H>>2]|0,f[G>>2]|0)|0;else{ta=f[_>>2]|0;Aa=0;wa=1;while(1){Da=Y(f[ta+(Aa<<2)>>2]|0,wa)|0;Aa=Aa+1|0;if((Aa|0)==(Ca|0)){Ea=Da;break}else wa=Da}}if((Ea|0)!=1){sa=42;break a}if((f[k>>2]&4095|0)!=5){sa=44;break a}nKa(l,za);Fa=+n[f[I>>2]>>2];Ga=(+n[f[J>>2]>>2]-Fa)/255.0;if(!(Ga>=0.0)){sa=46;break a}wa=K;f[wa>>2]=0;f[wa+4>>2]=0;f[g>>2]=33619968;f[L>>2]=l;dY(l,g,5,Ga,Ga*+(ALc(Fa/Ga)|0));f[va>>2]=1;wa=f[M>>2]|0;Ca=f[N>>2]|0;if((Ca|0)<3)Ha=Y(f[P>>2]|0,f[O>>2]|0)|0;else{Aa=f[V>>2]|0;ta=0;Da=1;while(1){Ia=Y(f[Aa+(ta<<2)>>2]|0,Da)|0;ta=ta+1|0;if((ta|0)==(Ca|0)){Ha=Ia;break}else Da=Ia}}wJa(za,wa,Y(675553809>>>(f[l>>2]<<2&28)&15,Ha)|0);Da=f[(f[p>>2]|0)+4+(ua<<2)>>2]|0;Ca=Da+60|0;ta=f[Da+4>>2]|0;Da=ta&-2;if(!(ta&1))Ja=Da;else Ja=f[Da+4>>2]|0;Da=f[Ca>>2]|0;if((Da|0)==537368)xJa(Ca,Ja,i);else oYc(Da,i)|0;lYc(m,i);f[Q>>2]=ua;Da=ZGa(c,g,m)|0;if(!(f[Da>>2]|0)){Ca=$Xc(32)|0;ta=Ca+16|0;f[ta>>2]=f[m>>2];f[ta+4>>2]=f[m+4>>2];f[ta+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[Ca+28>>2]=f[Q>>2];ta=f[g>>2]|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=ta;f[Da>>2]=Ca;ta=f[f[c>>2]>>2]|0;if(!ta)Ka=Ca;else{f[c>>2]=ta;Ka=f[Da>>2]|0}UQ(f[R>>2]|0,Ka);f[S>>2]=(f[S>>2]|0)+1;La=0}else La=1;if((b[T>>0]|0)<0)cYc(f[m>>2]|0);if(La){sa=64;break a}SQ(g,d,i,i);Da=f[U>>2]|0;do if(Da|0){ta=Da+12|0;Ca=f[ta>>2]|0;f[ta>>2]=Ca+-1;if((Ca|0)!=1)break;V$(l)}while(0);f[U>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[N>>2]|0)>0){Da=f[V>>2]|0;ua=0;do{f[Da+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[N>>2]|0))}ua=f[W>>2]|0;if((ua|0)!=(X|0))wL(ua);ua=f[Z>>2]|0;do if(ua|0){Da=ua+12|0;wa=f[Da>>2]|0;f[Da>>2]=wa+-1;if((wa|0)!=1)break;V$(k)}while(0);f[Z>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[F>>2]|0)>0){ua=f[_>>2]|0;wa=0;do{f[ua+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[F>>2]|0))}wa=f[$>>2]|0;if((wa|0)!=(aa|0))wL(wa);wa=f[ba>>2]|0;do if(wa|0){ua=wa+12|0;Da=f[ua>>2]|0;f[ua>>2]=Da+-1;if((Da|0)!=1)break;V$(h)}while(0);f[ba>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[C>>2]|0)>0){wa=f[ca>>2]|0;Da=0;do{f[wa+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[C>>2]|0))}Da=f[da>>2]|0;if((Da|0)!=(ea|0))wL(Da)}else{qa=oa;ra=pa;sa=90}while(0);if(((sa|0)==90?(sa=0,((qa<<24>>24<0?ra:qa&255)|0)==5):0)?(LYc(j,0,-1,381538,5)|0)==0:0){pa=na+24|0;elc(pa);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[ia>>0]=5;b[h>>0]=b[502066]|0;b[h+1>>0]=b[502067]|0;b[h+2>>0]=b[502068]|0;b[h+3>>0]=b[502069]|0;b[h+4>>0]=b[502070]|0;b[ja>>0]=0;yIa(g,f[na+56>>2]|0,h,0);oa=f[g>>2]|0;elc(pa);if((b[ia>>0]|0)<0)cYc(f[h>>2]|0);if(oa|0){lYc(h,i);f[ka>>2]=ma;oa=ZGa(c,g,h)|0;if(!(f[oa>>2]|0)){pa=$Xc(32)|0;Da=pa+16|0;f[Da>>2]=f[h>>2];f[Da+4>>2]=f[h+4>>2];f[Da+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[pa+28>>2]=f[ka>>2];Da=f[g>>2]|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=Da;f[oa>>2]=pa;Da=f[f[c>>2]>>2]|0;if(!Da)Ma=pa;else{f[c>>2]=Da;Ma=f[oa>>2]|0}UQ(f[R>>2]|0,Ma);f[S>>2]=(f[S>>2]|0)+1;Na=0}else Na=1;if((b[la>>0]|0)<0)cYc(f[h>>2]|0);if(Na){sa=102;break}}SQ(g,d,i,i)}if((b[a>>0]|0)<0)cYc(f[j>>2]|0);if((b[ha>>0]|0)<0)cYc(f[i>>2]|0);ma=ma+1|0;if((ma|0)>=(f[o>>2]|0)){sa=3;break}}switch(sa|0){case 3:{u=e;return}case 9:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=23;Oa=e;Pa=377685;Qa=Oa+23|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+23>>0]=0;vM(-215,g,380636,377558,575);break}case 11:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(64)|0;f[g>>2]=e;f[g+8>>2]=-2147483584;f[g+4>>2]=55;Oa=e;Pa=380650;Qa=Oa+55|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+55>>0]=0;vM(-215,g,380636,377558,577);break}case 20:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(80)|0;f[g>>2]=e;f[g+8>>2]=-2147483568;f[g+4>>2]=77;Oa=e;Pa=380716;Qa=Oa+77|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+77>>0]=0;vM(-215,g,380636,377558,579);break}case 24:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(48)|0;f[g>>2]=e;f[g+8>>2]=-2147483600;f[g+4>>2]=40;Oa=e;Pa=380794;Qa=Oa+40|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+40>>0]=0;vM(-215,g,380636,377558,588);break}case 34:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=17;Oa=e;Pa=380835;Qa=Oa+17|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+17>>0]=0;vM(-215,g,380636,377558,593);break}case 36:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(64)|0;f[g>>2]=e;f[g+8>>2]=-2147483584;f[g+4>>2]=56;Oa=e;Pa=380853;Qa=Oa+56|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+56>>0]=0;vM(-215,g,380636,377558,593);break}case 42:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=17;Oa=e;Pa=380910;Qa=Oa+17|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+17>>0]=0;vM(-215,g,380636,377558,593);break}case 44:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(64)|0;f[g>>2]=e;f[g+8>>2]=-2147483584;f[g+4>>2]=56;Oa=e;Pa=380928;Qa=Oa+56|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+56>>0]=0;vM(-215,g,380636,377558,593);break}case 46:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(16)|0;f[g>>2]=e;f[g+8>>2]=-2147483632;f[g+4>>2]=15;Oa=e;Pa=380985;Qa=Oa+15|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+15>>0]=0;vM(-215,g,380636,377558,599);break}case 64:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(64)|0;f[g>>2]=e;f[g+8>>2]=-2147483584;f[g+4>>2]=58;Oa=e;Pa=381001;Qa=Oa+58|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+58>>0]=0;vM(-215,g,380636,377558,607);break}case 102:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(64)|0;f[g>>2]=e;f[g+8>>2]=-2147483584;f[g+4>>2]=52;Oa=e;Pa=381060;Qa=Oa+52|0;do{b[Oa>>0]=b[Pa>>0]|0;Oa=Oa+1|0;Pa=Pa+1|0}while((Oa|0)<(Qa|0));b[e+52>>0]=0;vM(-215,g,380636,377558,616);break}}}function oIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=11;i=h;j=380532;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+11>>0]=0;h=a+24|0;elc(h);l=a+48|0;xIa(e,l);yIa(d,f[e+8>>2]|0,g,0);a=(f[d>>2]|0)==0;zIa(e);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(a){m=2;u=c;return m|0}a=$Xc(16)|0;f[e>>2]=a;f[e+8>>2]=-2147483632;f[e+4>>2]=11;i=a;j=380532;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[a+11>>0]=0;elc(h);h=AIa(l,e)|0;lYc(d,(f[h+20>>2]|0)==2?f[h+8>>2]|0:537368);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=d+11|0;l=b[h>>0]|0;a=d+4|0;j=f[a>>2]|0;if(((l<<24>>24<0?j:l&255)|0)==4)if(!(LYc(d,0,-1,380544,4)|0))n=0;else{o=b[h>>0]|0;p=f[a>>2]|0;q=9}else{o=l;p=j;q=9}do if((q|0)==9){if(((o<<24>>24<0?p:o&255)|0)==13){if(!(LYc(d,0,-1,380549,13)|0)){n=0;break}r=b[h>>0]|0;s=f[a>>2]|0}else{r=o;s=p}if(((r<<24>>24<0?s:r&255)|0)==4){if(!(LYc(d,0,-1,380563,4)|0)){n=1;break}t=b[h>>0]|0;v=f[a>>2]|0}else{t=r;v=s}if(((t<<24>>24<0?v:t&255)|0)!=14){SGa(e,380583,d);vM(-212,e,380611,377558,262)}if(!(LYc(d,0,-1,380568,14)|0))n=1;else{SGa(e,380583,d);vM(-212,e,380611,377558,262)}}while(0);if((b[h>>0]|0)<0)cYc(f[d>>2]|0);m=n;u=c;return m|0}function pIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function qIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function rIa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+32|0;h=g+16|0;i=g;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;k=c+12|0;if((f[k>>2]|0)<=0){u=g;return}l=c+20|0;c=e+11|0;m=e+4|0;n=h+11|0;o=h+4|0;p=d+11|0;q=d+4|0;r=i+12|0;s=a+8|0;t=i+11|0;v=0;do{w=f[(f[l>>2]|0)+4+(v<<2)>>2]|0;x=w+12|0;if((f[x>>2]|0)>0){y=w+20|0;z=w+60|0;A=w+64|0;w=0;do{vIa(i,f[(f[y>>2]|0)+4+(w<<2)>>2]|0);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];B=b[c>>0]|0;C=B<<24>>24<0;D=B&255;B=C?f[m>>2]|0:D;a:do if(B){E=f[A>>2]|0;F=b[E+11>>0]|0;G=F<<24>>24<0;if((B|0)==((G?f[E+4>>2]|0:F&255)|0)){F=f[e>>2]|0;H=G?f[E>>2]|0:E;if(C){I=(WKc(F,H,B)|0)==0;break}if((F&255)<<24>>24==(b[H>>0]|0)){F=e;E=D;G=H;while(1){E=E+-1|0;F=F+1|0;if(!E){I=1;break a}G=G+1|0;if((b[F>>0]|0)!=(b[G>>0]|0)){I=0;break}}}else I=0}else I=0}else I=1;while(0);D=b[n>>0]|0;B=D<<24>>24<0;C=D&255;D=B?f[o>>2]|0:C;G=b[p>>0]|0;F=G<<24>>24<0;b:do if((D|0)==((F?f[q>>2]|0:G&255)|0)){E=f[h>>2]|0;H=B?E:h;J=F?f[d>>2]|0:d;K=(D|0)==0;c:do if(B)if(K)L=1;else L=(WKc(H,J,D)|0)==0;else if(K)L=1;else{if((E&255)<<24>>24==(b[J>>0]|0)){M=h;N=C;O=J}else break b;while(1){N=N+-1|0;M=M+1|0;if(!N){L=1;break c}O=O+1|0;if((b[M>>0]|0)!=(b[O>>0]|0))break b}}while(0);if(I&L){lYc(i,f[z>>2]|0);f[r>>2]=v;J=f[j>>2]|0;if(J>>>0>=(f[s>>2]|0)>>>0){tJa(a,i);if((b[t>>0]|0)<0)cYc(f[i>>2]|0)}else{f[J>>2]=f[i>>2];f[J+4>>2]=f[i+4>>2];f[J+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[J+12>>2]=f[r>>2];f[j>>2]=(f[j>>2]|0)+16}}}while(0);if(B)cYc(f[h>>2]|0);w=w+1|0}while((w|0)<(f[x>>2]|0))}v=v+1|0}while((v|0)<(f[k>>2]|0));u=g;return}function sIa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;f[i>>2]=f[b>>2];f[g>>2]=f[i>>2];i=sJa(a,g,h,e+4|0,c)|0;c=f[i>>2]|0;if(c|0){j=c;u=e;return j|0}c=$Xc(32)|0;lYc(c+16|0,d);f[c+28>>2]=f[d+12>>2];d=f[h>>2]|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=d;f[i>>2]=c;d=f[f[a>>2]>>2]|0;if(!d)k=c;else{f[a>>2]=d;k=f[i>>2]|0}UQ(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;j=c;u=e;return j|0}function tIa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;h=u;u=u+80|0;i=h+56|0;j=h+40|0;k=h+24|0;l=h+12|0;m=h;if((e|0)==-1){n=c+12|0;if((f[n>>2]|0)<=0){o=$Xc(48)|0;f[i>>2]=o;p=i+8|0;f[p>>2]=-2147483600;q=i+4|0;f[q>>2]=38;r=o;s=380335;t=r+38|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));v=o+38|0;b[v>>0]=0;vM(-2,i,380322,377558,530)}w=c+20|0;x=d+4|0;y=i+11|0;z=0;A=-1;while(1){vIa(i,f[(f[w>>2]|0)+4+(z<<2)>>2]|0);if((CHa(d,i)|0)!=(x|0))if((A|0)==-1)B=z;else{C=6;break}else B=A;if((b[y>>0]|0)<0)cYc(f[i>>2]|0);z=z+1|0;if((z|0)>=(f[n>>2]|0))break;else A=B}if((C|0)==6){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;A=$Xc(32)|0;f[j>>2]=A;f[j+8>>2]=-2147483616;f[j+4>>2]=31;r=A;s=380290;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[A+31>>0]=0;vM(-2,j,380322,377558,522)}if((B|0)==-1){o=$Xc(48)|0;f[i>>2]=o;p=i+8|0;f[p>>2]=-2147483600;q=i+4|0;f[q>>2]=38;r=o;s=380335;t=r+38|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));v=o+38|0;b[v>>0]=0;vM(-2,i,380322,377558,530)}else D=B}else D=e;e=c+20|0;vIa(j,f[(f[e>>2]|0)+4+(D<<2)>>2]|0);if((CHa(d,j)|0)==(d+4|0)){SGa(m,380374,f[(f[e>>2]|0)+4+(D<<2)>>2]|0);e=AYc(m,380382)|0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;e=f[c+60>>2]|0;c=b[e+11>>0]|0;m=c<<24>>24<0;B=zYc(l,m?f[e>>2]|0:e,m?f[e+4>>2]|0:c&255)|0;f[k>>2]=f[B>>2];f[k+4>>2]=f[B+4>>2];f[k+8>>2]=f[B+8>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;B=AYc(k,380395)|0;f[i>>2]=f[B>>2];f[i+4>>2]=f[B+4>>2];f[i+8>>2]=f[B+8>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;vM(-2,i,380322,377558,535)}if(f[j+12>>2]|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;B=$Xc(32)|0;f[i>>2]=B;f[i+8>>2]=-2147483616;f[i+4>>2]=24;r=B;s=380407;t=r+24|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[B+24>>0]=0;vM(-2,i,380322,377558,537)}if(g|0)f[g>>2]=D;D=ZGa(d,i,j)|0;d=f[D>>2]|0;if(!d){D=af(8)|0;hYc(D,380432);f[D>>2]=192368;ig(D|0,25352,2140)}D=f[d+28>>2]|0;a:do if((D|0)<(f[a+12>>2]|0)?(d=f[(f[a+20>>2]|0)+4+(D<<2)>>2]|0,g=f[d+60>>2]|0,B=b[g+11>>0]|0,k=B<<24>>24<0,c=B&255,B=k?f[g+4>>2]|0:c,e=j+11|0,m=b[e>>0]|0,l=m<<24>>24<0,(B|0)==((l?f[j+4>>2]|0:m&255)|0)):0){m=f[g>>2]|0;v=k?m:g;o=l?f[j>>2]|0:j;l=(B|0)==0;b:do if(k){if(!l?WKc(v,o,B)|0:0){C=32;break a}}else if(!l){if((m&255)<<24>>24==(b[o>>0]|0)){E=g;F=c;G=o}else{C=32;break a}while(1){F=F+-1|0;E=E+1|0;if(!F)break b;G=G+1|0;if((b[E>>0]|0)!=(b[G>>0]|0)){C=32;break a}}}while(0);elc(d+24|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;o=i+11|0;b[o>>0]=5;b[i>>0]=b[502066]|0;b[i+1>>0]=b[502067]|0;b[i+2>>0]=b[502068]|0;b[i+3>>0]=b[502069]|0;b[i+4>>0]=b[502070]|0;b[i+5>>0]=0;c=AIa(d+48|0,i)|0;g=(f[c+20>>2]|0)==8?f[c+8>>2]|0:530864;if((b[o>>0]|0)<0)cYc(f[i>>2]|0);H=g;I=e}else C=32;while(0);if((C|0)==32){if((D|0)>=(f[a+52>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;C=$Xc(32)|0;f[i>>2]=C;f[i+8>>2]=-2147483616;f[i+4>>2]=28;r=C;s=380456;t=r+28|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[C+28>>0]=0;vM(-215,i,380322,377558,551)}C=f[(f[a+60>>2]|0)+4+(D<<2)>>2]|0;D=f[C+60>>2]|0;a=b[D+11>>0]|0;G=a<<24>>24<0;E=a&255;a=G?f[D+4>>2]|0:E;F=j+11|0;g=b[F>>0]|0;o=g<<24>>24<0;if((a|0)!=((o?f[j+4>>2]|0:g&255)|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;J=$Xc(48)|0;f[i>>2]=J;K=i+8|0;f[K>>2]=-2147483600;L=i+4|0;f[L>>2]=46;r=J;s=380485;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));M=J+46|0;b[M>>0]=0;vM(-215,i,380322,377558,551)}g=f[D>>2]|0;c=G?g:D;m=o?f[j>>2]|0:j;o=(a|0)==0;c:do if(G){if(!o?WKc(c,m,a)|0:0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;J=$Xc(48)|0;f[i>>2]=J;K=i+8|0;f[K>>2]=-2147483600;L=i+4|0;f[L>>2]=46;r=J;s=380485;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));M=J+46|0;b[M>>0]=0;vM(-215,i,380322,377558,551)}}else if(!o){if((g&255)<<24>>24==(b[m>>0]|0)){N=D;O=E;P=m}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;J=$Xc(48)|0;f[i>>2]=J;K=i+8|0;f[K>>2]=-2147483600;L=i+4|0;f[L>>2]=46;r=J;s=380485;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));M=J+46|0;b[M>>0]=0;vM(-215,i,380322,377558,551)}do{O=O+-1|0;N=N+1|0;if(!O)break c;P=P+1|0}while((b[N>>0]|0)==(b[P>>0]|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;J=$Xc(48)|0;f[i>>2]=J;K=i+8|0;f[K>>2]=-2147483600;L=i+4|0;f[L>>2]=46;r=J;s=380485;t=r+46|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));M=J+46|0;b[M>>0]=0;vM(-215,i,380322,377558,551)}while(0);elc(C+24|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;M=i+11|0;b[M>>0]=5;b[i>>0]=b[502066]|0;b[i+1>>0]=b[502067]|0;b[i+2>>0]=b[502068]|0;b[i+3>>0]=b[502069]|0;b[i+4>>0]=b[502070]|0;b[i+5>>0]=0;J=AIa(C+48|0,i)|0;C=(f[J+20>>2]|0)==8?f[J+8>>2]|0:530864;if((b[M>>0]|0)<0)cYc(f[i>>2]|0);H=C;I=F}if((b[I>>0]|0)>=0){u=h;return H|0}cYc(f[j>>2]|0);u=h;return H|0}function uIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=c+4|0;i=f[h>>2]|0;j=g;if((i|0)==(g|0))k=i;else{l=i+(~((i+-4-j|0)>>>2)<<2)|0;f[h>>2]=l;k=l}l=k;if((a|0)!=530864?(i=f[a+156>>2]|0,i|0):0){a=f[i+12>>2]|0;if(!a){f[e>>2]=1;switch(l-j>>2|0){case 0:{Uv(c,1,e);break}case 1:break;default:{m=g+4|0;if((k|0)!=(m|0))f[h>>2]=k+(~((k+-4-m|0)>>>2)<<2)}}u=d;return}m=l-j>>2;if(a>>>0<=m>>>0){if(a>>>0<m>>>0?(j=g+(a<<2)|0,(k|0)!=(j|0)):0)f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2)}else CS(c,a-m|0);if((a|0)<=0){u=d;return}m=f[i+20>>2]|0;i=f[c>>2]|0;c=0;do{f[i+(c<<2)>>2]=f[(f[m+4+(c<<2)>>2]|0)+16>>2];c=c+1|0}while((c|0)!=(a|0));u=d;return}d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=29;a=d;c=380240;m=a+29|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(m|0));b[d+29>>0]=0;vM(-2,e,380270,377558,91)}function vIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+160|0;e=d+140|0;g=d;lYc(a,c);h=a+12|0;f[h>>2]=0;i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c>>2]|0:c;l=j?f[c+4>>2]|0:i&255;if(!l){u=d;return}i=k+l|0;l=k;while(1){if((b[l>>0]|0)==58)break;j=l+1|0;if((j|0)==(i|0)){m=14;break}else l=j}if((m|0)==14){u=d;return}m=l-k|0;if((l|0)==(i|0)|(m|0)==-1){u=d;return}mYc(e,c,0,m,c);i=a+11|0;if((b[i>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0}else{b[a>>0]=0;b[i>>0]=0}sYc(a,0);f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];f[a+8>>2]=f[e+8>>2];mYc(e,c,m+1|0,-1,c);c=g+60|0;m=g+8|0;f[g>>2]=14468;f[c>>2]=14488;f[g+4>>2]=0;XNc(g+60|0,m);f[g+132>>2]=0;f[g+136>>2]=-1;f[g>>2]=80960;f[c>>2]=80980;aOc(m);f[m>>2]=35912;a=g+40|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[g+56>>2]=8;AM(m,e);gOc(g,h)|0;f[g>>2]=80960;f[c>>2]=80980;f[m>>2]=35912;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);LMc(m);xNc(g,80992);GMc(c);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}function wIa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+16|0;j=i;k=qIa(c,e)|0;if((k|0)==(c+4|0)){SGa(j,378062,e);vM(-2,j,393135,377558,497)}j=f[a+80>>2]|0;c=f[a+84>>2]|0;a=j;a:do if((j|0)==(c|0)){l=j;m=14}else{n=b[e+11>>0]|0;o=n<<24>>24<0;p=o?f[e+4>>2]|0:n&255;n=o?f[e>>2]|0:e;o=(p|0)==0;q=j;do{r=b[q+11>>0]|0;s=r<<24>>24<0;t=r&255;do if(((s?f[q+4>>2]|0:t)|0)==(p|0)){r=f[q>>2]|0;v=s?r:q;if(s){if(o){l=q;m=14;break a}if(!(WKc(v,n,p)|0)){l=q;m=14;break a}else break}if(o){l=q;m=14;break a}if((r&255)<<24>>24==(b[n>>0]|0)){r=q;v=t;w=n;do{v=v+-1|0;r=r+1|0;if(!v){l=q;m=14;break a}w=w+1|0}while((b[r>>0]|0)==(b[w>>0]|0))}}while(0);q=q+12|0}while((q|0)!=(c|0))}while(0);if((m|0)==14?(l|0)!=(c|0):0){x=(l-a|0)/12|0;y=k+28|0;z=f[y>>2]|0;YOa(d,z,x,g,h);u=i;return}x=f[e+12>>2]|0;y=k+28|0;z=f[y>>2]|0;YOa(d,z,x,g,h);u=i;return}function xIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;d=c+16|0;e=c;f[a>>2]=0;f[a+4>>2]=f[b+4>>2];aJa(a);g=f[b+8>>2]|0;b=f[g+12>>2]|0;h=f[g+4>>2]|0;a:do if(h>>>0>b>>>0){i=f[g+16>>2]|0;j=b;while(1){k=f[i+(j<<2)>>2]|0;if(k|0)break;l=j+1|0;if(l>>>0<h>>>0)j=l;else{m=0;n=l;break a}}if((k|0)==(f[i+((j^1)<<2)>>2]|0)){m=f[(f[k>>2]|0)+16>>2]|0;n=j;break}else{m=k;n=j;break}}else{m=0;n=b}while(0);f[e>>2]=m;f[e+4>>2]=g;f[e+8>>2]=n;if(!m){u=c;return}n=a+8|0;g=m;do{yIa(d,f[n>>2]|0,f[g+12>>2]|0,0);if(!(f[d>>2]|0)){m=f[(f[e>>2]|0)+12>>2]|0;kUa(bJa(a,m)|0,m+16|0)}RIa(e)|0;g=f[e>>2]|0}while((g|0)!=0);u=c;return}function yIa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d>>2]|0:d;l=b[k>>0]|0;if(!(l<<24>>24))m=0;else{n=k;o=0;p=l;while(1){q=(o*5|0)+(p<<24>>24)|0;n=n+1|0;p=b[n>>0]|0;if(!(p<<24>>24)){m=q;break}else o=q}}o=(f[c+4>>2]|0)+-1&(f[c+8>>2]|0)+m;m=f[c+16>>2]|0;p=f[m+(o<<2)>>2]|0;a:do if(!p)r=o;else{if((p|0)==(f[m+((o^1)<<2)>>2]|0)){if((p|0)!=(f[m+((o^1)<<2)>>2]|0)){r=o;break}n=o&-2;q=f[m+(n<<2)>>2]|0;f[h>>2]=d;s=q+4|0;t=$Ia(q,h,f[s>>2]|0,s)|0;do if((t|0)!=(s|0)){q=f[h>>2]|0;v=t+16|0;w=f[v>>2]|0;x=b[w+11>>0]|0;y=x<<24>>24<0;z=y?f[w+4>>2]|0:x&255;x=b[q+11>>0]|0;A=x<<24>>24<0;B=A?f[q+4>>2]|0:x&255;x=z>>>0<B>>>0?z:B;C=w;if((x|0)!=0?(D=WKc(A?f[q>>2]|0:q,y?f[w>>2]|0:w,x)|0,(D|0)!=0):0){if((D|0)<0)break}else E=20;if((E|0)==20?B>>>0<z>>>0:0)break;if(!e)F=C;else{f[e>>2]=t;F=f[v>>2]|0}f[a>>2]=F;f[a+4>>2]=c;f[a+8>>2]=n;f[a+12>>2]=n;u=g;return}while(0);r=n;break}t=j?f[d+4>>2]|0:i&255;s=(t|0)==0;v=p;b:while(1){C=b[v+11>>0]|0;z=C<<24>>24<0;B=C&255;do if(((z?f[v+4>>2]|0:B)|0)==(t|0)){C=f[v>>2]|0;D=z?C:v;if(z){if(s)break b;if(!(WKc(D,k,t)|0))break b;else break}if(s)break b;if((C&255)<<24>>24==l<<24>>24){C=v;D=B;x=k;do{D=D+-1|0;C=C+1|0;if(!D)break b;x=x+1|0}while((b[C>>0]|0)==(b[x>>0]|0))}}while(0);B=f[v+16>>2]|0;if(!B){r=o;break a}else v=B}f[a>>2]=v;f[a+4>>2]=c;f[a+8>>2]=o;f[a+12>>2]=o;u=g;return}while(0);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=r;u=g;return}function zIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+48|0;d=c+28|0;e=c+16|0;g=c;h=a+8|0;i=f[h>>2]|0;j=f[i+12>>2]|0;k=f[i+4>>2]|0;a:do if(k>>>0>j>>>0){l=f[i+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;o=m+1|0;if(o>>>0<k>>>0)m=o;else{p=9;break a}}if((n|0)==(f[l+((m^1)<<2)>>2]|0))q=f[(f[n>>2]|0)+16>>2]|0;else q=n;if(q){o=g+4|0;r=g+8|0;s=q;t=i;v=m;while(1){f[g>>2]=s;f[o>>2]=t;f[r>>2]=v;if((f[a>>2]|0)==0?(w=f[s+12>>2]|0,w|0):0){ESa(w+16|0);if((b[w+11>>0]|0)<0)cYc(f[w>>2]|0);cYc(w)};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];UIa(g)|0;w=f[h>>2]|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];VIa(w,d);s=f[g>>2]|0;if(!s){x=a;break}else{t=f[o>>2]|0;v=f[r>>2]|0}}}else p=9}else p=9;while(0);if((p|0)==9)x=a;if(f[x>>2]|0){u=c;return}x=f[h>>2]|0;if(!x){u=c;return}h=x+16|0;if(f[h>>2]|0?(WIa(x),(f[x+20>>2]|0)==0):0)cYc(f[h>>2]|0);cYc(x);u=c;return}function AIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;yIa(d,f[a+8>>2]|0,b,0);a=f[d>>2]|0;if(a|0){g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}u_b(e,3,379823,1059);r_b(c+40|0,q_b(p_b(p_b(e,379907)|0,379935)|0,b)|0);v_b(e);g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}function BIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+96|0;e=d+72|0;g=d+16|0;h=d;switch(f[a+160>>2]|0){case 19:case 1:{f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;uIa(a,e);j=f[e>>2]|0;k=((f[i>>2]|0)-j|0)==16;l=j;if(k){j=l+8|0;m=l+12|0;o=f[m>>2]|0;f[m>>2]=f[j>>2];m=l+4|0;l=f[m>>2]|0;f[m>>2]=o;f[j>>2]=l}T$(c,e,5);nKa(g,a);l=g+4|0;j=f[l>>2]|0;if((j|0)<3)q=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{o=f[g+40>>2]|0;m=0;r=1;while(1){s=Y(f[o+(m<<2)>>2]|0,r)|0;m=m+1|0;if((m|0)==(j|0)){q=s;break}else r=s}}r=f[c+4>>2]|0;if((r|0)<3)t=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{j=f[c+40>>2]|0;m=0;o=1;while(1){s=Y(f[j+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)==(r|0)){t=s;break}else o=s}}if((q|0)!=(t|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=$Xc(32)|0;f[h>>2]=t;f[h+8>>2]=-2147483616;f[h+4>>2]=28;v=t;w=377815;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+28>>0]=0;vM(-215,h,377844,377558,113)}t=f[c+16>>2]|0;o=g+16|0;r=f[o>>2]|0;a:do if(k){m=f[e>>2]|0;j=f[m>>2]|0;s=f[m+4>>2]|0;y=f[m+8>>2]|0;z=f[m+12>>2]|0;m=Y(Y(Y(s,j)|0,y)|0,z)|0;if((j|0)>0?(A=Y(Y(y,s)|0,z)|0,(s|0)>0):0){B=(y|0)<1|(z|0)<1;C=0;b:while(1){D=Y(A,C)|0;if(!B){E=0;do{F=Y(E,y)|0;G=E+D|0;H=0;do{I=(Y(H+F|0,z)|0)+D|0;J=Y(H,z)|0;K=0;do{L=I+K|0;M=G+(Y(K+J|0,s)|0)|0;if((L|0)>=(m|0)){N=28;break b}if((M|0)>=(m|0)){N=29;break b}f[t+(L<<2)>>2]=f[r+(M<<2)>>2];K=K+1|0}while((K|0)<(z|0));H=H+1|0}while((H|0)<(y|0));E=E+1|0}while((E|0)<(s|0))}C=C+1|0;if((C|0)>=(j|0))break a}if((N|0)==28){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(16)|0;f[h>>2]=j;f[h+8>>2]=-2147483632;f[h+4>>2]=13;v=j;w=377856;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[j+13>>0]=0;vM(-215,h,377844,377558,129)}else if((N|0)==29){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;C=$Xc(16)|0;f[h>>2]=C;f[h+8>>2]=-2147483632;f[h+4>>2]=13;v=C;w=377870;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[C+13>>0]=0;vM(-215,h,377844,377558,130)}}}else if((q|0)>0){j=0;do{f[t+(j<<2)>>2]=f[r+(j<<2)>>2];j=j+1|0}while((j|0)!=(q|0))}while(0);q=g+36|0;r=f[q>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)V$(g);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){o=f[g+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[l>>2]|0))}l=f[g+44>>2]|0;if((l|0)!=(g+48|0))wL(l);l=f[e>>2]|0;if(l|0){q=f[i>>2]|0;if((q|0)!=(l|0))f[i>>2]=q+(~((q+-4-l|0)>>>2)<<2);cYc(l)}u=d;return}case 2:{f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;uIa(a,e);q=f[e>>2]|0;i=((f[l>>2]|0)-q|0)==16;o=q;if(i){q=o+8|0;r=o+12|0;t=f[r>>2]|0;f[r>>2]=f[q>>2];r=o+4|0;o=f[r>>2]|0;f[r>>2]=t;f[q>>2]=o}T$(c,e,5);nKa(g,a);a=g+4|0;o=f[a>>2]|0;if((o|0)<3)O=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{q=f[g+40>>2]|0;t=0;r=1;while(1){k=Y(f[q+(t<<2)>>2]|0,r)|0;t=t+1|0;if((t|0)==(o|0)){O=k;break}else r=k}}r=f[c+4>>2]|0;if((r|0)<3)P=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;t=0;q=1;while(1){k=Y(f[o+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)==(r|0)){P=k;break}else q=k}}if((O|0)!=(P|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;P=$Xc(32)|0;f[h>>2]=P;f[h+8>>2]=-2147483616;f[h+4>>2]=28;v=P;w=377815;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[P+28>>0]=0;vM(-215,h,377844,377558,113)}P=f[c+16>>2]|0;c=g+16|0;q=f[c>>2]|0;c:do if(i){r=f[e>>2]|0;t=f[r>>2]|0;o=f[r+4>>2]|0;k=f[r+8>>2]|0;j=f[r+12>>2]|0;r=Y(Y(Y(o,t)|0,k)|0,j)|0;if((t|0)>0?(C=Y(Y(k,o)|0,j)|0,(o|0)>0):0){s=(k|0)<1|(j|0)<1;y=0;d:while(1){z=Y(C,y)|0;if(!s){m=0;do{B=Y(m,k)|0;A=m+z|0;E=0;do{D=(Y(E+B|0,j)|0)+z|0;H=Y(E,j)|0;G=0;do{F=D+G|0;K=A+(Y(G+H|0,o)|0)|0;if((F|0)>=(r|0)){N=70;break d}if((K|0)>=(r|0)){N=71;break d}n[P+(F<<2)>>2]=+p[q+(K<<3)>>3];G=G+1|0}while((G|0)<(j|0));E=E+1|0}while((E|0)<(k|0));m=m+1|0}while((m|0)<(o|0))}y=y+1|0;if((y|0)>=(t|0))break c}if((N|0)==70){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=$Xc(16)|0;f[h>>2]=t;f[h+8>>2]=-2147483632;f[h+4>>2]=13;v=t;w=377856;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+13>>0]=0;vM(-215,h,377844,377558,129)}else if((N|0)==71){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(16)|0;f[h>>2]=y;f[h+8>>2]=-2147483632;f[h+4>>2]=13;v=y;w=377870;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[y+13>>0]=0;vM(-215,h,377844,377558,130)}}}else if((O|0)>0){t=0;do{n[P+(t<<2)>>2]=+p[q+(t<<3)>>3];t=t+1|0}while((t|0)!=(O|0))}while(0);O=g+36|0;q=f[O>>2]|0;if(q|0?(P=q+12|0,q=f[P>>2]|0,f[P>>2]=q+-1,(q|0)==1):0)V$(g);f[O>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;O=0;do{f[c+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))wL(a);a=f[e>>2]|0;if(a|0){g=f[l>>2]|0;if((g|0)!=(a|0))f[l>>2]=g+(~((g+-4-a|0)>>>2)<<2);cYc(a)}u=d;return}default:{d=$Xc(48)|0;f[e>>2]=d;f[e+8>>2]=-2147483600;f[e+4>>2]=35;v=d;w=382219;x=v+35|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[d+35>>0]=0;vM(-2,e,379808,377558,154)}}}function CIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;k=a+20|0;lYc(g,f[(f[(f[k>>2]|0)+4+(c<<2)>>2]|0)+60>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;rIa(h,a,g,i);lYc(i,f[(f[(f[(f[k>>2]|0)+4+(c<<2)>>2]|0)+20>>2]|0)+4+(d<<2)>>2]|0);d=h+4|0;c=f[d>>2]|0;a=f[h>>2]|0;l=a;if((c|0)==(a|0))m=l;else{n=j+11|0;o=j+4|0;p=g+11|0;q=g+4|0;r=0;s=l;t=a;a=c;c=l;while(1){l=f[(f[k>>2]|0)+4+(f[c+(r<<4)+12>>2]<<2)>>2]|0;v=l+12|0;if((f[v>>2]|0)>0){w=l+20|0;l=0;do{lYc(j,f[(f[w>>2]|0)+4+(l<<2)>>2]|0);x=b[n>>0]|0;y=x<<24>>24<0;z=x&255;A=y?f[o>>2]|0:z;B=b[p>>0]|0;C=B<<24>>24<0;a:do if((A|0)==((C?f[q>>2]|0:B&255)|0)){D=f[j>>2]|0;E=y?D:j;F=C?f[g>>2]|0:g;G=(A|0)==0;b:do if(y){if(!G?WKc(E,F,A)|0:0){H=17;break a}}else if(!G){if((D&255)<<24>>24==(b[F>>0]|0)){I=j;J=z;K=F}else{L=x;H=16;break a}while(1){J=J+-1|0;I=I+1|0;if(!J)break b;K=K+1|0;if((b[I>>0]|0)!=(b[K>>0]|0)){L=x;H=16;break a}}}while(0);oYc(f[(f[w>>2]|0)+4+(l<<2)>>2]|0,i)|0;L=b[n>>0]|0;H=16}else{L=x;H=16}while(0);if((H|0)==16?(H=0,L<<24>>24<0):0)H=17;if((H|0)==17){H=0;cYc(f[j>>2]|0)}l=l+1|0}while((l|0)<(f[v>>2]|0));v=f[h>>2]|0;M=v;N=v;O=f[d>>2]|0}else{M=s;N=t;O=a}r=r+1|0;if(r>>>0>=O-N>>4>>>0){m=M;break}else{s=M;t=N;a=O;c=N}}}if((b[i+11>>0]|0)<0){cYc(f[i>>2]|0);P=f[h>>2]|0}else P=m;if(P|0){m=f[d>>2]|0;if((m|0)==(P|0))Q=P;else{i=m;while(1){m=i+-16|0;f[d>>2]=m;if((b[m+11>>0]|0)<0){cYc(f[m>>2]|0);R=f[d>>2]|0}else R=m;if((R|0)==(P|0))break;else i=R}Q=f[h>>2]|0}cYc(Q)}if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function DIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function EIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+96|0;e=d+72|0;g=d+16|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;uIa(a,e);switch(f[a+160>>2]|0){case 19:case 1:break;default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(80)|0;f[g>>2]=j;f[g+8>>2]=-2147483568;f[g+4>>2]=79;k=j;l=379701;m=k+79|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+79>>0]=0;vM(-215,g,379781,377558,458)}}j=f[e>>2]|0;n=j;if(((f[i>>2]|0)-j|0)!=16){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=9;k=g;l=379798;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[g+9>>0]=0;vM(-215,g,379781,377558,459)}j=n+8|0;o=f[n>>2]|0;f[n>>2]=f[j>>2];f[j>>2]=o;o=n+4|0;j=n+12|0;p=f[j>>2]|0;f[j>>2]=f[o>>2];j=f[n>>2]|0;f[n>>2]=p;f[o>>2]=j;T$(c,e,5);nKa(g,a);a=g+4|0;j=f[a>>2]|0;if((j|0)<3)q=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{o=f[g+40>>2]|0;p=0;n=1;while(1){r=Y(f[o+(p<<2)>>2]|0,n)|0;p=p+1|0;if((p|0)==(j|0)){q=r;break}else n=r}}n=f[c+4>>2]|0;if((n|0)<3)s=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{j=f[c+40>>2]|0;p=0;o=1;while(1){r=Y(f[j+(p<<2)>>2]|0,o)|0;p=p+1|0;if((p|0)==(n|0)){s=r;break}else o=r}}if((q|0)!=(s|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=$Xc(32)|0;f[h>>2]=s;f[h+8>>2]=-2147483616;f[h+4>>2]=28;k=s;l=377815;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[s+28>>0]=0;vM(-215,h,379781,377558,470)}s=f[c+16>>2]|0;c=g+16|0;q=f[c>>2]|0;o=f[e>>2]|0;n=f[o>>2]|0;p=f[o+4>>2]|0;j=f[o+8>>2]|0;r=f[o+12>>2]|0;o=Y(p,n)|0;t=Y(Y(o,j)|0,r)|0;a:do if((n|0)>0){v=(p|0)>0;w=(j|0)>0;x=(r|0)>0;y=0;b:while(1){if(v?(z=Y(y,p)|0,w):0){A=0;do{B=Y(A+z|0,j)|0;C=(Y(A,n)|0)+y|0;if(x){D=0;do{E=Y(B+D|0,r)|0;F=Y(D,r)|0;G=0;do{H=G+E|0;I=C+(Y(G+F|0,o)|0)|0;if((H|0)>=(t|0)){J=40;break b}if((I|0)>=(t|0)){J=41;break b}f[s+(H<<2)>>2]=f[q+(I<<2)>>2];G=G+1|0}while((G|0)<(r|0));D=D+1|0}while((D|0)<(j|0))}A=A+1|0}while((A|0)<(p|0))}y=y+1|0;if((y|0)>=(n|0))break a}if((J|0)==40){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(16)|0;f[h>>2]=y;f[h+8>>2]=-2147483632;f[h+4>>2]=13;k=y;l=377856;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[y+13>>0]=0;vM(-215,h,379781,377558,483)}else if((J|0)==41){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;k=x;l=377870;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[x+13>>0]=0;vM(-215,h,379781,377558,484)}}while(0);h=g+36|0;l=f[h>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)V$(g);f[h>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))wL(a);a=f[e>>2]|0;if(!a){u=d;return}e=f[i>>2]|0;if((e|0)!=(a|0))f[i>>2]=e+(~((e+-4-a|0)>>>2)<<2);cYc(a);u=d;return}function FIa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;e=h;i=TIa(c,e,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=h;return}d=$Xc(84)|0;lYc(d+16|0,f[g>>2]|0);f[d+28>>2]=1124007936;g=d+36|0;n=d+68|0;o=d+32|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=g;g=d+76|0;f[d+72>>2]=g;f[g>>2]=0;f[d+80>>2]=0;g=f[e>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=g;f[i>>2]=d;g=f[f[c>>2]>>2]|0;if(!g)q=d;else{f[c>>2]=g;q=f[i>>2]|0}UQ(f[c+4>>2]|0,q);q=c+8|0;f[q>>2]=(f[q>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=h;return}function GIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+48|0;e=d;g=d+28|0;h=d+16|0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=7;b[h>>0]=b[390066]|0;b[h+1>>0]=b[390067]|0;b[h+2>>0]=b[390068]|0;b[h+3>>0]=b[390069]|0;b[h+4>>0]=b[390070]|0;b[h+5>>0]=b[390071]|0;b[h+6>>0]=b[390072]|0;b[h+7>>0]=0;j=c+24|0;elc(j);k=c+48|0;xIa(g,k);yIa(e,f[g+8>>2]|0,h,0);l=(f[e>>2]|0)==0;zIa(g);if((b[i>>0]|0)<0)cYc(f[h>>2]|0);if(l){u=d;return}f[e+8>>2]=0;l=e+11|0;b[l>>0]=7;b[e>>0]=b[390066]|0;b[e+1>>0]=b[390067]|0;b[e+2>>0]=b[390068]|0;b[e+3>>0]=b[390069]|0;b[e+4>>0]=b[390070]|0;b[e+5>>0]=b[390071]|0;b[e+6>>0]=b[390072]|0;b[e+7>>0]=0;elc(j);j=AIa(k,e)|0;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);l=(oIa(c)|0)==1;c=l?3:2;k=l?2:1;h=l?1:3;l=j+20|0;i=(f[l>>2]|0)==1;m=j+8|0;j=i?f[m>>2]|0:530552;if((f[j+24>>2]|0)!=4){n=$Xc(32)|0;f[e>>2]=n;o=e+8|0;f[o>>2]=-2147483616;p=e+4|0;f[p>>2]=19;q=n;r=379670;s=q+19|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+19|0;b[t>>0]=0;vM(-2,e,379690,377558,296)}v=f[j+32>>2]|0;j=v+8|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){n=$Xc(32)|0;f[e>>2]=n;o=e+8|0;f[o>>2]=-2147483616;p=e+4|0;f[p>>2]=19;q=n;r=379670;s=q+19|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+19|0;b[t>>0]=0;vM(-2,e,379690,377558,296)}j=v+8+(h<<3)|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){n=$Xc(32)|0;f[e>>2]=n;o=e+8|0;f[o>>2]=-2147483616;p=e+4|0;f[p>>2]=19;q=n;r=379670;s=q+19|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+19|0;b[t>>0]=0;vM(-2,e,379690,377558,296)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=8;n=e;f[n>>2]=1769108595;f[n+4>>2]=1751082340;b[e+8>>0]=0;f[g>>2]=f[(f[(i?f[m>>2]|0:530552)+32>>2]|0)+8+(k<<3)>>2];aHa(a,e,g)|0;if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=8;k=e;f[k>>2]=1769108595;f[k+4>>2]=2002740580;b[e+8>>0]=0;f[g>>2]=f[(f[((f[l>>2]|0)==1?f[m>>2]|0:530552)+32>>2]|0)+8+(c<<3)>>2];aHa(a,e,g)|0;if((b[t>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}function HIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=f[a+4>>2]|0;if(!d){e=0;return e|0}a=b[c+11>>0]|0;g=a<<24>>24<0;h=g?f[c+4>>2]|0:a&255;a=g?f[c>>2]|0:c;c=d;while(1){d=c+16|0;g=b[d+11>>0]|0;i=g<<24>>24<0;j=i?f[c+20>>2]|0:g&255;g=j>>>0<h>>>0;k=g?j:h;if((k|0)!=0?(l=WKc(a,i?f[d>>2]|0:d,k)|0,(l|0)!=0):0)if((l|0)<0)m=7;else m=8;else if(h>>>0<j>>>0)m=7;else m=8;if((m|0)==7){m=0;n=c}else if((m|0)==8){m=0;l=h>>>0<j>>>0?h:j;if((l|0)!=0?(j=WKc(i?f[d>>2]|0:d,a,l)|0,(j|0)!=0):0){if((j|0)>=0){e=1;m=14;break}}else m=10;if((m|0)==10?(m=0,!g):0){e=1;m=14;break}n=c+4|0}c=f[n>>2]|0;if(!c){e=0;m=14;break}}if((m|0)==14)return e|0;return 0}function IIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+48|0;e=d;g=d+28|0;h=d+16|0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=7;b[h>>0]=b[435010]|0;b[h+1>>0]=b[435011]|0;b[h+2>>0]=b[435012]|0;b[h+3>>0]=b[435013]|0;b[h+4>>0]=b[435014]|0;b[h+5>>0]=b[435015]|0;b[h+6>>0]=b[435016]|0;b[h+7>>0]=0;j=c+24|0;elc(j);k=c+48|0;xIa(g,k);yIa(e,f[g+8>>2]|0,h,0);c=(f[e>>2]|0)==0;zIa(g);if((b[i>>0]|0)<0)cYc(f[h>>2]|0);if(c){u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=e+11|0;b[c>>0]=8;h=e;f[h>>2]=1600414064;f[h+4>>2]=1701080941;b[e+8>>0]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=7;b[g>>0]=b[435010]|0;b[g+1>>0]=b[435011]|0;b[g+2>>0]=b[435012]|0;b[g+3>>0]=b[435013]|0;b[g+4>>0]=b[435014]|0;b[g+5>>0]=b[435015]|0;b[g+6>>0]=b[435016]|0;b[g+7>>0]=0;elc(j);j=AIa(k,g)|0;_Ga(a,e,(f[j+20>>2]|0)==2?f[j+8>>2]|0:537368)|0;if((b[h>>0]|0)<0)cYc(f[g>>2]|0);if((b[c>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}function JIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;tYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;tYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function KIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+48|0;e=d;g=d+28|0;h=d+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=5;b[h>>0]=b[379637]|0;b[h+1>>0]=b[379638]|0;b[h+2>>0]=b[379639]|0;b[h+3>>0]=b[379640]|0;b[h+4>>0]=b[379641]|0;b[h+5>>0]=0;j=c+24|0;elc(j);k=c+48|0;xIa(g,k);yIa(e,f[g+8>>2]|0,h,0);l=(f[e>>2]|0)==0;zIa(g);if((b[i>>0]|0)<0)cYc(f[h>>2]|0);if(l){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=e+11|0;b[l>>0]=8;h=e;f[h>>2]=1852990827;f[h+4>>2]=1751084133;b[e+8>>0]=0;f[g>>2]=1;aHa(a,e,g)|0;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=e+11|0;b[l>>0]=8;h=e;f[h>>2]=1852990827;f[h+4>>2]=2002742373;b[e+8>>0]=0;f[g>>2]=1;aHa(a,e,g)|0;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=e+11|0;b[l>>0]=5;b[e>>0]=b[379637]|0;b[e+1>>0]=b[379638]|0;b[e+2>>0]=b[379639]|0;b[e+3>>0]=b[379640]|0;b[e+4>>0]=b[379641]|0;b[e+5>>0]=0;elc(j);j=AIa(k,e)|0;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);l=(oIa(c)|0)==1;c=l?3:2;k=l?2:1;h=l?1:3;l=j+20|0;i=(f[l>>2]|0)==1;m=j+8|0;j=i?f[m>>2]|0:530552;if((f[j+24>>2]|0)!=4){n=$Xc(32)|0;f[e>>2]=n;o=e+8|0;f[o>>2]=-2147483616;p=e+4|0;f[p>>2]=17;q=n;r=379643;s=q+17|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+17|0;b[t>>0]=0;vM(-2,e,379661,377558,333)}v=f[j+32>>2]|0;j=v+8|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){n=$Xc(32)|0;f[e>>2]=n;o=e+8|0;f[o>>2]=-2147483616;p=e+4|0;f[p>>2]=17;q=n;r=379643;s=q+17|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+17|0;b[t>>0]=0;vM(-2,e,379661,377558,333)}j=v+8+(h<<3)|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0)){n=$Xc(32)|0;f[e>>2]=n;o=e+8|0;f[o>>2]=-2147483616;p=e+4|0;f[p>>2]=17;q=n;r=379643;s=q+17|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+17|0;b[t>>0]=0;vM(-2,e,379661,377558,333)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=8;n=e;f[n>>2]=1852990827;f[n+4>>2]=1751084133;b[e+8>>0]=0;f[g>>2]=f[(f[(i?f[m>>2]|0:530552)+32>>2]|0)+8+(k<<3)>>2];aHa(a,e,g)|0;if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=8;k=e;f[k>>2]=1852990827;f[k+4>>2]=2002742373;b[e+8>>0]=0;f[g>>2]=f[(f[((f[l>>2]|0)==1?f[m>>2]|0:530552)+32>>2]|0)+8+(c<<3)>>2];aHa(a,e,g)|0;if((b[t>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}function LIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){l=d;m=f[l>>2]|0;n=f[l+4>>2]|0;f[g>>2]=0;l=$Xc(16)|0;o=l+8|0;f[l>>2]=o;f[l+4>>2]=1;f[g+4>>2]=l;l=o;f[l>>2]=m;f[l+4>>2]=n;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}k=d;n=f[k>>2]|0;l=f[k+4>>2]|0;f[j>>2]=0;k=$Xc(16)|0;m=k+8|0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;k=m;f[k>>2]=n;f[k+4>>2]=l;lYc(i,c);c=i+12|0;VGa(c,j);l=WGa(a,g,i)|0;if(!(f[l>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[l>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)p=g;else{f[a>>2]=k;p=f[l>>2]|0}UQ(f[a+4>>2]|0,p);p=a+8|0;f[p>>2]=(f[p>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function MIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;tYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;tYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function NIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+32|0;d=c+12|0;e=c;g=LGa(a,b)|0;if((g|0)==(a+4|0)){SGa(e,379562,b);b=AYc(e,379582)|0;f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2];f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;vM(-204,d,379488,455383,349)}else{u=c;return g+28|0}return 0}function OIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;if((f[c>>2]|0)!=3){b[g+11>>0]=10;h=g;i=379477;j=h+10|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+10>>0]=0;vM(-215,g,379488,455383,178)}k=(d|0)==-1;if(k){l=f[c+4>>2]|0;if((f[l+4>>2]|0)==1){m=l;n=k?0:d;o=f[m>>2]|0;p=o+(n*12|0)|0;lYc(a,p);u=e;return}}else if((d|0)>-1?(l=f[c+4>>2]|0,(f[l+4>>2]|0)>(d|0)):0){m=l;n=k?0:d;o=f[m>>2]|0;p=o+(n*12|0)|0;lYc(a,p);u=e;return}e=$Xc(80)|0;f[g>>2]=e;f[g+8>>2]=-2147483568;f[g+4>>2]=69;h=e;i=379492;j=h+69|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[e+69>>0]=0;vM(-215,g,379488,455383,179)}function PIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;tYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;tYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function QIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;tYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;tYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function RIa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+16>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+16>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);yIa(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function SIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if(!c)return;SIa(a,f[c>>2]|0);SIa(a,f[c+4>>2]|0);a=c+16|0;d=c+28|0;e=c+64|0;g=f[e>>2]|0;if(g|0?(h=g+12|0,g=f[h>>2]|0,f[h>>2]=g+-1,(g|0)==1):0)V$(d);f[e>>2]=0;e=c+44|0;d=c+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[c+68>>2]|0;g=0;do{f[e+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[d>>2]|0))}d=f[c+72>>2]|0;if((d|0)!=(c+76|0))wL(d);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function TIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function UIa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+16>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+16>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);yIa(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function VIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+8|0;g=d;h=f[c+4>>2]|0;i=c+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=h+16|0;l=f[k>>2]|0;m=f[l+(j<<2)>>2]|0;n=f[c>>2]|0;a:do if((m|0)!=(n|0)){b:do if(m|0?(m|0)!=(f[l+((j^1)<<2)>>2]|0):0){c=m;while(1){c=f[c+16>>2]|0;if(!c)break b;if((c|0)==(n|0)){o=j;p=7;break a}}}while(0);yIa(e,h,n,g);c=f[e+8>>2]|0;f[i>>2]=c;q=f[k>>2]|0;r=f[q+(c<<2)>>2]|0;if(r){s=a+16|0;t=(f[s>>2]|0)+(c<<2)|0;if((r|0)==(f[q+((c^1)<<2)>>2]|0)){q=f[t>>2]|0;_Ia(q,(f[g>>2]|0)+16|0)|0;if(!(f[q+12>>2]|0)){r=c&-2;v=f[a+20>>2]|0;YIa(q,f[q+4>>2]|0);if(!v)cYc(q);f[(f[s>>2]|0)+((c|1)<<2)>>2]=0;f[(f[s>>2]|0)+(r<<2)>>2]=0;w=r;x=s}else{w=c;x=s}}else{y=t;z=s;A=c;p=9}}else{o=c;p=7}}else{o=j;p=7}while(0);if((p|0)==7){j=a+16|0;y=(f[j>>2]|0)+(o<<2)|0;z=j;A=o;p=9}if((p|0)==9){o=ZIa(a,n,f[y>>2]|0)|0;f[(f[z>>2]|0)+(A<<2)>>2]=o;w=A;x=z}if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if(!(f[a+20>>2]|0))cYc(n);f[a>>2]=(f[a>>2]|0)+-1;n=a+12|0;if((w|0)!=(f[n>>2]|0)){u=d;return}z=f[a+4>>2]|0;if(w>>>0>=z>>>0){u=d;return}a=f[x>>2]|0;x=w;while(1){if(f[a+(x<<2)>>2]|0){p=23;break}x=x+1|0;f[n>>2]=x;if(x>>>0>=z>>>0){p=23;break}}if((p|0)==23){u=d;return}}function WIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!(f[c>>2]|0)){d=0;f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}g=a+16|0;h=a+20|0;i=0;while(1){j=f[g>>2]|0;k=j+(i<<2)|0;l=f[k>>2]|0;a:do if(l){if((l|0)!=(f[j+((i^1)<<2)>>2]|0)){f[k>>2]=0;m=l;while(1){n=m;m=f[m+16>>2]|0;if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if(!(f[h>>2]|0))cYc(n);if(!m){o=i;break a}}}if((l|0)==(f[j+((i^1)<<2)>>2]|0)){m=i+1|0;f[j+(m<<2)>>2]=0;f[(f[g>>2]|0)+(i<<2)>>2]=0;n=l+12|0;p=l+4|0;q=l+8|0;r=l+4|0;s=f[l>>2]|0;do{t=s;u=f[t+16>>2]|0;v=s;w=f[v+4>>2]|0;if(!w){x=v+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(v|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=w;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}w=f[t+4>>2]|0;if(!w){A=t+8|0;x=f[A>>2]|0;if((f[x>>2]|0)==(v|0))B=x;else{x=A;do{A=f[x>>2]|0;x=A+8|0;C=f[x>>2]|0}while((f[C>>2]|0)!=(A|0));B=C}}else{x=w;while(1){y=f[x>>2]|0;if(!y)break;else x=y}B=x}if((f[l>>2]|0)==(t|0))f[l>>2]=B;f[n>>2]=(f[n>>2]|0)+-1;XIa(f[p>>2]|0,v);if(!(f[q>>2]|0))cYc(s);s=z;if((b[u+11>>0]|0)<0)cYc(f[u>>2]|0);if(!(f[h>>2]|0))cYc(u)}while((z|0)!=(r|0));s=f[h>>2]|0;YIa(l,f[r>>2]|0);if(!s){cYc(l);o=m}else o=m}else o=i}else o=i;while(0);i=o+1|0;l=f[c>>2]|0;if(i>>>0>=l>>>0){d=l;break}}f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}function XIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[c>>2]|0;if(d){e=f[c+4>>2]|0;if(!e){g=c;h=d}else{d=e;while(1){e=f[d>>2]|0;if(!e){g=d;h=0;break}else d=e}}}else{g=c;h=0}d=g+4|0;e=f[(h|0?g:d)>>2]|0;h=(e|0)!=0;i=g+8|0;if(h)f[e+8>>2]=f[i>>2];j=f[i>>2]|0;if((f[j>>2]|0)==(g|0)){f[j>>2]=e;if((g|0)==(a|0)){k=e;l=0}else{m=j+4|0;n=10}}else{f[j+4>>2]=e;m=j;n=10}if((n|0)==10){k=a;l=f[m>>2]|0}m=g+12|0;a=(b[m>>0]|0)!=0;if((g|0)==(c|0))o=k;else{j=c+8|0;p=f[j>>2]|0;f[i>>2]=p;f[((f[f[j>>2]>>2]|0)==(c|0)?p:p+4|0)>>2]=g;p=f[c>>2]|0;f[g>>2]=p;f[p+8>>2]=g;p=f[c+4>>2]|0;f[d>>2]=p;if(p|0)f[p+8>>2]=g;b[m>>0]=b[c+12>>0]|0;o=(k|0)==(c|0)?g:k}if(!(a&(o|0)!=0))return;if(h){b[e+12>>0]=1;return}else{q=l;r=o}while(1){o=f[q+8>>2]|0;l=q+12|0;e=(b[l>>0]|0)!=0;if((f[o>>2]|0)==(q|0)){if(e){s=q;t=r}else{b[l>>0]=1;b[o+12>>0]=0;h=f[o>>2]|0;a=h+4|0;k=f[a>>2]|0;f[o>>2]=k;if(k|0)f[k+8>>2]=o;k=o+8|0;f[h+8>>2]=f[k>>2];g=f[k>>2]|0;f[((f[g>>2]|0)==(o|0)?g:g+4|0)>>2]=h;f[a>>2]=o;f[k>>2]=h;h=f[q+4>>2]|0;s=f[h>>2]|0;t=(r|0)==(h|0)?q:r}u=f[s>>2]|0;v=(u|0)==0;if(!v?(b[u+12>>0]|0)==0:0){w=s;x=u;n=55;break}y=s+4|0;z=f[y>>2]|0;if(z|0?(b[z+12>>0]|0)==0:0){n=49;break}b[s+12>>0]=0;h=f[s+8>>2]|0;A=h+12|0;if((h|0)==(t|0)|(b[A>>0]|0)==0){n=48;break}else{B=t;C=h}}else{if(e){D=q;E=r}else{b[l>>0]=1;b[o+12>>0]=0;l=o+4|0;e=f[l>>2]|0;h=f[e>>2]|0;f[l>>2]=h;if(h|0)f[h+8>>2]=o;h=o+8|0;f[e+8>>2]=f[h>>2];l=f[h>>2]|0;f[((f[l>>2]|0)==(o|0)?l:l+4|0)>>2]=e;f[e>>2]=o;f[h>>2]=e;e=f[q>>2]|0;D=f[e+4>>2]|0;E=(r|0)==(e|0)?q:r}F=f[D>>2]|0;if(F|0?(b[F+12>>0]|0)==0:0){n=31;break}e=f[D+4>>2]|0;if(e|0?(b[e+12>>0]|0)==0:0){G=e;n=32;break}b[D+12>>0]=0;e=f[D+8>>2]|0;if((e|0)==(E|0)){H=E;n=30;break}if(!(b[e+12>>0]|0)){H=e;n=30;break}else{B=E;C=e}}e=f[C+8>>2]|0;q=f[((f[e>>2]|0)==(C|0)?e+4|0:e)>>2]|0;r=B}do if((n|0)==30){b[H+12>>0]=1;return}else if((n|0)==31){B=f[D+4>>2]|0;if(!B)n=33;else{G=B;n=32}}else if((n|0)==48){b[A>>0]=1;return}else if((n|0)==49){if(v){I=y;J=z}else{if(!(b[u+12>>0]|0)){w=s;x=u;n=55;break}B=s+4|0;I=B;J=f[B>>2]|0}b[J+12>>0]=1;b[s+12>>0]=0;B=f[J>>2]|0;f[I>>2]=B;if(B|0)f[B+8>>2]=s;B=s+8|0;f[J+8>>2]=f[B>>2];r=f[B>>2]|0;f[((f[r>>2]|0)==(s|0)?r:r+4|0)>>2]=J;f[J>>2]=s;f[B>>2]=J;w=J;x=s;n=55}while(0);if((n|0)==32)if(!(b[G+12>>0]|0)){K=D;L=G}else n=33;else if((n|0)==55){G=f[w+8>>2]|0;s=G+12|0;b[w+12>>0]=b[s>>0]|0;b[s>>0]=1;b[x+12>>0]=1;x=f[G>>2]|0;s=x+4|0;w=f[s>>2]|0;f[G>>2]=w;if(w|0)f[w+8>>2]=G;w=G+8|0;f[x+8>>2]=f[w>>2];J=f[w>>2]|0;f[((f[J>>2]|0)==(G|0)?J:J+4|0)>>2]=x;f[s>>2]=G;f[w>>2]=x;return}if((n|0)==33){b[F+12>>0]=1;b[D+12>>0]=0;n=F+4|0;x=f[n>>2]|0;f[D>>2]=x;if(x|0)f[x+8>>2]=D;x=D+8|0;f[F+8>>2]=f[x>>2];w=f[x>>2]|0;f[((f[w>>2]|0)==(D|0)?w:w+4|0)>>2]=F;f[n>>2]=D;f[x>>2]=F;K=F;L=D}D=f[K+8>>2]|0;F=D+12|0;b[K+12>>0]=b[F>>0]|0;b[F>>0]=1;b[L+12>>0]=1;L=D+4|0;F=f[L>>2]|0;K=f[F>>2]|0;f[L>>2]=K;if(K|0)f[K+8>>2]=D;K=D+8|0;f[F+8>>2]=f[K>>2];L=f[K>>2]|0;f[((f[L>>2]|0)==(D|0)?L:L+4|0)>>2]=F;f[F>>2]=D;f[K>>2]=F;return}function YIa(a,b){a=a|0;b=b|0;if(!b)return;YIa(a,f[b>>2]|0);YIa(a,f[b+4>>2]|0);if(f[a+8>>2]|0)return;cYc(b);return}function ZIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=c+16|0;e=f[d>>2]|0;if((c|0)==(b|0))return e|0;else{g=ZIa(a,b,e)|0;f[d>>2]=g;return c|0}return 0}function _Ia(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=$Ia(a,c,f[d>>2]|0,d)|0;if((e|0)==(d|0)){g=0;return g|0}d=f[c>>2]|0;c=f[e+16>>2]|0;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c+4>>2]|0:h&255;h=b[d+11>>0]|0;k=h<<24>>24<0;l=k?f[d+4>>2]|0:h&255;h=j>>>0<l>>>0?j:l;if((h|0)!=0?(m=WKc(k?f[d>>2]|0:d,i?f[c>>2]|0:c,h)|0,(m|0)!=0):0){if((m|0)<0){g=0;return g|0}}else n=4;if((n|0)==4?l>>>0<j>>>0:0){g=0;return g|0}j=f[e+4>>2]|0;if(!j){l=e+8|0;n=f[l>>2]|0;if((f[n>>2]|0)==(e|0))o=n;else{n=l;do{l=f[n>>2]|0;n=l+8|0;m=f[n>>2]|0}while((f[m>>2]|0)!=(l|0));o=m}}else{n=j;while(1){j=f[n>>2]|0;if(!j)break;else n=j}o=n}if((f[a>>2]|0)==(e|0))f[a>>2]=o;o=a+12|0;f[o>>2]=(f[o>>2]|0)+-1;XIa(f[a+4>>2]|0,e);if(f[a+8>>2]|0){g=1;return g|0}cYc(e);g=1;return g|0}function $Ia(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=f[c>>2]|0;c=b[a+11>>0]|0;h=c<<24>>24<0;i=h?f[a+4>>2]|0:c&255;if(h){h=e;c=d;a:while(1){j=c;while(1){k=f[j+16>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[k+4>>2]|0:l&255;l=i>>>0<n>>>0?i:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,f[a>>2]|0,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=7;if((p|0)==7?(p=0,n>>>0>=i>>>0):0)break;n=f[j+4>>2]|0;if(!n){g=h;p=17;break a}else j=n}c=f[j>>2]|0;if(!c){g=j;p=17;break}else h=j}if((p|0)==17)return g|0}else{h=e;e=d;b:while(1){d=e;while(1){c=f[d+16>>2]|0;n=b[c+11>>0]|0;o=n<<24>>24<0;l=o?f[c+4>>2]|0:n&255;n=i>>>0<l>>>0?i:l;if((n|0)!=0?(k=WKc(o?f[c>>2]|0:c,a,n)|0,(k|0)!=0):0){if((k|0)>=0)break}else p=13;if((p|0)==13?(p=0,l>>>0>=i>>>0):0)break;l=f[d+4>>2]|0;if(!l){g=h;p=17;break b}else d=l}e=f[d>>2]|0;if(!e){g=d;p=17;break}else h=d}if((p|0)==17)return g|0}return 0}function aJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a>>2]|0;c=b;if(!b){d=$Xc(24)|0;f[d>>2]=0;f[d+8>>2]=d;e=d+16|0;f[e>>2]=0;f[d+20>>2]=c;g=$Xc(32)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;h=g;i=d;j=e;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}e=b+64|0;if(f[e>>2]|0)SXb(b,14424,24);d=RXb(b,24,2238)|0;f[d>>2]=0;f[d+8>>2]=d;g=d+16|0;f[g>>2]=0;f[d+20>>2]=c;if(f[e>>2]|0)SXb(b,25480,32);e=QXb(b,32)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=e;i=d;j=g;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}function bJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[a+8>>2]|0;lYc(e,c);f[e+12>>2]=0;cJa(g,h,e);h=(f[g>>2]|0)+12|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);e=f[h>>2]|0;if(e|0){i=e;j=i+16|0;u=d;return j|0}e=dJa(a,c)|0;f[h>>2]=e;i=e;j=i+16|0;u=d;return j|0}function cJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;yIa(g,c,d,0);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;b[a+12>>0]=0;u=e;return}k=(f[c>>2]|0)+1|0;j=f[c+4>>2]|0;i=j*12|0;l=i>>>4;if(l>>>0>k>>>0){if(j>>>0>8&i>>>6>>>0>=k>>>0){i=((k*5|0)>>>2)+1|0;k=1;while(1)if(i<<k>>>0<l>>>0)k=k+1|0;else break;l=j>>>k;k=l>>>0>8?l:8;if((k|0)!=(j|0)){fJa(c,k);m=11}}}else if(j>>>0<=134217728){fJa(c,j<<1);m=11}if((m|0)==11){yIa(h,c,d,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2]}m=f[g+12>>2]|0;g=f[c+20>>2]|0;if(!g)n=$Xc(20)|0;else{if(f[g+64>>2]|0)SXb(g,25480,24);n=QXb(g,24)|0}lYc(n,d);f[n+12>>2]=f[d+12>>2];gJa(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];b[a+12>>0]=1;u=e;return}function dJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=$Xc(40)|0;lYc(d,b);ISa(d+16|0);e=d;return e|0}if(f[c+64>>2]|0)SXb(c,25480,40);d=QXb(c,40)|0;c=f[a>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;eJa(c,d);JSa(d+16|0,f[a>>2]|0);oYc(d,b)|0;e=d;return e|0}function eJa(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2233);return}function fJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;i=a+4|0;j=f[i>>2]|0;f[i>>2]=c;k=a+20|0;l=f[k>>2]|0;m=c<<2;if(!l)n=$Xc(m)|0;else{c=m+7&-8;if(f[l+64>>2]|0)SXb(l,25480,c);n=QXb(l,c)|0}g1c(n|0,0,m|0)|0;f[g>>2]=n;n=a+12|0;g=f[n>>2]|0;f[n>>2]=f[i>>2];if(g>>>0<j>>>0){n=a+8|0;m=g;do{g=f[h+(m<<2)>>2]|0;do if(!g)o=m;else{if((g|0)==(f[h+((m^1)<<2)>>2]|0)){mJa(a,h,m);o=m+1|0;break}c=g;do{l=c;c=f[c+16>>2]|0;p=(b[l+11>>0]|0)<0?f[l>>2]|0:l;q=b[p>>0]|0;if(!(q<<24>>24))r=0;else{s=p;p=0;t=q;while(1){q=(p*5|0)+(t<<24>>24)|0;s=s+1|0;t=b[s>>0]|0;if(!(t<<24>>24)){r=q;break}else p=q}}gJa(e,a,(f[i>>2]|0)+-1&(f[n>>2]|0)+r,l)}while((c|0)!=0);o=m}while(0);m=o+1|0}while(m>>>0<j>>>0)}if(f[k>>2]|0){u=d;return}cYc(h);u=d;return}function gJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e+8|0;h=e;i=b+16|0;j=f[i>>2]|0;k=j+(c<<2)|0;l=f[k>>2]|0;m=l;do if(!l){f[d+16>>2]=m;f[k>>2]=d;n=d;o=c}else{if((l|0)==(f[j+((c^1)<<2)>>2]|0)){f[d+16>>2]=0;p=f[k>>2]|0;f[h>>2]=d;iJa(g,p,h,h);f[a>>2]=f[(f[g>>2]|0)+16>>2];f[a+4>>2]=b;f[a+8>>2]=c&-2;u=e;return}p=l;q=0;do{q=q+1|0;p=f[p+16>>2]|0}while((p|0)!=0);if(q>>>0>7){hJa(b,c);f[d+16>>2]=0;p=f[(f[i>>2]|0)+(c<<2)>>2]|0;f[h>>2]=d;iJa(g,p,h,h);n=f[(f[g>>2]|0)+16>>2]|0;o=c&-2;break}f[d+16>>2]=m;f[k>>2]=d;f[a>>2]=d;f[a+4>>2]=b;f[a+8>>2]=c;u=e;return}while(0);c=b+12|0;d=f[c>>2]|0;f[c>>2]=o>>>0<d>>>0?o:d;f[a>>2]=n;f[a+4>>2]=b;f[a+8>>2]=o;u=e;return}function hJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+32|0;d=c+24|0;e=c+16|0;g=c;h=a+20|0;i=f[h>>2]|0;if(!i)j=$Xc(16)|0;else{if(f[i+64>>2]|0)SXb(i,25480,16);j=QXb(i,16)|0}i=f[h>>2]|0;f[g+4>>2]=0;f[g+8>>2]=i;f[g+12>>2]=0;i=g+4|0;f[g>>2]=i;f[j>>2]=0;h=f[g+8>>2]|0;k=j+4|0;f[k>>2]=0;f[j+8>>2]=h;f[j+12>>2]=0;f[j>>2]=k;h=f[g>>2]|0;if((h|0)!=(i|0)){l=k;k=h;while(1){h=k+16|0;f[e>>2]=l;f[d>>2]=f[e>>2];kJa(j,d,h,h)|0;h=f[k+4>>2]|0;if(!h){m=k+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(k|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=h;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}if((o|0)==(i|0))break;else k=o}}YIa(g,f[i>>2]|0);i=a+16|0;a=f[i>>2]|0;g=f[a+(b<<2)>>2]|0;if(!g)q=a;else{a=g;do{f[e>>2]=a;iJa(d,j,e,e);g=a+16|0;a=f[g>>2]|0;f[g>>2]=0}while((a|0)!=0);q=f[i>>2]|0}a=b^1;g=f[q+(a<<2)>>2]|0;if(!g){r=q;s=r+(a<<2)|0;f[s>>2]=j;t=f[i>>2]|0;v=t+(b<<2)|0;f[v>>2]=j;u=c;return}q=g;do{f[e>>2]=q;iJa(d,j,e,e);g=q+16|0;q=f[g>>2]|0;f[g>>2]=0}while((q|0)!=0);r=f[i>>2]|0;s=r+(a<<2)|0;f[s>>2]=j;t=f[i>>2]|0;v=t+(b<<2)|0;f[v>>2]=j;u=c;return}function iJa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=jJa(c,h,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}d=f[c+8>>2]|0;if(!d)n=$Xc(20)|0;else{if(f[d+64>>2]|0)SXb(d,25480,24);n=QXb(d,24)|0}f[n+16>>2]=f[e>>2];e=f[h>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=e;f[i>>2]=n;e=f[f[c>>2]>>2]|0;if(!e)o=n;else{f[c>>2]=e;o=f[i>>2]|0}UQ(f[c+4>>2]|0,o);o=c+12|0;f[o>>2]=(f[o>>2]|0)+1;j=n;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}function jJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=a+4|0;g=f[e>>2]|0;h=a+4|0;if(!g){f[c>>2]=e;i=e;return i|0}e=f[d>>2]|0;d=b[e+11>>0]|0;a=d<<24>>24<0;j=f[e+4>>2]|0;k=d&255;d=a?j:k;a:do if(a){l=h;m=g;while(1){n=f[m+16>>2]|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[n+4>>2]|0:o&255;o=q>>>0<d>>>0?q:d;if((o|0)!=0?(r=WKc(f[e>>2]|0,p?f[n>>2]|0:n,o)|0,(r|0)!=0):0)if((r|0)<0)s=12;else s=7;else if(d>>>0<q>>>0)s=12;else s=7;if((s|0)==7){s=0;r=j>>>0<q>>>0?j:q;if((r|0)!=0?(o=WKc(p?f[n>>2]|0:n,f[e>>2]|0,r)|0,(o|0)!=0):0){if((o|0)>=0){t=l;u=m;s=27;break a}}else s=10;if((s|0)==10?(s=0,q>>>0>=j>>>0):0){t=l;u=m;s=27;break a}q=m+4|0;o=f[q>>2]|0;if(!o){v=m;w=q;s=26;break a}else{x=q;y=o}}else if((s|0)==12){s=0;o=f[m>>2]|0;if(!o){z=m;A=m;s=20;break a}else{x=m;y=o}}l=x;m=y}}else{m=h;l=g;while(1){o=f[l+16>>2]|0;q=b[o+11>>0]|0;r=q<<24>>24<0;n=r?f[o+4>>2]|0:q&255;q=n>>>0<d>>>0?n:d;if((q|0)!=0?(p=WKc(e,r?f[o>>2]|0:o,q)|0,(p|0)!=0):0)if((p|0)<0)s=19;else s=21;else if(d>>>0<n>>>0)s=19;else s=21;if((s|0)==19){s=0;p=f[l>>2]|0;if(!p){z=l;A=l;s=20;break a}else{B=l;C=p}}else if((s|0)==21){s=0;p=k>>>0<n>>>0?k:n;if((p|0)!=0?(q=WKc(r?f[o>>2]|0:o,e,p)|0,(q|0)!=0):0){if((q|0)>=0){t=m;u=l;s=27;break a}}else s=23;if((s|0)==23?(s=0,n>>>0>=k>>>0):0){t=m;u=l;s=27;break a}n=l+4|0;q=f[n>>2]|0;if(!q){v=l;w=n;s=26;break a}else{B=n;C=q}}m=B;l=C}}while(0);if((s|0)==20){f[c>>2]=z;i=A;return i|0}else if((s|0)==26){f[c>>2]=v;i=w;return i|0}else if((s|0)==27){f[c>>2]=u;i=t;return i|0}return 0}function kJa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;f[i>>2]=f[b>>2];f[g>>2]=f[i>>2];i=lJa(a,g,h,e+4|0,c)|0;c=f[i>>2]|0;if(c|0){j=c;u=e;return j|0}c=f[a+8>>2]|0;if(!c)k=$Xc(20)|0;else{if(f[c+64>>2]|0)SXb(c,25480,24);k=QXb(c,24)|0}f[k+16>>2]=f[d>>2];d=f[h>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=d;f[i>>2]=k;d=f[f[a>>2]>>2]|0;if(!d)l=k;else{f[a>>2]=d;l=f[i>>2]|0}UQ(f[a+4>>2]|0,l);l=a+12|0;f[l>>2]=(f[l>>2]|0)+1;j=k;u=e;return j|0}function lJa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=f[g>>2]|0;k=f[i+16>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[k+4>>2]|0:l&255;l=b[j+11>>0]|0;o=l<<24>>24<0;p=o?f[j+4>>2]|0:l&255;l=n>>>0<p>>>0;q=l?n:p;if((q|0)!=0?(r=WKc(o?f[j>>2]|0:j,m?f[k>>2]|0:k,q)|0,(r|0)!=0):0){if((r|0)<0)break}else s=4;if((s|0)==4?p>>>0<n>>>0:0)break;r=p>>>0<n>>>0?p:n;if((r|0)!=0?(n=WKc(m?f[k>>2]|0:k,o?f[j>>2]|0:j,r)|0,(n|0)!=0):0){if((n|0)>=0)s=36}else s=20;if((s|0)==20?!l:0)s=36;if((s|0)==36){f[d>>2]=c;f[e>>2]=c;t=e;return t|0}l=i+4|0;n=f[l>>2]|0;if(!n){r=i+8|0;k=f[r>>2]|0;if((f[k>>2]|0)==(i|0))u=k;else{k=r;do{r=f[k>>2]|0;k=r+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(r|0));u=m}}else{k=n;while(1){m=f[k>>2]|0;if(!m)break;else k=m}u=k}do if((u|0)!=(h|0)){n=f[u+16>>2]|0;m=b[n+11>>0]|0;r=m<<24>>24<0;q=r?f[n+4>>2]|0:m&255;m=q>>>0<p>>>0?q:p;if((m|0)!=0?(v=WKc(o?f[j>>2]|0:j,r?f[n>>2]|0:n,m)|0,(v|0)!=0):0){if((v|0)<0)break}else s=30;if((s|0)==30?p>>>0<q>>>0:0)break;t=jJa(a,d,g)|0;return t|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;t=l;return t|0}else{f[d>>2]=u;t=u;return t|0}}while(0);u=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))w=c;else{if(!u){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{x=e;break}}}else{h=u;while(1){l=f[h+4>>2]|0;if(!l){x=h;break}else h=l}}h=x;l=f[x+16>>2]|0;e=f[g>>2]|0;p=b[e+11>>0]|0;j=p<<24>>24<0;o=j?f[e+4>>2]|0:p&255;p=b[l+11>>0]|0;k=p<<24>>24<0;q=k?f[l+4>>2]|0:p&255;p=o>>>0<q>>>0?o:q;if((p|0)!=0?(v=WKc(k?f[l>>2]|0:l,j?f[e>>2]|0:e,p)|0,(v|0)!=0):0){if((v|0)<0){w=h;break}}else s=12;if((s|0)==12?q>>>0<o>>>0:0){w=h;break}t=jJa(a,d,g)|0;return t|0}while(0);if(!u){f[d>>2]=i;t=i;return t|0}else{i=w;f[d>>2]=i;t=i+4|0;return t|0}return 0}function mJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=f[c+(d<<2)>>2]|0;d=a+8|0;c=a+4|0;i=h+4|0;j=f[h>>2]|0;while(1){k=f[j+16>>2]|0;l=(b[k+11>>0]|0)<0?f[k>>2]|0:k;m=b[l>>0]|0;if(!(m<<24>>24))n=0;else{o=l;l=0;p=m;while(1){m=(l*5|0)+(p<<24>>24)|0;o=o+1|0;p=b[o>>0]|0;if(!(p<<24>>24)){n=m;break}else l=m}}gJa(g,a,(f[c>>2]|0)+-1&(f[d>>2]|0)+n,k);l=f[j+4>>2]|0;if(!l){p=j+8|0;o=f[p>>2]|0;if((f[o>>2]|0)==(j|0))q=o;else{o=p;do{p=f[o>>2]|0;o=p+8|0;m=f[o>>2]|0}while((f[m>>2]|0)!=(p|0));q=m}}else{o=l;while(1){k=f[o>>2]|0;if(!k)break;else o=k}q=o}if((q|0)==(i|0))break;else j=q}q=f[a+20>>2]|0;YIa(h,f[i>>2]|0);if(q|0){u=e;return}cYc(h);u=e;return}function nJa(a){a=a|0;var b=0;b=a+16|0;if(!(f[b>>2]|0))return;WIa(a);if(f[a+20>>2]|0)return;cYc(f[b>>2]|0);return}function oJa(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=80960;c=a+60|0;f[c>>2]=80980;d=a+8|0;f[d>>2]=35912;e=a+40|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);xNc(a,80992);GMc(c);return}function pJa(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=80960;c=a+60|0;f[c>>2]=80980;d=a+8|0;f[d>>2]=35912;e=a+40|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);xNc(a,80992);GMc(c);cYc(a);return}function qJa(a){a=a|0;var c=0,d=0,e=0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[c>>2]=80960;a=c+60|0;f[a>>2]=80980;d=c+8|0;f[d>>2]=35912;e=c+40|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);xNc(c,80992);GMc(a);return}function rJa(a){a=a|0;var c=0,d=0,e=0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[c>>2]=80960;a=c+60|0;f[a>>2]=80980;d=c+8|0;f[d>>2]=35912;e=c+40|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);LMc(d);xNc(c,80992);GMc(a);cYc(c);return}function sJa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=i+16|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[i+20>>2]|0:k&255;k=b[g+11>>0]|0;n=k<<24>>24<0;o=n?f[g+4>>2]|0:k&255;k=m>>>0<o>>>0;p=k?m:o;if((p|0)!=0?(q=WKc(n?f[g>>2]|0:g,l?f[j>>2]|0:j,p)|0,(q|0)!=0):0){if((q|0)<0)break}else r=4;if((r|0)==4?o>>>0<m>>>0:0)break;q=o>>>0<m>>>0?o:m;if((q|0)!=0?(m=WKc(l?f[j>>2]|0:j,n?f[g>>2]|0:g,q)|0,(m|0)!=0):0){if((m|0)>=0)r=36}else r=20;if((r|0)==20?!k:0)r=36;if((r|0)==36){f[d>>2]=c;f[e>>2]=c;s=e;return s|0}k=i+4|0;m=f[k>>2]|0;if(!m){q=i+8|0;j=f[q>>2]|0;if((f[j>>2]|0)==(i|0))t=j;else{j=q;do{q=f[j>>2]|0;j=q+8|0;l=f[j>>2]|0}while((f[l>>2]|0)!=(q|0));t=l}}else{j=m;while(1){l=f[j>>2]|0;if(!l)break;else j=l}t=j}do if((t|0)!=(h|0)){m=t+16|0;l=b[m+11>>0]|0;q=l<<24>>24<0;p=q?f[t+20>>2]|0:l&255;l=p>>>0<o>>>0?p:o;if((l|0)!=0?(u=WKc(n?f[g>>2]|0:g,q?f[m>>2]|0:m,l)|0,(u|0)!=0):0){if((u|0)<0)break}else r=30;if((r|0)==30?o>>>0<p>>>0:0)break;s=ZGa(a,d,g)|0;return s|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;s=k;return s|0}else{f[d>>2]=t;s=t;return s|0}}while(0);t=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))v=c;else{if(!t){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{w=e;break}}}else{h=t;while(1){k=f[h+4>>2]|0;if(!k){w=h;break}else h=k}}h=w;k=w+16|0;e=b[g+11>>0]|0;o=e<<24>>24<0;n=o?f[g+4>>2]|0:e&255;e=b[k+11>>0]|0;j=e<<24>>24<0;p=j?f[w+20>>2]|0:e&255;e=n>>>0<p>>>0?n:p;if((e|0)!=0?(u=WKc(j?f[k>>2]|0:k,o?f[g>>2]|0:g,e)|0,(u|0)!=0):0){if((u|0)<0){v=h;break}}else r=12;if((r|0)==12?p>>>0<n>>>0:0){v=h;break}s=ZGa(a,d,g)|0;return s|0}while(0);if(!t){f[d>>2]=i;s=i;return s|0}else{i=v;f[d>>2]=i;s=i+4|0;return s|0}return 0}function tJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+4|0;e=f[a>>2]|0;g=(f[d>>2]|0)-e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-e|0;e=j>>3;k=j>>4>>>0<134217727?(e>>>0<h>>>0?h:e):268435455;do if(k)if(k>>>0>268435455){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{l=$Xc(k<<4)|0;break}else l=0;while(0);e=l+(g<<4)|0;h=e;j=l+(k<<4)|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[e+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[l+(g<<4)+12>>2]=f[c+12>>2];c=e+16|0;g=f[a>>2]|0;l=f[d>>2]|0;if((l|0)==(g|0)){m=h;n=g;o=g}else{k=l;l=h;h=e;do{e=h+-16|0;p=k;k=k+-16|0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];f[e+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[h+-4>>2]=f[p+-4>>2];h=l+-16|0;l=h}while((k|0)!=(g|0));m=l;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=j;j=n;if((o|0)!=(j|0)){i=o;do{i=i+-16|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}while((i|0)!=(j|0))}if(!n)return;cYc(n);return}function uJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;yIa(d,f[a+8>>2]|0,b,0);a=f[d>>2]|0;if(a|0){g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}u_b(e,3,379823,1064);r_b(c+40|0,q_b(p_b(p_b(e,379907)|0,379935)|0,b)|0);v_b(e);g=a+12|0;h=f[g>>2]|0;i=h+16|0;u=c;return i|0}function vJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==8){c=f[a+8>>2]|0;return c|0}jSa(a);f[b>>2]=8;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=$Xc(172)|0;PUa(d);g=d}else{if(f[e+64>>2]|0)SXb(e,15504,176);d=QXb(e,176)|0;QUa(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function wJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(d>>>0>4294967279)jYc(g);if(d>>>0<11){b[g+11>>0]=d;if(!d)h=g;else{i=g;j=6}}else{k=d+16&-16;l=$Xc(k)|0;f[g>>2]=l;f[g+8>>2]=k|-2147483648;f[g+4>>2]=d;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,d|0)|0;h=i}b[h+d>>0]=0;d=f[a+4>>2]|0;h=d&-2;if(!(d&1))m=h;else m=f[h+4>>2]|0;h=a+152|0;a=f[h>>2]|0;if((a|0)==537368)xJa(h,m,g);else oYc(a,g)|0;if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function xJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=$Xc(12)|0;lYc(d,c);f[a>>2]=d;if(!b)return;yJa(b,d);return}function yJa(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2239);return}function zJa(a){a=a|0;if(!a)return;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(a);return}function AJa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+112|0;i=h+8|0;j=h;IWa(i);k=i+40|0;IWa(k);f[i+80>>2]=0;l=i+84|0;f[l>>2]=0;f[i+88>>2]=0;if((c|0)!=0&(d|0)!=0)jrb(c,d,i);if((e|0)!=0&(g|0)!=0)lrb(e,g,k);oOa(a);f[j>>2]=f[a>>2];g=f[a+4>>2]|0;f[j+4>>2]=g;if(g|0)TXc(g);mIa(i,j);ROa(j);j=i+80|0;g=f[j>>2]|0;if(!g){UUa(k);UUa(i);u=h;return}a=f[l>>2]|0;if((a|0)==(g|0))m=g;else{e=a;while(1){a=e+-12|0;f[l>>2]=a;if((b[a+11>>0]|0)<0){cYc(f[a>>2]|0);n=f[l>>2]|0}else n=a;if((n|0)==(g|0))break;else e=n}m=f[j>>2]|0}cYc(m);UUa(k);UUa(i);u=h;return}function BJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[b>>2]|0;e=f[c>>2]|0;g=f[c+4>>2]|0;AJa(a,d,(f[b+4>>2]|0)-d|0,(e|0)==(g|0)?0:e,g-e|0);return}function CJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+32|0;c=b+12|0;d=b;f[c>>2]=0;e=c+4|0;f[e>>2]=0;f[c+8>>2]=0;g=$Xc(64)|0;DJa(g);f[d>>2]=g;h=g;g=$Xc(16)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=81012;f[g+12>>2]=h;i=d+4|0;f[i>>2]=g;j=f[e>>2]|0;k=c+8|0;if(j>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[i>>2]|0;if(l|0)UXc(l)}else{f[j>>2]=h;f[j+4>>2]=g;f[d>>2]=0;f[i>>2]=0;f[e>>2]=j+8}j=$Xc(64)|0;FJa(j);f[d>>2]=j;i=j;j=$Xc(16)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=81040;f[j+12>>2]=i;g=d+4|0;f[g>>2]=j;h=f[e>>2]|0;if(h>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[g>>2]|0;if(l|0)UXc(l)}else{f[h>>2]=i;f[h+4>>2]=j;f[d>>2]=0;f[g>>2]=0;f[e>>2]=h+8}h=$Xc(64)|0;GJa(h);f[d>>2]=h;g=h;h=$Xc(16)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=81068;f[h+12>>2]=g;j=d+4|0;f[j>>2]=h;i=f[e>>2]|0;if(i>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[j>>2]|0;if(l|0)UXc(l)}else{f[i>>2]=g;f[i+4>>2]=h;f[d>>2]=0;f[j>>2]=0;f[e>>2]=i+8}i=$Xc(64)|0;HJa(i);f[d>>2]=i;j=i;i=$Xc(16)|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=81096;f[i+12>>2]=j;h=d+4|0;f[h>>2]=i;g=f[e>>2]|0;if(g>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[h>>2]|0;if(l|0)UXc(l)}else{f[g>>2]=j;f[g+4>>2]=i;f[d>>2]=0;f[h>>2]=0;f[e>>2]=g+8}g=$Xc(64)|0;IJa(g);f[d>>2]=g;h=g;g=$Xc(16)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=81124;f[g+12>>2]=h;i=d+4|0;f[i>>2]=g;j=f[e>>2]|0;if(j>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[i>>2]|0;if(l|0)UXc(l)}else{f[j>>2]=h;f[j+4>>2]=g;f[d>>2]=0;f[i>>2]=0;f[e>>2]=j+8}j=$Xc(64)|0;JJa(j);f[d>>2]=j;i=j;j=$Xc(16)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=81152;f[j+12>>2]=i;g=d+4|0;f[g>>2]=j;h=f[e>>2]|0;if(h>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[g>>2]|0;if(l|0)UXc(l)}else{f[h>>2]=i;f[h+4>>2]=j;f[d>>2]=0;f[g>>2]=0;f[e>>2]=h+8}h=$Xc(68)|0;KJa(h,3);f[d>>2]=h;g=h;h=$Xc(16)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=81180;f[h+12>>2]=g;j=d+4|0;f[j>>2]=h;i=f[e>>2]|0;if(i>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[j>>2]|0;if(l|0)UXc(l)}else{f[i>>2]=g;f[i+4>>2]=h;f[d>>2]=0;f[j>>2]=0;f[e>>2]=i+8}i=$Xc(64)|0;LJa(i);f[d>>2]=i;j=i;i=$Xc(16)|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=81208;f[i+12>>2]=j;h=d+4|0;f[h>>2]=i;g=f[e>>2]|0;if(g>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[h>>2]|0;if(l|0)UXc(l)}else{f[g>>2]=j;f[g+4>>2]=i;f[d>>2]=0;f[h>>2]=0;f[e>>2]=g+8}g=$Xc(64)|0;MJa(g);f[d>>2]=g;h=g;g=$Xc(16)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=81236;f[g+12>>2]=h;i=d+4|0;f[i>>2]=g;j=f[e>>2]|0;if(j>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[i>>2]|0;if(l|0)UXc(l)}else{f[j>>2]=h;f[j+4>>2]=g;f[d>>2]=0;f[i>>2]=0;f[e>>2]=j+8}j=$Xc(64)|0;NJa(j);f[d>>2]=j;i=j;j=$Xc(16)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=81264;f[j+12>>2]=i;g=d+4|0;f[g>>2]=j;h=f[e>>2]|0;if(h>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[g>>2]|0;if(l|0)UXc(l)}else{f[h>>2]=i;f[h+4>>2]=j;f[d>>2]=0;f[g>>2]=0;f[e>>2]=h+8}h=$Xc(64)|0;OJa(h);f[d>>2]=h;g=h;h=$Xc(16)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=81292;f[h+12>>2]=g;j=d+4|0;f[j>>2]=h;i=f[e>>2]|0;if(i>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[j>>2]|0;if(l|0)UXc(l)}else{f[i>>2]=g;f[i+4>>2]=h;f[d>>2]=0;f[j>>2]=0;f[e>>2]=i+8}i=$Xc(64)|0;PJa(i);f[d>>2]=i;j=i;i=$Xc(16)|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=81320;f[i+12>>2]=j;h=d+4|0;f[h>>2]=i;g=f[e>>2]|0;if(g>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);l=f[h>>2]|0;if(l|0)UXc(l)}else{f[g>>2]=j;f[g+4>>2]=i;f[d>>2]=0;f[h>>2]=0;f[e>>2]=g+8}g=$Xc(64)|0;QJa(g);f[d>>2]=g;h=g;g=$Xc(16)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=81348;f[g+12>>2]=h;i=d+4|0;f[i>>2]=g;j=f[e>>2]|0;if(j>>>0>=(f[k>>2]|0)>>>0){EJa(c,d);k=f[i>>2]|0;if(k|0)UXc(k)}else{f[j>>2]=h;f[j+4>>2]=g;f[d>>2]=0;f[i>>2]=0;f[e>>2]=j+8}j=f[a+12>>2]|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;f[d+8>>2]=0;if((j|0)>0){g=0;h=j;while(1){j=f[c>>2]|0;a:do if((f[e>>2]|0)==(j|0))m=h;else{k=0;l=j;while(1){n=f[l+(k<<3)>>2]|0;if(hh[f[(f[n>>2]|0)+8>>2]&127](n,a,g,d)|0)break;n=k+1|0;l=f[c>>2]|0;if(n>>>0>=(f[e>>2]|0)-l>>3>>>0){m=h;break a}else k=n}RJa(f[(f[c>>2]|0)+(k<<3)>>2]|0,a,d);m=h+1-((f[i>>2]|0)-(f[d>>2]|0)>>2)|0}while(0);g=g+1|0;if((g|0)>=(m|0))break;else h=m}m=f[d>>2]|0;if(m|0){d=f[i>>2]|0;if((d|0)!=(m|0))f[i>>2]=d+(~((d+-4-m|0)>>>2)<<2);cYc(m)}}m=f[c>>2]|0;if(!m){u=b;return}d=f[e>>2]|0;if((d|0)==(m|0))o=m;else{i=d;while(1){d=i+-8|0;f[e>>2]=d;h=f[i+-4>>2]|0;if(!h)p=d;else{UXc(h);p=f[e>>2]|0}if((p|0)==(m|0))break;else i=p}o=f[c>>2]|0}cYc(o);u=b;return}function DJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81800;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){n=f[l>>2]|0;if((n|0)!=(j|0))f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2);cYc(j)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;n=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-4-j|0)>>>2)<<2);cYc(j)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[j>>2]|0;if((q|0)!=(l|0))f[j>>2]=q+(~((q+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;q=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){r=f[l>>2]|0;if((r|0)!=(j|0))f[l>>2]=r+(~((r+-4-j|0)>>>2)<<2);cYc(j)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390465]|0;b[d+1>>0]=b[390466]|0;b[d+2>>0]=b[390467]|0;b[d+3>>0]=0;i=YJa(a,d,n,m,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[383443]|0;b[d+1>>0]=b[383444]|0;b[d+2>>0]=b[383445]|0;b[d+3>>0]=b[383446]|0;b[d+4>>0]=b[383447]|0;b[d+5>>0]=0;j=YJa(a,d,i,-1,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;i=YJa(a,d,j,q,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;j=YJa(a,d,k,i,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;r=YJa(a,d,o,i,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390473]|0;b[d+1>>0]=b[390474]|0;b[d+2>>0]=b[390475]|0;b[d+3>>0]=0;i=YJa(a,d,p,r,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390465]|0;b[d+1>>0]=b[390466]|0;b[d+2>>0]=b[390467]|0;b[d+3>>0]=0;YJa(a,d,j,i,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=e;i=384959;h=g+14|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(h|0));b[e+14>>0]=0;ZJa(a,d,k,q,p,o,n,m);if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function EJa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=l;k=n+(m<<3)|0;f[l>>2]=f[b>>2];m=b+4|0;f[n+(g<<3)+4>>2]=f[m>>2];f[b>>2]=0;f[m>>2]=0;m=l+8|0;if((j|0)==(i|0)){o=h;p=e}else{e=j;j=h;h=l;do{l=e;e=e+-8|0;f[h+-8>>2]=f[e>>2];b=l+-4|0;f[h+-4>>2]=f[b>>2];f[e>>2]=0;f[b>>2]=0;h=j+-8|0;j=h}while((e|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;o=f[c>>2]|0;f[c>>2]=m;f[d>>2]=k;k=p;if((o|0)!=(k|0)){d=o;do{o=f[d+-4>>2]|0;d=d+-8|0;if(o|0)UXc(o)}while((d|0)!=(k|0))}if(!p)return;cYc(p);return}function FJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81720;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){n=f[l>>2]|0;if((n|0)!=(j|0))f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2);cYc(j)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;n=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-4-j|0)>>>2)<<2);cYc(j)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[j>>2]|0;if((q|0)!=(l|0))f[j>>2]=q+(~((q+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390465]|0;b[d+1>>0]=b[390466]|0;b[d+2>>0]=b[390467]|0;b[d+3>>0]=0;i=YJa(a,d,n,m,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[383443]|0;b[d+1>>0]=b[383444]|0;b[d+2>>0]=b[383445]|0;b[d+3>>0]=b[383446]|0;b[d+4>>0]=b[383447]|0;b[d+5>>0]=0;l=YJa(a,d,i,-1,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;i=YJa(a,d,k,l,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;q=YJa(a,d,o,l,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390473]|0;b[d+1>>0]=b[390474]|0;b[d+2>>0]=b[390475]|0;b[d+3>>0]=0;l=YJa(a,d,p,q,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390465]|0;b[d+1>>0]=b[390466]|0;b[d+2>>0]=b[390467]|0;b[d+3>>0]=0;YJa(a,d,i,l,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=e;l=384959;h=g+14|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(h|0));b[e+14>>0]=0;ZJa(a,d,k,p,p,o,n,m);if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function GJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81696;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){n=f[l>>2]|0;if((n|0)!=(j|0))f[l>>2]=n+(~((n+-4-j|0)>>>2)<<2);cYc(j)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;n=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-4-j|0)>>>2)<<2);cYc(j)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[j>>2]|0;if((q|0)!=(l|0))f[j>>2]=q+(~((q+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=$Xc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;l=381927;h=g+12|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=YJa(a,d,m,n,o,p)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;n=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){l=f[o>>2]|0;if((l|0)!=(m|0))f[o>>2]=l+(~((l+-4-m|0)>>>2)<<2);cYc(m)}if((b[p>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=4;f[d>>2]=1801675088;b[d+4>>0]=0;p=YJa(a,d,i,n,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[396499]|0;b[d+1>>0]=b[396500]|0;b[d+2>>0]=b[396501]|0;b[d+3>>0]=b[396502]|0;b[d+4>>0]=b[396503]|0;b[d+5>>0]=b[396504]|0;b[d+6>>0]=b[396505]|0;b[d+7>>0]=0;YJa(a,d,k,p,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[396507]|0;b[d+1>>0]=b[396508]|0;b[d+2>>0]=b[396509]|0;b[d+3>>0]=b[396510]|0;b[d+4>>0]=b[396511]|0;b[d+5>>0]=b[396512]|0;b[d+6>>0]=b[396513]|0;b[d+7>>0]=0;ZJa(a,d,k,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function HJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81672;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=5;b[d>>0]=b[381532]|0;b[d+1>>0]=b[381533]|0;b[d+2>>0]=b[381534]|0;b[d+3>>0]=b[381535]|0;b[d+4>>0]=b[381536]|0;b[d+5>>0]=0;l=YJa(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);cYc(n)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[n>>2]|0;if((p|0)!=(m|0))f[n>>2]=p+(~((p+-4-m|0)>>>2)<<2);cYc(m)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[m>>2]|0;if((q|0)!=(n|0))f[m>>2]=q+(~((q+-4-n|0)>>>2)<<2);cYc(n)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=$Xc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;n=381927;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=YJa(a,d,l,j,o,p)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;j=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){n=f[o>>2]|0;if((n|0)!=(l|0))f[o>>2]=n+(~((n+-4-l|0)>>>2)<<2);cYc(l)}if((b[p>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=4;f[d>>2]=1801675088;b[d+4>>0]=0;p=YJa(a,d,i,j,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[396499]|0;b[d+1>>0]=b[396500]|0;b[d+2>>0]=b[396501]|0;b[d+3>>0]=b[396502]|0;b[d+4>>0]=b[396503]|0;b[d+5>>0]=b[396504]|0;b[d+6>>0]=b[396505]|0;b[d+7>>0]=0;YJa(a,d,k,p,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[396507]|0;b[d+1>>0]=b[396508]|0;b[d+2>>0]=b[396509]|0;b[d+3>>0]=b[396510]|0;b[d+4>>0]=b[396511]|0;b[d+5>>0]=b[396512]|0;b[d+6>>0]=b[396513]|0;b[d+7>>0]=0;ZJa(a,d,k,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function IJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81648;g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;f[d+8>>2]=0;i=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){k=f[h>>2]|0;if((k|0)!=(j|0))f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2);cYc(j)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;h=f[d>>2]|0;if(h|0){l=f[j>>2]|0;if((l|0)!=(h|0))f[j>>2]=l+(~((l+-4-h|0)>>>2)<<2);cYc(h)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=d+4|0;f[g>>2]=0;f[g+4>>2]=0;g=d+11|0;b[g>>0]=3;b[d>>0]=b[384209]|0;b[d+1>>0]=b[384210]|0;b[d+2>>0]=b[384211]|0;b[d+3>>0]=0;h=YJa(a,d,i,k,-1,-1)|0;if((b[g>>0]|0)<0)cYc(f[d>>2]|0);g=d+4|0;f[g>>2]=0;f[g+4>>2]=0;g=d+11|0;b[g>>0]=3;b[d>>0]=b[390473]|0;b[d+1>>0]=b[390474]|0;b[d+2>>0]=b[390475]|0;b[d+3>>0]=0;k=YJa(a,d,i,h,-1,-1)|0;if((b[g>>0]|0)<0)cYc(f[d>>2]|0);g=d+4|0;f[g>>2]=0;f[g+4>>2]=0;g=d+11|0;b[g>>0]=3;b[d>>0]=b[384213]|0;b[d+1>>0]=b[384214]|0;b[d+2>>0]=b[384215]|0;b[d+3>>0]=0;h=YJa(a,d,k,-1,-1,-1)|0;if((b[g>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;l=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){m=f[k>>2]|0;if((m|0)!=(j|0))f[k>>2]=m+(~((m+-4-j|0)>>>2)<<2);cYc(j)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390469]|0;b[d+1>>0]=b[390470]|0;b[d+2>>0]=b[390471]|0;b[d+3>>0]=0;g=YJa(a,d,h,l,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[384217]|0;b[d+1>>0]=b[384218]|0;b[d+2>>0]=b[384219]|0;b[d+3>>0]=b[384220]|0;b[d+4>>0]=b[384221]|0;b[d+5>>0]=b[384222]|0;b[d+6>>0]=b[384223]|0;b[d+7>>0]=0;YJa(a,d,h,g,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[429025]|0;b[d+1>>0]=b[429026]|0;b[d+2>>0]=b[429027]|0;b[d+3>>0]=b[429028]|0;b[d+4>>0]=b[429029]|0;b[d+5>>0]=b[429030]|0;b[d+6>>0]=b[429031]|0;b[d+7>>0]=0;ZJa(a,d,i,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function JJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81624;g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;f[d+8>>2]=0;i=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){k=f[h>>2]|0;if((k|0)!=(j|0))f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2);cYc(j)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;g=d+11|0;b[g>>0]=4;f[d>>2]=1970038098;b[d+4>>0]=0;j=YJa(a,d,i,-1,-1,-1)|0;if((b[g>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;h=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[k>>2]|0;if((m|0)!=(l|0))f[k>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;m=XJa(a,e,d)|0;k=f[d>>2]|0;if(k|0){n=f[l>>2]|0;if((n|0)!=(k|0))f[l>>2]=n+(~((n+-4-k|0)>>>2)<<2);cYc(k)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[383950]|0;b[d+1>>0]=b[383951]|0;b[d+2>>0]=b[383952]|0;b[d+3>>0]=b[383953]|0;b[d+4>>0]=b[383954]|0;b[d+5>>0]=b[383955]|0;b[d+6>>0]=b[383956]|0;b[d+7>>0]=0;g=YJa(a,d,j,h,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[383435]|0;b[d+1>>0]=b[383436]|0;b[d+2>>0]=b[383437]|0;b[d+3>>0]=b[383438]|0;b[d+4>>0]=b[383439]|0;b[d+5>>0]=b[383440]|0;b[d+6>>0]=b[383441]|0;b[d+7>>0]=0;YJa(a,d,g,m,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[383958]|0;b[d+1>>0]=b[383959]|0;b[d+2>>0]=b[383960]|0;b[d+3>>0]=b[383961]|0;b[d+4>>0]=b[383962]|0;b[d+5>>0]=0;ZJa(a,d,i,-1,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function KJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=a+4|0;j=i+60|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[a>>2]=81600;k=a+64|0;f[k>>2]=c;c=g+11|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=XJa(a,g,e)|0;n=f[e>>2]|0;if(n|0){o=f[l>>2]|0;if((o|0)!=(n|0))f[l>>2]=o+(~((o+-4-n|0)>>>2)<<2);cYc(n)}if((b[c>>0]|0)<0)cYc(f[g>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=e+11|0;b[c>>0]=5;b[e>>0]=b[381532]|0;b[e+1>>0]=b[381533]|0;b[e+2>>0]=b[381534]|0;b[e+3>>0]=b[381535]|0;b[e+4>>0]=b[381536]|0;b[e+5>>0]=0;n=YJa(a,e,m,-1,-1,-1)|0;if((b[c>>0]|0)<0)cYc(f[e>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[e>>2]=0;o=e+4|0;f[o>>2]=0;f[e+8>>2]=0;l=XJa(a,g,e)|0;p=f[e>>2]|0;if(p|0){q=f[o>>2]|0;if((q|0)!=(p|0))f[o>>2]=q+(~((q+-4-p|0)>>>2)<<2);cYc(p)}if((b[c>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[e>>2]=0;p=e+4|0;f[p>>2]=0;f[e+8>>2]=0;q=XJa(a,g,e)|0;o=f[e>>2]|0;if(o|0){r=f[p>>2]|0;if((r|0)!=(o|0))f[p>>2]=r+(~((r+-4-o|0)>>>2)<<2);cYc(o)}if((b[c>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=g+11|0;b[c>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[e>>2]=0;o=e+4|0;f[o>>2]=0;f[e+8>>2]=0;r=XJa(a,g,e)|0;p=f[e>>2]|0;if(p|0){s=f[o>>2]|0;if((s|0)!=(p|0))f[o>>2]=s+(~((s+-4-p|0)>>>2)<<2);cYc(p)}if((b[c>>0]|0)<0)cYc(f[g>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;c=$Xc(16)|0;f[e>>2]=c;f[e+8>>2]=-2147483632;f[e+4>>2]=12;i=c;p=381927;j=i+12|0;do{b[i>>0]=b[p>>0]|0;i=i+1|0;p=p+1|0}while((i|0)<(j|0));b[c+12>>0]=0;c=YJa(a,e,n,l,q,r)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);r=(f[k>>2]|0)+1|0;f[g>>2]=0;q=g+4|0;f[q>>2]=0;f[g+8>>2]=0;if(r>>>0>1073741823)kWc(g);l=r<<2;n=$Xc(l)|0;f[g>>2]=n;p=n+(r<<2)|0;f[g+8>>2]=p;g1c(n|0,0,l|0)|0;f[q>>2]=p;f[n>>2]=c;if((f[k>>2]|0)>0){c=h+11|0;n=h+5|0;p=e+4|0;l=e+8|0;r=0;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[c>>0]=5;b[h>>0]=b[381538]|0;b[h+1>>0]=b[381539]|0;b[h+2>>0]=b[381540]|0;b[h+3>>0]=b[381541]|0;b[h+4>>0]=b[381542]|0;b[n>>0]=0;f[e>>2]=0;f[p>>2]=0;f[l>>2]=0;i=XJa(a,h,e)|0;j=f[e>>2]|0;if(j|0){s=f[p>>2]|0;if((s|0)!=(j|0))f[p>>2]=s+(~((s+-4-j|0)>>>2)<<2);cYc(j)}r=r+1|0;f[(f[g>>2]|0)+(r<<2)>>2]=i;if((b[c>>0]|0)<0)cYc(f[h>>2]|0)}while((r|0)<(f[k>>2]|0))};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;k=e+11|0;b[k>>0]=4;f[e>>2]=1801675088;b[e+4>>0]=0;r=XJa(a,e,g)|0;if((b[k>>0]|0)<0)cYc(f[e>>2]|0);f[e+8>>2]=0;k=e+11|0;b[k>>0]=7;b[e>>0]=b[396499]|0;b[e+1>>0]=b[396500]|0;b[e+2>>0]=b[396501]|0;b[e+3>>0]=b[396502]|0;b[e+4>>0]=b[396503]|0;b[e+5>>0]=b[396504]|0;b[e+6>>0]=b[396505]|0;b[e+7>>0]=0;YJa(a,e,m,r,-1,-1)|0;if((b[k>>0]|0)<0)cYc(f[e>>2]|0);f[f[g>>2]>>2]=m;f[e+8>>2]=0;m=e+11|0;b[m>>0]=7;b[e>>0]=b[396499]|0;b[e+1>>0]=b[396500]|0;b[e+2>>0]=b[396501]|0;b[e+3>>0]=b[396502]|0;b[e+4>>0]=b[396503]|0;b[e+5>>0]=b[396504]|0;b[e+6>>0]=b[396505]|0;b[e+7>>0]=0;dKa(a,e,g);if((b[m>>0]|0)<0)cYc(f[e>>2]|0);e=f[g>>2]|0;if(!e){u=d;return}g=f[q>>2]|0;if((g|0)!=(e|0))f[q>>2]=g+(~((g+-4-e|0)>>>2)<<2);cYc(e);u=d;return}function LJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81576;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=6;b[d>>0]=b[387314]|0;b[d+1>>0]=b[387315]|0;b[d+2>>0]=b[387316]|0;b[d+3>>0]=b[387317]|0;b[d+4>>0]=b[387318]|0;b[d+5>>0]=b[387319]|0;b[d+6>>0]=0;l=YJa(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);cYc(n)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);i=d+4|0;f[i>>2]=0;f[i+4>>2]=0;i=d+11|0;b[i>>0]=3;b[d>>0]=b[390469]|0;b[d+1>>0]=b[390470]|0;b[d+2>>0]=b[390471]|0;b[d+3>>0]=0;n=YJa(a,d,l,j,-1,-1)|0;if((b[i>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;l=d+4|0;f[l>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[l>>2]|0;if((p|0)!=(m|0))f[l>>2]=p+(~((p+-4-m|0)>>>2)<<2);cYc(m)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[383435]|0;b[d+1>>0]=b[383436]|0;b[d+2>>0]=b[383437]|0;b[d+3>>0]=b[383438]|0;b[d+4>>0]=b[383439]|0;b[d+5>>0]=b[383440]|0;b[d+6>>0]=b[383441]|0;b[d+7>>0]=0;i=YJa(a,d,n,o,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[383443]|0;b[d+1>>0]=b[383444]|0;b[d+2>>0]=b[383445]|0;b[d+3>>0]=b[383446]|0;b[d+4>>0]=b[383447]|0;b[d+5>>0]=0;o=YJa(a,d,i,-1,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;YJa(a,d,k,o,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=11;g=e;o=383449;h=g+11|0;do{b[g>>0]=b[o>>0]|0;g=g+1|0;o=o+1|0}while((g|0)<(h|0));b[e+11>>0]=0;ZJa(a,d,k,j,-1,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function MJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+4|0;i=h+60|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[a>>2]=81552;j=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;l=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){n=f[k>>2]|0;if((n|0)!=(m|0))f[k>>2]=n+(~((n+-4-m|0)>>>2)<<2);cYc(m)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[381532]|0;b[d+1>>0]=b[381533]|0;b[d+2>>0]=b[381534]|0;b[d+3>>0]=b[381535]|0;b[d+4>>0]=b[381536]|0;b[d+5>>0]=0;m=YJa(a,d,l,-1,-1,-1)|0;if((b[j>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;o=f[d>>2]|0;if(o|0){p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-4-o|0)>>>2)<<2);cYc(o)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[o>>2]|0;if((q|0)!=(n|0))f[o>>2]=q+(~((q+-4-n|0)>>>2)<<2);cYc(n)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;q=XJa(a,e,d)|0;o=f[d>>2]|0;if(o|0){r=f[n>>2]|0;if((r|0)!=(o|0))f[n>>2]=r+(~((r+-4-o|0)>>>2)<<2);cYc(o)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;r=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){s=f[o>>2]|0;if((s|0)!=(n|0))f[o>>2]=s+(~((s+-4-n|0)>>>2)<<2);cYc(n)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=$Xc(16)|0;f[d>>2]=j;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=j;n=381927;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[j+12>>0]=0;j=YJa(a,d,m,p,q,r)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){o=f[q>>2]|0;if((o|0)!=(s|0))f[q>>2]=o+(~((o+-4-s|0)>>>2)<<2);cYc(s)}if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;q=f[d>>2]|0;if(q|0){t=f[s>>2]|0;if((t|0)!=(q|0))f[s>>2]=t+(~((t+-4-q|0)>>>2)<<2);cYc(q)}if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;t=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[q>>2]|0;if((v|0)!=(s|0))f[q>>2]=v+(~((v+-4-s|0)>>>2)<<2);cYc(s)}if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;r=$Xc(16)|0;f[d>>2]=r;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=r;n=381927;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[r+12>>0]=0;r=YJa(a,d,m,p,o,t)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[o>>2]|0;if((v|0)!=(s|0))f[o>>2]=v+(~((v+-4-s|0)>>>2)<<2);cYc(s)}if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;v=XJa(a,e,d)|0;o=f[d>>2]|0;if(o|0){q=f[s>>2]|0;if((q|0)!=(o|0))f[s>>2]=q+(~((q+-4-o|0)>>>2)<<2);cYc(o)}if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;q=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){w=f[o>>2]|0;if((w|0)!=(s|0))f[o>>2]=w+(~((w+-4-s|0)>>>2)<<2);cYc(s)}if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;t=$Xc(16)|0;f[d>>2]=t;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=t;n=381927;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[t+12>>0]=0;t=YJa(a,d,m,p,v,q)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[390721]|0;b[e+1>>0]=b[390722]|0;b[e+2>>0]=b[390723]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;s=XJa(a,g,d)|0;w=f[d>>2]|0;if(w|0){o=f[m>>2]|0;if((o|0)!=(w|0))f[m>>2]=o+(~((o+-4-w|0)>>>2)<<2);cYc(w)}w=YJa(a,e,r,s,-1,-1)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[390465]|0;b[e+1>>0]=b[390466]|0;b[e+2>>0]=b[390467]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;r=XJa(a,g,d)|0;o=f[d>>2]|0;if(o|0){m=f[s>>2]|0;if((m|0)!=(o|0))f[s>>2]=m+(~((m+-4-o|0)>>>2)<<2);cYc(o)}o=YJa(a,e,w,r,-1,-1)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[390721]|0;b[e+1>>0]=b[390722]|0;b[e+2>>0]=b[390723]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;r=d+4|0;f[r>>2]=0;f[d+8>>2]=0;w=XJa(a,g,d)|0;m=f[d>>2]|0;if(m|0){s=f[r>>2]|0;if((s|0)!=(m|0))f[r>>2]=s+(~((s+-4-m|0)>>>2)<<2);cYc(m)}m=YJa(a,e,t,w,-1,-1)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[390465]|0;b[e+1>>0]=b[390466]|0;b[e+2>>0]=b[390467]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;w=d+4|0;f[w>>2]=0;f[d+8>>2]=0;t=XJa(a,g,d)|0;s=f[d>>2]|0;if(s|0){r=f[w>>2]|0;if((r|0)!=(s|0))f[w>>2]=r+(~((r+-4-s|0)>>>2)<<2);cYc(s)}s=YJa(a,e,m,t,-1,-1)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=4;f[e>>2]=1801675088;b[e+4>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;t=d+4|0;f[t>>2]=0;f[d+8>>2]=0;m=XJa(a,g,d)|0;r=f[d>>2]|0;if(r|0){w=f[t>>2]|0;if((w|0)!=(r|0))f[t>>2]=w+(~((w+-4-r|0)>>>2)<<2);cYc(r)}r=YJa(a,e,j,o,s,m)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=e;n=382793;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[e+19>>0]=0;YJa(a,d,r,k,l,-1)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;r=$Xc(32)|0;f[d>>2]=r;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=r;n=382793;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[r+19>>0]=0;ZJa(a,d,p,k,l,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function NJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;h=a+4|0;i=h+60|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[a>>2]=81528;j=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;k=d+4|0;f[k>>2]=0;f[d+8>>2]=0;l=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){n=f[k>>2]|0;if((n|0)!=(m|0))f[k>>2]=n+(~((n+-4-m|0)>>>2)<<2);cYc(m)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[381532]|0;b[d+1>>0]=b[381533]|0;b[d+2>>0]=b[381534]|0;b[d+3>>0]=b[381535]|0;b[d+4>>0]=b[381536]|0;b[d+5>>0]=0;m=YJa(a,d,l,-1,-1,-1)|0;if((b[j>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;o=f[d>>2]|0;if(o|0){p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-4-o|0)>>>2)<<2);cYc(o)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[o>>2]|0;if((q|0)!=(n|0))f[o>>2]=q+(~((q+-4-n|0)>>>2)<<2);cYc(n)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;q=XJa(a,e,d)|0;o=f[d>>2]|0;if(o|0){r=f[n>>2]|0;if((r|0)!=(o|0))f[n>>2]=r+(~((r+-4-o|0)>>>2)<<2);cYc(o)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;r=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){s=f[o>>2]|0;if((s|0)!=(n|0))f[o>>2]=s+(~((s+-4-n|0)>>>2)<<2);cYc(n)}if((b[j>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=$Xc(16)|0;f[d>>2]=j;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=j;n=381927;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[j+12>>0]=0;j=YJa(a,d,m,p,q,r)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){o=f[q>>2]|0;if((o|0)!=(s|0))f[q>>2]=o+(~((o+-4-s|0)>>>2)<<2);cYc(s)}if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;q=f[d>>2]|0;if(q|0){t=f[s>>2]|0;if((t|0)!=(q|0))f[s>>2]=t+(~((t+-4-q|0)>>>2)<<2);cYc(q)}if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;r=e+11|0;b[r>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;t=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[q>>2]|0;if((v|0)!=(s|0))f[q>>2]=v+(~((v+-4-s|0)>>>2)<<2);cYc(s)}if((b[r>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;r=$Xc(16)|0;f[d>>2]=r;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=r;n=381927;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[r+12>>0]=0;r=YJa(a,d,m,p,o,t)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){v=f[o>>2]|0;if((v|0)!=(s|0))f[o>>2]=v+(~((v+-4-s|0)>>>2)<<2);cYc(s)}if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;v=XJa(a,e,d)|0;o=f[d>>2]|0;if(o|0){q=f[s>>2]|0;if((q|0)!=(o|0))f[s>>2]=q+(~((q+-4-o|0)>>>2)<<2);cYc(o)}if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;t=e+11|0;b[t>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;q=XJa(a,e,d)|0;s=f[d>>2]|0;if(s|0){w=f[o>>2]|0;if((w|0)!=(s|0))f[o>>2]=w+(~((w+-4-s|0)>>>2)<<2);cYc(s)}if((b[t>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;t=$Xc(16)|0;f[d>>2]=t;f[d+8>>2]=-2147483632;f[d+4>>2]=12;h=t;n=381927;i=h+12|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[t+12>>0]=0;t=YJa(a,d,m,p,v,q)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[390721]|0;b[e+1>>0]=b[390722]|0;b[e+2>>0]=b[390723]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;s=XJa(a,g,d)|0;w=f[d>>2]|0;if(w|0){o=f[m>>2]|0;if((o|0)!=(w|0))f[m>>2]=o+(~((o+-4-w|0)>>>2)<<2);cYc(w)}w=YJa(a,e,r,s,-1,-1)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);q=e+4|0;f[q>>2]=0;f[q+4>>2]=0;q=e+11|0;b[q>>0]=3;b[e>>0]=b[390721]|0;b[e+1>>0]=b[390722]|0;b[e+2>>0]=b[390723]|0;b[e+3>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;s=d+4|0;f[s>>2]=0;f[d+8>>2]=0;r=XJa(a,g,d)|0;o=f[d>>2]|0;if(o|0){m=f[s>>2]|0;if((m|0)!=(o|0))f[s>>2]=m+(~((m+-4-o|0)>>>2)<<2);cYc(o)}o=YJa(a,e,t,r,-1,-1)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=4;f[e>>2]=1801675088;b[e+4>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[381538]|0;b[g+1>>0]=b[381539]|0;b[g+2>>0]=b[381540]|0;b[g+3>>0]=b[381541]|0;b[g+4>>0]=b[381542]|0;b[g+5>>0]=0;f[d>>2]=0;r=d+4|0;f[r>>2]=0;f[d+8>>2]=0;t=XJa(a,g,d)|0;m=f[d>>2]|0;if(m|0){s=f[r>>2]|0;if((s|0)!=(m|0))f[r>>2]=s+(~((s+-4-m|0)>>>2)<<2);cYc(m)}m=YJa(a,e,j,w,o,t)|0;if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=e;n=382793;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[e+19>>0]=0;YJa(a,d,m,k,l,-1)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;m=$Xc(32)|0;f[d>>2]=m;f[d+8>>2]=-2147483616;f[d+4>>2]=19;h=m;n=382793;i=h+19|0;do{b[h>>0]=b[n>>0]|0;h=h+1|0;n=n+1|0}while((h|0)<(i|0));b[m+19>>0]=0;ZJa(a,d,p,k,l,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function OJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81504;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=5;b[d>>0]=b[381532]|0;b[d+1>>0]=b[381533]|0;b[d+2>>0]=b[381534]|0;b[d+3>>0]=b[381535]|0;b[d+4>>0]=b[381536]|0;b[d+5>>0]=0;l=YJa(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);cYc(n)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[n>>2]|0;if((p|0)!=(m|0))f[n>>2]=p+(~((p+-4-m|0)>>>2)<<2);cYc(m)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[m>>2]|0;if((q|0)!=(n|0))f[m>>2]=q+(~((q+-4-n|0)>>>2)<<2);cYc(n)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=$Xc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;n=381927;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=YJa(a,d,l,j,o,p)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;j=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[o>>2]|0;if((q|0)!=(l|0))f[o>>2]=q+(~((q+-4-l|0)>>>2)<<2);cYc(l)}if((b[p>>0]|0)<0)cYc(f[e>>2]|0);p=d+4|0;f[p>>2]=0;f[p+4>>2]=0;p=d+11|0;b[p>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;l=YJa(a,d,i,j,-1,-1)|0;if((b[p>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=d+11|0;b[p>>0]=5;b[d>>0]=b[381532]|0;b[d+1>>0]=b[381533]|0;b[d+2>>0]=b[381534]|0;b[d+3>>0]=b[381535]|0;b[d+4>>0]=b[381536]|0;b[d+5>>0]=0;i=YJa(a,d,k,-1,-1,-1)|0;if((b[p>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){r=f[q>>2]|0;if((r|0)!=(m|0))f[q>>2]=r+(~((r+-4-m|0)>>>2)<<2);cYc(m)}if((b[p>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;r=XJa(a,e,d)|0;q=f[d>>2]|0;if(q|0){s=f[m>>2]|0;if((s|0)!=(q|0))f[m>>2]=s+(~((s+-4-q|0)>>>2)<<2);cYc(q)}if((b[p>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=0;f[d+8>>2]=0;s=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){t=f[q>>2]|0;if((t|0)!=(m|0))f[q>>2]=t+(~((t+-4-m|0)>>>2)<<2);cYc(m)}if((b[p>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=$Xc(16)|0;f[d>>2]=p;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=p;n=381927;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[p+12>>0]=0;p=YJa(a,d,i,o,r,s)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;s=e+11|0;b[s>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;r=d+4|0;f[r>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;i=f[d>>2]|0;if(i|0){m=f[r>>2]|0;if((m|0)!=(i|0))f[r>>2]=m+(~((m+-4-i|0)>>>2)<<2);cYc(i)}if((b[s>>0]|0)<0)cYc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;s=YJa(a,d,p,o,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=4;f[d>>2]=1801675088;b[d+4>>0]=0;p=YJa(a,d,l,s,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(16)|0;f[d>>2]=e;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=e;n=382509;h=g+14|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[e+14>>0]=0;YJa(a,d,k,p,-1,-1)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=$Xc(16)|0;f[d>>2]=p;f[d+8>>2]=-2147483632;f[d+4>>2]=14;g=p;n=382509;h=g+14|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[p+14>>0]=0;ZJa(a,d,k,j,o,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function PJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81424;i=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){m=f[j>>2]|0;if((m|0)!=(l|0))f[j>>2]=m+(~((m+-4-l|0)>>>2)<<2);cYc(l)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=5;b[d>>0]=b[381532]|0;b[d+1>>0]=b[381533]|0;b[d+2>>0]=b[381534]|0;b[d+3>>0]=b[381535]|0;b[d+4>>0]=b[381536]|0;b[d+5>>0]=0;l=YJa(a,d,k,-1,-1,-1)|0;if((b[i>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;j=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){o=f[m>>2]|0;if((o|0)!=(n|0))f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);cYc(n)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;n=d+4|0;f[n>>2]=0;f[d+8>>2]=0;o=XJa(a,e,d)|0;m=f[d>>2]|0;if(m|0){p=f[n>>2]|0;if((p|0)!=(m|0))f[n>>2]=p+(~((p+-4-m|0)>>>2)<<2);cYc(m)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;m=d+4|0;f[m>>2]=0;f[d+8>>2]=0;p=XJa(a,e,d)|0;n=f[d>>2]|0;if(n|0){q=f[m>>2]|0;if((q|0)!=(n|0))f[m>>2]=q+(~((q+-4-n|0)>>>2)<<2);cYc(n)}if((b[i>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=$Xc(16)|0;f[d>>2]=i;f[d+8>>2]=-2147483632;f[d+4>>2]=12;g=i;n=381927;h=g+12|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[i+12>>0]=0;i=YJa(a,d,l,j,o,p)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;p=e+11|0;b[p>>0]=5;b[e>>0]=b[381538]|0;b[e+1>>0]=b[381539]|0;b[e+2>>0]=b[381540]|0;b[e+3>>0]=b[381541]|0;b[e+4>>0]=b[381542]|0;b[e+5>>0]=0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;j=XJa(a,e,d)|0;l=f[d>>2]|0;if(l|0){q=f[o>>2]|0;if((q|0)!=(l|0))f[o>>2]=q+(~((q+-4-l|0)>>>2)<<2);cYc(l)}if((b[p>>0]|0)<0)cYc(f[e>>2]|0);e=d+4|0;f[e>>2]=0;f[e+4>>2]=0;e=d+11|0;b[e>>0]=3;b[d>>0]=b[390721]|0;b[d+1>>0]=b[390722]|0;b[d+2>>0]=b[390723]|0;b[d+3>>0]=0;p=YJa(a,d,i,j,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=$Xc(32)|0;f[d>>2]=e;f[d+8>>2]=-2147483616;f[d+4>>2]=21;g=e;n=381940;h=g+21|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[e+21>>0]=0;YJa(a,d,k,p,-1,-1)|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;p=$Xc(32)|0;f[d>>2]=p;f[d+8>>2]=-2147483616;f[d+4>>2]=21;g=p;n=381940;h=g+21|0;do{b[g>>0]=b[n>>0]|0;g=g+1|0;n=n+1|0}while((g|0)<(h|0));b[p+21>>0]=0;ZJa(a,d,k,j,-1,-1,-1,-1);if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function QJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+4|0;h=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a>>2]=81376;g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;f[d+8>>2]=0;i=XJa(a,e,d)|0;j=f[d>>2]|0;if(j|0){k=f[h>>2]|0;if((k|0)!=(j|0))f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2);cYc(j)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;f[d+8>>2]=0;k=XJa(a,e,d)|0;h=f[d>>2]|0;if(h|0){l=f[j>>2]|0;if((l|0)!=(h|0))f[j>>2]=l+(~((l+-4-h|0)>>>2)<<2);cYc(h)}if((b[g>>0]|0)<0)cYc(f[e>>2]|0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;e=d+11|0;b[e>>0]=5;b[d>>0]=b[381532]|0;b[d+1>>0]=b[381533]|0;b[d+2>>0]=b[381534]|0;b[d+3>>0]=b[381535]|0;b[d+4>>0]=b[381536]|0;b[d+5>>0]=0;g=YJa(a,d,k,-1,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[396499]|0;b[d+1>>0]=b[396500]|0;b[d+2>>0]=b[396501]|0;b[d+3>>0]=b[396502]|0;b[d+4>>0]=b[396503]|0;b[d+5>>0]=b[396504]|0;b[d+6>>0]=b[396505]|0;b[d+7>>0]=0;YJa(a,d,i,g,-1,-1)|0;if((b[e>>0]|0)<0)cYc(f[d>>2]|0);f[d+8>>2]=0;e=d+11|0;b[e>>0]=7;b[d>>0]=b[396499]|0;b[d+1>>0]=b[396500]|0;b[d+2>>0]=b[396501]|0;b[d+3>>0]=b[396502]|0;b[d+4>>0]=b[396503]|0;b[d+5>>0]=b[396504]|0;b[d+6>>0]=b[396505]|0;b[d+7>>0]=0;ZJa(a,d,i,k,-1,-1,-1,-1);if((b[e>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}function RJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;j=a+52|0;k=a+56|0;GGa(g,(f[k>>2]|0)-(f[j>>2]|0)>>2);a:do if((f[k>>2]|0)!=(f[j>>2]|0)){l=d+4|0;m=h+11|0;n=h+4|0;o=c+20|0;p=a+40|0;q=a+16|0;r=0;b:while(1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=f[l>>2]|0;t=f[d>>2]|0;c:do if((s|0)==(t|0)){v=0;w=0}else{x=0;y=s;z=0;A=0;B=t;while(1){if((z<<24>>24<0?A:z&255)|0){v=z;w=A;break c}C=f[(f[o>>2]|0)+4+(f[B+(x<<2)>>2]<<2)>>2]|0;D=f[(f[p>>2]|0)+(x<<2)>>2]|0;E=f[q>>2]|0;F=f[C+12>>2]|0;G=f[E+(D*12|0)+4>>2]|0;H=f[E+(D*12|0)>>2]|0;D=H;if((F|0)!=(G-H>>2|0)){I=10;break b}d:do if((G|0)==(H|0)){J=B;K=y}else{E=f[(f[j>>2]|0)+(r<<2)>>2]|0;L=0;while(1){if((f[D+(L<<2)>>2]|0)==(E|0))break;M=L+1|0;if(M>>>0<F>>>0)L=M;else{J=B;K=y;break d}}oYc(h,f[(f[C+20>>2]|0)+4+(L<<2)>>2]|0)|0;J=f[d>>2]|0;K=f[l>>2]|0}while(0);x=x+1|0;C=b[m>>0]|0;F=f[n>>2]|0;if(x>>>0>=K-J>>2>>>0){v=C;w=F;break}else{y=K;z=C;A=F;B=J}}}while(0);if(!((v<<24>>24<0?w:v&255)|0)){I=15;break}oYc((f[g>>2]|0)+(r*12|0)|0,h)|0;if((b[m>>0]|0)<0)cYc(f[h>>2]|0);r=r+1|0;if(r>>>0>=(f[k>>2]|0)-(f[j>>2]|0)>>2>>>0){N=o;O=d;P=l;break a}}if((I|0)==10){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=$Xc(48)|0;f[i>>2]=l;f[i+8>>2]=-2147483600;f[i+4>>2]=38;Q=l;R=381113;S=Q+38|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[l+38>>0]=0;vM(-215,i,381152,381160,153)}else if((I|0)==15){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;o=$Xc(32)|0;f[i>>2]=o;f[i+8>>2]=-2147483616;f[i+4>>2]=16;Q=o;R=381251;S=Q+16|0;do{b[Q>>0]=b[R>>0]|0;Q=Q+1|0;R=R+1|0}while((Q|0)<(S|0));b[o+16>>0]=0;vM(-215,i,381152,381160,163)}}else{N=c+20|0;O=d;P=d+4|0}while(0);i=f[P>>2]|0;P=f[N>>2]|0;R=f[P+4+(f[i+-4>>2]<<2)>>2]|0;Q=f[O>>2]|0;O=(i-Q>>2)+-2|0;e:do if((O|0)>-1){i=c+8|0;S=O;I=Q;j=P;while(1){k=f[I+(S<<2)>>2]|0;v=f[j+4+(k<<2)>>2]|0;if(!((v|0)==0|(f[i>>2]|0)!=0))Yi[f[(f[v>>2]|0)+4>>2]&4095](v);YZb(i,k,1);if((S|0)<=0)break e;S=S+-1|0;I=f[d>>2]|0;j=f[N>>2]|0}}while(0);N=a+28|0;d=R+64|0;P=f[R+4>>2]|0;Q=P&-2;if(!(P&1))T=Q;else T=f[Q+4>>2]|0;Q=f[d>>2]|0;if((Q|0)==537368)xJa(d,T,N);else oYc(Q,N)|0;N=R+12|0;Q=f[N>>2]|0;if((Q|0)>0){T=f[R+20>>2]|0;d=0;do{P=f[T+4+(d<<2)>>2]|0;d=d+1|0;O=P+11|0;if((b[O>>0]|0)<0){b[f[P>>2]>>0]=0;f[P+4>>2]=0}else{b[P>>0]=0;b[O>>0]=0}}while((d|0)!=(Q|0));f[N>>2]=0}N=g+4|0;Q=f[N>>2]|0;d=f[g>>2]|0;if((Q|0)==(d|0)){U=Q;V=Q}else{Q=R+8|0;T=0;O=d;while(1){oYc(pHa(Q)|0,O+(T*12|0)|0)|0;T=T+1|0;d=f[N>>2]|0;P=f[g>>2]|0;if(T>>>0>=((d-P|0)/12|0)>>>0){U=P;V=d;break}else O=P}}O=V-U|0;T=(O|0)/12|0;f[h>>2]=0;Q=h+4|0;f[Q>>2]=0;f[h+8>>2]=0;if(!O)W=V;else{if(T>>>0>1073741823)kWc(h);V=$Xc(T<<2)|0;f[Q>>2]=V;f[h>>2]=V;f[h+8>>2]=V+(T<<2);O=T;T=V;do{f[T>>2]=0;T=(f[Q>>2]|0)+4|0;f[Q>>2]=T;O=O+-1|0}while((O|0)!=0);W=f[N>>2]|0}if((W|0)!=(U|0)){U=0;do{W=SJa(c,R,U)|0;f[(f[h>>2]|0)+(U<<2)>>2]=W;U=U+1|0}while(U>>>0<(((f[N>>2]|0)-(f[g>>2]|0)|0)/12|0)>>>0)}ei[f[(f[a>>2]|0)+12>>2]&511](a,c,R,h);R=f[h>>2]|0;if(R|0){h=f[Q>>2]|0;if((h|0)!=(R|0))f[Q>>2]=h+(~((h+-4-R|0)>>>2)<<2);cYc(R)}R=f[g>>2]|0;if(!R){u=e;return}h=f[N>>2]|0;if((h|0)==(R|0))X=R;else{Q=h;while(1){h=Q+-12|0;f[N>>2]=h;if((b[h+11>>0]|0)<0){cYc(f[h>>2]|0);Y=f[N>>2]|0}else Y=h;if((Y|0)==(R|0))break;else Q=Y}X=f[g>>2]|0}cYc(X);u=e;return}function SJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;if((f[c+12>>2]|0)<=(d|0)){j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=25;k=j;l=381268;m=k+25|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+25>>0]=0;vM(-215,g,381294,381160,85)}lYc(g,f[(f[c+20>>2]|0)+4+(d<<2)>>2]|0);mYc(h,g,0,KYc(g,58,-1)|0,g);d=g+11|0;if((b[d>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[d>>0]=0}sYc(g,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];c=f[a+12>>2]|0;if((c|0)<=0){SGa(i,381307,g);n=AYc(i,505847)|0;f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];f[h+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;vM(-212,h,381294,381160,96)}j=f[a+20>>2]|0;a=b[d>>0]|0;d=a<<24>>24<0;l=d?f[g+4>>2]|0:a&255;a=f[g>>2]|0;k=d?a:g;m=(l|0)==0;o=0;a:while(1){p=f[j+4+(o<<2)>>2]|0;q=f[p+60>>2]|0;r=b[q+11>>0]|0;s=r<<24>>24<0;t=r&255;do if(((s?f[q+4>>2]|0:t)|0)==(l|0)){r=f[q>>2]|0;v=s?r:q;if(s){if(m)break a;if(!(WKc(v,k,l)|0))break a;else break}if(m)break a;if((r&255)<<24>>24==(b[k>>0]|0)){r=q;v=t;w=k;do{v=v+-1|0;r=r+1|0;if(!v)break a;w=w+1|0}while((b[r>>0]|0)==(b[w>>0]|0))}}while(0);o=o+1|0;if((o|0)>=(c|0)){x=17;break}}if((x|0)==17){SGa(i,381307,g);n=AYc(i,505847)|0;f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];f[h+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;vM(-212,h,381294,381160,96)}if(!d){u=e;return p|0}cYc(a);u=e;return p|0}function TJa(a){a=a|0;NXc(a);cYc(a);return}function UJa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function VJa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==381329?a+12|0:0)|0}function WJa(a){a=a|0;cYc(a);return}function XJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[d+4>>2]|0;i=f[d>>2]|0;j=i;a:do if((h|0)==(i|0)){k=a+8|0;l=k;m=a+4|0;n=f[k>>2]|0}else{k=a+4|0;o=a+8|0;p=f[o>>2]|0;q=(p-(f[k>>2]|0)|0)/12|0;r=h-i>>2;s=p;p=0;while(1){if((f[j+(p<<2)>>2]|0)>=(q|0))break;p=p+1|0;if(p>>>0>=r>>>0){l=o;m=k;n=s;break a}}s=$Xc(32)|0;f[g>>2]=s;f[g+8>>2]=-2147483616;f[g+4>>2]=30;k=s;o=381626;r=k+30|0;do{b[k>>0]=b[o>>0]|0;k=k+1|0;o=o+1|0}while((k|0)<(r|0));b[s+30>>0]=0;vM(-215,g,381657,381160,44)}while(0);if((n|0)==(f[a+12>>2]|0))NN(m,c);else{lYc(n,c);f[l>>2]=(f[l>>2]|0)+12}c=a+20|0;n=f[c>>2]|0;if((n|0)==(f[a+24>>2]|0)){fKa(a+16|0,d);t=f[l>>2]|0;v=f[m>>2]|0;w=t-v|0;x=(w|0)/12|0;y=x+-1|0;u=e;return y|0}else{eKa(n,d);f[c>>2]=(f[c>>2]|0)+12;t=f[l>>2]|0;v=f[m>>2]|0;w=t-v|0;x=(w|0)/12|0;y=x+-1|0;u=e;return y|0}return 0}function YJa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i>>2]=c;f[i+4>>2]=d;f[i+8>>2]=e;f[i+12>>2]=g;k=((g|0)!=-1&1)+(((e|0)!=-1&1)+(((d|0)!=-1&1)+((c|0)!=-1&1)))|0;f[j>>2]=0;c=j+4|0;f[c>>2]=0;f[j+8>>2]=0;d=k<<2;if(k|0){e=$Xc(d)|0;f[j>>2]=e;f[j+8>>2]=e+(k<<2);o1c(e|0,i|0,d|0)|0;f[c>>2]=e+(k<<2)}k=XJa(a,b,j)|0;b=f[j>>2]|0;if(!b){u=h;return k|0}j=f[c>>2]|0;if((j|0)!=(b|0))f[c>>2]=j+(~((j+-4-b|0)>>>2)<<2);cYc(b);u=h;return k|0}function ZJa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=u;u=u+48|0;l=k+16|0;m=k;f[l>>2]=d;f[l+4>>2]=e;f[l+8>>2]=g;f[l+12>>2]=h;f[l+16>>2]=i;f[l+20>>2]=j;n=((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/12|0;if(!((n|0)>(d|0)&(n|0)>(e|0)&(n|0)>(g|0)&(n|0)>(h|0)&(n|0)>(i|0)&(n|0)>(j|0))){n=$Xc(48)|0;f[m>>2]=n;f[m+8>>2]=-2147483600;f[m+4>>2]=33;o=n;p=381579;q=o+33|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+33>>0]=0;vM(-215,m,381613,381160,62)}n=((j|0)!=-1&1)+(((i|0)!=-1&1)+(((h|0)!=-1&1)+(((g|0)!=-1&1)+(((e|0)!=-1&1)+((d|0)!=-1&1)))))|0;f[m>>2]=0;d=m+4|0;f[d>>2]=0;f[m+8>>2]=0;e=n<<2;if(n|0){g=$Xc(e)|0;f[m>>2]=g;f[m+8>>2]=g+(n<<2);o1c(g|0,l|0,e|0)|0;f[d>>2]=g+(n<<2)}dKa(a,c,m);c=f[m>>2]|0;if(!c){u=k;return}m=f[d>>2]|0;if((m|0)!=(c|0))f[d>>2]=m+(~((m+-4-c|0)>>>2)<<2);cYc(c);u=k;return}function _Ja(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=81400;c=f[a+52>>2]|0;if(c|0){d=a+56|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);cYc(c)}c=f[a+40>>2]|0;if(c|0){e=a+44|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-4-c|0)>>>2)<<2);cYc(c)}c=a+28|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+16|0;d=f[c>>2]|0;if(d|0){e=a+20|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;while(1){g=i+-12|0;f[e>>2]=g;j=f[g>>2]|0;if(!j)k=g;else{g=i+-8|0;l=f[g>>2]|0;if((l|0)!=(j|0))f[g>>2]=l+(~((l+-4-j|0)>>>2)<<2);cYc(j);k=f[e>>2]|0}if((k|0)==(d|0))break;else i=k}h=f[c>>2]|0}cYc(h)}h=a+4|0;c=f[h>>2]|0;if(!c)return;k=a+8|0;a=f[k>>2]|0;if((a|0)==(c|0))m=c;else{i=a;while(1){a=i+-12|0;f[k>>2]=a;if((b[a+11>>0]|0)<0){cYc(f[a>>2]|0);n=f[k>>2]|0}else n=a;if((n|0)==(c|0))break;else i=n}m=f[h>>2]|0}cYc(m);return}function $Ja(a){a=a|0;_Ja(a);cYc(a);return}function aKa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;g=u;u=u+16|0;h=g;f[h>>2]=d;i=f[e>>2]|0;j=e+4|0;k=f[j>>2]|0;if((k|0)!=(i|0))f[j>>2]=k+(~((k+-4-i|0)>>>2)<<2);i=a+40|0;k=a+44|0;cKa(e,(f[k>>2]|0)-(f[i>>2]|0)>>2);l=f[c+12>>2]|0;if((f[k>>2]|0)==(f[i>>2]|0)){m=1;u=g;return m|0}n=c+20|0;o=a+4|0;p=a+16|0;a=e+8|0;q=0;r=d;a:while(1){b:do if((r|0)<(l|0)){d=r;while(1){s=f[(f[(f[n>>2]|0)+4+(d<<2)>>2]|0)+64>>2]|0;t=b[s+11>>0]|0;if(((t<<24>>24<0?f[s+4>>2]|0:t&255)|0)!=5){v=d;break b}t=(LYc(s,0,-1,381538,5)|0)==0;s=f[h>>2]|0;if(!t){v=s;break b}t=s+1|0;f[h>>2]=t;if((t|0)<(l|0))d=t;else{v=t;break}}}else v=r;while(0);if((v|0)>=(l|0)){m=0;w=38;break}d=f[(f[n>>2]|0)+4+(v<<2)>>2]|0;t=f[d+64>>2]|0;s=f[(f[i>>2]|0)+(q<<2)>>2]|0;x=f[o>>2]|0;y=x+(s*12|0)|0;z=b[t+11>>0]|0;A=z<<24>>24<0;B=z&255;z=A?f[t+4>>2]|0:B;C=b[y+11>>0]|0;D=C<<24>>24<0;if((z|0)!=((D?f[x+(s*12|0)+4>>2]|0:C&255)|0)){m=0;w=38;break}C=f[t>>2]|0;E=A?C:t;F=D?f[y>>2]|0:y;y=(z|0)==0;c:do if(A){if(!y?WKc(E,F,z)|0:0){m=0;w=38;break a}}else if(!y){if((C&255)<<24>>24==(b[F>>0]|0)){G=t;H=B;I=F}else{m=0;w=38;break a}while(1){H=H+-1|0;G=G+1|0;if(!H)break c;I=I+1|0;if((b[G>>0]|0)!=(b[I>>0]|0)){m=0;w=38;break a}}}while(0);F=f[p>>2]|0;B=F+(s*12|0)|0;t=F+(s*12|0)+4|0;F=f[t>>2]|0;C=f[B>>2]|0;if((F-C>>2|0)!=(f[d+12>>2]|0)){m=0;w=38;break}if((F|0)!=(C|0)){F=0;y=C;C=x;while(1){z=f[y+(F<<2)>>2]|0;E=b[C+(z*12|0)+11>>0]|0;if(E<<24>>24<0)J=f[C+(z*12|0)+4>>2]|0;else J=E&255;d:do if(J){E=(SJa(c,d,F)|0)+64|0;z=f[E>>2]|0;E=f[B>>2]|0;A=f[E+(F<<2)>>2]|0;D=f[o>>2]|0;K=D+(A*12|0)|0;L=b[z+11>>0]|0;M=L<<24>>24<0;N=L&255;L=M?f[z+4>>2]|0:N;O=b[K+11>>0]|0;P=O<<24>>24<0;Q=E;if((L|0)!=((P?f[D+(A*12|0)+4>>2]|0:O&255)|0)){m=0;w=38;break a}O=f[z>>2]|0;A=M?O:z;E=P?f[K>>2]|0:K;K=(L|0)==0;if(M){if(K){R=Q;S=D;break}if(!(WKc(A,E,L)|0)){R=Q;S=D;break}else{m=0;w=38;break a}}if(K){R=Q;S=D}else{if((O&255)<<24>>24==(b[E>>0]|0)){T=z;U=N;V=E}else{m=0;w=38;break a}while(1){U=U+-1|0;T=T+1|0;if(!U){R=Q;S=D;break d}V=V+1|0;if((b[T>>0]|0)!=(b[V>>0]|0)){m=0;w=38;break a}}}}else{R=y;S=C}while(0);F=F+1|0;if(F>>>0>=(f[t>>2]|0)-R>>2>>>0)break;else{y=R;C=S}}}C=f[j>>2]|0;if((C|0)==(f[a>>2]|0))Tv(e,h);else{f[C>>2]=f[h>>2];f[j>>2]=C+4}r=(f[h>>2]|0)+1|0;f[h>>2]=r;q=q+1|0;if(q>>>0>=(f[k>>2]|0)-(f[i>>2]|0)>>2>>>0){m=1;w=38;break}}if((w|0)==38){u=g;return m|0}return 0}function bKa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function cKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>2;i=$Xc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;cYc(d);return}function dKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e;h=a+52|0;if((h|0)!=(d|0))eEa(h,f[d>>2]|0,f[d+4>>2]|0);oYc(a+28|0,c)|0;c=a+40|0;d=f[c>>2]|0;i=a+44|0;j=f[i>>2]|0;if((j|0)!=(d|0))f[i>>2]=j+(~((j+-4-d|0)>>>2)<<2);f[g>>2]=0;d=a+4|0;j=a+8|0;k=f[d>>2]|0;if((f[j>>2]|0)==(k|0)){u=e;return}l=a+56|0;m=a+48|0;a=k;k=0;do{n=a;o=f[h>>2]|0;p=f[l>>2]|0;a:do if((o|0)==(p|0)){q=o;r=11}else{s=o;while(1){if((f[s>>2]|0)==(k|0)){q=s;r=11;break a}s=s+4|0;if((s|0)==(p|0)){r=12;break}}}while(0);if((r|0)==11?(r=0,(q|0)==(p|0)):0)r=12;do if((r|0)==12){r=0;o=n+(k*12|0)|0;s=b[o+11>>0]|0;if(((s<<24>>24<0?f[n+(k*12|0)+4>>2]|0:s&255)|0)==5?(LYc(o,0,-1,381538,5)|0)==0:0)break;o=f[i>>2]|0;if((o|0)==(f[m>>2]|0)){Tv(c,g);break}else{f[o>>2]=f[g>>2];f[i>>2]=o+4;break}}while(0);k=(f[g>>2]|0)+1|0;f[g>>2]=k;a=f[d>>2]|0}while(k>>>0<(((f[j>>2]|0)-a|0)/12|0)>>>0);u=e;return}function eKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;o1c(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function fKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;eKa(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{d=e+-12|0;o=i;i=i+-12|0;f[d>>2]=0;p=e+-8|0;f[p>>2]=0;f[e+-4>>2]=0;f[d>>2]=f[i>>2];d=o+-8|0;f[p>>2]=f[d>>2];p=o+-4|0;f[e+-4>>2]=f[p>>2];f[p>>2]=0;f[d>>2]=0;f[i>>2]=0;e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-4-b|0)>>>2)<<2);cYc(b)}}while((h|0)!=(g|0))}if(!m)return;cYc(m);return}function gKa(a){a=a|0;_Ja(a);cYc(a);return}function hKa(a){a=a|0;NXc(a);cYc(a);return}function iKa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function jKa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==381722?a+12|0:0)|0}function kKa(a){a=a|0;cYc(a);return}function lKa(a){a=a|0;_Ja(a);cYc(a);return}function mKa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;a=u;u=u+160|0;g=a+136|0;h=a+80|0;i=a+40|0;j=a;k=a+64|0;l=f[(f[e>>2]|0)+4>>2]|0;elc(l+24|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=g+11|0;b[m>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;n=AIa(l+48|0,g)|0;nKa(h,(f[n+20>>2]|0)==8?f[n+8>>2]|0:530864);if((b[m>>0]|0)<0)cYc(f[g>>2]|0);m=h+4|0;n=f[m>>2]|0;l=(n|0)<3;if(l)o=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{p=f[h+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((o|0)!=2){if(l){t=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;nV(t,2,81440)}l=f[h+40>>2]|0;o=0;r=1;while(1){q=Y(f[l+(o<<2)>>2]|0,r)|0;o=o+1|0;if((o|0)==(n|0)){t=q;break}else r=q}nV(t,2,81440)}t=f[h>>2]&4095;if((t|0)!=4)kV(t,4,81468);t=f[(f[e>>2]|0)+4>>2]|0;e=t+24|0;elc(e);dlc(e);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;r=vJa(uJa(t+48|0,g)|0)|0;if((b[e>>0]|0)<0)cYc(f[g>>2]|0);f[r+40>>2]=0;e=f[r+152>>2]|0;do if((e|0)!=537368){t=e+11|0;if((b[t>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[t>>0]=0;break}}while(0);e=h+16|0;t=h+44|0;n=f[f[e>>2]>>2]|0;o=r+40|0;l=f[o>>2]|0;if((l|0)==(f[r+44>>2]|0)){qHa(o,l+1|0);v=f[o>>2]|0}else v=l;l=f[r+48>>2]|0;f[o>>2]=v+1;f[l+4+(v<<2)>>2]=n;n=oKa(c)|0;pKa(n,381538);AN(g,f[d+60>>2]|0,381962);c=n+60|0;v=f[n+4>>2]|0;l=v&-2;if(!(v&1))w=l;else w=f[l+4>>2]|0;l=f[c>>2]|0;if((l|0)==537368)xJa(c,w,g);else oYc(l,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);ISa(i);l=(vJa(i)|0)+160|0;f[l>>2]=3;l=vJa(i)|0;w=f[(f[e>>2]|0)+4>>2]|0;c=l+40|0;v=f[c>>2]|0;if((v|0)==(f[l+44>>2]|0)){qHa(c,v+1|0);x=f[c>>2]|0}else x=v;v=f[l+48>>2]|0;f[c>>2]=x+1;f[v+4+(x<<2)>>2]=w;w=n+24|0;elc(w);dlc(w);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=k+11|0;b[w>>0]=5;b[k>>0]=b[502066]|0;b[k+1>>0]=b[502067]|0;b[k+2>>0]=b[502068]|0;b[k+3>>0]=b[502069]|0;b[k+4>>0]=b[502070]|0;b[k+5>>0]=0;lYc(j,k);x=j+16|0;jUa(x,i);qKa(g,f[n+56>>2]|0,j);if(b[g+12>>0]|0){v=rKa(n+48|0,j)|0;f[(f[g>>2]|0)+12>>2]=v}ESa(x);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[w>>0]|0)<0)cYc(f[k>>2]|0);k=f[n+60>>2]|0;oYc(pHa(d+8|0)|0,k)|0;ESa(i);i=h+36|0;k=f[i>>2]|0;if(k|0?(d=k+12|0,k=f[d>>2]|0,f[d>>2]=k+-1,(k|0)==1):0)V$(h);f[i>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[m>>2]|0)>0){e=f[h+40>>2]|0;i=0;do{f[e+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[t>>2]|0;if((m|0)==(h+48|0)){u=a;return}wL(m);u=a;return}function nKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+144|0;e=d+128|0;g=d+72|0;h=d+16|0;i=d;j=f[c+152>>2]|0;switch(f[c+160>>2]|0){case 1:{k=b[j+11>>0]|0;l=k<<24>>24<0;if(l)m=f[j+4>>2]|0;else m=k&255;if(!m){m=f[c+8>>2]|0;if(!m){n=$Xc(16)|0;f[e>>2]=n;f[e+8>>2]=-2147483632;f[e+4>>2]=14;o=n;p=389913;q=o+14|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+14>>0]=0;vM(-215,e,382185,381160,720)}n=f[c+16>>2]|0;r=(n|0)==0?0:n+4|0;f[g>>2]=1124007941;n=g+4|0;f[n>>2]=2;s=g+8|0;f[s>>2]=1;f[g+12>>2]=m;t=g+16|0;f[t>>2]=r;f[g+20>>2]=r;v=g+24|0;w=g+40|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[w>>2]=s;s=g+48|0;x=g+44|0;f[x>>2]=s;y=g+52|0;f[y>>2]=0;f[s>>2]=0;if(!r){z=$Xc(32)|0;f[e>>2]=z;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=z;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[z+28>>0]=0;vM(-215,e,470343,470347,548)}z=m<<2;f[s>>2]=z;f[y>>2]=4;y=r+z|0;f[g+28>>2]=y;f[v>>2]=y+(0-z)+z;R$(g);f[a>>2]=1124007936;z=a+8|0;y=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[y>>2]=z;z=a+48|0;f[a+44>>2]=z;f[z>>2]=0;f[a+52>>2]=0;z=e+8|0;f[z>>2]=0;f[z+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;jR(g,e);z=g+36|0;y=f[z>>2]|0;if(y|0?(v=y+12|0,y=f[v>>2]|0,f[v>>2]=y+-1,(y|0)==1):0)V$(g);f[z>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[n>>2]|0)>0){t=f[w>>2]|0;w=0;do{f[t+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[n>>2]|0))}n=f[x>>2]|0;if((n|0)!=(s|0))wL(n);u=d;return}if(l){A=f[j+4>>2]|0;B=f[j>>2]|0}else{A=k&255;B=j}k=A>>>2;f[g>>2]=1124007941;A=g+4|0;f[A>>2]=2;l=g+8|0;f[l>>2]=1;f[g+12>>2]=k;n=g+16|0;f[n>>2]=B;f[g+20>>2]=B;s=g+24|0;x=g+40|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[x>>2]=l;l=g+48|0;w=g+44|0;f[w>>2]=l;t=g+52|0;f[t>>2]=0;f[l>>2]=0;if((k|0)!=0&(B|0)==0){z=$Xc(32)|0;f[e>>2]=z;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=z;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[z+28>>0]=0;vM(-215,e,470343,470347,548)}z=k<<2;f[l>>2]=z;f[t>>2]=4;t=B+z|0;f[g+28>>2]=t;f[s>>2]=t+(0-z)+z;R$(g);f[a>>2]=1124007936;z=a+8|0;t=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[t>>2]=z;z=a+48|0;f[a+44>>2]=z;f[z>>2]=0;f[a+52>>2]=0;z=e+8|0;f[z>>2]=0;f[z+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;jR(g,e);z=g+36|0;t=f[z>>2]|0;if(t|0?(s=t+12|0,t=f[s>>2]|0,f[s>>2]=t+-1,(t|0)==1):0)V$(g);f[z>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[A>>2]|0)>0){n=f[x>>2]|0;x=0;do{f[n+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[A>>2]|0))}A=f[w>>2]|0;if((A|0)!=(l|0))wL(A);u=d;return}case 2:{A=b[j+11>>0]|0;l=A<<24>>24<0;if(l)C=f[j+4>>2]|0;else C=A&255;if(!C){C=f[c+24>>2]|0;if(!C){w=$Xc(16)|0;f[e>>2]=w;f[e+8>>2]=-2147483632;f[e+4>>2]=14;o=w;p=389913;q=o+14|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[w+14>>0]=0;vM(-215,e,382185,381160,731)}w=f[c+32>>2]|0;x=(w|0)==0?0:w+8|0;f[g>>2]=1124007942;w=g+4|0;f[w>>2]=2;n=g+8|0;f[n>>2]=1;f[g+12>>2]=C;z=g+16|0;f[z>>2]=x;f[g+20>>2]=x;t=g+24|0;s=g+40|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[s>>2]=n;n=g+48|0;B=g+44|0;f[B>>2]=n;k=g+52|0;f[k>>2]=0;f[n>>2]=0;if(!x){y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=y;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[y+28>>0]=0;vM(-215,e,470343,470347,548)}y=C<<3;f[n>>2]=y;f[k>>2]=8;k=x+y|0;f[g+28>>2]=k;f[t>>2]=k+(0-y)+y;R$(g);f[a>>2]=1124007936;y=a+8|0;k=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[k>>2]=y;y=a+48|0;f[a+44>>2]=y;f[y>>2]=0;f[a+52>>2]=0;y=e+8|0;f[y>>2]=0;f[y+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;jR(g,e);y=g+36|0;k=f[y>>2]|0;if(k|0?(t=k+12|0,k=f[t>>2]|0,f[t>>2]=k+-1,(k|0)==1):0)V$(g);f[y>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[w>>2]|0)>0){z=f[s>>2]|0;s=0;do{f[z+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[w>>2]|0))}w=f[B>>2]|0;if((w|0)!=(n|0))wL(w);u=d;return}if(l){D=f[j+4>>2]|0;E=f[j>>2]|0}else{D=A&255;E=j}A=D>>>3;f[g>>2]=1124007942;D=g+4|0;f[D>>2]=2;l=g+8|0;f[l>>2]=1;f[g+12>>2]=A;w=g+16|0;f[w>>2]=E;f[g+20>>2]=E;n=g+24|0;B=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[B>>2]=l;l=g+48|0;s=g+44|0;f[s>>2]=l;z=g+52|0;f[z>>2]=0;f[l>>2]=0;if((A|0)!=0&(E|0)==0){y=$Xc(32)|0;f[e>>2]=y;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=y;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[y+28>>0]=0;vM(-215,e,470343,470347,548)}y=A<<3;f[l>>2]=y;f[z>>2]=8;z=E+y|0;f[g+28>>2]=z;f[n>>2]=z+(0-y)+y;R$(g);f[a>>2]=1124007936;y=a+8|0;z=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[z>>2]=y;y=a+48|0;f[a+44>>2]=y;f[y>>2]=0;f[a+52>>2]=0;y=e+8|0;f[y>>2]=0;f[y+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;jR(g,e);y=g+36|0;z=f[y>>2]|0;if(z|0?(n=z+12|0,z=f[n>>2]|0,f[n>>2]=z+-1,(z|0)==1):0)V$(g);f[y>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[D>>2]|0)>0){w=f[B>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[D>>2]|0))}D=f[s>>2]|0;if((D|0)!=(l|0))wL(D);u=d;return}case 3:{D=b[j+11>>0]|0;l=D<<24>>24<0;if(l)F=f[j+4>>2]|0;else F=D&255;if(!F){F=f[c+40>>2]|0;if(!F){s=$Xc(16)|0;f[e>>2]=s;f[e+8>>2]=-2147483632;f[e+4>>2]=14;o=s;p=389913;q=o+14|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[s+14>>0]=0;vM(-215,e,382185,381160,742)}s=f[c+48>>2]|0;B=(s|0)==0?0:s+4|0;f[g>>2]=1124007940;s=g+4|0;f[s>>2]=2;w=g+8|0;f[w>>2]=1;f[g+12>>2]=F;y=g+16|0;f[y>>2]=B;f[g+20>>2]=B;z=g+24|0;n=g+40|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[n>>2]=w;w=g+48|0;E=g+44|0;f[E>>2]=w;A=g+52|0;f[A>>2]=0;f[w>>2]=0;if(!B){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=k;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[k+28>>0]=0;vM(-215,e,470343,470347,548)}k=F<<2;f[w>>2]=k;f[A>>2]=4;A=B+k|0;f[g+28>>2]=A;f[z>>2]=A+(0-k)+k;R$(g);f[a>>2]=1124007936;k=a+8|0;A=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[A>>2]=k;k=a+48|0;f[a+44>>2]=k;f[k>>2]=0;f[a+52>>2]=0;k=e+8|0;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;jR(g,e);k=g+36|0;A=f[k>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)V$(g);f[k>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[s>>2]|0)>0){y=f[n>>2]|0;n=0;do{f[y+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[s>>2]|0))}s=f[E>>2]|0;if((s|0)!=(w|0))wL(s);u=d;return}if(l){G=f[j+4>>2]|0;H=f[j>>2]|0}else{G=D&255;H=j}D=G>>>2;f[g>>2]=1124007940;G=g+4|0;f[G>>2]=2;l=g+8|0;f[l>>2]=1;f[g+12>>2]=D;s=g+16|0;f[s>>2]=H;f[g+20>>2]=H;w=g+24|0;E=g+40|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[E>>2]=l;l=g+48|0;n=g+44|0;f[n>>2]=l;y=g+52|0;f[y>>2]=0;f[l>>2]=0;if((D|0)!=0&(H|0)==0){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=k;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[k+28>>0]=0;vM(-215,e,470343,470347,548)}k=D<<2;f[l>>2]=k;f[y>>2]=4;y=H+k|0;f[g+28>>2]=y;f[w>>2]=y+(0-k)+k;R$(g);f[a>>2]=1124007936;k=a+8|0;y=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[y>>2]=k;k=a+48|0;f[a+44>>2]=k;f[k>>2]=0;f[a+52>>2]=0;k=e+8|0;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;jR(g,e);k=g+36|0;y=f[k>>2]|0;if(y|0?(w=y+12|0,y=f[w>>2]|0,f[w>>2]=y+-1,(y|0)==1):0)V$(g);f[k>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[G>>2]|0)>0){s=f[E>>2]|0;E=0;do{f[s+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[G>>2]|0))}G=f[n>>2]|0;if((G|0)!=(l|0))wL(G);u=d;return}case 19:{f[g>>2]=1124007936;G=g+4|0;l=g+8|0;n=g+40|0;o=G;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=l;E=g+48|0;s=g+44|0;f[s>>2]=E;f[E>>2]=0;f[g+52>>2]=0;k=b[j+11>>0]|0;y=k<<24>>24<0;if(y)I=f[j+4>>2]|0;else I=k&255;if(!I){I=f[c+136>>2]|0;if(!I){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;w=$Xc(16)|0;f[e>>2]=w;f[e+8>>2]=-2147483632;f[e+4>>2]=14;o=w;p=389913;q=o+14|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[w+14>>0]=0;vM(-215,e,382185,381160,757)}w=f[c+144>>2]|0;c=(w|0)==0?0:w+4|0;f[h>>2]=1124007940;w=h+4|0;f[w>>2]=2;H=h+8|0;f[H>>2]=1;f[h+12>>2]=I;D=h+16|0;f[D>>2]=c;f[h+20>>2]=c;A=h+24|0;z=h+40|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[z>>2]=H;H=h+48|0;B=h+44|0;f[B>>2]=H;F=h+52|0;f[F>>2]=0;f[H>>2]=0;if(!c){t=$Xc(32)|0;f[e>>2]=t;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=t;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[t+28>>0]=0;vM(-215,e,470343,470347,548)}t=I<<2;f[H>>2]=t;f[F>>2]=4;F=c+t|0;f[h+28>>2]=F;f[A>>2]=F+(0-t)+t;R$(h);t=e+8|0;f[t>>2]=0;f[t+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=g;dY(h,e,2,1.0,0.0);t=h+36|0;F=f[t>>2]|0;if(F|0?(A=F+12|0,F=f[A>>2]|0,f[A>>2]=F+-1,(F|0)==1):0)V$(h);f[t>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){D=f[z>>2]|0;z=0;do{f[D+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[w>>2]|0))}w=f[B>>2]|0;if((w|0)!=(H|0))wL(w);J=g+16|0}else{if(y){K=f[j+4>>2]|0;L=f[j>>2]|0}else{K=k&255;L=j}k=K>>>1;f[h>>2]=1124007938;K=h+4|0;f[K>>2]=2;y=h+8|0;f[y>>2]=1;w=h+12|0;f[w>>2]=k;H=h+16|0;f[H>>2]=L;B=h+20|0;f[B>>2]=L;z=h+24|0;D=h+28|0;t=h+40|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[t>>2]=y;F=h+48|0;f[h+44>>2]=F;A=h+52|0;f[A>>2]=0;f[F>>2]=0;if((k|0)!=0&(L|0)==0){c=$Xc(32)|0;f[e>>2]=c;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=c;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[c+28>>0]=0;vM(-215,e,470343,470347,548)}c=k<<1;f[F>>2]=c;f[A>>2]=2;A=L+c|0;f[D>>2]=A;f[z>>2]=A+(0-c)+c;R$(h);c=g+36|0;A=f[c>>2]|0;if(A|0?(L=A+12|0,A=f[L>>2]|0,f[L>>2]=A+-1,(A|0)==1):0)V$(g);f[c>>2]=0;A=g+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[G>>2]|0)>0){L=f[n>>2]|0;k=0;do{f[L+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[G>>2]|0))}f[g>>2]=f[h>>2];k=f[K>>2]|0;f[G>>2]=k;f[l>>2]=f[y>>2];f[g+12>>2]=f[w>>2];f[A>>2]=f[H>>2];f[g+20>>2]=f[B>>2];f[g+24>>2]=f[z>>2];f[g+28>>2]=f[D>>2];f[g+32>>2]=f[h+32>>2];D=h+36|0;f[c>>2]=f[D>>2];c=g+44|0;z=f[c>>2]|0;if((z|0)==(E|0))M=k;else{wL(z);f[c>>2]=E;f[n>>2]=l;M=f[K>>2]|0}l=h+44|0;if((M|0)<3){M=f[l>>2]|0;f[E>>2]=f[M>>2];f[g+52>>2]=f[M+4>>2];N=M}else{f[c>>2]=f[l>>2];f[g+40>>2]=f[t>>2];f[l>>2]=F;f[t>>2]=y;N=F}f[h>>2]=1124007936;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;f[K+16>>2]=0;f[K+20>>2]=0;f[K+24>>2]=0;f[K+28>>2]=0;f[D>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((N|0)!=(F|0))wL(N);J=A}A=f[n>>2]|0;N=f[A+4>>2]|0;F=f[A>>2]|0;A=f[J>>2]|0;f[h>>2]=1124007939;H=h+4|0;f[H>>2]=2;D=h+8|0;f[D>>2]=F;f[h+12>>2]=N;K=h+16|0;f[K>>2]=A;f[h+20>>2]=A;y=h+24|0;t=h+40|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[t>>2]=D;D=h+48|0;l=h+44|0;f[l>>2]=D;c=h+52|0;f[c>>2]=0;f[D>>2]=0;if((Y(F,N)|0)!=0&(A|0)==0){M=$Xc(32)|0;f[e>>2]=M;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=M;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[M+28>>0]=0;vM(-215,e,470343,470347,577)}M=N<<1;f[D>>2]=M;f[c>>2]=2;c=A+(Y(F,M)|0)|0;f[h+28>>2]=c;f[y>>2]=c+(0-M)+M;R$(h);M=f[n>>2]|0;c=f[M+4>>2]|0;y=f[M>>2]|0;f[a>>2]=1124007936;M=a+8|0;F=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[F>>2]=M;M=a+48|0;f[a+44>>2]=M;f[M>>2]=0;f[a+52>>2]=0;f[e>>2]=y;f[e+4>>2]=c;S$(a,2,e,5);f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;c=i+8|0;f[c>>2]=0;f[c+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;eY(e,i);i=h+36|0;c=f[i>>2]|0;if(c|0?(y=c+12|0,c=f[y>>2]|0,f[y>>2]=c+-1,(c|0)==1):0)V$(h);f[i>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[H>>2]|0)>0){K=f[t>>2]|0;t=0;do{f[K+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[H>>2]|0))}H=f[l>>2]|0;if((H|0)!=(D|0))wL(H);H=g+36|0;D=f[H>>2]|0;if(D|0?(l=D+12|0,D=f[l>>2]|0,f[l>>2]=D+-1,(D|0)==1):0)V$(g);f[H>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[G>>2]|0)>0){J=f[n>>2]|0;n=0;do{f[J+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[G>>2]|0))}G=f[s>>2]|0;if((G|0)!=(E|0))wL(G);u=d;return}case 12:{G=b[j+11>>0]|0;E=G<<24>>24<0;if(E)O=f[j+4>>2]|0;else O=G&255;if(!O){O=$Xc(32)|0;f[e>>2]=O;f[e+8>>2]=-2147483616;f[e+4>>2]=16;o=O;p=382202;q=o+16|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[O+16>>0]=0;vM(-215,e,382185,381160,769)}if(E){P=f[j+4>>2]|0;Q=f[j>>2]|0}else{P=G&255;Q=j}f[g>>2]=1124007936;j=g+4|0;f[j>>2]=2;G=g+8|0;f[G>>2]=1;f[g+12>>2]=P;E=g+16|0;f[E>>2]=Q;f[g+20>>2]=Q;O=g+24|0;s=g+40|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[s>>2]=G;G=g+48|0;n=g+44|0;f[n>>2]=G;J=g+52|0;f[J>>2]=0;f[G>>2]=0;if((P|0)!=0&(Q|0)==0){H=$Xc(32)|0;f[e>>2]=H;f[e+8>>2]=-2147483616;f[e+4>>2]=28;o=H;p=470314;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[H+28>>0]=0;vM(-215,e,470343,470347,548)}f[G>>2]=P;f[J>>2]=1;J=Q+P|0;f[g+28>>2]=J;f[O>>2]=J+(0-P)+P;R$(g);f[a>>2]=1124007936;P=a+8|0;J=a+40|0;o=a+4|0;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[J>>2]=P;P=a+48|0;f[a+44>>2]=P;f[P>>2]=0;f[a+52>>2]=0;P=e+8|0;f[P>>2]=0;f[P+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;jR(g,e);a=g+36|0;P=f[a>>2]|0;if(P|0?(J=P+12|0,P=f[J>>2]|0,f[J>>2]=P+-1,(P|0)==1):0)V$(g);f[a>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[j>>2]|0)>0){E=f[s>>2]|0;s=0;do{f[E+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[j>>2]|0))}j=f[n>>2]|0;if((j|0)!=(G|0))wL(j);u=d;return}default:{d=$Xc(48)|0;f[e>>2]=d;f[e+8>>2]=-2147483600;f[e+4>>2]=35;o=d;p=382219;q=o+35|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[d+35>>0]=0;vM(-2,e,382185,381160,773)}}}function oKa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+8|0;c=a+20|0;d=f[c>>2]|0;do if(!d){e=a+12|0;g=f[a+16>>2]|0;h=6}else{i=a+12|0;j=f[i>>2]|0;k=f[d>>2]|0;if((j|0)>=(k|0))if((k|0)==(f[a+16>>2]|0)){e=i;g=k;h=6;break}else{l=i;m=k;n=d;break}f[i>>2]=j+1;o=f[d+4+(j<<2)>>2]|0;return o|0}while(0);if((h|0)==6){XZb(b,g+1|0);g=f[c>>2]|0;l=e;m=f[g>>2]|0;n=g}f[n>>2]=m+1;m=f[b>>2]|0;if(!m){b=$Xc(76)|0;qVa(b);p=b}else{if(f[m+64>>2]|0)SXb(m,15600,80);b=QXb(m,80)|0;AWa(b,m);p=b}b=f[c>>2]|0;c=f[l>>2]|0;f[l>>2]=c+1;f[b+4+(c<<2)>>2]=p;o=p;return o|0}function pKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=dJc(c)|0;if(g>>>0>4294967279)jYc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=$Xc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+64|0;a=f[h>>2]|0;if((a|0)==537368)xJa(h,m,e);else oYc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function qKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;yIa(g,c,d,0);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;b[a+12>>0]=0;u=e;return}k=(f[c>>2]|0)+1|0;j=f[c+4>>2]|0;i=j*12|0;l=i>>>4;if(l>>>0>k>>>0){if(j>>>0>8&i>>>6>>>0>=k>>>0){i=((k*5|0)>>>2)+1|0;k=1;while(1)if(i<<k>>>0<l>>>0)k=k+1|0;else break;l=j>>>k;k=l>>>0>8?l:8;if((k|0)!=(j|0)){fJa(c,k);m=11}}}else if(j>>>0<=134217728){fJa(c,j<<1);m=11}if((m|0)==11){yIa(h,c,d,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2]}m=f[g+12>>2]|0;g=f[c+20>>2]|0;if(!g)n=$Xc(20)|0;else{if(f[g+64>>2]|0)SXb(g,25480,24);n=QXb(g,24)|0}lYc(n,d);gJa(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];b[a+12>>0]=1;u=e;return}function rKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=$Xc(40)|0;lYc(d,b);jUa(d+16|0,b+16|0);e=d;return e|0}if(f[c+64>>2]|0)SXb(c,25480,40);d=QXb(c,40)|0;c=f[a>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;eJa(c,d);c=d+16|0;JSa(c,f[a>>2]|0);oYc(d,b)|0;kUa(c,b+16|0);e=d;return e|0}function sKa(a){a=a|0;NXc(a);cYc(a);return}function tKa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function uKa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==382306?a+12|0:0)|0}function vKa(a){a=a|0;cYc(a);return}function wKa(a){a=a|0;_Ja(a);cYc(a);return}function xKa(a){a=a|0;NXc(a);cYc(a);return}function yKa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function zKa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==382574?a+12|0:0)|0}function AKa(a){a=a|0;cYc(a);return}function BKa(a){a=a|0;_Ja(a);cYc(a);return}function CKa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+32|0;a=c+12|0;g=c;h=d+24|0;elc(h);i=d+48|0;f[g+8>>2]=0;d=g+11|0;b[d>>0]=7;b[g>>0]=b[435010]|0;b[g+1>>0]=b[435011]|0;b[g+2>>0]=b[435012]|0;b[g+3>>0]=b[435013]|0;b[g+4>>0]=b[435014]|0;b[g+5>>0]=b[435015]|0;b[g+6>>0]=b[435016]|0;b[g+7>>0]=0;j=AIa(i,g)|0;lYc(a,(f[j+20>>2]|0)==2?f[j+8>>2]|0:537368);if((b[d>>0]|0)<0)cYc(f[g>>2]|0);d=a+11|0;j=b[d>>0]|0;if(((j<<24>>24<0?f[a+4>>2]|0:j&255)|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=$Xc(32)|0;f[g>>2]=k;l=g+8|0;f[l>>2]=-2147483616;m=g+4|0;f[m>>2]=17;n=k;o=382813;p=n+17|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+17|0;b[q>>0]=0;vM(-215,g,455619,381160,528)}if(LYc(a,0,-1,453591,4)|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=$Xc(32)|0;f[g>>2]=k;l=g+8|0;f[l>>2]=-2147483616;m=g+4|0;f[m>>2]=17;n=k;o=382813;p=n+17|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+17|0;b[q>>0]=0;vM(-215,g,455619,381160,528)}elc(h);f[g+8>>2]=0;h=g+11|0;b[h>>0]=7;b[g>>0]=b[390066]|0;b[g+1>>0]=b[390067]|0;b[g+2>>0]=b[390068]|0;b[g+3>>0]=b[390069]|0;b[g+4>>0]=b[390070]|0;b[g+5>>0]=b[390071]|0;b[g+6>>0]=b[390072]|0;b[g+7>>0]=0;q=AIa(i,g)|0;i=(f[q+20>>2]|0)==1?f[q+8>>2]|0:530552;if((b[h>>0]|0)<0)cYc(f[g>>2]|0);if((f[i+24>>2]|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=$Xc(32)|0;f[g>>2]=h;f[g+8>>2]=-2147483616;f[g+4>>2]=21;n=h;o=382831;p=n+21|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+21>>0]=0;vM(-215,g,455619,381160,531)}h=f[i+32>>2]|0;i=f[h+16>>2]|0;o=f[h+24>>2]|0;h=f[f[e>>2]>>2]|0;e=h+24|0;elc(e);dlc(e);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;n=vJa(uJa(h+48|0,g)|0)|0;if((b[e>>0]|0)<0)cYc(f[g>>2]|0);f[n+40>>2]=0;g=n+40|0;e=n+44|0;if(!(f[e>>2]|0)){qHa(g,1);r=f[g>>2]|0}else r=0;h=n+48|0;n=f[h>>2]|0;f[g>>2]=r+1;f[n+4+(r<<2)>>2]=-1;r=f[g>>2]|0;if((r|0)==(f[e>>2]|0)){qHa(g,r+1|0);s=f[g>>2]|0;t=f[h>>2]|0}else{s=r;t=n}f[g>>2]=s+1;f[t+4+(s<<2)>>2]=i;i=f[g>>2]|0;if((i|0)==(f[e>>2]|0)){qHa(g,i+1|0);v=f[g>>2]|0;w=f[h>>2]|0}else{v=i;w=t}f[g>>2]=v+1;f[w+4+(v<<2)>>2]=o;o=f[g>>2]|0;if((o|0)==(f[e>>2]|0)){qHa(g,o+1|0);x=f[g>>2]|0;y=f[h>>2]|0}else{x=o;y=w}f[g>>2]=x+1;f[y+4+(x<<2)>>2]=-1;if((b[d>>0]|0)>=0){u=c;return}cYc(f[a>>2]|0);u=c;return}function DKa(a){a=a|0;NXc(a);cYc(a);return}function EKa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function FKa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==382911?a+12|0:0)|0}function GKa(a){a=a|0;cYc(a);return}function HKa(a){a=a|0;_Ja(a);cYc(a);return}function IKa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+32|0;a=c+12|0;g=c;elc(d+24|0);f[g+8>>2]=0;h=g+11|0;b[h>>0]=7;b[g>>0]=b[435010]|0;b[g+1>>0]=b[435011]|0;b[g+2>>0]=b[435012]|0;b[g+3>>0]=b[435013]|0;b[g+4>>0]=b[435014]|0;b[g+5>>0]=b[435015]|0;b[g+6>>0]=b[435016]|0;b[g+7>>0]=0;i=AIa(d+48|0,g)|0;lYc(a,(f[i+20>>2]|0)==2?f[i+8>>2]|0:537368);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=a+11|0;i=b[h>>0]|0;if(((i<<24>>24<0?f[a+4>>2]|0:i&255)|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(32)|0;f[g>>2]=j;k=g+8|0;f[k>>2]=-2147483616;l=g+4|0;f[l>>2]=18;m=j;n=383132;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+18|0;b[p>>0]=0;vM(-215,g,455619,381160,469)}if(LYc(a,0,-1,453585,5)|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(32)|0;f[g>>2]=j;k=g+8|0;f[k>>2]=-2147483616;l=g+4|0;f[l>>2]=18;m=j;n=383132;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+18|0;b[p>>0]=0;vM(-215,g,455619,381160,469)}p=f[(f[e>>2]|0)+4>>2]|0;j=p+24|0;elc(j);dlc(j);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;l=uJa(p+48|0,g)|0;p=f[((f[l+20>>2]|0)==8?f[l+8>>2]|0:530864)+156>>2]|0;l=p|0?p:531248;if((b[j>>0]|0)<0)cYc(f[g>>2]|0);if((f[l+12>>2]|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=27;m=j;n=383151;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[j+27>>0]=0;vM(-215,g,455619,381160,474)}j=f[l+20>>2]|0;l=f[(f[j+4>>2]|0)+16>>2]|0;n=f[(f[j+8>>2]|0)+16>>2]|0;j=f[f[e>>2]>>2]|0;e=j+24|0;elc(e);dlc(e);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;m=vJa(uJa(j+48|0,g)|0)|0;if((b[e>>0]|0)<0)cYc(f[g>>2]|0);f[m+40>>2]=0;g=m+40|0;e=m+44|0;if(!(f[e>>2]|0)){qHa(g,1);q=f[g>>2]|0}else q=0;j=m+48|0;m=f[j>>2]|0;f[g>>2]=q+1;f[m+4+(q<<2)>>2]=-1;q=f[g>>2]|0;if((q|0)==(f[e>>2]|0)){qHa(g,q+1|0);r=f[g>>2]|0;s=f[j>>2]|0}else{r=q;s=m}f[g>>2]=r+1;f[s+4+(r<<2)>>2]=l;l=f[g>>2]|0;if((l|0)==(f[e>>2]|0)){qHa(g,l+1|0);t=f[g>>2]|0;v=f[j>>2]|0}else{t=l;v=s}f[g>>2]=t+1;f[v+4+(t<<2)>>2]=n;n=f[g>>2]|0;if((n|0)==(f[e>>2]|0)){qHa(g,n+1|0);w=f[g>>2]|0;x=f[j>>2]|0}else{w=n;x=v}f[g>>2]=w+1;f[x+4+(w<<2)>>2]=-1;if((b[h>>0]|0)>=0){u=c;return}cYc(f[a>>2]|0);u=c;return}function JKa(a){a=a|0;NXc(a);cYc(a);return}function KKa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function LKa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==383238?a+12|0:0)|0}function MKa(a){a=a|0;cYc(a);return}function NKa(a){a=a|0;_Ja(a);cYc(a);return}function OKa(a){a=a|0;NXc(a);cYc(a);return}function PKa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function QKa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==383508?a+12|0:0)|0}function RKa(a){a=a|0;cYc(a);return}function SKa(a){a=a|0;_Ja(a);cYc(a);return}function TKa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+32|0;g=c+12|0;h=c;i=a+64|0;a=(f[i>>2]|0)+1|0;f[g>>2]=0;j=g+4|0;f[j>>2]=0;f[g+8>>2]=0;if(a>>>0>1073741823)kWc(g);k=a<<2;l=$Xc(k)|0;f[g>>2]=l;m=l+(a<<2)|0;f[g+8>>2]=m;g1c(l|0,0,k|0)|0;f[j>>2]=m;f[l>>2]=-1;if((f[i>>2]|0)>0){l=h+11|0;m=h+5|0;k=0;do{k=k+1|0;a=f[(f[e>>2]|0)+(k<<2)>>2]|0;elc(a+24|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[l>>0]=5;b[h>>0]=b[502066]|0;b[h+1>>0]=b[502067]|0;b[h+2>>0]=b[502068]|0;b[h+3>>0]=b[502069]|0;b[h+4>>0]=b[502070]|0;b[m>>0]=0;n=AIa(a+48|0,h)|0;f[(f[g>>2]|0)+(k<<2)>>2]=f[(f[((f[n+20>>2]|0)==8?f[n+8>>2]|0:530864)+48>>2]|0)+4>>2];if((b[l>>0]|0)<0)cYc(f[h>>2]|0)}while((k|0)<(f[i>>2]|0))}k=f[(f[e>>2]|0)+4>>2]|0;e=k+24|0;elc(e);dlc(e);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;e=h+11|0;b[e>>0]=5;b[h>>0]=b[502066]|0;b[h+1>>0]=b[502067]|0;b[h+2>>0]=b[502068]|0;b[h+3>>0]=b[502069]|0;b[h+4>>0]=b[502070]|0;b[h+5>>0]=0;l=vJa(uJa(k+48|0,h)|0)|0;if((b[e>>0]|0)<0)cYc(f[h>>2]|0);h=d+8|0;e=f[i>>2]|0;i=e+-1|0;if((e|0)>1){e=d+20|0;d=0;do{k=f[(f[e>>2]|0)+4+(d+2<<2)>>2]|0;if(!((k|0)==0|(f[h>>2]|0)!=0)){if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);cYc(k)}d=d+1|0}while((d|0)!=(i|0));YZb(h,2,i)}f[l+40>>2]=0;i=f[j>>2]|0;h=f[g>>2]|0;d=h;e=i;a:do if((i|0)==(h|0)){o=d;p=e}else{k=l+40|0;m=l+44|0;n=l+48|0;a=0;q=e;r=d;s=h;t=i;v=d;w=0;while(1){x=f[v+(a<<2)>>2]|0;if((w|0)==(f[m>>2]|0)){qHa(k,w+1|0);y=f[j>>2]|0;z=f[g>>2]|0;A=f[k>>2]|0;B=z;C=y;D=y;E=z}else{A=w;B=s;C=t;D=q;E=r}z=f[n>>2]|0;f[k>>2]=A+1;f[z+4+(A<<2)>>2]=x;x=a+1|0;if(x>>>0>=C-B>>2>>>0){o=E;p=D;break a}a=x;q=D;r=E;s=B;t=C;v=B;w=f[k>>2]|0}}while(0);if(!o){u=c;return}if((p|0)!=(o|0))f[j>>2]=p+(~((p+-4-o|0)>>>2)<<2);cYc(o);u=c;return}function UKa(a){a=a|0;NXc(a);cYc(a);return}function VKa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function WKa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==383755?a+12|0:0)|0}function XKa(a){a=a|0;cYc(a);return}function YKa(a){a=a|0;_Ja(a);cYc(a);return}function ZKa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+16|0;i=g;if(!(aKa(a,c,d,e)|0)){j=0;u=g;return j|0}e=f[(f[c+20>>2]|0)+4+(d+1<<2)>>2]|0;elc(e+24|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=i+11|0;b[d>>0]=5;b[i>>0]=b[502066]|0;b[i+1>>0]=b[502067]|0;b[i+2>>0]=b[502068]|0;b[i+3>>0]=b[502069]|0;b[i+4>>0]=b[502070]|0;b[i+5>>0]=0;c=AIa(e+48|0,i)|0;nKa(h,(f[c+20>>2]|0)==8?f[c+8>>2]|0:530864);if((b[d>>0]|0)<0)cYc(f[i>>2]|0);if((f[h>>2]&4095|0)==5){i=f[h+4>>2]|0;if((i|0)<3)k=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{d=f[h+40>>2]|0;c=0;e=1;while(1){a=Y(f[d+(c<<2)>>2]|0,e)|0;c=c+1|0;if((c|0)==(i|0)){k=a;break}else e=a}}if((k|0)==1)l=+n[f[h+16>>2]>>2]==6.0;else l=0}else l=0;k=h+36|0;e=f[k>>2]|0;if(e|0?(i=e+12|0,e=f[i>>2]|0,f[i>>2]=e+-1,(e|0)==1):0)V$(h);f[k>>2]=0;k=h+16|0;e=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[e>>2]|0)>0){k=f[h+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)!=(h+48|0))wL(e);j=l;u=g;return j|0}function _Ka(a){a=a|0;NXc(a);cYc(a);return}function $Ka(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function aLa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==384010?a+12|0:0)|0}function bLa(a){a=a|0;cYc(a);return}function cLa(a){a=a|0;_Ja(a);cYc(a);return}function dLa(a){a=a|0;NXc(a);cYc(a);return}function eLa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function fLa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==384273?a+12|0:0)|0}function gLa(a){a=a|0;cYc(a);return}function hLa(a){a=a|0;_Ja(a);cYc(a);return}function iLa(a){a=a|0;NXc(a);cYc(a);return}function jLa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function kLa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==384520?a+12|0:0)|0}function lLa(a){a=a|0;cYc(a);return}function mLa(a){a=a|0;_Ja(a);cYc(a);return}function nLa(a){a=a|0;NXc(a);cYc(a);return}function oLa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function pLa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==384752?a+12|0:0)|0}function qLa(a){a=a|0;cYc(a);return}function rLa(a){a=a|0;_Ja(a);cYc(a);return}function sLa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=u;u=u+160|0;g=a+136|0;h=a+80|0;i=a+40|0;j=a;k=a+64|0;l=f[(f[e+4>>2]|0)+-4>>2]|0;elc(l+24|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=g+11|0;b[e>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;m=AIa(l+48|0,g)|0;nKa(h,(f[m+20>>2]|0)==8?f[m+8>>2]|0:530864);if((b[e>>0]|0)<0)cYc(f[g>>2]|0);e=h+4|0;m=f[e>>2]|0;l=(m|0)<3;if(l)n=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{o=f[h+40>>2]|0;p=0;q=1;while(1){r=Y(f[o+(p<<2)>>2]|0,q)|0;p=p+1|0;if((p|0)==(m|0)){n=r;break}else q=r}}if((n|0)!=1){if(l){s=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;nV(s,1,81736)}l=f[h+40>>2]|0;n=0;q=1;while(1){p=Y(f[l+(n<<2)>>2]|0,q)|0;n=n+1|0;if((n|0)==(m|0)){s=p;break}else q=p}nV(s,1,81736)}s=f[h>>2]&4095;if((s|0)!=5)kV(s,5,81764);s=d+20|0;q=f[s>>2]|0;m=d+12|0;n=(f[m>>2]|0)+-1|0;f[m>>2]=n;m=f[q+4+(n<<2)>>2]|0;n=m+11|0;if((b[n>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0}else{b[m>>0]=0;b[n>>0]=0}LWa(d);ISa(i);n=h+16|0;m=f[f[n>>2]>>2]|0;q=i+20|0;if((f[q>>2]|0)!=4){jSa(i);f[q>>2]=4}f[i+8>>2]=m;m=d+24|0;elc(m);dlc(m);f[k+8>>2]=0;m=k+11|0;b[m>>0]=7;b[k>>0]=b[390628]|0;b[k+1>>0]=b[390629]|0;b[k+2>>0]=b[390630]|0;b[k+3>>0]=b[390631]|0;b[k+4>>0]=b[390632]|0;b[k+5>>0]=b[390633]|0;b[k+6>>0]=b[390634]|0;b[k+7>>0]=0;lYc(j,k);q=j+16|0;jUa(q,i);qKa(g,f[d+56>>2]|0,j);if(b[g+12>>0]|0){l=rKa(d+48|0,j)|0;f[(f[g>>2]|0)+12>>2]=l}ESa(q);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[m>>0]|0)<0)cYc(f[k>>2]|0);m=oKa(c)|0;pKa(m,381538);AN(g,f[d+60>>2]|0,384974);d=m+60|0;c=f[m+4>>2]|0;q=c&-2;if(!(c&1))t=q;else t=f[q+4>>2]|0;q=f[d>>2]|0;if((q|0)==537368)xJa(d,t,g);else oYc(q,g)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);q=m+24|0;elc(q);dlc(q);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=k+11|0;b[q>>0]=5;b[k>>0]=b[502066]|0;b[k+1>>0]=b[502067]|0;b[k+2>>0]=b[502068]|0;b[k+3>>0]=b[502069]|0;b[k+4>>0]=b[502070]|0;b[k+5>>0]=0;lYc(j,k);t=j+16|0;jUa(t,i);qKa(g,f[m+56>>2]|0,j);if(b[g+12>>0]|0){d=rKa(m+48|0,j)|0;f[(f[g>>2]|0)+12>>2]=d}ESa(t);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[q>>0]|0)<0)cYc(f[k>>2]|0);oYc(f[(f[s>>2]|0)+8>>2]|0,f[m+60>>2]|0)|0;ESa(i);i=h+36|0;m=f[i>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)V$(h);f[i>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[e>>2]|0)>0){n=f[h+40>>2]|0;i=0;do{f[n+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=a;return}wL(e);u=a;return}function tLa(a){a=a|0;NXc(a);cYc(a);return}function uLa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function vLa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==385220?a+12|0:0)|0}function wLa(a){a=a|0;cYc(a);return}function xLa(a){a=a|0;_Ja(a);cYc(a);return}function yLa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+160|0;a=c+136|0;g=c+80|0;h=c+40|0;i=c;j=c+64|0;k=f[(f[e+4>>2]|0)+-4>>2]|0;elc(k+24|0);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=a+11|0;b[e>>0]=5;b[a>>0]=b[502066]|0;b[a+1>>0]=b[502067]|0;b[a+2>>0]=b[502068]|0;b[a+3>>0]=b[502069]|0;b[a+4>>0]=b[502070]|0;b[a+5>>0]=0;l=AIa(k+48|0,a)|0;nKa(g,(f[l+20>>2]|0)==8?f[l+8>>2]|0:530864);if((b[e>>0]|0)<0)cYc(f[a>>2]|0);e=g+4|0;l=f[e>>2]|0;k=(l|0)<3;if(k)m=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{n=f[g+40>>2]|0;o=0;p=1;while(1){q=Y(f[n+(o<<2)>>2]|0,p)|0;o=o+1|0;if((o|0)==(l|0)){m=q;break}else p=q}}if((m|0)!=1){if(k){r=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;nV(r,1,81816)}k=f[g+40>>2]|0;m=0;p=1;while(1){o=Y(f[k+(m<<2)>>2]|0,p)|0;m=m+1|0;if((m|0)==(l|0)){r=o;break}else p=o}nV(r,1,81816)}r=f[g>>2]&4095;if((r|0)!=5)kV(r,5,81844);r=f[d+20>>2]|0;p=d+12|0;l=(f[p>>2]|0)+-1|0;f[p>>2]=l;p=f[r+4+(l<<2)>>2]|0;l=p+11|0;if((b[l>>0]|0)<0){b[f[p>>2]>>0]=0;f[p+4>>2]=0}else{b[p>>0]=0;b[l>>0]=0}LWa(d);ISa(h);l=g+16|0;p=f[f[l>>2]>>2]|0;r=h+20|0;if((f[r>>2]|0)!=4){jSa(h);f[r>>2]=4}f[h+8>>2]=p;p=d+24|0;elc(p);dlc(p);f[j+8>>2]=0;p=j+11|0;b[p>>0]=7;b[j>>0]=b[390628]|0;b[j+1>>0]=b[390629]|0;b[j+2>>0]=b[390630]|0;b[j+3>>0]=b[390631]|0;b[j+4>>0]=b[390632]|0;b[j+5>>0]=b[390633]|0;b[j+6>>0]=b[390634]|0;b[j+7>>0]=0;lYc(i,j);r=i+16|0;jUa(r,h);qKa(a,f[d+56>>2]|0,i);if(b[a+12>>0]|0){m=rKa(d+48|0,i)|0;f[(f[a>>2]|0)+12>>2]=m}ESa(r);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[p>>0]|0)<0)cYc(f[j>>2]|0);ESa(h);h=g+36|0;j=f[h>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)V$(g);f[h>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[e>>2]|0)>0){l=f[g+40>>2]|0;h=0;do{f[l+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[e>>2]|0))}e=f[g+44>>2]|0;if((e|0)==(g+48|0)){u=c;return}wL(e);u=c;return}function zLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+48|0;d=c;e=c+36|0;g=c+24|0;h=c+12|0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+4|0;f[e>>2]=i;f[g>>2]=0;j=g+4|0;f[j>>2]=0;f[g+8>>2]=0;k=f[a+12>>2]|0;f[d>>2]=0;l=(k|0)>0;if(l){m=a+20|0;n=h+11|0;o=h+4|0;p=g+8|0;q=0;do{r=f[(f[m>>2]|0)+4+(q<<2)>>2]|0;lYc(h,f[r+64>>2]|0);s=b[n>>0]|0;t=f[o>>2]|0;if(((s<<24>>24<0?t:s&255)|0)==8)if(!(LYc(h,0,-1,428991,8)|0))v=11;else{w=b[n>>0]|0;x=f[o>>2]|0;v=9}else{w=s;x=t;v=9}if(((v|0)==9?(v=0,((w<<24>>24<0?x:w&255)|0)==7):0)?(LYc(h,0,-1,396650,7)|0)==0:0)v=11;if((v|0)==11){v=0;t=f[j>>2]|0;if((t|0)==(f[p>>2]|0))Tv(g,d);else{f[t>>2]=f[d>>2];f[j>>2]=t+4}t=f[(f[r+20>>2]|0)+4>>2]|0;oYc(ALa(e,f[r+60>>2]|0)|0,t)|0}if((b[n>>0]|0)<0)cYc(f[h>>2]|0);q=(f[d>>2]|0)+1|0;f[d>>2]=q}while((q|0)<(k|0));if(l){l=a+20|0;q=d+11|0;h=0;do{n=f[(f[l>>2]|0)+4+(h<<2)>>2]|0;p=n+12|0;if((f[p>>2]|0)>0){v=n+20|0;n=0;do{lYc(d,f[(f[v>>2]|0)+4+(n<<2)>>2]|0);w=BLa(e,d)|0;if((w|0)!=(i|0))oYc(f[(f[v>>2]|0)+4+(n<<2)>>2]|0,w+28|0)|0;if((b[q>>0]|0)<0)cYc(f[d>>2]|0);n=n+1|0}while((n|0)<(f[p>>2]|0))}h=h+1|0}while((h|0)<(k|0))}}mMc(f[g>>2]|0,f[j>>2]|0,d);d=f[j>>2]|0;k=f[g>>2]|0;h=k;if((d|0)==(k|0)){y=d;z=h}else{d=a+8|0;k=a+20|0;a=0;q=h;while(1){h=(f[q+(a<<2)>>2]|0)-a|0;l=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;if(!((l|0)==0|(f[d>>2]|0)!=0))Yi[f[(f[l>>2]|0)+4>>2]&4095](l);YZb(d,h,1);a=a+1|0;h=f[j>>2]|0;l=f[g>>2]|0;p=l;if(a>>>0>=h-l>>2>>>0){y=h;z=p;break}else q=p}}q=y;if(!z){A=f[i>>2]|0;CLa(e,A);u=c;return}if((q|0)!=(z|0))f[j>>2]=q+(~((q+-4-z|0)>>>2)<<2);cYc(z);A=f[i>>2]|0;CLa(e,A);u=c;return}function ALa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=DLa(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=$Xc(40)|0;lYc(g+16|0,b);b=g+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}UQ(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function BLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function CLa(a,c){a=a|0;c=c|0;var d=0;if(!c)return;CLa(a,f[c>>2]|0);CLa(a,f[c+4>>2]|0);a=c+16|0;d=c+28|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function DLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function ELa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+152|0;d=a+4|0;e=f[d>>2]|0;g=e&-2;if(!(e&1))h=g;else h=f[g+4>>2]|0;g=f[c>>2]|0;if((g|0)==537368){xJa(c,h,537368);i=f[c>>2]|0}else i=g;g=b[i+11>>0]|0;if(g<<24>>24<0)j=f[i+4>>2]|0;else j=g&255;if(!j)return;j=f[d>>2]|0;d=j&-2;if(!(j&1))k=d;else k=f[d+4>>2]|0;d=a+152|0;if((i|0)==537368)return;if(!k){f[d>>2]=537368;if(!i)return;else{l=i;m=g}}else{g=$Xc(12)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[d>>2]=537368;l=g;m=b[g+11>>0]|0}if(m<<24>>24<0)cYc(f[l>>2]|0);cYc(l);return}function FLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;oOa(a);h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+16>>2]=a+20;f[a+32>>2]=0;f[a+36>>2]=0;f[a+28>>2]=a+32;f[a+44>>2]=0;f[a+48>>2]=0;f[a+40>>2]=a+44;j=a+52|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=sMa(c,391014,0)|0;c=$Xc(20)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=81928;a=c+12|0;f[a>>2]=j;f[a+4>>2]=2240;TXc(c);f[h>>2]=j;j=f[i>>2]|0;f[i>>2]=c;if(j|0)UXc(j);UXc(c);c=f[h>>2]|0;if(c|0?RMa(c)|0:0){c=f[h>>2]|0;if(d){SMa(c);u=e;return}else{TMa(c);u=e;return}};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(32)|0;f[g>>2]=e;f[g+8>>2]=-2147483616;f[g+4>>2]=29;c=e;d=388301;h=c+29|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(h|0));b[e+29>>0]=0;vM(-215,g,388331,385609,141)}function GLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+32|0;d=c;e=c+12|0;g=a+8|0;switch(UMa(f[g>>2]|0)|0){case 4:{h=UMa(f[g>>2]|0)|0;JLa(a,h);i=a+16|0;j=a+20|0;k=f[j>>2]|0;do if(k){l=a+20|0;m=k;while(1){n=f[m+16>>2]|0;if((h|0)<(n|0)){o=f[m>>2]|0;if(!o){p=7;break}else{q=m;r=o}}else{if((n|0)>=(h|0)){p=11;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=10;break}else{q=s;r=n}}l=q;m=r}if((p|0)==7){t=m;v=m;break}else if((p|0)==10){t=m;v=s;break}else if((p|0)==11){t=m;v=l;break}}else{t=j;v=j}while(0);if(f[v>>2]|0){u=c;return}j=$Xc(20)|0;f[j+16>>2]=h;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=t;f[v>>2]=j;t=f[f[i>>2]>>2]|0;if(!t)w=j;else{f[i>>2]=t;w=f[v>>2]|0}UQ(f[a+20>>2]|0,w);w=a+24|0;f[w>>2]=(f[w>>2]|0)+1;u=c;return}case 1:{+WMa(f[g>>2]|0);u=c;return}case 5:{UMa(f[g>>2]|0)|0;u=c;return}case 2:{w=UMa(f[g>>2]|0)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;if(w>>>0>4294967279)jYc(d);if(w>>>0<11){v=d+11|0;b[v>>0]=w;if(!w){x=d;y=v}else{z=d;A=v;p=24}}else{v=w+16&-16;t=$Xc(v)|0;f[d>>2]=t;f[d+8>>2]=v|-2147483648;f[d+4>>2]=w;z=t;A=d+11|0;p=24}if((p|0)==24){g1c(z|0,0,w|0)|0;x=z;y=A}b[x+w>>0]=0;IMa(f[g>>2]|0,(b[y>>0]|0)<0?f[d>>2]|0:d,w)|0;if((b[d+11>>0]|0)>=0){u=c;return}cYc(f[d>>2]|0);u=c;return}case 3:{KLa(a,-1);u=c;return}case 0:{u=c;return}default:{c=$Xc(32)|0;f[e>>2]=c;f[e+8>>2]=-2147483616;f[e+4>>2]=20;a=c;d=385690;w=a+20|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(w|0));b[c+20>>0]=0;vM(-213,e,385711,385609,1019)}}}function HLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!b)return;HLa(a,f[b>>2]|0);HLa(a,f[b+4>>2]|0);a=b+20|0;c=b+56|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(a);f[c>>2]=0;c=b+36|0;a=b+24|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[b+60>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[b+64>>2]|0;if((a|0)!=(b+68|0))wL(a);cYc(b);return}function ILa(a,b){a=a|0;b=b|0;if(!b)return;else{ILa(a,f[b>>2]|0);ILa(a,f[b+4>>2]|0);cYc(b);return}}function JLa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0.0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0;e=u;u=u+768|0;g=e+576|0;h=e+752|0;i=e+740|0;j=e+728|0;k=e+716|0;l=e+704|0;m=e+696|0;o=e+72|0;q=e+16|0;r=e;s=e+352|0;t=e+680|0;v=e+128|0;w=e+668|0;x=e+656|0;y=e+644|0;z=e+632|0;f[h>>2]=c;A=a+16|0;B=a+20|0;C=f[B>>2]|0;a:do if(C|0){D=C;while(1){E=f[D+16>>2]|0;if((E|0)>(c|0))F=D;else{if((E|0)>=(c|0))break;F=D+4|0}D=f[F>>2]|0;if(!D)break a}u=e;return}while(0);LLa(i,a);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;F=MLa(i,385722,385729)|0;do if((F|0)>-1)NLa(a,f[h>>2]|0,F);else{c=MLa(i,385736,385729)|0;if((c|0)>-1){OLa(a,f[h>>2]|0,c);break}if(!(PLa(i,j)|0)){SGa(k,387679,i);c=AYc(k,505469)|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[g+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-213,g,385937,385609,992)}f[k+4>>2]=0;f[k+8>>2]=0;c=k+4|0;f[k>>2]=c;C=l+4|0;f[C>>2]=0;D=l+8|0;f[D>>2]=0;E=l+4|0;f[l>>2]=E;G=$Xc(84)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;lYc(G,j);lYc(G+12|0,g);H=G+28|0;f[H>>2]=0;f[G+32>>2]=0;f[G+24>>2]=H;H=G+36|0;I=H+48|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[m>>2]=G;K=$Xc(16)|0;f[K+4>>2]=0;f[K+8>>2]=0;f[K>>2]=81880;f[K+12>>2]=G;L=m+4|0;f[L>>2]=K;if((b[g+11>>0]|0)<0){cYc(f[g>>2]|0);M=f[m>>2]|0}else M=G;K=M+24|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;N=$Xc(16)|0;f[g>>2]=N;f[g+8>>2]=-2147483632;f[g+4>>2]=11;H=N;O=385744;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[N+11>>0]=0;aHa(K,g,h)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);G=j+11|0;P=b[G>>0]|0;Q=j+4|0;R=f[Q>>2]|0;if(((P<<24>>24<0?R:P&255)|0)==10)if(!(LYc(j,0,-1,385756,10)|0))S=37;else{T=b[G>>0]|0;U=f[Q>>2]|0;S=19}else{T=P;U=R;S=19}b:do if((S|0)==19){if(((T<<24>>24<0?U:T&255)|0)==8){if(!(LYc(j,0,-1,385767,8)|0)){S=37;break}V=b[G>>0]|0;W=f[Q>>2]|0}else{V=T;W=U}if(((V<<24>>24<0?W:V&255)|0)==6){if(!(LYc(j,0,-1,428960,6)|0)){S=37;break}X=b[G>>0]|0;Z=f[Q>>2]|0}else{X=V;Z=W}if(((X<<24>>24<0?Z:X&255)|0)==11){if(!(LYc(j,0,-1,385776,11)|0)){S=37;break}_=b[G>>0]|0;$=f[Q>>2]|0}else{_=X;$=Z}if(((_<<24>>24<0?$:_&255)|0)==9){if(!(LYc(j,0,-1,385788,9)|0)){S=37;break}aa=b[G>>0]|0;ba=f[Q>>2]|0}else{aa=_;ba=$}if(((aa<<24>>24<0?ba:aa&255)|0)==11){if(!(LYc(j,0,-1,385798,11)|0)){S=37;break}ca=b[G>>0]|0;da=f[Q>>2]|0}else{ca=aa;da=ba}if(((ca<<24>>24<0?da:ca&255)|0)==9){if(!(LYc(j,0,-1,385810,9)|0)){S=37;break}ea=b[G>>0]|0;fa=f[Q>>2]|0}else{ea=ca;fa=da}if(((ea<<24>>24<0?fa:ea&255)|0)==18){if(LYc(j,0,-1,385861,18)|0){ga=b[G>>0]|0;ha=f[Q>>2]|0;S=70}}else{ga=ea;ha=fa;S=70}do if((S|0)==70){if(((ga<<24>>24<0?ha:ga&255)|0)==20){if(!(LYc(j,0,-1,385880,20)|0))break;ia=b[G>>0]|0;ja=f[Q>>2]|0}else{ia=ga;ja=ha}do if(((ia<<24>>24<0?ja:ia&255)|0)==16)if(!(LYc(j,0,-1,385997,16)|0)){SLa(a,k,l);break b}else{ka=b[G>>0]|0;la=f[Q>>2]|0;break}else{ka=ia;la=ja}while(0);do if(((ka<<24>>24<0?la:ka&255)|0)==17){if(!(LYc(j,0,-1,386014,17)|0))break;ma=b[G>>0]|0;na=f[Q>>2]|0;S=162}else{ma=ka;na=la;S=162}while(0);do if((S|0)==162){if(((ma<<24>>24<0?na:ma&255)|0)==21){if(!(LYc(j,0,-1,386032,21)|0))break;oa=b[G>>0]|0;pa=f[Q>>2]|0}else{oa=ma;pa=na}do if(((oa<<24>>24<0?pa:oa&255)|0)==6){if(LYc(j,0,-1,386126,6)|0){qa=b[G>>0]|0;ra=f[Q>>2]|0;break}tYc((f[m>>2]|0)+12|0,396578)|0;SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;R=g+11|0;b[R>>0]=6;b[g>>0]=b[385901]|0;b[g+1>>0]=b[385902]|0;b[g+2>>0]=b[385903]|0;b[g+3>>0]=b[385904]|0;b[g+4>>0]=b[385905]|0;b[g+5>>0]=b[385906]|0;b[g+6>>0]=0;P=(TLa(l,g)|0)==0;if((b[R>>0]|0)<0)cYc(f[g>>2]|0);if(P){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P=$Xc(32)|0;f[g>>2]=P;f[g+8>>2]=-2147483616;f[g+4>>2]=28;H=P;O=385908;I=H+28|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[P+28>>0]=0;vM(-215,g,385937,385609,593)};f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;R=q+11|0;b[R>>0]=6;b[q>>0]=b[385901]|0;b[q+1>>0]=b[385902]|0;b[q+2>>0]=b[385903]|0;b[q+3>>0]=b[385904]|0;b[q+4>>0]=b[385905]|0;b[q+5>>0]=b[385906]|0;b[q+6>>0]=0;sa=ULa(l,g,q)|0;ta=f[sa>>2]|0;if(!ta){ua=$Xc(88)|0;va=ua+16|0;f[va>>2]=f[q>>2];f[va+4>>2]=f[q+4>>2];f[va+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[ua+28>>2]=0;f[ua+32>>2]=1124007936;va=ua+40|0;wa=ua+72|0;H=ua+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[wa>>2]=va;P=ua+80|0;f[ua+76>>2]=P;f[P>>2]=0;f[ua+84>>2]=0;P=f[g>>2]|0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=P;f[sa>>2]=ua;P=f[f[l>>2]>>2]|0;if(!P)xa=ua;else{f[l>>2]=P;xa=f[sa>>2]|0}UQ(f[C>>2]|0,xa);f[D>>2]=(f[D>>2]|0)+1;ya=ua}else ya=ta;P=ya+32|0;f[o>>2]=f[P>>2];za=o+4|0;Aa=ya+36|0;f[za>>2]=f[Aa>>2];Ba=o+8|0;f[Ba>>2]=f[ya+40>>2];Ca=o+12|0;f[Ca>>2]=f[ya+44>>2];Da=o+16|0;f[Da>>2]=f[ya+48>>2];Ea=o+20|0;f[Ea>>2]=f[ya+52>>2];Fa=o+24|0;f[Fa>>2]=f[ya+56>>2];Ga=o+28|0;f[Ga>>2]=f[ya+60>>2];Ha=o+32|0;f[Ha>>2]=f[ya+64>>2];Ia=o+36|0;Ja=f[ya+68>>2]|0;f[Ia>>2]=Ja;Ka=o+40|0;f[Ka>>2]=Ba;La=o+48|0;Ma=o+44|0;f[Ma>>2]=La;f[La>>2]=0;f[o+52>>2]=0;if(Ja|0){Na=Ja+12|0;f[Na>>2]=(f[Na>>2]|0)+1}if((f[Aa>>2]|0)<3){Aa=f[ya+76>>2]|0;Na=f[Ma>>2]|0;f[Na>>2]=f[Aa>>2];f[Na+4>>2]=f[Aa+4>>2]}else{f[za>>2]=0;U$(o,P)}if((b[R>>0]|0)<0)cYc(f[q>>2]|0);P=M+36|0;Aa=M+40|0;Na=f[Aa>>2]|0;Ja=M+44|0;if((Na|0)==(f[Ja>>2]|0))bx(P,o);else{f[Na>>2]=f[o>>2];Oa=Na+4|0;f[Oa>>2]=f[za>>2];Pa=Na+8|0;f[Pa>>2]=f[Ba>>2];f[Na+12>>2]=f[Ca>>2];f[Na+16>>2]=f[Da>>2];f[Na+20>>2]=f[Ea>>2];f[Na+24>>2]=f[Fa>>2];f[Na+28>>2]=f[Ga>>2];f[Na+32>>2]=f[Ha>>2];Ha=f[Ia>>2]|0;f[Na+36>>2]=Ha;f[Na+40>>2]=Pa;Pa=Na+48|0;Ga=Na+44|0;f[Ga>>2]=Pa;f[Pa>>2]=0;f[Na+52>>2]=0;if(Ha|0){Pa=Ha+12|0;f[Pa>>2]=(f[Pa>>2]|0)+1}if((f[za>>2]|0)<3){Pa=f[Ma>>2]|0;Ha=f[Ga>>2]|0;f[Ha>>2]=f[Pa>>2];f[Ha+4>>2]=f[Pa+4>>2]}else{f[Oa>>2]=0;U$(Na,o)}f[Aa>>2]=(f[Aa>>2]|0)+56};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Na=g+11|0;b[Na>>0]=4;f[g>>2]=1935763810;b[g+4>>0]=0;Oa=(TLa(l,g)|0)!=0;if((b[Na>>0]|0)<0)cYc(f[g>>2]|0);b[q>>0]=Oa&1;if(Oa){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;Oa=r+11|0;b[Oa>>0]=4;f[r>>2]=1935763810;b[r+4>>0]=0;Na=ULa(l,g,r)|0;Pa=f[Na>>2]|0;if(!Pa){Ha=$Xc(88)|0;Ga=Ha+16|0;f[Ga>>2]=f[r>>2];f[Ga+4>>2]=f[r+4>>2];f[Ga+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[Ha+28>>2]=0;f[Ha+32>>2]=1124007936;Ga=Ha+40|0;Fa=Ha+72|0;H=Ha+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Fa>>2]=Ga;R=Ha+80|0;f[Ha+76>>2]=R;f[R>>2]=0;f[Ha+84>>2]=0;R=f[g>>2]|0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=R;f[Na>>2]=Ha;R=f[f[l>>2]>>2]|0;if(!R)Qa=Ha;else{f[l>>2]=R;Qa=f[Na>>2]|0}UQ(f[C>>2]|0,Qa);f[D>>2]=(f[D>>2]|0)+1;Ra=Ha}else Ra=Pa;R=Ra+32|0;ta=f[Aa>>2]|0;if((ta|0)==(f[Ja>>2]|0))bx(P,R);else{f[ta>>2]=f[R>>2];ua=ta+4|0;sa=Ra+36|0;f[ua>>2]=f[sa>>2];va=ta+8|0;f[va>>2]=f[Ra+40>>2];f[ta+12>>2]=f[Ra+44>>2];f[ta+16>>2]=f[Ra+48>>2];f[ta+20>>2]=f[Ra+52>>2];f[ta+24>>2]=f[Ra+56>>2];f[ta+28>>2]=f[Ra+60>>2];f[ta+32>>2]=f[Ra+64>>2];wa=f[Ra+68>>2]|0;f[ta+36>>2]=wa;f[ta+40>>2]=va;va=ta+48|0;Ea=ta+44|0;f[Ea>>2]=va;f[va>>2]=0;f[ta+52>>2]=0;if(wa|0){va=wa+12|0;f[va>>2]=(f[va>>2]|0)+1}if((f[sa>>2]|0)<3){sa=f[Ra+76>>2]|0;va=f[Ea>>2]|0;f[va>>2]=f[sa>>2];f[va+4>>2]=f[sa+4>>2]}else{f[ua>>2]=0;U$(ta,R)}f[Aa>>2]=(f[Aa>>2]|0)+56}if((b[Oa>>0]|0)<0)cYc(f[r>>2]|0)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;R=g+11|0;b[R>>0]=9;H=g;O=445999;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;cHa(K,g,q)|0;if((b[R>>0]|0)<0)cYc(f[g>>2]|0);Oa=g+11|0;b[Oa>>0]=10;H=g;O=453228;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;aHa(K,g,f[Ka>>2]|0)|0;if((b[Oa>>0]|0)<0)cYc(f[g>>2]|0);R=f[a+68>>2]|0;Aa=R+76|0;P=f[Aa>>2]|0;if((P|0)==(f[R+80>>2]|0))RLa(R+72|0,m);else{f[P>>2]=f[m>>2];R=f[L>>2]|0;f[P+4>>2]=R;if(!R)Sa=P;else{TXc(R);Sa=f[Aa>>2]|0}f[Aa>>2]=Sa+8}Aa=f[Ia>>2]|0;do if(Aa|0){R=Aa+12|0;P=f[R>>2]|0;f[R>>2]=P+-1;if((P|0)!=1)break;V$(o)}while(0);f[Ia>>2]=0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[za>>2]|0)>0){Aa=f[Ka>>2]|0;Oa=0;do{f[Aa+(Oa<<2)>>2]=0;Oa=Oa+1|0}while((Oa|0)<(f[za>>2]|0))}za=f[Ma>>2]|0;if((za|0)!=(La|0))wL(za);break b}else{qa=oa;ra=pa}while(0);do if(((qa<<24>>24<0?ra:qa&255)|0)==7){if(!(LYc(j,0,-1,396499,7)|0))break;Ta=b[G>>0]|0;Ua=f[Q>>2]|0;S=270}else{Ta=qa;Ua=ra;S=270}while(0);do if((S|0)==270){if(((Ta<<24>>24<0?Ua:Ta&255)|0)==4){if(!(LYc(j,0,-1,386133,4)|0))break;Va=b[G>>0]|0;Wa=f[Q>>2]|0}else{Va=Ta;Wa=Ua}do if(((Va<<24>>24<0?Wa:Va&255)|0)==4){if(LYc(j,0,-1,429133,4)|0){Xa=b[G>>0]|0;Ya=f[Q>>2]|0;break}za=f[a+68>>2]|0;Oa=za+72|0;Aa=$Xc(84)|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Ka=o+11|0;b[Ka>>0]=4;f[o>>2]=1431070034;b[o+4>>0]=0;lYc(Aa,j);lYc(Aa+12|0,o);Da=Aa+28|0;f[Da>>2]=0;f[Aa+32>>2]=0;f[Aa+24>>2]=Da;H=Aa+36|0;I=H+48|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[g>>2]=Aa;Da=Aa;Ia=$Xc(16)|0;f[Ia+4>>2]=0;f[Ia+8>>2]=0;f[Ia>>2]=81880;f[Ia+12>>2]=Da;P=g+4|0;f[P>>2]=Ia;R=za+76|0;Ja=f[R>>2]|0;do if(Ja>>>0<(f[za+80>>2]|0)>>>0){f[Ja>>2]=Da;f[Ja+4>>2]=Ia;f[g>>2]=0;f[P>>2]=0;f[R>>2]=Ja+8}else{WLa(Oa,g);Pa=f[P>>2]|0;if(!Pa)break;UXc(Pa)}while(0);if((b[Ka>>0]|0)<0)cYc(f[o>>2]|0);GLa(a);break b}else{Xa=Va;Ya=Wa}while(0);do if(((Xa<<24>>24<0?Ya:Xa&255)|0)==4){if(LYc(j,0,-1,386173,4)|0){Za=b[G>>0]|0;_a=f[Q>>2]|0;break}La=f[a+68>>2]|0;Ma=La+72|0;P=$Xc(84)|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Oa=o+11|0;b[Oa>>0]=4;f[o>>2]=1215193428;b[o+4>>0]=0;lYc(P,j);lYc(P+12|0,o);Ja=P+28|0;f[Ja>>2]=0;f[P+32>>2]=0;f[P+24>>2]=Ja;H=P+36|0;I=H+48|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[g>>2]=P;Ka=P;Ja=$Xc(16)|0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja>>2]=81880;f[Ja+12>>2]=Ka;R=g+4|0;f[R>>2]=Ja;Ia=La+76|0;Da=f[Ia>>2]|0;do if(Da>>>0<(f[La+80>>2]|0)>>>0){f[Da>>2]=Ka;f[Da+4>>2]=Ja;f[g>>2]=0;f[R>>2]=0;f[Ia>>2]=Da+8}else{WLa(Ma,g);za=f[R>>2]|0;if(!za)break;UXc(za)}while(0);if((b[Oa>>0]|0)<0)cYc(f[o>>2]|0);GLa(a);break b}else{Za=Xa;_a=Ya}while(0);do if(((Za<<24>>24<0?_a:Za&255)|0)==7){if(LYc(j,0,-1,396621,7)|0){$a=b[G>>0]|0;ab=f[Q>>2]|0;break}R=f[a+68>>2]|0;Ma=R+72|0;Da=$Xc(84)|0;f[o+8>>2]=0;Ia=o+11|0;b[Ia>>0]=7;b[o>>0]=b[396621]|0;b[o+1>>0]=b[396622]|0;b[o+2>>0]=b[396623]|0;b[o+3>>0]=b[396624]|0;b[o+4>>0]=b[396625]|0;b[o+5>>0]=b[396626]|0;b[o+6>>0]=b[396627]|0;b[o+7>>0]=0;lYc(Da,j);lYc(Da+12|0,o);Ja=Da+28|0;f[Ja>>2]=0;f[Da+32>>2]=0;f[Da+24>>2]=Ja;H=Da+36|0;I=H+48|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[g>>2]=Da;Oa=Da;Ja=$Xc(16)|0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja>>2]=81880;f[Ja+12>>2]=Oa;Ka=g+4|0;f[Ka>>2]=Ja;La=R+76|0;P=f[La>>2]|0;do if(P>>>0<(f[R+80>>2]|0)>>>0){f[P>>2]=Oa;f[P+4>>2]=Ja;f[g>>2]=0;f[Ka>>2]=0;f[La>>2]=P+8}else{WLa(Ma,g);za=f[Ka>>2]|0;if(!za)break;UXc(za)}while(0);if((b[Ia>>0]|0)<0)cYc(f[o>>2]|0);GLa(a);break b}else{$a=Za;ab=_a}while(0);do if((($a<<24>>24<0?ab:$a&255)|0)==25){if(!(LYc(j,0,-1,386178,25)|0))break;bb=b[G>>0]|0;cb=f[Q>>2]|0;S=326}else{bb=$a;cb=ab;S=326}while(0);do if((S|0)==326){if(((bb<<24>>24<0?cb:bb&255)|0)==21){if(!(LYc(j,0,-1,386204,21)|0))break;db=b[G>>0]|0;eb=f[Q>>2]|0}else{db=bb;eb=cb}if(((db<<24>>24<0?eb:db&255)|0)==18){if(!(LYc(j,0,-1,390567,18)|0))break;fb=b[G>>0]|0;gb=f[Q>>2]|0}else{fb=db;gb=eb}do if(((fb<<24>>24<0?gb:fb&255)|0)==5){if(LYc(j,0,-1,396615,5)|0){hb=b[G>>0]|0;ib=f[Q>>2]|0;break}SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=g+11|0;b[Ka>>0]=6;b[g>>0]=b[385901]|0;b[g+1>>0]=b[385902]|0;b[g+2>>0]=b[385903]|0;b[g+3>>0]=b[385904]|0;b[g+4>>0]=b[385905]|0;b[g+5>>0]=b[385906]|0;b[g+6>>0]=0;Ma=(TLa(l,g)|0)==0;if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);if(Ma){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ma=$Xc(32)|0;f[g>>2]=Ma;f[g+8>>2]=-2147483616;f[g+4>>2]=28;H=Ma;O=385908;I=H+28|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ma+28>>0]=0;vM(-215,g,385937,385609,699)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=$Xc(16)|0;f[g>>2]=Ka;f[g+8>>2]=-2147483632;f[g+4>>2]=12;H=Ka;O=385953;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ka+12>>0]=0;Ma=~~+NGa(NIa(k,g)|0,-1);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(!Ma){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;P=o+11|0;b[P>>0]=6;b[o>>0]=b[385901]|0;b[o+1>>0]=b[385902]|0;b[o+2>>0]=b[385903]|0;b[o+3>>0]=b[385904]|0;b[o+4>>0]=b[385905]|0;b[o+5>>0]=b[385906]|0;b[o+6>>0]=0;La=ULa(l,g,o)|0;Ja=f[La>>2]|0;if(!Ja){Oa=$Xc(88)|0;R=Oa+16|0;f[R>>2]=f[o>>2];f[R+4>>2]=f[o+4>>2];f[R+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[Oa+28>>2]=0;f[Oa+32>>2]=1124007936;R=Oa+40|0;Da=Oa+72|0;H=Oa+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Da>>2]=R;Ka=Oa+80|0;f[Oa+76>>2]=Ka;f[Ka>>2]=0;f[Oa+84>>2]=0;Ka=f[g>>2]|0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=Ka;f[La>>2]=Oa;Ka=f[f[l>>2]>>2]|0;if(!Ka)jb=Oa;else{f[l>>2]=Ka;jb=f[La>>2]|0}UQ(f[C>>2]|0,jb);f[D>>2]=(f[D>>2]|0)+1;kb=Oa}else kb=Ja;Ka=f[kb+36>>2]|0;if((Ka|0)<3)lb=Y(f[kb+44>>2]|0,f[kb+40>>2]|0)|0;else{za=f[kb+72>>2]|0;Aa=0;Pa=1;while(1){Ha=Y(f[za+(Aa<<2)>>2]|0,Pa)|0;Aa=Aa+1|0;if((Aa|0)==(Ka|0)){lb=Ha;break}else Pa=Ha}}if((b[P>>0]|0)<0)cYc(f[o>>2]|0);if((lb|0)!=1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Pa=$Xc(48)|0;f[g>>2]=Pa;f[g+8>>2]=-2147483600;f[g+4>>2]=42;H=Pa;O=386379;I=H+42|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Pa+42>>0]=0;vM(-215,g,385937,385609,710)};f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;P=q+11|0;b[P>>0]=6;b[q>>0]=b[385901]|0;b[q+1>>0]=b[385902]|0;b[q+2>>0]=b[385903]|0;b[q+3>>0]=b[385904]|0;b[q+4>>0]=b[385905]|0;b[q+5>>0]=b[385906]|0;b[q+6>>0]=0;Ka=ULa(l,g,q)|0;Aa=f[Ka>>2]|0;if(!Aa){za=$Xc(88)|0;Ja=za+16|0;f[Ja>>2]=f[q>>2];f[Ja+4>>2]=f[q+4>>2];f[Ja+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[za+28>>2]=0;f[za+32>>2]=1124007936;Ja=za+40|0;Oa=za+72|0;H=za+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Oa>>2]=Ja;Pa=za+80|0;f[za+76>>2]=Pa;f[Pa>>2]=0;f[za+84>>2]=0;Pa=f[g>>2]|0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=Pa;f[Ka>>2]=za;Pa=f[f[l>>2]>>2]|0;if(!Pa)mb=za;else{f[l>>2]=Pa;mb=f[Ka>>2]|0}UQ(f[C>>2]|0,mb);f[D>>2]=(f[D>>2]|0)+1;nb=za}else nb=Aa;Pa=f[f[nb+48>>2]>>2]|0;if((b[P>>0]|0)<0)cYc(f[q>>2]|0);f[o>>2]=Pa;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Pa=$Xc(16)|0;f[g>>2]=Pa;f[g+8>>2]=-2147483632;f[g+4>>2]=14;H=Pa;O=429299;I=H+14|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Pa+14>>0]=0;OGa(K,g,o)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);tYc((f[m>>2]|0)+12|0,429133)|0}else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;P=o+11|0;b[P>>0]=6;b[o>>0]=b[385901]|0;b[o+1>>0]=b[385902]|0;b[o+2>>0]=b[385903]|0;b[o+3>>0]=b[385904]|0;b[o+4>>0]=b[385905]|0;b[o+5>>0]=b[385906]|0;b[o+6>>0]=0;Aa=ULa(l,g,o)|0;za=f[Aa>>2]|0;if(!za){Ka=$Xc(88)|0;Ja=Ka+16|0;f[Ja>>2]=f[o>>2];f[Ja+4>>2]=f[o+4>>2];f[Ja+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[Ka+28>>2]=0;f[Ka+32>>2]=1124007936;Ja=Ka+40|0;Oa=Ka+72|0;H=Ka+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Oa>>2]=Ja;Pa=Ka+80|0;f[Ka+76>>2]=Pa;f[Pa>>2]=0;f[Ka+84>>2]=0;Pa=f[g>>2]|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=Pa;f[Aa>>2]=Ka;Pa=f[f[l>>2]>>2]|0;if(!Pa)ob=Ka;else{f[l>>2]=Pa;ob=f[Aa>>2]|0}UQ(f[C>>2]|0,ob);f[D>>2]=(f[D>>2]|0)+1;pb=Ka}else pb=za;Pa=f[pb+36>>2]|0;if((Pa|0)<3)qb=Y(f[pb+44>>2]|0,f[pb+40>>2]|0)|0;else{La=f[pb+72>>2]|0;R=0;Da=1;while(1){Ha=Y(f[La+(R<<2)>>2]|0,Da)|0;R=R+1|0;if((R|0)==(Pa|0)){qb=Ha;break}else Da=Ha}}if((b[P>>0]|0)<0)cYc(f[o>>2]|0);if((qb|0)!=(Ma|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=$Xc(64)|0;f[g>>2]=Da;f[g+8>>2]=-2147483584;f[g+4>>2]=55;H=Da;O=386323;I=H+55|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+55>>0]=0;vM(-215,g,385937,385609,704)}Ma=M+36|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;P=o+11|0;b[P>>0]=6;b[o>>0]=b[385901]|0;b[o+1>>0]=b[385902]|0;b[o+2>>0]=b[385903]|0;b[o+3>>0]=b[385904]|0;b[o+4>>0]=b[385905]|0;b[o+5>>0]=b[385906]|0;b[o+6>>0]=0;Pa=ULa(l,g,o)|0;R=f[Pa>>2]|0;if(!R){La=$Xc(88)|0;za=La+16|0;f[za>>2]=f[o>>2];f[za+4>>2]=f[o+4>>2];f[za+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[La+28>>2]=0;f[La+32>>2]=1124007936;za=La+40|0;Ka=La+72|0;H=La+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ka>>2]=za;Da=La+80|0;f[La+76>>2]=Da;f[Da>>2]=0;f[La+84>>2]=0;Da=f[g>>2]|0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=Da;f[Pa>>2]=La;Da=f[f[l>>2]>>2]|0;if(!Da)rb=La;else{f[l>>2]=Da;rb=f[Pa>>2]|0}UQ(f[C>>2]|0,rb);f[D>>2]=(f[D>>2]|0)+1;sb=La}else sb=R;Da=sb+32|0;Aa=M+40|0;Ja=f[Aa>>2]|0;if((Ja|0)==(f[M+44>>2]|0))bx(Ma,Da);else{f[Ja>>2]=f[Da>>2];Oa=Ja+4|0;Ha=sb+36|0;f[Oa>>2]=f[Ha>>2];Na=Ja+8|0;f[Na>>2]=f[sb+40>>2];f[Ja+12>>2]=f[sb+44>>2];f[Ja+16>>2]=f[sb+48>>2];f[Ja+20>>2]=f[sb+52>>2];f[Ja+24>>2]=f[sb+56>>2];f[Ja+28>>2]=f[sb+60>>2];f[Ja+32>>2]=f[sb+64>>2];Ga=f[sb+68>>2]|0;f[Ja+36>>2]=Ga;f[Ja+40>>2]=Na;Na=Ja+48|0;Fa=Ja+44|0;f[Fa>>2]=Na;f[Na>>2]=0;f[Ja+52>>2]=0;if(Ga|0){Na=Ga+12|0;f[Na>>2]=(f[Na>>2]|0)+1}if((f[Ha>>2]|0)<3){Ha=f[sb+76>>2]|0;Na=f[Fa>>2]|0;f[Na>>2]=f[Ha>>2];f[Na+4>>2]=f[Ha+4>>2]}else{f[Oa>>2]=0;U$(Ja,Da)}f[Aa>>2]=(f[Aa>>2]|0)+56}if((b[P>>0]|0)<0)cYc(f[o>>2]|0);tYc((f[m>>2]|0)+12|0,396601)|0}Aa=f[a+68>>2]|0;Da=Aa+76|0;Ja=f[Da>>2]|0;if((Ja|0)==(f[Aa+80>>2]|0)){RLa(Aa+72|0,m);break b}f[Ja>>2]=f[m>>2];Aa=f[L>>2]|0;f[Ja+4>>2]=Aa;if(!Aa)tb=Ja;else{TXc(Aa);tb=f[Da>>2]|0}f[Da>>2]=tb+8;break b}else{hb=fb;ib=gb}while(0);do if(((hb<<24>>24<0?ib:hb&255)|0)==14){if(!(LYc(j,0,-1,386422,14)|0))break;ub=b[G>>0]|0;vb=f[Q>>2]|0;S=558}else{ub=hb;vb=ib;S=558}while(0);do if((S|0)==558){if(((ub<<24>>24<0?vb:ub&255)|0)==7){if(!(LYc(j,0,-1,396650,7)|0))break;wb=b[G>>0]|0;xb=f[Q>>2]|0}else{wb=ub;xb=vb}do if(((wb<<24>>24<0?xb:wb&255)|0)==8){if(!(LYc(j,0,-1,428991,8)|0))break;yb=b[G>>0]|0;zb=f[Q>>2]|0;S=588}else{yb=wb;zb=xb;S=588}while(0);do if((S|0)==588){if(((yb<<24>>24<0?zb:yb&255)|0)==14){if(!(LYc(j,0,-1,386459,14)|0))break;Ab=b[G>>0]|0;Bb=f[Q>>2]|0}else{Ab=yb;Bb=zb}do if(((Ab<<24>>24<0?Bb:Ab&255)|0)==9){if(LYc(j,0,-1,396713,9)|0){Cb=b[G>>0]|0;Db=f[Q>>2]|0;break}SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P=g+11|0;b[P>>0]=1;b[g>>0]=112;b[g+1>>0]=0;Ma=(HIa(k,g)|0)==0;if((b[P>>0]|0)<0)cYc(f[g>>2]|0);if(Ma){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ma=$Xc(32)|0;f[g>>2]=Ma;f[g+8>>2]=-2147483616;f[g+4>>2]=21;H=Ma;O=386437;I=H+21|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ma+21>>0]=0;vM(-215,g,385937,385609,750)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P=g+11|0;b[P>>0]=1;b[g>>0]=112;b[g+1>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;R=q+11|0;b[R>>0]=1;b[q>>0]=112;b[q+1>>0]=0;Eb=+NGa(NIa(k,q)|0,-1);n[o>>2]=Eb;OGa(K,g,o)|0;if((b[R>>0]|0)<0)cYc(f[q>>2]|0);if((b[P>>0]|0)<0)cYc(f[g>>2]|0);P=g+4|0;f[P>>2]=0;f[P+4>>2]=0;P=g+11|0;b[P>>0]=3;b[g>>0]=b[513188]|0;b[g+1>>0]=b[513189]|0;b[g+2>>0]=b[513190]|0;b[g+3>>0]=0;R=(HIa(k,g)|0)==0;if((b[P>>0]|0)<0)cYc(f[g>>2]|0);if(!R){R=g+4|0;f[R>>2]=0;f[R+4>>2]=0;R=g+11|0;b[R>>0]=3;b[g>>0]=b[513188]|0;b[g+1>>0]=b[513189]|0;b[g+2>>0]=b[513190]|0;b[g+3>>0]=0;P=q+4|0;f[P>>2]=0;f[P+4>>2]=0;P=q+11|0;b[P>>0]=3;b[q>>0]=b[513188]|0;b[q+1>>0]=b[513189]|0;b[q+2>>0]=b[513190]|0;b[q+3>>0]=0;Eb=+NGa(NIa(k,q)|0,-1);n[o>>2]=Eb;OGa(K,g,o)|0;if((b[P>>0]|0)<0)cYc(f[q>>2]|0);if((b[R>>0]|0)<0)cYc(f[g>>2]|0)}tYc((f[m>>2]|0)+12|0,396713)|0;R=f[a+68>>2]|0;P=R+76|0;La=f[P>>2]|0;if((La|0)==(f[R+80>>2]|0)){RLa(R+72|0,m);break b}f[La>>2]=f[m>>2];R=f[L>>2]|0;f[La+4>>2]=R;if(!R)Fb=La;else{TXc(R);Fb=f[P>>2]|0}f[P>>2]=Fb+8;break b}else{Cb=Ab;Db=Bb}while(0);do if(((Cb<<24>>24<0?Db:Cb&255)|0)==7){if(LYc(j,0,-1,396729,7)|0){Gb=b[G>>0]|0;Hb=f[Q>>2]|0;break}SLa(a,k,l);tYc((f[m>>2]|0)+12|0,396729)|0;P=g+4|0;f[P>>2]=0;f[P+4>>2]=0;P=g+11|0;b[P>>0]=3;b[g>>0]=b[446809]|0;b[g+1>>0]=b[446810]|0;b[g+2>>0]=b[446811]|0;b[g+3>>0]=0;if(!(HIa(k,g)|0))Ib=0;else{R=o+4|0;f[R>>2]=0;f[R+4>>2]=0;R=o+11|0;b[R>>0]=3;b[o>>0]=b[515177]|0;b[o+1>>0]=b[515178]|0;b[o+2>>0]=b[515179]|0;b[o+3>>0]=0;La=(HIa(k,o)|0)!=0;if((b[R>>0]|0)<0)cYc(f[o>>2]|0);Ib=La}if((b[P>>0]|0)<0)cYc(f[g>>2]|0);if(!Ib){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P=$Xc(64)|0;f[g>>2]=P;f[g+8>>2]=-2147483584;f[g+4>>2]=50;H=P;O=386474;I=H+50|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[P+50>>0]=0;vM(-215,g,385937,385609,764)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ma=g+11|0;b[Ma>>0]=5;b[g>>0]=b[386525]|0;b[g+1>>0]=b[386526]|0;b[g+2>>0]=b[386527]|0;b[g+3>>0]=b[386528]|0;b[g+4>>0]=b[386529]|0;b[g+5>>0]=0;if(!(HIa(k,g)|0))Jb=0;else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;La=o+11|0;b[La>>0]=5;b[o>>0]=b[386525]|0;b[o+1>>0]=b[386526]|0;b[o+2>>0]=b[386527]|0;b[o+3>>0]=b[386528]|0;b[o+4>>0]=b[386529]|0;b[o+5>>0]=0;R=MGa(NIa(k,o)|0,-1)|0;if((b[La>>0]|0)<0)cYc(f[o>>2]|0);Jb=(R|0)!=1}if((b[Ma>>0]|0)<0)cYc(f[g>>2]|0);if(Jb){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ma=$Xc(48)|0;f[g>>2]=Ma;f[g+8>>2]=-2147483600;f[g+4>>2]=38;H=Ma;O=386531;I=H+38|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ma+38>>0]=0;vM(-213,g,385937,385609,766)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P=g+11|0;b[P>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;R=(HIa(k,g)|0)==0;if((b[P>>0]|0)<0)cYc(f[g>>2]|0);if(!R){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;R=g+11|0;b[R>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;P=q+11|0;b[P>>0]=5;b[q>>0]=b[502066]|0;b[q+1>>0]=b[502067]|0;b[q+2>>0]=b[502068]|0;b[q+3>>0]=b[502069]|0;b[q+4>>0]=b[502070]|0;b[q+5>>0]=0;Eb=+NGa(NIa(k,q)|0,-1);n[o>>2]=Eb;OGa(K,g,o)|0;if((b[P>>0]|0)<0)cYc(f[q>>2]|0);if((b[R>>0]|0)<0)cYc(f[g>>2]|0)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;R=g+11|0;b[R>>0]=9;H=g;O=386570;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;Ma=(HIa(k,g)|0)==0;if((b[R>>0]|0)<0)cYc(f[g>>2]|0);if(!Ma){Ma=g+11|0;b[Ma>>0]=10;H=g;O=449694;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;R=q+11|0;b[R>>0]=9;H=q;O=386570;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[q+9>>0]=0;P=MGa(NIa(k,q)|0,-1)|0;f[o>>2]=P;aHa(K,g,o)|0;if((b[R>>0]|0)<0)cYc(f[q>>2]|0);if((b[Ma>>0]|0)<0)cYc(f[g>>2]|0)}P=g+4|0;f[P>>2]=0;f[P+4>>2]=0;P=g+11|0;b[P>>0]=3;b[g>>0]=b[515177]|0;b[g+1>>0]=b[515178]|0;b[g+2>>0]=b[515179]|0;b[g+3>>0]=0;La=MGa(NIa(k,g)|0,-1)|0;if((b[P>>0]|0)<0)cYc(f[g>>2]|0);P=g+4|0;f[P>>2]=0;f[P+4>>2]=0;P=g+11|0;b[P>>0]=3;b[g>>0]=b[446809]|0;b[g+1>>0]=b[446810]|0;b[g+2>>0]=b[446811]|0;b[g+3>>0]=0;Pa=MGa(NIa(k,g)|0,-1)|0;if((b[P>>0]|0)<0)cYc(f[g>>2]|0);P=La<<1;f[g>>2]=0;za=g+4|0;f[za>>2]=0;f[g+8>>2]=0;if(P>>>0>1073741823)kWc(g);Ka=La<<3;La=$Xc(Ka)|0;f[g>>2]=La;Ia=La+(P<<2)|0;f[g+8>>2]=Ia;g1c(La|0,0,Ka|0)|0;f[za>>2]=Ia;Ka=(Pa|0)>0;f[La+((Ka?-1:-2)+P<<2)>>2]=Ka?Pa:0-Pa|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Pa=o+11|0;b[Pa>>0]=8;Ka=o;f[Ka>>2]=1684300144;f[Ka+4>>2]=1936158313;b[o+8>>0]=0;Ka=Ia-La|0;Ia=Ka>>2;P=$Xc(16)|0;Da=P+8|0;f[P>>2]=Da;f[P+4>>2]=Ia;if(Ia>>>0>1){Aa=bYc(Ia>>>0>536870911?-1:Ia<<3)|0;f[P>>2]=Aa;Kb=Aa}else Kb=Da;f[q>>2]=0;f[q+4>>2]=P;if((Ka|0)>0){Ka=La;La=0;while(1){P=f[Ka>>2]|0;Da=Kb+(La<<3)|0;f[Da>>2]=P;f[Da+4>>2]=((P|0)<0)<<31>>31;La=La+1|0;if((La|0)==(Ia|0))break;else Ka=Ka+4|0}}$Ga(K,o,q)|0;RGa(q);if((b[Pa>>0]|0)<0)cYc(f[o>>2]|0);Ka=f[a+68>>2]|0;Ia=Ka+76|0;La=f[Ia>>2]|0;if((La|0)==(f[Ka+80>>2]|0))RLa(Ka+72|0,m);else{f[La>>2]=f[m>>2];Ka=f[L>>2]|0;f[La+4>>2]=Ka;if(!Ka)Lb=La;else{TXc(Ka);Lb=f[Ia>>2]|0}f[Ia>>2]=Lb+8}Ia=f[g>>2]|0;if(Ia|0){Ka=f[za>>2]|0;if((Ka|0)!=(Ia|0))f[za>>2]=Ka+(~((Ka+-4-Ia|0)>>>2)<<2);cYc(Ia)}break b}else{Gb=Cb;Hb=Db}while(0);do if(((Gb<<24>>24<0?Hb:Gb&255)|0)==9){if(LYc(j,0,-1,386580,9)|0){Mb=b[G>>0]|0;Nb=f[Q>>2]|0;break}Ia=f[a+68>>2]|0;Ka=Ia+76|0;La=f[Ka>>2]|0;if((La|0)==(f[Ia+80>>2]|0))RLa(Ia+72|0,m);else{f[La>>2]=f[m>>2];Ia=f[L>>2]|0;f[La+4>>2]=Ia;if(!Ia)Ob=La;else{TXc(Ia);Ob=f[Ka>>2]|0}f[Ka>>2]=Ob+8}GLa(a);break b}else{Mb=Gb;Nb=Hb}while(0);do if(((Mb<<24>>24<0?Nb:Mb&255)|0)==25){if(LYc(j,0,-1,386590,25)|0){Pb=b[G>>0]|0;Qb=f[Q>>2]|0;break}SLa(a,k,l);tYc((f[m>>2]|0)+12|0,429163)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=g+11|0;b[Ka>>0]=4;f[g>>2]=1466196336;b[g+4>>0]=0;if(!(HIa(k,g)|0))Rb=0;else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Ia=o+11|0;b[Ia>>0]=4;f[o>>2]=1214538096;b[o+4>>0]=0;if(!(HIa(k,o)|0))Sb=0;else{f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;La=q+11|0;b[La>>0]=2;d[q>>1]=22372;b[q+2>>0]=0;if(!(HIa(k,q)|0))Tb=0;else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;Ma=r+11|0;b[Ma>>0]=2;d[r>>1]=18532;b[r+2>>0]=0;if(!(HIa(k,r)|0))Ub=0;else{f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;R=t+11|0;b[R>>0]=9;H=t;O=386616;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[t+9>>0]=0;if(!(HIa(k,t)|0))Vb=0;else{f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;za=w+11|0;b[za>>0]=9;H=w;O=386626;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[w+9>>0]=0;if(!(HIa(k,w)|0))Wb=0;else{f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;Pa=x+11|0;b[Pa>>0]=2;d[x>>1]=22379;b[x+2>>0]=0;if(!(HIa(k,x)|0))Xb=0;else{f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;P=y+11|0;b[P>>0]=2;d[y>>1]=18539;b[y+2>>0]=0;if(!(HIa(k,y)|0))Yb=0;else{f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;Da=$Xc(16)|0;f[z>>2]=Da;f[z+8>>2]=-2147483632;f[z+4>>2]=12;H=Da;O=385953;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+12>>0]=0;Aa=(HIa(k,z)|0)!=0;if((b[z+11>>0]|0)<0)cYc(f[z>>2]|0);Yb=Aa}if((b[P>>0]|0)<0)cYc(f[y>>2]|0);Xb=Yb}if((b[Pa>>0]|0)<0)cYc(f[x>>2]|0);Wb=Xb}if((b[za>>0]|0)<0)cYc(f[w>>2]|0);Vb=Wb}if((b[R>>0]|0)<0)cYc(f[t>>2]|0);Ub=Vb}if((b[Ma>>0]|0)<0)cYc(f[r>>2]|0);Tb=Ub}if((b[La>>0]|0)<0)cYc(f[q>>2]|0);Sb=Tb}if((b[Ia>>0]|0)<0)cYc(f[o>>2]|0);Rb=Sb}if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);if(!Rb){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Aa=$Xc(256)|0;f[g>>2]=Aa;f[g+8>>2]=-2147483392;f[g+4>>2]=251;o1c(Aa|0,386636,251)|0;b[Aa+251>>0]=0;vM(-215,g,385937,385609,803)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Aa=g+11|0;b[Aa>>0]=8;Ja=g;f[Ja>>2]=1852990827;f[Ja+4>>2]=2002742373;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ja=q+11|0;b[Ja>>0]=2;d[q>>1]=22379;b[q+2>>0]=0;Oa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Oa;aHa(K,g,o)|0;if((b[Ja>>0]|0)<0)cYc(f[q>>2]|0);if((b[Aa>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Aa=g+11|0;b[Aa>>0]=8;Ja=g;f[Ja>>2]=1852990827;f[Ja+4>>2]=1751084133;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ja=q+11|0;b[Ja>>0]=2;d[q>>1]=18539;b[q+2>>0]=0;Oa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Oa;aHa(K,g,o)|0;if((b[Ja>>0]|0)<0)cYc(f[q>>2]|0);if((b[Aa>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Aa=g+11|0;b[Aa>>0]=5;b[g>>0]=b[390339]|0;b[g+1>>0]=b[390340]|0;b[g+2>>0]=b[390341]|0;b[g+3>>0]=b[390342]|0;b[g+4>>0]=b[390343]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ja=q+11|0;b[Ja>>0]=4;f[q>>2]=1466196336;b[q+4>>0]=0;Oa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Oa;aHa(K,g,o)|0;if((b[Ja>>0]|0)<0)cYc(f[q>>2]|0);if((b[Aa>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Aa=g+11|0;b[Aa>>0]=5;b[g>>0]=b[390333]|0;b[g+1>>0]=b[390334]|0;b[g+2>>0]=b[390335]|0;b[g+3>>0]=b[390336]|0;b[g+4>>0]=b[390337]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ja=q+11|0;b[Ja>>0]=4;f[q>>2]=1214538096;b[q+4>>0]=0;Oa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Oa;aHa(K,g,o)|0;if((b[Ja>>0]|0)<0)cYc(f[q>>2]|0);if((b[Aa>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Aa=g+11|0;b[Aa>>0]=8;Ja=g;f[Ja>>2]=1769108595;f[Ja+4>>2]=2002740580;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ja=q+11|0;b[Ja>>0]=2;d[q>>1]=22372;b[q+2>>0]=0;Oa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Oa;aHa(K,g,o)|0;if((b[Ja>>0]|0)<0)cYc(f[q>>2]|0);if((b[Aa>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Aa=g+11|0;b[Aa>>0]=8;Ja=g;f[Ja>>2]=1769108595;f[Ja+4>>2]=1751082340;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ja=q+11|0;b[Ja>>0]=2;d[q>>1]=18532;b[q+2>>0]=0;Oa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Oa;aHa(K,g,o)|0;if((b[Ja>>0]|0)<0)cYc(f[q>>2]|0);if((b[Aa>>0]|0)<0)cYc(f[g>>2]|0);Aa=g+11|0;b[Aa>>0]=10;H=g;O=390205;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ka=q+11|0;b[Ka>>0]=9;H=q;O=386616;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[q+9>>0]=0;Ia=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Ia;aHa(K,g,o)|0;if((b[Ka>>0]|0)<0)cYc(f[q>>2]|0);if((b[Aa>>0]|0)<0)cYc(f[g>>2]|0);Ia=g+11|0;b[Ia>>0]=10;H=g;O=390194;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Aa=q+11|0;b[Aa>>0]=9;H=q;O=386626;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[q+9>>0]=0;Ka=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Ka;aHa(K,g,o)|0;if((b[Aa>>0]|0)<0)cYc(f[q>>2]|0);if((b[Ia>>0]|0)<0)cYc(f[g>>2]|0);Ka=g+11|0;b[Ka>>0]=10;H=g;O=453228;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=$Xc(16)|0;f[q>>2]=Ia;f[q+8>>2]=-2147483632;f[q+4>>2]=12;H=Ia;O=385953;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ia+12>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);Aa=M+36|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;La=o+11|0;b[La>>0]=6;b[o>>0]=b[385901]|0;b[o+1>>0]=b[385902]|0;b[o+2>>0]=b[385903]|0;b[o+3>>0]=b[385904]|0;b[o+4>>0]=b[385905]|0;b[o+5>>0]=b[385906]|0;b[o+6>>0]=0;Ma=ULa(l,g,o)|0;R=f[Ma>>2]|0;if(!R){za=$Xc(88)|0;Pa=za+16|0;f[Pa>>2]=f[o>>2];f[Pa+4>>2]=f[o+4>>2];f[Pa+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[za+28>>2]=0;f[za+32>>2]=1124007936;Pa=za+40|0;P=za+72|0;H=za+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[P>>2]=Pa;Ka=za+80|0;f[za+76>>2]=Ka;f[Ka>>2]=0;f[za+84>>2]=0;Ka=f[g>>2]|0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=Ka;f[Ma>>2]=za;Ka=f[f[l>>2]>>2]|0;if(!Ka)Zb=za;else{f[l>>2]=Ka;Zb=f[Ma>>2]|0}UQ(f[C>>2]|0,Zb);f[D>>2]=(f[D>>2]|0)+1;_b=za}else _b=R;Ka=_b+32|0;Ia=M+40|0;Da=f[Ia>>2]|0;Ja=M+44|0;if((Da|0)==(f[Ja>>2]|0))bx(Aa,Ka);else{f[Da>>2]=f[Ka>>2];Oa=Da+4|0;Ha=_b+36|0;f[Oa>>2]=f[Ha>>2];Na=Da+8|0;f[Na>>2]=f[_b+40>>2];f[Da+12>>2]=f[_b+44>>2];f[Da+16>>2]=f[_b+48>>2];f[Da+20>>2]=f[_b+52>>2];f[Da+24>>2]=f[_b+56>>2];f[Da+28>>2]=f[_b+60>>2];f[Da+32>>2]=f[_b+64>>2];Fa=f[_b+68>>2]|0;f[Da+36>>2]=Fa;f[Da+40>>2]=Na;Na=Da+48|0;Ga=Da+44|0;f[Ga>>2]=Na;f[Na>>2]=0;f[Da+52>>2]=0;if(Fa|0){Na=Fa+12|0;f[Na>>2]=(f[Na>>2]|0)+1}if((f[Ha>>2]|0)<3){Ha=f[_b+76>>2]|0;Na=f[Ga>>2]|0;f[Na>>2]=f[Ha>>2];f[Na+4>>2]=f[Ha+4>>2]}else{f[Oa>>2]=0;U$(Da,Ka)}f[Ia>>2]=(f[Ia>>2]|0)+56}if((b[La>>0]|0)<0)cYc(f[o>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=g+11|0;b[Ka>>0]=4;f[g>>2]=1935763810;b[g+4>>0]=0;Da=(TLa(l,g)|0)!=0;if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);b[o>>0]=Da&1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=9;H=g;O=445999;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;cHa(K,g,o)|0;if((b[Da>>0]|0)<0)cYc(f[g>>2]|0);if(b[o>>0]|0){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;La=q+11|0;b[La>>0]=4;f[q>>2]=1935763810;b[q+4>>0]=0;R=ULa(l,g,q)|0;za=f[R>>2]|0;if(!za){Ma=$Xc(88)|0;Pa=Ma+16|0;f[Pa>>2]=f[q>>2];f[Pa+4>>2]=f[q+4>>2];f[Pa+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[Ma+28>>2]=0;f[Ma+32>>2]=1124007936;Pa=Ma+40|0;P=Ma+72|0;H=Ma+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[P>>2]=Pa;Da=Ma+80|0;f[Ma+76>>2]=Da;f[Da>>2]=0;f[Ma+84>>2]=0;Da=f[g>>2]|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[Ma+8>>2]=Da;f[R>>2]=Ma;Da=f[f[l>>2]>>2]|0;if(!Da)$b=Ma;else{f[l>>2]=Da;$b=f[R>>2]|0}UQ(f[C>>2]|0,$b);f[D>>2]=(f[D>>2]|0)+1;ac=Ma}else ac=za;Da=ac+32|0;Ka=f[Ia>>2]|0;if((Ka|0)==(f[Ja>>2]|0))bx(Aa,Da);else{f[Ka>>2]=f[Da>>2];Oa=Ka+4|0;Ha=ac+36|0;f[Oa>>2]=f[Ha>>2];Na=Ka+8|0;f[Na>>2]=f[ac+40>>2];f[Ka+12>>2]=f[ac+44>>2];f[Ka+16>>2]=f[ac+48>>2];f[Ka+20>>2]=f[ac+52>>2];f[Ka+24>>2]=f[ac+56>>2];f[Ka+28>>2]=f[ac+60>>2];f[Ka+32>>2]=f[ac+64>>2];Ga=f[ac+68>>2]|0;f[Ka+36>>2]=Ga;f[Ka+40>>2]=Na;Na=Ka+48|0;Fa=Ka+44|0;f[Fa>>2]=Na;f[Na>>2]=0;f[Ka+52>>2]=0;if(Ga|0){Na=Ga+12|0;f[Na>>2]=(f[Na>>2]|0)+1}if((f[Ha>>2]|0)<3){Ha=f[ac+76>>2]|0;Na=f[Fa>>2]|0;f[Na>>2]=f[Ha>>2];f[Na+4>>2]=f[Ha+4>>2]}else{f[Oa>>2]=0;U$(Ka,Da)}f[Ia>>2]=(f[Ia>>2]|0)+56}if((b[La>>0]|0)<0)cYc(f[q>>2]|0)}Da=f[a+68>>2]|0;Ka=Da+76|0;Oa=f[Ka>>2]|0;if((Oa|0)==(f[Da+80>>2]|0))RLa(Da+72|0,m);else{f[Oa>>2]=f[m>>2];Da=f[L>>2]|0;f[Oa+4>>2]=Da;if(!Da)bc=Oa;else{TXc(Da);bc=f[Ka>>2]|0}f[Ka>>2]=bc+8}break b}else{Pb=Mb;Qb=Nb}while(0);do if(((Pb<<24>>24<0?Qb:Pb&255)|0)==22){if(LYc(j,0,-1,386888,22)|0){cc=b[G>>0]|0;dc=f[Q>>2]|0;break}SLa(a,k,l);tYc((f[m>>2]|0)+12|0,396536)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=g+11|0;b[Ka>>0]=4;f[g>>2]=1466196336;b[g+4>>0]=0;if(!(HIa(k,g)|0))ec=0;else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Da=o+11|0;b[Da>>0]=4;f[o>>2]=1214538096;b[o+4>>0]=0;if(!(HIa(k,o)|0))fc=0;else{f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Oa=q+11|0;b[Oa>>0]=2;d[q>>1]=22372;b[q+2>>0]=0;if(!(HIa(k,q)|0))gc=0;else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;Ha=r+11|0;b[Ha>>0]=2;d[r>>1]=18532;b[r+2>>0]=0;if(!(HIa(k,r)|0))hc=0;else{f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;Na=t+11|0;b[Na>>0]=4;f[t>>2]=1466590305;b[t+4>>0]=0;if(!(HIa(k,t)|0))ic=0;else{f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;Fa=w+11|0;b[Fa>>0]=4;f[w>>2]=1214932065;b[w+4>>0]=0;if(!(HIa(k,w)|0))jc=0;else{f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;Ga=x+11|0;b[Ga>>0]=2;d[x>>1]=22379;b[x+2>>0]=0;if(!(HIa(k,x)|0))kc=0;else{f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;ta=y+11|0;b[ta>>0]=2;d[y>>1]=18539;b[y+2>>0]=0;if(!(HIa(k,y)|0))lc=0;else{f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;ua=$Xc(16)|0;f[z>>2]=ua;f[z+8>>2]=-2147483632;f[z+4>>2]=12;H=ua;O=385953;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+12>>0]=0;La=(HIa(k,z)|0)!=0;if((b[z+11>>0]|0)<0)cYc(f[z>>2]|0);lc=La}if((b[ta>>0]|0)<0)cYc(f[y>>2]|0);kc=lc}if((b[Ga>>0]|0)<0)cYc(f[x>>2]|0);jc=kc}if((b[Fa>>0]|0)<0)cYc(f[w>>2]|0);ic=jc}if((b[Na>>0]|0)<0)cYc(f[t>>2]|0);hc=ic}if((b[Ha>>0]|0)<0)cYc(f[r>>2]|0);gc=hc}if((b[Oa>>0]|0)<0)cYc(f[q>>2]|0);fc=gc}if((b[Da>>0]|0)<0)cYc(f[o>>2]|0);ec=fc}if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);if(!ec){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=$Xc(256)|0;f[g>>2]=La;f[g+8>>2]=-2147483392;f[g+4>>2]=241;o1c(La|0,386911,241)|0;b[La+241>>0]=0;vM(-215,g,385937,385609,836)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=8;Ia=g;f[Ia>>2]=1852990827;f[Ia+4>>2]=2002742373;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=2;d[q>>1]=22379;b[q+2>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=8;Ia=g;f[Ia>>2]=1852990827;f[Ia+4>>2]=1751084133;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=2;d[q>>1]=18539;b[q+2>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=5;b[g>>0]=b[390339]|0;b[g+1>>0]=b[390340]|0;b[g+2>>0]=b[390341]|0;b[g+3>>0]=b[390342]|0;b[g+4>>0]=b[390343]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=4;f[q>>2]=1466196336;b[q+4>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=5;b[g>>0]=b[390333]|0;b[g+1>>0]=b[390334]|0;b[g+2>>0]=b[390335]|0;b[g+3>>0]=b[390336]|0;b[g+4>>0]=b[390337]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=4;f[q>>2]=1214538096;b[q+4>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=8;Ia=g;f[Ia>>2]=1769108595;f[Ia+4>>2]=2002740580;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=2;d[q>>1]=22372;b[q+2>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=8;Ia=g;f[Ia>>2]=1769108595;f[Ia+4>>2]=1751082340;b[g+8>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=2;d[q>>1]=18532;b[q+2>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=5;b[g>>0]=b[453245]|0;b[g+1>>0]=b[453246]|0;b[g+2>>0]=b[453247]|0;b[g+3>>0]=b[453248]|0;b[g+4>>0]=b[453249]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=4;f[q>>2]=1466590305;b[q+4>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=5;b[g>>0]=b[453239]|0;b[g+1>>0]=b[453240]|0;b[g+2>>0]=b[453241]|0;b[g+3>>0]=b[453242]|0;b[g+4>>0]=b[453243]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=q+11|0;b[Ia>>0]=4;f[q>>2]=1214932065;b[q+4>>0]=0;Aa=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Aa;aHa(K,g,o)|0;if((b[Ia>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);La=g+11|0;b[La>>0]=10;H=g;O=453228;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ka=$Xc(16)|0;f[q>>2]=Ka;f[q+8>>2]=-2147483632;f[q+4>>2]=12;H=Ka;O=385953;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ka+12>>0]=0;Da=~~+NGa(NIa(k,q)|0,-1);f[o>>2]=Da;aHa(K,g,o)|0;if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);Da=M+36|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Oa=o+11|0;b[Oa>>0]=6;b[o>>0]=b[385901]|0;b[o+1>>0]=b[385902]|0;b[o+2>>0]=b[385903]|0;b[o+3>>0]=b[385904]|0;b[o+4>>0]=b[385905]|0;b[o+5>>0]=b[385906]|0;b[o+6>>0]=0;Ha=ULa(l,g,o)|0;Na=f[Ha>>2]|0;if(!Na){Fa=$Xc(88)|0;Ga=Fa+16|0;f[Ga>>2]=f[o>>2];f[Ga+4>>2]=f[o+4>>2];f[Ga+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[Fa+28>>2]=0;f[Fa+32>>2]=1124007936;Ga=Fa+40|0;ta=Fa+72|0;H=Fa+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[ta>>2]=Ga;La=Fa+80|0;f[Fa+76>>2]=La;f[La>>2]=0;f[Fa+84>>2]=0;La=f[g>>2]|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=La;f[Ha>>2]=Fa;La=f[f[l>>2]>>2]|0;if(!La)mc=Fa;else{f[l>>2]=La;mc=f[Ha>>2]|0}UQ(f[C>>2]|0,mc);f[D>>2]=(f[D>>2]|0)+1;nc=Fa}else nc=Na;La=nc+32|0;Ka=M+40|0;ua=f[Ka>>2]|0;Ia=M+44|0;if((ua|0)==(f[Ia>>2]|0))bx(Da,La);else{f[ua>>2]=f[La>>2];Aa=ua+4|0;Ja=nc+36|0;f[Aa>>2]=f[Ja>>2];za=ua+8|0;f[za>>2]=f[nc+40>>2];f[ua+12>>2]=f[nc+44>>2];f[ua+16>>2]=f[nc+48>>2];f[ua+20>>2]=f[nc+52>>2];f[ua+24>>2]=f[nc+56>>2];f[ua+28>>2]=f[nc+60>>2];f[ua+32>>2]=f[nc+64>>2];Ma=f[nc+68>>2]|0;f[ua+36>>2]=Ma;f[ua+40>>2]=za;za=ua+48|0;R=ua+44|0;f[R>>2]=za;f[za>>2]=0;f[ua+52>>2]=0;if(Ma|0){za=Ma+12|0;f[za>>2]=(f[za>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[nc+76>>2]|0;za=f[R>>2]|0;f[za>>2]=f[Ja>>2];f[za+4>>2]=f[Ja+4>>2]}else{f[Aa>>2]=0;U$(ua,La)}f[Ka>>2]=(f[Ka>>2]|0)+56}if((b[Oa>>0]|0)<0)cYc(f[o>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=4;f[g>>2]=1935763810;b[g+4>>0]=0;ua=(TLa(l,g)|0)!=0;if((b[La>>0]|0)<0)cYc(f[g>>2]|0);b[o>>0]=ua&1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=9;H=g;O=445999;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;cHa(K,g,o)|0;if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);if(b[o>>0]|0){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Oa=q+11|0;b[Oa>>0]=4;f[q>>2]=1935763810;b[q+4>>0]=0;Na=ULa(l,g,q)|0;Fa=f[Na>>2]|0;if(!Fa){Ha=$Xc(88)|0;Ga=Ha+16|0;f[Ga>>2]=f[q>>2];f[Ga+4>>2]=f[q+4>>2];f[Ga+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[Ha+28>>2]=0;f[Ha+32>>2]=1124007936;Ga=Ha+40|0;ta=Ha+72|0;H=Ha+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[ta>>2]=Ga;ua=Ha+80|0;f[Ha+76>>2]=ua;f[ua>>2]=0;f[Ha+84>>2]=0;ua=f[g>>2]|0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=ua;f[Na>>2]=Ha;ua=f[f[l>>2]>>2]|0;if(!ua)oc=Ha;else{f[l>>2]=ua;oc=f[Na>>2]|0}UQ(f[C>>2]|0,oc);f[D>>2]=(f[D>>2]|0)+1;pc=Ha}else pc=Fa;ua=pc+32|0;La=f[Ka>>2]|0;if((La|0)==(f[Ia>>2]|0))bx(Da,ua);else{f[La>>2]=f[ua>>2];Aa=La+4|0;Ja=pc+36|0;f[Aa>>2]=f[Ja>>2];za=La+8|0;f[za>>2]=f[pc+40>>2];f[La+12>>2]=f[pc+44>>2];f[La+16>>2]=f[pc+48>>2];f[La+20>>2]=f[pc+52>>2];f[La+24>>2]=f[pc+56>>2];f[La+28>>2]=f[pc+60>>2];f[La+32>>2]=f[pc+64>>2];R=f[pc+68>>2]|0;f[La+36>>2]=R;f[La+40>>2]=za;za=La+48|0;Ma=La+44|0;f[Ma>>2]=za;f[za>>2]=0;f[La+52>>2]=0;if(R|0){za=R+12|0;f[za>>2]=(f[za>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[pc+76>>2]|0;za=f[Ma>>2]|0;f[za>>2]=f[Ja>>2];f[za+4>>2]=f[Ja+4>>2]}else{f[Aa>>2]=0;U$(La,ua)}f[Ka>>2]=(f[Ka>>2]|0)+56}if((b[Oa>>0]|0)<0)cYc(f[q>>2]|0)}ua=f[a+68>>2]|0;La=ua+76|0;Aa=f[La>>2]|0;if((Aa|0)==(f[ua+80>>2]|0))RLa(ua+72|0,m);else{f[Aa>>2]=f[m>>2];ua=f[L>>2]|0;f[Aa+4>>2]=ua;if(!ua)qc=Aa;else{TXc(ua);qc=f[La>>2]|0}f[La>>2]=qc+8}break b}else{cc=Pb;dc=Qb}while(0);do if(((cc<<24>>24<0?dc:cc&255)|0)==19){if(LYc(j,0,-1,387153,19)|0){rc=b[G>>0]|0;sc=f[Q>>2]|0;break}SLa(a,k,l);f[g+8>>2]=0;La=g+11|0;b[La>>0]=7;b[g>>0]=b[386070]|0;b[g+1>>0]=b[386071]|0;b[g+2>>0]=b[386072]|0;b[g+3>>0]=b[386073]|0;b[g+4>>0]=b[386074]|0;b[g+5>>0]=b[386075]|0;b[g+6>>0]=b[386076]|0;b[g+7>>0]=0;ua=(TLa(l,g)|0)==0;if((b[La>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(32)|0;f[g>>2]=ua;f[g+8>>2]=-2147483616;f[g+4>>2]=29;H=ua;O=387173;I=H+29|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+29>>0]=0;vM(-215,g,385937,385609,860)};f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Oa=$Xc(16)|0;f[o>>2]=Oa;f[o+8>>2]=-2147483632;f[o+4>>2]=15;H=Oa;O=386054;I=H+15|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Oa+15>>0]=0;f[q+8>>2]=0;ua=q+11|0;b[ua>>0]=7;b[q>>0]=b[386070]|0;b[q+1>>0]=b[386071]|0;b[q+2>>0]=b[386072]|0;b[q+3>>0]=b[386073]|0;b[q+4>>0]=b[386074]|0;b[q+5>>0]=b[386075]|0;b[q+6>>0]=b[386076]|0;b[q+7>>0]=0;Ka=ULa(l,g,q)|0;Da=f[Ka>>2]|0;if(!Da){Ia=$Xc(88)|0;Fa=Ia+16|0;f[Fa>>2]=f[q>>2];f[Fa+4>>2]=f[q+4>>2];f[Fa+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[Ia+28>>2]=0;f[Ia+32>>2]=1124007936;Fa=Ia+40|0;Ha=Ia+72|0;H=Ia+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ha>>2]=Fa;Oa=Ia+80|0;f[Ia+76>>2]=Oa;f[Oa>>2]=0;f[Ia+84>>2]=0;Oa=f[g>>2]|0;f[Ia>>2]=0;f[Ia+4>>2]=0;f[Ia+8>>2]=Oa;f[Ka>>2]=Ia;Oa=f[f[l>>2]>>2]|0;if(!Oa)tc=Ia;else{f[l>>2]=Oa;tc=f[Ka>>2]|0}UQ(f[C>>2]|0,tc);f[D>>2]=(f[D>>2]|0)+1;uc=Ia}else uc=Da;aHa(K,o,uc+28|0)|0;if((b[ua>>0]|0)<0)cYc(f[q>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);Oa=f[a+68>>2]|0;Na=Oa+76|0;Ga=f[Na>>2]|0;if((Ga|0)==(f[Oa+80>>2]|0)){RLa(Oa+72|0,m);break b}f[Ga>>2]=f[m>>2];Oa=f[L>>2]|0;f[Ga+4>>2]=Oa;if(!Oa)vc=Ga;else{TXc(Oa);vc=f[Na>>2]|0}f[Na>>2]=vc+8;break b}else{rc=cc;sc=dc}while(0);do if(((rc<<24>>24<0?sc:rc&255)|0)==7){if(LYc(j,0,-1,387203,7)|0){wc=b[G>>0]|0;xc=f[Q>>2]|0;break}tYc((f[m>>2]|0)+12|0,387203)|0;Na=f[a+68>>2]|0;Oa=Na+76|0;Ga=f[Oa>>2]|0;if((Ga|0)==(f[Na+80>>2]|0)){RLa(Na+72|0,m);break b}f[Ga>>2]=f[m>>2];Na=f[L>>2]|0;f[Ga+4>>2]=Na;if(!Na)yc=Ga;else{TXc(Na);yc=f[Oa>>2]|0}f[Oa>>2]=yc+8;break b}else{wc=rc;xc=sc}while(0);do if(((wc<<24>>24<0?xc:wc&255)|0)==10){if(LYc(j,0,-1,387211,10)|0){zc=b[G>>0]|0;Ac=f[Q>>2]|0;break}tYc((f[m>>2]|0)+12|0,387203)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Oa=$Xc(16)|0;f[g>>2]=Oa;f[g+8>>2]=-2147483632;f[g+4>>2]=11;H=Oa;O=436960;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Oa+11>>0]=0;b[o>>0]=1;cHa(K,g,o)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);ua=f[a+68>>2]|0;Da=ua+76|0;Ia=f[Da>>2]|0;if((Ia|0)==(f[ua+80>>2]|0)){RLa(ua+72|0,m);break b}f[Ia>>2]=f[m>>2];ua=f[L>>2]|0;f[Ia+4>>2]=ua;if(!ua)Bc=Ia;else{TXc(ua);Bc=f[Da>>2]|0}f[Da>>2]=Bc+8;break b}else{zc=wc;Ac=xc}while(0);do if(((zc<<24>>24<0?Ac:zc&255)|0)==18){if(LYc(j,0,-1,387222,18)|0){Cc=b[G>>0]|0;Dc=f[Q>>2]|0;break}tYc((f[m>>2]|0)+12|0,396574)|0;SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=5;b[g>>0]=b[441815]|0;b[g+1>>0]=b[441816]|0;b[g+2>>0]=b[441817]|0;b[g+3>>0]=b[441818]|0;b[g+4>>0]=b[441819]|0;b[g+5>>0]=0;ua=(HIa(k,g)|0)==0;if((b[Da>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(32)|0;f[g>>2]=ua;f[g+8>>2]=-2147483616;f[g+4>>2]=25;H=ua;O=387241;I=H+25|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+25>>0]=0;vM(-215,g,385937,385609,881)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Oa=g+11|0;b[Oa>>0]=4;f[g>>2]=1635018082;b[g+4>>0]=0;Da=(HIa(k,g)|0)==0;if((b[Oa>>0]|0)<0)cYc(f[g>>2]|0);if(Da){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=$Xc(32)|0;f[g>>2]=Da;f[g+8>>2]=-2147483616;f[g+4>>2]=24;H=Da;O=387267;I=H+24|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+24>>0]=0;vM(-215,g,385937,385609,882)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=1;b[g>>0]=107;b[g+1>>0]=0;Oa=(HIa(k,g)|0)==0;if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);if(Oa){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Oa=$Xc(32)|0;f[g>>2]=Oa;f[g+8>>2]=-2147483616;f[g+4>>2]=21;H=Oa;O=387292;I=H+21|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Oa+21>>0]=0;vM(-215,g,385937,385609,883)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=4;f[g>>2]=1702521203;b[g+4>>0]=0;ua=(HIa(k,g)|0)==0;if((b[Da>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(32)|0;f[g>>2]=ua;f[g+8>>2]=-2147483616;f[g+4>>2]=24;H=ua;O=386138;I=H+24|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+24>>0]=0;vM(-215,g,385937,385609,884)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Oa=$Xc(16)|0;f[g>>2]=Oa;f[g+8>>2]=-2147483632;f[g+4>>2]=11;H=Oa;O=441590;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Oa+11>>0]=0;YLa(K,g,441602)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=5;b[g>>0]=b[441815]|0;b[g+1>>0]=b[441816]|0;b[g+2>>0]=b[441817]|0;b[g+3>>0]=b[441818]|0;b[g+4>>0]=b[441819]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Da=q+11|0;b[Da>>0]=5;b[q>>0]=b[441815]|0;b[q+1>>0]=b[441816]|0;b[q+2>>0]=b[441817]|0;b[q+3>>0]=b[441818]|0;b[q+4>>0]=b[441819]|0;b[q+5>>0]=0;Eb=+NGa(NIa(k,q)|0,-1);n[o>>2]=Eb;OGa(K,g,o)|0;if((b[Da>>0]|0)<0)cYc(f[q>>2]|0);if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=4;f[g>>2]=1635018082;b[g+4>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Da=q+11|0;b[Da>>0]=4;f[q>>2]=1635018082;b[q+4>>0]=0;Eb=+NGa(NIa(k,q)|0,-1);n[o>>2]=Eb;OGa(K,g,o)|0;if((b[Da>>0]|0)<0)cYc(f[q>>2]|0);if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=4;f[g>>2]=1935763810;b[g+4>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Da=q+11|0;b[Da>>0]=1;b[q>>0]=107;b[q+1>>0]=0;Eb=+NGa(NIa(k,q)|0,-1);n[o>>2]=Eb;OGa(K,g,o)|0;if((b[Da>>0]|0)<0)cYc(f[q>>2]|0);if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);ua=g+11|0;b[ua>>0]=10;H=g;O=441745;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Oa=q+11|0;b[Oa>>0]=4;f[q>>2]=1702521203;b[q+4>>0]=0;Da=MGa(NIa(k,q)|0,-1)|0;f[o>>2]=Da;aHa(K,g,o)|0;if((b[Oa>>0]|0)<0)cYc(f[q>>2]|0);if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Oa=$Xc(16)|0;f[g>>2]=Oa;f[g+8>>2]=-2147483632;f[g+4>>2]=12;H=Oa;O=441821;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Oa+12>>0]=0;b[o>>0]=1;cHa(K,g,o)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);ua=f[a+68>>2]|0;Da=ua+76|0;Ia=f[Da>>2]|0;if((Ia|0)==(f[ua+80>>2]|0)){RLa(ua+72|0,m);break b}f[Ia>>2]=f[m>>2];ua=f[L>>2]|0;f[Ia+4>>2]=ua;if(!ua)Ec=Ia;else{TXc(ua);Ec=f[Da>>2]|0}f[Da>>2]=Ec+8;break b}else{Cc=zc;Dc=Ac}while(0);do if(((Cc<<24>>24<0?Dc:Cc&255)|0)==6){if(!(LYc(j,0,-1,387314,6)|0))break;Fc=b[G>>0]|0;Gc=f[Q>>2]|0;S=1001}else{Fc=Cc;Gc=Dc;S=1001}while(0);do if((S|0)==1001){if(((Fc<<24>>24<0?Gc:Fc&255)|0)==4){if(!(LYc(j,0,-1,387321,4)|0))break;Hc=b[G>>0]|0;Ic=f[Q>>2]|0}else{Hc=Fc;Ic=Gc}if(((Hc<<24>>24<0?Ic:Hc&255)|0)==5){if(!(LYc(j,0,-1,439430,5)|0))break;Jc=b[G>>0]|0;Kc=f[Q>>2]|0}else{Jc=Hc;Kc=Ic}do if(((Jc<<24>>24<0?Kc:Jc&255)|0)==11){if(LYc(j,0,-1,387330,11)|0){Lc=b[G>>0]|0;Mc=f[Q>>2]|0;break}SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=$Xc(16)|0;f[g>>2]=Da;f[g+8>>2]=-2147483632;f[g+4>>2]=15;H=Da;O=387342;I=H+15|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+15>>0]=0;ua=(HIa(k,g)|0)==0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(48)|0;f[g>>2]=ua;f[g+8>>2]=-2147483600;f[g+4>>2]=35;H=ua;O=387358;I=H+35|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+35>>0]=0;vM(-215,g,385937,385609,911)}tYc((f[m>>2]|0)+12|0,439430)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=5;b[g>>0]=b[439436]|0;b[g+1>>0]=b[439437]|0;b[g+2>>0]=b[439438]|0;b[g+3>>0]=b[439439]|0;b[g+4>>0]=b[439440]|0;b[g+5>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ia=$Xc(16)|0;f[q>>2]=Ia;f[q+8>>2]=-2147483632;f[q+4>>2]=15;H=Ia;O=387342;I=H+15|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ia+15>>0]=0;Eb=+NGa(NIa(k,q)|0,-1);n[o>>2]=Eb;OGa(K,g,o)|0;if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[Da>>0]|0)<0)cYc(f[g>>2]|0);ua=f[a+68>>2]|0;Ka=ua+76|0;Fa=f[Ka>>2]|0;if((Fa|0)==(f[ua+80>>2]|0)){RLa(ua+72|0,m);break b}f[Fa>>2]=f[m>>2];ua=f[L>>2]|0;f[Fa+4>>2]=ua;if(!ua)Nc=Fa;else{TXc(ua);Nc=f[Ka>>2]|0}f[Ka>>2]=Nc+8;break b}else{Lc=Jc;Mc=Kc}while(0);do if(((Lc<<24>>24<0?Mc:Lc&255)|0)==18){if(!(LYc(j,0,-1,387394,18)|0))break;Oc=b[G>>0]|0;Pc=f[Q>>2]|0;S=1049}else{Oc=Lc;Pc=Mc;S=1049}while(0);do if((S|0)==1049){if(((Oc<<24>>24<0?Pc:Oc&255)|0)==24){if(!(LYc(j,0,-1,387413,24)|0))break;Qc=b[G>>0]|0;Rc=f[Q>>2]|0}else{Qc=Oc;Rc=Pc}do if(((Qc<<24>>24<0?Rc:Qc&255)|0)==10){if(LYc(j,0,-1,387597,10)|0){Sc=b[G>>0]|0;Tc=f[Q>>2]|0;break}SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Oa=g+11|0;b[Oa>>0]=4;f[g>>2]=1702521203;b[g+4>>0]=0;Ka=(HIa(k,g)|0)==0;if((b[Oa>>0]|0)<0)cYc(f[g>>2]|0);if(Ka){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=$Xc(32)|0;f[g>>2]=Ka;f[g+8>>2]=-2147483616;f[g+4>>2]=24;H=Ka;O=386138;I=H+24|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ka+24>>0]=0;vM(-215,g,385937,385609,950)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Oa=g+11|0;b[Oa>>0]=4;f[g>>2]=1702521203;b[g+4>>0]=0;ua=MGa(NIa(k,g)|0,-1)|0;if((b[Oa>>0]|0)<0)cYc(f[g>>2]|0);Oa=~ua;tYc((f[m>>2]|0)+12|0,396487)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Fa=g+11|0;b[Fa>>0]=5;b[g>>0]=b[448895]|0;b[g+1>>0]=b[448896]|0;b[g+2>>0]=b[448897]|0;b[g+3>>0]=b[448898]|0;b[g+4>>0]=b[448899]|0;b[g+5>>0]=0;Ha=$Xc(16)|0;f[Ha>>2]=Ha+8;f[Ha+4>>2]=4;Na=bYc(32)|0;f[Ha>>2]=Na;f[o>>2]=0;f[o+4>>2]=Ha;Ha=((ua|0)<0)<<31>>31;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;Ga=Na+16|0;f[Ga>>2]=ua;f[Ga+4>>2]=Ha;Ga=Na+24|0;f[Ga>>2]=ua;f[Ga+4>>2]=Ha;$Ga(K,g,o)|0;RGa(o);if((b[Fa>>0]|0)<0)cYc(f[g>>2]|0);Fa=g+4|0;f[Fa>>2]=0;f[Fa+4>>2]=0;Fa=g+11|0;b[Fa>>0]=3;b[g>>0]=b[448901]|0;b[g+1>>0]=b[448902]|0;b[g+2>>0]=b[448903]|0;b[g+3>>0]=0;Ha=$Xc(16)|0;f[Ha>>2]=Ha+8;f[Ha+4>>2]=4;Ga=bYc(32)|0;f[Ha>>2]=Ga;f[o>>2]=0;f[o+4>>2]=Ha;Ha=((Oa|0)<0)<<31>>31;f[Ga>>2]=-1;f[Ga+4>>2]=-1;f[Ga+8>>2]=-1;f[Ga+12>>2]=-1;ua=Ga+16|0;f[ua>>2]=Oa;f[ua+4>>2]=Ha;ua=Ga+24|0;f[ua>>2]=Oa;f[ua+4>>2]=Ha;$Ga(K,g,o)|0;RGa(o);if((b[Fa>>0]|0)<0)cYc(f[g>>2]|0);Fa=f[a+68>>2]|0;Ha=Fa+76|0;ua=f[Ha>>2]|0;if((ua|0)==(f[Fa+80>>2]|0)){RLa(Fa+72|0,m);break b}f[ua>>2]=f[m>>2];Fa=f[L>>2]|0;f[ua+4>>2]=Fa;if(!Fa)Uc=ua;else{TXc(Fa);Uc=f[Ha>>2]|0}f[Ha>>2]=Uc+8;break b}else{Sc=Qc;Tc=Rc}while(0);do if(((Sc<<24>>24<0?Tc:Sc&255)|0)==24){if(LYc(j,0,-1,387608,24)|0)break;SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=$Xc(16)|0;f[g>>2]=Da;f[g+8>>2]=-2147483632;f[g+4>>2]=12;H=Da;O=387633;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+12>>0]=0;Ka=(HIa(k,g)|0)==0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(Ka){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=$Xc(48)|0;f[g>>2]=Ka;f[g+8>>2]=-2147483600;f[g+4>>2]=32;H=Ka;O=387646;I=H+32|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ka+32>>0]=0;vM(-215,g,385937,385609,964)};f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Da=$Xc(16)|0;f[o>>2]=Da;f[o+8>>2]=-2147483632;f[o+4>>2]=12;H=Da;O=387633;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+12>>0]=0;Ka=MGa(NIa(k,o)|0,-1)|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);f[g>>2]=Ka;tYc((f[m>>2]|0)+12|0,428823)|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Ka=$Xc(16)|0;f[o>>2]=Ka;f[o+8>>2]=-2147483632;f[o+4>>2]=13;H=Ka;O=435950;I=H+13|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ka+13>>0]=0;PIa(K,o,435964)|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Da=$Xc(16)|0;f[o>>2]=Da;f[o+8>>2]=-2147483632;f[o+4>>2]=11;H=Da;O=435694;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+11>>0]=0;aHa(K,o,g)|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);Ka=f[a+68>>2]|0;Ia=Ka+76|0;Ha=f[Ia>>2]|0;if((Ha|0)==(f[Ka+80>>2]|0))RLa(Ka+72|0,m);else{f[Ha>>2]=f[m>>2];Ka=f[L>>2]|0;f[Ha+4>>2]=Ka;if(!Ka)Vc=Ha;else{TXc(Ka);Vc=f[Ia>>2]|0}f[Ia>>2]=Vc+8}break b}while(0);SLa(a,k,l);Ia=f[k>>2]|0;if((Ia|0)!=(c|0)){Ka=Ia;while(1){$Ga(K,Ka+16|0,Ka+28|0)|0;Ia=f[Ka+4>>2]|0;do if(!Ia){Ha=Ka+8|0;Fa=f[Ha>>2]|0;if((f[Fa>>2]|0)==(Ka|0)){Wc=Fa;break}else Xc=Ha;do{Ha=f[Xc>>2]|0;Xc=Ha+8|0;Fa=f[Xc>>2]|0}while((f[Fa>>2]|0)!=(Ha|0));Wc=Fa}else{Fa=Ia;while(1){Ha=f[Fa>>2]|0;if(!Ha)break;else Fa=Ha}Wc=Fa}while(0);if((Wc|0)==(c|0))break;else Ka=Wc}}Ka=f[l>>2]|0;if((Ka|0)!=(E|0)){Ia=M+40|0;Da=M+44|0;Ha=M+36|0;ua=Ka;while(1){Ka=ua+32|0;Oa=f[Ia>>2]|0;if((Oa|0)==(f[Da>>2]|0))bx(Ha,Ka);else{f[Oa>>2]=f[Ka>>2];Ga=Oa+4|0;Na=ua+36|0;f[Ga>>2]=f[Na>>2];ta=Oa+8|0;f[ta>>2]=f[ua+40>>2];f[Oa+12>>2]=f[ua+44>>2];f[Oa+16>>2]=f[ua+48>>2];f[Oa+20>>2]=f[ua+52>>2];f[Oa+24>>2]=f[ua+56>>2];f[Oa+28>>2]=f[ua+60>>2];f[Oa+32>>2]=f[ua+64>>2];La=f[ua+68>>2]|0;f[Oa+36>>2]=La;f[Oa+40>>2]=ta;ta=Oa+48|0;Aa=Oa+44|0;f[Aa>>2]=ta;f[ta>>2]=0;f[Oa+52>>2]=0;if(La|0){ta=La+12|0;f[ta>>2]=(f[ta>>2]|0)+1}if((f[Na>>2]|0)<3){Na=f[ua+76>>2]|0;ta=f[Aa>>2]|0;f[ta>>2]=f[Na>>2];f[ta+4>>2]=f[Na+4>>2]}else{f[Ga>>2]=0;U$(Oa,Ka)}f[Ia>>2]=(f[Ia>>2]|0)+56}Ka=f[ua+4>>2]|0;do if(!Ka){Oa=ua+8|0;Ga=f[Oa>>2]|0;if((f[Ga>>2]|0)==(ua|0)){Yc=Ga;break}else Zc=Oa;do{Oa=f[Zc>>2]|0;Zc=Oa+8|0;Ga=f[Zc>>2]|0}while((f[Ga>>2]|0)!=(Oa|0));Yc=Ga}else{Fa=Ka;while(1){Ga=f[Fa>>2]|0;if(!Ga)break;else Fa=Ga}Yc=Fa}while(0);if((Yc|0)==(E|0))break;else ua=Yc}}oYc((f[m>>2]|0)+12|0,j)|0;ua=f[a+68>>2]|0;Ia=ua+76|0;Ha=f[Ia>>2]|0;if((Ha|0)==(f[ua+80>>2]|0)){RLa(ua+72|0,m);break b}f[Ha>>2]=f[m>>2];ua=f[L>>2]|0;f[Ha+4>>2]=ua;if(!ua)_c=Ha;else{TXc(ua);_c=f[Ia>>2]|0}f[Ia>>2]=_c+8;break b}while(0);SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=g+11|0;b[Ia>>0]=5;b[g>>0]=b[446785]|0;b[g+1>>0]=b[446786]|0;b[g+2>>0]=b[446787]|0;b[g+3>>0]=b[446788]|0;b[g+4>>0]=b[446789]|0;b[g+5>>0]=0;ua=(HIa(k,g)|0)==0;if((b[Ia>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(32)|0;f[g>>2]=ua;f[g+8>>2]=-2147483616;f[g+4>>2]=25;H=ua;O=387438;I=H+25|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+25>>0]=0;vM(-215,g,385937,385609,920)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=g+11|0;b[Ia>>0]=5;b[g>>0]=b[446797]|0;b[g+1>>0]=b[446798]|0;b[g+2>>0]=b[446799]|0;b[g+3>>0]=b[446800]|0;b[g+4>>0]=b[446801]|0;b[g+5>>0]=0;Ha=(HIa(k,g)|0)==0;if((b[Ia>>0]|0)<0)cYc(f[g>>2]|0);if(Ha){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ha=$Xc(32)|0;f[g>>2]=Ha;f[g+8>>2]=-2147483616;f[g+4>>2]=25;H=Ha;O=387464;I=H+25|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ha+25>>0]=0;vM(-215,g,385937,385609,920)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=5;b[g>>0]=b[446791]|0;b[g+1>>0]=b[446792]|0;b[g+2>>0]=b[446793]|0;b[g+3>>0]=b[446794]|0;b[g+4>>0]=b[446795]|0;b[g+5>>0]=0;Ia=(HIa(k,g)|0)==0;if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);if(Ia){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=$Xc(32)|0;f[g>>2]=Ia;f[g+8>>2]=-2147483616;f[g+4>>2]=25;H=Ia;O=387490;I=H+25|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ia+25>>0]=0;vM(-215,g,385937,385609,920)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ha=g+11|0;b[Ha>>0]=5;b[g>>0]=b[446803]|0;b[g+1>>0]=b[446804]|0;b[g+2>>0]=b[446805]|0;b[g+3>>0]=b[446806]|0;b[g+4>>0]=b[446807]|0;b[g+5>>0]=0;ua=(HIa(k,g)|0)==0;if((b[Ha>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(32)|0;f[g>>2]=ua;f[g+8>>2]=-2147483616;f[g+4>>2]=25;H=ua;O=387516;I=H+25|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+25>>0]=0;vM(-215,g,385937,385609,920)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=g+11|0;b[Ia>>0]=5;b[g>>0]=b[446791]|0;b[g+1>>0]=b[446792]|0;b[g+2>>0]=b[446793]|0;b[g+3>>0]=b[446794]|0;b[g+4>>0]=b[446795]|0;b[g+5>>0]=0;Ha=MGa(NIa(k,g)|0,-1)|0;Da=J;if((b[Ia>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=g+11|0;b[Ia>>0]=5;b[g>>0]=b[446785]|0;b[g+1>>0]=b[446786]|0;b[g+2>>0]=b[446787]|0;b[g+3>>0]=b[446788]|0;b[g+4>>0]=b[446789]|0;b[g+5>>0]=0;Da=MGa(NIa(k,g)|0,-1)|0;Ka=J;if((b[Ia>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=g+11|0;b[Ia>>0]=5;b[g>>0]=b[446797]|0;b[g+1>>0]=b[446798]|0;b[g+2>>0]=b[446799]|0;b[g+3>>0]=b[446800]|0;b[g+4>>0]=b[446801]|0;b[g+5>>0]=0;Ka=MGa(NIa(k,g)|0,-1)|0;Ga=J;if((b[Ia>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=g+11|0;b[Ia>>0]=5;b[g>>0]=b[446803]|0;b[g+1>>0]=b[446804]|0;b[g+2>>0]=b[446805]|0;b[g+3>>0]=b[446806]|0;b[g+4>>0]=b[446807]|0;b[g+5>>0]=0;Ga=MGa(NIa(k,g)|0,-1)|0;Oa=J;if((b[Ia>>0]|0)<0)cYc(f[g>>2]|0);if((Da|Ha|Ka|Ga|0)<0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ia=$Xc(64)|0;f[g>>2]=Ia;f[g+8>>2]=-2147483584;f[g+4>>2]=54;H=Ia;O=387542;I=H+54|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ia+54>>0]=0;vM(-213,g,385937,385609,926)}tYc((f[m>>2]|0)+12|0,396729)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=8;Oa=g;f[Oa>>2]=1684300144;f[Oa+4>>2]=1936158313;b[g+8>>0]=0;Oa=$Xc(16)|0;f[Oa>>2]=Oa+8;f[Oa+4>>2]=6;Na=bYc(48)|0;f[Oa>>2]=Na;f[o>>2]=0;f[o+4>>2]=Oa;Oa=k1c(0,Ha|0,32)|0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;ta=Na+16|0;f[ta>>2]=Oa;f[ta+4>>2]=J;ta=k1c(0,Ga|0,32)|0;Oa=Na+24|0;f[Oa>>2]=ta;f[Oa+4>>2]=J;Oa=k1c(0,Da|0,32)|0;ta=Na+32|0;f[ta>>2]=Oa;f[ta+4>>2]=J;ta=k1c(0,Ka|0,32)|0;Oa=Na+40|0;f[Oa>>2]=ta;f[Oa+4>>2]=J;$Ga(K,g,o)|0;RGa(o);if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);ua=g+11|0;b[ua>>0]=10;H=g;O=449694;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[o>>2]=3;aHa(K,g,o)|0;if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);Ka=b[G>>0]|0;do if(((Ka<<24>>24<0?f[Q>>2]|0:Ka&255)|0)==24){if(LYc(j,0,-1,387413,24)|0)break;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=4;f[g>>2]=1701869940;b[g+4>>0]=0;PIa(K,g,450034)|0;if((b[Da>>0]|0)<0)cYc(f[g>>2]|0)}while(0);Ka=f[a+68>>2]|0;ua=Ka+76|0;Da=f[ua>>2]|0;if((Da|0)==(f[Ka+80>>2]|0)){RLa(Ka+72|0,m);break b}f[Da>>2]=f[m>>2];Ka=f[L>>2]|0;f[Da+4>>2]=Ka;if(!Ka)$c=Da;else{TXc(Ka);$c=f[ua>>2]|0}f[ua>>2]=$c+8;break b}while(0);SLa(a,k,l);ua=b[G>>0]|0;Ka=f[Q>>2]|0;do if(((ua<<24>>24<0?Ka:ua&255)|0)==6)if(!(LYc(j,0,-1,387314,6)|0)){n[g>>2]=2.0;break}else{ad=b[G>>0]|0;bd=f[Q>>2]|0;S=1011;break}else{ad=ua;bd=Ka;S=1011}while(0);c:do if((S|0)==1011){do if(((ad<<24>>24<0?bd:ad&255)|0)==4)if(!(LYc(j,0,-1,387321,4)|0)){n[g>>2]=.5;break c}else{cd=b[G>>0]|0;dd=f[Q>>2]|0;break}else{cd=ad;dd=bd}while(0);if(((cd<<24>>24<0?dd:cd&255)|0)!=5)break;if(LYc(j,0,-1,439430,5)|0)break;Ka=o+4|0;f[Ka>>2]=0;f[Ka+4>>2]=0;Ka=o+11|0;b[Ka>>0]=3;b[o>>0]=b[387326]|0;b[o+1>>0]=b[387327]|0;b[o+2>>0]=b[387328]|0;b[o+3>>0]=0;ua=LGa(k,o)|0;if((ua|0)==(c|0))ed=1.0;else ed=+NGa(ua+28|0,-1);n[g>>2]=ed;if((b[Ka>>0]|0)<0)cYc(f[o>>2]|0)}while(0);tYc((f[m>>2]|0)+12|0,439430)|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Ka=o+11|0;b[Ka>>0]=5;b[o>>0]=b[431954]|0;b[o+1>>0]=b[431955]|0;b[o+2>>0]=b[431956]|0;b[o+3>>0]=b[431957]|0;b[o+4>>0]=b[431958]|0;b[o+5>>0]=0;OGa(K,o,g)|0;if((b[Ka>>0]|0)<0)cYc(f[o>>2]|0);Ka=f[a+68>>2]|0;ua=Ka+76|0;Da=f[ua>>2]|0;if((Da|0)==(f[Ka+80>>2]|0))RLa(Ka+72|0,m);else{f[Da>>2]=f[m>>2];Ka=f[L>>2]|0;f[Da+4>>2]=Ka;if(!Ka)fd=Da;else{TXc(Ka);fd=f[ua>>2]|0}f[ua>>2]=fd+8}break b}while(0);SLa(a,k,l);tYc((f[m>>2]|0)+12|0,428991)|0;ua=f[a+68>>2]|0;Ka=ua+76|0;Da=f[Ka>>2]|0;if((Da|0)==(f[ua+80>>2]|0)){RLa(ua+72|0,m);break b}f[Da>>2]=f[m>>2];ua=f[L>>2]|0;f[Da+4>>2]=ua;if(!ua)gd=Da;else{TXc(ua);gd=f[Ka>>2]|0}f[Ka>>2]=gd+8;break b}while(0);SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=g+11|0;b[Ka>>0]=1;b[g>>0]=112;b[g+1>>0]=0;ua=(HIa(k,g)|0)==0;if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(32)|0;f[g>>2]=ua;f[g+8>>2]=-2147483616;f[g+4>>2]=21;H=ua;O=386437;I=H+21|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+21>>0]=0;vM(-215,g,385937,385609,722)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=g+11|0;b[Ka>>0]=2;d[g>>1]=12918;b[g+2>>0]=0;if(!(HIa(k,g)|0))hd=0;else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Da=o+11|0;b[Da>>0]=2;d[o>>1]=12918;b[o+2>>0]=0;Ga=MGa(NIa(k,o)|0,-1)|0;Ha=(Ga|0)!=0|(J|0)!=0;if((b[Da>>0]|0)<0)cYc(f[o>>2]|0);hd=Ha}if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);if(!hd){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Ka=o+11|0;b[Ka>>0]=1;b[o>>0]=112;b[o+1>>0]=0;Eb=1.0-+NGa(NIa(k,o)|0,-1);if((b[Ka>>0]|0)<0)cYc(f[o>>2]|0);n[g>>2]=Eb;if(!(Eb>0.0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=9;H=o;O=439341;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[o+9>>0]=0;vM(-215,o,385937,385609,732)}tYc((f[m>>2]|0)+12|0,439430)|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;ua=o+11|0;b[ua>>0]=5;b[o>>0]=b[439436]|0;b[o+1>>0]=b[439437]|0;b[o+2>>0]=b[439438]|0;b[o+3>>0]=b[439439]|0;b[o+4>>0]=b[439440]|0;b[o+5>>0]=0;OGa(K,o,g)|0;if((b[ua>>0]|0)<0)cYc(f[o>>2]|0)}else tYc((f[m>>2]|0)+12|0,428991)|0;ua=f[a+68>>2]|0;Ka=ua+76|0;Ha=f[Ka>>2]|0;if((Ha|0)==(f[ua+80>>2]|0)){RLa(ua+72|0,m);break b}f[Ha>>2]=f[m>>2];ua=f[L>>2]|0;f[Ha+4>>2]=ua;if(!ua)id=Ha;else{TXc(ua);id=f[Ka>>2]|0}f[Ka>>2]=id+8;break b}while(0);tYc((f[m>>2]|0)+12|0,429107)|0;SLa(a,k,l);Ka=g+4|0;f[Ka>>2]=0;f[Ka+4>>2]=0;Ka=g+11|0;b[Ka>>0]=3;b[g>>0]=b[513188]|0;b[g+1>>0]=b[513189]|0;b[g+2>>0]=b[513190]|0;b[g+3>>0]=0;ua=(HIa(k,g)|0)==0;if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ua=$Xc(32)|0;f[g>>2]=ua;f[g+8>>2]=-2147483616;f[g+4>>2]=23;H=ua;O=386226;I=H+23|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ua+23>>0]=0;vM(-215,g,385937,385609,641)}Ka=g+4|0;f[Ka>>2]=0;f[Ka+4>>2]=0;Ka=g+11|0;b[Ka>>0]=3;b[g>>0]=b[513188]|0;b[g+1>>0]=b[513189]|0;b[g+2>>0]=b[513190]|0;b[g+3>>0]=0;Eb=+NGa(NIa(k,g)|0,-1);if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);n[o>>2]=Eb;Ka=g+4|0;f[Ka>>2]=0;f[Ka+4>>2]=0;Ka=g+11|0;b[Ka>>0]=3;b[g>>0]=b[513188]|0;b[g+1>>0]=b[513189]|0;b[g+2>>0]=b[513190]|0;b[g+3>>0]=0;OGa(K,g,o)|0;if((b[Ka>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=$Xc(16)|0;f[g>>2]=Ka;f[g+8>>2]=-2147483632;f[g+4>>2]=12;H=Ka;O=386250;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ka+12>>0]=0;ua=(TLa(l,g)|0)==0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(ua){f[g+8>>2]=0;ua=g+11|0;b[ua>>0]=7;b[g>>0]=b[386263]|0;b[g+1>>0]=b[386264]|0;b[g+2>>0]=b[386265]|0;b[g+3>>0]=b[386266]|0;b[g+4>>0]=b[386267]|0;b[g+5>>0]=b[386268]|0;b[g+6>>0]=b[386269]|0;b[g+7>>0]=0;Ha=(HIa(k,g)|0)==0;if((b[ua>>0]|0)<0)cYc(f[g>>2]|0);if(Ha){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ha=$Xc(32)|0;f[g>>2]=Ha;f[g+8>>2]=-2147483616;f[g+4>>2]=27;H=Ha;O=386271;I=H+27|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ha+27>>0]=0;vM(-215,g,385937,385609,651)}Ka=M+36|0;f[q+8>>2]=0;ua=q+11|0;b[ua>>0]=7;b[q>>0]=b[386263]|0;b[q+1>>0]=b[386264]|0;b[q+2>>0]=b[386265]|0;b[q+3>>0]=b[386266]|0;b[q+4>>0]=b[386267]|0;b[q+5>>0]=b[386268]|0;b[q+6>>0]=b[386269]|0;b[q+7>>0]=0;Da=MGa(NIa(k,q)|0,-1)|0;p$(s,1,Da,5);f[g>>2]=1124007936;Da=g+4|0;Ga=g+8|0;Ia=g+40|0;H=Da;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ia>>2]=Ga;Ha=g+48|0;Oa=g+44|0;f[Oa>>2]=Ha;f[Ha>>2]=0;f[g+52>>2]=0;ta=f[s>>2]|0;ei[f[(f[ta>>2]|0)+12>>2]&511](ta,s,g,-1);ta=M+40|0;Na=f[ta>>2]|0;do if(Na>>>0<(f[M+44>>2]|0)>>>0){f[Na>>2]=f[g>>2];f[Na+4>>2]=f[Da>>2];Aa=Na+8|0;f[Aa>>2]=f[Ga>>2];f[Na+12>>2]=f[g+12>>2];f[Na+16>>2]=f[g+16>>2];f[Na+20>>2]=f[g+20>>2];f[Na+24>>2]=f[g+24>>2];f[Na+28>>2]=f[g+28>>2];f[Na+32>>2]=f[g+32>>2];La=g+36|0;f[Na+36>>2]=f[La>>2];Ja=Na+40|0;f[Ja>>2]=Aa;Aa=Na+44|0;za=Na+48|0;f[Aa>>2]=za;Ma=Na+52|0;f[Ma>>2]=0;f[za>>2]=0;R=g+44|0;if((f[Da>>2]|0)<3){Pa=f[R>>2]|0;f[za>>2]=f[Pa>>2];f[Ma>>2]=f[Pa+4>>2]}else{f[Aa>>2]=f[R>>2];f[Ja>>2]=f[Ia>>2];f[R>>2]=Ha;f[Ia>>2]=Ga}f[g>>2]=1124007936;H=Da;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[ta>>2]=Na+56;jd=La}else{XLa(Ka,g);R=g+36|0;Ja=f[R>>2]|0;if(!Ja){jd=R;break}Aa=Ja+12|0;Ja=f[Aa>>2]|0;f[Aa>>2]=Ja+-1;if((Ja|0)!=1){jd=R;break}V$(g);jd=R}while(0);f[jd>>2]=0;Ka=g+16|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[Da>>2]|0)>0){Ka=f[Ia>>2]|0;Na=0;do{f[Ka+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[Da>>2]|0))}Da=f[Oa>>2]|0;if((Da|0)!=(Ha|0))wL(Da);Zj(s);if((b[ua>>0]|0)<0)cYc(f[q>>2]|0)}else{Da=M+36|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Na=$Xc(16)|0;f[q>>2]=Na;f[q+8>>2]=-2147483632;f[q+4>>2]=12;H=Na;O=386250;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Na+12>>0]=0;ua=ULa(l,g,q)|0;Ha=f[ua>>2]|0;if(!Ha){Oa=$Xc(88)|0;Ka=Oa+16|0;f[Ka>>2]=f[q>>2];f[Ka+4>>2]=f[q+4>>2];f[Ka+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[Oa+28>>2]=0;f[Oa+32>>2]=1124007936;Ka=Oa+40|0;Ia=Oa+72|0;H=Oa+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ia>>2]=Ka;Na=Oa+80|0;f[Oa+76>>2]=Na;f[Na>>2]=0;f[Oa+84>>2]=0;Na=f[g>>2]|0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=Na;f[ua>>2]=Oa;Na=f[f[l>>2]>>2]|0;if(!Na)kd=Oa;else{f[l>>2]=Na;kd=f[ua>>2]|0}UQ(f[C>>2]|0,kd);f[D>>2]=(f[D>>2]|0)+1;ld=Oa}else ld=Ha;Na=ld+32|0;ta=M+40|0;Ga=f[ta>>2]|0;if((Ga|0)==(f[M+44>>2]|0))bx(Da,Na);else{f[Ga>>2]=f[Na>>2];R=Ga+4|0;Ja=ld+36|0;f[R>>2]=f[Ja>>2];Aa=Ga+8|0;f[Aa>>2]=f[ld+40>>2];f[Ga+12>>2]=f[ld+44>>2];f[Ga+16>>2]=f[ld+48>>2];f[Ga+20>>2]=f[ld+52>>2];f[Ga+24>>2]=f[ld+56>>2];f[Ga+28>>2]=f[ld+60>>2];f[Ga+32>>2]=f[ld+64>>2];Pa=f[ld+68>>2]|0;f[Ga+36>>2]=Pa;f[Ga+40>>2]=Aa;Aa=Ga+48|0;Ma=Ga+44|0;f[Ma>>2]=Aa;f[Aa>>2]=0;f[Ga+52>>2]=0;if(Pa|0){Aa=Pa+12|0;f[Aa>>2]=(f[Aa>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[ld+76>>2]|0;Aa=f[Ma>>2]|0;f[Aa>>2]=f[Ja>>2];f[Aa+4>>2]=f[Ja+4>>2]}else{f[R>>2]=0;U$(Ga,Na)}f[ta>>2]=(f[ta>>2]|0)+56}if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ta=$Xc(16)|0;f[g>>2]=ta;f[g+8>>2]=-2147483632;f[g+4>>2]=11;H=ta;O=386299;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ta+11>>0]=0;Da=(TLa(l,g)|0)==0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);do if(Da){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ha=$Xc(16)|0;f[g>>2]=Ha;f[g+8>>2]=-2147483632;f[g+4>>2]=11;H=Ha;O=386311;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ha+11>>0]=0;La=(TLa(l,g)|0)==0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(!La){La=M+36|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Oa=$Xc(16)|0;f[q>>2]=Oa;f[q+8>>2]=-2147483632;f[q+4>>2]=11;H=Oa;O=386311;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Oa+11>>0]=0;Ha=ULa(l,g,q)|0;ua=f[Ha>>2]|0;if(!ua){Ka=$Xc(88)|0;Ia=Ka+16|0;f[Ia>>2]=f[q>>2];f[Ia+4>>2]=f[q+4>>2];f[Ia+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[Ka+28>>2]=0;f[Ka+32>>2]=1124007936;Ia=Ka+40|0;Na=Ka+72|0;H=Ka+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Na>>2]=Ia;Oa=Ka+80|0;f[Ka+76>>2]=Oa;f[Oa>>2]=0;f[Ka+84>>2]=0;Oa=f[g>>2]|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=Oa;f[Ha>>2]=Ka;Oa=f[f[l>>2]>>2]|0;if(!Oa)md=Ka;else{f[l>>2]=Oa;md=f[Ha>>2]|0}UQ(f[C>>2]|0,md);f[D>>2]=(f[D>>2]|0)+1;nd=Ka}else nd=ua;Oa=nd+32|0;Ga=M+40|0;R=f[Ga>>2]|0;if((R|0)==(f[M+44>>2]|0))bx(La,Oa);else{f[R>>2]=f[Oa>>2];Ja=R+4|0;Aa=nd+36|0;f[Ja>>2]=f[Aa>>2];Ma=R+8|0;f[Ma>>2]=f[nd+40>>2];f[R+12>>2]=f[nd+44>>2];f[R+16>>2]=f[nd+48>>2];f[R+20>>2]=f[nd+52>>2];f[R+24>>2]=f[nd+56>>2];f[R+28>>2]=f[nd+60>>2];f[R+32>>2]=f[nd+64>>2];Pa=f[nd+68>>2]|0;f[R+36>>2]=Pa;f[R+40>>2]=Ma;Ma=R+48|0;za=R+44|0;f[za>>2]=Ma;f[Ma>>2]=0;f[R+52>>2]=0;if(Pa|0){Ma=Pa+12|0;f[Ma>>2]=(f[Ma>>2]|0)+1}if((f[Aa>>2]|0)<3){Aa=f[nd+76>>2]|0;Ma=f[za>>2]|0;f[Ma>>2]=f[Aa>>2];f[Ma+4>>2]=f[Aa+4>>2]}else{f[Ja>>2]=0;U$(R,Oa)}f[Ga>>2]=(f[Ga>>2]|0)+56}if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);Oa=(f[Ga>>2]|0)+-56|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=Oa;R=q+8|0;f[R>>2]=0;f[R+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=Oa;QL(g,-2.0,q);Oa=(f[Ga>>2]|0)+-56|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=Oa;p[r>>3]=+n[o>>2];f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;Ga=t+8|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=Oa;G1(g,q,t,fT()|0,-1);break}f[g+8>>2]=0;Oa=g+11|0;b[Oa>>0]=7;b[g>>0]=b[386263]|0;b[g+1>>0]=b[386264]|0;b[g+2>>0]=b[386265]|0;b[g+3>>0]=b[386266]|0;b[g+4>>0]=b[386267]|0;b[g+5>>0]=b[386268]|0;b[g+6>>0]=b[386269]|0;b[g+7>>0]=0;Ga=(HIa(k,g)|0)==0;if((b[Oa>>0]|0)<0)cYc(f[g>>2]|0);if(Ga){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ga=$Xc(32)|0;f[g>>2]=Ga;f[g+8>>2]=-2147483616;f[g+4>>2]=27;H=Ga;O=386271;I=H+27|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ga+27>>0]=0;vM(-215,g,385937,385609,667)}La=M+36|0;f[q+8>>2]=0;ua=q+11|0;b[ua>>0]=7;b[q>>0]=b[386263]|0;b[q+1>>0]=b[386264]|0;b[q+2>>0]=b[386265]|0;b[q+3>>0]=b[386266]|0;b[q+4>>0]=b[386267]|0;b[q+5>>0]=b[386268]|0;b[q+6>>0]=b[386269]|0;b[q+7>>0]=0;Ka=MGa(NIa(k,q)|0,-1)|0;s$(v,1,Ka,5);f[g>>2]=1124007936;Ka=g+4|0;Ha=g+8|0;Ia=g+40|0;H=Ka;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ia>>2]=Ha;Ga=g+48|0;Na=g+44|0;f[Na>>2]=Ga;f[Ga>>2]=0;f[g+52>>2]=0;Oa=f[v>>2]|0;ei[f[(f[Oa>>2]|0)+12>>2]&511](Oa,v,g,-1);Oa=M+40|0;R=f[Oa>>2]|0;do if(R>>>0<(f[M+44>>2]|0)>>>0){f[R>>2]=f[g>>2];f[R+4>>2]=f[Ka>>2];Ja=R+8|0;f[Ja>>2]=f[Ha>>2];f[R+12>>2]=f[g+12>>2];f[R+16>>2]=f[g+16>>2];f[R+20>>2]=f[g+20>>2];f[R+24>>2]=f[g+24>>2];f[R+28>>2]=f[g+28>>2];f[R+32>>2]=f[g+32>>2];Aa=g+36|0;f[R+36>>2]=f[Aa>>2];Ma=R+40|0;f[Ma>>2]=Ja;Ja=R+44|0;za=R+48|0;f[Ja>>2]=za;Pa=R+52|0;f[Pa>>2]=0;f[za>>2]=0;P=g+44|0;if((f[Ka>>2]|0)<3){sa=f[P>>2]|0;f[za>>2]=f[sa>>2];f[Pa>>2]=f[sa+4>>2]}else{f[Ja>>2]=f[P>>2];f[Ma>>2]=f[Ia>>2];f[P>>2]=Ga;f[Ia>>2]=Ha}f[g>>2]=1124007936;H=Ka;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Oa>>2]=R+56;od=Aa}else{XLa(La,g);P=g+36|0;Ma=f[P>>2]|0;if(!Ma){od=P;break}Ja=Ma+12|0;Ma=f[Ja>>2]|0;f[Ja>>2]=Ma+-1;if((Ma|0)!=1){od=P;break}V$(g);od=P}while(0);f[od>>2]=0;La=g+16|0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[Ka>>2]|0)>0){La=f[Ia>>2]|0;R=0;do{f[La+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[Ka>>2]|0))}Ka=f[Na>>2]|0;if((Ka|0)!=(Ga|0))wL(Ka);Zj(v);if((b[ua>>0]|0)<0)cYc(f[q>>2]|0)}else{Ka=M+36|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;R=$Xc(16)|0;f[q>>2]=R;f[q+8>>2]=-2147483632;f[q+4>>2]=11;H=R;O=386299;I=H+11|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[R+11>>0]=0;ua=ULa(l,g,q)|0;Ga=f[ua>>2]|0;if(!Ga){Na=$Xc(88)|0;La=Na+16|0;f[La>>2]=f[q>>2];f[La+4>>2]=f[q+4>>2];f[La+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[Na+28>>2]=0;f[Na+32>>2]=1124007936;La=Na+40|0;Ia=Na+72|0;H=Na+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ia>>2]=La;R=Na+80|0;f[Na+76>>2]=R;f[R>>2]=0;f[Na+84>>2]=0;R=f[g>>2]|0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=R;f[ua>>2]=Na;R=f[f[l>>2]>>2]|0;if(!R)pd=Na;else{f[l>>2]=R;pd=f[ua>>2]|0}UQ(f[C>>2]|0,pd);f[D>>2]=(f[D>>2]|0)+1;qd=Na}else qd=Ga;R=qd+32|0;Oa=M+40|0;Ha=f[Oa>>2]|0;if((Ha|0)==(f[M+44>>2]|0))bx(Ka,R);else{f[Ha>>2]=f[R>>2];P=Ha+4|0;Ma=qd+36|0;f[P>>2]=f[Ma>>2];Ja=Ha+8|0;f[Ja>>2]=f[qd+40>>2];f[Ha+12>>2]=f[qd+44>>2];f[Ha+16>>2]=f[qd+48>>2];f[Ha+20>>2]=f[qd+52>>2];f[Ha+24>>2]=f[qd+56>>2];f[Ha+28>>2]=f[qd+60>>2];f[Ha+32>>2]=f[qd+64>>2];sa=f[qd+68>>2]|0;f[Ha+36>>2]=sa;f[Ha+40>>2]=Ja;Ja=Ha+48|0;Pa=Ha+44|0;f[Pa>>2]=Ja;f[Ja>>2]=0;f[Ha+52>>2]=0;if(sa|0){Ja=sa+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}if((f[Ma>>2]|0)<3){Ma=f[qd+76>>2]|0;Ja=f[Pa>>2]|0;f[Ja>>2]=f[Ma>>2];f[Ja+4>>2]=f[Ma+4>>2]}else{f[P>>2]=0;U$(Ha,R)}f[Oa>>2]=(f[Oa>>2]|0)+56}if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0)}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=6;b[g>>0]=b[385901]|0;b[g+1>>0]=b[385902]|0;b[g+2>>0]=b[385903]|0;b[g+3>>0]=b[385904]|0;b[g+4>>0]=b[385905]|0;b[g+5>>0]=b[385906]|0;b[g+6>>0]=0;ta=(TLa(l,g)|0)==0;if((b[Da>>0]|0)<0)cYc(f[g>>2]|0);if(!ta){ta=g+11|0;b[ta>>0]=10;H=g;O=444583;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;b[q>>0]=1;cHa(K,g,q)|0;if((b[ta>>0]|0)<0)cYc(f[g>>2]|0);Da=M+36|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Oa=q+11|0;b[Oa>>0]=6;b[q>>0]=b[385901]|0;b[q+1>>0]=b[385902]|0;b[q+2>>0]=b[385903]|0;b[q+3>>0]=b[385904]|0;b[q+4>>0]=b[385905]|0;b[q+5>>0]=b[385906]|0;b[q+6>>0]=0;R=ULa(l,g,q)|0;Ha=f[R>>2]|0;if(!Ha){P=$Xc(88)|0;Ma=P+16|0;f[Ma>>2]=f[q>>2];f[Ma+4>>2]=f[q+4>>2];f[Ma+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[P+28>>2]=0;f[P+32>>2]=1124007936;Ma=P+40|0;Ja=P+72|0;H=P+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ja>>2]=Ma;ta=P+80|0;f[P+76>>2]=ta;f[ta>>2]=0;f[P+84>>2]=0;ta=f[g>>2]|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=ta;f[R>>2]=P;ta=f[f[l>>2]>>2]|0;if(!ta)rd=P;else{f[l>>2]=ta;rd=f[R>>2]|0}UQ(f[C>>2]|0,rd);f[D>>2]=(f[D>>2]|0)+1;sd=P}else sd=Ha;ta=sd+32|0;Pa=M+40|0;sa=f[Pa>>2]|0;if((sa|0)==(f[M+44>>2]|0))bx(Da,ta);else{f[sa>>2]=f[ta>>2];za=sa+4|0;va=sd+36|0;f[za>>2]=f[va>>2];Ea=sa+8|0;f[Ea>>2]=f[sd+40>>2];f[sa+12>>2]=f[sd+44>>2];f[sa+16>>2]=f[sd+48>>2];f[sa+20>>2]=f[sd+52>>2];f[sa+24>>2]=f[sd+56>>2];f[sa+28>>2]=f[sd+60>>2];f[sa+32>>2]=f[sd+64>>2];wa=f[sd+68>>2]|0;f[sa+36>>2]=wa;f[sa+40>>2]=Ea;Ea=sa+48|0;Ca=sa+44|0;f[Ca>>2]=Ea;f[Ea>>2]=0;f[sa+52>>2]=0;if(wa|0){Ea=wa+12|0;f[Ea>>2]=(f[Ea>>2]|0)+1}if((f[va>>2]|0)<3){va=f[sd+76>>2]|0;Ea=f[Ca>>2]|0;f[Ea>>2]=f[va>>2];f[Ea+4>>2]=f[va+4>>2]}else{f[za>>2]=0;U$(sa,ta)}f[Pa>>2]=(f[Pa>>2]|0)+56}if((b[Oa>>0]|0)<0)cYc(f[q>>2]|0)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Pa=g+11|0;b[Pa>>0]=4;f[g>>2]=1935763810;b[g+4>>0]=0;ta=(TLa(l,g)|0)==0;if((b[Pa>>0]|0)<0)cYc(f[g>>2]|0);if(!ta){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ta=g+11|0;b[ta>>0]=8;Pa=g;f[Pa>>2]=1601397096;f[Pa+4>>2]=1935763810;b[g+8>>0]=0;b[q>>0]=1;cHa(K,g,q)|0;if((b[ta>>0]|0)<0)cYc(f[g>>2]|0);ta=M+36|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Pa=q+11|0;b[Pa>>0]=4;f[q>>2]=1935763810;b[q+4>>0]=0;sa=ULa(l,g,q)|0;za=f[sa>>2]|0;if(!za){va=$Xc(88)|0;Ea=va+16|0;f[Ea>>2]=f[q>>2];f[Ea+4>>2]=f[q+4>>2];f[Ea+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[va+28>>2]=0;f[va+32>>2]=1124007936;Ea=va+40|0;Ca=va+72|0;H=va+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ca>>2]=Ea;Oa=va+80|0;f[va+76>>2]=Oa;f[Oa>>2]=0;f[va+84>>2]=0;Oa=f[g>>2]|0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=Oa;f[sa>>2]=va;Oa=f[f[l>>2]>>2]|0;if(!Oa)td=va;else{f[l>>2]=Oa;td=f[sa>>2]|0}UQ(f[C>>2]|0,td);f[D>>2]=(f[D>>2]|0)+1;ud=va}else ud=za;Oa=ud+32|0;Da=M+40|0;Ha=f[Da>>2]|0;if((Ha|0)==(f[M+44>>2]|0))bx(ta,Oa);else{f[Ha>>2]=f[Oa>>2];P=Ha+4|0;R=ud+36|0;f[P>>2]=f[R>>2];Ma=Ha+8|0;f[Ma>>2]=f[ud+40>>2];f[Ha+12>>2]=f[ud+44>>2];f[Ha+16>>2]=f[ud+48>>2];f[Ha+20>>2]=f[ud+52>>2];f[Ha+24>>2]=f[ud+56>>2];f[Ha+28>>2]=f[ud+60>>2];f[Ha+32>>2]=f[ud+64>>2];Ja=f[ud+68>>2]|0;f[Ha+36>>2]=Ja;f[Ha+40>>2]=Ma;Ma=Ha+48|0;wa=Ha+44|0;f[wa>>2]=Ma;f[Ma>>2]=0;f[Ha+52>>2]=0;if(Ja|0){Ma=Ja+12|0;f[Ma>>2]=(f[Ma>>2]|0)+1}if((f[R>>2]|0)<3){R=f[ud+76>>2]|0;Ma=f[wa>>2]|0;f[Ma>>2]=f[R>>2];f[Ma+4>>2]=f[R+4>>2]}else{f[P>>2]=0;U$(Ha,Oa)}f[Da>>2]=(f[Da>>2]|0)+56}if((b[Pa>>0]|0)<0)cYc(f[q>>2]|0)}Da=b[G>>0]|0;do if(((Da<<24>>24<0?f[Q>>2]|0:Da&255)|0)==21){if(LYc(j,0,-1,386204,21)|0)break;Oa=$Xc(84)|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;lYc(Oa,j);lYc(Oa+12|0,q);Ha=Oa+28|0;f[Ha>>2]=0;f[Oa+32>>2]=0;f[Oa+24>>2]=Ha;H=Oa+36|0;I=H+48|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[g>>2]=Oa;Ka=$Xc(16)|0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka>>2]=81880;f[Ka+12>>2]=Oa;Ga=g+4|0;f[Ga>>2]=Ka;if((b[q+11>>0]|0)<0){cYc(f[q>>2]|0);vd=f[g>>2]|0}else vd=Oa;tYc(vd+12|0,396591)|0;Ka=f[a+68>>2]|0;Na=Ka+76|0;ua=f[Na>>2]|0;if((ua|0)==(f[Ka+80>>2]|0))RLa(Ka+72|0,g);else{f[ua>>2]=f[g>>2];Ka=f[Ga>>2]|0;f[ua+4>>2]=Ka;if(!Ka)wd=ua;else{TXc(Ka);wd=f[Na>>2]|0}f[Na>>2]=wd+8}Na=M+36|0;Ka=f[Na>>2]|0;p[r>>3]=0.0;f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;mR(Ka,q,fT()|0)|0;Ka=f[Na>>2]|0;p[r>>3]=1.0;f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;mR(Ka+56|0,q,fT()|0)|0;Ka=f[Ga>>2]|0;if(Ka|0)UXc(Ka)}while(0);Da=f[a+68>>2]|0;Pa=Da+76|0;ta=f[Pa>>2]|0;if((ta|0)==(f[Da+80>>2]|0))RLa(Da+72|0,m);else{f[ta>>2]=f[m>>2];Da=f[L>>2]|0;f[ta+4>>2]=Da;if(!Da)xd=ta;else{TXc(Da);xd=f[Pa>>2]|0}f[Pa>>2]=xd+8}break b}while(0);tYc((f[m>>2]|0)+12|0,396499)|0;SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Pa=g+11|0;b[Pa>>0]=4;f[g>>2]=1702521203;b[g+4>>0]=0;Da=(HIa(k,g)|0)==0;if((b[Pa>>0]|0)<0)cYc(f[g>>2]|0);if(Da){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=$Xc(32)|0;f[g>>2]=Da;f[g+8>>2]=-2147483616;f[g+4>>2]=24;H=Da;O=386138;I=H+24|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Da+24>>0]=0;vM(-215,g,385937,385609,610)};f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;Pa=o+11|0;b[Pa>>0]=4;f[o>>2]=1702521203;b[o+4>>0]=0;VGa(g,NIa(k,o)|0);if((b[Pa>>0]|0)<0)cYc(f[o>>2]|0);Pa=o+4|0;f[Pa>>2]=0;f[Pa+4>>2]=0;Pa=o+11|0;b[Pa>>0]=3;b[o>>0]=b[515177]|0;b[o+1>>0]=b[515178]|0;b[o+2>>0]=b[515179]|0;b[o+3>>0]=0;$Ga(K,o,g)|0;if((b[Pa>>0]|0)<0)cYc(f[o>>2]|0);f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Pa=q+11|0;b[Pa>>0]=9;H=q;O=386163;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[q+9>>0]=0;Da=LGa(k,q)|0;if((Da|0)==(c|0))yd=1;else{ta=MGa(Da+28|0,-1)|0;yd=(ta|0)!=0|(J|0)!=0}if((b[Pa>>0]|0)<0)cYc(f[q>>2]|0);f[o>>2]=yd&1;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;ta=q+11|0;b[ta>>0]=4;f[q>>2]=1936291937;b[q+4>>0]=0;aHa(K,q,o)|0;if((b[ta>>0]|0)<0)cYc(f[q>>2]|0);ta=f[a+68>>2]|0;Da=ta+76|0;za=f[Da>>2]|0;if((za|0)==(f[ta+80>>2]|0))RLa(ta+72|0,m);else{f[za>>2]=f[m>>2];ta=f[L>>2]|0;f[za+4>>2]=ta;if(!ta)zd=za;else{TXc(ta);zd=f[Da>>2]|0}f[Da>>2]=zd+8}RGa(g);break b}while(0);tYc((f[m>>2]|0)+12|0,429057)|0;SLa(a,k,l);Da=b[G>>0]|0;do if(((Da<<24>>24<0?f[Q>>2]|0:Da&255)|0)==17){if(LYc(j,0,-1,386014,17)|0)break;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ta=g+11|0;b[ta>>0]=4;f[g>>2]=1819242352;b[g+4>>0]=0;JIa(K,g,390419)|0;if((b[ta>>0]|0)<0)cYc(f[g>>2]|0);f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;ta=$Xc(16)|0;f[o>>2]=ta;f[o+8>>2]=-2147483632;f[o+4>>2]=15;H=ta;O=386054;I=H+15|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ta+15>>0]=0;f[q+8>>2]=0;Pa=q+11|0;b[Pa>>0]=7;b[q>>0]=b[386070]|0;b[q+1>>0]=b[386071]|0;b[q+2>>0]=b[386072]|0;b[q+3>>0]=b[386073]|0;b[q+4>>0]=b[386074]|0;b[q+5>>0]=b[386075]|0;b[q+6>>0]=b[386076]|0;b[q+7>>0]=0;za=ULa(l,g,q)|0;va=f[za>>2]|0;if(!va){sa=$Xc(88)|0;Ea=sa+16|0;f[Ea>>2]=f[q>>2];f[Ea+4>>2]=f[q+4>>2];f[Ea+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[sa+28>>2]=0;f[sa+32>>2]=1124007936;Ea=sa+40|0;Ca=sa+72|0;H=sa+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Ca>>2]=Ea;ta=sa+80|0;f[sa+76>>2]=ta;f[ta>>2]=0;f[sa+84>>2]=0;ta=f[g>>2]|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=ta;f[za>>2]=sa;ta=f[f[l>>2]>>2]|0;if(!ta)Ad=sa;else{f[l>>2]=ta;Ad=f[za>>2]|0}UQ(f[C>>2]|0,Ad);f[D>>2]=(f[D>>2]|0)+1;Bd=sa}else Bd=va;aHa(K,o,Bd+28|0)|0;if((b[Pa>>0]|0)<0)cYc(f[q>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0)}while(0);Da=b[G>>0]|0;do if(((Da<<24>>24<0?f[Q>>2]|0:Da&255)|0)==21){if(LYc(j,0,-1,386032,21)|0)break;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ta=g+11|0;b[ta>>0]=4;f[g>>2]=1819242352;b[g+4>>0]=0;JIa(K,g,390435)|0;if((b[ta>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ta=$Xc(32)|0;f[g>>2]=ta;f[g+8>>2]=-2147483616;f[g+4>>2]=20;H=ta;O=443543;I=H+20|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ta+20>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Pa=$Xc(32)|0;f[q>>2]=Pa;f[q+8>>2]=-2147483616;f[q+4>>2]=17;H=Pa;O=386078;I=H+17|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Pa+17>>0]=0;if(HIa(k,q)|0){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;ta=$Xc(32)|0;f[r>>2]=ta;f[r+8>>2]=-2147483616;f[r+4>>2]=17;H=ta;O=386078;I=H+17|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[ta+17>>0]=0;Pa=MGa(NIa(k,r)|0,-1)|0;b[o>>0]=((Pa|0)!=0|(J|0)!=0)&1;cHa(K,g,o)|0;if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0)}else{b[o>>0]=0;cHa(K,g,o)|0}if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}while(0);VLa(k,K);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=9;H=g;O=443519;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;Pa=(HIa(k,g)|0)==0;if((b[Da>>0]|0)<0)cYc(f[g>>2]|0);if(Pa){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Pa=$Xc(32)|0;f[g>>2]=Pa;f[g+8>>2]=-2147483616;f[g+4>>2]=29;H=Pa;O=386096;I=H+29|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Pa+29>>0]=0;vM(-215,g,385937,385609,583)};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Da=g+11|0;b[Da>>0]=9;H=g;O=443519;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Pa=q+11|0;b[Pa>>0]=9;H=q;O=443519;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[q+9>>0]=0;va=MGa(NIa(k,q)|0,-1)|0;b[o>>0]=((va|0)!=0|(J|0)!=0)&1;cHa(K,g,o)|0;if((b[Pa>>0]|0)<0)cYc(f[q>>2]|0);if((b[Da>>0]|0)<0)cYc(f[g>>2]|0);va=f[a+68>>2]|0;sa=va+76|0;za=f[sa>>2]|0;if((za|0)==(f[va+80>>2]|0)){RLa(va+72|0,m);break b}f[za>>2]=f[m>>2];va=f[L>>2]|0;f[za+4>>2]=va;if(!va)Cd=za;else{TXc(va);Cd=f[sa>>2]|0}f[sa>>2]=Cd+8;break b}while(0);tYc((f[m>>2]|0)+12|0,429163)|0;SLa(a,k,l);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;sa=g+11|0;b[sa>>0]=6;b[g>>0]=b[385901]|0;b[g+1>>0]=b[385902]|0;b[g+2>>0]=b[385903]|0;b[g+3>>0]=b[385904]|0;b[g+4>>0]=b[385905]|0;b[g+5>>0]=b[385906]|0;b[g+6>>0]=0;va=(TLa(l,g)|0)==0;if((b[sa>>0]|0)<0)cYc(f[g>>2]|0);if(va){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;va=$Xc(32)|0;f[g>>2]=va;f[g+8>>2]=-2147483616;f[g+4>>2]=28;H=va;O=385908;I=H+28|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[va+28>>0]=0;vM(-215,g,385937,385609,524)}sa=M+36|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;za=o+11|0;b[za>>0]=6;b[o>>0]=b[385901]|0;b[o+1>>0]=b[385902]|0;b[o+2>>0]=b[385903]|0;b[o+3>>0]=b[385904]|0;b[o+4>>0]=b[385905]|0;b[o+5>>0]=b[385906]|0;b[o+6>>0]=0;Ea=ULa(l,g,o)|0;Ca=f[Ea>>2]|0;if(!Ca){Ka=$Xc(88)|0;Ga=Ka+16|0;f[Ga>>2]=f[o>>2];f[Ga+4>>2]=f[o+4>>2];f[Ga+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[Ka+28>>2]=0;f[Ka+32>>2]=1124007936;Ga=Ka+40|0;Na=Ka+72|0;H=Ka+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Na>>2]=Ga;va=Ka+80|0;f[Ka+76>>2]=va;f[va>>2]=0;f[Ka+84>>2]=0;va=f[g>>2]|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=va;f[Ea>>2]=Ka;va=f[f[l>>2]>>2]|0;if(!va)Dd=Ka;else{f[l>>2]=va;Dd=f[Ea>>2]|0}UQ(f[C>>2]|0,Dd);f[D>>2]=(f[D>>2]|0)+1;Ed=Ka}else Ed=Ca;va=Ed+32|0;ua=M+40|0;La=f[ua>>2]|0;Ia=M+44|0;if((La|0)==(f[Ia>>2]|0))bx(sa,va);else{f[La>>2]=f[va>>2];Ha=La+4|0;P=Ed+36|0;f[Ha>>2]=f[P>>2];R=La+8|0;f[R>>2]=f[Ed+40>>2];f[La+12>>2]=f[Ed+44>>2];f[La+16>>2]=f[Ed+48>>2];f[La+20>>2]=f[Ed+52>>2];f[La+24>>2]=f[Ed+56>>2];f[La+28>>2]=f[Ed+60>>2];f[La+32>>2]=f[Ed+64>>2];Ma=f[Ed+68>>2]|0;f[La+36>>2]=Ma;f[La+40>>2]=R;R=La+48|0;wa=La+44|0;f[wa>>2]=R;f[R>>2]=0;f[La+52>>2]=0;if(Ma|0){R=Ma+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[P>>2]|0)<3){P=f[Ed+76>>2]|0;R=f[wa>>2]|0;f[R>>2]=f[P>>2];f[R+4>>2]=f[P+4>>2]}else{f[Ha>>2]=0;U$(La,va)}f[ua>>2]=(f[ua>>2]|0)+56}if((b[za>>0]|0)<0)cYc(f[o>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;va=g+11|0;b[va>>0]=4;f[g>>2]=1935763810;b[g+4>>0]=0;La=(TLa(l,g)|0)!=0;if((b[va>>0]|0)<0)cYc(f[g>>2]|0);b[o>>0]=La&1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;La=g+11|0;b[La>>0]=9;H=g;O=445999;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;cHa(K,g,o)|0;if((b[La>>0]|0)<0)cYc(f[g>>2]|0);if(b[o>>0]|0){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;za=q+11|0;b[za>>0]=4;f[q>>2]=1935763810;b[q+4>>0]=0;Ca=ULa(l,g,q)|0;Ka=f[Ca>>2]|0;if(!Ka){Ea=$Xc(88)|0;Ga=Ea+16|0;f[Ga>>2]=f[q>>2];f[Ga+4>>2]=f[q+4>>2];f[Ga+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[Ea+28>>2]=0;f[Ea+32>>2]=1124007936;Ga=Ea+40|0;Na=Ea+72|0;H=Ea+36|0;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[Na>>2]=Ga;La=Ea+80|0;f[Ea+76>>2]=La;f[La>>2]=0;f[Ea+84>>2]=0;La=f[g>>2]|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=La;f[Ca>>2]=Ea;La=f[f[l>>2]>>2]|0;if(!La)Fd=Ea;else{f[l>>2]=La;Fd=f[Ca>>2]|0}UQ(f[C>>2]|0,Fd);f[D>>2]=(f[D>>2]|0)+1;Gd=Ea}else Gd=Ka;La=Gd+32|0;va=f[ua>>2]|0;if((va|0)==(f[Ia>>2]|0))bx(sa,La);else{f[va>>2]=f[La>>2];Ha=va+4|0;P=Gd+36|0;f[Ha>>2]=f[P>>2];R=va+8|0;f[R>>2]=f[Gd+40>>2];f[va+12>>2]=f[Gd+44>>2];f[va+16>>2]=f[Gd+48>>2];f[va+20>>2]=f[Gd+52>>2];f[va+24>>2]=f[Gd+56>>2];f[va+28>>2]=f[Gd+60>>2];f[va+32>>2]=f[Gd+64>>2];wa=f[Gd+68>>2]|0;f[va+36>>2]=wa;f[va+40>>2]=R;R=va+48|0;Ma=va+44|0;f[Ma>>2]=R;f[R>>2]=0;f[va+52>>2]=0;if(wa|0){R=wa+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[P>>2]|0)<3){P=f[Gd+76>>2]|0;R=f[Ma>>2]|0;f[R>>2]=f[P>>2];f[R+4>>2]=f[P+4>>2]}else{f[Ha>>2]=0;U$(va,La)}f[ua>>2]=(f[ua>>2]|0)+56}if((b[za>>0]|0)<0)cYc(f[q>>2]|0)}La=g+11|0;b[La>>0]=10;H=g;O=453228;I=H+10|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+10>>0]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;za=$Xc(16)|0;f[r>>2]=za;f[r+8>>2]=-2147483632;f[r+4>>2]=12;H=za;O=385953;I=H+12|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[za+12>>0]=0;ua=MGa(NIa(k,r)|0,-1)|0;f[q>>2]=ua;aHa(K,g,q)|0;if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);if((b[La>>0]|0)<0)cYc(f[g>>2]|0);VLa(k,K);ua=b[G>>0]|0;do if(((ua<<24>>24<0?f[Q>>2]|0:ua&255)|0)==20){if(LYc(j,0,-1,385880,20)|0)break;Ia=f[sa>>2]|0;if((f[Ia+4>>2]|0)!=2){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Ka=$Xc(32)|0;f[g>>2]=Ka;f[g+8>>2]=-2147483616;f[g+4>>2]=30;H=Ka;O=385966;I=H+30|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Ka+30>>0]=0;vM(-215,g,385937,385609,539)}Da=f[(f[Ia+40>>2]|0)+4>>2]|0;f[g>>2]=0;Pa=g+4|0;f[Pa>>2]=0;f[g+8>>2]=0;Ea=$Xc(16)|0;f[g>>2]=Ea;Ca=Ea+16|0;f[g+8>>2]=Ca;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;f[Pa>>2]=Ca;f[Ea>>2]=f[f[(f[sa>>2]|0)+40>>2]>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ea=q+11|0;b[Ea>>0]=8;Ca=q;f[Ca>>2]=1852990827;f[Ca+4>>2]=1751084133;b[q+8>>0]=0;Ca=MGa(NIa(K,q)|0,-1)|0;f[(f[g>>2]|0)+8>>2]=Ca;if((b[Ea>>0]|0)<0)cYc(f[q>>2]|0);f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Ea=q+11|0;b[Ea>>0]=8;Ca=q;f[Ca>>2]=1852990827;f[Ca+4>>2]=2002742373;b[q+8>>0]=0;Ca=MGa(NIa(K,q)|0,-1)|0;Ga=f[g>>2]|0;f[Ga+12>>2]=Ca;if((b[Ea>>0]|0)<0){cYc(f[q>>2]|0);Ea=f[g>>2]|0;Hd=Ea;Id=f[Ea+12>>2]|0}else{Hd=Ga;Id=Ca}Ca=(Da|0)/(Y(Id,f[Hd+8>>2]|0)|0)|0;f[Hd+4>>2]=Ca;i0(q,f[sa>>2]|0,1,g);Ca=f[sa>>2]|0;do if((Ca|0)==(q|0)){Da=q+36|0;Ga=f[Da>>2]|0;if(!Ga){Jd=Da;break}Ea=Ga+12|0;Ga=f[Ea>>2]|0;f[Ea>>2]=Ga+-1;if((Ga|0)!=1){Jd=Da;break}V$(q);Jd=Da}else{Da=Ca+36|0;Ga=f[Da>>2]|0;do if(Ga|0){Ea=Ga+12|0;Na=f[Ea>>2]|0;f[Ea>>2]=Na+-1;if((Na|0)!=1)break;V$(Ca)}while(0);f[Da>>2]=0;Ga=Ca+16|0;ta=Ca+4|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[ta>>2]|0)>0){Na=f[Ca+40>>2]|0;Ea=0;do{f[Na+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[ta>>2]|0))}f[Ca>>2]=f[q>>2];Ea=q+4|0;f[ta>>2]=f[Ea>>2];Na=q+8|0;va=Ca+8|0;f[va>>2]=f[Na>>2];f[Ca+12>>2]=f[q+12>>2];f[Ga>>2]=f[q+16>>2];f[Ca+20>>2]=f[q+20>>2];f[Ca+24>>2]=f[q+24>>2];f[Ca+28>>2]=f[q+28>>2];f[Ca+32>>2]=f[q+32>>2];Ha=q+36|0;f[Da>>2]=f[Ha>>2];P=Ca+44|0;R=f[P>>2]|0;Ma=Ca+48|0;if((R|0)==(Ma|0))Kd=R;else{wL(R);f[P>>2]=Ma;f[Ca+40>>2]=va;Kd=Ma}Ma=q+44|0;if((f[Ea>>2]|0)<3){va=f[Ma>>2]|0;f[Kd>>2]=f[va>>2];f[Kd+4>>2]=f[va+4>>2]}else{f[P>>2]=f[Ma>>2];P=q+40|0;f[Ca+40>>2]=f[P>>2];f[Ma>>2]=q+48;f[P>>2]=Na}f[q>>2]=1124007936;H=Ea;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));Jd=Ha}while(0);f[Jd>>2]=0;Ca=q+16|0;Ia=q+4|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[Ia>>2]|0)>0){Ca=f[q+40>>2]|0;Ka=0;do{f[Ca+(Ka<<2)>>2]=0;Ka=Ka+1|0}while((Ka|0)<(f[Ia>>2]|0))}Ia=f[q+44>>2]|0;if((Ia|0)!=(q+48|0))wL(Ia);Ia=f[g>>2]|0;if(Ia|0){Ka=f[Pa>>2]|0;if((Ka|0)!=(Ia|0))f[Pa>>2]=Ka+(~((Ka+-4-Ia|0)>>>2)<<2);cYc(Ia)}}while(0);sa=f[a+68>>2]|0;ua=sa+76|0;La=f[ua>>2]|0;if((La|0)==(f[sa+80>>2]|0))RLa(sa+72|0,m);else{f[La>>2]=f[m>>2];sa=f[L>>2]|0;f[La+4>>2]=sa;if(!sa)Ld=La;else{TXc(sa);Ld=f[ua>>2]|0}f[ua>>2]=Ld+8}}while(0);d:do if((S|0)==37){D=a+68|0;C=f[D>>2]|0;N=C+76|0;ua=f[N>>2]|0;if((ua|0)==(f[C+80>>2]|0)){RLa(C+72|0,m);Md=m}else{f[ua>>2]=f[m>>2];sa=f[L>>2]|0;f[ua+4>>2]=sa;if(!sa)Nd=ua;else{TXc(sa);Nd=f[N>>2]|0}f[N>>2]=Nd+8;Md=m}f[D>>2]=f[Md>>2];SLa(a,k,l);f[D>>2]=C;C=b[G>>0]|0;D=f[Q>>2]|0;do if(((C<<24>>24<0?D:C&255)|0)==8){if(LYc(j,0,-1,385767,8)|0){Od=b[G>>0]|0;Pd=f[Q>>2]|0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;N=$Xc(16)|0;f[g>>2]=N;f[g+8>>2]=-2147483632;f[g+4>>2]=14;H=N;O=385820;I=H+14|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[N+14>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Pa=$Xc(16)|0;f[q>>2]=Pa;f[q+8>>2]=-2147483632;f[q+4>>2]=14;H=Pa;O=385820;I=H+14|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Pa+14>>0]=0;N=MGa(NIa(k,q)|0,-1)|0;f[o>>2]=N;aHa(K,g,o)|0;if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;N=$Xc(16)|0;f[g>>2]=N;f[g+8>>2]=-2147483632;f[g+4>>2]=15;H=N;O=385835;I=H+15|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[N+15>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Pa=$Xc(16)|0;f[q>>2]=Pa;f[q+8>>2]=-2147483632;f[q+4>>2]=15;H=Pa;O=385835;I=H+15|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[Pa+15>>0]=0;N=MGa(NIa(k,q)|0,-1)|0;f[o>>2]=N;aHa(K,g,o)|0;if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);break d}else{Od=C;Pd=D}while(0);if(((Od<<24>>24<0?Pd:Od&255)|0)==6){if(LYc(j,0,-1,428960,6)|0){Qd=b[G>>0]|0;Rd=f[Q>>2]|0;S=57}}else{Qd=Od;Rd=Pd;S=57}do if((S|0)==57){if(((Qd<<24>>24<0?Rd:Qd&255)|0)==9){if(!(LYc(j,0,-1,385788,9)|0))break;Sd=b[G>>0]|0;Td=f[Q>>2]|0}else{Sd=Qd;Td=Rd}if(((Sd<<24>>24<0?Td:Sd&255)|0)!=11)break d;if(LYc(j,0,-1,385798,11)|0)break d}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;D=g+11|0;b[D>>0]=9;H=g;O=385851;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[g+9>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;C=q+11|0;b[C>>0]=9;H=q;O=385851;I=H+9|0;do{b[H>>0]=b[O>>0]|0;H=H+1|0;O=O+1|0}while((H|0)<(I|0));b[q+9>>0]=0;N=MGa(NIa(k,q)|0,-1)|0;f[o>>2]=N;aHa(K,g,o)|0;if((b[C>>0]|0)<0)cYc(f[q>>2]|0);if((b[D>>0]|0)<0)cYc(f[g>>2]|0)}while(0);K=f[L>>2]|0;if(K|0)UXc(K);ZLa(l,f[E>>2]|0);QGa(k,f[c>>2]|0)}while(0);k=f[B>>2]|0;do if(k){l=f[h>>2]|0;g=a+20|0;q=k;while(1){o=f[q+16>>2]|0;if((l|0)<(o|0)){Sd=f[q>>2]|0;if(!Sd){S=1165;break}else{Ud=q;Vd=Sd}}else{if((o|0)>=(l|0)){S=1169;break}Wd=q+4|0;o=f[Wd>>2]|0;if(!o){S=1168;break}else{Ud=Wd;Vd=o}}g=Ud;q=Vd}if((S|0)==1165){Xd=q;Yd=q;break}else if((S|0)==1168){Xd=q;Yd=Wd;break}else if((S|0)==1169){Xd=q;Yd=g;break}}else{Xd=B;Yd=B}while(0);if(!(f[Yd>>2]|0)){B=$Xc(20)|0;f[B+16>>2]=f[h>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=Xd;f[Yd>>2]=B;Xd=f[f[A>>2]>>2]|0;if(!Xd)Zd=B;else{f[A>>2]=Xd;Zd=f[Yd>>2]|0}UQ(f[a+20>>2]|0,Zd);Zd=a+24|0;f[Zd>>2]=(f[Zd>>2]|0)+1}if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=e;return}function KLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((b|0)<0)c=UMa(f[a+8>>2]|0)|0;else c=b;b=a+16|0;d=a+20|0;e=f[d>>2]|0;do if(e){g=e;do{h=f[g+16>>2]|0;if((c|0)<(h|0))i=g;else{if((h|0)>=(c|0)){j=25;break}i=g+4|0}g=f[i>>2]|0}while((g|0)!=0);if((j|0)==25)return;g=a+20|0;h=e;while(1){k=f[h+16>>2]|0;if((c|0)<(k|0)){l=f[h>>2]|0;if(!l){j=13;break}else{m=h;n=l}}else{if((k|0)>=(c|0)){j=17;break}o=h+4|0;k=f[o>>2]|0;if(!k){j=16;break}else{m=o;n=k}}g=m;h=n}if((j|0)==13){p=h;q=h;break}else if((j|0)==16){p=h;q=o;break}else if((j|0)==17){p=h;q=g;break}}else{p=d;q=d}while(0);if(!(f[q>>2]|0)){d=$Xc(20)|0;f[d+16>>2]=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=p;f[q>>2]=d;p=f[f[b>>2]>>2]|0;if(!p)r=d;else{f[b>>2]=p;r=f[q>>2]|0}UQ(f[a+20>>2]|0,r);r=a+24|0;f[r>>2]=(f[r>>2]|0)+1}r=UMa(f[a+8>>2]|0)|0;if((r|0)>0)s=0;else return;do{GLa(a);GLa(a);s=s+1|0}while((s|0)!=(r|0));return}function LLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=c+8|0;c=UMa(f[g>>2]|0)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(c>>>0>4294967279)jYc(e);if(c>>>0<11){h=e+11|0;b[h>>0]=c;if(!c){i=e;j=h}else{k=e;l=h;m=6}}else{h=c+16&-16;n=$Xc(h)|0;f[e>>2]=n;f[e+8>>2]=h|-2147483648;f[e+4>>2]=c;k=n;l=e+11|0;m=6}if((m|0)==6){g1c(k|0,0,c|0)|0;i=k;j=l}b[i+c>>0]=0;IMa(f[g>>2]|0,(b[j>>0]|0)<0?f[e>>2]|0:e,c)|0;c=e+11|0;j=b[c>>0]|0;i=j<<24>>24<0;l=i?f[e>>2]|0:e;k=i?f[e+4>>2]|0:j&255;j=l+k|0;i=j;a:do if((k|0)>=2){n=l;h=k;while(1){o=h+-1|0;if(!o){m=22;break a}p=AJc(n,86,o)|0;if(!p){m=22;break a}if(!(WKc(p,388298,2)|0))break;n=p+1|0;h=i-n|0;if((h|0)<2){m=22;break a}}if((p|0)==(l|0)&(p|0)!=(j|0)){h=UMa(f[g>>2]|0)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(h>>>0>4294967279)jYc(a);if(h>>>0<11){n=a+11|0;b[n>>0]=h;if(!h){q=a;r=n}else{s=a;t=n;m=18}}else{n=h+16&-16;o=$Xc(n)|0;f[a>>2]=o;f[a+8>>2]=n|-2147483648;f[a+4>>2]=h;s=o;t=a+11|0;m=18}if((m|0)==18){g1c(s|0,0,h|0)|0;q=s;r=t}b[q+h>>0]=0;if((b[r>>0]|0)<0)v=f[a>>2]|0;else v=a;IMa(f[g>>2]|0,v,h)|0}else m=22}else m=22;while(0);if((m|0)==22)lYc(a,e);if((b[c>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function MLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=u;u=u+64|0;g=e+48|0;i=e+36|0;j=e+24|0;k=e+12|0;l=e;m=a+11|0;n=b[m>>0]|0;o=n<<24>>24<0;p=o?f[a>>2]|0:a;q=dJc(d)|0;r=a+4|0;s=f[r>>2]|0;t=n&255;do if(q|0){n=o?s:t;v=p+n|0;w=v;if((n|0)<(q|0)){x=-1;u=e;return x|0}y=h[d>>0]|0;z=p;A=n;while(1){n=A-q+1|0;if(!n){x=-1;B=44;break}C=AJc(z,y,n)|0;if(!C){x=-1;B=44;break}if(!(WKc(C,d,q)|0)){B=8;break}z=C+1|0;A=w-z|0;if((A|0)<(q|0)){x=-1;B=44;break}}if((B|0)==8){if((C|0)==(p|0)&(C|0)!=(v|0))break;else x=-1;u=e;return x|0}else if((B|0)==44){u=e;return x|0}}while(0);C=o?s:t;t=dJc(c)|0;s=p+C|0;a:do if((t|0)==0|(C|0)<(t|0))D=s;else{o=p+(t+-1)|0;q=c+t+-1|0;A=s;b:while(1){z=A;while(1){if((o|0)==(z|0)){D=s;break a}E=z+-1|0;if((b[E>>0]|0)==(b[q>>0]|0)){F=q;G=E;break}else z=E}while(1){if((F|0)==(c|0)){D=G;break a}z=G+-1|0;w=F+-1|0;if((b[z>>0]|0)==(b[w>>0]|0)){F=w;G=z}else{A=E;continue b}}}}while(0);if((((t|0)!=0&(D|0)==(s|0)?-1:D-p|0)|0)!=(C-(dJc(c)|0)|0)){x=-1;u=e;return x|0}p=dJc(d)|0;mYc(g,a,p,C-p-(dJc(c)|0)|0,a);c=g+11|0;p=b[c>>0]|0;C=g+4|0;d=f[C>>2]|0;if(((p<<24>>24<0?d:p&255)|0)==6)if(!(LYc(g,0,-1,388206,6)|0))H=6;else{I=b[c>>0]|0;J=f[C>>2]|0;B=20}else{I=p;J=d;B=20}do if((B|0)==20){if(((I<<24>>24<0?J:I&255)|0)==5){if(!(LYc(g,0,-1,388213,5)|0)){H=5;break}K=b[c>>0]|0;L=f[C>>2]|0}else{K=I;L=J}if(((K<<24>>24<0?L:K&255)|0)==4){if(!(LYc(g,0,-1,388219,4)|0)){H=5;break}M=b[c>>0]|0;N=f[C>>2]|0}else{M=K;N=L}if(((M<<24>>24<0?N:M&255)|0)==4){if(!(LYc(g,0,-1,388224,4)|0)){H=0;break}O=f[C>>2]|0;P=b[c>>0]|0}else{O=N;P=M}if(((P<<24>>24<0?O:P&255)|0)==4){if(!(LYc(g,0,-1,388229,4)|0)){H=1;break}Q=b[c>>0]|0;R=f[C>>2]|0}else{Q=P;R=O}if(((Q<<24>>24<0?R:Q&255)|0)==5){if(!(LYc(g,0,-1,388234,5)|0)){H=3;break}S=b[c>>0]|0;T=f[C>>2]|0}else{S=Q;T=R}if(((S<<24>>24<0?T:S&255)|0)==3){if(!(LYc(g,0,-1,388240,3)|0)){H=4;break}U=b[c>>0]|0;V=f[C>>2]|0}else{U=S;V=T}if(((U<<24>>24<0?V:U&255)|0)==4?(LYc(g,0,-1,388244,4)|0)==0:0){H=12;break}SGa(l,388249,g);d=AYc(l,388264)|0;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[k+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;d=b[m>>0]|0;p=d<<24>>24<0;D=zYc(k,p?f[a>>2]|0:a,p?f[r>>2]|0:d&255)|0;f[j>>2]=f[D>>2];f[j+4>>2]=f[D+4>>2];f[j+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=AYc(j,505469)|0;f[i>>2]=f[D>>2];f[i+4>>2]=f[D+4>>2];f[i+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;vM(-213,i,388283,385609,232)}while(0);if((b[c>>0]|0)<0)cYc(f[g>>2]|0);x=H;u=e;return x|0}function NLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;e=u;u=u+400|0;g=e+376|0;h=e+40|0;i=e;j=e+312|0;k=e+256|0;l=e+200|0;m=e+144|0;n=e+80|0;o=a+8|0;p=UMa(f[o>>2]|0)|0;q=h+8|0;f[h>>2]=q;r=h+4|0;s=p>>>0>4;f[r>>2]=p;if(s){t=bYc(p>>>0>536870911?-1:p<<3)|0;f[h>>2]=t;v=t}else v=q;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=p;if(s){x=bYc(p>>>0>536870911?-1:p<<3)|0;f[i>>2]=x}LMa(f[o>>2]|0,v,p)|0;LMa(f[o>>2]|0,f[i>>2]|0,p)|0;v=VMa(f[o>>2]|0)|0;x=v+-1|0;v=UMa(f[o>>2]|0)|0;if(!((v|0)==4|(v|p|0)==0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(64)|0;f[g>>2]=y;f[g+8>>2]=-2147483584;f[g+4>>2]=60;z=y;A=388018;B=z+60|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[y+60>>0]=0;vM(-215,g,388079,385609,399)}if(!v){v=k+4|0;y=k+40|0;f[y>>2]=k+8;C=k+48|0;D=k+44|0;f[D>>2]=C;f[C>>2]=0;f[k+52>>2]=0;f[j>>2]=c;f[j+4>>2]=1124007936;E=j+8|0;F=j+12|0;G=j+20|0;H=k+16|0;I=j+40|0;J=k+36|0;K=j+44|0;z=E;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[K>>2]=F;F=j+52|0;f[j+48>>2]=F;f[F>>2]=0;f[j+56>>2]=0;f[k>>2]=1124007936;z=v;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));dMa(g,a+40|0,j,j);K=j+4|0;L=f[I>>2]|0;if(L|0?(M=L+12|0,L=f[M>>2]|0,f[M>>2]=L+-1,(L|0)==1):0)V$(K);f[I>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[E>>2]|0)>0){G=f[j+44>>2]|0;I=0;do{f[G+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[E>>2]|0))}E=f[j+48>>2]|0;if((E|0)!=(F|0))wL(E);E=f[J>>2]|0;if(E|0?(F=E+12|0,E=f[F>>2]|0,f[F>>2]=E+-1,(E|0)==1):0)V$(k);f[J>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[v>>2]|0)>0){H=f[y>>2]|0;y=0;do{f[H+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[v>>2]|0))}v=f[D>>2]|0;if((v|0)!=(C|0))wL(v)}else{v=UMa(f[o>>2]|0)|0;o=a+16|0;C=a+20|0;D=f[C>>2]|0;a:do if(!D)N=31;else{y=D;while(1){H=f[y+16>>2]|0;if((v|0)<(H|0))O=y;else{if((H|0)>=(v|0))break;O=y+4|0}y=f[O>>2]|0;if(!y){N=31;break a}}y=a+32|0;P=d;Q=y;R=y;S=a+28|0}while(0);if((N|0)==31){LLa(g,a);O=MLa(g,385736,385729)|0;if(!((O|0)>-1&(O|0)==(d|0))){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;O=$Xc(48)|0;f[j>>2]=O;f[j+8>>2]=-2147483600;f[j+4>>2]=45;z=O;A=388095;B=z+45|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[O+45>>0]=0;vM(-215,j,388079,385609,412)}OLa(a,v,d);d=a+28|0;O=a+32|0;D=f[O>>2]|0;do if(D){y=a+32|0;H=D;while(1){J=f[H+16>>2]|0;if((v|0)<(J|0)){E=f[H>>2]|0;if(!E){N=38;break}else{T=H;U=E}}else{if((J|0)>=(v|0)){N=42;break}V=H+4|0;J=f[V>>2]|0;if(!J){N=41;break}else{T=V;U=J}}y=T;H=U}if((N|0)==38){W=H;X=H;break}else if((N|0)==41){W=H;X=V;break}else if((N|0)==42){W=H;X=y;break}}else{W=O;X=O}while(0);V=f[X>>2]|0;if(!V){U=$Xc(76)|0;f[U+16>>2]=v;f[U+20>>2]=1124007936;T=U+28|0;D=U+60|0;z=U+24|0;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[D>>2]=T;T=U+68|0;f[U+64>>2]=T;f[T>>2]=0;f[U+72>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=W;f[X>>2]=U;W=f[f[d>>2]>>2]|0;if(!W)Z=U;else{f[d>>2]=W;Z=f[X>>2]|0}UQ(f[a+32>>2]|0,Z);Z=a+36|0;f[Z>>2]=(f[Z>>2]|0)+1;_=U}else _=V;V=f[_+20>>2]&4095;_=f[C>>2]|0;do if(_){U=a+20|0;Z=_;while(1){X=f[Z+16>>2]|0;if((v|0)<(X|0)){W=f[Z>>2]|0;if(!W){N=53;break}else{$=Z;aa=W}}else{if((X|0)>=(v|0)){N=57;break}ba=Z+4|0;X=f[ba>>2]|0;if(!X){N=56;break}else{$=ba;aa=X}}U=$;Z=aa}if((N|0)==53){ca=Z;da=Z;break}else if((N|0)==56){ca=Z;da=ba;break}else if((N|0)==57){ca=Z;da=U;break}}else{ca=C;da=C}while(0);if(!(f[da>>2]|0)){C=$Xc(20)|0;f[C+16>>2]=v;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=ca;f[da>>2]=C;ca=f[f[o>>2]>>2]|0;if(!ca)ea=C;else{f[o>>2]=ca;ea=f[da>>2]|0}UQ(f[a+20>>2]|0,ea);ea=a+24|0;f[ea>>2]=(f[ea>>2]|0)+1}if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);P=V;Q=O;R=O;S=d}d=f[f[i>>2]>>2]|0;O=f[f[h>>2]>>2]|0;V=f[R>>2]|0;ea=a+32|0;do if(V){da=ea;ca=V;while(1){o=f[ca+16>>2]|0;if((v|0)<(o|0)){C=f[ca>>2]|0;if(!C){N=71;break}else{fa=ca;ga=C}}else{if((o|0)>=(v|0)){N=75;break}ha=ca+4|0;o=f[ha>>2]|0;if(!o){N=74;break}else{fa=ha;ga=o}}da=fa;ca=ga}if((N|0)==71){ia=ca;ja=ca;break}else if((N|0)==74){ia=ca;ja=ha;break}else if((N|0)==75){ia=ca;ja=da;break}}else{ia=Q;ja=ea}while(0);ea=f[ja>>2]|0;if(!ea){ha=$Xc(76)|0;f[ha+16>>2]=v;f[ha+20>>2]=1124007936;ga=ha+28|0;fa=ha+60|0;z=ha+24|0;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[fa>>2]=ga;ga=ha+68|0;f[ha+64>>2]=ga;f[ga>>2]=0;f[ha+72>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=ia;f[ja>>2]=ha;ia=f[f[a+28>>2]>>2]|0;if(!ia)ka=ha;else{f[S>>2]=ia;ka=f[ja>>2]|0}UQ(f[a+32>>2]|0,ka);ka=a+36|0;f[ka>>2]=(f[ka>>2]|0)+1;la=ha}else la=ea;ea=(Y(O,d)|0)+x|0;d=f[la+24>>2]|0;if((d|0)<3)ma=Y(f[la+32>>2]|0,f[la+28>>2]|0)|0;else{O=f[la+60>>2]|0;la=0;ha=1;while(1){ka=Y(f[O+(la<<2)>>2]|0,ha)|0;la=la+1|0;if((la|0)==(d|0)){ma=ka;break}else ha=ka}}if(ea>>>0>ma>>>0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ma=$Xc(80)|0;f[g>>2]=ma;f[g+8>>2]=-2147483568;f[g+4>>2]=64;z=ma;A=388141;B=z+64|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));b[ma+64>>0]=0;vM(-201,g,388079,385609,422)}ma=j+8|0;f[j>>2]=ma;A=j+4|0;f[A>>2]=p;if(s){ea=bYc(p>>>0>1073741823?-1:p<<2)|0;f[j>>2]=ea;na=ea}else na=ma;ea=k+8|0;f[k>>2]=ea;ha=k+4|0;f[ha>>2]=p;if(s){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[k>>2]=s;oa=s}else oa=ea;if((p|0)>0){s=f[h>>2]|0;d=f[i>>2]|0;la=Y(675553809>>>(P<<2&28)&15,(P>>>3&511)+1|0)|0;O=p;do{ka=O;O=O+-1|0;f[na+(O<<2)>>2]=f[s+(O<<3)>>2];ja=Y(la,f[d+(O<<3)>>2]|0)|0;f[oa+(O<<2)>>2]=ja}while((ka|0)>1)}O=f[R>>2]|0;R=a+32|0;do if(O){d=R;la=O;while(1){s=f[la+16>>2]|0;if((v|0)<(s|0)){ka=f[la>>2]|0;if(!ka){N=96;break}else{pa=la;qa=ka}}else{if((s|0)>=(v|0)){N=100;break}ra=la+4|0;s=f[ra>>2]|0;if(!s){N=99;break}else{pa=ra;qa=s}}d=pa;la=qa}if((N|0)==96){sa=la;ta=la;break}else if((N|0)==99){sa=la;ta=ra;break}else if((N|0)==100){sa=la;ta=d;break}}else{sa=Q;ta=R}while(0);R=f[ta>>2]|0;if(!R){Q=$Xc(76)|0;f[Q+16>>2]=v;f[Q+20>>2]=1124007936;v=Q+28|0;N=Q+60|0;z=Q+24|0;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[N>>2]=v;v=Q+68|0;f[Q+64>>2]=v;f[v>>2]=0;f[Q+72>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=sa;f[ta>>2]=Q;sa=f[f[a+28>>2]>>2]|0;if(!sa)ua=Q;else{f[S>>2]=sa;ua=f[ta>>2]|0}UQ(f[a+32>>2]|0,ua);ua=a+36|0;f[ua>>2]=(f[ua>>2]|0)+1;va=Q;wa=f[k>>2]|0}else{va=R;wa=oa}_$(l,p,na,P,(f[va+36>>2]|0)+(Y(Y((P>>>3&511)+1|0,x)|0,675553809>>>(P<<2&28)&15)|0)|0,wa);f[m>>2]=1124007936;wa=m+4|0;P=m+8|0;x=m+40|0;z=wa;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[x>>2]=P;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;va=g+8|0;f[va>>2]=0;f[va+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=m;dY(l,g,5,1.0,0.0);f[n>>2]=c;c=n+4|0;f[c>>2]=f[m>>2];va=n+8|0;na=f[wa>>2]|0;f[va>>2]=na;p=n+12|0;f[p>>2]=f[P>>2];f[n+16>>2]=f[m+12>>2];P=n+20|0;oa=m+16|0;f[P>>2]=f[oa>>2];f[n+24>>2]=f[m+20>>2];f[n+28>>2]=f[m+24>>2];f[n+32>>2]=f[m+28>>2];f[n+36>>2]=f[m+32>>2];R=n+40|0;Q=m+36|0;ua=f[Q>>2]|0;f[R>>2]=ua;ta=n+44|0;f[ta>>2]=p;p=n+52|0;sa=n+48|0;f[sa>>2]=p;f[p>>2]=0;f[n+56>>2]=0;if(!ua)xa=na;else{na=ua+12|0;f[na>>2]=(f[na>>2]|0)+1;xa=f[wa>>2]|0}if((xa|0)<3){xa=f[B>>2]|0;na=f[sa>>2]|0;f[na>>2]=f[xa>>2];f[na+4>>2]=f[xa+4>>2]}else{f[va>>2]=0;U$(c,m)}dMa(g,a+40|0,n,n);n=f[R>>2]|0;if(n|0?(a=n+12|0,n=f[a>>2]|0,f[a>>2]=n+-1,(n|0)==1):0)V$(c);f[R>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[va>>2]|0)>0){P=f[ta>>2]|0;ta=0;do{f[P+(ta<<2)>>2]=0;ta=ta+1|0}while((ta|0)<(f[va>>2]|0))}va=f[sa>>2]|0;if((va|0)!=(p|0))wL(va);va=f[Q>>2]|0;do if(va|0){p=va+12|0;sa=f[p>>2]|0;f[p>>2]=sa+-1;if((sa|0)!=1)break;V$(m)}while(0);f[Q>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[wa>>2]|0)>0){oa=f[x>>2]|0;x=0;do{f[oa+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[wa>>2]|0))}wa=f[B>>2]|0;if((wa|0)!=(z|0))wL(wa);wa=l+36|0;z=f[wa>>2]|0;do if(z|0){B=z+12|0;x=f[B>>2]|0;f[B>>2]=x+-1;if((x|0)!=1)break;V$(l)}while(0);f[wa>>2]=0;wa=l+16|0;z=l+4|0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[z>>2]|0)>0){wa=f[l+40>>2]|0;x=0;do{f[wa+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[z>>2]|0))}z=f[l+44>>2]|0;if((z|0)!=(l+48|0))wL(z);z=f[k>>2]|0;if((z|0)!=(ea|0)){if(z|0)dYc(z);f[k>>2]=ea;f[ha>>2]=4}ha=f[j>>2]|0;if((ha|0)!=(ma|0)){if(ha|0)dYc(ha);f[j>>2]=ma;f[A>>2]=4}}A=f[i>>2]|0;if((A|0)!=(t|0)){if(A|0)dYc(A);f[i>>2]=t;f[w>>2]=4}w=f[h>>2]|0;if((w|0)==(q|0)){u=e;return}if(w|0)dYc(w);f[h>>2]=q;f[r>>2]=4;u=e;return}function OLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+144|0;e=d+120|0;g=d+64|0;h=d;i=a+8|0;j=VMa(f[i>>2]|0)|0;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;n=g+48|0;o=g+44|0;f[o>>2]=n;f[n>>2]=0;f[g+52>>2]=0;switch(c|0){case 5:{f[e>>2]=1;f[e+4>>2]=j;S$(g,2,e,5);c=g+16|0;MMa(f[i>>2]|0,f[c>>2]|0,j)|0;q=c;break}case 6:{f[e>>2]=1;f[e+4>>2]=j;S$(g,2,e,6);c=g+16|0;NMa(f[i>>2]|0,f[c>>2]|0,j)|0;q=c;break}case 1:{f[e>>2]=1;f[e+4>>2]=j;S$(g,2,e,1);c=g+16|0;HMa(f[i>>2]|0,f[c>>2]|0,j)|0;q=c;break}case 0:{f[e>>2]=1;f[e+4>>2]=j;S$(g,2,e,0);c=g+16|0;HMa(f[i>>2]|0,f[c>>2]|0,j)|0;q=c;break}case 3:{f[e>>2]=1;f[e+4>>2]=j;S$(g,2,e,3);c=g+16|0;JMa(f[i>>2]|0,f[c>>2]|0,j)|0;q=c;break}case 4:{f[e>>2]=1;f[e+4>>2]=j;S$(g,2,e,4);c=g+16|0;KMa(f[i>>2]|0,f[c>>2]|0,j)|0;q=c;break}case 12:{f[e>>2]=1;f[e+4>>2]=j;S$(g,2,e,6);c=g+16|0;r=f[c>>2]|0;LMa(f[i>>2]|0,r,j)|0;if(!j)q=c;else{i=j;do{i=i+-1|0;j=r+(i<<3)|0;s=j;p[j>>3]=+((f[s>>2]|0)>>>0)+4294967296.0*+(f[s+4>>2]|0)}while((i|0)!=0);q=c}break}default:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;vM(-3,e,388001,385609,290)}}f[h>>2]=b;b=h+4|0;f[b>>2]=f[g>>2];c=h+8|0;i=f[k>>2]|0;f[c>>2]=i;r=h+12|0;f[r>>2]=f[l>>2];f[h+16>>2]=f[g+12>>2];l=h+20|0;f[l>>2]=f[q>>2];f[h+24>>2]=f[g+20>>2];f[h+28>>2]=f[g+24>>2];f[h+32>>2]=f[g+28>>2];f[h+36>>2]=f[g+32>>2];s=h+40|0;j=g+36|0;t=f[j>>2]|0;f[s>>2]=t;v=h+44|0;f[v>>2]=r;r=h+52|0;w=h+48|0;f[w>>2]=r;f[r>>2]=0;f[h+56>>2]=0;if(!t)x=i;else{i=t+12|0;f[i>>2]=(f[i>>2]|0)+1;x=f[k>>2]|0}if((x|0)<3){x=f[o>>2]|0;i=f[w>>2]|0;f[i>>2]=f[x>>2];f[i+4>>2]=f[x+4>>2]}else{f[c>>2]=0;U$(b,g)}dMa(e,a+28|0,h,h);h=f[s>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)V$(b);f[s>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[c>>2]|0)>0){l=f[v>>2]|0;v=0;do{f[l+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[c>>2]|0))}c=f[w>>2]|0;if((c|0)!=(r|0))wL(c);c=f[j>>2]|0;if(c|0?(r=c+12|0,c=f[r>>2]|0,f[r>>2]=c+-1,(c|0)==1):0)V$(g);f[j>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[k>>2]|0)>0){q=f[m>>2]|0;m=0;do{f[q+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[o>>2]|0;if((k|0)==(n|0)){u=d;return}wL(k);u=d;return}function PLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=b[a+11>>0]|0;h=g<<24>>24<0;i=h?f[a>>2]|0:a;j=h?f[a+4>>2]|0:g&255;g=i+j|0;h=g;if((j|0)<3){k=0;u=d;return k|0}else{l=i;m=j}while(1){n=m+-2|0;if(!n){o=12;break}p=AJc(l,110,n)|0;if(!p){o=12;break}if(!(WKc(p,387976,3)|0)){o=6;break}l=p+1|0;m=h-l|0;if((m|0)<3){o=12;break}}if((o|0)==6)if((p|0)==(i|0)&(p|0)!=(g|0))q=81900;else o=12;do if((o|0)==12){if((j|0)<5){k=0;u=d;return k|0}else{r=i;s=j}do{p=s+-4|0;if(!p)break;t=AJc(r,99,p)|0;if(!t)break;if(!(WKc(t,387980,5)|0)){o=17;break}r=t+1|0;s=h-r|0}while((s|0)>=5);if((o|0)==17?(t|0)==(i|0)&(t|0)!=(g|0):0){q=81904;break}if((j|0)<6){k=0;u=d;return k|0}else{v=i;w=j}do{p=w+-5|0;if(!p)break;x=AJc(v,99,p)|0;if(!x)break;if(!(WKc(x,387986,6)|0)){o=23;break}v=x+1|0;w=h-v|0}while((w|0)>=6);if((o|0)==23?(x|0)==(i|0)&(x|0)!=(g|0):0){q=81908;break}if((j|0)<7){k=0;u=d;return k|0}else{y=i;z=j}while(1){p=z+-6|0;if(!p){k=0;o=11;break}A=AJc(y,102,p)|0;if(!A){k=0;o=11;break}if(!(WKc(A,387993,7)|0)){o=29;break}y=A+1|0;z=h-y|0;if((z|0)<7){k=0;o=11;break}}if((o|0)==11){u=d;return k|0}else if((o|0)==29){if((A|0)==(i|0)&(A|0)!=(g|0)){q=81912;break}else k=0;u=d;return k|0}}while(0);mYc(e,a,dJc(f[q>>2]|0)|0,-1,a);a=c+11|0;if((b[a>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[a>>0]=0}sYc(c,0);f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];k=1;u=d;return k|0}function QLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+72|0;d=f[c>>2]|0;if(d|0){e=a+76|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;while(1){g=i+-8|0;f[e>>2]=g;j=f[i+-4>>2]|0;if(!j)k=g;else{UXc(j);k=f[e>>2]|0}if((k|0)==(d|0))break;else i=k}h=f[c>>2]|0}cYc(h)}h=a+60|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);h=a+48|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);hx(a+36|0);QGa(a+24|0,f[a+28>>2]|0);h=a+12|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[a+11>>0]|0)>=0)return;cYc(f[a>>2]|0);return}function RLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;f[e>>2]=f[b>>2];l=f[b+4>>2]|0;f[m+(g<<3)+4>>2]=l;if(!l){n=j;o=i}else{TXc(l);n=f[c>>2]|0;o=f[a>>2]|0}l=e+8|0;if((n|0)==(o|0)){p=h;q=o;r=n}else{i=n;n=h;h=e;do{e=i;i=i+-8|0;f[h+-8>>2]=f[i>>2];j=e+-4|0;f[h+-4>>2]=f[j>>2];f[i>>2]=0;f[j>>2]=0;h=n+-8|0;n=h}while((i|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=l;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=f[d+-4>>2]|0;d=d+-8|0;if(r|0)UXc(r)}while((d|0)!=(k|0))}if(!q)return;cYc(q);return}function SLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0,lb=0;e=u;u=u+208|0;g=e;h=e+192|0;i=e+120|0;j=e+56|0;k=a+8|0;l=UMa(f[k>>2]|0)|0;m=UMa(f[k>>2]|0)|0;if((l|0)!=3){n=$Xc(64)|0;f[g>>2]=n;o=g+8|0;f[o>>2]=-2147483584;q=g+4|0;f[q>>2]=56;r=n;s=387705;t=r+56|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));v=n+56|0;b[v>>0]=0;vM(-215,g,387762,385609,302)}l=a+16|0;w=a+20|0;x=f[w>>2]|0;do if(x){y=x;do{z=f[y+16>>2]|0;if((m|0)<(z|0))A=y;else{if((z|0)>=(m|0)){B=8;break}A=y+4|0}y=f[A>>2]|0}while((y|0)!=0);if((B|0)==8){n=$Xc(64)|0;f[g>>2]=n;o=g+8|0;f[o>>2]=-2147483584;q=g+4|0;f[q>>2]=56;r=n;s=387705;t=r+56|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));v=n+56|0;b[v>>0]=0;vM(-215,g,387762,385609,302)}y=a+20|0;z=x;while(1){C=f[z+16>>2]|0;if((m|0)<(C|0)){D=f[z>>2]|0;if(!D){B=13;break}else{E=z;F=D}}else{if((C|0)>=(m|0)){B=17;break}G=z+4|0;C=f[G>>2]|0;if(!C){B=16;break}else{E=G;F=C}}y=E;z=F}if((B|0)==13){H=z;I=z;break}else if((B|0)==16){H=z;I=G;break}else if((B|0)==17){H=z;I=y;break}}else{H=w;I=w}while(0);if(!(f[I>>2]|0)){w=$Xc(20)|0;f[w+16>>2]=m;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=H;f[I>>2]=w;H=f[f[l>>2]>>2]|0;if(!H)J=w;else{f[l>>2]=H;J=f[I>>2]|0}UQ(f[a+20>>2]|0,J);J=a+24|0;f[J>>2]=(f[J>>2]|0)+1}J=UMa(f[k>>2]|0)|0;if((J|0)<=0){u=e;return}I=h+11|0;H=a+68|0;l=a+40|0;w=a+44|0;m=a+28|0;G=a+32|0;F=a+32|0;E=a+36|0;x=g+4|0;v=g+8|0;n=g+40|0;s=g+48|0;q=g+44|0;o=g+52|0;A=i+8|0;C=i+4|0;D=g+16|0;K=g+12|0;L=i+4|0;M=g+36|0;N=a+44|0;O=a+48|0;P=j+4|0;Q=j+8|0;R=j+12|0;S=j+16|0;T=j+20|0;U=j+24|0;V=j+28|0;W=j+32|0;X=j+36|0;Z=j+40|0;_=j+44|0;$=j+52|0;aa=j+48|0;ba=j+56|0;ca=i+12|0;da=i+16|0;ea=j+4|0;fa=i+20|0;ga=i+24|0;ha=i+28|0;ia=i+32|0;ja=i+36|0;ka=i+40|0;la=i+44|0;ma=i+48|0;na=i+52|0;oa=i+56|0;pa=i+60|0;qa=i+64|0;ra=i+68|0;sa=j+48|0;ta=i+16|0;ua=i+56|0;va=i+60|0;wa=i+11|0;xa=g+11|0;ya=g+8|0;za=g+4|0;Aa=h+8|0;Ba=h+4|0;Ca=0;a:while(1){Da=PMa(f[k>>2]|0)|0;if((UMa(f[k>>2]|0)|0)==2){Ea=UMa(f[k>>2]|0)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(Ea>>>0>4294967279){B=28;break}if(Ea>>>0<11){b[I>>0]=Ea;if(!Ea)Fa=h;else{Ga=h;B=32}}else{Ha=Ea+16&-16;Ia=$Xc(Ha)|0;f[h>>2]=Ia;f[Aa>>2]=Ha|-2147483648;f[Ba>>2]=Ea;Ga=Ia;B=32}if((B|0)==32){B=0;g1c(Ga|0,0,Ea|0)|0;Fa=Ga}b[Fa+Ea>>0]=0;IMa(f[k>>2]|0,(b[I>>0]|0)<0?f[h>>2]|0:h,Ea)|0;Ea=PMa(f[k>>2]|0)|0;b:do switch(UMa(f[k>>2]|0)|0){case 4:{Ia=UMa(f[k>>2]|0)|0;Ha=f[H>>2]|0;Ja=(f[Ha+76>>2]|0)-(f[Ha+72>>2]|0)|0;JLa(a,Ia);Ha=f[w>>2]|0;c:do if(Ha|0){Ka=Ha;while(1){La=f[Ka+16>>2]|0;if((Ia|0)<(La|0))Ma=Ka;else{if((La|0)>=(Ia|0))break;Ma=Ka+4|0}Ka=f[Ma>>2]|0;if(!Ka)break c}Ka=N;La=Ha;while(1){Na=f[La+16>>2]|0;if((Ia|0)<(Na|0)){Oa=f[La>>2]|0;if(!Oa){Pa=La;break}else{Qa=La;Ra=Oa}}else{if((Na|0)>=(Ia|0)){Pa=Ka;break}Na=La+4|0;Oa=f[Na>>2]|0;if(!Oa){Pa=Na;break}else{Qa=Na;Ra=Oa}}Ka=Qa;La=Ra}Ka=f[Pa>>2]|0;if(!Ka){Oa=$Xc(76)|0;f[Oa+16>>2]=Ia;f[Oa+20>>2]=1124007936;Na=Oa+28|0;Sa=Oa+60|0;r=Oa+24|0;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));f[Sa>>2]=Na;Ta=Oa+68|0;f[Oa+64>>2]=Ta;f[Ta>>2]=0;f[Oa+72>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=La;f[Pa>>2]=Oa;Ta=f[f[l>>2]>>2]|0;if(!Ta)Ua=Oa;else{f[l>>2]=Ta;Ua=f[Pa>>2]|0}UQ(f[N>>2]|0,Ua);f[O>>2]=(f[O>>2]|0)+1;Va=Oa}else Va=Ka;Ta=Va+20|0;f[j>>2]=Ia;f[P>>2]=f[Ta>>2];Wa=Va+24|0;Xa=f[Wa>>2]|0;f[Q>>2]=Xa;f[R>>2]=f[Va+28>>2];f[S>>2]=f[Va+32>>2];f[T>>2]=f[Va+36>>2];f[U>>2]=f[Va+40>>2];f[V>>2]=f[Va+44>>2];f[W>>2]=f[Va+48>>2];f[X>>2]=f[Va+52>>2];Ya=f[Va+56>>2]|0;f[Z>>2]=Ya;f[_>>2]=R;f[aa>>2]=$;f[$>>2]=0;f[ba>>2]=0;if(!Ya)Za=Xa;else{Xa=Ya+12|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Za=f[Wa>>2]|0}if((Za|0)<3){Wa=f[Va+64>>2]|0;Xa=f[aa>>2]|0;f[Xa>>2]=f[Wa>>2];f[Xa+4>>2]=f[Wa+4>>2]}else{f[Q>>2]=0;U$(P,Ta)}lYc(i,h);f[ca>>2]=f[j>>2];f[da>>2]=f[ea>>2];Ta=f[Q>>2]|0;f[fa>>2]=Ta;f[ga>>2]=f[R>>2];f[ha>>2]=f[S>>2];f[ia>>2]=f[T>>2];f[ja>>2]=f[U>>2];f[ka>>2]=f[V>>2];f[la>>2]=f[W>>2];f[ma>>2]=f[X>>2];f[na>>2]=f[Z>>2];f[oa>>2]=ga;f[pa>>2]=qa;f[ra>>2]=0;f[qa>>2]=0;if((Ta|0)<3){Ta=f[sa>>2]|0;f[qa>>2]=f[Ta>>2];f[ra>>2]=f[Ta+4>>2]}else{f[pa>>2]=f[sa>>2];f[oa>>2]=f[_>>2];f[sa>>2]=$;f[_>>2]=R}f[ea>>2]=1124007936;r=Q;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));_La(g,d,i,i);Ka=f[na>>2]|0;if(Ka|0?(Oa=Ka+12|0,Ka=f[Oa>>2]|0,f[Oa>>2]=Ka+-1,(Ka|0)==1):0)V$(ta);f[na>>2]=0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[fa>>2]|0)>0){Ka=f[ua>>2]|0;Oa=0;do{f[Ka+(Oa<<2)>>2]=0;Oa=Oa+1|0}while((Oa|0)<(f[fa>>2]|0))}Oa=f[va>>2]|0;if((Oa|0)!=(qa|0))wL(Oa);if((b[wa>>0]|0)<0)cYc(f[i>>2]|0);Oa=f[Z>>2]|0;do if(Oa|0){Ka=Oa+12|0;La=f[Ka>>2]|0;f[Ka>>2]=La+-1;if((La|0)!=1)break;V$(P)}while(0);f[Z>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[Q>>2]|0)>0){Oa=f[_>>2]|0;La=0;do{f[Oa+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[Q>>2]|0))}La=f[aa>>2]|0;if((La|0)!=($|0))wL(La);break b}while(0);Ha=f[G>>2]|0;d:do if(Ha|0){La=Ha;while(1){Oa=f[La+16>>2]|0;if((Ia|0)<(Oa|0))_a=La;else{if((Oa|0)>=(Ia|0)){$a=F;ab=Ha;break}_a=La+4|0}La=f[_a>>2]|0;if(!La)break d}while(1){La=f[ab+16>>2]|0;if((Ia|0)<(La|0)){Oa=f[ab>>2]|0;if(!Oa){bb=ab;break}else{cb=ab;db=Oa}}else{if((La|0)>=(Ia|0)){bb=$a;break}La=ab+4|0;Oa=f[La>>2]|0;if(!Oa){bb=La;break}else{cb=La;db=Oa}}$a=cb;ab=db}Oa=f[bb>>2]|0;if(!Oa){La=$Xc(76)|0;f[La+16>>2]=Ia;f[La+20>>2]=1124007936;Ka=La+28|0;Na=La+60|0;r=La+24|0;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));f[Na>>2]=Ka;Sa=La+68|0;f[La+64>>2]=Sa;f[Sa>>2]=0;f[La+72>>2]=0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=ab;f[bb>>2]=La;Sa=f[f[m>>2]>>2]|0;if(!Sa)eb=La;else{f[m>>2]=Sa;eb=f[bb>>2]|0}UQ(f[F>>2]|0,eb);f[E>>2]=(f[E>>2]|0)+1;fb=La}else fb=Oa;Sa=fb+20|0;f[g>>2]=1124007936;r=x;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));f[n>>2]=v;f[q>>2]=s;f[s>>2]=0;f[o>>2]=0;Oa=A;f[Oa>>2]=0;f[Oa+4>>2]=0;f[i>>2]=33619968;f[C>>2]=g;dY(Sa,i,6,1.0,0.0);Oa=f[D>>2]|0;La=f[x>>2]|0;if((La|0)<3)gb=Y(f[K>>2]|0,f[v>>2]|0)|0;else{Ka=f[n>>2]|0;Na=0;Ta=1;while(1){Wa=Y(f[Ka+(Na<<2)>>2]|0,Ta)|0;Na=Na+1|0;if((Na|0)==(La|0)){gb=Wa;break}else Ta=Wa}}Ta=$Xc(16)|0;La=Ta+8|0;f[Ta>>2]=La;f[Ta+4>>2]=gb;if(gb>>>0>1){Na=bYc(gb>>>0>536870911?-1:gb<<3)|0;f[Ta>>2]=Na;hb=Na}else hb=La;f[i>>2]=2;f[L>>2]=Ta;if((gb|0)>0){Ta=Oa;La=0;while(1){p[hb+(La<<3)>>3]=+p[Ta>>3];La=La+1|0;if((La|0)==(gb|0))break;else Ta=Ta+8|0}}$Ga(c,h,i)|0;RGa(i);Ta=f[M>>2]|0;if(Ta|0?(La=Ta+12|0,Ta=f[La>>2]|0,f[La>>2]=Ta+-1,(Ta|0)==1):0)V$(g);f[M>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[x>>2]|0)>0){Ta=f[n>>2]|0;La=0;do{f[Ta+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[x>>2]|0))}La=f[q>>2]|0;if((La|0)!=(s|0))wL(La);break b}while(0);Ia=f[H>>2]|0;Ha=Ia+76|0;La=f[Ha>>2]|0;if((La-(f[Ia+72>>2]|0)|0)>>>0>Ja>>>0){Ia=La;La=Ha;do{Ha=Ia;Ta=Ha+-8|0;Oa=Ha;while(1){Ha=Oa+-8|0;f[La>>2]=Ha;Na=f[Oa+-4>>2]|0;if(!Na)ib=Ha;else{UXc(Na);ib=f[La>>2]|0}if((ib|0)==(Ta|0))break;else Oa=ib}Oa=f[H>>2]|0;La=Oa+76|0;Ia=f[La>>2]|0}while((Ia-(f[Oa+72>>2]|0)|0)>>>0>Ja>>>0)}break}case 1:{jb=+WMa(f[k>>2]|0);p[g>>3]=jb;dHa(c,h,g)|0;break}case 2:{Ja=UMa(f[k>>2]|0)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(Ja>>>0>4294967279){B=117;break a}if(Ja>>>0<11){b[xa>>0]=Ja;if(!Ja)kb=g;else{lb=g;B=121}}else{Ia=Ja+16&-16;La=$Xc(Ia)|0;f[g>>2]=La;f[ya>>2]=Ia|-2147483648;f[za>>2]=Ja;lb=La;B=121}if((B|0)==121){B=0;g1c(lb|0,0,Ja|0)|0;kb=lb}b[kb+Ja>>0]=0;IMa(f[k>>2]|0,(b[xa>>0]|0)<0?f[g>>2]|0:g,Ja)|0;_Ga(c,h,g)|0;if((b[xa>>0]|0)<0)cYc(f[g>>2]|0);break}case 5:{Ja=(UMa(f[k>>2]|0)|0)!=0&1;b[g>>0]=Ja;cHa(c,h,g)|0;break}default:{OMa(f[k>>2]|0,Ea);GLa(a)}}while(0);if((b[I>>0]|0)<0)cYc(f[h>>2]|0)}else{OMa(f[k>>2]|0,Da);GLa(a);GLa(a)}Ca=Ca+1|0;if((Ca|0)>=(J|0)){B=131;break}}if((B|0)==28)jYc(h);else if((B|0)==117)jYc(g);else if((B|0)==131){u=e;return}}function TLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=f[a+4>>2]|0;if(!d){e=0;return e|0}a=b[c+11>>0]|0;g=a<<24>>24<0;h=g?f[c+4>>2]|0:a&255;a=g?f[c>>2]|0:c;c=d;while(1){d=c+16|0;g=b[d+11>>0]|0;i=g<<24>>24<0;j=i?f[c+20>>2]|0:g&255;g=j>>>0<h>>>0;k=g?j:h;if((k|0)!=0?(l=WKc(a,i?f[d>>2]|0:d,k)|0,(l|0)!=0):0)if((l|0)<0)m=7;else m=8;else if(h>>>0<j>>>0)m=7;else m=8;if((m|0)==7){m=0;n=c}else if((m|0)==8){m=0;l=h>>>0<j>>>0?h:j;if((l|0)!=0?(j=WKc(i?f[d>>2]|0:d,a,l)|0,(j|0)!=0):0){if((j|0)>=0){e=1;m=14;break}}else m=10;if((m|0)==10?(m=0,!g):0){e=1;m=14;break}n=c+4|0}c=f[n>>2]|0;if(!c){e=0;m=14;break}}if((m|0)==14)return e|0;return 0}function ULa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function VLa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+32|0;g=e;h=e+24|0;i=e+12|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=8;k=g;f[k>>2]=1852990827;f[k+4>>2]=1751084133;b[g+8>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=2;d[i>>1]=18539;b[i+2>>0]=0;l=MGa(NIa(a,i)|0,-1)|0;f[h>>2]=l;aHa(c,g,h)|0;if((b[k>>0]|0)<0)cYc(f[i>>2]|0);if((b[j>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=8;k=g;f[k>>2]=1852990827;f[k+4>>2]=2002742373;b[g+8>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=2;d[i>>1]=22379;b[i+2>>0]=0;l=MGa(NIa(a,i)|0,-1)|0;f[h>>2]=l;aHa(c,g,h)|0;if((b[k>>0]|0)<0)cYc(f[i>>2]|0);if((b[j>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=8;k=g;f[k>>2]=1769108595;f[k+4>>2]=1751082340;b[g+8>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=2;d[i>>1]=18532;b[i+2>>0]=0;l=MGa(NIa(a,i)|0,-1)|0;f[h>>2]=l;aHa(c,g,h)|0;if((b[k>>0]|0)<0)cYc(f[i>>2]|0);if((b[j>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=8;k=g;f[k>>2]=1769108595;f[k+4>>2]=2002740580;b[g+8>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=2;d[i>>1]=22372;b[i+2>>0]=0;l=MGa(NIa(a,i)|0,-1)|0;f[h>>2]=l;aHa(c,g,h)|0;if((b[k>>0]|0)<0)cYc(f[i>>2]|0);if((b[j>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=5;b[g>>0]=b[390333]|0;b[g+1>>0]=b[390334]|0;b[g+2>>0]=b[390335]|0;b[g+3>>0]=b[390336]|0;b[g+4>>0]=b[390337]|0;b[g+5>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=4;f[i>>2]=1214538096;b[i+4>>0]=0;l=LGa(a,i)|0;m=a+4|0;if((l|0)==(m|0))n=0;else{o=MGa(l+28|0,-1)|0;n=o}f[h>>2]=n;aHa(c,g,h)|0;if((b[k>>0]|0)<0)cYc(f[i>>2]|0);if((b[j>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=5;b[g>>0]=b[390339]|0;b[g+1>>0]=b[390340]|0;b[g+2>>0]=b[390341]|0;b[g+3>>0]=b[390342]|0;b[g+4>>0]=b[390343]|0;b[g+5>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=4;f[i>>2]=1466196336;b[i+4>>0]=0;n=LGa(a,i)|0;if((n|0)==(m|0))p=0;else{m=MGa(n+28|0,-1)|0;p=m}f[h>>2]=p;aHa(c,g,h)|0;if((b[k>>0]|0)<0)cYc(f[i>>2]|0);if((b[j>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function WLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=l;k=n+(m<<3)|0;f[l>>2]=f[b>>2];m=b+4|0;f[n+(g<<3)+4>>2]=f[m>>2];f[b>>2]=0;f[m>>2]=0;m=l+8|0;if((j|0)==(i|0)){o=h;p=e}else{e=j;j=h;h=l;do{l=e;e=e+-8|0;f[h+-8>>2]=f[e>>2];b=l+-4|0;f[h+-4>>2]=f[b>>2];f[e>>2]=0;f[b>>2]=0;h=j+-8|0;j=h}while((e|0)!=(i|0));o=j;p=f[a>>2]|0}f[a>>2]=o;o=f[c>>2]|0;f[c>>2]=m;f[d>>2]=k;k=p;if((o|0)!=(k|0)){d=o;do{o=f[d+-4>>2]|0;d=d+-8|0;if(o|0)UXc(o)}while((d|0)!=(k|0))}if(!p)return;cYc(p);return}function XLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)kWc(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{k=$Xc(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=b+4|0;i=f[j>>2]|0;f[k+(g*56|0)+4>>2]=i;l=k+(g*56|0)+8|0;m=b+8|0;f[l>>2]=f[m>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];f[k+(g*56|0)+36>>2]=f[b+36>>2];n=k+(g*56|0)+40|0;f[n>>2]=l;l=k+(g*56|0)+44|0;o=k+(g*56|0)+48|0;f[l>>2]=o;p=k+(g*56|0)+52|0;f[p>>2]=0;f[o>>2]=0;g=b+44|0;if((i|0)<3){i=f[g>>2]|0;f[o>>2]=f[i>>2];f[p>>2]=f[i+4>>2];f[b>>2]=1124007936;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));s=e+56|0;f[h>>2]=s;cx(a,d);dx(d);u=c;return}else{f[l>>2]=f[g>>2];l=b+40|0;f[n>>2]=f[l>>2];f[g>>2]=b+48;f[l>>2]=m;f[b>>2]=1124007936;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));s=e+56|0;f[h>>2]=s;cx(a,d);dx(d);u=c;return}}function YLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;tYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;tYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function ZLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if(!c)return;ZLa(a,f[c>>2]|0);ZLa(a,f[c+4>>2]|0);a=c+16|0;d=c+32|0;e=c+68|0;g=f[e>>2]|0;if(g|0?(h=g+12|0,g=f[h>>2]|0,f[h>>2]=g+-1,(g|0)==1):0)V$(d);f[e>>2]=0;e=c+48|0;d=c+36|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[c+72>>2]|0;g=0;do{f[e+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[d>>2]|0))}d=f[c+76>>2]|0;if((d|0)!=(c+80|0))wL(d);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function _La(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+16|0;h=g;i=ULa(c,h,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}d=$Xc(88)|0;n=d+16|0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];f[n+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[d+28>>2]=f[e+12>>2];n=e+16|0;f[d+32>>2]=f[n>>2];o=e+20|0;p=f[o>>2]|0;f[d+36>>2]=p;q=d+40|0;r=e+24|0;f[q>>2]=f[r>>2];f[d+44>>2]=f[e+28>>2];f[d+48>>2]=f[e+32>>2];f[d+52>>2]=f[e+36>>2];f[d+56>>2]=f[e+40>>2];f[d+60>>2]=f[e+44>>2];f[d+64>>2]=f[e+48>>2];f[d+68>>2]=f[e+52>>2];s=d+72|0;f[s>>2]=q;q=d+76|0;t=d+80|0;f[q>>2]=t;v=d+84|0;f[v>>2]=0;f[t>>2]=0;w=e+60|0;if((p|0)<3){p=f[w>>2]|0;f[t>>2]=f[p>>2];f[v>>2]=f[p+4>>2]}else{f[q>>2]=f[w>>2];q=e+56|0;f[s>>2]=f[q>>2];f[w>>2]=e+64;f[q>>2]=r}f[n>>2]=1124007936;n=o;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));n=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=n;f[i>>2]=d;n=f[f[c>>2]>>2]|0;if(!n)x=d;else{f[c>>2]=n;x=f[i>>2]|0}UQ(f[c+4>>2]|0,x);x=c+8|0;f[x>>2]=(f[x>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}function $La(a){a=a|0;NXc(a);cYc(a);return}function aMa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;QLa(b);cYc(b);return}function bMa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==387777?a+12|0:0)|0}function cMa(a){a=a|0;cYc(a);return}function dMa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[d>>2]|0;j=c+4|0;k=h;while(1){l=f[k+16>>2]|0;if((i|0)<(l|0)){m=f[k>>2]|0;if(!m){n=6;break}else{o=k;p=m}}else{if((l|0)>=(i|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==6){r=k;s=k;break}else if((n|0)==9){r=k;s=q;break}else if((n|0)==10){r=k;s=j;break}}else{r=g;s=g}while(0);g=f[s>>2]|0;if(g|0){t=g;u=0;v=t;f[a>>2]=v;w=a+4|0;b[w>>0]=u;return}g=$Xc(76)|0;f[g+16>>2]=f[e>>2];n=e+4|0;f[g+20>>2]=f[n>>2];q=e+8|0;p=f[q>>2]|0;f[g+24>>2]=p;o=g+28|0;h=e+12|0;f[o>>2]=f[h>>2];f[g+32>>2]=f[e+16>>2];f[g+36>>2]=f[e+20>>2];f[g+40>>2]=f[e+24>>2];f[g+44>>2]=f[e+28>>2];f[g+48>>2]=f[e+32>>2];f[g+52>>2]=f[e+36>>2];f[g+56>>2]=f[e+40>>2];d=g+60|0;f[d>>2]=o;o=g+64|0;i=g+68|0;f[o>>2]=i;l=g+72|0;f[l>>2]=0;f[i>>2]=0;m=e+48|0;if((p|0)<3){p=f[m>>2]|0;f[i>>2]=f[p>>2];f[l>>2]=f[p+4>>2]}else{f[o>>2]=f[m>>2];o=e+44|0;f[d>>2]=f[o>>2];f[m>>2]=e+52;f[o>>2]=h}f[n>>2]=1124007936;n=q;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=r;f[s>>2]=g;r=f[f[c>>2]>>2]|0;if(!r)x=g;else{f[c>>2]=r;x=f[s>>2]|0}UQ(f[c+4>>2]|0,x);x=c+8|0;f[x>>2]=(f[x>>2]|0)+1;t=g;u=1;v=t;f[a>>2]=v;w=a+4|0;b[w>>0]=u;return}function eMa(a){a=a|0;NXc(a);cYc(a);return}function fMa(a){a=a|0;Yi[f[a+16>>2]&4095](f[a+12>>2]|0);return}function gMa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==388345?a+16|0:0)|0}function hMa(a){a=a|0;cYc(a);return}function iMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+96|0;g=e+20|0;h=e+8|0;i=e;lYc(h,c);FLa(g,h,d);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);oOa(a);f[i>>2]=f[a>>2];h=f[a+4>>2]|0;f[i+4>>2]=h;if(h|0)TXc(h);jMa(g,i);ROa(i);i=f[g+52>>2]|0;if(i|0){h=g+56|0;a=f[h>>2]|0;if((a|0)!=(i|0))f[h>>2]=a+(~((a+-4-i|0)>>>2)<<2);cYc(i)}HLa(g+40|0,f[g+44>>2]|0);HLa(g+28|0,f[g+32>>2]|0);ILa(g+16|0,f[g+20>>2]|0);i=f[g+12>>2]|0;if(!i){ROa(g);u=e;return}UXc(i);ROa(g);u=e;return}function jMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=a+64|0;if(f[g>>2]|0){h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=18;i=h;j=388439;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+18>>0]=0;vM(-215,e,390369,385609,1227)}kMa(e,385756);h=f[e>>2]|0;j=f[e+4>>2]|0;f[g>>2]=h;i=a+68|0;f[i>>2]=h;OMa(f[a+8>>2]|0,0);GLa(a);h=f[c>>2]|0;k=f[c+4>>2]|0;if(k|0)TXc(k);f[a>>2]=h;h=a+4|0;c=f[h>>2]|0;f[h>>2]=k;if(c|0)UXc(c);f[e>>2]=0;c=e+4|0;f[c>>2]=0;f[e+8>>2]=0;lMa(a,f[g>>2]|0,e,0,0)|0;f[g>>2]=0;f[i>>2]=0;i=f[e>>2]|0;if(i|0){e=f[c>>2]|0;if((e|0)!=(i|0))f[c>>2]=e+(~((e+-8-i|0)>>>3)<<3);cYc(i)}if(!j){u=d;return}UXc(j);u=d;return}function kMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+32|0;e=d+12|0;g=d;h=$Xc(96)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=81956;i=h+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=dJc(c)|0;if(j>>>0>4294967279)jYc(e);if(j>>>0<11){b[e+11>>0]=j;if(!j)k=e;else{l=e;m=6}}else{n=j+16&-16;o=$Xc(n)|0;f[e>>2]=o;f[e+8>>2]=n|-2147483648;f[e+4>>2]=j;l=o;m=6}if((m|0)==6){o1c(l|0,c|0,j|0)|0;k=l}b[k+j>>0]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;lYc(i,e);lYc(h+24|0,g);j=h+40|0;f[j>>2]=0;f[h+44>>2]=0;f[h+36>>2]=j;j=h+48|0;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[e+11>>0]|0)>=0){p=a+4|0;f[a>>2]=i;f[p>>2]=h;u=d;return}cYc(f[e>>2]|0);p=a+4|0;f[a>>2]=i;f[p>>2]=h;u=d;return}function lMa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;h=u;u=u+224|0;i=h+128|0;j=h+168|0;k=h+80|0;l=h+32|0;m=h+16|0;n=h;o=h+152|0;p=h+140|0;q=c;if(!c){r=e;u=h;return r|0}s=c+12|0;t=b[s+11>>0]|0;if(t<<24>>24<0)v=f[c+16>>2]|0;else v=t&255;if(v|0){mMa(i,a,s);v=SOa(a,i,s,c+24|0)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);YOa(a,e,g,v,0);f[i>>2]=v;f[i+4>>2]=q;s=d+4|0;t=f[s>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){w=i;x=f[w+4>>2]|0;y=t;f[y>>2]=f[w>>2];f[y+4>>2]=x;f[s>>2]=(f[s>>2]|0)+8}else nMa(d,i);r=v;u=h;return r|0}v=c+11|0;s=b[v>>0]|0;x=c+4|0;y=f[x>>2]|0;if(((s<<24>>24<0?y:s&255)|0)==10){if(LYc(c,0,-1,385756,10)|0){z=b[v>>0]|0;A=f[x>>2]|0;B=15}}else{z=s;A=y;B=15}do if((B|0)==15){if(((z<<24>>24<0?A:z&255)|0)==9){if(!(LYc(c,0,-1,385810,9)|0))break;C=b[v>>0]|0;D=f[x>>2]|0}else{C=z;D=A}do if(((C<<24>>24<0?D:C&255)|0)==6){if(LYc(c,0,-1,428960,6)|0){E=b[v>>0]|0;F=f[x>>2]|0;break}f[j+4>>2]=0;f[j+8>>2]=0;y=j+4|0;f[j>>2]=y;G=j+12|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=k+11|0;b[s>>0]=4;f[k>>2]=1936291937;b[k+4>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;w=m+11|0;b[w>>0]=9;G=m;I=385851;H=G+9|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[m+9>>0]=0;t=MGa(NIa(c+24|0,m)|0,-1)|0;f[l>>2]=t+-1;aHa(j,k,l)|0;if((b[w>>0]|0)<0)cYc(f[m>>2]|0);if((b[s>>0]|0)<0)cYc(f[k>>2]|0);f[k>>2]=0;t=k+4|0;f[t>>2]=0;f[k+8>>2]=0;J=c+72|0;K=c+76|0;L=f[J>>2]|0;if(((f[K>>2]|0)-L|0)>0){M=k+8|0;N=0;O=L;do{L=lMa(a,f[O+(N<<3)>>2]|0,d,e,g)|0;f[i>>2]=L;P=f[t>>2]|0;if((P|0)==(f[M>>2]|0))Tv(k,i);else{f[P>>2]=L;f[t>>2]=P+4}N=N+1|0;O=f[J>>2]|0}while((N|0)<((f[K>>2]|0)-O>>3|0))}O=a+72|0;f[O>>2]=(f[O>>2]|0)+1;O=m+11|0;b[O>>0]=10;G=m;I=388458;H=G+10|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[m+10>>0]=0;mMa(l,a,m);f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;K=n+11|0;b[K>>0]=6;b[n>>0]=b[428960]|0;b[n+1>>0]=b[428961]|0;b[n+2>>0]=b[428962]|0;b[n+3>>0]=b[428963]|0;b[n+4>>0]=b[428964]|0;b[n+5>>0]=b[428965]|0;b[n+6>>0]=0;N=SOa(a,l,n,j)|0;if((b[K>>0]|0)<0)cYc(f[n>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[O>>0]|0)<0)cYc(f[m>>2]|0);K=f[k>>2]|0;if((f[t>>2]|0)!=(K|0)){J=0;M=K;do{YOa(a,f[M+(J<<2)>>2]|0,0,N,J);J=J+1|0;M=f[k>>2]|0}while(J>>>0<(f[t>>2]|0)-M>>2>>>0)}f[l>>2]=N;f[l+4>>2]=q;M=d+4|0;J=f[M>>2]|0;if(J>>>0<(f[d+8>>2]|0)>>>0){O=l;K=f[O+4>>2]|0;s=J;f[s>>2]=f[O>>2];f[s+4>>2]=K;f[M>>2]=(f[M>>2]|0)+8}else nMa(d,l);M=f[k>>2]|0;if(M|0){K=f[t>>2]|0;if((K|0)!=(M|0))f[t>>2]=K+(~((K+-4-M|0)>>>2)<<2);cYc(M)}M=j+36|0;if((b[M+11>>0]|0)<0)cYc(f[M>>2]|0);M=j+24|0;if((b[M+11>>0]|0)<0)cYc(f[M>>2]|0);hx(j+12|0);QGa(j,f[y>>2]|0);r=N;u=h;return r|0}else{E=C;F=D}while(0);do if(((E<<24>>24<0?F:E&255)|0)==11){if(LYc(c,0,-1,385798,11)|0){Q=b[v>>0]|0;R=f[x>>2]|0;break}f[j+4>>2]=0;f[j+8>>2]=0;M=j+4|0;f[j>>2]=M;G=j+12|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;N=k+11|0;b[N>>0]=4;f[k>>2]=1936291937;b[k+4>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;y=m+11|0;b[y>>0]=9;G=m;I=385851;H=G+9|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[m+9>>0]=0;t=MGa(NIa(c+24|0,m)|0,-1)|0;f[l>>2]=t+-1;aHa(j,k,l)|0;if((b[y>>0]|0)<0)cYc(f[m>>2]|0);if((b[N>>0]|0)<0)cYc(f[k>>2]|0);f[k+8>>2]=0;t=k+11|0;b[t>>0]=7;b[k>>0]=b[435010]|0;b[k+1>>0]=b[435011]|0;b[k+2>>0]=b[435012]|0;b[k+3>>0]=b[435013]|0;b[k+4>>0]=b[435014]|0;b[k+5>>0]=b[435015]|0;b[k+6>>0]=b[435016]|0;b[k+7>>0]=0;b[l>>0]=1;cHa(j,k,l)|0;if((b[t>>0]|0)<0)cYc(f[k>>2]|0);f[k>>2]=0;t=k+4|0;f[t>>2]=0;f[k+8>>2]=0;K=c+72|0;s=c+76|0;O=f[K>>2]|0;if(((f[s>>2]|0)-O|0)>0){J=k+8|0;w=0;P=O;do{O=lMa(a,f[P+(w<<3)>>2]|0,d,e,g)|0;f[i>>2]=O;L=f[t>>2]|0;if((L|0)==(f[J>>2]|0))Tv(k,i);else{f[L>>2]=O;f[t>>2]=L+4}w=w+1|0;P=f[K>>2]|0}while((w|0)<((f[s>>2]|0)-P>>3|0))}P=m+11|0;b[P>>0]=10;G=m;I=388458;H=G+10|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[m+10>>0]=0;mMa(l,a,m);f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;s=n+11|0;b[s>>0]=6;b[n>>0]=b[428960]|0;b[n+1>>0]=b[428961]|0;b[n+2>>0]=b[428962]|0;b[n+3>>0]=b[428963]|0;b[n+4>>0]=b[428964]|0;b[n+5>>0]=b[428965]|0;b[n+6>>0]=0;w=SOa(a,l,n,j)|0;if((b[s>>0]|0)<0)cYc(f[n>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[P>>0]|0)<0)cYc(f[m>>2]|0);s=f[k>>2]|0;if((f[t>>2]|0)!=(s|0)){K=0;J=s;do{YOa(a,f[J+(K<<2)>>2]|0,0,w,K);K=K+1|0;J=f[k>>2]|0}while(K>>>0<(f[t>>2]|0)-J>>2>>>0)}f[l>>2]=w;f[l+4>>2]=q;J=d+4|0;K=f[J>>2]|0;if(K>>>0<(f[d+8>>2]|0)>>>0){P=l;s=f[P+4>>2]|0;N=K;f[N>>2]=f[P>>2];f[N+4>>2]=s;f[J>>2]=(f[J>>2]|0)+8}else nMa(d,l);J=f[k>>2]|0;if(J|0){s=f[t>>2]|0;if((s|0)!=(J|0))f[t>>2]=s+(~((s+-4-J|0)>>>2)<<2);cYc(J)}J=j+36|0;if((b[J+11>>0]|0)<0)cYc(f[J>>2]|0);J=j+24|0;if((b[J+11>>0]|0)<0)cYc(f[J>>2]|0);hx(j+12|0);QGa(j,f[M>>2]|0);r=w;u=h;return r|0}else{Q=E;R=F}while(0);do if(((Q<<24>>24<0?R:Q&255)|0)==8){if(LYc(c,0,-1,385767,8)|0){S=b[v>>0]|0;T=f[x>>2]|0;break}f[j+4>>2]=0;f[j+8>>2]=0;J=j+4|0;f[j>>2]=J;G=j+12|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[k+4>>2]=0;f[k+8>>2]=0;w=k+4|0;f[k>>2]=w;G=k+12|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[l+4>>2]=0;f[l+8>>2]=0;M=l+4|0;f[l>>2]=M;G=l+12|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;t=m+11|0;b[t>>0]=4;f[m>>2]=1936291937;b[m+4>>0]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;s=$Xc(16)|0;f[o>>2]=s;f[o+8>>2]=-2147483632;f[o+4>>2]=14;G=s;I=385820;H=G+14|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[s+14>>0]=0;N=c+24|0;P=MGa(NIa(N,o)|0,-1)|0;f[n>>2]=P+-1;aHa(j,m,n)|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);if((b[t>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;P=m+11|0;b[P>>0]=4;f[m>>2]=1936291937;b[m+4>>0]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;K=$Xc(16)|0;f[o>>2]=K;f[o+8>>2]=-2147483632;f[o+4>>2]=15;G=K;I=385835;H=G+15|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[K+15>>0]=0;t=MGa(NIa(N,o)|0,-1)|0;f[n>>2]=t+-1;aHa(k,m,n)|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);if((b[P>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;t=m+11|0;b[t>>0]=4;f[m>>2]=1936291937;b[m+4>>0]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;s=o+11|0;b[s>>0]=4;f[o>>2]=1936291937;b[o+4>>0]=0;y=MGa(NIa(j,o)|0,-1)|0;f[n>>2]=y;aHa(l,m,n)|0;if((b[s>>0]|0)<0)cYc(f[o>>2]|0);if((b[t>>0]|0)<0)cYc(f[m>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;t=m+11|0;b[t>>0]=8;s=m;f[s>>2]=1601009006;f[s+4>>2]=1936029793;b[m+8>>0]=0;f[n>>2]=1;aHa(l,m,n)|0;if((b[t>>0]|0)<0)cYc(f[m>>2]|0);t=n+11|0;b[t>>0]=10;G=n;I=388469;H=G+10|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[n+10>>0]=0;mMa(m,a,n);f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;P=o+11|0;b[P>>0]=5;b[o>>0]=b[396487]|0;b[o+1>>0]=b[396488]|0;b[o+2>>0]=b[396489]|0;b[o+3>>0]=b[396490]|0;b[o+4>>0]=b[396491]|0;b[o+5>>0]=0;N=SOa(a,m,o,j)|0;if((b[P>>0]|0)<0)cYc(f[o>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[t>>0]|0)<0)cYc(f[n>>2]|0);f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;P=$Xc(16)|0;f[n>>2]=P;f[n+8>>2]=-2147483632;f[n+4>>2]=12;G=P;I=388480;H=G+12|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[P+12>>0]=0;mMa(m,a,n);f[o+8>>2]=0;t=o+11|0;b[t>>0]=7;b[o>>0]=b[396499]|0;b[o+1>>0]=b[396500]|0;b[o+2>>0]=b[396501]|0;b[o+3>>0]=b[396502]|0;b[o+4>>0]=b[396503]|0;b[o+5>>0]=b[396504]|0;b[o+6>>0]=b[396505]|0;b[o+7>>0]=0;K=SOa(a,m,o,l)|0;if((b[t>>0]|0)<0)cYc(f[o>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);YOa(a,e,g,N,0);f[m>>2]=0;t=m+4|0;f[t>>2]=0;f[m+8>>2]=0;s=c+72|0;y=c+76|0;if(((f[y>>2]|0)-(f[s>>2]|0)|0)>0){L=m+8|0;O=0;do{YOa(a,N,O,K,O);U=lMa(a,f[(f[s>>2]|0)+(O<<3)>>2]|0,d,K,O)|0;f[i>>2]=U;V=f[t>>2]|0;if((V|0)==(f[L>>2]|0))Tv(m,i);else{f[V>>2]=U;f[t>>2]=V+4}O=O+1|0}while((O|0)<((f[y>>2]|0)-(f[s>>2]|0)>>3|0))}s=o+11|0;b[s>>0]=10;G=o;I=388458;H=G+10|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[o+10>>0]=0;mMa(n,a,o);f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=p+11|0;b[y>>0]=6;b[p>>0]=b[428960]|0;b[p+1>>0]=b[428961]|0;b[p+2>>0]=b[428962]|0;b[p+3>>0]=b[428963]|0;b[p+4>>0]=b[428964]|0;b[p+5>>0]=b[428965]|0;b[p+6>>0]=0;O=SOa(a,n,p,k)|0;if((b[y>>0]|0)<0)cYc(f[p>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[s>>0]|0)<0)cYc(f[o>>2]|0);y=f[m>>2]|0;if((f[t>>2]|0)!=(y|0)){L=0;K=y;do{YOa(a,f[K+(L<<2)>>2]|0,0,O,L);L=L+1|0;K=f[m>>2]|0}while(L>>>0<(f[t>>2]|0)-K>>2>>>0)}f[n>>2]=O;f[n+4>>2]=q;K=d+4|0;L=f[K>>2]|0;if(L>>>0<(f[d+8>>2]|0)>>>0){s=n;y=f[s+4>>2]|0;N=L;f[N>>2]=f[s>>2];f[N+4>>2]=y;f[K>>2]=(f[K>>2]|0)+8}else nMa(d,n);K=f[m>>2]|0;if(K|0){y=f[t>>2]|0;if((y|0)!=(K|0))f[t>>2]=y+(~((y+-4-K|0)>>>2)<<2);cYc(K)}K=l+36|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0);K=l+24|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0);hx(l+12|0);QGa(l,f[M>>2]|0);K=k+36|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0);K=k+24|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0);hx(k+12|0);QGa(k,f[w>>2]|0);K=j+36|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0);K=j+24|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0);hx(j+12|0);QGa(j,f[J>>2]|0);r=O;u=h;return r|0}else{S=Q;T=R}while(0);do if(((S<<24>>24<0?T:S&255)|0)==11){if(LYc(c,0,-1,385776,11)|0){W=b[v>>0]|0;X=f[x>>2]|0;break}K=a+72|0;f[K>>2]=(f[K>>2]|0)+1;K=c+72|0;y=c+76|0;N=f[y>>2]|0;s=f[K>>2]|0;if((N-s|0)>0){L=0;P=s;while(1){V=lMa(a,f[P+(L<<3)>>2]|0,d,e,g)|0;L=L+1|0;U=f[y>>2]|0;Y=f[K>>2]|0;if((L|0)>=(U-Y>>3|0)){Z=V;_=Y;$=U;break}else P=Y}}else{Z=-1;_=s;$=N}P=$-_>>3;f[i>>2]=P;L=a+56|0;K=f[L>>2]|0;if(K>>>0<(f[a+60>>2]|0)>>>0){f[K>>2]=P;f[L>>2]=K+4}else LA(a+52|0,i);r=Z;u=h;return r|0}else{W=S;X=T}while(0);do if(((W<<24>>24<0?X:W&255)|0)==9){if(LYc(c,0,-1,385788,9)|0){aa=b[v>>0]|0;ba=f[x>>2]|0;break}pQa(i,a);f[j+4>>2]=0;f[j+8>>2]=0;K=j+4|0;f[j>>2]=K;G=j+12|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;N=k+11|0;b[N>>0]=4;f[k>>2]=1936291937;b[k+4>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;s=m+11|0;b[s>>0]=9;G=m;I=385851;H=G+9|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[m+9>>0]=0;L=MGa(NIa(c+24|0,m)|0,-1)|0;f[l>>2]=L+-1;aHa(j,k,l)|0;if((b[s>>0]|0)<0)cYc(f[m>>2]|0);if((b[N>>0]|0)<0)cYc(f[k>>2]|0);L=l+11|0;b[L>>0]=10;G=l;I=388458;H=G+10|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[l+10>>0]=0;mMa(k,a,l);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;N=m+11|0;b[N>>0]=6;b[m>>0]=b[428960]|0;b[m+1>>0]=b[428961]|0;b[m+2>>0]=b[428962]|0;b[m+3>>0]=b[428963]|0;b[m+4>>0]=b[428964]|0;b[m+5>>0]=b[428965]|0;b[m+6>>0]=0;s=SOa(a,k,m,j)|0;if((b[N>>0]|0)<0)cYc(f[m>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[L>>0]|0)<0)cYc(f[l>>2]|0);f[k>>2]=s;f[k+4>>2]=q;N=d+4|0;P=f[N>>2]|0;if(P>>>0<(f[d+8>>2]|0)>>>0){y=k;O=f[y+4>>2]|0;J=P;f[J>>2]=f[y>>2];f[J+4>>2]=O;f[N>>2]=(f[N>>2]|0)+8}else nMa(d,k);N=a+56|0;O=f[N>>2]|0;if((f[a+52>>2]|0)==(O|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;J=$Xc(32)|0;f[k>>2]=J;f[k+8>>2]=-2147483616;f[k+4>>2]=29;G=J;I=388493;H=G+29|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[J+29>>0]=0;vM(-215,k,388523,385609,1151)}L=O+-4|0;y=f[L>>2]|0;f[N>>2]=L;L=i+4|0;P=f[L>>2]|0;w=f[i>>2]|0;if(y>>>0>P-w>>2>>>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;M=$Xc(32)|0;f[k>>2]=M;f[k+8>>2]=-2147483616;f[k+4>>2]=23;G=M;I=388528;H=G+23|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[M+23>>0]=0;vM(-215,k,388523,385609,1154)}a:do if((y|0)>0){N=0;O=w;J=P;while(1){YOa(a,f[O+(N-y+(J-O>>2)<<2)>>2]|0,0,s,N);t=N+1|0;if((t|0)>=(y|0))break a;N=t;O=f[i>>2]|0;J=f[L>>2]|0}}while(0);y=j+36|0;if((b[y+11>>0]|0)<0)cYc(f[y>>2]|0);y=j+24|0;if((b[y+11>>0]|0)<0)cYc(f[y>>2]|0);hx(j+12|0);QGa(j,f[K>>2]|0);y=f[i>>2]|0;if(y|0){P=f[L>>2]|0;if((P|0)!=(y|0))f[L>>2]=P+(~((P+-4-y|0)>>>2)<<2);cYc(y)}r=s;u=h;return r|0}else{aa=W;ba=X}while(0);do if(((aa<<24>>24<0?ba:aa&255)|0)==9){if(LYc(c,0,-1,386580,9)|0){ca=b[v>>0]|0;da=f[x>>2]|0;break}y=$Xc(16)|0;f[j>>2]=y;f[j+8>>2]=-2147483632;f[j+4>>2]=14;G=y;I=388552;H=G+14|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[y+14>>0]=0;mMa(i,a,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);pQa(j,a);f[k+4>>2]=0;f[k+8>>2]=0;s=k+4|0;f[k>>2]=s;G=k+12|0;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;y=l+11|0;b[y>>0]=9;G=l;I=437378;H=G+9|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[l+9>>0]=0;JIa(k,l,437393)|0;if((b[y>>0]|0)<0)cYc(f[l>>2]|0);f[l+8>>2]=0;L=l+11|0;b[L>>0]=7;b[l>>0]=b[428856]|0;b[l+1>>0]=b[428857]|0;b[l+2>>0]=b[428858]|0;b[l+3>>0]=b[428859]|0;b[l+4>>0]=b[428860]|0;b[l+5>>0]=b[428861]|0;b[l+6>>0]=b[428862]|0;b[l+7>>0]=0;K=SOa(a,i,l,k)|0;if((b[L>>0]|0)<0)cYc(f[l>>2]|0);L=a+56|0;P=f[L>>2]|0;if((f[a+52>>2]|0)==(P|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;w=$Xc(32)|0;f[l>>2]=w;f[l+8>>2]=-2147483616;f[l+4>>2]=29;G=w;I=388493;H=G+29|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[w+29>>0]=0;vM(-215,l,388523,385609,1172)}y=P+-4|0;M=f[y>>2]|0;f[L>>2]=y;y=j+4|0;J=f[y>>2]|0;O=f[j>>2]|0;if(M>>>0>J-O>>2>>>0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;N=$Xc(32)|0;f[l>>2]=N;f[l+8>>2]=-2147483616;f[l+4>>2]=23;G=N;I=388528;H=G+23|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[N+23>>0]=0;vM(-215,l,388523,385609,1175)}b:do if((M|0)>0){L=0;P=O;w=J;while(1){YOa(a,f[P+(L-M+(w-P>>2)<<2)>>2]|0,0,K,L);t=L+1|0;if((t|0)>=(M|0))break b;L=t;P=f[j>>2]|0;w=f[y>>2]|0}}while(0);f[l>>2]=K;f[l+4>>2]=q;M=d+4|0;J=f[M>>2]|0;if(J>>>0<(f[d+8>>2]|0)>>>0){O=l;N=f[O+4>>2]|0;w=J;f[w>>2]=f[O>>2];f[w+4>>2]=N;f[M>>2]=(f[M>>2]|0)+8}else nMa(d,l);M=k+36|0;if((b[M+11>>0]|0)<0)cYc(f[M>>2]|0);M=k+24|0;if((b[M+11>>0]|0)<0)cYc(f[M>>2]|0);hx(k+12|0);QGa(k,f[s>>2]|0);M=f[j>>2]|0;if(M|0){N=f[y>>2]|0;if((N|0)!=(M|0))f[y>>2]=N+(~((N+-4-M|0)>>>2)<<2);cYc(M)}if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);r=K;u=h;return r|0}else{ca=aa;da=ba}while(0);if(((ca<<24>>24<0?da:ca&255)|0)!=19){SGa(i,388648,c);vM(-3,i,388523,385609,1219)}if(LYc(c,0,-1,387153,19)|0){SGa(i,388648,c);vM(-3,i,388523,385609,1219)}M=c+24|0;N=$Xc(16)|0;f[i>>2]=N;f[i+8>>2]=-2147483632;f[i+4>>2]=15;G=N;I=386054;H=G+15|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[N+15>>0]=0;w=(HIa(M,i)|0)==0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if(w){w=$Xc(48)|0;f[i>>2]=w;f[i+8>>2]=-2147483600;f[i+4>>2]=37;G=w;I=388567;H=G+37|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[w+37>>0]=0;vM(-215,i,388523,385609,1185)}N=$Xc(16)|0;f[i>>2]=N;f[i+8>>2]=-2147483632;f[i+4>>2]=15;G=N;I=386054;H=G+15|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[N+15>>0]=0;w=MGa(NIa(M,i)|0,-1)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);O=d+4|0;J=f[d>>2]|0;c:do if((f[O>>2]|0)==(J|0)){ea=-1;fa=0}else{P=i+8|0;L=i+4|0;t=i+11|0;Y=j+8|0;U=j+4|0;V=j+11|0;ga=0;ha=J;d:while(1){ia=f[ha+(ga<<3)+4>>2]|0;ja=ia+12|0;ka=b[ja+11>>0]|0;do if(((ka<<24>>24<0?f[ia+16>>2]|0:ka&255)|0)==7){if(LYc(ja,0,-1,429057,7)|0)break;la=f[(f[d>>2]|0)+(ga<<3)+4>>2]|0;ma=$Xc(16)|0;f[i>>2]=ma;f[P>>2]=-2147483632;f[L>>2]=15;G=ma;I=386054;H=G+15|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[ma+15>>0]=0;if(!(HIa(la+24|0,i)|0))na=0;else{oa=f[(f[d>>2]|0)+(ga<<3)+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;pa=$Xc(16)|0;f[j>>2]=pa;f[Y>>2]=-2147483632;f[U>>2]=15;G=pa;I=386054;H=G+15|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[pa+15>>0]=0;la=MGa(NIa(oa+24|0,j)|0,-1)|0;if((b[V>>0]|0)<0)cYc(f[j>>2]|0);na=(la|0)==(w|0)}if((b[t>>0]|0)<0)cYc(f[i>>2]|0);if(na)break d}while(0);ja=ga+1|0;ha=f[d>>2]|0;if(ja>>>0>=(f[O>>2]|0)-ha>>3>>>0){ea=-1;fa=0;break c}else ga=ja}ha=f[d>>2]|0;ea=f[ha+(ga<<3)>>2]|0;fa=f[ha+(ga<<3)+4>>2]|0}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;O=i+11|0;b[O>>0]=8;w=i;f[w>>2]=1819242352;f[w+4>>2]=1751083871;b[i+8>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=k+11|0;b[w>>0]=8;J=k;f[J>>2]=1852990827;f[J+4>>2]=1751084133;b[k+8>>0]=0;J=fa+24|0;N=MGa(NIa(J,k)|0,-1)|0;f[j>>2]=N;aHa(M,i,j)|0;if((b[w>>0]|0)<0)cYc(f[k>>2]|0);if((b[O>>0]|0)<0)cYc(f[i>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;O=i+11|0;b[O>>0]=8;w=i;f[w>>2]=1819242352;f[w+4>>2]=2002742111;b[i+8>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=k+11|0;b[w>>0]=8;N=k;f[N>>2]=1852990827;f[N+4>>2]=2002742373;b[k+8>>0]=0;N=MGa(NIa(J,k)|0,-1)|0;f[j>>2]=N;aHa(M,i,j)|0;if((b[w>>0]|0)<0)cYc(f[k>>2]|0);if((b[O>>0]|0)<0)cYc(f[i>>2]|0);O=$Xc(16)|0;f[i>>2]=O;f[i+8>>2]=-2147483632;f[i+4>>2]=13;G=O;I=439860;H=G+13|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[O+13>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=k+11|0;b[w>>0]=8;N=k;f[N>>2]=1769108595;f[N+4>>2]=1751082340;b[k+8>>0]=0;N=MGa(NIa(J,k)|0,-1)|0;f[j>>2]=N;aHa(M,i,j)|0;if((b[w>>0]|0)<0)cYc(f[k>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);w=$Xc(16)|0;f[i>>2]=w;f[i+8>>2]=-2147483632;f[i+4>>2]=13;G=w;I=439846;H=G+13|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[w+13>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;O=k+11|0;b[O>>0]=8;N=k;f[N>>2]=1769108595;f[N+4>>2]=2002740580;b[k+8>>0]=0;N=MGa(NIa(J,k)|0,-1)|0;f[j>>2]=N;aHa(M,i,j)|0;if((b[O>>0]|0)<0)cYc(f[k>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);O=i+11|0;b[O>>0]=10;G=i;I=439835;H=G+10|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[i+10>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;w=k+11|0;b[w>>0]=5;b[k>>0]=b[390333]|0;b[k+1>>0]=b[390334]|0;b[k+2>>0]=b[390335]|0;b[k+3>>0]=b[390336]|0;b[k+4>>0]=b[390337]|0;b[k+5>>0]=0;N=MGa(NIa(J,k)|0,-1)|0;f[j>>2]=N;aHa(M,i,j)|0;if((b[w>>0]|0)<0)cYc(f[k>>2]|0);if((b[O>>0]|0)<0)cYc(f[i>>2]|0);w=i+11|0;b[w>>0]=10;G=i;I=439824;H=G+10|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[i+10>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;O=k+11|0;b[O>>0]=5;b[k>>0]=b[390339]|0;b[k+1>>0]=b[390340]|0;b[k+2>>0]=b[390341]|0;b[k+3>>0]=b[390342]|0;b[k+4>>0]=b[390343]|0;b[k+5>>0]=0;N=MGa(NIa(J,k)|0,-1)|0;f[j>>2]=N;aHa(M,i,j)|0;if((b[O>>0]|0)<0)cYc(f[k>>2]|0);if((b[w>>0]|0)<0)cYc(f[i>>2]|0);O=$Xc(32)|0;f[j>>2]=O;f[j+8>>2]=-2147483616;f[j+4>>2]=17;G=O;I=388605;H=G+17|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[O+17>>0]=0;mMa(i,a,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;w=j+11|0;b[w>>0]=9;G=j;I=396640;H=G+9|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[j+9>>0]=0;O=SOa(a,i,j,c+24|0)|0;if((b[w>>0]|0)<0)cYc(f[j>>2]|0);YOa(a,e,0,O,0);if((ea|0)==-1){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;M=$Xc(32)|0;f[j>>2]=M;f[j+8>>2]=-2147483616;f[j+4>>2]=24;G=M;I=388623;H=G+24|0;do{b[G>>0]=b[I>>0]|0;G=G+1|0;I=I+1|0}while((G|0)<(H|0));b[M+24>>0]=0;vM(-215,j,388523,385609,1212)}YOa(a,ea,1,O,1);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);r=O;u=h;return r|0}while(0);i=c+72|0;ea=c+76|0;c=f[i>>2]|0;if((f[ea>>2]|0)==(c|0)){r=e;u=h;return r|0}else{qa=e;ra=g;sa=0;ta=c}while(1){c=lMa(a,f[ta+(sa<<3)>>2]|0,d,qa,ra)|0;sa=sa+1|0;ta=f[i>>2]|0;if(sa>>>0>=(f[ea>>2]|0)-ta>>3>>>0){r=c;break}else{qa=c;ra=0}}u=h;return r|0}function mMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+192|0;g=e+176|0;h=e+40|0;i=e+24|0;j=e+12|0;k=e;l=c+72|0;f[l>>2]=(f[l>>2]|0)+1;c=h+56|0;m=h+4|0;f[h>>2]=6884;f[c>>2]=6904;XNc(h+56|0,m);f[h+128>>2]=0;f[h+132>>2]=-1;f[h>>2]=36020;f[c>>2]=36040;aOc(m);f[m>>2]=35912;n=h+36|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[h+52>>2]=16;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(m,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);nOc(h,f[l>>2]|0)|0;CM(k,m);f[h>>2]=36020;f[c>>2]=36040;f[m>>2]=35912;if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);LMc(m);HNc(h,36052);GMc(c);c=EYc(k,0,529314)|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=AYc(j,388677)|0;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=b[d+11>>0]|0;h=c<<24>>24<0;m=zYc(i,h?f[d>>2]|0:d,h?f[d+4>>2]|0:c&255)|0;f[a>>2]=f[m>>2];f[a+4>>2]=f[m+4>>2];f[a+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)>=0){u=e;return}cYc(f[k>>2]|0);u=e;return}function nMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function oMa(a){a=a|0;f[a>>2]=81956;QLa(a+12|0);NXc(a);return}function pMa(a){a=a|0;f[a>>2]=81956;QLa(a+12|0);NXc(a);cYc(a);return}function qMa(a){a=a|0;QLa(a+12|0);return}function rMa(a){a=a|0;cYc(a);return}function sMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e+16|0;h=e;i=e+20|0;a:do switch(dJc(c)|0){case 1:{switch(b[c>>0]|0){case 114:break;case 119:{j=$Xc(32)|0;f[i>>2]=j;k=i+8|0;f[k>>2]=-2147483616;l=i+4|0;f[l>>2]=25;m=j;n=388939;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+25|0;b[p>>0]=0;vM(-215,i,388924,388799,482);break}default:break a}q=a+11|0;r=iKc((b[q>>0]|0)<0?f[a>>2]|0:a,511741)|0;if(!r)if(!d){f[h>>2]=(b[q>>0]|0)<0?f[a>>2]|0:a;f[h+4>>2]=114;f[h+8>>2]=32;DM(i,388965,h);vM(-2,i,388924,388799,496)}else{s=0;u=e;return s|0}q=jIc(40)|0;if(!q){DM(i,388995,g);vM(-2,i,388924,388799,501)}f[q+28>>2]=r;f[q+32>>2]=1;f[q+36>>2]=0;f[q>>2]=81976;f[q+4>>2]=d;f[q+8>>2]=1;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=1;f[q+24>>2]=0;s=q;u=e;return s|0}case 2:{if((b[c>>0]|0)==114?(b[c+1>>0]|0)==119:0){j=$Xc(32)|0;f[i>>2]=j;k=i+8|0;f[k>>2]=-2147483616;l=i+4|0;f[l>>2]=25;m=j;n=388939;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+25|0;b[p>>0]=0;vM(-215,i,388924,388799,482)}break}default:{}}while(0);p=$Xc(48)|0;f[i>>2]=p;f[i+8>>2]=-2147483600;f[i+4>>2]=47;m=p;n=388876;o=m+47|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[p+47>>0]=0;vM(-215,i,388924,388799,480);return 0}function tMa(a){a=a|0;return (f[a+28>>2]|0)!=0|0}function uMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e;h=e+8|0;i=a+28|0;j=f[i>>2]|0;if(!j){k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=20;l=k;m=388778;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+20>>0]=0;vM(-215,h,389649,388799,266)}if(!(f[a+8>>2]|0)){k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=23;l=k;m=389249;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+23>>0]=0;vM(-215,h,389649,388799,266)}a:do if(!(f[a+16>>2]|0))if((d|0)>0){k=NLc(c,1,d,j)|0;if(!(f[a+20>>2]|0))o=k;else{m=MLc(f[i>>2]|0)|0;switch(m|0){case 10:case -1:{o=k;break a;break}default:{}}PLc(m,f[i>>2]|0)|0;o=k}}else o=0;else o=NLc(c,1,d,j)|0;while(0);if((o|0)==(d|0)){u=e;return o|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=o;f[g+4>>2]=d;DM(h,389465,g);vM(-2,h,389649,388799,266)}else{u=e;return o|0}return 0}function vMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e;h=e+8|0;i=a+28|0;j=f[i>>2]|0;if(!j){k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=20;l=k;m=388778;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+20>>0]=0;vM(-215,h,389629,388799,270)}if(!(f[a+8>>2]|0)){k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=23;l=k;m=389249;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+23>>0]=0;vM(-215,h,389629,388799,270)}a:do if(!(f[a+16>>2]|0))if((d|0)>0){k=NLc(c,1,d,j)|0;if(!(f[a+20>>2]|0))o=k;else{m=MLc(f[i>>2]|0)|0;switch(m|0){case 10:case -1:{o=k;break a;break}default:{}}PLc(m,f[i>>2]|0)|0;o=k}}else o=0;else o=NLc(c,1,d,j)|0;while(0);if((o|0)==(d|0)){u=e;return o|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=o;f[g+4>>2]=d;DM(h,389465,g);vM(-2,h,389629,388799,270)}else{u=e;return o|0}return 0}function wMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=20;n=m;o=388778;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+20>>0]=0;vM(-215,j,389604,388799,274)}if(!(f[a+8>>2]|0)){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=23;n=m;o=389249;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+23>>0]=0;vM(-215,j,389604,388799,274)}a:do if(!(f[a+16>>2]|0)){m=(d|0)>0;if(m){f[i>>2]=c;o=(tKc(l,389625,i)|0)>0;n=o&1;if(o&(d|0)!=1){o=n;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<1);r=(tKc(q,389625,h)|0)>0;q=(r&1)+o|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else o=q}}else s=n;if(m&(f[a+20>>2]|0)!=0){o=MLc(f[k>>2]|0)|0;switch(o|0){case 10:case -1:{t=s;break a;break}default:{}}PLc(o,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{o=NLc(c,2,d,l)|0;if((o|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+1|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;p=p+1|0;if((p|0)==(o|0)){t=o;break}else q=q+2|0}}else t=o}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;DM(j,389465,g);vM(-2,j,389604,388799,274)}else{u=e;return t|0}return 0}function xMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=20;n=m;o=388778;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+20>>0]=0;vM(-215,j,389580,388799,278)}if(!(f[a+8>>2]|0)){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=23;n=m;o=389249;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+23>>0]=0;vM(-215,j,389580,388799,278)}a:do if(!(f[a+16>>2]|0)){m=(d|0)>0;if(m){f[i>>2]=c;o=(tKc(l,389599,i)|0)>0;n=o&1;if(o&(d|0)!=1){o=n;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<2);r=(tKc(q,389599,h)|0)>0;q=(r&1)+o|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else o=q}}else s=n;if(m&(f[a+20>>2]|0)!=0){o=MLc(f[k>>2]|0)|0;switch(o|0){case 10:case -1:{t=s;break a;break}default:{}}PLc(o,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{o=NLc(c,4,d,l)|0;if((o|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+3|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;r=q+1|0;v=b[r>>0]|0;w=q+2|0;b[r>>0]=b[w>>0]|0;b[w>>0]=v;p=p+1|0;if((p|0)==(o|0)){t=o;break}else q=q+4|0}}else t=o}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;DM(j,389465,g);vM(-2,j,389580,388799,278)}else{u=e;return t|0}return 0}function yMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e+8|0;j=e;k=e+32|0;l=a+28|0;m=f[l>>2]|0;if(!m){n=$Xc(32)|0;f[k>>2]=n;f[k+8>>2]=-2147483616;f[k+4>>2]=20;o=n;p=388778;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+20>>0]=0;vM(-215,k,389532,388799,299)}if(!(f[a+8>>2]|0)){n=$Xc(32)|0;f[k>>2]=n;f[k+8>>2]=-2147483616;f[k+4>>2]=23;o=n;p=389249;q=o+23|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+23>>0]=0;vM(-215,k,389532,388799,300)}a:do if(!(f[a+16>>2]|0)){n=(d|0)>0;if(n){f[j>>2]=k;b:do if((tKc(m,389552,j)|0)<1){r=0;s=23}else{p=0;while(1){o=p+1|0;q=f[k>>2]|0;t=c+(p<<3)|0;f[t>>2]=q;f[t+4>>2]=((q|0)<0)<<31>>31;if((o|0)>=(d|0)){v=o;break b}q=f[l>>2]|0;f[h>>2]=k;if((tKc(q,389552,h)|0)<1){r=o;s=23;break}else p=o}}while(0);if((s|0)==23)v=r;if(n&(f[a+20>>2]|0)!=0){p=MLc(f[l>>2]|0)|0;switch(p|0){case 10:case -1:{w=v;break a;break}default:{}}PLc(p,f[l>>2]|0)|0;w=v}else w=v}else w=0}else switch(f[a+36>>2]|0){case 8:case 0:{p=NLc(c,8,d,m)|0;if((p|0)>0&(f[a+32>>2]|0)==0){x=0;y=c}else{w=p;break a}while(1){o=b[y>>0]|0;q=y+7|0;b[y>>0]=b[q>>0]|0;b[q>>0]=o;o=y+1|0;q=b[o>>0]|0;t=y+6|0;b[o>>0]=b[t>>0]|0;b[t>>0]=q;q=y+2|0;t=b[q>>0]|0;o=y+5|0;b[q>>0]=b[o>>0]|0;b[o>>0]=t;t=y+3|0;o=b[t>>0]|0;q=y+4|0;b[t>>0]=b[q>>0]|0;b[q>>0]=o;x=x+1|0;if((x|0)==(p|0)){w=p;break}else y=y+8|0}break}case 4:{p=NLc(c,4,d,m)|0;n=(p|0)>0;if(n&(f[a+32>>2]|0)==0){o=0;q=c;while(1){t=b[q>>0]|0;z=q+3|0;b[q>>0]=b[z>>0]|0;b[z>>0]=t;t=q+1|0;z=b[t>>0]|0;A=q+2|0;b[t>>0]=b[A>>0]|0;b[A>>0]=z;o=o+1|0;if((o|0)==(p|0))break;else q=q+4|0}}if(!n){w=p;break a}q=p;do{o=q;q=q+-1|0;z=f[c+(q<<2)>>2]|0;A=c+(q<<3)|0;f[A>>2]=z;f[A+4>>2]=((z|0)<0)<<31>>31}while((o|0)>1);w=p;break}default:{p=jIc(d<<3)|0;if(!p){DM(k,389556,i);vM(-2,k,389532,388799,323)}q=NLc(p,8,d,m)|0;n=(q|0)>0;if(n){o=q;do{z=o;o=o+-1|0;A=f[p+(o<<1<<2)>>2]|0;t=c+(o<<3)|0;f[t>>2]=A;f[t+4>>2]=((A|0)<0)<<31>>31}while((z|0)>1)}kIc(p);if(!(n&(f[a+32>>2]|0)==0)){w=q;break a}o=0;z=c;while(1){A=b[z>>0]|0;t=z+3|0;b[z>>0]=b[t>>0]|0;b[t>>0]=A;A=z+1|0;t=b[A>>0]|0;B=z+2|0;b[A>>0]=b[B>>0]|0;b[B>>0]=t;o=o+1|0;if((o|0)==(q|0)){w=q;break}else z=z+4|0}}}while(0);if((w|0)==(d|0)){u=e;return w|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=w;f[g+4>>2]=d;DM(k,389465,g);vM(-2,k,389532,388799,354)}else{u=e;return w|0}return 0}function zMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=20;n=m;o=388778;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+20>>0]=0;vM(-215,j,389508,388799,286)}if(!(f[a+8>>2]|0)){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=23;n=m;o=389249;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+23>>0]=0;vM(-215,j,389508,388799,286)}a:do if(!(f[a+16>>2]|0)){m=(d|0)>0;if(m){f[i>>2]=c;o=(tKc(l,389529,i)|0)>0;n=o&1;if(o&(d|0)!=1){o=n;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<2);r=(tKc(q,389529,h)|0)>0;q=(r&1)+o|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else o=q}}else s=n;if(m&(f[a+20>>2]|0)!=0){o=MLc(f[k>>2]|0)|0;switch(o|0){case 10:case -1:{t=s;break a;break}default:{}}PLc(o,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{o=NLc(c,4,d,l)|0;if((o|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+3|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;r=q+1|0;v=b[r>>0]|0;w=q+2|0;b[r>>0]=b[w>>0]|0;b[w>>0]=v;p=p+1|0;if((p|0)==(o|0)){t=o;break}else q=q+4|0}}else t=o}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;DM(j,389465,g);vM(-2,j,389508,388799,286)}else{u=e;return t|0}return 0}function AMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;l=f[k>>2]|0;if(!l){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=20;n=m;o=388778;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+20>>0]=0;vM(-215,j,389439,388799,290)}if(!(f[a+8>>2]|0)){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=23;n=m;o=389249;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+23>>0]=0;vM(-215,j,389439,388799,290)}a:do if(!(f[a+16>>2]|0)){m=(d|0)>0;if(m){f[i>>2]=c;o=(tKc(l,389461,i)|0)>0;n=o&1;if(o&(d|0)!=1){o=n;p=1;while(1){q=f[k>>2]|0;f[h>>2]=c+(p<<3);r=(tKc(q,389461,h)|0)>0;q=(r&1)+o|0;p=p+1|0;if(!(r&(p|0)<(d|0))){s=q;break}else o=q}}else s=n;if(m&(f[a+20>>2]|0)!=0){o=MLc(f[k>>2]|0)|0;switch(o|0){case 10:case -1:{t=s;break a;break}default:{}}PLc(o,f[k>>2]|0)|0;t=s}else t=s}else t=0}else{o=NLc(c,8,d,l)|0;if((o|0)>0&(f[a+32>>2]|0)==0){p=0;q=c;while(1){r=b[q>>0]|0;v=q+7|0;b[q>>0]=b[v>>0]|0;b[v>>0]=r;r=q+1|0;v=b[r>>0]|0;w=q+6|0;b[r>>0]=b[w>>0]|0;b[w>>0]=v;v=q+2|0;w=b[v>>0]|0;r=q+5|0;b[v>>0]=b[r>>0]|0;b[r>>0]=w;w=q+3|0;r=b[w>>0]|0;v=q+4|0;b[w>>0]=b[v>>0]|0;b[v>>0]=r;p=p+1|0;if((p|0)==(o|0)){t=o;break}else q=q+8|0}}else t=o}while(0);if((t|0)==(d|0)){u=e;return t|0}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[g>>2]=t;f[g+4>>2]=d;DM(j,389465,g);vM(-2,j,389439,388799,290)}else{u=e;return t|0}return 0}function BMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e+8|0;j=e;k=e+28|0;l=a+28|0;if(!(f[l>>2]|0)){m=$Xc(32)|0;f[k>>2]=m;f[k+8>>2]=-2147483616;f[k+4>>2]=20;n=m;o=388778;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+20>>0]=0;vM(-215,k,389227,388799,364)}if(!(f[a+8>>2]|0)){m=$Xc(32)|0;f[k>>2]=m;f[k+8>>2]=-2147483616;f[k+4>>2]=23;n=m;o=389249;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+23>>0]=0;vM(-215,k,389227,388799,365)}if(((dJc(c)|0)>>>0>1?(b[c>>0]|0)==42:0)?(m=b[c+1>>0]|0,c=m<<24>>24==97,!(c^m<<24>>24!=108)):0){m=jIc(1024)|0;if(c){c=0;q=1024;r=m;while(1){s=q+1024|0;if((q|0)==(c|0)){t=s;v=lIc(r,s)|0}else{t=q;v=r}if(!v){w=13;break}c=(NLc(v+c|0,1,t-c|0,f[l>>2]|0)|0)+c|0;if((c|0)<(t|0))break;else{q=t;r=v}}if((w|0)==13){DM(k,389362,j);vM(-2,k,389227,388799,386)}if(c|0){x=v;y=c;f[d>>2]=x;u=e;return y|0}kIc(v);f[a+24>>2]=1;if(!(f[a+4>>2]|0)){DM(k,389400,i);vM(-2,k,389227,388799,395)}else{x=0;y=0;f[d>>2]=x;u=e;return y|0}}else{z=0;A=1024;B=m}while(1){m=A+1024|0;if((A-z|0)<2){C=m;D=lIc(B,m)|0}else{C=A;D=B}if(!D){w=21;break}m=D+z|0;if(!(rKc(m,C-z|0,f[l>>2]|0)|0)){w=23;break}i=dJc(m)|0;if(i|0?(E=i+-1|0,(b[m+E>>0]|0)==10):0){w=29;break}z=i+z|0;A=C;B=D}if((w|0)==21){DM(k,389362,h);vM(-2,k,389227,388799,420)}else if((w|0)==23){if(z|0){x=D;y=z;f[d>>2]=x;u=e;return y|0}kIc(D);f[a+24>>2]=1;if(!(f[a+4>>2]|0)){DM(k,389400,g);vM(-2,k,389227,388799,428)}else{x=0;y=0;f[d>>2]=x;u=e;return y|0}}else if((w|0)==29){x=D;y=E+z|0;f[d>>2]=x;u=e;return y|0}}y=$Xc(96)|0;f[k>>2]=y;f[k+8>>2]=-2147483552;f[k+4>>2]=88;n=y;o=389273;p=n+88|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[y+88>>0]=0;vM(-215,k,389227,388799,366);return 0}function CMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=d+4|0;h=f[a+28>>2]|0;if(!h){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=20;j=i;k=388778;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+20>>0]=0;vM(-215,g,389180,388799,111)}if((PKc(h,c,0)|0)>=0){u=d;return}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){f[e>>2]=c;DM(g,389196,e);vM(-2,g,389180,388799,123)}else{u=d;return}}function DMa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=c+4|0;g=f[a+28>>2]|0;if(!g){h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=20;i=h;j=388778;k=i+20|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+20>>0]=0;vM(-215,e,389131,388799,131)}if((PKc(g,0,2)|0)>=0){u=c;return}f[a+24>>2]=1;if(!(f[a+4>>2]|0)){DM(e,389150,d);vM(-2,e,389131,388799,143)}else{u=c;return}}function EMa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=c+4|0;g=f[a+28>>2]|0;if(!g){h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=20;i=h;j=388778;k=i+20|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+20>>0]=0;vM(-215,e,389044,388799,150)}h=KLc(g)|0;if((h|0)>-1){l=h;u=c;return l|0}if(!(f[a+4>>2]|0)){DM(e,389064,d);vM(-2,e,389044,388799,162)}else{l=0;u=c;return l|0}return 0}function FMa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=a+28|0;a=f[e>>2]|0;if(!a){g=$Xc(32)|0;f[d>>2]=g;f[d+8>>2]=-2147483616;f[d+4>>2]=20;h=g;i=388778;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+20>>0]=0;vM(-215,d,389027,388799,170)}else{oKc(a)|0;f[e>>2]=0;u=c;return}}function GMa(a){a=a|0;var b=0;b=f[a+28>>2]|0;if(!b){kIc(a);return}oKc(b)|0;kIc(a);return}function HMa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+4>>2]&511](a,b,c)|0}function IMa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+8>>2]&511](a,b,c)|0}function JMa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+12>>2]&511](a,b,c)|0}function KMa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+16>>2]&511](a,b,c)|0}function LMa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+20>>2]&511](a,b,c)|0}function MMa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+24>>2]&511](a,b,c)|0}function NMa(a,b,c){a=a|0;b=b|0;c=c|0;return hj[f[(f[a>>2]|0)+28>>2]&511](a,b,c)|0}function OMa(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+36>>2]&2047](a,b);return}function PMa(a){a=a|0;return _i[f[(f[a>>2]|0)+44>>2]&2047](a)|0}function QMa(a){a=a|0;Yi[f[(f[a>>2]|0)+52>>2]&4095](a);return}function RMa(a){a=a|0;return _i[f[f[a>>2]>>2]&2047](a)|0}function SMa(a){a=a|0;f[a+16>>2]=1;return}function TMa(a){a=a|0;f[a+16>>2]=0;return}function UMa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;hj[f[(f[a>>2]|0)+16>>2]&511](a,c,1)|0;u=b;return f[c>>2]|0}function VMa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;hj[f[(f[a>>2]|0)+20>>2]&511](a,c,1)|0;a=c;J=f[a+4>>2]|0;u=b;return f[a>>2]|0}function WMa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;hj[f[(f[a>>2]|0)+28>>2]&511](a,c,1)|0;u=b;return +(+p[c>>3])}function XMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;d=u;u=u+144|0;e=d+88|0;g=d+72|0;h=d+16|0;i=d;j=c+128|0;k=f[j>>2]|0;l=b[k+11>>0]|0;if(l<<24>>24<0)m=f[k+4>>2]|0;else m=l&255;if((((m|0)==0?(f[c+28>>2]|0)==0:0)?(f[c+92>>2]|0)==0:0)?(f[c+76>>2]|0)==0:0){m=$Xc(160)|0;f[e>>2]=m;f[e+8>>2]=-2147483488;f[e+4>>2]=147;o1c(m|0,389669,147)|0;b[m+147>>0]=0;vM(-215,e,389817,389834,91)}m=f[c+140>>2]|0;f[a>>2]=1124007936;l=a+4|0;k=a+8|0;n=a+40|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=k;q=a+48|0;f[a+44>>2]=q;f[q>>2]=0;f[a+52>>2]=0;f[g>>2]=0;q=g+4|0;f[q>>2]=0;f[g+8>>2]=0;r=c+16|0;if((f[r>>2]|0)>0){s=c+24|0;t=g+8|0;v=0;w=0;x=0;while(1){y=f[(f[s>>2]|0)+8+(v<<3)>>2]|0;f[e>>2]=y;if(w>>>0<x>>>0){f[w>>2]=y;f[q>>2]=w+4}else LA(g,e);y=v+1|0;if((y|0)>=(f[r>>2]|0))break;v=y;w=f[q>>2]|0;x=f[t>>2]|0}if((f[g>>2]|0)==(f[q>>2]|0))z=17}else z=17;if((z|0)==17){f[e>>2]=1;YMa(g,1,e)}a:do switch(m|0){case 1:{t=c+28|0;x=f[t>>2]|0;if(!x){w=f[j>>2]|0;if((b[w+11>>0]|0)<0)A=f[w>>2]|0;else A=w;$$(e,g,5,A,0);w=h+8|0;f[w>>2]=0;f[w+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;jR(e,h);w=e+36|0;v=f[w>>2]|0;if(v|0?(r=v+12|0,v=f[r>>2]|0,f[r>>2]=v+-1,(v|0)==1):0)V$(e);f[w>>2]=0;w=e+16|0;v=e+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[v>>2]|0)>0){w=f[e+40>>2]|0;r=0;do{f[w+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[v>>2]|0))}v=f[e+44>>2]|0;if((v|0)!=(e+48|0))wL(v);break a}else{f[e>>2]=0;f[e+4>>2]=0;v=e+8|0;f[v>>2]=0;uHa(e,x);o1c((f[v>>2]|0)+4|0,(f[c+36>>2]|0)+4|0,f[t>>2]<<2|0)|0;f[e>>2]=f[t>>2];r=f[v>>2]|0;$$(h,g,5,(r|0)==0?0:r+4|0,0);r=i+8|0;f[r>>2]=0;f[r+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;jR(h,i);r=h+36|0;w=f[r>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)V$(h);f[r>>2]=0;r=h+16|0;w=h+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[w>>2]|0)>0){r=f[h+40>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[w>>2]|0))}w=f[h+44>>2]|0;if((w|0)!=(h+48|0))wL(w);w=f[v>>2]|0;if(w|0?(f[w>>2]|0)==0:0)cYc(w);break a}break}case 11:{f[e>>2]=0;f[e+4>>2]=0;w=e+8|0;f[w>>2]=0;s=c+92|0;r=f[s>>2]|0;if(!r){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=$Xc(16)|0;f[h>>2]=B;C=h+8|0;f[C>>2]=-2147483632;D=h+4|0;f[D>>2]=14;o=B;E=389913;p=o+14|0;do{b[o>>0]=b[E>>0]|0;o=o+1|0;E=E+1|0}while((o|0)<(p|0));F=B+14|0;b[F>>0]=0;vM(-215,h,389817,389834,115)}ZMa(e,r);o1c((f[w>>2]|0)+8|0,(f[c+100>>2]|0)+8|0,f[s>>2]<<3|0)|0;v=f[s>>2]|0;f[e>>2]=v;if(!v){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=$Xc(16)|0;f[h>>2]=B;C=h+8|0;f[C>>2]=-2147483632;D=h+4|0;f[D>>2]=14;o=B;E=389913;p=o+14|0;do{b[o>>0]=b[E>>0]|0;o=o+1|0;E=E+1|0}while((o|0)<(p|0));F=B+14|0;b[F>>0]=0;vM(-215,h,389817,389834,115)}s=f[w>>2]|0;$$(h,g,6,(s|0)==0?0:s+8|0,0);s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;dY(h,i,5,1.0,0.0);s=h+36|0;r=f[s>>2]|0;if(r|0?(v=r+12|0,r=f[v>>2]|0,f[v>>2]=r+-1,(r|0)==1):0)V$(h);f[s>>2]=0;s=h+16|0;r=h+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[h+40>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[r>>2]|0))}r=f[h+44>>2]|0;if((r|0)!=(h+48|0))wL(r);r=f[w>>2]|0;if(r|0?(f[r>>2]|0)==0:0)cYc(r);break}case 7:{T$(a,g,4);r=f[a+16>>2]|0;v=c+76|0;s=f[v>>2]|0;if(!s){t=f[j>>2]|0;if((b[t+11>>0]|0)<0)G=f[t>>2]|0;else G=t;t=f[l>>2]|0;if((t|0)<3)H=Y(f[a+12>>2]|0,f[k>>2]|0)|0;else{x=f[n>>2]|0;y=0;I=1;while(1){K=Y(f[x+(y<<2)>>2]|0,I)|0;y=y+1|0;if((y|0)==(t|0)){H=K;break}else I=K}}if((H|0)<=0)break a;I=r;t=0;while(1){y=G+(t<<3)|0;x=f[y>>2]|0;w=d1c(x|0,f[y+4>>2]|0,-2147483648,0)|0;y=J;if(y>>>0>0|(y|0)==0&w>>>0>4294967295)break;f[I+(t<<2)>>2]=x;t=t+1|0;if((t|0)>=(H|0))break a}t=$Xc(48)|0;f[e>>2]=t;f[e+8>>2]=-2147483600;f[e+4>>2]=32;o=t;E=389928;p=o+32|0;do{b[o>>0]=b[E>>0]|0;o=o+1|0;E=E+1|0}while((o|0)<(p|0));b[t+32>>0]=0;vM(-211,e,389961,389834,82)}f[h>>2]=0;f[h+4>>2]=0;I=h+8|0;f[I>>2]=0;_Ma(h,s);o1c((f[I>>2]|0)+8|0,(f[c+84>>2]|0)+8|0,f[v>>2]<<3|0)|0;f[h>>2]=f[v>>2];x=f[l>>2]|0;if((x|0)<3)L=Y(f[a+12>>2]|0,f[k>>2]|0)|0;else{w=f[n>>2]|0;y=0;K=1;while(1){M=Y(f[w+(y<<2)>>2]|0,K)|0;y=y+1|0;if((y|0)==(x|0)){L=M;break}else K=M}}K=f[I>>2]|0;b:do if((L|0)<=0){if(K|0)z=70}else{x=r;y=0;while(1){w=K+8+(y<<3)|0;v=f[w>>2]|0;s=d1c(v|0,f[w+4>>2]|0,-2147483648,0)|0;w=J;if(w>>>0>0|(w|0)==0&s>>>0>4294967295)break;f[x+(y<<2)>>2]=v;y=y+1|0;if((y|0)>=(L|0)){z=70;break b}}y=$Xc(48)|0;f[e>>2]=y;f[e+8>>2]=-2147483600;f[e+4>>2]=32;o=y;E=389928;p=o+32|0;do{b[o>>0]=b[E>>0]|0;o=o+1|0;E=E+1|0}while((o|0)<(p|0));b[y+32>>0]=0;vM(-211,e,389961,389834,82)}while(0);if((z|0)==70?(f[K>>2]|0)==0:0)cYc(K);break}default:{SGa(e,389981,cjc(brb()|0,m)|0);vM(-210,e,389817,389834,136)}}while(0);e=f[g>>2]|0;if(!e){u=d;return}g=f[q>>2]|0;if((g|0)!=(e|0))f[q>>2]=g+(~((g+-4-e|0)>>>2)<<2);cYc(e);u=d;return}function YMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>2>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>2;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=m;m=h;while(1){f[m>>2]=f[c>>2];j=j+-1|0;if(!j)break;else m=m+4|0}}if(!l){m=h+(b<<2)|0;if((n|0)==(m|0))return;else{o=i;p=n+(~((n+-4-m|0)>>>2)<<2)|0;break}}else{m=b-k|0;j=m;q=n;while(1){f[q>>2]=f[c>>2];j=j+-1|0;if(!j)break;else q=q+4|0}o=i;p=n+(m<<2)|0;break}}else{q=g;if(!g)r=e;else{j=a+4|0;k=f[j>>2]|0;if((k|0)!=(h|0))f[j>>2]=k+(~((k+-4-g|0)>>>2)<<2);cYc(q);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;r=0}if(b>>>0>1073741823)kWc(a);j=r>>1;q=r>>2>>>0<536870911?(j>>>0<b>>>0?b:j):1073741823;if(q>>>0>1073741823)kWc(a);j=$Xc(q<<2)|0;k=a+4|0;f[k>>2]=j;f[a>>2]=j;f[d>>2]=j+(q<<2);q=b;l=j;while(1){f[l>>2]=f[c>>2];q=q+-1|0;if(!q)break;else l=l+4|0}o=k;p=j+(b<<2)|0}while(0);f[o>>2]=p;return}function ZMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<3;if(!i)k=$Xc(d+8|0)|0;else{b=d+15&-8;if(f[i+64>>2]|0)SXb(i,25456,b);k=QXb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)o1c(k+8|0,g+8|0,j<<3|0)|0;if(h)return;if(f[g>>2]|0)return;cYc(g);return}function _Ma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(h)i=0;else i=f[g>>2]|0;j=d<<1;d=(j|0)<(b|0)?b:j;j=(d|0)>4?d:4;d=j<<3;if(!i)k=$Xc(d+8|0)|0;else{b=d+15&-8;if(f[i+64>>2]|0)SXb(i,25456,b);k=QXb(i,b)|0}f[e>>2]=k;f[k>>2]=i;f[c>>2]=j;j=f[a>>2]|0;if((j|0)>0)o1c(k+8|0,g+8|0,j<<3|0)|0;if(h)return;if(f[g>>2]|0)return;cYc(g);return}function $Ma(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;c=u;u=u+288|0;e=c+272|0;g=c+128|0;h=c+72|0;i=c;Gob(g);f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;j=d+36|0;if((f[j>>2]|0)<=0){Ynb(g);u=c;return}k=d+44|0;d=g+128|0;l=g+124|0;m=i+12|0;n=i+16|0;o=h+4|0;p=i+20|0;q=h+8|0;r=i+24|0;s=h+12|0;t=i+28|0;v=h+16|0;w=i+32|0;x=h+20|0;y=i+36|0;z=h+24|0;A=i+40|0;B=h+28|0;C=i+44|0;D=h+32|0;E=i+48|0;F=h+36|0;G=i+52|0;H=i+60|0;I=i+56|0;J=i+64|0;K=h+44|0;L=i+11|0;M=h+40|0;N=h+48|0;O=g+8|0;P=0;do{hrb(g,f[(f[k>>2]|0)+4+(P<<2)>>2]|0);XMa(h,g);Q=f[d>>2]|0;R=b[Q+11>>0]|0;S=R<<24>>24<0;if(S)T=f[Q+4>>2]|0;else T=R&255;if((T|0?(f[O>>2]=f[O>>2]&-3,(Q|0)!=537368):0)?(f[d>>2]=537368,Q|0):0){if(S)cYc(f[Q>>2]|0);cYc(Q)}lYc(i,f[l>>2]|0);f[m>>2]=f[h>>2];Q=f[o>>2]|0;f[n>>2]=Q;f[p>>2]=f[q>>2];f[r>>2]=f[s>>2];f[t>>2]=f[v>>2];f[w>>2]=f[x>>2];f[y>>2]=f[z>>2];f[A>>2]=f[B>>2];f[C>>2]=f[D>>2];S=f[F>>2]|0;f[E>>2]=S;f[G>>2]=p;f[I>>2]=H;f[H>>2]=0;f[J>>2]=0;if(!S)U=Q;else{Q=S+12|0;f[Q>>2]=(f[Q>>2]|0)+1;U=f[o>>2]|0}if((U|0)<3){Q=f[K>>2]|0;S=f[I>>2]|0;f[S>>2]=f[Q>>2];f[S+4>>2]=f[Q+4>>2]}else{f[n>>2]=0;U$(m,h)}aNa(e,a,i,i);Q=f[E>>2]|0;if(Q|0?(S=Q+12|0,Q=f[S>>2]|0,f[S>>2]=Q+-1,(Q|0)==1):0)V$(m);f[E>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[n>>2]|0)>0){Q=f[G>>2]|0;S=0;do{f[Q+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[n>>2]|0))}S=f[I>>2]|0;if((S|0)!=(H|0))wL(S);if((b[L>>0]|0)<0)cYc(f[i>>2]|0);S=f[F>>2]|0;if(S|0?(Q=S+12|0,S=f[Q>>2]|0,f[Q>>2]=S+-1,(S|0)==1):0)V$(h);f[F>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[o>>2]|0)>0){S=f[M>>2]|0;Q=0;do{f[S+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[o>>2]|0))}Q=f[K>>2]|0;if((Q|0)!=(N|0))wL(Q);P=P+1|0}while((P|0)<(f[j>>2]|0));Ynb(g);u=c;return}function aNa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+16|0;h=g;i=TIa(c,h,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}d=$Xc(84)|0;n=d+16|0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];f[n+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;n=e+12|0;f[d+28>>2]=f[n>>2];o=e+16|0;p=f[o>>2]|0;f[d+32>>2]=p;q=d+36|0;r=e+20|0;f[q>>2]=f[r>>2];f[d+40>>2]=f[e+24>>2];f[d+44>>2]=f[e+28>>2];f[d+48>>2]=f[e+32>>2];f[d+52>>2]=f[e+36>>2];f[d+56>>2]=f[e+40>>2];f[d+60>>2]=f[e+44>>2];f[d+64>>2]=f[e+48>>2];s=d+68|0;f[s>>2]=q;q=d+72|0;t=d+76|0;f[q>>2]=t;v=d+80|0;f[v>>2]=0;f[t>>2]=0;w=e+56|0;if((p|0)<3){p=f[w>>2]|0;f[t>>2]=f[p>>2];f[v>>2]=f[p+4>>2]}else{f[q>>2]=f[w>>2];q=e+52|0;f[s>>2]=f[q>>2];f[w>>2]=e+60;f[q>>2]=r}f[n>>2]=1124007936;n=o;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));n=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=n;f[i>>2]=d;n=f[f[c>>2]>>2]|0;if(!n)x=d;else{f[c>>2]=n;x=f[i>>2]|0}UQ(f[c+4>>2]|0,x);x=c+8|0;f[x>>2]=(f[x>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}function bNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;c=u;u=u+352|0;e=c+184|0;g=c+56|0;h=c+340|0;i=c;j=c+328|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));m=d+52|0;if((f[m>>2]|0)<=0){u=c;return}o=d+60|0;q=g+88|0;r=h+11|0;s=h+4|0;t=g+28|0;v=e+11|0;w=e+8|0;x=g+36|0;y=e+11|0;z=e+8|0;A=e+11|0;B=e+8|0;C=e+11|0;D=e+8|0;E=d+68|0;d=e+4|0;F=e+8|0;G=i+11|0;H=i+8|0;I=j+4|0;K=e+8|0;L=e+11|0;M=e+5|0;N=e+11|0;O=e+5|0;P=e+11|0;Q=e+5|0;R=e+11|0;S=e+5|0;T=g+92|0;U=e+11|0;V=e+8|0;W=e+11|0;X=e+8|0;Y=e+11|0;Z=e+10|0;_=e+11|0;$=e+10|0;aa=g+8|0;ba=g+16|0;ca=g+24|0;da=e+4|0;ea=i+4|0;fa=i+8|0;ga=j+4|0;ha=j+8|0;ia=e+4|0;ja=j+8|0;ka=g+104|0;la=a+16|0;ma=a+20|0;na=a+12|0;oa=i+36|0;pa=i+16|0;qa=i+4|0;ra=i+40|0;sa=i+44|0;ta=i+48|0;ua=i+8|0;va=i+12|0;wa=i+20|0;xa=i+24|0;ya=i+28|0;za=i+32|0;Aa=g+120|0;Ba=g+112|0;Ca=0;a:while(1){crb(g,f[(f[o>>2]|0)+4+(Ca<<2)>>2]|0);lYc(h,f[q>>2]|0);Da=b[r>>0]|0;Ea=f[s>>2]|0;do if(((Da<<24>>24<0?Ea:Da&255)|0)==12){if(LYc(h,0,-1,390005,12)|0){Fa=b[r>>0]|0;Ga=f[s>>2]|0;Ha=13;break}if((f[t>>2]|0)!=2){Ha=7;break a};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[v>>0]=8;Ia=e;f[Ia>>2]=1852990827;f[Ia+4>>2]=1751084133;b[w>>0]=0;Ia=(f[x>>2]|0)+8|0;Ja=f[Ia>>2]|0;Ka=f[Ia+4>>2]|0;Ia=d1c(Ja|0,Ka|0,-2147483648,0)|0;La=J;f[i>>2]=La>>>0<1|(La|0)==1&Ia>>>0<0?Ja:(Ka|0)>0|(Ka|0)==0&Ja>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[v>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[y>>0]=8;Ja=e;f[Ja>>2]=1852990827;f[Ja+4>>2]=2002742373;b[z>>0]=0;Ja=(f[x>>2]|0)+16|0;Ka=f[Ja>>2]|0;Ia=f[Ja+4>>2]|0;Ja=d1c(Ka|0,Ia|0,-2147483648,0)|0;La=J;f[i>>2]=La>>>0<1|(La|0)==1&Ja>>>0<0?Ka:(Ia|0)>0|(Ia|0)==0&Ka>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[y>>0]|0)<0)cYc(f[e>>2]|0)}else{Fa=Da;Ga=Ea;Ha=13}while(0);b:do if((Ha|0)==13){Ha=0;do if(((Fa<<24>>24<0?Ga:Fa&255)|0)==7){if(LYc(h,0,-1,390066,7)|0){Ma=b[r>>0]|0;Na=f[s>>2]|0;break}if((f[t>>2]|0)!=2){Ha=17;break a};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[A>>0]=8;Ea=e;f[Ea>>2]=1769108595;f[Ea+4>>2]=1751082340;b[B>>0]=0;Ea=(f[x>>2]|0)+8|0;Da=f[Ea>>2]|0;Ka=f[Ea+4>>2]|0;Ea=d1c(Da|0,Ka|0,-2147483648,0)|0;Ia=J;f[i>>2]=Ia>>>0<1|(Ia|0)==1&Ea>>>0<0?Da:(Ka|0)>0|(Ka|0)==0&Da>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[A>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[C>>0]=8;Da=e;f[Da>>2]=1769108595;f[Da+4>>2]=2002740580;b[D>>0]=0;Da=(f[x>>2]|0)+16|0;Ka=f[Da>>2]|0;Ea=f[Da+4>>2]|0;Da=d1c(Ka|0,Ea|0,-2147483648,0)|0;Ia=J;f[i>>2]=Ia>>>0<1|(Ia|0)==1&Da>>>0<0?Ka:(Ea|0)>0|(Ea|0)==0&Ka>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[C>>0]|0)<0)cYc(f[e>>2]|0);break b}else{Ma=Fa;Na=Ga}while(0);do if(((Ma<<24>>24<0?Na:Ma&255)|0)==4){if(LYc(h,0,-1,390074,4)|0){Oa=b[r>>0]|0;Pa=f[s>>2]|0;break}Ka=f[E>>2]|0;Ea=b[Ka+11>>0]|0;if(((Ea<<24>>24<0?f[Ka+4>>2]|0:Ea&255)|0)==3){Ea=(LYc(Ka,0,-1,390079,3)|0)==0;Ka=f[t>>2]|0;if(Ea){if(Ka&1|0){Ha=30;break a}Ea=(Ka|0)/2|0;f[e>>2]=0;f[d>>2]=0;f[F>>2]=0;cKa(e,Ka);if((Ka|0)>1){Da=0;do{Ia=f[x>>2]|0;Ja=f[Ia+8+(Da<<3)>>2]|0;f[i>>2]=Ja;La=f[d>>2]|0;Qa=f[K>>2]|0;if(La>>>0<Qa>>>0){f[La>>2]=Ja;Ja=La+4|0;f[d>>2]=Ja;Ra=Ia;Sa=Ja;Ta=Qa}else{LA(e,i);Ra=f[x>>2]|0;Sa=f[d>>2]|0;Ta=f[K>>2]|0}Qa=f[Ra+8+(Da+Ea<<3)>>2]|0;f[i>>2]=Qa;if(Sa>>>0<Ta>>>0){f[Sa>>2]=Qa;f[d>>2]=Sa+4}else LA(e,i);Da=Da+1|0}while((Da|0)<(Ea|0))};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[G>>0]=8;Ea=i;f[Ea>>2]=1684300144;f[Ea+4>>2]=1936158313;b[H>>0]=0;Ea=f[e>>2]|0;Da=(f[d>>2]|0)-Ea|0;Qa=Da>>2;Ja=$Xc(16)|0;Ia=Ja+8|0;f[Ja>>2]=Ia;f[Ja+4>>2]=Qa;if(Qa>>>0>1){La=bYc(Qa>>>0>536870911?-1:Qa<<3)|0;f[Ja>>2]=La;Ua=La}else Ua=Ia;f[j>>2]=0;f[I>>2]=Ja;if((Da|0)>0){Da=Ea;Ea=0;while(1){Ja=f[Da>>2]|0;Ia=Ua+(Ea<<3)|0;f[Ia>>2]=Ja;f[Ia+4>>2]=((Ja|0)<0)<<31>>31;Ea=Ea+1|0;if((Ea|0)==(Qa|0))break;else Da=Da+4|0}}$Ga(a,i,j)|0;RGa(j);if((b[G>>0]|0)<0)cYc(f[i>>2]|0);Da=f[e>>2]|0;if(Da|0){Qa=f[d>>2]|0;if((Qa|0)!=(Da|0))f[d>>2]=Qa+(~((Qa+-4-Da|0)>>>2)<<2);cYc(Da)}break b}else Va=Ka}else Va=f[t>>2]|0;if((Va|0)!=4){Ha=51;break a};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[L>>0]=5;b[e>>0]=b[446791]|0;b[e+1>>0]=b[446792]|0;b[e+2>>0]=b[446793]|0;b[e+3>>0]=b[446794]|0;b[e+4>>0]=b[446795]|0;b[M>>0]=0;Da=(f[x>>2]|0)+8|0;Qa=f[Da>>2]|0;Ea=f[Da+4>>2]|0;Da=d1c(Qa|0,Ea|0,-2147483648,0)|0;Ja=J;f[i>>2]=Ja>>>0<1|(Ja|0)==1&Da>>>0<0?Qa:(Ea|0)>0|(Ea|0)==0&Qa>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[L>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[N>>0]=5;b[e>>0]=b[446785]|0;b[e+1>>0]=b[446786]|0;b[e+2>>0]=b[446787]|0;b[e+3>>0]=b[446788]|0;b[e+4>>0]=b[446789]|0;b[O>>0]=0;Qa=(f[x>>2]|0)+16|0;Ea=f[Qa>>2]|0;Da=f[Qa+4>>2]|0;Qa=d1c(Ea|0,Da|0,-2147483648,0)|0;Ja=J;f[i>>2]=Ja>>>0<1|(Ja|0)==1&Qa>>>0<0?Ea:(Da|0)>0|(Da|0)==0&Ea>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[N>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[P>>0]=5;b[e>>0]=b[446803]|0;b[e+1>>0]=b[446804]|0;b[e+2>>0]=b[446805]|0;b[e+3>>0]=b[446806]|0;b[e+4>>0]=b[446807]|0;b[Q>>0]=0;Ea=(f[x>>2]|0)+24|0;Da=f[Ea>>2]|0;Qa=f[Ea+4>>2]|0;Ea=d1c(Da|0,Qa|0,-2147483648,0)|0;Ja=J;f[i>>2]=Ja>>>0<1|(Ja|0)==1&Ea>>>0<0?Da:(Qa|0)>0|(Qa|0)==0&Da>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[P>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[R>>0]=5;b[e>>0]=b[446797]|0;b[e+1>>0]=b[446798]|0;b[e+2>>0]=b[446799]|0;b[e+3>>0]=b[446800]|0;b[e+4>>0]=b[446801]|0;b[S>>0]=0;Da=(f[x>>2]|0)+32|0;Qa=f[Da>>2]|0;Ea=f[Da+4>>2]|0;Da=d1c(Qa|0,Ea|0,-2147483648,0)|0;Ja=J;f[i>>2]=Ja>>>0<1|(Ja|0)==1&Da>>>0<0?Qa:(Ea|0)>0|(Ea|0)==0&Qa>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[R>>0]|0)<0)cYc(f[e>>2]|0);break b}else{Oa=Ma;Pa=Na}while(0);do if(((Oa<<24>>24<0?Pa:Oa&255)|0)==8){if(LYc(h,0,-1,390153,8)|0){Wa=b[r>>0]|0;Xa=f[s>>2]|0;break}Qa=f[T>>2]|0;Ea=b[Qa+11>>0]|0;Da=f[Qa+4>>2]|0;if(((Ea<<24>>24<0?Da:Ea&255)|0)==10){if(LYc(Qa,0,-1,390162,10)|0){Ja=f[T>>2]|0;Ya=b[Ja+11>>0]|0;Za=f[Ja+4>>2]|0;_a=Ja;Ha=67}}else{Ya=Ea;Za=Da;_a=Qa;Ha=67}do if((Ha|0)==67){Ha=0;if(((Ya<<24>>24<0?Za:Ya&255)|0)==10){if(!(LYc(_a,0,-1,390173,10)|0))break;Qa=f[T>>2]|0;$a=b[Qa+11>>0]|0;ab=f[Qa+4>>2]|0;bb=Qa}else{$a=Ya;ab=Za;bb=_a}if((($a<<24>>24<0?ab:$a&255)|0)!=5)break b;if(LYc(bb,0,-1,453585,5)|0)break b;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[W>>0]=8;Qa=e;f[Qa>>2]=1600414064;f[Qa+4>>2]=1701080941;b[X>>0]=0;cNa(a,e,453585)|0;if((b[W>>0]|0)<0)cYc(f[e>>2]|0);break b}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[U>>0]=8;Ka=e;f[Ka>>2]=1600414064;f[Ka+4>>2]=1701080941;b[V>>0]=0;MIa(a,e,453591)|0;if((b[U>>0]|0)<0)cYc(f[e>>2]|0);break b}else{Wa=Oa;Xa=Pa}while(0);if(((Wa<<24>>24<0?Xa:Wa&255)|0)==9?(LYc(h,0,-1,390184,9)|0)==0:0){if((f[t>>2]|0)!=2){Ha=81;break a}b[Y>>0]=10;k=e;cb=390194;l=k+10|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[Z>>0]=0;Ka=(f[x>>2]|0)+8|0;Qa=f[Ka>>2]|0;Da=f[Ka+4>>2]|0;Ka=d1c(Qa|0,Da|0,-2147483648,0)|0;Ea=J;f[i>>2]=Ea>>>0<1|(Ea|0)==1&Ka>>>0<0?Qa:(Da|0)>0|(Da|0)==0&Qa>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[Y>>0]|0)<0)cYc(f[e>>2]|0);b[_>>0]=10;k=e;cb=390205;l=k+10|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[$>>0]=0;Qa=(f[x>>2]|0)+16|0;Da=f[Qa>>2]|0;Ka=f[Qa+4>>2]|0;Qa=d1c(Da|0,Ka|0,-2147483648,0)|0;Ea=J;f[i>>2]=Ea>>>0<1|(Ea|0)==1&Qa>>>0<0?Da:(Ka|0)>0|(Ka|0)==0&Da>>>0>0?2147483647:-2147483648;aHa(a,e,i)|0;if((b[_>>0]|0)<0)cYc(f[e>>2]|0);break}db=f[aa>>2]|0;if(db&64|0){Da=Ba;Ka=f[Da>>2]|0;Qa=d1c(Ka|0,f[Da+4>>2]|0,-2147483648,0)|0;Da=J;if(Da>>>0>0|(Da|0)==0&Qa>>>0>4294967295){Ha=89;break a}f[e>>2]=Ka;aHa(a,h,e)|0;break}if(db&128|0){f[e>>2]=f[Aa>>2];OGa(a,h,e)|0;break}if(db&2|0){_Ga(a,h,f[T>>2]|0)|0;break}Ka=f[ba>>2]|0;if((Ka|0)>0){Qa=f[ca>>2]|0;Da=$Xc(16)|0;Ea=Da+8|0;f[Da>>2]=Ea;f[Da+4>>2]=Ka;if(Ka>>>0>1){Ja=bYc(Ka>>>0>536870911?-1:Ka<<3)|0;f[Da>>2]=Ja;eb=Ja}else eb=Ea;f[e>>2]=2;f[da>>2]=Da;Da=(Qa|0)==0?0:Qa+4|0;Qa=0;while(1){p[eb+(Qa<<3)>>3]=+n[Da>>2];Qa=Qa+1|0;if((Qa|0)==(Ka|0))break;else Da=Da+4|0}$Ga(a,h,e)|0;RGa(e);break}Da=f[t>>2]|0;if((Da|0)>0){f[i>>2]=0;f[ea>>2]=0;f[fa>>2]=0;_Ma(i,Da);o1c((f[fa>>2]|0)+8|0,(f[x>>2]|0)+8|0,f[t>>2]<<3|0)|0;Da=f[t>>2]|0;f[i>>2]=Da;f[j>>2]=0;f[ga>>2]=0;f[ha>>2]=0;if(!Da){fb=0;gb=0}else{if(Da>>>0>1073741823){Ha=104;break a}Ka=Da<<2;Qa=$Xc(Ka)|0;f[j>>2]=Qa;Ea=Qa+(Da<<2)|0;f[ja>>2]=Ea;g1c(Qa|0,0,Ka|0)|0;f[ga>>2]=Ea;Ea=f[fa>>2]|0;Ka=0;do{Ja=Ea+8+(Ka<<3)|0;Ia=f[Ja>>2]|0;La=d1c(Ia|0,f[Ja+4>>2]|0,-2147483648,0)|0;Ja=J;if(Ja>>>0>0|(Ja|0)==0&La>>>0>4294967295){Ha=107;break a}f[Qa+(Ka<<2)>>2]=Ia;Ka=Ka+1|0}while((Ka|0)<(Da|0));fb=f[t>>2]|0;gb=Qa}Da=f[q>>2]|0;Ka=$Xc(16)|0;Ea=Ka+8|0;f[Ka>>2]=Ea;f[Ka+4>>2]=fb;if(fb>>>0>1){Ia=bYc(fb>>>0>536870911?-1:fb<<3)|0;f[Ka>>2]=Ia;hb=Ia}else hb=Ea;f[e>>2]=0;f[ia>>2]=Ka;if((fb|0)>0){Ka=gb;Ea=0;while(1){Ia=f[Ka>>2]|0;La=hb+(Ea<<3)|0;f[La>>2]=Ia;f[La+4>>2]=((Ia|0)<0)<<31>>31;Ea=Ea+1|0;if((Ea|0)==(fb|0))break;else Ka=Ka+4|0}}$Ga(a,Da,e)|0;RGa(e);Ka=f[j>>2]|0;if(Ka|0){Ea=f[ga>>2]|0;if((Ea|0)!=(Ka|0))f[ga>>2]=Ea+(~((Ea+-4-Ka|0)>>>2)<<2);cYc(Ka)}Ka=f[fa>>2]|0;do if(Ka|0){if(f[Ka>>2]|0)break;cYc(Ka)}while(0);break}else{if(!(db&16)){Ha=140;break a}Ka=f[ka>>2]|0;drb(e,Ka|0?Ka:536304);XMa(i,e);Ka=f[la>>2]|0;if((Ka|0)==(f[ma>>2]|0))bx(na,i);else{f[Ka>>2]=f[i>>2];Da=Ka+4|0;f[Da>>2]=f[qa>>2];Ea=Ka+8|0;f[Ea>>2]=f[ua>>2];f[Ka+12>>2]=f[va>>2];f[Ka+16>>2]=f[pa>>2];f[Ka+20>>2]=f[wa>>2];f[Ka+24>>2]=f[xa>>2];f[Ka+28>>2]=f[ya>>2];f[Ka+32>>2]=f[za>>2];Qa=f[oa>>2]|0;f[Ka+36>>2]=Qa;f[Ka+40>>2]=Ea;Ea=Ka+48|0;Ia=Ka+44|0;f[Ia>>2]=Ea;f[Ea>>2]=0;f[Ka+52>>2]=0;if(Qa|0){Ea=Qa+12|0;f[Ea>>2]=(f[Ea>>2]|0)+1}if((f[qa>>2]|0)<3){Ea=f[sa>>2]|0;Qa=f[Ia>>2]|0;f[Qa>>2]=f[Ea>>2];f[Qa+4>>2]=f[Ea+4>>2]}else{f[Da>>2]=0;U$(Ka,i)}f[la>>2]=(f[la>>2]|0)+56}Ka=f[oa>>2]|0;if(Ka|0?(Da=Ka+12|0,Ka=f[Da>>2]|0,f[Da>>2]=Ka+-1,(Ka|0)==1):0)V$(i);f[oa>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[qa>>2]|0)>0){Ka=f[ra>>2]|0;Da=0;do{f[Ka+(Da<<2)>>2]=0;Da=Da+1|0}while((Da|0)<(f[qa>>2]|0))}Da=f[sa>>2]|0;if((Da|0)!=(ta|0))wL(Da);Ynb(e);break}}while(0);if((b[r>>0]|0)<0)cYc(f[h>>2]|0);Klb(g);Ca=Ca+1|0;if((Ca|0)>=(f[m>>2]|0)){Ha=149;break}}switch(Ha|0){case 7:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ha=$Xc(48)|0;f[e>>2]=Ha;f[e+8>>2]=-2147483600;f[e+4>>2]=32;k=Ha;cb=390018;l=k+32|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[Ha+32>>0]=0;vM(-215,e,390051,389834,166);break}case 17:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ha=$Xc(48)|0;f[e>>2]=Ha;f[e+8>>2]=-2147483600;f[e+4>>2]=32;k=Ha;cb=390018;l=k+32|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[Ha+32>>0]=0;vM(-215,e,390051,389834,172);break}case 30:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ha=$Xc(48)|0;f[e>>2]=Ha;f[e+8>>2]=-2147483600;f[e+4>>2]=36;k=Ha;cb=390083;l=k+36|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[Ha+36>>0]=0;vM(-215,e,390051,389834,183);break}case 51:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ha=$Xc(48)|0;f[e>>2]=Ha;f[e+8>>2]=-2147483600;f[e+4>>2]=32;k=Ha;cb=390120;l=k+32|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[Ha+32>>0]=0;vM(-215,e,390051,389834,197);break}case 81:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ha=$Xc(48)|0;f[e>>2]=Ha;f[e+8>>2]=-2147483600;f[e+4>>2]=32;k=Ha;cb=390018;l=k+32|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[Ha+32>>0]=0;vM(-215,e,390051,389834,215);break}case 89:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ha=$Xc(48)|0;f[e>>2]=Ha;f[e+8>>2]=-2147483600;f[e+4>>2]=32;k=Ha;cb=389928;l=k+32|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[Ha+32>>0]=0;vM(-211,e,390051,389834,223);break}case 104:{kWc(j);break}case 107:{j=$Xc(48)|0;f[e>>2]=j;f[e+8>>2]=-2147483600;f[e+4>>2]=32;k=j;cb=389928;l=k+32|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[j+32>>0]=0;vM(-211,e,389961,389834,82);break}case 140:{if(db&32|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ib=$Xc(32)|0;f[e>>2]=ib;jb=e+8|0;f[jb>>2]=-2147483616;kb=e+4|0;f[kb>>2]=25;k=ib;cb=390216;l=k+25|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));lb=ib+25|0;b[lb>>0]=0;vM(-213,e,390051,389834,256)}if((f[g+44>>2]|0)>0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ib=$Xc(32)|0;f[e>>2]=ib;jb=e+8|0;f[jb>>2]=-2147483616;kb=e+4|0;f[kb>>2]=25;k=ib;cb=390216;l=k+25|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));lb=ib+25|0;b[lb>>0]=0;vM(-213,e,390051,389834,256)}if((f[g+60>>2]|0)>0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ib=$Xc(32)|0;f[e>>2]=ib;jb=e+8|0;f[jb>>2]=-2147483616;kb=e+4|0;f[kb>>2]=25;k=ib;cb=390216;l=k+25|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));lb=ib+25|0;b[lb>>0]=0;vM(-213,e,390051,389834,256)}if((f[g+76>>2]|0)>0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ib=$Xc(32)|0;f[e>>2]=ib;jb=e+8|0;f[jb>>2]=-2147483616;kb=e+4|0;f[kb>>2]=25;k=ib;cb=390216;l=k+25|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));lb=ib+25|0;b[lb>>0]=0;vM(-213,e,390051,389834,256)}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;lb=$Xc(32)|0;f[e>>2]=lb;f[e+8>>2]=-2147483616;f[e+4>>2]=26;k=lb;cb=390242;l=k+26|0;do{b[k>>0]=b[cb>>0]|0;k=k+1|0;cb=cb+1|0}while((k|0)<(l|0));b[lb+26>>0]=0;vM(-213,e,390051,389834,259)}break}case 149:{u=c;return}}}function cNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+40|0;h=e+28|0;i=e+8|0;j=e;k=TGa(a,c)|0;if((k|0)!=(a+4|0)){f[g>>2]=3;l=$Xc(20)|0;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[l>>2]=m;f[l+4>>2]=1;f[g+4>>2]=l;tYc(m,d)|0;UGa(k+28|0,g)|0;RGa(g);u=e;return d|0}f[j>>2]=3;k=$Xc(20)|0;m=k+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[k>>2]=m;f[k+4>>2]=1;f[j+4>>2]=k;tYc(m,d)|0;lYc(i,c);c=i+12|0;VGa(c,j);m=WGa(a,g,i)|0;if(!(f[m>>2]|0)){XGa(h,a,i);k=f[g>>2]|0;g=f[h>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=k;f[m>>2]=g;k=f[f[a>>2]>>2]|0;if(!k)n=g;else{f[a>>2]=k;n=f[m>>2]|0}UQ(f[a+4>>2]|0,n);n=a+8|0;f[n>>2]=(f[n>>2]|0)+1}RGa(c);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);RGa(j);u=e;return d|0}function dNa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;h=c+12|0;i=c;if((f[d+20>>2]|0)<=(g|0)){j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=31;k=j;l=390269;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+31>>0]=0;vM(-215,h,393368,389834,267)}j=d+28|0;d=eNa(e,f[(f[j>>2]|0)+4+(g<<2)>>2]|0)|0;if((d|0)==(e+4|0)){SGa(i,390301,f[(f[j>>2]|0)+4+(g<<2)>>2]|0);g=AYc(i,390307)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-204,h,393368,389834,272)}h=d+28|0;f[a>>2]=f[h>>2];g=a+4|0;i=d+32|0;f[g>>2]=f[i>>2];j=a+8|0;f[j>>2]=f[d+36>>2];f[a+12>>2]=f[d+40>>2];f[a+16>>2]=f[d+44>>2];f[a+20>>2]=f[d+48>>2];f[a+24>>2]=f[d+52>>2];f[a+28>>2]=f[d+56>>2];f[a+32>>2]=f[d+60>>2];e=f[d+64>>2]|0;f[a+36>>2]=e;f[a+40>>2]=j;j=a+48|0;l=a+44|0;f[l>>2]=j;f[j>>2]=0;f[a+52>>2]=0;if(e|0){j=e+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[d+72>>2]|0;d=f[l>>2]|0;f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];u=c;return}else{f[g>>2]=0;U$(a,h);u=c;return}}function eNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function fNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+48|0;d=a;e=a+36|0;g=a+24|0;h=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=8;j=d;f[j>>2]=1600414064;f[j+4>>2]=1701080941;b[d+8>>0]=0;j=(HIa(c,d)|0)==0;if((b[i>>0]|0)<0)cYc(f[d>>2]|0);if(!j){k=1;u=a;return k|0};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[390333]|0;b[d+1>>0]=b[390334]|0;b[d+2>>0]=b[390335]|0;b[d+3>>0]=b[390336]|0;b[d+4>>0]=b[390337]|0;b[d+5>>0]=0;i=(HIa(c,d)|0)==0;if((b[j>>0]|0)<0)cYc(f[d>>2]|0);if(i){k=0;u=a;return k|0};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;i=d+11|0;b[i>>0]=5;b[d>>0]=b[390333]|0;b[d+1>>0]=b[390334]|0;b[d+2>>0]=b[390335]|0;b[d+3>>0]=b[390336]|0;b[d+4>>0]=b[390337]|0;b[d+5>>0]=0;j=MGa(NIa(c,d)|0,-1)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=e+11|0;b[l>>0]=5;b[e>>0]=b[446803]|0;b[e+1>>0]=b[446804]|0;b[e+2>>0]=b[446805]|0;b[e+3>>0]=b[446806]|0;b[e+4>>0]=b[446807]|0;b[e+5>>0]=0;m=MGa(NIa(c,e)|0,-1)|0;if((j|0)==(m|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=g+11|0;b[m>>0]=5;b[g>>0]=b[390339]|0;b[g+1>>0]=b[390340]|0;b[g+2>>0]=b[390341]|0;b[g+3>>0]=b[390342]|0;b[g+4>>0]=b[390343]|0;b[g+5>>0]=0;j=MGa(NIa(c,g)|0,-1)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;n=h+11|0;b[n>>0]=5;b[h>>0]=b[446797]|0;b[h+1>>0]=b[446798]|0;b[h+2>>0]=b[446799]|0;b[h+3>>0]=b[446800]|0;b[h+4>>0]=b[446801]|0;b[h+5>>0]=0;o=MGa(NIa(c,h)|0,-1)|0;if((b[n>>0]|0)<0)cYc(f[h>>2]|0);if((b[m>>0]|0)<0)cYc(f[g>>2]|0);p=(j|0)!=(o|0)}else p=1;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);if((b[i>>0]|0)<0)cYc(f[d>>2]|0);k=p;u=a;return k|0}function gNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0.0,hk=0.0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0;d=u;u=u+1168|0;e=d+1104|0;g=d+608|0;h=d+600|0;i=d+592|0;j=d+584|0;k=d+576|0;l=d+992|0;m=d+980|0;o=d+968|0;q=d+956|0;r=d+944|0;s=d+896|0;t=d+816|0;v=d+804|0;w=d+736|0;x=d+352|0;y=d+72|0;z=d+680|0;A=d;B=d+128|0;C=d+1096|0;D=d+612|0;E=a+8|0;if(!(f[E>>2]&16)){F=$Xc(32)|0;f[e>>2]=F;f[e+8>>2]=-2147483616;f[e+4>>2]=23;G=F;H=390345;I=G+23|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[F+23>>0]=0;vM(-215,e,390369,389834,292)}F=f[a+64>>2]|0;erb(l,F|0?F:536168);$Ma(m,0,l);f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;if(f[E>>2]&1|0)oYc(o,f[a+48>>2]|0)|0;a=q+4|0;f[a>>2]=0;E=q+8|0;f[E>>2]=0;F=q+4|0;f[q>>2]=F;f[r>>2]=0;J=r+4|0;f[J>>2]=0;f[r+8>>2]=0;K=l+52|0;if((f[K>>2]|0)>0){L=l+60|0;M=m+4|0;N=r+8|0;O=s+12|0;P=s+11|0;Q=0;do{R=f[(f[(f[L>>2]|0)+4+(Q<<2)>>2]|0)+16>>2]|0;if((DIa(m,R)|0)==(M|0)){S=f[J>>2]|0;if((S|0)==(f[N>>2]|0)){NN(r,R);T=f[J>>2]|0}else{lYc(S,R);S=(f[J>>2]|0)+12|0;f[J>>2]=S;T=S}S=f[r>>2]|0;lYc(s,R);R=O;f[R>>2]=0;f[R+4>>2]=((T-S|0)/12|0)+-1;S=hNa(q,e,s)|0;if(!(f[S>>2]|0)){R=$Xc(36)|0;U=R+16|0;f[U>>2]=f[s>>2];f[U+4>>2]=f[s+4>>2];f[U+8>>2]=f[s+8>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;U=O;V=f[U+4>>2]|0;W=R+28|0;f[W>>2]=f[U>>2];f[W+4>>2]=V;V=f[e>>2]|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=V;f[S>>2]=R;V=f[f[q>>2]>>2]|0;if(!V)X=R;else{f[q>>2]=V;X=f[S>>2]|0}UQ(f[a>>2]|0,X);f[E>>2]=(f[E>>2]|0)+1}if((b[P>>0]|0)<0)cYc(f[s>>2]|0)}Q=Q+1|0}while((Q|0)<(f[K>>2]|0))}lQa(c,r);K=f[l+20>>2]|0;Q=s+4|0;f[Q>>2]=0;P=s+8|0;f[P>>2]=0;X=s+4|0;f[s>>2]=X;O=s+12|0;G=O;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));Vpb(t);a:do if((K|0)>0){T=l+28|0;N=e+36|0;M=N+11|0;L=e+24|0;S=L+11|0;V=e+12|0;R=e+4|0;W=t+36|0;U=t+44|0;Z=s+24|0;_=t+68|0;$=s+36|0;aa=v+11|0;ba=v+4|0;ca=e+11|0;da=e+4|0;ea=e+11|0;fa=e+9|0;ga=w+12|0;ha=w+11|0;ia=t+20|0;ja=t+28|0;ka=e+11|0;la=e+4|0;ma=e+11|0;na=e+9|0;oa=e+8|0;pa=e+4|0;qa=o+11|0;ra=o+4|0;sa=e+11|0;ta=e+11|0;ua=e+4|0;va=e+8|0;wa=e+4|0;xa=e+11|0;ya=e+36|0;za=e+16|0;Aa=e+4|0;Ba=e+40|0;Ca=w+4|0;Da=w+8|0;Ea=e+8|0;Fa=w+12|0;Ga=e+12|0;Ha=w+16|0;Ia=w+20|0;Ja=e+20|0;Ka=w+24|0;La=e+24|0;Ma=w+28|0;Na=e+28|0;Oa=w+32|0;Pa=e+32|0;Qa=w+36|0;Ra=e+44|0;Sa=e+48|0;Ta=w+44|0;Ua=w+40|0;Va=w+48|0;Wa=w+11|0;Xa=w+5|0;Ya=e+44|0;Za=s+16|0;_a=s+20|0;$a=s+12|0;ab=e+40|0;bb=e+4|0;cb=e+8|0;db=e+40|0;eb=e+48|0;fb=e+44|0;gb=e+52|0;hb=w+36|0;ib=w+16|0;jb=w+4|0;kb=w+40|0;lb=w+44|0;mb=w+48|0;nb=e+36|0;ob=e+16|0;pb=w+4|0;qb=w+8|0;rb=w+12|0;sb=e+12|0;tb=w+16|0;ub=w+20|0;vb=e+20|0;wb=w+24|0;xb=e+24|0;yb=w+28|0;zb=e+28|0;Ab=w+32|0;Bb=e+32|0;Cb=w+36|0;Db=e+44|0;Eb=w+44|0;Fb=w+40|0;Gb=w+48|0;Hb=w+11|0;Ib=w+5|0;Jb=e+40|0;Kb=w+12|0;Lb=w+16|0;Mb=w+20|0;Nb=w+24|0;Ob=w+28|0;Pb=w+32|0;Qb=w+36|0;Rb=w+40|0;Sb=w+44|0;Tb=w+48|0;Ub=w+52|0;Vb=w+60|0;Wb=w+56|0;Xb=w+64|0;Yb=w+11|0;Zb=e+11|0;_b=e+5|0;$b=e+11|0;ac=e+5|0;bc=e+11|0;cc=e+4|0;dc=e+11|0;ec=e+5|0;fc=z+11|0;gc=z+4|0;hc=A+8|0;ic=y+4|0;jc=y+8|0;kc=y+40|0;lc=y+48|0;mc=y+44|0;nc=y+52|0;oc=e+4|0;pc=y+12|0;qc=y+16|0;rc=y+20|0;sc=y+24|0;tc=y+28|0;uc=y+32|0;vc=y+36|0;wc=y+44|0;xc=e+11|0;yc=e+9|0;zc=z+11|0;Ac=z+4|0;Bc=y+4|0;Cc=y+8|0;Dc=y+40|0;Ec=y+48|0;Fc=y+44|0;Gc=y+52|0;Hc=y+12|0;Ic=e+11|0;Jc=e+4|0;Kc=y+16|0;Lc=e+11|0;Mc=e+4|0;Nc=y+36|0;Oc=y+20|0;Pc=y+24|0;Qc=y+28|0;Rc=y+32|0;Sc=y+11|0;Tc=y+5|0;Uc=e+11|0;Vc=e+5|0;Wc=w+8|0;Xc=w+4|0;Yc=w+11|0;Zc=e+11|0;_c=e+4|0;$c=w+11|0;ad=w+10|0;bd=e+11|0;cd=e+7|0;dd=w+11|0;ed=w+3|0;fd=e+11|0;gd=e+7|0;hd=w+8|0;id=w+4|0;jd=w+11|0;kd=y+11|0;ld=y+10|0;md=y+11|0;nd=y+8|0;od=w+36|0;pd=w+16|0;qd=w+4|0;rd=w+40|0;sd=w+44|0;td=w+48|0;ud=e+36|0;vd=e+16|0;wd=e+4|0;xd=e+40|0;yd=e+44|0;zd=e+48|0;Ad=y+11|0;Bd=y+8|0;Cd=y+4|0;Dd=y+8|0;Ed=y+12|0;Fd=y+16|0;Gd=y+20|0;Hd=y+24|0;Id=y+28|0;Jd=y+32|0;Kd=y+36|0;Ld=y+44|0;Md=y+40|0;Nd=y+48|0;Od=y+44|0;Pd=y+11|0;Qd=y+10|0;Rd=y+4|0;Sd=y+8|0;Td=y+12|0;Ud=y+16|0;Vd=y+20|0;Wd=y+24|0;Xd=y+28|0;Yd=y+32|0;Zd=y+36|0;_d=y+44|0;$d=y+40|0;ae=y+48|0;be=y+44|0;ce=w+8|0;de=w+12|0;ee=w+20|0;fe=w+24|0;ge=w+28|0;he=w+32|0;ie=e+8|0;je=e+12|0;ke=e+20|0;le=e+24|0;me=e+28|0;ne=e+32|0;oe=w+11|0;pe=w+6|0;qe=w+8|0;re=w+12|0;se=w+4|0;te=y+8|0;ue=y+4|0;ve=w+36|0;we=w+16|0;xe=w+4|0;ye=w+40|0;ze=w+44|0;Ae=w+48|0;Be=w+8|0;Ce=w+12|0;De=w+20|0;Ee=w+24|0;Fe=w+28|0;Ge=w+32|0;He=w+11|0;Ie=w+10|0;Je=w+11|0;Ke=w+9|0;Le=e+36|0;Me=e+16|0;Ne=e+4|0;Oe=e+40|0;Pe=e+44|0;Qe=e+48|0;Re=e+8|0;Se=e+12|0;Te=e+20|0;Ue=e+24|0;Ve=e+28|0;We=e+32|0;Xe=y+11|0;Ye=y+6|0;Ze=w+4|0;_e=w+8|0;$e=w+40|0;af=w+48|0;bf=w+44|0;cf=w+52|0;df=w+12|0;ef=w+16|0;ff=w+20|0;gf=w+24|0;hf=w+28|0;jf=w+32|0;kf=w+36|0;lf=w+44|0;mf=w+11|0;nf=w+9|0;of=w+11|0;pf=w+10|0;qf=e+36|0;rf=e+16|0;sf=e+4|0;tf=e+40|0;uf=e+44|0;vf=e+48|0;wf=e+36|0;xf=e+16|0;yf=e+4|0;zf=e+40|0;Af=w+4|0;Bf=w+8|0;Cf=e+8|0;Df=w+12|0;Ef=e+12|0;Ff=w+16|0;Gf=w+20|0;Hf=e+20|0;If=w+24|0;Jf=e+24|0;Kf=w+28|0;Lf=e+28|0;Mf=w+32|0;Nf=e+32|0;Of=w+36|0;Pf=e+44|0;Qf=e+48|0;Rf=w+44|0;Sf=w+40|0;Tf=w+48|0;Uf=w+11|0;Vf=w+5|0;Wf=e+44|0;Xf=e+40|0;Yf=e+11|0;Zf=e+9|0;_f=e+11|0;$f=e+10|0;ag=e+11|0;bg=e+9|0;cg=e+4|0;dg=e+8|0;eg=e+12|0;fg=e+16|0;gg=e+20|0;hg=e+24|0;ig=e+28|0;jg=e+32|0;kg=e+36|0;lg=e+44|0;mg=e+40|0;ng=e+48|0;og=e+44|0;pg=e+11|0;qg=e+10|0;rg=e+11|0;sg=e+9|0;tg=e+4|0;ug=e+8|0;vg=e+12|0;wg=e+16|0;xg=e+20|0;yg=e+24|0;zg=e+28|0;Ag=e+32|0;Bg=e+36|0;Cg=e+44|0;Dg=e+40|0;Eg=e+48|0;Fg=e+44|0;Gg=e+11|0;Hg=e+4|0;Ig=w+11|0;Jg=w+5|0;Kg=e+11|0;Lg=e+4|0;Mg=z+4|0;Ng=z+8|0;Og=w+4|0;Pg=y+4|0;Qg=y+4|0;Rg=D+12|0;Sg=D+16|0;Tg=A+4|0;Ug=D+20|0;Vg=A+8|0;Wg=D+24|0;Xg=A+12|0;Yg=D+28|0;Zg=A+16|0;_g=D+32|0;$g=A+20|0;ah=D+36|0;bh=A+24|0;ch=D+40|0;dh=A+28|0;eh=D+44|0;fh=A+32|0;gh=D+48|0;hh=A+36|0;ih=D+52|0;jh=D+60|0;kh=D+56|0;lh=D+64|0;mh=A+44|0;nh=D+11|0;oh=A+40|0;ph=A+48|0;qh=w+36|0;rh=w+16|0;sh=w+40|0;th=w+44|0;uh=w+48|0;vh=z+8|0;wh=A+4|0;xh=A+8|0;yh=e+8|0;zh=e+4|0;Ah=A+12|0;Bh=A+16|0;Ch=z+4|0;Dh=A+20|0;Eh=z+8|0;Fh=A+24|0;Gh=z+12|0;Hh=A+28|0;Ih=z+16|0;Jh=A+32|0;Kh=z+20|0;Lh=A+36|0;Mh=z+24|0;Nh=A+40|0;Oh=z+28|0;Ph=A+44|0;Qh=z+32|0;Rh=A+48|0;Sh=z+36|0;Th=A+52|0;Uh=A+60|0;Vh=A+56|0;Wh=A+64|0;Xh=z+44|0;Yh=A+11|0;Zh=z+40|0;_h=z+48|0;$h=y+36|0;ai=y+16|0;bi=y+4|0;ci=y+40|0;di=y+44|0;fi=y+48|0;gi=w+36|0;hi=w+16|0;ii=w+4|0;ji=w+40|0;ki=w+44|0;li=w+48|0;mi=e+11|0;ni=e+3|0;oi=w+8|0;pi=w+12|0;qi=y+4|0;ri=e+11|0;si=e+5|0;ti=e+11|0;ui=e+5|0;vi=y+4|0;wi=y+8|0;xi=w+4|0;yi=y+8|0;zi=w+4|0;Ai=D+12|0;Bi=D+16|0;Ci=A+4|0;Di=D+20|0;Ei=A+8|0;Fi=D+24|0;Gi=A+12|0;Hi=D+28|0;Ii=A+16|0;Ji=D+32|0;Ki=A+20|0;Li=D+36|0;Mi=A+24|0;Ni=D+40|0;Oi=A+28|0;Pi=D+44|0;Qi=A+32|0;Ri=D+48|0;Si=A+36|0;Ti=D+52|0;Ui=D+60|0;Vi=D+56|0;Wi=D+64|0;Xi=A+44|0;Yi=D+11|0;Zi=A+40|0;_i=A+48|0;$i=z+36|0;aj=z+16|0;bj=z+4|0;cj=z+40|0;dj=z+44|0;ej=z+48|0;fj=e+11|0;gj=e+5|0;hj=z+11|0;ij=z+3|0;jj=e+4|0;kj=e+8|0;lj=e+12|0;mj=e+16|0;nj=e+20|0;oj=e+24|0;pj=e+28|0;qj=e+32|0;rj=e+36|0;sj=e+44|0;tj=e+40|0;uj=e+48|0;vj=e+44|0;wj=e+52|0;xj=e+52|0;yj=e+8|0;zj=w+4|0;Aj=e+8|0;Bj=e+52|0;Cj=e+4|0;Dj=z+4|0;Ej=0;b:while(1){grb(t,f[(f[T>>2]|0)+4+(Ej<<2)>>2]|0);bNa(e,0,t);jNa(s,e)|0;if((b[M>>0]|0)<0)cYc(f[N>>2]|0);if((b[S>>0]|0)<0)cYc(f[L>>2]|0);hx(V);QGa(e,f[R>>2]|0);if((f[W>>2]|0)<=0){Fj=41;break}oYc(Z,f[(f[U>>2]|0)+4>>2]|0)|0;lYc(v,f[_>>2]|0);oYc($,v)|0;Gj=b[aa>>0]|0;Hj=f[ba>>2]|0;do if(((Gj<<24>>24<0?Hj:Gj&255)|0)==7){if(LYc(v,0,-1,390411,7)|0){Ij=b[aa>>0]|0;Jj=f[ba>>2]|0;Fj=50;break}tYc($,429057)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ca>>0]=4;f[e>>2]=1819242352;b[da>>0]=0;JIa(s,e,390419)|0;if((b[ca>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ea>>0]=9;G=e;H=443519;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[fa>>0]=0;Kj=(fNa(0,s)|0)&1;b[w>>0]=Kj;cHa(s,e,w)|0;if((b[ea>>0]|0)<0)cYc(f[e>>2]|0);Fj=799}else{Ij=Gj;Jj=Hj;Fj=50}while(0);c:do if((Fj|0)==50){Fj=0;do if(((Ij<<24>>24<0?Jj:Ij&255)|0)==11){if(LYc(v,0,-1,390423,11)|0){Lj=b[aa>>0]|0;Mj=f[ba>>2]|0;break}tYc($,429057)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ka>>0]=4;f[e>>2]=1819242352;b[la>>0]=0;JIa(s,e,390435)|0;if((b[ka>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ma>>0]=9;G=e;H=443519;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[na>>0]=0;Hj=(fNa(0,s)|0)&1;b[w>>0]=Hj;cHa(s,e,w)|0;if((b[ma>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Hj=$Xc(32)|0;f[e>>2]=Hj;f[oa>>2]=-2147483616;f[pa>>2]=20;G=Hj;H=443543;I=G+20|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Hj+20>>0]=0;Gj=b[qa>>0]|0;if(((Gj<<24>>24<0?f[ra>>2]|0:Gj&255)|0)==7)Nj=(LYc(o,0,-1,390439,7)|0)==0;else Nj=0;b[w>>0]=Nj&1;cHa(s,e,w)|0;if((b[sa>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}else{Lj=Ij;Mj=Jj}while(0);do if(((Lj<<24>>24<0?Mj:Lj&255)|0)==17){if(LYc(v,0,-1,390447,17)|0){Oj=b[aa>>0]|0;Pj=f[ba>>2]|0;break}tYc($,429057)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ta>>0]=4;f[e>>2]=1819242352;b[ua>>0]=0;JIa(s,e,390435)|0;if((b[ta>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Gj=$Xc(16)|0;f[e>>2]=Gj;f[va>>2]=-2147483632;f[wa>>2]=14;G=Gj;H=446919;I=G+14|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Gj+14>>0]=0;b[w>>0]=1;cHa(s,e,w)|0;if((b[xa>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}else{Oj=Lj;Pj=Mj}while(0);if(((Oj<<24>>24<0?Pj:Oj&255)|0)==3){if(LYc(v,0,-1,390465,3)|0){Qj=b[aa>>0]|0;Rj=f[ba>>2]|0;Fj=73}}else{Qj=Oj;Rj=Pj;Fj=73}do if((Fj|0)==73){Fj=0;if(((Qj<<24>>24<0?Rj:Qj&255)|0)==3){if(!(LYc(v,0,-1,390469,3)|0))break;Sj=b[aa>>0]|0;Tj=f[ba>>2]|0}else{Sj=Qj;Tj=Rj}do if(((Sj<<24>>24<0?Tj:Sj&255)|0)==3){if(LYc(v,0,-1,390473,3)|0){Uj=b[aa>>0]|0;Vj=f[ba>>2]|0;break}dNa(w,0,t,m,1);d$(x,-1.0,w);f[e>>2]=1124007936;G=bb;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[db>>2]=cb;f[fb>>2]=eb;f[eb>>2]=0;f[gb>>2]=0;Hj=f[x>>2]|0;ei[f[(f[Hj>>2]|0)+12>>2]&511](Hj,x,e,-1);Zj(x);Hj=f[hb>>2]|0;do if(Hj|0){Kj=Hj+12|0;Wj=f[Kj>>2]|0;f[Kj>>2]=Wj+-1;if((Wj|0)!=1)break;V$(w)}while(0);f[hb>>2]=0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[jb>>2]|0)>0){Hj=f[kb>>2]|0;Wj=0;do{f[Hj+(Wj<<2)>>2]=0;Wj=Wj+1|0}while((Wj|0)<(f[jb>>2]|0))}Wj=f[lb>>2]|0;if((Wj|0)!=(mb|0))wL(Wj);g0(w,e,1,1);Wj=f[nb>>2]|0;do if(Wj|0){Hj=Wj+12|0;Kj=f[Hj>>2]|0;f[Hj>>2]=Kj+-1;if((Kj|0)!=1)break;V$(e)}while(0);f[nb>>2]=0;f[ob>>2]=0;f[ob+4>>2]=0;f[ob+8>>2]=0;f[ob+12>>2]=0;if((f[bb>>2]|0)>0){Wj=f[db>>2]|0;Kj=0;do{f[Wj+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[bb>>2]|0))}f[e>>2]=f[w>>2];Kj=f[pb>>2]|0;f[bb>>2]=Kj;f[cb>>2]=f[qb>>2];f[sb>>2]=f[rb>>2];f[ob>>2]=f[tb>>2];f[vb>>2]=f[ub>>2];f[xb>>2]=f[wb>>2];f[zb>>2]=f[yb>>2];f[Bb>>2]=f[Ab>>2];f[nb>>2]=f[Cb>>2];Wj=f[Db>>2]|0;if((Wj|0)==(eb|0))Xj=Kj;else{wL(Wj);f[Db>>2]=eb;f[db>>2]=cb;Xj=f[pb>>2]|0}if((Xj|0)<3){Wj=f[Eb>>2]|0;f[eb>>2]=f[Wj>>2];f[xj>>2]=f[Wj+4>>2];Yj=Wj}else{f[Db>>2]=f[Eb>>2];f[Jb>>2]=f[Fb>>2];f[Eb>>2]=Gb;f[Fb>>2]=qb;Yj=Gb}f[w>>2]=1124007936;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;f[pb+16>>2]=0;f[pb+20>>2]=0;f[pb+24>>2]=0;f[pb+28>>2]=0;f[Cb>>2]=0;f[tb>>2]=0;f[tb+4>>2]=0;f[tb+8>>2]=0;f[tb+12>>2]=0;if((Yj|0)!=(Gb|0))wL(Yj);Wj=f[bb>>2]|0;if((Wj|0)<3)_j=Y(f[sb>>2]|0,f[cb>>2]|0)|0;else{Kj=f[db>>2]|0;Hj=0;$j=1;while(1){ak=Y(f[Kj+(Hj<<2)>>2]|0,$j)|0;Hj=Hj+1|0;if((Hj|0)==(Wj|0)){_j=ak;break}else $j=ak}}do if((_j|0)==1){tYc($,439430)|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[Hb>>0]=5;b[w>>0]=b[431960]|0;b[w+1>>0]=b[431961]|0;b[w+2>>0]=b[431962]|0;b[w+3>>0]=b[431963]|0;b[w+4>>0]=b[431964]|0;b[Ib>>0]=0;OGa(s,w,f[ob>>2]|0)|0;if((b[Hb>>0]|0)<0)cYc(f[w>>2]|0)}else{tYc($,396723)|0;$j=f[Za>>2]|0;if(($j|0)==(f[_a>>2]|0)){bx($a,e);break}f[$j>>2]=f[e>>2];Wj=$j+4|0;f[Wj>>2]=f[bb>>2];Hj=$j+8|0;f[Hj>>2]=f[cb>>2];f[$j+12>>2]=f[sb>>2];f[$j+16>>2]=f[ob>>2];f[$j+20>>2]=f[vb>>2];f[$j+24>>2]=f[xb>>2];f[$j+28>>2]=f[zb>>2];f[$j+32>>2]=f[Bb>>2];Kj=f[nb>>2]|0;f[$j+36>>2]=Kj;f[$j+40>>2]=Hj;Hj=$j+48|0;ak=$j+44|0;f[ak>>2]=Hj;f[Hj>>2]=0;f[$j+52>>2]=0;if(Kj|0){Hj=Kj+12|0;f[Hj>>2]=(f[Hj>>2]|0)+1}if((f[bb>>2]|0)<3){Hj=f[fb>>2]|0;Kj=f[ak>>2]|0;f[Kj>>2]=f[Hj>>2];f[Kj+4>>2]=f[Hj+4>>2]}else{f[Wj>>2]=0;U$($j,e)}f[Za>>2]=(f[Za>>2]|0)+56}while(0);$j=f[nb>>2]|0;do if($j|0){Wj=$j+12|0;Hj=f[Wj>>2]|0;f[Wj>>2]=Hj+-1;if((Hj|0)!=1)break;V$(e)}while(0);f[nb>>2]=0;f[ob>>2]=0;f[ob+4>>2]=0;f[ob+8>>2]=0;f[ob+12>>2]=0;if((f[bb>>2]|0)>0){$j=f[db>>2]|0;Hj=0;do{f[$j+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[bb>>2]|0))}Hj=f[fb>>2]|0;if((Hj|0)!=(eb|0))wL(Hj);Fj=799;break c}else{Uj=Sj;Vj=Tj}while(0);do if(((Uj<<24>>24<0?Vj:Uj&255)|0)==8){if(LYc(v,0,-1,390477,8)|0){bk=b[aa>>0]|0;ck=f[ba>>2]|0;break}if(f[ia>>2]|0){Fj=169;break b}Gj=f[$a>>2]|0;Hj=Gj;if(((f[Za>>2]|0)-Gj|0)!=56){Fj=171;break b}lYc(w,Z);f[Kb>>2]=f[Hj>>2];Gj=Hj+4|0;$j=f[Gj>>2]|0;f[Lb>>2]=$j;f[Mb>>2]=f[Hj+8>>2];f[Nb>>2]=f[Hj+12>>2];f[Ob>>2]=f[Hj+16>>2];f[Pb>>2]=f[Hj+20>>2];f[Qb>>2]=f[Hj+24>>2];f[Rb>>2]=f[Hj+28>>2];f[Sb>>2]=f[Hj+32>>2];Wj=f[Hj+36>>2]|0;f[Tb>>2]=Wj;f[Ub>>2]=Mb;f[Wb>>2]=Vb;f[Vb>>2]=0;f[Xb>>2]=0;if(!Wj)dk=$j;else{$j=Wj+12|0;f[$j>>2]=(f[$j>>2]|0)+1;dk=f[Gj>>2]|0}if((dk|0)<3){Gj=f[Hj+44>>2]|0;$j=f[Wb>>2]|0;f[$j>>2]=f[Gj>>2];f[$j+4>>2]=f[Gj+4>>2]}else{f[Lb>>2]=0;U$(Kb,Hj)}aNa(e,m,w,w);Hj=f[Tb>>2]|0;do if(Hj|0){Gj=Hj+12|0;$j=f[Gj>>2]|0;f[Gj>>2]=$j+-1;if(($j|0)!=1)break;V$(Kb)}while(0);f[Tb>>2]=0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[Ob+8>>2]=0;f[Ob+12>>2]=0;if((f[Lb>>2]|0)>0){Hj=f[Ub>>2]|0;$j=0;do{f[Hj+($j<<2)>>2]=0;$j=$j+1|0}while(($j|0)<(f[Lb>>2]|0))}$j=f[Wb>>2]|0;if(($j|0)!=(Vb|0))wL($j);if((b[Yb>>0]|0)<0)cYc(f[w>>2]|0);break c}else{bk=Uj;ck=Vj}while(0);do if(((bk<<24>>24<0?ck:bk&255)|0)==11){if(LYc(v,0,-1,390545,11)|0){ek=b[aa>>0]|0;fk=f[ba>>2]|0;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Zb>>0]=5;b[e>>0]=b[439436]|0;b[e+1>>0]=b[439437]|0;b[e+2>>0]=b[439438]|0;b[e+3>>0]=b[439439]|0;b[e+4>>0]=b[439440]|0;b[_b>>0]=0;if(!(HIa(s,e)|0))gk=1.0;else{f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;b[Sc>>0]=5;b[y>>0]=b[439436]|0;b[y+1>>0]=b[439437]|0;b[y+2>>0]=b[439438]|0;b[y+3>>0]=b[439439]|0;b[y+4>>0]=b[439440]|0;b[Tc>>0]=0;hk=+NGa(NIa(s,y)|0,-1);if((b[Sc>>0]|0)<0)cYc(f[y>>2]|0);gk=hk}if((b[Zb>>0]|0)<0)cYc(f[e>>2]|0);n[w>>2]=gk;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[$b>>0]=5;b[e>>0]=b[439436]|0;b[e+1>>0]=b[439437]|0;b[e+2>>0]=b[439438]|0;b[e+3>>0]=b[439439]|0;b[e+4>>0]=b[439440]|0;b[ac>>0]=0;$j=TGa(s,e)|0;if(($j|0)!=(X|0)){Hj=f[$j+4>>2]|0;do if(!Hj){Gj=$j+8|0;Wj=f[Gj>>2]|0;if((f[Wj>>2]|0)==($j|0)){ik=Wj;break}else jk=Gj;do{Gj=f[jk>>2]|0;jk=Gj+8|0;Wj=f[jk>>2]|0}while((f[Wj>>2]|0)!=(Gj|0));ik=Wj}else{Wj=Hj;while(1){Gj=f[Wj>>2]|0;if(!Gj)break;else Wj=Gj}ik=Wj}while(0);if((f[s>>2]|0)==($j|0))f[s>>2]=ik;f[P>>2]=(f[P>>2]|0)+-1;XIa(f[Q>>2]|0,$j);Hj=$j+16|0;RGa($j+28|0);if((b[Hj+11>>0]|0)<0)cYc(f[Hj>>2]|0);cYc($j)}if((b[$b>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[bc>>0]=4;f[e>>2]=1935763810;b[cc>>0]=0;Hj=(HIa(s,e)|0)==0;if((b[bc>>0]|0)<0)cYc(f[e>>2]|0);if(!Hj){tYc($,446585)|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;b[fc>>0]=4;f[z>>2]=1935763810;b[gc>>0]=0;Hj=NIa(s,z)|0;kk=f[Hj>>2]|0;switch(kk|0){case 0:{lk=(f[Hj+4>>2]|0)+4|0;break}case 3:{lk=(f[Hj+4>>2]|0)+4|0;break}case 2:{lk=(f[Hj+4>>2]|0)+4|0;break}default:{Fj=217;break b}}Hj=f[lk>>2]|0;p[A>>3]=+n[w>>2];f[hc>>2]=0;f[hc+4>>2]=0;f[hc+8>>2]=0;f[hc+12>>2]=0;f[hc+16>>2]=0;f[hc+20>>2]=0;f[y>>2]=1124007936;G=ic;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[kc>>2]=jc;f[mc>>2]=lc;f[lc>>2]=0;f[nc>>2]=0;f[e>>2]=Hj;f[oc>>2]=1;S$(y,2,e,5);lR(y,A)|0;$j=f[Za>>2]|0;do if($j>>>0<(f[_a>>2]|0)>>>0){f[$j>>2]=f[y>>2];f[$j+4>>2]=f[ic>>2];Gj=$j+8|0;f[Gj>>2]=f[jc>>2];f[$j+12>>2]=f[pc>>2];f[$j+16>>2]=f[qc>>2];f[$j+20>>2]=f[rc>>2];f[$j+24>>2]=f[sc>>2];f[$j+28>>2]=f[tc>>2];f[$j+32>>2]=f[uc>>2];f[$j+36>>2]=f[vc>>2];Kj=$j+40|0;f[Kj>>2]=Gj;Gj=$j+44|0;ak=$j+48|0;f[Gj>>2]=ak;mk=$j+52|0;f[mk>>2]=0;f[ak>>2]=0;if((f[ic>>2]|0)<3){nk=f[wc>>2]|0;f[ak>>2]=f[nk>>2];f[mk>>2]=f[nk+4>>2]}else{f[Gj>>2]=f[wc>>2];f[Kj>>2]=f[kc>>2];f[wc>>2]=lc;f[kc>>2]=jc}f[y>>2]=1124007936;G=ic;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Za>>2]=$j+56}else{XLa($a,y);Wj=f[vc>>2]|0;if(!Wj)break;Kj=Wj+12|0;Wj=f[Kj>>2]|0;f[Kj>>2]=Wj+-1;if((Wj|0)!=1)break;V$(y)}while(0);f[vc>>2]=0;f[qc>>2]=0;f[qc+4>>2]=0;f[qc+8>>2]=0;f[qc+12>>2]=0;if((f[ic>>2]|0)>0){$j=f[kc>>2]|0;Hj=0;do{f[$j+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[ic>>2]|0))}Hj=f[mc>>2]|0;if((Hj|0)!=(lc|0))wL(Hj);if((b[fc>>0]|0)<0)cYc(f[z>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[xc>>0]=9;G=e;H=445999;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[yc>>0]=0;b[y>>0]=1;cHa(s,e,y)|0;if((b[xc>>0]|0)<0)cYc(f[e>>2]|0);f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;b[zc>>0]=4;f[z>>2]=1935763810;b[Ac>>0]=0;Hj=NIa(s,z)|0;ok=f[Hj>>2]|0;switch(ok|0){case 0:{pk=(f[Hj+4>>2]|0)+4|0;break}case 3:{pk=(f[Hj+4>>2]|0)+4|0;break}case 2:{pk=(f[Hj+4>>2]|0)+4|0;break}default:{Fj=239;break b}}Hj=f[pk>>2]|0;f[y>>2]=1124007936;G=Bc;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Dc>>2]=Cc;f[Fc>>2]=Ec;f[Ec>>2]=0;f[Gc>>2]=0;f[e>>2]=1;f[oc>>2]=Hj;S$(y,2,e,5);if((b[zc>>0]|0)<0)cYc(f[z>>2]|0);$j=0;while(1){qk=f[Bc>>2]|0;if((qk|0)<3)rk=Y(f[Hc>>2]|0,f[Cc>>2]|0)|0;else{Wj=f[Dc>>2]|0;Kj=0;Gj=1;while(1){nk=Y(f[Wj+(Kj<<2)>>2]|0,Gj)|0;Kj=Kj+1|0;if((Kj|0)==(qk|0)){rk=nk;break}else Gj=nk}}if($j>>>0>=rk>>>0)break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Ic>>0]=4;f[e>>2]=1935763810;b[Jc>>0]=0;hk=+NGa(NIa(s,e)|0,$j);n[(f[Kc>>2]|0)+($j<<2)>>2]=hk;if((b[Ic>>0]|0)<0)cYc(f[e>>2]|0);$j=$j+1|0}$j=f[Za>>2]|0;if(($j|0)==(f[_a>>2]|0))bx($a,y);else{f[$j>>2]=f[y>>2];Hj=$j+4|0;f[Hj>>2]=qk;Gj=$j+8|0;f[Gj>>2]=f[Cc>>2];f[$j+12>>2]=f[Hc>>2];f[$j+16>>2]=f[Kc>>2];f[$j+20>>2]=f[Oc>>2];f[$j+24>>2]=f[Pc>>2];f[$j+28>>2]=f[Qc>>2];f[$j+32>>2]=f[Rc>>2];Kj=f[Nc>>2]|0;f[$j+36>>2]=Kj;f[$j+40>>2]=Gj;Gj=$j+48|0;Wj=$j+44|0;f[Wj>>2]=Gj;f[Gj>>2]=0;f[$j+52>>2]=0;if(Kj|0){Gj=Kj+12|0;f[Gj>>2]=(f[Gj>>2]|0)+1}if((f[Bc>>2]|0)<3){Gj=f[Fc>>2]|0;Kj=f[Wj>>2]|0;f[Kj>>2]=f[Gj>>2];f[Kj+4>>2]=f[Gj+4>>2]}else{f[Hj>>2]=0;U$($j,y)}f[Za>>2]=(f[Za>>2]|0)+56};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Lc>>0]=4;f[e>>2]=1935763810;b[Mc>>0]=0;$j=TGa(s,e)|0;if(($j|0)!=(X|0)){Hj=f[$j+4>>2]|0;do if(!Hj){Gj=$j+8|0;Kj=f[Gj>>2]|0;if((f[Kj>>2]|0)==($j|0)){sk=Kj;break}else tk=Gj;do{Gj=f[tk>>2]|0;tk=Gj+8|0;Kj=f[tk>>2]|0}while((f[Kj>>2]|0)!=(Gj|0));sk=Kj}else{Kj=Hj;while(1){Gj=f[Kj>>2]|0;if(!Gj)break;else Kj=Gj}sk=Kj}while(0);if((f[s>>2]|0)==($j|0))f[s>>2]=sk;f[P>>2]=(f[P>>2]|0)+-1;XIa(f[Q>>2]|0,$j);Hj=$j+16|0;RGa($j+28|0);if((b[Hj+11>>0]|0)<0)cYc(f[Hj>>2]|0);cYc($j)}if((b[Lc>>0]|0)<0)cYc(f[e>>2]|0);Hj=f[Nc>>2]|0;do if(Hj|0){Gj=Hj+12|0;Wj=f[Gj>>2]|0;f[Gj>>2]=Wj+-1;if((Wj|0)!=1)break;V$(y)}while(0);f[Nc>>2]=0;f[Kc>>2]=0;f[Kc+4>>2]=0;f[Kc+8>>2]=0;f[Kc+12>>2]=0;if((f[Bc>>2]|0)>0){Hj=f[Dc>>2]|0;$j=0;do{f[Hj+($j<<2)>>2]=0;$j=$j+1|0}while(($j|0)<(f[Bc>>2]|0))}$j=f[Fc>>2]|0;if(($j|0)!=(Ec|0))wL($j)}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[dc>>0]=5;b[e>>0]=b[439436]|0;b[e+1>>0]=b[439437]|0;b[e+2>>0]=b[439438]|0;b[e+3>>0]=b[439439]|0;b[e+4>>0]=b[439440]|0;b[ec>>0]=0;OGa(s,e,w)|0;if((b[dc>>0]|0)<0)cYc(f[e>>2]|0);tYc($,439430)|0}Fj=799;break c}else{ek=bk;fk=ck}while(0);do if(((ek<<24>>24<0?fk:ek&255)|0)==9){if(LYc(v,0,-1,390557,9)|0){uk=b[aa>>0]|0;vk=f[ba>>2]|0;break}tYc($,429133)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Uc>>0]=5;b[e>>0]=b[441815]|0;b[e+1>>0]=b[441816]|0;b[e+2>>0]=b[441817]|0;b[e+3>>0]=b[441818]|0;b[e+4>>0]=b[441819]|0;b[Vc>>0]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;$j=$Xc(16)|0;f[w>>2]=$j;f[Wc>>2]=-2147483632;f[Xc>>2]=14;G=$j;H=429299;I=G+14|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$j+14>>0]=0;lNa(s,e,w);if((b[Yc>>0]|0)<0)cYc(f[w>>2]|0);if((b[Uc>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}else{uk=ek;vk=fk}while(0);do if(((uk<<24>>24<0?vk:uk&255)|0)==3){if(LYc(v,0,-1,396574,3)|0){wk=b[aa>>0]|0;xk=f[ba>>2]|0;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Zc>>0]=4;f[e>>2]=1702521203;b[_c>>0]=0;b[$c>>0]=10;G=w;H=441745;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[ad>>0]=0;lNa(s,e,w);if((b[$c>>0]|0)<0)cYc(f[w>>2]|0);if((b[Zc>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}else{wk=uk;xk=vk}while(0);do if(((wk<<24>>24<0?xk:wk&255)|0)==18){if(LYc(v,0,-1,390567,18)|0){yk=b[aa>>0]|0;zk=f[ba>>2]|0;break}if((f[ia>>2]|0)!=5){Fj=305;break b}tYc($,429107)|0;f[yj>>2]=0;b[bd>>0]=7;b[e>>0]=b[390628]|0;b[e+1>>0]=b[390629]|0;b[e+2>>0]=b[390630]|0;b[e+3>>0]=b[390631]|0;b[e+4>>0]=b[390632]|0;b[e+5>>0]=b[390633]|0;b[e+6>>0]=b[390634]|0;b[cd>>0]=0;$j=zj;f[$j>>2]=0;f[$j+4>>2]=0;b[dd>>0]=3;b[w>>0]=b[513188]|0;b[w+1>>0]=b[513189]|0;b[w+2>>0]=b[513190]|0;b[ed>>0]=0;lNa(s,e,w);if((b[dd>>0]|0)<0)cYc(f[w>>2]|0);if((b[bd>>0]|0)<0)cYc(f[e>>2]|0);f[Aj>>2]=0;b[fd>>0]=7;b[e>>0]=b[390636]|0;b[e+1>>0]=b[390637]|0;b[e+2>>0]=b[390638]|0;b[e+3>>0]=b[390639]|0;b[e+4>>0]=b[390640]|0;b[e+5>>0]=b[390641]|0;b[e+6>>0]=b[390642]|0;b[gd>>0]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;$j=$Xc(32)|0;f[w>>2]=$j;f[hd>>2]=-2147483616;f[id>>2]=16;G=$j;H=444594;I=G+16|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$j+16>>0]=0;lNa(s,e,w);if((b[jd>>0]|0)<0)cYc(f[w>>2]|0);if((b[fd>>0]|0)<0)cYc(f[e>>2]|0);dNa(e,0,t,m,3);dNa(w,0,t,m,4);Hj=f[Za>>2]|0;if((Hj|0)==(f[_a>>2]|0)){bx($a,e);Ak=f[Za>>2]|0}else{f[Hj>>2]=f[e>>2];Wj=Hj+4|0;f[Wj>>2]=f[wd>>2];Gj=Hj+8|0;f[Gj>>2]=f[ie>>2];f[Hj+12>>2]=f[je>>2];f[Hj+16>>2]=f[vd>>2];f[Hj+20>>2]=f[ke>>2];f[Hj+24>>2]=f[le>>2];f[Hj+28>>2]=f[me>>2];f[Hj+32>>2]=f[ne>>2];nk=f[ud>>2]|0;f[Hj+36>>2]=nk;f[Hj+40>>2]=Gj;Gj=Hj+48|0;mk=Hj+44|0;f[mk>>2]=Gj;f[Gj>>2]=0;f[Hj+52>>2]=0;if(nk|0){Gj=nk+12|0;f[Gj>>2]=(f[Gj>>2]|0)+1}if((f[wd>>2]|0)<3){Gj=f[yd>>2]|0;nk=f[mk>>2]|0;f[nk>>2]=f[Gj>>2];f[nk+4>>2]=f[Gj+4>>2]}else{f[Wj>>2]=0;U$(Hj,e)}Hj=(f[Za>>2]|0)+56|0;f[Za>>2]=Hj;Ak=Hj}if((Ak|0)==(f[_a>>2]|0))bx($a,w);else{f[Ak>>2]=f[w>>2];Hj=Ak+4|0;f[Hj>>2]=f[qd>>2];Wj=Ak+8|0;f[Wj>>2]=f[ce>>2];f[Ak+12>>2]=f[de>>2];f[Ak+16>>2]=f[pd>>2];f[Ak+20>>2]=f[ee>>2];f[Ak+24>>2]=f[fe>>2];f[Ak+28>>2]=f[ge>>2];f[Ak+32>>2]=f[he>>2];Gj=f[od>>2]|0;f[Ak+36>>2]=Gj;f[Ak+40>>2]=Wj;Wj=Ak+48|0;nk=Ak+44|0;f[nk>>2]=Wj;f[Wj>>2]=0;f[Ak+52>>2]=0;if(Gj|0){Wj=Gj+12|0;f[Wj>>2]=(f[Wj>>2]|0)+1}if((f[qd>>2]|0)<3){Wj=f[sd>>2]|0;Gj=f[nk>>2]|0;f[Gj>>2]=f[Wj>>2];f[Gj+4>>2]=f[Wj+4>>2]}else{f[Hj>>2]=0;U$(Ak,w)}f[Za>>2]=(f[Za>>2]|0)+56}Hj=f[(f[ja>>2]|0)+8>>2]|0;Wj=b[Hj+11>>0]|0;if(Wj<<24>>24<0)Bk=f[Hj+4>>2]|0;else Bk=Wj&255;if(!Bk){b[kd>>0]=10;G=y;H=444583;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[ld>>0]=0;b[z>>0]=0;cHa(s,y,z)|0;if((b[kd>>0]|0)<0)cYc(f[y>>2]|0)}else{b[Pd>>0]=10;G=y;H=444583;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Qd>>0]=0;b[z>>0]=1;cHa(s,y,z)|0;if((b[Pd>>0]|0)<0)cYc(f[y>>2]|0);dNa(y,0,t,m,1);$j=f[Za>>2]|0;do if($j>>>0<(f[_a>>2]|0)>>>0){f[$j>>2]=f[y>>2];f[$j+4>>2]=f[Rd>>2];Wj=$j+8|0;f[Wj>>2]=f[Sd>>2];f[$j+12>>2]=f[Td>>2];f[$j+16>>2]=f[Ud>>2];f[$j+20>>2]=f[Vd>>2];f[$j+24>>2]=f[Wd>>2];f[$j+28>>2]=f[Xd>>2];f[$j+32>>2]=f[Yd>>2];f[$j+36>>2]=f[Zd>>2];Hj=$j+40|0;f[Hj>>2]=Wj;Wj=$j+44|0;Gj=$j+48|0;f[Wj>>2]=Gj;nk=$j+52|0;f[nk>>2]=0;f[Gj>>2]=0;if((f[Rd>>2]|0)<3){mk=f[_d>>2]|0;f[Gj>>2]=f[mk>>2];f[nk>>2]=f[mk+4>>2]}else{f[Wj>>2]=f[_d>>2];f[Hj>>2]=f[$d>>2];f[_d>>2]=ae;f[$d>>2]=Sd}f[y>>2]=1124007936;G=Rd;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Za>>2]=$j+56}else{XLa($a,y);Kj=f[Zd>>2]|0;if(!Kj)break;Hj=Kj+12|0;Kj=f[Hj>>2]|0;f[Hj>>2]=Kj+-1;if((Kj|0)!=1)break;V$(y)}while(0);f[Zd>>2]=0;f[Ud>>2]=0;f[Ud+4>>2]=0;f[Ud+8>>2]=0;f[Ud+12>>2]=0;if((f[Rd>>2]|0)>0){$j=f[$d>>2]|0;Kj=0;do{f[$j+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[Rd>>2]|0))}Kj=f[be>>2]|0;if((Kj|0)!=(ae|0))wL(Kj)}Kj=f[(f[ja>>2]|0)+12>>2]|0;$j=b[Kj+11>>0]|0;if($j<<24>>24<0)Ck=f[Kj+4>>2]|0;else Ck=$j&255;if(!Ck){f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;b[md>>0]=8;$j=y;f[$j>>2]=1601397096;f[$j+4>>2]=1935763810;b[nd>>0]=0;b[z>>0]=0;cHa(s,y,z)|0;if((b[md>>0]|0)<0)cYc(f[y>>2]|0)}else{f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;b[Ad>>0]=8;$j=y;f[$j>>2]=1601397096;f[$j+4>>2]=1935763810;b[Bd>>0]=0;b[z>>0]=1;cHa(s,y,z)|0;if((b[Ad>>0]|0)<0)cYc(f[y>>2]|0);dNa(y,0,t,m,2);$j=f[Za>>2]|0;do if($j>>>0<(f[_a>>2]|0)>>>0){f[$j>>2]=f[y>>2];f[$j+4>>2]=f[Cd>>2];Kj=$j+8|0;f[Kj>>2]=f[Dd>>2];f[$j+12>>2]=f[Ed>>2];f[$j+16>>2]=f[Fd>>2];f[$j+20>>2]=f[Gd>>2];f[$j+24>>2]=f[Hd>>2];f[$j+28>>2]=f[Id>>2];f[$j+32>>2]=f[Jd>>2];f[$j+36>>2]=f[Kd>>2];Hj=$j+40|0;f[Hj>>2]=Kj;Kj=$j+44|0;Wj=$j+48|0;f[Kj>>2]=Wj;mk=$j+52|0;f[mk>>2]=0;f[Wj>>2]=0;if((f[Cd>>2]|0)<3){nk=f[Ld>>2]|0;f[Wj>>2]=f[nk>>2];f[mk>>2]=f[nk+4>>2]}else{f[Kj>>2]=f[Ld>>2];f[Hj>>2]=f[Md>>2];f[Ld>>2]=Nd;f[Md>>2]=Dd}f[y>>2]=1124007936;G=Cd;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Za>>2]=$j+56}else{XLa($a,y);Hj=f[Kd>>2]|0;if(!Hj)break;Kj=Hj+12|0;Hj=f[Kj>>2]|0;f[Kj>>2]=Hj+-1;if((Hj|0)!=1)break;V$(y)}while(0);f[Kd>>2]=0;f[Fd>>2]=0;f[Fd+4>>2]=0;f[Fd+8>>2]=0;f[Fd+12>>2]=0;if((f[Cd>>2]|0)>0){$j=f[Md>>2]|0;Hj=0;do{f[$j+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[Cd>>2]|0))}Hj=f[Od>>2]|0;if((Hj|0)!=(Nd|0))wL(Hj)}Hj=f[od>>2]|0;do if(Hj|0){$j=Hj+12|0;Kj=f[$j>>2]|0;f[$j>>2]=Kj+-1;if((Kj|0)!=1)break;V$(w)}while(0);f[od>>2]=0;f[pd>>2]=0;f[pd+4>>2]=0;f[pd+8>>2]=0;f[pd+12>>2]=0;if((f[qd>>2]|0)>0){Hj=f[rd>>2]|0;Kj=0;do{f[Hj+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[qd>>2]|0))}Kj=f[sd>>2]|0;if((Kj|0)!=(td|0))wL(Kj);Kj=f[ud>>2]|0;do if(Kj|0){Hj=Kj+12|0;$j=f[Hj>>2]|0;f[Hj>>2]=$j+-1;if(($j|0)!=1)break;V$(e)}while(0);f[ud>>2]=0;f[vd>>2]=0;f[vd+4>>2]=0;f[vd+8>>2]=0;f[vd+12>>2]=0;if((f[wd>>2]|0)>0){Kj=f[xd>>2]|0;$j=0;do{f[Kj+($j<<2)>>2]=0;$j=$j+1|0}while(($j|0)<(f[wd>>2]|0))}$j=f[yd>>2]|0;if(($j|0)!=(zd|0))wL($j);Fj=799;break c}else{yk=wk;zk=xk}while(0);do if(((yk<<24>>24<0?zk:yk&255)|0)==4){if(LYc(v,0,-1,390644,4)|0){Dk=b[aa>>0]|0;Ek=f[ba>>2]|0;break}if((f[ia>>2]|0)<=1){Fj=397;break b}tYc($,396578)|0;dNa(e,0,t,m,1);f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[oe>>0]=6;b[w>>0]=b[390678]|0;b[w+1>>0]=b[390679]|0;b[w+2>>0]=b[390680]|0;b[w+3>>0]=b[390681]|0;b[w+4>>0]=b[390682]|0;b[w+5>>0]=b[390683]|0;b[pe>>0]=0;if(!(HIa(s,w)|0))Fk=0;else{f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;b[Xe>>0]=6;b[y>>0]=b[390678]|0;b[y+1>>0]=b[390679]|0;b[y+2>>0]=b[390680]|0;b[y+3>>0]=b[390681]|0;b[y+4>>0]=b[390682]|0;b[y+5>>0]=b[390683]|0;b[Ye>>0]=0;$j=MGa(NIa(s,y)|0,-1)|0;if((b[Xe>>0]|0)<0)cYc(f[y>>2]|0);Fk=($j|0)==0}if((b[oe>>0]|0)<0)cYc(f[w>>2]|0);if(Fk){f[qe>>2]=0;f[re>>2]=0;f[w>>2]=16842752;f[se>>2]=e;$j=te;f[$j>>2]=0;f[$j+4>>2]=0;f[y>>2]=33619968;f[ue>>2]=e;AV(w,y);Gk=1}else Gk=0;$j=f[Za>>2]|0;if(($j|0)==(f[_a>>2]|0))bx($a,e);else{f[$j>>2]=f[e>>2];Kj=$j+4|0;f[Kj>>2]=f[Ne>>2];Hj=$j+8|0;f[Hj>>2]=f[Re>>2];f[$j+12>>2]=f[Se>>2];f[$j+16>>2]=f[Me>>2];f[$j+20>>2]=f[Te>>2];f[$j+24>>2]=f[Ue>>2];f[$j+28>>2]=f[Ve>>2];f[$j+32>>2]=f[We>>2];nk=f[Le>>2]|0;f[$j+36>>2]=nk;f[$j+40>>2]=Hj;Hj=$j+48|0;mk=$j+44|0;f[mk>>2]=Hj;f[Hj>>2]=0;f[$j+52>>2]=0;if(nk|0){Hj=nk+12|0;f[Hj>>2]=(f[Hj>>2]|0)+1}if((f[Ne>>2]|0)<3){Hj=f[Pe>>2]|0;nk=f[mk>>2]|0;f[nk>>2]=f[Hj>>2];f[nk+4>>2]=f[Hj+4>>2]}else{f[Kj>>2]=0;U$($j,e)}f[Za>>2]=(f[Za>>2]|0)+56}if((f[ia>>2]|0)==3){dNa(w,0,t,m,2);$j=f[Za>>2]|0;if(($j|0)==(f[_a>>2]|0))bx($a,w);else{f[$j>>2]=f[w>>2];Kj=$j+4|0;f[Kj>>2]=f[xe>>2];Hj=$j+8|0;f[Hj>>2]=f[Be>>2];f[$j+12>>2]=f[Ce>>2];f[$j+16>>2]=f[we>>2];f[$j+20>>2]=f[De>>2];f[$j+24>>2]=f[Ee>>2];f[$j+28>>2]=f[Fe>>2];f[$j+32>>2]=f[Ge>>2];nk=f[ve>>2]|0;f[$j+36>>2]=nk;f[$j+40>>2]=Hj;Hj=$j+48|0;mk=$j+44|0;f[mk>>2]=Hj;f[Hj>>2]=0;f[$j+52>>2]=0;if(nk|0){Hj=nk+12|0;f[Hj>>2]=(f[Hj>>2]|0)+1}if((f[xe>>2]|0)<3){Hj=f[ze>>2]|0;nk=f[mk>>2]|0;f[nk>>2]=f[Hj>>2];f[nk+4>>2]=f[Hj+4>>2]}else{f[Kj>>2]=0;U$($j,w)}f[Za>>2]=(f[Za>>2]|0)+56}$j=f[ve>>2]|0;do if($j|0){Kj=$j+12|0;Hj=f[Kj>>2]|0;f[Kj>>2]=Hj+-1;if((Hj|0)!=1)break;V$(w)}while(0);f[ve>>2]=0;f[we>>2]=0;f[we+4>>2]=0;f[we+8>>2]=0;f[we+12>>2]=0;if((f[xe>>2]|0)>0){$j=f[ye>>2]|0;Hj=0;do{f[$j+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[xe>>2]|0))}Hj=f[ze>>2]|0;if((Hj|0)!=(Ae|0))wL(Hj)}b[He>>0]=10;G=w;H=453228;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ie>>0]=0;aHa(s,w,(f[(f[$a>>2]|0)+40>>2]|0)+(Gk<<2)|0)|0;if((b[He>>0]|0)<0)cYc(f[w>>2]|0);f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[Je>>0]=9;G=w;H=445999;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ke>>0]=0;b[y>>0]=(f[ia>>2]|0)==3&1;cHa(s,w,y)|0;if((b[Je>>0]|0)<0)cYc(f[w>>2]|0);Hj=f[Le>>2]|0;do if(Hj|0){$j=Hj+12|0;Kj=f[$j>>2]|0;f[$j>>2]=Kj+-1;if((Kj|0)!=1)break;V$(e)}while(0);f[Le>>2]=0;f[Me>>2]=0;f[Me+4>>2]=0;f[Me+8>>2]=0;f[Me+12>>2]=0;if((f[Ne>>2]|0)>0){Hj=f[Oe>>2]|0;Kj=0;do{f[Hj+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[Ne>>2]|0))}Kj=f[Pe>>2]|0;if((Kj|0)!=(Qe|0))wL(Kj);Fj=799;break c}else{Dk=yk;Ek=zk}while(0);do if(((Dk<<24>>24<0?Ek:Dk&255)|0)==6){if(LYc(v,0,-1,390685,6)|0){Hk=b[aa>>0]|0;Ik=f[ba>>2]|0;break}if((f[ia>>2]|0)!=2){Fj=449;break b}tYc($,396578)|0;dNa(e,0,t,m,1);m$(B,e);f[w>>2]=1124007936;G=Ze;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[$e>>2]=_e;f[bf>>2]=af;f[af>>2]=0;f[cf>>2]=0;Kj=f[B>>2]|0;ei[f[(f[Kj>>2]|0)+12>>2]&511](Kj,B,w,-1);Kj=f[Za>>2]|0;do if(Kj>>>0<(f[_a>>2]|0)>>>0){f[Kj>>2]=f[w>>2];f[Kj+4>>2]=f[Ze>>2];Hj=Kj+8|0;f[Hj>>2]=f[_e>>2];f[Kj+12>>2]=f[df>>2];f[Kj+16>>2]=f[ef>>2];f[Kj+20>>2]=f[ff>>2];f[Kj+24>>2]=f[gf>>2];f[Kj+28>>2]=f[hf>>2];f[Kj+32>>2]=f[jf>>2];f[Kj+36>>2]=f[kf>>2];$j=Kj+40|0;f[$j>>2]=Hj;Hj=Kj+44|0;nk=Kj+48|0;f[Hj>>2]=nk;mk=Kj+52|0;f[mk>>2]=0;f[nk>>2]=0;if((f[Ze>>2]|0)<3){Wj=f[lf>>2]|0;f[nk>>2]=f[Wj>>2];f[mk>>2]=f[Wj+4>>2]}else{f[Hj>>2]=f[lf>>2];f[$j>>2]=f[$e>>2];f[lf>>2]=af;f[$e>>2]=_e}f[w>>2]=1124007936;G=Ze;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Za>>2]=Kj+56}else{XLa($a,w);$j=f[kf>>2]|0;if(!$j)break;Hj=$j+12|0;$j=f[Hj>>2]|0;f[Hj>>2]=$j+-1;if(($j|0)!=1)break;V$(w)}while(0);f[kf>>2]=0;f[ef>>2]=0;f[ef+4>>2]=0;f[ef+8>>2]=0;f[ef+12>>2]=0;if((f[Ze>>2]|0)>0){Kj=f[$e>>2]|0;$j=0;do{f[Kj+($j<<2)>>2]=0;$j=$j+1|0}while(($j|0)<(f[Ze>>2]|0))}$j=f[bf>>2]|0;if(($j|0)!=(af|0))wL($j);Zj(B);f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[mf>>0]=9;G=w;H=445999;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[nf>>0]=0;b[y>>0]=0;cHa(s,w,y)|0;if((b[mf>>0]|0)<0)cYc(f[w>>2]|0);b[of>>0]=10;G=w;H=453228;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[pf>>0]=0;aHa(s,w,f[(f[$a>>2]|0)+40>>2]|0)|0;if((b[of>>0]|0)<0)cYc(f[w>>2]|0);$j=f[qf>>2]|0;do if($j|0){Kj=$j+12|0;Hj=f[Kj>>2]|0;f[Kj>>2]=Hj+-1;if((Hj|0)!=1)break;V$(e)}while(0);f[qf>>2]=0;f[rf>>2]=0;f[rf+4>>2]=0;f[rf+8>>2]=0;f[rf+12>>2]=0;if((f[sf>>2]|0)>0){$j=f[tf>>2]|0;Hj=0;do{f[$j+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[sf>>2]|0))}Hj=f[uf>>2]|0;if((Hj|0)!=(vf|0))wL(Hj);Fj=799;break c}else{Hk=Dk;Ik=Ek}while(0);do if(((Hk<<24>>24<0?Ik:Hk&255)|0)==3){if(LYc(v,0,-1,390721,3)|0){Jk=b[aa>>0]|0;Kk=f[ba>>2]|0;break}if((f[ia>>2]|0)!=2){Fj=480;break b}if((kNa(q,f[(f[ja>>2]|0)+8>>2]|0)|0)!=(F|0)){tYc($,428856)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Yf>>0]=9;G=e;H=437378;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Zf>>0]=0;MIa(s,e,437388)|0;if((b[Yf>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}dNa(e,0,t,m,1);g0(w,e,1,1);Hj=f[wf>>2]|0;do if(Hj|0){$j=Hj+12|0;Kj=f[$j>>2]|0;f[$j>>2]=Kj+-1;if((Kj|0)!=1)break;V$(e)}while(0);f[wf>>2]=0;f[xf>>2]=0;f[xf+4>>2]=0;f[xf+8>>2]=0;f[xf+12>>2]=0;if((f[yf>>2]|0)>0){Hj=f[zf>>2]|0;Kj=0;do{f[Hj+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[yf>>2]|0))}f[e>>2]=f[w>>2];Kj=f[Af>>2]|0;f[yf>>2]=Kj;f[Cf>>2]=f[Bf>>2];f[Ef>>2]=f[Df>>2];f[xf>>2]=f[Ff>>2];f[Hf>>2]=f[Gf>>2];f[Jf>>2]=f[If>>2];f[Lf>>2]=f[Kf>>2];f[Nf>>2]=f[Mf>>2];f[wf>>2]=f[Of>>2];Hj=f[Pf>>2]|0;if((Hj|0)==(Qf|0))Lk=Kj;else{wL(Hj);f[Pf>>2]=Qf;f[zf>>2]=Cf;Lk=f[Af>>2]|0}if((Lk|0)<3){Hj=f[Rf>>2]|0;f[Qf>>2]=f[Hj>>2];f[Bj>>2]=f[Hj+4>>2];Mk=Hj}else{f[Pf>>2]=f[Rf>>2];f[Xf>>2]=f[Sf>>2];f[Rf>>2]=Tf;f[Sf>>2]=Bf;Mk=Tf}f[w>>2]=1124007936;f[Af>>2]=0;f[Af+4>>2]=0;f[Af+8>>2]=0;f[Af+12>>2]=0;f[Af+16>>2]=0;f[Af+20>>2]=0;f[Af+24>>2]=0;f[Af+28>>2]=0;f[Of>>2]=0;f[Ff>>2]=0;f[Ff+4>>2]=0;f[Ff+8>>2]=0;f[Ff+12>>2]=0;if((Mk|0)!=(Tf|0))wL(Mk);Hj=f[yf>>2]|0;if((Hj|0)<3)Nk=Y(f[Ef>>2]|0,f[Cf>>2]|0)|0;else{Kj=f[zf>>2]|0;$j=0;Wj=1;while(1){mk=Y(f[Kj+($j<<2)>>2]|0,Wj)|0;$j=$j+1|0;if(($j|0)==(Hj|0)){Nk=mk;break}else Wj=mk}}if((Nk|0)==1){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[Uf>>0]=5;b[w>>0]=b[439436]|0;b[w+1>>0]=b[439437]|0;b[w+2>>0]=b[439438]|0;b[w+3>>0]=b[439439]|0;b[w+4>>0]=b[439440]|0;b[Vf>>0]=0;OGa(s,w,f[xf>>2]|0)|0;if((b[Uf>>0]|0)<0)cYc(f[w>>2]|0);tYc($,439430)|0}else{Wj=f[Za>>2]|0;if((Wj|0)==(f[_a>>2]|0))bx($a,e);else{f[Wj>>2]=f[e>>2];$j=Wj+4|0;f[$j>>2]=Hj;Kj=Wj+8|0;f[Kj>>2]=f[Cf>>2];f[Wj+12>>2]=f[Ef>>2];f[Wj+16>>2]=f[xf>>2];f[Wj+20>>2]=f[Hf>>2];f[Wj+24>>2]=f[Jf>>2];f[Wj+28>>2]=f[Lf>>2];f[Wj+32>>2]=f[Nf>>2];mk=f[wf>>2]|0;f[Wj+36>>2]=mk;f[Wj+40>>2]=Kj;Kj=Wj+48|0;nk=Wj+44|0;f[nk>>2]=Kj;f[Kj>>2]=0;f[Wj+52>>2]=0;if(mk|0){Kj=mk+12|0;f[Kj>>2]=(f[Kj>>2]|0)+1}if((f[yf>>2]|0)<3){Kj=f[Wf>>2]|0;mk=f[nk>>2]|0;f[mk>>2]=f[Kj>>2];f[mk+4>>2]=f[Kj+4>>2]}else{f[$j>>2]=0;U$(Wj,e)}f[Za>>2]=(f[Za>>2]|0)+56}tYc($,446585)|0}Wj=f[wf>>2]|0;do if(Wj|0){$j=Wj+12|0;Kj=f[$j>>2]|0;f[$j>>2]=Kj+-1;if((Kj|0)!=1)break;V$(e)}while(0);f[wf>>2]=0;f[xf>>2]=0;f[xf+4>>2]=0;f[xf+8>>2]=0;f[xf+12>>2]=0;if((f[yf>>2]|0)>0){Wj=f[zf>>2]|0;Hj=0;do{f[Wj+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[yf>>2]|0))}Hj=f[Wf>>2]|0;if((Hj|0)!=(Qf|0))wL(Hj);Fj=799;break c}else{Jk=Hk;Kk=Ik}while(0);do if(((Jk<<24>>24<0?Kk:Jk&255)|0)==4){if(LYc(v,0,-1,390725,4)|0){Ok=b[aa>>0]|0;Pk=f[ba>>2]|0;break}if((f[ia>>2]|0)<=1){Fj=528;break b}tYc($,429163)|0;if((f[ia>>2]|0)>1){Hj=1;do{dNa(e,0,t,m,Hj);Wj=f[Za>>2]|0;do if(Wj>>>0<(f[_a>>2]|0)>>>0){f[Wj>>2]=f[e>>2];f[Wj+4>>2]=f[cg>>2];Kj=Wj+8|0;f[Kj>>2]=f[dg>>2];f[Wj+12>>2]=f[eg>>2];f[Wj+16>>2]=f[fg>>2];f[Wj+20>>2]=f[gg>>2];f[Wj+24>>2]=f[hg>>2];f[Wj+28>>2]=f[ig>>2];f[Wj+32>>2]=f[jg>>2];f[Wj+36>>2]=f[kg>>2];$j=Wj+40|0;f[$j>>2]=Kj;Kj=Wj+44|0;mk=Wj+48|0;f[Kj>>2]=mk;nk=Wj+52|0;f[nk>>2]=0;f[mk>>2]=0;if((f[cg>>2]|0)<3){Gj=f[lg>>2]|0;f[mk>>2]=f[Gj>>2];f[nk>>2]=f[Gj+4>>2]}else{f[Kj>>2]=f[lg>>2];f[$j>>2]=f[mg>>2];f[lg>>2]=ng;f[mg>>2]=dg}f[e>>2]=1124007936;G=cg;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Za>>2]=Wj+56}else{XLa($a,e);$j=f[kg>>2]|0;if(!$j)break;Kj=$j+12|0;$j=f[Kj>>2]|0;f[Kj>>2]=$j+-1;if(($j|0)!=1)break;V$(e)}while(0);f[kg>>2]=0;f[fg>>2]=0;f[fg+4>>2]=0;f[fg+8>>2]=0;f[fg+12>>2]=0;if((f[cg>>2]|0)>0){Wj=f[mg>>2]|0;$j=0;do{f[Wj+($j<<2)>>2]=0;$j=$j+1|0}while(($j|0)<(f[cg>>2]|0))}$j=f[og>>2]|0;if(($j|0)!=(ng|0))wL($j);Hj=Hj+1|0}while((Hj|0)<(f[ia>>2]|0))}b[_f>>0]=10;G=e;H=453228;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$f>>0]=0;aHa(s,e,f[(f[O>>2]|0)+40>>2]|0)|0;if((b[_f>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ag>>0]=9;G=e;H=445999;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[bg>>0]=0;b[w>>0]=(f[ia>>2]|0)==3&1;cHa(s,e,w)|0;if((b[ag>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}else{Ok=Jk;Pk=Kk}while(0);do if(((Ok<<24>>24<0?Pk:Ok&255)|0)==13){if(LYc(v,0,-1,390730,13)|0){Qk=b[aa>>0]|0;Rk=f[ba>>2]|0;break}if((f[ia>>2]|0)<=1){Fj=553;break b}tYc($,396536)|0;if((f[ia>>2]|0)>1){Hj=1;do{dNa(e,0,t,m,Hj);$j=f[Za>>2]|0;do if($j>>>0<(f[_a>>2]|0)>>>0){f[$j>>2]=f[e>>2];f[$j+4>>2]=f[tg>>2];Wj=$j+8|0;f[Wj>>2]=f[ug>>2];f[$j+12>>2]=f[vg>>2];f[$j+16>>2]=f[wg>>2];f[$j+20>>2]=f[xg>>2];f[$j+24>>2]=f[yg>>2];f[$j+28>>2]=f[zg>>2];f[$j+32>>2]=f[Ag>>2];f[$j+36>>2]=f[Bg>>2];Kj=$j+40|0;f[Kj>>2]=Wj;Wj=$j+44|0;Gj=$j+48|0;f[Wj>>2]=Gj;nk=$j+52|0;f[nk>>2]=0;f[Gj>>2]=0;if((f[tg>>2]|0)<3){mk=f[Cg>>2]|0;f[Gj>>2]=f[mk>>2];f[nk>>2]=f[mk+4>>2]}else{f[Wj>>2]=f[Cg>>2];f[Kj>>2]=f[Dg>>2];f[Cg>>2]=Eg;f[Dg>>2]=ug}f[e>>2]=1124007936;G=tg;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Za>>2]=$j+56}else{XLa($a,e);Kj=f[Bg>>2]|0;if(!Kj)break;Wj=Kj+12|0;Kj=f[Wj>>2]|0;f[Wj>>2]=Kj+-1;if((Kj|0)!=1)break;V$(e)}while(0);f[Bg>>2]=0;f[wg>>2]=0;f[wg+4>>2]=0;f[wg+8>>2]=0;f[wg+12>>2]=0;if((f[tg>>2]|0)>0){$j=f[Dg>>2]|0;Kj=0;do{f[$j+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[tg>>2]|0))}Kj=f[Fg>>2]|0;if((Kj|0)!=(Eg|0))wL(Kj);Hj=Hj+1|0}while((Hj|0)<(f[ia>>2]|0))}b[pg>>0]=10;G=e;H=453228;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[qg>>0]=0;aHa(s,e,(f[(f[O>>2]|0)+40>>2]|0)+4|0)|0;if((b[pg>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[rg>>0]=9;G=e;H=445999;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[sg>>0]=0;b[w>>0]=(f[ia>>2]|0)==3&1;cHa(s,e,w)|0;if((b[rg>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}else{Qk=Ok;Rk=Pk}while(0);do if(((Qk<<24>>24<0?Rk:Qk&255)|0)==9){if(LYc(v,0,-1,390744,9)|0){Sk=b[aa>>0]|0;Tk=f[ba>>2]|0;break}tYc($,428903)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Gg>>0]=4;f[e>>2]=1836213616;b[Hg>>0]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[Ig>>0]=5;b[w>>0]=b[450562]|0;b[w+1>>0]=b[450563]|0;b[w+2>>0]=b[450564]|0;b[w+3>>0]=b[450565]|0;b[w+4>>0]=b[450566]|0;b[Jg>>0]=0;lNa(s,e,w);if((b[Ig>>0]|0)<0)cYc(f[w>>2]|0);if((b[Gg>>0]|0)<0)cYc(f[e>>2]|0);Fj=799;break c}else{Sk=Qk;Tk=Rk}while(0);do if(((Sk<<24>>24<0?Tk:Sk&255)|0)==9){if(LYc(v,0,-1,390754,9)|0){Uk=b[aa>>0]|0;Vk=f[ba>>2]|0;break}if((f[ia>>2]|0)!=1){Fj=586;break b}dNa(w,0,t,m,0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Kg>>0]=4;f[e>>2]=1936029793;b[Lg>>0]=0;VGa(y,NIa(s,e)|0);if((b[Kg>>0]|0)<0)cYc(f[e>>2]|0);f[z>>2]=0;f[Mg>>2]=0;f[Ng>>2]=0;d:do if((f[Og>>2]|0)>0){Hj=0;Kj=0;$j=0;while(1){Wj=(f[sh>>2]|0)+(Hj<<2)|0;if((Kj|0)==($j|0))Tv(z,Wj);else{f[Kj>>2]=f[Wj>>2];f[Mg>>2]=Kj+4}Wj=Hj+1|0;if((Wj|0)>=(f[Og>>2]|0))break d;Hj=Wj;Kj=f[Mg>>2]|0;$j=f[vh>>2]|0}}while(0);Wk=f[y>>2]|0;switch(Wk|0){case 0:{Xk=(f[Pg>>2]|0)+4|0;break}case 3:{Xk=(f[Qg>>2]|0)+4|0;break}case 2:{Xk=(f[Qg>>2]|0)+4|0;break}default:{Fj=594;break b}}$j=MGa(y,(f[Xk>>2]|0)+-1|0)|0;if($j>>>0>(f[Mg>>2]|0)-(f[z>>2]|0)>>2>>>0){Fj=601;break b}else Yk=0;while(1){Zk=f[y>>2]|0;switch(Zk|0){case 0:{_k=(f[Pg>>2]|0)+4|0;break}case 3:{_k=(f[Qg>>2]|0)+4|0;break}case 2:{_k=(f[Qg>>2]|0)+4|0;break}default:{Fj=606;break b}}if((Yk|0)>=(f[_k>>2]|0))break;$j=f[z>>2]|0;Kj=MGa(y,Yk)|0;f[C>>2]=$j+(Kj<<2);f[A>>2]=1;f[e>>2]=f[C>>2];mNa(z,e,A)|0;Yk=Yk+1|0}i0(A,w,0,z);lYc(D,Z);f[Rg>>2]=f[A>>2];Kj=f[Tg>>2]|0;f[Sg>>2]=Kj;f[Ug>>2]=f[Vg>>2];f[Wg>>2]=f[Xg>>2];f[Yg>>2]=f[Zg>>2];f[_g>>2]=f[$g>>2];f[ah>>2]=f[bh>>2];f[ch>>2]=f[dh>>2];f[eh>>2]=f[fh>>2];$j=f[hh>>2]|0;f[gh>>2]=$j;f[ih>>2]=Ug;f[kh>>2]=jh;f[jh>>2]=0;f[lh>>2]=0;if(!$j)$k=Kj;else{Kj=$j+12|0;f[Kj>>2]=(f[Kj>>2]|0)+1;$k=f[Tg>>2]|0}if(($k|0)<3){Kj=f[mh>>2]|0;$j=f[kh>>2]|0;f[$j>>2]=f[Kj>>2];f[$j+4>>2]=f[Kj+4>>2]}else{f[Sg>>2]=0;U$(Rg,A)}aNa(e,m,D,D);Kj=f[gh>>2]|0;do if(Kj|0){$j=Kj+12|0;Hj=f[$j>>2]|0;f[$j>>2]=Hj+-1;if((Hj|0)!=1)break;V$(Rg)}while(0);f[gh>>2]=0;f[Yg>>2]=0;f[Yg+4>>2]=0;f[Yg+8>>2]=0;f[Yg+12>>2]=0;if((f[Sg>>2]|0)>0){Kj=f[ih>>2]|0;Hj=0;do{f[Kj+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[Sg>>2]|0))}Hj=f[kh>>2]|0;if((Hj|0)!=(jh|0))wL(Hj);if((b[nh>>0]|0)<0)cYc(f[D>>2]|0);Hj=f[hh>>2]|0;do if(Hj|0){Kj=Hj+12|0;$j=f[Kj>>2]|0;f[Kj>>2]=$j+-1;if(($j|0)!=1)break;V$(A)}while(0);f[hh>>2]=0;f[Zg>>2]=0;f[Zg+4>>2]=0;f[Zg+8>>2]=0;f[Zg+12>>2]=0;if((f[Tg>>2]|0)>0){Hj=f[oh>>2]|0;$j=0;do{f[Hj+($j<<2)>>2]=0;$j=$j+1|0}while(($j|0)<(f[Tg>>2]|0))}$j=f[mh>>2]|0;if(($j|0)!=(ph|0))wL($j);$j=f[z>>2]|0;if($j|0){Hj=f[Mg>>2]|0;if((Hj|0)!=($j|0))f[Mg>>2]=Hj+(~((Hj+-4-$j|0)>>>2)<<2);cYc($j)}RGa(y);$j=f[qh>>2]|0;do if($j|0){Hj=$j+12|0;Kj=f[Hj>>2]|0;f[Hj>>2]=Kj+-1;if((Kj|0)!=1)break;V$(w)}while(0);f[qh>>2]=0;f[rh>>2]=0;f[rh+4>>2]=0;f[rh+8>>2]=0;f[rh+12>>2]=0;if((f[Og>>2]|0)>0){$j=f[sh>>2]|0;Kj=0;do{f[$j+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[Og>>2]|0))}Kj=f[th>>2]|0;if((Kj|0)!=(uh|0))wL(Kj);break c}else{Uk=Sk;Vk=Tk}while(0);do if(((Uk<<24>>24<0?Vk:Uk&255)|0)==7){if(LYc(v,0,-1,396499,7)|0){al=b[aa>>0]|0;bl=f[ba>>2]|0;break}do if((f[ia>>2]|0)!=2){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ri>>0]=5;b[e>>0]=b[390840]|0;b[e+1>>0]=b[390841]|0;b[e+2>>0]=b[390842]|0;b[e+3>>0]=b[390843]|0;b[e+4>>0]=b[390844]|0;b[si>>0]=0;Kj=(HIa(s,e)|0)==0;if((b[ri>>0]|0)<0)cYc(f[e>>2]|0);if(Kj){Fj=652;break b}if((f[ia>>2]|0)==2)break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ti>>0]=5;b[e>>0]=b[390840]|0;b[e+1>>0]=b[390841]|0;b[e+2>>0]=b[390842]|0;b[e+3>>0]=b[390843]|0;b[e+4>>0]=b[390844]|0;b[ui>>0]=0;VGa(w,NIa(s,e)|0);if((b[ti>>0]|0)<0)cYc(f[e>>2]|0);f[y>>2]=0;f[vi>>2]=0;f[wi>>2]=0;Kj=0;while(1){cl=f[w>>2]|0;switch(cl|0){case 0:{dl=(f[xi>>2]|0)+4|0;break}case 3:{dl=(f[zi>>2]|0)+4|0;break}case 2:{dl=(f[zi>>2]|0)+4|0;break}default:{Fj=727;break b}}if((Kj|0)>=(f[dl>>2]|0))break;$j=MGa(w,Kj)|0;f[e>>2]=$j;Hj=f[vi>>2]|0;if(Hj>>>0<(f[yi>>2]|0)>>>0){f[Hj>>2]=$j;f[vi>>2]=Hj+4}else LA(y,e);Kj=Kj+1|0}if((kNa(q,f[(f[ja>>2]|0)+4>>2]|0)|0)!=(F|0)){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[fj>>0]=5;b[e>>0]=b[390840]|0;b[e+1>>0]=b[390841]|0;b[e+2>>0]=b[390842]|0;b[e+3>>0]=b[390843]|0;b[e+4>>0]=b[390844]|0;b[gj>>0]=0;Kj=Dj;f[Kj>>2]=0;f[Kj+4>>2]=0;b[hj>>0]=3;b[z>>0]=b[515177]|0;b[z+1>>0]=b[515178]|0;b[z+2>>0]=b[515179]|0;b[ij>>0]=0;lNa(s,e,z);if((b[hj>>0]|0)<0)cYc(f[z>>2]|0);if((b[fj>>0]|0)<0)cYc(f[e>>2]|0);Kj=f[y>>2]|0;if(Kj|0){Hj=f[vi>>2]|0;if((Hj|0)!=(Kj|0))f[vi>>2]=Hj+(~((Hj+-4-Kj|0)>>>2)<<2);cYc(Kj)}RGa(w);Fj=799;break c}dNa(z,0,t,m,0);i0(A,z,0,y);lYc(D,Z);f[Ai>>2]=f[A>>2];Kj=f[Ci>>2]|0;f[Bi>>2]=Kj;f[Di>>2]=f[Ei>>2];f[Fi>>2]=f[Gi>>2];f[Hi>>2]=f[Ii>>2];f[Ji>>2]=f[Ki>>2];f[Li>>2]=f[Mi>>2];f[Ni>>2]=f[Oi>>2];f[Pi>>2]=f[Qi>>2];Hj=f[Si>>2]|0;f[Ri>>2]=Hj;f[Ti>>2]=Di;f[Vi>>2]=Ui;f[Ui>>2]=0;f[Wi>>2]=0;if(!Hj)el=Kj;else{Kj=Hj+12|0;f[Kj>>2]=(f[Kj>>2]|0)+1;el=f[Ci>>2]|0}if((el|0)<3){Kj=f[Xi>>2]|0;Hj=f[Vi>>2]|0;f[Hj>>2]=f[Kj>>2];f[Hj+4>>2]=f[Kj+4>>2]}else{f[Bi>>2]=0;U$(Ai,A)}aNa(e,m,D,D);Kj=f[Ri>>2]|0;do if(Kj|0){Hj=Kj+12|0;$j=f[Hj>>2]|0;f[Hj>>2]=$j+-1;if(($j|0)!=1)break;V$(Ai)}while(0);f[Ri>>2]=0;f[Hi>>2]=0;f[Hi+4>>2]=0;f[Hi+8>>2]=0;f[Hi+12>>2]=0;if((f[Bi>>2]|0)>0){Kj=f[Ti>>2]|0;$j=0;do{f[Kj+($j<<2)>>2]=0;$j=$j+1|0}while(($j|0)<(f[Bi>>2]|0))}$j=f[Vi>>2]|0;if(($j|0)!=(Ui|0))wL($j);if((b[Yi>>0]|0)<0)cYc(f[D>>2]|0);$j=f[Si>>2]|0;do if($j|0){Kj=$j+12|0;Hj=f[Kj>>2]|0;f[Kj>>2]=Hj+-1;if((Hj|0)!=1)break;V$(A)}while(0);f[Si>>2]=0;f[Ii>>2]=0;f[Ii+4>>2]=0;f[Ii+8>>2]=0;f[Ii+12>>2]=0;if((f[Ci>>2]|0)>0){$j=f[Zi>>2]|0;Hj=0;do{f[$j+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[Ci>>2]|0))}Hj=f[Xi>>2]|0;if((Hj|0)!=(_i|0))wL(Hj);Hj=f[$i>>2]|0;do if(Hj|0){$j=Hj+12|0;Kj=f[$j>>2]|0;f[$j>>2]=Kj+-1;if((Kj|0)!=1)break;V$(z)}while(0);f[$i>>2]=0;f[aj>>2]=0;f[aj+4>>2]=0;f[aj+8>>2]=0;f[aj+12>>2]=0;if((f[bj>>2]|0)>0){Hj=f[cj>>2]|0;Kj=0;do{f[Hj+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[bj>>2]|0))}Kj=f[dj>>2]|0;if((Kj|0)!=(ej|0))wL(Kj);Kj=f[y>>2]|0;if(Kj|0){Hj=f[vi>>2]|0;if((Hj|0)!=(Kj|0))f[vi>>2]=Hj+(~((Hj+-4-Kj|0)>>>2)<<2);cYc(Kj)}RGa(w);break c}while(0);dNa(w,0,t,m,1);if((f[w>>2]&4095|0)!=4){Fj=655;break b}if((kNa(q,f[(f[ja>>2]|0)+4>>2]|0)|0)!=(F|0)){Kj=Cj;f[Kj>>2]=0;f[Kj+4>>2]=0;b[mi>>0]=3;b[e>>0]=b[515177]|0;b[e+1>>0]=b[515178]|0;b[e+2>>0]=b[515179]|0;b[ni>>0]=0;Kj=f[hi>>2]|0;Hj=f[ii>>2]|0;if((Hj|0)<3)fl=Y(f[pi>>2]|0,f[oi>>2]|0)|0;else{$j=f[ji>>2]|0;Wj=0;mk=1;while(1){nk=Y(f[$j+(Wj<<2)>>2]|0,mk)|0;Wj=Wj+1|0;if((Wj|0)==(Hj|0)){fl=nk;break}else mk=nk}}mk=$Xc(16)|0;Hj=mk+8|0;f[mk>>2]=Hj;f[mk+4>>2]=fl;if(fl>>>0>1){Wj=bYc(fl>>>0>536870911?-1:fl<<3)|0;f[mk>>2]=Wj;gl=Wj}else gl=Hj;f[y>>2]=0;f[qi>>2]=mk;if((fl|0)>0){mk=Kj;Hj=0;while(1){Wj=f[mk>>2]|0;$j=gl+(Hj<<3)|0;f[$j>>2]=Wj;f[$j+4>>2]=((Wj|0)<0)<<31>>31;Hj=Hj+1|0;if((Hj|0)==(fl|0))break;else mk=mk+4|0}}$Ga(s,e,y)|0;RGa(y);if((b[mi>>0]|0)<0)cYc(f[e>>2]|0);mk=f[gi>>2]|0;do if(mk|0){Hj=mk+12|0;Kj=f[Hj>>2]|0;f[Hj>>2]=Kj+-1;if((Kj|0)!=1)break;V$(w)}while(0);f[gi>>2]=0;f[hi>>2]=0;f[hi+4>>2]=0;f[hi+8>>2]=0;f[hi+12>>2]=0;if((f[ii>>2]|0)>0){mk=f[ji>>2]|0;Kj=0;do{f[mk+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[ii>>2]|0))}Kj=f[ki>>2]|0;if((Kj|0)!=(li|0))wL(Kj);Fj=799;break c}dNa(y,0,t,m,0);f[A>>2]=0;f[wh>>2]=0;f[xh>>2]=0;Kj=yh;f[Kj>>2]=0;f[Kj+4>>2]=0;f[e>>2]=-2113732604;f[zh>>2]=A;jR(w,e);i0(z,y,0,A);Kj=f[A>>2]|0;if(Kj|0){mk=f[wh>>2]|0;if((mk|0)!=(Kj|0))f[wh>>2]=mk+(~((mk+-4-Kj|0)>>>2)<<2);cYc(Kj)}lYc(A,Z);f[Ah>>2]=f[z>>2];Kj=f[Ch>>2]|0;f[Bh>>2]=Kj;f[Dh>>2]=f[Eh>>2];f[Fh>>2]=f[Gh>>2];f[Hh>>2]=f[Ih>>2];f[Jh>>2]=f[Kh>>2];f[Lh>>2]=f[Mh>>2];f[Nh>>2]=f[Oh>>2];f[Ph>>2]=f[Qh>>2];mk=f[Sh>>2]|0;f[Rh>>2]=mk;f[Th>>2]=Dh;f[Vh>>2]=Uh;f[Uh>>2]=0;f[Wh>>2]=0;if(!mk)hl=Kj;else{Kj=mk+12|0;f[Kj>>2]=(f[Kj>>2]|0)+1;hl=f[Ch>>2]|0}if((hl|0)<3){Kj=f[Xh>>2]|0;mk=f[Vh>>2]|0;f[mk>>2]=f[Kj>>2];f[mk+4>>2]=f[Kj+4>>2]}else{f[Bh>>2]=0;U$(Ah,z)}aNa(e,m,A,A);Kj=f[Rh>>2]|0;do if(Kj|0){mk=Kj+12|0;Hj=f[mk>>2]|0;f[mk>>2]=Hj+-1;if((Hj|0)!=1)break;V$(Ah)}while(0);f[Rh>>2]=0;f[Hh>>2]=0;f[Hh+4>>2]=0;f[Hh+8>>2]=0;f[Hh+12>>2]=0;if((f[Bh>>2]|0)>0){Kj=f[Th>>2]|0;Hj=0;do{f[Kj+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[Bh>>2]|0))}Hj=f[Vh>>2]|0;if((Hj|0)!=(Uh|0))wL(Hj);if((b[Yh>>0]|0)<0)cYc(f[A>>2]|0);Hj=f[Sh>>2]|0;do if(Hj|0){Kj=Hj+12|0;mk=f[Kj>>2]|0;f[Kj>>2]=mk+-1;if((mk|0)!=1)break;V$(z)}while(0);f[Sh>>2]=0;f[Ih>>2]=0;f[Ih+4>>2]=0;f[Ih+8>>2]=0;f[Ih+12>>2]=0;if((f[Ch>>2]|0)>0){Hj=f[Zh>>2]|0;mk=0;do{f[Hj+(mk<<2)>>2]=0;mk=mk+1|0}while((mk|0)<(f[Ch>>2]|0))}mk=f[Xh>>2]|0;if((mk|0)!=(_h|0))wL(mk);mk=f[$h>>2]|0;do if(mk|0){Hj=mk+12|0;Kj=f[Hj>>2]|0;f[Hj>>2]=Kj+-1;if((Kj|0)!=1)break;V$(y)}while(0);f[$h>>2]=0;f[ai>>2]=0;f[ai+4>>2]=0;f[ai+8>>2]=0;f[ai+12>>2]=0;if((f[bi>>2]|0)>0){mk=f[ci>>2]|0;Kj=0;do{f[mk+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[bi>>2]|0))}Kj=f[di>>2]|0;if((Kj|0)!=(fi|0))wL(Kj);Kj=f[gi>>2]|0;do if(Kj|0){mk=Kj+12|0;Hj=f[mk>>2]|0;f[mk>>2]=Hj+-1;if((Hj|0)!=1)break;V$(w)}while(0);f[gi>>2]=0;f[hi>>2]=0;f[hi+4>>2]=0;f[hi+8>>2]=0;f[hi+12>>2]=0;if((f[ii>>2]|0)>0){Kj=f[ji>>2]|0;Hj=0;do{f[Kj+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[ii>>2]|0))}Hj=f[ki>>2]|0;if((Hj|0)!=(li|0))wL(Hj);break c}else{al=Uk;bl=Vk}while(0);do if(((al<<24>>24<0?bl:al&255)|0)==3){if(LYc(v,0,-1,390079,3)|0)break;tYc($,396729)|0;Fj=799;break c}while(0);if((f[ia>>2]|0)>0)il=0;else{Fj=799;break c}while(1){if((kNa(q,f[(f[ja>>2]|0)+4+(il<<2)>>2]|0)|0)==(F|0)){dNa(e,0,t,m,il);Hj=f[Za>>2]|0;do if(Hj>>>0<(f[_a>>2]|0)>>>0){f[Hj>>2]=f[e>>2];f[Hj+4>>2]=f[jj>>2];Kj=Hj+8|0;f[Kj>>2]=f[kj>>2];f[Hj+12>>2]=f[lj>>2];f[Hj+16>>2]=f[mj>>2];f[Hj+20>>2]=f[nj>>2];f[Hj+24>>2]=f[oj>>2];f[Hj+28>>2]=f[pj>>2];f[Hj+32>>2]=f[qj>>2];f[Hj+36>>2]=f[rj>>2];mk=Hj+40|0;f[mk>>2]=Kj;Kj=Hj+44|0;Wj=Hj+48|0;f[Kj>>2]=Wj;$j=Hj+52|0;f[$j>>2]=0;f[Wj>>2]=0;if((f[jj>>2]|0)<3){nk=f[sj>>2]|0;f[Wj>>2]=f[nk>>2];f[$j>>2]=f[nk+4>>2]}else{f[Kj>>2]=f[sj>>2];f[mk>>2]=f[tj>>2];f[sj>>2]=uj;f[tj>>2]=kj}f[e>>2]=1124007936;G=jj;I=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(I|0));f[Za>>2]=Hj+56}else{XLa($a,e);mk=f[rj>>2]|0;if(!mk)break;Kj=mk+12|0;mk=f[Kj>>2]|0;f[Kj>>2]=mk+-1;if((mk|0)!=1)break;V$(e)}while(0);f[rj>>2]=0;f[mj>>2]=0;f[mj+4>>2]=0;f[mj+8>>2]=0;f[mj+12>>2]=0;if((f[jj>>2]|0)>0){Hj=f[tj>>2]|0;mk=0;do{f[Hj+(mk<<2)>>2]=0;mk=mk+1|0}while((mk|0)<(f[jj>>2]|0))}mk=f[vj>>2]|0;if((mk|0)!=(uj|0))wL(mk)}il=il+1|0;if((il|0)>=(f[ia>>2]|0)){Fj=799;break c}}}while(0);if((kNa(q,f[(f[ja>>2]|0)+8>>2]|0)|0)!=(F|0)){tYc($,428856)|0;Fj=799;break}dNa(e,0,t,m,1);g0(w,e,1,1);mk=f[ya>>2]|0;if(mk|0?(Hj=mk+12|0,mk=f[Hj>>2]|0,f[Hj>>2]=mk+-1,(mk|0)==1):0)V$(e);f[ya>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[Aa>>2]|0)>0){mk=f[Ba>>2]|0;Hj=0;do{f[mk+(Hj<<2)>>2]=0;Hj=Hj+1|0}while((Hj|0)<(f[Aa>>2]|0))}f[e>>2]=f[w>>2];Hj=f[Ca>>2]|0;f[Aa>>2]=Hj;f[Ea>>2]=f[Da>>2];f[Ga>>2]=f[Fa>>2];f[za>>2]=f[Ha>>2];f[Ja>>2]=f[Ia>>2];f[La>>2]=f[Ka>>2];f[Na>>2]=f[Ma>>2];f[Pa>>2]=f[Oa>>2];f[ya>>2]=f[Qa>>2];mk=f[Ra>>2]|0;if((mk|0)==(Sa|0))jl=Hj;else{wL(mk);f[Ra>>2]=Sa;f[Ba>>2]=Ea;jl=f[Ca>>2]|0}if((jl|0)<3){mk=f[Ta>>2]|0;f[Sa>>2]=f[mk>>2];f[wj>>2]=f[mk+4>>2];kl=mk}else{f[Ra>>2]=f[Ta>>2];f[ab>>2]=f[Ua>>2];f[Ta>>2]=Va;f[Ua>>2]=Da;kl=Va}f[w>>2]=1124007936;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;f[Ca+16>>2]=0;f[Ca+20>>2]=0;f[Ca+24>>2]=0;f[Ca+28>>2]=0;f[Qa>>2]=0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((kl|0)!=(Va|0))wL(kl);mk=f[Aa>>2]|0;if((mk|0)<3)ll=Y(f[Ga>>2]|0,f[Ea>>2]|0)|0;else{Hj=f[Ba>>2]|0;Kj=0;nk=1;while(1){$j=Y(f[Hj+(Kj<<2)>>2]|0,nk)|0;Kj=Kj+1|0;if((Kj|0)==(mk|0)){ll=$j;break}else nk=$j}}do if((ll|0)==1){tYc($,439430)|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;b[Wa>>0]=5;b[w>>0]=b[431960]|0;b[w+1>>0]=b[431961]|0;b[w+2>>0]=b[431962]|0;b[w+3>>0]=b[431963]|0;b[w+4>>0]=b[431964]|0;b[Xa>>0]=0;OGa(s,w,f[za>>2]|0)|0;if((b[Wa>>0]|0)<0)cYc(f[w>>2]|0)}else{tYc($,396723)|0;nk=f[Za>>2]|0;if((nk|0)==(f[_a>>2]|0)){bx($a,e);break}f[nk>>2]=f[e>>2];mk=nk+4|0;f[mk>>2]=f[Aa>>2];Kj=nk+8|0;f[Kj>>2]=f[Ea>>2];f[nk+12>>2]=f[Ga>>2];f[nk+16>>2]=f[za>>2];f[nk+20>>2]=f[Ja>>2];f[nk+24>>2]=f[La>>2];f[nk+28>>2]=f[Na>>2];f[nk+32>>2]=f[Pa>>2];Hj=f[ya>>2]|0;f[nk+36>>2]=Hj;f[nk+40>>2]=Kj;Kj=nk+48|0;$j=nk+44|0;f[$j>>2]=Kj;f[Kj>>2]=0;f[nk+52>>2]=0;if(Hj|0){Kj=Hj+12|0;f[Kj>>2]=(f[Kj>>2]|0)+1}if((f[Aa>>2]|0)<3){Kj=f[Ya>>2]|0;Hj=f[$j>>2]|0;f[Hj>>2]=f[Kj>>2];f[Hj+4>>2]=f[Kj+4>>2]}else{f[mk>>2]=0;U$(nk,e)}f[Za>>2]=(f[Za>>2]|0)+56}while(0);nk=f[ya>>2]|0;do if(nk|0){mk=nk+12|0;Kj=f[mk>>2]|0;f[mk>>2]=Kj+-1;if((Kj|0)!=1)break;V$(e)}while(0);f[ya>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[Aa>>2]|0)>0){nk=f[Ba>>2]|0;Kj=0;do{f[nk+(Kj<<2)>>2]=0;Kj=Kj+1|0}while((Kj|0)<(f[Aa>>2]|0))}Kj=f[Ya>>2]|0;if((Kj|0)!=(Sa|0))wL(Kj);Fj=799}while(0);if((Fj|0)==799){Fj=0;Kj=SOa(c,Z,$,s)|0;lYc(w,Z);nk=ga;f[nk>>2]=Kj;f[nk+4>>2]=0;nk=hNa(q,e,w)|0;if(!(f[nk>>2]|0)){mk=$Xc(36)|0;Hj=mk+16|0;f[Hj>>2]=f[w>>2];f[Hj+4>>2]=f[w+4>>2];f[Hj+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;Hj=ga;$j=f[Hj+4>>2]|0;Wj=mk+28|0;f[Wj>>2]=f[Hj>>2];f[Wj+4>>2]=$j;$j=f[e>>2]|0;f[mk>>2]=0;f[mk+4>>2]=0;f[mk+8>>2]=$j;f[nk>>2]=mk;$j=f[f[q>>2]>>2]|0;if(!$j)ml=mk;else{f[q>>2]=$j;ml=f[nk>>2]|0}UQ(f[a>>2]|0,ml);f[E>>2]=(f[E>>2]|0)+1}if((b[ha>>0]|0)<0)cYc(f[w>>2]|0);if((f[ia>>2]|0)>0){nk=0;do{$j=kNa(q,f[(f[ja>>2]|0)+4+(nk<<2)>>2]|0)|0;if(($j|0)!=(F|0))YOa(c,f[$j+28>>2]|0,f[$j+32>>2]|0,Kj,nk);nk=nk+1|0}while((nk|0)<(f[ia>>2]|0))}}if((b[aa>>0]|0)<0)cYc(f[v>>2]|0);Ej=Ej+1|0;if((Ej|0)>=(K|0)){nl=$;break a}}switch(Fj|0){case 41:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(32)|0;f[e>>2]=$;f[e+8>>2]=-2147483616;f[e+4>>2]=29;G=$;H=390381;I=G+29|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$+29>>0]=0;vM(-215,e,390369,389834,324);break}case 169:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ej=$Xc(32)|0;f[e>>2]=Ej;f[e+8>>2]=-2147483616;f[e+4>>2]=28;G=Ej;H=390486;I=G+28|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ej+28>>0]=0;vM(-215,e,390369,389834,384);break}case 171:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(32)|0;f[e>>2]=$;f[e+8>>2]=-2147483616;f[e+4>>2]=29;G=$;H=390515;I=G+29|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$+29>>0]=0;vM(-215,e,390369,389834,385);break}case 217:{f[k>>2]=kk;DM(e,455363,k);vM(-3,e,470867,455383,297);break}case 239:{f[j>>2]=ok;DM(e,455363,j);vM(-3,e,470867,455383,297);break}case 305:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ej=$Xc(48)|0;f[e>>2]=Ej;f[e+8>>2]=-2147483600;f[e+4>>2]=41;G=Ej;H=390586;I=G+41|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ej+41>>0]=0;vM(-213,e,390369,389834,426);break}case 397:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(32)|0;f[e>>2]=$;f[e+8>>2]=-2147483616;f[e+4>>2]=28;G=$;H=390649;I=G+28|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$+28>>0]=0;vM(-215,e,390369,389834,454);break}case 449:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ej=$Xc(32)|0;f[e>>2]=Ej;f[e+8>>2]=-2147483616;f[e+4>>2]=28;G=Ej;H=390692;I=G+28|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ej+28>>0]=0;vM(-215,e,390369,389834,474);break}case 480:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(32)|0;f[e>>2]=$;f[e+8>>2]=-2147483616;f[e+4>>2]=28;G=$;H=390692;I=G+28|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$+28>>0]=0;vM(-215,e,390369,389834,483);break}case 528:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ej=$Xc(32)|0;f[e>>2]=Ej;f[e+8>>2]=-2147483616;f[e+4>>2]=28;G=Ej;H=390649;I=G+28|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ej+28>>0]=0;vM(-215,e,390369,389834,503);break}case 553:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(32)|0;f[e>>2]=$;f[e+8>>2]=-2147483616;f[e+4>>2]=28;G=$;H=390649;I=G+28|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$+28>>0]=0;vM(-215,e,390369,389834,513);break}case 586:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ej=$Xc(32)|0;f[e>>2]=Ej;f[e+8>>2]=-2147483616;f[e+4>>2]=28;G=Ej;H=390764;I=G+28|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ej+28>>0]=0;vM(-215,e,390369,389834,528);break}case 594:{f[i>>2]=Wk;DM(e,455363,i);vM(-3,e,470867,455383,297);break}case 601:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(48)|0;f[e>>2]=$;f[e+8>>2]=-2147483600;f[e+4>>2]=46;G=$;H=390793;I=G+46|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$+46>>0]=0;vM(-215,e,390369,389834,536);break}case 606:{f[h>>2]=Zk;DM(e,455363,h);vM(-3,e,470867,455383,297);break}case 652:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Ej=$Xc(64)|0;f[e>>2]=Ej;f[e+8>>2]=-2147483584;f[e+4>>2]=56;G=Ej;H=390846;I=G+56|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[Ej+56>>0]=0;vM(-215,e,390369,389834,547);break}case 655:{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;$=$Xc(32)|0;f[e>>2]=$;f[e+8>>2]=-2147483616;f[e+4>>2]=23;G=$;H=390903;I=G+23|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[$+23>>0]=0;vM(-215,e,390369,389834,551);break}case 727:{f[g>>2]=cl;DM(e,455363,g);vM(-3,e,470867,455383,297);break}}}else nl=s+36|0;while(0);fqb(t);if((b[nl+11>>0]|0)<0)cYc(f[s+36>>2]|0);nl=s+24|0;if((b[nl+11>>0]|0)<0)cYc(f[nl>>2]|0);hx(s+12|0);QGa(s,f[X>>2]|0);X=f[r>>2]|0;if(X|0){s=f[J>>2]|0;if((s|0)==(X|0))ol=X;else{nl=s;while(1){s=nl+-12|0;f[J>>2]=s;if((b[s+11>>0]|0)<0){cYc(f[s>>2]|0);pl=f[J>>2]|0}else pl=s;if((pl|0)==(X|0))break;else nl=pl}ol=f[r>>2]|0}cYc(ol)}iNa(q,f[F>>2]|0);if((b[o+11>>0]|0)>=0){ql=m+4|0;rl=f[ql>>2]|0;SIa(m,rl);xqb(l);u=d;return}cYc(f[o>>2]|0);ql=m+4|0;rl=f[ql>>2]|0;SIa(m,rl);xqb(l);u=d;return}function hNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function iNa(a,c){a=a|0;c=c|0;if(!c)return;iNa(a,f[c>>2]|0);iNa(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function jNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;QGa(a,f[d>>2]|0);f[a>>2]=f[c>>2];e=c+4|0;g=f[e>>2]|0;f[d>>2]=g;h=c+8|0;i=f[h>>2]|0;f[a+8>>2]=i;if(!i)f[a>>2]=d;else{f[g+8>>2]=d;f[c>>2]=e;f[e>>2]=0;f[h>>2]=0}h=a+12|0;e=c+12|0;oNa(h);f[h>>2]=f[e>>2];h=c+16|0;f[a+16>>2]=f[h>>2];d=c+20|0;f[a+20>>2]=f[d>>2];f[d>>2]=0;f[h>>2]=0;f[e>>2]=0;e=a+24|0;h=c+24|0;d=e+11|0;if((b[d>>0]|0)<0){b[f[e>>2]>>0]=0;f[a+28>>2]=0}else{b[e>>0]=0;b[d>>0]=0}sYc(e,0);f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=a+36|0;e=c+36|0;c=h+11|0;if((b[c>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+40>>2]=0;sYc(h,0);f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;return a|0}else{b[h>>0]=0;b[c>>0]=0;sYc(h,0);f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;return a|0}return 0}function kNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function lNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;if(!(HIa(a,c)|0))return;$Ga(a,d,NIa(a,c)|0)|0;d=TGa(a,c)|0;if((d|0)==(a+4|0))return;c=f[d+4>>2]|0;if(!c){e=d+8|0;g=f[e>>2]|0;if((f[g>>2]|0)==(d|0))h=g;else{g=e;do{e=f[g>>2]|0;g=e+8|0;i=f[g>>2]|0}while((f[i>>2]|0)!=(e|0));h=i}}else{g=c;while(1){c=f[g>>2]|0;if(!c)break;else g=c}h=g}if((f[a>>2]|0)==(d|0))f[a>>2]=h;h=a+8|0;f[h>>2]=(f[h>>2]|0)+-1;XIa(f[a+4>>2]|0,d);a=d+16|0;RGa(d+28|0);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(d);return}function mNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+32|0;e=d;g=f[a>>2]|0;h=g;i=(f[b>>2]|0)-h|0;b=g+(i>>2<<2)|0;g=a+4|0;j=f[g>>2]|0;k=a+8|0;l=f[k>>2]|0;m=j;n=l;if(j>>>0<l>>>0){if((b|0)==(j|0)){f[b>>2]=f[c>>2];f[g>>2]=b+4;o=b;u=d;return o|0}l=m-(b+4)|0;p=l>>2;q=b+(p<<2)|0;if(q>>>0<j>>>0){r=(j+(0-p<<2)+~b|0)>>>2;s=q;q=j;while(1){f[q>>2]=f[s>>2];s=s+4|0;if(s>>>0>=j>>>0)break;else q=q+4|0}f[g>>2]=j+(r+1<<2)}if(p|0)q1c(j+(0-p<<2)|0,b|0,l|0)|0;f[b>>2]=f[c>>2];o=b;u=d;return o|0}l=(m-h>>2)+1|0;if(l>>>0>1073741823)kWc(a);m=n-h|0;h=m>>1;n=m>>2>>>0<536870911?(h>>>0<l>>>0?l:h):1073741823;h=b;l=i>>2;f[e+12>>2]=0;f[e+16>>2]=a+8;do if(n)if(n>>>0>1073741823){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{t=$Xc(n<<2)|0;break}else t=0;while(0);f[e>>2]=t;i=t+(l<<2)|0;l=e+8|0;f[l>>2]=i;m=e+4|0;f[m>>2]=i;i=e+12|0;f[i>>2]=t+(n<<2);nNa(e,c);c=f[m>>2]|0;n=f[a>>2]|0;t=h-n|0;p=c+(0-(t>>2)<<2)|0;f[m>>2]=p;if((t|0)>0)o1c(p|0,n|0,t|0)|0;t=f[g>>2]|0;n=t-h|0;if((n|0)>0){o1c(f[l>>2]|0,b|0,n|0)|0;b=(f[l>>2]|0)+(n>>>2<<2)|0;f[l>>2]=b;v=l;w=b;x=f[g>>2]|0}else{v=l;w=f[l>>2]|0;x=t}t=f[a>>2]|0;f[a>>2]=f[m>>2];f[m>>2]=t;f[g>>2]=w;f[v>>2]=x;v=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=v;f[e>>2]=t;e=x;if((e|0)!=(t|0))f[l>>2]=e+(~((e+-4-t|0)>>>2)<<2);if(t|0)cYc(t);o=c;u=d;return o|0}function nNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;if((d|0)!=(g|0)){i=d;j=f[b>>2]|0;f[i>>2]=j;k=i+4|0;f[c>>2]=k;return}g=a+4|0;l=f[g>>2]|0;m=f[a>>2]|0;n=m;if(l>>>0>m>>>0){o=l;p=((o-n>>2)+1|0)/-2|0;q=l+(p<<2)|0;r=d-o|0;o=r>>2;if(!o)s=l;else{q1c(q|0,l|0,r|0)|0;s=f[g>>2]|0}r=q+(o<<2)|0;f[c>>2]=r;f[g>>2]=s+(p<<2);i=r;j=f[b>>2]|0;f[i>>2]=j;k=i+4|0;f[c>>2]=k;return}r=h-n>>1;n=(r|0)==0?1:r;if(n>>>0>1073741823){r=af(8)|0;hYc(r,512536);f[r>>2]=192348;ig(r|0,25336,2140)}r=$Xc(n<<2)|0;h=r;p=r+(n>>>2<<2)|0;s=p;o=r+(n<<2)|0;if((l|0)==(d|0))t=s;else{n=((d+-4-l|0)>>>2)+1|0;r=l;l=p;while(1){f[l>>2]=f[r>>2];r=r+4|0;if((r|0)==(d|0))break;else l=l+4|0}t=p+(n<<2)|0}f[a>>2]=h;f[g>>2]=s;f[c>>2]=t;f[e>>2]=o;if(!m){i=t;j=f[b>>2]|0;f[i>>2]=j;k=i+4|0;f[c>>2]=k;return}cYc(m);i=f[c>>2]|0;j=f[b>>2]|0;f[i>>2]=j;k=i+4|0;f[c>>2]=k;return}function oNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;do{d=g+-56|0;f[c>>2]=d;h=g+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)V$(d);f[h>>2]=0;h=g+-40|0;d=g+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[d>>2]|0)>0){h=f[g+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+-12>>2]|0;if((d|0)!=(g+-8|0))wL(d);g=f[c>>2]|0}while((g|0)!=(b|0));e=f[a>>2]|0}cYc(e);f[a+8>>2]=0;f[c>>2]=0;f[a>>2]=0;return}function pNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+96|0;e=d;g=d+88|0;qNa(e,(b[c+11>>0]|0)<0?f[c>>2]|0:c);oOa(a);f[g>>2]=f[a>>2];c=f[a+4>>2]|0;f[g+4>>2]=c;if(c|0)TXc(c);gNa(e,g);ROa(g);cpb(e);u=d;return}function qNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+208|0;e=d+16|0;g=d;Tqb(a);h=e+112|0;i=e+8|0;f[i>>2]=82064;j=e+12|0;f[e>>2]=14996;f[h>>2]=15016;f[e+4>>2]=0;XNc(e+112|0,j);f[e+184>>2]=0;f[e+188>>2]=-1;f[e>>2]=82044;f[h>>2]=82084;f[i>>2]=82064;RHa(j);i=e+76|0;if((f[i>>2]|0)==0?(k=iKc(c,511741)|0,f[i>>2]=k,(k|0)!=0):0)f[e+100>>2]=12;else{k=e+(f[(f[e>>2]|0)+-12>>2]|0)|0;WNc(k,f[k+16>>2]|4)}if(loc(a,e)|0){f[e>>2]=82044;f[h>>2]=82084;f[e+8>>2]=82064;SHa(j);TNc(e,82096);GMc(h);u=d;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=26;h=d;e=390927;j=h+26|0;do{b[h>>0]=b[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(j|0));b[d+26>>0]=0;vM(-210,g,390954,389834,56)}}function rNa(a){a=a|0;var b=0;f[a>>2]=82044;b=a+112|0;f[b>>2]=82084;f[a+8>>2]=82064;SHa(a+12|0);TNc(a,82096);GMc(b);return}function sNa(a){a=a|0;var b=0;f[a>>2]=82044;b=a+112|0;f[b>>2]=82084;f[a+8>>2]=82064;SHa(a+12|0);TNc(a,82096);GMc(b);cYc(a);return}function tNa(a){a=a|0;var b=0;b=a+-8|0;f[b>>2]=82044;a=b+112|0;f[a>>2]=82084;f[b+8>>2]=82064;SHa(b+12|0);TNc(b,82096);GMc(a);return}function uNa(a){a=a|0;var b=0;b=a+-8|0;f[b>>2]=82044;a=b+112|0;f[a>>2]=82084;f[b+8>>2]=82064;SHa(b+12|0);TNc(b,82096);GMc(a);cYc(b);return}function vNa(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[b>>2]=82044;a=b+112|0;f[a>>2]=82084;f[b+8>>2]=82064;SHa(b+12|0);TNc(b,82096);GMc(a);return}function wNa(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[b>>2]=82044;a=b+112|0;f[a>>2]=82084;f[b+8>>2]=82064;SHa(b+12|0);TNc(b,82096);GMc(a);cYc(b);return}function xNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+400|0;g=e+212|0;h=e+24|0;i=e+12|0;j=e;k=(b[c+11>>0]|0)<0?f[c>>2]|0:c;l=g+108|0;m=g+8|0;f[g>>2]=14364;f[l>>2]=14384;f[g+4>>2]=0;XNc(g+108|0,m);f[g+180>>2]=0;f[g+184>>2]=-1;f[g>>2]=80448;f[l>>2]=80468;RHa(m);n=g+72|0;if((f[n>>2]|0)==0?(o=iKc(k,391014)|0,f[n>>2]=o,(o|0)!=0):0)f[g+96>>2]=8;else p=4;if((p|0)==4?(o=g+(f[(f[g>>2]|0)+-12>>2]|0)|0,WNc(o,f[o+16>>2]|4),(f[n>>2]|0)==0):0){lYc(i,c);c=EYc(i,0,391016)|0;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[h+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;vM(-212,h,391052,391071,207)}c=b[d+11>>0]|0;n=c<<24>>24<0;if(!((n?f[d+4>>2]|0:c&255)|0)){zNa(a,g);f[g>>2]=80448;f[l>>2]=80468;SHa(m);xNc(g,80480);GMc(l);u=e;return}c=n?f[d>>2]|0:d;n=h+108|0;o=h+8|0;f[h>>2]=14364;f[n>>2]=14384;f[h+4>>2]=0;XNc(h+108|0,o);f[h+180>>2]=0;f[h+184>>2]=-1;f[h>>2]=80448;f[n>>2]=80468;RHa(o);k=h+72|0;if((f[k>>2]|0)==0?(q=iKc(c,511741)|0,f[k>>2]=q,(q|0)!=0):0)f[h+96>>2]=12;else p=10;if((p|0)==10?(p=h+(f[(f[h>>2]|0)+-12>>2]|0)|0,WNc(p,f[p+16>>2]|4),(f[k>>2]|0)==0):0){lYc(j,d);d=EYc(j,0,391016)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-212,i,391052,391071,214)}yNa(a,g,h);f[h>>2]=80448;f[n>>2]=80468;SHa(o);xNc(h,80480);GMc(n);f[g>>2]=80448;f[l>>2]=80468;SHa(m);xNc(g,80480);GMc(l);u=e;return}function yNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+96|0;g=e+8|0;h=e;oOa(a);f[g+40>>2]=0;f[g+44>>2]=0;i=g+40|0;j=g+36|0;k=g;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;f[g+52>>2]=0;f[g+56>>2]=0;j=g+52|0;f[g+48>>2]=j;f[g+60>>2]=0;k=g+64|0;f[k>>2]=0;f[g+68>>2]=0;f[g+76>>2]=0;f[g+80>>2]=0;l=g+76|0;f[g+72>>2]=l;Srb(c,g);Trb(d,g);f[h>>2]=f[a>>2];d=f[a+4>>2]|0;f[h+4>>2]=d;if(d|0)TXc(d);CNa(g,h);ROa(h);EGa(g+72|0,f[l>>2]|0);l=g+60|0;h=f[l>>2]|0;if(h|0){d=f[k>>2]|0;if((d|0)==(h|0))m=h;else{a=d;while(1){d=a+-20|0;f[k>>2]=d;if((b[d+11>>0]|0)<0){cYc(f[d>>2]|0);n=f[k>>2]|0}else n=d;if((n|0)==(h|0))break;else a=n}m=f[l>>2]|0}cYc(m)}CLa(g+48|0,f[j>>2]|0);ANa(g+36|0,f[i>>2]|0);i=f[g+24>>2]|0;if(i|0){j=g+28|0;m=f[j>>2]|0;if((m|0)!=(i|0))f[j>>2]=m+(~((m+-4-i|0)>>>2)<<2);cYc(i)}i=g+12|0;m=f[i>>2]|0;if(!m){u=e;return}j=g+16|0;g=f[j>>2]|0;if((g|0)==(m|0))o=m;else{l=g;do{g=l+-84|0;f[j>>2]=g;BNa(g);l=f[j>>2]|0}while((l|0)!=(m|0));o=f[i>>2]|0}cYc(o);u=e;return}function zNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+96|0;e=d+8|0;g=d;oOa(a);f[e+40>>2]=0;f[e+44>>2]=0;h=e+40|0;i=e+36|0;j=e;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;f[e+52>>2]=0;f[e+56>>2]=0;i=e+52|0;f[e+48>>2]=i;f[e+60>>2]=0;j=e+64|0;f[j>>2]=0;f[e+68>>2]=0;f[e+76>>2]=0;f[e+80>>2]=0;k=e+76|0;f[e+72>>2]=k;Srb(c,e);f[g>>2]=f[a>>2];c=f[a+4>>2]|0;f[g+4>>2]=c;if(c|0)TXc(c);CNa(e,g);ROa(g);EGa(e+72|0,f[k>>2]|0);k=e+60|0;g=f[k>>2]|0;if(g|0){c=f[j>>2]|0;if((c|0)==(g|0))l=g;else{a=c;while(1){c=a+-20|0;f[j>>2]=c;if((b[c+11>>0]|0)<0){cYc(f[c>>2]|0);m=f[j>>2]|0}else m=c;if((m|0)==(g|0))break;else a=m}l=f[k>>2]|0}cYc(l)}CLa(e+48|0,f[i>>2]|0);ANa(e+36|0,f[h>>2]|0);h=f[e+24>>2]|0;if(h|0){i=e+28|0;l=f[i>>2]|0;if((l|0)!=(h|0))f[i>>2]=l+(~((l+-4-h|0)>>>2)<<2);cYc(h)}h=e+12|0;l=f[h>>2]|0;if(!l){u=d;return}i=e+16|0;e=f[i>>2]|0;if((e|0)==(l|0))n=l;else{k=e;do{e=k+-84|0;f[i>>2]=e;BNa(e);k=f[i>>2]|0}while((k|0)!=(l|0));n=f[h>>2]|0}cYc(n);u=d;return}function ANa(a,b){a=a|0;b=b|0;if(!b)return;else{ANa(a,f[b>>2]|0);ANa(a,f[b+4>>2]|0);CLa(b+20|0,f[b+24>>2]|0);cYc(b);return}}function BNa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+72|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+60|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);hx(a+48|0);QGa(a+36|0,f[a+40>>2]|0);c=a+24|0;d=f[c>>2]|0;if(d|0){e=a+28|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;while(1){g=i+-12|0;f[e>>2]=g;if((b[g+11>>0]|0)<0){cYc(f[g>>2]|0);j=f[e>>2]|0}else j=g;if((j|0)==(d|0))break;else i=j}h=f[c>>2]|0}cYc(h)}h=a+12|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[a+11>>0]|0)>=0)return;cYc(f[a>>2]|0);return}function CNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0;d=u;u=u+224|0;e=d;g=d+204|0;h=d+184|0;i=d+88|0;j=d+76|0;k=d+64|0;l=d+16|0;m=d+4|0;n=d+172|0;o=a+12|0;p=a+16|0;q=(f[p>>2]|0)-(f[o>>2]|0)|0;r=(q|0)/84|0;s=a+72|0;t=a+76|0;EGa(s,f[t>>2]|0);f[a+80>>2]=0;f[s>>2]=t;f[t>>2]=0;t=a+60|0;v=f[t>>2]|0;w=a+64|0;x=f[w>>2]|0;if((x|0)==(v|0)){y=x;z=t;A=v}else{B=x;while(1){x=B+-20|0;f[w>>2]=x;if((b[x+11>>0]|0)<0){cYc(f[x>>2]|0);C=f[w>>2]|0}else C=x;if((C|0)==(v|0))break;else B=C}y=C;z=t;A=f[t>>2]|0}C=y;B=r+1|0;v=a+68|0;a=A;if((((f[v>>2]|0)-A|0)/20|0)>>>0<B>>>0){if(B>>>0>214748364){x=af(8)|0;hYc(x,512536);f[x>>2]=192348;ig(x|0,25336,2140)}x=$Xc(B*20|0)|0;D=x+(((C-A|0)/20|0)*20|0)|0;A=D;E=x+(B*20|0)|0;if((y|0)==(a|0)){F=A;G=C;H=a}else{C=y;y=A;B=D;do{D=B+-20|0;x=C;C=C+-20|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];f[D+8>>2]=f[C+8>>2];f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;D=x+-8|0;x=f[D+4>>2]|0;I=B+-8|0;f[I>>2]=f[D>>2];f[I+4>>2]=x;B=y+-20|0;y=B}while((C|0)!=(a|0));F=y;G=f[z>>2]|0;H=f[w>>2]|0}f[z>>2]=F;f[w>>2]=A;f[v>>2]=E;E=G;if((H|0)!=(E|0)){A=H;do{A=A+-20|0;if((b[A+11>>0]|0)<0)cYc(f[A>>2]|0)}while((A|0)!=(E|0))}if(G|0)cYc(G)}f[g>>2]=0;G=g+4|0;f[G>>2]=0;f[g+8>>2]=0;E=$Xc(12)|0;f[g>>2]=E;f[g+8>>2]=E+12;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[G>>2]=E+12;E=i+11|0;A=h+12|0;H=h+11|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[E>>0]=4;f[i>>2]=1635017060;b[i+4>>0]=0;lYc(h,i);f[A>>2]=0;f[h+16>>2]=0;F=f[w>>2]|0;y=f[v>>2]|0;a=y;if(F>>>0>=y>>>0){y=F;C=f[z>>2]|0;B=(y-C|0)/20|0;x=B+1|0;I=C;if(x>>>0>214748364)kWc(t);D=(a-C|0)/20|0;C=D<<1;a=D>>>0<107374182?(C>>>0<x>>>0?x:C):214748364;do if(a)if(a>>>0>214748364){C=af(8)|0;hYc(C,512536);f[C>>2]=192348;ig(C|0,25336,2140)}else{J=$Xc(a*20|0)|0;break}else J=0;while(0);C=J+(B*20|0)|0;x=C;D=J+(a*20|0)|0;f[C>>2]=f[h>>2];f[C+4>>2]=f[h+4>>2];f[C+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=A;K=f[a+4>>2]|0;L=J+(B*20|0)+12|0;f[L>>2]=f[a>>2];f[L+4>>2]=K;K=C+20|0;if((F|0)==(I|0)){M=x;N=y;O=F}else{y=F;L=x;x=C;do{C=x+-20|0;a=y;y=y+-20|0;f[C>>2]=f[y>>2];f[C+4>>2]=f[y+4>>2];f[C+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;C=a+-8|0;a=f[C+4>>2]|0;B=x+-8|0;f[B>>2]=f[C>>2];f[B+4>>2]=a;x=L+-20|0;L=x}while((y|0)!=(I|0));M=L;N=f[z>>2]|0;O=f[w>>2]|0}f[z>>2]=M;f[w>>2]=K;f[v>>2]=D;D=N;if((O|0)!=(D|0)){K=O;do{K=K+-20|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0)}while((K|0)!=(D|0))}if(N|0)cYc(N)}else{f[F>>2]=f[h>>2];f[F+4>>2]=f[h+4>>2];f[F+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;N=A;A=f[N+4>>2]|0;D=F+12|0;f[D>>2]=f[N>>2];f[D+4>>2]=A;f[w>>2]=(f[w>>2]|0)+20}if((b[H>>0]|0)<0)cYc(f[h>>2]|0);if((b[E>>0]|0)<0)cYc(f[i>>2]|0);b[h>>0]=0;b[h+1>>0]=0;b[h+2>>0]=0;b[h+3>>0]=0;b[h+4>>0]=0;b[h+5>>0]=0;E=f[g>>2]|0;H=E+11|0;if((b[H>>0]|0)<0){b[f[E>>2]>>0]=0;f[E+4>>2]=0}else{b[E>>0]=0;b[H>>0]=0}sYc(E,0);f[E>>2]=1635017060;b[E+4>>0]=0;H=E+5|0;b[H>>0]=b[h>>0]|0;b[H+1>>0]=b[h+1>>0]|0;b[H+2>>0]=b[h+2>>0]|0;b[H+3>>0]=b[h+3>>0]|0;b[H+4>>0]=b[h+4>>0]|0;b[H+5>>0]=b[h+5>>0]|0;b[E+11>>0]=4;lQa(c,g);E=f[g>>2]|0;if(E|0){H=f[G>>2]|0;if((H|0)==(E|0))P=E;else{A=H;while(1){H=A+-12|0;f[G>>2]=H;if((b[H+11>>0]|0)<0){cYc(f[H>>2]|0);Q=f[G>>2]|0}else Q=H;if((Q|0)==(E|0))break;else A=Q}P=f[g>>2]|0}cYc(P)}a:do if((q|0)>0){P=i+12|0;Q=i+36|0;A=i+24|0;E=i+28|0;G=m+11|0;H=m+4|0;D=n+11|0;N=g+11|0;F=g+4|0;K=h+11|0;O=h+4|0;M=h+12|0;L=h+16|0;I=h+11|0;y=l+36|0;x=y+11|0;a=l+24|0;B=a+11|0;C=l+12|0;J=l+4|0;R=k+11|0;S=j+11|0;T=g+11|0;U=g+4|0;V=0;b:while(1){W=f[o>>2]|0;if((((f[p>>2]|0)-W|0)/84|0)>>>0<=V>>>0){X=58;break}DNa(i,W+(V*84|0)|0);lYc(j,i);lYc(k,P);ENa(l,Q);W=IGa(s,j)|0;Y=f[W>>2]|0;f[W>>2]=Y+1;if(Y|0?(f[e>>2]=Y,DM(g,391156,e),Y=b[T>>0]|0,W=Y<<24>>24<0,zYc(j,W?f[g>>2]|0:g,W?f[U>>2]|0:Y&255)|0,(b[T>>0]|0)<0):0)cYc(f[g>>2]|0);Y=SOa(c,j,k,l)|0;W=f[E>>2]|0;Z=f[A>>2]|0;if((W-Z|0)>0){_=0;$=Z;Z=W;do{if(((Z-$|0)/12|0)>>>0<=_>>>0){X=65;break b}lYc(m,$+(_*12|0)|0);lYc(n,i);W=f[z>>2]|0;aa=(f[w>>2]|0)-W|0;ba=W;if((aa|0)<=0){X=79;break b}W=(aa>>>0)/20|0;aa=b[G>>0]|0;ca=aa<<24>>24<0;da=ca?f[H>>2]|0:aa&255;aa=ca?f[m>>2]|0:m;c:do if(da){ca=W;d:while(1){ea=ca+-1|0;fa=ba+(ea*20|0)|0;ga=b[fa+11>>0]|0;ha=ga<<24>>24<0;ia=ga&255;do if(((ha?f[ba+(ea*20|0)+4>>2]|0:ia)|0)==(da|0)){ga=f[fa>>2]|0;if(ha)if(!(WKc(ga,aa,da)|0)){ja=ea;break c}else break;if((ga&255)<<24>>24!=(b[aa>>0]|0))break;ga=fa;ka=ia;la=aa;do{ka=ka+-1|0;ga=ga+1|0;if(!ka)break d;la=la+1|0}while((b[ga>>0]|0)==(b[la>>0]|0))}while(0);if((ca|0)>1)ca=ea;else{X=79;break b}}if((ca|0)<1){X=79;break b}else ja=ea}else{ia=W;while(1){fa=ia;ia=ia+-1|0;ha=b[ba+(ia*20|0)+11>>0]|0;if(!((ha<<24>>24<0?f[ba+(ia*20|0)+4>>2]|0:ha&255)|0)){ja=ia;break c}if((fa|0)<=1){X=79;break b}}}while(0);YOa(c,f[ba+(ja*20|0)+12>>2]|0,f[ba+(ja*20|0)+16>>2]|0,Y,_);if((b[D>>0]|0)<0)cYc(f[n>>2]|0);if((b[G>>0]|0)<0)cYc(f[m>>2]|0);_=_+1|0;Z=f[E>>2]|0;$=f[A>>2]|0}while((_|0)<((Z-$|0)/12|0|0))}lYc(g,i);$=f[z>>2]|0;Z=(f[w>>2]|0)-$|0;_=$;e:do if((Z|0)>0){$=(Z>>>0)/20|0;W=b[N>>0]|0;aa=W<<24>>24<0;da=aa?f[F>>2]|0:W&255;W=aa?f[g>>2]|0:g;f:do if(!da){aa=$;while(1){ia=aa;aa=aa+-1|0;ca=b[_+(aa*20|0)+11>>0]|0;if(!((ca<<24>>24<0?f[_+(aa*20|0)+4>>2]|0:ca&255)|0))break f;if((ia|0)<=1)break e}}else{aa=$;while(1){ia=aa;aa=aa+-1|0;ca=_+(aa*20|0)|0;fa=b[ca+11>>0]|0;ha=fa<<24>>24<0;la=fa&255;do if(((ha?f[_+(aa*20|0)+4>>2]|0:la)|0)==(da|0)){fa=f[ca>>2]|0;if(ha)if(!(WKc(fa,W,da)|0))break f;else break;if((fa&255)<<24>>24!=(b[W>>0]|0))break;fa=ca;ga=la;ka=W;do{ga=ga+-1|0;fa=fa+1|0;if(!ga)break f;ka=ka+1|0}while((b[fa>>0]|0)==(b[ka>>0]|0))}while(0);if((ia|0)<=1)break e}}while(0);W=f[A>>2]|0;if(((f[E>>2]|0)-W|0)<=0){X=120;break b}lYc(h,W);W=b[K>>0]|0;da=W<<24>>24<0;$=W&255;W=da?f[O>>2]|0:$;ba=b[N>>0]|0;aa=ba<<24>>24<0;g:do if((W|0)==((aa?f[F>>2]|0:ba&255)|0)){la=f[h>>2]|0;ca=da?la:h;ha=aa?f[g>>2]|0:g;ka=(W|0)==0;if(da)if(!ka){fa=(WKc(ca,ha,W)|0)==0;cYc(la);if(fa)break e;else{X=120;break b}}else{cYc(la);break e}if(ka)break e;if((la&255)<<24>>24==(b[ha>>0]|0)){ma=h;na=$;oa=ha}else{X=111;break b}while(1){na=na+-1|0;ma=ma+1|0;if(!na){pa=1;break g}oa=oa+1|0;if((b[ma>>0]|0)!=(b[oa>>0]|0)){pa=0;break}}}else pa=0;while(0);if(da){cYc(f[h>>2]|0);if(pa)break;else{X=120;break b}}else if(pa)break;else{X=120;break b}}while(0);lYc(h,g);f[M>>2]=Y;f[L>>2]=0;_=f[w>>2]|0;Z=f[v>>2]|0;$=Z;do if(_>>>0<Z>>>0){f[_>>2]=f[h>>2];f[_+4>>2]=f[h+4>>2];f[_+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;W=M;aa=f[W+4>>2]|0;ba=_+12|0;f[ba>>2]=f[W>>2];f[ba+4>>2]=aa;f[w>>2]=(f[w>>2]|0)+20}else{aa=_;ba=f[z>>2]|0;W=(aa-ba|0)/20|0;ha=W+1|0;la=ba;if(ha>>>0>214748364){X=125;break b}ka=($-ba|0)/20|0;ba=ka<<1;fa=ka>>>0<107374182?(ba>>>0<ha>>>0?ha:ba):214748364;if(!fa)qa=0;else{if(fa>>>0>214748364){X=128;break b}qa=$Xc(fa*20|0)|0}ba=qa+(W*20|0)|0;ha=ba;ka=qa+(fa*20|0)|0;f[ba>>2]=f[h>>2];f[ba+4>>2]=f[h+4>>2];f[ba+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;fa=M;ca=f[fa+4>>2]|0;ga=qa+(W*20|0)+12|0;f[ga>>2]=f[fa>>2];f[ga+4>>2]=ca;ca=ba+20|0;if((_|0)==(la|0)){ra=ha;sa=aa;ta=_}else{aa=_;ga=ha;ha=ba;do{ba=ha+-20|0;fa=aa;aa=aa+-20|0;f[ba>>2]=f[aa>>2];f[ba+4>>2]=f[aa+4>>2];f[ba+8>>2]=f[aa+8>>2];f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;ba=fa+-8|0;fa=f[ba+4>>2]|0;W=ha+-8|0;f[W>>2]=f[ba>>2];f[W+4>>2]=fa;ha=ga+-20|0;ga=ha}while((aa|0)!=(la|0));ra=ga;sa=f[z>>2]|0;ta=f[w>>2]|0}f[z>>2]=ra;f[w>>2]=ca;f[v>>2]=ka;la=sa;if((ta|0)!=(la|0)){aa=ta;do{aa=aa+-20|0;if((b[aa+11>>0]|0)<0)cYc(f[aa>>2]|0)}while((aa|0)!=(la|0))}if(!sa)break;cYc(sa)}while(0);if((b[I>>0]|0)<0)cYc(f[h>>2]|0);if((b[N>>0]|0)<0)cYc(f[g>>2]|0);if((b[x>>0]|0)<0)cYc(f[y>>2]|0);if((b[B>>0]|0)<0)cYc(f[a>>2]|0);hx(C);QGa(l,f[J>>2]|0);if((b[R>>0]|0)<0)cYc(f[k>>2]|0);if((b[S>>0]|0)<0)cYc(f[j>>2]|0);BNa(i);V=V+1|0;if((V|0)>=(r|0))break a}if((X|0)==58)lWc(o);else if((X|0)==65)lWc(A);else if((X|0)==79){SGa(h,391160,m);V=AYc(h,505469)|0;f[g>>2]=f[V>>2];f[g+4>>2]=f[V+4>>2];f[g+8>>2]=f[V+8>>2];f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;vM(-204,g,391185,391071,176)}else if((X|0)==111){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ua=$Xc(48)|0;f[h>>2]=ua;va=h+8|0;f[va>>2]=-2147483600;wa=h+4|0;f[wa>>2]=44;xa=ua;ya=391194;za=xa+44|0;do{b[xa>>0]=b[ya>>0]|0;xa=xa+1|0;ya=ya+1|0}while((xa|0)<(za|0));Aa=ua+44|0;b[Aa>>0]=0;vM(-5,h,391239,391071,159)}else if((X|0)==120){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;ua=$Xc(48)|0;f[h>>2]=ua;va=h+8|0;f[va>>2]=-2147483600;wa=h+4|0;f[wa>>2]=44;xa=ua;ya=391194;za=xa+44|0;do{b[xa>>0]=b[ya>>0]|0;xa=xa+1|0;ya=ya+1|0}while((xa|0)<(za|0));Aa=ua+44|0;b[Aa>>0]=0;vM(-5,h,391239,391071,159)}else if((X|0)==125)kWc(t);else if((X|0)==128){A=af(8)|0;hYc(A,512536);f[A>>2]=192348;ig(A|0,25336,2140)}}while(0);X=f[t>>2]|0;t=f[w>>2]|0;if((t|0)==(X|0)){u=d;return}else Ba=t;while(1){t=Ba+-20|0;f[w>>2]=t;if((b[t+11>>0]|0)<0){cYc(f[t>>2]|0);Ca=f[w>>2]|0}else Ca=t;if((Ca|0)==(X|0))break;else Ba=Ca}u=d;return}function DNa(a,b){a=a|0;b=b|0;lYc(a,b);lYc(a+12|0,b+12|0);MN(a+24|0,b+24|0);ENa(a+36|0,b+36|0);return}function ENa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b>>2]|0;i=b+4|0;if((h|0)!=(i|0)){j=g;g=h;while(1){h=g+16|0;f[e>>2]=j;f[d>>2]=f[e>>2];FNa(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){k=g+8|0;l=f[k>>2]|0;if((f[l>>2]|0)==(g|0))m=l;else{l=k;do{k=f[l>>2]|0;l=k+8|0;n=f[l>>2]|0}while((f[n>>2]|0)!=(k|0));m=n}}else{l=h;while(1){n=f[l>>2]|0;if(!n)break;else l=n}m=l}if((m|0)==(i|0))break;else g=m}}GNa(a+12|0,b+12|0);lYc(a+24|0,b+24|0);lYc(a+36|0,b+36|0);u=c;return}function FNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;f[i>>2]=f[b>>2];f[g>>2]=f[i>>2];i=HNa(a,g,h,e+4|0,c)|0;c=f[i>>2]|0;if(c|0){j=c;u=e;return j|0}c=$Xc(36)|0;lYc(c+16|0,d);VGa(c+28|0,d+12|0);d=f[h>>2]|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=d;f[i>>2]=c;d=f[f[a>>2]>>2]|0;if(!d)k=c;else{f[a>>2]=d;k=f[i>>2]|0}UQ(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;j=c;u=e;return j|0}function GNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/56|0;if(!e)return;if(g>>>0>76695844)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*56|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{f[g>>2]=f[d>>2];h=g+4|0;a=d+4|0;f[h>>2]=f[a>>2];e=g+8|0;f[e>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[g+16>>2]=f[d+16>>2];f[g+20>>2]=f[d+20>>2];f[g+24>>2]=f[d+24>>2];f[g+28>>2]=f[d+28>>2];f[g+32>>2]=f[d+32>>2];i=f[d+36>>2]|0;f[g+36>>2]=i;f[g+40>>2]=e;e=g+48|0;j=g+44|0;f[j>>2]=e;f[e>>2]=0;f[g+52>>2]=0;if(i|0){e=i+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;e=f[j>>2]|0;f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2]}else{f[h>>2]=0;U$(g,d)}d=d+56|0;g=(f[c>>2]|0)+56|0;f[c>>2]=g}while((d|0)!=(b|0));return}function HNa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=i+16|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[i+20>>2]|0:k&255;k=b[g+11>>0]|0;n=k<<24>>24<0;o=n?f[g+4>>2]|0:k&255;k=m>>>0<o>>>0;p=k?m:o;if((p|0)!=0?(q=WKc(n?f[g>>2]|0:g,l?f[j>>2]|0:j,p)|0,(q|0)!=0):0){if((q|0)<0)break}else r=4;if((r|0)==4?o>>>0<m>>>0:0)break;q=o>>>0<m>>>0?o:m;if((q|0)!=0?(m=WKc(l?f[j>>2]|0:j,n?f[g>>2]|0:g,q)|0,(m|0)!=0):0){if((m|0)>=0)r=36}else r=20;if((r|0)==20?!k:0)r=36;if((r|0)==36){f[d>>2]=c;f[e>>2]=c;s=e;return s|0}k=i+4|0;m=f[k>>2]|0;if(!m){q=i+8|0;j=f[q>>2]|0;if((f[j>>2]|0)==(i|0))t=j;else{j=q;do{q=f[j>>2]|0;j=q+8|0;l=f[j>>2]|0}while((f[l>>2]|0)!=(q|0));t=l}}else{j=m;while(1){l=f[j>>2]|0;if(!l)break;else j=l}t=j}do if((t|0)!=(h|0)){m=t+16|0;l=b[m+11>>0]|0;q=l<<24>>24<0;p=q?f[t+20>>2]|0:l&255;l=p>>>0<o>>>0?p:o;if((l|0)!=0?(u=WKc(n?f[g>>2]|0:g,q?f[m>>2]|0:m,l)|0,(u|0)!=0):0){if((u|0)<0)break}else r=30;if((r|0)==30?o>>>0<p>>>0:0)break;s=WGa(a,d,g)|0;return s|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;s=k;return s|0}else{f[d>>2]=t;s=t;return s|0}}while(0);t=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))v=c;else{if(!t){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{w=e;break}}}else{h=t;while(1){k=f[h+4>>2]|0;if(!k){w=h;break}else h=k}}h=w;k=w+16|0;e=b[g+11>>0]|0;o=e<<24>>24<0;n=o?f[g+4>>2]|0:e&255;e=b[k+11>>0]|0;j=e<<24>>24<0;p=j?f[w+20>>2]|0:e&255;e=n>>>0<p>>>0?n:p;if((e|0)!=0?(u=WKc(j?f[k>>2]|0:k,o?f[g>>2]|0:g,e)|0,(u|0)!=0):0){if((u|0)<0){v=h;break}}else r=12;if((r|0)==12?p>>>0<n>>>0:0){v=h;break}s=WGa(a,d,g)|0;return s|0}while(0);if(!t){f[d>>2]=i;s=i;return s|0}else{i=v;f[d>>2]=i;s=i+4|0;return s|0}return 0}function INa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+240|0;h=g+208|0;i=g+120|0;j=g+88|0;k=g;aOc(h);f[h>>2]=82140;f[h+8>>2]=b;f[h+12>>2]=b;f[h+16>>2]=b+c;f[i>>2]=188912;f[i+8>>2]=188932;f[i+4>>2]=0;c=f[47225]|0;b=i+c|0;XNc(b,h);f[b+72>>2]=0;f[b+76>>2]=-1;if(!e){zNa(a,i);tNc(i);LMc(h);u=g;return}else{aOc(j);f[j>>2]=82140;f[j+8>>2]=d;f[j+12>>2]=d;f[j+16>>2]=d+e;f[k>>2]=188912;f[k+8>>2]=188932;f[k+4>>2]=0;e=k+c|0;XNc(e,j);f[e+72>>2]=0;f[e+76>>2]=-1;yNa(a,i,k);tNc(k);LMc(j);tNc(i);LMc(h);u=g;return}}function JNa(a){a=a|0;LMc(a);return}function KNa(a){a=a|0;LMc(a);cYc(a);return}function LNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[b>>2]|0;e=f[c>>2]|0;g=f[c+4>>2]|0;INa(a,d,(f[b+4>>2]|0)-d|0,(e|0)==(g|0)?0:e,g-e|0);return}function MNa(a){a=a|0;var c=0;f[a>>2]=82204;c=a+28|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+16|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);hx(a+4|0);qP(a);return}function NNa(a){a=a|0;var c=0;f[a>>2]=82204;c=a+28|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+16|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);hx(a+4|0);qP(a);cYc(a);return}function ONa(a,b,c){a=a|0;b=b|0;c=c|0;return}function PNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;gS(b,e);gS(c,g);f[h>>2]=0;c=h+4|0;f[c>>2]=0;f[h+8>>2]=0;b=f[i>>2]|0;j=f[e>>2]|0;k=b-j|0;if(!k){l=j;m=b}else{hOa(h,(k|0)/56|0);l=f[e>>2]|0;m=f[i>>2]|0}if((m|0)!=(l|0)){m=0;k=l;do{f[(f[h>>2]|0)+(m<<2)>>2]=k+(m*56|0);m=m+1|0;k=f[e>>2]|0}while(m>>>0<(((f[i>>2]|0)-k|0)/56|0)>>>0)}Ti[f[(f[a>>2]|0)+32>>2]&511](a,h,g);a=f[h>>2]|0;if(!a){hx(g);hx(e);u=d;return}h=f[c>>2]|0;if((h|0)!=(a|0))f[c>>2]=h+(~((h+-4-a|0)>>>2)<<2);cYc(a);hx(g);hx(e);u=d;return}function QNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function RNa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fOa(a,b,c,d);return}function SNa(a,b){a=a|0;b=b|0;return -1}function TNa(a,b){a=a|0;b=b|0;return 0}function UNa(a,b){a=a|0;b=b|0;return (b|0)==3|0}function VNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=u;u=u+32|0;a=c+12|0;d=c;SGa(d,391450,b+28|0);b=AYc(d,391372)|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;vM(-213,a,391470,391289,3252)}function WNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=u;u=u+32|0;a=c+12|0;d=c;SGa(d,391406,b+28|0);b=AYc(d,391372)|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;vM(-213,a,391436,391289,3259)}function XNa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=u;u=u+32|0;a=c+12|0;d=c;SGa(d,391353,b+28|0);b=AYc(d,391372)|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;vM(-213,a,391396,391289,3245)}function YNa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function ZNa(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function _Na(a,b){a=a|0;b=b|0;return 0}function $Na(a,b){a=a|0;b=b|0;return 0}function aOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;a=u;u=u+64|0;d=a;f[d>>2]=1124007936;e=d+4|0;g=d+8|0;h=d+40|0;i=e;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;k=d+48|0;f[d+44>>2]=k;f[k>>2]=0;f[d+52>>2]=0;if((d|0)!=(b|0)){l=b+36|0;m=f[l>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(b);f[l>>2]=0;m=b+16|0;n=b+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){o=f[b+40>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[n>>2]|0))}f[b>>2]=f[d>>2];p=f[e>>2]|0;f[n>>2]=p;n=b+8|0;f[n>>2]=f[g>>2];f[b+12>>2]=f[d+12>>2];f[m>>2]=f[d+16>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];m=d+36|0;f[l>>2]=f[m>>2];l=b+44|0;o=f[l>>2]|0;q=b+48|0;if((o|0)==(q|0)){r=p;s=o}else{wL(o);f[l>>2]=q;f[b+40>>2]=n;r=f[e>>2]|0;s=q}q=d+44|0;if((r|0)<3){r=f[q>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];t=r}else{f[l>>2]=f[q>>2];f[b+40>>2]=f[h>>2];f[q>>2]=k;f[h>>2]=g;t=k}f[d>>2]=1124007936;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[m>>2]=0;m=d+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((t|0)!=(k|0))wL(t)}else{f[d+36>>2]=0;t=d+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0}f[d>>2]=1124007936;t=d+4|0;k=d+8|0;m=d+40|0;i=t;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[m>>2]=k;i=d+48|0;f[d+44>>2]=i;f[i>>2]=0;f[d+52>>2]=0;if((d|0)==(c|0)){f[d+36>>2]=0;j=d+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;u=a;return}j=c+36|0;e=f[j>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[j>>2]=0;e=c+16|0;g=c+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){h=f[c+40>>2]|0;q=0;do{f[h+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[g>>2]|0))}f[c>>2]=f[d>>2];q=f[t>>2]|0;f[g>>2]=q;g=c+8|0;f[g>>2]=f[k>>2];f[c+12>>2]=f[d+12>>2];f[e>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[c+28>>2]=f[d+28>>2];f[c+32>>2]=f[d+32>>2];e=d+36|0;f[j>>2]=f[e>>2];j=c+44|0;h=f[j>>2]|0;b=c+48|0;if((h|0)==(b|0)){v=q;w=h}else{wL(h);f[j>>2]=b;f[c+40>>2]=g;v=f[t>>2]|0;w=b}b=d+44|0;if((v|0)<3){v=f[b>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];x=v}else{f[j>>2]=f[b>>2];f[c+40>>2]=f[m>>2];f[b>>2]=i;f[m>>2]=k;x=i}f[d>>2]=1124007936;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((x|0)==(i|0)){u=a;return}wL(x);u=a;return}function bOa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;d=f[(f[a>>2]|0)+80>>2]|0;f[c>>2]=0;e=c+4|0;f[e>>2]=0;Mi[d&1023](a,c)|0;c=f[e>>2]|0;if(!c){u=b;return}UXc(c);u=b;return}function cOa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;a=g;h=f[c>>2]|0;i=(f[c+4>>2]|0)-h|0;c=(i|0)/12|0;if(!i){i=$Xc(16)|0;f[a>>2]=i;f[a+8>>2]=-2147483632;f[a+4>>2]=13;j=i;k=442829;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+13>>0]=0;vM(-215,a,456079,391289,3480)}else{eOa(e,(c|0)>(d|0)?c:d,h);u=g;return 0}return 0}function dOa(a,b,c){a=a|0;b=b|0;c=c|0;J=0;return 0}function eOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;if(((e-g|0)/12|0)>>>0<b>>>0){if(!g)i=e;else{e=a+4|0;j=f[e>>2]|0;if((j|0)==(h|0))k=g;else{l=j;while(1){j=l+-12|0;f[e>>2]=j;m=f[j>>2]|0;if(!m)n=j;else{j=l+-8|0;o=f[j>>2]|0;if((o|0)!=(m|0))f[j>>2]=o+(~((o+-4-m|0)>>>2)<<2);cYc(m);n=f[e>>2]|0}if((n|0)==(h|0))break;else l=n}k=f[a>>2]|0}cYc(k);f[d>>2]=0;f[e>>2]=0;f[a>>2]=0;i=0}if(b>>>0>357913941)kWc(a);e=(i|0)/12|0;i=e<<1;k=e>>>0<178956970?(i>>>0<b>>>0?b:i):357913941;if(k>>>0>357913941)kWc(a);i=$Xc(k*12|0)|0;e=a+4|0;f[e>>2]=i;f[a>>2]=i;f[d>>2]=i+(k*12|0);k=b;d=i;do{eKa(d,c);d=(f[e>>2]|0)+12|0;f[e>>2]=d;k=k+-1|0}while((k|0)!=0);return}k=a+4|0;d=((f[k>>2]|0)-g|0)/12|0;g=d>>>0<b>>>0;e=g?d:b;if(e|0){i=c+4|0;n=e;e=h;while(1){if((e|0)!=(c|0))eEa(e,f[c>>2]|0,f[i>>2]|0);n=n+-1|0;if(!n)break;else e=e+12|0}}if(g){g=b-d|0;d=f[k>>2]|0;do{eKa(d,c);d=(f[k>>2]|0)+12|0;f[k>>2]=d;g=g+-1|0}while((g|0)!=0);return}g=(f[a>>2]|0)+(b*12|0)|0;b=f[k>>2]|0;if((b|0)==(g|0))return;else p=b;while(1){b=p+-12|0;f[k>>2]=b;a=f[b>>2]|0;if(!a)q=b;else{b=p+-8|0;d=f[b>>2]|0;if((d|0)!=(a|0))f[b>>2]=d+(~((d+-4-a|0)>>>2)<<2);cYc(a);q=f[k>>2]|0}if((q|0)==(g|0))break;else p=q}return}function fOa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+128|0;g=e+108|0;h=e+96|0;i=e+84|0;j=e+72|0;k=e+60|0;l=e+48|0;m=e+32|0;n=e+16|0;o=e;if((f[a+40>>2]|0)==2?(qS(b,-1)|0)==3:0){f[g>>2]=0;p=g+4|0;f[p>>2]=0;f[g+8>>2]=0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;f[k>>2]=0;t=k+4|0;f[t>>2]=0;f[k+8>>2]=0;f[l>>2]=0;v=l+4|0;f[v>>2]=0;f[l+8>>2]=0;jS(b,j);jS(c,k);jS(d,l);w=((f[s>>2]|0)-(f[j>>2]|0)|0)/48|0;x=f[p>>2]|0;y=f[g>>2]|0;z=(x-y|0)/48|0;A=y;y=x;if(w>>>0<=z>>>0){if(w>>>0<z>>>0?(x=A+(w*48|0)|0,(y|0)!=(x|0)):0){A=y;do{y=A+-48|0;f[p>>2]=y;EQ(y);A=f[p>>2]|0}while((A|0)!=(x|0))}}else kS(g,w-z|0);z=f[j>>2]|0;if((f[s>>2]|0)!=(z|0)){w=m+8|0;x=m+12|0;A=m+4|0;y=n+8|0;B=n+4|0;C=0;D=z;do{f[w>>2]=0;f[x>>2]=0;f[m>>2]=17432576;f[A>>2]=D+(C*48|0);z=(f[g>>2]|0)+(C*48|0)|0;E=y;f[E>>2]=0;f[E+4>>2]=0;f[n>>2]=34209792;f[B>>2]=z;eY(m,n);C=C+1|0;D=f[j>>2]|0}while(C>>>0<(((f[s>>2]|0)-D|0)/48|0)>>>0)}D=((f[t>>2]|0)-(f[k>>2]|0)|0)/48|0;C=f[q>>2]|0;B=f[h>>2]|0;y=(C-B|0)/48|0;A=B;B=C;if(D>>>0<=y>>>0){if(D>>>0<y>>>0?(C=A+(D*48|0)|0,(B|0)!=(C|0)):0){A=B;do{B=A+-48|0;f[q>>2]=B;EQ(B);A=f[q>>2]|0}while((A|0)!=(C|0))}}else kS(h,D-y|0);y=f[k>>2]|0;if((f[t>>2]|0)!=(y|0)){D=m+4|0;C=m+8|0;A=0;B=y;do{y=B;x=f[h>>2]|0;w=f[y+(A*48|0)+4>>2]|0;z=f[y+(A*48|0)+32>>2]|0;f[m>>2]=0;f[D>>2]=0;f[C>>2]=0;gOa(m,z,z+(w<<2)|0);CQ(x+(A*48|0)|0,m,5,0);x=f[m>>2]|0;if(x|0){w=f[D>>2]|0;if((w|0)!=(x|0))f[D>>2]=w+(~((w+-4-x|0)>>>2)<<2);cYc(x)}A=A+1|0;B=f[k>>2]|0}while(A>>>0<(((f[t>>2]|0)-B|0)/48|0)>>>0)}B=((f[v>>2]|0)-(f[l>>2]|0)|0)/48|0;A=f[r>>2]|0;D=f[i>>2]|0;C=(A-D|0)/48|0;x=D;D=A;if(B>>>0<=C>>>0){if(B>>>0<C>>>0?(A=x+(B*48|0)|0,(D|0)!=(A|0)):0){x=D;do{D=x+-48|0;f[r>>2]=D;EQ(D);x=f[r>>2]|0}while((x|0)!=(A|0))}}else kS(i,B-C|0);C=f[l>>2]|0;if((f[v>>2]|0)!=(C|0)){B=m+4|0;A=m+8|0;x=0;D=C;do{C=D;w=f[i>>2]|0;z=f[C+(x*48|0)+4>>2]|0;y=f[C+(x*48|0)+32>>2]|0;f[m>>2]=0;f[B>>2]=0;f[A>>2]=0;gOa(m,y,y+(z<<2)|0);CQ(w+(x*48|0)|0,m,5,0);w=f[m>>2]|0;if(w|0){z=f[B>>2]|0;if((z|0)!=(w|0))f[B>>2]=z+(~((z+-4-w|0)>>>2)<<2);cYc(w)}x=x+1|0;D=f[l>>2]|0}while(x>>>0<(((f[v>>2]|0)-D|0)/48|0)>>>0)}D=f[(f[a>>2]|0)+44>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=17498112;f[m+4>>2]=g;x=n+8|0;f[x>>2]=0;f[x+4>>2]=0;f[n>>2]=34275328;f[n+4>>2]=h;x=o+8|0;f[x>>2]=0;f[x+4>>2]=0;f[o>>2]=34275328;f[o+4>>2]=i;ei[D&511](a,m,n,o);o=f[h>>2]|0;if((f[q>>2]|0)!=(o|0)){D=m+8|0;x=m+12|0;B=m+4|0;A=n+8|0;w=n+4|0;z=0;y=o;do{f[D>>2]=0;f[x>>2]=0;f[m>>2]=17432576;f[B>>2]=y+(z*48|0);o=(f[k>>2]|0)+(z*48|0)|0;C=A;f[C>>2]=0;f[C+4>>2]=0;f[n>>2]=34209792;f[w>>2]=o;eY(m,n);z=z+1|0;y=f[h>>2]|0}while(z>>>0<(((f[q>>2]|0)-y|0)/48|0)>>>0)}dT(c,k);dT(d,l);y=f[l>>2]|0;if(y|0){z=f[v>>2]|0;if((z|0)==(y|0))F=y;else{n=z;do{z=n+-48|0;f[v>>2]=z;EQ(z);n=f[v>>2]|0}while((n|0)!=(y|0));F=f[l>>2]|0}cYc(F)}F=f[k>>2]|0;if(F|0){l=f[t>>2]|0;if((l|0)==(F|0))G=F;else{y=l;do{l=y+-48|0;f[t>>2]=l;EQ(l);y=f[t>>2]|0}while((y|0)!=(F|0));G=f[k>>2]|0}cYc(G)}G=f[j>>2]|0;if(G|0){k=f[s>>2]|0;if((k|0)==(G|0))H=G;else{F=k;do{k=F+-48|0;f[s>>2]=k;EQ(k);F=f[s>>2]|0}while((F|0)!=(G|0));H=f[j>>2]|0}cYc(H)}H=f[i>>2]|0;if(H|0){G=f[r>>2]|0;if((G|0)==(H|0))I=H;else{F=G;do{G=F+-48|0;f[r>>2]=G;EQ(G);F=f[r>>2]|0}while((F|0)!=(H|0));I=f[i>>2]|0}cYc(I)}I=f[h>>2]|0;if(I|0){H=f[q>>2]|0;if((H|0)==(I|0))J=I;else{F=H;do{H=F+-48|0;f[q>>2]=H;EQ(H);F=f[q>>2]|0}while((F|0)!=(I|0));J=f[h>>2]|0}cYc(J)}J=f[g>>2]|0;if(J|0){I=f[p>>2]|0;if((I|0)==(J|0))K=J;else{F=I;do{I=F+-48|0;f[p>>2]=I;EQ(I);F=f[p>>2]|0}while((F|0)!=(J|0));K=f[g>>2]|0}cYc(K)}u=e;return}f[g>>2]=0;K=g+4|0;f[K>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;gS(b,g);gS(c,h);gS(d,i);b=f[K>>2]|0;J=f[g>>2]|0;F=b-J|0;p=(F|0)/56|0;f[j>>2]=0;I=j+4|0;f[I>>2]=0;f[j+8>>2]=0;if(!F){L=b;M=0}else{if(p>>>0>1073741823)kWc(j);b=$Xc(p<<2)|0;f[I>>2]=b;f[j>>2]=b;f[j+8>>2]=b+(p<<2);F=p;p=b;do{f[p>>2]=0;p=(f[I>>2]|0)+4|0;f[I>>2]=p;F=F+-1|0}while((F|0)!=0);L=f[K>>2]|0;M=b}if((L|0)!=(J|0)?(f[M>>2]=J,J=f[g>>2]|0,(((f[K>>2]|0)-J|0)/56|0)>>>0>1):0){M=J;J=1;do{f[(f[j>>2]|0)+(J<<2)>>2]=M+(J*56|0);J=J+1|0;M=f[g>>2]|0}while(J>>>0<(((f[K>>2]|0)-M|0)/56|0)>>>0)}ei[f[(f[a>>2]|0)+40>>2]&511](a,j,h,i);eT(c,h);eT(d,i);d=f[j>>2]|0;if(d|0){j=f[I>>2]|0;if((j|0)!=(d|0))f[I>>2]=j+(~((j+-4-d|0)>>>2)<<2);cYc(d)}hx(i);hx(h);hx(g);u=e;return}function gOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=b;e=c-d>>2;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=i;if(e>>>0<=h-i>>2>>>0){k=a+4|0;l=(f[k>>2]|0)-i>>2;m=e>>>0>l>>>0;n=b+(l<<2)|0;l=m?n:c;o=l;p=o-d|0;q=p>>2;if(q|0)q1c(i|0,b|0,p|0)|0;p=j+(q<<2)|0;if(!m){m=f[k>>2]|0;if((m|0)==(p|0))return;f[k>>2]=m+(~((m+-4-p|0)>>>2)<<2);return}if((l|0)==(c|0))return;l=f[k>>2]|0;p=c+-4-o|0;o=n;n=l;while(1){f[n>>2]=f[o>>2];o=o+4|0;if((o|0)==(c|0))break;else n=n+4|0}f[k>>2]=l+((p>>>2)+1<<2);return}p=i;if(!i)r=h;else{h=a+4|0;l=f[h>>2]|0;if((l|0)!=(j|0))f[h>>2]=l+(~((l+-4-i|0)>>>2)<<2);cYc(p);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;r=0}if(e>>>0>1073741823)kWc(a);h=r>>1;p=r>>2>>>0<536870911?(h>>>0<e>>>0?e:h):1073741823;if(p>>>0>1073741823)kWc(a);h=$Xc(p<<2)|0;e=a+4|0;f[e>>2]=h;f[a>>2]=h;f[g>>2]=h+(p<<2);if((b|0)==(c|0))return;p=c+-4-d|0;d=b;b=h;while(1){f[b>>2]=f[d>>2];d=d+4|0;if((d|0)==(c|0))break;else b=b+4|0}f[e>>2]=h+((p>>>2)+1<<2);return}function hOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function iOa(){var a=0;a=(TM(391555,0)|0)&1;b[1163510]=a;a=HN(391595,3)|0;f[223016]=a;a=(TM(391622,0)|0)&1;b[1163511]=a;a=(TM(391647,0)|0)&1;b[1163512]=a;a=(TM(391677,0)|0)&1;b[1163513]=a;return}function jOa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+16|0;k=j;f[a>>2]=1124007936;l=a+8|0;m=a+40|0;n=a+4|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+48|0;f[a+44>>2]=l;f[l>>2]=0;f[a+52>>2]=0;l=k+8|0;f[l>>2]=0;f[l+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=a;kOa(b,k,c,d,e,g,h,i);u=j;return}function kOa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;j=u;u=u+80|0;k=j+64|0;l=j+8|0;m=j;do if((eS(a)|0)==65536){n=f[a+4>>2]|0;f[l>>2]=f[n>>2];o=l+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=l+8|0;f[q>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];f[l+16>>2]=f[n+16>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[l+36>>2]=r;f[l+40>>2]=q;q=l+48|0;s=l+44|0;f[s>>2]=q;f[q>>2]=0;f[l+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;U$(l,n);break}}else bS(l,a,-1);while(0);lOa(k,1,l);a=l+36|0;n=f[a>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)V$(l);f[a>>2]=0;a=l+16|0;n=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){a=f[l+40>>2]|0;o=0;do{f[a+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){t=l+8|0;f[t>>2]=0;v=l+12|0;f[v>>2]=0;f[l>>2]=17104896;w=l+4|0;f[w>>2]=k;x=f[d>>2]|0;f[m>>2]=x;y=m+4|0;z=d+4|0;A=f[z>>2]|0;f[y>>2]=A;mOa(l,b,c,m,e,g,h,i);hx(k);u=j;return}wL(n);t=l+8|0;f[t>>2]=0;v=l+12|0;f[v>>2]=0;f[l>>2]=17104896;w=l+4|0;f[w>>2]=k;x=f[d>>2]|0;f[m>>2]=x;y=m+4|0;z=d+4|0;A=f[z>>2]|0;f[y>>2]=A;mOa(l,b,c,m,e,g,h,i);hx(k);u=j;return}function lOa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>76695844)kWc(a);e=$Xc(b*56|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*56|0);a=c+4|0;g=c+8|0;h=c+12|0;i=c+16|0;j=c+20|0;k=c+24|0;l=c+28|0;m=c+32|0;n=c+36|0;o=c+44|0;p=b;b=e;do{f[b>>2]=f[c>>2];e=b+4|0;f[e>>2]=f[a>>2];q=b+8|0;f[q>>2]=f[g>>2];f[b+12>>2]=f[h>>2];f[b+16>>2]=f[i>>2];f[b+20>>2]=f[j>>2];f[b+24>>2]=f[k>>2];f[b+28>>2]=f[l>>2];f[b+32>>2]=f[m>>2];r=f[n>>2]|0;f[b+36>>2]=r;f[b+40>>2]=q;q=b+48|0;s=b+44|0;f[s>>2]=q;f[q>>2]=0;f[b+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[a>>2]|0)<3){q=f[o>>2]|0;r=f[s>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2]}else{f[e>>2]=0;U$(b,c)}b=(f[d>>2]|0)+56|0;f[d>>2]=b;p=p+-1|0}while((p|0)!=0);return}function mOa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0;k=u;u=u+592|0;l=k+56|0;m=k+536|0;n=k+472|0;o=k+448|0;q=k+528|0;r=k+464|0;s=k;t=k+392|0;v=k+168|0;w=k+112|0;x=(j|0)==5;switch(j|0){case 0:{y=3;break}case 5:break;default:qV(j,82308)}if((y|0)==3){if(!(d==1.0))oV(d,1.0,82336);if(!(+p[g>>3]==0.0)){z=$Xc(80)|0;f[l>>2]=z;A=l+8|0;f[A>>2]=-2147483568;B=l+4|0;f[B>>2]=77;C=z;D=391714;E=C+77|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+77|0;b[F>>0]=0;vM(-215,l,391792,391289,138)}if(!(+p[g+8>>3]==0.0)){z=$Xc(80)|0;f[l>>2]=z;A=l+8|0;f[A>>2]=-2147483568;B=l+4|0;f[B>>2]=77;C=z;D=391714;E=C+77|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+77|0;b[F>>0]=0;vM(-215,l,391792,391289,138)}if(!(+p[g+16>>3]==0.0)){z=$Xc(80)|0;f[l>>2]=z;A=l+8|0;f[A>>2]=-2147483568;B=l+4|0;f[B>>2]=77;C=z;D=391714;E=C+77|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+77|0;b[F>>0]=0;vM(-215,l,391792,391289,138)}if(!(+p[g+24>>3]==0.0)){z=$Xc(80)|0;f[l>>2]=z;A=l+8|0;f[A>>2]=-2147483568;B=l+4|0;f[B>>2]=77;C=z;D=391714;E=C+77|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+77|0;b[F>>0]=0;vM(-215,l,391792,391289,138)}}f[o>>2]=0;F=o+4|0;f[F>>2]=0;f[o+8>>2]=0;gS(a,o);a=f[o>>2]|0;z=f[F>>2]|0;if((a|0)==(z|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;B=$Xc(16)|0;f[l>>2]=B;f[l+8>>2]=-2147483632;f[l+4>>2]=15;C=B;D=391807;E=C+15|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+15>>0]=0;vM(-215,l,391792,391289,143)}B=z-a|0;if(!B){G=(B|0)/56|0;H=a}else{a=e+4|0;B=l+8|0;z=l+12|0;A=l+4|0;I=m+8|0;J=m+4|0;K=q+4|0;L=l+4|0;M=l+8|0;N=l+12|0;O=m+36|0;P=m+16|0;Q=m+4|0;R=m+40|0;S=m+44|0;T=m+48|0;U=m+8|0;V=m+12|0;W=m+20|0;X=m+24|0;Z=m+28|0;_=m+32|0;$=m+44|0;aa=l+8|0;ba=l+12|0;ca=l+4|0;da=m+8|0;ea=m+4|0;fa=r+4|0;ga=l+8|0;ha=l+4|0;ia=g+8|0;ja=s+8|0;ka=g+16|0;la=s+16|0;ma=g+24|0;na=s+24|0;oa=l+8|0;pa=l+12|0;qa=l+4|0;ra=m+8|0;sa=m+12|0;ta=m+4|0;ua=n+8|0;va=n+4|0;wa=l+8|0;xa=l+4|0;ya=0;za=f[o>>2]|0;while(1){Aa=f[za+(ya*56|0)+40>>2]|0;Ba=f[Aa+4>>2]|0;Ca=f[Aa>>2]|0;Aa=f[e>>2]|0;Da=f[a>>2]|0;if(!(Da|Aa)){f[e>>2]=Ba;f[a>>2]=Ca;Ea=Ba;Fa=Ca}else{Ea=Aa;Fa=Da}do if((Ea|0)!=(Ba|0)|(Fa|0)!=(Ca|0)){if(!i){f[aa>>2]=0;f[ba>>2]=0;f[l>>2]=16842752;f[ca>>2]=za+(ya*56|0);Da=da;f[Da>>2]=0;f[Da+4>>2]=0;f[m>>2]=33619968;f[ea>>2]=za+(ya*56|0);f[r>>2]=Ea;f[fa>>2]=Fa;Zna(l,m,r,0.0,0.0,1);break}Ga=+(Ea|0)/+(Ba|0);Ha=+(Fa|0)/+(Ca|0);f[B>>2]=0;f[z>>2]=0;f[l>>2]=16842752;f[A>>2]=za+(ya*56|0);Da=I;f[Da>>2]=0;f[Da+4>>2]=0;f[m>>2]=33619968;f[J>>2]=za+(ya*56|0);f[q>>2]=0;f[K>>2]=0;Ia=Ga<Ha?Ha:Ga;Zna(l,m,q,Ia,Ia,1);Da=f[o>>2]|0;Aa=f[e>>2]|0;Ja=f[a>>2]|0;Ka=~~(+((f[Da+(ya*56|0)+8>>2]|0)-Ja|0)*.5);f[l>>2]=~~(+((f[Da+(ya*56|0)+12>>2]|0)-Aa|0)*.5);f[L>>2]=Ka;f[M>>2]=Aa;f[N>>2]=Ja;Z$(m,Da+(ya*56|0)|0,l);Da=f[o>>2]|0;Ja=Da+(ya*56|0)|0;if((Ja|0)==(m|0)){Aa=f[O>>2]|0;if(Aa|0?(Ka=Aa+12|0,Aa=f[Ka>>2]|0,f[Ka>>2]=Aa+-1,(Aa|0)==1):0)V$(m)}else{Aa=Da+(ya*56|0)+36|0;Ka=f[Aa>>2]|0;if(Ka|0?(La=Ka+12|0,Ka=f[La>>2]|0,f[La>>2]=Ka+-1,(Ka|0)==1):0)V$(Ja);f[Aa>>2]=0;Ka=Da+(ya*56|0)+16|0;La=Da+(ya*56|0)+4|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[La>>2]|0)>0){Ma=f[Da+(ya*56|0)+40>>2]|0;Na=0;do{f[Ma+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[La>>2]|0))}f[Ja>>2]=f[m>>2];f[La>>2]=f[Q>>2];Na=Da+(ya*56|0)+8|0;f[Na>>2]=f[U>>2];f[Da+(ya*56|0)+12>>2]=f[V>>2];f[Ka>>2]=f[P>>2];f[Da+(ya*56|0)+20>>2]=f[W>>2];f[Da+(ya*56|0)+24>>2]=f[X>>2];f[Da+(ya*56|0)+28>>2]=f[Z>>2];f[Da+(ya*56|0)+32>>2]=f[_>>2];f[Aa>>2]=f[O>>2];Ma=Da+(ya*56|0)+44|0;Oa=f[Ma>>2]|0;Pa=Da+(ya*56|0)+48|0;if((Oa|0)==(Pa|0))Qa=Oa;else{wL(Oa);f[Ma>>2]=Pa;f[Da+(ya*56|0)+40>>2]=Na;Qa=Pa}if((f[Q>>2]|0)<3){Pa=f[$>>2]|0;f[Qa>>2]=f[Pa>>2];f[Qa+4>>2]=f[Pa+4>>2]}else{f[Ma>>2]=f[$>>2];f[Da+(ya*56|0)+40>>2]=f[R>>2];f[$>>2]=T;f[R>>2]=U}f[m>>2]=1124007936;C=Q;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0))}f[O>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[Q>>2]|0)>0){Da=f[R>>2]|0;Aa=0;do{f[Da+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[Q>>2]|0))}Aa=f[S>>2]|0;if((Aa|0)!=(T|0))wL(Aa)}while(0);Ca=(f[o>>2]|0)+(ya*56|0)|0;if(x&(f[Ca>>2]&7|0)==0){Ba=ga;f[Ba>>2]=0;f[Ba+4>>2]=0;f[l>>2]=33619968;f[ha>>2]=Ca;dY(Ca,l,5,1.0,0.0)}Ia=+p[g>>3];p[s>>3]=Ia;p[ja>>3]=+p[ia>>3];Ga=+p[ka>>3];p[la>>3]=Ga;p[na>>3]=+p[ma>>3];if(h){p[s>>3]=Ga;p[la>>3]=Ia}Ca=(f[o>>2]|0)+(ya*56|0)|0;f[oa>>2]=0;f[pa>>2]=0;f[l>>2]=16842752;f[qa>>2]=Ca;f[m>>2]=-1056833530;f[ta>>2]=s;f[ra>>2]=1;f[sa>>2]=4;Ba=ua;f[Ba>>2]=0;f[Ba+4>>2]=0;f[n>>2]=33619968;f[va>>2]=Ca;G1(l,m,n,fT()|0,-1);Ca=(f[o>>2]|0)+(ya*56|0)|0;Ba=wa;f[Ba>>2]=0;f[Ba+4>>2]=0;f[l>>2]=33619968;f[xa>>2]=Ca;dY(Ca,l,-1,d,0.0);ya=ya+1|0;Ca=f[o>>2]|0;Ba=((f[F>>2]|0)-Ca|0)/56|0;Aa=Ca;if(ya>>>0>=Ba>>>0){G=Ba;H=Aa;break}else za=Aa}}f[m>>2]=f[H>>2];za=m+4|0;ya=H+4|0;f[za>>2]=f[ya>>2];F=m+8|0;f[F>>2]=f[H+8>>2];xa=m+12|0;f[xa>>2]=f[H+12>>2];wa=m+16|0;f[wa>>2]=f[H+16>>2];f[m+20>>2]=f[H+20>>2];f[m+24>>2]=f[H+24>>2];f[m+28>>2]=f[H+28>>2];f[m+32>>2]=f[H+32>>2];va=m+36|0;ua=f[H+36>>2]|0;f[va>>2]=ua;sa=m+40|0;f[sa>>2]=F;ra=m+48|0;ta=m+44|0;f[ta>>2]=ra;f[ra>>2]=0;f[m+52>>2]=0;if(ua|0){qa=ua+12|0;f[qa>>2]=(f[qa>>2]|0)+1}if((f[ya>>2]|0)<3){ya=f[H+44>>2]|0;qa=f[ta>>2]|0;f[qa>>2]=f[ya>>2];f[qa+4>>2]=f[ya+4>>2]}else{f[za>>2]=0;U$(m,H)}H=(f[m>>2]|0)>>>3;ya=H&511;qa=ya+1|0;if((f[za>>2]|0)!=2){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ua=$Xc(32)|0;f[l>>2]=ua;f[l+8>>2]=-2147483616;f[l+4>>2]=16;C=ua;D=391823;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[ua+16>>0]=0;vM(-215,l,391792,391289,177)}f[n>>2]=1124007936;ua=n+4|0;pa=n+8|0;oa=n+40|0;C=ua;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[oa>>2]=pa;la=n+48|0;ma=n+44|0;f[ma>>2]=la;f[la>>2]=0;f[n+52>>2]=0;if((H&510|0)==2){f[s>>2]=G;f[s+4>>2]=qa;f[s+8>>2]=f[F>>2];f[s+12>>2]=f[xa>>2];xS(c,4,s,j,-1,0,0);do if((eS(c)|0)==65536){qa=f[c+4>>2]|0;f[t>>2]=f[qa>>2];H=t+4|0;na=qa+4|0;f[H>>2]=f[na>>2];ka=t+8|0;f[ka>>2]=f[qa+8>>2];f[t+12>>2]=f[qa+12>>2];f[t+16>>2]=f[qa+16>>2];f[t+20>>2]=f[qa+20>>2];f[t+24>>2]=f[qa+24>>2];f[t+28>>2]=f[qa+28>>2];f[t+32>>2]=f[qa+32>>2];ia=f[qa+36>>2]|0;f[t+36>>2]=ia;f[t+40>>2]=ka;ka=t+48|0;ja=t+44|0;f[ja>>2]=ka;f[ka>>2]=0;f[t+52>>2]=0;if(ia|0){ka=ia+12|0;f[ka>>2]=(f[ka>>2]|0)+1}if((f[na>>2]|0)<3){na=f[qa+44>>2]|0;ka=f[ja>>2]|0;f[ka>>2]=f[na>>2];f[ka+4>>2]=f[na+4>>2];break}else{f[H>>2]=0;U$(t,qa);break}}else bS(t,c,-1);while(0);f[v>>2]=1124007936;qa=v+4|0;H=v+8|0;na=v+40|0;C=qa;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[na>>2]=H;ka=v+48|0;f[v+44>>2]=ka;f[ka>>2]=0;f[v+52>>2]=0;f[v+56>>2]=1124007936;ja=v+64|0;ia=v+96|0;C=v+60|0;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[ia>>2]=ja;ja=v+104|0;f[v+100>>2]=ja;f[ja>>2]=0;f[v+108>>2]=0;f[v+112>>2]=1124007936;ja=v+116|0;ia=v+120|0;g=v+152|0;C=ja;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[g>>2]=ia;ha=v+160|0;f[v+156>>2]=ha;f[ha>>2]=0;f[v+164>>2]=0;f[v+168>>2]=1124007936;ga=v+176|0;x=v+208|0;C=v+172|0;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[x>>2]=ga;ga=v+216|0;f[v+212>>2]=ga;f[ga>>2]=0;f[v+220>>2]=0;do if(G){ga=n+12|0;x=t+16|0;T=t+44|0;S=l+36|0;Q=l+16|0;R=l+4|0;P=l+40|0;O=l+44|0;U=l+48|0;$=l+8|0;Qa=l+12|0;_=l+20|0;Z=l+24|0;X=l+28|0;W=l+32|0;V=l+44|0;N=v+112|0;M=l+4|0;L=l+8|0;a=l+12|0;e=v+12|0;q=l+16|0;K=v+16|0;J=l+20|0;I=v+20|0;A=l+24|0;z=v+24|0;B=l+28|0;Fa=v+28|0;Ea=l+32|0;r=v+32|0;fa=l+36|0;ea=v+36|0;da=l+40|0;ca=l+44|0;ba=l+48|0;aa=l+52|0;i=v+44|0;Aa=v+148|0;Ba=v+128|0;Ca=v+124|0;Da=v+132|0;Ka=v+136|0;La=v+140|0;Ja=v+144|0;Ma=v+156|0;Pa=l+40|0;Na=v+152|0;Oa=n+36|0;Ra=n+16|0;Sa=n+20|0;Ta=n+24|0;Ua=n+28|0;Va=n+32|0;Wa=v+164|0;Xa=0;while(1){Ya=f[o>>2]|0;Za=Ya+(Xa*56|0)|0;if((n|0)!=(Za|0)){_a=Ya+(Xa*56|0)+36|0;$a=f[_a>>2]|0;if($a|0){ab=$a+12|0;f[ab>>2]=(f[ab>>2]|0)+1}ab=f[Oa>>2]|0;if(ab|0?($a=ab+12|0,ab=f[$a>>2]|0,f[$a>>2]=ab+-1,(ab|0)==1):0)V$(n);f[Oa>>2]=0;f[Ra>>2]=0;f[Ra+4>>2]=0;f[Ra+8>>2]=0;f[Ra+12>>2]=0;if((f[ua>>2]|0)>0){ab=f[oa>>2]|0;$a=0;do{f[ab+($a<<2)>>2]=0;$a=$a+1|0;bb=f[ua>>2]|0}while(($a|0)<(bb|0));f[n>>2]=f[Za>>2];if((bb|0)<3)y=75;else y=77}else{f[n>>2]=f[Za>>2];y=75}if((y|0)==75){y=0;$a=f[Ya+(Xa*56|0)+4>>2]|0;if(($a|0)<3){f[ua>>2]=$a;f[pa>>2]=f[Ya+(Xa*56|0)+8>>2];f[ga>>2]=f[Ya+(Xa*56|0)+12>>2];$a=f[Ya+(Xa*56|0)+44>>2]|0;ab=f[ma>>2]|0;f[ab>>2]=f[$a>>2];f[ab+4>>2]=f[$a+4>>2]}else y=77}if((y|0)==77){y=0;U$(n,Za)}f[Ra>>2]=f[Ya+(Xa*56|0)+16>>2];f[Sa>>2]=f[Ya+(Xa*56|0)+20>>2];f[Ta>>2]=f[Ya+(Xa*56|0)+24>>2];f[Ua>>2]=f[Ya+(Xa*56|0)+28>>2];f[Va>>2]=f[Ya+(Xa*56|0)+32>>2];f[Oa>>2]=f[_a>>2]}$a=f[n>>2]|0;if(($a&7|0)!=(qS(c,-1)|0)){y=80;break}$a=(f[n>>2]|0)>>>3;ab=$a&511;if(!((f[ua>>2]|0)==2&($a&510|0)==2)){y=82;break}$a=f[oa>>2]|0;cb=f[sa>>2]|0;if((f[$a>>2]|0)==(f[cb>>2]|0)?(f[$a+4>>2]|0)==(f[cb+4>>2]|0):0)db=0;else{y=84;break}while(1){cb=f[T>>2]|0;$a=(f[x>>2]|0)+(Y(f[cb>>2]|0,Xa)|0)|0;Tj(l,f[pa>>2]|0,f[ga>>2]|0,j,$a+(Y(f[cb+4>>2]|0,db)|0)|0,0);cb=v+(db*56|0)|0;if((cb|0)==(l|0)){$a=f[S>>2]|0;if($a|0?(eb=$a+12|0,$a=f[eb>>2]|0,f[eb>>2]=$a+-1,($a|0)==1):0)V$(l)}else{$a=v+(db*56|0)+36|0;eb=f[$a>>2]|0;do if(eb|0){fb=eb+12|0;gb=f[fb>>2]|0;f[fb>>2]=gb+-1;if((gb|0)!=1)break;V$(cb)}while(0);f[$a>>2]=0;eb=v+(db*56|0)+16|0;gb=v+(db*56|0)+4|0;f[eb>>2]=0;f[eb+4>>2]=0;f[eb+8>>2]=0;f[eb+12>>2]=0;if((f[gb>>2]|0)>0){fb=f[v+(db*56|0)+40>>2]|0;hb=0;do{f[fb+(hb<<2)>>2]=0;hb=hb+1|0}while((hb|0)<(f[gb>>2]|0))}f[cb>>2]=f[l>>2];hb=f[R>>2]|0;f[gb>>2]=hb;fb=v+(db*56|0)+8|0;f[fb>>2]=f[$>>2];f[v+(db*56|0)+12>>2]=f[Qa>>2];f[eb>>2]=f[Q>>2];f[v+(db*56|0)+20>>2]=f[_>>2];f[v+(db*56|0)+24>>2]=f[Z>>2];f[v+(db*56|0)+28>>2]=f[X>>2];f[v+(db*56|0)+32>>2]=f[W>>2];f[$a>>2]=f[S>>2];ib=v+(db*56|0)+44|0;jb=f[ib>>2]|0;kb=v+(db*56|0)+48|0;if((jb|0)==(kb|0)){lb=hb;mb=jb}else{wL(jb);f[ib>>2]=kb;f[v+(db*56|0)+40>>2]=fb;lb=f[R>>2]|0;mb=kb}if((lb|0)<3){kb=f[V>>2]|0;f[mb>>2]=f[kb>>2];f[mb+4>>2]=f[kb+4>>2]}else{f[ib>>2]=f[V>>2];f[v+(db*56|0)+40>>2]=f[P>>2];f[V>>2]=U;f[P>>2]=$}f[l>>2]=1124007936;C=R;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0))}f[S>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[R>>2]|0)>0){$a=f[P>>2]|0;eb=0;do{f[$a+(eb<<2)>>2]=0;eb=eb+1|0}while((eb|0)<(f[R>>2]|0))}eb=f[O>>2]|0;if((eb|0)!=(U|0))wL(eb);if((db|0)<(ab|0))db=db+1|0;else break}if(h){f[l>>2]=f[v>>2];ab=f[qa>>2]|0;f[M>>2]=ab;f[L>>2]=f[H>>2];f[a>>2]=f[e>>2];f[q>>2]=f[K>>2];f[J>>2]=f[I>>2];f[A>>2]=f[z>>2];f[B>>2]=f[Fa>>2];f[Ea>>2]=f[r>>2];f[fa>>2]=f[ea>>2];f[da>>2]=L;f[ca>>2]=ba;f[aa>>2]=0;f[ba>>2]=0;if((ab|0)<3){ab=f[i>>2]|0;f[ba>>2]=f[ab>>2];f[aa>>2]=f[ab+4>>2]}else{f[ca>>2]=f[i>>2];f[da>>2]=f[na>>2];f[i>>2]=ka;f[na>>2]=H}f[v>>2]=1124007936;C=qa;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));nOa(v,N)|0;ab=f[Aa>>2]|0;do if(ab|0){_a=ab+12|0;Ya=f[_a>>2]|0;f[_a>>2]=Ya+-1;if((Ya|0)!=1)break;V$(N)}while(0);f[Aa>>2]=0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;if((f[ja>>2]|0)>0){ab=f[g>>2]|0;Ya=0;do{f[ab+(Ya<<2)>>2]=0;Ya=Ya+1|0}while((Ya|0)<(f[ja>>2]|0))}f[N>>2]=f[l>>2];Ya=f[M>>2]|0;f[ja>>2]=Ya;f[ia>>2]=f[L>>2];f[Ca>>2]=f[a>>2];f[Ba>>2]=f[q>>2];f[Da>>2]=f[J>>2];f[Ka>>2]=f[A>>2];f[La>>2]=f[B>>2];f[Ja>>2]=f[Ea>>2];f[Aa>>2]=f[fa>>2];ab=f[Ma>>2]|0;if((ab|0)==(ha|0))nb=Ya;else{wL(ab);f[Ma>>2]=ha;f[g>>2]=ia;nb=f[M>>2]|0}do if((nb|0)<3){ab=f[ca>>2]|0;f[ha>>2]=f[ab>>2];f[Wa>>2]=f[ab+4>>2];f[l>>2]=1124007936;C=M;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));if((ab|0)==(ba|0))break;wL(ab)}else{f[Ma>>2]=f[ca>>2];f[Na>>2]=f[Pa>>2];f[ca>>2]=ba;f[Pa>>2]=L;f[l>>2]=1124007936;C=M;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0))}while(0)}jY(n,v);Xa=Xa+1|0;if(Xa>>>0>=G>>>0){y=125;break}}if((y|0)==80){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Xa=$Xc(32)|0;f[l>>2]=Xa;f[l+8>>2]=-2147483616;f[l+4>>2]=30;C=Xa;D=391840;E=C+30|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[Xa+30>>0]=0;vM(-215,l,391792,391289,189)}else if((y|0)==82){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;M=$Xc(48)|0;f[l>>2]=M;f[l+8>>2]=-2147483600;f[l+4>>2]=41;C=M;D=391871;E=C+41|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[M+41>>0]=0;vM(-215,l,391792,391289,191)}else if((y|0)==84){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Xa=$Xc(32)|0;f[l>>2]=Xa;f[l+8>>2]=-2147483616;f[l+4>>2]=29;C=Xa;D=391913;E=C+29|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[Xa+29>>0]=0;vM(-215,l,391792,391289,192)}else if((y|0)==125){M=v+204|0;L=f[M>>2]|0;if(!L){ob=M;break}Pa=L+12|0;L=f[Pa>>2]|0;f[Pa>>2]=L+-1;if((L|0)!=1){ob=M;break}V$(v+168|0);ob=M;break}}else ob=v+204|0;while(0);f[ob>>2]=0;ob=v+184|0;ha=v+172|0;f[ob>>2]=0;f[ob+4>>2]=0;f[ob+8>>2]=0;f[ob+12>>2]=0;if((f[ha>>2]|0)>0){ob=f[v+208>>2]|0;nb=0;do{f[ob+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[ha>>2]|0))}ha=f[v+212>>2]|0;if((ha|0)!=(v+216|0))wL(ha);ha=v+112|0;nb=v+148|0;ob=f[nb>>2]|0;if(ob|0?(ia=ob+12|0,ob=f[ia>>2]|0,f[ia>>2]=ob+-1,(ob|0)==1):0)V$(ha);f[nb>>2]=0;nb=v+128|0;ha=v+116|0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[ha>>2]|0)>0){nb=f[v+152>>2]|0;ob=0;do{f[nb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[ha>>2]|0))}ha=f[v+156>>2]|0;if((ha|0)!=(v+160|0))wL(ha);ha=v+56|0;ob=v+92|0;nb=f[ob>>2]|0;if(nb|0?(ia=nb+12|0,nb=f[ia>>2]|0,f[ia>>2]=nb+-1,(nb|0)==1):0)V$(ha);f[ob>>2]=0;ob=v+72|0;ha=v+60|0;f[ob>>2]=0;f[ob+4>>2]=0;f[ob+8>>2]=0;f[ob+12>>2]=0;if((f[ha>>2]|0)>0){ob=f[v+96>>2]|0;nb=0;do{f[ob+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[ha>>2]|0))}ha=f[v+100>>2]|0;if((ha|0)!=(v+104|0))wL(ha);ha=v+36|0;nb=f[ha>>2]|0;if(nb|0?(ob=nb+12|0,nb=f[ob>>2]|0,f[ob>>2]=nb+-1,(nb|0)==1):0)V$(v);f[ha>>2]=0;ha=v+16|0;nb=v+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[nb>>2]|0)>0){ha=f[v+40>>2]|0;ob=0;do{f[ha+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[nb>>2]|0))}nb=f[v+44>>2]|0;if((nb|0)!=(v+48|0))wL(nb);nb=t+36|0;ob=f[nb>>2]|0;do if(ob|0){ha=ob+12|0;ia=f[ha>>2]|0;f[ha>>2]=ia+-1;if((ia|0)!=1)break;V$(t)}while(0);f[nb>>2]=0;nb=t+16|0;ob=t+4|0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[ob>>2]|0)>0){nb=f[t+40>>2]|0;ia=0;do{f[nb+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ob>>2]|0))}ob=f[t+44>>2]|0;if((ob|0)!=(t+48|0))wL(ob)}else{if(ya|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+11>>0]=8;ya=l;f[ya>>2]=543712110;f[ya+4>>2]=824196413;b[l+8>>0]=0;vM(-215,l,391792,391289,203)}f[l>>2]=G;f[l+4>>2]=1;f[l+8>>2]=f[F>>2];f[l+12>>2]=f[xa>>2];xS(c,4,l,j,-1,0,0);do if((eS(c)|0)==65536){l=f[c+4>>2]|0;f[s>>2]=f[l>>2];xa=s+4|0;F=l+4|0;f[xa>>2]=f[F>>2];ya=s+8|0;f[ya>>2]=f[l+8>>2];f[s+12>>2]=f[l+12>>2];f[s+16>>2]=f[l+16>>2];f[s+20>>2]=f[l+20>>2];f[s+24>>2]=f[l+24>>2];f[s+28>>2]=f[l+28>>2];f[s+32>>2]=f[l+32>>2];ob=f[l+36>>2]|0;f[s+36>>2]=ob;f[s+40>>2]=ya;ya=s+48|0;ia=s+44|0;f[ia>>2]=ya;f[ya>>2]=0;f[s+52>>2]=0;if(ob|0){ya=ob+12|0;f[ya>>2]=(f[ya>>2]|0)+1}if((f[F>>2]|0)<3){F=f[l+44>>2]|0;ya=f[ia>>2]|0;f[ya>>2]=f[F>>2];f[ya+4>>2]=f[F+4>>2];break}else{f[xa>>2]=0;U$(s,l);break}}else bS(s,c,-1);while(0);a:do if(G|0){l=t+4|0;xa=t+8|0;F=t+12|0;ya=t+16|0;ia=t+20|0;ob=t+24|0;nb=t+28|0;ha=t+32|0;g=t+36|0;ja=t+40|0;qa=t+48|0;H=t+44|0;na=t+52|0;ka=s+16|0;h=s+44|0;db=v+8|0;mb=v+4|0;lb=w+36|0;pa=w+16|0;bb=w+4|0;M=w+40|0;L=w+44|0;Pa=w+48|0;ba=0;while(1){ca=f[o>>2]|0;Na=ca+(ba*56|0)|0;f[t>>2]=f[Na>>2];Ma=ca+(ba*56|0)+4|0;f[l>>2]=f[Ma>>2];f[xa>>2]=f[ca+(ba*56|0)+8>>2];f[F>>2]=f[ca+(ba*56|0)+12>>2];f[ya>>2]=f[ca+(ba*56|0)+16>>2];f[ia>>2]=f[ca+(ba*56|0)+20>>2];f[ob>>2]=f[ca+(ba*56|0)+24>>2];f[nb>>2]=f[ca+(ba*56|0)+28>>2];f[ha>>2]=f[ca+(ba*56|0)+32>>2];Wa=f[ca+(ba*56|0)+36>>2]|0;f[g>>2]=Wa;f[ja>>2]=xa;f[H>>2]=qa;f[qa>>2]=0;f[na>>2]=0;if(Wa|0){fa=Wa+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[Ma>>2]|0)<3){Ma=f[ca+(ba*56|0)+44>>2]|0;ca=f[H>>2]|0;f[ca>>2]=f[Ma>>2];f[ca+4>>2]=f[Ma+4>>2]}else{f[l>>2]=0;U$(t,Na)}Na=f[t>>2]|0;if((Na&7|0)!=(qS(c,-1)|0)){y=159;break}if(!((f[l>>2]|0)==2&(f[t>>2]&4088|0)==0)){y=161;break}Na=f[ja>>2]|0;Ma=f[sa>>2]|0;if(!((f[Na>>2]|0)==(f[Ma>>2]|0)?(f[Na+4>>2]|0)==(f[Ma+4>>2]|0):0)){y=163;break}Tj(w,f[xa>>2]|0,f[F>>2]|0,j,(f[ka>>2]|0)+(Y(f[f[h>>2]>>2]|0,ba)|0)|0,0);Ma=db;f[Ma>>2]=0;f[Ma+4>>2]=0;f[v>>2]=-1040121856;f[mb>>2]=w;jR(t,v);Ma=f[lb>>2]|0;if(Ma|0?(Na=Ma+12|0,Ma=f[Na>>2]|0,f[Na>>2]=Ma+-1,(Ma|0)==1):0)V$(w);f[lb>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[bb>>2]|0)>0){Ma=f[M>>2]|0;Na=0;do{f[Ma+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[bb>>2]|0))}Na=f[L>>2]|0;if((Na|0)!=(Pa|0))wL(Na);Na=f[g>>2]|0;do if(Na|0){Ma=Na+12|0;ca=f[Ma>>2]|0;f[Ma>>2]=ca+-1;if((ca|0)!=1)break;V$(t)}while(0);f[g>>2]=0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[l>>2]|0)>0){Na=f[ja>>2]|0;ca=0;do{f[Na+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[l>>2]|0))}ca=f[H>>2]|0;if((ca|0)!=(qa|0))wL(ca);ba=ba+1|0;if(ba>>>0>=G>>>0)break a}if((y|0)==159){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;ba=$Xc(32)|0;f[v>>2]=ba;f[v+8>>2]=-2147483616;f[v+4>>2]=30;C=ba;D=391840;E=C+30|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[ba+30>>0]=0;vM(-215,v,391792,391289,211)}else if((y|0)==161){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;qa=$Xc(32)|0;f[v>>2]=qa;f[v+8>>2]=-2147483616;f[v+4>>2]=29;C=qa;D=391943;E=C+29|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[qa+29>>0]=0;vM(-215,v,391792,391289,213)}else if((y|0)==163){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;ba=$Xc(32)|0;f[v>>2]=ba;f[v+8>>2]=-2147483616;f[v+4>>2]=29;C=ba;D=391913;E=C+29|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[ba+29>>0]=0;vM(-215,v,391792,391289,214)}}while(0);v=s+36|0;D=f[v>>2]|0;if(D|0?(C=D+12|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)V$(s);f[v>>2]=0;v=s+16|0;D=s+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[D>>2]|0)>0){v=f[s+40>>2]|0;C=0;do{f[v+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[D>>2]|0))}D=f[s+44>>2]|0;if((D|0)!=(s+48|0))wL(D)}D=n+36|0;s=f[D>>2]|0;if(s|0?(C=s+12|0,s=f[C>>2]|0,f[C>>2]=s+-1,(s|0)==1):0)V$(n);f[D>>2]=0;D=n+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[ua>>2]|0)>0){D=f[oa>>2]|0;oa=0;do{f[D+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[ua>>2]|0))}ua=f[ma>>2]|0;if((ua|0)!=(la|0))wL(ua);ua=f[va>>2]|0;if(ua|0?(la=ua+12|0,ua=f[la>>2]|0,f[la>>2]=ua+-1,(ua|0)==1):0)V$(m);f[va>>2]=0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[za>>2]|0)>0){wa=f[sa>>2]|0;sa=0;do{f[wa+(sa<<2)>>2]=0;sa=sa+1|0}while((sa|0)<(f[za>>2]|0))}za=f[ta>>2]|0;if((za|0)==(ra|0)){hx(o);u=k;return}wL(za);hx(o);u=k;return}function nOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;if((a|0)==(b|0))return a|0;c=a+36|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(a);f[c>>2]=0;d=a+16|0;e=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){g=f[a+40>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[e>>2]|0))}f[a>>2]=f[b>>2];h=b+4|0;f[e>>2]=f[h>>2];e=b+8|0;g=a+8|0;f[g>>2]=f[e>>2];f[a+12>>2]=f[b+12>>2];f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[c>>2]=f[b+36>>2];c=a+44|0;d=f[c>>2]|0;i=a+48|0;if((d|0)==(i|0))j=d;else{wL(d);f[c>>2]=i;f[a+40>>2]=g;j=i}i=b+44|0;if((f[h>>2]|0)<3){g=f[i>>2]|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2]}else{f[c>>2]=f[i>>2];c=b+40|0;f[a+40>>2]=f[c>>2];f[i>>2]=b+48;f[c>>2]=e}f[b>>2]=1124007936;b=h;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));return a|0}function oOa(a){a=a|0;var b=0,c=0;b=$Xc(192)|0;pOa(b);f[a>>2]=b;c=$Xc(16)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=82372;f[c+12>>2]=b;f[a+4>>2]=c;return}function pOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=u;u=u+464|0;d=c+224|0;e=c;g=a+4|0;h=a+20|0;i=a+24|0;f[i>>2]=0;j=a+28|0;f[j>>2]=0;k=a+24|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[h>>2]=k;l=a+32|0;m=a+36|0;f[m>>2]=0;n=a+40|0;f[n>>2]=0;f[l>>2]=a+36;f[a+48>>2]=0;f[a+52>>2]=0;f[a+44>>2]=a+48;f[a+60>>2]=0;f[a+64>>2]=0;f[a+56>>2]=a+60;f[a+72>>2]=0;f[a+76>>2]=0;f[a+68>>2]=a+72;o=a+88|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+104>>2]=a+108;f[a+124>>2]=0;f[a+128>>2]=0;f[a+132>>2]=0;f[a+136>>2]=1124007936;o=a+144|0;p=a+176|0;q=a+140|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=a+184|0;f[a+180>>2]=o;f[o>>2]=0;f[a+188>>2]=0;o=$Xc(96)|0;yP(o);q=o+4|0;r=q+40|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=82400;p=o+44|0;q=p;r=q+48|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));b[p+48>>0]=0;p=o;o=$Xc(16)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=82512;f[o+12>>2]=p;TXc(o);f[a>>2]=p;p=f[g>>2]|0;f[g>>2]=o;if(p|0)UXc(p);UXc(o);f[e>>2]=-1;o=e+4|0;f[e+32>>2]=0;f[e+36>>2]=0;f[e+28>>2]=e+32;p=e+40|0;f[e+92>>2]=0;f[e+96>>2]=0;s=p+24|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[e+88>>2]=e+92;f[e+104>>2]=0;f[e+108>>2]=0;f[e+100>>2]=e+104;s=e+112|0;f[e+208>>2]=0;t=e+212|0;f[t>>2]=0;v=e+208|0;w=e+204|0;q=s+36|0;r=q+56|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[w>>2]=v;w=e+216|0;b[w>>0]=0;f[e+220>>2]=0;f[d>>2]=0;q=d+4|0;f[q>>2]=-1;r=d+8|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;o=d+20|0;r=e+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[d+36>>2]=0;f[d+40>>2]=0;f[d+32>>2]=d+36;r=d+44|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[e+48>>2]=0;f[e+44>>2]=0;f[p>>2]=0;p=d+56|0;r=e+52|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=d+68|0;p=e+64|0;f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2];f[r+8>>2]=f[p+8>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;p=d+80|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[e+84>>2]=0;f[e+80>>2]=0;f[e+76>>2]=0;f[d+96>>2]=0;f[d+100>>2]=0;f[d+92>>2]=d+96;f[d+108>>2]=0;f[d+112>>2]=0;f[d+104>>2]=d+108;p=d+116|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[e+120>>2]=0;f[e+116>>2]=0;f[s>>2]=0;s=d+128|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[e+132>>2]=0;f[e+128>>2]=0;f[e+124>>2]=0;s=d+140|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[e+144>>2]=0;f[e+140>>2]=0;f[e+136>>2]=0;s=d+152|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[e+156>>2]=0;f[e+152>>2]=0;f[e+148>>2]=0;s=e+160|0;f[d+164>>2]=f[s>>2];p=e+164|0;f[d+168>>2]=f[p>>2];f[s>>2]=0;f[p>>2]=0;p=e+168|0;f[d+172>>2]=f[p>>2];s=e+172|0;f[d+176>>2]=f[s>>2];r=e+176|0;f[d+180>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[p>>2]=0;p=e+180|0;f[d+184>>2]=f[p>>2];s=e+184|0;f[d+188>>2]=f[s>>2];r=e+188|0;f[d+192>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[p>>2]=0;p=e+192|0;f[d+196>>2]=f[p>>2];s=e+196|0;f[d+200>>2]=f[s>>2];r=e+200|0;f[d+204>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[p>>2]=0;p=d+208|0;s=e+204|0;f[p>>2]=f[s>>2];r=f[e+208>>2]|0;f[d+212>>2]=r;o=f[t>>2]|0;f[d+216>>2]=o;x=d+212|0;if(!o)f[p>>2]=x;else{f[r+8>>2]=x;f[s>>2]=v;f[v>>2]=0;f[t>>2]=0}t=w;w=f[t+4>>2]|0;v=d+220|0;f[v>>2]=f[t>>2];f[v+4>>2]=w;w=f[k>>2]|0;do if(w){v=f[d>>2]|0;t=i;s=w;while(1){x=f[s+16>>2]|0;if((v|0)<(x|0)){r=f[s>>2]|0;if(!r){y=11;break}else{z=s;A=r}}else{if((x|0)>=(v|0)){y=15;break}B=s+4|0;x=f[B>>2]|0;if(!x){y=14;break}else{z=B;A=x}}t=z;s=A}if((y|0)==11){C=s;D=s;break}else if((y|0)==14){C=s;D=B;break}else if((y|0)==15){C=s;D=t;break}}else{C=k;D=k}while(0);k=f[D>>2]|0;if(!k){y=$Xc(244)|0;f[y+16>>2]=f[d>>2];COa(y+20|0,q);f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=C;f[D>>2]=y;C=f[f[h>>2]>>2]|0;if(!C)E=y;else{f[h>>2]=C;E=f[D>>2]|0}UQ(f[i>>2]|0,E);f[j>>2]=(f[j>>2]|0)+1;F=y}else F=k;AOa(q);AOa(e);q=F+20|0;f[q>>2]=0;k=F+24|0;y=tYc(k,392413)|0;oYc((f[a>>2]|0)+16|0,y)|0;tYc(F+36|0,392420)|0;y=f[a>>2]|0;j=f[g>>2]|0;if(j|0)TXc(j);f[F+180>>2]=y;y=F+184|0;F=f[y>>2]|0;f[y>>2]=j;if(F|0)UXc(F);lYc(e,k);k=e+12|0;f[k>>2]=f[q>>2];q=ZGa(l,d,e)|0;if(!(f[q>>2]|0)){F=$Xc(32)|0;j=F+16|0;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[F+28>>2]=f[k>>2];k=f[d>>2]|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=k;f[q>>2]=F;k=f[f[l>>2]>>2]|0;if(!k)G=F;else{f[l>>2]=k;G=f[q>>2]|0}UQ(f[m>>2]|0,G);f[n>>2]=(f[n>>2]|0)+1}if((b[e+11>>0]|0)>=0){H=a+116|0;f[H>>2]=0;I=a+120|0;b[I>>0]=0;J=a+121|0;b[J>>0]=1;K=a+80|0;f[K>>2]=0;L=a+84|0;f[L>>2]=0;M=a+100|0;b[M>>0]=0;u=c;return}cYc(f[e>>2]|0);H=a+116|0;f[H>>2]=0;I=a+120|0;b[I>>0]=0;J=a+121|0;b[J>>0]=1;K=a+80|0;f[K>>2]=0;L=a+84|0;f[L>>2]=0;M=a+100|0;b[M>>0]=0;u=c;return}function qOa(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+136|0;d=a+172|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[d>>2]=0;d=a+152|0;c=a+140|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[a+176>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+180>>2]|0;if((c|0)!=(a+184|0))wL(c);c=f[a+124>>2]|0;if(c|0){e=a+128|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);cYc(c)}vOa(a+104|0,f[a+108>>2]|0);c=a+88|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);wOa(a+68|0,f[a+72>>2]|0);xOa(a+56|0,f[a+60>>2]|0);yOa(a+44|0,f[a+48>>2]|0);EGa(a+32|0,f[a+36>>2]|0);zOa(a+20|0,f[a+24>>2]|0);c=f[a+8>>2]|0;if(c|0){d=a+12|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);cYc(c)}c=f[a+4>>2]|0;if(!c)return;UXc(c);return}function rOa(a){a=a|0;NXc(a);cYc(a);return}function sOa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;qOa(b);cYc(b);return}function tOa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==392240?a+12|0:0)|0}function uOa(a){a=a|0;cYc(a);return}function vOa(a,b){a=a|0;b=b|0;if(!b)return;vOa(a,f[b>>2]|0);vOa(a,f[b+4>>2]|0);a=f[b+24>>2]|0;if(a|0)UXc(a);cYc(b);return}
function ZVb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0.0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0.0,$k=0,al=0.0,bl=0,cl=0,dl=0.0,el=0.0,fl=0.0,gl=0.0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0.0,nl=0.0,ol=0.0,pl=0.0,ql=0.0;i=u;u=u+5568|0;j=i+3264|0;k=i+3040|0;l=i+2816|0;m=i+2592|0;o=i+2144|0;q=i+1920|0;r=i+1472|0;t=i+1248|0;v=i+1024|0;w=i+800|0;x=i+576|0;y=i+352|0;z=i+5408|0;A=i+5352|0;B=i+128|0;C=i+5296|0;D=i+5240|0;E=i+5184|0;F=i+5128|0;G=i+5072|0;H=i+5016|0;I=i+4960|0;J=i+4904|0;K=i+4848|0;N=i+4792|0;Q=i+4736|0;R=i+4680|0;T=i+4624|0;U=i+4568|0;V=i+4512|0;W=i+4456|0;X=i+4400|0;Z=i+4344|0;_=i+4288|0;$=i+5560|0;aa=i+4232|0;ba=i+5552|0;ca=i+5544|0;da=i+4176|0;ea=i+2368|0;fa=i+4120|0;ga=i+1696|0;ha=i+4064|0;ia=i+4008|0;ja=i+3992|0;ka=i+5536|0;la=i+5528|0;ma=i+3936|0;na=i+3880|0;oa=i+3824|0;pa=i+3768|0;qa=i+3712|0;ra=i+3656|0;sa=i+3600|0;ta=i+3544|0;ua=i+3488|0;va=i+5520|0;wa=i+5512|0;xa=i+5504|0;ya=i+5496|0;za=i+5488|0;Aa=i+5480|0;Ba=i+5472|0;Ca=i+5464|0;Da=i+96|0;Ea=i+64|0;Fa=i+32|0;Ga=i;do if((eS(a)|0)==65536){Ha=f[a+4>>2]|0;f[H>>2]=f[Ha>>2];Ia=H+4|0;Ja=Ha+4|0;f[Ia>>2]=f[Ja>>2];Ka=H+8|0;f[Ka>>2]=f[Ha+8>>2];f[H+12>>2]=f[Ha+12>>2];f[H+16>>2]=f[Ha+16>>2];f[H+20>>2]=f[Ha+20>>2];f[H+24>>2]=f[Ha+24>>2];f[H+28>>2]=f[Ha+28>>2];f[H+32>>2]=f[Ha+32>>2];La=f[Ha+36>>2]|0;f[H+36>>2]=La;f[H+40>>2]=Ka;Ka=H+48|0;Ma=H+44|0;f[Ma>>2]=Ka;f[Ka>>2]=0;f[H+52>>2]=0;if(La|0){Ka=La+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[Ha+44>>2]|0;Ka=f[Ma>>2]|0;f[Ka>>2]=f[Ja>>2];f[Ka+4>>2]=f[Ja+4>>2];break}else{f[Ia>>2]=0;U$(H,Ha);break}}else bS(H,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[I>>2]=f[a>>2];Ha=I+4|0;Ia=a+4|0;f[Ha>>2]=f[Ia>>2];Ja=I+8|0;f[Ja>>2]=f[a+8>>2];f[I+12>>2]=f[a+12>>2];f[I+16>>2]=f[a+16>>2];f[I+20>>2]=f[a+20>>2];f[I+24>>2]=f[a+24>>2];f[I+28>>2]=f[a+28>>2];f[I+32>>2]=f[a+32>>2];Ka=f[a+36>>2]|0;f[I+36>>2]=Ka;f[I+40>>2]=Ja;Ja=I+48|0;Ma=I+44|0;f[Ma>>2]=Ja;f[Ja>>2]=0;f[I+52>>2]=0;if(Ka|0){Ja=Ka+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}if((f[Ia>>2]|0)<3){Ia=f[a+44>>2]|0;Ja=f[Ma>>2]|0;f[Ja>>2]=f[Ia>>2];f[Ja+4>>2]=f[Ia+4>>2];break}else{f[Ha>>2]=0;U$(I,a);break}}else bS(I,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[J>>2]=f[c>>2];a=J+4|0;Ha=c+4|0;f[a>>2]=f[Ha>>2];Ia=J+8|0;f[Ia>>2]=f[c+8>>2];f[J+12>>2]=f[c+12>>2];f[J+16>>2]=f[c+16>>2];f[J+20>>2]=f[c+20>>2];f[J+24>>2]=f[c+24>>2];f[J+28>>2]=f[c+28>>2];f[J+32>>2]=f[c+32>>2];Ja=f[c+36>>2]|0;f[J+36>>2]=Ja;f[J+40>>2]=Ia;Ia=J+48|0;Ma=J+44|0;f[Ma>>2]=Ia;f[Ia>>2]=0;f[J+52>>2]=0;if(Ja|0){Ia=Ja+12|0;f[Ia>>2]=(f[Ia>>2]|0)+1}if((f[Ha>>2]|0)<3){Ha=f[c+44>>2]|0;Ia=f[Ma>>2]|0;f[Ia>>2]=f[Ha>>2];f[Ia+4>>2]=f[Ha+4>>2];break}else{f[a>>2]=0;U$(J,c);break}}else bS(J,d,-1);while(0);c=H+16|0;if(!(f[c>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Na=$Xc(16)|0;f[j>>2]=Na;Oa=j+8|0;f[Oa>>2]=-2147483632;Pa=j+4|0;f[Pa>>2]=12;Qa=Na;Ra=471150;Sa=Qa+12|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));Ta=Na+12|0;b[Ta>>0]=0;vM(-215,j,471163,471180,325)}a=H+4|0;Ha=f[a>>2]|0;if((Ha|0)<3)Ua=Y(f[H+12>>2]|0,f[H+8>>2]|0)|0;else{Ia=f[H+40>>2]|0;Ma=0;Ja=1;while(1){Ka=Y(f[Ia+(Ma<<2)>>2]|0,Ja)|0;Ma=Ma+1|0;if((Ma|0)==(Ha|0)){Ua=Ka;break}else Ja=Ka}}if((Ha|0)==0|(Ua|0)==0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Na=$Xc(16)|0;f[j>>2]=Na;Oa=j+8|0;f[Oa>>2]=-2147483632;Pa=j+4|0;f[Pa>>2]=12;Qa=Na;Ra=471150;Sa=Qa+12|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));Ta=Na+12|0;b[Ta>>0]=0;vM(-215,j,471163,471180,325)}Ta=I+16|0;if(!(f[Ta>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Va=$Xc(16)|0;f[j>>2]=Va;Wa=j+8|0;f[Wa>>2]=-2147483632;Xa=j+4|0;f[Xa>>2]=12;Qa=Va;Ra=471246;Sa=Qa+12|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));Ya=Va+12|0;b[Ya>>0]=0;vM(-215,j,471163,471180,326)}Na=I+4|0;Pa=f[Na>>2]|0;if((Pa|0)<3)Za=Y(f[I+12>>2]|0,f[I+8>>2]|0)|0;else{Oa=f[I+40>>2]|0;Ua=0;Ha=1;while(1){Ja=Y(f[Oa+(Ua<<2)>>2]|0,Ha)|0;Ua=Ua+1|0;if((Ua|0)==(Pa|0)){Za=Ja;break}else Ha=Ja}}if((Pa|0)==0|(Za|0)==0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Va=$Xc(16)|0;f[j>>2]=Va;Wa=j+8|0;f[Wa>>2]=-2147483632;Xa=j+4|0;f[Xa>>2]=12;Qa=Va;Ra=471246;Sa=Qa+12|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));Ya=Va+12|0;b[Ya>>0]=0;vM(-215,j,471163,471180,326)}Ya=J+16|0;if(f[Ya>>2]|0){Va=f[J+4>>2]|0;if((Va|0)<3)_a=Y(f[J+12>>2]|0,f[J+8>>2]|0)|0;else{Xa=f[J+40>>2]|0;Wa=0;Za=1;while(1){Pa=Y(f[Xa+(Wa<<2)>>2]|0,Za)|0;Wa=Wa+1|0;if((Wa|0)==(Va|0)){_a=Pa;break}else Za=Pa}}if((Va|0)==0|(_a|0)==0)$a=42}else $a=42;if(($a|0)==42){_a=(e|0)==3?3:2;ZS(d,_a,3,5,-1,0,0);do if((eS(d)|0)==65536){Va=f[d+4>>2]|0;f[j>>2]=f[Va>>2];Za=j+4|0;Wa=Va+4|0;f[Za>>2]=f[Wa>>2];Xa=j+8|0;f[Xa>>2]=f[Va+8>>2];f[j+12>>2]=f[Va+12>>2];f[j+16>>2]=f[Va+16>>2];f[j+20>>2]=f[Va+20>>2];f[j+24>>2]=f[Va+24>>2];f[j+28>>2]=f[Va+28>>2];f[j+32>>2]=f[Va+32>>2];Pa=f[Va+36>>2]|0;f[j+36>>2]=Pa;f[j+40>>2]=Xa;Xa=j+48|0;Ha=j+44|0;f[Ha>>2]=Xa;f[Xa>>2]=0;f[j+52>>2]=0;if(Pa|0){Xa=Pa+12|0;f[Xa>>2]=(f[Xa>>2]|0)+1}if((f[Wa>>2]|0)<3){Wa=f[Va+44>>2]|0;Xa=f[Ha>>2]|0;f[Xa>>2]=f[Wa>>2];f[Xa+4>>2]=f[Wa+4>>2];break}else{f[Za>>2]=0;U$(j,Va);break}}else bS(j,d,-1);while(0);d=J+36|0;Va=f[d>>2]|0;if(Va|0?(Za=Va+12|0,Va=f[Za>>2]|0,f[Za>>2]=Va+-1,(Va|0)==1):0)V$(J);f[d>>2]=0;Va=J+4|0;f[Ya>>2]=0;f[Ya+4>>2]=0;f[Ya+8>>2]=0;f[Ya+12>>2]=0;if((f[Va>>2]|0)>0){Za=f[J+40>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[Va>>2]|0))}f[J>>2]=f[j>>2];Wa=j+4|0;Za=f[Wa>>2]|0;f[Va>>2]=Za;Va=j+8|0;Xa=J+8|0;f[Xa>>2]=f[Va>>2];f[J+12>>2]=f[j+12>>2];Ha=j+16|0;f[Ya>>2]=f[Ha>>2];f[J+20>>2]=f[j+20>>2];f[J+24>>2]=f[j+24>>2];f[J+28>>2]=f[j+28>>2];f[J+32>>2]=f[j+32>>2];Pa=j+36|0;f[d>>2]=f[Pa>>2];d=J+44|0;Ua=f[d>>2]|0;Oa=J+48|0;if((Ua|0)==(Oa|0))ab=Za;else{wL(Ua);f[d>>2]=Oa;f[J+40>>2]=Xa;ab=f[Wa>>2]|0}Xa=j+44|0;if((ab|0)<3){ab=f[Xa>>2]|0;f[Oa>>2]=f[ab>>2];f[J+52>>2]=f[ab+4>>2];bb=ab}else{f[d>>2]=f[Xa>>2];d=j+40|0;f[J+40>>2]=f[d>>2];ab=j+48|0;f[Xa>>2]=ab;f[d>>2]=Va;bb=ab}f[j>>2]=1124007936;f[Wa>>2]=0;f[Wa+4>>2]=0;f[Wa+8>>2]=0;f[Wa+12>>2]=0;f[Wa+16>>2]=0;f[Wa+20>>2]=0;f[Wa+24>>2]=0;f[Wa+28>>2]=0;f[Pa>>2]=0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((bb|0)!=(j+48|0))wL(bb);u$(j,_a,3,5);_a=f[j>>2]|0;ei[f[(f[_a>>2]|0)+12>>2]&511](_a,j,J,-1);Zj(j)}_a=f[H>>2]|0;if((f[I>>2]^_a)&4095|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;bb=$Xc(48)|0;f[j>>2]=bb;f[j+8>>2]=-2147483600;f[j+4>>2]=46;Qa=bb;Ra=471259;Sa=Qa+46|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[bb+46>>0]=0;vM(-205,j,471163,471180,340)}switch(_a&4095){case 5:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;_a=$Xc(48)|0;f[j>>2]=_a;f[j+8>>2]=-2147483600;f[j+4>>2]=35;Qa=_a;Ra=471306;Sa=Qa+35|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[_a+35>>0]=0;vM(-210,j,471163,471180,344)}}if((f[J>>2]&4095|0)!=5){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;_a=$Xc(64)|0;f[j>>2]=_a;f[j+8>>2]=-2147483584;f[j+4>>2]=55;Qa=_a;Ra=471342;Sa=Qa+55|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[_a+55>>0]=0;vM(-210,j,471163,471180,347)}if((f[J+12>>2]|0)!=3){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;_a=$Xc(16)|0;f[j>>2]=_a;f[j+8>>2]=-2147483632;f[j+4>>2]=13;Qa=_a;Ra=471398;Sa=Qa+13|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[_a+13>>0]=0;vM(-215,j,471163,471180,349)}_a=J+8|0;bb=f[_a>>2]|0;if((bb&-2|0)!=2){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Ha=$Xc(32)|0;f[j>>2]=Ha;f[j+8>>2]=-2147483616;f[j+4>>2]=29;Qa=Ha;Ra=471412;Sa=Qa+29|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[Ha+29>>0]=0;vM(-215,j,471163,471180,350)}switch(e|0){case 3:{$a=75;break}case 2:case 1:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Ha=$Xc(144)|0;f[j>>2]=Ha;f[j+8>>2]=-2147483504;f[j+4>>2]=132;o1c(Ha|0,471442,132)|0;b[Ha+132>>0]=0;vM(-215,j,471163,471180,353)}}if(($a|0)==75?(bb|0)!=3:0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;bb=$Xc(16)|0;f[j>>2]=bb;f[j+8>>2]=-2147483632;f[j+4>>2]=12;Qa=bb;Ra=471575;Sa=Qa+12|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[bb+12>>0]=0;vM(-215,j,471163,471180,356)}bb=f[g>>2]|0;Ha=(bb&1|0)!=0;Pa=(bb&2|0)==0;if(Pa&(Ha^1)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;bb=$Xc(80)|0;f[j>>2]=bb;f[j+8>>2]=-2147483568;f[j+4>>2]=72;Qa=bb;Ra=471588;Sa=Qa+72|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[bb+72>>0]=0;vM(-215,j,471163,471180,359)}if(Ha)cb=f[g+4>>2]|0;else cb=200;if(Pa)db=-1.0;else db=+p[g+8>>3];switch(e|0){case 0:{eb=2;break}case 1:{eb=3;break}case 3:{eb=8;break}default:eb=6}g=f[H+12>>2]|0;Pa=f[H+8>>2]|0;Ha=f[I+12>>2]|0;bb=f[I+8>>2]|0;f[K>>2]=1124007936;Wa=K+4|0;ab=K+8|0;Va=K+40|0;Qa=Wa;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Va>>2]=ab;ab=K+48|0;d=K+44|0;f[d>>2]=ab;f[ab>>2]=0;f[K+52>>2]=0;f[j>>2]=1;Xa=j+4|0;f[Xa>>2]=g;S$(K,2,j,5);f[N>>2]=1124007936;Oa=N+4|0;Ua=N+8|0;Za=N+40|0;Qa=Oa;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Za>>2]=Ua;Ua=N+48|0;Ja=N+44|0;f[Ja>>2]=Ua;f[Ua>>2]=0;f[N+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=1;S$(N,2,j,5);f[Q>>2]=1124007936;Ma=Q+4|0;Ia=Q+8|0;Ka=Q+40|0;Qa=Ma;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Ka>>2]=Ia;Ia=Q+48|0;La=Q+44|0;f[La>>2]=Ia;f[Ia>>2]=0;f[Q+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(Q,2,j,5);f[R>>2]=1124007936;fb=R+4|0;gb=R+8|0;hb=R+40|0;Qa=fb;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[hb>>2]=gb;gb=R+48|0;ib=R+44|0;f[ib>>2]=gb;f[gb>>2]=0;f[R+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(R,2,j,5);jb=K+16|0;kb=f[jb>>2]|0;lb=N+16|0;mb=f[lb>>2]|0;if((g|0)>0){nb=0;do{n[kb+(nb<<2)>>2]=+(nb|0);nb=nb+1|0}while((nb|0)!=(g|0))}if((Pa|0)>0){nb=0;do{n[mb+(nb<<2)>>2]=+(nb|0);nb=nb+1|0}while((nb|0)!=(Pa|0))}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=K;nb=k+8|0;f[nb>>2]=0;f[nb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=Q;pR(j,Pa,1,k);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=N;nb=k+8|0;f[nb>>2]=0;f[nb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=R;pR(j,1,g,k);nb=K+36|0;mb=f[nb>>2]|0;do if(mb|0){kb=mb+12|0;ob=f[kb>>2]|0;f[kb>>2]=ob+-1;if((ob|0)!=1)break;V$(K)}while(0);f[nb>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[Wa>>2]|0)>0){mb=f[Va>>2]|0;ob=0;do{f[mb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[Wa>>2]|0))}ob=N+36|0;mb=f[ob>>2]|0;do if(mb|0){kb=mb+12|0;pb=f[kb>>2]|0;f[kb>>2]=pb+-1;if((pb|0)!=1)break;V$(N)}while(0);f[ob>>2]=0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[Oa>>2]|0)>0){mb=f[Za>>2]|0;pb=0;do{f[mb+(pb<<2)>>2]=0;pb=pb+1|0}while((pb|0)<(f[Oa>>2]|0))}f[T>>2]=1124007936;pb=T+4|0;mb=T+8|0;kb=T+40|0;Qa=pb;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[kb>>2]=mb;qb=T+48|0;rb=T+44|0;f[rb>>2]=qb;f[qb>>2]=0;f[T+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(T,2,j,5);f[U>>2]=1124007936;sb=U+4|0;tb=U+8|0;ub=U+40|0;Qa=sb;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[ub>>2]=tb;tb=U+48|0;vb=U+44|0;f[vb>>2]=tb;f[tb>>2]=0;f[U+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(U,2,j,5);f[V>>2]=1124007936;wb=V+4|0;xb=V+8|0;yb=V+40|0;Qa=wb;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[yb>>2]=xb;xb=V+48|0;zb=V+44|0;f[zb>>2]=xb;f[xb>>2]=0;f[V+52>>2]=0;f[j>>2]=bb;f[Xa>>2]=Ha;S$(V,2,j,5);f[W>>2]=1124007936;Ab=W+4|0;Bb=W+8|0;Cb=W+40|0;Qa=Ab;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Cb>>2]=Bb;Bb=W+48|0;Db=W+44|0;f[Db>>2]=Bb;f[Bb>>2]=0;f[W+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(W,2,j,5);f[X>>2]=1124007936;Eb=X+4|0;Fb=X+8|0;Gb=X+40|0;Qa=Eb;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Gb>>2]=Fb;Fb=X+48|0;Hb=X+44|0;f[Hb>>2]=Fb;f[Fb>>2]=0;f[X+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(X,2,j,0);do if((eS(h)|0)==65536){Ib=f[h+4>>2]|0;f[Z>>2]=f[Ib>>2];Jb=Z+4|0;Kb=Ib+4|0;f[Jb>>2]=f[Kb>>2];Lb=Z+8|0;f[Lb>>2]=f[Ib+8>>2];f[Z+12>>2]=f[Ib+12>>2];f[Z+16>>2]=f[Ib+16>>2];f[Z+20>>2]=f[Ib+20>>2];f[Z+24>>2]=f[Ib+24>>2];f[Z+28>>2]=f[Ib+28>>2];f[Z+32>>2]=f[Ib+32>>2];Mb=f[Ib+36>>2]|0;f[Z+36>>2]=Mb;f[Z+40>>2]=Lb;Lb=Z+48|0;Nb=Z+44|0;f[Nb>>2]=Lb;f[Lb>>2]=0;f[Z+52>>2]=0;if(Mb|0){Lb=Mb+12|0;f[Lb>>2]=(f[Lb>>2]|0)+1}if((f[Kb>>2]|0)<3){Kb=f[Ib+44>>2]|0;Lb=f[Nb>>2]|0;f[Lb>>2]=f[Kb>>2];f[Lb+4>>2]=f[Kb+4>>2];break}else{f[Jb>>2]=0;U$(Z,Ib);break}}else bS(Z,h,-1);while(0);f[_>>2]=1124007936;Ib=_+4|0;Jb=_+8|0;Kb=_+40|0;Qa=Ib;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Kb>>2]=Jb;Jb=_+48|0;Lb=_+44|0;f[Lb>>2]=Jb;f[Jb>>2]=0;f[_+52>>2]=0;if(sS(h)|0){s$(j,bb,Ha,0);Nb=f[j>>2]|0;ei[f[(f[Nb>>2]|0)+12>>2]&511](Nb,j,_,-1);Zj(j)}else{Nb=j+8|0;f[Nb>>2]=0;f[Nb+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;+_na(h,j,0.0,1.0,0)}h=j+8|0;f[h>>2]=0;f[h+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=U;dY(H,j,f[U>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=U;h=k+8|0;f[h>>2]=0;f[h+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=U;f[$>>2]=5;f[$+4>>2]=5;Jqa(j,k,$,0.0,0.0,4);f[aa>>2]=1124007936;$=aa+4|0;h=aa+8|0;Nb=aa+40|0;Qa=$;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Nb>>2]=h;h=aa+48|0;Mb=aa+44|0;f[Mb>>2]=h;f[h>>2]=0;f[aa+52>>2]=0;Ob=j+8|0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;dY(_,j,5,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=aa;Ob=k+8|0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=aa;f[ba>>2]=5;f[ba+4>>2]=5;Jqa(j,k,ba,0.0,0.0,4);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;dY(aa,j,-1,.5263157894736842,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;dY(aa,j,f[_>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;dY(_,j,f[aa>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=V;dY(I,j,f[V>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ba=k+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=V;f[ca>>2]=5;f[ca+4>>2]=5;Jqa(j,k,ca,0.0,0.0,4);p$(ea,bb,Ha,5);f[da>>2]=1124007936;ca=da+4|0;ba=da+8|0;Ob=da+40|0;Qa=ca;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Ob>>2]=ba;ba=da+48|0;Pb=da+44|0;f[Pb>>2]=ba;f[ba>>2]=0;f[da+52>>2]=0;Qb=f[ea>>2]|0;ei[f[(f[Qb>>2]|0)+12>>2]&511](Qb,ea,da,-1);Zj(ea);p$(ga,bb,Ha,5);f[fa>>2]=1124007936;Ha=fa+4|0;bb=fa+8|0;ea=fa+40|0;Qa=Ha;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[ea>>2]=bb;bb=fa+48|0;Qb=fa+44|0;f[Qb>>2]=bb;f[bb>>2]=0;f[fa+52>>2]=0;Rb=f[ga>>2]|0;ei[f[(f[Rb>>2]|0)+12>>2]&511](Rb,ga,fa,-1);Zj(ga);f[ha>>2]=1124007936;ga=ha+4|0;Rb=ha+8|0;Sb=ha+40|0;Qa=ga;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Sb>>2]=Rb;Tb=ha+48|0;Ub=ha+44|0;f[Ub>>2]=Tb;f[Tb>>2]=0;f[ha+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(ha,2,j,5);f[ia>>2]=1124007936;Vb=ia+4|0;Wb=ia+8|0;Xb=ia+40|0;Qa=Vb;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Xb>>2]=Wb;Wb=ia+48|0;Yb=ia+44|0;f[Yb>>2]=Wb;f[Wb>>2]=0;f[ia+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(ia,2,j,5);n[ja>>2]=-.5;Zb=ja+4|0;n[Zb>>2]=0.0;_b=ja+8|0;n[_b>>2]=.5;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;$b=k+8|0;f[$b>>2]=0;f[$b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=da;f[l>>2]=-1056833531;f[l+4>>2]=ja;f[l+8>>2]=3;f[l+12>>2]=1;f[ka>>2]=-1;f[ka+4>>2]=-1;zja(j,k,-1,l,ka,0.0,4);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ka=k+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=fa;f[m>>2]=f[ja>>2];f[m+4>>2]=f[Zb>>2];f[m+8>>2]=f[_b>>2];f[l>>2]=-1056833531;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=3;f[la>>2]=-1;f[la+4>>2]=-1;zja(j,k,-1,l,la,0.0,4);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;o$(j,da,k,1.0);la=f[j>>2]|0;ei[f[(f[la>>2]|0)+12>>2]&511](la,j,da,-1);Zj(j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;o$(j,fa,k,1.0);la=f[j>>2]|0;ei[f[(f[la>>2]|0)+12>>2]&511](la,j,fa,-1);Zj(j);la=Y(g,eb)|0;f[ma>>2]=1124007936;_b=ma+4|0;Zb=ma+8|0;ja=ma+40|0;Qa=_b;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[ja>>2]=Zb;ka=ma+48|0;$b=ma+44|0;f[$b>>2]=ka;f[ka>>2]=0;f[ma+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=la;S$(ma,2,j,5);f[na>>2]=1124007936;la=na+4|0;ac=na+8|0;bc=na+40|0;Qa=la;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[bc>>2]=ac;ac=na+48|0;cc=na+44|0;f[cc>>2]=ac;f[ac>>2]=0;f[na+52>>2]=0;f[j>>2]=eb;f[Xa>>2]=eb;S$(na,2,j,5);f[oa>>2]=1124007936;dc=oa+4|0;ec=oa+8|0;fc=oa+40|0;Qa=dc;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[fc>>2]=ec;ec=oa+48|0;gc=oa+44|0;f[gc>>2]=ec;f[ec>>2]=0;f[oa+52>>2]=0;f[j>>2]=eb;f[Xa>>2]=eb;S$(oa,2,j,5);f[pa>>2]=1124007936;hc=pa+4|0;ic=pa+8|0;jc=pa+40|0;Qa=hc;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[jc>>2]=ic;ic=pa+48|0;kc=pa+44|0;f[kc>>2]=ic;f[ic>>2]=0;f[pa+52>>2]=0;f[j>>2]=eb;f[Xa>>2]=1;S$(pa,2,j,5);f[qa>>2]=1124007936;lc=qa+4|0;mc=qa+8|0;nc=qa+40|0;Qa=lc;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[nc>>2]=mc;mc=qa+48|0;oc=qa+44|0;f[oc>>2]=mc;f[mc>>2]=0;f[qa+52>>2]=0;f[j>>2]=eb;f[Xa>>2]=1;S$(qa,2,j,5);f[ra>>2]=1124007936;pc=ra+4|0;qc=ra+8|0;rc=ra+40|0;Qa=pc;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[rc>>2]=qc;qc=ra+48|0;sc=ra+44|0;f[sc>>2]=qc;f[qc>>2]=0;f[ra+52>>2]=0;f[j>>2]=eb;f[Xa>>2]=1;S$(ra,2,j,5);f[sa>>2]=1124007936;tc=sa+4|0;uc=sa+8|0;vc=sa+40|0;Qa=tc;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[vc>>2]=uc;uc=sa+48|0;wc=sa+44|0;f[wc>>2]=uc;f[uc>>2]=0;f[sa+52>>2]=0;f[j>>2]=eb;f[Xa>>2]=1;S$(sa,2,j,5);f[ta>>2]=1124007936;xc=ta+4|0;yc=ta+8|0;zc=ta+40|0;Qa=xc;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[zc>>2]=yc;Ac=ta+48|0;Bc=ta+44|0;f[Bc>>2]=Ac;f[Ac>>2]=0;f[ta+52>>2]=0;f[j>>2]=eb;f[Xa>>2]=1;S$(ta,2,j,5);f[ua>>2]=1124007936;eb=ua+4|0;Cc=ua+8|0;Dc=ua+40|0;Qa=eb;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Dc>>2]=Cc;Cc=ua+48|0;Ec=ua+44|0;f[Ec>>2]=Cc;f[Cc>>2]=0;f[ua+52>>2]=0;f[j>>2]=Pa;f[Xa>>2]=g;S$(ua,2,j,5);a:do if((cb|0)<1)Fc=-1.0;else{g=(e|0)==3;Xa=j+8|0;Pa=j+12|0;Gc=j+4|0;Hc=k+8|0;Ic=k+4|0;Jc=l+8|0;Kc=l+12|0;Lc=l+4|0;Mc=za+4|0;Nc=j+8|0;Oc=j+12|0;Pc=j+4|0;Qc=k+8|0;Rc=k+4|0;Sc=l+8|0;Tc=l+12|0;Uc=l+4|0;Vc=Aa+4|0;Wc=j+8|0;Xc=j+12|0;Yc=j+4|0;Zc=k+8|0;_c=k+4|0;$c=l+8|0;ad=l+12|0;bd=l+4|0;cd=Ba+4|0;dd=j+8|0;ed=j+12|0;fd=j+4|0;gd=k+8|0;hd=k+4|0;id=l+8|0;jd=l+12|0;kd=l+4|0;ld=Ca+4|0;md=j+8|0;nd=j+12|0;od=j+4|0;pd=k+4|0;qd=k+8|0;rd=k+12|0;sd=l+4|0;td=l+8|0;ud=l+12|0;vd=m+8|0;wd=m+12|0;xd=m+4|0;yd=j+8|0;zd=j+12|0;Ad=j+4|0;Bd=k+4|0;Cd=k+8|0;Dd=k+12|0;Ed=l+4|0;Fd=l+8|0;Gd=l+12|0;Hd=m+8|0;Id=m+12|0;Jd=m+4|0;Kd=j+8|0;Ld=j+12|0;Md=j+4|0;Nd=k+8|0;Od=k+12|0;Pd=k+4|0;Qd=l+8|0;Rd=l+4|0;Sd=m+8|0;Td=m+12|0;Ud=m+4|0;Vd=T+12|0;Wd=j+8|0;Xd=j+12|0;Yd=j+4|0;Zd=k+8|0;_d=k+12|0;$d=k+4|0;ae=l+8|0;be=l+4|0;ce=m+8|0;de=m+12|0;ee=m+4|0;fe=j+8|0;ge=j+12|0;he=j+4|0;ie=j+8|0;je=j+12|0;ke=j+4|0;le=j+8|0;me=j+12|0;ne=j+4|0;oe=j+8|0;pe=j+12|0;qe=j+4|0;re=j+8|0;se=j+12|0;te=j+4|0;ue=(e|0)==0;ve=(e|0)==1;we=(e|0)==2;xe=e>>>0<4;ye=ta+12|0;ze=ta+16|0;Ae=ma+12|0;Be=ha+12|0;Ce=m+8|0;De=m+12|0;Ee=m+4|0;Fe=j+4|0;Ge=k+4|0;He=o+36|0;Ie=o+16|0;Je=o+4|0;Ke=o+40|0;Le=o+44|0;Me=o+48|0;Ne=m+8|0;Oe=m+12|0;Pe=m+4|0;Qe=j+4|0;Re=k+4|0;Se=q+36|0;Te=q+16|0;Ue=q+4|0;Ve=q+40|0;We=q+44|0;Xe=q+48|0;Ye=m+8|0;Ze=m+12|0;_e=m+4|0;$e=j+4|0;af=k+4|0;bf=r+36|0;cf=r+16|0;df=r+4|0;ef=r+40|0;ff=r+44|0;gf=r+48|0;hf=m+8|0;jf=m+12|0;kf=m+4|0;lf=j+4|0;mf=k+4|0;nf=t+36|0;of=t+16|0;pf=t+4|0;qf=t+40|0;rf=t+44|0;sf=t+48|0;tf=j+4|0;uf=k+4|0;vf=l+8|0;wf=l+4|0;xf=m+36|0;yf=m+16|0;zf=m+4|0;Af=m+40|0;Bf=m+44|0;Cf=m+48|0;Df=j+4|0;Ef=k+4|0;Ff=l+8|0;Gf=l+4|0;Hf=m+36|0;If=m+16|0;Jf=m+4|0;Kf=m+40|0;Lf=m+44|0;Mf=m+48|0;Nf=q+8|0;Of=l+4|0;Pf=l+8|0;Qf=l+40|0;Rf=l+48|0;Sf=l+44|0;Tf=l+52|0;Uf=v+8|0;Vf=o+4|0;Wf=o+8|0;Xf=o+40|0;Yf=o+48|0;Zf=o+44|0;_f=o+52|0;$f=j+8|0;ag=j+12|0;bg=j+4|0;cg=k+8|0;dg=k+12|0;eg=k+4|0;fg=q+8|0;gg=q+4|0;hg=x+8|0;ig=q+4|0;jg=q+8|0;kg=q+40|0;lg=q+48|0;mg=q+44|0;ng=q+52|0;og=j+8|0;pg=j+12|0;qg=j+4|0;rg=k+8|0;sg=k+12|0;tg=k+4|0;ug=t+8|0;vg=t+4|0;wg=t+4|0;xg=t+8|0;yg=t+40|0;zg=t+48|0;Ag=t+44|0;Bg=t+52|0;Cg=v+4|0;Dg=v+8|0;Eg=v+40|0;Fg=v+48|0;Gg=v+44|0;Hg=v+52|0;Ig=j+8|0;Jg=j+12|0;Kg=j+4|0;Lg=k+8|0;Mg=k+12|0;Ng=k+4|0;Og=x+8|0;Pg=x+4|0;Qg=j+8|0;Rg=j+12|0;Sg=j+4|0;Tg=k+8|0;Ug=k+12|0;Vg=k+4|0;Wg=x+8|0;Xg=x+4|0;Yg=y+8|0;Zg=y+12|0;_g=y+4|0;$g=j+4|0;ah=k+4|0;bh=z+36|0;ch=z+16|0;dh=z+4|0;eh=z+40|0;fh=z+44|0;gh=z+48|0;hh=y+8|0;ih=y+12|0;jh=y+4|0;kh=j+4|0;lh=k+4|0;mh=A+36|0;nh=A+16|0;oh=A+4|0;ph=A+40|0;qh=A+44|0;rh=A+48|0;sh=k+8|0;th=k+12|0;uh=k+4|0;vh=C+8|0;wh=C+12|0;xh=C+4|0;yh=x+4|0;zh=x+8|0;Ah=x+40|0;Bh=x+48|0;Ch=x+44|0;Dh=x+52|0;Eh=C+8|0;Fh=C+12|0;Gh=C+4|0;Hh=j+4|0;Ih=k+4|0;Jh=D+36|0;Kh=D+16|0;Lh=D+4|0;Mh=D+40|0;Nh=D+44|0;Oh=D+48|0;Ph=o+36|0;Qh=o+16|0;Rh=q+36|0;Sh=q+16|0;Th=C+8|0;Uh=C+12|0;Vh=C+4|0;Wh=j+4|0;Xh=k+4|0;Yh=E+36|0;Zh=E+16|0;_h=E+4|0;$h=E+40|0;ai=E+44|0;bi=E+48|0;ci=C+8|0;di=C+12|0;fi=C+4|0;gi=j+4|0;hi=k+4|0;ii=F+36|0;ji=F+16|0;ki=F+4|0;li=F+40|0;mi=F+44|0;ni=F+48|0;oi=C+8|0;pi=C+12|0;qi=C+4|0;ri=j+4|0;si=k+4|0;ti=G+36|0;ui=G+16|0;vi=G+4|0;wi=G+40|0;xi=G+44|0;yi=G+48|0;zi=j+4|0;Ai=k+4|0;Bi=y+8|0;Ci=y+4|0;Di=C+36|0;Ei=C+16|0;Fi=C+4|0;Gi=C+40|0;Hi=C+44|0;Ii=C+48|0;Ji=j+4|0;Ki=k+4|0;Li=y+8|0;Mi=y+4|0;Ni=C+36|0;Oi=C+16|0;Pi=C+4|0;Qi=C+40|0;Ri=C+44|0;Si=C+48|0;Ti=x+36|0;Ui=x+16|0;Vi=v+36|0;Wi=v+16|0;Xi=t+36|0;Yi=t+16|0;Zi=l+36|0;_i=l+16|0;$i=j+4|0;aj=k+4|0;bj=l+8|0;cj=l+4|0;dj=m+36|0;ej=m+16|0;fj=m+4|0;gj=m+40|0;hj=m+44|0;ij=m+48|0;jj=j+4|0;kj=k+4|0;lj=l+8|0;mj=l+4|0;nj=m+36|0;oj=m+16|0;pj=m+4|0;qj=m+40|0;rj=m+44|0;sj=m+48|0;tj=l+4|0;uj=l+8|0;vj=l+40|0;wj=l+48|0;xj=l+44|0;yj=l+52|0;zj=o+4|0;Aj=o+8|0;Bj=o+40|0;Cj=o+48|0;Dj=o+44|0;Ej=o+52|0;Fj=v+8|0;Gj=v+12|0;Hj=v+4|0;Ij=x+8|0;Jj=x+12|0;Kj=x+4|0;Lj=j+4|0;Mj=k+4|0;Nj=y+36|0;Oj=y+16|0;Pj=y+4|0;Qj=y+40|0;Rj=y+44|0;Sj=y+48|0;Tj=j+4|0;Uj=k+4|0;Vj=r+8|0;Wj=r+4|0;Xj=t+36|0;Yj=t+16|0;_j=t+4|0;$j=t+40|0;ak=t+44|0;bk=t+48|0;ck=j+4|0;dk=k+4|0;ek=r+8|0;fk=r+4|0;gk=t+36|0;hk=t+16|0;ik=t+4|0;jk=t+40|0;kk=t+44|0;lk=t+48|0;mk=o+36|0;nk=o+16|0;ok=l+36|0;pk=l+16|0;qk=j+8|0;rk=j+12|0;sk=j+4|0;tk=k+8|0;uk=k+4|0;vk=l+8|0;wk=l+12|0;xk=l+4|0;yk=va+4|0;zk=j+8|0;Ak=j+12|0;Bk=j+4|0;Ck=k+8|0;Dk=k+4|0;Ek=l+8|0;Fk=l+12|0;Gk=l+4|0;Hk=wa+4|0;Ik=j+8|0;Jk=j+12|0;Kk=j+4|0;Lk=k+8|0;Mk=k+4|0;Nk=l+8|0;Ok=l+12|0;Pk=l+4|0;Qk=xa+4|0;Rk=j+8|0;Sk=j+12|0;Tk=j+4|0;Uk=k+8|0;Vk=k+4|0;Wk=l+8|0;Xk=l+12|0;Yk=l+4|0;Zk=ya+4|0;_k=-1.0;$k=1;al=-db;b:while(1){if(!(+L(+(_k-al))>=db)){Fc=_k;break a}if(g){f[Xa>>2]=0;f[Pa>>2]=0;f[j>>2]=16842752;f[Gc>>2]=V;bl=Hc;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[Ic>>2]=W;f[Jc>>2]=0;f[Kc>>2]=0;f[l>>2]=16842752;f[Lc>>2]=J;bl=f[Cb>>2]|0;cl=f[bl>>2]|0;f[za>>2]=f[bl+4>>2];f[Mc>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;aba(j,k,l,za,17,0,m);f[Nc>>2]=0;f[Oc>>2]=0;f[j>>2]=16842752;f[Pc>>2]=da;cl=Qc;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[Rc>>2]=ha;f[Sc>>2]=0;f[Tc>>2]=0;f[l>>2]=16842752;f[Uc>>2]=J;cl=f[Sb>>2]|0;bl=f[cl>>2]|0;f[Aa>>2]=f[cl+4>>2];f[Vc>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;aba(j,k,l,Aa,17,0,m);f[Wc>>2]=0;f[Xc>>2]=0;f[j>>2]=16842752;f[Yc>>2]=fa;bl=Zc;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[_c>>2]=ia;f[$c>>2]=0;f[ad>>2]=0;f[l>>2]=16842752;f[bd>>2]=J;bl=f[Xb>>2]|0;cl=f[bl>>2]|0;f[Ba>>2]=f[bl+4>>2];f[cd>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;aba(j,k,l,Ba,17,0,m);f[dd>>2]=0;f[ed>>2]=0;f[j>>2]=16842752;f[fd>>2]=_;cl=gd;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[hd>>2]=X;f[id>>2]=0;f[jd>>2]=0;f[l>>2]=16842752;f[kd>>2]=J;cl=f[Gb>>2]|0;bl=f[cl>>2]|0;f[Ca>>2]=f[cl+4>>2];f[ld>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;aba(j,k,l,Ca,16,0,m)}else{f[qk>>2]=0;f[rk>>2]=0;f[j>>2]=16842752;f[sk>>2]=V;bl=tk;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[uk>>2]=W;f[vk>>2]=0;f[wk>>2]=0;f[l>>2]=16842752;f[xk>>2]=J;bl=f[Cb>>2]|0;cl=f[bl>>2]|0;f[va>>2]=f[bl+4>>2];f[yk>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Waa(j,k,l,va,17,0,m);f[zk>>2]=0;f[Ak>>2]=0;f[j>>2]=16842752;f[Bk>>2]=da;cl=Ck;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[Dk>>2]=ha;f[Ek>>2]=0;f[Fk>>2]=0;f[l>>2]=16842752;f[Gk>>2]=J;cl=f[Sb>>2]|0;bl=f[cl>>2]|0;f[wa>>2]=f[cl+4>>2];f[Hk>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Waa(j,k,l,wa,17,0,m);f[Ik>>2]=0;f[Jk>>2]=0;f[j>>2]=16842752;f[Kk>>2]=fa;bl=Lk;f[bl>>2]=0;f[bl+4>>2]=0;f[k>>2]=33619968;f[Mk>>2]=ia;f[Nk>>2]=0;f[Ok>>2]=0;f[l>>2]=16842752;f[Pk>>2]=J;bl=f[Xb>>2]|0;cl=f[bl>>2]|0;f[xa>>2]=f[bl+4>>2];f[Qk>>2]=cl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Waa(j,k,l,xa,17,0,m);f[Rk>>2]=0;f[Sk>>2]=0;f[j>>2]=16842752;f[Tk>>2]=_;cl=Uk;f[cl>>2]=0;f[cl+4>>2]=0;f[k>>2]=33619968;f[Vk>>2]=X;f[Wk>>2]=0;f[Xk>>2]=0;f[l>>2]=16842752;f[Yk>>2]=J;cl=f[Gb>>2]|0;bl=f[cl>>2]|0;f[ya>>2]=f[cl+4>>2];f[Zk>>2]=bl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Waa(j,k,l,ya,16,0,m)};f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;f[Da+16>>2]=0;f[Da+20>>2]=0;f[Da+24>>2]=0;f[Da+28>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;f[Ea+16>>2]=0;f[Ea+20>>2]=0;f[Ea+24>>2]=0;f[Ea+28>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;f[Fa+16>>2]=0;f[Fa+20>>2]=0;f[Fa+24>>2]=0;f[Fa+28>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;f[Ga+16>>2]=0;f[Ga+20>>2]=0;f[Ga+24>>2]=0;f[Ga+28>>2]=0;f[md>>2]=0;f[nd>>2]=0;f[j>>2]=16842752;f[od>>2]=W;f[k>>2]=-1040056314;f[pd>>2]=Da;f[qd>>2]=1;f[rd>>2]=4;f[l>>2]=-1040056314;f[sd>>2]=Ea;f[td>>2]=1;f[ud>>2]=4;f[vd>>2]=0;f[wd>>2]=0;f[m>>2]=16842752;f[xd>>2]=X;nL(j,k,l,m);f[yd>>2]=0;f[zd>>2]=0;f[j>>2]=16842752;f[Ad>>2]=U;f[k>>2]=-1040056314;f[Bd>>2]=Fa;f[Cd>>2]=1;f[Dd>>2]=4;f[l>>2]=-1040056314;f[Ed>>2]=Ga;f[Fd>>2]=1;f[Gd>>2]=4;f[Hd>>2]=0;f[Id>>2]=0;f[m>>2]=16842752;f[Jd>>2]=X;nL(j,k,l,m);f[Kd>>2]=0;f[Ld>>2]=0;f[j>>2]=16842752;f[Md>>2]=W;f[k>>2]=-1056833530;f[Pd>>2]=Da;f[Nd>>2]=1;f[Od>>2]=4;bl=Qd;f[bl>>2]=0;f[bl+4>>2]=0;f[l>>2]=33619968;f[Rd>>2]=W;f[Sd>>2]=0;f[Td>>2]=0;f[m>>2]=16842752;f[Ud>>2]=X;G1(j,k,l,m,-1);p$(j,f[mb>>2]|0,f[Vd>>2]|0,f[T>>2]&4095);bl=f[j>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,j,T,-1);Zj(j);f[Wd>>2]=0;f[Xd>>2]=0;f[j>>2]=16842752;f[Yd>>2]=U;f[k>>2]=-1056833530;f[$d>>2]=Fa;f[Zd>>2]=1;f[_d>>2]=4;bl=ae;f[bl>>2]=0;f[bl+4>>2]=0;f[l>>2]=33619968;f[be>>2]=T;f[ce>>2]=0;f[de>>2]=0;f[m>>2]=16842752;f[ee>>2]=X;G1(j,k,l,m,-1);f[fe>>2]=0;f[ge>>2]=0;f[j>>2]=16842752;f[he>>2]=X;dl=+(jP(j)|0);el=+p[Ga>>3];fl=+M(+(el*(dl*el)));f[ie>>2]=0;f[je>>2]=0;f[j>>2]=16842752;f[ke>>2]=X;el=+(jP(j)|0);dl=+p[Ea>>3];gl=+M(+(dl*(el*dl)));switch(e|0){case 2:{bl=f[Sb>>2]|0;cl=f[bl+4>>2]|0;hl=f[bl>>2]|0;bl=f[Xb>>2]|0;if(!((hl|0)==(f[bl>>2]|0)?(cl|0)==(f[bl+4>>2]|0):0)){$a=346;break b}bl=f[Ka>>2]|0;if(!((hl|0)==(f[bl>>2]|0)?(cl|0)==(f[bl+4>>2]|0):0)){$a=348;break b}bl=f[hb>>2]|0;if(!((hl|0)==(f[bl>>2]|0)?(cl|0)==(f[bl+4>>2]|0):0)){$a=350;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){$a=352;break b}bl=f[Ae>>2]|0;cl=f[Be>>2]|0;if((bl|0)!=(cl*6|0)){$a=354;break b}if((f[ma>>2]&4095|0)!=5){$a=356;break b}f[Ce>>2]=0;f[De>>2]=0;f[m>>2]=16842752;f[Ee>>2]=Q;o$(l,ha,m,1.0);f[j>>2]=-2147483648;f[Fe>>2]=2147483647;f[k>>2]=0;f[Ge>>2]=cl;W$(o,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,o,-1);hl=f[He>>2]|0;do if(hl|0){il=hl+12|0;jl=f[il>>2]|0;f[il>>2]=jl+-1;if((jl|0)!=1)break;V$(o)}while(0);f[He>>2]=0;f[Ie>>2]=0;f[Ie+4>>2]=0;f[Ie+8>>2]=0;f[Ie+12>>2]=0;if((f[Je>>2]|0)>0){hl=f[Ke>>2]|0;jl=0;do{f[hl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Je>>2]|0))}jl=f[Le>>2]|0;if((jl|0)!=(Me|0))wL(jl);Zj(l);f[Ne>>2]=0;f[Oe>>2]=0;f[m>>2]=16842752;f[Pe>>2]=Q;o$(l,ia,m,1.0);jl=cl<<1;f[j>>2]=-2147483648;f[Qe>>2]=2147483647;f[k>>2]=cl;f[Re>>2]=jl;W$(q,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,q,-1);hl=f[Se>>2]|0;do if(hl|0){il=hl+12|0;kl=f[il>>2]|0;f[il>>2]=kl+-1;if((kl|0)!=1)break;V$(q)}while(0);f[Se>>2]=0;f[Te>>2]=0;f[Te+4>>2]=0;f[Te+8>>2]=0;f[Te+12>>2]=0;if((f[Ue>>2]|0)>0){hl=f[Ve>>2]|0;kl=0;do{f[hl+(kl<<2)>>2]=0;kl=kl+1|0}while((kl|0)<(f[Ue>>2]|0))}kl=f[We>>2]|0;if((kl|0)!=(Xe|0))wL(kl);Zj(l);f[Ye>>2]=0;f[Ze>>2]=0;f[m>>2]=16842752;f[_e>>2]=R;o$(l,ha,m,1.0);kl=cl*3|0;f[j>>2]=-2147483648;f[$e>>2]=2147483647;f[k>>2]=jl;f[af>>2]=kl;W$(r,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,r,-1);hl=f[bf>>2]|0;do if(hl|0){il=hl+12|0;ll=f[il>>2]|0;f[il>>2]=ll+-1;if((ll|0)!=1)break;V$(r)}while(0);f[bf>>2]=0;f[cf>>2]=0;f[cf+4>>2]=0;f[cf+8>>2]=0;f[cf+12>>2]=0;if((f[df>>2]|0)>0){hl=f[ef>>2]|0;jl=0;do{f[hl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[df>>2]|0))}jl=f[ff>>2]|0;if((jl|0)!=(gf|0))wL(jl);Zj(l);f[hf>>2]=0;f[jf>>2]=0;f[m>>2]=16842752;f[kf>>2]=R;o$(l,ia,m,1.0);jl=cl<<2;f[j>>2]=-2147483648;f[lf>>2]=2147483647;f[k>>2]=kl;f[mf>>2]=jl;W$(t,ma,j,k);hl=f[l>>2]|0;ei[f[(f[hl>>2]|0)+12>>2]&511](hl,l,t,-1);hl=f[nf>>2]|0;do if(hl|0){ll=hl+12|0;il=f[ll>>2]|0;f[ll>>2]=il+-1;if((il|0)!=1)break;V$(t)}while(0);f[nf>>2]=0;f[of>>2]=0;f[of+4>>2]=0;f[of+8>>2]=0;f[of+12>>2]=0;if((f[pf>>2]|0)>0){hl=f[qf>>2]|0;kl=0;do{f[hl+(kl<<2)>>2]=0;kl=kl+1|0}while((kl|0)<(f[pf>>2]|0))}kl=f[rf>>2]|0;if((kl|0)!=(sf|0))wL(kl);Zj(l);kl=cl*5|0;f[j>>2]=-2147483648;f[tf>>2]=2147483647;f[k>>2]=jl;f[uf>>2]=kl;W$(m,ma,j,k);hl=vf;f[hl>>2]=0;f[hl+4>>2]=0;f[l>>2]=-1040121856;f[wf>>2]=m;jR(ha,l);hl=f[xf>>2]|0;do if(hl|0){il=hl+12|0;ll=f[il>>2]|0;f[il>>2]=ll+-1;if((ll|0)!=1)break;V$(m)}while(0);f[xf>>2]=0;f[yf>>2]=0;f[yf+4>>2]=0;f[yf+8>>2]=0;f[yf+12>>2]=0;if((f[zf>>2]|0)>0){hl=f[Af>>2]|0;jl=0;do{f[hl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[zf>>2]|0))}jl=f[Bf>>2]|0;if((jl|0)!=(Cf|0))wL(jl);f[j>>2]=-2147483648;f[Df>>2]=2147483647;f[k>>2]=kl;f[Ef>>2]=bl;W$(m,ma,j,k);jl=Ff;f[jl>>2]=0;f[jl+4>>2]=0;f[l>>2]=-1040121856;f[Gf>>2]=m;jR(ia,l);jl=f[Hf>>2]|0;do if(jl|0){hl=jl+12|0;cl=f[hl>>2]|0;f[hl>>2]=cl+-1;if((cl|0)!=1)break;V$(m)}while(0);f[Hf>>2]=0;f[If>>2]=0;f[If+4>>2]=0;f[If+8>>2]=0;f[If+12>>2]=0;if((f[Jf>>2]|0)>0){jl=f[Kf>>2]|0;bl=0;do{f[jl+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Jf>>2]|0))}bl=f[Lf>>2]|0;if((bl|0)!=(Mf|0))wL(bl);break}case 3:{bl=f[Ya>>2]|0;jl=f[Sb>>2]|0;kl=f[jl+4>>2]|0;cl=f[jl>>2]|0;jl=f[Xb>>2]|0;if(!((cl|0)==(f[jl>>2]|0)?(kl|0)==(f[jl+4>>2]|0):0)){$a=407;break b}jl=f[Ka>>2]|0;if(!((cl|0)==(f[jl>>2]|0)?(kl|0)==(f[jl+4>>2]|0):0)){$a=409;break b}jl=f[hb>>2]|0;if(!((cl|0)==(f[jl>>2]|0)?(kl|0)==(f[jl+4>>2]|0):0)){$a=411;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){$a=413;break b}jl=f[Ae>>2]|0;kl=f[Be>>2]|0;if((jl|0)!=(kl<<3|0)){$a=415;break b}if((f[ma>>2]&4095|0)!=5){$a=417;break b}if(!(f[J>>2]&16384)){$a=419;break b}dl=+n[bl>>2];el=+n[bl+12>>2];ml=+n[bl+4>>2];nl=+n[bl+16>>2];ol=+n[bl+28>>2];pl=+n[bl+8>>2];ql=+n[bl+20>>2];c$(k,Q,+n[bl+24>>2]);c$(o,R,ol);V_(j,k,o);p[q>>3]=1.0;f[Nf>>2]=0;f[Nf+4>>2]=0;f[Nf+8>>2]=0;f[Nf+12>>2]=0;f[Nf+16>>2]=0;f[Nf+20>>2]=0;U_(m,j,q);f[l>>2]=1124007936;Qa=Of;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Qf>>2]=Pf;f[Sf>>2]=Rf;f[Rf>>2]=0;f[Tf>>2]=0;bl=f[m>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,m,l,-1);Zj(m);Zj(j);Zj(o);Zj(k);$_(q,Q);e$(k,q,dl);c$(t,R,ml);__(j,k,t);p[v>>3]=pl;f[Uf>>2]=0;f[Uf+4>>2]=0;f[Uf+8>>2]=0;f[Uf+12>>2]=0;f[Uf+16>>2]=0;f[Uf+20>>2]=0;Z_(r,j,v);f[o>>2]=1124007936;Qa=Vf;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Xf>>2]=Wf;f[Zf>>2]=Yf;f[Yf>>2]=0;f[_f>>2]=0;bl=f[r>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,r,o,-1);Zj(r);Zj(j);Zj(t);Zj(k);Zj(q);f[$f>>2]=0;f[ag>>2]=0;f[j>>2]=16842752;f[bg>>2]=o;f[cg>>2]=0;f[dg>>2]=0;f[k>>2]=16842752;f[eg>>2]=l;bl=fg;f[bl>>2]=0;f[bl+4>>2]=0;f[q>>2]=33619968;f[gg>>2]=o;J1(j,k,q,1.0,-1);$_(t,Q);e$(k,t,el);c$(v,R,nl);__(j,k,v);p[x>>3]=ql;f[hg>>2]=0;f[hg+4>>2]=0;f[hg+8>>2]=0;f[hg+12>>2]=0;f[hg+16>>2]=0;f[hg+20>>2]=0;Z_(w,j,x);f[q>>2]=1124007936;Qa=ig;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[kg>>2]=jg;f[mg>>2]=lg;f[lg>>2]=0;f[ng>>2]=0;bl=f[w>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,w,q,-1);Zj(w);Zj(j);Zj(v);Zj(k);Zj(t);f[og>>2]=0;f[pg>>2]=0;f[j>>2]=16842752;f[qg>>2]=q;f[rg>>2]=0;f[sg>>2]=0;f[k>>2]=16842752;f[tg>>2]=l;bl=ug;f[bl>>2]=0;f[bl+4>>2]=0;f[t>>2]=33619968;f[vg>>2]=q;J1(j,k,t,1.0,-1);f[t>>2]=1124007936;Qa=wg;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[yg>>2]=xg;f[Ag>>2]=zg;f[zg>>2]=0;f[Bg>>2]=0;f[v>>2]=1124007936;Qa=Cg;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Eg>>2]=Dg;f[Gg>>2]=Fg;f[Fg>>2]=0;f[Hg>>2]=0;f[Ig>>2]=0;f[Jg>>2]=0;f[j>>2]=16842752;f[Kg>>2]=ha;f[Lg>>2]=0;f[Mg>>2]=0;f[k>>2]=16842752;f[Ng>>2]=l;bl=Og;f[bl>>2]=0;f[bl+4>>2]=0;f[x>>2]=33619968;f[Pg>>2]=t;J1(j,k,x,1.0,-1);f[Qg>>2]=0;f[Rg>>2]=0;f[j>>2]=16842752;f[Sg>>2]=ia;f[Tg>>2]=0;f[Ug>>2]=0;f[k>>2]=16842752;f[Vg>>2]=l;bl=Wg;f[bl>>2]=0;f[bl+4>>2]=0;f[x>>2]=33619968;f[Xg>>2]=v;J1(j,k,x,1.0,-1);f[Yg>>2]=0;f[Zg>>2]=0;f[y>>2]=16842752;f[_g>>2]=Q;o$(x,t,y,1.0);f[j>>2]=-2147483648;f[$g>>2]=2147483647;f[k>>2]=0;f[ah>>2]=kl;W$(z,ma,j,k);bl=f[x>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,x,z,-1);bl=f[bh>>2]|0;do if(bl|0){cl=bl+12|0;hl=f[cl>>2]|0;f[cl>>2]=hl+-1;if((hl|0)!=1)break;V$(z)}while(0);f[bh>>2]=0;f[ch>>2]=0;f[ch+4>>2]=0;f[ch+8>>2]=0;f[ch+12>>2]=0;if((f[dh>>2]|0)>0){bl=f[eh>>2]|0;hl=0;do{f[bl+(hl<<2)>>2]=0;hl=hl+1|0}while((hl|0)<(f[dh>>2]|0))}hl=f[fh>>2]|0;if((hl|0)!=(gh|0))wL(hl);Zj(x);f[hh>>2]=0;f[ih>>2]=0;f[y>>2]=16842752;f[jh>>2]=Q;o$(x,v,y,1.0);hl=kl<<1;f[j>>2]=-2147483648;f[kh>>2]=2147483647;f[k>>2]=kl;f[lh>>2]=hl;W$(A,ma,j,k);bl=f[x>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,x,A,-1);bl=f[mh>>2]|0;do if(bl|0){cl=bl+12|0;ll=f[cl>>2]|0;f[cl>>2]=ll+-1;if((ll|0)!=1)break;V$(A)}while(0);f[mh>>2]=0;f[nh>>2]=0;f[nh+4>>2]=0;f[nh+8>>2]=0;f[nh+12>>2]=0;if((f[oh>>2]|0)>0){bl=f[ph>>2]|0;ll=0;do{f[bl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[oh>>2]|0))}ll=f[qh>>2]|0;if((ll|0)!=(rh|0))wL(ll);Zj(x);f[sh>>2]=0;f[th>>2]=0;f[k>>2]=16842752;f[uh>>2]=t;o$(j,o,k,1.0);f[vh>>2]=0;f[wh>>2]=0;f[C>>2]=16842752;f[xh>>2]=v;o$(y,q,C,1.0);V_(B,j,y);f[x>>2]=1124007936;Qa=yh;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Ah>>2]=zh;f[Ch>>2]=Bh;f[Bh>>2]=0;f[Dh>>2]=0;ll=f[B>>2]|0;ei[f[(f[ll>>2]|0)+12>>2]&511](ll,B,x,-1);Zj(B);Zj(y);Zj(j);f[Eh>>2]=0;f[Fh>>2]=0;f[C>>2]=16842752;f[Gh>>2]=Q;o$(y,x,C,1.0);ll=kl*3|0;f[j>>2]=-2147483648;f[Hh>>2]=2147483647;f[k>>2]=hl;f[Ih>>2]=ll;W$(D,ma,j,k);bl=f[y>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,y,D,-1);bl=f[Jh>>2]|0;do if(bl|0){cl=bl+12|0;il=f[cl>>2]|0;f[cl>>2]=il+-1;if((il|0)!=1)break;V$(D)}while(0);f[Jh>>2]=0;f[Kh>>2]=0;f[Kh+4>>2]=0;f[Kh+8>>2]=0;f[Kh+12>>2]=0;if((f[Lh>>2]|0)>0){bl=f[Mh>>2]|0;hl=0;do{f[bl+(hl<<2)>>2]=0;hl=hl+1|0}while((hl|0)<(f[Lh>>2]|0))}hl=f[Nh>>2]|0;if((hl|0)!=(Oh|0))wL(hl);Zj(y);hl=f[Ph>>2]|0;do if(hl|0){bl=hl+12|0;il=f[bl>>2]|0;f[bl>>2]=il+-1;if((il|0)!=1)break;V$(o)}while(0);f[Ph>>2]=0;f[Qh>>2]=0;f[Qh+4>>2]=0;f[Qh+8>>2]=0;f[Qh+12>>2]=0;if((f[Vf>>2]|0)>0){hl=f[Xf>>2]|0;il=0;do{f[hl+(il<<2)>>2]=0;il=il+1|0}while((il|0)<(f[Vf>>2]|0))}il=f[Rh>>2]|0;do if(il|0){hl=il+12|0;bl=f[hl>>2]|0;f[hl>>2]=bl+-1;if((bl|0)!=1)break;V$(q)}while(0);f[Rh>>2]=0;f[Sh>>2]=0;f[Sh+4>>2]=0;f[Sh+8>>2]=0;f[Sh+12>>2]=0;if((f[ig>>2]|0)>0){il=f[kg>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[ig>>2]|0))}f[Th>>2]=0;f[Uh>>2]=0;f[C>>2]=16842752;f[Vh>>2]=R;o$(y,t,C,1.0);bl=kl<<2;f[j>>2]=-2147483648;f[Wh>>2]=2147483647;f[k>>2]=ll;f[Xh>>2]=bl;W$(E,ma,j,k);il=f[y>>2]|0;ei[f[(f[il>>2]|0)+12>>2]&511](il,y,E,-1);il=f[Yh>>2]|0;do if(il|0){hl=il+12|0;cl=f[hl>>2]|0;f[hl>>2]=cl+-1;if((cl|0)!=1)break;V$(E)}while(0);f[Yh>>2]=0;f[Zh>>2]=0;f[Zh+4>>2]=0;f[Zh+8>>2]=0;f[Zh+12>>2]=0;if((f[_h>>2]|0)>0){il=f[$h>>2]|0;ll=0;do{f[il+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[_h>>2]|0))}ll=f[ai>>2]|0;if((ll|0)!=(bi|0))wL(ll);Zj(y);f[ci>>2]=0;f[di>>2]=0;f[C>>2]=16842752;f[fi>>2]=R;o$(y,v,C,1.0);ll=kl*5|0;f[j>>2]=-2147483648;f[gi>>2]=2147483647;f[k>>2]=bl;f[hi>>2]=ll;W$(F,ma,j,k);il=f[y>>2]|0;ei[f[(f[il>>2]|0)+12>>2]&511](il,y,F,-1);il=f[ii>>2]|0;do if(il|0){cl=il+12|0;hl=f[cl>>2]|0;f[cl>>2]=hl+-1;if((hl|0)!=1)break;V$(F)}while(0);f[ii>>2]=0;f[ji>>2]=0;f[ji+4>>2]=0;f[ji+8>>2]=0;f[ji+12>>2]=0;if((f[ki>>2]|0)>0){il=f[li>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[ki>>2]|0))}bl=f[mi>>2]|0;if((bl|0)!=(ni|0))wL(bl);Zj(y);f[oi>>2]=0;f[pi>>2]=0;f[C>>2]=16842752;f[qi>>2]=R;o$(y,x,C,1.0);bl=kl*6|0;f[j>>2]=-2147483648;f[ri>>2]=2147483647;f[k>>2]=ll;f[si>>2]=bl;W$(G,ma,j,k);il=f[y>>2]|0;ei[f[(f[il>>2]|0)+12>>2]&511](il,y,G,-1);il=f[ti>>2]|0;do if(il|0){hl=il+12|0;cl=f[hl>>2]|0;f[hl>>2]=cl+-1;if((cl|0)!=1)break;V$(G)}while(0);f[ti>>2]=0;f[ui>>2]=0;f[ui+4>>2]=0;f[ui+8>>2]=0;f[ui+12>>2]=0;if((f[vi>>2]|0)>0){il=f[wi>>2]|0;ll=0;do{f[il+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[vi>>2]|0))}ll=f[xi>>2]|0;if((ll|0)!=(yi|0))wL(ll);Zj(y);ll=kl*7|0;f[j>>2]=-2147483648;f[zi>>2]=2147483647;f[k>>2]=bl;f[Ai>>2]=ll;W$(C,ma,j,k);il=Bi;f[il>>2]=0;f[il+4>>2]=0;f[y>>2]=-1040121856;f[Ci>>2]=C;jR(t,y);il=f[Di>>2]|0;do if(il|0){cl=il+12|0;hl=f[cl>>2]|0;f[cl>>2]=hl+-1;if((hl|0)!=1)break;V$(C)}while(0);f[Di>>2]=0;f[Ei>>2]=0;f[Ei+4>>2]=0;f[Ei+8>>2]=0;f[Ei+12>>2]=0;if((f[Fi>>2]|0)>0){il=f[Gi>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Fi>>2]|0))}bl=f[Hi>>2]|0;if((bl|0)!=(Ii|0))wL(bl);f[j>>2]=-2147483648;f[Ji>>2]=2147483647;f[k>>2]=ll;f[Ki>>2]=jl;W$(C,ma,j,k);bl=Li;f[bl>>2]=0;f[bl+4>>2]=0;f[y>>2]=-1040121856;f[Mi>>2]=C;jR(v,y);bl=f[Ni>>2]|0;do if(bl|0){il=bl+12|0;kl=f[il>>2]|0;f[il>>2]=kl+-1;if((kl|0)!=1)break;V$(C)}while(0);f[Ni>>2]=0;f[Oi>>2]=0;f[Oi+4>>2]=0;f[Oi+8>>2]=0;f[Oi+12>>2]=0;if((f[Pi>>2]|0)>0){bl=f[Qi>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Pi>>2]|0))}jl=f[Ri>>2]|0;if((jl|0)!=(Si|0))wL(jl);jl=f[Ti>>2]|0;do if(jl|0){bl=jl+12|0;ll=f[bl>>2]|0;f[bl>>2]=ll+-1;if((ll|0)!=1)break;V$(x)}while(0);f[Ti>>2]=0;f[Ui>>2]=0;f[Ui+4>>2]=0;f[Ui+8>>2]=0;f[Ui+12>>2]=0;if((f[yh>>2]|0)>0){jl=f[Ah>>2]|0;ll=0;do{f[jl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[yh>>2]|0))}ll=f[Ch>>2]|0;if((ll|0)!=(Bh|0))wL(ll);ll=f[Vi>>2]|0;do if(ll|0){jl=ll+12|0;bl=f[jl>>2]|0;f[jl>>2]=bl+-1;if((bl|0)!=1)break;V$(v)}while(0);f[Vi>>2]=0;f[Wi>>2]=0;f[Wi+4>>2]=0;f[Wi+8>>2]=0;f[Wi+12>>2]=0;if((f[Cg>>2]|0)>0){ll=f[Eg>>2]|0;bl=0;do{f[ll+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Cg>>2]|0))}bl=f[Gg>>2]|0;if((bl|0)!=(Fg|0))wL(bl);bl=f[Xi>>2]|0;do if(bl|0){ll=bl+12|0;jl=f[ll>>2]|0;f[ll>>2]=jl+-1;if((jl|0)!=1)break;V$(t)}while(0);f[Xi>>2]=0;f[Yi>>2]=0;f[Yi+4>>2]=0;f[Yi+8>>2]=0;f[Yi+12>>2]=0;if((f[wg>>2]|0)>0){bl=f[yg>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[wg>>2]|0))}jl=f[Ag>>2]|0;if((jl|0)!=(zg|0))wL(jl);jl=f[Rh>>2]|0;do if(jl|0){bl=jl+12|0;ll=f[bl>>2]|0;f[bl>>2]=ll+-1;if((ll|0)!=1)break;V$(q)}while(0);f[Rh>>2]=0;f[Sh>>2]=0;f[Sh+4>>2]=0;f[Sh+8>>2]=0;f[Sh+12>>2]=0;if((f[ig>>2]|0)>0){jl=f[kg>>2]|0;ll=0;do{f[jl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[ig>>2]|0))}ll=f[mg>>2]|0;if((ll|0)!=(lg|0))wL(ll);ll=f[Ph>>2]|0;do if(ll|0){jl=ll+12|0;bl=f[jl>>2]|0;f[jl>>2]=bl+-1;if((bl|0)!=1)break;V$(o)}while(0);f[Ph>>2]=0;f[Qh>>2]=0;f[Qh+4>>2]=0;f[Qh+8>>2]=0;f[Qh+12>>2]=0;if((f[Vf>>2]|0)>0){ll=f[Xf>>2]|0;bl=0;do{f[ll+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[Vf>>2]|0))}bl=f[Zf>>2]|0;if((bl|0)!=(Yf|0))wL(bl);bl=f[Zi>>2]|0;do if(bl|0){ll=bl+12|0;jl=f[ll>>2]|0;f[ll>>2]=jl+-1;if((jl|0)!=1)break;V$(l)}while(0);f[Zi>>2]=0;f[_i>>2]=0;f[_i+4>>2]=0;f[_i+8>>2]=0;f[_i+12>>2]=0;if((f[Of>>2]|0)>0){bl=f[Qf>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[Of>>2]|0))}jl=f[Sf>>2]|0;if((jl|0)!=(Rf|0))wL(jl);break}case 0:{jl=f[Sb>>2]|0;bl=f[Xb>>2]|0;if(!((f[jl>>2]|0)==(f[bl>>2]|0)?(f[jl+4>>2]|0)==(f[bl+4>>2]|0):0)){$a=546;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){$a=548;break b}bl=f[Ae>>2]|0;jl=f[Be>>2]|0;if((bl|0)!=(jl<<1|0)){$a=550;break b}if((f[ma>>2]&4095|0)!=5){$a=552;break b}f[j>>2]=-2147483648;f[$i>>2]=2147483647;f[k>>2]=0;f[aj>>2]=jl;W$(m,ma,j,k);ll=bj;f[ll>>2]=0;f[ll+4>>2]=0;f[l>>2]=-1040121856;f[cj>>2]=m;jR(ha,l);ll=f[dj>>2]|0;do if(ll|0){kl=ll+12|0;il=f[kl>>2]|0;f[kl>>2]=il+-1;if((il|0)!=1)break;V$(m)}while(0);f[dj>>2]=0;f[ej>>2]=0;f[ej+4>>2]=0;f[ej+8>>2]=0;f[ej+12>>2]=0;if((f[fj>>2]|0)>0){ll=f[gj>>2]|0;il=0;do{f[ll+(il<<2)>>2]=0;il=il+1|0}while((il|0)<(f[fj>>2]|0))}il=f[hj>>2]|0;if((il|0)!=(ij|0))wL(il);f[j>>2]=-2147483648;f[jj>>2]=2147483647;f[k>>2]=jl;f[kj>>2]=bl;W$(m,ma,j,k);il=lj;f[il>>2]=0;f[il+4>>2]=0;f[l>>2]=-1040121856;f[mj>>2]=m;jR(ia,l);il=f[nj>>2]|0;do if(il|0){ll=il+12|0;kl=f[ll>>2]|0;f[ll>>2]=kl+-1;if((kl|0)!=1)break;V$(m)}while(0);f[nj>>2]=0;f[oj>>2]=0;f[oj+4>>2]=0;f[oj+8>>2]=0;f[oj+12>>2]=0;if((f[pj>>2]|0)>0){il=f[qj>>2]|0;bl=0;do{f[il+(bl<<2)>>2]=0;bl=bl+1|0}while((bl|0)<(f[pj>>2]|0))}bl=f[rj>>2]|0;if((bl|0)!=(sj|0))wL(bl);break}case 1:{bl=f[Ya>>2]|0;il=f[Sb>>2]|0;jl=f[il+4>>2]|0;kl=f[il>>2]|0;il=f[Xb>>2]|0;if(!((kl|0)==(f[il>>2]|0)?(jl|0)==(f[il+4>>2]|0):0)){$a=571;break b}il=f[Ka>>2]|0;if(!((kl|0)==(f[il>>2]|0)?(jl|0)==(f[il+4>>2]|0):0)){$a=573;break b}il=f[hb>>2]|0;if(!((kl|0)==(f[il>>2]|0)?(jl|0)==(f[il+4>>2]|0):0)){$a=575;break b}if((f[Rb>>2]|0)!=(f[Zb>>2]|0)){$a=577;break b}il=f[Ae>>2]|0;jl=f[Be>>2]|0;if((il|0)!=(jl*3|0)){$a=579;break b}if((f[ma>>2]&4095|0)!=5){$a=581;break b}if(!(f[J>>2]&16384)){$a=583;break b}ql=+n[bl>>2];nl=+n[bl+12>>2];c$(k,Q,nl);a$(j,k);el=ql;c$(o,R,el);__(m,j,o);f[l>>2]=1124007936;Qa=tj;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[vj>>2]=uj;f[xj>>2]=wj;f[wj>>2]=0;f[yj>>2]=0;bl=f[m>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,m,l,-1);Zj(m);Zj(o);Zj(j);Zj(k);c$(j,Q,el);c$(k,R,nl);__(q,j,k);f[o>>2]=1124007936;Qa=zj;Sa=Qa+36|0;do{f[Qa>>2]=0;Qa=Qa+4|0}while((Qa|0)<(Sa|0));f[Bj>>2]=Aj;f[Dj>>2]=Cj;f[Cj>>2]=0;f[Ej>>2]=0;bl=f[q>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,q,o,-1);Zj(q);Zj(k);Zj(j);f[Fj>>2]=0;f[Gj>>2]=0;f[v>>2]=16842752;f[Hj>>2]=l;o$(t,ha,v,1.0);f[Ij>>2]=0;f[Jj>>2]=0;f[x>>2]=16842752;f[Kj>>2]=o;o$(w,ia,x,1.0);V_(r,t,w);f[j>>2]=-2147483648;f[Lj>>2]=2147483647;f[k>>2]=0;f[Mj>>2]=jl;W$(y,ma,j,k);bl=f[r>>2]|0;ei[f[(f[bl>>2]|0)+12>>2]&511](bl,r,y,-1);bl=f[Nj>>2]|0;do if(bl|0){kl=bl+12|0;ll=f[kl>>2]|0;f[kl>>2]=ll+-1;if((ll|0)!=1)break;V$(y)}while(0);f[Nj>>2]=0;f[Oj>>2]=0;f[Oj+4>>2]=0;f[Oj+8>>2]=0;f[Oj+12>>2]=0;if((f[Pj>>2]|0)>0){bl=f[Qj>>2]|0;ll=0;do{f[bl+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[Pj>>2]|0))}ll=f[Rj>>2]|0;if((ll|0)!=(Sj|0))wL(ll);Zj(r);Zj(w);Zj(t);ll=jl<<1;f[j>>2]=-2147483648;f[Tj>>2]=2147483647;f[k>>2]=jl;f[Uj>>2]=ll;W$(t,ma,j,k);bl=Vj;f[bl>>2]=0;f[bl+4>>2]=0;f[r>>2]=-1040121856;f[Wj>>2]=t;jR(ha,r);bl=f[Xj>>2]|0;do if(bl|0){kl=bl+12|0;hl=f[kl>>2]|0;f[kl>>2]=hl+-1;if((hl|0)!=1)break;V$(t)}while(0);f[Xj>>2]=0;f[Yj>>2]=0;f[Yj+4>>2]=0;f[Yj+8>>2]=0;f[Yj+12>>2]=0;if((f[_j>>2]|0)>0){bl=f[$j>>2]|0;jl=0;do{f[bl+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[_j>>2]|0))}jl=f[ak>>2]|0;if((jl|0)!=(bk|0))wL(jl);f[j>>2]=-2147483648;f[ck>>2]=2147483647;f[k>>2]=ll;f[dk>>2]=il;W$(t,ma,j,k);jl=ek;f[jl>>2]=0;f[jl+4>>2]=0;f[r>>2]=-1040121856;f[fk>>2]=t;jR(ia,r);jl=f[gk>>2]|0;do if(jl|0){bl=jl+12|0;hl=f[bl>>2]|0;f[bl>>2]=hl+-1;if((hl|0)!=1)break;V$(t)}while(0);f[gk>>2]=0;f[hk>>2]=0;f[hk+4>>2]=0;f[hk+8>>2]=0;f[hk+12>>2]=0;if((f[ik>>2]|0)>0){jl=f[jk>>2]|0;il=0;do{f[jl+(il<<2)>>2]=0;il=il+1|0}while((il|0)<(f[ik>>2]|0))}il=f[kk>>2]|0;if((il|0)!=(lk|0))wL(il);il=f[mk>>2]|0;do if(il|0){jl=il+12|0;ll=f[jl>>2]|0;f[jl>>2]=ll+-1;if((ll|0)!=1)break;V$(o)}while(0);f[mk>>2]=0;f[nk>>2]=0;f[nk+4>>2]=0;f[nk+8>>2]=0;f[nk+12>>2]=0;if((f[zj>>2]|0)>0){il=f[Bj>>2]|0;ll=0;do{f[il+(ll<<2)>>2]=0;ll=ll+1|0}while((ll|0)<(f[zj>>2]|0))}ll=f[Dj>>2]|0;if((ll|0)!=(Cj|0))wL(ll);ll=f[ok>>2]|0;do if(ll|0){il=ll+12|0;jl=f[il>>2]|0;f[il>>2]=jl+-1;if((jl|0)!=1)break;V$(l)}while(0);f[ok>>2]=0;f[pk>>2]=0;f[pk+4>>2]=0;f[pk+8>>2]=0;f[pk+12>>2]=0;if((f[tj>>2]|0)>0){ll=f[vj>>2]|0;jl=0;do{f[ll+(jl<<2)>>2]=0;jl=jl+1|0}while((jl|0)<(f[tj>>2]|0))}jl=f[xj>>2]|0;if((jl|0)!=(wj|0))wL(jl);break}default:{}}_Vb(ma,ma,na);n$(j,na,0);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,oa,-1);Zj(j);f[le>>2]=0;f[me>>2]=0;f[j>>2]=16842752;f[ne>>2]=W;nl=+nZ(T,j);el=nl/(fl*gl);p[s>>3]=el;if(((f[s+4>>2]&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){$a=626;break}_Vb(ma,W,pa);_Vb(ma,T,qa);b$(j,oa,pa);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,ra,-1);Zj(j);f[oe>>2]=0;f[pe>>2]=0;f[j>>2]=16842752;f[qe>>2]=ra;ql=gl*gl-+nZ(pa,j);f[re>>2]=0;f[se>>2]=0;f[j>>2]=16842752;f[te>>2]=ra;pl=nl-+nZ(qa,j);if(pl<=0.0){$a=628;break}d$(k,ql/pl,T);Y_(j,k,W);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,ua,-1);Zj(j);Zj(k);_Vb(ma,ua,sa);b$(j,oa,sa);jl=f[j>>2]|0;ei[f[(f[jl>>2]|0)+12>>2]&511](jl,j,ta,-1);Zj(j);jl=f[J>>2]|0;if((jl&4095|0)!=5){$a=630;break}ll=f[ta>>2]|0;if((ll&4095|0)!=5){$a=632;break}if(!xe){$a=634;break}il=f[_a>>2]|0;do if(g){if(!((il|0)==3&(f[yc>>2]|0)==8)){$a=637;break b}}else{hl=(il|0)==2;bl=f[yc>>2]|0;if(we)if(hl&(bl|0)==6)break;else{$a=640;break b}if(ve)if(hl&(bl|0)==3)break;else{$a=643;break b}else if(hl&(bl|0)==2)break;else{$a=645;break b}}while(0);if((f[ye>>2]|0)!=1){$a=647;break}if(!(jl&16384)){$a=649;break}if(!(ll&16384)){$a=651;break}il=f[Ya>>2]|0;bl=f[ze>>2]|0;if(ue){hl=il+8|0;n[hl>>2]=+n[bl>>2]+ +n[hl>>2];hl=il+20|0;n[hl>>2]=+n[bl+4>>2]+ +n[hl>>2]}if(we){n[il>>2]=+n[bl>>2]+ +n[il>>2];hl=il+12|0;n[hl>>2]=+n[bl+4>>2]+ +n[hl>>2];hl=il+4|0;n[hl>>2]=+n[bl+8>>2]+ +n[hl>>2];hl=il+16|0;n[hl>>2]=+n[bl+12>>2]+ +n[hl>>2];hl=il+8|0;n[hl>>2]=+n[bl+16>>2]+ +n[hl>>2];hl=il+20|0;n[hl>>2]=+n[bl+20>>2]+ +n[hl>>2]}if(g){n[il>>2]=+n[bl>>2]+ +n[il>>2];hl=il+12|0;n[hl>>2]=+n[bl+4>>2]+ +n[hl>>2];hl=il+24|0;n[hl>>2]=+n[bl+8>>2]+ +n[hl>>2];hl=il+4|0;n[hl>>2]=+n[bl+12>>2]+ +n[hl>>2];hl=il+16|0;n[hl>>2]=+n[bl+16>>2]+ +n[hl>>2];hl=il+28|0;n[hl>>2]=+n[bl+20>>2]+ +n[hl>>2];hl=il+8|0;n[hl>>2]=+n[bl+24>>2]+ +n[hl>>2];hl=il+20|0;n[hl>>2]=+n[bl+28>>2]+ +n[hl>>2]}if(ve){hl=il+12|0;gl=+n[bl>>2]+ +S(+(+n[hl>>2]));kl=il+8|0;n[kl>>2]=+n[bl+4>>2]+ +n[kl>>2];kl=il+20|0;n[kl>>2]=+n[bl+8>>2]+ +n[kl>>2];fl=+O(+gl);n[il+16>>2]=fl;n[il>>2]=fl;fl=+P(+gl);n[hl>>2]=fl;n[il+4>>2]=-fl}if(($k|0)<(cb|0)){fl=_k;_k=el;$k=$k+1|0;al=fl}else{Fc=el;break a}}switch($a|0){case 346:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=26;Qa=$k;Ra=471661;Sa=Qa+26|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+26>>0]=0;vM(-215,j,471688,471180,167);break}case 348:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=26;Qa=ve;Ra=471714;Sa=Qa+26|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+26>>0]=0;vM(-215,j,471688,471180,168);break}case 350:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=26;Qa=$k;Ra=471741;Sa=Qa+26|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+26>>0]=0;vM(-215,j,471688,471180,169);break}case 352:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=21;Qa=ve;Ra=471768;Sa=Qa+21|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+21>>0]=0;vM(-215,j,471688,471180,171);break}case 354:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=25;Qa=$k;Ra=471790;Sa=Qa+25|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+25>>0]=0;vM(-215,j,471688,471180,172);break}case 356:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=22;Qa=ve;Ra=471816;Sa=Qa+22|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+22>>0]=0;vM(-215,j,471688,471180,174);break}case 407:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=26;Qa=$k;Ra=471661;Sa=Qa+26|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+26>>0]=0;vM(-215,j,471839,471180,57);break}case 409:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=26;Qa=ve;Ra=471714;Sa=Qa+26|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+26>>0]=0;vM(-215,j,471839,471180,58);break}case 411:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=26;Qa=$k;Ra=471741;Sa=Qa+26|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+26>>0]=0;vM(-215,j,471839,471180,59);break}case 413:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=21;Qa=ve;Ra=471768;Sa=Qa+21|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+21>>0]=0;vM(-215,j,471839,471180,61);break}case 415:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=25;Qa=$k;Ra=471863;Sa=Qa+25|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+25>>0]=0;vM(-215,j,471839,471180,62);break}case 417:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=22;Qa=ve;Ra=471816;Sa=Qa+22|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+22>>0]=0;vM(-215,j,471839,471180,63);break}case 419:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=19;Qa=$k;Ra=471889;Sa=Qa+19|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+19>>0]=0;vM(-215,j,471839,471180,65);break}case 546:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=24;Qa=ve;Ra=471909;Sa=Qa+24|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+24>>0]=0;vM(-215,j,471934,471180,193);break}case 548:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=21;Qa=$k;Ra=471768;Sa=Qa+21|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+21>>0]=0;vM(-215,j,471934,471180,195);break}case 550:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=25;Qa=ve;Ra=471965;Sa=Qa+25|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+25>>0]=0;vM(-215,j,471934,471180,196);break}case 552:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=22;Qa=$k;Ra=471816;Sa=Qa+22|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+22>>0]=0;vM(-215,j,471934,471180,197);break}case 571:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=24;Qa=ve;Ra=471909;Sa=Qa+24|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+24>>0]=0;vM(-215,j,471991,471180,130);break}case 573:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=24;Qa=$k;Ra=472020;Sa=Qa+24|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+24>>0]=0;vM(-215,j,471991,471180,131);break}case 575:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=24;Qa=ve;Ra=472045;Sa=Qa+24|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+24>>0]=0;vM(-215,j,471991,471180,132);break}case 577:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=21;Qa=$k;Ra=471768;Sa=Qa+21|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+21>>0]=0;vM(-215,j,471991,471180,134);break}case 579:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=25;Qa=ve;Ra=472070;Sa=Qa+25|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+25>>0]=0;vM(-215,j,471991,471180,135);break}case 581:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=22;Qa=$k;Ra=471816;Sa=Qa+22|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+22>>0]=0;vM(-215,j,471991,471180,136);break}case 583:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=19;Qa=ve;Ra=471889;Sa=Qa+19|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+19>>0]=0;vM(-215,j,471991,471180,138);break}case 626:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=16;Qa=$k;Ra=472096;Sa=Qa+16|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+16>>0]=0;vM(-7,j,471163,471180,525);break}case 628:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;ve=$Xc(144)|0;f[j>>2]=ve;f[j+8>>2]=-2147483504;f[j+4>>2]=132;o1c(ve|0,472113,132)|0;b[ve+132>>0]=0;vM(-7,j,471163,471180,540);break}case 630:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=29;Qa=ve;Ra=472246;Sa=Qa+29|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+29>>0]=0;vM(-215,j,472276,471180,252);break}case 632:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=25;Qa=$k;Ra=472302;Sa=Qa+25|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+25>>0]=0;vM(-215,j,472276,471180,253);break}case 634:{ve=$Xc(144)|0;f[j>>2]=ve;f[j+8>>2]=-2147483504;f[j+4>>2]=132;o1c(ve|0,472328,132)|0;b[ve+132>>0]=0;vM(-215,j,472276,471180,256);break}case 637:{ve=$Xc(48)|0;f[j>>2]=ve;f[j+8>>2]=-2147483600;f[j+4>>2]=40;Qa=ve;Ra=472461;Sa=Qa+40|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+40>>0]=0;vM(-215,j,472276,471180,259);break}case 640:{$k=$Xc(48)|0;f[j>>2]=$k;f[j+8>>2]=-2147483600;f[j+4>>2]=40;Qa=$k;Ra=472502;Sa=Qa+40|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+40>>0]=0;vM(-215,j,472276,471180,261);break}case 643:{ve=$Xc(48)|0;f[j>>2]=ve;f[j+8>>2]=-2147483600;f[j+4>>2]=40;Qa=ve;Ra=472543;Sa=Qa+40|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+40>>0]=0;vM(-215,j,472276,471180,263);break}case 645:{$k=$Xc(48)|0;f[j>>2]=$k;f[j+8>>2]=-2147483600;f[j+4>>2]=40;Qa=$k;Ra=472584;Sa=Qa+40|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+40>>0]=0;vM(-215,j,472276,471180,265);break}case 647:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=16;Qa=ve;Ra=472625;Sa=Qa+16|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+16>>0]=0;vM(-215,j,472276,471180,267);break}case 649:{$k=$Xc(32)|0;f[j>>2]=$k;f[j+8>>2]=-2147483616;f[j+4>>2]=25;Qa=$k;Ra=472642;Sa=Qa+25|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[$k+25>>0]=0;vM(-215,j,472276,471180,269);break}case 651:{ve=$Xc(32)|0;f[j>>2]=ve;f[j+8>>2]=-2147483616;f[j+4>>2]=21;Qa=ve;Ra=472668;Sa=Qa+21|0;do{b[Qa>>0]=b[Ra>>0]|0;Qa=Qa+1|0;Ra=Ra+1|0}while((Qa|0)<(Sa|0));b[ve+21>>0]=0;vM(-215,j,472276,471180,270);break}}}while(0);j=ua+36|0;Ra=f[j>>2]|0;do if(Ra|0){Qa=Ra+12|0;Sa=f[Qa>>2]|0;f[Qa>>2]=Sa+-1;if((Sa|0)!=1)break;V$(ua)}while(0);f[j>>2]=0;j=ua+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[eb>>2]|0)>0){j=f[Dc>>2]|0;Dc=0;do{f[j+(Dc<<2)>>2]=0;Dc=Dc+1|0}while((Dc|0)<(f[eb>>2]|0))}eb=f[Ec>>2]|0;if((eb|0)!=(Cc|0))wL(eb);eb=ta+36|0;Cc=f[eb>>2]|0;do if(Cc|0){Ec=Cc+12|0;Dc=f[Ec>>2]|0;f[Ec>>2]=Dc+-1;if((Dc|0)!=1)break;V$(ta)}while(0);f[eb>>2]=0;eb=ta+16|0;f[eb>>2]=0;f[eb+4>>2]=0;f[eb+8>>2]=0;f[eb+12>>2]=0;if((f[xc>>2]|0)>0){eb=f[zc>>2]|0;zc=0;do{f[eb+(zc<<2)>>2]=0;zc=zc+1|0}while((zc|0)<(f[xc>>2]|0))}xc=f[Bc>>2]|0;if((xc|0)!=(Ac|0))wL(xc);xc=sa+36|0;Ac=f[xc>>2]|0;do if(Ac|0){Bc=Ac+12|0;zc=f[Bc>>2]|0;f[Bc>>2]=zc+-1;if((zc|0)!=1)break;V$(sa)}while(0);f[xc>>2]=0;xc=sa+16|0;f[xc>>2]=0;f[xc+4>>2]=0;f[xc+8>>2]=0;f[xc+12>>2]=0;if((f[tc>>2]|0)>0){xc=f[vc>>2]|0;vc=0;do{f[xc+(vc<<2)>>2]=0;vc=vc+1|0}while((vc|0)<(f[tc>>2]|0))}tc=f[wc>>2]|0;if((tc|0)!=(uc|0))wL(tc);tc=ra+36|0;uc=f[tc>>2]|0;do if(uc|0){wc=uc+12|0;vc=f[wc>>2]|0;f[wc>>2]=vc+-1;if((vc|0)!=1)break;V$(ra)}while(0);f[tc>>2]=0;tc=ra+16|0;f[tc>>2]=0;f[tc+4>>2]=0;f[tc+8>>2]=0;f[tc+12>>2]=0;if((f[pc>>2]|0)>0){tc=f[rc>>2]|0;rc=0;do{f[tc+(rc<<2)>>2]=0;rc=rc+1|0}while((rc|0)<(f[pc>>2]|0))}pc=f[sc>>2]|0;if((pc|0)!=(qc|0))wL(pc);pc=qa+36|0;qc=f[pc>>2]|0;do if(qc|0){sc=qc+12|0;rc=f[sc>>2]|0;f[sc>>2]=rc+-1;if((rc|0)!=1)break;V$(qa)}while(0);f[pc>>2]=0;pc=qa+16|0;f[pc>>2]=0;f[pc+4>>2]=0;f[pc+8>>2]=0;f[pc+12>>2]=0;if((f[lc>>2]|0)>0){pc=f[nc>>2]|0;nc=0;do{f[pc+(nc<<2)>>2]=0;nc=nc+1|0}while((nc|0)<(f[lc>>2]|0))}lc=f[oc>>2]|0;if((lc|0)!=(mc|0))wL(lc);lc=pa+36|0;mc=f[lc>>2]|0;do if(mc|0){oc=mc+12|0;nc=f[oc>>2]|0;f[oc>>2]=nc+-1;if((nc|0)!=1)break;V$(pa)}while(0);f[lc>>2]=0;lc=pa+16|0;f[lc>>2]=0;f[lc+4>>2]=0;f[lc+8>>2]=0;f[lc+12>>2]=0;if((f[hc>>2]|0)>0){lc=f[jc>>2]|0;jc=0;do{f[lc+(jc<<2)>>2]=0;jc=jc+1|0}while((jc|0)<(f[hc>>2]|0))}hc=f[kc>>2]|0;if((hc|0)!=(ic|0))wL(hc);hc=oa+36|0;ic=f[hc>>2]|0;do if(ic|0){kc=ic+12|0;jc=f[kc>>2]|0;f[kc>>2]=jc+-1;if((jc|0)!=1)break;V$(oa)}while(0);f[hc>>2]=0;hc=oa+16|0;f[hc>>2]=0;f[hc+4>>2]=0;f[hc+8>>2]=0;f[hc+12>>2]=0;if((f[dc>>2]|0)>0){hc=f[fc>>2]|0;fc=0;do{f[hc+(fc<<2)>>2]=0;fc=fc+1|0}while((fc|0)<(f[dc>>2]|0))}dc=f[gc>>2]|0;if((dc|0)!=(ec|0))wL(dc);dc=na+36|0;ec=f[dc>>2]|0;do if(ec|0){gc=ec+12|0;fc=f[gc>>2]|0;f[gc>>2]=fc+-1;if((fc|0)!=1)break;V$(na)}while(0);f[dc>>2]=0;dc=na+16|0;f[dc>>2]=0;f[dc+4>>2]=0;f[dc+8>>2]=0;f[dc+12>>2]=0;if((f[la>>2]|0)>0){dc=f[bc>>2]|0;bc=0;do{f[dc+(bc<<2)>>2]=0;bc=bc+1|0}while((bc|0)<(f[la>>2]|0))}la=f[cc>>2]|0;if((la|0)!=(ac|0))wL(la);la=ma+36|0;ac=f[la>>2]|0;do if(ac|0){cc=ac+12|0;bc=f[cc>>2]|0;f[cc>>2]=bc+-1;if((bc|0)!=1)break;V$(ma)}while(0);f[la>>2]=0;la=ma+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[_b>>2]|0)>0){la=f[ja>>2]|0;ja=0;do{f[la+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[_b>>2]|0))}_b=f[$b>>2]|0;if((_b|0)!=(ka|0))wL(_b);_b=ia+36|0;ka=f[_b>>2]|0;do if(ka|0){$b=ka+12|0;ja=f[$b>>2]|0;f[$b>>2]=ja+-1;if((ja|0)!=1)break;V$(ia)}while(0);f[_b>>2]=0;_b=ia+16|0;f[_b>>2]=0;f[_b+4>>2]=0;f[_b+8>>2]=0;f[_b+12>>2]=0;if((f[Vb>>2]|0)>0){_b=f[Xb>>2]|0;Xb=0;do{f[_b+(Xb<<2)>>2]=0;Xb=Xb+1|0}while((Xb|0)<(f[Vb>>2]|0))}Vb=f[Yb>>2]|0;if((Vb|0)!=(Wb|0))wL(Vb);Vb=ha+36|0;Wb=f[Vb>>2]|0;do if(Wb|0){Yb=Wb+12|0;Xb=f[Yb>>2]|0;f[Yb>>2]=Xb+-1;if((Xb|0)!=1)break;V$(ha)}while(0);f[Vb>>2]=0;Vb=ha+16|0;f[Vb>>2]=0;f[Vb+4>>2]=0;f[Vb+8>>2]=0;f[Vb+12>>2]=0;if((f[ga>>2]|0)>0){Vb=f[Sb>>2]|0;Sb=0;do{f[Vb+(Sb<<2)>>2]=0;Sb=Sb+1|0}while((Sb|0)<(f[ga>>2]|0))}ga=f[Ub>>2]|0;if((ga|0)!=(Tb|0))wL(ga);ga=fa+36|0;Tb=f[ga>>2]|0;do if(Tb|0){Ub=Tb+12|0;Sb=f[Ub>>2]|0;f[Ub>>2]=Sb+-1;if((Sb|0)!=1)break;V$(fa)}while(0);f[ga>>2]=0;ga=fa+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[Ha>>2]|0)>0){ga=f[ea>>2]|0;ea=0;do{f[ga+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[Ha>>2]|0))}Ha=f[Qb>>2]|0;if((Ha|0)!=(bb|0))wL(Ha);Ha=da+36|0;bb=f[Ha>>2]|0;do if(bb|0){Qb=bb+12|0;ea=f[Qb>>2]|0;f[Qb>>2]=ea+-1;if((ea|0)!=1)break;V$(da)}while(0);f[Ha>>2]=0;Ha=da+16|0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((f[ca>>2]|0)>0){Ha=f[Ob>>2]|0;Ob=0;do{f[Ha+(Ob<<2)>>2]=0;Ob=Ob+1|0}while((Ob|0)<(f[ca>>2]|0))}ca=f[Pb>>2]|0;if((ca|0)!=(ba|0))wL(ca);ca=aa+36|0;ba=f[ca>>2]|0;do if(ba|0){Pb=ba+12|0;Ob=f[Pb>>2]|0;f[Pb>>2]=Ob+-1;if((Ob|0)!=1)break;V$(aa)}while(0);f[ca>>2]=0;ca=aa+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[$>>2]|0)>0){ca=f[Nb>>2]|0;Nb=0;do{f[ca+(Nb<<2)>>2]=0;Nb=Nb+1|0}while((Nb|0)<(f[$>>2]|0))}$=f[Mb>>2]|0;if(($|0)!=(h|0))wL($);$=_+36|0;h=f[$>>2]|0;do if(h|0){Mb=h+12|0;Nb=f[Mb>>2]|0;f[Mb>>2]=Nb+-1;if((Nb|0)!=1)break;V$(_)}while(0);f[$>>2]=0;$=_+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[Ib>>2]|0)>0){$=f[Kb>>2]|0;Kb=0;do{f[$+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[Ib>>2]|0))}Ib=f[Lb>>2]|0;if((Ib|0)!=(Jb|0))wL(Ib);Ib=Z+36|0;Jb=f[Ib>>2]|0;do if(Jb|0){Lb=Jb+12|0;Kb=f[Lb>>2]|0;f[Lb>>2]=Kb+-1;if((Kb|0)!=1)break;V$(Z)}while(0);f[Ib>>2]=0;Ib=Z+16|0;Jb=Z+4|0;f[Ib>>2]=0;f[Ib+4>>2]=0;f[Ib+8>>2]=0;f[Ib+12>>2]=0;if((f[Jb>>2]|0)>0){Ib=f[Z+40>>2]|0;Kb=0;do{f[Ib+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[Jb>>2]|0))}Jb=f[Z+44>>2]|0;if((Jb|0)!=(Z+48|0))wL(Jb);Jb=X+36|0;Z=f[Jb>>2]|0;do if(Z|0){Kb=Z+12|0;Ib=f[Kb>>2]|0;f[Kb>>2]=Ib+-1;if((Ib|0)!=1)break;V$(X)}while(0);f[Jb>>2]=0;Jb=X+16|0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[Eb>>2]|0)>0){Jb=f[Gb>>2]|0;Gb=0;do{f[Jb+(Gb<<2)>>2]=0;Gb=Gb+1|0}while((Gb|0)<(f[Eb>>2]|0))}Eb=f[Hb>>2]|0;if((Eb|0)!=(Fb|0))wL(Eb);Eb=W+36|0;Fb=f[Eb>>2]|0;do if(Fb|0){Hb=Fb+12|0;Gb=f[Hb>>2]|0;f[Hb>>2]=Gb+-1;if((Gb|0)!=1)break;V$(W)}while(0);f[Eb>>2]=0;Eb=W+16|0;f[Eb>>2]=0;f[Eb+4>>2]=0;f[Eb+8>>2]=0;f[Eb+12>>2]=0;if((f[Ab>>2]|0)>0){Eb=f[Cb>>2]|0;Cb=0;do{f[Eb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[Ab>>2]|0))}Ab=f[Db>>2]|0;if((Ab|0)!=(Bb|0))wL(Ab);Ab=V+36|0;Bb=f[Ab>>2]|0;do if(Bb|0){Db=Bb+12|0;Cb=f[Db>>2]|0;f[Db>>2]=Cb+-1;if((Cb|0)!=1)break;V$(V)}while(0);f[Ab>>2]=0;Ab=V+16|0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[wb>>2]|0)>0){Ab=f[yb>>2]|0;yb=0;do{f[Ab+(yb<<2)>>2]=0;yb=yb+1|0}while((yb|0)<(f[wb>>2]|0))}wb=f[zb>>2]|0;if((wb|0)!=(xb|0))wL(wb);wb=U+36|0;xb=f[wb>>2]|0;do if(xb|0){zb=xb+12|0;yb=f[zb>>2]|0;f[zb>>2]=yb+-1;if((yb|0)!=1)break;V$(U)}while(0);f[wb>>2]=0;wb=U+16|0;f[wb>>2]=0;f[wb+4>>2]=0;f[wb+8>>2]=0;f[wb+12>>2]=0;if((f[sb>>2]|0)>0){wb=f[ub>>2]|0;ub=0;do{f[wb+(ub<<2)>>2]=0;ub=ub+1|0}while((ub|0)<(f[sb>>2]|0))}sb=f[vb>>2]|0;if((sb|0)!=(tb|0))wL(sb);sb=T+36|0;tb=f[sb>>2]|0;do if(tb|0){vb=tb+12|0;ub=f[vb>>2]|0;f[vb>>2]=ub+-1;if((ub|0)!=1)break;V$(T)}while(0);f[sb>>2]=0;sb=T+16|0;f[sb>>2]=0;f[sb+4>>2]=0;f[sb+8>>2]=0;f[sb+12>>2]=0;if((f[pb>>2]|0)>0){sb=f[kb>>2]|0;kb=0;do{f[sb+(kb<<2)>>2]=0;kb=kb+1|0}while((kb|0)<(f[pb>>2]|0))}pb=f[rb>>2]|0;if((pb|0)!=(qb|0))wL(pb);pb=R+36|0;qb=f[pb>>2]|0;do if(qb|0){rb=qb+12|0;kb=f[rb>>2]|0;f[rb>>2]=kb+-1;if((kb|0)!=1)break;V$(R)}while(0);f[pb>>2]=0;pb=R+16|0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[fb>>2]|0)>0){pb=f[hb>>2]|0;hb=0;do{f[pb+(hb<<2)>>2]=0;hb=hb+1|0}while((hb|0)<(f[fb>>2]|0))}fb=f[ib>>2]|0;if((fb|0)!=(gb|0))wL(fb);fb=Q+36|0;gb=f[fb>>2]|0;do if(gb|0){ib=gb+12|0;hb=f[ib>>2]|0;f[ib>>2]=hb+-1;if((hb|0)!=1)break;V$(Q)}while(0);f[fb>>2]=0;fb=Q+16|0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[Ma>>2]|0)>0){fb=f[Ka>>2]|0;Ka=0;do{f[fb+(Ka<<2)>>2]=0;Ka=Ka+1|0}while((Ka|0)<(f[Ma>>2]|0))}Ma=f[La>>2]|0;if((Ma|0)!=(Ia|0))wL(Ma);Ma=f[ob>>2]|0;do if(Ma|0){Ia=Ma+12|0;La=f[Ia>>2]|0;f[Ia>>2]=La+-1;if((La|0)!=1)break;V$(N)}while(0);f[ob>>2]=0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[Oa>>2]|0)>0){lb=f[Za>>2]|0;Za=0;do{f[lb+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[Oa>>2]|0))}Oa=f[Ja>>2]|0;if((Oa|0)!=(Ua|0))wL(Oa);Oa=f[nb>>2]|0;do if(Oa|0){Ua=Oa+12|0;Ja=f[Ua>>2]|0;f[Ua>>2]=Ja+-1;if((Ja|0)!=1)break;V$(K)}while(0);f[nb>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[Wa>>2]|0)>0){jb=f[Va>>2]|0;Va=0;do{f[jb+(Va<<2)>>2]=0;Va=Va+1|0}while((Va|0)<(f[Wa>>2]|0))}Wa=f[d>>2]|0;if((Wa|0)!=(ab|0))wL(Wa);Wa=J+36|0;ab=f[Wa>>2]|0;do if(ab|0){d=ab+12|0;Va=f[d>>2]|0;f[d>>2]=Va+-1;if((Va|0)!=1)break;V$(J)}while(0);f[Wa>>2]=0;Wa=J+4|0;f[Ya>>2]=0;f[Ya+4>>2]=0;f[Ya+8>>2]=0;f[Ya+12>>2]=0;if((f[Wa>>2]|0)>0){Ya=f[J+40>>2]|0;ab=0;do{f[Ya+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[Wa>>2]|0))}Wa=f[J+44>>2]|0;if((Wa|0)!=(J+48|0))wL(Wa);Wa=I+36|0;J=f[Wa>>2]|0;do if(J|0){ab=J+12|0;Ya=f[ab>>2]|0;f[ab>>2]=Ya+-1;if((Ya|0)!=1)break;V$(I)}while(0);f[Wa>>2]=0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[Na>>2]|0)>0){Ta=f[I+40>>2]|0;Wa=0;do{f[Ta+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[Na>>2]|0))}Na=f[I+44>>2]|0;if((Na|0)!=(I+48|0))wL(Na);Na=H+36|0;I=f[Na>>2]|0;do if(I|0){Wa=I+12|0;Ta=f[Wa>>2]|0;f[Wa>>2]=Ta+-1;if((Ta|0)!=1)break;V$(H)}while(0);f[Na>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[H+40>>2]|0;Na=0;do{f[c+(Na<<2)>>2]=0;Na=Na+1|0}while((Na|0)<(f[a>>2]|0))}a=f[H+44>>2]|0;if((a|0)==(H+48|0)){u=i;return +Fc}wL(a);u=i;return +Fc}function _Vb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+192|0;g=e+176|0;h=e+168|0;i=e+112|0;j=e+56|0;k=e;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=22;m=l;o=472690;p=m+22|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));b[l+22>>0]=0;vM(-215,g,472713,471180,219)}l=f[a+12>>2]|0;q=f[c+12>>2]|0;if((l|0)%(q|0)|0|0){r=$Xc(32)|0;f[g>>2]=r;f[g+8>>2]=-2147483616;f[g+4>>2]=28;m=r;o=472739;p=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));b[r+28>>0]=0;vM(-215,g,472713,471180,220)}r=f[d+16>>2]|0;if((l|0)!=(q|0)){s=d+8|0;if((f[s>>2]|0)<=0){u=e;return}t=g+4|0;v=h+4|0;w=i+8|0;x=i+12|0;y=i+4|0;z=j+36|0;A=j+16|0;B=j+4|0;C=j+40|0;D=j+44|0;E=j+48|0;F=0;do{G=Y(F,q)|0;H=F;F=F+1|0;I=Y(F,q)|0;f[g>>2]=-2147483648;f[t>>2]=2147483647;f[h>>2]=G;f[v>>2]=I;W$(j,a,g,h);f[w>>2]=0;f[x>>2]=0;f[i>>2]=16842752;f[y>>2]=j;J=+nZ(c,i);n[r+(H<<2)>>2]=J;H=f[z>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)V$(j);f[z>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){H=f[C>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[B>>2]|0))}I=f[D>>2]|0;if((I|0)!=(E|0))wL(I)}while((F|0)<(f[s>>2]|0));u=e;return}s=d+12|0;F=f[s>>2]|0;E=d+8|0;if((F|0)!=(f[E>>2]|0)){d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=20;m=d;o=472768;p=m+20|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));b[d+20>>0]=0;vM(-215,g,472713,471180,233)}d=(l|0)/(F|0)|0;f[i>>2]=1124007936;l=i+4|0;o=i+8|0;D=i+40|0;m=l;p=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(p|0));f[D>>2]=o;m=i+48|0;p=i+44|0;f[p>>2]=m;f[m>>2]=0;f[i+52>>2]=0;if((F|0)>0){F=g+4|0;B=h+4|0;C=i+36|0;A=i+16|0;z=j+4|0;y=j+8|0;x=j+12|0;w=i+12|0;v=j+16|0;t=j+20|0;q=i+20|0;I=j+24|0;H=i+24|0;G=j+28|0;K=i+28|0;L=j+32|0;M=i+32|0;N=j+36|0;O=i+44|0;P=j+44|0;Q=j+40|0;R=j+48|0;S=g+8|0;T=g+12|0;U=g+4|0;V=g+4|0;W=h+4|0;X=j+8|0;Z=j+12|0;_=j+4|0;$=k+36|0;aa=k+16|0;ba=k+4|0;ca=k+40|0;da=k+44|0;ea=k+48|0;fa=i+40|0;ga=i+52|0;ha=0;do{ia=Y(ha,d)|0;ja=ha;ha=ha+1|0;ka=Y(ha,d)|0;f[g>>2]=-2147483648;f[F>>2]=2147483647;f[h>>2]=ia;f[B>>2]=ka;W$(j,a,g,h);ka=f[C>>2]|0;if(ka|0?(ia=ka+12|0,ka=f[ia>>2]|0,f[ia>>2]=ka+-1,(ka|0)==1):0)V$(i);f[C>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[l>>2]|0)>0){ka=f[D>>2]|0;ia=0;do{f[ka+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[l>>2]|0))}f[i>>2]=f[j>>2];ia=f[z>>2]|0;f[l>>2]=ia;f[o>>2]=f[y>>2];f[w>>2]=f[x>>2];f[A>>2]=f[v>>2];f[q>>2]=f[t>>2];f[H>>2]=f[I>>2];f[K>>2]=f[G>>2];f[M>>2]=f[L>>2];f[C>>2]=f[N>>2];ka=f[O>>2]|0;if((ka|0)==(m|0))la=ia;else{wL(ka);f[O>>2]=m;f[D>>2]=o;la=f[z>>2]|0}if((la|0)<3){ka=f[P>>2]|0;f[m>>2]=f[ka>>2];f[ga>>2]=f[ka+4>>2];ma=ka}else{f[O>>2]=f[P>>2];f[fa>>2]=f[Q>>2];f[P>>2]=R;f[Q>>2]=y;ma=R}f[j>>2]=1124007936;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[N>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((ma|0)!=(R|0))wL(ma);f[S>>2]=0;f[T>>2]=0;f[g>>2]=16842752;f[U>>2]=i;J=+XN(g,4,fT()|0);ka=f[E>>2]|0;ia=r+((Y(ka+1|0,ja)|0)<<2)|0;n[ia>>2]=J*J;if((ha|0)<(f[s>>2]|0)){ia=ha;do{na=Y(ia,d)|0;oa=ia;ia=ia+1|0;pa=Y(ia,d)|0;f[g>>2]=-2147483648;f[V>>2]=2147483647;f[h>>2]=na;f[W>>2]=pa;W$(k,c,g,h);f[X>>2]=0;f[Z>>2]=0;f[j>>2]=16842752;f[_>>2]=k;J=+nZ(i,j);pa=r+((Y(f[s>>2]|0,ja)|0)+oa<<2)|0;n[pa>>2]=J;pa=f[$>>2]|0;if(pa|0?(na=pa+12|0,pa=f[na>>2]|0,f[na>>2]=pa+-1,(pa|0)==1):0)V$(k);f[$>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[ba>>2]|0)>0){pa=f[ca>>2]|0;na=0;do{f[pa+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[ba>>2]|0))}na=f[da>>2]|0;if((na|0)!=(ea|0))wL(na);na=f[s>>2]|0;pa=r+((Y(na,ja)|0)+oa<<2)|0;qa=r+((Y(na,oa)|0)+ja<<2)|0;f[qa>>2]=f[pa>>2]}while((ia|0)<(na|0));ra=f[E>>2]|0}else ra=ka}while((ha|0)<(ra|0));ra=f[C>>2]|0;if((ra|0)!=0?(ha=ra+12|0,ra=f[ha>>2]|0,f[ha>>2]=ra+-1,(ra|0)==1):0){V$(i);sa=C}else sa=C}else sa=i+36|0;f[sa>>2]=0;sa=i+16|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[l>>2]|0)>0){sa=f[D>>2]|0;D=0;do{f[sa+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[l>>2]|0))}l=f[p>>2]|0;if((l|0)!=(m|0))wL(l);u=e;return}function $Vb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=u;u=u+432|0;g=e+368|0;h=e+320|0;i=e+264|0;j=e;k=e+248|0;l=e+192|0;f[g>>2]=1124007936;m=g+4|0;n=g+8|0;o=g+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;s=g+48|0;t=g+44|0;f[t>>2]=s;f[s>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;v=h+4|0;w=h+8|0;x=h+20|0;y=h+24|0;z=h+28|0;A=h+32|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[A>>2]=w;B=h+40|0;f[h+36>>2]=B;f[h+44>>2]=0;f[B>>2]=0;C=(eS(a)|0)==655360;if(C){fS(i,a,-1);D=f[y>>2]|0;if(D|0?(E=D+8|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)FQ(h);if((f[v>>2]|0)>0){D=f[A>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[v>>2]|0))}f[h>>2]=f[i>>2];E=i+4|0;D=f[E>>2]|0;f[v>>2]=D;v=i+8|0;f[w>>2]=f[v>>2];f[h+12>>2]=f[i+12>>2];f[h+16>>2]=f[i+16>>2];f[x>>2]=f[i+20>>2];x=i+24|0;f[y>>2]=f[x>>2];y=i+28|0;f[z>>2]=f[y>>2];z=h+36|0;F=f[z>>2]|0;if((F|0)==(B|0))G=D;else{wL(F);f[z>>2]=B;f[A>>2]=w;G=f[E>>2]|0}w=i+36|0;if((G|0)<3){G=f[w>>2]|0;f[B>>2]=f[G>>2];f[h+44>>2]=f[G+4>>2];H=f[A>>2]|0}else{f[z>>2]=f[w>>2];z=i+32|0;A=f[z>>2]|0;f[h+32>>2]=A;f[w>>2]=i+40;f[z>>2]=v;H=A}f[i>>2]=1124007936;f[x>>2]=0;f[y>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;E=f[h>>2]|0;y=f[H+4>>2]|0;x=f[H>>2]|0;EQ(i);I=E;J=y;K=x}else{do if((eS(a)|0)==65536){x=f[a+4>>2]|0;f[i>>2]=f[x>>2];y=i+4|0;E=x+4|0;f[y>>2]=f[E>>2];H=i+8|0;f[H>>2]=f[x+8>>2];f[i+12>>2]=f[x+12>>2];f[i+16>>2]=f[x+16>>2];f[i+20>>2]=f[x+20>>2];f[i+24>>2]=f[x+24>>2];f[i+28>>2]=f[x+28>>2];f[i+32>>2]=f[x+32>>2];A=f[x+36>>2]|0;f[i+36>>2]=A;f[i+40>>2]=H;H=i+48|0;v=i+44|0;f[v>>2]=H;f[H>>2]=0;f[i+52>>2]=0;if(A|0){H=A+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[E>>2]|0)<3){E=f[x+44>>2]|0;H=f[v>>2]|0;f[H>>2]=f[E>>2];f[H+4>>2]=f[E+4>>2];break}else{f[y>>2]=0;U$(i,x);break}}else bS(i,a,-1);while(0);a=g+36|0;x=f[a>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)V$(g);f[a>>2]=0;x=g+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[m>>2]|0)>0){y=f[o>>2]|0;E=0;do{f[y+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[m>>2]|0))}f[g>>2]=f[i>>2];E=i+4|0;y=f[E>>2]|0;f[m>>2]=y;H=i+8|0;f[n>>2]=f[H>>2];f[g+12>>2]=f[i+12>>2];v=i+16|0;f[x>>2]=f[v>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];x=i+36|0;f[a>>2]=f[x>>2];a=g+44|0;A=f[a>>2]|0;if((A|0)==(s|0))M=y;else{wL(A);f[a>>2]=s;f[o>>2]=n;M=f[E>>2]|0}n=i+44|0;if((M|0)<3){M=f[n>>2]|0;f[s>>2]=f[M>>2];f[g+52>>2]=f[M+4>>2];N=f[o>>2]|0;O=M}else{f[a>>2]=f[n>>2];a=i+40|0;M=f[a>>2]|0;f[g+40>>2]=M;A=i+48|0;f[n>>2]=A;f[a>>2]=H;N=M;O=A}f[i>>2]=1124007936;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[E+28>>2]=0;E=f[g>>2]|0;A=f[N+4>>2]|0;M=f[N>>2]|0;f[x>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((O|0)!=(i+48|0))wL(O);I=E;J=A;K=M}M=f[c>>2]|0;f[i>>2]=M;A=i+4|0;E=c+4|0;O=f[E>>2]|0;f[A>>2]=O;v=i+8|0;x=c+8|0;N=f[x>>2]|0;f[v>>2]=N;H=i+12|0;a=c+12|0;n=f[a>>2]|0;f[H>>2]=n;if(I&4088|0){f[j+8>>2]=0;b[j+11>>0]=7;b[j>>0]=b[472789]|0;b[j+1>>0]=b[472790]|0;b[j+2>>0]=b[472791]|0;b[j+3>>0]=b[472792]|0;b[j+4>>0]=b[472793]|0;b[j+5>>0]=b[472794]|0;b[j+6>>0]=b[472795]|0;b[j+7>>0]=0;vM(-215,j,472797,472807,61)}if((n|0)<1|(N|0)<1){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;I=$Xc(48)|0;f[j>>2]=I;f[j+8>>2]=-2147483600;f[j+4>>2]=35;q=I;y=472878;r=q+35|0;do{b[q>>0]=b[y>>0]|0;q=q+1|0;y=y+1|0}while((q|0)<(r|0));b[I+35>>0]=0;vM(-5,j,472797,472807,64)}I=(M|0)>0?M:0;y=(O|0)>0?O:0;q=M+N|0;r=((J|0)<(q|0)?J:q)-I|0;q=O+n|0;z=((K|0)<(q|0)?K:q)-y|0;q=(r|0)<1|(z|0)<1;f[c>>2]=q?0:I;f[E>>2]=q?0:y;f[x>>2]=q?0:r;f[a>>2]=q?0:z;z=f[d>>2]|0;if(!(z&2))P=1.0;else{Q=+p[d+8>>3];P=Q<0.0?0.0:Q}q=zLc(P*P)|0;r=((q|0)<0)<<31>>31;if(!(z&1))R=100;else{z=f[d+4>>2]|0;R=(z|0)>1?z:1}z=(J|0)/2|0;d=(K|0)/2|0;y=k+8|0;I=k+12|0;w=k+4|0;G=j+8|0;B=j+16|0;F=k+8|0;D=k+12|0;S=k+4|0;T=l+36|0;U=l+16|0;V=l+4|0;W=l+40|0;X=l+44|0;Z=l+48|0;_=0;$=M;M=O;O=N;N=n;while(1){n=($|0)>0?$:0;aa=(M|0)>0?M:0;ba=O+$|0;ca=((J|0)<(ba|0)?J:ba)-n|0;ba=N+M|0;da=((K|0)<(ba|0)?K:ba)-aa|0;ba=(ca|0)<1|(da|0)<1;ea=ba?0:da;fa=ba?0:ca;f[i>>2]=ba?0:n;f[A>>2]=ba?0:aa;f[v>>2]=fa;f[H>>2]=ea;if((aa|n|0)==0|ba?ba|(ca|da|0)==0:0){f[i>>2]=z;f[A>>2]=d}f[v>>2]=(fa|0)>1?fa:1;f[H>>2]=(ea|0)>1?ea:1;if(!C){Z$(l,g,i);f[F>>2]=0;f[D>>2]=0;f[k>>2]=16842752;f[S>>2]=l;Nwa(j,k,0);ea=f[T>>2]|0;if(ea|0?(fa=ea+12|0,ea=f[fa>>2]|0,f[fa>>2]=ea+-1,(ea|0)==1):0)V$(l);f[T>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[V>>2]|0)>0){ea=f[W>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[V>>2]|0))}fa=f[X>>2]|0;if((fa|0)!=(Z|0))wL(fa)}else{AQ(l,h,i);f[y>>2]=0;f[I>>2]=0;f[k>>2]=17432576;f[w>>2]=l;Nwa(j,k,0);EQ(l)}P=+p[j>>3];if(+L(+P)<2.220446049250313e-16){ga=59;break}fa=zLc(+p[G>>3]/P-+(f[x>>2]|0)*.5)|0;ea=zLc(+p[B>>3]/P-+(f[a>>2]|0)*.5)|0;da=f[i>>2]|0;ca=da+fa|0;fa=f[v>>2]|0;ba=J-fa|0;n=(ca|0)>0?ca:0;ca=(ba|0)<(n|0)?ba:n;n=f[A>>2]|0;ba=n+ea|0;ea=f[H>>2]|0;aa=K-ea|0;ha=(ba|0)>0?ba:0;ba=(aa|0)<(ha|0)?aa:ha;ha=ca-da|0;da=ba-n|0;f[i>>2]=ca;f[A>>2]=ba;if(0<(r|0)|(0==(r|0)?((Y(da,da)|0)+(Y(ha,ha)|0)|0)>>>0<q>>>0:0)){ia=ca;ja=ba;ka=fa;la=ea;ga=61;break}ha=_+1|0;if((ha|0)<(R|0)){_=ha;$=ca;M=ba;O=fa;N=ea}else{ma=ha;na=ca;oa=ba;pa=fa;qa=ea;break}}if((ga|0)==59){ia=f[i>>2]|0;ja=f[A>>2]|0;ka=f[v>>2]|0;la=f[H>>2]|0;ga=61}if((ga|0)==61){ma=_;na=ia;oa=ja;pa=ka;qa=la}f[c>>2]=na;f[E>>2]=oa;f[x>>2]=pa;f[a>>2]=qa;EQ(h);h=g+36|0;qa=f[h>>2]|0;if(qa|0?(a=qa+12|0,qa=f[a>>2]|0,f[a>>2]=qa+-1,(qa|0)==1):0)V$(g);f[h>>2]=0;h=g+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[m>>2]|0)>0){h=f[o>>2]|0;o=0;do{f[h+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[m>>2]|0))}m=f[t>>2]|0;if((m|0)==(s|0)){u=e;return ma|0}wL(m);u=e;return ma|0}function aWb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0;e=u;u=u+368|0;g=e;h=e+312|0;i=e+264|0;j=e+248|0;k=e+192|0;f[h>>2]=1124007936;l=h+4|0;m=h+8|0;o=h+40|0;q=l;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=m;q=h+48|0;r=h+44|0;f[r>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;s=i+4|0;t=i+8|0;v=i+20|0;w=i+24|0;x=i+28|0;y=i+32|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[y>>2]=t;z=i+40|0;f[i+36>>2]=z;f[i+44>>2]=0;f[z>>2]=0;A=(eS(b)|0)==655360;if(A){fS(g,b,-1);B=f[w>>2]|0;if(B|0?(C=B+8|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)FQ(i);if((f[s>>2]|0)>0){B=f[y>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[s>>2]|0))}f[i>>2]=f[g>>2];C=g+4|0;B=f[C>>2]|0;f[s>>2]=B;s=g+8|0;f[t>>2]=f[s>>2];f[i+12>>2]=f[g+12>>2];f[i+16>>2]=f[g+16>>2];f[v>>2]=f[g+20>>2];v=g+24|0;f[w>>2]=f[v>>2];w=g+28|0;f[x>>2]=f[w>>2];x=i+36|0;D=f[x>>2]|0;if((D|0)==(z|0))E=B;else{wL(D);f[x>>2]=z;f[y>>2]=t;E=f[C>>2]|0}t=g+36|0;if((E|0)<3){E=f[t>>2]|0;f[z>>2]=f[E>>2];f[i+44>>2]=f[E+4>>2];F=f[y>>2]|0}else{f[x>>2]=f[t>>2];x=g+32|0;y=f[x>>2]|0;f[i+32>>2]=y;f[t>>2]=g+40;f[x>>2]=s;F=y}f[g>>2]=1124007936;f[v>>2]=0;f[w>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;C=f[F+4>>2]|0;w=f[F>>2]|0;EQ(g);G=C;H=w}else{do if((eS(b)|0)==65536){w=f[b+4>>2]|0;f[g>>2]=f[w>>2];C=g+4|0;F=w+4|0;f[C>>2]=f[F>>2];v=g+8|0;f[v>>2]=f[w+8>>2];f[g+12>>2]=f[w+12>>2];f[g+16>>2]=f[w+16>>2];f[g+20>>2]=f[w+20>>2];f[g+24>>2]=f[w+24>>2];f[g+28>>2]=f[w+28>>2];f[g+32>>2]=f[w+32>>2];y=f[w+36>>2]|0;f[g+36>>2]=y;f[g+40>>2]=v;v=g+48|0;s=g+44|0;f[s>>2]=v;f[v>>2]=0;f[g+52>>2]=0;if(y|0){v=y+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[F>>2]|0)<3){F=f[w+44>>2]|0;v=f[s>>2]|0;f[v>>2]=f[F>>2];f[v+4>>2]=f[F+4>>2];break}else{f[C>>2]=0;U$(g,w);break}}else bS(g,b,-1);while(0);w=h+36|0;C=f[w>>2]|0;if(C|0?(F=C+12|0,C=f[F>>2]|0,f[F>>2]=C+-1,(C|0)==1):0)V$(h);f[w>>2]=0;C=h+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[l>>2]|0)>0){F=f[o>>2]|0;v=0;do{f[F+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[l>>2]|0))}f[h>>2]=f[g>>2];v=g+4|0;F=f[v>>2]|0;f[l>>2]=F;s=g+8|0;f[m>>2]=f[s>>2];f[h+12>>2]=f[g+12>>2];y=g+16|0;f[C>>2]=f[y>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];C=g+36|0;f[w>>2]=f[C>>2];w=h+44|0;x=f[w>>2]|0;if((x|0)==(q|0))I=F;else{wL(x);f[w>>2]=q;f[o>>2]=m;I=f[v>>2]|0}m=g+44|0;if((I|0)<3){I=f[m>>2]|0;f[q>>2]=f[I>>2];f[h+52>>2]=f[I+4>>2];J=f[o>>2]|0;K=I}else{f[w>>2]=f[m>>2];w=g+40|0;I=f[w>>2]|0;f[h+40>>2]=I;x=g+48|0;f[m>>2]=x;f[w>>2]=s;J=I;K=x}f[g>>2]=1124007936;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[v+28>>2]=0;v=f[J+4>>2]|0;x=f[J>>2]|0;f[C>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((K|0)!=(g+48|0))wL(K);G=v;H=x};f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];$Vb(b,c,g)|0;b=f[c>>2]|0;d=(b|0)<10?0:b+-10|0;f[c>>2]=d;b=c+4|0;x=f[b>>2]|0;v=(x|0)<10?0:x+-10|0;f[b>>2]=v;x=c+8|0;K=(f[x>>2]|0)+20|0;f[x>>2]=(d+K|0)>(G|0)?G-d|0:K;K=c+12|0;d=(f[K>>2]|0)+20|0;f[K>>2]=(v+d|0)>(H|0)?H-v|0:d;if(!A){Z$(k,h,c);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=k;Nwa(g,j,0);A=k+36|0;d=f[A>>2]|0;if(d|0?(v=d+12|0,d=f[v>>2]|0,f[v>>2]=d+-1,(d|0)==1):0)V$(k);f[A>>2]=0;A=k+16|0;d=k+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[d>>2]|0)>0){A=f[k+40>>2]|0;v=0;do{f[A+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))wL(d)}else{AQ(k,i,c);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17432576;f[j+4>>2]=k;Nwa(g,j,0);EQ(k)}N=+p[g>>3];Q=+p[g+88>>3];R=+p[g+80>>3];S=+p[g+96>>3];if(+L(+N)<2.220446049250313e-16){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0}else{T=+p[g+16>>3];V=1.0/N;k=zLc(V*+p[g+8>>3]+ +(f[c>>2]|0))|0;g=zLc(V*T+ +(f[b>>2]|0))|0;T=Q*V;N=V*R-V*S;W=+U(+(T*2.0),+(N+ +M(+(T*(T*4.0)+N*N))));N=+O(+W);T=+P(+W);X=N*N;Y=Q*(N*2.0*T);Q=T*T;Z=+M(+(V*(S*Q+(R*X+Y))))*4.0;_=+M(+(V*(S*X+(R*Q-Y))))*4.0;if(Z<_){$=1.5707963267948966-W;aa=Z;ba=_;ca=N;da=T}else{$=W;aa=_;ba=Z;ca=T;da=N}j=zLc(+L(+(da*ba)))|0;d=zLc(+L(+(ca*aa)))|0;v=((j|0)<(d|0)?d:j)+2|0;j=G-k<<1;d=(v|0)>(j|0)?j:v;v=zLc(+L(+(ca*ba)))|0;j=zLc(+L(+(da*aa)))|0;A=((v|0)<(j|0)?j:v)+2|0;v=H-g<<1;j=(A|0)>(v|0)?v:A;A=k-((d|0)/2|0)|0;k=(A|0)>0?A:0;f[c>>2]=k;c=g-((j|0)/2|0)|0;g=(c|0)>0?c:0;f[b>>2]=g;b=G-k|0;G=(b|0)>(d|0)?d:b;f[x>>2]=G;x=H-g|0;H=(x|0)>(j|0)?j:x;f[K>>2]=H;da=ba;ba=aa;aa=($+1.5707963267948966)*180.0/3.141592653589793;if(aa<0.0){$=aa;while(1){ca=$+360.0;if(ca<0.0)$=ca;else{ea=ca;break}}}else ea=aa;if(!(ea>=360.0))fa=ea;else{aa=ea;while(1){ea=aa+-360.0;if(!(ea>=360.0)){fa=ea;break}else aa=ea}}n[a>>2]=+(k|0)+ +(G|0)*.5;n[a+4>>2]=+(g|0)+ +(H|0)*.5;n[a+8>>2]=ba;n[a+12>>2]=da;n[a+16>>2]=!(fa>=180.0)?fa:fa+-180.0}EQ(i);i=h+36|0;a=f[i>>2]|0;if(a|0?(H=a+12|0,a=f[H>>2]|0,f[H>>2]=a+-1,(a|0)==1):0)V$(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[l>>2]|0)>0){i=f[o>>2]|0;o=0;do{f[i+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)==(q|0)){u=e;return}wL(l);u=e;return}function bWb(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=164812;c=a+184|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+72|0;d=a+108|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(c);f[d>>2]=0;d=a+88|0;c=a+76|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[a+112>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+116>>2]|0;if((c|0)!=(a+120|0))wL(c);c=a+16|0;e=a+52|0;d=f[e>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)V$(c);f[e>>2]=0;e=a+32|0;c=a+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[c>>2]|0)>0){e=f[a+56>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+60>>2]|0;if((c|0)==(a+64|0)){qP(a);return}wL(c);qP(a);return}function cWb(a){a=a|0;bWb(a);cYc(a);return}function dWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0;d=u;u=u+16|0;e=d;zP(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=4;f[e>>2]=1701667182;b[e+4>>0]=0;i=s5(c,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=s5(i,a+184|0)|0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=7;b[e>>0]=b[473226]|0;b[e+1>>0]=b[473227]|0;b[e+2>>0]=b[473228]|0;b[e+3>>0]=b[473229]|0;b[e+4>>0]=b[473230]|0;b[e+5>>0]=b[473231]|0;b[e+6>>0]=b[473232]|0;b[e+7>>0]=0;j=s5(g,e)|0;if((b[i>>0]|0)<0)cYc(f[e>>2]|0);i=a+132|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](j)|0){g=c+4|0;if((f[g>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(j,c+8|0,f[i>>2]|0);if(f[g>>2]&4|0)f[g>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=9;l=e;m=473234;o=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[e+9>>0]=0;i=s5(j,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=a+136|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](i)|0){j=c+4|0;if((f[j>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(i,c+8|0,f[g>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6}j=$Xc(16)|0;f[e>>2]=j;f[e+8>>2]=-2147483632;f[e+4>>2]=15;l=j;m=473244;o=l+15|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[j+15>>0]=0;j=s5(i,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);i=a+152|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](j)|0){g=c+4|0;if((f[g>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(j,c+8|0,+n[i>>2]);if(f[g>>2]&4|0)f[g>>2]=6}g=$Xc(16)|0;f[e>>2]=g;f[e+8>>2]=-2147483632;f[e+4>>2]=12;l=g;m=473260;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[g+12>>0]=0;g=s5(j,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);j=a+144|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](g)|0){i=c+4|0;if((f[i>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}q5(g,c+8|0,+p[j>>3]);if(f[i>>2]&4|0)f[i>>2]=6}i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=15;l=i;m=473273;o=l+15|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[i+15>>0]=0;i=s5(g,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);g=a+156|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](i)|0){j=c+4|0;if((f[j>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(i,c+8|0,+n[g>>2]);if(f[j>>2]&4|0)f[j>>2]=6}f[e+8>>2]=0;j=e+11|0;b[j>>0]=7;b[e>>0]=b[473289]|0;b[e+1>>0]=b[473290]|0;b[e+2>>0]=b[473291]|0;b[e+3>>0]=b[473292]|0;b[e+4>>0]=b[473293]|0;b[e+5>>0]=b[473294]|0;b[e+6>>0]=b[473295]|0;b[e+7>>0]=0;g=s5(i,e)|0;if((b[j>>0]|0)<0)cYc(f[e>>2]|0);j=a+160|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](g)|0){i=c+4|0;if((f[i>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(g,c+8|0,+n[j>>2]);if(f[i>>2]&4|0)f[i>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=6;b[e>>0]=b[473297]|0;b[e+1>>0]=b[473298]|0;b[e+2>>0]=b[473299]|0;b[e+3>>0]=b[473300]|0;b[e+4>>0]=b[473301]|0;b[e+5>>0]=b[473302]|0;b[e+6>>0]=0;j=s5(g,e)|0;if((b[i>>0]|0)<0)cYc(f[e>>2]|0);i=a+164|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](j)|0){g=c+4|0;if((f[g>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(j,c+8|0,+n[i>>2]);if(f[g>>2]&4|0)f[g>>2]=6};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=6;b[e>>0]=b[473304]|0;b[e+1>>0]=b[473305]|0;b[e+2>>0]=b[473306]|0;b[e+3>>0]=b[473307]|0;b[e+4>>0]=b[473308]|0;b[e+5>>0]=b[473309]|0;b[e+6>>0]=0;i=s5(j,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);g=a+168|0;if(_i[f[(f[c>>2]|0)+12>>2]&2047](i)|0){j=c+4|0;if((f[j>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(i,c+8|0,+n[g>>2]);if(f[j>>2]&4|0)f[j>>2]=6}j=$Xc(32)|0;f[e>>2]=j;f[e+8>>2]=-2147483616;f[e+4>>2]=28;l=j;m=473311;o=l+28|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[j+28>>0]=0;j=s5(i,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);i=a+172|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](j)|0){g=c+4|0;if((f[g>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(j,c+8|0,+n[i>>2]);if(!(f[g>>2]&4))break;f[g>>2]=6}while(0);i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=13;l=i;m=473340;o=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[i+13>>0]=0;i=s5(j,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);j=h[a+176>>0]|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](i)|0){q=c+4|0;if((f[q>>2]|0)==6){r=$Xc(32)|0;f[e>>2]=r;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=r;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[r+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(i,c+8|0,j);if(!(f[q>>2]&4))break;f[q>>2]=6}while(0);j=$Xc(16)|0;f[e>>2]=j;f[e+8>>2]=-2147483632;f[e+4>>2]=11;l=j;m=473354;o=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[j+11>>0]=0;j=s5(i,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);i=h[a+177>>0]|0;do if(_i[f[(f[c>>2]|0)+12>>2]&2047](j)|0){g=c+4|0;if((f[g>>2]|0)==6){k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=k;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+30>>0]=0;vM(-2,e,528568,473413,1207)}o5(j,c+8|0,i);if(!(f[g>>2]&4))break;f[g>>2]=6}while(0);i=$Xc(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=15;l=i;m=473366;o=l+15|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[i+15>>0]=0;i=s5(j,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);j=a+180|0;if(!(_i[f[(f[c>>2]|0)+12>>2]&2047](i)|0)){u=d;return}a=c+4|0;if((f[a>>2]|0)==6){q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=30;l=q;m=473382;o=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[q+30>>0]=0;vM(-2,e,528568,473413,1207)}p5(i,c+8|0,+n[j>>2]);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function eWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0;d=u;u=u+176|0;e=d+156|0;g=d+144|0;h=d+132|0;i=d+120|0;j=d+108|0;k=d+96|0;l=d+84|0;m=d+72|0;o=d+60|0;q=d+48|0;r=d+36|0;s=d+24|0;t=d+12|0;v=d;i5(g,c,473188);H4(e,g);g=a+184|0;w=b[e+11>>0]|0;x=w<<24>>24<0;y=w&255;w=x?f[e+4>>2]|0:y;z=b[g+11>>0]|0;A=z<<24>>24<0;a:do if((w|0)==((A?f[a+188>>2]|0:z&255)|0)){B=f[e>>2]|0;C=x?B:e;D=A?f[g>>2]|0:g;E=(w|0)==0;if(x)if(E){cYc(f[e>>2]|0);break}else{F=(WKc(C,D,w)|0)==0;G=11;break}if(E)break;if((B&255)<<24>>24==(b[D>>0]|0)){B=e;E=y;C=D;while(1){E=E+-1|0;B=B+1|0;if(!E){H=1;G=10;break a}C=C+1|0;if((b[B>>0]|0)!=(b[C>>0]|0)){H=0;G=10;break}}}else{H=0;G=10}}else{H=0;G=10}while(0);if((G|0)==10)if(!x){if(!H){I=$Xc(32)|0;f[e>>2]=I;J=e+8|0;f[J>>2]=-2147483616;K=e+4|0;f[K>>2]=27;L=I;M=473193;N=L+27|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));O=I+27|0;b[O>>0]=0;vM(-215,e,473221,473028,307)}}else{F=H;G=11}if((G|0)==11?(cYc(f[e>>2]|0),!F):0){I=$Xc(32)|0;f[e>>2]=I;J=e+8|0;f[J>>2]=-2147483616;K=e+4|0;f[K>>2]=27;L=I;M=473193;N=L+27|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));O=I+27|0;b[O>>0]=0;vM(-215,e,473221,473028,307)}i5(h,c,473226);e=H5(h)|0;f[a+132>>2]=e;i5(i,c,473234);e=H5(i)|0;f[a+136>>2]=e;i5(j,c,473244);P=+I5(j);n[a+152>>2]=P;i5(k,c,473260);P=+J5(k);p[a+144>>3]=P;i5(l,c,473273);P=+I5(l);n[a+156>>2]=P;i5(m,c,473289);P=+I5(m);n[a+160>>2]=P;i5(o,c,473297);P=+I5(o);n[a+164>>2]=P;i5(q,c,473304);P=+I5(q);n[a+168>>2]=P;i5(r,c,473311);P=+I5(r);n[a+172>>2]=P;i5(s,c,473340);r=(H5(s)|0)!=0&1;b[a+176>>0]=r;i5(t,c,473354);r=H5(t)|0;b[a+177>>0]=r>>>0<256?r:(r|0)>0?255:0;i5(v,c,473366);P=+I5(v);n[a+180>>2]=P;u=d;return}function fWb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0;g=u;u=u+208|0;h=g+152|0;i=g+144|0;j=g+80|0;k=g+88|0;l=g+68|0;m=g;o=a+128|0;do if(!(e>=1.0|(f[o>>2]|0)==0)){cS(h,c,-1);if(!((f[h>>2]|0)!=(f[a+4>>2]|0)?1:(f[h+4>>2]|0)!=(f[a+8>>2]|0))?(q=dS(c,-1)|0,(q|0)==(f[a+12>>2]|0)):0)break;else{r=5;break}}else r=5;while(0);if((r|0)==5){cS(i,c,-1);JWb(a,i,dS(c,-1)|0)}do if((eS(c)|0)==65536){i=f[c+4>>2]|0;f[h>>2]=f[i>>2];r=h+4|0;q=i+4|0;f[r>>2]=f[q>>2];s=h+8|0;f[s>>2]=f[i+8>>2];f[h+12>>2]=f[i+12>>2];f[h+16>>2]=f[i+16>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];t=f[i+36>>2]|0;f[h+36>>2]=t;v=h+40|0;f[v>>2]=s;s=h+48|0;w=h+44|0;f[w>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[q>>2]|0)<3){q=f[i+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[q>>2];f[s+4>>2]=f[q+4>>2];x=v;break}else{f[r>>2]=0;U$(h,i);x=v;break}}else{bS(h,c,-1);x=h+40|0}while(0);c=f[x>>2]|0;v=f[c>>2]|0;f[j>>2]=f[c+4>>2];f[j+4>>2]=v;wS(d,j,0,-1,0,0);do if((eS(d)|0)==65536){j=f[d+4>>2]|0;f[k>>2]=f[j>>2];v=k+4|0;c=j+4|0;f[v>>2]=f[c>>2];i=k+8|0;f[i>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];r=f[j+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=i;i=k+48|0;q=k+44|0;f[q>>2]=i;f[i>>2]=0;f[k+52>>2]=0;if(r|0){i=r+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[c>>2]|0)<3){c=f[j+44>>2]|0;i=f[q>>2]|0;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];break}else{f[v>>2]=0;U$(k,j);break}}else bS(k,d,-1);while(0);d=f[o>>2]|0;j=d+1|0;f[o>>2]=j;if(e>=0.0&(d|0)>0)y=e;else{d=j<<1;j=f[a+132>>2]|0;y=1.0/+(((j|0)<(d|0)?j:d)|0)}if(!(y>=0.0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;d=$Xc(32)|0;f[l>>2]=d;f[l+8>>2]=-2147483616;f[l+4>>2]=17;j=d;o=473105;v=j+17|0;do{b[j>>0]=b[o>>0]|0;j=j+1|0;o=o+1|0}while((j|0)<(v|0));b[d+17>>0]=0;vM(-215,l,473123,473028,870)}d=h+8|0;o=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=o;j=f[a+32>>2]|0;v=f[a+136>>2]|0;c=Y(v<<3,o)|0;o=f[h+12>>2]|0;i=j+(Y(c,o)|0)|0;c=f[a+88>>2]|0;e=+p[a+144>>3];q=f[a+152>>2]|0;r=f[a+156>>2]|0;s=f[a+160>>2]|0;z=+n[a+164>>2];A=+n[a+168>>2];B=-(y*+n[a+172>>2]);w=f[a+180>>2]|0;t=b[a+176>>0]|0;C=b[a+177>>0]|0;f[m>>2]=164956;f[m+4>>2]=h;f[m+8>>2]=k;f[m+12>>2]=j;f[m+16>>2]=i;f[m+20>>2]=c;f[m+24>>2]=v;n[m+28>>2]=y;n[m+32>>2]=e;f[m+36>>2]=q;f[m+40>>2]=r;f[m+44>>2]=s;n[m+48>>2]=z>A?A:z;n[m+52>>2]=z<A?A:z;n[m+56>>2]=B;f[m+60>>2]=w;b[m+64>>0]=t;b[m+65>>0]=C;C=h+4|0;t=f[C>>2]|0;if((t|0)<3)D=Y(o,f[d>>2]|0)|0;else{d=f[x>>2]|0;o=0;w=1;while(1){s=Y(f[d+(o<<2)>>2]|0,w)|0;o=o+1|0;if((o|0)==(t|0)){D=s;break}else w=s}}h3(l,m,+(D>>>0)*.0000152587890625);D=k+36|0;m=f[D>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)V$(k);f[D>>2]=0;D=k+16|0;m=k+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){D=f[k+40>>2]|0;l=0;do{f[D+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))wL(m);m=h+36|0;k=f[m>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)V$(h);f[m>>2]=0;m=h+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[C>>2]|0)>0){m=f[x>>2]|0;x=0;do{f[m+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)==(h+48|0)){u=g;return}wL(C);u=g;return}function gWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;switch(f[a+12>>2]|0){case 0:{FWb(a,c);u=d;return}case 16:{GWb(a,c);u=d;return}case 5:{HWb(a,c);u=d;return}case 21:{IWb(a,c);u=d;return}default:{d=$Xc(96)|0;f[e>>2]=d;f[e+8>>2]=-2147483552;f[e+4>>2]=94;c=d;a=472914;g=c+94|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));b[d+94>>0]=0;vM(-215,e,473009,473028,929)}}}function hWb(a){a=a|0;return f[a+132>>2]|0}function iWb(a,b){a=a|0;b=b|0;f[a+132>>2]=b;return}function jWb(a){a=a|0;return f[a+136>>2]|0}function kWb(a,b){a=a|0;b=b|0;f[a+136>>2]=b;return}function lWb(a){a=a|0;return +(+n[a+152>>2])}function mWb(a,b){a=a|0;b=+b;n[a+152>>2]=b;return}function nWb(a){a=a|0;return +(+p[a+144>>3])}function oWb(a,b){a=a|0;b=+b;p[a+144>>3]=b;return}function pWb(a){a=a|0;return +(+n[a+156>>2])}function qWb(a,b){a=a|0;b=+b;n[a+156>>2]=b;return}function rWb(a){a=a|0;return +(+n[a+160>>2])}function sWb(a,b){a=a|0;b=+b;n[a+160>>2]=b;return}function tWb(a){a=a|0;return +(+n[a+164>>2])}function uWb(a,b){a=a|0;b=+b;n[a+164>>2]=b;return}function vWb(a){a=a|0;return +(+n[a+168>>2])}function wWb(a,b){a=a|0;b=+b;n[a+168>>2]=b;return}function xWb(a){a=a|0;return +(+n[a+172>>2])}function yWb(a,b){a=a|0;b=+b;n[a+172>>2]=b;return}function zWb(a){a=a|0;return (b[a+176>>0]|0)!=0|0}function AWb(a,c){a=a|0;c=c|0;var d=0;d=a+176|0;if((h[d>>0]|0|0)==(c&1|0))return;b[d>>0]=c&1;return}function BWb(a){a=a|0;return h[a+177>>0]|0|0}function CWb(a,c){a=a|0;c=c|0;b[a+177>>0]=c;return}function DWb(a){a=a|0;return +(+n[a+180>>2])}function EWb(a,b){a=a|0;b=+b;n[a+180>>2]=b;return}function FWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,M=0,N=0,O=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;S$(g,2,e,m&4095);lR(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=f[e>>2]|0;y=m;while(1){if((x|0)>0){m=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+m|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0}else{E=+n[v>>2];B=z;F=0.0;G=0.0;while(1){H=+n[h+(B<<3)>>2];I=G+H*+n[k+(B<<2)>>2];J=F+H;B=B+1|0;if(!(!(J>E)&(B|0)<(A|0))){C=J;D=I;break}else{F=J;G=I}}}A=+L(+C)>1.1920928955078125e-07;B=ALc(D*(A?1.0/C:0.0))|0;A=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)+m|0;b[A>>0]=B>>>0<256?B:(B|0)>0?255:0;z=(f[i>>2]|0)+z|0;m=m+1|0;K=f[e>>2]|0}while((m|0)<(K|0));M=z;N=f[p>>2]|0;O=K}else{M=a;N=y;O=x}w=w+1|0;if((w|0)>=(N|0))break;else{a=M;x=O;y=N}}}jR(g,c);c=g+36|0;N=f[c>>2]|0;if(N|0?(y=N+12|0,N=f[y>>2]|0,f[y>>2]=N+-1,(N|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}wL(o);u=d;return}function GWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;S$(g,2,e,m&4095);lR(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=m;m=f[e>>2]|0;while(1){if((m|0)>0){y=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+y|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0;E=0.0;F=0.0}else{G=+n[v>>2];B=z;H=0.0;I=0.0;J=0.0;K=0.0;while(1){M=+n[h+(B<<3)>>2];N=B*3|0;O=I+M*+n[k+(N<<2)>>2];P=J+M*+n[k+(N+1<<2)>>2];Q=K+M*+n[k+(N+2<<2)>>2];R=H+M;B=B+1|0;if(!(!(R>G)&(B|0)<(A|0))){C=R;D=O;E=P;F=Q;break}else{H=R;I=O;J=P;K=Q}}}A=+L(+C)>1.1920928955078125e-07;K=A?1.0/C:0.0;A=ALc(D*K)|0;B=ALc(E*K)|0;N=ALc(K*F)|0;S=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)|0;b[S+(y*3|0)>>0]=A>>>0<256?A:(A|0)>0?255:0;b[S+(y*3|0)+1>>0]=B>>>0<256?B:(B|0)>0?255:0;b[S+(y*3|0)+2>>0]=N>>>0<256?N:(N|0)>0?255:0;z=(f[i>>2]|0)+z|0;y=y+1|0;T=f[e>>2]|0}while((y|0)<(T|0));U=z;V=T;W=f[p>>2]|0}else{U=a;V=m;W=x}w=w+1|0;if((w|0)>=(W|0))break;else{a=U;x=W;m=V}}}jR(g,c);c=g+36|0;V=f[c>>2]|0;if(V|0?(m=V+12|0,V=f[m>>2]|0,f[m>>2]=V+-1,(V|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}wL(o);u=d;return}function HWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,M=0,N=0,O=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;S$(g,2,e,m&4095);lR(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=f[e>>2]|0;y=m;while(1){if((x|0)>0){m=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+m|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0}else{E=+n[v>>2];B=z;F=0.0;G=0.0;while(1){H=+n[h+(B<<3)>>2];I=G+H*+n[k+(B<<2)>>2];J=F+H;B=B+1|0;if(!(!(J>E)&(B|0)<(A|0))){C=J;D=I;break}else{F=J;G=I}}}A=+L(+C)>1.1920928955078125e-07;B=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)+(m<<2)|0;n[B>>2]=D*(A?1.0/C:0.0);z=(f[i>>2]|0)+z|0;m=m+1|0;K=f[e>>2]|0}while((m|0)<(K|0));M=z;N=f[p>>2]|0;O=K}else{M=a;N=y;O=x}w=w+1|0;if((w|0)>=(N|0))break;else{a=M;x=O;y=N}}}jR(g,c);c=g+36|0;N=f[c>>2]|0;if(N|0?(y=N+12|0,N=f[y>>2]|0,f[y>>2]=N+-1,(N|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}wL(o);u=d;return}function IWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0;d=u;u=u+96|0;e=d+88|0;g=d+32|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;m=f[a+12>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=l;f[e+4>>2]=j;S$(g,2,e,m&4095);lR(g,h)|0;h=f[a+32>>2]|0;m=Y(f[k>>2]|0,f[i>>2]|0)|0;i=a+136|0;k=h+((Y(m,f[i>>2]|0)|0)<<3)|0;m=f[p>>2]|0;if((m|0)>0){e=g+12|0;j=a+88|0;l=a+116|0;t=g+16|0;v=a+152|0;a=0;w=0;x=m;m=f[e>>2]|0;while(1){if((m|0)>0){y=0;z=a;do{A=(f[j>>2]|0)+(Y(f[f[l>>2]>>2]|0,w)|0)+y|0;B=b[A>>0]|0;A=(B&255)+z|0;if(!(B<<24>>24)){C=0.0;D=0.0;E=0.0;F=0.0}else{G=+n[v>>2];B=z;H=0.0;I=0.0;J=0.0;K=0.0;while(1){M=+n[h+(B<<3)>>2];N=B*3|0;O=I+M*+n[k+(N<<2)>>2];P=J+M*+n[k+(N+1<<2)>>2];Q=K+M*+n[k+(N+2<<2)>>2];R=H+M;B=B+1|0;if(!(!(R>G)&(B|0)<(A|0))){C=R;D=O;E=P;F=Q;break}else{H=R;I=O;J=P;K=Q}}}A=+L(+C)>1.1920928955078125e-07;K=A?1.0/C:0.0;A=(f[t>>2]|0)+(Y(f[f[s>>2]>>2]|0,w)|0)|0;n[A+(y*12|0)>>2]=D*K;n[A+(y*12|0)+4>>2]=E*K;n[A+(y*12|0)+8>>2]=K*F;z=(f[i>>2]|0)+z|0;y=y+1|0;S=f[e>>2]|0}while((y|0)<(S|0));T=z;U=S;V=f[p>>2]|0}else{T=a;U=m;V=x}w=w+1|0;if((w|0)>=(V|0))break;else{a=T;x=V;m=U}}}jR(g,c);c=g+36|0;U=f[c>>2]|0;if(U|0?(m=U+12|0,U=f[m>>2]|0,f[m>>2]=U+-1,(U|0)==1):0)V$(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[q>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[s>>2]|0;if((o|0)==(r|0)){u=d;return}wL(o);u=d;return}function JWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+32|0;g=e;h=f[c>>2]|0;i=a+4|0;f[i>>2]=h;j=f[c+4>>2]|0;c=a+8|0;f[c>>2]=j;f[a+12>>2]=d;f[a+128>>2]=0;k=d>>>3&511;if((k+1|0)>>>0>=513){d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=22;l=d;m=473148;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[d+22>>0]=0;vM(-215,g,516941,473028,192)}d=f[a+136>>2]|0;if((d|0)>=256){o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=16;l=o;m=473171;n=l+16|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+16>>0]=0;vM(-215,g,516941,473028,193)}o=a+16|0;m=Y(Y(Y(d,k+3|0)|0,j)|0,h)|0;if(((((f[a+20>>2]|0)<3?(f[a+24>>2]|0)==1:0)?(f[a+28>>2]|0)==(m|0):0)?(f[o>>2]&4095|0)==5:0)?(f[a+32>>2]|0)!=0:0){p=j;q=h}else{f[g>>2]=1;f[g+4>>2]=m;S$(o,2,g,5);p=f[c>>2]|0;q=f[i>>2]|0}i=a+72|0;if(((((f[a+76>>2]|0)<3?(f[a+80>>2]|0)==(p|0):0)?(f[a+84>>2]|0)==(q|0):0)?(f[i>>2]&4095|0)==0:0)?f[a+88>>2]|0:0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;lR(i,g)|0;u=e;return}f[g>>2]=p;f[g+4>>2]=q;S$(i,2,g,0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;lR(i,g)|0;u=e;return}function KWb(a){a=a|0;cYc(a);return}function LWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0.0,Qa=0.0,Ra=0,Sa=0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0,gb=0,hb=0;d=u;u=u+3248|0;e=d+3224|0;g=d+3168|0;i=d+2104|0;j=d+56|0;k=d;l=f[c>>2]|0;m=f[c+4>>2]|0;c=a+4|0;o=f[c>>2]|0;p=f[o+12>>2]|0;q=((f[o>>2]|0)>>>3&511)+1|0;r=Y(p,q)|0;s=i+8|0;f[i>>2]=s;t=i+4|0;f[t>>2]=r;if(r>>>0>264){v=bYc(r>>>0>1073741823?-1:r<<2)|0;f[i>>2]=v;w=v}else w=s;v=a+28|0;x=1.0-+n[v>>2];a:do if((l|0)<(m|0)){r=a+16|0;y=a+24|0;z=a+12|0;A=a+20|0;B=a+8|0;C=(p|0)>0;D=a+64|0;E=a+32|0;F=a+36|0;G=a+60|0;H=a+65|0;I=a+44|0;J=a+56|0;K=(q|0)==3;M=j+4|0;N=j+8|0;O=a+40|0;P=a+48|0;Q=a+52|0;R=e+4|0;S=g+4|0;T=(q<<3)+-3|0;U=e+8|0;V=e+4|0;W=g+36|0;X=g+16|0;Z=g+4|0;_=g+40|0;$=g+44|0;aa=g+48|0;ba=k+36|0;ca=k+16|0;da=k+4|0;ea=k+40|0;fa=k+44|0;ga=k+48|0;ha=l;ia=o;ja=w;while(1){if((f[ia>>2]&7|0)==5)ka=(f[ia+16>>2]|0)+(Y(f[f[ia+44>>2]>>2]|0,ha)|0)|0;else{f[e>>2]=ha;f[R>>2]=ha+1;f[g>>2]=-2147483648;f[S>>2]=2147483647;W$(k,ia,e,g);Tj(g,1,p,T,ja,0);la=U;f[la>>2]=0;f[la+4>>2]=0;f[e>>2]=-1040121856;f[V>>2]=g;dY(k,e,5,1.0,0.0);la=f[W>>2]|0;if(la|0?(ma=la+12|0,la=f[ma>>2]|0,f[ma>>2]=la+-1,(la|0)==1):0)V$(g);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){la=f[_>>2]|0;ma=0;do{f[la+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[Z>>2]|0))}ma=f[$>>2]|0;if((ma|0)!=(aa|0))wL(ma);ma=f[ba>>2]|0;if(ma|0?(la=ma+12|0,ma=f[la>>2]|0,f[la>>2]=ma+-1,(ma|0)==1):0)V$(k);f[ba>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){ma=f[ea>>2]|0;la=0;do{f[ma+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[da>>2]|0))}la=f[fa>>2]|0;if((la|0)!=(ga|0))wL(la);ka=ja}la=Y(f[y>>2]|0,p)|0;ma=(f[A>>2]|0)+(Y(ha,p)|0)|0;na=f[B>>2]|0;oa=(f[na+16>>2]|0)+(Y(f[f[na+44>>2]>>2]|0,ha)|0)|0;if(C){na=(f[z>>2]|0)+((Y(la,ha)|0)<<3)|0;pa=0;qa=na;na=(f[r>>2]|0)+((Y(Y(ha,q)|0,la)|0)<<2)|0;la=ka;while(1){ra=ma+pa|0;sa=b[ra>>0]|0;ta=sa&255;if(!(sa<<24>>24)){ua=0.0;va=ta;wa=0;xa=0}else{sa=la+4|0;ya=la+8|0;za=0;Aa=na;Ba=0.0;Ca=ta;ta=0;Da=0;Ea=+n[J>>2];while(1){Fa=x*+n[qa+(za<<3)>>2]+Ea;b:do if(!ta){Ga=qa+(za<<3)+4|0;Ha=+n[Ga>>2];if(K){Ia=+n[Aa>>2]-+n[la>>2];n[j>>2]=Ia;Ja=+n[Aa+4>>2]-+n[sa>>2];n[M>>2]=Ja;Ka=+n[Aa+8>>2]-+n[ya>>2];n[N>>2]=Ka;La=Ka*Ka+(Ia*Ia+Ja*Ja)}else{Ma=0;Ja=0.0;while(1){Ia=+n[Aa+(Ma<<2)>>2]-+n[la+(Ma<<2)>>2];n[j+(Ma<<2)>>2]=Ia;Ka=Ja+Ia*Ia;Ma=Ma+1|0;if((Ma|0)==(q|0)){La=Ka;break}else Ja=Ka}}if(Ba<+n[F>>2]?La<Ha*+n[E>>2]:0)Na=1;else Na=Da;if(La<Ha*+n[O>>2]){Ja=+n[v>>2];Ka=Fa+Ja;Ia=Ja/Ka;Ma=0;do{Oa=Aa+(Ma<<2)|0;n[Oa>>2]=+n[Oa>>2]-Ia*+n[j+(Ma<<2)>>2];Ma=Ma+1|0}while((Ma|0)!=(q|0));Ja=Ha+(La-Ha)*Ia;Pa=+n[P>>2];Qa=Ja<Pa?Pa:Ja;Ja=+n[Q>>2];n[Ga>>2]=Qa>Ja?Ja:Qa;if((za|0)>0){Ma=za;Oa=0;while(1){Ra=Ma;Ma=Ma+-1|0;Sa=qa+(Ma<<3)|0;if(Ka<+n[Sa>>2]){Ta=Ka;Ua=Oa;Va=1;Wa=Na;break b}Xa=qa+(Ra<<3)|0;Ya=Xa;Za=f[Ya>>2]|0;_a=f[Ya+4>>2]|0;Ya=Sa;$a=f[Ya+4>>2]|0;ab=Xa;f[ab>>2]=f[Ya>>2];f[ab+4>>2]=$a;$a=Sa;f[$a>>2]=Za;f[$a+4>>2]=_a;_a=Y(Ra,q)|0;$a=Y(Ma,q)|0;Za=0;do{Sa=na+(Za+_a<<2)|0;ab=na+(Za+$a<<2)|0;Ya=f[Sa>>2]|0;f[Sa>>2]=f[ab>>2];f[ab>>2]=Ya;Za=Za+1|0}while((Za|0)!=(q|0));Za=Oa+1|0;if((Ra|0)<=1){Ta=Ka;Ua=Za;Va=1;Wa=Na;break}else Oa=Za}}else{Ta=Ka;Ua=0;Va=1;Wa=Na}}else{Ta=Fa;Ua=0;Va=0;Wa=Na}}else{Ta=Fa;Ua=0;Va=1;Wa=Da}while(0);Ea=+n[J>>2];Oa=Ta<-Ea;Ma=(Oa<<31>>31)+Ca|0;Fa=Oa?0.0:Ta;n[qa+(za-Ua<<3)>>2]=Fa;Ia=Ba+Fa;za=za+1|0;if((za|0)>=(Ma|0)){ua=Ia;va=Ma;wa=Va;xa=Wa;break}else{Aa=Aa+(q<<2)|0;Ba=Ia;Ca=Ma;ta=Va;Da=Wa}}}Da=+L(+ua)>1.1920928955078125e-07;Ba=Da?1.0/ua:0.0;if((va|0)>0){Da=0;do{ta=qa+(Da<<3)|0;n[ta>>2]=Ba*+n[ta>>2];Da=Da+1|0}while((Da|0)!=(va|0))}c:do if(!wa?(Ba=+n[v>>2],Ba>0.0):0){Da=f[y>>2]|0;ta=(va|0)==(Da|0);Ca=((ta^1)&1)+va|0;Aa=ta?Da+-1|0:va;Da=qa+(Aa<<3)|0;if((Ca|0)!=1){n[Da>>2]=Ba;ta=Ca+-1|0;if((Ca|0)>1){za=0;do{ya=qa+(za<<3)|0;n[ya>>2]=x*+n[ya>>2];za=za+1|0}while((za|0)<(ta|0))}}else n[Da>>2]=1.0;ta=Y(Aa,q)|0;za=0;do{f[na+(za+ta<<2)>>2]=f[la+(za<<2)>>2];za=za+1|0}while((za|0)!=(q|0));f[qa+(Aa<<3)+4>>2]=f[I>>2];if((Ca|0)>1){za=Ca;while(1){ta=za+-2|0;za=za+-1|0;Da=qa+(ta<<3)|0;if(+n[v>>2]<+n[Da>>2]){bb=Ca;break c}ya=qa+(za<<3)|0;sa=ya;Ma=f[sa>>2]|0;Oa=f[sa+4>>2]|0;sa=Da;Ga=f[sa+4>>2]|0;Za=ya;f[Za>>2]=f[sa>>2];f[Za+4>>2]=Ga;Ga=Da;f[Ga>>2]=Ma;f[Ga+4>>2]=Oa;Oa=Y(za,q)|0;Ga=Y(ta,q)|0;ta=0;do{Ma=na+(ta+Oa<<2)|0;Da=na+(ta+Ga<<2)|0;Za=f[Ma>>2]|0;f[Ma>>2]=f[Da>>2];f[Da>>2]=Za;ta=ta+1|0}while((ta|0)!=(q|0));if((za|0)<=1){bb=Ca;break}}}else bb=Ca}else bb=va;while(0);b[ra>>0]=bb;d:do if(!xa)if((b[D>>0]|0)!=0?(Ka=+n[E>>2],Ba=+n[F>>2],Ea=+n[G>>2],(bb|0)>0):0){za=0;Aa=na;Ia=0.0;ta=0;while(1){Fa=+n[qa+(ta<<3)>>2];Ha=+n[qa+(ta<<3)+4>>2];Ga=0;Qa=0.0;Ja=0.0;do{Pa=+n[Aa+(Ga<<2)>>2];Ja=Ja+ +n[la+(Ga<<2)>>2]*Pa;Qa=Qa+Pa*Pa;Ga=Ga+1|0}while((Ga|0)!=(q|0));if(Qa==0.0){cb=255;break d}if(!(!(Ja<=Qa)|!(Ja>=Ea*Qa))){Pa=Ja/Qa;Ga=0;db=0.0;do{eb=Pa*+n[Aa+(Ga<<2)>>2]-+n[la+(Ga<<2)>>2];db=db+eb*eb;Ga=Ga+1|0}while((Ga|0)!=(q|0));Ga=db<Pa*(Ka*Ha*Pa);fb=za|Ga;if(Ga)break;else gb=fb}else gb=za;Ia=Ia+Fa;if(Ia>Ba){cb=255;break d}ta=ta+1|0;if((ta|0)>=(bb|0)){cb=255;break d}else{za=gb;Aa=Aa+(q<<2)|0}}if(fb)cb=h[H>>0]|0;else cb=255}else cb=255;else cb=0;while(0);b[oa+pa>>0]=cb;pa=pa+1|0;ra=f[y>>2]|0;na=na+((Y(ra,q)|0)<<2)|0;if((pa|0)==(p|0))break;else{qa=qa+(ra<<3)|0;la=la+(q<<2)|0}}}la=ha+1|0;qa=f[i>>2]|0;if((la|0)>=(m|0)){hb=qa;break a}ha=la;ia=f[c>>2]|0;ja=qa}}else hb=w;while(0);if((hb|0)==(s|0)){u=d;return}if(hb|0)dYc(hb);f[i>>2]=s;f[t>>2]=264;u=d;return}function MWb(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=$Xc(216)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=164976;g=e+16|0;NWb(g,b,c,d);f[a>>2]=g;f[a+4>>2]=e;return}function NWb(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=e&1;yP(a);f[a>>2]=164812;e=a+4|0;h=a+8|0;f[a+16>>2]=1124007936;i=a+24|0;j=a+56|0;k=a+20|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+64|0;f[a+60>>2]=i;f[i>>2]=0;f[a+68>>2]=0;f[a+72>>2]=1124007936;i=a+80|0;j=a+112|0;k=a+76|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+120|0;f[a+116>>2]=i;f[i>>2]=0;f[a+124>>2]=0;i=a+184|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[e>>2]=0;f[h>>2]=0;f[a+12>>2]=0;f[a+128>>2]=0;f[a+132>>2]=(c|0)>0?c:500;p[a+144>>3]=d>0.0?d:16.0;b[a+176>>0]=g;f[a+136>>2]=5;n[a+152>>2]=.8999999761581421;n[a+160>>2]=15.0;n[a+168>>2]=75.0;n[a+164>>2]=4.0;n[a+156>>2]=9.0;n[a+172>>2]=.05000000074505806;b[a+177>>0]=127;n[a+180>>2]=.5;tYc(i,473539)|0;return}function OWb(a){a=a|0;f[a>>2]=164976;bWb(a+16|0);NXc(a);return}function PWb(a){a=a|0;f[a>>2]=164976;bWb(a+16|0);NXc(a);cYc(a);return}function QWb(a){a=a|0;bWb(a+16|0);return}function RWb(a){a=a|0;cYc(a);return}function SWb(a){a=a|0;cYc(a);return}function TWb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0.0,db=0.0,eb=0,fb=0.0,gb=0.0,hb=0.0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0;e=u;u=u+1200|0;g=e+144|0;i=e+88|0;j=e+24|0;k=e+32|0;l=e;m=e+8|0;o=a+32|0;q=f[o>>2]|0;r=+(q+-1|0)*.5;s=a+36|0;t=f[s>>2]|0;v=+(t+-1|0)*.5;w=f[a+4>>2]|0;x=f[a+8>>2]|0;y=f[a+12>>2]|0;z=((f[w>>2]|0)>>>3&511)+1|0;A=z<<1;B=Y(Y(q*3|0,t)|0,z)|0;C=g+8|0;f[g>>2]=C;D=g+4|0;f[D>>2]=B;if(B>>>0>520){E=bYc(B>>>0>2147483647?-1:B<<1)|0;f[g>>2]=E;F=E}else F=C;f[j>>2]=q;f[j+4>>2]=t;cM(i,j,(z<<3)+-5|0,F,0);F=f[o>>2]|0;f[l>>2]=F;j=f[s>>2]|0;f[l+4>>2]=j;cM(k,l,(z<<4)+-5|0,(f[g>>2]|0)+((Y(Y(j,z)|0,F)|0)<<1)|0,0);F=f[c>>2]|0;j=c+4|0;a:do if((F|0)<(f[j>>2]|0)){c=a+16|0;l=a+56|0;t=a+60|0;q=a+64|0;E=a+20|0;B=a+24|0;G=a+28|0;H=y+12|0;I=y+8|0;J=y+48|0;K=w+48|0;N=x+48|0;O=w+16|0;P=y+16|0;Q=i+16|0;R=i+44|0;S=k+16|0;T=k+44|0;U=A|1;V=a+68|0;W=a+44|0;X=x+12|0;Z=x+8|0;_=x+16|0;$=a+48|0;aa=z<<5;ba=F;b:while(1){ca=f[c>>2]|0;da=f[l>>2]|0;ea=1.0/+(1<<da|0);fa=+n[ca+(ba<<3)>>2]*ea;ga=+n[ca+(ba<<3)+4>>2]*ea;if((da|0)==(f[t>>2]|0))if(!(f[q>>2]&4)){ha=fa;ia=ga;ja=f[E>>2]|0}else{ka=ea;la=30}else{ka=2.0;la=30}if((la|0)==30){la=0;ca=f[E>>2]|0;ha=ka*+n[ca+(ba<<3)>>2];ia=ka*+n[ca+(ba<<3)+4>>2];ja=ca}ca=ja+(ba<<3)|0;n[ca>>2]=ha;ma=ja+(ba<<3)+4|0;n[ma>>2]=ia;ea=fa-r;fa=ga-v;na=~~ea;oa=na-(+(na|0)>ea&1)|0;na=~~fa;pa=na-(+(na|0)>fa&1)|0;na=f[o>>2]|0;c:do if((((oa|0)>=(0-na|0)?(oa|0)<(f[H>>2]|0):0)?(qa=f[s>>2]|0,(pa|0)>=(0-qa|0)):0)?(pa|0)<(f[I>>2]|0):0){ga=ea-+(oa|0);ra=fa-+(pa|0);sa=1.0-ga;ta=1.0-ra;ua=ALc(sa*ta*16384.0)|0;va=ALc(ga*ta*16384.0)|0;wa=ALc(ra*sa*16384.0)|0;xa=16384-ua-va-wa|0;ya=((f[J>>2]|0)>>>0)/((675553809>>>(f[y>>2]<<2&28)&15)>>>0)|0;za=((f[K>>2]|0)>>>0)/((675553809>>>(f[w>>2]<<2&28)&15)>>>0)|0;Aa=((f[N>>2]|0)>>>0)/((675553809>>>(f[x>>2]<<2&28)&15)>>>0)|0;if((qa|0)>0){Ba=Y(oa,z)|0;Ca=Y(oa,A)|0;Da=ya+A|0;Ea=ya+1|0;Fa=Da+1|0;Ga=f[O>>2]|0;Ha=f[P>>2]|0;Ia=f[Q>>2]|0;Ja=f[f[R>>2]>>2]|0;Ka=f[S>>2]|0;La=f[f[T>>2]>>2]|0;Ma=Y(na,z)|0;Na=(Ma|0)>0;sa=0.0;ra=0.0;ta=0.0;Oa=0;Pa=qa;while(1){Qa=Oa+pa|0;Ra=Ga+(Y(Qa,za)|0)+Ba|0;Sa=Ia+(Y(Ja,Oa)|0)|0;if(Na){Ta=Ka+(Y(La,Oa)|0)|0;Ua=0;Va=Ha+((Y(Qa,ya)|0)<<1)+(Ca<<1)|0;ga=sa;Wa=ra;Xa=ta;while(1){Qa=Y(h[Ra+Ua>>0]|0,ua)|0;Ya=Y(h[Ra+(Ua+z)>>0]|0,va)|0;Za=Ua+za|0;_a=Y(h[Ra+Za>>0]|0,wa)|0;$a=(Qa+256+Ya+_a+(Y(h[Ra+(Za+z)>>0]|0,xa)|0)|0)>>>9;Za=Y(d[Va>>1]|0,ua)|0;_a=Y(d[Va+(A<<1)>>1]|0,va)|0;Ya=Y(d[Va+(ya<<1)>>1]|0,wa)|0;Qa=Za+8192+_a+Ya+(Y(d[Va+(Da<<1)>>1]|0,xa)|0)>>14;Ya=Y(d[Va+2>>1]|0,ua)|0;_a=Y(d[Va+(U<<1)>>1]|0,va)|0;Za=Y(d[Va+(Ea<<1)>>1]|0,wa)|0;ab=Ya+8192+_a+Za+(Y(d[Va+(Fa<<1)>>1]|0,xa)|0)>>14;d[Sa+(Ua<<1)>>1]=$a;d[Ta>>1]=Qa;d[Ta+2>>1]=ab;ga=ga+ +(Y(Qa,Qa)|0);Wa=Wa+ +(Y(ab,Qa)|0);Xa=Xa+ +(Y(ab,ab)|0);Ua=Ua+1|0;if((Ua|0)>=(Ma|0))break;else{Ta=Ta+4|0;Va=Va+4|0}}bb=ga;cb=Wa;db=Xa;eb=f[s>>2]|0}else{bb=sa;cb=ra;db=ta;eb=Pa}Oa=Oa+1|0;if((Oa|0)>=(eb|0))break;else{sa=bb;ra=cb;ta=db;Pa=eb}}fb=bb;gb=cb;hb=db;ib=eb;jb=f[o>>2]|0}else{fb=0.0;gb=0.0;hb=0.0;ib=qa;jb=na}ta=fb*9.5367431640625e-07;ra=gb*9.5367431640625e-07;sa=hb*9.5367431640625e-07;kb=sa*ta-ra*ra;lb=ta-sa;mb=(sa+ta-+M(+(ra*(ra*4.0)+lb*lb)))/+(Y(ib<<1,jb)|0);Pa=f[G>>2]|0;if(Pa|0?f[q>>2]&8|0:0)n[Pa+(ba<<2)>>2]=mb;if(kb<1.1920928955078125e-07?1:mb<+n[V>>2]){if(da|0)break;Pa=f[B>>2]|0;if(!Pa)break;b[Pa+ba>>0]=0;break}mb=1.0/kb;Pa=f[W>>2]|0;d:do if((Pa|0)>0){Oa=0-jb|0;Ma=0-ib|0;xa=(ib|0)>0;Fa=Y(jb,z)|0;wa=(Fa|0)>0;Ea=0;kb=ha-r;lb=ia-v;nb=0.0;ob=0.0;e:while(1){va=~~kb;ua=va-(+(va|0)>kb&1)|0;va=~~lb;Da=va-(+(va|0)>lb&1)|0;if((ua|0)<(Oa|0))break;if((Da|0)<(Ma|0)?1:(ua|0)>=(f[X>>2]|0))break;if((Da|0)>=(f[Z>>2]|0))break;pb=kb-+(ua|0);qb=lb-+(Da|0);rb=1.0-pb;sb=1.0-qb;va=ALc(rb*sb*16384.0)|0;ya=ALc(pb*sb*16384.0)|0;za=ALc(rb*qb*16384.0)|0;Ca=16384-va-ya-za|0;do if(xa){Ha=f[_>>2]|0;La=Y(ua,z)|0;Ka=f[Q>>2]|0;Na=f[f[R>>2]>>2]|0;Ja=f[S>>2]|0;Ia=f[f[T>>2]>>2]|0;if(wa){tb=0.0;ub=0.0;vb=0}else{wb=0.0;xb=0.0;break}while(1){Ba=Ha+(Y(vb+Da|0,Aa)|0)+La|0;Ga=Ka+(Y(Na,vb)|0)|0;Va=Ja+(Y(Ia,vb)|0)|0;qb=tb;rb=ub;Ta=0;while(1){Ua=Y(h[Ba+Ta>>0]|0,va)|0;Sa=Y(h[Ba+(Ta+z)>>0]|0,ya)|0;Ra=Ta+Aa|0;ab=Y(h[Ba+Ra>>0]|0,za)|0;Qa=Ua+256+Sa+ab+(Y(h[Ba+(Ra+z)>>0]|0,Ca)|0)>>9;Ra=Qa-(d[Ga+(Ta<<1)>>1]|0)|0;rb=rb+ +(Y(Ra,d[Va>>1]|0)|0);qb=qb+ +(Y(Ra,d[Va+2>>1]|0)|0);Ta=Ta+1|0;if((Ta|0)>=(Fa|0))break;else Va=Va+4|0}vb=vb+1|0;if((vb|0)>=(ib|0)){wb=qb;xb=rb;break}else{tb=qb;ub=rb}}}else{wb=0.0;xb=0.0}while(0);sb=xb*9.5367431640625e-07;pb=wb*9.5367431640625e-07;yb=nb;nb=mb*(ra*pb-sa*sb);zb=ob;ob=mb*(ra*sb-ta*pb);kb=kb+nb;lb=lb+ob;Ab=r+kb;Bb=v+lb;n[ca>>2]=Ab;n[ma>>2]=Bb;pb=nb;sb=ob;if(pb*pb+sb*sb<=+p[$>>3])break d;do if((Ea|0)>0){if(!(+L(+(yb+nb))<.01))break;if(+L(+(zb+ob))<.01){la=72;break e}}while(0);Ea=Ea+1|0;if((Ea|0)>=(Pa|0))break d}if((la|0)==72){la=0;n[ca>>2]=Ab-nb*.5;n[ma>>2]=Bb-ob*.5;break}if(!da){Ea=f[B>>2]|0;if(!Ea){la=75;break b}b[Ea+ba>>0]=0}}while(0);Pa=f[B>>2]|0;if(!Pa){la=75;break b}qa=Pa+ba|0;if(((b[qa>>0]|0?(Pa=f[G>>2]|0,Pa|0):0)?(f[l>>2]|0)==0:0)?(f[q>>2]&8|0)==0:0){Ea=f[E>>2]|0;ta=+n[Ea+(ba<<3)>>2]-r;ra=+n[Ea+(ba<<3)+4>>2]-v;Ea=~~ta;Fa=Ea-(+(Ea|0)>ta&1)|0;Ea=~~ra;wa=Ea-(+(Ea|0)>ra&1)|0;Ea=f[o>>2]|0;do if((Fa|0)>=(0-Ea|0)){if((Fa|0)>=(f[X>>2]|0))break;xa=f[s>>2]|0;if((wa|0)<(0-xa|0))break;if((wa|0)>=(f[Z>>2]|0))break;mb=ta-+(Fa|0);sa=ra-+(wa|0);lb=1.0-mb;kb=1.0-sa;Ma=ALc(lb*kb*16384.0)|0;Oa=ALc(mb*kb*16384.0)|0;Ca=ALc(lb*sa*16384.0)|0;za=16384-Ma-Oa-Ca|0;do if((xa|0)>0){ya=f[_>>2]|0;va=Y(Fa,z)|0;Da=f[Q>>2]|0;ua=f[f[R>>2]>>2]|0;Ia=Y(Ea,z)|0;if((Ia|0)>0){Cb=0.0;Db=0}else{Eb=0.0;break}while(1){Ja=ya+(Y(Db+wa|0,Aa)|0)+va|0;Na=Da+(Y(ua,Db)|0)|0;sa=Cb;Ka=0;do{La=Y(h[Ja+Ka>>0]|0,Ma)|0;Ha=Y(h[Ja+(Ka+z)>>0]|0,Oa)|0;Va=Ka+Aa|0;Ta=Y(h[Ja+Va>>0]|0,Ca)|0;Ga=La+256+Ha+Ta+(Y(h[Ja+(Va+z)>>0]|0,za)|0)>>9;sa=sa+ +L(+(+(Ga-(d[Na+(Ka<<1)>>1]|0)|0)));Ka=Ka+1|0}while((Ka|0)<(Ia|0));Db=Db+1|0;if((Db|0)>=(xa|0)){Eb=sa;break}else Cb=sa}}else Eb=0.0;while(0);ob=Eb/+(Y(Y(aa,xa)|0,Ea)|0);n[Pa+(ba<<2)>>2]=ob;break c}while(0);b[qa>>0]=0}}else la=35;while(0);if((la|0)==35?(la=0,(da|0)==0):0){ma=f[B>>2]|0;if(ma|0)b[ma+ba>>0]=0;ma=f[G>>2]|0;if(ma|0)n[ma+(ba<<2)>>2]=0.0}ba=ba+1|0;if((ba|0)>=(f[j>>2]|0))break a}if((la|0)==75){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;ba=$Xc(16)|0;f[m>>2]=ba;f[m+8>>2]=-2147483632;f[m+4>>2]=14;G=ba;B=473652;aa=G+14|0;do{b[G>>0]=b[B>>0]|0;G=G+1|0;B=B+1|0}while((G|0)<(aa|0));b[ba+14>>0]=0;vM(-215,m,528391,473667,655)}}while(0);m=k+36|0;la=f[m>>2]|0;if(la|0?(j=la+12|0,la=f[j>>2]|0,f[j>>2]=la+-1,(la|0)==1):0)V$(k);f[m>>2]=0;m=k+16|0;la=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[la>>2]|0)>0){m=f[k+40>>2]|0;j=0;do{f[m+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[la>>2]|0))}la=f[k+44>>2]|0;if((la|0)!=(k+48|0))wL(la);la=i+36|0;k=f[la>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)V$(i);f[la>>2]=0;la=i+16|0;k=i+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[k>>2]|0)>0){la=f[i+40>>2]|0;j=0;do{f[la+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))wL(k);k=f[g>>2]|0;if((k|0)==(C|0)){u=e;return}if(k|0)dYc(k);f[g>>2]=C;f[D>>2]=520;u=e;return}function UWb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0;k=u;u=u+368|0;l=k+304|0;m=k+248|0;n=k+192|0;o=k+64|0;p=k+136|0;q=k+120|0;r=k+32|0;s=k;do if((eS(a)|0)==65536){t=f[a+4>>2]|0;f[m>>2]=f[t>>2];v=m+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[t+8>>2];f[m+12>>2]=f[t+12>>2];f[m+16>>2]=f[t+16>>2];f[m+20>>2]=f[t+20>>2];f[m+24>>2]=f[t+24>>2];f[m+28>>2]=f[t+28>>2];f[m+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=x;x=m+48|0;z=m+44|0;f[z>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];A=m;break}else{f[v>>2]=0;U$(m,t);A=m;break}}else{bS(m,a,-1);A=m}while(0);if(f[A>>2]&7|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;B=$Xc(64)|0;f[l>>2]=B;C=l+8|0;f[C>>2]=-2147483584;D=l+4|0;f[D>>2]=63;E=B;F=473770;G=E+63|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));H=B+63|0;b[H>>0]=0;vM(-215,l,473834,473667,704)}if((f[d>>2]|0)<=2){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;B=$Xc(64)|0;f[l>>2]=B;C=l+8|0;f[C>>2]=-2147483584;D=l+4|0;f[D>>2]=63;E=B;F=473770;G=E+63|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));H=B+63|0;b[H>>0]=0;vM(-215,l,473834,473667,704)}a=d+4|0;if((f[a>>2]|0)<=2){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;B=$Xc(64)|0;f[l>>2]=B;C=l+8|0;f[C>>2]=-2147483584;D=l+4|0;f[D>>2]=63;E=B;F=473770;G=E+63|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));H=B+63|0;b[H>>0]=0;vM(-215,l,473834,473667,704)}H=g?2:1;ZS(c,1,Y(H,e+1|0)|0,0,-1,1,0);B=f[A>>2]|0;F=B<<1&8176|11;do if(j?(h&16|0)==0&(B&32768|0)!=0:0){f[l>>2]=0;E=l+4|0;f[E>>2]=0;f[n>>2]=0;G=n+4|0;f[G>>2]=0;e0(m,l,n);D=f[n>>2]|0;C=f[d>>2]|0;if((D|0)<(C|0)){I=38;break}t=f[G>>2]|0;G=f[a>>2]|0;if((t|0)<(G|0)){I=38;break}v=m+12|0;if((C+D+(f[v>>2]|0)|0)>(f[l>>2]|0)){I=38;break}D=m+8|0;if((G+t+(f[D>>2]|0)|0)>(f[E>>2]|0)){I=38;break}E=WS(c,0)|0;if((E|0)!=(m|0)){t=m+36|0;G=f[t>>2]|0;if(G|0){C=G+12|0;f[C>>2]=(f[C>>2]|0)+1}C=E+36|0;G=f[C>>2]|0;if(G|0?(w=G+12|0,G=f[w>>2]|0,f[w>>2]=G+-1,(G|0)==1):0)V$(E);f[C>>2]=0;G=E+16|0;w=E+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[w>>2]|0)>0){x=f[E+40>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0;J=f[w>>2]|0}while((z|0)<(J|0));f[E>>2]=f[A>>2];if((J|0)<3)I=29;else I=31}else{f[E>>2]=f[A>>2];I=29}if((I|0)==29){z=f[m+4>>2]|0;if((z|0)<3){f[w>>2]=z;f[E+8>>2]=f[D>>2];f[E+12>>2]=f[v>>2];z=f[m+44>>2]|0;x=f[E+44>>2]|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2]}else I=31}if((I|0)==31)U$(E,m);f[G>>2]=f[m+16>>2];f[E+20>>2]=f[m+20>>2];f[E+24>>2]=f[m+24>>2];f[E+28>>2]=f[m+28>>2];f[E+32>>2]=f[m+32>>2];f[C>>2]=f[t>>2]}}else I=38;while(0);if((I|0)==38){J=WS(c,0)|0;B=J+16|0;if(f[B>>2]|0){j=f[J+4>>2]|0;if((j|0)<3)K=Y(f[J+12>>2]|0,f[J+8>>2]|0)|0;else{z=f[J+40>>2]|0;x=0;y=1;while(1){L=Y(f[z+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(j|0)){K=L;break}else y=L}}if(!((j|0)==0|(K|0)==0)){K=f[a>>2]|0;j=f[d>>2]|0;f0(J,K,K,j,j)|0}}j=f[J>>2]|0;K=f[A>>2]|0;y=m+12|0;x=f[y>>2]|0;if(!((K^j)&4095)){z=f[d>>2]|0;if(!((f[J+12>>2]|0)==((z<<1)+x|0)?(f[J+8>>2]|0)==((f[a>>2]<<1)+(f[m+8>>2]|0)|0):0)){M=z;I=49}}else{M=f[d>>2]|0;I=49}do if((I|0)==49){z=(f[a>>2]<<1)+(f[m+8>>2]|0)|0;L=(M<<1)+x|0;N=K&4095;if((((f[J+4>>2]|0)<3?(f[J+8>>2]|0)==(z|0):0)?(f[J+12>>2]|0)==(L|0):0)?!((j&4095|0)!=(N|0)|(f[B>>2]|0)==0):0)break;f[l>>2]=z;f[l+4>>2]=L;S$(J,2,l,N)}while(0);if((h|0)==5){B=f[a>>2]|0;j=f[y>>2]|0;y=f[m+8>>2]|0;f[o>>2]=f[d>>2];f[o+4>>2]=B;f[o+8>>2]=j;f[o+12>>2]=y;Z$(n,J,o);y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=-1040121856;f[l+4>>2]=n;jR(m,l);y=n+36|0;j=f[y>>2]|0;if(j|0?(B=j+12|0,j=f[B>>2]|0,f[B>>2]=j+-1,(j|0)==1):0)V$(n);f[y>>2]=0;y=n+16|0;j=n+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){y=f[n+40>>2]|0;B=0;do{f[y+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[j>>2]|0))}j=f[n+44>>2]|0;if((j|0)!=(n+48|0))wL(j)}else{f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;j=n+8|0;f[j>>2]=0;f[j+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=J;j=f[a>>2]|0;B=f[d>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;rR(l,n,j,j,B,B,h,o)}B=0-(f[a>>2]|0)|0;j=0-(f[d>>2]|0)|0;f0(J,B,B,j,j)|0}j=m+40|0;B=f[j>>2]|0;J=f[B>>2]|0;f[n>>2]=f[B+4>>2];B=n+4|0;f[B>>2]=J;J=WS(c,0)|0;f[o>>2]=f[J>>2];y=o+4|0;K=J+4|0;f[y>>2]=f[K>>2];x=o+8|0;f[x>>2]=f[J+8>>2];M=o+12|0;f[M>>2]=f[J+12>>2];N=o+16|0;f[N>>2]=f[J+16>>2];L=o+20|0;f[L>>2]=f[J+20>>2];z=o+24|0;f[z>>2]=f[J+24>>2];O=o+28|0;f[O>>2]=f[J+28>>2];P=o+32|0;f[P>>2]=f[J+32>>2];Q=o+36|0;R=f[J+36>>2]|0;f[Q>>2]=R;S=o+40|0;f[S>>2]=x;T=o+48|0;U=o+44|0;f[U>>2]=T;f[T>>2]=0;f[o+52>>2]=0;if(R|0){V=R+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[K>>2]|0)<3){K=f[J+44>>2]|0;V=f[U>>2]|0;f[V>>2]=f[K>>2];f[V+4>>2]=f[K+4>>2]}else{f[y>>2]=0;U$(o,J)}f[p>>2]=f[o>>2];J=p+4|0;K=f[y>>2]|0;f[J>>2]=K;V=p+8|0;f[V>>2]=f[x>>2];R=p+12|0;f[R>>2]=f[M>>2];W=p+16|0;f[W>>2]=f[N>>2];X=p+20|0;f[X>>2]=f[L>>2];Z=p+24|0;f[Z>>2]=f[z>>2];_=p+28|0;f[_>>2]=f[O>>2];$=p+32|0;f[$>>2]=f[P>>2];aa=p+36|0;ba=f[Q>>2]|0;f[aa>>2]=ba;ca=p+40|0;f[ca>>2]=V;da=p+48|0;ea=p+44|0;f[ea>>2]=da;f[da>>2]=0;f[p+52>>2]=0;if(!ba)fa=K;else{K=ba+12|0;f[K>>2]=(f[K>>2]|0)+1;fa=f[y>>2]|0}if((fa|0)<3){fa=f[U>>2]|0;K=f[ea>>2]|0;f[K>>2]=f[fa>>2];f[K+4>>2]=f[fa+4>>2]}else{f[J>>2]=0;U$(p,o)}a:do if((e|0)<0)ga=e;else{fa=q+4|0;K=q+8|0;ba=q+12|0;ha=(i|0)==5;ia=l+36|0;ja=l+16|0;ka=l+4|0;la=l+40|0;ma=l+44|0;na=l+48|0;oa=q+8|0;pa=q+12|0;qa=q+4|0;ra=r+8|0;sa=r+4|0;ta=i|16;ua=F&4091;va=l+4|0;wa=q+4|0;xa=q+8|0;ya=q+12|0;za=l+4|0;Aa=l+8|0;Ba=l+12|0;Ca=l+16|0;Da=l+20|0;Ea=l+24|0;Fa=l+28|0;Ga=l+32|0;Ha=l+36|0;Ia=p+44|0;Ja=l+44|0;Ka=l+40|0;La=l+48|0;Ma=l+8|0;Na=l+12|0;Oa=l+4|0;Pa=q+8|0;Qa=q+4|0;Ra=(h|0)==5;Sa=l+8|0;Ta=l+12|0;Ua=l+4|0;Va=q+8|0;Wa=q+4|0;Xa=h|16;Ya=p+40|0;Za=p+52|0;_a=0;while(1){if(_a|0){$a=WS(c,Y(_a,H)|0)|0;ab=$a+16|0;if(f[ab>>2]|0){bb=f[$a+4>>2]|0;if((bb|0)<3)cb=Y(f[$a+12>>2]|0,f[$a+8>>2]|0)|0;else{db=f[$a+40>>2]|0;eb=0;fb=1;while(1){gb=Y(f[db+(eb<<2)>>2]|0,fb)|0;eb=eb+1|0;if((eb|0)==(bb|0)){cb=gb;break}else fb=gb}}if(!((bb|0)==0|(cb|0)==0)){fb=f[a>>2]|0;eb=f[d>>2]|0;f0($a,fb,fb,eb,eb)|0}}eb=f[$a>>2]|0;fb=f[A>>2]|0;db=f[n>>2]|0;if(!((fb^eb)&4095)){gb=f[d>>2]|0;if((f[$a+12>>2]|0)==((gb<<1)+db|0)?(hb=f[a>>2]|0,ib=f[B>>2]|0,(f[$a+8>>2]|0)==((hb<<1)+ib|0)):0){jb=gb;kb=hb;lb=db;mb=ib}else{nb=gb;I=90}}else{nb=f[d>>2]|0;I=90}b:do if((I|0)==90){I=0;gb=f[B>>2]|0;ib=f[a>>2]|0;hb=(ib<<1)+gb|0;ob=(nb<<1)+db|0;pb=fb&4095;do if((f[$a+4>>2]|0)<3?(f[$a+8>>2]|0)==(hb|0):0){if((f[$a+12>>2]|0)!=(ob|0))break;if(!((eb&4095|0)!=(pb|0)|(f[ab>>2]|0)==0)){jb=nb;kb=ib;lb=db;mb=gb;break b}}while(0);f[l>>2]=hb;f[va>>2]=ob;S$($a,2,l,pb);jb=f[d>>2]|0;kb=f[a>>2]|0;lb=f[n>>2]|0;mb=f[B>>2]|0}while(0);f[q>>2]=jb;f[wa>>2]=kb;f[xa>>2]=lb;f[ya>>2]=mb;Z$(l,$a,q);db=f[aa>>2]|0;if(db|0?(ab=db+12|0,db=f[ab>>2]|0,f[ab>>2]=db+-1,(db|0)==1):0)V$(p);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[J>>2]|0)>0){db=f[ca>>2]|0;ab=0;do{f[db+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[J>>2]|0))}f[p>>2]=f[l>>2];ab=f[za>>2]|0;f[J>>2]=ab;f[V>>2]=f[Aa>>2];f[R>>2]=f[Ba>>2];f[W>>2]=f[Ca>>2];f[X>>2]=f[Da>>2];f[Z>>2]=f[Ea>>2];f[_>>2]=f[Fa>>2];f[$>>2]=f[Ga>>2];f[aa>>2]=f[Ha>>2];db=f[Ia>>2]|0;if((db|0)==(da|0))qb=ab;else{wL(db);f[Ia>>2]=da;f[ca>>2]=V;qb=f[za>>2]|0}if((qb|0)<3){db=f[Ja>>2]|0;f[da>>2]=f[db>>2];f[Za>>2]=f[db+4>>2];rb=db}else{f[Ia>>2]=f[Ja>>2];f[Ya>>2]=f[Ka>>2];f[Ja>>2]=La;f[Ka>>2]=Aa;rb=La}f[l>>2]=1124007936;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;f[za+16>>2]=0;f[za+20>>2]=0;f[za+24>>2]=0;f[za+28>>2]=0;f[Ha>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((rb|0)!=(La|0))wL(rb);f[Ma>>2]=0;f[Na>>2]=0;f[l>>2]=16842752;f[Oa>>2]=o;db=Pa;f[db>>2]=0;f[db+4>>2]=0;f[q>>2]=33619968;f[Qa>>2]=p;Gpa(l,q,n,4);if(!Ra){f[Sa>>2]=0;f[Ta>>2]=0;f[l>>2]=16842752;f[Ua>>2]=p;db=Va;f[db>>2]=0;f[db+4>>2]=0;f[q>>2]=33619968;f[Wa>>2]=$a;db=f[a>>2]|0;ab=f[d>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;rR(l,q,db,db,ab,ab,Xa,r)}ab=0-(f[a>>2]|0)|0;db=0-(f[d>>2]|0)|0;f0($a,ab,ab,db,db)|0}if(g){db=WS(c,(Y(_a,H)|0)+1|0)|0;ab=db+16|0;if(f[ab>>2]|0){eb=f[db+4>>2]|0;if((eb|0)<3)sb=Y(f[db+12>>2]|0,f[db+8>>2]|0)|0;else{fb=f[db+40>>2]|0;bb=0;gb=1;while(1){ib=Y(f[fb+(bb<<2)>>2]|0,gb)|0;bb=bb+1|0;if((bb|0)==(eb|0)){sb=ib;break}else gb=ib}}if(!((eb|0)==0|(sb|0)==0)){gb=f[a>>2]|0;bb=f[d>>2]|0;f0(db,gb,gb,bb,bb)|0}}bb=f[db>>2]&4095;gb=f[n>>2]|0;if((bb|0)==(F|0)){fb=f[d>>2]|0;if((f[db+12>>2]|0)==((fb<<1)+gb|0)?($a=f[a>>2]|0,ib=f[B>>2]|0,(f[db+8>>2]|0)==(($a<<1)+ib|0)):0){tb=fb;ub=$a;vb=gb;wb=ib}else{xb=fb;I=123}}else{xb=f[d>>2]|0;I=123}c:do if((I|0)==123){I=0;fb=f[B>>2]|0;ib=f[a>>2]|0;$a=(ib<<1)+fb|0;yb=(xb<<1)+gb|0;do if((f[db+4>>2]|0)<3){if((f[db+8>>2]|0)!=($a|0))break;if((f[db+12>>2]|0)!=(yb|0))break;if(!((bb|0)!=(ua|0)|(f[ab>>2]|0)==0)){tb=xb;ub=ib;vb=gb;wb=fb;break c}}while(0);f[l>>2]=$a;f[va>>2]=yb;S$(db,2,l,ua);tb=f[d>>2]|0;ub=f[a>>2]|0;vb=f[n>>2]|0;wb=f[B>>2]|0}while(0);f[q>>2]=tb;f[fa>>2]=ub;f[K>>2]=vb;f[ba>>2]=wb;Z$(l,db,q);VWb(p,l);if(!ha){f[oa>>2]=0;f[pa>>2]=0;f[q>>2]=16842752;f[qa>>2]=l;gb=ra;f[gb>>2]=0;f[gb+4>>2]=0;f[r>>2]=33619968;f[sa>>2]=db;gb=f[a>>2]|0;ab=f[d>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[s+28>>2]=0;rR(q,r,gb,gb,ab,ab,ta,s)}ab=0-(f[a>>2]|0)|0;gb=0-(f[d>>2]|0)|0;f0(db,ab,ab,gb,gb)|0;gb=f[ia>>2]|0;do if(gb|0){ab=gb+12|0;bb=f[ab>>2]|0;f[ab>>2]=bb+-1;if((bb|0)!=1)break;V$(l)}while(0);f[ia>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ka>>2]|0)>0){gb=f[la>>2]|0;db=0;do{f[gb+(db<<2)>>2]=0;db=db+1|0}while((db|0)<(f[ka>>2]|0))}db=f[ma>>2]|0;if((db|0)!=(na|0))wL(db)}db=((f[n>>2]|0)+1|0)/2|0;gb=((f[B>>2]|0)+1|0)/2|0;f[n>>2]=db;f[B>>2]=gb;if((db|0)<=(f[d>>2]|0))break;if((gb|0)<=(f[a>>2]|0))break;gb=f[aa>>2]|0;if(gb|0){db=gb+12|0;f[db>>2]=(f[db>>2]|0)+1}db=f[Q>>2]|0;if(db|0?(gb=db+12|0,db=f[gb>>2]|0,f[gb>>2]=db+-1,(db|0)==1):0)V$(o);f[Q>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[y>>2]|0)>0){db=f[S>>2]|0;gb=0;do{f[db+(gb<<2)>>2]=0;gb=gb+1|0;zb=f[y>>2]|0}while((gb|0)<(zb|0));f[o>>2]=f[p>>2];if((zb|0)<3)I=152;else I=154}else{f[o>>2]=f[p>>2];I=152}do if((I|0)==152){I=0;gb=f[J>>2]|0;if((gb|0)>=3){I=154;break}f[y>>2]=gb;f[x>>2]=f[V>>2];f[M>>2]=f[R>>2];gb=f[ea>>2]|0;db=f[U>>2]|0;f[db>>2]=f[gb>>2];f[db+4>>2]=f[gb+4>>2]}while(0);if((I|0)==154){I=0;U$(o,p)}f[N>>2]=f[W>>2];f[L>>2]=f[X>>2];f[z>>2]=f[Z>>2];f[O>>2]=f[_>>2];f[P>>2]=f[$>>2];f[Q>>2]=f[aa>>2];if((_a|0)<(e|0))_a=_a+1|0;else{ga=e;break a}}ZS(c,1,Y(_a+1|0,H)|0,0,-1,1,0);ga=_a}while(0);H=f[aa>>2]|0;if(H|0?(c=H+12|0,H=f[c>>2]|0,f[c>>2]=H+-1,(H|0)==1):0)V$(p);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[J>>2]|0)>0){W=f[ca>>2]|0;ca=0;do{f[W+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[J>>2]|0))}J=f[ea>>2]|0;if((J|0)!=(da|0))wL(J);J=f[Q>>2]|0;if(J|0?(da=J+12|0,J=f[da>>2]|0,f[da>>2]=J+-1,(J|0)==1):0)V$(o);f[Q>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[y>>2]|0)>0){N=f[S>>2]|0;S=0;do{f[N+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[y>>2]|0))}y=f[U>>2]|0;if((y|0)!=(T|0))wL(y);y=m+36|0;T=f[y>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)V$(m);f[y>>2]=0;y=m+16|0;T=m+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[T>>2]|0)>0){y=f[j>>2]|0;j=0;do{f[y+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[T>>2]|0))}T=f[m+44>>2]|0;if((T|0)==(m+48|0)){u=k;return ga|0}wL(T);u=k;return ga|0}function VWb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+1056|0;g=e;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a>>2]|0;m=(l>>>3&511)+1|0;n=Y(m,k)|0;if(l&7|0){l=$Xc(16)|0;f[g>>2]=l;f[g+8>>2]=-2147483632;f[g+4>>2]=14;o=l;p=473858;q=o+14|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+14>>0]=0;vM(-215,g,473873,473667,63)}l=(m<<4)+4091&4091;if(!(((((f[c+4>>2]|0)<3?(f[c+8>>2]|0)==(i|0):0)?(f[c+12>>2]|0)==(k|0):0)?(f[c>>2]&4095|0)==(l|0):0)?(f[c+16>>2]|0)!=0:0)){f[g>>2]=i;f[g+4>>2]=k;S$(c,2,g,l)}l=(Y(m,k+2|0)|0)+15&-16;p=(l<<1)+64|0;o=g+8|0;f[g>>2]=o;q=g+4|0;f[q>>2]=p;if(p>>>0>520){r=bYc(p>>>0>2147483647?-1:p<<1)|0;f[g>>2]=r;s=r}else s=o;r=s+(m<<1)+15&-16;p=r+(l<<1)|0;if((i|0)>0){l=(i|0)!=1;t=l&1;v=i+-1|0;w=l?i+-2|0:0;l=(n|0)>0;x=(k|0)>1;y=x?m:0;z=Y(m,x?k+-2|0:0)|0;k=f[a+16>>2]|0;x=f[f[a+44>>2]>>2]|0;a=f[c+16>>2]|0;A=f[f[c+44>>2]>>2]|0;c=0;do{B=k+(Y(x,(c|0)>0?c+-1|0:t)|0)|0;C=k+(Y(x,c)|0)|0;D=c;c=c+1|0;E=k+(Y(x,(D|0)<(v|0)?c:w)|0)|0;F=a+(Y(A,D)|0)|0;if(l){D=0;do{G=h[B+D>>0]|0;H=h[E+D>>0]|0;d[r+(D<<1)>>1]=((H+G|0)*3|0)+((h[C+D>>0]|0)*10|0);d[p+(D<<1)>>1]=H-G;D=D+1|0}while((D|0)!=(n|0));I=0}else I=0;do{D=I+y|0;C=I-m|0;d[r+(C<<1)>>1]=d[r+(D<<1)>>1]|0;E=I+z|0;B=I+n|0;d[r+(B<<1)>>1]=d[r+(E<<1)>>1]|0;d[p+(C<<1)>>1]=d[p+(D<<1)>>1]|0;d[p+(B<<1)>>1]=d[p+(E<<1)>>1]|0;I=I+1|0}while((I|0)!=(m|0));if(l){E=0;do{B=E+m|0;D=E-m|0;C=(((d[p+(D<<1)>>1]|0)+(d[p+(B<<1)>>1]|0)|0)*3|0)+((d[p+(E<<1)>>1]|0)*10|0)&65535;G=E<<1;d[F+(G<<1)>>1]=(j[r+(B<<1)>>1]|0)-(j[r+(D<<1)>>1]|0);d[F+((G|1)<<1)>>1]=C;E=E+1|0}while((E|0)!=(n|0))}}while((c|0)!=(i|0))}if((s|0)==(o|0)){u=e;return}dYc(s);f[g>>2]=o;f[q>>2]=520;u=e;return}function WWb(a){a=a|0;qP(a);cYc(a);return}function XWb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;j=u;u=u+560|0;k=j+504|0;l=j+448|0;m=j+440|0;o=j+384|0;q=j+328|0;r=j+272|0;s=j+244|0;t=j+232|0;v=j+176|0;w=j+120|0;x=j+264|0;y=j+256|0;z=j+32|0;A=j+104|0;B=j;do if((eS(e)|0)==65536){C=f[e+4>>2]|0;f[l>>2]=f[C>>2];D=l+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=l+8|0;f[F>>2]=f[C+8>>2];f[l+12>>2]=f[C+12>>2];f[l+16>>2]=f[C+16>>2];f[l+20>>2]=f[C+20>>2];f[l+24>>2]=f[C+24>>2];f[l+28>>2]=f[C+28>>2];f[l+32>>2]=f[C+32>>2];G=f[C+36>>2]|0;f[l+36>>2]=G;f[l+40>>2]=F;F=l+48|0;H=l+44|0;f[H>>2]=F;f[F>>2]=0;f[l+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[D>>2]=0;U$(l,C);break}}else bS(l,e,-1);while(0);e=a+12|0;if((f[e>>2]|0)<=-1){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(64)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483584;K=k+4|0;f[K>>2]=56;L=I;M=473888;N=L+56|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));O=I+56|0;b[O>>0]=0;vM(-215,k,474953,473667,1226)}C=a+4|0;if((f[C>>2]|0)<=2){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(64)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483584;K=k+4|0;f[K>>2]=56;L=I;M=473888;N=L+56|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));O=I+56|0;b[O>>0]=0;vM(-215,k,474953,473667,1226)}D=a+8|0;if((f[D>>2]|0)<=2){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(64)|0;f[k>>2]=I;J=k+8|0;f[J>>2]=-2147483584;K=k+4|0;f[K>>2]=56;L=I;M=473888;N=L+56|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));O=I+56|0;b[O>>0]=0;vM(-215,k,474953,473667,1226)}O=k0(l,2,5,1)|0;if((O|0)<=-1){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;I=$Xc(64)|0;f[k>>2]=I;f[k+8>>2]=-2147483584;f[k+4>>2]=56;L=I;M=473945;N=L+56|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[I+56>>0]=0;vM(-215,k,474953,473667,1229)}if(O){I=a+32|0;if(!(f[I>>2]&4)){K=f[l+40>>2]|0;J=f[K>>2]|0;f[m>>2]=f[K+4>>2];f[m+4>>2]=J;wS(g,m,f[l>>2]&4095,-1,1,0)}do if((eS(g)|0)==65536){m=f[g+4>>2]|0;f[o>>2]=f[m>>2];J=o+4|0;K=m+4|0;f[J>>2]=f[K>>2];E=o+8|0;f[E>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];f[o+32>>2]=f[m+32>>2];F=f[m+36>>2]|0;f[o+36>>2]=F;f[o+40>>2]=E;E=o+48|0;H=o+44|0;f[H>>2]=E;f[E>>2]=0;f[o+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[K>>2]|0)<3){K=f[m+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[K>>2];f[E+4>>2]=f[K+4>>2];break}else{f[J>>2]=0;U$(o,m);break}}else bS(o,g,-1);while(0);if((k0(o,2,5,1)|0)!=(O|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;m=$Xc(64)|0;f[k>>2]=m;f[k+8>>2]=-2147483584;f[k+4>>2]=50;L=m;M=474002;N=L+50|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[m+50>>0]=0;vM(-215,k,474953,473667,1243)}m=f[l+16>>2]|0;J=o+16|0;K=f[J>>2]|0;E=o+44|0;ZS(h,O,1,0,-1,1,0);do if((eS(h)|0)==65536){H=f[h+4>>2]|0;f[q>>2]=f[H>>2];F=q+4|0;G=H+4|0;f[F>>2]=f[G>>2];P=q+8|0;f[P>>2]=f[H+8>>2];f[q+12>>2]=f[H+12>>2];f[q+16>>2]=f[H+16>>2];f[q+20>>2]=f[H+20>>2];f[q+24>>2]=f[H+24>>2];f[q+28>>2]=f[H+28>>2];f[q+32>>2]=f[H+32>>2];Q=f[H+36>>2]|0;f[q+36>>2]=Q;f[q+40>>2]=P;P=q+48|0;R=q+44|0;f[R>>2]=P;f[P>>2]=0;f[q+52>>2]=0;if(Q|0){P=Q+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[G>>2]|0)<3){G=f[H+44>>2]|0;P=f[R>>2]|0;f[P>>2]=f[G>>2];f[P+4>>2]=f[G+4>>2];S=q;break}else{f[F>>2]=0;U$(q,H);S=q;break}}else{bS(q,h,-1);S=q}while(0);f[r>>2]=1124007936;H=r+4|0;F=r+8|0;G=r+40|0;L=H;N=L+36|0;do{f[L>>2]=0;L=L+4|0}while((L|0)<(N|0));f[G>>2]=F;P=r+48|0;R=r+44|0;f[R>>2]=P;f[P>>2]=0;f[r+52>>2]=0;if(!(f[S>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;S=$Xc(32)|0;f[k>>2]=S;f[k+8>>2]=-2147483616;f[k+4>>2]=24;L=S;M=474053;N=L+24|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[S+24>>0]=0;vM(-215,k,474953,473667,1250)}S=q+16|0;Q=f[S>>2]|0;T=q+44|0;if((O|0)>0)g1c(Q|0,1,O|0)|0;do if(aT(i)|0){ZS(i,O,1,5,-1,1,0);do if((eS(i)|0)==65536){U=f[i+4>>2]|0;f[k>>2]=f[U>>2];V=k+4|0;W=U+4|0;f[V>>2]=f[W>>2];X=k+8|0;f[X>>2]=f[U+8>>2];f[k+12>>2]=f[U+12>>2];f[k+16>>2]=f[U+16>>2];f[k+20>>2]=f[U+20>>2];f[k+24>>2]=f[U+24>>2];f[k+28>>2]=f[U+28>>2];f[k+32>>2]=f[U+32>>2];Z=f[U+36>>2]|0;f[k+36>>2]=Z;f[k+40>>2]=X;X=k+48|0;_=k+44|0;f[_>>2]=X;f[X>>2]=0;f[k+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[W>>2]|0)<3){W=f[U+44>>2]|0;X=f[_>>2]|0;f[X>>2]=f[W>>2];f[X+4>>2]=f[W+4>>2];break}else{f[V>>2]=0;U$(k,U);break}}else bS(k,i,-1);while(0);U=r+36|0;V=f[U>>2]|0;if(V|0?(W=V+12|0,V=f[W>>2]|0,f[W>>2]=V+-1,(V|0)==1):0)V$(r);f[U>>2]=0;V=r+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[H>>2]|0)>0){W=f[G>>2]|0;X=0;do{f[W+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[H>>2]|0))}f[r>>2]=f[k>>2];X=k+4|0;W=f[X>>2]|0;f[H>>2]=W;_=k+8|0;f[F>>2]=f[_>>2];f[r+12>>2]=f[k+12>>2];Z=k+16|0;f[V>>2]=f[Z>>2];f[r+20>>2]=f[k+20>>2];f[r+24>>2]=f[k+24>>2];f[r+28>>2]=f[k+28>>2];f[r+32>>2]=f[k+32>>2];$=k+36|0;f[U>>2]=f[$>>2];aa=r+44|0;ba=f[aa>>2]|0;if((ba|0)==(P|0))ca=W;else{wL(ba);f[aa>>2]=P;f[G>>2]=F;ca=f[X>>2]|0}ba=k+44|0;if((ca|0)<3){W=f[ba>>2]|0;f[P>>2]=f[W>>2];f[r+52>>2]=f[W+4>>2];da=W}else{f[aa>>2]=f[ba>>2];aa=k+40|0;f[r+40>>2]=f[aa>>2];W=k+48|0;f[ba>>2]=W;f[aa>>2]=_;da=W}f[k>>2]=1124007936;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;f[X+16>>2]=0;f[X+20>>2]=0;f[X+24>>2]=0;f[X+28>>2]=0;f[$>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((da|0)!=(k+48|0))wL(da);if(!(f[r>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;Z=$Xc(32)|0;f[k>>2]=Z;f[k+8>>2]=-2147483616;f[k+4>>2]=21;L=Z;M=474078;N=L+21|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[Z+21>>0]=0;vM(-215,k,474953,473667,1261)}else{ea=f[V>>2]|0;break}}else ea=0;while(0);f[s>>2]=0;da=s+4|0;f[da>>2]=0;f[s+8>>2]=0;f[t>>2]=0;ca=t+4|0;f[ca>>2]=0;f[t+8>>2]=0;if((eS(c)|0)==327680){gS(c,s);F=f[s>>2]|0;U=(f[da>>2]|0)-F|0;da=((U|0)/56|0)+-1|0;$=F;if((U|0)<=0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;U=$Xc(16)|0;f[k>>2]=U;f[k+8>>2]=-2147483632;f[k+4>>2]=12;L=U;M=474100;N=L+12|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[U+12>>0]=0;vM(-215,k,474953,473667,1276)}if(((da|0)%2|0|0)==1?(U=f[$+56>>2]|0,(U&7|0)==3?((f[$>>2]|0)>>>2&1022|1|0)==(U>>>3&511|0):0):0){fa=2;ga=(da|0)/2|0}else{fa=1;ga=da}do if((ga|0)>0){f[k>>2]=0;da=k+4|0;f[da>>2]=0;f[v>>2]=0;U=v+4|0;f[U>>2]=0;e0($+(fa*56|0)|0,k,v);F=f[v>>2]|0;X=f[C>>2]|0;if((F|0)<(X|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;ha=$Xc(192)|0;f[w>>2]=ha;ia=w+8|0;f[ia>>2]=-2147483456;ja=w+4|0;f[ja>>2]=187;o1c(ha|0,474113,187)|0;ka=ha+187|0;b[ka>>0]=0;vM(-215,w,474953,473667,1292)}W=f[U>>2]|0;U=f[D>>2]|0;if((W|0)<(U|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;ha=$Xc(192)|0;f[w>>2]=ha;ia=w+8|0;f[ia>>2]=-2147483456;ja=w+4|0;f[ja>>2]=187;o1c(ha|0,474113,187)|0;ka=ha+187|0;b[ka>>0]=0;vM(-215,w,474953,473667,1292)}_=f[s>>2]|0;if((X+F+(f[_+(fa*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;ha=$Xc(192)|0;f[w>>2]=ha;ia=w+8|0;f[ia>>2]=-2147483456;ja=w+4|0;f[ja>>2]=187;o1c(ha|0,474113,187)|0;ka=ha+187|0;b[ka>>0]=0;vM(-215,w,474953,473667,1292)}if((U+W+(f[_+(fa*56|0)+8>>2]|0)|0)>(f[da>>2]|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;ha=$Xc(192)|0;f[w>>2]=ha;ia=w+8|0;f[ia>>2]=-2147483456;ja=w+4|0;f[ja>>2]=187;o1c(ha|0,474113,187)|0;ka=ha+187|0;b[ka>>0]=0;vM(-215,w,474953,473667,1292)}else break}while(0);if((ga|0)<(f[e>>2]|0)){f[e>>2]=ga;la=fa;ma=ga}else{la=fa;ma=ga}}else{la=1;ma=-1}do if((eS(d)|0)==327680){gS(d,t);ga=f[t>>2]|0;fa=(f[ca>>2]|0)-ga|0;ka=((fa|0)/56|0)+-1|0;ha=ga;if((fa|0)<=0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;fa=$Xc(16)|0;f[k>>2]=fa;f[k+8>>2]=-2147483632;f[k+4>>2]=12;L=fa;M=474301;N=L+12|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[fa+12>>0]=0;vM(-215,k,474953,473667,1304)}do if(((ka|0)%2|0|0)==1){V=f[ha+56>>2]|0;if(!((V&7|0)==3?((f[ha>>2]|0)>>>2&1022|1|0)==(V>>>3&511|0):0)){na=1;oa=ka;break}na=2;oa=(ka|0)/2|0}else{na=1;oa=ka}while(0);do if((oa|0)>0){f[k>>2]=0;ka=k+4|0;f[ka>>2]=0;f[v>>2]=0;fa=v+4|0;f[fa>>2]=0;e0(ha+(na*56|0)|0,k,v);V=f[v>>2]|0;Z=f[C>>2]|0;if((V|0)<(Z|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;pa=$Xc(192)|0;f[w>>2]=pa;qa=w+8|0;f[qa>>2]=-2147483456;ra=w+4|0;f[ra>>2]=187;o1c(pa|0,474314,187)|0;sa=pa+187|0;b[sa>>0]=0;vM(-215,w,474953,473667,1320)}ga=f[fa>>2]|0;fa=f[D>>2]|0;if((ga|0)<(fa|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;pa=$Xc(192)|0;f[w>>2]=pa;qa=w+8|0;f[qa>>2]=-2147483456;ra=w+4|0;f[ra>>2]=187;o1c(pa|0,474314,187)|0;sa=pa+187|0;b[sa>>0]=0;vM(-215,w,474953,473667,1320)}ja=f[t>>2]|0;if((Z+V+(f[ja+(na*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;pa=$Xc(192)|0;f[w>>2]=pa;qa=w+8|0;f[qa>>2]=-2147483456;ra=w+4|0;f[ra>>2]=187;o1c(pa|0,474314,187)|0;sa=pa+187|0;b[sa>>0]=0;vM(-215,w,474953,473667,1320)}if((fa+ga+(f[ja+(na*56|0)+8>>2]|0)|0)>(f[ka>>2]|0)){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;pa=$Xc(192)|0;f[w>>2]=pa;qa=w+8|0;f[qa>>2]=-2147483456;ra=w+4|0;f[ra>>2]=187;o1c(pa|0,474314,187)|0;sa=pa+187|0;b[sa>>0]=0;vM(-215,w,474953,473667,1320)}else break}while(0);if((oa|0)>=(f[e>>2]|0)){ta=na;ua=oa;break}f[e>>2]=oa;ta=na;ua=oa}else{ta=1;ua=-1}while(0);if((ma|0)<0){ma=k+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=s;f[x>>2]=f[C>>2];f[x+4>>2]=f[D>>2];ma=UWb(c,k,x,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=ma}if((ua|0)<0){ua=k+8|0;f[ua>>2]=0;f[ua+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=t;f[y>>2]=f[C>>2];f[y+4>>2]=f[D>>2];ua=UWb(d,k,y,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=ua}ua=a+16|0;y=f[ua>>2]|0;d=a+20|0;if(!(y&1))va=30;else{ma=f[d>>2]|0;x=(ma|0)>0?ma:0;va=(x|0)<100?x:100}f[d>>2]=va;va=a+24|0;if(!(y&2))wa=.01;else{xa=+p[va>>3];ya=xa<0.0?0.0:xa;wa=ya>10.0?10.0:ya}p[va>>3]=wa*wa;f[v>>2]=1124007936;va=v+4|0;y=v+8|0;d=v+40|0;L=va;N=L+36|0;do{f[L>>2]=0;L=L+4|0}while((L|0)<(N|0));f[d>>2]=y;y=v+48|0;x=v+44|0;f[x>>2]=y;f[y>>2]=0;f[v+52>>2]=0;ma=(la|0)==1;if(ma){c=f[s>>2]|0;oa=(f[C>>2]<<1)+(f[c+12>>2]|0)|0;na=f[c>>2]<<1&4080|11;f[k>>2]=(f[D>>2]<<1)+(f[c+8>>2]|0);f[k+4>>2]=oa;S$(v,2,k,na)}na=f[e>>2]|0;a:do if((na|0)>-1){oa=k+4|0;c=k+8|0;sa=k+40|0;pa=k+48|0;ra=k+44|0;qa=k+52|0;ca=v+16|0;ha=A+4|0;ka=A+8|0;ja=A+12|0;ga=k+36|0;fa=k+16|0;V=z+4|0;Z=z+8|0;ia=z+12|0;$=k+12|0;da=z+16|0;_=z+20|0;W=k+20|0;U=z+24|0;F=k+24|0;X=z+28|0;aa=k+28|0;ba=z+32|0;za=k+32|0;Aa=z+36|0;Ba=k+44|0;Ca=z+44|0;Da=z+40|0;Ea=z+48|0;Fa=z+8|0;Ga=z+12|0;Ha=z+4|0;Ia=A+8|0;Ja=A+4|0;Ka=w+36|0;La=w+16|0;Ma=w+4|0;Na=w+40|0;Oa=w+44|0;Pa=w+48|0;Qa=k+40|0;Ra=w+4|0;Sa=a+40|0;Ta=z+32|0;Ua=z+36|0;Va=z+40|0;Wa=z+4|0;Xa=z+12|0;Ya=z+8|0;Za=z+16|0;_a=z+20|0;$a=z+24|0;ab=z+28|0;bb=z+56|0;cb=z+60|0;db=z+64|0;eb=z+68|0;fb=k+52|0;gb=na;while(1){f[k>>2]=1124007936;L=oa;N=L+36|0;do{f[L>>2]=0;L=L+4|0}while((L|0)<(N|0));f[sa>>2]=c;f[ra>>2]=pa;f[pa>>2]=0;f[qa>>2]=0;hb=Y(gb,la)|0;do if(ma){ib=f[(f[s>>2]|0)+(hb*56|0)+40>>2]|0;jb=f[ib+4>>2]|0;kb=f[ib>>2]|0;Tj(w,(f[D>>2]<<1)+kb|0,(f[C>>2]<<1)+jb|0,f[v>>2]&4095,f[ca>>2]|0,0);ib=f[D>>2]|0;f[A>>2]=f[C>>2];f[ha>>2]=ib;f[ka>>2]=jb;f[ja>>2]=kb;Z$(z,w,A);kb=f[ga>>2]|0;do if(kb|0){jb=kb+12|0;ib=f[jb>>2]|0;f[jb>>2]=ib+-1;if((ib|0)!=1)break;V$(k)}while(0);f[ga>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[oa>>2]|0)>0){kb=f[sa>>2]|0;ib=0;do{f[kb+(ib<<2)>>2]=0;ib=ib+1|0}while((ib|0)<(f[oa>>2]|0))}f[k>>2]=f[z>>2];ib=f[V>>2]|0;f[oa>>2]=ib;f[c>>2]=f[Z>>2];f[$>>2]=f[ia>>2];f[fa>>2]=f[da>>2];f[W>>2]=f[_>>2];f[F>>2]=f[U>>2];f[aa>>2]=f[X>>2];f[za>>2]=f[ba>>2];f[ga>>2]=f[Aa>>2];kb=f[Ba>>2]|0;if((kb|0)==(pa|0))lb=ib;else{wL(kb);f[Ba>>2]=pa;f[sa>>2]=c;lb=f[V>>2]|0}if((lb|0)<3){kb=f[Ca>>2]|0;f[pa>>2]=f[kb>>2];f[fb>>2]=f[kb+4>>2];mb=kb}else{f[Ba>>2]=f[Ca>>2];f[Qa>>2]=f[Da>>2];f[Ca>>2]=Ea;f[Da>>2]=Z;mb=Ea}f[z>>2]=1124007936;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;f[V+16>>2]=0;f[V+20>>2]=0;f[V+24>>2]=0;f[V+28>>2]=0;f[Aa>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((mb|0)!=(Ea|0))wL(mb);VWb((f[s>>2]|0)+(hb*56|0)|0,k);f[Fa>>2]=0;f[Ga>>2]=0;f[z>>2]=16842752;f[Ha>>2]=k;kb=Ia;f[kb>>2]=0;f[kb+4>>2]=0;f[A>>2]=33619968;f[Ja>>2]=w;kb=f[D>>2]|0;ib=f[C>>2]|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;f[B+24>>2]=0;f[B+28>>2]=0;rR(z,A,kb,kb,ib,ib,16,B);ib=f[Ka>>2]|0;do if(ib|0){kb=ib+12|0;jb=f[kb>>2]|0;f[kb>>2]=jb+-1;if((jb|0)!=1)break;V$(w)}while(0);f[Ka>>2]=0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[Ma>>2]|0)>0){ib=f[Na>>2]|0;jb=0;do{f[ib+(jb<<2)>>2]=0;jb=jb+1|0}while((jb|0)<(f[Ma>>2]|0))}jb=f[Oa>>2]|0;if((jb|0)!=(Pa|0))wL(jb)}else{jb=hb+1|0;ib=f[s>>2]|0;kb=ib+(jb*56|0)|0;if((k|0)==(kb|0))break;nb=ib+(jb*56|0)+36|0;ob=f[nb>>2]|0;do if(ob|0){pb=ob+12|0;f[pb>>2]=(f[pb>>2]|0)+1;pb=f[ga>>2]|0;if(!pb)break;qb=pb+12|0;pb=f[qb>>2]|0;f[qb>>2]=pb+-1;if((pb|0)!=1)break;V$(k)}while(0);f[ga>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[oa>>2]|0)>0){ob=f[sa>>2]|0;pb=0;do{f[ob+(pb<<2)>>2]=0;pb=pb+1|0;rb=f[oa>>2]|0}while((pb|0)<(rb|0));f[k>>2]=f[kb>>2];if((rb|0)<3)sb=137;else sb=139}else{f[k>>2]=f[kb>>2];sb=137}do if((sb|0)==137){sb=0;pb=f[ib+(jb*56|0)+4>>2]|0;if((pb|0)>=3){sb=139;break}f[oa>>2]=pb;f[c>>2]=f[ib+(jb*56|0)+8>>2];f[$>>2]=f[ib+(jb*56|0)+12>>2];pb=f[ib+(jb*56|0)+44>>2]|0;ob=f[ra>>2]|0;f[ob>>2]=f[pb>>2];f[ob+4>>2]=f[pb+4>>2]}while(0);if((sb|0)==139){sb=0;U$(k,kb)}f[fa>>2]=f[ib+(jb*56|0)+16>>2];f[W>>2]=f[ib+(jb*56|0)+20>>2];f[F>>2]=f[ib+(jb*56|0)+24>>2];f[aa>>2]=f[ib+(jb*56|0)+28>>2];f[za>>2]=f[ib+(jb*56|0)+32>>2];f[ga>>2]=f[nb>>2]}while(0);pb=f[s>>2]|0;ob=f[pb+(hb*56|0)+40>>2]|0;qb=Y(gb,ta)|0;tb=f[t>>2]|0;ub=f[tb+(qb*56|0)+40>>2]|0;if(!((f[ob>>2]|0)==(f[ub>>2]|0)?(f[ob+4>>2]|0)==(f[ub+4>>2]|0):0)){sb=142;break}if((f[tb+(qb*56|0)>>2]^f[pb+(hb*56|0)>>2])&4095|0){sb=144;break}f[w>>2]=0;f[Ra>>2]=O;ub=f[C>>2]|0;ob=f[D>>2]|0;vb=f[e>>2]|0;wb=f[I>>2]|0;wa=+p[Sa>>3];f[z>>2]=165004;f[Wa>>2]=pb+(hb*56|0);f[Xa>>2]=k;f[Ya>>2]=tb+(qb*56|0);f[Za>>2]=m;f[_a>>2]=K;f[$a>>2]=Q;f[ab>>2]=ea;f[Ta>>2]=ub;f[Ua>>2]=ob;f[Va>>2]=f[ua>>2];f[Va+4>>2]=f[ua+4>>2];f[Va+8>>2]=f[ua+8>>2];f[Va+12>>2]=f[ua+12>>2];f[bb>>2]=gb;f[cb>>2]=vb;f[db>>2]=wb;n[eb>>2]=wa;h3(w,z,-1.0);wb=f[ga>>2]|0;do if(wb|0){vb=wb+12|0;ob=f[vb>>2]|0;f[vb>>2]=ob+-1;if((ob|0)!=1)break;V$(k)}while(0);f[ga>>2]=0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[oa>>2]|0)>0){wb=f[sa>>2]|0;hb=0;do{f[wb+(hb<<2)>>2]=0;hb=hb+1|0}while((hb|0)<(f[oa>>2]|0))}hb=f[ra>>2]|0;if((hb|0)!=(pa|0))wL(hb);if((gb|0)>0)gb=gb+-1|0;else break a}if((sb|0)==142){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;gb=$Xc(80)|0;f[w>>2]=gb;f[w+8>>2]=-2147483568;f[w+4>>2]=68;L=gb;M=474502;N=L+68|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[gb+68>>0]=0;vM(-215,w,474953,473667,1363)}else if((sb|0)==144){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;pa=$Xc(80)|0;f[w>>2]=pa;f[w+8>>2]=-2147483568;f[w+4>>2]=68;L=pa;M=474571;N=L+68|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));b[pa+68>>0]=0;vM(-215,w,474953,473667,1364)}}while(0);w=v+36|0;M=f[w>>2]|0;do if(M|0){L=M+12|0;N=f[L>>2]|0;f[L>>2]=N+-1;if((N|0)!=1)break;V$(v)}while(0);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[va>>2]|0)>0){w=f[d>>2]|0;d=0;do{f[w+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[va>>2]|0))}va=f[x>>2]|0;if((va|0)!=(y|0))wL(va);hx(t);hx(s);s=r+36|0;t=f[s>>2]|0;do if(t|0){va=t+12|0;y=f[va>>2]|0;f[va>>2]=y+-1;if((y|0)!=1)break;V$(r)}while(0);f[s>>2]=0;s=r+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[H>>2]|0)>0){s=f[G>>2]|0;G=0;do{f[s+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[H>>2]|0))}H=f[R>>2]|0;if((H|0)!=(P|0))wL(H);H=q+36|0;P=f[H>>2]|0;do if(P|0){R=P+12|0;G=f[R>>2]|0;f[R>>2]=G+-1;if((G|0)!=1)break;V$(q)}while(0);f[H>>2]=0;H=q+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[H>>2]|0)>0){S=f[q+40>>2]|0;P=0;do{f[S+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[H>>2]|0))}H=f[T>>2]|0;if((H|0)!=(q+48|0))wL(H);H=o+36|0;q=f[H>>2]|0;do if(q|0){T=q+12|0;P=f[T>>2]|0;f[T>>2]=P+-1;if((P|0)!=1)break;V$(o)}while(0);f[H>>2]=0;H=o+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[H>>2]|0)>0){J=f[o+40>>2]|0;q=0;do{f[J+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[H>>2]|0))}H=f[E>>2]|0;if((H|0)!=(o+48|0))wL(H)}else{vS(g);vS(h);vS(i)}i=l+36|0;h=f[i>>2]|0;if(h|0?(g=h+12|0,h=f[g>>2]|0,f[g>>2]=h+-1,(h|0)==1):0)V$(l);f[i>>2]=0;i=l+16|0;h=l+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[h>>2]|0)>0){i=f[l+40>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[l+44>>2]|0;if((h|0)==(l+48|0)){u=j;return}wL(h);u=j;return}function YWb(a,b){a=a|0;b=b|0;f[a>>2]=f[b+4>>2];f[a+4>>2]=f[b+8>>2];return}function ZWb(a,b){a=a|0;b=b|0;f[a+4>>2]=f[b>>2];f[a+8>>2]=f[b+4>>2];return}function _Wb(a){a=a|0;return f[a+12>>2]|0}function $Wb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function aXb(a,b){a=a|0;b=b|0;var c=0;c=b+16|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];return}function bXb(a,b){a=a|0;b=b|0;var c=0;c=a+16|0;f[c>>2]=f[b>>2];f[c+4>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+12>>2]=f[b+12>>2];return}function cXb(a){a=a|0;return f[a+32>>2]|0}function dXb(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function eXb(a){a=a|0;return +(+p[a+40>>3])}function fXb(a,b){a=a|0;b=+b;p[a+40>>3]=b;return}function gXb(a){a=a|0;f[a>>2]=165024;qP(a+16|0);NXc(a);return}function hXb(a){a=a|0;f[a>>2]=165024;qP(a+16|0);NXc(a);cYc(a);return}function iXb(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function jXb(a){a=a|0;cYc(a);return}function kXb(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,q=0.0,r=0;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[j>>2]|0;o=f[j+4>>2]|0;q=+p[j+8>>3];j=$Xc(64)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=165024;r=j+16|0;yP(r);f[r>>2]=165052;f[j+20>>2]=m;f[j+24>>2]=n;f[j+28>>2]=i;f[j+32>>2]=h;f[j+36>>2]=o;p[j+40>>3]=q;f[j+48>>2]=k;p[j+56>>3]=l;XWb(r,a,b,c,d,e,g);UXc(j);return}function lXb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;var m=0,n=0;m=$Xc(64)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=165136;n=m+16|0;yP(n);f[n>>2]=165164;f[m+20>>2]=g;p[m+24>>3]=e;b[m+32>>0]=0;f[m+36>>2]=h;f[m+40>>2]=i;f[m+44>>2]=j;p[m+48>>3]=k;f[m+56>>2]=l;TXc(m);UXc(m);ei[f[(f[n>>2]|0)+32>>2]&511](n,a,c,d);UXc(m);return}function mXb(a){a=a|0;qP(a);cYc(a);return}function nXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0.0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0.0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0.0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0.0,td=0.0,ud=0.0,vd=0,wd=0.0,xd=0.0,yd=0.0,zd=0,Ad=0,Bd=0,Cd=0.0,Dd=0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0,Ud=0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0.0,fe=0,ge=0,he=0,ie=0,je=0;g=u;u=u+5968|0;h=g+1064|0;i=g+4896|0;j=g;k=g+3832|0;l=g+2760|0;m=g+2688|0;o=g+2632|0;q=g+2616|0;r=g+2552|0;s=g+2496|0;t=g+2440|0;v=g+3824|0;w=g+2384|0;x=g+2752|0;y=g+2744|0;z=g+2272|0;A=g+2216|0;B=g+2160|0;C=g+2624|0;D=g+2608|0;do if((eS(c)|0)==65536){E=f[c+4>>2]|0;f[m>>2]=f[E>>2];F=m+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=m+8|0;f[H>>2]=f[E+8>>2];f[m+12>>2]=f[E+12>>2];f[m+16>>2]=f[E+16>>2];f[m+20>>2]=f[E+20>>2];f[m+24>>2]=f[E+24>>2];f[m+28>>2]=f[E+28>>2];f[m+32>>2]=f[E+32>>2];I=f[E+36>>2]|0;f[m+36>>2]=I;f[m+40>>2]=H;H=m+48|0;J=m+44|0;f[J>>2]=H;f[H>>2]=0;f[m+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[F>>2]=0;U$(m,E);break}}else bS(m,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[o>>2]=f[c>>2];E=o+4|0;F=c+4|0;f[E>>2]=f[F>>2];G=o+8|0;f[G>>2]=f[c+8>>2];f[o+12>>2]=f[c+12>>2];f[o+16>>2]=f[c+16>>2];f[o+20>>2]=f[c+20>>2];f[o+24>>2]=f[c+24>>2];f[o+28>>2]=f[c+28>>2];f[o+32>>2]=f[c+32>>2];H=f[c+36>>2]|0;f[o+36>>2]=H;J=o+40|0;f[J>>2]=G;G=o+48|0;I=o+44|0;f[I>>2]=G;f[G>>2]=0;f[o+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[c+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];K=J;break}else{f[E>>2]=0;U$(o,c);K=J;break}}else{bS(o,d,-1);K=o+40|0}while(0);f[q>>2]=m;f[q+4>>2]=o;f[r>>2]=1124007936;d=r+4|0;J=r+8|0;c=r+40|0;E=d;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[c>>2]=J;G=r+48|0;I=r+44|0;f[I>>2]=G;f[G>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;H=s+4|0;L=s+8|0;M=s+40|0;E=H;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[M>>2]=L;N=s+48|0;O=s+44|0;f[O>>2]=N;f[N>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;P=t+4|0;Q=t+8|0;R=t+40|0;E=P;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[R>>2]=Q;Q=t+48|0;S=t+44|0;f[S>>2]=Q;f[Q>>2]=0;f[t+52>>2]=0;T=f[a+4>>2]|0;U=m+40|0;W=f[U>>2]|0;X=f[W+4>>2]|0;Z=f[W>>2]|0;W=f[K>>2]|0;if(!((Z|0)==(f[W>>2]|0)?(X|0)==(f[W+4>>2]|0):0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=$Xc(112)|0;f[h>>2]=_;$=h+8|0;f[$>>2]=-2147483536;aa=h+4|0;f[aa>>2]=110;E=_;ba=474842;F=E+110|0;do{b[E>>0]=b[ba>>0]|0;E=E+1|0;ba=ba+1|0}while((E|0)<(F|0));ca=_+110|0;b[ca>>0]=0;vM(-215,h,474953,474958,1114)}W=(f[m>>2]|0)>>>3&511;if(!((W|0)==0?(W|0)==((f[o>>2]|0)>>>3&511|0):0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=$Xc(112)|0;f[h>>2]=_;$=h+8|0;f[$>>2]=-2147483536;aa=h+4|0;f[aa>>2]=110;E=_;ba=474842;F=E+110|0;do{b[E>>0]=b[ba>>0]|0;E=E+1|0;ba=ba+1|0}while((E|0)<(F|0));ca=_+110|0;b[ca>>0]=0;vM(-215,h,474953,474958,1114)}W=a+8|0;if(!(+p[W>>3]<1.0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;_=$Xc(112)|0;f[h>>2]=_;$=h+8|0;f[$>>2]=-2147483536;aa=h+4|0;f[aa>>2]=110;E=_;ba=474842;F=E+110|0;do{b[E>>0]=b[ba>>0]|0;E=E+1|0;ba=ba+1|0}while((E|0)<(F|0));ca=_+110|0;b[ca>>0]=0;vM(-215,h,474953,474958,1114)}f[v>>2]=X;f[v+4>>2]=Z;wS(e,v,13,-1,0,0);do if((eS(e)|0)==65536){v=f[e+4>>2]|0;f[w>>2]=f[v>>2];Z=w+4|0;X=v+4|0;f[Z>>2]=f[X>>2];ca=w+8|0;f[ca>>2]=f[v+8>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];_=f[v+36>>2]|0;f[w+36>>2]=_;f[w+40>>2]=ca;ca=w+48|0;aa=w+44|0;f[aa>>2]=ca;f[ca>>2]=0;f[w+52>>2]=0;if(_|0){ca=_+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[X>>2]|0)<3){X=f[v+44>>2]|0;ca=f[aa>>2]|0;f[ca>>2]=f[X>>2];f[ca+4>>2]=f[X+4>>2];break}else{f[Z>>2]=0;U$(w,v);break}}else bS(w,e,-1);while(0);if((T|0)>0){da=+p[W>>3];ea=+(f[m+12>>2]|0);fa=+(f[m+8>>2]|0);ga=1.0;e=0;while(1){ga=ga*da;if(ga*ea<32.0|ga*fa<32.0){ha=e;break}v=e+1|0;if((v|0)>=(T|0)){ha=v;break}else e=v}if((ha|0)>-1){ia=ha;ja=30}else ka=w+36|0}else{ia=0;ja=30}a:do if((ja|0)==30){ha=m+12|0;e=m+8|0;T=s+12|0;v=s+16|0;Z=i+4|0;X=r+16|0;ca=a+40|0;aa=h+8|0;_=h+12|0;$=h+4|0;la=i+8|0;ma=i+4|0;na=x+4|0;oa=h+8|0;pa=h+4|0;qa=A+4|0;ra=A+8|0;sa=A+40|0;ta=A+48|0;ua=A+44|0;va=A+52|0;wa=B+4|0;xa=B+8|0;ya=B+40|0;za=B+48|0;Aa=B+44|0;Ba=B+52|0;Ca=h+8|0;Da=h+4|0;Ea=h+8|0;Fa=h+12|0;Ga=h+4|0;Ha=i+8|0;Ia=i+4|0;Ja=C+4|0;Ka=h+8|0;La=h+12|0;Ma=h+4|0;Na=i+8|0;Oa=i+4|0;Pa=D+4|0;Qa=a+28|0;Ra=a+32|0;Sa=A+12|0;Ta=k+8|0;Ua=k+4|0;Va=l+8|0;Wa=l+4|0;Xa=h+4|0;Ya=h+8|0;Za=h+40|0;_a=h+48|0;$a=h+44|0;ab=h+52|0;bb=i+8|0;cb=i+12|0;db=i+4|0;eb=h+16|0;fb=i+16|0;gb=i+44|0;hb=i+36|0;ib=i+4|0;jb=i+40|0;kb=i+48|0;lb=h+36|0;mb=A+16|0;nb=z+56|0;ob=a+24|0;pb=s+36|0;qb=r+36|0;rb=r+12|0;sb=s+20|0;tb=r+20|0;ub=s+24|0;vb=r+24|0;wb=s+28|0;xb=r+28|0;yb=s+32|0;zb=r+32|0;Ab=B+36|0;Bb=B+16|0;Cb=A+36|0;Db=a+20|0;Eb=h+8|0;Fb=h+4|0;Gb=h+8|0;Hb=h+4|0;Ib=i+8|0;Jb=i+4|0;Kb=Ib;Lb=j+8|0;Mb=j+4|0;Nb=k+8|0;Ob=k+4|0;Pb=h+8|0;Qb=h+12|0;Rb=h+4|0;Sb=i+8|0;Tb=i+4|0;Ub=y+4|0;Vb=h+8|0;Wb=h+4|0;Xb=w+36|0;Yb=w+4|0;Zb=w+8|0;_b=w+12|0;$b=w+44|0;ac=w+16|0;bc=w+20|0;cc=w+24|0;dc=w+28|0;ec=w+32|0;fc=z+4|0;gc=z+8|0;hc=z+40|0;ic=z+48|0;jc=z+44|0;kc=z+52|0;lc=z+56|0;mc=z+60|0;nc=z+64|0;oc=z+96|0;pc=z+104|0;qc=z+100|0;rc=z+108|0;sc=z+56|0;tc=z+92|0;uc=z+72|0;vc=z+60|0;wc=z+96|0;xc=z+100|0;yc=z+104|0;zc=z+36|0;Ac=z+16|0;Bc=z+4|0;Cc=z+40|0;Dc=z+44|0;Ec=z+48|0;Fc=ia;b:while(1){Gc=(Fc|0)>0;if(Gc){fa=+p[W>>3];Hc=0;ga=1.0;while(1){ea=ga*fa;Hc=Hc+1|0;if((Hc|0)==(Fc|0)){Ic=ea;break}else ga=ea}}else Ic=1.0;ga=(1.0/Ic+-1.0)*.5;Hc=zLc(ga*5.0)|0|1;Jc=(Hc|0)>3?Hc:3;Hc=zLc(Ic*+(f[ha>>2]|0))|0;Kc=zLc(Ic*+(f[e>>2]|0))|0;do if(Gc){if(((f[H>>2]|0)<3?(f[L>>2]|0)==(Kc|0):0)&(f[T>>2]|0)==(Hc|0)?!((f[v>>2]|0)==0?1:(f[s>>2]&4095|0)!=13):0)break;f[i>>2]=Kc;f[Z>>2]=Hc;S$(s,2,i,13)}else{Lc=f[Xb>>2]|0;if(Lc|0){Mc=Lc+12|0;f[Mc>>2]=(f[Mc>>2]|0)+1}Mc=f[pb>>2]|0;if(Mc|0?(Lc=Mc+12|0,Mc=f[Lc>>2]|0,f[Lc>>2]=Mc+-1,(Mc|0)==1):0)V$(s);f[pb>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[H>>2]|0)>0){Mc=f[M>>2]|0;Lc=0;do{f[Mc+(Lc<<2)>>2]=0;Lc=Lc+1|0;Nc=f[H>>2]|0}while((Lc|0)<(Nc|0));f[s>>2]=f[w>>2];if((Nc|0)<3)ja=50;else ja=52}else{f[s>>2]=f[w>>2];ja=50}if((ja|0)==50){ja=0;Lc=f[Yb>>2]|0;if((Lc|0)<3){f[H>>2]=Lc;f[L>>2]=f[Zb>>2];f[T>>2]=f[_b>>2];Lc=f[$b>>2]|0;Mc=f[O>>2]|0;f[Mc>>2]=f[Lc>>2];f[Mc+4>>2]=f[Lc+4>>2]}else ja=52}if((ja|0)==52){ja=0;U$(s,w)}f[v>>2]=f[ac>>2];f[sb>>2]=f[bc>>2];f[ub>>2]=f[cc>>2];f[wb>>2]=f[dc>>2];f[yb>>2]=f[ec>>2];f[pb>>2]=f[Xb>>2]}while(0);if(f[X>>2]|0){Lc=f[d>>2]|0;if((Lc|0)<3)Oc=Y(f[rb>>2]|0,f[J>>2]|0)|0;else{Mc=f[c>>2]|0;Pc=0;Qc=1;while(1){Rc=Y(f[Mc+(Pc<<2)>>2]|0,Qc)|0;Pc=Pc+1|0;if((Pc|0)==(Lc|0)){Oc=Rc;break}else Qc=Rc}}if(!((Lc|0)==0|(Oc|0)==0)){f[Pb>>2]=0;f[Qb>>2]=0;f[h>>2]=16842752;f[Rb>>2]=r;Qc=Sb;f[Qc>>2]=0;f[Qc+4>>2]=0;f[i>>2]=33619968;f[Tb>>2]=s;f[y>>2]=Hc;f[Ub>>2]=Kc;Zna(h,i,y,0.0,0.0,1);fa=1.0/+p[W>>3];Qc=Vb;f[Qc>>2]=0;f[Qc+4>>2]=0;f[h>>2]=33619968;f[Wb>>2]=s;dY(s,h,-1,fa,0.0)}else ja=60}else ja=60;do if((ja|0)==60){ja=0;if(!(f[ca>>2]&4)){p$(h,Kc,Hc,13);Qc=f[h>>2]|0;ei[f[(f[Qc>>2]|0)+12>>2]&511](Qc,h,s,-1);Zj(h);break}else{f[aa>>2]=0;f[_>>2]=0;f[h>>2]=16842752;f[$>>2]=w;Qc=la;f[Qc>>2]=0;f[Qc+4>>2]=0;f[i>>2]=33619968;f[ma>>2]=s;f[x>>2]=Hc;f[na>>2]=Kc;Zna(h,i,x,0.0,0.0,3);Qc=oa;f[Qc>>2]=0;f[Qc+4>>2]=0;f[h>>2]=33619968;f[pa>>2]=s;dY(s,h,-1,Ic,0.0);break}}while(0);f[z>>2]=1124007936;E=fc;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[hc>>2]=gc;f[jc>>2]=ic;f[ic>>2]=0;f[kc>>2]=0;f[lc>>2]=1124007936;E=mc;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[oc>>2]=nc;f[qc>>2]=pc;f[pc>>2]=0;f[rc>>2]=0;f[A>>2]=1124007936;E=qa;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[sa>>2]=ra;f[ua>>2]=ta;f[ta>>2]=0;f[va>>2]=0;f[B>>2]=1124007936;E=wa;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[ya>>2]=xa;f[Aa>>2]=za;f[za>>2]=0;f[Ba>>2]=0;Lc=0;do{Qc=f[q+(Lc<<2)>>2]|0;Pc=Ca;f[Pc>>2]=0;f[Pc+4>>2]=0;f[h>>2]=33619968;f[Da>>2]=t;dY(Qc,h,5,1.0,0.0);f[Ea>>2]=0;f[Fa>>2]=0;f[h>>2]=16842752;f[Ga>>2]=t;Qc=Ha;f[Qc>>2]=0;f[Qc+4>>2]=0;f[i>>2]=33619968;f[Ia>>2]=t;f[C>>2]=Jc;f[Ja>>2]=Jc;Jqa(h,i,C,ga,ga,4);f[Ka>>2]=0;f[La>>2]=0;f[h>>2]=16842752;f[Ma>>2]=t;Qc=Na;f[Qc>>2]=0;f[Qc+4>>2]=0;f[i>>2]=33619968;f[Oa>>2]=A;f[D>>2]=Hc;f[Pa>>2]=Kc;Zna(h,i,D,1.0,0.0,1);Qc=z+(Lc*56|0)|0;Pc=f[Qa>>2]|0;fa=+p[Ra>>3];if((f[A>>2]&4095|0)!=5)break b;Mc=f[Sa>>2]|0;Rc=f[ra>>2]|0;Sc=(Pc*6|0)+3|0;f[k>>2]=Ta;f[Ua>>2]=Sc;if(Sc>>>0>264){Tc=bYc(Sc>>>0>1073741823?-1:Sc<<2)|0;f[k>>2]=Tc;Uc=Tc}else Uc=Ta;Tc=Pc<<1;Sc=(Mc+Tc|0)*3|0;f[l>>2]=Va;f[Wa>>2]=Sc;if(Sc>>>0>264){Vc=bYc(Sc>>>0>1073741823?-1:Sc<<2)|0;f[l>>2]=Vc;Wc=Vc}else Wc=Va;Vc=Uc+(Pc<<2)|0;Sc=Vc+(Tc<<2)+4|0;Xc=Sc+(Tc<<2)+4|0;Tc=Pc*3|0;Yc=Wc+(Tc<<2)|0;ea=fa<1.1920928955078125e-07?+(Pc|0)*.3:fa;Zc=0-Pc|0;_c=(Pc|0)<(Zc|0);if(!_c){fa=ea*(ea*2.0);$c=Zc;ea=0.0;while(1){da=+V(+(+(Y($c,0-$c|0)|0)/fa));n[Vc+($c<<2)>>2]=da;ea=ea+da;if(($c|0)>=(Pc|0))break;else $c=$c+1|0}fa=1.0/ea;$c=Zc;while(1){ad=Vc+($c<<2)|0;da=fa*+n[ad>>2];n[ad>>2]=da;n[Sc+($c<<2)>>2]=+($c|0)*da;bd=+(Y($c,$c)|0)*da;n[Xc+($c<<2)>>2]=bd;if(($c|0)<(Pc|0))$c=$c+1|0;else break}}f[h>>2]=1124007936;E=Xa;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[Za>>2]=Ya;f[$a>>2]=_a;f[_a>>2]=0;f[ab>>2]=0;f[i>>2]=6;f[Z>>2]=6;S$(h,2,i,6);p[j>>3]=0.0;f[i>>2]=-1056833530;f[db>>2]=j;f[bb>>2]=1;f[cb>>2]=1;mR(h,i,fT()|0)|0;if(_c){$c=f[eb>>2]|0;cd=$c;dd=$c}else{$c=f[eb>>2]|0;ad=f[f[$a>>2]>>2]|0;ed=$c+ad+8|0;fd=$c+(ad*3|0)+24|0;gd=$c+(ad*5|0)+40|0;ad=Zc;while(1){fa=+n[Vc+(ad<<2)>>2];ea=+(ad|0);hd=Zc;while(1){bd=fa*+n[Vc+(hd<<2)>>2];p[$c>>3]=+p[$c>>3]+bd;da=+(hd|0);id=da*(da*bd);p[ed>>3]=+p[ed>>3]+id;p[fd>>3]=+p[fd>>3]+da*(da*id);p[gd>>3]=ea*(ea*id)+ +p[gd>>3];if((hd|0)<(Pc|0))hd=hd+1|0;else break}if((ad|0)<(Pc|0))ad=ad+1|0;else{cd=$c;dd=$c;break}}}$c=f[f[$a>>2]>>2]|0;ea=+p[cd+$c+8>>3];ad=cd+($c<<2)|0;p[ad>>3]=ea;gd=cd+($c*3|0)|0;p[gd>>3]=ea;p[dd+32>>3]=ea;p[dd+24>>3]=ea;p[dd+($c<<1)+16>>3]=ea;p[ad+32>>3]=+p[gd+24>>3];ea=+p[cd+($c*5|0)+40>>3];p[ad+24>>3]=ea;p[gd+32>>3]=ea;n$(j,h,3);FXb(i,j);Zj(j);gd=f[fb>>2]|0;ad=f[f[gb>>2]>>2]|0;ea=+p[gd+ad+8>>3];fa=+p[gd+24>>3];id=+p[gd+(ad*3|0)+24>>3];da=+p[gd+(ad*5|0)+40>>3];ad=f[hb>>2]|0;do if(ad|0){gd=ad+12|0;$c=f[gd>>2]|0;f[gd>>2]=$c+-1;if(($c|0)!=1)break;V$(i)}while(0);f[hb>>2]=0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[ib>>2]|0)>0){ad=f[jb>>2]|0;$c=0;do{f[ad+($c<<2)>>2]=0;$c=$c+1|0}while(($c|0)<(f[ib>>2]|0))}$c=f[gb>>2]|0;if(($c|0)!=(kb|0))wL($c);$c=f[lb>>2]|0;do if($c|0){ad=$c+12|0;gd=f[ad>>2]|0;f[ad>>2]=gd+-1;if((gd|0)!=1)break;V$(h)}while(0);f[lb>>2]=0;f[eb>>2]=0;f[eb+4>>2]=0;f[eb+8>>2]=0;f[eb+12>>2]=0;if((f[Xa>>2]|0)>0){$c=f[Za>>2]|0;gd=0;do{f[$c+(gd<<2)>>2]=0;gd=gd+1|0}while((gd|0)<(f[Xa>>2]|0))}gd=f[$a>>2]|0;if((gd|0)!=(_a|0))wL(gd);do if((f[z+(Lc*56|0)+4>>2]|0)<3){if((f[z+(Lc*56|0)+8>>2]|0)!=(Rc|0)){ja=103;break}if((f[z+(Lc*56|0)+12>>2]|0)!=(Mc|0)){ja=103;break}if((f[Qc>>2]&4095|0)!=37){ja=103;break}if(!(f[z+(Lc*56|0)+16>>2]|0))ja=103}else ja=103;while(0);if((ja|0)==103){ja=0;f[i>>2]=Rc;f[Z>>2]=Mc;S$(Qc,2,i,37)}if((Rc|0)>0){gd=f[mb>>2]|0;$c=f[f[ua>>2]>>2]|0;ad=f[z+(Lc*56|0)+16>>2]|0;fd=f[f[z+(Lc*56|0)+44>>2]>>2]|0;ed=(Mc|0)>0;Zc=(Pc|0)<1;_c=(Pc|0)>0;hd=Mc*3|0;jd=Rc+-1|0;kd=Pc+1|0;ld=Zc|ed^1;md=0;do{bd=+n[Vc>>2];nd=gd+(Y(md,$c)|0)|0;od=ad+(Y(md,fd)|0)|0;do if(ed){pd=0;do{qd=pd*3|0;n[Yc+(qd<<2)>>2]=bd*+n[nd+(pd<<2)>>2];n[Yc+(qd+2<<2)>>2]=0.0;n[Yc+(qd+1<<2)>>2]=0.0;pd=pd+1|0}while((pd|0)!=(Mc|0));if(ld)break;else rd=1;do{sd=+n[Vc+(rd<<2)>>2];td=+n[Sc+(rd<<2)>>2];ud=+n[Xc+(rd<<2)>>2];pd=md-rd|0;qd=gd+(Y((pd|0)>0?pd:0,$c)|0)|0;pd=rd+md|0;vd=gd+(Y((jd|0)<(pd|0)?jd:pd,$c)|0)|0;pd=0;do{wd=+n[qd+(pd<<2)>>2];xd=+n[vd+(pd<<2)>>2];yd=wd+xd;zd=pd*3|0;Ad=Yc+(zd<<2)|0;Bd=Yc+(zd+1<<2)|0;Cd=+n[Bd>>2]+td*(xd-wd);Dd=Yc+(zd+2<<2)|0;wd=ud*yd+ +n[Dd>>2];n[Ad>>2]=+n[Ad>>2]+sd*yd;n[Bd>>2]=Cd;n[Dd>>2]=wd;pd=pd+1|0}while((pd|0)!=(Mc|0));rd=rd+1|0}while((rd|0)!=(kd|0))}while(0);if(_c){nd=0;do{f[Yc+(~nd<<2)>>2]=f[Yc+(2-nd<<2)>>2];pd=nd+hd|0;f[Yc+(pd<<2)>>2]=f[Yc+(pd+-3<<2)>>2];nd=nd+1|0}while((nd|0)<(Tc|0))}c:do if(ed){nd=0;sd=bd;while(1){pd=nd*3|0;ud=sd*+n[Yc+(pd<<2)>>2];td=sd*+n[Yc+(pd+1<<2)>>2];wd=sd*+n[Yc+(pd+2<<2)>>2];if(Zc){Ed=0.0;Fd=wd;Gd=0.0;Hd=td;Id=0.0;Jd=ud}else{Cd=0.0;yd=wd;wd=0.0;xd=td;td=0.0;Kd=ud;pd=1;while(1){vd=(pd+nd|0)*3|0;ud=+n[Yc+(vd<<2)>>2];qd=(nd-pd|0)*3|0;Ld=+n[Yc+(qd<<2)>>2];Md=ud+Ld;Nd=+n[Vc+(pd<<2)>>2];Od=Kd+Md*Nd;Pd=wd+Md*+n[Xc+(pd<<2)>>2];Md=+n[Sc+(pd<<2)>>2];Qd=td+(ud-Ld)*Md;Ld=+n[Yc+(vd+1<<2)>>2];ud=+n[Yc+(qd+1<<2)>>2];Rd=xd+Nd*(Ld+ud);Sd=Cd+Md*(Ld-ud);ud=yd+Nd*(+n[Yc+(vd+2<<2)>>2]+ +n[Yc+(qd+2<<2)>>2]);pd=pd+1|0;if((pd|0)==(kd|0)){Ed=Sd;Fd=ud;Gd=Pd;Hd=Rd;Id=Qd;Jd=Od;break}else{Cd=Sd;yd=ud;wd=Pd;xd=Rd;td=Qd;Kd=Od}}}pd=nd*5|0;n[od+(pd+1<<2)>>2]=ea*Id;n[od+(pd<<2)>>2]=ea*Hd;Kd=fa*Jd;n[od+(pd+3<<2)>>2]=Kd+id*Gd;n[od+(pd+2<<2)>>2]=Kd+id*Fd;n[od+(pd+4<<2)>>2]=da*Ed;pd=nd+1|0;if((pd|0)==(Mc|0))break c;nd=pd;sd=+n[Vc>>2]}}while(0);md=md+1|0}while((md|0)!=(Rc|0))}Rc=f[l>>2]|0;if((Rc|0)!=(Va|0)){if(Rc|0)dYc(Rc);f[l>>2]=Va;f[Wa>>2]=264}Rc=f[k>>2]|0;if((Rc|0)!=(Ta|0)){if(Rc|0)dYc(Rc);f[k>>2]=Ta;f[Ua>>2]=264}Lc=Lc+1|0}while((Lc|0)<2);GXb(z,nb,s,B,0,f[L>>2]|0);Lc=f[ob>>2]|0;if((Lc|0)>0){Kc=0;Hc=Lc;do{Lc=f[Db>>2]|0;Jc=(Kc|0)<(Hc+-1|0);Rc=f[T>>2]|0;md=f[L>>2]|0;Vc=(Lc|0)/2|0;Mc=1024/(Rc|0)|0;kd=(Mc|0)<(Lc|0)?Lc:Mc;if(!(f[ca>>2]&256)){ga=1.0/+(Y(Lc,Lc)|0);Mc=(((Vc<<1)+Rc|0)*5|0)+10|0;f[h>>2]=Eb;f[Fb>>2]=Mc;if(Mc>>>0>136){Yc=bYc(Mc>>>0>536870911?-1:Mc<<3)|0;f[h>>2]=Yc;Td=Yc}else Td=Eb;Yc=(Vc*5|0)+5|0;Mc=Td+(Yc<<3)|0;Sc=f[Bb>>2]|0;Xc=Rc*5|0;Zc=(Rc|0)>0;if(Zc){da=+(Vc+2|0);ed=0;do{p[Mc+(ed<<3)>>3]=da*+n[Sc+(ed<<2)>>2];ed=ed+1|0}while((ed|0)<(Xc|0))}ed=(Lc|0)>3;do if(ed){Tc=md+-1|0;hd=f[f[Aa>>2]>>2]|0;if(Zc)Ud=1;else break;do{_c=Sc+(Y((Tc|0)<(Ud|0)?Tc:Ud,hd)|0)|0;$c=0;do{jd=Mc+($c<<3)|0;p[jd>>3]=+p[jd>>3]+ +n[_c+($c<<2)>>2];$c=$c+1|0}while(($c|0)<(Xc|0));Ud=Ud+1|0}while((Ud|0)<(Vc|0))}while(0);if((md|0)>0){hd=md+-1|0;Tc=(Yc|0)>0;da=+(Vc+2|0);$c=Mc+8|0;_c=Mc+16|0;jd=Mc+24|0;gd=Mc+32|0;ld=0;fd=Sc;ad=0;while(1){Pc=(f[v>>2]|0)+(Y(f[f[O>>2]>>2]|0,ad)|0)|0;Qc=ad-Vc+-1|0;od=f[f[Aa>>2]>>2]|0;nd=fd+(Y(od,(Qc|0)>0?Qc:0)|0)|0;Qc=ad+Vc|0;pd=fd+(Y(od,(hd|0)<(Qc|0)?hd:Qc)|0)|0;if(Zc){Qc=0;do{od=Mc+(Qc<<3)|0;p[od>>3]=+p[od>>3]+(+n[pd+(Qc<<2)>>2]-+n[nd+(Qc<<2)>>2]);Qc=Qc+1|0}while((Qc|0)<(Xc|0))}if(Tc){Qc=0;do{p[Mc+(~Qc<<3)>>3]=+p[Mc+(4-Qc<<3)>>3];nd=Qc+Xc|0;p[Mc+(nd<<3)>>3]=+p[Mc+(nd+-5<<3)>>3];Qc=Qc+1|0}while((Qc|0)!=(Yc|0))}id=da*+p[Mc>>3];fa=da*+p[$c>>3];ea=da*+p[_c>>3];bd=da*+p[jd>>3];sd=da*+p[gd>>3];if(ed){Kd=id;td=fa;xd=ea;wd=sd;yd=bd;Qc=1;while(1){nd=Qc*5|0;Cd=Kd+ +p[Mc+(nd<<3)>>3];Od=td+ +p[Mc+(nd+1<<3)>>3];Qd=xd+ +p[Mc+(nd+2<<3)>>3];Rd=yd+ +p[Mc+(nd+3<<3)>>3];Pd=wd+ +p[Mc+(nd+4<<3)>>3];Qc=Qc+1|0;if((Qc|0)>=(Vc|0)){Vd=Cd;Wd=Od;Xd=Qd;Yd=Pd;Zd=Rd;break}else{Kd=Cd;td=Od;xd=Qd;wd=Pd;yd=Rd}}}else{Vd=id;Wd=fa;Xd=ea;Yd=sd;Zd=bd}if(Zc){yd=Vd;wd=Wd;xd=Xd;td=Yd;Kd=Zd;Qc=0;do{nd=(Qc+Vc|0)*5|0;pd=(Qc-Vc|0)*5|0;yd=yd+(+p[Mc+(nd<<3)>>3]-+p[Mc+(pd+-5<<3)>>3]);wd=wd+(+p[Mc+(nd+1<<3)>>3]-+p[Mc+(pd+-4<<3)>>3]);xd=xd+(+p[Mc+(nd+2<<3)>>3]-+p[Mc+(pd+-3<<3)>>3]);Kd=Kd+(+p[Mc+(nd+3<<3)>>3]-+p[Mc+(pd+-2<<3)>>3]);td=td+(+p[Mc+(nd+4<<3)>>3]-+p[Mc+(pd+-1<<3)>>3]);Rd=ga*yd;Pd=ga*wd;Qd=ga*xd;Od=ga*Kd;Cd=ga*td;ud=1.0/(Rd*Qd-Pd*Pd+.001);pd=Qc<<1;n[Pc+(pd<<2)>>2]=ud*(Rd*Cd-Pd*Od);n[Pc+((pd|1)<<2)>>2]=ud*(Qd*Od-Pd*Cd);Qc=Qc+1|0}while((Qc|0)!=(Rc|0))}Qc=(ad|0)==(hd|0)?md:ad-Lc|0;do if(Jc){if((Qc|0)!=(md|0)&(Qc|0)<(ld+kd|0)){_d=ld;break}GXb(z,nb,s,B,ld,Qc);_d=Qc}else _d=ld;while(0);Qc=ad+1|0;if((Qc|0)>=(md|0))break;ld=_d;fd=f[Bb>>2]|0;ad=Qc}$d=f[h>>2]|0}else $d=Td;if(($d|0)!=(Eb|0)){if($d|0)dYc($d);f[h>>2]=Eb;f[Fb>>2]=136}}else{ga=+(Vc|0)*.3;ad=Vc<<1;fd=((ad+Rc|0)*5|0)+26|0;f[h>>2]=Gb;f[Hb>>2]=fd;if(fd>>>0>264){ld=bYc(fd>>>0>1073741823?-1:fd<<2)|0;f[h>>2]=ld;ae=ld}else ae=Gb;ld=Rc*5|0;fd=ld+16|0;f[i>>2]=Ib;f[Jb>>2]=fd;if(fd>>>0>264){hd=bYc(fd>>>0>1073741823?-1:fd<<2)|0;f[i>>2]=hd;be=hd}else be=Kb;hd=Vc*5|0;fd=hd+21|0;f[j>>2]=Lb;f[Mb>>2]=fd;if(fd>>>0>264){Mc=bYc(fd>>>0>1073741823?-1:fd<<2)|0;f[j>>2]=Mc;ce=Mc}else ce=Lb;Mc=ad|1;f[k>>2]=Nb;f[Ob>>2]=Mc;if(Mc>>>0>264){ad=bYc(Mc>>>0>1073741823?-1:Mc<<2)|0;f[k>>2]=ad;de=ad}else de=Nb;ad=ae+(hd+5<<2)+15&-16;Mc=be+15&-16;n[ce>>2]=1.0;fd=(Lc|0)<2;if(fd)ee=1.0;else{da=ga*(ga*2.0);Zc=1;ga=1.0;while(1){td=+V(+(+(Y(Zc,0-Zc|0)|0)/da));n[ce+(Zc<<2)>>2]=td;Kd=ga+td*2.0;if((Zc|0)<(Vc|0)){Zc=Zc+1|0;ga=Kd}else{ee=Kd;break}}}ga=1.0/ee;Zc=(Lc|0)<-1;if(!Zc){ed=0;while(1){gd=ce+(ed<<2)|0;n[gd>>2]=ga*+n[gd>>2];if((ed|0)<(Vc|0))ed=ed+1|0;else break}}if((md|0)>0){ed=(Rc|0)>0;gd=de+(Vc<<2)|0;jd=(hd|0)>0;_c=md+-1|0;$c=0;Yc=0;while(1){Xc=(f[v>>2]|0)+(Y(f[f[O>>2]>>2]|0,$c)|0)|0;if(!Zc){Tc=f[Bb>>2]|0;Sc=f[f[Aa>>2]>>2]|0;Qc=0;while(1){Pc=$c-Qc|0;pd=Tc+(Y((Pc|0)>0?Pc:0,Sc)|0)|0;f[de+(Vc-Qc<<2)>>2]=pd;pd=Qc+$c|0;Pc=Tc+(Y((_c|0)<(pd|0)?_c:pd,Sc)|0)|0;f[de+(Qc+Vc<<2)>>2]=Pc;if((Vc|0)>(Qc|0))Qc=Qc+1|0;else break}}d:do if(ed){Qc=f[gd>>2]|0;if(fd){Sc=0;while(1){n[ad+(Sc<<2)>>2]=+n[Qc+(Sc<<2)>>2]*+n[ce>>2];Sc=Sc+1|0;if((Sc|0)>=(ld|0))break d}}else fe=0;do{ga=+n[Qc+(fe<<2)>>2]*+n[ce>>2];Sc=1;while(1){ga=ga+(+n[(f[de+(Sc+Vc<<2)>>2]|0)+(fe<<2)>>2]+ +n[(f[de+(Vc-Sc<<2)>>2]|0)+(fe<<2)>>2])*+n[ce+(Sc<<2)>>2];if((Vc|0)<=(Sc|0))break;else Sc=Sc+1|0}n[ad+(fe<<2)>>2]=ga;fe=fe+1|0}while((fe|0)<(ld|0))}while(0);if(jd){Qc=0;do{f[ad+(~Qc<<2)>>2]=f[ad+(4-Qc<<2)>>2];Sc=Qc+ld|0;f[ad+(Sc<<2)>>2]=f[ad+(Sc+-5<<2)>>2];Qc=Qc+1|0}while((Qc|0)!=(hd|0))}if(ed){if(fd){Qc=0;do{n[Mc+(Qc<<2)>>2]=+n[ad+(Qc<<2)>>2]*+n[ce>>2];Qc=Qc+1|0}while((Qc|0)<(ld|0));ge=0}else{Qc=0;do{da=+n[ad+(Qc<<2)>>2]*+n[ce>>2];Sc=1;while(1){Tc=Sc*5|0;da=da+ +n[ce+(Sc<<2)>>2]*(+n[ad+(Qc-Tc<<2)>>2]+ +n[ad+(Tc+Qc<<2)>>2]);if((Sc|0)>=(Vc|0))break;else Sc=Sc+1|0}n[Mc+(Qc<<2)>>2]=da;Qc=Qc+1|0}while((Qc|0)<(ld|0));ge=0}do{Qc=ge*5|0;Kd=+n[Mc+(Qc<<2)>>2];td=+n[Mc+(Qc+1<<2)>>2];xd=+n[Mc+(Qc+2<<2)>>2];wd=+n[Mc+(Qc+3<<2)>>2];yd=+n[Mc+(Qc+4<<2)>>2];bd=1.0/(Kd*xd-td*td+.001);Qc=ge<<1;n[Xc+(Qc<<2)>>2]=(Kd*yd-td*wd)*bd;n[Xc+((Qc|1)<<2)>>2]=(xd*wd-td*yd)*bd;ge=ge+1|0}while((ge|0)!=(Rc|0))}Xc=($c|0)==(_c|0)?md:$c-Lc|0;do if(Jc){if((Xc|0)!=(md|0)&(Xc|0)<(Yc+kd|0)){he=Yc;break}GXb(z,nb,s,B,Yc,Xc);he=Xc}else he=Yc;while(0);$c=$c+1|0;if(($c|0)>=(md|0))break;else Yc=he}ie=f[k>>2]|0}else ie=de;if((ie|0)!=(Nb|0)){if(ie|0)dYc(ie);f[k>>2]=Nb;f[Ob>>2]=264}Yc=f[j>>2]|0;if((Yc|0)!=(Lb|0)){if(Yc|0)dYc(Yc);f[j>>2]=Lb;f[Mb>>2]=264}Yc=f[i>>2]|0;if((Yc|0)!=(Ib|0)){if(Yc|0)dYc(Yc);f[i>>2]=Ib;f[Jb>>2]=264}Yc=f[h>>2]|0;if((Yc|0)!=(Gb|0)){if(Yc|0)dYc(Yc);f[h>>2]=Gb;f[Hb>>2]=264}}Kc=Kc+1|0;Hc=f[ob>>2]|0}while((Kc|0)<(Hc|0))}Hc=f[pb>>2]|0;if(Hc|0){Kc=Hc+12|0;f[Kc>>2]=(f[Kc>>2]|0)+1}Kc=f[qb>>2]|0;if(Kc|0?(Hc=Kc+12|0,Kc=f[Hc>>2]|0,f[Hc>>2]=Kc+-1,(Kc|0)==1):0)V$(r);f[qb>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[d>>2]|0)>0){Kc=f[c>>2]|0;Hc=0;do{f[Kc+(Hc<<2)>>2]=0;Hc=Hc+1|0;je=f[d>>2]|0}while((Hc|0)<(je|0));f[r>>2]=f[s>>2];if((je|0)<3)ja=228;else ja=230}else{f[r>>2]=f[s>>2];ja=228}if((ja|0)==228){ja=0;Hc=f[H>>2]|0;if((Hc|0)<3){f[d>>2]=Hc;f[J>>2]=f[L>>2];f[rb>>2]=f[T>>2];Hc=f[O>>2]|0;Kc=f[I>>2]|0;f[Kc>>2]=f[Hc>>2];f[Kc+4>>2]=f[Hc+4>>2]}else ja=230}if((ja|0)==230){ja=0;U$(r,s)}f[X>>2]=f[v>>2];f[tb>>2]=f[sb>>2];f[vb>>2]=f[ub>>2];f[xb>>2]=f[wb>>2];f[zb>>2]=f[yb>>2];f[qb>>2]=f[pb>>2];Hc=f[Ab>>2]|0;if(Hc|0?(Kc=Hc+12|0,Hc=f[Kc>>2]|0,f[Kc>>2]=Hc+-1,(Hc|0)==1):0)V$(B);f[Ab>>2]=0;f[Bb>>2]=0;f[Bb+4>>2]=0;f[Bb+8>>2]=0;f[Bb+12>>2]=0;if((f[wa>>2]|0)>0){Hc=f[ya>>2]|0;Kc=0;do{f[Hc+(Kc<<2)>>2]=0;Kc=Kc+1|0}while((Kc|0)<(f[wa>>2]|0))}Kc=f[Aa>>2]|0;if((Kc|0)!=(za|0))wL(Kc);Kc=f[Cb>>2]|0;do if(Kc|0){Hc=Kc+12|0;Yc=f[Hc>>2]|0;f[Hc>>2]=Yc+-1;if((Yc|0)!=1)break;V$(A)}while(0);f[Cb>>2]=0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[qa>>2]|0)>0){Kc=f[sa>>2]|0;Yc=0;do{f[Kc+(Yc<<2)>>2]=0;Yc=Yc+1|0}while((Yc|0)<(f[qa>>2]|0))}Yc=f[ua>>2]|0;if((Yc|0)!=(ta|0))wL(Yc);Yc=f[tc>>2]|0;do if(Yc|0){Kc=Yc+12|0;Hc=f[Kc>>2]|0;f[Kc>>2]=Hc+-1;if((Hc|0)!=1)break;V$(sc)}while(0);f[tc>>2]=0;f[uc>>2]=0;f[uc+4>>2]=0;f[uc+8>>2]=0;f[uc+12>>2]=0;if((f[vc>>2]|0)>0){Yc=f[wc>>2]|0;Hc=0;do{f[Yc+(Hc<<2)>>2]=0;Hc=Hc+1|0}while((Hc|0)<(f[vc>>2]|0))}Hc=f[xc>>2]|0;if((Hc|0)!=(yc|0))wL(Hc);Hc=f[zc>>2]|0;do if(Hc|0){Yc=Hc+12|0;Kc=f[Yc>>2]|0;f[Yc>>2]=Kc+-1;if((Kc|0)!=1)break;V$(z)}while(0);f[zc>>2]=0;f[Ac>>2]=0;f[Ac+4>>2]=0;f[Ac+8>>2]=0;f[Ac+12>>2]=0;if((f[Bc>>2]|0)>0){Hc=f[Cc>>2]|0;Kc=0;do{f[Hc+(Kc<<2)>>2]=0;Kc=Kc+1|0}while((Kc|0)<(f[Bc>>2]|0))}Kc=f[Dc>>2]|0;if((Kc|0)!=(Ec|0))wL(Kc);if(Gc)Fc=Fc+-1|0;else{ka=Xb;break a}}Xb=$Xc(32)|0;f[h>>2]=Xb;f[h+8>>2]=-2147483616;f[h+4>>2]=22;E=Xb;ba=475030;F=E+22|0;do{b[E>>0]=b[ba>>0]|0;E=E+1|0;ba=ba+1|0}while((E|0)<(F|0));b[Xb+22>>0]=0;vM(-215,h,475053,474958,120)}while(0);h=f[ka>>2]|0;if(h|0?(ba=h+12|0,h=f[ba>>2]|0,f[ba>>2]=h+-1,(h|0)==1):0)V$(w);f[ka>>2]=0;ka=w+16|0;h=w+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[h>>2]|0)>0){ka=f[w+40>>2]|0;ba=0;do{f[ka+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[h>>2]|0))}h=f[w+44>>2]|0;if((h|0)!=(w+48|0))wL(h);h=t+36|0;w=f[h>>2]|0;if(w|0?(ba=w+12|0,w=f[ba>>2]|0,f[ba>>2]=w+-1,(w|0)==1):0)V$(t);f[h>>2]=0;h=t+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[P>>2]|0)>0){h=f[R>>2]|0;R=0;do{f[h+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[P>>2]|0))}P=f[S>>2]|0;if((P|0)!=(Q|0))wL(P);P=s+36|0;Q=f[P>>2]|0;if(Q|0?(S=Q+12|0,Q=f[S>>2]|0,f[S>>2]=Q+-1,(Q|0)==1):0)V$(s);f[P>>2]=0;P=s+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[H>>2]|0)>0){P=f[M>>2]|0;M=0;do{f[P+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[H>>2]|0))}H=f[O>>2]|0;if((H|0)!=(N|0))wL(H);H=r+36|0;N=f[H>>2]|0;if(N|0?(O=N+12|0,N=f[O>>2]|0,f[O>>2]=N+-1,(N|0)==1):0)V$(r);f[H>>2]=0;H=r+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[d>>2]|0)>0){H=f[c>>2]|0;c=0;do{f[H+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[I>>2]|0;if((d|0)!=(G|0))wL(d);d=o+36|0;G=f[d>>2]|0;do if(G|0){I=G+12|0;c=f[I>>2]|0;f[I>>2]=c+-1;if((c|0)!=1)break;V$(o)}while(0);f[d>>2]=0;d=o+16|0;G=o+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[G>>2]|0)>0){d=f[K>>2]|0;K=0;do{f[d+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[G>>2]|0))}G=f[o+44>>2]|0;if((G|0)!=(o+48|0))wL(G);G=m+36|0;o=f[G>>2]|0;do if(o|0){K=o+12|0;d=f[K>>2]|0;f[K>>2]=d+-1;if((d|0)!=1)break;V$(m)}while(0);f[G>>2]=0;G=m+16|0;o=m+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[o>>2]|0)>0){G=f[U>>2]|0;U=0;do{f[G+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)==(m+48|0)){u=g;return}wL(o);u=g;return}function oXb(a){a=a|0;return}function pXb(a){a=a|0;return f[a+4>>2]|0}function qXb(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function rXb(a){a=a|0;return +(+p[a+8>>3])}function sXb(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function tXb(a){a=a|0;return (b[a+16>>0]|0)!=0|0}function uXb(a,c){a=a|0;c=c|0;b[a+16>>0]=c&1;return}function vXb(a){a=a|0;return f[a+20>>2]|0}function wXb(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function xXb(a){a=a|0;return f[a+24>>2]|0}function yXb(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function zXb(a){a=a|0;return f[a+28>>2]|0}function AXb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function BXb(a){a=a|0;return +(+p[a+32>>3])}function CXb(a,b){a=a|0;b=+b;p[a+32>>3]=b;return}function DXb(a){a=a|0;return f[a+40>>2]|0}function EXb(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function FXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+64|0;d=c;e=a+8|0;g=a+40|0;h=a+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+48|0;f[a+44>>2]=e;f[e>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007942;f[d>>2]=1124007936;e=d+4|0;g=d+8|0;j=d+40|0;h=e;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[j>>2]=g;g=d+48|0;h=d+44|0;f[h>>2]=g;f[g>>2]=0;f[d+52>>2]=0;i=f[b>>2]|0;ei[f[(f[i>>2]|0)+12>>2]&511](i,b,d,-1);HXb(a,d)|0;a=d+36|0;b=f[a>>2]|0;if(b|0?(i=b+12|0,b=f[i>>2]|0,f[i>>2]=b+-1,(b|0)==1):0)V$(d);f[a>>2]=0;a=d+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[e>>2]|0)>0){a=f[j>>2]|0;j=0;do{f[a+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[h>>2]|0;if((e|0)==(g|0)){u=c;return}wL(e);u=c;return}function GXb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0;h=u;u=u+16|0;i=h;j=f[c+12>>2]|0;k=f[c+8>>2]|0;l=f[b+16>>2]|0;m=(f[b+48>>2]|0)>>>2;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(k|0):0)?(f[d+12>>2]|0)==(j|0):0)?(f[d>>2]&4095|0)==37:0)?(f[d+16>>2]|0)!=0:0)){f[i>>2]=k;f[i+4>>2]=j;S$(d,2,i,37)}if((e|0)>=(g|0)){u=h;return}i=f[c+16>>2]|0;b=f[f[c+44>>2]>>2]|0;c=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[d+16>>2]|0;p=f[f[d+44>>2]>>2]|0;d=(j|0)>0;q=j+-1|0;r=k+-1|0;s=m+5|0;t=m+1|0;v=m+6|0;w=m+2|0;x=m+7|0;y=m+3|0;z=m+8|0;A=m+4|0;B=m+9|0;C=j+-10|0;D=k+-10|0;E=j+-5|0;F=k+-5|0;k=e;do{e=i+(Y(b,k)|0)|0;G=c+(Y(o,k)|0)|0;H=a+(Y(p,k)|0)|0;if(d){I=+(k|0);J=(k|0)<5;K=165268+(k<<2)|0;L=(k|0)<(F|0);M=165268+(r-k<<2)|0;N=(k+-5|0)>>>0>=D>>>0;O=0;do{P=O<<1;Q=+n[e+(P<<2)>>2];R=+n[e+((P|1)<<2)>>2];S=+(O|0)+Q;T=I+R;P=~~S;U=P-(+(P|0)>S&1)|0;P=~~T;V=P-(+(P|0)>T&1)|0;P=l+((Y(V,m)|0)<<2)+(U*5<<2)|0;W=S-+(U|0);S=T-+(V|0);if(U>>>0<q>>>0&V>>>0<r>>>0){T=1.0-W;X=1.0-S;Z=T*X;_=W*X;X=T*S;T=W*S;V=O*5|0;$=Z*+n[P>>2]+_*+n[P+20>>2]+X*+n[P+(m<<2)>>2]+T*+n[P+(s<<2)>>2];aa=(Z*+n[P+16>>2]+_*+n[P+36>>2]+X*+n[P+(A<<2)>>2]+T*+n[P+(B<<2)>>2]+ +n[G+(V+4<<2)>>2])*.25;ba=(Z*+n[P+12>>2]+_*+n[P+32>>2]+X*+n[P+(y<<2)>>2]+T*+n[P+(z<<2)>>2]+ +n[G+(V+3<<2)>>2])*.5;ca=(Z*+n[P+8>>2]+_*+n[P+28>>2]+X*+n[P+(w<<2)>>2]+T*+n[P+(x<<2)>>2]+ +n[G+(V+2<<2)>>2])*.5;da=Z*+n[P+4>>2]+_*+n[P+24>>2]+X*+n[P+(t<<2)>>2]+T*+n[P+(v<<2)>>2];ea=V}else{V=O*5|0;$=0.0;aa=+n[G+(V+4<<2)>>2]*.5;ba=+n[G+(V+3<<2)>>2];ca=+n[G+(V+2<<2)>>2];da=0.0;ea=V}V=ea+1|0;T=R*ca+Q*aa+(+n[G+(ea<<2)>>2]-$)*.5;X=Q*ba+R*aa+(+n[G+(V<<2)>>2]-da)*.5;if((O+-5|0)>>>0>=C>>>0|N){if((O|0)<5)fa=+n[165268+(O<<2)>>2];else fa=1.0;if((O|0)<(E|0))ga=1.0;else ga=+n[165268+(q-O<<2)>>2];if(J)ha=+n[K>>2];else ha=1.0;if(L)ia=1.0;else ia=+n[M>>2];R=fa*ga*ha*ia;ja=T*R;ka=aa*R;la=ba*R;ma=ca*R;na=X*R}else{ja=T;ka=aa;la=ba;ma=ca;na=X}X=ka*ka;n[H+(ea<<2)>>2]=ma*ma+X;n[H+(V<<2)>>2]=(ma+la)*ka;n[H+(ea+2<<2)>>2]=la*la+X;n[H+(ea+3<<2)>>2]=na*ka+ma*ja;n[H+(ea+4<<2)>>2]=na*la+ka*ja;O=O+1|0}while((O|0)!=(j|0))}k=k+1|0}while((k|0)!=(g|0));u=h;return}function HXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;e=f[b>>2]|0;if((e&4095|0)==6){nOa(a,b)|0;u=c;return a|0}if((e&7|0)!=6){e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=-2113863674;f[d+4>>2]=a;dY(b,d,6,1.0,0.0);u=c;return a|0}h0(d,b,1,f[b+4>>2]|0,0);if((a|0)==(d|0)){b=d+36|0;e=f[b>>2]|0;if((e|0)!=0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0){V$(d);h=b}else h=b}else{b=a+36|0;e=f[b>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)V$(a);f[b>>2]=0;e=a+16|0;g=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){i=f[a+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[a>>2]=f[d>>2];j=d+4|0;i=f[j>>2]|0;f[g>>2]=i;g=d+8|0;k=a+8|0;f[k>>2]=f[g>>2];f[a+12>>2]=f[d+12>>2];f[e>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];f[a+24>>2]=f[d+24>>2];f[a+28>>2]=f[d+28>>2];f[a+32>>2]=f[d+32>>2];e=d+36|0;f[b>>2]=f[e>>2];b=a+44|0;l=f[b>>2]|0;m=a+48|0;if((l|0)==(m|0)){n=i;o=l}else{wL(l);f[b>>2]=m;f[a+40>>2]=k;n=f[j>>2]|0;o=m}m=d+44|0;if((n|0)<3){n=f[m>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2]}else{f[b>>2]=f[m>>2];b=d+40|0;f[a+40>>2]=f[b>>2];f[m>>2]=d+48;f[b>>2]=g}f[d>>2]=1124007936;g=j;j=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(j|0));h=e}f[h>>2]=0;h=d+16|0;e=d+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[e>>2]|0)>0){h=f[d+40>>2]|0;g=0;do{f[h+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[e>>2]|0))}e=f[d+44>>2]|0;if((e|0)!=(d+48|0))wL(e);u=c;return a|0}function IXb(a){a=a|0;f[a>>2]=165136;qP(a+16|0);NXc(a);return}function JXb(a){a=a|0;f[a>>2]=165136;qP(a+16|0);NXc(a);cYc(a);return}function KXb(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function LXb(a){a=a|0;cYc(a);return}function MXb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e;if(!c)h=f[a+24>>2]|0;else{i=f[c+16>>2]<<1;c=f[a+28>>2]|0;h=c>>>0<i>>>0?c:i}if(d>>>0>4294967271){u_b(g,3,475265,116);r_b(e+24|0,p_b(g,475352)|0);v_b(g)}g=d+24|0;d=h>>>0<g>>>0?g:h;h=_i[f[a+40>>2]&2047](d)|0;f[h+12>>2]=24;f[h+16>>2]=d;f[h>>2]=b;f[h+8>>2]=0;b=a+8|0;f[b>>2]=(f[b>>2]|0)+d;u=e;return h|0}function NXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!b)d=8;else d=f[b+4>>2]<<1;b=d>>>0<64?d:64;d=(b<<3|12)+7&2032;e=f[c+12>>2]|0;do if(((f[c+16>>2]|0)-e|0)>>>0<d>>>0){g=20672;h=a+16|0;i=h;if((f[g>>2]|0)==(f[i>>2]|0)?(f[g+4>>2]|0)==(f[i+4>>2]|0):0){i=f[5170]|0;g=f[i+12>>2]|0;if(((f[i+16>>2]|0)-g|0)>>>0<d>>>0)j=i;else{k=i;l=g;break}}else j=0;g=a+4|0;i=f[g>>2]|0;m=i;if((i|0)!=0?(f[m>>2]|0)==20672:0){i=f[m+12>>2]|0;if(((f[m+16>>2]|0)-i|0)>>>0<d>>>0){n=m;o=10}else{k=m;l=i;break}}else if(!j)p=OXb(a,20672,d)|0;else{n=j;o=10}if((o|0)==10)p=f[n+4>>2]|0;i=p+4|0;m=f[i>>2]|0;if(((f[m+16>>2]|0)-(f[m+12>>2]|0)|0)>>>0<d>>>0){q=MXb(a,20672,m,d)|0;f[q+4>>2]=p;f[q+8>>2]=m;f[i>>2]=q;r=q}else r=m;f[5170]=r;m=h;h=f[m+4>>2]|0;q=20672;f[q>>2]=f[m>>2];f[q+4>>2]=h;f[g>>2]=r;k=r;l=f[r+12>>2]|0}else{k=c;l=e}while(0);f[k+12>>2]=l+d;d=k+l|0;l=k+4|0;f[d+8>>2]=f[(f[l>>2]|0)+8>>2];f[d+4>>2]=b;f[d>>2]=0;f[(f[l>>2]|0)+8>>2]=d;return d|0}function OXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d;g=d+24|0;h=f[a>>2]|0;a:do if(h|0){i=h;while(1){if((f[i>>2]|0)==(b|0))break;j=f[i+12>>2]|0;if(!j)break a;else i=j}if(i|0){k=i;u=d;return k|0}}while(0);h=f[a+24>>2]|0;if((c+16|0)>>>0>4294967271){u_b(e,3,475265,116);r_b(g,p_b(e,475352)|0);v_b(e)}e=c+40|0;c=h>>>0<e>>>0?e:h;h=_i[f[a+40>>2]&2047](c)|0;e=h+12|0;f[e>>2]=24;f[h+16>>2]=c;f[h>>2]=b;f[h+8>>2]=0;b=a+8|0;f[b>>2]=(f[b>>2]|0)+c;c=f[e>>2]|0;f[e>>2]=c+16;e=h+c|0;f[h+4>>2]=e;f[e>>2]=f[h>>2];f[e+4>>2]=h;f[e+8>>2]=0;h=e+12|0;c=e;do{b=f[a>>2]|0;f[h>>2]=b;g=f[a>>2]|0;if((g|0)==(b|0))f[a>>2]=c}while((((g|0)==(b|0)?b:g)|0)!=(b|0));k=e;u=d;return k|0}function PXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=20672;e=a+16|0;g=e;do if((f[d>>2]|0)==(f[g>>2]|0)?(f[d+4>>2]|0)==(f[g+4>>2]|0):0)h=f[5170]|0;else{i=a+4|0;j=f[i>>2]|0;k=j;if(j|0?(f[k>>2]|0)==20672:0){h=k;break}k=f[a>>2]|0;a:do if(k){j=k;while(1){if((f[j>>2]|0)==20672)break;l=f[j+12>>2]|0;if(!l){m=10;break a}else j=l}if(j)n=j;else m=10}else m=10;while(0);if((m|0)==10){k=f[a+24>>2]|0;l=k>>>0>40?k:40;k=_i[f[a+40>>2]&2047](l)|0;o=k+12|0;f[o>>2]=24;f[k+16>>2]=l;f[k>>2]=20672;f[k+8>>2]=0;p=a+8|0;f[p>>2]=(f[p>>2]|0)+l;l=f[o>>2]|0;f[o>>2]=l+16;o=k+l|0;f[k+4>>2]=o;f[o>>2]=f[k>>2];f[o+4>>2]=k;f[o+8>>2]=0;k=o+12|0;l=o;do{p=f[a>>2]|0;f[k>>2]=p;q=f[a>>2]|0;if((q|0)==(p|0))f[a>>2]=l}while((((q|0)==(p|0)?p:q)|0)!=(p|0));n=o}l=f[n+4>>2]|0;f[5170]=l;k=e;p=f[k+4>>2]|0;q=20672;f[q>>2]=f[k>>2];f[q+4>>2]=p;f[i>>2]=l;h=l}while(0);e=f[(f[h+4>>2]|0)+8>>2]|0;if(e|0?(n=f[e>>2]|0,(n|0)!=(f[e+4>>2]|0)):0){r=e;s=n;t=s+1|0;f[r>>2]=t;u=r+12+(s<<3)|0;f[u>>2]=b;v=r+12+(s<<3)+4|0;f[v>>2]=c;return}n=NXb(a,e,h)|0;r=n;s=f[n>>2]|0;t=s+1|0;f[r>>2]=t;u=r+12+(s<<3)|0;f[u>>2]=b;v=r+12+(s<<3)+4|0;f[v>>2]=c;return}function QXb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=20672;d=a+16|0;e=d;if((f[c>>2]|0)==(f[e>>2]|0)?(f[c+4>>2]|0)==(f[e+4>>2]|0):0){e=f[5170]|0;c=f[e+12>>2]|0;if(((f[e+16>>2]|0)-c|0)>>>0<b>>>0)g=e;else{h=e;i=c;j=h+12|0;k=i+b|0;f[j>>2]=k;l=h+i|0;return l|0}}else g=0;c=a+4|0;e=f[c>>2]|0;m=e;if((e|0)!=0?(f[m>>2]|0)==20672:0){e=f[m+12>>2]|0;if(((f[m+16>>2]|0)-e|0)>>>0<b>>>0){n=m;o=7}else{h=m;i=e;j=h+12|0;k=i+b|0;f[j>>2]=k;l=h+i|0;return l|0}}else if(!g)p=OXb(a,20672,b)|0;else{n=g;o=7}if((o|0)==7)p=f[n+4>>2]|0;n=p+4|0;o=f[n>>2]|0;if(((f[o+16>>2]|0)-(f[o+12>>2]|0)|0)>>>0<b>>>0){g=MXb(a,20672,o,b)|0;f[g+4>>2]=p;f[g+8>>2]=o;f[n>>2]=g;q=g}else q=o;f[5170]=q;o=d;d=f[o+4>>2]|0;g=20672;f[g>>2]=f[o>>2];f[g+4>>2]=d;f[c>>2]=q;h=q;i=f[q+12>>2]|0;j=h+12|0;k=i+b|0;f[j>>2]=k;l=h+i|0;return l|0}function RXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=20672;e=a+16|0;g=e;if((f[d>>2]|0)==(f[g>>2]|0)?(f[d+4>>2]|0)==(f[g+4>>2]|0):0){g=f[5170]|0;d=f[g+12>>2]|0;if(((f[g+16>>2]|0)-d|0)>>>0<b>>>0){h=g;i=3}else{j=g;k=d}}else{h=0;i=3}do if((i|0)==3){d=a+4|0;g=f[d>>2]|0;l=g;if((g|0)!=0?(f[l>>2]|0)==20672:0){g=f[l+12>>2]|0;if(((f[l+16>>2]|0)-g|0)>>>0<b>>>0){m=l;i=7}else{j=l;k=g;break}}else if(!h)n=OXb(a,20672,b)|0;else{m=h;i=7}if((i|0)==7)n=f[m+4>>2]|0;g=n+4|0;l=f[g>>2]|0;if(((f[l+16>>2]|0)-(f[l+12>>2]|0)|0)>>>0<b>>>0){o=MXb(a,20672,l,b)|0;f[o+4>>2]=n;f[o+8>>2]=l;f[g>>2]=o;p=o}else p=l;f[5170]=p;l=e;o=f[l+4>>2]|0;g=20672;f[g>>2]=f[l>>2];f[g+4>>2]=o;f[d>>2]=p;j=p;k=f[p+12>>2]|0}while(0);f[j+12>>2]=k+b;b=j+k|0;k=f[(f[j+4>>2]|0)+8>>2]|0;if(k|0?(p=f[k>>2]|0,(p|0)!=(f[k+4>>2]|0)):0){q=k;r=p;s=r+1|0;f[q>>2]=s;t=q+12+(r<<3)|0;f[t>>2]=b;u=q+12+(r<<3)+4|0;f[u>>2]=c;return b|0}p=NXb(a,k,j)|0;q=p;r=f[p>>2]|0;s=r+1|0;f[q>>2]=s;t=q+12+(r<<3)|0;f[t>>2]=b;u=q+12+(r<<3)+4|0;f[u>>2]=c;return b|0}function SXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a+52>>2]|0;if(!d)return;ei[d&511](b,c,0,f[a+64>>2]|0);return}function TXb(){if((b[537379]|0)>=0)return;cYc(f[134342]|0);return}function UXb(){f[134342]=0;f[134343]=0;f[134344]=0;l_b(124);return}function VXb(a){a=a|0;var c=0,d=0,e=0;c=(b[a+11>>0]|0)<0;d=f[a>>2]|0;if(a>>>0>(c?d:a)>>>0){if(!c){e=10;return e|0}}else{if(!c){e=0;return e|0}if(d>>>0<(a+12|0)>>>0){e=0;return e|0}}e=(f[a+8>>2]&2147483647)+-1|0;return e|0}function WXb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223513]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=125;b[c+8>>0]=0;J_b(894052,c);a_b(c);u=a;return}function XXb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;g=u;u=u+32|0;h=g;i=g+24|0;if((d|0)<=0){u=g;return}j=e+8|0;k=e+4|0;l=0;do{m=c+(l*20|0)|0;o=f[m>>2]|0;q=a+o|0;r=f[c+(l*20|0)+12>>2]|0;a:do switch(r|0){case 0:{s=f[c+(l*20|0)+8>>2]|0;if(1<<(s&31)&f[a+(s>>>5<<2)>>2]|0){s=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){t=f[k>>2]|0;if(s>>>0>127){v=s;w=t;while(1){b[w>>0]=v|128;x=v>>>7;y=w+1|0;if(v>>>0>16383){v=x;w=y}else{z=y;A=x;break}}}else{z=t;A=s}b[z>>0]=A;w=z+1-t|0;f[k>>2]=(f[k>>2]|0)+w;f[j>>2]=(f[j>>2]|0)-w}else eZb(e,s);w=q;dZb(e,f[w>>2]|0,f[w+4>>2]|0)}break}case 20:{if(!(+p[q>>3]==0.0)){w=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){v=f[k>>2]|0;if(w>>>0>127){x=w;y=v;while(1){b[y>>0]=x|128;B=x>>>7;C=y+1|0;if(x>>>0>16383){x=B;y=C}else{D=C;E=B;break}}}else{D=v;E=w}b[D>>0]=E;y=D+1-v|0;f[k>>2]=(f[k>>2]|0)+y;f[j>>2]=(f[j>>2]|0)-y}else eZb(e,w);y=q;dZb(e,f[y>>2]|0,f[y+4>>2]|0)}break}case 40:{if((f[q>>2]|0)>0){y=c+(l*20|0)+4|0;x=q+8|0;s=0;do{t=f[y>>2]|0;if((f[j>>2]|0)>4){B=f[k>>2]|0;if(t>>>0>127){C=t;F=B;while(1){b[F>>0]=C|128;G=C>>>7;H=F+1|0;if(C>>>0>16383){C=G;F=H}else{I=H;J=G;break}}}else{I=B;J=t}b[I>>0]=J;F=I+1-B|0;f[k>>2]=(f[k>>2]|0)+F;f[j>>2]=(f[j>>2]|0)-F}else eZb(e,t);F=(f[x>>2]|0)+8+(s<<3)|0;dZb(e,f[F>>2]|0,f[F+4>>2]|0);s=s+1|0}while((s|0)<(f[q>>2]|0))}break}case 60:{YXb(q,m,e);break}case 80:{s=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(s>>>3|0)){if((f[j>>2]|0)>4){x=f[k>>2]|0;if(s>>>0>127){y=s;w=x;while(1){b[w>>0]=y|128;v=y>>>7;F=w+1|0;if(y>>>0>16383){y=v;w=F}else{K=F;L=v;break}}}else{K=x;L=s}b[K>>0]=L;w=K+1-x|0;f[k>>2]=(f[k>>2]|0)+w;f[j>>2]=(f[j>>2]|0)-w}else eZb(e,s);w=q;dZb(e,f[w>>2]|0,f[w+4>>2]|0)}break}case 1:{w=f[c+(l*20|0)+8>>2]|0;if(1<<(w&31)&f[a+(w>>>5<<2)>>2]|0){w=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){y=f[k>>2]|0;if(w>>>0>127){v=w;F=y;while(1){b[F>>0]=v|128;C=v>>>7;G=F+1|0;if(v>>>0>16383){v=C;F=G}else{M=G;N=C;break}}}else{M=y;N=w}b[M>>0]=N;F=M+1-y|0;f[k>>2]=(f[k>>2]|0)+F;f[j>>2]=(f[j>>2]|0)-F}else eZb(e,w);cZb(e,f[q>>2]|0)}break}case 21:{if(!(+n[q>>2]==0.0)){F=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){v=f[k>>2]|0;if(F>>>0>127){s=F;x=v;while(1){b[x>>0]=s|128;C=s>>>7;G=x+1|0;if(s>>>0>16383){s=C;x=G}else{O=G;P=C;break}}}else{O=v;P=F}b[O>>0]=P;x=O+1-v|0;f[k>>2]=(f[k>>2]|0)+x;f[j>>2]=(f[j>>2]|0)-x}else eZb(e,F);cZb(e,f[q>>2]|0)}break}case 41:{if((f[q>>2]|0)>0){x=c+(l*20|0)+4|0;s=q+8|0;w=0;do{y=f[x>>2]|0;if((f[j>>2]|0)>4){C=f[k>>2]|0;if(y>>>0>127){G=y;H=C;while(1){b[H>>0]=G|128;Q=G>>>7;R=H+1|0;if(G>>>0>16383){G=Q;H=R}else{S=R;T=Q;break}}}else{S=C;T=y}b[S>>0]=T;H=S+1-C|0;f[k>>2]=(f[k>>2]|0)+H;f[j>>2]=(f[j>>2]|0)-H}else eZb(e,y);cZb(e,f[(f[s>>2]|0)+4+(w<<2)>>2]|0);w=w+1|0}while((w|0)<(f[q>>2]|0))}break}case 61:{ZXb(q,m,e);break}case 81:{w=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(w>>>3|0)){if((f[j>>2]|0)>4){s=f[k>>2]|0;if(w>>>0>127){x=w;F=s;while(1){b[F>>0]=x|128;v=x>>>7;H=F+1|0;if(x>>>0>16383){x=v;F=H}else{U=H;V=v;break}}}else{U=s;V=w}b[U>>0]=V;F=U+1-s|0;f[k>>2]=(f[k>>2]|0)+F;f[j>>2]=(f[j>>2]|0)-F}else eZb(e,w);cZb(e,f[q>>2]|0)}break}case 2:{F=f[c+(l*20|0)+8>>2]|0;if(1<<(F&31)&f[a+(F>>>5<<2)>>2]|0)_Xb(q,m,e);break}case 22:{F=q;if(!((f[F>>2]|0)==0&(f[F+4>>2]|0)==0))_Xb(q,m,e);break}case 42:{$Xb(q,m,e);break}case 62:{aYb(q,m,e);break}case 82:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))_Xb(q,m,e);break}case 3:{F=f[c+(l*20|0)+8>>2]|0;if(1<<(F&31)&f[a+(F>>>5<<2)>>2]|0)bYb(q,m,e);break}case 23:{F=q;if(!((f[F>>2]|0)==0&(f[F+4>>2]|0)==0))bYb(q,m,e);break}case 43:{cYb(q,m,e);break}case 63:{dYb(q,m,e);break}case 83:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))bYb(q,m,e);break}case 4:{F=f[c+(l*20|0)+8>>2]|0;if(1<<(F&31)&f[a+(F>>>5<<2)>>2]|0)eYb(q,m,e);break}case 24:{if(f[q>>2]|0)eYb(q,m,e);break}case 44:{fYb(q,m,e);break}case 64:{gYb(q,m,e);break}case 84:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))eYb(q,m,e);break}case 5:{F=f[c+(l*20|0)+8>>2]|0;if(1<<(F&31)&f[a+(F>>>5<<2)>>2]|0){F=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){x=f[k>>2]|0;if(F>>>0>127){v=F;H=x;while(1){b[H>>0]=v|128;G=v>>>7;t=H+1|0;if(v>>>0>16383){v=G;H=t}else{W=t;X=G;break}}}else{W=x;X=F}b[W>>0]=X;H=W+1-x|0;f[k>>2]=(f[k>>2]|0)+H;f[j>>2]=(f[j>>2]|0)-H}else eZb(e,F);H=q;dZb(e,f[H>>2]|0,f[H+4>>2]|0)}break}case 25:{H=q;if(!((f[H>>2]|0)==0&(f[H+4>>2]|0)==0)){H=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){v=f[k>>2]|0;if(H>>>0>127){w=H;s=v;while(1){b[s>>0]=w|128;G=w>>>7;t=s+1|0;if(w>>>0>16383){w=G;s=t}else{Y=t;Z=G;break}}}else{Y=v;Z=H}b[Y>>0]=Z;s=Y+1-v|0;f[k>>2]=(f[k>>2]|0)+s;f[j>>2]=(f[j>>2]|0)-s}else eZb(e,H);s=q;dZb(e,f[s>>2]|0,f[s+4>>2]|0)}break}case 45:{if((f[q>>2]|0)>0){s=c+(l*20|0)+4|0;w=q+8|0;F=0;do{x=f[s>>2]|0;if((f[j>>2]|0)>4){G=f[k>>2]|0;if(x>>>0>127){t=x;B=G;while(1){b[B>>0]=t|128;Q=t>>>7;R=B+1|0;if(t>>>0>16383){t=Q;B=R}else{_=R;$=Q;break}}}else{_=G;$=x}b[_>>0]=$;B=_+1-G|0;f[k>>2]=(f[k>>2]|0)+B;f[j>>2]=(f[j>>2]|0)-B}else eZb(e,x);B=(f[w>>2]|0)+8+(F<<3)|0;dZb(e,f[B>>2]|0,f[B+4>>2]|0);F=F+1|0}while((F|0)<(f[q>>2]|0))}break}case 65:{hYb(q,m,e);break}case 85:{F=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(F>>>3|0)){if((f[j>>2]|0)>4){w=f[k>>2]|0;if(F>>>0>127){s=F;H=w;while(1){b[H>>0]=s|128;v=s>>>7;B=H+1|0;if(s>>>0>16383){s=v;H=B}else{aa=B;ba=v;break}}}else{aa=w;ba=F}b[aa>>0]=ba;H=aa+1-w|0;f[k>>2]=(f[k>>2]|0)+H;f[j>>2]=(f[j>>2]|0)-H}else eZb(e,F);H=q;dZb(e,f[H>>2]|0,f[H+4>>2]|0)}break}case 6:{H=f[c+(l*20|0)+8>>2]|0;if(1<<(H&31)&f[a+(H>>>5<<2)>>2]|0){H=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){s=f[k>>2]|0;if(H>>>0>127){v=H;B=s;while(1){b[B>>0]=v|128;t=v>>>7;y=B+1|0;if(v>>>0>16383){v=t;B=y}else{ca=y;da=t;break}}}else{ca=s;da=H}b[ca>>0]=da;B=ca+1-s|0;f[k>>2]=(f[k>>2]|0)+B;f[j>>2]=(f[j>>2]|0)-B}else eZb(e,H);cZb(e,f[q>>2]|0)}break}case 26:{if(f[q>>2]|0){B=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){v=f[k>>2]|0;if(B>>>0>127){F=B;w=v;while(1){b[w>>0]=F|128;t=F>>>7;y=w+1|0;if(F>>>0>16383){F=t;w=y}else{ea=y;fa=t;break}}}else{ea=v;fa=B}b[ea>>0]=fa;w=ea+1-v|0;f[k>>2]=(f[k>>2]|0)+w;f[j>>2]=(f[j>>2]|0)-w}else eZb(e,B);cZb(e,f[q>>2]|0)}break}case 46:{if((f[q>>2]|0)>0){w=c+(l*20|0)+4|0;F=q+8|0;H=0;do{s=f[w>>2]|0;if((f[j>>2]|0)>4){t=f[k>>2]|0;if(s>>>0>127){y=s;C=t;while(1){b[C>>0]=y|128;Q=y>>>7;R=C+1|0;if(y>>>0>16383){y=Q;C=R}else{ga=R;ha=Q;break}}}else{ga=t;ha=s}b[ga>>0]=ha;C=ga+1-t|0;f[k>>2]=(f[k>>2]|0)+C;f[j>>2]=(f[j>>2]|0)-C}else eZb(e,s);cZb(e,f[(f[F>>2]|0)+4+(H<<2)>>2]|0);H=H+1|0}while((H|0)<(f[q>>2]|0))}break}case 66:{iYb(q,m,e);break}case 86:{H=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(H>>>3|0)){if((f[j>>2]|0)>4){F=f[k>>2]|0;if(H>>>0>127){w=H;B=F;while(1){b[B>>0]=w|128;v=w>>>7;C=B+1|0;if(w>>>0>16383){w=v;B=C}else{ia=C;ja=v;break}}}else{ia=F;ja=H}b[ia>>0]=ja;B=ia+1-F|0;f[k>>2]=(f[k>>2]|0)+B;f[j>>2]=(f[j>>2]|0)-B}else eZb(e,H);cZb(e,f[q>>2]|0)}break}case 7:{B=f[c+(l*20|0)+8>>2]|0;if(1<<(B&31)&f[a+(B>>>5<<2)>>2]|0){B=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){w=f[k>>2]|0;if(B>>>0>127){v=B;C=w;while(1){b[C>>0]=v|128;y=v>>>7;x=C+1|0;if(v>>>0>16383){v=y;C=x}else{ka=x;la=y;break}}}else{ka=w;la=B}b[ka>>0]=la;C=ka+1-w|0;f[k>>2]=(f[k>>2]|0)+C;v=(f[j>>2]|0)-C|0;f[j>>2]=v;ma=v}else{eZb(e,B);ma=f[j>>2]|0}v=b[q>>0]|0;if((ma|0)>4){b[f[k>>2]>>0]=v;f[k>>2]=(f[k>>2]|0)+1;f[j>>2]=(f[j>>2]|0)+-1;break a}else{eZb(e,v&255);break a}}break}case 27:{if(b[q>>0]|0){v=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){C=f[k>>2]|0;if(v>>>0>127){H=v;F=C;while(1){b[F>>0]=H|128;y=H>>>7;x=F+1|0;if(H>>>0>16383){H=y;F=x}else{na=x;oa=y;break}}}else{na=C;oa=v}b[na>>0]=oa;F=na+1-C|0;f[k>>2]=(f[k>>2]|0)+F;H=(f[j>>2]|0)-F|0;f[j>>2]=H;pa=H}else{eZb(e,v);pa=f[j>>2]|0}H=b[q>>0]|0;if((pa|0)>4){b[f[k>>2]>>0]=H;f[k>>2]=(f[k>>2]|0)+1;f[j>>2]=(f[j>>2]|0)+-1;break a}else{eZb(e,H&255);break a}}break}case 47:{jYb(q,m,e);break}case 67:{kYb(q,m,e);break}case 87:{H=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(H>>>3|0)){if((f[j>>2]|0)>4){F=f[k>>2]|0;if(H>>>0>127){B=H;w=F;while(1){b[w>>0]=B|128;y=B>>>7;x=w+1|0;if(B>>>0>16383){B=y;w=x}else{qa=x;ra=y;break}}}else{qa=F;ra=H}b[qa>>0]=ra;w=qa+1-F|0;f[k>>2]=(f[k>>2]|0)+w;B=(f[j>>2]|0)-w|0;f[j>>2]=B;sa=B}else{eZb(e,H);sa=f[j>>2]|0}B=b[q>>0]|0;if((sa|0)>4){b[f[k>>2]>>0]=B;f[k>>2]=(f[k>>2]|0)+1;f[j>>2]=(f[j>>2]|0)+-1;break a}else{eZb(e,B&255);break a}}break}case 8:{B=f[c+(l*20|0)+8>>2]|0;if(1<<(B&31)&f[a+(B>>>5<<2)>>2]|0){B=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){w=f[k>>2]|0;if(B>>>0>127){v=B;C=w;while(1){b[C>>0]=v|128;y=v>>>7;x=C+1|0;if(v>>>0>16383){v=y;C=x}else{ta=x;ua=y;break}}}else{ta=w;ua=B}b[ta>>0]=ua;C=ta+1-w|0;f[k>>2]=(f[k>>2]|0)+C;f[j>>2]=(f[j>>2]|0)-C}else eZb(e,B);lYb(f[q>>2]|0,e)}break}case 28:{C=f[q>>2]|0;v=b[C+11>>0]|0;if(v<<24>>24<0)va=f[C+4>>2]|0;else va=v&255;if(va|0){v=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){C=f[k>>2]|0;if(v>>>0>127){H=v;F=C;while(1){b[F>>0]=H|128;y=H>>>7;x=F+1|0;if(H>>>0>16383){H=y;F=x}else{wa=x;xa=y;break}}}else{wa=C;xa=v}b[wa>>0]=xa;F=wa+1-C|0;f[k>>2]=(f[k>>2]|0)+F;f[j>>2]=(f[j>>2]|0)-F}else eZb(e,v);lYb(f[q>>2]|0,e)}break}case 48:{F=q+4|0;if((f[F>>2]|0)>0){H=c+(l*20|0)+4|0;B=q+12|0;w=0;do{y=f[H>>2]|0;if((f[j>>2]|0)>4){x=f[k>>2]|0;if(y>>>0>127){G=y;Q=x;while(1){b[Q>>0]=G|128;R=G>>>7;ya=Q+1|0;if(G>>>0>16383){G=R;Q=ya}else{za=ya;Aa=R;break}}}else{za=x;Aa=y}b[za>>0]=Aa;Q=za+1-x|0;f[k>>2]=(f[k>>2]|0)+Q;f[j>>2]=(f[j>>2]|0)-Q}else eZb(e,y);Q=f[B>>2]|0;lYb(f[((Q|0)==0?0:Q+4|0)+(w<<2)>>2]|0,e);w=w+1|0}while((w|0)<(f[F>>2]|0))}break}case 68:{mYb(q,m,e);break}case 88:{F=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(F>>>3|0)){if((f[j>>2]|0)>4){w=f[k>>2]|0;if(F>>>0>127){B=F;H=w;while(1){b[H>>0]=B|128;v=B>>>7;C=H+1|0;if(B>>>0>16383){B=v;H=C}else{Ba=C;Ca=v;break}}}else{Ba=w;Ca=F}b[Ba>>0]=Ca;H=Ba+1-w|0;f[k>>2]=(f[k>>2]|0)+H;f[j>>2]=(f[j>>2]|0)-H}else eZb(e,F);lYb(f[q>>2]|0,e)}break}case 9:{H=f[c+(l*20|0)+8>>2]|0;if(1<<(H&31)&f[a+(H>>>5<<2)>>2]|0)nYb(q,m,e);break}case 29:{if(f[q>>2]|0)nYb(q,m,e);break}case 49:{oYb(q,m,e);break}case 69:{mYb(q,m,e);break}case 89:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))nYb(q,m,e);break}case 10:{H=f[c+(l*20|0)+8>>2]|0;if(1<<(H&31)&f[a+(H>>>5<<2)>>2]|0){H=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){B=f[k>>2]|0;if(H>>>0>127){v=H;C=B;while(1){b[C>>0]=v|128;Q=v>>>7;G=C+1|0;if(v>>>0>16383){v=Q;C=G}else{Da=G;Ea=Q;break}}}else{Da=B;Ea=H}b[Da>>0]=Ea;C=Da+1-B|0;f[k>>2]=(f[k>>2]|0)+C;f[j>>2]=(f[j>>2]|0)-C}else eZb(e,H);pYb(f[q>>2]|0,f[c+(l*20|0)+16>>2]|0,e)}break}case 30:{if(f[q>>2]|0){C=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){v=f[k>>2]|0;if(C>>>0>127){F=C;w=v;while(1){b[w>>0]=F|128;Q=F>>>7;G=w+1|0;if(F>>>0>16383){F=Q;w=G}else{Fa=G;Ga=Q;break}}}else{Fa=v;Ga=C}b[Fa>>0]=Ga;w=Fa+1-v|0;f[k>>2]=(f[k>>2]|0)+w;f[j>>2]=(f[j>>2]|0)-w}else eZb(e,C);pYb(f[q>>2]|0,f[c+(l*20|0)+16>>2]|0,e)}break}case 50:{w=q+4|0;if((f[w>>2]|0)>0){F=c+(l*20|0)+4|0;H=q+12|0;B=c+(l*20|0)+16|0;Q=0;do{G=f[F>>2]|0;if((f[j>>2]|0)>4){s=f[k>>2]|0;if(G>>>0>127){t=G;R=s;while(1){b[R>>0]=t|128;ya=t>>>7;Ha=R+1|0;if(t>>>0>16383){t=ya;R=Ha}else{Ia=Ha;Ja=ya;break}}}else{Ia=s;Ja=G}b[Ia>>0]=Ja;R=Ia+1-s|0;f[k>>2]=(f[k>>2]|0)+R;f[j>>2]=(f[j>>2]|0)-R}else eZb(e,G);R=f[H>>2]|0;pYb(f[((R|0)==0?0:R+4|0)+(Q<<2)>>2]|0,f[B>>2]|0,e);Q=Q+1|0}while((Q|0)<(f[w>>2]|0))}break}case 70:{mYb(q,m,e);break}case 90:{w=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(w>>>3|0)){if((f[j>>2]|0)>4){Q=f[k>>2]|0;if(w>>>0>127){B=w;H=Q;while(1){b[H>>0]=B|128;F=B>>>7;C=H+1|0;if(B>>>0>16383){B=F;H=C}else{Ka=C;La=F;break}}}else{Ka=Q;La=w}b[Ka>>0]=La;H=Ka+1-Q|0;f[k>>2]=(f[k>>2]|0)+H;f[j>>2]=(f[j>>2]|0)-H}else eZb(e,w);pYb(f[q>>2]|0,f[c+(l*20|0)+16>>2]|0,e)}break}case 11:{H=f[c+(l*20|0)+8>>2]|0;if(1<<(H&31)&f[a+(H>>>5<<2)>>2]|0){H=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){B=f[k>>2]|0;if(H>>>0>127){F=H;C=B;while(1){b[C>>0]=F|128;v=F>>>7;R=C+1|0;if(F>>>0>16383){F=v;C=R}else{Ma=R;Na=v;break}}}else{Ma=B;Na=H}b[Ma>>0]=Na;C=Ma+1-B|0;f[k>>2]=(f[k>>2]|0)+C;f[j>>2]=(f[j>>2]|0)-C}else eZb(e,H);lYb(f[q>>2]|0,e)}break}case 31:{C=f[q>>2]|0;F=b[C+11>>0]|0;if(F<<24>>24<0)Oa=f[C+4>>2]|0;else Oa=F&255;if(Oa|0){F=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){C=f[k>>2]|0;if(F>>>0>127){w=F;Q=C;while(1){b[Q>>0]=w|128;v=w>>>7;R=Q+1|0;if(w>>>0>16383){w=v;Q=R}else{Pa=R;Qa=v;break}}}else{Pa=C;Qa=F}b[Pa>>0]=Qa;Q=Pa+1-C|0;f[k>>2]=(f[k>>2]|0)+Q;f[j>>2]=(f[j>>2]|0)-Q}else eZb(e,F);lYb(f[q>>2]|0,e)}break}case 51:{Q=q+4|0;if((f[Q>>2]|0)>0){w=c+(l*20|0)+4|0;H=q+12|0;B=0;do{v=f[w>>2]|0;if((f[j>>2]|0)>4){R=f[k>>2]|0;if(v>>>0>127){t=v;y=R;while(1){b[y>>0]=t|128;x=t>>>7;ya=y+1|0;if(t>>>0>16383){t=x;y=ya}else{Ra=ya;Sa=x;break}}}else{Ra=R;Sa=v}b[Ra>>0]=Sa;y=Ra+1-R|0;f[k>>2]=(f[k>>2]|0)+y;f[j>>2]=(f[j>>2]|0)-y}else eZb(e,v);y=f[H>>2]|0;lYb(f[((y|0)==0?0:y+4|0)+(B<<2)>>2]|0,e);B=B+1|0}while((B|0)<(f[Q>>2]|0))}break}case 71:{mYb(q,m,e);break}case 91:{Q=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(Q>>>3|0)){if((f[j>>2]|0)>4){B=f[k>>2]|0;if(Q>>>0>127){H=Q;w=B;while(1){b[w>>0]=H|128;F=H>>>7;C=w+1|0;if(H>>>0>16383){H=F;w=C}else{Ta=C;Ua=F;break}}}else{Ta=B;Ua=Q}b[Ta>>0]=Ua;w=Ta+1-B|0;f[k>>2]=(f[k>>2]|0)+w;f[j>>2]=(f[j>>2]|0)-w}else eZb(e,Q);lYb(f[q>>2]|0,e)}break}case 12:{w=f[c+(l*20|0)+8>>2]|0;if(1<<(w&31)&f[a+(w>>>5<<2)>>2]|0)qYb(q,m,e);break}case 32:{if(f[q>>2]|0)qYb(q,m,e);break}case 52:{rYb(q,m,e);break}case 72:{sYb(q,m,e);break}case 92:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))qYb(q,m,e);break}case 13:{w=f[c+(l*20|0)+8>>2]|0;if(1<<(w&31)&f[a+(w>>>5<<2)>>2]|0)tYb(q,m,e);break}case 33:{if(f[q>>2]|0)tYb(q,m,e);break}case 53:{uYb(q,m,e);break}case 73:{vYb(q,m,e);break}case 93:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))tYb(q,m,e);break}case 14:{w=f[c+(l*20|0)+8>>2]|0;if(1<<(w&31)&f[a+(w>>>5<<2)>>2]|0){w=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){H=f[k>>2]|0;if(w>>>0>127){F=w;C=H;while(1){b[C>>0]=F|128;y=F>>>7;t=C+1|0;if(F>>>0>16383){F=y;C=t}else{Va=t;Wa=y;break}}}else{Va=H;Wa=w}b[Va>>0]=Wa;C=Va+1-H|0;f[k>>2]=(f[k>>2]|0)+C;f[j>>2]=(f[j>>2]|0)-C}else eZb(e,w);cZb(e,f[q>>2]|0)}break}case 34:{if(f[q>>2]|0){C=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){F=f[k>>2]|0;if(C>>>0>127){Q=C;B=F;while(1){b[B>>0]=Q|128;y=Q>>>7;t=B+1|0;if(Q>>>0>16383){Q=y;B=t}else{Xa=t;Ya=y;break}}}else{Xa=F;Ya=C}b[Xa>>0]=Ya;B=Xa+1-F|0;f[k>>2]=(f[k>>2]|0)+B;f[j>>2]=(f[j>>2]|0)-B}else eZb(e,C);cZb(e,f[q>>2]|0)}break}case 54:{if((f[q>>2]|0)>0){B=c+(l*20|0)+4|0;Q=q+8|0;w=0;do{H=f[B>>2]|0;if((f[j>>2]|0)>4){y=f[k>>2]|0;if(H>>>0>127){t=H;G=y;while(1){b[G>>0]=t|128;s=t>>>7;x=G+1|0;if(t>>>0>16383){t=s;G=x}else{Za=x;_a=s;break}}}else{Za=y;_a=H}b[Za>>0]=_a;G=Za+1-y|0;f[k>>2]=(f[k>>2]|0)+G;f[j>>2]=(f[j>>2]|0)-G}else eZb(e,H);cZb(e,f[(f[Q>>2]|0)+4+(w<<2)>>2]|0);w=w+1|0}while((w|0)<(f[q>>2]|0))}break}case 74:{wYb(q,m,e);break}case 94:{w=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(w>>>3|0)){if((f[j>>2]|0)>4){Q=f[k>>2]|0;if(w>>>0>127){B=w;C=Q;while(1){b[C>>0]=B|128;F=B>>>7;G=C+1|0;if(B>>>0>16383){B=F;C=G}else{$a=G;ab=F;break}}}else{$a=Q;ab=w}b[$a>>0]=ab;C=$a+1-Q|0;f[k>>2]=(f[k>>2]|0)+C;f[j>>2]=(f[j>>2]|0)-C}else eZb(e,w);cZb(e,f[q>>2]|0)}break}case 15:{C=f[c+(l*20|0)+8>>2]|0;if(1<<(C&31)&f[a+(C>>>5<<2)>>2]|0){C=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){B=f[k>>2]|0;if(C>>>0>127){F=C;G=B;while(1){b[G>>0]=F|128;t=F>>>7;v=G+1|0;if(F>>>0>16383){F=t;G=v}else{bb=v;cb=t;break}}}else{bb=B;cb=C}b[bb>>0]=cb;G=bb+1-B|0;f[k>>2]=(f[k>>2]|0)+G;f[j>>2]=(f[j>>2]|0)-G}else eZb(e,C);G=q;dZb(e,f[G>>2]|0,f[G+4>>2]|0)}break}case 35:{G=q;if(!((f[G>>2]|0)==0&(f[G+4>>2]|0)==0)){G=f[c+(l*20|0)+4>>2]|0;if((f[j>>2]|0)>4){F=f[k>>2]|0;if(G>>>0>127){w=G;Q=F;while(1){b[Q>>0]=w|128;t=w>>>7;v=Q+1|0;if(w>>>0>16383){w=t;Q=v}else{db=v;eb=t;break}}}else{db=F;eb=G}b[db>>0]=eb;Q=db+1-F|0;f[k>>2]=(f[k>>2]|0)+Q;f[j>>2]=(f[j>>2]|0)-Q}else eZb(e,G);Q=q;dZb(e,f[Q>>2]|0,f[Q+4>>2]|0)}break}case 55:{if((f[q>>2]|0)>0){Q=c+(l*20|0)+4|0;w=q+8|0;C=0;do{B=f[Q>>2]|0;if((f[j>>2]|0)>4){t=f[k>>2]|0;if(B>>>0>127){v=B;R=t;while(1){b[R>>0]=v|128;s=v>>>7;x=R+1|0;if(v>>>0>16383){v=s;R=x}else{fb=x;gb=s;break}}}else{fb=t;gb=B}b[fb>>0]=gb;R=fb+1-t|0;f[k>>2]=(f[k>>2]|0)+R;f[j>>2]=(f[j>>2]|0)-R}else eZb(e,B);R=(f[w>>2]|0)+8+(C<<3)|0;dZb(e,f[R>>2]|0,f[R+4>>2]|0);C=C+1|0}while((C|0)<(f[q>>2]|0))}break}case 75:{xYb(q,m,e);break}case 95:{C=f[c+(l*20|0)+4>>2]|0;if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==(C>>>3|0)){if((f[j>>2]|0)>4){w=f[k>>2]|0;if(C>>>0>127){Q=C;G=w;while(1){b[G>>0]=Q|128;F=Q>>>7;R=G+1|0;if(Q>>>0>16383){Q=F;G=R}else{hb=R;ib=F;break}}}else{hb=w;ib=C}b[hb>>0]=ib;G=hb+1-w|0;f[k>>2]=(f[k>>2]|0)+G;f[j>>2]=(f[j>>2]|0)-G}else eZb(e,C);G=q;dZb(e,f[G>>2]|0,f[G+4>>2]|0)}break}case 16:{G=f[c+(l*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0)yYb(q,m,e);break}case 36:{if(f[q>>2]|0)yYb(q,m,e);break}case 56:{zYb(q,m,e);break}case 76:{AYb(q,m,e);break}case 96:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))yYb(q,m,e);break}case 17:{G=f[c+(l*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0)BYb(q,m,e);break}case 37:{G=q;if(!((f[G>>2]|0)==0&(f[G+4>>2]|0)==0))BYb(q,m,e);break}case 57:{CYb(q,m,e);break}case 77:{DYb(q,m,e);break}case 97:{if((f[a+(f[c+(l*20|0)+8>>2]|0)>>2]|0)==((f[c+(l*20|0)+4>>2]|0)>>>3|0))BYb(q,m,e);break}case 100:{gi[f[c+(l*20|0)+16>>2]&255](a,o,f[c+(l*20|0)+4>>2]|0,f[c+(l*20|0)+8>>2]|0,e);break}default:{u_b(h,3,475434,537);r_b(i,s_b(p_b(h,475538)|0,r)|0);v_b(h)}}while(0);l=l+1|0}while((l|0)<(d|0));u=g;return}function YXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{c=(f[e>>2]|0)+8+(q<<3)|0;dZb(d,f[c>>2]|0,f[c+4>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function ZXb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{cZb(d,f[(f[e>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function _Xb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=a;a=f[e>>2]|0;g=f[e+4>>2]|0;if((o|0)<=9){fZb(d,a,g);return}o=d+4|0;d=f[o>>2]|0;e=a&255;if(g>>>0>0|(g|0)==0&a>>>0>127){n=d;h=e;m=a;a=g;while(1){b[n>>0]=h|-128;g=m;m=l1c(m|0,a|0,7)|0;j=n+1|0;i=m&255;if(!(a>>>0>0|(a|0)==0&g>>>0>16383)){p=j;q=i;break}else{n=j;h=i;a=J}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function $Xb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=(f[h>>2]|0)+8+(i<<3)|0;m=f[l>>2]|0;n=f[l+4>>2]|0;if((r|0)>9){l=f[g>>2]|0;o=m&255;if(n>>>0>0|(n|0)==0&m>>>0>127){s=l;t=o;u=m;v=n;while(1){b[s>>0]=t|-128;w=u;u=l1c(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=l;A=o}b[z>>0]=A;v=z+1-l|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else fZb(d,m,n);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function aYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=(f[e>>2]|0)+8+(o<<3)|0;p=f[g>>2]|0;h=f[g+4>>2]|0;if((f[c>>2]|0)>9){g=f[q>>2]|0;n=p&255;if(h>>>0>0|(h|0)==0&p>>>0>127){m=g;j=n;i=p;k=h;while(1){b[m>>0]=j|-128;l=i;i=l1c(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=g;u=n}b[t>>0]=u;k=t+1-g|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else fZb(d,p,h);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function bYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=a;a=f[e>>2]|0;g=f[e+4>>2]|0;if((o|0)<=9){fZb(d,a,g);return}o=d+4|0;d=f[o>>2]|0;e=a&255;if(g>>>0>0|(g|0)==0&a>>>0>127){n=d;h=e;m=a;a=g;while(1){b[n>>0]=h|-128;g=m;m=l1c(m|0,a|0,7)|0;j=n+1|0;i=m&255;if(!(a>>>0>0|(a|0)==0&g>>>0>16383)){p=j;q=i;break}else{n=j;h=i;a=J}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function cYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=(f[h>>2]|0)+8+(i<<3)|0;m=f[l>>2]|0;n=f[l+4>>2]|0;if((r|0)>9){l=f[g>>2]|0;o=m&255;if(n>>>0>0|(n|0)==0&m>>>0>127){s=l;t=o;u=m;v=n;while(1){b[s>>0]=t|-128;w=u;u=l1c(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=l;A=o}b[z>>0]=A;v=z+1-l|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else fZb(d,m,n);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function dYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=(f[e>>2]|0)+8+(o<<3)|0;p=f[g>>2]|0;h=f[g+4>>2]|0;if((f[c>>2]|0)>9){g=f[q>>2]|0;n=p&255;if(h>>>0>0|(h|0)==0&p>>>0>127){m=g;j=n;i=p;k=h;while(1){b[m>>0]=j|-128;l=i;i=l1c(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=g;u=n}b[t>>0]=u;k=t+1-g|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else fZb(d,p,h);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function eYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;a=((e|0)<0)<<31>>31;if((o|0)<=9){fZb(d,e,a);return}o=d+4|0;d=f[o>>2]|0;g=e&255;if(e>>>0>127){n=d;h=g;m=e;e=a;while(1){b[n>>0]=h|-128;a=m;m=l1c(m|0,e|0,7)|0;j=n+1|0;i=m&255;if(!(e>>>0>0|(e|0)==0&a>>>0>16383)){p=j;q=i;break}else{n=j;h=i;e=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function fYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;m=((l|0)<0)<<31>>31;if((r|0)>9){n=f[g>>2]|0;o=l&255;if(l>>>0>127){s=n;t=o;u=l;v=m;while(1){b[s>>0]=t|-128;w=u;u=l1c(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=n;A=o}b[z>>0]=A;v=z+1-n|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else fZb(d,l,m);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function gYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;p=((g|0)<0)<<31>>31;if((f[c>>2]|0)>9){h=f[q>>2]|0;n=g&255;if(g>>>0>127){m=h;j=n;i=g;k=p;while(1){b[m>>0]=j|-128;l=i;i=l1c(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=h;u=n}b[t>>0]=u;k=t+1-h|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else fZb(d,g,p);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function hYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{c=(f[e>>2]|0)+8+(q<<3)|0;dZb(d,f[c>>2]|0,f[c+4>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function iYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{cZb(d,f[(f[e>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function jYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=b[(f[h>>2]|0)+4+i>>0]|0;if((r|0)>4){b[f[g>>2]>>0]=l;f[g>>2]=(f[g>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+-1}else eZb(d,l&255);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function kYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=b[(f[e>>2]|0)+4+o>>0]|0;if((f[c>>2]|0)>4){b[f[q>>2]>>0]=g;f[q>>2]=(f[q>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+-1}else eZb(d,g&255);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function lYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+11|0;e=b[d>>0]|0;if(e<<24>>24<0)g=f[a+4>>2]|0;else g=e&255;e=c+8|0;if((f[e>>2]|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else eZb(c,g);g=b[d>>0]|0;if(g<<24>>24<0){p=f[a>>2]|0;q=f[a+4>>2]|0}else{p=a;q=g&255}if(!(b[c+17>>0]|0)){aZb(c,p,q);return}else{bZb(c,p,q);return}}function mYb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=u;u=u+32|0;a=c;u_b(a,3,475434,512);d=p_b(a,475538)|0;e=p_b(t_b(d,f[b+4>>2]|0)|0,475568)|0;r_b(c+24|0,t_b(e,f[b+12>>2]|0)|0);v_b(a);u=c;return}function nYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=c+4|0;g=f[e>>2]|0;h=d+8|0;if((f[h>>2]|0)>4){i=d+4|0;j=f[i>>2]|0;if(g>>>0>127){k=g;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=g}b[o>>0]=p;p=o+1-j|0;f[i>>2]=(f[i>>2]|0)+p;f[h>>2]=(f[h>>2]|0)-p}else eZb(d,g);g=f[a>>2]|0;a=f[c+16>>2]|0;do if(!a)mi[f[(f[g>>2]|0)+52>>2]&2047](g,d);else{c=f[a+4>>2]|0;p=f[g+(f[c>>2]|0)>>2]|0;i=(f[a>>2]|0)+-1|0;j=c+20|0;c=f[h>>2]|0;o=d+4|0;if((c|0)>=(p|0)?(l=f[o>>2]|0,f[o>>2]=l+p,f[h>>2]=c-p,l|0):0){if(!(b[d+18>>0]|0))q=(f[223514]|0)!=0;else q=(b[d+19>>0]|0)!=0;hj[f[(f[g>>2]|0)+64>>2]&511](g,q,l)|0;break}XXb(g,j,i,d)}while(0);g=(f[e>>2]|0)+1|0;if((f[h>>2]|0)<=4){eZb(d,g);return}e=d+4|0;d=f[e>>2]|0;if(g>>>0>127){q=g;a=d;while(1){b[a>>0]=q|128;i=q>>>7;j=a+1|0;if(q>>>0>16383){q=i;a=j}else{r=j;s=i;break}}}else{r=d;s=g}b[r>>0]=s;s=r+1-d|0;f[e>>2]=(f[e>>2]|0)+s;f[h>>2]=(f[h>>2]|0)-s;return}function oYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=a+4|0;if((f[e>>2]|0)<=0)return;g=c+4|0;h=d+8|0;i=d+4|0;j=a+12|0;a=c+16|0;c=d+18|0;k=d+19|0;l=0;do{m=f[g>>2]|0;if((f[h>>2]|0)>4){n=f[i>>2]|0;if(m>>>0>127){o=m;p=n;while(1){b[p>>0]=o|128;q=o>>>7;r=p+1|0;if(o>>>0>16383){o=q;p=r}else{s=r;t=q;break}}}else{s=n;t=m}b[s>>0]=t;p=s+1-n|0;f[i>>2]=(f[i>>2]|0)+p;f[h>>2]=(f[h>>2]|0)-p}else eZb(d,m);p=f[j>>2]|0;o=f[((p|0)==0?0:p+4|0)+(l<<2)>>2]|0;p=f[a>>2]|0;do if(!p)mi[f[(f[o>>2]|0)+52>>2]&2047](o,d);else{q=f[p+4>>2]|0;r=f[o+(f[q>>2]|0)>>2]|0;u=(f[p>>2]|0)+-1|0;v=q+20|0;q=f[h>>2]|0;if((q|0)>=(r|0)?(w=f[i>>2]|0,f[i>>2]=w+r,f[h>>2]=q-r,w|0):0){if(!(b[c>>0]|0))x=(f[223514]|0)!=0;else x=(b[k>>0]|0)!=0;hj[f[(f[o>>2]|0)+64>>2]&511](o,x,w)|0;break}XXb(o,v,u,d)}while(0);o=(f[g>>2]|0)+1|0;if((f[h>>2]|0)>4){p=f[i>>2]|0;if(o>>>0>127){m=o;n=p;while(1){b[n>>0]=m|128;u=m>>>7;v=n+1|0;if(m>>>0>16383){m=u;n=v}else{y=v;z=u;break}}}else{y=p;z=o}b[y>>0]=z;n=y+1-p|0;f[i>>2]=(f[i>>2]|0)+n;f[h>>2]=(f[h>>2]|0)-n}else eZb(d,o);l=l+1|0}while((l|0)<(f[e>>2]|0));return}function pYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!c){e=_i[f[(f[a>>2]|0)+60>>2]&2047](a)|0;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else eZb(d,e);mi[f[(f[a>>2]|0)+52>>2]&2047](a,d);return}e=f[c+4>>2]|0;o=f[a+(f[e>>2]|0)>>2]|0;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;i=f[h>>2]|0;if(o>>>0>127){n=o;k=i;while(1){b[k>>0]=n|128;j=n>>>7;l=k+1|0;if(n>>>0>16383){n=j;k=l}else{p=l;q=j;break}}}else{p=i;q=o}b[p>>0]=q;q=p+1-i|0;f[h>>2]=(f[h>>2]|0)+q;i=(f[g>>2]|0)-q|0;f[g>>2]=i;r=h;s=i}else{eZb(d,o);r=d+4|0;s=f[g>>2]|0}i=(f[c>>2]|0)+-1|0;c=e+20|0;if((s|0)>=(o|0)?(e=f[r>>2]|0,f[r>>2]=e+o,f[g>>2]=s-o,e|0):0){if(!(b[d+18>>0]|0))t=(f[223514]|0)!=0;else t=(b[d+19>>0]|0)!=0;hj[f[(f[a>>2]|0)+64>>2]&511](a,t,e)|0;return}XXb(a,c,i,d);return}function qYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;if((o|0)<=4){eZb(d,e);return}o=d+4|0;d=f[o>>2]|0;if(e>>>0>127){a=e;g=d;while(1){b[g>>0]=a|128;n=a>>>7;h=g+1|0;if(a>>>0>16383){a=n;g=h}else{p=h;q=n;break}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function rYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;if((r|0)>4){m=f[g>>2]|0;if(l>>>0>127){n=l;o=m;while(1){b[o>>0]=n|128;s=n>>>7;t=o+1|0;if(n>>>0>16383){n=s;o=t}else{u=t;v=s;break}}}else{u=m;v=l}b[u>>0]=v;o=u+1-m|0;f[g>>2]=(f[g>>2]|0)+o;f[c>>2]=(f[c>>2]|0)-o}else eZb(d,l);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function sYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;if((f[c>>2]|0)>4){p=f[q>>2]|0;if(g>>>0>127){h=g;n=p;while(1){b[n>>0]=h|128;m=h>>>7;j=n+1|0;if(h>>>0>16383){h=m;n=j}else{r=j;s=m;break}}}else{r=p;s=g}b[r>>0]=s;n=r+1-p|0;f[q>>2]=(f[q>>2]|0)+n;f[c>>2]=(f[c>>2]|0)-n}else eZb(d,g);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function tYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;a=((e|0)<0)<<31>>31;if((o|0)<=9){fZb(d,e,a);return}o=d+4|0;d=f[o>>2]|0;g=e&255;if(e>>>0>127){n=d;h=g;m=e;e=a;while(1){b[n>>0]=h|-128;a=m;m=l1c(m|0,e|0,7)|0;j=n+1|0;i=m&255;if(!(e>>>0>0|(e|0)==0&a>>>0>16383)){p=j;q=i;break}else{n=j;h=i;e=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function uYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;m=((l|0)<0)<<31>>31;if((r|0)>9){n=f[g>>2]|0;o=l&255;if(l>>>0>127){s=n;t=o;u=l;v=m;while(1){b[s>>0]=t|-128;w=u;u=l1c(u|0,v|0,7)|0;x=s+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{s=x;t=y;v=J}}}else{z=n;A=o}b[z>>0]=A;v=z+1-n|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else fZb(d,l,m);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function vYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;p=((g|0)<0)<<31>>31;if((f[c>>2]|0)>9){h=f[q>>2]|0;n=g&255;if(g>>>0>127){m=h;j=n;i=g;k=p;while(1){b[m>>0]=j|-128;l=i;i=l1c(i|0,k|0,7)|0;r=m+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{m=r;j=s;k=J}}}else{t=h;u=n}b[t>>0]=u;k=t+1-h|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else fZb(d,g,p);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function wYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{cZb(d,f[(f[e>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function xYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=0;do{c=(f[e>>2]|0)+8+(q<<3)|0;dZb(d,f[c>>2]|0,f[c+4>>2]|0);q=q+1|0}while((q|0)<(f[a>>2]|0));return}function yYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a>>2]|0;a=e<<1^e>>31;if((o|0)<=4){eZb(d,a);return}o=d+4|0;d=f[o>>2]|0;if(a>>>0>127){e=a;g=d;while(1){b[g>>0]=e|128;n=e>>>7;h=g+1|0;if(e>>>0>16383){e=n;g=h}else{p=h;q=n;break}}}else{p=d;q=a}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function zYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;m=l<<1^l>>31;if((r|0)>4){l=f[g>>2]|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;s=n>>>7;t=o+1|0;if(n>>>0>16383){n=s;o=t}else{u=t;v=s;break}}}else{u=l;v=m}b[u>>0]=v;o=u+1-l|0;f[g>>2]=(f[g>>2]|0)+o;f[c>>2]=(f[c>>2]|0)-o}else eZb(d,m);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function AYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=f[(f[e>>2]|0)+4+(o<<2)>>2]|0;p=g<<1^g>>31;if((f[c>>2]|0)>4){g=f[q>>2]|0;if(p>>>0>127){h=p;n=g;while(1){b[n>>0]=h|128;m=h>>>7;j=n+1|0;if(h>>>0>16383){h=m;n=j}else{r=j;s=m;break}}}else{r=g;s=p}b[r>>0]=s;n=r+1-g|0;f[q>>2]=(f[q>>2]|0)+n;f[c>>2]=(f[c>>2]|0)-n}else eZb(d,p);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function BYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=a;a=f[e>>2]|0;g=f[e+4>>2]|0;e=u1c(a|0,g|0,1)|0;n=J;h=k1c(a|0,g|0,63)|0;g=e^h;h=n^J;if((o|0)<=9){fZb(d,g,h);return}o=d+4|0;d=f[o>>2]|0;n=g&255;if(h>>>0>0|(h|0)==0&g>>>0>127){e=d;a=n;m=g;g=h;while(1){b[e>>0]=a|-128;h=m;m=l1c(m|0,g|0,7)|0;j=e+1|0;i=m&255;if(!(g>>>0>0|(g|0)==0&h>>>0>16383)){p=j;q=i;break}else{e=j;a=i;g=J}}}else{p=d;q=n}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q;return}function CYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((f[a>>2]|0)<=0)return;e=c+4|0;c=d+8|0;g=d+4|0;h=a+8|0;i=0;do{j=f[e>>2]|0;if((f[c>>2]|0)>4){k=f[g>>2]|0;if(j>>>0>127){l=j;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=j}b[p>>0]=q;m=p+1-k|0;f[g>>2]=(f[g>>2]|0)+m;l=(f[c>>2]|0)-m|0;f[c>>2]=l;r=l}else{eZb(d,j);r=f[c>>2]|0}l=(f[h>>2]|0)+8+(i<<3)|0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=u1c(m|0,n|0,1)|0;o=J;s=k1c(m|0,n|0,63)|0;n=l^s;s=o^J;if((r|0)>9){o=f[g>>2]|0;l=n&255;if(s>>>0>0|(s|0)==0&n>>>0>127){m=o;t=l;u=n;v=s;while(1){b[m>>0]=t|-128;w=u;u=l1c(u|0,v|0,7)|0;x=m+1|0;y=u&255;if(!(v>>>0>0|(v|0)==0&w>>>0>16383)){z=x;A=y;break}else{m=x;t=y;v=J}}}else{z=o;A=l}b[z>>0]=A;v=z+1-o|0;f[g>>2]=(f[g>>2]|0)+v;f[c>>2]=(f[c>>2]|0)-v}else fZb(d,n,s);i=i+1|0}while((i|0)<(f[a>>2]|0));return}function DYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if(!(f[a>>2]|0))return;e=f[c+4>>2]|0;c=d+8|0;if((f[c>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[c>>2]|0)-n|0;f[c>>2]=g;o=g}else{eZb(d,e);o=f[c>>2]|0}e=f[a+12>>2]|0;if((o|0)>4){o=d+4|0;g=f[o>>2]|0;if(e>>>0>127){n=e;h=g;while(1){b[h>>0]=n|128;m=n>>>7;j=h+1|0;if(n>>>0>16383){n=m;h=j}else{p=j;q=m;break}}}else{p=g;q=e}b[p>>0]=q;q=p+1-g|0;f[o>>2]=(f[o>>2]|0)+q;f[c>>2]=(f[c>>2]|0)-q}else eZb(d,e);if((f[a>>2]|0)<=0)return;e=a+8|0;q=d+4|0;o=0;do{g=(f[e>>2]|0)+8+(o<<3)|0;p=f[g>>2]|0;h=f[g+4>>2]|0;g=u1c(p|0,h|0,1)|0;n=J;m=k1c(p|0,h|0,63)|0;h=g^m;m=n^J;if((f[c>>2]|0)>9){n=f[q>>2]|0;g=h&255;if(m>>>0>0|(m|0)==0&h>>>0>127){p=n;j=g;i=h;k=m;while(1){b[p>>0]=j|-128;l=i;i=l1c(i|0,k|0,7)|0;r=p+1|0;s=i&255;if(!(k>>>0>0|(k|0)==0&l>>>0>16383)){t=r;u=s;break}else{p=r;j=s;k=J}}}else{t=n;u=g}b[t>>0]=u;k=t+1-n|0;f[q>>2]=(f[q>>2]|0)+k;f[c>>2]=(f[c>>2]|0)-k}else fZb(d,h,m);o=o+1|0}while((o|0)<(f[a>>2]|0));return}function EYb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0;h=u;u=u+64|0;i=h+32|0;j=h+8|0;k=h;l=e&1;f[k>>2]=g;g=k+4|0;b[g>>0]=l;if((d|0)<=0){m=f[k>>2]|0;u=h;return m|0}e=j+18|0;o=j+19|0;q=j+12|0;r=j+8|0;s=0;do{t=c+(s*20|0)|0;v=a+(f[t>>2]|0)|0;w=f[c+(s*20|0)+12>>2]|0;a:do switch(w|0){case 0:{x=f[c+(s*20|0)+8>>2]|0;if(1<<(x&31)&f[a+(x>>>5<<2)>>2]|0){x=f[c+(s*20|0)+4>>2]|0;y=f[k>>2]|0;if(x>>>0>127){z=x;A=y;while(1){b[A>>0]=z|128;B=z>>>7;C=A+1|0;if(z>>>0>16383){z=B;A=C}else{D=C;E=B;break}}}else{D=y;E=x}b[D>>0]=E;A=v;z=f[A>>2]|0;B=f[A+4>>2]|0;A=D+1|0;C=A;b[C>>0]=z;b[C+1>>0]=z>>8;b[C+2>>0]=z>>16;b[C+3>>0]=z>>24;z=A+4|0;b[z>>0]=B;b[z+1>>0]=B>>8;b[z+2>>0]=B>>16;b[z+3>>0]=B>>24;f[k>>2]=D+9}break}case 20:{if(!(+p[v>>3]==0.0)){B=f[c+(s*20|0)+4>>2]|0;z=f[k>>2]|0;if(B>>>0>127){A=B;C=z;while(1){b[C>>0]=A|128;F=A>>>7;G=C+1|0;if(A>>>0>16383){A=F;C=G}else{H=G;I=F;break}}}else{H=z;I=B}b[H>>0]=I;C=v;A=f[C>>2]|0;x=f[C+4>>2]|0;C=H+1|0;y=C;b[y>>0]=A;b[y+1>>0]=A>>8;b[y+2>>0]=A>>16;b[y+3>>0]=A>>24;A=C+4|0;b[A>>0]=x;b[A+1>>0]=x>>8;b[A+2>>0]=x>>16;b[A+3>>0]=x>>24;f[k>>2]=H+9}break}case 40:{if((f[v>>2]|0)>0){x=c+(s*20|0)+4|0;A=v+8|0;C=0;y=f[k>>2]|0;do{F=f[x>>2]|0;if(F>>>0>127){G=F;K=y;while(1){b[K>>0]=G|128;L=G>>>7;M=K+1|0;if(G>>>0>16383){G=L;K=M}else{N=M;O=L;break}}}else{N=y;O=F}b[N>>0]=O;K=(f[A>>2]|0)+8+(C<<3)|0;G=f[K>>2]|0;L=f[K+4>>2]|0;K=N+1|0;M=K;b[M>>0]=G;b[M+1>>0]=G>>8;b[M+2>>0]=G>>16;b[M+3>>0]=G>>24;G=K+4|0;b[G>>0]=L;b[G+1>>0]=L>>8;b[G+2>>0]=L>>16;b[G+3>>0]=L>>24;y=N+9|0;f[k>>2]=y;C=C+1|0}while((C|0)<(f[v>>2]|0))}break}case 60:{if(f[v>>2]|0){C=f[c+(s*20|0)+4>>2]|0;y=f[k>>2]|0;if(C>>>0>127){A=C;x=y;while(1){b[x>>0]=A|128;B=A>>>7;z=x+1|0;if(A>>>0>16383){A=B;x=z}else{P=z;Q=B;break}}}else{P=y;Q=C}b[P>>0]=Q;x=P+1|0;f[k>>2]=x;A=f[v+12>>2]|0;if(A>>>0>127){B=A;z=x;while(1){b[z>>0]=B|128;L=B>>>7;G=z+1|0;if(B>>>0>16383){B=L;z=G}else{R=G;S=L;break}}}else{R=x;S=A}b[R>>0]=S;z=R+1|0;f[k>>2]=z;if((f[v>>2]|0)>0){B=v+8|0;C=0;y=z;do{z=(f[B>>2]|0)+8+(C<<3)|0;L=f[z>>2]|0;G=f[z+4>>2]|0;z=y;K=z;b[K>>0]=L;b[K+1>>0]=L>>8;b[K+2>>0]=L>>16;b[K+3>>0]=L>>24;L=z+4|0;b[L>>0]=G;b[L+1>>0]=G>>8;b[L+2>>0]=G>>16;b[L+3>>0]=G>>24;y=y+8|0;f[k>>2]=y;C=C+1|0}while((C|0)<(f[v>>2]|0))}}break}case 80:{C=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(C>>>3|0)){y=f[k>>2]|0;if(C>>>0>127){B=C;A=y;while(1){b[A>>0]=B|128;x=B>>>7;G=A+1|0;if(B>>>0>16383){B=x;A=G}else{T=G;U=x;break}}}else{T=y;U=C}b[T>>0]=U;A=v;B=f[A>>2]|0;x=f[A+4>>2]|0;A=T+1|0;G=A;b[G>>0]=B;b[G+1>>0]=B>>8;b[G+2>>0]=B>>16;b[G+3>>0]=B>>24;B=A+4|0;b[B>>0]=x;b[B+1>>0]=x>>8;b[B+2>>0]=x>>16;b[B+3>>0]=x>>24;f[k>>2]=T+9}break}case 1:{x=f[c+(s*20|0)+8>>2]|0;if(1<<(x&31)&f[a+(x>>>5<<2)>>2]|0){x=f[c+(s*20|0)+4>>2]|0;B=f[k>>2]|0;if(x>>>0>127){A=x;G=B;while(1){b[G>>0]=A|128;L=A>>>7;z=G+1|0;if(A>>>0>16383){A=L;G=z}else{V=z;W=L;break}}}else{V=B;W=x}b[V>>0]=W;G=V+1|0;A=f[v>>2]|0;b[G>>0]=A;b[G+1>>0]=A>>8;b[G+2>>0]=A>>16;b[G+3>>0]=A>>24;f[k>>2]=V+5}break}case 21:{if(!(+n[v>>2]==0.0)){A=f[c+(s*20|0)+4>>2]|0;G=f[k>>2]|0;if(A>>>0>127){C=A;y=G;while(1){b[y>>0]=C|128;L=C>>>7;z=y+1|0;if(C>>>0>16383){C=L;y=z}else{X=z;Y=L;break}}}else{X=G;Y=A}b[X>>0]=Y;y=X+1|0;C=f[v>>2]|0;b[y>>0]=C;b[y+1>>0]=C>>8;b[y+2>>0]=C>>16;b[y+3>>0]=C>>24;f[k>>2]=X+5}break}case 41:{if((f[v>>2]|0)>0){C=c+(s*20|0)+4|0;y=v+8|0;x=0;B=f[k>>2]|0;do{L=f[C>>2]|0;if(L>>>0>127){z=L;K=B;while(1){b[K>>0]=z|128;M=z>>>7;Z=K+1|0;if(z>>>0>16383){z=M;K=Z}else{_=Z;$=M;break}}}else{_=B;$=L}b[_>>0]=$;K=_+1|0;z=f[(f[y>>2]|0)+4+(x<<2)>>2]|0;b[K>>0]=z;b[K+1>>0]=z>>8;b[K+2>>0]=z>>16;b[K+3>>0]=z>>24;B=_+5|0;f[k>>2]=B;x=x+1|0}while((x|0)<(f[v>>2]|0))}break}case 61:{if(f[v>>2]|0){x=f[c+(s*20|0)+4>>2]|0;B=f[k>>2]|0;if(x>>>0>127){y=x;C=B;while(1){b[C>>0]=y|128;A=y>>>7;G=C+1|0;if(y>>>0>16383){y=A;C=G}else{aa=G;ba=A;break}}}else{aa=B;ba=x}b[aa>>0]=ba;C=aa+1|0;f[k>>2]=C;y=f[v+12>>2]|0;if(y>>>0>127){A=y;G=C;while(1){b[G>>0]=A|128;z=A>>>7;K=G+1|0;if(A>>>0>16383){A=z;G=K}else{ca=K;da=z;break}}}else{ca=C;da=y}b[ca>>0]=da;G=ca+1|0;f[k>>2]=G;if((f[v>>2]|0)>0){A=v+8|0;x=0;B=G;do{G=f[(f[A>>2]|0)+4+(x<<2)>>2]|0;b[B>>0]=G;b[B+1>>0]=G>>8;b[B+2>>0]=G>>16;b[B+3>>0]=G>>24;B=B+4|0;f[k>>2]=B;x=x+1|0}while((x|0)<(f[v>>2]|0))}}break}case 81:{x=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(x>>>3|0)){B=f[k>>2]|0;if(x>>>0>127){A=x;y=B;while(1){b[y>>0]=A|128;C=A>>>7;G=y+1|0;if(A>>>0>16383){A=C;y=G}else{ea=G;fa=C;break}}}else{ea=B;fa=x}b[ea>>0]=fa;y=ea+1|0;A=f[v>>2]|0;b[y>>0]=A;b[y+1>>0]=A>>8;b[y+2>>0]=A>>16;b[y+3>>0]=A>>24;f[k>>2]=ea+5}break}case 2:{A=f[c+(s*20|0)+8>>2]|0;if(1<<(A&31)&f[a+(A>>>5<<2)>>2]|0){A=f[c+(s*20|0)+4>>2]|0;y=f[k>>2]|0;if(A>>>0>127){C=A;G=y;while(1){b[G>>0]=C|128;z=C>>>7;K=G+1|0;if(C>>>0>16383){C=z;G=K}else{ga=K;ha=z;break}}}else{ga=y;ha=A}b[ga>>0]=ha;G=ga+1|0;f[k>>2]=G;C=v;x=f[C>>2]|0;B=f[C+4>>2]|0;C=x&255;if(B>>>0>0|(B|0)==0&x>>>0>127){z=G;K=C;F=x;x=B;while(1){b[z>>0]=K|-128;B=F;F=l1c(F|0,x|0,7)|0;M=z+1|0;Z=F&255;if(!(x>>>0>0|(x|0)==0&B>>>0>16383)){ia=M;ja=Z;break}else{z=M;K=Z;x=J}}}else{ia=G;ja=C}b[ia>>0]=ja;f[k>>2]=ia+1}break}case 22:{x=v;if(!((f[x>>2]|0)==0&(f[x+4>>2]|0)==0)){x=f[c+(s*20|0)+4>>2]|0;K=f[k>>2]|0;if(x>>>0>127){z=x;F=K;while(1){b[F>>0]=z|128;A=z>>>7;y=F+1|0;if(z>>>0>16383){z=A;F=y}else{ka=y;la=A;break}}}else{ka=K;la=x}b[ka>>0]=la;F=ka+1|0;f[k>>2]=F;z=v;C=f[z>>2]|0;G=f[z+4>>2]|0;z=C&255;if(G>>>0>0|(G|0)==0&C>>>0>127){A=F;y=z;Z=C;C=G;while(1){b[A>>0]=y|-128;G=Z;Z=l1c(Z|0,C|0,7)|0;M=A+1|0;B=Z&255;if(!(C>>>0>0|(C|0)==0&G>>>0>16383)){ma=M;na=B;break}else{A=M;y=B;C=J}}}else{ma=F;na=z}b[ma>>0]=na;f[k>>2]=ma+1}break}case 42:{if((f[v>>2]|0)>0){C=c+(s*20|0)+4|0;y=v+8|0;A=0;Z=f[k>>2]|0;do{x=f[C>>2]|0;if(x>>>0>127){K=x;B=Z;while(1){b[B>>0]=K|128;M=K>>>7;G=B+1|0;if(K>>>0>16383){K=M;B=G}else{oa=G;pa=M;break}}}else{oa=Z;pa=x}b[oa>>0]=pa;B=oa+1|0;f[k>>2]=B;K=(f[y>>2]|0)+8+(A<<3)|0;L=f[K>>2]|0;M=f[K+4>>2]|0;K=L&255;if(M>>>0>0|(M|0)==0&L>>>0>127){G=B;qa=K;ra=L;L=M;while(1){b[G>>0]=qa|-128;M=ra;ra=l1c(ra|0,L|0,7)|0;sa=G+1|0;ta=ra&255;if(!(L>>>0>0|(L|0)==0&M>>>0>16383)){ua=sa;va=ta;break}else{G=sa;qa=ta;L=J}}}else{ua=B;va=K}b[ua>>0]=va;Z=ua+1|0;f[k>>2]=Z;A=A+1|0}while((A|0)<(f[v>>2]|0))}break}case 62:{if(f[v>>2]|0){A=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(A>>>0>127){y=A;C=Z;while(1){b[C>>0]=y|128;z=y>>>7;F=C+1|0;if(y>>>0>16383){y=z;C=F}else{wa=F;xa=z;break}}}else{wa=Z;xa=A}b[wa>>0]=xa;C=wa+1|0;f[k>>2]=C;y=f[v+12>>2]|0;if(y>>>0>127){z=y;F=C;while(1){b[F>>0]=z|128;L=z>>>7;qa=F+1|0;if(z>>>0>16383){z=L;F=qa}else{ya=qa;za=L;break}}}else{ya=C;za=y}b[ya>>0]=za;F=ya+1|0;f[k>>2]=F;if((f[v>>2]|0)>0){z=v+8|0;A=0;Z=F;do{F=(f[z>>2]|0)+8+(A<<3)|0;L=f[F>>2]|0;qa=f[F+4>>2]|0;F=L&255;if(qa>>>0>0|(qa|0)==0&L>>>0>127){G=Z;ra=F;x=L;L=qa;while(1){b[G>>0]=ra|-128;qa=x;x=l1c(x|0,L|0,7)|0;ta=G+1|0;sa=x&255;if(!(L>>>0>0|(L|0)==0&qa>>>0>16383)){Aa=ta;Ba=sa;break}else{G=ta;ra=sa;L=J}}}else{Aa=Z;Ba=F}b[Aa>>0]=Ba;Z=Aa+1|0;f[k>>2]=Z;A=A+1|0}while((A|0)<(f[v>>2]|0))}}break}case 82:{A=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(A>>>3|0)){Z=f[k>>2]|0;if(A>>>0>127){z=A;y=Z;while(1){b[y>>0]=z|128;C=z>>>7;L=y+1|0;if(z>>>0>16383){z=C;y=L}else{Ca=L;Da=C;break}}}else{Ca=Z;Da=A}b[Ca>>0]=Da;y=Ca+1|0;f[k>>2]=y;z=v;C=f[z>>2]|0;L=f[z+4>>2]|0;z=C&255;if(L>>>0>0|(L|0)==0&C>>>0>127){ra=y;G=z;x=C;C=L;while(1){b[ra>>0]=G|-128;L=x;x=l1c(x|0,C|0,7)|0;K=ra+1|0;B=x&255;if(!(C>>>0>0|(C|0)==0&L>>>0>16383)){Ea=K;Fa=B;break}else{ra=K;G=B;C=J}}}else{Ea=y;Fa=z}b[Ea>>0]=Fa;f[k>>2]=Ea+1}break}case 3:{C=f[c+(s*20|0)+8>>2]|0;if(1<<(C&31)&f[a+(C>>>5<<2)>>2]|0){C=f[c+(s*20|0)+4>>2]|0;G=f[k>>2]|0;if(C>>>0>127){ra=C;x=G;while(1){b[x>>0]=ra|128;A=ra>>>7;Z=x+1|0;if(ra>>>0>16383){ra=A;x=Z}else{Ga=Z;Ha=A;break}}}else{Ga=G;Ha=C}b[Ga>>0]=Ha;x=Ga+1|0;f[k>>2]=x;ra=v;z=f[ra>>2]|0;y=f[ra+4>>2]|0;ra=z&255;if(y>>>0>0|(y|0)==0&z>>>0>127){A=x;Z=ra;B=z;z=y;while(1){b[A>>0]=Z|-128;y=B;B=l1c(B|0,z|0,7)|0;K=A+1|0;L=B&255;if(!(z>>>0>0|(z|0)==0&y>>>0>16383)){Ia=K;Ja=L;break}else{A=K;Z=L;z=J}}}else{Ia=x;Ja=ra}b[Ia>>0]=Ja;f[k>>2]=Ia+1}break}case 23:{z=v;if(!((f[z>>2]|0)==0&(f[z+4>>2]|0)==0)){z=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(z>>>0>127){A=z;B=Z;while(1){b[B>>0]=A|128;C=A>>>7;G=B+1|0;if(A>>>0>16383){A=C;B=G}else{Ka=G;La=C;break}}}else{Ka=Z;La=z}b[Ka>>0]=La;B=Ka+1|0;f[k>>2]=B;A=v;ra=f[A>>2]|0;x=f[A+4>>2]|0;A=ra&255;if(x>>>0>0|(x|0)==0&ra>>>0>127){C=B;G=A;L=ra;ra=x;while(1){b[C>>0]=G|-128;x=L;L=l1c(L|0,ra|0,7)|0;K=C+1|0;y=L&255;if(!(ra>>>0>0|(ra|0)==0&x>>>0>16383)){Ma=K;Na=y;break}else{C=K;G=y;ra=J}}}else{Ma=B;Na=A}b[Ma>>0]=Na;f[k>>2]=Ma+1}break}case 43:{if((f[v>>2]|0)>0){ra=c+(s*20|0)+4|0;G=v+8|0;C=0;L=f[k>>2]|0;do{z=f[ra>>2]|0;if(z>>>0>127){Z=z;y=L;while(1){b[y>>0]=Z|128;K=Z>>>7;x=y+1|0;if(Z>>>0>16383){Z=K;y=x}else{Oa=x;Pa=K;break}}}else{Oa=L;Pa=z}b[Oa>>0]=Pa;y=Oa+1|0;f[k>>2]=y;Z=(f[G>>2]|0)+8+(C<<3)|0;F=f[Z>>2]|0;K=f[Z+4>>2]|0;Z=F&255;if(K>>>0>0|(K|0)==0&F>>>0>127){x=y;sa=Z;ta=F;F=K;while(1){b[x>>0]=sa|-128;K=ta;ta=l1c(ta|0,F|0,7)|0;qa=x+1|0;M=ta&255;if(!(F>>>0>0|(F|0)==0&K>>>0>16383)){Qa=qa;Ra=M;break}else{x=qa;sa=M;F=J}}}else{Qa=y;Ra=Z}b[Qa>>0]=Ra;L=Qa+1|0;f[k>>2]=L;C=C+1|0}while((C|0)<(f[v>>2]|0))}break}case 63:{if(f[v>>2]|0){C=f[c+(s*20|0)+4>>2]|0;L=f[k>>2]|0;if(C>>>0>127){G=C;ra=L;while(1){b[ra>>0]=G|128;A=G>>>7;B=ra+1|0;if(G>>>0>16383){G=A;ra=B}else{Sa=B;Ta=A;break}}}else{Sa=L;Ta=C}b[Sa>>0]=Ta;ra=Sa+1|0;f[k>>2]=ra;G=f[v+12>>2]|0;if(G>>>0>127){A=G;B=ra;while(1){b[B>>0]=A|128;F=A>>>7;sa=B+1|0;if(A>>>0>16383){A=F;B=sa}else{Ua=sa;Va=F;break}}}else{Ua=ra;Va=G}b[Ua>>0]=Va;B=Ua+1|0;f[k>>2]=B;if((f[v>>2]|0)>0){A=v+8|0;C=0;L=B;do{B=(f[A>>2]|0)+8+(C<<3)|0;F=f[B>>2]|0;sa=f[B+4>>2]|0;B=F&255;if(sa>>>0>0|(sa|0)==0&F>>>0>127){x=L;ta=B;z=F;F=sa;while(1){b[x>>0]=ta|-128;sa=z;z=l1c(z|0,F|0,7)|0;M=x+1|0;qa=z&255;if(!(F>>>0>0|(F|0)==0&sa>>>0>16383)){Wa=M;Xa=qa;break}else{x=M;ta=qa;F=J}}}else{Wa=L;Xa=B}b[Wa>>0]=Xa;L=Wa+1|0;f[k>>2]=L;C=C+1|0}while((C|0)<(f[v>>2]|0))}}break}case 83:{C=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(C>>>3|0)){L=f[k>>2]|0;if(C>>>0>127){A=C;G=L;while(1){b[G>>0]=A|128;ra=A>>>7;F=G+1|0;if(A>>>0>16383){A=ra;G=F}else{Ya=F;Za=ra;break}}}else{Ya=L;Za=C}b[Ya>>0]=Za;G=Ya+1|0;f[k>>2]=G;A=v;ra=f[A>>2]|0;F=f[A+4>>2]|0;A=ra&255;if(F>>>0>0|(F|0)==0&ra>>>0>127){ta=G;x=A;z=ra;ra=F;while(1){b[ta>>0]=x|-128;F=z;z=l1c(z|0,ra|0,7)|0;Z=ta+1|0;y=z&255;if(!(ra>>>0>0|(ra|0)==0&F>>>0>16383)){_a=Z;$a=y;break}else{ta=Z;x=y;ra=J}}}else{_a=G;$a=A}b[_a>>0]=$a;f[k>>2]=_a+1}break}case 4:{ra=f[c+(s*20|0)+8>>2]|0;if(1<<(ra&31)&f[a+(ra>>>5<<2)>>2]|0){ra=f[c+(s*20|0)+4>>2]|0;x=f[k>>2]|0;if(ra>>>0>127){ta=ra;z=x;while(1){b[z>>0]=ta|128;C=ta>>>7;L=z+1|0;if(ta>>>0>16383){ta=C;z=L}else{ab=L;bb=C;break}}}else{ab=x;bb=ra}b[ab>>0]=bb;z=ab+1|0;f[k>>2]=z;ta=f[v>>2]|0;A=ta&255;if(ta>>>0>127){G=z;C=A;L=ta;y=((ta|0)<0)<<31>>31;while(1){b[G>>0]=C|-128;ta=L;L=l1c(L|0,y|0,7)|0;Z=G+1|0;F=L&255;if(!(y>>>0>0|(y|0)==0&ta>>>0>16383)){cb=Z;db=F;break}else{G=Z;C=F;y=J}}}else{cb=z;db=A}b[cb>>0]=db;f[k>>2]=cb+1}break}case 24:{if(f[v>>2]|0){y=f[c+(s*20|0)+4>>2]|0;C=f[k>>2]|0;if(y>>>0>127){G=y;L=C;while(1){b[L>>0]=G|128;ra=G>>>7;x=L+1|0;if(G>>>0>16383){G=ra;L=x}else{eb=x;fb=ra;break}}}else{eb=C;fb=y}b[eb>>0]=fb;L=eb+1|0;f[k>>2]=L;G=f[v>>2]|0;A=G&255;if(G>>>0>127){z=L;ra=A;x=G;F=((G|0)<0)<<31>>31;while(1){b[z>>0]=ra|-128;G=x;x=l1c(x|0,F|0,7)|0;Z=z+1|0;ta=x&255;if(!(F>>>0>0|(F|0)==0&G>>>0>16383)){gb=Z;hb=ta;break}else{z=Z;ra=ta;F=J}}}else{gb=L;hb=A}b[gb>>0]=hb;f[k>>2]=gb+1}break}case 44:{if((f[v>>2]|0)>0){F=c+(s*20|0)+4|0;ra=v+8|0;z=0;x=f[k>>2]|0;do{y=f[F>>2]|0;if(y>>>0>127){C=y;ta=x;while(1){b[ta>>0]=C|128;Z=C>>>7;G=ta+1|0;if(C>>>0>16383){C=Z;ta=G}else{ib=G;jb=Z;break}}}else{ib=x;jb=y}b[ib>>0]=jb;ta=ib+1|0;f[k>>2]=ta;C=f[(f[ra>>2]|0)+4+(z<<2)>>2]|0;B=C&255;if(C>>>0>127){Z=ta;G=B;qa=C;M=((C|0)<0)<<31>>31;while(1){b[Z>>0]=G|-128;C=qa;qa=l1c(qa|0,M|0,7)|0;sa=Z+1|0;K=qa&255;if(!(M>>>0>0|(M|0)==0&C>>>0>16383)){kb=sa;lb=K;break}else{Z=sa;G=K;M=J}}}else{kb=ta;lb=B}b[kb>>0]=lb;x=kb+1|0;f[k>>2]=x;z=z+1|0}while((z|0)<(f[v>>2]|0))}break}case 64:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;x=f[k>>2]|0;if(z>>>0>127){ra=z;F=x;while(1){b[F>>0]=ra|128;A=ra>>>7;L=F+1|0;if(ra>>>0>16383){ra=A;F=L}else{mb=L;nb=A;break}}}else{mb=x;nb=z}b[mb>>0]=nb;F=mb+1|0;f[k>>2]=F;ra=f[v+12>>2]|0;if(ra>>>0>127){A=ra;L=F;while(1){b[L>>0]=A|128;M=A>>>7;G=L+1|0;if(A>>>0>16383){A=M;L=G}else{ob=G;pb=M;break}}}else{ob=F;pb=ra}b[ob>>0]=pb;L=ob+1|0;f[k>>2]=L;if((f[v>>2]|0)>0){A=v+8|0;z=0;x=L;do{L=f[(f[A>>2]|0)+4+(z<<2)>>2]|0;M=L&255;if(L>>>0>127){G=x;Z=M;qa=L;y=((L|0)<0)<<31>>31;while(1){b[G>>0]=Z|-128;L=qa;qa=l1c(qa|0,y|0,7)|0;K=G+1|0;sa=qa&255;if(!(y>>>0>0|(y|0)==0&L>>>0>16383)){qb=K;rb=sa;break}else{G=K;Z=sa;y=J}}}else{qb=x;rb=M}b[qb>>0]=rb;x=qb+1|0;f[k>>2]=x;z=z+1|0}while((z|0)<(f[v>>2]|0))}}break}case 84:{z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){x=f[k>>2]|0;if(z>>>0>127){A=z;ra=x;while(1){b[ra>>0]=A|128;F=A>>>7;y=ra+1|0;if(A>>>0>16383){A=F;ra=y}else{sb=y;tb=F;break}}}else{sb=x;tb=z}b[sb>>0]=tb;ra=sb+1|0;f[k>>2]=ra;A=f[v>>2]|0;F=A&255;if(A>>>0>127){y=ra;Z=F;G=A;qa=((A|0)<0)<<31>>31;while(1){b[y>>0]=Z|-128;A=G;G=l1c(G|0,qa|0,7)|0;B=y+1|0;ta=G&255;if(!(qa>>>0>0|(qa|0)==0&A>>>0>16383)){ub=B;vb=ta;break}else{y=B;Z=ta;qa=J}}}else{ub=ra;vb=F}b[ub>>0]=vb;f[k>>2]=ub+1}break}case 5:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(qa>>>0>127){y=qa;G=Z;while(1){b[G>>0]=y|128;z=y>>>7;x=G+1|0;if(y>>>0>16383){y=z;G=x}else{wb=x;xb=z;break}}}else{wb=Z;xb=qa}b[wb>>0]=xb;G=v;y=f[G>>2]|0;F=f[G+4>>2]|0;G=wb+1|0;ra=G;b[ra>>0]=y;b[ra+1>>0]=y>>8;b[ra+2>>0]=y>>16;b[ra+3>>0]=y>>24;y=G+4|0;b[y>>0]=F;b[y+1>>0]=F>>8;b[y+2>>0]=F>>16;b[y+3>>0]=F>>24;f[k>>2]=wb+9}break}case 25:{F=v;if(!((f[F>>2]|0)==0&(f[F+4>>2]|0)==0)){F=f[c+(s*20|0)+4>>2]|0;y=f[k>>2]|0;if(F>>>0>127){G=F;ra=y;while(1){b[ra>>0]=G|128;z=G>>>7;x=ra+1|0;if(G>>>0>16383){G=z;ra=x}else{yb=x;zb=z;break}}}else{yb=y;zb=F}b[yb>>0]=zb;ra=v;G=f[ra>>2]|0;qa=f[ra+4>>2]|0;ra=yb+1|0;Z=ra;b[Z>>0]=G;b[Z+1>>0]=G>>8;b[Z+2>>0]=G>>16;b[Z+3>>0]=G>>24;G=ra+4|0;b[G>>0]=qa;b[G+1>>0]=qa>>8;b[G+2>>0]=qa>>16;b[G+3>>0]=qa>>24;f[k>>2]=yb+9}break}case 45:{if((f[v>>2]|0)>0){qa=c+(s*20|0)+4|0;G=v+8|0;ra=0;Z=f[k>>2]|0;do{z=f[qa>>2]|0;if(z>>>0>127){x=z;ta=Z;while(1){b[ta>>0]=x|128;B=x>>>7;A=ta+1|0;if(x>>>0>16383){x=B;ta=A}else{Ab=A;Bb=B;break}}}else{Ab=Z;Bb=z}b[Ab>>0]=Bb;ta=(f[G>>2]|0)+8+(ra<<3)|0;x=f[ta>>2]|0;M=f[ta+4>>2]|0;ta=Ab+1|0;B=ta;b[B>>0]=x;b[B+1>>0]=x>>8;b[B+2>>0]=x>>16;b[B+3>>0]=x>>24;x=ta+4|0;b[x>>0]=M;b[x+1>>0]=M>>8;b[x+2>>0]=M>>16;b[x+3>>0]=M>>24;Z=Ab+9|0;f[k>>2]=Z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}break}case 65:{if(f[v>>2]|0){ra=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(ra>>>0>127){G=ra;qa=Z;while(1){b[qa>>0]=G|128;F=G>>>7;y=qa+1|0;if(G>>>0>16383){G=F;qa=y}else{Cb=y;Db=F;break}}}else{Cb=Z;Db=ra}b[Cb>>0]=Db;qa=Cb+1|0;f[k>>2]=qa;G=f[v+12>>2]|0;if(G>>>0>127){F=G;y=qa;while(1){b[y>>0]=F|128;M=F>>>7;x=y+1|0;if(F>>>0>16383){F=M;y=x}else{Eb=x;Fb=M;break}}}else{Eb=qa;Fb=G}b[Eb>>0]=Fb;y=Eb+1|0;f[k>>2]=y;if((f[v>>2]|0)>0){F=v+8|0;ra=0;Z=y;do{y=(f[F>>2]|0)+8+(ra<<3)|0;M=f[y>>2]|0;x=f[y+4>>2]|0;y=Z;ta=y;b[ta>>0]=M;b[ta+1>>0]=M>>8;b[ta+2>>0]=M>>16;b[ta+3>>0]=M>>24;M=y+4|0;b[M>>0]=x;b[M+1>>0]=x>>8;b[M+2>>0]=x>>16;b[M+3>>0]=x>>24;Z=Z+8|0;f[k>>2]=Z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}}break}case 85:{ra=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(ra>>>3|0)){Z=f[k>>2]|0;if(ra>>>0>127){F=ra;G=Z;while(1){b[G>>0]=F|128;qa=F>>>7;x=G+1|0;if(F>>>0>16383){F=qa;G=x}else{Gb=x;Hb=qa;break}}}else{Gb=Z;Hb=ra}b[Gb>>0]=Hb;G=v;F=f[G>>2]|0;qa=f[G+4>>2]|0;G=Gb+1|0;x=G;b[x>>0]=F;b[x+1>>0]=F>>8;b[x+2>>0]=F>>16;b[x+3>>0]=F>>24;F=G+4|0;b[F>>0]=qa;b[F+1>>0]=qa>>8;b[F+2>>0]=qa>>16;b[F+3>>0]=qa>>24;f[k>>2]=Gb+9}break}case 6:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;F=f[k>>2]|0;if(qa>>>0>127){G=qa;x=F;while(1){b[x>>0]=G|128;M=G>>>7;y=x+1|0;if(G>>>0>16383){G=M;x=y}else{Ib=y;Jb=M;break}}}else{Ib=F;Jb=qa}b[Ib>>0]=Jb;x=Ib+1|0;G=f[v>>2]|0;b[x>>0]=G;b[x+1>>0]=G>>8;b[x+2>>0]=G>>16;b[x+3>>0]=G>>24;f[k>>2]=Ib+5}break}case 26:{if(f[v>>2]|0){G=f[c+(s*20|0)+4>>2]|0;x=f[k>>2]|0;if(G>>>0>127){ra=G;Z=x;while(1){b[Z>>0]=ra|128;M=ra>>>7;y=Z+1|0;if(ra>>>0>16383){ra=M;Z=y}else{Kb=y;Lb=M;break}}}else{Kb=x;Lb=G}b[Kb>>0]=Lb;Z=Kb+1|0;ra=f[v>>2]|0;b[Z>>0]=ra;b[Z+1>>0]=ra>>8;b[Z+2>>0]=ra>>16;b[Z+3>>0]=ra>>24;f[k>>2]=Kb+5}break}case 46:{if((f[v>>2]|0)>0){ra=c+(s*20|0)+4|0;Z=v+8|0;qa=0;F=f[k>>2]|0;do{M=f[ra>>2]|0;if(M>>>0>127){y=M;ta=F;while(1){b[ta>>0]=y|128;B=y>>>7;A=ta+1|0;if(y>>>0>16383){y=B;ta=A}else{Mb=A;Nb=B;break}}}else{Mb=F;Nb=M}b[Mb>>0]=Nb;ta=Mb+1|0;y=f[(f[Z>>2]|0)+4+(qa<<2)>>2]|0;b[ta>>0]=y;b[ta+1>>0]=y>>8;b[ta+2>>0]=y>>16;b[ta+3>>0]=y>>24;F=Mb+5|0;f[k>>2]=F;qa=qa+1|0}while((qa|0)<(f[v>>2]|0))}break}case 66:{if(f[v>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;F=f[k>>2]|0;if(qa>>>0>127){Z=qa;ra=F;while(1){b[ra>>0]=Z|128;G=Z>>>7;x=ra+1|0;if(Z>>>0>16383){Z=G;ra=x}else{Ob=x;Pb=G;break}}}else{Ob=F;Pb=qa}b[Ob>>0]=Pb;ra=Ob+1|0;f[k>>2]=ra;Z=f[v+12>>2]|0;if(Z>>>0>127){G=Z;x=ra;while(1){b[x>>0]=G|128;y=G>>>7;ta=x+1|0;if(G>>>0>16383){G=y;x=ta}else{Qb=ta;Rb=y;break}}}else{Qb=ra;Rb=Z}b[Qb>>0]=Rb;x=Qb+1|0;f[k>>2]=x;if((f[v>>2]|0)>0){G=v+8|0;qa=0;F=x;do{x=f[(f[G>>2]|0)+4+(qa<<2)>>2]|0;b[F>>0]=x;b[F+1>>0]=x>>8;b[F+2>>0]=x>>16;b[F+3>>0]=x>>24;F=F+4|0;f[k>>2]=F;qa=qa+1|0}while((qa|0)<(f[v>>2]|0))}}break}case 86:{qa=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(qa>>>3|0)){F=f[k>>2]|0;if(qa>>>0>127){G=qa;Z=F;while(1){b[Z>>0]=G|128;ra=G>>>7;x=Z+1|0;if(G>>>0>16383){G=ra;Z=x}else{Sb=x;Tb=ra;break}}}else{Sb=F;Tb=qa}b[Sb>>0]=Tb;Z=Sb+1|0;G=f[v>>2]|0;b[Z>>0]=G;b[Z+1>>0]=G>>8;b[Z+2>>0]=G>>16;b[Z+3>>0]=G>>24;f[k>>2]=Sb+5}break}case 7:{G=f[c+(s*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(G>>>0>127){ra=G;x=Z;while(1){b[x>>0]=ra|128;y=ra>>>7;ta=x+1|0;if(ra>>>0>16383){ra=y;x=ta}else{Ub=ta;Vb=y;break}}}else{Ub=Z;Vb=G}b[Ub>>0]=Vb;b[Ub+1>>0]=b[v>>0]|0;f[k>>2]=Ub+2}break}case 27:{if(b[v>>0]|0){x=f[c+(s*20|0)+4>>2]|0;ra=f[k>>2]|0;if(x>>>0>127){qa=x;F=ra;while(1){b[F>>0]=qa|128;y=qa>>>7;ta=F+1|0;if(qa>>>0>16383){qa=y;F=ta}else{Wb=ta;Xb=y;break}}}else{Wb=ra;Xb=x}b[Wb>>0]=Xb;b[Wb+1>>0]=b[v>>0]|0;f[k>>2]=Wb+2}break}case 47:{if((f[v>>2]|0)>0){F=c+(s*20|0)+4|0;qa=v+8|0;G=0;Z=f[k>>2]|0;do{y=f[F>>2]|0;if(y>>>0>127){ta=y;z=Z;while(1){b[z>>0]=ta|128;B=ta>>>7;A=z+1|0;if(ta>>>0>16383){ta=B;z=A}else{Yb=A;Zb=B;break}}}else{Yb=Z;Zb=y}b[Yb>>0]=Zb;b[Yb+1>>0]=b[(f[qa>>2]|0)+4+G>>0]|0;Z=Yb+2|0;f[k>>2]=Z;G=G+1|0}while((G|0)<(f[v>>2]|0))}break}case 67:{if(f[v>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(G>>>0>127){qa=G;F=Z;while(1){b[F>>0]=qa|128;x=qa>>>7;ra=F+1|0;if(qa>>>0>16383){qa=x;F=ra}else{_b=ra;$b=x;break}}}else{_b=Z;$b=G}b[_b>>0]=$b;F=_b+1|0;f[k>>2]=F;qa=f[v+12>>2]|0;if(qa>>>0>127){x=qa;ra=F;while(1){b[ra>>0]=x|128;z=x>>>7;ta=ra+1|0;if(x>>>0>16383){x=z;ra=ta}else{ac=ta;bc=z;break}}}else{ac=F;bc=qa}b[ac>>0]=bc;ra=ac+1|0;f[k>>2]=ra;if((f[v>>2]|0)>0){x=v+8|0;G=0;Z=ra;do{b[Z>>0]=b[(f[x>>2]|0)+4+G>>0]|0;Z=Z+1|0;f[k>>2]=Z;G=G+1|0}while((G|0)<(f[v>>2]|0))}}break}case 87:{G=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(G>>>3|0)){Z=f[k>>2]|0;if(G>>>0>127){x=G;qa=Z;while(1){b[qa>>0]=x|128;F=x>>>7;ra=qa+1|0;if(x>>>0>16383){x=F;qa=ra}else{cc=ra;dc=F;break}}}else{cc=Z;dc=G}b[cc>>0]=dc;b[cc+1>>0]=b[v>>0]|0;f[k>>2]=cc+2}break}case 8:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;x=f[k>>2]|0;if(qa>>>0>127){F=qa;ra=x;while(1){b[ra>>0]=F|128;z=F>>>7;ta=ra+1|0;if(F>>>0>16383){F=z;ra=ta}else{ec=ta;fc=z;break}}}else{ec=x;fc=qa}b[ec>>0]=fc;ra=ec+1|0;f[k>>2]=ra;F=gZb(f[v>>2]|0,ra)|0;f[k>>2]=F}break}case 28:{F=f[v>>2]|0;ra=b[F+11>>0]|0;if(ra<<24>>24<0)gc=f[F+4>>2]|0;else gc=ra&255;if(gc|0){ra=f[c+(s*20|0)+4>>2]|0;F=f[k>>2]|0;if(ra>>>0>127){G=ra;Z=F;while(1){b[Z>>0]=G|128;z=G>>>7;ta=Z+1|0;if(G>>>0>16383){G=z;Z=ta}else{hc=ta;ic=z;break}}}else{hc=F;ic=ra}b[hc>>0]=ic;Z=hc+1|0;f[k>>2]=Z;G=gZb(f[v>>2]|0,Z)|0;f[k>>2]=G}break}case 48:{G=v+4|0;if((f[G>>2]|0)>0){Z=c+(s*20|0)+4|0;qa=v+12|0;x=0;z=f[k>>2]|0;do{ta=f[Z>>2]|0;if(ta>>>0>127){M=ta;B=z;while(1){b[B>>0]=M|128;A=M>>>7;sa=B+1|0;if(M>>>0>16383){M=A;B=sa}else{jc=sa;kc=A;break}}}else{jc=z;kc=ta}b[jc>>0]=kc;B=jc+1|0;f[k>>2]=B;M=f[qa>>2]|0;z=gZb(f[((M|0)==0?0:M+4|0)+(x<<2)>>2]|0,B)|0;f[k>>2]=z;x=x+1|0}while((x|0)<(f[G>>2]|0))}break}case 68:{FYb(v,t,k);break}case 88:{G=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(G>>>3|0)){x=f[k>>2]|0;if(G>>>0>127){z=G;qa=x;while(1){b[qa>>0]=z|128;Z=z>>>7;ra=qa+1|0;if(z>>>0>16383){z=Z;qa=ra}else{lc=ra;mc=Z;break}}}else{lc=x;mc=G}b[lc>>0]=mc;qa=lc+1|0;f[k>>2]=qa;z=gZb(f[v>>2]|0,qa)|0;f[k>>2]=z}break}case 9:{z=f[c+(s*20|0)+8>>2]|0;if(1<<(z&31)&f[a+(z>>>5<<2)>>2]|0){z=c+(s*20|0)+4|0;qa=f[z>>2]|0;Z=f[k>>2]|0;if(qa>>>0>127){ra=qa;F=Z;while(1){b[F>>0]=ra|128;B=ra>>>7;M=F+1|0;if(ra>>>0>16383){ra=B;F=M}else{nc=M;oc=B;break}}}else{nc=Z;oc=qa}b[nc>>0]=oc;F=nc+1|0;f[k>>2]=F;ra=f[v>>2]|0;G=f[c+(s*20|0)+16>>2]|0;if(!G)pc=hj[f[(f[ra>>2]|0)+64>>2]&511](ra,(b[g>>0]|0)!=0,F)|0;else pc=EYb(ra,(f[G+4>>2]|0)+20|0,(f[G>>2]|0)+-1|0,(b[g>>0]|0)!=0,F)|0;f[k>>2]=pc;F=(f[z>>2]|0)+1|0;if(F>>>0>127){G=F;ra=pc;while(1){b[ra>>0]=G|128;x=G>>>7;B=ra+1|0;if(G>>>0>16383){G=x;ra=B}else{qc=B;rc=x;break}}}else{qc=pc;rc=F}b[qc>>0]=rc;f[k>>2]=qc+1}break}case 29:{if(f[v>>2]|0){ra=c+(s*20|0)+4|0;G=f[ra>>2]|0;z=f[k>>2]|0;if(G>>>0>127){qa=G;Z=z;while(1){b[Z>>0]=qa|128;x=qa>>>7;B=Z+1|0;if(qa>>>0>16383){qa=x;Z=B}else{sc=B;tc=x;break}}}else{sc=z;tc=G}b[sc>>0]=tc;Z=sc+1|0;f[k>>2]=Z;qa=f[v>>2]|0;F=f[c+(s*20|0)+16>>2]|0;if(!F)uc=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,(b[g>>0]|0)!=0,Z)|0;else uc=EYb(qa,(f[F+4>>2]|0)+20|0,(f[F>>2]|0)+-1|0,(b[g>>0]|0)!=0,Z)|0;f[k>>2]=uc;Z=(f[ra>>2]|0)+1|0;if(Z>>>0>127){F=Z;qa=uc;while(1){b[qa>>0]=F|128;x=F>>>7;B=qa+1|0;if(F>>>0>16383){F=x;qa=B}else{vc=B;wc=x;break}}}else{vc=uc;wc=Z}b[vc>>0]=wc;f[k>>2]=vc+1}break}case 49:{qa=v+4|0;if((f[qa>>2]|0)>0){F=c+(s*20|0)+4|0;ra=v+12|0;G=c+(s*20|0)+16|0;z=0;do{x=f[F>>2]|0;B=f[k>>2]|0;if(x>>>0>127){M=x;y=B;while(1){b[y>>0]=M|128;A=M>>>7;sa=y+1|0;if(M>>>0>16383){M=A;y=sa}else{xc=sa;yc=A;break}}}else{xc=B;yc=x}b[xc>>0]=yc;y=xc+1|0;f[k>>2]=y;M=f[ra>>2]|0;ta=f[((M|0)==0?0:M+4|0)+(z<<2)>>2]|0;M=f[G>>2]|0;if(!M)zc=hj[f[(f[ta>>2]|0)+64>>2]&511](ta,(b[g>>0]|0)!=0,y)|0;else zc=EYb(ta,(f[M+4>>2]|0)+20|0,(f[M>>2]|0)+-1|0,(b[g>>0]|0)!=0,y)|0;f[k>>2]=zc;y=(f[F>>2]|0)+1|0;if(y>>>0>127){M=y;ta=zc;while(1){b[ta>>0]=M|128;A=M>>>7;sa=ta+1|0;if(M>>>0>16383){M=A;ta=sa}else{Ac=sa;Bc=A;break}}}else{Ac=zc;Bc=y}b[Ac>>0]=Bc;f[k>>2]=Ac+1;z=z+1|0}while((z|0)<(f[qa>>2]|0))}break}case 69:{FYb(v,t,k);break}case 89:{qa=c+(s*20|0)+4|0;z=f[qa>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){F=f[k>>2]|0;if(z>>>0>127){G=z;ra=F;while(1){b[ra>>0]=G|128;Z=G>>>7;ta=ra+1|0;if(G>>>0>16383){G=Z;ra=ta}else{Cc=ta;Dc=Z;break}}}else{Cc=F;Dc=z}b[Cc>>0]=Dc;ra=Cc+1|0;f[k>>2]=ra;G=f[v>>2]|0;Z=f[c+(s*20|0)+16>>2]|0;if(!Z)Ec=hj[f[(f[G>>2]|0)+64>>2]&511](G,(b[g>>0]|0)!=0,ra)|0;else Ec=EYb(G,(f[Z+4>>2]|0)+20|0,(f[Z>>2]|0)+-1|0,(b[g>>0]|0)!=0,ra)|0;f[k>>2]=Ec;ra=(f[qa>>2]|0)+1|0;if(ra>>>0>127){Z=ra;G=Ec;while(1){b[G>>0]=Z|128;ta=Z>>>7;M=G+1|0;if(Z>>>0>16383){Z=ta;G=M}else{Fc=M;Gc=ta;break}}}else{Fc=Ec;Gc=ra}b[Fc>>0]=Gc;f[k>>2]=Fc+1}break}case 10:{G=f[c+(s*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(G>>>0>127){qa=G;z=Z;while(1){b[z>>0]=qa|128;F=qa>>>7;ta=z+1|0;if(qa>>>0>16383){qa=F;z=ta}else{Hc=ta;Ic=F;break}}}else{Hc=Z;Ic=G}b[Hc>>0]=Ic;z=Hc+1|0;f[k>>2]=z;qa=f[v>>2]|0;ra=f[c+(s*20|0)+16>>2]|0;if(!ra){F=_i[f[(f[qa>>2]|0)+60>>2]&2047](qa)|0;ta=f[k>>2]|0;if(F>>>0>127){M=F;x=ta;while(1){b[x>>0]=M|128;B=M>>>7;A=x+1|0;if(M>>>0>16383){M=B;x=A}else{Jc=A;Kc=B;break}}}else{Jc=ta;Kc=F}b[Jc>>0]=Kc;x=Jc+1|0;f[k>>2]=x;M=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,(b[g>>0]|0)!=0,x)|0;f[k>>2]=M;break a}else{M=f[ra+4>>2]|0;x=f[qa+(f[M>>2]|0)>>2]|0;if(x>>>0>127){G=x;Z=z;while(1){b[Z>>0]=G|128;B=G>>>7;A=Z+1|0;if(G>>>0>16383){G=B;Z=A}else{Lc=A;Mc=B;break}}}else{Lc=z;Mc=x}b[Lc>>0]=Mc;Z=Lc+1|0;f[k>>2]=Z;G=EYb(qa,M+20|0,(f[ra>>2]|0)+-1|0,(b[g>>0]|0)!=0,Z)|0;f[k>>2]=G;break a}}break}case 30:{if(f[v>>2]|0){G=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(G>>>0>127){F=G;ta=Z;while(1){b[ta>>0]=F|128;B=F>>>7;A=ta+1|0;if(F>>>0>16383){F=B;ta=A}else{Nc=A;Oc=B;break}}}else{Nc=Z;Oc=G}b[Nc>>0]=Oc;ta=Nc+1|0;f[k>>2]=ta;F=f[v>>2]|0;ra=f[c+(s*20|0)+16>>2]|0;if(!ra){M=_i[f[(f[F>>2]|0)+60>>2]&2047](F)|0;qa=f[k>>2]|0;if(M>>>0>127){x=M;z=qa;while(1){b[z>>0]=x|128;B=x>>>7;A=z+1|0;if(x>>>0>16383){x=B;z=A}else{Pc=A;Qc=B;break}}}else{Pc=qa;Qc=M}b[Pc>>0]=Qc;z=Pc+1|0;f[k>>2]=z;x=hj[f[(f[F>>2]|0)+64>>2]&511](F,(b[g>>0]|0)!=0,z)|0;f[k>>2]=x;break a}else{x=f[ra+4>>2]|0;z=f[F+(f[x>>2]|0)>>2]|0;if(z>>>0>127){G=z;Z=ta;while(1){b[Z>>0]=G|128;B=G>>>7;A=Z+1|0;if(G>>>0>16383){G=B;Z=A}else{Rc=A;Sc=B;break}}}else{Rc=ta;Sc=z}b[Rc>>0]=Sc;Z=Rc+1|0;f[k>>2]=Z;G=EYb(F,x+20|0,(f[ra>>2]|0)+-1|0,(b[g>>0]|0)!=0,Z)|0;f[k>>2]=G;break a}}break}case 50:{G=v+4|0;if((f[G>>2]|0)>0){Z=c+(s*20|0)+4|0;M=v+12|0;qa=c+(s*20|0)+16|0;B=0;do{A=f[Z>>2]|0;sa=f[k>>2]|0;if(A>>>0>127){K=A;L=sa;while(1){b[L>>0]=K|128;C=K>>>7;Tc=L+1|0;if(K>>>0>16383){K=C;L=Tc}else{Uc=Tc;Vc=C;break}}}else{Uc=sa;Vc=A}b[Uc>>0]=Vc;L=Uc+1|0;f[k>>2]=L;K=f[M>>2]|0;y=f[((K|0)==0?0:K+4|0)+(B<<2)>>2]|0;K=f[qa>>2]|0;if(!K){C=_i[f[(f[y>>2]|0)+60>>2]&2047](y)|0;Tc=f[k>>2]|0;if(C>>>0>127){Wc=C;Xc=Tc;while(1){b[Xc>>0]=Wc|128;Yc=Wc>>>7;Zc=Xc+1|0;if(Wc>>>0>16383){Wc=Yc;Xc=Zc}else{_c=Zc;$c=Yc;break}}}else{_c=Tc;$c=C}b[_c>>0]=$c;Xc=_c+1|0;f[k>>2]=Xc;ad=hj[f[(f[y>>2]|0)+64>>2]&511](y,(b[g>>0]|0)!=0,Xc)|0}else{Xc=f[K+4>>2]|0;Wc=f[y+(f[Xc>>2]|0)>>2]|0;if(Wc>>>0>127){A=Wc;sa=L;while(1){b[sa>>0]=A|128;Yc=A>>>7;Zc=sa+1|0;if(A>>>0>16383){A=Yc;sa=Zc}else{bd=Zc;cd=Yc;break}}}else{bd=L;cd=Wc}b[bd>>0]=cd;sa=bd+1|0;f[k>>2]=sa;ad=EYb(y,Xc+20|0,(f[K>>2]|0)+-1|0,(b[g>>0]|0)!=0,sa)|0}f[k>>2]=ad;B=B+1|0}while((B|0)<(f[G>>2]|0))}break}case 70:{FYb(v,t,k);break}case 90:{G=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(G>>>3|0)){B=f[k>>2]|0;if(G>>>0>127){qa=G;M=B;while(1){b[M>>0]=qa|128;Z=qa>>>7;ra=M+1|0;if(qa>>>0>16383){qa=Z;M=ra}else{dd=ra;ed=Z;break}}}else{dd=B;ed=G}b[dd>>0]=ed;M=dd+1|0;f[k>>2]=M;qa=f[v>>2]|0;Z=f[c+(s*20|0)+16>>2]|0;if(!Z){ra=_i[f[(f[qa>>2]|0)+60>>2]&2047](qa)|0;x=f[k>>2]|0;if(ra>>>0>127){F=ra;z=x;while(1){b[z>>0]=F|128;ta=F>>>7;sa=z+1|0;if(F>>>0>16383){F=ta;z=sa}else{fd=sa;gd=ta;break}}}else{fd=x;gd=ra}b[fd>>0]=gd;z=fd+1|0;f[k>>2]=z;F=hj[f[(f[qa>>2]|0)+64>>2]&511](qa,(b[g>>0]|0)!=0,z)|0;f[k>>2]=F;break a}else{F=f[Z+4>>2]|0;z=f[qa+(f[F>>2]|0)>>2]|0;if(z>>>0>127){G=z;B=M;while(1){b[B>>0]=G|128;ta=G>>>7;sa=B+1|0;if(G>>>0>16383){G=ta;B=sa}else{hd=sa;id=ta;break}}}else{hd=M;id=z}b[hd>>0]=id;B=hd+1|0;f[k>>2]=B;G=EYb(qa,F+20|0,(f[Z>>2]|0)+-1|0,(b[g>>0]|0)!=0,B)|0;f[k>>2]=G;break a}}break}case 11:{G=f[c+(s*20|0)+8>>2]|0;if(1<<(G&31)&f[a+(G>>>5<<2)>>2]|0){G=f[c+(s*20|0)+4>>2]|0;B=f[k>>2]|0;if(G>>>0>127){ra=G;x=B;while(1){b[x>>0]=ra|128;ta=ra>>>7;sa=x+1|0;if(ra>>>0>16383){ra=ta;x=sa}else{jd=sa;kd=ta;break}}}else{jd=B;kd=G}b[jd>>0]=kd;x=jd+1|0;f[k>>2]=x;ra=gZb(f[v>>2]|0,x)|0;f[k>>2]=ra}break}case 31:{ra=f[v>>2]|0;x=b[ra+11>>0]|0;if(x<<24>>24<0)ld=f[ra+4>>2]|0;else ld=x&255;if(ld|0){x=f[c+(s*20|0)+4>>2]|0;ra=f[k>>2]|0;if(x>>>0>127){Z=x;F=ra;while(1){b[F>>0]=Z|128;qa=Z>>>7;z=F+1|0;if(Z>>>0>16383){Z=qa;F=z}else{md=z;nd=qa;break}}}else{md=ra;nd=x}b[md>>0]=nd;F=md+1|0;f[k>>2]=F;Z=gZb(f[v>>2]|0,F)|0;f[k>>2]=Z}break}case 51:{Z=v+4|0;if((f[Z>>2]|0)>0){F=c+(s*20|0)+4|0;G=v+12|0;B=0;qa=f[k>>2]|0;do{z=f[F>>2]|0;if(z>>>0>127){M=z;ta=qa;while(1){b[ta>>0]=M|128;sa=M>>>7;A=ta+1|0;if(M>>>0>16383){M=sa;ta=A}else{od=A;pd=sa;break}}}else{od=qa;pd=z}b[od>>0]=pd;ta=od+1|0;f[k>>2]=ta;M=f[G>>2]|0;qa=gZb(f[((M|0)==0?0:M+4|0)+(B<<2)>>2]|0,ta)|0;f[k>>2]=qa;B=B+1|0}while((B|0)<(f[Z>>2]|0))}break}case 71:{FYb(v,t,k);break}case 91:{Z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(Z>>>3|0)){B=f[k>>2]|0;if(Z>>>0>127){qa=Z;G=B;while(1){b[G>>0]=qa|128;F=qa>>>7;x=G+1|0;if(qa>>>0>16383){qa=F;G=x}else{qd=x;rd=F;break}}}else{qd=B;rd=Z}b[qd>>0]=rd;G=qd+1|0;f[k>>2]=G;qa=gZb(f[v>>2]|0,G)|0;f[k>>2]=qa}break}case 12:{qa=f[c+(s*20|0)+8>>2]|0;if(1<<(qa&31)&f[a+(qa>>>5<<2)>>2]|0){qa=f[c+(s*20|0)+4>>2]|0;G=f[k>>2]|0;if(qa>>>0>127){F=qa;x=G;while(1){b[x>>0]=F|128;ra=F>>>7;ta=x+1|0;if(F>>>0>16383){F=ra;x=ta}else{sd=ta;td=ra;break}}}else{sd=G;td=qa}b[sd>>0]=td;x=sd+1|0;f[k>>2]=x;F=f[v>>2]|0;if(F>>>0>127){Z=F;B=x;while(1){b[B>>0]=Z|128;ra=Z>>>7;ta=B+1|0;if(Z>>>0>16383){Z=ra;B=ta}else{ud=ta;vd=ra;break}}}else{ud=x;vd=F}b[ud>>0]=vd;f[k>>2]=ud+1}break}case 32:{if(f[v>>2]|0){B=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(B>>>0>127){qa=B;G=Z;while(1){b[G>>0]=qa|128;ra=qa>>>7;ta=G+1|0;if(qa>>>0>16383){qa=ra;G=ta}else{wd=ta;xd=ra;break}}}else{wd=Z;xd=B}b[wd>>0]=xd;G=wd+1|0;f[k>>2]=G;qa=f[v>>2]|0;if(qa>>>0>127){F=qa;x=G;while(1){b[x>>0]=F|128;ra=F>>>7;ta=x+1|0;if(F>>>0>16383){F=ra;x=ta}else{yd=ta;zd=ra;break}}}else{yd=G;zd=qa}b[yd>>0]=zd;f[k>>2]=yd+1}break}case 52:{if((f[v>>2]|0)>0){x=c+(s*20|0)+4|0;F=v+8|0;B=0;Z=f[k>>2]|0;do{ra=f[x>>2]|0;if(ra>>>0>127){ta=ra;M=Z;while(1){b[M>>0]=ta|128;K=ta>>>7;Xc=M+1|0;if(ta>>>0>16383){ta=K;M=Xc}else{Ad=Xc;Bd=K;break}}}else{Ad=Z;Bd=ra}b[Ad>>0]=Bd;M=Ad+1|0;f[k>>2]=M;ta=f[(f[F>>2]|0)+4+(B<<2)>>2]|0;if(ta>>>0>127){z=ta;K=M;while(1){b[K>>0]=z|128;Xc=z>>>7;y=K+1|0;if(z>>>0>16383){z=Xc;K=y}else{Cd=y;Dd=Xc;break}}}else{Cd=M;Dd=ta}b[Cd>>0]=Dd;Z=Cd+1|0;f[k>>2]=Z;B=B+1|0}while((B|0)<(f[v>>2]|0))}break}case 72:{if(f[v>>2]|0){B=f[c+(s*20|0)+4>>2]|0;Z=f[k>>2]|0;if(B>>>0>127){F=B;x=Z;while(1){b[x>>0]=F|128;qa=F>>>7;G=x+1|0;if(F>>>0>16383){F=qa;x=G}else{Ed=G;Fd=qa;break}}}else{Ed=Z;Fd=B}b[Ed>>0]=Fd;x=Ed+1|0;f[k>>2]=x;F=f[v+12>>2]|0;if(F>>>0>127){qa=F;G=x;while(1){b[G>>0]=qa|128;K=qa>>>7;z=G+1|0;if(qa>>>0>16383){qa=K;G=z}else{Gd=z;Hd=K;break}}}else{Gd=x;Hd=F}b[Gd>>0]=Hd;G=Gd+1|0;f[k>>2]=G;if((f[v>>2]|0)>0){qa=v+8|0;B=0;Z=G;do{G=f[(f[qa>>2]|0)+4+(B<<2)>>2]|0;if(G>>>0>127){K=G;z=Z;while(1){b[z>>0]=K|128;ra=K>>>7;Xc=z+1|0;if(K>>>0>16383){K=ra;z=Xc}else{Id=Xc;Jd=ra;break}}}else{Id=Z;Jd=G}b[Id>>0]=Jd;Z=Id+1|0;f[k>>2]=Z;B=B+1|0}while((B|0)<(f[v>>2]|0))}}break}case 92:{B=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(B>>>3|0)){Z=f[k>>2]|0;if(B>>>0>127){qa=B;F=Z;while(1){b[F>>0]=qa|128;x=qa>>>7;z=F+1|0;if(qa>>>0>16383){qa=x;F=z}else{Kd=z;Ld=x;break}}}else{Kd=Z;Ld=B}b[Kd>>0]=Ld;F=Kd+1|0;f[k>>2]=F;qa=f[v>>2]|0;if(qa>>>0>127){x=qa;z=F;while(1){b[z>>0]=x|128;K=x>>>7;ta=z+1|0;if(x>>>0>16383){x=K;z=ta}else{Md=ta;Nd=K;break}}}else{Md=F;Nd=qa}b[Md>>0]=Nd;f[k>>2]=Md+1}break}case 13:{z=f[c+(s*20|0)+8>>2]|0;if(1<<(z&31)&f[a+(z>>>5<<2)>>2]|0){z=f[c+(s*20|0)+4>>2]|0;x=f[k>>2]|0;if(z>>>0>127){B=z;Z=x;while(1){b[Z>>0]=B|128;K=B>>>7;ta=Z+1|0;if(B>>>0>16383){B=K;Z=ta}else{Od=ta;Pd=K;break}}}else{Od=x;Pd=z}b[Od>>0]=Pd;Z=Od+1|0;f[k>>2]=Z;B=f[v>>2]|0;qa=B&255;if(B>>>0>127){F=Z;K=qa;ta=B;M=((B|0)<0)<<31>>31;while(1){b[F>>0]=K|-128;B=ta;ta=l1c(ta|0,M|0,7)|0;ra=F+1|0;Xc=ta&255;if(!(M>>>0>0|(M|0)==0&B>>>0>16383)){Qd=ra;Rd=Xc;break}else{F=ra;K=Xc;M=J}}}else{Qd=Z;Rd=qa}b[Qd>>0]=Rd;f[k>>2]=Qd+1}break}case 33:{if(f[v>>2]|0){M=f[c+(s*20|0)+4>>2]|0;K=f[k>>2]|0;if(M>>>0>127){F=M;ta=K;while(1){b[ta>>0]=F|128;z=F>>>7;x=ta+1|0;if(F>>>0>16383){F=z;ta=x}else{Sd=x;Td=z;break}}}else{Sd=K;Td=M}b[Sd>>0]=Td;ta=Sd+1|0;f[k>>2]=ta;F=f[v>>2]|0;qa=F&255;if(F>>>0>127){Z=ta;z=qa;x=F;Xc=((F|0)<0)<<31>>31;while(1){b[Z>>0]=z|-128;F=x;x=l1c(x|0,Xc|0,7)|0;ra=Z+1|0;B=x&255;if(!(Xc>>>0>0|(Xc|0)==0&F>>>0>16383)){Ud=ra;Vd=B;break}else{Z=ra;z=B;Xc=J}}}else{Ud=ta;Vd=qa}b[Ud>>0]=Vd;f[k>>2]=Ud+1}break}case 53:{if((f[v>>2]|0)>0){Xc=c+(s*20|0)+4|0;z=v+8|0;Z=0;x=f[k>>2]|0;do{M=f[Xc>>2]|0;if(M>>>0>127){K=M;B=x;while(1){b[B>>0]=K|128;ra=K>>>7;F=B+1|0;if(K>>>0>16383){K=ra;B=F}else{Wd=F;Xd=ra;break}}}else{Wd=x;Xd=M}b[Wd>>0]=Xd;B=Wd+1|0;f[k>>2]=B;K=f[(f[z>>2]|0)+4+(Z<<2)>>2]|0;G=K&255;if(K>>>0>127){ra=B;F=G;y=K;Wc=((K|0)<0)<<31>>31;while(1){b[ra>>0]=F|-128;K=y;y=l1c(y|0,Wc|0,7)|0;L=ra+1|0;sa=y&255;if(!(Wc>>>0>0|(Wc|0)==0&K>>>0>16383)){Yd=L;Zd=sa;break}else{ra=L;F=sa;Wc=J}}}else{Yd=B;Zd=G}b[Yd>>0]=Zd;x=Yd+1|0;f[k>>2]=x;Z=Z+1|0}while((Z|0)<(f[v>>2]|0))}break}case 73:{if(f[v>>2]|0){Z=f[c+(s*20|0)+4>>2]|0;x=f[k>>2]|0;if(Z>>>0>127){z=Z;Xc=x;while(1){b[Xc>>0]=z|128;qa=z>>>7;ta=Xc+1|0;if(z>>>0>16383){z=qa;Xc=ta}else{_d=ta;$d=qa;break}}}else{_d=x;$d=Z}b[_d>>0]=$d;Xc=_d+1|0;f[k>>2]=Xc;z=f[v+12>>2]|0;if(z>>>0>127){qa=z;ta=Xc;while(1){b[ta>>0]=qa|128;Wc=qa>>>7;F=ta+1|0;if(qa>>>0>16383){qa=Wc;ta=F}else{ae=F;be=Wc;break}}}else{ae=Xc;be=z}b[ae>>0]=be;ta=ae+1|0;f[k>>2]=ta;if((f[v>>2]|0)>0){qa=v+8|0;Z=0;x=ta;do{ta=f[(f[qa>>2]|0)+4+(Z<<2)>>2]|0;Wc=ta&255;if(ta>>>0>127){F=x;ra=Wc;y=ta;M=((ta|0)<0)<<31>>31;while(1){b[F>>0]=ra|-128;ta=y;y=l1c(y|0,M|0,7)|0;sa=F+1|0;L=y&255;if(!(M>>>0>0|(M|0)==0&ta>>>0>16383)){ce=sa;de=L;break}else{F=sa;ra=L;M=J}}}else{ce=x;de=Wc}b[ce>>0]=de;x=ce+1|0;f[k>>2]=x;Z=Z+1|0}while((Z|0)<(f[v>>2]|0))}}break}case 93:{Z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(Z>>>3|0)){x=f[k>>2]|0;if(Z>>>0>127){qa=Z;z=x;while(1){b[z>>0]=qa|128;Xc=qa>>>7;M=z+1|0;if(qa>>>0>16383){qa=Xc;z=M}else{ee=M;fe=Xc;break}}}else{ee=x;fe=Z}b[ee>>0]=fe;z=ee+1|0;f[k>>2]=z;qa=f[v>>2]|0;Xc=qa&255;if(qa>>>0>127){M=z;ra=Xc;F=qa;y=((qa|0)<0)<<31>>31;while(1){b[M>>0]=ra|-128;qa=F;F=l1c(F|0,y|0,7)|0;G=M+1|0;B=F&255;if(!(y>>>0>0|(y|0)==0&qa>>>0>16383)){ge=G;he=B;break}else{M=G;ra=B;y=J}}}else{ge=z;he=Xc}b[ge>>0]=he;f[k>>2]=ge+1}break}case 14:{y=f[c+(s*20|0)+8>>2]|0;if(1<<(y&31)&f[a+(y>>>5<<2)>>2]|0){y=f[c+(s*20|0)+4>>2]|0;ra=f[k>>2]|0;if(y>>>0>127){M=y;F=ra;while(1){b[F>>0]=M|128;Z=M>>>7;x=F+1|0;if(M>>>0>16383){M=Z;F=x}else{ie=x;je=Z;break}}}else{ie=ra;je=y}b[ie>>0]=je;F=ie+1|0;M=f[v>>2]|0;b[F>>0]=M;b[F+1>>0]=M>>8;b[F+2>>0]=M>>16;b[F+3>>0]=M>>24;f[k>>2]=ie+5}break}case 34:{if(f[v>>2]|0){M=f[c+(s*20|0)+4>>2]|0;F=f[k>>2]|0;if(M>>>0>127){Xc=M;z=F;while(1){b[z>>0]=Xc|128;Z=Xc>>>7;x=z+1|0;if(Xc>>>0>16383){Xc=Z;z=x}else{ke=x;le=Z;break}}}else{ke=F;le=M}b[ke>>0]=le;z=ke+1|0;Xc=f[v>>2]|0;b[z>>0]=Xc;b[z+1>>0]=Xc>>8;b[z+2>>0]=Xc>>16;b[z+3>>0]=Xc>>24;f[k>>2]=ke+5}break}case 54:{if((f[v>>2]|0)>0){Xc=c+(s*20|0)+4|0;z=v+8|0;y=0;ra=f[k>>2]|0;do{Z=f[Xc>>2]|0;if(Z>>>0>127){x=Z;B=ra;while(1){b[B>>0]=x|128;G=x>>>7;qa=B+1|0;if(x>>>0>16383){x=G;B=qa}else{me=qa;ne=G;break}}}else{me=ra;ne=Z}b[me>>0]=ne;B=me+1|0;x=f[(f[z>>2]|0)+4+(y<<2)>>2]|0;b[B>>0]=x;b[B+1>>0]=x>>8;b[B+2>>0]=x>>16;b[B+3>>0]=x>>24;ra=me+5|0;f[k>>2]=ra;y=y+1|0}while((y|0)<(f[v>>2]|0))}break}case 74:{if(f[v>>2]|0){y=f[c+(s*20|0)+4>>2]|0;ra=f[k>>2]|0;if(y>>>0>127){z=y;Xc=ra;while(1){b[Xc>>0]=z|128;M=z>>>7;F=Xc+1|0;if(z>>>0>16383){z=M;Xc=F}else{oe=F;pe=M;break}}}else{oe=ra;pe=y}b[oe>>0]=pe;Xc=oe+1|0;f[k>>2]=Xc;z=f[v+12>>2]|0;if(z>>>0>127){M=z;F=Xc;while(1){b[F>>0]=M|128;x=M>>>7;B=F+1|0;if(M>>>0>16383){M=x;F=B}else{qe=B;re=x;break}}}else{qe=Xc;re=z}b[qe>>0]=re;F=qe+1|0;f[k>>2]=F;if((f[v>>2]|0)>0){M=v+8|0;y=0;ra=F;do{F=f[(f[M>>2]|0)+4+(y<<2)>>2]|0;b[ra>>0]=F;b[ra+1>>0]=F>>8;b[ra+2>>0]=F>>16;b[ra+3>>0]=F>>24;ra=ra+4|0;f[k>>2]=ra;y=y+1|0}while((y|0)<(f[v>>2]|0))}}break}case 94:{y=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(y>>>3|0)){ra=f[k>>2]|0;if(y>>>0>127){M=y;z=ra;while(1){b[z>>0]=M|128;Xc=M>>>7;F=z+1|0;if(M>>>0>16383){M=Xc;z=F}else{se=F;te=Xc;break}}}else{se=ra;te=y}b[se>>0]=te;z=se+1|0;M=f[v>>2]|0;b[z>>0]=M;b[z+1>>0]=M>>8;b[z+2>>0]=M>>16;b[z+3>>0]=M>>24;f[k>>2]=se+5}break}case 15:{M=f[c+(s*20|0)+8>>2]|0;if(1<<(M&31)&f[a+(M>>>5<<2)>>2]|0){M=f[c+(s*20|0)+4>>2]|0;z=f[k>>2]|0;if(M>>>0>127){Xc=M;F=z;while(1){b[F>>0]=Xc|128;x=Xc>>>7;B=F+1|0;if(Xc>>>0>16383){Xc=x;F=B}else{ue=B;ve=x;break}}}else{ue=z;ve=M}b[ue>>0]=ve;F=v;Xc=f[F>>2]|0;y=f[F+4>>2]|0;F=ue+1|0;ra=F;b[ra>>0]=Xc;b[ra+1>>0]=Xc>>8;b[ra+2>>0]=Xc>>16;b[ra+3>>0]=Xc>>24;Xc=F+4|0;b[Xc>>0]=y;b[Xc+1>>0]=y>>8;b[Xc+2>>0]=y>>16;b[Xc+3>>0]=y>>24;f[k>>2]=ue+9}break}case 35:{y=v;if(!((f[y>>2]|0)==0&(f[y+4>>2]|0)==0)){y=f[c+(s*20|0)+4>>2]|0;Xc=f[k>>2]|0;if(y>>>0>127){F=y;ra=Xc;while(1){b[ra>>0]=F|128;x=F>>>7;B=ra+1|0;if(F>>>0>16383){F=x;ra=B}else{we=B;xe=x;break}}}else{we=Xc;xe=y}b[we>>0]=xe;ra=v;F=f[ra>>2]|0;M=f[ra+4>>2]|0;ra=we+1|0;z=ra;b[z>>0]=F;b[z+1>>0]=F>>8;b[z+2>>0]=F>>16;b[z+3>>0]=F>>24;F=ra+4|0;b[F>>0]=M;b[F+1>>0]=M>>8;b[F+2>>0]=M>>16;b[F+3>>0]=M>>24;f[k>>2]=we+9}break}case 55:{if((f[v>>2]|0)>0){M=c+(s*20|0)+4|0;F=v+8|0;ra=0;z=f[k>>2]|0;do{x=f[M>>2]|0;if(x>>>0>127){B=x;Wc=z;while(1){b[Wc>>0]=B|128;G=B>>>7;qa=Wc+1|0;if(B>>>0>16383){B=G;Wc=qa}else{ye=qa;ze=G;break}}}else{ye=z;ze=x}b[ye>>0]=ze;Wc=(f[F>>2]|0)+8+(ra<<3)|0;B=f[Wc>>2]|0;Z=f[Wc+4>>2]|0;Wc=ye+1|0;G=Wc;b[G>>0]=B;b[G+1>>0]=B>>8;b[G+2>>0]=B>>16;b[G+3>>0]=B>>24;B=Wc+4|0;b[B>>0]=Z;b[B+1>>0]=Z>>8;b[B+2>>0]=Z>>16;b[B+3>>0]=Z>>24;z=ye+9|0;f[k>>2]=z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}break}case 75:{if(f[v>>2]|0){ra=f[c+(s*20|0)+4>>2]|0;z=f[k>>2]|0;if(ra>>>0>127){F=ra;M=z;while(1){b[M>>0]=F|128;y=F>>>7;Xc=M+1|0;if(F>>>0>16383){F=y;M=Xc}else{Ae=Xc;Be=y;break}}}else{Ae=z;Be=ra}b[Ae>>0]=Be;M=Ae+1|0;f[k>>2]=M;F=f[v+12>>2]|0;if(F>>>0>127){y=F;Xc=M;while(1){b[Xc>>0]=y|128;Z=y>>>7;B=Xc+1|0;if(y>>>0>16383){y=Z;Xc=B}else{Ce=B;De=Z;break}}}else{Ce=M;De=F}b[Ce>>0]=De;Xc=Ce+1|0;f[k>>2]=Xc;if((f[v>>2]|0)>0){y=v+8|0;ra=0;z=Xc;do{Xc=(f[y>>2]|0)+8+(ra<<3)|0;Z=f[Xc>>2]|0;B=f[Xc+4>>2]|0;Xc=z;Wc=Xc;b[Wc>>0]=Z;b[Wc+1>>0]=Z>>8;b[Wc+2>>0]=Z>>16;b[Wc+3>>0]=Z>>24;Z=Xc+4|0;b[Z>>0]=B;b[Z+1>>0]=B>>8;b[Z+2>>0]=B>>16;b[Z+3>>0]=B>>24;z=z+8|0;f[k>>2]=z;ra=ra+1|0}while((ra|0)<(f[v>>2]|0))}}break}case 95:{ra=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(ra>>>3|0)){z=f[k>>2]|0;if(ra>>>0>127){y=ra;F=z;while(1){b[F>>0]=y|128;M=y>>>7;B=F+1|0;if(y>>>0>16383){y=M;F=B}else{Ee=B;Fe=M;break}}}else{Ee=z;Fe=ra}b[Ee>>0]=Fe;F=v;y=f[F>>2]|0;M=f[F+4>>2]|0;F=Ee+1|0;B=F;b[B>>0]=y;b[B+1>>0]=y>>8;b[B+2>>0]=y>>16;b[B+3>>0]=y>>24;y=F+4|0;b[y>>0]=M;b[y+1>>0]=M>>8;b[y+2>>0]=M>>16;b[y+3>>0]=M>>24;f[k>>2]=Ee+9}break}case 16:{M=f[c+(s*20|0)+8>>2]|0;if(1<<(M&31)&f[a+(M>>>5<<2)>>2]|0){M=f[c+(s*20|0)+4>>2]|0;y=f[k>>2]|0;if(M>>>0>127){F=M;B=y;while(1){b[B>>0]=F|128;Z=F>>>7;Xc=B+1|0;if(F>>>0>16383){F=Z;B=Xc}else{Ge=Xc;He=Z;break}}}else{Ge=y;He=M}b[Ge>>0]=He;B=Ge+1|0;f[k>>2]=B;F=f[v>>2]|0;ra=F<<1^F>>31;if(ra>>>0>127){F=ra;z=B;while(1){b[z>>0]=F|128;Z=F>>>7;Xc=z+1|0;if(F>>>0>16383){F=Z;z=Xc}else{Ie=Xc;Je=Z;break}}}else{Ie=B;Je=ra}b[Ie>>0]=Je;f[k>>2]=Ie+1}break}case 36:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;F=f[k>>2]|0;if(z>>>0>127){M=z;y=F;while(1){b[y>>0]=M|128;Z=M>>>7;Xc=y+1|0;if(M>>>0>16383){M=Z;y=Xc}else{Ke=Xc;Le=Z;break}}}else{Ke=F;Le=z}b[Ke>>0]=Le;y=Ke+1|0;f[k>>2]=y;M=f[v>>2]|0;ra=M<<1^M>>31;if(ra>>>0>127){M=ra;B=y;while(1){b[B>>0]=M|128;Z=M>>>7;Xc=B+1|0;if(M>>>0>16383){M=Z;B=Xc}else{Me=Xc;Ne=Z;break}}}else{Me=y;Ne=ra}b[Me>>0]=Ne;f[k>>2]=Me+1}break}case 56:{if((f[v>>2]|0)>0){B=c+(s*20|0)+4|0;M=v+8|0;z=0;F=f[k>>2]|0;do{Z=f[B>>2]|0;if(Z>>>0>127){Xc=Z;Wc=F;while(1){b[Wc>>0]=Xc|128;G=Xc>>>7;qa=Wc+1|0;if(Xc>>>0>16383){Xc=G;Wc=qa}else{Oe=qa;Pe=G;break}}}else{Oe=F;Pe=Z}b[Oe>>0]=Pe;Wc=Oe+1|0;f[k>>2]=Wc;Xc=f[(f[M>>2]|0)+4+(z<<2)>>2]|0;x=Xc<<1^Xc>>31;if(x>>>0>127){Xc=x;G=Wc;while(1){b[G>>0]=Xc|128;qa=Xc>>>7;L=G+1|0;if(Xc>>>0>16383){Xc=qa;G=L}else{Qe=L;Re=qa;break}}}else{Qe=Wc;Re=x}b[Qe>>0]=Re;F=Qe+1|0;f[k>>2]=F;z=z+1|0}while((z|0)<(f[v>>2]|0))}break}case 76:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;F=f[k>>2]|0;if(z>>>0>127){M=z;B=F;while(1){b[B>>0]=M|128;ra=M>>>7;y=B+1|0;if(M>>>0>16383){M=ra;B=y}else{Se=y;Te=ra;break}}}else{Se=F;Te=z}b[Se>>0]=Te;B=Se+1|0;f[k>>2]=B;M=f[v+12>>2]|0;if(M>>>0>127){ra=M;y=B;while(1){b[y>>0]=ra|128;G=ra>>>7;Xc=y+1|0;if(ra>>>0>16383){ra=G;y=Xc}else{Ue=Xc;Ve=G;break}}}else{Ue=B;Ve=M}b[Ue>>0]=Ve;y=Ue+1|0;f[k>>2]=y;if((f[v>>2]|0)>0){ra=v+8|0;z=0;F=y;do{y=f[(f[ra>>2]|0)+4+(z<<2)>>2]|0;G=y<<1^y>>31;if(G>>>0>127){y=G;Xc=F;while(1){b[Xc>>0]=y|128;Z=y>>>7;qa=Xc+1|0;if(y>>>0>16383){y=Z;Xc=qa}else{We=qa;Xe=Z;break}}}else{We=F;Xe=G}b[We>>0]=Xe;F=We+1|0;f[k>>2]=F;z=z+1|0}while((z|0)<(f[v>>2]|0))}}break}case 96:{z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){F=f[k>>2]|0;if(z>>>0>127){ra=z;M=F;while(1){b[M>>0]=ra|128;B=ra>>>7;Xc=M+1|0;if(ra>>>0>16383){ra=B;M=Xc}else{Ye=Xc;Ze=B;break}}}else{Ye=F;Ze=z}b[Ye>>0]=Ze;M=Ye+1|0;f[k>>2]=M;ra=f[v>>2]|0;B=ra<<1^ra>>31;if(B>>>0>127){ra=B;Xc=M;while(1){b[Xc>>0]=ra|128;y=ra>>>7;x=Xc+1|0;if(ra>>>0>16383){ra=y;Xc=x}else{_e=x;$e=y;break}}}else{_e=M;$e=B}b[_e>>0]=$e;f[k>>2]=_e+1}break}case 17:{Xc=f[c+(s*20|0)+8>>2]|0;if(1<<(Xc&31)&f[a+(Xc>>>5<<2)>>2]|0){Xc=f[c+(s*20|0)+4>>2]|0;ra=f[k>>2]|0;if(Xc>>>0>127){z=Xc;F=ra;while(1){b[F>>0]=z|128;y=z>>>7;x=F+1|0;if(z>>>0>16383){z=y;F=x}else{af=x;bf=y;break}}}else{af=ra;bf=Xc}b[af>>0]=bf;F=af+1|0;f[k>>2]=F;z=v;B=f[z>>2]|0;M=f[z+4>>2]|0;z=u1c(B|0,M|0,1)|0;y=J;x=k1c(B|0,M|0,63)|0;M=z^x;x=y^J;y=M&255;if(x>>>0>0|(x|0)==0&M>>>0>127){z=F;B=y;Wc=M;M=x;while(1){b[z>>0]=B|-128;x=Wc;Wc=l1c(Wc|0,M|0,7)|0;Z=z+1|0;qa=Wc&255;if(!(M>>>0>0|(M|0)==0&x>>>0>16383)){cf=Z;df=qa;break}else{z=Z;B=qa;M=J}}}else{cf=F;df=y}b[cf>>0]=df;f[k>>2]=cf+1}break}case 37:{M=v;if(!((f[M>>2]|0)==0&(f[M+4>>2]|0)==0)){M=f[c+(s*20|0)+4>>2]|0;B=f[k>>2]|0;if(M>>>0>127){z=M;Wc=B;while(1){b[Wc>>0]=z|128;Xc=z>>>7;ra=Wc+1|0;if(z>>>0>16383){z=Xc;Wc=ra}else{ef=ra;ff=Xc;break}}}else{ef=B;ff=M}b[ef>>0]=ff;Wc=ef+1|0;f[k>>2]=Wc;z=v;y=f[z>>2]|0;F=f[z+4>>2]|0;z=u1c(y|0,F|0,1)|0;Xc=J;ra=k1c(y|0,F|0,63)|0;F=z^ra;ra=Xc^J;Xc=F&255;if(ra>>>0>0|(ra|0)==0&F>>>0>127){z=Wc;y=Xc;qa=F;F=ra;while(1){b[z>>0]=y|-128;ra=qa;qa=l1c(qa|0,F|0,7)|0;Z=z+1|0;x=qa&255;if(!(F>>>0>0|(F|0)==0&ra>>>0>16383)){gf=Z;hf=x;break}else{z=Z;y=x;F=J}}}else{gf=Wc;hf=Xc}b[gf>>0]=hf;f[k>>2]=gf+1}break}case 57:{if((f[v>>2]|0)>0){F=c+(s*20|0)+4|0;y=v+8|0;z=0;qa=f[k>>2]|0;do{M=f[F>>2]|0;if(M>>>0>127){B=M;x=qa;while(1){b[x>>0]=B|128;Z=B>>>7;ra=x+1|0;if(B>>>0>16383){B=Z;x=ra}else{jf=ra;kf=Z;break}}}else{jf=qa;kf=M}b[jf>>0]=kf;x=jf+1|0;f[k>>2]=x;B=(f[y>>2]|0)+8+(z<<3)|0;G=f[B>>2]|0;Z=f[B+4>>2]|0;B=u1c(G|0,Z|0,1)|0;ra=J;L=k1c(G|0,Z|0,63)|0;Z=B^L;L=ra^J;ra=Z&255;if(L>>>0>0|(L|0)==0&Z>>>0>127){B=x;G=ra;sa=Z;Z=L;while(1){b[B>>0]=G|-128;L=sa;sa=l1c(sa|0,Z|0,7)|0;ta=B+1|0;K=sa&255;if(!(Z>>>0>0|(Z|0)==0&L>>>0>16383)){lf=ta;mf=K;break}else{B=ta;G=K;Z=J}}}else{lf=x;mf=ra}b[lf>>0]=mf;qa=lf+1|0;f[k>>2]=qa;z=z+1|0}while((z|0)<(f[v>>2]|0))}break}case 77:{if(f[v>>2]|0){z=f[c+(s*20|0)+4>>2]|0;qa=f[k>>2]|0;if(z>>>0>127){y=z;F=qa;while(1){b[F>>0]=y|128;Xc=y>>>7;Wc=F+1|0;if(y>>>0>16383){y=Xc;F=Wc}else{nf=Wc;of=Xc;break}}}else{nf=qa;of=z}b[nf>>0]=of;F=nf+1|0;f[k>>2]=F;y=f[v+12>>2]|0;if(y>>>0>127){Xc=y;Wc=F;while(1){b[Wc>>0]=Xc|128;Z=Xc>>>7;G=Wc+1|0;if(Xc>>>0>16383){Xc=Z;Wc=G}else{pf=G;qf=Z;break}}}else{pf=F;qf=y}b[pf>>0]=qf;Wc=pf+1|0;f[k>>2]=Wc;if((f[v>>2]|0)>0){Xc=v+8|0;z=0;qa=Wc;do{Wc=(f[Xc>>2]|0)+8+(z<<3)|0;Z=f[Wc>>2]|0;G=f[Wc+4>>2]|0;Wc=u1c(Z|0,G|0,1)|0;B=J;sa=k1c(Z|0,G|0,63)|0;G=Wc^sa;sa=B^J;B=G&255;if(sa>>>0>0|(sa|0)==0&G>>>0>127){Wc=qa;Z=B;M=G;G=sa;while(1){b[Wc>>0]=Z|-128;sa=M;M=l1c(M|0,G|0,7)|0;K=Wc+1|0;ta=M&255;if(!(G>>>0>0|(G|0)==0&sa>>>0>16383)){rf=K;sf=ta;break}else{Wc=K;Z=ta;G=J}}}else{rf=qa;sf=B}b[rf>>0]=sf;qa=rf+1|0;f[k>>2]=qa;z=z+1|0}while((z|0)<(f[v>>2]|0))}}break}case 97:{z=f[c+(s*20|0)+4>>2]|0;if((f[a+(f[c+(s*20|0)+8>>2]|0)>>2]|0)==(z>>>3|0)){qa=f[k>>2]|0;if(z>>>0>127){Xc=z;y=qa;while(1){b[y>>0]=Xc|128;F=Xc>>>7;G=y+1|0;if(Xc>>>0>16383){Xc=F;y=G}else{tf=G;uf=F;break}}}else{tf=qa;uf=z}b[tf>>0]=uf;y=tf+1|0;f[k>>2]=y;Xc=v;F=f[Xc>>2]|0;G=f[Xc+4>>2]|0;Xc=u1c(F|0,G|0,1)|0;Z=J;Wc=k1c(F|0,G|0,63)|0;G=Xc^Wc;Wc=Z^J;Z=G&255;if(Wc>>>0>0|(Wc|0)==0&G>>>0>127){Xc=y;F=Z;M=G;G=Wc;while(1){b[Xc>>0]=F|-128;Wc=M;M=l1c(M|0,G|0,7)|0;ra=Xc+1|0;x=M&255;if(!(G>>>0>0|(G|0)==0&Wc>>>0>16383)){vf=ra;wf=x;break}else{Xc=ra;F=x;G=J}}}else{vf=y;wf=Z}b[vf>>0]=wf;f[k>>2]=vf+1}break}case 100:{GZb(i,f[k>>2]|0,2147483647,-1);_Yb(j,i);b[e>>0]=1;b[o>>0]=l;gi[f[c+(s*20|0)+16>>2]&255](a,f[t>>2]|0,f[c+(s*20|0)+4>>2]|0,f[c+(s*20|0)+8>>2]|0,j);f[k>>2]=(f[k>>2]|0)+((f[q>>2]|0)-(f[r>>2]|0));$Yb(j);break}default:{u_b(i,3,475434,537);r_b(j,s_b(p_b(i,475538)|0,w)|0);v_b(i)}}while(0);s=s+1|0}while((s|0)<(d|0));m=f[k>>2]|0;u=h;return m|0}function FYb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=u;u=u+32|0;a=c;u_b(a,3,475434,512);d=p_b(a,475538)|0;e=p_b(t_b(d,f[b+4>>2]|0)|0,475568)|0;r_b(c+24|0,t_b(e,f[b+12>>2]|0)|0);v_b(a);u=c;return}function GYb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+8>>2]|0;if(!b)return;c=a+4|0;d=a+32|0;e=a+16|0;g=(f[c>>2]|0)-(f[a>>2]|0)+(f[d>>2]|0)+(f[e>>2]|0)|0;if((g|0)<=0)return;mi[f[(f[b>>2]|0)+12>>2]&2047](b,g);g=f[a>>2]|0;b=a+12|0;f[b>>2]=g-(f[c>>2]|0)-(f[d>>2]|0)+(f[b>>2]|0);f[c>>2]=g;f[d>>2]=0;f[e>>2]=0;return}function HYb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;g=a+32|0;h=f[g>>2]|0;i=c-e+(f[a>>2]|0)-h|0;j=a+28|0;k=f[j>>2]|0;if(!((k-i|0)>(b|0)&((b|0)>-1&(2147483647-i|0)>=(b|0))))return k|0;l=i+b|0;f[j>>2]=l;j=e+h|0;f[d>>2]=j;h=f[a+36>>2]|0;a=(h|0)<(l|0)?h:l;if((c|0)>(a|0)){l=c-a|0;f[g>>2]=l;f[d>>2]=j+(0-l);return k|0}else{f[g>>2]=0;return k|0}return 0}function IYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[a+28>>2]=c;d=a+32|0;e=a+4|0;g=(f[e>>2]|0)+(f[d>>2]|0)|0;f[e>>2]=g;h=f[a+36>>2]|0;i=(h|0)<(c|0)?h:c;c=f[a+12>>2]|0;if((c|0)>(i|0)){h=c-i|0;f[d>>2]=h;f[e>>2]=g+(0-h);j=a+24|0;b[j>>0]=0;return}else{f[d>>2]=0;j=a+24|0;b[j>>0]=0;return}}function JYb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[b+12>>2]|0;e=b+4|0;g=f[e>>2]|0;h=b+32|0;i=f[h>>2]|0;j=d-g+(f[b>>2]|0)-i|0;k=b+28|0;l=f[k>>2]|0;do if((l-j|0)>(c|0)&((c|0)>-1&(2147483647-j|0)>=(c|0))){m=j+c|0;f[k>>2]=m;n=g+i|0;f[e>>2]=n;o=f[b+36>>2]|0;p=(o|0)<(m|0)?o:m;if((d|0)>(p|0)){m=d-p|0;f[h>>2]=m;f[e>>2]=n+(0-m);break}else{f[h>>2]=0;break}}while(0);h=b+40|0;b=(f[h>>2]|0)+-1|0;f[h>>2]=b;f[a>>2]=l;f[a+4>>2]=b;return}function KYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=f[a+4>>2]|0;i=f[a>>2]|0;j=g;k=i;do if((g-i|0)<=9){if(j>>>0>k>>>0?(b[j+-1>>0]|0)>=0:0)break;LYb(e,a);l=(b[e+8>>0]|0)!=0;m=l?0:-1;n=l?f[e>>2]|0:-1;J=m;u=d;return n|0}while(0);e=k+2|0;j=h[k+1>>0]|0;i=c+-128+(j<<7)|0;if(j&128){j=k+3|0;c=h[e>>0]|0;g=i+-16384+(c<<14)|0;if(c&128){c=k+4|0;l=h[j>>0]|0;o=g+-2097152+(l<<21)|0;if(l&128){l=k+5|0;p=h[c>>0]|0;q=o+-268435456+(p<<28)|0;if(p&128){p=k+6|0;if((b[l>>0]|0)<0){r=k+7|0;if((b[p>>0]|0)<0){s=k+8|0;if((b[r>>0]|0)<0){t=k+9|0;if((b[s>>0]|0)<0)if((b[t>>0]|0)<0){m=-1;n=-1;J=m;u=d;return n|0}else{v=q;w=k+10|0}else{v=q;w=t}}else{v=q;w=s}}else{v=q;w=r}}else{v=q;w=p}}else{v=q;w=l}}else{v=o;w=c}}else{v=g;w=j}}else{v=i;w=e}f[a>>2]=w;m=0;n=v;J=m;u=d;return n|0}function LYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=c+4|0;e=f[d>>2]|0;g=f[c>>2]|0;i=e;j=g;a:do if((e-g|0)>9)k=4;else{if(i>>>0>j>>>0?(b[i+-1>>0]|0)>=0:0){k=4;break}else{l=0;m=0;n=0;o=j;p=i}while(1){if((l|0)==10){q=0;r=0;s=0;break a}if((o|0)==(p|0))while(1){if(!(MYb(c)|0)){q=0;r=0;s=0;break a}t=f[c>>2]|0;u=f[d>>2]|0;if((t|0)!=(u|0)){v=t;w=u;break}}else{v=o;w=p}u=h[v>>0]|0;t=u1c(u&127|0,0,l*7|0)|0;x=t|m;t=J|n;o=v+1|0;f[c>>2]=o;if(!(u&128)){q=1;r=x;s=t;break}else{l=l+1|0;m=x;n=t;p=w}}}while(0);do if((k|0)==4){w=j+1|0;p=h[j>>0]|0;if(p&128){n=j+2|0;m=h[w>>0]|0;l=p+-128+(m<<7)|0;if(m&128){m=j+3|0;o=h[n>>0]|0;v=l+-16384+(o<<14)|0;if(o&128){o=j+4|0;d=h[m>>0]|0;i=v+-2097152+(d<<21)|0;if(d&128){d=i+-268435456|0;g=j+5|0;e=h[o>>0]|0;if(e&128){t=j+6|0;x=h[g>>0]|0;u=e+-128+(x<<7)|0;if(x&128){x=j+7|0;y=h[t>>0]|0;z=u+-16384+(y<<14)|0;if(y&128){y=j+8|0;A=h[x>>0]|0;B=z+-2097152+(A<<21)|0;if(A&128){A=B+-268435456|0;C=j+9|0;D=h[y>>0]|0;if(D&128){E=h[C>>0]|0;if(!(E&128)){F=D+-128+(E<<7)|0;G=A;H=d;I=j+10|0}else{q=0;r=0;s=0;break}}else{F=D;G=A;H=d;I=C}}else{F=0;G=B;H=d;I=y}}else{F=0;G=z;H=d;I=x}}else{F=0;G=u;H=d;I=t}}else{F=0;G=e;H=d;I=g}}else{F=0;G=0;H=i;I=o}}else{F=0;G=0;H=v;I=m}}else{F=0;G=0;H=l;I=n}}else{F=0;G=0;H=p;I=w}w=u1c(G|0,0,28)|0;p=J;n=u1c(F|0,0,56)|0;f[c>>2]=I;q=1;r=w|H|n;s=p|J}while(0);H=a;f[H>>2]=r;f[H+4>>2]=s;b[a+8>>0]=q;return}function MYb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;b=u;u=u+48|0;c=b+28|0;d=b+24|0;e=b;g=b+32|0;h=a+32|0;i=f[h>>2]|0;if(((i|0)<=0?(j=a+16|0,(f[j>>2]|0)<=0):0)?(k=a+12|0,l=a+28|0,(f[k>>2]|0)!=(f[l>>2]|0)):0){m=f[a+8>>2]|0;while(1){if(!(hj[f[(f[m>>2]|0)+8>>2]&511](m,c,d)|0)){n=18;break}o=f[d>>2]|0;if(o|0){n=10;break}}do if((n|0)==10){m=f[c>>2]|0;f[a>>2]=m;p=a+4|0;f[p>>2]=m+o;if((o|0)>-1)q=o;else{u_b(e,3,475580,590);r_b(g,p_b(e,475677)|0);v_b(e);q=f[d>>2]|0}m=f[k>>2]|0;r=2147483647-q|0;if((m|0)>(r|0)){s=m-r|0;f[j>>2]=s;r=(f[p>>2]|0)+(0-s)|0;f[p>>2]=r;t=r;v=2147483647}else{t=f[p>>2]|0;v=q+m|0}f[k>>2]=v;m=t+(f[h>>2]|0)|0;f[p>>2]=m;r=f[a+36>>2]|0;s=f[l>>2]|0;w=(r|0)<(s|0)?r:s;if((v|0)>(w|0)){s=v-w|0;f[h>>2]=s;f[p>>2]=m+(0-s);x=1;break}else{f[h>>2]=0;x=1;break}}else if((n|0)==18){f[a>>2]=0;f[a+4>>2]=0;x=0}while(0);y=x;u=b;return y|0}x=f[a+36>>2]|0;if(((f[a+12>>2]|0)-i|0)<(x|0)){y=0;u=b;return y|0}if((x|0)==(f[a+28>>2]|0)){y=0;u=b;return y|0}NYb(a);y=0;u=b;return y|0}function NYb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;u_b(c,2,475580,193);d=p_b(c,475714)|0;r_b(b+24|0,p_b(s_b(d,f[a+36>>2]|0)|0,475781)|0);v_b(c);u=b;return}function OYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+24|0;e=(b[d>>0]|0)!=0;f[a+28>>2]=c;g=a+32|0;h=a+4|0;i=(f[h>>2]|0)+(f[g>>2]|0)|0;f[h>>2]=i;j=f[a+36>>2]|0;k=(j|0)<(c|0)?j:c;c=f[a+12>>2]|0;if((c|0)>(k|0)){j=c-k|0;f[g>>2]=j;f[h>>2]=i+(0-j);b[d>>0]=0;l=a+40|0;m=f[l>>2]|0;n=m+1|0;f[l>>2]=n;return e|0}else{f[g>>2]=0;b[d>>0]=0;l=a+40|0;m=f[l>>2]|0;n=m+1|0;f[l>>2]=n;return e|0}return 0}function PYb(a){a=a|0;var b=0,c=0;b=f[a+28>>2]|0;if((b|0)==2147483647){c=-1;return c|0}c=b-(f[a+12>>2]|0)+(f[a+4>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;return c|0}function QYb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;g=a+32|0;h=f[g>>2]|0;i=c-e+(f[a>>2]|0)-h|0;j=(i|0)<(b|0)?b:i;f[a+36>>2]=j;i=e+h|0;f[d>>2]=i;h=f[a+28>>2]|0;a=(j|0)<(h|0)?j:h;if((c|0)>(a|0)){h=c-a|0;f[g>>2]=h;f[d>>2]=i+(0-h);return}else{f[g>>2]=0;return}}function RYb(a){a=a|0;var b=0,c=0;b=f[a+36>>2]|0;if((b|0)==2147483647){c=-1;return c|0}c=b-(f[a+12>>2]|0)+(f[a+4>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;return c|0}function SYb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;if((f[a+32>>2]|0)>0){f[a>>2]=(f[a>>2]|0)+c;d=0;return d|0}e=b-c|0;f[a>>2]=0;f[a+4>>2]=0;c=f[a+36>>2]|0;b=f[a+28>>2]|0;g=(c|0)<(b|0)?c:b;b=a+12|0;c=f[b>>2]|0;h=g-c|0;if((h|0)>=(e|0)){f[b>>2]=c+e;c=f[a+8>>2]|0;d=Mi[f[(f[c>>2]|0)+16>>2]&1023](c,e)|0;return d|0}if((h|0)<=0){d=0;return d|0}f[b>>2]=g;g=f[a+8>>2]|0;Mi[f[(f[g>>2]|0)+16>>2]&1023](g,h)|0;d=0;return d|0}function TYb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=c;c=b;while(1){b=f[a>>2]|0;g=(f[d>>2]|0)-b|0;h=b;if((e|0)<=(g|0))break;o1c(c|0,h|0,g|0)|0;f[a>>2]=(f[a>>2]|0)+g;if(MYb(a)|0){e=e-g|0;c=c+g|0}else{i=0;j=5;break}}if((j|0)==5)return i|0;o1c(c|0,h|0,e|0)|0;f[a>>2]=(f[a>>2]|0)+e;i=1;return i|0}function UYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;if((d|0)<0){e=0;return e|0}if(((f[a+4>>2]|0)-(f[a>>2]|0)|0)<(d|0)){e=VYb(a,c,d)|0;return e|0}uYc(c,d,0);if((b[c+11>>0]|0)<0)g=f[c>>2]|0;else g=c;o1c(g|0,f[a>>2]|0,d|0)|0;f[a>>2]=(f[a>>2]|0)+d;e=1;return e|0}function VYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=c+11|0;g=b[e>>0]|0;h=g<<24>>24<0;if(h)i=f[c+4>>2]|0;else i=g&255;do if(i|0)if(h){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[e>>0]=0;break}while(0);e=f[a+36>>2]|0;h=f[a+28>>2]|0;i=(e|0)<(h|0)?e:h;if((i|0)!=2147483647){h=a+4|0;e=i-(f[a+12>>2]|0)+(f[h>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;if((e|0)<(d|0)|((d|0)<1|(e|0)<1)){j=h;k=a}else{sYc(c,d);j=h;k=a}}else{j=a+4|0;k=a}h=d;while(1){d=f[k>>2]|0;e=(f[j>>2]|0)-d|0;l=d;if((h|0)<=(e|0))break;if(!e)m=l;else{zYc(c,l,e)|0;m=f[a>>2]|0}f[a>>2]=m+e;if(MYb(a)|0)h=h-e|0;else{n=0;o=18;break}}if((o|0)==18)return n|0;zYc(c,l,h)|0;f[a>>2]=(f[a>>2]|0)+h;n=1;return n|0}function WYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=j;if((i-j|0)>>>0>3){l=k;m=k+4|0}else{k=i-j|0;i=j;a:do if((k|0)<4){j=4;n=e;o=i;p=k;while(1){o1c(n|0,o|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;if(!(MYb(a)|0)){q=0;break}r=j-p|0;s=n+p|0;t=f[a>>2]|0;p=(f[g>>2]|0)-t|0;v=t;if((r|0)<=(p|0)){w=r;x=s;y=v;break a}else{j=r;n=s;o=v}}u=d;return q|0}else{w=4;x=e;y=i}while(0);o1c(x|0,y|0,w|0)|0;l=e;m=(f[a>>2]|0)+w|0}f[a>>2]=m;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;b[c>>0]=m;b[c+1>>0]=m>>8;b[c+2>>0]=m>>16;b[c+3>>0]=m>>24;q=1;u=d;return q|0}function XYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=j;if((i-j|0)>>>0>7){l=k;m=k+8|0}else{k=i-j|0;i=j;a:do if((k|0)<8){j=8;n=e;o=i;p=k;while(1){o1c(n|0,o|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;if(!(MYb(a)|0)){q=0;break}r=j-p|0;s=n+p|0;t=f[a>>2]|0;p=(f[g>>2]|0)-t|0;v=t;if((r|0)<=(p|0)){w=r;x=s;y=v;break a}else{j=r;n=s;o=v}}u=d;return q|0}else{w=8;x=e;y=i}while(0);o1c(x|0,y|0,w|0)|0;l=e;m=(f[a>>2]|0)+w|0}f[a>>2]=m;m=l;l=m;a=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=m+4|0;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=c;c=l;b[c>>0]=a;b[c+1>>0]=a>>8;b[c+2>>0]=a>>16;b[c+3>>0]=a>>24;a=l+4|0;b[a>>0]=m;b[a+1>>0]=m>>8;b[a+2>>0]=m>>16;b[a+3>>0]=m>>24;q=1;u=d;return q|0}function YYb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;g=f[a>>2]|0;i=e;j=g;do if((e-g|0)<=9){if(i>>>0>j>>>0?(b[i+-1>>0]|0)>=0:0)break;LYb(d,a);if(!(b[d+8>>0]|0))k=-1;else{l=d;m=f[l>>2]|0;n=f[l+4>>2]|0;k=n>>>0>0|(n|0)==0&m>>>0>2147483647?-1:m}o=k;u=c;return o|0}while(0);k=j+1|0;d=h[j>>0]|0;if(d&128){i=j+2|0;g=h[k>>0]|0;e=d+-128+(g<<7)|0;if(g&128){g=j+3|0;m=h[i>>0]|0;n=e+-16384+(m<<14)|0;if(m&128){m=j+4|0;l=h[g>>0]|0;p=n+-2097152+(l<<21)|0;if(l&128){l=p+-268435456|0;q=j+5|0;r=h[m>>0]|0;if(r&128){s=j+6|0;t=h[q>>0]|0;v=r+-128+(t<<7)|0;if(t&128){t=j+7|0;w=h[s>>0]|0;x=v+-16384+(w<<14)|0;if(w&128){w=j+8|0;y=h[t>>0]|0;z=x+-2097152+(y<<21)|0;if(y&128){y=z+-268435456|0;A=j+9|0;B=h[w>>0]|0;if(B&128){C=h[A>>0]|0;if(!(C&128)){D=B+-128+(C<<7)|0;E=y;F=l;G=j+10|0}else{o=-1;u=c;return o|0}}else{D=B;E=y;F=l;G=A}}else{D=0;E=z;F=l;G=w}}else{D=0;E=x;F=l;G=t}}else{D=0;E=v;F=l;G=s}}else{D=0;E=r;F=l;G=q}}else{D=0;E=0;F=p;G=m}}else{D=0;E=0;F=n;G=g}}else{D=0;E=0;F=e;G=i}}else{D=0;E=0;F=d;G=k}k=u1c(E|0,0,28)|0;E=J;d=k|F;F=u1c(D|0,0,56)|0;D=E|J;if(D>>>0>0|(D|0)==0&(d|F)>>>0>2147483647){o=-1;u=c;return o|0}f[a>>2]=G;o=d;u=c;return o|0}function ZYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=i-j|0;l=i;i=j;a:do if((k|0)<=9){do if((k|0)>0){if((b[l+-1>>0]|0)>=0)break a}else if(!k){j=f[a+32>>2]|0;m=f[a+12>>2]|0;if((j|0)<=0?(m|0)!=(f[a+28>>2]|0):0)break;if((m-j|0)<(f[a+36>>2]|0)){b[a+24>>0]=1;n=0;u=d;return n|0}}while(0);do if((i|0)==(l|0)){if(MYb(a)|0){o=f[a>>2]|0;p=f[g>>2]|0;break}j=f[a+36>>2]|0;if(((f[a+12>>2]|0)-(f[a+32>>2]|0)|0)<(j|0)){b[a+24>>0]=1;n=0;u=d;return n|0}else{b[a+24>>0]=(f[a+28>>2]|0)==(j|0)&1;n=0;u=d;return n|0}}else{o=i;p=l}while(0);if(o>>>0<p>>>0?(j=b[o>>0]|0,j<<24>>24>-1):0){f[a>>2]=o+1;q=j&255}else{LYb(e,a);if(!(b[e+8>>0]|0)){n=0;u=d;return n|0}else q=f[e>>2]|0}n=q;u=d;return n|0}while(0);if(!c){f[a>>2]=i+1;n=0;u=d;return n|0}q=i+2|0;e=h[i+1>>0]|0;o=c+-128+(e<<7)|0;if(e&128){e=i+3|0;c=h[q>>0]|0;p=o+-16384+(c<<14)|0;if(c&128){c=i+4|0;l=h[e>>0]|0;g=p+-2097152+(l<<21)|0;if(l&128){l=i+5|0;k=h[c>>0]|0;j=g+-268435456+(k<<28)|0;if(k&128){k=i+6|0;if((b[l>>0]|0)<0){m=i+7|0;if((b[k>>0]|0)<0){r=i+8|0;if((b[m>>0]|0)<0){s=i+9|0;if((b[r>>0]|0)<0)if((b[s>>0]|0)<0){n=0;u=d;return n|0}else{t=j;v=i+10|0}else{t=j;v=s}}else{t=j;v=r}}else{t=j;v=m}}else{t=j;v=k}}else{t=j;v=l}}else{t=g;v=c}}else{t=p;v=e}}else{t=o;v=q}f[a>>2]=v;n=t;u=d;return n|0}function _Yb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=c;h=a+4|0;i=a+8|0;j=a+12|0;k=a+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d[h+12>>1]=0;b[h+14>>0]=0;if(hj[f[(f[c>>2]|0)+8>>2]&511](c,g,i)|0){f[h>>2]=f[g>>2];f[j>>2]=(f[j>>2]|0)+(f[i>>2]|0);b[k>>0]=0;u=e;return}else{f[h>>2]=0;f[i>>2]=0;b[k>>0]=1;b[k>>0]=0;u=e;return}}function $Yb(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a>>2]|0;mi[f[(f[d>>2]|0)+12>>2]&2047](d,c);c=a+12|0;f[c>>2]=(f[c>>2]|0)-(f[b>>2]|0);f[b>>2]=0;f[a+4>>2]=0;return}function aZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;i=f[h>>2]|0;j=a+4|0;k=f[j>>2]|0;a:do if((i|0)<(d|0)){l=a+12|0;m=d;n=c;o=k;p=i;while(1){o1c(o|0,n|0,p|0)|0;q=f[h>>2]|0;r=f[a>>2]|0;if(!(hj[f[(f[r>>2]|0)+8>>2]&511](r,g,h)|0))break;r=n+q|0;s=m-q|0;q=f[g>>2]|0;f[j>>2]=q;p=f[h>>2]|0;f[l>>2]=(f[l>>2]|0)+p;t=q;if((p|0)>=(s|0)){v=s;w=r;x=t;break a}else{m=s;n=r;o=t}}f[j>>2]=0;f[h>>2]=0;b[a+16>>0]=1;u=e;return}else{v=d;w=c;x=k}while(0);o1c(x|0,w|0,v|0)|0;f[j>>2]=(f[j>>2]|0)+v;f[h>>2]=(f[h>>2]|0)-v;u=e;return}function bZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0;e=a+8|0;g=f[e>>2]|0;if((g|0)>(d|0)){i=a+4|0;o1c(f[i>>2]|0,c|0,d|0)|0;f[i>>2]=(f[i>>2]|0)+d;f[e>>2]=(f[e>>2]|0)-d;return}if((g|0)>0){i=f[a>>2]|0;mi[f[(f[i>>2]|0)+12>>2]&2047](i,g);g=a+12|0;i=(f[g>>2]|0)-(f[e>>2]|0)|0;f[g>>2]=i;f[e>>2]=0;f[a+4>>2]=0;j=a;k=g;l=i}else{i=a+12|0;j=a;k=i;l=f[i>>2]|0}f[k>>2]=l+d;l=f[j>>2]|0;j=((hj[f[(f[l>>2]|0)+20>>2]&511](l,c,d)|0)^1)&1;d=a+16|0;b[d>>0]=h[d>>0]|0|j;return}function cZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;h=a+8|0;i=f[h>>2]|0;if(i>>>0>3){j=a+4|0;k=f[j>>2]|0;b[k>>0]=c;b[k+1>>0]=c>>8;b[k+2>>0]=c>>16;b[k+3>>0]=c>>24;f[j>>2]=(f[j>>2]|0)+4;f[h>>2]=(f[h>>2]|0)+-4;u=d;return}f[g>>2]=c;c=a+4|0;j=a+12|0;k=4;l=g;g=f[c>>2]|0;m=i;while(1){o1c(g|0,l|0,m|0)|0;i=f[h>>2]|0;n=f[a>>2]|0;if(!(hj[f[(f[n>>2]|0)+8>>2]&511](n,e,h)|0)){o=6;break}l=l+i|0;k=k-i|0;i=f[e>>2]|0;f[c>>2]=i;m=f[h>>2]|0;f[j>>2]=(f[j>>2]|0)+m;g=i;if((m|0)>=(k|0)){o=7;break}}if((o|0)==6){f[c>>2]=0;f[h>>2]=0;b[a+16>>0]=1;u=d;return}else if((o|0)==7){o1c(g|0,l|0,k|0)|0;f[c>>2]=(f[c>>2]|0)+k;f[h>>2]=(f[h>>2]|0)-k;u=d;return}}function dZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e+8|0;h=e;i=a+8|0;j=f[i>>2]|0;if(j>>>0>7){k=a+4|0;l=f[k>>2]|0;m=l;b[m>>0]=c;b[m+1>>0]=c>>8;b[m+2>>0]=c>>16;b[m+3>>0]=c>>24;m=l+4|0;b[m>>0]=d;b[m+1>>0]=d>>8;b[m+2>>0]=d>>16;b[m+3>>0]=d>>24;f[k>>2]=(f[k>>2]|0)+8;f[i>>2]=(f[i>>2]|0)+-8;u=e;return}k=h;f[k>>2]=c;f[k+4>>2]=d;d=a+4|0;k=a+12|0;c=8;m=h;h=f[d>>2]|0;l=j;while(1){o1c(h|0,m|0,l|0)|0;j=f[i>>2]|0;n=f[a>>2]|0;if(!(hj[f[(f[n>>2]|0)+8>>2]&511](n,g,i)|0)){o=6;break}m=m+j|0;c=c-j|0;j=f[g>>2]|0;f[d>>2]=j;l=f[i>>2]|0;f[k>>2]=(f[k>>2]|0)+l;h=j;if((l|0)>=(c|0)){o=7;break}}if((o|0)==6){f[d>>2]=0;f[i>>2]=0;b[a+16>>0]=1;u=e;return}else if((o|0)==7){o1c(h|0,m|0,c|0)|0;f[d>>2]=(f[d>>2]|0)+c;f[i>>2]=(f[i>>2]|0)-c;u=e;return}}function eZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=d+4|0;if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;m=l+1-g|0;l=a+8|0;c=f[l>>2]|0;i=a+4|0;h=f[i>>2]|0;a:do if((c|0)<(m|0)){j=a+12|0;k=m;n=g;o=h;p=c;while(1){o1c(o|0,n|0,p|0)|0;q=f[l>>2]|0;r=f[a>>2]|0;if(!(hj[f[(f[r>>2]|0)+8>>2]&511](r,e,l)|0))break;r=n+q|0;s=k-q|0;q=f[e>>2]|0;f[i>>2]=q;p=f[l>>2]|0;f[j>>2]=(f[j>>2]|0)+p;t=q;if((p|0)>=(s|0)){v=s;w=r;x=t;break a}else{k=s;n=r;o=t}}f[i>>2]=0;f[l>>2]=0;b[a+16>>0]=1;u=d;return}else{v=m;w=g;x=h}while(0);o1c(x|0,w|0,v|0)|0;f[i>>2]=(f[i>>2]|0)+v;f[l>>2]=(f[l>>2]|0)-v;u=d;return}function fZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=e+4|0;i=c&255;if(d>>>0>0|(d|0)==0&c>>>0>127){j=h;k=i;l=c;c=d;while(1){b[j>>0]=k|-128;d=l;l=l1c(l|0,c|0,7)|0;m=j+1|0;n=l&255;if(!(c>>>0>0|(c|0)==0&d>>>0>16383)){o=m;p=n;break}else{j=m;k=n;c=J}}}else{o=h;p=i}b[o>>0]=p;p=o+1-h|0;o=a+8|0;i=f[o>>2]|0;c=a+4|0;k=f[c>>2]|0;a:do if((i|0)<(p|0)){j=a+12|0;l=p;n=h;m=k;d=i;while(1){o1c(m|0,n|0,d|0)|0;q=f[o>>2]|0;r=f[a>>2]|0;if(!(hj[f[(f[r>>2]|0)+8>>2]&511](r,g,o)|0))break;r=n+q|0;s=l-q|0;q=f[g>>2]|0;f[c>>2]=q;d=f[o>>2]|0;f[j>>2]=(f[j>>2]|0)+d;t=q;if((d|0)>=(s|0)){v=s;w=r;x=t;break a}else{l=s;n=r;m=t}}f[c>>2]=0;f[o>>2]=0;b[a+16>>0]=1;u=e;return}else{v=p;w=h;x=k}while(0);o1c(x|0,w|0,v|0)|0;f[c>>2]=(f[c>>2]|0)+v;f[o>>2]=(f[o>>2]|0)-v;u=e;return}function gZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+11|0;e=b[d>>0]|0;if(e<<24>>24<0){g=a+4|0;h=f[g>>2]|0;if(h>>>0>127){i=h;j=c;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;o=g;break}}}else{m=c;n=h;o=g}}else{m=c;n=e&255;o=a+4|0}b[m>>0]=n;n=m+1|0;m=b[d>>0]|0;d=m<<24>>24<0;e=d?f[o>>2]|0:m&255;o1c(n|0,(d?f[a>>2]|0:a)|0,e|0)|0;return n+e|0}function hZb(a){a=a|0;return}function iZb(a){a=a|0;cYc(a);return}function jZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+16|0;e=f[d>>2]|0;g=f[a+8>>2]|0;if((g|0)>(e|0)){h=g-e|0;g=f[a+12>>2]|0;i=(h|0)<(g|0)?h:g;g=a+20|0;f[g>>2]=i;f[b>>2]=(f[a+4>>2]|0)+e;f[c>>2]=i;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);j=1;return j|0}else{f[a+20>>2]=0;j=0;return j|0}return 0}function kZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=a+20|0;i=f[h>>2]|0;if((i|0)>0)j=i;else{u_b(d,3,475926,82);r_b(c+74|0,p_b(p_b(d,476068)|0,476112)|0);v_b(d);j=f[h>>2]|0}if((j|0)<(b|0)){u_b(e,3,475926,84);r_b(c+73|0,p_b(e,476167)|0);v_b(e)}if((b|0)>-1){k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}u_b(g,3,475926,85);r_b(c+72|0,p_b(g,476037)|0);v_b(g);k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}function lZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+32|0;d=c;if((b|0)<=-1){u_b(d,3,475926,91);r_b(c+24|0,p_b(d,476037)|0);v_b(d)}f[a+20>>2]=0;d=f[a+8>>2]|0;e=a+16|0;a=f[e>>2]|0;g=(d-a|0)<(b|0);f[e>>2]=g?d:a+b|0;u=c;return g^1|0}function mZb(a){a=a|0;var b=0;b=f[a+16>>2]|0;J=((b|0)<0)<<31>>31;return b|0}function nZb(a){a=a|0;return}function oZb(a){a=a|0;cYc(a);return}function pZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+16|0;e=f[d>>2]|0;g=f[a+8>>2]|0;if((g|0)>(e|0)){h=g-e|0;g=f[a+12>>2]|0;i=(h|0)<(g|0)?h:g;g=a+20|0;f[g>>2]=i;f[b>>2]=(f[a+4>>2]|0)+e;f[c>>2]=i;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);j=1;return j|0}else{f[a+20>>2]=0;j=0;return j|0}return 0}function qZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=a+20|0;i=f[h>>2]|0;if((i|0)>0)j=i;else{u_b(d,3,475926,132);r_b(c+74|0,p_b(p_b(d,476068)|0,476112)|0);v_b(d);j=f[h>>2]|0}if((j|0)<(b|0)){u_b(e,3,475926,134);r_b(c+73|0,p_b(e,476167)|0);v_b(e)}if((b|0)>-1){k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}u_b(g,3,475926,135);r_b(c+72|0,p_b(g,476037)|0);v_b(g);k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}function rZb(a){a=a|0;var b=0;b=f[a+16>>2]|0;J=((b|0)<0)<<31>>31;return b|0}function sZb(a){a=a|0;return 0}function tZb(a){a=a|0;cYc(a);return}function uZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+24|0;h=e;i=e+48|0;j=a+4|0;a=f[j>>2]|0;if(!a){u_b(g,3,475926,151);r_b(e+49|0,p_b(g,476340)|0);v_b(g);k=f[j>>2]|0}else k=a;a=b[k+11>>0]|0;g=a<<24>>24<0;if(g){l=f[k+4>>2]|0;m=(f[k+8>>2]&2147483647)+-1|0}else{l=a&255;m=10}do if(l>>>0<m>>>0){if(g)n=(f[k+8>>2]&2147483647)+-1|0;else n=10;uYc(k,n,0)}else{if((l|0)<=1073741823){a=l<<1;uYc(k,(a|0)>16?a:16,0);break}u_b(h,2,475926,164);r_b(i,p_b(p_b(h,476417)|0,476467)|0);v_b(h);o=0;u=e;return o|0}while(0);h=f[j>>2]|0;if((b[h+11>>0]|0)<0)p=f[h>>2]|0;else p=h;f[c>>2]=p+l;p=f[j>>2]|0;j=b[p+11>>0]|0;if(j<<24>>24<0)q=f[p+4>>2]|0;else q=j&255;f[d>>2]=q-l;o=1;u=e;return o|0}function vZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;if((c|0)<=-1){u_b(e,3,475926,182);r_b(d+74|0,p_b(e,476037)|0);v_b(e)}e=a+4|0;a=f[e>>2]|0;if(!a){u_b(g,3,475926,183);r_b(d+73|0,p_b(g,476340)|0);v_b(g);i=f[e>>2]|0}else i=a;a=b[i+11>>0]|0;if(a<<24>>24<0)j=f[i+4>>2]|0;else j=a&255;if(j>>>0<c>>>0){u_b(h,3,475926,184);r_b(d+72|0,p_b(h,476372)|0);v_b(h);h=f[e>>2]|0;k=b[h+11>>0]|0;l=h}else{k=a;l=i}if(k<<24>>24<0){m=f[l+4>>2]|0;n=m-c|0;uYc(l,n,0);u=d;return}else{m=k&255;n=m-c|0;uYc(l,n,0);u=d;return}}function wZb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c;e=a+4|0;a=f[e>>2]|0;if(!a){u_b(d,3,475926,189);r_b(c+24|0,p_b(d,476340)|0);v_b(d);g=f[e>>2]|0}else g=a;a=b[g+11>>0]|0;if(a<<24>>24<0){h=f[g+4>>2]|0;J=0;u=c;return h|0}else{h=a&255;J=0;u=c;return h|0}return 0}function xZb(a){a=a|0;var c=0;f[a>>2]=165404;if(b[a+8>>0]|0?(c=f[a+4>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+24>>2]|0;if(!c)return;dYc(c);return}function yZb(a){a=a|0;var c=0;f[a>>2]=165404;if(b[a+8>>0]|0?(c=f[a+4>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+24>>2]|0;if(!c){cYc(a);return}dYc(c);cYc(a);return}function zZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+9|0;if(b[e>>0]|0){g=0;return g|0}h=a+24|0;i=f[h>>2]|0;if(!i){j=f[a+28>>2]|0;k=bYc((j|0)>-1?j:-1)|0;f[h>>2]=k;l=k}else l=i;i=a+36|0;k=f[i>>2]|0;if((k|0)>0){f[c>>2]=l+(f[a+32>>2]|0)+(0-k);f[d>>2]=k;f[i>>2]=0;g=1;return g|0}i=f[a+4>>2]|0;k=hj[f[(f[i>>2]|0)+8>>2]&511](i,l,f[a+28>>2]|0)|0;f[a+32>>2]=k;if((k|0)>=1){l=a+16|0;i=l;j=d1c(f[i>>2]|0,f[i+4>>2]|0,k|0,((k|0)<0)<<31>>31|0)|0;i=l;f[i>>2]=j;f[i+4>>2]=J;f[d>>2]=k;f[c>>2]=f[h>>2];g=1;return g|0}if((k|0)<0)b[e>>0]=1;DZb(a);g=0;return g|0}function AZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+80|0;d=c+48|0;e=c+74|0;g=c+24|0;h=c+73|0;i=c;j=c+72|0;k=a+36|0;if(!((f[k>>2]|0)==0?(f[a+24>>2]|0)!=0:0)){u_b(d,3,475926,266);r_b(e,p_b(p_b(d,476529)|0,476589)|0);v_b(d)}if((f[a+32>>2]|0)<(b|0)){u_b(g,3,475926,268);r_b(h,p_b(p_b(g,476632)|0,476674)|0);v_b(g)}if((b|0)>-1){f[k>>2]=b;u=c;return}u_b(i,3,475926,271);r_b(j,p_b(p_b(i,476037)|0,476752)|0);v_b(i);f[k>>2]=b;u=c;return}function BZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;if((c|0)<=-1){u_b(e,3,475926,278);r_b(d+24|0,p_b(e,476037)|0);v_b(e)}if(b[a+9>>0]|0){g=0;u=d;return g|0}e=a+36|0;h=f[e>>2]|0;if((h|0)<(c|0)){i=c-h|0;f[e>>2]=0;j=f[a+4>>2]|0;k=Mi[f[(f[j>>2]|0)+12>>2]&1023](j,i)|0;j=a+16|0;a=j;l=d1c(f[a>>2]|0,f[a+4>>2]|0,k|0,((k|0)<0)<<31>>31|0)|0;a=j;f[a>>2]=l;f[a+4>>2]=J;g=(k|0)==(i|0);u=d;return g|0}else{f[e>>2]=h-c;g=1;u=d;return g|0}return 0}function CZb(a){a=a|0;var b=0,c=0;b=a+16|0;c=f[a+36>>2]|0;a=c1c(f[b>>2]|0,f[b+4>>2]|0,c|0,((c|0)<0)<<31>>31|0)|0;return a|0}function DZb(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;if(f[a+36>>2]|0){u_b(c,3,475926,311);r_b(b+24|0,p_b(c,476794)|0);v_b(c)}f[a+32>>2]=0;c=a+24|0;a=f[c>>2]|0;if(!a){u=b;return}dYc(a);f[c>>2]=0;u=b;return}function EZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+4096|0;d=c;e=0;while(1){if((e|0)>=(b|0)){g=4;break}h=b-e|0;i=hj[f[(f[a>>2]|0)+8>>2]&511](a,d,(h|0)<4096?h:4096)|0;h=(i|0)<1;if(h){g=4;break}else e=(h?0:i)+e|0}if((g|0)==4){u=c;return e|0}return 0}function FZb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=165300;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=(d|0)>0?d:c;f[a+16>>2]=0;f[a+20>>2]=0;return}function GZb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=165332;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=(d|0)>0?d:c;f[a+16>>2]=0;f[a+20>>2]=0;return}function HZb(a,b){a=a|0;b=b|0;f[a>>2]=165368;f[a+4>>2]=b;return}function IZb(a,c,d){a=a|0;c=c|0;d=d|0;f[a>>2]=165404;f[a+4>>2]=c;b[a+8>>0]=0;b[a+9>>0]=0;c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=0;f[a+28>>2]=(d|0)>0?d:8192;f[a+32>>2]=0;f[a+36>>2]=0;return}function JZb(a,b){a=a|0;b=b|0;return hj[f[(f[a>>2]|0)+64>>2]&511](a,(f[223514]|0)!=0,b)|0}function KZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+80|0;g=e+48|0;h=e+24|0;i=e;j=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;if(j|0){k=EYb(a,(f[j+4>>2]|0)+20|0,(f[j>>2]|0)+-1|0,c,d)|0;u=e;return k|0}j=_i[f[(f[a>>2]|0)+60>>2]&2047](a)|0;GZb(g,d,j,-1);_Yb(h,g);b[h+18>>0]=1;b[h+19>>0]=c&1;mi[f[(f[a>>2]|0)+52>>2]&2047](a,h);if(b[h+16>>0]|0){u_b(i,3,476925,373);r_b(e+72|0,p_b(i,477019)|0);v_b(i)}$Yb(h);k=d+j|0;u=e;return k|0}function LZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d+40|0;g=d+16|0;h=d;Yi[f[(f[a>>2]|0)+28>>2]&4095](a);if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){i=0;u=d;return i|0}if(_i[f[(f[a>>2]|0)+32>>2]&2047](a)|0){i=1;u=d;return i|0}u_b(g,2,476925,121);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;AYc(h,477089)|0;AYc(h,477096)|0;AYc(h,477102)|0;mi[f[(f[a>>2]|0)+8>>2]&2047](e,a);c=e+11|0;j=b[c>>0]|0;k=j<<24>>24<0;zYc(h,k?f[e>>2]|0:e,k?f[e+4>>2]|0:j&255)|0;if((b[c>>0]|0)<0)cYc(f[e>>2]|0);AYc(h,477121)|0;mi[f[(f[a>>2]|0)+36>>2]&2047](e,a);a=e+11|0;c=b[a>>0]|0;j=c<<24>>24<0;zYc(h,j?f[e>>2]|0:e,j?f[e+4>>2]|0:c&255)|0;if((b[a>>0]|0)<0)cYc(f[e>>2]|0);r_b(d+52|0,q_b(g,h)|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);v_b(g);i=0;u=d;return i|0}function MZb(a,c){a=a|0;c=c|0;var e=0,g=0;e=u;u=u+64|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=c;c=g+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d[c+12>>1]=0;f[g+28>>2]=2147483647;f[g+32>>2]=0;f[g+36>>2]=2147483647;c=f[41322]|0;f[g+40>>2]=c;f[g+44>>2]=c;b[g+48>>0]=1;f[g+52>>2]=0;f[g+56>>2]=0;MYb(g)|0;c=LZb(a,g)|0;a=c&(b[g+24>>0]|0)!=0;GYb(g);u=e;return a|0}function NZb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+60|0;j=e+108|0;k=e;l=b[c+11>>0]|0;m=l<<24>>24<0;n=m?f[c>>2]|0:c;o=m?f[c+4>>2]|0:l&255;f[k>>2]=n;f[k+4>>2]=n+o;f[k+8>>2]=0;f[k+12>>2]=o;n=k+16|0;f[n>>2]=0;f[n+4>>2]=0;d[n+8>>1]=0;f[k+28>>2]=o;f[k+32>>2]=0;f[k+36>>2]=2147483647;o=f[41322]|0;f[k+40>>2]=o;f[k+44>>2]=o;b[k+48>>0]=1;f[k+52>>2]=0;f[k+56>>2]=0;Yi[f[(f[a>>2]|0)+28>>2]&4095](a);if(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,k)|0){if(_i[f[(f[a>>2]|0)+32>>2]&2047](a)|0){p=(b[k+24>>0]|0)!=0;GYb(k);u=e;return p|0}u_b(h,2,476925,121);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;AYc(i,477089)|0;AYc(i,477096)|0;AYc(i,477102)|0;mi[f[(f[a>>2]|0)+8>>2]&2047](g,a);o=g+11|0;n=b[o>>0]|0;l=n<<24>>24<0;zYc(i,l?f[g>>2]|0:g,l?f[g+4>>2]|0:n&255)|0;if((b[o>>0]|0)<0)cYc(f[g>>2]|0);AYc(i,477121)|0;mi[f[(f[a>>2]|0)+36>>2]&2047](g,a);a=g+11|0;o=b[a>>0]|0;n=o<<24>>24<0;zYc(i,n?f[g>>2]|0:g,n?f[g+4>>2]|0:o&255)|0;if((b[a>>0]|0)<0)cYc(f[g>>2]|0);r_b(j,q_b(h,i)|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);v_b(h)}p=0;GYb(k);u=e;return p|0}function OZb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+64|0;g=e;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c>>2]|0:c;k=i?f[c+4>>2]|0:h&255;f[g>>2]=j;f[g+4>>2]=j+k;f[g+8>>2]=0;f[g+12>>2]=k;j=g+16|0;f[j>>2]=0;f[j+4>>2]=0;d[j+8>>1]=0;f[g+28>>2]=k;f[g+32>>2]=0;f[g+36>>2]=2147483647;k=f[41322]|0;f[g+40>>2]=k;f[g+44>>2]=k;b[g+48>>0]=1;f[g+52>>2]=0;f[g+56>>2]=0;Yi[f[(f[a>>2]|0)+28>>2]&4095](a);k=Mi[f[(f[a>>2]|0)+44>>2]&1023](a,g)|0;a=k&(b[g+24>>0]|0)!=0;GYb(g);u=e;return a|0}function PZb(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+112|0;h=g+96|0;i=g+72|0;j=g+60|0;k=g+108|0;l=g;f[l>>2]=c;f[l+4>>2]=c+e;f[l+8>>2]=0;f[l+12>>2]=e;c=l+16|0;f[c>>2]=0;f[c+4>>2]=0;d[c+8>>1]=0;f[l+28>>2]=e;f[l+32>>2]=0;f[l+36>>2]=2147483647;e=f[41322]|0;f[l+40>>2]=e;f[l+44>>2]=e;b[l+48>>0]=1;f[l+52>>2]=0;f[l+56>>2]=0;Yi[f[(f[a>>2]|0)+28>>2]&4095](a);if(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,l)|0){if(_i[f[(f[a>>2]|0)+32>>2]&2047](a)|0){m=(b[l+24>>0]|0)!=0;GYb(l);u=g;return m|0}u_b(i,2,476925,121);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;AYc(j,477089)|0;AYc(j,477096)|0;AYc(j,477102)|0;mi[f[(f[a>>2]|0)+8>>2]&2047](h,a);e=h+11|0;c=b[e>>0]|0;n=c<<24>>24<0;zYc(j,n?f[h>>2]|0:h,n?f[h+4>>2]|0:c&255)|0;if((b[e>>0]|0)<0)cYc(f[h>>2]|0);AYc(j,477121)|0;mi[f[(f[a>>2]|0)+36>>2]&2047](h,a);a=h+11|0;e=b[a>>0]|0;c=e<<24>>24<0;zYc(j,c?f[h>>2]|0:h,c?f[h+4>>2]|0:e&255)|0;if((b[a>>0]|0)<0)cYc(f[h>>2]|0);r_b(k,q_b(i,j)|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);v_b(i)}m=0;GYb(l);u=g;return m|0}function QZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+96|0;h=g+48|0;i=g+72|0;j=g+24|0;k=g+85|0;l=g;m=g+84|0;if((a|0)!=(c|0)){u_b(h,3,476925,68);c=p_b(h,477203)|0;mi[f[(f[e>>2]|0)+8>>2]&2047](i,e);r_b(g+86|0,p_b(q_b(c,i)|0,477287)|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);v_b(h)}if((d|0)==(a|0)){u_b(l,3,476925,75);n=p_b(l,477577)|0;r_b(m,n);v_b(l);u=g;return}u_b(j,3,476925,71);a=p_b(p_b(j,477336)|0,477422)|0;mi[f[(f[e>>2]|0)+8>>2]&2047](i,e);r_b(k,p_b(q_b(a,i)|0,528338)|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);v_b(j);u_b(l,3,476925,75);n=p_b(l,477577)|0;r_b(m,n);v_b(l);u=g;return}function RZb(a,b){a=a|0;b=b|0;return SZb(a,b)|0}function SZb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d;g=c+11|0;h=b[g>>0]|0;if(h<<24>>24<0)i=f[c+4>>2]|0;else i=h&255;h=_i[f[(f[a>>2]|0)+48>>2]&2047](a)|0;if((h|0)<0){u_b(e,2,476925,289);r_b(d+24|0,t_b(p_b(e,477163)|0,h)|0);v_b(e);j=0;u=d;return j|0}uYc(c,h+i|0,0);if((b[g>>0]|0)<0)k=f[c>>2]|0;else k=c;c=k+i|0;i=(Mi[f[(f[a>>2]|0)+56>>2]&1023](a,c)|0)-c|0;if((i|0)==(h|0)){j=1;u=d;return j|0}QZb(h,_i[f[(f[a>>2]|0)+48>>2]&2047](a)|0,i,a);j=1;u=d;return j|0}function TZb(a,c){a=a|0;c=c|0;var d=0;d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[d>>0]=0}return SZb(a,c)|0}function UZb(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(SZb(c,a)|0)return;c=a+11|0;if((b[c>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0;return}else{b[a>>0]=0;b[c>>0]=0;return}}function VZb(a,b){a=a|0;b=b|0;oYc(b,a)|0;return}function WZb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;h=g+b|0;b=a+8|0;i=f[b>>2]|0;j=a+12|0;k=f[j>>2]|0;if((i|0)>=(h|0)){l=k;m=g;n=l+4+(m<<2)|0;u=c;return n|0}g=f[a>>2]|0;a=i<<1;i=(a|0)<(h|0)?h:a;a=(i|0)>4?i:4;if(a>>>0>1073741822){u_b(d,3,477630,59);r_b(c+24|0,p_b(p_b(d,477726)|0,477843)|0);v_b(d)}d=a<<2;i=(g|0)==0;if(i)o=$Xc(d+4|0)|0;else{h=d+11&-8;if(f[g+64>>2]|0)SXb(g,25456,h);o=QXb(g,h)|0}f[j>>2]=o;f[b>>2]=a;if((k|0)!=0?(a=f[k>>2]|0,(a|0)>0):0){o1c(o+4|0,k+4|0,a<<2|0)|0;p=f[k>>2]|0;q=f[j>>2]|0}else{p=0;q=o}f[q>>2]=p;if(i){cYc(k);r=f[j>>2]|0}else r=q;l=r;m=f[e>>2]|0;n=l+4+(m<<2)|0;u=c;return n|0}function XZb(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;if((c|0)>=(b|0))return;WZb(a,b-c|0)|0;return}function YZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+12|0;e=f[d>>2]|0;if(!e)return;g=c+b|0;b=f[e>>2]|0;if((g|0)<(b|0)){h=g;g=e;while(1){f[g+4+(h-c<<2)>>2]=f[g+4+(h<<2)>>2];h=h+1|0;i=f[d>>2]|0;j=f[i>>2]|0;if((h|0)>=(j|0)){k=j;l=i;break}else g=i}}else{k=b;l=e}e=a+4|0;f[e>>2]=(f[e>>2]|0)-c;f[l>>2]=k-c;return}function ZZb(a){a=a|0;var c=0;f[a>>2]=165436;c=a+12|0;if((b[c+11>>0]|0)>=0)return;cYc(f[c>>2]|0);return}function _Zb(a){a=a|0;var c=0;f[a>>2]=165436;c=a+12|0;if((b[c+11>>0]|0)>=0){cYc(a);return}cYc(f[c>>2]|0);cYc(a);return}function $Zb(a){a=a|0;var c=0,d=0;c=a+12|0;if((b[c+11>>0]|0)<0){d=f[c>>2]|0;return d|0}else{d=c;return d|0}return 0}function a_b(a){a=a|0;return}function b_b(a){a=a|0;cYc(a);return}function c_b(a){a=a|0;var c=0;c=b[a+8>>0]|0;Ui[f[a+4>>2]&255]();if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function d_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+256|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;k=e+128|0;l=e+88|0;m=e+112|0;n=e+64|0;if((c|0)>3005001){f[l>>2]=3;f[l+4>>2]=477999;f[l+8>>2]=68;o=l+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;AYc(o,478093)|0;f[j>>2]=(c>>>0)/1e6|0;f[j+4>>2]=(((c>>>0)/1e3|0)>>>0)%1e3|0;f[j+8>>2]=(c>>>0)%1e3|0;oJc(k,128,478124,j)|0;c=k+127|0;b[c>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=dJc(k)|0;if(p>>>0>4294967279)jYc(m);if(p>>>0<11){q=m+11|0;b[q>>0]=p;if(!p){r=m;s=q}else{t=m;v=q;w=7}}else{q=p+16&-16;x=$Xc(q)|0;f[m>>2]=x;f[m+8>>2]=q|-2147483648;f[m+4>>2]=p;t=x;v=m+11|0;w=7}if((w|0)==7){o1c(t|0,k|0,p|0)|0;r=t;s=v}b[r+p>>0]=0;p=b[s>>0]|0;r=p<<24>>24<0;zYc(o,r?f[m>>2]|0:m,r?f[m+4>>2]|0:p&255)|0;AYc(o,478133)|0;f[i>>2]=3;f[i+4>>2]=5;f[i+8>>2]=1;oJc(k,128,478124,i)|0;b[c>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=dJc(k)|0;if(c>>>0>4294967279)jYc(j);if(c>>>0<11){i=j+11|0;b[i>>0]=c;if(!c){y=j;z=i}else{A=j;B=i;w=13}}else{i=c+16&-16;p=$Xc(i)|0;f[j>>2]=p;f[j+8>>2]=i|-2147483648;f[j+4>>2]=c;A=p;B=j+11|0;w=13}if((w|0)==13){o1c(A|0,k|0,c|0)|0;y=A;z=B}b[y+c>>0]=0;c=b[z>>0]|0;y=c<<24>>24<0;zYc(o,y?f[j>>2]|0:j,y?f[j+4>>2]|0:c&255)|0;AYc(o,478204)|0;AYc(o,d)|0;AYc(o,478410)|0;e_b(l);if((b[z>>0]|0)<0)cYc(f[j>>2]|0);if((b[s>>0]|0)<0)cYc(f[m>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0)}if((a|0)>=3005e3){u=e;return}f[n>>2]=3;f[n+4>>2]=477999;f[n+8>>2]=79;o=n+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;AYc(o,478414)|0;f[h>>2]=(a|0)/1e6|0;f[h+4>>2]=((a|0)/1e3|0|0)%1e3|0;f[h+8>>2]=(a|0)%1e3|0;oJc(k,128,478124,h)|0;a=k+127|0;b[a>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;s=dJc(k)|0;if(s>>>0>4294967279)jYc(m);if(s>>>0<11){j=m+11|0;b[j>>0]=s;if(!s){C=m;D=j}else{E=m;F=j;w=26}}else{j=s+16&-16;z=$Xc(j)|0;f[m>>2]=z;f[m+8>>2]=j|-2147483648;f[m+4>>2]=s;E=z;F=m+11|0;w=26}if((w|0)==26){o1c(E|0,k|0,s|0)|0;C=E;D=F}b[C+s>>0]=0;s=b[D>>0]|0;C=s<<24>>24<0;zYc(o,C?f[m>>2]|0:m,C?f[m+4>>2]|0:s&255)|0;AYc(o,478457)|0;f[g>>2]=3;f[g+4>>2]=5;f[g+8>>2]=1;oJc(k,128,478124,g)|0;b[a>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=dJc(k)|0;if(a>>>0>4294967279)jYc(h);if(a>>>0<11){g=h+11|0;b[g>>0]=a;if(!a){G=h;H=g}else{I=h;J=g;w=32}}else{g=a+16&-16;s=$Xc(g)|0;f[h>>2]=s;f[h+8>>2]=g|-2147483648;f[h+4>>2]=a;I=s;J=h+11|0;w=32}if((w|0)==32){o1c(I|0,k|0,a|0)|0;G=I;H=J}b[G+a>>0]=0;a=b[H>>0]|0;G=a<<24>>24<0;zYc(o,G?f[h>>2]|0:h,G?f[h+4>>2]|0:a&255)|0;AYc(o,478551)|0;AYc(o,d)|0;AYc(o,478410)|0;e_b(n);if((b[H>>0]|0)<0)cYc(f[h>>2]|0);if((b[D>>0]|0)<0)cYc(f[m>>2]|0);if((b[o+11>>0]|0)>=0){u=e;return}cYc(f[o>>2]|0);u=e;return}function e_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if((f[a>>2]|0)!=3){if((f[223515]|0)!=2){f[d>>2]=165456;f[d+4>>2]=126;b[d+8>>0]=0;J_b(894060,d)}d=f[223518]|0;g_b(d);e=f[223519]|0;h_b(d);if((e|0)<=0){g=f[a>>2]|0;h=6}}else{g=3;h=6}if((h|0)==6)ei[f[41367]&511](g,f[a+4>>2]|0,f[a+8>>2]|0,a+12|0);if((f[a>>2]|0)==3){g=af(24)|0;i_b(g,f[a+4>>2]|0,f[a+8>>2]|0,a+12|0);ig(g|0,20776,1812)}else{u=c;return}}function f_b(){var a=0,b=0;a=$Xc(4)|0;b=$Xc(28)|0;f[a>>2]=b;ng(b|0,0)|0;f[223518]=a;l_b(127);return}function g_b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c;e=f1c(f[a>>2]|0)|0;if(!e){u=c;return}f[d>>2]=3;f[d+4>>2]=477999;f[d+8>>2]=378;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;AYc(a,478822)|0;AYc(a,HIc(e)|0)|0;e_b(d);if((b[a+11>>0]|0)>=0){u=c;return}cYc(f[a>>2]|0);u=c;return}function h_b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c;e=e1c(f[a>>2]|0)|0;if(!e){u=c;return}f[d>>2]=3;f[d+4>>2]=477999;f[d+8>>2]=385;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;AYc(a,478799)|0;AYc(a,HIc(e)|0)|0;e_b(d);if((b[a+11>>0]|0)>=0){u=c;return}cYc(f[a>>2]|0);u=c;return}function i_b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=165436;f[a+4>>2]=b;f[a+8>>2]=c;lYc(a+12|0,d);return}function j_b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;if((a|0)<0){u=g;return}i=f[46249]|0;j=(b[e+11>>0]|0)<0?f[e>>2]|0:e;f[h>>2]=f[165472+(a<<2)>>2];f[h+4>>2]=c;f[h+8>>2]=d;f[h+12>>2]=j;OKc(i,478772,h)|0;pKc(i)|0;u=g;return}function k_b(){var a=0,b=0;a=f[223518]|0;if(!a){f[223518]=0;return}Zf(f[a>>2]|0)|0;b=f[a>>2]|0;if(b|0)cYc(b);cYc(a);f[223518]=0;return}function l_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c+4|0;e=c;f[e>>2]=a;if((f[223517]|0)!=2){f[d>>2]=165456;f[d+4>>2]=128;b[d+8>>0]=0;J_b(894068,d)}d=(f[223516]|0)+36|0;g_b(d);a=f[223516]|0;g=a+4|0;h=f[g>>2]|0;if((h|0)==(f[a+8>>2]|0)){n_b(a,e);h_b(d);u=c;return}else{f[h>>2]=f[e>>2];f[g>>2]=(f[g>>2]|0)+4;h_b(d);u=c;return}}function m_b(){var a=0;a=$Xc(40)|0;o_b(a);f[223516]=a;return}function n_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function o_b(a){a=a|0;var b=0,c=0;b=a;c=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(c|0));b=$Xc(28)|0;f[a+36>>2]=b;ng(b|0,0)|0;return}function p_b(a,b){a=a|0;b=b|0;AYc(a+12|0,b)|0;return a|0}function q_b(a,c){a=a|0;c=c|0;var d=0,e=0;d=b[c+11>>0]|0;e=d<<24>>24<0;zYc(a+12|0,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)|0;return a|0}function r_b(a,b){a=a|0;b=b|0;e_b(b);return}function s_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+144|0;e=d;g=d+8|0;f[e>>2]=c;oJc(g,128,505729,e)|0;b[g+127>>0]=0;AYc(a+12|0,g)|0;u=d;return a|0}function t_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+144|0;e=d;g=d+8|0;f[e>>2]=c;oJc(g,128,478843,e)|0;b[g+127>>0]=0;AYc(a+12|0,g)|0;u=d;return a|0}function u_b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=b;f[a+4>>2]=c;f[a+8>>2]=d;d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;return}function v_b(a){a=a|0;var c=0;c=a+12|0;if((b[c+11>>0]|0)>=0)return;cYc(f[c>>2]|0);return}function w_b(a){a=a|0;var b=0;b=$Xc(28)|0;f[a>>2]=b;ng(b|0,0)|0;return}function x_b(a){a=a|0;var b=0;Zf(f[a>>2]|0)|0;b=f[a>>2]|0;if(!b)return;cYc(b);return}function y_b(a){a=a|0;return}function z_b(a){a=a|0;return s1c(a|0)|0}function A_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c+4|0;e=c;f[e>>2]=a;if((f[223517]|0)!=2){f[d>>2]=165456;f[d+4>>2]=128;b[d+8>>0]=0;J_b(894068,d)}d=(f[223516]|0)+36|0;g_b(d);a=f[223516]|0;g=a+16|0;h=f[g>>2]|0;if((h|0)==(f[a+20>>2]|0)){B_b(a+12|0,e);h_b(d);u=c;return}else{f[h>>2]=f[e>>2];f[g>>2]=(f[g>>2]|0)+4;h_b(d);u=c;return}}function B_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function C_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if((f[223517]|0)!=2){f[d>>2]=165456;f[d+4>>2]=128;b[d+8>>0]=0;J_b(894068,d)}e=(f[223516]|0)+36|0;g_b(e);g=f[223516]|0;f[d>>2]=a;h=g+28|0;i=f[h>>2]|0;if(i>>>0<(f[g+32>>2]|0)>>>0){f[i>>2]=a;f[h>>2]=(f[h>>2]|0)+4;h_b(e);u=c;return}else{D_b(g+24|0,d);h_b(e);u=c;return}}function D_b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function E_b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223517]|0)!=2){f[c>>2]=165456;f[c+4>>2]=128;b[c+8>>0]=0;J_b(894068,c)}c=f[223516]|0;if(!c){u=a;return}F_b(c);cYc(c);f[223516]=0;u=a;return}function F_b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+4|0;d=f[a>>2]|0;if((f[c>>2]|0)!=(d|0)){e=0;g=d;do{Ui[f[g+(e<<2)>>2]&255]();e=e+1|0;g=f[a>>2]|0}while(e>>>0<(f[c>>2]|0)-g>>2>>>0)}g=a+12|0;e=a+16|0;d=f[e>>2]|0;h=f[g>>2]|0;if((d|0)!=(h|0)){i=0;j=h;h=d;while(1){d=f[j+(i<<2)>>2]|0;if((b[d+11>>0]|0)<0){cYc(f[d>>2]|0);k=f[g>>2]|0;l=f[e>>2]|0}else{k=j;l=h}i=i+1|0;if(i>>>0>=l-k>>2>>>0)break;else{j=k;h=l}}}l=a+24|0;h=a+28|0;k=f[l>>2]|0;if((f[h>>2]|0)!=(k|0)){j=0;i=k;do{k=f[i+(j<<2)>>2]|0;Yi[f[f[k>>2]>>2]&4095](k);j=j+1|0;i=f[l>>2]|0}while(j>>>0<(f[h>>2]|0)-i>>2>>>0)}i=a+36|0;Zf(f[i>>2]|0)|0;j=f[i>>2]|0;if(j|0)cYc(j);j=f[l>>2]|0;if(j|0){l=f[h>>2]|0;if((l|0)!=(j|0))f[h>>2]=l+(~((l+-4-j|0)>>>2)<<2);cYc(j)}j=f[g>>2]|0;if(j|0){g=f[e>>2]|0;if((g|0)!=(j|0))f[e>>2]=g+(~((g+-4-j|0)>>>2)<<2);cYc(j)}j=f[a>>2]|0;if(!j)return;a=f[c>>2]|0;if((a|0)!=(j|0))f[c>>2]=a+(~((a+-4-j|0)>>>2)<<2);cYc(j);return}function G_b(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function H_b(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function I_b(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function J_b(a,b){a=a|0;b=b|0;var c=0;if((f[a>>2]|0)==2)return;c=f[a>>2]|0;if(!c)f[a>>2]=1;switch(((c|0)==0?0:c)|0){case 0:{Yi[f[(f[b>>2]|0)+8>>2]&4095](b);f[a>>2]=2;return}case 1:{do Ye()|0;while((f[a>>2]|0)==1);return}default:return}}function K_b(){var a=0,b=0,c=0;a=u;u=u+16|0;b=a+8|0;c=a;f[223520]=0;f[223521]=0;f[223522]=0;f[223523]=0;be(2269,894080,x|0)|0;f[c>>2]=1165591;f[c+4>>2]=0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];M_b(894096,1,b);be(2269,894096,x|0)|0;f[c>>2]=1165591;f[c+4>>2]=0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];M_b(894112,2,b);be(2269,894112,x|0)|0;u=a;return}function L_b(a){a=a|0;var c=0;c=a+4|0;if((b[c+11>>0]|0)>=0)return;cYc(f[c>>2]|0);return}function M_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;f[a>>2]=c;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(!c){u=e;return}c=f[d>>2]|0;if(c){i=f[d+4>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)jYc(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=9}}else{d=i+16&-16;m=$Xc(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=9}if((l|0)==9){o1c(k|0,c|0,i|0)|0;j=k}b[j+i>>0]=0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+8>>2]=0}else{n=i;l=12}}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;n=h+11|0;l=12}if((l|0)==12){b[h>>0]=0;b[n>>0]=0}sYc(h,0);f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];u=e;return}function N_b(a){a=a|0;return}function O_b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=c>>>3;if(!g){i=0;u=d;return i|0}switch(c&7){case 0:{c=f[a>>2]|0;if(c>>>0<(f[a+4>>2]|0)>>>0?(b[c>>0]|0)>-1:0)f[a>>2]=c+1;else j=6;if((j|0)==6?(LYb(e,a),(b[e+8>>0]|0)==0):0){i=0;u=d;return i|0}i=1;u=d;return i|0}case 1:{c=f[a>>2]|0;if(((f[a+4>>2]|0)-c|0)<=7)if(XYb(a,e)|0)j=11;else k=0;else{l=c;m=l;n=l+4|0;l=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;n=e;f[n>>2]=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;f[n+4>>2]=l;f[a>>2]=c+8;j=11}if((j|0)==11)k=1;i=k;u=d;return i|0}case 2:{k=f[a>>2]|0;c=a+4|0;l=f[c>>2]|0;n=l;if(k>>>0<l>>>0){l=b[k>>0]|0;m=l&255;if(l<<24>>24>-1){l=k+1|0;f[a>>2]=l;o=m;p=l;q=n}else{r=m;j=16}}else{r=0;j=16}do if((j|0)==16){m=KYb(a,r)|0;if((J|0)<0|(m|0)<0){i=0;u=d;return i|0}else{o=m;p=f[a>>2]|0;q=f[c>>2]|0;break}}while(0);c=q-p|0;if((c|0)<(o|0)){if(!(SYb(a,o,c)|0)){i=0;u=d;return i|0}}else f[a>>2]=p+o;i=1;u=d;return i|0}case 3:{o=a+40|0;p=f[o>>2]|0;f[o>>2]=p+-1;if((p|0)<=0){i=0;u=d;return i|0}p=a+4|0;c=a+20|0;while(1){q=f[a>>2]|0;if(q>>>0<(f[p>>2]|0)>>>0){r=b[q>>0]|0;m=r&255;if(r<<24>>24>-1){f[a>>2]=q+1;s=m}else{t=m;j=27}}else{t=0;j=27}if((j|0)==27){j=0;s=ZYb(a,t)|0}f[c>>2]=s;if((s|0)==0|(s&7|0)==4)break;if(!(O_b(a,s)|0)){i=0;j=38;break}}if((j|0)==38){u=d;return i|0}c=f[o>>2]|0;if((c|0)<(f[a+44>>2]|0))f[o>>2]=c+1;i=(s|0)==(g<<3|4|0);u=d;return i|0}case 5:{g=f[a>>2]|0;if(((f[a+4>>2]|0)-g|0)<=3)if(WYb(a,e)|0)j=36;else v=0;else{s=g;f[e>>2]=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[a>>2]=g+4;j=36}if((j|0)==36)v=1;i=v;u=d;return i|0}default:{i=0;u=d;return i|0}}return 0}function P_b(a,b,c){a=a|0;b=b|0;c=c|0;aZb(c,a,b<<2);return}function Q_b(a,b,c){a=a|0;b=b|0;c=c|0;aZb(c,a,b<<3);return}function R_b(a,b,c){a=a|0;b=b|0;c=c|0;aZb(c,a,b);return}function S_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{eZb(d,e);o=f[a>>2]|0}e=((c|0)<0)<<31>>31;if((o|0)<=9){fZb(d,c,e);return}o=d+4|0;d=f[o>>2]|0;g=c&255;if(c>>>0>127){n=d;h=g;m=c;c=e;while(1){b[n>>0]=h|-128;e=m;m=l1c(m|0,c|0,7)|0;j=n+1|0;i=m&255;if(!(c>>>0>0|(c|0)==0&e>>>0>16383)){p=j;q=i;break}else{n=j;h=i;c=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function T_b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)>4){h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;h=(f[a>>2]|0)-o|0;f[a>>2]=h;p=h}else{eZb(e,g);p=f[a>>2]|0}if((p|0)<=9){fZb(e,c,d);return}p=e+4|0;e=f[p>>2]|0;g=c&255;if(d>>>0>0|(d|0)==0&c>>>0>127){h=e;o=g;i=c;c=d;while(1){b[h>>0]=o|-128;d=i;i=l1c(i|0,c|0,7)|0;n=h+1|0;k=i&255;if(!(c>>>0>0|(c|0)==0&d>>>0>16383)){q=n;r=k;break}else{h=n;o=k;c=J}}}else{q=e;r=g}b[q>>0]=r;r=q+1-e|0;f[p>>2]=(f[p>>2]|0)+r;f[a>>2]=(f[a>>2]|0)-r;return}function U_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{eZb(d,e);o=f[a>>2]|0}if((o|0)<=4){eZb(d,c);return}o=d+4|0;d=f[o>>2]|0;if(c>>>0>127){e=c;g=d;while(1){b[g>>0]=e|128;n=e>>>7;h=g+1|0;if(e>>>0>16383){e=n;g=h}else{p=h;q=n;break}}}else{p=d;q=c}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function V_b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)>4){h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;h=(f[a>>2]|0)-o|0;f[a>>2]=h;p=h}else{eZb(e,g);p=f[a>>2]|0}if((p|0)<=9){fZb(e,c,d);return}p=e+4|0;e=f[p>>2]|0;g=c&255;if(d>>>0>0|(d|0)==0&c>>>0>127){h=e;o=g;i=c;c=d;while(1){b[h>>0]=o|-128;d=i;i=l1c(i|0,c|0,7)|0;n=h+1|0;k=i&255;if(!(c>>>0>0|(c|0)==0&d>>>0>16383)){q=n;r=k;break}else{h=n;o=k;c=J}}}else{q=e;r=g}b[q>>0]=r;r=q+1-e|0;f[p>>2]=(f[p>>2]|0)+r;f[a>>2]=(f[a>>2]|0)-r;return}function W_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{eZb(d,e);o=f[a>>2]|0}e=c<<1^c>>31;if((o|0)<=4){eZb(d,e);return}o=d+4|0;d=f[o>>2]|0;if(e>>>0>127){c=e;g=d;while(1){b[g>>0]=c|128;n=c>>>7;h=g+1|0;if(c>>>0>16383){c=n;g=h}else{p=h;q=n;break}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function X_b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)>4){h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;h=(f[a>>2]|0)-o|0;f[a>>2]=h;p=h}else{eZb(e,g);p=f[a>>2]|0}g=u1c(c|0,d|0,1)|0;h=J;o=k1c(c|0,d|0,63)|0;d=g^o;o=h^J;if((p|0)<=9){fZb(e,d,o);return}p=e+4|0;e=f[p>>2]|0;h=d&255;if(o>>>0>0|(o|0)==0&d>>>0>127){g=e;c=h;i=d;d=o;while(1){b[g>>0]=c|-128;o=i;i=l1c(i|0,d|0,7)|0;n=g+1|0;k=i&255;if(!(d>>>0>0|(d|0)==0&o>>>0>16383)){q=n;r=k;break}else{g=n;c=k;d=J}}}else{q=e;r=h}b[q>>0]=r;r=q+1-e|0;f[p>>2]=(f[p>>2]|0)+r;f[a>>2]=(f[a>>2]|0)-r;return}function Y_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){eZb(d,e);cZb(d,c);return}g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n;cZb(d,c);return}function Z_b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3|1;a=e+8|0;if((f[a>>2]|0)<=4){eZb(e,g);dZb(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;dZb(e,c,d);return}function __b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){eZb(d,e);cZb(d,c);return}g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n;cZb(d,c);return}function $_b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3|1;a=e+8|0;if((f[a>>2]|0)<=4){eZb(e,g);dZb(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;dZb(e,c,d);return}function a$b(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){eZb(d,e);g=(n[s>>2]=c,f[s>>2]|0);cZb(d,g);return}h=d+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{o=m;p=l;break}}}else{o=i;p=e}b[o>>0]=p;p=o+1-i|0;f[h>>2]=(f[h>>2]|0)+p;f[a>>2]=(f[a>>2]|0)-p;g=(n[s>>2]=c,f[s>>2]|0);cZb(d,g);return}function b$b(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|1;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else eZb(d,e);p[s>>3]=c;dZb(d,f[s>>2]|0,f[s+4>>2]|0);return}function c$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{eZb(d,e);o=f[a>>2]|0}if((o|0)>4){o=d+4|0;b[f[o>>2]>>0]=c&1;f[o>>2]=(f[o>>2]|0)+1;f[a>>2]=(f[a>>2]|0)+-1;return}else{eZb(d,c&1);return}}function d$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{eZb(d,e);o=f[a>>2]|0}e=((c|0)<0)<<31>>31;if((o|0)<=9){fZb(d,c,e);return}o=d+4|0;d=f[o>>2]|0;g=c&255;if(c>>>0>127){n=d;h=g;m=c;c=e;while(1){b[n>>0]=h|-128;e=m;m=l1c(m|0,c|0,7)|0;j=n+1|0;i=m&255;if(!(c>>>0>0|(c|0)==0&e>>>0>16383)){p=j;q=i;break}else{n=j;h=i;c=J}}}else{p=d;q=g}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function e$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else eZb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(u_b(g,3,478888,510),r_b(h,p_b(g,478986)|0),v_b(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)<=4){eZb(d,t);v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;aZb(d,y,C);u=e;return}r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{D=j;E=h;break}}}else{D=s;E=t}b[D>>0]=E;E=D+1-s|0;f[r>>2]=(f[r>>2]|0)+E;f[a>>2]=(f[a>>2]|0)-E;v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;aZb(d,y,C);u=e;return}function f$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else eZb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(u_b(g,3,478888,519),r_b(h,p_b(g,478986)|0),v_b(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)>4){r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{v=j;w=h;break}}}else{v=s;w=t}b[v>>0]=w;w=v+1-s|0;f[r>>2]=(f[r>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else eZb(d,t);t=b[i>>0]|0;i=t<<24>>24<0;w=i?f[c>>2]|0:c;a=i?f[c+4>>2]|0:t&255;if(!(b[d+17>>0]|0)){aZb(d,w,a);u=e;return}else{bZb(d,w,a);u=e;return}}function g$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else eZb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(u_b(g,3,478888,526),r_b(h,p_b(g,478986)|0),v_b(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)<=4){eZb(d,t);v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;aZb(d,y,C);u=e;return}r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{D=j;E=h;break}}}else{D=s;E=t}b[D>>0]=E;E=D+1-s|0;f[r>>2]=(f[r>>2]|0)+E;f[a>>2]=(f[a>>2]|0)-E;v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;aZb(d,y,C);u=e;return}function h$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else eZb(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(u_b(g,3,478888,534),r_b(h,p_b(g,478986)|0),v_b(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)>4){r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{v=j;w=h;break}}}else{v=s;w=t}b[v>>0]=w;w=v+1-s|0;f[r>>2]=(f[r>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else eZb(d,t);t=b[i>>0]|0;i=t<<24>>24<0;w=i?f[c>>2]|0:c;a=i?f[c+4>>2]|0:t&255;if(!(b[d+17>>0]|0)){aZb(d,w,a);u=e;return}else{bZb(d,w,a);u=e;return}}function i$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=e|3;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;i=f[h>>2]|0;if(a>>>0>127){j=a;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=a}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else eZb(d,a);mi[f[(f[c>>2]|0)+52>>2]&2047](c,d);c=e|4;if((f[g>>2]|0)<=4){eZb(d,c);return}e=d+4|0;d=f[e>>2]|0;if(c>>>0>127){a=c;o=d;while(1){b[o>>0]=a|128;h=a>>>7;i=o+1|0;if(a>>>0>16383){a=h;o=i}else{p=i;q=h;break}}}else{p=d;q=c}b[p>>0]=q;q=p+1-d|0;f[e>>2]=(f[e>>2]|0)+q;f[g>>2]=(f[g>>2]|0)-q;return}function j$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else eZb(d,e);e=_i[f[(f[c>>2]|0)+60>>2]&2047](c)|0;if((f[a>>2]|0)<=4){eZb(d,e);o=f[c>>2]|0;p=o+52|0;q=f[p>>2]|0;mi[q&2047](c,d);return}n=d+4|0;g=f[n>>2]|0;if(e>>>0>127){h=e;m=g;while(1){b[m>>0]=h|128;j=h>>>7;i=m+1|0;if(h>>>0>16383){h=j;m=i}else{r=i;s=j;break}}}else{r=g;s=e}b[r>>0]=s;s=r+1-g|0;f[n>>2]=(f[n>>2]|0)+s;f[a>>2]=(f[a>>2]|0)-s;o=f[c>>2]|0;p=o+52|0;q=f[p>>2]|0;mi[q&2047](c,d);return}function k$b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else eZb(d,e);e=_i[f[(f[c>>2]|0)+60>>2]&2047](c)|0;if((f[a>>2]|0)>4){n=d+4|0;g=f[n>>2]|0;if(e>>>0>127){h=e;m=g;while(1){b[m>>0]=h|128;j=h>>>7;i=m+1|0;if(h>>>0>16383){h=j;m=i}else{o=i;p=j;break}}}else{o=g;p=e}b[o>>0]=p;p=o+1-g|0;f[n>>2]=(f[n>>2]|0)+p;g=(f[a>>2]|0)-p|0;f[a>>2]=g;q=n;r=g}else{eZb(d,e);q=d+4|0;r=f[a>>2]|0}if((r|0)>=(e|0)?(g=f[q>>2]|0,f[q>>2]=g+e,f[a>>2]=r-e,g|0):0){if(!(b[d+18>>0]|0))s=(f[223514]|0)!=0;else s=(b[d+19>>0]|0)!=0;hj[f[(f[c>>2]|0)+64>>2]&511](c,s,g)|0;return}mi[f[(f[c>>2]|0)+52>>2]&2047](c,d);return}function l$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d>>>0<g>>>0){g=b[d>>0]|0;i=g&255;if(g<<24>>24>-1){g=d+1|0;f[a>>2]=g;j=i;k=g;l=h}else{m=i;n=4}}else{m=0;n=4}do if((n|0)==4){i=KYb(a,m)|0;if((J|0)<0|(i|0)<0){o=0;return o|0}else{j=i;k=f[a>>2]|0;l=f[e>>2]|0;break}}while(0);if((l-k|0)<(j|0)){o=VYb(a,c,j)|0;return o|0}uYc(c,j,0);if((b[c+11>>0]|0)<0)p=f[c>>2]|0;else p=c;o1c(p|0,f[a>>2]|0,j|0)|0;f[a>>2]=(f[a>>2]|0)+j;o=1;return o|0}function m$b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+64|0;h=g;i=g+44|0;j=g+32|0;k=g+8|0;l=g+56|0;if(atc(a,c)|0){m=1;u=g;return m|0}c=(d|0)==0?479044:(d|0)==1?479032:0;d=i+11|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(e|0){f[h>>2]=e;Zsc(j,479052,h);if((b[d>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[d>>0]=0}sYc(i,0);f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2]}u_b(k,2,478888,629);r_b(l,p_b(p_b(p_b(p_b(p_b(p_b(q_b(p_b(k,479058)|0,i)|0,479071)|0,479090)|0,c)|0,479107)|0,479120)|0,479176)|0);v_b(k);if((b[d>>0]|0)<0)cYc(f[i>>2]|0);m=0;u=g;return m|0}function n$b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a>>2]|0;if((b|0)<=0){c=0;return c|0}d=f[a+8>>2]|0;a=0;e=0;while(1){g=f[d+4+(e<<2)>>2]|0;if((g|0)<0)h=10;else h=(((($(g|1|0)|0)^31)*9|0)+73|0)>>>6;g=h+a|0;e=e+1|0;if((e|0)==(b|0)){c=g;break}else a=g}return c|0}function o$b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a>>2]|0;if((b|0)<=0){c=0;return c|0}d=f[a+8>>2]|0;a=0;e=0;while(1){g=((((($(f[d+4+(e<<2)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+a|0;e=e+1|0;if((e|0)==(b|0)){c=g;break}else a=g}return c|0}function p$b(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;n[a+28>>2]=1.0;b=a+32|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+48>>2]=1.0;b=a+52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+68>>2]=1.0;b=a+132|0;c=a+148|0;d=a+72|0;e=d+76|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));n[c>>2]=1.0;q$b(b,3);b=a+152|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+168>>2]=1.0;r$b(b,3);f[a+176>>2]=0;f[a+180>>2]=0;f[a+172>>2]=a+176;d=a+184|0;e=d+48|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function q$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){t$b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;t$b(a,d);return}function r$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){s$b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;s$b(a,d);return}function s$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){b:do if(h){e=k;c=l;i=m;while(1){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(GIc(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[e>>2]|0;if(!o){v=37;break a}else d=o}c=f[d>>2]|0;if(!c){v=37;break a}else{e=d;i=d}}}else{i=k;e=l;c=m;while(1){o=e;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=c;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(GIc(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[c>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=37;break a}else o=w}e=f[o>>2]|0;if(!e){v=37;break a}else{i=o;c=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=37;break}else{j=s;k=p;m=p}}if((v|0)==37)return}function t$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){b:do if(h){e=k;c=l;i=m;while(1){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(GIc(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[e>>2]|0;if(!o){v=37;break a}else d=o}c=f[d>>2]|0;if(!c){v=37;break a}else{e=d;i=d}}}else{i=k;e=l;c=m;while(1){o=e;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=c;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(GIc(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[c>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=37;break a}else o=w}e=f[o>>2]|0;if(!e){v=37;break a}else{i=o;c=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=37;break}else{j=s;k=p;m=p}}if((v|0)==37)return}function u$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+84|0;d=f[c>>2]|0;e=a+88|0;g=f[e>>2]|0;if((d|0)!=(g|0)){h=d;do{d=f[h>>2]|0;h=h+4|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d)}while((h|0)!=(g|0));g=f[c>>2]|0;h=f[e>>2]|0;if((h|0)!=(g|0))f[e>>2]=h+(~((h+-4-g|0)>>>2)<<2)}g=a+120|0;h=a+124|0;d=f[g>>2]|0;if((f[h>>2]|0)!=(d|0)){i=0;j=d;do{cYc(f[j+(i<<2)>>2]|0);i=i+1|0;j=f[g>>2]|0}while(i>>>0<(f[h>>2]|0)-j>>2>>>0)}j=a+72|0;i=f[j>>2]|0;d=a+76|0;k=f[d>>2]|0;if((i|0)!=(k|0)){l=i;do{i=f[l>>2]|0;l=l+4|0;if(i|0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}}while((l|0)!=(k|0));k=f[j>>2]|0;l=f[d>>2]|0;if((l|0)!=(k|0))f[d>>2]=l+(~((l+-4-k|0)>>>2)<<2)}k=a+108|0;l=f[k>>2]|0;i=a+112|0;m=f[i>>2]|0;if((l|0)!=(m|0)){n=l;do{l=f[n>>2]|0;n=n+4|0;if(l|0){v$b(l);cYc(l)}}while((n|0)!=(m|0));m=f[k>>2]|0;n=f[i>>2]|0;if((n|0)!=(m|0))f[i>>2]=n+(~((n+-4-m|0)>>>2)<<2)}m=a+96|0;n=f[m>>2]|0;l=a+100|0;o=f[l>>2]|0;if((n|0)!=(o|0)){p=n;do{n=f[p>>2]|0;p=p+4|0;if(n|0)cYc(n)}while((p|0)!=(o|0));o=f[m>>2]|0;p=f[l>>2]|0;if((p|0)!=(o|0))f[l>>2]=p+(~((p+-4-o|0)>>>2)<<2)}o=f[a+220>>2]|0;if(o|0){p=a+224|0;n=f[p>>2]|0;if((n|0)!=(o|0))f[p>>2]=n+(~((n+-8-o|0)>>>3)<<3);cYc(o)}o=f[a+208>>2]|0;if(o|0){n=a+212|0;p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-4-o|0)>>>2)<<2);cYc(o)}o=f[a+196>>2]|0;if(o|0){p=a+200|0;n=f[p>>2]|0;if((n|0)!=(o|0))f[p>>2]=n+(~((n+-4-o|0)>>>2)<<2);cYc(o)}o=f[a+184>>2]|0;if(o|0){n=a+188|0;p=f[n>>2]|0;if((p|0)!=(o|0))f[n>>2]=p+(~((p+-32-o|0)>>>5)<<5);cYc(o)}w$b(a+172|0,f[a+176>>2]|0);o=f[a+160>>2]|0;if(o|0){p=o;do{o=p;p=f[p>>2]|0;cYc(o)}while((p|0)!=0)}p=a+152|0;o=f[p>>2]|0;f[p>>2]=0;if(o|0)cYc(o);o=f[a+140>>2]|0;if(o|0){p=o;do{o=p;p=f[p>>2]|0;cYc(o)}while((p|0)!=0)}p=a+132|0;o=f[p>>2]|0;f[p>>2]=0;if(o|0)cYc(o);o=f[g>>2]|0;if(o|0){g=f[h>>2]|0;if((g|0)!=(o|0))f[h>>2]=g+(~((g+-4-o|0)>>>2)<<2);cYc(o)}o=f[k>>2]|0;if(o|0){k=f[i>>2]|0;if((k|0)!=(o|0))f[i>>2]=k+(~((k+-4-o|0)>>>2)<<2);cYc(o)}o=f[m>>2]|0;if(o|0){m=f[l>>2]|0;if((m|0)!=(o|0))f[l>>2]=m+(~((m+-4-o|0)>>>2)<<2);cYc(o)}o=f[c>>2]|0;if(o|0){c=f[e>>2]|0;if((c|0)!=(o|0))f[e>>2]=c+(~((c+-4-o|0)>>>2)<<2);cYc(o)}o=f[j>>2]|0;if(o|0){j=f[d>>2]|0;if((j|0)!=(o|0))f[d>>2]=j+(~((j+-4-o|0)>>>2)<<2);cYc(o)}o=f[a+60>>2]|0;if(o|0){j=o;do{o=j;j=f[j>>2]|0;cYc(o)}while((j|0)!=0)}j=a+52|0;o=f[j>>2]|0;f[j>>2]=0;if(o|0)cYc(o);o=f[a+40>>2]|0;if(o|0){j=o;do{o=j;j=f[j>>2]|0;d=o+8|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);cYc(o)}while((j|0)!=0)}j=a+32|0;o=f[j>>2]|0;f[j>>2]=0;if(o|0)cYc(o);o=f[a+20>>2]|0;if(o|0){j=o;do{o=j;j=f[j>>2]|0;d=o+8|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);cYc(o)}while((j|0)!=0)}j=a+12|0;o=f[j>>2]|0;f[j>>2]=0;if(o|0)cYc(o);o=f[a>>2]|0;if(!o)return;j=a+4|0;d=f[j>>2]|0;if((d|0)==(o|0))q=o;else{c=d;while(1){d=c+-12|0;f[j>>2]=d;if((b[d+11>>0]|0)<0){cYc(f[d>>2]|0);r=f[j>>2]|0}else r=d;if((r|0)==(o|0))break;else c=r}q=f[a>>2]|0}cYc(q);return}function v$b(a){a=a|0;var c=0,d=0,e=0;x_b(a+160|0);c=f[a+148>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;e=c+8|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(c)}while((d|0)!=0)}d=a+140|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)cYc(c);c=f[a+124>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;cYc(c)}while((d|0)!=0)}d=a+116|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)cYc(c);c=f[a+104>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;cYc(c)}while((d|0)!=0)}d=a+96|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)cYc(c);c=f[a+84>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;cYc(c)}while((d|0)!=0)}d=a+76|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)cYc(c);c=f[a+56>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;cYc(c)}while((d|0)!=0)}d=a+48|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)cYc(c);c=f[a+28>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;cYc(c)}while((d|0)!=0)}d=a+20|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)cYc(c);c=f[a+8>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;cYc(c)}while((d|0)!=0)}d=f[a>>2]|0;f[a>>2]=0;if(!d)return;cYc(d);return}function w$b(a,b){a=a|0;b=b|0;if(!b)return;else{w$b(a,f[b>>2]|0);w$b(a,f[b+4>>2]|0);cYc(b);return}}function x$b(a){a=a|0;var b=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;n[a+16>>2]=1.0;y$b(a,3);b=a+20|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+36>>2]=1.0;z$b(b,3);b=$Xc(20)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[b+16>>2]=1.0;f[a+40>>2]=b;b=a+44|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;n[a+64>>2]=1.0;z$b(a+48|0,3);b=$Xc(20)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[b+16>>2]=1.0;f[a+68>>2]=b;b=a+72|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;n[a+92>>2]=1.0;A$b(a+76|0,3);b=a+96|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+112>>2]=1.0;B$b(b,3);b=a+116|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+132>>2]=1.0;B$b(b,3);b=a+136|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;n[a+156>>2]=1.0;C$b(a+140|0,3);w_b(a+160|0);return}function y$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){H$b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;H$b(a,d);return}function z$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){G$b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;G$b(a,d);return}function A$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){F$b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;F$b(a,d);return}function B$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){E$b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;E$b(a,d);return}function C$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){D$b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;D$b(a,d);return}function D$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=a+4|0;if(!c){e=f[a>>2]|0;f[a>>2]=0;if(e|0)cYc(e);f[d>>2]=0;return}if(c>>>0>1073741823){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}e=$Xc(c<<2)|0;g=f[a>>2]|0;f[a>>2]=e;if(g|0)cYc(g);f[d>>2]=c;d=0;do{f[(f[a>>2]|0)+(d<<2)>>2]=0;d=d+1|0}while((d|0)!=(c|0));d=a+8|0;g=f[d>>2]|0;if(!g)return;e=f[g+4>>2]|0;h=c+-1|0;i=(h&c|0)==0;if(!i)if(e>>>0<c>>>0)j=e;else j=(e>>>0)%(c>>>0)|0;else j=e&h;f[(f[a>>2]|0)+(j<<2)>>2]=d;d=f[g>>2]|0;if(!d)return;else{k=j;l=g;m=d;n=g}a:while(1){g=l;d=m;j=n;b:while(1){o=d;while(1){e=f[o+4>>2]|0;if(!i)if(e>>>0<c>>>0)p=e;else p=(e>>>0)%(c>>>0)|0;else p=e&h;if((p|0)==(k|0))break;q=(f[a>>2]|0)+(p<<2)|0;if(!(f[q>>2]|0))break b;e=f[o>>2]|0;c:do if(!e)r=o;else{s=o+8|0;t=b[s+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[o+12>>2]|0:v;w=(t|0)==0;if(u){u=o;x=e;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){r=u;break c}if(!w?WKc(f[s>>2]|0,A?f[y>>2]|0:y,t)|0:0){r=u;break c}y=f[x>>2]|0;if(!y){r=x;break c}else{A=x;x=y;u=A}}}if(w){u=o;x=e;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){r=u;break c}A=f[x>>2]|0;if(!A){r=x;break c}else{y=x;x=A;u=y}}}u=o;x=e;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){r=u;break c}y=A?f[w>>2]|0:w;if((f[s>>2]&255)<<24>>24==(b[y>>0]|0)){B=s;C=v;D=y}else{r=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){r=u;break c}}y=f[x>>2]|0;if(!y){r=x;break}else{w=x;x=y;u=w}}}while(0);f[j>>2]=f[r>>2];f[r>>2]=f[f[(f[a>>2]|0)+(p<<2)>>2]>>2];f[f[(f[a>>2]|0)+(p<<2)>>2]>>2]=o;e=f[g>>2]|0;if(!e){E=43;break a}else o=e}d=f[o>>2]|0;if(!d){E=43;break a}else{g=o;j=o}}f[q>>2]=j;m=f[o>>2]|0;if(!m){E=43;break}else{k=p;l=o;n=o}}if((E|0)==43)return}function E$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){e=k;c=l;i=m;b:while(1){c:do if(h){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=d+12|0;t=f[d>>2]|0;d:do if(!t)u=d;else{v=f[d+8>>2]|0;w=d;x=t;while(1){if((v|0)!=(f[x+8>>2]|0)){u=w;break d}if((f[p>>2]|0)!=(f[x+12>>2]|0)){u=w;break d}y=f[x>>2]|0;if(!y){u=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[u>>2];f[u>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}else{d=c;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=d+12|0;t=f[d>>2]|0;e:do if(!t)C=d;else{w=f[d+8>>2]|0;x=d;v=t;while(1){if((w|0)!=(f[v+8>>2]|0)){C=x;break e}if((f[p>>2]|0)!=(f[v+12>>2]|0)){C=x;break e}z=f[v>>2]|0;if(!z){C=v;break}else{y=v;v=z;x=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}while(0);c=f[o>>2]|0;if(!c){A=39;break a}else{e=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=39;break}else{j=s;k=q;m=q}}if((A|0)==39)return}function F$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){e=k;c=l;i=m;b:while(1){c:do if(h){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=d+12|0;t=f[d>>2]|0;d:do if(!t)u=d;else{v=f[d+8>>2]|0;w=d;x=t;while(1){if((v|0)!=(f[x+8>>2]|0)){u=w;break d}if((f[p>>2]|0)!=(f[x+12>>2]|0)){u=w;break d}y=f[x>>2]|0;if(!y){u=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[u>>2];f[u>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}else{d=c;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=d+12|0;t=f[d>>2]|0;e:do if(!t)C=d;else{w=f[d+8>>2]|0;x=d;v=t;while(1){if((w|0)!=(f[v+8>>2]|0)){C=x;break e}if((f[p>>2]|0)!=(f[v+12>>2]|0)){C=x;break e}z=f[v>>2]|0;if(!z){C=v;break}else{y=v;v=z;x=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}while(0);c=f[o>>2]|0;if(!c){A=39;break a}else{e=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=39;break}else{j=s;k=q;m=q}}if((A|0)==39)return}function G$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){e=k;c=l;i=m;b:while(1){c:do if(h){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=f[d>>2]|0;d:do if(!p)t=d;else{u=f[d+8>>2]|0;v=d+12|0;w=d;x=p;while(1){if((u|0)!=(f[x+8>>2]|0)){t=w;break d}if(GIc(f[v>>2]|0,f[x+12>>2]|0)|0){t=w;break d}y=f[x>>2]|0;if(!y){t=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[t>>2];f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}else{d=c;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=f[d>>2]|0;e:do if(!p)C=d;else{w=f[d+8>>2]|0;x=d+12|0;v=d;u=p;while(1){if((w|0)!=(f[u+8>>2]|0)){C=v;break e}if(GIc(f[x>>2]|0,f[u+12>>2]|0)|0){C=v;break e}z=f[u>>2]|0;if(!z){C=u;break}else{y=u;u=z;v=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}while(0);c=f[o>>2]|0;if(!c){A=39;break a}else{e=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=39;break}else{j=s;k=q;m=q}}if((A|0)==39)return}function H$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){e=k;c=l;i=m;b:while(1){c:do if(h){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=f[d>>2]|0;d:do if(!p)t=d;else{u=f[d+8>>2]|0;v=d+12|0;w=d;x=p;while(1){if((u|0)!=(f[x+8>>2]|0)){t=w;break d}if(GIc(f[v>>2]|0,f[x+12>>2]|0)|0){t=w;break d}y=f[x>>2]|0;if(!y){t=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[t>>2];f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}else{d=c;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=f[d>>2]|0;e:do if(!p)C=d;else{w=f[d+8>>2]|0;x=d+12|0;v=d;u=p;while(1){if((w|0)!=(f[u+8>>2]|0)){C=v;break e}if(GIc(f[x>>2]|0,f[u+12>>2]|0)|0){C=v;break e}z=f[u>>2]|0;if(!z){C=u;break}else{y=u;u=z;v=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[e>>2]|0;if(!d){A=39;break a}}}while(0);c=f[o>>2]|0;if(!c){A=39;break a}else{e=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=39;break}else{j=s;k=q;m=q}}if((A|0)==39)return}function I$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>5;h=g+1|0;if(h>>>0>134217727)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>4;l=j>>5>>>0<67108863?(k>>>0<h>>>0?h:k):134217727;do if(l)if(l>>>0>134217727){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<5)|0;break}else m=0;while(0);k=m+(g<<5)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];b=k+(0-g<<5)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+32;f[i>>2]=m+(l<<5);if(!d)return;cYc(d);return}function J$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+188|0;d=f[c>>2]|0;e=d+-12|0;g=f[e>>2]|0;h=a+196|0;i=a+200|0;j=f[h>>2]|0;if(g>>>0<(f[i>>2]|0)-j>>2>>>0){k=a+132|0;l=g;g=j;do{K$b(k,g+(l<<2)|0)|0;l=l+1|0;g=f[h>>2]|0}while(l>>>0<(f[i>>2]|0)-g>>2>>>0)}g=d+-8|0;l=f[g>>2]|0;k=a+208|0;j=a+212|0;m=f[k>>2]|0;if(l>>>0<(f[j>>2]|0)-m>>2>>>0){n=a+152|0;o=l;l=m;do{L$b(n,l+(o<<2)|0)|0;o=o+1|0;l=f[k>>2]|0}while(o>>>0<(f[j>>2]|0)-l>>2>>>0)}l=d+-4|0;o=f[l>>2]|0;n=a+220|0;m=a+224|0;p=f[n>>2]|0;if(o>>>0<(f[m>>2]|0)-p>>3>>>0){q=a+172|0;r=o;o=p;do{O$b(q,o+(r<<3)|0)|0;r=r+1|0;o=f[n>>2]|0}while(r>>>0<(f[m>>2]|0)-o>>3>>>0)}o=f[e>>2]|0;e=f[i>>2]|0;r=f[h>>2]|0;q=e-r>>2;p=r;r=e;if(o>>>0<=q>>>0){if(o>>>0<q>>>0?(e=p+(o<<2)|0,(r|0)!=(e|0)):0)f[i>>2]=r+(~((r+-4-e|0)>>>2)<<2)}else M$b(h,o-q|0);q=f[g>>2]|0;g=f[j>>2]|0;o=f[k>>2]|0;h=g-o>>2;e=o;o=g;if(q>>>0<=h>>>0){if(q>>>0<h>>>0?(g=e+(q<<2)|0,(o|0)!=(g|0)):0)f[j>>2]=o+(~((o+-4-g|0)>>>2)<<2)}else M$b(k,q-h|0);h=f[l>>2]|0;l=f[m>>2]|0;q=f[n>>2]|0;k=l-q>>3;g=q;q=l;if(h>>>0<=k>>>0){if(h>>>0<k>>>0?(l=g+(h<<3)|0,(q|0)!=(l|0)):0)f[m>>2]=q+(~((q+-8-l|0)>>>3)<<3)}else N$b(n,h-k|0);k=a+72|0;h=d+-32|0;n=(f[k>>2]|0)+(f[h>>2]<<2)|0;l=a+76|0;q=f[l>>2]|0;if((n|0)!=(q|0)){m=n;do{n=f[m>>2]|0;m=m+4|0;if(n|0){if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);cYc(n)}}while((m|0)!=(q|0))}q=a+84|0;m=d+-28|0;n=(f[q>>2]|0)+(f[m>>2]<<2)|0;g=a+88|0;o=f[g>>2]|0;if((n|0)!=(o|0)){j=n;do{n=f[j>>2]|0;j=j+4|0;if(n|0)Yi[f[(f[n>>2]|0)+4>>2]&4095](n)}while((j|0)!=(o|0))}o=a+96|0;j=d+-24|0;n=(f[o>>2]|0)+(f[j>>2]<<2)|0;e=a+100|0;r=f[e>>2]|0;if((n|0)!=(r|0)){i=n;do{n=f[i>>2]|0;i=i+4|0;if(n|0)cYc(n)}while((i|0)!=(r|0))}r=a+108|0;i=d+-20|0;n=(f[r>>2]|0)+(f[i>>2]<<2)|0;p=a+112|0;s=f[p>>2]|0;if((n|0)!=(s|0)){t=n;do{n=f[t>>2]|0;t=t+4|0;if(n|0){v$b(n);cYc(n)}}while((t|0)!=(s|0))}s=d+-16|0;d=f[s>>2]|0;t=a+120|0;n=a+124|0;a=f[t>>2]|0;if(d>>>0<(f[n>>2]|0)-a>>2>>>0){u=d;d=a;do{cYc(f[d+(u<<2)>>2]|0);u=u+1|0;d=f[t>>2]|0}while(u>>>0<(f[n>>2]|0)-d>>2>>>0)}d=f[h>>2]|0;h=f[l>>2]|0;u=f[k>>2]|0;a=h-u>>2;v=u;u=h;if(d>>>0<=a>>>0){if(d>>>0<a>>>0?(h=v+(d<<2)|0,(u|0)!=(h|0)):0)f[l>>2]=u+(~((u+-4-h|0)>>>2)<<2)}else P$b(k,d-a|0);a=f[m>>2]|0;m=f[g>>2]|0;d=f[q>>2]|0;k=m-d>>2;h=d;d=m;if(a>>>0<=k>>>0){if(a>>>0<k>>>0?(m=h+(a<<2)|0,(d|0)!=(m|0)):0)f[g>>2]=d+(~((d+-4-m|0)>>>2)<<2)}else Q$b(q,a-k|0);k=f[j>>2]|0;j=f[e>>2]|0;a=f[o>>2]|0;q=j-a>>2;m=a;a=j;if(k>>>0<=q>>>0){if(k>>>0<q>>>0?(j=m+(k<<2)|0,(a|0)!=(j|0)):0)f[e>>2]=a+(~((a+-4-j|0)>>>2)<<2)}else R$b(o,k-q|0);q=f[i>>2]|0;i=f[p>>2]|0;k=f[r>>2]|0;o=i-k>>2;j=k;k=i;if(q>>>0<=o>>>0){if(q>>>0<o>>>0?(i=j+(q<<2)|0,(k|0)!=(i|0)):0)f[p>>2]=k+(~((k+-4-i|0)>>>2)<<2)}else S$b(r,q-o|0);o=f[s>>2]|0;s=f[n>>2]|0;q=f[t>>2]|0;r=s-q>>2;i=s;if(o>>>0>r>>>0){T$b(t,o-r|0);w=f[c>>2]|0;x=w+-32|0;f[c>>2]=x;return}if(o>>>0>=r>>>0){w=f[c>>2]|0;x=w+-32|0;f[c>>2]=x;return}r=q+(o<<2)|0;if((i|0)==(r|0)){w=f[c>>2]|0;x=w+-32|0;f[c>>2]=x;return}f[n>>2]=i+(~((i+-4-r|0)>>>2)<<2);w=f[c>>2]|0;x=w+-32|0;f[c>>2]=x;return}function K$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=V$b(a,b)|0;if(!c){d=0;return d|0}b=f[a+4>>2]|0;e=f[c+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(e>>>0<b>>>0)i=e;else i=(e>>>0)%(b>>>0)|0;else i=g&e;e=(f[a>>2]|0)+(i<<2)|0;j=f[e>>2]|0;while(1){k=f[j>>2]|0;if((k|0)==(c|0))break;else j=k}if((j|0)!=(a+8|0)){k=f[j+4>>2]|0;if(!h)if(k>>>0<b>>>0)l=k;else l=(k>>>0)%(b>>>0)|0;else l=k&g;if((l|0)==(i|0))m=c;else n=15}else n=15;do if((n|0)==15){l=f[c>>2]|0;if(l|0){k=f[l+4>>2]|0;if(!h)if(k>>>0<b>>>0)o=k;else o=(k>>>0)%(b>>>0)|0;else o=k&g;if((o|0)==(i|0)){m=c;break}}f[e>>2]=0;m=c}while(0);e=f[m>>2]|0;o=e;if(e){n=f[e+4>>2]|0;if(!h)if(n>>>0<b>>>0)p=n;else p=(n>>>0)%(b>>>0)|0;else p=n&g;if((p|0)!=(i|0)){f[(f[a>>2]|0)+(p<<2)>>2]=j;q=f[c>>2]|0}else q=o}else q=o;f[j>>2]=q;f[m>>2]=0;m=a+12|0;f[m>>2]=(f[m>>2]|0)+-1;cYc(c);d=1;return d|0}function L$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=U$b(a,b)|0;if(!c){d=0;return d|0}b=f[a+4>>2]|0;e=f[c+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(e>>>0<b>>>0)i=e;else i=(e>>>0)%(b>>>0)|0;else i=g&e;e=(f[a>>2]|0)+(i<<2)|0;j=f[e>>2]|0;while(1){k=f[j>>2]|0;if((k|0)==(c|0))break;else j=k}if((j|0)!=(a+8|0)){k=f[j+4>>2]|0;if(!h)if(k>>>0<b>>>0)l=k;else l=(k>>>0)%(b>>>0)|0;else l=k&g;if((l|0)==(i|0))m=c;else n=15}else n=15;do if((n|0)==15){l=f[c>>2]|0;if(l|0){k=f[l+4>>2]|0;if(!h)if(k>>>0<b>>>0)o=k;else o=(k>>>0)%(b>>>0)|0;else o=k&g;if((o|0)==(i|0)){m=c;break}}f[e>>2]=0;m=c}while(0);e=f[m>>2]|0;o=e;if(e){n=f[e+4>>2]|0;if(!h)if(n>>>0<b>>>0)p=n;else p=(n>>>0)%(b>>>0)|0;else p=n&g;if((p|0)!=(i|0)){f[(f[a>>2]|0)+(p<<2)>>2]=j;q=f[c>>2]|0}else q=o}else q=o;f[j>>2]=q;f[m>>2]=0;m=a+12|0;f[m>>2]=(f[m>>2]|0)+-1;cYc(c);d=1;return d|0}function M$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function N$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){g1c(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)kWc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;g1c(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;cYc(h);return}function O$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[c>>2]|0;if(!d){e=0;return e|0}g=f[b>>2]|0;h=f[b+4>>2]|0;b=c;i=d;a:while(1){j=i;while(1){k=f[j+16>>2]|0;if(k>>>0>=g>>>0){if(g>>>0<k>>>0)break;if((f[j+20>>2]|0)>=(h|0))break}k=f[j+4>>2]|0;if(!k){l=b;break a}else j=k}i=f[j>>2]|0;if(!i){l=j;break}else b=j}if((l|0)==(c|0)){e=0;return e|0}c=f[l+16>>2]|0;if(g>>>0<c>>>0){e=0;return e|0}if(c>>>0>=g>>>0?(h|0)<(f[l+20>>2]|0):0){e=0;return e|0}h=f[l+4>>2]|0;if(!h){g=l+8|0;c=f[g>>2]|0;if((f[c>>2]|0)==(l|0))m=c;else{c=g;do{g=f[c>>2]|0;c=g+8|0;b=f[c>>2]|0}while((f[b>>2]|0)!=(g|0));m=b}}else{c=h;while(1){h=f[c>>2]|0;if(!h)break;else c=h}m=c}if((f[a>>2]|0)==(l|0))f[a>>2]=m;m=a+8|0;f[m>>2]=(f[m>>2]|0)+-1;XIa(d,l);cYc(l);e=1;return e|0}function P$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function Q$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function R$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function S$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function T$b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function U$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(GIc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(GIc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function V$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(GIc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(GIc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function W$b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g;i=f[d>>2]|0;j=(i|0)==0;if(!j)g_b(i);k=c+44|0;if(f[k>>2]|0){l=c+40|0;m=f[l>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;o=m+8|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);cYc(m)}while((n|0)!=0)}f[l>>2]=0;l=f[c+36>>2]|0;if(l|0){n=c+32|0;m=0;do{f[(f[n>>2]|0)+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(l|0))}f[k>>2]=0}k=c+24|0;if(f[k>>2]|0){l=c+20|0;m=f[l>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;o=m+8|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);cYc(m)}while((n|0)!=0)}f[l>>2]=0;l=f[c+16>>2]|0;if(l|0){n=c+12|0;m=0;do{f[(f[n>>2]|0)+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(l|0))}f[k>>2]=0}k=e+11|0;f[h>>2]=(b[k>>0]|0)<0?f[e>>2]|0:e;l=c+132|0;c=X$b(l,h)|0;if(c){m=c+12|0;c=f[m>>2]|0;n=f[m+4>>2]|0;m=a;f[m>>2]=c;f[m+4>>2]=n;if(!c)p=24}else{c=a;f[c>>2]=0;f[c+4>>2]=0;p=24}do if((p|0)==24){c=f[d+12>>2]|0;if(c|0?(W$b(h,f[c+16>>2]|0,c,e),c=h,n=f[c>>2]|0,m=f[c+4>>2]|0,c=a,f[c>>2]=n,f[c+4>>2]=m,n|0):0)break;if(Y$b(d,e)|0){f[h>>2]=(b[k>>0]|0)<0?f[e>>2]|0:e;n=X$b(l,h)|0;if(!n){q=0;r=0}else{m=n+12|0;q=f[m>>2]|0;r=f[m+4>>2]|0}m=a;f[m>>2]=q;f[m+4>>2]=r}}while(0);if(j){u=g;return}h_b(i);u=g;return}function X$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(e|0)==(c|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(GIc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(e|0)==(a|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(GIc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function Y$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0;d=u;u=u+144|0;e=d+140|0;g=d;h=a+4|0;if(!(f[h>>2]|0)){i=0;u=d;return i|0}j=a+16|0;if(Z$b((f[j>>2]|0)+32|0,c)|0){i=0;u=d;return i|0}Rec(g);do if(!(_$b(a,c)|0)?(k=f[h>>2]|0,hj[f[(f[k>>2]|0)+12>>2]&511](k,c,g)|0):0){k=f[j>>2]|0;l=f[g+120>>2]|0;f[e>>2]=(b[l+11>>0]|0)<0?f[l>>2]|0:l;l=$$b(k+152|0,e)|0;if(l)if(f[l+12>>2]|0){m=9;break}if(a0b(a,g)|0)o=1;else m=9}else m=9;while(0);a:do if((m|0)==9){a=f[j>>2]|0;e=a+32|0;h=b[c+11>>0]|0;l=h<<24>>24<0;k=l?f[c>>2]|0:c;p=b[k>>0]|0;if(!(p<<24>>24))q=0;else{r=k;s=0;t=p;while(1){v=(s*5|0)+(t<<24>>24)|0;r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24)){q=v;break}else s=v}}s=a+36|0;t=f[s>>2]|0;r=(t|0)==0;b:do if(!r){v=t+-1|0;w=(v&t|0)==0;if(!w)if(q>>>0<t>>>0)x=q;else x=(q>>>0)%(t>>>0)|0;else x=v&q;y=f[(f[e>>2]|0)+(x<<2)>>2]|0;if((y|0)!=0?(z=f[y>>2]|0,(z|0)!=0):0){y=l?f[c+4>>2]|0:h&255;A=(y|0)==0;if(w){if(A){w=z;while(1){B=f[w+4>>2]|0;if(!((B|0)==(q|0)|(B&v|0)==(x|0))){C=x;break b}B=b[w+8+11>>0]|0;if(!((B<<24>>24<0?f[w+12>>2]|0:B&255)|0)){o=0;break a}w=f[w>>2]|0;if(!w){C=x;break b}}}else D=z;while(1){w=f[D+4>>2]|0;if(!((w|0)==(q|0)|(w&v|0)==(x|0))){C=x;break b}w=D+8|0;B=b[w+11>>0]|0;E=B<<24>>24<0;F=B&255;do if(((E?f[D+12>>2]|0:F)|0)==(y|0)){B=f[w>>2]|0;if(E)if(!(WKc(B,k,y)|0)){o=0;break a}else break;if((B&255)<<24>>24==p<<24>>24){B=w;G=F;H=k;do{G=G+-1|0;B=B+1|0;if(!G){o=0;break a}H=H+1|0}while((b[B>>0]|0)==(b[H>>0]|0))}}while(0);D=f[D>>2]|0;if(!D){C=x;break b}}}if(A){v=z;while(1){F=f[v+4>>2]|0;if((F|0)!=(q|0)){if(F>>>0<t>>>0)I=F;else I=(F>>>0)%(t>>>0)|0;if((I|0)!=(x|0)){C=x;break b}}F=b[v+8+11>>0]|0;if(!((F<<24>>24<0?f[v+12>>2]|0:F&255)|0)){o=0;break a}v=f[v>>2]|0;if(!v){C=x;break b}}}else J=z;while(1){v=f[J+4>>2]|0;if((v|0)!=(q|0)){if(v>>>0<t>>>0)K=v;else K=(v>>>0)%(t>>>0)|0;if((K|0)!=(x|0)){C=x;break b}}v=J+8|0;A=b[v+11>>0]|0;F=A<<24>>24<0;w=A&255;do if(((F?f[J+12>>2]|0:w)|0)==(y|0)){A=f[v>>2]|0;if(F)if(!(WKc(A,k,y)|0)){o=0;break a}else break;if((A&255)<<24>>24==p<<24>>24){A=v;E=w;H=k;do{E=E+-1|0;A=A+1|0;if(!E){o=0;break a}H=H+1|0}while((b[A>>0]|0)==(b[H>>0]|0))}}while(0);J=f[J>>2]|0;if(!J){C=x;break}}}else C=x}else C=0;while(0);k=$Xc(20)|0;lYc(k+8|0,c);f[k+4>>2]=q;f[k>>2]=0;p=a+44|0;L=+(((f[p>>2]|0)+1|0)>>>0);M=+n[a+48>>2];do if(r|L>+(t>>>0)*M){h=(t>>>0<3|(t+-1&t|0)!=0)&1|t<<1;l=~~+X(+(L/M))>>>0;b0b(e,h>>>0<l>>>0?l:h);h=f[s>>2]|0;l=h+-1|0;if(!(l&h)){N=h;O=l&q;break}if(q>>>0<h>>>0){N=h;O=q}else{N=h;O=(q>>>0)%(h>>>0)|0}}else{N=t;O=C}while(0);t=(f[e>>2]|0)+(O<<2)|0;s=f[t>>2]|0;if(!s){r=a+40|0;f[k>>2]=f[r>>2];f[r>>2]=k;f[t>>2]=r;r=f[k>>2]|0;if(r|0){t=f[r+4>>2]|0;r=N+-1|0;if(r&N)if(t>>>0<N>>>0)P=t;else P=(t>>>0)%(N>>>0)|0;else P=t&r;Q=(f[e>>2]|0)+(P<<2)|0;m=64}}else{f[k>>2]=f[s>>2];Q=s;m=64}if((m|0)==64)f[Q>>2]=k;f[p>>2]=(f[p>>2]|0)+1;o=0}while(0);vec(g);i=o;u=d;return i|0}function Z$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(i|0)==(c|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(WKc(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(i|0)==(a|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(WKc(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function _$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+32|0;e=d+12|0;g=d;lYc(g,c);h=KYc(g,46,-1)|0;a:do if((h|0)==-1)i=9;else{j=g+11|0;k=g+4|0;l=a+16|0;m=h;while(1){mYc(e,g,0,m,g);if((b[j>>0]|0)<0){b[f[g>>2]>>0]=0;f[k>>2]=0}else{b[g>>0]=0;b[j>>0]=0}sYc(g,0);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];n=f[l>>2]|0;f[e>>2]=(b[j>>0]|0)<0?f[g>>2]|0:g;o=X$b(n+132|0,e)|0;if(o|0)switch(f[o+12>>2]|0){case 8:case 0:break;default:{p=1;break a}}m=KYc(g,46,-1)|0;if((m|0)==-1){i=9;break}}}while(0);if((i|0)==9){i=f[a+12>>2]|0;if(!i)p=0;else p=_$b(i,c)|0}if((b[g+11>>0]|0)>=0){u=d;return p|0}cYc(f[g>>2]|0);u=d;return p|0}function $$b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(e|0)==(c|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(GIc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(e|0)==(a|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(GIc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function a0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0;d=u;u=u+112|0;e=d;g=a+16|0;h=c+120|0;if(Z$b((f[g>>2]|0)+12|0,f[h>>2]|0)|0){i=0;u=d;return i|0}j=f[g>>2]|0;k=f[a+8>>2]|0;f[e>>2]=a;f[e+4>>2]=j;f[e+8>>2]=k;k=e+12|0;j=e+28|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[e+52>>2]=0;f[e+56>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+12>>0]=0;f[e+48>>2]=e+52;f[e+64>>2]=0;f[e+68>>2]=0;f[e+60>>2]=e+64;k=e+72|0;j=e+88|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;b[j+11>>0]=0;b[j>>0]=0;j=d0b(e,c)|0;e0b(e);if(j|0){i=j;u=d;return i|0}j=f[g>>2]|0;g=j+12|0;e=f[h>>2]|0;h=b[e+11>>0]|0;c=h<<24>>24<0;k=c?f[e>>2]|0:e;a=b[k>>0]|0;if(!(a<<24>>24))l=0;else{m=k;o=0;p=a;while(1){q=(o*5|0)+(p<<24>>24)|0;m=m+1|0;p=b[m>>0]|0;if(!(p<<24>>24)){l=q;break}else o=q}}o=j+16|0;p=f[o>>2]|0;m=(p|0)==0;a:do if(!m){q=p+-1|0;r=(q&p|0)==0;if(!r)if(l>>>0<p>>>0)s=l;else s=(l>>>0)%(p>>>0)|0;else s=q&l;t=f[(f[g>>2]|0)+(s<<2)>>2]|0;if((t|0)!=0?(v=f[t>>2]|0,(v|0)!=0):0){t=c?f[e+4>>2]|0:h&255;w=(t|0)==0;if(r){if(w){r=v;while(1){x=f[r+4>>2]|0;if(!((x|0)==(l|0)|(x&q|0)==(s|0))){y=s;break a}x=b[r+8+11>>0]|0;if(!((x<<24>>24<0?f[r+12>>2]|0:x&255)|0)){i=0;break}r=f[r>>2]|0;if(!r){y=s;break a}}u=d;return i|0}else z=v;b:while(1){r=f[z+4>>2]|0;if(!((r|0)==(l|0)|(r&q|0)==(s|0))){y=s;break a}r=z+8|0;x=b[r+11>>0]|0;A=x<<24>>24<0;B=x&255;do if(((A?f[z+12>>2]|0:B)|0)==(t|0)){x=f[r>>2]|0;if(A)if(!(WKc(x,k,t)|0)){i=0;C=60;break b}else break;if((x&255)<<24>>24==a<<24>>24){x=r;D=B;E=k;do{D=D+-1|0;x=x+1|0;if(!D){i=0;C=60;break b}E=E+1|0}while((b[x>>0]|0)==(b[E>>0]|0))}}while(0);z=f[z>>2]|0;if(!z){y=s;break a}}if((C|0)==60){u=d;return i|0}}if(w){q=v;while(1){B=f[q+4>>2]|0;if((B|0)!=(l|0)){if(B>>>0<p>>>0)F=B;else F=(B>>>0)%(p>>>0)|0;if((F|0)!=(s|0)){y=s;break a}}B=b[q+8+11>>0]|0;if(!((B<<24>>24<0?f[q+12>>2]|0:B&255)|0)){i=0;break}q=f[q>>2]|0;if(!q){y=s;break a}}u=d;return i|0}else G=v;c:while(1){q=f[G+4>>2]|0;if((q|0)!=(l|0)){if(q>>>0<p>>>0)H=q;else H=(q>>>0)%(p>>>0)|0;if((H|0)!=(s|0)){y=s;break a}}q=G+8|0;w=b[q+11>>0]|0;B=w<<24>>24<0;r=w&255;do if(((B?f[G+12>>2]|0:r)|0)==(t|0)){w=f[q>>2]|0;if(B)if(!(WKc(w,k,t)|0)){i=0;C=60;break c}else break;if((w&255)<<24>>24==a<<24>>24){w=q;A=r;E=k;do{A=A+-1|0;w=w+1|0;if(!A){i=0;C=60;break c}E=E+1|0}while((b[w>>0]|0)==(b[E>>0]|0))}}while(0);G=f[G>>2]|0;if(!G){y=s;break a}}if((C|0)==60){u=d;return i|0}}else y=s}else y=0;while(0);s=$Xc(20)|0;lYc(s+8|0,e);f[s+4>>2]=l;f[s>>2]=0;e=j+24|0;I=+(((f[e>>2]|0)+1|0)>>>0);J=+n[j+28>>2];do if(m|I>+(p>>>0)*J){G=(p>>>0<3|(p+-1&p|0)!=0)&1|p<<1;k=~~+X(+(I/J))>>>0;b0b(g,G>>>0<k>>>0?k:G);G=f[o>>2]|0;k=G+-1|0;if(!(k&G)){K=G;L=k&l;break}if(l>>>0<G>>>0){K=G;L=l}else{K=G;L=(l>>>0)%(G>>>0)|0}}else{K=p;L=y}while(0);y=(f[g>>2]|0)+(L<<2)|0;L=f[y>>2]|0;if(!L){p=j+20|0;f[s>>2]=f[p>>2];f[p>>2]=s;f[y>>2]=p;p=f[s>>2]|0;if(p|0){y=f[p+4>>2]|0;p=K+-1|0;if(p&K)if(y>>>0<K>>>0)M=y;else M=(y>>>0)%(K>>>0)|0;else M=y&p;N=(f[g>>2]|0)+(M<<2)|0;C=58}}else{f[s>>2]=f[L>>2];N=L;C=58}if((C|0)==58)f[N>>2]=s;f[e>>2]=(f[e>>2]|0)+1;i=0;u=d;return i|0}function b0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){c0b(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;c0b(a,d);return}function c0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=a+4|0;if(!c){e=f[a>>2]|0;f[a>>2]=0;if(e|0)cYc(e);f[d>>2]=0;return}if(c>>>0>1073741823){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}e=$Xc(c<<2)|0;g=f[a>>2]|0;f[a>>2]=e;if(g|0)cYc(g);f[d>>2]=c;d=0;do{f[(f[a>>2]|0)+(d<<2)>>2]=0;d=d+1|0}while((d|0)!=(c|0));d=a+8|0;g=f[d>>2]|0;if(!g)return;e=f[g+4>>2]|0;h=c+-1|0;i=(h&c|0)==0;if(!i)if(e>>>0<c>>>0)j=e;else j=(e>>>0)%(c>>>0)|0;else j=e&h;f[(f[a>>2]|0)+(j<<2)>>2]=d;d=f[g>>2]|0;if(!d)return;else{k=j;l=g;m=d;n=g}a:while(1){g=l;d=m;j=n;b:while(1){o=d;while(1){e=f[o+4>>2]|0;if(!i)if(e>>>0<c>>>0)p=e;else p=(e>>>0)%(c>>>0)|0;else p=e&h;if((p|0)==(k|0))break;q=(f[a>>2]|0)+(p<<2)|0;if(!(f[q>>2]|0))break b;e=f[o>>2]|0;c:do if(!e)r=o;else{s=o+8|0;t=b[s+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[o+12>>2]|0:v;w=(t|0)==0;if(u){u=o;x=e;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){r=u;break c}if(!w?WKc(f[s>>2]|0,A?f[y>>2]|0:y,t)|0:0){r=u;break c}y=f[x>>2]|0;if(!y){r=x;break c}else{A=x;x=y;u=A}}}if(w){u=o;x=e;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){r=u;break c}A=f[x>>2]|0;if(!A){r=x;break c}else{y=x;x=A;u=y}}}u=o;x=e;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){r=u;break c}y=A?f[w>>2]|0:w;if((f[s>>2]&255)<<24>>24==(b[y>>0]|0)){B=s;C=v;D=y}else{r=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){r=u;break c}}y=f[x>>2]|0;if(!y){r=x;break}else{w=x;x=y;u=w}}}while(0);f[j>>2]=f[r>>2];f[r>>2]=f[f[(f[a>>2]|0)+(p<<2)>>2]>>2];f[f[(f[a>>2]|0)+(p<<2)>>2]>>2]=o;e=f[g>>2]|0;if(!e){E=43;break a}else o=e}d=f[o>>2]|0;if(!d){E=43;break a}else{g=o;j=o}}f[q>>2]=j;m=f[o>>2]|0;if(!m){E=43;break}else{k=p;l=o;n=o}}if((E|0)==43)return}function d0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+176|0;e=d+24|0;g=d+12|0;h=d;i=c+120|0;j=a+28|0;oYc(j,f[i>>2]|0)|0;k=a+4|0;l=f[k>>2]|0;f[e>>2]=(b[j+11>>0]|0)<0?f[j>>2]|0:j;j=$$b(l+152|0,e)|0;if(j){l=f[j+12>>2]|0;if(l|0){Rec(e);g0b(l,e);if((f[l+44>>2]|0)==2?f[c+8>>2]&4|0:0)h0b(e,479424);UZb(g,e);UZb(h,c);j=g+11|0;m=b[j>>0]|0;n=m<<24>>24<0;o=m&255;p=n?f[g+4>>2]|0:o;q=b[h+11>>0]|0;r=q<<24>>24<0;a:do if((p|0)==((r?f[h+4>>2]|0:q&255)|0)){s=f[g>>2]|0;t=n?s:g;v=r?f[h>>2]|0:h;w=(p|0)==0;if(n){if(w){x=1;break}x=(WKc(t,v,p)|0)==0;break}if(!w)if((s&255)<<24>>24==(b[v>>0]|0)){s=g;w=o;t=v;while(1){w=w+-1|0;s=s+1|0;if(!w){x=1;break a}t=t+1|0;if((b[s>>0]|0)!=(b[t>>0]|0)){x=0;break}}}else x=0;else x=1}else x=0;while(0);if(r){cYc(f[h>>2]|0);y=b[j>>0]|0}else y=m;if(y<<24>>24<0)cYc(f[g>>2]|0);vec(e);if(x){z=l;u=d;return z|0}}}l=f[k>>2]|0;x=l+4|0;g=f[x>>2]|0;y=f[l>>2]|0;m=g;j=y;b:do if((g|0)!=(y|0)){h=f[i>>2]|0;r=b[h+11>>0]|0;o=r<<24>>24<0;p=o?f[h+4>>2]|0:r&255;r=(p|0)==0;n=(g-y|0)/12|0;c:do if(o){q=0;while(1){t=j+(q*12|0)|0;s=b[t+11>>0]|0;w=s<<24>>24<0;v=s&255;do if(((w?f[j+(q*12|0)+4>>2]|0:v)|0)==(p|0)){s=f[t>>2]|0;A=w?s:t;B=f[h>>2]|0;if(w){if(r){C=q;break c}if(!(WKc(A,B,p)|0)){C=q;break c}else break}if(r){C=q;break c}if((s&255)<<24>>24==(b[B>>0]|0)){s=t;A=v;D=B;do{A=A+-1|0;s=s+1|0;if(!A){C=q;break c}D=D+1|0}while((b[s>>0]|0)==(b[D>>0]|0))}}while(0);q=q+1|0;if(q>>>0>=n>>>0)break b}}else{q=0;while(1){v=j+(q*12|0)|0;t=b[v+11>>0]|0;w=t<<24>>24<0;D=t&255;do if(((w?f[j+(q*12|0)+4>>2]|0:D)|0)==(p|0)){t=f[v>>2]|0;s=w?t:v;if(w){if(r){C=q;break c}if(!(WKc(s,h,p)|0)){C=q;break c}else break}if(r){C=q;break c}if((t&255)<<24>>24==(b[h>>0]|0)){t=v;s=D;A=h;do{s=s+-1|0;t=t+1|0;if(!s){C=q;break c}A=A+1|0}while((b[t>>0]|0)==(b[A>>0]|0))}}while(0);q=q+1|0;if(q>>>0>=n>>>0)break b}}while(0);i0b(a,c,C);z=0;u=d;return z|0}while(0);C=f[a>>2]|0;if((b[C+21>>0]|0)==0?(f[C+4>>2]|0)!=0:0){C=f[i>>2]|0;if((m|0)==(f[l+8>>2]|0))NN(l,C);else{lYc(m,C);f[x>>2]=(f[x>>2]|0)+12}x=c+20|0;C=f[k>>2]|0;if((f[x>>2]|0)>0){m=c+28|0;i=0;j=C;while(1){y=f[(f[m>>2]|0)+4+(i<<2)>>2]|0;f[e>>2]=(b[y+11>>0]|0)<0?f[y>>2]|0:y;y=$$b(j+152|0,e)|0;if(!((y|0)!=0?(f[y+12>>2]|0)!=0:0))E=55;do if((E|0)==55){E=0;y=f[a>>2]|0;g=f[y+12>>2]|0;if(!g)F=y;else{if(j0b(g,f[(f[m>>2]|0)+4+(i<<2)>>2]|0)|0)break;F=f[a>>2]|0}k0b(F,f[(f[m>>2]|0)+4+(i<<2)>>2]|0)|0}while(0);i=i+1|0;g=f[k>>2]|0;if((i|0)>=(f[x>>2]|0)){G=g;break}else j=g}}else G=C;C=G+4|0;G=f[C>>2]|0;j=G+-12|0;x=G;while(1){G=x+-12|0;f[C>>2]=G;if((b[G+11>>0]|0)<0){cYc(f[G>>2]|0);H=f[C>>2]|0}else H=G;if((H|0)==(j|0))break;else x=H}I=f[k>>2]|0}else I=l;f[e>>2]=(f[I+76>>2]|0)-(f[I+72>>2]|0)>>2;f[e+4>>2]=(f[I+88>>2]|0)-(f[I+84>>2]|0)>>2;f[e+8>>2]=(f[I+100>>2]|0)-(f[I+96>>2]|0)>>2;f[e+12>>2]=(f[I+112>>2]|0)-(f[I+108>>2]|0)>>2;f[e+16>>2]=(f[I+124>>2]|0)-(f[I+120>>2]|0)>>2;f[e+20>>2]=(f[I+200>>2]|0)-(f[I+196>>2]|0)>>2;f[e+24>>2]=(f[I+212>>2]|0)-(f[I+208>>2]|0)>>2;f[e+28>>2]=(f[I+224>>2]|0)-(f[I+220>>2]|0)>>3;l=I+188|0;H=f[l>>2]|0;if(H>>>0<(f[I+192>>2]|0)>>>0){f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];f[H+16>>2]=f[e+16>>2];f[H+20>>2]=f[e+20>>2];f[H+24>>2]=f[e+24>>2];f[H+28>>2]=f[e+28>>2];f[l>>2]=(f[l>>2]|0)+32}else I$b(I+184|0,e);e=l0b(a,c)|0;m0b(f[a+44>>2]|0);a=f[k>>2]|0;if(!e){J$b(a);z=0;u=d;return z|0}k=a+188|0;c=(f[k>>2]|0)+-32|0;f[k>>2]=c;if((f[a+184>>2]|0)==(c|0)){c=f[a+196>>2]|0;k=a+200|0;I=f[k>>2]|0;if((I|0)!=(c|0))f[k>>2]=I+(~((I+-4-c|0)>>>2)<<2);c=f[a+208>>2]|0;I=a+212|0;k=f[I>>2]|0;if((k|0)!=(c|0))f[I>>2]=k+(~((k+-4-c|0)>>>2)<<2);c=f[a+220>>2]|0;k=a+224|0;a=f[k>>2]|0;if((a|0)!=(c|0))f[k>>2]=a+(~((a+-8-c|0)>>>3)<<3)}b[e+49>>0]=1;z=e;u=d;return z|0}function e0b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+88|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+76|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);f0b(a+60|0,f[a+64>>2]|0);f0b(a+48|0,f[a+52>>2]|0);c=a+28|0;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);c=a+12|0;d=f[c>>2]|0;if(!d)return;e=a+16|0;a=f[e>>2]|0;if((a|0)==(d|0))g=d;else{h=a;do{a=h+-32|0;f[e>>2]=a;i=h+-20|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);h=f[e>>2]|0}while((h|0)!=(d|0));g=f[c>>2]|0}cYc(g);return}function f0b(a,b){a=a|0;b=b|0;if(!b)return;else{f0b(a,f[b>>2]|0);f0b(a,f[b+4>>2]|0);cYc(b);return}}function g0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;i=c+120|0;j=c+4|0;k=f[j>>2]|0;l=k&-2;if(!(k&1))m=l;else m=f[l+4>>2]|0;l=f[i>>2]|0;if((l|0)==537368)xJa(i,m,g);else oYc(l,g)|0;g=f[a+4>>2]|0;l=b[g+11>>0]|0;if(l<<24>>24<0)n=f[g+4>>2]|0;else n=l&255;do if(n|0){f[h>>2]=f[h>>2]|2;l=c+124|0;m=f[j>>2]|0;i=m&-2;if(!(m&1))o=i;else o=f[i+4>>2]|0;i=f[l>>2]|0;if((i|0)==537368){xJa(l,o,g);break}else{oYc(i,g)|0;break}}while(0);if((f[a+44>>2]|0)==3)h0b(c,479417);g=a+16|0;if((f[g>>2]|0)>0){o=a+12|0;j=a+52|0;n=c+16|0;i=e+4|0;l=e+8|0;m=e+12|0;k=0;do{p=f[o>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[e>>2]=165864;f[i>>2]=2270;b[l>>0]=0;f[m>>2]=a;J_b(p,e)}p=f[f[(f[j>>2]|0)+(k<<2)>>2]>>2]|0;oYc(pHa(n)|0,p)|0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=a+20|0;if((f[g>>2]|0)>0){k=a+60|0;n=c+96|0;j=c+100|0;e=c+104|0;m=0;do{l=f[(f[k>>2]|0)+(m<<2)>>2]|0;i=f[n>>2]|0;if((i|0)==(f[j>>2]|0)){qHa(n,i+1|0);q=f[n>>2]|0}else q=i;i=f[e>>2]|0;f[n>>2]=q+1;f[i+4+(q<<2)>>2]=l;m=m+1|0}while((m|0)<(f[g>>2]|0))}g=a+24|0;if((f[g>>2]|0)>0){m=a+64|0;q=c+108|0;n=c+112|0;e=c+116|0;j=0;do{k=f[(f[m>>2]|0)+(j<<2)>>2]|0;l=f[q>>2]|0;if((l|0)==(f[n>>2]|0)){qHa(q,l+1|0);r=f[q>>2]|0}else r=l;l=f[e>>2]|0;f[q>>2]=r+1;f[l+4+(r<<2)>>2]=k;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=a+28|0;if((f[g>>2]|0)>0){j=a+68|0;r=c+32|0;q=0;do{e=(f[j>>2]|0)+(q*88|0)|0;W2b(e,V2b(r)|0);q=q+1|0}while((q|0)<(f[g>>2]|0))}g=a+32|0;if((f[g>>2]|0)>0){q=a+72|0;r=c+48|0;j=0;do{e=(f[q>>2]|0)+(j*48|0)|0;Y2b(e,X2b(r)|0);j=j+1|0}while((j|0)<(f[g>>2]|0))}g=a+36|0;if((f[g>>2]|0)>0){j=a+76|0;r=c+64|0;q=c+76|0;e=c+72|0;n=c+68|0;m=0;do{k=(f[j>>2]|0)+(m*24|0)|0;l=f[q>>2]|0;do if(l){i=f[n>>2]|0;o=f[l>>2]|0;if((i|0)>=(o|0))if((o|0)==(f[e>>2]|0)){s=o;t=50;break}else{v=o;w=l;t=51;break}else{f[n>>2]=i+1;x=f[l+4+(i<<2)>>2]|0;break}}else{s=f[e>>2]|0;t=50}while(0);if((t|0)==50){t=0;XZb(r,s+1|0);l=f[q>>2]|0;v=f[l>>2]|0;w=l;t=51}if((t|0)==51){t=0;f[w>>2]=v+1;l=f[r>>2]|0;if(!l){i=$Xc(40)|0;Jac(i);y=i}else{if(f[l+64>>2]|0)SXb(l,21176,40);i=QXb(l,40)|0;Kac(i,l);y=i}i=f[q>>2]|0;l=f[n>>2]|0;f[n>>2]=l+1;f[i+4+(l<<2)>>2]=y;x=y}Z2b(k,x);m=m+1|0}while((m|0)<(f[g>>2]|0))}g=a+40|0;if((f[g>>2]|0)>0){m=a+80|0;x=c+80|0;y=0;do{n=(f[m>>2]|0)+(y*88|0)|0;$2b(n,_2b(x)|0);y=y+1|0}while((y|0)<(f[g>>2]|0))}g=a+84|0;a=f[g>>2]|0;if((a|0)==(efc()|0)){u=d;return}f[h>>2]=f[h>>2]|8;h=c+132|0;a=f[h>>2]|0;if(!a){Oec(c);z=f[h>>2]|0}else z=a;ffc(z,f[g>>2]|0);u=d;return}function h0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|4;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=dJc(c)|0;if(g>>>0>4294967279)jYc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=$Xc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+128|0;a=f[h>>2]|0;if((a|0)==537368)xJa(h,m,e);else oYc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function i0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=$Xc(48)|0;f[g>>2]=h;f[g+8>>2]=-2147483600;f[g+4>>2]=33;i=h;j=488730;k=i+33|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+33>>0]=0;h=a+4|0;j=f[h>>2]|0;if((((f[j+4>>2]|0)-(f[j>>2]|0)|0)/12|0)>>>0>d>>>0){i=d;d=j;do{j=f[d>>2]|0;k=j+(i*12|0)|0;l=b[k+11>>0]|0;m=l<<24>>24<0;zYc(g,m?f[k>>2]|0:k,m?f[j+(i*12|0)+4>>2]|0:l&255)|0;AYc(g,488764)|0;i=i+1|0;d=f[h>>2]|0}while(i>>>0<(((f[d+4>>2]|0)-(f[d>>2]|0)|0)/12|0)>>>0)}d=c+120|0;i=f[d>>2]|0;h=b[i+11>>0]|0;l=h<<24>>24<0;zYc(g,l?f[i>>2]|0:i,l?f[i+4>>2]|0:h&255)|0;q0b(a,f[d>>2]|0,c,9,g);if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function j0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=(g|0)==0;if(!h)g_b(g);i=a+16|0;j=f[i>>2]|0;k=j+44|0;if(!(f[k>>2]|0))l=j;else{m=j+40|0;n=f[m>>2]|0;if(n|0){o=n;do{n=o;o=f[o>>2]|0;p=n+8|0;if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);cYc(n)}while((o|0)!=0)}f[m>>2]=0;m=f[j+36>>2]|0;if(m|0){o=j+32|0;j=0;do{f[(f[o>>2]|0)+(j<<2)>>2]=0;j=j+1|0}while((j|0)!=(m|0))}f[k>>2]=0;l=f[i>>2]|0}k=l+24|0;if(!(f[k>>2]|0))q=l;else{m=l+20|0;j=f[m>>2]|0;if(j|0){o=j;do{j=o;o=f[o>>2]|0;n=j+8|0;if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);cYc(j)}while((o|0)!=0)}f[m>>2]=0;m=f[l+16>>2]|0;if(m|0){o=l+12|0;l=0;do{f[(f[o>>2]|0)+(l<<2)>>2]=0;l=l+1|0}while((l|0)!=(m|0))}f[k>>2]=0;q=f[i>>2]|0}k=c+11|0;f[e>>2]=(b[k>>0]|0)<0?f[c>>2]|0:c;m=$$b(q+152|0,e)|0;if((m|0)!=0?(q=f[m+12>>2]|0,(q|0)!=0):0)r=q;else s=24;a:do if((s|0)==24){q=f[a+12>>2]|0;if(q|0?(m=j0b(q,c)|0,m|0):0){r=m;break}do if(k0b(a,c)|0){m=f[i>>2]|0;f[e>>2]=(b[k>>0]|0)<0?f[c>>2]|0:c;q=$$b(m+152|0,e)|0;if((q|0)!=0?(m=f[q+12>>2]|0,(m|0)!=0):0){r=m;break a}else break}while(0);r=0}while(0);if(h){u=d;return r|0}h_b(g);u=d;return r|0}function k0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0;d=u;u=u+144|0;e=d;g=a+4|0;if(!(f[g>>2]|0)){h=0;u=d;return h|0}i=a+16|0;if(Z$b((f[i>>2]|0)+12|0,c)|0){h=0;u=d;return h|0}Rec(e);j=f[g>>2]|0;if(hj[f[(f[j>>2]|0)+8>>2]&511](j,c,e)|0?(a0b(a,e)|0)!=0:0)k=1;else l=5;a:do if((l|0)==5){a=f[i>>2]|0;j=a+12|0;g=b[c+11>>0]|0;m=g<<24>>24<0;o=m?f[c>>2]|0:c;p=b[o>>0]|0;if(!(p<<24>>24))q=0;else{r=o;s=0;t=p;while(1){v=(s*5|0)+(t<<24>>24)|0;r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24)){q=v;break}else s=v}}s=a+16|0;t=f[s>>2]|0;r=(t|0)==0;b:do if(!r){v=t+-1|0;w=(v&t|0)==0;if(!w)if(q>>>0<t>>>0)x=q;else x=(q>>>0)%(t>>>0)|0;else x=v&q;y=f[(f[j>>2]|0)+(x<<2)>>2]|0;if((y|0)!=0?(z=f[y>>2]|0,(z|0)!=0):0){y=m?f[c+4>>2]|0:g&255;A=(y|0)==0;if(w){if(A){w=z;while(1){B=f[w+4>>2]|0;if(!((B|0)==(q|0)|(B&v|0)==(x|0))){C=x;break b}B=b[w+8+11>>0]|0;if(!((B<<24>>24<0?f[w+12>>2]|0:B&255)|0)){k=0;break a}w=f[w>>2]|0;if(!w){C=x;break b}}}else D=z;while(1){w=f[D+4>>2]|0;if(!((w|0)==(q|0)|(w&v|0)==(x|0))){C=x;break b}w=D+8|0;B=b[w+11>>0]|0;E=B<<24>>24<0;F=B&255;do if(((E?f[D+12>>2]|0:F)|0)==(y|0)){B=f[w>>2]|0;if(E)if(!(WKc(B,o,y)|0)){k=0;break a}else break;if((B&255)<<24>>24==p<<24>>24){B=w;G=F;H=o;do{G=G+-1|0;B=B+1|0;if(!G){k=0;break a}H=H+1|0}while((b[B>>0]|0)==(b[H>>0]|0))}}while(0);D=f[D>>2]|0;if(!D){C=x;break b}}}if(A){v=z;while(1){F=f[v+4>>2]|0;if((F|0)!=(q|0)){if(F>>>0<t>>>0)I=F;else I=(F>>>0)%(t>>>0)|0;if((I|0)!=(x|0)){C=x;break b}}F=b[v+8+11>>0]|0;if(!((F<<24>>24<0?f[v+12>>2]|0:F&255)|0)){k=0;break a}v=f[v>>2]|0;if(!v){C=x;break b}}}else J=z;while(1){v=f[J+4>>2]|0;if((v|0)!=(q|0)){if(v>>>0<t>>>0)K=v;else K=(v>>>0)%(t>>>0)|0;if((K|0)!=(x|0)){C=x;break b}}v=J+8|0;A=b[v+11>>0]|0;F=A<<24>>24<0;w=A&255;do if(((F?f[J+12>>2]|0:w)|0)==(y|0)){A=f[v>>2]|0;if(F)if(!(WKc(A,o,y)|0)){k=0;break a}else break;if((A&255)<<24>>24==p<<24>>24){A=v;E=w;H=o;do{E=E+-1|0;A=A+1|0;if(!E){k=0;break a}H=H+1|0}while((b[A>>0]|0)==(b[H>>0]|0))}}while(0);J=f[J>>2]|0;if(!J){C=x;break}}}else C=x}else C=0;while(0);o=$Xc(20)|0;lYc(o+8|0,c);f[o+4>>2]=q;f[o>>2]=0;p=a+24|0;L=+(((f[p>>2]|0)+1|0)>>>0);M=+n[a+28>>2];do if(r|L>+(t>>>0)*M){g=(t>>>0<3|(t+-1&t|0)!=0)&1|t<<1;m=~~+X(+(L/M))>>>0;b0b(j,g>>>0<m>>>0?m:g);g=f[s>>2]|0;m=g+-1|0;if(!(m&g)){N=g;O=m&q;break}if(q>>>0<g>>>0){N=g;O=q}else{N=g;O=(q>>>0)%(g>>>0)|0}}else{N=t;O=C}while(0);t=(f[j>>2]|0)+(O<<2)|0;s=f[t>>2]|0;if(!s){r=a+20|0;f[o>>2]=f[r>>2];f[r>>2]=o;f[t>>2]=r;r=f[o>>2]|0;if(r|0){t=f[r+4>>2]|0;r=N+-1|0;if(r&N)if(t>>>0<N>>>0)P=t;else P=(t>>>0)%(N>>>0)|0;else P=t&r;Q=(f[j>>2]|0)+(P<<2)|0;l=60}}else{f[o>>2]=f[s>>2];Q=s;l=60}if((l|0)==60)f[Q>>2]=o;f[p>>2]=(f[p>>2]|0)+1;k=0}while(0);vec(e);h=k;u=d;return h|0}function l0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;d=u;u=u+208|0;e=d;g=d+184|0;h=d+160|0;i=d+199|0;j=d+136|0;k=d+198|0;l=d+112|0;m=d+197|0;n=d+88|0;o=d+196|0;p=d+72|0;q=d+60|0;r=d+48|0;s=d+16|0;t=a+4|0;v=f[t>>2]|0;w=$Xc(96)|0;f[e>>2]=w;x=v+124|0;y=f[x>>2]|0;if((y|0)==(f[v+128>>2]|0))wN(v+120|0,e);else{f[y>>2]=w;f[x>>2]=(f[x>>2]|0)+4}x=f[e>>2]|0;w=a+40|0;f[w>>2]=x;b[x+48>>0]=0;b[x+49>>0]=0;y=c+8|0;if(!(f[y>>2]&16))z=ufc()|0;else{v=f[t>>2]|0;A=$Xc(32)|0;a6b(A);f[e>>2]=A;B=v+88|0;C=f[B>>2]|0;if(C>>>0<(f[v+92>>2]|0)>>>0){f[C>>2]=A;f[B>>2]=(f[B>>2]|0)+4}else n0b(v+84|0,e);v=f[c+136>>2]|0;vfc(A,v|0?v:538760);z=A}f[x+92>>2]=z;z=f[t>>2]|0;A=$Xc(164)|0;x$b(A);f[e>>2]=A;v=z+112|0;B=f[v>>2]|0;if((B|0)==(f[z+116>>2]|0))o0b(z+108|0,e);else{f[B>>2]=A;f[v>>2]=(f[v>>2]|0)+4}v=f[e>>2]|0;f[a+44>>2]=v;f[(f[w>>2]|0)+88>>2]=v;if((f[y>>2]&1|0)==0?(f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,p0b(a,e,c,9,479431),(b[e+11>>0]|0)<0):0)cYc(f[e>>2]|0);v=c+128|0;A=f[v>>2]|0;B=b[A+11>>0]|0;z=B<<24>>24<0;if(z)D=f[A+4>>2]|0;else D=B&255;a:do if(D){C=f[A+4>>2]|0;if(((z?C:B&255)|0)==6){if(!(LYc(A,0,-1,479424,6)|0)){E=24;break}F=f[v>>2]|0;G=F;H=b[F+11>>0]|0;I=f[F+4>>2]|0}else{G=A;H=B;I=C}do if(((H<<24>>24<0?I:H&255)|0)==6){C=(LYc(G,0,-1,479417,6)|0)==0;F=(f[w>>2]|0)+44|0;if(C){f[F>>2]=3;break a}else{J=F;K=f[v>>2]|0;break}}else{J=(f[w>>2]|0)+44|0;K=G}while(0);f[J>>2]=0;F=f[c+120>>2]|0;SGa(e,479472,K);q0b(a,F,c,9,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0)}else E=24;while(0);if((E|0)==24)f[(f[w>>2]|0)+44>>2]=2;w=f[t>>2]|0;K=c+120|0;J=f[K>>2]|0;G=$Xc(12)|0;lYc(G,J);f[e>>2]=G;J=w+76|0;v=f[J>>2]|0;if((v|0)==(f[w+80>>2]|0))r0b(w+72|0,e);else{f[v>>2]=G;f[J>>2]=(f[J>>2]|0)+4}f[x>>2]=f[e>>2];J=f[t>>2]|0;if(!(f[y>>2]&2)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;G=$Xc(12)|0;lYc(G,g);f[e>>2]=G;v=J+76|0;w=f[v>>2]|0;if((w|0)==(f[J+80>>2]|0))r0b(J+72|0,e);else{f[w>>2]=G;f[v>>2]=(f[v>>2]|0)+4}f[x+4>>2]=f[e>>2];if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}else{v=f[c+124>>2]|0;G=$Xc(12)|0;lYc(G,v);f[e>>2]=G;v=J+76|0;w=f[v>>2]|0;if((w|0)==(f[J+80>>2]|0))r0b(J+72|0,e);else{f[w>>2]=G;f[v>>2]=(f[v>>2]|0)+4}f[x+4>>2]=f[e>>2]}f[x+8>>2]=f[a>>2];v=f[t>>2]|0;G=f[x>>2]|0;if((b[G+11>>0]|0)<0)L=f[G>>2]|0;else L=G;f[e>>2]=L;f[e+4>>2]=x;if(!(s0b(v+152|0,e)|0)){p0b(a,f[K>>2]|0,c,9,479494);M=0;u=d;return M|0}L=f[x>>2]|0;if((b[L+11>>0]|0)<0)N=f[L>>2]|0;else N=L;f[e>>2]=N;L=v+212|0;G=f[L>>2]|0;if(G>>>0<(f[v+216>>2]|0)>>>0){f[G>>2]=N;f[L>>2]=(f[L>>2]|0)+4}else t0b(v+208|0,e);v=x+4|0;L=f[v>>2]|0;N=b[L+11>>0]|0;if(N<<24>>24<0)O=f[L+4>>2]|0;else O=N&255;if(O|0)u0b(a,L,c,x);f[q+4>>2]=0;f[q+8>>2]=0;L=q+4|0;f[q>>2]=L;O=c+20|0;N=f[O>>2]|0;G=x+16|0;f[G>>2]=N;w=f[t>>2]|0;J=N<<2;if(!J)P=0;else{N=$Xc(J)|0;f[e>>2]=N;J=w+124|0;H=f[J>>2]|0;if((H|0)==(f[w+128>>2]|0))wN(w+120|0,e);else{f[H>>2]=N;f[J>>2]=(f[J>>2]|0)+4}P=f[e>>2]|0}J=x+52|0;f[J>>2]=P;if(b[(f[a>>2]|0)+21>>0]|0){P=f[t>>2]|0;N=$Xc(4)|0;f[N>>2]=0;f[e>>2]=N;H=P+100|0;w=f[H>>2]|0;if((w|0)==(f[P+104>>2]|0))v0b(P+96|0,e);else{f[w>>2]=N;f[H>>2]=(f[H>>2]|0)+4}f[x+12>>2]=f[e>>2];H=f[t>>2]|0;N=f[O>>2]|0;w=N<<2;if(!w){Q=0;R=N}else{N=$Xc(w)|0;f[e>>2]=N;w=H+124|0;P=f[w>>2]|0;if((P|0)==(f[H+128>>2]|0))wN(H+120|0,e);else{f[P>>2]=N;f[w>>2]=(f[w>>2]|0)+4}Q=f[e>>2]|0;R=f[O>>2]|0}f[x+56>>2]=Q;if((R|0)>0)g1c(Q|0,0,R<<2|0)|0}else{f[x+12>>2]=0;f[x+56>>2]=0}R=a+60|0;Q=a+64|0;f0b(R,f[Q>>2]|0);w=a+68|0;f[w>>2]=0;f[R>>2]=Q;f[Q>>2]=0;N=r+4|0;f[N>>2]=0;P=r+8|0;f[P>>2]=0;H=r+4|0;f[r>>2]=H;I=c+108|0;B=f[I>>2]|0;b:do if((B|0)>0){A=c+116|0;z=0;D=0;F=B;while(1){C=f[(f[A>>2]|0)+4+(z<<2)>>2]|0;do if(D){S=N;T=D;while(1){U=f[T+16>>2]|0;if((C|0)<(U|0)){V=f[T>>2]|0;if(!V){E=88;break}else{W=T;X=V}}else{if((U|0)>=(C|0)){E=92;break}Y=T+4|0;U=f[Y>>2]|0;if(!U){E=91;break}else{W=Y;X=U}}S=W;T=X}if((E|0)==88){E=0;Z=T;_=T;break}else if((E|0)==91){E=0;Z=T;_=Y;break}else if((E|0)==92){E=0;Z=T;_=S;break}}else{Z=H;_=H}while(0);if(!(f[_>>2]|0)){U=$Xc(20)|0;f[U+16>>2]=C;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=Z;f[_>>2]=U;V=f[f[r>>2]>>2]|0;if(!V)$=U;else{f[r>>2]=V;$=f[_>>2]|0}UQ(f[N>>2]|0,$);f[P>>2]=(f[P>>2]|0)+1;aa=f[I>>2]|0}else aa=F;V=z+1|0;if((V|0)>=(aa|0))break b;z=V;D=f[H>>2]|0;F=aa}}while(0);c:do if((f[O>>2]|0)>0){aa=c+28|0;P=e+4|0;$=x+56|0;N=a+64|0;_=0;while(1){Z=f[(f[aa>>2]|0)+4+(_<<2)>>2]|0;SQ(e,q,Z,Z);if(!(b[P>>0]|0))w0b(a,c,_);Z=f[t>>2]|0;Y=f[(f[aa>>2]|0)+4+(_<<2)>>2]|0;f[e>>2]=(b[Y+11>>0]|0)<0?f[Y>>2]|0:Y;Y=$$b(Z+152|0,e)|0;if(Y){Z=f[Y+12>>2]|0;Y=Z;if(!Z){ba=Y;E=104}else ca=Y}else{ba=0;E=104}do if((E|0)==104){E=0;Y=f[(f[a>>2]|0)+12>>2]|0;if(!Y){ca=ba;break}ca=j0b(Y,f[(f[aa>>2]|0)+4+(_<<2)>>2]|0)|0}while(0);C=ca;if((C|0)==(x|0)){da=0;ea=q;fa=H;break c}Y=f[a>>2]|0;d:do if(!ca){if(b[Y+21>>0]|0){ga=0;break}e:do if(!(b[Y+22>>0]|0)){do if(!(b[Y+23>>0]|0)){Z=f[H>>2]|0;if(!Z)break;else{ha=H;ia=Z}f:while(1){Z=ia;while(1){if((f[Z+16>>2]|0)>=(_|0))break;X=f[Z+4>>2]|0;if(!X){ja=ha;break f}else Z=X}ia=f[Z>>2]|0;if(!ia){ja=Z;break}else ha=Z}if((ja|0)==(H|0))break;if((_|0)>=(f[ja+16>>2]|0))break e}while(0);y0b(a,c,_);ga=0;break d}while(0);ga=x0b(Y,f[(f[aa>>2]|0)+4+(_<<2)>>2]|0)|0}else{if(!(b[Y+20>>0]|0)){ga=ca;break}S=z0b(Y+28|0,f[K>>2]|0)|0;if((S|0)==((f[a>>2]|0)+32|0)){ga=ca;break}if(f[C+20>>2]|0){ga=ca;break}S=f[Q>>2]|0;do if(S){T=N;X=S;while(1){W=f[X+16>>2]|0;if(C>>>0<W>>>0){B=f[X>>2]|0;if(!B){E=127;break}else{ka=X;la=B}}else{if(W>>>0>=C>>>0){E=131;break}ma=X+4|0;W=f[ma>>2]|0;if(!W){E=130;break}else{ka=ma;la=W}}T=ka;X=la}if((E|0)==127){E=0;na=X;oa=X;break}else if((E|0)==130){E=0;na=X;oa=ma;break}else if((E|0)==131){E=0;na=X;oa=T;break}}else{na=Q;oa=Q}while(0);if(f[oa>>2]|0){ga=ca;break}S=$Xc(20)|0;f[S+16>>2]=ca;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=na;f[oa>>2]=S;W=f[f[R>>2]>>2]|0;if(!W)pa=S;else{f[R>>2]=W;pa=f[oa>>2]|0}UQ(f[N>>2]|0,pa);f[w>>2]=(f[w>>2]|0)+1;ga=ca}while(0);f[(f[J>>2]|0)+(_<<2)>>2]=ga;if(!(ga|0?1:(b[(f[a>>2]|0)+21>>0]|0)==0)){C=f[t>>2]|0;Y=f[(f[aa>>2]|0)+4+(_<<2)>>2]|0;W=$Xc(12)|0;lYc(W,Y);f[e>>2]=W;Y=C+76|0;S=f[Y>>2]|0;if((S|0)==(f[C+80>>2]|0))r0b(C+72|0,e);else{f[S>>2]=W;f[Y>>2]=(f[Y>>2]|0)+4}f[(f[$>>2]|0)+(_<<2)>>2]=f[e>>2]}_=_+1|0;if((_|0)>=(f[O>>2]|0)){E=142;break}}}else E=142;while(0);if((E|0)==142){ga=f[t>>2]|0;ca=c+96|0;pa=f[ca>>2]|0;oa=pa<<2;if(!oa){qa=0;ra=pa}else{pa=$Xc(oa)|0;f[e>>2]=pa;oa=ga+124|0;na=f[oa>>2]|0;if((na|0)==(f[ga+128>>2]|0))wN(ga+120|0,e);else{f[na>>2]=pa;f[oa>>2]=(f[oa>>2]|0)+4}qa=f[e>>2]|0;ra=f[ca>>2]|0}oa=x+60|0;f[oa>>2]=qa;if((ra|0)>0){ra=c+104|0;qa=x+12|0;pa=e+4|0;na=e+8|0;ga=e+12|0;ma=0;la=0;while(1){ka=f[(f[ra>>2]|0)+4+(ma<<2)>>2]|0;do if((ka|0)>-1?(ka|0)<(f[O>>2]|0):0){ja=la+1|0;f[(f[oa>>2]|0)+(la<<2)>>2]=ka;if(b[(f[a>>2]|0)+21>>0]|0){sa=ja;break}ha=f[qa>>2]|0;do if(ha|0){if((f[ha>>2]|0)==2)break;f[e>>2]=165864;f[pa>>2]=2270;b[na>>0]=0;f[ga>>2]=x;J_b(ha,e)}while(0);ha=f[(f[J>>2]|0)+(ka<<2)>>2]|0;ia=f[Q>>2]|0;if(!ia){sa=ja;break}else{ta=Q;ua=ia}g:while(1){ba=ua;while(1){if((f[ba+16>>2]|0)>>>0>=ha>>>0)break;_=f[ba+4>>2]|0;if(!_){va=ta;break g}else ba=_}ua=f[ba>>2]|0;if(!ua){va=ba;break}else ta=ba}if((va|0)==(Q|0)){sa=ja;break}if(ha>>>0<(f[va+16>>2]|0)>>>0){sa=ja;break}_=f[va+4>>2]|0;do if(!_){$=va+8|0;aa=f[$>>2]|0;if((f[aa>>2]|0)==(va|0)){wa=aa;break}else xa=$;do{$=f[xa>>2]|0;xa=$+8|0;aa=f[xa>>2]|0}while((f[aa>>2]|0)!=($|0));wa=aa}else{ba=_;while(1){aa=f[ba>>2]|0;if(!aa)break;else ba=aa}wa=ba}while(0);if((f[R>>2]|0)==(va|0))f[R>>2]=wa;f[w>>2]=(f[w>>2]|0)+-1;XIa(ia,va);cYc(va);sa=ja}else{p0b(a,f[K>>2]|0,c,9,479540);sa=la}while(0);ma=ma+1|0;if((ma|0)>=(f[ca>>2]|0)){ya=sa;break}else la=sa}}else ya=0;f[x+20>>2]=ya;ya=a+48|0;sa=a+52|0;f0b(ya,f[sa>>2]|0);f[a+56>>2]=0;f[ya>>2]=sa;f[sa>>2]=0;do if(!(b[(f[a>>2]|0)+21>>0]|0)){if((f[G>>2]|0)<=0)break;sa=x+12|0;ya=e+4|0;la=e+8|0;ca=e+12|0;ma=0;do{va=f[sa>>2]|0;do if(va|0){if((f[va>>2]|0)==2)break;f[e>>2]=165864;f[ya>>2]=2270;b[la>>0]=0;f[ca>>2]=x;J_b(va,e)}while(0);B0b(a,f[(f[J>>2]|0)+(ma<<2)>>2]|0);ma=ma+1|0}while((ma|0)<(f[G>>2]|0))}while(0);G=f[t>>2]|0;J=f[I>>2]|0;ma=J<<2;if(!ma){za=0;Aa=J}else{J=$Xc(ma)|0;f[e>>2]=J;ma=G+124|0;ca=f[ma>>2]|0;if((ca|0)==(f[G+128>>2]|0))wN(G+120|0,e);else{f[ca>>2]=J;f[ma>>2]=(f[ma>>2]|0)+4}za=f[e>>2]|0;Aa=f[I>>2]|0}ma=x+64|0;f[ma>>2]=za;if((Aa|0)>0){Aa=c+116|0;za=0;J=0;while(1){ca=f[(f[Aa>>2]|0)+4+(za<<2)>>2]|0;if((ca|0)>-1?(ca|0)<(f[O>>2]|0):0){f[(f[ma>>2]|0)+(J<<2)>>2]=ca;Ba=J+1|0}else{p0b(a,f[K>>2]|0,c,9,479573);Ba=J}za=za+1|0;if((za|0)>=(f[I>>2]|0)){Ca=Ba;break}else J=Ba}}else Ca=0;f[x+24>>2]=Ca;Ca=c+36|0;Ba=f[Ca>>2]|0;f[x+28>>2]=Ba;J=x+68|0;I=f[t>>2]|0;za=Ba*88|0;if(!za){Da=0;Ea=Ba}else{Ba=$Xc(za)|0;f[e>>2]=Ba;za=I+124|0;K=f[za>>2]|0;if((K|0)==(f[I+128>>2]|0))wN(I+120|0,e);else{f[K>>2]=Ba;f[za>>2]=(f[za>>2]|0)+4}Da=f[e>>2]|0;Ea=f[Ca>>2]|0}f[J>>2]=Da;h:do if((Ea|0)>0){za=c+44|0;Ba=0;K=Da;while(1){C0b(a,f[(f[za>>2]|0)+4+(Ba<<2)>>2]|0,0,K+(Ba*88|0)|0);I=Ba+1|0;if((I|0)>=(f[Ca>>2]|0))break h;Ba=I;K=f[J>>2]|0}}while(0);Da=c+52|0;Ea=f[Da>>2]|0;f[x+32>>2]=Ea;K=x+72|0;Ba=f[t>>2]|0;za=Ea*48|0;if(!za){Fa=0;Ga=Ea}else{Ea=$Xc(za)|0;f[e>>2]=Ea;za=Ba+124|0;I=f[za>>2]|0;if((I|0)==(f[Ba+128>>2]|0))wN(Ba+120|0,e);else{f[I>>2]=Ea;f[za>>2]=(f[za>>2]|0)+4}Fa=f[e>>2]|0;Ga=f[Da>>2]|0}f[K>>2]=Fa;i:do if((Ga|0)>0){za=c+60|0;Ea=0;I=Fa;while(1){D0b(a,f[(f[za>>2]|0)+4+(Ea<<2)>>2]|0,0,I+(Ea*48|0)|0);Ba=Ea+1|0;if((Ba|0)>=(f[Da>>2]|0))break i;Ea=Ba;I=f[K>>2]|0}}while(0);K=c+68|0;Da=f[K>>2]|0;f[x+36>>2]=Da;Fa=x+76|0;Ga=f[t>>2]|0;I=Da*24|0;if(!I){Ha=0;Ia=Da}else{Da=$Xc(I)|0;f[e>>2]=Da;I=Ga+124|0;Ea=f[I>>2]|0;if((Ea|0)==(f[Ga+128>>2]|0))wN(Ga+120|0,e);else{f[Ea>>2]=Da;f[I>>2]=(f[I>>2]|0)+4}Ha=f[e>>2]|0;Ia=f[K>>2]|0}f[Fa>>2]=Ha;j:do if((Ia|0)>0){I=c+76|0;Da=0;Ea=Ha;while(1){E0b(a,f[(f[I>>2]|0)+4+(Da<<2)>>2]|0,0,Ea+(Da*24|0)|0);Ga=Da+1|0;if((Ga|0)>=(f[K>>2]|0))break j;Da=Ga;Ea=f[Fa>>2]|0}}while(0);Fa=c+84|0;K=f[Fa>>2]|0;f[x+40>>2]=K;Ha=x+80|0;Ia=f[t>>2]|0;t=K*88|0;if(!t){Ja=0;Ka=K}else{K=$Xc(t)|0;f[e>>2]=K;t=Ia+124|0;Ea=f[t>>2]|0;if((Ea|0)==(f[Ia+128>>2]|0))wN(Ia+120|0,e);else{f[Ea>>2]=K;f[t>>2]=(f[t>>2]|0)+4}Ja=f[e>>2]|0;Ka=f[Fa>>2]|0}f[Ha>>2]=Ja;k:do if((Ka|0)>0){t=c+92|0;K=0;Ea=Ja;while(1){F0b(a,f[(f[t>>2]|0)+4+(K<<2)>>2]|0,0,Ea+(K*88|0)|0,1);Ia=K+1|0;if((Ia|0)>=(f[Fa>>2]|0))break k;K=Ia;Ea=f[Ha>>2]|0}}while(0);if(f[y>>2]&8){y=f[c+132>>2]|0;AN(e,f[v>>2]|0,479604);G0b(a,e,f[x>>2]|0,y|0?y:538104,x);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0)}else f[x+84>>2]=0;H0b(a,x,c);y=a+24|0;do if(!(b[y>>0]|0)){I0b(s,a);v=a+12|0;Ha=f[v>>2]|0;Fa=a+16|0;do if((Ha|0)!=(f[Fa>>2]|0)){Ja=s+4|0;Ka=g+8|0;Ea=g+4|0;K=g+11|0;t=e+4|0;Ia=g+8|0;Da=g+4|0;I=g+11|0;Ga=e+4|0;za=s+8|0;Ba=e+11|0;ma=g+11|0;O=p+11|0;Aa=e+4|0;ca=Ha;do{G=f[ca+28>>2]|0;la=f[ca+24>>2]|0;f[Ja>>2]=ca;mi[f[(f[G>>2]|0)+96>>2]&2047](e,G);ya=f[e>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;sa=$Xc(32)|0;f[g>>2]=sa;f[Ka>>2]=-2147483616;f[Ea>>2]=20;va=sa;ja=479611;ia=va+20|0;do{b[va>>0]=b[ja>>0]|0;va=va+1|0;ja=ja+1|0}while((va|0)<(ia|0));b[sa+20>>0]=0;J0b(e,f[(f[ya+8>>2]|0)+88>>2]|0,ya,g);ba=(f[e>>2]|0)==2;wa=e;R=ba?f[wa+4>>2]|0:0;if(!((ba?f[wa>>2]|0:0)|0))La=0;else La=b[R+38>>0]|0?0:R;if((b[K>>0]|0)<0)cYc(f[g>>2]|0);if(!La){u_b(h,3,479317,6243);r_b(i,p_b(p_b(h,479632)|0,479684)|0);v_b(h)}mi[f[(f[G>>2]|0)+96>>2]&2047](e,G);R=f[t>>2]|0;Ti[f[(f[R>>2]|0)+28>>2]&511](R,G,La);mi[f[(f[la>>2]|0)+96>>2]&2047](e,la);R=f[e>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;wa=$Xc(32)|0;f[g>>2]=wa;f[Ia>>2]=-2147483616;f[Da>>2]=20;va=wa;ja=479611;ia=va+20|0;do{b[va>>0]=b[ja>>0]|0;va=va+1|0;ja=ja+1|0}while((va|0)<(ia|0));b[wa+20>>0]=0;J0b(e,f[(f[R+8>>2]|0)+88>>2]|0,R,g);ja=(f[e>>2]|0)==2;va=e;ia=ja?f[va+4>>2]|0:0;if(!((ja?f[va>>2]|0:0)|0))Ma=0;else Ma=b[ia+38>>0]|0?0:ia;if((b[I>>0]|0)<0)cYc(f[g>>2]|0);if(!Ma){u_b(j,3,479317,6251);r_b(k,p_b(p_b(j,479744)|0,479684)|0);v_b(j)}mi[f[(f[la>>2]|0)+96>>2]&2047](e,la);ia=f[Ga>>2]|0;va=hj[f[(f[ia>>2]|0)+24>>2]&511](ia,la,Ma)|0;l:do if((va|0)>0){ia=0;while(1){mi[f[(f[la>>2]|0)+96>>2]&2047](e,la);ja=f[Aa>>2]|0;ya=hh[f[(f[ja>>2]|0)+208>>2]&127](ja,la,Ma,ia)|0;f[za>>2]=ya;ia=ia+1|0;if(!(K0b(s,G)|0))break;if((ia|0)>=(va|0)){E=255;break l}}f[za>>2]=0;f[Ja>>2]=0}else E=255;while(0);if((E|0)==255){E=0;f[za>>2]=0;f[Ja>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(!(SZb(G,e)|0)){u_b(l,3,479317,6280);r_b(m,p_b(p_b(l,479805)|0,479858)|0);v_b(l)}if(!(OZb(G,e)|0)){u_b(n,3,479317,6282);r_b(o,p_b(p_b(n,479900)|0,479953)|0);v_b(n)}if(!(_i[f[(f[G>>2]|0)+32>>2]&2047](G)|0)){va=f[s>>2]|0;mi[f[(f[G>>2]|0)+36>>2]&2047](p,G);R=EYc(p,0,480008)|0;f[g>>2]=f[R>>2];f[g+4>>2]=f[R+4>>2];f[g+8>>2]=f[R+8>>2];f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;L0b(va,ca+12|0,la,9,g);if((b[ma>>0]|0)<0)cYc(f[g>>2]|0);if((b[O>>0]|0)<0)cYc(f[p>>2]|0)}if((b[Ba>>0]|0)<0)cYc(f[e>>2]|0)}ca=ca+32|0}while((ca|0)!=(f[Fa>>2]|0));Ba=f[v>>2]|0;if((ca|0)==(Ba|0))break;else Na=ca;do{O=Na+-32|0;f[Fa>>2]=O;ma=Na+-20|0;if((b[ma+11>>0]|0)<0)cYc(f[ma>>2]|0);if((b[O+11>>0]|0)<0)cYc(f[O>>2]|0);Na=f[Fa>>2]|0}while((Na|0)!=(Ba|0))}while(0);ngc(s+12|0);if(b[y>>0]|0){E=272;break}if(b[(f[a>>2]|0)+21>>0]|0)break;M0b(a,x,c);if((b[y>>0]|0)!=0&(f[Ca>>2]|0)>0)E=273}else E=272;while(0);if((E|0)==272?(f[Ca>>2]|0)>0:0)E=273;if((E|0)==273){E=c+44|0;s=0;do{N0b(a,(f[J>>2]|0)+(s*88|0)|0,f[(f[E>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[Ca>>2]|0))}do if(f[w>>2]|0){if(b[(f[a>>2]|0)+21>>0]|0)break;O0b(a,c,0)}while(0);da=(b[y>>0]|0)==0?x:0;ea=q;fa=H}ILa(r,f[fa>>2]|0);RQ(ea,f[L>>2]|0);M=da;u=d;return M|0}function m0b(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+40|0;c=f[b>>2]|0;if(c|0){d=f[c+8>>2]|0;if(d|0){e=d;do{d=e;e=f[e>>2]|0;cYc(d)}while((e|0)!=0)}e=f[c>>2]|0;f[c>>2]=0;if(e|0)cYc(e);cYc(c)}f[b>>2]=0;b=a+68|0;a=f[b>>2]|0;if(!a){f[b>>2]=0;return}c=f[a+8>>2]|0;if(c|0){e=c;do{c=e;e=f[e>>2]|0;cYc(c)}while((e|0)!=0)}e=f[a>>2]|0;f[a>>2]=0;if(e|0)cYc(e);cYc(a);f[b>>2]=0;return}function n0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function o0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function p0b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=dJc(g)|0;if(j>>>0>4294967279)jYc(i);if(j>>>0<11){b[i+11>>0]=j;if(!j)k=i;else{l=i;m=6}}else{n=j+16&-16;o=$Xc(n)|0;f[i>>2]=o;f[i+8>>2]=n|-2147483648;f[i+4>>2]=j;l=o;m=6}if((m|0)==6){o1c(l|0,g|0,j|0)|0;k=l}b[k+j>>0]=0;q0b(a,c,d,e,i);if((b[i+11>>0]|0)>=0){u=h;return}cYc(f[i>>2]|0);u=h;return}function q0b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+24|0;j=h;k=f[a+8>>2]|0;if(k|0){Fh[f[(f[k>>2]|0)+8>>2]&255](k,a+28|0,c,d,e,g);l=a+24|0;b[l>>0]=1;u=h;return}e=a+24|0;if(!(b[e>>0]|0)){u_b(i,2,479317,3592);r_b(h+49|0,p_b(q_b(p_b(i,488688)|0,a+28|0)|0,488724)|0);v_b(i)}u_b(j,2,479317,3595);r_b(h+48|0,q_b(p_b(q_b(p_b(j,488727)|0,c)|0,518985)|0,g)|0);v_b(j);l=e;b[l>>0]=1;u=h;return}function r0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function s0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(GIc(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(GIc(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=$Xc(16)|0;r=c;c=f[r+4>>2]|0;l=d+8|0;f[l>>2]=f[r>>2];f[l+4>>2]=c;f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){l=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;r=~~+X(+(t/u))>>>0;r$b(a,l>>>0<r>>>0?r:l);l=f[i>>2]|0;r=l+-1|0;if(!(r&l)){v=l;w=r&g;break}if(g>>>0<l>>>0){v=l;w=g}else{v=l;w=(g>>>0)%(l>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function t0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function u0b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+48|0;h=g+36|0;i=g+24|0;j=g+12|0;k=g;l=a+4|0;m=f[l>>2]|0;n=c+11|0;f[h>>2]=(b[n>>0]|0)<0?f[c>>2]|0:c;f[h+4>>2]=8;f[h+8>>2]=e;if(y2b(m+132|0,h)|0){o=(b[n>>0]|0)<0?f[c>>2]|0:c;f[h>>2]=o;p=m+200|0;q=f[p>>2]|0;if(q>>>0<(f[m+204>>2]|0)>>>0){f[q>>2]=o;f[p>>2]=(f[p>>2]|0)+4}else t0b(m+196|0,h);m=KYc(c,46,-1)|0;if((m|0)==-1){v2b(a,c,c,d);u=g;return}p=f[l>>2]|0;mYc(i,c,0,m,c);o=$Xc(12)|0;lYc(o,i);f[h>>2]=o;q=p+76|0;r=f[q>>2]|0;if((r|0)==(f[p+80>>2]|0))r0b(p+72|0,h);else{f[r>>2]=o;f[q>>2]=(f[q>>2]|0)+4}q=f[h>>2]|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u0b(a,q,d,e);mYc(h,c,m+1|0,-1,c);v2b(a,h,c,d);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);u=g;return}m=f[l>>2]|0;f[h>>2]=(b[n>>0]|0)<0?f[c>>2]|0:c;n=X$b(m+132|0,h)|0;if(n){m=f[n+12>>2]|0;if((m|0)==8){u=g;return}else{s=m;t=f[n+16>>2]|0}}else{s=0;t=0}SGa(k,505469,c);n=AYc(k,488621)|0;f[j>>2]=f[n>>2];f[j+4>>2]=f[n+4>>2];f[j+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;switch(s|0){case 7:{v=(f[t+8>>2]|0)+8|0;w=25;break}case 1:{v=t+8|0;w=25;break}case 2:{v=t+20|0;w=25;break}case 3:{v=(f[t+8>>2]|0)+8|0;w=25;break}case 4:{v=t+8|0;w=25;break}case 5:{v=(f[t+12>>2]|0)+8|0;w=25;break}case 6:{v=t+8|0;w=25;break}default:x=0}if((w|0)==25)x=f[v>>2]|0;v=f[x>>2]|0;x=b[v+11>>0]|0;w=x<<24>>24<0;t=zYc(j,w?f[v>>2]|0:v,w?f[v+4>>2]|0:x&255)|0;f[i>>2]=f[t>>2];f[i+4>>2]=f[t+4>>2];f[i+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;t=AYc(i,506102)|0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];f[h+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;q0b(a,c,d,0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);u=g;return}function v0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function w0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+12|0;h=e;i=f[c+120>>2]|0;SGa(h,488538,f[(f[c+28>>2]|0)+4+(d<<2)>>2]|0);d=AYc(h,488601)|0;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;q0b(a,i,c,9,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return}cYc(f[h>>2]|0);u=e;return}function x0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;i=$Xc(96)|0;f[e>>2]=i;j=h+124|0;k=f[j>>2]|0;if((k|0)==(f[h+128>>2]|0))wN(h+120|0,e);else{f[k>>2]=i;f[j>>2]=(f[j>>2]|0)+4}j=f[e>>2]|0;i=j;k=i+96|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(k|0));i=f[g>>2]|0;g=$Xc(12)|0;lYc(g,c);f[e>>2]=g;c=i+76|0;k=f[c>>2]|0;if((k|0)==(f[i+80>>2]|0))r0b(i+72|0,e);else{f[k>>2]=g;f[c>>2]=(f[c>>2]|0)+4}f[j>>2]=f[e>>2];if((f[223513]|0)!=2){f[e>>2]=165456;f[e+4>>2]=125;b[e+8>>0]=0;J_b(894052,e);a_b(e)}f[j+4>>2]=537368;f[j+8>>2]=a;a=efc()|0;f[j+84>>2]=a;if((f[223537]|0)==2){l=f[223538]|0;m=j+88|0;f[m>>2]=l;n=ufc()|0;o=j+92|0;f[o>>2]=n;p=j+48|0;b[p>>0]=1;q=j+44|0;f[q>>2]=2;r=j+49|0;b[r>>0]=1;u=d;return j|0}f[e>>2]=165456;f[e+4>>2]=129;b[e+8>>0]=0;J_b(894148,e);a_b(e);l=f[223538]|0;m=j+88|0;f[m>>2]=l;n=ufc()|0;o=j+92|0;f[o>>2]=n;p=j+48|0;b[p>>0]=1;q=j+44|0;f[q>>2]=2;r=j+49|0;b[r>>0]=1;u=d;return j|0}function y0b(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+32|0;h=g+20|0;i=g+12|0;j=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(!(f[(f[a>>2]|0)+4>>2]|0)){SGa(j,488538,f[(f[c+28>>2]|0)+4+(e<<2)>>2]|0);k=AYc(j,488547)|0;l=f[k>>2]|0;m=k+4|0;f[i>>2]=f[m>>2];d[i+4>>1]=d[m+4>>1]|0;b[i+6>>0]=b[m+6>>0]|0;m=b[k+11>>0]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;k=h+11|0;if((b[k>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[k>>0]=0}sYc(h,0);f[h>>2]=l;l=h+4|0;f[l>>2]=f[i>>2];d[l+4>>1]=d[i+4>>1]|0;b[l+6>>0]=b[i+6>>0]|0;b[h+11>>0]=m;f[i>>2]=0;d[i+4>>1]=0;b[i+6>>0]=0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}else{SGa(j,488538,f[(f[c+28>>2]|0)+4+(e<<2)>>2]|0);e=AYc(j,488570)|0;m=f[e>>2]|0;l=e+4|0;f[i>>2]=f[l>>2];d[i+4>>1]=d[l+4>>1]|0;b[i+6>>0]=b[l+6>>0]|0;l=b[e+11>>0]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;e=h+11|0;if((b[e>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[e>>0]=0}sYc(h,0);f[h>>2]=m;m=h+4|0;f[m>>2]=f[i>>2];d[m+4>>1]=d[i+4>>1]|0;b[m+6>>0]=b[i+6>>0]|0;b[h+11>>0]=l;f[i>>2]=0;d[i+4>>1]=0;b[i+6>>0]=0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}q0b(a,f[c+120>>2]|0,c,9,h);if((b[h+11>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function z0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function A0b(a){a=a|0;Q2b(a);return}function B0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=c;if(!c){u=d;return}h=a+48|0;i=a+52|0;j=f[i>>2]|0;do if(j){k=a+52|0;l=j;while(1){m=f[l+16>>2]|0;if(m>>>0>c>>>0){n=f[l>>2]|0;if(!n){o=7;break}else{p=l;q=n}}else{if(m>>>0>=c>>>0){o=11;break}r=l+4|0;m=f[r>>2]|0;if(!m){o=10;break}else{p=r;q=m}}k=p;l=q}if((o|0)==7){s=l;t=l;break}else if((o|0)==10){s=l;t=r;break}else if((o|0)==11){s=l;t=k;break}}else{s=i;t=i}while(0);if(f[t>>2]|0){u=d;return}i=$Xc(20)|0;f[i+16>>2]=g;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=s;f[t>>2]=i;s=f[f[h>>2]>>2]|0;if(!s)v=i;else{f[h>>2]=s;v=f[t>>2]|0}UQ(f[a+52>>2]|0,v);v=a+56|0;f[v>>2]=(f[v>>2]|0)+1;v=c+20|0;t=c+60|0;s=c+12|0;h=c+52|0;i=e+4|0;g=e+8|0;o=e+12|0;if((f[v>>2]|0)>0)w=0;else{u=d;return}do{r=f[(f[t>>2]|0)+(w<<2)>>2]|0;q=f[s>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[e>>2]=165864;f[i>>2]=2270;b[g>>0]=0;f[o>>2]=c;J_b(q,e)}B0b(a,f[(f[h>>2]|0)+(r<<2)>>2]|0);w=w+1|0}while((w|0)<(f[v>>2]|0));u=d;return}function C0b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;g=u;u=u+480|0;h=g+448|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;o=g+240|0;p=g+200|0;q=g+160|0;r=g+120|0;s=g+80|0;t=g+40|0;v=g;if(!d)w=(f[a+40>>2]|0)+4|0;else w=d+4|0;x=f[w>>2]|0;w=a+4|0;y=f[w>>2]|0;z=$Xc(12)|0;lYc(z,x);f[h>>2]=z;x=y+76|0;A=f[x>>2]|0;if((A|0)==(f[y+80>>2]|0))r0b(y+72|0,h);else{f[A>>2]=z;f[x>>2]=(f[x>>2]|0)+4}x=f[h>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0)B=f[x+4>>2]|0;else B=z&255;if(B|0)vYc(x,1,46)|0;B=c+144|0;z=f[B>>2]|0;A=b[z+11>>0]|0;y=A<<24>>24<0;zYc(x,y?f[z>>2]|0:z,y?f[z+4>>2]|0:A&255)|0;v2b(a,f[B>>2]|0,x,c);A=f[w>>2]|0;z=f[B>>2]|0;B=$Xc(12)|0;lYc(B,z);f[h>>2]=B;z=A+76|0;y=f[z>>2]|0;if((y|0)==(f[A+80>>2]|0))r0b(A+72|0,h);else{f[y>>2]=B;f[z>>2]=(f[z>>2]|0)+4}f[e>>2]=f[h>>2];z=e+4|0;f[z>>2]=x;f[e+8>>2]=f[a+40>>2];f[e+12>>2]=d;b[e+84>>0]=0;b[e+85>>0]=0;x=c+100|0;B=f[x>>2]|0;f[e+56>>2]=B;y=e+24|0;A=f[w>>2]|0;C=B*28|0;if(!C){D=0;E=B}else{B=$Xc(C)|0;f[h>>2]=B;C=A+124|0;F=f[C>>2]|0;if((F|0)==(f[A+128>>2]|0))wN(A+120|0,h);else{f[F>>2]=B;f[C>>2]=(f[C>>2]|0)+4}D=f[h>>2]|0;E=f[x>>2]|0}f[y>>2]=D;if((E|0)>0?(E=c+108|0,M2b(a,f[(f[E>>2]|0)+4>>2]|0,e,D),(f[x>>2]|0)>1):0){D=1;do{M2b(a,f[(f[E>>2]|0)+4+(D<<2)>>2]|0,e,(f[y>>2]|0)+(D*28|0)|0);D=D+1|0}while((D|0)<(f[x>>2]|0))}x=c+20|0;D=f[x>>2]|0;y=e+52|0;f[y>>2]=D;E=e+20|0;C=f[w>>2]|0;B=D*88|0;if(!B){G=0;H=D}else{D=$Xc(B)|0;f[h>>2]=D;B=C+124|0;F=f[B>>2]|0;if((F|0)==(f[C+128>>2]|0))wN(C+120|0,h);else{f[F>>2]=D;f[B>>2]=(f[B>>2]|0)+4}G=f[h>>2]|0;H=f[x>>2]|0}f[E>>2]=G;if((H|0)>0?(H=c+28|0,F0b(a,f[(f[H>>2]|0)+4>>2]|0,e,G,0),(f[x>>2]|0)>1):0){G=1;do{F0b(a,f[(f[H>>2]|0)+4+(G<<2)>>2]|0,e,(f[E>>2]|0)+(G*88|0)|0,0);G=G+1|0}while((G|0)<(f[x>>2]|0))}x=c+36|0;G=f[x>>2]|0;f[e+60>>2]=G;H=e+28|0;B=f[w>>2]|0;D=G*88|0;if(!D){I=0;J=G}else{G=$Xc(D)|0;f[h>>2]=G;D=B+124|0;F=f[D>>2]|0;if((F|0)==(f[B+128>>2]|0))wN(B+120|0,h);else{f[F>>2]=G;f[D>>2]=(f[D>>2]|0)+4}I=f[h>>2]|0;J=f[x>>2]|0}f[H>>2]=I;if((J|0)>0?(J=c+44|0,C0b(a,f[(f[J>>2]|0)+4>>2]|0,e,I),(f[x>>2]|0)>1):0){I=1;do{C0b(a,f[(f[J>>2]|0)+4+(I<<2)>>2]|0,e,(f[H>>2]|0)+(I*88|0)|0);I=I+1|0}while((I|0)<(f[x>>2]|0))}x=c+52|0;I=f[x>>2]|0;f[e+64>>2]=I;H=e+32|0;J=f[w>>2]|0;D=I*48|0;if(!D){K=0;L=I}else{I=$Xc(D)|0;f[h>>2]=I;D=J+124|0;G=f[D>>2]|0;if((G|0)==(f[J+128>>2]|0))wN(J+120|0,h);else{f[G>>2]=I;f[D>>2]=(f[D>>2]|0)+4}K=f[h>>2]|0;L=f[x>>2]|0}f[H>>2]=K;if((L|0)>0?(L=c+60|0,D0b(a,f[(f[L>>2]|0)+4>>2]|0,e,K),(f[x>>2]|0)>1):0){K=1;do{D0b(a,f[(f[L>>2]|0)+4+(K<<2)>>2]|0,e,(f[H>>2]|0)+(K*48|0)|0);K=K+1|0}while((K|0)<(f[x>>2]|0))}x=c+68|0;K=f[x>>2]|0;H=e+68|0;f[H>>2]=K;L=e+36|0;D=f[w>>2]|0;I=K*12|0;if(!I){M=0;N=K}else{K=$Xc(I)|0;f[h>>2]=K;I=D+124|0;G=f[I>>2]|0;if((G|0)==(f[D+128>>2]|0))wN(D+120|0,h);else{f[G>>2]=K;f[I>>2]=(f[I>>2]|0)+4}M=f[h>>2]|0;N=f[x>>2]|0}f[L>>2]=M;a:do if((N|0)>0){I=c+76|0;K=0;G=M;while(1){D=f[(f[I>>2]|0)+4+(K<<2)>>2]|0;J=G+(K*12|0)|0;F=f[D+20>>2]|0;f[J>>2]=F;B=f[D+24>>2]|0;C=G+(K*12|0)+4|0;f[C>>2]=B;if((F|0)<1){p0b(a,f[z>>2]|0,D,1,487978);O=f[J>>2]|0;P=f[C>>2]|0}else{O=F;P=B}if((O|0)>=(P|0))p0b(a,f[z>>2]|0,D,1,488023);if(!(f[D+8>>2]&1))f[G+(K*12|0)+8>>2]=0;else{B=f[z>>2]|0;F=f[D+16>>2]|0;N2b(a,B,B,F|0?F:537768,J)}J=K+1|0;if((J|0)>=(f[x>>2]|0))break a;K=J;G=f[L>>2]|0}}while(0);x=c+84|0;P=f[x>>2]|0;f[e+72>>2]=P;O=e+40|0;M=f[w>>2]|0;N=P*88|0;if(!N){Q=0;R=P}else{P=$Xc(N)|0;f[h>>2]=P;N=M+124|0;G=f[N>>2]|0;if((G|0)==(f[M+128>>2]|0))wN(M+120|0,h);else{f[G>>2]=P;f[N>>2]=(f[N>>2]|0)+4}Q=f[h>>2]|0;R=f[x>>2]|0}f[O>>2]=Q;if((R|0)>0?(R=c+92|0,F0b(a,f[(f[R>>2]|0)+4>>2]|0,e,Q,1),(f[x>>2]|0)>1):0){Q=1;do{F0b(a,f[(f[R>>2]|0)+4+(Q<<2)>>2]|0,e,(f[O>>2]|0)+(Q*88|0)|0,1);Q=Q+1|0}while((Q|0)<(f[x>>2]|0))}x=c+116|0;Q=f[x>>2]|0;O=e+76|0;f[O>>2]=Q;R=e+44|0;N=f[w>>2]|0;P=Q<<3;if(!P){S=0;T=Q}else{Q=$Xc(P)|0;f[h>>2]=Q;P=N+124|0;G=f[P>>2]|0;if((G|0)==(f[N+128>>2]|0))wN(N+120|0,h);else{f[G>>2]=Q;f[P>>2]=(f[P>>2]|0)+4}S=f[h>>2]|0;T=f[x>>2]|0}f[R>>2]=S;b:do if((T|0)>0){P=c+124|0;Q=0;G=S;N=T;while(1){M=f[(f[P>>2]|0)+4+(Q<<2)>>2]|0;K=f[M+16>>2]|0;f[G+(Q<<3)>>2]=K;f[G+(Q<<3)+4>>2]=f[M+20>>2];if((K|0)<1){p0b(a,f[z>>2]|0,M,1,488085);U=f[x>>2]|0}else U=N;M=Q+1|0;if((M|0)>=(U|0))break b;Q=M;G=f[R>>2]|0;N=U}}while(0);U=c+132|0;T=f[U>>2]|0;f[e+80>>2]=T;S=f[w>>2]|0;N=T<<2;if(!N)V=0;else{G=$Xc(N)|0;f[h>>2]=G;N=S+124|0;Q=f[N>>2]|0;if((Q|0)==(f[S+128>>2]|0))wN(S+120|0,h);else{f[Q>>2]=G;f[N>>2]=(f[N>>2]|0)+4}V=f[h>>2]|0}N=e+48|0;f[N>>2]=V;if((T|0)>0){V=c+140|0;G=0;do{Q=f[w>>2]|0;S=f[(f[V>>2]|0)+4+(G<<2)>>2]|0;P=$Xc(12)|0;lYc(P,S);f[h>>2]=P;S=Q+76|0;M=f[S>>2]|0;if((M|0)==(f[Q+80>>2]|0))r0b(Q+72|0,h);else{f[M>>2]=P;f[S>>2]=(f[S>>2]|0)+4}f[(f[N>>2]|0)+(G<<2)>>2]=f[h>>2];G=G+1|0}while((G|0)<(T|0))}if(!(f[c+8>>2]&2))f[e+16>>2]=0;else{T=f[c+148>>2]|0;G=f[z>>2]|0;O2b(a,G,G,T|0?T:538200,e)}T=f[z>>2]|0;G=f[e>>2]|0;f[i>>2]=1;f[i+4>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];x2b(a,T,d,G,c,h)|0;G=f[x>>2]|0;if((G|0)>0){d=c+124|0;T=j+8|0;i=j+4|0;e=k+8|0;N=k+4|0;V=l+8|0;w=l+4|0;S=m+8|0;P=m+4|0;M=o+4|0;Q=p+4|0;K=q+4|0;I=r+4|0;J=s+4|0;F=t+4|0;B=h+11|0;D=0;C=G;while(1){G=f[d>>2]|0;A=f[G+4+(D<<2)>>2]|0;W=D;D=D+1|0;c:do if((D|0)<(C|0)){Y=A+20|0;Z=A+16|0;_=D;$=G;aa=C;while(1){ba=f[$+4+(_<<2)>>2]|0;ca=f[ba+16>>2]|0;do if((f[Y>>2]|0)>(ca|0)){da=ba+20|0;if((f[da>>2]|0)<=(f[Z>>2]|0)){ea=aa;break}fa=f[z>>2]|0;ga=f[$+4+(W<<2)>>2]|0;ha=itc(ca,T)|0;f[j>>2]=ha;ia=dJc(ha)|0;f[i>>2]=ia;ia=itc((f[da>>2]|0)+-1|0,e)|0;f[k>>2]=ia;da=dJc(ia)|0;f[N>>2]=da;da=itc(f[Z>>2]|0,V)|0;f[l>>2]=da;ia=dJc(da)|0;f[w>>2]=ia;ia=itc((f[Y>>2]|0)+-1|0,S)|0;f[m>>2]=ia;da=dJc(ia)|0;f[P>>2]=da;f[o>>2]=0;f[M>>2]=-1;f[p>>2]=0;f[Q>>2]=-1;f[q>>2]=0;f[K>>2]=-1;f[r>>2]=0;f[I>>2]=-1;f[s>>2]=0;f[J>>2]=-1;f[t>>2]=0;f[F>>2]=-1;Toc(h,487435,j,k,l,m,o,p,q,r,s,t);q0b(a,fa,ga,1,h);if((b[B>>0]|0)<0)cYc(f[h>>2]|0);ea=f[x>>2]|0}else ea=aa;while(0);ca=_+1|0;if((ca|0)>=(ea|0)){ja=ea;break c}_=ca;$=f[d>>2]|0;aa=ea}}else ja=C;while(0);if((D|0)>=(ja|0))break;else C=ja}}ja=h+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;n[ja>>2]=1.0;if((f[U>>2]|0)>0){C=c+140|0;D=h+4|0;ea=h+12|0;d=h+8|0;x=k+4|0;B=l+4|0;F=m+4|0;J=o+4|0;I=p+4|0;K=q+4|0;Q=r+4|0;M=s+4|0;P=t+4|0;S=v+4|0;w=j+11|0;V=0;do{N=f[(f[C>>2]|0)+4+(V<<2)>>2]|0;d:do if(G2b(h,N)|0){e=b[N+11>>0]|0;i=e<<24>>24<0;f[k>>2]=i?f[N>>2]|0:N;f[x>>2]=i?f[N+4>>2]|0:e&255;f[l>>2]=0;f[B>>2]=-1;f[m>>2]=0;f[F>>2]=-1;f[o>>2]=0;f[J>>2]=-1;f[p>>2]=0;f[I>>2]=-1;f[q>>2]=0;f[K>>2]=-1;f[r>>2]=0;f[Q>>2]=-1;f[s>>2]=0;f[M>>2]=-1;f[t>>2]=0;f[P>>2]=-1;f[v>>2]=0;f[S>>2]=-1;Toc(j,488129,k,l,m,o,p,q,r,s,t,v);q0b(a,N,c,0,j);if((b[w>>0]|0)<0)cYc(f[j>>2]|0)}else{e=b[N+11>>0]|0;i=e<<24>>24<0;T=i?f[N>>2]|0:N;W=b[T>>0]|0;if(!(W<<24>>24))ka=0;else{G=T;A=0;aa=W;while(1){$=(A*5|0)+(aa<<24>>24)|0;G=G+1|0;aa=b[G>>0]|0;if(!(aa<<24>>24)){ka=$;break}else A=$}}A=f[D>>2]|0;aa=(A|0)==0;e:do if(aa)la=0;else{G=A+-1|0;$=(G&A|0)==0;do if($)ma=G&ka;else{if(ka>>>0<A>>>0){ma=ka;break}ma=(ka>>>0)%(A>>>0)|0}while(0);_=f[(f[h>>2]|0)+(ma<<2)>>2]|0;if(!_){la=ma;break}Y=f[_>>2]|0;if(!Y){la=ma;break}_=i?f[N+4>>2]|0:e&255;Z=(_|0)==0;if($){if(Z){ca=Y;while(1){ba=f[ca+4>>2]|0;if(!((ba|0)==(ka|0)|(ba&G|0)==(ma|0))){la=ma;break e}ba=b[ca+8+11>>0]|0;if(!((ba<<24>>24<0?f[ca+12>>2]|0:ba&255)|0))break d;ca=f[ca>>2]|0;if(!ca){la=ma;break e}}}else na=Y;while(1){ca=f[na+4>>2]|0;if(!((ca|0)==(ka|0)|(ca&G|0)==(ma|0))){la=ma;break e}ca=na+8|0;$=b[ca+11>>0]|0;ba=$<<24>>24<0;ga=$&255;do if(((ba?f[na+12>>2]|0:ga)|0)==(_|0)){$=f[ca>>2]|0;if(ba)if(!(WKc($,T,_)|0))break d;else break;if(($&255)<<24>>24!=W<<24>>24)break;$=ca;fa=ga;da=T;do{fa=fa+-1|0;$=$+1|0;if(!fa)break d;da=da+1|0}while((b[$>>0]|0)==(b[da>>0]|0))}while(0);na=f[na>>2]|0;if(!na){la=ma;break e}}}if(Z){G=Y;while(1){ga=f[G+4>>2]|0;if((ga|0)!=(ka|0)){if(ga>>>0<A>>>0)oa=ga;else oa=(ga>>>0)%(A>>>0)|0;if((oa|0)!=(ma|0)){la=ma;break e}}ga=b[G+8+11>>0]|0;if(!((ga<<24>>24<0?f[G+12>>2]|0:ga&255)|0))break d;G=f[G>>2]|0;if(!G){la=ma;break e}}}else pa=Y;while(1){G=f[pa+4>>2]|0;if((G|0)!=(ka|0)){if(G>>>0<A>>>0)qa=G;else qa=(G>>>0)%(A>>>0)|0;if((qa|0)!=(ma|0)){la=ma;break e}}G=pa+8|0;Z=b[G+11>>0]|0;ga=Z<<24>>24<0;ca=Z&255;do if(((ga?f[pa+12>>2]|0:ca)|0)==(_|0)){Z=f[G>>2]|0;if(ga)if(!(WKc(Z,T,_)|0))break d;else break;if((Z&255)<<24>>24!=W<<24>>24)break;Z=G;ba=ca;da=T;do{ba=ba+-1|0;Z=Z+1|0;if(!ba)break d;da=da+1|0}while((b[Z>>0]|0)==(b[da>>0]|0))}while(0);pa=f[pa>>2]|0;if(!pa){la=ma;break}}}while(0);T=$Xc(20)|0;lYc(T+8|0,N);f[T+4>>2]=ka;f[T>>2]=0;ra=+(((f[ea>>2]|0)+1|0)>>>0);sa=+n[ja>>2];do if(aa|ra>+(A>>>0)*sa){W=(A>>>0<3|(A+-1&A|0)!=0)&1|A<<1;e=~~+X(+(ra/sa))>>>0;b0b(h,W>>>0<e>>>0?e:W);W=f[D>>2]|0;e=W+-1|0;if(!(e&W)){ta=W;ua=e&ka;break}if(ka>>>0<W>>>0){ta=W;ua=ka;break}ta=W;ua=(ka>>>0)%(W>>>0)|0}else{ta=A;ua=la}while(0);A=(f[h>>2]|0)+(ua<<2)|0;aa=f[A>>2]|0;do if(!aa){f[T>>2]=f[d>>2];f[d>>2]=T;f[A>>2]=d;W=f[T>>2]|0;if(!W)break;e=f[W+4>>2]|0;W=ta+-1|0;do if(!(W&ta))va=e&W;else{if(e>>>0<ta>>>0){va=e;break}va=(e>>>0)%(ta>>>0)|0}while(0);wa=(f[h>>2]|0)+(va<<2)|0;xa=168}else{f[T>>2]=f[aa>>2];wa=aa;xa=168}while(0);if((xa|0)==168){xa=0;f[wa>>2]=T}f[ea>>2]=(f[ea>>2]|0)+1}while(0);V=V+1|0}while((V|0)<(f[U>>2]|0))}if((f[y>>2]|0)>0){U=c+28|0;V=k+4|0;ea=l+4|0;wa=m+4|0;xa=o+4|0;va=p+4|0;ta=q+4|0;d=r+4|0;ua=s+4|0;la=t+4|0;ka=v+4|0;D=j+11|0;ja=c+124|0;ma=k+4|0;pa=l+8|0;qa=l+4|0;oa=m+4|0;na=o+4|0;w=p+4|0;S=q+4|0;P=r+4|0;M=s+4|0;Q=t+4|0;K=v+4|0;I=j+11|0;J=c+76|0;F=k+8|0;B=k+4|0;x=l+8|0;C=l+4|0;N=m+4|0;aa=o+8|0;A=o+4|0;e=p+4|0;W=q+4|0;i=r+4|0;_=s+4|0;Y=t+4|0;ca=v+4|0;G=j+11|0;ga=0;do{da=f[E>>2]|0;Z=da+(ga*88|0)|0;ba=f[H>>2]|0;if((ba|0)>0){$=da+(ga*88|0)+40|0;fa=da+(ga*88|0)+4|0;ia=0;ha=ba;while(1){ba=f[L>>2]|0;ya=f[ba+(ia*12|0)>>2]|0;za=f[$>>2]|0;do if((ya|0)>(za|0))Aa=ha;else{Ba=ba+(ia*12|0)+4|0;if((za|0)>=(f[Ba>>2]|0)){Aa=ha;break}Ca=f[fa>>2]|0;Da=f[(f[J>>2]|0)+4+(ia<<2)>>2]|0;Ea=itc(ya,F)|0;f[k>>2]=Ea;Fa=dJc(Ea)|0;f[B>>2]=Fa;Fa=itc((f[Ba>>2]|0)+-1|0,x)|0;f[l>>2]=Fa;Ba=dJc(Fa)|0;f[C>>2]=Ba;Ba=f[Z>>2]|0;Fa=b[Ba+11>>0]|0;Ea=Fa<<24>>24<0;f[m>>2]=Ea?f[Ba>>2]|0:Ba;f[N>>2]=Ea?f[Ba+4>>2]|0:Fa&255;Fa=itc(f[$>>2]|0,aa)|0;f[o>>2]=Fa;Ba=dJc(Fa)|0;f[A>>2]=Ba;f[p>>2]=0;f[e>>2]=-1;f[q>>2]=0;f[W>>2]=-1;f[r>>2]=0;f[i>>2]=-1;f[s>>2]=0;f[_>>2]=-1;f[t>>2]=0;f[Y>>2]=-1;f[v>>2]=0;f[ca>>2]=-1;Toc(j,488173,k,l,m,o,p,q,r,s,t,v);q0b(a,Ca,Da,1,j);if((b[G>>0]|0)<0)cYc(f[j>>2]|0);Aa=f[H>>2]|0}while(0);ia=ia+1|0;if((ia|0)>=(Aa|0))break;else ha=Aa}}ha=f[O>>2]|0;if((ha|0)>0){ia=da+(ga*88|0)+40|0;$=da+(ga*88|0)+4|0;fa=0;ya=ha;while(1){ha=f[R>>2]|0;za=f[ia>>2]|0;do if((f[ha+(fa<<3)>>2]|0)>(za|0))Ga=ya;else{if((za|0)>=(f[ha+(fa<<3)+4>>2]|0)){Ga=ya;break}ba=f[$>>2]|0;T=f[(f[ja>>2]|0)+4+(fa<<2)>>2]|0;Da=f[Z>>2]|0;Ca=b[Da+11>>0]|0;Ba=Ca<<24>>24<0;f[k>>2]=Ba?f[Da>>2]|0:Da;f[ma>>2]=Ba?f[Da+4>>2]|0:Ca&255;Ca=itc(za,pa)|0;f[l>>2]=Ca;Da=dJc(Ca)|0;f[qa>>2]=Da;f[m>>2]=0;f[oa>>2]=-1;f[o>>2]=0;f[na>>2]=-1;f[p>>2]=0;f[w>>2]=-1;f[q>>2]=0;f[S>>2]=-1;f[r>>2]=0;f[P>>2]=-1;f[s>>2]=0;f[M>>2]=-1;f[t>>2]=0;f[Q>>2]=-1;f[v>>2]=0;f[K>>2]=-1;Toc(j,488224,k,l,m,o,p,q,r,s,t,v);q0b(a,ba,T,1,j);if((b[I>>0]|0)<0)cYc(f[j>>2]|0);Ga=f[O>>2]|0}while(0);fa=fa+1|0;if((fa|0)>=(Ga|0)){Ha=Z;break}else ya=Ga}}else Ha=Z;if(G2b(h,f[Ha>>2]|0)|0?(ya=f[da+(ga*88|0)+4>>2]|0,fa=f[(f[U>>2]|0)+4+(ga<<2)>>2]|0,$=f[Ha>>2]|0,ia=b[$+11>>0]|0,za=ia<<24>>24<0,f[k>>2]=za?f[$>>2]|0:$,f[V>>2]=za?f[$+4>>2]|0:ia&255,f[l>>2]=0,f[ea>>2]=-1,f[m>>2]=0,f[wa>>2]=-1,f[o>>2]=0,f[xa>>2]=-1,f[p>>2]=0,f[va>>2]=-1,f[q>>2]=0,f[ta>>2]=-1,f[r>>2]=0,f[d>>2]=-1,f[s>>2]=0,f[ua>>2]=-1,f[t>>2]=0,f[la>>2]=-1,f[v>>2]=0,f[ka>>2]=-1,Toc(j,488260,k,l,m,o,p,q,r,s,t,v),q0b(a,ya,fa,0,j),(b[D>>0]|0)<0):0)cYc(f[j>>2]|0);ga=ga+1|0}while((ga|0)<(f[y>>2]|0))}y=f[H>>2]|0;if((y|0)>0){ga=c+76|0;c=k+8|0;D=k+4|0;ka=l+8|0;la=l+4|0;ua=m+8|0;d=m+4|0;ta=o+8|0;va=o+4|0;xa=p+4|0;wa=q+4|0;ea=r+4|0;V=s+4|0;Ha=t+4|0;U=v+4|0;Ga=j+11|0;I=k+8|0;K=k+4|0;Q=l+8|0;M=l+4|0;P=m+8|0;S=m+4|0;w=o+8|0;na=o+4|0;oa=p+4|0;qa=q+4|0;pa=r+4|0;ma=s+4|0;ja=t+4|0;Aa=v+4|0;G=j+11|0;ca=0;Y=y;while(1){y=f[L>>2]|0;_=y+(ca*12|0)|0;i=f[O>>2]|0;if((i|0)>0){W=y+(ca*12|0)+4|0;e=0;A=i;while(1){i=f[R>>2]|0;aa=i+(e<<3)|0;do if((f[W>>2]|0)>(f[aa>>2]|0)){N=i+(e<<3)+4|0;C=f[_>>2]|0;if((f[N>>2]|0)<=(C|0)){Ia=A;break}x=f[z>>2]|0;B=f[(f[ga>>2]|0)+4+(ca<<2)>>2]|0;F=itc(C,I)|0;f[k>>2]=F;C=dJc(F)|0;f[K>>2]=C;C=itc((f[W>>2]|0)+-1|0,Q)|0;f[l>>2]=C;F=dJc(C)|0;f[M>>2]=F;F=itc(f[aa>>2]|0,P)|0;f[m>>2]=F;C=dJc(F)|0;f[S>>2]=C;C=itc((f[N>>2]|0)+-1|0,w)|0;f[o>>2]=C;N=dJc(C)|0;f[na>>2]=N;f[p>>2]=0;f[oa>>2]=-1;f[q>>2]=0;f[qa>>2]=-1;f[r>>2]=0;f[pa>>2]=-1;f[s>>2]=0;f[ma>>2]=-1;f[t>>2]=0;f[ja>>2]=-1;f[v>>2]=0;f[Aa>>2]=-1;Toc(j,488289,k,l,m,o,p,q,r,s,t,v);q0b(a,x,B,1,j);if((b[G>>0]|0)<0)cYc(f[j>>2]|0);Ia=f[O>>2]|0}else Ia=A;while(0);e=e+1|0;if((e|0)>=(Ia|0))break;else A=Ia}Ja=f[H>>2]|0}else Ja=Y;A=ca;ca=ca+1|0;if((ca|0)<(Ja|0)){e=y+(A*12|0)+4|0;W=ca;da=Ja;while(1){Z=f[L>>2]|0;aa=f[Z+(W*12|0)>>2]|0;do if((f[e>>2]|0)>(aa|0)){i=Z+(W*12|0)+4|0;if((f[i>>2]|0)<=(f[_>>2]|0)){Ka=da;break}B=f[z>>2]|0;x=f[(f[ga>>2]|0)+4+(A<<2)>>2]|0;N=itc(aa,c)|0;f[k>>2]=N;C=dJc(N)|0;f[D>>2]=C;C=itc((f[i>>2]|0)+-1|0,ka)|0;f[l>>2]=C;i=dJc(C)|0;f[la>>2]=i;i=itc(f[_>>2]|0,ua)|0;f[m>>2]=i;C=dJc(i)|0;f[d>>2]=C;C=itc((f[e>>2]|0)+-1|0,ta)|0;f[o>>2]=C;i=dJc(C)|0;f[va>>2]=i;f[p>>2]=0;f[xa>>2]=-1;f[q>>2]=0;f[wa>>2]=-1;f[r>>2]=0;f[ea>>2]=-1;f[s>>2]=0;f[V>>2]=-1;f[t>>2]=0;f[Ha>>2]=-1;f[v>>2]=0;f[U>>2]=-1;Toc(j,488353,k,l,m,o,p,q,r,s,t,v);q0b(a,B,x,1,j);if((b[Ga>>0]|0)<0)cYc(f[j>>2]|0);Ka=f[H>>2]|0}else Ka=da;while(0);W=W+1|0;if((W|0)>=(Ka|0)){La=Ka;break}else da=Ka}}else La=Ja;if((ca|0)>=(La|0))break;else Y=La}}La=f[h+8>>2]|0;if(La|0){Y=La;do{La=Y;Y=f[Y>>2]|0;ca=La+8|0;if((b[ca+11>>0]|0)<0)cYc(f[ca>>2]|0);cYc(La)}while((Y|0)!=0)}Y=f[h>>2]|0;f[h>>2]=0;if(!Y){u=g;return}cYc(Y);u=g;return}function D0b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;g=u;u=u+480|0;h=g+448|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;o=g+240|0;p=g+200|0;q=g+160|0;r=g+120|0;s=g+80|0;t=g+40|0;v=g;if(!d)w=(f[a+40>>2]|0)+4|0;else w=d+4|0;x=f[w>>2]|0;w=a+4|0;y=f[w>>2]|0;z=$Xc(12)|0;lYc(z,x);f[h>>2]=z;x=y+76|0;A=f[x>>2]|0;if((A|0)==(f[y+80>>2]|0))r0b(y+72|0,h);else{f[A>>2]=z;f[x>>2]=(f[x>>2]|0)+4}x=f[h>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0)B=f[x+4>>2]|0;else B=z&255;if(B|0)vYc(x,1,46)|0;B=c+64|0;z=f[B>>2]|0;A=b[z+11>>0]|0;y=A<<24>>24<0;zYc(x,y?f[z>>2]|0:z,y?f[z+4>>2]|0:A&255)|0;v2b(a,f[B>>2]|0,x,c);A=f[w>>2]|0;z=f[B>>2]|0;B=$Xc(12)|0;lYc(B,z);f[h>>2]=B;z=A+76|0;y=f[z>>2]|0;if((y|0)==(f[A+80>>2]|0))r0b(A+72|0,h);else{f[y>>2]=B;f[z>>2]=(f[z>>2]|0)+4}f[e>>2]=f[h>>2];z=e+4|0;f[z>>2]=x;f[e+8>>2]=f[a+40>>2];f[e+12>>2]=d;b[e+20>>0]=0;b[e+21>>0]=0;B=c+20|0;y=f[B>>2]|0;if(!y){p0b(a,x,c,0,487335);C=f[B>>2]|0}else C=y;y=e+24|0;f[y>>2]=C;x=e+28|0;A=f[w>>2]|0;D=C*20|0;if(!D){E=0;F=C}else{C=$Xc(D)|0;f[h>>2]=C;D=A+124|0;G=f[D>>2]|0;if((G|0)==(f[A+128>>2]|0))wN(A+120|0,h);else{f[G>>2]=C;f[D>>2]=(f[D>>2]|0)+4}E=f[h>>2]|0;F=f[B>>2]|0}f[x>>2]=E;if((F|0)>0?(F=c+28|0,D2b(a,f[(f[F>>2]|0)+4>>2]|0,e,E),(f[B>>2]|0)>1):0){E=1;do{D2b(a,f[(f[F>>2]|0)+4+(E<<2)>>2]|0,e,(f[x>>2]|0)+(E*20|0)|0);E=E+1|0}while((E|0)<(f[B>>2]|0))}B=c+36|0;E=f[B>>2]|0;F=e+32|0;f[F>>2]=E;D=e+40|0;C=f[w>>2]|0;G=E<<3;if(!G){H=0;I=E}else{E=$Xc(G)|0;f[h>>2]=E;G=C+124|0;A=f[G>>2]|0;if((A|0)==(f[C+128>>2]|0))wN(C+120|0,h);else{f[A>>2]=E;f[G>>2]=(f[G>>2]|0)+4}H=f[h>>2]|0;I=f[B>>2]|0}f[D>>2]=H;a:do if((I|0)>0){G=c+44|0;E=0;A=H;C=I;while(1){J=f[(f[G>>2]|0)+4+(E<<2)>>2]|0;K=f[J+16>>2]|0;f[A+(E<<3)>>2]=K;L=f[J+20>>2]|0;f[A+(E<<3)+4>>2]=L;if((K|0)>(L|0)){p0b(a,f[z>>2]|0,J,1,487374);M=f[B>>2]|0}else M=C;J=E+1|0;if((J|0)>=(M|0))break a;E=J;A=f[D>>2]|0;C=M}}while(0);M=c+52|0;I=f[M>>2]|0;f[e+36>>2]=I;H=f[w>>2]|0;C=I<<2;if(!C)N=0;else{A=$Xc(C)|0;f[h>>2]=A;C=H+124|0;E=f[C>>2]|0;if((E|0)==(f[H+128>>2]|0))wN(H+120|0,h);else{f[E>>2]=A;f[C>>2]=(f[C>>2]|0)+4}N=f[h>>2]|0}C=e+44|0;f[C>>2]=N;if((I|0)>0){N=c+60|0;A=0;do{E=f[w>>2]|0;H=f[(f[N>>2]|0)+4+(A<<2)>>2]|0;G=$Xc(12)|0;lYc(G,H);f[h>>2]=G;H=E+76|0;J=f[H>>2]|0;if((J|0)==(f[E+80>>2]|0))r0b(E+72|0,h);else{f[J>>2]=G;f[H>>2]=(f[H>>2]|0)+4}f[(f[C>>2]|0)+(A<<2)>>2]=f[h>>2];A=A+1|0}while((A|0)<(I|0))}E2b(a,c,e);if(!(f[c+8>>2]&2))f[e+16>>2]=0;else{I=f[c+68>>2]|0;A=f[z>>2]|0;F2b(a,A,A,I|0?I:538368,e)}I=f[z>>2]|0;A=f[e>>2]|0;f[i>>2]=4;f[i+4>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];x2b(a,I,d,A,c,h)|0;A=f[B>>2]|0;if((A|0)>0){d=c+44|0;I=j+8|0;i=j+4|0;e=k+8|0;C=k+4|0;N=l+8|0;w=l+4|0;H=m+8|0;G=m+4|0;J=o+4|0;E=p+4|0;L=q+4|0;K=r+4|0;O=s+4|0;P=t+4|0;Q=h+11|0;R=0;S=A;while(1){A=f[d>>2]|0;T=f[A+4+(R<<2)>>2]|0;U=R;R=R+1|0;b:do if((R|0)<(S|0)){V=T+20|0;W=T+16|0;Y=R;Z=A;_=S;while(1){$=f[Z+4+(Y<<2)>>2]|0;aa=f[$+16>>2]|0;do if((f[V>>2]|0)>(aa|0)){ba=$+20|0;if((f[ba>>2]|0)<=(f[W>>2]|0)){ca=_;break}da=f[z>>2]|0;ea=f[Z+4+(U<<2)>>2]|0;fa=itc(aa,I)|0;f[j>>2]=fa;ga=dJc(fa)|0;f[i>>2]=ga;ga=itc((f[ba>>2]|0)+-1|0,e)|0;f[k>>2]=ga;ba=dJc(ga)|0;f[C>>2]=ba;ba=itc(f[W>>2]|0,N)|0;f[l>>2]=ba;ga=dJc(ba)|0;f[w>>2]=ga;ga=itc((f[V>>2]|0)+-1|0,H)|0;f[m>>2]=ga;ba=dJc(ga)|0;f[G>>2]=ba;f[o>>2]=0;f[J>>2]=-1;f[p>>2]=0;f[E>>2]=-1;f[q>>2]=0;f[L>>2]=-1;f[r>>2]=0;f[K>>2]=-1;f[s>>2]=0;f[O>>2]=-1;f[t>>2]=0;f[P>>2]=-1;Toc(h,487435,j,k,l,m,o,p,q,r,s,t);q0b(a,da,ea,1,h);if((b[Q>>0]|0)<0)cYc(f[h>>2]|0);ca=f[B>>2]|0}else ca=_;while(0);aa=Y+1|0;if((aa|0)>=(ca|0)){ha=ca;break b}Y=aa;Z=f[d>>2]|0;_=ca}}else ha=S;while(0);if((R|0)>=(ha|0))break;else S=ha}}ha=h+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;n[ha>>2]=1.0;if((f[M>>2]|0)>0){S=c+60|0;R=h+4|0;ca=h+12|0;d=h+8|0;B=k+4|0;Q=l+4|0;P=m+4|0;O=o+4|0;K=p+4|0;L=q+4|0;E=r+4|0;J=s+4|0;G=t+4|0;H=v+4|0;w=j+11|0;N=0;do{C=f[(f[S>>2]|0)+4+(N<<2)>>2]|0;c:do if(G2b(h,C)|0){e=b[C+11>>0]|0;i=e<<24>>24<0;f[k>>2]=i?f[C>>2]|0:C;f[B>>2]=i?f[C+4>>2]|0:e&255;f[l>>2]=0;f[Q>>2]=-1;f[m>>2]=0;f[P>>2]=-1;f[o>>2]=0;f[O>>2]=-1;f[p>>2]=0;f[K>>2]=-1;f[q>>2]=0;f[L>>2]=-1;f[r>>2]=0;f[E>>2]=-1;f[s>>2]=0;f[J>>2]=-1;f[t>>2]=0;f[G>>2]=-1;f[v>>2]=0;f[H>>2]=-1;Toc(j,487505,k,l,m,o,p,q,r,s,t,v);q0b(a,C,c,0,j);if((b[w>>0]|0)<0)cYc(f[j>>2]|0)}else{e=b[C+11>>0]|0;i=e<<24>>24<0;I=i?f[C>>2]|0:C;z=b[I>>0]|0;if(!(z<<24>>24))ia=0;else{U=I;A=0;T=z;while(1){_=(A*5|0)+(T<<24>>24)|0;U=U+1|0;T=b[U>>0]|0;if(!(T<<24>>24)){ia=_;break}else A=_}}A=f[R>>2]|0;T=(A|0)==0;d:do if(T)ja=0;else{U=A+-1|0;_=(U&A|0)==0;do if(_)ka=U&ia;else{if(ia>>>0<A>>>0){ka=ia;break}ka=(ia>>>0)%(A>>>0)|0}while(0);Z=f[(f[h>>2]|0)+(ka<<2)>>2]|0;if(!Z){ja=ka;break}Y=f[Z>>2]|0;if(!Y){ja=ka;break}Z=i?f[C+4>>2]|0:e&255;V=(Z|0)==0;if(_){if(V){W=Y;while(1){aa=f[W+4>>2]|0;if(!((aa|0)==(ia|0)|(aa&U|0)==(ka|0))){ja=ka;break d}aa=b[W+8+11>>0]|0;if(!((aa<<24>>24<0?f[W+12>>2]|0:aa&255)|0))break c;W=f[W>>2]|0;if(!W){ja=ka;break d}}}else la=Y;while(1){W=f[la+4>>2]|0;if(!((W|0)==(ia|0)|(W&U|0)==(ka|0))){ja=ka;break d}W=la+8|0;_=b[W+11>>0]|0;aa=_<<24>>24<0;$=_&255;do if(((aa?f[la+12>>2]|0:$)|0)==(Z|0)){_=f[W>>2]|0;if(aa)if(!(WKc(_,I,Z)|0))break c;else break;if((_&255)<<24>>24!=z<<24>>24)break;_=W;ea=$;da=I;do{ea=ea+-1|0;_=_+1|0;if(!ea)break c;da=da+1|0}while((b[_>>0]|0)==(b[da>>0]|0))}while(0);la=f[la>>2]|0;if(!la){ja=ka;break d}}}if(V){U=Y;while(1){$=f[U+4>>2]|0;if(($|0)!=(ia|0)){if($>>>0<A>>>0)ma=$;else ma=($>>>0)%(A>>>0)|0;if((ma|0)!=(ka|0)){ja=ka;break d}}$=b[U+8+11>>0]|0;if(!(($<<24>>24<0?f[U+12>>2]|0:$&255)|0))break c;U=f[U>>2]|0;if(!U){ja=ka;break d}}}else na=Y;while(1){U=f[na+4>>2]|0;if((U|0)!=(ia|0)){if(U>>>0<A>>>0)oa=U;else oa=(U>>>0)%(A>>>0)|0;if((oa|0)!=(ka|0)){ja=ka;break d}}U=na+8|0;V=b[U+11>>0]|0;$=V<<24>>24<0;W=V&255;do if((($?f[na+12>>2]|0:W)|0)==(Z|0)){V=f[U>>2]|0;if($)if(!(WKc(V,I,Z)|0))break c;else break;if((V&255)<<24>>24!=z<<24>>24)break;V=U;aa=W;da=I;do{aa=aa+-1|0;V=V+1|0;if(!aa)break c;da=da+1|0}while((b[V>>0]|0)==(b[da>>0]|0))}while(0);na=f[na>>2]|0;if(!na){ja=ka;break}}}while(0);I=$Xc(20)|0;lYc(I+8|0,C);f[I+4>>2]=ia;f[I>>2]=0;pa=+(((f[ca>>2]|0)+1|0)>>>0);qa=+n[ha>>2];do if(T|pa>+(A>>>0)*qa){z=(A>>>0<3|(A+-1&A|0)!=0)&1|A<<1;e=~~+X(+(pa/qa))>>>0;b0b(h,z>>>0<e>>>0?e:z);z=f[R>>2]|0;e=z+-1|0;if(!(e&z)){ra=z;sa=e&ia;break}if(ia>>>0<z>>>0){ra=z;sa=ia;break}ra=z;sa=(ia>>>0)%(z>>>0)|0}else{ra=A;sa=ja}while(0);A=(f[h>>2]|0)+(sa<<2)|0;T=f[A>>2]|0;do if(!T){f[I>>2]=f[d>>2];f[d>>2]=I;f[A>>2]=d;z=f[I>>2]|0;if(!z)break;e=f[z+4>>2]|0;z=ra+-1|0;do if(!(z&ra))ta=e&z;else{if(e>>>0<ra>>>0){ta=e;break}ta=(e>>>0)%(ra>>>0)|0}while(0);ua=(f[h>>2]|0)+(ta<<2)|0;va=122}else{f[I>>2]=f[T>>2];ua=T;va=122}while(0);if((va|0)==122){va=0;f[ua>>2]=I}f[ca>>2]=(f[ca>>2]|0)+1}while(0);N=N+1|0}while((N|0)<(f[M>>2]|0))}if((f[y>>2]|0)>0){M=c+28|0;N=k+4|0;ca=l+4|0;ua=m+4|0;va=o+4|0;ta=p+4|0;ra=q+4|0;d=r+4|0;sa=s+4|0;ja=t+4|0;ia=v+4|0;R=j+11|0;ha=c+44|0;c=k+4|0;ka=l+8|0;na=l+4|0;oa=m+4|0;ma=o+4|0;la=p+4|0;w=q+4|0;H=r+4|0;G=s+4|0;J=t+4|0;E=v+4|0;L=j+11|0;K=0;do{O=f[x>>2]|0;P=O+(K*20|0)|0;Q=f[F>>2]|0;if((Q|0)>0){B=O+(K*20|0)+8|0;S=O+(K*20|0)+4|0;C=0;T=Q;while(1){Q=f[D>>2]|0;A=f[B>>2]|0;do if((f[Q+(C<<3)>>2]|0)>(A|0))wa=T;else{if((A|0)>(f[Q+(C<<3)+4>>2]|0)){wa=T;break}e=f[S>>2]|0;z=f[(f[ha>>2]|0)+4+(C<<2)>>2]|0;i=f[P>>2]|0;Z=b[i+11>>0]|0;Y=Z<<24>>24<0;f[k>>2]=Y?f[i>>2]|0:i;f[c>>2]=Y?f[i+4>>2]|0:Z&255;Z=itc(A,ka)|0;f[l>>2]=Z;i=dJc(Z)|0;f[na>>2]=i;f[m>>2]=0;f[oa>>2]=-1;f[o>>2]=0;f[ma>>2]=-1;f[p>>2]=0;f[la>>2]=-1;f[q>>2]=0;f[w>>2]=-1;f[r>>2]=0;f[H>>2]=-1;f[s>>2]=0;f[G>>2]=-1;f[t>>2]=0;f[J>>2]=-1;f[v>>2]=0;f[E>>2]=-1;Toc(j,487549,k,l,m,o,p,q,r,s,t,v);q0b(a,e,z,1,j);if((b[L>>0]|0)<0)cYc(f[j>>2]|0);wa=f[F>>2]|0}while(0);C=C+1|0;if((C|0)>=(wa|0)){xa=P;break}else T=wa}}else xa=P;if(G2b(h,f[xa>>2]|0)|0?(T=f[O+(K*20|0)+4>>2]|0,C=f[(f[M>>2]|0)+4+(K<<2)>>2]|0,S=f[xa>>2]|0,B=b[S+11>>0]|0,A=B<<24>>24<0,f[k>>2]=A?f[S>>2]|0:S,f[N>>2]=A?f[S+4>>2]|0:B&255,f[l>>2]=0,f[ca>>2]=-1,f[m>>2]=0,f[ua>>2]=-1,f[o>>2]=0,f[va>>2]=-1,f[p>>2]=0,f[ta>>2]=-1,f[q>>2]=0,f[ra>>2]=-1,f[r>>2]=0,f[d>>2]=-1,f[s>>2]=0,f[sa>>2]=-1,f[t>>2]=0,f[ja>>2]=-1,f[v>>2]=0,f[ia>>2]=-1,Toc(j,487590,k,l,m,o,p,q,r,s,t,v),q0b(a,T,C,0,j),(b[R>>0]|0)<0):0)cYc(f[j>>2]|0);K=K+1|0}while((K|0)<(f[y>>2]|0))}y=f[h+8>>2]|0;if(y|0){K=y;do{y=K;K=f[K>>2]|0;j=y+8|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(y)}while((K|0)!=0)}K=f[h>>2]|0;f[h>>2]=0;if(!K){u=g;return}cYc(K);u=g;return}function E0b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;g=d+8|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+40|0;l=f[(f[k>>2]|0)+4>>2]|0;m=$Xc(12)|0;lYc(m,l);f[g>>2]=m;l=j+76|0;n=f[l>>2]|0;if((n|0)==(f[j+80>>2]|0))r0b(j+72|0,g);else{f[n>>2]=m;f[l>>2]=(f[l>>2]|0)+4}l=f[g>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0)o=f[l+4>>2]|0;else o=m&255;if(o|0)vYc(l,1,46)|0;o=c+32|0;m=f[o>>2]|0;n=b[m+11>>0]|0;j=n<<24>>24<0;zYc(l,j?f[m>>2]|0:m,j?f[m+4>>2]|0:n&255)|0;v2b(a,f[o>>2]|0,l,c);n=f[i>>2]|0;m=f[o>>2]|0;o=$Xc(12)|0;lYc(o,m);f[g>>2]=o;m=n+76|0;j=f[m>>2]|0;if((j|0)==(f[n+80>>2]|0))r0b(n+72|0,g);else{f[j>>2]=o;f[m>>2]=(f[m>>2]|0)+4}f[e>>2]=f[g>>2];m=e+4|0;f[m>>2]=l;f[e+8>>2]=f[k>>2];k=c+20|0;l=f[k>>2]|0;f[e+20>>2]=l;o=e+16|0;j=f[i>>2]|0;i=l*52|0;if(!i){p=0;q=l}else{l=$Xc(i)|0;f[g>>2]=l;i=j+124|0;n=f[i>>2]|0;if((n|0)==(f[j+128>>2]|0))wN(j+120|0,g);else{f[n>>2]=l;f[i>>2]=(f[i>>2]|0)+4}p=f[g>>2]|0;q=f[k>>2]|0}f[o>>2]=p;if((q|0)>0?(q=c+28|0,A2b(a,f[(f[q>>2]|0)+4>>2]|0,e,p),(f[k>>2]|0)>1):0){p=1;do{A2b(a,f[(f[q>>2]|0)+4+(p<<2)>>2]|0,e,(f[o>>2]|0)+(p*52|0)|0);p=p+1|0}while((p|0)<(f[k>>2]|0))}if(!(f[c+8>>2]&2)){f[e+12>>2]=0;r=f[m>>2]|0;s=f[e>>2]|0;f[h>>2]=6;t=h+4|0;f[t>>2]=e;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];x2b(a,r,0,s,c,g)|0;u=d;return}else{k=f[c+36>>2]|0;p=f[m>>2]|0;B2b(a,p,p,k|0?k:538480,e);r=f[m>>2]|0;s=f[e>>2]|0;f[h>>2]=6;t=h+4|0;f[t>>2]=e;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];x2b(a,r,0,s,c,g)|0;u=d;return}}function F0b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;h=u;u=u+448|0;i=h+424|0;j=h+400|0;k=h+360|0;l=h+320|0;m=h+280|0;o=h+240|0;q=h+200|0;r=h+160|0;s=h+120|0;t=h+80|0;v=h+40|0;w=h;x=h+416|0;if(!d)y=(f[a+40>>2]|0)+4|0;else y=d+4|0;z=f[y>>2]|0;y=a+4|0;A=f[y>>2]|0;B=$Xc(12)|0;lYc(B,z);f[i>>2]=B;z=A+76|0;E=f[z>>2]|0;if((E|0)==(f[A+80>>2]|0))r0b(A+72|0,i);else{f[E>>2]=B;f[z>>2]=(f[z>>2]|0)+4}z=f[i>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0)F=f[z+4>>2]|0;else F=B&255;if(F|0)vYc(z,1,46)|0;F=c+16|0;B=f[F>>2]|0;E=b[B+11>>0]|0;A=E<<24>>24<0;zYc(z,A?f[B>>2]|0:B,A?f[B+4>>2]|0:E&255)|0;v2b(a,f[F>>2]|0,z,c);E=f[y>>2]|0;B=f[F>>2]|0;A=$Xc(12)|0;lYc(A,B);f[i>>2]=A;B=E+76|0;G=f[B>>2]|0;if((G|0)==(f[E+80>>2]|0))r0b(E+72|0,i);else{f[G>>2]=A;f[B>>2]=(f[B>>2]|0)+4}f[e>>2]=f[i>>2];B=e+4|0;f[B>>2]=z;f[e+20>>2]=f[a+40>>2];z=e+40|0;f[z>>2]=f[c+40>>2];A=e+38|0;b[A>>0]=g&1;lYc(j,f[F>>2]|0);G=j+11|0;E=b[G>>0]|0;H=E<<24>>24<0;I=f[j>>2]|0;K=j+4|0;L=f[K>>2]|0;M=H?I+L|0:j+(E&255)|0;N=H?I:j;if((N|0)==(M|0)){O=L;P=E}else{E=N;do{N=b[E>>0]|0;if((N+-65&255)<26)b[E>>0]=(N&255)+32;E=E+1|0}while((E|0)!=(M|0));O=f[K>>2]|0;P=b[G>>0]|0}K=f[F>>2]|0;M=P<<24>>24<0;E=P&255;P=M?O:E;O=b[K+11>>0]|0;N=O<<24>>24<0;a:do if((P|0)==((N?f[K+4>>2]|0:O&255)|0)){L=f[j>>2]|0;I=M?L:j;H=N?f[K>>2]|0:K;Q=(P|0)==0;b:do if(M){if(!Q?WKc(I,H,P)|0:0){R=29;break a}}else if(!Q){if((L&255)<<24>>24==(b[H>>0]|0)){S=j;T=E;U=H}else{R=29;break a}while(1){T=T+-1|0;S=S+1|0;if(!T)break b;U=U+1|0;if((b[S>>0]|0)!=(b[U>>0]|0)){R=29;break a}}}while(0);V=f[e>>2]|0;W=K}else R=29;while(0);if((R|0)==29){K=f[y>>2]|0;U=$Xc(12)|0;lYc(U,j);f[i>>2]=U;S=K+76|0;T=f[S>>2]|0;if((T|0)==(f[K+80>>2]|0))r0b(K+72|0,i);else{f[T>>2]=U;f[S>>2]=(f[S>>2]|0)+4}V=f[i>>2]|0;W=f[F>>2]|0}f[e+8>>2]=V;V=f[y>>2]|0;h1b(k,W,1);W=$Xc(12)|0;lYc(W,k);f[i>>2]=W;S=V+76|0;U=f[S>>2]|0;if((U|0)==(f[V+80>>2]|0))r0b(V+72|0,i);else{f[U>>2]=W;f[S>>2]=(f[S>>2]|0)+4}f[e+12>>2]=f[i>>2];if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);S=c+8|0;W=e+37|0;if(!(f[S>>2]&16)){b[W>>0]=0;U=f[y>>2]|0;V=f[F>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=V+11|0;T=b[F>>0]|0;K=V+4|0;sYc(k,T<<24>>24<0?f[K>>2]|0:T&255);T=b[F>>0]|0;if((T<<24>>24<0?f[K>>2]|0:T&255)|0){E=0;P=0;M=T;while(1){T=b[(M<<24>>24<0?f[V>>2]|0:V)+P>>0]|0;do if(T<<24>>24!=95)if(E){N=T<<24>>24;BYc(k,((T+-97&255)<26?N+224|0:N)&255);X=0;break}else{BYc(k,T);X=0;break}else X=1;while(0);P=P+1|0;M=b[F>>0]|0;if(P>>>0>=(M<<24>>24<0?f[K>>2]|0:M&255)>>>0)break;else E=X}}X=$Xc(12)|0;lYc(X,k);f[i>>2]=X;E=U+76|0;M=f[E>>2]|0;if((M|0)==(f[U+80>>2]|0))r0b(U+72|0,i);else{f[M>>2]=X;f[E>>2]=(f[E>>2]|0)+4}f[e+16>>2]=f[i>>2];if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0)}else{b[W>>0]=1;W=f[y>>2]|0;E=f[c+32>>2]|0;X=$Xc(12)|0;lYc(X,E);f[i>>2]=X;E=W+76|0;M=f[E>>2]|0;if((M|0)==(f[W+80>>2]|0))r0b(W+72|0,i);else{f[M>>2]=X;f[E>>2]=(f[E>>2]|0)+4}f[e+16>>2]=f[i>>2]}E=e+28|0;f[E>>2]=f[c+52>>2];X=f[c+48>>2]|0;M=e+32|0;f[M>>2]=X;if((X|0)==2&(b[A>>0]|0)!=0)p0b(a,f[B>>2]|0,c,2,486516);A=e+48|0;f[A>>2]=0;X=e+56|0;f[X>>2]=0;f[e+60>>2]=0;f[e+64>>2]=0;f[e+72>>2]=0;W=e+24|0;f[W>>2]=0;U=e+80|0;f[U>>2]=0;f[e+76>>2]=0;K=f[S>>2]|0;P=e+36|0;b[P>>0]=K>>>3&1;if((K&8|0)!=0?(f[M>>2]|0)==3:0){p0b(a,f[B>>2]|0,c,4,486564);Y=f[S>>2]|0}else Y=K;c:do if(Y&512|0){if(!(Y&8)){K=f[W>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=e;J_b(K,i)}switch(f[165644+(f[E>>2]<<2)>>2]|0){case 1:{f[U>>2]=0;break c;break}case 2:{K=U;f[K>>2]=0;f[K+4>>2]=0;break c;break}case 3:{f[U>>2]=0;break c;break}case 4:{K=U;f[K>>2]=0;f[K+4>>2]=0;break c;break}case 6:{n[U>>2]=0.0;break c;break}case 5:{p[U>>3]=0.0;break c;break}case 7:{b[U>>0]=0;break c;break}case 8:{f[U>>2]=0;break c;break}case 9:{if((f[223513]|0)!=2){f[i>>2]=165456;f[i+4>>2]=125;b[i+8>>0]=0;J_b(894052,i);a_b(i)}f[U>>2]=537368;break c;break}default:break c}}f[k>>2]=0;K=f[W>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=e;J_b(K,i)}d:do switch(f[165644+(f[E>>2]<<2)>>2]|0){case 1:{K=f[c+28>>2]|0;if((b[K+11>>0]|0)<0)Z=f[K>>2]|0;else Z=K;K=aJc(Z,k,0)|0;f[U>>2]=K;break}case 2:{K=f[c+28>>2]|0;if((b[K+11>>0]|0)<0)_=f[K>>2]|0;else _=K;K=_Ic(_,k,0)|0;M=U;f[M>>2]=K;f[M+4>>2]=J;break}case 3:{M=f[c+28>>2]|0;if((b[M+11>>0]|0)<0)$=f[M>>2]|0;else $=M;M=$Ic($,k,0)|0;f[U>>2]=M;break}case 4:{M=f[c+28>>2]|0;if((b[M+11>>0]|0)<0)aa=f[M>>2]|0;else aa=M;M=RIc(aa,k,0)|0;K=U;f[K>>2]=M;f[K+4>>2]=J;break}case 6:{K=c+28|0;M=f[K>>2]|0;F=b[M+11>>0]|0;V=f[M+4>>2]|0;if(((F<<24>>24<0?V:F&255)|0)==3)if(!(LYc(M,0,-1,524109,3)|0))ba=D;else{T=f[K>>2]|0;ca=b[T+11>>0]|0;da=f[T+4>>2]|0;ea=T;R=86}else{ca=F;da=V;ea=M;R=86}do if((R|0)==86){if(((ca<<24>>24<0?da:ca&255)|0)==4){if(!(LYc(ea,0,-1,511555,4)|0)){ba=-D;break}M=f[K>>2]|0;fa=b[M+11>>0]|0;ga=f[M+4>>2]|0;ha=M}else{fa=ca;ga=da;ha=ea}if(((fa<<24>>24<0?ga:fa&255)|0)==3){if(!(LYc(ha,0,-1,524261,3)|0)){ba=C;break}M=f[K>>2]|0;ia=b[M+11>>0]|0;ja=M}else{ia=fa;ja=ha}if(ia<<24>>24<0)ka=f[ja>>2]|0;else ka=ja;ba=+mjc(+kjc(ka,k))}while(0);n[U>>2]=ba;break}case 5:{K=c+28|0;M=f[K>>2]|0;V=b[M+11>>0]|0;F=f[M+4>>2]|0;if(((V<<24>>24<0?F:V&255)|0)==3)if(!(LYc(M,0,-1,524109,3)|0))la=D;else{T=f[K>>2]|0;ma=b[T+11>>0]|0;na=f[T+4>>2]|0;oa=T;R=100}else{ma=V;na=F;oa=M;R=100}do if((R|0)==100){if(((ma<<24>>24<0?na:ma&255)|0)==4){if(!(LYc(oa,0,-1,511555,4)|0)){la=-D;break}M=f[K>>2]|0;pa=b[M+11>>0]|0;qa=f[M+4>>2]|0;ra=M}else{pa=ma;qa=na;ra=oa}if(((pa<<24>>24<0?qa:pa&255)|0)==3){if(!(LYc(ra,0,-1,524261,3)|0)){la=C;break}M=f[K>>2]|0;sa=b[M+11>>0]|0;ta=M}else{sa=pa;ta=ra}if(sa<<24>>24<0)ua=f[ta>>2]|0;else ua=ta;la=+kjc(ua,k)}while(0);p[U>>3]=la;break}case 7:{K=c+28|0;M=f[K>>2]|0;F=b[M+11>>0]|0;V=f[M+4>>2]|0;do if(((F<<24>>24<0?V:F&255)|0)==4)if(!(LYc(M,0,-1,529255,4)|0)){b[U>>0]=1;break d}else{T=f[K>>2]|0;va=b[T+11>>0]|0;wa=f[T+4>>2]|0;xa=T;break}else{va=F;wa=V;xa=M}while(0);do if(((va<<24>>24<0?wa:va&255)|0)==5){if(LYc(xa,0,-1,529249,5)|0)break;b[U>>0]=0;break d}while(0);p0b(a,f[B>>2]|0,c,4,486607);break}case 8:{f[U>>2]=0;break}case 9:{M=f[W>>2]|0;if(M|0?(f[M>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=e;J_b(M,i)}M=f[y>>2]|0;if((f[E>>2]|0)!=12){V=f[c+28>>2]|0;F=$Xc(12)|0;lYc(F,V);f[i>>2]=F;V=M+76|0;K=f[V>>2]|0;if((K|0)==(f[M+80>>2]|0))r0b(M+72|0,i);else{f[K>>2]=F;f[V>>2]=(f[V>>2]|0)+4}f[U>>2]=f[i>>2];break d}etc(l,f[c+28>>2]|0);V=$Xc(12)|0;lYc(V,l);f[i>>2]=V;F=M+76|0;K=f[F>>2]|0;if((K|0)==(f[M+80>>2]|0))r0b(M+72|0,i);else{f[K>>2]=V;f[F>>2]=(f[F>>2]|0)+4}f[U>>2]=f[i>>2];if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);break}case 10:{p0b(a,f[B>>2]|0,c,4,485930);b[P>>0]=0;break}default:{}}while(0);F=f[k>>2]|0;do if(F|0){V=f[c+28>>2]|0;K=b[V+11>>0]|0;if(K<<24>>24<0)ya=f[V+4>>2]|0;else ya=K&255;if(ya|0?(b[F>>0]|0)==0:0)break;K=f[B>>2]|0;SGa(l,486646,V);V=AYc(l,506102)|0;f[i>>2]=f[V>>2];f[i+4>>2]=f[V+4>>2];f[i+8>>2]=f[V+8>>2];f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;q0b(a,K,c,4,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0)}while(0)}while(0);ya=f[z>>2]|0;do if((ya|0)>=1){if((ya|0)>536870911&(g^1)){z=f[B>>2]|0;P=itc(536870911,k+8|0)|0;f[k>>2]=P;U=dJc(P)|0;f[k+4>>2]=U;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Toc(i,486718,k,l,m,o,q,r,s,t,v,w);q0b(a,z,c,1,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);break}if((ya+-19e3|0)>>>0<1e3?(z=f[B>>2]|0,U=itc(19e3,k+8|0)|0,f[k>>2]=U,P=dJc(U)|0,f[k+4>>2]=P,P=itc(19999,l+8|0)|0,f[l>>2]=P,U=dJc(P)|0,f[l+4>>2]=U,f[m>>2]=0,f[m+4>>2]=-1,f[o>>2]=0,f[o+4>>2]=-1,f[q>>2]=0,f[q+4>>2]=-1,f[r>>2]=0,f[r+4>>2]=-1,f[s>>2]=0,f[s+4>>2]=-1,f[t>>2]=0,f[t+4>>2]=-1,f[v>>2]=0,f[v+4>>2]=-1,f[w>>2]=0,f[w+4>>2]=-1,Toc(i,486759,k,l,m,o,q,r,s,t,v,w),q0b(a,z,c,1,i),(b[i+11>>0]|0)<0):0)cYc(f[i>>2]|0)}else p0b(a,f[B>>2]|0,c,1,486677);while(0);ya=f[S>>2]|0;z=(ya&2|0)!=0;e:do if(g){if(z)za=ya;else{p0b(a,f[B>>2]|0,c,3,486848);za=f[S>>2]|0}f[X>>2]=d;if(!(za&128))Aa=0;else{p0b(a,f[B>>2]|0,c,9,486907);Aa=0}}else{if(z){p0b(a,f[B>>2]|0,c,3,486974);Ba=f[S>>2]|0}else Ba=ya;f[A>>2]=d;if(!(Ba&128))Aa=0;else{U=f[c+44>>2]|0;do if((U|0)>=0){if((U|0)>=(f[d+56>>2]|0))break;Aa=(f[d+24>>2]|0)+(U*28|0)|0;break e}while(0);P=f[B>>2]|0;E=itc(U,k+8|0)|0;f[k>>2]=E;y=dJc(E)|0;f[k+4>>2]=y;y=f[d>>2]|0;E=b[y+11>>0]|0;W=E<<24>>24<0;f[l>>2]=W?f[y>>2]|0:y;f[l+4>>2]=W?f[y+4>>2]|0:E&255;f[m>>2]=0;f[m+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Toc(i,487033,k,l,m,o,q,r,s,t,v,w);q0b(a,P,c,9,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);Aa=0}}while(0);f[e+52>>2]=Aa;if(!(f[S>>2]&32))f[e+68>>2]=0;else{S=f[c+36>>2]|0;Aa=f[B>>2]|0;w2b(a,Aa,Aa,S|0?S:538256,e)}S=f[B>>2]|0;B=f[e>>2]|0;f[x>>2]=2;f[x+4>>2]=e;f[i>>2]=f[x>>2];f[i+4>>2]=f[x+4>>2];x2b(a,S,d,B,c,i)|0;if((b[G>>0]|0)>=0){u=h;return}cYc(f[j>>2]|0);u=h;return}function G0b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(96)|0;Q9b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+84>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function H0b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=b+84|0;if(!(f[d>>2]|0)){e=efc()|0;f[d>>2]=e}e=b+28|0;if((f[e>>2]|0)>0){d=b+68|0;g=c+44|0;h=0;do{j2b(a,(f[d>>2]|0)+(h*88|0)|0,f[(f[g>>2]|0)+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)<(f[e>>2]|0))}e=b+40|0;if((f[e>>2]|0)>0){h=b+80|0;g=c+92|0;d=0;do{k2b(a,(f[h>>2]|0)+(d*88|0)|0,f[(f[g>>2]|0)+4+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(f[e>>2]|0))}e=b+32|0;if((f[e>>2]|0)>0){d=b+72|0;g=0;do{h=f[d>>2]|0;i=h+(g*48|0)+16|0;if(!(f[i>>2]|0)){j=mfc()|0;f[i>>2]=j}j=h+(g*48|0)+24|0;i=f[j>>2]|0;if((i|0)>0){k=h+(g*48|0)+28|0;h=0;l=i;while(1){i=(f[k>>2]|0)+(h*20|0)+16|0;if(!(f[i>>2]|0)){m=ofc()|0;f[i>>2]=m;n=f[j>>2]|0}else n=l;h=h+1|0;if((h|0)>=(n|0))break;else l=n}}g=g+1|0}while((g|0)<(f[e>>2]|0))}e=b+36|0;if((f[e>>2]|0)<=0)return;g=b+76|0;b=c+76|0;c=0;do{n=f[g>>2]|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;l=n+(c*24|0)+12|0;if(!(f[l>>2]|0)){h=qfc()|0;f[l>>2]=h}h=n+(c*24|0)+20|0;if((f[h>>2]|0)>0){l=n+(c*24|0)+16|0;n=d+28|0;d=0;do{l2b(a,(f[l>>2]|0)+(d*52|0)|0,f[(f[n>>2]|0)+4+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(f[h>>2]|0))}c=c+1|0}while((c|0)<(f[e>>2]|0));return}function I0b(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;f[a>>2]=b;rgc(a+12|0);if(f[a>>2]|0){u=c;return}u_b(d,3,479317,6223);r_b(c+24|0,p_b(d,485232)|0);v_b(d);u=c;return}function J0b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=(b[e+11>>0]|0)<0?f[e>>2]|0:e;e=d*65535|0;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){h=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=h;break}else k=h}}k=i+e|0;e=f[c+4>>2]|0;a:do if(e|0){i=e+-1|0;l=(i&e|0)==0;if(!l)if(k>>>0<e>>>0)m=k;else m=(k>>>0)%(e>>>0)|0;else m=i&k;j=f[(f[c>>2]|0)+(m<<2)>>2]|0;if(j|0?(h=f[j>>2]|0,h|0):0){b:do if(l){j=h;while(1){n=f[j+4>>2]|0;o=(k|0)==(n|0);if(!(o|(n&i|0)==(m|0)))break a;if((o?(f[j+8>>2]|0)==(d|0):0)?(GIc(f[j+12>>2]|0,g)|0)==0:0){p=j;break b}j=f[j>>2]|0;if(!j)break a}}else{j=h;while(1){o=f[j+4>>2]|0;if((k|0)==(o|0)){if((f[j+8>>2]|0)==(d|0)?(GIc(f[j+12>>2]|0,g)|0)==0:0){p=j;break b}}else{if(o>>>0<e>>>0)q=o;else q=(o>>>0)%(e>>>0)|0;if((q|0)!=(m|0))break a}j=f[j>>2]|0;if(!j)break a}}while(0);h=p+16|0;i=f[h+4>>2]|0;l=a;f[l>>2]=f[h>>2];f[l+4>>2]=i;return}}while(0);p=a;f[p>>2]=0;f[p+4>>2]=0;return}function K0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;d=u;u=u+224|0;e=d+32|0;g=d+8|0;h=d;i=d+192|0;j=d+218|0;k=d+156|0;l=d+144|0;m=d+108|0;n=d+96|0;o=d+84|0;p=d+72|0;q=d+60|0;r=d+48|0;s=d+188|0;t=d+184|0;v=d+160|0;w=d+217|0;x=d+120|0;y=d+216|0;z=a+8|0;A=f[z>>2]|0;if(!(f[A+20>>2]|0)){B=$Xc(32)|0;f[e>>2]=B;f[e+8>>2]=-2147483616;f[e+4>>2]=24;C=B;D=482495;E=C+24|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+24>>0]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,A,7,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);F=0;u=d;return F|0}B=f[(f[(f[A+28>>2]|0)+4>>2]|0)+16>>2]|0;A=b[B+11>>0]|0;if(((A<<24>>24<0?f[B+4>>2]|0:A&255)|0)==20?(LYc(B,0,-1,479611,20)|0)==0:0){B=$Xc(64)|0;f[e>>2]=B;f[e+8>>2]=-2147483584;f[e+4>>2]=57;C=B;D=482520;E=C+57|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+57>>0]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);F=0;u=d;return F|0}B=f[a>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);j1b(h,B,f[B>>2]|0,f[(f[e>>2]|0)+4>>2]|0,1);if((f[h>>2]|0)==1)G=f[h+4>>2]|0;else{mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);G=f[e>>2]|0}if(!G){u_b(i,3,479317,6330);r_b(j,p_b(i,482578)|0);v_b(i)}f[k>>2]=0;f[l>>2]=0;i=l+4|0;f[i>>2]=0;f[l+8>>2]=0;j=m+11|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;B=f[z>>2]|0;do if((f[B+20>>2]|0)>0){D=m+4|0;C=l+8|0;E=e+4|0;A=e+8|0;H=e+12|0;I=e+4|0;J=e+8|0;K=e+12|0;L=e+11|0;M=e+4|0;N=g+11|0;O=a+4|0;P=0;Q=G;R=B;S=0;T=0;U=G;while(1){V=f[(f[R+28>>2]|0)+4+(P<<2)>>2]|0;W=f[V+16>>2]|0;if(!((S<<24>>24<0?T:S&255)|0))X=V;else{AYc(m,528338)|0;X=f[(f[(f[z>>2]|0)+28>>2]|0)+4+(P<<2)>>2]|0}do if(b[X+20>>0]|0){SGa(g,528049,W);V=AYc(g,528047)|0;f[e>>2]=f[V>>2];f[e+4>>2]=f[V+4>>2];f[e+8>>2]=f[V+8>>2];f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;V=b[L>>0]|0;Y=V<<24>>24<0;zYc(m,Y?f[e>>2]|0:e,Y?f[M>>2]|0:V&255)|0;if((b[L>>0]|0)<0)cYc(f[e>>2]|0);if((b[N>>0]|0)<0)cYc(f[g>>2]|0);V=f[a>>2]|0;k1b(g,V,W,f[O>>2]|0,0,1);if((f[g>>2]|0)==0?(Y=f[V>>2]|0,b[Y+22>>0]|0):0){l1b(e,Y,W,0);Y=e;V=f[Y+4>>2]|0;Z=g;f[Z>>2]=f[Y>>2];f[Z+4>>2]=V}V=g;Z=f[V>>2]|0;Y=f[V+4>>2]|0;V=h;f[V>>2]=Z;f[V+4>>2]=Y;if((Z|0)==2){f[k>>2]=Y;_=Y;break}else{_=f[k>>2]|0;break}}else{Y=b[W+11>>0]|0;Z=Y<<24>>24<0;zYc(m,Z?f[W>>2]|0:W,Z?f[W+4>>2]|0:Y&255)|0;J0b(e,f[(f[Q+8>>2]|0)+88>>2]|0,U,W);Y=(f[e>>2]|0)==2;Z=e;V=Y?f[Z+4>>2]|0:0;if(!((Y?f[Z>>2]|0:0)|0))$=0;else $=b[V+38>>0]|0?0:V;f[k>>2]=$;_=$}while(0);if(!_){aa=34;break}ba=f[_+48>>2]|0;if((ba|0)!=(Q|0)){aa=61;break}W=f[z>>2]|0;V=f[W+20>>2]|0;if((P|0)<(V+-1|0)){Z=f[_+24>>2]|0;if(Z|0?(f[Z>>2]|0)!=2:0){f[e>>2]=80424;f[I>>2]=2231;b[J>>0]=0;f[K>>2]=_;J_b(Z,e)}if((f[_+28>>2]|1|0)!=11){aa=77;break}Z=f[k>>2]|0;if((f[Z+32>>2]|0)==3){aa=83;break}Y=f[i>>2]|0;if((Y|0)==(f[C>>2]|0))n1b(l,k);else{f[Y>>2]=Z;f[i>>2]=(f[i>>2]|0)+4}Z=f[k>>2]|0;Y=f[Z+24>>2]|0;if(Y|0?(f[Y>>2]|0)!=2:0){f[e>>2]=80424;f[E>>2]=2231;b[A>>0]=0;f[H>>2]=Z;J_b(Y,e)}Y=f[Z+60>>2]|0;Z=f[z>>2]|0;ca=Y;da=f[Z+20>>2]|0;ea=Z;fa=Y}else{ca=Q;da=V;ea=W;fa=U}W=P+1|0;if((W|0)>=(da|0)){aa=97;break}P=W;Q=ca;R=ea;S=b[j>>0]|0;T=f[D>>2]|0;U=fa}if((aa|0)==34){U=f[a>>2]|0;if(b[(f[U>>2]|0)+22>>0]|0){m1b(0,f[z>>2]|0,c);ga=1;break}D=b[U+88+11>>0]|0;if(D<<24>>24<0)ha=f[U+92>>2]|0;else ha=D&255;if(!ha){SGa(g,482613,m);D=AYc(g,482803)|0;f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;q0b(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);ga=0;break}SGa(q,482613,m);D=AYc(q,482622)|0;f[p>>2]=f[D>>2];f[p+4>>2]=f[D+4>>2];f[p+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=f[a>>2]|0;U=D+88|0;T=b[U+11>>0]|0;S=T<<24>>24<0;R=zYc(p,S?f[U>>2]|0:U,S?f[D+92>>2]|0:T&255)|0;f[o>>2]=f[R>>2];f[o+4>>2]=f[R+4>>2];f[o+8>>2]=f[R+8>>2];f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;R=AYc(o,482642)|0;f[n>>2]=f[R>>2];f[n+4>>2]=f[R+4>>2];f[n+8>>2]=f[R+8>>2];f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;mYc(r,m,1,-1,m);R=r+11|0;T=b[R>>0]|0;D=T<<24>>24<0;S=zYc(n,D?f[r>>2]|0:r,D?f[r+4>>2]|0:T&255)|0;f[g>>2]=f[S>>2];f[g+4>>2]=f[S+4>>2];f[g+8>>2]=f[S+8>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;S=AYc(g,482765)|0;f[e>>2]=f[S>>2];f[e+4>>2]=f[S+4>>2];f[e+8>>2]=f[S+8>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;q0b(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[R>>0]|0)<0)cYc(f[r>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);ga=0;break}else if((aa|0)==61){if(b[ba+84>>0]|0){m1b(0,f[z>>2]|0,c);ga=1;break}SGa(o,482814,m);R=AYc(o,482829)|0;f[n>>2]=f[R>>2];f[n+4>>2]=f[R+4>>2];f[n+8>>2]=f[R+8>>2];f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;R=f[Q>>2]|0;S=b[R+11>>0]|0;T=S<<24>>24<0;D=zYc(n,T?f[R>>2]|0:R,T?f[R+4>>2]|0:S&255)|0;f[g>>2]=f[D>>2];f[g+4>>2]=f[D+4>>2];f[g+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=AYc(g,506102)|0;f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;q0b(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);ga=0;break}else if((aa|0)==77){SGa(g,482613,m);D=AYc(g,482872)|0;f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;q0b(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);ga=0;break}else if((aa|0)==83){SGa(g,482814,m);D=AYc(g,482908)|0;f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;q0b(f[a>>2]|0,(f[O>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);ga=0;break}else if((aa|0)==97){ia=f[k>>2]|0;aa=98;break}}else{ia=0;aa=98}while(0);do if((aa|0)==98){if((f[ia+32>>2]|0)!=3?(f[s>>2]=f[l>>2],f[t>>2]=f[i>>2],mi[f[(f[c>>2]|0)+96>>2]&2047](e,c),z=f[e+4>>2]|0,o=Mi[f[(f[z>>2]|0)+8>>2]&1023](z,c)|0,f[g>>2]=f[s>>2],f[e>>2]=f[t>>2],!(o1b(a,g,e,ia,m,o)|0)):0){ga=0;break}o=$Xc(4)|0;f[o>>2]=0;if(p1b(a,f[k>>2]|0,o)|0){z=f[i>>2]|0;a:do if((z|0)==(f[l>>2]|0)){ja=o;ka=o;aa=123}else{n=g+16|0;ba=e+4|0;q=e+8|0;p=e+12|0;r=o;ha=z;fa=o;ea=o;ca=o;b:while(1){la=$Xc(4)|0;f[la>>2]=0;ha=ha+-4|0;da=f[ha>>2]|0;_=f[da+24>>2]|0;if(_|0?(f[_>>2]|0)!=2:0){f[e>>2]=80424;f[ba>>2]=2231;b[q>>0]=0;f[p>>2]=da;J_b(_,e)}switch(f[da+28>>2]|0){case 11:{HZb(e,Bqc(la,f[(f[ha>>2]|0)+40>>2]|0)|0);_Yb(g,e);Oqc(r,g);if(b[n>>0]|0){u_b(v,3,479317,6459);r_b(w,p_b(q_b(p_b(p_b(v,483004)|0,483036)|0,m)|0,506102)|0);v_b(v)}$Yb(g);break}case 10:{vqc(Cqc(la,f[(f[ha>>2]|0)+40>>2]|0)|0,r);break}default:break b}if((r|0)!=(la|0))if(!r){ma=la;na=la;oa=la;pa=la}else{if(f[r>>2]|0)sqc(r);cYc(fa);ma=la;na=la;oa=la;pa=la}else{ma=r;na=ca;oa=ea;pa=fa}if((ha|0)==(f[l>>2]|0)){ja=oa;ka=ma;aa=123;break a}else{r=ma;fa=pa;ea=oa;ca=na}}u_b(x,3,479317,6472);ca=p_b(x,483092)|0;fa=f[ha>>2]|0;n=f[fa+24>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=fa;J_b(n,e)}r_b(y,s_b(ca,f[fa+28>>2]|0)|0);v_b(x);if(f[la>>2]|0)sqc(la);cYc(la);qa=0;ra=r;sa=ea}while(0);if((aa|0)==123){mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);z=f[e+4>>2]|0;vqc(Mi[f[(f[z>>2]|0)+12>>2]&1023](z,c)|0,ka);qa=1;ra=ka;sa=ja}if(!ra){ga=qa;break}else{ta=qa;ua=ra;va=sa}}else{ta=0;ua=o;va=o}if(f[ua>>2]|0)sqc(ua);cYc(va);ga=ta}while(0);if((b[j>>0]|0)<0)cYc(f[m>>2]|0);m=f[l>>2]|0;if(m|0){l=f[i>>2]|0;if((l|0)!=(m|0))f[i>>2]=l+(~((l+-4-m|0)>>>2)<<2);cYc(m)}F=ga;u=d;return F|0}function L0b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=f[a+8>>2]|0;if(!i){u_b(h,1,479317,3646);r_b(g+24|0,q_b(p_b(q_b(p_b(q_b(h,a+28|0)|0,528081)|0,b)|0,518985)|0,e)|0);v_b(h);u=g;return}else{Fh[f[(f[i>>2]|0)+12>>2]&255](i,a+28|0,b,c,d,e);u=g;return}}function M0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;j=c+28|0;if((f[j>>2]|0)>0){k=c+68|0;l=d+44|0;m=0;do{S0b(a,(f[k>>2]|0)+(m*88|0)|0,f[(f[l>>2]|0)+4+(m<<2)>>2]|0);m=m+1|0}while((m|0)<(f[j>>2]|0))}j=c+32|0;if((f[j>>2]|0)>0){m=c+72|0;l=d+60|0;k=0;do{T0b(a,(f[m>>2]|0)+(k*48|0)|0,f[(f[l>>2]|0)+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)<(f[j>>2]|0))}j=c+36|0;if((f[j>>2]|0)>0){k=c+76|0;l=d+76|0;m=0;do{n=f[k>>2]|0;o=f[(f[l>>2]|0)+4+(m<<2)>>2]|0;p=n+(m*24|0)+8|0;q=f[p>>2]|0;do if((q|0?(r=q+84|0,s=f[r>>2]|0,(s|0)!=(efc()|0)):0)?(f[(f[r>>2]|0)+92>>2]|0)==3:0){r=f[(f[p>>2]|0)+84>>2]|0;if((b[r+84>>0]|0)==0?(b[r+85>>0]|0)==0:0)break;p0b(a,f[n+(m*24|0)+4>>2]|0,o,0,480574)}while(0);m=m+1|0}while((m|0)<(f[j>>2]|0))}j=c+40|0;if((f[j>>2]|0)>0){m=c+80|0;l=d+92|0;k=0;do{U0b(a,(f[m>>2]|0)+(k*88|0)|0,f[(f[l>>2]|0)+4+(k<<2)>>2]|0);k=k+1|0}while((k|0)<(f[j>>2]|0))}j=c+84|0;k=f[j>>2]|0;if(!((k|0)!=(efc()|0)?(f[(f[j>>2]|0)+92>>2]|0)==3:0))t=19;a:do if((t|0)==19?(j=c+16|0,(f[j>>2]|0)>0):0){k=c+12|0;l=c+52|0;m=g+4|0;o=g+8|0;n=g+12|0;p=0;while(1){q=f[k>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[g>>2]=165864;f[m>>2]=2270;b[o>>0]=0;f[n>>2]=c;J_b(q,g)}q=f[(f[l>>2]|0)+(p<<2)>>2]|0;if((q|0?(r=q+84|0,q=f[r>>2]|0,(q|0)!=(efc()|0)):0)?(f[(f[r>>2]|0)+92>>2]|0)==3:0)break;r=p+1|0;if((r|0)<(f[j>>2]|0))p=r;else break a}j=f[c>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=165864;f[g+4>>2]=2270;b[g+8>>0]=0;f[g+12>>2]=c;J_b(n,g)}SGa(i,480719,f[f[(f[l>>2]|0)+(p<<2)>>2]>>2]|0);n=AYc(i,480856)|0;f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];f[h+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;q0b(a,j,d,9,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}while(0);if((f[c+44>>2]|0)!=3){u=e;return}V0b(a,c,d);u=e;return}function N0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+48|0;g=e+28|0;h=e+16|0;i=e;j=h+4|0;f[j>>2]=0;k=h+8|0;f[k>>2]=0;l=h+4|0;f[h>>2]=l;m=c+60|0;if((f[m>>2]|0)>0){n=c+28|0;o=i+12|0;p=i+11|0;q=c+4|0;r=g+11|0;s=i+11|0;t=d+44|0;v=0;do{w=f[n>>2]|0;x=w+(v*88|0)|0;lYc(i,f[x>>2]|0);f[o>>2]=x;y=P0b(h,g,i)|0;z=f[y>>2]|0;if(!z){A=$Xc(32)|0;B=A+16|0;f[B>>2]=f[i>>2];f[B+4>>2]=f[i+4>>2];f[B+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[A+28>>2]=f[o>>2];B=f[g>>2]|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=B;f[y>>2]=A;B=f[f[h>>2]>>2]|0;if(!B)C=A;else{f[h>>2]=B;C=f[y>>2]|0}UQ(f[j>>2]|0,C);f[k>>2]=(f[k>>2]|0)+1;D=A;E=1}else{D=z;E=0}if((b[p>>0]|0)<0)cYc(f[i>>2]|0);do if(!(E<<24>>24)){if((b[(f[(f[D+28>>2]|0)+16>>2]|0)+51>>0]|0)==0?(b[(f[w+(v*88|0)+16>>2]|0)+51>>0]|0)==0:0)break;z=f[q>>2]|0;SGa(i,480386,f[x>>2]|0);A=AYc(i,480411)|0;f[g>>2]=f[A>>2];f[g+4>>2]=f[A+4>>2];f[g+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q0b(a,z,d,0,g);if((b[r>>0]|0)<0)cYc(f[g>>2]|0);if((b[s>>0]|0)<0)cYc(f[i>>2]|0)}while(0);N0b(a,(f[n>>2]|0)+(v*88|0)|0,f[(f[t>>2]|0)+4+(v<<2)>>2]|0);v=v+1|0}while((v|0)<(f[m>>2]|0))}m=c+52|0;if((f[m>>2]|0)>0){v=c+20|0;t=c+4|0;n=g+11|0;s=i+11|0;r=0;do{q=Q0b(h,f[(f[v>>2]|0)+(r*88|0)>>2]|0)|0;if((q|0)!=(l|0)?(D=f[q+28>>2]|0,b[(f[D+16>>2]|0)+51>>0]|0):0){q=f[t>>2]|0;SGa(i,480386,f[D>>2]|0);D=AYc(i,480460)|0;f[g>>2]=f[D>>2];f[g+4>>2]=f[D+4>>2];f[g+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;q0b(a,q,d,0,g);if((b[n>>0]|0)<0)cYc(f[g>>2]|0);if((b[s>>0]|0)<0)cYc(f[i>>2]|0)}r=r+1|0}while((r|0)<(f[m>>2]|0))}m=c+64|0;if((f[m>>2]|0)>0){r=c+32|0;s=c+4|0;n=g+11|0;t=i+11|0;v=0;do{q=Q0b(h,f[(f[r>>2]|0)+(v*48|0)>>2]|0)|0;if((q|0)!=(l|0)?(D=f[q+28>>2]|0,b[(f[D+16>>2]|0)+51>>0]|0):0){q=f[s>>2]|0;SGa(i,480386,f[D>>2]|0);D=AYc(i,480495)|0;f[g>>2]=f[D>>2];f[g+4>>2]=f[D+4>>2];f[g+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;q0b(a,q,d,0,g);if((b[n>>0]|0)<0)cYc(f[g>>2]|0);if((b[t>>0]|0)<0)cYc(f[i>>2]|0)}v=v+1|0}while((v|0)<(f[m>>2]|0))}m=c+56|0;if((f[m>>2]|0)<=0){F=h;G=f[l>>2]|0;R0b(F,G);u=e;return}v=c+24|0;t=c+4|0;c=g+11|0;n=i+11|0;s=0;do{r=Q0b(h,f[(f[v>>2]|0)+(s*28|0)>>2]|0)|0;if((r|0)!=(l|0)?(q=f[r+28>>2]|0,b[(f[q+16>>2]|0)+51>>0]|0):0){r=f[t>>2]|0;SGa(i,480386,f[q>>2]|0);q=AYc(i,480534)|0;f[g>>2]=f[q>>2];f[g+4>>2]=f[q+4>>2];f[g+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;q0b(a,r,d,0,g);if((b[c>>0]|0)<0)cYc(f[g>>2]|0);if((b[n>>0]|0)<0)cYc(f[i>>2]|0)}s=s+1|0}while((s|0)<(f[m>>2]|0));F=h;G=f[l>>2]|0;R0b(F,G);u=e;return}function O0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;if(!(f[a+68>>2]|0)){u=d;return}i=g+4|0;f[i>>2]=0;j=g+8|0;f[j>>2]=0;k=g+4|0;f[g>>2]=k;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=$Xc(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=30;m=l;n=480123;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+30>>0]=0;l=TQ(g,e,h)|0;if(!(f[l>>2]|0)){p=$Xc(28)|0;q=p+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=q;f[l>>2]=p;q=f[f[g>>2]>>2]|0;if(!q)r=p;else{f[g>>2]=q;r=f[l>>2]|0}UQ(f[i>>2]|0,r);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=$Xc(32)|0;f[h>>2]=r;f[h+8>>2]=-2147483616;f[h+4>>2]=27;m=r;n=480154;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[r+27>>0]=0;r=TQ(g,e,h)|0;if(!(f[r>>2]|0)){l=$Xc(28)|0;q=l+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=q;f[r>>2]=l;q=f[f[g>>2]>>2]|0;if(!q)s=l;else{f[g>>2]=q;s=f[r>>2]|0}UQ(f[i>>2]|0,s);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=$Xc(32)|0;f[h>>2]=s;f[h+8>>2]=-2147483616;f[h+4>>2]=28;m=s;n=480182;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[s+28>>0]=0;s=TQ(g,e,h)|0;if(!(f[s>>2]|0)){r=$Xc(28)|0;q=r+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=q;f[s>>2]=r;q=f[f[g>>2]>>2]|0;if(!q)t=r;else{f[g>>2]=q;t=f[s>>2]|0}UQ(f[i>>2]|0,t);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=$Xc(32)|0;f[h>>2]=t;f[h+8>>2]=-2147483616;f[h+4>>2]=27;m=t;n=480211;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[t+27>>0]=0;t=TQ(g,e,h)|0;if(!(f[t>>2]|0)){s=$Xc(28)|0;q=s+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=q;f[t>>2]=s;q=f[f[g>>2]>>2]|0;if(!q)v=s;else{f[g>>2]=q;v=f[t>>2]|0}UQ(f[i>>2]|0,v);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=$Xc(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=32;m=v;n=480239;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[v+32>>0]=0;v=TQ(g,e,h)|0;if(!(f[v>>2]|0)){t=$Xc(28)|0;q=t+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[v>>2]=t;q=f[f[g>>2]>>2]|0;if(!q)w=t;else{f[g>>2]=q;w=f[v>>2]|0}UQ(f[i>>2]|0,w);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(48)|0;f[h>>2]=w;f[h+8>>2]=-2147483600;f[h+4>>2]=32;m=w;n=480239;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[w+32>>0]=0;w=TQ(g,e,h)|0;if(!(f[w>>2]|0)){v=$Xc(28)|0;q=v+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=q;f[w>>2]=v;q=f[f[g>>2]>>2]|0;if(!q)x=v;else{f[g>>2]=q;x=f[w>>2]|0}UQ(f[i>>2]|0,x);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(32)|0;f[h>>2]=x;f[h+8>>2]=-2147483616;f[h+4>>2]=30;m=x;n=480272;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[x+30>>0]=0;x=TQ(g,e,h)|0;if(!(f[x>>2]|0)){w=$Xc(28)|0;q=w+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=q;f[x>>2]=w;q=f[f[g>>2]>>2]|0;if(!q)y=w;else{f[g>>2]=q;y=f[x>>2]|0}UQ(f[i>>2]|0,y);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(32)|0;f[h>>2]=y;f[h+8>>2]=-2147483616;f[h+4>>2]=29;m=y;n=480303;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[y+29>>0]=0;y=TQ(g,e,h)|0;if(!(f[y>>2]|0)){x=$Xc(28)|0;q=x+16|0;f[q>>2]=f[h>>2];f[q+4>>2]=f[h+4>>2];f[q+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[e>>2]|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=q;f[y>>2]=x;q=f[f[g>>2]>>2]|0;if(!q)z=x;else{f[g>>2]=q;z=f[y>>2]|0}UQ(f[i>>2]|0,z);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=$Xc(32)|0;f[h>>2]=z;f[h+8>>2]=-2147483616;f[h+4>>2]=29;m=z;n=480333;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[z+29>>0]=0;z=TQ(g,e,h)|0;if(!(f[z>>2]|0)){n=$Xc(28)|0;m=n+16|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;m=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=m;f[z>>2]=n;m=f[f[g>>2]>>2]|0;if(!m)A=n;else{f[g>>2]=m;A=f[z>>2]|0}UQ(f[i>>2]|0,A);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);j=f[a+60>>2]|0;A=a+64|0;if((j|0)!=(A|0)){i=h+11|0;z=e+11|0;m=j;while(1){j=m+16|0;n=f[j>>2]|0;o=f[n+40>>2]|0;a:do if((o|0)>0){y=0;q=n;while(1){if((pIa(g,f[(f[(f[q+80>>2]|0)+(y*88|0)+48>>2]|0)+4>>2]|0)|0)!=(k|0))break;x=y+1|0;w=f[j>>2]|0;v=f[w+40>>2]|0;if((x|0)<(v|0)){y=x;q=w}else{B=x;C=v;D=w;break a}}q=f[j>>2]|0;B=y;C=f[q+40>>2]|0;D=q}else{B=0;C=o;D=n}while(0);if((B|0)==(C|0)){SGa(h,480363,f[D>>2]|0);n=AYc(h,480371)|0;f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];f[e+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;if((b[i>>0]|0)<0)cYc(f[h>>2]|0);L0b(a,f[f[j>>2]>>2]|0,c,9,e);if((b[z>>0]|0)<0)cYc(f[e>>2]|0)}n=f[m+4>>2]|0;do if(!n){o=m+8|0;q=f[o>>2]|0;if((f[q>>2]|0)==(m|0)){E=q;break}else F=o;do{o=f[F>>2]|0;F=o+8|0;q=f[F>>2]|0}while((f[q>>2]|0)!=(o|0));E=q}else{y=n;while(1){q=f[y>>2]|0;if(!q)break;else y=q}E=y}while(0);if((E|0)==(A|0))break;else m=E}}RQ(g,f[k>>2]|0);u=d;return}function P0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function Q0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function R0b(a,c){a=a|0;c=c|0;if(!c)return;R0b(a,f[c>>2]|0);R0b(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function S0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+416|0;g=e+400|0;h=e+360|0;i=e+320|0;j=e+280|0;k=e+240|0;l=e+200|0;m=e+160|0;n=e+120|0;o=e+80|0;p=e+40|0;q=e;r=c+52|0;if((f[r>>2]|0)>0){s=c+20|0;t=d+28|0;v=0;do{U0b(a,(f[s>>2]|0)+(v*88|0)|0,f[(f[t>>2]|0)+4+(v<<2)>>2]|0);v=v+1|0}while((v|0)<(f[r>>2]|0))}r=c+60|0;if((f[r>>2]|0)>0){v=c+28|0;t=d+44|0;s=0;do{S0b(a,(f[v>>2]|0)+(s*88|0)|0,f[(f[t>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[r>>2]|0))}r=c+64|0;if((f[r>>2]|0)>0){s=c+32|0;t=d+60|0;v=0;do{T0b(a,(f[s>>2]|0)+(v*48|0)|0,f[(f[t>>2]|0)+4+(v<<2)>>2]|0);v=v+1|0}while((v|0)<(f[r>>2]|0))}r=c+72|0;if((f[r>>2]|0)>0){v=c+40|0;t=d+92|0;s=0;do{U0b(a,(f[v>>2]|0)+(s*88|0)|0,f[(f[t>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[r>>2]|0))}r=(b[(f[c+16>>2]|0)+48>>0]|0)!=0;s=r?2147483647:536870911;t=r?0:0;r=c+68|0;v=f[r>>2]|0;if((v|0)<=0){u=e;return}w=c+36|0;x=d1c(s|0,t|0,1,0)|0;y=J;z=c+4|0;c=d+76|0;d=h+8|0;A=h+4|0;B=i+4|0;C=j+4|0;D=k+4|0;E=l+4|0;F=m+4|0;G=n+4|0;H=o+4|0;I=p+4|0;K=q+4|0;L=g+11|0;M=0;N=v;while(1){v=f[(f[w>>2]|0)+(M*12|0)+4>>2]|0;O=((v|0)<0)<<31>>31;if((O|0)>(y|0)|(O|0)==(y|0)&v>>>0>x>>>0){v=f[z>>2]|0;O=f[(f[c>>2]|0)+4+(M<<2)>>2]|0;P=htc(s,t,d)|0;f[h>>2]=P;Q=dJc(P)|0;f[A>>2]=Q;f[i>>2]=0;f[B>>2]=-1;f[j>>2]=0;f[C>>2]=-1;f[k>>2]=0;f[D>>2]=-1;f[l>>2]=0;f[E>>2]=-1;f[m>>2]=0;f[F>>2]=-1;f[n>>2]=0;f[G>>2]=-1;f[o>>2]=0;f[H>>2]=-1;f[p>>2]=0;f[I>>2]=-1;f[q>>2]=0;f[K>>2]=-1;Toc(g,482450,h,i,j,k,l,m,n,o,p,q);q0b(a,v,O,1,g);if((b[L>>0]|0)<0)cYc(f[g>>2]|0);R=f[r>>2]|0}else R=N;M=M+1|0;if((M|0)>=(R|0))break;else N=R}u=e;return}function T0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;e=u;u=u+96|0;g=e+72|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e;m=e+84|0;n=c+24|0;o=c+16|0;p=f[o>>2]|0;if(f[p+24>>2]&1|0?b[p+48>>0]|0:0){u=e;return}p=g+4|0;f[p>>2]=0;q=g+8|0;f[q>>2]=0;r=g+4|0;f[g>>2]=r;if((f[n>>2]|0)>0){s=c+28|0;t=i+11|0;v=j+11|0;w=k+11|0;x=c+4|0;c=h+11|0;y=0;z=0;while(1){A=f[s>>2]|0;B=A+(y*20|0)+8|0;C=f[B>>2]|0;do if(z){D=r;E=z;a:while(1){F=E;while(1){if((f[F+16>>2]|0)>=(C|0))break;G=f[F+4>>2]|0;if(!G){H=D;break a}else F=G}E=f[F>>2]|0;if(!E){H=F;break}else D=F}if((H|0)!=(r|0)?(C|0)>=(f[H+16>>2]|0):0){SGa(k,505469,f[A+(y*20|0)+4>>2]|0);D=AYc(k,482337)|0;f[j>>2]=f[D>>2];f[j+4>>2]=f[D+4>>2];f[j+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=f[B>>2]|0;E=f[r>>2]|0;do if(E){G=p;I=E;while(1){J=f[I+16>>2]|0;if((D|0)<(J|0)){K=f[I>>2]|0;if(!K){L=18;break}else{M=I;N=K}}else{if((J|0)>=(D|0)){L=22;break}O=I+4|0;J=f[O>>2]|0;if(!J){L=21;break}else{M=O;N=J}}G=M;I=N}if((L|0)==18){L=0;P=I;Q=I;break}else if((L|0)==21){L=0;P=I;Q=O;break}else if((L|0)==22){L=0;P=I;Q=G;break}}else{P=r;Q=r}while(0);E=f[Q>>2]|0;if(!E){F=$Xc(32)|0;f[F+16>>2]=D;J=F+20|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=P;f[Q>>2]=F;J=f[f[g>>2]>>2]|0;if(!J)R=F;else{f[g>>2]=J;R=f[Q>>2]|0}UQ(f[p>>2]|0,R);f[q>>2]=(f[q>>2]|0)+1;S=F}else S=E;E=S+20|0;F=b[E+11>>0]|0;J=F<<24>>24<0;K=zYc(j,J?f[E>>2]|0:E,J?f[S+24>>2]|0:F&255)|0;f[i>>2]=f[K>>2];f[i+4>>2]=f[K+4>>2];f[i+8>>2]=f[K+8>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;K=AYc(i,482369)|0;f[h>>2]=f[K>>2];f[h+4>>2]=f[K+4>>2];f[h+8>>2]=f[K+8>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;if((b[t>>0]|0)<0)cYc(f[i>>2]|0);if((b[v>>0]|0)<0)cYc(f[j>>2]|0);if((b[w>>0]|0)<0)cYc(f[k>>2]|0);if(!(b[(f[o>>2]|0)+48>>0]|0))q0b(a,f[x>>2]|0,d,1,h);else{u_b(l,2,479317,6017);r_b(m,q_b(l,h)|0);v_b(l)}if((b[c>>0]|0)<0)cYc(f[h>>2]|0);break}K=f[A+(y*20|0)+4>>2]|0;F=p;J=z;while(1){E=f[J+16>>2]|0;if((C|0)<(E|0)){T=f[J>>2]|0;if(!T){L=43;break}else{U=J;V=T}}else{if((E|0)>=(C|0)){L=47;break}W=J+4|0;E=f[W>>2]|0;if(!E){L=46;break}else{U=W;V=E}}F=U;J=V}if((L|0)==43){L=0;X=J;Y=J;Z=K;L=48;break}else if((L|0)==46){L=0;X=J;Y=W;Z=K;L=48;break}else if((L|0)==47){L=0;X=J;Y=F;Z=K;L=48;break}}else{X=r;Y=r;Z=f[A+(y*20|0)+4>>2]|0;L=48}while(0);if((L|0)==48){L=0;A=f[Y>>2]|0;if(!A){B=$Xc(32)|0;f[B+16>>2]=C;D=B+20|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=X;f[Y>>2]=B;D=f[f[g>>2]>>2]|0;if(!D)_=B;else{f[g>>2]=D;_=f[Y>>2]|0}UQ(f[p>>2]|0,_);f[q>>2]=(f[q>>2]|0)+1;$=B}else $=A;oYc($+20|0,Z)|0}y=y+1|0;A=f[r>>2]|0;if((y|0)>=(f[n>>2]|0)){aa=A;break}else z=A}}else aa=0;i1b(g,aa);u=e;return}function U0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;if(b[(f[a>>2]|0)+21>>0]|0){if(!c){u=e;return}h=f[c+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(h,g)}if(!(f[c+60>>2]|0)){u=e;return}}h=c+68|0;if(b[(f[h>>2]|0)+53>>0]|0){i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(i,g)}if((f[c+28>>2]|0)!=11)p0b(a,f[c+4>>2]|0,d,2,481606)}do if(b[(f[h>>2]|0)+52>>0]|0){if((f[c+32>>2]|0)==3){i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(i,g)}if(((f[c+28>>2]|0)+-9|0)>>>0>3)break}p0b(a,f[c+4>>2]|0,d,2,481665)}while(0);h=c+48|0;i=f[h>>2]|0;do if((i|0?(j=f[i+16>>2]|0,(j|0)!=(gfc()|0)):0)?b[(f[(f[h>>2]|0)+16>>2]|0)+48>>0]|0:0){if(!(b[c+38>>0]|0)){p0b(a,f[c+4>>2]|0,d,0,481734);break}if((f[c+32>>2]|0)==1){j=f[c+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(j,g)}if((f[c+28>>2]|0)==11)break}p0b(a,f[c+4>>2]|0,d,2,507228)}while(0);i=f[c+20>>2]|0;do if(((i|0?(j=i+84|0,k=f[j>>2]|0,(k|0)!=(efc()|0)):0)?(f[(f[j>>2]|0)+92>>2]|0)==3:0)?(j=f[h>>2]|0,j|0):0){k=f[j+8>>2]|0;if((k|0?(j=k+84|0,k=f[j>>2]|0,(k|0)!=(efc()|0)):0)?(f[(f[j>>2]|0)+92>>2]|0)==3:0)break;p0b(a,f[c+4>>2]|0,d,3,481783)}while(0);h=f[c+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(h,g)}if(((f[c+28>>2]|0)==11?b[(f[(f[c+60>>2]|0)+16>>2]|0)+51>>0]|0:0)?!(f1b(a,c,d)|0):0)p0b(a,f[c+4>>2]|0,d,9,481949);g1b(a,c,d);u=e;return}function V0b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=b+40|0;if((f[d>>2]|0)>0){e=b+80|0;g=c+92|0;h=0;do{W0b(a,(f[e>>2]|0)+(h*88|0)|0,f[(f[g>>2]|0)+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)<(f[d>>2]|0))}d=b+28|0;if((f[d>>2]|0)>0){h=b+68|0;g=c+44|0;e=0;do{X0b(a,(f[h>>2]|0)+(e*88|0)|0,f[(f[g>>2]|0)+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)<(f[d>>2]|0))}d=b+32|0;e=f[d>>2]|0;if((e|0)<=0)return;g=b+72|0;b=c+60|0;c=0;h=e;while(1){e=f[g>>2]|0;i=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if((f[e+(c*48|0)+24>>2]|0)>0?(f[(f[e+(c*48|0)+28>>2]|0)+8>>2]|0)!=0:0){p0b(a,f[e+(c*48|0)+4>>2]|0,i,9,480868);j=f[d>>2]|0}else j=h;c=c+1|0;if((c|0)>=(j|0))break;else h=j}return}function W0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e+48|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;if(b[c+38>>0]|0){l=f[(f[c+48>>2]|0)+4>>2]|0;if((f[223532]|0)!=2){f[g>>2]=165456;f[g+4>>2]=130;b[g+8>>0]=0;J_b(894128,g);a_b(g)}m=pIa(f[223533]|0,l)|0;if((m|0)==((f[223533]|0)+4|0))p0b(a,f[c+4>>2]|0,d,9,481092)}if((f[c+32>>2]|0)==2)p0b(a,f[c+4>>2]|0,d,9,481152);if(b[c+36>>0]|0)p0b(a,f[c+4>>2]|0,d,9,481195);m=c+24|0;l=f[m>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(l,g)}l=c+28|0;if((f[l>>2]|0)==14){n=f[m>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(n,g)}n=c+64|0;if(f[n>>2]|0){o=f[m>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(o,g)}if((f[(f[(f[n>>2]|0)+8>>2]|0)+44>>2]|0)!=3){o=f[c+4>>2]|0;p=f[m>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(p,g)}SGa(k,481246,f[(f[n>>2]|0)+4>>2]|0);n=AYc(k,481258)|0;f[j>>2]=f[n>>2];f[j+4>>2]=f[n+4>>2];f[j+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=f[(f[c+48>>2]|0)+4>>2]|0;p=b[n+11>>0]|0;q=p<<24>>24<0;r=zYc(j,q?f[n>>2]|0:n,q?f[n+4>>2]|0:p&255)|0;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=AYc(i,481299)|0;f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2];f[h+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;q0b(a,o,d,2,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0)}}}k=f[m>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(k,g)}if((f[l>>2]|0)!=10){u=e;return}p0b(a,f[c+4>>2]|0,d,2,481333);u=e;return}function X0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+96|0;g=e+72|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;n=c+60|0;if((f[n>>2]|0)>0){o=c+28|0;p=d+44|0;q=0;do{X0b(a,(f[o>>2]|0)+(q*88|0)|0,f[(f[p>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[n>>2]|0))}n=c+64|0;q=f[n>>2]|0;if((q|0)>0){p=c+32|0;o=d+60|0;r=0;s=q;while(1){q=f[p>>2]|0;t=f[(f[o>>2]|0)+4+(r<<2)>>2]|0;if((f[q+(r*48|0)+24>>2]|0)>0?(f[(f[q+(r*48|0)+28>>2]|0)+8>>2]|0)!=0:0){p0b(a,f[q+(r*48|0)+4>>2]|0,t,9,480868);v=f[n>>2]|0}else v=s;r=r+1|0;if((r|0)>=(v|0))break;else s=v}}v=c+52|0;if((f[v>>2]|0)>0){s=c+20|0;r=d+28|0;n=0;do{W0b(a,(f[s>>2]|0)+(n*88|0)|0,f[(f[r>>2]|0)+4+(n<<2)>>2]|0);n=n+1|0}while((n|0)<(f[v>>2]|0))}n=c+72|0;if((f[n>>2]|0)>0){r=c+40|0;s=d+92|0;o=0;do{W0b(a,(f[r>>2]|0)+(o*88|0)|0,f[(f[s>>2]|0)+4+(o<<2)>>2]|0);o=o+1|0}while((o|0)<(f[n>>2]|0))}if((f[c+68>>2]|0)>0)p0b(a,f[c+4>>2]|0,d,9,480913);if(b[(f[c+16>>2]|0)+48>>0]|0)p0b(a,f[c+4>>2]|0,d,9,480957);f[g+4>>2]=0;f[g+8>>2]=0;n=g+4|0;f[g>>2]=n;if((f[v>>2]|0)<=0){w=g;x=0;Y0b(w,x);u=e;return}o=c+20|0;s=h+11|0;r=c+4|0;c=i+11|0;p=j+11|0;t=k+11|0;q=l+11|0;y=m+11|0;z=0;do{A=f[(f[o>>2]|0)+(z*88|0)>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=A+11|0;C=b[B>>0]|0;D=A+4|0;if((C<<24>>24<0?f[D>>2]|0:C&255)|0){E=0;F=C;do{C=b[(F<<24>>24<0?f[A>>2]|0:A)+E>>0]|0;do if(C<<24>>24!=95)if((C+-65&255)<26){BYc(h,(C&255)+32&255);break}else{BYc(h,C);break}while(0);E=E+1|0;F=b[B>>0]|0}while(E>>>0<(F<<24>>24<0?f[D>>2]|0:F&255)>>>0)}if((Z0b(g,h)|0)!=(n|0)){F=f[r>>2]|0;SGa(m,480996,f[(f[o>>2]|0)+(z*88|0)>>2]|0);D=AYc(m,481032)|0;f[l>>2]=f[D>>2];f[l+4>>2]=f[D+4>>2];f[l+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=_0b(g,h)|0;E=f[f[D>>2]>>2]|0;D=b[E+11>>0]|0;B=D<<24>>24<0;A=zYc(l,B?f[E>>2]|0:E,B?f[E+4>>2]|0:D&255)|0;f[k>>2]=f[A>>2];f[k+4>>2]=f[A+4>>2];f[k+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;A=AYc(k,481057)|0;f[j>>2]=f[A>>2];f[j+4>>2]=f[A+4>>2];f[j+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;A=AYc(j,481073)|0;f[i>>2]=f[A>>2];f[i+4>>2]=f[A+4>>2];f[i+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q0b(a,F,d,9,i);if((b[c>>0]|0)<0)cYc(f[i>>2]|0);if((b[p>>0]|0)<0)cYc(f[j>>2]|0);if((b[t>>0]|0)<0)cYc(f[k>>2]|0);if((b[q>>0]|0)<0)cYc(f[l>>2]|0);if((b[y>>0]|0)<0)cYc(f[m>>2]|0)}else{F=f[o>>2]|0;A=_0b(g,h)|0;f[A>>2]=F+(z*88|0)}if((b[s>>0]|0)<0)cYc(f[h>>2]|0);z=z+1|0}while((z|0)<(f[v>>2]|0));w=g;x=f[n>>2]|0;Y0b(w,x);u=e;return}function Y0b(a,c){a=a|0;c=c|0;if(!c)return;Y0b(a,f[c>>2]|0);Y0b(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function Z0b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function _0b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=$0b(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=$Xc(32)|0;lYc(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}UQ(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function $0b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function a1b(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+48|0;c=a+36|0;d=a+24|0;e=a+12|0;g=a;h=$Xc(12)|0;i=h+4|0;f[i>>2]=0;f[h+8>>2]=0;f[h>>2]=i;f[223533]=h;i=e+8|0;j=e+4|0;k=d+11|0;l=e+11|0;m=g+11|0;n=g+5|0;o=d+11|0;p=e+11|0;q=0;r=h;while(1){h=$Xc(32)|0;f[e>>2]=h;f[i>>2]=-2147483616;f[j>>2]=16;s=h;t=481469;v=s+16|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[h+16>>0]=0;t=f[165876+(q<<2)>>2]|0;s=AYc(e,t)|0;f[d>>2]=f[s>>2];f[d+4>>2]=f[s+4>>2];f[d+8>>2]=f[s+8>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;s=TQ(r,c,d)|0;if(!(f[s>>2]|0)){v=$Xc(28)|0;w=v+16|0;f[w>>2]=f[d>>2];f[w+4>>2]=f[d+4>>2];f[w+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;w=f[c>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=w;f[s>>2]=v;w=f[f[r>>2]>>2]|0;if(!w)x=v;else{f[r>>2]=w;x=f[s>>2]|0}UQ(f[r+4>>2]|0,x);s=r+8|0;f[s>>2]=(f[s>>2]|0)+1}if((b[k>>0]|0)<0)cYc(f[d>>2]|0);if((b[l>>0]|0)<0)cYc(f[e>>2]|0);s=f[223533]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[m>>0]=5;b[g>>0]=b[481486]|0;b[g+1>>0]=b[481487]|0;b[g+2>>0]=b[481488]|0;b[g+3>>0]=b[481489]|0;b[g+4>>0]=b[481490]|0;b[n>>0]=0;w=AYc(g,481492)|0;f[e>>2]=f[w>>2];f[e+4>>2]=f[w+4>>2];f[e+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;w=AYc(e,t)|0;f[d>>2]=f[w>>2];f[d+4>>2]=f[w+4>>2];f[d+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;w=TQ(s,c,d)|0;if(!(f[w>>2]|0)){t=$Xc(28)|0;v=t+16|0;f[v>>2]=f[d>>2];f[v+4>>2]=f[d+4>>2];f[v+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;v=f[c>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=v;f[w>>2]=t;v=f[f[s>>2]>>2]|0;if(!v)y=t;else{f[s>>2]=v;y=f[w>>2]|0}UQ(f[s+4>>2]|0,y);w=s+8|0;f[w>>2]=(f[w>>2]|0)+1}if((b[o>>0]|0)<0)cYc(f[d>>2]|0);if((b[p>>0]|0)<0)cYc(f[e>>2]|0);if((b[m>>0]|0)<0)cYc(f[g>>2]|0);w=q+1|0;if(w>>>0>=8)break;q=w;r=f[223533]|0}l_b(131);u=a;return}function b1b(a){a=a|0;c1b(a);return}function c1b(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+96|0;e=c+56|0;g=c+80|0;h=c+48|0;i=c+36|0;j=c+24|0;k=c;l=c+92|0;m=a+20|0;if(!(b[(f[m>>2]|0)+49>>0]|0)){u_b(e,3,479317,6998);r_b(c+93|0,p_b(e,481376)|0);v_b(e)}e=f[a+72>>2]|0;if(e|0){n=a+28|0;d1b(g,f[(f[m>>2]|0)+8>>2]|0,e,0);switch(f[g>>2]|0){case 1:{f[n>>2]=11;f[a+60>>2]=f[g+4>>2];break}case 4:{f[n>>2]=14;f[a+64>>2]=f[g+4>>2];break}default:{}}}n=a+64|0;e=f[n>>2]|0;if(!e){u=c;return}o=a+80|0;if(f[o>>2]|0){u=c;return}p=a+76|0;if(f[p>>2]|0){lYc(g,f[e+4>>2]|0);e=KYc(g,46,-1)|0;if((e|0)!=-1){mYc(j,g,0,e,g);e=AYc(j,528338)|0;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;e=f[p>>2]|0;a=b[e+11>>0]|0;q=a<<24>>24<0;r=zYc(i,q?f[e>>2]|0:e,q?f[e+4>>2]|0:a&255)|0;a=f[r>>2]|0;e=r+4|0;f[h>>2]=f[e>>2];d[h+4>>1]=d[e+4>>1]|0;b[h+6>>0]=b[e+6>>0]|0;e=b[r+11>>0]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=g+11|0;if((b[r>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[r>>0]=0}sYc(g,0);f[g>>2]=a;a=g+4|0;f[a>>2]=f[h>>2];d[a+4>>1]=d[h+4>>1]|0;b[a+6>>0]=b[h+6>>0]|0;b[g+11>>0]=e;f[h>>2]=0;d[h+4>>1]=0;b[h+6>>0]=0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}else oYc(g,f[p>>2]|0)|0;d1b(h,f[(f[m>>2]|0)+8>>2]|0,g,0);if((f[h>>2]|0)==5)f[o>>2]=f[h+4>>2];if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(f[o>>2]|0){u=c;return}}g=f[n>>2]|0;if(!(f[g+24>>2]|0)){u_b(k,3,479317,7030);r_b(l,p_b(k,481427)|0);v_b(k);s=f[n>>2]|0}else s=g;f[o>>2]=f[s+28>>2];u=c;return}function d1b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e+12|0;h=e;lYc(g,d);d=g+11|0;i=b[d>>0]|0;j=i<<24>>24<0;k=g+4|0;if((j?f[k>>2]|0:i&255)|0?(b[(j?f[g>>2]|0:g)>>0]|0)==46:0){mYc(h,g,1,-1,g);if((b[d>>0]|0)<0){b[f[g>>2]>>0]=0;f[k>>2]=0}else{b[g>>0]=0;b[d>>0]=0}sYc(g,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2]}W$b(a,f[c+16>>2]|0,c,g);if((b[d>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function e1b(){var a=0;a=f[223533]|0;if(!a)return;RQ(a,f[a+4>>2]|0);cYc(a);return}function f1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(i,g)}i=f[c+60>>2]|0;if(f[i+72>>2]|0){j=0;u=e;return j|0}if((f[c+32>>2]|0)!=3){j=0;u=e;return j|0}if(f[i+68>>2]|0){j=0;u=e;return j|0}if(f[i+60>>2]|0){j=0;u=e;return j|0}if(f[i+64>>2]|0){j=0;u=e;return j|0}if((f[i+52>>2]|0)!=2){j=0;u=e;return j|0}k=f[i>>2]|0;h1b(h,f[c>>2]|0,0);l=AYc(h,482173)|0;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=l&255;l=m?f[k+4>>2]|0:n;o=b[g+11>>0]|0;p=o<<24>>24<0;a:do if((l|0)==((p?f[g+4>>2]|0:o&255)|0)){q=f[k>>2]|0;r=m?q:k;s=p?f[g>>2]|0:g;t=(l|0)==0;b:do if(m){if(!t?WKc(r,s,l)|0:0){v=1;break a}}else if(!t){if((q&255)<<24>>24==(b[s>>0]|0)){w=k;x=n;y=s}else{v=1;break a}while(1){x=x+-1|0;w=w+1|0;if(!x)break b;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){v=1;break a}}}while(0);v=(f[c+48>>2]|0)!=(f[i+12>>2]|0)}else v=1;while(0);if(p)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if(v){j=0;u=e;return j|0}v=f[i+20>>2]|0;i=v+88|0;if((f[v+32>>2]|0)!=1){j=0;u=e;return j|0}if((f[v+40>>2]|0)!=1){j=0;u=e;return j|0}h=f[v>>2]|0;p=b[h+11>>0]|0;if(((p<<24>>24<0?f[h+4>>2]|0:p&255)|0)!=3){j=0;u=e;return j|0}if(LYc(h,0,-1,502062,3)|0){j=0;u=e;return j|0}if((f[v+120>>2]|0)!=1){j=0;u=e;return j|0}if((f[v+128>>2]|0)!=2){j=0;u=e;return j|0}h=f[i>>2]|0;p=b[h+11>>0]|0;if(((p<<24>>24<0?f[h+4>>2]|0:p&255)|0)!=5){j=0;u=e;return j|0}if(LYc(h,0,-1,502066,5)|0){j=0;u=e;return j|0}h=f[v+24>>2]|0;do if(h|0){if((f[h>>2]|0)==2)break;f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=v;J_b(h,g)}while(0);switch(f[v+28>>2]|0){case 14:{p0b(a,f[c+4>>2]|0,d,2,482179);break}case 12:case 10:case 11:case 1:case 2:{p0b(a,f[c+4>>2]|0,d,2,482219);break}default:{}}h=v+112|0;p=f[h>>2]|0;do if(p|0){if((f[p>>2]|0)==2)break;f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=i;J_b(p,g)}while(0);if((f[v+116>>2]|0)!=14){j=1;u=e;return j|0}p=f[h>>2]|0;do if(p|0){if((f[p>>2]|0)==2)break;f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=i;J_b(p,g)}while(0);if(!(f[(f[(f[v+152>>2]|0)+28>>2]|0)+8>>2]|0)){j=1;u=e;return j|0}p0b(a,f[c+4>>2]|0,d,2,482285);j=1;u=e;return j|0}function g1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;h=f[(f[c+68>>2]|0)+56>>2]|0;if(!h){u=e;return}i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(i,g)}switch(f[c+28>>2]|0){case 16:case 6:case 18:case 3:case 4:break;default:{p0b(a,f[c+4>>2]|0,d,2,482096);u=e;return}}if((h+-1|0)>>>0<2){u=e;return}i=f[c+4>>2]|0;c=(bfc()|0)+28|0;SGa(g,482026,f[(f[c>>2]|0)+(h*20|0)>>2]|0);q0b(a,i,d,2,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);u=e;return}function h1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=c+11|0;g=b[e>>0]|0;h=c+4|0;sYc(a,g<<24>>24<0?f[h>>2]|0:g&255);g=b[e>>0]|0;if((g<<24>>24<0?f[h>>2]|0:g&255)|0){i=d^1;j=0;k=g;while(1){g=b[(k<<24>>24<0?f[c>>2]|0:c)+j>>0]|0;do if(g<<24>>24!=95)if(i){l=g<<24>>24;BYc(a,((g+-97&255)<26?l+224|0:l)&255);m=0;break}else{BYc(a,g);m=0;break}else m=1;while(0);j=j+1|0;k=b[e>>0]|0;if(j>>>0>=(k<<24>>24<0?f[h>>2]|0:k&255)>>>0)break;else i=m}}if(!d)return;d=b[a+11>>0]|0;m=d<<24>>24<0;if(m)n=f[a+4>>2]|0;else n=d&255;if(!n)return;if(m)o=f[a>>2]|0;else o=a;n=b[o>>0]|0;o=n<<24>>24;if(m)p=f[a>>2]|0;else p=a;b[p>>0]=(n+-65&255)<26?o+32|0:o;return}function i1b(a,c){a=a|0;c=c|0;if(!c)return;i1b(a,f[c>>2]|0);i1b(a,f[c+4>>2]|0);a=c+20|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function j1b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=u;u=u+16|0;i=h;if((f[c>>2]|0)!=(d|0)?(j=f[d>>2]|0,(j|0)!=0):0){g_b(j);k=j;l=0}else{k=0;l=1}j=d+16|0;m=f[j>>2]|0;n=e+11|0;f[i>>2]=(b[n>>0]|0)<0?f[e>>2]|0:e;o=X$b(m+132|0,i)|0;if(o){m=o+12|0;o=f[m>>2]|0;p=f[m+4>>2]|0;m=a;f[m>>2]=o;f[m+4>>2]=p;if(!o)q=7}else{o=a;f[o>>2]=0;f[o+4>>2]=0;q=7}if((q|0)==7){q=f[d+12>>2]|0;if(!q)r=0;else{j1b(i,c,q,e,1);q=i;c=f[q>>2]|0;o=f[q+4>>2]|0;q=a;f[q>>2]=c;f[q+4>>2]=o;r=(c|0)!=0}if(!(r|g^1)?Y$b(d,e)|0:0){d=f[j>>2]|0;f[i>>2]=(b[n>>0]|0)<0?f[e>>2]|0:e;e=X$b(d+132|0,i)|0;if(!e){s=0;t=0}else{i=e+12|0;s=f[i>>2]|0;t=f[i+4>>2]|0}i=a;f[i>>2]=s;f[i+4>>2]=t}}if(l){u=h;return}h_b(k);u=h;return}function k1b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+48|0;j=i+28|0;k=i+16|0;l=i+8|0;m=i;f[c+72>>2]=0;n=c+88|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[c+92>>2]=0}else{b[n>>0]=0;b[o>>0]=0}o=d+11|0;p=b[o>>0]|0;q=p<<24>>24<0;r=d+4|0;if((q?f[r>>2]|0:p&255)|0?(b[(q?f[d>>2]|0:d)>>0]|0)==46:0){mYc(j,d,1,-1,d);i2b(a,c,j,h);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);u=i;return}q=JYc(d,46,0)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if((q|0)==-1)oYc(j,d)|0;else{mYc(k,d,0,q,d);q=j+11|0;if((b[q>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0}else{b[j>>0]=0;b[q>>0]=0}sYc(j,0);f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2]}lYc(k,e);e=KYc(k,46,-1)|0;a:do if((e|0)==-1)s=23;else{q=k+11|0;p=k+4|0;t=j+11|0;v=j+4|0;b:do if((g|0)==1){w=e;while(1){FYc(k,w,-1)|0;x=b[q>>0]|0;y=x<<24>>24<0?f[p>>2]|0:x&255;vYc(k,1,46)|0;x=b[t>>0]|0;z=x<<24>>24<0;zYc(k,z?f[j>>2]|0:j,z?f[v>>2]|0:x&255)|0;i2b(l,c,k,h);x=f[l>>2]|0;c:do if(x|0){z=b[t>>0]|0;A=f[v>>2]|0;B=b[o>>0]|0;C=f[r>>2]|0;if((z<<24>>24<0?A:z&255)>>>0>=(B<<24>>24<0?C:B&255)>>>0)switch(x|0){case 1:case 4:{s=31;break b;break}default:break c}D=x+-1|0;if(D>>>0<8?(-87&255)>>>(D&255)&1:0){E=z;F=A;G=B;H=C;s=28;break b}}while(0);FYc(k,y,-1)|0;w=KYc(k,46,-1)|0;if((w|0)==-1){s=23;break a}}}else{w=e;while(1){FYc(k,w,-1)|0;x=b[q>>0]|0;C=x<<24>>24<0?f[p>>2]|0:x&255;vYc(k,1,46)|0;x=b[t>>0]|0;B=x<<24>>24<0;zYc(k,B?f[j>>2]|0:j,B?f[v>>2]|0:x&255)|0;i2b(l,c,k,h);x=f[l>>2]|0;if(x|0){B=b[t>>0]|0;A=f[v>>2]|0;z=b[o>>0]|0;D=f[r>>2]|0;if((B<<24>>24<0?A:B&255)>>>0>=(z<<24>>24<0?D:z&255)>>>0){s=31;break b}I=x+-1|0;if(I>>>0<8?(-87&255)>>>(I&255)&1:0){E=B;F=A;G=z;H=D;s=28;break b}}FYc(k,C,-1)|0;w=KYc(k,46,-1)|0;if((w|0)==-1){s=23;break a}}}while(0);if((s|0)==28){v=E<<24>>24<0?F:E&255;CYc(k,d,v,(G<<24>>24<0?H:G&255)-v|0)|0;i2b(m,c,k,h);v=m;t=f[v>>2]|0;p=f[v+4>>2]|0;v=l;f[v>>2]=t;f[v+4>>2]=p;if(!t)oYc(n,k)|0;v=a;f[v>>2]=t;f[v+4>>2]=p}else if((s|0)==31){p=l;v=f[p+4>>2]|0;t=a;f[t>>2]=f[p>>2];f[t+4>>2]=v}J=q}while(0);if((s|0)==23){i2b(a,c,d,h);J=k+11|0}if((b[J>>0]|0)<0)cYc(f[k>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);u=i;return}function l1b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+32|0;h=g+12|0;i=g;j=d+11|0;k=b[j>>0]|0;l=k<<24>>24<0;m=l?f[d+4>>2]|0:k&255;a:do if(m|0){k=l?f[d>>2]|0:d;n=0;o=0;while(1){p=b[k+n>>0]|0;do if(p<<24>>24>96)if(p<<24>>24<123)q=0;else break a;else{if(p<<24>>24>64)if(p<<24>>24<91|p<<24>>24==95){q=0;break}else break a;if(p<<24>>24>47)if(p<<24>>24<58){q=0;break}else break a;else if(o|p<<24>>24!=46)break a;else{q=1;break}}while(0);n=n+1|0;if(n>>>0>=m>>>0)break;else o=q}if(!q){o=c+16|0;n=f[o>>2]|0;if((b[k>>0]|0)==46){mYc(i,d,1,-1,d);p=$Xc(12)|0;lYc(p,i);f[h>>2]=p;r=n+76|0;s=f[r>>2]|0;if((s|0)==(f[n+80>>2]|0))r0b(n+72|0,h);else{f[s>>2]=p;f[r>>2]=(f[r>>2]|0)+4}r=f[h>>2]|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);t=r}else{r=$Xc(12)|0;lYc(r,d);f[h>>2]=r;p=n+76|0;s=f[p>>2]|0;if((s|0)==(f[n+80>>2]|0))r0b(n+72|0,h);else{f[s>>2]=r;f[p>>2]=(f[p>>2]|0)+4}t=f[h>>2]|0}p=KYc(t,46,-1)|0;if((p|0)==-1)if((f[223513]|0)==2){v=t;w=537368;x=537368}else{f[h>>2]=165456;f[h+4>>2]=125;b[h+8>>0]=0;J_b(894052,h);a_b(h);v=t;w=537368;x=537368}else{r=f[o>>2]|0;mYc(i,t,0,p,t);s=$Xc(12)|0;lYc(s,i);f[h>>2]=s;n=r+76|0;y=f[n>>2]|0;if((y|0)==(f[r+80>>2]|0))r0b(r+72|0,h);else{f[y>>2]=s;f[n>>2]=(f[n>>2]|0)+4}n=f[h>>2]|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);s=f[o>>2]|0;mYc(i,t,p+1|0,-1,t);p=$Xc(12)|0;lYc(p,i);f[h>>2]=p;y=s+76|0;r=f[y>>2]|0;if((r|0)==(f[s+80>>2]|0))r0b(s+72|0,h);else{f[r>>2]=p;f[y>>2]=(f[y>>2]|0)+4}y=f[h>>2]|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);v=y;w=n;x=n}AN(h,t,485176);n=x0b(c,h)|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[n+4>>2]=x;if((e|0)!=1){f[n+28>>2]=1;y=f[o>>2]|0;p=$Xc(88)|0;f[h>>2]=p;r=y+124|0;s=f[r>>2]|0;if((s|0)==(f[y+128>>2]|0))wN(y+120|0,h);else{f[s>>2]=p;f[r>>2]=(f[r>>2]|0)+4}r=f[h>>2]|0;f[n+68>>2]=r;z=r+12|0;A=z+76|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[r+4>>2]=t;f[r>>2]=v;f[r+8>>2]=n;k=gfc()|0;f[r+16>>2]=k;b[r+84>>0]=1;b[r+85>>0]=(b[((b[j>>0]|0)<0?f[d>>2]|0:d)>>0]|0)!=46&1;if((e|0)==2){f[r+68>>2]=1;k=f[o>>2]|0;p=$Xc(12)|0;f[h>>2]=p;s=k+124|0;y=f[s>>2]|0;if((y|0)==(f[k+128>>2]|0))wN(k+120|0,h);else{f[y>>2]=p;f[s>>2]=(f[s>>2]|0)+4}s=f[h>>2]|0;f[r+36>>2]=s;f[s>>2]=1;f[s+4>>2]=536870912}f[a>>2]=1;f[a+4>>2]=r;u=g;return}f[n+32>>2]=1;s=f[o>>2]|0;p=$Xc(48)|0;f[h>>2]=p;y=s+124|0;k=f[y>>2]|0;if((k|0)==(f[s+128>>2]|0))wN(s+120|0,h);else{f[k>>2]=p;f[y>>2]=(f[y>>2]|0)+4}y=f[h>>2]|0;f[n+72>>2]=y;z=y+12|0;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y+4>>2]=t;f[y>>2]=v;f[y+8>>2]=n;r=mfc()|0;f[y+16>>2]=r;b[y+20>>0]=1;b[y+21>>0]=(b[((b[j>>0]|0)<0?f[d>>2]|0:d)>>0]|0)!=46&1;f[y+24>>2]=1;r=f[o>>2]|0;p=$Xc(20)|0;f[h>>2]=p;k=r+124|0;s=f[k>>2]|0;if((s|0)==(f[r+128>>2]|0))wN(r+120|0,h);else{f[s>>2]=p;f[k>>2]=(f[k>>2]|0)+4}k=f[h>>2]|0;f[y+28>>2]=k;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;p=f[o>>2]|0;s=$Xc(32)|0;f[i>>2]=s;f[i+8>>2]=-2147483616;f[i+4>>2]=17;z=s;r=485195;A=z+17|0;do{b[z>>0]=b[r>>0]|0;z=z+1|0;r=r+1|0}while((z|0)<(A|0));b[s+17>>0]=0;r=$Xc(12)|0;lYc(r,i);f[h>>2]=r;n=p+76|0;B=f[n>>2]|0;if((B|0)==(f[p+80>>2]|0))r0b(p+72|0,h);else{f[B>>2]=r;f[n>>2]=(f[n>>2]|0)+4}f[k>>2]=f[h>>2];if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);n=b[x+11>>0]|0;if(n<<24>>24<0)C=f[w+4>>2]|0;else C=n&255;if(C){n=f[o>>2]|0;AN(i,w,485213);r=$Xc(12)|0;lYc(r,i);f[h>>2]=r;B=n+76|0;D=f[B>>2]|0;if((D|0)==(f[n+80>>2]|0))r0b(n+72|0,h);else{f[D>>2]=r;f[B>>2]=(f[B>>2]|0)+4}f[k+4>>2]=f[h>>2];if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}else f[k+4>>2]=f[k>>2];f[k+8>>2]=0;f[k+12>>2]=y;B=ofc()|0;f[k+16>>2]=B;f[a>>2]=4;f[a+4>>2]=y;u=g;return}}while(0);i=a;f[i>>2]=0;f[i+4>>2]=0;u=g;return}function m1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;e=a;g=a+8|0;h=a+24|0;i=a+48|0;mi[f[(f[d>>2]|0)+96>>2]&2047](e,d);j=f[e>>2]|0;k=$Xc(32)|0;f[g>>2]=k;f[g+8>>2]=-2147483616;f[g+4>>2]=20;l=k;m=479611;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+20>>0]=0;J0b(e,f[(f[j+8>>2]|0)+88>>2]|0,j,g);j=(f[e>>2]|0)==2;k=e;m=j?f[k+4>>2]|0:0;if(!((j?f[k>>2]|0:0)|0))o=0;else o=b[m+38>>0]|0?0:m;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(!o){u_b(h,3,479317,6491);r_b(i,p_b(h,485146)|0);v_b(h)}mi[f[(f[d>>2]|0)+96>>2]&2047](e,d);h=f[e+4>>2]|0;e=hh[f[(f[h>>2]|0)+300>>2]&127](h,d,o,0)|0;mi[f[(f[e>>2]|0)+72>>2]&2047](e,c);u=a;return}function n1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function o1b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+96|0;j=i+64|0;k=i+48|0;l=i;m=i+44|0;n=i+40|0;o=i+36|0;p=i+32|0;q=i+8|0;r=i+80|0;if((f[c>>2]|0)==(f[d>>2]|0)){s=f[h>>2]|0;t=e+40|0;if(!s){v=1;u=i;return v|0}w=f[s>>2]|0;x=w;y=(f[s+4>>2]|0)-w>>4;w=0;while(1){if((w|0)>=(y|0)){v=1;z=12;break}if((f[x+(w<<4)>>2]|0)==(f[t>>2]|0))break;else w=w+1|0}if((z|0)==12){u=i;return v|0}SGa(k,482613,g);w=AYc(k,485127)|0;f[j>>2]=f[w>>2];f[j+4>>2]=f[w+4>>2];f[j+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[a+8>>2]|0,7,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);v=0;u=i;return v|0}w=j+4|0;t=j+8|0;x=j+12|0;y=0;a:while(1){s=f[h>>2]|0;if(!s)A=0;else A=(f[s+4>>2]|0)-(f[s>>2]|0)>>4;if((y|0)>=(A|0)){v=1;z=12;break}B=f[s>>2]|0;s=f[f[c>>2]>>2]|0;b:do if((f[B+(y<<4)>>2]|0)==(f[s+40>>2]|0)){C=f[s+24>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[j>>2]=80424;f[w>>2]=2231;b[t>>0]=0;f[x>>2]=s;J_b(C,j)}D=f[s+28>>2]|0;switch(D|0){case 11:break;case 10:{if((f[B+(y<<4)+4>>2]|0)!=4)break b;f[o>>2]=(f[c>>2]|0)+4;f[p>>2]=f[d>>2];C=f[B+(y<<4)+8>>2]|0;f[k>>2]=f[o>>2];f[j>>2]=f[p>>2];if(o1b(a,k,j,e,g,C)|0)break b;else{v=0;z=12;break a}break}default:{z=30;break a}}if((f[B+(y<<4)+4>>2]|0)==3){f[l>>2]=0;C=f[B+(y<<4)+8>>2]|0;E=b[C+11>>0]|0;F=E<<24>>24<0;if(Fqc(l,F?f[C>>2]|0:C,F?f[C+4>>2]|0:E&255)|0?(f[m>>2]=(f[c>>2]|0)+4,f[n>>2]=f[d>>2],f[k>>2]=f[m>>2],f[j>>2]=f[n>>2],!(o1b(a,k,j,e,g,l)|0)):0)G=1;else G=0;if(f[l>>2]|0)sqc(l);if(G|0){v=0;z=12;break a}}}while(0);y=y+1|0}if((z|0)==12){u=i;return v|0}else if((z|0)==30){u_b(q,3,479317,6551);r_b(r,s_b(p_b(q,483092)|0,D)|0);v_b(q);v=0;u=i;return v|0}return 0}function p1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+112|0;g=e;h=e+88|0;i=e+76|0;j=e+64|0;k=e+52|0;l=e+40|0;m=e+28|0;o=e+16|0;q=c+24|0;r=f[q>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(r,g)}r=c+28|0;a:do switch(f[165644+(f[r>>2]<<2)>>2]|0){case 1:{t=a+8|0;v=f[t>>2]|0;w=f[v+8>>2]|0;if(w&8|0){x=v+48|0;y=f[x>>2]|0;z=f[x+4>>2]|0;if(!(z>>>0>0|(z|0)==0&y>>>0>2147483647)){z=f[c+40>>2]|0;x=f[q>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(x,g)}q1b(0,z,y,f[r>>2]|0,d);break a}SGa(h,483132,f[c+4>>2]|0);y=AYc(h,506102)|0;f[g>>2]=f[y>>2];f[g+4>>2]=f[y+4>>2];f[g+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}if(!(w&16)){SGa(h,483170,f[c+4>>2]|0);w=AYc(h,506102)|0;f[g>>2]=f[w>>2];f[g+4>>2]=f[w+4>>2];f[g+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}w=v+56|0;v=f[w>>2]|0;y=f[w+4>>2]|0;if(!((y|0)<-1|(y|0)==-1&v>>>0<2147483648)){y=f[c+40>>2]|0;w=f[q>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(w,g)}q1b(0,y,v,f[r>>2]|0,d);break a}SGa(h,483132,f[c+4>>2]|0);v=AYc(h,506102)|0;f[g>>2]=f[v>>2];f[g+4>>2]=f[v+4>>2];f[g+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}case 2:{t=a+8|0;v=f[t>>2]|0;y=f[v+8>>2]|0;if(!(y&8)){if(y&16|0){y=f[c+40>>2]|0;w=v+56|0;z=f[w>>2]|0;x=f[w+4>>2]|0;w=f[q>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(w,g)}r1b(0,y,z,x,f[r>>2]|0,d);break a}SGa(h,483249,f[c+4>>2]|0);x=AYc(h,506102)|0;f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];f[g+8>>2]=f[x+8>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}else{x=v+48|0;v=f[x>>2]|0;z=f[x+4>>2]|0;if((z|0)>=0){x=f[c+40>>2]|0;y=f[q>>2]|0;if(y|0?(f[y>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(y,g)}r1b(0,x,v,z,f[r>>2]|0,d);break a}SGa(h,483211,f[c+4>>2]|0);z=AYc(h,506102)|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];f[g+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}break}case 3:{t=a+8|0;z=f[t>>2]|0;if(!(f[z+8>>2]&8)){SGa(h,483329,f[c+4>>2]|0);v=AYc(h,506102)|0;f[g>>2]=f[v>>2];f[g+4>>2]=f[v+4>>2];f[g+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}v=z+48|0;z=f[v>>2]|0;x=f[v+4>>2]|0;if(!(x>>>0>0|(x|0)==0&z>>>0>4294967295)){x=f[c+40>>2]|0;v=f[q>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(v,g)}s1b(0,x,z,f[r>>2]|0,d);break a}SGa(h,483290,f[c>>2]|0);z=AYc(h,506102)|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];f[g+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}case 4:{t=a+8|0;z=f[t>>2]|0;if(f[z+8>>2]&8|0){x=f[c+40>>2]|0;v=z+48|0;z=f[v>>2]|0;y=f[v+4>>2]|0;v=f[q>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(v,g)}t1b(0,x,z,y,f[r>>2]|0,d);break a}SGa(h,483384,f[c+4>>2]|0);y=AYc(h,506102)|0;f[g>>2]=f[y>>2];f[g+4>>2]=f[y+4>>2];f[g+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}case 6:{t=a+8|0;y=f[t>>2]|0;z=f[y+8>>2]|0;do if(!(z&32)){if(z&8|0){x=y+48|0;B=+((f[x>>2]|0)>>>0)+4294967296.0*+((f[x+4>>2]|0)>>>0);break}if(z&16|0){x=y+56|0;B=+((f[x>>2]|0)>>>0)+4294967296.0*+(f[x+4>>2]|0);break}SGa(h,483439,f[c+4>>2]|0);x=AYc(h,506102)|0;f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];f[g+8>>2]=f[x+8>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}else B=+p[y+64>>3];while(0);zqc(d,f[c+40>>2]|0,(n[s>>2]=B,f[s>>2]|0));break}case 5:{y=a+8|0;t=f[y>>2]|0;z=f[t+8>>2]|0;do if(!(z&32)){if(z&8|0){x=t+48|0;C=+((f[x>>2]|0)>>>0)+4294967296.0*+((f[x+4>>2]|0)>>>0);break}if(z&16|0){x=t+56|0;C=+((f[x>>2]|0)>>>0)+4294967296.0*+(f[x+4>>2]|0);break}SGa(h,483479,f[c+4>>2]|0);x=AYc(h,506102)|0;f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];f[g+8>>2]=f[x+8>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[y>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}else C=+p[t+64>>3];while(0);p[s>>3]=C;Aqc(d,f[c+40>>2]|0,f[s>>2]|0,f[s+4>>2]|0);break}case 7:{t=a+8|0;y=f[t>>2]|0;if(!(f[y+8>>2]&1)){SGa(h,483520,f[c+4>>2]|0);z=AYc(h,506102)|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];f[g+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}z=f[y+32>>2]|0;y=b[z+11>>0]|0;x=f[z+4>>2]|0;if(((y<<24>>24<0?x:y&255)|0)==4)if(!(LYc(z,0,-1,529255,4)|0)){D=1;E=0}else{v=f[(f[t>>2]|0)+32>>2]|0;F=b[v+11>>0]|0;G=f[v+4>>2]|0;H=v;I=112}else{F=y;G=x;H=z;I=112}do if((I|0)==112){if(((F<<24>>24<0?G:F&255)|0)==5?(LYc(H,0,-1,529249,5)|0)==0:0){D=0;E=0;break}SGa(h,483566,f[c+4>>2]|0);z=AYc(h,506102)|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];f[g+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}while(0);yqc(d,f[c+40>>2]|0,D,E);break}case 8:{t=a+8|0;if(!(f[(f[t>>2]|0)+8>>2]&1)){SGa(h,483619,f[c+4>>2]|0);z=AYc(h,506102)|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];f[g+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}z=f[q>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(z,g)}z=c+64|0;x=f[z>>2]|0;y=f[(f[t>>2]|0)+32>>2]|0;v=x+8|0;w=f[(f[v>>2]|0)+8>>2]|0;if((f[223534]|0)!=2){f[g>>2]=165456;f[g+4>>2]=132;b[g+8>>0]=0;J_b(894136,g);a_b(g)}if((w|0)==(f[223535]|0)){J0b(g,f[(f[v>>2]|0)+88>>2]|0,x,y);v=(f[g>>2]|0)==5;w=g;if((v?f[w>>2]|0:0)|0){J=v?f[w+4>>2]|0:0;I=154}}else{w=x+4|0;lYc(g,f[w>>2]|0);v=g+11|0;K=b[v>>0]|0;L=f[x>>2]|0;M=b[L+11>>0]|0;if(M<<24>>24<0)N=f[L+4>>2]|0;else N=M&255;uYc(g,(K<<24>>24<0?f[g+4>>2]|0:K&255)-N|0,0);K=y+11|0;M=b[K>>0]|0;L=M<<24>>24<0;O=y+4|0;zYc(g,L?f[y>>2]|0:y,L?f[O>>2]|0:M&255)|0;M=f[a>>2]|0;j1b(h,M,f[M>>2]|0,g,1);if((f[h>>2]|0)==5){M=f[h+4>>2]|0;if((f[M+12>>2]|0)==(x|0)){P=M;Q=0}else{SGa(o,481246,f[w>>2]|0);w=AYc(o,483669)|0;f[m>>2]=f[w>>2];f[m+4>>2]=f[w+4>>2];f[m+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;w=b[K>>0]|0;K=w<<24>>24<0;M=zYc(m,K?f[y>>2]|0:y,K?f[O>>2]|0:w&255)|0;f[l>>2]=f[M>>2];f[l+4>>2]=f[M+4>>2];f[l+8>>2]=f[M+8>>2];f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;M=AYc(l,483692)|0;f[k>>2]=f[M>>2];f[k+4>>2]=f[M+4>>2];f[k+8>>2]=f[M+8>>2];f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;M=f[c+4>>2]|0;w=b[M+11>>0]|0;O=w<<24>>24<0;K=zYc(k,O?f[M>>2]|0:M,O?f[M+4>>2]|0:w&255)|0;f[j>>2]=f[K>>2];f[j+4>>2]=f[K+4>>2];f[j+8>>2]=f[K+8>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;K=AYc(j,483707)|0;f[i>>2]=f[K>>2];f[i+4>>2]=f[K+4>>2];f[i+8>>2]=f[K+8>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);P=0;Q=1}}else{P=0;Q=0}if((b[v>>0]|0)<0)cYc(f[g>>2]|0);if(!Q){J=P;I=154}else{A=0;u=e;return A|0}}if((I|0)==154?J|0:0){v=f[J+8>>2]|0;yqc(d,f[c+40>>2]|0,v,((v|0)<0)<<31>>31);break a}v=f[q>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(v,g)}SGa(m,481246,f[(f[z>>2]|0)+4>>2]|0);z=AYc(m,483669)|0;f[l>>2]=f[z>>2];f[l+4>>2]=f[z+4>>2];f[l+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;z=b[y+11>>0]|0;v=z<<24>>24<0;K=zYc(l,v?f[y>>2]|0:y,v?f[y+4>>2]|0:z&255)|0;f[k>>2]=f[K>>2];f[k+4>>2]=f[K+4>>2];f[k+8>>2]=f[K+8>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;K=AYc(k,483692)|0;f[j>>2]=f[K>>2];f[j+4>>2]=f[K+4>>2];f[j+8>>2]=f[K+8>>2];f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;K=f[c+4>>2]|0;z=b[K+11>>0]|0;y=z<<24>>24<0;v=zYc(j,y?f[K>>2]|0:K,y?f[K+4>>2]|0:z&255)|0;f[i>>2]=f[v>>2];f[i+4>>2]=f[v+4>>2];f[i+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;v=AYc(i,506102)|0;f[h>>2]=f[v>>2];f[h+4>>2]=f[v+4>>2];f[h+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);A=0;u=e;return A|0}case 9:{t=a+8|0;v=f[t>>2]|0;if(f[v+8>>2]&2|0){z=f[v+36>>2]|0;oYc(Bqc(d,f[c+40>>2]|0)|0,z)|0;break a}SGa(h,483758,f[c+4>>2]|0);z=AYc(h,506102)|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];f[g+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[t>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);A=0;u=e;return A|0}case 10:{if(!(v1b(a,c,d)|0)){A=0;u=e;return A|0}break}default:{}}while(0);A=1;u=e;return A|0}function q1b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=u;u=u+32|0;f=a;switch(d|0){case 5:{yqc(e,b,c,((c|0)<0)<<31>>31);u=a;return}case 15:{zqc(e,b,c);u=a;return}case 17:{yqc(e,b,c<<1^c>>31,0);u=a;return}default:{u_b(f,3,479317,6886);r_b(a+24|0,s_b(p_b(f,485089)|0,d)|0);v_b(f);u=a;return}}}function r1b(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=u;u=u+32|0;g=a;switch(e|0){case 3:{yqc(f,b,c,d);u=a;return}case 16:{Aqc(f,b,c,d);u=a;return}case 18:{h=u1c(c|0,d|0,1)|0;i=J;yqc(f,b,h^(k1c(c|0,d|0,63)|0),i^J);u=a;return}default:{u_b(g,3,479317,6908);r_b(a+24|0,s_b(p_b(g,485051)|0,e)|0);v_b(g);u=a;return}}}function s1b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=u;u=u+32|0;f=a;switch(d|0){case 13:{yqc(e,b,c,0);u=a;return}case 7:{zqc(e,b,c);u=a;return}default:{u_b(f,3,479317,6925);r_b(a+24|0,s_b(p_b(f,485012)|0,d)|0);v_b(f);u=a;return}}}function t1b(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a=u;u=u+32|0;g=a;switch(e|0){case 4:{yqc(f,b,c,d);u=a;return}case 6:{Aqc(f,b,c,d);u=a;return}default:{u_b(g,3,479317,6942);r_b(a+24|0,s_b(p_b(g,484973)|0,e)|0);v_b(g);u=a;return}}}function u1b(){var a=0,c=0;a=$Xc(52)|0;Mfc(a);f[223536]=a;c=$Xc(40)|0;g2b(c,a,0);f[223535]=c;b[c+21>>0]=1;b[c+20>>0]=0;l_b(133);return}function v1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+144|0;g=e+120|0;h=e+104|0;i=e+68|0;j=e+48|0;k=e+12|0;l=e;m=e+80|0;n=e+137|0;o=e+24|0;p=e+136|0;q=a+8|0;if(!(f[(f[q>>2]|0)+8>>2]&4)){SGa(l,482613,f[c+4>>2]|0);r=AYc(l,483806)|0;f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=f[c>>2]|0;s=b[r+11>>0]|0;t=s<<24>>24<0;v=zYc(k,t?f[r>>2]|0:r,t?f[r+4>>2]|0:s&255)|0;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2];f[j+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;v=AYc(j,483867)|0;f[i>>2]=f[v>>2];f[i+4>>2]=f[v+4>>2];f[i+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;v=f[c>>2]|0;s=b[v+11>>0]|0;r=s<<24>>24<0;t=zYc(i,r?f[v>>2]|0:v,r?f[v+4>>2]|0:s&255)|0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];f[h+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;t=AYc(h,483939)|0;f[g>>2]=f[t>>2];f[g+4>>2]=f[t+4>>2];f[g+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[q>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);w=0;u=e;return w|0}t=c+24|0;s=f[t>>2]|0;if(s|0?(f[s>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(s,g)}s=pgc(a+12|0,f[c+60>>2]|0)|0;v=_i[f[(f[s>>2]|0)+12>>2]&2047](s)|0;s=(v|0)==0;if(s){u_b(m,3,479317,6840);r=p_b(p_b(m,483954)|0,483992)|0;b[g>>0]=0;b[g+1>>0]=0;b[g+2>>0]=0;w1b(h,c,g);r_b(n,q_b(r,h)|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);v_b(m)}f[h>>2]=165916;m=h+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[i>>2]=165940;f[i+4>>2]=f[a>>2];Kpc(j,0);f[j>>2]=h;f[j+4>>2]=i;if(jqc(j,f[(f[q>>2]|0)+40>>2]|0,v)|0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;TZb(v,k)|0;i=f[t>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(i,g)}i=c+28|0;if((f[i>>2]|0)==11){oYc(Bqc(d,f[c+40>>2]|0)|0,k)|0;x=k+11|0}else{r=f[t>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(r,g)}if((f[i>>2]|0)!=10){u_b(o,3,479317,6860);r_b(p,p_b(o,484068)|0);v_b(o)}o=Cqc(d,f[c+40>>2]|0)|0;d=k+11|0;p=b[d>>0]|0;i=p<<24>>24<0;Fqc(o,i?f[k>>2]|0:k,i?f[k+4>>2]|0:p&255)|0;x=d}if((b[x>>0]|0)<0)cYc(f[k>>2]|0);y=1;z=m+11|0}else{SGa(l,484025,f[c>>2]|0);c=AYc(l,484064)|0;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[k+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=m+11|0;x=b[c>>0]|0;d=x<<24>>24<0;p=zYc(k,d?f[m>>2]|0:m,d?f[h+8>>2]|0:x&255)|0;f[g>>2]=f[p>>2];f[g+4>>2]=f[p+4>>2];f[g+8>>2]=f[p+8>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;q0b(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[q>>2]|0,8,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);y=0;z=c}Lpc(j);f[h>>2]=165916;if((b[z>>0]|0)<0)cYc(f[m>>2]|0);if(s){w=y;u=e;return w|0}Yi[f[(f[v>>2]|0)+4>>2]&4095](v);w=y;u=e;return w|0}function w1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+400|0;g=e+360|0;h=e+320|0;i=e+280|0;j=e+240|0;k=e+200|0;l=e+160|0;m=e+120|0;n=e+80|0;o=e+40|0;p=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;q=c+38|0;if(!(b[q>>0]|0))r=0;else{s=f[(f[c+48>>2]|0)+4>>2]|0;t=b[s+11>>0]|0;v=t<<24>>24<0;f[g>>2]=v?f[s>>2]|0:s;f[g+4>>2]=v?f[s+4>>2]|0:t&255;f[h>>2]=0;f[h+4>>2]=-1;f[i>>2]=0;f[i+4>>2]=-1;f[j>>2]=0;f[j+4>>2]=-1;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;Uoc(a,484281,g,h,i,j,k,l,m,n,o,p);r=1}D1b(c,r,0,a,d);if(!(b[q>>0]|0)){u=e;return}AYc(a,505406)|0;u=e;return}function x1b(a){a=a|0;cYc(a);return}function y1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+8|0;h=e;i=a+4|0;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);c=f[g>>2]|0;k1b(h,f[i>>2]|0,d,f[c+4>>2]|0,0,1);switch(f[h>>2]|0){case 2:{d=f[h+4>>2]|0;j=(b[d+38>>0]|0)==0?0:d;u=e;return j|0}case 1:{if(!(b[(f[c+16>>2]|0)+48>>0]|0)){j=0;u=e;return j|0}d=f[h+4>>2]|0;h=d+72|0;if((f[h>>2]|0)<=0){j=0;u=e;return j|0}i=d+40|0;a=g+4|0;k=g+8|0;l=g+12|0;m=g+4|0;n=g+8|0;o=g+12|0;p=0;while(1){q=f[i>>2]|0;r=q+(p*88|0)|0;if((f[q+(p*88|0)+48>>2]|0)==(c|0)){s=q+(p*88|0)+24|0;t=f[s>>2]|0;if(t|0?(f[t>>2]|0)!=2:0){f[g>>2]=80424;f[m>>2]=2231;b[n>>0]=0;f[o>>2]=r;J_b(t,g)}if((f[q+(p*88|0)+28>>2]|0)==11?(f[q+(p*88|0)+32>>2]|0)==1:0){t=f[s>>2]|0;if(t|0?(f[t>>2]|0)!=2:0){f[g>>2]=80424;f[a>>2]=2231;b[k>>0]=0;f[l>>2]=r;J_b(t,g)}if((f[q+(p*88|0)+60>>2]|0)==(d|0)){j=r;v=19;break}}}p=p+1|0;if((p|0)>=(f[h>>2]|0)){j=0;v=19;break}}if((v|0)==19){u=e;return j|0}break}default:{j=0;u=e;return j|0}}return 0}function z1b(a){a=a|0;var c=0;f[a>>2]=165916;c=a+4|0;if((b[c+11>>0]|0)>=0)return;cYc(f[c>>2]|0);return}function A1b(a){a=a|0;var c=0;f[a>>2]=165916;c=a+4|0;if((b[c+11>>0]|0)>=0){cYc(a);return}cYc(f[c>>2]|0);cYc(a);return}function B1b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;d=a+4|0;c=b[d+11>>0]|0;if(c<<24>>24<0)g=f[a+8>>2]|0;else g=c&255;if(g|0)AYc(d,484220)|0;g=b[e+11>>0]|0;c=g<<24>>24<0;zYc(d,c?f[e>>2]|0:e,c?f[e+4>>2]|0:g&255)|0;return}function C1b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function D1b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=u;u=u+576|0;i=h+536|0;j=h+524|0;k=h+512|0;l=h+472|0;m=h+400|0;n=h+360|0;o=h+320|0;p=h+280|0;q=h+240|0;r=h+200|0;s=h+160|0;t=h+120|0;v=h+80|0;w=h+40|0;x=h;y=c<<1;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(y>>>0>4294967279)jYc(j);if(y>>>0<11){b[j+11>>0]=y;if(!c)z=j;else{A=j;B=6}}else{C=y+16&-16;D=$Xc(C)|0;f[j>>2]=D;f[j+8>>2]=C|-2147483648;f[j+4>>2]=y;A=D;B=6}if((B|0)==6){g1c(A|0,32,y|0)|0;z=A}b[z+y>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;y=a+24|0;z=f[y>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(z,i)}z=a+28|0;if((f[z>>2]|0)==11?(A=a+60|0,(b[(f[(f[A>>2]|0)+16>>2]|0)+51>>0]|0)!=0):0){D=f[y>>2]|0;if(D|0?(f[D>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(D,i)}E1b(m,f[(f[A>>2]|0)+20>>2]|0);D=m+11|0;C=b[D>>0]|0;E=C<<24>>24<0;f[l>>2]=E?f[m>>2]|0:m;f[l+4>>2]=E?f[m+4>>2]|0:C&255;C=f[y>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(C,i)}E1b(o,(f[(f[A>>2]|0)+20>>2]|0)+88|0);A=o+11|0;C=b[A>>0]|0;E=C<<24>>24<0;f[n>>2]=E?f[o>>2]|0:o;f[n+4>>2]=E?f[o+4>>2]|0:C&255;f[i>>2]=0;f[i+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Uoc(k,484295,l,n,i,p,q,r,s,t,v,w);if((b[A>>0]|0)<0)cYc(f[o>>2]|0);if((b[D>>0]|0)<0)cYc(f[m>>2]|0)}else{E1b(i,a);D=k+11|0;if((b[D>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0}else{b[k>>0]=0;b[D>>0]=0}sYc(k,0);f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2]}D=a+32|0;if((f[D>>2]|0)==1)if((d|0)!=1?(f[(f[a+20>>2]|0)+44>>2]|0)!=3:0)B=30;else B=35;else B=30;do if((B|0)==30){d=f[y>>2]|0;if(d|0?(f[d>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(d,i)}if((f[z>>2]|0)==11?b[(f[(f[a+60>>2]|0)+16>>2]|0)+51>>0]|0:0){B=35;break};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;tYc(l,f[165840+(f[D>>2]<<2)>>2]|0)|0;BYc(l,32);F=l}while(0);if((B|0)==35){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;F=l}D=m+4|0;d=m+20|0;A=d;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));A=m+56|0;b[A>>0]=b[g>>0]|0;b[A+1>>0]=b[g+1>>0]|0;b[A+2>>0]=b[g+2>>0]|0;A=m+60|0;lYc(A,j);if(!(b[g>>0]|0))G=0;else G=F1b(a,D)|0;b[m>>0]=G&1;G1b(m,e);G=j+11|0;D=b[G>>0]|0;C=D<<24>>24<0;f[n>>2]=C?f[j>>2]|0:j;f[n+4>>2]=C?f[j+4>>2]|0:D&255;D=l+11|0;C=b[D>>0]|0;E=C<<24>>24<0;f[o>>2]=E?f[l>>2]|0:F;f[o+4>>2]=E?f[l+4>>2]|0:C&255;C=k+11|0;E=b[C>>0]|0;F=E<<24>>24<0;f[p>>2]=F?f[k>>2]|0:k;f[p+4>>2]=F?f[k+4>>2]|0:E&255;E=f[y>>2]|0;if(E|0?(f[E>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(E,i)}if((f[z>>2]|0)==10){E=f[y>>2]|0;if(E|0?(f[E>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(E,i)}H=f[a+60>>2]|0}else H=a;E=f[H>>2]|0;H=b[E+11>>0]|0;F=H<<24>>24<0;f[q>>2]=F?f[E>>2]|0:E;f[q+4>>2]=F?f[E+4>>2]|0:H&255;H=itc(f[a+40>>2]|0,i+8|0)|0;f[i>>2]=H;E=dJc(H)|0;f[i+4>>2]=E;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;Uoc(e,484307,n,o,p,q,i,r,s,t,v,w);if(!(b[a+36>>0]|0))I=0;else{H1b(n,a,1);E=n+11|0;H=b[E>>0]|0;F=H<<24>>24<0;f[i>>2]=F?f[n>>2]|0:n;f[i+4>>2]=F?f[n+4>>2]|0:H&255;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;f[x>>2]=0;f[x+4>>2]=-1;Uoc(e,484322,i,o,p,q,r,s,t,v,w,x);if((b[E>>0]|0)<0)cYc(f[n>>2]|0);I=1}if(!(b[a+37>>0]|0))J=I;else{if(I)AYc(e,528271)|0;else AYc(e,505467)|0;AYc(e,484337)|0;gtc(i,f[a+16>>2]|0);I=i+11|0;E=b[I>>0]|0;x=E<<24>>24<0;zYc(e,x?f[i>>2]|0:i,x?f[i+4>>2]|0:E&255)|0;if((b[I>>0]|0)<0)cYc(f[i>>2]|0);AYc(e,505469)|0;J=1};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;if(!(I1b(c,f[a+68>>2]|0,f[(f[a+20>>2]|0)+8>>2]|0,n)|0)){if(J)B=62}else{AYc(e,J?528271:528041)|0;J=b[n+11>>0]|0;I=J<<24>>24<0;zYc(e,I?f[n>>2]|0:n,I?f[n+4>>2]|0:J&255)|0;B=62}if((B|0)==62)AYc(e,528096)|0;B=f[y>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(B,i)}do if((f[z>>2]|0)==10){if(b[g+1>>0]|0){AYc(e,484351)|0;break}B=f[y>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=a;J_b(B,i)}J1b(f[a+60>>2]|0,c,e,g,0)}else AYc(e,484362)|0;while(0);K1b(m,e);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[A+11>>0]|0)<0)cYc(f[A>>2]|0);A=m+44|0;n=f[A>>2]|0;if(n|0){e=m+48|0;g=f[e>>2]|0;if((g|0)==(n|0))K=n;else{c=g;while(1){g=c+-12|0;f[e>>2]=g;if((b[g+11>>0]|0)<0){cYc(f[g>>2]|0);L=f[e>>2]|0}else L=g;if((L|0)==(n|0))break;else c=L}K=f[A>>2]|0}cYc(K)}K=m+32|0;if((b[K+11>>0]|0)<0)cYc(f[K>>2]|0);if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);if((b[D>>0]|0)<0)cYc(f[l>>2]|0);if((b[C>>0]|0)<0)cYc(f[k>>2]|0);if((b[G>>0]|0)>=0){u=h;return}cYc(f[j>>2]|0);u=h;return}function E1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=c+24|0;h=f[g>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=c;J_b(h,e)}h=c+28|0;switch(f[h>>2]|0){case 11:{i=f[g>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=c;J_b(i,e)}SGa(a,528338,f[(f[c+60>>2]|0)+4>>2]|0);u=d;return}case 14:{i=f[g>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=c;J_b(i,e)}SGa(a,528338,f[(f[c+64>>2]|0)+4>>2]|0);u=d;return}default:{i=f[g>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=c;J_b(i,e)}e=f[165720+(f[h>>2]<<2)>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=dJc(e)|0;if(h>>>0>4294967279)jYc(a);if(h>>>0<11){b[a+11>>0]=h;if(!h)j=a;else{k=a;l=21}}else{i=h+16&-16;c=$Xc(i)|0;f[a>>2]=c;f[a+8>>2]=i|-2147483648;f[a+4>>2]=h;k=c;l=21}if((l|0)==21){o1c(k|0,e|0,h|0)|0;j=k}b[j+h>>0]=0;u=d;return}}}function F1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;f2b(a,d);g=T1b(f[a+20>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);u=c;return g|0}function G1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;if(!(b[a>>0]|0)){u=d;return}g=a+44|0;h=a+48|0;i=f[g>>2]|0;if((f[h>>2]|0)!=(i|0)){j=e+11|0;k=e+4|0;l=0;m=i;do{L1b(e,a,m+(l*12|0)|0);i=b[j>>0]|0;n=i<<24>>24<0;zYc(c,n?f[e>>2]|0:e,n?f[k>>2]|0:i&255)|0;if((b[j>>0]|0)<0)cYc(f[e>>2]|0);AYc(c,505563)|0;l=l+1|0;m=f[g>>2]|0}while(l>>>0<(((f[h>>2]|0)-m|0)/12|0)>>>0)}m=a+20|0;h=b[m+11>>0]|0;if(h<<24>>24<0)o=f[a+24>>2]|0;else o=h&255;if(!o){u=d;return}L1b(e,a,m);m=e+11|0;a=b[m>>0]|0;o=a<<24>>24<0;zYc(c,o?f[e>>2]|0:e,o?f[e+4>>2]|0:a&255)|0;if((b[m>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}function H1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+24|0;j=e+40|0;k=e+105|0;l=e;m=e+104|0;if(!(b[c+36>>0]|0)){u_b(h,3,479317,1934);r_b(e+106|0,p_b(p_b(h,484830)|0,484866)|0);v_b(h)}h=c+24|0;o=f[h>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(o,g)}o=c+28|0;do switch(f[165644+(f[o>>2]<<2)>>2]|0){case 1:{mtc(a,f[c+80>>2]|0);u=e;return}case 2:{q=c+80|0;otc(a,f[q>>2]|0,f[q+4>>2]|0);u=e;return}case 3:{ntc(a,f[c+80>>2]|0);u=e;return}case 4:{q=c+80|0;ptc(a,f[q>>2]|0,f[q+4>>2]|0);u=e;return}case 6:{stc(a,+n[c+80>>2]);u=e;return}case 5:{qtc(a,+p[c+80>>3]);u=e;return}case 7:{q=(b[c+80>>0]|0)!=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=q?4:5;b[a+11>>0]=r;o1c(a|0,(q?529255:529249)|0,r|0)|0;b[a+r>>0]=0;u=e;return}case 9:{if(d){gtc(i,f[c+80>>2]|0);r=EYc(i,0,505469)|0;f[g>>2]=f[r>>2];f[g+4>>2]=f[r+4>>2];f[g+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=AYc(g,505469)|0;f[a>>2]=f[r>>2];f[a+4>>2]=f[r+4>>2];f[a+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=e;return}r=f[h>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(r,g)}r=f[c+80>>2]|0;if((f[o>>2]|0)==12){gtc(a,r);u=e;return}else{lYc(a,r);u=e;return}break}case 8:{r=f[h>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(r,g)}lYc(a,f[f[c+80>>2]>>2]|0);u=e;return}case 10:{u_b(j,2,479317,1972);r_b(k,p_b(j,484883)|0);v_b(j);break}default:{}}while(0);u_b(l,3,479317,1975);r_b(m,p_b(l,484919)|0);v_b(l);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;u=e;return}function I1b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+64|0;h=g+24|0;i=g+12|0;j=g;f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[i+8>>2]=0;if(d2b(a,c,d,i)|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=f[i>>2]|0;c=f[k>>2]|0;if((d|0)==(c|0)){l=j+11|0;m=j;n=0;o=0;p=0}else{a=h+4|0;q=d;do{if((q|0)!=(d|0))AYc(j,528271)|0;r=b[q+11>>0]|0;s=r<<24>>24<0;f[h>>2]=s?f[q>>2]|0:q;f[a>>2]=s?f[q+4>>2]|0:r&255;xtc(j,h);q=q+12|0}while((q|0)!=(c|0));c=j+11|0;l=c;m=j;n=b[c>>0]|0;o=f[j>>2]|0;p=f[j+4>>2]|0}c=n<<24>>24<0;zYc(e,c?o:j,c?p:n&255)|0;if((b[l>>0]|0)<0)cYc(f[m>>2]|0)}m=f[i>>2]|0;l=f[k>>2]|0;n=(m|0)!=(l|0);if(!m){u=g;return n|0}if((l|0)==(m|0))t=m;else{p=l;while(1){l=p+-12|0;f[k>>2]=l;if((b[l+11>>0]|0)<0){cYc(f[l>>2]|0);v=f[k>>2]|0}else v=l;if((v|0)==(m|0))break;else p=v}t=f[i>>2]|0}cYc(t);u=g;return n|0}function J1b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;h=u;u=u+576|0;i=h+528|0;j=h+512|0;k=h+440|0;l=h+400|0;m=h+360|0;n=h+320|0;o=h+280|0;p=h+240|0;q=h+200|0;r=h+160|0;s=h+120|0;t=h+80|0;v=h+40|0;w=h;x=a+16|0;if(b[(f[x>>2]|0)+51>>0]|0){u=h;return}y=c<<1;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(y>>>0>4294967279)jYc(j);if(y>>>0<11){b[j+11>>0]=y;if(!c)z=j;else{A=j;B=7}}else{C=y+16&-16;D=$Xc(C)|0;f[j>>2]=D;f[j+8>>2]=C|-2147483648;f[j+4>>2]=y;A=D;B=7}if((B|0)==7){g1c(A|0,32,y|0)|0;z=A}b[z+y>>0]=0;y=c+1|0;z=k+4|0;A=k+20|0;D=A;C=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(C|0));D=k+56|0;b[D>>0]=b[e>>0]|0;b[D+1>>0]=b[e+1>>0]|0;b[D+2>>0]=b[e+2>>0]|0;D=k+60|0;lYc(D,j);if(!(b[e>>0]|0))E=0;else E=M1b(a,z)|0;b[k>>0]=E&1;G1b(k,d);if(g){g=b[j+11>>0]|0;E=g<<24>>24<0;f[i>>2]=E?f[j>>2]|0:j;f[i+4>>2]=E?f[j+4>>2]|0:g&255;g=f[a>>2]|0;E=b[g+11>>0]|0;z=E<<24>>24<0;f[l>>2]=z?f[g>>2]|0:g;f[l+4>>2]=z?f[g+4>>2]|0:E&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;Uoc(d,484374,i,l,m,n,o,p,q,r,s,t)}AYc(d,505463)|0;N1b(y,f[x>>2]|0,f[(f[a+8>>2]|0)+8>>2]|0,d)|0;x=l+4|0;f[x>>2]=0;E=l+8|0;f[E>>2]=0;g=l+4|0;f[l>>2]=g;z=a+52|0;if((f[z>>2]|0)>0){C=a+20|0;F=i+4|0;G=i+8|0;H=i+12|0;I=i+4|0;J=i+8|0;K=i+12|0;L=0;do{M=f[C>>2]|0;N=M+(L*88|0)|0;O=f[M+(L*88|0)+24>>2]|0;if(O|0?(f[O>>2]|0)!=2:0){f[i>>2]=80424;f[I>>2]=2231;b[J>>0]=0;f[K>>2]=N;J_b(O,i)}if((f[M+(L*88|0)+28>>2]|0)==10){M=f[C>>2]|0;O=M+(L*88|0)|0;N=f[M+(L*88|0)+24>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[i>>2]=80424;f[F>>2]=2231;b[G>>0]=0;f[H>>2]=O;J_b(N,i)}N=f[M+(L*88|0)+60>>2]|0;M=N;O=f[g>>2]|0;do if(O){P=x;Q=O;while(1){R=f[Q+16>>2]|0;if(N>>>0<R>>>0){S=f[Q>>2]|0;if(!S){B=27;break}else{T=Q;U=S}}else{if(R>>>0>=N>>>0){B=31;break}V=Q+4|0;R=f[V>>2]|0;if(!R){B=30;break}else{T=V;U=R}}P=T;Q=U}if((B|0)==27){B=0;W=Q;X=Q;break}else if((B|0)==30){B=0;W=Q;X=V;break}else if((B|0)==31){B=0;W=Q;X=P;break}}else{W=g;X=g}while(0);if(!(f[X>>2]|0)){N=$Xc(20)|0;f[N+16>>2]=M;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=W;f[X>>2]=N;O=f[f[l>>2]>>2]|0;if(!O)Y=N;else{f[l>>2]=O;Y=f[X>>2]|0}UQ(f[x>>2]|0,Y);f[E>>2]=(f[E>>2]|0)+1}}L=L+1|0}while((L|0)<(f[z>>2]|0))}L=a+72|0;if((f[L>>2]|0)>0){Y=a+40|0;X=i+4|0;W=i+8|0;V=i+12|0;U=i+4|0;T=i+8|0;H=i+12|0;G=0;do{F=f[Y>>2]|0;C=F+(G*88|0)|0;K=f[F+(G*88|0)+24>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[i>>2]=80424;f[U>>2]=2231;b[T>>0]=0;f[H>>2]=C;J_b(K,i)}if((f[F+(G*88|0)+28>>2]|0)==10){F=f[Y>>2]|0;K=F+(G*88|0)|0;C=f[F+(G*88|0)+24>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[i>>2]=80424;f[X>>2]=2231;b[W>>0]=0;f[V>>2]=K;J_b(C,i)}C=f[F+(G*88|0)+60>>2]|0;F=C;K=f[g>>2]|0;do if(K){J=x;I=K;while(1){O=f[I+16>>2]|0;if(C>>>0<O>>>0){N=f[I>>2]|0;if(!N){B=50;break}else{Z=I;_=N}}else{if(O>>>0>=C>>>0){B=54;break}$=I+4|0;O=f[$>>2]|0;if(!O){B=53;break}else{Z=$;_=O}}J=Z;I=_}if((B|0)==50){B=0;aa=I;ba=I;break}else if((B|0)==53){B=0;aa=I;ba=$;break}else if((B|0)==54){B=0;aa=I;ba=J;break}}else{aa=g;ba=g}while(0);if(!(f[ba>>2]|0)){C=$Xc(20)|0;f[C+16>>2]=F;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=aa;f[ba>>2]=C;K=f[f[l>>2]>>2]|0;if(!K)ca=C;else{f[l>>2]=K;ca=f[ba>>2]|0}UQ(f[x>>2]|0,ca);f[E>>2]=(f[E>>2]|0)+1}}G=G+1|0}while((G|0)<(f[L>>2]|0))}G=a+60|0;E=f[G>>2]|0;if((E|0)>0){ca=a+28|0;x=0;ba=E;while(1){E=(f[ca>>2]|0)+(x*88|0)|0;aa=f[g>>2]|0;a:do if(!aa)B=68;else{$=aa;while(1){_=f[$+16>>2]|0;if(E>>>0<_>>>0)da=$;else{if(_>>>0>=E>>>0){ea=ba;break a}da=$+4|0}$=f[da>>2]|0;if(!$){B=68;break}}}while(0);if((B|0)==68){B=0;J1b(E,y,d,e,1);ea=f[G>>2]|0}x=x+1|0;if((x|0)>=(ea|0))break;else ba=ea}}ea=a+64|0;if((f[ea>>2]|0)>0){ba=a+32|0;x=0;do{O1b((f[ba>>2]|0)+(x*48|0)|0,y,d,e);x=x+1|0}while((x|0)<(f[ea>>2]|0))}if((f[z>>2]|0)>0){ea=a+20|0;x=0;do{ba=f[ea>>2]|0;G=ba+(x*88|0)|0;B=f[ba+(x*88|0)+52>>2]|0;if(B){if((f[f[B+20>>2]>>2]|0)==(G|0))P1b(B,y,d,e)}else D1b(G,y,0,d,e);x=x+1|0}while((x|0)<(f[z>>2]|0))}z=a+68|0;if((f[z>>2]|0)>0){x=j+11|0;y=i+4|0;ea=j+4|0;G=a+36|0;B=m+8|0;ba=m+4|0;da=n+8|0;ca=n+4|0;aa=o+4|0;F=p+4|0;$=q+4|0;J=r+4|0;I=s+4|0;_=t+4|0;Z=v+4|0;V=0;do{W=b[x>>0]|0;X=W<<24>>24<0;f[i>>2]=X?f[j>>2]|0:j;f[y>>2]=X?f[ea>>2]|0:W&255;W=itc(f[(f[G>>2]|0)+(V*12|0)>>2]|0,B)|0;f[m>>2]=W;X=dJc(W)|0;f[ba>>2]=X;X=itc((f[(f[G>>2]|0)+(V*12|0)+4>>2]|0)+-1|0,da)|0;f[n>>2]=X;W=dJc(X)|0;f[ca>>2]=W;f[o>>2]=0;f[aa>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[$>>2]=-1;f[r>>2]=0;f[J>>2]=-1;f[s>>2]=0;f[I>>2]=-1;f[t>>2]=0;f[_>>2]=-1;f[v>>2]=0;f[Z>>2]=-1;Uoc(d,484387,i,m,n,o,p,q,r,s,t,v);V=V+1|0}while((V|0)<(f[z>>2]|0))}if((f[L>>2]|0)>0){z=a+40|0;V=c+2|0;c=j+11|0;Z=i+4|0;_=j+4|0;I=m+4|0;J=n+4|0;$=o+4|0;F=p+4|0;aa=q+4|0;ca=r+4|0;da=s+4|0;G=t+4|0;ba=v+4|0;B=i+4|0;ea=m+4|0;y=n+4|0;x=o+4|0;W=p+4|0;X=q+4|0;Y=r+4|0;H=s+4|0;T=t+4|0;U=v+4|0;K=0;C=0;while(1){M=f[z>>2]|0;P=f[M+(K*88|0)+48>>2]|0;if((P|0)==(C|0)){fa=C;ga=M}else{if((K|0)>0){M=b[c>>0]|0;Q=M<<24>>24<0;f[i>>2]=Q?f[j>>2]|0:j;f[Z>>2]=Q?f[_>>2]|0:M&255;f[m>>2]=0;f[I>>2]=-1;f[n>>2]=0;f[J>>2]=-1;f[o>>2]=0;f[$>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[aa>>2]=-1;f[r>>2]=0;f[ca>>2]=-1;f[s>>2]=0;f[da>>2]=-1;f[t>>2]=0;f[G>>2]=-1;f[v>>2]=0;f[ba>>2]=-1;Uoc(d,484413,i,m,n,o,p,q,r,s,t,v);ha=f[(f[z>>2]|0)+(K*88|0)+48>>2]|0}else ha=P;P=b[c>>0]|0;M=P<<24>>24<0;f[i>>2]=M?f[j>>2]|0:j;f[B>>2]=M?f[_>>2]|0:P&255;P=f[ha+4>>2]|0;M=b[P+11>>0]|0;Q=M<<24>>24<0;f[m>>2]=Q?f[P>>2]|0:P;f[ea>>2]=Q?f[P+4>>2]|0:M&255;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[x>>2]=-1;f[p>>2]=0;f[W>>2]=-1;f[q>>2]=0;f[X>>2]=-1;f[r>>2]=0;f[Y>>2]=-1;f[s>>2]=0;f[H>>2]=-1;f[t>>2]=0;f[T>>2]=-1;f[v>>2]=0;f[U>>2]=-1;Uoc(d,484420,i,m,n,o,p,q,r,s,t,v);fa=ha;ga=f[z>>2]|0}D1b(ga+(K*88|0)|0,V,0,d,e);K=K+1|0;ia=f[L>>2]|0;if((K|0)>=(ia|0))break;else C=fa}if((ia|0)>0){ia=b[j+11>>0]|0;fa=ia<<24>>24<0;f[i>>2]=fa?f[j>>2]|0:j;f[i+4>>2]=fa?f[j+4>>2]|0:ia&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Uoc(d,484413,i,m,n,o,p,q,r,s,t,v)}}ia=a+76|0;if((f[ia>>2]|0)>0){fa=b[j+11>>0]|0;C=fa<<24>>24<0;f[i>>2]=C?f[j>>2]|0:j;f[i+4>>2]=C?f[j+4>>2]|0:fa&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Uoc(d,484438,i,m,n,o,p,q,r,s,t,v);if((f[ia>>2]|0)>0){fa=a+44|0;C=i+8|0;K=i+4|0;L=m+4|0;e=n+4|0;V=o+4|0;ga=p+4|0;z=q+4|0;ha=r+4|0;U=s+4|0;T=t+4|0;H=v+4|0;Y=i+8|0;X=i+4|0;W=m+8|0;x=m+4|0;y=n+4|0;ea=o+4|0;_=p+4|0;B=q+4|0;c=r+4|0;ba=s+4|0;G=t+4|0;da=v+4|0;ca=0;do{aa=f[fa>>2]|0;F=aa+(ca<<3)+4|0;$=f[aa+(ca<<3)>>2]|0;if((f[F>>2]|0)==($+1|0)){aa=itc($,C)|0;f[i>>2]=aa;J=dJc(aa)|0;f[K>>2]=J;f[m>>2]=0;f[L>>2]=-1;f[n>>2]=0;f[e>>2]=-1;f[o>>2]=0;f[V>>2]=-1;f[p>>2]=0;f[ga>>2]=-1;f[q>>2]=0;f[z>>2]=-1;f[r>>2]=0;f[ha>>2]=-1;f[s>>2]=0;f[U>>2]=-1;f[t>>2]=0;f[T>>2]=-1;f[v>>2]=0;f[H>>2]=-1;Uoc(d,484452,i,m,n,o,p,q,r,s,t,v)}else{J=itc($,Y)|0;f[i>>2]=J;$=dJc(J)|0;f[X>>2]=$;$=itc((f[F>>2]|0)+-1|0,W)|0;f[m>>2]=$;F=dJc($)|0;f[x>>2]=F;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[ea>>2]=-1;f[p>>2]=0;f[_>>2]=-1;f[q>>2]=0;f[B>>2]=-1;f[r>>2]=0;f[c>>2]=-1;f[s>>2]=0;f[ba>>2]=-1;f[t>>2]=0;f[G>>2]=-1;f[v>>2]=0;f[da>>2]=-1;Uoc(d,484457,i,m,n,o,p,q,r,s,t,v)}ca=ca+1|0}while((ca|0)<(f[ia>>2]|0))}ia=b[d+11>>0]|0;if(ia<<24>>24<0)ja=f[d+4>>2]|0;else ja=ia&255;HYc(d,ja+-2|0,2,484362)|0}ja=a+80|0;if((f[ja>>2]|0)>0){ia=j+11|0;ca=b[ia>>0]|0;da=ca<<24>>24<0;f[i>>2]=da?f[j>>2]|0:j;G=j+4|0;f[i+4>>2]=da?f[G>>2]|0:ca&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Uoc(d,484438,i,m,n,o,p,q,r,s,t,v);if((f[ja>>2]|0)>0){ca=a+48|0;a=m+11|0;da=i+4|0;ba=m+4|0;c=n+4|0;B=o+4|0;_=p+4|0;ea=q+4|0;y=r+4|0;x=s+4|0;W=t+4|0;X=v+4|0;Y=w+4|0;H=0;do{gtc(m,f[(f[ca>>2]|0)+(H<<2)>>2]|0);T=b[a>>0]|0;U=T<<24>>24<0;f[i>>2]=U?f[m>>2]|0:m;f[da>>2]=U?f[ba>>2]|0:T&255;f[n>>2]=0;f[c>>2]=-1;f[o>>2]=0;f[B>>2]=-1;f[p>>2]=0;f[_>>2]=-1;f[q>>2]=0;f[ea>>2]=-1;f[r>>2]=0;f[y>>2]=-1;f[s>>2]=0;f[x>>2]=-1;f[t>>2]=0;f[W>>2]=-1;f[v>>2]=0;f[X>>2]=-1;f[w>>2]=0;f[Y>>2]=-1;Uoc(d,484468,i,n,o,p,q,r,s,t,v,w);if((b[a>>0]|0)<0)cYc(f[m>>2]|0);H=H+1|0}while((H|0)<(f[ja>>2]|0))}ja=b[d+11>>0]|0;if(ja<<24>>24<0)ka=f[d+4>>2]|0;else ka=ja&255;HYc(d,ka+-2|0,2,484362)|0;la=ia;ma=j;na=G}else{la=j+11|0;ma=j;na=j+4|0}G=b[la>>0]|0;ia=G<<24>>24<0;f[i>>2]=ia?f[ma>>2]|0:j;f[i+4>>2]=ia?f[na>>2]|0:G&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;Uoc(d,484475,i,m,n,o,p,q,r,s,t,v);K1b(k,d);Q1b(l,f[g>>2]|0);if((b[D+11>>0]|0)<0)cYc(f[D>>2]|0);D=k+44|0;g=f[D>>2]|0;if(g|0){l=k+48|0;d=f[l>>2]|0;if((d|0)==(g|0))oa=g;else{v=d;while(1){d=v+-12|0;f[l>>2]=d;if((b[d+11>>0]|0)<0){cYc(f[d>>2]|0);pa=f[l>>2]|0}else pa=d;if((pa|0)==(g|0))break;else v=pa}oa=f[D>>2]|0}cYc(oa)}oa=k+32|0;if((b[oa+11>>0]|0)<0)cYc(f[oa>>2]|0);if((b[A+11>>0]|0)<0)cYc(f[A>>2]|0);if((b[la>>0]|0)<0)cYc(f[ma>>2]|0);u=h;return}function K1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;if(!(b[a>>0]|0)){u=d;return}g=a+32|0;h=b[g+11>>0]|0;if(h<<24>>24<0)i=f[a+36>>2]|0;else i=h&255;if(!i){u=d;return}L1b(e,a,g);g=e+11|0;a=b[g>>0]|0;i=a<<24>>24<0;zYc(c,i?f[e>>2]|0:e,i?f[e+4>>2]|0:a&255)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}function L1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+432|0;g=e+412|0;h=e+400|0;i=e+360|0;j=e+320|0;k=e+280|0;l=e+240|0;m=e+200|0;n=e+160|0;o=e+120|0;p=e+80|0;q=e+40|0;r=e;lYc(g,d);btc(g);f[h>>2]=0;d=h+4|0;f[d>>2]=0;f[h+8>>2]=0;ctc(g,505563,h);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;s=f[d>>2]|0;t=f[h>>2]|0;v=t;if((s|0)==(t|0)){w=s;x=v}else{s=c+60|0;t=s+11|0;y=i+4|0;z=c+64|0;c=j+4|0;A=k+4|0;B=l+4|0;C=m+4|0;D=n+4|0;E=o+4|0;F=p+4|0;G=q+4|0;H=r+4|0;I=0;J=v;while(1){v=J+(I*12|0)|0;K=b[t>>0]|0;L=K<<24>>24<0;f[i>>2]=L?f[s>>2]|0:s;f[y>>2]=L?f[z>>2]|0:K&255;K=b[v+11>>0]|0;L=K<<24>>24<0;f[j>>2]=L?f[v>>2]|0:v;f[c>>2]=L?f[J+(I*12|0)+4>>2]|0:K&255;f[k>>2]=0;f[A>>2]=-1;f[l>>2]=0;f[B>>2]=-1;f[m>>2]=0;f[C>>2]=-1;f[n>>2]=0;f[D>>2]=-1;f[o>>2]=0;f[E>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[G>>2]=-1;f[r>>2]=0;f[H>>2]=-1;Uoc(a,484365,i,j,k,l,m,n,o,p,q,r);I=I+1|0;K=f[d>>2]|0;L=f[h>>2]|0;v=L;if(I>>>0>=((K-L|0)/12|0)>>>0){w=K;x=v;break}else J=v}}J=w;if(x|0){if((J|0)==(x|0))M=x;else{w=J;while(1){J=w+-12|0;f[d>>2]=J;if((b[J+11>>0]|0)<0){cYc(f[J>>2]|0);N=f[d>>2]|0}else N=J;if((N|0)==(x|0))break;else w=N}M=f[h>>2]|0}cYc(M)}if((b[g+11>>0]|0)>=0){u=e;return}cYc(f[g>>2]|0);u=e;return}function M1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;S1b(a,d);g=T1b(f[a+8>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);u=c;return g|0}function N1b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=u;u=u+432|0;h=g+412|0;i=g+400|0;j=g+360|0;k=g+320|0;l=g+280|0;m=g+240|0;n=g+200|0;o=g+160|0;p=g+120|0;q=g+80|0;r=g+40|0;s=g;t=a<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(t>>>0>4294967279)jYc(h);if(t>>>0<11){b[h+11>>0]=t;if(!a)v=h;else{w=h;x=6}}else{y=t+16&-16;z=$Xc(y)|0;f[h>>2]=z;f[h+8>>2]=y|-2147483648;f[h+4>>2]=t;w=z;x=6}if((x|0)==6){g1c(w|0,32,t|0)|0;v=w}b[v+t>>0]=0;f[i>>2]=0;t=i+4|0;f[t>>2]=0;f[i+8>>2]=0;if(d2b(a,c,d,i)|0){d=f[t>>2]|0;c=f[i>>2]|0;a=c;if((d|0)==(c|0)){A=a;B=d}else{d=h+11|0;c=j+4|0;v=h+4|0;w=k+4|0;x=l+4|0;z=m+4|0;y=n+4|0;C=o+4|0;D=p+4|0;E=q+4|0;F=r+4|0;G=s+4|0;H=0;I=a;do{a=b[d>>0]|0;J=a<<24>>24<0;f[j>>2]=J?f[h>>2]|0:h;f[c>>2]=J?f[v>>2]|0:a&255;a=I+(H*12|0)|0;J=b[a+11>>0]|0;K=J<<24>>24<0;f[k>>2]=K?f[a>>2]|0:a;f[w>>2]=K?f[I+(H*12|0)+4>>2]|0:J&255;f[l>>2]=0;f[x>>2]=-1;f[m>>2]=0;f[z>>2]=-1;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[C>>2]=-1;f[p>>2]=0;f[D>>2]=-1;f[q>>2]=0;f[E>>2]=-1;f[r>>2]=0;f[F>>2]=-1;f[s>>2]=0;f[G>>2]=-1;Uoc(e,484772,j,k,l,m,n,o,p,q,r,s);H=H+1|0;L=f[t>>2]|0;J=f[i>>2]|0;I=J}while(H>>>0<((L-J|0)/12|0)>>>0);A=I;B=L}}else{A=f[i>>2]|0;B=f[t>>2]|0}L=(A|0)!=(B|0);if(A|0){if((B|0)==(A|0))M=A;else{I=B;while(1){B=I+-12|0;f[t>>2]=B;if((b[B+11>>0]|0)<0){cYc(f[B>>2]|0);N=f[t>>2]|0}else N=B;if((N|0)==(A|0))break;else I=N}M=f[i>>2]|0}cYc(M)}if((b[h+11>>0]|0)>=0){u=g;return L|0}cYc(f[h>>2]|0);u=g;return L|0}function O1b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;g=u;u=u+528|0;h=g+512|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;n=g+240|0;o=g+200|0;p=g+160|0;q=g+120|0;r=g+80|0;s=g+40|0;t=g;v=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(v>>>0>4294967279)jYc(h);if(v>>>0<11){b[h+11>>0]=v;if(!c)w=h;else{x=h;y=6}}else{z=v+16&-16;A=$Xc(z)|0;f[h>>2]=A;f[h+8>>2]=z|-2147483648;f[h+4>>2]=v;x=A;y=6}if((y|0)==6){g1c(x|0,32,v|0)|0;w=x}b[w+v>>0]=0;v=c+1|0;c=i+4|0;w=i+20|0;x=w;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));x=i+56|0;b[x>>0]=b[e>>0]|0;b[x+1>>0]=b[e+1>>0]|0;b[x+2>>0]=b[e+2>>0]|0;x=i+60|0;lYc(x,h);if(!(b[e>>0]|0))B=0;else B=$1b(a,c)|0;b[i>>0]=B&1;G1b(i,d);B=h+11|0;c=b[B>>0]|0;y=c<<24>>24<0;f[j>>2]=y?f[h>>2]|0:h;A=h+4|0;f[j+4>>2]=y?f[A>>2]|0:c&255;c=f[a>>2]|0;y=b[c+11>>0]|0;z=y<<24>>24<0;f[k>>2]=z?f[c>>2]|0:c;f[k+4>>2]=z?f[c+4>>2]|0:y&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Uoc(d,484743,j,k,l,m,n,o,p,q,r,s);N1b(v,f[a+16>>2]|0,f[(f[a+8>>2]|0)+8>>2]|0,d)|0;y=a+24|0;if((f[y>>2]|0)>0){c=a+28|0;z=0;do{a2b((f[c>>2]|0)+(z*20|0)|0,v,d,e);z=z+1|0}while((z|0)<(f[y>>2]|0))}y=a+32|0;if((f[y>>2]|0)>0){z=b[B>>0]|0;e=z<<24>>24<0;f[j>>2]=e?f[h>>2]|0:h;f[j+4>>2]=e?f[A>>2]|0:z&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Uoc(d,484438,j,k,l,m,n,o,p,q,r,s);if((f[y>>2]|0)>0){z=a+40|0;e=j+8|0;v=j+4|0;c=k+4|0;C=l+4|0;D=m+4|0;E=n+4|0;F=o+4|0;G=p+4|0;H=q+4|0;I=r+4|0;J=s+4|0;K=j+8|0;L=j+4|0;M=k+8|0;N=k+4|0;O=l+4|0;P=m+4|0;Q=n+4|0;R=o+4|0;S=p+4|0;T=q+4|0;U=r+4|0;V=s+4|0;W=0;do{X=f[z>>2]|0;Y=X+(W<<3)+4|0;Z=f[Y>>2]|0;_=f[X+(W<<3)>>2]|0;if((Z|0)==(_|0)){X=itc(Z,e)|0;f[j>>2]=X;Z=dJc(X)|0;f[v>>2]=Z;f[k>>2]=0;f[c>>2]=-1;f[l>>2]=0;f[C>>2]=-1;f[m>>2]=0;f[D>>2]=-1;f[n>>2]=0;f[E>>2]=-1;f[o>>2]=0;f[F>>2]=-1;f[p>>2]=0;f[G>>2]=-1;f[q>>2]=0;f[H>>2]=-1;f[r>>2]=0;f[I>>2]=-1;f[s>>2]=0;f[J>>2]=-1;Uoc(d,484452,j,k,l,m,n,o,p,q,r,s)}else{Z=itc(_,K)|0;f[j>>2]=Z;_=dJc(Z)|0;f[L>>2]=_;_=itc(f[Y>>2]|0,M)|0;f[k>>2]=_;Y=dJc(_)|0;f[N>>2]=Y;f[l>>2]=0;f[O>>2]=-1;f[m>>2]=0;f[P>>2]=-1;f[n>>2]=0;f[Q>>2]=-1;f[o>>2]=0;f[R>>2]=-1;f[p>>2]=0;f[S>>2]=-1;f[q>>2]=0;f[T>>2]=-1;f[r>>2]=0;f[U>>2]=-1;f[s>>2]=0;f[V>>2]=-1;Uoc(d,484457,j,k,l,m,n,o,p,q,r,s)}W=W+1|0}while((W|0)<(f[y>>2]|0))}y=b[d+11>>0]|0;if(y<<24>>24<0)$=f[d+4>>2]|0;else $=y&255;HYc(d,$+-2|0,2,484362)|0}$=a+36|0;if((f[$>>2]|0)>0){y=b[B>>0]|0;W=y<<24>>24<0;f[j>>2]=W?f[h>>2]|0:h;f[j+4>>2]=W?f[A>>2]|0:y&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Uoc(d,484438,j,k,l,m,n,o,p,q,r,s);if((f[$>>2]|0)>0){y=a+44|0;a=k+11|0;W=j+4|0;V=k+4|0;U=l+4|0;T=m+4|0;S=n+4|0;R=o+4|0;Q=p+4|0;P=q+4|0;O=r+4|0;N=s+4|0;M=t+4|0;L=0;do{gtc(k,f[(f[y>>2]|0)+(L<<2)>>2]|0);K=b[a>>0]|0;J=K<<24>>24<0;f[j>>2]=J?f[k>>2]|0:k;f[W>>2]=J?f[V>>2]|0:K&255;f[l>>2]=0;f[U>>2]=-1;f[m>>2]=0;f[T>>2]=-1;f[n>>2]=0;f[S>>2]=-1;f[o>>2]=0;f[R>>2]=-1;f[p>>2]=0;f[Q>>2]=-1;f[q>>2]=0;f[P>>2]=-1;f[r>>2]=0;f[O>>2]=-1;f[s>>2]=0;f[N>>2]=-1;f[t>>2]=0;f[M>>2]=-1;Uoc(d,484468,j,l,m,n,o,p,q,r,s,t);if((b[a>>0]|0)<0)cYc(f[k>>2]|0);L=L+1|0}while((L|0)<(f[$>>2]|0))}$=b[d+11>>0]|0;if($<<24>>24<0)aa=f[d+4>>2]|0;else aa=$&255;HYc(d,aa+-2|0,2,484362)|0}aa=b[B>>0]|0;$=aa<<24>>24<0;f[j>>2]=$?f[h>>2]|0:h;f[j+4>>2]=$?f[A>>2]|0:aa&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Uoc(d,484475,j,k,l,m,n,o,p,q,r,s);K1b(i,d);if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);x=i+44|0;d=f[x>>2]|0;if(d|0){s=i+48|0;r=f[s>>2]|0;if((r|0)==(d|0))ba=d;else{q=r;while(1){r=q+-12|0;f[s>>2]=r;if((b[r+11>>0]|0)<0){cYc(f[r>>2]|0);ca=f[s>>2]|0}else ca=r;if((ca|0)==(d|0))break;else q=ca}ba=f[x>>2]|0}cYc(ba)}ba=i+32|0;if((b[ba+11>>0]|0)<0)cYc(f[ba>>2]|0);if((b[w+11>>0]|0)<0)cYc(f[w>>2]|0);if((b[B>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function P1b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+496|0;h=g+472|0;i=g+400|0;j=g+360|0;k=g+320|0;l=g+280|0;m=g+240|0;n=g+200|0;o=g+160|0;p=g+120|0;q=g+80|0;r=g+40|0;s=g;t=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(t>>>0>4294967279)jYc(h);if(t>>>0<11){b[h+11>>0]=t;if(!c)v=h;else{w=h;x=6}}else{y=t+16&-16;z=$Xc(y)|0;f[h>>2]=z;f[h+8>>2]=y|-2147483648;f[h+4>>2]=t;w=z;x=6}if((x|0)==6){g1c(w|0,32,t|0)|0;v=w}b[v+t>>0]=0;t=c+1|0;c=i+4|0;v=i+20|0;w=v;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));w=i+56|0;b[w>>0]=b[e>>0]|0;b[w+1>>0]=b[e+1>>0]|0;b[w+2>>0]=b[e+2>>0]|0;w=i+60|0;lYc(w,h);if(!(b[e>>0]|0))A=0;else A=R1b(a,c)|0;b[i>>0]=A&1;G1b(i,d);A=h+11|0;c=b[A>>0]|0;x=c<<24>>24<0;f[j>>2]=x?f[h>>2]|0:h;z=h+4|0;f[j+4>>2]=x?f[z>>2]|0:c&255;c=f[a>>2]|0;x=b[c+11>>0]|0;y=x<<24>>24<0;f[k>>2]=y?f[c>>2]|0:c;f[k+4>>2]=y?f[c+4>>2]|0:x&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Uoc(d,484480,j,k,l,m,n,o,p,q,r,s);N1b(t,f[a+24>>2]|0,f[(f[(f[a+8>>2]|0)+8>>2]|0)+8>>2]|0,d)|0;if(!(b[e+2>>0]|0)){AYc(d,505563)|0;x=a+16|0;if((f[x>>2]|0)>0){c=a+20|0;a=0;do{D1b(f[(f[c>>2]|0)+(a<<2)>>2]|0,t,1,d,e);a=a+1|0}while((a|0)<(f[x>>2]|0))}x=b[A>>0]|0;a=x<<24>>24<0;f[j>>2]=a?f[h>>2]|0:h;f[j+4>>2]=a?f[z>>2]|0:x&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Uoc(d,484475,j,k,l,m,n,o,p,q,r,s)}else AYc(d,484493)|0;K1b(i,d);if((b[w+11>>0]|0)<0)cYc(f[w>>2]|0);w=i+44|0;d=f[w>>2]|0;if(d|0){s=i+48|0;r=f[s>>2]|0;if((r|0)==(d|0))B=d;else{q=r;while(1){r=q+-12|0;f[s>>2]=r;if((b[r+11>>0]|0)<0){cYc(f[r>>2]|0);C=f[s>>2]|0}else C=r;if((C|0)==(d|0))break;else q=C}B=f[w>>2]|0}cYc(B)}B=i+32|0;if((b[B+11>>0]|0)<0)cYc(f[B>>2]|0);if((b[v+11>>0]|0)<0)cYc(f[v>>2]|0);if((b[A>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function Q1b(a,b){a=a|0;b=b|0;if(!b)return;else{Q1b(a,f[b>>2]|0);Q1b(a,f[b+4>>2]|0);cYc(b);return}}function R1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+12|0;e=c;f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;h=a+8|0;S1b(f[h>>2]|0,e);i=f[g>>2]|0;j=e+8|0;k=f[j>>2]|0;if((i|0)==(k|0)){Tv(e,170904);l=f[g>>2]|0;m=f[j>>2]|0}else{f[i>>2]=f[42726];j=i+4|0;f[g>>2]=j;l=j;m=k}k=f[h>>2]|0;j=(a-(f[k+24>>2]|0)|0)/28|0;f[d>>2]=j;if(l>>>0<m>>>0){f[l>>2]=j;f[g>>2]=l+4;n=k}else{LA(e,d);n=f[h>>2]|0}h=T1b(f[n+8>>2]|0,e,b)|0;b=f[e>>2]|0;if(!b){u=c;return h|0}e=f[g>>2]|0;if((e|0)!=(b|0))f[g>>2]=e+(~((e+-4-b|0)>>>2)<<2);cYc(b);u=c;return h|0}function S1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;if(!g){h=b+4|0;i=f[h>>2]|0;j=b+8|0;if((i|0)==(f[j>>2]|0)){Tv(b,170876);k=f[e>>2]|0;l=a;if(!k){m=l;n=d;o=15}else{p=k+28|0;q=l;r=d}}else{f[i>>2]=f[42719];f[h>>2]=i+4;m=a;n=d;o=15}if((o|0)==15){p=(f[a+8>>2]|0)+68|0;q=m;r=n}n=(q-(f[p>>2]|0)|0)/88|0;f[d>>2]=n;p=f[h>>2]|0;if(p>>>0<(f[j>>2]|0)>>>0){f[p>>2]=n;f[h>>2]=p+4}else LA(b,d);u=c;return}S1b(g,b);g=b+4|0;p=f[g>>2]|0;h=b+8|0;if((p|0)==(f[h>>2]|0))Tv(b,170896);else{f[p>>2]=f[42724];f[g>>2]=p+4}p=f[e>>2]|0;if(!p)s=(f[a+8>>2]|0)+68|0;else s=p+28|0;p=(a-(f[s>>2]|0)|0)/88|0;f[d>>2]=p;s=f[g>>2]|0;if(s>>>0<(f[h>>2]|0)>>>0){f[s>>2]=p;f[g>>2]=s+4}else LA(b,d);u=c;return}function T1b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;if(!c){u_b(e,3,484501,166);r_b(g,p_b(e,484595)|0);v_b(e)}j=f[a+92>>2]|0;if(!j){k=0;u=d;return k|0}l=U1b(f[a+88>>2]|0,b,j)|0;if(!l){k=0;u=d;return k|0}j=f[l+32>>2]|0;if((j+-3|0)>>>0>=2){k=0;u=d;return k|0}b=f[l+40>>2]|0;f[c>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+4>>2]=f[b+4+(((j|0)==3?0:2)<<2)>>2];f[c+12>>2]=f[b+4+(j+-1<<2)>>2];oYc(c+16|0,f[l+64>>2]|0)|0;oYc(c+28|0,f[l+68>>2]|0)|0;j=f[l+60>>2]|0;b=(j|0)==0?0:j+4|0;f[h>>2]=b;f[i>>2]=b+(f[l+52>>2]<<2);f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];V1b(c+40|0,g,e);k=1;u=d;return k|0}function U1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e+24|0;h=e+16|0;i=e;f[h>>2]=a;f[h+4>>2]=d;d=a+136|0;if((f[d>>2]|0)!=2){f[g>>2]=165960;f[g+4>>2]=2271;b[g+8>>0]=0;f[g+12>>2]=h;J_b(d,g)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=f[c>>2]|0;h=f[c+4>>2]|0;if((d|0)!=(h|0)){c=g+8|0;j=g+4|0;k=c;l=d;do{if((l|0)!=(d|0))AYc(i,528117)|0;m=f[l>>2]|0;f[g>>2]=c;n=(ktc(m,c)|0)-k|0;f[j>>2]=n;xtc(i,g);l=l+4|0}while((l|0)!=(h|0))}h=X1b(a+140|0,i)|0;if(!h)o=0;else o=f[h+20>>2]|0;if((b[i+11>>0]|0)>=0){u=e;return o|0}cYc(f[i>>2]|0);u=e;return o|0}function V1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[c>>2]|0;c=f[d>>2]|0;d=c-e>>2;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=e;k=i;l=c;if(d>>>0<=((h-i|0)/12|0)>>>0){m=a+4|0;n=((f[m>>2]|0)-i|0)/12|0;o=d>>>0>n>>>0;p=o?j+(n<<2)|0:c;c=p;if((j|0)==(c|0))q=k;else{n=k;r=e;while(1){oYc(n,f[r>>2]|0)|0;r=r+4|0;s=n+12|0;if((r|0)==(c|0)){q=s;break}else n=s}}if(o){if((c|0)==(l|0))return;c=p;p=f[m>>2]|0;do{lYc(p,f[c>>2]|0);c=c+4|0;p=(f[m>>2]|0)+12|0;f[m>>2]=p}while((c|0)!=(l|0));return}c=f[m>>2]|0;if((c|0)==(q|0))return;else t=c;while(1){c=t+-12|0;f[m>>2]=c;if((b[c+11>>0]|0)<0){cYc(f[c>>2]|0);u=f[m>>2]|0}else u=c;if((u|0)==(q|0))break;else t=u}return}if(!i)v=h;else{h=a+4|0;u=f[h>>2]|0;if((u|0)==(k|0))w=i;else{i=u;while(1){u=i+-12|0;f[h>>2]=u;if((b[u+11>>0]|0)<0){cYc(f[u>>2]|0);x=f[h>>2]|0}else x=u;if((x|0)==(k|0))break;else i=x}w=f[a>>2]|0}cYc(w);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;v=0}if(d>>>0>357913941)kWc(a);h=(v|0)/12|0;v=h<<1;w=h>>>0<178956970?(v>>>0<d>>>0?d:v):357913941;if(w>>>0>357913941)kWc(a);v=$Xc(w*12|0)|0;d=a+4|0;f[d>>2]=v;f[a>>2]=v;f[g>>2]=v+(w*12|0);if((j|0)==(l|0))return;j=e;e=v;do{lYc(e,f[j>>2]|0);j=j+4|0;e=(f[d>>2]|0)+12|0;f[d>>2]=e}while((j|0)!=(l|0));return}function W1b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+64|0;d=c+16|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[h+20>>2]|0;if((i|0)<=0){u=c;return}j=e+11|0;k=d+8|0;l=d+4|0;m=k;n=0;o=h;while(1){h=f[(f[o+28>>2]|0)+4+(n<<2)>>2]|0;p=(f[a>>2]|0)+140|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=f[h+24>>2]|0;r=(q|0)==0;s=r?0:q+4|0;t=r?0:q+4+(f[h+16>>2]<<2)|0;if((s|0)!=(t|0)){q=s;do{if((q|0)!=(s|0))AYc(e,528117)|0;r=f[q>>2]|0;f[d>>2]=k;v=(ktc(r,k)|0)-m|0;f[l>>2]=v;xtc(e,d);q=q+4|0}while((q|0)!=(t|0))}t=Y1b(p,e)|0;f[t>>2]=h;if((b[j>>0]|0)<0)cYc(f[e>>2]|0);t=n+1|0;if((t|0)>=(i|0))break;n=t;o=f[g>>2]|0}u=c;return}function X1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(c|0)==(i|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(WKc(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(a|0)==(i|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(WKc(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function Y1b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0,L=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=a+4|0;l=f[k>>2]|0;j=(l|0)==0;a:do if(!j){m=l+-1|0;o=(m&l|0)==0;if(!o)if(i>>>0<l>>>0)p=i;else p=(i>>>0)%(l>>>0)|0;else p=m&i;q=f[(f[a>>2]|0)+(p<<2)>>2]|0;if((q|0)!=0?(r=f[q>>2]|0,(r|0)!=0):0){q=e?f[c+4>>2]|0:d&255;s=(q|0)==0;if(o){if(s){o=r;while(1){t=f[o+4>>2]|0;if(!((t|0)==(i|0)|(t&m|0)==(p|0))){u=p;break a}t=b[o+8+11>>0]|0;if(!((t<<24>>24<0?f[o+12>>2]|0:t&255)|0)){v=o;break}o=f[o>>2]|0;if(!o){u=p;break a}}w=v+20|0;return w|0}else x=r;b:while(1){o=f[x+4>>2]|0;if(!((o|0)==(i|0)|(o&m|0)==(p|0))){u=p;break a}o=x+8|0;t=b[o+11>>0]|0;y=t<<24>>24<0;z=t&255;do if(((y?f[x+12>>2]|0:z)|0)==(q|0)){t=f[o>>2]|0;if(y)if(!(WKc(t,g,q)|0)){v=x;A=58;break b}else break;if((t&255)<<24>>24==h<<24>>24){t=o;B=z;C=g;do{B=B+-1|0;t=t+1|0;if(!B){v=x;A=58;break b}C=C+1|0}while((b[t>>0]|0)==(b[C>>0]|0))}}while(0);x=f[x>>2]|0;if(!x){u=p;break a}}if((A|0)==58){w=v+20|0;return w|0}}if(s){m=r;while(1){z=f[m+4>>2]|0;if((z|0)!=(i|0)){if(z>>>0<l>>>0)D=z;else D=(z>>>0)%(l>>>0)|0;if((D|0)!=(p|0)){u=p;break a}}z=b[m+8+11>>0]|0;if(!((z<<24>>24<0?f[m+12>>2]|0:z&255)|0)){v=m;break}m=f[m>>2]|0;if(!m){u=p;break a}}w=v+20|0;return w|0}else E=r;c:while(1){m=f[E+4>>2]|0;if((m|0)!=(i|0)){if(m>>>0<l>>>0)F=m;else F=(m>>>0)%(l>>>0)|0;if((F|0)!=(p|0)){u=p;break a}}m=E+8|0;s=b[m+11>>0]|0;z=s<<24>>24<0;o=s&255;do if(((z?f[E+12>>2]|0:o)|0)==(q|0)){s=f[m>>2]|0;if(z)if(!(WKc(s,g,q)|0)){v=E;A=58;break c}else break;if((s&255)<<24>>24==h<<24>>24){s=m;y=o;C=g;do{y=y+-1|0;s=s+1|0;if(!y){v=E;A=58;break c}C=C+1|0}while((b[s>>0]|0)==(b[C>>0]|0))}}while(0);E=f[E>>2]|0;if(!E){u=p;break a}}if((A|0)==58){w=v+20|0;return w|0}}else u=p}else u=0;while(0);p=$Xc(24)|0;E=p+8|0;f[E>>2]=f[c>>2];f[E+4>>2]=f[c+4>>2];f[E+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[p+20>>2]=0;f[p+4>>2]=i;f[p>>2]=0;c=a+12|0;G=+(((f[c>>2]|0)+1|0)>>>0);H=+n[a+16>>2];do if(j|G>+(l>>>0)*H){E=(l>>>0<3|(l+-1&l|0)!=0)&1|l<<1;g=~~+X(+(G/H))>>>0;C$b(a,E>>>0<g>>>0?g:E);E=f[k>>2]|0;g=E+-1|0;if(!(g&E)){I=E;J=g&i;break}if(i>>>0<E>>>0){I=E;J=i}else{I=E;J=(i>>>0)%(E>>>0)|0}}else{I=l;J=u}while(0);u=(f[a>>2]|0)+(J<<2)|0;J=f[u>>2]|0;if(!J){l=a+8|0;f[p>>2]=f[l>>2];f[l>>2]=p;f[u>>2]=l;l=f[p>>2]|0;if(l|0){u=f[l+4>>2]|0;l=I+-1|0;if(l&I)if(u>>>0<I>>>0)K=u;else K=(u>>>0)%(I>>>0)|0;else K=u&l;L=(f[a>>2]|0)+(K<<2)|0;A=56}}else{f[p>>2]=f[J>>2];L=J;A=56}if((A|0)==56)f[L>>2]=p;f[c>>2]=(f[c>>2]|0)+1;v=p;w=v+20|0;return w|0}function Z1b(a){a=a|0;cYc(a);return}function _1b(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&4095](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function $1b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;c2b(a,d);g=T1b(f[a+8>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);u=c;return g|0}function a2b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+528|0;h=g+512|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;n=g+240|0;o=g+200|0;p=g+160|0;q=g+120|0;r=g+80|0;s=g+40|0;t=g;v=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(v>>>0>4294967279)jYc(h);if(v>>>0<11){b[h+11>>0]=v;if(!c)w=h;else{x=h;y=6}}else{z=v+16&-16;A=$Xc(z)|0;f[h>>2]=A;f[h+8>>2]=z|-2147483648;f[h+4>>2]=v;x=A;y=6}if((y|0)==6){g1c(x|0,32,v|0)|0;w=x}b[w+v>>0]=0;v=i+4|0;w=i+20|0;x=w;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));x=i+56|0;b[x>>0]=b[e>>0]|0;b[x+1>>0]=b[e+1>>0]|0;b[x+2>>0]=b[e+2>>0]|0;x=i+60|0;lYc(x,h);if(!(b[e>>0]|0))B=0;else B=b2b(a,v)|0;b[i>>0]=B&1;G1b(i,d);B=h+11|0;v=b[B>>0]|0;e=v<<24>>24<0;f[j>>2]=e?f[h>>2]|0:h;f[j+4>>2]=e?f[h+4>>2]|0:v&255;v=f[a>>2]|0;e=b[v+11>>0]|0;y=e<<24>>24<0;f[k>>2]=y?f[v>>2]|0:v;f[k+4>>2]=y?f[v+4>>2]|0:e&255;e=itc(f[a+8>>2]|0,l+8|0)|0;f[l>>2]=e;v=dJc(e)|0;f[l+4>>2]=v;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;Uoc(d,484756,j,k,l,m,n,o,p,q,r,s);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(I1b(c,f[a+16>>2]|0,f[(f[(f[a+12>>2]|0)+8>>2]|0)+8>>2]|0,j)|0){a=b[j+11>>0]|0;c=a<<24>>24<0;f[k>>2]=c?f[j>>2]|0:j;f[k+4>>2]=c?f[j+4>>2]|0:a&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;Uoc(d,484766,k,l,m,n,o,p,q,r,s,t)}AYc(d,484362)|0;K1b(i,d);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);x=i+44|0;j=f[x>>2]|0;if(j|0){d=i+48|0;t=f[d>>2]|0;if((t|0)==(j|0))C=j;else{s=t;while(1){t=s+-12|0;f[d>>2]=t;if((b[t+11>>0]|0)<0){cYc(f[t>>2]|0);D=f[d>>2]|0}else D=t;if((D|0)==(j|0))break;else s=D}C=f[x>>2]|0}cYc(C)}C=i+32|0;if((b[C+11>>0]|0)<0)cYc(f[C>>2]|0);if((b[w+11>>0]|0)<0)cYc(f[w>>2]|0);if((b[B>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function b2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+12|0;e=c;f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;h=a+12|0;c2b(f[h>>2]|0,e);i=f[g>>2]|0;j=e+8|0;k=f[j>>2]|0;if((i|0)==(k|0)){Tv(e,170908);l=f[g>>2]|0;m=f[j>>2]|0}else{f[i>>2]=f[42727];j=i+4|0;f[g>>2]=j;l=j;m=k}k=f[h>>2]|0;j=(a-(f[k+28>>2]|0)|0)/20|0;f[d>>2]=j;if(l>>>0<m>>>0){f[l>>2]=j;f[g>>2]=l+4;n=k}else{LA(e,d);n=f[h>>2]|0}h=T1b(f[n+8>>2]|0,e,b)|0;b=f[e>>2]|0;if(!b){u=c;return h|0}e=f[g>>2]|0;if((e|0)!=(b|0))f[g>>2]=e+(~((e+-4-b|0)>>>2)<<2);cYc(b);u=c;return h|0}function c2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;if(!g){h=b+4|0;i=f[h>>2]|0;j=b+8|0;if((i|0)==(f[j>>2]|0)){Tv(b,170880);k=f[e>>2]|0;l=a;if(!k){m=l;n=d;o=15}else{p=k+32|0;q=l;r=d}}else{f[i>>2]=f[42720];f[h>>2]=i+4;m=a;n=d;o=15}if((o|0)==15){p=(f[a+8>>2]|0)+72|0;q=m;r=n}n=(q-(f[p>>2]|0)|0)/48|0;f[d>>2]=n;p=f[h>>2]|0;if(p>>>0<(f[j>>2]|0)>>>0){f[p>>2]=n;f[h>>2]=p+4}else LA(b,d);u=c;return}S1b(g,b);g=b+4|0;p=f[g>>2]|0;h=b+8|0;if((p|0)==(f[h>>2]|0))Tv(b,170900);else{f[p>>2]=f[42725];f[g>>2]=p+4}p=f[e>>2]|0;if(!p)s=(f[a+8>>2]|0)+72|0;else s=p+32|0;p=(a-(f[s>>2]|0)|0)/48|0;f[d>>2]=p;s=f[g>>2]|0;if(s>>>0<(f[h>>2]|0)>>>0){f[s>>2]=p;f[g>>2]=s+4}else LA(b,d);u=c;return}function d2b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+64|0;h=g+48|0;i=g;j=g+24|0;mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);if((f[(f[(f[h>>2]|0)+8>>2]|0)+8>>2]|0)==(d|0)){k=e2b(a,c,e)|0;u=g;return k|0}mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);W$b(h,f[d+16>>2]|0,d,f[(f[h>>2]|0)+4>>2]|0);d=f[h+4>>2]|0;if((f[h>>2]|0)!=1|(d|0)==0){k=e2b(a,c,e)|0;u=g;return k|0}rgc(i);l=pgc(i,d)|0;d=_i[f[(f[l>>2]|0)+12>>2]&2047](l)|0;UZb(h,c);l=NZb(d,h)|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if(l)m=d;else{u_b(j,2,479317,2297);l=p_b(j,484786)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);r_b(g+60|0,q_b(l,f[(f[h>>2]|0)+4>>2]|0)|0);v_b(j);m=c}c=e2b(a,m,e)|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);ngc(i);k=c;u=g;return k|0}function e2b(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=u;u=u+96|0;h=g+80|0;i=g+64|0;j=g+52|0;k=g;l=g+40|0;m=f[e>>2]|0;n=e+4|0;o=f[n>>2]|0;if((o|0)!=(m|0)){p=o;while(1){o=p+-12|0;f[n>>2]=o;if((b[o+11>>0]|0)<0){cYc(f[o>>2]|0);q=f[n>>2]|0}else q=o;if((q|0)==(m|0))break;else p=q}}mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);q=f[h+4>>2]|0;f[i>>2]=0;p=i+4|0;f[p>>2]=0;f[i+8>>2]=0;Ti[f[(f[q>>2]|0)+64>>2]&511](q,c,i);m=f[p>>2]|0;o=f[i>>2]|0;r=o;if((m|0)==(o|0)){s=m;t=r}else{m=a+1|0;o=h+11|0;v=h+4|0;w=a<<1;a=j+11|0;x=j+4|0;y=e+8|0;z=k+11|0;A=l+11|0;B=h+11|0;C=h+4|0;D=h+11|0;E=l+11|0;F=h+4|0;G=h+8|0;H=h+12|0;I=0;J=r;while(1){r=f[J+(I<<2)>>2]|0;if((f[r+32>>2]|0)==3){K=hj[f[(f[q>>2]|0)+24>>2]&511](q,c,r)|0;if((K|0)>0){L=1;M=K;N=14}}else{L=0;M=1;N=14}if((N|0)==14){N=0;K=0;do{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=f[(f[i>>2]|0)+(I<<2)>>2]|0;O=f[r+24>>2]|0;if(O|0?(f[O>>2]|0)!=2:0){f[h>>2]=80424;f[F>>2]=2231;b[G>>0]=0;f[H>>2]=r;J_b(O,h)}if((f[r+28>>2]|1|0)==11){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;lqc(k);f[k>>2]=m;nqc(k,c,f[(f[i>>2]|0)+(I<<2)>>2]|0,L?K:-1,h);AYc(j,484824)|0;r=b[o>>0]|0;O=r<<24>>24<0;zYc(j,O?f[h>>2]|0:h,O?f[v>>2]|0:r&255)|0;vYc(j,w,32)|0;AYc(j,506651)|0;mqc(k);if((b[o>>0]|0)<0)cYc(f[h>>2]|0)}else oqc(c,f[(f[i>>2]|0)+(I<<2)>>2]|0,L?K:-1,j);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=f[(f[i>>2]|0)+(I<<2)>>2]|0;if(b[r+38>>0]|0){SGa(l,484827,f[r+4>>2]|0);O=AYc(l,528047)|0;P=f[O>>2]|0;Q=O+4|0;f[k>>2]=f[Q>>2];d[k+4>>1]=d[Q+4>>1]|0;b[k+6>>0]=b[Q+6>>0]|0;Q=b[O+11>>0]|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;if((b[B>>0]|0)<0){b[f[h>>2]>>0]=0;f[C>>2]=0}else{b[h>>0]=0;b[B>>0]=0}sYc(h,0);f[h>>2]=P;f[C>>2]=f[k>>2];d[C+4>>1]=d[k+4>>1]|0;b[C+6>>0]=b[k+6>>0]|0;b[D>>0]=Q;f[k>>2]=0;d[k+4>>1]=0;b[k+6>>0]=0;if((b[E>>0]|0)<0)cYc(f[l>>2]|0)}else oYc(h,f[r>>2]|0)|0;AN(l,h,496529);r=b[a>>0]|0;Q=r<<24>>24<0;P=zYc(l,Q?f[j>>2]|0:j,Q?f[x>>2]|0:r&255)|0;f[k>>2]=f[P>>2];f[k+4>>2]=f[P+4>>2];f[k+8>>2]=f[P+8>>2];f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;P=f[n>>2]|0;if(P>>>0>=(f[y>>2]|0)>>>0){QA(e,k);if((b[z>>0]|0)<0)cYc(f[k>>2]|0)}else{f[P>>2]=f[k>>2];f[P+4>>2]=f[k+4>>2];f[P+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[n>>2]=(f[n>>2]|0)+12}if((b[A>>0]|0)<0)cYc(f[l>>2]|0);if((b[B>>0]|0)<0)cYc(f[h>>2]|0);if((b[a>>0]|0)<0)cYc(f[j>>2]|0);K=K+1|0}while((K|0)<(M|0))}I=I+1|0;K=f[p>>2]|0;P=f[i>>2]|0;r=P;if(I>>>0>=K-P>>2>>>0){s=K;t=r;break}else J=r}}J=s;s=(f[e>>2]|0)!=(f[n>>2]|0);if(!t){u=g;return s|0}if((J|0)!=(t|0))f[p>>2]=J+(~((J+-4-t|0)>>>2)<<2);cYc(t);u=g;return s|0}function f2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=a+38|0;if(!(b[g>>0]|0)){h=a+48|0;S1b(f[h>>2]|0,c);i=c+4|0;j=f[i>>2]|0;k=c+8|0;if((j|0)==(f[k>>2]|0))Tv(c,170888);else{f[j>>2]=f[42722];f[i>>2]=j+4}do if(b[g>>0]|0){j=f[a+56>>2]|0;l=a;if(!j){m=l-(f[(f[a+20>>2]|0)+80>>2]|0)|0;break}else{m=l-(f[j+40>>2]|0)|0;break}}else m=a-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);h=(m|0)/88|0;f[e>>2]=h;m=f[i>>2]|0;if(m>>>0<(f[k>>2]|0)>>>0){f[m>>2]=h;f[i>>2]=m+4}else LA(c,e);u=d;return}m=a+56|0;i=f[m>>2]|0;if(!i){h=c+4|0;k=f[h>>2]|0;j=c+8|0;if((k|0)==(f[j>>2]|0)){Tv(c,170884);if(!(b[g>>0]|0)){n=a-(f[(f[a+48>>2]|0)+20>>2]|0)|0;o=e}else{p=e;q=7}}else{f[k>>2]=f[42721];f[h>>2]=k+4;p=e;q=7}do if((q|0)==7){k=f[m>>2]|0;l=a;if(!k){n=l-(f[(f[a+20>>2]|0)+80>>2]|0)|0;o=p;break}else{n=l-(f[k+40>>2]|0)|0;o=p;break}}while(0);p=(n|0)/88|0;f[e>>2]=p;n=f[h>>2]|0;if(n>>>0<(f[j>>2]|0)>>>0){f[n>>2]=p;f[h>>2]=n+4}else LA(c,e);u=d;return}S1b(i,c);i=c+4|0;n=f[i>>2]|0;h=c+8|0;if((n|0)==(f[h>>2]|0))Tv(c,170892);else{f[n>>2]=f[42723];f[i>>2]=n+4}do if(b[g>>0]|0){n=f[m>>2]|0;p=a;if(!n){r=p-(f[(f[a+20>>2]|0)+80>>2]|0)|0;break}else{r=p-(f[n+40>>2]|0)|0;break}}else r=a-(f[(f[a+48>>2]|0)+20>>2]|0)|0;while(0);a=(r|0)/88|0;f[e>>2]=a;r=f[i>>2]|0;if(r>>>0<(f[h>>2]|0)>>>0){f[r>>2]=a;f[i>>2]=r+4}else LA(c,e);u=d;return}function g2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;e=$Xc(4)|0;w_b(e);f[a>>2]=e;f[a+4>>2]=c;f[a+8>>2]=d;f[a+12>>2]=0;d=$Xc(232)|0;p$b(d);f[a+16>>2]=d;b[a+20>>0]=1;d=a+21|0;f[a+32>>2]=0;f[a+36>>2]=0;b[d>>0]=0;b[d+1>>0]=0;b[d+2>>0]=0;b[d+3>>0]=0;f[a+28>>2]=a+32;return}function h2b(){var a=0,b=0;a=f[223536]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223536]=0;a=f[223535]|0;if(!a){f[223535]=0;return}b=f[a>>2]|0;if(b|0){x_b(b);cYc(b)}RQ(a+28|0,f[a+32>>2]|0);b=f[a+16>>2]|0;if(b|0){u$b(b);cYc(b)}cYc(a);f[223535]=0;return}function i2b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;j1b(h,c,f[c>>2]|0,d,e);e=f[h>>2]|0;if(!e){i=h;j=f[i+4>>2]|0;k=a;f[k>>2]=f[i>>2];f[k+4>>2]=j;u=g;return}if(!(b[(f[c>>2]|0)+20>>0]|0)){j=h;k=f[j+4>>2]|0;i=a;f[i>>2]=f[j>>2];f[i+4>>2]=k;u=g;return}switch(e|0){case 8:{l=h+4|0;m=14;break}case 1:{l=(f[h+4>>2]|0)+8|0;m=14;break}case 2:{l=(f[h+4>>2]|0)+20|0;m=14;break}case 3:{l=(f[(f[h+4>>2]|0)+8>>2]|0)+8|0;m=14;break}case 4:{l=(f[h+4>>2]|0)+8|0;m=14;break}case 5:{l=(f[(f[h+4>>2]|0)+12>>2]|0)+8|0;m=14;break}case 6:{l=(f[h+4>>2]|0)+8|0;m=14;break}case 7:{l=(f[(f[h+4>>2]|0)+8>>2]|0)+8|0;m=14;break}default:n=0}if((m|0)==14)n=f[l>>2]|0;l=n;m=f[c+40>>2]|0;a:do if((n|0)!=(m|0)){k=c+52|0;i=f[k>>2]|0;if(i|0){j=i;do{i=f[j+16>>2]|0;if(n>>>0<i>>>0)o=j;else{if(i>>>0>=n>>>0)break a;o=j+4|0}j=f[o>>2]|0}while((j|0)!=0)}b:do if((e|0)==8){j=m+4|0;i=f[j>>2]|0;p=b[i+11>>0]|0;q=d+11|0;r=b[q>>0]|0;s=r<<24>>24<0;t=d+4|0;v=s?f[t>>2]|0:r&255;do if((p<<24>>24<0?f[i+4>>2]|0:p&255)>>>0>=v>>>0?(LYc(i,0,v,s?f[d>>2]|0:d,v)|0)==0:0){r=f[j>>2]|0;w=b[r+11>>0]|0;x=w<<24>>24<0;if(x)y=f[r+4>>2]|0;else y=w&255;w=b[q>>0]|0;z=w<<24>>24<0?f[t>>2]|0:w&255;if((y|0)!=(z|0)){if(x)A=f[r>>2]|0;else A=r;if((b[A+z>>0]|0)!=46)break}z=h;r=f[z+4>>2]|0;x=a;f[x>>2]=f[z>>2];f[x+4>>2]=r;u=g;return}while(0);j=f[c+48>>2]|0;if((j|0)!=(k|0)){v=j;while(1){j=f[v+16>>2]|0;if((j|0?(s=j+4|0,j=f[s>>2]|0,i=b[j+11>>0]|0,p=b[q>>0]|0,r=p<<24>>24<0,x=r?f[t>>2]|0:p&255,(i<<24>>24<0?f[j+4>>2]|0:i&255)>>>0>=x>>>0):0)?(LYc(j,0,x,r?f[d>>2]|0:d,x)|0)==0:0){x=f[s>>2]|0;s=b[x+11>>0]|0;r=s<<24>>24<0;if(r)B=f[x+4>>2]|0;else B=s&255;s=b[q>>0]|0;j=s<<24>>24<0?f[t>>2]|0:s&255;if((B|0)==(j|0))break;if(r)C=f[x>>2]|0;else C=x;if((b[C+j>>0]|0)==46)break}j=f[v+4>>2]|0;if(!j){x=v+8|0;r=f[x>>2]|0;if((f[r>>2]|0)==(v|0))D=r;else{r=x;do{x=f[r>>2]|0;r=x+8|0;s=f[r>>2]|0}while((f[s>>2]|0)!=(x|0));D=s}}else{r=j;while(1){s=f[r>>2]|0;if(!s)break;else r=s}D=r}if((D|0)==(k|0))break b;else v=D}v=h;t=f[v+4>>2]|0;q=a;f[q>>2]=f[v>>2];f[q+4>>2]=t;u=g;return}}while(0);f[c+72>>2]=l;oYc(c+76|0,d)|0;k=a;f[k>>2]=0;f[k+4>>2]=0;u=g;return}while(0);d=c+60|0;l=c+64|0;D=f[l>>2]|0;if(D|0){C=l;B=D;c:while(1){A=B;while(1){if((f[A+16>>2]|0)>>>0>=n>>>0)break;y=f[A+4>>2]|0;if(!y){E=C;break c}else A=y}B=f[A>>2]|0;if(!B){E=A;break}else C=A}if((E|0)!=(l|0)?n>>>0>=(f[E+16>>2]|0)>>>0:0){n=f[E+4>>2]|0;if(!n){l=E+8|0;C=f[l>>2]|0;if((f[C>>2]|0)==(E|0))F=C;else{C=l;do{l=f[C>>2]|0;C=l+8|0;B=f[C>>2]|0}while((f[B>>2]|0)!=(l|0));F=B}}else{C=n;while(1){n=f[C>>2]|0;if(!n)break;else C=n}F=C}if((f[d>>2]|0)==(E|0))f[d>>2]=F;F=c+68|0;f[F>>2]=(f[F>>2]|0)+-1;XIa(D,E);cYc(E)}}E=h;h=f[E+4>>2]|0;D=a;f[D>>2]=f[E>>2];f[D+4>>2]=h;u=g;return}function j2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=u;u=u+448|0;g=e+424|0;h=e+412|0;i=e+400|0;j=e+360|0;k=e+320|0;l=e+280|0;m=e+240|0;n=e+200|0;o=e+160|0;p=e+120|0;q=e+80|0;r=e+40|0;s=e;t=c+16|0;if(!(f[t>>2]|0)){v=gfc()|0;f[t>>2]=v}v=c+60|0;if((f[v>>2]|0)>0){t=c+28|0;w=d+44|0;x=0;do{j2b(a,(f[t>>2]|0)+(x*88|0)|0,f[(f[w>>2]|0)+4+(x<<2)>>2]|0);x=x+1|0}while((x|0)<(f[v>>2]|0))}v=c+64|0;if((f[v>>2]|0)>0){x=c+32|0;w=0;do{t=f[x>>2]|0;y=t+(w*48|0)+16|0;if(!(f[y>>2]|0)){z=mfc()|0;f[y>>2]=z}z=t+(w*48|0)+24|0;y=f[z>>2]|0;if((y|0)>0){A=t+(w*48|0)+28|0;t=0;B=y;while(1){y=(f[A>>2]|0)+(t*20|0)+16|0;if(!(f[y>>2]|0)){C=ofc()|0;f[y>>2]=C;D=f[z>>2]|0}else D=B;t=t+1|0;if((t|0)>=(D|0))break;else B=D}}w=w+1|0}while((w|0)<(f[v>>2]|0))}v=c+52|0;if((f[v>>2]|0)>0){w=c+20|0;D=d+28|0;x=0;do{k2b(a,(f[w>>2]|0)+(x*88|0)|0,f[(f[D>>2]|0)+4+(x<<2)>>2]|0);x=x+1|0}while((x|0)<(f[v>>2]|0))}x=c+72|0;if((f[x>>2]|0)>0){D=c+40|0;w=d+92|0;B=0;do{k2b(a,(f[D>>2]|0)+(B*88|0)|0,f[(f[w>>2]|0)+4+(B<<2)>>2]|0);B=B+1|0}while((B|0)<(f[x>>2]|0))}x=c+68|0;B=f[x>>2]|0;if((B|0)>0){w=c+36|0;D=0;t=B;while(1){B=(f[w>>2]|0)+(D*12|0)+8|0;if(!(f[B>>2]|0)){z=cfc()|0;f[B>>2]=z;E=f[x>>2]|0}else E=t;D=D+1|0;if((D|0)>=(E|0))break;else t=E}}E=f[v>>2]|0;if((E|0)>0){t=c+20|0;D=c+4|0;x=d+28|0;w=j+4|0;z=k+4|0;B=l+4|0;A=m+4|0;C=n+4|0;y=o+4|0;F=p+4|0;G=q+4|0;H=r+4|0;I=s+4|0;J=i+11|0;K=g+11|0;L=h+11|0;M=c+24|0;N=0;O=E;while(1){P=f[t>>2]|0;Q=f[P+(N*88|0)+52>>2]|0;if(!Q)R=O;else{if((f[Q+16>>2]|0)>0?(S=N+-1|0,(f[P+(S*88|0)+52>>2]|0)!=(Q|0)):0){AN(h,f[D>>2]|0,528338);P=f[(f[t>>2]|0)+(S*88|0)>>2]|0;T=b[P+11>>0]|0;U=T<<24>>24<0;V=zYc(h,U?f[P>>2]|0:P,U?f[P+4>>2]|0:T&255)|0;f[g>>2]=f[V>>2];f[g+4>>2]=f[V+4>>2];f[g+8>>2]=f[V+8>>2];f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;V=f[(f[x>>2]|0)+4+(S<<2)>>2]|0;T=f[(f[t>>2]|0)+(S*88|0)>>2]|0;S=b[T+11>>0]|0;P=S<<24>>24<0;f[j>>2]=P?f[T>>2]|0:T;f[w>>2]=P?f[T+4>>2]|0:S&255;S=f[Q>>2]|0;T=b[S+11>>0]|0;P=T<<24>>24<0;f[k>>2]=P?f[S>>2]|0:S;f[z>>2]=P?f[S+4>>2]|0:T&255;f[l>>2]=0;f[B>>2]=-1;f[m>>2]=0;f[A>>2]=-1;f[n>>2]=0;f[C>>2]=-1;f[o>>2]=0;f[y>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[G>>2]=-1;f[r>>2]=0;f[H>>2]=-1;f[s>>2]=0;f[I>>2]=-1;Toc(i,486349,j,k,l,m,n,o,p,q,r,s);q0b(a,g,V,9,i);if((b[J>>0]|0)<0)cYc(f[i>>2]|0);if((b[K>>0]|0)<0)cYc(f[g>>2]|0);if((b[L>>0]|0)<0)cYc(f[h>>2]|0);W=f[v>>2]|0}else W=O;V=(f[M>>2]|0)+(((Q-(f[(f[Q+8>>2]|0)+24>>2]|0)|0)/28|0)*28|0)+16|0;f[V>>2]=(f[V>>2]|0)+1;R=W}N=N+1|0;if((N|0)>=(R|0)){X=R;break}else O=R}}else X=E;E=c+56|0;if((f[E>>2]|0)>0){R=c+24|0;O=c+4|0;N=d+108|0;d=g+11|0;W=h+11|0;M=a+4|0;L=0;do{K=f[R>>2]|0;i=K+(L*28|0)+16|0;J=f[i>>2]|0;if(!J){AN(h,f[O>>2]|0,528338);s=f[K+(L*28|0)>>2]|0;r=b[s+11>>0]|0;q=r<<24>>24<0;p=zYc(h,q?f[s>>2]|0:s,q?f[s+4>>2]|0:r&255)|0;f[g>>2]=f[p>>2];f[g+4>>2]=f[p+4>>2];f[g+8>>2]=f[p+8>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;p0b(a,g,f[(f[N>>2]|0)+4+(L<<2)>>2]|0,0,486480);if((b[d>>0]|0)<0)cYc(f[g>>2]|0);if((b[W>>0]|0)<0)cYc(f[h>>2]|0);Y=f[i>>2]|0}else Y=J;J=f[M>>2]|0;p=Y<<2;if(!p)Z=0;else{r=$Xc(p)|0;f[g>>2]=r;p=J+124|0;s=f[p>>2]|0;if((s|0)==(f[J+128>>2]|0))wN(J+120|0,g);else{f[s>>2]=r;f[p>>2]=(f[p>>2]|0)+4}Z=f[g>>2]|0}f[K+(L*28|0)+20>>2]=Z;f[i>>2]=0;i=K+(L*28|0)+24|0;if(!(f[i>>2]|0)){K=kfc()|0;f[i>>2]=K}L=L+1|0}while((L|0)<(f[E>>2]|0));_=f[v>>2]|0}else _=X;if((_|0)<=0){u=e;return}X=c+20|0;v=c+24|0;c=0;do{E=f[X>>2]|0;L=f[E+(c*88|0)+52>>2]|0;if(L|0){Z=f[v>>2]|0;g=(L-(f[(f[L+8>>2]|0)+24>>2]|0)|0)/28|0;L=Z+(g*28|0)+16|0;Y=f[L>>2]|0;f[E+(c*88|0)+44>>2]=Y;M=f[Z+(g*28|0)+20>>2]|0;f[L>>2]=Y+1;f[M+(Y<<2)>>2]=E+(c*88|0)}c=c+1|0}while((c|0)<(_|0));u=e;return}function k2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+464|0;g=e+40|0;h=e;i=e+416|0;j=e+376|0;k=e+336|0;l=e+296|0;m=e+256|0;n=e+216|0;o=e+176|0;p=e+136|0;q=e+96|0;r=e+56|0;s=c+68|0;if(!(f[s>>2]|0)){t=ifc()|0;f[s>>2]=t}t=a+44|0;p2b(f[t>>2]|0,c);s=d+8|0;if(f[s>>2]&2|0){v=d+20|0;w=f[v>>2]|0;x=c+4|0;k1b(h,a,w,f[x>>2]|0,0,1);y=f[h>>2]|0;do if(!y){z=f[a>>2]|0;if(b[z+22>>0]|0?(l1b(g,z,w,2),z=g,A=f[z>>2]|0,B=f[z+4>>2]|0,z=h,f[z>>2]=A,f[z+4>>2]=B,A|0):0){C=A;break}m2b(a,f[x>>2]|0,d,3,f[v>>2]|0);u=e;return}else C=y;while(0);if((C|0)!=1){C=f[x>>2]|0;SGa(i,505469,f[v>>2]|0);v=AYc(i,485257)|0;f[g>>2]=f[v>>2];f[g+4>>2]=f[v+4>>2];f[g+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;q0b(a,C,d,3,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=e;return}C=f[h+4>>2]|0;f[c+48>>2]=C;v=C;C=f[c+40>>2]|0;y=f[v+68>>2]|0;a:do if((y|0)>0){w=f[v+36>>2]|0;A=0;while(1){if((f[w+(A*12|0)>>2]|0)<=(C|0)?(f[w+(A*12|0)+4>>2]|0)>(C|0):0)break a;A=A+1|0;if((A|0)>=(y|0)){D=19;break}}}else D=19;while(0);if((D|0)==19?(y=f[x>>2]|0,x=f[v+4>>2]|0,v=b[x+11>>0]|0,A=v<<24>>24<0,f[i>>2]=A?f[x>>2]|0:x,f[i+4>>2]=A?f[x+4>>2]|0:v&255,v=itc(C,j+8|0)|0,f[j>>2]=v,C=dJc(v)|0,f[j+4>>2]=C,f[k>>2]=0,f[k+4>>2]=-1,f[l>>2]=0,f[l+4>>2]=-1,f[m>>2]=0,f[m+4>>2]=-1,f[n>>2]=0,f[n+4>>2]=-1,f[o>>2]=0,f[o+4>>2]=-1,f[p>>2]=0,f[p+4>>2]=-1,f[q>>2]=0,f[q+4>>2]=-1,f[r>>2]=0,f[r+4>>2]=-1,Toc(g,485782,i,j,k,l,m,n,o,p,q,r),q0b(a,y,d,1,g),(b[g+11>>0]|0)<0):0)cYc(f[g>>2]|0)}if(f[c+52>>2]|0?(f[c+32>>2]|0)!=1:0)p0b(a,f[c+4>>2]|0,d,0,485831);y=f[s>>2]|0;do if(!(y&4)){C=c+24|0;v=f[C>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(v,g)}v=c+28|0;if((f[v>>2]|1|0)!=11){x=f[C>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(x,g)}if((f[v>>2]|0)!=14)break}p0b(a,f[c+4>>2]|0,d,2,486085)}else{v=f[a>>2]|0;if(!(b[v+23>>0]|0)){x=f[d+36>>2]|0;E=(b[(x|0?x:538256)+55>>0]|0)!=0}else E=0;x=(b[v+21>>0]|0)!=0;v=x&(E^1);C=d+24|0;A=f[C>>2]|0;w=c+4|0;B=(f[d+52>>2]|0)==14|y>>>3&1;k1b(h,a,A,f[w>>2]|0,1,E|x^1);x=f[h>>2]|0;do if(!x){z=f[a>>2]|0;if(b[z+22>>0]|0?(l1b(g,z,A,B),z=g,F=f[z>>2]|0,G=f[z+4>>2]|0,z=h,f[z>>2]=F,f[z+4>>2]=G,F|0):0){H=F;break}if(!v){if(E){F=$Xc(32)|0;f[i>>2]=F;f[i+8>>2]=-2147483616;f[i+4>>2]=21;G=F;z=485891;I=G+21|0;do{b[G>>0]=b[z>>0]|0;G=G+1|0;z=z+1|0}while((G|0)<(I|0));b[F+21>>0]=0;i2b(g,a,i,1);z=g;G=f[z>>2]|0;I=f[z+4>>2]|0;z=h;f[z>>2]=G;f[z+4>>2]=I;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if(G|0){H=G;break}}m2b(a,f[w>>2]|0,d,2,f[C>>2]|0);u=e;return}lYc(i,f[C>>2]|0);G=a+4|0;I=f[G>>2]|0;z=$Xc(4)|0;f[z>>2]=0;f[g>>2]=z;J=I+100|0;K=f[J>>2]|0;if((K|0)==(f[I+104>>2]|0))v0b(I+96|0,g);else{f[K>>2]=z;f[J>>2]=(f[J>>2]|0)+4}f[c+24>>2]=f[g>>2];J=f[G>>2]|0;z=$Xc(12)|0;lYc(z,i);f[g>>2]=z;K=J+76|0;I=f[K>>2]|0;if((I|0)==(f[J+80>>2]|0))r0b(J+72|0,g);else{f[I>>2]=z;f[K>>2]=(f[K>>2]|0)+4}f[c+72>>2]=f[g>>2];if(f[s>>2]&8|0){K=f[G>>2]|0;z=f[d+28>>2]|0;I=$Xc(12)|0;lYc(I,z);f[g>>2]=I;z=K+76|0;J=f[z>>2]|0;if((J|0)==(f[K+80>>2]|0))r0b(K+72|0,g);else{f[J>>2]=I;f[z>>2]=(f[z>>2]|0)+4}f[c+76>>2]=f[g>>2]}q2b(f[t>>2]|0,c)|0;if(b[c+38>>0]|0)r2b(f[G>>2]|0,c)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=e;return}else H=x;while(0);if(!(f[s>>2]&512)){switch(H|0){case 1:{L=11;break}case 4:{L=14;break}default:{x=f[w>>2]|0;SGa(i,505469,f[C>>2]|0);v=AYc(i,485913)|0;f[g>>2]=f[v>>2];f[g+4>>2]=f[v+4>>2];f[g+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;q0b(a,x,d,2,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=e;return}}f[c+28>>2]=L}x=c+24|0;v=f[x>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(v,g)}v=c+28|0;do if((f[v>>2]|1|0)!=11){B=f[x>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(B,g)}if((f[v>>2]|0)!=14){p0b(a,f[w>>2]|0,d,2,486044);break}if((f[h>>2]|0)!=4){B=f[w>>2]|0;SGa(i,505469,f[C>>2]|0);A=AYc(i,485966)|0;f[g>>2]=f[A>>2];f[g+4>>2]=f[A+4>>2];f[g+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q0b(a,B,d,2,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=e;return}B=c+64|0;f[B>>2]=f[h+4>>2];A=f[x>>2]|0;if(A|0?(f[A>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(A,g)}A=c+36|0;if(!(b[(f[B>>2]|0)+20>>0]|0)){if(b[A>>0]|0){G=d+28|0;if(!(Ajc(f[G>>2]|0)|0)){p0b(a,f[w>>2]|0,d,4,485989);break}z=f[G>>2]|0;I=f[x>>2]|0;do if(I|0){if((f[I>>2]|0)==2)break;f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(I,g)}while(0);k1b(i,a,z,f[(f[B>>2]|0)+4>>2]|0,0,1);do if((f[i>>2]|0)==5){I=i+4|0;F=f[(f[I>>2]|0)+12>>2]|0;J=f[x>>2]|0;do if(J|0){if((f[J>>2]|0)==2)break;f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(J,g)}while(0);if((F|0)!=(f[B>>2]|0)){D=102;break}f[c+80>>2]=f[I>>2]}else D=102;while(0);if((D|0)==102){z=f[w>>2]|0;J=f[x>>2]|0;do if(J|0){if((f[J>>2]|0)==2)break;f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(J,g)}while(0);SGa(m,481246,f[(f[B>>2]|0)+4>>2]|0);J=AYc(m,483669)|0;f[l>>2]=f[J>>2];f[l+4>>2]=f[J+4>>2];f[l+8>>2]=f[J+8>>2];f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;J=f[G>>2]|0;K=b[J+11>>0]|0;M=K<<24>>24<0;N=zYc(l,M?f[J>>2]|0:J,M?f[J+4>>2]|0:K&255)|0;f[k>>2]=f[N>>2];f[k+4>>2]=f[N+4>>2];f[k+8>>2]=f[N+8>>2];f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;N=AYc(k,506102)|0;f[j>>2]=f[N>>2];f[j+4>>2]=f[N+4>>2];f[j+8>>2]=f[N+8>>2];f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;q0b(a,z,d,4,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0)}break}}else b[A>>0]=0;N=f[x>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(N,g)}if((f[(f[B>>2]|0)+24>>2]|0)>0){N=f[x>>2]|0;do if(N|0){if((f[N>>2]|0)==2)break;f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(N,g)}while(0);f[c+80>>2]=f[(f[B>>2]|0)+28>>2]}}else{if((f[h>>2]|0)==1){f[c+60>>2]=f[h+4>>2];if(!(b[c+36>>0]|0))break;p0b(a,f[w>>2]|0,d,4,485930);break}N=f[w>>2]|0;SGa(i,505469,f[C>>2]|0);A=AYc(i,485257)|0;f[g>>2]=f[A>>2];f[g+4>>2]=f[A+4>>2];f[g+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q0b(a,N,d,2,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=e;return}while(0)}while(0);if(q2b(f[t>>2]|0,c)|0){if(!(b[c+38>>0]|0)){u=e;return}D=a+4|0;if(r2b(f[D>>2]|0,c)|0){u=e;return}L=c+48|0;H=f[L>>2]|0;s=f[c+40>>2]|0;E=(f[D>>2]|0)+176|0;D=f[E>>2]|0;do if(D){y=E;C=D;b:while(1){w=C;while(1){x=f[w+16>>2]|0;if(x>>>0>=H>>>0){if(x>>>0>H>>>0)break;if((f[w+20>>2]|0)>=(s|0))break}x=f[w+4>>2]|0;if(!x){O=y;break b}else w=x}C=f[w>>2]|0;if(!C){O=w;break}else y=w}if((O|0)!=(E|0)?(y=f[O+16>>2]|0,y>>>0<=H>>>0):0){if(y>>>0>=H>>>0?(f[O+20>>2]|0)>(s|0):0){P=0;break}P=f[O+24>>2]|0}else P=0}else P=0;while(0);O=itc(s,h+8|0)|0;f[h>>2]=O;s=dJc(O)|0;f[h+4>>2]=s;s=f[(f[L>>2]|0)+4>>2]|0;L=b[s+11>>0]|0;O=L<<24>>24<0;f[i>>2]=O?f[s>>2]|0:s;f[i+4>>2]=O?f[s+4>>2]|0:L&255;L=f[P+4>>2]|0;s=b[L+11>>0]|0;O=s<<24>>24<0;f[j>>2]=O?f[L>>2]|0:L;f[j+4>>2]=O?f[L+4>>2]|0:s&255;s=f[f[P+20>>2]>>2]|0;P=b[s+11>>0]|0;L=P<<24>>24<0;f[k>>2]=L?f[s>>2]|0:s;f[k+4>>2]=L?f[s+4>>2]|0:P&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;Toc(g,486266,h,i,j,k,l,m,n,o,p,q);L0b(a,f[c+4>>2]|0,d,1,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);u=e;return}P=f[t>>2]|0;t=f[c+48>>2]|0;s=c+40|0;L=f[s>>2]|0;O=(t*65535|0)+L|0;H=f[P+80>>2]|0;c:do if(H){E=H+-1|0;D=(E&H|0)==0;if(!D)if(O>>>0<H>>>0)Q=O;else Q=(O>>>0)%(H>>>0)|0;else Q=E&O;y=f[(f[P+76>>2]|0)+(Q<<2)>>2]|0;if((y|0)!=0?(C=f[y>>2]|0,(C|0)!=0):0){d:do if(D){y=C;while(1){B=f[y+4>>2]|0;x=(O|0)==(B|0);if(!(x|(B&E|0)==(Q|0))){R=0;break c}if((x?(f[y+8>>2]|0)==(t|0):0)?(f[y+12>>2]|0)==(L|0):0){S=y;break d}y=f[y>>2]|0;if(!y){R=0;break c}}}else{y=C;while(1){w=f[y+4>>2]|0;if((O|0)==(w|0)){if((f[y+8>>2]|0)==(t|0)?(f[y+12>>2]|0)==(L|0):0){S=y;break d}}else{if(w>>>0<H>>>0)T=w;else T=(w>>>0)%(H>>>0)|0;if((T|0)!=(Q|0)){R=0;break c}}y=f[y>>2]|0;if(!y){R=0;break c}}}while(0);R=f[S+16>>2]|0}else R=0}else R=0;while(0);if(!t){f[g+8>>2]=0;b[g+11>>0]=7;b[g>>0]=b[479409]|0;b[g+1>>0]=b[479410]|0;b[g+2>>0]=b[479411]|0;b[g+3>>0]=b[479412]|0;b[g+4>>0]=b[479413]|0;b[g+5>>0]=b[479414]|0;b[g+6>>0]=b[479415]|0;b[g+7>>0]=0}else lYc(g,f[t+4>>2]|0);t=f[c+4>>2]|0;if(!(b[c+38>>0]|0)){c=itc(f[s>>2]|0,i+8|0)|0;f[i>>2]=c;S=dJc(c)|0;f[i+4>>2]=S;S=g+11|0;c=b[S>>0]|0;Q=c<<24>>24<0;f[j>>2]=Q?f[g>>2]|0:g;f[j+4>>2]=Q?f[g+4>>2]|0:c&255;c=f[R>>2]|0;Q=b[c+11>>0]|0;T=Q<<24>>24<0;f[k>>2]=T?f[c>>2]|0:c;f[k+4>>2]=T?f[c+4>>2]|0:Q&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;Toc(h,486205,i,j,k,l,m,n,o,p,q,r);q0b(a,t,d,1,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);U=S}else{S=itc(f[s>>2]|0,i+8|0)|0;f[i>>2]=S;s=dJc(S)|0;f[i+4>>2]=s;s=g+11|0;S=b[s>>0]|0;Q=S<<24>>24<0;f[j>>2]=Q?f[g>>2]|0:g;f[j+4>>2]=Q?f[g+4>>2]|0:S&255;S=f[R+4>>2]|0;R=b[S+11>>0]|0;Q=R<<24>>24<0;f[k>>2]=Q?f[S>>2]|0:S;f[k+4>>2]=Q?f[S+4>>2]|0:R&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;Toc(h,486136,i,j,k,l,m,n,o,p,q,r);q0b(a,t,d,1,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);U=s}if((b[U>>0]|0)<0)cYc(f[g>>2]|0);u=e;return}function l2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e;j=e+36|0;k=c+44|0;if(!(f[k>>2]|0)){l=sfc()|0;f[k>>2]=l}l=d+20|0;k=f[l>>2]|0;m=c+4|0;k1b(h,a,k,f[m>>2]|0,0,(b[(f[a>>2]|0)+21>>0]|0)==0);n=f[h>>2]|0;do if(!n){o=f[a>>2]|0;if(b[o+22>>0]|0?(l1b(g,o,k,0),o=g,p=f[o>>2]|0,q=f[o+4>>2]|0,o=h,f[o>>2]=p,f[o+4>>2]=q,p|0):0){r=p;s=9;break}if(!(b[(f[a>>2]|0)+21>>0]|0)){m2b(a,f[m>>2]|0,d,5,f[l>>2]|0);break}else{n2b(c+12|0,f[l>>2]|0,f[a+40>>2]|0);break}}else{r=n;s=9}while(0);do if((s|0)==9){if((r|0)==1){o2b(c+12|0,f[h+4>>2]|0);break}n=f[m>>2]|0;SGa(i,505469,f[l>>2]|0);k=AYc(i,485257)|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q0b(a,n,d,5,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}while(0);l=d+24|0;h=f[l>>2]|0;k1b(i,a,h,f[m>>2]|0,0,(b[(f[a>>2]|0)+21>>0]|0)==0);r=f[i>>2]|0;do if(!r){s=f[a>>2]|0;if(b[s+22>>0]|0?(l1b(g,s,h,0),s=g,n=f[s>>2]|0,k=f[s+4>>2]|0,s=i,f[s>>2]=n,f[s+4>>2]=k,n|0):0){t=n;break}if(!(b[(f[a>>2]|0)+21>>0]|0)){m2b(a,f[m>>2]|0,d,6,f[l>>2]|0);u=e;return}else{n2b(c+28|0,f[l>>2]|0,f[a+40>>2]|0);u=e;return}}else t=r;while(0);if((t|0)==1){o2b(c+28|0,f[i+4>>2]|0);u=e;return}i=f[m>>2]|0;SGa(j,505469,f[l>>2]|0);l=AYc(j,485257)|0;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q0b(a,i,d,6,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);u=e;return}function m2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+80|0;i=h+60|0;j=h+48|0;k=h+36|0;l=h+24|0;m=h+12|0;n=h;o=a+72|0;if(!(f[o>>2]|0)){p=a+88|0;q=p+11|0;r=b[q>>0]|0;if(r<<24>>24<0)s=f[a+92>>2]|0;else s=r&255;if(!s){SGa(j,505469,g);s=AYc(j,485514)|0;f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[i+8>>2]=f[s+8>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;q0b(a,c,d,e,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);u=h;return}else{t=q;v=p;w=r}}else{SGa(n,505469,a+76|0);r=AYc(n,485532)|0;f[m>>2]=f[r>>2];f[m+4>>2]=f[r+4>>2];f[m+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=f[f[o>>2]>>2]|0;o=b[r+11>>0]|0;p=o<<24>>24<0;q=zYc(m,p?f[r>>2]|0:r,p?f[r+4>>2]|0:o&255)|0;f[l>>2]=f[q>>2];f[l+4>>2]=f[q+4>>2];f[l+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;q=AYc(l,485559)|0;f[k>>2]=f[q>>2];f[k+4>>2]=f[q+4>>2];f[k+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;q=a+28|0;o=b[q+11>>0]|0;r=o<<24>>24<0;p=zYc(k,r?f[q>>2]|0:q,r?f[a+32>>2]|0:o&255)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;p=AYc(j,485589)|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];f[i+8>>2]=f[p+8>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;q0b(a,c,d,e,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);p=a+88|0;o=p+11|0;t=o;v=p;w=b[o>>0]|0}if(w<<24>>24<0)x=f[a+92>>2]|0;else x=w&255;if(!x){u=h;return}SGa(n,505469,g);x=AYc(n,485642)|0;f[m>>2]=f[x>>2];f[m+4>>2]=f[x+4>>2];f[m+8>>2]=f[x+8>>2];f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;x=b[t>>0]|0;t=x<<24>>24<0;w=zYc(m,t?f[a+88>>2]|0:v,t?f[a+92>>2]|0:x&255)|0;f[l>>2]=f[w>>2];f[l+4>>2]=f[w+4>>2];f[l+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;w=AYc(l,485661)|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2];f[k+8>>2]=f[w+8>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;w=b[g+11>>0]|0;x=w<<24>>24<0;t=zYc(k,x?f[g>>2]|0:g,x?f[g+4>>2]|0:w&255)|0;f[j>>2]=f[t>>2];f[j+4>>2]=f[t+4>>2];f[j+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;t=AYc(j,482765)|0;f[i>>2]=f[t>>2];f[i+4>>2]=f[t+4>>2];f[i+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;q0b(a,c,d,e,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);u=h;return}function n2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+192|0;g=e+168|0;h=e+144|0;i=e+120|0;j=e+96|0;k=e+72|0;l=e+48|0;m=e+174|0;n=e+24|0;o=e+173|0;p=e;q=e+172|0;if(f[a>>2]|0){u_b(h,3,479317,7105);r_b(e+178|0,p_b(h,485351)|0);v_b(h)}h=a+12|0;if(f[h>>2]|0){u_b(i,3,479317,7106);r_b(e+177|0,p_b(i,485328)|0);v_b(i)}i=a+4|0;if(f[i>>2]|0){u_b(j,3,479317,7107);r_b(e+176|0,p_b(j,485282)|0);v_b(j)}j=a+8|0;if(f[j>>2]|0){u_b(k,3,479317,7108);r_b(e+175|0,p_b(k,485305)|0);v_b(k)}if((d|0)!=0?(k=d+8|0,a=f[k>>2]|0,(a|0)!=0):0){r=k;s=a}else{u_b(l,3,479317,7109);r_b(m,p_b(l,485380)|0);v_b(l);l=d+8|0;r=l;s=f[l>>2]|0}if(!(b[s+21>>0]|0)){u_b(n,3,479317,7110);r_b(o,p_b(n,485416)|0);v_b(n)}if(b[d+49>>0]|0){u_b(p,3,479317,7111);r_b(q,p_b(p,485472)|0);v_b(p)}f[h>>2]=d;d=f[(f[r>>2]|0)+16>>2]|0;h=$Xc(12)|0;lYc(h,c);f[g>>2]=h;c=d+76|0;p=f[c>>2]|0;if((p|0)==(f[d+80>>2]|0))r0b(d+72|0,g);else{f[p>>2]=h;f[c>>2]=(f[c>>2]|0)+4}f[i>>2]=f[g>>2];i=f[(f[r>>2]|0)+16>>2]|0;r=$Xc(4)|0;f[r>>2]=0;f[g>>2]=r;c=i+100|0;h=f[c>>2]|0;if((h|0)==(f[i+104>>2]|0)){v0b(i+96|0,g);t=f[g>>2]|0;f[j>>2]=t;u=e;return}else{f[h>>2]=r;f[c>>2]=(f[c>>2]|0)+4;t=f[g>>2]|0;f[j>>2]=t;u=e;return}}function o2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;if(f[a+4>>2]|0){u_b(d,3,479317,7097);r_b(c+74|0,p_b(d,485282)|0);v_b(d)}if(f[a+8>>2]|0){u_b(e,3,479317,7098);r_b(c+73|0,p_b(e,485305)|0);v_b(e)}if(!(f[a+12>>2]|0)){f[a>>2]=b;u=c;return}u_b(g,3,479317,7099);r_b(c+72|0,p_b(g,485328)|0);v_b(g);f[a>>2]=b;u=c;return}function p2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+16|0;g=d+24|0;h=d+8|0;i=d;f[e>>2]=c;do if(b[c+38>>0]|0){j=f[c+56>>2]|0;if(!j){k=f[c+20>>2]|0;break}else{k=j;break}}else k=f[c+48>>2]|0;while(0);j=k;k=f[c+8>>2]|0;if((b[k+11>>0]|0)<0)l=f[k>>2]|0;else l=k;f[g>>2]=j;f[g+4>>2]=l;l=a+40|0;if(!(t2b(f[l>>2]|0,g,e)|0)){k=u2b(f[l>>2]|0,g)|0;f[h>>2]=k;t2b(a+20|0,g,h)|0}g=f[c+12>>2]|0;if((b[g+11>>0]|0)<0)m=f[g>>2]|0;else m=g;f[h>>2]=j;f[h+4>>2]=m;m=a+68|0;if(t2b(f[m>>2]|0,h,e)|0){u=d;return}e=u2b(f[m>>2]|0,h)|0;f[i>>2]=e;t2b(a+48|0,h,i)|0;u=d;return}function q2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0;c=b;d=f[b+48>>2]|0;e=f[b+40>>2]|0;b=a+76|0;g=(d*65535|0)+e|0;h=a+80|0;i=f[h>>2]|0;j=(i|0)==0;k=d;a:do if(!j){l=i+-1|0;m=(l&i|0)==0;if(!m)if(g>>>0<i>>>0)o=g;else o=(g>>>0)%(i>>>0)|0;else o=l&g;p=f[(f[b>>2]|0)+(o<<2)>>2]|0;if((p|0)!=0?(q=f[p>>2]|0,(q|0)!=0):0){if(m){m=q;while(1){p=f[m+4>>2]|0;if(!((p|0)==(g|0)|(p&l|0)==(o|0))){r=o;break a}if((f[m+8>>2]|0)==(k|0)?(f[m+12>>2]|0)==(e|0):0){s=0;break}m=f[m>>2]|0;if(!m){r=o;break a}}return s|0}else t=q;while(1){m=f[t+4>>2]|0;if((m|0)!=(g|0)){if(m>>>0<i>>>0)u=m;else u=(m>>>0)%(i>>>0)|0;if((u|0)!=(o|0)){r=o;break a}}if((f[t+8>>2]|0)==(k|0)?(f[t+12>>2]|0)==(e|0):0){s=0;break}t=f[t>>2]|0;if(!t){r=o;break a}}return s|0}else r=o}else r=0;while(0);o=$Xc(20)|0;t=o+8|0;f[t>>2]=d;f[t+4>>2]=e;f[o+16>>2]=c;f[o+4>>2]=g;f[o>>2]=0;c=a+88|0;v=+(((f[c>>2]|0)+1|0)>>>0);w=+n[a+92>>2];do if(j|v>+(i>>>0)*w){e=(i>>>0<3|(i+-1&i|0)!=0)&1|i<<1;t=~~+X(+(v/w))>>>0;A$b(b,e>>>0<t>>>0?t:e);e=f[h>>2]|0;t=e+-1|0;if(!(t&e)){x=e;y=t&g;break}if(g>>>0<e>>>0){x=e;y=g}else{x=e;y=(g>>>0)%(e>>>0)|0}}else{x=i;y=r}while(0);r=(f[b>>2]|0)+(y<<2)|0;y=f[r>>2]|0;if(!y){i=a+84|0;f[o>>2]=f[i>>2];f[i>>2]=o;f[r>>2]=i;i=f[o>>2]|0;if(i|0){r=f[i+4>>2]|0;i=x+-1|0;if(i&x)if(r>>>0<x>>>0)z=r;else z=(r>>>0)%(x>>>0)|0;else z=r&i;A=(f[b>>2]|0)+(z<<2)|0;B=33}}else{f[o>>2]=f[y>>2];A=y;B=33}if((B|0)==33)f[A>>2]=o;f[c>>2]=(f[c>>2]|0)+1;s=1;return s|0}function r2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c;e=b;g=f[b+48>>2]|0;h=f[b+40>>2]|0;f[d>>2]=g;f[d+4>>2]=h;b=a+172|0;i=a+176|0;j=f[i>>2]|0;do if(j){k=g;l=a+176|0;m=j;a:while(1){n=f[m+16>>2]|0;do if(k>>>0>=n>>>0){if(n>>>0>=k>>>0){o=f[m+20>>2]|0;if((h|0)<(o|0)){p=7;break}if((o|0)>=(h|0)){p=12;break a}}q=m+4|0;o=f[q>>2]|0;if(!o){p=11;break a}else{r=q;s=o}}else p=7;while(0);if((p|0)==7){p=0;n=f[m>>2]|0;if(!n){p=8;break}else{r=m;s=n}}l=r;m=s}if((p|0)==8){t=m;v=m;break}else if((p|0)==11){t=m;v=q;break}else if((p|0)==12){t=m;v=l;break}}else{t=i;v=i}while(0);if(f[v>>2]|0){w=0;u=c;return w|0}i=$Xc(28)|0;f[i+16>>2]=g;f[i+20>>2]=h;f[i+24>>2]=e;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=t;f[v>>2]=i;t=f[f[b>>2]>>2]|0;if(!t)x=i;else{f[b>>2]=t;x=f[v>>2]|0}UQ(f[a+176>>2]|0,x);x=a+180|0;f[x>>2]=(f[x>>2]|0)+1;x=a+224|0;v=f[x>>2]|0;if((v|0)==(f[a+228>>2]|0)){s2b(a+220|0,d);w=1;u=c;return w|0}else{a=d;d=f[a+4>>2]|0;t=v;f[t>>2]=f[a>>2];f[t+4>>2]=d;f[x>>2]=(f[x>>2]|0)+8;w=1;u=c;return w|0}return 0}function s2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function t2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0;e=f[c>>2]|0;g=f[c+4>>2]|0;c=f[d>>2]|0;d=e*65535|0;h=g;i=b[h>>0]|0;j=e;if(!(i<<24>>24))k=0;else{l=h;m=0;o=i;while(1){i=(m*5|0)+(o<<24>>24)|0;l=l+1|0;o=b[l>>0]|0;if(!(o<<24>>24)){k=i;break}else m=i}}m=k+d|0;d=a+4|0;k=f[d>>2]|0;o=(k|0)==0;a:do if(!o){l=k+-1|0;i=(l&k|0)==0;if(!i)if(m>>>0<k>>>0)p=m;else p=(m>>>0)%(k>>>0)|0;else p=l&m;q=f[(f[a>>2]|0)+(p<<2)>>2]|0;if((q|0)!=0?(r=f[q>>2]|0,(r|0)!=0):0){if(i){i=r;while(1){q=f[i+4>>2]|0;if(!((q|0)==(m|0)|(q&l|0)==(p|0))){s=p;break a}if((f[i+8>>2]|0)==(j|0)?(GIc(f[i+12>>2]|0,h)|0)==0:0){t=0;break}i=f[i>>2]|0;if(!i){s=p;break a}}return t|0}else u=r;while(1){i=f[u+4>>2]|0;if((i|0)!=(m|0)){if(i>>>0<k>>>0)v=i;else v=(i>>>0)%(k>>>0)|0;if((v|0)!=(p|0)){s=p;break a}}if((f[u+8>>2]|0)==(j|0)?(GIc(f[u+12>>2]|0,h)|0)==0:0){t=0;break}u=f[u>>2]|0;if(!u){s=p;break a}}return t|0}else s=p}else s=0;while(0);p=$Xc(20)|0;f[p+8>>2]=e;f[p+12>>2]=g;f[p+16>>2]=c;f[p+4>>2]=m;f[p>>2]=0;c=a+12|0;w=+(((f[c>>2]|0)+1|0)>>>0);x=+n[a+16>>2];do if(o|w>+(k>>>0)*x){g=(k>>>0<3|(k+-1&k|0)!=0)&1|k<<1;e=~~+X(+(w/x))>>>0;z$b(a,g>>>0<e>>>0?e:g);g=f[d>>2]|0;e=g+-1|0;if(!(e&g)){y=g;z=e&m;break}if(m>>>0<g>>>0){y=g;z=m}else{y=g;z=(m>>>0)%(g>>>0)|0}}else{y=k;z=s}while(0);s=(f[a>>2]|0)+(z<<2)|0;z=f[s>>2]|0;if(!z){k=a+8|0;f[p>>2]=f[k>>2];f[k>>2]=p;f[s>>2]=k;k=f[p>>2]|0;if(k|0){s=f[k+4>>2]|0;k=y+-1|0;if(k&y)if(s>>>0<y>>>0)A=s;else A=(s>>>0)%(y>>>0)|0;else A=s&k;B=(f[a>>2]|0)+(A<<2)|0;C=35}}else{f[p>>2]=f[z>>2];B=z;C=35}if((C|0)==35)f[B>>2]=p;f[c>>2]=(f[c>>2]|0)+1;t=1;return t|0}function u2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[c>>2]|0;e=d*65535|0;g=f[c+4>>2]|0;c=b[g>>0]|0;h=d;if(!(c<<24>>24))i=0;else{d=g;j=0;k=c;while(1){c=(j*5|0)+(k<<24>>24)|0;d=d+1|0;k=b[d>>0]|0;if(!(k<<24>>24)){i=c;break}else j=c}}j=i+e|0;e=f[a+4>>2]|0;if(!e){l=0;return l|0}i=e+-1|0;k=(i&e|0)==0;if(!k)if(j>>>0<e>>>0)m=j;else m=(j>>>0)%(e>>>0)|0;else m=i&j;d=f[(f[a>>2]|0)+(m<<2)>>2]|0;if(!d){l=0;return l|0}a=f[d>>2]|0;if(!a){l=0;return l|0}a:do if(k){d=a;while(1){c=f[d+4>>2]|0;n=(c|0)==(j|0);if(!(n|(c&i|0)==(m|0))){l=0;o=24;break}if((n?(f[d+8>>2]|0)==(h|0):0)?(GIc(f[d+12>>2]|0,g)|0)==0:0){p=d;break a}d=f[d>>2]|0;if(!d){l=0;o=24;break}}if((o|0)==24)return l|0}else{d=a;while(1){n=f[d+4>>2]|0;if((n|0)==(j|0)){if((f[d+8>>2]|0)==(h|0)?(GIc(f[d+12>>2]|0,g)|0)==0:0){p=d;break a}}else{if(n>>>0<e>>>0)q=n;else q=(n>>>0)%(e>>>0)|0;if((q|0)!=(m|0)){l=0;o=24;break}}d=f[d>>2]|0;if(!d){l=0;o=24;break}}if((o|0)==24)return l|0}while(0);l=f[p+16>>2]|0;return l|0}function v2b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g+12|0;i=g;j=c+11|0;k=b[j>>0]|0;l=c+4|0;m=f[l>>2]|0;if(!((k<<24>>24<0?m:k&255)|0)){p0b(a,d,e,0,487292);u=g;return}n=h+11|0;o=i+11|0;p=0;q=k;k=m;while(1){m=b[(q<<24>>24<0?f[c>>2]|0:c)+p>>0]|0;do if(m<<24>>24<97)if(m<<24>>24<65)if((m+-48&255)>9){r=9;break}else{s=q;t=k;break}else if(m<<24>>24<91|m<<24>>24==95){s=q;t=k;break}else{r=9;break}else if(m<<24>>24>122)r=9;else{s=q;t=k}while(0);if((r|0)==9){r=0;SGa(i,505469,c);m=AYc(i,487306)|0;f[h>>2]=f[m>>2];f[h+4>>2]=f[m+4>>2];f[h+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;q0b(a,d,e,0,h);if((b[n>>0]|0)<0)cYc(f[h>>2]|0);if((b[o>>0]|0)<0)cYc(f[i>>2]|0);s=b[j>>0]|0;t=f[l>>2]|0}p=p+1|0;if(p>>>0>=(s<<24>>24<0?t:s&255)>>>0)break;else{q=s;k=t}}u=g;return}function w2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(60)|0;c9b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+68>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function x2b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;i=u;u=u+112|0;j=i+96|0;k=i;l=i+72|0;m=i+108|0;n=i+56|0;o=i+44|0;p=i+32|0;q=i+20|0;r=i+8|0;if(!d)s=f[a+40>>2]|0;else s=d;d=a+4|0;t=f[d>>2]|0;v=h;h=f[v>>2]|0;w=f[v+4>>2]|0;v=c+11|0;f[j>>2]=(b[v>>0]|0)<0?f[c>>2]|0:c;x=j+4|0;f[x>>2]=h;f[x+4>>2]=w;if(y2b(t+132|0,j)|0){x=(b[v>>0]|0)<0?f[c>>2]|0:c;f[j>>2]=x;y=t+200|0;z=f[y>>2]|0;if(z>>>0<(f[t+204>>2]|0)>>>0){f[z>>2]=x;f[y>>2]=(f[y>>2]|0)+4}else t0b(t+196|0,j);t=f[a+44>>2]|0;y=k;f[y>>2]=h;f[y+4>>2]=w;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];if(z2b(t,s,e,j)|0){A=1;u=i;return A|0}if(b[a+24>>0]|0){A=0;u=i;return A|0}u_b(l,2,479317,3991);r_b(m,p_b(q_b(p_b(l,505469)|0,c)|0,487100)|0);v_b(l);A=0;u=i;return A|0}l=f[d>>2]|0;f[j>>2]=(b[v>>0]|0)<0?f[c>>2]|0:c;v=X$b(l+132|0,j)|0;a:do if(!v)B=0;else{l=f[v+16>>2]|0;switch(f[v+12>>2]|0){case 8:{B=l;break a;break}case 1:{B=f[l+8>>2]|0;break a;break}case 2:{B=f[l+20>>2]|0;break a;break}case 3:{B=f[(f[l+8>>2]|0)+8>>2]|0;break a;break}case 4:{B=f[l+8>>2]|0;break a;break}case 5:{B=f[(f[l+12>>2]|0)+8>>2]|0;break a;break}case 6:{B=f[l+8>>2]|0;break a;break}case 7:{B=f[(f[l+8>>2]|0)+8>>2]|0;break a;break}default:{B=0;break a}}}while(0);if((B|0)!=(f[a+40>>2]|0)){SGa(p,505469,c);v=AYc(p,487261)|0;f[o>>2]=f[v>>2];f[o+4>>2]=f[v+4>>2];f[o+8>>2]=f[v+8>>2];f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;v=f[B>>2]|0;B=b[v+11>>0]|0;l=B<<24>>24<0;d=zYc(o,l?f[v>>2]|0:v,l?f[v+4>>2]|0:B&255)|0;f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];f[n+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;d=AYc(n,506102)|0;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;q0b(a,c,g,0,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);A=0;u=i;return A|0}d=KYc(c,46,-1)|0;if((d|0)==-1){SGa(n,505469,c);B=AYc(n,487213)|0;f[j>>2]=f[B>>2];f[j+4>>2]=f[B+4>>2];f[j+8>>2]=f[B+8>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;q0b(a,c,g,0,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);A=0;u=i;return A|0}mYc(q,c,d+1|0,-1,c);B=EYc(q,0,505469)|0;f[p>>2]=f[B>>2];f[p+4>>2]=f[B+4>>2];f[p+8>>2]=f[B+8>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;B=AYc(p,487235)|0;f[o>>2]=f[B>>2];f[o+4>>2]=f[B+4>>2];f[o+8>>2]=f[B+8>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;mYc(r,c,0,d,c);d=r+11|0;B=b[d>>0]|0;v=B<<24>>24<0;l=zYc(o,v?f[r>>2]|0:r,v?f[r+4>>2]|0:B&255)|0;f[n>>2]=f[l>>2];f[n+4>>2]=f[l+4>>2];f[n+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;l=AYc(n,506102)|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];f[j+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;q0b(a,c,g,0,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[d>>0]|0)<0)cYc(f[r>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);A=0;u=i;return A|0}function y2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(GIc(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(GIc(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=$Xc(20)|0;r=d+8|0;f[r>>2]=f[c>>2];f[r+4>>2]=f[c+4>>2];f[r+8>>2]=f[c+8>>2];f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){r=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;l=~~+X(+(t/u))>>>0;q$b(a,r>>>0<l>>>0?l:r);r=f[i>>2]|0;l=r+-1|0;if(!(l&r)){v=r;w=l&g;break}if(g>>>0<r>>>0){v=r;w=g}else{v=r;w=(g>>>0)%(r>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function z2b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0;g=c;h=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=h;i=e;e=f[i>>2]|0;j=f[i+4>>2]|0;i=g*65535|0;k=b[h>>0]|0;if(!(k<<24>>24))l=0;else{m=h;o=0;p=k;while(1){k=(o*5|0)+(p<<24>>24)|0;m=m+1|0;p=b[m>>0]|0;if(!(p<<24>>24)){l=k;break}else o=k}}o=l+i|0;i=a+4|0;l=f[i>>2]|0;p=(l|0)==0;a:do if(!p){m=l+-1|0;k=(m&l|0)==0;if(!k)if(o>>>0<l>>>0)q=o;else q=(o>>>0)%(l>>>0)|0;else q=m&o;r=f[(f[a>>2]|0)+(q<<2)>>2]|0;if((r|0)!=0?(s=f[r>>2]|0,(s|0)!=0):0){if(k){k=s;while(1){r=f[k+4>>2]|0;if(!((r|0)==(o|0)|(r&m|0)==(q|0))){t=q;break a}if((f[k+8>>2]|0)==(c|0)?(GIc(f[k+12>>2]|0,h)|0)==0:0){u=0;break}k=f[k>>2]|0;if(!k){t=q;break a}}return u|0}else v=s;while(1){k=f[v+4>>2]|0;if((k|0)!=(o|0)){if(k>>>0<l>>>0)w=k;else w=(k>>>0)%(l>>>0)|0;if((w|0)!=(q|0)){t=q;break a}}if((f[v+8>>2]|0)==(c|0)?(GIc(f[v+12>>2]|0,h)|0)==0:0){u=0;break}v=f[v>>2]|0;if(!v){t=q;break a}}return u|0}else t=q}else t=0;while(0);q=$Xc(24)|0;f[q+8>>2]=g;f[q+12>>2]=d;d=q+16|0;f[d>>2]=e;f[d+4>>2]=j;f[q+4>>2]=o;f[q>>2]=0;j=a+12|0;x=+(((f[j>>2]|0)+1|0)>>>0);y=+n[a+16>>2];do if(p|x>+(l>>>0)*y){d=(l>>>0<3|(l+-1&l|0)!=0)&1|l<<1;e=~~+X(+(x/y))>>>0;y$b(a,d>>>0<e>>>0?e:d);d=f[i>>2]|0;e=d+-1|0;if(!(e&d)){z=d;A=e&o;break}if(o>>>0<d>>>0){z=d;A=o}else{z=d;A=(o>>>0)%(d>>>0)|0}}else{z=l;A=t}while(0);t=(f[a>>2]|0)+(A<<2)|0;A=f[t>>2]|0;if(!A){l=a+8|0;f[q>>2]=f[l>>2];f[l>>2]=q;f[t>>2]=l;l=f[q>>2]|0;if(l|0){t=f[l+4>>2]|0;l=z+-1|0;if(l&z)if(t>>>0<z>>>0)B=t;else B=(t>>>0)%(z>>>0)|0;else B=t&l;C=(f[a>>2]|0)+(B<<2)|0;D=35}}else{f[q>>2]=f[A>>2];C=A;D=35}if((D|0)==35)f[C>>2]=q;f[j>>2]=(f[j>>2]|0)+1;u=1;return u|0}function A2b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g+8|0;i=g;j=a+4|0;k=f[j>>2]|0;l=c+16|0;m=f[l>>2]|0;n=$Xc(12)|0;lYc(n,m);f[h>>2]=n;m=k+76|0;o=f[m>>2]|0;if((o|0)==(f[k+80>>2]|0))r0b(k+72|0,h);else{f[o>>2]=n;f[m>>2]=(f[m>>2]|0)+4}f[e>>2]=f[h>>2];f[e+8>>2]=d;m=f[j>>2]|0;j=f[d+4>>2]|0;n=$Xc(12)|0;lYc(n,j);f[h>>2]=n;j=m+76|0;o=f[j>>2]|0;if((o|0)==(f[m+80>>2]|0))r0b(m+72|0,h);else{f[o>>2]=n;f[j>>2]=(f[j>>2]|0)+4}j=f[h>>2]|0;vYc(j,1,46)|0;n=f[e>>2]|0;o=b[n+11>>0]|0;m=o<<24>>24<0;zYc(j,m?f[n>>2]|0:n,m?f[n+4>>2]|0:o&255)|0;o=e+4|0;f[o>>2]=j;v2b(a,f[l>>2]|0,j,c);j=e+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;if(!(f[c+8>>2]&8)){f[e+44>>2]=0;p=c+32|0;q=b[p>>0]|0;r=e+48|0;b[r>>0]=q;s=c+33|0;t=b[s>>0]|0;v=e+49|0;b[v>>0]=t;w=f[o>>2]|0;x=f[e>>2]|0;f[i>>2]=7;y=i+4|0;f[y>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];x2b(a,w,d,x,c,h)|0;u=g;return}else{j=f[c+28>>2]|0;l=f[o>>2]|0;C2b(a,l,l,j|0?j:538536,e);p=c+32|0;q=b[p>>0]|0;r=e+48|0;b[r>>0]=q;s=c+33|0;t=b[s>>0]|0;v=e+49|0;b[v>>0]=t;w=f[o>>2]|0;x=f[e>>2]|0;f[i>>2]=7;y=i+4|0;f[y>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];x2b(a,w,d,x,c,h)|0;u=g;return}}function B2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(52)|0;G7b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+12>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function C2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(56)|0;n7b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+44>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function D2b(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=u;u=u+112|0;i=h+88|0;j=h+60|0;k=h+80|0;l=h+72|0;m=h+48|0;n=h+36|0;o=h+24|0;p=h+12|0;q=h;r=a+4|0;s=f[r>>2]|0;t=c+16|0;v=f[t>>2]|0;w=$Xc(12)|0;lYc(w,v);f[i>>2]=w;v=s+76|0;x=f[v>>2]|0;if((x|0)==(f[s+80>>2]|0))r0b(s+72|0,i);else{f[x>>2]=w;f[v>>2]=(f[v>>2]|0)+4}f[g>>2]=f[i>>2];v=g+8|0;f[v>>2]=f[c+24>>2];w=g+12|0;f[w>>2]=e;x=f[r>>2]|0;r=f[e+4>>2]|0;s=$Xc(12)|0;lYc(s,r);f[i>>2]=s;r=x+76|0;y=f[r>>2]|0;if((y|0)==(f[x+80>>2]|0))r0b(x+72|0,i);else{f[y>>2]=s;f[r>>2]=(f[r>>2]|0)+4}r=f[i>>2]|0;s=b[r+11>>0]|0;if(s<<24>>24<0)z=f[r+4>>2]|0;else z=s&255;s=f[e>>2]|0;y=b[s+11>>0]|0;if(y<<24>>24<0)A=f[s+4>>2]|0;else A=y&255;uYc(r,z-A|0,0);A=f[g>>2]|0;z=b[A+11>>0]|0;y=z<<24>>24<0;zYc(r,y?f[A>>2]|0:A,y?f[A+4>>2]|0:z&255)|0;z=g+4|0;f[z>>2]=r;v2b(a,f[t>>2]|0,r,c);if(!(f[c+8>>2]&2))f[g+16>>2]=0;else{r=f[c+20>>2]|0;t=f[z>>2]|0;K2b(a,t,t,r|0?r:538424,g)}r=f[z>>2]|0;t=e+12|0;A=f[t>>2]|0;y=f[g>>2]|0;f[k>>2]=5;f[k+4>>2]=g;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];k=x2b(a,r,A,y,c,i)|0;y=a+44|0;A=f[y>>2]|0;r=f[g>>2]|0;f[l>>2]=5;f[l+4>>2]=g;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];if(k|(z2b(A,e,r,i)|0)^1){B=f[y>>2]|0;f[i>>2]=g;C=f[w>>2]|0;D=f[v>>2]|0;f[j>>2]=C;E=j+4|0;f[E>>2]=D;F=B+96|0;L2b(F,j,i)|0;u=h;return};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;r=f[t>>2]|0;if(!r)oYc(i,f[(f[a+40>>2]|0)+4>>2]|0)|0;else oYc(i,f[r+4>>2]|0)|0;r=i+11|0;t=b[r>>0]|0;A=i+4|0;if((t<<24>>24<0?f[A>>2]|0:t&255)|0){SGa(m,505469,i);t=AYc(m,505469)|0;k=f[t>>2]|0;l=t+4|0;f[j>>2]=f[l>>2];d[j+4>>1]=d[l+4>>1]|0;b[j+6>>0]=b[l+6>>0]|0;l=b[t+11>>0]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;if((b[r>>0]|0)<0){b[f[i>>2]>>0]=0;f[A>>2]=0}else{b[i>>0]=0;b[r>>0]=0}sYc(i,0);f[i>>2]=k;f[A>>2]=f[j>>2];d[A+4>>1]=d[j+4>>1]|0;b[A+6>>0]=b[j+6>>0]|0;b[i+11>>0]=l;f[j>>2]=0;d[j+4>>1]=0;b[j+6>>0]=0;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0)}else tYc(i,487784)|0;l=f[z>>2]|0;SGa(q,487801,f[g>>2]|0);z=AYc(q,487933)|0;f[p>>2]=f[z>>2];f[p+4>>2]=f[z+4>>2];f[p+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;z=b[r>>0]|0;k=z<<24>>24<0;t=zYc(p,k?f[i>>2]|0:i,k?f[A>>2]|0:z&255)|0;f[o>>2]=f[t>>2];f[o+4>>2]=f[t+4>>2];f[o+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;t=AYc(o,487958)|0;f[n>>2]=f[t>>2];f[n+4>>2]=f[t+4>>2];f[n+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;t=f[e>>2]|0;e=b[t+11>>0]|0;z=e<<24>>24<0;A=zYc(n,z?f[t>>2]|0:t,z?f[t+4>>2]|0:e&255)|0;f[m>>2]=f[A>>2];f[m+4>>2]=f[A+4>>2];f[m+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;A=AYc(m,506102)|0;f[j>>2]=f[A>>2];f[j+4>>2]=f[A+4>>2];f[j+8>>2]=f[A+8>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q0b(a,l,c,0,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);if((b[r>>0]|0)<0)cYc(f[i>>2]|0);B=f[y>>2]|0;f[i>>2]=g;C=f[w>>2]|0;D=f[v>>2]|0;f[j>>2]=C;E=j+4|0;f[E>>2]=D;F=B+96|0;L2b(F,j,i)|0;u=h;return}function E2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=u;u=u+96|0;g=e+76|0;h=e+64|0;i=e+52|0;j=e+40|0;k=e+24|0;l=e+12|0;m=e;n=f[d>>2]|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[n>>2]|0:n;r=p?f[n+4>>2]|0:o&255;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if((r|0)>0){o=0;do{n=b[q+o>>0]|0;if(n<<24>>24!=95){p=n<<24>>24;BYc(h,((n+-65&255)<26?p+32|0:p)&255)}o=o+1|0}while((o|0)<(r|0))}r=i+4|0;f[r>>2]=0;o=i+8|0;f[o>>2]=0;q=i+4|0;f[i>>2]=q;p=d+24|0;do if((f[p>>2]|0)>0){n=d+28|0;s=h+11|0;t=h+4|0;v=g+11|0;w=g+8|0;x=g+4|0;y=k+12|0;z=k+11|0;A=k+11|0;B=l+11|0;C=m+11|0;D=d+8|0;E=c+28|0;F=g+11|0;G=j+11|0;H=0;a:while(1){I=f[n>>2]|0;J=I+(H*20|0)|0;K=J;L=f[J>>2]|0;M=b[L+11>>0]|0;N=M<<24>>24<0;O=N?f[L>>2]|0:L;P=N?f[L+4>>2]|0:M&255;M=(P|0)==0;L=b[s>>0]|0;b:do if(M){Q=0;R=0;S=L&255;T=30}else{N=L&255;c:do if(L<<24>>24<0){U=f[t>>2]|0;V=f[h>>2]|0;W=0;X=0;while(1){if(X>>>0>=U>>>0){Q=X;R=W;S=N;T=30;break b}Y=b[O+W>>0]|0;if(Y<<24>>24!=95){Z=Y<<24>>24;if((((Y+-65&255)<26?Z+32|0:Z)&255)<<24>>24==(b[V+X>>0]|0))_=X+1|0;else break c}else _=X;Z=W+1|0;if(Z>>>0<P>>>0){W=Z;X=_}else{Q=_;R=Z;S=N;T=30;break b}}}else{X=0;W=0;while(1){if(W>>>0>=N>>>0){Q=W;R=X;S=N;T=30;break b}V=b[O+X>>0]|0;if(V<<24>>24!=95){U=V<<24>>24;if((((V+-65&255)<26?U+32|0:U)&255)<<24>>24==(b[h+W>>0]|0))$=W+1|0;else break c}else $=W;U=X+1|0;if(U>>>0<P>>>0){X=U;W=$}else{Q=$;R=U;S=N;T=30;break b}}}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(P>>>0>4294967279){T=24;break a}if(P>>>0<11){b[v>>0]=P;aa=g}else{N=P+16&-16;W=$Xc(N)|0;f[g>>2]=W;f[w>>2]=N|-2147483648;f[x>>2]=P;aa=W}o1c(aa|0,O|0,P|0)|0;b[aa+P>>0]=0}while(0);do if((T|0)==30){T=0;if(Q>>>0<(L<<24>>24<0?f[t>>2]|0:S)>>>0){if(!O){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(P>>>0>4294967279){T=35;break a}if(P>>>0<11){b[v>>0]=P;if(M)ba=g;else{ca=g;T=39}}else{W=P+16&-16;N=$Xc(W)|0;f[g>>2]=N;f[w>>2]=W|-2147483648;f[x>>2]=P;ca=N;T=39}if((T|0)==39){T=0;o1c(ca|0,O|0,P|0)|0;ba=ca}b[ba+P>>0]=0;break}d:do if(R>>>0<P>>>0){N=R;while(1){if((b[O+N>>0]|0)!=95){da=N;break d}W=N+1|0;if(W>>>0<P>>>0)N=W;else{da=W;break}}}else da=R;while(0);if((P|0)==(da|0)){if(!O){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(P>>>0>4294967279){T=47;break a}if(P>>>0<11){b[v>>0]=P;if(M)ea=g;else{fa=g;T=51}}else{N=P+16&-16;W=$Xc(N)|0;f[g>>2]=W;f[w>>2]=N|-2147483648;f[x>>2]=P;fa=W;T=51}if((T|0)==51){T=0;o1c(fa|0,O|0,P|0)|0;ea=fa}b[ea+P>>0]=0;break}else{W=O+da|0;N=P-da|0;if(!W){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(N>>>0>4294967279){T=56;break a}if(N>>>0<11){b[v>>0]=N;if(!N)ga=g;else{ha=g;T=60}}else{X=N+16&-16;U=$Xc(X)|0;f[g>>2]=U;f[w>>2]=X|-2147483648;f[x>>2]=N;ha=U;T=60}if((T|0)==60){T=0;o1c(ha|0,W|0,N|0)|0;ga=ha}b[ga+N>>0]=0;break}}while(0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;P=b[v>>0]|0;sYc(j,P<<24>>24<0?f[x>>2]|0:P&255);P=b[v>>0]|0;if(!((P<<24>>24<0?f[x>>2]|0:P&255)|0))ia=P;else{O=1;M=0;L=P;while(1){P=b[(L<<24>>24<0?f[g>>2]|0:g)+M>>0]|0;do if(P<<24>>24!=95){N=P<<24>>24;if(O){BYc(j,((P+-97&255)<26?N+224|0:N)&255);ja=0;break}else{BYc(j,((P+-65&255)<26?N+32|0:N)&255);ja=0;break}}else ja=1;while(0);M=M+1|0;P=b[v>>0]|0;if(M>>>0>=(P<<24>>24<0?f[x>>2]|0:P&255)>>>0){ia=P;break}else{O=ja;L=P}}}if(ia<<24>>24<0)cYc(f[g>>2]|0);lYc(k,j);f[y>>2]=K;L=I2b(i,g,k)|0;O=f[L>>2]|0;if(!O){M=$Xc(32)|0;P=M+16|0;f[P>>2]=f[k>>2];f[P+4>>2]=f[k+4>>2];f[P+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[M+28>>2]=f[y>>2];P=f[g>>2]|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=P;f[L>>2]=M;P=f[f[i>>2]>>2]|0;if(!P)ka=M;else{f[i>>2]=P;ka=f[L>>2]|0}UQ(f[r>>2]|0,ka);f[o>>2]=(f[o>>2]|0)+1;la=M;ma=1}else{la=O;ma=0}if((b[z>>0]|0)<0)cYc(f[k>>2]|0);e:do if(!(ma<<24>>24)){O=f[la+28>>2]|0;M=f[O>>2]|0;L=f[J>>2]|0;P=b[M+11>>0]|0;N=P<<24>>24<0;W=P&255;P=N?f[M+4>>2]|0:W;U=b[L+11>>0]|0;X=U<<24>>24<0;do if((P|0)==((X?f[L+4>>2]|0:U&255)|0)){V=f[M>>2]|0;Z=N?V:M;Y=X?f[L>>2]|0:L;na=(P|0)==0;if(N){if(na)break e;if(!(WKc(Z,Y,P)|0))break e;else break}if(na)break e;if((V&255)<<24>>24==(b[Y>>0]|0)){V=M;na=W;Z=Y;do{na=na+-1|0;V=V+1|0;if(!na)break e;Z=Z+1|0}while((b[V>>0]|0)==(b[Z>>0]|0))}}while(0);if((f[O+8>>2]|0)!=(f[I+(H*20|0)+8>>2]|0)){SGa(m,487619,j);W=AYc(m,487673)|0;f[l>>2]=f[W>>2];f[l+4>>2]=f[W+4>>2];f[l+8>>2]=f[W+8>>2];f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;W=J2b(i,j)|0;M=f[f[W>>2]>>2]|0;W=b[M+11>>0]|0;P=W<<24>>24<0;N=zYc(l,P?f[M>>2]|0:M,P?f[M+4>>2]|0:W&255)|0;f[k>>2]=f[N>>2];f[k+4>>2]=f[N+4>>2];f[k+8>>2]=f[N+8>>2];f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;N=AYc(k,487709)|0;f[g>>2]=f[N>>2];f[g+4>>2]=f[N+4>>2];f[g+8>>2]=f[N+8>>2];f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;if((b[A>>0]|0)<0)cYc(f[k>>2]|0);if((b[B>>0]|0)<0)cYc(f[l>>2]|0);if((b[C>>0]|0)<0)cYc(f[m>>2]|0);N=f[I+(H*20|0)+4>>2]|0;W=f[(f[E>>2]|0)+4+(H<<2)>>2]|0;if((f[(f[D>>2]|0)+44>>2]|0)==2)L0b(a,N,W,0,g);else q0b(a,N,W,0,g);if((b[F>>0]|0)<0)cYc(f[g>>2]|0)}}while(0);if((b[G>>0]|0)<0)cYc(f[j>>2]|0);H=H+1|0;if((H|0)>=(f[p>>2]|0)){T=8;break}}if((T|0)==8){oa=i;pa=s;qa=f[q>>2]|0;break}else if((T|0)==24)jYc(g);else if((T|0)==35)jYc(g);else if((T|0)==47)jYc(g);else if((T|0)==56)jYc(g)}else{oa=i;pa=h+11|0;qa=0}while(0);H2b(oa,qa);if((b[pa>>0]|0)>=0){u=e;return}cYc(f[h>>2]|0);u=e;return}function F2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(52)|0;r8b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function G2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(c|0)==(i|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(WKc(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(a|0)==(i|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(WKc(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function H2b(a,c){a=a|0;c=c|0;if(!c)return;H2b(a,f[c>>2]|0);H2b(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function I2b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function J2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=I2b(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=$Xc(32)|0;lYc(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}UQ(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function K2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(52)|0;Z7b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function L2b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=f[c>>2]|0;c=(b*65535|0)+e|0;g=a+4|0;h=f[g>>2]|0;i=(h|0)==0;j=b;a:do if(!i){k=h+-1|0;l=(k&h|0)==0;if(!l)if(c>>>0<h>>>0)m=c;else m=(c>>>0)%(h>>>0)|0;else m=k&c;o=f[(f[a>>2]|0)+(m<<2)>>2]|0;if((o|0)!=0?(p=f[o>>2]|0,(p|0)!=0):0){if(l){l=p;while(1){o=f[l+4>>2]|0;if(!((o|0)==(c|0)|(o&k|0)==(m|0))){q=m;break a}if((f[l+8>>2]|0)==(j|0)?(f[l+12>>2]|0)==(e|0):0){r=0;break}l=f[l>>2]|0;if(!l){q=m;break a}}return r|0}else s=p;while(1){l=f[s+4>>2]|0;if((l|0)!=(c|0)){if(l>>>0<h>>>0)t=l;else t=(l>>>0)%(h>>>0)|0;if((t|0)!=(m|0)){q=m;break a}}if((f[s+8>>2]|0)==(j|0)?(f[s+12>>2]|0)==(e|0):0){r=0;break}s=f[s>>2]|0;if(!s){q=m;break a}}return r|0}else q=m}else q=0;while(0);m=$Xc(20)|0;s=m+8|0;f[s>>2]=b;f[s+4>>2]=e;f[m+16>>2]=d;f[m+4>>2]=c;f[m>>2]=0;d=a+12|0;u=+(((f[d>>2]|0)+1|0)>>>0);v=+n[a+16>>2];do if(i|u>+(h>>>0)*v){e=(h>>>0<3|(h+-1&h|0)!=0)&1|h<<1;s=~~+X(+(u/v))>>>0;B$b(a,e>>>0<s>>>0?s:e);e=f[g>>2]|0;s=e+-1|0;if(!(s&e)){w=e;x=s&c;break}if(c>>>0<e>>>0){w=e;x=c}else{w=e;x=(c>>>0)%(e>>>0)|0}}else{w=h;x=q}while(0);q=(f[a>>2]|0)+(x<<2)|0;x=f[q>>2]|0;if(!x){h=a+8|0;f[m>>2]=f[h>>2];f[h>>2]=m;f[q>>2]=h;h=f[m>>2]|0;if(h|0){q=f[h+4>>2]|0;h=w+-1|0;if(h&w)if(q>>>0<w>>>0)y=q;else y=(q>>>0)%(w>>>0)|0;else y=q&h;z=(f[a>>2]|0)+(y<<2)|0;A=33}}else{f[m>>2]=f[x>>2];z=x;A=33}if((A|0)==33)f[z>>2]=m;f[d>>2]=(f[d>>2]|0)+1;r=1;return r|0}function M2b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g+8|0;i=g;j=a+4|0;k=f[j>>2]|0;l=f[d+4>>2]|0;m=$Xc(12)|0;lYc(m,l);f[h>>2]=m;l=k+76|0;n=f[l>>2]|0;if((n|0)==(f[k+80>>2]|0))r0b(k+72|0,h);else{f[n>>2]=m;f[l>>2]=(f[l>>2]|0)+4}l=f[h>>2]|0;vYc(l,1,46)|0;m=c+16|0;n=f[m>>2]|0;k=b[n+11>>0]|0;o=k<<24>>24<0;zYc(l,o?f[n>>2]|0:n,o?f[n+4>>2]|0:k&255)|0;v2b(a,f[m>>2]|0,l,c);k=f[j>>2]|0;j=f[m>>2]|0;m=$Xc(12)|0;lYc(m,j);f[h>>2]=m;j=k+76|0;n=f[j>>2]|0;if((n|0)==(f[k+80>>2]|0))r0b(k+72|0,h);else{f[n>>2]=m;f[j>>2]=(f[j>>2]|0)+4}j=f[h>>2]|0;f[e>>2]=j;m=e+4|0;f[m>>2]=l;f[e+8>>2]=d;f[e+16>>2]=0;f[e+20>>2]=0;if(!(f[c+8>>2]&2)){f[e+24>>2]=0;p=l;q=j;f[i>>2]=3;r=i+4|0;f[r>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];x2b(a,p,d,q,c,h)|0;u=g;return}else{j=f[c+20>>2]|0;P2b(a,l,l,j|0?j:538320,e);p=f[m>>2]|0;q=f[e>>2]|0;f[i>>2]=3;r=i+4|0;f[r>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];x2b(a,p,d,q,c,h)|0;u=g;return}}function N2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(48)|0;adc(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+8>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function O2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(52)|0;w9b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function P2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=$Xc(48)|0;K8b(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if(m>>>0<(f[j+92>>2]|0)>>>0){f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}else n0b(j+84|0,i);UZb(i,e);NZb(k,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[g+24>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;lYc(i,c);c=i+12|0;lYc(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;j=a+20|0;a=f[j>>2]|0;l=a;if(e>>>0>=a>>>0){a=e;m=f[g>>2]|0;n=a-m>>5;o=n+1|0;p=m;if(o>>>0>134217727)kWc(g);q=l-m|0;m=q>>4;l=q>>5>>>0<67108863?(m>>>0<o>>>0?o:m):134217727;do if(l)if(l>>>0>134217727){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}else{r=$Xc(l<<5)|0;break}else r=0;while(0);m=r+(n<<5)|0;o=m;q=r+(l<<5)|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=r+(n<<5)+12|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;l=d;s=f[l+4>>2]|0;t=r+(n<<5)+24|0;f[t>>2]=f[l>>2];f[t+4>>2]=s;s=m+32|0;if((e|0)==(p|0)){v=o;w=a;x=e}else{a=e;t=o;o=m;do{m=o+-32|0;l=a;a=a+-32|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];f[m+8>>2]=f[a+8>>2];f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;m=o+-20|0;n=l+-20|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;n=l+-8|0;l=f[n+4>>2]|0;m=o+-8|0;f[m>>2]=f[n>>2];f[m+4>>2]=l;o=t+-32|0;t=o}while((a|0)!=(p|0));v=t;w=f[g>>2]|0;x=f[k>>2]|0}f[g>>2]=v;f[k>>2]=s;f[j>>2]=q;q=w;if((x|0)!=(q|0)){j=x;do{x=j+-20|0;j=j+-32|0;if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0)}while((j|0)!=(q|0))}if(w|0)cYc(w)}else{f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=e+12|0;f[w>>2]=f[c>>2];f[w+4>>2]=f[c+4>>2];f[w+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;w=d;d=f[w+4>>2]|0;q=e+24|0;f[q>>2]=f[w>>2];f[q+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}function Q2b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c;if(!(b[a+49>>0]|0)){u_b(d,3,479317,7065);r_b(c+24|0,p_b(d,488424)|0);v_b(d)}d=a+16|0;e=f[d>>2]|0;if((e|0)<=0){u=c;return}g=a+56|0;h=a+8|0;i=a+52|0;a=0;j=e;while(1){e=f[(f[g>>2]|0)+(a<<2)>>2]|0;if(!e)k=j;else{l=j0b(f[h>>2]|0,e)|0;f[(f[i>>2]|0)+(a<<2)>>2]=l;k=f[d>>2]|0}a=a+1|0;if((a|0)>=(k|0))break;else j=k}u=c;return}function R2b(a){a=a|0;cYc(a);return}function S2b(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&4095](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function T2b(){var a=0;a=$Xc(164)|0;x$b(a);f[223538]=a;l_b(134);return}function U2b(){var a=0;a=f[223538]|0;if(a|0){v$b(a);cYc(a)}f[223538]=0;return}function V2b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(152)|0;rec(a);o=a}else{if(f[l+64>>2]|0)SXb(l,21288,152);a=QXb(l,152)|0;tec(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function W2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+144|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==537368)xJa(e,i,c);else oYc(h,c)|0;c=a+52|0;if((f[c>>2]|0)>0){h=a+20|0;i=b+16|0;e=0;do{g=(f[h>>2]|0)+(e*88|0)|0;$2b(g,_2b(i)|0);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=a+56|0;if((f[c>>2]|0)>0){e=a+24|0;i=b+96|0;h=b+108|0;g=b+104|0;j=b+100|0;k=0;do{l=(f[e>>2]|0)+(k*28|0)|0;m=f[h>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[g>>2]|0)){p=o;q=19;break}else{r=o;s=m;q=20;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[g>>2]|0;q=19}while(0);if((q|0)==19){q=0;XZb(i,p+1|0);m=f[h>>2]|0;r=f[m>>2]|0;s=m;q=20}if((q|0)==20){q=0;f[s>>2]=r+1;m=f[i>>2]|0;if(!m){n=$Xc(24)|0;ncc(n);u=n}else{if(f[m+64>>2]|0)SXb(m,21240,24);n=QXb(m,24)|0;occ(n,m);u=n}n=f[h>>2]|0;m=f[j>>2]|0;f[j>>2]=m+1;f[n+4+(m<<2)>>2]=u;t=u}k3b(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+60|0;if((f[c>>2]|0)>0){k=a+28|0;t=b+32|0;u=0;do{j=(f[k>>2]|0)+(u*88|0)|0;W2b(j,V2b(t)|0);u=u+1|0}while((u|0)<(f[c>>2]|0))}c=a+64|0;if((f[c>>2]|0)>0){u=a+32|0;t=b+48|0;k=0;do{j=(f[u>>2]|0)+(k*48|0)|0;Y2b(j,X2b(t)|0);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+68|0;if((f[c>>2]|0)>0){k=b+64|0;t=b+76|0;u=b+72|0;j=b+68|0;h=a+36|0;i=0;do{r=f[t>>2]|0;do if(r){s=f[j>>2]|0;p=f[r>>2]|0;if((s|0)>=(p|0))if((p|0)==(f[u>>2]|0)){v=p;q=40;break}else{w=p;x=r;q=41;break}else{f[j>>2]=s+1;y=f[r+4+(s<<2)>>2]|0;break}}else{v=f[u>>2]|0;q=40}while(0);if((q|0)==40){q=0;XZb(k,v+1|0);r=f[t>>2]|0;w=f[r>>2]|0;x=r;q=41}if((q|0)==41){q=0;f[x>>2]=w+1;r=f[k>>2]|0;if(!r){l=$Xc(28)|0;Wdc(l);z=l}else{if(f[r+64>>2]|0)SXb(r,21320,32);l=QXb(r,32)|0;Ydc(l,r);z=l}l=f[t>>2]|0;r=f[j>>2]|0;f[j>>2]=r+1;f[l+4+(r<<2)>>2]=z;y=z}r=f[h>>2]|0;l=f[r+(i*12|0)>>2]|0;s=y+8|0;p=f[s>>2]|0;f[s>>2]=p|2;f[y+20>>2]=l;l=f[r+(i*12|0)+4>>2]|0;f[s>>2]=p|6;f[y+24>>2]=l;l=f[r+(i*12|0)+8>>2]|0;if((l|0)!=(cfc()|0)){f[s>>2]=f[s>>2]|1;s=y+16|0;r=f[s>>2]|0;if(!r){pec(y);A=f[s>>2]|0}else A=r;dfc(A,l)}i=i+1|0}while((i|0)<(f[c>>2]|0))}c=a+72|0;if((f[c>>2]|0)>0){i=a+40|0;A=b+80|0;y=0;do{h=(f[i>>2]|0)+(y*88|0)|0;$2b(h,_2b(A)|0);y=y+1|0}while((y|0)<(f[c>>2]|0))}c=a+76|0;if((f[c>>2]|0)>0){y=b+112|0;A=b+124|0;i=b+120|0;h=b+116|0;z=a+44|0;j=0;do{t=f[A>>2]|0;do if(t){k=f[h>>2]|0;w=f[t>>2]|0;if((k|0)>=(w|0))if((w|0)==(f[i>>2]|0)){B=w;q=62;break}else{C=w;D=t;q=63;break}else{f[h>>2]=k+1;E=f[t+4+(k<<2)>>2]|0;break}}else{B=f[i>>2]|0;q=62}while(0);if((q|0)==62){q=0;XZb(y,B+1|0);t=f[A>>2]|0;C=f[t>>2]|0;D=t;q=63}if((q|0)==63){q=0;f[D>>2]=C+1;t=f[y>>2]|0;if(!t){k=$Xc(24)|0;Bdc(k);F=k}else{if(f[t+64>>2]|0)SXb(t,21304,24);k=QXb(t,24)|0;Ddc(k,t);F=k}k=f[A>>2]|0;t=f[h>>2]|0;f[h>>2]=t+1;f[k+4+(t<<2)>>2]=F;E=F}t=f[z>>2]|0;k=f[t+(j<<3)>>2]|0;w=E+8|0;x=f[w>>2]|0;f[w>>2]=x|1;f[E+16>>2]=k;k=f[t+(j<<3)+4>>2]|0;f[w>>2]=x|3;f[E+20>>2]=k;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=a+80|0;if((f[c>>2]|0)>0){j=a+48|0;E=b+128|0;z=0;do{F=f[(f[j>>2]|0)+(z<<2)>>2]|0;oYc(pHa(E)|0,F)|0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=a+16|0;a=f[c>>2]|0;if((a|0)==(gfc()|0))return;f[d>>2]=f[d>>2]|2;d=b+148|0;a=f[d>>2]|0;if(!a){Adc(b);G=f[d>>2]|0}else G=a;hfc(G,f[c>>2]|0);return}function X2b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(72)|0;Ubc(a);o=a}else{if(f[l+64>>2]|0)SXb(l,21208,72);a=QXb(l,72)|0;Vbc(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function Y2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+64|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==537368)xJa(e,i,c);else oYc(h,c)|0;c=a+24|0;if((f[c>>2]|0)>0){h=a+28|0;i=b+16|0;e=b+28|0;g=b+24|0;j=b+20|0;k=0;do{l=(f[h>>2]|0)+(k*20|0)|0;m=f[e>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[g>>2]|0)){p=o;q=16;break}else{r=o;s=m;q=17;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[g>>2]|0;q=16}while(0);if((q|0)==16){q=0;XZb(i,p+1|0);m=f[e>>2]|0;r=f[m>>2]|0;s=m;q=17}if((q|0)==17){q=0;f[s>>2]=r+1;m=f[i>>2]|0;if(!m){n=$Xc(28)|0;cbc(n);u=n}else{if(f[m+64>>2]|0)SXb(m,21192,32);n=QXb(m,32)|0;dbc(n,m);u=n}n=f[e>>2]|0;m=f[j>>2]|0;f[j>>2]=m+1;f[n+4+(m<<2)>>2]=u;t=u}j3b(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+32|0;if((f[c>>2]|0)>0){k=b+32|0;t=b+44|0;u=b+40|0;j=b+36|0;e=a+40|0;i=0;do{r=f[t>>2]|0;do if(r){s=f[j>>2]|0;p=f[r>>2]|0;if((s|0)>=(p|0))if((p|0)==(f[u>>2]|0)){v=p;q=31;break}else{w=p;x=r;q=32;break}else{f[j>>2]=s+1;y=f[r+4+(s<<2)>>2]|0;break}}else{v=f[u>>2]|0;q=31}while(0);if((q|0)==31){q=0;XZb(k,v+1|0);r=f[t>>2]|0;w=f[r>>2]|0;x=r;q=32}if((q|0)==32){q=0;f[x>>2]=w+1;r=f[k>>2]|0;if(!r){l=$Xc(24)|0;zbc(l);z=l}else{if(f[r+64>>2]|0)SXb(r,21224,24);l=QXb(r,24)|0;Bbc(l,r);z=l}l=f[t>>2]|0;r=f[j>>2]|0;f[j>>2]=r+1;f[l+4+(r<<2)>>2]=z;y=z}r=f[e>>2]|0;l=f[r+(i<<3)>>2]|0;s=y+8|0;p=f[s>>2]|0;f[s>>2]=p|1;f[y+16>>2]=l;l=f[r+(i<<3)+4>>2]|0;f[s>>2]=p|3;f[y+20>>2]=l;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=a+36|0;if((f[c>>2]|0)>0){i=a+44|0;y=b+48|0;e=0;do{z=f[(f[i>>2]|0)+(e<<2)>>2]|0;oYc(pHa(y)|0,z)|0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=a+16|0;a=f[c>>2]|0;if((a|0)==(mfc()|0))return;f[d>>2]=f[d>>2]|2;d=b+68|0;a=f[d>>2]|0;if(!a){ybc(b);A=f[d>>2]|0}else A=a;nfc(A,f[c>>2]|0);return}function Z2b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+32|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==537368)xJa(e,i,c);else oYc(h,c)|0;c=a+20|0;if((f[c>>2]|0)>0){h=a+16|0;i=b+16|0;e=b+28|0;g=b+24|0;j=b+20|0;k=0;do{l=(f[h>>2]|0)+(k*52|0)|0;m=f[e>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[g>>2]|0)){p=o;q=15;break}else{r=o;s=m;q=16;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[g>>2]|0;q=15}while(0);if((q|0)==15){q=0;XZb(i,p+1|0);m=f[e>>2]|0;r=f[m>>2]|0;s=m;q=16}if((q|0)==16){q=0;f[s>>2]=r+1;m=f[i>>2]|0;if(!m){n=$Xc(36)|0;lac(n);u=n}else{if(f[m+64>>2]|0)SXb(m,21160,40);n=QXb(m,40)|0;mac(n,m);u=n}n=f[e>>2]|0;m=f[j>>2]|0;f[j>>2]=m+1;f[n+4+(m<<2)>>2]=u;t=u}c3b(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+12|0;a=f[c>>2]|0;if((a|0)==(qfc()|0))return;f[d>>2]=f[d>>2]|2;d=b+36|0;a=f[d>>2]|0;if(!a){Hac(b);v=f[d>>2]|0}else v=a;rfc(v,f[c>>2]|0);return}function _2b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(56)|0;Icc(a);o=a}else{if(f[l+64>>2]|0)SXb(l,21256,56);a=QXb(l,56)|0;Jcc(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function $2b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;i=c+16|0;j=c+4|0;k=f[j>>2]|0;l=k&-2;if(!(k&1))m=l;else m=f[l+4>>2]|0;l=f[i>>2]|0;if((l|0)==537368)xJa(i,m,g);else oYc(l,g)|0;g=f[a+40>>2]|0;l=f[h>>2]|0;f[h>>2]=l|64;f[c+40>>2]=g;do if(b[a+37>>0]|0){g=f[a+16>>2]|0;f[h>>2]=l|80;m=c+32|0;i=f[j>>2]|0;k=i&-2;if(!(i&1))n=k;else n=f[k+4>>2]|0;k=f[m>>2]|0;if((k|0)==537368){xJa(m,n,g);break}else{oYc(k,g)|0;break}}while(0);n=f[a+32>>2]|0;f[h>>2]=f[h>>2]|256;f[c+48>>2]=n;n=a+24|0;l=f[n>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(l,e)}l=a+28|0;g=f[l>>2]|0;k=f[h>>2]|512;f[h>>2]=k;m=c+52|0;f[m>>2]=g;g=a+38|0;if(b[g>>0]|0){i=a+48|0;if(!(b[(f[i>>2]|0)+85>>0]|0)){a3b(c,528338);o=f[h>>2]|0}else o=k;f[h>>2]=o|2;o=c+20|0;k=f[j>>2]|0;p=k&-2;if(!(k&1))q=p;else q=f[p+4>>2]|0;p=f[o>>2]|0;if((p|0)==537368){xJa(o,q,537368);r=f[o>>2]|0}else r=p;p=f[(f[i>>2]|0)+4>>2]|0;i=b[p+11>>0]|0;o=i<<24>>24<0;zYc(r,o?f[p>>2]|0:p,o?f[p+4>>2]|0:i&255)|0}i=f[n>>2]|0;if(!i)s=0;else{if((f[i>>2]|0)!=2){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(i,e)}s=f[n>>2]|0}i=(s|0)==0;if((f[l>>2]|1|0)!=11){if(!i?(f[s>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(s,e)}if((f[l>>2]|0)==14){l=f[n>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(l,e)}l=a+64|0;if(!(b[(f[l>>2]|0)+21>>0]|0))b3b(c,528338);f[h>>2]=f[h>>2]|4;p=c+24|0;o=f[j>>2]|0;r=o&-2;if(!(o&1))t=r;else t=f[r+4>>2]|0;r=f[p>>2]|0;if((r|0)==537368){xJa(p,t,537368);v=f[p>>2]|0}else v=r;r=f[n>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(r,e)}r=f[(f[l>>2]|0)+4>>2]|0;l=b[r+11>>0]|0;p=l<<24>>24<0;zYc(v,p?f[r>>2]|0:r,p?f[r+4>>2]|0:l&255)|0}}else{if(!i?(f[s>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(s,e)}s=a+60|0;if(b[(f[s>>2]|0)+84>>0]|0){f[m>>2]=1;f[h>>2]=f[h>>2]&-513}m=f[n>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(m,e)}if(!(b[(f[s>>2]|0)+85>>0]|0))b3b(c,528338);f[h>>2]=f[h>>2]|4;m=c+24|0;i=f[j>>2]|0;l=i&-2;if(!(i&1))w=l;else w=f[l+4>>2]|0;l=f[m>>2]|0;if((l|0)==537368){xJa(m,w,537368);x=f[m>>2]|0}else x=l;l=f[n>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(l,e)}l=f[(f[s>>2]|0)+4>>2]|0;s=b[l+11>>0]|0;n=s<<24>>24<0;zYc(x,n?f[l>>2]|0:l,n?f[l+4>>2]|0:s&255)|0}if(b[a+36>>0]|0){H1b(e,a,0);f[h>>2]=f[h>>2]|8;s=c+28|0;l=f[j>>2]|0;j=l&-2;if(!(l&1))y=j;else y=f[j+4>>2]|0;j=f[s>>2]|0;if((j|0)==537368)xJa(s,y,e);else oYc(j,e)|0;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0)}e=f[a+52>>2]|0;if(e|0?(b[g>>0]|0)==0:0){g=(e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0;f[h>>2]=f[h>>2]|128;f[c+44>>2]=g}g=a+68|0;a=f[g>>2]|0;if((a|0)==(ifc()|0)){u=d;return}f[h>>2]=f[h>>2]|32;h=c+36|0;a=f[h>>2]|0;if(!a){Hcc(c);z=f[h>>2]|0}else z=a;jfc(z,f[g>>2]|0);u=d;return}function a3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=dJc(c)|0;if(g>>>0>4294967279)jYc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=$Xc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+20|0;a=f[h>>2]|0;if((a|0)==537368)xJa(h,m,e);else oYc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function b3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|4;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=dJc(c)|0;if(g>>>0>4294967279)jYc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=$Xc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+24|0;a=f[h>>2]|0;if((a|0)==537368)xJa(h,m,e);else oYc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function c3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;i=c+16|0;j=c+4|0;k=f[j>>2]|0;l=k&-2;if(!(k&1))m=l;else m=f[l+4>>2]|0;l=f[i>>2]|0;if((l|0)==537368)xJa(i,m,g);else oYc(l,g)|0;g=a+12|0;l=a+20|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[e>>2]=165980;f[e+4>>2]=2272;b[e+8>>0]=0;f[e+12>>2]=g;J_b(m,e)}if(!(b[(f[g>>2]|0)+85>>0]|0))e3b(c,528338);f[h>>2]=f[h>>2]|2;m=c+20|0;i=f[j>>2]|0;k=i&-2;if(!(i&1))n=k;else n=f[k+4>>2]|0;k=f[m>>2]|0;if((k|0)==537368){xJa(m,n,537368);o=f[m>>2]|0}else o=k;k=f[l>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[e>>2]=165980;f[e+4>>2]=2272;b[e+8>>0]=0;f[e+12>>2]=g;J_b(k,e)}k=f[(f[g>>2]|0)+4>>2]|0;g=b[k+11>>0]|0;l=g<<24>>24<0;zYc(o,l?f[k>>2]|0:k,l?f[k+4>>2]|0:g&255)|0;g=a+28|0;k=a+36|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[e>>2]=165980;f[e+4>>2]=2272;b[e+8>>0]=0;f[e+12>>2]=g;J_b(l,e)}if(!(b[(f[g>>2]|0)+85>>0]|0))f3b(c,528338);f[h>>2]=f[h>>2]|4;l=c+24|0;o=f[j>>2]|0;j=o&-2;if(!(o&1))p=j;else p=f[j+4>>2]|0;j=f[l>>2]|0;if((j|0)==537368){xJa(l,p,537368);q=f[l>>2]|0}else q=j;j=f[k>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[e>>2]=165980;f[e+4>>2]=2272;b[e+8>>0]=0;f[e+12>>2]=g;J_b(j,e)}e=f[(f[g>>2]|0)+4>>2]|0;g=b[e+11>>0]|0;j=g<<24>>24<0;zYc(q,j?f[e>>2]|0:e,j?f[e+4>>2]|0:g&255)|0;g=a+44|0;e=f[g>>2]|0;if((e|0)!=(sfc()|0)){f[h>>2]=f[h>>2]|8;e=c+28|0;j=f[e>>2]|0;if(!j){kac(c);r=f[e>>2]|0}else r=j;tfc(r,f[g>>2]|0)}if(b[a+48>>0]|0){f[h>>2]=f[h>>2]|16;b[c+32>>0]=1}if(!(b[a+49>>0]|0)){u=d;return}f[h>>2]=f[h>>2]|32;b[c+33>>0]=1;u=d;return}function d3b(a){a=a|0;g3b(a);return}function e3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=dJc(c)|0;if(g>>>0>4294967279)jYc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=$Xc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+20|0;a=f[h>>2]|0;if((a|0)==537368)xJa(h,m,e);else oYc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function f3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|4;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=dJc(c)|0;if(g>>>0>4294967279)jYc(e);if(g>>>0<11){b[e+11>>0]=g;if(!g)h=e;else{i=e;j=6}}else{k=g+16&-16;l=$Xc(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=g;i=l;j=6}if((j|0)==6){o1c(i|0,c|0,g|0)|0;h=i}b[h+g>>0]=0;g=f[a+4>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=a+24|0;a=f[h>>2]|0;if((a|0)==537368)xJa(h,m,e);else oYc(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function g3b(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c;e=c+24|0;g=a+12|0;if(!(b[(f[g>>2]|0)+49>>0]|0)){u_b(d,3,479317,7126);r_b(c+32|0,p_b(d,488769)|0);v_b(d)}if(f[a>>2]|0){u=c;return}d=f[a+4>>2]|0;if(!d){u=c;return}d1b(e,f[(f[g>>2]|0)+8>>2]|0,d,0);if((f[e>>2]|0)==1)f[a>>2]=f[e+4>>2];u=c;return}function h3b(a){a=a|0;cYc(a);return}function i3b(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&4095](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function j3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+16|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==537368)xJa(e,i,c);else oYc(h,c)|0;c=f[a+8>>2]|0;f[d>>2]=f[d>>2]|4;f[b+24>>2]=c;c=a+16|0;a=f[c>>2]|0;if((a|0)==(ofc()|0))return;f[d>>2]=f[d>>2]|2;d=b+20|0;a=f[d>>2]|0;if(!a){bbc(b);j=f[d>>2]|0}else j=a;pfc(j,f[c>>2]|0);return}function k3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+16|0;g=f[b+4>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=f[e>>2]|0;if((h|0)==537368)xJa(e,i,c);else oYc(h,c)|0;c=a+24|0;a=f[c>>2]|0;if((a|0)==(kfc()|0))return;f[d>>2]=f[d>>2]|2;d=b+20|0;a=f[d>>2]|0;if(!a){mcc(b);j=f[d>>2]|0}else j=a;lfc(j,f[c>>2]|0);return}function l3b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[a+84>>2]|0;if(!e){u=c;return}g=d+4|0;h=a+20|0;a=e;do{e=a+16|0;i=f[e>>2]|0;do if(b[i+38>>0]|0){j=f[i+56>>2]|0;if(!j){k=f[i+20>>2]|0;break}else{k=j;break}}else k=f[i+48>>2]|0;while(0);j=f[i+8>>2]|0;if((b[j+11>>0]|0)<0)l=f[j>>2]|0;else l=j;f[d>>2]=k;f[g>>2]=l;t2b(h,d,e)|0;a=f[a>>2]|0}while((a|0)!=0);u=c;return}function m3b(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[223534]|0)==2){d=f[223535]|0;u=a;return d|0}f[c>>2]=165456;f[c+4>>2]=132;b[c+8>>0]=0;J_b(894136,c);a_b(c);d=f[223535]|0;u=a;return d|0}function n3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[223534]|0)!=2){f[e>>2]=165456;f[e+4>>2]=132;b[e+8>>0]=0;J_b(894136,e);a_b(e)}if(Nfc(f[223536]|0,a,c)|0){u=d;return}u_b(g,3,479317,1394);r_b(d+36|0,p_b(g,488881)|0);v_b(g);u=d;return}function o3b(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;W$b(d,f[a+16>>2]|0,a,b);u=c;return ((f[d>>2]|0)==1?f[d+4>>2]|0:0)|0}function p3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;W$b(e,f[a+16>>2]|0,a,c);if((f[e>>2]|0)!=2){g=0;u=d;return g|0}c=f[e+4>>2]|0;g=b[c+38>>0]|0?c:0;u=d;return g|0}function q3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=f[a>>2]|0;if(e){g_b(e);g=a+16|0;h=(f[g>>2]|0)+176|0;i=f[h>>2]|0;do if(i){j=h;k=i;a:while(1){l=k;while(1){m=f[l+16>>2]|0;if(m>>>0>=c>>>0){if(m>>>0>c>>>0)break;if((f[l+20>>2]|0)>=(d|0))break}m=f[l+4>>2]|0;if(!m){n=j;break a}else l=m}k=f[l>>2]|0;if(!k){n=l;break}else j=l}if((n|0)!=(h|0)?(j=f[n+16>>2]|0,j>>>0<=c>>>0):0){if(j>>>0>=c>>>0?(f[n+20>>2]|0)>(d|0):0){o=0;break}o=f[n+24>>2]|0}else o=0}else o=0;while(0);h_b(e);if(o|0){p=o;return p|0}o=f[a>>2]|0;if(!o){q=g;r=0;s=1}else{g_b(o);q=g;r=o;s=0}}else{q=a+16|0;r=0;s=1}o=f[q>>2]|0;g=o+44|0;if(!(f[g>>2]|0))t=o;else{e=o+40|0;n=f[e>>2]|0;if(n|0){h=n;do{n=h;h=f[h>>2]|0;i=n+8|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(n)}while((h|0)!=0)}f[e>>2]=0;e=f[o+36>>2]|0;if(e|0){h=o+32|0;o=0;do{f[(f[h>>2]|0)+(o<<2)>>2]=0;o=o+1|0}while((o|0)!=(e|0))}f[g>>2]=0;t=f[q>>2]|0}g=t+24|0;if(!(f[g>>2]|0))u=t;else{e=t+20|0;o=f[e>>2]|0;if(o|0){h=o;do{o=h;h=f[h>>2]|0;n=o+8|0;if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);cYc(o)}while((h|0)!=0)}f[e>>2]=0;e=f[t+16>>2]|0;if(e|0){h=t+12|0;t=0;do{f[(f[h>>2]|0)+(t<<2)>>2]=0;t=t+1|0}while((t|0)!=(e|0))}f[g>>2]=0;u=f[q>>2]|0}g=u+176|0;u=f[g>>2]|0;do if(u){e=g;t=u;b:while(1){h=t;while(1){o=f[h+16>>2]|0;if(o>>>0>=c>>>0){if(o>>>0>c>>>0)break;if((f[h+20>>2]|0)>=(d|0))break}o=f[h+4>>2]|0;if(!o){v=e;break b}else h=o}t=f[h>>2]|0;if(!t){v=h;break}else e=h}if((v|0)!=(g|0)?(e=f[v+16>>2]|0,e>>>0<=c>>>0):0){if(e>>>0>=c>>>0?(f[v+20>>2]|0)>(d|0):0){w=48;break}e=f[v+24>>2]|0;if(e){x=e;w=64}else w=48}else w=48}else w=48;while(0);c:do if((w|0)==48){v=f[a+12>>2]|0;if(v|0?(g=q3b(v,c,d)|0,g|0):0){x=g;w=64;break}do if(r3b(a,c,d)|0?(g=(f[q>>2]|0)+176|0,v=f[g>>2]|0,v|0):0){u=g;e=v;d:while(1){v=e;while(1){t=f[v+16>>2]|0;if(t>>>0>=c>>>0){if(t>>>0>c>>>0)break;if((f[v+20>>2]|0)>=(d|0))break}t=f[v+4>>2]|0;if(!t){y=u;break d}else v=t}e=f[v>>2]|0;if(!e){y=v;break}else u=v}if((y|0)!=(g|0)?(u=f[y+16>>2]|0,u>>>0<=c>>>0):0){if(u>>>0>=c>>>0?(f[y+20>>2]|0)>(d|0):0)break;u=f[y+24>>2]|0;if(u|0){x=u;w=64;break c}}}while(0);if(s){p=0;return p|0}else z=0}while(0);if((w|0)==64)if(s){p=x;return p|0}else z=x;h_b(r);p=z;return p|0}function r3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+144|0;g=e+140|0;h=e;i=a+4|0;if(!(f[i>>2]|0)){j=0;u=e;return j|0}Rec(h);k=f[i>>2]|0;do if(hh[f[(f[k>>2]|0)+16>>2]&127](k,f[c+4>>2]|0,d,h)|0){i=f[a+16>>2]|0;l=f[h+120>>2]|0;f[g>>2]=(b[l+11>>0]|0)<0?f[l>>2]|0:l;l=$$b(i+152|0,g)|0;if(l)if(f[l+12>>2]|0){m=0;break}m=(a0b(a,h)|0)!=0}else m=0;while(0);vec(h);j=m;u=e;return j|0}function s3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[(f[a+8>>2]|0)+88>>2]|0;e=(a*65535|0)+c|0;g=f[d+80>>2]|0;if(!g)return 0;h=g+-1|0;i=(h&g|0)==0;if(!i)if(e>>>0<g>>>0)j=e;else j=(e>>>0)%(g>>>0)|0;else j=h&e;k=f[(f[d+76>>2]|0)+(j<<2)>>2]|0;if(!k)return 0;d=f[k>>2]|0;if(!d)return 0;a:do if(i){k=d;while(1){l=f[k+4>>2]|0;m=(e|0)==(l|0);if(!(m|(l&h|0)==(j|0))){n=23;break}if((m?(f[k+8>>2]|0)==(a|0):0)?(f[k+12>>2]|0)==(c|0):0){o=k;break a}k=f[k>>2]|0;if(!k){n=23;break}}if((n|0)==23)return 0}else{k=d;while(1){m=f[k+4>>2]|0;if((e|0)==(m|0)){if((f[k+8>>2]|0)==(a|0)?(f[k+12>>2]|0)==(c|0):0){o=k;break a}}else{if(m>>>0<g>>>0)p=m;else p=(m>>>0)%(g>>>0)|0;if((p|0)!=(j|0)){n=23;break}}k=f[k>>2]|0;if(!k){n=23;break}}if((n|0)==23)return 0}while(0);n=f[o+16>>2]|0;if(!n)return 0;else return (b[n+38>>0]|0?0:n)|0;return 0}function t3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[(f[a+8>>2]|0)+88>>2]|0;h=g+44|0;if((f[h>>2]|0)!=2){f[e>>2]=166e3;f[e+4>>2]=2273;b[e+8>>0]=0;f[e+12>>2]=g;J_b(h,e)}h=(b[c+11>>0]|0)<0?f[c>>2]|0:c;f[e>>2]=a;f[e+4>>2]=h;h=u2b(g+20|0,e)|0;if(!h){u=d;return 0}else{u=d;return (b[h+38>>0]|0?0:h)|0}return 0}function u3b(a){a=a|0;cYc(a);return}function v3b(a){a=a|0;var c=0;c=b[a+8>>0]|0;Yi[f[a+4>>2]&4095](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function w3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;J0b(e,f[(f[a+8>>2]|0)+88>>2]|0,a,c);c=(f[e>>2]|0)==2;a=e;e=c?f[a+4>>2]|0:0;if(!((c?f[a>>2]|0:0)|0)){g=0;u=d;return g|0}g=b[e+38>>0]|0?0:e;u=d;return g|0}function x3b(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;J0b(d,f[(f[a+8>>2]|0)+88>>2]|0,a,b);b=(f[d>>2]|0)==5;a=d;u=c;return (((b?f[a>>2]|0:0)|0)==0?0:b?f[a+4>>2]|0:0)|0}function y3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[(f[a+8>>2]|0)+88>>2]|0;d=(a*65535|0)+b|0;e=f[c+100>>2]|0;if(!e){g=0;return g|0}h=e+-1|0;i=(h&e|0)==0;if(!i)if(d>>>0<e>>>0)j=d;else j=(d>>>0)%(e>>>0)|0;else j=h&d;k=f[(f[c+96>>2]|0)+(j<<2)>>2]|0;if(!k){g=0;return g|0}c=f[k>>2]|0;if(!c){g=0;return g|0}a:do if(i){k=c;while(1){l=f[k+4>>2]|0;m=(d|0)==(l|0);if(!(m|(l&h|0)==(j|0))){g=0;n=22;break}if((m?(f[k+8>>2]|0)==(a|0):0)?(f[k+12>>2]|0)==(b|0):0){o=k;break a}k=f[k>>2]|0;if(!k){g=0;n=22;break}}if((n|0)==22)return g|0}else{k=c;while(1){m=f[k+4>>2]|0;if((d|0)==(m|0)){if((f[k+8>>2]|0)==(a|0)?(f[k+12>>2]|0)==(b|0):0){o=k;break a}}else{if(m>>>0<e>>>0)p=m;else p=(m>>>0)%(e>>>0)|0;if((p|0)!=(j|0)){g=0;n=22;break}}k=f[k>>2]|0;if(!k){g=0;n=22;break}}if((n|0)==22)return g|0}while(0);g=f[o+16>>2]|0;return g|0}function z3b(a,b){a=a|0;b=b|0;return A3b(f[(f[a+8>>2]|0)+88>>2]|0,a,b)|0}function A3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+48|0;g=e;h=e+36|0;i=e+24|0;j=e+12|0;k=c;l=(k*65535|0)+d|0;m=f[a+100>>2]|0;a:do if(m|0){n=m+-1|0;o=(n&m|0)==0;if(!o)if(l>>>0<m>>>0)p=l;else p=(l>>>0)%(m>>>0)|0;else p=n&l;q=f[(f[a+96>>2]|0)+(p<<2)>>2]|0;if(q|0?(r=f[q>>2]|0,r|0):0){b:do if(o){q=r;while(1){s=f[q+4>>2]|0;t=(l|0)==(s|0);if(!(t|(s&n|0)==(p|0)))break a;if((t?(f[q+8>>2]|0)==(c|0):0)?(f[q+12>>2]|0)==(d|0):0){v=q;break b}q=f[q>>2]|0;if(!q)break a}}else{q=r;while(1){t=f[q+4>>2]|0;if((l|0)==(t|0)){if((f[q+8>>2]|0)==(c|0)?(f[q+12>>2]|0)==(d|0):0){v=q;break b}}else{if(t>>>0<m>>>0)w=t;else w=(t>>>0)%(m>>>0)|0;if((w|0)!=(p|0))break a}q=f[q>>2]|0;if(!q)break a}}while(0);r=f[v+16>>2]|0;if(r|0){x=r;u=e;return x|0}}}while(0);v=a+160|0;g_b(v);p=a+116|0;w=a+120|0;a=f[w>>2]|0;c:do if(a){m=a+-1|0;r=(m&a|0)==0;if(!r)if(l>>>0<a>>>0)y=l;else y=(l>>>0)%(a>>>0)|0;else y=m&l;n=f[(f[p>>2]|0)+(y<<2)>>2]|0;if((n|0)!=0?(o=f[n>>2]|0,(o|0)!=0):0){d:do if(r){n=o;while(1){q=f[n+4>>2]|0;t=(q|0)==(l|0);if(!(t|(q&m|0)==(y|0))){z=0;break c}if((t?(f[n+8>>2]|0)==(c|0):0)?(f[n+12>>2]|0)==(d|0):0){A=n;break d}n=f[n>>2]|0;if(!n){z=0;break c}}}else{n=o;while(1){t=f[n+4>>2]|0;if((t|0)==(l|0)){if((f[n+8>>2]|0)==(c|0)?(f[n+12>>2]|0)==(d|0):0){A=n;break d}}else{if(t>>>0<a>>>0)B=t;else B=(t>>>0)%(a>>>0)|0;if((B|0)!=(y|0)){z=0;break c}}n=f[n>>2]|0;if(!n){z=0;break c}}}while(0);z=f[A+16>>2]|0}else z=0}else z=0;while(0);h_b(v);if(z|0){x=z;u=e;return x|0}g_b(v);z=f[w>>2]|0;e:do if(z){w=z+-1|0;A=(w&z|0)==0;if(!A)if(l>>>0<z>>>0)C=l;else C=(l>>>0)%(z>>>0)|0;else C=w&l;y=f[(f[p>>2]|0)+(C<<2)>>2]|0;if((y|0)!=0?(B=f[y>>2]|0,(B|0)!=0):0){f:do if(A){y=B;while(1){a=f[y+4>>2]|0;o=(a|0)==(l|0);if(!(o|(a&w|0)==(C|0))){D=65;break e}if((o?(f[y+8>>2]|0)==(c|0):0)?(f[y+12>>2]|0)==(d|0):0){E=y;break f}y=f[y>>2]|0;if(!y){D=65;break e}}}else{y=B;while(1){o=f[y+4>>2]|0;if((o|0)==(l|0)){if((f[y+8>>2]|0)==(c|0)?(f[y+12>>2]|0)==(d|0):0){E=y;break f}}else{if(o>>>0<z>>>0)F=o;else F=(o>>>0)%(z>>>0)|0;if((F|0)!=(C|0)){D=65;break e}}y=f[y>>2]|0;if(!y){D=65;break e}}}while(0);B=f[E+16>>2]|0;if(B)G=B;else D=65}else D=65}else D=65;while(0);if((D|0)==65){D=f[c>>2]|0;if((b[D+11>>0]|0)<0)H=f[D>>2]|0;else H=D;f[g>>2]=H;f[g+4>>2]=d;Zsc(h,489030,g);if((f[223534]|0)!=2){f[g>>2]=165456;f[g+4>>2]=132;b[g+8>>0]=0;J_b(894136,g);a_b(g)}H=f[(f[223535]|0)+16>>2]|0;D=$Xc(20)|0;f[g>>2]=D;E=H+124|0;C=f[E>>2]|0;if((C|0)==(f[H+128>>2]|0))wN(H+120|0,g);else{f[C>>2]=D;f[E>>2]=(f[E>>2]|0)+4}E=f[g>>2]|0;D=$Xc(12)|0;lYc(D,h);f[g>>2]=D;C=H+76|0;F=f[C>>2]|0;z=H+80|0;if((F|0)==(f[z>>2]|0))r0b(H+72|0,g);else{f[F>>2]=D;f[C>>2]=(f[C>>2]|0)+4}f[E>>2]=f[g>>2];AN(j,f[c+4>>2]|0,528338);c=h+11|0;D=b[c>>0]|0;F=D<<24>>24<0;l=zYc(j,F?f[h>>2]|0:h,F?f[h+4>>2]|0:D&255)|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;l=$Xc(12)|0;lYc(l,i);f[g>>2]=l;D=f[C>>2]|0;if((D|0)==(f[z>>2]|0))r0b(H+72|0,g);else{f[D>>2]=l;f[C>>2]=(f[C>>2]|0)+4}f[E+4>>2]=f[g>>2];if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);f[E+8>>2]=d;f[E+12>>2]=k;j=ofc()|0;f[E+16>>2]=j;f[g>>2]=k;f[g+4>>2]=d;f[i>>2]=E;L2b(p,g,i)|0;if((b[c>>0]|0)<0)cYc(f[h>>2]|0);G=E}h_b(v);x=G;u=e;return x|0}function B3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+68>>2]|0;if((c|0)<=0){d=0;return d|0}e=f[a+36>>2]|0;a=0;while(1){g=e+(a*12|0)|0;if((f[g>>2]|0)<=(b|0)?(f[e+(a*12|0)+4>>2]|0)>(b|0):0){d=g;h=6;break}a=a+1|0;if((a|0)>=(c|0)){d=0;h=6;break}}if((h|0)==6)return d|0;return 0}function C3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+76>>2]|0;if((c|0)<=0){d=0;return d|0}e=f[a+44>>2]|0;a=0;while(1){g=e+(a<<3)|0;if((f[g>>2]|0)<=(b|0)?(f[e+(a<<3)+4>>2]|0)>(b|0):0){d=g;h=6;break}a=a+1|0;if((a|0)>=(c|0)){d=0;h=6;break}}if((h|0)==6)return d|0;return 0}function D3b(a){a=a|0;return (b[(f[(f[a+60>>2]|0)+16>>2]|0)+51>>0]|0)!=0|0}function E3b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[a+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[d>>2]=80424;f[d+4>>2]=2231;b[d+8>>0]=0;f[d+12>>2]=a;J_b(e,d)}u=c;return f[a+80>>2]|0}function F3b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[a+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[d>>2]=80424;f[d+4>>2]=2231;b[d+8>>0]=0;f[d+12>>2]=a;J_b(e,d)}u=c;return f[a+60>>2]|0}function G3b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[a+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[d>>2]=80424;f[d+4>>2]=2231;b[d+8>>0]=0;f[d+12>>2]=a;J_b(e,d)}u=c;return f[a+64>>2]|0}function H3b(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[a+32>>2]|0)!=3){e=0;u=c;return e|0}g=f[a+24>>2]|0;if(g|0?(f[g>>2]|0)!=2:0){f[d>>2]=80424;f[d+4>>2]=2231;b[d+8>>0]=0;f[d+12>>2]=a;J_b(g,d)}if(((f[a+28>>2]|0)+-9|0)>>>0<=3){e=0;u=c;return e|0}d=f[a+68>>2]|0;g=(d|0)==0;if((f[(f[a+20>>2]|0)+44>>2]|0)==2){if(g){e=0;u=c;return e|0}e=(b[d+52>>0]|0)!=0;u=c;return e|0}if(g){e=1;u=c;return e|0}if(!(f[d+24>>2]&2)){e=1;u=c;return e|0}e=(b[d+52>>0]|0)!=0;u=c;return e|0}function I3b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=167536;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function J3b(a){a=a|0;I3b(a);cYc(a);return}function K3b(a){a=a|0;a=$Xc(32)|0;_ec(a);return a|0}function L3b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(32)|0;_ec(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,20920,32);a=QXb(b,32)|0;$ec(a,b);c=a;return c|0}function M3b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function N3b(a){a=a|0;return f[a+4>>2]|0}function O3b(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{Bec(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function P3b(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;if(!(Cec(f[(f[b>>2]|0)+4+(c<<2)>>2]|0)|0)){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function Q3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;XZb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=$Xc(140)|0;Rec(a);y=a}else{if(f[o+64>>2]|0)SXb(o,21336,144);a=QXb(o,144)|0;Sec(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=YYb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}JYb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(OYb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=lSa(m)|0;else B=a&-2;if(!(Lqc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function R3b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function S3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function T3b(a){a=a|0;return f[a+12>>2]|0}function U3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Pqc(j&-2,g)|0;return s|0}function V3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))return;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{Bec(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=a+4|0;d=f[c>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(b,21568,20920,0)|0;if(!g){Ooc(b,a);return}b=f[g+4>>2]|0;if(b&1|0){d=f[c>>2]|0;if(!(d&1))h=lSa(c)|0;else h=d&-2;vqc(h,b&-2)}Yec(a+16|0,g+16|0);return}function W3b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,20920,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}Yec(a+16|0,c+16|0);return}function X3b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538872;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z3b(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223546]|0)!=2){f[c>>2]=165456;f[c+4>>2]=136;b[c+8>>0]=0;J_b(894184,c);a_b(c)}d=$Xc(48)|0;f[c>>2]=d;f[c+8>>2]=-2147483600;f[c+4>>2]=32;e=d;g=489055;h=e+32|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+32>>0]=0;ejc(c,167636,167960,166012,0,538872,894156,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function _3b(){$3b();n3b(489088,5968);Boc(489055,2274);return}function $3b(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223547]|0)!=2){f[c>>2]=165456;f[c+4>>2]=137;b[c+8>>0]=0;J_b(894188,c);a_b(c)}if((f[223548]|0)!=2){f[c>>2]=165456;f[c+4>>2]=138;b[c+8>>0]=0;J_b(894192,c);a_b(c)}if((f[223549]|0)!=2){f[c>>2]=165456;f[c+4>>2]=139;b[c+8>>0]=0;J_b(894196,c);a_b(c)}if((f[223550]|0)!=2){f[c>>2]=165456;f[c+4>>2]=140;b[c+8>>0]=0;J_b(894200,c);a_b(c)}if((f[223551]|0)!=2){f[c>>2]=165456;f[c+4>>2]=141;b[c+8>>0]=0;J_b(894204,c);a_b(c)}if((f[223552]|0)!=2){f[c>>2]=165456;f[c+4>>2]=142;b[c+8>>0]=0;J_b(894208,c);a_b(c)}if((f[223553]|0)!=2){f[c>>2]=165456;f[c+4>>2]=143;b[c+8>>0]=0;J_b(894212,c);a_b(c)}if((f[223554]|0)!=2){f[c>>2]=165456;f[c+4>>2]=144;b[c+8>>0]=0;J_b(894216,c);a_b(c)}if((f[223555]|0)!=2){f[c>>2]=165456;f[c+4>>2]=145;b[c+8>>0]=0;J_b(894220,c);a_b(c)}if((f[223556]|0)!=2){f[c>>2]=165456;f[c+4>>2]=146;b[c+8>>0]=0;J_b(894224,c);a_b(c)}if((f[223557]|0)!=2){f[c>>2]=165456;f[c+4>>2]=147;b[c+8>>0]=0;J_b(894228,c);a_b(c)}if((f[223558]|0)!=2){f[c>>2]=165456;f[c+4>>2]=148;b[c+8>>0]=0;J_b(894232,c);a_b(c)}if((f[223559]|0)!=2){f[c>>2]=165456;f[c+4>>2]=149;b[c+8>>0]=0;J_b(894236,c);a_b(c)}if((f[223560]|0)!=2){f[c>>2]=165456;f[c+4>>2]=150;b[c+8>>0]=0;J_b(894240,c);a_b(c)}if((f[223561]|0)!=2){f[c>>2]=165456;f[c+4>>2]=151;b[c+8>>0]=0;J_b(894244,c);a_b(c)}if((f[223562]|0)!=2){f[c>>2]=165456;f[c+4>>2]=152;b[c+8>>0]=0;J_b(894248,c);a_b(c)}if((f[223563]|0)!=2){f[c>>2]=165456;f[c+4>>2]=153;b[c+8>>0]=0;J_b(894252,c);a_b(c)}if((f[223564]|0)!=2){f[c>>2]=165456;f[c+4>>2]=154;b[c+8>>0]=0;J_b(894256,c);a_b(c)}if((f[223565]|0)!=2){f[c>>2]=165456;f[c+4>>2]=155;b[c+8>>0]=0;J_b(894260,c);a_b(c)}if((f[223566]|0)!=2){f[c>>2]=165456;f[c+4>>2]=156;b[c+8>>0]=0;J_b(894264,c);a_b(c)}if((f[223567]|0)!=2){f[c>>2]=165456;f[c+4>>2]=157;b[c+8>>0]=0;J_b(894268,c);a_b(c)}if((f[223568]|0)!=2){f[c>>2]=165456;f[c+4>>2]=158;b[c+8>>0]=0;J_b(894272,c);a_b(c)}if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}if((f[223570]|0)!=2){f[c>>2]=165456;f[c+4>>2]=160;b[c+8>>0]=0;J_b(894280,c);a_b(c)}if((f[223571]|0)!=2){f[c>>2]=165456;f[c+4>>2]=161;b[c+8>>0]=0;J_b(894284,c);a_b(c)}if((f[223572]|0)!=2){f[c>>2]=165456;f[c+4>>2]=162;b[c+8>>0]=0;J_b(894288,c);a_b(c)}if((f[223573]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=163;b[c+8>>0]=0;J_b(894292,c);a_b(c);u=a;return}function a4b(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223545]|0)!=2){f[c>>2]=165456;f[c+4>>2]=135;b[c+8>>0]=0;J_b(894180,c);a_b(c)}jjc(538872,27);u=a;return}function b4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223548]|0)!=2){f[c>>2]=165456;f[c+4>>2]=138;b[c+8>>0]=0;J_b(894192,c);a_b(c)}f[134346]=167536;f[134347]=0;f[134348]=0;f[134349]=0;f[134350]=0;f[134351]=0;f[134352]=0;f[134353]=0;C_b(537384);u=a;return}function c4b(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223551]|0)!=2){f[c>>2]=165456;f[c+4>>2]=141;b[c+8>>0]=0;J_b(894204,c);a_b(c)}if((f[223556]|0)!=2){f[c>>2]=165456;f[c+4>>2]=146;b[c+8>>0]=0;J_b(894224,c);a_b(c)}if((f[223558]|0)!=2){f[c>>2]=165456;f[c+4>>2]=148;b[c+8>>0]=0;J_b(894232,c);a_b(c)}if((f[223553]|0)!=2){f[c>>2]=165456;f[c+4>>2]=143;b[c+8>>0]=0;J_b(894212,c);a_b(c)}if((f[223560]|0)!=2){f[c>>2]=165456;f[c+4>>2]=150;b[c+8>>0]=0;J_b(894240,c);a_b(c)}if((f[223571]|0)!=2){f[c>>2]=165456;f[c+4>>2]=161;b[c+8>>0]=0;J_b(894284,c);a_b(c)}f[134354]=170776;f[134355]=0;c=537424;d=c+112|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[134384]=537368;f[134385]=537368;f[134386]=537368;c=537548;f[c>>2]=0;f[c+4>>2]=0;C_b(537416);f[134387]=538104;f[134388]=538760;u=a;return}function d4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223552]|0)!=2){f[c>>2]=165456;f[c+4>>2]=142;b[c+8>>0]=0;J_b(894208,c);a_b(c)}f[134390]=170668;f[134391]=0;f[134392]=0;f[134393]=0;f[134394]=0;f[134395]=0;f[134396]=0;C_b(537560);f[134394]=537768;u=a;return}function e4b(){d_b(3005001,3005e3,495057);WXb();f[134398]=170560;f[134399]=0;f[134400]=0;f[134401]=0;f[134402]=0;f[134403]=0;C_b(537592);return}function f4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223553]|0)!=2){f[c>>2]=165456;f[c+4>>2]=143;b[c+8>>0]=0;J_b(894212,c);a_b(c)}if((f[223556]|0)!=2){f[c>>2]=165456;f[c+4>>2]=146;b[c+8>>0]=0;J_b(894224,c);a_b(c)}if((f[223549]|0)!=2){f[c>>2]=165456;f[c+4>>2]=139;b[c+8>>0]=0;J_b(894196,c);a_b(c)}if((f[223554]|0)!=2){f[c>>2]=165456;f[c+4>>2]=144;b[c+8>>0]=0;J_b(894216,c);a_b(c)}if((f[223561]|0)!=2){f[c>>2]=165456;f[c+4>>2]=151;b[c+8>>0]=0;J_b(894244,c);a_b(c)}if((f[223550]|0)==2){f[134404]=170452;f[134405]=0;g1c(537624,0,136)|0;f[134440]=537368;f[134441]=0;C_b(537616);f[134441]=538200;u=a;return}f[c>>2]=165456;f[c+4>>2]=140;b[c+8>>0]=0;J_b(894200,c);a_b(c);f[134404]=170452;f[134405]=0;g1c(537624,0,136)|0;f[134440]=537368;f[134441]=0;C_b(537616);f[134441]=538200;u=a;return}function g4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134442]=170344;trc(537772);f[134447]=0;f[134448]=0;f[134449]=0;f[134450]=0;f[134451]=0;f[134452]=0;f[134453]=0;C_b(537768);u=a;return}function h4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223562]|0)!=2){f[c>>2]=165456;f[c+4>>2]=152;b[c+8>>0]=0;J_b(894248,c);a_b(c)}f[134454]=170236;f[134455]=0;f[134456]=0;f[134457]=0;f[134458]=537368;f[134459]=537368;f[134460]=537368;f[134461]=537368;f[134462]=537368;f[134463]=0;f[134464]=0;f[134465]=0;f[134466]=1;f[134467]=1;C_b(537816);f[134463]=538256;u=a;return}function i4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223563]|0)!=2){f[c>>2]=165456;f[c+4>>2]=153;b[c+8>>0]=0;J_b(894252,c);a_b(c)}f[134468]=170128;f[134469]=0;f[134470]=0;f[134471]=0;f[134472]=537368;f[134473]=0;C_b(537872);f[134473]=538320;u=a;return}function j4b(){d_b(3005001,3005e3,495057);WXb();f[134474]=170020;f[134475]=0;f[134476]=0;f[134477]=0;f[134478]=0;f[134479]=0;C_b(537896);return}function k4b(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223557]|0)!=2){f[c>>2]=165456;f[c+4>>2]=147;b[c+8>>0]=0;J_b(894228,c);a_b(c)}if((f[223564]|0)!=2){f[c>>2]=165456;f[c+4>>2]=154;b[c+8>>0]=0;J_b(894256,c);a_b(c)}if((f[223555]|0)!=2){f[c>>2]=165456;f[c+4>>2]=145;b[c+8>>0]=0;J_b(894220,c);a_b(c)}f[134480]=169912;f[134481]=0;c=537928;d=c+56|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[134496]=537368;f[134497]=0;C_b(537920);f[134497]=538368;u=a;return}function l4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223565]|0)!=2){f[c>>2]=165456;f[c+4>>2]=155;b[c+8>>0]=0;J_b(894260,c);a_b(c)}f[134498]=169804;f[134499]=0;f[134500]=0;f[134501]=0;f[134502]=537368;c=538012;f[c>>2]=0;f[c+4>>2]=0;C_b(537992);f[134503]=538424;u=a;return}function m4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223559]|0)!=2){f[c>>2]=165456;f[c+4>>2]=149;b[c+8>>0]=0;J_b(894236,c);a_b(c)}if((f[223566]|0)!=2){f[c>>2]=165456;f[c+4>>2]=156;b[c+8>>0]=0;J_b(894264,c);a_b(c)}f[134506]=169696;f[134507]=0;f[134508]=0;f[134509]=0;f[134510]=0;f[134511]=0;f[134512]=0;f[134513]=0;f[134514]=537368;f[134515]=0;C_b(538024);f[134515]=538480;u=a;return}function n4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223567]|0)!=2){f[c>>2]=165456;f[c+4>>2]=157;b[c+8>>0]=0;J_b(894268,c);a_b(c)}f[134516]=169588;f[134517]=0;f[134518]=0;f[134519]=0;f[134520]=537368;f[134521]=537368;f[134522]=537368;f[134523]=0;d[269048]=0;C_b(538064);f[134523]=538536;u=a;return}function o4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134526]=169480;trc(538108);f[134531]=0;f[134532]=0;f[134533]=0;f[134534]=0;f[134535]=0;f[134536]=0;f[134537]=0;f[134538]=537368;f[134539]=537368;f[134540]=537368;f[134541]=537368;f[134542]=537368;f[134543]=537368;f[134544]=537368;f[134545]=537368;f[134546]=0;f[134547]=0;b[538192]=0;f[134549]=1;C_b(538104);u=a;return}function p4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134550]=169372;trc(538204);f[134555]=0;f[134556]=0;f[134557]=0;f[134558]=0;f[134559]=0;f[134560]=0;f[134561]=0;f[134562]=0;C_b(538200);u=a;return}function q4b(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134564]=169264;trc(538260);c=538276;d=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));C_b(538256);u=a;return}function r4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134580]=169156;trc(538324);f[134585]=0;f[134586]=0;f[134587]=0;f[134588]=0;f[134589]=0;f[134590]=0;f[134591]=0;C_b(538320);u=a;return}function s4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134592]=169048;trc(538372);f[134597]=0;f[134598]=0;f[134599]=0;f[134600]=0;f[134601]=0;f[134602]=0;f[134603]=0;d[269208]=0;C_b(538368);u=a;return}function t4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134606]=168940;trc(538428);f[134611]=0;f[134612]=0;f[134613]=0;f[134614]=0;f[134615]=0;f[134616]=0;f[134617]=0;b[538472]=0;C_b(538424);u=a;return}function u4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134620]=168832;trc(538484);f[134625]=0;f[134626]=0;f[134627]=0;f[134628]=0;f[134629]=0;f[134630]=0;f[134631]=0;b[538528]=0;C_b(538480);u=a;return}function v4b(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223569]|0)!=2){f[c>>2]=165456;f[c+4>>2]=159;b[c+8>>0]=0;J_b(894276,c);a_b(c)}f[134634]=168724;trc(538540);c=538556;d=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));C_b(538536);u=a;return}function w4b(){d_b(3005001,3005e3,495057);WXb();f[134648]=168616;f[134649]=0;f[134650]=0;f[134651]=0;f[134652]=537368;b[538612]=0;C_b(538592);return}function x4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223568]|0)!=2){f[c>>2]=165456;f[c+4>>2]=158;b[c+8>>0]=0;J_b(894272,c);a_b(c)}f[134654]=168508;f[134655]=0;f[134656]=0;f[134657]=0;f[134658]=0;f[134659]=0;f[134660]=0;f[134661]=0;f[134662]=537368;f[134663]=537368;f[134664]=537368;f[134666]=0;f[134667]=0;f[134668]=0;f[134669]=0;f[134670]=0;f[134671]=0;C_b(538616);u=a;return}function y4b(){d_b(3005001,3005e3,495057);WXb();f[134672]=168400;f[134673]=0;f[134680]=0;f[134681]=0;f[134682]=0;f[134684]=0;f[134685]=0;f[134686]=0;f[134687]=0;f[134674]=0;f[134675]=0;f[134676]=0;f[134677]=0;f[134678]=0;f[134688]=537368;f[134689]=537368;C_b(538688);return}function z4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223570]|0)!=2){f[c>>2]=165456;f[c+4>>2]=160;b[c+8>>0]=0;J_b(894280,c);a_b(c)}f[134690]=168292;f[134691]=0;f[134692]=0;f[134693]=0;f[134694]=0;f[134695]=0;f[134696]=0;f[134697]=0;C_b(538760);u=a;return}function A4b(){var a=0;d_b(3005001,3005e3,495057);WXb();f[134698]=168184;f[134699]=0;f[134700]=0;f[134701]=0;f[134702]=0;f[134703]=0;f[134704]=0;f[134706]=537368;a=538828;f[a>>2]=0;f[a+4>>2]=0;C_b(538792);return}function B4b(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,495057);WXb();if((f[223572]|0)!=2){f[c>>2]=165456;f[c+4>>2]=162;b[c+8>>0]=0;J_b(894288,c);a_b(c)}f[134710]=168076;f[134711]=0;f[134712]=0;f[134713]=0;f[134714]=0;f[134715]=0;f[134716]=0;f[134717]=0;C_b(538840);u=a;return}function C4b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=168076;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function D4b(a){a=a|0;C4b(a);cYc(a);return}function E4b(a){a=a|0;a=$Xc(32)|0;n5b(a);return a|0}function F4b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(32)|0;n5b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,20936,32);a=QXb(b,32)|0;o5b(a,b);c=a;return c|0}function G4b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function H4b(a){a=a|0;return f[a+4>>2]|0}function I4b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;f[h+16>>2]=0;i=h+8|0;j=f[i>>2]|0;do if(j&1|0?(k=f[h+32>>2]|0,(k|0)!=537368):0){l=k+11|0;if((b[l>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[l>>0]=0;break}}while(0);if(j&6|0){l=h+36|0;f[l>>2]=0;f[l+4>>2]=0}f[i>>2]=0;l=f[h+4>>2]|0;if(l&1|0?(k=l&-2,f[k>>2]|0):0)sqc(k)}while((g|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function J4b(a){a=a|0;return 1}function K4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;XZb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=$Xc(44)|0;U4b(a);y=a}else{if(f[o+64>>2]|0)SXb(o,20952,48);a=QXb(o,48)|0;W4b(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=YYb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}JYb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(OYb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=lSa(m)|0;else B=a&-2;if(!(Lqc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function L4b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function M4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function N4b(a){a=a|0;return f[a+12>>2]|0}function O4b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Pqc(j&-2,g)|0;return s|0}function P4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;I4b(a);c=kZc(b,21568,20936,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}T4b(a+16|0,c+16|0);return}function Q4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,20936,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}T4b(a+16|0,c+16|0);return}function R4b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function S4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539080;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function T4b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{V4b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(44)|0;U4b(l);V4b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,20952,48);l=QXb(i,48)|0;W4b(l,i);V4b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function U4b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=168184;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=538792?(f[223572]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=162;b[d+8>>0]=0;J_b(894288,d);a_b(d)}f[a+12>>2]=0;f[a+32>>2]=537368;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function V4b(a,b){a=a|0;b=b|0;m5b(b,a);return}function W4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=168184;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=a+24|0;f[g>>2]=0;if(c|0){if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[223572]|0)!=2){f[e>>2]=165456;f[e+4>>2]=162;b[e+8>>0]=0;J_b(894288,e);a_b(e)}f[a+12>>2]=0;f[a+32>>2]=537368;e=a+36|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function X4b(a){a=a|0;var c=0,d=0;f[a>>2]=168184;c=f[a+32>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function Y4b(a){a=a|0;X4b(a);cYc(a);return}function Z4b(a){a=a|0;a=$Xc(44)|0;U4b(a);return a|0}function _4b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(44)|0;U4b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,20952,48);a=QXb(b,48)|0;W4b(a,b);c=a;return c|0}function $4b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function a5b(a){a=a|0;return f[a+4>>2]|0}function b5b(a){a=a|0;var c=0,d=0,e=0,g=0;f[a+16>>2]=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0?(e=f[a+32>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&6|0){d=a+36|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function c5b(a){a=a|0;return 1}function d5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=c+4|0;e=a+16|0;g=a+20|0;h=a+24|0;i=a+8|0;j=a+32|0;k=a+4|0;l=a+36|0;m=a+40|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch((p&255)<<24>>24){case 10:break;case 8:{if(OUa(1,10,c,e)|0)continue a;else{t=0;q=46;break a}break}default:{s=p;break b}}o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;u=a&255}else{a=YYb(c)|0;if((a|0)>-1)u=a;else{t=0;q=46;break a}}a=HYb(c,u)|0;if((PYb(c)|0)>0)do{o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){n=b[o>>0]|0;v=n&255;if(n<<24>>24>-1){f[c>>2]=o+1;w=v}else{x=v;q=16}}else{x=0;q=16}if((q|0)==16){q=0;v=KYb(c,x)|0;o=J;if((o|0)>-1|(o|0)==-1&v>>>0>4294967295)w=v;else{t=0;q=46;break a}}v=f[e>>2]|0;if((v|0)==(f[g>>2]|0)){qHa(e,v+1|0);y=f[e>>2]|0}else y=v;v=f[h>>2]|0;f[e>>2]=y+1;f[v+4+(y<<2)>>2]=w}while((PYb(c)|0)>0);IYb(c,a);continue a;break}case 2:{if((p&255|0)!=18){s=p;break b}f[i>>2]=f[i>>2]|1;v=f[k>>2]|0;o=v&-2;if(!(v&1))z=o;else z=f[o+4>>2]|0;o=f[j>>2]|0;if((o|0)==537368){xJa(j,z,537368);A=f[j>>2]|0}else A=o;if(l$b(c,A)|0)continue a;else{t=0;q=46;break a}break}case 3:{if((p&255|0)!=24){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){v=b[o>>0]|0;n=v&255;if(v<<24>>24>-1){f[c>>2]=o+1;B=n}else{C=n;q=33}}else{C=0;q=33}if((q|0)==33){q=0;n=KYb(c,C)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)B=n;else{t=0;q=46;break a}}f[l>>2]=B;continue a;break}case 4:{if((p&255|0)!=32){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){o=b[n>>0]|0;v=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;D=v}else{E=v;q=39}}else{E=0;q=39}if((q|0)==39){q=0;v=KYb(c,E)|0;n=J;if((n|0)>-1|(n|0)==-1&v>>>0>4294967295)D=v;else{t=0;q=46;break a}}f[m>>2]=D;continue a;break}default:{s=p;break b}}}while(0);if(!s){t=1;q=46;break}v=f[k>>2]|0;if(!(v&1))F=lSa(k)|0;else F=v&-2;if(!(Lqc(c,s,F)|0)){t=0;q=46;break}}if((q|0)==46)return t|0;return 0}function e5b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=n$b(a+16|0)|0;if(!c)e=d;else{if((c|0)<0)g=11;else g=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=g+d|0}f[a+28>>2]=c;d=e+c|0;c=f[a+8>>2]|0;if(!(c&7)){h=d;i=a+12|0;f[i>>2]=h;return h|0}if(!(c&1))j=d;else{e=f[a+32>>2]|0;g=b[e+11>>0]|0;k=g<<24>>24<0?f[e+4>>2]|0:g&255;j=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=j;else{k=f[a+36>>2]|0;if((k|0)<0)m=11;else m=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+j|0}if(!(c&4)){h=l;i=a+12|0;f[i>>2]=h;return h|0}c=f[a+40>>2]|0;if((c|0)<0)n=11;else n=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=n+l|0;i=a+12|0;f[i>>2]=h;return h|0}function f5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{eZb(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else eZb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;n=((i|0)<0)<<31>>31;if((f[o>>2]|0)>9){k=f[e>>2]|0;j=i&255;if(i>>>0>127){l=k;m=j;p=i;q=n;while(1){b[l>>0]=m|-128;r=p;p=l1c(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=k;v=j}b[u>>0]=v;q=u+1-k|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else fZb(c,i,n);h=h+1|0}while((h|0)!=(g|0))}}g=f[a+8>>2]|0;if(g&1|0)f$b(2,f[a+32>>2]|0,c);if(g&2|0)S_b(3,f[a+36>>2]|0,c);if(g&4|0)S_b(4,f[a+40>>2]|0,c);g=f[a+4>>2]|0;if(!(g&1))return;Oqc(g&-2,c);return}function g5b(a){a=a|0;return f[a+12>>2]|0}function h5b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=f[c>>2]|0;c=f[a+24>>2]|0;g=0;e=l+1|0;while(1){l=f[c+4+(g<<2)>>2]|0;i=l&255;if(l>>>0>127){h=e;j=i;k=l;n=((l|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;l=k;k=l1c(k|0,n|0,7)|0;o=h+1|0;p=k&255;if(!(n>>>0>0|(n|0)==0&l>>>0>16383)){q=o;r=p;break}else{h=o;j=p;n=J}}}else{q=e;r=i}b[q>>0]=r;n=q+1|0;g=g+1|0;if((g|0)>=(m|0)){s=n;break}else e=n}}else s=d;d=f[a+8>>2]|0;if(!(d&1))t=s;else{e=f[a+32>>2]|0;b[s>>0]=18;t=gZb(e,s+1|0)|0}if(!(d&2))u=t;else{s=f[a+36>>2]|0;b[t>>0]=24;e=t+1|0;t=s&255;if(s>>>0>127){m=e;g=t;q=s;r=((s|0)<0)<<31>>31;while(1){b[m>>0]=g|-128;s=q;q=l1c(q|0,r|0,7)|0;c=m+1|0;n=q&255;if(!(r>>>0>0|(r|0)==0&s>>>0>16383)){v=c;w=n;break}else{m=c;g=n;r=J}}}else{v=e;w=t}b[v>>0]=w;u=v+1|0}if(!(d&4))x=u;else{d=f[a+40>>2]|0;b[u>>0]=32;v=u+1|0;u=d&255;if(d>>>0>127){w=v;t=u;e=d;r=((d|0)<0)<<31>>31;while(1){b[w>>0]=t|-128;d=e;e=l1c(e|0,r|0,7)|0;g=w+1|0;m=e&255;if(!(r>>>0>0|(r|0)==0&d>>>0>16383)){y=g;z=m;break}else{w=g;t=m;r=J}}}else{y=v;z=u}b[y>>0]=z;x=y+1|0}y=f[a+4>>2]|0;if(!(y&1)){A=x;return A|0}A=Pqc(y&-2,x)|0;return A|0}function i5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;f[a+16>>2]=0;d=a+8|0;e=f[d>>2]|0;do if(e&1|0?(g=f[a+32>>2]|0,(g|0)!=537368):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&6|0){e=a+36|0;f[e>>2]=0;f[e+4>>2]=0}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,20952,0)|0;if(!e){Ooc(c,a);return}else{m5b(a,e);return}}function j5b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,20952,0)|0;if(!c){Ooc(b,a);return}else{m5b(a,c);return}}function k5b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function l5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539072;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function m5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){qHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[b+8>>2]|0;if(!(g&7))return;do if(g&1|0){d=f[b+32>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+32|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,d);break}else{oYc(i,d)|0;break}}while(0);if(g&2|0)f[a+36>>2]=f[b+36>>2];if(g&4|0)f[a+40>>2]=f[b+40>>2];b=a+8|0;f[b>>2]=f[b>>2]|g;return}function n5b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=168076;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538840?(f[223573]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=163;b[d+8>>0]=0;J_b(894292,d);a_b(d)}f[a+12>>2]=0;u=c;return}function o5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=168076;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[223573]|0)==2){g=a+12|0;f[g>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=163;b[e+8>>0]=0;J_b(894292,e);a_b(e);g=a+12|0;f[g>>2]=0;u=d;return}function p5b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=168292;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function q5b(a){a=a|0;p5b(a);cYc(a);return}function r5b(a){a=a|0;a=$Xc(32)|0;a6b(a);return a|0}function s5b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(32)|0;a6b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,20968,32);a=QXb(b,32)|0;b6b(a,b);c=a;return c|0}function t5b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function u5b(a){a=a|0;return f[a+4>>2]|0}function v5b(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{Q5b(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function w5b(a){a=a|0;return 1}function x5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}if((q|0)==6){q=0;if((p|0)==10){o=f[i>>2]|0;do if(o){a=f[k>>2]|0;n=f[o>>2]|0;if((a|0)>=(n|0))if((n|0)==(f[j>>2]|0)){t=n;q=12;break}else{v=n;w=o;q=13;break}else{f[k>>2]=a+1;x=f[o+4+(a<<2)>>2]|0;break}}else{t=f[j>>2]|0;q=12}while(0);if((q|0)==12){q=0;XZb(h,t+1|0);o=f[i>>2]|0;v=f[o>>2]|0;w=o;q=13}if((q|0)==13){q=0;f[w>>2]=v+1;o=f[h>>2]|0;if(!o){a=$Xc(72)|0;H5b(a);y=a}else{if(f[o+64>>2]|0)SXb(o,20984,72);a=QXb(o,72)|0;J5b(a,o);y=a}a=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[a+4+(o<<2)>>2]=y;x=y}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;z=a&255}else{a=YYb(c)|0;if((a|0)>-1)z=a;else{A=0;q=32;break}}JYb(e,c,z);if((f[l>>2]|0)<0){q=25;break}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=25;break}if(OYb(c,f[e>>2]|0)|0)continue;else{A=0;q=32;break}}else s=p}if(!s){A=1;q=32;break}a=f[m>>2]|0;if(!(a&1))B=lSa(m)|0;else B=a&-2;if(!(Lqc(c,s,B)|0)){A=0;q=32;break}}if((q|0)==25){A=0;u=d;return A|0}else if((q|0)==32){u=d;return A|0}return 0}function y5b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function z5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function A5b(a){a=a|0;return f[a+12>>2]|0}function B5b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Pqc(j&-2,g)|0;return s|0}function C5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))return;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{Q5b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=a+4|0;d=f[c>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(b,21568,20968,0)|0;if(!g){Ooc(b,a);return}b=f[g+4>>2]|0;if(b&1|0){d=f[c>>2]|0;if(!(d&1))h=lSa(c)|0;else h=d&-2;vqc(h,b&-2)}G5b(a+16|0,g+16|0);return}function D5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,20968,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}G5b(a+16|0,c+16|0);return}function E5b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function F5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539064;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function G5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{I5b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(72)|0;H5b(l);I5b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,20984,72);l=QXb(i,72)|0;J5b(l,i);I5b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function H5b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=168400;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538688?(f[223570]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=160;b[d+8>>0]=0;J_b(894280,d);a_b(d)}f[a+12>>2]=0;f[a+64>>2]=537368;f[a+68>>2]=537368;u=c;return}function I5b(a,b){a=a|0;b=b|0;$5b(b,a);return}function J5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=168400;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=a+24|0;f[g>>2]=0;if(!c){f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0}else{if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+32>>2]=0;f[a+36>>2]=0;h=a+40|0;f[h>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);g=QXb(c,8)|0;f[h>>2]=g;f[g>>2]=c}f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;if((f[223570]|0)==2){i=a+12|0;f[i>>2]=0;j=a+64|0;f[j>>2]=537368;k=a+68|0;f[k>>2]=537368;u=d;return}f[e>>2]=165456;f[e+4>>2]=160;b[e+8>>0]=0;J_b(894280,e);a_b(e);i=a+12|0;f[i>>2]=0;j=a+64|0;f[j>>2]=537368;k=a+68|0;f[k>>2]=537368;u=d;return}function K5b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=168400;c=f[a+64>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+68>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[c>>2]=0;return}function L5b(a){a=a|0;K5b(a);cYc(a);return}function M5b(a){a=a|0;a=$Xc(72)|0;H5b(a);return a|0}function N5b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(72)|0;H5b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,20984,72);a=QXb(b,72)|0;J5b(a,b);c=a;return c|0}function O5b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function P5b(a){a=a|0;return f[a+4>>2]|0}function Q5b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a+16>>2]=0;f[a+32>>2]=0;c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0?(g=f[a+64>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&2|0?(e=f[a+68>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function R5b(a){a=a|0;return 1}function S5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;d=c+4|0;e=a+16|0;g=a+20|0;h=a+24|0;i=a+32|0;j=a+36|0;k=a+40|0;l=a+8|0;m=a+64|0;n=a+4|0;o=a+68|0;p=a+48|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=a+1;s=r;t=6}else{u=r;t=5}}else{u=0;t=5}if((t|0)==5){t=0;r=ZYb(c,u)|0;if((r+-1|0)>>>0<127){s=r;t=6}else v=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{switch((s&255)<<24>>24){case 10:break;case 8:{if(OUa(1,10,c,e)|0)continue a;else{w=0;t=58;break a}break}default:{v=s;break b}}r=f[c>>2]|0;if(r>>>0<(f[d>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;x=a&255}else{a=YYb(c)|0;if((a|0)>-1)x=a;else{w=0;t=58;break a}}a=HYb(c,x)|0;if((PYb(c)|0)>0)do{r=f[c>>2]|0;if(r>>>0<(f[d>>2]|0)>>>0){q=b[r>>0]|0;y=q&255;if(q<<24>>24>-1){f[c>>2]=r+1;z=y}else{A=y;t=16}}else{A=0;t=16}if((t|0)==16){t=0;y=KYb(c,A)|0;r=J;if((r|0)>-1|(r|0)==-1&y>>>0>4294967295)z=y;else{w=0;t=58;break a}}y=f[e>>2]|0;if((y|0)==(f[g>>2]|0)){qHa(e,y+1|0);B=f[e>>2]|0}else B=y;y=f[h>>2]|0;f[e>>2]=B+1;f[y+4+(B<<2)>>2]=z}while((PYb(c)|0)>0);IYb(c,a);continue a;break}case 2:{switch((s&255)<<24>>24){case 18:break;case 16:{if(OUa(1,18,c,i)|0)continue a;else{w=0;t=58;break a}break}default:{v=s;break b}}y=f[c>>2]|0;if(y>>>0<(f[d>>2]|0)>>>0?(r=b[y>>0]|0,r<<24>>24>-1):0){f[c>>2]=y+1;C=r&255}else{r=YYb(c)|0;if((r|0)>-1)C=r;else{w=0;t=58;break a}}r=HYb(c,C)|0;if((PYb(c)|0)>0)do{y=f[c>>2]|0;if(y>>>0<(f[d>>2]|0)>>>0){q=b[y>>0]|0;D=q&255;if(q<<24>>24>-1){f[c>>2]=y+1;E=D}else{F=D;t=31}}else{F=0;t=31}if((t|0)==31){t=0;D=KYb(c,F)|0;y=J;if((y|0)>-1|(y|0)==-1&D>>>0>4294967295)E=D;else{w=0;t=58;break a}}D=f[i>>2]|0;if((D|0)==(f[j>>2]|0)){qHa(i,D+1|0);G=f[i>>2]|0}else G=D;D=f[k>>2]|0;f[i>>2]=G+1;f[D+4+(G<<2)>>2]=E}while((PYb(c)|0)>0);IYb(c,r);continue a;break}case 3:{if((s&255|0)!=26){v=s;break b}f[l>>2]=f[l>>2]|1;a=f[n>>2]|0;D=a&-2;if(!(a&1))H=D;else H=f[D+4>>2]|0;D=f[m>>2]|0;if((D|0)==537368){xJa(m,H,537368);I=f[m>>2]|0}else I=D;if(l$b(c,I)|0)continue a;else{w=0;t=58;break a}break}case 4:{if((s&255|0)!=34){v=s;break b}f[l>>2]=f[l>>2]|2;D=f[n>>2]|0;a=D&-2;if(!(D&1))K=a;else K=f[a+4>>2]|0;a=f[o>>2]|0;if((a|0)==537368){xJa(o,K,537368);L=f[o>>2]|0}else L=a;if(l$b(c,L)|0)continue a;else{w=0;t=58;break a}break}case 6:{if((s&255|0)!=50){v=s;break b}if(l$b(c,pHa(p)|0)|0)continue a;else{w=0;t=58;break a}break}default:{v=s;break b}}}while(0);if(!v){w=1;t=58;break}a=f[n>>2]|0;if(!(a&1))M=lSa(n)|0;else M=a&-2;if(!(Lqc(c,v,M)|0)){w=0;t=58;break}}if((t|0)==58)return w|0;return 0}function T5b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=n$b(a+16|0)|0;if(!c)e=d;else{if((c|0)<0)g=11;else g=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=g+d|0}f[a+28>>2]=c;d=e+c|0;c=n$b(a+32|0)|0;if(!c)h=d;else{if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+d|0}f[a+44>>2]=c;d=f[a+52>>2]|0;i=h+c+d|0;if((d|0)>0){c=f[a+60>>2]|0;h=0;e=i;while(1){g=f[c+4+(h<<2)>>2]|0;j=b[g+11>>0]|0;k=j<<24>>24<0?f[g+4>>2]|0:j&255;j=k+e+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=j;break}else e=j}}else l=i;i=f[a+8>>2]|0;if(!(i&3)){m=l;n=a+12|0;f[n>>2]=m;return m|0}if(!(i&1))o=l;else{e=f[a+64>>2]|0;d=b[e+11>>0]|0;h=d<<24>>24<0?f[e+4>>2]|0:d&255;o=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2)){m=o;n=a+12|0;f[n>>2]=m;return m|0}i=f[a+68>>2]|0;h=b[i+11>>0]|0;l=h<<24>>24<0?f[i+4>>2]|0:h&255;m=o+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=a+12|0;f[n>>2]=m;return m|0}function U5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{eZb(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else eZb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;n=((i|0)<0)<<31>>31;if((f[o>>2]|0)>9){k=f[e>>2]|0;j=i&255;if(i>>>0>127){l=k;m=j;p=i;q=n;while(1){b[l>>0]=m|-128;r=p;p=l1c(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=k;v=j}b[u>>0]=v;q=u+1-k|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else fZb(c,i,n);h=h+1|0}while((h|0)!=(g|0))}}g=a+32|0;if((f[g>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){o=c+4|0;b[f[o>>2]>>0]=18;f[o>>2]=(f[o>>2]|0)+1;o=(f[h>>2]|0)+-1|0;f[h>>2]=o;w=o}else{eZb(c,18);w=f[h>>2]|0}o=f[a+44>>2]|0;if((w|0)>4){w=c+4|0;e=f[w>>2]|0;if(o>>>0>127){u=o;v=e;while(1){b[v>>0]=u|128;d=u>>>7;q=v+1|0;if(u>>>0>16383){u=d;v=q}else{x=q;y=d;break}}}else{x=e;y=o}b[x>>0]=y;y=x+1-e|0;f[w>>2]=(f[w>>2]|0)+y;f[h>>2]=(f[h>>2]|0)-y}else eZb(c,o);o=f[g>>2]|0;if((o|0)>0){g=a+40|0;y=c+8|0;h=c+4|0;w=0;do{e=f[(f[g>>2]|0)+4+(w<<2)>>2]|0;x=((e|0)<0)<<31>>31;if((f[y>>2]|0)>9){v=f[h>>2]|0;u=e&255;if(e>>>0>127){d=v;q=u;m=e;l=x;while(1){b[d>>0]=q|-128;p=m;m=l1c(m|0,l|0,7)|0;t=d+1|0;s=m&255;if(!(l>>>0>0|(l|0)==0&p>>>0>16383)){z=t;A=s;break}else{d=t;q=s;l=J}}}else{z=v;A=u}b[z>>0]=A;l=z+1-v|0;f[h>>2]=(f[h>>2]|0)+l;f[y>>2]=(f[y>>2]|0)-l}else fZb(c,e,x);w=w+1|0}while((w|0)!=(o|0))}}o=f[a+8>>2]|0;if(o&1|0)f$b(3,f[a+64>>2]|0,c);if(o&2|0)f$b(4,f[a+68>>2]|0,c);o=f[a+52>>2]|0;if((o|0)>0){w=a+60|0;y=0;do{e$b(6,f[(f[w>>2]|0)+4+(y<<2)>>2]|0,c);y=y+1|0}while((y|0)!=(o|0))}o=f[a+4>>2]|0;if(!(o&1))return;Oqc(o&-2,c);return}function V5b(a){a=a|0;return f[a+12>>2]|0}function W5b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=f[c>>2]|0;c=f[a+24>>2]|0;g=0;e=l+1|0;while(1){l=f[c+4+(g<<2)>>2]|0;i=l&255;if(l>>>0>127){h=e;j=i;k=l;n=((l|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;l=k;k=l1c(k|0,n|0,7)|0;o=h+1|0;p=k&255;if(!(n>>>0>0|(n|0)==0&l>>>0>16383)){q=o;r=p;break}else{h=o;j=p;n=J}}}else{q=e;r=i}b[q>>0]=r;n=q+1|0;g=g+1|0;if((g|0)>=(m|0)){s=n;break}else e=n}}else s=d;d=a+32|0;if((f[d>>2]|0)>0){b[s>>0]=18;e=s+1|0;m=f[a+44>>2]|0;if(m>>>0>127){g=m;q=e;while(1){b[q>>0]=g|128;r=g>>>7;c=q+1|0;if(g>>>0>16383){g=r;q=c}else{t=c;u=r;break}}}else{t=e;u=m}b[t>>0]=u;u=f[d>>2]|0;d=f[a+40>>2]|0;m=0;e=t+1|0;while(1){t=f[d+4+(m<<2)>>2]|0;q=t&255;if(t>>>0>127){g=e;r=q;c=t;n=((t|0)<0)<<31>>31;while(1){b[g>>0]=r|-128;t=c;c=l1c(c|0,n|0,7)|0;j=g+1|0;h=c&255;if(!(n>>>0>0|(n|0)==0&t>>>0>16383)){v=j;w=h;break}else{g=j;r=h;n=J}}}else{v=e;w=q}b[v>>0]=w;n=v+1|0;m=m+1|0;if((m|0)>=(u|0)){x=n;break}else e=n}}else x=s;s=f[a+8>>2]|0;if(!(s&1))y=x;else{e=f[a+64>>2]|0;b[x>>0]=26;y=gZb(e,x+1|0)|0}if(!(s&2))z=y;else{s=f[a+68>>2]|0;b[y>>0]=34;z=gZb(s,y+1|0)|0}y=f[a+52>>2]|0;if((y|0)>0){s=a+60|0;x=0;e=z;while(1){u=f[(f[s>>2]|0)+4+(x<<2)>>2]|0;b[e>>0]=50;m=gZb(u,e+1|0)|0;x=x+1|0;if((x|0)==(y|0)){A=m;break}else e=m}}else A=z;z=f[a+4>>2]|0;if(!(z&1)){B=A;return B|0}B=Pqc(z&-2,A)|0;return B|0}function X5b(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Q5b(a);c=kZc(b,21568,20984,0)|0;if(!c){Ooc(b,a);return}else{$5b(a,c);return}}function Y5b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,20984,0)|0;if(!c){Ooc(b,a);return}else{$5b(a,c);return}}function Z5b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function _5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539056;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function $5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){qHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+32|0;d=b+32|0;e=f[d>>2]|0;if(e|0){qHa(g,(f[g>>2]|0)+e|0);o1c((f[a+40>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}vSa(a+48|0,b+48|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+64>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+64|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,g);break}else{oYc(i,g)|0;break}}while(0);if(!(d&2))return;d=f[b+68>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;b=a+68|0;a=f[c>>2]|0;c=a&-2;if(!(a&1))k=c;else k=f[c+4>>2]|0;c=f[b>>2]|0;if((c|0)==537368){xJa(b,k,d);return}else{oYc(c,d)|0;return}}function a6b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=168292;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538760?(f[223571]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=161;b[d+8>>0]=0;J_b(894284,d);a_b(d)}f[a+12>>2]=0;u=c;return}function b6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=168292;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[223571]|0)==2){g=a+12|0;f[g>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=161;b[e+8>>0]=0;J_b(894284,e);a_b(e);g=a+12|0;f[g>>2]=0;u=d;return}function c6b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=168508;S6b(a);b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function d6b(a){a=a|0;c6b(a);cYc(a);return}function e6b(a){a=a|0;a=$Xc(72)|0;Q6b(a);return a|0}function f6b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(72)|0;Q6b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21e3,72);a=QXb(b,72)|0;R6b(a,b);c=a;return c|0}function g6b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function h6b(a){a=a|0;return f[a+4>>2]|0}function i6b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+8|0;do if(f[i>>2]&1|0?(j=f[h+16>>2]|0,(j|0)!=537368):0){k=j+11|0;if((b[k>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[k>>0]=0;break}}while(0);b[h+20>>0]=0;f[i>>2]=0;k=f[h+4>>2]|0;if(k&1|0?(j=k&-2,f[j>>2]|0):0)sqc(j)}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;do if(d&7|0){do if(d&1|0?(g=f[a+32>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0?(h=f[a+36>>2]|0,(h|0)!=537368):0){i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[i>>0]=0;break}}while(0);if(d&4|0?(i=f[a+40>>2]|0,(i|0)!=537368):0){h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[h>>0]=0;break}}}while(0);if(d&56|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function j6b(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+28>>2]|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;if((f[(f[b+4+(c<<2)>>2]|0)+8>>2]&3|0)!=3){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function k6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+16|0;j=a+28|0;k=a+24|0;l=a+20|0;m=e+4|0;n=a+8|0;o=a+32|0;q=a+4|0;r=a+48|0;t=e+8|0;v=a+56|0;w=e+8|0;x=a+64|0;y=a+36|0;z=a+40|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=a+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=ZYb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;switch(C>>>3&536870911|0){case 2:{if((C&255|0)!=18){F=C;break b}B=f[j>>2]|0;do if(B){a=f[l>>2]|0;A=f[B>>2]|0;if((a|0)>=(A|0))if((A|0)==(f[k>>2]|0)){G=A;D=13;break}else{H=A;I=B;D=14;break}else{f[l>>2]=a+1;J=f[B+4+(a<<2)>>2]|0;break}}else{G=f[k>>2]|0;D=13}while(0);if((D|0)==13){D=0;XZb(i,G+1|0);B=f[j>>2]|0;H=f[B>>2]|0;I=B;D=14}if((D|0)==14){D=0;f[I>>2]=H+1;B=f[i>>2]|0;if(!B){a=$Xc(24)|0;v6b(a);K=a}else{if(f[B+64>>2]|0)SXb(B,21016,24);a=QXb(B,24)|0;x6b(a,B);K=a}a=f[j>>2]|0;B=f[l>>2]|0;f[l>>2]=B+1;f[a+4+(B<<2)>>2]=K;J=K}B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){f[c>>2]=B+1;L=a&255}else{a=YYb(c)|0;if((a|0)>-1)L=a;else{M=0;D=72;break a}}JYb(e,c,L);if((f[m>>2]|0)<0){D=26;break a}if(!(Mi[f[(f[J>>2]|0)+44>>2]&1023](J,c)|0)){D=26;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{M=0;D=72;break a}break}case 3:{if((C&255|0)!=26){F=C;break b}f[n>>2]=f[n>>2]|1;a=f[q>>2]|0;B=a&-2;if(!(a&1))N=B;else N=f[B+4>>2]|0;B=f[o>>2]|0;if((B|0)==537368){xJa(o,N,537368);O=f[o>>2]|0}else O=B;if(l$b(c,O)|0)continue a;else{M=0;D=72;break a}break}case 4:{if((C&255|0)!=32){F=C;break b}f[n>>2]=f[n>>2]|8;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){A=r;f[A>>2]=a&255;f[A+4>>2]=0;f[c>>2]=B+1;continue a}LYb(e,c);B=e;A=f[B+4>>2]|0;a=r;f[a>>2]=f[B>>2];f[a+4>>2]=A;if(!(b[t>>0]|0)){M=0;D=72;break a}else continue a;break}case 5:{if((C&255|0)!=40){F=C;break b}f[n>>2]=f[n>>2]|16;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;P=a&255;Q=0}else{LYb(e,c);a=e;if(!(b[w>>0]|0)){M=0;D=72;break a}else{P=f[a>>2]|0;Q=f[a+4>>2]|0}}a=v;f[a>>2]=P;f[a+4>>2]=Q;continue a;break}case 6:{if((C&255|0)!=49){F=C;break b}f[n>>2]=f[n>>2]|32;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>7){A=a;B=A;R=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=A+4|0;A=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=e;f[B>>2]=R;f[B+4>>2]=A;f[c>>2]=a+8;f[s>>2]=R;f[s+4>>2]=A;S=+p[s>>3]}else{if(!(XYb(c,e)|0)){D=52;break a}S=+p[e>>3]}p[x>>3]=S;continue a;break}case 7:{if((C&255|0)!=58){F=C;break b}f[n>>2]=f[n>>2]|2;A=f[q>>2]|0;R=A&-2;if(!(A&1))T=R;else T=f[R+4>>2]|0;R=f[y>>2]|0;if((R|0)==537368){xJa(y,T,537368);U=f[y>>2]|0}else U=R;if(l$b(c,U)|0)continue a;else{M=0;D=72;break a}break}case 8:{if((C&255|0)!=66){F=C;break b}f[n>>2]=f[n>>2]|4;R=f[q>>2]|0;A=R&-2;if(!(R&1))V=A;else V=f[A+4>>2]|0;A=f[z>>2]|0;if((A|0)==537368){xJa(z,V,537368);W=f[z>>2]|0}else W=A;if(l$b(c,W)|0)continue a;else{M=0;D=72;break a}break}default:{F=C;break b}}}while(0);if(!F){M=1;D=72;break}A=f[q>>2]|0;if(!(A&1))X=lSa(q)|0;else X=A&-2;if(!(Lqc(c,F,X)|0)){M=0;D=72;break}}if((D|0)==26){M=0;u=d;return M|0}else if((D|0)==52){M=0;u=d;return M|0}else if((D|0)==72){u=d;return M|0}return 0}function l6b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+8>>2]|0;if(!(i&63)){k=g;l=a+12|0;f[l>>2]=k;return k|0}if(!(i&1))m=g;else{c=f[a+32>>2]|0;h=b[c+11>>0]|0;d=h<<24>>24<0?f[c+4>>2]|0:h&255;m=g+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))n=m;else{d=f[a+36>>2]|0;g=b[d+11>>0]|0;h=g<<24>>24<0?f[d+4>>2]|0:g&255;n=m+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&4))o=n;else{h=f[a+40>>2]|0;m=b[h+11>>0]|0;g=m<<24>>24<0?f[h+4>>2]|0:m&255;o=n+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&8))p=o;else{g=a+48|0;n=t1c(f[g>>2]|1|0,f[g+4>>2]|0,1)|0;p=o+1+((((n^63)*9|0)+73|0)>>>6)|0}if(!(i&16))q=p;else{n=a+56|0;o=t1c(f[n>>2]|1|0,f[n+4>>2]|0,1)|0;q=p+1+((((o^63)*9|0)+73|0)>>>6)|0}k=i&32|0?q+9|0:q;l=a+12|0;f[l>>2]=k;return k|0}function m6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(2,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+8>>2]|0;if(c&1|0)f$b(3,f[a+32>>2]|0,b);if(c&8|0){e=a+48|0;V_b(4,f[e>>2]|0,f[e+4>>2]|0,b)}if(c&16|0){e=a+56|0;T_b(5,f[e>>2]|0,f[e+4>>2]|0,b)}if(c&32|0)b$b(6,+p[a+64>>3],b);if(c&2|0)h$b(7,f[a+36>>2]|0,b);if(c&4|0)f$b(8,f[a+40>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function n6b(a){a=a|0;return f[a+12>>2]|0}function o6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;q=n+1|0;if(m>>>0>16383){m=o;n=q}else{r=q;t=o;break}}}else{r=k;t=l}b[r>>0]=t;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,r+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+8>>2]|0;if(!(j&1))u=g;else{e=f[a+32>>2]|0;b[g>>0]=26;u=gZb(e,g+1|0)|0}if(!(j&8))v=u;else{g=a+48|0;e=f[g>>2]|0;i=f[g+4>>2]|0;b[u>>0]=32;g=u+1|0;u=e&255;if(i>>>0>0|(i|0)==0&e>>>0>127){r=g;c=u;t=e;e=i;while(1){b[r>>0]=c|-128;i=t;t=l1c(t|0,e|0,7)|0;h=r+1|0;n=t&255;if(!(e>>>0>0|(e|0)==0&i>>>0>16383)){w=h;x=n;break}else{r=h;c=n;e=J}}}else{w=g;x=u}b[w>>0]=x;v=w+1|0}if(!(j&16))y=v;else{w=a+56|0;x=f[w>>2]|0;u=f[w+4>>2]|0;b[v>>0]=40;w=v+1|0;v=x&255;if(u>>>0>0|(u|0)==0&x>>>0>127){g=w;e=v;c=x;x=u;while(1){b[g>>0]=e|-128;u=c;c=l1c(c|0,x|0,7)|0;r=g+1|0;t=c&255;if(!(x>>>0>0|(x|0)==0&u>>>0>16383)){z=r;A=t;break}else{g=r;e=t;x=J}}}else{z=w;A=v}b[z>>0]=A;y=z+1|0}if(!(j&32))B=y;else{C=+p[a+64>>3];b[y>>0]=49;z=y+1|0;p[s>>3]=C;b[z>>0]=b[s>>0];b[z+1>>0]=b[s+1>>0];b[z+2>>0]=b[s+2>>0];b[z+3>>0]=b[s+3>>0];b[z+4>>0]=b[s+4>>0];b[z+5>>0]=b[s+5>>0];b[z+6>>0]=b[s+6>>0];b[z+7>>0]=b[s+7>>0];B=y+9|0}if(!(j&2))D=B;else{y=f[a+36>>2]|0;b[B>>0]=58;D=gZb(y,B+1|0)|0}if(!(j&4))E=D;else{j=f[a+40>>2]|0;b[D>>0]=66;E=gZb(j,D+1|0)|0}D=f[a+4>>2]|0;if(!(D&1)){F=E;return F|0}F=Pqc(D&-2,E)|0;return F|0}function p6b(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;i6b(a);c=kZc(b,21568,21e3,0)|0;if(!c){Ooc(b,a);return}else{t6b(a,c);return}}function q6b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21e3,0)|0;if(!c){Ooc(b,a);return}else{t6b(a,c);return}}function r6b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539048;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function t6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}u6b(a+16|0,b+16|0);d=f[b+8>>2]|0;if(!(d&63))return;do if(d&1|0){g=f[b+32>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+32|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,g);break}else{oYc(i,g)|0;break}}while(0);do if(d&2|0){j=f[b+36>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+36|0;i=f[c>>2]|0;e=i&-2;if(!(i&1))k=e;else k=f[e+4>>2]|0;e=f[g>>2]|0;if((e|0)==537368){xJa(g,k,j);break}else{oYc(e,j)|0;break}}while(0);do if(d&4|0){k=f[b+40>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|4;j=a+40|0;e=f[c>>2]|0;g=e&-2;if(!(e&1))l=g;else l=f[g+4>>2]|0;g=f[j>>2]|0;if((g|0)==537368){xJa(j,l,k);break}else{oYc(g,k)|0;break}}while(0);if(d&8|0){l=b+48|0;c=f[l+4>>2]|0;k=a+48|0;f[k>>2]=f[l>>2];f[k+4>>2]=c}if(d&16|0){c=b+56|0;k=f[c+4>>2]|0;l=a+56|0;f[l>>2]=f[c>>2];f[l+4>>2]=k}if(d&32|0)p[a+64>>3]=+p[b+64>>3];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function u6b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{w6b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(24)|0;v6b(l);w6b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21016,24);l=QXb(i,24)|0;x6b(l,i);w6b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function v6b(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=168616;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=538592?(f[223568]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=158;b[d+8>>0]=0;J_b(894272,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;b[a+20>>0]=0;u=c;return}function w6b(a,b){a=a|0;b=b|0;P6b(b,a);return}function x6b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=168616;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223568]|0)!=2){f[e>>2]=165456;f[e+4>>2]=158;b[e+8>>0]=0;J_b(894272,e);a_b(e)}f[a+12>>2]=0;f[a+16>>2]=537368;b[a+20>>0]=0;u=d;return}function y6b(a){a=a|0;var c=0,d=0;f[a>>2]=168616;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function z6b(a){a=a|0;y6b(a);cYc(a);return}function A6b(a){a=a|0;a=$Xc(24)|0;v6b(a);return a|0}function B6b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(24)|0;v6b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21016,24);a=QXb(b,24)|0;x6b(a,b);c=a;return c|0}function C6b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function D6b(a){a=a|0;return f[a+4>>2]|0}function E6b(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0?(d=f[a+16>>2]|0,(d|0)!=537368):0){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);b[a+20>>0]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function F6b(a){a=a|0;return (f[a+8>>2]&3|0)==3|0}function G6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;a=e+8|0;a:while(1){l=f[c>>2]|0;if(l>>>0<(f[g>>2]|0)>>>0){m=b[l>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=l+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:break;case 2:{if((o&255|0)!=16){r=o;break b}f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(l=b[n>>0]|0,l<<24>>24>-1):0){f[c>>2]=n+1;s=l<<24>>24!=0}else{LYb(e,c);l=e;if(!(b[a>>0]|0)){t=0;p=25;break a}else s=(f[l>>2]|0)!=0|(f[l+4>>2]|0)!=0}b[k>>0]=s&1;continue a;break}default:{r=o;break b}}if((o&255|0)==10){f[h>>2]=f[h>>2]|1;l=f[j>>2]|0;n=l&-2;if(!(l&1))v=n;else v=f[n+4>>2]|0;n=f[i>>2]|0;if((n|0)==537368){xJa(i,v,537368);w=f[i>>2]|0}else w=n;if(l$b(c,w)|0)continue a;else{t=0;p=25;break a}}else r=o}while(0);if(!r){t=1;p=25;break}n=f[j>>2]|0;if(!(n&1))x=lSa(j)|0;else x=n&-2;if(!(Lqc(c,r,x)|0)){t=0;p=25;break}}if((p|0)==25){u=d;return t|0}return 0}function H6b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if((c&3|0)==3){e=f[a+16>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0?f[e+4>>2]|0:g&255;i=d+3+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=a+12|0;f[j>>2]=i;return i|0}if(!(c&1))k=0;else{h=f[a+16>>2]|0;g=b[h+11>>0]|0;e=g<<24>>24<0?f[h+4>>2]|0:g&255;k=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}i=(c&2|0?k+2|0:k)+d|0;j=a+12|0;f[j>>2]=i;return i|0}function I6b(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+16>>2]|0,c);if(d&2|0)c$b(2,(b[a+20>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function J6b(a){a=a|0;return f[a+12>>2]|0}function K6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{c=b[a+20>>0]|0;b[e>>0]=16;b[e+1>>0]=c;h=e+2|0}e=f[a+4>>2]|0;if(!(e&1)){i=h;return i|0}i=Pqc(e&-2,h)|0;return i|0}function L6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;do if(f[d>>2]&1|0?(e=f[a+16>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);b[a+20>>0]=0;f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(c,21568,21016,0)|0;if(!g){Ooc(c,a);return}else{P6b(a,g);return}}function M6b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21016,0)|0;if(!c){Ooc(b,a);return}else{P6b(a,c);return}}function N6b(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function O6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539040;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function P6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&3))return;do if(e&1|0){h=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==537368){xJa(g,k,h);break}else{oYc(j,h)|0;break}}while(0);if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Q6b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=168508;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538616?(f[223569]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=159;b[d+8>>0]=0;J_b(894276,d);a_b(d)}f[a+12>>2]=0;f[a+32>>2]=537368;f[a+36>>2]=537368;f[a+40>>2]=537368;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function R6b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=168508;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[223569]|0)!=2){f[e>>2]=165456;f[e+4>>2]=159;b[e+8>>0]=0;J_b(894276,e);a_b(e)}f[a+12>>2]=0;f[a+32>>2]=537368;f[a+36>>2]=537368;f[a+40>>2]=537368;e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;u=d;return}function S6b(a){a=a|0;var c=0;c=f[a+32>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+36>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+40>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function T6b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function U6b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=168724;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function V6b(a){a=a|0;U6b(a);cYc(a);return}function W6b(a){a=a|0;a=$Xc(56)|0;n7b(a);return a|0}function X6b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(56)|0;n7b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21032,56);a=QXb(b,56)|0;o7b(a,b);c=a;return c|0}function Y6b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function Z6b(a){a=a|0;return f[a+20>>2]|0}function _6b(a){a=a|0;var b=0,c=0,d=0,e=0;Ksc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{i6b(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}b=a+24|0;if(f[b>>2]&3|0){c=a+48|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function $6b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function a7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+32|0;m=e+4|0;n=a+4|0;o=a+20|0;p=a+52|0;a:while(1){b:while(1){a=f[c>>2]|0;q=f[g>>2]|0;do if(a>>>0<q>>>0){r=b[a>>0]|0;s=r&255;t=a+1|0;if(r<<24>>24>0){v=t;w=s}else{if(t>>>0>=q>>>0){x=s;y=8;break}r=h[t>>0]|0;if(((r^128)&s)>>>0<=127){x=s;y=8;break}v=a+2|0;w=s+-128+(r<<7)|0}f[c>>2]=v;z=w;y=10}else{x=0;y=8}while(0);if((y|0)==8){y=0;a=ZYb(c,x)|0;if((a+-1|0)>>>0<16383){z=a;y=10}else A=a}c:do if((y|0)==10){y=0;switch(z>>>3&536870911|0){case 33:{if((z&255|0)!=8){A=z;break c}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;B=q<<24>>24!=0}else{LYb(e,c);q=e;if(!(b[k>>0]|0)){C=0;y=47;break a}else B=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}b[j>>0]=B&1;continue b;break}case 34:{if((z&255|0)==16)break b;else{A=z;break c}break}case 999:{if((z&255|0)!=58){A=z;break c}q=m7b(l)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;D=r&255}else{r=YYb(c)|0;if((r|0)>-1)D=r;else{C=0;y=47;break a}}JYb(e,c,D);if((f[m>>2]|0)<0){y=35;break a}if(!(Mi[f[(f[q>>2]|0)+44>>2]&1023](q,c)|0)){y=35;break a}if(OYb(c,f[e>>2]|0)|0)continue b;else{C=0;y=47;break a}break}default:{A=z;break c}}}while(0);if(!A){C=1;y=47;break a}q=f[o>>2]|0;r=(q&1|0)==0;if(A>>>0>7999){if(r)E=lSa(o)|0;else E=q&-2;if(Fgc(n,A,c,538536,E)|0)continue;else{C=0;y=47;break a}}else{if(r)F=lSa(o)|0;else F=q&-2;if(Lqc(c,A,F)|0)continue;else{C=0;y=47;break a}}}q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0){r=b[q>>0]|0;a=r&255;if(r<<24>>24>-1){f[c>>2]=q+1;G=a}else{H=a;y=21}}else{H=0;y=21}if((y|0)==21){y=0;a=KYb(c,H)|0;q=J;if((q|0)>-1|(q|0)==-1&a>>>0>4294967295)G=a;else{C=0;y=47;break}}if(G>>>0<3){f[i>>2]=f[i>>2]|2;f[p>>2]=G;continue}a=f[o>>2]|0;if(!(a&1))I=lSa(o)|0;else I=a&-2;yqc(I,34,G,((G|0)<0)<<31>>31)}if((y|0)==35){C=0;u=d;return C|0}else if((y|0)==47){u=d;return C|0}return 0}function b7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&3)){j=e;k=a+28|0;f[k>>2]=j;return j|0}b=h&1|0?e+3|0:e;if(!(h&2)){j=b;k=a+28|0;f[k>>2]=j;return j|0}h=f[a+52>>2]|0;if((h|0)<0)l=12;else l=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;j=l+b|0;k=a+28|0;f[k>>2]=j;return j|0}function c7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)c$b(33,(b[a+48>>0]|0)!=0,c);if(d&2|0)d$b(34,f[a+52>>2]|0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{k$b(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Tsc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function d7b(a){a=a|0;return f[a+28>>2]|0}function e7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=b[a+48>>0]|0;b[d>>0]=-120;b[d+1>>0]=2;b[d+2>>0]=h;g=d+3|0}if(!(e&2))i=g;else{e=f[a+52>>2]|0;b[g>>0]=-112;b[g+1>>0]=2;d=g+2|0;g=e&255;if(e>>>0>127){h=d;j=g;k=e;l=((e|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;e=k;k=l1c(k|0,l|0,7)|0;m=h+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&e>>>0>16383)){o=m;p=n;break}else{h=m;j=n;l=J}}}else{o=d;p=g}b[o>>0]=p;i=o+1|0}o=f[a+36>>2]|0;if(!o)q=i;else{p=a+44|0;g=0;d=i;while(1){i=f[(f[p>>2]|0)+4+(g<<2)>>2]|0;b[d>>0]=-70;b[d+1>>0]=62;l=d+2|0;j=_i[f[(f[i>>2]|0)+60>>2]&2047](i)|0;if(j>>>0>127){h=j;k=l;while(1){b[k>>0]=h|128;n=h>>>7;m=k+1|0;if(h>>>0>16383){h=n;k=m}else{r=m;s=n;break}}}else{r=l;s=j}b[r>>0]=s;k=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,r+1|0)|0;g=g+1|0;if((g|0)==(o|0)){q=k;break}else d=k}}d=Jgc(a+4|0,1e3,536870912,c,q)|0;q=f[a+20>>2]|0;if(!(q&1)){t=d;return t|0}t=Pqc(q&-2,d)|0;return t|0}function f7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;if(f[c>>2]&3|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,21032,0)|0;if(!d){Ooc(b,a);return}else{j7b(a,d);return}}function g7b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21032,0)|0;if(!c){Ooc(b,a);return}else{j7b(a,c);return}}function h7b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function i7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539032;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function j7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Lsc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}k7b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&3))return;if(e&1|0)b[a+48>>0]=b[c+48>>0]|0;if(e&2|0)f[a+52>>2]=f[c+52>>2];c=a+24|0;f[c>>2]=f[c>>2]|e;return}function k7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{l7b(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(72)|0;Q6b(l);l7b(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21e3,72);l=QXb(i,72)|0;R6b(l,i);l7b(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function l7b(a,b){a=a|0;b=b|0;t6b(b,a);return}function m7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(72)|0;Q6b(a);o=a}else{if(f[l+64>>2]|0)SXb(l,21e3,72);a=QXb(l,72)|0;R6b(a,l);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function n7b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=168724;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538536?(f[223567]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=157;b[d+8>>0]=0;J_b(894268,d);a_b(d)}f[a+28>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function o7b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=168724;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223567]|0)!=2){f[e>>2]=165456;f[e+4>>2]=157;b[e+8>>0]=0;J_b(894268,e);a_b(e)}f[a+28>>2]=0;e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function p7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=168832;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function q7b(a){a=a|0;p7b(a);cYc(a);return}function r7b(a){a=a|0;a=$Xc(52)|0;G7b(a);return a|0}function s7b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(52)|0;G7b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21048,56);a=QXb(b,56)|0;H7b(a,b);c=a;return c|0}function t7b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function u7b(a){a=a|0;return f[a+20>>2]|0}function v7b(a){a=a|0;var c=0,d=0,e=0,g=0;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}b[a+48>>0]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function w7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function x7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+32|0;m=e+4|0;n=a+4|0;o=a+20|0;a:while(1){a=f[c>>2]|0;p=f[g>>2]|0;do if(a>>>0<p>>>0){q=b[a>>0]|0;r=q&255;s=a+1|0;if(q<<24>>24>0){t=s;v=r}else{if(s>>>0>=p>>>0){w=r;x=7;break}q=h[s>>0]|0;if(((q^128)&r)>>>0<=127){w=r;x=7;break}t=a+2|0;v=r+-128+(q<<7)|0}f[c>>2]=t;y=v;x=9}else{w=0;x=7}while(0);if((x|0)==7){x=0;a=ZYb(c,w)|0;if((a+-1|0)>>>0<16383){y=a;x=9}else z=a}b:do if((x|0)==9){x=0;switch(y>>>3&536870911|0){case 33:{if((y&255|0)!=8){z=y;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(p=b[a>>0]|0,p<<24>>24>-1):0){f[c>>2]=a+1;A=p<<24>>24!=0}else{LYb(e,c);p=e;if(!(b[k>>0]|0)){B=0;x=35;break a}else A=(f[p>>2]|0)!=0|(f[p+4>>2]|0)!=0}b[j>>0]=A&1;continue a;break}case 999:break;default:{z=y;break b}}if((y&255|0)==58){p=m7b(l)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;C=q&255}else{q=YYb(c)|0;if((q|0)>-1)C=q;else{B=0;x=35;break a}}JYb(e,c,C);if((f[m>>2]|0)<0){x=23;break a}if(!(Mi[f[(f[p>>2]|0)+44>>2]&1023](p,c)|0)){x=23;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=35;break a}}else z=y}while(0);if(!z){B=1;x=35;break}p=f[o>>2]|0;q=(p&1|0)==0;if(z>>>0>7999){if(q)D=lSa(o)|0;else D=p&-2;if(Fgc(n,z,c,538480,D)|0)continue;else{B=0;x=35;break}}else{if(q)E=lSa(o)|0;else E=p&-2;if(Lqc(c,z,E)|0)continue;else{B=0;x=35;break}}}if((x|0)==23){B=0;u=d;return B|0}else if((x|0)==35){u=d;return B|0}return 0}function y7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+3|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}d=a+44|0;n=0;o=c;while(1){c=f[(f[d>>2]|0)+4+(n<<2)>>2]|0;p=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=p+o+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(b|0)){e=c;break}else o=c}g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+3|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}function z7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(f[a+24>>2]&1|0)c$b(33,(b[a+48>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{k$b(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Tsc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function A7b(a){a=a|0;return f[a+28>>2]|0}function B7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a+24>>2]&1))e=d;else{g=b[a+48>>0]|0;b[d>>0]=-120;b[d+1>>0]=2;b[d+2>>0]=g;e=d+3|0}d=f[a+36>>2]|0;if(!d)h=e;else{g=a+44|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}j=Jgc(a+4|0,1e3,536870912,c,h)|0;h=f[a+20>>2]|0;if(!(h&1)){s=j;return s|0}s=Pqc(h&-2,j)|0;return s|0}function C7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;Ksc(a+4|0);d=a+36|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+44>>2]|0;h=0;do{i6b(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[d>>2]=0}b[a+48>>0]=0;f[a+24>>2]=0;d=f[a+20>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);D7b(a,c);return}function D7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,21048,0)|0;if(!d){Ooc(c,a);return}Lsc(a+4|0,d+4|0);c=a+20|0;e=f[d+20>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}k7b(a+32|0,d+32|0);if(!(f[d+24>>2]&1))return;e=b[d+48>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|1;b[a+48>>0]=e;return}function E7b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function F7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539024;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function G7b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=168832;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538480?(f[223566]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=156;b[d+8>>0]=0;J_b(894264,d);a_b(d)}f[a+28>>2]=0;b[a+48>>0]=0;u=c;return}function H7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=168832;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223566]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=156;b[e+8>>0]=0;J_b(894264,e);a_b(e);g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}function I7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=168940;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function J7b(a){a=a|0;I7b(a);cYc(a);return}function K7b(a){a=a|0;a=$Xc(52)|0;Z7b(a);return a|0}function L7b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(52)|0;Z7b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21064,56);a=QXb(b,56)|0;_7b(a,b);c=a;return c|0}function M7b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function N7b(a){a=a|0;return f[a+20>>2]|0}function O7b(a){a=a|0;var c=0,d=0,e=0,g=0;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}b[a+48>>0]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function P7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function Q7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+32|0;m=e+4|0;n=a+4|0;o=a+20|0;a:while(1){a=f[c>>2]|0;p=f[g>>2]|0;do if(a>>>0<p>>>0){q=b[a>>0]|0;r=q&255;s=a+1|0;if(q<<24>>24>0){t=s;v=r}else{if(s>>>0>=p>>>0){w=r;x=7;break}q=h[s>>0]|0;if(((q^128)&r)>>>0<=127){w=r;x=7;break}t=a+2|0;v=r+-128+(q<<7)|0}f[c>>2]=t;y=v;x=9}else{w=0;x=7}while(0);if((x|0)==7){x=0;a=ZYb(c,w)|0;if((a+-1|0)>>>0<16383){y=a;x=9}else z=a}b:do if((x|0)==9){x=0;switch(y>>>3&536870911|0){case 1:{if((y&255|0)!=8){z=y;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(p=b[a>>0]|0,p<<24>>24>-1):0){f[c>>2]=a+1;A=p<<24>>24!=0}else{LYb(e,c);p=e;if(!(b[k>>0]|0)){B=0;x=35;break a}else A=(f[p>>2]|0)!=0|(f[p+4>>2]|0)!=0}b[j>>0]=A&1;continue a;break}case 999:break;default:{z=y;break b}}if((y&255|0)==58){p=m7b(l)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;C=q&255}else{q=YYb(c)|0;if((q|0)>-1)C=q;else{B=0;x=35;break a}}JYb(e,c,C);if((f[m>>2]|0)<0){x=23;break a}if(!(Mi[f[(f[p>>2]|0)+44>>2]&1023](p,c)|0)){x=23;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=35;break a}}else z=y}while(0);if(!z){B=1;x=35;break}p=f[o>>2]|0;q=(p&1|0)==0;if(z>>>0>7999){if(q)D=lSa(o)|0;else D=p&-2;if(Fgc(n,z,c,538424,D)|0)continue;else{B=0;x=35;break}}else{if(q)E=lSa(o)|0;else E=p&-2;if(Lqc(c,z,E)|0)continue;else{B=0;x=35;break}}}if((x|0)==23){B=0;u=d;return B|0}else if((x|0)==35){u=d;return B|0}return 0}function R7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+2|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}d=a+44|0;n=0;o=c;while(1){c=f[(f[d>>2]|0)+4+(n<<2)>>2]|0;p=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=p+o+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(b|0)){e=c;break}else o=c}g=a+24|0;h=f[g>>2]|0;i=h&1;j=(i|0)!=0;k=e+2|0;l=j?k:e;m=a+28|0;f[m>>2]=l;return l|0}function S7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(f[a+24>>2]&1|0)c$b(1,(b[a+48>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{k$b(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Tsc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function T7b(a){a=a|0;return f[a+28>>2]|0}function U7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a+24>>2]&1))e=d;else{g=b[a+48>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}d=f[a+36>>2]|0;if(!d)h=e;else{g=a+44|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}j=Jgc(a+4|0,1e3,536870912,c,h)|0;h=f[a+20>>2]|0;if(!(h&1)){s=j;return s|0}s=Pqc(h&-2,j)|0;return s|0}function V7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;Ksc(a+4|0);d=a+36|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+44>>2]|0;h=0;do{i6b(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[d>>2]=0}b[a+48>>0]=0;f[a+24>>2]=0;d=f[a+20>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);W7b(a,c);return}function W7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,21064,0)|0;if(!d){Ooc(c,a);return}Lsc(a+4|0,d+4|0);c=a+20|0;e=f[d+20>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}k7b(a+32|0,d+32|0);if(!(f[d+24>>2]&1))return;e=b[d+48>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|1;b[a+48>>0]=e;return}function X7b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Y7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539016;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z7b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=168940;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538424?(f[223565]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=155;b[d+8>>0]=0;J_b(894260,d);a_b(d)}f[a+28>>2]=0;b[a+48>>0]=0;u=c;return}function _7b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=168940;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223565]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=155;b[e+8>>0]=0;J_b(894260,e);a_b(e);g=a+28|0;f[g>>2]=0;h=a+48|0;b[h>>0]=0;u=d;return}function $7b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=169048;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function a8b(a){a=a|0;$7b(a);cYc(a);return}function b8b(a){a=a|0;a=$Xc(52)|0;r8b(a);return a|0}function c8b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(52)|0;r8b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21080,56);a=QXb(b,56)|0;s8b(a,b);c=a;return c|0}function d8b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function e8b(a){a=a|0;return f[a+20>>2]|0}function f8b(a){a=a|0;var b=0,c=0,e=0,g=0;Ksc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(c|0));f[b>>2]=0}d[a+48>>1]=0;f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function g8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function h8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+49|0;m=e+8|0;n=a+32|0;o=e+4|0;p=a+4|0;q=a+20|0;a:while(1){a=f[c>>2]|0;r=f[g>>2]|0;do if(a>>>0<r>>>0){s=b[a>>0]|0;t=s&255;v=a+1|0;if(s<<24>>24>0){w=v;x=t}else{if(v>>>0>=r>>>0){y=t;z=7;break}s=h[v>>0]|0;if(((s^128)&t)>>>0<=127){y=t;z=7;break}w=a+2|0;x=t+-128+(s<<7)|0}f[c>>2]=w;A=x;z=9}else{y=0;z=7}while(0);if((z|0)==7){z=0;a=ZYb(c,y)|0;if((a+-1|0)>>>0<16383){A=a;z=9}else B=a}b:do if((z|0)==9){z=0;switch(A>>>3&536870911|0){case 2:{if((A&255|0)!=16){B=A;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;C=r<<24>>24!=0}else{LYb(e,c);r=e;if(!(b[k>>0]|0)){D=0;z=41;break a}else C=(f[r>>2]|0)!=0|(f[r+4>>2]|0)!=0}b[j>>0]=C&1;continue a;break}case 3:{if((A&255|0)!=24){B=A;break b}f[i>>2]=f[i>>2]|2;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;E=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[m>>0]|0)){D=0;z=41;break a}else E=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=E&1;continue a;break}case 999:{if((A&255|0)!=58){B=A;break b}a=m7b(n)|0;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(s=b[r>>0]|0,s<<24>>24>-1):0){f[c>>2]=r+1;F=s&255}else{s=YYb(c)|0;if((s|0)>-1)F=s;else{D=0;z=41;break a}}JYb(e,c,F);if((f[o>>2]|0)<0){z=29;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){z=29;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{D=0;z=41;break a}break}default:{B=A;break b}}}while(0);if(!B){D=1;z=41;break}a=f[q>>2]|0;s=(a&1|0)==0;if(B>>>0>7999){if(s)G=lSa(q)|0;else G=a&-2;if(Fgc(p,B,c,538368,G)|0)continue;else{D=0;z=41;break}}else{if(s)H=lSa(q)|0;else H=a&-2;if(Lqc(c,B,H)|0)continue;else{D=0;z=41;break}}}if((z|0)==29){D=0;u=d;return D|0}else if((z|0)==41){u=d;return D|0}return 0}function i8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&3)){j=e;k=a+28|0;f[k>>2]=j;return j|0}b=h&1|0?e+2|0:e;j=h&2|0?b+2|0:b;k=a+28|0;f[k>>2]=j;return j|0}function j8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)c$b(2,(b[a+48>>0]|0)!=0,c);if(d&2|0)c$b(3,(b[a+49>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{k$b(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Tsc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function k8b(a){a=a|0;return f[a+28>>2]|0}function l8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=b[a+48>>0]|0;b[d>>0]=16;b[d+1>>0]=h;g=d+2|0}if(!(e&2))i=g;else{e=b[a+49>>0]|0;b[g>>0]=24;b[g+1>>0]=e;i=g+2|0}g=f[a+36>>2]|0;if(!g)j=i;else{e=a+44|0;d=0;h=i;while(1){i=f[(f[e>>2]|0)+4+(d<<2)>>2]|0;b[h>>0]=-70;b[h+1>>0]=62;k=h+2|0;l=_i[f[(f[i>>2]|0)+60>>2]&2047](i)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,q+1|0)|0;d=d+1|0;if((d|0)==(g|0)){j=n;break}else h=n}}h=Jgc(a+4|0,1e3,536870912,c,j)|0;j=f[a+20>>2]|0;if(!(j&1)){s=h;return s|0}s=Pqc(j&-2,h)|0;return s|0}function m8b(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0;if((a|0)==(b|0))return;Ksc(a+4|0);c=a+36|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+44>>2]|0;h=0;do{i6b(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[c>>2]=0}d[a+48>>1]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(e=c&-2,f[e>>2]|0):0)sqc(e);e=kZc(b,21568,21080,0)|0;if(!e){Ooc(b,a);return}else{q8b(a,e);return}}function n8b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21080,0)|0;if(!c){Ooc(b,a);return}else{q8b(a,c);return}}function o8b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function p8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539008;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function q8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Lsc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}k7b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&3))return;if(e&1|0)b[a+48>>0]=b[c+48>>0]|0;if(e&2|0)b[a+49>>0]=b[c+49>>0]|0;c=a+24|0;f[c>>2]=f[c>>2]|e;return}function r8b(a){a=a|0;var c=0,e=0,g=0;c=u;u=u+16|0;e=c;f[a>>2]=169048;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;g=a+32|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((a|0)!=538368?(f[223564]|0)!=2:0){f[e>>2]=165456;f[e+4>>2]=154;b[e+8>>0]=0;J_b(894256,e);a_b(e)}f[a+28>>2]=0;d[a+48>>1]=0;u=c;return}function s8b(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;f[a>>2]=169048;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223564]|0)==2){h=a+28|0;f[h>>2]=0;i=a+48|0;d[i>>1]=0;u=e;return}f[g>>2]=165456;f[g+4>>2]=154;b[g+8>>0]=0;J_b(894256,g);a_b(g);h=a+28|0;f[h>>2]=0;i=a+48|0;d[i>>1]=0;u=e;return}function t8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=169156;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function u8b(a){a=a|0;t8b(a);cYc(a);return}function v8b(a){a=a|0;a=$Xc(48)|0;K8b(a);return a|0}function w8b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(48)|0;K8b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21096,48);a=QXb(b,48)|0;L8b(a,b);c=a;return c|0}function x8b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function y8b(a){a=a|0;return f[a+20>>2]|0}function z8b(a){a=a|0;var b=0,c=0,d=0,e=0;Ksc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{i6b(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function A8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function B8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+32|0;j=e+4|0;k=a+4|0;l=a+20|0;while(1){a=f[c>>2]|0;m=f[g>>2]|0;do if(a>>>0<m>>>0){n=b[a>>0]|0;o=n&255;p=a+1|0;if(n<<24>>24>0){q=p;r=o}else{if(p>>>0>=m>>>0){s=o;t=7;break}n=h[p>>0]|0;if(((n^128)&o)>>>0<=127){s=o;t=7;break}q=a+2|0;r=o+-128+(n<<7)|0}f[c>>2]=q;v=r;t=9}else{s=0;t=7}while(0);if((t|0)==7){t=0;a=ZYb(c,s)|0;if((a+-1|0)>>>0<16383){v=a;t=9}else w=a}if((t|0)==9){t=0;if((v|0)==7994){a=m7b(i)|0;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[c>>2]=m+1;x=n&255}else{n=YYb(c)|0;if((n|0)>-1)x=n;else{y=0;t=28;break}}JYb(e,c,x);if((f[j>>2]|0)<0){t=16;break}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){t=16;break}if(OYb(c,f[e>>2]|0)|0)continue;else{y=0;t=28;break}}else w=v}if(!w){y=1;t=28;break}a=f[l>>2]|0;n=(a&1|0)==0;if(w>>>0>7999){if(n)z=lSa(l)|0;else z=a&-2;if(Fgc(k,w,c,538320,z)|0)continue;else{y=0;t=28;break}}else{if(n)A=lSa(l)|0;else A=a&-2;if(Lqc(c,w,A)|0)continue;else{y=0;t=28;break}}}if((t|0)==16){y=0;u=d;return y|0}else if((t|0)==28){u=d;return y|0}return 0}function C8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+28|0;f[g>>2]=e;return e|0}d=a+44|0;h=0;i=c;while(1){c=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=c;break}else i=c}g=a+28|0;f[g>>2]=e;return e|0}function D8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+36>>2]|0;if(c|0){d=a+44|0;e=0;do{k$b(999,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}Tsc(a+4|0,1e3,536870912,b);c=f[a+20>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function E8b(a){a=a|0;return f[a+28>>2]|0}function F8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+36>>2]|0;if(!e)g=d;else{h=a+44|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=Jgc(a+4|0,1e3,536870912,c,g)|0;g=f[a+20>>2]|0;if(!(g&1)){s=j;return s|0}s=Pqc(g&-2,j)|0;return s|0}function G8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);H8b(a,b);return}function H8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,21096,0)|0;if(!c){Ooc(b,a);return}Lsc(a+4|0,c+4|0);b=a+20|0;d=f[c+20>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}k7b(a+32|0,c+32|0);return}function I8b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function J8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=539e3;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function K8b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=169156;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538320?(f[223563]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=153;b[d+8>>0]=0;J_b(894252,d);a_b(d)}f[a+28>>2]=0;u=c;return}function L8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=169156;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223563]|0)==2){g=a+28|0;f[g>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=153;b[e+8>>0]=0;J_b(894252,e);a_b(e);g=a+28|0;f[g>>2]=0;u=d;return}function M8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=169264;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function N8b(a){a=a|0;M8b(a);cYc(a);return}function O8b(a){a=a|0;a=$Xc(60)|0;c9b(a);return a|0}function P8b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(60)|0;c9b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21112,64);a=QXb(b,64)|0;d9b(a,b);c=a;return c|0}function Q8b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function R8b(a){a=a|0;return f[a+20>>2]|0}function S8b(a){a=a|0;var b=0,c=0,d=0,e=0;Ksc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{i6b(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}b=a+24|0;if(f[b>>2]&63|0){c=a+48|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0}f[b>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function T8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function U8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=a+20|0;l=a+52|0;m=e+8|0;n=a+54|0;o=e+8|0;p=a+53|0;q=e+8|0;r=a+56|0;s=a+55|0;t=e+8|0;v=a+32|0;w=e+4|0;x=a+4|0;a:while(1){a=f[c>>2]|0;y=f[g>>2]|0;do if(a>>>0<y>>>0){z=b[a>>0]|0;A=z&255;B=a+1|0;if(z<<24>>24>0){C=B;D=A}else{if(B>>>0>=y>>>0){E=A;F=7;break}z=h[B>>0]|0;if(((z^128)&A)>>>0<=127){E=A;F=7;break}C=a+2|0;D=A+-128+(z<<7)|0}f[c>>2]=C;G=D;F=9}else{E=0;F=7}while(0);if((F|0)==7){F=0;a=ZYb(c,E)|0;if((a+-1|0)>>>0<16383){G=a;F=9}else H=a}b:do if((F|0)==9){F=0;switch(G>>>3&536870911|0){case 1:{if((G&255|0)!=8){H=G;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){y=b[a>>0]|0;z=y&255;if(y<<24>>24>-1){f[c>>2]=a+1;I=z}else{K=z;F=14}}else{K=0;F=14}if((F|0)==14){F=0;z=KYb(c,K)|0;a=J;if((a|0)>-1|(a|0)==-1&z>>>0>4294967295)I=z;else{L=0;F=75;break a}}if(I>>>0<3){f[i>>2]=f[i>>2]|1;f[j>>2]=I;continue a}z=f[k>>2]|0;if(!(z&1))M=lSa(k)|0;else M=z&-2;yqc(M,1,I,((I|0)<0)<<31>>31);continue a;break}case 2:{if((G&255|0)!=16){H=G;break b}f[i>>2]=f[i>>2]|2;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(a=b[z>>0]|0,a<<24>>24>-1):0){f[c>>2]=z+1;N=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[m>>0]|0)){L=0;F=75;break a}else N=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=N&1;continue a;break}case 3:{if((G&255|0)!=24){H=G;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(z=b[a>>0]|0,z<<24>>24>-1):0){f[c>>2]=a+1;O=z<<24>>24!=0}else{LYb(e,c);z=e;if(!(b[o>>0]|0)){L=0;F=75;break a}else O=(f[z>>2]|0)!=0|(f[z+4>>2]|0)!=0}b[n>>0]=O&1;continue a;break}case 5:{if((G&255|0)!=40){H=G;break b}f[i>>2]=f[i>>2]|4;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(a=b[z>>0]|0,a<<24>>24>-1):0){f[c>>2]=z+1;P=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[q>>0]|0)){L=0;F=75;break a}else P=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[p>>0]=P&1;continue a;break}case 6:{if((G&255|0)!=48){H=G;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){z=b[a>>0]|0;y=z&255;if(z<<24>>24>-1){f[c>>2]=a+1;Q=y}else{R=y;F=43}}else{R=0;F=43}if((F|0)==43){F=0;y=KYb(c,R)|0;a=J;if((a|0)>-1|(a|0)==-1&y>>>0>4294967295)Q=y;else{L=0;F=75;break a}}if(Q>>>0<3){f[i>>2]=f[i>>2]|32;f[r>>2]=Q;continue a}y=f[k>>2]|0;if(!(y&1))S=lSa(k)|0;else S=y&-2;yqc(S,6,Q,((Q|0)<0)<<31>>31);continue a;break}case 10:{if((G&255|0)!=80){H=G;break b}f[i>>2]=f[i>>2]|16;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(a=b[y>>0]|0,a<<24>>24>-1):0){f[c>>2]=y+1;T=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[t>>0]|0)){L=0;F=75;break a}else T=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[s>>0]=T&1;continue a;break}case 999:{if((G&255|0)!=58){H=G;break b}a=m7b(v)|0;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(z=b[y>>0]|0,z<<24>>24>-1):0){f[c>>2]=y+1;U=z&255}else{z=YYb(c)|0;if((z|0)>-1)U=z;else{L=0;F=75;break a}}JYb(e,c,U);if((f[w>>2]|0)<0){F=63;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){F=63;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{L=0;F=75;break a}break}default:{H=G;break b}}}while(0);if(!H){L=1;F=75;break}a=f[k>>2]|0;z=(a&1|0)==0;if(H>>>0>7999){if(z)V=lSa(k)|0;else V=a&-2;if(Fgc(x,H,c,538256,V)|0)continue;else{L=0;F=75;break}}else{if(z)W=lSa(k)|0;else W=a&-2;if(Lqc(c,H,W)|0)continue;else{L=0;F=75;break}}}if((F|0)==63){L=0;u=d;return L|0}else if((F|0)==75){u=d;return L|0}return 0}function V8b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&63)){j=e;k=a+28|0;f[k>>2]=j;return j|0}if(!(h&1))l=e;else{b=f[a+48>>2]|0;if((b|0)<0)m=11;else m=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+e|0}e=h&2|0?l+2|0:l;l=h&4|0?e+2|0:e;e=h&8|0?l+2|0:l;l=h&16|0?e+2|0:e;if(!(h&32)){j=l;k=a+28|0;f[k>>2]=j;return j|0}h=f[a+56>>2]|0;if((h|0)<0)n=11;else n=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=n+l|0;k=a+28|0;f[k>>2]=j;return j|0}function W8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)d$b(1,f[a+48>>2]|0,c);if(d&2|0)c$b(2,(b[a+52>>0]|0)!=0,c);if(d&8|0)c$b(3,(b[a+54>>0]|0)!=0,c);if(d&4|0)c$b(5,(b[a+53>>0]|0)!=0,c);if(d&32|0)d$b(6,f[a+56>>2]|0,c);if(d&16|0)c$b(10,(b[a+55>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{k$b(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Tsc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function X8b(a){a=a|0;return f[a+28>>2]|0}function Y8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=f[a+48>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&2))r=g;else{p=b[a+52>>0]|0;b[g>>0]=16;b[g+1>>0]=p;r=g+2|0}if(!(e&8))s=r;else{g=b[a+54>>0]|0;b[r>>0]=24;b[r+1>>0]=g;s=r+2|0}if(!(e&4))t=s;else{r=b[a+53>>0]|0;b[s>>0]=40;b[s+1>>0]=r;t=s+2|0}if(!(e&32))u=t;else{s=f[a+56>>2]|0;b[t>>0]=48;r=t+1|0;t=s&255;if(s>>>0>127){g=r;p=t;q=s;d=((s|0)<0)<<31>>31;while(1){b[g>>0]=p|-128;s=q;q=l1c(q|0,d|0,7)|0;i=g+1|0;m=q&255;if(!(d>>>0>0|(d|0)==0&s>>>0>16383)){v=i;w=m;break}else{g=i;p=m;d=J}}}else{v=r;w=t}b[v>>0]=w;u=v+1|0}if(!(e&16))x=u;else{e=b[a+55>>0]|0;b[u>>0]=80;b[u+1>>0]=e;x=u+2|0}u=f[a+36>>2]|0;if(!u)y=x;else{e=a+44|0;v=0;w=x;while(1){x=f[(f[e>>2]|0)+4+(v<<2)>>2]|0;b[w>>0]=-70;b[w+1>>0]=62;t=w+2|0;r=_i[f[(f[x>>2]|0)+60>>2]&2047](x)|0;if(r>>>0>127){d=r;p=t;while(1){b[p>>0]=d|128;g=d>>>7;q=p+1|0;if(d>>>0>16383){d=g;p=q}else{z=q;A=g;break}}}else{z=t;A=r}b[z>>0]=A;p=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,z+1|0)|0;v=v+1|0;if((v|0)==(u|0)){y=p;break}else w=p}}w=Jgc(a+4|0,1e3,536870912,c,y)|0;y=f[a+20>>2]|0;if(!(y&1)){B=w;return B|0}B=Pqc(y&-2,w)|0;return B|0}function Z8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;if(f[c>>2]&63|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[c>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,21112,0)|0;if(!d){Ooc(b,a);return}else{b9b(a,d);return}}function _8b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21112,0)|0;if(!c){Ooc(b,a);return}else{b9b(a,c);return}}function $8b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function a9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538992;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function b9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Lsc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}k7b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&63))return;if(e&1|0)f[a+48>>2]=f[c+48>>2];if(e&2|0)b[a+52>>0]=b[c+52>>0]|0;if(e&4|0)b[a+53>>0]=b[c+53>>0]|0;if(e&8|0)b[a+54>>0]=b[c+54>>0]|0;if(e&16|0)b[a+55>>0]=b[c+55>>0]|0;if(e&32|0)f[a+56>>2]=f[c+56>>2];c=a+24|0;f[c>>2]=f[c>>2]|e;return}function c9b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=169264;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538256?(f[223562]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=152;b[d+8>>0]=0;J_b(894248,d);a_b(d)}f[a+28>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;u=c;return}function d9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=169264;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223562]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=152;b[e+8>>0]=0;J_b(894248,e);a_b(e);g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;u=d;return}function e9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=169372;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function f9b(a){a=a|0;e9b(a);cYc(a);return}function g9b(a){a=a|0;a=$Xc(52)|0;w9b(a);return a|0}function h9b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(52)|0;w9b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21128,56);a=QXb(b,56)|0;x9b(a,b);c=a;return c|0}function i9b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function j9b(a){a=a|0;return f[a+20>>2]|0}function k9b(a){a=a|0;var b=0,c=0,d=0,e=0;Ksc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{i6b(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}f[a+48>>2]=0;f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function l9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function m9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=e+8|0;l=a+49|0;m=e+8|0;n=a+50|0;o=e+8|0;p=a+51|0;q=e+8|0;r=a+32|0;s=e+4|0;t=a+4|0;v=a+20|0;a:while(1){a=f[c>>2]|0;w=f[g>>2]|0;do if(a>>>0<w>>>0){x=b[a>>0]|0;y=x&255;z=a+1|0;if(x<<24>>24>0){A=z;B=y}else{if(z>>>0>=w>>>0){C=y;D=7;break}x=h[z>>0]|0;if(((x^128)&y)>>>0<=127){C=y;D=7;break}A=a+2|0;B=y+-128+(x<<7)|0}f[c>>2]=A;E=B;D=9}else{C=0;D=7}while(0);if((D|0)==7){D=0;a=ZYb(c,C)|0;if((a+-1|0)>>>0<16383){E=a;D=9}else F=a}b:do if((D|0)==9){D=0;switch(E>>>3&536870911|0){case 1:{if((E&255|0)!=8){F=E;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(w=b[a>>0]|0,w<<24>>24>-1):0){f[c>>2]=a+1;G=w<<24>>24!=0}else{LYb(e,c);w=e;if(!(b[k>>0]|0)){H=0;D=53;break a}else G=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0}b[j>>0]=G&1;continue a;break}case 2:{if((E&255|0)!=16){F=E;break b}f[i>>2]=f[i>>2]|2;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;I=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[m>>0]|0)){H=0;D=53;break a}else I=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=I&1;continue a;break}case 3:{if((E&255|0)!=24){F=E;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(w=b[a>>0]|0,w<<24>>24>-1):0){f[c>>2]=a+1;J=w<<24>>24!=0}else{LYb(e,c);w=e;if(!(b[o>>0]|0)){H=0;D=53;break a}else J=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0}b[n>>0]=J&1;continue a;break}case 7:{if((E&255|0)!=56){F=E;break b}f[i>>2]=f[i>>2]|8;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;K=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[q>>0]|0)){H=0;D=53;break a}else K=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[p>>0]=K&1;continue a;break}case 999:{if((E&255|0)!=58){F=E;break b}a=m7b(r)|0;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(x=b[w>>0]|0,x<<24>>24>-1):0){f[c>>2]=w+1;L=x&255}else{x=YYb(c)|0;if((x|0)>-1)L=x;else{H=0;D=53;break a}}JYb(e,c,L);if((f[s>>2]|0)<0){D=41;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){D=41;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{H=0;D=53;break a}break}default:{F=E;break b}}}while(0);if(!F){H=1;D=53;break}a=f[v>>2]|0;x=(a&1|0)==0;if(F>>>0>7999){if(x)M=lSa(v)|0;else M=a&-2;if(Fgc(t,F,c,538200,M)|0)continue;else{H=0;D=53;break}}else{if(x)N=lSa(v)|0;else N=a&-2;if(Lqc(c,F,N)|0)continue;else{H=0;D=53;break}}}if((D|0)==41){H=0;u=d;return H|0}else if((D|0)==53){u=d;return H|0}return 0}function n9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b)e=c;else{d=a+44|0;g=0;h=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=c;break}else h=c}}h=f[a+24>>2]|0;if(!(h&15)){j=e;k=a+28|0;f[k>>2]=j;return j|0}b=h&1|0?e+2|0:e;e=h&2|0?b+2|0:b;b=h&4|0?e+2|0:e;j=h&8|0?b+2|0:b;k=a+28|0;f[k>>2]=j;return j|0}function o9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)c$b(1,(b[a+48>>0]|0)!=0,c);if(d&2|0)c$b(2,(b[a+49>>0]|0)!=0,c);if(d&4|0)c$b(3,(b[a+50>>0]|0)!=0,c);if(d&8|0)c$b(7,(b[a+51>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{k$b(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Tsc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function p9b(a){a=a|0;return f[a+28>>2]|0}function q9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=b[a+48>>0]|0;b[d>>0]=8;b[d+1>>0]=h;g=d+2|0}if(!(e&2))i=g;else{d=b[a+49>>0]|0;b[g>>0]=16;b[g+1>>0]=d;i=g+2|0}if(!(e&4))j=i;else{g=b[a+50>>0]|0;b[i>>0]=24;b[i+1>>0]=g;j=i+2|0}if(!(e&8))k=j;else{e=b[a+51>>0]|0;b[j>>0]=56;b[j+1>>0]=e;k=j+2|0}j=f[a+36>>2]|0;if(!j)l=k;else{e=a+44|0;i=0;g=k;while(1){k=f[(f[e>>2]|0)+4+(i<<2)>>2]|0;b[g>>0]=-70;b[g+1>>0]=62;d=g+2|0;h=_i[f[(f[k>>2]|0)+60>>2]&2047](k)|0;if(h>>>0>127){m=h;n=d;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=d;r=h}b[q>>0]=r;n=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,q+1|0)|0;i=i+1|0;if((i|0)==(j|0)){l=n;break}else g=n}}g=Jgc(a+4|0,1e3,536870912,c,l)|0;l=f[a+20>>2]|0;if(!(l&1)){s=g;return s|0}s=Pqc(l&-2,g)|0;return s|0}function r9b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+48>>2]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,21128,0)|0;if(!d){Ooc(b,a);return}else{v9b(a,d);return}}function s9b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21128,0)|0;if(!c){Ooc(b,a);return}else{v9b(a,c);return}}function t9b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function u9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538984;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function v9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;Lsc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}k7b(a+32|0,c+32|0);e=f[c+24>>2]|0;if(!(e&15))return;if(e&1|0)b[a+48>>0]=b[c+48>>0]|0;if(e&2|0)b[a+49>>0]=b[c+49>>0]|0;if(e&4|0)b[a+50>>0]=b[c+50>>0]|0;if(e&8|0)b[a+51>>0]=b[c+51>>0]|0;c=a+24|0;f[c>>2]=f[c>>2]|e;return}function w9b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=169372;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538200?(f[223561]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=151;b[d+8>>0]=0;J_b(894244,d);a_b(d)}f[a+28>>2]=0;f[a+48>>2]=0;u=c;return}function x9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=169372;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223561]|0)==2){g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=151;b[e+8>>0]=0;J_b(894244,e);a_b(e);g=a+28|0;f[g>>2]=0;h=a+48|0;f[h>>2]=0;u=d;return}function y9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=169480;S9b(a);b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function z9b(a){a=a|0;y9b(a);cYc(a);return}function A9b(a){a=a|0;a=$Xc(96)|0;Q9b(a);return a|0}function B9b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(96)|0;Q9b(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21144,96);a=QXb(b,96)|0;R9b(a,b);c=a;return c|0}function C9b(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function D9b(a){a=a|0;return f[a+20>>2]|0}function E9b(a){a=a|0;var c=0,d=0,e=0,g=0;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;d=f[c>>2]|0;do if(d&255|0){do if(d&1|0?(g=f[a+48>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0?(e=f[a+52>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0?(g=f[a+56>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0?(e=f[a+60>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&16|0?(g=f[a+64>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&32|0?(e=f[a+68>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&64|0?(g=f[a+72>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&128|0?(e=f[a+76>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);if(d&65280|0){g=a+80|0;f[g>>2]=0;f[g+4>>2]=0}if(d&196608|0){b[a+88>>0]=0;f[a+92>>2]=1}f[c>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function F9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function G9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+24|0;j=a+48|0;k=a+20|0;l=a+52|0;m=a+92|0;n=a+81|0;o=e+8|0;p=a+56|0;q=a+84|0;r=e+8|0;s=a+85|0;t=e+8|0;v=a+86|0;w=e+8|0;x=a+82|0;y=e+8|0;z=a+88|0;A=e+8|0;B=a+83|0;C=e+8|0;D=a+80|0;E=e+8|0;F=a+60|0;G=a+64|0;H=a+68|0;I=a+72|0;K=a+76|0;L=a+87|0;M=e+8|0;N=a+32|0;O=e+4|0;P=a+4|0;a:while(1){a=f[c>>2]|0;Q=f[g>>2]|0;do if(a>>>0<Q>>>0){R=b[a>>0]|0;S=R&255;T=a+1|0;if(R<<24>>24>0){U=T;V=S}else{if(T>>>0>=Q>>>0){W=S;X=7;break}R=h[T>>0]|0;if(((R^128)&S)>>>0<=127){W=S;X=7;break}U=a+2|0;V=S+-128+(R<<7)|0}f[c>>2]=U;Y=V;X=9}else{W=0;X=7}while(0);if((X|0)==7){X=0;a=ZYb(c,W)|0;if((a+-1|0)>>>0<16383){Y=a;X=9}else Z=a}b:do if((X|0)==9){X=0;do switch(Y>>>3&536870911|0){case 1:{if((Y&255|0)!=10){Z=Y;break b}f[i>>2]=f[i>>2]|1;a=f[k>>2]|0;Q=a&-2;if(!(a&1))_=Q;else _=f[Q+4>>2]|0;Q=f[j>>2]|0;if((Q|0)==537368){xJa(j,_,537368);$=f[j>>2]|0}else $=Q;if(l$b(c,$)|0)continue a;else{aa=0;X=150;break a}break}case 8:{if((Y&255|0)!=66){Z=Y;break b}f[i>>2]=f[i>>2]|2;Q=f[k>>2]|0;a=Q&-2;if(!(Q&1))ba=a;else ba=f[a+4>>2]|0;a=f[l>>2]|0;if((a|0)==537368){xJa(l,ba,537368);ca=f[l>>2]|0}else ca=a;if(l$b(c,ca)|0)continue a;else{aa=0;X=150;break a}break}case 9:{if((Y&255|0)!=72){Z=Y;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){Q=b[a>>0]|0;R=Q&255;if(Q<<24>>24>-1){f[c>>2]=a+1;da=R}else{ea=R;X=28}}else{ea=0;X=28}if((X|0)==28){X=0;R=KYb(c,ea)|0;a=J;if((a|0)>-1|(a|0)==-1&R>>>0>4294967295)da=R;else{aa=0;X=150;break a}}if((da+-1|0)>>>0<3){f[i>>2]=f[i>>2]|131072;f[m>>2]=da;continue a}R=f[k>>2]|0;if(!(R&1))fa=lSa(k)|0;else fa=R&-2;yqc(fa,9,da,((da|0)<0)<<31>>31);continue a;break}case 10:{if((Y&255|0)!=80){Z=Y;break b}f[i>>2]=f[i>>2]|512;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;ga=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[o>>0]|0)){aa=0;X=150;break a}else ga=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[n>>0]=ga&1;continue a;break}case 11:{if((Y&255|0)!=90){Z=Y;break b}f[i>>2]=f[i>>2]|4;a=f[k>>2]|0;R=a&-2;if(!(a&1))ha=R;else ha=f[R+4>>2]|0;R=f[p>>2]|0;if((R|0)==537368){xJa(p,ha,537368);ia=f[p>>2]|0}else ia=R;if(l$b(c,ia)|0)continue a;else{aa=0;X=150;break a}break}case 16:{if((Y&255|0)!=128){Z=Y;break b}f[i>>2]=f[i>>2]|4096;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;ja=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[r>>0]|0)){aa=0;X=150;break a}else ja=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[q>>0]=ja&1;continue a;break}case 17:{if((Y&255|0)!=136){Z=Y;break b}f[i>>2]=f[i>>2]|8192;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;ka=R<<24>>24!=0}else{LYb(e,c);R=e;if(!(b[t>>0]|0)){aa=0;X=150;break a}else ka=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[s>>0]=ka&1;continue a;break}case 18:{if((Y&255|0)!=144){Z=Y;break b}f[i>>2]=f[i>>2]|16384;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;la=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[w>>0]|0)){aa=0;X=150;break a}else la=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[v>>0]=la&1;continue a;break}case 20:{if((Y&255|0)!=160){Z=Y;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;ma=R<<24>>24!=0}else{LYb(e,c);R=e;if(!(b[y>>0]|0)){aa=0;X=150;break a}else ma=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[x>>0]=ma&1;continue a;break}case 23:{if((Y&255|0)!=184){Z=Y;break b}f[i>>2]=f[i>>2]|65536;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;na=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[A>>0]|0)){aa=0;X=150;break a}else na=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[z>>0]=na&1;continue a;break}case 27:{if((Y&255|0)!=216){Z=Y;break b}f[i>>2]=f[i>>2]|2048;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;oa=R<<24>>24!=0}else{LYb(e,c);R=e;if(!(b[C>>0]|0)){aa=0;X=150;break a}else oa=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[B>>0]=oa&1;continue a;break}case 31:{if((Y&255|0)!=248){Z=Y;break b}f[i>>2]=f[i>>2]|256;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;pa=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[E>>0]|0)){aa=0;X=150;break a}else pa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[D>>0]=pa&1;continue a;break}case 36:{if((Y&255|0)!=34){Z=Y;break b}f[i>>2]=f[i>>2]|8;a=f[k>>2]|0;R=a&-2;if(!(a&1))qa=R;else qa=f[R+4>>2]|0;R=f[F>>2]|0;if((R|0)==537368){xJa(F,qa,537368);ra=f[F>>2]|0}else ra=R;if(l$b(c,ra)|0)continue a;else{aa=0;X=150;break a}break}case 37:{if((Y&255|0)!=42){Z=Y;break b}f[i>>2]=f[i>>2]|16;R=f[k>>2]|0;a=R&-2;if(!(R&1))sa=a;else sa=f[a+4>>2]|0;a=f[G>>2]|0;if((a|0)==537368){xJa(G,sa,537368);ta=f[G>>2]|0}else ta=a;if(l$b(c,ta)|0)continue a;else{aa=0;X=150;break a}break}case 39:{if((Y&255|0)!=58){Z=Y;break b}f[i>>2]=f[i>>2]|32;a=f[k>>2]|0;R=a&-2;if(!(a&1))ua=R;else ua=f[R+4>>2]|0;R=f[H>>2]|0;if((R|0)==537368){xJa(H,ua,537368);va=f[H>>2]|0}else va=R;if(l$b(c,va)|0)continue a;else{aa=0;X=150;break a}break}case 40:{if((Y&255|0)!=66){Z=Y;break b}f[i>>2]=f[i>>2]|64;R=f[k>>2]|0;a=R&-2;if(!(R&1))wa=a;else wa=f[a+4>>2]|0;a=f[I>>2]|0;if((a|0)==537368){xJa(I,wa,537368);xa=f[I>>2]|0}else xa=a;if(l$b(c,xa)|0)continue a;else{aa=0;X=150;break a}break}case 41:{if((Y&255|0)!=74){Z=Y;break b}f[i>>2]=f[i>>2]|128;a=f[k>>2]|0;R=a&-2;if(!(a&1))ya=R;else ya=f[R+4>>2]|0;R=f[K>>2]|0;if((R|0)==537368){xJa(K,ya,537368);za=f[K>>2]|0}else za=R;if(l$b(c,za)|0)continue a;else{aa=0;X=150;break a}break}case 42:{if((Y&255|0)!=80){Z=Y;break b}f[i>>2]=f[i>>2]|32768;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;Aa=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[M>>0]|0)){aa=0;X=150;break a}else Aa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[L>>0]=Aa&1;continue a;break}case 999:{if((Y&255|0)!=58){Z=Y;break b}a=m7b(N)|0;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(Q=b[R>>0]|0,Q<<24>>24>-1):0){f[c>>2]=R+1;Ba=Q&255}else{Q=YYb(c)|0;if((Q|0)>-1)Ba=Q;else{aa=0;X=150;break a}}JYb(e,c,Ba);if((f[O>>2]|0)<0){X=138;break a}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){X=138;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{aa=0;X=150;break a}break}default:{Z=Y;break b}}while(0)}while(0);if(!Z){aa=1;X=150;break}a=f[k>>2]|0;Q=(a&1|0)==0;if(Z>>>0>7999){if(Q)Ca=lSa(k)|0;else Ca=a&-2;if(Fgc(P,Z,c,538104,Ca)|0)continue;else{aa=0;X=150;break}}else{if(Q)Da=lSa(k)|0;else Da=a&-2;if(Lqc(c,Z,Da)|0)continue;else{aa=0;X=150;break}}}if((X|0)==138){aa=0;u=d;return aa|0}else if((X|0)==150){u=d;return aa|0}return 0}function H9b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=Vsc(a+4|0)|0;d=f[a+20>>2]|0;if(!(d&1))e=c;else e=(Rqc(d&-2)|0)+c|0;c=f[a+36>>2]|0;d=(c<<1)+e|0;if(!c)g=d;else{e=a+44|0;h=0;i=d;while(1){d=f[(f[e>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=d;break}else i=d}}i=f[a+24>>2]|0;if(i&255){if(!(i&1))k=g;else{c=f[a+48>>2]|0;h=b[c+11>>0]|0;e=h<<24>>24<0?f[c+4>>2]|0:h&255;k=g+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2))l=k;else{e=f[a+52>>2]|0;h=b[e+11>>0]|0;c=h<<24>>24<0?f[e+4>>2]|0:h&255;l=k+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&4))m=l;else{c=f[a+56>>2]|0;k=b[c+11>>0]|0;h=k<<24>>24<0?f[c+4>>2]|0:k&255;m=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&8))n=m;else{h=f[a+60>>2]|0;l=b[h+11>>0]|0;k=l<<24>>24<0?f[h+4>>2]|0:l&255;n=m+2+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&16))o=n;else{k=f[a+64>>2]|0;m=b[k+11>>0]|0;l=m<<24>>24<0?f[k+4>>2]|0:m&255;o=n+2+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&32))p=o;else{l=f[a+68>>2]|0;n=b[l+11>>0]|0;m=n<<24>>24<0?f[l+4>>2]|0:n&255;p=o+2+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&64))q=p;else{m=f[a+72>>2]|0;o=b[m+11>>0]|0;n=o<<24>>24<0?f[m+4>>2]|0:o&255;q=p+2+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&128))r=q;else{n=f[a+76>>2]|0;p=b[n+11>>0]|0;o=p<<24>>24<0?f[n+4>>2]|0:p&255;r=q+2+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}}else r=g;if(!(i&65280))s=r;else{g=i&256|0?r+3|0:r;r=i&512|0?g+2|0:g;g=i&1024|0?r+3|0:r;r=i&2048|0?g+3|0:g;g=i&4096|0?r+3|0:r;r=i&8192|0?g+3|0:g;g=i&16384|0?r+3|0:r;s=i&32768|0?g+3|0:g}if(!(i&196608)){t=s;u=a+28|0;f[u>>2]=t;return t|0}g=i&65536|0?s+3|0:s;if(!(i&131072)){t=g;u=a+28|0;f[u>>2]=t;return t|0}i=f[a+92>>2]|0;if((i|0)<0)v=11;else v=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;t=v+g|0;u=a+28|0;f[u>>2]=t;return t|0}function I9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+24>>2]|0;if(d&1|0)f$b(1,f[a+48>>2]|0,c);if(d&2|0)f$b(8,f[a+52>>2]|0,c);if(d&131072|0)d$b(9,f[a+92>>2]|0,c);if(d&512|0)c$b(10,(b[a+81>>0]|0)!=0,c);if(d&4|0)f$b(11,f[a+56>>2]|0,c);if(d&4096|0)c$b(16,(b[a+84>>0]|0)!=0,c);if(d&8192|0)c$b(17,(b[a+85>>0]|0)!=0,c);if(d&16384|0)c$b(18,(b[a+86>>0]|0)!=0,c);if(d&1024|0)c$b(20,(b[a+82>>0]|0)!=0,c);if(d&65536|0)c$b(23,(b[a+88>>0]|0)!=0,c);if(d&2048|0)c$b(27,(b[a+83>>0]|0)!=0,c);if(d&256|0)c$b(31,(b[a+80>>0]|0)!=0,c);if(d&8|0)f$b(36,f[a+60>>2]|0,c);if(d&16|0)f$b(37,f[a+64>>2]|0,c);if(d&32|0)f$b(39,f[a+68>>2]|0,c);if(d&64|0)f$b(40,f[a+72>>2]|0,c);if(d&128|0)f$b(41,f[a+76>>2]|0,c);if(d&32768|0)c$b(42,(b[a+87>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{k$b(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}Tsc(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function J9b(a){a=a|0;return f[a+28>>2]|0}function K9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;e=f[a+24>>2]|0;if(!(e&1))g=d;else{h=f[a+48>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+52>>2]|0;b[g>>0]=66;i=gZb(d,g+1|0)|0}if(!(e&131072))j=i;else{g=f[a+92>>2]|0;b[i>>0]=72;d=i+1|0;i=g&255;if(g>>>0>127){h=d;k=i;l=g;m=((g|0)<0)<<31>>31;while(1){b[h>>0]=k|-128;g=l;l=l1c(l|0,m|0,7)|0;n=h+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&g>>>0>16383)){p=n;q=o;break}else{h=n;k=o;m=J}}}else{p=d;q=i}b[p>>0]=q;j=p+1|0}if(!(e&512))r=j;else{p=b[a+81>>0]|0;b[j>>0]=80;b[j+1>>0]=p;r=j+2|0}if(!(e&4))s=r;else{j=f[a+56>>2]|0;b[r>>0]=90;s=gZb(j,r+1|0)|0}if(!(e&4096))t=s;else{r=b[a+84>>0]|0;b[s>>0]=-128;b[s+1>>0]=1;b[s+2>>0]=r;t=s+3|0}if(!(e&8192))u=t;else{s=b[a+85>>0]|0;b[t>>0]=-120;b[t+1>>0]=1;b[t+2>>0]=s;u=t+3|0}if(!(e&16384))v=u;else{t=b[a+86>>0]|0;b[u>>0]=-112;b[u+1>>0]=1;b[u+2>>0]=t;v=u+3|0}if(!(e&1024))w=v;else{u=b[a+82>>0]|0;b[v>>0]=-96;b[v+1>>0]=1;b[v+2>>0]=u;w=v+3|0}if(!(e&65536))x=w;else{v=b[a+88>>0]|0;b[w>>0]=-72;b[w+1>>0]=1;b[w+2>>0]=v;x=w+3|0}if(!(e&2048))y=x;else{w=b[a+83>>0]|0;b[x>>0]=-40;b[x+1>>0]=1;b[x+2>>0]=w;y=x+3|0}if(!(e&256))z=y;else{x=b[a+80>>0]|0;b[y>>0]=-8;b[y+1>>0]=1;b[y+2>>0]=x;z=y+3|0}if(!(e&8))A=z;else{y=f[a+60>>2]|0;b[z>>0]=-94;b[z+1>>0]=2;A=gZb(y,z+2|0)|0}if(!(e&16))B=A;else{z=f[a+64>>2]|0;b[A>>0]=-86;b[A+1>>0]=2;B=gZb(z,A+2|0)|0}if(!(e&32))C=B;else{A=f[a+68>>2]|0;b[B>>0]=-70;b[B+1>>0]=2;C=gZb(A,B+2|0)|0}if(!(e&64))D=C;else{B=f[a+72>>2]|0;b[C>>0]=-62;b[C+1>>0]=2;D=gZb(B,C+2|0)|0}if(!(e&128))E=D;else{C=f[a+76>>2]|0;b[D>>0]=-54;b[D+1>>0]=2;E=gZb(C,D+2|0)|0}if(!(e&32768))F=E;else{e=b[a+87>>0]|0;b[E>>0]=-48;b[E+1>>0]=2;b[E+2>>0]=e;F=E+3|0}E=f[a+36>>2]|0;if(!E)G=F;else{e=a+44|0;D=0;C=F;while(1){F=f[(f[e>>2]|0)+4+(D<<2)>>2]|0;b[C>>0]=-70;b[C+1>>0]=62;B=C+2|0;A=_i[f[(f[F>>2]|0)+60>>2]&2047](F)|0;if(A>>>0>127){z=A;y=B;while(1){b[y>>0]=z|128;x=z>>>7;w=y+1|0;if(z>>>0>16383){z=x;y=w}else{H=w;I=x;break}}}else{H=B;I=A}b[H>>0]=I;y=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,H+1|0)|0;D=D+1|0;if((D|0)==(E|0)){G=y;break}else C=y}}C=Jgc(a+4|0,1e3,536870912,c,G)|0;G=f[a+20>>2]|0;if(!(G&1)){K=C;return K|0}K=Pqc(G&-2,C)|0;return K|0}function L9b(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;E9b(a);c=kZc(b,21568,21144,0)|0;if(!c){Ooc(b,a);return}else{P9b(a,c);return}}function M9b(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21144,0)|0;if(!c){Ooc(b,a);return}else{P9b(a,c);return}}function N9b(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function O9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538976;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function P9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;Lsc(a+4|0,c+4|0);d=a+20|0;e=f[c+20>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}k7b(a+32|0,c+32|0);e=f[c+24>>2]|0;do if(e&255|0){do if(e&1|0){h=f[c+48>>2]|0;g=a+24|0;f[g>>2]=f[g>>2]|1;g=a+48|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==537368){xJa(g,k,h);break}else{oYc(j,h)|0;break}}while(0);do if(e&2|0){h=f[c+52>>2]|0;j=a+24|0;f[j>>2]=f[j>>2]|2;j=a+52|0;g=f[d>>2]|0;i=g&-2;if(!(g&1))l=i;else l=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==537368){xJa(j,l,h);break}else{oYc(i,h)|0;break}}while(0);do if(e&4|0){h=f[c+56>>2]|0;i=a+24|0;f[i>>2]=f[i>>2]|4;i=a+56|0;j=f[d>>2]|0;g=j&-2;if(!(j&1))m=g;else m=f[g+4>>2]|0;g=f[i>>2]|0;if((g|0)==537368){xJa(i,m,h);break}else{oYc(g,h)|0;break}}while(0);do if(e&8|0){h=f[c+60>>2]|0;g=a+24|0;f[g>>2]=f[g>>2]|8;g=a+60|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))n=j;else n=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==537368){xJa(g,n,h);break}else{oYc(j,h)|0;break}}while(0);do if(e&16|0){h=f[c+64>>2]|0;j=a+24|0;f[j>>2]=f[j>>2]|16;j=a+64|0;g=f[d>>2]|0;i=g&-2;if(!(g&1))o=i;else o=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==537368){xJa(j,o,h);break}else{oYc(i,h)|0;break}}while(0);do if(e&32|0){h=f[c+68>>2]|0;i=a+24|0;f[i>>2]=f[i>>2]|32;i=a+68|0;j=f[d>>2]|0;g=j&-2;if(!(j&1))p=g;else p=f[g+4>>2]|0;g=f[i>>2]|0;if((g|0)==537368){xJa(i,p,h);break}else{oYc(g,h)|0;break}}while(0);do if(e&64|0){h=f[c+72>>2]|0;g=a+24|0;f[g>>2]=f[g>>2]|64;g=a+72|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))q=j;else q=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==537368){xJa(g,q,h);break}else{oYc(j,h)|0;break}}while(0);if(e&128|0){h=f[c+76>>2]|0;j=a+24|0;f[j>>2]=f[j>>2]|128;j=a+76|0;g=f[d>>2]|0;i=g&-2;if(!(g&1))r=i;else r=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==537368){xJa(j,r,h);break}else{oYc(i,h)|0;break}}}while(0);if(e&65280|0){if(e&256|0)b[a+80>>0]=b[c+80>>0]|0;if(e&512|0)b[a+81>>0]=b[c+81>>0]|0;if(e&1024|0)b[a+82>>0]=b[c+82>>0]|0;if(e&2048|0)b[a+83>>0]=b[c+83>>0]|0;if(e&4096|0)b[a+84>>0]=b[c+84>>0]|0;if(e&8192|0)b[a+85>>0]=b[c+85>>0]|0;if(e&16384|0)b[a+86>>0]=b[c+86>>0]|0;if(e&32768|0)b[a+87>>0]=b[c+87>>0]|0;r=a+24|0;f[r>>2]=f[r>>2]|e}if(!(e&196608))return;if(e&65536|0)b[a+88>>0]=b[c+88>>0]|0;if(e&131072|0)f[a+92>>2]=f[c+92>>2];c=a+24|0;f[c>>2]=f[c>>2]|e;return}function Q9b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=169480;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538104?(f[223560]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=150;b[d+8>>0]=0;J_b(894240,d);a_b(d)}f[a+28>>2]=0;f[a+48>>2]=537368;f[a+52>>2]=537368;f[a+56>>2]=537368;f[a+60>>2]=537368;f[a+64>>2]=537368;f[a+68>>2]=537368;f[a+72>>2]=537368;f[a+76>>2]=537368;d=a+80|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+92>>2]=1;u=c;return}function R9b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=169480;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223560]|0)!=2){f[e>>2]=165456;f[e+4>>2]=150;b[e+8>>0]=0;J_b(894240,e);a_b(e)}f[a+28>>2]=0;f[a+48>>2]=537368;f[a+52>>2]=537368;f[a+56>>2]=537368;f[a+60>>2]=537368;f[a+64>>2]=537368;f[a+68>>2]=537368;f[a+72>>2]=537368;f[a+76>>2]=537368;e=a+80|0;f[e>>2]=0;f[e+4>>2]=0;b[e+8>>0]=0;f[a+92>>2]=1;u=d;return}function S9b(a){a=a|0;var c=0;c=f[a+48>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+52>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+56>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+60>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+64>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+68>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+72>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+76>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function T9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function U9b(a){a=a|0;var b=0,c=0;f[a>>2]=169588;nac(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function V9b(a){a=a|0;U9b(a);cYc(a);return}function W9b(a){a=a|0;a=$Xc(36)|0;lac(a);return a|0}function X9b(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(36)|0;lac(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21160,40);a=QXb(b,40)|0;mac(a,b);c=a;return c|0}function Y9b(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function Z9b(a){a=a|0;return f[a+4>>2]|0}function _9b(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;e=f[c>>2]|0;if(e&15|0){do if(e&1|0?(g=f[a+16>>2]|0,(g|0)!=537368):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);do if(e&2|0?(h=f[a+20>>2]|0,(h|0)!=537368):0){g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);do if(e&4|0?(g=f[a+24>>2]|0,(g|0)!=537368):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&8|0){e=f[a+28>>2]|0;Ksc(e+4|0);h=e+36|0;g=f[h>>2]|0;if((g|0)>0){i=f[e+44>>2]|0;j=0;do{i6b(f[i+4+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=(g|0));f[h>>2]=0}h=e+24|0;if(f[h>>2]&3|0){g=e+48|0;f[g>>2]=0;f[g+4>>2]=0}f[h>>2]=0;h=f[e+20>>2]|0;if(h&1|0?(e=h&-2,f[e>>2]|0):0)sqc(e)}}d[a+32>>1]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function $9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(f[a+8>>2]&8)){b=1;return b|0}c=f[a+28>>2]|0;if(!(Psc(c+4|0)|0)){b=0;return b|0}a=f[c+36>>2]|0;if((a|0)<=0){b=1;return b|0}d=f[c+44>>2]|0;c=a;a:while(1){a=c;c=c+-1|0;e=f[d+4+(c<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=9;break a}}if((a|0)<=1){b=1;i=9;break}}if((i|0)==9)return b|0;return 0}function aac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=a+24|0;m=a+28|0;n=e+4|0;o=a+32|0;p=e+8|0;q=a+33|0;r=e+8|0;a:while(1){s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){t=b[s>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=s+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=ZYb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=10){z=w;break b}f[h>>2]=f[h>>2]|1;v=f[j>>2]|0;s=v&-2;if(!(v&1))A=s;else A=f[s+4>>2]|0;s=f[i>>2]|0;if((s|0)==537368){xJa(i,A,537368);B=f[i>>2]|0}else B=s;if(l$b(c,B)|0)continue a;else{C=0;x=56;break a}break}case 2:{if((w&255|0)!=18){z=w;break b}f[h>>2]=f[h>>2]|2;s=f[j>>2]|0;v=s&-2;if(!(s&1))D=v;else D=f[v+4>>2]|0;v=f[k>>2]|0;if((v|0)==537368){xJa(k,D,537368);E=f[k>>2]|0}else E=v;if(l$b(c,E)|0)continue a;else{C=0;x=56;break a}break}case 3:{if((w&255|0)!=26){z=w;break b}f[h>>2]=f[h>>2]|4;v=f[j>>2]|0;s=v&-2;if(!(v&1))F=s;else F=f[s+4>>2]|0;s=f[l>>2]|0;if((s|0)==537368){xJa(l,F,537368);G=f[l>>2]|0}else G=s;if(l$b(c,G)|0)continue a;else{C=0;x=56;break a}break}case 4:{if((w&255|0)!=34){z=w;break b}f[h>>2]=f[h>>2]|8;s=f[m>>2]|0;if(!s){kac(a);H=f[m>>2]|0}else H=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;I=v&255}else{v=YYb(c)|0;if((v|0)>-1)I=v;else{C=0;x=56;break a}}JYb(e,c,I);if((f[n>>2]|0)<0){x=37;break a}if(!(Mi[f[(f[H>>2]|0)+44>>2]&1023](H,c)|0)){x=37;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{C=0;x=56;break a}break}case 5:{if((w&255|0)!=40){z=w;break b}f[h>>2]=f[h>>2]|16;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(s=b[v>>0]|0,s<<24>>24>-1):0){f[c>>2]=v+1;J=s<<24>>24!=0}else{LYb(e,c);s=e;if(!(b[p>>0]|0)){C=0;x=56;break a}else J=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0}b[o>>0]=J&1;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}f[h>>2]=f[h>>2]|32;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;K=v<<24>>24!=0}else{LYb(e,c);v=e;if(!(b[r>>0]|0)){C=0;x=56;break a}else K=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[q>>0]=K&1;continue a;break}default:{z=w;break b}}}while(0);if(!z){C=1;x=56;break}v=f[j>>2]|0;if(!(v&1))L=lSa(j)|0;else L=v&-2;if(!(Lqc(c,z,L)|0)){C=0;x=56;break}}if((x|0)==37){C=0;u=d;return C|0}else if((x|0)==56){u=d;return C|0}return 0}function bac(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=a+8|0;e=f[c>>2]|0;if(!(e&63)){g=d;h=a+12|0;f[h>>2]=g;return g|0}if(!(e&1))i=d;else{j=f[a+16>>2]|0;k=b[j+11>>0]|0;l=k<<24>>24<0?f[j+4>>2]|0:k&255;i=d+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&2))m=i;else{l=f[a+20>>2]|0;d=b[l+11>>0]|0;k=d<<24>>24<0?f[l+4>>2]|0:d&255;m=i+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&4))n=m;else{k=f[a+24>>2]|0;i=b[k+11>>0]|0;d=i<<24>>24<0?f[k+4>>2]|0:i&255;n=m+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&8)){o=n;p=e}else{e=f[a+28>>2]|0;d=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=n+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;o=e;p=f[c>>2]|0}c=p&16|0?o+2|0:o;g=p&32|0?c+2|0:c;h=a+12|0;f[h>>2]=g;return g|0}function cac(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+16>>2]|0,c);if(d&2|0)f$b(2,f[a+20>>2]|0,c);if(d&4|0)f$b(3,f[a+24>>2]|0,c);if(d&8|0)k$b(4,f[a+28>>2]|0,c);if(d&16|0)c$b(5,(b[a+32>>0]|0)!=0,c);if(d&32|0)c$b(6,(b[a+33>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function dac(a){a=a|0;return f[a+12>>2]|0}function eac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+20>>2]|0;b[g>>0]=18;i=gZb(d,g+1|0)|0}if(!(e&4))j=i;else{g=f[a+24>>2]|0;b[i>>0]=26;j=gZb(g,i+1|0)|0}if(!(e&8))k=j;else{i=f[a+28>>2]|0;b[j>>0]=34;g=j+1|0;j=_i[f[(f[i>>2]|0)+60>>2]&2047](i)|0;if(j>>>0>127){d=j;h=g;while(1){b[h>>0]=d|128;l=d>>>7;m=h+1|0;if(d>>>0>16383){d=l;h=m}else{n=m;o=l;break}}}else{n=g;o=j}b[n>>0]=o;k=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,n+1|0)|0}if(!(e&16))p=k;else{n=b[a+32>>0]|0;b[k>>0]=40;b[k+1>>0]=n;p=k+2|0}if(!(e&32))q=p;else{e=b[a+33>>0]|0;b[p>>0]=48;b[p+1>>0]=e;q=p+2|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Pqc(p&-2,q)|0;return r|0}function fac(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;_9b(a);c=kZc(b,21568,21160,0)|0;if(!c){Ooc(b,a);return}else{jac(a,c);return}}function gac(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21160,0)|0;if(!c){Ooc(b,a);return}else{jac(a,c);return}}function hac(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function iac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538968;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function jac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&63))return;do if(e&1|0){h=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==537368){xJa(g,k,h);break}else{oYc(j,h)|0;break}}while(0);do if(e&2|0){k=f[c+20>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|2;h=a+20|0;j=f[d>>2]|0;g=j&-2;if(!(j&1))l=g;else l=f[g+4>>2]|0;g=f[h>>2]|0;if((g|0)==537368){xJa(h,l,k);break}else{oYc(g,k)|0;break}}while(0);do if(e&4|0){l=f[c+24>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|4;k=a+24|0;g=f[d>>2]|0;h=g&-2;if(!(g&1))m=h;else m=f[h+4>>2]|0;h=f[k>>2]|0;if((h|0)==537368){xJa(k,m,l);break}else{oYc(h,l)|0;break}}while(0);if(e&8|0){m=a+8|0;f[m>>2]=f[m>>2]|8;m=a+28|0;d=f[m>>2]|0;if(!d){kac(a);n=f[m>>2]|0}else n=d;d=f[c+28>>2]|0;j7b(n,d|0?d:538536)}if(e&16|0)b[a+32>>0]=b[c+32>>0]|0;if(e&32|0)b[a+33>>0]=b[c+33>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function kac(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(56)|0;n7b(c);e=c;g=a+28|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21032,56);c=QXb(d,56)|0;o7b(c,d);e=c;g=a+28|0;f[g>>2]=e;return}function lac(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=169588;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=538064?(f[223559]|0)!=2:0){f[e>>2]=165456;f[e+4>>2]=149;b[e+8>>0]=0;J_b(894236,e);a_b(e)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;e=a+28|0;f[e>>2]=0;d[e+4>>1]=0;u=c;return}function mac(a,c){a=a|0;c=c|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[a>>2]=169588;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223559]|0)!=2){f[g>>2]=165456;f[g+4>>2]=149;b[g+8>>0]=0;J_b(894236,g);a_b(g)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;g=a+28|0;f[g>>2]=0;d[g+4>>1]=0;u=e;return}function nac(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==538064)return;c=f[a+28>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function oac(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=169696;c=f[a+32>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=538024?(c=f[a+36>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[c>>2]=0;return}function pac(a){a=a|0;oac(a);cYc(a);return}function qac(a){a=a|0;a=$Xc(40)|0;Jac(a);return a|0}function rac(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(40)|0;Jac(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21176,40);a=QXb(b,40)|0;Kac(a,b);c=a;return c|0}function sac(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function tac(a){a=a|0;return f[a+4>>2]|0}function uac(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{_9b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(g=f[a+32>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&2|0){d=f[a+36>>2]|0;Ksc(d+4|0);e=d+36|0;g=f[e>>2]|0;if((g|0)>0){h=f[d+44>>2]|0;i=0;do{i6b(f[h+4+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0));f[e>>2]=0}b[d+48>>0]=0;f[d+24>>2]=0;e=f[d+20>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function vac(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+20>>2]|0;a:do if((b|0)>0){c=a+28|0;d=b;b:while(1){e=d;d=d+-1|0;g=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(f[g+8>>2]&8|0){h=f[g+28>>2]|0;if(!(Psc(h+4|0)|0)){i=0;j=20;break}g=f[h+36>>2]|0;if((g|0)>0){k=f[h+44>>2]|0;h=g;do{g=h;h=h+-1|0;l=f[k+4+(h<<2)>>2]|0;m=f[l+28>>2]|0;n=f[l+20>>2]|0;while(1){if((n|0)<=0)break;n=n+-1|0;if((f[(f[m+4+(n<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=20;break b}}}while((g|0)>1)}}if((e|0)<=1)break a}if((j|0)==20)return i|0}while(0);if(!(f[a+8>>2]&2)){i=1;return i|0}b=f[a+36>>2]|0;if(!(Psc(b+4|0)|0)){i=0;return i|0}a=f[b+36>>2]|0;if((a|0)<=0){i=1;return i|0}d=f[b+44>>2]|0;b=a;c:while(1){a=b;b=b+-1|0;c=f[d+4+(b<<2)>>2]|0;h=f[c+28>>2]|0;k=f[c+20>>2]|0;while(1){if((k|0)<=0)break;k=k+-1|0;if((f[(f[h+4+(k<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=20;break c}}if((a|0)<=1){i=1;j=20;break}}if((j|0)==20)return i|0;return 0}function wac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+32|0;j=a+4|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=e+4|0;p=a+36|0;q=e+4|0;a:while(1){r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=r+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=ZYb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}f[h>>2]=f[h>>2]|1;t=f[j>>2]|0;r=t&-2;if(!(t&1))z=r;else z=f[r+4>>2]|0;r=f[i>>2]|0;if((r|0)==537368){xJa(i,z,537368);A=f[i>>2]|0}else A=r;if(l$b(c,A)|0)continue a;else{B=0;w=51;break a}break}case 2:{if((v&255|0)!=18){y=v;break b}r=f[l>>2]|0;do if(r){t=f[n>>2]|0;s=f[r>>2]|0;if((t|0)>=(s|0))if((s|0)==(f[m>>2]|0)){C=s;w=20;break}else{D=s;E=r;w=21;break}else{f[n>>2]=t+1;F=f[r+4+(t<<2)>>2]|0;break}}else{C=f[m>>2]|0;w=20}while(0);if((w|0)==20){w=0;XZb(k,C+1|0);r=f[l>>2]|0;D=f[r>>2]|0;E=r;w=21}if((w|0)==21){w=0;f[E>>2]=D+1;r=f[k>>2]|0;if(!r){t=$Xc(36)|0;lac(t);G=t}else{if(f[r+64>>2]|0)SXb(r,21160,40);t=QXb(r,40)|0;mac(t,r);G=t}t=f[l>>2]|0;r=f[n>>2]|0;f[n>>2]=r+1;f[t+4+(r<<2)>>2]=G;F=G}r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(t=b[r>>0]|0,t<<24>>24>-1):0){f[c>>2]=r+1;H=t&255}else{t=YYb(c)|0;if((t|0)>-1)H=t;else{B=0;w=51;break a}}JYb(e,c,H);if((f[o>>2]|0)<0){w=33;break a}if(!(Mi[f[(f[F>>2]|0)+44>>2]&1023](F,c)|0)){w=33;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;w=51;break a}break}case 3:{if((v&255|0)!=26){y=v;break b}f[h>>2]=f[h>>2]|2;t=f[p>>2]|0;if(!t){Hac(a);I=f[p>>2]|0}else I=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(r=b[t>>0]|0,r<<24>>24>-1):0){f[c>>2]=t+1;J=r&255}else{r=YYb(c)|0;if((r|0)>-1)J=r;else{B=0;w=51;break a}}JYb(e,c,J);if((f[q>>2]|0)<0){w=44;break a}if(!(Mi[f[(f[I>>2]|0)+44>>2]&1023](I,c)|0)){w=44;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;w=51;break a}break}default:{y=v;break b}}}while(0);if(!y){B=1;w=51;break}r=f[j>>2]|0;if(!(r&1))K=lSa(j)|0;else K=r&-2;if(!(Lqc(c,y,K)|0)){B=0;w=51;break}}if((w|0)==33){B=0;u=d;return B|0}else if((w|0)==44){B=0;u=d;return B|0}else if((w|0)==51){u=d;return B|0}return 0}function xac(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+8>>2]|0;if(!(i&3)){k=g;l=a+12|0;f[l>>2]=k;return k|0}if(!(i&1))m=g;else{c=f[a+32>>2]|0;h=b[c+11>>0]|0;d=h<<24>>24<0?f[c+4>>2]|0:h&255;m=g+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2)){k=m;l=a+12|0;f[l>>2]=k;return k|0}i=f[a+36>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;k=m+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=a+12|0;f[l>>2]=k;return k|0}function yac(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+32>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{k$b(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)k$b(3,f[a+36>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function zac(a){a=a|0;return f[a+12>>2]|0}function Aac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+32>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&2047](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}if(!(e&2))t=i;else{e=f[a+36>>2]|0;b[i>>0]=26;k=i+1|0;i=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(i>>>0>127){d=i;j=k;while(1){b[j>>0]=d|128;r=d>>>7;s=j+1|0;if(d>>>0>16383){d=r;j=s}else{u=s;v=r;break}}}else{u=k;v=i}b[u>>0]=v;t=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,u+1|0)|0}u=f[a+4>>2]|0;if(!(u&1)){w=t;return w|0}w=Pqc(u&-2,t)|0;return w|0}function Bac(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;uac(a);c=kZc(b,21568,21176,0)|0;if(!c){Ooc(b,a);return}else{Fac(a,c);return}}function Cac(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21176,0)|0;if(!c){Ooc(b,a);return}else{Fac(a,c);return}}function Dac(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Eac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538960;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Fac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}Gac(a+16|0,c+16|0);e=f[c+8>>2]|0;if(!(e&3))return;do if(e&1|0){h=f[c+32>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+32|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==537368){xJa(g,k,h);break}else{oYc(j,h)|0;break}}while(0);if(!(e&2))return;e=a+8|0;f[e>>2]=f[e>>2]|2;e=a+36|0;k=f[e>>2]|0;if(!k){Hac(a);l=f[e>>2]|0}else l=k;k=f[c+36>>2]|0;c=k|0?k:538480;Lsc(l+4|0,c+4|0);k=l+20|0;e=f[c+20>>2]|0;if(e&1|0){a=f[k>>2]|0;if(!(a&1))m=lSa(k)|0;else m=a&-2;vqc(m,e&-2)}k7b(l+32|0,c+32|0);if(!(f[c+24>>2]&1))return;e=b[c+48>>0]|0;c=l+24|0;f[c>>2]=f[c>>2]|1;b[l+48>>0]=e;return}function Gac(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Iac(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(36)|0;lac(l);Iac(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21160,40);l=QXb(i,40)|0;mac(l,i);Iac(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Hac(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(52)|0;G7b(c);e=c;g=a+36|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21048,56);c=QXb(d,56)|0;H7b(c,d);e=c;g=a+36|0;f[g>>2]=e;return}function Iac(a,b){a=a|0;b=b|0;jac(b,a);return}function Jac(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=169696;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=538024?(f[223558]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=148;b[d+8>>0]=0;J_b(894232,d);a_b(d)}f[a+12>>2]=0;f[a+32>>2]=537368;f[a+36>>2]=0;u=c;return}function Kac(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=169696;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[223558]|0)!=2){f[e>>2]=165456;f[e+4>>2]=148;b[e+8>>0]=0;J_b(894232,e);a_b(e)}f[a+12>>2]=0;f[a+32>>2]=537368;f[a+36>>2]=0;u=d;return}function Lac(a){a=a|0;var c=0,d=0;f[a>>2]=169804;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=537992?(c=f[a+20>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function Mac(a){a=a|0;Lac(a);cYc(a);return}function Nac(a){a=a|0;a=$Xc(28)|0;cbc(a);return a|0}function Oac(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(28)|0;cbc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21192,32);a=QXb(b,32)|0;dbc(a,b);c=a;return c|0}function Pac(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function Qac(a){a=a|0;return f[a+4>>2]|0}function Rac(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){d=f[a+20>>2]|0;Ksc(d+4|0);g=d+36|0;e=f[g>>2]|0;if((e|0)>0){h=f[d+44>>2]|0;i=0;do{i6b(f[h+4+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(e|0));f[g>>2]=0}b[d+48>>0]=0;f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)sqc(d)}}f[a+24>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Sac(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(f[a+8>>2]&2)){b=1;return b|0}c=f[a+20>>2]|0;if(!(Psc(c+4|0)|0)){b=0;return b|0}a=f[c+36>>2]|0;if((a|0)<=0){b=1;return b|0}d=f[c+44>>2]|0;c=a;a:while(1){a=c;c=c+-1|0;e=f[d+4+(c<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=9;break a}}if((a|0)<=1){b=1;i=9;break}}if((i|0)==9)return b|0;return 0}function Tac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+24|0;l=a+20|0;m=e+4|0;a:while(1){n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=n+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=ZYb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=10){t=q;break b}f[h>>2]=f[h>>2]|1;p=f[j>>2]|0;n=p&-2;if(!(p&1))v=n;else v=f[n+4>>2]|0;n=f[i>>2]|0;if((n|0)==537368){xJa(i,v,537368);w=f[i>>2]|0}else w=n;if(l$b(c,w)|0)continue a;else{x=0;r=36;break a}break}case 2:{if((q&255|0)!=16){t=q;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){p=b[n>>0]|0;o=p&255;if(p<<24>>24>-1){f[c>>2]=n+1;y=o}else{z=o;r=18}}else{z=0;r=18}if((r|0)==18){r=0;o=KYb(c,z)|0;n=J;if((n|0)>-1|(n|0)==-1&o>>>0>4294967295)y=o;else{x=0;r=36;break a}}f[k>>2]=y;continue a;break}case 3:{if((q&255|0)!=26){t=q;break b}f[h>>2]=f[h>>2]|2;o=f[l>>2]|0;if(!o){bbc(a);A=f[l>>2]|0}else A=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(n=b[o>>0]|0,n<<24>>24>-1):0){f[c>>2]=o+1;B=n&255}else{n=YYb(c)|0;if((n|0)>-1)B=n;else{x=0;r=36;break a}}JYb(e,c,B);if((f[m>>2]|0)<0){r=29;break a}if(!(Mi[f[(f[A>>2]|0)+44>>2]&1023](A,c)|0)){r=29;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{x=0;r=36;break a}break}default:{t=q;break b}}}while(0);if(!t){x=1;r=36;break}n=f[j>>2]|0;if(!(n&1))C=lSa(j)|0;else C=n&-2;if(!(Lqc(c,t,C)|0)){x=0;r=36;break}}if((r|0)==29){x=0;u=d;return x|0}else if((r|0)==36){u=d;return x|0}return 0}function Uac(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=a+8|0;e=f[c>>2]|0;if(!(e&7)){g=d;h=a+12|0;f[h>>2]=g;return g|0}if(!(e&1))i=d;else{j=f[a+16>>2]|0;k=b[j+11>>0]|0;l=k<<24>>24<0?f[j+4>>2]|0:k&255;i=d+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&2)){m=i;n=e}else{e=f[a+20>>2]|0;l=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=i+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;m=e;n=f[c>>2]|0}if(!(n&4)){g=m;h=a+12|0;f[h>>2]=g;return g|0}n=f[a+24>>2]|0;if((n|0)<0)o=11;else o=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=o+m|0;h=a+12|0;f[h>>2]=g;return g|0}function Vac(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&4|0)S_b(2,f[a+24>>2]|0,b);if(c&2|0)k$b(3,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Wac(a){a=a|0;return f[a+12>>2]|0}function Xac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&4))i=g;else{d=f[a+24>>2]|0;b[g>>0]=16;h=g+1|0;g=d&255;if(d>>>0>127){j=h;k=g;l=d;m=((d|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;d=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&d>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=h;q=g}b[p>>0]=q;i=p+1|0}if(!(e&2))r=i;else{e=f[a+20>>2]|0;b[i>>0]=26;p=i+1|0;i=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(i>>>0>127){q=i;g=p;while(1){b[g>>0]=q|128;h=q>>>7;m=g+1|0;if(q>>>0>16383){q=h;g=m}else{s=m;t=h;break}}}else{s=p;t=i}b[s>>0]=t;r=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,s+1|0)|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Pqc(s&-2,r)|0;return u|0}function Yac(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Rac(a);c=kZc(b,21568,21192,0)|0;if(!c){Ooc(b,a);return}else{abc(a,c);return}}function Zac(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21192,0)|0;if(!c){Ooc(b,a);return}else{abc(a,c);return}}function _ac(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function $ac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538952;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function abc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&7))return;do if(e&1|0){h=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[g>>2]|0;if((j|0)==537368){xJa(g,k,h);break}else{oYc(j,h)|0;break}}while(0);if(e&2|0){k=a+8|0;f[k>>2]=f[k>>2]|2;k=a+20|0;d=f[k>>2]|0;if(!d){bbc(a);l=f[k>>2]|0}else l=d;d=f[c+20>>2]|0;k=d|0?d:538424;Lsc(l+4|0,k+4|0);d=l+20|0;h=f[k+20>>2]|0;if(h&1|0){j=f[d>>2]|0;if(!(j&1))m=lSa(d)|0;else m=j&-2;vqc(m,h&-2)}k7b(l+32|0,k+32|0);if(f[k+24>>2]&1|0){h=b[k+48>>0]|0;k=l+24|0;f[k>>2]=f[k>>2]|1;b[l+48>>0]=h}}if(e&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function bbc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(52)|0;Z7b(c);e=c;g=a+20|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21064,56);c=QXb(d,56)|0;_7b(c,d);e=c;g=a+20|0;f[g>>2]=e;return}function cbc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=169804;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=537992?(f[223557]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=147;b[d+8>>0]=0;J_b(894228,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function dbc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=169804;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223557]|0)!=2){f[e>>2]=165456;f[e+4>>2]=147;b[e+8>>0]=0;J_b(894228,e);a_b(e)}f[a+12>>2]=0;f[a+16>>2]=537368;e=a+20|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function ebc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=169912;c=f[a+64>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=537920?(c=f[a+68>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+44|0;i=f[c>>2]|0;if(i|0?(f[a+32>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+28|0;j=f[c>>2]|0;if(j|0?(f[a+16>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(k);f[c>>2]=0;return}function fbc(a){a=a|0;ebc(a);cYc(a);return}function gbc(a){a=a|0;a=$Xc(72)|0;Ubc(a);return a|0}function hbc(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(72)|0;Ubc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21208,72);a=QXb(b,72)|0;Vbc(a,b);c=a;return c|0}function ibc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function jbc(a){a=a|0;return f[a+4>>2]|0}function kbc(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+20|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{Rac(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[c>>2]=0}c=a+36|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+44>>2]|0;g=0;do{i=f[h+4+(g<<2)>>2]|0;g=g+1|0;j=i+8|0;if(f[j>>2]&3|0){k=i+16|0;f[k>>2]=0;f[k+4>>2]=0}f[j>>2]=0;j=f[i+4>>2]|0;if(j&1|0?(i=j&-2,f[i>>2]|0):0)sqc(i)}while((g|0)!=(e|0));f[c>>2]=0}c=a+52|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+60>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((h|0)!=(e|0));f[c>>2]=0}c=a+8|0;e=f[c>>2]|0;if(e&3|0){do if(e&1|0?(h=f[a+64>>2]|0,(h|0)!=537368):0){g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);if(e&2|0){e=f[a+68>>2]|0;Ksc(e+4|0);g=e+36|0;h=f[g>>2]|0;if((h|0)>0){j=f[e+44>>2]|0;i=0;do{i6b(f[j+4+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(h|0));f[g>>2]=0}d[e+48>>1]=0;f[e+24>>2]=0;g=f[e+20>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function lbc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+20>>2]|0;a:do if((b|0)>0){c=a+28|0;d=b;b:while(1){e=d;d=d+-1|0;g=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(f[g+8>>2]&2|0){h=f[g+20>>2]|0;if(!(Psc(h+4|0)|0)){i=0;j=20;break}g=f[h+36>>2]|0;if((g|0)>0){k=f[h+44>>2]|0;h=g;do{g=h;h=h+-1|0;l=f[k+4+(h<<2)>>2]|0;m=f[l+28>>2]|0;n=f[l+20>>2]|0;while(1){if((n|0)<=0)break;n=n+-1|0;if((f[(f[m+4+(n<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=20;break b}}}while((g|0)>1)}}if((e|0)<=1)break a}if((j|0)==20)return i|0}while(0);if(!(f[a+8>>2]&2)){i=1;return i|0}b=f[a+68>>2]|0;if(!(Psc(b+4|0)|0)){i=0;return i|0}a=f[b+36>>2]|0;if((a|0)<=0){i=1;return i|0}d=f[b+44>>2]|0;b=a;c:while(1){a=b;b=b+-1|0;c=f[d+4+(b<<2)>>2]|0;h=f[c+28>>2]|0;k=f[c+20>>2]|0;while(1){if((k|0)<=0)break;k=k+-1|0;if((f[(f[h+4+(k<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=20;break c}}if((a|0)<=1){i=1;j=20;break}}if((j|0)==20)return i|0;return 0}function mbc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+64|0;j=a+4|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=e+4|0;p=a+68|0;q=e+4|0;r=a+32|0;s=a+44|0;t=a+40|0;v=a+36|0;w=e+4|0;x=a+48|0;a:while(1){y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>0){f[c>>2]=y+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=ZYb(c,D)|0;if((A+-1|0)>>>0<127){B=A;C=6}else E=A}b:do if((C|0)==6){C=0;switch(B>>>3&536870911|0){case 1:{if((B&255|0)!=10){E=B;break b}f[h>>2]=f[h>>2]|1;A=f[j>>2]|0;y=A&-2;if(!(A&1))F=y;else F=f[y+4>>2]|0;y=f[i>>2]|0;if((y|0)==537368){xJa(i,F,537368);G=f[i>>2]|0}else G=y;if(l$b(c,G)|0)continue a;else{H=0;C=74;break a}break}case 2:{if((B&255|0)!=18){E=B;break b}y=f[l>>2]|0;do if(y){A=f[n>>2]|0;z=f[y>>2]|0;if((A|0)>=(z|0))if((z|0)==(f[m>>2]|0)){I=z;C=20;break}else{J=z;K=y;C=21;break}else{f[n>>2]=A+1;L=f[y+4+(A<<2)>>2]|0;break}}else{I=f[m>>2]|0;C=20}while(0);if((C|0)==20){C=0;XZb(k,I+1|0);y=f[l>>2]|0;J=f[y>>2]|0;K=y;C=21}if((C|0)==21){C=0;f[K>>2]=J+1;y=f[k>>2]|0;if(!y){A=$Xc(28)|0;cbc(A);M=A}else{if(f[y+64>>2]|0)SXb(y,21192,32);A=QXb(y,32)|0;dbc(A,y);M=A}A=f[l>>2]|0;y=f[n>>2]|0;f[n>>2]=y+1;f[A+4+(y<<2)>>2]=M;L=M}y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(A=b[y>>0]|0,A<<24>>24>-1):0){f[c>>2]=y+1;N=A&255}else{A=YYb(c)|0;if((A|0)>-1)N=A;else{H=0;C=74;break a}}JYb(e,c,N);if((f[o>>2]|0)<0){C=33;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){C=33;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{H=0;C=74;break a}break}case 3:{if((B&255|0)!=26){E=B;break b}f[h>>2]=f[h>>2]|2;A=f[p>>2]|0;if(!A){ybc(a);O=f[p>>2]|0}else O=A;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(y=b[A>>0]|0,y<<24>>24>-1):0){f[c>>2]=A+1;P=y&255}else{y=YYb(c)|0;if((y|0)>-1)P=y;else{H=0;C=74;break a}}JYb(e,c,P);if((f[q>>2]|0)<0){C=44;break a}if(!(Mi[f[(f[O>>2]|0)+44>>2]&1023](O,c)|0)){C=44;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{H=0;C=74;break a}break}case 4:{if((B&255|0)!=34){E=B;break b}y=f[s>>2]|0;do if(y){A=f[v>>2]|0;z=f[y>>2]|0;if((A|0)>=(z|0))if((z|0)==(f[t>>2]|0)){Q=z;C=52;break}else{R=z;S=y;C=53;break}else{f[v>>2]=A+1;T=f[y+4+(A<<2)>>2]|0;break}}else{Q=f[t>>2]|0;C=52}while(0);if((C|0)==52){C=0;XZb(r,Q+1|0);y=f[s>>2]|0;R=f[y>>2]|0;S=y;C=53}if((C|0)==53){C=0;f[S>>2]=R+1;y=f[r>>2]|0;if(!y){A=$Xc(24)|0;zbc(A);U=A}else{if(f[y+64>>2]|0)SXb(y,21224,24);A=QXb(y,24)|0;Bbc(A,y);U=A}A=f[s>>2]|0;y=f[v>>2]|0;f[v>>2]=y+1;f[A+4+(y<<2)>>2]=U;T=U}y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(A=b[y>>0]|0,A<<24>>24>-1):0){f[c>>2]=y+1;V=A&255}else{A=YYb(c)|0;if((A|0)>-1)V=A;else{H=0;C=74;break a}}JYb(e,c,V);if((f[w>>2]|0)<0){C=65;break a}if(!(Mi[f[(f[T>>2]|0)+44>>2]&1023](T,c)|0)){C=65;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{H=0;C=74;break a}break}case 5:{if((B&255|0)!=42){E=B;break b}if(l$b(c,pHa(x)|0)|0)continue a;else{H=0;C=74;break a}break}default:{E=B;break b}}}while(0);if(!E){H=1;C=74;break}A=f[j>>2]|0;if(!(A&1))W=lSa(j)|0;else W=A&-2;if(!(Lqc(c,E,W)|0)){H=0;C=74;break}}if((C|0)==33){H=0;u=d;return H|0}else if((C|0)==44){H=0;u=d;return H|0}else if((C|0)==65){H=0;u=d;return H|0}else if((C|0)==74){u=d;return H|0}return 0}function nbc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+52>>2]|0;i=d+k|0;if((d|0)>0){k=f[a+60>>2]|0;h=0;g=i;while(1){c=f[k+4+(h<<2)>>2]|0;e=b[c+11>>0]|0;j=e<<24>>24<0?f[c+4>>2]|0:e&255;e=j+g+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=e;break}else g=e}}else l=i;i=f[a+8>>2]|0;if(!(i&3)){m=l;n=a+12|0;f[n>>2]=m;return m|0}if(!(i&1))o=l;else{g=f[a+64>>2]|0;d=b[g+11>>0]|0;h=d<<24>>24<0?f[g+4>>2]|0:d&255;o=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(i&2)){m=o;n=a+12|0;f[n>>2]=m;return m|0}i=f[a+68>>2]|0;h=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;m=o+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=a+12|0;f[n>>2]=m;return m|0}function obc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+64>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{k$b(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)k$b(3,f[a+68>>2]|0,b);c=f[a+36>>2]|0;if(c|0){d=a+44|0;g=0;do{k$b(4,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+52>>2]|0;if((c|0)>0){g=a+60|0;d=0;do{e$b(5,f[(f[g>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function pbc(a){a=a|0;return f[a+12>>2]|0}function qbc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+64>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&2047](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}if(!(e&2))t=i;else{e=f[a+68>>2]|0;b[i>>0]=26;k=i+1|0;i=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(i>>>0>127){d=i;j=k;while(1){b[j>>0]=d|128;r=d>>>7;s=j+1|0;if(d>>>0>16383){d=r;j=s}else{u=s;v=r;break}}}else{u=k;v=i}b[u>>0]=v;t=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,u+1|0)|0}u=f[a+36>>2]|0;if(!u)w=t;else{e=a+44|0;v=0;i=t;while(1){t=f[(f[e>>2]|0)+4+(v<<2)>>2]|0;b[i>>0]=34;k=i+1|0;j=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(j>>>0>127){d=j;r=k;while(1){b[r>>0]=d|128;s=d>>>7;h=r+1|0;if(d>>>0>16383){d=s;r=h}else{x=h;y=s;break}}}else{x=k;y=j}b[x>>0]=y;r=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;v=v+1|0;if((v|0)==(u|0)){w=r;break}else i=r}}i=f[a+52>>2]|0;if((i|0)>0){u=a+60|0;v=0;x=w;while(1){c=f[(f[u>>2]|0)+4+(v<<2)>>2]|0;b[x>>0]=42;y=gZb(c,x+1|0)|0;v=v+1|0;if((v|0)==(i|0)){z=y;break}else x=y}}else z=w;w=f[a+4>>2]|0;if(!(w&1)){A=z;return A|0}A=Pqc(w&-2,z)|0;return A|0}function rbc(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;kbc(a);c=kZc(b,21568,21208,0)|0;if(!c){Ooc(b,a);return}else{vbc(a,c);return}}function sbc(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21208,0)|0;if(!c){Ooc(b,a);return}else{vbc(a,c);return}}function tbc(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ubc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538944;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function vbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}wbc(a+16|0,b+16|0);xbc(a+32|0,b+32|0);vSa(a+48|0,b+48|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+64>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+64|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,g);break}else{oYc(i,g)|0;break}}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+68|0;j=f[d>>2]|0;if(!j){ybc(a);k=f[d>>2]|0}else k=j;j=f[b+68>>2]|0;q8b(k,j|0?j:538368);return}function wbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Tbc(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(28)|0;cbc(l);Tbc(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21192,32);l=QXb(i,32)|0;dbc(l,i);Tbc(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function xbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Abc(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(24)|0;zbc(l);Abc(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21224,24);l=QXb(i,24)|0;Bbc(l,i);Abc(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ybc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(52)|0;r8b(c);e=c;g=a+68|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21080,56);c=QXb(d,56)|0;s8b(c,d);e=c;g=a+68|0;f[g>>2]=e;return}function zbc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=170020;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=537896?(f[223555]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=145;b[d+8>>0]=0;J_b(894220,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Abc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[a+8>>2]|0;if(!(d&3))return;if(d&1|0)f[b+16>>2]=f[a+16>>2];if(d&2|0)f[b+20>>2]=f[a+20>>2];a=b+8|0;f[a>>2]=f[a>>2]|d;return}function Bbc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=170020;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223555]|0)!=2){f[e>>2]=165456;f[e+4>>2]=145;b[e+8>>0]=0;J_b(894220,e);a_b(e)}f[a+12>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function Cbc(a){a=a|0;var b=0,c=0;f[a>>2]=170020;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Dbc(a){a=a|0;var b=0,c=0;f[a>>2]=170020;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Ebc(a){a=a|0;a=$Xc(24)|0;zbc(a);return a|0}function Fbc(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(24)|0;zbc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21224,24);a=QXb(b,24)|0;Bbc(a,b);c=a;return c|0}function Gbc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function Hbc(a){a=a|0;return f[a+4>>2]|0}function Ibc(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Jbc(a){a=a|0;return 1}function Kbc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=KYb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=KYb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=lSa(i)|0;else u=a&-2;if(!(Lqc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function Lbc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function Mbc(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)S_b(1,f[a+16>>2]|0,b);if(c&2|0)S_b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Nbc(a){a=a|0;return f[a+12>>2]|0}function Obc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=l1c(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function Pbc(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Qbc(a,b);return}function Qbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,21224,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function Rbc(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Sbc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538936;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Tbc(a,b){a=a|0;b=b|0;abc(b,a);return}function Ubc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=169912;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==537920;g=a+16|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223556]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=146;b[d+8>>0]=0;J_b(894224,d);a_b(d)}f[a+12>>2]=0;f[a+64>>2]=537368;f[a+68>>2]=0;u=c;return}function Vbc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[a>>2]=169912;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;if((f[223556]|0)==2){g=a+12|0;f[g>>2]=0;h=a+64|0;f[h>>2]=537368;i=a+68|0;f[i>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=146;b[e+8>>0]=0;J_b(894224,e);a_b(e);g=a+12|0;f[g>>2]=0;h=a+64|0;f[h>>2]=537368;i=a+68|0;f[i>>2]=0;u=d;return}function Wbc(a){a=a|0;var c=0,d=0;f[a>>2]=170128;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=537872?(c=f[a+20>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function Xbc(a){a=a|0;Wbc(a);cYc(a);return}function Ybc(a){a=a|0;a=$Xc(24)|0;ncc(a);return a|0}function Zbc(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(24)|0;ncc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21240,24);a=QXb(b,24)|0;occ(a,b);c=a;return c|0}function _bc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function $bc(a){a=a|0;return f[a+4>>2]|0}function acc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){d=f[a+20>>2]|0;Ksc(d+4|0);g=d+36|0;e=f[g>>2]|0;if((e|0)>0){h=f[d+44>>2]|0;i=0;do{i6b(f[h+4+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(e|0));f[g>>2]=0}f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)sqc(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function bcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(f[a+8>>2]&2)){b=1;return b|0}c=f[a+20>>2]|0;if(!(Psc(c+4|0)|0)){b=0;return b|0}a=f[c+36>>2]|0;if((a|0)<=0){b=1;return b|0}d=f[c+44>>2]|0;c=a;a:while(1){a=c;c=c+-1|0;e=f[d+4+(c<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=9;break a}}if((a|0)<=1){b=1;i=9;break}}if((i|0)==9)return b|0;return 0}function ccc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=e+4|0;a:while(1){m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=m+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[j>>2]|0;m=o&-2;if(!(o&1))t=m;else t=f[m+4>>2]|0;m=f[i>>2]|0;if((m|0)==537368){xJa(i,t,537368);v=f[i>>2]|0}else v=m;if(l$b(c,v)|0)continue a;else{w=0;q=30;break a}break}case 2:break;default:{s=p;break b}}if((p&255|0)==18){f[h>>2]=f[h>>2]|2;m=f[k>>2]|0;if(!m){mcc(a);x=f[k>>2]|0}else x=m;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(o=b[m>>0]|0,o<<24>>24>-1):0){f[c>>2]=m+1;y=o&255}else{o=YYb(c)|0;if((o|0)>-1)y=o;else{w=0;q=30;break a}}JYb(e,c,y);if((f[l>>2]|0)<0){q=23;break a}if(!(Mi[f[(f[x>>2]|0)+44>>2]&1023](x,c)|0)){q=23;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{w=0;q=30;break a}}else s=p}while(0);if(!s){w=1;q=30;break}o=f[j>>2]|0;if(!(o&1))z=lSa(j)|0;else z=o&-2;if(!(Lqc(c,s,z)|0)){w=0;q=30;break}}if((q|0)==23){w=0;u=d;return w|0}else if((q|0)==30){u=d;return w|0}return 0}function dcc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+20>>2]|0;k=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;e=h+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function ecc(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&2|0)k$b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function fcc(a){a=a|0;return f[a+12>>2]|0}function gcc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&2))i=g;else{e=f[a+20>>2]|0;b[g>>0]=18;d=g+1|0;g=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(g>>>0>127){h=g;j=d;while(1){b[j>>0]=h|128;k=h>>>7;l=j+1|0;if(h>>>0>16383){h=k;j=l}else{m=l;n=k;break}}}else{m=d;n=g}b[m>>0]=n;i=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,m+1|0)|0}m=f[a+4>>2]|0;if(!(m&1)){o=i;return o|0}o=Pqc(m&-2,i)|0;return o|0}function hcc(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;acc(a);c=kZc(b,21568,21240,0)|0;if(!c){Ooc(b,a);return}else{lcc(a,c);return}}function icc(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21240,0)|0;if(!c){Ooc(b,a);return}else{lcc(a,c);return}}function jcc(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function kcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538928;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function lcc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+16>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+16|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,g);break}else{oYc(i,g)|0;break}}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+20|0;j=f[d>>2]|0;if(!j){mcc(a);k=f[d>>2]|0}else k=j;j=f[b+20>>2]|0;b=j|0?j:538320;Lsc(k+4|0,b+4|0);j=k+20|0;d=f[b+20>>2]|0;if(d&1|0){a=f[j>>2]|0;if(!(a&1))l=lSa(j)|0;else l=a&-2;vqc(l,d&-2)}k7b(k+32|0,b+32|0);return}function mcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(48)|0;K8b(c);e=c;g=a+20|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21096,48);c=QXb(d,48)|0;L8b(c,d);e=c;g=a+20|0;f[g>>2]=e;return}function ncc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=170128;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=537872?(f[223554]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=144;b[d+8>>0]=0;J_b(894216,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=0;u=c;return}function occ(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=170128;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223554]|0)!=2){f[e>>2]=165456;f[e+4>>2]=144;b[e+8>>0]=0;J_b(894216,e);a_b(e)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=0;u=d;return}function pcc(a){a=a|0;var b=0,c=0;f[a>>2]=170236;Kcc(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function qcc(a){a=a|0;pcc(a);cYc(a);return}function rcc(a){a=a|0;a=$Xc(56)|0;Icc(a);return a|0}function scc(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(56)|0;Icc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21256,56);a=QXb(b,56)|0;Jcc(a,b);c=a;return c|0}function tcc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function ucc(a){a=a|0;return f[a+4>>2]|0}function vcc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(d&63|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0?(g=f[a+20>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&4|0?(e=f[a+24>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&8|0?(g=f[a+28>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&16|0?(e=f[a+32>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&32|0){g=f[a+36>>2]|0;Ksc(g+4|0);e=g+36|0;h=f[e>>2]|0;if((h|0)>0){i=f[g+44>>2]|0;j=0;do{i6b(f[i+4+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=(h|0));f[e>>2]=0}e=g+24|0;if(f[e>>2]&63|0){h=g+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0}f[e>>2]=0;e=f[g+20>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g)}}if(d&192|0){g=a+40|0;f[g>>2]=0;f[g+4>>2]=0}if(d&768|0){f[a+48>>2]=1;f[a+52>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function wcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(f[a+8>>2]&32)){b=1;return b|0}c=f[a+36>>2]|0;if(!(Psc(c+4|0)|0)){b=0;return b|0}a=f[c+36>>2]|0;if((a|0)<=0){b=1;return b|0}d=f[c+44>>2]|0;c=a;a:while(1){a=c;c=c+-1|0;e=f[d+4+(c<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=9;break a}}if((a|0)<=1){b=1;i=9;break}}if((i|0)==9)return b|0;return 0}function xcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=a+40|0;m=a+48|0;n=a+52|0;o=a+24|0;p=a+28|0;q=a+36|0;r=e+4|0;s=a+44|0;t=a+32|0;a:while(1){v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){w=b[v>>0]|0;x=w&255;if(w<<24>>24>0){f[c>>2]=v+1;y=x;z=6}else{A=x;z=5}}else{A=0;z=5}if((z|0)==5){z=0;x=ZYb(c,A)|0;if((x+-1|0)>>>0<127){y=x;z=6}else B=x}b:do if((z|0)==6){z=0;do switch(y>>>3&536870911|0){case 1:{if((y&255|0)!=10){B=y;break b}f[h>>2]=f[h>>2]|1;x=f[j>>2]|0;v=x&-2;if(!(x&1))C=v;else C=f[v+4>>2]|0;v=f[i>>2]|0;if((v|0)==537368){xJa(i,C,537368);D=f[i>>2]|0}else D=v;if(l$b(c,D)|0)continue a;else{E=0;z=92;break a}break}case 2:{if((y&255|0)!=18){B=y;break b}f[h>>2]=f[h>>2]|2;v=f[j>>2]|0;x=v&-2;if(!(v&1))F=x;else F=f[x+4>>2]|0;x=f[k>>2]|0;if((x|0)==537368){xJa(k,F,537368);G=f[k>>2]|0}else G=x;if(l$b(c,G)|0)continue a;else{E=0;z=92;break a}break}case 3:{if((y&255|0)!=24){B=y;break b}f[h>>2]=f[h>>2]|64;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){v=b[x>>0]|0;w=v&255;if(v<<24>>24>-1){f[c>>2]=x+1;H=w}else{I=w;z=25}}else{I=0;z=25}if((z|0)==25){z=0;w=KYb(c,I)|0;x=J;if((x|0)>-1|(x|0)==-1&w>>>0>4294967295)H=w;else{E=0;z=92;break a}}f[l>>2]=H;continue a;break}case 4:{if((y&255|0)!=32){B=y;break b}w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){x=b[w>>0]|0;v=x&255;if(x<<24>>24>-1){f[c>>2]=w+1;K=v}else{L=v;z=31}}else{L=0;z=31}if((z|0)==31){z=0;v=KYb(c,L)|0;w=J;if((w|0)>-1|(w|0)==-1&v>>>0>4294967295)K=v;else{E=0;z=92;break a}}if((K+-1|0)>>>0<3){f[h>>2]=f[h>>2]|256;f[m>>2]=K;continue a}v=f[j>>2]|0;if(!(v&1))M=lSa(j)|0;else M=v&-2;yqc(M,4,K,((K|0)<0)<<31>>31);continue a;break}case 5:{if((y&255|0)!=40){B=y;break b}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){w=b[v>>0]|0;x=w&255;if(w<<24>>24>-1){f[c>>2]=v+1;N=x}else{O=x;z=42}}else{O=0;z=42}if((z|0)==42){z=0;x=KYb(c,O)|0;v=J;if((v|0)>-1|(v|0)==-1&x>>>0>4294967295)N=x;else{E=0;z=92;break a}}if((N+-1|0)>>>0<18){f[h>>2]=f[h>>2]|512;f[n>>2]=N;continue a}x=f[j>>2]|0;if(!(x&1))P=lSa(j)|0;else P=x&-2;yqc(P,5,N,((N|0)<0)<<31>>31);continue a;break}case 6:{if((y&255|0)!=50){B=y;break b}f[h>>2]=f[h>>2]|4;x=f[j>>2]|0;v=x&-2;if(!(x&1))Q=v;else Q=f[v+4>>2]|0;v=f[o>>2]|0;if((v|0)==537368){xJa(o,Q,537368);R=f[o>>2]|0}else R=v;if(l$b(c,R)|0)continue a;else{E=0;z=92;break a}break}case 7:{if((y&255|0)!=58){B=y;break b}f[h>>2]=f[h>>2]|8;v=f[j>>2]|0;x=v&-2;if(!(v&1))S=x;else S=f[x+4>>2]|0;x=f[p>>2]|0;if((x|0)==537368){xJa(p,S,537368);T=f[p>>2]|0}else T=x;if(l$b(c,T)|0)continue a;else{E=0;z=92;break a}break}case 8:{if((y&255|0)!=66){B=y;break b}f[h>>2]=f[h>>2]|32;x=f[q>>2]|0;if(!x){Hcc(a);U=f[q>>2]|0}else U=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(v=b[x>>0]|0,v<<24>>24>-1):0){f[c>>2]=x+1;V=v&255}else{v=YYb(c)|0;if((v|0)>-1)V=v;else{E=0;z=92;break a}}JYb(e,c,V);if((f[r>>2]|0)<0){z=72;break a}if(!(Mi[f[(f[U>>2]|0)+44>>2]&1023](U,c)|0)){z=72;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{E=0;z=92;break a}break}case 9:{if((y&255|0)!=72){B=y;break b}f[h>>2]=f[h>>2]|128;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){x=b[v>>0]|0;w=x&255;if(x<<24>>24>-1){f[c>>2]=v+1;W=w}else{X=w;z=78}}else{X=0;z=78}if((z|0)==78){z=0;w=KYb(c,X)|0;v=J;if((v|0)>-1|(v|0)==-1&w>>>0>4294967295)W=w;else{E=0;z=92;break a}}f[s>>2]=W;continue a;break}case 10:{if((y&255|0)!=82){B=y;break b}f[h>>2]=f[h>>2]|16;w=f[j>>2]|0;v=w&-2;if(!(w&1))Y=v;else Y=f[v+4>>2]|0;v=f[t>>2]|0;if((v|0)==537368){xJa(t,Y,537368);Z=f[t>>2]|0}else Z=v;if(l$b(c,Z)|0)continue a;else{E=0;z=92;break a}break}default:{B=y;break b}}while(0)}while(0);if(!B){E=1;z=92;break}v=f[j>>2]|0;if(!(v&1))_=lSa(j)|0;else _=v&-2;if(!(Lqc(c,B,_)|0)){E=0;z=92;break}}if((z|0)==72){E=0;u=d;return E|0}else if((z|0)==92){u=d;return E|0}return 0}function ycc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=a+8|0;e=f[c>>2]|0;if(e&255){if(!(e&1))g=d;else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0?f[h+4>>2]|0:i&255;g=d+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&2))k=g;else{j=f[a+20>>2]|0;i=b[j+11>>0]|0;h=i<<24>>24<0?f[j+4>>2]|0:i&255;k=g+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&4))l=k;else{h=f[a+24>>2]|0;g=b[h+11>>0]|0;i=g<<24>>24<0?f[h+4>>2]|0:g&255;l=k+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&8))m=l;else{i=f[a+28>>2]|0;k=b[i+11>>0]|0;g=k<<24>>24<0?f[i+4>>2]|0:k&255;m=l+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&16))n=m;else{g=f[a+32>>2]|0;l=b[g+11>>0]|0;k=l<<24>>24<0?f[g+4>>2]|0:l&255;n=m+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(e&32)){o=n;p=e}else{k=f[a+36>>2]|0;m=_i[f[(f[k>>2]|0)+48>>2]&2047](k)|0;k=n+1+m+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;o=k;p=f[c>>2]|0}if(!(p&64))q=o;else{c=f[a+40>>2]|0;if((c|0)<0)r=11;else r=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;q=r+o|0}if(!(p&128)){s=q;t=p}else{o=f[a+44>>2]|0;if((o|0)<0)u=11;else u=((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;s=u+q|0;t=p}}else{s=d;t=e}if(!(t&768)){v=s;w=a+12|0;f[w>>2]=v;return v|0}if(!(t&256))x=s;else{e=f[a+48>>2]|0;if((e|0)<0)y=11;else y=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;x=y+s|0}if(!(t&512)){v=x;w=a+12|0;f[w>>2]=v;return v|0}t=f[a+52>>2]|0;if((t|0)<0)z=11;else z=((((($(t|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;v=z+x|0;w=a+12|0;f[w>>2]=v;return v|0}function zcc(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&2|0)f$b(2,f[a+20>>2]|0,b);if(c&64|0)S_b(3,f[a+40>>2]|0,b);if(c&256|0)d$b(4,f[a+48>>2]|0,b);if(c&512|0)d$b(5,f[a+52>>2]|0,b);if(c&4|0)f$b(6,f[a+24>>2]|0,b);if(c&8|0)f$b(7,f[a+28>>2]|0,b);if(c&32|0)k$b(8,f[a+36>>2]|0,b);if(c&128|0)S_b(9,f[a+44>>2]|0,b);if(c&16|0)f$b(10,f[a+32>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Acc(a){a=a|0;return f[a+12>>2]|0}function Bcc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+20>>2]|0;b[g>>0]=18;i=gZb(d,g+1|0)|0}if(!(e&64))j=i;else{g=f[a+40>>2]|0;b[i>>0]=24;d=i+1|0;i=g&255;if(g>>>0>127){h=d;k=i;l=g;m=((g|0)<0)<<31>>31;while(1){b[h>>0]=k|-128;g=l;l=l1c(l|0,m|0,7)|0;n=h+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&g>>>0>16383)){p=n;q=o;break}else{h=n;k=o;m=J}}}else{p=d;q=i}b[p>>0]=q;j=p+1|0}if(!(e&256))r=j;else{p=f[a+48>>2]|0;b[j>>0]=32;q=j+1|0;j=p&255;if(p>>>0>127){i=q;d=j;m=p;k=((p|0)<0)<<31>>31;while(1){b[i>>0]=d|-128;p=m;m=l1c(m|0,k|0,7)|0;h=i+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=h;t=l;break}else{i=h;d=l;k=J}}}else{s=q;t=j}b[s>>0]=t;r=s+1|0}if(!(e&512))u=r;else{s=f[a+52>>2]|0;b[r>>0]=40;t=r+1|0;r=s&255;if(s>>>0>127){j=t;q=r;k=s;d=((s|0)<0)<<31>>31;while(1){b[j>>0]=q|-128;s=k;k=l1c(k|0,d|0,7)|0;i=j+1|0;m=k&255;if(!(d>>>0>0|(d|0)==0&s>>>0>16383)){v=i;w=m;break}else{j=i;q=m;d=J}}}else{v=t;w=r}b[v>>0]=w;u=v+1|0}if(!(e&4))x=u;else{v=f[a+24>>2]|0;b[u>>0]=50;x=gZb(v,u+1|0)|0}if(!(e&8))y=x;else{u=f[a+28>>2]|0;b[x>>0]=58;y=gZb(u,x+1|0)|0}if(!(e&32))z=y;else{x=f[a+36>>2]|0;b[y>>0]=66;u=y+1|0;y=_i[f[(f[x>>2]|0)+60>>2]&2047](x)|0;if(y>>>0>127){v=y;w=u;while(1){b[w>>0]=v|128;r=v>>>7;t=w+1|0;if(v>>>0>16383){v=r;w=t}else{A=t;B=r;break}}}else{A=u;B=y}b[A>>0]=B;z=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,A+1|0)|0}if(!(e&128))C=z;else{A=f[a+44>>2]|0;b[z>>0]=72;c=z+1|0;z=A&255;if(A>>>0>127){x=c;B=z;y=A;u=((A|0)<0)<<31>>31;while(1){b[x>>0]=B|-128;A=y;y=l1c(y|0,u|0,7)|0;w=x+1|0;v=y&255;if(!(u>>>0>0|(u|0)==0&A>>>0>16383)){D=w;E=v;break}else{x=w;B=v;u=J}}}else{D=c;E=z}b[D>>0]=E;C=D+1|0}if(!(e&16))F=C;else{e=f[a+32>>2]|0;b[C>>0]=82;F=gZb(e,C+1|0)|0}C=f[a+4>>2]|0;if(!(C&1)){G=F;return G|0}G=Pqc(C&-2,F)|0;return G|0}function Ccc(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;vcc(a);c=kZc(b,21568,21256,0)|0;if(!c){Ooc(b,a);return}else{Gcc(a,c);return}}function Dcc(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21256,0)|0;if(!c){Ooc(b,a);return}else{Gcc(a,c);return}}function Ecc(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Fcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538920;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Gcc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(d&255|0){do if(d&1|0){g=f[b+16>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+16|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,g);break}else{oYc(i,g)|0;break}}while(0);do if(d&2|0){j=f[b+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[c>>2]|0;e=i&-2;if(!(i&1))k=e;else k=f[e+4>>2]|0;e=f[g>>2]|0;if((e|0)==537368){xJa(g,k,j);break}else{oYc(e,j)|0;break}}while(0);do if(d&4|0){k=f[b+24>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|4;j=a+24|0;e=f[c>>2]|0;g=e&-2;if(!(e&1))l=g;else l=f[g+4>>2]|0;g=f[j>>2]|0;if((g|0)==537368){xJa(j,l,k);break}else{oYc(g,k)|0;break}}while(0);do if(d&8|0){l=f[b+28>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|8;k=a+28|0;g=f[c>>2]|0;j=g&-2;if(!(g&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==537368){xJa(k,m,l);break}else{oYc(j,l)|0;break}}while(0);do if(d&16|0){m=f[b+32>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|16;l=a+32|0;j=f[c>>2]|0;k=j&-2;if(!(j&1))n=k;else n=f[k+4>>2]|0;k=f[l>>2]|0;if((k|0)==537368){xJa(l,n,m);break}else{oYc(k,m)|0;break}}while(0);if(d&32|0){n=a+8|0;f[n>>2]=f[n>>2]|32;n=a+36|0;c=f[n>>2]|0;if(!c){Hcc(a);o=f[n>>2]|0}else o=c;c=f[b+36>>2]|0;b9b(o,c|0?c:538256)}if(d&64|0)f[a+40>>2]=f[b+40>>2];if(d&128|0)f[a+44>>2]=f[b+44>>2];c=a+8|0;f[c>>2]=f[c>>2]|d}if(!(d&768))return;if(d&256|0)f[a+48>>2]=f[b+48>>2];if(d&512|0)f[a+52>>2]=f[b+52>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function Hcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(60)|0;c9b(c);e=c;g=a+36|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21112,64);c=QXb(d,64)|0;d9b(c,d);e=c;g=a+36|0;f[g>>2]=e;return}function Icc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=170236;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=537816?(f[223553]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=143;b[d+8>>0]=0;J_b(894212,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;f[a+28>>2]=537368;f[a+32>>2]=537368;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[a+48>>2]=1;f[a+52>>2]=1;u=c;return}function Jcc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=170236;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223553]|0)!=2){f[e>>2]=165456;f[e+4>>2]=143;b[e+8>>0]=0;J_b(894212,e);a_b(e)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;f[a+28>>2]=537368;f[a+32>>2]=537368;e=a+36|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[a+48>>2]=1;f[a+52>>2]=1;u=d;return}function Kcc(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+28>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+32>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==537816)return;c=f[a+36>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function Lcc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=170344;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)sqc(h);cYc(c)}f[b>>2]=0;urc(a+4|0);return}function Mcc(a){a=a|0;Lcc(a);cYc(a);return}function Ncc(a){a=a|0;a=$Xc(48)|0;adc(a);return a|0}function Occ(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(48)|0;adc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21272,48);a=QXb(b,48)|0;bdc(a,b);c=a;return c|0}function Pcc(a){a=a|0;var b=0,c=0;b=f[a+20>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function Qcc(a){a=a|0;return f[a+20>>2]|0}function Rcc(a){a=a|0;var b=0,c=0,d=0,e=0;Ksc(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{i6b(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Scc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(Psc(a+4|0)|0)){b=0;return b|0}c=f[a+36>>2]|0;if((c|0)<=0){b=1;return b|0}d=f[a+44>>2]|0;a=c;a:while(1){c=a;a=a+-1|0;e=f[d+4+(a<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=8;break a}}if((c|0)<=1){b=1;i=8;break}}if((i|0)==8)return b|0;return 0}function Tcc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+32|0;j=e+4|0;k=a+4|0;l=a+20|0;while(1){a=f[c>>2]|0;m=f[g>>2]|0;do if(a>>>0<m>>>0){n=b[a>>0]|0;o=n&255;p=a+1|0;if(n<<24>>24>0){q=p;r=o}else{if(p>>>0>=m>>>0){s=o;t=7;break}n=h[p>>0]|0;if(((n^128)&o)>>>0<=127){s=o;t=7;break}q=a+2|0;r=o+-128+(n<<7)|0}f[c>>2]=q;v=r;t=9}else{s=0;t=7}while(0);if((t|0)==7){t=0;a=ZYb(c,s)|0;if((a+-1|0)>>>0<16383){v=a;t=9}else w=a}if((t|0)==9){t=0;if((v|0)==7994){a=m7b(i)|0;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[c>>2]=m+1;x=n&255}else{n=YYb(c)|0;if((n|0)>-1)x=n;else{y=0;t=28;break}}JYb(e,c,x);if((f[j>>2]|0)<0){t=16;break}if(!(Mi[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){t=16;break}if(OYb(c,f[e>>2]|0)|0)continue;else{y=0;t=28;break}}else w=v}if(!w){y=1;t=28;break}a=f[l>>2]|0;n=(a&1|0)==0;if(w>>>0>7999){if(n)z=lSa(l)|0;else z=a&-2;if(Fgc(k,w,c,537768,z)|0)continue;else{y=0;t=28;break}}else{if(n)A=lSa(l)|0;else A=a&-2;if(Lqc(c,w,A)|0)continue;else{y=0;t=28;break}}}if((t|0)==16){y=0;u=d;return y|0}else if((t|0)==28){u=d;return y|0}return 0}function Ucc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=Vsc(a+4|0)|0;c=f[a+20>>2]|0;if(!(c&1))d=b;else d=(Rqc(c&-2)|0)+b|0;b=f[a+36>>2]|0;c=(b<<1)+d|0;if(!b){e=c;g=a+28|0;f[g>>2]=e;return e|0}d=a+44|0;h=0;i=c;while(1){c=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=c;break}else i=c}g=a+28|0;f[g>>2]=e;return e|0}function Vcc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+36>>2]|0;if(c|0){d=a+44|0;e=0;do{k$b(999,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}Tsc(a+4|0,1e3,536870912,b);c=f[a+20>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Wcc(a){a=a|0;return f[a+28>>2]|0}function Xcc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+36>>2]|0;if(!e)g=d;else{h=a+44|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=-70;b[j+1>>0]=62;k=j+2|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=Jgc(a+4|0,1e3,536870912,c,g)|0;g=f[a+20>>2]|0;if(!(g&1)){s=j;return s|0}s=Pqc(g&-2,j)|0;return s|0}function Ycc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Zcc(a,b);return}function Zcc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,21272,0)|0;if(!c){Ooc(b,a);return}Lsc(a+4|0,c+4|0);b=a+20|0;d=f[c+20>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}k7b(a+32|0,c+32|0);return}function _cc(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function $cc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538912;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function adc(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=170344;trc(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=537768?(f[223552]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=142;b[d+8>>0]=0;J_b(894208,d);a_b(d)}f[a+28>>2]=0;u=c;return}function bdc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=170344;prc(a+4|0,c);f[a+20>>2]=c;f[a+24>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;if((f[223552]|0)==2){g=a+28|0;f[g>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=142;b[e+8>>0]=0;J_b(894208,e);a_b(e);g=a+28|0;f[g>>2]=0;u=d;return}function cdc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f[a>>2]=170452;c=f[a+144>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=537616?(c=f[a+148>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=a+140|0;d=f[c>>2]|0;if(d|0?(f[a+128>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+124|0;i=f[c>>2]|0;if(i|0?(f[a+112>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+108|0;j=f[c>>2]|0;if(j|0?(f[a+96>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+92|0;k=f[c>>2]|0;if(k|0?(f[a+80>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;cYc(l)}f[c>>2]=0;c=a+76|0;l=f[c>>2]|0;if(l|0?(f[a+64>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0)Yi[f[(f[i>>2]|0)+4>>2]&4095](i);j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;cYc(m)}f[c>>2]=0;c=a+60|0;m=f[c>>2]|0;if(m|0?(f[a+48>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0)Yi[f[(f[j>>2]|0)+4>>2]&4095](j);k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;cYc(n)}f[c>>2]=0;c=a+44|0;n=f[c>>2]|0;if(n|0?(f[a+32>>2]|0)==0:0){m=f[n>>2]|0;if((m|0)>0){l=0;do{k=f[n+4+(l<<2)>>2]|0;if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&4095](k);l=l+1|0}while((l|0)!=(m|0));o=f[c>>2]|0}else o=n;cYc(o)}f[c>>2]=0;c=a+28|0;o=f[c>>2]|0;if(o|0?(f[a+16>>2]|0)==0:0){n=f[o>>2]|0;if((n|0)>0){m=0;do{l=f[o+4+(m<<2)>>2]|0;if(l|0)Yi[f[(f[l>>2]|0)+4>>2]&4095](l);m=m+1|0}while((m|0)!=(n|0));p=f[c>>2]|0}else p=o;cYc(p)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}p=a&-2;a=p;if((p|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(p);f[c>>2]=0;return}function ddc(a){a=a|0;cdc(a);cYc(a);return}function edc(a){a=a|0;a=$Xc(152)|0;rec(a);return a|0}function fdc(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(152)|0;rec(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21288,152);a=QXb(b,152)|0;tec(a,b);c=a;return c|0}function gdc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function hdc(a){a=a|0;return f[a+4>>2]|0}function idc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{vcc(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{idc(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{kbc(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+68|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+76>>2]|0;e=0;do{dec(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+84|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+92>>2]|0;g=0;do{vcc(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+100|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+108>>2]|0;e=0;do{acc(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+116|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+124>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+8|0;if(f[i>>2]&3|0){j=h+16|0;f[j>>2]=0;f[j+4>>2]=0}f[i>>2]=0;i=f[h+4>>2]|0;if(i&1|0?(h=i&-2,f[h>>2]|0):0)sqc(h)}while((g|0)!=(d|0));f[c>>2]=0}c=a+132|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+140>>2]|0;e=0;do{h=f[g+4+(e<<2)>>2]|0;e=e+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+144>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){d=f[a+148>>2]|0;Ksc(d+4|0);g=d+36|0;e=f[g>>2]|0;if((e|0)>0){i=f[d+44>>2]|0;h=0;do{i6b(f[i+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[g>>2]=0}f[d+48>>2]=0;f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)sqc(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function jdc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=f[a+20>>2]|0;a:do if((b|0)>0){c=a+28|0;d=b;b:while(1){e=d;d=d+-1|0;g=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(f[g+8>>2]&32|0){h=f[g+36>>2]|0;if(!(Psc(h+4|0)|0)){i=0;j=59;break}g=f[h+36>>2]|0;if((g|0)>0){k=f[h+44>>2]|0;h=g;do{g=h;h=h+-1|0;l=f[k+4+(h<<2)>>2]|0;m=f[l+28>>2]|0;n=f[l+20>>2]|0;while(1){if((n|0)<=0)break;n=n+-1|0;if((f[(f[m+4+(n<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=59;break b}}}while((g|0)>1)}}if((e|0)<=1)break a}if((j|0)==59)return i|0}while(0);b=a+44|0;d=f[a+36>>2]|0;while(1){if((d|0)<=0)break;d=d+-1|0;if(!(jdc(f[(f[b>>2]|0)+4+(d<<2)>>2]|0)|0)){i=0;j=59;break}}if((j|0)==59)return i|0;d=a+60|0;b=f[a+52>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;if(!(lbc(f[(f[d>>2]|0)+4+(b<<2)>>2]|0)|0)){i=0;j=59;break}}if((j|0)==59)return i|0;b=f[a+68>>2]|0;c:do if((b|0)>0){d=a+76|0;c=b;d:while(1){h=c;c=c+-1|0;k=f[(f[d>>2]|0)+4+(c<<2)>>2]|0;if(f[k+8>>2]&1|0){n=f[k+16>>2]|0;if(!(Psc(n+4|0)|0)){i=0;j=59;break}k=f[n+36>>2]|0;if((k|0)>0){m=f[n+44>>2]|0;n=k;do{k=n;n=n+-1|0;l=f[m+4+(n<<2)>>2]|0;o=f[l+28>>2]|0;p=f[l+20>>2]|0;while(1){if((p|0)<=0)break;p=p+-1|0;if((f[(f[o+4+(p<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=59;break d}}}while((k|0)>1)}}if((h|0)<=1)break c}if((j|0)==59)return i|0}while(0);b=f[a+84>>2]|0;e:do if((b|0)>0){c=a+92|0;d=b;f:while(1){n=d;d=d+-1|0;m=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;if(f[m+8>>2]&32|0){e=f[m+36>>2]|0;if(!(Psc(e+4|0)|0)){i=0;j=59;break}m=f[e+36>>2]|0;if((m|0)>0){p=f[e+44>>2]|0;e=m;do{m=e;e=e+-1|0;o=f[p+4+(e<<2)>>2]|0;g=f[o+28>>2]|0;l=f[o+20>>2]|0;while(1){if((l|0)<=0)break;l=l+-1|0;if((f[(f[g+4+(l<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=59;break f}}}while((m|0)>1)}}if((n|0)<=1)break e}if((j|0)==59)return i|0}while(0);b=f[a+100>>2]|0;g:do if((b|0)>0){d=a+108|0;c=b;h:while(1){e=c;c=c+-1|0;p=f[(f[d>>2]|0)+4+(c<<2)>>2]|0;if(f[p+8>>2]&2|0){h=f[p+20>>2]|0;if(!(Psc(h+4|0)|0)){i=0;j=59;break}p=f[h+36>>2]|0;if((p|0)>0){l=f[h+44>>2]|0;h=p;do{p=h;h=h+-1|0;g=f[l+4+(h<<2)>>2]|0;k=f[g+28>>2]|0;o=f[g+20>>2]|0;while(1){if((o|0)<=0)break;o=o+-1|0;if((f[(f[k+4+(o<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=59;break h}}}while((p|0)>1)}}if((e|0)<=1)break g}if((j|0)==59)return i|0}while(0);if(!(f[a+8>>2]&2)){i=1;return i|0}b=f[a+148>>2]|0;if(!(Psc(b+4|0)|0)){i=0;return i|0}a=f[b+36>>2]|0;if((a|0)<=0){i=1;return i|0}c=f[b+44>>2]|0;b=a;i:while(1){a=b;b=b+-1|0;d=f[c+4+(b<<2)>>2]|0;h=f[d+28>>2]|0;l=f[d+20>>2]|0;while(1){if((l|0)<=0)break;l=l+-1|0;if((f[(f[h+4+(l<<2)>>2]|0)+8>>2]&3|0)!=3){i=0;j=59;break i}}if((a|0)<=1){i=1;j=59;break}}if((j|0)==59)return i|0;return 0}function kdc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+144|0;j=a+4|0;k=a+16|0;l=e+4|0;m=a+32|0;n=e+4|0;o=a+48|0;p=e+4|0;q=a+64|0;r=a+76|0;s=a+72|0;t=a+68|0;v=e+4|0;w=a+80|0;x=e+4|0;y=a+148|0;z=e+4|0;A=a+96|0;B=a+108|0;C=a+104|0;D=a+100|0;E=e+4|0;F=a+112|0;G=a+124|0;H=a+120|0;I=a+116|0;J=e+4|0;K=a+128|0;a:while(1){L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){M=b[L>>0]|0;N=M&255;if(M<<24>>24>0){f[c>>2]=L+1;O=N;P=6}else{Q=N;P=5}}else{Q=0;P=5}if((P|0)==5){P=0;N=ZYb(c,Q)|0;if((N+-1|0)>>>0<127){O=N;P=6}else R=N}b:do if((P|0)==6){P=0;do switch(O>>>3&536870911|0){case 1:{if((O&255|0)!=10){R=O;break b}f[h>>2]=f[h>>2]|1;N=f[j>>2]|0;L=N&-2;if(!(N&1))S=L;else S=f[L+4>>2]|0;L=f[i>>2]|0;if((L|0)==537368){xJa(i,S,537368);T=f[i>>2]|0}else T=L;if(l$b(c,T)|0)continue a;else{U=0;P=131;break a}break}case 2:{if((O&255|0)!=18){R=O;break b}L=_2b(k)|0;N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0?(M=b[N>>0]|0,M<<24>>24>-1):0){f[c>>2]=N+1;V=M&255}else{M=YYb(c)|0;if((M|0)>-1)V=M;else{U=0;P=131;break a}}JYb(e,c,V);if((f[l>>2]|0)<0){P=21;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){P=21;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 3:{if((O&255|0)!=26){R=O;break b}L=V2b(m)|0;M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(N=b[M>>0]|0,N<<24>>24>-1):0){f[c>>2]=M+1;W=N&255}else{N=YYb(c)|0;if((N|0)>-1)W=N;else{U=0;P=131;break a}}JYb(e,c,W);if((f[n>>2]|0)<0){P=30;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){P=30;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 4:{if((O&255|0)!=34){R=O;break b}L=X2b(o)|0;N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0?(M=b[N>>0]|0,M<<24>>24>-1):0){f[c>>2]=N+1;X=M&255}else{M=YYb(c)|0;if((M|0)>-1)X=M;else{U=0;P=131;break a}}JYb(e,c,X);if((f[p>>2]|0)<0){P=39;break a}if(!(Mi[f[(f[L>>2]|0)+44>>2]&1023](L,c)|0)){P=39;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 5:{if((O&255|0)!=42){R=O;break b}L=f[r>>2]|0;do if(L){M=f[t>>2]|0;N=f[L>>2]|0;if((M|0)>=(N|0))if((N|0)==(f[s>>2]|0)){Y=N;P=47;break}else{Z=N;_=L;P=48;break}else{f[t>>2]=M+1;$=f[L+4+(M<<2)>>2]|0;break}}else{Y=f[s>>2]|0;P=47}while(0);if((P|0)==47){P=0;XZb(q,Y+1|0);L=f[r>>2]|0;Z=f[L>>2]|0;_=L;P=48}if((P|0)==48){P=0;f[_>>2]=Z+1;L=f[q>>2]|0;if(!L){M=$Xc(28)|0;Wdc(M);aa=M}else{if(f[L+64>>2]|0)SXb(L,21320,32);M=QXb(L,32)|0;Ydc(M,L);aa=M}M=f[r>>2]|0;L=f[t>>2]|0;f[t>>2]=L+1;f[M+4+(L<<2)>>2]=aa;$=aa}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(M=b[L>>0]|0,M<<24>>24>-1):0){f[c>>2]=L+1;ba=M&255}else{M=YYb(c)|0;if((M|0)>-1)ba=M;else{U=0;P=131;break a}}JYb(e,c,ba);if((f[v>>2]|0)<0){P=60;break a}if(!(Mi[f[(f[$>>2]|0)+44>>2]&1023]($,c)|0)){P=60;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 6:{if((O&255|0)!=50){R=O;break b}M=_2b(w)|0;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(N=b[L>>0]|0,N<<24>>24>-1):0){f[c>>2]=L+1;ca=N&255}else{N=YYb(c)|0;if((N|0)>-1)ca=N;else{U=0;P=131;break a}}JYb(e,c,ca);if((f[x>>2]|0)<0){P=69;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){P=69;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 7:{if((O&255|0)!=58){R=O;break b}f[h>>2]=f[h>>2]|2;M=f[y>>2]|0;if(!M){Adc(a);da=f[y>>2]|0}else da=M;M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(N=b[M>>0]|0,N<<24>>24>-1):0){f[c>>2]=M+1;ea=N&255}else{N=YYb(c)|0;if((N|0)>-1)ea=N;else{U=0;P=131;break a}}JYb(e,c,ea);if((f[z>>2]|0)<0){P=80;break a}if(!(Mi[f[(f[da>>2]|0)+44>>2]&1023](da,c)|0)){P=80;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 8:{if((O&255|0)!=66){R=O;break b}N=f[B>>2]|0;do if(N){M=f[D>>2]|0;L=f[N>>2]|0;if((M|0)>=(L|0))if((L|0)==(f[C>>2]|0)){fa=L;P=88;break}else{ga=L;ha=N;P=89;break}else{f[D>>2]=M+1;ia=f[N+4+(M<<2)>>2]|0;break}}else{fa=f[C>>2]|0;P=88}while(0);if((P|0)==88){P=0;XZb(A,fa+1|0);N=f[B>>2]|0;ga=f[N>>2]|0;ha=N;P=89}if((P|0)==89){P=0;f[ha>>2]=ga+1;N=f[A>>2]|0;if(!N){M=$Xc(24)|0;ncc(M);ja=M}else{if(f[N+64>>2]|0)SXb(N,21240,24);M=QXb(N,24)|0;occ(M,N);ja=M}M=f[B>>2]|0;N=f[D>>2]|0;f[D>>2]=N+1;f[M+4+(N<<2)>>2]=ja;ia=ja}N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0?(M=b[N>>0]|0,M<<24>>24>-1):0){f[c>>2]=N+1;ka=M&255}else{M=YYb(c)|0;if((M|0)>-1)ka=M;else{U=0;P=131;break a}}JYb(e,c,ka);if((f[E>>2]|0)<0){P=101;break a}if(!(Mi[f[(f[ia>>2]|0)+44>>2]&1023](ia,c)|0)){P=101;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 9:{if((O&255|0)!=74){R=O;break b}M=f[G>>2]|0;do if(M){N=f[I>>2]|0;L=f[M>>2]|0;if((N|0)>=(L|0))if((L|0)==(f[H>>2]|0)){la=L;P=109;break}else{ma=L;na=M;P=110;break}else{f[I>>2]=N+1;oa=f[M+4+(N<<2)>>2]|0;break}}else{la=f[H>>2]|0;P=109}while(0);if((P|0)==109){P=0;XZb(F,la+1|0);M=f[G>>2]|0;ma=f[M>>2]|0;na=M;P=110}if((P|0)==110){P=0;f[na>>2]=ma+1;M=f[F>>2]|0;if(!M){N=$Xc(24)|0;Bdc(N);pa=N}else{if(f[M+64>>2]|0)SXb(M,21304,24);N=QXb(M,24)|0;Ddc(N,M);pa=N}N=f[G>>2]|0;M=f[I>>2]|0;f[I>>2]=M+1;f[N+4+(M<<2)>>2]=pa;oa=pa}M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(N=b[M>>0]|0,N<<24>>24>-1):0){f[c>>2]=M+1;qa=N&255}else{N=YYb(c)|0;if((N|0)>-1)qa=N;else{U=0;P=131;break a}}JYb(e,c,qa);if((f[J>>2]|0)<0){P=122;break a}if(!(Mi[f[(f[oa>>2]|0)+44>>2]&1023](oa,c)|0)){P=122;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{U=0;P=131;break a}break}case 10:{if((O&255|0)!=82){R=O;break b}if(l$b(c,pHa(K)|0)|0)continue a;else{U=0;P=131;break a}break}default:{R=O;break b}}while(0)}while(0);if(!R){U=1;P=131;break}N=f[j>>2]|0;if(!(N&1))ra=lSa(j)|0;else ra=N&-2;if(!(Lqc(c,R,ra)|0)){U=0;P=131;break}}if((P|0)==21){U=0;u=d;return U|0}else if((P|0)==30){U=0;u=d;return U|0}else if((P|0)==39){U=0;u=d;return U|0}else if((P|0)==60){U=0;u=d;return U|0}else if((P|0)==69){U=0;u=d;return U|0}else if((P|0)==80){U=0;u=d;return U|0}else if((P|0)==101){U=0;u=d;return U|0}else if((P|0)==122){U=0;u=d;return U|0}else if((P|0)==131){u=d;return U|0}return 0}function ldc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+36>>2]|0;c=i+g|0;if(!i)k=c;else{g=a+44|0;h=0;d=c;while(1){c=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;e=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;c=e+d+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(i|0)){k=c;break}else d=c}}d=f[a+52>>2]|0;i=d+k|0;if(!d)l=i;else{k=a+60|0;h=0;g=i;while(1){i=f[(f[k>>2]|0)+4+(h<<2)>>2]|0;c=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=c+g+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(d|0)){l=i;break}else g=i}}g=f[a+68>>2]|0;d=g+l|0;if(!g)m=d;else{l=a+76|0;h=0;k=d;while(1){d=f[(f[l>>2]|0)+4+(h<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=i+k+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(g|0)){m=d;break}else k=d}}k=f[a+84>>2]|0;g=k+m|0;if(!k)n=g;else{m=a+92|0;h=0;l=g;while(1){g=f[(f[m>>2]|0)+4+(h<<2)>>2]|0;d=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;g=d+l+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(k|0)){n=g;break}else l=g}}l=f[a+100>>2]|0;k=l+n|0;if(!l)o=k;else{n=a+108|0;h=0;m=k;while(1){k=f[(f[n>>2]|0)+4+(h<<2)>>2]|0;g=_i[f[(f[k>>2]|0)+48>>2]&2047](k)|0;k=g+m+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(l|0)){o=k;break}else m=k}}m=f[a+116>>2]|0;l=m+o|0;if(!m)p=l;else{o=a+124|0;h=0;n=l;while(1){l=f[(f[o>>2]|0)+4+(h<<2)>>2]|0;k=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;l=k+n+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(m|0)){p=l;break}else n=l}}n=f[a+132>>2]|0;m=n+p|0;if((n|0)>0){p=f[a+140>>2]|0;h=0;o=m;while(1){l=f[p+4+(h<<2)>>2]|0;k=b[l+11>>0]|0;g=k<<24>>24<0?f[l+4>>2]|0:k&255;k=g+o+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(n|0)){q=k;break}else o=k}}else q=m;m=f[a+8>>2]|0;if(!(m&3)){r=q;s=a+12|0;f[s>>2]=r;return r|0}if(!(m&1))t=q;else{o=f[a+144>>2]|0;n=b[o+11>>0]|0;h=n<<24>>24<0?f[o+4>>2]|0:n&255;t=q+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&2)){r=t;s=a+12|0;f[s>>2]=r;return r|0}m=f[a+148>>2]|0;h=_i[f[(f[m>>2]|0)+48>>2]&2047](m)|0;r=t+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;s=a+12|0;f[s>>2]=r;return r|0}function mdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+144>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{k$b(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+36>>2]|0;if(d|0){g=a+44|0;e=0;do{k$b(3,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{k$b(4,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+68>>2]|0;if(d|0){g=a+76|0;e=0;do{k$b(5,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+84>>2]|0;if(d|0){e=a+92|0;g=0;do{k$b(6,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)k$b(7,f[a+148>>2]|0,b);c=f[a+100>>2]|0;if(c|0){d=a+108|0;g=0;do{k$b(8,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+116>>2]|0;if(c|0){g=a+124|0;d=0;do{k$b(9,f[(f[g>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+132>>2]|0;if((c|0)>0){d=a+140|0;g=0;do{e$b(10,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function ndc(a){a=a|0;return f[a+12>>2]|0}function odc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+144>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}d=f[a+20>>2]|0;if(!d)i=g;else{h=a+28|0;j=0;k=g;while(1){g=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=18;l=k+1|0;m=_i[f[(f[g>>2]|0)+60>>2]&2047](g)|0;if(m>>>0>127){n=m;o=l;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=l;s=m}b[r>>0]=s;o=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,r+1|0)|0;j=j+1|0;if((j|0)==(d|0)){i=o;break}else k=o}}k=f[a+36>>2]|0;if(!k)t=i;else{d=a+44|0;j=0;r=i;while(1){i=f[(f[d>>2]|0)+4+(j<<2)>>2]|0;b[r>>0]=26;s=r+1|0;h=_i[f[(f[i>>2]|0)+60>>2]&2047](i)|0;if(h>>>0>127){o=h;n=s;while(1){b[n>>0]=o|128;p=o>>>7;q=n+1|0;if(o>>>0>16383){o=p;n=q}else{u=q;v=p;break}}}else{u=s;v=h}b[u>>0]=v;n=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,u+1|0)|0;j=j+1|0;if((j|0)==(k|0)){t=n;break}else r=n}}r=f[a+52>>2]|0;if(!r)w=t;else{k=a+60|0;j=0;u=t;while(1){t=f[(f[k>>2]|0)+4+(j<<2)>>2]|0;b[u>>0]=34;v=u+1|0;d=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(d>>>0>127){n=d;o=v;while(1){b[o>>0]=n|128;g=n>>>7;m=o+1|0;if(n>>>0>16383){n=g;o=m}else{x=m;y=g;break}}}else{x=v;y=d}b[x>>0]=y;o=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;j=j+1|0;if((j|0)==(r|0)){w=o;break}else u=o}}u=f[a+68>>2]|0;if(!u)z=w;else{r=a+76|0;j=0;x=w;while(1){w=f[(f[r>>2]|0)+4+(j<<2)>>2]|0;b[x>>0]=42;y=x+1|0;k=_i[f[(f[w>>2]|0)+60>>2]&2047](w)|0;if(k>>>0>127){o=k;n=y;while(1){b[n>>0]=o|128;i=o>>>7;h=n+1|0;if(o>>>0>16383){o=i;n=h}else{A=h;B=i;break}}}else{A=y;B=k}b[A>>0]=B;n=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,A+1|0)|0;j=j+1|0;if((j|0)==(u|0)){z=n;break}else x=n}}x=f[a+84>>2]|0;if(!x)C=z;else{u=a+92|0;j=0;A=z;while(1){z=f[(f[u>>2]|0)+4+(j<<2)>>2]|0;b[A>>0]=50;B=A+1|0;r=_i[f[(f[z>>2]|0)+60>>2]&2047](z)|0;if(r>>>0>127){n=r;o=B;while(1){b[o>>0]=n|128;t=n>>>7;d=o+1|0;if(n>>>0>16383){n=t;o=d}else{D=d;E=t;break}}}else{D=B;E=r}b[D>>0]=E;o=hj[f[(f[z>>2]|0)+64>>2]&511](z,c,D+1|0)|0;j=j+1|0;if((j|0)==(x|0)){C=o;break}else A=o}}if(!(e&2))F=C;else{e=f[a+148>>2]|0;b[C>>0]=58;A=C+1|0;C=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(C>>>0>127){x=C;j=A;while(1){b[j>>0]=x|128;D=x>>>7;E=j+1|0;if(x>>>0>16383){x=D;j=E}else{G=E;H=D;break}}}else{G=A;H=C}b[G>>0]=H;F=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,G+1|0)|0}G=f[a+100>>2]|0;if(!G)I=F;else{e=a+108|0;H=0;C=F;while(1){F=f[(f[e>>2]|0)+4+(H<<2)>>2]|0;b[C>>0]=66;A=C+1|0;j=_i[f[(f[F>>2]|0)+60>>2]&2047](F)|0;if(j>>>0>127){x=j;D=A;while(1){b[D>>0]=x|128;E=x>>>7;u=D+1|0;if(x>>>0>16383){x=E;D=u}else{J=u;K=E;break}}}else{J=A;K=j}b[J>>0]=K;D=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,J+1|0)|0;H=H+1|0;if((H|0)==(G|0)){I=D;break}else C=D}}C=f[a+116>>2]|0;if(!C)L=I;else{G=a+124|0;H=0;J=I;while(1){I=f[(f[G>>2]|0)+4+(H<<2)>>2]|0;b[J>>0]=74;K=J+1|0;e=_i[f[(f[I>>2]|0)+60>>2]&2047](I)|0;if(e>>>0>127){D=e;x=K;while(1){b[x>>0]=D|128;z=D>>>7;r=x+1|0;if(D>>>0>16383){D=z;x=r}else{M=r;N=z;break}}}else{M=K;N=e}b[M>>0]=N;x=hj[f[(f[I>>2]|0)+64>>2]&511](I,c,M+1|0)|0;H=H+1|0;if((H|0)==(C|0)){L=x;break}else J=x}}J=f[a+132>>2]|0;if((J|0)>0){C=a+140|0;H=0;M=L;while(1){c=f[(f[C>>2]|0)+4+(H<<2)>>2]|0;b[M>>0]=82;N=gZb(c,M+1|0)|0;H=H+1|0;if((H|0)==(J|0)){O=N;break}else M=N}}else O=L;L=f[a+4>>2]|0;if(!(L&1)){P=O;return P|0}P=Pqc(L&-2,O)|0;return P|0}function pdc(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;idc(a);c=kZc(b,21568,21288,0)|0;if(!c){Ooc(b,a);return}else{tdc(a,c);return}}function qdc(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21288,0)|0;if(!c){Ooc(b,a);return}else{tdc(a,c);return}}function rdc(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function sdc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538904;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function tdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}udc(a+16|0,b+16|0);vdc(a+32|0,b+32|0);wdc(a+48|0,b+48|0);xdc(a+64|0,b+64|0);udc(a+80|0,b+80|0);ydc(a+96|0,b+96|0);zdc(a+112|0,b+112|0);vSa(a+128|0,b+128|0);d=f[b+8>>2]|0;if(!(d&3))return;do if(d&1|0){g=f[b+144>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+144|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,g);break}else{oYc(i,g)|0;break}}while(0);if(!(d&2))return;d=a+8|0;f[d>>2]=f[d>>2]|2;d=a+148|0;j=f[d>>2]|0;if(!j){Adc(a);k=f[d>>2]|0}else k=j;j=f[b+148>>2]|0;v9b(k,j|0?j:538200);return}function udc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{uec(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(56)|0;Icc(l);uec(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21256,56);l=QXb(i,56)|0;Jcc(l,i);uec(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function vdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{sec(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(152)|0;rec(l);sec(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21288,152);l=QXb(i,152)|0;tec(l,i);sec(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function wdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{qec(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(72)|0;Ubc(l);qec(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21208,72);l=QXb(i,72)|0;Vbc(l,i);qec(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function xdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Xdc(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(28)|0;Wdc(l);Xdc(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21320,32);l=QXb(i,32)|0;Ydc(l,i);Xdc(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ydc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Vdc(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(24)|0;ncc(l);Vdc(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21240,24);l=QXb(i,24)|0;occ(l,i);Vdc(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function zdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Cdc(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(24)|0;Bdc(l);Cdc(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21304,24);l=QXb(i,24)|0;Ddc(l,i);Cdc(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Adc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(52)|0;w9b(c);e=c;g=a+148|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21128,56);c=QXb(d,56)|0;x9b(c,d);e=c;g=a+148|0;f[g>>2]=e;return}function Bdc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=170560;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=537592?(f[223550]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=140;b[d+8>>0]=0;J_b(894200,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Cdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[a+8>>2]|0;if(!(d&3))return;if(d&1|0)f[b+16>>2]=f[a+16>>2];if(d&2|0)f[b+20>>2]=f[a+20>>2];a=b+8|0;f[a>>2]=f[a>>2]|d;return}function Ddc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=170560;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223550]|0)!=2){f[e>>2]=165456;f[e+4>>2]=140;b[e+8>>0]=0;J_b(894200,e);a_b(e)}f[a+12>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;u=d;return}function Edc(a){a=a|0;var b=0,c=0;f[a>>2]=170560;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Fdc(a){a=a|0;var b=0,c=0;f[a>>2]=170560;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Gdc(a){a=a|0;a=$Xc(24)|0;Bdc(a);return a|0}function Hdc(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(24)|0;Bdc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21304,24);a=QXb(b,24)|0;Ddc(a,b);c=a;return c|0}function Idc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function Jdc(a){a=a|0;return f[a+4>>2]|0}function Kdc(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Ldc(a){a=a|0;return 1}function Mdc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=KYb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=KYb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=lSa(i)|0;else u=a&-2;if(!(Lqc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function Ndc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function Odc(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)S_b(1,f[a+16>>2]|0,b);if(c&2|0)S_b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Pdc(a){a=a|0;return f[a+12>>2]|0}function Qdc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=l1c(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function Rdc(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Sdc(a,b);return}function Sdc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,21304,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function Tdc(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Udc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538896;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Vdc(a,b){a=a|0;b=b|0;lcc(b,a);return}function Wdc(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=170668;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=537560?(f[223549]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=139;b[d+8>>0]=0;J_b(894196,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function Xdc(a,b){a=a|0;b=b|0;oec(b,a);return}function Ydc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=170668;f[a+4>>2]=c;f[a+8>>2]=0;if((f[223549]|0)!=2){f[e>>2]=165456;f[e+4>>2]=139;b[e+8>>0]=0;J_b(894196,e);a_b(e)}e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;u=d;return}function Zdc(a){a=a|0;var b=0,c=0;f[a>>2]=170668;if((a|0)!=537560?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function _dc(a){a=a|0;var b=0,c=0;f[a>>2]=170668;if((a|0)!=537560?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function $dc(a){a=a|0;a=$Xc(28)|0;Wdc(a);return a|0}function aec(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(28)|0;Wdc(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21320,32);a=QXb(b,32)|0;Ydc(a,b);c=a;return c|0}function bec(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function cec(a){a=a|0;return f[a+4>>2]|0}function dec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+8|0;c=f[b>>2]|0;if(c&1|0){d=f[a+16>>2]|0;Ksc(d+4|0);e=d+36|0;g=f[e>>2]|0;if((g|0)>0){h=f[d+44>>2]|0;i=0;do{i6b(f[h+4+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0));f[e>>2]=0}f[d+24>>2]=0;e=f[d+20>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d)}if(c&6|0){c=a+20|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function eec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;if(!(f[a+8>>2]&1)){b=1;return b|0}c=f[a+16>>2]|0;if(!(Psc(c+4|0)|0)){b=0;return b|0}a=f[c+36>>2]|0;if((a|0)<=0){b=1;return b|0}d=f[c+44>>2]|0;c=a;a:while(1){a=c;c=c+-1|0;e=f[d+4+(c<<2)>>2]|0;g=f[e+28>>2]|0;h=f[e+20>>2]|0;while(1){if((h|0)<=0)break;h=h+-1|0;if((f[(f[g+4+(h<<2)>>2]|0)+8>>2]&3|0)!=3){b=0;i=9;break a}}if((a|0)<=1){b=1;i=9;break}}if((i|0)==9)return b|0;return 0}function fec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+24|0;k=a+16|0;l=e+4|0;m=a+4|0;a:while(1){n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=n+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=ZYb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=8){t=q;break b}f[h>>2]=f[h>>2]|2;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){n=b[p>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=p+1;v=o}else{w=o;r=11}}else{w=0;r=11}if((r|0)==11){r=0;o=KYb(c,w)|0;p=J;if((p|0)>-1|(p|0)==-1&o>>>0>4294967295)v=o;else{x=0;r=35;break a}}f[i>>2]=v;continue a;break}case 2:{if((q&255|0)!=16){t=q;break b}f[h>>2]=f[h>>2]|4;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;n=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;y=n}else{z=n;r=17}}else{z=0;r=17}if((r|0)==17){r=0;n=KYb(c,z)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)y=n;else{x=0;r=35;break a}}f[j>>2]=y;continue a;break}case 3:{if((q&255|0)!=26){t=q;break b}f[h>>2]=f[h>>2]|1;n=f[k>>2]|0;if(!n){pec(a);A=f[k>>2]|0}else A=n;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;B=o&255}else{o=YYb(c)|0;if((o|0)>-1)B=o;else{x=0;r=35;break a}}JYb(e,c,B);if((f[l>>2]|0)<0){r=28;break a}if(!(Mi[f[(f[A>>2]|0)+44>>2]&1023](A,c)|0)){r=28;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{x=0;r=35;break a}break}default:{t=q;break b}}}while(0);if(!t){x=1;r=35;break}o=f[m>>2]|0;if(!(o&1))C=lSa(m)|0;else C=o&-2;if(!(Lqc(c,t,C)|0)){x=0;r=35;break}}if((r|0)==28){x=0;u=d;return x|0}else if((r|0)==35){u=d;return x|0}return 0}function gec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&7)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2))k=h;else{b=f[a+20>>2]|0;if((b|0)<0)l=11;else l=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=l+h|0}if(!(i&4)){e=k;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+24>>2]|0;if((i|0)<0)m=11;else m=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=m+k|0;g=a+12|0;f[g>>2]=e;return e|0}function hec(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)S_b(1,f[a+20>>2]|0,b);if(c&4|0)S_b(2,f[a+24>>2]|0,b);if(c&1|0)k$b(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function iec(a){a=a|0;return f[a+12>>2]|0}function jec(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&4))r=g;else{p=f[a+24>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=l1c(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&1))u=r;else{e=f[a+16>>2]|0;b[r>>0]=26;s=r+1|0;r=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(r>>>0>127){t=r;g=s;while(1){b[g>>0]=t|128;q=t>>>7;k=g+1|0;if(t>>>0>16383){t=q;g=k}else{v=k;w=q;break}}}else{v=s;w=r}b[v>>0]=w;u=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,v+1|0)|0}v=f[a+4>>2]|0;if(!(v&1)){x=u;return x|0}x=Pqc(v&-2,u)|0;return x|0}function kec(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;dec(a);c=kZc(b,21568,21320,0)|0;if(!c){Ooc(b,a);return}else{oec(a,c);return}}function lec(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21320,0)|0;if(!c){Ooc(b,a);return}else{oec(a,c);return}}function mec(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function nec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538888;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function oec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){pec(a);h=f[g>>2]|0}else h=e;e=f[b+16>>2]|0;g=e|0?e:537768;Lsc(h+4|0,g+4|0);e=h+20|0;c=f[g+20>>2]|0;if(c&1|0){i=f[e>>2]|0;if(!(i&1))j=lSa(e)|0;else j=i&-2;vqc(j,c&-2)}k7b(h+32|0,g+32|0)}if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function pec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(48)|0;adc(c);e=c;g=a+16|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21272,48);c=QXb(d,48)|0;bdc(c,d);e=c;g=a+16|0;f[g>>2]=e;return}function qec(a,b){a=a|0;b=b|0;vbc(b,a);return}function rec(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=170452;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==537616;g=a+16|0;h=g+128|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223551]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=141;b[d+8>>0]=0;J_b(894204,d);a_b(d)}f[a+12>>2]=0;f[a+144>>2]=537368;f[a+148>>2]=0;u=c;return}function sec(a,b){a=a|0;b=b|0;tdc(b,a);return}function tec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[a>>2]=170452;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=c;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=c;f[a+84>>2]=0;f[a+88>>2]=0;f[a+92>>2]=0;f[a+96>>2]=c;f[a+100>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=c;f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=c;f[a+132>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;if((f[223551]|0)==2){g=a+12|0;f[g>>2]=0;h=a+144|0;f[h>>2]=537368;i=a+148|0;f[i>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=141;b[e+8>>0]=0;J_b(894204,e);a_b(e);g=a+12|0;f[g>>2]=0;h=a+144|0;f[h>>2]=537368;i=a+148|0;f[i>>2]=0;u=d;return}function uec(a,b){a=a|0;b=b|0;Gcc(b,a);return}function vec(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=170776;Tec(a);c=f[a+116>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+104>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+92|0;d=f[c>>2]|0;if(d|0?(f[a+80>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+76|0;i=f[c>>2]|0;if(i|0?(f[a+64>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+60|0;j=f[c>>2]|0;if(j|0?(f[a+48>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+44|0;k=f[c>>2]|0;if(k|0?(f[a+32>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;cYc(l)}f[c>>2]=0;c=a+28|0;l=f[c>>2]|0;if(l|0?(f[a+16>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;cYc(m)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}m=a&-2;a=m;if((m|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(m);f[c>>2]=0;return}function wec(a){a=a|0;vec(a);cYc(a);return}function xec(a){a=a|0;a=$Xc(140)|0;Rec(a);return a|0}function yec(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(140)|0;Rec(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,21336,144);a=QXb(b,144)|0;Sec(a,b);c=a;return c|0}function zec(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function Aec(a){a=a|0;return f[a+4>>2]|0}function Bec(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{idc(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+52|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+60>>2]|0;g=0;do{kbc(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+68|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+76>>2]|0;e=0;do{uac(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+84|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+92>>2]|0;g=0;do{vcc(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+96>>2]=0;f[a+108>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&31|0){do if(d&1|0?(g=f[a+120>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0?(e=f[a+124>>2]|0,(e|0)!=537368):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0?(g=f[a+128>>2]|0,(g|0)!=537368):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&8|0)E9b(f[a+132>>2]|0);if(d&16|0){d=f[a+136>>2]|0;e=d+20|0;g=f[e>>2]|0;if((g|0)>0){i=f[d+28>>2]|0;h=0;do{Q5b(f[i+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(g|0));f[e>>2]=0}f[d+8>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Cec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;if(!(jdc(f[(f[b>>2]|0)+4+(c<<2)>>2]|0)|0)){d=0;e=29;break}}if((e|0)==29)return d|0;c=a+60|0;b=f[a+52>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;if(!(lbc(f[(f[c>>2]|0)+4+(b<<2)>>2]|0)|0)){d=0;e=29;break}}if((e|0)==29)return d|0;b=a+76|0;c=f[a+68>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;if(!(vac(f[(f[b>>2]|0)+4+(c<<2)>>2]|0)|0)){d=0;e=29;break}}if((e|0)==29)return d|0;c=f[a+84>>2]|0;a:do if((c|0)>0){b=a+92|0;g=c;b:while(1){h=g;g=g+-1|0;i=f[(f[b>>2]|0)+4+(g<<2)>>2]|0;if(f[i+8>>2]&32|0){j=f[i+36>>2]|0;if(!(Psc(j+4|0)|0)){d=0;e=29;break}i=f[j+36>>2]|0;if((i|0)>0){k=f[j+44>>2]|0;j=i;do{i=j;j=j+-1|0;l=f[k+4+(j<<2)>>2]|0;m=f[l+28>>2]|0;n=f[l+20>>2]|0;while(1){if((n|0)<=0)break;n=n+-1|0;if((f[(f[m+4+(n<<2)>>2]|0)+8>>2]&3|0)!=3){d=0;e=29;break b}}}while((i|0)>1)}}if((h|0)<=1)break a}if((e|0)==29)return d|0}while(0);if(!(f[a+8>>2]&8)){d=1;return d|0}c=f[a+132>>2]|0;if(!(Psc(c+4|0)|0)){d=0;return d|0}a=f[c+36>>2]|0;if((a|0)<=0){d=1;return d|0}g=f[c+44>>2]|0;c=a;c:while(1){a=c;c=c+-1|0;b=f[g+4+(c<<2)>>2]|0;j=f[b+28>>2]|0;k=f[b+20>>2]|0;while(1){if((k|0)<=0)break;k=k+-1|0;if((f[(f[j+4+(k<<2)>>2]|0)+8>>2]&3|0)!=3){d=0;e=29;break c}}if((a|0)<=1){d=1;e=29;break}}if((e|0)==29)return d|0;return 0}function Dec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+120|0;j=a+4|0;k=a+124|0;l=a+16|0;m=a+32|0;n=e+4|0;o=a+48|0;p=e+4|0;q=a+64|0;r=a+76|0;s=a+72|0;t=a+68|0;v=e+4|0;w=a+80|0;x=e+4|0;y=a+132|0;z=e+4|0;A=a+136|0;B=e+4|0;C=a+96|0;D=a+100|0;E=a+104|0;F=a+108|0;G=a+112|0;H=a+116|0;I=a+128|0;a:while(1){K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0){L=b[K>>0]|0;M=L&255;if(L<<24>>24>0){f[c>>2]=K+1;N=M;O=6}else{P=M;O=5}}else{P=0;O=5}if((O|0)==5){O=0;M=ZYb(c,P)|0;if((M+-1|0)>>>0<127){N=M;O=6}else Q=M}b:do if((O|0)==6){O=0;do switch(N>>>3&536870911|0){case 1:{if((N&255|0)!=10){Q=N;break b}f[h>>2]=f[h>>2]|1;M=f[j>>2]|0;K=M&-2;if(!(M&1))R=K;else R=f[K+4>>2]|0;K=f[i>>2]|0;if((K|0)==537368){xJa(i,R,537368);S=f[i>>2]|0}else S=K;if(l$b(c,S)|0)continue a;else{T=0;O=139;break a}break}case 2:{if((N&255|0)!=18){Q=N;break b}f[h>>2]=f[h>>2]|2;K=f[j>>2]|0;M=K&-2;if(!(K&1))U=M;else U=f[M+4>>2]|0;M=f[k>>2]|0;if((M|0)==537368){xJa(k,U,537368);V=f[k>>2]|0}else V=M;if(l$b(c,V)|0)continue a;else{T=0;O=139;break a}break}case 3:{if((N&255|0)!=26){Q=N;break b}if(l$b(c,pHa(l)|0)|0)continue a;else{T=0;O=139;break a}break}case 4:{if((N&255|0)!=34){Q=N;break b}M=V2b(m)|0;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(L=b[K>>0]|0,L<<24>>24>-1):0){f[c>>2]=K+1;W=L&255}else{L=YYb(c)|0;if((L|0)>-1)W=L;else{T=0;O=139;break a}}JYb(e,c,W);if((f[n>>2]|0)<0){O=30;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){O=30;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 5:{if((N&255|0)!=42){Q=N;break b}M=X2b(o)|0;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;X=K&255}else{K=YYb(c)|0;if((K|0)>-1)X=K;else{T=0;O=139;break a}}JYb(e,c,X);if((f[p>>2]|0)<0){O=39;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){O=39;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 6:{if((N&255|0)!=50){Q=N;break b}M=f[r>>2]|0;do if(M){K=f[t>>2]|0;L=f[M>>2]|0;if((K|0)>=(L|0))if((L|0)==(f[s>>2]|0)){Y=L;O=47;break}else{Z=L;_=M;O=48;break}else{f[t>>2]=K+1;$=f[M+4+(K<<2)>>2]|0;break}}else{Y=f[s>>2]|0;O=47}while(0);if((O|0)==47){O=0;XZb(q,Y+1|0);M=f[r>>2]|0;Z=f[M>>2]|0;_=M;O=48}if((O|0)==48){O=0;f[_>>2]=Z+1;M=f[q>>2]|0;if(!M){K=$Xc(40)|0;Jac(K);aa=K}else{if(f[M+64>>2]|0)SXb(M,21176,40);K=QXb(M,40)|0;Kac(K,M);aa=K}K=f[r>>2]|0;M=f[t>>2]|0;f[t>>2]=M+1;f[K+4+(M<<2)>>2]=aa;$=aa}M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(K=b[M>>0]|0,K<<24>>24>-1):0){f[c>>2]=M+1;ba=K&255}else{K=YYb(c)|0;if((K|0)>-1)ba=K;else{T=0;O=139;break a}}JYb(e,c,ba);if((f[v>>2]|0)<0){O=60;break a}if(!(Mi[f[(f[$>>2]|0)+44>>2]&1023]($,c)|0)){O=60;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 7:{if((N&255|0)!=58){Q=N;break b}K=_2b(w)|0;M=f[c>>2]|0;if(M>>>0<(f[g>>2]|0)>>>0?(L=b[M>>0]|0,L<<24>>24>-1):0){f[c>>2]=M+1;ca=L&255}else{L=YYb(c)|0;if((L|0)>-1)ca=L;else{T=0;O=139;break a}}JYb(e,c,ca);if((f[x>>2]|0)<0){O=69;break a}if(!(Mi[f[(f[K>>2]|0)+44>>2]&1023](K,c)|0)){O=69;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 8:{if((N&255|0)!=66){Q=N;break b}f[h>>2]=f[h>>2]|8;K=f[y>>2]|0;if(!K){Oec(a);da=f[y>>2]|0}else da=K;K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(L=b[K>>0]|0,L<<24>>24>-1):0){f[c>>2]=K+1;ea=L&255}else{L=YYb(c)|0;if((L|0)>-1)ea=L;else{T=0;O=139;break a}}JYb(e,c,ea);if((f[z>>2]|0)<0){O=80;break a}if(!(Mi[f[(f[da>>2]|0)+44>>2]&1023](da,c)|0)){O=80;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 9:{if((N&255|0)!=74){Q=N;break b}f[h>>2]=f[h>>2]|16;L=f[A>>2]|0;if(!L){Pec(a);fa=f[A>>2]|0}else fa=L;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;ga=K&255}else{K=YYb(c)|0;if((K|0)>-1)ga=K;else{T=0;O=139;break a}}JYb(e,c,ga);if((f[B>>2]|0)<0){O=91;break a}if(!(Mi[f[(f[fa>>2]|0)+44>>2]&1023](fa,c)|0)){O=91;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{T=0;O=139;break a}break}case 10:{switch((N&255)<<24>>24){case 80:break;case 82:{if(dkb(c,C)|0)continue a;else{T=0;O=139;break a}break}default:{Q=N;break b}}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0){L=b[K>>0]|0;M=L&255;if(L<<24>>24>-1){f[c>>2]=K+1;ha=M}else{ia=M;O=97}}else{ia=0;O=97}if((O|0)==97){O=0;M=KYb(c,ia)|0;K=J;if((K|0)>-1|(K|0)==-1&M>>>0>4294967295)ha=M;else{T=0;O=139;break a}}M=f[C>>2]|0;if((M|0)==(f[D>>2]|0)){qHa(C,M+1|0);ja=f[C>>2]|0}else ja=M;M=f[E>>2]|0;f[C>>2]=ja+1;f[M+4+(ja<<2)>>2]=ha;K=(f[D>>2]|0)-(f[C>>2]|0)|0;if((K|0)>0){ka=K;la=M}else continue a;while(1){M=f[c>>2]|0;K=f[g>>2]|0;if(M>>>0>=K>>>0)continue a;if((b[M>>0]|0)!=80)continue a;L=M+1|0;f[c>>2]=L;if(L>>>0<K>>>0){K=b[L>>0]|0;L=K&255;if(K<<24>>24>-1){f[c>>2]=M+2;ma=L;na=la}else{oa=L;O=105}}else{oa=0;O=105}if((O|0)==105){O=0;L=KYb(c,oa)|0;M=J;if(!((M|0)>-1|(M|0)==-1&L>>>0>4294967295)){T=0;O=139;break a}ma=L;na=f[E>>2]|0}L=f[C>>2]|0;f[C>>2]=L+1;f[na+4+(L<<2)>>2]=ma;if((ka|0)>1){ka=ka+-1|0;la=na}else continue a}break}case 11:{switch((N&255)<<24>>24){case 88:break;case 90:{if(dkb(c,F)|0)continue a;else{T=0;O=139;break a}break}default:{Q=N;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){M=b[L>>0]|0;K=M&255;if(M<<24>>24>-1){f[c>>2]=L+1;pa=K}else{qa=K;O=114}}else{qa=0;O=114}if((O|0)==114){O=0;K=KYb(c,qa)|0;L=J;if((L|0)>-1|(L|0)==-1&K>>>0>4294967295)pa=K;else{T=0;O=139;break a}}K=f[F>>2]|0;if((K|0)==(f[G>>2]|0)){qHa(F,K+1|0);ra=f[F>>2]|0}else ra=K;K=f[H>>2]|0;f[F>>2]=ra+1;f[K+4+(ra<<2)>>2]=pa;L=(f[G>>2]|0)-(f[F>>2]|0)|0;if((L|0)>0){sa=L;ta=K}else continue a;while(1){K=f[c>>2]|0;L=f[g>>2]|0;if(K>>>0>=L>>>0)continue a;if((b[K>>0]|0)!=88)continue a;M=K+1|0;f[c>>2]=M;if(M>>>0<L>>>0){L=b[M>>0]|0;M=L&255;if(L<<24>>24>-1){f[c>>2]=K+2;ua=M;va=ta}else{wa=M;O=122}}else{wa=0;O=122}if((O|0)==122){O=0;M=KYb(c,wa)|0;K=J;if(!((K|0)>-1|(K|0)==-1&M>>>0>4294967295)){T=0;O=139;break a}ua=M;va=f[H>>2]|0}M=f[F>>2]|0;f[F>>2]=M+1;f[va+4+(M<<2)>>2]=ua;if((sa|0)>1){sa=sa+-1|0;ta=va}else continue a}break}case 12:{if((N&255|0)!=98){Q=N;break b}f[h>>2]=f[h>>2]|4;M=f[j>>2]|0;K=M&-2;if(!(M&1))xa=K;else xa=f[K+4>>2]|0;K=f[I>>2]|0;if((K|0)==537368){xJa(I,xa,537368);ya=f[I>>2]|0}else ya=K;if(l$b(c,ya)|0)continue a;else{T=0;O=139;break a}break}default:{Q=N;break b}}while(0)}while(0);if(!Q){T=1;O=139;break}K=f[j>>2]|0;if(!(K&1))za=lSa(j)|0;else za=K&-2;if(!(Lqc(c,Q,za)|0)){T=0;O=139;break}}if((O|0)==30){T=0;u=d;return T|0}else if((O|0)==39){T=0;u=d;return T|0}else if((O|0)==60){T=0;u=d;return T|0}else if((O|0)==69){T=0;u=d;return T|0}else if((O|0)==80){T=0;u=d;return T|0}else if((O|0)==91){T=0;u=d;return T|0}else if((O|0)==139){u=d;return T|0}return 0}function Eec(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if(!e)m=h;else{l=a+44|0;c=0;g=h;while(1){h=f[(f[l>>2]|0)+4+(c<<2)>>2]|0;d=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;h=d+g+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=h;break}else g=h}}g=f[a+52>>2]|0;e=g+m|0;if(!g)n=e;else{m=a+60|0;c=0;l=e;while(1){e=f[(f[m>>2]|0)+4+(c<<2)>>2]|0;h=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=h+l+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(g|0)){n=e;break}else l=e}}l=f[a+68>>2]|0;g=l+n|0;if(!l)o=g;else{n=a+76|0;c=0;m=g;while(1){g=f[(f[n>>2]|0)+4+(c<<2)>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;g=e+m+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(l|0)){o=g;break}else m=g}}m=f[a+84>>2]|0;l=m+o|0;if(!m)p=l;else{o=a+92|0;c=0;n=l;while(1){l=f[(f[o>>2]|0)+4+(c<<2)>>2]|0;g=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;l=g+n+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(m|0)){p=l;break}else n=l}}n=n$b(a+96|0)|0;m=f[a+96>>2]|0;c=n$b(a+108|0)|0;o=n+p+m+c+(f[a+108>>2]|0)|0;c=a+8|0;m=f[c>>2]|0;if(!(m&31)){q=o;r=a+12|0;f[r>>2]=q;return q|0}if(!(m&1))s=o;else{p=f[a+120>>2]|0;n=b[p+11>>0]|0;l=n<<24>>24<0?f[p+4>>2]|0:n&255;s=o+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&2))t=s;else{l=f[a+124>>2]|0;o=b[l+11>>0]|0;n=o<<24>>24<0?f[l+4>>2]|0:o&255;t=s+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&4))u=t;else{n=f[a+128>>2]|0;s=b[n+11>>0]|0;o=s<<24>>24<0?f[n+4>>2]|0:s&255;u=t+1+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(m&8)){v=u;w=m}else{m=f[a+132>>2]|0;o=_i[f[(f[m>>2]|0)+48>>2]&2047](m)|0;m=u+1+o+((((($(o|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=m;w=f[c>>2]|0}if(!(w&16)){q=v;r=a+12|0;f[r>>2]=q;return q|0}w=f[a+136>>2]|0;c=_i[f[(f[w>>2]|0)+48>>2]&2047](w)|0;q=v+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=a+12|0;f[r>>2]=q;return q|0}function Fec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+120>>2]|0,b);if(c&2|0)f$b(2,f[a+124>>2]|0,b);d=f[a+20>>2]|0;if((d|0)>0){e=a+28|0;g=0;do{e$b(3,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+36>>2]|0;if(d|0){g=a+44|0;e=0;do{k$b(4,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{k$b(5,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+68>>2]|0;if(d|0){g=a+76|0;e=0;do{k$b(6,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+84>>2]|0;if(d|0){e=a+92|0;g=0;do{k$b(7,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&8|0)k$b(8,f[a+132>>2]|0,b);if(c&16|0)k$b(9,f[a+136>>2]|0,b);d=f[a+96>>2]|0;if((d|0)>0){g=a+104|0;e=0;do{S_b(10,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+108>>2]|0;if((d|0)>0){e=a+116|0;g=0;do{S_b(11,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&4|0)f$b(12,f[a+128>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Gec(a){a=a|0;return f[a+12>>2]|0}function Hec(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+120>>2]|0;b[d>>0]=10;g=gZb(h,d+1|0)|0}if(!(e&2))i=g;else{d=f[a+124>>2]|0;b[g>>0]=18;i=gZb(d,g+1|0)|0}g=f[a+20>>2]|0;if((g|0)>0){d=a+28|0;h=0;j=i;while(1){k=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;b[j>>0]=26;l=gZb(k,j+1|0)|0;h=h+1|0;if((h|0)==(g|0)){m=l;break}else j=l}}else m=i;i=f[a+36>>2]|0;if(!i)n=m;else{j=a+44|0;g=0;h=m;while(1){m=f[(f[j>>2]|0)+4+(g<<2)>>2]|0;b[h>>0]=34;d=h+1|0;l=_i[f[(f[m>>2]|0)+60>>2]&2047](m)|0;if(l>>>0>127){k=l;o=d;while(1){b[o>>0]=k|128;p=k>>>7;q=o+1|0;if(k>>>0>16383){k=p;o=q}else{r=q;s=p;break}}}else{r=d;s=l}b[r>>0]=s;o=hj[f[(f[m>>2]|0)+64>>2]&511](m,c,r+1|0)|0;g=g+1|0;if((g|0)==(i|0)){n=o;break}else h=o}}h=f[a+52>>2]|0;if(!h)t=n;else{i=a+60|0;g=0;r=n;while(1){n=f[(f[i>>2]|0)+4+(g<<2)>>2]|0;b[r>>0]=42;s=r+1|0;j=_i[f[(f[n>>2]|0)+60>>2]&2047](n)|0;if(j>>>0>127){o=j;k=s;while(1){b[k>>0]=o|128;p=o>>>7;q=k+1|0;if(o>>>0>16383){o=p;k=q}else{u=q;v=p;break}}}else{u=s;v=j}b[u>>0]=v;k=hj[f[(f[n>>2]|0)+64>>2]&511](n,c,u+1|0)|0;g=g+1|0;if((g|0)==(h|0)){t=k;break}else r=k}}r=f[a+68>>2]|0;if(!r)w=t;else{h=a+76|0;g=0;u=t;while(1){t=f[(f[h>>2]|0)+4+(g<<2)>>2]|0;b[u>>0]=50;v=u+1|0;i=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(i>>>0>127){k=i;o=v;while(1){b[o>>0]=k|128;m=k>>>7;l=o+1|0;if(k>>>0>16383){k=m;o=l}else{x=l;y=m;break}}}else{x=v;y=i}b[x>>0]=y;o=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;g=g+1|0;if((g|0)==(r|0)){w=o;break}else u=o}}u=f[a+84>>2]|0;if(!u)z=w;else{r=a+92|0;g=0;x=w;while(1){w=f[(f[r>>2]|0)+4+(g<<2)>>2]|0;b[x>>0]=58;y=x+1|0;h=_i[f[(f[w>>2]|0)+60>>2]&2047](w)|0;if(h>>>0>127){o=h;k=y;while(1){b[k>>0]=o|128;n=o>>>7;j=k+1|0;if(o>>>0>16383){o=n;k=j}else{A=j;B=n;break}}}else{A=y;B=h}b[A>>0]=B;k=hj[f[(f[w>>2]|0)+64>>2]&511](w,c,A+1|0)|0;g=g+1|0;if((g|0)==(u|0)){z=k;break}else x=k}}if(!(e&8))C=z;else{x=f[a+132>>2]|0;b[z>>0]=66;u=z+1|0;z=_i[f[(f[x>>2]|0)+60>>2]&2047](x)|0;if(z>>>0>127){g=z;A=u;while(1){b[A>>0]=g|128;B=g>>>7;r=A+1|0;if(g>>>0>16383){g=B;A=r}else{D=r;E=B;break}}}else{D=u;E=z}b[D>>0]=E;C=hj[f[(f[x>>2]|0)+64>>2]&511](x,c,D+1|0)|0}if(!(e&16))F=C;else{D=f[a+136>>2]|0;b[C>>0]=74;x=C+1|0;C=_i[f[(f[D>>2]|0)+60>>2]&2047](D)|0;if(C>>>0>127){E=C;z=x;while(1){b[z>>0]=E|128;u=E>>>7;A=z+1|0;if(E>>>0>16383){E=u;z=A}else{G=A;H=u;break}}}else{G=x;H=C}b[G>>0]=H;F=hj[f[(f[D>>2]|0)+64>>2]&511](D,c,G+1|0)|0}G=f[a+96>>2]|0;if(!G)I=F;else{c=f[a+104>>2]|0;D=0;H=F;while(1){F=f[c+4+(D<<2)>>2]|0;b[H>>0]=80;C=H+1|0;x=F&255;if(F>>>0>127){z=C;E=x;u=F;A=((F|0)<0)<<31>>31;while(1){b[z>>0]=E|-128;F=u;u=l1c(u|0,A|0,7)|0;g=z+1|0;B=u&255;if(!(A>>>0>0|(A|0)==0&F>>>0>16383)){K=g;L=z;M=B;break}else{z=g;E=B;A=J}}}else{K=C;L=H;M=x}b[K>>0]=M;A=L+2|0;D=D+1|0;if((D|0)>=(G|0)){I=A;break}else H=A}}H=f[a+108>>2]|0;if(!H)N=I;else{G=f[a+116>>2]|0;D=0;L=I;while(1){I=f[G+4+(D<<2)>>2]|0;b[L>>0]=88;M=L+1|0;K=I&255;if(I>>>0>127){c=M;A=K;E=I;z=((I|0)<0)<<31>>31;while(1){b[c>>0]=A|-128;I=E;E=l1c(E|0,z|0,7)|0;u=c+1|0;w=E&255;if(!(z>>>0>0|(z|0)==0&I>>>0>16383)){O=u;P=c;Q=w;break}else{c=u;A=w;z=J}}}else{O=M;P=L;Q=K}b[O>>0]=Q;z=P+2|0;D=D+1|0;if((D|0)>=(H|0)){N=z;break}else L=z}}if(!(e&4))R=N;else{e=f[a+128>>2]|0;b[N>>0]=98;R=gZb(e,N+1|0)|0}N=f[a+4>>2]|0;if(!(N&1)){S=R;return S|0}S=Pqc(N&-2,R)|0;return S|0}function Iec(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Bec(a);c=kZc(b,21568,21336,0)|0;if(!c){Ooc(b,a);return}else{Mec(a,c);return}}function Jec(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,21336,0)|0;if(!c){Ooc(b,a);return}else{Mec(a,c);return}}function Kec(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Lec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223545]|0)!=2){f[d>>2]=165456;f[d+4>>2]=135;b[d+8>>0]=0;J_b(894180,d);a_b(d)}d=538880;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Mec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}vSa(a+16|0,b+16|0);vdc(a+32|0,b+32|0);wdc(a+48|0,b+48|0);Nec(a+64|0,b+64|0);udc(a+80|0,b+80|0);d=a+96|0;g=b+96|0;e=f[g>>2]|0;if(e|0){qHa(d,(f[d>>2]|0)+e|0);o1c((f[a+104>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+104>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+108|0;d=b+108|0;e=f[d>>2]|0;if(e|0){qHa(g,(f[g>>2]|0)+e|0);o1c((f[a+116>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+116>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&31))return;do if(d&1|0){g=f[b+120>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;e=a+120|0;h=f[c>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==537368){xJa(e,j,g);break}else{oYc(i,g)|0;break}}while(0);do if(d&2|0){j=f[b+124>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+124|0;i=f[c>>2]|0;e=i&-2;if(!(i&1))k=e;else k=f[e+4>>2]|0;e=f[g>>2]|0;if((e|0)==537368){xJa(g,k,j);break}else{oYc(e,j)|0;break}}while(0);do if(d&4|0){k=f[b+128>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|4;j=a+128|0;e=f[c>>2]|0;g=e&-2;if(!(e&1))l=g;else l=f[g+4>>2]|0;g=f[j>>2]|0;if((g|0)==537368){xJa(j,l,k);break}else{oYc(g,k)|0;break}}while(0);if(d&8|0){l=a+8|0;f[l>>2]=f[l>>2]|8;l=a+132|0;c=f[l>>2]|0;if(!c){Oec(a);m=f[l>>2]|0}else m=c;c=f[b+132>>2]|0;P9b(m,c|0?c:538104)}if(!(d&16))return;d=a+8|0;f[d>>2]=f[d>>2]|16;d=a+136|0;c=f[d>>2]|0;if(!c){Pec(a);n=f[d>>2]|0}else n=c;c=f[b+136>>2]|0;b=c|0?c:538760;c=n+4|0;d=f[b+4>>2]|0;if(d&1|0){a=f[c>>2]|0;if(!(a&1))o=lSa(c)|0;else o=a&-2;vqc(o,d&-2)}G5b(n+16|0,b+16|0);return}function Nec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Qec(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(40)|0;Jac(l);Qec(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21176,40);l=QXb(i,40)|0;Kac(l,i);Qec(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Oec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(96)|0;Q9b(c);e=c;g=a+132|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,21144,96);c=QXb(d,96)|0;R9b(c,d);e=c;g=a+132|0;f[g>>2]=e;return}function Pec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(32)|0;a6b(c);e=c;g=a+136|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,20968,32);c=QXb(d,32)|0;b6b(c,d);e=c;g=a+136|0;f[g>>2]=e;return}function Qec(a,b){a=a|0;b=b|0;Fac(b,a);return}function Rec(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=170776;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==537416;g=a+16|0;h=g+104|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223548]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=138;b[d+8>>0]=0;J_b(894192,d);a_b(d)}f[a+12>>2]=0;f[a+120>>2]=537368;f[a+124>>2]=537368;f[a+128>>2]=537368;d=a+132|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function Sec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[a>>2]=170776;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=c;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=c;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=c;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=c;g=a+84|0;h=a+104|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;if(!c){f[a+108>>2]=0;f[a+112>>2]=0;f[a+116>>2]=0}else{if(f[c+64>>2]|0)SXb(c,25456,8);g=QXb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+108>>2]=0;f[a+112>>2]=0;g=a+116|0;f[g>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[223548]|0)==2){i=a+12|0;f[i>>2]=0;j=a+120|0;f[j>>2]=537368;k=a+124|0;f[k>>2]=537368;l=a+128|0;f[l>>2]=537368;m=a+132|0;n=m;o=n;f[o>>2]=0;p=n+4|0;q=p;f[q>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=138;b[e+8>>0]=0;J_b(894192,e);a_b(e);i=a+12|0;f[i>>2]=0;j=a+120|0;f[j>>2]=537368;k=a+124|0;f[k>>2]=537368;l=a+128|0;f[l>>2]=537368;m=a+132|0;n=m;o=n;f[o>>2]=0;p=n+4|0;q=p;f[q>>2]=0;u=d;return}function Tec(a){a=a|0;var c=0;c=f[a+120>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+124>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+128>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==537416)return;c=f[a+132>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+136>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function Uec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Vec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Wec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Xec(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Yec(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{Zec(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(140)|0;Rec(l);Zec(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,21336,144);l=QXb(i,144)|0;Sec(l,i);Zec(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function Zec(a,b){a=a|0;b=b|0;Mec(b,a);return}function _ec(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=167536;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=537384?(f[223547]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=137;b[d+8>>0]=0;J_b(894188,d);a_b(d)}f[a+12>>2]=0;u=c;return}function $ec(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=167536;f[a+4>>2]=c;f[a+8>>2]=0;f[a+16>>2]=c;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;if((f[223547]|0)==2){g=a+12|0;f[g>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=137;b[e+8>>0]=0;J_b(894188,e);a_b(e);g=a+12|0;f[g>>2]=0;u=d;return}function afc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223546]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=136;b[c+8>>0]=0;J_b(894184,c);a_b(c);u=a;return}function bfc(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[223545]|0)==2){d=f[223543]|0;u=a;return d|0}f[c>>2]=165456;f[c+4>>2]=135;b[c+8>>0]=0;J_b(894180,c);a_b(c);d=f[223543]|0;u=a;return d|0}function cfc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223552]|0)==2){u=a;return 537768}f[c>>2]=165456;f[c+4>>2]=142;b[c+8>>0]=0;J_b(894208,c);a_b(c);u=a;return 537768}function dfc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((b|0)==(a|0))return;c=a+4|0;Ksc(c);d=a+36|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+44>>2]|0;h=0;do{i6b(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[d>>2]=0}f[a+24>>2]=0;d=a+20|0;e=f[d>>2]|0;if(e&1|0?(h=e&-2,f[h>>2]|0):0)sqc(h);Lsc(c,b+4|0);c=f[b+20>>2]|0;if(c&1|0){h=f[d>>2]|0;if(!(h&1))i=lSa(d)|0;else i=h&-2;vqc(i,c&-2)}k7b(a+32|0,b+32|0);return}function efc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223560]|0)==2){u=a;return 538104}f[c>>2]=165456;f[c+4>>2]=150;b[c+8>>0]=0;J_b(894240,c);a_b(c);u=a;return 538104}function ffc(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;E9b(a);P9b(a,b);return}function gfc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223561]|0)==2){u=a;return 538200}f[c>>2]=165456;f[c+4>>2]=151;b[c+8>>0]=0;J_b(894244,c);a_b(c);u=a;return 538200}function hfc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+48>>2]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);v9b(a,b);return}function ifc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223562]|0)==2){u=a;return 538256}f[c>>2]=165456;f[c+4>>2]=152;b[c+8>>0]=0;J_b(894248,c);a_b(c);u=a;return 538256}function jfc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;if(f[c>>2]&63|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[c>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);b9b(a,b);return}function kfc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223563]|0)==2){u=a;return 538320}f[c>>2]=165456;f[c+4>>2]=153;b[c+8>>0]=0;J_b(894252,c);a_b(c);u=a;return 538320}function lfc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((b|0)==(a|0))return;c=a+4|0;Ksc(c);d=a+36|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+44>>2]|0;h=0;do{i6b(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[d>>2]=0}f[a+24>>2]=0;d=a+20|0;e=f[d>>2]|0;if(e&1|0?(h=e&-2,f[h>>2]|0):0)sqc(h);Lsc(c,b+4|0);c=f[b+20>>2]|0;if(c&1|0){h=f[d>>2]|0;if(!(h&1))i=lSa(d)|0;else i=h&-2;vqc(i,c&-2)}k7b(a+32|0,b+32|0);return}function mfc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223564]|0)==2){u=a;return 538368}f[c>>2]=165456;f[c+4>>2]=154;b[c+8>>0]=0;J_b(894256,c);a_b(c);u=a;return 538368}function nfc(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0;if((b|0)==(a|0))return;Ksc(a+4|0);c=a+36|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+44>>2]|0;h=0;do{i6b(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[c>>2]=0}d[a+48>>1]=0;f[a+24>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(e=c&-2,f[e>>2]|0):0)sqc(e);q8b(a,b);return}function ofc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223565]|0)==2){u=a;return 538424}f[c>>2]=165456;f[c+4>>2]=155;b[c+8>>0]=0;J_b(894260,c);a_b(c);u=a;return 538424}function pfc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((c|0)==(a|0))return;d=a+4|0;Ksc(d);e=a+36|0;g=f[e>>2]|0;if((g|0)>0){h=f[a+44>>2]|0;i=0;do{i6b(f[h+4+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0));f[e>>2]=0}e=a+48|0;b[e>>0]=0;g=a+24|0;f[g>>2]=0;i=a+20|0;h=f[i>>2]|0;if(h&1|0?(j=h&-2,f[j>>2]|0):0)sqc(j);Lsc(d,c+4|0);d=f[c+20>>2]|0;if(d&1|0){j=f[i>>2]|0;if(!(j&1))k=lSa(i)|0;else k=j&-2;vqc(k,d&-2)}k7b(a+32|0,c+32|0);if(!(f[c+24>>2]&1))return;a=b[c+48>>0]|0;f[g>>2]=f[g>>2]|1;b[e>>0]=a;return}function qfc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223566]|0)==2){u=a;return 538480}f[c>>2]=165456;f[c+4>>2]=156;b[c+8>>0]=0;J_b(894264,c);a_b(c);u=a;return 538480}function rfc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((c|0)==(a|0))return;d=a+4|0;Ksc(d);e=a+36|0;g=f[e>>2]|0;if((g|0)>0){h=f[a+44>>2]|0;i=0;do{i6b(f[h+4+(i<<2)>>2]|0);i=i+1|0}while((i|0)!=(g|0));f[e>>2]=0}e=a+48|0;b[e>>0]=0;g=a+24|0;f[g>>2]=0;i=a+20|0;h=f[i>>2]|0;if(h&1|0?(j=h&-2,f[j>>2]|0):0)sqc(j);Lsc(d,c+4|0);d=f[c+20>>2]|0;if(d&1|0){j=f[i>>2]|0;if(!(j&1))k=lSa(i)|0;else k=j&-2;vqc(k,d&-2)}k7b(a+32|0,c+32|0);if(!(f[c+24>>2]&1))return;a=b[c+48>>0]|0;f[g>>2]=f[g>>2]|1;b[e>>0]=a;return}function sfc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223567]|0)==2){u=a;return 538536}f[c>>2]=165456;f[c+4>>2]=157;b[c+8>>0]=0;J_b(894268,c);a_b(c);u=a;return 538536}function tfc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;Ksc(a+4|0);c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{i6b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;if(f[c>>2]&3|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+20>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);j7b(a,b);return}function ufc(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223571]|0)==2){u=a;return 538760}f[c>>2]=165456;f[c+4>>2]=161;b[c+8>>0]=0;J_b(894284,c);a_b(c);u=a;return 538760}function vfc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{Q5b(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=a+4|0;d=f[c>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=f[b+4>>2]|0;if(g&1|0){d=f[c>>2]|0;if(!(d&1))h=lSa(c)|0;else h=d&-2;vqc(h,g&-2)}G5b(a+16|0,b+16|0);return}function wfc(a,b){a=a|0;b=b|0;return 0}function xfc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=170920;b=a+40|0;c=a+44|0;d=f[c>>2]|0;e=f[b>>2]|0;g=e;if((d|0)==(e|0)){h=d;i=g}else{d=0;e=g;while(1){cYc(f[e+(d<<2)>>2]|0);d=d+1|0;g=f[c>>2]|0;j=f[b>>2]|0;k=j;if(d>>>0>=g-j>>2>>>0){h=g;i=k;break}else e=k}}e=h;if(i|0){if((e|0)!=(i|0))f[c>>2]=e+(~((e+-4-i|0)>>>2)<<2);cYc(i)}Kfc(a+28|0,f[a+32>>2]|0);Lfc(a+16|0,f[a+20>>2]|0);Lfc(a+4|0,f[a+8>>2]|0);return}function yfc(a){a=a|0;xfc(a);cYc(a);return}function zfc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=Jfc(a+4|0,b)|0;b=(g|0)==(a+8|0)?e:g+28|0;g=f[b>>2]|0;if(!g){h=0;u=d;return h|0}h=PZb(c,g,f[b+4>>2]|0)|0;u=d;return h|0}function Afc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;Hfc(e,a+4|0,b);b=f[e>>2]|0;if(!b){g=0;u=d;return g|0}g=PZb(c,b,f[e+4>>2]|0)|0;u=d;return g|0}function Bfc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+8|0;i=g;lYc(h,c);f[h+12>>2]=d;f[i>>2]=0;f[i+4>>2]=0;d=Ffc(a+28|0,h)|0;c=(d|0)==(a+32|0)?i:d+32|0;d=f[c>>2]|0;i=f[c+4>>2]|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if(!d){j=0;u=g;return j|0}j=PZb(e,d,i)|0;u=g;return j|0}function Cfc(a,b,c){a=a|0;b=b|0;c=c|0;return Dfc(a+4|0,b,c)|0}function Dfc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;lYc(g,c);f[g+12>>2]=0;h=a+28|0;i=Efc(a+24|0,g,f[h>>2]|0,h)|0;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((i|0)==(h|0)){j=0;u=e;return j|0}g=c+11|0;a=c+4|0;k=d+4|0;l=d+8|0;m=0;n=i;a:while(1){i=n+16|0;o=b[i+11>>0]|0;p=o<<24>>24<0;q=o&255;o=p?f[n+20>>2]|0:q;r=b[g>>0]|0;s=r<<24>>24<0;if((o|0)!=((s?f[a>>2]|0:r&255)|0)){j=m;t=22;break}r=f[i>>2]|0;v=p?r:i;w=s?f[c>>2]|0:c;s=(o|0)==0;b:do if(p){if(!s?WKc(v,w,o)|0:0){j=m;t=22;break a}}else if(!s){if((r&255)<<24>>24==(b[w>>0]|0)){x=i;y=q;z=w}else{j=m;t=22;break a}while(1){y=y+-1|0;x=x+1|0;if(!y)break b;z=z+1|0;if((b[x>>0]|0)!=(b[z>>0]|0)){j=m;t=22;break a}}}while(0);w=n+28|0;q=f[k>>2]|0;if((q|0)==(f[l>>2]|0))Tv(d,w);else{f[q>>2]=f[w>>2];f[k>>2]=q+4}q=f[n+4>>2]|0;if(!q){w=n+8|0;i=f[w>>2]|0;if((f[i>>2]|0)==(n|0))A=i;else{i=w;do{w=f[i>>2]|0;i=w+8|0;r=f[i>>2]|0}while((f[r>>2]|0)!=(w|0));A=r}}else{i=q;while(1){r=f[i>>2]|0;if(!r)break;else i=r}A=i}if((A|0)==(h|0)){j=1;t=22;break}else{m=1;n=A}}if((t|0)==22){u=e;return j|0}return 0}function Efc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=b[c+11>>0]|0;h=a<<24>>24<0;i=h?f[c+4>>2]|0:a&255;a=f[c+12>>2]|0;j=h?f[c>>2]|0:c;c=e;e=d;a:while(1){d=e;while(1){h=d+16|0;k=b[h+11>>0]|0;l=k<<24>>24<0;m=l?f[d+20>>2]|0:k&255;k=i>>>0<m>>>0;n=k?i:m;if((n|0)!=0?(o=WKc(l?f[h>>2]|0:h,j,n)|0,(o|0)!=0):0){if((o|0)>=0)p=8}else p=6;if((p|0)==6?(p=0,m>>>0>=i>>>0):0)p=8;if((p|0)==8){p=0;o=m>>>0<i>>>0?m:i;if((o|0)!=0?(m=WKc(j,l?f[h>>2]|0:h,o)|0,(m|0)!=0):0){if((m|0)<0)break}else p=10;if((p|0)==10?(p=0,k):0)break;if((f[d+28>>2]|0)>=(a|0))break}k=f[d+4>>2]|0;if(!k){g=c;p=15;break a}else d=k}e=f[d>>2]|0;if(!e){g=d;p=15;break}else c=d}if((p|0)==15)return g|0;return 0}function Ffc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=Gfc(a,c,f[d>>2]|0,d)|0;do if((e|0)!=(d|0)){a=e+16|0;g=b[a+11>>0]|0;h=g<<24>>24<0;i=h?f[e+20>>2]|0:g&255;g=b[c+11>>0]|0;j=g<<24>>24<0;k=j?f[c+4>>2]|0:g&255;g=i>>>0<k>>>0;l=g?i:k;if((l|0)!=0?(m=WKc(j?f[c>>2]|0:c,h?f[a>>2]|0:a,l)|0,(m|0)!=0):0){if((m|0)<0)break}else n=4;if((n|0)==4?k>>>0<i>>>0:0)break;m=k>>>0<i>>>0?k:i;if((m|0)!=0?(i=WKc(h?f[a>>2]|0:a,j?f[c>>2]|0:c,m)|0,(i|0)!=0):0){if((i|0)<0){o=e;return o|0}}else n=8;if((n|0)==8?g:0){o=e;return o|0}if((f[c+12>>2]|0)>=(f[e+28>>2]|0)){o=e;return o|0}}while(0);o=d;return o|0}function Gfc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=b[c+11>>0]|0;h=a<<24>>24<0;i=h?f[c+4>>2]|0:a&255;a=f[c+12>>2]|0;j=h?f[c>>2]|0:c;c=e;e=d;a:while(1){d=e;while(1){h=d+16|0;k=b[h+11>>0]|0;l=k<<24>>24<0;m=l?f[d+20>>2]|0:k&255;k=i>>>0<m>>>0;n=k?i:m;if((n|0)!=0?(o=WKc(l?f[h>>2]|0:h,j,n)|0,(o|0)!=0):0){if((o|0)>=0)p=8}else p=6;if((p|0)==6?(p=0,m>>>0>=i>>>0):0)p=8;if((p|0)==8){p=0;o=m>>>0<i>>>0?m:i;if((o|0)!=0?(m=WKc(j,l?f[h>>2]|0:h,o)|0,(m|0)!=0):0){if((m|0)<0)break}else p=10;if((p|0)==10?(p=0,k):0)break;if((f[d+28>>2]|0)>=(a|0))break}k=f[d+4>>2]|0;if(!k){g=c;p=15;break a}else d=k}e=f[d>>2]|0;if(!e){g=d;p=15;break}else c=d}if((p|0)==15)return g|0;return 0}function Hfc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=c+16|0;g=f[e>>2]|0;a:do if(!g)h=e;else{i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d+4>>2]|0:i&255;i=j?f[d>>2]|0:d;j=e;l=g;while(1){m=l;while(1){n=m+16|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[m+20>>2]|0:o&255;o=q>>>0<k>>>0?q:k;if((o|0)!=0?(r=WKc(i,p?f[n>>2]|0:n,o)|0,(r|0)!=0):0){if((r|0)<0)break}else s=6;if((s|0)==6?(s=0,k>>>0<q>>>0):0)break;q=f[m+4>>2]|0;if(!q){h=j;break a}else m=q}l=f[m>>2]|0;if(!l){h=m;break}else j=m}}while(0);if((h|0)==(f[c+12>>2]|0))t=h;else{s=f[h>>2]|0;if(!s){g=h;while(1){h=f[g+8>>2]|0;if((f[h>>2]|0)==(g|0))g=h;else{u=h;break}}}else{g=s;while(1){s=f[g+4>>2]|0;if(!s){u=g;break}else g=s}}t=u}if((t|0)!=(e|0)?Ifc(c,t+16|0,d)|0:0){d=t+28|0;t=f[d+4>>2]|0;c=a;f[c>>2]=f[d>>2];f[c+4>>2]=t;return}f[a>>2]=0;f[a+4>>2]=0;return}function Ifc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=c+11|0;e=b[a>>0]|0;g=e<<24>>24<0;h=c+4|0;i=e&255;e=g?f[h>>2]|0:i;j=d+11|0;k=b[j>>0]|0;l=k<<24>>24<0;m=l?f[d+4>>2]|0:k&255;a:do if((e|0)==(m|0)){k=f[c>>2]|0;n=g?k:c;o=l?f[d>>2]|0:d;p=(e|0)==0;if(g){if(p){q=1;return q|0}if(!(WKc(n,o,e)|0))q=1;else break;return q|0}if(p){q=1;return q|0}if((k&255)<<24>>24==(b[o>>0]|0)){k=c;p=i;n=o;while(1){p=p+-1|0;k=k+1|0;if(!p){q=1;break}n=n+1|0;if((b[k>>0]|0)!=(b[n>>0]|0))break a}return q|0}}while(0);if(m>>>0<e>>>0){q=0;return q|0}if(LYc(d,0,e,g?f[c>>2]|0:c,e)|0){q=0;return q|0}e=b[a>>0]|0;q=(b[((b[j>>0]|0)<0?f[d>>2]|0:d)+(e<<24>>24<0?f[h>>2]|0:e&255)>>0]|0)==46;return q|0}function Jfc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function Kfc(a,c){a=a|0;c=c|0;if(!c)return;Kfc(a,f[c>>2]|0);Kfc(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function Lfc(a,c){a=a|0;c=c|0;if(!c)return;Lfc(a,f[c>>2]|0);Lfc(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function Mfc(a){a=a|0;f[a>>2]=170920;f[a+8>>2]=0;f[a+12>>2]=0;f[a+4>>2]=a+8;f[a+20>>2]=0;f[a+24>>2]=0;f[a+16>>2]=a+20;f[a+32>>2]=0;f[a+36>>2]=0;f[a+28>>2]=a+32;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;return}function Nfc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+192|0;e=d+176|0;g=d+32|0;h=d+24|0;i=d;Rec(g);if(PZb(g,b,c)|0){f[h>>2]=b;f[h+4>>2]=c;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];j=Ofc(a+4|0,g,e)|0;vec(g);u=d;return j|0}else{u_b(i,2,496330,318);r_b(d+184|0,p_b(i,496611)|0);v_b(i);j=0;vec(g);u=d;return j|0}return 0}function Ofc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+128|0;g=e+104|0;h=e+60|0;i=e+80|0;j=e+48|0;k=e+40|0;l=e+32|0;m=e+24|0;n=e+16|0;o=e+8|0;p=e;q=c+120|0;lYc(h,f[q>>2]|0);r=d;d=f[r>>2]|0;s=f[r+4>>2]|0;r=h+12|0;f[r>>2]=d;f[r+4>>2]=s;Pfc(g,a,h,h);r=(b[g+4>>0]|0)==0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if(r){u_b(i,2,496330,58);r=p_b(i,496431)|0;r_b(e+112|0,q_b(r,f[q>>2]|0)|0);v_b(i);t=0;u=e;return t|0}if(!(f[c+8>>2]&2)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=h+11|0;w=0;x=0}else{lYc(h,f[c+124>>2]|0);i=h+11|0;v=i;w=b[i>>0]|0;x=f[h+4>>2]|0}if((w<<24>>24<0?x:w&255)|0)BYc(h,46);w=c+36|0;a:do if((f[w>>2]|0)>0){x=c+44|0;i=j+11|0;q=0;while(1){nBb(j,h,f[(f[(f[x>>2]|0)+4+(q<<2)>>2]|0)+144>>2]|0);r=k;f[r>>2]=d;f[r+4>>2]=s;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];r=Qfc(a,j,g)|0;if((b[i>>0]|0)<0)cYc(f[j>>2]|0);if(!r){y=0;break a}r=f[(f[x>>2]|0)+4+(q<<2)>>2]|0;z=l;f[z>>2]=d;f[z+4>>2]=s;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];q=q+1|0;if(!(Rfc(a,r,g)|0)){y=0;break a}if((q|0)>=(f[w>>2]|0)){A=13;break}}}else A=13;while(0);b:do if((A|0)==13){w=c+52|0;if((f[w>>2]|0)>0){l=c+60|0;k=j+11|0;q=0;do{nBb(j,h,f[(f[(f[l>>2]|0)+4+(q<<2)>>2]|0)+64>>2]|0);x=m;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];x=Qfc(a,j,g)|0;if((b[k>>0]|0)<0)cYc(f[j>>2]|0);q=q+1|0;if(!x){y=0;break b}}while((q|0)<(f[w>>2]|0))}w=c+84|0;if((f[w>>2]|0)>0){q=c+92|0;k=j+11|0;l=0;do{nBb(j,h,f[(f[(f[q>>2]|0)+4+(l<<2)>>2]|0)+16>>2]|0);x=n;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];x=Qfc(a,j,g)|0;if((b[k>>0]|0)<0)cYc(f[j>>2]|0);if(!x){y=0;break b}x=f[(f[q>>2]|0)+4+(l<<2)>>2]|0;i=o;f[i>>2]=d;f[i+4>>2]=s;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];l=l+1|0;if(!(Sfc(a,x,g)|0)){y=0;break b}}while((l|0)<(f[w>>2]|0))}w=c+68|0;if((f[w>>2]|0)>0){l=c+76|0;q=j+11|0;k=0;while(1){nBb(j,h,f[(f[(f[l>>2]|0)+4+(k<<2)>>2]|0)+32>>2]|0);x=p;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[p>>2];f[g+4>>2]=f[p+4>>2];x=Qfc(a,j,g)|0;if((b[q>>0]|0)<0)cYc(f[j>>2]|0);k=k+1|0;if(!x){y=0;break b}if((k|0)>=(f[w>>2]|0)){y=1;break}}}else y=1}while(0);if((b[v>>0]|0)<0)cYc(f[h>>2]|0);t=y;u=e;return t|0}function Pfc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=Yfc(c,h,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}d=$Xc(36)|0;lYc(d+16|0,e);n=e+12|0;e=f[n+4>>2]|0;o=d+28|0;f[o>>2]=f[n>>2];f[o+4>>2]=e;e=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=e;f[i>>2]=d;e=f[f[c>>2]>>2]|0;if(!e)p=d;else{f[c>>2]=e;p=f[i>>2]|0}UQ(f[c+4>>2]|0,p);p=c+8|0;f[p>>2]=(f[p>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}function Qfc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+128|0;g=e+112|0;h=e+68|0;i=e+88|0;j=e+122|0;k=e+24|0;l=e+121|0;m=e;n=e+120|0;o=e+48|0;p=b[c+11>>0]|0;q=p<<24>>24<0;r=q?f[c+4>>2]|0:p&255;a:do if(r|0){p=q?f[c>>2]|0:c;s=0;b:while(1){t=b[p+s>>0]|0;switch(t<<24>>24){case 95:case 46:break;default:{if(t<<24>>24<48)break b;if(t<<24>>24>57){if(t<<24>>24<65)break b;if(t<<24>>24>90&(t+-97&255)>25)break b}}}s=s+1|0;if(s>>>0>=r>>>0)break a}u_b(i,2,496330,95);r_b(j,q_b(p_b(i,496536)|0,c)|0);v_b(i);v=0;u=e;return v|0}while(0);i=a+16|0;j=f[i>>2]|0;c:do if(!j)w=i;else{s=q?f[c>>2]|0:c;p=i;t=j;while(1){x=t;while(1){y=x+16|0;z=b[y+11>>0]|0;A=z<<24>>24<0;B=A?f[x+20>>2]|0:z&255;z=B>>>0<r>>>0?B:r;if((z|0)!=0?(C=WKc(s,A?f[y>>2]|0:y,z)|0,(C|0)!=0):0){if((C|0)<0)break}else D=15;if((D|0)==15?(D=0,r>>>0<B>>>0):0)break;B=f[x+4>>2]|0;if(!B){w=p;break c}else x=B}t=f[x>>2]|0;if(!t){w=x;break}else p=x}}while(0);if((w|0)==(f[a+12>>2]|0))E=w;else{r=f[w>>2]|0;if(!r){D=w;while(1){w=f[D+8>>2]|0;if((f[w>>2]|0)==(D|0))D=w;else{F=w;break}}}else{D=r;while(1){r=f[D+4>>2]|0;if(!r){F=D;break}else D=r}}E=F}F=a+12|0;if((E|0)==(i|0)){lYc(h,c);D=d;r=f[D+4>>2]|0;w=h+12|0;f[w>>2]=f[D>>2];f[w+4>>2]=r;Vfc(g,F,h,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);v=1;u=e;return v|0}r=E+16|0;if(Ifc(a,r,c)|0){u_b(k,2,496330,111);r_b(l,p_b(q_b(p_b(q_b(p_b(k,496558)|0,c)|0,496572)|0,r)|0,506102)|0);v_b(k);v=0;u=e;return v|0}k=f[E+4>>2]|0;if(!k){r=E+8|0;l=f[r>>2]|0;if((f[l>>2]|0)==(E|0))G=l;else{l=r;do{r=f[l>>2]|0;l=r+8|0;E=f[l>>2]|0}while((f[E>>2]|0)!=(r|0));G=E}}else{l=k;while(1){k=f[l>>2]|0;if(!k)break;else l=k}G=l}l=G;if((G|0)!=(i|0)?(i=G+16|0,Ifc(a,c,i)|0):0){u_b(m,2,496330,124);r_b(n,p_b(q_b(p_b(q_b(p_b(m,496558)|0,c)|0,496572)|0,i)|0,506102)|0);v_b(m);v=0;u=e;return v|0}lYc(o,c);c=d;d=f[c+4>>2]|0;m=o+12|0;f[m>>2]=f[c>>2];f[m+4>>2]=d;f[h>>2]=l;f[g>>2]=f[h>>2];Wfc(F,g,o,o)|0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);v=1;u=e;return v|0}function Rfc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;i=b+36|0;a:do if((f[i>>2]|0)>0){j=b+44|0;k=c;l=f[k>>2]|0;m=f[k+4>>2]|0;k=0;while(1){n=f[(f[j>>2]|0)+4+(k<<2)>>2]|0;o=g;f[o>>2]=l;f[o+4>>2]=m;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];k=k+1|0;if(!(Rfc(a,n,e)|0)){p=0;break}if((k|0)>=(f[i>>2]|0))break a}u=d;return p|0}while(0);i=b+84|0;if((f[i>>2]|0)<=0){p=1;u=d;return p|0}g=b+92|0;b=c;c=f[b>>2]|0;k=f[b+4>>2]|0;b=0;while(1){m=f[(f[g>>2]|0)+4+(b<<2)>>2]|0;l=h;f[l>>2]=c;f[l+4>>2]=k;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];b=b+1|0;if(!(Sfc(a,m,e)|0)){p=0;q=9;break}if((b|0)>=(f[i>>2]|0)){p=1;q=9;break}}if((q|0)==9){u=d;return p|0}return 0}function Sfc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+96|0;g=e+80|0;h=e+56|0;i=e+40|0;j=e+24|0;k=e;l=c+20|0;m=f[l>>2]|0;n=b[m+11>>0]|0;o=n<<24>>24<0;if(o)p=f[m+4>>2]|0;else p=n&255;if(!p){q=1;u=e;return q|0}if(o)r=f[m>>2]|0;else r=m;if((b[r>>0]|0)!=46){q=1;u=e;return q|0}mYc(j,m,1,-1,m);m=c+40|0;r=f[m>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;o=i+12|0;f[o>>2]=r;lYc(h,i);f[h+12>>2]=f[o>>2];o=d;d=f[o+4>>2]|0;r=h+16|0;f[r>>2]=f[o>>2];f[r+4>>2]=d;Tfc(g,a+24|0,h,h);a=(b[g+4>>0]|0)==0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if(!a){q=1;u=e;return q|0}u_b(k,2,496330,163);a=p_b(k,496465)|0;j=p_b(q_b(a,f[l>>2]|0)|0,505459)|0;l=p_b(q_b(j,f[c+16>>2]|0)|0,496529)|0;r_b(e+88|0,p_b(s_b(l,f[m>>2]|0)|0,496533)|0);v_b(k);q=0;u=e;return q|0}function Tfc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=Ufc(c,h,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}d=$Xc(40)|0;lYc(d+16|0,e);f[d+28>>2]=f[e+12>>2];n=e+16|0;e=f[n+4>>2]|0;o=d+32|0;f[o>>2]=f[n>>2];f[o+4>>2]=e;e=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=e;f[i>>2]=d;e=f[f[c>>2]>>2]|0;if(!e)p=d;else{f[c>>2]=e;p=f[i>>2]|0}UQ(f[c+4>>2]|0,p);p=c+8|0;f[p>>2]=(f[p>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}function Ufc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=f[d+12>>2]|0;k=i?f[d>>2]|0:d;d=a+4|0;a=g;a:while(1){g=a+16|0;i=b[g+11>>0]|0;l=i<<24>>24<0;m=l?f[a+20>>2]|0:i&255;i=m>>>0<j>>>0;n=i?m:j;o=(n|0)==0;if(!o?(p=WKc(k,l?f[g>>2]|0:g,n)|0,(p|0)!=0):0)if((p|0)<0)q=13;else q=8;else if(j>>>0<m>>>0)q=13;else q=8;do if((q|0)==8){q=0;p=j>>>0<m>>>0;r=p?j:m;s=(r|0)==0;if(!s?(t=WKc(l?f[g>>2]|0:g,k,r)|0,(t|0)!=0):0)if((t|0)<0)q=16;else q=12;else if(i)q=15;else q=12;if((q|0)==12){q=0;if((e|0)<(f[a+28>>2]|0)){q=13;break}else q=15}if((q|0)==15){q=0;if(s)q=17;else q=16}if((q|0)==16){q=0;s=WKc(l?f[g>>2]|0:g,k,r)|0;if(s){if((s|0)>=0)q=19}else q=17}if((q|0)==17?(q=0,!i):0)q=19;if((q|0)==19){q=0;if(!o?(s=WKc(k,l?f[g>>2]|0:g,n)|0,(s|0)!=0):0){if((s|0)<0){q=26;break a}}else q=21;if((q|0)==21?(q=0,p):0){q=26;break a}if((f[a+28>>2]|0)>=(e|0)){q=26;break a}}u=a+4|0;p=f[u>>2]|0;if(!p){q=25;break a}else{v=u;w=p}}while(0);if((q|0)==13){q=0;n=f[a>>2]|0;if(!n){q=14;break}else{v=a;w=n}}d=v;a=w}if((q|0)==14){f[c>>2]=a;h=a;return h|0}else if((q|0)==25){f[c>>2]=a;h=u;return h|0}else if((q|0)==26){f[c>>2]=a;h=d;return h|0}return 0}function Vfc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=Yfc(c,h,d)|0;d=f[i>>2]|0;if(d|0){j=d;k=0;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}d=$Xc(36)|0;lYc(d+16|0,e);n=e+12|0;e=f[n+4>>2]|0;o=d+28|0;f[o>>2]=f[n>>2];f[o+4>>2]=e;e=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=e;f[i>>2]=d;e=f[f[c>>2]>>2]|0;if(!e)p=d;else{f[c>>2]=e;p=f[i>>2]|0}UQ(f[c+4>>2]|0,p);p=c+8|0;f[p>>2]=(f[p>>2]|0)+1;j=d;k=1;l=j;f[a>>2]=l;m=a+4|0;b[m>>0]=k;u=g;return}function Wfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;f[i>>2]=f[b>>2];f[g>>2]=f[i>>2];i=Xfc(a,g,h,e+4|0,c)|0;c=f[i>>2]|0;if(c|0){j=c;u=e;return j|0}c=$Xc(36)|0;lYc(c+16|0,d);g=d+12|0;d=f[g+4>>2]|0;b=c+28|0;f[b>>2]=f[g>>2];f[b+4>>2]=d;d=f[h>>2]|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=d;f[i>>2]=c;d=f[f[a>>2]>>2]|0;if(!d)k=c;else{f[a>>2]=d;k=f[i>>2]|0}UQ(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;j=c;u=e;return j|0}function Xfc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=i+16|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[i+20>>2]|0:k&255;k=b[g+11>>0]|0;n=k<<24>>24<0;o=n?f[g+4>>2]|0:k&255;k=m>>>0<o>>>0;p=k?m:o;if((p|0)!=0?(q=WKc(n?f[g>>2]|0:g,l?f[j>>2]|0:j,p)|0,(q|0)!=0):0){if((q|0)<0)break}else r=4;if((r|0)==4?o>>>0<m>>>0:0)break;q=o>>>0<m>>>0?o:m;if((q|0)!=0?(m=WKc(l?f[j>>2]|0:j,n?f[g>>2]|0:g,q)|0,(m|0)!=0):0){if((m|0)>=0)r=36}else r=20;if((r|0)==20?!k:0)r=36;if((r|0)==36){f[d>>2]=c;f[e>>2]=c;s=e;return s|0}k=i+4|0;m=f[k>>2]|0;if(!m){q=i+8|0;j=f[q>>2]|0;if((f[j>>2]|0)==(i|0))t=j;else{j=q;do{q=f[j>>2]|0;j=q+8|0;l=f[j>>2]|0}while((f[l>>2]|0)!=(q|0));t=l}}else{j=m;while(1){l=f[j>>2]|0;if(!l)break;else j=l}t=j}do if((t|0)!=(h|0)){m=t+16|0;l=b[m+11>>0]|0;q=l<<24>>24<0;p=q?f[t+20>>2]|0:l&255;l=p>>>0<o>>>0?p:o;if((l|0)!=0?(u=WKc(n?f[g>>2]|0:g,q?f[m>>2]|0:m,l)|0,(u|0)!=0):0){if((u|0)<0)break}else r=30;if((r|0)==30?o>>>0<p>>>0:0)break;s=Yfc(a,d,g)|0;return s|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;s=k;return s|0}else{f[d>>2]=t;s=t;return s|0}}while(0);t=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))v=c;else{if(!t){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{w=e;break}}}else{h=t;while(1){k=f[h+4>>2]|0;if(!k){w=h;break}else h=k}}h=w;k=w+16|0;e=b[g+11>>0]|0;o=e<<24>>24<0;n=o?f[g+4>>2]|0:e&255;e=b[k+11>>0]|0;j=e<<24>>24<0;p=j?f[w+20>>2]|0:e&255;e=n>>>0<p>>>0?n:p;if((e|0)!=0?(u=WKc(j?f[k>>2]|0:k,o?f[g>>2]|0:g,e)|0,(u|0)!=0):0){if((u|0)<0){v=h;break}}else r=12;if((r|0)==12?p>>>0<n>>>0:0){v=h;break}s=Yfc(a,d,g)|0;return s|0}while(0);if(!t){f[d>>2]=i;s=i;return s|0}else{i=v;f[d>>2]=i;s=i+4|0;return s|0}return 0}function Yfc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}
function W6(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{b[m+p>>0]=b[246515+((h[n+p>>0]|0|256)-(h[l+p>>0]|0))>>0]|0;p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;if((o|0)<(i|0)){q=d;r=f;s=a;t=k}else{n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=b[246515+((h[f+m>>0]|0|256)-(h[n+m>>0]|0))>>0]|0;b[d+k>>0]=b[246515+((h[f+k>>0]|0|256)-(h[n+k>>0]|0))>>0]|0;b[d+m>>0]=l;l=k|2;m=k|3;p=b[246515+((h[f+m>>0]|0|256)-(h[n+m>>0]|0))>>0]|0;b[d+l>>0]=b[246515+((h[f+l>>0]|0|256)-(h[n+l>>0]|0))>>0]|0;b[d+m>>0]=p;k=k+4|0}while((k|0)<=(j|0));if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[246515+((h[s+f>>0]|0|256)-(h[q+f>>0]|0))>>0]|0;b[r+a>>0]=b[246515+((h[s+a>>0]|0|256)-(h[q+a>>0]|0))>>0]|0;b[r+f>>0]=d;d=a|2;f=a|3;n=b[246515+((h[s+f>>0]|0|256)-(h[q+f>>0]|0))>>0]|0;b[r+d>>0]=b[246515+((h[s+d>>0]|0|256)-(h[q+d>>0]|0))>>0]|0;b[r+f>>0]=n;a=a+4|0}while((a|0)<=(j|0));u=o;do{b[r+u>>0]=b[246515+((h[s+u>>0]|0|256)-(h[q+u>>0]|0))>>0]|0;u=u+1|0}while((u|0)!=(i|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function X6(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=(b[m+o>>0]|0)-(b[k+o>>0]|0)|0;b[l+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){q=d;r=f;s=a;t=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=(b[f+j>>0]|0)-(b[m+j>>0]|0)|0;k=j|1;o=(b[f+k>>0]|0)-(b[m+k>>0]|0)|0;b[d+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[d+k>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=j|2;k=(b[f+o>>0]|0)-(b[m+o>>0]|0)|0;l=j|3;p=(b[f+l>>0]|0)-(b[m+l>>0]|0)|0;b[d+o>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=(b[s+a>>0]|0)-(b[q+a>>0]|0)|0;d=a|1;m=(b[s+d>>0]|0)-(b[q+d>>0]|0)|0;b[r+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[r+d>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;m=a|2;d=(b[s+m>>0]|0)-(b[q+m>>0]|0)|0;f=a|3;j=(b[s+f>>0]|0)-(b[q+f>>0]|0)|0;b[r+m>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[r+f>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;a=a+4|0}while((a|0)<=(i|0));u=n;do{a=(b[s+u>>0]|0)-(b[q+u>>0]|0)|0;b[r+u>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;u=u+1|0}while((u|0)!=(h|0));if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0;t=t+-1|0}}return}function Y6(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){l=c;m=f;n=a;o=g}else return;while(1){p=0;do{q=(j[n+(p<<1)>>1]|0)-(j[l+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;p=p+1|0}while((p|0)!=(h|0));if(!o)break;else{l=l+(b<<1)|0;m=m+(e<<1)|0;n=n+(k<<1)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=g;while(1){g=0;do{l=(j[f+(g<<1)>>1]|0)-(j[m+(g<<1)>>1]|0)|0;p=g|1;q=(j[f+(p<<1)>>1]|0)-(j[m+(p<<1)>>1]|0)|0;d[c+(g<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;d[c+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=g|2;p=(j[f+(q<<1)>>1]|0)-(j[m+(q<<1)>>1]|0)|0;l=g|3;r=(j[f+(l<<1)>>1]|0)-(j[m+(l<<1)>>1]|0)|0;d[c+(q<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;d[c+(l<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;g=g+4|0}while((g|0)<=(i|0));if(n){g=o;do{r=(j[f+(g<<1)>>1]|0)-(j[m+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0;a=a+-1|0}}return}function Z6(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=(d[m+(o<<1)>>1]|0)-(d[k+(o<<1)>>1]|0)|0;d[l+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=c;c=f;f=a;a=g;while(1){g=0;do{k=(d[f+(g<<1)>>1]|0)-(d[l+(g<<1)>>1]|0)|0;o=g|1;p=(d[f+(o<<1)>>1]|0)-(d[l+(o<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=g|2;o=(d[f+(p<<1)>>1]|0)-(d[l+(p<<1)>>1]|0)|0;k=g|3;q=(d[f+(k<<1)>>1]|0)-(d[l+(k<<1)>>1]|0)|0;d[c+(p<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[c+(k<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+4|0}while((g|0)<=(i|0));if(m){g=n;do{q=(d[f+(g<<1)>>1]|0)-(d[l+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}function _6(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{f[l+(o<<2)>>2]=(f[m+(o<<2)>>2]|0)-(f[k+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=c;q=e;r=a;s=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=g|1;k=(f[e+(l<<2)>>2]|0)-(f[m+(l<<2)>>2]|0)|0;f[c+(g<<2)>>2]=(f[e+(g<<2)>>2]|0)-(f[m+(g<<2)>>2]|0);f[c+(l<<2)>>2]=k;k=g|2;l=g|3;o=(f[e+(l<<2)>>2]|0)-(f[m+(l<<2)>>2]|0)|0;f[c+(k<<2)>>2]=(f[e+(k<<2)>>2]|0)-(f[m+(k<<2)>>2]|0);f[c+(l<<2)>>2]=o;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;c=(f[r+(e<<2)>>2]|0)-(f[p+(e<<2)>>2]|0)|0;f[q+(a<<2)>>2]=(f[r+(a<<2)>>2]|0)-(f[p+(a<<2)>>2]|0);f[q+(e<<2)>>2]=c;c=a|2;e=a|3;m=(f[r+(e<<2)>>2]|0)-(f[p+(e<<2)>>2]|0)|0;f[q+(c<<2)>>2]=(f[r+(c<<2)>>2]|0)-(f[p+(c<<2)>>2]|0);f[q+(e<<2)>>2]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{f[q+(t<<2)>>2]=(f[r+(t<<2)>>2]|0)-(f[p+(t<<2)>>2]|0);t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(j<<2)|0;s=s+-1|0}}return}function $6(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{n[k+(o<<2)>>2]=+n[l+(o<<2)>>2]-+n[j+(o<<2)>>2];o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){p=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]-+n[l+(f<<2)>>2];n[c+(k<<2)>>2]=t;k=f|2;j=f|3;t=+n[e+(j<<2)>>2]-+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2];n[c+(j<<2)>>2]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+n[r+(e<<2)>>2]-+n[p+(e<<2)>>2];n[q+(a<<2)>>2]=+n[r+(a<<2)>>2]-+n[p+(a<<2)>>2];n[q+(e<<2)>>2]=t;e=a|2;c=a|3;t=+n[r+(c<<2)>>2]-+n[p+(c<<2)>>2];n[q+(e<<2)>>2]=+n[r+(e<<2)>>2]-+n[p+(e<<2)>>2];n[q+(c<<2)>>2]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{n[q+(u<<2)>>2]=+n[r+(u<<2)>>2]-+n[p+(u<<2)>>2];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{p=p+(b<<2)|0;q=q+(d<<2)|0;r=r+(i<<2)|0;s=s+-1|0}}return}function a7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{p[k+(n<<3)>>3]=+p[l+(n<<3)>>3]-+p[j+(n<<3)>>3];n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){o=c;q=e;r=a;s=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{k=f|1;t=+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3];p[c+(f<<3)>>3]=+p[e+(f<<3)>>3]-+p[l+(f<<3)>>3];p[c+(k<<3)>>3]=t;k=f|2;j=f|3;t=+p[e+(j<<3)>>3]-+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3];p[c+(j<<3)>>3]=t;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=+p[r+(e<<3)>>3]-+p[o+(e<<3)>>3];p[q+(a<<3)>>3]=+p[r+(a<<3)>>3]-+p[o+(a<<3)>>3];p[q+(e<<3)>>3]=t;e=a|2;c=a|3;t=+p[r+(c<<3)>>3]-+p[o+(c<<3)>>3];p[q+(e<<3)>>3]=+p[r+(e<<3)>>3]-+p[o+(e<<3)>>3];p[q+(c<<3)>>3]=t;a=a+4|0}while((a|0)<=(h|0));u=m;do{p[q+(u<<3)>>3]=+p[r+(u<<3)>>3]-+p[o+(u<<3)>>3];u=u+1|0}while((u|0)!=(g|0));if(!s)break;else{o=o+(b<<3)|0;q=q+(d<<3)|0;r=r+(i<<3)|0;s=s+-1|0}}return}function b7(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{q=h[n+p>>0]|0;b[m+p>>0]=q-(h[246515+((q|256)-(h[l+p>>0]|0))>>0]|0);p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;if((o|0)<(i|0)){r=d;s=f;t=a;u=k}else{n=d;d=f;f=a;a=k;while(1){k=0;do{m=h[f+k>>0]|0;l=k|1;p=h[f+l>>0]|0;q=p-(h[246515+((p|256)-(h[n+l>>0]|0))>>0]|0)&255;b[d+k>>0]=m-(h[246515+((m|256)-(h[n+k>>0]|0))>>0]|0);b[d+l>>0]=q;q=k|2;l=h[f+q>>0]|0;m=k|3;p=h[f+m>>0]|0;v=p-(h[246515+((p|256)-(h[n+m>>0]|0))>>0]|0)&255;b[d+q>>0]=l-(h[246515+((l|256)-(h[n+q>>0]|0))>>0]|0);b[d+m>>0]=v;k=k+4|0}while((k|0)<=(j|0));if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=h[t+a>>0]|0;d=a|1;n=h[t+d>>0]|0;k=n-(h[246515+((n|256)-(h[r+d>>0]|0))>>0]|0)&255;b[s+a>>0]=f-(h[246515+((f|256)-(h[r+a>>0]|0))>>0]|0);b[s+d>>0]=k;k=a|2;d=h[t+k>>0]|0;f=a|3;n=h[t+f>>0]|0;v=n-(h[246515+((n|256)-(h[r+f>>0]|0))>>0]|0)&255;b[s+k>>0]=d-(h[246515+((d|256)-(h[r+k>>0]|0))>>0]|0);b[s+f>>0]=v;a=a+4|0}while((a|0)<=(j|0));w=o;do{a=h[t+w>>0]|0;b[s+w>>0]=a-(h[246515+((a|256)-(h[r+w>>0]|0))>>0]|0);w=w+1|0}while((w|0)!=(i|0));if(!u)break;else{r=r+e|0;s=s+g|0;t=t+c|0;u=u+-1|0}}return}function c7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=b[m+o>>0]|0;q=b[k+o>>0]|0;b[l+o>>0]=q<<24>>24<p<<24>>24?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=d;s=f;t=a;u=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=b[f+j>>0]|0;k=b[m+j>>0]|0;o=j|1;p=b[f+o>>0]|0;q=b[m+o>>0]|0;b[d+j>>0]=k<<24>>24<l<<24>>24?k:l;b[d+o>>0]=q<<24>>24<p<<24>>24?q:p;p=j|2;q=b[f+p>>0]|0;o=b[m+p>>0]|0;l=j|3;k=b[f+l>>0]|0;v=b[m+l>>0]|0;b[d+p>>0]=o<<24>>24<q<<24>>24?o:q;b[d+l>>0]=v<<24>>24<k<<24>>24?v:k;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=b[t+a>>0]|0;d=b[r+a>>0]|0;m=a|1;j=b[t+m>>0]|0;k=b[r+m>>0]|0;b[s+a>>0]=d<<24>>24<f<<24>>24?d:f;b[s+m>>0]=k<<24>>24<j<<24>>24?k:j;j=a|2;k=b[t+j>>0]|0;m=b[r+j>>0]|0;f=a|3;d=b[t+f>>0]|0;v=b[r+f>>0]|0;b[s+j>>0]=m<<24>>24<k<<24>>24?m:k;b[s+f>>0]=v<<24>>24<d<<24>>24?v:d;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=b[t+w>>0]|0;d=b[r+w>>0]|0;b[s+w>>0]=d<<24>>24<a<<24>>24?d:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+e|0;s=s+g|0;t=t+c|0;u=u+-1|0}}return}function d7(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=(q&65535)<(p&65535)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=(k&65535)<(l&65535)?k:l;d[c+(o<<1)>>1]=(q&65535)<(p&65535)?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=(o&65535)<(q&65535)?o:q;d[c+(l<<1)>>1]=(v&65535)<(k&65535)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=(c&65535)<(f&65535)?c:f;d[s+(m<<1)>>1]=(k&65535)<(g&65535)?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=(m&65535)<(k&65535)?m:k;d[s+(f<<1)>>1]=(v&65535)<(c&65535)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=(c&65535)<(a&65535)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function e7(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=q<<16>>16<p<<16>>16?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=k<<16>>16<l<<16>>16?k:l;d[c+(o<<1)>>1]=q<<16>>16<p<<16>>16?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=o<<16>>16<q<<16>>16?o:q;d[c+(l<<1)>>1]=v<<16>>16<k<<16>>16?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=c<<16>>16<f<<16>>16?c:f;d[s+(m<<1)>>1]=k<<16>>16<g<<16>>16?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=m<<16>>16<k<<16>>16?m:k;d[s+(f<<1)>>1]=v<<16>>16<c<<16>>16?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=c<<16>>16<a<<16>>16?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function f7(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{p=f[m+(o<<2)>>2]|0;q=f[k+(o<<2)>>2]|0;f[l+(o<<2)>>2]=(q|0)<(p|0)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=e;t=a;u=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=f[e+(g<<2)>>2]|0;k=f[m+(g<<2)>>2]|0;o=g|1;p=f[e+(o<<2)>>2]|0;q=f[m+(o<<2)>>2]|0;f[c+(g<<2)>>2]=(k|0)<(l|0)?k:l;f[c+(o<<2)>>2]=(q|0)<(p|0)?q:p;p=g|2;q=f[e+(p<<2)>>2]|0;o=f[m+(p<<2)>>2]|0;l=g|3;k=f[e+(l<<2)>>2]|0;v=f[m+(l<<2)>>2]|0;f[c+(p<<2)>>2]=(o|0)<(q|0)?o:q;f[c+(l<<2)>>2]=(v|0)<(k|0)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=f[t+(a<<2)>>2]|0;c=f[r+(a<<2)>>2]|0;m=a|1;g=f[t+(m<<2)>>2]|0;k=f[r+(m<<2)>>2]|0;f[s+(a<<2)>>2]=(c|0)<(e|0)?c:e;f[s+(m<<2)>>2]=(k|0)<(g|0)?k:g;g=a|2;k=f[t+(g<<2)>>2]|0;m=f[r+(g<<2)>>2]|0;e=a|3;c=f[t+(e<<2)>>2]|0;v=f[r+(e<<2)>>2]|0;f[s+(g<<2)>>2]=(m|0)<(k|0)?m:k;f[s+(e<<2)>>2]=(v|0)<(c|0)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=f[t+(w<<2)>>2]|0;c=f[r+(w<<2)>>2]|0;f[s+(w<<2)>>2]=(c|0)<(a|0)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(j<<2)|0;u=u+-1|0}}return}function g7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{p=+n[l+(o<<2)>>2];q=+n[j+(o<<2)>>2];n[k+(o<<2)>>2]=q<p?q:p;o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{p=+n[e+(f<<2)>>2];q=+n[l+(f<<2)>>2];k=f|1;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];n[c+(f<<2)>>2]=q<p?q:p;n[c+(k<<2)>>2]=w<v?w:v;k=f|2;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];j=f|3;p=+n[e+(j<<2)>>2];q=+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=w<v?w:v;n[c+(j<<2)>>2]=q<p?q:p;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{p=+n[t+(a<<2)>>2];q=+n[r+(a<<2)>>2];e=a|1;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];n[s+(a<<2)>>2]=q<p?q:p;n[s+(e<<2)>>2]=w<v?w:v;e=a|2;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];c=a|3;p=+n[t+(c<<2)>>2];q=+n[r+(c<<2)>>2];n[s+(e<<2)>>2]=w<v?w:v;n[s+(c<<2)>>2]=q<p?q:p;a=a+4|0}while((a|0)<=(h|0));x=m;do{p=+n[t+(x<<2)>>2];q=+n[r+(x<<2)>>2];n[s+(x<<2)>>2]=q<p?q:p;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(i<<2)|0;u=u+-1|0}}return}function h7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{o=+p[l+(n<<3)>>3];q=+p[j+(n<<3)>>3];p[k+(n<<3)>>3]=q<o?q:o;n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{o=+p[e+(f<<3)>>3];q=+p[l+(f<<3)>>3];k=f|1;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];p[c+(f<<3)>>3]=q<o?q:o;p[c+(k<<3)>>3]=w<v?w:v;k=f|2;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];j=f|3;o=+p[e+(j<<3)>>3];q=+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=w<v?w:v;p[c+(j<<3)>>3]=q<o?q:o;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{o=+p[t+(a<<3)>>3];q=+p[r+(a<<3)>>3];e=a|1;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];p[s+(a<<3)>>3]=q<o?q:o;p[s+(e<<3)>>3]=w<v?w:v;e=a|2;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];c=a|3;o=+p[t+(c<<3)>>3];q=+p[r+(c<<3)>>3];p[s+(e<<3)>>3]=w<v?w:v;p[s+(c<<3)>>3]=q<o?q:o;a=a+4|0}while((a|0)<=(h|0));x=m;do{o=+p[t+(x<<3)>>3];q=+p[r+(x<<3)>>3];p[s+(x<<3)>>3]=q<o?q:o;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<3)|0;s=s+(d<<3)|0;t=t+(i<<3)|0;u=u+-1|0}}return}function i7(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){l=d;m=f;n=a;o=k}else return;while(1){p=0;do{q=h[n+p>>0]|0;b[m+p>>0]=(h[246515+(256-q+(h[l+p>>0]|0))>>0]|0)+q;p=p+1|0}while((p|0)!=(i|0));if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=i&-4;n=(o|0)<(i|0);m=d;d=f;f=a;a=k;while(1){k=0;do{l=h[f+k>>0]|0;p=k|1;q=h[f+p>>0]|0;r=(h[246515+(256-q+(h[m+p>>0]|0))>>0]|0)+q&255;b[d+k>>0]=(h[246515+(256-l+(h[m+k>>0]|0))>>0]|0)+l;b[d+p>>0]=r;r=k|2;p=h[f+r>>0]|0;l=k|3;q=h[f+l>>0]|0;s=(h[246515+(256-q+(h[m+l>>0]|0))>>0]|0)+q&255;b[d+r>>0]=(h[246515+(256-p+(h[m+r>>0]|0))>>0]|0)+p;b[d+l>>0]=s;k=k+4|0}while((k|0)<=(j|0));if(n){k=o;do{s=h[f+k>>0]|0;b[d+k>>0]=(h[246515+(256-s+(h[m+k>>0]|0))>>0]|0)+s;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function j7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=b[m+o>>0]|0;q=b[k+o>>0]|0;b[l+o>>0]=p<<24>>24<q<<24>>24?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=d;s=f;t=a;u=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=b[f+j>>0]|0;k=b[m+j>>0]|0;o=j|1;p=b[f+o>>0]|0;q=b[m+o>>0]|0;b[d+j>>0]=l<<24>>24<k<<24>>24?k:l;b[d+o>>0]=p<<24>>24<q<<24>>24?q:p;p=j|2;q=b[f+p>>0]|0;o=b[m+p>>0]|0;l=j|3;k=b[f+l>>0]|0;v=b[m+l>>0]|0;b[d+p>>0]=q<<24>>24<o<<24>>24?o:q;b[d+l>>0]=k<<24>>24<v<<24>>24?v:k;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=b[t+a>>0]|0;d=b[r+a>>0]|0;m=a|1;j=b[t+m>>0]|0;k=b[r+m>>0]|0;b[s+a>>0]=f<<24>>24<d<<24>>24?d:f;b[s+m>>0]=j<<24>>24<k<<24>>24?k:j;j=a|2;k=b[t+j>>0]|0;m=b[r+j>>0]|0;f=a|3;d=b[t+f>>0]|0;v=b[r+f>>0]|0;b[s+j>>0]=k<<24>>24<m<<24>>24?m:k;b[s+f>>0]=d<<24>>24<v<<24>>24?v:d;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=b[t+w>>0]|0;d=b[r+w>>0]|0;b[s+w>>0]=a<<24>>24<d<<24>>24?d:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+e|0;s=s+g|0;t=t+c|0;u=u+-1|0}}return}function k7(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=(p&65535)<(q&65535)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=(l&65535)<(k&65535)?k:l;d[c+(o<<1)>>1]=(p&65535)<(q&65535)?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=(q&65535)<(o&65535)?o:q;d[c+(l<<1)>>1]=(k&65535)<(v&65535)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=(f&65535)<(c&65535)?c:f;d[s+(m<<1)>>1]=(g&65535)<(k&65535)?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=(k&65535)<(m&65535)?m:k;d[s+(f<<1)>>1]=(c&65535)<(v&65535)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=(a&65535)<(c&65535)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function l7(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;d[l+(o<<1)>>1]=p<<16>>16<q<<16>>16?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=f;t=a;u=g}else{m=c;c=f;f=a;a=g;while(1){g=0;do{l=d[f+(g<<1)>>1]|0;k=d[m+(g<<1)>>1]|0;o=g|1;p=d[f+(o<<1)>>1]|0;q=d[m+(o<<1)>>1]|0;d[c+(g<<1)>>1]=l<<16>>16<k<<16>>16?k:l;d[c+(o<<1)>>1]=p<<16>>16<q<<16>>16?q:p;p=g|2;q=d[f+(p<<1)>>1]|0;o=d[m+(p<<1)>>1]|0;l=g|3;k=d[f+(l<<1)>>1]|0;v=d[m+(l<<1)>>1]|0;d[c+(p<<1)>>1]=q<<16>>16<o<<16>>16?o:q;d[c+(l<<1)>>1]=k<<16>>16<v<<16>>16?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=d[t+(a<<1)>>1]|0;c=d[r+(a<<1)>>1]|0;m=a|1;g=d[t+(m<<1)>>1]|0;k=d[r+(m<<1)>>1]|0;d[s+(a<<1)>>1]=f<<16>>16<c<<16>>16?c:f;d[s+(m<<1)>>1]=g<<16>>16<k<<16>>16?k:g;g=a|2;k=d[t+(g<<1)>>1]|0;m=d[r+(g<<1)>>1]|0;f=a|3;c=d[t+(f<<1)>>1]|0;v=d[r+(f<<1)>>1]|0;d[s+(g<<1)>>1]=k<<16>>16<m<<16>>16?m:k;d[s+(f<<1)>>1]=c<<16>>16<v<<16>>16?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=d[t+(w<<1)>>1]|0;c=d[r+(w<<1)>>1]|0;d[s+(w<<1)>>1]=a<<16>>16<c<<16>>16?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0;u=u+-1|0}}return}function m7(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{p=f[m+(o<<2)>>2]|0;q=f[k+(o<<2)>>2]|0;f[l+(o<<2)>>2]=(p|0)<(q|0)?q:p;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=e;t=a;u=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=f[e+(g<<2)>>2]|0;k=f[m+(g<<2)>>2]|0;o=g|1;p=f[e+(o<<2)>>2]|0;q=f[m+(o<<2)>>2]|0;f[c+(g<<2)>>2]=(l|0)<(k|0)?k:l;f[c+(o<<2)>>2]=(p|0)<(q|0)?q:p;p=g|2;q=f[e+(p<<2)>>2]|0;o=f[m+(p<<2)>>2]|0;l=g|3;k=f[e+(l<<2)>>2]|0;v=f[m+(l<<2)>>2]|0;f[c+(p<<2)>>2]=(q|0)<(o|0)?o:q;f[c+(l<<2)>>2]=(k|0)<(v|0)?v:k;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=f[t+(a<<2)>>2]|0;c=f[r+(a<<2)>>2]|0;m=a|1;g=f[t+(m<<2)>>2]|0;k=f[r+(m<<2)>>2]|0;f[s+(a<<2)>>2]=(e|0)<(c|0)?c:e;f[s+(m<<2)>>2]=(g|0)<(k|0)?k:g;g=a|2;k=f[t+(g<<2)>>2]|0;m=f[r+(g<<2)>>2]|0;e=a|3;c=f[t+(e<<2)>>2]|0;v=f[r+(e<<2)>>2]|0;f[s+(g<<2)>>2]=(k|0)<(m|0)?m:k;f[s+(e<<2)>>2]=(c|0)<(v|0)?v:c;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=f[t+(w<<2)>>2]|0;c=f[r+(w<<2)>>2]|0;f[s+(w<<2)>>2]=(a|0)<(c|0)?c:a;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(j<<2)|0;u=u+-1|0}}return}function n7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{p=+n[l+(o<<2)>>2];q=+n[j+(o<<2)>>2];n[k+(o<<2)>>2]=p<q?q:p;o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{p=+n[e+(f<<2)>>2];q=+n[l+(f<<2)>>2];k=f|1;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];n[c+(f<<2)>>2]=p<q?q:p;n[c+(k<<2)>>2]=v<w?w:v;k=f|2;v=+n[e+(k<<2)>>2];w=+n[l+(k<<2)>>2];j=f|3;p=+n[e+(j<<2)>>2];q=+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=v<w?w:v;n[c+(j<<2)>>2]=p<q?q:p;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{p=+n[t+(a<<2)>>2];q=+n[r+(a<<2)>>2];e=a|1;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];n[s+(a<<2)>>2]=p<q?q:p;n[s+(e<<2)>>2]=v<w?w:v;e=a|2;v=+n[t+(e<<2)>>2];w=+n[r+(e<<2)>>2];c=a|3;p=+n[t+(c<<2)>>2];q=+n[r+(c<<2)>>2];n[s+(e<<2)>>2]=v<w?w:v;n[s+(c<<2)>>2]=p<q?q:p;a=a+4|0}while((a|0)<=(h|0));x=m;do{p=+n[t+(x<<2)>>2];q=+n[r+(x<<2)>>2];n[s+(x<<2)>>2]=p<q?q:p;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(i<<2)|0;u=u+-1|0}}return}function o7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{o=+p[l+(n<<3)>>3];q=+p[j+(n<<3)>>3];p[k+(n<<3)>>3]=o<q?q:o;n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){r=c;s=e;t=a;u=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{o=+p[e+(f<<3)>>3];q=+p[l+(f<<3)>>3];k=f|1;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];p[c+(f<<3)>>3]=o<q?q:o;p[c+(k<<3)>>3]=v<w?w:v;k=f|2;v=+p[e+(k<<3)>>3];w=+p[l+(k<<3)>>3];j=f|3;o=+p[e+(j<<3)>>3];q=+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=v<w?w:v;p[c+(j<<3)>>3]=o<q?q:o;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{o=+p[t+(a<<3)>>3];q=+p[r+(a<<3)>>3];e=a|1;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];p[s+(a<<3)>>3]=o<q?q:o;p[s+(e<<3)>>3]=v<w?w:v;e=a|2;v=+p[t+(e<<3)>>3];w=+p[r+(e<<3)>>3];c=a|3;o=+p[t+(c<<3)>>3];q=+p[r+(c<<3)>>3];p[s+(e<<3)>>3]=v<w?w:v;p[s+(c<<3)>>3]=o<q?q:o;a=a+4|0}while((a|0)<=(h|0));x=m;do{o=+p[t+(x<<3)>>3];q=+p[r+(x<<3)>>3];p[s+(x<<3)>>3]=o<q?q:o;x=x+1|0}while((x|0)!=(g|0));if(!u)break;else{r=r+(b<<3)|0;s=s+(d<<3)|0;t=t+(i<<3)|0;u=u+-1|0}}return}function p7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=b[m+o>>0]|0;q=b[k+o>>0]|0;r=(p&255)>(q&255);b[l+o>>0]=((r?p:q)&255)-((r?q:p)&255);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=d;d=f;f=a;a=j;while(1){j=0;do{k=b[f+j>>0]|0;o=b[l+j>>0]|0;p=(k&255)>(o&255);q=j|1;r=b[f+q>>0]|0;s=b[l+q>>0]|0;t=(r&255)>(s&255);b[d+j>>0]=((p?k:o)&255)-((p?o:k)&255);b[d+q>>0]=((t?r:s)&255)-((t?s:r)&255);r=j|2;s=b[f+r>>0]|0;t=b[l+r>>0]|0;q=(s&255)>(t&255);k=j|3;o=b[f+k>>0]|0;p=b[l+k>>0]|0;u=(o&255)>(p&255);b[d+r>>0]=((q?s:t)&255)-((q?t:s)&255);b[d+k>>0]=((u?o:p)&255)-((u?p:o)&255);j=j+4|0}while((j|0)<=(i|0));if(m){j=n;do{o=b[f+j>>0]|0;p=b[l+j>>0]|0;u=(o&255)>(p&255);b[d+j>>0]=((u?o:p)&255)-((u?p:o)&255);j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{l=l+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function q7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{p=(b[m+o>>0]|0)-(b[k+o>>0]|0)|0;q=(p|0)>-1?p:0-p|0;b[l+o>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=d;d=f;f=a;a=j;while(1){j=0;do{k=(b[f+j>>0]|0)-(b[l+j>>0]|0)|0;o=(k|0)>-1?k:0-k|0;k=j|1;q=(b[f+k>>0]|0)-(b[l+k>>0]|0)|0;p=(q|0)>-1?q:0-q|0;b[d+j>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;b[d+k>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=j|2;k=(b[f+p>>0]|0)-(b[l+p>>0]|0)|0;o=(k|0)>-1?k:0-k|0;k=j|3;q=(b[f+k>>0]|0)-(b[l+k>>0]|0)|0;r=(q|0)>-1?q:0-q|0;b[d+p>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;b[d+k>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(m){j=n;do{r=(b[f+j>>0]|0)-(b[l+j>>0]|0)|0;k=(r|0)>-1?r:0-r|0;b[d+j>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{l=l+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function r7(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=f;m=a;n=g}else return;while(1){o=0;do{p=d[m+(o<<1)>>1]|0;q=d[k+(o<<1)>>1]|0;r=(p&65535)>(q&65535);d[l+(o<<1)>>1]=((r?p:q)&65535)-((r?q:p)&65535);o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<1)|0;l=l+(e<<1)|0;m=m+(j<<1)|0;n=n+-1|0}}return}n=h&-4;m=(n|0)<(h|0);l=c;c=f;f=a;a=g;while(1){g=0;do{k=d[f+(g<<1)>>1]|0;o=d[l+(g<<1)>>1]|0;p=(k&65535)>(o&65535);q=g|1;r=d[f+(q<<1)>>1]|0;s=d[l+(q<<1)>>1]|0;t=(r&65535)>(s&65535);d[c+(g<<1)>>1]=((p?k:o)&65535)-((p?o:k)&65535);d[c+(q<<1)>>1]=((t?r:s)&65535)-((t?s:r)&65535);r=g|2;s=d[f+(r<<1)>>1]|0;t=d[l+(r<<1)>>1]|0;q=(s&65535)>(t&65535);k=g|3;o=d[f+(k<<1)>>1]|0;p=d[l+(k<<1)>>1]|0;u=(o&65535)>(p&65535);d[c+(r<<1)>>1]=((q?s:t)&65535)-((q?t:s)&65535);d[c+(k<<1)>>1]=((u?o:p)&65535)-((u?p:o)&65535);g=g+4|0}while((g|0)<=(i|0));if(m){g=n;do{o=d[f+(g<<1)>>1]|0;p=d[l+(g<<1)>>1]|0;u=(o&65535)>(p&65535);d[c+(g<<1)>>1]=((u?o:p)&65535)-((u?p:o)&65535);g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}function s7(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;k=(h|0)<4;l=h&-4;m=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(k)n=0;else{i=0;do{o=(d[f+(i<<1)>>1]|0)-(d[m+(i<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=i|1;q=(d[f+(o<<1)>>1]|0)-(d[m+(o<<1)>>1]|0)|0;r=(q|0)>-1?q:0-q|0;d[c+(i<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[c+(o<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=i|2;o=(d[f+(r<<1)>>1]|0)-(d[m+(r<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=i|3;q=(d[f+(o<<1)>>1]|0)-(d[m+(o<<1)>>1]|0)|0;s=(q|0)>-1?q:0-q|0;d[c+(r<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[c+(o<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;i=i+4|0}while((i|0)<=(g|0));n=l}if((n|0)<(h|0)){i=n;do{s=(d[f+(i<<1)>>1]|0)-(d[m+(i<<1)>>1]|0)|0;o=(s|0)>-1?s:0-s|0;d[c+(i<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{m=m+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0}}return}function t7(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=c;l=e;m=a;n=g}else return;while(1){o=0;do{p=f[m+(o<<2)>>2]|0;q=f[k+(o<<2)>>2]|0;f[l+(o<<2)>>2]=(p|0)>(q|0)?p-q|0:q-p|0;o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(j<<2)|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){r=c;s=e;t=a;u=g}else{m=c;c=e;e=a;a=g;while(1){g=0;do{l=f[e+(g<<2)>>2]|0;k=f[m+(g<<2)>>2]|0;o=g|1;p=f[e+(o<<2)>>2]|0;q=f[m+(o<<2)>>2]|0;f[c+(g<<2)>>2]=(l|0)>(k|0)?l-k|0:k-l|0;f[c+(o<<2)>>2]=(p|0)>(q|0)?p-q|0:q-p|0;p=g|2;q=f[e+(p<<2)>>2]|0;o=f[m+(p<<2)>>2]|0;l=g|3;k=f[e+(l<<2)>>2]|0;v=f[m+(l<<2)>>2]|0;f[c+(p<<2)>>2]=(q|0)>(o|0)?q-o|0:o-q|0;f[c+(l<<2)>>2]=(k|0)>(v|0)?k-v|0:v-k|0;g=g+4|0}while((g|0)<=(i|0));if(!a)break;else{m=m+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=f[t+(a<<2)>>2]|0;c=f[r+(a<<2)>>2]|0;m=a|1;g=f[t+(m<<2)>>2]|0;k=f[r+(m<<2)>>2]|0;f[s+(a<<2)>>2]=(e|0)>(c|0)?e-c|0:c-e|0;f[s+(m<<2)>>2]=(g|0)>(k|0)?g-k|0:k-g|0;g=a|2;k=f[t+(g<<2)>>2]|0;m=f[r+(g<<2)>>2]|0;e=a|3;c=f[t+(e<<2)>>2]|0;v=f[r+(e<<2)>>2]|0;f[s+(g<<2)>>2]=(k|0)>(m|0)?k-m|0:m-k|0;f[s+(e<<2)>>2]=(c|0)>(v|0)?c-v|0:v-c|0;a=a+4|0}while((a|0)<=(i|0));w=n;do{a=f[t+(w<<2)>>2]|0;c=f[r+(w<<2)>>2]|0;f[s+(w<<2)>>2]=(a|0)>(c|0)?a-c|0:c-a|0;w=w+1|0}while((w|0)!=(h|0));if(!u)break;else{r=r+(b<<2)|0;s=s+(d<<2)|0;t=t+(j<<2)|0;u=u+-1|0}}return}function u7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0.0,v=0;i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){o=0;do{p=+L(+(+n[l+(o<<2)>>2]-+n[j+(o<<2)>>2]));n[k+(o<<2)>>2]=p;o=o+1|0}while((o|0)!=(g|0));if(!m)break;else{j=j+(b<<2)|0;k=k+(d<<2)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){q=c;r=e;s=a;t=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{p=+L(+(+n[e+(f<<2)>>2]-+n[l+(f<<2)>>2]));k=f|1;u=+L(+(+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2]));n[c+(f<<2)>>2]=p;n[c+(k<<2)>>2]=u;k=f|2;u=+L(+(+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2]));j=f|3;p=+L(+(+n[e+(j<<2)>>2]-+n[l+(j<<2)>>2]));n[c+(k<<2)>>2]=u;n[c+(j<<2)>>2]=p;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{p=+L(+(+n[s+(a<<2)>>2]-+n[q+(a<<2)>>2]));e=a|1;u=+L(+(+n[s+(e<<2)>>2]-+n[q+(e<<2)>>2]));n[r+(a<<2)>>2]=p;n[r+(e<<2)>>2]=u;e=a|2;u=+L(+(+n[s+(e<<2)>>2]-+n[q+(e<<2)>>2]));c=a|3;p=+L(+(+n[s+(c<<2)>>2]-+n[q+(c<<2)>>2]));n[r+(e<<2)>>2]=u;n[r+(c<<2)>>2]=p;a=a+4|0}while((a|0)<=(h|0));v=m;do{p=+L(+(+n[s+(v<<2)>>2]-+n[q+(v<<2)>>2]));n[r+(v<<2)>>2]=p;v=v+1|0}while((v|0)!=(g|0));if(!t)break;else{q=q+(b<<2)|0;r=r+(d<<2)|0;s=s+(i<<2)|0;t=t+-1|0}}return}function v7(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,u=0.0,v=0;i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){j=c;k=e;l=a;m=f}else return;while(1){n=0;do{o=+L(+(+p[l+(n<<3)>>3]-+p[j+(n<<3)>>3]));p[k+(n<<3)>>3]=o;n=n+1|0}while((n|0)!=(g|0));if(!m)break;else{j=j+(b<<3)|0;k=k+(d<<3)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=g&-4;if((m|0)<(g|0)){q=c;r=e;s=a;t=f}else{l=c;c=e;e=a;a=f;while(1){f=0;do{o=+L(+(+p[e+(f<<3)>>3]-+p[l+(f<<3)>>3]));k=f|1;u=+L(+(+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3]));p[c+(f<<3)>>3]=o;p[c+(k<<3)>>3]=u;k=f|2;u=+L(+(+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3]));j=f|3;o=+L(+(+p[e+(j<<3)>>3]-+p[l+(j<<3)>>3]));p[c+(k<<3)>>3]=u;p[c+(j<<3)>>3]=o;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{l=l+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{o=+L(+(+p[s+(a<<3)>>3]-+p[q+(a<<3)>>3]));e=a|1;u=+L(+(+p[s+(e<<3)>>3]-+p[q+(e<<3)>>3]));p[r+(a<<3)>>3]=o;p[r+(e<<3)>>3]=u;e=a|2;u=+L(+(+p[s+(e<<3)>>3]-+p[q+(e<<3)>>3]));c=a|3;o=+L(+(+p[s+(c<<3)>>3]-+p[q+(c<<3)>>3]));p[r+(e<<3)>>3]=u;p[r+(c<<3)>>3]=o;a=a+4|0}while((a|0)<=(h|0));v=m;do{o=+L(+(+p[s+(v<<3)>>3]-+p[q+(v<<3)>>3]));p[r+(v<<3)>>3]=o;v=v+1|0}while((v|0)!=(g|0));if(!t)break;else{q=q+(b<<3)|0;r=r+(d<<3)|0;s=s+(i<<3)|0;t=t+-1|0}}return}function w7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{b[l+o>>0]=b[k+o>>0]|b[m+o>>0];o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=d;q=f;r=a;s=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]|b[f+l>>0];b[d+j>>0]=b[m+j>>0]|b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;o=b[m+l>>0]|b[f+l>>0];b[d+k>>0]=b[m+k>>0]|b[f+k>>0];b[d+l>>0]=o;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[p+f>>0]|b[r+f>>0];b[q+a>>0]=b[p+a>>0]|b[r+a>>0];b[q+f>>0]=d;d=a|2;f=a|3;m=b[p+f>>0]|b[r+f>>0];b[q+d>>0]=b[p+d>>0]|b[r+d>>0];b[q+f>>0]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{b[q+t>>0]=b[p+t>>0]|b[r+t>>0];t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+e|0;q=q+g|0;r=r+c|0;s=s+-1|0}}return}function x7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{b[l+o>>0]=b[k+o>>0]^b[m+o>>0];o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=d;q=f;r=a;s=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]^b[f+l>>0];b[d+j>>0]=b[m+j>>0]^b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;o=b[m+l>>0]^b[f+l>>0];b[d+k>>0]=b[m+k>>0]^b[f+k>>0];b[d+l>>0]=o;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[p+f>>0]^b[r+f>>0];b[q+a>>0]=b[p+a>>0]^b[r+a>>0];b[q+f>>0]=d;d=a|2;f=a|3;m=b[p+f>>0]^b[r+f>>0];b[q+d>>0]=b[p+d>>0]^b[r+d>>0];b[q+f>>0]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{b[q+t>>0]=b[p+t>>0]^b[r+t>>0];t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+e|0;q=q+g|0;r=r+c|0;s=s+-1|0}}return}function y7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=d;l=f;m=a;n=j}else return;while(1){o=0;do{b[l+o>>0]=b[k+o>>0]&b[m+o>>0];o=o+1|0}while((o|0)!=(h|0));if(!n)break;else{k=k+e|0;l=l+g|0;m=m+c|0;n=n+-1|0}}return}n=h&-4;if((n|0)<(h|0)){p=d;q=f;r=a;s=j}else{m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]&b[f+l>>0];b[d+j>>0]=b[m+j>>0]&b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;o=b[m+l>>0]&b[f+l>>0];b[d+k>>0]=b[m+k>>0]&b[f+k>>0];b[d+l>>0]=o;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;d=b[p+f>>0]&b[r+f>>0];b[q+a>>0]=b[p+a>>0]&b[r+a>>0];b[q+f>>0]=d;d=a|2;f=a|3;m=b[p+f>>0]&b[r+f>>0];b[q+d>>0]=b[p+d>>0]&b[r+d>>0];b[q+f>>0]=m;a=a+4|0}while((a|0)<=(i|0));t=n;do{b[q+t>>0]=b[p+t>>0]&b[r+t>>0];t=t+1|0}while((t|0)!=(h|0));if(!s)break;else{p=p+e|0;q=q+g|0;r=r+c|0;s=s+-1|0}}return}function z7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){j=f;k=a;l=e}else return;while(1){d=0;do{b[j+d>>0]=~b[k+d>>0];d=d+1|0}while((d|0)!=(h|0));if(!l)break;else{j=j+g|0;k=k+c|0;l=l+-1|0}}return}l=h&-4;if((l|0)<(h|0)){m=f;n=a;o=e}else{k=f;f=a;a=e;while(1){e=0;do{j=e|1;d=~b[f+j>>0];b[k+e>>0]=~b[f+e>>0];b[k+j>>0]=d;d=e|2;j=e|3;p=~b[f+j>>0];b[k+d>>0]=~b[f+d>>0];b[k+j>>0]=p;e=e+4|0}while((e|0)<=(i|0));if(!a)break;else{k=k+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;k=~b[n+f>>0];b[m+a>>0]=~b[n+a>>0];b[m+f>>0]=k;k=a|2;f=a|3;e=~b[n+f>>0];b[m+k>>0]=~b[n+k>>0];b[m+f>>0]=e;a=a+4|0}while((a|0)<=(i|0));q=l;do{b[m+q>>0]=~b[n+q>>0];q=q+1|0}while((q|0)!=(h|0));if(!o)break;else{m=m+g|0;n=n+c|0;o=o+-1|0}}return}function A7(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{B7(a,c,d,e,g,h,i,j);u=l;return}case 1:{B7(d,e,a,c,g,h,i,j);u=l;return}case 4:{C7(a,c,d,e,g,h,i,j);u=l;return}case 2:{C7(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=j+-1|0;if(!j){u=l;return}n=i+-4|0;if((i|0)<4){if((i|0)>0){o=d;p=g;q=a;r=k}else{u=l;return}while(1){s=0;do{b[p+s>>0]=((b[q+s>>0]|0)==(b[o+s>>0]|0))<<31>>31;s=s+1|0}while((s|0)!=(i|0));if(!r)break;else{o=o+e|0;p=p+h|0;q=q+c|0;r=r+-1|0}}u=l;return}r=i&-4;if((r|0)<(i|0)){t=d;v=g;w=a;x=k}else{q=d;p=g;o=a;s=k;while(1){k=0;do{y=k|1;z=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+k>>0]=((b[o+k>>0]|0)==(b[q+k>>0]|0))<<31>>31;b[p+y>>0]=z;z=k|2;y=k|3;A=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+z>>0]=((b[o+z>>0]|0)==(b[q+z>>0]|0))<<31>>31;b[p+y>>0]=A;k=k+4|0}while((k|0)<=(n|0));if(!s)break;else{q=q+e|0;p=p+h|0;o=o+c|0;s=s+-1|0}}u=l;return}while(1){s=0;do{o=s|1;p=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+s>>0]=((b[w+s>>0]|0)==(b[t+s>>0]|0))<<31>>31;b[v+o>>0]=p;p=s|2;o=s|3;q=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+p>>0]=((b[w+p>>0]|0)==(b[t+p>>0]|0))<<31>>31;b[v+o>>0]=q;s=s+4|0}while((s|0)<=(n|0));B=r;do{b[v+B>>0]=((b[w+B>>0]|0)==(b[t+B>>0]|0))<<31>>31;B=B+1|0}while((B|0)!=(i|0));if(!x)break;else{t=t+e|0;v=v+h|0;w=w+c|0;x=x+-1|0}}u=l;return}case 5:{x=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){C=d;D=g;E=a;F=x}else{u=l;return}while(1){w=0;do{b[D+w>>0]=((b[E+w>>0]|0)!=(b[C+w>>0]|0))<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!F)break;else{C=C+e|0;D=D+h|0;E=E+c|0;F=F+-1|0}}u=l;return}F=i&-4;if((F|0)<(i|0)){G=d;H=g;I=a;J=x}else{E=d;d=g;g=a;a=x;while(1){x=0;do{D=x|1;C=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+x>>0]=((b[g+x>>0]|0)!=(b[E+x>>0]|0))<<31>>31;b[d+D>>0]=C;C=x|2;D=x|3;w=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+C>>0]=((b[g+C>>0]|0)!=(b[E+C>>0]|0))<<31>>31;b[d+D>>0]=w;x=x+4|0}while((x|0)<=(j|0));if(!a)break;else{E=E+e|0;d=d+h|0;g=g+c|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+a>>0]=((b[I+a>>0]|0)!=(b[G+a>>0]|0))<<31>>31;b[H+g>>0]=d;d=a|2;g=a|3;E=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+d>>0]=((b[I+d>>0]|0)!=(b[G+d>>0]|0))<<31>>31;b[H+g>>0]=E;a=a+4|0}while((a|0)<=(j|0));K=F;do{b[H+K>>0]=((b[I+K>>0]|0)!=(b[G+K>>0]|0))<<31>>31;K=K+1|0}while((K|0)!=(i|0));if(!J)break;else{G=G+e|0;H=H+h|0;I=I+c|0;J=J+-1|0}}u=l;return}default:{l=$Xc(16)|0;f[m>>2]=l;f[m+8>>2]=-2147483632;f[m+4>>2]=15;J=l;c=249826;I=J+15|0;do{b[J>>0]=b[c>>0]|0;J=J+1|0;c=c+1|0}while((J|0)<(I|0));b[l+15>>0]=0;vM(-215,m,249842,249851,759)}}}function B7(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{b[n+q>>0]=((h[o+q>>0]|0)<(h[m+q>>0]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=((h[f+m>>0]|0)<(h[n+m>>0]|0))<<31>>31;b[d+k>>0]=((h[f+k>>0]|0)<(h[n+k>>0]|0))<<31>>31;b[d+m>>0]=l;l=k|2;m=k|3;q=((h[f+m>>0]|0)<(h[n+m>>0]|0))<<31>>31;b[d+l>>0]=((h[f+l>>0]|0)<(h[n+l>>0]|0))<<31>>31;b[d+m>>0]=q;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{b[d+k>>0]=((h[f+k>>0]|0)<(h[n+k>>0]|0))<<31>>31;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function C7(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{b[n+q>>0]=((h[o+q>>0]|0)<=(h[m+q>>0]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=((h[f+m>>0]|0)<=(h[n+m>>0]|0))<<31>>31;b[d+k>>0]=((h[f+k>>0]|0)<=(h[n+k>>0]|0))<<31>>31;b[d+m>>0]=l;l=k|2;m=k|3;q=((h[f+m>>0]|0)<=(h[n+m>>0]|0))<<31>>31;b[d+l>>0]=((h[f+l>>0]|0)<=(h[n+l>>0]|0))<<31>>31;b[d+m>>0]=q;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{b[d+k>>0]=((h[f+k>>0]|0)<=(h[n+k>>0]|0))<<31>>31;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function D7(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{E7(a,c,d,e,g,h,i,j);u=l;return}case 1:{E7(d,e,a,c,g,h,i,j);u=l;return}case 4:{F7(a,c,d,e,g,h,i,j);u=l;return}case 2:{F7(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=j+-1|0;if(!j){u=l;return}n=i+-4|0;if((i|0)<4){if((i|0)>0){o=d;p=g;q=a;r=k}else{u=l;return}while(1){s=0;do{b[p+s>>0]=((b[q+s>>0]|0)==(b[o+s>>0]|0))<<31>>31;s=s+1|0}while((s|0)!=(i|0));if(!r)break;else{o=o+e|0;p=p+h|0;q=q+c|0;r=r+-1|0}}u=l;return}r=i&-4;if((r|0)<(i|0)){t=d;v=g;w=a;x=k}else{q=d;p=g;o=a;s=k;while(1){k=0;do{y=k|1;z=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+k>>0]=((b[o+k>>0]|0)==(b[q+k>>0]|0))<<31>>31;b[p+y>>0]=z;z=k|2;y=k|3;A=((b[o+y>>0]|0)==(b[q+y>>0]|0))<<31>>31;b[p+z>>0]=((b[o+z>>0]|0)==(b[q+z>>0]|0))<<31>>31;b[p+y>>0]=A;k=k+4|0}while((k|0)<=(n|0));if(!s)break;else{q=q+e|0;p=p+h|0;o=o+c|0;s=s+-1|0}}u=l;return}while(1){s=0;do{o=s|1;p=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+s>>0]=((b[w+s>>0]|0)==(b[t+s>>0]|0))<<31>>31;b[v+o>>0]=p;p=s|2;o=s|3;q=((b[w+o>>0]|0)==(b[t+o>>0]|0))<<31>>31;b[v+p>>0]=((b[w+p>>0]|0)==(b[t+p>>0]|0))<<31>>31;b[v+o>>0]=q;s=s+4|0}while((s|0)<=(n|0));B=r;do{b[v+B>>0]=((b[w+B>>0]|0)==(b[t+B>>0]|0))<<31>>31;B=B+1|0}while((B|0)!=(i|0));if(!x)break;else{t=t+e|0;v=v+h|0;w=w+c|0;x=x+-1|0}}u=l;return}case 5:{x=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){C=d;D=g;E=a;F=x}else{u=l;return}while(1){w=0;do{b[D+w>>0]=((b[E+w>>0]|0)!=(b[C+w>>0]|0))<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!F)break;else{C=C+e|0;D=D+h|0;E=E+c|0;F=F+-1|0}}u=l;return}F=i&-4;if((F|0)<(i|0)){G=d;H=g;I=a;J=x}else{E=d;d=g;g=a;a=x;while(1){x=0;do{D=x|1;C=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+x>>0]=((b[g+x>>0]|0)!=(b[E+x>>0]|0))<<31>>31;b[d+D>>0]=C;C=x|2;D=x|3;w=((b[g+D>>0]|0)!=(b[E+D>>0]|0))<<31>>31;b[d+C>>0]=((b[g+C>>0]|0)!=(b[E+C>>0]|0))<<31>>31;b[d+D>>0]=w;x=x+4|0}while((x|0)<=(j|0));if(!a)break;else{E=E+e|0;d=d+h|0;g=g+c|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+a>>0]=((b[I+a>>0]|0)!=(b[G+a>>0]|0))<<31>>31;b[H+g>>0]=d;d=a|2;g=a|3;E=((b[I+g>>0]|0)!=(b[G+g>>0]|0))<<31>>31;b[H+d>>0]=((b[I+d>>0]|0)!=(b[G+d>>0]|0))<<31>>31;b[H+g>>0]=E;a=a+4|0}while((a|0)<=(j|0));K=F;do{b[H+K>>0]=((b[I+K>>0]|0)!=(b[G+K>>0]|0))<<31>>31;K=K+1|0}while((K|0)!=(i|0));if(!J)break;else{G=G+e|0;H=H+h|0;I=I+c|0;J=J+-1|0}}u=l;return}default:{l=$Xc(16)|0;f[m>>2]=l;f[m+8>>2]=-2147483632;f[m+4>>2]=15;J=l;c=249826;I=J+15|0;do{b[J>>0]=b[c>>0]|0;J=J+1|0;c=c+1|0}while((J|0)<(I|0));b[l+15>>0]=0;vM(-215,m,249842,249851,759)}}}function E7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{b[m+p>>0]=((b[n+p>>0]|0)<(b[l+p>>0]|0))<<31>>31;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=((b[f+l>>0]|0)<(b[m+l>>0]|0))<<31>>31;b[d+j>>0]=((b[f+j>>0]|0)<(b[m+j>>0]|0))<<31>>31;b[d+l>>0]=k;k=j|2;l=j|3;p=((b[f+l>>0]|0)<(b[m+l>>0]|0))<<31>>31;b[d+k>>0]=((b[f+k>>0]|0)<(b[m+k>>0]|0))<<31>>31;b[d+l>>0]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{b[d+j>>0]=((b[f+j>>0]|0)<(b[m+j>>0]|0))<<31>>31;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function F7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{b[m+p>>0]=((b[n+p>>0]|0)<=(b[l+p>>0]|0))<<31>>31;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=((b[f+l>>0]|0)<=(b[m+l>>0]|0))<<31>>31;b[d+j>>0]=((b[f+j>>0]|0)<=(b[m+j>>0]|0))<<31>>31;b[d+l>>0]=k;k=j|2;l=j|3;p=((b[f+l>>0]|0)<=(b[m+l>>0]|0))<<31>>31;b[d+k>>0]=((b[f+k>>0]|0)<=(b[m+k>>0]|0))<<31>>31;b[d+l>>0]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{b[d+j>>0]=((b[f+j>>0]|0)<=(b[m+j>>0]|0))<<31>>31;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function G7(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;m=u;u=u+16|0;n=m;switch(l|0){case 3:{H7(a,c,e,g,h,i,j,k);u=m;return}case 1:{H7(e,g,a,c,h,i,j,k);u=m;return}case 4:{I7(a,c,e,g,h,i,j,k);u=m;return}case 2:{I7(e,g,a,c,h,i,j,k);u=m;return}case 0:{l=c>>>1;o=g>>>1;p=k+-1|0;if(!k){u=m;return}q=j+-4|0;if((j|0)<4){if((j|0)>0){r=e;s=h;t=a;v=p}else{u=m;return}while(1){w=0;do{b[s+w>>0]=((d[t+(w<<1)>>1]|0)==(d[r+(w<<1)>>1]|0))<<31>>31;w=w+1|0}while((w|0)!=(j|0));if(!v)break;else{r=r+(o<<1)|0;s=s+i|0;t=t+(l<<1)|0;v=v+-1|0}}u=m;return}v=j&-4;if((v|0)<(j|0)){x=e;y=h;z=a;A=p}else{t=e;s=h;r=a;w=p;while(1){p=0;do{B=p|1;C=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+p>>0]=((d[r+(p<<1)>>1]|0)==(d[t+(p<<1)>>1]|0))<<31>>31;b[s+B>>0]=C;C=p|2;B=p|3;D=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+C>>0]=((d[r+(C<<1)>>1]|0)==(d[t+(C<<1)>>1]|0))<<31>>31;b[s+B>>0]=D;p=p+4|0}while((p|0)<=(q|0));if(!w)break;else{t=t+(o<<1)|0;s=s+i|0;r=r+(l<<1)|0;w=w+-1|0}}u=m;return}while(1){w=0;do{r=w|1;s=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+w>>0]=((d[z+(w<<1)>>1]|0)==(d[x+(w<<1)>>1]|0))<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+s>>0]=((d[z+(s<<1)>>1]|0)==(d[x+(s<<1)>>1]|0))<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=((d[z+(E<<1)>>1]|0)==(d[x+(E<<1)>>1]|0))<<31>>31;E=E+1|0}while((E|0)!=(j|0));if(!A)break;else{x=x+(o<<1)|0;y=y+i|0;z=z+(l<<1)|0;A=A+-1|0}}u=m;return}case 5:{A=c>>>1;c=g>>>1;g=k+-1|0;if(!k){u=m;return}k=j+-4|0;if((j|0)<4){if((j|0)>0){F=e;G=h;H=a;I=g}else{u=m;return}while(1){l=0;do{b[G+l>>0]=((d[H+(l<<1)>>1]|0)!=(d[F+(l<<1)>>1]|0))<<31>>31;l=l+1|0}while((l|0)!=(j|0));if(!I)break;else{F=F+(c<<1)|0;G=G+i|0;H=H+(A<<1)|0;I=I+-1|0}}u=m;return}I=j&-4;if((I|0)<(j|0)){J=e;K=h;L=a;M=g}else{H=e;e=h;h=a;a=g;while(1){g=0;do{G=g|1;F=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+g>>0]=((d[h+(g<<1)>>1]|0)!=(d[H+(g<<1)>>1]|0))<<31>>31;b[e+G>>0]=F;F=g|2;G=g|3;l=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+F>>0]=((d[h+(F<<1)>>1]|0)!=(d[H+(F<<1)>>1]|0))<<31>>31;b[e+G>>0]=l;g=g+4|0}while((g|0)<=(k|0));if(!a)break;else{H=H+(c<<1)|0;e=e+i|0;h=h+(A<<1)|0;a=a+-1|0}}u=m;return}while(1){a=0;do{h=a|1;e=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+a>>0]=((d[L+(a<<1)>>1]|0)!=(d[J+(a<<1)>>1]|0))<<31>>31;b[K+h>>0]=e;e=a|2;h=a|3;H=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+e>>0]=((d[L+(e<<1)>>1]|0)!=(d[J+(e<<1)>>1]|0))<<31>>31;b[K+h>>0]=H;a=a+4|0}while((a|0)<=(k|0));N=I;do{b[K+N>>0]=((d[L+(N<<1)>>1]|0)!=(d[J+(N<<1)>>1]|0))<<31>>31;N=N+1|0}while((N|0)!=(j|0));if(!M)break;else{J=J+(c<<1)|0;K=K+i|0;L=L+(A<<1)|0;M=M+-1|0}}u=m;return}default:{m=$Xc(16)|0;f[n>>2]=m;f[n+8>>2]=-2147483632;f[n+4>>2]=15;M=m;A=249826;L=M+15|0;do{b[M>>0]=b[A>>0]|0;M=M+1|0;A=A+1|0}while((M|0)<(L|0));b[m+15>>0]=0;vM(-215,n,249842,249851,759)}}}function H7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=e>>>1;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=d;n=f;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((j[o+(q<<1)>>1]|0)<(j[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+g|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);n=d;d=f;f=a;a=e;while(1){e=0;do{m=e|1;l=((j[f+(m<<1)>>1]|0)<(j[n+(m<<1)>>1]|0))<<31>>31;b[d+e>>0]=((j[f+(e<<1)>>1]|0)<(j[n+(e<<1)>>1]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((j[f+(m<<1)>>1]|0)<(j[n+(m<<1)>>1]|0))<<31>>31;b[d+l>>0]=((j[f+(l<<1)>>1]|0)<(j[n+(l<<1)>>1]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=((j[f+(e<<1)>>1]|0)<(j[n+(e<<1)>>1]|0))<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{n=n+(c<<1)|0;d=d+g|0;f=f+(k<<1)|0;a=a+-1|0}}return}function I7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=e>>>1;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=d;n=f;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((j[o+(q<<1)>>1]|0)<=(j[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+g|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);n=d;d=f;f=a;a=e;while(1){e=0;do{m=e|1;l=((j[f+(m<<1)>>1]|0)<=(j[n+(m<<1)>>1]|0))<<31>>31;b[d+e>>0]=((j[f+(e<<1)>>1]|0)<=(j[n+(e<<1)>>1]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((j[f+(m<<1)>>1]|0)<=(j[n+(m<<1)>>1]|0))<<31>>31;b[d+l>>0]=((j[f+(l<<1)>>1]|0)<=(j[n+(l<<1)>>1]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=((j[f+(e<<1)>>1]|0)<=(j[n+(e<<1)>>1]|0))<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{n=n+(c<<1)|0;d=d+g|0;f=f+(k<<1)|0;a=a+-1|0}}return}function J7(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;m=u;u=u+16|0;n=m;switch(l|0){case 3:{K7(a,c,e,g,h,i,j,k);u=m;return}case 1:{K7(e,g,a,c,h,i,j,k);u=m;return}case 4:{L7(a,c,e,g,h,i,j,k);u=m;return}case 2:{L7(e,g,a,c,h,i,j,k);u=m;return}case 0:{l=c>>>1;o=g>>>1;p=k+-1|0;if(!k){u=m;return}q=j+-4|0;if((j|0)<4){if((j|0)>0){r=e;s=h;t=a;v=p}else{u=m;return}while(1){w=0;do{b[s+w>>0]=((d[t+(w<<1)>>1]|0)==(d[r+(w<<1)>>1]|0))<<31>>31;w=w+1|0}while((w|0)!=(j|0));if(!v)break;else{r=r+(o<<1)|0;s=s+i|0;t=t+(l<<1)|0;v=v+-1|0}}u=m;return}v=j&-4;if((v|0)<(j|0)){x=e;y=h;z=a;A=p}else{t=e;s=h;r=a;w=p;while(1){p=0;do{B=p|1;C=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+p>>0]=((d[r+(p<<1)>>1]|0)==(d[t+(p<<1)>>1]|0))<<31>>31;b[s+B>>0]=C;C=p|2;B=p|3;D=((d[r+(B<<1)>>1]|0)==(d[t+(B<<1)>>1]|0))<<31>>31;b[s+C>>0]=((d[r+(C<<1)>>1]|0)==(d[t+(C<<1)>>1]|0))<<31>>31;b[s+B>>0]=D;p=p+4|0}while((p|0)<=(q|0));if(!w)break;else{t=t+(o<<1)|0;s=s+i|0;r=r+(l<<1)|0;w=w+-1|0}}u=m;return}while(1){w=0;do{r=w|1;s=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+w>>0]=((d[z+(w<<1)>>1]|0)==(d[x+(w<<1)>>1]|0))<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=((d[z+(r<<1)>>1]|0)==(d[x+(r<<1)>>1]|0))<<31>>31;b[y+s>>0]=((d[z+(s<<1)>>1]|0)==(d[x+(s<<1)>>1]|0))<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=((d[z+(E<<1)>>1]|0)==(d[x+(E<<1)>>1]|0))<<31>>31;E=E+1|0}while((E|0)!=(j|0));if(!A)break;else{x=x+(o<<1)|0;y=y+i|0;z=z+(l<<1)|0;A=A+-1|0}}u=m;return}case 5:{A=c>>>1;c=g>>>1;g=k+-1|0;if(!k){u=m;return}k=j+-4|0;if((j|0)<4){if((j|0)>0){F=e;G=h;H=a;I=g}else{u=m;return}while(1){l=0;do{b[G+l>>0]=((d[H+(l<<1)>>1]|0)!=(d[F+(l<<1)>>1]|0))<<31>>31;l=l+1|0}while((l|0)!=(j|0));if(!I)break;else{F=F+(c<<1)|0;G=G+i|0;H=H+(A<<1)|0;I=I+-1|0}}u=m;return}I=j&-4;if((I|0)<(j|0)){J=e;K=h;L=a;M=g}else{H=e;e=h;h=a;a=g;while(1){g=0;do{G=g|1;F=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+g>>0]=((d[h+(g<<1)>>1]|0)!=(d[H+(g<<1)>>1]|0))<<31>>31;b[e+G>>0]=F;F=g|2;G=g|3;l=((d[h+(G<<1)>>1]|0)!=(d[H+(G<<1)>>1]|0))<<31>>31;b[e+F>>0]=((d[h+(F<<1)>>1]|0)!=(d[H+(F<<1)>>1]|0))<<31>>31;b[e+G>>0]=l;g=g+4|0}while((g|0)<=(k|0));if(!a)break;else{H=H+(c<<1)|0;e=e+i|0;h=h+(A<<1)|0;a=a+-1|0}}u=m;return}while(1){a=0;do{h=a|1;e=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+a>>0]=((d[L+(a<<1)>>1]|0)!=(d[J+(a<<1)>>1]|0))<<31>>31;b[K+h>>0]=e;e=a|2;h=a|3;H=((d[L+(h<<1)>>1]|0)!=(d[J+(h<<1)>>1]|0))<<31>>31;b[K+e>>0]=((d[L+(e<<1)>>1]|0)!=(d[J+(e<<1)>>1]|0))<<31>>31;b[K+h>>0]=H;a=a+4|0}while((a|0)<=(k|0));N=I;do{b[K+N>>0]=((d[L+(N<<1)>>1]|0)!=(d[J+(N<<1)>>1]|0))<<31>>31;N=N+1|0}while((N|0)!=(j|0));if(!M)break;else{J=J+(c<<1)|0;K=K+i|0;L=L+(A<<1)|0;M=M+-1|0}}u=m;return}default:{m=$Xc(16)|0;f[n>>2]=m;f[n+8>>2]=-2147483632;f[n+4>>2]=15;M=m;A=249826;L=M+15|0;do{b[M>>0]=b[A>>0]|0;M=M+1|0;A=A+1|0}while((M|0)<(L|0));b[m+15>>0]=0;vM(-215,n,249842,249851,759)}}}function K7(a,c,e,f,g,h,i,j){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=f>>>1;f=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=e;n=g;o=a;p=f;while(1){if(l){q=0;do{b[n+q>>0]=((d[o+(q<<1)>>1]|0)<(d[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+h|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=e;e=g;g=a;a=f;while(1){f=0;do{m=f|1;l=((d[g+(m<<1)>>1]|0)<(d[n+(m<<1)>>1]|0))<<31>>31;b[e+f>>0]=((d[g+(f<<1)>>1]|0)<(d[n+(f<<1)>>1]|0))<<31>>31;b[e+m>>0]=l;l=f|2;m=f|3;q=((d[g+(m<<1)>>1]|0)<(d[n+(m<<1)>>1]|0))<<31>>31;b[e+l>>0]=((d[g+(l<<1)>>1]|0)<(d[n+(l<<1)>>1]|0))<<31>>31;b[e+m>>0]=q;f=f+4|0}while((f|0)<=(j|0));if(o){f=p;do{b[e+f>>0]=((d[g+(f<<1)>>1]|0)<(d[n+(f<<1)>>1]|0))<<31>>31;f=f+1|0}while((f|0)!=(i|0))}if(!a)break;else{n=n+(c<<1)|0;e=e+h|0;g=g+(k<<1)|0;a=a+-1|0}}return}function L7(a,c,e,f,g,h,i,j){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>1;c=f>>>1;f=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=e;n=g;o=a;p=f;while(1){if(l){q=0;do{b[n+q>>0]=((d[o+(q<<1)>>1]|0)<=(d[m+(q<<1)>>1]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<1)|0;n=n+h|0;o=o+(k<<1)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=e;e=g;g=a;a=f;while(1){f=0;do{m=f|1;l=((d[g+(m<<1)>>1]|0)<=(d[n+(m<<1)>>1]|0))<<31>>31;b[e+f>>0]=((d[g+(f<<1)>>1]|0)<=(d[n+(f<<1)>>1]|0))<<31>>31;b[e+m>>0]=l;l=f|2;m=f|3;q=((d[g+(m<<1)>>1]|0)<=(d[n+(m<<1)>>1]|0))<<31>>31;b[e+l>>0]=((d[g+(l<<1)>>1]|0)<=(d[n+(l<<1)>>1]|0))<<31>>31;b[e+m>>0]=q;f=f+4|0}while((f|0)<=(j|0));if(o){f=p;do{b[e+f>>0]=((d[g+(f<<1)>>1]|0)<=(d[n+(f<<1)>>1]|0))<<31>>31;f=f+1|0}while((f|0)!=(i|0))}if(!a)break;else{n=n+(c<<1)|0;e=e+h|0;g=g+(k<<1)|0;a=a+-1|0}}return}function M7(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{N7(a,c,d,e,g,h,i,j);u=l;return}case 1:{N7(d,e,a,c,g,h,i,j);u=l;return}case 4:{O7(a,c,d,e,g,h,i,j);u=l;return}case 2:{O7(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=c>>>2;n=e>>>2;o=j+-1|0;if(!j){u=l;return}p=i+-4|0;if((i|0)<4){if((i|0)>0){q=d;r=g;s=a;t=o}else{u=l;return}while(1){v=0;do{b[r+v>>0]=((f[s+(v<<2)>>2]|0)==(f[q+(v<<2)>>2]|0))<<31>>31;v=v+1|0}while((v|0)!=(i|0));if(!t)break;else{q=q+(n<<2)|0;r=r+h|0;s=s+(k<<2)|0;t=t+-1|0}}u=l;return}t=i&-4;if((t|0)<(i|0)){w=d;x=g;y=a;z=o}else{s=d;r=g;q=a;v=o;while(1){o=0;do{A=o|1;B=((f[q+(A<<2)>>2]|0)==(f[s+(A<<2)>>2]|0))<<31>>31;b[r+o>>0]=((f[q+(o<<2)>>2]|0)==(f[s+(o<<2)>>2]|0))<<31>>31;b[r+A>>0]=B;B=o|2;A=o|3;C=((f[q+(A<<2)>>2]|0)==(f[s+(A<<2)>>2]|0))<<31>>31;b[r+B>>0]=((f[q+(B<<2)>>2]|0)==(f[s+(B<<2)>>2]|0))<<31>>31;b[r+A>>0]=C;o=o+4|0}while((o|0)<=(p|0));if(!v)break;else{s=s+(n<<2)|0;r=r+h|0;q=q+(k<<2)|0;v=v+-1|0}}u=l;return}while(1){v=0;do{q=v|1;r=((f[y+(q<<2)>>2]|0)==(f[w+(q<<2)>>2]|0))<<31>>31;b[x+v>>0]=((f[y+(v<<2)>>2]|0)==(f[w+(v<<2)>>2]|0))<<31>>31;b[x+q>>0]=r;r=v|2;q=v|3;s=((f[y+(q<<2)>>2]|0)==(f[w+(q<<2)>>2]|0))<<31>>31;b[x+r>>0]=((f[y+(r<<2)>>2]|0)==(f[w+(r<<2)>>2]|0))<<31>>31;b[x+q>>0]=s;v=v+4|0}while((v|0)<=(p|0));D=t;do{b[x+D>>0]=((f[y+(D<<2)>>2]|0)==(f[w+(D<<2)>>2]|0))<<31>>31;D=D+1|0}while((D|0)!=(i|0));if(!z)break;else{w=w+(n<<2)|0;x=x+h|0;y=y+(k<<2)|0;z=z+-1|0}}u=l;return}case 5:{z=c>>>2;c=e>>>2;e=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){E=d;F=g;G=a;H=e}else{u=l;return}while(1){k=0;do{b[F+k>>0]=((f[G+(k<<2)>>2]|0)!=(f[E+(k<<2)>>2]|0))<<31>>31;k=k+1|0}while((k|0)!=(i|0));if(!H)break;else{E=E+(c<<2)|0;F=F+h|0;G=G+(z<<2)|0;H=H+-1|0}}u=l;return}H=i&-4;if((H|0)<(i|0)){I=d;J=g;K=a;L=e}else{G=d;d=g;g=a;a=e;while(1){e=0;do{F=e|1;E=((f[g+(F<<2)>>2]|0)!=(f[G+(F<<2)>>2]|0))<<31>>31;b[d+e>>0]=((f[g+(e<<2)>>2]|0)!=(f[G+(e<<2)>>2]|0))<<31>>31;b[d+F>>0]=E;E=e|2;F=e|3;k=((f[g+(F<<2)>>2]|0)!=(f[G+(F<<2)>>2]|0))<<31>>31;b[d+E>>0]=((f[g+(E<<2)>>2]|0)!=(f[G+(E<<2)>>2]|0))<<31>>31;b[d+F>>0]=k;e=e+4|0}while((e|0)<=(j|0));if(!a)break;else{G=G+(c<<2)|0;d=d+h|0;g=g+(z<<2)|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=((f[K+(g<<2)>>2]|0)!=(f[I+(g<<2)>>2]|0))<<31>>31;b[J+a>>0]=((f[K+(a<<2)>>2]|0)!=(f[I+(a<<2)>>2]|0))<<31>>31;b[J+g>>0]=d;d=a|2;g=a|3;G=((f[K+(g<<2)>>2]|0)!=(f[I+(g<<2)>>2]|0))<<31>>31;b[J+d>>0]=((f[K+(d<<2)>>2]|0)!=(f[I+(d<<2)>>2]|0))<<31>>31;b[J+g>>0]=G;a=a+4|0}while((a|0)<=(j|0));M=H;do{b[J+M>>0]=((f[K+(M<<2)>>2]|0)!=(f[I+(M<<2)>>2]|0))<<31>>31;M=M+1|0}while((M|0)!=(i|0));if(!L)break;else{I=I+(c<<2)|0;J=J+h|0;K=K+(z<<2)|0;L=L+-1|0}}u=l;return}default:{l=$Xc(16)|0;f[m>>2]=l;f[m+8>>2]=-2147483632;f[m+4>>2]=15;L=l;z=249826;K=L+15|0;do{b[L>>0]=b[z>>0]|0;L=L+1|0;z=z+1|0}while((L|0)<(K|0));b[l+15>>0]=0;vM(-215,m,249842,249851,759)}}}function N7(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>2;c=e>>>2;e=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=g;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((f[o+(q<<2)>>2]|0)<(f[m+(q<<2)>>2]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<2)|0;n=n+h|0;o=o+(k<<2)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=g;g=a;a=e;while(1){e=0;do{m=e|1;l=((f[g+(m<<2)>>2]|0)<(f[n+(m<<2)>>2]|0))<<31>>31;b[d+e>>0]=((f[g+(e<<2)>>2]|0)<(f[n+(e<<2)>>2]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((f[g+(m<<2)>>2]|0)<(f[n+(m<<2)>>2]|0))<<31>>31;b[d+l>>0]=((f[g+(l<<2)>>2]|0)<(f[n+(l<<2)>>2]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(j|0));if(o){e=p;do{b[d+e>>0]=((f[g+(e<<2)>>2]|0)<(f[n+(e<<2)>>2]|0))<<31>>31;e=e+1|0}while((e|0)!=(i|0))}if(!a)break;else{n=n+(c<<2)|0;d=d+h|0;g=g+(k<<2)|0;a=a+-1|0}}return}function O7(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=c>>>2;c=e>>>2;e=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=g;o=a;p=e;while(1){if(l){q=0;do{b[n+q>>0]=((f[o+(q<<2)>>2]|0)<=(f[m+(q<<2)>>2]|0))<<31>>31;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+(c<<2)|0;n=n+h|0;o=o+(k<<2)|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=g;g=a;a=e;while(1){e=0;do{m=e|1;l=((f[g+(m<<2)>>2]|0)<=(f[n+(m<<2)>>2]|0))<<31>>31;b[d+e>>0]=((f[g+(e<<2)>>2]|0)<=(f[n+(e<<2)>>2]|0))<<31>>31;b[d+m>>0]=l;l=e|2;m=e|3;q=((f[g+(m<<2)>>2]|0)<=(f[n+(m<<2)>>2]|0))<<31>>31;b[d+l>>0]=((f[g+(l<<2)>>2]|0)<=(f[n+(l<<2)>>2]|0))<<31>>31;b[d+m>>0]=q;e=e+4|0}while((e|0)<=(j|0));if(o){e=p;do{b[d+e>>0]=((f[g+(e<<2)>>2]|0)<=(f[n+(e<<2)>>2]|0))<<31>>31;e=e+1|0}while((e|0)!=(i|0))}if(!a)break;else{n=n+(c<<2)|0;d=d+h|0;g=g+(k<<2)|0;a=a+-1|0}}return}function P7(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{Q7(a,c,d,e,g,h,i,j);u=l;return}case 1:{Q7(d,e,a,c,g,h,i,j);u=l;return}case 4:{R7(a,c,d,e,g,h,i,j);u=l;return}case 2:{R7(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=c>>>2;o=e>>>2;p=j+-1|0;if(!j){u=l;return}q=i+-4|0;if((i|0)<4){if((i|0)>0){r=d;s=g;t=a;v=p}else{u=l;return}while(1){w=0;do{b[s+w>>0]=(+n[t+(w<<2)>>2]==+n[r+(w<<2)>>2])<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!v)break;else{r=r+(o<<2)|0;s=s+h|0;t=t+(k<<2)|0;v=v+-1|0}}u=l;return}v=i&-4;if((v|0)<(i|0)){x=d;y=g;z=a;A=p}else{t=d;s=g;r=a;w=p;while(1){p=0;do{B=p|1;C=(+n[r+(B<<2)>>2]==+n[t+(B<<2)>>2])<<31>>31;b[s+p>>0]=(+n[r+(p<<2)>>2]==+n[t+(p<<2)>>2])<<31>>31;b[s+B>>0]=C;C=p|2;B=p|3;D=(+n[r+(B<<2)>>2]==+n[t+(B<<2)>>2])<<31>>31;b[s+C>>0]=(+n[r+(C<<2)>>2]==+n[t+(C<<2)>>2])<<31>>31;b[s+B>>0]=D;p=p+4|0}while((p|0)<=(q|0));if(!w)break;else{t=t+(o<<2)|0;s=s+h|0;r=r+(k<<2)|0;w=w+-1|0}}u=l;return}while(1){w=0;do{r=w|1;s=(+n[z+(r<<2)>>2]==+n[x+(r<<2)>>2])<<31>>31;b[y+w>>0]=(+n[z+(w<<2)>>2]==+n[x+(w<<2)>>2])<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=(+n[z+(r<<2)>>2]==+n[x+(r<<2)>>2])<<31>>31;b[y+s>>0]=(+n[z+(s<<2)>>2]==+n[x+(s<<2)>>2])<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=(+n[z+(E<<2)>>2]==+n[x+(E<<2)>>2])<<31>>31;E=E+1|0}while((E|0)!=(i|0));if(!A)break;else{x=x+(o<<2)|0;y=y+h|0;z=z+(k<<2)|0;A=A+-1|0}}u=l;return}case 5:{A=c>>>2;c=e>>>2;e=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){F=d;G=g;H=a;I=e}else{u=l;return}while(1){k=0;do{b[G+k>>0]=(+n[H+(k<<2)>>2]!=+n[F+(k<<2)>>2])<<31>>31;k=k+1|0}while((k|0)!=(i|0));if(!I)break;else{F=F+(c<<2)|0;G=G+h|0;H=H+(A<<2)|0;I=I+-1|0}}u=l;return}I=i&-4;if((I|0)<(i|0)){J=d;K=g;L=a;M=e}else{H=d;d=g;g=a;a=e;while(1){e=0;do{G=e|1;F=(+n[g+(G<<2)>>2]!=+n[H+(G<<2)>>2])<<31>>31;b[d+e>>0]=(+n[g+(e<<2)>>2]!=+n[H+(e<<2)>>2])<<31>>31;b[d+G>>0]=F;F=e|2;G=e|3;k=(+n[g+(G<<2)>>2]!=+n[H+(G<<2)>>2])<<31>>31;b[d+F>>0]=(+n[g+(F<<2)>>2]!=+n[H+(F<<2)>>2])<<31>>31;b[d+G>>0]=k;e=e+4|0}while((e|0)<=(j|0));if(!a)break;else{H=H+(c<<2)|0;d=d+h|0;g=g+(A<<2)|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=(+n[L+(g<<2)>>2]!=+n[J+(g<<2)>>2])<<31>>31;b[K+a>>0]=(+n[L+(a<<2)>>2]!=+n[J+(a<<2)>>2])<<31>>31;b[K+g>>0]=d;d=a|2;g=a|3;H=(+n[L+(g<<2)>>2]!=+n[J+(g<<2)>>2])<<31>>31;b[K+d>>0]=(+n[L+(d<<2)>>2]!=+n[J+(d<<2)>>2])<<31>>31;b[K+g>>0]=H;a=a+4|0}while((a|0)<=(j|0));N=I;do{b[K+N>>0]=(+n[L+(N<<2)>>2]!=+n[J+(N<<2)>>2])<<31>>31;N=N+1|0}while((N|0)!=(i|0));if(!M)break;else{J=J+(c<<2)|0;K=K+h|0;L=L+(A<<2)|0;M=M+-1|0}}u=l;return}default:{l=$Xc(16)|0;f[m>>2]=l;f[m+8>>2]=-2147483632;f[m+4>>2]=15;M=l;A=249826;L=M+15|0;do{b[M>>0]=b[A>>0]|0;M=M+1|0;A=A+1|0}while((M|0)<(L|0));b[l+15>>0]=0;vM(-215,m,249842,249851,759)}}}function Q7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0;j=c>>>2;c=e>>>2;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;o=a;p=e;while(1){if(k){q=0;do{b[m+q>>0]=(+n[o+(q<<2)>>2]<+n[l+(q<<2)>>2])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{l=l+(c<<2)|0;m=m+g|0;o=o+(j<<2)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+n[f+(l<<2)>>2]<+n[m+(l<<2)>>2])<<31>>31;b[d+e>>0]=(+n[f+(e<<2)>>2]<+n[m+(e<<2)>>2])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+n[f+(l<<2)>>2]<+n[m+(l<<2)>>2])<<31>>31;b[d+k>>0]=(+n[f+(k<<2)>>2]<+n[m+(k<<2)>>2])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=(+n[f+(e<<2)>>2]<+n[m+(e<<2)>>2])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<2)|0;d=d+g|0;f=f+(j<<2)|0;a=a+-1|0}}return}function R7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0;j=c>>>2;c=e>>>2;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;o=a;p=e;while(1){if(k){q=0;do{b[m+q>>0]=(+n[o+(q<<2)>>2]<=+n[l+(q<<2)>>2])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{l=l+(c<<2)|0;m=m+g|0;o=o+(j<<2)|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+n[f+(l<<2)>>2]<=+n[m+(l<<2)>>2])<<31>>31;b[d+e>>0]=(+n[f+(e<<2)>>2]<=+n[m+(e<<2)>>2])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+n[f+(l<<2)>>2]<=+n[m+(l<<2)>>2])<<31>>31;b[d+k>>0]=(+n[f+(k<<2)>>2]<=+n[m+(k<<2)>>2])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(o){e=p;do{b[d+e>>0]=(+n[f+(e<<2)>>2]<=+n[m+(e<<2)>>2])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<2)|0;d=d+g|0;f=f+(j<<2)|0;a=a+-1|0}}return}function S7(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=u;u=u+16|0;m=l;switch(k|0){case 3:{T7(a,c,d,e,g,h,i,j);u=l;return}case 1:{T7(d,e,a,c,g,h,i,j);u=l;return}case 4:{U7(a,c,d,e,g,h,i,j);u=l;return}case 2:{U7(d,e,a,c,g,h,i,j);u=l;return}case 0:{k=c>>>3;n=e>>>3;o=j+-1|0;if(!j){u=l;return}q=i+-4|0;if((i|0)<4){if((i|0)>0){r=d;s=g;t=a;v=o}else{u=l;return}while(1){w=0;do{b[s+w>>0]=(+p[t+(w<<3)>>3]==+p[r+(w<<3)>>3])<<31>>31;w=w+1|0}while((w|0)!=(i|0));if(!v)break;else{r=r+(n<<3)|0;s=s+h|0;t=t+(k<<3)|0;v=v+-1|0}}u=l;return}v=i&-4;if((v|0)<(i|0)){x=d;y=g;z=a;A=o}else{t=d;s=g;r=a;w=o;while(1){o=0;do{B=o|1;C=(+p[r+(B<<3)>>3]==+p[t+(B<<3)>>3])<<31>>31;b[s+o>>0]=(+p[r+(o<<3)>>3]==+p[t+(o<<3)>>3])<<31>>31;b[s+B>>0]=C;C=o|2;B=o|3;D=(+p[r+(B<<3)>>3]==+p[t+(B<<3)>>3])<<31>>31;b[s+C>>0]=(+p[r+(C<<3)>>3]==+p[t+(C<<3)>>3])<<31>>31;b[s+B>>0]=D;o=o+4|0}while((o|0)<=(q|0));if(!w)break;else{t=t+(n<<3)|0;s=s+h|0;r=r+(k<<3)|0;w=w+-1|0}}u=l;return}while(1){w=0;do{r=w|1;s=(+p[z+(r<<3)>>3]==+p[x+(r<<3)>>3])<<31>>31;b[y+w>>0]=(+p[z+(w<<3)>>3]==+p[x+(w<<3)>>3])<<31>>31;b[y+r>>0]=s;s=w|2;r=w|3;t=(+p[z+(r<<3)>>3]==+p[x+(r<<3)>>3])<<31>>31;b[y+s>>0]=(+p[z+(s<<3)>>3]==+p[x+(s<<3)>>3])<<31>>31;b[y+r>>0]=t;w=w+4|0}while((w|0)<=(q|0));E=v;do{b[y+E>>0]=(+p[z+(E<<3)>>3]==+p[x+(E<<3)>>3])<<31>>31;E=E+1|0}while((E|0)!=(i|0));if(!A)break;else{x=x+(n<<3)|0;y=y+h|0;z=z+(k<<3)|0;A=A+-1|0}}u=l;return}case 5:{A=c>>>3;c=e>>>3;e=j+-1|0;if(!j){u=l;return}j=i+-4|0;if((i|0)<4){if((i|0)>0){F=d;G=g;H=a;I=e}else{u=l;return}while(1){k=0;do{b[G+k>>0]=(+p[H+(k<<3)>>3]!=+p[F+(k<<3)>>3])<<31>>31;k=k+1|0}while((k|0)!=(i|0));if(!I)break;else{F=F+(c<<3)|0;G=G+h|0;H=H+(A<<3)|0;I=I+-1|0}}u=l;return}I=i&-4;if((I|0)<(i|0)){J=d;K=g;L=a;M=e}else{H=d;d=g;g=a;a=e;while(1){e=0;do{G=e|1;F=(+p[g+(G<<3)>>3]!=+p[H+(G<<3)>>3])<<31>>31;b[d+e>>0]=(+p[g+(e<<3)>>3]!=+p[H+(e<<3)>>3])<<31>>31;b[d+G>>0]=F;F=e|2;G=e|3;k=(+p[g+(G<<3)>>3]!=+p[H+(G<<3)>>3])<<31>>31;b[d+F>>0]=(+p[g+(F<<3)>>3]!=+p[H+(F<<3)>>3])<<31>>31;b[d+G>>0]=k;e=e+4|0}while((e|0)<=(j|0));if(!a)break;else{H=H+(c<<3)|0;d=d+h|0;g=g+(A<<3)|0;a=a+-1|0}}u=l;return}while(1){a=0;do{g=a|1;d=(+p[L+(g<<3)>>3]!=+p[J+(g<<3)>>3])<<31>>31;b[K+a>>0]=(+p[L+(a<<3)>>3]!=+p[J+(a<<3)>>3])<<31>>31;b[K+g>>0]=d;d=a|2;g=a|3;H=(+p[L+(g<<3)>>3]!=+p[J+(g<<3)>>3])<<31>>31;b[K+d>>0]=(+p[L+(d<<3)>>3]!=+p[J+(d<<3)>>3])<<31>>31;b[K+g>>0]=H;a=a+4|0}while((a|0)<=(j|0));N=I;do{b[K+N>>0]=(+p[L+(N<<3)>>3]!=+p[J+(N<<3)>>3])<<31>>31;N=N+1|0}while((N|0)!=(i|0));if(!M)break;else{J=J+(c<<3)|0;K=K+h|0;L=L+(A<<3)|0;M=M+-1|0}}u=l;return}default:{l=$Xc(16)|0;f[m>>2]=l;f[m+8>>2]=-2147483632;f[m+4>>2]=15;M=l;A=249826;L=M+15|0;do{b[M>>0]=b[A>>0]|0;M=M+1|0;A=A+1|0}while((M|0)<(L|0));b[l+15>>0]=0;vM(-215,m,249924,249851,814)}}}function T7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=c>>>3;c=e>>>3;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=e;while(1){if(k){q=0;do{b[m+q>>0]=(+p[n+(q<<3)>>3]<+p[l+(q<<3)>>3])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!o)break;else{l=l+(c<<3)|0;m=m+g|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+p[f+(l<<3)>>3]<+p[m+(l<<3)>>3])<<31>>31;b[d+e>>0]=(+p[f+(e<<3)>>3]<+p[m+(e<<3)>>3])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+p[f+(l<<3)>>3]<+p[m+(l<<3)>>3])<<31>>31;b[d+k>>0]=(+p[f+(k<<3)>>3]<+p[m+(k<<3)>>3])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(n){e=o;do{b[d+e>>0]=(+p[f+(e<<3)>>3]<+p[m+(e<<3)>>3])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<3)|0;d=d+g|0;f=f+(j<<3)|0;a=a+-1|0}}return}function U7(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=c>>>3;c=e>>>3;e=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=e;while(1){if(k){q=0;do{b[m+q>>0]=(+p[n+(q<<3)>>3]<=+p[l+(q<<3)>>3])<<31>>31;q=q+1|0}while((q|0)!=(h|0))}if(!o)break;else{l=l+(c<<3)|0;m=m+g|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=e;while(1){e=0;do{l=e|1;k=(+p[f+(l<<3)>>3]<=+p[m+(l<<3)>>3])<<31>>31;b[d+e>>0]=(+p[f+(e<<3)>>3]<=+p[m+(e<<3)>>3])<<31>>31;b[d+l>>0]=k;k=e|2;l=e|3;q=(+p[f+(l<<3)>>3]<=+p[m+(l<<3)>>3])<<31>>31;b[d+k>>0]=(+p[f+(k<<3)>>3]<=+p[m+(k<<3)>>3])<<31>>31;b[d+l>>0]=q;e=e+4|0}while((e|0)<=(i|0));if(n){e=o;do{b[d+e>>0]=(+p[f+(e<<3)>>3]<=+p[m+(e<<3)>>3])<<31>>31;e=e+1|0}while((e|0)!=(h|0))}if(!a)break;else{m=m+(c<<3)|0;d=d+g|0;f=f+(j<<3)|0;a=a+-1|0}}return}function V7(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=+p[k>>3];if(!(+L(+(l+-1.0))<=1.1920928955078125e-07)){if(!j)return;k=i+-4|0;m=(i|0)<4;o=i&-4;q=d;r=f;s=a;t=j;while(1){t=t+-1|0;if(m)u=0;else{v=0;do{w=ALc(l*+n[47240+((h[s+v>>0]|0)+128<<2)>>2]*+n[47240+((h[q+v>>0]|0)+128<<2)>>2])|0;x=v|1;y=ALc(l*+n[47240+((h[s+x>>0]|0)+128<<2)>>2]*+n[47240+((h[q+x>>0]|0)+128<<2)>>2])|0;b[r+v>>0]=w>>>0<256?w:(w|0)>0?255:0;b[r+x>>0]=y>>>0<256?y:(y|0)>0?255:0;y=v|2;x=ALc(l*+n[47240+((h[s+y>>0]|0)+128<<2)>>2]*+n[47240+((h[q+y>>0]|0)+128<<2)>>2])|0;w=v|3;z=ALc(l*+n[47240+((h[s+w>>0]|0)+128<<2)>>2]*+n[47240+((h[q+w>>0]|0)+128<<2)>>2])|0;b[r+y>>0]=x>>>0<256?x:(x|0)>0?255:0;b[r+w>>0]=z>>>0<256?z:(z|0)>0?255:0;v=v+4|0}while((v|0)<=(k|0));u=o}if((u|0)<(i|0)){v=u;do{z=ALc(l*+n[47240+((h[s+v>>0]|0)+128<<2)>>2]*+n[47240+((h[q+v>>0]|0)+128<<2)>>2])|0;b[r+v>>0]=z>>>0<256?z:(z|0)>0?255:0;v=v+1|0}while((v|0)!=(i|0))}if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0}}return}s=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){A=d;B=f;C=a;D=s}else return;while(1){r=0;do{q=Y(h[A+r>>0]|0,h[C+r>>0]|0)|0;b[B+r>>0]=q>>>0<256?q:q|0?255:0;r=r+1|0}while((r|0)!=(i|0));if(!D)break;else{A=A+e|0;B=B+g|0;C=C+c|0;D=D+-1|0}}return}D=i&-4;if((D|0)<(i|0)){E=d;F=f;G=a;H=s}else{C=d;d=f;f=a;a=s;while(1){s=0;do{B=Y(h[C+s>>0]|0,h[f+s>>0]|0)|0;A=s|1;r=Y(h[C+A>>0]|0,h[f+A>>0]|0)|0;b[d+s>>0]=B>>>0<256?B:B|0?255:0;b[d+A>>0]=r>>>0<256?r:r|0?255:0;r=s|2;A=Y(h[C+r>>0]|0,h[f+r>>0]|0)|0;B=s|3;q=Y(h[C+B>>0]|0,h[f+B>>0]|0)|0;b[d+r>>0]=A>>>0<256?A:A|0?255:0;b[d+B>>0]=q>>>0<256?q:q|0?255:0;s=s+4|0}while((s|0)<=(j|0));if(!a)break;else{C=C+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(h[E+a>>0]|0,h[G+a>>0]|0)|0;d=a|1;C=Y(h[E+d>>0]|0,h[G+d>>0]|0)|0;b[F+a>>0]=f>>>0<256?f:f|0?255:0;b[F+d>>0]=C>>>0<256?C:C|0?255:0;C=a|2;d=Y(h[E+C>>0]|0,h[G+C>>0]|0)|0;f=a|3;s=Y(h[E+f>>0]|0,h[G+f>>0]|0)|0;b[F+C>>0]=d>>>0<256?d:d|0?255:0;b[F+f>>0]=s>>>0<256?s:s|0?255:0;a=a+4|0}while((a|0)<=(j|0));I=D;do{a=Y(h[E+I>>0]|0,h[G+I>>0]|0)|0;b[F+I>>0]=a>>>0<256?a:a|0?255:0;I=I+1|0}while((I|0)!=(i|0));if(!H)break;else{E=E+e|0;F=F+g|0;G=G+c|0;H=H+-1|0}}return}function W7(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;k=+p[j>>3];j=i+-1|0;l=(i|0)==0;if(!(+L(+(k+-1.0))<=1.1920928955078125e-07)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=d;n=f;o=a;q=j}else return;while(1){r=0;do{s=ALc(+(b[m+r>>0]|0)*(k*+(b[o+r>>0]|0)))|0;b[n+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(h|0));if(!q)break;else{m=m+e|0;n=n+g|0;o=o+c|0;q=q+-1|0}}return}q=h&-4;if((q|0)<(h|0)){t=d;u=f;v=a;w=j}else{o=d;n=f;m=a;r=j;while(1){s=0;do{x=ALc(+(b[o+s>>0]|0)*(k*+(b[m+s>>0]|0)))|0;y=s|1;z=ALc(+(b[o+y>>0]|0)*(k*+(b[m+y>>0]|0)))|0;b[n+s>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;b[n+y>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;z=s|2;y=ALc(+(b[o+z>>0]|0)*(k*+(b[m+z>>0]|0)))|0;x=s|3;A=ALc(+(b[o+x>>0]|0)*(k*+(b[m+x>>0]|0)))|0;b[n+z>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;b[n+x>>0]=(A+128|0)>>>0<256?A:(A|0)>0?127:128;s=s+4|0}while((s|0)<=(i|0));if(!r)break;else{o=o+e|0;n=n+g|0;m=m+c|0;r=r+-1|0}}return}while(1){r=0;do{m=ALc(+(b[t+r>>0]|0)*(k*+(b[v+r>>0]|0)))|0;n=r|1;o=ALc(+(b[t+n>>0]|0)*(k*+(b[v+n>>0]|0)))|0;b[u+r>>0]=(m+128|0)>>>0<256?m:(m|0)>0?127:128;b[u+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=r|2;n=ALc(+(b[t+o>>0]|0)*(k*+(b[v+o>>0]|0)))|0;m=r|3;s=ALc(+(b[t+m>>0]|0)*(k*+(b[v+m>>0]|0)))|0;b[u+o>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;b[u+m>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+4|0}while((r|0)<=(i|0));B=q;do{r=ALc(+(b[t+B>>0]|0)*(k*+(b[v+B>>0]|0)))|0;b[u+B>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;B=B+1|0}while((B|0)!=(h|0));if(!w)break;else{t=t+e|0;u=u+g|0;v=v+c|0;w=w+-1|0}}return}else{if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){C=d;D=f;E=a;F=j}else return;while(1){w=0;do{v=Y(b[C+w>>0]|0,b[E+w>>0]|0)|0;b[D+w>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;w=w+1|0}while((w|0)!=(h|0));if(!F)break;else{C=C+e|0;D=D+g|0;E=E+c|0;F=F+-1|0}}return}F=h&-4;if((F|0)<(h|0)){G=d;H=f;I=a;J=j}else{E=d;d=f;f=a;a=j;while(1){j=0;do{D=Y(b[E+j>>0]|0,b[f+j>>0]|0)|0;C=j|1;w=Y(b[E+C>>0]|0,b[f+C>>0]|0)|0;b[d+j>>0]=(D+128|0)>>>0<256?D:(D|0)>0?127:128;b[d+C>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;w=j|2;C=Y(b[E+w>>0]|0,b[f+w>>0]|0)|0;D=j|3;v=Y(b[E+D>>0]|0,b[f+D>>0]|0)|0;b[d+w>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;b[d+D>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;j=j+4|0}while((j|0)<=(l|0));if(!a)break;else{E=E+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(b[G+a>>0]|0,b[I+a>>0]|0)|0;d=a|1;E=Y(b[G+d>>0]|0,b[I+d>>0]|0)|0;b[H+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[H+d>>0]=(E+128|0)>>>0<256?E:(E|0)>0?127:128;E=a|2;d=Y(b[G+E>>0]|0,b[I+E>>0]|0)|0;f=a|3;j=Y(b[G+f>>0]|0,b[I+f>>0]|0)|0;b[H+E>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[H+f>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;a=a+4|0}while((a|0)<=(l|0));K=F;do{a=Y(b[G+K>>0]|0,b[I+K>>0]|0)|0;b[H+K>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;K=K+1|0}while((K|0)!=(h|0));if(!J)break;else{G=G+e|0;H=H+g|0;I=I+c|0;J=J+-1|0}}return}}function X7(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;l=+p[k>>3];k=b>>>1;b=e>>>1;e=g>>>1;if(!(+L(+(l+-1.0))<=1.1920928955078125e-07)){if(!i)return;g=h+-4|0;m=(h|0)<4;n=h&-4;o=c;q=f;r=a;s=i;while(1){s=s+-1|0;if(m)t=0;else{u=0;do{v=ALc(+(j[o+(u<<1)>>1]|0)*(l*+(j[r+(u<<1)>>1]|0)))|0;w=u|1;x=ALc(+(j[o+(w<<1)>>1]|0)*(l*+(j[r+(w<<1)>>1]|0)))|0;d[q+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[q+(w<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=u|2;w=ALc(+(j[o+(x<<1)>>1]|0)*(l*+(j[r+(x<<1)>>1]|0)))|0;v=u|3;y=ALc(+(j[o+(v<<1)>>1]|0)*(l*+(j[r+(v<<1)>>1]|0)))|0;d[q+(x<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[q+(v<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;u=u+4|0}while((u|0)<=(g|0));t=n}if((t|0)<(h|0)){u=t;do{y=ALc(+(j[o+(u<<1)>>1]|0)*(l*+(j[r+(u<<1)>>1]|0)))|0;d[q+(u<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;u=u+1|0}while((u|0)!=(h|0))}if(!s)break;else{o=o+(b<<1)|0;q=q+(e<<1)|0;r=r+(k<<1)|0}}return}r=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){z=c;A=f;B=a;C=r}else return;while(1){q=0;do{o=Y(j[z+(q<<1)>>1]|0,j[B+(q<<1)>>1]|0)|0;d[A+(q<<1)>>1]=o>>>0<65536?o:o|0?65535:0;q=q+1|0}while((q|0)!=(h|0));if(!C)break;else{z=z+(b<<1)|0;A=A+(e<<1)|0;B=B+(k<<1)|0;C=C+-1|0}}return}C=h&-4;if((C|0)<(h|0)){D=c;E=f;F=a;G=r}else{B=c;c=f;f=a;a=r;while(1){r=0;do{A=Y(j[B+(r<<1)>>1]|0,j[f+(r<<1)>>1]|0)|0;z=r|1;q=Y(j[B+(z<<1)>>1]|0,j[f+(z<<1)>>1]|0)|0;d[c+(r<<1)>>1]=A>>>0<65536?A:A|0?65535:0;d[c+(z<<1)>>1]=q>>>0<65536?q:q|0?65535:0;q=r|2;z=Y(j[B+(q<<1)>>1]|0,j[f+(q<<1)>>1]|0)|0;A=r|3;o=Y(j[B+(A<<1)>>1]|0,j[f+(A<<1)>>1]|0)|0;d[c+(q<<1)>>1]=z>>>0<65536?z:z|0?65535:0;d[c+(A<<1)>>1]=o>>>0<65536?o:o|0?65535:0;r=r+4|0}while((r|0)<=(i|0));if(!a)break;else{B=B+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(j[D+(a<<1)>>1]|0,j[F+(a<<1)>>1]|0)|0;c=a|1;B=Y(j[D+(c<<1)>>1]|0,j[F+(c<<1)>>1]|0)|0;d[E+(a<<1)>>1]=f>>>0<65536?f:f|0?65535:0;d[E+(c<<1)>>1]=B>>>0<65536?B:B|0?65535:0;B=a|2;c=Y(j[D+(B<<1)>>1]|0,j[F+(B<<1)>>1]|0)|0;f=a|3;r=Y(j[D+(f<<1)>>1]|0,j[F+(f<<1)>>1]|0)|0;d[E+(B<<1)>>1]=c>>>0<65536?c:c|0?65535:0;d[E+(f<<1)>>1]=r>>>0<65536?r:r|0?65535:0;a=a+4|0}while((a|0)<=(i|0));H=C;do{a=Y(j[D+(H<<1)>>1]|0,j[F+(H<<1)>>1]|0)|0;d[E+(H<<1)>>1]=a>>>0<65536?a:a|0?65535:0;H=H+1|0}while((H|0)!=(h|0));if(!G)break;else{D=D+(b<<1)|0;E=E+(e<<1)|0;F=F+(k<<1)|0;G=G+-1|0}}return}function Y7(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=+p[j>>3];j=b>>>1;b=e>>>1;e=g>>>1;if(!(+L(+(k+-1.0))<=1.1920928955078125e-07)){if(!i)return;g=h+-4|0;l=(h|0)<4;m=h&-4;n=c;o=f;q=a;r=i;while(1){r=r+-1|0;if(l)s=0;else{t=0;do{u=ALc(+(d[n+(t<<1)>>1]|0)*(k*+(d[q+(t<<1)>>1]|0)))|0;v=t|1;w=ALc(+(d[n+(v<<1)>>1]|0)*(k*+(d[q+(v<<1)>>1]|0)))|0;d[o+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[o+(v<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;w=t|2;v=ALc(+(d[n+(w<<1)>>1]|0)*(k*+(d[q+(w<<1)>>1]|0)))|0;u=t|3;x=ALc(+(d[n+(u<<1)>>1]|0)*(k*+(d[q+(u<<1)>>1]|0)))|0;d[o+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[o+(u<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;t=t+4|0}while((t|0)<=(g|0));s=m}if((s|0)<(h|0)){t=s;do{x=ALc(+(d[n+(t<<1)>>1]|0)*(k*+(d[q+(t<<1)>>1]|0)))|0;d[o+(t<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;t=t+1|0}while((t|0)!=(h|0))}if(!r)break;else{n=n+(b<<1)|0;o=o+(e<<1)|0;q=q+(j<<1)|0}}return}q=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){y=c;z=f;A=a;B=q}else return;while(1){o=0;do{n=Y(d[y+(o<<1)>>1]|0,d[A+(o<<1)>>1]|0)|0;d[z+(o<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;o=o+1|0}while((o|0)!=(h|0));if(!B)break;else{y=y+(b<<1)|0;z=z+(e<<1)|0;A=A+(j<<1)|0;B=B+-1|0}}return}B=h&-4;if((B|0)<(h|0)){C=c;D=f;E=a;F=q}else{A=c;c=f;f=a;a=q;while(1){q=0;do{z=Y(d[A+(q<<1)>>1]|0,d[f+(q<<1)>>1]|0)|0;y=q|1;o=Y(d[A+(y<<1)>>1]|0,d[f+(y<<1)>>1]|0)|0;d[c+(q<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[c+(y<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=q|2;y=Y(d[A+(o<<1)>>1]|0,d[f+(o<<1)>>1]|0)|0;z=q|3;n=Y(d[A+(z<<1)>>1]|0,d[f+(z<<1)>>1]|0)|0;d[c+(o<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[c+(z<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;q=q+4|0}while((q|0)<=(i|0));if(!a)break;else{A=A+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(d[C+(a<<1)>>1]|0,d[E+(a<<1)>>1]|0)|0;c=a|1;A=Y(d[C+(c<<1)>>1]|0,d[E+(c<<1)>>1]|0)|0;d[D+(a<<1)>>1]=(f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768;d[D+(c<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;A=a|2;c=Y(d[C+(A<<1)>>1]|0,d[E+(A<<1)>>1]|0)|0;f=a|3;q=Y(d[C+(f<<1)>>1]|0,d[E+(f<<1)>>1]|0)|0;d[D+(A<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;d[D+(f<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;a=a+4|0}while((a|0)<=(i|0));G=B;do{a=Y(d[C+(G<<1)>>1]|0,d[E+(G<<1)>>1]|0)|0;d[D+(G<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0));if(!F)break;else{C=C+(b<<1)|0;D=D+(e<<1)|0;E=E+(j<<1)|0;F=F+-1|0}}return}function Z7(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;k=(h|0)==0;if(!(+L(+(j+-1.0))<=1.1920928955078125e-07)){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;o=a;q=f}else return;while(1){r=0;do{n[m+(r<<2)>>2]=+n[l+(r<<2)>>2]*(j*+n[o+(r<<2)>>2]);r=r+1|0}while((r|0)!=(g|0));if(!q)break;else{l=l+(b<<2)|0;m=m+(d<<2)|0;o=o+(i<<2)|0;q=q+-1|0}}return}q=g&-4;if((q|0)<(g|0)){s=c;t=e;u=a;v=f}else{o=c;m=e;l=a;r=f;while(1){w=0;do{x=w|1;y=+n[o+(x<<2)>>2]*(j*+n[l+(x<<2)>>2]);n[m+(w<<2)>>2]=+n[o+(w<<2)>>2]*(j*+n[l+(w<<2)>>2]);n[m+(x<<2)>>2]=y;x=w|2;z=w|3;y=+n[o+(z<<2)>>2]*(j*+n[l+(z<<2)>>2]);n[m+(x<<2)>>2]=+n[o+(x<<2)>>2]*(j*+n[l+(x<<2)>>2]);n[m+(z<<2)>>2]=y;w=w+4|0}while((w|0)<=(h|0));if(!r)break;else{o=o+(b<<2)|0;m=m+(d<<2)|0;l=l+(i<<2)|0;r=r+-1|0}}return}while(1){r=0;do{l=r|1;y=+n[s+(l<<2)>>2]*(j*+n[u+(l<<2)>>2]);n[t+(r<<2)>>2]=+n[s+(r<<2)>>2]*(j*+n[u+(r<<2)>>2]);n[t+(l<<2)>>2]=y;l=r|2;m=r|3;y=+n[s+(m<<2)>>2]*(j*+n[u+(m<<2)>>2]);n[t+(l<<2)>>2]=+n[s+(l<<2)>>2]*(j*+n[u+(l<<2)>>2]);n[t+(m<<2)>>2]=y;r=r+4|0}while((r|0)<=(h|0));A=q;do{n[t+(A<<2)>>2]=+n[s+(A<<2)>>2]*(j*+n[u+(A<<2)>>2]);A=A+1|0}while((A|0)!=(g|0));if(!v)break;else{s=s+(b<<2)|0;t=t+(d<<2)|0;u=u+(i<<2)|0;v=v+-1|0}}return}else{if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){B=c;C=e;D=a;E=f}else return;while(1){v=0;do{n[C+(v<<2)>>2]=+n[D+(v<<2)>>2]*+n[B+(v<<2)>>2];v=v+1|0}while((v|0)!=(g|0));if(!E)break;else{B=B+(b<<2)|0;C=C+(d<<2)|0;D=D+(i<<2)|0;E=E+-1|0}}return}E=g&-4;if((E|0)<(g|0)){F=c;G=e;H=a;I=f}else{D=c;c=e;e=a;a=f;while(1){f=0;do{C=f|1;j=+n[e+(C<<2)>>2]*+n[D+(C<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]*+n[D+(f<<2)>>2];n[c+(C<<2)>>2]=j;C=f|2;B=f|3;j=+n[e+(B<<2)>>2]*+n[D+(B<<2)>>2];n[c+(C<<2)>>2]=+n[e+(C<<2)>>2]*+n[D+(C<<2)>>2];n[c+(B<<2)>>2]=j;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{D=D+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;j=+n[H+(e<<2)>>2]*+n[F+(e<<2)>>2];n[G+(a<<2)>>2]=+n[H+(a<<2)>>2]*+n[F+(a<<2)>>2];n[G+(e<<2)>>2]=j;e=a|2;c=a|3;j=+n[H+(c<<2)>>2]*+n[F+(c<<2)>>2];n[G+(e<<2)>>2]=+n[H+(e<<2)>>2]*+n[F+(e<<2)>>2];n[G+(c<<2)>>2]=j;a=a+4|0}while((a|0)<=(k|0));J=E;do{n[G+(J<<2)>>2]=+n[H+(J<<2)>>2]*+n[F+(J<<2)>>2];J=J+1|0}while((J|0)!=(g|0));if(!I)break;else{F=F+(b<<2)|0;G=G+(d<<2)|0;H=H+(i<<2)|0;I=I+-1|0}}return}}function _7(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;k=+p[j>>3];j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;l=(i|0)==0;if(!(+L(+(k+-1.0))<=1.1920928955078125e-07)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=c;n=e;o=a;q=g}else return;while(1){r=0;do{s=zLc(+(f[m+(r<<2)>>2]|0)*(k*+(f[o+(r<<2)>>2]|0)))|0;f[n+(r<<2)>>2]=s;r=r+1|0}while((r|0)!=(h|0));if(!q)break;else{m=m+(b<<2)|0;n=n+(d<<2)|0;o=o+(j<<2)|0;q=q+-1|0}}return}q=h&-4;if((q|0)<(h|0)){t=c;u=e;v=a;w=g}else{o=c;n=e;m=a;r=g;while(1){s=0;do{x=zLc(+(f[o+(s<<2)>>2]|0)*(k*+(f[m+(s<<2)>>2]|0)))|0;y=s|1;z=zLc(+(f[o+(y<<2)>>2]|0)*(k*+(f[m+(y<<2)>>2]|0)))|0;f[n+(s<<2)>>2]=x;f[n+(y<<2)>>2]=z;z=s|2;y=zLc(+(f[o+(z<<2)>>2]|0)*(k*+(f[m+(z<<2)>>2]|0)))|0;x=s|3;A=zLc(+(f[o+(x<<2)>>2]|0)*(k*+(f[m+(x<<2)>>2]|0)))|0;f[n+(z<<2)>>2]=y;f[n+(x<<2)>>2]=A;s=s+4|0}while((s|0)<=(i|0));if(!r)break;else{o=o+(b<<2)|0;n=n+(d<<2)|0;m=m+(j<<2)|0;r=r+-1|0}}return}while(1){r=0;do{m=zLc(+(f[t+(r<<2)>>2]|0)*(k*+(f[v+(r<<2)>>2]|0)))|0;n=r|1;o=zLc(+(f[t+(n<<2)>>2]|0)*(k*+(f[v+(n<<2)>>2]|0)))|0;f[u+(r<<2)>>2]=m;f[u+(n<<2)>>2]=o;o=r|2;n=zLc(+(f[t+(o<<2)>>2]|0)*(k*+(f[v+(o<<2)>>2]|0)))|0;m=r|3;s=zLc(+(f[t+(m<<2)>>2]|0)*(k*+(f[v+(m<<2)>>2]|0)))|0;f[u+(o<<2)>>2]=n;f[u+(m<<2)>>2]=s;r=r+4|0}while((r|0)<=(i|0));B=q;do{r=zLc(+(f[t+(B<<2)>>2]|0)*(k*+(f[v+(B<<2)>>2]|0)))|0;f[u+(B<<2)>>2]=r;B=B+1|0}while((B|0)!=(h|0));if(!w)break;else{t=t+(b<<2)|0;u=u+(d<<2)|0;v=v+(j<<2)|0;w=w+-1|0}}return}else{if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){C=c;D=e;E=a;F=g}else return;while(1){w=0;do{v=Y(f[C+(w<<2)>>2]|0,f[E+(w<<2)>>2]|0)|0;f[D+(w<<2)>>2]=v;w=w+1|0}while((w|0)!=(h|0));if(!F)break;else{C=C+(b<<2)|0;D=D+(d<<2)|0;E=E+(j<<2)|0;F=F+-1|0}}return}F=h&-4;if((F|0)<(h|0)){G=c;H=e;I=a;J=g}else{E=c;c=e;e=a;a=g;while(1){g=0;do{D=Y(f[E+(g<<2)>>2]|0,f[e+(g<<2)>>2]|0)|0;C=g|1;w=Y(f[E+(C<<2)>>2]|0,f[e+(C<<2)>>2]|0)|0;f[c+(g<<2)>>2]=D;f[c+(C<<2)>>2]=w;w=g|2;C=Y(f[E+(w<<2)>>2]|0,f[e+(w<<2)>>2]|0)|0;D=g|3;v=Y(f[E+(D<<2)>>2]|0,f[e+(D<<2)>>2]|0)|0;f[c+(w<<2)>>2]=C;f[c+(D<<2)>>2]=v;g=g+4|0}while((g|0)<=(l|0));if(!a)break;else{E=E+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=Y(f[G+(a<<2)>>2]|0,f[I+(a<<2)>>2]|0)|0;c=a|1;E=Y(f[G+(c<<2)>>2]|0,f[I+(c<<2)>>2]|0)|0;f[H+(a<<2)>>2]=e;f[H+(c<<2)>>2]=E;E=a|2;c=Y(f[G+(E<<2)>>2]|0,f[I+(E<<2)>>2]|0)|0;e=a|3;g=Y(f[G+(e<<2)>>2]|0,f[I+(e<<2)>>2]|0)|0;f[H+(E<<2)>>2]=c;f[H+(e<<2)>>2]=g;a=a+4|0}while((a|0)<=(l|0));K=F;do{a=Y(f[G+(K<<2)>>2]|0,f[I+(K<<2)>>2]|0)|0;f[H+(K<<2)>>2]=a;K=K+1|0}while((K|0)!=(h|0));if(!J)break;else{G=G+(b<<2)|0;H=H+(d<<2)|0;I=I+(j<<2)|0;J=J+-1|0}}return}}function $7(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;j=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;k=(h|0)==0;if(+p[i>>3]==1.0){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;n=a;o=f}else return;while(1){q=0;do{p[m+(q<<3)>>3]=+p[n+(q<<3)>>3]*+p[l+(q<<3)>>3];q=q+1|0}while((q|0)!=(g|0));if(!o)break;else{l=l+(b<<3)|0;m=m+(d<<3)|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=g&-4;if((o|0)<(g|0)){r=c;s=e;t=a;u=f}else{n=c;m=e;l=a;q=f;while(1){v=0;do{w=v|1;x=+p[l+(w<<3)>>3]*+p[n+(w<<3)>>3];p[m+(v<<3)>>3]=+p[l+(v<<3)>>3]*+p[n+(v<<3)>>3];p[m+(w<<3)>>3]=x;w=v|2;y=v|3;x=+p[l+(y<<3)>>3]*+p[n+(y<<3)>>3];p[m+(w<<3)>>3]=+p[l+(w<<3)>>3]*+p[n+(w<<3)>>3];p[m+(y<<3)>>3]=x;v=v+4|0}while((v|0)<=(h|0));if(!q)break;else{n=n+(b<<3)|0;m=m+(d<<3)|0;l=l+(j<<3)|0;q=q+-1|0}}return}while(1){q=0;do{l=q|1;x=+p[t+(l<<3)>>3]*+p[r+(l<<3)>>3];p[s+(q<<3)>>3]=+p[t+(q<<3)>>3]*+p[r+(q<<3)>>3];p[s+(l<<3)>>3]=x;l=q|2;m=q|3;x=+p[t+(m<<3)>>3]*+p[r+(m<<3)>>3];p[s+(l<<3)>>3]=+p[t+(l<<3)>>3]*+p[r+(l<<3)>>3];p[s+(m<<3)>>3]=x;q=q+4|0}while((q|0)<=(h|0));z=o;do{p[s+(z<<3)>>3]=+p[t+(z<<3)>>3]*+p[r+(z<<3)>>3];z=z+1|0}while((z|0)!=(g|0));if(!u)break;else{r=r+(b<<3)|0;s=s+(d<<3)|0;t=t+(j<<3)|0;u=u+-1|0}}return}else{if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){A=c;B=e;C=a;D=f}else return;while(1){u=0;do{p[B+(u<<3)>>3]=+p[A+(u<<3)>>3]*(+p[C+(u<<3)>>3]*+p[i>>3]);u=u+1|0}while((u|0)!=(g|0));if(!D)break;else{A=A+(b<<3)|0;B=B+(d<<3)|0;C=C+(j<<3)|0;D=D+-1|0}}return}D=g&-4;if((D|0)<(g|0)){E=c;F=e;G=a;H=f}else{C=c;c=e;e=a;a=f;while(1){f=0;do{x=+p[i>>3];B=f|1;I=x*+p[e+(B<<3)>>3]*+p[C+(B<<3)>>3];p[c+(f<<3)>>3]=+p[C+(f<<3)>>3]*(+p[e+(f<<3)>>3]*x);p[c+(B<<3)>>3]=I;B=f|2;I=+p[i>>3];A=f|3;x=I*+p[e+(A<<3)>>3]*+p[C+(A<<3)>>3];p[c+(B<<3)>>3]=+p[C+(B<<3)>>3]*(+p[e+(B<<3)>>3]*I);p[c+(A<<3)>>3]=x;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{C=C+(b<<3)|0;c=c+(d<<3)|0;e=e+(j<<3)|0;a=a+-1|0}}return}while(1){a=0;do{x=+p[i>>3];e=a|1;I=x*+p[G+(e<<3)>>3]*+p[E+(e<<3)>>3];p[F+(a<<3)>>3]=+p[E+(a<<3)>>3]*(+p[G+(a<<3)>>3]*x);p[F+(e<<3)>>3]=I;e=a|2;I=+p[i>>3];c=a|3;x=I*+p[G+(c<<3)>>3]*+p[E+(c<<3)>>3];p[F+(e<<3)>>3]=+p[E+(e<<3)>>3]*(+p[G+(e<<3)>>3]*I);p[F+(c<<3)>>3]=x;a=a+4|0}while((a|0)<=(k|0));J=D;do{p[F+(J<<3)>>3]=+p[E+(J<<3)>>3]*(+p[G+(J<<3)>>3]*+p[i>>3]);J=J+1|0}while((J|0)!=(g|0));if(!H)break;else{E=E+(b<<3)|0;F=F+(d<<3)|0;G=G+(j<<3)|0;H=H+-1|0}}return}}function a8(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=+p[k>>3];if(!j)return;k=i+-4|0;m=(i|0)<4;o=i&-4;q=d;d=f;f=a;a=j;while(1){a=a+-1|0;if(m)r=0;else{j=0;do{s=b[q+j>>0]|0;if(!(s<<24>>24))t=0;else{u=ALc(l*+n[47240+((h[f+j>>0]|0)+128<<2)>>2]/+n[47240+((s&255)+128<<2)>>2])|0;t=(u>>>0<256?u:(u|0)>0?255:0)&255}u=j|1;s=b[q+u>>0]|0;if(!(s<<24>>24))v=0;else{w=ALc(l*+n[47240+((h[f+u>>0]|0)+128<<2)>>2]/+n[47240+((s&255)+128<<2)>>2])|0;v=(w>>>0<256?w:(w|0)>0?255:0)&255}b[d+j>>0]=t;b[d+u>>0]=v;u=j|2;w=b[q+u>>0]|0;if(!(w<<24>>24))x=0;else{s=ALc(l*+n[47240+((h[f+u>>0]|0)+128<<2)>>2]/+n[47240+((w&255)+128<<2)>>2])|0;x=(s>>>0<256?s:(s|0)>0?255:0)&255}s=j|3;w=b[q+s>>0]|0;if(!(w<<24>>24))y=0;else{z=ALc(l*+n[47240+((h[f+s>>0]|0)+128<<2)>>2]/+n[47240+((w&255)+128<<2)>>2])|0;y=(z>>>0<256?z:(z|0)>0?255:0)&255}b[d+u>>0]=x;b[d+s>>0]=y;j=j+4|0}while((j|0)<=(k|0));r=o}if((r|0)<(i|0)){j=r;do{s=b[q+j>>0]|0;if(!(s<<24>>24))A=0;else{u=ALc(l*+n[47240+((h[f+j>>0]|0)+128<<2)>>2]/+n[47240+((s&255)+128<<2)>>2])|0;A=(u>>>0<256?u:(u|0)>0?255:0)&255}b[d+j>>0]=A;j=j+1|0}while((j|0)!=(i|0))}if(!a)break;else{q=q+e|0;d=d+g|0;f=f+c|0}}return}function b8(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=+p[j>>3];if(!i)return;j=h+-4|0;l=(h|0)<4;m=h&-4;n=d;d=f;f=a;a=i;while(1){a=a+-1|0;if(l)o=0;else{i=0;do{q=b[n+i>>0]|0;if(!(q<<24>>24))r=0;else{s=ALc(k*+(b[f+i>>0]|0)/+(q<<24>>24))|0;r=((s+128|0)>>>0<256?s:(s|0)>0?127:128)&255}s=i|1;q=b[n+s>>0]|0;if(!(q<<24>>24))t=0;else{u=ALc(k*+(b[f+s>>0]|0)/+(q<<24>>24))|0;t=((u+128|0)>>>0<256?u:(u|0)>0?127:128)&255}b[d+i>>0]=r;b[d+s>>0]=t;s=i|2;u=b[n+s>>0]|0;if(!(u<<24>>24))v=0;else{q=ALc(k*+(b[f+s>>0]|0)/+(u<<24>>24))|0;v=((q+128|0)>>>0<256?q:(q|0)>0?127:128)&255}q=i|3;u=b[n+q>>0]|0;if(!(u<<24>>24))w=0;else{x=ALc(k*+(b[f+q>>0]|0)/+(u<<24>>24))|0;w=((x+128|0)>>>0<256?x:(x|0)>0?127:128)&255}b[d+s>>0]=v;b[d+q>>0]=w;i=i+4|0}while((i|0)<=(j|0));o=m}if((o|0)<(h|0)){i=o;do{q=b[n+i>>0]|0;if(!(q<<24>>24))y=0;else{s=ALc(k*+(b[f+i>>0]|0)/+(q<<24>>24))|0;y=((s+128|0)>>>0<256?s:(s|0)>0?127:128)&255}b[d+i>>0]=y;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0}}return}function c8(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;l=+p[k>>3];k=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;m=(h|0)<4;n=h&-4;o=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(m)q=0;else{i=0;do{r=d[o+(i<<1)>>1]|0;if(!(r<<16>>16))s=0;else{t=ALc(l*+(j[f+(i<<1)>>1]|0)/+(r&65535))|0;s=(t>>>0<65536?t:(t|0)>0?65535:0)&65535}t=i|1;r=d[o+(t<<1)>>1]|0;if(!(r<<16>>16))u=0;else{v=ALc(l*+(j[f+(t<<1)>>1]|0)/+(r&65535))|0;u=(v>>>0<65536?v:(v|0)>0?65535:0)&65535}d[c+(i<<1)>>1]=s;d[c+(t<<1)>>1]=u;t=i|2;v=d[o+(t<<1)>>1]|0;if(!(v<<16>>16))w=0;else{r=ALc(l*+(j[f+(t<<1)>>1]|0)/+(v&65535))|0;w=(r>>>0<65536?r:(r|0)>0?65535:0)&65535}r=i|3;v=d[o+(r<<1)>>1]|0;if(!(v<<16>>16))x=0;else{y=ALc(l*+(j[f+(r<<1)>>1]|0)/+(v&65535))|0;x=(y>>>0<65536?y:(y|0)>0?65535:0)&65535}d[c+(t<<1)>>1]=w;d[c+(r<<1)>>1]=x;i=i+4|0}while((i|0)<=(g|0));q=n}if((q|0)<(h|0)){i=q;do{r=d[o+(i<<1)>>1]|0;if(!(r<<16>>16))z=0;else{t=ALc(l*+(j[f+(i<<1)>>1]|0)/+(r&65535))|0;z=(t>>>0<65536?t:(t|0)>0?65535:0)&65535}d[c+(i<<1)>>1]=z;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{o=o+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0}}return}function d8(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=+p[j>>3];j=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;l=(h|0)<4;m=h&-4;n=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(l)o=0;else{i=0;do{q=d[n+(i<<1)>>1]|0;if(!(q<<16>>16))r=0;else{s=ALc(k*+(d[f+(i<<1)>>1]|0)/+(q<<16>>16))|0;r=((s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768)&65535}s=i|1;q=d[n+(s<<1)>>1]|0;if(!(q<<16>>16))t=0;else{u=ALc(k*+(d[f+(s<<1)>>1]|0)/+(q<<16>>16))|0;t=((u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768)&65535}d[c+(i<<1)>>1]=r;d[c+(s<<1)>>1]=t;s=i|2;u=d[n+(s<<1)>>1]|0;if(!(u<<16>>16))v=0;else{q=ALc(k*+(d[f+(s<<1)>>1]|0)/+(u<<16>>16))|0;v=((q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768)&65535}q=i|3;u=d[n+(q<<1)>>1]|0;if(!(u<<16>>16))w=0;else{x=ALc(k*+(d[f+(q<<1)>>1]|0)/+(u<<16>>16))|0;w=((x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768)&65535}d[c+(s<<1)>>1]=v;d[c+(q<<1)>>1]=w;i=i+4|0}while((i|0)<=(g|0));o=m}if((o|0)<(h|0)){i=o;do{q=d[n+(i<<1)>>1]|0;if(!(q<<16>>16))y=0;else{s=ALc(k*+(d[f+(i<<1)>>1]|0)/+(q<<16>>16))|0;y=((s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768)&65535}d[c+(i<<1)>>1]=y;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{n=n+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0}}return}function e8(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=+p[j>>3];j=b>>>2;b=d>>>2;d=g>>>2;if(!i)return;g=h+-4|0;l=(h|0)<4;m=h&-4;n=c;c=e;e=a;a=i;while(1){a=a+-1|0;if(l)o=0;else{i=0;do{q=f[n+(i<<2)>>2]|0;if(!q)r=0;else r=ALc(k*+(f[e+(i<<2)>>2]|0)/+(q|0))|0;q=i|1;s=f[n+(q<<2)>>2]|0;if(!s)t=0;else t=ALc(k*+(f[e+(q<<2)>>2]|0)/+(s|0))|0;f[c+(i<<2)>>2]=r;f[c+(q<<2)>>2]=t;q=i|2;s=f[n+(q<<2)>>2]|0;if(!s)u=0;else u=ALc(k*+(f[e+(q<<2)>>2]|0)/+(s|0))|0;s=i|3;v=f[n+(s<<2)>>2]|0;if(!v)w=0;else w=ALc(k*+(f[e+(s<<2)>>2]|0)/+(v|0))|0;f[c+(q<<2)>>2]=u;f[c+(s<<2)>>2]=w;i=i+4|0}while((i|0)<=(g|0));o=m}if((o|0)<(h|0)){i=o;do{s=f[n+(i<<2)>>2]|0;if(!s)x=0;else x=ALc(k*+(f[e+(i<<2)>>2]|0)/+(s|0))|0;f[c+(i<<2)>>2]=x;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{n=n+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0}}return}function f8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;k=(h|0)==0;if(!(+L(+(j+-1.0))<=1.1920928955078125e-07)){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;o=a;q=f}else return;while(1){r=0;do{n[m+(r<<2)>>2]=j*+n[o+(r<<2)>>2]/+n[l+(r<<2)>>2];r=r+1|0}while((r|0)!=(g|0));if(!q)break;else{l=l+(b<<2)|0;m=m+(d<<2)|0;o=o+(i<<2)|0;q=q+-1|0}}return}q=g&-4;if((q|0)<(g|0)){s=c;t=e;u=a;v=f}else{o=c;m=e;l=a;r=f;while(1){w=0;do{x=w|1;y=j*+n[l+(x<<2)>>2]/+n[o+(x<<2)>>2];n[m+(w<<2)>>2]=j*+n[l+(w<<2)>>2]/+n[o+(w<<2)>>2];n[m+(x<<2)>>2]=y;x=w|2;z=w|3;y=j*+n[l+(z<<2)>>2]/+n[o+(z<<2)>>2];n[m+(x<<2)>>2]=j*+n[l+(x<<2)>>2]/+n[o+(x<<2)>>2];n[m+(z<<2)>>2]=y;w=w+4|0}while((w|0)<=(h|0));if(!r)break;else{o=o+(b<<2)|0;m=m+(d<<2)|0;l=l+(i<<2)|0;r=r+-1|0}}return}while(1){r=0;do{l=r|1;y=j*+n[u+(l<<2)>>2]/+n[s+(l<<2)>>2];n[t+(r<<2)>>2]=j*+n[u+(r<<2)>>2]/+n[s+(r<<2)>>2];n[t+(l<<2)>>2]=y;l=r|2;m=r|3;y=j*+n[u+(m<<2)>>2]/+n[s+(m<<2)>>2];n[t+(l<<2)>>2]=j*+n[u+(l<<2)>>2]/+n[s+(l<<2)>>2];n[t+(m<<2)>>2]=y;r=r+4|0}while((r|0)<=(h|0));A=q;do{n[t+(A<<2)>>2]=j*+n[u+(A<<2)>>2]/+n[s+(A<<2)>>2];A=A+1|0}while((A|0)!=(g|0));if(!v)break;else{s=s+(b<<2)|0;t=t+(d<<2)|0;u=u+(i<<2)|0;v=v+-1|0}}return}else{if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){B=c;C=e;D=a;E=f}else return;while(1){v=0;do{n[C+(v<<2)>>2]=+n[D+(v<<2)>>2]/+n[B+(v<<2)>>2];v=v+1|0}while((v|0)!=(g|0));if(!E)break;else{B=B+(b<<2)|0;C=C+(d<<2)|0;D=D+(i<<2)|0;E=E+-1|0}}return}E=g&-4;if((E|0)<(g|0)){F=c;G=e;H=a;I=f}else{D=c;c=e;e=a;a=f;while(1){f=0;do{C=f|1;j=+n[e+(C<<2)>>2]/+n[D+(C<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]/+n[D+(f<<2)>>2];n[c+(C<<2)>>2]=j;C=f|2;B=f|3;j=+n[e+(B<<2)>>2]/+n[D+(B<<2)>>2];n[c+(C<<2)>>2]=+n[e+(C<<2)>>2]/+n[D+(C<<2)>>2];n[c+(B<<2)>>2]=j;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{D=D+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;j=+n[H+(e<<2)>>2]/+n[F+(e<<2)>>2];n[G+(a<<2)>>2]=+n[H+(a<<2)>>2]/+n[F+(a<<2)>>2];n[G+(e<<2)>>2]=j;e=a|2;c=a|3;j=+n[H+(c<<2)>>2]/+n[F+(c<<2)>>2];n[G+(e<<2)>>2]=+n[H+(e<<2)>>2]/+n[F+(e<<2)>>2];n[G+(c<<2)>>2]=j;a=a+4|0}while((a|0)<=(k|0));J=E;do{n[G+(J<<2)>>2]=+n[H+(J<<2)>>2]/+n[F+(J<<2)>>2];J=J+1|0}while((J|0)!=(g|0));if(!I)break;else{F=F+(b<<2)|0;G=G+(d<<2)|0;H=H+(i<<2)|0;I=I+-1|0}}return}}function g8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;j=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;k=(h|0)==0;if(+p[i>>3]==1.0){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;n=a;o=f}else return;while(1){q=0;do{p[m+(q<<3)>>3]=+p[n+(q<<3)>>3]/+p[l+(q<<3)>>3];q=q+1|0}while((q|0)!=(g|0));if(!o)break;else{l=l+(b<<3)|0;m=m+(d<<3)|0;n=n+(j<<3)|0;o=o+-1|0}}return}o=g&-4;if((o|0)<(g|0)){r=c;s=e;t=a;u=f}else{n=c;m=e;l=a;q=f;while(1){v=0;do{w=v|1;x=+p[l+(w<<3)>>3]/+p[n+(w<<3)>>3];p[m+(v<<3)>>3]=+p[l+(v<<3)>>3]/+p[n+(v<<3)>>3];p[m+(w<<3)>>3]=x;w=v|2;y=v|3;x=+p[l+(y<<3)>>3]/+p[n+(y<<3)>>3];p[m+(w<<3)>>3]=+p[l+(w<<3)>>3]/+p[n+(w<<3)>>3];p[m+(y<<3)>>3]=x;v=v+4|0}while((v|0)<=(h|0));if(!q)break;else{n=n+(b<<3)|0;m=m+(d<<3)|0;l=l+(j<<3)|0;q=q+-1|0}}return}while(1){q=0;do{l=q|1;x=+p[t+(l<<3)>>3]/+p[r+(l<<3)>>3];p[s+(q<<3)>>3]=+p[t+(q<<3)>>3]/+p[r+(q<<3)>>3];p[s+(l<<3)>>3]=x;l=q|2;m=q|3;x=+p[t+(m<<3)>>3]/+p[r+(m<<3)>>3];p[s+(l<<3)>>3]=+p[t+(l<<3)>>3]/+p[r+(l<<3)>>3];p[s+(m<<3)>>3]=x;q=q+4|0}while((q|0)<=(h|0));z=o;do{p[s+(z<<3)>>3]=+p[t+(z<<3)>>3]/+p[r+(z<<3)>>3];z=z+1|0}while((z|0)!=(g|0));if(!u)break;else{r=r+(b<<3)|0;s=s+(d<<3)|0;t=t+(j<<3)|0;u=u+-1|0}}return}else{if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){A=c;B=e;C=a;D=f}else return;while(1){u=0;do{p[B+(u<<3)>>3]=+p[C+(u<<3)>>3]*+p[i>>3]/+p[A+(u<<3)>>3];u=u+1|0}while((u|0)!=(g|0));if(!D)break;else{A=A+(b<<3)|0;B=B+(d<<3)|0;C=C+(j<<3)|0;D=D+-1|0}}return}D=g&-4;if((D|0)<(g|0)){E=c;F=e;G=a;H=f}else{C=c;c=e;e=a;a=f;while(1){f=0;do{x=+p[i>>3];B=f|1;I=x*+p[e+(B<<3)>>3]/+p[C+(B<<3)>>3];p[c+(f<<3)>>3]=+p[e+(f<<3)>>3]*x/+p[C+(f<<3)>>3];p[c+(B<<3)>>3]=I;B=f|2;I=+p[i>>3];A=f|3;x=I*+p[e+(A<<3)>>3]/+p[C+(A<<3)>>3];p[c+(B<<3)>>3]=+p[e+(B<<3)>>3]*I/+p[C+(B<<3)>>3];p[c+(A<<3)>>3]=x;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{C=C+(b<<3)|0;c=c+(d<<3)|0;e=e+(j<<3)|0;a=a+-1|0}}return}while(1){a=0;do{x=+p[i>>3];e=a|1;I=x*+p[G+(e<<3)>>3]/+p[E+(e<<3)>>3];p[F+(a<<3)>>3]=+p[G+(a<<3)>>3]*x/+p[E+(a<<3)>>3];p[F+(e<<3)>>3]=I;e=a|2;I=+p[i>>3];c=a|3;x=I*+p[G+(c<<3)>>3]/+p[E+(c<<3)>>3];p[F+(e<<3)>>3]=+p[G+(e<<3)>>3]*I/+p[E+(e<<3)>>3];p[F+(c<<3)>>3]=x;a=a+4|0}while((a|0)<=(k|0));J=D;do{p[F+(J<<3)>>3]=+p[G+(J<<3)>>3]*+p[i>>3]/+p[E+(J<<3)>>3];J=J+1|0}while((J|0)!=(g|0));if(!H)break;else{E=E+(b<<3)|0;F=F+(d<<3)|0;G=G+(j<<3)|0;H=H+-1|0}}return}}function h8(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,o=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=+p[k>>3];m=+p[k+8>>3];o=+p[k+16>>3];k=(j|0)==0;if(m==1.0&o==0.0){if(k)return;q=i+-4|0;r=(i|0)<4;s=i&-4;t=d;u=f;v=a;w=j;while(1){w=w+-1|0;if(r)x=0;else{y=0;do{z=ALc(+(h[t+y>>0]|0)+l*+n[47240+((h[v+y>>0]|0)+128<<2)>>2])|0;A=y|1;B=ALc(+(h[t+A>>0]|0)+l*+n[47240+((h[v+A>>0]|0)+128<<2)>>2])|0;b[u+y>>0]=z>>>0<256?z:(z|0)>0?255:0;b[u+A>>0]=B>>>0<256?B:(B|0)>0?255:0;B=y|2;A=ALc(+(h[t+B>>0]|0)+l*+n[47240+((h[v+B>>0]|0)+128<<2)>>2])|0;z=y|3;C=ALc(+(h[t+z>>0]|0)+l*+n[47240+((h[v+z>>0]|0)+128<<2)>>2])|0;b[u+B>>0]=A>>>0<256?A:(A|0)>0?255:0;b[u+z>>0]=C>>>0<256?C:(C|0)>0?255:0;y=y+4|0}while((y|0)<=(q|0));x=s}if((x|0)<(i|0)){y=x;do{C=ALc(+(h[t+y>>0]|0)+l*+n[47240+((h[v+y>>0]|0)+128<<2)>>2])|0;b[u+y>>0]=C>>>0<256?C:(C|0)>0?255:0;y=y+1|0}while((y|0)!=(i|0))}if(!w)break;else{t=t+e|0;u=u+g|0;v=v+c|0}}return}else{if(k)return;k=i+-4|0;v=(i|0)<4;u=i&-4;t=d;d=f;f=a;a=j;while(1){a=a+-1|0;if(v)D=0;else{j=0;do{w=ALc(o+(l*+n[47240+((h[f+j>>0]|0)+128<<2)>>2]+m*+n[47240+((h[t+j>>0]|0)+128<<2)>>2]))|0;x=j|1;s=ALc(o+(l*+n[47240+((h[f+x>>0]|0)+128<<2)>>2]+m*+n[47240+((h[t+x>>0]|0)+128<<2)>>2]))|0;b[d+j>>0]=w>>>0<256?w:(w|0)>0?255:0;b[d+x>>0]=s>>>0<256?s:(s|0)>0?255:0;s=j|2;x=ALc(o+(l*+n[47240+((h[f+s>>0]|0)+128<<2)>>2]+m*+n[47240+((h[t+s>>0]|0)+128<<2)>>2]))|0;w=j|3;q=ALc(o+(l*+n[47240+((h[f+w>>0]|0)+128<<2)>>2]+m*+n[47240+((h[t+w>>0]|0)+128<<2)>>2]))|0;b[d+s>>0]=x>>>0<256?x:(x|0)>0?255:0;b[d+w>>0]=q>>>0<256?q:(q|0)>0?255:0;j=j+4|0}while((j|0)<=(k|0));D=u}if((D|0)<(i|0)){j=D;do{q=ALc(o+(l*+n[47240+((h[f+j>>0]|0)+128<<2)>>2]+m*+n[47240+((h[t+j>>0]|0)+128<<2)>>2]))|0;b[d+j>>0]=q>>>0<256?q:(q|0)>0?255:0;j=j+1|0}while((j|0)!=(i|0))}if(!a)break;else{t=t+e|0;d=d+g|0;f=f+c|0}}return}}function i8(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];if(!(l==1.0&m==0.0)){if(!i)return;j=h+-4|0;n=(h|0)<4;o=h&-4;q=d;r=f;s=a;t=i;while(1){t=t+-1|0;if(n)u=0;else{v=0;do{w=ALc(m+(k*+(b[s+v>>0]|0)+l*+(b[q+v>>0]|0)))|0;x=v|1;y=ALc(m+(k*+(b[s+x>>0]|0)+l*+(b[q+x>>0]|0)))|0;b[r+v>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;b[r+x>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;y=v|2;x=ALc(m+(k*+(b[s+y>>0]|0)+l*+(b[q+y>>0]|0)))|0;w=v|3;z=ALc(m+(k*+(b[s+w>>0]|0)+l*+(b[q+w>>0]|0)))|0;b[r+y>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;b[r+w>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;v=v+4|0}while((v|0)<=(j|0));u=o}if((u|0)<(h|0)){v=u;do{z=ALc(m+(k*+(b[s+v>>0]|0)+l*+(b[q+v>>0]|0)))|0;b[r+v>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;v=v+1|0}while((v|0)!=(h|0))}if(!t)break;else{q=q+e|0;r=r+g|0;s=s+c|0}}return}s=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){A=d;B=f;C=a;D=s}else return;while(1){r=0;do{q=ALc(+(b[A+r>>0]|0)+k*+(b[C+r>>0]|0))|0;b[B+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;r=r+1|0}while((r|0)!=(h|0));if(!D)break;else{A=A+e|0;B=B+g|0;C=C+c|0;D=D+-1|0}}return}D=h&-4;if((D|0)<(h|0)){E=d;F=f;G=a;H=s}else{C=d;d=f;f=a;a=s;while(1){s=0;do{B=ALc(+(b[C+s>>0]|0)+k*+(b[f+s>>0]|0))|0;A=s|1;r=ALc(+(b[C+A>>0]|0)+k*+(b[f+A>>0]|0))|0;b[d+s>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;b[d+A>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=s|2;A=ALc(+(b[C+r>>0]|0)+k*+(b[f+r>>0]|0))|0;B=s|3;q=ALc(+(b[C+B>>0]|0)+k*+(b[f+B>>0]|0))|0;b[d+r>>0]=(A+128|0)>>>0<256?A:(A|0)>0?127:128;b[d+B>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;s=s+4|0}while((s|0)<=(i|0));if(!a)break;else{C=C+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=ALc(+(b[E+a>>0]|0)+k*+(b[G+a>>0]|0))|0;d=a|1;C=ALc(+(b[E+d>>0]|0)+k*+(b[G+d>>0]|0))|0;b[F+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[F+d>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;C=a|2;d=ALc(+(b[E+C>>0]|0)+k*+(b[G+C>>0]|0))|0;f=a|3;s=ALc(+(b[E+f>>0]|0)+k*+(b[G+f>>0]|0))|0;b[F+C>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[F+f>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;a=a+4|0}while((a|0)<=(i|0));I=D;do{a=ALc(+(b[E+I>>0]|0)+k*+(b[G+I>>0]|0))|0;b[F+I>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;I=I+1|0}while((I|0)!=(h|0));if(!H)break;else{E=E+e|0;F=F+g|0;G=G+c|0;H=H+-1|0}}return}function j8(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;l=+p[k>>3];m=+p[k+8>>3];n=+p[k+16>>3];k=b>>>1;b=e>>>1;e=g>>>1;g=(i|0)==0;if(m==1.0&n==0.0){if(g)return;o=h+-4|0;q=(h|0)<4;r=h&-4;s=c;t=f;u=a;v=i;while(1){v=v+-1|0;if(q)w=0;else{x=0;do{y=ALc(+(j[s+(x<<1)>>1]|0)+l*+(j[u+(x<<1)>>1]|0))|0;z=x|1;A=ALc(+(j[s+(z<<1)>>1]|0)+l*+(j[u+(z<<1)>>1]|0))|0;d[t+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;d[t+(z<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;A=x|2;z=ALc(+(j[s+(A<<1)>>1]|0)+l*+(j[u+(A<<1)>>1]|0))|0;y=x|3;B=ALc(+(j[s+(y<<1)>>1]|0)+l*+(j[u+(y<<1)>>1]|0))|0;d[t+(A<<1)>>1]=z>>>0<65536?z:(z|0)>0?65535:0;d[t+(y<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+4|0}while((x|0)<=(o|0));w=r}if((w|0)<(h|0)){x=w;do{B=ALc(+(j[s+(x<<1)>>1]|0)+l*+(j[u+(x<<1)>>1]|0))|0;d[t+(x<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+1|0}while((x|0)!=(h|0))}if(!v)break;else{s=s+(b<<1)|0;t=t+(e<<1)|0;u=u+(k<<1)|0}}return}else{if(g)return;g=h+-4|0;u=(h|0)<4;t=h&-4;s=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(u)C=0;else{i=0;do{v=ALc(n+(l*+(j[f+(i<<1)>>1]|0)+m*+(j[s+(i<<1)>>1]|0)))|0;w=i|1;r=ALc(n+(l*+(j[f+(w<<1)>>1]|0)+m*+(j[s+(w<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[c+(w<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=i|2;w=ALc(n+(l*+(j[f+(r<<1)>>1]|0)+m*+(j[s+(r<<1)>>1]|0)))|0;v=i|3;o=ALc(n+(l*+(j[f+(v<<1)>>1]|0)+m*+(j[s+(v<<1)>>1]|0)))|0;d[c+(r<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[c+(v<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;i=i+4|0}while((i|0)<=(g|0));C=t}if((C|0)<(h|0)){i=C;do{o=ALc(n+(l*+(j[f+(i<<1)>>1]|0)+m*+(j[s+(i<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{s=s+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0}}return}}function k8(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];j=b>>>1;b=e>>>1;e=g>>>1;g=(i|0)==0;if(l==1.0&m==0.0){if(g)return;n=h+-4|0;o=(h|0)<4;q=h&-4;r=c;s=f;t=a;u=i;while(1){u=u+-1|0;if(o)v=0;else{w=0;do{x=ALc(+(d[r+(w<<1)>>1]|0)+k*+(d[t+(w<<1)>>1]|0))|0;y=w|1;z=ALc(+(d[r+(y<<1)>>1]|0)+k*+(d[t+(y<<1)>>1]|0))|0;d[s+(w<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;d[s+(y<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;z=w|2;y=ALc(+(d[r+(z<<1)>>1]|0)+k*+(d[t+(z<<1)>>1]|0))|0;x=w|3;A=ALc(+(d[r+(x<<1)>>1]|0)+k*+(d[t+(x<<1)>>1]|0))|0;d[s+(z<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;w=w+4|0}while((w|0)<=(n|0));v=q}if((v|0)<(h|0)){w=v;do{A=ALc(+(d[r+(w<<1)>>1]|0)+k*+(d[t+(w<<1)>>1]|0))|0;d[s+(w<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;w=w+1|0}while((w|0)!=(h|0))}if(!u)break;else{r=r+(b<<1)|0;s=s+(e<<1)|0;t=t+(j<<1)|0}}return}else{if(g)return;g=h+-4|0;t=(h|0)<4;s=h&-4;r=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(t)B=0;else{i=0;do{u=ALc(m+(k*+(d[f+(i<<1)>>1]|0)+l*+(d[r+(i<<1)>>1]|0)))|0;v=i|1;q=ALc(m+(k*+(d[f+(v<<1)>>1]|0)+l*+(d[r+(v<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[c+(v<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;q=i|2;v=ALc(m+(k*+(d[f+(q<<1)>>1]|0)+l*+(d[r+(q<<1)>>1]|0)))|0;u=i|3;n=ALc(m+(k*+(d[f+(u<<1)>>1]|0)+l*+(d[r+(u<<1)>>1]|0)))|0;d[c+(q<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[c+(u<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;i=i+4|0}while((i|0)<=(g|0));B=s}if((B|0)<(h|0)){i=B;do{n=ALc(m+(k*+(d[f+(i<<1)>>1]|0)+l*+(d[r+(i<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{r=r+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0}}return}}function l8(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;k=+p[j+8>>3];if(k==1.0?+p[j+16>>3]==0.0:0){l=b>>>2;m=d>>>2;n=g>>>2;o=i+-1|0;if(!i)return;q=h+-4|0;if((h|0)<4){if((h|0)<=0)return;r=+p[j>>3];s=c;t=e;u=a;v=o;while(1){w=0;do{x=zLc(+(f[s+(w<<2)>>2]|0)+r*+(f[u+(w<<2)>>2]|0))|0;f[t+(w<<2)>>2]=x;w=w+1|0}while((w|0)!=(h|0));if(!v)break;else{s=s+(m<<2)|0;t=t+(n<<2)|0;u=u+(l<<2)|0;v=v+-1|0}}return}v=h&-4;r=+p[j>>3];if((v|0)<(h|0)){y=c;z=e;A=a;B=o}else{u=c;t=e;s=a;w=o;while(1){o=0;do{x=zLc(+(f[u+(o<<2)>>2]|0)+r*+(f[s+(o<<2)>>2]|0))|0;C=o|1;D=zLc(+(f[u+(C<<2)>>2]|0)+r*+(f[s+(C<<2)>>2]|0))|0;f[t+(o<<2)>>2]=x;f[t+(C<<2)>>2]=D;D=o|2;C=zLc(+(f[u+(D<<2)>>2]|0)+r*+(f[s+(D<<2)>>2]|0))|0;x=o|3;E=zLc(+(f[u+(x<<2)>>2]|0)+r*+(f[s+(x<<2)>>2]|0))|0;f[t+(D<<2)>>2]=C;f[t+(x<<2)>>2]=E;o=o+4|0}while((o|0)<=(q|0));if(!w)break;else{u=u+(m<<2)|0;t=t+(n<<2)|0;s=s+(l<<2)|0;w=w+-1|0}}return}while(1){w=0;do{s=zLc(+(f[y+(w<<2)>>2]|0)+r*+(f[A+(w<<2)>>2]|0))|0;t=w|1;u=zLc(+(f[y+(t<<2)>>2]|0)+r*+(f[A+(t<<2)>>2]|0))|0;f[z+(w<<2)>>2]=s;f[z+(t<<2)>>2]=u;u=w|2;t=zLc(+(f[y+(u<<2)>>2]|0)+r*+(f[A+(u<<2)>>2]|0))|0;s=w|3;o=zLc(+(f[y+(s<<2)>>2]|0)+r*+(f[A+(s<<2)>>2]|0))|0;f[z+(u<<2)>>2]=t;f[z+(s<<2)>>2]=o;w=w+4|0}while((w|0)<=(q|0));F=v;do{w=zLc(+(f[y+(F<<2)>>2]|0)+r*+(f[A+(F<<2)>>2]|0))|0;f[z+(F<<2)>>2]=w;F=F+1|0}while((F|0)!=(h|0));if(!B)break;else{y=y+(m<<2)|0;z=z+(n<<2)|0;A=A+(l<<2)|0;B=B+-1|0}}return}B=b>>>2;b=d>>>2;d=g>>>2;if(!i)return;g=h+-4|0;l=j+16|0;A=h&-4;if((h|0)<4){n=(h|0)>0;z=c;m=e;y=a;F=i;while(1){F=F+-1|0;if(n){r=+p[j>>3];G=+p[l>>3];v=0;do{q=zLc(G+(r*+(f[y+(v<<2)>>2]|0)+k*+(f[z+(v<<2)>>2]|0)))|0;f[m+(v<<2)>>2]=q;v=v+1|0}while((v|0)!=(h|0))}if(!F)break;else{z=z+(b<<2)|0;m=m+(d<<2)|0;y=y+(B<<2)|0}}return}r=+p[j>>3];G=+p[l>>3];l=(A|0)<(h|0);j=c;c=e;e=a;a=i;while(1){i=0;do{y=zLc(G+(r*+(f[e+(i<<2)>>2]|0)+k*+(f[j+(i<<2)>>2]|0)))|0;m=i|1;z=zLc(G+(r*+(f[e+(m<<2)>>2]|0)+k*+(f[j+(m<<2)>>2]|0)))|0;f[c+(i<<2)>>2]=y;f[c+(m<<2)>>2]=z;z=i|2;m=zLc(G+(r*+(f[e+(z<<2)>>2]|0)+k*+(f[j+(z<<2)>>2]|0)))|0;y=i|3;F=zLc(G+(r*+(f[e+(y<<2)>>2]|0)+k*+(f[j+(y<<2)>>2]|0)))|0;f[c+(z<<2)>>2]=m;f[c+(y<<2)>>2]=F;i=i+4|0}while((i|0)<=(g|0));a=a+-1|0;if(l){i=A;do{F=zLc(G+(r*+(f[e+(i<<2)>>2]|0)+k*+(f[j+(i<<2)>>2]|0)))|0;f[c+(i<<2)>>2]=F;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{j=j+(b<<2)|0;c=c+(d<<2)|0;e=e+(B<<2)|0}}return}function m8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0;j=+p[i+8>>3];if(j==1.0?+p[i+16>>3]==0.0:0){k=b>>>2;l=d>>>2;m=f>>>2;o=h+-1|0;if(!h)return;q=g+-4|0;if((g|0)<4){if((g|0)<=0)return;r=+p[i>>3];s=c;t=e;u=a;v=o;while(1){w=0;do{n[t+(w<<2)>>2]=+n[s+(w<<2)>>2]+r*+n[u+(w<<2)>>2];w=w+1|0}while((w|0)!=(g|0));if(!v)break;else{s=s+(l<<2)|0;t=t+(m<<2)|0;u=u+(k<<2)|0;v=v+-1|0}}return}v=g&-4;r=+p[i>>3];if((v|0)<(g|0)){x=c;y=e;z=a;A=o}else{u=c;t=e;s=a;w=o;while(1){o=0;do{B=o|1;C=+n[u+(B<<2)>>2]+r*+n[s+(B<<2)>>2];n[t+(o<<2)>>2]=+n[u+(o<<2)>>2]+r*+n[s+(o<<2)>>2];n[t+(B<<2)>>2]=C;B=o|2;D=o|3;C=+n[u+(D<<2)>>2]+r*+n[s+(D<<2)>>2];n[t+(B<<2)>>2]=+n[u+(B<<2)>>2]+r*+n[s+(B<<2)>>2];n[t+(D<<2)>>2]=C;o=o+4|0}while((o|0)<=(q|0));if(!w)break;else{u=u+(l<<2)|0;t=t+(m<<2)|0;s=s+(k<<2)|0;w=w+-1|0}}return}while(1){w=0;do{s=w|1;C=+n[x+(s<<2)>>2]+r*+n[z+(s<<2)>>2];n[y+(w<<2)>>2]=+n[x+(w<<2)>>2]+r*+n[z+(w<<2)>>2];n[y+(s<<2)>>2]=C;s=w|2;t=w|3;C=+n[x+(t<<2)>>2]+r*+n[z+(t<<2)>>2];n[y+(s<<2)>>2]=+n[x+(s<<2)>>2]+r*+n[z+(s<<2)>>2];n[y+(t<<2)>>2]=C;w=w+4|0}while((w|0)<=(q|0));E=v;do{n[y+(E<<2)>>2]=+n[x+(E<<2)>>2]+r*+n[z+(E<<2)>>2];E=E+1|0}while((E|0)!=(g|0));if(!A)break;else{x=x+(l<<2)|0;y=y+(m<<2)|0;z=z+(k<<2)|0;A=A+-1|0}}return}A=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;k=i+16|0;if((g|0)<4){if((g|0)<=0)return;r=+p[i>>3];C=+p[k>>3];z=c;m=e;y=a;l=f;while(1){x=0;do{n[m+(x<<2)>>2]=C+(r*+n[y+(x<<2)>>2]+j*+n[z+(x<<2)>>2]);x=x+1|0}while((x|0)!=(g|0));if(!l)break;else{z=z+(b<<2)|0;m=m+(d<<2)|0;y=y+(A<<2)|0;l=l+-1|0}}return}l=g&-4;r=+p[i>>3];C=+p[k>>3];if((l|0)<(g|0)){F=c;G=e;H=a;I=f}else{k=c;c=e;e=a;a=f;while(1){f=0;do{i=f|1;J=C+(r*+n[e+(i<<2)>>2]+j*+n[k+(i<<2)>>2]);n[c+(f<<2)>>2]=C+(r*+n[e+(f<<2)>>2]+j*+n[k+(f<<2)>>2]);n[c+(i<<2)>>2]=J;i=f|2;y=f|3;J=C+(r*+n[e+(y<<2)>>2]+j*+n[k+(y<<2)>>2]);n[c+(i<<2)>>2]=C+(r*+n[e+(i<<2)>>2]+j*+n[k+(i<<2)>>2]);n[c+(y<<2)>>2]=J;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{k=k+(b<<2)|0;c=c+(d<<2)|0;e=e+(A<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;J=C+(r*+n[H+(e<<2)>>2]+j*+n[F+(e<<2)>>2]);n[G+(a<<2)>>2]=C+(r*+n[H+(a<<2)>>2]+j*+n[F+(a<<2)>>2]);n[G+(e<<2)>>2]=J;e=a|2;c=a|3;J=C+(r*+n[H+(c<<2)>>2]+j*+n[F+(c<<2)>>2]);n[G+(e<<2)>>2]=C+(r*+n[H+(e<<2)>>2]+j*+n[F+(e<<2)>>2]);n[G+(c<<2)>>2]=J;a=a+4|0}while((a|0)<=(h|0));K=l;do{n[G+(K<<2)>>2]=C+(r*+n[H+(K<<2)>>2]+j*+n[F+(K<<2)>>2]);K=K+1|0}while((K|0)!=(g|0));if(!I)break;else{F=F+(b<<2)|0;G=G+(d<<2)|0;H=H+(A<<2)|0;I=I+-1|0}}return}function n8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0;j=i+8|0;if(+p[j>>3]==1.0?+p[i+16>>3]==0.0:0){k=b>>>3;l=d>>>3;m=f>>>3;n=h+-1|0;if(!h)return;o=g+-4|0;if((g|0)<4){if((g|0)>0){q=c;r=e;s=a;t=n}else return;while(1){u=0;do{p[r+(u<<3)>>3]=+p[q+(u<<3)>>3]+ +p[s+(u<<3)>>3]*+p[i>>3];u=u+1|0}while((u|0)!=(g|0));if(!t)break;else{q=q+(l<<3)|0;r=r+(m<<3)|0;s=s+(k<<3)|0;t=t+-1|0}}return}t=g&-4;if((t|0)<(g|0)){v=c;w=e;x=a;y=n}else{s=c;r=e;q=a;u=n;while(1){n=0;do{z=+p[i>>3];A=n|1;B=z*+p[q+(A<<3)>>3]+ +p[s+(A<<3)>>3];p[r+(n<<3)>>3]=+p[s+(n<<3)>>3]+ +p[q+(n<<3)>>3]*z;p[r+(A<<3)>>3]=B;A=n|2;B=+p[i>>3];C=n|3;z=B*+p[q+(C<<3)>>3]+ +p[s+(C<<3)>>3];p[r+(A<<3)>>3]=+p[s+(A<<3)>>3]+ +p[q+(A<<3)>>3]*B;p[r+(C<<3)>>3]=z;n=n+4|0}while((n|0)<=(o|0));if(!u)break;else{s=s+(l<<3)|0;r=r+(m<<3)|0;q=q+(k<<3)|0;u=u+-1|0}}return}while(1){u=0;do{z=+p[i>>3];q=u|1;B=z*+p[x+(q<<3)>>3]+ +p[v+(q<<3)>>3];p[w+(u<<3)>>3]=+p[v+(u<<3)>>3]+ +p[x+(u<<3)>>3]*z;p[w+(q<<3)>>3]=B;q=u|2;B=+p[i>>3];r=u|3;z=B*+p[x+(r<<3)>>3]+ +p[v+(r<<3)>>3];p[w+(q<<3)>>3]=+p[v+(q<<3)>>3]+ +p[x+(q<<3)>>3]*B;p[w+(r<<3)>>3]=z;u=u+4|0}while((u|0)<=(o|0));D=t;do{p[w+(D<<3)>>3]=+p[v+(D<<3)>>3]+ +p[x+(D<<3)>>3]*+p[i>>3];D=D+1|0}while((D|0)!=(g|0));if(!y)break;else{v=v+(l<<3)|0;w=w+(m<<3)|0;x=x+(k<<3)|0;y=y+-1|0}}return}y=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;k=i+16|0;if((g|0)<4){if((g|0)>0){E=c;F=e;G=a;H=f}else return;while(1){x=0;do{p[F+(x<<3)>>3]=+p[k>>3]+(+p[G+(x<<3)>>3]*+p[i>>3]+ +p[E+(x<<3)>>3]*+p[j>>3]);x=x+1|0}while((x|0)!=(g|0));if(!H)break;else{E=E+(b<<3)|0;F=F+(d<<3)|0;G=G+(y<<3)|0;H=H+-1|0}}return}H=g&-4;if((H|0)<(g|0)){I=c;J=e;K=a;L=f}else{G=c;c=e;e=a;a=f;while(1){f=0;do{z=+p[i>>3];B=+p[j>>3];M=+p[k>>3];F=f|1;N=M+(z*+p[e+(F<<3)>>3]+B*+p[G+(F<<3)>>3]);p[c+(f<<3)>>3]=M+(+p[e+(f<<3)>>3]*z+ +p[G+(f<<3)>>3]*B);p[c+(F<<3)>>3]=N;F=f|2;N=+p[i>>3];B=+p[j>>3];z=+p[k>>3];E=f|3;M=z+(N*+p[e+(E<<3)>>3]+B*+p[G+(E<<3)>>3]);p[c+(F<<3)>>3]=z+(+p[e+(F<<3)>>3]*N+ +p[G+(F<<3)>>3]*B);p[c+(E<<3)>>3]=M;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{G=G+(b<<3)|0;c=c+(d<<3)|0;e=e+(y<<3)|0;a=a+-1|0}}return}while(1){a=0;do{M=+p[i>>3];B=+p[j>>3];N=+p[k>>3];e=a|1;z=N+(M*+p[K+(e<<3)>>3]+B*+p[I+(e<<3)>>3]);p[J+(a<<3)>>3]=N+(+p[K+(a<<3)>>3]*M+ +p[I+(a<<3)>>3]*B);p[J+(e<<3)>>3]=z;e=a|2;z=+p[i>>3];B=+p[j>>3];M=+p[k>>3];c=a|3;N=M+(z*+p[K+(c<<3)>>3]+B*+p[I+(c<<3)>>3]);p[J+(e<<3)>>3]=M+(+p[K+(e<<3)>>3]*z+ +p[I+(e<<3)>>3]*B);p[J+(c<<3)>>3]=N;a=a+4|0}while((a|0)<=(h|0));O=H;do{p[J+(O<<3)>>3]=+p[k>>3]+(+p[K+(O<<3)>>3]*+p[i>>3]+ +p[I+(O<<3)>>3]*+p[j>>3]);O=O+1|0}while((O|0)!=(g|0));if(!L)break;else{I=I+(b<<3)|0;J=J+(d<<3)|0;K=K+(y<<3)|0;L=L+-1|0}}return}function o8(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;i=+p[h>>3];if(!g)return;h=f+-4|0;j=(f|0)<4;k=f&-4;l=d;d=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{o=b[d+g>>0]|0;if(!(o<<24>>24))q=0;else{r=ALc(i/+n[47240+((o&255)+128<<2)>>2])|0;q=(r>>>0<256?r:(r|0)>0?255:0)&255}r=g|1;o=b[d+r>>0]|0;if(!(o<<24>>24))s=0;else{t=ALc(i/+n[47240+((o&255)+128<<2)>>2])|0;s=(t>>>0<256?t:(t|0)>0?255:0)&255}b[l+g>>0]=q;b[l+r>>0]=s;r=g|2;t=b[d+r>>0]|0;if(!(t<<24>>24))u=0;else{o=ALc(i/+n[47240+((t&255)+128<<2)>>2])|0;u=(o>>>0<256?o:(o|0)>0?255:0)&255}o=g|3;t=b[d+o>>0]|0;if(!(t<<24>>24))v=0;else{w=ALc(i/+n[47240+((t&255)+128<<2)>>2])|0;v=(w>>>0<256?w:(w|0)>0?255:0)&255}b[l+r>>0]=u;b[l+o>>0]=v;g=g+4|0}while((g|0)<=(h|0));m=k}if((m|0)<(f|0)){g=m;do{o=b[d+g>>0]|0;if(!(o<<24>>24))x=0;else{r=ALc(i/+n[47240+((o&255)+128<<2)>>2])|0;x=(r>>>0<256?r:(r|0)>0?255:0)&255}b[l+g>>0]=x;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+e|0;d=d+c|0}}return}function p8(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=+p[h>>3];if(!g)return;h=f+-4|0;j=(f|0)<4;k=f&-4;l=d;d=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{n=b[d+g>>0]|0;if(!(n<<24>>24))o=0;else{q=ALc(i/+(n<<24>>24))|0;o=((q+128|0)>>>0<256?q:(q|0)>0?127:128)&255}q=g|1;n=b[d+q>>0]|0;if(!(n<<24>>24))r=0;else{s=ALc(i/+(n<<24>>24))|0;r=((s+128|0)>>>0<256?s:(s|0)>0?127:128)&255}b[l+g>>0]=o;b[l+q>>0]=r;q=g|2;s=b[d+q>>0]|0;if(!(s<<24>>24))t=0;else{n=ALc(i/+(s<<24>>24))|0;t=((n+128|0)>>>0<256?n:(n|0)>0?127:128)&255}n=g|3;s=b[d+n>>0]|0;if(!(s<<24>>24))u=0;else{v=ALc(i/+(s<<24>>24))|0;u=((v+128|0)>>>0<256?v:(v|0)>0?127:128)&255}b[l+q>>0]=t;b[l+n>>0]=u;g=g+4|0}while((g|0)<=(h|0));m=k}if((m|0)<(f|0)){g=m;do{n=b[d+g>>0]|0;if(!(n<<24>>24))w=0;else{q=ALc(i/+(n<<24>>24))|0;w=((q+128|0)>>>0<256?q:(q|0)>0?127:128)&255}b[l+g>>0]=w;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+e|0;d=d+c|0}}return}function q8(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=+p[h>>3];h=b>>>1;b=e>>>1;if(!g)return;e=f+-4|0;j=(f|0)<4;k=f&-4;l=c;c=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))o=0;else{q=ALc(i/+(n&65535))|0;o=(q>>>0<65536?q:(q|0)>0?65535:0)&65535}q=g|1;n=d[c+(q<<1)>>1]|0;if(!(n<<16>>16))r=0;else{s=ALc(i/+(n&65535))|0;r=(s>>>0<65536?s:(s|0)>0?65535:0)&65535}d[l+(g<<1)>>1]=o;d[l+(q<<1)>>1]=r;q=g|2;s=d[c+(q<<1)>>1]|0;if(!(s<<16>>16))t=0;else{n=ALc(i/+(s&65535))|0;t=(n>>>0<65536?n:(n|0)>0?65535:0)&65535}n=g|3;s=d[c+(n<<1)>>1]|0;if(!(s<<16>>16))u=0;else{v=ALc(i/+(s&65535))|0;u=(v>>>0<65536?v:(v|0)>0?65535:0)&65535}d[l+(q<<1)>>1]=t;d[l+(n<<1)>>1]=u;g=g+4|0}while((g|0)<=(e|0));m=k}if((m|0)<(f|0)){g=m;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))w=0;else{q=ALc(i/+(n&65535))|0;w=(q>>>0<65536?q:(q|0)>0?65535:0)&65535}d[l+(g<<1)>>1]=w;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(h<<1)|0}}return}function r8(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=+p[h>>3];h=b>>>1;b=e>>>1;if(!g)return;e=f+-4|0;j=(f|0)<4;k=f&-4;l=c;c=a;a=g;while(1){a=a+-1|0;if(j)m=0;else{g=0;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))o=0;else{q=ALc(i/+(n<<16>>16))|0;o=((q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768)&65535}q=g|1;n=d[c+(q<<1)>>1]|0;if(!(n<<16>>16))r=0;else{s=ALc(i/+(n<<16>>16))|0;r=((s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768)&65535}d[l+(g<<1)>>1]=o;d[l+(q<<1)>>1]=r;q=g|2;s=d[c+(q<<1)>>1]|0;if(!(s<<16>>16))t=0;else{n=ALc(i/+(s<<16>>16))|0;t=((n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768)&65535}n=g|3;s=d[c+(n<<1)>>1]|0;if(!(s<<16>>16))u=0;else{v=ALc(i/+(s<<16>>16))|0;u=((v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768)&65535}d[l+(q<<1)>>1]=t;d[l+(n<<1)>>1]=u;g=g+4|0}while((g|0)<=(e|0));m=k}if((m|0)<(f|0)){g=m;do{n=d[c+(g<<1)>>1]|0;if(!(n<<16>>16))w=0;else{q=ALc(i/+(n<<16>>16))|0;w=((q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768)&65535}d[l+(g<<1)>>1]=w;g=g+1|0}while((g|0)!=(f|0))}if(!a)break;else{l=l+(b<<1)|0;c=c+(h<<1)|0}}return}function s8(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=+p[h>>3];h=b>>>2;b=d>>>2;d=g+-1|0;if(!g)return;g=e+-4|0;if((e|0)<4){if((e|0)>0){j=c;k=a;l=d}else return;while(1){m=0;do{n=f[k+(m<<2)>>2]|0;if(!n)o=0;else o=ALc(i/+(n|0))|0;f[j+(m<<2)>>2]=o;m=m+1|0}while((m|0)!=(e|0));if(!l)break;else{j=j+(b<<2)|0;k=k+(h<<2)|0;l=l+-1|0}}return}l=e&-4;if((l|0)<(e|0)){q=c;r=a;s=d}else{k=c;c=a;a=d;while(1){d=0;do{j=f[c+(d<<2)>>2]|0;if(!j)t=0;else t=ALc(i/+(j|0))|0;j=d|1;o=f[c+(j<<2)>>2]|0;if(!o)u=0;else u=ALc(i/+(o|0))|0;f[k+(d<<2)>>2]=t;f[k+(j<<2)>>2]=u;j=d|2;o=f[c+(j<<2)>>2]|0;if(!o)v=0;else v=ALc(i/+(o|0))|0;o=d|3;m=f[c+(o<<2)>>2]|0;if(!m)w=0;else w=ALc(i/+(m|0))|0;f[k+(j<<2)>>2]=v;f[k+(o<<2)>>2]=w;d=d+4|0}while((d|0)<=(g|0));if(!a)break;else{k=k+(b<<2)|0;c=c+(h<<2)|0;a=a+-1|0}}return}while(1){a=0;do{c=f[r+(a<<2)>>2]|0;if(!c)x=0;else x=ALc(i/+(c|0))|0;c=a|1;k=f[r+(c<<2)>>2]|0;if(!k)y=0;else y=ALc(i/+(k|0))|0;f[q+(a<<2)>>2]=x;f[q+(c<<2)>>2]=y;c=a|2;k=f[r+(c<<2)>>2]|0;if(!k)z=0;else z=ALc(i/+(k|0))|0;k=a|3;w=f[r+(k<<2)>>2]|0;if(!w)A=0;else A=ALc(i/+(w|0))|0;f[q+(c<<2)>>2]=z;f[q+(k<<2)>>2]=A;a=a+4|0}while((a|0)<=(g|0));B=l;do{a=f[r+(B<<2)>>2]|0;if(!a)C=0;else C=ALc(i/+(a|0))|0;f[q+(B<<2)>>2]=C;B=B+1|0}while((B|0)!=(e|0));if(!s)break;else{q=q+(b<<2)|0;r=r+(h<<2)|0;s=s+-1|0}}return}function t8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0;h=+p[g>>3];g=b>>>2;b=d>>>2;d=f+-1|0;if(!f)return;f=e+-4|0;if((e|0)<4){if((e|0)>0){i=c;j=a;k=d}else return;while(1){l=0;do{n[i+(l<<2)>>2]=h/+n[j+(l<<2)>>2];l=l+1|0}while((l|0)!=(e|0));if(!k)break;else{i=i+(b<<2)|0;j=j+(g<<2)|0;k=k+-1|0}}return}k=e&-4;if((k|0)<(e|0)){m=c;o=a;q=d}else{j=c;c=a;a=d;while(1){d=0;do{i=d|1;r=h/+n[c+(i<<2)>>2];n[j+(d<<2)>>2]=h/+n[c+(d<<2)>>2];n[j+(i<<2)>>2]=r;i=d|2;l=d|3;r=h/+n[c+(l<<2)>>2];n[j+(i<<2)>>2]=h/+n[c+(i<<2)>>2];n[j+(l<<2)>>2]=r;d=d+4|0}while((d|0)<=(f|0));if(!a)break;else{j=j+(b<<2)|0;c=c+(g<<2)|0;a=a+-1|0}}return}while(1){a=0;do{c=a|1;r=h/+n[o+(c<<2)>>2];n[m+(a<<2)>>2]=h/+n[o+(a<<2)>>2];n[m+(c<<2)>>2]=r;c=a|2;j=a|3;r=h/+n[o+(j<<2)>>2];n[m+(c<<2)>>2]=h/+n[o+(c<<2)>>2];n[m+(j<<2)>>2]=r;a=a+4|0}while((a|0)<=(f|0));s=k;do{n[m+(s<<2)>>2]=h/+n[o+(s<<2)>>2];s=s+1|0}while((s|0)!=(e|0));if(!q)break;else{m=m+(b<<2)|0;o=o+(g<<2)|0;q=q+-1|0}}return}function u8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0;h=b>>>3;b=d>>>3;d=f+-1|0;if(!f)return;f=e+-4|0;if((e|0)<4){if((e|0)>0){i=c;j=a;k=d}else return;while(1){l=0;do{p[i+(l<<3)>>3]=+p[g>>3]/+p[j+(l<<3)>>3];l=l+1|0}while((l|0)!=(e|0));if(!k)break;else{i=i+(b<<3)|0;j=j+(h<<3)|0;k=k+-1|0}}return}k=e&-4;if((k|0)<(e|0)){m=c;n=a;o=d}else{j=c;c=a;a=d;while(1){d=0;do{q=+p[g>>3];i=d|1;r=q/+p[c+(i<<3)>>3];p[j+(d<<3)>>3]=q/+p[c+(d<<3)>>3];p[j+(i<<3)>>3]=r;i=d|2;r=+p[g>>3];l=d|3;q=r/+p[c+(l<<3)>>3];p[j+(i<<3)>>3]=r/+p[c+(i<<3)>>3];p[j+(l<<3)>>3]=q;d=d+4|0}while((d|0)<=(f|0));if(!a)break;else{j=j+(b<<3)|0;c=c+(h<<3)|0;a=a+-1|0}}return}while(1){a=0;do{q=+p[g>>3];c=a|1;r=q/+p[n+(c<<3)>>3];p[m+(a<<3)>>3]=q/+p[n+(a<<3)>>3];p[m+(c<<3)>>3]=r;c=a|2;r=+p[g>>3];j=a|3;q=r/+p[n+(j<<3)>>3];p[m+(c<<3)>>3]=r/+p[n+(c<<3)>>3];p[m+(j<<3)>>3]=q;a=a+4|0}while((a|0)<=(f|0));s=k;do{p[m+(s<<3)>>3]=+p[g>>3]/+p[n+(s<<3)>>3];s=s+1|0}while((s|0)!=(e|0));if(!o)break;else{m=m+(b<<3)|0;n=n+(h<<3)|0;o=o+-1|0}}return}function v8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;P6(a,b,c,d,e,f,g,h);return}function w8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Q6(a,b,c,d,e,f,g,h);return}function x8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;R6(a,b,c,d,e,f,g,h);return}function y8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;S6(a,b,c,d,e,f,g,h);return}function z8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;T6(a,b,c,d,e,f,g,h);return}function A8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;U6(a,b,c,d,e,f,g,h);return}function B8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;V6(a,b,c,d,e,f,g,h);return}function C8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;W6(a,b,c,d,e,f,g,h);return}function D8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;X6(a,b,c,d,e,f,g,h);return}function E8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Y6(a,b,c,d,e,f,g,h);return}function F8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Z6(a,b,c,d,e,f,g,h);return}function G8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_6(a,b,c,d,e,f,g,h);return}function H8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$6(a,b,c,d,e,f,g,h);return}function I8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;a7(a,b,c,d,e,f,g,h);return}function J8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;b7(a,b,c,d,e,f,g,h);return}function K8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c7(a,b,c,d,e,f,g,h);return}function L8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;d7(a,b,c,d,e,f,g,h);return}function M8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;e7(a,b,c,d,e,f,g,h);return}function N8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;f7(a,b,c,d,e,f,g,h);return}function O8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;g7(a,b,c,d,e,f,g,h);return}function P8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;h7(a,b,c,d,e,f,g,h);return}function Q8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;i7(a,b,c,d,e,f,g,h);return}function R8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j7(a,b,c,d,e,f,g,h);return}function S8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k7(a,b,c,d,e,f,g,h);return}function T8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;l7(a,b,c,d,e,f,g,h);return}function U8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;m7(a,b,c,d,e,f,g,h);return}function V8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;n7(a,b,c,d,e,f,g,h);return}function W8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;o7(a,b,c,d,e,f,g,h);return}function X8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;p7(a,b,c,d,e,f,g,h);return}function Y8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;q7(a,b,c,d,e,f,g,h);return}function Z8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;r7(a,b,c,d,e,f,g,h);return}function _8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;s7(a,b,c,d,e,f,g,h);return}function $8(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;t7(a,b,c,d,e,f,g,h);return}function a9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;u7(a,b,c,d,e,f,g,h);return}function b9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;v7(a,b,c,d,e,f,g,h);return}function c9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;w7(a,b,c,d,e,f,g,h);return}function d9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;x7(a,b,c,d,e,f,g,h);return}function e9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;y7(a,b,c,d,e,f,g,h);return}function f9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;z7(a,b,c,d,e,f,g,h);return}function g9(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;A7(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function h9(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;D7(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function i9(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;G7(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function j9(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;J7(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function k9(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;M7(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function l9(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;P7(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function m9(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;S7(a,b,c,d,e,g,h,i,f[j>>2]|0);return}function n9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;V7(a,b,c,d,e,f,g,h,i);return}function o9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;W7(a,b,c,d,e,f,g,h,i);return}function p9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;X7(a,b,c,d,e,f,g,h,i);return}function q9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Y7(a,b,c,d,e,f,g,h,i);return}function r9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Z7(a,b,c,d,e,f,g,h,i);return}function s9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_7(a,b,c,d,e,f,g,h,i);return}function t9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$7(a,b,c,d,e,f,g,h,i);return}function u9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;a8(a,b,c,d,e,f,g,h,i);return}function v9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;b8(a,b,c,d,e,f,g,h,i);return}function w9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c8(a,b,c,d,e,f,g,h,i);return}function x9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;d8(a,b,c,d,e,f,g,h,i);return}function y9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;e8(a,b,c,d,e,f,g,h,i);return}function z9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;f8(a,b,c,d,e,f,g,h,i);return}function A9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;g8(a,b,c,d,e,f,g,h,i);return}function B9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;h8(a,b,c,d,e,f,g,h,i);return}function C9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;i8(a,b,c,d,e,f,g,h,i);return}function D9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j8(a,b,c,d,e,f,g,h,i);return}function E9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k8(a,b,c,d,e,f,g,h,i);return}function F9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;l8(a,b,c,d,e,f,g,h,i);return}function G9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;m8(a,b,c,d,e,f,g,h,i);return}function H9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;n8(a,b,c,d,e,f,g,h,i);return}function I9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;o8(c,d,e,f,g,h,i);return}function J9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;p8(c,d,e,f,g,h,i);return}function K9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;q8(c,d,e,f,g,h,i);return}function L9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;r8(c,d,e,f,g,h,i);return}function M9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;s8(c,d,e,f,g,h,i);return}function N9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;t8(c,d,e,f,g,h,i);return}function O9(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;u8(c,d,e,f,g,h,i);return}function P9(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(20)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=49040;d=c+12|0;f[d>>2]=49068;f[c+16>>2]=b;f[a>>2]=d;f[a+4>>2]=c;return}function Q9(a){a=a|0;cYc(a);return}function R9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+5136|0;j=i+16|0;k=i;l=g&15|16;if(!(D5(l)|0)){g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=72;m=g;n=250416;o=m+72|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[g+72>>0]=0;vM(-5,k,250489,249976,27)}if(((h|0)!=0?(b[h>>0]|0)!=0:0)?(WKc(h,250506,6)|0)==0:0){p=3;q=j}else{h=b5(l)|0;b[j>>0]=h?123:91;p=l;q=j+1|0}b[q>>0]=0;Ti[f[(f[c>>2]|0)+28>>2]&511](c,e,j);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=f[d+16>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;oYc(a,k)|0;f[a+12>>2]=p;f[a+16>>2]=j+4;if((b[k+11>>0]|0)>=0){u=i;return}cYc(f[k>>2]|0);u=i;return}function S9(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=f[c+12>>2]|0;if(!(D5(g)|0)){h=$Xc(48)|0;f[e>>2]=h;f[e+8>>2]=-2147483600;f[e+4>>2]=36;i=h;j=250364;k=i+36|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+36>>0]=0;vM(-215,e,250401,249976,56)}e=a+4|0;if(!(E5(g)|0)){a=f[e>>2]|0;_i[f[(f[a>>2]|0)+56>>2]&2047](a)|0}a=f[e>>2]|0;h=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;a=f[e>>2]|0;j=_i[f[(f[a>>2]|0)+44>>2]&2047](a)|0;if(h>>>0>(j+(f[c+16>>2]|0)|0)>>>0?!(F5(g)|0):0){b[h>>0]=32;l=h+1|0}else l=h;h=b5(g)|0;b[l>>0]=h?125:93;h=f[e>>2]|0;mi[f[(f[h>>2]|0)+52>>2]&2047](h,l+1|0);u=d;return}function T9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+128|0;e=f[(f[a>>2]|0)+28>>2]|0;g=Y3(c,d,10)|0;Ti[e&511](a,b,g);u=d;return}function U9(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+128|0;e=f[(f[a>>2]|0)+28>>2]|0;g=Z3(d,c,1)|0;Ti[e&511](a,b,g);u=d;return}function V9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16416|0;h=g+16|0;i=g;if(!d){j=$Xc(32)|0;f[i>>2]=j;f[i+8>>2]=-2147483616;f[i+4>>2]=19;k=j;l=250307;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+19>>0]=0;vM(-27,i,250327,249976,100)}j=dJc(d)|0;if((j|0)>4096){n=$Xc(32)|0;f[i>>2]=n;f[i+8>>2]=-2147483616;f[i+4>>2]=30;k=n;l=250333;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[n+30>>0]=0;vM(-5,i,250327,249976,104)}a:do if(!((j|0)==0|e)?(i=b[d>>0]|0,i<<24>>24==(b[d+(j+-1)>>0]|0)):0){switch(i<<24>>24){case 39:case 34:{o=d;break}default:break a}p=f[a>>2]|0;q=p+28|0;r=f[q>>2]|0;Ti[r&511](a,c,o);u=g;return}while(0);e=h+1|0;b[h>>0]=34;b:do if((j|0)>0){i=0;n=e;while(1){l=b[d+i>>0]|0;switch(l<<24>>24|0){case 39:case 34:case 92:{b[n>>0]=92;b[n+1>>0]=l;s=n+2|0;break}case 10:{b[n>>0]=92;b[n+1>>0]=110;s=n+2|0;break}case 13:{b[n>>0]=92;b[n+1>>0]=114;s=n+2|0;break}case 9:{b[n>>0]=92;b[n+1>>0]=116;s=n+2|0;break}case 8:{b[n>>0]=92;b[n+1>>0]=98;s=n+2|0;break}case 12:{b[n>>0]=92;b[n+1>>0]=102;s=n+2|0;break}default:{b[n>>0]=l;s=n+1|0}}i=i+1|0;if((i|0)==(j|0)){t=s;break b}else n=s}}else t=e;while(0);b[t>>0]=34;b[t+1>>0]=0;o=h;p=f[a>>2]|0;q=p+28|0;r=f[q>>2]|0;Ti[r&511](a,c,o);u=g;return}function W9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e;if((c|0)!=0?(b[c>>0]|0)!=0:0){h=dJc(c)|0;if(!h){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=19;j=i;k=250054;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+19>>0]=0;vM(-5,g,250074,249976,146)}if((h|0)>4096){i=$Xc(32)|0;f[g>>2]=i;f[g+8>>2]=-2147483616;f[g+4>>2]=19;j=i;k=250086;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+19>>0]=0;vM(-5,g,250074,249976,148)}else{m=c;n=h;o=1}}else{m=0;n=0;o=0}h=(d|0)!=0;if(h)p=dJc(d)|0;else p=0;c=a+4|0;a=f[c>>2]|0;i=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;a=i+12|0;q=f[a>>2]|0;if(D5(q)|0)if(o^(b5(q)|0)){r=$Xc(96)|0;f[g>>2]=r;f[g+8>>2]=-2147483552;f[g+4>>2]=85;j=r;k=250106;l=j+85|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[r+85>>0]=0;vM(-5,g,250074,249976,161)}else s=q;else{q=f[c>>2]|0;Yi[f[(f[q>>2]|0)+60>>2]&4095](q);s=o?21:20}do if(E5(s)|0){q=f[c>>2]|0;r=_i[f[(f[q>>2]|0)+40>>2]&2047](q)|0;if(F5(s)|0)t=r;else{b[r>>0]=44;t=r+1|0}r=f[c>>2]|0;q=p+n+t-(_i[f[(f[r>>2]|0)+44>>2]&2047](r)|0)|0;r=f[c>>2]|0;if((q|0)>(_i[f[(f[r>>2]|0)+64>>2]&2047](r)|0)?(q-(f[i+16>>2]|0)|0)>10:0){q=f[c>>2]|0;mi[f[(f[q>>2]|0)+52>>2]&2047](q,t);q=f[c>>2]|0;v=_i[f[(f[q>>2]|0)+56>>2]&2047](q)|0;break}b[t>>0]=32;v=t+1|0}else{if(!(F5(s)|0)){q=f[c>>2]|0;r=_i[f[(f[q>>2]|0)+40>>2]&2047](q)|0;b[r>>0]=44;b[r+1>>0]=10;b[r+2>>0]=0;r=f[c>>2]|0;q=f[r>>2]|0;w=f[q+12>>2]|0;x=_i[f[q+44>>2]&2047](r)|0;mi[w&2047](r,x);x=f[c>>2]|0;r=f[x>>2]|0;w=f[r+52>>2]|0;q=_i[f[r+44>>2]&2047](x)|0;mi[w&2047](x,q)}q=f[c>>2]|0;v=_i[f[(f[q>>2]|0)+56>>2]&2047](q)|0}while(0);if(o){o=b[m>>0]|0;if(!(((o&-33)+-65&255)<26|o<<24>>24==95)){o=$Xc(48)|0;f[g>>2]=o;f[g+8>>2]=-2147483600;f[g+4>>2]=33;j=o;k=250192;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[o+33>>0]=0;vM(-5,g,250074,249976,202)}o=f[c>>2]|0;s=hj[f[(f[o>>2]|0)+36>>2]&511](o,v,n)|0;o=s+1|0;b[s>>0]=34;a:do if(n|0){s=0;b:while(1){t=b[m+s>>0]|0;b[o+s>>0]=t;if(!((t+-48&255)<10|((t&-33)+-65&255)<26))switch(t<<24>>24){case 32:case 45:case 95:break;default:break b}s=s+1|0;if(s>>>0>=n>>>0)break a}s=$Xc(96)|0;f[g>>2]=s;f[g+8>>2]=-2147483552;f[g+4>>2]=80;j=s;k=250226;l=j+80|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[s+80>>0]=0;vM(-5,g,250074,249976,213)}while(0);g=o+n|0;n=g+1|0;b[g>>0]=34;g=n+1|0;b[n>>0]=58;b[g>>0]=32;y=g+1|0}else y=v;if(!h){z=y;A=f[c>>2]|0;B=f[A>>2]|0;C=B+52|0;D=f[C>>2]|0;mi[D&2047](A,z);E=f[a>>2]|0;F=E&-17;f[a>>2]=F;u=e;return}h=f[c>>2]|0;v=hj[f[(f[h>>2]|0)+36>>2]&511](h,y,p)|0;o1c(v|0,d|0,p|0)|0;z=v+p|0;A=f[c>>2]|0;B=f[A>>2]|0;C=B+52|0;D=f[C>>2]|0;mi[D&2047](A,z);E=f[a>>2]|0;F=E&-17;f[a>>2]=F;u=e;return}function X9(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;if(!c){h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;i=h;j=249950;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+12>>0]=0;vM(-27,g,249963,249976,236)}g=dJc(c)|0;h=a+4|0;a=f[h>>2]|0;j=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;a=OJc(c,10)|0;if(((a|0)==0&d?(d=f[h>>2]|0,((_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0)-j|0)>=(g|0)):0)?(g=f[h>>2]|0,(j|0)!=(_i[f[(f[g>>2]|0)+44>>2]&2047](g)|0)):0){b[j>>0]=32;l=0;m=j+1|0;n=c}else{j=f[h>>2]|0;l=a;m=_i[f[(f[j>>2]|0)+56>>2]&2047](j)|0;n=c}while(1){b[m>>0]=47;b[m+1>>0]=47;c=m+3|0;b[m+2>>0]=32;if(!l){j=dJc(n)|0;a=f[h>>2]|0;g=hj[f[(f[a>>2]|0)+36>>2]&511](a,c,j)|0;o1c(g|0,n|0,j|0)|0;a=f[h>>2]|0;mi[f[(f[a>>2]|0)+52>>2]&2047](a,g+j|0);o=0;p=0}else{j=f[h>>2]|0;g=l-n|0;a=g+1|0;d=hj[f[(f[j>>2]|0)+36>>2]&511](j,c,a)|0;o1c(d|0,n|0,a|0)|0;a=f[h>>2]|0;mi[f[(f[a>>2]|0)+52>>2]&2047](a,d+g|0);g=l+1|0;o=g;p=OJc(g,10)|0}g=f[h>>2]|0;m=_i[f[(f[g>>2]|0)+56>>2]&2047](g)|0;if(!o)break;else{l=p;n=o}}u=e;return}function Y9(a){a=a|0;var b=0;b=a+4|0;a=f[b>>2]|0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,249940);a=f[b>>2]|0;mi[f[(f[a>>2]|0)+12>>2]&2047](a,249945);return}function Z9(a){a=a|0;NXc(a);return}function _9(a){a=a|0;NXc(a);cYc(a);return}function $9(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function aaa(a){a=a|0;cYc(a);return}function baa(a,b){a=a|0;b=b|0;var c=0,d=0;c=$Xc(5140)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=49116;d=c+12|0;f[d>>2]=49144;f[c+16>>2]=b;f[a>>2]=d;f[a+4>>2]=c;return}function caa(a){a=a|0;cYc(a);return}function daa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=faa(a,c)|0;if(!i){j=0;u=d;return j|0}if(!(b[i>>0]|0)){j=0;u=d;return j|0}c=a+4|0;k=f[c>>2]|0;u5(e,_i[f[(f[k>>2]|0)+8>>2]&2047](k)|0,0,0);switch(b[i>>0]|0){case 123:{k=f[c>>2]|0;l=f[(f[k>>2]|0)+76>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Ii[l&127](g,k,e,h,5,0,-1);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);gaa(a,i,g)|0;break}case 91:{k=f[c>>2]|0;l=f[(f[k>>2]|0)+76>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Ii[l&127](g,k,e,h,4,0,-1);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);haa(a,i,g)|0;break}default:{a=f[c>>2]|0;h=f[(f[a>>2]|0)+92>>2]|0;e=$Xc(48)|0;f[g>>2]=e;f[g+8>>2]=-2147483600;f[g+4>>2]=34;m=e;n=250667;o=m+34|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[e+34>>0]=0;gi[h&255](a,477096,g,249976,838);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}}if(!(b[i>>0]|0)){i=f[c>>2]|0;c=f[(f[i>>2]|0)+92>>2]|0;a=$Xc(32)|0;f[g>>2]=a;f[g+8>>2]=-2147483616;f[g+4>>2]=22;m=a;n=250702;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[a+22>>0]=0;gi[c&255](i,477096,g,249976,842);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}j=1;u=d;return j|0}function eaa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;g=u;u=u+16|0;e=g;d=f[a+4>>2]|0;a=f[(f[d>>2]|0)+92>>2]|0;c=$Xc(64)|0;f[e>>2]=c;f[e+8>>2]=-2147483584;f[e+4>>2]=51;h=c;i=250602;j=h+51|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[c+51>>0]=0;gi[a&255](d,250654,e,249976,427);if((b[e+11>>0]|0)>=0){u=g;return 0}cYc(f[e>>2]|0);u=g;return 0}function faa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=a+4|0;a=e+8|0;h=e+4|0;i=e+11|0;j=e+8|0;k=e+4|0;l=e+11|0;m=c;a:while(1){n=b[m>>0]|0;switch(n<<24>>24|0){case 47:{c=m+1|0;o=b[c>>0]|0;if(!(o<<24>>24)){p=f[g>>2]|0;q=_i[f[(f[p>>2]|0)+16>>2]&2047](p)|0;if(!q){r=31;break a}p=b[q>>0]|0;if(!(p<<24>>24)){r=31;break a}else{s=q;t=p}}else{s=c;t=o}switch(t<<24>>24){case 47:{o=s;c=47;b:while(1){switch(c<<24>>24){case 13:case 10:{m=o;continue a;break}case 0:break;default:{p=o+1|0;o=p;c=b[p>>0]|0;continue b}}p=f[g>>2]|0;o=_i[f[(f[p>>2]|0)+16>>2]&2047](p)|0;if(!o){r=31;break a}c=b[o>>0]|0;if(!(c<<24>>24)){r=31;break a}}break}case 42:{c=s+1|0;while(1){o=b[c>>0]|0;if(!(o<<24>>24)){p=f[g>>2]|0;q=_i[f[(f[p>>2]|0)+16>>2]&2047](p)|0;if(!q){r=31;break a}if(!(b[q>>0]|0)){r=31;break a}else{c=q;continue}}q=c+1|0;if(o<<24>>24!=42){c=q;continue}o=b[q>>0]|0;if(!(o<<24>>24)){p=f[g>>2]|0;v=_i[f[(f[p>>2]|0)+16>>2]&2047](p)|0;if(!v){r=31;break a}p=b[v>>0]|0;if(!(p<<24>>24)){r=31;break a}else{w=v;x=p}}else{w=q;x=o}if(x<<24>>24==47)break;else c=w}m=w+1|0;continue a;break}default:{c=f[g>>2]|0;o=f[(f[c>>2]|0)+92>>2]|0;q=$Xc(32)|0;f[e>>2]=q;f[j>>2]=-2147483616;f[k>>2]=30;y=q;z=251352;A=y+30|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[q+30>>0]=0;gi[o&255](c,251383,e,249976,357);if((b[l>>0]|0)<0)cYc(f[e>>2]|0);m=s;continue a}}break}case 32:case 9:{m=m+1|0;continue a;break}case 13:case 10:case 0:{p=f[g>>2]|0;v=_i[f[(f[p>>2]|0)+16>>2]&2047](p)|0;if(!v){r=31;break a}if(!(b[v>>0]|0)){r=31;break a}else{m=v;continue a}break}default:break a}}if((r|0)==31){r=f[g>>2]|0;s=_i[f[(f[r>>2]|0)+44>>2]&2047](r)|0;b[s>>0]=0;r=f[g>>2]|0;Yi[f[(f[r>>2]|0)+24>>2]&4095](r);r=f[g>>2]|0;l=f[(f[r>>2]|0)+92>>2]|0;k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=19;y=k;z=251426;A=y+19|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[k+19>>0]=0;gi[l&255](r,251383,e,249976,387);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);B=s;u=d;return B|0}if((n&255)>31){B=m;u=d;return B|0}n=f[g>>2]|0;g=f[(f[n>>2]|0)+92>>2]|0;s=$Xc(32)|0;f[e>>2]=s;f[a>>2]=-2147483616;f[h>>2]=31;y=s;z=251394;A=y+31|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[s+31>>0]=0;gi[g&255](n,251383,e,249976,375);if((b[i>>0]|0)<0)cYc(f[e>>2]|0);B=m;u=d;return B|0}function gaa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+16|0;g=e;if(!c){h=f[a+4>>2]|0;i=f[(f[h>>2]|0)+92>>2]|0;j=$Xc(16)|0;f[g>>2]=j;f[g+8>>2]=-2147483632;f[g+4>>2]=11;k=j;l=250725;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+11>>0]=0;gi[i&255](h,251170,g,249976,761);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}if((b[c>>0]|0)==123){n=c+1|0;o=a+4|0}else{h=a+4|0;i=f[h>>2]|0;j=f[(f[i>>2]|0)+92>>2]|0;p=$Xc(48)|0;f[g>>2]=p;f[g+8>>2]=-2147483600;f[g+4>>2]=34;k=p;l=251179;m=k+34|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[p+34>>0]=0;gi[j&255](i,251170,g,249976,764);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);n=c;o=h}h=f[o>>2]|0;Ti[f[(f[h>>2]|0)+72>>2]&511](h,5,d);h=faa(a,n)|0;a:do if(h){n=g+8|0;c=g+4|0;i=g+11|0;j=h;b:while(1){switch(b[j>>0]|0){case 0:{q=j;break a;break}case 34:{t5(g);p=jaa(a,j,d,g)|0;if(!p){r=28;break b}if(!(b[p>>0]|0)){s=p;r=29;break b}t=faa(a,p)|0;if(!t){r=28;break b}switch(b[t>>0]|0){case 0:{s=t;r=29;break b;break}case 91:{v=haa(a,t,g)|0;break}case 123:{v=gaa(a,t,g)|0;break}default:v=iaa(a,t,g)|0}w=v;break}default:w=j}t=faa(a,w)|0;if(!t){r=30;break a}switch(b[t>>0]|0){case 125:case 0:{q=t;break a;break}case 44:{x=t+1|0;break}default:{p=f[o>>2]|0;y=f[(f[p>>2]|0)+92>>2]|0;z=$Xc(32)|0;f[g>>2]=z;f[n>>2]=-2147483616;f[c>>2]=20;k=z;l=250781;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[z+20>>0]=0;gi[y&255](p,251170,g,249976,803);if((b[i>>0]|0)<0)cYc(f[g>>2]|0);x=t}}j=faa(a,x)|0;if(!j){r=30;break a}}if((r|0)==28){r=30;break}else if((r|0)==29){q=s;break}}else r=30;while(0);if((r|0)==30){r=f[o>>2]|0;s=f[(f[r>>2]|0)+92>>2]|0;x=$Xc(16)|0;f[g>>2]=x;f[g+8>>2]=-2147483632;f[g+4>>2]=11;k=x;l=250725;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[x+11>>0]=0;gi[s&255](r,251170,g,249976,807);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);q=0}if((b[q>>0]|0)==125){A=q+1|0;B=f[o>>2]|0;C=f[B>>2]|0;D=C+80|0;E=f[D>>2]|0;mi[E&2047](B,d);u=e;return A|0}r=f[o>>2]|0;s=f[(f[r>>2]|0)+92>>2]|0;x=$Xc(48)|0;f[g>>2]=x;f[g+8>>2]=-2147483600;f[g+4>>2]=35;k=x;l=251214;m=k+35|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[x+35>>0]=0;gi[s&255](r,251170,g,249976,810);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);A=q;B=f[o>>2]|0;C=f[B>>2]|0;D=C+80|0;E=f[D>>2]|0;mi[E&2047](B,d);u=e;return A|0}function haa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+32|0;g=e+12|0;h=e;if(!c){i=f[a+4>>2]|0;j=f[(f[i>>2]|0)+92>>2]|0;k=$Xc(16)|0;f[g>>2]=k;f[g+8>>2]=-2147483632;f[g+4>>2]=11;l=k;m=250725;n=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+11>>0]=0;gi[j&255](i,250737,g,249976,707);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}if((b[c>>0]|0)==91){o=c+1|0;p=a+4|0}else{i=a+4|0;j=f[i>>2]|0;k=f[(f[j>>2]|0)+92>>2]|0;q=$Xc(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=34;l=q;m=250746;n=l+34|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[q+34>>0]=0;gi[k&255](j,250737,g,249976,710);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);o=c;p=i}i=f[p>>2]|0;Ti[f[(f[i>>2]|0)+72>>2]&511](i,4,d);i=faa(a,o)|0;a:do if(!i)r=27;else{o=h+11|0;c=g+8|0;j=g+4|0;k=g+11|0;q=i;b:while(1){switch(b[q>>0]|0){case 0:{s=q;break b;break}case 93:{t=q;break}default:{v=f[p>>2]|0;w=f[(f[v>>2]|0)+76>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Ii[w&127](g,v,d,h,0,0,-1);if((b[o>>0]|0)<0)cYc(f[h>>2]|0);switch(b[q>>0]|0){case 91:{x=haa(a,q,g)|0;break}case 123:{x=gaa(a,q,g)|0;break}default:x=iaa(a,q,g)|0}t=x}}v=faa(a,t)|0;if(!v){r=27;break a}switch(b[v>>0]|0){case 93:{y=v;break a;break}case 0:{s=v;break b;break}case 44:{z=v+1|0;break}default:{w=f[p>>2]|0;A=f[(f[w>>2]|0)+92>>2]|0;B=$Xc(32)|0;f[g>>2]=B;f[c>>2]=-2147483616;f[j>>2]=20;l=B;m=250781;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[B+20>>0]=0;gi[A&255](w,250737,g,249976,743);if((b[k>>0]|0)<0)cYc(f[g>>2]|0);z=v}}q=faa(a,z)|0;if(!q){r=27;break a}}q=f[p>>2]|0;k=f[(f[q>>2]|0)+92>>2]|0;j=$Xc(48)|0;f[g>>2]=j;f[g+8>>2]=-2147483600;f[g+4>>2]=35;l=j;m=250802;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+35>>0]=0;gi[k&255](q,250737,g,249976,750);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);C=s;D=f[p>>2]|0;E=f[D>>2]|0;F=E+80|0;G=f[F>>2]|0;mi[G&2047](D,d);u=e;return C|0}while(0);if((r|0)==27){r=f[p>>2]|0;s=f[(f[r>>2]|0)+92>>2]|0;z=$Xc(16)|0;f[g>>2]=z;f[g+8>>2]=-2147483632;f[g+4>>2]=11;l=z;m=250725;n=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[z+11>>0]=0;gi[s&255](r,250737,g,249976,747);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);y=0}C=y+1|0;D=f[p>>2]|0;E=f[D>>2]|0;F=E+80|0;G=f[F>>2]|0;mi[G&2047](D,d);u=e;return C|0}function iaa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0;e=u;u=u+32|0;g=e+24|0;h=e;i=e+12|0;j=faa(a,c)|0;f[g>>2]=j;if((j|0)!=0?(c=b[j>>0]|0,c<<24>>24!=0):0){k=c;l=j}else{j=f[a+4>>2]|0;c=f[(f[j>>2]|0)+92>>2]|0;m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=22;n=m;o=250702;q=n+22|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[m+22>>0]=0;gi[c&255](j,250838,h,249976,435);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);j=f[g>>2]|0;k=b[j>>0]|0;l=j}if(k<<24>>24==34){j=l+1|0;c=0;m=j;while(1){f[g>>2]=m;r=b[m>>0]|0;if((r+-48&255)<10|((r&-33)+-65&255)<26){if(c>>>0>=10){s=13;break}}else if(!(c>>>0<10&r<<24>>24==36)){s=12;break}c=c+1|0;m=m+1|0}if((s|0)==12?c>>>0>7:0)s=13;if((s|0)==13?(WKc(j,250849,8)|0)==0:0){c=f[a+4>>2]|0;m=f[(f[c>>2]|0)+92>>2]|0;r=$Xc(32)|0;f[h>>2]=r;f[h+8>>2]=-2147483616;f[h+4>>2]=28;n=r;o=250858;q=n+28|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[r+28>>0]=0;gi[m&255](c,250838,h,249976,447);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);t=f[g>>2]|0;u=e;return t|0}f[g>>2]=j;c=a+4|0;m=h+8|0;r=h+4|0;v=h+11|0;w=h+8|0;x=h+4|0;y=h+11|0;z=h+8|0;A=h+4|0;B=h+11|0;C=h+8|0;D=h+4|0;E=h+11|0;F=0;G=j;a:while(1){j=G;b:while(1){H=j;c:while(1){switch(b[H>>0]|0){case 34:{break a;break}case 92:{break b;break}case 0:{s=37;break b;break}case 13:case 10:break;default:break c}I=f[c>>2]|0;J=f[(f[I>>2]|0)+92>>2]|0;K=$Xc(48)|0;f[h>>2]=K;f[m>>2]=-2147483600;f[r>>2]=38;n=K;o=250945;q=n+38|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[K+38>>0]=0;gi[J&255](I,250838,h,249976,624);if((b[v>>0]|0)<0)cYc(f[h>>2]|0);H=f[g>>2]|0}L=H+1|0;f[g>>2]=L;j=L}if((s|0)==37){s=0;j=H-G|0;if((j|0)>0){o1c(a+8+F|0,G|0,j|0)|0;M=j+F|0}else M=F;j=f[c>>2]|0;L=_i[f[(f[j>>2]|0)+16>>2]&2047](j)|0;f[g>>2]=L;if(L|0?b[L>>0]|0:0){F=M;G=L;continue}L=f[c>>2]|0;j=f[(f[L>>2]|0)+92>>2]|0;N=$Xc(48)|0;f[h>>2]=N;f[C>>2]=-2147483600;f[D>>2]=38;n=N;o=250945;q=n+38|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[N+38>>0]=0;gi[j&255](L,250838,h,249976,604);if((b[E>>0]|0)<0)cYc(f[h>>2]|0);F=M;G=f[g>>2]|0;continue}O=H-G|0;if((O|0)>0){o1c(a+8+F|0,G|0,O|0)|0;P=O+F|0}else P=F;O=H+1|0;f[g>>2]=O;Q=b[O>>0]|0;switch(Q<<24>>24|0){case 39:case 34:case 92:{b[a+8+P>>0]=Q;R=P+1|0;break}case 110:{b[a+8+P>>0]=10;R=P+1|0;break}case 114:{b[a+8+P>>0]=13;R=P+1|0;break}case 116:{b[a+8+P>>0]=9;R=P+1|0;break}case 98:{b[a+8+P>>0]=8;R=P+1|0;break}case 102:{b[a+8+P>>0]=12;R=P+1|0;break}case 117:{Q=f[c>>2]|0;O=f[(f[Q>>2]|0)+92>>2]|0;S=$Xc(48)|0;f[h>>2]=S;f[z>>2]=-2147483600;f[A>>2]=32;n=S;o=250887;q=n+32|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[S+32>>0]=0;gi[O&255](Q,250838,h,249976,586);if((b[B>>0]|0)<0)cYc(f[h>>2]|0);R=P;break}default:{L=f[c>>2]|0;j=f[(f[L>>2]|0)+92>>2]|0;N=$Xc(32)|0;f[h>>2]=N;f[w>>2]=-2147483616;f[x>>2]=24;n=N;o=250920;q=n+24|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[N+24>>0]=0;gi[j&255](L,250838,h,249976,587);if((b[y>>0]|0)<0)cYc(f[h>>2]|0);R=P}}Q=(f[g>>2]|0)+1|0;f[g>>2]=Q;F=R;G=Q}R=H-G|0;if((R|0)>0){o1c(a+8+F|0,G|0,R|0)|0;T=R+F|0}else T=F;if((b[H>>0]|0)!=34){F=f[c>>2]|0;c=f[(f[F>>2]|0)+92>>2]|0;R=$Xc(48)|0;f[h>>2]=R;f[h+8>>2]=-2147483600;f[h+4>>2]=38;n=R;o=250945;q=n+38|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[R+38>>0]=0;gi[c&255](F,250838,h,249976,636);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}else f[g>>2]=H+1;F4(d,3,a+8|0,T);t=f[g>>2]|0;u=e;return t|0}d:do if((k+-48&255)<10)switch(k<<24>>24){case 45:case 43:{s=63;break}default:{}}else{switch(k<<24>>24){case 45:case 43:{s=63;break d;break}case 46:{break d;break}default:{}}e:do if(((k&-33)+-65&255)<26){T=a+4|0;H=h+8|0;F=h+4|0;c=h+11|0;R=0;G=l;while(1){P=R+1|0;y=G+1|0;f[g>>2]=y;if((b[y>>0]|0)==0?(x=f[T>>2]|0,(y|0)==((_i[f[(f[x>>2]|0)+48>>2]&2047](x)|0)+-1|0)):0){x=f[T>>2]|0;y=f[(f[x>>2]|0)+92>>2]|0;w=$Xc(64)|0;f[h>>2]=w;f[H>>2]=-2147483584;f[F>>2]=50;n=w;o=250984;q=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[w+50>>0]=0;gi[y&255](x,250838,h,249976,682);if((b[c>>0]|0)<0)cYc(f[h>>2]|0)}G=f[g>>2]|0;if(!((P|0)<7?((b[G>>0]&-33)+-65&255)<26:0))break;else R=P}f:do switch(R|0){case 3:{if(WKc(l,251101,4)|0)if(!(WKc(l,529255,4)|0))break f;else break e;G=f[a+4>>2]|0;c=f[(f[G>>2]|0)+92>>2]|0;F=$Xc(48)|0;f[h>>2]=F;f[h+8>>2]=-2147483600;f[h+4>>2]=44;n=F;o=251106;q=n+44|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[F+44>>0]=0;gi[c&255](G,250838,h,249976,687);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);t=f[g>>2]|0;u=e;return t|0}case 4:{if(WKc(l,529249,5)|0)break e;break}default:break e}while(0);f[h>>2]=(b[l>>0]|0)==116&1;F4(d,1,h,-1);t=f[g>>2]|0;u=e;return t|0}while(0);L=f[a+4>>2]|0;j=f[(f[L>>2]|0)+92>>2]|0;N=$Xc(32)|0;f[h>>2]=N;f[h+8>>2]=-2147483616;f[h+4>>2]=18;n=N;o=251151;q=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[N+18>>0]=0;gi[j&255](L,250838,h,249976,697);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);t=f[g>>2]|0;u=e;return t|0}while(0);if(((s|0)==63?(s=l+1|0,f[g>>2]=s,(b[s>>0]|0)==0):0)?(k=a+4|0,R=f[k>>2]|0,(s|0)==((_i[f[(f[R>>2]|0)+48>>2]&2047](R)|0)+-1|0)):0){R=f[k>>2]|0;k=f[(f[R>>2]|0)+92>>2]|0;s=$Xc(64)|0;f[h>>2]=s;f[h+8>>2]=-2147483584;f[h+4>>2]=50;n=s;o=250984;q=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[s+50>>0]=0;gi[k&255](R,250838,h,249976,649);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}R=f[g>>2]|0;k=b[R>>0]|0;if((k+-48&255)<10){s=a+4|0;P=h+8|0;x=h+4|0;y=h+11|0;w=R;do{R=w+1|0;f[g>>2]=R;if((b[R>>0]|0)==0?(H=f[s>>2]|0,(R|0)==((_i[f[(f[H>>2]|0)+48>>2]&2047](H)|0)+-1|0)):0){H=f[s>>2]|0;R=f[(f[H>>2]|0)+92>>2]|0;T=$Xc(64)|0;f[h>>2]=T;f[P>>2]=-2147483584;f[x>>2]=50;n=T;o=250984;q=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[T+50>>0]=0;gi[R&255](H,250838,h,249976,654);if((b[y>>0]|0)<0)cYc(f[h>>2]|0)}w=f[g>>2]|0;L=b[w>>0]|0}while((L+-48&255)<10);U=L}else U=k;switch(U<<24>>24){case 101:case 46:{U=a+4|0;k=f[U>>2]|0;V=+Sh[f[(f[k>>2]|0)+84>>2]&31](k,l,g);p[h>>3]=V;k=f[g>>2]|0;if((b[k>>0]|0)==0?(w=f[U>>2]|0,(k|0)==((_i[f[(f[w>>2]|0)+48>>2]&2047](w)|0)+-1|0)):0){w=f[U>>2]|0;U=f[(f[w>>2]|0)+92>>2]|0;k=$Xc(64)|0;f[i>>2]=k;f[i+8>>2]=-2147483584;f[i+4>>2]=50;n=k;o=250984;q=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[k+50>>0]=0;gi[U&255](w,250838,i,249976,659);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}F4(d,2,h,-1);break}default:{w=aJc(l,g,0)|0;f[h>>2]=w;w=f[g>>2]|0;if((b[w>>0]|0)==0?(U=a+4|0,k=f[U>>2]|0,(w|0)==((_i[f[(f[k>>2]|0)+48>>2]&2047](k)|0)+-1|0)):0){k=f[U>>2]|0;U=f[(f[k>>2]|0)+92>>2]|0;w=$Xc(64)|0;f[i>>2]=w;f[i+8>>2]=-2147483584;f[i+4>>2]=50;n=w;o=250984;q=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[w+50>>0]=0;gi[U&255](k,250838,i,249976,666);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0)}F4(d,1,h,-1)}}if(l>>>0<(f[g>>2]|0)>>>0){t=f[g>>2]|0;u=e;return t|0}l=f[a+4>>2]|0;a=f[(f[l>>2]|0)+92>>2]|0;d=$Xc(80)|0;f[h>>2]=d;f[h+8>>2]=-2147483568;f[h+4>>2]=65;n=d;o=251035;q=n+65|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[d+65>>0]=0;gi[a&255](l,250838,h,249976,672);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);t=f[g>>2]|0;u=e;return t|0}function jaa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+32|0;h=g+12|0;i=g;j=a+4|0;if((b[c>>0]|0)!=34){k=f[j>>2]|0;l=f[(f[k>>2]|0)+92>>2]|0;m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=23;n=m;o=251250;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+23>>0]=0;gi[l&255](k,251274,h,249976,396);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}k=c+1|0;l=h+8|0;m=h+4|0;q=h+11|0;r=c;while(1){s=r+1|0;t=b[s>>0]|0;if(!(t<<24>>24)){v=f[j>>2]|0;if((s|0)==((_i[f[(f[v>>2]|0)+48>>2]&2047](v)|0)+-1|0)){v=f[j>>2]|0;w=f[(f[v>>2]|0)+92>>2]|0;x=$Xc(64)|0;f[h>>2]=x;f[l>>2]=-2147483584;f[m>>2]=50;n=x;o=250984;p=n+50|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[x+50>>0]=0;gi[w&255](v,251274,h,249976,402);if((b[q>>0]|0)<0)cYc(f[h>>2]|0)}y=b[s>>0]|0}else y=t;z=y<<24>>24!=34;if((y&255)<32|z^1)break;else r=s}if(z){z=f[j>>2]|0;y=f[(f[z>>2]|0)+92>>2]|0;q=$Xc(32)|0;f[h>>2]=q;f[h+8>>2]=-2147483616;f[h+4>>2]=21;n=q;o=251283;p=n+21|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+21>>0]=0;gi[y&255](z,251274,h,249976,406);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}z=faa(a,r+2|0)|0;if(!z){A=0;u=g;return A|0}switch(b[z>>0]|0){case 58:break;case 0:{A=0;u=g;return A|0}default:B=19}if((B|0)==19){a=f[j>>2]|0;y=f[(f[a>>2]|0)+92>>2]|0;q=$Xc(48)|0;f[h>>2]=q;f[h+8>>2]=-2147483600;f[h+4>>2]=33;n=q;o=251305;p=n+33|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+33>>0]=0;gi[y&255](a,251274,h,249976,415);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}if(r>>>0<=c>>>0){c=f[j>>2]|0;r=f[(f[c>>2]|0)+92>>2]|0;a=$Xc(16)|0;f[h>>2]=a;f[h+8>>2]=-2147483632;f[h+4>>2]=12;n=a;o=251339;p=n+12|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[a+12>>0]=0;gi[r&255](c,251274,h,249976,419);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0)}c=f[j>>2]|0;j=f[(f[c>>2]|0)+76>>2]|0;r=s-k|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(r>>>0>4294967279)jYc(i);if(r>>>0<11){b[i+11>>0]=r;if(!r)C=i;else{D=i;B=31}}else{s=r+16&-16;a=$Xc(s)|0;f[i>>2]=a;f[i+8>>2]=s|-2147483648;f[i+4>>2]=r;D=a;B=31}if((B|0)==31){o1c(D|0,k|0,r|0)|0;C=D}b[C+r>>0]=0;Ii[j&127](h,c,d,i,0,0,-1);f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];f[e+8>>2]=f[h+8>>2];if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);A=z+1|0;u=g;return A|0}function kaa(a){a=a|0;NXc(a);return}function laa(a){a=a|0;NXc(a);cYc(a);return}function maa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function naa(a){a=a|0;cYc(a);return}function oaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){g1c(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)kWc(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;g1c(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;cYc(h);return}function paa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)q1c(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;o1c(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);cYc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)kWc(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)kWc(a);j=$Xc(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;o1c(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function qaa(){var a=0;if(((((raa(1,0)|0)!=0?(raa(1,1)|0)!=0:0)?(raa(2,0)|0)!=0:0)?(raa(2,1)|0)!=0:0)?(raa(4,0)|0)!=0:0)a=(raa(4,1)|0)!=0&1;else a=0;b[1161450]=a;return}function raa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;e=u;u=u+1088|0;g=e+1064|0;h=e;switch(a|0){case 1:{i=872416;k=1061856;l=2;break}case 2:{i=544736;k=898016;l=4;break}case 4:{i=610272;k=930784;l=8;break}default:{m=$Xc(48)|0;f[g>>2]=m;f[g+8>>2]=-2147483600;f[g+4>>2]=38;o=m;p=251533;q=o+38|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[m+38>>0]=0;vM(-5,g,251572,251587,226)}}m=1161451+a|0;if(b[m>>0]|0){r=i;s=k;t=c?s:r;u=e;return t|0}v=h+8|0;f[h>>2]=v;w=h+4|0;f[w>>2]=256;switch(a|0){case 1:{a=0;x=v;while(1){y=+(a|0)*.03125;n[x>>2]=1.0-y;n[x+4>>2]=y;a=a+1|0;if((a|0)==32){z=v;break}else x=x+8|0}break}case 2:{x=0;a=v;while(1){y=+(x|0)*.03125;A=y+1.0;B=A*(A*(3.75-A*.75)+-6.0)+3.0;n[a>>2]=B;A=y*(y*(y*1.25+-2.25))+1.0;n[a+4>>2]=A;C=1.0-y;y=C*(C*(C*1.25+-2.25))+1.0;n[a+8>>2]=y;n[a+12>>2]=1.0-B-A-y;x=x+1|0;if((x|0)==32){z=v;break}else a=a+16|0}break}case 4:{a=0;x=v;while(1){y=+(a|0)*.03125;if(y<1.1920928955078125e-07){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;D=1.0}else{A=y+3.0;y=-A*3.141592653589793*.25;B=+P(+y);C=+O(+y);E=C*0.0;F=(B+E)/(y*y);y=-(A+-1.0)*3.141592653589793*.25;G=B*-.7071067811865476;H=C*-.7071067811865476;I=(G+H)/(y*y);y=-(A+-2.0)*3.141592653589793*.25;J=B*0.0;K=(J+C)/(y*y);y=-(A+-3.0)*3.141592653589793*.25;L=B*.7071067811865476;M=(L+H)/(y*y);y=-(A+-4.0)*3.141592653589793*.25;H=(E-B)/(y*y);y=-(A+-5.0)*3.141592653589793*.25;B=C*.7071067811865476;E=(L+B)/(y*y);y=-(A+-6.0)*3.141592653589793*.25;L=(J-C)/(y*y);y=-(A+-7.0)*3.141592653589793*.25;A=(G+B)/(y*y);y=1.0/(A+(L+(E+(H+(M+(K+(I+(F+0.0))))))));n[x>>2]=F*y;n[x+4>>2]=I*y;n[x+8>>2]=K*y;n[x+16>>2]=H*y;n[x+20>>2]=E*y;n[x+24>>2]=L*y;n[x+28>>2]=A*y;D=M*y}n[x+12>>2]=D;a=a+1|0;if((a|0)==32)break;else x=x+32|0}z=f[h>>2]|0;break}default:{x=$Xc(32)|0;f[g>>2]=x;f[g+8>>2]=-2147483616;f[g+4>>2]=28;o=x;p=264588;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[x+28>>0]=0;vM(-5,g,251659,251587,209)}}g=Y(l,l)|0;x=l>>>1;p=g<<5;o=g<<10;q=i+(o<<2)|0;a=Y(x,l)|0;N=x+a|0;Q=x+1|0;R=Q+a|0;S=Y(Q,l)|0;T=x+S|0;U=Q+S|0;S=0;V=i;i=k;while(1){W=S<<5;X=(S|0)<16&1;Z=Y(S,l)|0;_=0;$=V;V=V+(p<<2)|0;aa=i;while(1){ba=_+W|0;b[1161459+(ba<<1)>>0]=(_|0)<16&1;b[1161459+(ba<<1)+1>>0]=X;ba=Y(_,l)|0;ca=0;da=0;while(1){D=+n[z+(da+Z<<2)>>2];ea=Y(da,l)|0;fa=0;ga=ca;do{y=D*+n[z+(fa+ba<<2)>>2];ha=fa+ea|0;n[$+(ha<<2)>>2]=y;ia=ALc(y*32768.0)|0;ja=(ia+32768|0)>>>0<65536?ia:(ia|0)>0?32767:32768;d[aa+(ha<<1)>>1]=ja;ga=(ja<<16>>16)+ga|0;fa=fa+1|0}while((fa|0)<(l|0));da=da+1|0;if((da|0)>=(l|0))break;else ca=ga}if((ga|0)!=32768){ca=d[aa+(N<<1)>>1]|0;da=d[aa+(R<<1)>>1]|0;ba=da<<16>>16<ca<<16>>16;fa=ba?x:da<<16>>16>ca<<16>>16?Q:x;ca=ba?Q:x;ba=d[aa+(T<<1)>>1]|0;if(ba<<16>>16<(d[aa+(a+ca<<1)>>1]|0)){ka=x;la=Q;ma=fa;na=x}else{da=ba<<16>>16>(d[aa+(a+fa<<1)>>1]|0);ka=ca;la=x;ma=da?x:fa;na=da?Q:x}da=d[aa+(U<<1)>>1]|0;fa=aa+((Y(la,l)|0)+ka<<1)|0;if(da<<16>>16<(d[fa>>1]|0)){oa=Q;pa=Q;qa=ma;ra=na}else{fa=aa+((Y(na,l)|0)+ma<<1)|0;ca=da<<16>>16>(d[fa>>1]|0);oa=ka;pa=la;qa=ca?Q:ma;ra=ca?Q:na}if((ga|0)<32768){ca=(Y(ra,l)|0)+qa|0;sa=d[aa+(ca<<1)>>1]|0;ta=ca}else{ca=(Y(pa,l)|0)+oa|0;sa=j[aa+(ca<<1)>>1]|0;ta=ca}d[aa+(ta<<1)>>1]=-32768-ga+sa}_=_+1|0;if((_|0)==32)break;else{$=$+(g<<2)|0;aa=aa+(g<<1)|0}}S=S+1|0;if((S|0)==32)break;else i=i+(p<<1)|0}p=Y(Y(l,-1024)|0,l)|0;l=q+(p<<2)|0;q=k+(o<<1)+(p<<1)|0;b[m>>0]=1;if((z|0)!=(v|0)){if(z|0)dYc(z);f[h>>2]=v;f[w>>2]=264}r=l;s=q;t=c?s:r;u=e;return t|0}function saa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;j=u;u=u+368|0;k=j;l=j+304|0;m=j+240|0;n=j+184|0;o=j+296|0;q=j+128|0;r=j+72|0;if(sS(d)|0){s=$Xc(16)|0;f[k>>2]=s;f[k+8>>2]=-2147483632;f[k+4>>2]=14;t=s;v=251674;w=t+14|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+14>>0]=0;vM(-215,k,251689,251587,1708)}if(!(sS(e)|0)?(cS(k,e,-1),cS(l,d,-1),!((f[k>>2]|0)==(f[l>>2]|0)?(f[k+4>>2]|0)==(f[l+4>>2]|0):0)):0){s=$Xc(48)|0;f[k>>2]=s;f[k+8>>2]=-2147483600;f[k+4>>2]=47;t=s;v=251695;w=t+47|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+47>>0]=0;vM(-215,k,251689,251587,1709)}do if((eS(a)|0)==65536){s=f[a+4>>2]|0;f[l>>2]=f[s>>2];x=l+4|0;y=s+4|0;f[x>>2]=f[y>>2];z=l+8|0;f[z>>2]=f[s+8>>2];f[l+12>>2]=f[s+12>>2];f[l+16>>2]=f[s+16>>2];f[l+20>>2]=f[s+20>>2];f[l+24>>2]=f[s+24>>2];f[l+28>>2]=f[s+28>>2];f[l+32>>2]=f[s+32>>2];A=f[s+36>>2]|0;f[l+36>>2]=A;f[l+40>>2]=z;z=l+48|0;B=l+44|0;f[B>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[s+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(l,s);break}}else bS(l,a,-1);while(0);do if((eS(d)|0)==65536){s=f[d+4>>2]|0;f[m>>2]=f[s>>2];x=m+4|0;y=s+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];f[m+32>>2]=f[s+32>>2];B=f[s+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=z;z=m+48|0;A=m+44|0;f[A>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(B|0){z=B+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[s+44>>2]|0;z=f[A>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(m,s);break}}else bS(m,d,-1);while(0);do if((eS(e)|0)==65536){d=f[e+4>>2]|0;f[n>>2]=f[d>>2];s=n+4|0;x=d+4|0;f[s>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];z=f[d+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;A=n+44|0;f[A>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[d+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[s>>2]=0;U$(n,d);break}}else bS(n,e,-1);while(0);e=m+40|0;d=f[e>>2]|0;s=f[d>>2]|0;f[o>>2]=f[d+4>>2];f[o+4>>2]=s;wS(c,o,f[l>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){o=f[c+4>>2]|0;f[q>>2]=f[o>>2];s=q+4|0;d=o+4|0;f[s>>2]=f[d>>2];x=q+8|0;f[x>>2]=f[o+8>>2];y=q+12|0;f[y>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2];f[q+32>>2]=f[o+32>>2];A=f[o+36>>2]|0;f[q+36>>2]=A;f[q+40>>2]=x;x=q+48|0;z=q+44|0;f[z>>2]=x;f[x>>2]=0;f[q+52>>2]=0;if(A|0){x=A+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[d>>2]|0)<3){d=f[o+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[d>>2];f[x+4>>2]=f[d+4>>2];C=y;break}else{f[s>>2]=0;U$(q,o);C=y;break}}else{bS(q,c,-1);C=q+12|0}while(0);if((f[C>>2]|0)>=32767){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(96)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483552;F=k+4|0;f[F>>2]=88;t=D;v=251743;w=t+88|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));G=D+88|0;b[G>>0]=0;vM(-215,k,251689,251587,1729)}c=q+8|0;if((f[c>>2]|0)>=32767){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(96)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483552;F=k+4|0;f[F>>2]=88;t=D;v=251743;w=t+88|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));G=D+88|0;b[G>>0]=0;vM(-215,k,251689,251587,1729)}y=l+12|0;if((f[y>>2]|0)>=32767){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(96)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483552;F=k+4|0;f[F>>2]=88;t=D;v=251743;w=t+88|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));G=D+88|0;b[G>>0]=0;vM(-215,k,251689,251587,1729)}o=l+8|0;if((f[o>>2]|0)>=32767){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(96)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483552;F=k+4|0;f[F>>2]=88;t=D;v=251743;w=t+88|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));G=D+88|0;b[G>>0]=0;vM(-215,k,251689,251587,1729)}G=q+16|0;D=l+16|0;if((f[G>>2]|0)==(f[D>>2]|0)){f[r>>2]=1124007936;F=r+4|0;E=r+8|0;s=r+40|0;t=F;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[s>>2]=E;d=r+48|0;f[r+44>>2]=d;f[d>>2]=0;f[r+52>>2]=0;x=k+8|0;f[x>>2]=0;f[x+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=r;jR(l,k);x=l+36|0;z=f[x>>2]|0;if(z|0?(A=z+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)V$(l);f[x>>2]=0;z=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[z>>2]|0)>0){A=f[l+40>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}f[l>>2]=f[r>>2];B=f[F>>2]|0;f[z>>2]=B;f[o>>2]=f[E>>2];f[y>>2]=f[r+12>>2];y=r+16|0;f[D>>2]=f[y>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];z=r+36|0;f[x>>2]=f[z>>2];x=l+44|0;A=f[x>>2]|0;H=l+48|0;if((A|0)==(H|0))I=B;else{wL(A);f[x>>2]=H;f[l+40>>2]=o;I=f[F>>2]|0}o=r+44|0;if((I|0)<3){I=f[o>>2]|0;f[H>>2]=f[I>>2];f[l+52>>2]=f[I+4>>2];J=I}else{f[x>>2]=f[o>>2];f[l+40>>2]=f[s>>2];f[o>>2]=d;f[s>>2]=E;J=d}f[r>>2]=1124007936;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;f[F+16>>2]=0;f[F+20>>2]=0;f[F+24>>2]=0;f[F+28>>2]=0;f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((J|0)!=(d|0))wL(J)}J=(g|0)==3?1:g;g=f[l>>2]&7;d=(g|0)==0;switch(J|0){case 0:{y=f[49160+(g<<2)>>2]|0;if((g|0)==7){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;z=$Xc(16)|0;f[k>>2]=z;f[k+8>>2]=-2147483632;f[k+4>>2]=11;t=z;v=251832;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[z+11>>0]=0;vM(-215,k,251689,251587,1789)}else{K=0;L=y;M=0}break}case 1:{N=f[49192+(g<<2)>>2]|0;O=63;break}case 2:{y=f[49224+(g<<2)>>2]|0;if((rS(a,-1)|0)<5){N=y;O=63}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;y=$Xc(32)|0;f[k>>2]=y;f[k+8>>2]=-2147483616;f[k+4>>2]=20;t=y;v=251844;w=t+20|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[y+20>>0]=0;vM(-215,k,251689,251587,1797)}break}case 4:{y=f[49256+(g<<2)>>2]|0;if((rS(a,-1)|0)<5){N=y;O=63}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;y=$Xc(32)|0;f[k>>2]=y;f[k+8>>2]=-2147483616;f[k+4>>2]=20;t=y;v=251844;w=t+20|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[y+20>>0]=0;vM(-215,k,251689,251587,1801)}break}default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;y=$Xc(32)|0;f[k>>2]=y;f[k+8>>2]=-2147483616;f[k+4>>2]=28;t=y;v=264588;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[y+28>>0]=0;vM(-5,k,251689,251587,1804)}}do if((O|0)==63)if(!N){b[k+11>>0]=10;t=k;v=251865;w=t+10|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[k+10>>0]=0;vM(-215,k,251689,251587,1805)}else{K=raa(J,d)|0;L=0;M=N;break}while(0);N=m;d=n;J=f[m>>2]|0;y=J&4095;a=(y|0)==11;g=f[n>>2]|0;if(a)if((g&4094|0)!=2?(f[n+16>>2]|0)!=0:0){z=f[n+4>>2]|0;if((z|0)<3)P=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{F=f[n+40>>2]|0;E=0;s=1;while(1){o=Y(f[F+(E<<2)>>2]|0,s)|0;E=E+1|0;if((E|0)==(z|0)){P=o;break}else s=o}}if(!((z|0)==0|(P|0)==0))O=74;else O=82}else O=82;else O=74;do if((O|0)==74){P=g&4095;if((P|0)==11){if((J&4094|0)==2){O=82;break}if(!(f[m+16>>2]|0)){O=82;break}z=f[m+4>>2]|0;if((z|0)<3)Q=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{s=f[e>>2]|0;E=0;F=1;while(1){o=Y(f[s+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(z|0)){Q=o;break}else F=o}}if((z|0)==0|(Q|0)==0){O=82;break}}switch(J&4095){case 11:case 13:{if(f[n+16>>2]|0){F=f[n+4>>2]|0;if((F|0)<3)R=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{E=f[n+40>>2]|0;s=0;o=1;while(1){x=Y(f[E+(s<<2)>>2]|0,o)|0;s=s+1|0;if((s|0)==(F|0)){R=x;break}else o=x}}if(!((F|0)==0|(R|0)==0))O=90}break}default:O=90}if((O|0)==90?!((y|0)==5&(P|0)==5):0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;o=$Xc(128)|0;f[k>>2]=o;f[k+8>>2]=-2147483520;f[k+4>>2]=126;t=o;v=251876;w=t+126|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[o+126>>0]=0;vM(-215,k,251689,251587,1820)}S=(J&4088|0)==0;T=d;U=N}while(0);if((O|0)==82){S=0;T=a?d:N;U=a?N:d}f[k>>2]=49296;f[k+4>>2]=l;f[k+8>>2]=q;f[k+12>>2]=U;f[k+16>>2]=T;f[k+20>>2]=h;p[k+24>>3]=+p[i>>3];p[k+32>>3]=+p[i+8>>3];p[k+40>>3]=+p[i+16>>3];p[k+48>>3]=+p[i+24>>3];f[k+56>>2]=S&1;f[k+60>>2]=L;f[k+64>>2]=M;f[k+68>>2]=K;K=f[c>>2]|0;f[r>>2]=0;f[r+4>>2]=K;c=q+4|0;M=f[c>>2]|0;if((M|0)<3)V=Y(f[C>>2]|0,K)|0;else{K=f[q+40>>2]|0;C=0;L=1;while(1){S=Y(f[K+(C<<2)>>2]|0,L)|0;C=C+1|0;if((C|0)==(M|0)){V=S;break}else L=S}}h3(r,k,+(V>>>0)*.0000152587890625);V=q+36|0;k=f[V>>2]|0;if(k|0?(r=k+12|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)V$(q);f[V>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[c>>2]|0)>0){G=f[q+40>>2]|0;V=0;do{f[G+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[c>>2]|0))}c=f[q+44>>2]|0;if((c|0)!=(q+48|0))wL(c);c=n+36|0;q=f[c>>2]|0;if(q|0?(V=q+12|0,q=f[V>>2]|0,f[V>>2]=q+-1,(q|0)==1):0)V$(n);f[c>>2]=0;c=n+16|0;q=n+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[n+40>>2]|0;V=0;do{f[c+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[q>>2]|0))}q=f[n+44>>2]|0;if((q|0)!=(n+48|0))wL(q);q=m+36|0;n=f[q>>2]|0;do if(n|0){V=n+12|0;c=f[V>>2]|0;f[V>>2]=c+-1;if((c|0)!=1)break;V$(m)}while(0);f[q>>2]=0;q=m+16|0;n=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[n>>2]|0)>0){q=f[e>>2]|0;e=0;do{f[q+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))wL(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){e=m+12|0;q=f[e>>2]|0;f[e>>2]=q+-1;if((q|0)!=1)break;V$(l)}while(0);f[n>>2]=0;n=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[n>>2]|0)>0){D=f[l+40>>2]|0;m=0;do{f[D+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){u=j;return}wL(n);u=j;return}function taa(a){a=a|0;cYc(a);return}function uaa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0;c=u;u=u+352|0;e=c+296|0;g=c+240|0;i=c+184|0;k=c+128|0;l=c+72|0;m=c+16|0;o=c;p=a+8|0;q=f[p>>2]|0;r=f[q+8>>2]|0;s=a+12|0;t=f[f[s>>2]>>2]&7;v=16384/(((r|0)<128?r:128)|0)|0;w=f[q+12>>2]|0;q=(w|0)<(v|0)?w:v;v=16384/(q|0)|0;w=(r|0)<(v|0)?r:v;f[g>>2]=1124007936;v=g+4|0;r=g+8|0;x=g+40|0;y=v;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=r;r=g+48|0;A=g+44|0;f[A>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=w;B=e+4|0;f[B>>2]=q;S$(g,2,e,11);f[i>>2]=1124007936;C=i+4|0;D=i+8|0;E=i+40|0;y=C;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[E>>2]=D;D=i+48|0;y=i+44|0;f[y>>2]=D;f[D>>2]=0;f[i+52>>2]=0;z=a+60|0;if(!(f[z>>2]|0)){f[e>>2]=w;f[B>>2]=q;S$(i,2,e,2)}B=f[b>>2]|0;F=b+4|0;if((B|0)<(f[F>>2]|0)){b=k+4|0;G=k+8|0;H=k+12|0;I=l+4|0;J=l+8|0;K=l+12|0;L=m+4|0;M=m+8|0;N=m+12|0;O=a+64|0;P=a+4|0;Q=a+68|0;R=a+20|0;S=a+24|0;T=l+36|0;U=l+16|0;V=l+4|0;W=l+40|0;X=l+44|0;Z=l+48|0;_=k+16|0;$=k+44|0;aa=a+16|0;ba=o+4|0;ca=o+8|0;da=o+12|0;ea=k+36|0;fa=k+4|0;ga=k+40|0;ha=m+4|0;ia=m+8|0;ja=k+8|0;ka=m+12|0;la=k+12|0;ma=m+16|0;na=m+20|0;oa=k+20|0;pa=m+24|0;qa=k+24|0;ra=m+28|0;sa=k+28|0;ta=m+32|0;ua=k+32|0;va=m+36|0;wa=k+44|0;xa=k+48|0;ya=m+44|0;za=m+40|0;Aa=m+48|0;Ba=k+40|0;Ca=a+56|0;a=e+36|0;Da=e+16|0;Ea=e+4|0;Fa=e+40|0;Ga=e+44|0;Ha=e+48|0;Ia=m+4|0;Ja=m+8|0;Ka=m+12|0;La=l+4|0;Ma=l+8|0;Na=l+12|0;Oa=l+16|0;Pa=l+20|0;Qa=l+24|0;Ra=l+28|0;Sa=l+32|0;Ta=l+36|0;Ua=l+44|0;Va=l+40|0;Wa=l+48|0;Xa=(t|0)==5;t=m+4|0;Ya=m+8|0;Za=m+12|0;_a=o+8|0;$a=o+4|0;ab=l+36|0;bb=l+16|0;cb=l+4|0;db=l+40|0;eb=l+44|0;fb=l+48|0;gb=k+52|0;hb=k+52|0;ib=B;B=f[p>>2]|0;while(1){jb=f[B+12>>2]|0;if((jb|0)>0){kb=0;lb=jb;jb=B;while(1){mb=(f[F>>2]|0)-ib|0;nb=(mb|0)<(w|0)?mb:w;mb=lb-kb|0;ob=(mb|0)<(q|0)?mb:q;f[k>>2]=kb;f[b>>2]=ib;f[G>>2]=ob;f[H>>2]=nb;Z$(e,jb,k);f[l>>2]=0;f[I>>2]=0;f[J>>2]=ob;f[K>>2]=nb;Z$(k,g,l);if(!(f[z>>2]|0)){f[m>>2]=0;f[L>>2]=0;f[M>>2]=ob;f[N>>2]=nb;Z$(l,i,m);if((nb|0)>0){mb=(ob|0)>0;pb=kb<<1;qb=0;do{rb=(f[_>>2]|0)+(Y(f[f[$>>2]>>2]|0,qb)|0)|0;sb=(f[U>>2]|0)+(Y(f[f[X>>2]>>2]|0,qb)|0)|0;tb=f[s>>2]|0;do if((f[tb>>2]&4095|0)==11?(f[f[aa>>2]>>2]&4094|0)==2:0){f[o>>2]=kb;f[ba>>2]=ib;f[ca>>2]=ob;f[da>>2]=nb;Z$(m,tb,o);ub=f[ea>>2]|0;if(ub|0?(vb=ub+12|0,ub=f[vb>>2]|0,f[vb>>2]=ub+-1,(ub|0)==1):0)V$(k);f[ea>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[fa>>2]|0)>0){ub=f[ga>>2]|0;vb=0;do{f[ub+(vb<<2)>>2]=0;vb=vb+1|0}while((vb|0)<(f[fa>>2]|0))}f[k>>2]=f[m>>2];vb=f[ha>>2]|0;f[fa>>2]=vb;f[ja>>2]=f[ia>>2];f[la>>2]=f[ka>>2];f[_>>2]=f[ma>>2];f[oa>>2]=f[na>>2];f[qa>>2]=f[pa>>2];f[sa>>2]=f[ra>>2];f[ua>>2]=f[ta>>2];f[ea>>2]=f[va>>2];ub=f[wa>>2]|0;if((ub|0)==(xa|0))wb=vb;else{wL(ub);f[wa>>2]=xa;f[ga>>2]=ja;wb=f[ha>>2]|0}if((wb|0)<3){ub=f[ya>>2]|0;f[xa>>2]=f[ub>>2];f[gb>>2]=f[ub+4>>2];xb=ub}else{f[wa>>2]=f[ya>>2];f[Ba>>2]=f[za>>2];f[ya>>2]=Aa;f[za>>2]=ia;xb=Aa}f[m>>2]=1124007936;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;f[ha+16>>2]=0;f[ha+20>>2]=0;f[ha+24>>2]=0;f[ha+28>>2]=0;f[va>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((xb|0)!=(Aa|0))wL(xb);ub=f[aa>>2]|0;vb=(f[ub+16>>2]|0)+(Y(f[f[ub+44>>2]>>2]|0,qb+ib|0)|0)+(kb<<1)|0;if(mb)yb=0;else break;do{d[sb+(yb<<1)>>1]=d[vb+(yb<<1)>>1]&1023;yb=yb+1|0}while((yb|0)<(ob|0))}else zb=70;while(0);do if((zb|0)==70){zb=0;vb=qb+ib|0;ub=(f[tb+16>>2]|0)+(Y(f[f[tb+44>>2]>>2]|0,vb)|0)|0;if(!(f[Ca>>2]|0)){Ab=ub+(pb<<2)|0;if(mb)Bb=0;else break;do{Cb=Bb<<1;Db=ALc(+n[Ab+(Cb<<2)>>2]*32.0)|0;Eb=Cb|1;Fb=ALc(+n[Ab+(Eb<<2)>>2]*32.0)|0;Gb=Db>>5;d[rb+(Cb<<1)>>1]=(Gb+32768|0)>>>0<65536?Gb:(Gb|0)>0?32767:32768;Gb=Fb>>5;d[rb+(Eb<<1)>>1]=(Gb+32768|0)>>>0<65536?Gb:(Gb|0)>0?32767:32768;d[sb+(Bb<<1)>>1]=Fb<<5&992|Db&31;Bb=Bb+1|0}while((Bb|0)<(ob|0))}else{Ab=ub+(kb<<2)|0;Db=f[aa>>2]|0;Fb=(f[Db+16>>2]|0)+(Y(f[f[Db+44>>2]>>2]|0,vb)|0)+(kb<<2)|0;if(mb)Hb=0;else break;do{Db=ALc(+n[Ab+(Hb<<2)>>2]*32.0)|0;Gb=ALc(+n[Fb+(Hb<<2)>>2]*32.0)|0;Eb=Db>>5;Cb=Hb<<1;d[rb+(Cb<<1)>>1]=(Eb+32768|0)>>>0<65536?Eb:(Eb|0)>0?32767:32768;Eb=Gb>>5;d[rb+((Cb|1)<<1)>>1]=(Eb+32768|0)>>>0<65536?Eb:(Eb|0)>0?32767:32768;d[sb+(Hb<<1)>>1]=Gb<<5&992|Db&31;Hb=Hb+1|0}while((Hb|0)<(ob|0))}}while(0);qb=qb+1|0}while((qb|0)<(nb|0))}Ii[f[O>>2]&127](f[P>>2]|0,e,k,l,f[Q>>2]|0,f[R>>2]|0,S);qb=f[T>>2]|0;if(qb|0?(mb=qb+12|0,qb=f[mb>>2]|0,f[mb>>2]=qb+-1,(qb|0)==1):0)V$(l);f[T>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[V>>2]|0)>0){qb=f[W>>2]|0;mb=0;do{f[qb+(mb<<2)>>2]=0;mb=mb+1|0}while((mb|0)<(f[V>>2]|0))}mb=f[X>>2]|0;if((mb|0)!=(Z|0))wL(mb)}else{mb=f[s>>2]|0;do if((f[mb>>2]&4095|0)==11){qb=f[aa>>2]|0;if(f[qb+16>>2]|0){pb=f[qb+4>>2]|0;if((pb|0)<3)Ib=Y(f[qb+12>>2]|0,f[qb+8>>2]|0)|0;else{sb=f[qb+40>>2]|0;qb=0;rb=1;while(1){tb=Y(f[sb+(qb<<2)>>2]|0,rb)|0;qb=qb+1|0;if((qb|0)==(pb|0)){Ib=tb;break}else rb=tb}}if(!((pb|0)==0|(Ib|0)==0)){zb=28;break}}f[m>>2]=kb;f[Ia>>2]=ib;f[Ja>>2]=ob;f[Ka>>2]=nb;Z$(l,mb,m);rb=f[ea>>2]|0;if(rb|0?(qb=rb+12|0,rb=f[qb>>2]|0,f[qb>>2]=rb+-1,(rb|0)==1):0)V$(k);f[ea>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[fa>>2]|0)>0){rb=f[ga>>2]|0;qb=0;do{f[rb+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[fa>>2]|0))}f[k>>2]=f[l>>2];qb=f[La>>2]|0;f[fa>>2]=qb;f[ja>>2]=f[Ma>>2];f[la>>2]=f[Na>>2];f[_>>2]=f[Oa>>2];f[oa>>2]=f[Pa>>2];f[qa>>2]=f[Qa>>2];f[sa>>2]=f[Ra>>2];f[ua>>2]=f[Sa>>2];f[ea>>2]=f[Ta>>2];rb=f[wa>>2]|0;if((rb|0)==(xa|0))Jb=qb;else{wL(rb);f[wa>>2]=xa;f[ga>>2]=ja;Jb=f[La>>2]|0}if((Jb|0)<3){rb=f[Ua>>2]|0;f[xa>>2]=f[rb>>2];f[hb>>2]=f[rb+4>>2];Kb=rb}else{f[wa>>2]=f[Ua>>2];f[Ba>>2]=f[Va>>2];f[Ua>>2]=Wa;f[Va>>2]=Ma;Kb=Wa}f[l>>2]=1124007936;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;f[La+16>>2]=0;f[La+20>>2]=0;f[La+24>>2]=0;f[La+28>>2]=0;f[Ta>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((Kb|0)!=(Wa|0))wL(Kb)}else zb=28;while(0);a:do if((zb|0)==28){zb=0;if(!Xa){if((nb|0)<=0)break;rb=f[_>>2]|0;qb=f[mb+16>>2]|0;pb=kb<<1;sb=f[aa>>2]|0;tb=f[sb+16>>2]|0;if((ob|0)<=0)break;Fb=f[f[$>>2]>>2]|0;Ab=f[f[mb+44>>2]>>2]|0;vb=f[f[sb+44>>2]>>2]|0;sb=0;while(1){ub=rb+(Y(Fb,sb)|0)|0;Db=sb+ib|0;Gb=qb+(Y(Ab,Db)|0)+(pb<<1)|0;Eb=tb+(Y(vb,Db)|0)+(kb<<1)|0;Db=0;do{Cb=d[Eb+(Db<<1)>>1]&1023;Lb=Db<<1;d[ub+(Lb<<1)>>1]=(h[1161459+(Cb<<1)>>0]|0)+(j[Gb+(Lb<<1)>>1]|0);Mb=Lb|1;d[ub+(Mb<<1)>>1]=(h[1161459+(Cb<<1)+1>>0]|0)+(j[Gb+(Mb<<1)>>1]|0);Db=Db+1|0}while((Db|0)<(ob|0));sb=sb+1|0;if((sb|0)>=(nb|0))break a}}if(f[Ca>>2]|0){if((nb|0)<=0)break;sb=f[_>>2]|0;vb=f[f[$>>2]>>2]|0;tb=f[mb+16>>2]|0;pb=f[f[mb+44>>2]>>2]|0;Ab=f[aa>>2]|0;qb=f[Ab+16>>2]|0;Fb=f[f[Ab+44>>2]>>2]|0;if((ob|0)>0)Nb=0;else break;while(1){Ab=sb+(Y(vb,Nb)|0)|0;rb=Nb+ib|0;Db=tb+(Y(pb,rb)|0)+(kb<<2)|0;Gb=qb+(Y(Fb,rb)|0)+(kb<<2)|0;rb=0;do{ub=ALc(+n[Db+(rb<<2)>>2])|0;Eb=rb<<1;d[Ab+(Eb<<1)>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;ub=ALc(+n[Gb+(rb<<2)>>2])|0;d[Ab+((Eb|1)<<1)>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;rb=rb+1|0}while((rb|0)<(ob|0));Nb=Nb+1|0;if((Nb|0)>=(nb|0))break a}}f[m>>2]=kb;f[t>>2]=ib;f[Ya>>2]=ob;f[Za>>2]=nb;Z$(l,mb,m);Fb=_a;f[Fb>>2]=0;f[Fb+4>>2]=0;f[o>>2]=33619968;f[$a>>2]=k;dY(l,o,f[k>>2]&7,1.0,0.0);Fb=f[ab>>2]|0;if(Fb|0?(qb=Fb+12|0,Fb=f[qb>>2]|0,f[qb>>2]=Fb+-1,(Fb|0)==1):0)V$(l);f[ab>>2]=0;f[bb>>2]=0;f[bb+4>>2]=0;f[bb+8>>2]=0;f[bb+12>>2]=0;if((f[cb>>2]|0)>0){Fb=f[db>>2]|0;qb=0;do{f[Fb+(qb<<2)>>2]=0;qb=qb+1|0}while((qb|0)<(f[cb>>2]|0))}qb=f[eb>>2]|0;if((qb|0)!=(fb|0))wL(qb)}while(0);gi[f[z>>2]&255](f[P>>2]|0,e,k,f[R>>2]|0,S)}mb=f[ea>>2]|0;if(mb|0?(nb=mb+12|0,mb=f[nb>>2]|0,f[nb>>2]=mb+-1,(mb|0)==1):0)V$(k);f[ea>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[fa>>2]|0)>0){mb=f[ga>>2]|0;nb=0;do{f[mb+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[fa>>2]|0))}nb=f[$>>2]|0;if((nb|0)!=(xa|0))wL(nb);nb=f[a>>2]|0;if(nb|0?(mb=nb+12|0,nb=f[mb>>2]|0,f[mb>>2]=nb+-1,(nb|0)==1):0)V$(e);f[a>>2]=0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;if((f[Ea>>2]|0)>0){nb=f[Fa>>2]|0;mb=0;do{f[nb+(mb<<2)>>2]=0;mb=mb+1|0}while((mb|0)<(f[Ea>>2]|0))}mb=f[Ga>>2]|0;if((mb|0)!=(Ha|0))wL(mb);kb=kb+q|0;mb=f[p>>2]|0;lb=f[mb+12>>2]|0;if((lb|0)<=(kb|0)){Ob=mb;break}else jb=mb}}else Ob=B;ib=ib+w|0;if((ib|0)>=(f[F>>2]|0))break;else B=Ob}}Ob=i+36|0;B=f[Ob>>2]|0;if(B|0?(F=B+12|0,B=f[F>>2]|0,f[F>>2]=B+-1,(B|0)==1):0)V$(i);f[Ob>>2]=0;Ob=i+16|0;f[Ob>>2]=0;f[Ob+4>>2]=0;f[Ob+8>>2]=0;f[Ob+12>>2]=0;if((f[C>>2]|0)>0){Ob=f[E>>2]|0;E=0;do{f[Ob+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[y>>2]|0;if((C|0)!=(D|0))wL(C);C=g+36|0;D=f[C>>2]|0;if(D|0?(y=D+12|0,D=f[y>>2]|0,f[y>>2]=D+-1,(D|0)==1):0)V$(g);f[C>>2]=0;C=g+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[x>>2]|0;x=0;do{f[C+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[A>>2]|0;if((v|0)==(r|0)){u=c;return}wL(v);u=c;return}function vaa(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;m=u;u=u+576|0;n=m+64|0;o=m+32|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=zLc(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-7|0;A=(l|0)>0?l:0;l=t+-7|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(k|0)==5;k=(a|0)==0;P=o+4|0;Q=o+8|0;R=o+12|0;S=o+16|0;T=o+20|0;U=o+24|0;V=o+28|0;W=(r|-512)^511;r=q+4|0;X=q+8|0;Z=q+12|0;_=q+16|0;$=q+20|0;aa=q+24|0;ba=q+28|0;ca=0;da=y;while(1){y=f[w>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,ca)|0)|0;ga=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(g){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(x,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=i+(j[ga+(ia<<1)>>1]<<6<<1)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+(Y(la,z)|0)+(Y(oa,x)|0)|0;while(1){ta=0;ua=0;va=sa;wa=qa;while(1){xa=Y(d[wa>>1]|0,h[va>>0]|0)|0;ya=Y(d[wa+2>>1]|0,h[va+x>>0]|0)|0;za=Y(d[wa+4>>1]|0,h[va+l>>0]|0)|0;Aa=Y(d[wa+6>>1]|0,h[va+H>>0]|0)|0;Ba=Y(d[wa+8>>1]|0,h[va+I>>0]|0)|0;Ca=Y(d[wa+10>>1]|0,h[va+J>>0]|0)|0;Da=Y(d[wa+12>>1]|0,h[va+K>>0]|0)|0;ua=xa+ua+ya+za+Aa+Ba+Ca+Da+(Y(d[wa+14>>1]|0,h[va+L>>0]|0)|0)|0;ta=ta+1|0;if((ta|0)==8)break;else{va=va+z|0;wa=wa+16|0}}wa=ua+16384>>15;b[ha+ra>>0]=wa>>>0<256?wa:(wa|0)>0?255:0;ra=ra+1|0;if((ra|0)==(x|0)){Ea=ja;break}else sa=sa+M+N|0}}else{if(O?!(na>>>0<s>>>0&pa>>>0<t>>>0):0)Fa=ja;else G=19;do if((G|0)==19){G=0;if(k?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(s|0)&(la|0)<(t|0)^1:0){o1c(ka|0,n|0,x|0)|0;Fa=ja;break}sa=Y(qR(oa,s,a)|0,x)|0;f[o>>2]=sa;ra=qR(la,t,a)|0;f[q>>2]=ra;ra=Y(qR(na+-2|0,s,a)|0,x)|0;f[P>>2]=ra;wa=qR(pa+-2|0,t,a)|0;f[r>>2]=wa;wa=Y(qR(na+-1|0,s,a)|0,x)|0;f[Q>>2]=wa;va=qR(pa+-1|0,t,a)|0;f[X>>2]=va;va=Y(qR(na,s,a)|0,x)|0;f[R>>2]=va;ta=qR(pa,t,a)|0;f[Z>>2]=ta;ta=Y(qR(na+1|0,s,a)|0,x)|0;f[S>>2]=ta;Da=qR(pa+1|0,t,a)|0;f[_>>2]=Da;Da=Y(qR(na+2|0,s,a)|0,x)|0;f[T>>2]=Da;Ca=qR(pa+2|0,t,a)|0;f[$>>2]=Ca;Ca=Y(qR(na+3|0,s,a)|0,x)|0;f[U>>2]=Ca;Ba=qR(pa+3|0,t,a)|0;f[aa>>2]=Ba;Ba=Y(qR(na+4|0,s,a)|0,x)|0;f[V>>2]=Ba;Aa=qR(pa+4|0,t,a)|0;f[ba>>2]=Aa;Aa=0;za=ja;ya=sa;sa=ra;ra=wa;wa=va;va=ta;ta=Da;Da=Ca;Ca=Ba;while(1){Ba=h[n+Aa>>0]|0;xa=Ba<<15;Ga=(sa|0)>-1;Ha=(ra|0)>-1;Ia=(wa|0)>-1;Ja=(va|0)>-1;Ka=(ta|0)>-1;La=(Da|0)>-1;Ma=(Ca|0)>-1;if((ya|0)>-1){Na=0;Oa=xa;Pa=qa;while(1){Qa=f[q+(Na<<2)>>2]|0;Ra=za+(Y(Qa,z)|0)|0;do if((Qa|0)<0)Sa=Oa;else{Ta=(Y((h[Ra+ya>>0]|0)-Ba|0,d[Pa>>1]|0)|0)+Oa|0;if(Ga)Ua=(Y((h[Ra+sa>>0]|0)-Ba|0,d[Pa+2>>1]|0)|0)+Ta|0;else Ua=Ta;if(Ha)Va=(Y((h[Ra+ra>>0]|0)-Ba|0,d[Pa+4>>1]|0)|0)+Ua|0;else Va=Ua;if(Ia)Wa=(Y((h[Ra+wa>>0]|0)-Ba|0,d[Pa+6>>1]|0)|0)+Va|0;else Wa=Va;if(Ja)Xa=(Y((h[Ra+va>>0]|0)-Ba|0,d[Pa+8>>1]|0)|0)+Wa|0;else Xa=Wa;if(Ka)Ya=(Y((h[Ra+ta>>0]|0)-Ba|0,d[Pa+10>>1]|0)|0)+Xa|0;else Ya=Xa;if(La)Za=(Y((h[Ra+Da>>0]|0)-Ba|0,d[Pa+12>>1]|0)|0)+Ya|0;else Za=Ya;if(!Ma){Sa=Za;break}Sa=(Y((h[Ra+Ca>>0]|0)-Ba|0,d[Pa+14>>1]|0)|0)+Za|0}while(0);Na=Na+1|0;if((Na|0)==8){_a=Sa;break}else{Oa=Sa;Pa=Pa+16|0}}}else{Pa=0;Oa=xa;Na=qa;while(1){Ra=f[q+(Pa<<2)>>2]|0;Qa=za+(Y(Ra,z)|0)|0;do if((Ra|0)<0)$a=Oa;else{if(Ga)ab=(Y((h[Qa+sa>>0]|0)-Ba|0,d[Na+2>>1]|0)|0)+Oa|0;else ab=Oa;if(Ha)bb=(Y((h[Qa+ra>>0]|0)-Ba|0,d[Na+4>>1]|0)|0)+ab|0;else bb=ab;if(Ia)cb=(Y((h[Qa+wa>>0]|0)-Ba|0,d[Na+6>>1]|0)|0)+bb|0;else cb=bb;if(Ja)db=(Y((h[Qa+va>>0]|0)-Ba|0,d[Na+8>>1]|0)|0)+cb|0;else db=cb;if(Ka)eb=(Y((h[Qa+ta>>0]|0)-Ba|0,d[Na+10>>1]|0)|0)+db|0;else eb=db;if(La)fb=(Y((h[Qa+Da>>0]|0)-Ba|0,d[Na+12>>1]|0)|0)+eb|0;else fb=eb;if(!Ma){$a=fb;break}$a=(Y((h[Qa+Ca>>0]|0)-Ba|0,d[Na+14>>1]|0)|0)+fb|0}while(0);Pa=Pa+1|0;if((Pa|0)==8){_a=$a;break}else{Oa=$a;Na=Na+16|0}}}Na=_a+16384>>15;b[ha+Aa>>0]=Na>>>0<256?Na:(Na|0)>0?255:0;Na=Aa+1|0;if((Na|0)==(x|0))break;Aa=Na;za=za+1|0;ya=f[o>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;Da=f[U>>2]|0;Ca=f[V>>2]|0}Fa=ja+x+W|0}while(0);Ea=Fa}ia=ia+1|0;if((ia|0)==(D|0)){gb=Ea;break}else{ha=ha+x|0;ja=Ea}}}else gb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=gb}u=m;return}function waa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=zLc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+(j[va>>1]|0)*+n[wa>>2]+ +(j[va+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(j[va+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(j[va+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(j[va+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(j[va+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(j[va+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(j[va+(L<<1)>>1]|0)*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<1)|0;wa=wa+32|0}}wa=ALc(ua)|0;d[ha+(ra<<1)>>1]=wa>>>0<65536?wa:(wa|0)>0?65535:0;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){o1c(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(qR(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=qR(la,s,a)|0;f[o>>2]=ra;ra=Y(qR(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=qR(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(qR(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=qR(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(qR(na,r,a)|0,x)|0;f[R>>2]=va;ta=qR(pa,s,a)|0;f[Z>>2]=ta;ta=Y(qR(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=qR(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(qR(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=qR(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(qR(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=qR(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(qR(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=qR(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+(j[l+(Ca<<1)>>1]|0);Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(j[Qa+(Ea<<1)>>1]|0)-Fa);if(Ba)Ta=Sa+ +n[Oa+4>>2]*(+(j[Qa+(sa<<1)>>1]|0)-Fa);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(j[Qa+(ra<<1)>>1]|0)-Fa);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(j[Qa+(wa<<1)>>1]|0)-Fa);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(j[Qa+(va<<1)>>1]|0)-Fa);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(j[Qa+(ta<<1)>>1]|0)-Fa);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(j[Qa+(za<<1)>>1]|0)-Fa);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(j[Qa+(Aa<<1)>>1]|0)-Fa)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+ +n[Ma+4>>2]*(+(j[Pa+(sa<<1)>>1]|0)-Fa);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(j[Pa+(ra<<1)>>1]|0)-Fa);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(j[Pa+(wa<<1)>>1]|0)-Fa);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(j[Pa+(va<<1)>>1]|0)-Fa);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(j[Pa+(ta<<1)>>1]|0)-Fa);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(j[Pa+(za<<1)>>1]|0)-Fa);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(j[Pa+(Aa<<1)>>1]|0)-Fa)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=ALc(Za)|0;d[ha+(Ca<<1)>>1]=Ma>>>0<65536?Ma:(Ma|0)>0?65535:0;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+2|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<1)+(W<<1)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function xaa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=zLc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+(d[va>>1]|0)*+n[wa>>2]+ +(d[va+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(d[va+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(d[va+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(d[va+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(d[va+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(d[va+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(d[va+(L<<1)>>1]|0)*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<1)|0;wa=wa+32|0}}wa=ALc(ua)|0;d[ha+(ra<<1)>>1]=(wa+32768|0)>>>0<65536?wa:(wa|0)>0?32767:32768;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){o1c(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(qR(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=qR(la,s,a)|0;f[o>>2]=ra;ra=Y(qR(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=qR(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(qR(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=qR(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(qR(na,r,a)|0,x)|0;f[R>>2]=va;ta=qR(pa,s,a)|0;f[Z>>2]=ta;ta=Y(qR(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=qR(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(qR(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=qR(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(qR(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=qR(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(qR(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=qR(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+(d[l+(Ca<<1)>>1]|0);Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(d[Qa+(Ea<<1)>>1]|0)-Fa);if(Ba)Ta=Sa+ +n[Oa+4>>2]*(+(d[Qa+(sa<<1)>>1]|0)-Fa);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(d[Qa+(ra<<1)>>1]|0)-Fa);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(d[Qa+(wa<<1)>>1]|0)-Fa);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(d[Qa+(va<<1)>>1]|0)-Fa);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(d[Qa+(ta<<1)>>1]|0)-Fa);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(d[Qa+(za<<1)>>1]|0)-Fa);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(d[Qa+(Aa<<1)>>1]|0)-Fa)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+ +n[Ma+4>>2]*(+(d[Pa+(sa<<1)>>1]|0)-Fa);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(d[Pa+(ra<<1)>>1]|0)-Fa);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(d[Pa+(wa<<1)>>1]|0)-Fa);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(d[Pa+(va<<1)>>1]|0)-Fa);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(d[Pa+(ta<<1)>>1]|0)-Fa);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(d[Pa+(za<<1)>>1]|0)-Fa);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(d[Pa+(Aa<<1)>>1]|0)-Fa)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=ALc(Za)|0;d[ha+(Ca<<1)>>1]=(Ma+32768|0)>>>0<65536?Ma:(Ma|0)>0?32767:32768;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+2|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<1)+(W<<1)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function yaa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+2112|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<2)+4|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<2)+((Y(oa,x)|0)<<2)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+n[va>>2]*+n[wa>>2]+ +n[va+(x<<2)>>2]*+n[wa+4>>2]+ +n[va+(i<<2)>>2]*+n[wa+8>>2]+ +n[va+(H<<2)>>2]*+n[wa+12>>2]+ +n[va+(I<<2)>>2]*+n[wa+16>>2]+ +n[va+(J<<2)>>2]*+n[wa+20>>2]+ +n[va+(K<<2)>>2]*+n[wa+24>>2]+ +n[va+(L<<2)>>2]*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<2)|0;wa=wa+32|0}}n[ha+(ra<<2)>>2]=ua;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<2)+(N<<2)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){o1c(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(qR(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=qR(la,s,a)|0;f[o>>2]=ra;ra=Y(qR(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=qR(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(qR(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=qR(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(qR(na,r,a)|0,x)|0;f[R>>2]=va;ta=qR(pa,s,a)|0;f[Z>>2]=ta;ta=Y(qR(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=qR(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(qR(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=qR(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(qR(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=qR(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(qR(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=qR(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+n[l+(Ca<<2)>>2];Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<2)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+n[Qa+(Ea<<2)>>2]-Fa)*+n[Oa>>2];if(Ba)Ta=Sa+(+n[Qa+(sa<<2)>>2]-Fa)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+n[Qa+(ra<<2)>>2]-Fa)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+n[Qa+(wa<<2)>>2]-Fa)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+n[Qa+(va<<2)>>2]-Fa)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+n[Qa+(ta<<2)>>2]-Fa)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+n[Qa+(za<<2)>>2]-Fa)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+n[Qa+(Aa<<2)>>2]-Fa)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<2)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+(+n[Pa+(sa<<2)>>2]-Fa)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+n[Pa+(ra<<2)>>2]-Fa)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+n[Pa+(wa<<2)>>2]-Fa)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+n[Pa+(va<<2)>>2]-Fa)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+n[Pa+(ta<<2)>>2]-Fa)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+n[Pa+(za<<2)>>2]-Fa)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+n[Pa+(Aa<<2)>>2]-Fa)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}n[ha+(Ca<<2)>>2]=Za;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+4|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<2)+(W<<2)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<2)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function zaa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+4160|0;l=k;m=k+4128|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<3)+((Y(oa,x)|0)<<3)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+p[va>>3]*+n[wa>>2]+ +p[va+(x<<3)>>3]*+n[wa+4>>2]+ +p[va+(i<<3)>>3]*+n[wa+8>>2]+ +p[va+(H<<3)>>3]*+n[wa+12>>2]+ +p[va+(I<<3)>>3]*+n[wa+16>>2]+ +p[va+(J<<3)>>3]*+n[wa+20>>2]+ +p[va+(K<<3)>>3]*+n[wa+24>>2]+ +p[va+(L<<3)>>3]*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<3)|0;wa=wa+32|0}}p[ha+(ra<<3)>>3]=ua;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<3)+(N<<3)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){o1c(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(qR(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=qR(la,s,a)|0;f[o>>2]=ra;ra=Y(qR(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=qR(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(qR(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=qR(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(qR(na,r,a)|0,x)|0;f[R>>2]=va;ta=qR(pa,s,a)|0;f[Z>>2]=ta;ta=Y(qR(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=qR(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(qR(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=qR(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(qR(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=qR(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(qR(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=qR(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+p[l+(Ca<<3)>>3];Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<3)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+p[Qa+(Ea<<3)>>3]-Fa)*+n[Oa>>2];if(Ba)Ta=Sa+(+p[Qa+(sa<<3)>>3]-Fa)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+p[Qa+(ra<<3)>>3]-Fa)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+p[Qa+(wa<<3)>>3]-Fa)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+p[Qa+(va<<3)>>3]-Fa)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+p[Qa+(ta<<3)>>3]-Fa)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+p[Qa+(za<<3)>>3]-Fa)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+p[Qa+(Aa<<3)>>3]-Fa)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<3)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+(+p[Pa+(sa<<3)>>3]-Fa)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+p[Pa+(ra<<3)>>3]-Fa)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+p[Pa+(wa<<3)>>3]-Fa)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+p[Pa+(va<<3)>>3]-Fa)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+p[Pa+(ta<<3)>>3]-Fa)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+p[Pa+(za<<3)>>3]-Fa)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+p[Pa+(Aa<<3)>>3]-Fa)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}p[ha+(Ca<<3)>>3]=Za;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+8|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<3)+(W<<3)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<3)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Aaa(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0;m=u;u=u+544|0;n=m+32|0;o=m+16|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=zLc(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-3|0;A=(l|0)>0?l:0;l=t+-3|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(k|0)==5;k=(a|0)==0;K=o+4|0;L=o+8|0;M=o+12|0;N=(r|-512)^511;r=q+4|0;O=q+8|0;P=q+12|0;Q=0;R=y;while(1){y=f[w>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,Q)|0)|0;U=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(g){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(x,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=i+(j[U+(W<<1)>>1]<<4<<1)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=ca+2|0;ea=ca+4|0;fa=ca+6|0;ga=ca+8|0;ha=ca+10|0;ia=ca+12|0;ja=ca+14|0;ka=ca+16|0;la=ca+18|0;ma=ca+20|0;na=ca+22|0;oa=ca+24|0;pa=ca+26|0;qa=ca+28|0;ra=ca+30|0;sa=0;ta=X+(Y(_,z)|0)+(Y(aa,x)|0)|0;while(1){ua=Y(d[ca>>1]|0,h[ta>>0]|0)|0;va=Y(d[da>>1]|0,h[ta+x>>0]|0)|0;wa=Y(d[ea>>1]|0,h[ta+l>>0]|0)|0;xa=Y(d[fa>>1]|0,h[ta+H>>0]|0)|0;ya=ta+z|0;za=Y(d[ga>>1]|0,h[ya>>0]|0)|0;Aa=Y(d[ha>>1]|0,h[ya+x>>0]|0)|0;Ba=Y(d[ia>>1]|0,h[ya+l>>0]|0)|0;Ca=Y(d[ja>>1]|0,h[ya+H>>0]|0)|0;Da=ya+z|0;ya=Y(d[ka>>1]|0,h[Da>>0]|0)|0;Ea=Y(d[la>>1]|0,h[Da+x>>0]|0)|0;Fa=Y(d[ma>>1]|0,h[Da+l>>0]|0)|0;Ga=Y(d[na>>1]|0,h[Da+H>>0]|0)|0;Ha=Da+z|0;Da=Y(d[oa>>1]|0,h[Ha>>0]|0)|0;Ia=Y(d[pa>>1]|0,h[Ha+x>>0]|0)|0;Ja=Y(d[qa>>1]|0,h[Ha+l>>0]|0)|0;Ka=ua+16384+va+wa+xa+za+Aa+Ba+Ca+ya+Ea+Fa+Ga+Da+Ia+Ja+(Y(d[ra>>1]|0,h[Ha+H>>0]|0)|0)>>15;b[V+sa>>0]=Ka>>>0<256?Ka:(Ka|0)>0?255:0;sa=sa+1|0;if((sa|0)==(x|0)){La=X;break}else ta=Ha+I|0}}else{if(J?!($>>>0<s>>>0&ba>>>0<t>>>0):0)Ma=X;else G=17;do if((G|0)==17){G=0;if(k?(ba+3|0)<1|((ba|0)>(t|0)|(($|0)>(s|0)|($+3|0)<1)):0){o1c(Z|0,n|0,x|0)|0;Ma=X;break}ta=Y(qR(aa,s,a)|0,x)|0;f[o>>2]=ta;sa=qR(_,t,a)|0;f[q>>2]=sa;sa=Y(qR($,s,a)|0,x)|0;f[K>>2]=sa;ra=qR(ba,t,a)|0;f[r>>2]=ra;ra=Y(qR($+1|0,s,a)|0,x)|0;f[L>>2]=ra;qa=qR(ba+1|0,t,a)|0;f[O>>2]=qa;qa=Y(qR($+2|0,s,a)|0,x)|0;f[M>>2]=qa;pa=qR(ba+2|0,t,a)|0;f[P>>2]=pa;pa=ca+8|0;oa=pa+8|0;na=oa+8|0;ma=na+2|0;la=na+4|0;ka=na+6|0;ja=oa+2|0;ia=oa+4|0;ha=oa+6|0;ga=pa+2|0;fa=pa+4|0;ea=pa+6|0;da=ca+2|0;Ha=ca+4|0;Ka=ca+6|0;Ja=ca+8|0;Ia=Ja+8|0;Da=Ia+8|0;Ga=Da+2|0;Fa=Da+4|0;Ea=Da+6|0;Da=Ia+2|0;ya=Ia+4|0;Ca=Ia+6|0;Ia=Ja+2|0;Ba=Ja+4|0;Aa=Ja+6|0;Ja=ca+2|0;za=ca+4|0;xa=ca+6|0;wa=ca+8|0;va=ca+16|0;ua=ca+24|0;Na=ua+4|0;Oa=ua+6|0;ua=va+4|0;Pa=va+6|0;va=wa+4|0;Qa=wa+6|0;wa=ca+4|0;Ra=ca+6|0;Sa=0;Ta=X;Ua=ta;ta=sa;sa=ra;ra=qa;while(1){qa=h[n+Sa>>0]|0;Va=qa<<15;Wa=(ta|0)>-1;Xa=(sa|0)>-1;Ya=(ra|0)>-1;Za=f[q>>2]|0;_a=Ta+(Y(Za,z)|0)|0;$a=(Za|0)<0;do if((Ua|0)>-1){if(!$a){Za=(Y((h[_a+Ua>>0]|0)-qa|0,d[ca>>1]|0)|0)+Va|0;if(Wa)ab=(Y((h[_a+ta>>0]|0)-qa|0,d[da>>1]|0)|0)+Za|0;else ab=Za;if(Xa)bb=(Y((h[_a+sa>>0]|0)-qa|0,d[Ha>>1]|0)|0)+ab|0;else bb=ab;if(Ya)cb=(Y((h[_a+ra>>0]|0)-qa|0,d[Ka>>1]|0)|0)+bb|0;else cb=bb}else cb=Va;Za=f[r>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Ua>>0]|0)-qa|0,d[pa>>1]|0)|0)+cb|0;if(Wa)eb=(Y((h[db+ta>>0]|0)-qa|0,d[ga>>1]|0)|0)+Za|0;else eb=Za;if(Xa)fb=(Y((h[db+sa>>0]|0)-qa|0,d[fa>>1]|0)|0)+eb|0;else fb=eb;if(Ya)gb=(Y((h[db+ra>>0]|0)-qa|0,d[ea>>1]|0)|0)+fb|0;else gb=fb}else gb=cb;db=f[O>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+Ua>>0]|0)-qa|0,d[oa>>1]|0)|0)+gb|0;if(Wa)hb=(Y((h[Za+ta>>0]|0)-qa|0,d[ja>>1]|0)|0)+db|0;else hb=db;if(Xa)ib=(Y((h[Za+sa>>0]|0)-qa|0,d[ia>>1]|0)|0)+hb|0;else ib=hb;if(Ya)jb=(Y((h[Za+ra>>0]|0)-qa|0,d[ha>>1]|0)|0)+ib|0;else jb=ib}else jb=gb;Za=f[P>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Ua>>0]|0)-qa|0,d[na>>1]|0)|0)+jb|0;if(Wa)kb=(Y((h[db+ta>>0]|0)-qa|0,d[ma>>1]|0)|0)+Za|0;else kb=Za;if(Xa)lb=(Y((h[db+sa>>0]|0)-qa|0,d[la>>1]|0)|0)+kb|0;else lb=kb;if(Ya)mb=(Y((h[db+ra>>0]|0)-qa|0,d[ka>>1]|0)|0)+lb|0;else mb=lb}else mb=jb}else if(Wa){if(!$a){db=(Y((h[_a+ta>>0]|0)-qa|0,d[Ja>>1]|0)|0)+Va|0;if(Xa)nb=(Y((h[_a+sa>>0]|0)-qa|0,d[za>>1]|0)|0)+db|0;else nb=db;if(Ya)ob=(Y((h[_a+ra>>0]|0)-qa|0,d[xa>>1]|0)|0)+nb|0;else ob=nb}else ob=Va;db=f[r>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+ta>>0]|0)-qa|0,d[Ia>>1]|0)|0)+ob|0;if(Xa)pb=(Y((h[Za+sa>>0]|0)-qa|0,d[Ba>>1]|0)|0)+db|0;else pb=db;if(Ya)qb=(Y((h[Za+ra>>0]|0)-qa|0,d[Aa>>1]|0)|0)+pb|0;else qb=pb}else qb=ob;Za=f[O>>2]|0;db=Ta+(Y(Za,z)|0)|0;do if((Za|0)<0)rb=qb;else{sb=(Y((h[db+ta>>0]|0)-qa|0,d[Da>>1]|0)|0)+qb|0;if(Xa)tb=(Y((h[db+sa>>0]|0)-qa|0,d[ya>>1]|0)|0)+sb|0;else tb=sb;if(!Ya){rb=tb;break}rb=(Y((h[db+ra>>0]|0)-qa|0,d[Ca>>1]|0)|0)+tb|0}while(0);db=f[P>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)<0){mb=rb;break}db=(Y((h[Za+ta>>0]|0)-qa|0,d[Ga>>1]|0)|0)+rb|0;if(Xa)ub=(Y((h[Za+sa>>0]|0)-qa|0,d[Fa>>1]|0)|0)+db|0;else ub=db;if(!Ya){mb=ub;break}mb=(Y((h[Za+ra>>0]|0)-qa|0,d[Ea>>1]|0)|0)+ub|0;break}else{if(!$a){if(Xa)vb=(Y((h[_a+sa>>0]|0)-qa|0,d[wa>>1]|0)|0)+Va|0;else vb=Va;if(Ya)wb=(Y((h[_a+ra>>0]|0)-qa|0,d[Ra>>1]|0)|0)+vb|0;else wb=vb}else wb=Va;Za=f[r>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){if(Xa)xb=(Y((h[db+sa>>0]|0)-qa|0,d[va>>1]|0)|0)+wb|0;else xb=wb;if(Ya)yb=(Y((h[db+ra>>0]|0)-qa|0,d[Qa>>1]|0)|0)+xb|0;else yb=xb}else yb=wb;db=f[O>>2]|0;Za=Ta+(Y(db,z)|0)|0;do if((db|0)<0)zb=yb;else{if(Xa)Ab=(Y((h[Za+sa>>0]|0)-qa|0,d[ua>>1]|0)|0)+yb|0;else Ab=yb;if(!Ya){zb=Ab;break}zb=(Y((h[Za+ra>>0]|0)-qa|0,d[Pa>>1]|0)|0)+Ab|0}while(0);Za=f[P>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)<0){mb=zb;break}if(Xa)Bb=(Y((h[db+sa>>0]|0)-qa|0,d[Na>>1]|0)|0)+zb|0;else Bb=zb;if(!Ya){mb=Bb;break}mb=(Y((h[db+ra>>0]|0)-qa|0,d[Oa>>1]|0)|0)+Bb|0;break}while(0);qa=mb+16384>>15;b[V+Sa>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;qa=Sa+1|0;if((qa|0)==(x|0))break;Sa=qa;Ta=Ta+1|0;Ua=f[o>>2]|0;ta=f[K>>2]|0;sa=f[L>>2]|0;ra=f[M>>2]|0}Ma=X+x+N|0}while(0);La=Ma}W=W+1|0;if((W|0)==(D|0)){Cb=La;break}else{V=V+x|0;X=La}}}else Cb=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Cb}u=m;return}function Baa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=zLc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<1)|0;wa=da+(z<<1)|0;xa=wa+(z<<1)|0;ya=ALc(+(j[va>>1]|0)*ea+ +(j[va+(x<<1)>>1]|0)*fa+ +(j[va+(i<<1)>>1]|0)*ga+ +(j[va+(H<<1)>>1]|0)*ha+(+(j[da>>1]|0)*ia+ +(j[da+(x<<1)>>1]|0)*ja+ +(j[da+(i<<1)>>1]|0)*ka+ +(j[da+(H<<1)>>1]|0)*la)+(+(j[wa>>1]|0)*ma+ +(j[wa+(x<<1)>>1]|0)*na+ +(j[wa+(i<<1)>>1]|0)*oa+ +(j[wa+(H<<1)>>1]|0)*pa)+(+(j[xa>>1]|0)*qa+ +(j[xa+(x<<1)>>1]|0)*ra+ +(j[xa+(i<<1)>>1]|0)*sa+ +(j[xa+(H<<1)>>1]|0)*ta))|0;d[V+(ua<<1)>>1]=ya>>>0<65536?ya:(ya|0)>0?65535:0;ua=ua+1|0;if((ua|0)==(x|0)){za=X;break}else va=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){o1c(Z|0,l|0,q|0)|0;Aa=X;break}va=Y(qR(aa,r,a)|0,x)|0;f[m>>2]=va;ua=qR(_,s,a)|0;f[o>>2]=ua;xa=Y(qR($,r,a)|0,x)|0;f[K>>2]=xa;ya=qR(ba,s,a)|0;f[w>>2]=ya;wa=Y(qR($+1|0,r,a)|0,x)|0;f[L>>2]=wa;da=qR(ba+1|0,s,a)|0;f[O>>2]=da;Ba=Y(qR($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=qR(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(da,z)|0;Ka=(da|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(da,z)|0;ab=(da|0)<0;da=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=da+8|0;db=da+12|0;da=ya+8|0;eb=ya+12|0;ya=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=wa;wa=Ba;while(1){ta=+(j[l+(hb<<1)>>1]|0);Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=ib+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=ib+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=ib+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[ua>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=ib+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=ib+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[da>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(j[Eb+(jb<<1)>>1]|0)-ta);if(Ba)Fb=ra+ +n[Cb+4>>2]*(+(j[Eb+(va<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(j[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(j[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=ALc(tb)|0;d[V+(hb<<1)>>1]=lb>>>0<65536?lb:(lb|0)>0?65535:0;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+2|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0}Aa=X+(x<<1)+(N<<1)|0}while(0);za=Aa}W=W+1|0;if((W|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;X=za}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Caa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=zLc(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<1)|0;wa=da+(z<<1)|0;xa=wa+(z<<1)|0;ya=ALc(+(d[va>>1]|0)*ea+ +(d[va+(x<<1)>>1]|0)*fa+ +(d[va+(i<<1)>>1]|0)*ga+ +(d[va+(H<<1)>>1]|0)*ha+(+(d[da>>1]|0)*ia+ +(d[da+(x<<1)>>1]|0)*ja+ +(d[da+(i<<1)>>1]|0)*ka+ +(d[da+(H<<1)>>1]|0)*la)+(+(d[wa>>1]|0)*ma+ +(d[wa+(x<<1)>>1]|0)*na+ +(d[wa+(i<<1)>>1]|0)*oa+ +(d[wa+(H<<1)>>1]|0)*pa)+(+(d[xa>>1]|0)*qa+ +(d[xa+(x<<1)>>1]|0)*ra+ +(d[xa+(i<<1)>>1]|0)*sa+ +(d[xa+(H<<1)>>1]|0)*ta))|0;d[V+(ua<<1)>>1]=(ya+32768|0)>>>0<65536?ya:(ya|0)>0?32767:32768;ua=ua+1|0;if((ua|0)==(x|0)){za=X;break}else va=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){o1c(Z|0,l|0,q|0)|0;Aa=X;break}va=Y(qR(aa,r,a)|0,x)|0;f[m>>2]=va;ua=qR(_,s,a)|0;f[o>>2]=ua;xa=Y(qR($,r,a)|0,x)|0;f[K>>2]=xa;ya=qR(ba,s,a)|0;f[w>>2]=ya;wa=Y(qR($+1|0,r,a)|0,x)|0;f[L>>2]=wa;da=qR(ba+1|0,s,a)|0;f[O>>2]=da;Ba=Y(qR($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=qR(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(da,z)|0;Ka=(da|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(da,z)|0;ab=(da|0)<0;da=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=da+8|0;db=da+12|0;da=ya+8|0;eb=ya+12|0;ya=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=wa;wa=Ba;while(1){ta=+(d[l+(hb<<1)>>1]|0);Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=ib+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=ib+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=ib+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[ua>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=ib+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=ib+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[da>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(d[Eb+(jb<<1)>>1]|0)-ta);if(Ba)Fb=ra+ +n[Cb+4>>2]*(+(d[Eb+(va<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(d[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(d[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=ALc(tb)|0;d[V+(hb<<1)>>1]=(lb+32768|0)>>>0<65536?lb:(lb|0)>0?32767:32768;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+2|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0}Aa=X+(x<<1)+(N<<1)|0}while(0);za=Aa}W=W+1|0;if((W|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;X=za}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Daa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0,pb=0,qb=0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0;k=u;u=u+2064|0;l=k+16|0;m=k;o=f[a+40>>2]|0;q=f[o+4>>2]|0;r=f[o>>2]|0;o=f[b+40>>2]|0;s=f[o+4>>2]|0;t=f[o>>2]|0;o=(f[a>>2]|0)>>>3;v=o&511;w=v+1|0;x=f[a+16>>2]|0;y=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(w|0));a=(h|0)!=5?h:4;i=q+-3|0;z=(i|0)>0?i:0;i=r+-3|0;A=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;B=Y(i?t:1,s)|0;if(i){C=B;D=1}else{E=B;F=6}}else{E=s;F=6}if((F|0)==6)if((t|0)>0){C=E;D=t}else{u=k;return}t=b+16|0;E=b+44|0;b=c+16|0;s=c+44|0;c=e+16|0;B=e+44|0;e=(C|0)>0;i=w<<1;G=w*3|0;H=(Y(y,-3)|0)+1|0;I=(h|0)==5;h=(a|0)==0;J=m+4|0;K=m+8|0;L=m+12|0;M=(o|-512)^511;o=(v<<2)+4|0;v=0;N=x;while(1){x=f[t>>2]|0;O=Y(f[f[E>>2]>>2]|0,v)|0;P=(f[b>>2]|0)+(Y(f[f[s>>2]>>2]|0,v)|0)|0;Q=(f[c>>2]|0)+(Y(f[f[B>>2]>>2]|0,v)|0)|0;if(e){R=x+O|0;S=0;T=N;while(1){U=x+(O+(Y(o,S)|0))|0;V=S<<1;W=d[P+(V<<1)>>1]|0;X=W+-1|0;Z=d[P+((V|1)<<1)>>1]|0;V=Z+-1|0;_=g+(j[Q+(S<<1)>>1]<<4<<2)|0;if(X>>>0<z>>>0&V>>>0<A>>>0){$=_+4|0;aa=_+8|0;ba=_+12|0;ca=_+16|0;da=_+20|0;ea=_+24|0;fa=_+28|0;ga=_+32|0;ha=_+36|0;ia=_+40|0;ja=_+44|0;ka=_+48|0;la=_+52|0;ma=_+56|0;na=_+60|0;oa=0;pa=T+((Y(V,y)|0)<<2)+((Y(X,w)|0)<<2)|0;while(1){qa=pa+(y<<2)|0;ra=qa+(y<<2)|0;sa=ra+(y<<2)|0;n[R+(oa<<2)>>2]=+n[pa>>2]*+n[_>>2]+ +n[pa+(w<<2)>>2]*+n[$>>2]+ +n[pa+(i<<2)>>2]*+n[aa>>2]+ +n[pa+(G<<2)>>2]*+n[ba>>2]+(+n[qa>>2]*+n[ca>>2]+ +n[qa+(w<<2)>>2]*+n[da>>2]+ +n[qa+(i<<2)>>2]*+n[ea>>2]+ +n[qa+(G<<2)>>2]*+n[fa>>2])+(+n[ra>>2]*+n[ga>>2]+ +n[ra+(w<<2)>>2]*+n[ha>>2]+ +n[ra+(i<<2)>>2]*+n[ia>>2]+ +n[ra+(G<<2)>>2]*+n[ja>>2])+(+n[sa>>2]*+n[ka>>2]+ +n[sa+(w<<2)>>2]*+n[la>>2]+ +n[sa+(i<<2)>>2]*+n[ma>>2]+ +n[sa+(G<<2)>>2]*+n[na>>2]);oa=oa+1|0;if((oa|0)==(w|0)){ta=T;break}else pa=sa+(H<<2)|0}}else{if(I?!(W>>>0<q>>>0&Z>>>0<r>>>0):0)ua=T;else F=17;do if((F|0)==17){F=0;if(h?(Z+3|0)<1|((Z|0)>(r|0)|((W|0)>(q|0)|(W+3|0)<1)):0){o1c(U|0,l|0,o|0)|0;ua=T;break}pa=Y(qR(X,q,a)|0,w)|0;f[m>>2]=pa;oa=qR(V,r,a)|0;na=Y(qR(W,q,a)|0,w)|0;f[J>>2]=na;ma=qR(Z,r,a)|0;la=Y(qR(W+1|0,q,a)|0,w)|0;f[K>>2]=la;ka=qR(Z+1|0,r,a)|0;ja=Y(qR(W+2|0,q,a)|0,w)|0;f[L>>2]=ja;ia=qR(Z+2|0,r,a)|0;ha=Y(oa,y)|0;ga=(oa|0)<0;fa=_+16|0;ea=Y(ma,y)|0;da=(ma|0)<0;ca=fa+16|0;ba=Y(ka,y)|0;aa=(ka|0)<0;$=ca+16|0;sa=Y(ia,y)|0;ra=(ia|0)<0;qa=$+4|0;va=$+8|0;wa=$+12|0;xa=ca+4|0;ya=ca+8|0;za=ca+12|0;Aa=fa+4|0;Ba=fa+8|0;Ca=fa+12|0;Da=_+4|0;Ea=_+8|0;Fa=_+12|0;Ga=Y(oa,y)|0;Ha=(oa|0)<0;Ia=_+16|0;Ja=Y(ma,y)|0;Ka=(ma|0)<0;La=Ia+16|0;Ma=Y(ka,y)|0;Na=(ka|0)<0;Oa=La+16|0;Pa=Y(ia,y)|0;Qa=(ia|0)<0;Ra=Oa+4|0;Sa=Oa+8|0;Ta=Oa+12|0;Oa=La+4|0;Ua=La+8|0;Va=La+12|0;La=Ia+4|0;Wa=Ia+8|0;Xa=Ia+12|0;Ia=_+4|0;Ya=_+8|0;Za=_+12|0;_a=Y(oa,y)|0;$a=(oa|0)<0;oa=_+16|0;ab=Y(ma,y)|0;bb=(ma|0)<0;ma=_+32|0;cb=Y(ka,y)|0;db=(ka|0)<0;ka=_+48|0;eb=Y(ia,y)|0;fb=(ia|0)<0;ia=ka+8|0;gb=ka+12|0;ka=ma+8|0;hb=ma+12|0;ma=oa+8|0;ib=oa+12|0;oa=_+8|0;jb=_+12|0;kb=0;lb=T;mb=pa;pa=na;na=la;la=ja;while(1){nb=+n[l+(kb<<2)>>2];ja=(pa|0)>-1;ob=(na|0)>-1;pb=(la|0)>-1;do if((mb|0)>-1){qb=lb+(ha<<2)|0;if(!ga){rb=nb+(+n[qb+(mb<<2)>>2]-nb)*+n[_>>2];if(ja)sb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[Da>>2];else sb=rb;if(ob)tb=sb+(+n[qb+(na<<2)>>2]-nb)*+n[Ea>>2];else tb=sb;if(pb)ub=tb+(+n[qb+(la<<2)>>2]-nb)*+n[Fa>>2];else ub=tb}else ub=nb;qb=lb+(ea<<2)|0;if(!da){rb=ub+(+n[qb+(mb<<2)>>2]-nb)*+n[fa>>2];if(ja)vb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[Aa>>2];else vb=rb;if(ob)wb=vb+(+n[qb+(na<<2)>>2]-nb)*+n[Ba>>2];else wb=vb;if(pb)xb=wb+(+n[qb+(la<<2)>>2]-nb)*+n[Ca>>2];else xb=wb}else xb=ub;qb=lb+(ba<<2)|0;if(!aa){rb=xb+(+n[qb+(mb<<2)>>2]-nb)*+n[ca>>2];if(ja)yb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[xa>>2];else yb=rb;if(ob)zb=yb+(+n[qb+(na<<2)>>2]-nb)*+n[ya>>2];else zb=yb;if(pb)Ab=zb+(+n[qb+(la<<2)>>2]-nb)*+n[za>>2];else Ab=zb}else Ab=xb;qb=lb+(sa<<2)|0;if(!ra){rb=Ab+(+n[qb+(mb<<2)>>2]-nb)*+n[$>>2];if(ja)Bb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[qa>>2];else Bb=rb;if(ob)Cb=Bb+(+n[qb+(na<<2)>>2]-nb)*+n[va>>2];else Cb=Bb;if(pb)Db=Cb+(+n[qb+(la<<2)>>2]-nb)*+n[wa>>2];else Db=Cb}else Db=Ab}else if(ja){qb=lb+(Ga<<2)|0;if(!Ha){rb=nb+(+n[qb+(pa<<2)>>2]-nb)*+n[Ia>>2];if(ob)Eb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Ya>>2];else Eb=rb;if(pb)Fb=Eb+(+n[qb+(la<<2)>>2]-nb)*+n[Za>>2];else Fb=Eb}else Fb=nb;qb=lb+(Ja<<2)|0;if(!Ka){rb=Fb+(+n[qb+(pa<<2)>>2]-nb)*+n[La>>2];if(ob)Gb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Wa>>2];else Gb=rb;if(pb)Hb=Gb+(+n[qb+(la<<2)>>2]-nb)*+n[Xa>>2];else Hb=Gb}else Hb=Fb;qb=lb+(Ma<<2)|0;do if(Na)Ib=Hb;else{rb=Hb+(+n[qb+(pa<<2)>>2]-nb)*+n[Oa>>2];if(ob)Jb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Ua>>2];else Jb=rb;if(!pb){Ib=Jb;break}Ib=Jb+(+n[qb+(la<<2)>>2]-nb)*+n[Va>>2]}while(0);qb=lb+(Pa<<2)|0;if(Qa){Db=Ib;break}rb=Ib+(+n[qb+(pa<<2)>>2]-nb)*+n[Ra>>2];if(ob)Kb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Sa>>2];else Kb=rb;if(!pb){Db=Kb;break}Db=Kb+(+n[qb+(la<<2)>>2]-nb)*+n[Ta>>2];break}else{qb=lb+(_a<<2)|0;if(!$a){if(ob)Lb=nb+(+n[qb+(na<<2)>>2]-nb)*+n[oa>>2];else Lb=nb;if(pb)Mb=Lb+(+n[qb+(la<<2)>>2]-nb)*+n[jb>>2];else Mb=Lb}else Mb=nb;qb=lb+(ab<<2)|0;if(!bb){if(ob)Nb=Mb+(+n[qb+(na<<2)>>2]-nb)*+n[ma>>2];else Nb=Mb;if(pb)Ob=Nb+(+n[qb+(la<<2)>>2]-nb)*+n[ib>>2];else Ob=Nb}else Ob=Mb;qb=lb+(cb<<2)|0;do if(db)Pb=Ob;else{if(ob)Qb=Ob+(+n[qb+(na<<2)>>2]-nb)*+n[ka>>2];else Qb=Ob;if(!pb){Pb=Qb;break}Pb=Qb+(+n[qb+(la<<2)>>2]-nb)*+n[hb>>2]}while(0);qb=lb+(eb<<2)|0;if(fb){Db=Pb;break}if(ob)Rb=Pb+(+n[qb+(na<<2)>>2]-nb)*+n[ia>>2];else Rb=Pb;if(!pb){Db=Rb;break}Db=Rb+(+n[qb+(la<<2)>>2]-nb)*+n[gb>>2];break}while(0);n[R+(kb<<2)>>2]=Db;pb=kb+1|0;if((pb|0)==(w|0))break;kb=pb;lb=lb+4|0;mb=f[m>>2]|0;pa=f[J>>2]|0;na=f[K>>2]|0;la=f[L>>2]|0}ua=T+(w<<2)+(M<<2)|0}while(0);ta=ua}S=S+1|0;if((S|0)==(C|0)){Sb=ta;break}else{R=R+(w<<2)|0;T=ta}}}else Sb=N;v=v+1|0;if((v|0)==(D|0))break;else N=Sb}u=k;return}function Eaa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+4128|0;l=k;m=k+4112|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<3)+((Y(aa,x)|0)<<3)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<3)|0;wa=da+(z<<3)|0;xa=wa+(z<<3)|0;p[V+(ua<<3)>>3]=+p[va>>3]*ea+ +p[va+(x<<3)>>3]*fa+ +p[va+(i<<3)>>3]*ga+ +p[va+(H<<3)>>3]*ha+(+p[da>>3]*ia+ +p[da+(x<<3)>>3]*ja+ +p[da+(i<<3)>>3]*ka+ +p[da+(H<<3)>>3]*la)+(+p[wa>>3]*ma+ +p[wa+(x<<3)>>3]*na+ +p[wa+(i<<3)>>3]*oa+ +p[wa+(H<<3)>>3]*pa)+(+p[xa>>3]*qa+ +p[xa+(x<<3)>>3]*ra+ +p[xa+(i<<3)>>3]*sa+ +p[xa+(H<<3)>>3]*ta);ua=ua+1|0;if((ua|0)==(x|0)){ya=X;break}else va=xa+(I<<3)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)za=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){o1c(Z|0,l|0,q|0)|0;za=X;break}va=Y(qR(aa,r,a)|0,x)|0;f[m>>2]=va;ua=qR(_,s,a)|0;f[o>>2]=ua;xa=Y(qR($,r,a)|0,x)|0;f[K>>2]=xa;wa=qR(ba,s,a)|0;f[w>>2]=wa;da=Y(qR($+1|0,r,a)|0,x)|0;f[L>>2]=da;Aa=qR(ba+1|0,s,a)|0;f[O>>2]=Aa;Ba=Y(qR($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=qR(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(wa,z)|0;Ha=(wa|0)<0;Ia=Fa+16|0;Ja=Y(Aa,z)|0;Ka=(Aa|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(wa,z)|0;_a=(wa|0)<0;wa=ca+32|0;$a=Y(Aa,z)|0;ab=(Aa|0)<0;Aa=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=Aa+8|0;db=Aa+12|0;Aa=wa+8|0;eb=wa+12|0;wa=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=da;da=Ba;while(1){ta=+p[l+(hb<<3)>>3];Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(da|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<3)|0;if(!Ea){sa=ta+(+p[mb+(va<<3)>>3]-ta)*+n[Fa>>2];if(kb)nb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Va>>2];else nb=sa;if(lb)ob=nb+(+p[mb+(da<<3)>>3]-ta)*+n[Wa>>2];else ob=nb}else ob=ta;mb=ib+(Ga<<3)|0;if(!Ha){sa=ob+(+p[mb+(va<<3)>>3]-ta)*+n[Ia>>2];if(kb)pb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ta>>2];else pb=sa;if(lb)qb=pb+(+p[mb+(da<<3)>>3]-ta)*+n[Ua>>2];else qb=pb}else qb=ob;mb=ib+(Ja<<3)|0;do if(Ka)rb=qb;else{sa=qb+(+p[mb+(va<<3)>>3]-ta)*+n[La>>2];if(kb)sb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ra>>2];else sb=sa;if(!lb){rb=sb;break}rb=sb+(+p[mb+(da<<3)>>3]-ta)*+n[Sa>>2]}while(0);mb=ib+(Ma<<3)|0;if(Na){tb=rb;break}sa=rb+(+p[mb+(va<<3)>>3]-ta)*+n[Oa>>2];if(kb)ub=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Pa>>2];else ub=sa;if(!lb){tb=ub;break}tb=ub+(+p[mb+(da<<3)>>3]-ta)*+n[Qa>>2];break}else{mb=ib+(Xa<<3)|0;if(!Ya){if(kb)vb=ta+(+p[mb+(xa<<3)>>3]-ta)*+n[ua>>2];else vb=ta;if(lb)wb=vb+(+p[mb+(da<<3)>>3]-ta)*+n[gb>>2];else wb=vb}else wb=ta;mb=ib+(Za<<3)|0;if(!_a){if(kb)xb=wb+(+p[mb+(xa<<3)>>3]-ta)*+n[wa>>2];else xb=wb;if(lb)yb=xb+(+p[mb+(da<<3)>>3]-ta)*+n[fb>>2];else yb=xb}else yb=wb;mb=ib+($a<<3)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+(+p[mb+(xa<<3)>>3]-ta)*+n[Aa>>2];else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+(+p[mb+(da<<3)>>3]-ta)*+n[eb>>2]}while(0);mb=ib+(bb<<3)|0;if(cb){tb=zb;break}if(kb)Bb=zb+(+p[mb+(xa<<3)>>3]-ta)*+n[Ca>>2];else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+(+p[mb+(da<<3)>>3]-ta)*+n[db>>2];break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<3)|0;if((Db|0)>=0){ra=sa+(+p[Eb+(jb<<3)>>3]-ta)*+n[Cb>>2];if(Ba)Fb=ra+(+p[Eb+(va<<3)>>3]-ta)*+n[Cb+4>>2];else Fb=ra;if(kb)Gb=Fb+(+p[Eb+(xa<<3)>>3]-ta)*+n[Cb+8>>2];else Gb=Fb;if(lb)Hb=Gb+(+p[Eb+(da<<3)>>3]-ta)*+n[Cb+12>>2];else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);p[V+(hb<<3)>>3]=tb;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+8|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;da=f[M>>2]|0}za=X+(x<<3)+(N<<3)|0}while(0);ya=za}W=W+1|0;if((W|0)==(D|0)){Ib=ya;break}else{V=V+(x<<3)|0;X=ya}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Faa(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;m=u;u=u+528|0;n=m+16|0;o=m;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=zLc(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=r+-1|0;l=(a|0)>0?a:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){C=$Xc(16)|0;f[o>>2]=C;f[o+8>>2]=-2147483632;f[o+4>>2]=14;D=C;E=267376;F=D+14|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[C+14>>0]=0;vM(-215,o,252023,251587,666)}if((v|0)<=0){u=m;return}o=c+16|0;C=c+44|0;c=e+16|0;E=e+44|0;e=g+16|0;D=g+44|0;g=(t|0)<0;F=(k|0)==5;G=F&(x|0)!=3;H=(w|0)==0;w=(k|0)==0;I=(k|0)==1;J=q&65535;q=z+1|0;K=z+2|0;L=z+3|0;M=z+4|0;N=z+5|0;O=z+6|0;P=z+7|0;Q=0;do{R=(f[c>>2]|0)+(Y(f[f[E>>2]>>2]|0,Q)|0)|0;S=(f[e>>2]|0)+(Y(f[f[D>>2]>>2]|0,Q)|0)|0;if(!g){T=(f[o>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;U=0;V=0;W=0;while(1){do if((W|0)<(t|0)){X=W<<1;if((d[R+(X<<1)>>1]|0)>>>0>=l>>>0)if(V){Z=18;break}else{_=T;$=W;aa=U;ba=0;break}else{ca=(d[R+((X|1)<<1)>>1]|0)>>>0<B>>>0;Z=16;break}}else{ca=V^1;Z=16}while(0);do if((Z|0)==16){Z=0;if(V^ca)if(ca){if(G){_=T+(Y(W-U|0,x)|0)|0;$=W;aa=W;ba=1;break}X=(W|0)>(U|0);if(H){if(!X){_=T;$=U;aa=W;ba=1;break}da=W-U|0;ea=U;fa=T;while(1){ga=ea<<1;ha=d[R+(ga<<1)>>1]|0;ia=ha<<16>>16;ja=d[R+((ga|1)<<1)>>1]|0;ga=ja<<16>>16;do if(w)if(ja<<16>>16<-1|ha<<16>>16>-2&(ia|0)<(r|0)&(ga|0)<(s|0)^1){ka=b[n>>0]|0;break}else{la=i+(j[S+(ea<<1)>>1]<<2<<1)|0;Z=49;break}else{ma=i+(j[S+(ea<<1)>>1]<<2<<1)|0;if(I){na=ha<<16>>16>-1?((ia|0)<(r|0)?ia:a):0;oa=ia+1|0;pa=ha<<16>>16>-2?((oa|0)<(r|0)?oa:a):0;oa=ga+1|0;qa=Y(ja<<16>>16>-1?((ga|0)<(s|0)?ga:A):0,z)|0;ra=Y(ja<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0;sa=y+(ra+pa)|0;ta=y+(ra+na)|0;ua=y+(qa+pa)|0;va=y+(qa+na)|0;wa=ma;Z=50}else{la=ma;Z=49}}while(0);if((Z|0)==49){Z=0;ja=qR(ia,r,k)|0;ha=qR(ia+1|0,r,k)|0;ma=qR(ga,s,k)|0;na=qR(ga+1|0,s,k)|0;qa=Y(ma,z)|0;pa=Y(na,z)|0;sa=(na|ha|0)>-1?y+(pa+ha)|0:n;ta=(na|ja|0)>-1?y+(pa+ja)|0:n;ua=(ma|ha|0)>-1?y+(qa+ha)|0:n;va=(ma|ja|0)>-1?y+(qa+ja)|0:n;wa=la;Z=50}if((Z|0)==50){Z=0;ja=Y(d[wa>>1]|0,h[va>>0]|0)|0;qa=Y(d[wa+2>>1]|0,h[ua>>0]|0)|0;ma=Y(d[wa+4>>1]|0,h[ta>>0]|0)|0;ha=ja+16384+qa+ma+(Y(d[wa+6>>1]|0,h[sa>>0]|0)|0)>>15;ka=(ha>>>0<256?ha:(ha|0)>0?255:0)&255}b[fa>>0]=ka;ea=ea+1|0;if((ea|0)==(W|0))break;else fa=fa+1|0}_=T+da|0;$=W;aa=W;ba=1;break}if(X){fa=Y(x,W+-1-U|0)|0;ea=U;ha=T;while(1){ma=ea<<1;qa=d[R+(ma<<1)>>1]|0;ja=qa<<16>>16;pa=d[R+((ma|1)<<1)>>1]|0;ma=pa<<16>>16;do if(w)if(pa<<16>>16<-1|qa<<16>>16>-2&(ja|0)<(r|0)&(ma|0)<(s|0)^1){na=0;do{b[ha+na>>0]=b[n+na>>0]|0;na=na+1|0}while((na|0)!=(x|0))}else{xa=i+(j[S+(ea<<1)>>1]<<2<<1)|0;Z=58;break}else{na=i+(j[S+(ea<<1)>>1]<<2<<1)|0;if(I){ra=ja+1|0;oa=ma+1|0;ya=y+(Y(pa<<16>>16>-1?((ma|0)<(s|0)?ma:A):0,z)|0)|0;za=Y(qa<<16>>16>-1?((ja|0)<(r|0)?ja:a):0,x)|0;Aa=Y(qa<<16>>16>-2?((ra|0)<(r|0)?ra:a):0,x)|0;ra=y+(Y(pa<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0)|0;Ba=ra+Aa|0;Ca=ra+za|0;Da=ya+Aa|0;Ea=ya+za|0;Fa=na;Z=61}else{xa=na;Z=58}}while(0);do if((Z|0)==58){Z=0;if(F?!(ja>>>0<a>>>0&ma>>>0<A>>>0):0)break;pa=qR(ja,r,k)|0;qa=qR(ja+1|0,r,k)|0;ga=qR(ma,s,k)|0;ia=qR(ma+1|0,s,k)|0;na=y+(Y(ga,z)|0)|0;za=Y(pa,x)|0;ya=Y(qa,x)|0;Aa=y+(Y(ia,z)|0)|0;Ba=(ia|qa|0)>-1?Aa+ya|0:n;Ca=(ia|pa|0)>-1?Aa+za|0:n;Da=(ga|qa|0)>-1?na+ya|0:n;Ea=(ga|pa|0)>-1?na+za|0:n;Fa=xa;Z=61}while(0);if((Z|0)==61){Z=0;ma=Fa+2|0;ja=Fa+4|0;za=Fa+6|0;na=0;do{pa=Y(d[Fa>>1]|0,h[Ea+na>>0]|0)|0;ga=Y(d[ma>>1]|0,h[Da+na>>0]|0)|0;ya=Y(d[ja>>1]|0,h[Ca+na>>0]|0)|0;qa=pa+16384+ga+ya+(Y(d[za>>1]|0,h[Ba+na>>0]|0)|0)>>15;b[ha+na>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;na=na+1|0}while((na|0)!=(x|0))}ea=ea+1|0;if((ea|0)==(W|0))break;else ha=ha+x|0}_=T+x+fa|0;$=W;aa=W;ba=1}else{_=T;$=U;aa=W;ba=1}}else Z=18;else{_=T;$=W;aa=U;ba=V}}while(0);a:do if((Z|0)==18){Z=0;switch(J&511){case 0:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ha=W-U|0;ea=T;X=U;while(1){da=X<<1;na=i+(j[S+(X<<1)>>1]<<2<<1)|0;za=y+(Y(d[R+((da|1)<<1)>>1]|0,z)|0)+(d[R+(da<<1)>>1]|0)|0;da=Y(d[na>>1]|0,h[za>>0]|0)|0;ja=Y(d[na+2>>1]|0,h[za+1>>0]|0)|0;ma=Y(d[na+4>>1]|0,h[za+z>>0]|0)|0;qa=da+16384+ja+ma+(Y(d[na+6>>1]|0,h[za+q>>0]|0)|0)>>15;b[ea>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;X=X+1|0;if((X|0)==(W|0))break;else ea=ea+1|0}_=T+ha|0;$=W;aa=W;ba=0;break a;break}case 1:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ea=W-U<<1;X=T;fa=U;while(1){qa=fa<<1;za=i+(j[S+(fa<<1)>>1]<<2<<1)|0;na=y+(Y(d[R+((qa|1)<<1)>>1]|0,z)|0)+(d[R+(qa<<1)>>1]<<1)|0;qa=d[za>>1]|0;ma=Y(qa,h[na>>0]|0)|0;ja=d[za+2>>1]|0;da=Y(ja,h[na+2>>0]|0)|0;ya=d[za+4>>1]|0;ga=Y(ya,h[na+z>>0]|0)|0;pa=d[za+6>>1]|0;za=Y(pa,h[na+K>>0]|0)|0;Aa=Y(h[na+1>>0]|0,qa)|0;qa=Y(h[na+3>>0]|0,ja)|0;ja=Y(h[na+q>>0]|0,ya)|0;ya=Y(h[na+L>>0]|0,pa)|0;pa=ma+16384+da+ga+za>>15;b[X>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;pa=Aa+16384+qa+ja+ya>>15;b[X+1>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;fa=fa+1|0;if((fa|0)==(W|0))break;else X=X+2|0}_=T+ea|0;$=W;aa=W;ba=0;break a;break}case 2:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}X=(W-U|0)*3|0;fa=T;ha=U;while(1){pa=ha<<1;ya=i+(j[S+(ha<<1)>>1]<<2<<1)|0;ja=y+(Y(d[R+((pa|1)<<1)>>1]|0,z)|0)+((d[R+(pa<<1)>>1]|0)*3|0)|0;pa=d[ya>>1]|0;qa=Y(pa,h[ja>>0]|0)|0;Aa=d[ya+2>>1]|0;za=Y(Aa,h[ja+3>>0]|0)|0;ga=d[ya+4>>1]|0;da=Y(ga,h[ja+z>>0]|0)|0;ma=d[ya+6>>1]|0;ya=Y(ma,h[ja+L>>0]|0)|0;na=Y(h[ja+1>>0]|0,pa)|0;ia=Y(h[ja+4>>0]|0,Aa)|0;ra=Y(h[ja+q>>0]|0,ga)|0;oa=Y(h[ja+M>>0]|0,ma)|0;Ga=Y(h[ja+2>>0]|0,pa)|0;pa=Y(h[ja+5>>0]|0,Aa)|0;Aa=Y(h[ja+K>>0]|0,ga)|0;ga=Y(h[ja+N>>0]|0,ma)|0;ma=qa+16384+za+da+ya>>15;b[fa>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=na+16384+ia+ra+oa>>15;b[fa+1>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=Ga+16384+pa+Aa+ga>>15;b[fa+2>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ha=ha+1|0;if((ha|0)==(W|0))break;else fa=fa+3|0}_=T+X|0;$=W;aa=W;ba=0;break a;break}case 3:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}fa=W-U<<2;ha=U;ea=T;while(1){ma=ha<<1;ga=i+(j[S+(ha<<1)>>1]<<2<<1)|0;Aa=y+(Y(d[R+((ma|1)<<1)>>1]|0,z)|0)+(d[R+(ma<<1)>>1]<<2)|0;ma=d[ga>>1]|0;pa=Y(ma,h[Aa>>0]|0)|0;Ga=ga+2|0;oa=d[Ga>>1]|0;ra=Y(oa,h[Aa+4>>0]|0)|0;ia=ga+4|0;na=d[ia>>1]|0;ya=Y(na,h[Aa+z>>0]|0)|0;da=ga+6|0;za=d[da>>1]|0;qa=Y(za,h[Aa+M>>0]|0)|0;ja=Y(h[Aa+1>>0]|0,ma)|0;ma=Y(h[Aa+5>>0]|0,oa)|0;oa=Y(h[Aa+q>>0]|0,na)|0;na=Y(h[Aa+N>>0]|0,za)|0;za=pa+16384+ra+ya+qa>>15;b[ea>>0]=za>>>0<256?za:(za|0)>0?255:0;za=ja+16384+ma+oa+na>>15;b[ea+1>>0]=za>>>0<256?za:(za|0)>0?255:0;za=d[ga>>1]|0;ga=Y(za,h[Aa+2>>0]|0)|0;na=d[Ga>>1]|0;Ga=Y(na,h[Aa+6>>0]|0)|0;oa=d[ia>>1]|0;ia=Y(oa,h[Aa+K>>0]|0)|0;ma=d[da>>1]|0;da=Y(ma,h[Aa+O>>0]|0)|0;ja=Y(h[Aa+3>>0]|0,za)|0;za=Y(h[Aa+7>>0]|0,na)|0;na=Y(h[Aa+L>>0]|0,oa)|0;oa=Y(h[Aa+P>>0]|0,ma)|0;ma=ga+16384+Ga+ia+da>>15;b[ea+2>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=ja+16384+za+na+oa>>15;b[ea+3>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ha=ha+1|0;if((ha|0)==(W|0))break;else ea=ea+4|0}_=T+fa|0;$=W;aa=W;ba=0;break a;break}default:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ea=Y(x,W+-1-U|0)|0;ha=U;X=T;while(1){ma=ha<<1;oa=i+(j[S+(ha<<1)>>1]<<2<<1)|0;na=y+(Y(d[R+((ma|1)<<1)>>1]|0,z)|0)+(Y(d[R+(ma<<1)>>1]|0,x)|0)|0;ma=oa+2|0;za=oa+4|0;ja=oa+6|0;da=0;do{ia=Y(d[oa>>1]|0,h[na+da>>0]|0)|0;Ga=Y(d[ma>>1]|0,h[na+(da+x)>>0]|0)|0;ga=da+z|0;Aa=Y(d[za>>1]|0,h[na+ga>>0]|0)|0;qa=ia+16384+Ga+Aa+(Y(d[ja>>1]|0,h[na+(ga+x)>>0]|0)|0)>>15;b[X+da>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;da=da+1|0}while((da|0)!=(x|0));ha=ha+1|0;if((ha|0)==(W|0))break;else X=X+x|0}_=T+x+ea|0;$=W;aa=W;ba=0;break a}}}while(0);if(($|0)<(t|0)){T=_;U=aa;V=ba;W=$+1|0}else break}}Q=Q+1|0}while((Q|0)!=(v|0));u=m;return}function Gaa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+16|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=zLc(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){C=$Xc(16)|0;f[o>>2]=C;f[o+8>>2]=-2147483632;f[o+4>>2]=14;D=C;E=267376;F=D+14|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[C+14>>0]=0;vM(-215,o,252023,251587,666)}if((v|0)<=0){u=l;return}o=c+16|0;C=c+44|0;c=e+16|0;E=e+44|0;e=g+16|0;D=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<1)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<1)|0;ua=d[y+(sa+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(ra+oa<<1)>>1]|0;xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=qR(ja,r,i)|0;ia=qR(ja+1|0,r,i)|0;na=qR(ha,s,i)|0;oa=qR(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;ra=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((oa|ka|0)>-1)Aa=y+((Y(oa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((oa|ia|0)<=-1){ta=m;ua=ka;va=na;wa=ra;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<1)|0;ua=ka;va=na;wa=ra;xa=ma;_=57}while(0);if((_|0)==57){_=0;ha=ALc(+(wa&65535)*+n[xa>>2]+ +(va&65535)*+n[xa+4>>2]+ +(ua&65535)*+n[xa+8>>2]+ +(j[ta>>1]|0)*+n[xa+12>>2])|0;la=(ha>>>0<65536?ha:(ha|0)>0?65535:0)&65535}d[ga>>1]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+2|0}$=U+(ea<<1)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ra=d[S+(ja<<1)>>1]|0;na=ra<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ra<<16>>16>-2&(na|0)<(r|0)&(ja|0)<(s|0)^1){ia=0;do{d[ha+(ia<<1)>>1]=d[m+(ia<<1)>>1]|0;ia=ia+1|0}while((ia|0)!=(x|0))}else{Ba=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{ia=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=na+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ra<<16>>16>-1?((na|0)<(r|0)?na:z):0,x)|0;Ca=Y(ra<<16>>16>-2?((oa|0)<(r|0)?oa:z):0,x)|0;oa=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<1)|0;Da=oa+(Ca<<1)|0;Ea=oa+(pa<<1)|0;Fa=sa+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=ia;_=75}else{Ba=ia;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(na>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=qR(na,r,i)|0;ra=qR(na+1|0,r,i)|0;ia=qR(ja,s,i)|0;pa=qR(ja+1|0,s,i)|0;if((ia|ka|0)>-1)Ia=y+((Y(ia,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((ia|ra|0)>-1)Ja=y+((Y(ia,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;else Ja=m;if((pa|ka|0)>-1)Ka=y+((Y(pa,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((pa|ra|0)<=-1){Da=m;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75;break}Da=y+((Y(pa,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75}while(0);if((_|0)==75){_=0;La=+n[Ha>>2];Ma=+n[Ha+4>>2];Na=+n[Ha+8>>2];Oa=+n[Ha+12>>2];ja=0;do{na=ALc(+(j[Ga+(ja<<1)>>1]|0)*La+ +(j[Fa+(ja<<1)>>1]|0)*Ma+ +(j[Ea+(ja<<1)>>1]|0)*Na+ +(j[Da+(ja<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=na>>>0<65536?na:(na|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<1)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=ALc(+(j[na>>1]|0)*+n[ja>>2]+ +(j[na+2>>1]|0)*+n[ja+4>>2]+ +(j[na+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(j[na+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[fa>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+2|0}$=U+(ha<<1)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ea=ga<<1;ja=h+(j[T+(ga<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(j[na+2>>1]|0)+Na*+(j[na+6>>1]|0)+Ma*+(j[na+(q<<1)>>1]|0)+La*+(j[na+(M<<1)>>1]|0);ja=ALc(+(j[na>>1]|0)*Oa+ +(j[na+4>>1]|0)*Na+ +(j[na+(a<<1)>>1]|0)*Ma+ +(j[na+(L<<1)>>1]|0)*La)|0;d[Z>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;ja=ALc(Pa)|0;d[Z+2>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+4|0}$=U+(fa<<1)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ja=ha<<1;na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[na>>2];La=+n[na+4>>2];Ma=+n[na+8>>2];Na=+n[na+12>>2];Oa=Pa*+(j[ea+2>>1]|0)+La*+(j[ea+8>>1]|0)+Ma*+(j[ea+(q<<1)>>1]|0)+Na*+(j[ea+(N<<1)>>1]|0);Qa=Pa*+(j[ea+4>>1]|0)+La*+(j[ea+10>>1]|0)+Ma*+(j[ea+(L<<1)>>1]|0)+Na*+(j[ea+(O<<1)>>1]|0);na=ALc(+(j[ea>>1]|0)*Pa+ +(j[ea+6>>1]|0)*La+ +(j[ea+(a<<1)>>1]|0)*Ma+ +(j[ea+(M<<1)>>1]|0)*Na)|0;d[ga>>1]=na>>>0<65536?na:(na|0)>0?65535:0;na=ALc(Oa)|0;d[ga+2>>1]=na>>>0<65536?na:(na|0)>0?65535:0;na=ALc(Qa)|0;d[ga+4>>1]=na>>>0<65536?na:(na|0)>0?65535:0;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+6|0}$=U+(Z<<1)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){na=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((na|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(na<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(j[ja+2>>1]|0)+Oa*+(j[ja+10>>1]|0)+Na*+(j[ja+(q<<1)>>1]|0)+Ma*+(j[ja+(O<<1)>>1]|0);ea=ALc(+(j[ja>>1]|0)*Qa+ +(j[ja+8>>1]|0)*Oa+ +(j[ja+(a<<1)>>1]|0)*Na+ +(j[ja+(N<<1)>>1]|0)*Ma)|0;d[fa>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=ALc(La)|0;d[fa+2>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;La=Qa*+(j[ja+6>>1]|0)+Oa*+(j[ja+14>>1]|0)+Na*+(j[ja+(M<<1)>>1]|0)+Ma*+(j[ja+(Q<<1)>>1]|0);ea=ALc(+(j[ja+4>>1]|0)*Qa+ +(j[ja+12>>1]|0)*Oa+ +(j[ja+(L<<1)>>1]|0)*Na+ +(j[ja+(P<<1)>>1]|0)*Ma)|0;d[fa+4>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=ALc(La)|0;d[fa+6>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+8|0}$=U+(ga<<1)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ra=ALc(+(j[na+(ja<<1)>>1]|0)*La+ +(j[na+(ja+x<<1)>>1]|0)*Ma+ +(j[na+(ea<<1)>>1]|0)*Na+ +(j[na+(ea+x<<1)>>1]|0)*Oa)|0;d[Z+(ja<<1)>>1]=ra>>>0<65536?ra:(ra|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<1)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Haa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+16|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=zLc(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){C=$Xc(16)|0;f[o>>2]=C;f[o+8>>2]=-2147483632;f[o+4>>2]=14;D=C;E=267376;F=D+14|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[C+14>>0]=0;vM(-215,o,252023,251587,666)}if((v|0)<=0){u=l;return}o=c+16|0;C=c+44|0;c=e+16|0;E=e+44|0;e=g+16|0;D=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<1)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<1)|0;ua=d[y+(sa+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(ra+oa<<1)>>1]|0;xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=qR(ja,r,i)|0;ia=qR(ja+1|0,r,i)|0;na=qR(ha,s,i)|0;oa=qR(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;ra=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((oa|ka|0)>-1)Aa=y+((Y(oa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((oa|ia|0)<=-1){ta=m;ua=ka;va=na;wa=ra;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<1)|0;ua=ka;va=na;wa=ra;xa=ma;_=57}while(0);if((_|0)==57){_=0;ha=ALc(+(wa<<16>>16)*+n[xa>>2]+ +(va<<16>>16)*+n[xa+4>>2]+ +(ua<<16>>16)*+n[xa+8>>2]+ +(d[ta>>1]|0)*+n[xa+12>>2])|0;la=((ha+32768|0)>>>0<65536?ha:(ha|0)>0?32767:32768)&65535}d[ga>>1]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+2|0}$=U+(ea<<1)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ra=d[S+(ja<<1)>>1]|0;na=ra<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ra<<16>>16>-2&(na|0)<(r|0)&(ja|0)<(s|0)^1){ia=0;do{d[ha+(ia<<1)>>1]=d[m+(ia<<1)>>1]|0;ia=ia+1|0}while((ia|0)!=(x|0))}else{Ba=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{ia=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=na+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ra<<16>>16>-1?((na|0)<(r|0)?na:z):0,x)|0;Ca=Y(ra<<16>>16>-2?((oa|0)<(r|0)?oa:z):0,x)|0;oa=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<1)|0;Da=oa+(Ca<<1)|0;Ea=oa+(pa<<1)|0;Fa=sa+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=ia;_=75}else{Ba=ia;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(na>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=qR(na,r,i)|0;ra=qR(na+1|0,r,i)|0;ia=qR(ja,s,i)|0;pa=qR(ja+1|0,s,i)|0;if((ia|ka|0)>-1)Ia=y+((Y(ia,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((ia|ra|0)>-1)Ja=y+((Y(ia,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;else Ja=m;if((pa|ka|0)>-1)Ka=y+((Y(pa,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((pa|ra|0)<=-1){Da=m;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75;break}Da=y+((Y(pa,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75}while(0);if((_|0)==75){_=0;La=+n[Ha>>2];Ma=+n[Ha+4>>2];Na=+n[Ha+8>>2];Oa=+n[Ha+12>>2];ja=0;do{na=ALc(+(d[Ga+(ja<<1)>>1]|0)*La+ +(d[Fa+(ja<<1)>>1]|0)*Ma+ +(d[Ea+(ja<<1)>>1]|0)*Na+ +(d[Da+(ja<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<1)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=ALc(+(d[na>>1]|0)*+n[ja>>2]+ +(d[na+2>>1]|0)*+n[ja+4>>2]+ +(d[na+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(d[na+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[fa>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+2|0}$=U+(ha<<1)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ea=ga<<1;ja=h+(j[T+(ga<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(d[na+2>>1]|0)+Na*+(d[na+6>>1]|0)+Ma*+(d[na+(q<<1)>>1]|0)+La*+(d[na+(M<<1)>>1]|0);ja=ALc(+(d[na>>1]|0)*Oa+ +(d[na+4>>1]|0)*Na+ +(d[na+(a<<1)>>1]|0)*Ma+ +(d[na+(L<<1)>>1]|0)*La)|0;d[Z>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;ja=ALc(Pa)|0;d[Z+2>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+4|0}$=U+(fa<<1)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ja=ha<<1;na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[na>>2];La=+n[na+4>>2];Ma=+n[na+8>>2];Na=+n[na+12>>2];Oa=Pa*+(d[ea+2>>1]|0)+La*+(d[ea+8>>1]|0)+Ma*+(d[ea+(q<<1)>>1]|0)+Na*+(d[ea+(N<<1)>>1]|0);Qa=Pa*+(d[ea+4>>1]|0)+La*+(d[ea+10>>1]|0)+Ma*+(d[ea+(L<<1)>>1]|0)+Na*+(d[ea+(O<<1)>>1]|0);na=ALc(+(d[ea>>1]|0)*Pa+ +(d[ea+6>>1]|0)*La+ +(d[ea+(a<<1)>>1]|0)*Ma+ +(d[ea+(M<<1)>>1]|0)*Na)|0;d[ga>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;na=ALc(Oa)|0;d[ga+2>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;na=ALc(Qa)|0;d[ga+4>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+6|0}$=U+(Z<<1)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){na=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((na|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(na<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(d[ja+2>>1]|0)+Oa*+(d[ja+10>>1]|0)+Na*+(d[ja+(q<<1)>>1]|0)+Ma*+(d[ja+(O<<1)>>1]|0);ea=ALc(+(d[ja>>1]|0)*Qa+ +(d[ja+8>>1]|0)*Oa+ +(d[ja+(a<<1)>>1]|0)*Na+ +(d[ja+(N<<1)>>1]|0)*Ma)|0;d[fa>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=ALc(La)|0;d[fa+2>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;La=Qa*+(d[ja+6>>1]|0)+Oa*+(d[ja+14>>1]|0)+Na*+(d[ja+(M<<1)>>1]|0)+Ma*+(d[ja+(Q<<1)>>1]|0);ea=ALc(+(d[ja+4>>1]|0)*Qa+ +(d[ja+12>>1]|0)*Oa+ +(d[ja+(L<<1)>>1]|0)*Na+ +(d[ja+(P<<1)>>1]|0)*Ma)|0;d[fa+4>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=ALc(La)|0;d[fa+6>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+8|0}$=U+(ga<<1)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ra=ALc(+(d[na+(ja<<1)>>1]|0)*La+ +(d[na+(ja+x<<1)>>1]|0)*Ma+ +(d[na+(ea<<1)>>1]|0)*Na+ +(d[na+(ea+x<<1)>>1]|0)*Oa)|0;d[Z+(ja<<1)>>1]=(ra+32768|0)>>>0<65536?ra:(ra|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<1)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Iaa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+2064|0;m=l+16|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{n[m+(a<<2)>>2]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>2;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){C=$Xc(16)|0;f[o>>2]=C;f[o+8>>2]=-2147483632;f[o+4>>2]=14;D=C;E=267376;F=D+14|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[C+14>>0]=0;vM(-215,o,252023,251587,666)}if((v|0)<=0){u=l;return}o=c+16|0;C=c+44|0;c=e+16|0;E=e+44|0;e=g+16|0;D=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<2)+4|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<2)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+n[m>>2];break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<2)|0;ua=+n[y+(sa+oa<<2)>>2];va=+n[y+(ra+qa<<2)>>2];wa=+n[y+(ra+oa<<2)>>2];xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=qR(ja,r,i)|0;ia=qR(ja+1|0,r,i)|0;na=qR(ha,s,i)|0;oa=qR(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<2)|0;else ya=m;za=+n[ya>>2];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<2)|0;else Aa=m;Ba=+n[Aa>>2];if((oa|ka|0)>-1)Ca=y+((Y(oa,a)|0)+ka<<2)|0;else Ca=m;Da=+n[Ca>>2];if((oa|ia|0)<=-1){ta=m;ua=Da;va=Ba;wa=za;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<2)|0;ua=Da;va=Ba;wa=za;xa=ma;_=57}while(0);if((_|0)==57){_=0;la=wa*+n[xa>>2]+va*+n[xa+4>>2]+ua*+n[xa+8>>2]+ +n[ta>>2]*+n[xa+12>>2]}n[ga>>2]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+4|0}$=U+(ea<<2)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<2)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ia=d[S+(ja<<1)>>1]|0;oa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(oa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{f[ha+(na<<2)>>2]=f[m+(na<<2)>>2];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){ra=oa+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<2)|0;pa=Y(ia<<16>>16>-1?((oa|0)<(r|0)?oa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((ra|0)<(r|0)?ra:z):0,x)|0;ra=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<2)|0;Ga=ra+(Fa<<2)|0;Ha=ra+(pa<<2)|0;Ia=sa+(Fa<<2)|0;Ja=sa+(pa<<2)|0;Ka=na;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(oa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=qR(oa,r,i)|0;ia=qR(oa+1|0,r,i)|0;na=qR(ja,s,i)|0;pa=qR(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;else Ma=m;if((pa|ka|0)>-1)Na=y+((Y(pa,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else Na=m;if((pa|ia|0)<=-1){Ga=m;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75;break}Ga=y+((Y(pa,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75}while(0);if((_|0)==75){_=0;ja=Ka+4|0;oa=Ka+8|0;ia=Ka+12|0;pa=0;do{n[ha+(pa<<2)>>2]=+n[Ja+(pa<<2)>>2]*+n[Ka>>2]+ +n[Ia+(pa<<2)>>2]*+n[ja>>2]+ +n[Ha+(pa<<2)>>2]*+n[oa>>2]+ +n[Ga+(pa<<2)>>2]*+n[ia>>2];pa=pa+1|0}while((pa|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<2)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;pa=h+(j[T+(Z<<1)>>1]<<2<<2)|0;ia=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(ea<<1)>>1]<<2)|0;n[fa>>2]=+n[ia>>2]*+n[pa>>2]+ +n[ia+4>>2]*+n[pa+4>>2]+ +n[ia+(a<<2)>>2]*+n[pa+8>>2]+ +n[ia+(q<<2)>>2]*+n[pa+12>>2];Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+4|0}$=U+(ha<<2)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){pa=ga<<1;ia=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((pa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(pa<<1)>>1]<<1<<2)|0;za=+n[ia>>2];Ba=+n[ia+4>>2];Da=+n[ia+8>>2];Oa=+n[ia+12>>2];Pa=za*+n[ea+4>>2]+Ba*+n[ea+12>>2]+Da*+n[ea+(q<<2)>>2]+Oa*+n[ea+(M<<2)>>2];n[Z>>2]=+n[ea>>2]*za+ +n[ea+8>>2]*Ba+ +n[ea+(a<<2)>>2]*Da+ +n[ea+(L<<2)>>2]*Oa;n[Z+4>>2]=Pa;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+8|0}$=U+(fa<<2)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ea=ha<<1;ia=h+(j[T+(ha<<1)>>1]<<2<<2)|0;pa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((d[S+(ea<<1)>>1]|0)*3<<2)|0;Pa=+n[ia>>2];Oa=+n[ia+4>>2];Da=+n[ia+8>>2];Ba=+n[ia+12>>2];za=Pa*+n[pa+4>>2]+Oa*+n[pa+16>>2]+Da*+n[pa+(q<<2)>>2]+Ba*+n[pa+(N<<2)>>2];Qa=Pa*+n[pa+8>>2]+Oa*+n[pa+20>>2]+Da*+n[pa+(L<<2)>>2]+Ba*+n[pa+(O<<2)>>2];n[ga>>2]=+n[pa>>2]*Pa+ +n[pa+12>>2]*Oa+ +n[pa+(a<<2)>>2]*Da+ +n[pa+(M<<2)>>2]*Ba;n[ga+4>>2]=za;n[ga+8>>2]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+12|0}$=U+(Z<<2)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){pa=ha<<1;ia=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((pa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(pa<<1)>>1]<<2<<2)|0;Qa=+n[ia>>2];pa=ia+4|0;za=+n[pa>>2];oa=ia+8|0;Ba=+n[oa>>2];ja=ia+12|0;Da=+n[ja>>2];Oa=Qa*+n[ea+4>>2]+za*+n[ea+20>>2]+Ba*+n[ea+(q<<2)>>2]+Da*+n[ea+(O<<2)>>2];n[fa>>2]=+n[ea>>2]*Qa+ +n[ea+16>>2]*za+ +n[ea+(a<<2)>>2]*Ba+ +n[ea+(N<<2)>>2]*Da;n[fa+4>>2]=Oa;Oa=+n[ia>>2];Da=+n[pa>>2];Ba=+n[oa>>2];za=+n[ja>>2];Qa=Oa*+n[ea+12>>2]+Da*+n[ea+28>>2]+Ba*+n[ea+(M<<2)>>2]+za*+n[ea+(Q<<2)>>2];n[fa+8>>2]=+n[ea+8>>2]*Oa+ +n[ea+24>>2]*Da+ +n[ea+(L<<2)>>2]*Ba+ +n[ea+(P<<2)>>2]*za;n[fa+12>>2]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+16|0}$=U+(ga<<2)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<2)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;oa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<2)|0;ea=ja+4|0;pa=ja+8|0;ia=ja+12|0;ka=0;do{na=ka+a|0;n[Z+(ka<<2)>>2]=+n[oa+(ka<<2)>>2]*+n[ja>>2]+ +n[oa+(ka+x<<2)>>2]*+n[ea>>2]+ +n[oa+(na<<2)>>2]*+n[pa>>2]+ +n[oa+(na+x<<2)>>2]*+n[ia>>2];ka=ka+1|0}while((ka|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<2)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Jaa(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+4112|0;m=l;o=l+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{p[m+(a<<3)>>3]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>3;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((r|0)<1|(s|0)<1){C=$Xc(16)|0;f[o>>2]=C;f[o+8>>2]=-2147483632;f[o+4>>2]=14;D=C;E=267376;F=D+14|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[C+14>>0]=0;vM(-215,o,252023,251587,666)}if((v|0)<=0){u=l;return}o=c+16|0;C=c+44|0;c=e+16|0;E=e+44|0;e=g+16|0;D=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<3)+8|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<3)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+p[m>>3];break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<3)|0;ua=+p[y+(sa+oa<<3)>>3];va=+p[y+(ra+qa<<3)>>3];wa=+p[y+(ra+oa<<3)>>3];xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=qR(ja,r,i)|0;ia=qR(ja+1|0,r,i)|0;na=qR(ha,s,i)|0;oa=qR(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<3)|0;else ya=m;za=+p[ya>>3];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<3)|0;else Aa=m;Ba=+p[Aa>>3];if((oa|ka|0)>-1)Ca=y+((Y(oa,a)|0)+ka<<3)|0;else Ca=m;Da=+p[Ca>>3];if((oa|ia|0)<=-1){ta=m;ua=Da;va=Ba;wa=za;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<3)|0;ua=Da;va=Ba;wa=za;xa=ma;_=57}while(0);if((_|0)==57){_=0;la=wa*+n[xa>>2]+va*+n[xa+4>>2]+ua*+n[xa+8>>2]+ +p[ta>>3]*+n[xa+12>>2]}p[ga>>3]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+8|0}$=U+(ea<<3)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<3)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ia=d[S+(ja<<1)>>1]|0;oa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(oa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{p[ha+(na<<3)>>3]=+p[m+(na<<3)>>3];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){ra=oa+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<3)|0;pa=Y(ia<<16>>16>-1?((oa|0)<(r|0)?oa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((ra|0)<(r|0)?ra:z):0,x)|0;ra=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<3)|0;Ga=ra+(Fa<<3)|0;Ha=ra+(pa<<3)|0;Ia=sa+(Fa<<3)|0;Ja=sa+(pa<<3)|0;Ka=na;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(oa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=qR(oa,r,i)|0;ia=qR(oa+1|0,r,i)|0;na=qR(ja,s,i)|0;pa=qR(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;else Ma=m;if((pa|ka|0)>-1)Na=y+((Y(pa,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else Na=m;if((pa|ia|0)<=-1){Ga=m;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75;break}Ga=y+((Y(pa,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75}while(0);if((_|0)==75){_=0;za=+n[Ka>>2];Ba=+n[Ka+4>>2];Da=+n[Ka+8>>2];Oa=+n[Ka+12>>2];ja=0;do{p[ha+(ja<<3)>>3]=+p[Ja+(ja<<3)>>3]*za+ +p[Ia+(ja<<3)>>3]*Ba+ +p[Ha+(ja<<3)>>3]*Da+ +p[Ga+(ja<<3)>>3]*Oa;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<3)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;oa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ea<<1)>>1]<<3)|0;p[fa>>3]=+p[oa>>3]*+n[ja>>2]+ +p[oa+8>>3]*+n[ja+4>>2]+ +p[oa+(a<<3)>>3]*+n[ja+8>>2]+ +p[oa+(q<<3)>>3]*+n[ja+12>>2];Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+8|0}$=U+(ha<<3)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ja=ga<<1;oa=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<1<<3)|0;Oa=+n[oa>>2];Da=+n[oa+4>>2];Ba=+n[oa+8>>2];za=+n[oa+12>>2];Pa=Oa*+p[ea+8>>3]+Da*+p[ea+24>>3]+Ba*+p[ea+(q<<3)>>3]+za*+p[ea+(M<<3)>>3];p[Z>>3]=+p[ea>>3]*Oa+ +p[ea+16>>3]*Da+ +p[ea+(a<<3)>>3]*Ba+ +p[ea+(L<<3)>>3]*za;p[Z+8>>3]=Pa;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+16|0}$=U+(fa<<3)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ea=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((d[S+(ea<<1)>>1]|0)*3<<3)|0;Pa=+n[oa>>2];za=+n[oa+4>>2];Ba=+n[oa+8>>2];Da=+n[oa+12>>2];Oa=Pa*+p[ja+8>>3]+za*+p[ja+32>>3]+Ba*+p[ja+(q<<3)>>3]+Da*+p[ja+(N<<3)>>3];Qa=Pa*+p[ja+16>>3]+za*+p[ja+40>>3]+Ba*+p[ja+(L<<3)>>3]+Da*+p[ja+(O<<3)>>3];p[ga>>3]=+p[ja>>3]*Pa+ +p[ja+24>>3]*za+ +p[ja+(a<<3)>>3]*Ba+ +p[ja+(M<<3)>>3]*Da;p[ga+8>>3]=Oa;p[ga+16>>3]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+24|0}$=U+(Z<<3)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){ja=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<2<<3)|0;Qa=+n[oa>>2];Oa=+n[oa+4>>2];Da=+n[oa+8>>2];Ba=+n[oa+12>>2];za=Qa*+p[ea+8>>3]+Oa*+p[ea+40>>3]+Da*+p[ea+(q<<3)>>3]+Ba*+p[ea+(O<<3)>>3];p[fa>>3]=+p[ea>>3]*Qa+ +p[ea+32>>3]*Oa+ +p[ea+(a<<3)>>3]*Da+ +p[ea+(N<<3)>>3]*Ba;p[fa+8>>3]=za;za=Qa*+p[ea+24>>3]+Oa*+p[ea+56>>3]+Da*+p[ea+(M<<3)>>3]+Ba*+p[ea+(Q<<3)>>3];p[fa+16>>3]=+p[ea+16>>3]*Qa+ +p[ea+48>>3]*Oa+ +p[ea+(L<<3)>>3]*Da+ +p[ea+(P<<3)>>3]*Ba;p[fa+24>>3]=za;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+32|0}$=U+(ga<<3)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<3)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<3)|0;za=+n[oa>>2];Ba=+n[oa+4>>2];Da=+n[oa+8>>2];Oa=+n[oa+12>>2];oa=0;do{ea=oa+a|0;p[Z+(oa<<3)>>3]=+p[ja+(oa<<3)>>3]*za+ +p[ja+(oa+x<<3)>>3]*Ba+ +p[ja+(ea<<3)>>3]*Da+ +p[ja+(ea+x<<3)>>3]*Oa;oa=oa+1|0}while((oa|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<3)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Kaa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=zLc(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(m|0)?F:a):0;K=G<<16>>16>-1?((H|0)<(l|0)?H:h):0}H=r+((Y(J,s)|0)+K)|0;b[C+E>>0]=b[H>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;H=r+((Y(F,s)|0)+G)|0;b[C+E>>0]=b[(G>>>0<l>>>0&F>>>0<m>>>0?H:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{H=E<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;if(!(F>>>0<l>>>0&G>>>0<m>>>0)){if(!A){H=qR(F,l,g)|0;L=H;M=qR(G,m,g)|0;y=28}}else{L=F;M=G;y=28}if((y|0)==28){y=0;G=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[G>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=0;G=C;while(1){F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(H>>>0<l>>>0&I>>>0<m>>>0){F=r+(Y(I,s)|0)|0;if(t){N=F+(H*3|0)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;b[G+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[G+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(v|0))break a;else G=G+q|0}}else{O=0;P=C}while(1){G=O<<1;E=d[D+(G<<1)>>1]|0;H=E<<16>>16;I=d[D+((G|1)<<1)>>1]|0;G=I<<16>>16;b:do if(H>>>0<l>>>0&G>>>0<m>>>0){F=r+(Y(G,s)|0)|0;if(t){N=F+(H*3|0)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;b[P+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[P+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(I<<16>>16>-1?((G|0)<(m|0)?G:a):0,s)|0)+(Y(E<<16>>16>-1?((H|0)<(l|0)?H:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{F=qR(H,l,g)|0;Q=r+(Y(qR(G,m,g)|0,s)|0)+(Y(F,q)|0)|0}}F=0;do{b[P+F>>0]=b[Q+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);O=O+1|0;if((O|0)==(v|0))break;else P=P+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function Laa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=zLc(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(m|0)?F:a):0;K=G<<16>>16>-1?((H|0)<(l|0)?H:h):0}H=r+((Y(J,s)|0)+K)|0;b[C+E>>0]=b[H>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;H=r+((Y(F,s)|0)+G)|0;b[C+E>>0]=b[(G>>>0<l>>>0&F>>>0<m>>>0?H:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{H=E<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;if(!(F>>>0<l>>>0&G>>>0<m>>>0)){if(!A){H=qR(F,l,g)|0;L=H;M=qR(G,m,g)|0;y=28}}else{L=F;M=G;y=28}if((y|0)==28){y=0;G=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[G>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=0;G=C;while(1){F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(H>>>0<l>>>0&I>>>0<m>>>0){F=r+(Y(I,s)|0)|0;if(t){N=F+(H*3|0)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;b[G+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[G+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(v|0))break a;else G=G+q|0}}else{O=0;P=C}while(1){G=O<<1;E=d[D+(G<<1)>>1]|0;H=E<<16>>16;I=d[D+((G|1)<<1)>>1]|0;G=I<<16>>16;b:do if(H>>>0<l>>>0&G>>>0<m>>>0){F=r+(Y(G,s)|0)|0;if(t){N=F+(H*3|0)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;b[P+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[P+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(I<<16>>16>-1?((G|0)<(m|0)?G:a):0,s)|0)+(Y(E<<16>>16>-1?((H|0)<(l|0)?H:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{F=qR(H,l,g)|0;Q=r+(Y(qR(G,m,g)|0,s)|0)+(Y(F,q)|0)|0}}F=0;do{b[P+F>>0]=b[Q+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);O=O+1|0;if((O|0)==(v|0))break;else P=P+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function Maa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=zLc(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=qR(E,k,e)|0;L=F;M=qR(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;d[G+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[G+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<1)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;d[P+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[P+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<1)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{E=qR(F,k,e)|0;Q=q+((Y(qR(G,l,e)|0,a)|0)<<1)+((Y(E,o)|0)<<1)|0}}E=0;do{d[P+(E<<1)>>1]=d[Q+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Naa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=zLc(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=qR(E,k,e)|0;L=F;M=qR(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;d[G+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[G+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<1)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;d[P+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[P+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<1)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{E=qR(F,k,e)|0;Q=q+((Y(qR(G,l,e)|0,a)|0)<<1)+((Y(E,o)|0)<<1)|0}}E=0;do{d[P+(E<<1)>>1]=d[Q+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Oaa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=zLc(+p[g+((a&3)<<3)>>3])|0;f[i+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(o|0));a=r>>>2;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<2)|0;f[B+(D<<2)>>2]=f[G>>2];D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<2)|0;else K=i;f[B+(D<<2)>>2]=f[K>>2];D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=qR(E,k,e)|0;L=F;M=qR(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<2)|0;f[B+(D<<2)>>2]=f[G>>2]}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<2)|0;if(s){N=E+(F*3<<2)|0;f[G>>2]=f[N>>2];f[G+4>>2]=f[N+4>>2];f[G+8>>2]=f[N+8>>2];break}if(y){N=E+(F<<2<<2)|0;f[G>>2]=f[N>>2];f[G+4>>2]=f[N+4>>2];f[G+8>>2]=f[N+8>>2];f[G+12>>2]=f[N+12>>2];break}N=E+((Y(F,o)|0)<<2)|0;E=0;do{f[G+(E<<2)>>2]=f[N+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<2)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<2)|0;if(s){N=E+(F*3<<2)|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];break}if(y){N=E+(F<<2<<2)|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];break}N=E+((Y(F,o)|0)<<2)|0;E=0;do{f[P+(E<<2)>>2]=f[N+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<2)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<2)|0;break}case 0:{Q=i;break}default:{E=qR(F,k,e)|0;Q=q+((Y(qR(G,l,e)|0,a)|0)<<2)+((Y(E,o)|0)<<2)|0}}E=0;do{f[P+(E<<2)>>2]=f[Q+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<2)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Paa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;o=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;q=j+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{n[i+(a<<2)>>2]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(q|0));a=s>>>2;if(f[b>>2]&16384){s=(f[c>>2]&16384|0)!=0;g=Y(s?o:1,m)|0;if(s){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((o|0)>0){t=w;v=o}else{u=h;return}o=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;s=l+-1|0;y=(q|0)==3;z=(q|0)==4;A=(e|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[w>>2]>>2]|0,B)|0)|0;D=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,B)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<k>>>0&F>>>0<l>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(l|0)?F:s):0;K=G<<16>>16>-1?((H|0)<(k|0)?H:g):0}H=r+((Y(J,a)|0)+K<<2)|0;f[C+(E<<2)>>2]=f[H>>2];E=E+1|0}while((E|0)!=(t|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;if(G>>>0<k>>>0&F>>>0<l>>>0)L=r+((Y(F,a)|0)+G<<2)|0;else L=i;f[C+(E<<2)>>2]=f[L>>2];E=E+1|0}while((E|0)!=(t|0));break}default:{E=0;do{G=E<<1;F=d[D+(G<<1)>>1]|0;H=d[D+((G|1)<<1)>>1]|0;if(!(F>>>0<k>>>0&H>>>0<l>>>0)){if(!A){G=qR(F,k,e)|0;M=G;N=qR(H,l,e)|0;x=30}}else{M=F;N=H;x=30}if((x|0)==30){x=0;H=r+((Y(N,a)|0)+M<<2)|0;f[C+(E<<2)>>2]=f[H>>2]}E=E+1|0}while((E|0)!=(t|0))}}}else if(j){if(A){E=0;H=C;while(1){F=E<<1;G=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(G>>>0<k>>>0&I>>>0<l>>>0){F=r+((Y(I,a)|0)<<2)|0;if(y){O=F+(G*3<<2)|0;f[H>>2]=f[O>>2];f[H+4>>2]=f[O+4>>2];f[H+8>>2]=f[O+8>>2];break}if(z){O=F+(G<<2<<2)|0;f[H>>2]=f[O>>2];f[H+4>>2]=f[O+4>>2];f[H+8>>2]=f[O+8>>2];f[H+12>>2]=f[O+12>>2];break}O=F+((Y(G,q)|0)<<2)|0;F=0;do{f[H+(F<<2)>>2]=f[O+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(t|0))break a;else H=H+(q<<2)|0}}else{P=0;Q=C}while(1){H=P<<1;E=d[D+(H<<1)>>1]|0;G=E<<16>>16;I=d[D+((H|1)<<1)>>1]|0;H=I<<16>>16;b:do if(G>>>0<k>>>0&H>>>0<l>>>0){F=r+((Y(H,a)|0)<<2)|0;if(y){O=F+(G*3<<2)|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2];f[Q+8>>2]=f[O+8>>2];break}if(z){O=F+(G<<2<<2)|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2];f[Q+8>>2]=f[O+8>>2];f[Q+12>>2]=f[O+12>>2];break}O=F+((Y(G,q)|0)<<2)|0;F=0;do{f[Q+(F<<2)>>2]=f[O+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}else{switch(e|0){case 5:{break b;break}case 1:{R=r+((Y(I<<16>>16>-1?((H|0)<(l|0)?H:s):0,a)|0)<<2)+((Y(E<<16>>16>-1?((G|0)<(k|0)?G:g):0,q)|0)<<2)|0;break}case 0:{R=i;break}default:{F=qR(G,k,e)|0;R=r+((Y(qR(H,l,e)|0,a)|0)<<2)+((Y(F,q)|0)<<2)|0}}F=0;do{f[Q+(F<<2)>>2]=f[R+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}while(0);P=P+1|0;if((P|0)==(t|0))break;else Q=Q+(q<<2)|0}}while(0);B=B+1|0}while((B|0)!=(v|0));u=h;return}function Qaa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+4096|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{p[i+(a<<3)>>3]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(o|0));a=r>>>3;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){s=g;t=1}else{v=g;w=5}}else{v=m;w=5}if((w|0)==5)if((n|0)>0){s=v;t=n}else{u=h;return}n=b+16|0;v=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(s|0)>0;g=k+-1|0;r=l+-1|0;x=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[v>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<3)|0;p[B+(D<<3)>>3]=+p[G>>3];D=D+1|0}while((D|0)!=(s|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<3)|0;else K=i;p[B+(D<<3)>>3]=+p[K>>3];D=D+1|0}while((D|0)!=(s|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=qR(E,k,e)|0;L=F;M=qR(G,l,e)|0;w=30}}else{L=E;M=G;w=30}if((w|0)==30){w=0;G=q+((Y(M,a)|0)+L<<3)|0;p[B+(D<<3)>>3]=+p[G>>3]}D=D+1|0}while((D|0)!=(s|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<3)|0;if(x){N=E+(F*3<<3)|0;p[G>>3]=+p[N>>3];p[G+8>>3]=+p[N+8>>3];p[G+16>>3]=+p[N+16>>3];break}if(y){N=E+(F<<2<<3)|0;p[G>>3]=+p[N>>3];p[G+8>>3]=+p[N+8>>3];p[G+16>>3]=+p[N+16>>3];p[G+24>>3]=+p[N+24>>3];break}N=E+((Y(F,o)|0)<<3)|0;E=0;do{p[G+(E<<3)>>3]=+p[N+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(s|0))break a;else G=G+(o<<3)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<3)|0;if(x){N=E+(F*3<<3)|0;p[P>>3]=+p[N>>3];p[P+8>>3]=+p[N+8>>3];p[P+16>>3]=+p[N+16>>3];break}if(y){N=E+(F<<2<<3)|0;p[P>>3]=+p[N>>3];p[P+8>>3]=+p[N+8>>3];p[P+16>>3]=+p[N+16>>3];p[P+24>>3]=+p[N+24>>3];break}N=E+((Y(F,o)|0)<<3)|0;E=0;do{p[P+(E<<3)>>3]=+p[N+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<3)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<3)|0;break}case 0:{Q=i;break}default:{E=qR(F,k,e)|0;Q=q+((Y(qR(G,l,e)|0,a)|0)<<3)+((Y(E,o)|0)<<3)|0}}E=0;do{p[P+(E<<3)>>3]=+p[Q+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(s|0))break;else P=P+(o<<3)|0}}while(0);A=A+1|0}while((A|0)!=(t|0));u=h;return}function Raa(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0;o=u;u=u+1408|0;q=o+1352|0;r=o+1288|0;s=o+1296|0;t=o+208|0;v=o+224|0;w=o+216|0;x=o+32|0;y=o;f[r>>2]=d;f[r+4>>2]=e;cM(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;cM(s,t,a,g,h);h=s+12|0;g=f[h>>2]|0;a=g<<1;t=v+8|0;f[v>>2]=t;j=v+4|0;f[j>>2]=a;if(a>>>0>264){i=bYc(a>>>0>1073741823?-1:a<<2)|0;f[v>>2]=i;z=i}else z=t;i=z+(g<<2)|0;if((g|0)>0){A=+p[k>>3];B=+p[k+24>>3];g=f[h>>2]|0;a=0;do{C=+(a|0);c=zLc(C*A*1024.0)|0;f[z+(a<<2)>>2]=c;c=zLc(C*B*1024.0)|0;f[i+(a<<2)>>2]=c;a=a+1|0}while((a|0)<(g|0))}g=s+8|0;a=f[g>>2]|0;f[w>>2]=0;f[w+4>>2]=a;B=+p[n+8>>3];A=+p[n+16>>3];C=+p[n+24>>3];p[y>>3]=+p[n>>3];p[y+8>>3]=B;p[y+16>>3]=A;p[y+24>>3]=C;Saa(x,q,s,l,m,y,z,i,k);k=s+4|0;i=f[k>>2]|0;if((i|0)<3)D=Y(f[h>>2]|0,f[g>>2]|0)|0;else{g=f[s+40>>2]|0;h=0;z=1;while(1){y=Y(f[g+(h<<2)>>2]|0,z)|0;h=h+1|0;if((h|0)==(i|0)){D=y;break}else z=y}}h3(w,x,+(D>>>0)*.0000152587890625);Taa(x);x=f[v>>2]|0;if((x|0)!=(t|0)){if(x|0)dYc(x);f[v>>2]=t;f[j>>2]=264}j=s+36|0;t=f[j>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)V$(s);f[j>>2]=0;j=s+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[s+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}k=f[s+44>>2]|0;if((k|0)!=(s+48|0))wL(k);k=q+36|0;s=f[k>>2]|0;if(s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)V$(q);f[k>>2]=0;k=q+16|0;s=q+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[q+40>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}wL(s);u=o;return}function Saa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;f[a>>2]=49316;k=a+4|0;f[k>>2]=f[b>>2];l=a+8|0;m=b+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;q=a+48|0;f[q>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[b+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;U$(k,b)}b=a+60|0;f[b>>2]=f[c>>2];k=a+64|0;l=c+4|0;f[k>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;q=a+104|0;f[q>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[c+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}else{f[k>>2]=0;U$(b,c);r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}}function Taa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49316;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Uaa(a){a=a|0;Taa(a);cYc(a);return}function Vaa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;c=u;u=u+24912|0;e=c+8520|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+116|0;r=(f[q>>2]|0)==0?512:16;s=a+60|0;t=f[a+68>>2]|0;v=4096/(((t|0)<32?t:32)|0)|0;w=a+72|0;x=f[w>>2]|0;y=(x|0)<(v|0)?x:v;v=4096/(y|0)|0;x=(t|0)<(v|0)?t:v;v=f[b>>2]|0;t=b+4|0;if((v|0)>=(f[t>>2]|0)){u=c;return}b=h+4|0;z=h+8|0;A=h+12|0;B=h+16|0;C=h+20|0;D=h+24|0;E=h+28|0;F=h+40|0;G=h+48|0;H=h+44|0;I=h+52|0;J=i+4|0;K=i+8|0;L=i+40|0;M=i+48|0;N=i+44|0;O=i+52|0;P=k+4|0;Q=k+8|0;R=k+12|0;S=a+4|0;T=k+8|0;U=k+12|0;V=k+4|0;W=l+8|0;X=l+4|0;Z=m+8|0;_=m+12|0;$=m+4|0;aa=o+4|0;ba=o+8|0;ca=o+40|0;da=o+48|0;ea=o+44|0;fa=o+52|0;ga=n+8|0;ha=n+12|0;ia=n+4|0;ja=a+120|0;ka=a+128|0;la=o+36|0;ma=o+16|0;na=j+36|0;oa=j+16|0;pa=j+4|0;qa=j+40|0;ra=j+44|0;sa=j+48|0;ta=i+36|0;ua=i+16|0;va=h+36|0;wa=k+4|0;xa=k+8|0;ya=k+12|0;za=k+16|0;Aa=k+20|0;Ba=k+24|0;Ca=k+28|0;Da=k+40|0;Ea=k+48|0;Fa=k+44|0;Ga=k+52|0;Ha=l+8|0;Ia=l+12|0;Ja=l+4|0;Ka=m+8|0;La=m+4|0;Ma=n+8|0;Na=n+12|0;Oa=n+4|0;Pa=o+8|0;Qa=o+12|0;Ra=o+4|0;Sa=k+36|0;Ta=a+168|0;Ua=a+160|0;Va=a+164|0;a=D+8|0;Wa=Ba+8|0;Xa=v;v=f[w>>2]|0;while(1){if((v|0)>0){Ya=0;Za=v;while(1){_a=Za-Ya|0;$a=(_a|0)<(y|0)?_a:y;_a=(f[t>>2]|0)-Xa|0;ab=(_a|0)<(x|0)?_a:x;f[h>>2]=1124007947;f[b>>2]=2;f[z>>2]=ab;f[A>>2]=$a;f[B>>2]=e;f[C>>2]=e;_a=a;f[_a>>2]=0;f[_a+4>>2]=0;f[F>>2]=z;f[H>>2]=G;_a=$a<<2;f[G>>2]=_a;f[I>>2]=4;bb=e+(Y(ab,_a)|0)|0;f[E>>2]=bb;f[D>>2]=bb+(0-_a)+_a;R$(h);f[i>>2]=1124007936;_a=J;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[L>>2]=K;f[N>>2]=M;f[M>>2]=0;f[O>>2]=0;f[k>>2]=Ya;f[P>>2]=Xa;f[Q>>2]=$a;f[R>>2]=ab;Z$(j,s,k);if((ab|0)>0){cb=f[Ta>>2]|0;db=+p[cb+8>>3];eb=+p[cb+16>>3];fb=+p[cb+32>>3];gb=+p[cb+40>>3];cb=f[q>>2]|0;hb=(cb|0)==0;ib=($a|0)>0;jb=0;do{kb=Y(jb,$a)|0;lb=e+(kb<<1<<1)|0;mb=+(jb+Xa|0);nb=(zLc((mb*db+eb)*1024.0)|0)+r|0;ob=(zLc((mb*fb+gb)*1024.0)|0)+r|0;if(hb){if(ib){pb=f[Ua>>2]|0;qb=f[Va>>2]|0;rb=0;do{sb=rb+Ya|0;tb=(f[pb+(sb<<2)>>2]|0)+nb>>10;ub=(f[qb+(sb<<2)>>2]|0)+ob>>10;sb=rb<<1;d[lb+(sb<<1)>>1]=(tb+32768|0)>>>0<65536?tb:(tb|0)>0?32767:32768;d[lb+((sb|1)<<1)>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;rb=rb+1|0}while((rb|0)<($a|0))}}else{rb=g+(kb<<1)|0;if(ib){qb=f[Ua>>2]|0;pb=f[Va>>2]|0;ub=0;do{sb=ub+Ya|0;tb=(f[qb+(sb<<2)>>2]|0)+nb|0;vb=(f[pb+(sb<<2)>>2]|0)+ob|0;sb=tb>>10;wb=ub<<1;d[lb+(wb<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;sb=vb>>10;d[lb+((wb|1)<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;d[rb+(ub<<1)>>1]=vb&992|tb>>>5&31;ub=ub+1|0}while((ub|0)<($a|0))}}jb=jb+1|0}while((jb|0)<(ab|0));xb=cb}else xb=f[q>>2]|0;if(!xb){f[T>>2]=0;f[U>>2]=0;f[k>>2]=16842752;f[V>>2]=S;cb=W;f[cb>>2]=0;f[cb+4>>2]=0;f[l>>2]=33619968;f[X>>2]=j;f[Z>>2]=0;f[_>>2]=0;f[m>>2]=16842752;f[$>>2]=h;f[o>>2]=1124007936;_a=aa;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[ca>>2]=ba;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[ha>>2]=0;f[n>>2]=16842752;f[ia>>2]=o;saa(k,l,m,n,0,f[ja>>2]|0,ka);_a=f[la>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)V$(o);f[la>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[aa>>2]|0)>0){_a=f[ca>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[aa>>2]|0))}bb=f[ea>>2]|0;if((bb|0)!=(da|0))wL(bb)}else{f[k>>2]=1124007938;f[wa>>2]=2;f[xa>>2]=ab;f[ya>>2]=$a;f[za>>2]=g;f[Aa>>2]=g;bb=Wa;f[bb>>2]=0;f[bb+4>>2]=0;f[Da>>2]=xa;f[Fa>>2]=Ea;bb=$a<<1;f[Ea>>2]=bb;f[Ga>>2]=2;_a=g+((Y(ab,$a)|0)<<1)|0;f[Ca>>2]=_a;f[Ba>>2]=_a+(0-bb)+bb;R$(k);f[Ha>>2]=0;f[Ia>>2]=0;f[l>>2]=16842752;f[Ja>>2]=S;bb=Ka;f[bb>>2]=0;f[bb+4>>2]=0;f[m>>2]=33619968;f[La>>2]=j;f[Ma>>2]=0;f[Na>>2]=0;f[n>>2]=16842752;f[Oa>>2]=h;f[Pa>>2]=0;f[Qa>>2]=0;f[o>>2]=16842752;f[Ra>>2]=k;saa(l,m,n,o,f[q>>2]|0,f[ja>>2]|0,ka);bb=f[Sa>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)V$(k);f[Sa>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[wa>>2]|0)>0){bb=f[Da>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[wa>>2]|0))}_a=f[Fa>>2]|0;if((_a|0)!=(Ea|0))wL(_a)}_a=f[na>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)V$(j);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[pa>>2]|0)>0){_a=f[qa>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[pa>>2]|0))}bb=f[ra>>2]|0;if((bb|0)!=(sa|0))wL(bb);bb=f[ta>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)V$(i);f[ta>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[J>>2]|0)>0){bb=f[L>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[J>>2]|0))}_a=f[N>>2]|0;if((_a|0)!=(M|0))wL(_a);_a=f[va>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)V$(h);f[va>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[b>>2]|0)>0){_a=f[F>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[b>>2]|0))}bb=f[H>>2]|0;if((bb|0)!=(G|0))wL(bb);Ya=Ya+y|0;bb=f[w>>2]|0;if((bb|0)<=(Ya|0)){yb=bb;break}else Za=bb}}else yb=v;Xa=Xa+x|0;if((Xa|0)>=(f[t>>2]|0))break;else v=yb}u=c;return}function Waa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0;j=u;u=u+304|0;k=j;l=j+240|0;m=j+176|0;n=j+232|0;o=j+120|0;q=j+64|0;r=j+48|0;s=g&7;a:do if((rS(a,-1)|0)>=5){switch(g&7){case 2:case 4:break;default:break a}t=$Xc(96)|0;f[k>>2]=t;f[k+8>>2]=-2147483552;f[k+4>>2]=89;v=t;w=252062;x=v+89|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+89>>0]=0;vM(-215,k,252152,251587,2597)}while(0);do if((eS(a)|0)==65536){y=f[a+4>>2]|0;f[l>>2]=f[y>>2];z=l+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=l+8|0;f[B>>2]=f[y+8>>2];f[l+12>>2]=f[y+12>>2];f[l+16>>2]=f[y+16>>2];f[l+20>>2]=f[y+20>>2];f[l+24>>2]=f[y+24>>2];f[l+28>>2]=f[y+28>>2];f[l+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[l+36>>2]=C;f[l+40>>2]=B;B=l+48|0;D=l+44|0;f[D>>2]=B;f[B>>2]=0;f[l+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;U$(l,y);break}}else bS(l,a,-1);while(0);do if((eS(d)|0)==65536){a=f[d+4>>2]|0;f[m>>2]=f[a>>2];y=m+4|0;z=a+4|0;f[y>>2]=f[z>>2];A=m+8|0;f[A>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=A;A=m+48|0;D=m+44|0;f[D>>2]=A;f[A>>2]=0;f[m+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;U$(m,a);break}}else bS(m,d,-1);while(0);d=f[e>>2]|0;if((d|0)>=1?(a=f[e+4>>2]|0,(a|0)>=1):0){E=a;F=d}else{d=f[l+40>>2]|0;E=f[d>>2]|0;F=f[d+4>>2]|0}f[n>>2]=F;f[n+4>>2]=E;wS(c,n,f[l>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){n=f[c+4>>2]|0;f[o>>2]=f[n>>2];E=o+4|0;F=n+4|0;f[E>>2]=f[F>>2];d=o+8|0;f[d>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];f[o+16>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];a=f[n+36>>2]|0;f[o+36>>2]=a;f[o+40>>2]=d;d=o+48|0;e=o+44|0;f[e>>2]=d;f[d>>2]=0;f[o+52>>2]=0;if(a|0){d=a+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[F>>2]|0)<3){F=f[n+44>>2]|0;d=f[e>>2]|0;f[d>>2]=f[F>>2];f[d+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;U$(o,n);break}}else bS(o,c,-1);while(0);c=l+12|0;if((f[c>>2]|0)<=0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;G=$Xc(32)|0;f[k>>2]=G;H=k+8|0;f[H>>2]=-2147483616;I=k+4|0;f[I>>2]=28;v=G;w=252163;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));J=G+28|0;b[J>>0]=0;vM(-215,k,252152,251587,2611)}n=l+8|0;if((f[n>>2]|0)<=0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;G=$Xc(32)|0;f[k>>2]=G;H=k+8|0;f[H>>2]=-2147483616;I=k+4|0;f[I>>2]=28;v=G;w=252163;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));J=G+28|0;b[J>>0]=0;vM(-215,k,252152,251587,2611)}J=o+16|0;G=l+16|0;if((f[J>>2]|0)==(f[G>>2]|0)){f[q>>2]=1124007936;I=q+4|0;H=q+8|0;E=q+40|0;v=I;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[E>>2]=H;F=q+48|0;f[q+44>>2]=F;f[F>>2]=0;f[q+52>>2]=0;d=k+8|0;f[d>>2]=0;f[d+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;jR(l,k);d=l+36|0;e=f[d>>2]|0;if(e|0?(a=e+12|0,e=f[a>>2]|0,f[a>>2]=e+-1,(e|0)==1):0)V$(l);f[d>>2]=0;e=l+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[e>>2]|0)>0){a=f[l+40>>2]|0;y=0;do{f[a+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[e>>2]|0))}f[l>>2]=f[q>>2];y=f[I>>2]|0;f[e>>2]=y;f[n>>2]=f[H>>2];f[c>>2]=f[q+12>>2];e=q+16|0;f[G>>2]=f[e>>2];f[l+20>>2]=f[q+20>>2];f[l+24>>2]=f[q+24>>2];f[l+28>>2]=f[q+28>>2];f[l+32>>2]=f[q+32>>2];a=q+36|0;f[d>>2]=f[a>>2];d=l+44|0;z=f[d>>2]|0;A=l+48|0;if((z|0)==(A|0))K=y;else{wL(z);f[d>>2]=A;f[l+40>>2]=n;K=f[I>>2]|0}z=q+44|0;if((K|0)<3){K=f[z>>2]|0;f[A>>2]=f[K>>2];f[l+52>>2]=f[K+4>>2];L=K}else{f[d>>2]=f[z>>2];f[l+40>>2]=f[E>>2];f[z>>2]=F;f[E>>2]=H;L=F}f[q>>2]=1124007936;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[I+16>>2]=0;f[I+20>>2]=0;f[I+24>>2]=0;f[I+28>>2]=0;f[a>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((L|0)!=(F|0))wL(L)}v=k;x=v+48|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[q>>2]=1124007942;L=q+4|0;f[L>>2]=2;F=q+8|0;f[F>>2]=2;f[q+12>>2]=3;e=q+16|0;f[e>>2]=k;f[q+20>>2]=k;a=q+24|0;I=q+40|0;H=a+8|0;f[H>>2]=0;f[H+4>>2]=0;f[I>>2]=F;F=q+48|0;H=q+44|0;f[H>>2]=F;f[F>>2]=24;f[q+52>>2]=8;f[q+28>>2]=k+48;f[a>>2]=k+48;R$(q);a=(s|0)==3?1:s;if(((f[m>>2]&4095)+-5|0)>>>0>=2){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;M=$Xc(80)|0;f[r>>2]=M;N=r+8|0;f[N>>2]=-2147483568;O=r+4|0;f[O>>2]=76;v=M;w=252192;x=v+76|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));P=M+76|0;b[P>>0]=0;vM(-215,r,252152,251587,2620)}if((f[m+8>>2]|0)!=2){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;M=$Xc(80)|0;f[r>>2]=M;N=r+8|0;f[N>>2]=-2147483568;O=r+4|0;f[O>>2]=76;v=M;w=252192;x=v+76|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));P=M+76|0;b[P>>0]=0;vM(-215,r,252152,251587,2620)}if((f[m+12>>2]|0)!=3){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;M=$Xc(80)|0;f[r>>2]=M;N=r+8|0;f[N>>2]=-2147483568;O=r+4|0;f[O>>2]=76;v=M;w=252192;x=v+76|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));P=M+76|0;b[P>>0]=0;vM(-215,r,252152,251587,2620)}P=r+8|0;f[P>>2]=0;f[P+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=q;dY(m,r,f[q>>2]&4095,1.0,0.0);if(!(g&16)){Q=+p[k>>3];g=k+32|0;R=+p[g>>3];r=k+8|0;S=+p[r>>3];P=k+24|0;T=+p[P>>3];U=Q*R-S*T;V=U!=0.0?1.0/U:0.0;U=R*V;R=Q*V;p[k>>3]=U;Q=-V;V=S*Q;p[r>>3]=V;S=T*Q;p[P>>3]=S;p[g>>3]=R;g=k+16|0;Q=+p[g>>3];P=k+40|0;T=+p[P>>3];p[g>>3]=-(U*Q)-V*T;p[P>>3]=-(Q*S)-R*T}P=l+48|0;g=o+48|0;Raa(f[l>>2]&4095,f[G>>2]|0,f[P>>2]|0,f[c>>2]|0,f[n>>2]|0,f[J>>2]|0,f[g>>2]|0,f[o+12>>2]|0,f[o+8>>2]|0,k,a,h,i);i=q+36|0;h=f[i>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)V$(q);f[i>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[L>>2]|0)>0){e=f[I>>2]|0;I=0;do{f[e+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[L>>2]|0))}L=f[H>>2]|0;if((L|0)!=(F|0))wL(L);L=o+36|0;F=f[L>>2]|0;if(F|0?(H=F+12|0,F=f[H>>2]|0,f[H>>2]=F+-1,(F|0)==1):0)V$(o);f[L>>2]=0;L=o+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[L>>2]|0)>0){J=f[o+40>>2]|0;F=0;do{f[J+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[L>>2]|0))}L=f[o+44>>2]|0;if((L|0)!=(g|0))wL(L);L=m+36|0;g=f[L>>2]|0;do if(g|0){o=g+12|0;F=f[o>>2]|0;f[o>>2]=F+-1;if((F|0)!=1)break;V$(m)}while(0);f[L>>2]=0;L=m+16|0;g=m+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[g>>2]|0)>0){L=f[m+40>>2]|0;F=0;do{f[L+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[g>>2]|0))}g=f[m+44>>2]|0;if((g|0)!=(m+48|0))wL(g);g=l+36|0;m=f[g>>2]|0;do if(m|0){F=m+12|0;L=f[F>>2]|0;f[F>>2]=L+-1;if((L|0)!=1)break;V$(l)}while(0);f[g>>2]=0;g=l+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[g>>2]|0)>0){G=f[l+40>>2]|0;m=0;do{f[G+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[g>>2]|0))}g=f[l+44>>2]|0;if((g|0)==(P|0)){u=j;return}wL(g);u=j;return}function Xaa(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0;o=u;u=u+336|0;q=o+272|0;r=o+208|0;s=o+216|0;t=o+192|0;v=o+200|0;w=o+32|0;x=o;f[r>>2]=d;f[r+4>>2]=e;cM(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;cM(s,t,a,g,h);h=s+8|0;g=f[h>>2]|0;f[v>>2]=0;f[v+4>>2]=g;y=+p[n+8>>3];z=+p[n+16>>3];A=+p[n+24>>3];p[x>>3]=+p[n>>3];p[x+8>>3]=y;p[x+16>>3]=z;p[x+24>>3]=A;Yaa(w,q,s,k,l,m,x);x=s+4|0;m=f[x>>2]|0;if((m|0)<3)B=Y(f[s+12>>2]|0,f[h>>2]|0)|0;else{h=f[s+40>>2]|0;l=0;k=1;while(1){n=Y(f[h+(l<<2)>>2]|0,k)|0;l=l+1|0;if((l|0)==(m|0)){B=n;break}else k=n}}h3(v,w,+(B>>>0)*.0000152587890625);Zaa(w);w=s+36|0;B=f[w>>2]|0;if(B|0?(v=B+12|0,B=f[v>>2]|0,f[v>>2]=B+-1,(B|0)==1):0)V$(s);f[w>>2]=0;w=s+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[s+40>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[x>>2]|0))}x=f[s+44>>2]|0;if((x|0)!=(s+48|0))wL(x);x=q+36|0;s=f[x>>2]|0;if(s|0?(B=s+12|0,s=f[B>>2]|0,f[B>>2]=s+-1,(s|0)==1):0)V$(q);f[x>>2]=0;x=q+16|0;s=q+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[q+40>>2]|0;B=0;do{f[x+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}wL(s);u=o;return}function Yaa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0;f[a>>2]=49336;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;U$(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}else{f[i>>2]=0;U$(b,c);o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}}function Zaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49336;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function _aa(a){a=a|0;Zaa(a);cYc(a);return}function $aa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0,zb=0,Ab=0,Bb=0;c=u;u=u+6480|0;e=c+2376|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+60|0;r=f[a+72>>2]|0;s=f[a+68>>2]|0;t=1024/(((s|0)<16?s:16)|0)|0;v=(r|0)<(t|0)?r:t;t=1024/(v|0)|0;w=(s|0)<(t|0)?s:t;t=f[b>>2]|0;s=b+4|0;if((t|0)>=(f[s>>2]|0)){u=c;return}b=(r|0)>0;x=h+4|0;y=h+8|0;z=h+12|0;A=h+16|0;B=h+20|0;C=h+24|0;D=h+28|0;E=h+40|0;F=h+48|0;G=h+44|0;H=h+52|0;I=i+4|0;J=i+8|0;K=i+40|0;L=i+48|0;M=i+44|0;N=i+52|0;O=k+4|0;P=k+8|0;Q=k+12|0;R=a+120|0;S=a+4|0;T=k+8|0;U=k+12|0;V=k+4|0;W=l+8|0;X=l+4|0;Z=m+8|0;_=m+12|0;$=m+4|0;aa=o+4|0;ba=o+8|0;ca=o+40|0;da=o+48|0;ea=o+44|0;fa=o+52|0;ga=n+8|0;ha=n+12|0;ia=n+4|0;ja=a+124|0;ka=a+128|0;la=o+36|0;ma=o+16|0;na=j+36|0;oa=j+16|0;pa=j+4|0;qa=j+40|0;ra=j+44|0;sa=j+48|0;ta=i+36|0;ua=i+16|0;va=h+36|0;wa=k+4|0;xa=k+8|0;ya=k+12|0;za=k+16|0;Aa=k+20|0;Ba=k+24|0;Ca=k+28|0;Da=k+40|0;Ea=k+48|0;Fa=k+44|0;Ga=k+52|0;Ha=l+8|0;Ia=l+12|0;Ja=l+4|0;Ka=m+8|0;La=m+4|0;Ma=n+8|0;Na=n+12|0;Oa=n+4|0;Pa=o+8|0;Qa=o+12|0;Ra=o+4|0;Sa=k+36|0;Ta=a+116|0;a=C+8|0;Ua=Ba+8|0;Va=t;do{if(b){t=0;do{Wa=r-t|0;Xa=(Wa|0)<(v|0)?Wa:v;Wa=(f[s>>2]|0)-Va|0;Ya=(Wa|0)<(w|0)?Wa:w;f[h>>2]=1124007947;f[x>>2]=2;f[y>>2]=Ya;f[z>>2]=Xa;f[A>>2]=e;f[B>>2]=e;Wa=a;f[Wa>>2]=0;f[Wa+4>>2]=0;f[E>>2]=y;f[G>>2]=F;Wa=Xa<<2;f[F>>2]=Wa;f[H>>2]=4;Za=e+(Y(Ya,Wa)|0)|0;f[D>>2]=Za;f[C>>2]=Za+(0-Wa)+Wa;R$(h);f[i>>2]=1124007936;Wa=I;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[K>>2]=J;f[M>>2]=L;f[L>>2]=0;f[N>>2]=0;f[k>>2]=t;f[O>>2]=Va;f[P>>2]=Xa;f[Q>>2]=Ya;Z$(j,q,k);_a=(f[R>>2]|0)==0;if((Ya|0)>0){$a=f[Ta>>2]|0;ab=+p[$a>>3];bb=+(t|0);cb=bb*ab;db=+p[$a+8>>3];eb=+p[$a+16>>3];fb=+p[$a+24>>3];gb=bb*fb;hb=+p[$a+32>>3];ib=+p[$a+40>>3];jb=+p[$a+48>>3];kb=bb*jb;bb=+p[$a+56>>3];lb=+p[$a+64>>3];$a=(Xa|0)>0;mb=0;do{nb=Y(mb,Xa)|0;ob=e+(nb<<1<<1)|0;pb=+(mb+Va|0);qb=eb+(cb+pb*db);rb=ib+(gb+pb*hb);sb=lb+(kb+pb*bb);if(_a){if($a){tb=0;do{pb=+(tb|0);ub=sb+pb*jb;vb=ub!=0.0?1.0/ub:0.0;ub=vb*(qb+pb*ab);wb=ub<2147483647.0?ub:2147483647.0;ub=vb*(rb+pb*fb);pb=ub<2147483647.0?ub:2147483647.0;xb=zLc(wb>-2147483648.0?wb:-2147483648.0)|0;yb=zLc(pb>-2147483648.0?pb:-2147483648.0)|0;zb=tb<<1;d[ob+(zb<<1)>>1]=(xb+32768|0)>>>0<65536?xb:(xb|0)>0?32767:32768;d[ob+((zb|1)<<1)>>1]=(yb+32768|0)>>>0<65536?yb:(yb|0)>0?32767:32768;tb=tb+1|0}while((tb|0)<(Xa|0))}}else{tb=g+(nb<<1)|0;if($a){yb=0;do{pb=+(yb|0);wb=sb+pb*jb;ub=wb!=0.0?32.0/wb:0.0;wb=ub*(qb+pb*ab);vb=wb<2147483647.0?wb:2147483647.0;wb=ub*(rb+pb*fb);pb=wb<2147483647.0?wb:2147483647.0;zb=zLc(vb>-2147483648.0?vb:-2147483648.0)|0;xb=zLc(pb>-2147483648.0?pb:-2147483648.0)|0;Ab=zb>>5;Bb=yb<<1;d[ob+(Bb<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;Ab=xb>>5;d[ob+((Bb|1)<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;d[tb+(yb<<1)>>1]=xb<<5&992|zb&31;yb=yb+1|0}while((yb|0)<(Xa|0))}}mb=mb+1|0}while((mb|0)<(Ya|0))}if(_a){f[T>>2]=0;f[U>>2]=0;f[k>>2]=16842752;f[V>>2]=S;mb=W;f[mb>>2]=0;f[mb+4>>2]=0;f[l>>2]=33619968;f[X>>2]=j;f[Z>>2]=0;f[_>>2]=0;f[m>>2]=16842752;f[$>>2]=h;f[o>>2]=1124007936;Wa=aa;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[ca>>2]=ba;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[ha>>2]=0;f[n>>2]=16842752;f[ia>>2]=o;saa(k,l,m,n,0,f[ja>>2]|0,ka);Wa=f[la>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)V$(o);f[la>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[aa>>2]|0)>0){Wa=f[ca>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[aa>>2]|0))}Za=f[ea>>2]|0;if((Za|0)!=(da|0))wL(Za)}else{f[k>>2]=1124007938;f[wa>>2]=2;f[xa>>2]=Ya;f[ya>>2]=Xa;f[za>>2]=g;f[Aa>>2]=g;Za=Ua;f[Za>>2]=0;f[Za+4>>2]=0;f[Da>>2]=xa;f[Fa>>2]=Ea;Za=Xa<<1;f[Ea>>2]=Za;f[Ga>>2]=2;Wa=g+((Y(Ya,Xa)|0)<<1)|0;f[Ca>>2]=Wa;f[Ba>>2]=Wa+(0-Za)+Za;R$(k);f[Ha>>2]=0;f[Ia>>2]=0;f[l>>2]=16842752;f[Ja>>2]=S;Za=Ka;f[Za>>2]=0;f[Za+4>>2]=0;f[m>>2]=33619968;f[La>>2]=j;f[Ma>>2]=0;f[Na>>2]=0;f[n>>2]=16842752;f[Oa>>2]=h;f[Pa>>2]=0;f[Qa>>2]=0;f[o>>2]=16842752;f[Ra>>2]=k;saa(l,m,n,o,f[R>>2]|0,f[ja>>2]|0,ka);Za=f[Sa>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)V$(k);f[Sa>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[wa>>2]|0)>0){Za=f[Da>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[wa>>2]|0))}Wa=f[Fa>>2]|0;if((Wa|0)!=(Ea|0))wL(Wa)}Wa=f[na>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)V$(j);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[pa>>2]|0)>0){Wa=f[qa>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[pa>>2]|0))}Za=f[ra>>2]|0;if((Za|0)!=(sa|0))wL(Za);Za=f[ta>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)V$(i);f[ta>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[I>>2]|0)>0){Za=f[K>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[I>>2]|0))}Wa=f[M>>2]|0;if((Wa|0)!=(L|0))wL(Wa);Wa=f[va>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)V$(h);f[va>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[x>>2]|0)>0){Wa=f[E>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[x>>2]|0))}Za=f[G>>2]|0;if((Za|0)!=(F|0))wL(Za);t=t+v|0}while((r|0)>(t|0))}Va=Va+w|0}while((Va|0)<(f[s>>2]|0));u=c;return}function aba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=u;u=u+336|0;k=j;l=j+280|0;m=j+216|0;n=j+272|0;o=j+160|0;p=j+104|0;q=j+88|0;r=j+72|0;if(!(pS(a,-1)|0)){s=$Xc(32)|0;f[k>>2]=s;f[k+8>>2]=-2147483616;f[k+4>>2]=16;t=s;v=252299;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+16>>0]=0;vM(-215,k,252316,251587,2903)}do if((eS(a)|0)==65536){s=f[a+4>>2]|0;f[l>>2]=f[s>>2];x=l+4|0;y=s+4|0;f[x>>2]=f[y>>2];z=l+8|0;f[z>>2]=f[s+8>>2];f[l+12>>2]=f[s+12>>2];f[l+16>>2]=f[s+16>>2];f[l+20>>2]=f[s+20>>2];f[l+24>>2]=f[s+24>>2];f[l+28>>2]=f[s+28>>2];f[l+32>>2]=f[s+32>>2];A=f[s+36>>2]|0;f[l+36>>2]=A;f[l+40>>2]=z;z=l+48|0;B=l+44|0;f[B>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[s+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(l,s);break}}else bS(l,a,-1);while(0);do if((eS(d)|0)==65536){a=f[d+4>>2]|0;f[m>>2]=f[a>>2];s=m+4|0;x=a+4|0;f[s>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=y;y=m+48|0;B=m+44|0;f[B>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[a+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[s>>2]=0;U$(m,a);break}}else bS(m,d,-1);while(0);d=f[e>>2]|0;if((d|0)>=1?(a=f[e+4>>2]|0,(a|0)>=1):0){C=a;D=d}else{d=f[l+40>>2]|0;C=f[d>>2]|0;D=f[d+4>>2]|0}f[n>>2]=D;f[n+4>>2]=C;wS(c,n,f[l>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){n=f[c+4>>2]|0;f[o>>2]=f[n>>2];C=o+4|0;D=n+4|0;f[C>>2]=f[D>>2];d=o+8|0;f[d>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];a=o+16|0;f[a>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];e=f[n+36>>2]|0;f[o+36>>2]=e;f[o+40>>2]=d;d=o+48|0;s=o+44|0;f[s>>2]=d;f[d>>2]=0;f[o+52>>2]=0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[D>>2]|0)<3){D=f[n+44>>2]|0;d=f[s>>2]|0;f[d>>2]=f[D>>2];f[d+4>>2]=f[D+4>>2];E=a;break}else{f[C>>2]=0;U$(o,n);E=a;break}}else{bS(o,c,-1);E=o+16|0}while(0);c=l+16|0;if((f[E>>2]|0)==(f[c>>2]|0)){f[p>>2]=1124007936;a=p+4|0;n=p+8|0;C=p+40|0;t=a;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[C>>2]=n;D=p+48|0;f[p+44>>2]=D;f[D>>2]=0;f[p+52>>2]=0;d=k+8|0;f[d>>2]=0;f[d+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=p;jR(l,k);d=l+36|0;s=f[d>>2]|0;if(s|0?(e=s+12|0,s=f[e>>2]|0,f[e>>2]=s+-1,(s|0)==1):0)V$(l);f[d>>2]=0;s=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[s>>2]|0)>0){e=f[l+40>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}f[l>>2]=f[p>>2];x=f[a>>2]|0;f[s>>2]=x;s=l+8|0;f[s>>2]=f[n>>2];f[l+12>>2]=f[p+12>>2];e=p+16|0;f[c>>2]=f[e>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];y=p+36|0;f[d>>2]=f[y>>2];d=l+44|0;B=f[d>>2]|0;z=l+48|0;if((B|0)==(z|0))F=x;else{wL(B);f[d>>2]=z;f[l+40>>2]=s;F=f[a>>2]|0}s=p+44|0;if((F|0)<3){F=f[s>>2]|0;f[z>>2]=f[F>>2];f[l+52>>2]=f[F+4>>2];G=F}else{f[d>>2]=f[s>>2];f[l+40>>2]=f[C>>2];f[s>>2]=D;f[C>>2]=n;G=D}f[p>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[y>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((G|0)!=(D|0))wL(G)}f[p>>2]=1124007942;G=p+4|0;f[G>>2]=2;D=p+8|0;f[D>>2]=3;f[p+12>>2]=3;e=p+16|0;f[e>>2]=k;f[p+20>>2]=k;y=p+24|0;a=p+40|0;n=y+8|0;f[n>>2]=0;f[n+4>>2]=0;f[a>>2]=D;D=p+48|0;n=p+44|0;f[n>>2]=D;f[D>>2]=24;f[p+52>>2]=8;f[p+28>>2]=k+72;f[y>>2]=k+72;R$(p);k=g&7;y=(k|0)==3?1:k;if(((f[m>>2]&4095)+-5|0)>>>0>=2){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;H=$Xc(80)|0;f[q>>2]=H;I=q+8|0;f[I>>2]=-2147483568;J=q+4|0;f[J>>2]=76;t=H;v=252332;w=t+76|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));K=H+76|0;b[K>>0]=0;vM(-215,q,252316,251587,2927)}if((f[m+8>>2]|0)!=3){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;H=$Xc(80)|0;f[q>>2]=H;I=q+8|0;f[I>>2]=-2147483568;J=q+4|0;f[J>>2]=76;t=H;v=252332;w=t+76|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));K=H+76|0;b[K>>0]=0;vM(-215,q,252316,251587,2927)}if((f[m+12>>2]|0)!=3){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;H=$Xc(80)|0;f[q>>2]=H;I=q+8|0;f[I>>2]=-2147483568;J=q+4|0;f[J>>2]=76;t=H;v=252332;w=t+76|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));K=H+76|0;b[K>>0]=0;vM(-215,q,252316,251587,2927)}K=q+8|0;f[K>>2]=0;f[K+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=p;dY(m,q,f[p>>2]&4095,1.0,0.0);if(!(g&16)){f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=p;g=r+8|0;f[g>>2]=0;f[g+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=p;+gM(q,r,0)}r=l+48|0;q=o+48|0;Xaa(f[l>>2]&4095,f[c>>2]|0,f[r>>2]|0,f[l+12>>2]|0,f[l+8>>2]|0,f[E>>2]|0,f[q>>2]|0,f[o+12>>2]|0,f[o+8>>2]|0,f[e>>2]|0,y,h,i);i=p+36|0;h=f[i>>2]|0;if(h|0?(y=h+12|0,h=f[y>>2]|0,f[y>>2]=h+-1,(h|0)==1):0)V$(p);f[i>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[G>>2]|0)>0){e=f[a>>2]|0;a=0;do{f[e+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[G>>2]|0))}G=f[n>>2]|0;if((G|0)!=(D|0))wL(G);G=o+36|0;D=f[G>>2]|0;if(D|0?(n=D+12|0,D=f[n>>2]|0,f[n>>2]=D+-1,(D|0)==1):0)V$(o);f[G>>2]=0;G=o+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[G>>2]|0)>0){E=f[o+40>>2]|0;D=0;do{f[E+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[G>>2]|0))}G=f[o+44>>2]|0;if((G|0)!=(q|0))wL(G);G=m+36|0;q=f[G>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)V$(m);f[G>>2]=0;G=m+16|0;q=m+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[q>>2]|0)>0){G=f[m+40>>2]|0;o=0;do{f[G+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[m+44>>2]|0;if((q|0)!=(m+48|0))wL(q);q=l+36|0;m=f[q>>2]|0;do if(m|0){o=m+12|0;G=f[o>>2]|0;f[o>>2]=G+-1;if((G|0)!=1)break;V$(l)}while(0);f[q>>2]=0;q=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[l+40>>2]|0;m=0;do{f[c+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[q>>2]|0))}q=f[l+44>>2]|0;if((q|0)==(r|0)){u=j;return}wL(q);u=j;return}function bba(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0;e=u;u=u+16|0;g=e;h=c*.017453292519943295;c=+O(+h)*d;i=+P(+h)*d;f[a>>2]=1124007936;j=a+8|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;S$(a,2,g,6);g=f[a+16>>2]|0;p[g>>3]=c;p[g+8>>3]=i;d=1.0-c;h=+n[b>>2];o=+n[b+4>>2];p[g+16>>3]=d*h-i*o;p[g+24>>3]=-i;p[g+32>>3]=c;p[g+40>>3]=i*h+d*o;u=e;return}function cba(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0,N=0.0;g=u;u=u+800|0;h=g+64|0;i=g+736|0;j=g;k=g+680|0;l=g+624|0;m=g+608|0;o=g+592|0;q=g+576|0;f[a>>2]=1124007936;r=a+8|0;s=a+40|0;t=a+4|0;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;r=a+48|0;f[a+44>>2]=r;f[r>>2]=0;f[a+52>>2]=0;f[h>>2]=3;f[h+4>>2]=3;S$(a,2,h,6);r=a+16|0;a=f[r>>2]|0;f[i>>2]=1124007942;s=i+4|0;f[s>>2]=2;w=i+8|0;f[w>>2]=8;f[i+12>>2]=1;x=i+16|0;f[x>>2]=a;f[i+20>>2]=a;y=i+24|0;z=i+40|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[z>>2]=w;w=i+48|0;A=i+44|0;f[A>>2]=w;B=i+52|0;f[B>>2]=0;f[w>>2]=0;if(!a){C=$Xc(32)|0;f[h>>2]=C;f[h+8>>2]=-2147483616;f[h+4>>2]=28;t=C;D=470314;v=t+28|0;do{b[t>>0]=b[D>>0]|0;t=t+1|0;D=D+1|0}while((t|0)<(v|0));b[C+28>>0]=0;vM(-215,h,470343,470347,548)}f[w>>2]=8;f[B>>2]=8;B=a+64|0;f[i+28>>2]=B;f[y>>2]=B;R$(i);f[k>>2]=1124007942;B=k+4|0;f[B>>2]=2;y=k+8|0;f[y>>2]=8;f[k+12>>2]=8;a=k+16|0;f[a>>2]=h;f[k+20>>2]=h;C=k+24|0;D=k+40|0;t=C+8|0;f[t>>2]=0;f[t+4>>2]=0;f[D>>2]=y;y=k+48|0;t=k+44|0;f[t>>2]=y;f[y>>2]=64;f[k+52>>2]=8;f[k+28>>2]=h+512;f[C>>2]=h+512;R$(k);f[l>>2]=1124007942;C=l+4|0;f[C>>2]=2;v=l+8|0;f[v>>2]=8;f[l+12>>2]=1;E=l+16|0;f[E>>2]=j;f[l+20>>2]=j;F=l+24|0;G=l+40|0;H=F+8|0;f[H>>2]=0;f[H+4>>2]=0;f[G>>2]=v;v=l+48|0;H=l+44|0;f[H>>2]=v;f[v>>2]=8;f[l+52>>2]=8;f[l+28>>2]=j+64;f[F>>2]=j+64;R$(l);F=0;do{I=+n[c+(F<<3)>>2];J=I;K=F+4|0;p[h+(K<<6)+24>>3]=J;p[h+(F<<6)>>3]=J;J=+n[c+(F<<3)+4>>2];L=J;p[h+(K<<6)+32>>3]=L;p[h+(F<<6)+8>>3]=L;p[h+(K<<6)+40>>3]=1.0;p[h+(F<<6)+16>>3]=1.0;M=h+(K<<6)|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;M=h+(F<<6)+24|0;L=-I;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;I=+n[d+(F<<3)>>2];p[h+(F<<6)+48>>3]=I*L;N=-J;p[h+(F<<6)+56>>3]=I*N;J=+n[d+(F<<3)+4>>2];p[h+(K<<6)+48>>3]=J*L;p[h+(K<<6)+56>>3]=J*N;p[j+(F<<3)>>3]=I;p[j+(K<<3)>>3]=J;F=F+1|0}while((F|0)!=4);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;F=q+8|0;f[F>>2]=0;f[F+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=i;pM(m,o,q,e)|0;p[(f[r>>2]|0)+64>>3]=1.0;r=l+36|0;e=f[r>>2]|0;if(e|0?(q=e+12|0,e=f[q>>2]|0,f[q>>2]=e+-1,(e|0)==1):0)V$(l);f[r>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[G>>2]|0;G=0;do{f[E+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[C>>2]|0))}C=f[H>>2]|0;if((C|0)!=(v|0))wL(C);C=k+36|0;v=f[C>>2]|0;if(v|0?(H=v+12|0,v=f[H>>2]|0,f[H>>2]=v+-1,(v|0)==1):0)V$(k);f[C>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[B>>2]|0)>0){a=f[D>>2]|0;D=0;do{f[a+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[t>>2]|0;if((B|0)!=(y|0))wL(B);B=i+36|0;y=f[B>>2]|0;if(y|0?(t=y+12|0,y=f[t>>2]|0,f[t>>2]=y+-1,(y|0)==1):0)V$(i);f[B>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[z>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[s>>2]|0))}s=f[A>>2]|0;if((s|0)==(w|0)){u=g;return}wL(s);u=g;return}function dba(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;e=u;u=u+560|0;g=e+48|0;h=e+496|0;i=e;j=e+440|0;k=e+384|0;l=e+368|0;m=e+352|0;o=e+336|0;f[a>>2]=1124007936;q=a+8|0;r=a+40|0;s=a+4|0;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=a+48|0;f[a+44>>2]=q;f[q>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;S$(a,2,g,6);q=f[a+16>>2]|0;f[h>>2]=1124007942;a=h+4|0;f[a>>2]=2;r=h+8|0;f[r>>2]=6;f[h+12>>2]=1;v=h+16|0;f[v>>2]=q;f[h+20>>2]=q;w=h+24|0;x=h+40|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[x>>2]=r;r=h+48|0;y=h+44|0;f[y>>2]=r;z=h+52|0;f[z>>2]=0;f[r>>2]=0;if(!q){A=$Xc(32)|0;f[g>>2]=A;f[g+8>>2]=-2147483616;f[g+4>>2]=28;s=A;B=470314;t=s+28|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(t|0));b[A+28>>0]=0;vM(-215,g,470343,470347,548)}f[r>>2]=8;f[z>>2]=8;z=q+48|0;f[h+28>>2]=z;f[w>>2]=z;R$(h);f[j>>2]=1124007942;z=j+4|0;f[z>>2]=2;w=j+8|0;f[w>>2]=6;f[j+12>>2]=6;q=j+16|0;f[q>>2]=g;f[j+20>>2]=g;A=j+24|0;B=j+40|0;C=A+8|0;f[C>>2]=0;f[C+4>>2]=0;f[B>>2]=w;w=j+48|0;C=j+44|0;f[C>>2]=w;f[w>>2]=48;f[j+52>>2]=8;f[j+28>>2]=g+288;f[A>>2]=g+288;R$(j);f[k>>2]=1124007942;A=k+4|0;f[A>>2]=2;D=k+8|0;f[D>>2]=6;f[k+12>>2]=1;E=k+16|0;f[E>>2]=i;f[k+20>>2]=i;F=k+24|0;G=k+40|0;H=F+8|0;f[H>>2]=0;f[H+4>>2]=0;f[G>>2]=D;D=k+48|0;H=k+44|0;f[H>>2]=D;f[D>>2]=8;f[k+52>>2]=8;f[k+28>>2]=i+48;f[F>>2]=i+48;R$(k);I=+n[c>>2];p[g+72>>3]=I;p[g>>3]=I;I=+n[c+4>>2];p[g+80>>3]=I;p[g+8>>3]=I;p[g+88>>3]=1.0;p[g+16>>3]=1.0;s=g+24|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i>>3]=+n[d>>2];p[i+8>>3]=+n[d+4>>2];I=+n[c+8>>2];p[g+168>>3]=I;p[g+96>>3]=I;I=+n[c+12>>2];p[g+176>>3]=I;p[g+104>>3]=I;p[g+184>>3]=1.0;p[g+112>>3]=1.0;F=d+8|0;s=g+120|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+16>>3]=+n[F>>2];p[i+24>>3]=+n[d+12>>2];I=+n[c+16>>2];p[g+264>>3]=I;p[g+192>>3]=I;I=+n[c+20>>2];p[g+272>>3]=I;p[g+200>>3]=I;p[g+280>>3]=1.0;p[g+208>>3]=1.0;c=d+16|0;s=g+216|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+32>>3]=+n[c>>2];p[i+40>>3]=+n[d+20>>2];f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=h;pM(l,m,o,0)|0;o=k+36|0;m=f[o>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)V$(k);f[o>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[A>>2]|0)>0){E=f[G>>2]|0;G=0;do{f[E+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[A>>2]|0))}A=f[H>>2]|0;if((A|0)!=(D|0))wL(A);A=j+36|0;D=f[A>>2]|0;if(D|0?(H=D+12|0,D=f[H>>2]|0,f[H>>2]=D+-1,(D|0)==1):0)V$(j);f[A>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[z>>2]|0)>0){q=f[B>>2]|0;B=0;do{f[q+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[C>>2]|0;if((z|0)!=(w|0))wL(z);z=h+36|0;w=f[z>>2]|0;if(w|0?(C=w+12|0,w=f[C>>2]|0,f[C>>2]=w+-1,(w|0)==1):0)V$(h);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[a>>2]|0)>0){v=f[x>>2]|0;x=0;do{f[v+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[a>>2]|0))}a=f[y>>2]|0;if((a|0)==(r|0)){u=e;return}wL(a);u=e;return}function eba(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+128|0;h=g+72|0;i=g+16|0;j=g;do if((eS(c)|0)==65536){k=f[c+4>>2]|0;f[h>>2]=f[k>>2];l=h+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=h+8|0;f[n>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=n;n=h+48|0;p=h+44|0;f[p>>2]=n;f[n>>2]=0;f[h+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;U$(h,k);break}}else bS(h,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[i>>2]=f[c>>2];k=i+4|0;l=c+4|0;f[k>>2]=f[l>>2];m=i+8|0;f[m>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[i+36>>2]=n;f[i+40>>2]=m;m=i+48|0;p=i+44|0;f[p>>2]=m;f[m>>2]=0;f[i+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[c+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;U$(i,c);break}}else bS(i,d,-1);while(0);if((k0(h,2,5,1)|0)!=4){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;q=$Xc(80)|0;f[j>>2]=q;r=j+8|0;f[r>>2]=-2147483568;s=j+4|0;f[s>>2]=66;t=q;v=252409;w=t+66|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+66|0;b[x>>0]=0;vM(-215,j,252476,251587,3157)}if((k0(i,2,5,1)|0)!=4){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;q=$Xc(80)|0;f[j>>2]=q;r=j+8|0;f[r>>2]=-2147483568;s=j+4|0;f[s>>2]=66;t=q;v=252409;w=t+66|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+66|0;b[x>>0]=0;vM(-215,j,252476,251587,3157)}j=h+16|0;x=i+16|0;cba(a,f[j>>2]|0,f[x>>2]|0,e);e=i+36|0;a=f[e>>2]|0;if(a|0?(q=a+12|0,a=f[q>>2]|0,f[q>>2]=a+-1,(a|0)==1):0)V$(i);f[e>>2]=0;e=i+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[e>>2]|0)>0){x=f[i+40>>2]|0;a=0;do{f[x+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[e>>2]|0))}e=f[i+44>>2]|0;if((e|0)!=(i+48|0))wL(e);e=h+36|0;i=f[e>>2]|0;if(i|0?(a=i+12|0,i=f[a>>2]|0,f[a>>2]=i+-1,(i|0)==1):0)V$(h);f[e>>2]=0;e=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[e>>2]|0)>0){j=f[h+40>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function fba(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;do if((eS(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;U$(g,j);break}}else bS(g,c,-1);while(0);do if((eS(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];j=h+4|0;k=c+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];m=f[c+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[c+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;U$(h,c);break}}else bS(h,d,-1);while(0);if((k0(g,2,5,1)|0)!=3){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=$Xc(80)|0;f[i>>2]=p;q=i+8|0;f[q>>2]=-2147483568;r=i+4|0;f[r>>2]=66;s=p;t=252500;v=s+66|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+66|0;b[w>>0]=0;vM(-215,i,252567,251587,3164)}if((k0(h,2,5,1)|0)!=3){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=$Xc(80)|0;f[i>>2]=p;q=i+8|0;f[q>>2]=-2147483568;r=i+4|0;f[r>>2]=66;s=p;t=252500;v=s+66|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+66|0;b[w>>0]=0;vM(-215,i,252567,251587,3164)}i=g+16|0;w=h+16|0;dba(a,f[i>>2]|0,f[w>>2]|0);a=h+36|0;p=f[a>>2]|0;if(p|0?(t=p+12|0,p=f[t>>2]|0,f[t>>2]=p+-1,(p|0)==1):0)V$(h);f[a>>2]=0;a=h+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[a>>2]|0)>0){w=f[h+40>>2]|0;p=0;do{f[w+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))wL(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(p=h+12|0,h=f[p>>2]|0,f[p>>2]=h+-1,(h|0)==1):0)V$(g);f[a>>2]=0;a=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}wL(a);u=e;return}function gba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0;i=u;u=u+1200|0;j=i+1144|0;k=i+80|0;l=i+24|0;m=i;do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[l>>2]=f[o>>2];p=l+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=l+8|0;f[r>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];f[l+16>>2]=f[o+16>>2];f[l+20>>2]=f[o+20>>2];f[l+24>>2]=f[o+24>>2];f[l+28>>2]=f[o+28>>2];f[l+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[l+36>>2]=s;f[l+40>>2]=r;r=l+48|0;t=l+44|0;f[t>>2]=r;f[r>>2]=0;f[l+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(l,o);break}}else bS(l,a,-1);while(0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;a=k0(l,2,-1,0)|0;o=k0(l,3,-1,0)|0;p=(a|0)>-1;if((o&a|0)<=-1){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;q=$Xc(32)|0;f[j>>2]=q;f[j+8>>2]=-2147483616;f[j+4>>2]=30;v=q;w=252586;x=v+30|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[q+30>>0]=0;vM(-215,j,252617,252625,607)}if((f[l>>2]&16391|0)==16389)y=l+16|0;else{f[j>>2]=1124007936;q=j+4|0;r=j+8|0;t=j+40|0;v=q;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[t>>2]=r;s=j+48|0;z=j+44|0;f[z>>2]=s;f[s>>2]=0;f[j+52>>2]=0;A=k+8|0;f[A>>2]=0;f[A+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;dY(l,k,5,1.0,0.0);A=j+36|0;B=f[A>>2]|0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}C=l+36|0;B=f[C>>2]|0;if(B|0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0)V$(l);f[C>>2]=0;B=l+16|0;D=l+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[D>>2]|0)>0){E=f[l+40>>2]|0;F=0;do{f[E+(F<<2)>>2]=0;F=F+1|0;G=f[D>>2]|0}while((F|0)<(G|0));f[l>>2]=f[j>>2];if((G|0)<3)H=22;else H=24}else{f[l>>2]=f[j>>2];H=22}if((H|0)==22){G=f[q>>2]|0;if((G|0)<3){f[D>>2]=G;f[l+8>>2]=f[r>>2];f[l+12>>2]=f[j+12>>2];r=f[z>>2]|0;G=f[l+44>>2]|0;f[G>>2]=f[r>>2];f[G+4>>2]=f[r+4>>2]}else H=24}if((H|0)==24)U$(l,j);r=j+16|0;f[B>>2]=f[r>>2];f[l+20>>2]=f[j+20>>2];f[l+24>>2]=f[j+24>>2];f[l+28>>2]=f[j+28>>2];f[l+32>>2]=f[j+32>>2];G=f[A>>2]|0;f[C>>2]=G;if(G|0?(C=G+12|0,G=f[C>>2]|0,f[C>>2]=G+-1,(G|0)==1):0)V$(j);f[A>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[q>>2]|0)>0){r=f[t>>2]|0;t=0;do{f[r+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[q>>2]|0))}q=f[z>>2]|0;if((q|0)!=(s|0))wL(q);y=B}B=f[y>>2]|0;if(p){I=e;K=g;N=h;O=+(a|0)*1.1920928955078125e-07;P=K!=0.0?K:1.0;p=N!=0.0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;switch(d|0){case 2:{hba(B,a,0,m);break}case 1:{Q=424;S=0;H=42;break}case 4:{Q=425;S=0;H=42;break}case 5:{Q=0;S=41;H=42;break}case 6:{Q=0;S=42;H=42;break}case 7:{Q=0;S=43;H=42;break}default:{q=$Xc(32)|0;f[k>>2]=q;f[k+8>>2]=-2147483616;f[k+4>>2]=21;v=q;w=252697;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[q+21>>0]=0;vM(-5,k,252719,252625,361)}}if((H|0)==42){q=a<<1;s=k+8|0;f[k>>2]=s;z=k+4|0;f[z>>2]=q;if(q>>>0>264){t=bYc(q>>>0>1073741823?-1:q<<2)|0;f[k>>2]=t;T=t}else T=s;t=T+(a<<2)|0;q=(a|0)>0;r=(a|0)<10?a:10;A=j+4|0;K=p?N:.009999999776482582;p=j+8|0;G=j+12|0;C=(Q|0)==0;D=a<<2;F=(a|0)==0|q^1;E=0;N=0.0;U=1797693134862315708145274.0e284;V=0.0;W=0.0;X=0.0;Y=0.0;Z=-1;_=-1;while(1){if(q)g1c(T|0,0,D|0)|0;if(F){$=Z;aa=_}else{ba=0;ca=Z;da=_;while(1){ea=ca;fa=da;do{ga=x1c(ea|0,0,-130063606,0)|0;ea=d1c(ga|0,J|0,fa|0,0)|0;fa=J;ha=T+(((ea>>>0)%(a>>>0)|0)<<2)|0}while(!(+n[ha>>2]<1.1920928955078125e-07));ba=ba+1|0;n[ha>>2]=1.0;if((ba|0)>=(r|0)){$=ea;aa=fa;break}else{ca=ea;da=fa}}}hba(B,a,T,j);da=0;ia=N;ca=0;ja=V;ka=W;la=X;ma=Y;while(1){if(da){na=+n[j>>2];oa=+n[A>>2];pa=ja*na+ka*oa;qa=pa<-1.0?-1.0:pa;if(+L(+(+R(+(qa>1.0?1.0:qa))))<K?(qa=+L(+(+n[p>>2]-la)),pa=+L(+(+n[G>>2]-ma)),(qa>pa?qa:pa)<P):0){ra=ia;sa=ja;ta=ka;ua=la;va=ma;break}else{wa=na;xa=oa}}else{wa=+n[j>>2];xa=+n[A>>2]}oa=+n[p>>2];na=+n[G>>2];if(q){pa=0.0;ba=0;while(1){qa=+L(+(xa*(+n[B+(ba<<3)>>2]-oa)-wa*(+n[B+(ba<<3)+4>>2]-na)));n[t+(ba<<2)>>2]=qa;ya=pa+qa;ba=ba+1|0;if((ba|0)==(a|0)){za=ya;break}else pa=ya}}else za=0.0;if(za<O){ra=za;sa=ja;ta=ka;ua=la;va=ma;break}if(C)$h[S&63](t,a,T,I);else Ti[Q&511](t,a,T);if(q){ba=0;pa=0.0;while(1){ya=pa+ +n[T+(ba<<2)>>2];ba=ba+1|0;if((ba|0)==(a|0)){Aa=ya;break}else pa=ya}}else Aa=0.0;if(+L(+Aa)>1.1920928955078125e-07){pa=1.0/Aa;if(q){ba=0;do{fa=T+(ba<<2)|0;n[fa>>2]=pa*+n[fa>>2];ba=ba+1|0}while((ba|0)!=(a|0))}}else if(q){ba=0;do{n[T+(ba<<2)>>2]=1.0;ba=ba+1|0}while((ba|0)!=(a|0))}hba(B,a,T,j);ca=ca+1|0;if((ca|0)>=30){ra=za;sa=wa;ta=xa;ua=oa;va=na;break}else{da=1;ia=za;ja=wa;ka=xa;la=oa;ma=na}}if(ra<U){f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];if(ra<O)break;else Ba=ra}else Ba=U;E=E+1|0;if((E|0)>=20)break;else{N=ra;U=Ba;V=sa;W=ta;X=ua;Y=va;Z=$;_=aa}}aa=f[k>>2]|0;if((aa|0)!=(s|0)){if(aa|0)dYc(aa);f[k>>2]=s;f[z>>2]=264}}}else{va=e;e=g;g=h;h=+(o|0)*1.1920928955078125e-07;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;Y=e!=0.0?e:1.0;z=g!=0.0;switch(d|0){case 2:{nba(B,o,0,m);break}case 1:{Ca=424;Da=0;H=86;break}case 4:{Ca=425;Da=0;H=86;break}case 5:{Ca=0;Da=41;H=86;break}case 6:{Ca=0;Da=42;H=86;break}case 7:{Ca=0;Da=43;H=86;break}default:{d=$Xc(32)|0;f[k>>2]=d;f[k+8>>2]=-2147483616;f[k+4>>2]=16;v=d;w=252729;x=v+16|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[d+16>>0]=0;vM(-5,k,252746,252625,496)}}if((H|0)==86){H=o<<1;d=k+8|0;f[k>>2]=d;w=k+4|0;f[w>>2]=H;if(H>>>0>264){v=bYc(H>>>0>1073741823?-1:H<<2)|0;f[k>>2]=v;Ea=v}else Ea=d;v=Ea+(o<<2)|0;H=(o|0)>0;x=(o|0)<10?o:10;s=j+4|0;aa=j+8|0;e=z?g:.009999999776482582;z=j+12|0;_=j+16|0;$=j+20|0;Z=(Ca|0)==0;E=o<<2;T=(o|0)==0|H^1;q=0;g=1797693134862315708145274.0e284;ua=0.0;X=0.0;ta=0.0;W=0.0;sa=0.0;V=0.0;Ba=0.0;t=-1;Q=-1;while(1){if(H)g1c(Ea|0,0,E|0)|0;if(T){Fa=t;Ga=Q}else{S=0;C=t;G=Q;while(1){p=C;A=G;do{r=x1c(p|0,0,-130063606,0)|0;p=d1c(r|0,J|0,A|0,0)|0;A=J;Ha=Ea+(((p>>>0)%(o>>>0)|0)<<2)|0}while(!(+n[Ha>>2]<1.1920928955078125e-07));S=S+1|0;n[Ha>>2]=1.0;if((S|0)>=(x|0)){Fa=p;Ga=A;break}else{C=p;G=A}}}nba(B,o,Ea,j);G=0;na=ua;C=0;oa=X;U=ta;ra=W;N=sa;O=V;xa=Ba;while(1){wa=+n[j>>2];if(G){za=+n[s>>2];Aa=+n[aa>>2];I=oa*wa+O*za+xa*Aa;P=I<-1.0?-1.0:I;if(+L(+(+R(+(P>1.0?1.0:P))))<e?(P=+n[z>>2]-U,I=+n[_>>2]-ra,K=+n[$>>2]-N,ma=wa-oa,la=za-O,ka=Aa-xa,ja=+L(+(ka*I-la*K)),ia=+L(+(ma*K-ka*P)),ka=+L(+(la*P-ma*I)),I=ja>ia?ja:ia,(I>ka?I:ka)<Y):0){Ia=na;Ja=oa;Ka=U;La=ra;Ma=N;Na=O;Oa=xa;break}else{Pa=za;Qa=Aa}}else{Pa=+n[s>>2];Qa=+n[aa>>2]}Aa=+n[z>>2];za=+n[_>>2];ka=+n[$>>2];if(H){I=0.0;S=0;while(1){ia=+n[B+(S*12|0)>>2]-Aa;ja=+n[B+(S*12|0)+4>>2]-za;ma=+n[B+(S*12|0)+8>>2]-ka;P=Pa*ma-Qa*ja;la=Qa*ia-wa*ma;ma=wa*ja-Pa*ia;ia=+M(+(ma*ma+(P*P+la*la)));n[v+(S<<2)>>2]=ia;la=I+ia;S=S+1|0;if((S|0)==(o|0)){Ra=la;break}else I=la}}else Ra=0.0;if(Z)$h[Da&63](v,o,Ea,va);else Ti[Ca&511](v,o,Ea);if(H){S=0;I=0.0;while(1){la=I+ +n[Ea+(S<<2)>>2];S=S+1|0;if((S|0)==(o|0)){Sa=la;break}else I=la}}else Sa=0.0;if(+L(+Sa)>1.1920928955078125e-07){I=1.0/Sa;if(H){S=0;do{A=Ea+(S<<2)|0;n[A>>2]=I*+n[A>>2];S=S+1|0}while((S|0)!=(o|0))}}else if(H){S=0;do{n[Ea+(S<<2)>>2]=1.0;S=S+1|0}while((S|0)!=(o|0))}nba(B,o,Ea,j);C=C+1|0;if((C|0)>=30){Ia=Ra;Ja=wa;Ka=Aa;La=za;Ma=ka;Na=Pa;Oa=Qa;break}else{G=1;na=Ra;oa=wa;U=Aa;ra=za;N=ka;O=Pa;xa=Qa}}if(Ia<g){f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];f[m+16>>2]=f[j+16>>2];f[m+20>>2]=f[j+20>>2];if(Ia<h)break;else Ta=Ia}else Ta=g;q=q+1|0;if((q|0)>=20)break;else{g=Ta;ua=Ia;X=Ja;ta=Ka;W=La;sa=Ma;V=Na;Ba=Oa;t=Fa;Q=Ga}}Ga=f[k>>2]|0;if((Ga|0)!=(d|0)){if(Ga|0)dYc(Ga);f[k>>2]=d;f[w>>2]=264}}}w=a>>31&2|4;f[j>>2]=1124007941;a=j+4|0;f[a>>2]=2;d=j+8|0;f[d>>2]=w;f[j+12>>2]=1;k=j+16|0;f[k>>2]=m;f[j+20>>2]=m;Ga=j+24|0;Q=j+40|0;Fa=Ga+8|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Q>>2]=d;d=j+48|0;Fa=j+44|0;f[Fa>>2]=d;f[d>>2]=4;f[j+52>>2]=4;t=m+(w<<2)|0;f[j+28>>2]=t;f[Ga>>2]=t;R$(j);jR(j,c);c=j+36|0;t=f[c>>2]|0;if(t|0?(Ga=t+12|0,t=f[Ga>>2]|0,f[Ga>>2]=t+-1,(t|0)==1):0)V$(j);f[c>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[a>>2]|0)>0){k=f[Q>>2]|0;Q=0;do{f[k+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[a>>2]|0))}a=f[Fa>>2]|0;if((a|0)!=(d|0))wL(a);a=l+36|0;d=f[a>>2]|0;if(d|0?(Fa=d+12|0,d=f[Fa>>2]|0,f[Fa>>2]=d+-1,(d|0)==1):0)V$(l);f[a>>2]=0;a=l+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[a>>2]|0)>0){y=f[l+40>>2]|0;d=0;do{f[y+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[l+44>>2]|0;if((a|0)==(l+48|0)){u=i;return}wL(a);u=i;return}function hba(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;g=u;u=u+16|0;h=g;if((c|0)<=0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=9;i=h;j=252756;k=i+9|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+9>>0]=0;vM(-215,h,252781,252625,50)}if(!d){h=0;l=0.0;m=0.0;o=0.0;p=0.0;q=0.0;do{r=+n[a+(h<<3)>>2];q=q+r;s=+n[a+(h<<3)+4>>2];l=l+s;m=m+r*r;o=o+s*s;p=p+r*s;h=h+1|0}while((h|0)!=(c|0));t=+(c|0);v=q;w=l;x=m;y=o;z=p}else{p=0.0;h=0;o=0.0;m=0.0;l=0.0;q=0.0;s=0.0;while(1){r=+n[d+(h<<2)>>2];A=+n[a+(h<<3)>>2];B=r*A;C=s+B;D=+n[a+(h<<3)+4>>2];E=r*D;F=o+E;G=m+A*B;A=l+D*E;E=q+B*D;D=p+r;h=h+1|0;if((h|0)==(c|0)){t=D;v=C;w=F;x=G;y=A;z=E;break}else{p=D;o=F;m=G;l=A;q=E;s=C}}}s=v/t;v=w/t;w=+U(+((z/t-v*s)*2.0),+(x/t-s*s-(y/t-v*v)))*.5;t=+O(+w);n[e>>2]=t;t=+P(+w);n[e+4>>2]=t;n[e+8>>2]=s;n[e+12>>2]=v;u=g;return}function iba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d<=0.0?1.3450000286102295:d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];n[c+(f<<2)>>2]=d<e?1.0:e/d;f=f+1|0}while((f|0)!=(b|0));return}function jba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0;e=d==0.0?.3350532650947571:1.0/d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];g=+V(+-(e*(e*(d*d))));n[c+(f<<2)>>2]=g;f=f+1|0}while((f|0)!=(b|0));return}function kba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d==0.0?.7143877744674683:1.0/d;if((b|0)>0)f=0;else return;do{n[c+(f<<2)>>2]=1.0/(e*+n[a+(f<<2)>>2]+1.0);f=f+1|0}while((f|0)!=(b|0));return}function lba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0;if((b|0)>0)d=0;else return;do{e=+n[a+(d<<2)>>2];f=1.0/+M(+(e*e*.5+1.0));n[c+(d<<2)>>2]=f;d=d+1|0}while((d|0)!=(b|0));return}function mba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((b|0)>0)d=0;else return;do{e=+L(+(+n[a+(d<<2)>>2]));n[c+(d<<2)>>2]=1.0/(e<1.0e-06?1.0e-06:e);d=d+1|0}while((d|0)!=(b|0));return}function nba(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;g=u;u=u+304|0;h=g+264|0;i=g+228|0;j=g+216|0;k=g+160|0;l=g+104|0;m=g+48|0;o=g+32|0;p=g+16|0;q=g;if((c|0)<=0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=9;r=h;s=252756;t=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[h+9>>0]=0;vM(-215,h,252766,252625,102)};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=i;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));if(!d){r=0;v=0.0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;do{E=+n[a+(r*12|0)>>2];F=+n[a+(r*12|0)+4>>2];G=+n[a+(r*12|0)+8>>2];y=y+E*E;B=B+E*F;D=D+E*G;z=z+F*F;C=C+F*G;A=A+G*G;v=v+E;w=w+F;x=x+G;r=r+1|0}while((r|0)!=(c|0));H=+(c|0);I=v;J=w;K=x;L=y;N=z;O=A;P=B;Q=C;R=D}else{r=0;D=0.0;C=0.0;B=0.0;A=0.0;z=0.0;y=0.0;x=0.0;w=0.0;v=0.0;G=0.0;while(1){F=+n[a+(r*12|0)>>2];E=+n[a+(r*12|0)+4>>2];S=+n[a+(r*12|0)+8>>2];T=+n[d+(r<<2)>>2];U=z+F*F*T;V=w+F*E*T;W=G+F*S*T;X=y+E*E*T;Y=v+E*S*T;Z=x+S*S*T;_=C+F*T;F=B+E*T;E=A+S*T;S=D+T;r=r+1|0;if((r|0)==(c|0)){H=S;I=_;J=F;K=E;L=U;N=X;O=Z;P=V;Q=Y;R=W;break}else{D=S;C=_;B=F;A=E;z=U;y=X;x=Z;w=V;v=Y;G=W}}}G=I/H;I=J/H;J=K/H;K=L/H-G*G;L=N/H-I*I;N=O/H-J*J;n[h>>2]=N+L;O=-(P/H-G*I);n[h+4>>2]=O;P=-(R/H-G*J);n[h+8>>2]=P;n[h+12>>2]=O;n[h+16>>2]=K+N;N=-(Q/H-I*J);n[h+20>>2]=N;n[h+24>>2]=P;n[h+28>>2]=N;n[h+32>>2]=L+K;f[k>>2]=1124007941;c=k+4|0;f[c>>2]=2;r=k+8|0;f[r>>2]=3;f[k+12>>2]=3;d=k+16|0;f[d>>2]=h;f[k+20>>2]=h;a=k+24|0;t=k+40|0;s=a+8|0;f[s>>2]=0;f[s+4>>2]=0;f[t>>2]=r;r=k+48|0;s=k+44|0;f[s>>2]=r;f[r>>2]=12;f[k+52>>2]=4;f[k+28>>2]=h+36;f[a>>2]=h+36;R$(k);f[l>>2]=1124007941;h=l+4|0;f[h>>2]=2;a=l+8|0;f[a>>2]=3;f[l+12>>2]=3;$=l+16|0;f[$>>2]=i;f[l+20>>2]=i;aa=l+24|0;ba=l+40|0;ca=aa+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ba>>2]=a;a=l+48|0;ca=l+44|0;f[ca>>2]=a;f[a>>2]=12;f[l+52>>2]=4;f[l+28>>2]=i+36;f[aa>>2]=i+36;R$(l);f[m>>2]=1124007941;aa=m+4|0;f[aa>>2]=2;da=m+8|0;f[da>>2]=3;f[m+12>>2]=1;ea=m+16|0;f[ea>>2]=j;f[m+20>>2]=j;fa=m+24|0;ga=m+40|0;ha=fa+8|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ga>>2]=da;da=m+48|0;ha=m+44|0;f[ha>>2]=da;f[da>>2]=4;f[m+52>>2]=4;f[m+28>>2]=j+12;f[fa>>2]=j+12;R$(m);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;fa=p+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=m;fa=q+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;jM(o,p,q)|0;q=!(+n[j>>2]<+n[j+4>>2]);p=i+((+n[j+((q&1)<<2)>>2]<+n[j+8>>2]?(q?3:0):6)<<2)|0;K=+n[p>>2];L=K;N=+n[p+4>>2];P=N;H=+n[p+8>>2];Q=H;O=+M(+(L*L+P*P+Q*Q));Q=O<1.0e-06?1.0e-06:O;n[e>>2]=K/Q;n[e+4>>2]=N/Q;n[e+8>>2]=H/Q;n[e+12>>2]=G;n[e+16>>2]=I;n[e+20>>2]=J;e=m+36|0;p=f[e>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)V$(m);f[e>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[aa>>2]|0)>0){ea=f[ga>>2]|0;ga=0;do{f[ea+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[aa>>2]|0))}aa=f[ha>>2]|0;if((aa|0)!=(da|0))wL(aa);aa=l+36|0;da=f[aa>>2]|0;if(da|0?(ha=da+12|0,da=f[ha>>2]|0,f[ha>>2]=da+-1,(da|0)==1):0)V$(l);f[aa>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[h>>2]|0)>0){$=f[ba>>2]|0;ba=0;do{f[$+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[h>>2]|0))}h=f[ca>>2]|0;if((h|0)!=(a|0))wL(h);h=k+36|0;a=f[h>>2]|0;if(a|0?(ca=a+12|0,a=f[ca>>2]|0,f[ca>>2]=a+-1,(a|0)==1):0)V$(k);f[h>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[t>>2]|0;t=0;do{f[d+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[c>>2]|0))}c=f[s>>2]|0;if((c|0)==(r|0)){u=g;return}wL(c);u=g;return}function oba(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=a+48|0;n=a+44|0;f[n>>2]=m;f[m>>2]=0;f[a+52>>2]=0;m=c+16|0;o=(f[m>>2]|0)==0;q=f[c+4>>2]|0;if(!o){if((q|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{s=f[c+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){if((f[c>>2]&4095|0)!=6){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;x=$Xc(80)|0;f[e>>2]=x;y=e+8|0;f[y>>2]=-2147483568;z=e+4|0;f[z>>2]=72;k=x;A=252796;l=k+72|0;do{b[k>>0]=b[A>>0]|0;k=k+1|0;A=A+1|0}while((k|0)<(l|0));B=x+72|0;b[B>>0]=0;vM(-5,e,252869,252873,97)}if((f[c+8>>2]|0)!=1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;x=$Xc(80)|0;f[e>>2]=x;y=e+8|0;f[y>>2]=-2147483568;z=e+4|0;f[z>>2]=72;k=x;A=252796;l=k+72|0;do{b[k>>0]=b[A>>0]|0;k=k+1|0;A=A+1|0}while((k|0)<(l|0));B=x+72|0;b[B>>0]=0;vM(-5,e,252869,252873,97)}if((f[c+12>>2]|0)!=65){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;x=$Xc(80)|0;f[e>>2]=x;y=e+8|0;f[y>>2]=-2147483568;z=e+4|0;f[z>>2]=72;k=x;A=252796;l=k+72|0;do{b[k>>0]=b[A>>0]|0;k=k+1|0;A=A+1|0}while((k|0)<(l|0));B=x+72|0;b[B>>0]=0;vM(-5,e,252869,252873,97)}}else C=7}else C=7;if((C|0)==7){if(!((((q|0)<3?(f[c+8>>2]|0)==1:0)?(f[c+12>>2]|0)==65:0)?!((f[c>>2]&4095|0)!=6|o):0)){f[e>>2]=1;f[e+4>>2]=65;S$(c,2,e,6)}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=-1056833530;f[e+4>>2]=g;f[e+8>>2]=1;f[e+12>>2]=4;mR(c,e,fT()|0)|0}if((a|0)==(c|0))D=f[a+16>>2]|0;else{e=c+36|0;g=f[e>>2]|0;if(g|0){o=g+12|0;f[o>>2]=(f[o>>2]|0)+1}o=a+36|0;g=f[o>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)V$(a);f[o>>2]=0;g=a+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){q=f[j>>2]|0;j=0;do{f[q+(j<<2)>>2]=0;j=j+1|0;E=f[h>>2]|0}while((j|0)<(E|0));f[a>>2]=f[c>>2];if((E|0)<3)C=29;else C=31}else{f[a>>2]=f[c>>2];C=29}if((C|0)==29){E=f[c+4>>2]|0;if((E|0)<3){f[h>>2]=E;f[i>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];i=f[c+44>>2]|0;E=f[n>>2]|0;f[E>>2]=f[i>>2];f[E+4>>2]=f[i+4>>2]}else C=31}if((C|0)==31)U$(a,c);C=f[m>>2]|0;f[g>>2]=C;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[o>>2]=f[e>>2];D=C}C=a+56|0;f[C>>2]=D;f[a+60>>2]=D+40;f[a+64>>2]=D+160;if(+p[D>>3]>0.0){pba(a,0,0.0);F=f[C>>2]|0}else F=D;if(+p[F+8>>3]>0.0){pba(a,1,0.0);G=f[C>>2]|0}else G=F;if(+p[G+16>>3]>0.0){pba(a,2,0.0);H=f[C>>2]|0}else H=G;if(+p[H+24>>3]>0.0){pba(a,3,0.0);I=f[C>>2]|0}else I=H;if(!(+p[I+32>>3]>0.0)){J=a+972|0;f[J>>2]=0;u=d;return}pba(a,4,0.0);J=a+972|0;f[J>>2]=0;u=d;return}function pba(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0.0,t=0,v=0.0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0;e=u;u=u+16|0;g=e;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){u=e;return}h=(f[a+64>>2]|0)+(c*9<<3)|0;i=+p[h>>3];j=h+32|0;k=+p[j>>3];l=h+64|0;m=+p[l>>3];n=h+40|0;o=+p[n>>3];q=h+56|0;r=+p[q>>3];s=o*r;t=h+8|0;v=+p[t>>3];w=h+24|0;x=+p[w>>3];y=h+48|0;z=+p[y>>3];A=o*z;B=h+16|0;o=+p[B>>3];C=r*x;r=o*(C-k*z)+(i*(k*m-s)-v*(m*x-A));if(d>0.0&r<=1.0e-06){D=i+d;p[h>>3]=D;i=k+d;p[j>>3]=i;k=m+d;p[l>>3]=k;E=o*(C-i*z)+(D*(i*k-s)-v*(k*x-A))}else E=r;p[a+432+(c<<3)>>3]=E;if(!(E>2.220446049250313e-16)){F=$Xc(48)|0;f[g>>2]=F;f[g+8>>2]=-2147483600;f[g+4>>2]=45;G=F;H=252945;I=G+45|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[F+45>>0]=0;vM(-215,g,252991,252873,218)}r=1.0/E;p[a+72+(c*72|0)>>3]=r*(+p[j>>3]*+p[l>>3]-+p[n>>3]*+p[q>>3]);p[a+72+(c*72|0)+24>>3]=-(r*(+p[w>>3]*+p[l>>3]-+p[n>>3]*+p[y>>3]));p[a+72+(c*72|0)+48>>3]=r*(+p[w>>3]*+p[q>>3]-+p[j>>3]*+p[y>>3]);p[a+72+(c*72|0)+8>>3]=-(r*(+p[t>>3]*+p[l>>3]-+p[B>>3]*+p[q>>3]));p[a+72+(c*72|0)+32>>3]=r*(+p[h>>3]*+p[l>>3]-+p[B>>3]*+p[y>>3]);p[a+72+(c*72|0)+56>>3]=-(r*(+p[h>>3]*+p[q>>3]-+p[t>>3]*+p[y>>3]));p[a+72+(c*72|0)+16>>3]=r*(+p[t>>3]*+p[n>>3]-+p[B>>3]*+p[j>>3]);p[a+72+(c*72|0)+40>>3]=-(r*(+p[h>>3]*+p[n>>3]-+p[B>>3]*+p[w>>3]));p[a+72+(c*72|0)+64>>3]=r*(+p[h>>3]*+p[j>>3]-+p[t>>3]*+p[w>>3]);u=e;return}function qba(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0;e=u;u=u+16|0;g=e;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){h=0.0;u=e;return +h}i=+p[a+432+(c<<3)>>3];if(!(i>2.220446049250313e-16)){j=$Xc(64)|0;f[g>>2]=j;f[g+8>>2]=-2147483584;f[g+4>>2]=55;k=j;l=253015;m=k+55|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+55>>0]=0;vM(-215,g,528391,252873,124)}g=(f[a+60>>2]|0)+(c*3<<3)|0;n=+p[d>>3]-+p[g>>3];o=+p[d+8>>3]-+p[g+8>>3];q=+p[d+16>>3]-+p[g+16>>3];h=1.0/+M(+i)*+V(+((n*(n*+p[a+72+(c*72|0)>>3]+o*+p[a+72+(c*72|0)+24>>3]+q*+p[a+72+(c*72|0)+48>>3])+o*(n*+p[a+72+(c*72|0)+8>>3]+o*+p[a+72+(c*72|0)+32>>3]+q*+p[a+72+(c*72|0)+56>>3])+q*(n*+p[a+72+(c*72|0)+16>>3]+o*+p[a+72+(c*72|0)+40>>3]+q*+p[a+72+(c*72|0)+64>>3]))*-.5));u=e;return +h}function rba(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+972|0;if((f[e>>2]|0)<=0){g=$Xc(32)|0;f[d>>2]=g;f[d+8>>2]=-2147483616;f[d+4>>2]=20;h=g;i=253071;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+20>>0]=0;vM(-215,d,253092,252873,178)}d=a+56|0;g=a+60|0;i=a+64|0;h=0;do{j=f[a+952+(h<<2)>>2]|0;k=f[d>>2]|0;if(!j)p[k+(h<<3)>>3]=0.0;else{l=+(j|0);m=1.0/l;p[k+(h<<3)>>3]=l/+(f[e>>2]|0);k=(f[g>>2]|0)+(h*3<<3)|0;l=m*+p[a+472+(h*24|0)>>3];p[k>>3]=l;j=k+8|0;p[j>>3]=m*+p[a+472+(h*24|0)+8>>3];n=k+16|0;p[n>>3]=m*+p[a+472+(h*24|0)+16>>3];o=(f[i>>2]|0)+(h*9<<3)|0;p[o>>3]=m*+p[a+592+(h*72|0)>>3]-l*l;p[o+8>>3]=m*+p[a+592+(h*72|0)+8>>3]-+p[k>>3]*+p[j>>3];p[o+16>>3]=m*+p[a+592+(h*72|0)+16>>3]-+p[k>>3]*+p[n>>3];p[o+24>>3]=m*+p[a+592+(h*72|0)+24>>3]-+p[j>>3]*+p[k>>3];l=+p[j>>3];p[o+32>>3]=m*+p[a+592+(h*72|0)+32>>3]-l*l;p[o+40>>3]=m*+p[a+592+(h*72|0)+40>>3]-+p[j>>3]*+p[n>>3];p[o+48>>3]=m*+p[a+592+(h*72|0)+48>>3]-+p[n>>3]*+p[k>>3];p[o+56>>3]=m*+p[a+592+(h*72|0)+56>>3]-+p[n>>3]*+p[j>>3];l=+p[n>>3];p[o+64>>3]=m*+p[a+592+(h*72|0)+64>>3]-l*l;pba(a,h,.01)}h=h+1|0}while((h|0)!=5);u=c;return}function sba(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0.0,Mb=0.0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0;k=u;u=u+2560|0;l=k+2128|0;m=k+2072|0;o=k+2016|0;q=k+2480|0;r=k+2424|0;s=k+2368|0;t=k+2312|0;v=k+1984|0;w=k+1968|0;x=k+2296|0;y=k+1952|0;z=k+2240|0;A=k+976|0;B=k;C=k+2184|0;D=k+2536|0;do if((eS(a)|0)==65536){E=f[a+4>>2]|0;f[z>>2]=f[E>>2];F=z+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=z+8|0;f[H>>2]=f[E+8>>2];f[z+12>>2]=f[E+12>>2];f[z+16>>2]=f[E+16>>2];f[z+20>>2]=f[E+20>>2];f[z+24>>2]=f[E+24>>2];f[z+28>>2]=f[E+28>>2];f[z+32>>2]=f[E+32>>2];I=f[E+36>>2]|0;f[z+36>>2]=I;f[z+40>>2]=H;H=z+48|0;J=z+44|0;f[J>>2]=H;f[H>>2]=0;f[z+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[F>>2]=0;U$(z,E);break}}else bS(z,a,-1);while(0);a=WS(c,-1)|0;c=WS(e,-1)|0;e=WS(g,-1)|0;g=z+16|0;if(!(f[g>>2]|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;K=$Xc(16)|0;f[l>>2]=K;L=l+8|0;f[L>>2]=-2147483632;M=l+4|0;f[M>>2]=14;N=K;O=253104;P=N+14|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));Q=K+14|0;b[Q>>0]=0;vM(-5,l,253119,252873,543)}E=z+4|0;F=f[E>>2]|0;if((F|0)<3)R=Y(f[z+12>>2]|0,f[z+8>>2]|0)|0;else{G=f[z+40>>2]|0;H=0;J=1;while(1){I=Y(f[G+(H<<2)>>2]|0,J)|0;H=H+1|0;if((H|0)==(F|0)){R=I;break}else J=I}}if((F|0)==0|(R|0)==0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;K=$Xc(16)|0;f[l>>2]=K;L=l+8|0;f[L>>2]=-2147483632;M=l+4|0;f[M>>2]=14;N=K;O=253104;P=N+14|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));Q=K+14|0;b[Q>>0]=0;vM(-5,l,253119,252873,543)}if((f[z>>2]&4095|0)!=16){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Q=$Xc(32)|0;f[l>>2]=Q;f[l+8>>2]=-2147483616;f[l+4>>2]=28;N=Q;O=253127;P=N+28|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));b[Q+28>>0]=0;vM(-5,l,253119,252873,545)}oba(A,c);oba(B,e);e=z+40|0;c=f[e>>2]|0;Q=f[c+4>>2]|0;K=f[c>>2]|0;f[C>>2]=1124007936;c=C+4|0;M=C+8|0;L=C+40|0;N=c;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[L>>2]=M;M=C+48|0;R=C+44|0;f[R>>2]=M;f[M>>2]=0;f[C+52>>2]=0;f[l>>2]=K;K=l+4|0;f[K>>2]=Q;S$(C,2,l,4);Q=j|1;if((Q|0)==1){if(!j){F=f[e>>2]|0;J=f[F+4>>2]|0;H=f[F>>2]|0;f[D>>2]=f[d>>2];F=D+4|0;f[F>>2]=f[d+4>>2];G=D+8|0;f[G>>2]=f[d+8>>2];I=D+12|0;f[I>>2]=f[d+12>>2];if(!(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(H|0):0)?(f[a+12>>2]|0)==(J|0):0)?(f[a>>2]&4095|0)==0:0)?(f[a+16>>2]|0)!=0:0)){f[l>>2]=H;f[K>>2]=J;S$(a,2,l,0)}p[m>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;mR(a,l,fT()|0)|0;d=f[D>>2]|0;S=(d|0)>0?d:0;f[D>>2]=S;d=f[F>>2]|0;T=(d|0)>0?d:0;f[F>>2]=T;F=J-S|0;S=f[G>>2]|0;f[G>>2]=(F|0)<(S|0)?F:S;S=H-T|0;T=f[I>>2]|0;f[I>>2]=(S|0)<(T|0)?S:T;Z$(l,a,D);p[o>>3]=3.0;D=o+8|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[m>>2]=-1056833530;f[m+4>>2]=o;f[m+8>>2]=1;f[m+12>>2]=4;mR(l,m,fT()|0)|0;D=l+36|0;T=f[D>>2]|0;if(T|0?(S=T+12|0,T=f[S>>2]|0,f[S>>2]=T+-1,(T|0)==1):0)V$(l);f[D>>2]=0;D=l+16|0;T=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[T>>2]|0)>0){D=f[l+40>>2]|0;S=0;do{f[D+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[T>>2]|0))}T=f[l+44>>2]|0;if((T|0)!=(l+48|0))wL(T);U=z+8|0}else{T=z+8|0;tba(f[T>>2]|0,f[z+12>>2]|0,a);U=T}f[m>>2]=1124007936;T=m+4|0;S=m+8|0;D=m+40|0;N=T;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[D>>2]=S;S=m+48|0;I=m+44|0;f[I>>2]=S;f[S>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;H=o+4|0;F=o+8|0;G=o+40|0;N=H;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[G>>2]=F;F=o+48|0;J=o+44|0;f[J>>2]=F;f[F>>2]=0;f[o+52>>2]=0;f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;f[r>>2]=0;X=r+4|0;f[X>>2]=0;f[r+8>>2]=0;Z=f[U>>2]|0;if((Z|0)<=0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;_=$Xc(48)|0;f[l>>2]=_;$=l+8|0;f[$>>2]=-2147483600;aa=l+4|0;f[aa>>2]=42;N=_;O=253156;P=N+42|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));ba=_+42|0;b[ba>>0]=0;vM(-215,l,253199,252873,382)}ca=z+12|0;da=a+16|0;ea=a+44|0;fa=z+44|0;ga=l+4|0;ha=l+8|0;ia=r+8|0;ja=l+4|0;ka=l+8|0;la=q+8|0;ma=Z;Z=f[ca>>2]|0;na=0;while(1){if((Z|0)>0){oa=0;do{pa=(f[da>>2]|0)+(Y(f[f[ea>>2]>>2]|0,na)|0)+oa|0;switch(b[pa>>0]|0){case 2:case 0:{pa=(f[g>>2]|0)+(Y(f[f[fa>>2]>>2]|0,na)|0)|0;qa=+(h[pa+(oa*3|0)>>0]|0);n[l>>2]=qa;n[ja>>2]=+(h[pa+(oa*3|0)+1>>0]|0);n[ka>>2]=+(h[pa+(oa*3|0)+2>>0]|0);pa=f[d>>2]|0;if(pa>>>0<(f[la>>2]|0)>>>0){n[pa>>2]=qa;f[pa+4>>2]=f[ja>>2];f[pa+8>>2]=f[ka>>2];f[d>>2]=pa+12}else uba(q,l);break}default:{pa=(f[g>>2]|0)+(Y(f[f[fa>>2]>>2]|0,na)|0)|0;qa=+(h[pa+(oa*3|0)>>0]|0);n[l>>2]=qa;n[ga>>2]=+(h[pa+(oa*3|0)+1>>0]|0);n[ha>>2]=+(h[pa+(oa*3|0)+2>>0]|0);pa=f[X>>2]|0;if(pa>>>0<(f[ia>>2]|0)>>>0){n[pa>>2]=qa;f[pa+4>>2]=f[ga>>2];f[pa+8>>2]=f[ha>>2];f[X>>2]=pa+12}else uba(r,l)}}oa=oa+1|0;ra=f[ca>>2]|0}while((oa|0)<(ra|0));sa=ra;ta=f[U>>2]|0}else{sa=Z;ta=ma}na=na+1|0;if((na|0)>=(ta|0))break;else{ma=ta;Z=sa}}sa=f[q>>2]|0;Z=f[d>>2]|0;ta=Z;ma=sa;if((sa|0)==(Z|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;_=$Xc(48)|0;f[l>>2]=_;$=l+8|0;f[$>>2]=-2147483600;aa=l+4|0;f[aa>>2]=42;N=_;O=253156;P=N+42|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));ba=_+42|0;b[ba>>0]=0;vM(-215,l,253199,252873,382)}if((f[r>>2]|0)==(f[X>>2]|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;_=$Xc(48)|0;f[l>>2]=_;$=l+8|0;f[$>>2]=-2147483600;aa=l+4|0;f[aa>>2]=42;N=_;O=253156;P=N+42|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));ba=_+42|0;b[ba>>0]=0;vM(-215,l,253199,252873,382)}ba=ta-ma|0;f[s>>2]=1124007941;ma=s+4|0;f[ma>>2]=2;ta=s+8|0;f[ta>>2]=(ba|0)/12|0;f[s+12>>2]=3;_=s+16|0;f[_>>2]=sa;f[s+20>>2]=sa;aa=s+24|0;$=s+40|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;f[$>>2]=ta;ta=s+48|0;Z=s+44|0;f[Z>>2]=ta;na=s+52|0;f[na>>2]=0;f[ta>>2]=0;if((sa|0)==0&(ba|0)!=0){U=$Xc(32)|0;f[l>>2]=U;f[l+8>>2]=-2147483616;f[l+4>>2]=28;N=U;O=470314;P=N+28|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));b[U+28>>0]=0;vM(-215,l,470343,470347,548)}f[ta>>2]=12;f[na>>2]=4;na=sa+ba|0;f[s+28>>2]=na;f[aa>>2]=na+-12+12;R$(s);f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=s;na=v+8|0;f[na>>2]=0;f[na+4>>2]=0;f[v>>2]=50397184;f[v+4>>2]=m;f[w>>2]=1;f[w+4>>2]=10;p[w+8>>3]=0.0;na=fT()|0;f[l>>2]=f[w>>2];f[l+4>>2]=f[w+4>>2];f[l+8>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];+hQ(t,5,v,l,0,2,na);na=f[r>>2]|0;w=(f[X>>2]|0)-na|0;aa=na;f[t>>2]=1124007941;ba=t+4|0;f[ba>>2]=2;sa=t+8|0;f[sa>>2]=(w|0)/12|0;f[t+12>>2]=3;U=t+16|0;f[U>>2]=aa;f[t+20>>2]=aa;ra=t+24|0;ca=t+40|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;f[ca>>2]=sa;sa=t+48|0;ha=t+44|0;f[ha>>2]=sa;ga=t+52|0;f[ga>>2]=0;f[sa>>2]=0;if((na|0)==0&(w|0)!=0){na=$Xc(32)|0;f[l>>2]=na;f[l+8>>2]=-2147483616;f[l+4>>2]=28;N=na;O=470314;P=N+28|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));b[na+28>>0]=0;vM(-215,l,470343,470347,548)}f[sa>>2]=12;f[ga>>2]=4;ga=aa+w|0;f[t+28>>2]=ga;f[ra>>2]=ga+-12+12;R$(t);f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=t;ga=x+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[x>>2]=50397184;f[x+4>>2]=o;f[y>>2]=1;f[y+4>>2]=10;p[y+8>>3]=0.0;ga=fT()|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];f[l+8>>2]=f[y+8>>2];f[l+12>>2]=f[y+12>>2];+hQ(v,5,x,l,0,2,ga);g1c(A+472|0,0,504)|0;ga=f[q>>2]|0;x=(f[d>>2]|0)-ga|0;y=ga;if((x|0)>0){ga=f[m+16>>2]|0;ra=f[I>>2]|0;w=A+972|0;aa=(x>>>0)/12|0;x=0;do{na=ga+(Y(f[ra>>2]|0,x)|0)|0;ia=f[na>>2]|0;qa=+n[y+(x*12|0)>>2];ua=+n[y+(x*12|0)+4>>2];va=+n[y+(x*12|0)+8>>2];na=A+472+(ia*24|0)|0;p[na>>3]=qa+ +p[na>>3];na=A+472+(ia*24|0)+8|0;p[na>>3]=ua+ +p[na>>3];na=A+472+(ia*24|0)+16|0;p[na>>3]=va+ +p[na>>3];na=A+592+(ia*72|0)|0;p[na>>3]=qa*qa+ +p[na>>3];wa=qa*ua;na=A+592+(ia*72|0)+8|0;p[na>>3]=wa+ +p[na>>3];xa=qa*va;na=A+592+(ia*72|0)+16|0;p[na>>3]=xa+ +p[na>>3];na=A+592+(ia*72|0)+24|0;p[na>>3]=wa+ +p[na>>3];na=A+592+(ia*72|0)+32|0;p[na>>3]=ua*ua+ +p[na>>3];wa=ua*va;na=A+592+(ia*72|0)+40|0;p[na>>3]=wa+ +p[na>>3];na=A+592+(ia*72|0)+48|0;p[na>>3]=xa+ +p[na>>3];na=A+592+(ia*72|0)+56|0;p[na>>3]=wa+ +p[na>>3];na=A+592+(ia*72|0)+64|0;p[na>>3]=va*va+ +p[na>>3];na=A+952+(ia<<2)|0;f[na>>2]=(f[na>>2]|0)+1;f[w>>2]=(f[w>>2]|0)+1;x=x+1|0}while((x|0)<(aa|0))}rba(A);g1c(B+472|0,0,504)|0;aa=f[r>>2]|0;x=(f[X>>2]|0)-aa|0;w=aa;if((x|0)>0){aa=f[o+16>>2]|0;y=f[J>>2]|0;ra=B+972|0;ga=(x>>>0)/12|0;x=0;do{na=aa+(Y(f[y>>2]|0,x)|0)|0;ia=f[na>>2]|0;va=+n[w+(x*12|0)>>2];wa=+n[w+(x*12|0)+4>>2];xa=+n[w+(x*12|0)+8>>2];na=B+472+(ia*24|0)|0;p[na>>3]=va+ +p[na>>3];na=B+472+(ia*24|0)+8|0;p[na>>3]=wa+ +p[na>>3];na=B+472+(ia*24|0)+16|0;p[na>>3]=xa+ +p[na>>3];na=B+592+(ia*72|0)|0;p[na>>3]=va*va+ +p[na>>3];ua=va*wa;na=B+592+(ia*72|0)+8|0;p[na>>3]=ua+ +p[na>>3];qa=va*xa;na=B+592+(ia*72|0)+16|0;p[na>>3]=qa+ +p[na>>3];na=B+592+(ia*72|0)+24|0;p[na>>3]=ua+ +p[na>>3];na=B+592+(ia*72|0)+32|0;p[na>>3]=wa*wa+ +p[na>>3];ua=wa*xa;na=B+592+(ia*72|0)+40|0;p[na>>3]=ua+ +p[na>>3];na=B+592+(ia*72|0)+48|0;p[na>>3]=qa+ +p[na>>3];na=B+592+(ia*72|0)+56|0;p[na>>3]=ua+ +p[na>>3];na=B+592+(ia*72|0)+64|0;p[na>>3]=xa*xa+ +p[na>>3];na=B+952+(ia<<2)|0;f[na>>2]=(f[na>>2]|0)+1;f[ra>>2]=(f[ra>>2]|0)+1;x=x+1|0}while((x|0)<(ga|0))}rba(B);ga=t+36|0;x=f[ga>>2]|0;if(x|0?(ra=x+12|0,x=f[ra>>2]|0,f[ra>>2]=x+-1,(x|0)==1):0)V$(t);f[ga>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[ba>>2]|0)>0){U=f[ca>>2]|0;ca=0;do{f[U+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ba>>2]|0))}ba=f[ha>>2]|0;if((ba|0)!=(sa|0))wL(ba);ba=s+36|0;sa=f[ba>>2]|0;do if(sa|0){ha=sa+12|0;ca=f[ha>>2]|0;f[ha>>2]=ca+-1;if((ca|0)!=1)break;V$(s)}while(0);f[ba>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[ma>>2]|0)>0){_=f[$>>2]|0;$=0;do{f[_+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[ma>>2]|0))}ma=f[Z>>2]|0;if((ma|0)!=(ta|0))wL(ma);ma=f[r>>2]|0;if(ma|0){ta=f[X>>2]|0;if((ta|0)!=(ma|0))f[X>>2]=ta+(~(((ta+-12-ma|0)>>>0)/12|0)*12|0);cYc(ma)}ma=f[q>>2]|0;if(ma|0){ta=f[d>>2]|0;if((ta|0)!=(ma|0))f[d>>2]=ta+(~(((ta+-12-ma|0)>>>0)/12|0)*12|0);cYc(ma)}ma=o+36|0;ta=f[ma>>2]|0;do if(ta|0){d=ta+12|0;X=f[d>>2]|0;f[d>>2]=X+-1;if((X|0)!=1)break;V$(o)}while(0);f[ma>>2]=0;ma=o+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[H>>2]|0)>0){ma=f[G>>2]|0;G=0;do{f[ma+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[H>>2]|0))}H=f[J>>2]|0;if((H|0)!=(F|0))wL(H);H=m+36|0;F=f[H>>2]|0;do if(F|0){J=F+12|0;G=f[J>>2]|0;f[J>>2]=G+-1;if((G|0)!=1)break;V$(m)}while(0);f[H>>2]=0;H=m+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[T>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[T>>2]|0))}T=f[I>>2]|0;if((T|0)!=(S|0))wL(T)}if((i|0)>=1){T=(j|0)==3;j=T?1:i;i=z+8|0;if((Q|0)==3)tba(f[i>>2]|0,f[z+12>>2]|0,a);Q=f[i>>2]|0;S=z+12|0;I=f[S>>2]|0;if((Q|0)>0){D=(I|0)>0;H=f[g>>2]|0;F=f[z+44>>2]|0;G=I+-1|0;J=0;xa=0.0;while(1){a:do if(D){ma=f[F>>2]|0;ta=H+(Y(ma,J)|0)|0;X=H+(Y(ma,J+-1|0)|0)|0;if((J|0)>0){ya=0;za=xa}else{ma=0;ua=xa;while(1){if((ma|0)>0){d=ma+-1|0;qa=+(h[ta+(ma*3|0)>>0]|0)-+(h[ta+(d*3|0)>>0]|0);wa=+(h[ta+(ma*3|0)+1>>0]|0)-+(h[ta+(d*3|0)+1>>0]|0);va=+(h[ta+(ma*3|0)+2>>0]|0)-+(h[ta+(d*3|0)+2>>0]|0);Aa=ua+(qa*qa+0.0+wa*wa+va*va)}else Aa=ua;ma=ma+1|0;if((ma|0)==(I|0)){Ba=Aa;break a}else ua=Aa}}while(1){ua=+(h[ta+(ya*3|0)>>0]|0);va=+(h[ta+(ya*3|0)+1>>0]|0);wa=+(h[ta+(ya*3|0)+2>>0]|0);if((ya|0)>0){ma=ya+-1|0;qa=ua-+(h[ta+(ma*3|0)>>0]|0);Ca=va-+(h[ta+(ma*3|0)+1>>0]|0);Da=wa-+(h[ta+(ma*3|0)+2>>0]|0);Ea=ua-+(h[X+(ma*3|0)>>0]|0);Fa=va-+(h[X+(ma*3|0)+1>>0]|0);Ga=wa-+(h[X+(ma*3|0)+2>>0]|0);Ha=za+(qa*qa+0.0+Ca*Ca+Da*Da)+(Ea*Ea+0.0+Fa*Fa+Ga*Ga)}else Ha=za;Ga=ua-+(h[X+(ya*3|0)>>0]|0);Fa=va-+(h[X+(ya*3|0)+1>>0]|0);Ea=wa-+(h[X+(ya*3|0)+2>>0]|0);Da=Ha+(Ga*Ga+0.0+Fa*Fa+Ea*Ea);ma=ya;ya=ya+1|0;if((ma|0)<(G|0)){Ea=ua-+(h[X+(ya*3|0)>>0]|0);ua=va-+(h[X+(ya*3|0)+1>>0]|0);va=wa-+(h[X+(ya*3|0)+2>>0]|0);Ia=Da+(Ea*Ea+0.0+ua*ua+va*va)}else Ia=Da;if((ya|0)==(I|0)){Ba=Ia;break}else za=Ia}}else Ba=xa;while(0);J=J+1|0;if((J|0)==(Q|0))break;else xa=Ba}if(!(Ba<=2.220446049250313e-16))Ja=1.0/(Ba*2.0/+((Y(Q,-3)|0)+2+(Y(I,(Q<<2)+-3|0)|0)|0));else Ja=0.0}else Ja=0.0;f[q>>2]=1124007936;J=q+4|0;ya=q+8|0;G=q+40|0;N=J;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[G>>2]=ya;ya=q+48|0;H=q+44|0;f[H>>2]=ya;f[ya>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;F=r+4|0;D=r+8|0;X=r+40|0;N=F;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[X>>2]=D;ta=r+48|0;ma=r+44|0;f[ma>>2]=ta;f[ta>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;d=s+4|0;Z=s+8|0;$=s+40|0;N=d;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[$>>2]=Z;_=s+48|0;ba=s+44|0;f[ba>>2]=_;f[_>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;sa=t+4|0;ca=t+8|0;ha=t+40|0;N=sa;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[ha>>2]=ca;U=t+48|0;ga=t+44|0;f[ga>>2]=U;f[U>>2]=0;f[t+52>>2]=0;f[l>>2]=Q;f[K>>2]=I;S$(q,2,l,6);I=f[i>>2]|0;Q=f[S>>2]|0;x=f[D>>2]|0;if((((f[F>>2]|0)<3&(x|0)==(I|0)?(f[r+12>>2]|0)==(Q|0):0)?(f[r>>2]&4095|0)==6:0)?(f[r+16>>2]|0)!=0:0){Ka=I;La=x;Ma=Q}else{f[l>>2]=I;f[K>>2]=Q;S$(r,2,l,6);Q=f[i>>2]|0;Ka=Q;La=Q;Ma=f[S>>2]|0}if(((((f[d>>2]|0)<3?(f[Z>>2]|0)==(La|0):0)?(f[s+12>>2]|0)==(Ma|0):0)?(f[s>>2]&4095|0)==6:0)?(f[s+16>>2]|0)!=0:0){Na=Ka;Oa=La;Pa=Ma}else{f[l>>2]=La;f[K>>2]=Ma;S$(s,2,l,6);Ma=f[i>>2]|0;Na=Ma;Oa=Ma;Pa=f[S>>2]|0}if(((((f[sa>>2]|0)<3?(f[ca>>2]|0)==(Oa|0):0)?(f[t+12>>2]|0)==(Pa|0):0)?(f[t>>2]&4095|0)==6:0)?(f[t+16>>2]|0)!=0:0){Qa=Na;Ra=Oa}else{f[l>>2]=Oa;f[K>>2]=Pa;S$(t,2,l,6);Pa=f[i>>2]|0;Qa=Pa;Ra=Pa}if((Ra|0)>0){Pa=z+44|0;K=q+16|0;Oa=r+16|0;Na=s+16|0;ca=t+16|0;Ma=f[S>>2]|0;La=(Ma|0)>0;Ka=0;do{if(La){Z=(Ka|0)>0;Q=f[g>>2]|0;I=f[f[Pa>>2]>>2]|0;x=Q+(Y(I,Ka)|0)|0;D=Q+(Y(I,Ka+-1|0)|0)|0;I=0;while(1){Ba=+(h[x+(I*3|0)>>0]|0);xa=+(h[x+(I*3|0)+1>>0]|0);Ia=+(h[x+(I*3|0)+2>>0]|0);Q=I+-1|0;do if((I|0)>0){za=Ba-+(h[x+(Q*3|0)>>0]|0);Ha=xa-+(h[x+(Q*3|0)+1>>0]|0);Aa=Ia-+(h[x+(Q*3|0)+2>>0]|0);Da=+V(+-(Ja*(za*za+0.0+Ha*Ha+Aa*Aa)))*50.0;ra=(f[K>>2]|0)+(Y(f[f[H>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[ra>>3]=Da;if(Z){Da=Ba-+(h[D+(Q*3|0)>>0]|0);Aa=xa-+(h[D+(Q*3|0)+1>>0]|0);Ha=Ia-+(h[D+(Q*3|0)+2>>0]|0);za=+V(+-(Ja*(Da*Da+0.0+Aa*Aa+Ha*Ha)))*35.35533966440824;ra=(f[Oa>>2]|0)+(Y(f[f[ma>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[ra>>3]=za;Sa=151;break}else{ra=(f[Oa>>2]|0)+(Y(f[f[ma>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[ra>>3]=0.0;Sa=150;break}}else{ra=(f[K>>2]|0)+(Y(f[f[H>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[ra>>3]=0.0;ra=(f[Oa>>2]|0)+(Y(f[f[ma>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[ra>>3]=0.0;if(Z)Sa=151;else Sa=150}while(0);do if((Sa|0)==150){Sa=0;Q=(f[Na>>2]|0)+(Y(f[f[ba>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[Q>>3]=0.0;Ta=I+1|0;Ua=0.0}else if((Sa|0)==151){Sa=0;za=Ba-+(h[D+(I*3|0)>>0]|0);Ha=xa-+(h[D+(I*3|0)+1>>0]|0);Aa=Ia-+(h[D+(I*3|0)+2>>0]|0);Da=+V(+-(Ja*(za*za+0.0+Ha*Ha+Aa*Aa)))*50.0;Q=(f[Na>>2]|0)+(Y(f[f[ba>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[Q>>3]=Da;Q=I+1|0;if((Q|0)>=(Ma|0)){Ta=Q;Ua=0.0;break}Da=Ba-+(h[D+(Q*3|0)>>0]|0);Aa=xa-+(h[D+(Q*3|0)+1>>0]|0);Ha=Ia-+(h[D+(Q*3|0)+2>>0]|0);Ta=Q;Ua=+V(+-(Ja*(Da*Da+0.0+Aa*Aa+Ha*Ha)))*35.35533966440824}while(0);Q=(f[ca>>2]|0)+(Y(f[f[ga>>2]>>2]|0,Ka)|0)+(I<<3)|0;p[Q>>3]=Ua;if((Ta|0)<(Ma|0))I=Ta;else break}}Ka=Ka+1|0}while((Ka|0)!=(Ra|0))}b:do if((j|0)>0){Ra=z+44|0;Ka=a+16|0;Ta=a+44|0;Ma=l+8|0;ca=l+16|0;Na=C+16|0;Oa=l+8|0;K=l+16|0;Pa=v+12|0;La=v+24|0;I=v+4|0;D=v+8|0;Z=A+56|0;x=l+8|0;Q=l+16|0;ra=B+56|0;w=l+8|0;y=l+16|0;aa=q+16|0;na=r+16|0;ia=s+16|0;fa=t+16|0;ka=a+8|0;ja=a+12|0;la=v+12|0;ea=v+16|0;da=A+472|0;oa=B+472|0;pa=0;Va=Qa;c:while(1){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[v+28>>2]=0;if((Va|0)>0){Wa=f[S>>2]|0;Xa=Va;Ya=0;while(1){if((Wa|0)>0){Za=0;do{_a=(f[g>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Ya)|0)|0;Ua=+(h[_a+(Za*3|0)>>0]|0);Ja=+(h[_a+(Za*3|0)+1>>0]|0);Ia=+(h[_a+(Za*3|0)+2>>0]|0);_a=(f[Ka>>2]|0)+(Y(f[f[Ta>>2]>>2]|0,Ya)|0)+Za|0;switch(b[_a>>0]|0){case 2:case 0:{p[l>>3]=Ua;p[Oa>>3]=Ja;p[K>>3]=Ia;xa=+qba(A,0,l);Ba=xa>0.0?xa:0.0;p[l>>3]=Ua;p[Oa>>3]=Ja;p[K>>3]=Ia;xa=+qba(A,1,l);_a=xa>Ba;Ha=_a?xa:Ba;p[l>>3]=Ua;p[Oa>>3]=Ja;p[K>>3]=Ia;Ba=+qba(A,2,l);$a=Ba>Ha;xa=$a?Ba:Ha;p[l>>3]=Ua;p[Oa>>3]=Ja;p[K>>3]=Ia;Ha=+qba(A,3,l);ab=Ha>xa;p[l>>3]=Ua;p[Oa>>3]=Ja;p[K>>3]=Ia;Ba=+qba(A,4,l);bb=Ba>(ab?Ha:xa)?4:ab?3:$a?2:_a&1;break}default:{p[l>>3]=Ua;p[Ma>>3]=Ja;p[ca>>3]=Ia;xa=+qba(B,0,l);Ha=xa>0.0?xa:0.0;p[l>>3]=Ua;p[Ma>>3]=Ja;p[ca>>3]=Ia;xa=+qba(B,1,l);_a=xa>Ha;Ba=_a?xa:Ha;p[l>>3]=Ua;p[Ma>>3]=Ja;p[ca>>3]=Ia;Ha=+qba(B,2,l);$a=Ha>Ba;xa=$a?Ha:Ba;p[l>>3]=Ua;p[Ma>>3]=Ja;p[ca>>3]=Ia;Ba=+qba(B,3,l);ab=Ba>xa;p[l>>3]=Ua;p[Ma>>3]=Ja;p[ca>>3]=Ia;Ia=+qba(B,4,l);bb=Ia>(ab?Ba:xa)?4:ab?3:$a?2:_a&1}}_a=(f[Na>>2]|0)+(Y(f[f[R>>2]>>2]|0,Ya)|0)+(Za<<2)|0;f[_a>>2]=bb;Za=Za+1|0;cb=f[S>>2]|0}while((Za|0)<(cb|0));db=f[i>>2]|0;eb=cb}else{db=Xa;eb=Wa}Ya=Ya+1|0;if((Ya|0)>=(db|0)){fb=db;break}else{Wa=eb;Xa=db}}}else fb=Va;if(T)gb=fb;else{g1c(da|0,0,504)|0;g1c(oa|0,0,504)|0;Xa=0;Wa=fb;while(1){if((Wa|0)>0){Ya=B+472+(Xa*24|0)|0;Za=B+472+(Xa*24|0)+8|0;_a=B+472+(Xa*24|0)+16|0;$a=B+592+(Xa*72|0)|0;ab=B+592+(Xa*72|0)+8|0;hb=B+592+(Xa*72|0)+16|0;ib=B+592+(Xa*72|0)+24|0;jb=B+592+(Xa*72|0)+32|0;kb=B+592+(Xa*72|0)+40|0;lb=B+592+(Xa*72|0)+48|0;mb=B+592+(Xa*72|0)+56|0;nb=A+472+(Xa*24|0)|0;ob=A+472+(Xa*24|0)+8|0;pb=A+472+(Xa*24|0)+16|0;qb=A+592+(Xa*72|0)|0;rb=A+592+(Xa*72|0)+8|0;sb=A+592+(Xa*72|0)+16|0;tb=A+592+(Xa*72|0)+24|0;ub=A+592+(Xa*72|0)+32|0;vb=A+592+(Xa*72|0)+40|0;wb=A+592+(Xa*72|0)+48|0;xb=A+592+(Xa*72|0)+56|0;yb=f[S>>2]|0;zb=(yb|0)>0;Ab=Wa;Bb=0;while(1){if(zb){Cb=f[Na>>2]|0;Db=f[R>>2]|0;Eb=0;while(1){Fb=Cb+(Y(f[Db>>2]|0,Bb)|0)+(Eb<<2)|0;if((f[Fb>>2]|0)==(Xa|0)){Fb=(f[Ka>>2]|0)+(Y(f[f[Ta>>2]>>2]|0,Bb)|0)+Eb|0;switch(b[Fb>>0]|0){case 2:case 0:{Fb=(f[g>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Bb)|0)|0;xa=+(h[Fb+(Eb*3|0)>>0]|0);Ba=+(h[Fb+(Eb*3|0)+1>>0]|0);Ia=+(h[Fb+(Eb*3|0)+2>>0]|0);p[nb>>3]=xa+ +p[nb>>3];p[ob>>3]=Ba+ +p[ob>>3];p[pb>>3]=Ia+ +p[pb>>3];p[qb>>3]=xa*xa+ +p[qb>>3];Ja=xa*Ba;p[rb>>3]=Ja+ +p[rb>>3];Ua=xa*Ia;p[sb>>3]=Ua+ +p[sb>>3];p[tb>>3]=Ja+ +p[tb>>3];p[ub>>3]=Ba*Ba+ +p[ub>>3];Ja=Ba*Ia;p[vb>>3]=Ja+ +p[vb>>3];p[wb>>3]=Ua+ +p[wb>>3];p[xb>>3]=Ja+ +p[xb>>3];Gb=Ia*Ia;Hb=A;break}default:{Fb=(f[g>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Bb)|0)|0;Ia=+(h[Fb+(Eb*3|0)>>0]|0);Ja=+(h[Fb+(Eb*3|0)+1>>0]|0);Ua=+(h[Fb+(Eb*3|0)+2>>0]|0);p[Ya>>3]=Ia+ +p[Ya>>3];p[Za>>3]=Ja+ +p[Za>>3];p[_a>>3]=Ua+ +p[_a>>3];p[$a>>3]=Ia*Ia+ +p[$a>>3];Ba=Ia*Ja;p[ab>>3]=Ba+ +p[ab>>3];xa=Ia*Ua;p[hb>>3]=xa+ +p[hb>>3];p[ib>>3]=Ba+ +p[ib>>3];p[jb>>3]=Ja*Ja+ +p[jb>>3];Ba=Ja*Ua;p[kb>>3]=Ba+ +p[kb>>3];p[lb>>3]=xa+ +p[lb>>3];p[mb>>3]=Ba+ +p[mb>>3];Gb=Ua*Ua;Hb=B}}Fb=Hb+592+(Xa*72|0)+64|0;p[Fb>>3]=Gb+ +p[Fb>>3];Fb=Hb+952+(Xa<<2)|0;f[Fb>>2]=(f[Fb>>2]|0)+1;Fb=Hb+972|0;f[Fb>>2]=(f[Fb>>2]|0)+1}Eb=Eb+1|0;if((Eb|0)>=(yb|0)){Ib=fb;break}}}else Ib=Ab;Bb=Bb+1|0;if((Bb|0)>=(Ib|0)){Jb=Ib;break}else Ab=Ib}}else Jb=Wa;Xa=Xa+1|0;if((Xa|0)==5)break;else Wa=Jb}rba(A);rba(B);gb=f[i>>2]|0}Wa=f[S>>2]|0;vba(v,Y(gb,Wa)|0);wba(Pa,((Y(gb+Wa|0,-3)|0)+(Y(Wa<<2,gb)|0)<<1)+6|0);p[La>>3]=0.0;Wa=f[i>>2]|0;if((Wa|0)>0){Xa=f[S>>2]|0;Ab=Wa;Wa=0;while(1){if((Xa|0)>0){Bb=(Wa|0)>0;yb=0;do{N=l;P=N+40|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));mb=f[I>>2]|0;if((mb|0)==(f[D>>2]|0)){xba(v,l);Kb=f[I>>2]|0}else{N=mb;O=l;P=N+40|0;do{f[N>>2]=f[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));lb=mb+40|0;f[I>>2]=lb;Kb=lb}lb=Kb-(f[v>>2]|0)|0;kb=(lb|0)/40|0;jb=kb+-1|0;ib=(f[g>>2]|0)+(Y(f[f[Ra>>2]>>2]|0,Wa)|0)|0;hb=(f[Ka>>2]|0)+(Y(f[f[Ta>>2]>>2]|0,Wa)|0)+yb|0;ab=b[hb>>0]|0;if((ab&-2)<<24>>24==2){Ua=+(h[ib+(yb*3|0)>>0]|0);Ba=+(h[ib+(yb*3|0)+1>>0]|0);xa=+(h[ib+(yb*3|0)+2>>0]|0);Ja=+p[f[Z>>2]>>3];p[l>>3]=Ua;p[x>>3]=Ba;p[Q>>3]=xa;Ia=+qba(A,0,l);Ha=+p[(f[Z>>2]|0)+8>>3];p[l>>3]=Ua;p[x>>3]=Ba;p[Q>>3]=xa;Aa=+qba(A,1,l);Da=+p[(f[Z>>2]|0)+16>>3];p[l>>3]=Ua;p[x>>3]=Ba;p[Q>>3]=xa;za=+qba(A,2,l);va=+p[(f[Z>>2]|0)+24>>3];p[l>>3]=Ua;p[x>>3]=Ba;p[Q>>3]=xa;ua=+qba(A,3,l);Ea=+p[(f[Z>>2]|0)+32>>3];p[l>>3]=Ua;p[x>>3]=Ba;p[Q>>3]=xa;wa=-+W(+(Ja*Ia+0.0+Ha*Aa+Da*za+va*ua+Ea*+qba(A,4,l)));Ea=+p[f[ra>>2]>>3];p[l>>3]=Ua;p[w>>3]=Ba;p[y>>3]=xa;ua=+qba(B,0,l);va=+p[(f[ra>>2]|0)+8>>3];p[l>>3]=Ua;p[w>>3]=Ba;p[y>>3]=xa;za=+qba(B,1,l);Da=+p[(f[ra>>2]|0)+16>>3];p[l>>3]=Ua;p[w>>3]=Ba;p[y>>3]=xa;Aa=+qba(B,2,l);Ha=+p[(f[ra>>2]|0)+24>>3];p[l>>3]=Ua;p[w>>3]=Ba;p[y>>3]=xa;Ia=+qba(B,3,l);Ja=+p[(f[ra>>2]|0)+32>>3];p[l>>3]=Ua;p[w>>3]=Ba;p[y>>3]=xa;Lb=wa;Mb=-+W(+(Ea*ua+0.0+va*za+Da*Aa+Ha*Ia+Ja*+qba(B,4,l)))}else{ib=ab<<24>>24==0;Lb=ib?0.0:450.0;Mb=ib?450.0:0.0}if((lb|0)<=0){Sa=222;break c}lb=f[v>>2]|0;if((((f[I>>2]|0)-lb|0)/40|0|0)<(kb|0)){Sa=222;break c}ib=lb+(jb*40|0)+24|0;Ja=+p[ib>>3];lb=Ja>0.0;Ia=lb?Mb:Mb-Ja;Ha=lb?Lb+Ja:Lb;p[La>>3]=+p[La>>3]+(Ha<Ia?Ha:Ia);p[ib>>3]=Ha-Ia;do if((yb|0)<=0){if(Bb)Sa=227}else{ib=(f[aa>>2]|0)+(Y(f[f[H>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ia=+p[ib>>3];ib=kb+-2|0;yba(v,jb,ib,Ia,Ia);if(!Bb)break;lb=(f[na>>2]|0)+(Y(f[f[ma>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ia=+p[lb>>3];yba(v,jb,ib-(f[S>>2]|0)|0,Ia,Ia);Sa=227}while(0);do if((Sa|0)==227){Sa=0;mb=(f[ia>>2]|0)+(Y(f[f[ba>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ia=+p[mb>>3];yba(v,jb,jb-(f[S>>2]|0)|0,Ia,Ia);mb=f[S>>2]|0;if((yb|0)>=(mb+-1|0))break;ib=(f[fa>>2]|0)+(Y(f[f[ga>>2]>>2]|0,Wa)|0)+(yb<<3)|0;Ia=+p[ib>>3];yba(v,jb,kb-mb|0,Ia,Ia)}while(0);yb=yb+1|0;Nb=f[S>>2]|0}while((yb|0)<(Nb|0));Ob=f[i>>2]|0;Pb=Nb}else{Ob=Ab;Pb=Xa}Wa=Wa+1|0;if((Wa|0)>=(Ob|0))break;else{Xa=Pb;Ab=Ob}}}+zba(v);Ab=f[ka>>2]|0;if((Ab|0)>0){Xa=f[ja>>2]|0;Wa=Ab;Ab=0;while(1){if((Xa|0)>0){yb=Xa;Bb=0;while(1){kb=(f[Ka>>2]|0)+(Y(f[f[Ta>>2]>>2]|0,Ab)|0)+Bb|0;if((b[kb>>0]&-2)<<24>>24==2){jb=(Y(yb,Ab)|0)+Bb|0;if((jb|0)<=-1){Sa=238;break c}mb=f[v>>2]|0;if((((f[I>>2]|0)-mb|0)/40|0|0)<=(jb|0)){Sa=238;break c}ib=(b[mb+(jb*40|0)+32>>0]|0)==0;jb=ib?m:o;f[jb>>2]=Bb;f[jb+4>>2]=Ab;b[kb>>0]=ib?3:2;Qb=f[ja>>2]|0}else Qb=yb;Bb=Bb+1|0;if((Bb|0)>=(Qb|0))break;else yb=Qb}Rb=f[ka>>2]|0;Sb=Qb}else{Rb=Wa;Sb=Xa}Ab=Ab+1|0;if((Ab|0)>=(Rb|0))break;else{Xa=Sb;Wa=Rb}}}Wa=f[la>>2]|0;if(Wa|0){Xa=f[ea>>2]|0;if((Xa|0)!=(Wa|0))f[ea>>2]=Xa+(~((Xa+-16-Wa|0)>>>4)<<4);cYc(Wa)}Wa=f[v>>2]|0;if(Wa|0){Xa=f[I>>2]|0;if((Xa|0)!=(Wa|0))f[I>>2]=Xa+(~(((Xa+-40-Wa|0)>>>0)/40|0)*40|0);cYc(Wa)}Wa=pa+1|0;if((Wa|0)>=(j|0))break b;pa=Wa;Va=f[i>>2]|0}if((Sa|0)==222){Va=$Xc(32)|0;f[l>>2]=Va;f[l+8>>2]=-2147483616;f[l+4>>2]=26;N=Va;O=253208;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));b[Va+26>>0]=0;vM(-215,l,253235,253250,144)}else if((Sa|0)==238){pa=$Xc(32)|0;f[l>>2]=pa;f[l+8>>2]=-2147483616;f[l+4>>2]=26;N=pa;O=253208;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));b[pa+26>>0]=0;vM(-215,l,253349,253250,384)}}while(0);l=t+36|0;O=f[l>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)V$(t);f[l>>2]=0;l=t+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[sa>>2]|0)>0){l=f[ha>>2]|0;ha=0;do{f[l+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[sa>>2]|0))}sa=f[ga>>2]|0;if((sa|0)!=(U|0))wL(sa);sa=s+36|0;U=f[sa>>2]|0;do if(U|0){ga=U+12|0;ha=f[ga>>2]|0;f[ga>>2]=ha+-1;if((ha|0)!=1)break;V$(s)}while(0);f[sa>>2]=0;sa=s+16|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[d>>2]|0)>0){sa=f[$>>2]|0;$=0;do{f[sa+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[d>>2]|0))}d=f[ba>>2]|0;if((d|0)!=(_|0))wL(d);d=r+36|0;_=f[d>>2]|0;do if(_|0){ba=_+12|0;$=f[ba>>2]|0;f[ba>>2]=$+-1;if(($|0)!=1)break;V$(r)}while(0);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[F>>2]|0)>0){d=f[X>>2]|0;X=0;do{f[d+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[F>>2]|0))}F=f[ma>>2]|0;if((F|0)!=(ta|0))wL(F);F=q+36|0;ta=f[F>>2]|0;do if(ta|0){ma=ta+12|0;X=f[ma>>2]|0;f[ma>>2]=X+-1;if((X|0)!=1)break;V$(q)}while(0);f[F>>2]=0;F=q+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[J>>2]|0)>0){F=f[G>>2]|0;G=0;do{f[F+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[J>>2]|0))}J=f[H>>2]|0;if((J|0)!=(ya|0))wL(J)}J=C+36|0;ya=f[J>>2]|0;if(ya|0?(H=ya+12|0,ya=f[H>>2]|0,f[H>>2]=ya+-1,(ya|0)==1):0)V$(C);f[J>>2]=0;J=C+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[c>>2]|0)>0){J=f[L>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[c>>2]|0))}c=f[R>>2]|0;if((c|0)!=(M|0))wL(c);c=B+36|0;M=f[c>>2]|0;if(M|0?(R=M+12|0,M=f[R>>2]|0,f[R>>2]=M+-1,(M|0)==1):0)V$(B);f[c>>2]=0;c=B+16|0;M=B+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){c=f[B+40>>2]|0;R=0;do{f[c+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[M>>2]|0))}M=f[B+44>>2]|0;if((M|0)!=(B+48|0))wL(M);M=A+36|0;B=f[M>>2]|0;if(B|0?(R=B+12|0,B=f[R>>2]|0,f[R>>2]=B+-1,(B|0)==1):0)V$(A);f[M>>2]=0;M=A+16|0;B=A+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[B>>2]|0)>0){M=f[A+40>>2]|0;R=0;do{f[M+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[B>>2]|0))}B=f[A+44>>2]|0;if((B|0)!=(A+48|0))wL(B);B=z+36|0;A=f[B>>2]|0;if(A|0?(R=A+12|0,A=f[R>>2]|0,f[R>>2]=A+-1,(A|0)==1):0)V$(z);f[B>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[E>>2]|0)>0){g=f[e>>2]|0;e=0;do{f[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[E>>2]|0))}E=f[z+44>>2]|0;if((E|0)==(z+48|0)){u=k;return}wL(E);u=k;return}function tba(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+16|0;g=e;i=f[d+16>>2]|0;if(!i){j=$Xc(16)|0;f[g>>2]=j;k=g+8|0;f[k>>2]=-2147483632;l=g+4|0;f[l>>2]=13;m=j;n=253446;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+13|0;b[p>>0]=0;vM(-5,g,253460,252873,328)}q=f[d+4>>2]|0;if((q|0)<3)r=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;else{s=f[d+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if((q|0)==0|(r|0)==0){j=$Xc(16)|0;f[g>>2]=j;k=g+8|0;f[k>>2]=-2147483632;l=g+4|0;f[l>>2]=13;m=j;n=253446;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=j+13|0;b[p>>0]=0;vM(-5,g,253460,252873,328)}if(f[d>>2]&4095|0){p=$Xc(32)|0;f[g>>2]=p;f[g+8>>2]=-2147483616;f[g+4>>2]=27;m=p;n=253470;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[p+27>>0]=0;vM(-5,g,253460,252873,330)}if((f[d+12>>2]|0)!=(c|0)){x=$Xc(48)|0;f[g>>2]=x;y=g+8|0;f[y>>2]=-2147483600;z=g+4|0;f[z>>2]=43;m=x;n=253498;o=m+43|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));A=x+43|0;b[A>>0]=0;vM(-5,g,253460,252873,332)}if((f[d+8>>2]|0)!=(a|0)){x=$Xc(48)|0;f[g>>2]=x;y=g+8|0;f[y>>2]=-2147483600;z=g+4|0;f[z>>2]=43;m=x;n=253498;o=m+43|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));A=x+43|0;b[A>>0]=0;vM(-5,g,253460,252873,332)}if(!((a|0)>0&(c|0)>0)){u=e;return}A=f[f[d+44>>2]>>2]|0;d=0;a:while(1){x=i+(Y(A,d)|0)|0;z=0;do{if((h[x+z>>0]|0)>=4){B=20;break a}z=z+1|0}while((z|0)<(c|0));d=d+1|0;if((d|0)>=(a|0)){B=19;break}}if((B|0)==19){u=e;return}else if((B|0)==20){B=$Xc(80)|0;f[g>>2]=B;f[g+8>>2]=-2147483568;f[g+4>>2]=75;m=B;n=253542;o=m+75|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[B+75>>0]=0;vM(-5,g,253460,252873,340)}}function uba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)kWc(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/12|0;l=k<<1;m=k>>>0<178956970?(l>>>0<h>>>0?h:l):357913941;do if(m)if(m>>>0>357913941){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);l=n+(g*12|0)|0;h=n+(m*12|0)|0;f[l>>2]=f[b>>2];f[n+(g*12|0)+4>>2]=f[b+4>>2];f[n+(g*12|0)+8>>2]=f[b+8>>2];b=l+12|0;if((j|0)==(i|0))o=l;else{g=j;j=l;while(1){l=j+-12|0;n=g;g=g+-12|0;f[l>>2]=f[g>>2];f[j+-8>>2]=f[n+-8>>2];f[j+-4>>2]=f[n+-4>>2];if((g|0)==(i|0)){o=l;break}else j=l}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function vba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/40|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>107374182){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=$Xc(b*40|0)|0;i=h+(((g|0)/40|0)*40|0)|0;j=i+(((g|0)/-40|0)*40|0)|0;if((g|0)>0)o1c(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*40|0);if(!d)return;cYc(d);return}function wba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>4;i=$Xc(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;cYc(d);return}function xba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/40|0;h=g+1|0;if(h>>>0>107374182)kWc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/40|0;k=j<<1;l=j>>>0<53687091?(k>>>0<h>>>0?h:k):107374182;do if(l)if(l>>>0>107374182){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l*40|0)|0;break}else m=0;while(0);k=m+(g*40|0)|0;g=m+(l*40|0)|0;l=k;m=b;b=l+40|0;do{f[l>>2]=f[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(b|0));m=k+(((e|0)/-40|0)*40|0)|0;if((e|0)>0)o1c(m|0,d|0,e|0)|0;f[a>>2]=m;f[c>>2]=k+40;f[i>>2]=g;if(!d)return;cYc(d);return}function yba(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h+16|0;j=h;if((c|0)<=-1){k=$Xc(32)|0;f[i>>2]=k;l=i+8|0;f[l>>2]=-2147483616;m=i+4|0;f[m>>2]=26;n=k;o=253208;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));r=k+26|0;b[r>>0]=0;vM(-215,i,253387,253250,119)}s=f[a>>2]|0;t=((f[a+4>>2]|0)-s|0)/40|0;v=s;if((t|0)<=(c|0)){k=$Xc(32)|0;f[i>>2]=k;l=i+8|0;f[l>>2]=-2147483616;m=i+4|0;f[m>>2]=26;n=k;o=253208;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));r=k+26|0;b[r>>0]=0;vM(-215,i,253387,253250,119)}if(!((d|0)>-1&(t|0)>(d|0))){t=$Xc(32)|0;f[i>>2]=t;f[i+8>>2]=-2147483616;f[i+4>>2]=26;n=t;o=253396;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[t+26>>0]=0;vM(-215,i,253387,253250,120)}if(!(e>=0.0&g>=0.0)){t=$Xc(16)|0;f[i>>2]=t;f[i+8>>2]=-2147483632;f[i+4>>2]=15;n=t;o=253423;q=n+15|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[t+15>>0]=0;vM(-215,i,253387,253250,121)}if((c|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=6;b[i>>0]=b[253439]|0;b[i+1>>0]=b[253440]|0;b[i+2>>0]=b[253441]|0;b[i+3>>0]=b[253442]|0;b[i+4>>0]=b[253443]|0;b[i+5>>0]=b[253444]|0;b[i+6>>0]=0;vM(-215,i,253387,253250,122)}t=a+12|0;o=a+16|0;n=f[o>>2]|0;q=f[t>>2]|0;if((n|0)==(q|0)){Bba(t,2);w=f[o>>2]|0;x=a;y=f[a>>2]|0;z=f[t>>2]|0}else{w=n;x=a;y=v;z=q}f[i>>2]=d;f[i+4>>2]=f[y+(c*40|0)+8>>2];p[i+8>>3]=e;f[y+(c*40|0)+8>>2]=w-z>>4;z=a+20|0;if((w|0)==(f[z>>2]|0)){Cba(t,i);a=f[o>>2]|0;A=a;B=a}else{a=w;f[a>>2]=f[i>>2];f[a+4>>2]=f[i+4>>2];f[a+8>>2]=f[i+8>>2];f[a+12>>2]=f[i+12>>2];i=(f[o>>2]|0)+16|0;f[o>>2]=i;A=i;B=i}f[j>>2]=c;c=(f[x>>2]|0)+(d*40|0)+8|0;f[j+4>>2]=f[c>>2];p[j+8>>3]=g;f[c>>2]=A-(f[t>>2]|0)>>4;if((B|0)==(f[z>>2]|0)){Cba(t,j);u=h;return}else{f[B>>2]=f[j>>2];f[B+4>>2]=f[j+4>>2];f[B+8>>2]=f[j+8>>2];f[B+12>>2]=f[j+12>>2];f[o>>2]=(f[o>>2]|0)+16;u=h;return}}function zba(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;c=u;u=u+80|0;d=c;e=c+60|0;g=c+56|0;h=c+52|0;i=c+40|0;f[d>>2]=d;j=f[a>>2]|0;k=f[a+12>>2]|0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=(f[a+4>>2]|0)-j|0;if((m|0)>0){n=(m>>>0)/40|0;m=d;o=0;while(1){q=j+(o*40|0)|0;f[j+(o*40|0)+12>>2]=0;r=+p[j+(o*40|0)+24>>3];if(r!=0.0){f[m>>2]=q;f[j+(o*40|0)+16>>2]=1;b[j+(o*40|0)+32>>0]=r<0.0&1;s=q;t=-1}else{s=m;t=0}f[j+(o*40|0)+4>>2]=t;o=o+1|0;if((o|0)>=(n|0))break;else m=s}v=s;w=f[d>>2]|0}else{v=d;w=d}f[v>>2]=d;f[d>>2]=0;s=a+24|0;a=e+8|0;a:do if((w|0)!=(d|0)){m=w;n=0;o=v;t=0;b:while(1){q=-1;x=m;y=o;while(1){f[g>>2]=x;if(!(f[x+4>>2]|0)){z=q;A=y;B=x}else{C=b[x+32>>0]|0;D=f[x+8>>2]|0;c:do if(!D){E=q;F=y}else{G=C&255;H=D;I=y;while(1){J=H^G;do if(!(+p[k+(J<<4)+8>>3]==0.0)){K=f[k+(H<<4)>>2]|0;M=j+(K*40|0)|0;f[h>>2]=M;N=j+(K*40|0)+4|0;O=j+(K*40|0)+32|0;if(!(f[N>>2]|0)){b[O>>0]=C;f[j+(K*40|0)+4>>2]=H^1;P=f[g>>2]|0;f[j+(K*40|0)+12>>2]=f[P+12>>2];f[j+(K*40|0)+16>>2]=(f[P+16>>2]|0)+1;if(f[M>>2]|0){Q=I;break}f[M>>2]=d;M=f[h>>2]|0;f[I>>2]=M;Q=M;break}if((b[O>>0]|0)!=C<<24>>24){E=J;F=I;break c}O=f[g>>2]|0;M=(f[O+16>>2]|0)+1|0;if((f[j+(K*40|0)+16>>2]|0)>(M|0)?(P=f[O+12>>2]|0,(f[j+(K*40|0)+12>>2]|0)<=(P|0)):0){f[N>>2]=H^1;f[j+(K*40|0)+12>>2]=P;f[j+(K*40|0)+16>>2]=M;Q=I}else Q=I}else Q=I;while(0);H=f[k+(H<<4)+4>>2]|0;if(!H){E=q;F=Q;break}else I=Q}}while(0);if((E|0)>0){R=x;S=E;T=F;break}z=E;A=F;B=f[g>>2]|0}x=f[x>>2]|0;f[B>>2]=0;if((x|0)==(d|0)){U=24;break}else{q=z;y=A}}if((U|0)==24){U=0;if((z|0)<1){V=t;break a}else{R=d;S=z;T=A}}y=k+(S<<4)+8|0;r=+p[y>>3];if(!(r>0.0)){U=27;break}q=S^1;W=r;x=q;while(1){X=f[k+(x<<4)>>2]|0;x=f[j+(X*40|0)+4>>2]|0;if((x|0)<0)break;Y=+p[k+((x^1)<<4)+8>>3];Z=W>Y?Y:W;if(!(Z>0.0)){_=X;U=30;break b}else W=Z}f[g>>2]=j+(X*40|0);Z=+L(+(+p[j+(X*40|0)+24>>3]));Y=W>Z?Z:W;if(Y>0.0){$=Y;aa=S}else{U=32;break}while(1){ba=f[k+(aa<<4)>>2]|0;aa=f[j+(ba*40|0)+4>>2]|0;if((aa|0)<0)break;Y=+p[k+(aa<<4)+8>>3];Z=$>Y?Y:$;if(!(Z>0.0)){_=ba;U=30;break b}else $=Z}f[g>>2]=j+(ba*40|0);W=+L(+(+p[j+(ba*40|0)+24>>3]));Z=$>W?W:$;if(!(Z>0.0)){U=32;break}p[y>>3]=r-Z;x=k+(q<<4)+8|0;p[x>>3]=Z+ +p[x>>3];p[s>>3]=Z+ +p[s>>3];x=f[k+(q<<4)>>2]|0;C=j+(x*40|0)|0;f[g>>2]=C;D=f[j+(x*40|0)+4>>2]|0;I=C;if((D|0)<0){ca=x;da=I}else{x=D;D=I;while(1){I=k+(x<<4)+8|0;p[I>>3]=Z+ +p[I>>3];I=k+((x^1)<<4)+8|0;W=+p[I>>3]-Z;p[I>>3]=W;if(W==0.0){I=f[l>>2]|0;if((I|0)==(f[a>>2]|0))Aba(e,g);else{f[I>>2]=D;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}I=f[k+(x<<4)>>2]|0;C=j+(I*40|0)|0;f[g>>2]=C;x=f[j+(I*40|0)+4>>2]|0;H=C;if((x|0)<0){ca=I;da=H;break}else D=H}}D=j+(ca*40|0)+24|0;r=+p[D>>3]-Z;p[D>>3]=r;if(r==0.0){D=f[l>>2]|0;if((D|0)==(f[a>>2]|0))Aba(e,g);else{f[D>>2]=da;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}D=f[k+(S<<4)>>2]|0;x=j+(D*40|0)|0;f[g>>2]=x;q=f[j+(D*40|0)+4>>2]|0;y=x;if((q|0)<0){ea=D;fa=y}else{D=q;q=y;while(1){y=k+((D^1)<<4)+8|0;p[y>>3]=Z+ +p[y>>3];y=k+(D<<4)+8|0;r=+p[y>>3]-Z;p[y>>3]=r;if(r==0.0){y=f[l>>2]|0;if((y|0)==(f[a>>2]|0))Aba(e,g);else{f[y>>2]=q;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}y=f[k+(D<<4)>>2]|0;x=j+(y*40|0)|0;f[g>>2]=x;D=f[j+(y*40|0)+4>>2]|0;H=x;if((D|0)<0){ea=y;fa=H;break}else q=H}}q=j+(ea*40|0)+24|0;r=Z+ +p[q>>3];p[q>>3]=r;if(r==0.0){q=f[l>>2]|0;if((q|0)==(f[a>>2]|0))Aba(e,g);else{f[q>>2]=fa;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}n=n+1|0;q=f[e>>2]|0;D=f[l>>2]|0;d:do if((q|0)==(D|0)){ga=T;ha=q}else{H=T;y=q;x=D;while(1){I=x;while(1){I=I+-4|0;ia=f[I>>2]|0;f[l>>2]=I;ja=b[ia+32>>0]|0;ka=ia+8|0;C=f[ka>>2]|0;if(!C){U=50;break}G=(ja^1)&255;J=2147483647;M=C;C=0;while(1){e:do if(!(+p[k+((M^G)<<4)+8>>3]==0.0)?(K=f[k+(M<<4)>>2]|0,P=j+(K*40|0)|0,f[h>>2]=P,(b[j+(K*40|0)+32>>0]|0)==ja<<24>>24):0){if(!(f[j+(K*40|0)+4>>2]|0)){la=J;ma=C;break}N=j+(K*40|0)+12|0;f:do if((f[N>>2]|0)==(n|0)){na=0;oa=K;U=56}else{O=0;pa=P;qa=N;while(1){ra=f[pa+4>>2]|0;sa=O+1|0;if((ra|0)<0)break;ta=f[k+(ra<<4)>>2]|0;ua=j+(ta*40|0)|0;f[h>>2]=ua;va=j+(ta*40|0)+12|0;if((f[va>>2]|0)==(n|0)){na=sa;oa=ta;U=56;break f}else{O=sa;pa=ua;qa=va}}if((ra|0)==-2){la=J;ma=C;break e}f[qa>>2]=n;f[pa+16>>2]=1;wa=sa}while(0);if((U|0)==56){U=0;wa=(f[j+(oa*40|0)+16>>2]|0)+na|0}N=wa+1|0;if((N|0)==2147483647){la=J;ma=C;break}O=(N|0)<(J|0);va=O?M:C;ua=O?N:J;f[h>>2]=P;O=j+(K*40|0)+12|0;if((f[O>>2]|0)==(n|0)){la=ua;ma=va;break}else{xa=N;ya=K;za=O}do{f[za>>2]=n;xa=xa+-1|0;f[j+(ya*40|0)+16>>2]=xa;ya=f[k+(f[j+(ya*40|0)+4>>2]<<4)>>2]|0;za=j+(ya*40|0)+12|0}while((f[za>>2]|0)!=(n|0));f[h>>2]=j+(ya*40|0);la=ua;ma=va}else{la=J;ma=C}while(0);M=f[k+(M<<4)+4>>2]|0;if(!M)break;else{J=la;C=ma}}f[ia+4>>2]=ma;C=ia+12|0;if((ma|0)<=0){Aa=C;break}f[C>>2]=n;f[ia+16>>2]=la;if((y|0)==(I|0)){ga=H;ha=y;break d}}if((U|0)==50){U=0;f[ia+4>>2]=0;Aa=ia+12|0}f[Aa>>2]=0;C=f[ka>>2]|0;if(!C){Ba=H;Ca=I}else{J=(ja^1)&255;M=C;C=H;while(1){G=f[k+(M<<4)>>2]|0;K=j+(G*40|0)|0;f[h>>2]=K;P=f[j+(G*40|0)+4>>2]|0;do if(P|0?(b[j+(G*40|0)+32>>0]|0)==ja<<24>>24:0){do if(+p[k+((M^J)<<4)+8>>3]!=0.0){if(f[K>>2]|0){Da=C;break}f[K>>2]=d;O=f[h>>2]|0;f[C>>2]=O;Da=O}else Da=C;while(0);if((P|0)<=0){Ea=Da;break}if((j+((f[k+(P<<4)>>2]|0)*40|0)|0)!=(ia|0)){Ea=Da;break}O=f[l>>2]|0;if((O|0)==(f[a>>2]|0))Aba(e,h);else{f[O>>2]=f[h>>2];f[l>>2]=(f[l>>2]|0)+4}f[(f[h>>2]|0)+4>>2]=-2;Ea=Da}else Ea=C;while(0);M=f[k+(M<<4)+4>>2]|0;if(!M)break;else C=Ea}Ba=Ea;Ca=f[l>>2]|0}y=f[e>>2]|0;if((y|0)==(Ca|0)){ga=Ba;ha=Ca;break}else{H=Ba;x=Ca}}}while(0);if((R|0)==(d|0)){V=ha;break a}else{m=R;o=ga;t=ha}}if((U|0)==27){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;t=$Xc(16)|0;f[i>>2]=t;f[i+8>>2]=-2147483632;f[i+4>>2]=13;Fa=t;Ga=253365;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));b[t+13>>0]=0;vM(-215,i,253379,253250,247)}else if((U|0)==30){f[g>>2]=j+(_*40|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;o=$Xc(16)|0;f[i>>2]=o;f[i+8>>2]=-2147483632;f[i+4>>2]=13;Fa=o;Ga=253365;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));b[o+13>>0]=0;vM(-215,i,253379,253250,257)}else if((U|0)==32){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;t=$Xc(16)|0;f[i>>2]=t;f[i+8>>2]=-2147483632;f[i+4>>2]=13;Fa=t;Ga=253365;Ha=Fa+13|0;do{b[Fa>>0]=b[Ga>>0]|0;Fa=Fa+1|0;Ga=Ga+1|0}while((Fa|0)<(Ha|0));b[t+13>>0]=0;vM(-215,i,253379,253250,261)}}else V=0;while(0);$=+p[s>>3];if(!V){u=c;return +$}s=f[l>>2]|0;if((s|0)!=(V|0))f[l>>2]=s+(~((s+-4-V|0)>>>2)<<2);cYc(V);u=c;return +$}function Aba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function Bba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)kWc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=k+(d<<4)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(0-(b>>4)<<4)|0;if((b|0)>0)o1c(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;cYc(d);return}function Cba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;cYc(d);return}function Dba(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,K=0.0,L=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0;e=u;u=u+80|0;g=e+16|0;h=e;do if((eS(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;U$(g,i);break}}else bS(g,a,-1);while(0);a=k0(g,2,-1,1)|0;i=f[g>>2]&7;if((a|0)<=-1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;p=$Xc(64)|0;f[h>>2]=p;q=h+8|0;f[q>>2]=-2147483584;r=h+4|0;f[r>>2]=50;t=p;v=253691;w=t+50|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=p+50|0;b[x>>0]=0;vM(-215,h,253742,253618,103)}j=(i|0)==5;if((i|1|0)!=5){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;p=$Xc(64)|0;f[h>>2]=p;q=h+8|0;f[q>>2]=-2147483584;r=h+4|0;f[r>>2]=50;t=p;v=253691;w=t+50|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=p+50|0;b[x>>0]=0;vM(-215,h,253742,253618,103)}y=+n[c>>2];h=ALc(y)|0;z=+n[c+4>>2];c=ALc(z)|0;a:do if(!a)A=d?-1797693134862315708145274.0e284:-1.0;else{x=f[g+16>>2]|0;p=a+-1|0;v=f[x+(p<<3)>>2]|0;t=f[x+(p<<3)+4>>2]|0;if(+(h|0)==y&((j|d)^1)&+(c|0)==z){p=0;w=0;r=v;q=t;while(1){i=r;r=f[x+(p<<3)>>2]|0;k=q;q=f[x+(p<<3)+4>>2]|0;l=(q|0)>(c|0);if((c|0)<(k|0))if(l)B=18;else B=17;else if(l)B=17;else B=18;if((B|0)==17){B=0;if(!((h|0)>(i|0)&(r|0)<(h|0))){l=c-k|0;o=r-i|0;m=x1c(o|0,((o|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;o=h-i|0;C=q-k|0;D=x1c(C|0,((C|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=c1c(m|0,l|0,D|0,J|0)|0;D=J;l=(q|0)<(k|0);m=c1c(0,0,o|0,D|0)|0;C=l?J:D;if((o|0)==0&(D|0)==0){A=0.0;break a}else E=(((C|0)>0|(C|0)==0&(l?m:o)>>>0>0)&1)+w|0}else B=18}if((B|0)==18){B=0;if((c|0)==(q|0)){if((h|0)==(r|0)){A=0.0;break a}if((c|0)==(k|0)){if(!((h|0)<(i|0)|(h|0)>(r|0))){A=0.0;break a}if(!((h|0)>(i|0)|(r|0)>(h|0))){A=0.0;break a}else E=w}else E=w}else E=w}p=p+1|0;if((p|0)>=(a|0))break;else w=E}A=+((E<<1&2)+-1|0);break}if(j){F=v;G=t;H=(f[s>>2]=t,+n[s>>2])}else{I=+(t|0);w=(n[s>>2]=+(v|0),f[s>>2]|0);F=w;G=(n[s>>2]=I,f[s>>2]|0);H=I}if(!d){if(j){w=0;p=0;r=F;I=H;while(1){q=r;r=f[x+(w<<3)>>2]|0;K=(f[s>>2]=r,+n[s>>2]);L=I;I=+n[x+(w<<3)+4>>2];if((!(L<=z)|!(I<=z)?!(L>z&I>z):0)?(N=(f[s>>2]=q,+n[s>>2]),!(N<y&K<y)):0){O=(K-N)*(z-L)-(I-L)*(y-N);if(O==0.0){A=0.0;break a}P=((I<L?-O:O)>0.0&1)+p|0}else if(z==I){if(y==K){A=0.0;break a}if(z==L){L=(f[s>>2]=q,+n[s>>2]);if(!(!(L<=y)|!(y<=K))){A=0.0;break a}if(!(!(K<=y)|!(y<=L))){A=0.0;break a}else P=p}else P=p}else P=p;w=w+1|0;if((w|0)>=(a|0)){Q=P;break}else p=P}}else{p=0;w=0;r=F;I=H;while(1){L=+(f[x+(p<<3)>>2]|0);K=I;I=+(f[x+(p<<3)+4>>2]|0);v=r;r=(n[s>>2]=L,f[s>>2]|0);if((!(K<=z)|!(I<=z)?!(K>z&I>z):0)?(O=(f[s>>2]=v,+n[s>>2]),!(O<y&L<y)):0){N=(L-O)*(z-K)-(I-K)*(y-O);if(N==0.0){A=0.0;break a}R=((I<K?-N:N)>0.0&1)+w|0}else if(z==I){if(y==L){A=0.0;break a}if(z==K){K=(f[s>>2]=v,+n[s>>2]);if(!(!(K<=y)|!(y<=L))){A=0.0;break a}if(!(!(L<=y)|!(y<=K))){A=0.0;break a}else R=w}else R=w}else R=w;p=p+1|0;if((p|0)>=(a|0)){Q=R;break}else w=R}}A=+((Q<<1&2)+-1|0);break}b:do if(j){I=3402823466385288598117041.0e14;K=1.0;w=0;p=0;r=F;v=G;while(1){t=r;r=f[x+(w<<3)>>2]|0;L=(f[s>>2]=r,+n[s>>2]);q=v;v=f[x+(w<<3)+4>>2]|0;N=(f[s>>2]=v,+n[s>>2]);O=(f[s>>2]=t,+n[s>>2]);S=L-O;T=(f[s>>2]=q,+n[s>>2]);U=N-T;V=U;W=y-O;X=z-T;Y=y-L;Z=z-N;do if(!(S*W+V*X<=0.0))if(!(S*Y+V*Z>=0.0)){_=S*X-V*W;$=S*S+V*V;aa=_*_;break}else{$=1.0;aa=Y*Y+Z*Z;break}else{$=1.0;aa=W*W+X*X}while(0);if(K*aa<I*$)if(aa==0.0){ba=aa;ca=$;da=p;break b}else{ea=aa;fa=$}else{ea=I;fa=K}if((!(T<=z)|!(N<=z)?!(T>z&N>z):0)?!(O<y&L<y):0){Z=S*X-V*W;ga=((U<0.0?-Z:Z)>0.0&1)+p|0}else ga=p;w=w+1|0;if((w|0)>=(a|0)){ba=ea;ca=fa;da=ga;break}else{I=ea;K=fa;p=ga}}}else{K=3402823466385288598117041.0e14;I=1.0;p=0;w=0;v=F;r=G;while(1){Z=+(f[x+(p<<3)>>2]|0);Y=+(f[x+(p<<3)+4>>2]|0);q=v;v=(n[s>>2]=Z,f[s>>2]|0);t=r;r=(n[s>>2]=Y,f[s>>2]|0);_=(f[s>>2]=q,+n[s>>2]);ha=Z-_;ia=(f[s>>2]=t,+n[s>>2]);ja=Y-ia;ka=ja;la=y-_;ma=z-ia;na=y-Z;oa=z-Y;do if(!(ha*la+ka*ma<=0.0))if(!(ha*na+ka*oa>=0.0)){pa=ha*ma-ka*la;qa=ha*ha+ka*ka;ra=pa*pa;break}else{qa=1.0;ra=na*na+oa*oa;break}else{qa=1.0;ra=la*la+ma*ma}while(0);if(I*ra<K*qa)if(ra==0.0){ba=ra;ca=qa;da=w;break b}else{sa=ra;ta=qa}else{sa=K;ta=I}if((!(ia<=z)|!(Y<=z)?!(ia>z&Y>z):0)?!(_<y&Z<y):0){oa=ha*ma-ka*la;ua=((ja<0.0?-oa:oa)>0.0&1)+w|0}else ua=w;p=p+1|0;if((p|0)>=(a|0)){ba=sa;ca=ta;da=ua;break}else{K=sa;I=ta;w=ua}}}while(0);I=+M(+(ba/ca));A=(da&1|0)==0?-I:I}while(0);da=g+36|0;ua=f[da>>2]|0;if(ua|0?(a=ua+12|0,ua=f[a>>2]|0,f[a>>2]=ua+-1,(ua|0)==1):0)V$(g);f[da>>2]=0;da=g+16|0;ua=g+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ua>>2]|0)>0){da=f[g+40>>2]|0;a=0;do{f[da+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[ua>>2]|0))}ua=f[g+44>>2]|0;if((ua|0)==(g+48|0)){u=e;return +A}wL(ua);u=e;return +A}function Eba(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0;k=u;u=u+832|0;l=k+112|0;m=k+816|0;n=k+760|0;o=k+756|0;p=k+752|0;q=k+696|0;r=k+640|0;s=k+632|0;t=k+576|0;v=k+520|0;w=k+464|0;x=k+56|0;y=k+408|0;z=k+352|0;A=k+296|0;B=k+240|0;C=k+184|0;D=k;E=k+168|0;f[m>>2]=0;F=m+4|0;f[F>>2]=0;f[m+8>>2]=0;f[n>>2]=f[c>>2];G=n+4|0;H=c+4|0;I=f[H>>2]|0;f[G>>2]=I;J=n+8|0;f[J>>2]=f[c+8>>2];K=n+12|0;f[K>>2]=f[c+12>>2];L=n+16|0;f[L>>2]=f[c+16>>2];M=n+20|0;f[M>>2]=f[c+20>>2];N=n+24|0;f[N>>2]=f[c+24>>2];O=n+28|0;f[O>>2]=f[c+28>>2];P=n+32|0;f[P>>2]=f[c+32>>2];Q=n+36|0;R=f[c+36>>2]|0;f[Q>>2]=R;S=n+40|0;f[S>>2]=J;T=n+48|0;U=n+44|0;f[U>>2]=T;f[T>>2]=0;f[n+52>>2]=0;if(!R)V=I;else{I=R+12|0;f[I>>2]=(f[I>>2]|0)+1;V=f[H>>2]|0}if((V|0)<3){V=f[c+44>>2]|0;H=f[U>>2]|0;f[H>>2]=f[V>>2];f[H+4>>2]=f[V+4>>2]}else{f[G>>2]=0;U$(n,c)}V=f[a>>2]|0;H=V&7;I=V>>>3;V=I&511;R=f[n>>2]|0;W=R&7;f[o>>2]=W;X=R>>>3&511;R=X+1|0;Z=g&7;f[p>>2]=Z;_=g>>>3;$=_&511;aa=a+4|0;if(!((f[aa>>2]|0)<3&(f[G>>2]|0)<3)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ba=$Xc(64)|0;f[l>>2]=ba;ca=l+8|0;f[ca>>2]=-2147483584;da=l+4|0;f[da>>2]=50;ea=ba;fa=253759;ga=ea+50|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));ha=ba+50|0;b[ha>>0]=0;vM(-215,l,253810,253820,579)}ia=d+4|0;if((f[ia>>2]|0)>=3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ba=$Xc(64)|0;f[l>>2]=ba;ca=l+8|0;f[ca>>2]=-2147483584;da=l+4|0;f[da>>2]=50;ea=ba;fa=253759;ga=ea+50|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));ha=ba+50|0;b[ha>>0]=0;vM(-215,l,253810,253820,579)}if((H|0)!=(W|0)){ha=H>>>0>5?H:5;if((W|0)==(ha|0))ja=W;else{W=l+8|0;f[W>>2]=0;f[W+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;dY(c,l,ha,1.0,0.0);ha=f[n>>2]&7;f[o>>2]=ha;ja=ha}}else ja=H;if(!((H|0)==(ja|0)|(ja|0)==5)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ha=$Xc(48)|0;f[l>>2]=ha;f[l+8>>2]=-2147483600;f[l+4>>2]=35;ea=ha;fa=253895;ga=ea+35|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[ha+35>>0]=0;vM(-215,l,253810,253820,587)}ha=f[e+4>>2]|0;c=a+8|0;if((ha|0)>=((f[J>>2]|0)+(f[c>>2]|0)|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ka=$Xc(96)|0;f[l>>2]=ka;la=l+8|0;f[la>>2]=-2147483552;ma=l+4|0;f[ma>>2]=91;ea=ka;fa=253931;ga=ea+91|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));na=ka+91|0;b[na>>0]=0;vM(-215,l,253810,253820,589)}W=f[e>>2]|0;e=a+12|0;if((W|0)>=((f[K>>2]|0)+(f[e>>2]|0)|0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;ka=$Xc(96)|0;f[l>>2]=ka;la=l+8|0;f[la>>2]=-2147483552;ma=l+4|0;f[ma>>2]=91;ea=ka;fa=253931;ga=ea+91|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));na=ka+91|0;b[na>>0]=0;vM(-215,l,253810,253820,589)}na=($|0)==0;if(!(na|i==0.0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;$=$Xc(32)|0;f[l>>2]=$;f[l+8>>2]=-2147483616;f[l+4>>2]=22;ea=$;fa=254023;ga=ea+22|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[$+22>>0]=0;vM(-215,l,253810,253820,591)}$=g&4095;if(!(((((f[ia>>2]|0)<3?(f[d+8>>2]|0)==(ha|0):0)?(f[d+12>>2]|0)==(W|0):0)?(f[d>>2]&4095|0)==($|0):0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=ha;f[l+4>>2]=W;S$(d,2,l,$)}if(H>>>0>1)oa=6;else{$=ja>>>0>5?ja:5;oa=($|0)<(Z|0)?Z:$}$=f[K>>2]|0;W=zLc(+($|0)*4.5)|0;ha=256-$+1|0;ia=(W|0)<(ha|0)?ha:W;W=d+12|0;ha=f[W>>2]|0;g=f[J>>2]|0;ka=zLc(+(g|0)*4.5)|0;ma=256-g+1|0;g=(ka|0)<(ma|0)?ma:ka;ka=d+8|0;ma=f[ka>>2]|0;la=c1($+-1+((ha|0)<(ia|0)?ha:ia)|0)|0;ia=(la|0)>2?la:2;la=c1(((ma|0)<(g|0)?ma:g)+-1+(f[J>>2]|0)|0)|0;if((ia|0)<1|(la|0)<1){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;g=$Xc(32)|0;f[l>>2]=g;f[l+8>>2]=-2147483616;f[l+4>>2]=28;ea=g;fa=254046;ga=ea+28|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[g+28>>0]=0;vM(-211,l,253810,253820,608)}g=ia-(f[K>>2]|0)|0;ma=f[W>>2]|0;ha=(g|0)>=(ma|0)?ma:g+1|0;g=la-(f[J>>2]|0)|0;ma=f[ka>>2]|0;$=(g|0)>=(ma|0)?ma:g+1|0;g=Y(la,R)|0;f[q>>2]=1124007936;R=q+4|0;ma=q+8|0;ba=q+40|0;ea=R;ga=ea+36|0;do{f[ea>>2]=0;ea=ea+4|0}while((ea|0)<(ga|0));f[ba>>2]=ma;ma=q+48|0;da=q+44|0;f[da>>2]=ma;f[ma>>2]=0;f[q+52>>2]=0;ca=oa&4095;f[l>>2]=g;g=l+4|0;f[g>>2]=ia;S$(q,2,l,ca);f[r>>2]=1124007936;pa=r+4|0;qa=r+8|0;ra=r+40|0;ea=pa;ga=ea+36|0;do{f[ea>>2]=0;ea=ea+4|0}while((ea|0)<(ga|0));f[ra>>2]=qa;qa=r+48|0;sa=r+44|0;f[sa>>2]=qa;f[qa>>2]=0;f[r+52>>2]=0;f[l>>2]=la;f[g>>2]=ia;S$(r,2,l,ca);ca=(X|0)!=0;if((ja|0)==(oa|0)|ca^1)ta=0;else ta=Y(Y(675553809>>>(ja<<2)&15,f[K>>2]|0)|0,f[J>>2]|0)|0;ja=(V|0)!=0;g=(H|0)==(oa|0);if(g|ja^1)ua=ta;else{va=Y(Y(ha+-1+(f[K>>2]|0)|0,675553809>>>(H<<2)&15)|0,$+-1+(f[J>>2]|0)|0)|0;ua=(ta|0)<(va|0)?va:ta}if(((I|_)&511|0)==0|(Z|0)==(oa|0))wa=ua;else{_=Y(Y($,ha)|0,675553809>>>(Z<<2)&15)|0;wa=(ua|0)<(_|0)?_:ua}ua=f[F>>2]|0;_=f[m>>2]|0;Z=ua-_|0;I=_;_=ua;if(wa>>>0<=Z>>>0){if(wa>>>0<Z>>>0?(ua=I+wa|0,(_|0)!=(ua|0)):0)f[F>>2]=ua}else zS(m,wa-Z|0);N0(s,ia,la,f[q>>2]&7,1,1,1024,f[J>>2]|0);Z=t+4|0;wa=t+8|0;ua=t+12|0;_=t+16|0;I=t+20|0;ta=t+24|0;va=t+28|0;xa=t+32|0;ya=t+36|0;za=t+40|0;Aa=t+48|0;Ba=t+44|0;Ca=t+52|0;Da=l+4|0;Ea=l+8|0;Fa=l+12|0;Ga=l+4|0;Ha=l+8|0;Ia=l+12|0;Ja=x+4|0;Ka=w+4|0;La=x+8|0;Ma=w+8|0;Na=x+12|0;Oa=w+12|0;Pa=x+16|0;Qa=w+16|0;Ra=x+20|0;Sa=w+20|0;Ta=x+24|0;Ua=w+24|0;Va=x+28|0;Wa=w+28|0;Xa=x+32|0;Ya=w+32|0;Za=x+36|0;_a=w+36|0;$a=x+40|0;ab=x+48|0;bb=x+44|0;cb=x+52|0;db=w+44|0;eb=t+44|0;fb=x+44|0;gb=l+4|0;hb=t+40|0;ib=v+12|0;jb=x+4|0;kb=y+4|0;lb=l+36|0;mb=l+16|0;nb=l+4|0;ob=l+40|0;pb=l+44|0;qb=l+48|0;rb=v+16|0;sb=v+48|0;tb=w+40|0;ub=w+48|0;vb=v+36|0;wb=v+4|0;xb=v+40|0;yb=v+44|0;zb=l+8|0;Ab=l+4|0;Bb=t+52|0;Cb=0;a:while(1){Db=Y(Cb,la)|0;f[t>>2]=f[n>>2];Eb=f[G>>2]|0;f[Z>>2]=Eb;f[wa>>2]=f[J>>2];f[ua>>2]=f[K>>2];f[_>>2]=f[L>>2];f[I>>2]=f[M>>2];f[ta>>2]=f[N>>2];f[va>>2]=f[O>>2];f[xa>>2]=f[P>>2];Fb=f[Q>>2]|0;f[ya>>2]=Fb;f[za>>2]=wa;f[Ba>>2]=Aa;f[Aa>>2]=0;f[Ca>>2]=0;if(!Fb)Gb=Eb;else{Eb=Fb+12|0;f[Eb>>2]=(f[Eb>>2]|0)+1;Gb=f[G>>2]|0}if((Gb|0)<3){Eb=f[U>>2]|0;Fb=f[Ba>>2]|0;f[Fb>>2]=f[Eb>>2];f[Fb+4>>2]=f[Eb+4>>2]}else{f[Z>>2]=0;U$(t,n)}f[l>>2]=0;f[Da>>2]=Db;f[Ea>>2]=ia;f[Fa>>2]=la;Z$(v,q,l);Eb=f[K>>2]|0;Fb=f[J>>2]|0;f[l>>2]=0;f[Ga>>2]=Db;f[Ha>>2]=Eb;f[Ia>>2]=Fb;Z$(w,q,l);if(ca){Fb=f[o>>2]|0;do if((Fb|0)==(oa|0)){f[x>>2]=f[w>>2];Eb=f[Ka>>2]|0;f[Ja>>2]=Eb;f[La>>2]=f[Ma>>2];f[Na>>2]=f[Oa>>2];f[Pa>>2]=f[Qa>>2];f[Ra>>2]=f[Sa>>2];f[Ta>>2]=f[Ua>>2];f[Va>>2]=f[Wa>>2];f[Xa>>2]=f[Ya>>2];Db=f[_a>>2]|0;f[Za>>2]=Db;f[$a>>2]=La;f[bb>>2]=ab;f[ab>>2]=0;f[cb>>2]=0;if(!Db)Hb=Eb;else{Eb=Db+12|0;f[Eb>>2]=(f[Eb>>2]|0)+1;Hb=f[Ka>>2]|0}if((Hb|0)<3){Eb=f[db>>2]|0;Db=f[bb>>2]|0;f[Db>>2]=f[Eb>>2];f[Db+4>>2]=f[Eb+4>>2];break}else{f[Ja>>2]=0;U$(x,w);break}}else{Eb=f[S>>2]|0;Db=f[Eb+4>>2]|0;Ib=f[Eb>>2]|0;Eb=f[m>>2]|0;f[x>>2]=Fb&4095|1124007936;f[Ja>>2]=2;f[La>>2]=Ib;f[Na>>2]=Db;f[Pa>>2]=Eb;f[Ra>>2]=Eb;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;f[$a>>2]=La;f[bb>>2]=ab;f[cb>>2]=0;f[ab>>2]=0;if((Y(Ib,Db)|0)!=0&(Eb|0)==0){Jb=54;break a}Kb=Y(675553809>>>(Fb<<2&28)&15,(Fb>>>3&511)+1|0)|0;Lb=Y(Db,Kb)|0;f[ab>>2]=Lb;f[cb>>2]=Kb;Kb=Eb+(Y(Ib,Lb)|0)|0;f[Va>>2]=Kb;f[Ta>>2]=Kb+(0-Lb)+Lb;R$(x)}while(0);Fb=f[ya>>2]|0;do if(Fb|0){Lb=Fb+12|0;Kb=f[Lb>>2]|0;f[Lb>>2]=Kb+-1;if((Kb|0)!=1)break;V$(t)}while(0);f[ya>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Fb=f[za>>2]|0;Kb=0;do{f[Fb+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[Z>>2]|0))}f[t>>2]=f[x>>2];Kb=f[Ja>>2]|0;f[Z>>2]=Kb;f[wa>>2]=f[La>>2];f[ua>>2]=f[Na>>2];f[_>>2]=f[Pa>>2];f[I>>2]=f[Ra>>2];f[ta>>2]=f[Ta>>2];f[va>>2]=f[Va>>2];f[xa>>2]=f[Xa>>2];f[ya>>2]=f[Za>>2];Fb=f[eb>>2]|0;if((Fb|0)==(Aa|0))Mb=Kb;else{wL(Fb);f[eb>>2]=Aa;f[za>>2]=wa;Mb=f[Ja>>2]|0}if((Mb|0)<3){Fb=f[fb>>2]|0;f[Aa>>2]=f[Fb>>2];f[Bb>>2]=f[Fb+4>>2];Nb=Fb}else{f[eb>>2]=f[fb>>2];f[hb>>2]=f[$a>>2];f[fb>>2]=ab;f[$a>>2]=La;Nb=ab}f[x>>2]=1124007936;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;f[Ja+16>>2]=0;f[Ja+20>>2]=0;f[Ja+24>>2]=0;f[Ja+28>>2]=0;f[Za>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((Nb|0)!=(ab|0))wL(Nb);f[l>>2]=Cb;f[gb>>2]=0;d1(n,1,t,1,l,1)}if((f[Qa>>2]|0)!=(f[_>>2]|0)){Fb=zb;f[Fb>>2]=0;f[Fb+4>>2]=0;f[l>>2]=33619968;f[Ab>>2]=w;dY(t,l,f[w>>2]&7,1.0,0.0)}Fb=f[ib>>2]|0;Kb=f[K>>2]|0;if((Fb|0)>(Kb|0)){Lb=f[J>>2]|0;f[x>>2]=0;f[jb>>2]=Lb;f[y>>2]=Kb;f[kb>>2]=Fb;W$(l,v,x,y);f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;lR(l,x)|0;Fb=f[lb>>2]|0;do if(Fb|0){Kb=Fb+12|0;Lb=f[Kb>>2]|0;f[Kb>>2]=Lb+-1;if((Lb|0)!=1)break;V$(l)}while(0);f[lb>>2]=0;f[mb>>2]=0;f[mb+4>>2]=0;f[mb+8>>2]=0;f[mb+12>>2]=0;if((f[nb>>2]|0)>0){Fb=f[ob>>2]|0;Lb=0;do{f[Fb+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[nb>>2]|0))}Lb=f[pb>>2]|0;if((Lb|0)!=(qb|0))wL(Lb)}Lb=f[s>>2]|0;Fb=f[rb>>2]|0;Kb=f[sb>>2]|0;gi[f[f[Lb>>2]>>2]&255](Lb,Fb,Kb,Fb,Kb);Kb=f[_a>>2]|0;do if(Kb|0){Fb=Kb+12|0;Lb=f[Fb>>2]|0;f[Fb>>2]=Lb+-1;if((Lb|0)!=1)break;V$(w)}while(0);f[_a>>2]=0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[Qa+8>>2]=0;f[Qa+12>>2]=0;if((f[Ka>>2]|0)>0){Kb=f[tb>>2]|0;Lb=0;do{f[Kb+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[Ka>>2]|0))}Lb=f[db>>2]|0;if((Lb|0)!=(ub|0))wL(Lb);Lb=f[vb>>2]|0;do if(Lb|0){Kb=Lb+12|0;Fb=f[Kb>>2]|0;f[Kb>>2]=Fb+-1;if((Fb|0)!=1)break;V$(v)}while(0);f[vb>>2]=0;f[rb>>2]=0;f[rb+4>>2]=0;f[rb+8>>2]=0;f[rb+12>>2]=0;if((f[wb>>2]|0)>0){Lb=f[xb>>2]|0;Fb=0;do{f[Lb+(Fb<<2)>>2]=0;Fb=Fb+1|0}while((Fb|0)<(f[wb>>2]|0))}Fb=f[yb>>2]|0;if((Fb|0)!=(sb|0))wL(Fb);Fb=f[ya>>2]|0;do if(Fb|0){Lb=Fb+12|0;Kb=f[Lb>>2]|0;f[Lb>>2]=Kb+-1;if((Kb|0)!=1)break;V$(t)}while(0);f[ya>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Fb=f[za>>2]|0;Kb=0;do{f[Fb+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[Z>>2]|0))}Kb=f[Ba>>2]|0;if((Kb|0)!=(Aa|0))wL(Kb);if((Cb|0)<(X|0))Cb=Cb+1|0;else break}if((Jb|0)==54){Cb=$Xc(32)|0;f[l>>2]=Cb;f[l+8>>2]=-2147483616;f[l+4>>2]=28;ea=Cb;fa=470314;ga=ea+28|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[Cb+28>>0]=0;vM(-215,l,470343,470347,577)}Cb=(ha+-1+(f[W>>2]|0)|0)/(ha|0)|0;X=$+-1|0;Aa=Y((X+(f[ka>>2]|0)|0)/($|0)|0,Cb)|0;Ba=f[a+40>>2]|0;Z=f[Ba>>2]|0;f[t>>2]=f[Ba+4>>2];Ba=t+4|0;f[Ba>>2]=Z;f[v>>2]=0;Z=v+4|0;f[Z>>2]=0;f[w>>2]=f[a>>2];za=w+4|0;_=f[aa>>2]|0;f[za>>2]=_;ya=w+8|0;f[ya>>2]=f[c>>2];sb=w+12|0;f[sb>>2]=f[e>>2];yb=w+16|0;f[yb>>2]=f[a+16>>2];f[w+20>>2]=f[a+20>>2];f[w+24>>2]=f[a+24>>2];f[w+28>>2]=f[a+28>>2];f[w+32>>2]=f[a+32>>2];wb=w+36|0;xb=f[a+36>>2]|0;f[wb>>2]=xb;rb=w+40|0;f[rb>>2]=ya;vb=w+48|0;ub=w+44|0;f[ub>>2]=vb;f[vb>>2]=0;f[w+52>>2]=0;if(!xb)Ob=_;else{_=xb+12|0;f[_>>2]=(f[_>>2]|0)+1;Ob=f[aa>>2]|0}if((Ob|0)<3){Ob=f[a+44>>2]|0;aa=f[ub>>2]|0;f[aa>>2]=f[Ob>>2];f[aa+4>>2]=f[Ob+4>>2]}else{f[za>>2]=0;U$(w,a)}if(!(j&16)){e0(a,t,v);a=f[Z>>2]|0;Ob=f[v>>2]|0;f0(w,a,(f[Ba>>2]|0)-a-(f[c>>2]|0)|0,Ob,(f[t>>2]|0)-Ob-(f[e>>2]|0)|0)|0}e=j|16;N0(l,ia,la,oa,1,1,1024,X+(f[J>>2]|0)|0);X=f[l>>2]|0;j=l+4|0;Ob=f[j>>2]|0;t=(Ob|0)==0;do if(!t){TXc(Ob);c=f[j>>2]|0;if(!c)break;UXc(c)}while(0);N0(l,ia,la,oa,1,1,1027,$);j=f[l>>2]|0;c=l+4|0;a=f[c>>2]|0;Ba=(a|0)==0;do if(!Ba){TXc(a);aa=f[c>>2]|0;if(!aa)break;UXc(aa)}while(0);b:do if((Aa|0)>0){c=h+4|0;aa=l+4|0;_=y+4|0;xb=l+4|0;db=l+8|0;Ka=l+12|0;tb=l+4|0;Qa=l+8|0;_a=l+12|0;qb=l+4|0;pb=l+8|0;nb=l+12|0;ob=B+4|0;mb=x+4|0;lb=B+8|0;kb=x+8|0;jb=B+12|0;ib=x+12|0;Ab=B+16|0;zb=x+16|0;gb=B+20|0;Nb=x+20|0;ab=B+24|0;Pa=x+24|0;Za=B+28|0;Ja=x+28|0;La=B+32|0;$a=x+32|0;fb=B+36|0;hb=x+36|0;eb=B+40|0;Bb=B+48|0;Mb=B+44|0;wa=B+52|0;Xa=x+44|0;xa=C+4|0;Va=z+4|0;va=C+8|0;Ta=z+8|0;ta=C+12|0;Ra=z+12|0;I=C+16|0;Na=z+16|0;ua=C+20|0;cb=z+20|0;bb=C+24|0;Hb=z+24|0;Ya=C+28|0;Wa=z+28|0;Ua=C+32|0;Sa=z+32|0;Oa=C+36|0;Ma=z+36|0;o=C+40|0;Ia=C+48|0;Ha=C+44|0;Ga=C+52|0;Fa=z+44|0;Ea=B+44|0;Da=C+44|0;Gb=l+4|0;Ca=B+40|0;P=H|1124007936;O=675553809>>>(H<<2)&15;N=l+8|0;M=l+12|0;Kb=l+4|0;Fb=C+8|0;Lb=C+4|0;Ib=y+8|0;Eb=y+12|0;Db=r+16|0;Pb=l+4|0;Qb=l+8|0;Rb=l+12|0;Sb=l+8|0;Tb=l+12|0;Ub=l+4|0;Vb=D+8|0;Wb=D+12|0;Xb=D+4|0;Yb=E+8|0;Zb=E+4|0;_b=D+4|0;$b=D+8|0;ac=D+12|0;bc=l+4|0;cc=l+8|0;dc=l+12|0;ec=l+16|0;fc=l+20|0;gc=l+24|0;hc=l+28|0;ic=l+32|0;jc=l+36|0;kc=l+44|0;lc=l+40|0;mc=l+48|0;nc=l+8|0;oc=l+4|0;pc=l+8|0;qc=l+12|0;rc=l+4|0;sc=D+8|0;tc=D+12|0;uc=D+4|0;vc=E+8|0;wc=E+4|0;xc=D+4|0;yc=D+8|0;zc=D+12|0;Ac=D+16|0;Bc=D+20|0;Cc=D+24|0;Dc=D+28|0;Ec=D+40|0;Fc=D+48|0;Gc=D+44|0;Hc=D+52|0;Ic=l+8|0;Jc=l+4|0;Kc=D+36|0;Lc=D+32|0;Mc=C+36|0;Nc=C+16|0;Oc=C+4|0;Pc=C+40|0;Qc=C+44|0;Rc=C+48|0;Sc=l+4|0;Tc=D+4|0;Uc=D+8|0;Vc=D+12|0;Wc=D+16|0;Xc=D+20|0;Yc=D+24|0;Zc=D+28|0;_c=D+40|0;$c=D+48|0;ad=D+44|0;bd=D+52|0;cd=l+8|0;dd=l+4|0;ed=D+36|0;fd=D+32|0;gd=l+8|0;hd=l+12|0;id=l+4|0;jd=D+8|0;kd=D+4|0;ld=l+8|0;md=l+12|0;nd=l+4|0;od=C+8|0;pd=C+4|0;qd=l+8|0;rd=l+4|0;sd=A+36|0;td=A+16|0;ud=A+4|0;vd=A+40|0;wd=A+44|0;xd=A+48|0;yd=z+40|0;zd=z+48|0;Ad=y+36|0;Bd=y+16|0;Cd=y+4|0;Dd=y+40|0;Ed=y+44|0;Fd=y+48|0;Gd=x+40|0;Hd=x+48|0;Id=B+52|0;Jd=B+52|0;Kd=0;c:while(1){Ld=Y((Kd|0)%(Cb|0)|0,ha)|0;Md=Y((Kd|0)/(Cb|0)|0,$)|0;Nd=(f[W>>2]|0)-Ld|0;Od=(Nd|0)<(ha|0)?Nd:ha;Nd=(f[ka>>2]|0)-Md|0;Pd=(Nd|0)<($|0)?Nd:$;Qd=(f[K>>2]|0)+-1+Od|0;Rd=(f[J>>2]|0)+-1+Pd|0;Sd=Ld-(f[h>>2]|0)+(f[v>>2]|0)|0;Td=Md-(f[c>>2]|0)+(f[Z>>2]|0)|0;Ud=(Sd|0)>0?Sd:0;Vd=(Td|0)>0?Td:0;Wd=Sd+Qd|0;Xd=f[sb>>2]|0;Yd=(Wd|0)<(Xd|0)?Wd:Xd;Xd=Td+Rd|0;Wd=f[ya>>2]|0;Zd=(Xd|0)<(Wd|0)?Xd:Wd;f[l>>2]=Vd;f[aa>>2]=Zd;f[y>>2]=Ud;f[_>>2]=Yd;W$(x,w,l,y);f[l>>2]=0;f[xb>>2]=0;f[db>>2]=Qd;f[Ka>>2]=Rd;Z$(y,r,l);Wd=Ud-Sd|0;Sd=Vd-Td|0;Td=Yd-Ud|0;Ud=Zd-Vd|0;f[l>>2]=Wd;f[tb>>2]=Sd;f[Qa>>2]=Td;f[_a>>2]=Ud;Z$(z,r,l);f[l>>2]=Ld;f[qb>>2]=Md;f[pb>>2]=Od;f[nb>>2]=Pd;Z$(A,d,l);Md=(Y(Ud,Td)|0)!=0;Ld=Y(Td,O)|0;Vd=Y(Ld,Ud)|0;Zd=0-Ld|0;Yd=(Td|0)<(Qd|0)|(Ud|0)<(Rd|0);Qd=($|0)<=(Nd|0);Nd=(Y(Pd,Od)|0)!=0;Xd=0;while(1){f[B>>2]=f[x>>2];_d=f[mb>>2]|0;f[ob>>2]=_d;f[lb>>2]=f[kb>>2];f[jb>>2]=f[ib>>2];f[Ab>>2]=f[zb>>2];f[gb>>2]=f[Nb>>2];f[ab>>2]=f[Pa>>2];f[Za>>2]=f[Ja>>2];f[La>>2]=f[$a>>2];$d=f[hb>>2]|0;f[fb>>2]=$d;f[eb>>2]=lb;f[Mb>>2]=Bb;f[Bb>>2]=0;f[wa>>2]=0;if(!$d)ae=_d;else{_d=$d+12|0;f[_d>>2]=(f[_d>>2]|0)+1;ae=f[mb>>2]|0}if((ae|0)<3){_d=f[Xa>>2]|0;$d=f[Mb>>2]|0;f[$d>>2]=f[_d>>2];f[$d+4>>2]=f[_d+4>>2]}else{f[ob>>2]=0;U$(B,x)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;lR(r,l)|0;if(ja){do if(g){f[C>>2]=f[z>>2];_d=f[Va>>2]|0;f[xa>>2]=_d;f[va>>2]=f[Ta>>2];f[ta>>2]=f[Ra>>2];f[I>>2]=f[Na>>2];f[ua>>2]=f[cb>>2];f[bb>>2]=f[Hb>>2];f[Ya>>2]=f[Wa>>2];f[Ua>>2]=f[Sa>>2];$d=f[Ma>>2]|0;f[Oa>>2]=$d;f[o>>2]=va;f[Ha>>2]=Ia;f[Ia>>2]=0;f[Ga>>2]=0;if(!$d)be=_d;else{_d=$d+12|0;f[_d>>2]=(f[_d>>2]|0)+1;be=f[Va>>2]|0}if((be|0)<3){_d=f[Fa>>2]|0;$d=f[Ha>>2]|0;f[$d>>2]=f[_d>>2];f[$d+4>>2]=f[_d+4>>2];break}else{f[xa>>2]=0;U$(C,z);break}}else{_d=f[m>>2]|0;f[C>>2]=P;f[xa>>2]=2;f[va>>2]=Ud;f[ta>>2]=Td;f[I>>2]=_d;f[ua>>2]=_d;f[bb>>2]=0;f[bb+4>>2]=0;f[bb+8>>2]=0;f[bb+12>>2]=0;f[o>>2]=va;f[Ha>>2]=Ia;f[Ga>>2]=0;f[Ia>>2]=0;if(Md&(_d|0)==0){Jb=136;break c}f[Ia>>2]=Ld;f[Ga>>2]=O;$d=_d+Vd|0;f[Ya>>2]=$d;f[bb>>2]=$d+Zd+Ld;R$(C)}while(0);$d=f[fb>>2]|0;do if($d|0){_d=$d+12|0;ce=f[_d>>2]|0;f[_d>>2]=ce+-1;if((ce|0)!=1)break;V$(B)}while(0);f[fb>>2]=0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[ob>>2]|0)>0){$d=f[eb>>2]|0;ce=0;do{f[$d+(ce<<2)>>2]=0;ce=ce+1|0}while((ce|0)<(f[ob>>2]|0))}f[B>>2]=f[C>>2];ce=f[xa>>2]|0;f[ob>>2]=ce;f[lb>>2]=f[va>>2];f[jb>>2]=f[ta>>2];f[Ab>>2]=f[I>>2];f[gb>>2]=f[ua>>2];f[ab>>2]=f[bb>>2];f[Za>>2]=f[Ya>>2];f[La>>2]=f[Ua>>2];f[fb>>2]=f[Oa>>2];$d=f[Ea>>2]|0;if(($d|0)==(Bb|0))de=ce;else{wL($d);f[Ea>>2]=Bb;f[eb>>2]=lb;de=f[xa>>2]|0}if((de|0)<3){$d=f[Da>>2]|0;f[Bb>>2]=f[$d>>2];f[Id>>2]=f[$d+4>>2];ee=$d}else{f[Ea>>2]=f[Da>>2];f[Ca>>2]=f[o>>2];f[Da>>2]=Ia;f[o>>2]=va;ee=Ia}f[C>>2]=1124007936;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;f[xa+16>>2]=0;f[xa+20>>2]=0;f[xa+24>>2]=0;f[xa+28>>2]=0;f[Oa>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((ee|0)!=(Ia|0))wL(ee);f[l>>2]=Xd;f[Gb>>2]=0;d1(x,1,B,1,l,1)}if((f[Na>>2]|0)!=(f[Ab>>2]|0)){$d=qd;f[$d>>2]=0;f[$d+4>>2]=0;f[l>>2]=33619968;f[rd>>2]=z;dY(B,l,f[z>>2]&7,1.0,0.0)}if(Yd){f[N>>2]=0;f[M>>2]=0;f[l>>2]=16842752;f[Kb>>2]=z;$d=Fb;f[$d>>2]=0;f[$d+4>>2]=0;f[C>>2]=33619968;f[Lb>>2]=y;$d=f[Ib>>2]|0;ce=f[Ta>>2]|0;_d=f[Eb>>2]|0;fe=f[Ra>>2]|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[D+24>>2]=0;f[D+28>>2]=0;rR(l,C,Sd,$d-Sd-ce|0,Wd,_d-Wd-fe|0,e,D)}if(Qd){fe=f[Db>>2]|0;_d=f[qa>>2]|0;gi[f[f[X>>2]>>2]&255](X,fe,_d,fe,_d)}else{f[ld>>2]=0;f[md>>2]=0;f[l>>2]=16842752;f[nd>>2]=r;_d=od;f[_d>>2]=0;f[_d+4>>2]=0;f[C>>2]=33619968;f[pd>>2]=r;a1(l,C,0,Rd)}_d=Y(Xd,la)|0;f[l>>2]=0;f[Pb>>2]=ca?_d:0;f[Qb>>2]=ia;f[Rb>>2]=la;Z$(C,q,l);f[Sb>>2]=0;f[Tb>>2]=0;f[l>>2]=16842752;f[Ub>>2]=r;f[Vb>>2]=0;f[Wb>>2]=0;f[D>>2]=16842752;f[Xb>>2]=C;_d=Yb;f[_d>>2]=0;f[_d+4>>2]=0;f[E>>2]=33619968;f[Zb>>2]=r;b1(l,D,E,0,1);if(Qd){_d=f[Db>>2]|0;fe=f[qa>>2]|0;gi[f[f[j>>2]>>2]&255](j,_d,fe,_d,fe)}else{f[gd>>2]=0;f[hd>>2]=0;f[l>>2]=16842752;f[id>>2]=r;fe=jd;f[fe>>2]=0;f[fe+4>>2]=0;f[D>>2]=33619968;f[kd>>2]=r;a1(l,D,3,Pd)}f[D>>2]=0;f[_b>>2]=0;f[$b>>2]=Od;f[ac>>2]=Pd;Z$(l,r,D);fe=f[fb>>2]|0;do if(fe|0){_d=fe+12|0;ce=f[_d>>2]|0;f[_d>>2]=ce+-1;if((ce|0)!=1)break;V$(B)}while(0);f[fb>>2]=0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[ob>>2]|0)>0){fe=f[eb>>2]|0;ce=0;do{f[fe+(ce<<2)>>2]=0;ce=ce+1|0}while((ce|0)<(f[ob>>2]|0))}f[B>>2]=f[l>>2];ce=f[bc>>2]|0;f[ob>>2]=ce;f[lb>>2]=f[cc>>2];f[jb>>2]=f[dc>>2];f[Ab>>2]=f[ec>>2];f[gb>>2]=f[fc>>2];f[ab>>2]=f[gc>>2];f[Za>>2]=f[hc>>2];f[La>>2]=f[ic>>2];f[fb>>2]=f[jc>>2];fe=f[Ea>>2]|0;if((fe|0)==(Bb|0))ge=ce;else{wL(fe);f[Ea>>2]=Bb;f[eb>>2]=lb;ge=f[bc>>2]|0}if((ge|0)<3){fe=f[kc>>2]|0;f[Bb>>2]=f[fe>>2];f[Jd>>2]=f[fe+4>>2];he=fe}else{f[Ea>>2]=f[kc>>2];f[Ca>>2]=f[lc>>2];f[kc>>2]=mc;f[lc>>2]=cc;he=mc}f[l>>2]=1124007936;f[bc>>2]=0;f[bc+4>>2]=0;f[bc+8>>2]=0;f[bc+12>>2]=0;f[bc+16>>2]=0;f[bc+20>>2]=0;f[bc+24>>2]=0;f[bc+28>>2]=0;f[jc>>2]=0;f[ec>>2]=0;f[ec+4>>2]=0;f[ec+8>>2]=0;f[ec+12>>2]=0;if((he|0)!=(mc|0))wL(he);do if(na){if(!Xd){fe=nc;f[fe>>2]=0;f[fe+4>>2]=0;f[l>>2]=33619968;f[oc>>2]=A;dY(B,l,f[p>>2]|0,1.0,i);break}fe=f[p>>2]|0;if((oa|0)!=(fe|0)){ce=f[m>>2]|0;f[D>>2]=fe&4095|1124007936;f[xc>>2]=2;f[yc>>2]=Pd;f[zc>>2]=Od;f[Ac>>2]=ce;f[Bc>>2]=ce;f[Cc>>2]=0;f[Cc+4>>2]=0;f[Cc+8>>2]=0;f[Cc+12>>2]=0;f[Ec>>2]=yc;f[Gc>>2]=Fc;f[Hc>>2]=0;f[Fc>>2]=0;if(Nd&(ce|0)==0){Jb=206;break c}_d=Y(675553809>>>(fe<<2&28)&15,(fe>>>3&511)+1|0)|0;$d=Y(_d,Od)|0;f[Fc>>2]=$d;f[Hc>>2]=_d;_d=ce+(Y($d,Pd)|0)|0;f[Dc>>2]=_d;f[Cc>>2]=_d+(0-$d)+$d;R$(D);$d=Ic;f[$d>>2]=0;f[$d+4>>2]=0;f[l>>2]=33619968;f[Jc>>2]=D;dY(B,l,fe,1.0,0.0);fe=f[Kc>>2]|0;if(fe|0){$d=fe+12|0;f[$d>>2]=(f[$d>>2]|0)+1}$d=f[fb>>2]|0;do if($d|0){fe=$d+12|0;_d=f[fe>>2]|0;f[fe>>2]=_d+-1;if((_d|0)!=1)break;V$(B)}while(0);f[fb>>2]=0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[ob>>2]|0)>0){$d=f[eb>>2]|0;_d=0;do{f[$d+(_d<<2)>>2]=0;_d=_d+1|0;ie=f[ob>>2]|0}while((_d|0)<(ie|0));f[B>>2]=f[D>>2];if((ie|0)<3)Jb=217;else Jb=219}else{f[B>>2]=f[D>>2];Jb=217}do if((Jb|0)==217){Jb=0;_d=f[xc>>2]|0;if((_d|0)>=3){Jb=219;break}f[ob>>2]=_d;f[lb>>2]=f[yc>>2];f[jb>>2]=f[zc>>2];_d=f[Gc>>2]|0;$d=f[Mb>>2]|0;f[$d>>2]=f[_d>>2];f[$d+4>>2]=f[_d+4>>2]}while(0);if((Jb|0)==219){Jb=0;U$(B,D)}f[Ab>>2]=f[Ac>>2];f[gb>>2]=f[Bc>>2];f[ab>>2]=f[Cc>>2];f[Za>>2]=f[Dc>>2];f[La>>2]=f[Lc>>2];_d=f[Kc>>2]|0;f[fb>>2]=_d;do if(_d|0){$d=_d+12|0;fe=f[$d>>2]|0;f[$d>>2]=fe+-1;if((fe|0)!=1)break;V$(D)}while(0);f[Kc>>2]=0;f[Ac>>2]=0;f[Ac+4>>2]=0;f[Ac+8>>2]=0;f[Ac+12>>2]=0;if((f[xc>>2]|0)>0){_d=f[Ec>>2]|0;fe=0;do{f[_d+(fe<<2)>>2]=0;fe=fe+1|0}while((fe|0)<(f[xc>>2]|0))}fe=f[Gc>>2]|0;if((fe|0)!=(Fc|0))wL(fe)}f[pc>>2]=0;f[qc>>2]=0;f[l>>2]=16842752;f[rc>>2]=B;f[sc>>2]=0;f[tc>>2]=0;f[D>>2]=16842752;f[uc>>2]=A;fe=vc;f[fe>>2]=0;f[fe+4>>2]=0;f[E>>2]=33619968;f[wc>>2]=A;E1(l,D,E,fT()|0,-1)}else{fe=f[p>>2]|0;if((fe|0)!=(oa|0)){_d=f[m>>2]|0;f[D>>2]=fe&4095|1124007936;f[Tc>>2]=2;f[Uc>>2]=Pd;f[Vc>>2]=Od;f[Wc>>2]=_d;f[Xc>>2]=_d;f[Yc>>2]=0;f[Yc+4>>2]=0;f[Yc+8>>2]=0;f[Yc+12>>2]=0;f[_c>>2]=Uc;f[ad>>2]=$c;f[bd>>2]=0;f[$c>>2]=0;if(Nd&(_d|0)==0){Jb=178;break c}$d=Y(675553809>>>(fe<<2&28)&15,(fe>>>3&511)+1|0)|0;ce=Y($d,Od)|0;f[$c>>2]=ce;f[bd>>2]=$d;$d=_d+(Y(ce,Pd)|0)|0;f[Zc>>2]=$d;f[Yc>>2]=$d+(0-ce)+ce;R$(D);ce=cd;f[ce>>2]=0;f[ce+4>>2]=0;f[l>>2]=33619968;f[dd>>2]=D;dY(B,l,fe,1.0,i);fe=f[ed>>2]|0;if(fe|0){ce=fe+12|0;f[ce>>2]=(f[ce>>2]|0)+1}ce=f[fb>>2]|0;do if(ce|0){fe=ce+12|0;$d=f[fe>>2]|0;f[fe>>2]=$d+-1;if(($d|0)!=1)break;V$(B)}while(0);f[fb>>2]=0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[ob>>2]|0)>0){ce=f[eb>>2]|0;$d=0;do{f[ce+($d<<2)>>2]=0;$d=$d+1|0;je=f[ob>>2]|0}while(($d|0)<(je|0));f[B>>2]=f[D>>2];if((je|0)<3)Jb=189;else Jb=191}else{f[B>>2]=f[D>>2];Jb=189}do if((Jb|0)==189){Jb=0;$d=f[Tc>>2]|0;if(($d|0)>=3){Jb=191;break}f[ob>>2]=$d;f[lb>>2]=f[Uc>>2];f[jb>>2]=f[Vc>>2];$d=f[ad>>2]|0;ce=f[Mb>>2]|0;f[ce>>2]=f[$d>>2];f[ce+4>>2]=f[$d+4>>2]}while(0);if((Jb|0)==191){Jb=0;U$(B,D)}f[Ab>>2]=f[Wc>>2];f[gb>>2]=f[Xc>>2];f[ab>>2]=f[Yc>>2];f[Za>>2]=f[Zc>>2];f[La>>2]=f[fd>>2];$d=f[ed>>2]|0;f[fb>>2]=$d;do if($d|0){ce=$d+12|0;fe=f[ce>>2]|0;f[ce>>2]=fe+-1;if((fe|0)!=1)break;V$(D)}while(0);f[ed>>2]=0;f[Wc>>2]=0;f[Wc+4>>2]=0;f[Wc+8>>2]=0;f[Wc+12>>2]=0;if((f[Tc>>2]|0)>0){$d=f[_c>>2]|0;fe=0;do{f[$d+(fe<<2)>>2]=0;fe=fe+1|0}while((fe|0)<(f[Tc>>2]|0))}fe=f[ad>>2]|0;if((fe|0)!=($c|0))wL(fe)}f[l>>2]=0;f[Sc>>2]=Xd;d1(B,1,A,1,l,1)}while(0);fe=f[Mc>>2]|0;do if(fe|0){$d=fe+12|0;ce=f[$d>>2]|0;f[$d>>2]=ce+-1;if((ce|0)!=1)break;V$(C)}while(0);f[Mc>>2]=0;f[Nc>>2]=0;f[Nc+4>>2]=0;f[Nc+8>>2]=0;f[Nc+12>>2]=0;if((f[Oc>>2]|0)>0){fe=f[Pc>>2]|0;ce=0;do{f[fe+(ce<<2)>>2]=0;ce=ce+1|0}while((ce|0)<(f[Oc>>2]|0))}ce=f[Qc>>2]|0;if((ce|0)!=(Rc|0))wL(ce);ce=f[fb>>2]|0;do if(ce|0){fe=ce+12|0;$d=f[fe>>2]|0;f[fe>>2]=$d+-1;if(($d|0)!=1)break;V$(B)}while(0);f[fb>>2]=0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=0;f[Ab+12>>2]=0;if((f[ob>>2]|0)>0){ce=f[eb>>2]|0;$d=0;do{f[ce+($d<<2)>>2]=0;$d=$d+1|0}while(($d|0)<(f[ob>>2]|0))}$d=f[Mb>>2]|0;if(($d|0)!=(Bb|0))wL($d);if((Xd|0)<(V|0))Xd=Xd+1|0;else break}Xd=f[sd>>2]|0;do if(Xd|0){Pd=Xd+12|0;Od=f[Pd>>2]|0;f[Pd>>2]=Od+-1;if((Od|0)!=1)break;V$(A)}while(0);f[sd>>2]=0;f[td>>2]=0;f[td+4>>2]=0;f[td+8>>2]=0;f[td+12>>2]=0;if((f[ud>>2]|0)>0){Xd=f[vd>>2]|0;Od=0;do{f[Xd+(Od<<2)>>2]=0;Od=Od+1|0}while((Od|0)<(f[ud>>2]|0))}Od=f[wd>>2]|0;if((Od|0)!=(xd|0))wL(Od);Od=f[Ma>>2]|0;do if(Od|0){Xd=Od+12|0;Pd=f[Xd>>2]|0;f[Xd>>2]=Pd+-1;if((Pd|0)!=1)break;V$(z)}while(0);f[Ma>>2]=0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[Va>>2]|0)>0){Od=f[yd>>2]|0;Pd=0;do{f[Od+(Pd<<2)>>2]=0;Pd=Pd+1|0}while((Pd|0)<(f[Va>>2]|0))}Pd=f[Fa>>2]|0;if((Pd|0)!=(zd|0))wL(Pd);Pd=f[Ad>>2]|0;do if(Pd|0){Od=Pd+12|0;Xd=f[Od>>2]|0;f[Od>>2]=Xd+-1;if((Xd|0)!=1)break;V$(y)}while(0);f[Ad>>2]=0;f[Bd>>2]=0;f[Bd+4>>2]=0;f[Bd+8>>2]=0;f[Bd+12>>2]=0;if((f[Cd>>2]|0)>0){Pd=f[Dd>>2]|0;Xd=0;do{f[Pd+(Xd<<2)>>2]=0;Xd=Xd+1|0}while((Xd|0)<(f[Cd>>2]|0))}Xd=f[Ed>>2]|0;if((Xd|0)!=(Fd|0))wL(Xd);Xd=f[hb>>2]|0;do if(Xd|0){Pd=Xd+12|0;Od=f[Pd>>2]|0;f[Pd>>2]=Od+-1;if((Od|0)!=1)break;V$(x)}while(0);f[hb>>2]=0;f[zb>>2]=0;f[zb+4>>2]=0;f[zb+8>>2]=0;f[zb+12>>2]=0;if((f[mb>>2]|0)>0){Xd=f[Gd>>2]|0;Od=0;do{f[Xd+(Od<<2)>>2]=0;Od=Od+1|0}while((Od|0)<(f[mb>>2]|0))}Od=f[Xa>>2]|0;if((Od|0)!=(Hd|0))wL(Od);Kd=Kd+1|0;if((Kd|0)>=(Aa|0))break b}if((Jb|0)==136){Kd=$Xc(32)|0;f[l>>2]=Kd;f[l+8>>2]=-2147483616;f[l+4>>2]=28;ea=Kd;fa=470314;ga=ea+28|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[Kd+28>>0]=0;vM(-215,l,470343,470347,548)}else if((Jb|0)==178){Hd=$Xc(32)|0;f[l>>2]=Hd;f[l+8>>2]=-2147483616;f[l+4>>2]=28;ea=Hd;fa=470314;ga=ea+28|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[Hd+28>>0]=0;vM(-215,l,470343,470347,577)}else if((Jb|0)==206){Kd=$Xc(32)|0;f[l>>2]=Kd;f[l+8>>2]=-2147483616;f[l+4>>2]=28;ea=Kd;fa=470314;ga=ea+28|0;do{b[ea>>0]=b[fa>>0]|0;ea=ea+1|0;fa=fa+1|0}while((ea|0)<(ga|0));b[Kd+28>>0]=0;vM(-215,l,470343,470347,577)}}while(0);if(!Ba)UXc(a);if(!t)UXc(Ob);Ob=f[wb>>2]|0;do if(Ob|0){t=Ob+12|0;a=f[t>>2]|0;f[t>>2]=a+-1;if((a|0)!=1)break;V$(w)}while(0);f[wb>>2]=0;f[yb>>2]=0;f[yb+4>>2]=0;f[yb+8>>2]=0;f[yb+12>>2]=0;if((f[za>>2]|0)>0){yb=f[rb>>2]|0;rb=0;do{f[yb+(rb<<2)>>2]=0;rb=rb+1|0}while((rb|0)<(f[za>>2]|0))}za=f[ub>>2]|0;if((za|0)!=(vb|0))wL(za);za=f[s+4>>2]|0;if(za|0)UXc(za);za=r+36|0;s=f[za>>2]|0;do if(s|0){vb=s+12|0;ub=f[vb>>2]|0;f[vb>>2]=ub+-1;if((ub|0)!=1)break;V$(r)}while(0);f[za>>2]=0;za=r+16|0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((f[pa>>2]|0)>0){za=f[ra>>2]|0;ra=0;do{f[za+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[pa>>2]|0))}pa=f[sa>>2]|0;if((pa|0)!=(qa|0))wL(pa);pa=q+36|0;qa=f[pa>>2]|0;do if(qa|0){sa=qa+12|0;ra=f[sa>>2]|0;f[sa>>2]=ra+-1;if((ra|0)!=1)break;V$(q)}while(0);f[pa>>2]=0;pa=q+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[R>>2]|0)>0){pa=f[ba>>2]|0;ba=0;do{f[pa+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[R>>2]|0))}R=f[da>>2]|0;if((R|0)!=(ma|0))wL(R);R=f[Q>>2]|0;do if(R|0){ma=R+12|0;da=f[ma>>2]|0;f[ma>>2]=da+-1;if((da|0)!=1)break;V$(n)}while(0);f[Q>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[G>>2]|0)>0){L=f[S>>2]|0;S=0;do{f[L+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[G>>2]|0))}G=f[U>>2]|0;if((G|0)!=(T|0))wL(G);G=f[m>>2]|0;if(!G){u=k;return}if((f[F>>2]|0)!=(G|0))f[F>>2]=G;cYc(G);u=k;return}function Fba(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0;h=u;u=u+2128|0;i=h+1360|0;j=h+2064|0;k=h+1328|0;l=h+1272|0;m=h+1216|0;o=h+2008|0;q=h+1952|0;r=h+1872|0;s=h+1816|0;t=h+992|0;v=h+1760|0;w=h+768|0;x=h+1704|0;y=h+544|0;z=h+512|0;A=h+480|0;B=h+256|0;C=h+32|0;D=h+1648|0;E=h+1640|0;F=h+1632|0;G=h+1624|0;H=h+1616|0;I=h;J=h+1608|0;K=h+1600|0;N=h+1592|0;O=h+1584|0;P=h+1944|0;Q=h+1936|0;R=h+1928|0;if(!(sS(g)|0)){S=dS(a,-1)|0;T=S&4088;if(e>>>0>=6){U=$Xc(64)|0;f[i>>2]=U;f[i+8>>2]=-2147483584;f[i+4>>2]=55;V=U;W=254075;X=V+55|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));b[U+55>>0]=0;vM(-215,i,254131,253820,768)}U=(S&7|0)==0;switch(S&7){case 0:case 5:break;default:{Z=$Xc(96)|0;f[i>>2]=Z;_=i+8|0;f[_>>2]=-2147483552;$=i+4|0;f[$>>2]=80;V=Z;W=254149;X=V+80|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));aa=Z+80|0;b[aa>>0]=0;vM(-215,i,254131,253820,769)}}if((S|0)!=(dS(c,-1)|0)){Z=$Xc(96)|0;f[i>>2]=Z;_=i+8|0;f[_>>2]=-2147483552;$=i+4|0;f[$>>2]=80;V=Z;W=254149;X=V+80|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));aa=Z+80|0;b[aa>>0]=0;vM(-215,i,254131,253820,769)}if((oS(a,-1)|0)>=3){Z=$Xc(96)|0;f[i>>2]=Z;_=i+8|0;f[_>>2]=-2147483552;$=i+4|0;f[$>>2]=80;V=Z;W=254149;X=V+80|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));aa=Z+80|0;b[aa>>0]=0;vM(-215,i,254131,253820,769)}do if((eS(a)|0)==65536){aa=f[a+4>>2]|0;f[l>>2]=f[aa>>2];Z=l+4|0;$=aa+4|0;f[Z>>2]=f[$>>2];_=l+8|0;f[_>>2]=f[aa+8>>2];f[l+12>>2]=f[aa+12>>2];f[l+16>>2]=f[aa+16>>2];f[l+20>>2]=f[aa+20>>2];f[l+24>>2]=f[aa+24>>2];f[l+28>>2]=f[aa+28>>2];f[l+32>>2]=f[aa+32>>2];S=f[aa+36>>2]|0;f[l+36>>2]=S;f[l+40>>2]=_;_=l+48|0;ba=l+44|0;f[ba>>2]=_;f[_>>2]=0;f[l+52>>2]=0;if(S|0){_=S+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[$>>2]|0)<3){$=f[aa+44>>2]|0;_=f[ba>>2]|0;f[_>>2]=f[$>>2];f[_+4>>2]=f[$+4>>2];break}else{f[Z>>2]=0;U$(l,aa);break}}else bS(l,a,-1);while(0);do if((eS(c)|0)==65536){aa=f[c+4>>2]|0;f[m>>2]=f[aa>>2];Z=m+4|0;$=aa+4|0;f[Z>>2]=f[$>>2];_=m+8|0;f[_>>2]=f[aa+8>>2];f[m+12>>2]=f[aa+12>>2];f[m+16>>2]=f[aa+16>>2];f[m+20>>2]=f[aa+20>>2];f[m+24>>2]=f[aa+24>>2];f[m+28>>2]=f[aa+28>>2];f[m+32>>2]=f[aa+32>>2];ba=f[aa+36>>2]|0;f[m+36>>2]=ba;f[m+40>>2]=_;_=m+48|0;S=m+44|0;f[S>>2]=_;f[_>>2]=0;f[m+52>>2]=0;if(ba|0){_=ba+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[$>>2]|0)<3){$=f[aa+44>>2]|0;_=f[S>>2]|0;f[_>>2]=f[$>>2];f[_+4>>2]=f[$+4>>2];break}else{f[Z>>2]=0;U$(m,aa);break}}else bS(m,c,-1);while(0);do if((eS(g)|0)==65536){aa=f[g+4>>2]|0;f[o>>2]=f[aa>>2];Z=o+4|0;$=aa+4|0;f[Z>>2]=f[$>>2];_=o+8|0;f[_>>2]=f[aa+8>>2];f[o+12>>2]=f[aa+12>>2];f[o+16>>2]=f[aa+16>>2];f[o+20>>2]=f[aa+20>>2];f[o+24>>2]=f[aa+24>>2];f[o+28>>2]=f[aa+28>>2];f[o+32>>2]=f[aa+32>>2];S=f[aa+36>>2]|0;f[o+36>>2]=S;f[o+40>>2]=_;_=o+48|0;ba=o+44|0;f[ba>>2]=_;f[_>>2]=0;f[o+52>>2]=0;if(S|0){_=S+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[$>>2]|0)<3){$=f[aa+44>>2]|0;_=f[ba>>2]|0;f[_>>2]=f[$>>2];f[_+4>>2]=f[$+4>>2];break}else{f[Z>>2]=0;U$(o,aa);break}}else bS(o,g,-1);while(0);g=f[m>>2]|0;aa=f[l>>2]&4088;if(U){Z=i+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;dY(l,i,T|5,.00392156862745098,0.0)}if(!(g&7)){T=i+8|0;f[T>>2]=0;f[T+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;dY(m,i,g&4088|5,.00392156862745098,0.0)}if(U){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=k;f[j+8>>2]=1;f[j+12>>2]=4;U=q+8|0;f[U>>2]=0;f[U+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;M1(i,j,q,5);U=i+8|0;f[U>>2]=0;f[U+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;dY(o,i,aa|5,.00392156862745098,0.0)}aa=m+12|0;U=(f[l+12>>2]|0)-(f[aa>>2]|0)+1|0;g=m+8|0;T=(f[l+8>>2]|0)-(f[g>>2]|0)+1|0;f[r>>2]=U;f[r+4>>2]=T;wS(d,r,5,-1,0,0);do if((eS(d)|0)==65536){Z=f[d+4>>2]|0;f[q>>2]=f[Z>>2];$=q+4|0;_=Z+4|0;f[$>>2]=f[_>>2];ba=q+8|0;f[ba>>2]=f[Z+8>>2];f[q+12>>2]=f[Z+12>>2];f[q+16>>2]=f[Z+16>>2];f[q+20>>2]=f[Z+20>>2];f[q+24>>2]=f[Z+24>>2];f[q+28>>2]=f[Z+28>>2];f[q+32>>2]=f[Z+32>>2];S=f[Z+36>>2]|0;f[q+36>>2]=S;f[q+40>>2]=ba;ba=q+48|0;ca=q+44|0;f[ca>>2]=ba;f[ba>>2]=0;f[q+52>>2]=0;if(S|0){ba=S+12|0;f[ba>>2]=(f[ba>>2]|0)+1}if((f[_>>2]|0)<3){_=f[Z+44>>2]|0;ba=f[ca>>2]|0;f[ba>>2]=f[_>>2];f[ba+4>>2]=f[_+4>>2];break}else{f[$>>2]=0;U$(q,Z);break}}else bS(q,d,-1);while(0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=l;o$(t,l,i,1.0);f[s>>2]=1124007936;Z=s+4|0;$=s+8|0;_=s+40|0;V=Z;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[_>>2]=$;$=s+48|0;ba=s+44|0;f[ba>>2]=$;f[$>>2]=0;f[s+52>>2]=0;ca=f[t>>2]|0;ei[f[(f[ca>>2]|0)+12>>2]&511](ca,t,s,-1);Zj(t);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;o$(w,o,i,1.0);f[v>>2]=1124007936;ca=v+4|0;S=v+8|0;da=v+40|0;V=ca;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[da>>2]=S;S=v+48|0;ea=v+44|0;f[ea>>2]=S;f[S>>2]=0;f[v+52>>2]=0;fa=f[w>>2]|0;ei[f[(f[fa>>2]|0)+12>>2]&511](fa,w,v,-1);Zj(w);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;o$(y,m,i,1.0);f[x>>2]=1124007936;w=x+4|0;fa=x+8|0;ga=x+40|0;V=w;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[ga>>2]=fa;fa=x+48|0;ha=x+44|0;f[ha>>2]=fa;f[fa>>2]=0;f[x+52>>2]=0;ia=f[y>>2]|0;ei[f[(f[ia>>2]|0)+12>>2]&511](ia,y,x,-1);Zj(y);f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+20>>2]=0;f[A+24>>2]=0;f[A+28>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=x;f[j>>2]=-1040056314;f[j+4>>2]=z;f[j+8>>2]=1;f[j+12>>2]=4;f[k>>2]=-1040056314;f[k+4>>2]=A;f[k+8>>2]=1;f[k+12>>2]=4;nL(i,j,k,fT()|0);ja=+p[A>>3];ka=+p[A+8>>3];la=+p[A+16>>3];ma=+p[A+24>>3];na=+p[z>>3];oa=+p[z+8>>3];pa=+p[z+16>>3];qa=+p[z+24>>3];ra=(ja*ja+ka*ka+la*la+ma*ma+(na*na+oa*oa+pa*pa+qa*qa))*(+(f[g>>2]|0)*+(f[aa>>2]|0));a:do switch(e|0){case 0:{f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=v;o$(C,m,i,1.0);f[B>>2]=1124007936;aa=B+4|0;g=B+8|0;z=B+40|0;V=aa;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[z>>2]=g;A=B+48|0;y=B+44|0;f[y>>2]=A;f[A>>2]=0;f[B+52>>2]=0;ia=f[C>>2]|0;ei[f[(f[ia>>2]|0)+12>>2]&511](ia,C,B,-1);Zj(C);f[D>>2]=1124007936;ia=D+4|0;sa=D+8|0;ta=D+40|0;V=ia;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[ta>>2]=sa;g=D+48|0;ua=D+44|0;f[ua>>2]=g;f[g>>2]=0;f[D+52>>2]=0;f[i>>2]=T;f[i+4>>2]=U;S$(D,2,i,5);va=f[ta>>2]|0;wa=f[va>>2]|0;f[E>>2]=f[va+4>>2];f[E+4>>2]=wa;wa=f[D>>2]&4095;f[F>>2]=0;f[F+4>>2]=0;Eba(l,B,D,E,wa,F,0.0,0);wa=f[q+40>>2]|0;va=f[wa>>2]|0;f[G>>2]=f[wa+4>>2];f[G+4>>2]=va;va=f[q>>2]&4095;f[H>>2]=0;f[H+4>>2]=0;Eba(s,o,q,G,va,H,0.0,0);c$(i,D,2.0);va=f[i>>2]|0;Ti[f[(f[va>>2]|0)+28>>2]&511](va,i,q);Zj(i);p[I>>3]=ra;va=I+8|0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;f[va+16>>2]=0;f[va+20>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=q;f[j>>2]=-1056833530;f[j+4>>2]=I;f[j+8>>2]=1;f[j+12>>2]=4;va=k+8|0;f[va>>2]=0;f[va+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;E1(i,j,k,fT()|0,-1);va=D+36|0;wa=f[va>>2]|0;if(wa|0?(xa=wa+12|0,wa=f[xa>>2]|0,f[xa>>2]=wa+-1,(wa|0)==1):0)V$(D);f[va>>2]=0;va=D+16|0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[ia>>2]|0)>0){va=f[ta>>2]|0;wa=0;do{f[va+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[ia>>2]|0))}ia=f[ua>>2]|0;if((ia|0)!=(g|0))wL(ia);ia=B+36|0;wa=f[ia>>2]|0;if(wa|0?(va=wa+12|0,wa=f[va>>2]|0,f[va>>2]=wa+-1,(wa|0)==1):0)V$(B);f[ia>>2]=0;ia=B+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[aa>>2]|0)>0){ia=f[z>>2]|0;wa=0;do{f[ia+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[aa>>2]|0))}aa=f[y>>2]|0;if((aa|0)!=(A|0))wL(aa);break}case 3:{if(ra<2.220446049250313e-16){p[i>>3]=1.0;p[i+8>>3]=1.0;p[i+16>>3]=1.0;p[i+24>>3]=1.0;lR(q,i)|0;break a}f[j>>2]=1124007936;aa=j+4|0;wa=j+8|0;ia=j+40|0;V=aa;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[ia>>2]=wa;A=j+48|0;y=j+44|0;f[y>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[i>>2]=T;f[i+4>>2]=U;S$(j,2,i,5);z=f[ia>>2]|0;g=f[z>>2]|0;f[J>>2]=f[z+4>>2];f[J+4>>2]=g;g=f[j>>2]&4095;f[K>>2]=0;f[K+4>>2]=0;Eba(s,v,j,J,g,K,0.0,0);g=f[q+40>>2]|0;z=f[g>>2]|0;f[N>>2]=f[g+4>>2];f[N+4>>2]=z;z=f[q>>2]&4095;f[O>>2]=0;f[O+4>>2]=0;Eba(l,x,q,N,z,O,0.0,0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=j;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;YL(i,k);f$(B,1.0,j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=-1056571392;f[k+4>>2]=B;o$(i,q,k,1.0);z=f[i>>2]|0;ei[f[(f[z>>2]|0)+12>>2]&511](z,i,q,-1);Zj(i);Zj(B);qa=+M(+ra);z=i+8|0;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;dY(q,i,-1,1.0/qa,0.0);z=j+36|0;g=f[z>>2]|0;if(g|0?(ua=g+12|0,g=f[ua>>2]|0,f[ua>>2]=g+-1,(g|0)==1):0)V$(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[aa>>2]|0)>0){z=f[ia>>2]|0;g=0;do{f[z+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[aa>>2]|0))}aa=f[y>>2]|0;if((aa|0)!=(A|0))wL(aa);break}default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;vM(-213,i,254131,253820,841)}}while(0);B=x+36|0;O=f[B>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)V$(x);f[B>>2]=0;B=x+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[w>>2]|0)>0){B=f[ga>>2]|0;ga=0;do{f[B+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[w>>2]|0))}w=f[ha>>2]|0;if((w|0)!=(fa|0))wL(w);w=v+36|0;fa=f[w>>2]|0;if(fa|0?(ha=fa+12|0,fa=f[ha>>2]|0,f[ha>>2]=fa+-1,(fa|0)==1):0)V$(v);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[ca>>2]|0)>0){w=f[da>>2]|0;da=0;do{f[w+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ca>>2]|0))}ca=f[ea>>2]|0;if((ca|0)!=(S|0))wL(ca);ca=s+36|0;S=f[ca>>2]|0;do if(S|0){ea=S+12|0;da=f[ea>>2]|0;f[ea>>2]=da+-1;if((da|0)!=1)break;V$(s)}while(0);f[ca>>2]=0;ca=s+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[Z>>2]|0)>0){ca=f[_>>2]|0;_=0;do{f[ca+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[Z>>2]|0))}Z=f[ba>>2]|0;if((Z|0)!=($|0))wL(Z);Z=q+36|0;$=f[Z>>2]|0;do if($|0){ba=$+12|0;_=f[ba>>2]|0;f[ba>>2]=_+-1;if((_|0)!=1)break;V$(q)}while(0);f[Z>>2]=0;Z=q+16|0;$=q+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[$>>2]|0)>0){Z=f[q+40>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[$>>2]|0))}$=f[q+44>>2]|0;if(($|0)!=(q+48|0))wL($);$=o+36|0;_=f[$>>2]|0;do if(_|0){Z=_+12|0;ba=f[Z>>2]|0;f[Z>>2]=ba+-1;if((ba|0)!=1)break;V$(o)}while(0);f[$>>2]=0;$=o+16|0;_=o+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[_>>2]|0)>0){$=f[o+40>>2]|0;ba=0;do{f[$+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[_>>2]|0))}_=f[o+44>>2]|0;if((_|0)!=(o+48|0))wL(_);_=m+36|0;ba=f[_>>2]|0;do if(ba|0){$=ba+12|0;Z=f[$>>2]|0;f[$>>2]=Z+-1;if((Z|0)!=1)break;V$(m)}while(0);f[_>>2]=0;_=m+16|0;ba=m+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[ba>>2]|0)>0){_=f[m+40>>2]|0;Z=0;do{f[_+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[ba>>2]|0))}ba=f[m+44>>2]|0;if((ba|0)!=(m+48|0))wL(ba);ba=l+36|0;Z=f[ba>>2]|0;do if(Z|0){_=Z+12|0;$=f[_>>2]|0;f[_>>2]=$+-1;if(($|0)!=1)break;V$(l)}while(0);f[ba>>2]=0;ba=l+16|0;Z=l+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[Z>>2]|0)>0){ba=f[l+40>>2]|0;$=0;do{f[ba+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[Z>>2]|0))}Z=f[l+44>>2]|0;if((Z|0)!=(l+48|0))wL(Z);u=h;return}Z=dS(a,-1)|0;$=(Z>>>3&511)+1|0;if(e>>>0>=6){ba=$Xc(64)|0;f[i>>2]=ba;f[i+8>>2]=-2147483584;f[i+4>>2]=55;V=ba;W=254075;X=V+55|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));b[ba+55>>0]=0;vM(-215,i,254230,253820,1106)}switch(Z&7){case 0:case 5:break;default:{ya=$Xc(96)|0;f[i>>2]=ya;za=i+8|0;f[za>>2]=-2147483552;Aa=i+4|0;f[Aa>>2]=80;V=ya;W=254149;X=V+80|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));Ba=ya+80|0;b[Ba>>0]=0;vM(-215,i,254230,253820,1107)}}if((Z|0)!=(dS(c,-1)|0)){ya=$Xc(96)|0;f[i>>2]=ya;za=i+8|0;f[za>>2]=-2147483552;Aa=i+4|0;f[Aa>>2]=80;V=ya;W=254149;X=V+80|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));Ba=ya+80|0;b[Ba>>0]=0;vM(-215,i,254230,253820,1107)}if((oS(a,-1)|0)>=3){ya=$Xc(96)|0;f[i>>2]=ya;za=i+8|0;f[za>>2]=-2147483552;Aa=i+4|0;f[Aa>>2]=80;V=ya;W=254149;X=V+80|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));Ba=ya+80|0;b[Ba>>0]=0;vM(-215,i,254230,253820,1107)}cS(i,a,-1);Ba=f[i+4>>2]|0;cS(j,c,-1);if((Ba|0)>=(f[j+4>>2]|0)?(cS(k,a,-1),Ba=f[k>>2]|0,cS(l,c,-1),(Ba|0)>=(f[l>>2]|0)):0)Ca=0;else Da=138;do if((Da|0)==138){cS(i,a,-1);Ba=f[i+4>>2]|0;cS(j,c,-1);if((Ba|0)>(f[j+4>>2]|0)){Ea=$Xc(96)|0;f[i>>2]=Ea;Fa=i+8|0;f[Fa>>2]=-2147483552;Ga=i+4|0;f[Ga>>2]=86;V=Ea;W=254244;X=V+86|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));Ha=Ea+86|0;b[Ha>>0]=0;vM(-215,i,254230,253820,1112)}else{cS(k,a,-1);A=f[k>>2]|0;cS(l,c,-1);if((A|0)<=(f[l>>2]|0)){Ca=1;break}Ea=$Xc(96)|0;f[i>>2]=Ea;Fa=i+8|0;f[Fa>>2]=-2147483552;Ga=i+4|0;f[Ga>>2]=86;V=Ea;W=254244;X=V+86|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));Ha=Ea+86|0;b[Ha>>0]=0;vM(-215,i,254230,253820,1112)}}while(0);do if((eS(a)|0)==65536){Ha=f[a+4>>2]|0;f[r>>2]=f[Ha>>2];Ea=r+4|0;Ga=Ha+4|0;f[Ea>>2]=f[Ga>>2];Fa=r+8|0;f[Fa>>2]=f[Ha+8>>2];f[r+12>>2]=f[Ha+12>>2];f[r+16>>2]=f[Ha+16>>2];f[r+20>>2]=f[Ha+20>>2];f[r+24>>2]=f[Ha+24>>2];f[r+28>>2]=f[Ha+28>>2];f[r+32>>2]=f[Ha+32>>2];A=f[Ha+36>>2]|0;f[r+36>>2]=A;f[r+40>>2]=Fa;Fa=r+48|0;y=r+44|0;f[y>>2]=Fa;f[Fa>>2]=0;f[r+52>>2]=0;if(A|0){Fa=A+12|0;f[Fa>>2]=(f[Fa>>2]|0)+1}if((f[Ga>>2]|0)<3){Ga=f[Ha+44>>2]|0;Fa=f[y>>2]|0;f[Fa>>2]=f[Ga>>2];f[Fa+4>>2]=f[Ga+4>>2];break}else{f[Ea>>2]=0;U$(r,Ha);break}}else bS(r,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[s>>2]=f[a>>2];Ha=s+4|0;Ea=a+4|0;f[Ha>>2]=f[Ea>>2];Ga=s+8|0;f[Ga>>2]=f[a+8>>2];f[s+12>>2]=f[a+12>>2];f[s+16>>2]=f[a+16>>2];f[s+20>>2]=f[a+20>>2];f[s+24>>2]=f[a+24>>2];f[s+28>>2]=f[a+28>>2];f[s+32>>2]=f[a+32>>2];Fa=f[a+36>>2]|0;f[s+36>>2]=Fa;f[s+40>>2]=Ga;Ga=s+48|0;y=s+44|0;f[y>>2]=Ga;f[Ga>>2]=0;f[s+52>>2]=0;if(Fa|0){Ga=Fa+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1}if((f[Ea>>2]|0)<3){Ea=f[a+44>>2]|0;Ga=f[y>>2]|0;f[Ga>>2]=f[Ea>>2];f[Ga+4>>2]=f[Ea+4>>2];break}else{f[Ha>>2]=0;U$(s,a);break}}else bS(s,c,-1);while(0);if(Ca){f[i>>2]=f[r>>2];Ca=i+4|0;c=r+4|0;a=f[c>>2]|0;f[Ca>>2]=a;Ha=i+8|0;Ea=r+8|0;f[Ha>>2]=f[Ea>>2];Ga=i+12|0;y=r+12|0;f[Ga>>2]=f[y>>2];Fa=i+16|0;A=r+16|0;f[Fa>>2]=f[A>>2];Ba=i+20|0;ya=r+20|0;f[Ba>>2]=f[ya>>2];Aa=i+24|0;za=r+24|0;f[Aa>>2]=f[za>>2];Z=i+28|0;ba=r+28|0;f[Z>>2]=f[ba>>2];_=i+32|0;ca=r+32|0;f[_>>2]=f[ca>>2];S=i+36|0;da=r+36|0;f[S>>2]=f[da>>2];ea=i+40|0;f[ea>>2]=Ha;w=i+44|0;v=i+48|0;f[w>>2]=v;fa=i+52|0;f[fa>>2]=0;f[v>>2]=0;ha=r+44|0;if((a|0)<3){a=f[ha>>2]|0;f[v>>2]=f[a>>2];f[fa>>2]=f[a+4>>2];Ia=a}else{f[w>>2]=f[ha>>2];a=r+40|0;f[ea>>2]=f[a>>2];ea=r+48|0;f[ha>>2]=ea;f[a>>2]=Ea;Ia=ea}ea=s+4|0;a=f[ea>>2]|0;fa=s+8|0;ga=f[fa>>2]|0;B=s+12|0;x=f[B>>2]|0;f[r>>2]=f[s>>2];f[c>>2]=a;f[Ea>>2]=ga;f[y>>2]=x;x=s+16|0;f[A>>2]=f[x>>2];A=s+20|0;f[ya>>2]=f[A>>2];ya=s+24|0;f[za>>2]=f[ya>>2];za=s+28|0;f[ba>>2]=f[za>>2];ba=s+32|0;f[ca>>2]=f[ba>>2];ca=s+36|0;f[da>>2]=f[ca>>2];da=r+48|0;if((Ia|0)!=(da|0)){wL(Ia);f[ha>>2]=da;f[r+40>>2]=Ea}Ia=s+44|0;if((f[ea>>2]|0)<3){ga=f[Ia>>2]|0;f[da>>2]=f[ga>>2];f[r+52>>2]=f[ga+4>>2];Ja=ga}else{f[ha>>2]=f[Ia>>2];ha=s+40|0;f[r+40>>2]=f[ha>>2];ga=s+48|0;f[Ia>>2]=ga;f[ha>>2]=fa;Ja=ga}ga=f[Ca>>2]|0;ha=f[Ha>>2]|0;da=f[Ga>>2]|0;f[s>>2]=f[i>>2];f[ea>>2]=ga;f[fa>>2]=ha;f[B>>2]=da;f[x>>2]=f[Fa>>2];f[A>>2]=f[Ba>>2];f[ya>>2]=f[Aa>>2];f[za>>2]=f[Z>>2];f[ba>>2]=f[_>>2];f[ca>>2]=f[S>>2];S=s+48|0;if((Ja|0)==(S|0))Ka=ga;else{wL(Ja);f[Ia>>2]=S;f[s+40>>2]=fa;Ka=f[Ca>>2]|0}if((Ka|0)<3){Ka=f[w>>2]|0;f[S>>2]=f[Ka>>2];f[s+52>>2]=f[Ka+4>>2];f[i>>2]=1124007936;V=Ca;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));if((Ka|0)!=(v|0))wL(Ka)}else{f[Ia>>2]=f[w>>2];Ia=i+40|0;f[s+40>>2]=f[Ia>>2];f[w>>2]=v;f[Ia>>2]=Ha;f[i>>2]=1124007936;V=Ca;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0))}La=y;Ma=B;Na=Ea;Oa=fa}else{La=r+12|0;Ma=s+12|0;Na=r+8|0;Oa=s+8|0}fa=(f[Na>>2]|0)+1-(f[Oa>>2]|0)|0;f[P>>2]=(f[La>>2]|0)+1-(f[Ma>>2]|0);f[P+4>>2]=fa;wS(d,P,5,-1,0,0);do if((eS(d)|0)==65536){P=f[d+4>>2]|0;f[t>>2]=f[P>>2];fa=t+4|0;La=P+4|0;f[fa>>2]=f[La>>2];Na=t+8|0;f[Na>>2]=f[P+8>>2];f[t+12>>2]=f[P+12>>2];f[t+16>>2]=f[P+16>>2];f[t+20>>2]=f[P+20>>2];f[t+24>>2]=f[P+24>>2];f[t+28>>2]=f[P+28>>2];f[t+32>>2]=f[P+32>>2];Ea=f[P+36>>2]|0;f[t+36>>2]=Ea;B=t+40|0;f[B>>2]=Na;Na=t+48|0;y=t+44|0;f[y>>2]=Na;f[Na>>2]=0;f[t+52>>2]=0;if(Ea|0){Na=Ea+12|0;f[Na>>2]=(f[Na>>2]|0)+1}if((f[La>>2]|0)<3){La=f[P+44>>2]|0;Na=f[y>>2]|0;f[Na>>2]=f[La>>2];f[Na+4>>2]=f[La+4>>2];Pa=B;Qa=t;break}else{f[fa>>2]=0;U$(t,P);Pa=B;Qa=t;break}}else{bS(t,d,-1);Pa=t+40|0;Qa=t}while(0);d=f[Pa>>2]|0;B=f[d>>2]|0;f[Q>>2]=f[d+4>>2];f[Q+4>>2]=B;B=f[Qa>>2]&4095;f[R>>2]=0;f[R+4>>2]=0;Eba(r,s,t,Q,B,R,0.0,0);switch(e|0){case 2:break;case 3:{Ra=0;Da=182;break}default:{Ra=(e|1|0)==5?1:2;Da=182}}if((Da|0)==182){R=(e|0)==5;ra=1.0/(+(f[Oa>>2]|0)*+(f[Ma>>2]|0));f[i>>2]=1124007936;B=i+4|0;Q=i+8|0;Qa=i+40|0;V=B;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[Qa>>2]=Q;Q=i+48|0;d=i+44|0;f[d>>2]=Q;f[Q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;P=j+4|0;fa=j+8|0;La=j+40|0;V=P;X=V+36|0;do{f[V>>2]=0;V=V+4|0}while((V|0)<(X|0));f[La>>2]=fa;fa=j+48|0;Na=j+44|0;f[Na>>2]=fa;f[fa>>2]=0;f[j+52>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;do if((e|0)!=4){f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;y=o+8|0;f[y>>2]=0;f[y+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;y=q+8|0;f[y>>2]=0;f[y+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;Qja(m,o,q,6,-1);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;f[o>>2]=-1040056314;f[o+4>>2]=k;f[o+8>>2]=1;f[o+12>>2]=4;f[q>>2]=-1040056314;f[q+4>>2]=l;f[q+8>>2]=1;f[q+12>>2]=4;nL(m,o,q,fT()|0);qa=+p[l>>3];pa=+p[l+8>>3];oa=+p[l+16>>3];na=+p[l+24>>3];ma=qa*qa+pa*pa+oa*oa+na*na;if(R&ma<2.220446049250313e-16){p[m>>3]=1.0;p[m+8>>3]=1.0;p[m+16>>3]=1.0;p[m+24>>3]=1.0;lR(t,m)|0;break}na=+p[k>>3];oa=+p[k+8>>3];pa=+p[k+16>>3];qa=+p[k+24>>3];la=ma+na*na+oa*oa+pa*pa+qa*qa;if((Ra|0)==1)Sa=ma;else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Sa=la}y=f[j+16>>2]|0;if(!y){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;Ea=$Xc(32)|0;f[m>>2]=Ea;f[m+8>>2]=-2147483616;f[m+4>>2]=18;V=Ea;W=254331;X=V+18|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));b[Ea+18>>0]=0;vM(-215,m,254350,253820,892)}else{ma=+M(+Sa)/+M(+ra);Ca=Y(f[Ma>>2]|0,$)|0;Ha=y+(Y(f[fa>>2]|0,f[Oa>>2]|0)|0)|0;Ta=y;Ua=y+(Ca<<3)|0;Va=Ha;Wa=Ha+(Ca<<3)|0;Xa=la/ra;Ya=ma;Da=191;break}}else{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;Ca=o+8|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;Pja(m,o,6);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;mL(m,o,fT()|0);p[k>>3]=+p[m>>3];p[k+8>>3]=+p[m+8>>3];p[k+16>>3]=+p[m+16>>3];p[k+24>>3]=+p[m+24>>3];Ta=0;Ua=0;Va=0;Wa=0;Xa=0.0;Ya=0.0;Da=191}while(0);if((Da|0)==191){Da=f[i+16>>2]|0;if(!Da){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;o=$Xc(32)|0;f[m>>2]=o;f[m+8>>2]=-2147483616;f[m+4>>2]=16;V=o;W=254371;X=V+16|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));b[o+16>>0]=0;vM(-215,m,254350,253820,899)}m=Y(f[Ma>>2]|0,$)|0;Ma=Da+(m<<3)|0;o=f[Q>>2]|0;W=Da+(Y(o,f[Oa>>2]|0)|0)|0;Oa=W+(m<<3)|0;m=o>>>3;o=(f[j+16>>2]|0)==0?0:(f[fa>>2]|0)>>>3;V=f[t+8>>2]|0;if((V|0)>0){X=f[t+16>>2]|0;R=f[f[t+44>>2]>>2]|0;l=f[t+12>>2]|0;q=(l|0)>0;Sa=+((e|0)==1&1);Ca=Ra&255;Ra=0;do{Ha=X+(Y(Ra,R)|0)|0;Ia=Y(Ra,o)|0;b:do if(q)switch(Ca&3){case 1:{v=Ia;w=Y(Ra,m)|0;Ka=0;while(1){S=Ha+(Ka<<2)|0;ma=0.0;qa=+n[S>>2];Ja=0;do{ga=Ja+w|0;pa=+p[Da+(ga<<3)>>3]-+p[Ma+(ga<<3)>>3]-+p[W+(ga<<3)>>3]+ +p[Oa+(ga<<3)>>3];ma=ma+pa*pa;qa=qa-pa*+p[k+(Ja<<3)>>3];Ja=Ja+1|0}while((Ja|0)!=($|0));pa=ra*ma;switch(e|0){case 1:case 3:case 5:{oa=0.0;Ja=0;while(1){ga=Ja+v|0;na=oa+(+p[Ta+(ga<<3)>>3]-+p[Ua+(ga<<3)>>3]-+p[Va+(ga<<3)>>3]+ +p[Wa+(ga<<3)>>3]);Ja=Ja+1|0;if((Ja|0)==($|0)){Za=na;break}else oa=na}break}default:Za=0.0}c:do switch(e|0){case 1:case 3:case 5:{oa=Za-pa;ma=oa<0.0?0.0:oa;oa=Za*1.1920928955078125e-06;if(!(ma<=(oa<.5?oa:.5)))_a=Ya*+M(+ma);else _a=0.0;ma=+L(+qa);if(ma<_a){$a=qa/_a;break c}if(!(ma<_a*1.125)){$a=Sa;break c}$a=qa>0.0?1.0:-1.0;break}default:$a=qa}while(0);n[S>>2]=$a;Ka=Ka+1|0;if((Ka|0)==(l|0))break b;else{v=v+$|0;w=w+$|0}}break}case 2:{w=Ia;v=0;while(1){Ka=Ha+(v<<2)|0;qa=+n[Ka>>2];pa=0.0;Ja=0;do{ga=Ja+w|0;pa=pa+(+p[Ta+(ga<<3)>>3]-+p[Ua+(ga<<3)>>3]-+p[Va+(ga<<3)>>3]+ +p[Wa+(ga<<3)>>3]);Ja=Ja+1|0}while((Ja|0)!=($|0));ma=Xa+(pa-qa*2.0);oa=ma<0.0?0.0:ma;d:do switch(e|0){case 1:case 3:case 5:{ma=pa<0.0?0.0:pa;na=pa*1.1920928955078125e-06;if(!(ma<=(na<.5?na:.5)))ab=Ya*+M(+ma);else ab=0.0;ma=+L(+oa);if(ma<ab){bb=oa/ab;break d}if(!(ma<ab*1.125)){bb=Sa;break d}bb=oa>0.0?1.0:-1.0;break}default:bb=oa}while(0);n[Ka>>2]=bb;v=v+1|0;if((v|0)==(l|0))break b;else w=w+$|0}break}default:{w=Ia;v=0;while(1){Ja=Ha+(v<<2)|0;oa=+n[Ja>>2];pa=oa;switch(e|0){case 1:case 3:case 5:{qa=0.0;S=0;while(1){ga=S+w|0;ma=qa+(+p[Ta+(ga<<3)>>3]-+p[Ua+(ga<<3)>>3]-+p[Va+(ga<<3)>>3]+ +p[Wa+(ga<<3)>>3]);S=S+1|0;if((S|0)==($|0)){cb=ma;break}else qa=ma}break}default:cb=0.0}e:do switch(e|0){case 1:case 3:case 5:{qa=cb<0.0?0.0:cb;ma=cb*1.1920928955078125e-06;if(!(qa<=(ma<.5?ma:.5)))db=Ya*+M(+qa);else db=0.0;qa=+L(+oa);if(qa<db){eb=pa/db;break e}if(!(qa<db*1.125)){eb=Sa;break e}eb=oa>0.0?1.0:-1.0;break}default:eb=pa}while(0);n[Ja>>2]=eb;v=v+1|0;if((v|0)==(l|0))break b;else w=w+$|0}}}while(0);Ra=Ra+1|0}while((Ra|0)!=(V|0))}}V=j+36|0;Ra=f[V>>2]|0;if(Ra|0?($=Ra+12|0,Ra=f[$>>2]|0,f[$>>2]=Ra+-1,(Ra|0)==1):0)V$(j);f[V>>2]=0;V=j+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[P>>2]|0)>0){V=f[La>>2]|0;La=0;do{f[V+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[P>>2]|0))}P=f[Na>>2]|0;if((P|0)!=(fa|0))wL(P);P=i+36|0;fa=f[P>>2]|0;if(fa|0?(Na=fa+12|0,fa=f[Na>>2]|0,f[Na>>2]=fa+-1,(fa|0)==1):0)V$(i);f[P>>2]=0;P=i+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[B>>2]|0)>0){P=f[Qa>>2]|0;Qa=0;do{f[P+(Qa<<2)>>2]=0;Qa=Qa+1|0}while((Qa|0)<(f[B>>2]|0))}B=f[d>>2]|0;if((B|0)!=(Q|0))wL(B)}B=t+36|0;Q=f[B>>2]|0;if(Q|0?(d=Q+12|0,Q=f[d>>2]|0,f[d>>2]=Q+-1,(Q|0)==1):0)V$(t);f[B>>2]=0;B=t+16|0;Q=t+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[Q>>2]|0)>0){B=f[Pa>>2]|0;Pa=0;do{f[B+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[Q>>2]|0))}Q=f[t+44>>2]|0;if((Q|0)!=(t+48|0))wL(Q);Q=s+36|0;t=f[Q>>2]|0;if(t|0?(Pa=t+12|0,t=f[Pa>>2]|0,f[Pa>>2]=t+-1,(t|0)==1):0)V$(s);f[Q>>2]=0;Q=s+16|0;t=s+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[t>>2]|0)>0){Q=f[s+40>>2]|0;Pa=0;do{f[Q+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))wL(t);t=r+36|0;s=f[t>>2]|0;if(s|0?(Pa=s+12|0,s=f[Pa>>2]|0,f[Pa>>2]=s+-1,(s|0)==1):0)V$(r);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;Pa=0;do{f[t+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))wL(s);u=h;return}function Gba(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0;d=u;u=u+1152|0;e=d+88|0;g=d+72|0;h=d+56|0;i=d;f[i>>2]=1124007936;j=i+4|0;k=i+8|0;l=i+40|0;m=j;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[l>>2]=k;p=i+48|0;q=i+44|0;f[q>>2]=p;f[p>>2]=0;f[i+52>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;r=e+8|0;f[r>>2]=0;f[r+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=i;Eva(c,e,1,1);if((f[i>>2]&7|0)!=5){f[e>>2]=1124007936;c=e+4|0;r=e+8|0;t=e+40|0;m=c;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[t>>2]=r;v=e+48|0;w=e+44|0;f[w>>2]=v;f[v>>2]=0;f[e+52>>2]=0;x=g+8|0;f[x>>2]=0;f[x+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;dY(i,g,5,1.0,0.0);x=e+36|0;y=f[x>>2]|0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}z=i+36|0;y=f[z>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)V$(i);f[z>>2]=0;y=i+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0;C=f[j>>2]|0}while((B|0)<(C|0));f[i>>2]=f[e>>2];if((C|0)<3)D=12;else D=14}else{f[i>>2]=f[e>>2];D=12}if((D|0)==12){C=f[c>>2]|0;if((C|0)<3){f[j>>2]=C;f[k>>2]=f[r>>2];f[i+12>>2]=f[e+12>>2];r=f[w>>2]|0;k=f[q>>2]|0;f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2]}else D=14}if((D|0)==14)U$(i,e);r=e+16|0;f[y>>2]=f[r>>2];f[i+20>>2]=f[e+20>>2];f[i+24>>2]=f[e+24>>2];f[i+28>>2]=f[e+28>>2];f[i+32>>2]=f[e+32>>2];y=f[x>>2]|0;f[z>>2]=y;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)V$(e);f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[t>>2]|0;t=0;do{f[r+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[c>>2]|0))}c=f[w>>2]|0;if((c|0)!=(v|0))wL(c)}c=k0(i,2,-1,1)|0;v=i+16|0;w=f[v>>2]|0;a:do if((c|0)>2){t=c*3|0;r=e+8|0;f[e>>2]=r;x=e+4|0;f[x>>2]=t;if(t>>>0>264){y=bYc(t>>>0>1073741823?-1:t<<2)|0;f[e>>2]=y;E=y}else E=r;y=E+(c<<2)|0;f[g>>2]=-1;f[g+4>>2]=-1;f[g+8>>2]=-1;f[g+12>>2]=-1;t=f[w>>2]|0;z=f[w+4>>2]|0;F=(f[s>>2]=t,+n[s>>2]);G=(f[s>>2]=z,+n[s>>2]);k=0;C=0;B=0;A=0;H=0;I=F;J=F;F=G;K=G;L=t;t=z;while(1){G=(f[s>>2]=L,+n[s>>2]);z=G<I;C=z?k:C;N=G>J;A=N?k:A;O=(f[s>>2]=t,+n[s>>2]);P=O>F;H=P?k:H;Q=O<K;B=Q?k:B;R=k;k=k+1|0;S=(k|0)<(c|0)?k:0;L=f[w+(S<<3)>>2]|0;t=f[w+(S<<3)+4>>2]|0;T=(f[s>>2]=L,+n[s>>2])-G;V=T;W=(f[s>>2]=t,+n[s>>2])-O;X=W;n[y+(R<<3)>>2]=T;n[y+(R<<3)+4>>2]=W;W=1.0/+M(+(V*V+X*X));n[E+(R<<2)>>2]=W;if((k|0)==(c|0))break;else{I=z?G:I;J=N?G:J;F=P?O:F;K=Q?O:K}}k=c+-1|0;K=+n[y+(k<<3)>>2];F=+n[y+(k<<3)+4>>2];k=0;while(1){J=K;K=+n[y+(k<<3)>>2];I=F;F=+n[y+(k<<3)+4>>2];Y=J*F-I*K;k=k+1|0;if(Y!=0.0)break;if((k|0)>=(c|0)){D=32;break}}if((D|0)==32){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=16;m=k;t=254388;o=m+16|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));b[k+16>>0]=0;vM(-215,h,254405,254422,166)}f[g>>2]=B;t=g+4|0;f[t>>2]=A;L=g+8|0;f[L>>2]=H;Q=g+12|0;f[Q>>2]=C;P=0;K=Y>0.0?1.0:-1.0;F=0.0;I=3402823466385288598117041.0e14;N=0;J=0.0;O=0.0;G=0.0;z=0;W=0.0;R=B;S=A;Z=H;_=C;b:while(1){X=(K*+n[y+(R<<3)>>2]+F*+n[y+(R<<3)+4>>2])*+n[E+(R<<2)>>2];V=(K*+n[y+(S<<3)+4>>2]-F*+n[y+(S<<3)>>2])*+n[E+(S<<2)>>2];$=V>X;T=$?V:X;X=(-(K*+n[y+(Z<<3)>>2])-F*+n[y+(Z<<3)+4>>2])*+n[E+(Z<<2)>>2];aa=X>T;ba=(F*+n[y+(_<<3)>>2]-K*+n[y+(_<<3)+4>>2])*+n[E+(_<<2)>>2]>(aa?X:T)?3:aa?2:$&1;$=g+(ba<<2)|0;aa=f[$>>2]|0;T=+n[E+(aa<<2)>>2];X=+n[y+(aa<<3)>>2]*T;V=T*+n[y+(aa<<3)+4>>2];switch(ba&3){case 0:{ca=X;da=V;break}case 1:{ca=V;da=-X;break}case 2:{ca=-X;da=-V;break}case 3:{ca=-V;da=X;break}default:{D=38;break b}}ba=aa+1|0;f[$>>2]=(ba|0)==(c|0)?0:ba;S=f[t>>2]|0;_=f[Q>>2]|0;X=ca*(+n[w+(S<<3)>>2]-+n[w+(_<<3)>>2])+da*(+n[w+(S<<3)+4>>2]-+n[w+(_<<3)+4>>2]);Z=f[L>>2]|0;R=f[g>>2]|0;V=ca*(+n[w+(Z<<3)+4>>2]-+n[w+(R<<3)+4>>2])-da*(+n[w+(Z<<3)>>2]-+n[w+(R<<3)>>2]);T=X*V;if(!(T<=I)){ea=I;fa=N;ga=J;ha=O;ia=G;ja=z;ka=W}else{ea=T;fa=_;ga=X;ha=da;ia=V;ja=R;ka=ca}P=P+1|0;if((P|0)>=(c|0))break;else{K=ca;F=da;I=ea;N=fa;J=ga;O=ha;G=ia;z=ja;W=ka}}W=-ha;G=ka*+n[w+(fa<<3)>>2]+ha*+n[w+(fa<<3)+4>>2];O=+n[w+(ja<<3)>>2]*W+ka*+n[w+(ja<<3)+4>>2];J=1.0/(ka*ka-ha*W);I=ga*ka;F=ha*ga;K=ia*W;V=ia*ka;if((E|0)!=(r|0)){dYc(E);f[e>>2]=r;f[x>>2]=264}n[a>>2]=J*(ka*G-ha*O)+(I+K)*.5;n[a+4>>2]=J*(ka*O-G*W)+(F+V)*.5;W=I;I=F;F=+M(+(W*W+I*I));n[a+8>>2]=F;F=K;K=V;V=+M(+(F*F+K*K));n[a+12>>2]=V;V=+U(+I,+W);n[a+16>>2]=V}else switch(c|0){case 2:{V=+n[w>>2];W=+n[w+8>>2];n[a>>2]=(V+W)*.5;I=+n[w+4>>2];K=+n[w+12>>2];n[a+4>>2]=(I+K)*.5;F=W-V;V=K-I;I=+M(+(F*F+V*V));n[a+8>>2]=I;n[a+12>>2]=0.0;I=+U(+V,+F);n[a+16>>2]=I;break a;break}case 1:{f[a>>2]=f[w>>2];f[a+4>>2]=f[w+4>>2];break a;break}default:break a}while(0);w=a+16|0;n[w>>2]=+n[w>>2]*180.0/3.141592653589793;w=i+36|0;a=f[w>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)V$(i);f[w>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[j>>2]|0)>0){v=f[l>>2]|0;l=0;do{f[v+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)==(p|0)){u=d;return}wL(j);u=d;return}function Hba(a){a=a|0;return}function Iba(a){a=a|0;cYc(a);return}function Jba(a){a=a|0;return}function Kba(a){a=a|0;cYc(a);return}function Lba(a){a=a|0;return}function Mba(a){a=a|0;return}function Nba(a){a=a|0;cYc(a);return}function Oba(a){a=a|0;return}function Pba(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=49424;b=f[a+196>>2]|0;if(b|0)UXc(b);b=f[a+188>>2]|0;if(b|0)UXc(b);b=f[a+180>>2]|0;if(b|0)UXc(b);b=f[a+164>>2]|0;if(b|0){c=a+168|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+128>>2]|0;if(b|0){d=a+132|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+116>>2]|0;if(b|0){d=a+120|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+104>>2]|0;if(b|0){d=a+108|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+92>>2]|0;if(b|0){d=a+96|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+76>>2]|0;if(!b)return;d=a+80|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function Qba(a){a=a|0;Pba(a);cYc(a);return}function Rba(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;g=u;u=u+16|0;h=g;i=f[c>>2]|0;j=a+36|0;f[j>>2]=i;k=f[c+4>>2]|0;c=a+40|0;f[c>>2]=k;l=f[e>>2]|0;m=f[e+4>>2]|0;e=f[d>>2]|0;n=f[d+4>>2]|0;d=a+44|0;f[d>>2]=l;o=a+48|0;f[o>>2]=m;p=a+52|0;f[p>>2]=e;q=a+56|0;f[q>>2]=n;if(((e+l|0)>(i|0)?1:(l|m|e|n|0)<0)|(n+m|0)>(k|0)){k=$Xc(144)|0;f[h>>2]=k;f[h+8>>2]=-2147483504;f[h+4>>2]=143;o1c(k|0,254789,143)|0;b[k+143>>0]=0;vM(-215,h,254933,254608,173)}k=a+4|0;m=f[k>>2]|0;n=Y(675553809>>>(m<<2&28)&15,(m>>>3&511)+1|0)|0;l=a+12|0;i=f[l>>2]|0;r=Y(675553809>>>(i<<2&28)&15,(i>>>3&511)+1|0)|0;i=a+116|0;s=f[i>>2]|0;t=a+120|0;v=(s|0)==(f[t>>2]|0)?0:s;s=a+16|0;w=a+20|0;x=f[w>>2]|0;y=x+3|0;z=a+28|0;A=f[z>>2]|0;B=x-A+-1|0;x=((A|0)<(B|0)?B:A)<<1|1;A=(y|0)<(x|0)?x:y;y=a+32|0;x=f[y>>2]|0;if((x|0)>=(e|0)){B=a+164|0;C=a+168|0;D=f[C>>2]|0;E=f[B>>2]|0;if((A|0)==(D-E>>2|0))F=a+176|0;else{G=C;H=C;I=B;J=B;K=E;L=D;M=7}}else{D=a+168|0;E=a+164|0;G=D;H=D;I=E;J=E;K=f[E>>2]|0;L=f[D>>2]|0;M=7}do if((M|0)==7){D=L-K>>2;E=K;B=L;if(A>>>0<=D>>>0)if(A>>>0<D>>>0?(C=E+(A<<2)|0,(B|0)!=(C|0)):0){f[G>>2]=B+(~((B+-4-C|0)>>>2)<<2);N=x;O=e;P=m}else{N=x;O=e;P=m}else{Vba(J,A-D|0);N=f[y>>2]|0;O=f[p>>2]|0;P=f[k>>2]|0}D=(N|0)<(O|0)?O:N;f[y>>2]=D;C=(P>>>3&511)+1|0;B=a+104|0;E=Y(D+-1+(f[s>>2]|0)|0,n)|0;D=a+108|0;Q=f[D>>2]|0;R=f[B>>2]|0;S=Q-R|0;T=R;R=Q;if(E>>>0<=S>>>0){if(E>>>0<S>>>0?(Q=T+E|0,(R|0)!=(Q|0)):0)f[D>>2]=Q}else zS(B,E-S|0);if(!(f[a+72>>2]|0)){if(!v){S=$Xc(32)|0;f[h>>2]=S;f[h+8>>2]=-2147483616;f[h+4>>2]=16;U=S;V=254939;W=U+16|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[S+16>>0]=0;vM(-215,h,254933,254608,191)}E=a+128|0;Q=f[l>>2]|0;D=Y(675553809>>>(Q<<2&28)&15,(Q>>>3&511)+1|0)|0;Q=f[y>>2]|0;R=f[s>>2]|0;T=Y(D,Q+63+R|0)|0;D=a+132|0;X=f[D>>2]|0;Z=f[E>>2]|0;_=X-Z|0;$=Z;aa=X;if(T>>>0<=_>>>0)if(T>>>0<_>>>0?(X=$+T|0,(aa|0)!=(X|0)):0){f[D>>2]=X;ba=Z;ca=Q;da=R}else{ba=Z;ca=Q;da=R}else{zS(E,T-_|0);ba=f[E>>2]|0;ca=f[y>>2]|0;da=f[s>>2]|0}E=ba+63&-64;_=Y(ca+-1+da|0,n)|0;T=a+176|0;R=f[T>>2]|0;if(!R)ea=f[B>>2]|0;else ea=E;if((_|0)>0){Q=(f[t>>2]|0)-(f[i>>2]|0)|0;Z=0;do{X=_-Z|0;Q=(X|0)<(Q|0)?X:Q;if((Q|0)>0){X=0;do{b[ea+(X+Z)>>0]=b[v+X>>0]|0;X=X+1|0}while((X|0)<(Q|0))}Z=Q+Z|0}while((_|0)>(Z|0));fa=f[T>>2]|0}else fa=R;if(!fa){Z=f[a+184>>2]|0;gi[f[(f[Z>>2]|0)+8>>2]&255](Z,f[B>>2]|0,E,f[y>>2]|0,C);ga=T}else ga=T}else ga=a+176|0;if(!(f[ga>>2]|0))ha=0;else ha=(f[s>>2]|0)+-1|0;Z=Y((f[y>>2]|0)+63+ha&-64,r)|0;_=a+92|0;Q=(Y(Z,(f[H>>2]|0)-(f[I>>2]|0)>>2)|0)+64|0;Z=a+96|0;S=f[Z>>2]|0;X=f[_>>2]|0;D=S-X|0;if(Q>>>0>D>>>0){zS(_,Q-D|0);F=ga;break}if(Q>>>0<D>>>0?(D=X+Q|0,(S|0)!=(D|0)):0){f[Z>>2]=D;F=ga}else F=ga}while(0);ga=f[p>>2]|0;I=f[F>>2]|0;H=(I|0)==0;ha=f[s>>2]|0;y=Y(ga+15+(H?0:ha+-1|0)&-16,r)|0;r=a+140|0;f[r>>2]=y;y=f[a+24>>2]|0;fa=f[d>>2]|0;d=y-fa|0;ea=(d|0)>0;i=a+60|0;f[i>>2]=ea?d:0;t=f[j>>2]|0;j=ha+-1-y+fa+ga-t|0;ga=(j|0)>0;ha=a+64|0;f[ha>>2]=ga?j:0;a:do if(ea|ga){j=a+68|0;da=f[j>>2]|0;if(!da){if(!v){ca=$Xc(32)|0;f[h>>2]=ca;f[h+8>>2]=-2147483616;f[h+4>>2]=16;U=ca;V=254939;W=U+16|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));b[ca+16>>0]=0;vM(-215,h,254933,254608,225)}if(!H){T=(f[a+168>>2]|0)-(f[a+164>>2]|0)|0;if((T|0)>0)ia=T>>2;else break}else ia=1;T=a+104|0;C=a+92|0;E=0;B=I;while(1){if(!B)ja=f[T>>2]|0;else ja=((f[C>>2]|0)+63&-64)+(Y(f[r>>2]|0,E)|0)|0;o1c(ja|0,v|0,Y(f[i>>2]|0,n)|0)|0;R=f[ha>>2]|0;o1c(ja+(Y((f[p>>2]|0)+-1+(f[s>>2]|0)-R|0,n)|0)|0,v|0,Y(R,n)|0)|0;R=E+1|0;if((R|0)==(ia|0))break a;E=R;B=f[F>>2]|0}}B=((y|0)<(fa|0)?y:fa)-fa|0;E=f[a+88>>2]|0;C=f[a+76>>2]|0;b:do if(ea){if((E|0)>0){ka=0;la=d;ma=da}else{qR(0-d|0,t,da)|0;T=f[i>>2]|0;if((T|0)>1){na=T;oa=1}else break;while(1){qR(oa-na|0,t,f[j>>2]|0)|0;oa=oa+1|0;na=f[i>>2]|0;if((oa|0)>=(na|0))break b}}while(1){T=Y((qR(ka-la|0,t,ma)|0)+B|0,E)|0;ca=Y(ka,E)|0;R=0;do{f[C+(R+ca<<2)>>2]=R+T;R=R+1|0}while((R|0)!=(E|0));R=ka+1|0;T=f[i>>2]|0;if((R|0)>=(T|0))break b;ka=R;la=T;ma=f[j>>2]|0}}while(0);if((f[ha>>2]|0)>0){if((E|0)>0)pa=0;else{da=0;while(1){qR(da+t|0,t,f[j>>2]|0)|0;da=da+1|0;if((da|0)>=(f[ha>>2]|0))break a}}do{da=Y((qR(pa+t|0,t,f[j>>2]|0)|0)+B|0,E)|0;T=0;do{R=C+((Y((f[i>>2]|0)+pa|0,E)|0)+T<<2)|0;f[R>>2]=T+da;T=T+1|0}while((T|0)!=(E|0));pa=pa+1|0}while((pa|0)<(f[ha>>2]|0))}}while(0);f[a+160>>2]=0;f[a+156>>2]=0;ha=f[o>>2]|0;o=f[z>>2]|0;z=ha-o|0;pa=(z|0)>0?z:0;f[a+148>>2]=pa;z=a+144|0;f[z>>2]=pa;pa=ha+-1+(f[q>>2]|0)+(f[w>>2]|0)-o|0;o=f[c>>2]|0;f[a+152>>2]=(o|0)<(pa|0)?o:pa;pa=f[a+192>>2]|0;if(pa|0)Yi[f[(f[pa>>2]|0)+12>>2]&4095](pa);pa=f[a+176>>2]|0;if(!pa){qa=f[z>>2]|0;u=g;return qa|0}Yi[f[(f[pa>>2]|0)+12>>2]&4095](pa);qa=f[z>>2]|0;u=g;return qa|0}function Sba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;h=f[(f[a>>2]|0)+8>>2]|0;i=f[b+40>>2]|0;b=f[i>>2]|0;f[g>>2]=f[i+4>>2];f[g+4>>2]=b;hh[h&127](a,c,g,d)|0;u=e;return (f[a+144>>2]|0)-(f[d+4>>2]|0)|0}function Tba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;i=u;u=u+16|0;j=i;if((f[a+36>>2]|0)<=0){k=$Xc(48)|0;f[j>>2]=k;l=j+8|0;f[l>>2]=-2147483600;m=j+4|0;f[m>>2]=43;n=k;o=254679;p=n+43|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+43|0;b[q>>0]=0;vM(-215,j,254723,254608,288)}r=a+40|0;if((f[r>>2]|0)<=0){k=$Xc(48)|0;f[j>>2]=k;l=j+8|0;f[l>>2]=-2147483600;m=j+4|0;f[m>>2]=43;n=k;o=254679;p=n+43|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+43|0;b[q>>0]=0;vM(-215,j,254723,254608,288)}q=f[a+76>>2]|0;k=a+4|0;m=f[k>>2]|0;l=Y(675553809>>>(m<<2&28)&15,(m>>>3&511)+1|0)|0;m=f[a+88>>2]|0;s=f[a+164>>2]|0;t=(f[a+168>>2]|0)-s>>2;v=((f[a+12>>2]|0)>>>3&511)+1|0;w=a+52|0;x=f[w>>2]|0;y=f[a+16>>2]|0;z=f[a+20>>2]|0;A=f[a+28>>2]|0;B=f[a+60>>2]|0;C=f[a+64>>2]|0;D=f[a+24>>2]|0;E=f[a+44>>2]|0;F=a+176|0;G=(f[F>>2]|0)==0;if((B|0)>0|(C|0)>0)H=(f[a+68>>2]|0)!=0;else H=0;I=c+(Y((D|0)<(E|0)?D:E,0-l|0)|0)|0;E=a+144|0;D=f[E>>2]|0;c=a+156|0;J=f[c>>2]|0;K=(f[a+152>>2]|0)-D-J|0;L=(K|0)<(e|0)?K:e;if(!((g|0)!=0&(I|0)!=0&(L|0)>0)){e=$Xc(32)|0;f[j>>2]=e;f[j+8>>2]=-2147483616;f[j+4>>2]=23;n=e;o=254731;p=n+23|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[e+23>>0]=0;vM(-215,j,254723,254608,307)}e=t-A|0;K=a+48|0;M=t+1-z|0;N=a+148|0;O=a+92|0;P=a+140|0;Q=a+104|0;R=Y(B,l)|0;S=x+-1+y-C|0;y=Y(S-B|0,l)|0;T=(m<<2|0)==(l|0);U=Y(B,m)|0;B=(U|0)>0;V=Y(C,m)|0;W=(V|0)>0;X=Y(S,m)|0;m=(R|0)>0;Z=Y(C,l)|0;C=(Z|0)>0;_=Y(S,l)|0;l=a+184|0;S=a+56|0;$=a+160|0;aa=z+-1|0;ba=a+192|0;ca=a+72|0;da=a+128|0;a=I;I=g;g=0;ea=L;L=D;D=J;a:while(1){J=e-L-D+(f[K>>2]|0)|0;fa=(J|0)>0?J:M;J=(ea|0)<(fa|0)?ea:fa;fa=ea-J|0;ga=J+-1|0;do if((J|0)>0){ha=Y(J,d)|0;if(G){ia=a;ja=L;ka=D;la=ga;while(1){ma=((f[O>>2]|0)+63&-64)+(Y(f[P>>2]|0,(ja-(f[N>>2]|0)+ka|0)%(t|0)|0)|0)|0;na=f[Q>>2]|0;f[c>>2]=ka+1;if((ka|0)>=(t|0)){f[c>>2]=ka;f[E>>2]=ja+1}o1c(na+R|0,ia|0,y|0)|0;do if(H)if(T){if(B){oa=0;do{f[na+(oa<<2)>>2]=f[ia+(f[q+(oa<<2)>>2]<<2)>>2];oa=oa+1|0}while((oa|0)!=(U|0))}if(W)pa=0;else break;do{f[na+(pa+X<<2)>>2]=f[ia+(f[q+(pa+U<<2)>>2]<<2)>>2];pa=pa+1|0}while((pa|0)!=(V|0))}else{if(m){oa=0;do{b[na+oa>>0]=b[ia+(f[q+(oa<<2)>>2]|0)>>0]|0;oa=oa+1|0}while((oa|0)!=(R|0))}if(C)qa=0;else break;do{b[na+(qa+_)>>0]=b[ia+(f[q+(qa+R<<2)>>2]|0)>>0]|0;qa=qa+1|0}while((qa|0)!=(Z|0))}while(0);oa=f[l>>2]|0;gi[f[(f[oa>>2]|0)+8>>2]&255](oa,na,ma,x,((f[k>>2]|0)>>>3&511)+1|0);if((la|0)<=0)break;ia=ia+d|0;ja=f[E>>2]|0;ka=f[c>>2]|0;la=la+-1|0}ra=a+ha|0;break}else{la=a;ka=L;ja=D;ia=ga;while(1){oa=((f[O>>2]|0)+63&-64)+(Y(f[P>>2]|0,(ka-(f[N>>2]|0)+ja|0)%(t|0)|0)|0)|0;f[c>>2]=ja+1;if((ja|0)>=(t|0)){f[c>>2]=ja;f[E>>2]=ka+1}o1c(oa+R|0,la|0,y|0)|0;do if(H)if(T){if(B){sa=0;do{f[oa+(sa<<2)>>2]=f[la+(f[q+(sa<<2)>>2]<<2)>>2];sa=sa+1|0}while((sa|0)!=(U|0))}if(W)ta=0;else break;do{f[oa+(ta+X<<2)>>2]=f[la+(f[q+(ta+U<<2)>>2]<<2)>>2];ta=ta+1|0}while((ta|0)!=(V|0))}else{if(m){sa=0;do{b[oa+sa>>0]=b[la+(f[q+(sa<<2)>>2]|0)>>0]|0;sa=sa+1|0}while((sa|0)!=(R|0))}if(C)ua=0;else break;do{b[oa+(ua+_)>>0]=b[la+(f[q+(ua+R<<2)>>2]|0)>>0]|0;ua=ua+1|0}while((ua|0)!=(Z|0))}while(0);if((ia|0)<=0)break;la=la+d|0;ka=f[E>>2]|0;ja=f[c>>2]|0;ia=ia+-1|0}ra=a+ha|0;break}}else ra=a;while(0);ga=f[$>>2]|0;J=aa-g+(f[S>>2]|0)-ga|0;ia=(J|0)<(t|0)?J:t;b:do if((ia|0)>0){J=g-A|0;ja=0;ka=ga;while(1){la=qR(J+ja+ka+(f[K>>2]|0)|0,f[r>>2]|0,f[ca>>2]|0)|0;if((la|0)<0)va=(f[da>>2]|0)+63&-64;else{oa=f[E>>2]|0;if((la|0)<(oa|0)){wa=46;break a}if((la|0)>=((f[c>>2]|0)+oa|0)){xa=ja;break b}va=((f[O>>2]|0)+63&-64)+(Y(f[P>>2]|0,(la-(f[N>>2]|0)|0)%(t|0)|0)|0)|0}f[s+(ja<<2)>>2]=va;la=ja+1|0;if((la|0)>=(ia|0)){xa=la;break b}ja=la;ka=f[$>>2]|0}}else xa=0;while(0);if((xa|0)<(z|0))break;ia=xa-aa|0;ga=f[F>>2]|0;if(!ga){ka=f[ba>>2]|0;ja=Y(f[w>>2]|0,v)|0;Fh[f[(f[ka>>2]|0)+8>>2]&255](ka,s,I,h,ia,ja)}else Ii[f[(f[ga>>2]|0)+8>>2]&127](ga,s,I,h,ia,f[w>>2]|0,v);ga=I+(Y(ia,h)|0)|0;a=ra;I=ga;g=ia+g|0;ea=fa;L=f[E>>2]|0;D=f[c>>2]|0}if((wa|0)==46){wa=$Xc(16)|0;f[j>>2]=wa;f[j+8>>2]=-2147483632;f[j+4>>2]=14;n=wa;o=254755;p=n+14|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[wa+14>>0]=0;vM(-215,j,254723,254608,363)}wa=(f[$>>2]|0)+g|0;f[$>>2]=wa;if((wa|0)>(f[S>>2]|0)){S=$Xc(32)|0;f[j>>2]=S;f[j+8>>2]=-2147483616;f[j+4>>2]=18;n=S;o=254770;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[S+18>>0]=0;vM(-215,j,254723,254608,380)}else{u=i;return g|0}return 0}function Uba(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;if((f[c>>2]&4095|0)==(f[a+4>>2]|0)?(f[d>>2]&4095|0)==(f[a+8>>2]|0):0){j=hh[f[(f[a>>2]|0)+12>>2]&127](a,c,e,g)|0;g=f[c+48>>2]|0;e=(f[c+16>>2]|0)+(Y(g,j)|0)|0;xg[f[(f[a>>2]|0)+16>>2]&127](a,e,g,(f[a+152>>2]|0)-(f[a+144>>2]|0)|0,f[d+16>>2]|0,f[d+48>>2]|0)|0;u=h;return}h=$Xc(48)|0;f[i>>2]=h;f[i+8>>2]=-2147483600;f[i+4>>2]=46;d=h;a=254561;g=d+46|0;do{b[d>>0]=b[a>>0]|0;d=d+1|0;a=a+1|0}while((d|0)<(g|0));b[h+46>>0]=0;vM(-215,i,473123,254608,388)}function Vba(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)kWc(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)o1c(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;cYc(d);return}function Wba(a){a=a|0;f[a>>2]=49356;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function Xba(a){a=a|0;f[a>>2]=49376;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function Yba(a){a=a|0;var b=0;f[a>>2]=49400;b=a+4|0;f[b>>2]=-1;f[b+4>>2]=-1;f[b+8>>2]=-1;f[b+12>>2]=-1;return}function Zba(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;f[a>>2]=49424;f[a+4>>2]=-1;f[a+8>>2]=-1;f[a+12>>2]=-1;l=a+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[a+36>>2]=-1;f[a+40>>2]=-1;l=a+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[a+68>>2]=1;f[a+72>>2]=1;l=a+76|0;m=l+124|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));_ba(a,b,c,d,e,g,h,i,j,k);return}function _ba(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;m=u;u=u+16|0;n=m;o=g&4095;p=a+4|0;f[p>>2]=o;q=Y(675553809>>>(o<<2&28)&15,(g>>>3&511)+1|0)|0;f[a+8>>2]=h&4095;h=a+12|0;f[h>>2]=i&4095;i=f[c>>2]|0;g=f[c+4>>2]|0;if(g|0)TXc(g);f[a+176>>2]=i;i=a+180|0;c=f[i>>2]|0;f[i>>2]=g;if(c|0)UXc(c);c=a+184|0;g=f[d>>2]|0;i=f[d+4>>2]|0;if(i|0)TXc(i);f[c>>2]=g;g=a+188|0;d=f[g>>2]|0;f[g>>2]=i;if(d|0)UXc(d);d=a+192|0;i=f[e>>2]|0;g=f[e+4>>2]|0;if(g|0)TXc(g);f[d>>2]=i;i=a+196|0;e=f[i>>2]|0;f[i>>2]=g;if(e|0)UXc(e);e=(k|0)<0?j:k;k=a+68|0;f[k>>2]=j;j=a+72|0;f[j>>2]=e;if((e|0)==3){e=$Xc(32)|0;f[n>>2]=e;f[n+8>>2]=-2147483616;f[n+4>>2]=31;r=e;s=254976;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[e+31>>0]=0;vM(-215,n,255008,254608,127)}e=f[a+176>>2]|0;do if(!e){g=f[c>>2]|0;if(!g){v=$Xc(32)|0;f[n>>2]=v;w=n+8|0;f[w>>2]=-2147483616;x=n+4|0;f[x>>2]=25;r=v;s=255013;t=r+25|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));y=v+25|0;b[y>>0]=0;vM(-215,n,255008,254608,131)}i=f[d>>2]|0;if(!i){v=$Xc(32)|0;f[n>>2]=v;w=n+8|0;f[w>>2]=-2147483616;x=n+4|0;f[x>>2]=25;r=v;s=255013;t=r+25|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));y=v+25|0;b[y>>0]=0;vM(-215,n,255008,254608,131)}else{o=f[g+4>>2]|0;z=f[i+4>>2]|0;f[a+16>>2]=o;f[a+20>>2]=z;A=f[g+8>>2]|0;B=f[i+8>>2]|0;f[a+24>>2]=A;C=B;D=A;E=o;F=z;break}}else if((f[h>>2]|0)==(f[p>>2]|0)){z=f[e+4>>2]|0;f[a+16>>2]=z;o=f[e+8>>2]|0;f[a+20>>2]=o;A=f[e+12>>2]|0;f[a+24>>2]=A;C=f[e+16>>2]|0;D=A;E=z;F=o;break}else{o=$Xc(32)|0;f[n>>2]=o;f[n+8>>2]=-2147483616;f[n+4>>2]=18;r=o;s=255039;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[o+18>>0]=0;vM(-215,n,255008,254608,137)}while(0);f[a+28>>2]=C;if(!((D|C|0)>-1&(D|0)<(E|0)&(C|0)<(F|0))){F=$Xc(96)|0;f[n>>2]=F;f[n+8>>2]=-2147483552;f[n+4>>2]=83;r=F;s=255058;t=r+83|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));b[F+83>>0]=0;vM(-215,n,255008,254608,143)}n=q>>>((f[p>>2]|0)>>>1&2);f[a+88>>2]=n;F=E+-1|0;E=(F|0)>1?F:1;F=a+76|0;s=Y(E,n)|0;n=a+80|0;r=f[n>>2]|0;t=f[F>>2]|0;C=r-t>>2;D=t;t=r;if(s>>>0<=C>>>0){if(s>>>0<C>>>0?(r=D+(s<<2)|0,(t|0)!=(r|0)):0)f[n>>2]=t+(~((t+-4-r|0)>>>2)<<2)}else CS(F,s-C|0);f[a+140>>2]=0;f[a+32>>2]=0;C=f[a+128>>2]|0;s=a+132|0;if((f[s>>2]|0)!=(C|0))f[s>>2]=C;if(f[k>>2]|0?f[j>>2]|0:0){G=a+36|0;f[G>>2]=-1;H=a+40|0;f[H>>2]=-1;u=m;return}j=a+116|0;k=Y(E,q)|0;q=a+120|0;C=f[q>>2]|0;s=f[j>>2]|0;F=C-s|0;r=s;s=C;if(k>>>0<=F>>>0)if(k>>>0<F>>>0?(C=r+k|0,(s|0)!=(C|0)):0){f[q>>2]=C;I=r}else I=r;else{zS(j,k-F|0);I=f[j>>2]|0}j=f[p>>2]|0;p=j>>>3&511;F=p+1|0;q3(l,I,(F>>>0>4?24:p<<3)|j&7,Y(F,E)|0);G=a+36|0;f[G>>2]=-1;H=a+40|0;f[H>>2]=-1;u=m;return}function $ba(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;d=u;u=u+128|0;e=d+72|0;g=d+16|0;h=d;do if((eS(a)|0)==65536){i=f[a+4>>2]|0;f[e>>2]=f[i>>2];j=e+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];o=e;break}else{f[j>>2]=0;U$(e,i);o=e;break}}else{bS(e,a,-1);o=e}while(0);if(f[o>>2]&4088|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=$Xc(32)|0;f[g>>2]=o;f[g+8>>2]=-2147483616;f[g+4>>2]=23;q=o;a=255142;r=q+23|0;do{b[q>>0]=b[a>>0]|0;q=q+1|0;a=a+1|0}while((q|0)<(r|0));b[o+23>>0]=0;vM(-215,g,255166,254608,407)}o=e+8|0;a=e+12|0;i=Y(f[a>>2]|0,f[o>>2]|0)|0;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[l>>2]=k;k=g+48|0;q=g+44|0;f[q>>2]=k;f[k>>2]=0;f[g+52>>2]=0;r=h+8|0;f[r>>2]=0;f[r+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;dY(e,h,6,1.0,0.0);h=g+16|0;r=f[h>>2]|0;n=f[o>>2]|0;o=f[a>>2]|0;if((n|0)==1|(o|0)==1?(f[c>>2]<<1|1|0)==(o|0):0)s=(f[c+4>>2]<<1|1|0)==(n|0)?15:12;else s=12;if((i|0)>0){n=i+-1|0;t=0.0;c=0;o=s;while(1){v=+p[r+(c<<3)>>3];w=+p[r+(n-c<<3)>>3];a=v!=w?o&-2:o;m=v!=-w?a&-3:a;a=v<0.0?m&-5:m;m=v!=+(zLc(v)|0);x=m?a&-9:a;w=t+v;c=c+1|0;if((c|0)==(i|0)){y=w;z=x;break}else{t=w;o=x}}}else{y=0.0;z=s}s=+L(+(y+-1.0))>(+L(+y)+1.0)*1.1920928955078125e-07;o=s?z&-5:z;z=g+36|0;s=f[z>>2]|0;if(s|0?(i=s+12|0,s=f[i>>2]|0,f[i>>2]=s+-1,(s|0)==1):0)V$(g);f[z>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){h=f[l>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(k|0))wL(j);j=e+36|0;k=f[j>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)V$(e);f[j>>2]=0;j=e+16|0;k=e+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[e+40>>2]|0;q=0;do{f[j+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}k=f[e+44>>2]|0;if((k|0)==(e+48|0)){u=d;return o|0}wL(k);u=d;return o|0}function aca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+80|0;j=i;k=i+64|0;l=i+8|0;do if((eS(e)|0)==65536){m=f[e+4>>2]|0;f[l>>2]=f[m>>2];n=l+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=l+8|0;f[p>>2]=f[m+8>>2];f[l+12>>2]=f[m+12>>2];f[l+16>>2]=f[m+16>>2];f[l+20>>2]=f[m+20>>2];f[l+24>>2]=f[m+24>>2];f[l+28>>2]=f[m+28>>2];f[l+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;r=l+44|0;f[r>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;U$(l,m);break}}else bS(l,e,-1);while(0);e=c&7;m=d&7;if((d^c)&4088|0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=$Xc(96)|0;f[k>>2]=s;t=k+8|0;f[t>>2]=-2147483552;v=k+4|0;f[v>>2]=89;w=s;x=255180;y=w+89|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+89|0;b[z>>0]=0;vM(-215,k,255270,254608,3605)}if((m|0)<((e>>>0>4?e:4)|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=$Xc(96)|0;f[k>>2]=s;t=k+8|0;f[t>>2]=-2147483552;v=k+4|0;f[v>>2]=89;w=s;x=255180;y=w+89|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+89|0;b[z>>0]=0;vM(-215,k,255270,254608,3605)}if((f[l>>2]&4095|0)!=(m|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=$Xc(96)|0;f[k>>2]=s;t=k+8|0;f[t>>2]=-2147483552;v=k+4|0;f[v>>2]=89;w=s;x=255180;y=w+89|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+89|0;b[z>>0]=0;vM(-215,k,255270,254608,3605)}z=(e|0)==0;s=z&(m|0)==4;do if(h&3|0?((f[l+12>>2]|0)+(f[l+8>>2]|0)|0)<7:0){if(s){x=$Xc(88)|0;f[x+4>>2]=0;f[x+8>>2]=0;f[x>>2]=49456;w=x+12|0;bca(w,l,g,h,k);f[a>>2]=w;f[a+4>>2]=x;break}if((e|0)==5&(m|0)==5){x=$Xc(88)|0;f[x+4>>2]=0;f[x+8>>2]=0;f[x>>2]=49484;w=x+12|0;cca(w,l,g,h,k);f[a>>2]=w;f[a+4>>2]=x}else A=19}else if(s){x=$Xc(84)|0;f[x+4>>2]=0;f[x+8>>2]=0;f[x>>2]=49512;w=x+12|0;dca(w,l,g,k);f[a>>2]=w;f[a+4>>2]=x}else A=19;while(0);do if((A|0)==19){s=(m|0)==5;if(z&s){h=$Xc(84)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=49540;x=h+12|0;eca(x,l,g,k);f[a>>2]=x;f[a+4>>2]=h;break}h=(m|0)==6;if(z&h){x=$Xc(84)|0;f[x+4>>2]=0;f[x+8>>2]=0;f[x>>2]=49568;w=x+12|0;fca(w,l,g,k);f[a>>2]=w;f[a+4>>2]=x;break}x=(e|0)==2;if(x&s){w=$Xc(84)|0;f[w+4>>2]=0;f[w+8>>2]=0;f[w>>2]=49596;y=w+12|0;gca(y,l,g,k);f[a>>2]=y;f[a+4>>2]=w;break}if(x&h){x=$Xc(84)|0;f[x+4>>2]=0;f[x+8>>2]=0;f[x>>2]=49624;w=x+12|0;hca(w,l,g,k);f[a>>2]=w;f[a+4>>2]=x;break}x=(e|0)==3;if(x&s){w=$Xc(84)|0;f[w+4>>2]=0;f[w+8>>2]=0;f[w>>2]=49652;y=w+12|0;ica(y,l,g,k);f[a>>2]=y;f[a+4>>2]=w;break}if(x&h){x=$Xc(84)|0;f[x+4>>2]=0;f[x+8>>2]=0;f[x>>2]=49680;w=x+12|0;jca(w,l,g,k);f[a>>2]=w;f[a+4>>2]=x;break}x=(e|0)==5;if(x&s){s=$Xc(84)|0;f[s+4>>2]=0;f[s+8>>2]=0;f[s>>2]=49708;w=s+12|0;kca(w,l,g,k);f[a>>2]=w;f[a+4>>2]=s;break}if(x&h){x=$Xc(84)|0;f[x+4>>2]=0;f[x+8>>2]=0;f[x>>2]=49736;s=x+12|0;lca(s,l,g,k);f[a>>2]=s;f[a+4>>2]=x;break}if((e|0)==6&h){h=$Xc(84)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=49764;x=h+12|0;mca(x,l,g,k);f[a>>2]=x;f[a+4>>2]=h;break}else{f[j>>2]=c;f[j+4>>2]=d;DM(k,275105,j);vM(-213,k,255270,254608,3644)}}while(0);k=l+36|0;j=f[k>>2]|0;if(j|0?(d=j+12|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)V$(l);f[k>>2]=0;k=l+16|0;j=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[l+40>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[l+44>>2]|0;if((j|0)==(l+48|0)){u=i;return}wL(j);u=i;return}function bca(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Nda(a,c,d,g);f[a>>2]=50032;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;h=$Xc(96)|0;f[i>>2]=h;f[i+8>>2]=-2147483552;f[i+4>>2]=84;a=h;e=256557;g=a+84|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));b[h+84>>0]=0;vM(-215,i,256642,254608,3112)}function cca(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;Dda(a,c,d,g);f[a>>2]=49992;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;h=$Xc(96)|0;f[i>>2]=h;f[i+8>>2]=-2147483552;f[i+4>>2]=84;a=h;e=256557;g=a+84|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));b[h+84>>0]=0;vM(-215,i,256642,254608,3112)}function dca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49972;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function eca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49952;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function fca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49932;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function gca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49912;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function hca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49892;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function ica(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49872;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function jca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49852;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function kca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49832;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function lca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49812;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function mca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=49792;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function nca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49792;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function oca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49792;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function pca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<3)|0;m=+p[h>>3];n=m*+p[l+8>>3];o=m*+p[l+16>>3];q=m*+p[l+24>>3];p[c+(k<<3)>>3]=m*+p[l>>3];p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<3)|0;q=+p[h>>3];l=k;o=q*+p[k+24>>3];n=q*+p[k+16>>3];m=q*+p[k+8>>3];r=q*+p[k>>3];k=1;do{l=l+(e<<3)|0;q=+p[h+(k<<3)>>3];r=r+q*+p[l>>3];m=m+q*+p[l+8>>3];n=n+q*+p[l+16>>3];o=o+q*+p[l+24>>3];k=k+1|0}while((k|0)!=(g|0));p[c+(j<<3)>>3]=r;p[c+((j|1)<<3)>>3]=m;p[c+((j|2)<<3)>>3]=n;p[c+((j|3)<<3)>>3]=o;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+p[b+(d<<3)>>3];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<3)|0;q=+p[h>>3]*+p[d>>3];i=d;d=1;do{i=i+(e<<3)|0;q=q+ +p[h+(d<<3)>>3]*+p[i>>3];d=d+1|0}while((d|0)!=(g|0));p[c+(s<<3)>>3]=q;s=s+1|0}while((s|0)!=(a|0));return}function qca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49764;f[a+12>>2]=49792;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function rca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49764;f[a+12>>2]=49792;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function sca(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function tca(a){a=a|0;cYc(a);return}function uca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49812;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function vca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49812;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function wca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+p[h>>3];o=m*+n[l+4>>2];q=m*+n[l+8>>2];r=m*+n[l+12>>2];p[c+(k<<3)>>3]=m*+n[l>>2];p[c+((k|1)<<3)>>3]=o;p[c+((k|2)<<3)>>3]=q;p[c+((k|3)<<3)>>3]=r;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;r=+p[h>>3];l=k;q=r*+n[k+12>>2];o=r*+n[k+8>>2];m=r*+n[k+4>>2];s=r*+n[k>>2];k=1;do{l=l+(e<<2)|0;r=+p[h+(k<<3)>>3];s=s+r*+n[l>>2];m=m+r*+n[l+4>>2];o=o+r*+n[l+8>>2];q=q+r*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));p[c+(j<<3)>>3]=s;p[c+((j|1)<<3)>>3]=m;p[c+((j|2)<<3)>>3]=o;p[c+((j|3)<<3)>>3]=q;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<2)|0;r=+p[h>>3]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;r=r+ +p[h+(d<<3)>>3]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function xca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49736;f[a+12>>2]=49812;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function yca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49736;f[a+12>>2]=49812;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function zca(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Aca(a){a=a|0;cYc(a);return}function Bca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49832;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Cca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49832;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Dca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;p=q*+n[k+12>>2];o=q*+n[k+8>>2];m=q*+n[k+4>>2];r=q*+n[k>>2];k=1;do{l=l+(e<<2)|0;q=+n[h+(k<<2)>>2];r=r+q*+n[l>>2];m=m+q*+n[l+4>>2];o=o+q*+n[l+8>>2];p=p+q*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));n[c+(j<<2)>>2]=r;n[c+((j|1)<<2)>>2]=m;n[c+((j|2)<<2)>>2]=o;n[c+((j|3)<<2)>>2]=p;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<2)|0;q=+n[h>>2]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;q=q+ +n[h+(d<<2)>>2]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));n[c+(s<<2)>>2]=q;s=s+1|0}while((s|0)!=(a|0));return}function Eca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49708;f[a+12>>2]=49832;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Fca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49708;f[a+12>>2]=49832;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Gca(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Hca(a){a=a|0;cYc(a);return}function Ica(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49852;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Jca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49852;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Kca(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[i>>3];o=n*+(d[m+2>>1]|0);q=n*+(d[m+4>>1]|0);r=n*+(d[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(d[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+p[i>>3];m=l;q=r*+(d[l+6>>1]|0);o=r*+(d[l+4>>1]|0);n=r*+(d[l+2>>1]|0);s=r*+(d[l>>1]|0);l=1;do{m=m+(g<<1)|0;r=+p[i+(l<<3)>>3];s=s+r*+(d[m>>1]|0);n=n+r*+(d[m+2>>1]|0);o=o+r*+(d[m+4>>1]|0);q=q+r*+(d[m+6>>1]|0);l=l+1|0}while((l|0)!=(h|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)t=j;else{e=j;do{p[c+(e<<3)>>3]=+p[i>>3]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(t<<1)|0;r=+p[i>>3]*+(d[e>>1]|0);j=e;e=1;do{j=j+(g<<1)|0;r=r+ +p[i+(e<<3)>>3]*+(d[j>>1]|0);e=e+1|0}while((e|0)!=(h|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function Lca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49680;f[a+12>>2]=49852;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Mca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49680;f[a+12>>2]=49852;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Nca(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Oca(a){a=a|0;cYc(a);return}function Pca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49872;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Qca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49872;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Rca(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[i>>2];p=o*+(d[m+2>>1]|0);q=o*+(d[m+4>>1]|0);r=o*+(d[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(d[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+n[i>>2];m=l;q=r*+(d[l+6>>1]|0);p=r*+(d[l+4>>1]|0);o=r*+(d[l+2>>1]|0);s=r*+(d[l>>1]|0);l=1;do{m=m+(g<<1)|0;r=+n[i+(l<<2)>>2];s=s+r*+(d[m>>1]|0);o=o+r*+(d[m+2>>1]|0);p=p+r*+(d[m+4>>1]|0);q=q+r*+(d[m+6>>1]|0);l=l+1|0}while((l|0)!=(h|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)t=j;else{e=j;do{n[c+(e<<2)>>2]=+n[i>>2]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(t<<1)|0;r=+n[i>>2]*+(d[e>>1]|0);j=e;e=1;do{j=j+(g<<1)|0;r=r+ +n[i+(e<<2)>>2]*+(d[j>>1]|0);e=e+1|0}while((e|0)!=(h|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function Sca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49652;f[a+12>>2]=49872;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Tca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49652;f[a+12>>2]=49872;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Uca(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Vca(a){a=a|0;cYc(a);return}function Wca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49892;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Xca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49892;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Yca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[h>>3];o=n*+(j[m+2>>1]|0);q=n*+(j[m+4>>1]|0);r=n*+(j[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(j[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+p[h>>3];m=l;q=r*+(j[l+6>>1]|0);o=r*+(j[l+4>>1]|0);n=r*+(j[l+2>>1]|0);s=r*+(j[l>>1]|0);l=1;do{m=m+(e<<1)|0;r=+p[h+(l<<3)>>3];s=s+r*+(j[m>>1]|0);n=n+r*+(j[m+2>>1]|0);o=o+r*+(j[m+4>>1]|0);q=q+r*+(j[m+6>>1]|0);l=l+1|0}while((l|0)!=(g|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<1)|0;r=+p[h>>3]*+(j[d>>1]|0);i=d;d=1;do{i=i+(e<<1)|0;r=r+ +p[h+(d<<3)>>3]*+(j[i>>1]|0);d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function Zca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49624;f[a+12>>2]=49892;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function _ca(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49624;f[a+12>>2]=49892;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function $ca(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function ada(a){a=a|0;cYc(a);return}function bda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49912;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function cda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49912;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function dda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[h>>2];p=o*+(j[m+2>>1]|0);q=o*+(j[m+4>>1]|0);r=o*+(j[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(j[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+n[h>>2];m=l;q=r*+(j[l+6>>1]|0);p=r*+(j[l+4>>1]|0);o=r*+(j[l+2>>1]|0);s=r*+(j[l>>1]|0);l=1;do{m=m+(e<<1)|0;r=+n[h+(l<<2)>>2];s=s+r*+(j[m>>1]|0);o=o+r*+(j[m+2>>1]|0);p=p+r*+(j[m+4>>1]|0);q=q+r*+(j[m+6>>1]|0);l=l+1|0}while((l|0)!=(g|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<1)|0;r=+n[h>>2]*+(j[d>>1]|0);i=d;d=1;do{i=i+(e<<1)|0;r=r+ +n[h+(d<<2)>>2]*+(j[i>>1]|0);d=d+1|0}while((d|0)!=(g|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function eda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49596;f[a+12>>2]=49912;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function fda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49596;f[a+12>>2]=49912;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function gda(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function hda(a){a=a|0;cYc(a);return}function ida(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49932;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function jda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49932;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function kda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=+p[i>>3];o=n*+(h[m+1>>0]|0);q=n*+(h[m+2>>0]|0);r=n*+(h[m+3>>0]|0);p[c+(l<<3)>>3]=n*+(h[m>>0]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+p[i>>3];m=l;q=r*+(h[l+3>>0]|0);o=r*+(h[l+2>>0]|0);n=r*+(h[l+1>>0]|0);s=r*+(h[l>>0]|0);l=1;do{m=m+e|0;r=+p[i+(l<<3)>>3];s=s+r*+(h[m>>0]|0);n=n+r*+(h[m+1>>0]|0);o=o+r*+(h[m+2>>0]|0);q=q+r*+(h[m+3>>0]|0);l=l+1|0}while((l|0)!=(g|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{p[c+(d<<3)>>3]=+p[i>>3]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;r=+p[i>>3]*+(h[d>>0]|0);j=d;d=1;do{j=j+e|0;r=r+ +p[i+(d<<3)>>3]*+(h[j>>0]|0);d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function lda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49568;f[a+12>>2]=49932;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function mda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49568;f[a+12>>2]=49932;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function nda(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function oda(a){a=a|0;cYc(a);return}function pda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49952;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function qda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49952;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function rda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;o=+n[i>>2];p=o*+(h[m+1>>0]|0);q=o*+(h[m+2>>0]|0);r=o*+(h[m+3>>0]|0);n[c+(l<<2)>>2]=o*+(h[m>>0]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+n[i>>2];m=l;q=r*+(h[l+3>>0]|0);p=r*+(h[l+2>>0]|0);o=r*+(h[l+1>>0]|0);s=r*+(h[l>>0]|0);l=1;do{m=m+e|0;r=+n[i+(l<<2)>>2];s=s+r*+(h[m>>0]|0);o=o+r*+(h[m+1>>0]|0);p=p+r*+(h[m+2>>0]|0);q=q+r*+(h[m+3>>0]|0);l=l+1|0}while((l|0)!=(g|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{n[c+(d<<2)>>2]=+n[i>>2]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;r=+n[i>>2]*+(h[d>>0]|0);j=d;d=1;do{j=j+e|0;r=r+ +n[i+(d<<2)>>2]*+(h[j>>0]|0);d=d+1|0}while((d|0)!=(g|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function sda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49540;f[a+12>>2]=49952;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function tda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49540;f[a+12>>2]=49952;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function uda(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function vda(a){a=a|0;cYc(a);return}function wda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49972;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function xda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49972;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function yda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=Y(h[l+3>>0]|0,r)|0;r=o;o=p;p=q;q=1;do{n=n+e|0;l=f[i+(q<<2)>>2]|0;p=(Y(h[n>>0]|0,l)|0)+p|0;o=(Y(h[n+1>>0]|0,l)|0)+o|0;r=(Y(h[n+2>>0]|0,l)|0)+r|0;m=(Y(h[n+3>>0]|0,l)|0)+m|0;q=q+1|0}while((q|0)!=(g|0));f[c+(k<<2)>>2]=p;f[c+((k|1)<<2)>>2]=o;f[c+((k|2)<<2)>>2]=r;f[c+((k|3)<<2)>>2]=m;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)s=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+s|0;j=Y(h[d>>0]|0,f[i>>2]|0)|0;k=d;d=1;do{k=k+e|0;j=(Y(h[k>>0]|0,f[i+(d<<2)>>2]|0)|0)+j|0;d=d+1|0}while((d|0)!=(g|0));f[c+(s<<2)>>2]=j;s=s+1|0}while((s|0)!=(a|0));return}function zda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49512;f[a+12>>2]=49972;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Ada(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49512;f[a+12>>2]=49972;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Bda(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Cda(a){a=a|0;cYc(a);return}function Dda(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=50012;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function Eda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50012;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Fda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50012;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Gda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;p=q*+n[k+12>>2];o=q*+n[k+8>>2];m=q*+n[k+4>>2];r=q*+n[k>>2];k=1;do{l=l+(e<<2)|0;q=+n[h+(k<<2)>>2];r=r+q*+n[l>>2];m=m+q*+n[l+4>>2];o=o+q*+n[l+8>>2];p=p+q*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));n[c+(j<<2)>>2]=r;n[c+((j|1)<<2)>>2]=m;n[c+((j|2)<<2)>>2]=o;n[c+((j|3)<<2)>>2]=p;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<2)|0;q=+n[h>>2]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;q=q+ +n[h+(d<<2)>>2]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));n[c+(s<<2)>>2]=q;s=s+1|0}while((s|0)!=(a|0));return}function Hda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50012;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Ida(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0;g=f[a+4>>2]|0;h=(g|0)/2|0;i=Y(h,e)|0;j=(f[a+28>>2]|0)+(h<<2)|0;k=b+(i<<2)|0;l=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{m=+n[j+4>>2];a=l+-2|0;d=(l|0)<2;if(+n[j>>2]==0.0&m==1.0){if(d){o=k;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=a>>>1;u=t<<1;v=b+((i<<2)+(t<<3)+8)|0;t=k;w=0;while(1){x=+n[t+(r<<2)>>2]-+n[t+(s<<2)>>2];n[c+(w<<2)>>2]=+n[t+(e<<2)>>2]-+n[t+(q<<2)>>2];n[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(a|0))break;else t=t+8|0}o=v;p=u+2|0;break a}else{if(d){o=k;p=0;break a}t=0-e|0;w=e+1|0;q=1-e|0;s=a>>>1;r=s<<1;y=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){x=m*(+n[s+(w<<2)>>2]-+n[s+(q<<2)>>2]);n[c+(z<<2)>>2]=m*(+n[s+(e<<2)>>2]-+n[s+(t<<2)>>2]);n[c+((z|1)<<2)>>2]=x;z=z+2|0;if((z|0)>(a|0))break;else s=s+8|0}o=y;p=r+2|0;break a}break}case 5:{m=+n[j+4>>2];x=+n[j+8>>2];s=l+-2|0;if((l|0)<2){o=k;p=0}else{a=0-e|0;z=e<<1;t=a<<1;q=e+1|0;w=1-e|0;d=z|1;u=1-z|0;v=s>>>1;A=v<<1;B=b+((i<<2)+(v<<3)+8)|0;v=0;C=k;while(1){D=m*(+n[C+(q<<2)>>2]-+n[C+(w<<2)>>2])+x*(+n[C+(d<<2)>>2]-+n[C+(u<<2)>>2]);n[c+(v<<2)>>2]=m*(+n[C+(e<<2)>>2]-+n[C+(a<<2)>>2])+x*(+n[C+(z<<2)>>2]-+n[C+(t<<2)>>2]);n[c+((v|1)<<2)>>2]=D;v=v+2|0;if((v|0)>(s|0))break;else C=C+8|0}o=B;p=A+2|0}break}default:{o=k;p=0}}while(0);if((p|0)>=(l|0))return;if((g|0)<2){C=o;s=p;while(1){n[c+(s<<2)>>2]=+n[j>>2]*+n[C>>2];s=s+1|0;if((s|0)==(l|0))break;else C=C+4|0}return}else{E=o;F=p}while(1){x=+n[j>>2]*+n[E>>2];p=e;o=1;while(1){x=x+ +n[j+(o<<2)>>2]*(+n[E+(p<<2)>>2]-+n[E+(0-p<<2)>>2]);if((o|0)>=(h|0))break;else{p=p+e|0;o=o+1|0}}n[c+(F<<2)>>2]=x;F=F+1|0;if((F|0)==(l|0))break;else E=E+4|0}return}b:do switch(g|0){case 1:{if(+n[j>>2]==1.0?(E=l+-2|0,(l|0)>=2):0){F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=0;A=k;while(1){B=F|1;C=f[k+(B<<2)>>2]|0;f[c+(F<<2)>>2]=f[A>>2];f[c+(B<<2)>>2]=C;C=F+2|0;if((C|0)>(E|0))break;else{F=C;A=k+(C<<2)|0}}G=p;H=o+2|0}else{G=k;H=0}break}case 3:{x=+n[j>>2];m=+n[j+4>>2];A=m==1.0;if(x==2.0&A){F=l+-2|0;if((l|0)<2){G=k;H=0;break b}E=0-e|0;C=1-e|0;B=e+1|0;s=F>>>1;v=s<<1;t=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){D=+n[s+(B<<2)>>2]+(+n[s+(C<<2)>>2]+ +n[s+4>>2]*2.0);n[c+(z<<2)>>2]=+n[s+(e<<2)>>2]+(+n[s+(E<<2)>>2]+ +n[s>>2]*2.0);n[c+((z|1)<<2)>>2]=D;z=z+2|0;if((z|0)>(F|0))break;else s=s+8|0}G=t;H=v+2|0;break b}s=l+-2|0;F=(l|0)<2;if(x==-2.0&A){if(F){G=k;H=0;break b}z=0-e|0;E=1-e|0;C=e+1|0;B=s>>>1;o=B<<1;p=b+((i<<2)+(B<<3)+8)|0;B=k;a=0;while(1){D=+n[B+(C<<2)>>2]+(+n[B+(E<<2)>>2]-+n[B+4>>2]*2.0);n[c+(a<<2)>>2]=+n[B+(e<<2)>>2]+(+n[B+(z<<2)>>2]-+n[B>>2]*2.0);n[c+((a|1)<<2)>>2]=D;a=a+2|0;if((a|0)>(s|0))break;else B=B+8|0}G=p;H=o+2|0;break b}else{if(F){G=k;H=0;break b}B=0-e|0;a=1-e|0;z=e+1|0;E=s>>>1;C=E<<1;A=b+((i<<2)+(E<<3)+8)|0;E=k;v=0;while(1){D=x*+n[E+4>>2]+m*(+n[E+(a<<2)>>2]+ +n[E+(z<<2)>>2]);n[c+(v<<2)>>2]=x*+n[E>>2]+m*(+n[E+(B<<2)>>2]+ +n[E+(e<<2)>>2]);n[c+((v|1)<<2)>>2]=D;v=v+2|0;if((v|0)>(s|0))break;else E=E+8|0}G=A;H=C+2|0;break b}break}case 5:{m=+n[j>>2];x=+n[j+4>>2];D=+n[j+8>>2];E=l+-2|0;s=(l|0)<2;if(m==-2.0&x==0.0&D==1.0){if(s){G=k;H=0;break b}v=0-e<<1;B=e<<1;z=1-B|0;a=B|1;F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=k;t=0;while(1){I=+n[F+(z<<2)>>2]-+n[F+4>>2]*2.0+ +n[F+(a<<2)>>2];n[c+(t<<2)>>2]=+n[F+(v<<2)>>2]-+n[F>>2]*2.0+ +n[F+(B<<2)>>2];n[c+((t|1)<<2)>>2]=I;t=t+2|0;if((t|0)>(E|0))break;else F=F+8|0}G=p;H=o+2|0;break b}else{if(s){G=k;H=0;break b}F=0-e|0;t=F<<1;B=e<<1;v=1-e|0;a=e+1|0;z=1-B|0;C=B|1;A=E>>>1;u=A<<1;d=b+((i<<2)+(A<<3)+8)|0;A=k;w=0;while(1){I=m*+n[A+4>>2]+x*(+n[A+(v<<2)>>2]+ +n[A+(a<<2)>>2])+D*(+n[A+(z<<2)>>2]+ +n[A+(C<<2)>>2]);n[c+(w<<2)>>2]=m*+n[A>>2]+x*(+n[A+(F<<2)>>2]+ +n[A+(e<<2)>>2])+D*(+n[A+(t<<2)>>2]+ +n[A+(B<<2)>>2]);n[c+((w|1)<<2)>>2]=I;w=w+2|0;if((w|0)>(E|0))break;else A=A+8|0}G=d;H=u+2|0;break b}break}default:{G=k;H=0}}while(0);if((H|0)>=(l|0))return;if((g|0)<2){g=G;k=H;while(1){n[c+(k<<2)>>2]=+n[j>>2]*+n[g>>2];k=k+1|0;if((k|0)==(l|0))break;else g=g+4|0}return}else{J=G;K=H}while(1){H=e;G=1;D=+n[j>>2]*+n[J>>2];while(1){D=D+ +n[j+(G<<2)>>2]*(+n[J+(H<<2)>>2]+ +n[J+(0-H<<2)>>2]);if((G|0)>=(h|0))break;else{H=H+e|0;G=G+1|0}}n[c+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(l|0))break;else J=J+4|0}return}function Jda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49484;f[a+12>>2]=50012;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Kda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49484;f[a+12>>2]=50012;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Lda(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Mda(a){a=a|0;cYc(a);return}function Nda(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=50052;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){V$(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)U$(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;jR(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}if((d|0)==1|(l|0)==1){u=e;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;y=$Xc(80)|0;f[g>>2]=y;z=g+8|0;f[z>>2]=-2147483568;A=g+4|0;f[A>>2]=77;n=y;B=255289;o=n+77|0;do{b[n>>0]=b[B>>0]|0;n=n+1|0;B=B+1|0}while((n|0)<(o|0));C=y+77|0;b[C>>0]=0;vM(-215,g,255367,254608,3053)}}function Oda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50052;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Pda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50052;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Qda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=Y(h[l+3>>0]|0,r)|0;r=o;o=p;p=q;q=1;do{n=n+e|0;l=f[i+(q<<2)>>2]|0;p=(Y(h[n>>0]|0,l)|0)+p|0;o=(Y(h[n+1>>0]|0,l)|0)+o|0;r=(Y(h[n+2>>0]|0,l)|0)+r|0;m=(Y(h[n+3>>0]|0,l)|0)+m|0;q=q+1|0}while((q|0)!=(g|0));f[c+(k<<2)>>2]=p;f[c+((k|1)<<2)>>2]=o;f[c+((k|2)<<2)>>2]=r;f[c+((k|3)<<2)>>2]=m;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)s=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+s|0;j=Y(h[d>>0]|0,f[i>>2]|0)|0;k=d;d=1;do{k=k+e|0;j=(Y(h[k>>0]|0,f[i+(d<<2)>>2]|0)|0)+j|0;d=d+1|0}while((d|0)!=(g|0));f[c+(s<<2)>>2]=j;s=s+1|0}while((s|0)!=(a|0));return}function Rda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50052;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Sda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[a+4>>2]|0;i=(g|0)/2|0;j=Y(i,e)|0;k=(f[a+28>>2]|0)+(i<<2)|0;l=b+j|0;m=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{a=f[k+4>>2]|0;d=m+-2|0;n=(m|0)<2;if((f[k>>2]|0)==0&(a|0)==1){if(n){o=l;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=d&-2;u=j+t+2|0;v=l;w=0;while(1){x=(h[v+r>>0]|0)-(h[v+s>>0]|0)|0;f[c+(w<<2)>>2]=(h[v+e>>0]|0)-(h[v+q>>0]|0);f[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(d|0))break;else v=v+2|0}o=b+u|0;p=t+2|0;break a}else{if(n){o=l;p=0;break a}v=0-e|0;w=e+1|0;q=1-e|0;s=d&-2;r=j+s+2|0;x=l;y=0;while(1){z=Y((h[x+e>>0]|0)-(h[x+v>>0]|0)|0,a)|0;A=Y((h[x+w>>0]|0)-(h[x+q>>0]|0)|0,a)|0;f[c+(y<<2)>>2]=z;f[c+((y|1)<<2)>>2]=A;y=y+2|0;if((y|0)>(d|0))break;else x=x+2|0}o=b+r|0;p=s+2|0;break a}break}case 5:{x=f[k+4>>2]|0;d=f[k+8>>2]|0;y=m+-2|0;if((m|0)<2){o=l;p=0}else{a=0-e|0;q=e<<1;w=a<<1;v=e+1|0;n=1-e|0;t=q|1;u=1-q|0;A=y&-2;z=j+A+2|0;B=0;C=l;while(1){D=Y((h[C+e>>0]|0)-(h[C+a>>0]|0)|0,x)|0;E=(Y((h[C+q>>0]|0)-(h[C+w>>0]|0)|0,d)|0)+D|0;D=Y((h[C+v>>0]|0)-(h[C+n>>0]|0)|0,x)|0;F=(Y((h[C+t>>0]|0)-(h[C+u>>0]|0)|0,d)|0)+D|0;f[c+(B<<2)>>2]=E;f[c+((B|1)<<2)>>2]=F;B=B+2|0;if((B|0)>(y|0))break;else C=C+2|0}o=b+z|0;p=A+2|0}break}default:{o=l;p=0}}while(0);if((p|0)>=(m|0))return;if((g|0)<2){C=o;y=p;while(1){B=Y(h[C>>0]|0,f[k>>2]|0)|0;f[c+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(m|0))break;else C=C+1|0}return}else{G=o;H=p}while(1){p=Y(h[G>>0]|0,f[k>>2]|0)|0;o=e;C=1;while(1){p=(Y((h[G+o>>0]|0)-(h[G+(0-o)>>0]|0)|0,f[k+(C<<2)>>2]|0)|0)+p|0;if((C|0)>=(i|0))break;else{o=o+e|0;C=C+1|0}}f[c+(H<<2)>>2]=p;H=H+1|0;if((H|0)==(m|0))break;else G=G+1|0}return}b:do switch(g|0){case 1:{if((f[k>>2]|0)==1?(G=m+-2|0,(m|0)>=2):0){H=G&-2;C=j+H+2|0;o=0;A=l;while(1){z=o|1;y=h[l+z>>0]|0;f[c+(o<<2)>>2]=h[A>>0];f[c+(z<<2)>>2]=y;y=o+2|0;if((y|0)>(G|0))break;else{o=y;A=l+y|0}}I=b+C|0;J=H+2|0}else{I=l;J=0}break}case 3:{A=f[k>>2]|0;o=f[k+4>>2]|0;G=(o|0)==1;if((A|0)==2&G){p=m+-2|0;if((m|0)<2){I=l;J=0;break b}y=0-e|0;z=1-e|0;B=e+1|0;d=p&-2;u=j+d+2|0;t=l;x=0;while(1){n=((h[t+1>>0]|0)<<1)+(h[t+z>>0]|0)+(h[t+B>>0]|0)|0;f[c+(x<<2)>>2]=((h[t>>0]|0)<<1)+(h[t+y>>0]|0)+(h[t+e>>0]|0);f[c+((x|1)<<2)>>2]=n;x=x+2|0;if((x|0)>(p|0))break;else t=t+2|0}I=b+u|0;J=d+2|0;break b}t=m+-2|0;p=(m|0)<2;if((A|0)==-2&G){if(p){I=l;J=0;break b}x=0-e|0;y=1-e|0;B=e+1|0;z=t&-2;H=j+z+2|0;C=l;n=0;while(1){v=(h[C+y>>0]|0)-((h[C+1>>0]|0)<<1)+(h[C+B>>0]|0)|0;f[c+(n<<2)>>2]=(h[C+x>>0]|0)-((h[C>>0]|0)<<1)+(h[C+e>>0]|0);f[c+((n|1)<<2)>>2]=v;n=n+2|0;if((n|0)>(t|0))break;else C=C+2|0}I=b+H|0;J=z+2|0;break b}else{if(p){I=l;J=0;break b}C=0-e|0;n=1-e|0;x=e+1|0;B=t&-2;y=j+B+2|0;G=l;d=0;while(1){u=Y(h[G>>0]|0,A)|0;v=(Y((h[G+e>>0]|0)+(h[G+C>>0]|0)|0,o)|0)+u|0;u=Y(h[G+1>>0]|0,A)|0;w=(Y((h[G+x>>0]|0)+(h[G+n>>0]|0)|0,o)|0)+u|0;f[c+(d<<2)>>2]=v;f[c+((d|1)<<2)>>2]=w;d=d+2|0;if((d|0)>(t|0))break;else G=G+2|0}I=b+y|0;J=B+2|0;break b}break}case 5:{G=f[k>>2]|0;t=f[k+4>>2]|0;d=f[k+8>>2]|0;o=m+-2|0;n=(m|0)<2;if((G|0)==-2&(t|0)==0&(d|0)==1){if(n){I=l;J=0;break b}x=0-e<<1;A=e<<1;C=1-A|0;p=A|1;z=o&-2;H=j+z+2|0;w=l;v=0;while(1){u=Y(h[w>>0]|0,-2)|0;q=Y(h[w+1>>0]|0,-2)|0;a=q+(h[w+C>>0]|0)+(h[w+p>>0]|0)|0;f[c+(v<<2)>>2]=u+(h[w+x>>0]|0)+(h[w+A>>0]|0);f[c+((v|1)<<2)>>2]=a;v=v+2|0;if((v|0)>(o|0))break;else w=w+2|0}I=b+H|0;J=z+2|0;break b}else{if(n){I=l;J=0;break b}w=0-e|0;v=w<<1;A=e<<1;x=1-e|0;p=e+1|0;C=1-A|0;B=A|1;y=o&-2;a=j+y+2|0;u=l;q=0;while(1){s=Y(h[u>>0]|0,G)|0;r=(Y((h[u+e>>0]|0)+(h[u+w>>0]|0)|0,t)|0)+s|0;s=r+(Y((h[u+A>>0]|0)+(h[u+v>>0]|0)|0,d)|0)|0;r=Y(h[u+1>>0]|0,G)|0;F=(Y((h[u+p>>0]|0)+(h[u+x>>0]|0)|0,t)|0)+r|0;r=F+(Y((h[u+B>>0]|0)+(h[u+C>>0]|0)|0,d)|0)|0;f[c+(q<<2)>>2]=s;f[c+((q|1)<<2)>>2]=r;q=q+2|0;if((q|0)>(o|0))break;else u=u+2|0}I=b+a|0;J=y+2|0;break b}break}default:{I=l;J=0}}while(0);if((J|0)>=(m|0))return;if((g|0)<2){g=I;l=J;while(1){b=Y(h[g>>0]|0,f[k>>2]|0)|0;f[c+(l<<2)>>2]=b;l=l+1|0;if((l|0)==(m|0))break;else g=g+1|0}return}else{K=I;L=J}while(1){J=e;I=1;g=Y(h[K>>0]|0,f[k>>2]|0)|0;while(1){g=(Y((h[K+(0-J)>>0]|0)+(h[K+J>>0]|0)|0,f[k+(I<<2)>>2]|0)|0)+g|0;if((I|0)>=(i|0))break;else{J=J+e|0;I=I+1|0}}f[c+(L<<2)>>2]=g;L=L+1|0;if((L|0)==(m|0))break;else K=K+1|0}return}function Tda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49456;f[a+12>>2]=50052;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Uda(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=49456;f[a+12>>2]=50052;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Vda(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Wda(a){a=a|0;cYc(a);return}function Xda(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+96|0;l=k;m=k+72|0;n=k+64|0;o=k+8|0;do if((eS(e)|0)==65536){p=f[e+4>>2]|0;f[o>>2]=f[p>>2];q=o+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=o+8|0;f[s>>2]=f[p+8>>2];f[o+12>>2]=f[p+12>>2];f[o+16>>2]=f[p+16>>2];f[o+20>>2]=f[p+20>>2];f[o+24>>2]=f[p+24>>2];f[o+28>>2]=f[p+28>>2];f[o+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[o+36>>2]=t;f[o+40>>2]=s;s=o+48|0;v=o+44|0;f[v>>2]=s;f[s>>2]=0;f[o+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;U$(o,p);break}}else bS(o,e,-1);while(0);e=c&7;p=d&7;if((d^c)&4088|0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;w=$Xc(96)|0;f[m>>2]=w;x=m+8|0;f[x>>2]=-2147483552;y=m+4|0;f[y>>2]=89;z=w;A=257063;B=z+89|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+89|0;b[C>>0]=0;vM(-215,m,257153,254608,3658)}if((e|0)<((p>>>0>4?p:4)|0)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;w=$Xc(96)|0;f[m>>2]=w;x=m+8|0;f[x>>2]=-2147483552;y=m+4|0;f[y>>2]=89;z=w;A=257063;B=z+89|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+89|0;b[C>>0]=0;vM(-215,m,257153,254608,3658)}if((f[o>>2]&4095|0)!=(e|0)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;w=$Xc(96)|0;f[m>>2]=w;x=m+8|0;f[x>>2]=-2147483552;y=m+4|0;f[y>>2]=89;z=w;A=257063;B=z+89|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));C=w+89|0;b[C>>0]=0;vM(-215,m,257153,254608,3658)}do if(!(h&3)){C=(p|0)==0;if((e|0)==4&C){f[n>>2]=j;f[n+4>>2]=(j|0)==0?0:1<<j+-1;w=$Xc(96)|0;f[w+4>>2]=0;f[w+8>>2]=0;f[w>>2]=50072;A=w+12|0;Yda(A,o,g,i,n,m);f[a>>2]=A;f[a+4>>2]=w;break}w=(e|0)==5;if(w&C){A=$Xc(88)|0;f[A+4>>2]=0;f[A+8>>2]=0;f[A>>2]=50100;z=A+12|0;Zda(z,o,g,i,m,n);f[a>>2]=z;f[a+4>>2]=A;break}A=(e|0)==6;if(A&C){C=$Xc(96)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=50128;z=C+16|0;_da(z,o,g,i,m,n);f[a>>2]=z;f[a+4>>2]=C;break}C=(p|0)==2;if(w&C){z=$Xc(88)|0;f[z+4>>2]=0;f[z+8>>2]=0;f[z>>2]=50156;B=z+12|0;$da(B,o,g,i,m,n);f[a>>2]=B;f[a+4>>2]=z;break}if(A&C){C=$Xc(96)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=50184;z=C+16|0;aea(z,o,g,i,m,n);f[a>>2]=z;f[a+4>>2]=C;break}C=(p|0)==3;if(w&C){z=$Xc(88)|0;f[z+4>>2]=0;f[z+8>>2]=0;f[z>>2]=50212;B=z+12|0;bea(B,o,g,i,m,n);f[a>>2]=B;f[a+4>>2]=z;break}if(A&C){C=$Xc(96)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=50240;z=C+16|0;cea(z,o,g,i,m,n);f[a>>2]=z;f[a+4>>2]=C;break}if(w&(p|0)==5){w=$Xc(88)|0;f[w+4>>2]=0;f[w+8>>2]=0;f[w>>2]=50268;C=w+12|0;dea(C,o,g,i,m,n);f[a>>2]=C;f[a+4>>2]=w;break}if(A&(p|0)==6){A=$Xc(96)|0;f[A+4>>2]=0;f[A+8>>2]=0;f[A>>2]=50296;w=A+16|0;eea(w,o,g,i,m,n);f[a>>2]=w;f[a+4>>2]=A;break}else{f[l>>2]=c;D=l+4|0;f[D>>2]=d;DM(m,257175,l);vM(-213,m,257153,254608,3739)}}else{if(((f[o+12>>2]|0)+(f[o+8>>2]|0)|0)==4){A=(e|0)==4;if(A&(p|0)==0){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;w=$Xc(100)|0;f[w+4>>2]=0;f[w+8>>2]=0;f[w>>2]=50324;C=w+12|0;fea(C,o,g,i,h,m,n);f[a>>2]=C;f[a+4>>2]=w;break}if(A&(p|0)==3&(j|0)==0){A=$Xc(92)|0;f[A+4>>2]=0;f[A+8>>2]=0;f[A>>2]=50352;w=A+12|0;gea(w,o,g,i,h,m,n);f[a>>2]=w;f[a+4>>2]=A;break}if((e|0)==5&(p|0)==5){A=$Xc(92)|0;f[A+4>>2]=0;f[A+8>>2]=0;f[A>>2]=50380;w=A+12|0;hea(w,o,g,i,h,m,n);f[a>>2]=w;f[a+4>>2]=A;break}}A=(p|0)==0;w=(e|0)==4;if(w&A){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;C=$Xc(100)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=50408;z=C+12|0;iea(z,o,g,i,h,m,n);f[a>>2]=z;f[a+4>>2]=C;break}C=(e|0)==5;if(C&A){z=$Xc(92)|0;f[z+4>>2]=0;f[z+8>>2]=0;f[z>>2]=50436;B=z+12|0;jea(B,o,g,i,h,m,n);f[a>>2]=B;f[a+4>>2]=z;break}z=(e|0)==6;if(z&A){A=$Xc(104)|0;f[A+4>>2]=0;f[A+8>>2]=0;f[A>>2]=50464;B=A+16|0;kea(B,o,g,i,h,m,n);f[a>>2]=B;f[a+4>>2]=A;break}A=(p|0)==2;if(C&A){B=$Xc(92)|0;f[B+4>>2]=0;f[B+8>>2]=0;f[B>>2]=50492;y=B+12|0;lea(y,o,g,i,h,m,n);f[a>>2]=y;f[a+4>>2]=B;break}if(z&A){A=$Xc(104)|0;f[A+4>>2]=0;f[A+8>>2]=0;f[A>>2]=50520;B=A+16|0;mea(B,o,g,i,h,m,n);f[a>>2]=B;f[a+4>>2]=A;break}A=(p|0)==3;if(w&A){w=$Xc(92)|0;f[w+4>>2]=0;f[w+8>>2]=0;f[w>>2]=50548;B=w+12|0;nea(B,o,g,i,h,m,n);f[a>>2]=B;f[a+4>>2]=w;break}if(C&A){w=$Xc(92)|0;f[w+4>>2]=0;f[w+8>>2]=0;f[w>>2]=50576;B=w+12|0;oea(B,o,g,i,h,m,n);f[a>>2]=B;f[a+4>>2]=w;break}if(z&A){A=$Xc(104)|0;f[A+4>>2]=0;f[A+8>>2]=0;f[A>>2]=50604;w=A+16|0;pea(w,o,g,i,h,m,n);f[a>>2]=w;f[a+4>>2]=A;break}if(C&(p|0)==5){C=$Xc(92)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=50632;A=C+12|0;qea(A,o,g,i,h,m,n);f[a>>2]=A;f[a+4>>2]=C;break}if(z&(p|0)==6){z=$Xc(104)|0;f[z+4>>2]=0;f[z+8>>2]=0;f[z>>2]=50660;C=z+16|0;rea(C,o,g,i,h,m,n);f[a>>2]=C;f[a+4>>2]=z;break}else{f[l>>2]=c;D=l+4|0;f[D>>2]=d;DM(m,257175,l);vM(-213,m,257153,254608,3739)}}while(0);m=o+36|0;l=f[m>>2]|0;if(l|0?(d=l+12|0,l=f[d>>2]|0,f[d>>2]=l+-1,(l|0)==1):0)V$(o);f[m>>2]=0;m=o+16|0;l=o+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[o+40>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[l>>2]|0))}l=f[o+44>>2]|0;if((l|0)==(o+48|0)){u=k;return}wL(l);u=k;return}function Yda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=u;u=u+16|0;i=h;j=a+8|0;f[j>>2]=-1;k=a+4|0;f[k>>2]=-1;f[a>>2]=51144;l=a+12|0;f[l>>2]=1124007936;m=a+16|0;n=a+20|0;o=a+52|0;p=m;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=n;r=a+60|0;s=a+56|0;f[s>>2]=r;t=a+68|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if(f[c>>2]&16384){if((l|0)!=(c|0)){r=c+36|0;v=f[r>>2]|0;if(v){w=v+12|0;f[w>>2]=(f[w>>2]|0)+1;w=a+48|0;v=f[w>>2]|0;if((v|0)!=0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0){V$(l);y=w}else y=w}else y=a+48|0;f[y>>2]=0;w=a+28|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){v=f[o>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0;z=f[m>>2]|0}while((o|0)<(z|0));f[l>>2]=f[c>>2];if((z|0)<3)A=13;else A=15}else{f[l>>2]=f[c>>2];A=13}if((A|0)==13){z=f[c+4>>2]|0;if((z|0)<3){f[m>>2]=z;f[n>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];z=f[c+44>>2]|0;m=f[s>>2]|0;f[m>>2]=f[z>>2];f[m+4>>2]=f[z+4>>2]}else A=15}if((A|0)==15)U$(l,c);f[w>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[y>>2]=f[r>>2]}}else{r=i+8|0;f[r>>2]=0;f[r+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;jR(c,i)}f[j>>2]=d;d=f[n>>2]|0;n=f[a+24>>2]|0;f[k>>2]=d+-1+n;k=zLc(e)|0;f[a+80>>2]=k;k=g;g=f[k+4>>2]|0;a=t;f[a>>2]=f[k>>2];f[a+4>>2]=g;if((f[l>>2]&4095|0)!=4){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;B=$Xc(80)|0;f[i>>2]=B;C=i+8|0;f[C>>2]=-2147483568;D=i+4|0;f[D>>2]=77;p=B;E=258310;q=p+77|0;do{b[p>>0]=b[E>>0]|0;p=p+1|0;E=E+1|0}while((p|0)<(q|0));F=B+77|0;b[F>>0]=0;vM(-215,i,258388,254608,3251)}if((d|0)==1|(n|0)==1){u=h;return}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;B=$Xc(80)|0;f[i>>2]=B;C=i+8|0;f[C>>2]=-2147483568;D=i+4|0;f[D>>2]=77;p=B;E=258310;q=p+77|0;do{b[p>>0]=b[E>>0]|0;p=p+1|0;E=E+1|0}while((p|0)<(q|0));F=B+77|0;b[F>>0]=0;vM(-215,i,258388,254608,3251)}}function Zda(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=51096;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function _da(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=51048;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function $da(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=51e3;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function aea(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=50952;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function bea(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=50856;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function cea(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=50808;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function dea(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=50760;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function eea(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=50712;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;o=A;D=258310;q=o+77|0;do{b[o>>0]=b[D>>0]|0;o=o+1|0;D=D+1|0}while((o|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function fea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;iea(a,c,d,e,g,h,i);f[a>>2]=51312;if((f[a+4>>2]|0)==3){u=j;return}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(32)|0;f[k>>2]=j;f[k+8>>2]=-2147483616;f[k+4>>2]=16;a=j;i=259625;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[j+16>>0]=0;vM(-215,k,259642,254608,3420)}}function gea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;oga(a,c,d,e,g,h,i);f[a>>2]=51240;if((f[a+4>>2]|0)==3){u=j;return}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(32)|0;f[k>>2]=j;f[k+8>>2]=-2147483616;f[k+4>>2]=16;a=j;i=259625;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[j+16>>0]=0;vM(-215,k,259642,254608,3420)}}function hea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;bga(a,c,d,e,g,h,i);f[a>>2]=51168;if((f[a+4>>2]|0)==3){u=j;return}else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(32)|0;f[k>>2]=j;f[k+8>>2]=-2147483616;f[k+4>>2]=16;a=j;i=259625;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[j+16>>0]=0;vM(-215,k,259642,254608,3420)}}function iea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Yda(a,c,d,e,h,i);f[a>>2]=51120;f[a+84>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function jea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Zda(a,c,d,e,h,i);f[a>>2]=51072;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function kea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;_da(a,c,d,e,h,i);f[a>>2]=51024;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function lea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;$da(a,c,d,e,h,i);f[a>>2]=50976;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function mea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;aea(a,c,d,e,h,i);f[a>>2]=50928;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function nea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;afa(a,c,d,e,h,i);f[a>>2]=50880;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function oea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;bea(a,c,d,e,h,i);f[a>>2]=50832;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function pea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;cea(a,c,d,e,h,i);f[a>>2]=50784;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function qea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;dea(a,c,d,e,h,i);f[a>>2]=50736;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function rea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;eea(a,c,d,e,h,i);f[a>>2]=50688;f[a+80>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function sea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50712;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function tea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50712;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function uea(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+p[a+72>>3];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;n=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)o=0;else{e=f[n>>2]|0;if(l)q=0;else{r=0;while(1){s=+p[h>>3];t=e+(r<<3)|0;u=i+s*+p[t+8>>3];v=i+s*+p[t+16>>3];w=i+s*+p[t+24>>3];p[b+(r<<3)>>3]=i+s*+p[t>>3];p[b+((r|1)<<3)>>3]=u;p[b+((r|2)<<3)>>3]=v;p[b+((r|3)<<3)>>3]=w;r=r+4|0;if((r|0)>(a|0)){o=m;break a}}}do{w=+p[h>>3];r=e+(q<<3)|0;v=i+w*+p[r+24>>3];u=i+w*+p[r+16>>3];s=i+w*+p[r+8>>3];x=i+w*+p[r>>3];r=1;do{t=(f[n+(r<<2)>>2]|0)+(q<<3)|0;w=+p[h+(r<<3)>>3];x=x+w*+p[t>>3];s=s+w*+p[t+8>>3];u=u+w*+p[t+16>>3];v=v+w*+p[t+24>>3];r=r+1|0}while((r|0)!=(j|0));p[b+(q<<3)>>3]=x;p[b+((q|1)<<3)>>3]=s;p[b+((q|2)<<3)>>3]=u;p[b+((q|3)<<3)>>3]=v;q=q+4|0}while((q|0)<=(a|0));o=m}while(0);b:do if((o|0)<(g|0)){e=f[n>>2]|0;if(l)y=o;else{r=o;while(1){p[b+(r<<3)>>3]=i+ +p[h>>3]*+p[e+(r<<3)>>3];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +p[h>>3]*+p[e+(y<<3)>>3];r=1;do{w=w+ +p[h+(r<<3)>>3]*+p[(f[n+(r<<2)>>2]|0)+(y<<3)>>3];r=r+1|0}while((r|0)!=(j|0));p[b+(y<<3)>>3]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{n=n+4|0;b=b+d|0}}return}function vea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50712;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function wea(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<3)|0;k=+p[a+72>>3];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+80>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;n=(h|0)<2;o=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(n){u=0;while(1){p[q+(u<<3)>>3]=k;p[q+((u|1)<<3)>>3]=k;p[q+((u|2)<<3)>>3]=k;p[q+((u|3)<<3)>>3]=k;u=u+4|0;if((u|0)>(a|0)){t=o;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<3)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<3)|0;C=+p[j+(u<<3)>>3];z=z+C*(+p[A>>3]-+p[B>>3]);y=y+C*(+p[A+8>>3]-+p[B+8>>3]);x=x+C*(+p[A+16>>3]-+p[B+16>>3]);w=w+C*(+p[A+24>>3]-+p[B+24>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[q+(v<<3)>>3]=z;p[q+((v|1)<<3)>>3]=y;p[q+((v|2)<<3)>>3]=x;p[q+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(a|0));t=o}while(0);b:do if((t|0)<(g|0)){if(n){u=t;while(1){p[q+(u<<3)>>3]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +p[j+(u<<3)>>3]*(+p[(f[r+(u<<2)>>2]|0)+(D<<3)>>3]-+p[(f[r+(0-u<<2)>>2]|0)+(D<<3)>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[q+(D<<3)>>3]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+p[j>>3];t=b+(D<<3)|0;x=k+w*+p[t+8>>3];y=k+w*+p[t+16>>3];z=k+w*+p[t+24>>3];p[l+(D<<3)>>3]=k+w*+p[t>>3];p[l+((D|1)<<3)>>3]=x;p[l+((D|2)<<3)>>3]=y;p[l+((D|3)<<3)>>3]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+p[j>>3];D=b+(F<<3)|0;y=k+z*+p[D+24>>3];x=k+z*+p[D+16>>3];w=k+z*+p[D+8>>3];G=k+z*+p[D>>3];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<3)|0;n=(f[q+(0-D<<2)>>2]|0)+(F<<3)|0;z=+p[j+(D<<3)>>3];G=G+z*(+p[t>>3]+ +p[n>>3]);w=w+z*(+p[t+8>>3]+ +p[n+8>>3]);x=x+z*(+p[t+16>>3]+ +p[n+16>>3]);y=y+z*(+p[t+24>>3]+ +p[n+24>>3]);if((D|0)>=(i|0))break;else D=D+1|0}p[l+(F<<3)>>3]=G;p[l+((F|1)<<3)>>3]=w;p[l+((F|2)<<3)>>3]=x;p[l+((F|3)<<3)>>3]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){p[l+(D<<3)>>3]=k+ +p[j>>3]*+p[b+(D<<3)>>3];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +p[j>>3]*+p[b+(H<<3)>>3];D=1;while(1){C=C+ +p[j+(D<<3)>>3]*(+p[(f[q+(D<<2)>>2]|0)+(H<<3)>>3]+ +p[(f[q+(0-D<<2)>>2]|0)+(H<<3)>>3]);if((D|0)>=(i|0))break;else D=D+1|0}p[l+(H<<3)>>3]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function xea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50660;f[a+16>>2]=50712;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function yea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50660;f[a+16>>2]=50712;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function zea(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Aea(a){a=a|0;cYc(a);return}function Bea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50760;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Cea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50760;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Dea(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)p=0;else{e=f[o>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=e+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[b+(r<<2)>>2]=i+s*+n[t>>2];n[b+((r|1)<<2)>>2]=u;n[b+((r|2)<<2)>>2]=v;n[b+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=e+(q<<2)|0;v=i+w*+n[r+12>>2];u=i+w*+n[r+8>>2];s=i+w*+n[r+4>>2];x=i+w*+n[r>>2];r=1;do{t=(f[o+(r<<2)>>2]|0)+(q<<2)|0;w=+n[h+(r<<2)>>2];x=x+w*+n[t>>2];s=s+w*+n[t+4>>2];u=u+w*+n[t+8>>2];v=v+w*+n[t+12>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(q<<2)>>2]=x;n[b+((q|1)<<2)>>2]=s;n[b+((q|2)<<2)>>2]=u;n[b+((q|3)<<2)>>2]=v;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){e=f[o>>2]|0;if(l)y=p;else{r=p;while(1){n[b+(r<<2)>>2]=i+ +n[h>>2]*+n[e+(r<<2)>>2];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +n[h>>2]*+n[e+(y<<2)>>2];r=1;do{w=w+ +n[h+(r<<2)>>2]*+n[(f[o+(r<<2)>>2]|0)+(y<<2)>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{o=o+4|0;b=b+d|0}}return}function Eea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50760;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Fea(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[q+(u<<2)>>2]=k;n[q+((u|1)<<2)>>2]=k;n[q+((u|2)<<2)>>2]=k;n[q+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<2)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];z=z+C*(+n[A>>2]-+n[B>>2]);y=y+C*(+n[A+4>>2]-+n[B+4>>2]);x=x+C*(+n[A+8>>2]-+n[B+8>>2]);w=w+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(v<<2)>>2]=z;n[q+((v|1)<<2)>>2]=y;n[q+((v|2)<<2)>>2]=x;n[q+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[q+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[r+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[r+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+n[j>>2];t=b+(D<<2)|0;x=k+w*+n[t+4>>2];y=k+w*+n[t+8>>2];z=k+w*+n[t+12>>2];n[l+(D<<2)>>2]=k+w*+n[t>>2];n[l+((D|1)<<2)>>2]=x;n[l+((D|2)<<2)>>2]=y;n[l+((D|3)<<2)>>2]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+n[j>>2];D=b+(F<<2)|0;y=k+z*+n[D+12>>2];x=k+z*+n[D+8>>2];w=k+z*+n[D+4>>2];G=k+z*+n[D>>2];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<2)|0;o=(f[q+(0-D<<2)>>2]|0)+(F<<2)|0;z=+n[j+(D<<2)>>2];G=G+z*(+n[t>>2]+ +n[o>>2]);w=w+z*(+n[t+4>>2]+ +n[o+4>>2]);x=x+z*(+n[t+8>>2]+ +n[o+8>>2]);y=y+z*(+n[t+12>>2]+ +n[o+12>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(F<<2)>>2]=G;n[l+((F|1)<<2)>>2]=w;n[l+((F|2)<<2)>>2]=x;n[l+((F|3)<<2)>>2]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){n[l+(D<<2)>>2]=k+ +n[j>>2]*+n[b+(D<<2)>>2];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +n[j>>2]*+n[b+(H<<2)>>2];D=1;while(1){C=C+ +n[j+(D<<2)>>2]*(+n[(f[q+(D<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[q+(0-D<<2)>>2]|0)+(H<<2)>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function Gea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50632;f[a+12>>2]=50760;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Hea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50632;f[a+12>>2]=50760;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Iea(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Jea(a){a=a|0;cYc(a);return}function Kea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50808;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Lea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50808;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Mea(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+p[i>>3];g=f[o>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=zLc(j+r*+p[u>>3])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=zLc(v)|0;d[b+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=zLc(w)|0;d[b+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=zLc(x)|0;d[b+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=g+(s<<3)|0;x=j+r*+p[t+24>>3];w=j+r*+p[t+16>>3];v=j+r*+p[t+8>>3];z=j+r*+p[t>>3];t=1;do{y=(f[o+(t<<2)>>2]|0)+(s<<3)|0;A=+p[i+(t<<3)>>3];z=z+A*+p[y>>3];v=v+A*+p[y+8>>3];w=w+A*+p[y+16>>3];x=x+A*+p[y+24>>3];t=t+1|0}while((t|0)!=(k|0));t=zLc(z)|0;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=zLc(v)|0;d[b+((s|1)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=zLc(w)|0;d[b+((s|2)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=zLc(x)|0;d[b+((s|3)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];g=f[o>>2]|0;if(m)B=q;else{t=q;while(1){y=zLc(j+r*+p[g+(t<<3)>>3])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+p[g+(B<<3)>>3];t=1;do{A=A+ +p[i+(t<<3)>>3]*+p[(f[o+(t<<2)>>2]|0)+(B<<3)>>3];t=t+1|0}while((t|0)!=(k|0));t=zLc(A)|0;d[b+(B<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function Nea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50808;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Oea(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[r>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=zLc(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=zLc(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=zLc(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=zLc(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;B=l+v*+p[x+24>>3];A=l+v*+p[x+16>>3];z=l+v*+p[x+8>>3];E=l+v*+p[x>>3];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<3)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<3)|0;F=+p[k+(x<<3)>>3];E=E+F*(+p[C>>3]+ +p[y>>3]);z=z+F*(+p[C+8>>3]+ +p[y+8>>3]);A=A+F*(+p[C+16>>3]+ +p[y+16>>3]);B=B+F*(+p[C+24>>3]+ +p[y+24>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=zLc(E)|0;d[s+(D<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=zLc(z)|0;d[s+((D|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=zLc(A)|0;d[s+((D|2)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=zLc(B)|0;d[s+((D|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[r>>2]|0;if(o){x=u;while(1){y=zLc(l+v*+p[w+(x<<3)>>3])|0;d[s+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+p[w+(G<<3)>>3];x=1;while(1){F=F+ +p[k+(x<<3)>>3]*(+p[(f[r+(x<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[r+(0-x<<2)>>2]|0)+(G<<3)>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=zLc(F)|0;d[s+(G<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=zLc(l)|0;G=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(n|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<3)|0;E=+p[k+(b<<3)>>3];z=z+E*(+p[G>>3]-+p[u>>3]);A=A+E*(+p[G+8>>3]-+p[u+8>>3]);B=B+E*(+p[G+16>>3]-+p[u+16>>3]);v=v+E*(+p[G+24>>3]-+p[u+24>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=zLc(z)|0;d[r+(I<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=zLc(A)|0;d[r+((I|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=zLc(B)|0;d[r+((I|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=zLc(v)|0;d[r+((I|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=zLc(l)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +p[k+(b<<3)>>3]*(+p[(f[c+(b<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-b<<2)>>2]|0)+(J<<3)>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=zLc(F)|0;d[r+(J<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function Pea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50604;f[a+16>>2]=50808;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function Qea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50604;f[a+16>>2]=50808;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Rea(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Sea(a){a=a|0;cYc(a);return}function Tea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50856;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Uea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50856;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Vea(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+n[i>>2];g=f[p>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=ALc(j+r*+n[u>>2])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=ALc(v)|0;d[b+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=ALc(w)|0;d[b+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=ALc(x)|0;d[b+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=g+(s<<2)|0;x=j+r*+n[t+12>>2];w=j+r*+n[t+8>>2];v=j+r*+n[t+4>>2];z=j+r*+n[t>>2];t=1;do{y=(f[p+(t<<2)>>2]|0)+(s<<2)|0;A=+n[i+(t<<2)>>2];z=z+A*+n[y>>2];v=v+A*+n[y+4>>2];w=w+A*+n[y+8>>2];x=x+A*+n[y+12>>2];t=t+1|0}while((t|0)!=(k|0));t=ALc(z)|0;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=ALc(v)|0;d[b+((s|1)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=ALc(w)|0;d[b+((s|2)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=ALc(x)|0;d[b+((s|3)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];g=f[p>>2]|0;if(m)B=q;else{t=q;while(1){y=ALc(j+r*+n[g+(t<<2)>>2])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+n[g+(B<<2)>>2];t=1;do{A=A+ +n[i+(t<<2)>>2]*+n[(f[p+(t<<2)>>2]|0)+(B<<2)>>2];t=t+1|0}while((t|0)!=(k|0));t=ALc(A)|0;d[b+(B<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{p=p+4|0;b=b+e|0}}return}function Wea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50856;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Xea(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[r>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=ALc(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=ALc(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=ALc(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=ALc(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;B=l+v*+n[x+12>>2];A=l+v*+n[x+8>>2];z=l+v*+n[x+4>>2];E=l+v*+n[x>>2];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<2)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<2)|0;F=+n[k+(x<<2)>>2];E=E+F*(+n[C>>2]+ +n[y>>2]);z=z+F*(+n[C+4>>2]+ +n[y+4>>2]);A=A+F*(+n[C+8>>2]+ +n[y+8>>2]);B=B+F*(+n[C+12>>2]+ +n[y+12>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=ALc(E)|0;d[s+(D<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=ALc(z)|0;d[s+((D|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=ALc(A)|0;d[s+((D|2)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=ALc(B)|0;d[s+((D|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[r>>2]|0;if(p){x=u;while(1){y=ALc(l+v*+n[w+(x<<2)>>2])|0;d[s+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+n[w+(G<<2)>>2];x=1;while(1){F=F+ +n[k+(x<<2)>>2]*(+n[(f[r+(x<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[r+(0-x<<2)>>2]|0)+(G<<2)>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=ALc(F)|0;d[s+(G<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=ALc(l)|0;G=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(o|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<2)|0;E=+n[k+(b<<2)>>2];z=z+E*(+n[G>>2]-+n[u>>2]);A=A+E*(+n[G+4>>2]-+n[u+4>>2]);B=B+E*(+n[G+8>>2]-+n[u+8>>2]);v=v+E*(+n[G+12>>2]-+n[u+12>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=ALc(z)|0;d[r+(I<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=ALc(A)|0;d[r+((I|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=ALc(B)|0;d[r+((I|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=ALc(v)|0;d[r+((I|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=ALc(l)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +n[k+(b<<2)>>2]*(+n[(f[c+(b<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-b<<2)>>2]|0)+(J<<2)>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=ALc(F)|0;d[r+(J<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function Yea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50576;f[a+12>>2]=50856;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Zea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50576;f[a+12>>2]=50856;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function _ea(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function $ea(a){a=a|0;cYc(a);return}function afa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=50904;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){V$(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)U$(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=zLc(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(80)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483568;B=g+4|0;f[B>>2]=77;o=z;C=258310;p=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(p|0));D=z+77|0;b[D>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(80)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483568;B=g+4|0;f[B>>2]=77;o=z;C=258310;p=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(p|0));D=z+77|0;b[D>>0]=0;vM(-215,g,258388,254608,3251)}}function bfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50904;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function cfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50904;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function dfa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)p=0;else{g=f[i>>2]|0;q=f[o>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,g)|0)+j|0;v=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;x=(Y(f[t+12>>2]|0,g)|0)+j|0;d[b+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[b+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,g)|0)+j|0;w=(Y(f[s+4>>2]|0,g)|0)+j|0;v=(Y(f[s+8>>2]|0,g)|0)+j|0;u=(Y(f[s+12>>2]|0,g)|0)+j|0;s=v;v=w;w=x;x=1;do{t=(f[o+(x<<2)>>2]|0)+(r<<2)|0;y=f[i+(x<<2)>>2]|0;w=(Y(f[t>>2]|0,y)|0)+w|0;v=(Y(f[t+4>>2]|0,y)|0)+v|0;s=(Y(f[t+8>>2]|0,y)|0)+s|0;u=(Y(f[t+12>>2]|0,y)|0)+u|0;x=x+1|0}while((x|0)!=(k|0));d[b+(r<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((r|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((r|2)<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+((r|3)<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){g=f[i>>2]|0;q=f[o>>2]|0;if(m)z=p;else{x=p;while(1){y=(Y(f[q+(x<<2)>>2]|0,g)|0)+j|0;d[b+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}do{x=(Y(f[q+(z<<2)>>2]|0,g)|0)+j|0;y=1;do{x=(Y(f[(f[o+(y<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(y<<2)>>2]|0)|0)+x|0;y=y+1|0}while((y|0)!=(k|0));d[b+(z<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function efa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50904;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function ffa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=c;t=m;u=b;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[s+(w<<1)>>1]=r;d[s+((w|1)<<1)>>1]=r;d[s+((w|2)<<1)>>1]=r;d[s+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=l;y=l;z=l;A=l;B=1;while(1){C=(f[t+(B<<2)>>2]|0)+(x<<2)|0;D=(f[t+(0-B<<2)>>2]|0)+(x<<2)|0;E=f[k+(B<<2)>>2]|0;A=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+A|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;y=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+y|0;w=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+w|0;if((B|0)>=(j|0))break;else B=B+1|0}d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[s+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[s+((x|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+((x|3)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){B=v;while(1){d[s+(B<<1)>>1]=q;B=B+1|0;if((B|0)==(h|0))break b}}else F=v;do{B=l;E=1;while(1){B=(Y((f[(f[t+(E<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[t+(0-E<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(E<<2)>>2]|0)|0)+B|0;if((E|0)>=(j|0))break;else E=E+1|0}d[s+(F<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!u)break;else{s=s+e|0;t=t+4|0;u=u+-1|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=m;m=c;c=b;while(1){c:do if(u)G=0;else{b=f[k>>2]|0;F=f[s>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,b)|0)+l|0;p=(Y(f[q+4>>2]|0,b)|0)+l|0;a=(Y(f[q+8>>2]|0,b)|0)+l|0;x=(Y(f[q+12>>2]|0,b)|0)+l|0;d[m+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[m+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,b)|0)+l|0;a=(Y(f[v+4>>2]|0,b)|0)+l|0;p=(Y(f[v+8>>2]|0,b)|0)+l|0;o=(Y(f[v+12>>2]|0,b)|0)+l|0;v=p;p=a;a=x;x=1;while(1){q=(f[s+(x<<2)>>2]|0)+(H<<2)|0;r=(f[s+(0-x<<2)>>2]|0)+(H<<2)|0;g=f[k+(x<<2)>>2]|0;a=(Y((f[r>>2]|0)+(f[q>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+4>>2]|0)+(f[q+4>>2]|0)|0,g)|0)+p|0;v=(Y((f[r+8>>2]|0)+(f[q+8>>2]|0)|0,g)|0)+v|0;o=(Y((f[r+12>>2]|0)+(f[q+12>>2]|0)|0,g)|0)+o|0;if((x|0)>=(j|0))break;else x=x+1|0}d[m+(H<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((H|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((H|2)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[m+((H|3)<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){b=f[k>>2]|0;F=f[s>>2]|0;if(t){x=G;while(1){B=(Y(f[F+(x<<2)>>2]|0,b)|0)+l|0;d[m+(x<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break d}}else I=G;do{x=(Y(f[F+(I<<2)>>2]|0,b)|0)+l|0;B=1;while(1){x=(Y((f[(f[s+(0-B<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[s+(B<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(B<<2)>>2]|0)|0)+x|0;if((B|0)>=(j|0))break;else B=B+1|0}d[m+(I<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!c)break;else{s=s+4|0;m=m+e|0;c=c+-1|0}}return}}function gfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50548;f[a+12>>2]=50904;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function hfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50548;f[a+12>>2]=50904;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function ifa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function jfa(a){a=a|0;cYc(a);return}function kfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50952;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function lfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50952;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function mfa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+p[i>>3];g=f[o>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=zLc(j+r*+p[u>>3])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=zLc(v)|0;d[b+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=zLc(w)|0;d[b+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=zLc(x)|0;d[b+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=g+(s<<3)|0;x=j+r*+p[t+24>>3];w=j+r*+p[t+16>>3];v=j+r*+p[t+8>>3];z=j+r*+p[t>>3];t=1;do{y=(f[o+(t<<2)>>2]|0)+(s<<3)|0;A=+p[i+(t<<3)>>3];z=z+A*+p[y>>3];v=v+A*+p[y+8>>3];w=w+A*+p[y+16>>3];x=x+A*+p[y+24>>3];t=t+1|0}while((t|0)!=(k|0));t=zLc(z)|0;d[b+(s<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=zLc(v)|0;d[b+((s|1)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=zLc(w)|0;d[b+((s|2)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=zLc(x)|0;d[b+((s|3)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];g=f[o>>2]|0;if(m)B=q;else{t=q;while(1){y=zLc(j+r*+p[g+(t<<3)>>3])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+p[g+(B<<3)>>3];t=1;do{A=A+ +p[i+(t<<3)>>3]*+p[(f[o+(t<<2)>>2]|0)+(B<<3)>>3];t=t+1|0}while((t|0)!=(k|0));t=zLc(A)|0;d[b+(B<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function nfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50952;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function ofa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[r>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=zLc(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=zLc(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=zLc(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=zLc(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;B=l+v*+p[x+24>>3];A=l+v*+p[x+16>>3];z=l+v*+p[x+8>>3];E=l+v*+p[x>>3];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<3)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<3)|0;F=+p[k+(x<<3)>>3];E=E+F*(+p[C>>3]+ +p[y>>3]);z=z+F*(+p[C+8>>3]+ +p[y+8>>3]);A=A+F*(+p[C+16>>3]+ +p[y+16>>3]);B=B+F*(+p[C+24>>3]+ +p[y+24>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=zLc(E)|0;d[s+(D<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=zLc(z)|0;d[s+((D|1)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=zLc(A)|0;d[s+((D|2)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=zLc(B)|0;d[s+((D|3)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[r>>2]|0;if(o){x=u;while(1){y=zLc(l+v*+p[w+(x<<3)>>3])|0;d[s+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+p[w+(G<<3)>>3];x=1;while(1){F=F+ +p[k+(x<<3)>>3]*(+p[(f[r+(x<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[r+(0-x<<2)>>2]|0)+(G<<3)>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=zLc(F)|0;d[s+(G<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=zLc(l)|0;G=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(n|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<3)|0;E=+p[k+(b<<3)>>3];z=z+E*(+p[G>>3]-+p[u>>3]);A=A+E*(+p[G+8>>3]-+p[u+8>>3]);B=B+E*(+p[G+16>>3]-+p[u+16>>3]);v=v+E*(+p[G+24>>3]-+p[u+24>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=zLc(z)|0;d[r+(I<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=zLc(A)|0;d[r+((I|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=zLc(B)|0;d[r+((I|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=zLc(v)|0;d[r+((I|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=zLc(l)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +p[k+(b<<3)>>3]*(+p[(f[c+(b<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-b<<2)>>2]|0)+(J<<3)>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=zLc(F)|0;d[r+(J<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function pfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50520;f[a+16>>2]=50952;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function qfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50520;f[a+16>>2]=50952;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function rfa(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function sfa(a){a=a|0;cYc(a);return}function tfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51e3;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function ufa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51e3;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function vfa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+n[i>>2];g=f[p>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=ALc(j+r*+n[u>>2])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=ALc(v)|0;d[b+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=ALc(w)|0;d[b+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=ALc(x)|0;d[b+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=g+(s<<2)|0;x=j+r*+n[t+12>>2];w=j+r*+n[t+8>>2];v=j+r*+n[t+4>>2];z=j+r*+n[t>>2];t=1;do{y=(f[p+(t<<2)>>2]|0)+(s<<2)|0;A=+n[i+(t<<2)>>2];z=z+A*+n[y>>2];v=v+A*+n[y+4>>2];w=w+A*+n[y+8>>2];x=x+A*+n[y+12>>2];t=t+1|0}while((t|0)!=(k|0));t=ALc(z)|0;d[b+(s<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=ALc(v)|0;d[b+((s|1)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=ALc(w)|0;d[b+((s|2)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=ALc(x)|0;d[b+((s|3)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];g=f[p>>2]|0;if(m)B=q;else{t=q;while(1){y=ALc(j+r*+n[g+(t<<2)>>2])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+n[g+(B<<2)>>2];t=1;do{A=A+ +n[i+(t<<2)>>2]*+n[(f[p+(t<<2)>>2]|0)+(B<<2)>>2];t=t+1|0}while((t|0)!=(k|0));t=ALc(A)|0;d[b+(B<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{p=p+4|0;b=b+e|0}}return}function wfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51e3;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function xfa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[r>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=ALc(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=ALc(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=ALc(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=ALc(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;B=l+v*+n[x+12>>2];A=l+v*+n[x+8>>2];z=l+v*+n[x+4>>2];E=l+v*+n[x>>2];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<2)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<2)|0;F=+n[k+(x<<2)>>2];E=E+F*(+n[C>>2]+ +n[y>>2]);z=z+F*(+n[C+4>>2]+ +n[y+4>>2]);A=A+F*(+n[C+8>>2]+ +n[y+8>>2]);B=B+F*(+n[C+12>>2]+ +n[y+12>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=ALc(E)|0;d[s+(D<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=ALc(z)|0;d[s+((D|1)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=ALc(A)|0;d[s+((D|2)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=ALc(B)|0;d[s+((D|3)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[r>>2]|0;if(p){x=u;while(1){y=ALc(l+v*+n[w+(x<<2)>>2])|0;d[s+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+n[w+(G<<2)>>2];x=1;while(1){F=F+ +n[k+(x<<2)>>2]*(+n[(f[r+(x<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[r+(0-x<<2)>>2]|0)+(G<<2)>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=ALc(F)|0;d[s+(G<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=ALc(l)|0;G=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(o|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<2)|0;E=+n[k+(b<<2)>>2];z=z+E*(+n[G>>2]-+n[u>>2]);A=A+E*(+n[G+4>>2]-+n[u+4>>2]);B=B+E*(+n[G+8>>2]-+n[u+8>>2]);v=v+E*(+n[G+12>>2]-+n[u+12>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=ALc(z)|0;d[r+(I<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=ALc(A)|0;d[r+((I|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=ALc(B)|0;d[r+((I|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=ALc(v)|0;d[r+((I|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=ALc(l)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +n[k+(b<<2)>>2]*(+n[(f[c+(b<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-b<<2)>>2]|0)+(J<<2)>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=ALc(F)|0;d[r+(J<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function yfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50492;f[a+12>>2]=51e3;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function zfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50492;f[a+12>>2]=51e3;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Afa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Bfa(a){a=a|0;cYc(a);return}function Cfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51048;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Dfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51048;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Efa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=c;c=d;d=g;while(1){d=d+-1|0;a:do if(l)q=0;else{if(m)r=0;else{g=0;while(1){s=+p[i>>3];t=(f[o>>2]|0)+(g<<3)|0;u=j+s*+p[t+8>>3];v=j+s*+p[t+16>>3];w=j+s*+p[t+24>>3];x=zLc(j+s*+p[t>>3])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;x=zLc(u)|0;b[c+(g|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=zLc(v)|0;b[c+(g|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=zLc(w)|0;b[c+(g|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+4|0;if((g|0)>(a|0)){q=n;break a}}}do{w=+p[i>>3];g=(f[o>>2]|0)+(r<<3)|0;v=j+w*+p[g+24>>3];u=j+w*+p[g+16>>3];s=j+w*+p[g+8>>3];y=j+w*+p[g>>3];g=1;do{x=(f[o+(g<<2)>>2]|0)+(r<<3)|0;w=+p[i+(g<<3)>>3];y=y+w*+p[x>>3];s=s+w*+p[x+8>>3];u=u+w*+p[x+16>>3];v=v+w*+p[x+24>>3];g=g+1|0}while((g|0)!=(k|0));g=zLc(y)|0;b[c+r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=zLc(s)|0;b[c+(r|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=zLc(u)|0;b[c+(r|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=zLc(v)|0;b[c+(r|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{g=q;while(1){x=zLc(j+ +p[i>>3]*+p[(f[o>>2]|0)+(g<<3)>>3])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+1|0;if((g|0)==(h|0))break b}}do{w=j+ +p[i>>3]*+p[(f[o>>2]|0)+(z<<3)>>3];g=1;do{w=w+ +p[i+(g<<3)>>3]*+p[(f[o+(g<<2)>>2]|0)+(z<<3)>>3];g=g+1|0}while((g|0)!=(k|0));g=zLc(w)|0;b[c+z>>0]=g>>>0<256?g:(g|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{o=o+4|0;c=c+e|0}}return}function Ffa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51048;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Gfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=c+(j<<2)|0;c=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=d;t=c;while(1){a:do if(g)u=0;else{if(o){v=0;while(1){w=+p[k>>3];x=(f[r>>2]|0)+(v<<3)|0;y=l+w*+p[x+8>>3];z=l+w*+p[x+16>>3];A=l+w*+p[x+24>>3];B=zLc(l+w*+p[x>>3])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=zLc(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=zLc(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=zLc(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+p[k>>3];v=(f[r>>2]|0)+(C<<3)|0;z=l+A*+p[v+24>>3];y=l+A*+p[v+16>>3];w=l+A*+p[v+8>>3];D=l+A*+p[v>>3];v=1;while(1){B=(f[r+(v<<2)>>2]|0)+(C<<3)|0;x=(f[r+(0-v<<2)>>2]|0)+(C<<3)|0;A=+p[k+(v<<3)>>3];D=D+A*(+p[B>>3]+ +p[x>>3]);w=w+A*(+p[B+8>>3]+ +p[x+8>>3]);y=y+A*(+p[B+16>>3]+ +p[x+16>>3]);z=z+A*(+p[B+24>>3]+ +p[x+24>>3]);if((v|0)>=(j|0))break;else v=v+1|0}v=zLc(D)|0;b[s+C>>0]=v>>>0<256?v:(v|0)>0?255:0;v=zLc(w)|0;b[s+(C|1)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=zLc(y)|0;b[s+(C|2)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=zLc(z)|0;b[s+(C|3)>>0]=v>>>0<256?v:(v|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(o){v=u;while(1){x=zLc(l+ +p[k>>3]*+p[(f[r>>2]|0)+(v<<3)>>3])|0;b[s+v>>0]=x>>>0<256?x:(x|0)>0?255:0;v=v+1|0;if((v|0)==(h|0))break b}}else E=u;do{A=l+ +p[k>>3]*+p[(f[r>>2]|0)+(E<<3)>>3];v=1;while(1){A=A+ +p[k+(v<<3)>>3]*(+p[(f[r+(v<<2)>>2]|0)+(E<<3)>>3]+ +p[(f[r+(0-v<<2)>>2]|0)+(E<<3)>>3]);if((v|0)>=(j|0))break;else v=v+1|0}v=zLc(A)|0;b[s+E>>0]=v>>>0<256?v:(v|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=d;d=m;m=c;while(1){c:do if(t)F=0;else{if(s){c=zLc(l)|0;E=(c>>>0<256?c:(c|0)>0?255:0)&255;c=0;while(1){b[r+c>>0]=E;b[r+(c|1)>>0]=E;b[r+(c|2)>>0]=E;b[r+(c|3)>>0]=E;c=c+4|0;if((c|0)>(n|0)){F=i;break c}}}else G=0;do{z=l;y=l;w=l;D=l;c=1;while(1){E=(f[d+(c<<2)>>2]|0)+(G<<3)|0;u=(f[d+(0-c<<2)>>2]|0)+(G<<3)|0;H=+p[k+(c<<3)>>3];D=D+H*(+p[E>>3]-+p[u>>3]);w=w+H*(+p[E+8>>3]-+p[u+8>>3]);y=y+H*(+p[E+16>>3]-+p[u+16>>3]);z=z+H*(+p[E+24>>3]-+p[u+24>>3]);if((c|0)>=(j|0))break;else c=c+1|0}c=zLc(D)|0;b[r+G>>0]=c>>>0<256?c:(c|0)>0?255:0;c=zLc(w)|0;b[r+(G|1)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=zLc(y)|0;b[r+(G|2)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=zLc(z)|0;b[r+(G|3)>>0]=c>>>0<256?c:(c|0)>0?255:0;G=G+4|0}while((G|0)<=(n|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){c=zLc(l)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=F;while(1){b[r+c>>0]=u;c=c+1|0;if((c|0)==(h|0))break d}}else I=F;do{A=l;c=1;while(1){A=A+ +p[k+(c<<3)>>3]*(+p[(f[d+(c<<2)>>2]|0)+(I<<3)>>3]-+p[(f[d+(0-c<<2)>>2]|0)+(I<<3)>>3]);if((c|0)>=(j|0))break;else c=c+1|0}c=zLc(A)|0;b[r+I>>0]=c>>>0<256?c:(c|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;d=d+4|0;m=m+-1|0}}return}function Hfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50464;f[a+16>>2]=51048;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function Ifa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50464;f[a+16>>2]=51048;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Jfa(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Kfa(a){a=a|0;cYc(a);return}function Lfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51096;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Mfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51096;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Nfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=c;c=d;d=g;while(1){d=d+-1|0;a:do if(l)q=0;else{if(m)r=0;else{g=0;while(1){s=+n[i>>2];t=(f[p>>2]|0)+(g<<2)|0;u=j+s*+n[t+4>>2];v=j+s*+n[t+8>>2];w=j+s*+n[t+12>>2];x=ALc(j+s*+n[t>>2])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;x=ALc(u)|0;b[c+(g|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=ALc(v)|0;b[c+(g|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=ALc(w)|0;b[c+(g|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+4|0;if((g|0)>(a|0)){q=o;break a}}}do{w=+n[i>>2];g=(f[p>>2]|0)+(r<<2)|0;v=j+w*+n[g+12>>2];u=j+w*+n[g+8>>2];s=j+w*+n[g+4>>2];y=j+w*+n[g>>2];g=1;do{x=(f[p+(g<<2)>>2]|0)+(r<<2)|0;w=+n[i+(g<<2)>>2];y=y+w*+n[x>>2];s=s+w*+n[x+4>>2];u=u+w*+n[x+8>>2];v=v+w*+n[x+12>>2];g=g+1|0}while((g|0)!=(k|0));g=ALc(y)|0;b[c+r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=ALc(s)|0;b[c+(r|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=ALc(u)|0;b[c+(r|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=ALc(v)|0;b[c+(r|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{g=q;while(1){x=ALc(j+ +n[i>>2]*+n[(f[p>>2]|0)+(g<<2)>>2])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+1|0;if((g|0)==(h|0))break b}}do{w=j+ +n[i>>2]*+n[(f[p>>2]|0)+(z<<2)>>2];g=1;do{w=w+ +n[i+(g<<2)>>2]*+n[(f[p+(g<<2)>>2]|0)+(z<<2)>>2];g=g+1|0}while((g|0)!=(k|0));g=ALc(w)|0;b[c+z>>0]=g>>>0<256?g:(g|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{p=p+4|0;c=c+e|0}}return}function Ofa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51096;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Pfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=c+(j<<2)|0;c=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=d;t=c;while(1){a:do if(g)u=0;else{if(p){v=0;while(1){w=+n[k>>2];x=(f[r>>2]|0)+(v<<2)|0;y=l+w*+n[x+4>>2];z=l+w*+n[x+8>>2];A=l+w*+n[x+12>>2];B=ALc(l+w*+n[x>>2])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=ALc(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=ALc(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=ALc(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+n[k>>2];v=(f[r>>2]|0)+(C<<2)|0;z=l+A*+n[v+12>>2];y=l+A*+n[v+8>>2];w=l+A*+n[v+4>>2];D=l+A*+n[v>>2];v=1;while(1){B=(f[r+(v<<2)>>2]|0)+(C<<2)|0;x=(f[r+(0-v<<2)>>2]|0)+(C<<2)|0;A=+n[k+(v<<2)>>2];D=D+A*(+n[B>>2]+ +n[x>>2]);w=w+A*(+n[B+4>>2]+ +n[x+4>>2]);y=y+A*(+n[B+8>>2]+ +n[x+8>>2]);z=z+A*(+n[B+12>>2]+ +n[x+12>>2]);if((v|0)>=(j|0))break;else v=v+1|0}v=ALc(D)|0;b[s+C>>0]=v>>>0<256?v:(v|0)>0?255:0;v=ALc(w)|0;b[s+(C|1)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=ALc(y)|0;b[s+(C|2)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=ALc(z)|0;b[s+(C|3)>>0]=v>>>0<256?v:(v|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(p){v=u;while(1){x=ALc(l+ +n[k>>2]*+n[(f[r>>2]|0)+(v<<2)>>2])|0;b[s+v>>0]=x>>>0<256?x:(x|0)>0?255:0;v=v+1|0;if((v|0)==(h|0))break b}}else E=u;do{A=l+ +n[k>>2]*+n[(f[r>>2]|0)+(E<<2)>>2];v=1;while(1){A=A+ +n[k+(v<<2)>>2]*(+n[(f[r+(v<<2)>>2]|0)+(E<<2)>>2]+ +n[(f[r+(0-v<<2)>>2]|0)+(E<<2)>>2]);if((v|0)>=(j|0))break;else v=v+1|0}v=ALc(A)|0;b[s+E>>0]=v>>>0<256?v:(v|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=d;d=m;m=c;while(1){c:do if(t)F=0;else{if(s){c=ALc(l)|0;E=(c>>>0<256?c:(c|0)>0?255:0)&255;c=0;while(1){b[r+c>>0]=E;b[r+(c|1)>>0]=E;b[r+(c|2)>>0]=E;b[r+(c|3)>>0]=E;c=c+4|0;if((c|0)>(o|0)){F=i;break c}}}else G=0;do{z=l;y=l;w=l;D=l;c=1;while(1){E=(f[d+(c<<2)>>2]|0)+(G<<2)|0;u=(f[d+(0-c<<2)>>2]|0)+(G<<2)|0;H=+n[k+(c<<2)>>2];D=D+H*(+n[E>>2]-+n[u>>2]);w=w+H*(+n[E+4>>2]-+n[u+4>>2]);y=y+H*(+n[E+8>>2]-+n[u+8>>2]);z=z+H*(+n[E+12>>2]-+n[u+12>>2]);if((c|0)>=(j|0))break;else c=c+1|0}c=ALc(D)|0;b[r+G>>0]=c>>>0<256?c:(c|0)>0?255:0;c=ALc(w)|0;b[r+(G|1)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=ALc(y)|0;b[r+(G|2)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=ALc(z)|0;b[r+(G|3)>>0]=c>>>0<256?c:(c|0)>0?255:0;G=G+4|0}while((G|0)<=(o|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){c=ALc(l)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=F;while(1){b[r+c>>0]=u;c=c+1|0;if((c|0)==(h|0))break d}}else I=F;do{A=l;c=1;while(1){A=A+ +n[k+(c<<2)>>2]*(+n[(f[d+(c<<2)>>2]|0)+(I<<2)>>2]-+n[(f[d+(0-c<<2)>>2]|0)+(I<<2)>>2]);if((c|0)>=(j|0))break;else c=c+1|0}c=ALc(A)|0;b[r+I>>0]=c>>>0<256?c:(c|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;d=d+4|0;m=m+-1|0}}return}function Qfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50436;f[a+12>>2]=51096;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Rfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50436;f[a+12>>2]=51096;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Sfa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Tfa(a){a=a|0;cYc(a);return}function Ufa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51144;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function Vfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51144;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Wfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+80>>2]|0;k=f[a+4>>2]|0;l=a+68|0;a=f[l>>2]|0;m=f[l+4>>2]|0;if(!g)return;l=h+-4|0;n=(h|0)<4;o=(k|0)>1;p=h&-4;q=c;c=d;d=g;while(1){d=d+-1|0;a:do if(n)r=0;else{if(o)s=0;else{g=0;while(1){t=f[i>>2]|0;u=(f[q>>2]|0)+(g<<2)|0;v=(Y(f[u>>2]|0,t)|0)+j|0;w=(Y(f[u+4>>2]|0,t)|0)+j|0;x=(Y(f[u+8>>2]|0,t)|0)+j|0;y=(Y(f[u+12>>2]|0,t)|0)+j|0;t=v+m>>a;b[c+g>>0]=t>>>0<256?t:(t|0)>0?255:0;t=w+m>>a;b[c+(g|1)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=x+m>>a;b[c+(g|2)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=y+m>>a;b[c+(g|3)>>0]=t>>>0<256?t:(t|0)>0?255:0;g=g+4|0;if((g|0)>(l|0)){r=p;break a}}}do{g=f[i>>2]|0;t=(f[q>>2]|0)+(s<<2)|0;y=(Y(f[t>>2]|0,g)|0)+j|0;x=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;v=(Y(f[t+12>>2]|0,g)|0)+j|0;g=w;w=x;x=y;y=1;do{t=(f[q+(y<<2)>>2]|0)+(s<<2)|0;u=f[i+(y<<2)>>2]|0;x=(Y(f[t>>2]|0,u)|0)+x|0;w=(Y(f[t+4>>2]|0,u)|0)+w|0;g=(Y(f[t+8>>2]|0,u)|0)+g|0;v=(Y(f[t+12>>2]|0,u)|0)+v|0;y=y+1|0}while((y|0)!=(k|0));y=x+m>>a;b[c+s>>0]=y>>>0<256?y:(y|0)>0?255:0;y=w+m>>a;b[c+(s|1)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=g+m>>a;b[c+(s|2)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=v+m>>a;b[c+(s|3)>>0]=y>>>0<256?y:(y|0)>0?255:0;s=s+4|0}while((s|0)<=(l|0));r=p}while(0);b:do if((r|0)<(h|0)){if(o)z=r;else{y=r;while(1){u=(Y(f[(f[q>>2]|0)+(y<<2)>>2]|0,f[i>>2]|0)|0)+j+m>>a;b[c+y>>0]=u>>>0<256?u:(u|0)>0?255:0;y=y+1|0;if((y|0)==(h|0))break b}}do{y=(Y(f[(f[q>>2]|0)+(z<<2)>>2]|0,f[i>>2]|0)|0)+j|0;u=1;do{y=(Y(f[(f[q+(u<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(u<<2)>>2]|0)|0)+y|0;u=u+1|0}while((u|0)!=(k|0));u=y+m>>a;b[c+z>>0]=u>>>0<256?u:(u|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{q=q+4|0;c=c+e|0}}return}function Xfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51144;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Yfa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+80>>2]|0;m=a+68|0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c+(j<<2)|0;c=g+-1|0;p=(g|0)==0;if(!(f[a+84>>2]&1)){if(p)return;a=h+-4|0;g=(h|0)<4;q=(i|0)<2;r=h&-4;s=l+o>>n;t=(s>>>0<256?s:(s|0)>0?255:0)&255;s=l+o>>n;u=(s>>>0<256?s:(s|0)>0?255:0)&255;s=d;v=m;w=c;while(1){a:do if(g)x=0;else{if(q){y=0;while(1){b[s+y>>0]=u;b[s+(y|1)>>0]=u;b[s+(y|2)>>0]=u;b[s+(y|3)>>0]=u;y=y+4|0;if((y|0)>(a|0)){x=r;break a}}}else z=0;do{y=l;A=l;B=l;C=l;D=1;while(1){E=(f[v+(D<<2)>>2]|0)+(z<<2)|0;F=(f[v+(0-D<<2)>>2]|0)+(z<<2)|0;G=f[k+(D<<2)>>2]|0;C=(Y((f[E>>2]|0)-(f[F>>2]|0)|0,G)|0)+C|0;B=(Y((f[E+4>>2]|0)-(f[F+4>>2]|0)|0,G)|0)+B|0;A=(Y((f[E+8>>2]|0)-(f[F+8>>2]|0)|0,G)|0)+A|0;y=(Y((f[E+12>>2]|0)-(f[F+12>>2]|0)|0,G)|0)+y|0;if((D|0)>=(j|0))break;else D=D+1|0}D=C+o>>n;b[s+z>>0]=D>>>0<256?D:(D|0)>0?255:0;D=B+o>>n;b[s+(z|1)>>0]=D>>>0<256?D:(D|0)>0?255:0;D=A+o>>n;b[s+(z|2)>>0]=D>>>0<256?D:(D|0)>0?255:0;D=y+o>>n;b[s+(z|3)>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+4|0}while((z|0)<=(a|0));x=r}while(0);b:do if((x|0)<(h|0)){if(q){D=x;while(1){b[s+D>>0]=t;D=D+1|0;if((D|0)==(h|0))break b}}else H=x;do{D=l;G=1;while(1){D=(Y((f[(f[v+(G<<2)>>2]|0)+(H<<2)>>2]|0)-(f[(f[v+(0-G<<2)>>2]|0)+(H<<2)>>2]|0)|0,f[k+(G<<2)>>2]|0)|0)+D|0;if((G|0)>=(j|0))break;else G=G+1|0}G=D+o>>n;b[s+H>>0]=G>>>0<256?G:(G|0)>0?255:0;H=H+1|0}while((H|0)!=(h|0))}while(0);if(!w)break;else{s=s+e|0;v=v+4|0;w=w+-1|0}}return}else{if(p)return;p=h+-4|0;w=(h|0)<4;v=(i|0)<2;i=h&-4;s=m;m=d;d=c;while(1){c:do if(w)I=0;else{if(v){c=0;while(1){H=f[k>>2]|0;x=(f[s>>2]|0)+(c<<2)|0;t=(Y(f[x>>2]|0,H)|0)+l|0;q=(Y(f[x+4>>2]|0,H)|0)+l|0;r=(Y(f[x+8>>2]|0,H)|0)+l|0;a=(Y(f[x+12>>2]|0,H)|0)+l|0;H=t+o>>n;b[m+c>>0]=H>>>0<256?H:(H|0)>0?255:0;H=q+o>>n;b[m+(c|1)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=r+o>>n;b[m+(c|2)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=a+o>>n;b[m+(c|3)>>0]=H>>>0<256?H:(H|0)>0?255:0;c=c+4|0;if((c|0)>(p|0)){I=i;break c}}}else J=0;do{c=f[k>>2]|0;H=(f[s>>2]|0)+(J<<2)|0;a=(Y(f[H>>2]|0,c)|0)+l|0;r=(Y(f[H+4>>2]|0,c)|0)+l|0;q=(Y(f[H+8>>2]|0,c)|0)+l|0;t=(Y(f[H+12>>2]|0,c)|0)+l|0;c=q;q=r;r=a;a=1;while(1){H=(f[s+(a<<2)>>2]|0)+(J<<2)|0;x=(f[s+(0-a<<2)>>2]|0)+(J<<2)|0;z=f[k+(a<<2)>>2]|0;r=(Y((f[x>>2]|0)+(f[H>>2]|0)|0,z)|0)+r|0;q=(Y((f[x+4>>2]|0)+(f[H+4>>2]|0)|0,z)|0)+q|0;c=(Y((f[x+8>>2]|0)+(f[H+8>>2]|0)|0,z)|0)+c|0;t=(Y((f[x+12>>2]|0)+(f[H+12>>2]|0)|0,z)|0)+t|0;if((a|0)>=(j|0))break;else a=a+1|0}a=r+o>>n;b[m+J>>0]=a>>>0<256?a:(a|0)>0?255:0;a=q+o>>n;b[m+(J|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=c+o>>n;b[m+(J|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=t+o>>n;b[m+(J|3)>>0]=a>>>0<256?a:(a|0)>0?255:0;J=J+4|0}while((J|0)<=(p|0));I=i}while(0);d:do if((I|0)<(h|0)){if(v){a=I;while(1){D=(Y(f[(f[s>>2]|0)+(a<<2)>>2]|0,f[k>>2]|0)|0)+l+o>>n;b[m+a>>0]=D>>>0<256?D:(D|0)>0?255:0;a=a+1|0;if((a|0)==(h|0))break d}}else K=I;do{a=(Y(f[(f[s>>2]|0)+(K<<2)>>2]|0,f[k>>2]|0)|0)+l|0;D=1;while(1){a=(Y((f[(f[s+(0-D<<2)>>2]|0)+(K<<2)>>2]|0)+(f[(f[s+(D<<2)>>2]|0)+(K<<2)>>2]|0)|0,f[k+(D<<2)>>2]|0)|0)+a|0;if((D|0)>=(j|0))break;else D=D+1|0}D=a+o>>n;b[m+K>>0]=D>>>0<256?D:(D|0)>0?255:0;K=K+1|0}while((K|0)!=(h|0))}while(0);if(!d)break;else{s=s+4|0;m=m+e|0;d=d+-1|0}}return}}function Zfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50408;f[a+12>>2]=51144;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function _fa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50408;f[a+12>>2]=51144;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function $fa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function aga(a){a=a|0;cYc(a);return}function bga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;hga(a,c,d,e,h,i);f[a>>2]=51216;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function cga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51192;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function dga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51192;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function ega(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)p=0;else{e=f[o>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=e+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[b+(r<<2)>>2]=i+s*+n[t>>2];n[b+((r|1)<<2)>>2]=u;n[b+((r|2)<<2)>>2]=v;n[b+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=e+(q<<2)|0;v=i+w*+n[r+12>>2];u=i+w*+n[r+8>>2];s=i+w*+n[r+4>>2];x=i+w*+n[r>>2];r=1;do{t=(f[o+(r<<2)>>2]|0)+(q<<2)|0;w=+n[h+(r<<2)>>2];x=x+w*+n[t>>2];s=s+w*+n[t+4>>2];u=u+w*+n[t+8>>2];v=v+w*+n[t+12>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(q<<2)>>2]=x;n[b+((q|1)<<2)>>2]=s;n[b+((q|2)<<2)>>2]=u;n[b+((q|3)<<2)>>2]=v;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){e=f[o>>2]|0;if(l)y=p;else{r=p;while(1){n[b+(r<<2)>>2]=i+ +n[h>>2]*+n[e+(r<<2)>>2];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +n[h>>2]*+n[e+(y<<2)>>2];r=1;do{w=w+ +n[h+(r<<2)>>2]*+n[(f[o+(r<<2)>>2]|0)+(y<<2)>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{o=o+4|0;b=b+d|0}}return}function fga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51192;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function gga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0;h=(f[a+4>>2]|0)/2|0;i=(f[a+28>>2]|0)+(h<<2)|0;j=(f[a+76>>2]&1|0)==0;k=+n[i>>2];l=+n[i+4>>2];i=l==1.0;m=k==2.0&i;o=k==-2.0&i;p=k!=0.0;q=p|i?p^1:l==-1.0;r=+n[a+72>>2];if(!e)return;a=l<0.0;p=g+-4|0;i=(g|0)<4;s=g&-4;t=c;c=b+(h<<2)|0;h=e;while(1){h=h+-1|0;e=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(j)if(q){v=a?u:e;w=a?e:u;if(i)x=0;else{y=w;z=v;A=0;do{B=A|1;C=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[t+(A<<2)>>2]=r+(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[t+(B<<2)>>2]=C;B=A|2;D=A|3;C=r+(+n[y+(D<<2)>>2]-+n[z+(D<<2)>>2]);n[t+(B<<2)>>2]=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[t+(D<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));x=s}if((x|0)>=(g|0))break;A=w;z=v;y=x;do{n[t+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(i)E=0;else{y=u;z=e;A=0;do{v=A|1;C=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[t+(A<<2)>>2]=r+l*(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[t+(v<<2)>>2]=C;v=A|2;w=A|3;C=r+l*(+n[y+(w<<2)>>2]-+n[z+(w<<2)>>2]);n[t+(v<<2)>>2]=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[t+(w<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));E=s}if((E|0)>=(g|0))break;A=u;z=e;y=E;do{n[t+(y<<2)>>2]=r+l*(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(m){if(i)F=0;else{y=e;z=u;A=0;do{w=A|1;C=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[t+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]+ +n[b+(A<<2)>>2]*2.0));n[t+(w<<2)>>2]=C;w=A|2;v=A|3;C=r+(+n[z+(v<<2)>>2]+(+n[y+(v<<2)>>2]+ +n[b+(v<<2)>>2]*2.0));n[t+(w<<2)>>2]=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[t+(v<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));F=s}if((F|0)>=(g|0))break;A=e;y=u;z=F;while(1){n[t+(z<<2)>>2]=r+(+n[y+(z<<2)>>2]+(+n[A+(z<<2)>>2]+ +n[b+(z<<2)>>2]*2.0));z=z+1|0;if((z|0)==(g|0))break a}}if(o){if(i)G=0;else{z=e;A=u;y=0;do{v=y|1;C=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[t+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]+(+n[z+(y<<2)>>2]-+n[b+(y<<2)>>2]*2.0));n[t+(v<<2)>>2]=C;v=y|2;w=y|3;C=r+(+n[A+(w<<2)>>2]+(+n[z+(w<<2)>>2]-+n[b+(w<<2)>>2]*2.0));n[t+(v<<2)>>2]=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[t+(w<<2)>>2]=C;y=y+4|0}while((y|0)<=(p|0));G=s}if((G|0)>=(g|0))break;y=e;z=u;A=G;do{n[t+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]-+n[b+(A<<2)>>2]*2.0));A=A+1|0}while((A|0)!=(g|0))}else{if(i)H=0;else{A=e;y=u;z=0;do{w=z|1;C=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[t+(z<<2)>>2]=r+(l*(+n[A+(z<<2)>>2]+ +n[y+(z<<2)>>2])+k*+n[b+(z<<2)>>2]);n[t+(w<<2)>>2]=C;w=z|2;v=z|3;C=r+(l*(+n[A+(v<<2)>>2]+ +n[y+(v<<2)>>2])+k*+n[b+(v<<2)>>2]);n[t+(w<<2)>>2]=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[t+(v<<2)>>2]=C;z=z+4|0}while((z|0)<=(p|0));H=s}if((H|0)>=(g|0))break;z=e;y=u;A=H;do{n[t+(A<<2)>>2]=r+(l*(+n[z+(A<<2)>>2]+ +n[y+(A<<2)>>2])+k*+n[b+(A<<2)>>2]);A=A+1|0}while((A|0)!=(g|0))}}while(0);if(!h)break;else t=t+d|0}return}function hga(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=51192;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){V$(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)U$(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=$Xc(80)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483568;C=g+4|0;f[C>>2]=77;p=A;D=258310;q=p+77|0;do{b[p>>0]=b[D>>0]|0;p=p+1|0;D=D+1|0}while((p|0)<(q|0));E=A+77|0;b[E>>0]=0;vM(-215,g,258388,254608,3251)}}function iga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51192;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function jga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[q+(u<<2)>>2]=k;n[q+((u|1)<<2)>>2]=k;n[q+((u|2)<<2)>>2]=k;n[q+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<2)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];z=z+C*(+n[A>>2]-+n[B>>2]);y=y+C*(+n[A+4>>2]-+n[B+4>>2]);x=x+C*(+n[A+8>>2]-+n[B+8>>2]);w=w+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(v<<2)>>2]=z;n[q+((v|1)<<2)>>2]=y;n[q+((v|2)<<2)>>2]=x;n[q+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[q+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[r+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[r+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+n[j>>2];t=b+(D<<2)|0;x=k+w*+n[t+4>>2];y=k+w*+n[t+8>>2];z=k+w*+n[t+12>>2];n[l+(D<<2)>>2]=k+w*+n[t>>2];n[l+((D|1)<<2)>>2]=x;n[l+((D|2)<<2)>>2]=y;n[l+((D|3)<<2)>>2]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+n[j>>2];D=b+(F<<2)|0;y=k+z*+n[D+12>>2];x=k+z*+n[D+8>>2];w=k+z*+n[D+4>>2];G=k+z*+n[D>>2];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<2)|0;o=(f[q+(0-D<<2)>>2]|0)+(F<<2)|0;z=+n[j+(D<<2)>>2];G=G+z*(+n[t>>2]+ +n[o>>2]);w=w+z*(+n[t+4>>2]+ +n[o+4>>2]);x=x+z*(+n[t+8>>2]+ +n[o+8>>2]);y=y+z*(+n[t+12>>2]+ +n[o+12>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(F<<2)>>2]=G;n[l+((F|1)<<2)>>2]=w;n[l+((F|2)<<2)>>2]=x;n[l+((F|3)<<2)>>2]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){n[l+(D<<2)>>2]=k+ +n[j>>2]*+n[b+(D<<2)>>2];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +n[j>>2]*+n[b+(H<<2)>>2];D=1;while(1){C=C+ +n[j+(D<<2)>>2]*(+n[(f[q+(D<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[q+(0-D<<2)>>2]|0)+(H<<2)>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function kga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50380;f[a+12>>2]=51192;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function lga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50380;f[a+12>>2]=51192;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function mga(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function nga(a){a=a|0;cYc(a);return}function oga(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;uga(a,c,d,e,h,i);f[a>>2]=51288;f[a+76>>2]=g;if(!(g&3)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(80)|0;f[k>>2]=g;f[k+8>>2]=-2147483568;f[k+4>>2]=64;a=g;i=257252;h=a+64|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));b[g+64>>0]=0;vM(-215,k,257317,254608,3314)}else{u=j;return}}function pga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51264;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;wL(b);return}function qga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51264;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function rga(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)p=0;else{g=f[i>>2]|0;q=f[o>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,g)|0)+j|0;v=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;x=(Y(f[t+12>>2]|0,g)|0)+j|0;d[b+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[b+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,g)|0)+j|0;w=(Y(f[s+4>>2]|0,g)|0)+j|0;v=(Y(f[s+8>>2]|0,g)|0)+j|0;u=(Y(f[s+12>>2]|0,g)|0)+j|0;s=v;v=w;w=x;x=1;do{t=(f[o+(x<<2)>>2]|0)+(r<<2)|0;y=f[i+(x<<2)>>2]|0;w=(Y(f[t>>2]|0,y)|0)+w|0;v=(Y(f[t+4>>2]|0,y)|0)+v|0;s=(Y(f[t+8>>2]|0,y)|0)+s|0;u=(Y(f[t+12>>2]|0,y)|0)+u|0;x=x+1|0}while((x|0)!=(k|0));d[b+(r<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((r|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((r|2)<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+((r|3)<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){g=f[i>>2]|0;q=f[o>>2]|0;if(m)z=p;else{x=p;while(1){y=(Y(f[q+(x<<2)>>2]|0,g)|0)+j|0;d[b+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}do{x=(Y(f[q+(z<<2)>>2]|0,g)|0)+j|0;y=1;do{x=(Y(f[(f[o+(y<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(y<<2)>>2]|0)|0)+x|0;y=y+1|0}while((y|0)!=(k|0));d[b+(z<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function sga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51264;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function tga(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+76>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=f[a+72>>2]|0;if(!g)return;a=(m|0)<0;q=h+-4|0;r=(h|0)<4;s=h&-4;t=c;c=b+(i<<2)|0;i=g;while(1){i=i+-1|0;g=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(k)if(p){v=a?u:g;w=a?g:u;if(r)x=0;else{y=w;z=v;A=0;do{B=(f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)+j|0;C=A|1;D=(f[y+(C<<2)>>2]|0)-(f[z+(C<<2)>>2]|0)+j|0;d[t+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(C<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;D=A|2;C=(f[y+(D<<2)>>2]|0)-(f[z+(D<<2)>>2]|0)+j|0;B=A|3;E=(f[y+(B<<2)>>2]|0)-(f[z+(B<<2)>>2]|0)+j|0;d[t+(D<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[t+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));x=s}if((x|0)>=(h|0))break;A=w;z=v;y=x;do{E=(f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)+j|0;d[t+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)F=0;else{y=u;z=g;A=0;do{v=(Y((f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)|0,m)|0)+j|0;w=A|1;E=(Y((f[y+(w<<2)>>2]|0)-(f[z+(w<<2)>>2]|0)|0,m)|0)+j|0;d[t+(A<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[t+(w<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;E=A|2;w=(Y((f[y+(E<<2)>>2]|0)-(f[z+(E<<2)>>2]|0)|0,m)|0)+j|0;v=A|3;B=(Y((f[y+(v<<2)>>2]|0)-(f[z+(v<<2)>>2]|0)|0,m)|0)+j|0;d[t+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[t+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));F=s}if((F|0)>=(h|0))break;A=u;z=g;y=F;do{B=(Y((f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)|0,m)|0)+j|0;d[t+(y<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(n){if(r)G=0;else{y=g;z=u;A=0;do{B=(f[y+(A<<2)>>2]|0)+j+(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;v=A|1;w=(f[y+(v<<2)>>2]|0)+j+(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;d[t+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(v<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;w=A|2;v=(f[y+(w<<2)>>2]|0)+j+(f[b+(w<<2)>>2]<<1)+(f[z+(w<<2)>>2]|0)|0;B=A|3;E=(f[y+(B<<2)>>2]|0)+j+(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[t+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[t+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));G=s}if((G|0)>=(h|0))break;A=g;z=u;y=G;while(1){E=(f[A+(y<<2)>>2]|0)+j+(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[t+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0;if((y|0)==(h|0))break a}}if(o){if(r)H=0;else{y=g;z=u;A=0;do{E=(f[y+(A<<2)>>2]|0)+j-(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;B=A|1;v=(f[y+(B<<2)>>2]|0)+j-(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[t+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(B<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;B=(f[y+(v<<2)>>2]|0)+j-(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;E=A|3;w=(f[y+(E<<2)>>2]|0)+j-(f[b+(E<<2)>>2]<<1)+(f[z+(E<<2)>>2]|0)|0;d[t+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));H=s}if((H|0)>=(h|0))break;A=g;z=u;y=H;do{w=(f[A+(y<<2)>>2]|0)+j-(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[t+(y<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)I=0;else{y=g;z=u;A=0;do{w=Y((f[z+(A<<2)>>2]|0)+(f[y+(A<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(A<<2)>>2]|0,l)|0)+j+w|0;w=A|1;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;v=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[t+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;w=Y((f[z+(v<<2)>>2]|0)+(f[y+(v<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(v<<2)>>2]|0,l)|0)+j+w|0;w=A|3;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;C=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[t+(v<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(w<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));I=s}if((I|0)>=(h|0))break;A=g;y=u;z=I;do{C=Y((f[y+(z<<2)>>2]|0)+(f[A+(z<<2)>>2]|0)|0,m)|0;w=(Y(f[b+(z<<2)>>2]|0,l)|0)+j+C|0;d[t+(z<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}}while(0);if(!i)break;else t=t+e|0}return}function uga(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=51264;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){V$(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)U$(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;jR(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=zLc(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)!=4){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(80)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483568;B=g+4|0;f[B>>2]=77;o=z;C=258310;p=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(p|0));D=z+77|0;b[D>>0]=0;vM(-215,g,258388,254608,3251)}if((d|0)==1|(m|0)==1){u=h;return}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(80)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483568;B=g+4|0;f[B>>2]=77;o=z;C=258310;p=o+77|0;do{b[o>>0]=b[C>>0]|0;o=o+1|0;C=C+1|0}while((o|0)<(p|0));D=z+77|0;b[D>>0]=0;vM(-215,g,258388,254608,3251)}}function vga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51264;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function wga(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=c;t=m;u=b;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[s+(w<<1)>>1]=r;d[s+((w|1)<<1)>>1]=r;d[s+((w|2)<<1)>>1]=r;d[s+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=l;y=l;z=l;A=l;B=1;while(1){C=(f[t+(B<<2)>>2]|0)+(x<<2)|0;D=(f[t+(0-B<<2)>>2]|0)+(x<<2)|0;E=f[k+(B<<2)>>2]|0;A=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+A|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;y=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+y|0;w=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+w|0;if((B|0)>=(j|0))break;else B=B+1|0}d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[s+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[s+((x|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+((x|3)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){B=v;while(1){d[s+(B<<1)>>1]=q;B=B+1|0;if((B|0)==(h|0))break b}}else F=v;do{B=l;E=1;while(1){B=(Y((f[(f[t+(E<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[t+(0-E<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(E<<2)>>2]|0)|0)+B|0;if((E|0)>=(j|0))break;else E=E+1|0}d[s+(F<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!u)break;else{s=s+e|0;t=t+4|0;u=u+-1|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=m;m=c;c=b;while(1){c:do if(u)G=0;else{b=f[k>>2]|0;F=f[s>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,b)|0)+l|0;p=(Y(f[q+4>>2]|0,b)|0)+l|0;a=(Y(f[q+8>>2]|0,b)|0)+l|0;x=(Y(f[q+12>>2]|0,b)|0)+l|0;d[m+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[m+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,b)|0)+l|0;a=(Y(f[v+4>>2]|0,b)|0)+l|0;p=(Y(f[v+8>>2]|0,b)|0)+l|0;o=(Y(f[v+12>>2]|0,b)|0)+l|0;v=p;p=a;a=x;x=1;while(1){q=(f[s+(x<<2)>>2]|0)+(H<<2)|0;r=(f[s+(0-x<<2)>>2]|0)+(H<<2)|0;g=f[k+(x<<2)>>2]|0;a=(Y((f[r>>2]|0)+(f[q>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+4>>2]|0)+(f[q+4>>2]|0)|0,g)|0)+p|0;v=(Y((f[r+8>>2]|0)+(f[q+8>>2]|0)|0,g)|0)+v|0;o=(Y((f[r+12>>2]|0)+(f[q+12>>2]|0)|0,g)|0)+o|0;if((x|0)>=(j|0))break;else x=x+1|0}d[m+(H<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((H|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((H|2)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[m+((H|3)<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){b=f[k>>2]|0;F=f[s>>2]|0;if(t){x=G;while(1){B=(Y(f[F+(x<<2)>>2]|0,b)|0)+l|0;d[m+(x<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break d}}else I=G;do{x=(Y(f[F+(I<<2)>>2]|0,b)|0)+l|0;B=1;while(1){x=(Y((f[(f[s+(0-B<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[s+(B<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(B<<2)>>2]|0)|0)+x|0;if((B|0)>=(j|0))break;else B=B+1|0}d[m+(I<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!c)break;else{s=s+4|0;m=m+e|0;c=c+-1|0}}return}}function xga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50352;f[a+12>>2]=51264;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function yga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50352;f[a+12>>2]=51264;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function zga(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Aga(a){a=a|0;cYc(a);return}function Bga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=51144;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){cYc(a);return}wL(b);cYc(a);return}function Cga(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+84>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=a+68|0;q=f[j>>2]|0;if(!g)return;r=(m|0)<0;s=h+-4|0;t=(h|0)<4;u=(f[j+4>>2]|0)+(f[a+80>>2]|0)|0;a=h&-4;j=d;d=c+(i<<2)|0;i=g;while(1){i=i+-1|0;g=f[d+-4>>2]|0;c=f[d>>2]|0;d=d+4|0;v=f[d>>2]|0;a:do if(k)if(p){w=r?v:g;x=r?g:v;if(t)y=0;else{z=x;A=w;B=0;do{C=B|1;D=f[z+(C<<2)>>2]|0;E=f[A+(C<<2)>>2]|0;F=u+(f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+D-E>>q;b[j+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=B|2;C=B|3;E=f[z+(C<<2)>>2]|0;D=f[A+(C<<2)>>2]|0;G=u+(f[z+(F<<2)>>2]|0)-(f[A+(F<<2)>>2]|0)>>q;b[j+F>>0]=G>>>0<256?G:(G|0)>0?255:0;G=u+E-D>>q;b[j+C>>0]=G>>>0<256?G:(G|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));y=a}if((y|0)>=(h|0))break;B=x;A=w;z=y;do{G=u+(f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=G>>>0<256?G:(G|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)H=0;else{z=v;A=g;B=0;do{w=Y((f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)|0,m)|0;x=B|1;G=Y((f[z+(x<<2)>>2]|0)-(f[A+(x<<2)>>2]|0)|0,m)|0;C=u+w>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+G>>q;b[j+x>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;x=Y((f[z+(C<<2)>>2]|0)-(f[A+(C<<2)>>2]|0)|0,m)|0;G=B|3;w=Y((f[z+(G<<2)>>2]|0)-(f[A+(G<<2)>>2]|0)|0,m)|0;D=u+x>>q;b[j+C>>0]=D>>>0<256?D:(D|0)>0?255:0;D=u+w>>q;b[j+G>>0]=D>>>0<256?D:(D|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));H=a}if((H|0)>=(h|0))break;B=v;A=g;z=H;do{D=u+(Y((f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)|0,m)|0)>>q;b[j+z>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(n){if(t)I=0;else{z=g;A=v;B=0;do{D=B|1;G=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;C=f[A+(D<<2)>>2]|0;x=u+(f[z+(B<<2)>>2]|0)+(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+G+w+C>>q;b[j+D>>0]=x>>>0<256?x:(x|0)>0?255:0;x=B|2;D=B|3;C=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;G=f[A+(D<<2)>>2]|0;E=u+(f[z+(x<<2)>>2]|0)+(f[c+(x<<2)>>2]<<1)+(f[A+(x<<2)>>2]|0)>>q;b[j+x>>0]=E>>>0<256?E:(E|0)>0?255:0;E=u+C+w+G>>q;b[j+D>>0]=E>>>0<256?E:(E|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));I=a}if((I|0)>=(h|0))break;B=g;A=v;z=I;while(1){E=u+(f[B+(z<<2)>>2]|0)+(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=E>>>0<256?E:(E|0)>0?255:0;z=z+1|0;if((z|0)==(h|0))break a}}if(o){if(t)J=0;else{z=g;A=v;B=0;do{E=B|1;D=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;w=f[A+(E<<2)>>2]|0;C=u+(f[z+(B<<2)>>2]|0)-(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+D-G+w>>q;b[j+E>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;E=B|3;w=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;D=f[A+(E<<2)>>2]|0;x=u+(f[z+(C<<2)>>2]|0)-(f[c+(C<<2)>>2]<<1)+(f[A+(C<<2)>>2]|0)>>q;b[j+C>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+w-G+D>>q;b[j+E>>0]=x>>>0<256?x:(x|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));J=a}if((J|0)>=(h|0))break;B=g;A=v;z=J;do{x=u+(f[B+(z<<2)>>2]|0)-(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=x>>>0<256?x:(x|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)K=0;else{z=g;A=v;B=0;do{x=Y((f[A+(B<<2)>>2]|0)+(f[z+(B<<2)>>2]|0)|0,m)|0;E=Y(f[c+(B<<2)>>2]|0,l)|0;D=B|1;G=Y((f[A+(D<<2)>>2]|0)+(f[z+(D<<2)>>2]|0)|0,m)|0;w=Y(f[c+(D<<2)>>2]|0,l)|0;C=u+E+x>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+w+G>>q;b[j+D>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;D=Y((f[A+(C<<2)>>2]|0)+(f[z+(C<<2)>>2]|0)|0,m)|0;G=Y(f[c+(C<<2)>>2]|0,l)|0;w=B|3;x=Y((f[A+(w<<2)>>2]|0)+(f[z+(w<<2)>>2]|0)|0,m)|0;E=Y(f[c+(w<<2)>>2]|0,l)|0;F=u+G+D>>q;b[j+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+E+x>>q;b[j+w>>0]=F>>>0<256?F:(F|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));K=a}if((K|0)>=(h|0))break;B=g;z=v;A=K;do{F=Y((f[z+(A<<2)>>2]|0)+(f[B+(A<<2)>>2]|0)|0,m)|0;w=u+(Y(f[c+(A<<2)>>2]|0,l)|0)+F>>q;b[j+A>>0]=w>>>0<256?w:(w|0)>0?255:0;A=A+1|0}while((A|0)!=(h|0))}}while(0);if(!i)break;else j=j+e|0}return}function Dga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50324;f[a+12>>2]=51144;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Ega(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50324;f[a+12>>2]=51144;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Fga(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Gga(a){a=a|0;cYc(a);return}function Hga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50296;f[a+16>>2]=50712;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function Iga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50296;f[a+16>>2]=50712;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Jga(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Kga(a){a=a|0;cYc(a);return}function Lga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50268;f[a+12>>2]=50760;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Mga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50268;f[a+12>>2]=50760;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Nga(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Oga(a){a=a|0;cYc(a);return}function Pga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50240;f[a+16>>2]=50808;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function Qga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50240;f[a+16>>2]=50808;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Rga(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Sga(a){a=a|0;cYc(a);return}function Tga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50212;f[a+12>>2]=50856;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function Uga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50212;f[a+12>>2]=50856;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Vga(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Wga(a){a=a|0;cYc(a);return}function Xga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50184;f[a+16>>2]=50952;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function Yga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50184;f[a+16>>2]=50952;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function Zga(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function _ga(a){a=a|0;cYc(a);return}function $ga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50156;f[a+12>>2]=51e3;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function aha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50156;f[a+12>>2]=51e3;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function bha(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function cha(a){a=a|0;cYc(a);return}function dha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50128;f[a+16>>2]=51048;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);return}wL(b);NXc(a);return}function eha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50128;f[a+16>>2]=51048;b=a+28|0;c=a+64|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+44|0;b=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+68>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+72>>2]|0;if((b|0)==(a+76|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function fha(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function gha(a){a=a|0;cYc(a);return}function hha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50100;f[a+12>>2]=51096;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function iha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50100;f[a+12>>2]=51096;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function jha(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function kha(a){a=a|0;cYc(a);return}function lha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50072;f[a+12>>2]=51144;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);return}wL(b);NXc(a);return}function mha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=50072;f[a+12>>2]=51144;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){NXc(a);cYc(a);return}wL(b);NXc(a);cYc(a);return}function nha(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function oha(a){a=a|0;cYc(a);return}function pha(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0;m=u;u=u+288|0;n=m+232|0;o=m+176|0;p=m+120|0;q=m+112|0;r=m+104|0;s=m+48|0;t=m+32|0;v=m+16|0;w=m;do if((eS(e)|0)==65536){x=f[e+4>>2]|0;f[n>>2]=f[x>>2];y=n+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[n+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;U$(n,x);break}}else bS(n,e,-1);while(0);do if((eS(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];x=o+4|0;y=e+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];A=f[e+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;C=o+44|0;f[C>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[e+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(o,e);break}}else bS(o,g,-1);while(0);g=c&4095;e=d&4095;x=c&7;y=d&7;z=c>>>3&511;if((z|0)!=(d>>>3&511|0)){f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;d=$Xc(32)|0;f[p>>2]=d;f[p+8>>2]=-2147483616;f[p+4>>2]=25;D=d;c=261452;E=D+25|0;do{b[D>>0]=b[c>>0]|0;D=D+1|0;c=c+1|0}while((D|0)<(E|0));b[d+25>>0]=0;vM(-215,p,261478,254608,3755)}d=n+8|0;c=o+8|0;C=o+12|0;A=(f[c>>2]|0)+-1+(f[C>>2]|0)|0;B=f[h>>2]|0;if((B|0)<0){F=((f[d>>2]|0)+-1+(f[n+12>>2]|0)|0)/2|0;f[h>>2]=F;G=F}else G=B;B=h+4|0;if((f[B>>2]|0)<0)f[B>>2]=(A|0)/2|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;A=(f[d>>2]|0)==1;f[q>>2]=A?G:0;f[q+4>>2]=A?0:G;G=$ba(p,q)|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=o;q=(f[c>>2]|0)==1;A=f[B>>2]|0;f[r>>2]=q?A:0;f[r+4>>2]=q?0:A;A=$ba(p,r)|0;f[p>>2]=1124007936;r=p+4|0;q=p+8|0;F=p+40|0;D=r;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[F>>2]=q;H=p+48|0;I=p+44|0;f[I>>2]=H;f[H>>2]=0;f[p+52>>2]=0;f[s>>2]=1124007936;J=s+4|0;K=s+8|0;L=s+40|0;D=J;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[L>>2]=K;D=s+48|0;E=s+44|0;f[E>>2]=D;f[D>>2]=0;f[s+52>>2]=0;M=x>>>0<y>>>0?y:x;N=(M|0)>5?M:5;do if(!x){M=(y|0)==0;if(!((G|0)==5&(A|0)==5&M)){if((G&3|0)==0|(A&3|0)==0){O=26;break}if(!((G&8&A|0)!=0&(y|0)==3)){O=26;break}}P=M?8:0;M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;Q=+(1<<P|0);dY(n,t,4,Q,0.0);M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;dY(o,t,4,Q,0.0);M=P<<1;R=M;S=4;T=+(1<<M|0)*i}else O=26;while(0);do if((O|0)==26){if((f[n>>2]&4095|0)==(N|0)){y=n+36|0;x=f[y>>2]|0;if(x){M=x+12|0;f[M>>2]=(f[M>>2]|0)+1;M=p+36|0;x=f[M>>2]|0;if((x|0)!=0?(P=x+12|0,x=f[P>>2]|0,f[P>>2]=x+-1,(x|0)==1):0){V$(p);U=M}else U=M}else U=p+36|0;f[U>>2]=0;M=p+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[r>>2]|0)>0){x=f[F>>2]|0;P=0;do{f[x+(P<<2)>>2]=0;P=P+1|0;V=f[r>>2]|0}while((P|0)<(V|0));f[p>>2]=f[n>>2];if((V|0)<3)O=38;else O=40}else{f[p>>2]=f[n>>2];O=38}if((O|0)==38){P=f[n+4>>2]|0;if((P|0)<3){f[r>>2]=P;f[q>>2]=f[d>>2];f[p+12>>2]=f[n+12>>2];P=f[n+44>>2]|0;x=f[I>>2]|0;f[x>>2]=f[P>>2];f[x+4>>2]=f[P+4>>2]}else O=40}if((O|0)==40)U$(p,n);f[M>>2]=f[n+16>>2];f[p+20>>2]=f[n+20>>2];f[p+24>>2]=f[n+24>>2];f[p+28>>2]=f[n+28>>2];f[p+32>>2]=f[n+32>>2];f[U>>2]=f[y>>2]}else{P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;dY(n,t,N,1.0,0.0)}if((f[o>>2]&4095|0)!=(N|0)){P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;dY(o,t,N,1.0,0.0);R=0;S=N;T=i;break}P=o+36|0;x=f[P>>2]|0;if(x|0){W=x+12|0;f[W>>2]=(f[W>>2]|0)+1}W=s+36|0;x=f[W>>2]|0;if(x|0?(X=x+12|0,x=f[X>>2]|0,f[X>>2]=x+-1,(x|0)==1):0)V$(s);f[W>>2]=0;x=s+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[J>>2]|0)>0){X=f[L>>2]|0;Y=0;do{f[X+(Y<<2)>>2]=0;Y=Y+1|0;Z=f[J>>2]|0}while((Y|0)<(Z|0));f[s>>2]=f[o>>2];if((Z|0)<3)O=54;else O=56}else{f[s>>2]=f[o>>2];O=54}if((O|0)==54){Y=f[o+4>>2]|0;if((Y|0)<3){f[J>>2]=Y;f[K>>2]=f[c>>2];f[s+12>>2]=f[C>>2];Y=f[o+44>>2]|0;X=f[E>>2]|0;f[X>>2]=f[Y>>2];f[X+4>>2]=f[Y+4>>2]}else O=56}if((O|0)==56)U$(s,o);f[x>>2]=f[o+16>>2];f[s+20>>2]=f[o+20>>2];f[s+24>>2]=f[o+24>>2];f[s+28>>2]=f[o+28>>2];f[s+32>>2]=f[o+32>>2];f[W>>2]=f[P>>2];R=0;S=N;T=i}while(0);N=S&7|z<<3;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=p;aca(t,g,N,v,f[h>>2]|0,G);f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=s;Xda(v,N,e,w,f[B>>2]|0,A,T,R);R=$Xc(200)|0;f[w>>2]=0;f[w+4>>2]=0;Zba(R,w,t,v,g,e,N,j,k,l);f[a>>2]=R;l=$Xc(16)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=51336;f[l+12>>2]=R;f[a+4>>2]=l;l=f[v+4>>2]|0;if(l|0)UXc(l);l=f[t+4>>2]|0;if(l|0)UXc(l);l=s+36|0;t=f[l>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)V$(s);f[l>>2]=0;l=s+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[J>>2]|0)>0){l=f[L>>2]|0;L=0;do{f[l+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[J>>2]|0))}J=f[E>>2]|0;if((J|0)!=(D|0))wL(J);J=p+36|0;D=f[J>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)V$(p);f[J>>2]=0;J=p+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[r>>2]|0)>0){J=f[F>>2]|0;F=0;do{f[J+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[r>>2]|0))}r=f[I>>2]|0;if((r|0)!=(H|0))wL(r);r=o+36|0;H=f[r>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)V$(o);f[r>>2]=0;r=o+16|0;H=o+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[H>>2]|0)>0){r=f[o+40>>2]|0;I=0;do{f[r+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[o+44>>2]|0;if((H|0)!=(o+48|0))wL(H);H=n+36|0;o=f[H>>2]|0;if(o|0?(I=o+12|0,o=f[I>>2]|0,f[I>>2]=o+-1,(o|0)==1):0)V$(n);f[H>>2]=0;H=n+16|0;o=n+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[o>>2]|0)>0){H=f[n+40>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)==(n+48|0)){u=m;return}wL(o);u=m;return}function qha(a){a=a|0;NXc(a);cYc(a);return}function rha(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function sha(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==261506?a+12|0:0)|0}function tha(a){a=a|0;cYc(a);return}function uha(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;h=jP(g)|0;i=f[a>>2]|0;j=(h|0)==0?1:h;h=i&65535;switch(h&4095){case 0:case 4:case 5:case 6:break;default:{k=$Xc(80)|0;f[g>>2]=k;f[g+8>>2]=-2147483568;f[g+4>>2]=71;l=k;m=261649;o=l+71|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+71>>0]=0;vM(-215,g,261721,254608,3822)}}g=c+4|0;k=f[g>>2]|0;m=f[c>>2]|0;l=k-m>>3;o=m;m=k;if(j>>>0<=l>>>0){if(j>>>0<l>>>0?(k=o+(j<<3)|0,(m|0)!=(k|0)):0)f[g>>2]=m+(~((m+-8-k|0)>>>3)<<3)}else pP(c,j-l|0);l=Y(Y((i>>>3&511)+1|0,j)|0,675553809>>>(i<<2&28)&15)|0;i=d+4|0;j=f[i>>2]|0;k=f[d>>2]|0;m=j-k|0;g=k;k=j;if(l>>>0<=m>>>0)if(l>>>0<m>>>0?(j=g+l|0,(k|0)!=(j|0)):0){f[i>>2]=j;q=g}else q=g;else{zS(d,l-m|0);q=f[d>>2]|0}d=a+8|0;if((f[d>>2]|0)<=0){u=e;return}m=a+16|0;l=a+44|0;g=a+12|0;a=(h&4095)==0;j=0;i=0;k=f[g>>2]|0;while(1){o=(f[m>>2]|0)+(Y(f[f[l>>2]>>2]|0,j)|0)|0;a:do if((k|0)>0){if(a){r=0;s=i;t=k;while(1){v=b[o+r>>0]|0;if(!(v<<24>>24)){w=s;x=t}else{y=f[c>>2]|0;f[y+(s<<3)>>2]=r;f[y+(s<<3)+4>>2]=j;b[q+s>>0]=v;w=s+1|0;x=f[g>>2]|0}r=r+1|0;if((r|0)>=(x|0)){z=w;A=x;break a}else{s=w;t=x}}}t=f[c>>2]|0;s=0;r=i;v=k;while(1){switch(h&4095){case 5:{B=+n[o+(s<<2)>>2];if(B==0.0){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=j;n[q+(r<<2)>>2]=B;C=r+1|0;D=v}break}case 4:{y=f[o+(s<<2)>>2]|0;if(!y){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=j;f[q+(r<<2)>>2]=y;C=r+1|0;D=f[g>>2]|0}break}default:{B=+p[o+(s<<3)>>3];if(B==0.0){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=j;p[q+(r<<3)>>3]=B;C=r+1|0;D=v}}}s=s+1|0;if((s|0)>=(D|0)){z=C;A=D;break a}else{r=C;v=D}}}else{z=i;A=k}while(0);j=j+1|0;if((j|0)>=(f[d>>2]|0))break;else{i=z;k=A}}u=e;return}function vha(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=u;u=u+144|0;k=j;l=j+120|0;m=j+137|0;n=j+136|0;o=j+64|0;p=j+8|0;do if((eS(e)|0)==65536){q=f[e+4>>2]|0;f[o>>2]=f[q>>2];r=o+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=o+8|0;f[t>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2];f[o+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[o+36>>2]=v;f[o+40>>2]=t;t=o+48|0;w=o+44|0;f[w>>2]=t;f[t>>2]=0;f[o+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];x=o;break}else{f[r>>2]=0;U$(o,q);x=o;break}}else{bS(o,e,-1);x=o}while(0);e=c&7;q=d&7;if(q>>>0<e>>>0|((d^c)&4088|0)!=0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;r=$Xc(48)|0;f[l>>2]=r;f[l+8>>2]=-2147483600;f[l+4>>2]=44;y=r;z=261740;A=y+44|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[r+44>>0]=0;vM(-215,l,261785,254608,4428)}r=f[g>>2]|0;s=g+4|0;t=f[s>>2]|0;w=o+40|0;v=f[w>>2]|0;B=f[v+4>>2]|0;C=f[v>>2]|0;v=(r|0)==-1?(B|0)/2|0:r;r=(t|0)==-1?(C|0)/2|0:t;if(!((v|0)>-1&(v|0)<(B|0))){D=$Xc(64)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483584;F=l+4|0;f[F>>2]=52;y=D;z=362293;A=y+52|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));G=D+52|0;b[G>>0]=0;vM(-215,l,362346,362362,363)}if((r|0)<0|(r|0)>=(C|0)){D=$Xc(64)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483584;F=l+4|0;f[F>>2]=52;y=D;z=362293;A=y+52|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));G=D+52|0;b[G>>0]=0;vM(-215,l,362346,362362,363)}f[g>>2]=v;f[s>>2]=r;r=(e|0)==6;v=(q|0)==6;G=r|v?6:5;f[p>>2]=1124007936;D=p+4|0;z=p+8|0;F=p+40|0;y=D;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[F>>2]=z;y=p+48|0;A=p+44|0;f[A>>2]=y;f[y>>2]=0;f[p+52>>2]=0;E=f[x>>2]&4095;if((E|0)==(G|0)){C=o+36|0;B=f[C>>2]|0;if(B){t=B+12|0;f[t>>2]=(f[t>>2]|0)+1;t=p+36|0;B=f[t>>2]|0;if((B|0)!=0?(H=B+12|0,B=f[H>>2]|0,f[H>>2]=B+-1,(B|0)==1):0){V$(p);I=t}else I=t}else I=p+36|0;f[I>>2]=0;t=p+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[D>>2]|0)>0){B=f[F>>2]|0;H=0;do{f[B+(H<<2)>>2]=0;H=H+1|0;J=f[D>>2]|0}while((H|0)<(J|0));f[p>>2]=f[x>>2];if((J|0)<3)K=24;else K=26}else{f[p>>2]=f[x>>2];K=24}if((K|0)==24){x=f[o+4>>2]|0;if((x|0)<3){f[D>>2]=x;f[z>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];z=f[o+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2]}else K=26}if((K|0)==26)U$(p,o);f[t>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];f[I>>2]=f[C>>2]}else{C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=p;dY(o,l,G,(E|0)==4?1.0/+(1<<i|0):1.0,0.0)}i=(e|0)==0;do if((d|c)&7){E=(q|0)==2;if(i&E){G=f[g>>2]|0;C=f[s>>2]|0;I=$Xc(76)|0;f[I+4>>2]=0;f[I+8>>2]=0;f[I>>2]=51392;t=I+12|0;f[l>>2]=G;f[l+4>>2]=C;xha(t,p,l,h,m,n);f[a>>2]=t;f[a+4>>2]=I;break}I=(q|0)==3;if(i&I){t=f[g>>2]|0;C=f[s>>2]|0;G=$Xc(76)|0;f[G+4>>2]=0;f[G+8>>2]=0;f[G>>2]=51420;K=G+12|0;f[l>>2]=t;f[l+4>>2]=C;yha(K,p,l,h,m,n);f[a>>2]=K;f[a+4>>2]=G;break}G=(q|0)==5;if(i&G){K=f[g>>2]|0;C=f[s>>2]|0;t=$Xc(76)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=51448;z=t+12|0;f[l>>2]=K;f[l+4>>2]=C;zha(z,p,l,h,m,n);f[a>>2]=z;f[a+4>>2]=t;break}if(i&v){t=f[g>>2]|0;z=f[s>>2]|0;C=$Xc(88)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=51476;K=C+16|0;f[l>>2]=t;f[l+4>>2]=z;Aha(K,p,l,h,m,n);f[a>>2]=K;f[a+4>>2]=C;break}C=(e|0)==2;if(C&E){E=f[g>>2]|0;K=f[s>>2]|0;z=$Xc(76)|0;f[z+4>>2]=0;f[z+8>>2]=0;f[z>>2]=51504;t=z+12|0;f[l>>2]=E;f[l+4>>2]=K;Bha(t,p,l,h,m,n);f[a>>2]=t;f[a+4>>2]=z;break}if(C&G){z=f[g>>2]|0;t=f[s>>2]|0;K=$Xc(76)|0;f[K+4>>2]=0;f[K+8>>2]=0;f[K>>2]=51532;E=K+12|0;f[l>>2]=z;f[l+4>>2]=t;Cha(E,p,l,h,m,n);f[a>>2]=E;f[a+4>>2]=K;break}if(C&v){C=f[g>>2]|0;K=f[s>>2]|0;E=$Xc(88)|0;f[E+4>>2]=0;f[E+8>>2]=0;f[E>>2]=51560;t=E+16|0;f[l>>2]=C;f[l+4>>2]=K;Dha(t,p,l,h,m,n);f[a>>2]=t;f[a+4>>2]=E;break}E=(e|0)==3;if(E&I){I=f[g>>2]|0;t=f[s>>2]|0;K=$Xc(76)|0;f[K+4>>2]=0;f[K+8>>2]=0;f[K>>2]=51588;C=K+12|0;f[l>>2]=I;f[l+4>>2]=t;Eha(C,p,l,h,m,n);f[a>>2]=C;f[a+4>>2]=K;break}if(E&G){K=f[g>>2]|0;C=f[s>>2]|0;t=$Xc(76)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=51616;I=t+12|0;f[l>>2]=K;f[l+4>>2]=C;Fha(I,p,l,h,m,n);f[a>>2]=I;f[a+4>>2]=t;break}if(E&v){E=f[g>>2]|0;t=f[s>>2]|0;I=$Xc(88)|0;f[I+4>>2]=0;f[I+8>>2]=0;f[I>>2]=51644;C=I+16|0;f[l>>2]=E;f[l+4>>2]=t;Gha(C,p,l,h,m,n);f[a>>2]=C;f[a+4>>2]=I;break}if((e|0)==5&G){G=f[g>>2]|0;I=f[s>>2]|0;C=$Xc(76)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=51672;t=C+12|0;f[l>>2]=G;f[l+4>>2]=I;Hha(t,p,l,h,m,n);f[a>>2]=t;f[a+4>>2]=C;break}if(r&v){C=f[g>>2]|0;t=f[s>>2]|0;I=$Xc(88)|0;f[I+4>>2]=0;f[I+8>>2]=0;f[I>>2]=51700;G=I+16|0;f[l>>2]=C;f[l+4>>2]=t;Iha(G,p,l,h,m,n);f[a>>2]=G;f[a+4>>2]=I;break}else{f[k>>2]=c;f[k+4>>2]=d;DM(l,261801,k);vM(-213,l,261785,254608,4493)}}else{I=f[g>>2]|0;G=f[s>>2]|0;t=$Xc(76)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=51364;C=t+12|0;f[l>>2]=I;f[l+4>>2]=G;wha(C,p,l,h,m,n);f[a>>2]=C;f[a+4>>2]=t}while(0);a=p+36|0;n=f[a>>2]|0;if(n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)V$(p);f[a>>2]=0;a=p+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[D>>2]|0)>0){a=f[F>>2]|0;F=0;do{f[a+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[A>>2]|0;if((D|0)!=(y|0))wL(D);D=o+36|0;y=f[D>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)V$(o);f[D>>2]=0;D=o+16|0;y=o+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[y>>2]|0)>0){D=f[w>>2]|0;w=0;do{f[D+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[y>>2]|0))}y=f[o+44>>2]|0;if((y|0)==(o+48|0)){u=j;return}wL(y);u=j;return}function wha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=52016;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function xha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51992;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function yha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51968;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function zha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51944;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Aha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51920;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;o=a;r=261878;q=o+36|0;do{b[o>>0]=b[r>>0]|0;o=o+1|0;r=r+1|0}while((o|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Bha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51896;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Cha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51872;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Dha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51848;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;o=a;r=261878;q=o+36|0;do{b[o>>0]=b[r>>0]|0;o=o+1|0;r=r+1|0}while((o|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Eha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51824;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Fha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51800;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Gha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51776;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;o=a;r=261878;q=o+36|0;do{b[o>>0]=b[r>>0]|0;o=o+1|0;r=r+1|0}while((o|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Hha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51752;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;p=a;r=261878;q=p+36|0;do{b[p>>0]=b[r>>0]|0;p=p+1|0;r=r+1|0}while((p|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Iha(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=51728;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=$Xc(48)|0;f[g>>2]=a;f[g+8>>2]=-2147483600;f[g+4>>2]=36;o=a;r=261878;q=o+36|0;do{b[o>>0]=b[r>>0]|0;o=o+1|0;r=r+1|0}while((o|0)<(q|0));b[a+36>>0]=0;vM(-215,g,261915,254608,3883)}uha(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Vba(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function Jha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51728;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function Kha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51728;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function Lha(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+p[a+56>>3];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;n=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=n+-4|0;o=(n|0)<4;q=n&-4;r=b;b=c;c=e;while(1){if(g){e=0;do{s=(f[r+(f[j+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(e<<3)>>2]|0,h)|0)<<3)|0;f[l+(e<<2)>>2]=s;e=e+1|0}while((e|0)<(a|0))}a:do if(o)t=0;else{if(g)u=0;else{e=0;while(1){p[b+(e<<3)>>3]=i;p[b+((e|1)<<3)>>3]=i;p[b+((e|2)<<3)>>3]=i;p[b+((e|3)<<3)>>3]=i;e=e+4|0;if((e|0)>(m|0)){t=q;break a}}}do{v=i;w=i;x=i;y=i;e=0;do{s=(f[l+(e<<2)>>2]|0)+(u<<3)|0;z=+p[k+(e<<3)>>3];y=y+z*+p[s>>3];x=x+z*+p[s+8>>3];w=w+z*+p[s+16>>3];v=v+z*+p[s+24>>3];e=e+1|0}while((e|0)<(a|0));p[b+(u<<3)>>3]=y;p[b+((u|1)<<3)>>3]=x;p[b+((u|2)<<3)>>3]=w;p[b+((u|3)<<3)>>3]=v;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(n|0)){if(g)A=t;else{e=t;while(1){p[b+(e<<3)>>3]=i;e=e+1|0;if((e|0)==(n|0))break b}}do{z=i;e=0;do{z=z+ +p[k+(e<<3)>>3]*+p[(f[l+(e<<2)>>2]|0)+(A<<3)>>3];e=e+1|0}while((e|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(n|0))}while(0);if((c|0)>1){r=r+4|0;b=b+d|0;c=c+-1|0}else break}return}function Mha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51700;f[a+16>>2]=51728;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function Nha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51700;f[a+16>>2]=51728;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Oha(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Pha(a){a=a|0;cYc(a);return}function Qha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51752;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function Rha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51752;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function Sha(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+n[a+56>>2];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=o+-4|0;p=(o|0)<4;q=o&-4;r=b;b=c;c=e;while(1){if(g){e=0;do{s=(f[r+(f[j+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(e<<3)>>2]|0,h)|0)<<2)|0;f[l+(e<<2)>>2]=s;e=e+1|0}while((e|0)<(a|0))}a:do if(p)t=0;else{if(g)u=0;else{e=0;while(1){n[b+(e<<2)>>2]=i;n[b+((e|1)<<2)>>2]=i;n[b+((e|2)<<2)>>2]=i;n[b+((e|3)<<2)>>2]=i;e=e+4|0;if((e|0)>(m|0)){t=q;break a}}}do{v=i;w=i;x=i;y=i;e=0;do{s=(f[l+(e<<2)>>2]|0)+(u<<2)|0;z=+n[k+(e<<2)>>2];y=y+z*+n[s>>2];x=x+z*+n[s+4>>2];w=w+z*+n[s+8>>2];v=v+z*+n[s+12>>2];e=e+1|0}while((e|0)<(a|0));n[b+(u<<2)>>2]=y;n[b+((u|1)<<2)>>2]=x;n[b+((u|2)<<2)>>2]=w;n[b+((u|3)<<2)>>2]=v;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(o|0)){if(g)A=t;else{e=t;while(1){n[b+(e<<2)>>2]=i;e=e+1|0;if((e|0)==(o|0))break b}}do{z=i;e=0;do{z=z+ +n[k+(e<<2)>>2]*+n[(f[l+(e<<2)>>2]|0)+(A<<2)>>2];e=e+1|0}while((e|0)<(a|0));n[b+(A<<2)>>2]=z;A=A+1|0}while((A|0)!=(o|0))}while(0);if((c|0)>1){r=r+4|0;b=b+d|0;c=c+-1|0}else break}return}function Tha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51672;f[a+12>>2]=51752;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function Uha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51672;f[a+12>>2]=51752;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Vha(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Wha(a){a=a|0;cYc(a);return}function Xha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51776;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function Yha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51776;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function Zha(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,h)|0;if((g|0)<=0)return;h=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=0;while(1){p[b+(g<<3)>>3]=j;p[b+((g|1)<<3)>>3]=j;p[b+((g|2)<<3)>>3]=j;p[b+((g|3)<<3)>>3]=j;g=g+4|0;if((g|0)>(n|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+p[l+(g<<3)>>3];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(h)B=u;else{g=u;while(1){p[b+(g<<3)>>3]=j;g=g+1|0;if((g|0)==(o|0))break b}}do{A=j;g=0;do{A=A+ +p[l+(g<<3)>>3]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function _ha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51644;f[a+16>>2]=51776;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function $ha(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51644;f[a+16>>2]=51776;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function aia(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function bia(a){a=a|0;cYc(a);return}function cia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51800;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function dia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51800;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function eia(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=0;while(1){n[b+(g<<2)>>2]=j;n[b+((g|1)<<2)>>2]=j;n[b+((g|2)<<2)>>2]=j;n[b+((g|3)<<2)>>2]=j;g=g+4|0;if((g|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+n[l+(g<<2)>>2];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{g=u;while(1){n[b+(g<<2)>>2]=j;g=g+1|0;if((g|0)==(p|0))break b}}do{A=j;g=0;do{A=A+ +n[l+(g<<2)>>2]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function fia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51616;f[a+12>>2]=51800;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function gia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51616;f[a+12>>2]=51800;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function hia(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function iia(a){a=a|0;cYc(a);return}function jia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51824;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function kia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51824;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function lia(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=ALc(j)|0;t=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=0;while(1){d[b+(g<<1)>>1]=t;d[b+((g|1)<<1)>>1]=t;d[b+((g|2)<<1)>>1]=t;d[b+((g|3)<<1)>>1]=t;g=g+4|0;if((g|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+n[l+(g<<2)>>2];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(z)|0;d[b+(v<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=ALc(y)|0;d[b+((v|1)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=ALc(x)|0;d[b+((v|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=ALc(w)|0;d[b+((v|3)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{g=ALc(j)|0;t=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=u;while(1){d[b+(g<<1)>>1]=t;g=g+1|0;if((g|0)==(p|0))break b}}do{A=j;g=0;do{A=A+ +n[l+(g<<2)>>2]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(A)|0;d[b+(B<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function mia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51588;f[a+12>>2]=51824;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function nia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51588;f[a+12>>2]=51824;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function oia(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function pia(a){a=a|0;cYc(a);return}function qia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51848;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function ria(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51848;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function sia(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(e<<3)>>2]|0,h)|0)<<1)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){p[b+(e<<3)>>3]=i;p[b+((e|1)<<3)>>3]=i;p[b+((e|2)<<3)>>3]=i;p[b+((e|3)<<3)>>3]=i;e=e+4|0;if((e|0)>(n|0)){u=r;break a}}}do{w=i;x=i;y=i;z=i;e=0;do{t=(f[m+(e<<2)>>2]|0)+(v<<1)|0;A=+p[l+(e<<3)>>3];z=z+A*+(j[t>>1]|0);y=y+A*+(j[t+2>>1]|0);x=x+A*+(j[t+4>>1]|0);w=w+A*+(j[t+6>>1]|0);e=e+1|0}while((e|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{e=u;while(1){p[b+(e<<3)>>3]=i;e=e+1|0;if((e|0)==(o|0))break b}}do{A=i;e=0;do{A=A+ +p[l+(e<<3)>>3]*+(j[(f[m+(e<<2)>>2]|0)+(B<<1)>>1]|0);e=e+1|0}while((e|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function tia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51560;f[a+16>>2]=51848;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function uia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51560;f[a+16>>2]=51848;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function via(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function wia(a){a=a|0;cYc(a);return}function xia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51872;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function yia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51872;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function zia(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(h,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(e<<3)>>2]|0,h)|0)<<1)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){n[b+(e<<2)>>2]=i;n[b+((e|1)<<2)>>2]=i;n[b+((e|2)<<2)>>2]=i;n[b+((e|3)<<2)>>2]=i;e=e+4|0;if((e|0)>(o|0)){u=r;break a}}}do{w=i;x=i;y=i;z=i;e=0;do{t=(f[m+(e<<2)>>2]|0)+(v<<1)|0;A=+n[l+(e<<2)>>2];z=z+A*+(j[t>>1]|0);y=y+A*+(j[t+2>>1]|0);x=x+A*+(j[t+4>>1]|0);w=w+A*+(j[t+6>>1]|0);e=e+1|0}while((e|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{e=u;while(1){n[b+(e<<2)>>2]=i;e=e+1|0;if((e|0)==(p|0))break b}}do{A=i;e=0;do{A=A+ +n[l+(e<<2)>>2]*+(j[(f[m+(e<<2)>>2]|0)+(B<<1)>>1]|0);e=e+1|0}while((e|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function Aia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51532;f[a+12>>2]=51872;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function Bia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51532;f[a+12>>2]=51872;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Cia(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Dia(a){a=a|0;cYc(a);return}function Eia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51896;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function Fia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51896;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function Gia(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(i,h)|0;if((g|0)<=0)return;h=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(h){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[l+(g<<3)>>2]|0,i)|0)<<1)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(h)w=0;else{g=ALc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+(w<<1)|0;B=+n[m+(g<<2)>>2];A=A+B*+(j[u>>1]|0);z=z+B*+(j[u+2>>1]|0);y=y+B*+(j[u+4>>1]|0);x=x+B*+(j[u+6>>1]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(A)|0;d[b+(w<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=ALc(z)|0;d[b+((w|1)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=ALc(y)|0;d[b+((w|2)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=ALc(x)|0;d[b+((w|3)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(h)C=v;else{g=ALc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(j[(f[o+(g<<2)>>2]|0)+(C<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(B)|0;d[b+(C<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function Hia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51504;f[a+12>>2]=51896;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function Iia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51504;f[a+12>>2]=51896;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Jia(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Kia(a){a=a|0;cYc(a);return}function Lia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51920;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function Mia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51920;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function Nia(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(e<<3)>>2]|0,i)|0)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){p[b+(e<<3)>>3]=j;p[b+((e|1)<<3)>>3]=j;p[b+((e|2)<<3)>>3]=j;p[b+((e|3)<<3)>>3]=j;e=e+4|0;if((e|0)>(n|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;e=0;do{t=(f[m+(e<<2)>>2]|0)+v|0;A=+p[l+(e<<3)>>3];z=z+A*+(h[t>>0]|0);y=y+A*+(h[t+1>>0]|0);x=x+A*+(h[t+2>>0]|0);w=w+A*+(h[t+3>>0]|0);e=e+1|0}while((e|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{e=u;while(1){p[b+(e<<3)>>3]=j;e=e+1|0;if((e|0)==(o|0))break b}}do{A=j;e=0;do{A=A+ +p[l+(e<<3)>>3]*+(h[(f[m+(e<<2)>>2]|0)+B>>0]|0);e=e+1|0}while((e|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function Oia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51476;f[a+16>>2]=51920;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function Pia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51476;f[a+16>>2]=51920;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+48>>2]|0;if(b|0){d=a+52|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+36>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Qia(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Ria(a){a=a|0;cYc(a);return}function Sia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51944;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function Tia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51944;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function Uia(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(e<<3)>>2]|0,i)|0)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){n[b+(e<<2)>>2]=j;n[b+((e|1)<<2)>>2]=j;n[b+((e|2)<<2)>>2]=j;n[b+((e|3)<<2)>>2]=j;e=e+4|0;if((e|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;e=0;do{t=(f[m+(e<<2)>>2]|0)+v|0;A=+n[l+(e<<2)>>2];z=z+A*+(h[t>>0]|0);y=y+A*+(h[t+1>>0]|0);x=x+A*+(h[t+2>>0]|0);w=w+A*+(h[t+3>>0]|0);e=e+1|0}while((e|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{e=u;while(1){n[b+(e<<2)>>2]=j;e=e+1|0;if((e|0)==(p|0))break b}}do{A=j;e=0;do{A=A+ +n[l+(e<<2)>>2]*+(h[(f[m+(e<<2)>>2]|0)+B>>0]|0);e=e+1|0}while((e|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function Via(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51448;f[a+12>>2]=51944;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function Wia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51448;f[a+12>>2]=51944;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Xia(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Yia(a){a=a|0;cYc(a);return}function Zia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51968;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function _ia(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51968;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function $ia(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=ALc(k)|0;u=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(A)|0;d[b+(w<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=ALc(z)|0;d[b+((w|1)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=ALc(y)|0;d[b+((w|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=ALc(x)|0;d[b+((w|3)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=ALc(k)|0;u=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(B)|0;d[b+(C<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function aja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51420;f[a+12>>2]=51968;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function bja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51420;f[a+12>>2]=51968;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function cja(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function dja(a){a=a|0;cYc(a);return}function eja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51992;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function fja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51992;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function gja(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=ALc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(A)|0;d[b+(w<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=ALc(z)|0;d[b+((w|1)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=ALc(y)|0;d[b+((w|2)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=ALc(x)|0;d[b+((w|3)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=ALc(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(B)|0;d[b+(C<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function hja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51392;f[a+12>>2]=51992;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function ija(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51392;f[a+12>>2]=51992;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function jja(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function kja(a){a=a|0;cYc(a);return}function lja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=52016;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function mja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=52016;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function nja(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=c;c=d;d=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=ALc(k)|0;u=(g>>>0<256?g:(g|0)>0?255:0)&255;g=0;while(1){b[c+g>>0]=u;b[c+(g|1)>>0]=u;b[c+(g|2)>>0]=u;b[c+(g|3)>>0]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(A)|0;b[c+w>>0]=g>>>0<256?g:(g|0)>0?255:0;g=ALc(z)|0;b[c+(w|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=ALc(y)|0;b[c+(w|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=ALc(x)|0;b[c+(w|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=ALc(k)|0;u=(g>>>0<256?g:(g|0)>0?255:0)&255;g=v;while(1){b[c+g>>0]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=ALc(B)|0;b[c+C>>0]=g>>>0<256?g:(g|0)>0?255:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((d|0)>1){t=t+4|0;c=c+e|0;d=d+-1|0}else break}return}function oja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51364;f[a+12>>2]=52016;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function pja(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51364;f[a+12>>2]=52016;b=f[a+56>>2]|0;if(b|0){c=a+60|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+44>>2]|0;if(b|0){d=a+48|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function qja(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function rja(a){a=a|0;cYc(a);return}function sja(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=u;u=u+160|0;m=l+96|0;n=l+40|0;o=l+32|0;p=l+8|0;q=l+24|0;r=l;do if((eS(e)|0)==65536){s=f[e+4>>2]|0;f[m>>2]=f[s>>2];t=m+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=m+8|0;f[w>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];f[m+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[m+36>>2]=x;f[m+40>>2]=w;w=m+48|0;y=m+44|0;f[y>>2]=w;f[w>>2]=0;f[m+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;U$(m,s);break}}else bS(m,e,-1);while(0);e=c&4095;s=d&4095;if((d^c)&4088|0){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;c=$Xc(32)|0;f[n>>2]=c;f[n+8>>2]=-2147483616;f[n+4>>2]=25;d=c;t=261452;v=d+25|0;do{b[d>>0]=b[t>>0]|0;d=d+1|0;t=t+1|0}while((d|0)<(v|0));b[c+25>>0]=0;vM(-215,n,263861,254608,4507)}f[n>>2]=f[m>>2];c=n+4|0;t=m+4|0;d=f[t>>2]|0;f[c>>2]=d;v=n+8|0;f[v>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];w=n+16|0;y=m+16|0;f[w>>2]=f[y>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];x=n+36|0;z=m+36|0;A=f[z>>2]|0;f[x>>2]=A;B=n+40|0;f[B>>2]=v;v=n+48|0;C=n+44|0;f[C>>2]=v;f[v>>2]=0;f[n+52>>2]=0;if(!A)D=d;else{d=A+12|0;f[d>>2]=(f[d>>2]|0)+1;D=f[t>>2]|0}if((D|0)<3){D=f[m+44>>2]|0;d=f[C>>2]|0;f[d>>2]=f[D>>2];f[d+4>>2]=f[D+4>>2]}else{f[c>>2]=0;U$(n,m)}f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];vha(o,e,s,p,q,h,0);f[p>>2]=0;f[p+4>>2]=0;f[r>>2]=0;f[r+4>>2]=0;q=$Xc(212)|0;f[q+4>>2]=0;f[q+8>>2]=0;f[q>>2]=52040;g=q+12|0;Zba(g,o,p,r,e,s,e,i,j,k);f[a>>2]=g;f[a+4>>2]=q;q=f[o+4>>2]|0;if(q|0)UXc(q);q=f[x>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)V$(n);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[c>>2]|0)>0){w=f[B>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[c>>2]|0))}c=f[C>>2]|0;if((c|0)!=(v|0))wL(c);c=f[z>>2]|0;if(c|0?(v=c+12|0,c=f[v>>2]|0,f[v>>2]=c+-1,(c|0)==1):0)V$(m);f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[t>>2]|0)>0){y=f[m+40>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[t>>2]|0))}t=f[m+44>>2]|0;if((t|0)==(m+48|0)){u=l;return}wL(t);u=l;return}function tja(a){a=a|0;f[a>>2]=52040;Pba(a+12|0);NXc(a);return}function uja(a){a=a|0;f[a>>2]=52040;Pba(a+12|0);NXc(a);cYc(a);return}function vja(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function wja(a){a=a|0;cYc(a);return}function xja(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=+w;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;y=u;u=u+496|0;z=y+432|0;A=y+56|0;B=y+376|0;C=y+320|0;D=y+264|0;E=y;F=y+208|0;G=y+200|0;H=y+144|0;I=y+136|0;J=y+128|0;K=y+120|0;L=y+104|0;M=y+88|0;N=y+80|0;O=y+72|0;P=y+64|0;p[A>>3]=w;if((Y(s,r)|0)<=49){f[A>>2]=r;f[A+4>>2]=s;cM(z,A,c,o,q);f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=z;f[D>>2]=t;f[D+4>>2]=v;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[E+28>>2]=0;sja(B,a,b,C,D,w,x&-17,-1,E);f[F>>2]=i;f[F+4>>2]=j;cM(C,F,a,d,e);f[G>>2]=i;f[G+4>>2]=j;cM(E,G,b,g,h);j=f[B>>2]|0;i=f[(f[j>>2]|0)+20>>2]|0;f[H>>2]=k;f[H+4>>2]=l;f[I>>2]=m;f[I+4>>2]=n;gi[i&255](j,C,E,H,I);j=E+36|0;i=f[j>>2]|0;if(i|0?(Q=i+12|0,i=f[Q>>2]|0,f[Q>>2]=i+-1,(i|0)==1):0)V$(E);f[j>>2]=0;j=E+16|0;i=E+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[E+40>>2]|0;Q=0;do{f[j+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[i>>2]|0))}i=f[E+44>>2]|0;if((i|0)!=(E+48|0))wL(i);i=C+36|0;Q=f[i>>2]|0;if(Q|0?(j=Q+12|0,Q=f[j>>2]|0,f[j>>2]=Q+-1,(Q|0)==1):0)V$(C);f[i>>2]=0;i=C+16|0;Q=C+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[Q>>2]|0)>0){i=f[C+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[Q>>2]|0))}Q=f[C+44>>2]|0;if((Q|0)!=(C+48|0))wL(Q);Q=f[B+4>>2]|0;if(Q|0)UXc(Q);Q=z+36|0;j=f[Q>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)V$(z);f[Q>>2]=0;Q=z+16|0;j=z+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[j>>2]|0)>0){Q=f[z+40>>2]|0;i=0;do{f[Q+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[j>>2]|0))}j=f[z+44>>2]|0;if((j|0)!=(z+48|0))wL(j);u=y;return}f[C>>2]=r;f[C+4>>2]=s;cM(B,C,c,o,q);f[E>>2]=k-m;f[E+4>>2]=l-n;cM(D,E,a,d,e);f[G>>2]=k;f[G+4>>2]=l;cM(F,G,b,g,h);f[H>>2]=1124007936;G=H+4|0;e=H+8|0;E=H+40|0;n=G;m=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(m|0));f[E>>2]=e;q=H+48|0;o=H+44|0;f[o>>2]=q;f[q>>2]=0;c=H+52|0;f[c>>2]=0;C=a>>>3&511;a=b&4088;s=b&7;if((C|0)!=0&+p[A>>3]!=0.0){if((s+-5|0)>>>0>1|(d|0)==(g|0)){r=(s|0)==6?6:5;f[z>>2]=l;f[z+4>>2]=k;S$(H,2,z,r|a);R=r}else{f[I>>2]=k;f[I+4>>2]=l;cM(z,I,b,g,h);I=H+36|0;r=f[I>>2]|0;if(r|0?(a=r+12|0,r=f[a>>2]|0,f[a>>2]=r+-1,(r|0)==1):0)V$(H);f[I>>2]=0;r=H+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[G>>2]|0)>0){a=f[E>>2]|0;j=0;do{f[a+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[G>>2]|0))}f[H>>2]=f[z>>2];j=z+4|0;a=f[j>>2]|0;f[G>>2]=a;i=z+8|0;f[e>>2]=f[i>>2];f[H+12>>2]=f[z+12>>2];f[r>>2]=f[z+16>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];f[I>>2]=f[z+36>>2];I=H+44|0;r=f[I>>2]|0;if((r|0)==(q|0))S=a;else{wL(r);f[I>>2]=q;f[E>>2]=e;S=f[j>>2]|0}r=z+44|0;if((S|0)<3){S=f[r>>2]|0;f[q>>2]=f[S>>2];f[c>>2]=f[S+4>>2];f[z>>2]=1124007936;a=(S|0)==(z+48|0);n=j;m=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(m|0));if(!a)wL(S)}else{f[I>>2]=f[r>>2];I=z+40|0;f[H+40>>2]=f[I>>2];f[r>>2]=z+48;f[I>>2]=i;f[z>>2]=1124007936;n=j;m=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(m|0))}R=s}j=f[D+40>>2]|0;i=f[j>>2]|0;f[J>>2]=f[j+4>>2];f[J+4>>2]=i;f[K>>2]=t;f[K+4>>2]=v;Eba(D,B,H,J,R|C<<3,K,0.0,x);f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=H;f[L>>2]=-1056833530;f[L+4>>2]=A;f[L+8>>2]=1;f[L+12>>2]=1;K=M+8|0;f[K>>2]=0;f[K+4>>2]=0;f[M>>2]=33619968;f[M+4>>2]=H;E1(z,L,M,fT()|0,-1);if((f[H+16>>2]|0)!=(g|0)){M=z+8|0;f[M>>2]=0;f[M+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;dY(H,z,f[F>>2]&4095,1.0,0.0)}}else{if((d|0)!=(g|0)){f[N>>2]=k;f[N+4>>2]=l;cM(z,N,b,g,h);h=H+36|0;N=f[h>>2]|0;if(N|0?(d=N+12|0,N=f[d>>2]|0,f[d>>2]=N+-1,(N|0)==1):0)V$(H);f[h>>2]=0;N=H+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[G>>2]|0)>0){d=f[E>>2]|0;M=0;do{f[d+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[G>>2]|0))}f[H>>2]=f[z>>2];M=z+4|0;d=f[M>>2]|0;f[G>>2]=d;L=z+8|0;f[e>>2]=f[L>>2];f[H+12>>2]=f[z+12>>2];f[N>>2]=f[z+16>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];f[h>>2]=f[z+36>>2];h=H+44|0;N=f[h>>2]|0;if((N|0)==(q|0))T=d;else{wL(N);f[h>>2]=q;f[E>>2]=e;T=f[M>>2]|0}e=z+44|0;if((T|0)<3){T=f[e>>2]|0;f[q>>2]=f[T>>2];f[c>>2]=f[T+4>>2];f[z>>2]=1124007936;c=(T|0)==(z+48|0);n=M;m=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(m|0));if(!c)wL(T)}else{f[h>>2]=f[e>>2];h=z+40|0;f[H+40>>2]=f[h>>2];f[e>>2]=z+48;f[h>>2]=L;f[z>>2]=1124007936;n=M;m=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(m|0))}}else{f[z>>2]=l;f[z+4>>2]=k;S$(H,2,z,b&4095)}b=f[D+40>>2]|0;k=f[b>>2]|0;f[O>>2]=f[b+4>>2];f[O+4>>2]=k;f[P>>2]=t;f[P+4>>2]=v;Eba(D,B,H,O,C<<3|s,P,+p[A>>3],x);if((f[H+16>>2]|0)!=(g|0)){g=z+8|0;f[g>>2]=0;f[g+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;jR(H,z)}}z=H+36|0;g=f[z>>2]|0;if(g|0?(x=g+12|0,g=f[x>>2]|0,f[x>>2]=g+-1,(g|0)==1):0)V$(H);f[z>>2]=0;z=H+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[G>>2]|0)>0){z=f[E>>2]|0;E=0;do{f[z+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[G>>2]|0))}G=f[o>>2]|0;if((G|0)!=(q|0))wL(G);G=F+36|0;q=f[G>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)V$(F);f[G>>2]=0;G=F+16|0;q=F+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[q>>2]|0)>0){G=f[F+40>>2]|0;o=0;do{f[G+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[F+44>>2]|0;if((q|0)!=(F+48|0))wL(q);q=D+36|0;F=f[q>>2]|0;if(F|0?(o=F+12|0,F=f[o>>2]|0,f[o>>2]=F+-1,(F|0)==1):0)V$(D);f[q>>2]=0;q=D+16|0;F=D+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[F>>2]|0)>0){q=f[D+40>>2]|0;o=0;do{f[q+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[F>>2]|0))}F=f[D+44>>2]|0;if((F|0)!=(D+48|0))wL(F);F=B+36|0;D=f[F>>2]|0;if(D|0?(o=D+12|0,D=f[o>>2]|0,f[o>>2]=D+-1,(D|0)==1):0)V$(B);f[F>>2]=0;F=B+16|0;D=B+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[D>>2]|0)>0){F=f[B+40>>2]|0;o=0;do{f[F+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[D>>2]|0))}D=f[B+44>>2]|0;if((D|0)!=(B+48|0))wL(D);u=y;return}function yja(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p,q,r,s,t,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;v=+v;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;x=u;u=u+320|0;y=x+256|0;z=x+248|0;A=x+192|0;B=x+184|0;C=x+176|0;D=x+120|0;E=x+64|0;F=x+56|0;G=x;H=x+48|0;I=x+40|0;J=x+32|0;f[z>>2]=p;f[z+4>>2]=1;cM(y,z,c,o,0);f[B>>2]=r;f[B+4>>2]=1;cM(A,B,c,q,0);f[D+8>>2]=0;f[D+12>>2]=0;f[D>>2]=16842752;f[D+4>>2]=y;f[E+8>>2]=0;f[E+12>>2]=0;f[E>>2]=16842752;f[E+4>>2]=A;f[F>>2]=s;f[F+4>>2]=t;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[G+16>>2]=0;f[G+20>>2]=0;f[G+24>>2]=0;f[G+28>>2]=0;pha(C,a,b,D,E,F,v,w&-17,-1,G);f[H>>2]=i;f[H+4>>2]=j;cM(D,H,a,d,e);f[I>>2]=i;f[I+4>>2]=j;cM(E,I,b,g,h);h=f[C>>2]|0;g=f[(f[h>>2]|0)+20>>2]|0;f[G>>2]=k;f[G+4>>2]=l;f[J>>2]=m;f[J+4>>2]=n;gi[g&255](h,D,E,G,J);J=E+36|0;G=f[J>>2]|0;if(G|0?(h=G+12|0,G=f[h>>2]|0,f[h>>2]=G+-1,(G|0)==1):0)V$(E);f[J>>2]=0;J=E+16|0;G=E+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[G>>2]|0)>0){J=f[E+40>>2]|0;h=0;do{f[J+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[G>>2]|0))}G=f[E+44>>2]|0;if((G|0)!=(E+48|0))wL(G);G=D+36|0;E=f[G>>2]|0;if(E|0?(h=E+12|0,E=f[h>>2]|0,f[h>>2]=E+-1,(E|0)==1):0)V$(D);f[G>>2]=0;G=D+16|0;E=D+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[E>>2]|0)>0){G=f[D+40>>2]|0;h=0;do{f[G+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[E>>2]|0))}E=f[D+44>>2]|0;if((E|0)!=(D+48|0))wL(E);E=f[C+4>>2]|0;if(E|0)UXc(E);E=A+36|0;C=f[E>>2]|0;if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)V$(A);f[E>>2]=0;E=A+16|0;C=A+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[A+40>>2]|0;D=0;do{f[E+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[C>>2]|0))}C=f[A+44>>2]|0;if((C|0)!=(A+48|0))wL(C);C=y+36|0;A=f[C>>2]|0;if(A|0?(D=A+12|0,A=f[D>>2]|0,f[D>>2]=A+-1,(A|0)==1):0)V$(y);f[C>>2]=0;C=y+16|0;A=y+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){C=f[y+40>>2]|0;D=0;do{f[C+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[A>>2]|0))}A=f[y+44>>2]|0;if((A|0)==(y+48|0)){u=x;return}wL(A);u=x;return}function zja(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=u;u=u+208|0;k=j+184|0;l=j+128|0;m=j+72|0;n=j+8|0;o=j+16|0;p=j;do if((eS(a)|0)==65536){q=f[a+4>>2]|0;f[l>>2]=f[q>>2];r=l+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=l+8|0;f[t>>2]=f[q+8>>2];f[l+12>>2]=f[q+12>>2];f[l+16>>2]=f[q+16>>2];f[l+20>>2]=f[q+20>>2];f[l+24>>2]=f[q+24>>2];f[l+28>>2]=f[q+28>>2];f[l+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[l+36>>2]=v;f[l+40>>2]=t;t=l+48|0;w=l+44|0;f[w>>2]=t;f[t>>2]=0;f[l+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;U$(l,q);break}}else bS(l,a,-1);while(0);do if((eS(e)|0)==65536){a=f[e+4>>2]|0;f[m>>2]=f[a>>2];q=m+4|0;r=a+4|0;f[q>>2]=f[r>>2];s=m+8|0;f[s>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[m+36>>2]=t;f[m+40>>2]=s;s=m+48|0;w=m+44|0;f[w>>2]=s;f[s>>2]=0;f[m+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;U$(m,a);break}}else bS(m,e,-1);while(0);e=f[l>>2]|0;a=l+40|0;q=f[a>>2]|0;r=f[q>>2]|0;f[n>>2]=f[q+4>>2];f[n+4>>2]=r;wS(c,n,e&4088|((d|0)<0?e:d)&7,-1,0,0);do if((eS(c)|0)==65536){d=f[c+4>>2]|0;f[o>>2]=f[d>>2];e=o+4|0;n=d+4|0;f[e>>2]=f[n>>2];r=o+8|0;f[r>>2]=f[d+8>>2];f[o+12>>2]=f[d+12>>2];f[o+16>>2]=f[d+16>>2];f[o+20>>2]=f[d+20>>2];f[o+24>>2]=f[d+24>>2];f[o+28>>2]=f[d+28>>2];f[o+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[o+36>>2]=q;f[o+40>>2]=r;r=o+48|0;s=o+44|0;f[s>>2]=r;f[r>>2]=0;f[o+52>>2]=0;if(q|0){r=q+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[n>>2]|0)<3){n=f[d+44>>2]|0;r=f[s>>2]|0;f[r>>2]=f[n>>2];f[r+4>>2]=f[n+4>>2];break}else{f[e>>2]=0;U$(o,d);break}}else bS(o,c,-1);while(0);c=f[g>>2]|0;d=f[g+4>>2]|0;g=m+40|0;e=f[g>>2]|0;n=f[e+4>>2]|0;r=f[e>>2]|0;e=(c|0)==-1?(n|0)/2|0:c;c=(d|0)==-1?(r|0)/2|0:d;if(!((e|0)>-1&(e|0)<(n|0))){x=$Xc(64)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483584;z=k+4|0;f[z>>2]=52;A=x;B=362293;C=A+52|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+52|0;b[D>>0]=0;vM(-215,k,362346,362362,363)}if((c|0)<0|(c|0)>=(r|0)){x=$Xc(64)|0;f[k>>2]=x;y=k+8|0;f[y>>2]=-2147483584;z=k+4|0;f[z>>2]=52;A=x;B=362293;C=A+52|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));D=x+52|0;b[D>>0]=0;vM(-215,k,362346,362362,363)}f[k>>2]=0;D=k+4|0;f[D>>2]=0;x=f[l+12>>2]|0;B=f[l+8>>2]|0;f[p>>2]=x;A=p+4|0;f[A>>2]=B;if(!(i&16)){e0(l,p,k);E=f[p>>2]|0;F=f[A>>2]|0;G=f[k>>2]|0;H=f[D>>2]|0}else{E=x;F=B;G=0;H=0}B=f[l>>2]|0;x=l+16|0;D=l+48|0;k=o+16|0;A=o+48|0;p=m+16|0;C=m+48|0;xja(B&4095,f[o>>2]&4095,f[m>>2]&4095,f[x>>2]|0,f[D>>2]|0,f[k>>2]|0,f[A>>2]|0,f[o+12>>2]|0,f[o+8>>2]|0,E,F,G,H,f[p>>2]|0,f[C>>2]|0,f[m+12>>2]|0,f[m+8>>2]|0,e,c,h,i,(B&32768|0)!=0);B=o+36|0;i=f[B>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)V$(o);f[B>>2]=0;B=o+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[B>>2]|0)>0){k=f[o+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[B>>2]|0))}B=f[o+44>>2]|0;if((B|0)!=(A|0))wL(B);B=m+36|0;A=f[B>>2]|0;if(A|0?(o=A+12|0,A=f[o>>2]|0,f[o>>2]=A+-1,(A|0)==1):0)V$(m);f[B>>2]=0;B=m+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[B>>2]|0)>0){p=f[g>>2]|0;g=0;do{f[p+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)!=(C|0))wL(B);B=l+36|0;C=f[B>>2]|0;if(C|0?(m=C+12|0,C=f[m>>2]|0,f[m>>2]=C+-1,(C|0)==1):0)V$(l);f[B>>2]=0;B=l+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[B>>2]|0)>0){x=f[a>>2]|0;a=0;do{f[x+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[B>>2]|0))}B=f[l+44>>2]|0;if((B|0)==(D|0)){u=j;return}wL(B);u=j;return}function Aja(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;k=u;u=u+384|0;l=k+360|0;m=k+304|0;n=k+248|0;o=k+184|0;p=k+240|0;q=k+128|0;r=k+120|0;s=k+112|0;t=k+56|0;v=k;do if((eS(a)|0)==65536){w=f[a+4>>2]|0;f[m>>2]=f[w>>2];x=m+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[w+8>>2];f[m+12>>2]=f[w+12>>2];f[m+16>>2]=f[w+16>>2];f[m+20>>2]=f[w+20>>2];f[m+24>>2]=f[w+24>>2];f[m+28>>2]=f[w+28>>2];f[m+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(m,w);break}}else bS(m,a,-1);while(0);do if((eS(e)|0)==65536){a=f[e+4>>2]|0;f[n>>2]=f[a>>2];w=n+4|0;x=a+4|0;f[w>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;B=n+44|0;f[B>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[a+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;U$(n,a);break}}else bS(n,e,-1);while(0);do if((eS(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];a=o+4|0;w=e+4|0;f[a>>2]=f[w>>2];x=o+8|0;f[x>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];y=f[e+36>>2]|0;f[o+36>>2]=y;f[o+40>>2]=x;x=o+48|0;B=o+44|0;f[B>>2]=x;f[x>>2]=0;f[o+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[e+44>>2]|0;x=f[B>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[a>>2]=0;U$(o,e);break}}else bS(o,g,-1);while(0);g=f[m>>2]|0;e=m+40|0;a=f[e>>2]|0;w=f[a>>2]|0;f[p>>2]=f[a+4>>2];f[p+4>>2]=w;wS(c,p,g&4088|((d|0)<0?g:d)&7,-1,0,0);do if((eS(c)|0)==65536){d=f[c+4>>2]|0;f[q>>2]=f[d>>2];g=q+4|0;p=d+4|0;f[g>>2]=f[p>>2];w=q+8|0;f[w>>2]=f[d+8>>2];f[q+12>>2]=f[d+12>>2];f[q+16>>2]=f[d+16>>2];f[q+20>>2]=f[d+20>>2];f[q+24>>2]=f[d+24>>2];f[q+28>>2]=f[d+28>>2];f[q+32>>2]=f[d+32>>2];a=f[d+36>>2]|0;f[q+36>>2]=a;f[q+40>>2]=w;w=q+48|0;x=q+44|0;f[x>>2]=w;f[w>>2]=0;f[q+52>>2]=0;if(a|0){w=a+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[p>>2]|0)<3){p=f[d+44>>2]|0;w=f[x>>2]|0;f[w>>2]=f[p>>2];f[w+4>>2]=f[p+4>>2];break}else{f[g>>2]=0;U$(q,d);break}}else bS(q,c,-1);while(0);f[r>>2]=0;c=r+4|0;f[c>>2]=0;d=f[m+8>>2]|0;f[s>>2]=f[m+12>>2];g=s+4|0;f[g>>2]=d;if(!(j&16))e0(m,s,r);d=f[n>>2]|0;if((f[o>>2]^d)&4095|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;C=$Xc(128)|0;f[l>>2]=C;D=l+8|0;f[D>>2]=-2147483520;E=l+4|0;f[E>>2]=120;F=C;G=263951;H=F+120|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=C+120|0;b[I>>0]=0;vM(-215,l,264072,254608,4949)}p=n+12|0;w=f[p>>2]|0;if((w|0)!=1?(f[n+8>>2]|0)!=1:0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;C=$Xc(128)|0;f[l>>2]=C;D=l+8|0;f[D>>2]=-2147483520;E=l+4|0;f[E>>2]=120;F=C;G=263951;H=F+120|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=C+120|0;b[I>>0]=0;vM(-215,l,264072,254608,4949)}x=o+12|0;if((f[x>>2]|0)!=1?(f[o+8>>2]|0)!=1:0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;C=$Xc(128)|0;f[l>>2]=C;D=l+8|0;f[D>>2]=-2147483520;E=l+4|0;f[E>>2]=120;F=C;G=263951;H=F+120|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=C+120|0;b[I>>0]=0;vM(-215,l,264072,254608,4949)}do if(d&16384){f[t>>2]=d;I=t+4|0;C=n+4|0;G=f[C>>2]|0;f[I>>2]=G;E=t+8|0;f[E>>2]=f[n+8>>2];f[t+12>>2]=w;f[t+16>>2]=f[n+16>>2];f[t+20>>2]=f[n+20>>2];f[t+24>>2]=f[n+24>>2];f[t+28>>2]=f[n+28>>2];f[t+32>>2]=f[n+32>>2];D=f[n+36>>2]|0;f[t+36>>2]=D;f[t+40>>2]=E;E=t+48|0;a=t+44|0;f[a>>2]=E;f[E>>2]=0;f[t+52>>2]=0;if(!D)J=G;else{G=D+12|0;f[G>>2]=(f[G>>2]|0)+1;J=f[C>>2]|0}if((J|0)<3){C=f[n+44>>2]|0;G=f[a>>2]|0;f[G>>2]=f[C>>2];f[G+4>>2]=f[C+4>>2];break}else{f[I>>2]=0;U$(t,n);break}}else{f[t>>2]=1124007936;I=t+8|0;C=t+40|0;F=t+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[C>>2]=I;G=t+48|0;f[t+44>>2]=G;f[G>>2]=0;f[t+52>>2]=0;G=l+8|0;f[G>>2]=0;f[G+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=t;jR(n,l)}while(0);J=f[o>>2]|0;do if(J&16384){f[v>>2]=J;w=v+4|0;d=o+4|0;G=f[d>>2]|0;f[w>>2]=G;a=v+8|0;D=o+8|0;f[a>>2]=f[D>>2];f[v+12>>2]=f[x>>2];E=v+16|0;f[E>>2]=f[o+16>>2];f[v+20>>2]=f[o+20>>2];f[v+24>>2]=f[o+24>>2];f[v+28>>2]=f[o+28>>2];f[v+32>>2]=f[o+32>>2];B=f[o+36>>2]|0;f[v+36>>2]=B;f[v+40>>2]=a;a=v+48|0;y=v+44|0;f[y>>2]=a;f[a>>2]=0;f[v+52>>2]=0;if(!B)K=G;else{G=B+12|0;f[G>>2]=(f[G>>2]|0)+1;K=f[d>>2]|0}if((K|0)<3){d=f[o+44>>2]|0;G=f[y>>2]|0;f[G>>2]=f[d>>2];f[G+4>>2]=f[d+4>>2];L=D;M=E;break}else{f[w>>2]=0;U$(v,o);L=D;M=E;break}}else{f[v>>2]=1124007936;E=v+8|0;D=v+40|0;F=v+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[D>>2]=E;I=v+48|0;f[v+44>>2]=I;f[I>>2]=0;f[v+52>>2]=0;I=l+8|0;f[I>>2]=0;f[I+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=v;jR(o,l);L=o+8|0;M=v+16|0}while(0);l=m+16|0;F=m+48|0;H=q+16|0;K=q+48|0;J=t+16|0;yja(f[m>>2]&4095,f[q>>2]&4095,f[n>>2]&4095,f[l>>2]|0,f[F>>2]|0,f[H>>2]|0,f[K>>2]|0,f[q+12>>2]|0,f[q+8>>2]|0,f[s>>2]|0,f[g>>2]|0,f[r>>2]|0,f[c>>2]|0,f[J>>2]|0,(f[p>>2]|0)+-1+(f[n+8>>2]|0)|0,f[M>>2]|0,(f[x>>2]|0)+-1+(f[L>>2]|0)|0,f[h>>2]|0,f[h+4>>2]|0,i,j&-17);j=v+36|0;h=f[j>>2]|0;if(h|0?(L=h+12|0,h=f[L>>2]|0,f[L>>2]=h+-1,(h|0)==1):0)V$(v);f[j>>2]=0;j=v+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[j>>2]|0)>0){M=f[v+40>>2]|0;h=0;do{f[M+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))wL(j);j=t+36|0;v=f[j>>2]|0;if(v|0?(h=v+12|0,v=f[h>>2]|0,f[h>>2]=v+-1,(v|0)==1):0)V$(t);f[j>>2]=0;j=t+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[j>>2]|0)>0){J=f[t+40>>2]|0;v=0;do{f[J+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[j>>2]|0))}j=f[t+44>>2]|0;if((j|0)!=(t+48|0))wL(j);j=q+36|0;t=f[j>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)V$(q);f[j>>2]=0;j=q+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[j>>2]|0)>0){H=f[q+40>>2]|0;t=0;do{f[H+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[q+44>>2]|0;if((j|0)!=(K|0))wL(j);j=o+36|0;K=f[j>>2]|0;do if(K|0){q=K+12|0;t=f[q>>2]|0;f[q>>2]=t+-1;if((t|0)!=1)break;V$(o)}while(0);f[j>>2]=0;j=o+16|0;K=o+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[K>>2]|0)>0){j=f[o+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[K>>2]|0))}K=f[o+44>>2]|0;if((K|0)!=(o+48|0))wL(K);K=n+36|0;o=f[K>>2]|0;do if(o|0){t=o+12|0;j=f[t>>2]|0;f[t>>2]=j+-1;if((j|0)!=1)break;V$(n)}while(0);f[K>>2]=0;K=n+16|0;o=n+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[o>>2]|0)>0){K=f[n+40>>2]|0;j=0;do{f[K+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)!=(n+48|0))wL(o);o=m+36|0;n=f[o>>2]|0;do if(n|0){j=n+12|0;K=f[j>>2]|0;f[j>>2]=K+-1;if((K|0)!=1)break;V$(m)}while(0);f[o>>2]=0;o=m+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[o>>2]|0)>0){l=f[e>>2]|0;e=0;do{f[l+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)==(F|0)){u=k;return}wL(o);u=k;return}function Bja(a,b,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0;p=u;u=u+16|0;q=p;r=(a|0)==0;s=r&(b|0)==4;t=(c|0)==6;if(s&t){Cja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}v=(c|0)==5;if(s&v){Dja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&(c|0)==4){Eja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}c=(b|0)==5;s=r&c;if(s&t){Fja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&v){Gja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}s=(b|0)==6;if(r&s&t){Hja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==2&s&t){Ija(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==3&s&t){Jja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}r=(a|0)==5;b=r&c;if(b&t){Kja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(b&v){Lja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(r&s&t){Mja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(!((a|0)==6&s&t)){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;vM(-210,q,264084,264093,549)}Nja(d,e,g,h,i,j,k,l,m,n,o);u=p;return}function Cja(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;o=u;u=u+1072|0;q=0-n|0;r=o;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>3;i=Y(n,l)|0;l=i+n|0;v=l<<2;g1c(d|0,0,v|0)|0;w=d+(s+n<<2)|0;if(!g)x=0;else{g1c(g|0,0,l<<3|0)|0;x=g+(t+n<<3)|0}if(!j)y=0;else{g1c(j|0,0,v|0)|0;y=j+(e+n<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=o;return}v=(i|0)>0;g=c-n|0;z=s-n|0;if((n|0)<=0){u=o;return}A=n+-1|0;B=n<<2;C=w;D=0;E=a;while(1){if(v){F=0;G=C;H=E;while(1){f[G+(q<<2)>>2]=0;I=0;J=0;do{I=(h[H+J>>0]|0)+I|0;f[G+(J<<2)>>2]=I+(f[G+(J-s<<2)>>2]|0);J=J+n|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(n|0))break;else{G=G+4|0;H=H+1|0}}}else g1c(C+(q<<2)|0,0,B|0)|0;D=D+1|0;if((D|0)==(m|0))break;else{C=C+(A<<2)+4+(z<<2)|0;E=E+A+1+g|0}}u=o;return}if(j){if((m|0)<=0){u=o;return}j=(i|0)>0;g=c-n|0;A=s-n|0;E=t-n|0;if((n|0)<=0){u=o;return}z=n+-1|0;C=x;D=0;B=w;v=a;while(1){if(j){H=0;G=C;F=B;J=v;while(1){f[F+(q<<2)>>2]=0;p[G+(q<<3)>>3]=0.0;K=0.0;I=0;L=0;do{M=b[J+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+p[G+(L-t<<3)>>3]+K;f[F+(L<<2)>>2]=I+(f[F+(L-s<<2)>>2]|0);p[G+(L<<3)>>3]=N;L=L+n|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(n|0))break;else{G=G+8|0;F=F+4|0;J=J+1|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;p[F+(q<<3)>>3]=0.0;J=J+1|0;if((J|0)==(n|0))break;else{F=F+8|0;G=G+4|0}}}D=D+1|0;if((D|0)==(m|0))break;else{C=C+(z<<3)+8+(E<<3)|0;B=B+(z<<2)+4+(A<<2)|0;v=v+z+1+g|0}}u=o;return}g=r+8|0;f[r>>2]=g;z=r+4|0;f[z>>2]=l;if(l>>>0>264){v=bYc(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=v;O=v}else O=g;v=(n|0)>0;do if(v){l=(i|0)==(n|0);A=s+(n<<1)|0;B=y+(n<<2)|0;if((i|0)>0){P=O;Q=y;R=0;S=x;T=w;U=a}else{E=O;C=y;D=0;j=x;G=w;while(1){f[C+(q<<2)>>2]=0;f[G+(q<<2)>>2]=0;if(l)f[E+(n<<2)>>2]=0;if(!j)V=0;else{p[j+(q<<3)>>3]=0.0;V=j+8|0}D=D+1|0;if((D|0)==(n|0))break;else{E=E+4|0;C=C+4|0;j=V;G=G+4|0}}W=O+(n<<2)|0;X=B;Z=V;_=a+n|0;$=d+(A<<2)|0;break}while(1){f[Q+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(S|0)!=0;if(G){K=0.0;j=0;C=0;do{E=b[U+C>>0]|0;D=E&255;f[Q+(C<<2)>>2]=D;f[P+(C<<2)>>2]=D;j=D+j|0;N=+(E&255);K=K+N*N;f[T+(C<<2)>>2]=j;p[S+(C<<3)>>3]=K;C=C+n|0}while((C|0)<(i|0))}else{C=0;j=0;do{E=h[U+j>>0]|0;f[Q+(j<<2)>>2]=E;f[P+(j<<2)>>2]=E;C=E+C|0;f[T+(j<<2)>>2]=C;j=j+n|0}while((j|0)<(i|0))}if(l)f[P+(n<<2)>>2]=0;if(G){p[S+(q<<3)>>3]=0.0;aa=S+8|0}else aa=0;R=R+1|0;if((R|0)==(n|0))break;else{P=P+4|0;Q=Q+4|0;S=aa;T=T+4|0;U=U+1|0}}W=O+(n<<2)|0;X=B;Z=aa;_=a+n|0;$=d+(A<<2)|0}else{W=O;X=y;Z=x;_=a;$=w}while(0);if((m|0)>1){w=c-n|0;a=s-n|0;x=e-n|0;y=t-n|0;d=0-s|0;aa=0-t|0;U=i-n|0;T=(U|0)>(n|0);S=e+n|0;Q=(i|0)>(n|0);i=W;W=X;X=1;P=$;$=Z;Z=_;while(1){_=Z+w|0;R=P+(a<<2)|0;V=W+(x<<2)|0;l=i+(q<<2)|0;j=($|0)==0?0:$+(y<<3)|0;if(v){C=P+(s<<2)|0;E=l;D=V;F=0;J=R;H=_;L=j;while(1){I=b[H>>0]|0;M=I&255;K=+(I&255);N=K*K;f[J+(q<<2)>>2]=0;I=(L|0)!=0;if(I)p[L+(q<<3)>>3]=0.0;ba=D+(k<<2)|0;f[D+(q<<2)>>2]=f[ba>>2];f[J>>2]=(f[J+(d<<2)>>2]|0)+M;if(I)p[L>>3]=N+ +p[L+(aa<<3)>>3];f[D>>2]=(f[ba>>2]|0)+M+(f[E+(n<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=n;while(1){ea=f[E+(da<<2)>>2]|0;f[E+(da-n<<2)>>2]=ea+ba;fa=b[H+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ca|0;ia=K+ha*ha;f[J+(da<<2)>>2]=fa+(f[J+(da-s<<2)>>2]|0);p[L+(da<<3)>>3]=ia+ +p[L+(da-t<<3)>>3];ja=da+n|0;f[D+(da<<2)>>2]=ga+ea+(f[E+(ja<<2)>>2]|0)+(f[D+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=ga;K=ia;ca=fa;da=ja}else{ka=ga;la=ia;ma=fa;na=ja;break}}}else{da=M;K=N;ca=M;ba=n;while(1){G=f[E+(ba<<2)>>2]|0;f[E+(ba-n<<2)>>2]=G+da;ja=b[H+ba>>0]|0;fa=ja&255;ia=+(ja&255);ja=fa+ca|0;ha=K+ia*ia;f[J+(ba<<2)>>2]=ja+(f[J+(ba-s<<2)>>2]|0);ga=ba+n|0;f[D+(ba<<2)>>2]=fa+G+(f[E+(ga<<2)>>2]|0)+(f[D+(ba-S<<2)>>2]|0);if((ga|0)<(U|0)){da=fa;K=ha;ca=ja;ba=ga}else{ka=fa;la=ha;ma=ja;na=ga;break}}}else{ka=M;la=N;ma=M;na=n}if(Q){ba=E+(na<<2)|0;ca=f[ba>>2]|0;f[E+(na-n<<2)>>2]=ca+ka;da=b[H+na>>0]|0;ga=da&255;f[J+(na<<2)>>2]=ga+ma+(f[J+(na-s<<2)>>2]|0);K=+(da&255);if(I)p[L+(na<<3)>>3]=la+K*K+ +p[L+(na-t<<3)>>3];f[D+(na<<2)>>2]=ga+ca+(f[D+(na-S<<2)>>2]|0);f[ba>>2]=ga}L=I?L+8|0:0;F=F+1|0;if((F|0)==(n|0))break;else{E=E+4|0;D=D+4|0;J=J+4|0;H=H+1|0}}oa=i;pa=W+(e<<2)|0;qa=Z+c|0;ra=C;sa=L}else{oa=l;pa=V;qa=_;ra=R;sa=j}X=X+1|0;if((X|0)==(m|0))break;else{i=oa;W=pa;P=ra;$=sa;Z=qa}}}if((O|0)!=(g|0)){dYc(O);f[r>>2]=g;f[z>>2]=264}u=o;return}function Dja(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;p=u;u=u+1072|0;q=0-o|0;r=p;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>2;i=Y(o,l)|0;l=i+o|0;v=l<<2;g1c(d|0,0,v|0)|0;w=d+(s+o<<2)|0;if(!g)x=0;else{g1c(g|0,0,v|0)|0;x=g+(t+o<<2)|0}if(!j)y=0;else{g1c(j|0,0,v|0)|0;y=j+(e+o<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=p;return}v=(i|0)>0;g=c-o|0;z=s-o|0;if((o|0)<=0){u=p;return}A=o+-1|0;B=o<<2;C=w;D=0;E=a;while(1){if(v){F=0;G=C;H=E;while(1){f[G+(q<<2)>>2]=0;I=0;J=0;do{I=(h[H+J>>0]|0)+I|0;f[G+(J<<2)>>2]=I+(f[G+(J-s<<2)>>2]|0);J=J+o|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(o|0))break;else{G=G+4|0;H=H+1|0}}}else g1c(C+(q<<2)|0,0,B|0)|0;D=D+1|0;if((D|0)==(m|0))break;else{C=C+(A<<2)+4+(z<<2)|0;E=E+A+1+g|0}}u=p;return}if(j){if((m|0)<=0){u=p;return}j=(i|0)>0;g=c-o|0;A=s-o|0;E=t-o|0;if((o|0)<=0){u=p;return}z=o+-1|0;C=x;D=0;B=w;v=a;while(1){if(j){H=0;G=C;F=B;J=v;while(1){f[F+(q<<2)>>2]=0;n[G+(q<<2)>>2]=0.0;K=0.0;I=0;L=0;do{M=b[J+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+n[G+(L-t<<2)>>2]+K;f[F+(L<<2)>>2]=I+(f[F+(L-s<<2)>>2]|0);n[G+(L<<2)>>2]=N;L=L+o|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(o|0))break;else{G=G+4|0;F=F+4|0;J=J+1|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;n[F+(q<<2)>>2]=0.0;J=J+1|0;if((J|0)==(o|0))break;else{F=F+4|0;G=G+4|0}}}D=D+1|0;if((D|0)==(m|0))break;else{C=C+(z<<2)+4+(E<<2)|0;B=B+(z<<2)+4+(A<<2)|0;v=v+z+1+g|0}}u=p;return}g=r+8|0;f[r>>2]=g;z=r+4|0;f[z>>2]=l;if(l>>>0>264){v=bYc(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=v;O=v}else O=g;v=(o|0)>0;do if(v){l=(i|0)==(o|0);A=s+(o<<1)|0;B=y+(o<<2)|0;if((i|0)>0){P=O;Q=y;R=0;S=x;T=w;U=a}else{E=O;C=y;D=0;j=x;G=w;while(1){f[C+(q<<2)>>2]=0;f[G+(q<<2)>>2]=0;if(l)f[E+(o<<2)>>2]=0;if(!j)V=0;else{n[j+(q<<2)>>2]=0.0;V=j+4|0}D=D+1|0;if((D|0)==(o|0))break;else{E=E+4|0;C=C+4|0;j=V;G=G+4|0}}W=O+(o<<2)|0;X=B;Z=V;_=a+o|0;$=d+(A<<2)|0;break}while(1){f[Q+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(S|0)!=0;if(G){K=0.0;j=0;C=0;do{E=b[U+C>>0]|0;D=E&255;f[Q+(C<<2)>>2]=D;f[P+(C<<2)>>2]=D;j=D+j|0;N=+(E&255);K=K+N*N;f[T+(C<<2)>>2]=j;n[S+(C<<2)>>2]=K;C=C+o|0}while((C|0)<(i|0))}else{C=0;j=0;do{E=h[U+j>>0]|0;f[Q+(j<<2)>>2]=E;f[P+(j<<2)>>2]=E;C=E+C|0;f[T+(j<<2)>>2]=C;j=j+o|0}while((j|0)<(i|0))}if(l)f[P+(o<<2)>>2]=0;if(G){n[S+(q<<2)>>2]=0.0;aa=S+4|0}else aa=0;R=R+1|0;if((R|0)==(o|0))break;else{P=P+4|0;Q=Q+4|0;S=aa;T=T+4|0;U=U+1|0}}W=O+(o<<2)|0;X=B;Z=aa;_=a+o|0;$=d+(A<<2)|0}else{W=O;X=y;Z=x;_=a;$=w}while(0);if((m|0)>1){w=c-o|0;a=s-o|0;x=e-o|0;y=t-o|0;d=0-s|0;aa=0-t|0;U=i-o|0;T=(U|0)>(o|0);S=e+o|0;Q=(i|0)>(o|0);i=W;W=X;X=1;P=$;$=Z;Z=_;while(1){_=Z+w|0;R=P+(a<<2)|0;V=W+(x<<2)|0;l=i+(q<<2)|0;j=($|0)==0?0:$+(y<<2)|0;if(v){C=P+(s<<2)|0;E=l;D=V;F=0;J=R;H=_;L=j;while(1){I=b[H>>0]|0;M=I&255;K=+(I&255);N=K*K;f[J+(q<<2)>>2]=0;I=(L|0)!=0;if(I)n[L+(q<<2)>>2]=0.0;ba=D+(k<<2)|0;f[D+(q<<2)>>2]=f[ba>>2];f[J>>2]=(f[J+(d<<2)>>2]|0)+M;if(I)n[L>>2]=N+ +n[L+(aa<<2)>>2];f[D>>2]=(f[ba>>2]|0)+M+(f[E+(o<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=o;while(1){ea=f[E+(da<<2)>>2]|0;f[E+(da-o<<2)>>2]=ea+ba;fa=b[H+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ca|0;ia=K+ha*ha;f[J+(da<<2)>>2]=fa+(f[J+(da-s<<2)>>2]|0);n[L+(da<<2)>>2]=ia+ +n[L+(da-t<<2)>>2];ja=da+o|0;f[D+(da<<2)>>2]=ga+ea+(f[E+(ja<<2)>>2]|0)+(f[D+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=ga;K=ia;ca=fa;da=ja}else{ka=ga;la=ia;ma=fa;na=ja;break}}}else{da=M;K=N;ca=M;ba=o;while(1){G=f[E+(ba<<2)>>2]|0;f[E+(ba-o<<2)>>2]=G+da;ja=b[H+ba>>0]|0;fa=ja&255;ia=+(ja&255);ja=fa+ca|0;ha=K+ia*ia;f[J+(ba<<2)>>2]=ja+(f[J+(ba-s<<2)>>2]|0);ga=ba+o|0;f[D+(ba<<2)>>2]=fa+G+(f[E+(ga<<2)>>2]|0)+(f[D+(ba-S<<2)>>2]|0);if((ga|0)<(U|0)){da=fa;K=ha;ca=ja;ba=ga}else{ka=fa;la=ha;ma=ja;na=ga;break}}}else{ka=M;la=N;ma=M;na=o}if(Q){ba=E+(na<<2)|0;ca=f[ba>>2]|0;f[E+(na-o<<2)>>2]=ca+ka;da=b[H+na>>0]|0;ga=da&255;f[J+(na<<2)>>2]=ga+ma+(f[J+(na-s<<2)>>2]|0);K=+(da&255);if(I)n[L+(na<<2)>>2]=la+K*K+ +n[L+(na-t<<2)>>2];f[D+(na<<2)>>2]=ga+ca+(f[D+(na-S<<2)>>2]|0);f[ba>>2]=ga}L=I?L+4|0:0;F=F+1|0;if((F|0)==(o|0))break;else{E=E+4|0;D=D+4|0;J=J+4|0;H=H+1|0}}oa=i;pa=W+(e<<2)|0;qa=Z+c|0;ra=C;sa=L}else{oa=l;pa=V;qa=_;ra=R;sa=j}X=X+1|0;if((X|0)==(m|0))break;else{i=oa;W=pa;P=ra;$=sa;Z=qa}}}if((O|0)!=(g|0)){dYc(O);f[r>>2]=g;f[z>>2]=264}u=p;return}function Eja(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;n=u;u=u+1072|0;o=0-m|0;p=n;q=d>>>2;d=j>>>2;j=0-d|0;r=g>>>2;g=Y(m,k)|0;k=g+m|0;s=k<<2;g1c(c|0,0,s|0)|0;t=c+(q+m<<2)|0;if(!e)v=0;else{g1c(e|0,0,s|0)|0;v=e+(r+m<<2)|0}if(!i)w=0;else{g1c(i|0,0,s|0)|0;w=i+(d+m<<2)|0}i=(w|0)==0;if((v|0)==0&i){if((l|0)<=0){u=n;return}s=(g|0)>0;e=b-m|0;x=q-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;z=m<<2;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){f[E+(o<<2)>>2]=0;G=0;H=0;do{G=(h[F+H>>0]|0)+G|0;f[E+(H<<2)>>2]=G+(f[E+(H-q<<2)>>2]|0);H=H+m|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(m|0))break;else{E=E+4|0;F=F+1|0}}}else g1c(A+(o<<2)|0,0,z|0)|0;B=B+1|0;if((B|0)==(l|0))break;else{A=A+(y<<2)+4+(x<<2)|0;C=C+y+1+e|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;e=b-m|0;y=q-m|0;C=r-m|0;if((m|0)<=0){u=n;return}x=m+-1|0;A=v;B=0;z=t;s=a;while(1){if(i){F=0;E=A;D=z;H=s;while(1){f[D+(o<<2)>>2]=0;f[E+(o<<2)>>2]=0;G=0;I=0;J=0;do{K=h[H+J>>0]|0;I=K+I|0;G=(Y(K,K)|0)+G|0;K=G+(f[E+(J-r<<2)>>2]|0)|0;f[D+(J<<2)>>2]=I+(f[D+(J-q<<2)>>2]|0);f[E+(J<<2)>>2]=K;J=J+m|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(m|0))break;else{E=E+4|0;D=D+4|0;H=H+1|0}}}else{H=0;D=A;E=z;while(1){f[E+(o<<2)>>2]=0;f[D+(o<<2)>>2]=0;H=H+1|0;if((H|0)==(m|0))break;else{D=D+4|0;E=E+4|0}}}B=B+1|0;if((B|0)==(l|0))break;else{A=A+(x<<2)+4+(C<<2)|0;z=z+(x<<2)+4+(y<<2)|0;s=s+x+1+e|0}}u=n;return}e=p+8|0;f[p>>2]=e;x=p+4|0;f[x>>2]=k;if(k>>>0>264){s=bYc(k>>>0>1073741823?-1:k<<2)|0;f[p>>2]=s;L=s}else L=e;s=(m|0)>0;do if(s){k=(g|0)==(m|0);y=q+(m<<1)|0;z=w+(m<<2)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;i=v;E=t;while(1){f[A+(o<<2)>>2]=0;f[E+(o<<2)>>2]=0;if(k)f[C+(m<<2)>>2]=0;if(!i)S=0;else{f[i+(o<<2)>>2]=0;S=i+4|0}B=B+1|0;if((B|0)==(m|0))break;else{C=C+4|0;A=A+4|0;i=S;E=E+4|0}}T=L+(m<<2)|0;U=z;V=S;W=a+m|0;X=c+(y<<2)|0;break}while(1){f[N+(o<<2)>>2]=0;f[Q+(o<<2)>>2]=0;E=(P|0)!=0;if(E){i=0;A=0;C=0;do{B=h[R+C>>0]|0;f[N+(C<<2)>>2]=B;f[M+(C<<2)>>2]=B;A=B+A|0;i=(Y(B,B)|0)+i|0;f[Q+(C<<2)>>2]=A;f[P+(C<<2)>>2]=i;C=C+m|0}while((C|0)<(g|0))}else{C=0;i=0;do{A=h[R+i>>0]|0;f[N+(i<<2)>>2]=A;f[M+(i<<2)>>2]=A;C=A+C|0;f[Q+(i<<2)>>2]=C;i=i+m|0}while((i|0)<(g|0))}if(k)f[M+(m<<2)>>2]=0;if(E){f[P+(o<<2)>>2]=0;Z=P+4|0}else Z=0;O=O+1|0;if((O|0)==(m|0))break;else{M=M+4|0;N=N+4|0;P=Z;Q=Q+4|0;R=R+1|0}}T=L+(m<<2)|0;U=z;V=Z;W=a+m|0;X=c+(y<<2)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((l|0)>1){t=b-m|0;a=q-m|0;v=d-m|0;w=r-m|0;c=0-q|0;Z=0-r|0;R=g-m|0;Q=(R|0)>(m|0);P=d+m|0;N=(g|0)>(m|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+t|0;O=M+(a<<2)|0;S=T+(v<<2)|0;k=g+(o<<2)|0;i=(X|0)==0?0:X+(w<<2)|0;if(s){C=M+(q<<2)|0;A=k;B=S;D=0;H=O;F=W;J=i;while(1){I=h[F>>0]|0;G=Y(I,I)|0;f[H+(o<<2)>>2]=0;K=(J|0)!=0;if(K)f[J+(o<<2)>>2]=0;_=B+(j<<2)|0;f[B+(o<<2)>>2]=f[_>>2];f[H>>2]=(f[H+(c<<2)>>2]|0)+I;if(K)f[J>>2]=(f[J+(Z<<2)>>2]|0)+G;f[B>>2]=(f[_>>2]|0)+I+(f[A+(m<<2)>>2]|0);if(Q)if(K){_=I;$=G;aa=I;ba=m;while(1){ca=f[A+(ba<<2)>>2]|0;f[A+(ba-m<<2)>>2]=ca+_;da=h[F+ba>>0]|0;ea=da+aa|0;fa=(Y(da,da)|0)+$|0;f[H+(ba<<2)>>2]=ea+(f[H+(ba-q<<2)>>2]|0);f[J+(ba<<2)>>2]=(f[J+(ba-r<<2)>>2]|0)+fa;ga=ba+m|0;f[B+(ba<<2)>>2]=da+ca+(f[A+(ga<<2)>>2]|0)+(f[B+(ba-P<<2)>>2]|0);if((ga|0)<(R|0)){_=da;$=fa;aa=ea;ba=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;$=I;_=m;while(1){E=f[A+(_<<2)>>2]|0;f[A+(_-m<<2)>>2]=E+ba;ga=h[F+_>>0]|0;ea=ga+$|0;fa=(Y(ga,ga)|0)+aa|0;f[H+(_<<2)>>2]=ea+(f[H+(_-q<<2)>>2]|0);da=_+m|0;f[B+(_<<2)>>2]=ga+E+(f[A+(da<<2)>>2]|0)+(f[B+(_-P<<2)>>2]|0);if((da|0)<(R|0)){ba=ga;aa=fa;$=ea;_=da}else{ha=ga;ia=fa;ja=ea;ka=da;break}}}else{ha=I;ia=G;ja=I;ka=m}if(N){_=A+(ka<<2)|0;$=f[_>>2]|0;f[A+(ka-m<<2)>>2]=$+ha;aa=h[F+ka>>0]|0;f[H+(ka<<2)>>2]=aa+ja+(f[H+(ka-q<<2)>>2]|0);if(K){ba=(Y(aa,aa)|0)+ia|0;f[J+(ka<<2)>>2]=ba+(f[J+(ka-r<<2)>>2]|0)}f[B+(ka<<2)>>2]=aa+$+(f[B+(ka-P<<2)>>2]|0);f[_>>2]=aa}J=K?J+4|0:0;D=D+1|0;if((D|0)==(m|0))break;else{A=A+4|0;B=B+4|0;H=H+4|0;F=F+1|0}}la=g;ma=T+(d<<2)|0;na=V+b|0;oa=C;pa=J}else{la=k;ma=S;na=W;oa=O;pa=i}U=U+1|0;if((U|0)==(l|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){dYc(L);f[p>>2]=e;f[x>>2]=264}u=n;return}function Fja(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;q=u;u=u+1072|0;r=0-o|0;s=q;t=e>>>2;e=k>>>2;k=0-e|0;v=i>>>3;i=Y(o,l)|0;l=i+o|0;w=l<<2;g1c(d|0,0,w|0)|0;x=d+(t+o<<2)|0;if(!g)y=0;else{g1c(g|0,0,l<<3|0)|0;y=g+(v+o<<3)|0}if(!j)z=0;else{g1c(j|0,0,w|0)|0;z=j+(e+o<<2)|0}j=(z|0)==0;if((y|0)==0&j){if((m|0)<=0){u=q;return}w=(i|0)>0;g=c-o|0;A=t-o|0;if((o|0)<=0){u=q;return}B=o+-1|0;C=o<<2;D=x;E=0;F=a;while(1){if(w){G=0;H=D;I=F;while(1){n[H+(r<<2)>>2]=0.0;J=0.0;K=0;do{J=J+ +(h[I+K>>0]|0);n[H+(K<<2)>>2]=+n[H+(K-t<<2)>>2]+J;K=K+o|0}while((K|0)<(i|0));G=G+1|0;if((G|0)==(o|0))break;else{H=H+4|0;I=I+1|0}}}else g1c(D+(r<<2)|0,0,C|0)|0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+(B<<2)+4+(A<<2)|0;F=F+B+1+g|0}}u=q;return}if(j){if((m|0)<=0){u=q;return}j=(i|0)>0;g=c-o|0;B=t-o|0;F=v-o|0;if((o|0)<=0){u=q;return}A=o+-1|0;D=y;E=0;C=x;w=a;while(1){if(j){I=0;H=D;G=C;K=w;while(1){n[G+(r<<2)>>2]=0.0;p[H+(r<<3)>>3]=0.0;J=0.0;L=0.0;M=0;do{N=b[K+M>>0]|0;L=L+ +(N&255);O=+(N&255);J=J+O*O;O=+p[H+(M-v<<3)>>3]+J;n[G+(M<<2)>>2]=+n[G+(M-t<<2)>>2]+L;p[H+(M<<3)>>3]=O;M=M+o|0}while((M|0)<(i|0));I=I+1|0;if((I|0)==(o|0))break;else{H=H+8|0;G=G+4|0;K=K+1|0}}}else{K=0;G=D;H=C;while(1){n[H+(r<<2)>>2]=0.0;p[G+(r<<3)>>3]=0.0;K=K+1|0;if((K|0)==(o|0))break;else{G=G+8|0;H=H+4|0}}}E=E+1|0;if((E|0)==(m|0))break;else{D=D+(A<<3)+8+(F<<3)|0;C=C+(A<<2)+4+(B<<2)|0;w=w+A+1+g|0}}u=q;return}g=s+8|0;f[s>>2]=g;A=s+4|0;f[A>>2]=l;if(l>>>0>264){w=bYc(l>>>0>1073741823?-1:l<<2)|0;f[s>>2]=w;P=w}else P=g;w=(o|0)>0;do if(w){l=(i|0)==(o|0);B=t+(o<<1)|0;C=z+(o<<2)|0;if((i|0)>0){Q=P;R=z;S=0;T=y;U=x;V=a}else{F=P;D=z;E=0;j=y;H=x;while(1){n[D+(r<<2)>>2]=0.0;n[H+(r<<2)>>2]=0.0;if(l)n[F+(o<<2)>>2]=0.0;if(!j)W=0;else{p[j+(r<<3)>>3]=0.0;W=j+8|0}E=E+1|0;if((E|0)==(o|0))break;else{F=F+4|0;D=D+4|0;j=W;H=H+4|0}}X=P+(o<<2)|0;Z=C;_=W;$=a+o|0;aa=d+(B<<2)|0;break}while(1){n[R+(r<<2)>>2]=0.0;n[U+(r<<2)>>2]=0.0;H=(T|0)!=0;if(H){L=0.0;J=0.0;j=0;do{D=b[V+j>>0]|0;O=+(D&255);n[R+(j<<2)>>2]=O;n[Q+(j<<2)>>2]=O;J=J+O;O=+(D&255);L=L+O*O;n[U+(j<<2)>>2]=J;p[T+(j<<3)>>3]=L;j=j+o|0}while((j|0)<(i|0))}else{L=0.0;j=0;do{J=+(h[V+j>>0]|0);n[R+(j<<2)>>2]=J;n[Q+(j<<2)>>2]=J;L=L+J;n[U+(j<<2)>>2]=L;j=j+o|0}while((j|0)<(i|0))}if(l)n[Q+(o<<2)>>2]=0.0;if(H){p[T+(r<<3)>>3]=0.0;ba=T+8|0}else ba=0;S=S+1|0;if((S|0)==(o|0))break;else{Q=Q+4|0;R=R+4|0;T=ba;U=U+4|0;V=V+1|0}}X=P+(o<<2)|0;Z=C;_=ba;$=a+o|0;aa=d+(B<<2)|0}else{X=P;Z=z;_=y;$=a;aa=x}while(0);if((m|0)>1){x=c-o|0;a=t-o|0;y=e-o|0;z=v-o|0;d=0-t|0;ba=0-v|0;V=i-o|0;U=(V|0)>(o|0);T=e+o|0;R=(i|0)>(o|0);i=X;X=Z;Z=1;Q=aa;aa=_;_=$;while(1){$=_+x|0;S=Q+(a<<2)|0;W=X+(y<<2)|0;l=i+(r<<2)|0;j=(aa|0)==0?0:aa+(z<<3)|0;if(w){D=Q+(t<<2)|0;F=l;E=W;G=0;K=S;I=$;M=j;while(1){N=b[I>>0]|0;L=+(N&255);J=+(N&255);O=J*J;n[K+(r<<2)>>2]=0.0;N=(M|0)!=0;if(N)p[M+(r<<3)>>3]=0.0;ca=E+(k<<2)|0;f[E+(r<<2)>>2]=f[ca>>2];n[K>>2]=L+ +n[K+(d<<2)>>2];if(N)p[M>>3]=O+ +p[M+(ba<<3)>>3];n[E>>2]=L+ +n[ca>>2]+ +n[F+(o<<2)>>2];if(U)if(N){J=L;da=O;ea=L;ca=o;while(1){fa=+n[F+(ca<<2)>>2];n[F+(ca-o<<2)>>2]=J+fa;ga=b[I+ca>>0]|0;ha=+(ga&255);ia=+(ga&255);ja=ea+ha;ka=da+ia*ia;n[K+(ca<<2)>>2]=+n[K+(ca-t<<2)>>2]+ja;p[M+(ca<<3)>>3]=ka+ +p[M+(ca-v<<3)>>3];ga=ca+o|0;n[E+(ca<<2)>>2]=fa+(ha+ +n[F+(ga<<2)>>2]+ +n[E+(ca-T<<2)>>2]);if((ga|0)<(V|0)){J=ha;da=ka;ea=ja;ca=ga}else{la=ha;ma=ka;na=ja;oa=ga;break}}}else{ea=L;da=O;J=L;ca=o;while(1){ja=+n[F+(ca<<2)>>2];n[F+(ca-o<<2)>>2]=ea+ja;H=b[I+ca>>0]|0;ka=+(H&255);ha=+(H&255);fa=J+ka;ia=da+ha*ha;n[K+(ca<<2)>>2]=+n[K+(ca-t<<2)>>2]+fa;H=ca+o|0;n[E+(ca<<2)>>2]=ja+(ka+ +n[F+(H<<2)>>2]+ +n[E+(ca-T<<2)>>2]);if((H|0)<(V|0)){ea=ka;da=ia;J=fa;ca=H}else{la=ka;ma=ia;na=fa;oa=H;break}}}else{la=L;ma=O;na=L;oa=o}if(R){ca=F+(oa<<2)|0;J=+n[ca>>2];n[F+(oa-o<<2)>>2]=la+J;H=b[I+oa>>0]|0;da=+(H&255);n[K+(oa<<2)>>2]=+n[K+(oa-t<<2)>>2]+(na+da);ea=+(H&255);if(N)p[M+(oa<<3)>>3]=ma+ea*ea+ +p[M+(oa-v<<3)>>3];n[E+(oa<<2)>>2]=J+da+ +n[E+(oa-T<<2)>>2];n[ca>>2]=da}M=N?M+8|0:0;G=G+1|0;if((G|0)==(o|0))break;else{F=F+4|0;E=E+4|0;K=K+4|0;I=I+1|0}}pa=i;qa=X+(e<<2)|0;ra=_+c|0;sa=D;ta=M}else{pa=l;qa=W;ra=$;sa=S;ta=j}Z=Z+1|0;if((Z|0)==(m|0))break;else{i=pa;X=qa;Q=sa;aa=ta;_=ra}}}if((P|0)!=(g|0)){dYc(P);f[s>>2]=g;f[A>>2]=264}u=q;return}function Gja(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;o=u;u=u+1072|0;p=0-m|0;q=o;r=d>>>2;d=j>>>2;j=0-d|0;s=g>>>2;g=Y(m,k)|0;k=g+m|0;t=k<<2;g1c(c|0,0,t|0)|0;v=c+(r+m<<2)|0;if(!e)w=0;else{g1c(e|0,0,t|0)|0;w=e+(s+m<<2)|0}if(!i)x=0;else{g1c(i|0,0,t|0)|0;x=i+(d+m<<2)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=o;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=o;return}z=m+-1|0;A=m<<2;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){n[F+(p<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +(h[G+I>>0]|0);n[F+(I<<2)>>2]=+n[F+(I-r<<2)>>2]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+4|0;G=G+1|0}}}else g1c(B+(p<<2)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<2)+4+(y<<2)|0;D=D+z+1+e|0}}u=o;return}if(i){if((l|0)<=0){u=o;return}i=(g|0)>0;e=b-m|0;z=r-m|0;D=s-m|0;if((m|0)<=0){u=o;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){n[E+(p<<2)>>2]=0.0;n[F+(p<<2)>>2]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[I+K>>0]|0);J=J+L;H=H+L*L;L=+n[F+(K-s<<2)>>2]+H;n[E+(K<<2)>>2]=+n[E+(K-r<<2)>>2]+J;n[F+(K<<2)>>2]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+4|0;E=E+4|0;I=I+1|0}}}else{I=0;E=B;F=A;while(1){n[F+(p<<2)>>2]=0.0;n[E+(p<<2)>>2]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+4|0;F=F+4|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<2)+4+(D<<2)|0;A=A+(y<<2)+4+(z<<2)|0;t=t+y+1+e|0}}u=o;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>264){t=bYc(k>>>0>1073741823?-1:k<<2)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=r+(m<<1)|0;A=x+(m<<2)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){n[B+(p<<2)>>2]=0.0;n[F+(p<<2)>>2]=0.0;if(k)n[D+(m<<2)>>2]=0.0;if(!i)T=0;else{n[i+(p<<2)>>2]=0.0;T=i+4|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+4|0;B=B+4|0;i=T;F=F+4|0}}U=M+(m<<2)|0;V=A;W=T;X=a+m|0;Z=c+(z<<2)|0;break}while(1){n[O+(p<<2)>>2]=0.0;n[R+(p<<2)>>2]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(h[S+i>>0]|0);n[O+(i<<2)>>2]=L;n[N+(i<<2)>>2]=L;H=H+L;J=J+L*L;n[R+(i<<2)>>2]=H;n[Q+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[S+i>>0]|0);n[O+(i<<2)>>2]=H;n[N+(i<<2)>>2]=H;J=J+H;n[R+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}if(k)n[N+(m<<2)>>2]=0.0;if(F){n[Q+(p<<2)>>2]=0.0;_=Q+4|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+4|0;O=O+4|0;Q=_;R=R+4|0;S=S+1|0}}U=M+(m<<2)|0;V=A;W=_;X=a+m|0;Z=c+(z<<2)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=b-m|0;a=r-m|0;w=d-m|0;x=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+v|0;P=N+(a<<2)|0;T=U+(w<<2)|0;k=g+(p<<2)|0;i=(Z|0)==0?0:Z+(x<<2)|0;if(t){B=N+(r<<2)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(h[G>>0]|0);H=J*J;n[I+(p<<2)>>2]=0.0;$=(K|0)!=0;if($)n[K+(p<<2)>>2]=0.0;aa=C+(j<<2)|0;f[C+(p<<2)>>2]=f[aa>>2];n[I>>2]=J+ +n[I+(c<<2)>>2];if($)n[K>>2]=H+ +n[K+(_<<2)>>2];n[C>>2]=J+ +n[aa>>2]+ +n[D+(m<<2)>>2];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+n[D+(aa<<2)>>2];n[D+(aa-m<<2)>>2]=L+da;ea=+(h[G+aa>>0]|0);fa=ca+ea;ga=ba+ea*ea;n[I+(aa<<2)>>2]=+n[I+(aa-r<<2)>>2]+fa;n[K+(aa<<2)>>2]=ga+ +n[K+(aa-s<<2)>>2];ha=aa+m|0;n[C+(aa<<2)>>2]=da+(ea+ +n[D+(ha<<2)>>2]+ +n[C+(aa-Q<<2)>>2]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+n[D+(aa<<2)>>2];n[D+(aa-m<<2)>>2]=ca+fa;ga=+(h[G+aa>>0]|0);ea=L+ga;da=ba+ga*ga;n[I+(aa<<2)>>2]=+n[I+(aa-r<<2)>>2]+ea;F=aa+m|0;n[C+(aa<<2)>>2]=fa+(ga+ +n[D+(F<<2)>>2]+ +n[C+(aa-Q<<2)>>2]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<2)|0;L=+n[aa>>2];n[D+(la-m<<2)>>2]=ia+L;ba=+(h[G+la>>0]|0);n[I+(la<<2)>>2]=+n[I+(la-r<<2)>>2]+(ka+ba);if($)n[K+(la<<2)>>2]=ja+ba*ba+ +n[K+(la-s<<2)>>2];n[C+(la<<2)>>2]=L+ba+ +n[C+(la-Q<<2)>>2];n[aa>>2]=ba}K=$?K+4|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+4|0;C=C+4|0;I=I+4|0;G=G+1|0}}ma=g;na=U+(d<<2)|0;oa=W+b|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){dYc(M);f[q>>2]=e;f[y>>2]=264}u=o;return}function Hja(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=d>>>3;d=j>>>3;j=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;g1c(c|0,0,t|0)|0;v=c+(r+m<<3)|0;if(!e)w=0;else{g1c(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!i)x=0;else{g1c(i|0,0,t|0)|0;x=i+(d+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(h[G+I>>0]|0);p[F+(I<<3)>>3]=+p[F+(I-r<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+1|0}}}else g1c(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+z+1+e|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;e=b-m|0;z=r-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[I+K>>0]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-r<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+1|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+y+1+e|0}}u=n;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=bYc(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=r+(m<<1)|0;A=x+(m<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!i)T=0;else{p[i+(o<<3)>>3]=0.0;T=i+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;i=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+m|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(h[S+i>>0]|0);p[O+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[Q+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[S+i>>0]|0);p[O+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+1|0}}U=M+(m<<3)|0;V=A;W=_;X=a+m|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=b-m|0;a=r-m|0;w=d-m|0;x=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+v|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=g+(o<<3)|0;i=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(r<<3)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(h[G>>0]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(j<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(h[G+aa>>0]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-r<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(h[G+aa>>0]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-r<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(h[G+la>>0]|0);p[I+(la<<3)>>3]=+p[I+(la-r<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+1|0}}ma=g;na=U+(d<<3)|0;oa=W+b|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){dYc(M);f[q>>2]=e;f[y>>2]=136}u=n;return}function Ija(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;g1c(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!e)w=0;else{g1c(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!h)x=0;else{g1c(h|0,0,t|0)|0;x=h+(d+m<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((l|0)<=0){u=n;return}t=(g|0)>0;e=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(j[G+(I<<1)>>1]|0);p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+2|0}}}else g1c(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<1)+2+(e<<1)|0}}u=n;return}if(h){if((l|0)<=0){u=n;return}h=(g|0)>0;e=r-m|0;z=b-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(j[I+(K<<1)>>1]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+2|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<1)+2+(e<<1)|0}}u=n;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=bYc(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=b+(m<<1)|0;A=x+(m<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;h=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!h)T=0;else{p[h+(o<<3)>>3]=0.0;T=h+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;h=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+(m<<1)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;h=0;do{L=+(j[S+(h<<1)>>1]|0);p[O+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[Q+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+(j[S+(h<<1)>>1]|0);p[O+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+2|0}}U=M+(m<<3)|0;V=A;W=_;X=a+(m<<1)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=r-m|0;a=b-m|0;w=d-m|0;x=s-m|0;c=0-b|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<1)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=g+(o<<3)|0;h=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=k;C=T;E=0;I=P;G=X;K=h;while(1){J=+(j[G>>1]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(i<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(j[G+(aa<<1)>>1]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(j[G+(aa<<1)>>1]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(j[G+(la<<1)>>1]|0);p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+2|0}}ma=g;na=U+(d<<3)|0;oa=W+(r<<1)|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=h}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){dYc(M);f[q>>2]=e;f[y>>2]=136}u=n;return}function Jja(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=e>>>3;e=j>>>3;j=0-e|0;s=h>>>3;h=Y(m,k)|0;k=h+m|0;t=k<<3;g1c(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!g)w=0;else{g1c(g|0,0,t|0)|0;w=g+(s+m<<3)|0}if(!i)x=0;else{g1c(i|0,0,t|0)|0;x=i+(e+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(h|0)>0;g=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(d[G+(I<<1)>>1]|0);p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(h|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+2|0}}}else g1c(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<1)+2+(g<<1)|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(h|0)>0;g=r-m|0;z=b-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(d[I+(K<<1)>>1]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(h|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+2|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<1)+2+(g<<1)|0}}u=n;return}g=q+8|0;f[q>>2]=g;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=bYc(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=g;t=(m|0)>0;do if(t){k=(h|0)==(m|0);z=b+(m<<1)|0;A=x+(m<<3)|0;if((h|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!i)T=0;else{p[i+(o<<3)>>3]=0.0;T=i+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;i=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+(m<<1)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(d[S+(i<<1)>>1]|0);p[O+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[Q+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}else{J=0.0;i=0;do{H=+(d[S+(i<<1)>>1]|0);p[O+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+2|0}}U=M+(m<<3)|0;V=A;W=_;X=a+(m<<1)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=r-m|0;a=b-m|0;w=e-m|0;x=s-m|0;c=0-b|0;_=0-s|0;S=h-m|0;R=(S|0)>(m|0);Q=e+m|0;O=(h|0)>(m|0);h=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<1)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=h+(o<<3)|0;i=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(d[G>>1]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(j<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(d[G+(aa<<1)>>1]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(d[G+(aa<<1)>>1]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(d[G+(la<<1)>>1]|0);p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+2|0}}ma=h;na=U+(e<<3)|0;oa=W+(r<<1)|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{h=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(g|0)){dYc(M);f[q>>2]=g;f[y>>2]=136}u=n;return}function Kja(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;m=u;u=u+1072|0;o=0-l|0;q=m;r=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<2;g1c(c|0,0,t|0)|0;v=c+(b+l<<2)|0;if(!e)w=0;else{g1c(e|0,0,j<<3|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{g1c(h|0,0,t|0)|0;x=h+(d+l<<2)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<2;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){n[F+(o<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +n[G+(I<<2)>>2];n[F+(I<<2)>>2]=+n[F+(I-b<<2)>>2]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+4|0;G=G+4|0}}}else g1c(B+(o<<2)|0,0,A|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{B=B+(z<<2)+4+(y<<2)|0;D=D+(z<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=r-l|0;z=b-l|0;D=s-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){n[E+(o<<2)>>2]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[I+(K<<2)>>2];J=J+L;M=L;H=H+M*M;M=+p[F+(K-s<<3)>>3]+H;n[E+(K<<2)>>2]=+n[E+(K-b<<2)>>2]+J;p[F+(K<<3)>>3]=M;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+4|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){n[F+(o<<2)>>2]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+4|0}}}C=C+1|0;if((C|0)==(k|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<2)+4+(z<<2)|0;t=t+(y<<2)+4+(e<<2)|0}}u=m;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=j;if(j>>>0>264){t=bYc(j>>>0>1073741823?-1:j<<2)|0;f[q>>2]=t;N=t}else N=e;t=(l|0)>0;do if(t){j=(g|0)==(l|0);z=b+(l<<1)|0;A=x+(l<<2)|0;if((g|0)>0){O=N;P=x;Q=0;R=w;S=v;T=a}else{D=N;B=x;C=0;h=w;F=v;while(1){n[B+(o<<2)>>2]=0.0;n[F+(o<<2)>>2]=0.0;if(j)n[D+(l<<2)>>2]=0.0;if(!h)U=0;else{p[h+(o<<3)>>3]=0.0;U=h+8|0}C=C+1|0;if((C|0)==(l|0))break;else{D=D+4|0;B=B+4|0;h=U;F=F+4|0}}V=N+(l<<2)|0;W=A;X=U;Z=a+(l<<2)|0;_=c+(z<<2)|0;break}while(1){n[P+(o<<2)>>2]=0.0;n[S+(o<<2)>>2]=0.0;F=(R|0)!=0;if(F){J=0.0;H=0.0;h=0;do{M=+n[T+(h<<2)>>2];n[P+(h<<2)>>2]=M;n[O+(h<<2)>>2]=M;H=H+M;L=M;J=J+L*L;n[S+(h<<2)>>2]=H;p[R+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[T+(h<<2)>>2];n[P+(h<<2)>>2]=H;n[O+(h<<2)>>2]=H;J=J+H;n[S+(h<<2)>>2]=J;h=h+l|0}while((h|0)<(g|0))}if(j)n[O+(l<<2)>>2]=0.0;if(F){p[R+(o<<3)>>3]=0.0;$=R+8|0}else $=0;Q=Q+1|0;if((Q|0)==(l|0))break;else{O=O+4|0;P=P+4|0;R=$;S=S+4|0;T=T+4|0}}V=N+(l<<2)|0;W=A;X=$;Z=a+(l<<2)|0;_=c+(z<<2)|0}else{V=N;W=x;X=w;Z=a;_=v}while(0);if((k|0)>1){v=r-l|0;a=b-l|0;w=d-l|0;x=s-l|0;c=0-b|0;$=0-s|0;T=g-l|0;S=(T|0)>(l|0);R=d+l|0;P=(g|0)>(l|0);g=V;V=W;W=1;O=_;_=X;X=Z;while(1){Z=X+(v<<2)|0;Q=O+(a<<2)|0;U=V+(w<<2)|0;j=g+(o<<2)|0;h=(_|0)==0?0:_+(x<<3)|0;if(t){B=O+(b<<2)|0;D=j;C=U;E=0;I=Q;G=Z;K=h;while(1){J=+n[G>>2];H=J;L=H*H;n[I+(o<<2)>>2]=0.0;aa=(K|0)!=0;if(aa)p[K+(o<<3)>>3]=0.0;ba=C+(i<<2)|0;f[C+(o<<2)>>2]=f[ba>>2];n[I>>2]=J+ +n[I+(c<<2)>>2];if(aa)p[K>>3]=L+ +p[K+($<<3)>>3];n[C>>2]=J+ +n[ba>>2]+ +n[D+(l<<2)>>2];if(S)if(aa){H=J;M=L;ca=J;ba=l;while(1){da=+n[D+(ba<<2)>>2];n[D+(ba-l<<2)>>2]=H+da;ea=+n[G+(ba<<2)>>2];fa=ea;ga=ca+ea;ha=M+fa*fa;n[I+(ba<<2)>>2]=+n[I+(ba-b<<2)>>2]+ga;p[K+(ba<<3)>>3]=ha+ +p[K+(ba-s<<3)>>3];ia=ba+l|0;n[C+(ba<<2)>>2]=da+(ea+ +n[D+(ia<<2)>>2]+ +n[C+(ba-R<<2)>>2]);if((ia|0)<(T|0)){H=ea;M=ha;ca=ga;ba=ia}else{ja=ea;ka=ha;la=ga;ma=ia;break}}}else{ca=J;M=L;H=J;ba=l;while(1){ga=+n[D+(ba<<2)>>2];n[D+(ba-l<<2)>>2]=ca+ga;ha=+n[G+(ba<<2)>>2];ea=ha;da=H+ha;fa=M+ea*ea;n[I+(ba<<2)>>2]=+n[I+(ba-b<<2)>>2]+da;F=ba+l|0;n[C+(ba<<2)>>2]=ga+(ha+ +n[D+(F<<2)>>2]+ +n[C+(ba-R<<2)>>2]);if((F|0)<(T|0)){ca=ha;M=fa;H=da;ba=F}else{ja=ha;ka=fa;la=da;ma=F;break}}}else{ja=J;ka=L;la=J;ma=l}if(P){ba=D+(ma<<2)|0;H=+n[ba>>2];n[D+(ma-l<<2)>>2]=ja+H;M=+n[G+(ma<<2)>>2];ca=M;n[I+(ma<<2)>>2]=+n[I+(ma-b<<2)>>2]+(la+M);if(aa)p[K+(ma<<3)>>3]=ka+ca*ca+ +p[K+(ma-s<<3)>>3];n[C+(ma<<2)>>2]=H+M+ +n[C+(ma-R<<2)>>2];n[ba>>2]=M}K=aa?K+8|0:0;E=E+1|0;if((E|0)==(l|0))break;else{D=D+4|0;C=C+4|0;I=I+4|0;G=G+4|0}}na=g;oa=V+(d<<2)|0;pa=X+(r<<2)|0;qa=B;ra=K}else{na=j;oa=U;pa=Z;qa=Q;ra=h}W=W+1|0;if((W|0)==(k|0))break;else{g=na;V=oa;O=qa;_=ra;X=pa}}}if((N|0)!=(e|0)){dYc(N);f[q>>2]=e;f[y>>2]=264}u=m;return}function Lja(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1072|0;o=0-l|0;p=m;q=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;r=g>>>2;g=Y(l,j)|0;j=g+l|0;s=j<<2;g1c(c|0,0,s|0)|0;t=c+(b+l<<2)|0;if(!e)v=0;else{g1c(e|0,0,s|0)|0;v=e+(r+l<<2)|0}if(!h)w=0;else{g1c(h|0,0,s|0)|0;w=h+(d+l<<2)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<2;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){n[E+(o<<2)>>2]=0.0;G=0.0;H=0;do{G=G+ +n[F+(H<<2)>>2];n[E+(H<<2)>>2]=+n[E+(H-b<<2)>>2]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+4|0;F=F+4|0}}}else g1c(A+(o<<2)|0,0,z|0)|0;B=B+1|0;if((B|0)==(k|0))break;else{A=A+(y<<2)+4+(x<<2)|0;C=C+(y<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=q-l|0;y=b-l|0;C=r-l|0;if((l|0)<=0){u=m;return}x=l+-1|0;A=v;B=0;z=t;s=a;while(1){if(h){F=0;E=A;D=z;H=s;while(1){n[D+(o<<2)>>2]=0.0;n[E+(o<<2)>>2]=0.0;G=0.0;I=0.0;J=0;do{K=+n[H+(J<<2)>>2];I=I+K;G=G+K*K;K=+n[E+(J-r<<2)>>2]+G;n[D+(J<<2)>>2]=+n[D+(J-b<<2)>>2]+I;n[E+(J<<2)>>2]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+4|0;D=D+4|0;H=H+4|0}}}else{H=0;D=A;E=z;while(1){n[E+(o<<2)>>2]=0.0;n[D+(o<<2)>>2]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+4|0;E=E+4|0}}}B=B+1|0;if((B|0)==(k|0))break;else{A=A+(x<<2)+4+(C<<2)|0;z=z+(x<<2)+4+(y<<2)|0;s=s+(x<<2)+4+(e<<2)|0}}u=m;return}e=p+8|0;f[p>>2]=e;x=p+4|0;f[x>>2]=j;if(j>>>0>264){s=bYc(j>>>0>1073741823?-1:j<<2)|0;f[p>>2]=s;L=s}else L=e;s=(l|0)>0;do if(s){j=(g|0)==(l|0);y=b+(l<<1)|0;z=w+(l<<2)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;h=v;E=t;while(1){n[A+(o<<2)>>2]=0.0;n[E+(o<<2)>>2]=0.0;if(j)n[C+(l<<2)>>2]=0.0;if(!h)S=0;else{n[h+(o<<2)>>2]=0.0;S=h+4|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+4|0;A=A+4|0;h=S;E=E+4|0}}T=L+(l<<2)|0;U=z;V=S;W=a+(l<<2)|0;X=c+(y<<2)|0;break}while(1){n[N+(o<<2)>>2]=0.0;n[Q+(o<<2)>>2]=0.0;E=(P|0)!=0;if(E){I=0.0;G=0.0;h=0;do{K=+n[R+(h<<2)>>2];n[N+(h<<2)>>2]=K;n[M+(h<<2)>>2]=K;G=G+K;I=I+K*K;n[Q+(h<<2)>>2]=G;n[P+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+n[R+(h<<2)>>2];n[N+(h<<2)>>2]=G;n[M+(h<<2)>>2]=G;I=I+G;n[Q+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}if(j)n[M+(l<<2)>>2]=0.0;if(E){n[P+(o<<2)>>2]=0.0;Z=P+4|0}else Z=0;O=O+1|0;if((O|0)==(l|0))break;else{M=M+4|0;N=N+4|0;P=Z;Q=Q+4|0;R=R+4|0}}T=L+(l<<2)|0;U=z;V=Z;W=a+(l<<2)|0;X=c+(y<<2)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((k|0)>1){t=q-l|0;a=b-l|0;v=d-l|0;w=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;N=(g|0)>(l|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+(t<<2)|0;O=M+(a<<2)|0;S=T+(v<<2)|0;j=g+(o<<2)|0;h=(X|0)==0?0:X+(w<<2)|0;if(s){A=M+(b<<2)|0;C=j;B=S;D=0;H=O;F=W;J=h;while(1){I=+n[F>>2];G=I*I;n[H+(o<<2)>>2]=0.0;_=(J|0)!=0;if(_)n[J+(o<<2)>>2]=0.0;$=B+(i<<2)|0;f[B+(o<<2)>>2]=f[$>>2];n[H>>2]=I+ +n[H+(c<<2)>>2];if(_)n[J>>2]=G+ +n[J+(Z<<2)>>2];n[B>>2]=I+ +n[$>>2]+ +n[C+(l<<2)>>2];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+n[C+($<<2)>>2];n[C+($-l<<2)>>2]=K+ca;da=+n[F+($<<2)>>2];ea=ba+da;fa=aa+da*da;n[H+($<<2)>>2]=+n[H+($-b<<2)>>2]+ea;n[J+($<<2)>>2]=fa+ +n[J+($-r<<2)>>2];ga=$+l|0;n[B+($<<2)>>2]=ca+(da+ +n[C+(ga<<2)>>2]+ +n[B+($-P<<2)>>2]);if((ga|0)<(R|0)){K=da;aa=fa;ba=ea;$=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){ea=+n[C+($<<2)>>2];n[C+($-l<<2)>>2]=ba+ea;fa=+n[F+($<<2)>>2];da=K+fa;ca=aa+fa*fa;n[H+($<<2)>>2]=+n[H+($-b<<2)>>2]+da;E=$+l|0;n[B+($<<2)>>2]=ea+(fa+ +n[C+(E<<2)>>2]+ +n[B+($-P<<2)>>2]);if((E|0)<(R|0)){ba=fa;aa=ca;K=da;$=E}else{ha=fa;ia=ca;ja=da;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(N){$=C+(ka<<2)|0;K=+n[$>>2];n[C+(ka-l<<2)>>2]=ha+K;aa=+n[F+(ka<<2)>>2];n[H+(ka<<2)>>2]=+n[H+(ka-b<<2)>>2]+(ja+aa);if(_)n[J+(ka<<2)>>2]=ia+aa*aa+ +n[J+(ka-r<<2)>>2];n[B+(ka<<2)>>2]=K+aa+ +n[B+(ka-P<<2)>>2];n[$>>2]=aa}J=_?J+4|0:0;D=D+1|0;if((D|0)==(l|0))break;else{C=C+4|0;B=B+4|0;H=H+4|0;F=F+4|0}}la=g;ma=T+(d<<2)|0;na=V+(q<<2)|0;oa=A;pa=J}else{la=j;ma=S;na=W;oa=O;pa=h}U=U+1|0;if((U|0)==(k|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){dYc(L);f[p>>2]=e;f[x>>2]=264}u=m;return}function Mja(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;m=u;u=u+1104|0;o=0-l|0;q=m;r=b>>>2;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<3;g1c(c|0,0,t|0)|0;v=c+(b+l<<3)|0;if(!e)w=0;else{g1c(e|0,0,t|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{g1c(h|0,0,t|0)|0;x=h+(d+l<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +n[G+(I<<2)>>2];p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+8|0;G=G+4|0}}}else g1c(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=r-l|0;z=b-l|0;D=s-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[I+(K<<2)>>2];J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+8|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(k|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<2)+4+(e<<2)|0}}u=m;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=j;if(j>>>0>136){t=bYc(j>>>0>536870911?-1:j<<3)|0;f[q>>2]=t;M=t}else M=e;t=(l|0)>0;do if(t){j=(g|0)==(l|0);z=b+(l<<1)|0;A=x+(l<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;h=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(j)p[D+(l<<3)>>3]=0.0;if(!h)T=0;else{p[h+(o<<3)>>3]=0.0;T=h+8|0}C=C+1|0;if((C|0)==(l|0))break;else{D=D+8|0;B=B+8|0;h=T;F=F+8|0}}U=M+(l<<3)|0;V=A;W=T;X=a+(l<<2)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;h=0;do{L=+n[S+(h<<2)>>2];p[O+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[Q+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[S+(h<<2)>>2];p[O+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}if(j)p[N+(l<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(l|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+4|0}}U=M+(l<<3)|0;V=A;W=_;X=a+(l<<2)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((k|0)>1){v=r-l|0;a=b-l|0;w=d-l|0;x=s-l|0;c=0-b|0;_=0-s|0;S=g-l|0;R=(S|0)>(l|0);Q=d+l|0;O=(g|0)>(l|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<2)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;j=g+(o<<3)|0;h=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=j;C=T;E=0;I=P;G=X;K=h;while(1){J=+n[G>>2];H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(i<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(l<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=l;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-l<<3)>>3]=L+da;ea=+n[G+(aa<<2)>>2];fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+l|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=l;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-l<<3)>>3]=ca+fa;ga=+n[G+(aa<<2)>>2];ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+l|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=l}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-l<<3)>>3]=ia+L;ba=+n[G+(la<<2)>>2];p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(l|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+4|0}}ma=g;na=U+(d<<3)|0;oa=W+(r<<2)|0;pa=B;qa=K}else{ma=j;na=T;oa=X;pa=P;qa=h}V=V+1|0;if((V|0)==(k|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){dYc(M);f[q>>2]=e;f[y>>2]=136}u=m;return}function Nja(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1104|0;n=0-l|0;o=m;q=b>>>3;b=d>>>3;d=i>>>3;i=0-d|0;r=g>>>3;g=Y(l,j)|0;j=g+l|0;s=j<<3;g1c(c|0,0,s|0)|0;t=c+(b+l<<3)|0;if(!e)v=0;else{g1c(e|0,0,s|0)|0;v=e+(r+l<<3)|0}if(!h)w=0;else{g1c(h|0,0,s|0)|0;w=h+(d+l<<3)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<3;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){p[E+(n<<3)>>3]=0.0;G=0.0;H=0;do{G=G+ +p[F+(H<<3)>>3];p[E+(H<<3)>>3]=+p[E+(H-b<<3)>>3]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}else g1c(A+(n<<3)|0,0,z|0)|0;B=B+1|0;if((B|0)==(k|0))break;else{A=A+(y<<3)+8+(x<<3)|0;C=C+(y<<3)+8+(e<<3)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=q-l|0;y=b-l|0;C=r-l|0;if((l|0)<=0){u=m;return}x=l+-1|0;A=v;B=0;z=t;s=a;while(1){if(h){F=0;E=A;D=z;H=s;while(1){p[D+(n<<3)>>3]=0.0;p[E+(n<<3)>>3]=0.0;G=0.0;I=0.0;J=0;do{K=+p[H+(J<<3)>>3];I=I+K;G=G+K*K;K=+p[E+(J-r<<3)>>3]+G;p[D+(J<<3)>>3]=+p[D+(J-b<<3)>>3]+I;p[E+(J<<3)>>3]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+8|0;D=D+8|0;H=H+8|0}}}else{H=0;D=A;E=z;while(1){p[E+(n<<3)>>3]=0.0;p[D+(n<<3)>>3]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+8|0;E=E+8|0}}}B=B+1|0;if((B|0)==(k|0))break;else{A=A+(x<<3)+8+(C<<3)|0;z=z+(x<<3)+8+(y<<3)|0;s=s+(x<<3)+8+(e<<3)|0}}u=m;return}e=o+8|0;f[o>>2]=e;x=o+4|0;f[x>>2]=j;if(j>>>0>136){s=bYc(j>>>0>536870911?-1:j<<3)|0;f[o>>2]=s;L=s}else L=e;s=(l|0)>0;do if(s){j=(g|0)==(l|0);y=b+(l<<1)|0;z=w+(l<<3)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;h=v;E=t;while(1){p[A+(n<<3)>>3]=0.0;p[E+(n<<3)>>3]=0.0;if(j)p[C+(l<<3)>>3]=0.0;if(!h)S=0;else{p[h+(n<<3)>>3]=0.0;S=h+8|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+8|0;A=A+8|0;h=S;E=E+8|0}}T=L+(l<<3)|0;U=z;V=S;W=a+(l<<3)|0;X=c+(y<<3)|0;break}while(1){p[N+(n<<3)>>3]=0.0;p[Q+(n<<3)>>3]=0.0;E=(P|0)!=0;if(E){I=0.0;G=0.0;h=0;do{K=+p[R+(h<<3)>>3];p[N+(h<<3)>>3]=K;p[M+(h<<3)>>3]=K;G=G+K;I=I+K*K;p[Q+(h<<3)>>3]=G;p[P+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+p[R+(h<<3)>>3];p[N+(h<<3)>>3]=G;p[M+(h<<3)>>3]=G;I=I+G;p[Q+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}if(j)p[M+(l<<3)>>3]=0.0;if(E){p[P+(n<<3)>>3]=0.0;Z=P+8|0}else Z=0;O=O+1|0;if((O|0)==(l|0))break;else{M=M+8|0;N=N+8|0;P=Z;Q=Q+8|0;R=R+8|0}}T=L+(l<<3)|0;U=z;V=Z;W=a+(l<<3)|0;X=c+(y<<3)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((k|0)>1){t=q-l|0;a=b-l|0;v=d-l|0;w=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;N=(g|0)>(l|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+(t<<3)|0;O=M+(a<<3)|0;S=T+(v<<3)|0;j=g+(n<<3)|0;h=(X|0)==0?0:X+(w<<3)|0;if(s){A=M+(b<<3)|0;C=j;B=S;D=0;H=O;F=W;J=h;while(1){I=+p[F>>3];G=I*I;p[H+(n<<3)>>3]=0.0;_=(J|0)!=0;if(_)p[J+(n<<3)>>3]=0.0;$=B+(i<<3)|0;p[B+(n<<3)>>3]=+p[$>>3];p[H>>3]=I+ +p[H+(c<<3)>>3];if(_)p[J>>3]=G+ +p[J+(Z<<3)>>3];p[B>>3]=I+ +p[$>>3]+ +p[C+(l<<3)>>3];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+p[C+($<<3)>>3];p[C+($-l<<3)>>3]=K+ca;da=+p[F+($<<3)>>3];ea=ba+da;fa=aa+da*da;p[H+($<<3)>>3]=+p[H+($-b<<3)>>3]+ea;p[J+($<<3)>>3]=fa+ +p[J+($-r<<3)>>3];ga=$+l|0;p[B+($<<3)>>3]=ca+(da+ +p[C+(ga<<3)>>3]+ +p[B+($-P<<3)>>3]);if((ga|0)<(R|0)){K=da;aa=fa;ba=ea;$=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){ea=+p[C+($<<3)>>3];p[C+($-l<<3)>>3]=ba+ea;fa=+p[F+($<<3)>>3];da=K+fa;ca=aa+fa*fa;p[H+($<<3)>>3]=+p[H+($-b<<3)>>3]+da;E=$+l|0;p[B+($<<3)>>3]=ea+(fa+ +p[C+(E<<3)>>3]+ +p[B+($-P<<3)>>3]);if((E|0)<(R|0)){ba=fa;aa=ca;K=da;$=E}else{ha=fa;ia=ca;ja=da;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(N){$=C+(ka<<3)|0;K=+p[$>>3];p[C+(ka-l<<3)>>3]=ha+K;aa=+p[F+(ka<<3)>>3];p[H+(ka<<3)>>3]=+p[H+(ka-b<<3)>>3]+(ja+aa);if(_)p[J+(ka<<3)>>3]=ia+aa*aa+ +p[J+(ka-r<<3)>>3];p[B+(ka<<3)>>3]=K+aa+ +p[B+(ka-P<<3)>>3];p[$>>3]=aa}J=_?J+8|0:0;D=D+1|0;if((D|0)==(l|0))break;else{C=C+8|0;B=B+8|0;H=H+8|0;F=F+8|0}}la=g;ma=T+(d<<3)|0;na=V+(q<<3)|0;oa=A;pa=J}else{la=j;ma=S;na=W;oa=O;pa=h}U=U+1|0;if((U|0)==(k|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){dYc(L);f[o>>2]=e;f[x>>2]=136}u=m;return}function Oja(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=u;u=u+320|0;i=h+304|0;j=h+240|0;k=h+248|0;l=h+184|0;m=h+128|0;n=h+72|0;o=h+8|0;p=h+16|0;q=h;r=dS(a,-1)|0;s=r&7;t=r>>>3&511;r=t+1|0;v=((e|0)<1?((s|0)==0?4:6):e)&7;e=(g|0)<1?6:g&7;cS(i,a,-1);g=(f[i>>2]|0)+1|0;w=(f[i+4>>2]|0)+1|0;f[j>>2]=g;f[j+4>>2]=w;i=t<<3;t=v|i;wS(b,j,t,-1,0,0);do if((eS(a)|0)==65536){j=f[a+4>>2]|0;f[k>>2]=f[j>>2];x=k+4|0;y=j+4|0;f[x>>2]=f[y>>2];z=k+8|0;f[z>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];A=f[j+36>>2]|0;f[k+36>>2]=A;f[k+40>>2]=z;z=k+48|0;B=k+44|0;f[B>>2]=z;f[z>>2]=0;f[k+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[j+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(k,j);break}}else bS(k,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[l>>2]=f[a>>2];j=l+4|0;x=a+4|0;f[j>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];z=f[a+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;B=l+44|0;f[B>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[a+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[j>>2]=0;U$(l,a);break}}else bS(l,b,-1);while(0);f[m>>2]=1124007936;b=m+4|0;a=m+8|0;j=m+40|0;x=b;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[j>>2]=a;B=m+48|0;z=m+44|0;f[z>>2]=B;f[B>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;A=n+4|0;C=n+8|0;D=n+40|0;x=A;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[D>>2]=C;x=n+48|0;y=n+44|0;f[y>>2]=x;f[x>>2]=0;f[n+52>>2]=0;if(aT(c)|0){f[o>>2]=g;f[o+4>>2]=w;wS(c,o,i|e,-1,0,0);do if((eS(c)|0)==65536){i=f[c+4>>2]|0;f[p>>2]=f[i>>2];o=p+4|0;E=i+4|0;f[o>>2]=f[E>>2];F=p+8|0;f[F>>2]=f[i+8>>2];f[p+12>>2]=f[i+12>>2];f[p+16>>2]=f[i+16>>2];f[p+20>>2]=f[i+20>>2];f[p+24>>2]=f[i+24>>2];f[p+28>>2]=f[i+28>>2];f[p+32>>2]=f[i+32>>2];G=f[i+36>>2]|0;f[p+36>>2]=G;f[p+40>>2]=F;F=p+48|0;H=p+44|0;f[H>>2]=F;f[F>>2]=0;f[p+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[i+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[o>>2]=0;U$(p,i);break}}else bS(p,c,-1);while(0);c=m+36|0;i=f[c>>2]|0;if(i|0?(o=i+12|0,i=f[o>>2]|0,f[o>>2]=i+-1,(i|0)==1):0)V$(m);f[c>>2]=0;i=m+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[b>>2]|0)>0){o=f[j>>2]|0;E=0;do{f[o+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[b>>2]|0))}f[m>>2]=f[p>>2];E=p+4|0;o=f[E>>2]|0;f[b>>2]=o;F=p+8|0;f[a>>2]=f[F>>2];f[m+12>>2]=f[p+12>>2];H=p+16|0;f[i>>2]=f[H>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];i=p+36|0;f[c>>2]=f[i>>2];c=m+44|0;G=f[c>>2]|0;if((G|0)==(B|0))I=o;else{wL(G);f[c>>2]=B;f[j>>2]=a;I=f[E>>2]|0}a=p+44|0;if((I|0)<3){I=f[a>>2]|0;f[B>>2]=f[I>>2];f[m+52>>2]=f[I+4>>2];J=I}else{f[c>>2]=f[a>>2];c=p+40|0;f[m+40>>2]=f[c>>2];I=p+48|0;f[a>>2]=I;f[c>>2]=F;J=I}f[p>>2]=1124007936;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[E+28>>2]=0;f[i>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((J|0)!=(p+48|0))wL(J)}if(aT(d)|0){f[q>>2]=g;f[q+4>>2]=w;wS(d,q,t,-1,0,0);do if((eS(d)|0)==65536){t=f[d+4>>2]|0;f[p>>2]=f[t>>2];q=p+4|0;w=t+4|0;f[q>>2]=f[w>>2];g=p+8|0;f[g>>2]=f[t+8>>2];f[p+12>>2]=f[t+12>>2];f[p+16>>2]=f[t+16>>2];f[p+20>>2]=f[t+20>>2];f[p+24>>2]=f[t+24>>2];f[p+28>>2]=f[t+28>>2];f[p+32>>2]=f[t+32>>2];J=f[t+36>>2]|0;f[p+36>>2]=J;f[p+40>>2]=g;g=p+48|0;H=p+44|0;f[H>>2]=g;f[g>>2]=0;f[p+52>>2]=0;if(J|0){g=J+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;g=f[H>>2]|0;f[g>>2]=f[w>>2];f[g+4>>2]=f[w+4>>2];break}else{f[q>>2]=0;U$(p,t);break}}else bS(p,d,-1);while(0);d=n+36|0;t=f[d>>2]|0;if(t|0?(q=t+12|0,t=f[q>>2]|0,f[q>>2]=t+-1,(t|0)==1):0)V$(n);f[d>>2]=0;t=n+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[A>>2]|0)>0){q=f[D>>2]|0;w=0;do{f[q+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[A>>2]|0))}f[n>>2]=f[p>>2];w=p+4|0;q=f[w>>2]|0;f[A>>2]=q;g=p+8|0;f[C>>2]=f[g>>2];f[n+12>>2]=f[p+12>>2];H=p+16|0;f[t>>2]=f[H>>2];f[n+20>>2]=f[p+20>>2];f[n+24>>2]=f[p+24>>2];f[n+28>>2]=f[p+28>>2];f[n+32>>2]=f[p+32>>2];J=p+36|0;f[d>>2]=f[J>>2];d=n+44|0;i=f[d>>2]|0;if((i|0)==(x|0))K=q;else{wL(i);f[d>>2]=x;f[D>>2]=C;K=f[w>>2]|0}C=p+44|0;if((K|0)<3){K=f[C>>2]|0;f[x>>2]=f[K>>2];f[n+52>>2]=f[K+4>>2];L=K}else{f[d>>2]=f[C>>2];d=p+40|0;f[n+40>>2]=f[d>>2];K=p+48|0;f[C>>2]=K;f[d>>2]=g;L=K}f[p>>2]=1124007936;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[w+24>>2]=0;f[w+28>>2]=0;f[J>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((L|0)!=(p+48|0))wL(L);M=t}else M=n+16|0;t=k+16|0;L=k+44|0;p=k+48|0;H=l+16|0;J=l+44|0;w=l+48|0;K=m+16|0;Bja(s,v,e,f[t>>2]|0,f[p>>2]|0,f[H>>2]|0,f[w>>2]|0,f[K>>2]|0,f[B>>2]|0,f[M>>2]|0,f[x>>2]|0,f[k+12>>2]|0,f[k+8>>2]|0,r);r=n+36|0;e=f[r>>2]|0;if(e|0?(v=e+12|0,e=f[v>>2]|0,f[v>>2]=e+-1,(e|0)==1):0)V$(n);f[r>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[A>>2]|0)>0){M=f[D>>2]|0;D=0;do{f[M+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[A>>2]|0))}A=f[y>>2]|0;if((A|0)!=(x|0))wL(A);A=m+36|0;x=f[A>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)V$(m);f[A>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[b>>2]|0)>0){K=f[j>>2]|0;j=0;do{f[K+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[b>>2]|0))}b=f[z>>2]|0;if((b|0)!=(B|0))wL(b);b=l+36|0;B=f[b>>2]|0;if(B|0?(z=B+12|0,B=f[z>>2]|0,f[z>>2]=B+-1,(B|0)==1):0)V$(l);f[b>>2]=0;b=l+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[b>>2]|0)>0){H=f[l+40>>2]|0;l=0;do{f[H+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[b>>2]|0))}b=f[J>>2]|0;if((b|0)!=(w|0))wL(b);b=k+36|0;w=f[b>>2]|0;if(w|0?(J=w+12|0,w=f[J>>2]|0,f[J>>2]=w+-1,(w|0)==1):0)V$(k);f[b>>2]=0;b=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[b>>2]|0)>0){t=f[k+40>>2]|0;k=0;do{f[t+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[b>>2]|0))}b=f[L>>2]|0;if((b|0)==(p|0)){u=h;return}wL(b);u=h;return}function Pja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fT()|0;Oja(a,b,d,fT()|0,c,-1);return}function Qja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Oja(a,b,c,fT()|0,d,e);return}function Rja(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;m=u;u=u+416|0;o=m+48|0;q=m+352|0;r=m+296|0;s=m+240|0;t=m+32|0;v=m+216|0;w=m+160|0;x=m+104|0;y=m+232|0;z=m;if(!((d|0)>-1&(e>0.0&g>=0.0))){A=$Xc(64)|0;f[o>>2]=A;f[o+8>>2]=-2147483584;f[o+4>>2]=55;B=A;C=264167;D=B+55|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[A+55>>0]=0;vM(-215,o,264223,264243,364)}if(!(sS(h)|0)){if(dS(h,-1)|0){E=$Xc(80)|0;f[o>>2]=E;F=o+8|0;f[F>>2]=-2147483568;G=o+4|0;f[G>>2]=68;B=E;C=264321;D=B+68|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));H=E+68|0;b[H>>0]=0;vM(-215,o,264223,264243,365)}if(!(nS(h,a)|0)){E=$Xc(80)|0;f[o>>2]=E;F=o+8|0;f[F>>2]=-2147483568;G=o+4|0;f[G>>2]=68;B=E;C=264321;D=B+68|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));H=E+68|0;b[H>>0]=0;vM(-215,o,264223,264243,365)}}do if((eS(a)|0)==65536){H=f[a+4>>2]|0;f[q>>2]=f[H>>2];E=q+4|0;C=H+4|0;f[E>>2]=f[C>>2];G=q+8|0;f[G>>2]=f[H+8>>2];f[q+12>>2]=f[H+12>>2];F=q+16|0;f[F>>2]=f[H+16>>2];f[q+20>>2]=f[H+20>>2];f[q+24>>2]=f[H+24>>2];f[q+28>>2]=f[H+28>>2];f[q+32>>2]=f[H+32>>2];A=f[H+36>>2]|0;f[q+36>>2]=A;f[q+40>>2]=G;G=q+48|0;I=q+44|0;f[I>>2]=G;f[G>>2]=0;f[q+52>>2]=0;if(A|0){G=A+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[C>>2]|0)<3){C=f[H+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[C>>2];f[G+4>>2]=f[C+4>>2];J=F;break}else{f[E>>2]=0;U$(q,H);J=F;break}}else{bS(q,a,-1);J=q+16|0}while(0);f[r>>2]=1124007936;a=r+4|0;F=r+8|0;H=r+40|0;B=a;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[H>>2]=F;F=r+48|0;E=r+44|0;f[E>>2]=F;f[F>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;C=s+4|0;G=s+8|0;I=s+40|0;B=C;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[I>>2]=G;G=s+48|0;A=s+44|0;f[A>>2]=G;f[G>>2]=0;f[s+52>>2]=0;if(f[J>>2]|0){K=f[q+4>>2]|0;if((K|0)<3)L=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{M=f[q+40>>2]|0;N=0;O=1;while(1){P=Y(f[M+(N<<2)>>2]|0,O)|0;N=N+1|0;if((N|0)==(K|0)){L=P;break}else O=P}}if(!((K|0)==0|(L|0)==0)){if(k){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=q;k=t+8|0;f[k>>2]=0;f[k+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=r;$Ba(o,t,i,j,l,4)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=q;k=t+8|0;f[k>>2]=0;f[k+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=r;ZBa(o,t,i,j,4)}p[t>>3]=0.0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;SP(o,0,t,0,0,h);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;j=v+8|0;f[j>>2]=0;f[j+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=r;+_na(o,v,+p[t>>3]*e,0.0,3);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;t=v+8|0;f[t>>2]=0;f[t+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;f[x>>2]=1124007936;t=x+4|0;j=x+8|0;i=x+40|0;B=t;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[i>>2]=j;j=x+48|0;B=x+44|0;f[B>>2]=j;f[j>>2]=0;f[x+52>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=x;f[y>>2]=-1;f[y+4>>2]=-1;p[z>>3]=1797693134862315708145274.0e284;p[z+8>>3]=1797693134862315708145274.0e284;p[z+16>>3]=1797693134862315708145274.0e284;p[z+24>>3]=1797693134862315708145274.0e284;XBa(o,v,w,y,1,0,z);y=x+36|0;D=f[y>>2]|0;if(D|0?(k=D+12|0,D=f[k>>2]|0,f[k>>2]=D+-1,(D|0)==1):0)V$(x);f[y>>2]=0;y=x+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[t>>2]|0)>0){y=f[i>>2]|0;i=0;do{f[y+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[t>>2]|0))}t=f[B>>2]|0;if((t|0)!=(j|0))wL(t);t=f[q+40>>2]|0;j=f[t+4>>2]|0;B=f[t>>2]|0;f[v>>2]=0;t=v+4|0;f[t>>2]=0;f[v+8>>2]=0;do if((eS(h)|0)==65536){i=f[h+4>>2]|0;f[w>>2]=f[i>>2];y=w+4|0;D=i+4|0;f[y>>2]=f[D>>2];k=w+8|0;f[k>>2]=f[i+8>>2];f[w+12>>2]=f[i+12>>2];f[w+16>>2]=f[i+16>>2];f[w+20>>2]=f[i+20>>2];f[w+24>>2]=f[i+24>>2];f[w+28>>2]=f[i+28>>2];f[w+32>>2]=f[i+32>>2];L=f[i+36>>2]|0;f[w+36>>2]=L;f[w+40>>2]=k;k=w+48|0;K=w+44|0;f[K>>2]=k;f[k>>2]=0;f[w+52>>2]=0;if(L|0){k=L+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[D>>2]|0)<3){D=f[i+44>>2]|0;k=f[K>>2]|0;f[k>>2]=f[D>>2];f[k+4>>2]=f[D+4>>2];break}else{f[y>>2]=0;U$(w,i);break}}else bS(w,h,-1);while(0);h=B+-1|0;if((h|0)>1?(B=r+16|0,i=s+16|0,y=w+16|0,D=j+-1|0,j=v+8|0,k=w+44|0,(D|0)>1):0){K=1;do{L=(f[B>>2]|0)+(Y(f[f[E>>2]>>2]|0,K)|0)|0;O=(f[i>>2]|0)+(Y(f[f[A>>2]>>2]|0,K)|0)|0;N=f[y>>2]|0;if((N|0)!=0?(M=N+(Y(f[f[k>>2]>>2]|0,K)|0)|0,(M|0)!=0):0){N=1;do{P=L+(N<<2)|0;e=+n[P>>2];do if(e!=0.0){if(!(e==+n[O+(N<<2)>>2]))break;if(!(b[M+N>>0]|0))break;f[o>>2]=P;Q=f[t>>2]|0;if(Q>>>0<(f[j>>2]|0)>>>0){f[Q>>2]=P;f[t>>2]=(f[t>>2]|0)+4}else Sja(v,o)}while(0);N=N+1|0}while((N|0)<(D|0))}else{R=1;S=52}if((S|0)==52)while(1){S=0;N=L+(R<<2)|0;e=+n[N>>2];do if(e!=0.0){if(!(e==+n[O+(R<<2)>>2]))break;f[o>>2]=N;M=f[t>>2]|0;if(M>>>0<(f[j>>2]|0)>>>0){f[M>>2]=N;f[t>>2]=(f[t>>2]|0)+4}else Sja(v,o)}while(0);R=R+1|0;if((R|0)>=(D|0))break;else S=52}K=K+1|0}while((K|0)<(h|0))}f[x>>2]=0;h=x+4|0;f[h>>2]=0;f[x+8>>2]=0;K=f[t>>2]|0;D=f[v>>2]|0;R=K-D>>2;if(R){Tja(D,K,o);if(!(g>=1.0)){K=r+16|0;D=o+4|0;j=x+8|0;if((d|0)>0){k=0;do{y=(f[(f[v>>2]|0)+(k<<2)>>2]|0)-(f[K>>2]|0)|0;i=f[F>>2]|0;B=(y>>>0)/(i>>>0)|0;e=+((y-(Y(B,i)|0)|0)>>>2|0);n[o>>2]=e;n[D>>2]=+(B|0);B=f[h>>2]|0;if(B>>>0<(f[j>>2]|0)>>>0){n[B>>2]=e;f[B+4>>2]=f[D>>2];f[h>>2]=B+8}else Uja(x,o);k=k+1|0}while((k|0)!=(d|0)&k>>>0<R>>>0)}else{k=0;do{B=(f[(f[v>>2]|0)+(k<<2)>>2]|0)-(f[K>>2]|0)|0;i=f[F>>2]|0;y=(B>>>0)/(i>>>0)|0;e=+((B-(Y(y,i)|0)|0)>>>2|0);n[o>>2]=e;n[D>>2]=+(y|0);y=f[h>>2]|0;if(y>>>0<(f[j>>2]|0)>>>0){n[y>>2]=e;f[y+4>>2]=f[D>>2];f[h>>2]=y+8}else Uja(x,o);k=k+1|0}while(k>>>0<R>>>0)}}else{k=f[q+12>>2]|0;D=f[q+8>>2]|0;j=zLc(g)|0;K=(k+-1+j|0)/(j|0)|0;k=(D+-1+j|0)/(j|0)|0;Vja(o,Y(k,K)|0);e=g*g;D=r+16|0;y=K+-1|0;i=k+-1|0;k=z+4|0;B=z+4|0;O=x+8|0;L=(d|0)>0;N=0;M=0;while(1){P=(f[(f[v>>2]|0)+(N<<2)>>2]|0)-(f[D>>2]|0)|0;Q=f[F>>2]|0;T=(P>>>0)/(Q>>>0)|0;U=(P-(Y(T,Q)|0)|0)>>>2;Q=(U|0)/(j|0)|0;P=(T|0)/(j|0)|0;V=Q+-1|0;W=P+-1|0;X=Q+1|0;Z=P+1|0;_=(V|0)>0?V:0;V=(W|0)>0?W:0;W=(X|0)<(y|0)?X:y;X=(Z|0)<(i|0)?Z:i;do if((V|0)<=(X|0)){Z=f[o>>2]|0;g=+(U|0);l=+(T|0);if((_|0)>(W|0)){$=g;aa=l;ba=Z;S=80;break}else{ca=V;da=1}a:while(1){ea=Y(ca,K)|0;fa=_;ga=da;while(1){ha=fa+ea|0;ia=f[Z+(ha*12|0)+4>>2]|0;ja=f[Z+(ha*12|0)>>2]|0;ha=ja;if((ia|0)==(ja|0))ka=ga;else{la=ia-ja>>3;ja=0;ia=ga;while(1){ma=g-+n[ha+(ja<<3)>>2];na=l-+n[ha+(ja<<3)+4>>2];oa=ma*ma+na*na<e;pa=ia&(oa^1);ja=ja+1|0;if(oa){S=79;break a}if(ja>>>0>=la>>>0){ka=pa;break}else ia=pa}}if((fa|0)<(W|0)){fa=fa+1|0;ga=ka}else break}if((ca|0)<(X|0)){ca=ca+1|0;da=ka}else{S=72;break}}if((S|0)==72){S=0;if(ka){$=g;aa=l;ba=Z;S=80;break}else{qa=M;break}}else if((S|0)==79){S=0;if(pa){$=g;aa=l;ba=Z;S=80;break}else{qa=M;break}}}else{$=+(U|0);aa=+(T|0);ba=f[o>>2]|0;S=80}while(0);if((S|0)==80){S=0;T=(Y(P,K)|0)+Q|0;n[z>>2]=$;n[k>>2]=aa;U=ba+(T*12|0)+4|0;X=f[U>>2]|0;if(X>>>0<(f[ba+(T*12|0)+8>>2]|0)>>>0){n[X>>2]=$;f[X+4>>2]=f[k>>2];f[U>>2]=X+8}else Uja(ba+(T*12|0)|0,z);n[z>>2]=$;n[B>>2]=aa;T=f[h>>2]|0;if(T>>>0<(f[O>>2]|0)>>>0){n[T>>2]=$;f[T+4>>2]=f[B>>2];f[h>>2]=T+8}else Uja(x,z);T=M+1|0;if(L&(T|0)==(d|0))break;else qa=T}N=N+1|0;if(N>>>0>=R>>>0)break;else M=qa}qa=f[o>>2]|0;if(qa|0){M=o+4|0;R=f[M>>2]|0;if((R|0)==(qa|0))ra=qa;else{N=R;while(1){R=N+-12|0;f[M>>2]=R;d=f[R>>2]|0;if(!d)sa=R;else{R=N+-8|0;L=f[R>>2]|0;if((L|0)!=(d|0))f[R>>2]=L+(~((L+-8-d|0)>>>3)<<3);cYc(d);sa=f[M>>2]|0}if((sa|0)==(qa|0))break;else N=sa}ra=f[o>>2]|0}cYc(ra)}}f[o>>2]=1124024333;ra=o+4|0;f[ra>>2]=2;sa=o+8|0;N=f[h>>2]|0;qa=f[x>>2]|0;M=N-qa|0;f[sa>>2]=M>>3;f[o+12>>2]=1;d=o+16|0;L=o+40|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[L>>2]=sa;sa=o+48|0;R=o+44|0;f[R>>2]=sa;f[sa>>2]=0;z=o+52|0;f[z>>2]=0;B=qa;if((B|0)!=(N|0)){f[z>>2]=8;f[sa>>2]=8;f[d>>2]=B;f[o+20>>2]=B;B=qa+M|0;f[o+24>>2]=B;f[o+28>>2]=B}if(YS(c)|0)ta=dS(c,-1)|0;else ta=5;dY(o,c,ta,1.0,0.0);ta=o+36|0;B=f[ta>>2]|0;do if(B|0){M=B+12|0;qa=f[M>>2]|0;f[M>>2]=qa+-1;if((qa|0)!=1)break;V$(o)}while(0);f[ta>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[ra>>2]|0)>0){d=f[L>>2]|0;L=0;do{f[d+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[ra>>2]|0))}ra=f[R>>2]|0;if((ra|0)!=(sa|0))wL(ra)}else vS(c);ra=f[x>>2]|0;if(ra|0){x=f[h>>2]|0;if((x|0)!=(ra|0))f[h>>2]=x+(~((x+-8-ra|0)>>>3)<<3);cYc(ra)}ra=w+36|0;x=f[ra>>2]|0;if(x|0?(h=x+12|0,x=f[h>>2]|0,f[h>>2]=x+-1,(x|0)==1):0)V$(w);f[ra>>2]=0;ra=w+16|0;x=w+4|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[x>>2]|0)>0){ra=f[w+40>>2]|0;h=0;do{f[ra+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[x>>2]|0))}x=f[w+44>>2]|0;if((x|0)!=(w+48|0))wL(x);x=f[v>>2]|0;if(x|0){v=f[t>>2]|0;if((v|0)!=(x|0))f[t>>2]=v+(~((v+-4-x|0)>>>2)<<2);cYc(x)}}else S=20}else S=20;if((S|0)==20)vS(c);c=s+36|0;S=f[c>>2]|0;if(S|0?(x=S+12|0,S=f[x>>2]|0,f[x>>2]=S+-1,(S|0)==1):0)V$(s);f[c>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[C>>2]|0)>0){c=f[I>>2]|0;I=0;do{f[c+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[C>>2]|0))}C=f[A>>2]|0;if((C|0)!=(G|0))wL(C);C=r+36|0;G=f[C>>2]|0;if(G|0?(A=G+12|0,G=f[A>>2]|0,f[A>>2]=G+-1,(G|0)==1):0)V$(r);f[C>>2]=0;C=r+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[a>>2]|0)>0){C=f[H>>2]|0;H=0;do{f[C+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[a>>2]|0))}a=f[E>>2]|0;if((a|0)!=(F|0))wL(a);a=q+36|0;F=f[a>>2]|0;if(F|0?(E=F+12|0,F=f[E>>2]|0,f[E>>2]=F+-1,(F|0)==1):0)V$(q);f[a>>2]=0;a=q+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[a>>2]|0)>0){J=f[q+40>>2]|0;F=0;do{f[J+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[a>>2]|0))}a=f[q+44>>2]|0;if((a|0)==(q+48|0)){u=m;return}wL(a);u=m;return}function Sja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function Tja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=8;break a;break}case 4:{l=24;break a;break}case 5:{l=25;break a;break}case 1:case 0:{l=89;break a;break}default:{}}if((j|0)<124){l=27;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)>3996){o=(k|0)/4|0;p=Xja(h,h+(o<<2)|0,m,m+(o<<2)|0,e,c)|0}else{o=f[m>>2]|0;q=f[h>>2]|0;r=+n[o>>2];s=+n[q>>2];t=o;u=q;if(!(r>s))if(r<s)v=0;else v=o>>>0>q>>>0;else v=1;w=f[e>>2]|0;x=+n[w>>2];y=w;if(!(x>r))if(x<r)z=0;else z=w>>>0>o>>>0;else z=1;if(!v){if(!z){p=0;break}f[m>>2]=y;f[e>>2]=t;o=f[m>>2]|0;w=f[h>>2]|0;r=+n[o>>2];x=+n[w>>2];A=w;B=o;if(!(r>x)?o>>>0<=w>>>0|r<x:0){p=1;break}f[h>>2]=B;f[m>>2]=A;p=2;break}if(z){f[h>>2]=y;f[e>>2]=u;p=1;break}f[h>>2]=t;f[m>>2]=u;t=f[e>>2]|0;x=+n[t>>2];y=t;if(!(x>s)?t>>>0<=q>>>0|x<s:0){p=1;break}f[m>>2]=y;f[e>>2]=u;p=2}while(0);C=f[h>>2]|0;k=f[m>>2]|0;s=+n[C>>2];x=+n[k>>2];if(s>x){D=e;E=p;break}if(C>>>0<=k>>>0|s<x)F=e;else{D=e;E=p;break}while(1){F=F+-4|0;if((h|0)==(F|0))break;G=f[F>>2]|0;r=+n[G>>2];if(r>x){l=67;break b}if(!(G>>>0<=k>>>0|r<x)){l=67;break b}}k=h+4|0;j=f[e>>2]|0;x=+n[j>>2];u=j;if(!(s>x)?C>>>0<=j>>>0|s<x:0){if((k|0)==(e|0)){l=89;break a}else H=k;while(1){I=f[H>>2]|0;x=+n[I>>2];if(s>x)break;if(!(C>>>0<=I>>>0|s<x))break;j=H+4|0;if((j|0)==(e|0)){l=89;break a}else H=j}f[H>>2]=u;f[e>>2]=I;J=H+4|0}else J=k;if((J|0)==(e|0)){l=89;break a}else{K=e;L=J}while(1){j=f[h>>2]|0;y=f[L>>2]|0;s=+n[j>>2];x=+n[y>>2];c:do if(s>x)M=L;else{q=L;r=x;t=y;while(1){if(!(j>>>0<=t>>>0|s<r)){M=q;break c}A=q+4|0;t=f[A>>2]|0;r=+n[t>>2];if(s>r){M=A;break}else q=A}}while(0);y=K;while(1){q=y;y=y+-4|0;N=f[y>>2]|0;x=+n[N>>2];if(s>x){y=y;continue}if(j>>>0<=N>>>0|s<x)break}if(M>>>0>=y>>>0){h=M;continue b}j=f[M>>2]|0;f[M>>2]=N;f[y>>2]=j;K=y;L=M+4|0}}if((l|0)==67){l=0;f[h>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=h+4|0;d:do if(k>>>0<D>>>0){u=m;j=D;q=k;t=E;while(1){A=f[u>>2]|0;s=+n[A>>2];B=q;while(1){O=f[B>>2]|0;x=+n[O>>2];if(!(x>s)?O>>>0<=A>>>0|x<s:0)break;B=B+4|0}y=O;w=j;do{w=w+-4|0;P=f[w>>2]|0;x=+n[P>>2];if(x>s)break}while(P>>>0<=A>>>0|x<s);if(B>>>0>w>>>0){Q=u;R=t;S=B;break d}f[B>>2]=P;f[w>>2]=y;u=(u|0)==(B|0)?w:u;j=w;q=B+4|0;t=t+1|0}}else{Q=m;R=E;S=k}while(0);do if((S|0)==(Q|0))T=R;else{k=f[Q>>2]|0;t=f[S>>2]|0;s=+n[k>>2];x=+n[t>>2];q=t;j=k;if(!(s>x)?!(k>>>0>t>>>0&!(s<x)):0){T=R;break}f[S>>2]=j;f[Q>>2]=q;T=R+1|0}while(0);if(!T){U=Zja(h,S,c)|0;q=S+4|0;if(Zja(q,a,c)|0){l=88;break}if(U){g=q;continue}}q=S;if((q-i|0)>=(b-q|0)){l=87;break}Tja(h,S,c);g=S+4|0}if((l|0)==87){l=0;Tja(S+4|0,a,c);d=h;a=S;continue}else if((l|0)==88){l=0;if(U){l=89;break}else{d=h;a=S;continue}}}if((l|0)==5){S=f[e>>2]|0;d=f[h>>2]|0;x=+n[S>>2];s=+n[d>>2];U=d;i=S;if(!(x>s)?S>>>0<=d>>>0|x<s:0)return;f[h>>2]=i;f[e>>2]=U;return}else if((l|0)==8){U=h+4|0;i=f[U>>2]|0;d=f[h>>2]|0;s=+n[i>>2];x=+n[d>>2];S=i;T=d;if(!(s>x))if(s<x)V=0;else V=i>>>0>d>>>0;else V=1;R=f[e>>2]|0;r=+n[R>>2];Q=R;if(!(r>s))if(r<s)W=0;else W=R>>>0>i>>>0;else W=1;if(!V){if(!W)return;f[U>>2]=Q;f[e>>2]=S;V=f[U>>2]|0;i=f[h>>2]|0;s=+n[V>>2];r=+n[i>>2];R=i;E=V;if(!(s>r)?V>>>0<=i>>>0|s<r:0)return;f[h>>2]=E;f[U>>2]=R;return}if(W){f[h>>2]=Q;f[e>>2]=T;return}f[h>>2]=S;f[U>>2]=T;S=f[e>>2]|0;r=+n[S>>2];Q=S;if(!(r>x)?S>>>0<=d>>>0|r<x:0)return;f[U>>2]=Q;f[e>>2]=T;return}else if((l|0)==24){Wja(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==25){Xja(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==27){Yja(h,a,c);return}else if((l|0)==89)return}function Uja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;do{m=j;j=j+-8|0;k=n;n=n+-8|0;f[j>>2]=f[n>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function Vja(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)kWc(a);d=b*12|0;e=$Xc(d)|0;f[a>>2]=e;g=e+(b*12|0)|0;f[a+8>>2]=g;g1c(e|0,0,d|0)|0;f[c>>2]=g;return}function Wja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h>o)?r>>>0<=s>>>0|h<o:0){v=1;w=e;x=j;break}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=2;w=t;x=t}else{v=0;w=m;x=p}else{if(q){f[a>>2]=p;f[c>>2]=k;v=1;w=g;x=k;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o>i)?t>>>0<=g>>>0|o<i:0){v=1;w=t;x=u;break}f[b>>2]=u;f[c>>2]=k;v=2;w=g;x=k}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[w>>2];g=k;if(!(i>o)?k>>>0<=w>>>0|i<o:0){y=v;return y|0}f[c>>2]=g;f[d>>2]=x;x=f[c>>2]|0;d=f[b>>2]|0;o=+n[x>>2];i=+n[d>>2];g=d;w=x;if(!(o>i)?x>>>0<=d>>>0|o<i:0){y=v+1|0;return y|0}f[b>>2]=w;f[c>>2]=g;g=f[b>>2]|0;c=f[a>>2]|0;i=+n[g>>2];o=+n[c>>2];w=c;d=g;if(!(i>o)?!(g>>>0>c>>>0&!(i<o)):0){y=v+2|0;return y|0}f[a>>2]=d;f[b>>2]=w;y=v+3|0;return y|0}function Xja(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=Wja(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j>k)?g>>>0<=i>>>0|j<k:0){o=h;return o|0}f[d>>2]=m;f[e>>2]=l;l=f[d>>2]|0;e=f[c>>2]|0;k=+n[l>>2];j=+n[e>>2];m=e;i=l;if(!(k>j)?l>>>0<=e>>>0|k<j:0){o=h+1|0;return o|0}f[c>>2]=i;f[d>>2]=m;m=f[c>>2]|0;d=f[b>>2]|0;j=+n[m>>2];k=+n[d>>2];i=d;e=m;if(!(j>k)?m>>>0<=d>>>0|j<k:0){o=h+2|0;return o|0}f[b>>2]=e;f[c>>2]=i;i=f[b>>2]|0;c=f[a>>2]|0;k=+n[i>>2];j=+n[c>>2];e=c;d=i;if(!(k>j)?!(i>>>0>c>>>0&!(k<j)):0){o=h+3|0;return o|0}f[a>>2]=d;f[b>>2]=e;o=h+4|0;return o|0}function Yja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=j;s=e;break}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=p;s=m;break}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=g;u=c;v=s;w=r}while(1){r=f[t>>2]|0;i=+n[r>>2];o=+n[v>>2];s=r;if(!(!(i>o)?r>>>0<=v>>>0|i<o:0)){f[t>>2]=w;a:do if((u|0)==(a|0))x=u;else{c=u;g=u;while(1){k=g;g=c+-4|0;p=f[g>>2]|0;o=+n[p>>2];d=p;if(!(i>o)?r>>>0<=p>>>0|i<o:0){x=k;break a}f[k>>2]=d;if((g|0)==(a|0)){x=g;break}else c=g}}while(0);f[x>>2]=s}r=t+4|0;if((r|0)==(b|0))break;g=f[t>>2]|0;c=t;t=r;v=g;w=g;u=c}return}function Zja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h>i)?e>>>0<=g>>>0|h<i:0){l=1;return l|0}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i>h))if(i<h)o=0;else o=k>>>0>g>>>0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q>i))if(q<i)s=0;else s=p>>>0>k>>>0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i>q)?o>>>0<=k>>>0|i<q:0){l=1;return l|0}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q>h)?e>>>0<=g>>>0|q<h:0){l=1;return l|0}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{Wja(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{Xja(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h>q))if(h<q)u=0;else u=d>>>0>r>>>0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i>h))if(i<h)v=0;else v=e>>>0>d>>>0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=d;break}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=e;break}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=r;s=0;m=c;e=w;while(1){j=f[g>>2]|0;q=+n[j>>2];i=+n[e>>2];v=j;if(!(q>i)?j>>>0<=e>>>0|q<i:0)z=s;else{f[g>>2]=f[m>>2];b:do if((m|0)==(a|0))A=m;else{d=m;u=m;while(1){p=u;u=d+-4|0;t=f[u>>2]|0;i=+n[t>>2];k=t;if(!(q>i)?j>>>0<=t>>>0|q<i:0){A=p;break b}f[p>>2]=k;if((u|0)==(a|0)){A=u;break}else d=u}}while(0);f[A>>2]=v;j=s+1|0;if((j|0)==8){x=0;y=(g+4|0)==(b|0);break a}else z=j}j=g+4|0;if((j|0)==(b|0)){x=1;y=0;break a}u=f[g>>2]|0;d=g;g=j;s=z;e=u;m=d}}while(0);l=y|x;return l|0}}return 0}function _ja(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;Rja(a,b,c,d,e,f,g,3,h,i);return}function $ja(a,c,e,g,h,i,j,k,l,m,o,q){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;o=+o;q=q|0;var r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0;r=u;u=u+2464|0;s=r+1328|0;t=r+264|0;v=r;w=r+200|0;x=r+256|0;y=r+136|0;z=r+192|0;if(!((k|0)>0&(l|0)>0)?!(m>0.0&o>0.0):0){A=$Xc(80)|0;f[s>>2]=A;f[s+8>>2]=-2147483568;f[s+4>>2]=73;B=A;C=264390;D=B+73|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[A+73>>0]=0;vM(-215,s,264464,264471,3415)}if(m<2.220446049250313e-16|o<2.220446049250313e-16){E=+(g|0);F=+(h|0);G=+(k|0)/E;H=+(l|0)/F;I=F;J=E}else{G=m;H=o;I=+(h|0);J=+(g|0)}A=a&7;K=(a>>>3&511)+1|0;M=zLc(J*G)|0;N=zLc(I*H)|0;if((M|0)<1|(N|0)<1){O=$Xc(16)|0;f[s>>2]=O;f[s+8>>2]=-2147483632;f[s+4>>2]=14;B=O;C=264542;D=B+14|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[O+14>>0]=0;vM(-215,s,264464,264471,3427)}I=1.0/G;J=1.0/H;O=zLc(I)|0;P=zLc(J)|0;if(+L(+(I-+(O|0)))<2.220446049250313e-16)Q=+L(+(J-+(P|0)))<2.220446049250313e-16;else Q=0;f[x>>2]=g;f[x+4>>2]=h;cM(w,x,a,c,e);f[z>>2]=M;f[z+4>>2]=N;cM(y,z,a,i,j);a:do switch(q|0){case 5:{if(!((K|0)!=2&((P|0)==2&((O|0)==2&Q))))if(A>>>0<5){nj[f[52060+(A<<2)>>2]&7](c,e,g,h,i,j,k,l,K,G,H);break a}else{f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;b[s+11>>0]=9;B=s;C=264557;D=B+9|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[s+9>>0]=0;vM(-215,s,264464,264471,3567)}else{R=3;S=43}break}case 0:{a=f[(f[w+40>>2]|0)+4>>2]|0;z=y+40|0;x=f[z>>2]|0;T=f[x+4>>2]|0;U=f[x>>2]|0;x=s+8|0;f[s>>2]=x;V=s+4|0;f[V>>2]=T;if(T>>>0>264){W=bYc(T>>>0>1073741823?-1:T<<2)|0;f[s>>2]=W;X=W}else X=x;W=w+4|0;Z=f[W>>2]|0;if((Z|0)>0)_=f[(f[w+44>>2]|0)+(Z+-1<<2)>>2]|0;else _=0;$=_>>>2;if((T|0)>0){aa=a+-1|0;a=0;do{o=I*+(a|0);ba=~~o;ca=ba-(+(ba|0)>o&1)|0;ba=Y((aa|0)<(ca|0)?aa:ca,_)|0;f[X+(a<<2)>>2]=ba;a=a+1|0}while((a|0)!=(T|0))}f[t>>2]=0;f[t+4>>2]=U;f[v>>2]=52100;T=v+4|0;f[T>>2]=f[w>>2];a=v+8|0;f[a>>2]=Z;aa=v+12|0;f[aa>>2]=f[w+8>>2];f[v+16>>2]=f[w+12>>2];f[v+20>>2]=f[w+16>>2];f[v+24>>2]=f[w+20>>2];f[v+28>>2]=f[w+24>>2];f[v+32>>2]=f[w+28>>2];f[v+36>>2]=f[w+32>>2];ba=f[w+36>>2]|0;f[v+40>>2]=ba;f[v+44>>2]=aa;aa=v+52|0;ca=v+48|0;f[ca>>2]=aa;f[aa>>2]=0;f[v+56>>2]=0;if(!ba)da=Z;else{aa=ba+12|0;f[aa>>2]=(f[aa>>2]|0)+1;da=f[W>>2]|0}if((da|0)<3){aa=f[w+44>>2]|0;ba=f[ca>>2]|0;f[ba>>2]=f[aa>>2];f[ba+4>>2]=f[aa+4>>2]}else{f[a>>2]=0;U$(T,w)}T=v+60|0;f[T>>2]=f[y>>2];a=v+64|0;aa=y+4|0;ba=f[aa>>2]|0;f[a>>2]=ba;ca=v+68|0;ea=y+8|0;f[ca>>2]=f[ea>>2];fa=y+12|0;f[v+72>>2]=f[fa>>2];f[v+76>>2]=f[y+16>>2];f[v+80>>2]=f[y+20>>2];f[v+84>>2]=f[y+24>>2];f[v+88>>2]=f[y+28>>2];f[v+92>>2]=f[y+32>>2];ga=f[y+36>>2]|0;f[v+96>>2]=ga;f[v+100>>2]=ca;ca=v+108|0;ha=v+104|0;f[ha>>2]=ca;f[ca>>2]=0;f[v+112>>2]=0;if(!ga)ia=ba;else{ba=ga+12|0;f[ba>>2]=(f[ba>>2]|0)+1;ia=f[aa>>2]|0}if((ia|0)<3){ba=f[y+44>>2]|0;ga=f[ha>>2]|0;f[ga>>2]=f[ba>>2];f[ga+4>>2]=f[ba+4>>2]}else{f[a>>2]=0;U$(T,y)}f[v+116>>2]=X;f[v+120>>2]=$;p[v+128>>3]=J;T=f[aa>>2]|0;if((T|0)<3)ja=Y(f[fa>>2]|0,f[ea>>2]|0)|0;else{ea=f[z>>2]|0;fa=0;aa=1;while(1){a=Y(f[ea+(fa<<2)>>2]|0,aa)|0;fa=fa+1|0;if((fa|0)==(T|0)){ja=a;break}else aa=a}}h3(t,v,+(ja>>>0)*.0000152587890625);aka(v);aa=f[s>>2]|0;if((aa|0)!=(x|0)){if(aa|0)dYc(aa);f[s>>2]=x;f[V>>2]=264}break}default:{R=(q|0)==1&((P|0)==2&((O|0)==2&Q))?3:q;S=43}}while(0);do if((S|0)==43){q=(R|0)==3;if(J>=1.0&(I>=1.0&q)){if(Q){v=Y(P,O)|0;ja=(e>>>0)/((675553809>>>(f[w>>2]<<2&28)&15)>>>0)|0;X=v+(Y(M,K)|0)|0;ia=s+8|0;f[s>>2]=ia;da=s+4|0;f[da>>2]=X;if(X>>>0>264){_=bYc(X>>>0>1073741823?-1:X<<2)|0;f[s>>2]=_;ka=_}else ka=ia;_=ka+(v<<2)|0;v=f[52112+(A<<2)>>2]|0;if(!(109>>>A&1)){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;b[t+11>>0]=9;B=t;C=264557;D=B+9|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[t+9>>0]=0;vM(-215,t,264464,264471,3602)}if((P|0)>0&(O|0)>0){V=0;x=0;while(1){X=Y(x,ja)|0;l=0;k=V;while(1){j=(Y(l,K)|0)+X|0;f[ka+(k<<2)>>2]=j;l=l+1|0;if((l|0)==(O|0))break;else k=k+1|0}x=x+1|0;if((x|0)==(P|0))break;else V=O+V|0}}if((M|0)>0){V=0;do{x=Y(V,K)|0;ja=Y(x,O)|0;k=0;do{f[_+(k+x<<2)>>2]=k+ja;k=k+1|0}while((k|0)!=(K|0));V=V+1|0}while((V|0)!=(M|0))}Fh[v&255](w,y,ka,_,O,P);V=f[s>>2]|0;if((V|0)!=(ia|0)){if(V|0)dYc(V);f[s>>2]=ia;f[da>>2]=264}break}V=f[52144+(A<<2)>>2]|0;if(!((109>>>A&1|0)!=0&K>>>0<5)){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;k=$Xc(32)|0;f[s>>2]=k;f[s+8>>2]=-2147483616;f[s+4>>2]=20;B=k;C=264567;D=B+20|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[k+20>>0]=0;vM(-215,s,264464,264471,3621)}da=h+g<<1;ia=s+8|0;f[s>>2]=ia;_=s+4|0;f[_>>2]=da;if(da>>>0>93){v=bYc(da>>>0>357913941?-1:da*12|0)|0;f[s>>2]=v;la=v}else la=ia;v=la+((g<<1)*12|0)|0;da=bka(g,M,K,I,la)|0;ja=bka(h,N,1,J,v)|0;x=N+1|0;l=t+8|0;f[t>>2]=l;X=t+4|0;f[X>>2]=x;if(x>>>0>264){j=bYc(x>>>0>1073741823?-1:x<<2)|0;f[t>>2]=j;ma=j}else ma=l;if((ja|0)>0){j=0;x=0;while(1){if((x|0)!=0?(f[v+(x*12|0)+4>>2]|0)==(f[v+((x+-1|0)*12|0)+4>>2]|0):0)na=j;else{f[ma+(j<<2)>>2]=x;na=j+1|0}x=x+1|0;if((x|0)==(ja|0)){oa=na;break}else j=na}}else oa=0;f[ma+(oa<<2)>>2]=ja;Ii[V&127](w,y,la,da,v,ja,ma);j=f[t>>2]|0;if((j|0)!=(l|0)){if(j|0)dYc(j);f[t>>2]=l;f[X>>2]=264}j=f[s>>2]|0;if((j|0)!=(ia|0)){if(j|0)dYc(j);f[s>>2]=ia;f[_>>2]=93}break}j=Y(M,K)|0;x=(A|0)==0;k=(R|0)==2;if(!k)if((R|0)!=4)if((R|2|0)==3){pa=2;qa=52208}else{f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;i=$Xc(32)|0;f[s>>2]=i;f[s+8>>2]=-2147483616;f[s+4>>2]=28;B=i;C=264588;D=B+28|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[i+28>>0]=0;vM(-5,s,264464,264471,3659)}else{pa=8;qa=52176}else{pa=4;qa=52240}_=f[qa+(A<<2)>>2]|0;ia=pa>>>1;if(!_){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;b[s+11>>0]=9;B=s;C=264557;D=B+9|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[s+9>>0]=0;vM(-215,s,264464,264471,3662)}i=j+N|0;X=pa<<2;l=Y(X|4,i)|0;ja=s+8|0;f[s>>2]=ja;v=s+4|0;f[v>>2]=l;if(l>>>0>1032){da=bYc(l)|0;f[s>>2]=da;ra=da}else ra=ja;da=ra+(j<<2)|0;l=da+(N<<2)|0;V=Y(pa,j)|0;c=l+(V<<2)|0;aa=l+(V<<1)|0;B=t;D=B+64|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));if((M|0)>0){j=ia+-1|0;V=t+4|0;T=t+8|0;fa=t+12|0;ea=Y(pa,K)|0;z=(R|0)==4;$=g+-1|0;W=0;Z=M;U=0;while(1){a=Y(ea,U)|0;ba=ra+(i+a<<2)|0;o=+(U|0);if(q){m=I*o;ga=~~m;ha=ga-(+(ga|0)>m&1)|0;m=+(U+1|0)-G*+(ha+1|0);ga=~~m;if(!(m<=0.0)){sa=m-+(ga-(+(ga|0)>m&1)|0);ta=ha}else{sa=0.0;ta=ha}}else{m=I*(o+.5)+-.5;ha=~~m;ga=ha-(+(ha|0)>m&1)|0;sa=m-+(ga|0);ta=ga}b:do if((ta|0)<(j|0)){ga=U+1|0;if((ta|0)<0){switch(R|0){case 2:case 4:{ua=sa;va=ga;wa=ta;break b;break}default:{}}ua=0.0;va=ga;wa=0}else{ua=sa;va=ga;wa=ta}}else{ua=sa;va=W;wa=ta}while(0);c:do if((wa+ia|0)>=(g|0)){ga=(U|0)<(Z|0)?U:Z;if((wa|0)<($|0)){xa=ga;ya=ua;za=wa}else{switch(R|0){case 2:case 4:{xa=ga;ya=ua;za=wa;break c;break}default:{}}xa=ga;ya=0.0;za=$}}else{xa=Z;ya=ua;za=wa}while(0);ga=Y(za,K)|0;ha=Y(U,K)|0;ca=0;do{f[ra+(ca+ha<<2)>>2]=ca+ga;ca=ca+1|0}while((ca|0)!=(K|0));do if(!k)if(z){cka(ya,t);break}else{n[t>>2]=1.0-ya;n[V>>2]=ya;break}else{m=ya+1.0;o=m*(m*(3.75-m*.75)+-6.0)+3.0;n[t>>2]=o;m=ya*(ya*(ya*1.25+-2.25))+1.0;n[V>>2]=m;E=1.0-ya;F=E*(E*(E*1.25+-2.25))+1.0;n[T>>2]=F;n[fa>>2]=1.0-o-m-F}while(0);if(x){ca=0;do{ga=ALc(+n[t+(ca<<2)>>2]*2048.0)|0;d[l+(ca+a<<1)>>1]=(ga+32768|0)>>>0<65536?ga:(ga|0)>0?32767:32768;ca=ca+1|0}while((ca|0)<(pa|0));if((ca|0)<(ea|0)){ga=ca;do{ha=ga+a|0;d[l+(ha<<1)>>1]=d[l+(ha-pa<<1)>>1]|0;ga=ga+1|0}while((ga|0)!=(ea|0))}}else{o1c(ba|0,t|0,X|0)|0;ga=0;do ga=ga+1|0;while((ga|0)<(pa|0));if((ga|0)<(ea|0)){ba=ga;do{ca=ba+a|0;f[l+(ca<<2)>>2]=f[l+(ca-pa<<2)>>2];ba=ba+1|0}while((ba|0)!=(ea|0))}}U=U+1|0;if((U|0)==(M|0)){Aa=va;Ba=xa;break}else{W=va;Z=xa}}}else{Aa=0;Ba=M}if((N|0)>0){Z=t+4|0;W=t+8|0;U=t+12|0;ea=(R|0)==4;fa=Y(Y(M,X|4)|0,K)|0;T=0;do{V=Y(pa,T)|0;z=ra+(N+V<<2)+fa|0;F=+(T|0);if(q){m=J*F;$=~~m;ia=$-(+($|0)>m&1)|0;m=+(T+1|0)-H*+(ia+1|0);$=~~m;if(!(m<=0.0)){Ca=m-+($-(+($|0)>m&1)|0);Da=ia}else{Ca=0.0;Da=ia}}else{m=J*(F+.5)+-.5;ia=~~m;$=ia-(+(ia|0)>m&1)|0;Ca=m-+($|0);Da=$}f[da+(T<<2)>>2]=Da;do if(!k)if(ea){cka(Ca,t);break}else{n[t>>2]=1.0-Ca;n[Z>>2]=Ca;break}else{m=Ca+1.0;F=m*(m*(3.75-m*.75)+-6.0)+3.0;n[t>>2]=F;m=Ca*(Ca*(Ca*1.25+-2.25))+1.0;n[Z>>2]=m;o=1.0-Ca;E=o*(o*(o*1.25+-2.25))+1.0;n[W>>2]=E;n[U>>2]=1.0-F-m-E}while(0);if(x){$=0;do{ia=ALc(+n[t+($<<2)>>2]*2048.0)|0;d[aa+($+V<<1)>>1]=(ia+32768|0)>>>0<65536?ia:(ia|0)>0?32767:32768;$=$+1|0}while(($|0)<(pa|0))}else o1c(z|0,t|0,X|0)|0;T=T+1|0}while((T|0)!=(N|0))}Li[_&127](w,y,ra,l,da,x?aa:c,Aa,Ba,pa);T=f[s>>2]|0;if((T|0)!=(ja|0)){if(T|0)dYc(T);f[s>>2]=ja;f[v>>2]=1032}}while(0);s=y+36|0;pa=f[s>>2]|0;if(pa|0?(Ba=pa+12|0,pa=f[Ba>>2]|0,f[Ba>>2]=pa+-1,(pa|0)==1):0)V$(y);f[s>>2]=0;s=y+16|0;pa=y+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[pa>>2]|0)>0){s=f[y+40>>2]|0;Ba=0;do{f[s+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[pa>>2]|0))}pa=f[y+44>>2]|0;if((pa|0)!=(y+48|0))wL(pa);pa=w+36|0;y=f[pa>>2]|0;if(y|0?(Ba=y+12|0,y=f[Ba>>2]|0,f[Ba>>2]=y+-1,(y|0)==1):0)V$(w);f[pa>>2]=0;pa=w+16|0;y=w+4|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[y>>2]|0)>0){pa=f[w+40>>2]|0;Ba=0;do{f[pa+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[y>>2]|0))}y=f[w+44>>2]|0;if((y|0)==(w+48|0)){u=r;return}wL(y);u=r;return}function aka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52100;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function bka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((b|0)<=0){g=0;return g|0}h=+(a|0);i=a+-1|0;a=0;j=0;while(1){k=+(j|0)*d;l=k+d;m=h-k;o=m<d?m:d;p=~~k;q=(+(p|0)<k&1)+p|0;p=~~l;r=p-(+(p|0)>l&1)|0;p=(i|0)<(r|0)?i:r;r=(p|0)<(q|0)?p:q;m=+(r|0)-k;if(m>.001){s=Y(j,c)|0;f[e+(a*12|0)+4>>2]=s;s=Y(r+-1|0,c)|0;f[e+(a*12|0)>>2]=s;n[e+(a*12|0)+8>>2]=m/o;t=a+1|0}else t=a;if((p|0)>(q|0)){q=Y(j,c)|0;m=1.0/o;s=r;r=t;while(1){f[e+(r*12|0)+4>>2]=q;u=Y(s,c)|0;f[e+(r*12|0)>>2]=u;u=r+1|0;n[e+(r*12|0)+8>>2]=m;s=s+1|0;if((s|0)>=(p|0)){v=u;break}else r=u}}else v=t;m=l-+(p|0);if(m>.001){r=Y(j,c)|0;f[e+(v*12|0)+4>>2]=r;r=Y(p,c)|0;f[e+(v*12|0)>>2]=r;k=m>1.0?1.0:m;n[e+(v*12|0)+8>>2]=(o<k?o:k)/o;w=v+1|0}else w=v;j=j+1|0;if((j|0)==(b|0)){g=w;break}else a=w}return g|0}function cka(a,b){a=+a;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0;if(a<1.1920928955078125e-07){f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;n[b+12>>2]=1.0;return}else{c=a+3.0;a=-c*3.141592653589793*.25;d=+P(+a);e=+O(+a);g=e*0.0;h=(d+g)/(a*a);a=-(c+-1.0)*3.141592653589793*.25;i=d*-.7071067811865476;j=e*-.7071067811865476;k=(i+j)/(a*a);a=-(c+-2.0)*3.141592653589793*.25;l=d*0.0;m=(l+e)/(a*a);a=-(c+-3.0)*3.141592653589793*.25;o=d*.7071067811865476;p=(o+j)/(a*a);a=-(c+-4.0)*3.141592653589793*.25;j=(g-d)/(a*a);a=-(c+-5.0)*3.141592653589793*.25;d=e*.7071067811865476;g=(o+d)/(a*a);a=-(c+-6.0)*3.141592653589793*.25;o=(l-e)/(a*a);a=-(c+-7.0)*3.141592653589793*.25;c=(i+d)/(a*a);a=1.0/(h+0.0+k+m+p+j+g+o+c);n[b>>2]=a*h;n[b+4>>2]=a*k;n[b+8>>2]=a*m;n[b+12>>2]=a*p;n[b+16>>2]=a*j;n[b+20>>2]=a*g;n[b+24>>2]=a*o;n[b+28>>2]=a*c;return}}function dka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Cka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Dka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Dka(o);u=k;return}function eka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;xka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);yka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);yka(o);u=k;return}function fka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;ska(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);tka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);tka(o);u=k;return}function gka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;nka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);oka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);oka(o);u=k;return}function hka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;ika(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);jka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);jka(o);u=k;return}function ika(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52280;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function jka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52280;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function kka(a){a=a|0;jka(a);cYc(a);return}function lka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0;c=u;u=u+1296|0;d=c+1288|0;e=c;g=c+1224|0;h=c+1160|0;i=c+1096|0;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;q=Y(l,o)|0;r=e+8|0;f[e>>2]=r;s=e+4|0;f[s>>2]=q;if(q>>>0>136){t=bYc(q>>>0>536870911?-1:q<<3)|0;f[e>>2]=t;v=t}else v=r;t=g;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((o|0)>0){g1c(i|0,-1,o<<2|0)|0;t=0;do{q=v+((Y(t,l)|0)<<3)|0;f[h+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(o|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=h+4|0;E=h+8|0;F=h+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=l<<3;l=(f[a+128>>2]|0)+((Y(t,o)|0)<<2)|0;a=t;t=o;while(1){if((t|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=o+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[i+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){o1c(f[h+(N<<2)>>2]|0,f[h+(O<<2)>>2]|0,J|0)|0;S=f[m>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[g+(N<<2)>>2]=P;f[i+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))mka(d,g+(K<<2)|0,h+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[k>>2]|0,j,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[k>>2]|0;U=+n[l>>2];V=+n[l+4>>2];W=+n[l+8>>2];X=+n[l+12>>2];N=f[h>>2]|0;o=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{p[M+(Z<<3)>>3]=U*+p[N+(Z<<3)>>3]+V*+p[o+(Z<<3)>>3]+W*+p[P+(Z<<3)>>3]+X*+p[R+(Z<<3)>>3];Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[m>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{l=l+(L<<2)|0;t=L}}_=f[e>>2]|0}else _=v;if((_|0)==(r|0)){u=c;return}if(_|0)dYc(_);f[e>>2]=r;f[s>>2]=136;u=c;return}function mka(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;q=j*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=k;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=A-j|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+j|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-j|0}F=+p[s+(C<<3)>>3]*+n[z>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-j|0}I=F+ +p[s+(G<<3)>>3]*+n[z+4>>2];D=o+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+j|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-j|0}F=I+ +p[s+(J<<3)>>3]*+n[z+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-j|0}p[t+(y<<3)>>3]=F+ +p[s+(L<<3)>>3]*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(i|0))break;if((N|0)<(l|0)){P=N;Q=O}else{u=i;v=N;w=O;continue}while(1){z=f[e+(P<<2)>>2]|0;p[t+(P<<3)>>3]=+p[s+(z-j<<3)>>3]*+n[Q>>2]+ +p[s+(z<<3)>>3]*+n[Q+4>>2]+ +p[s+(z+j<<3)>>3]*+n[Q+8>>2]+ +p[s+(z+a<<3)>>3]*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(l|0)){P=z;Q=y}else{u=i;v=l;w=y;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=O+(m<<2)|0}return}function nka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52300;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function oka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52300;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function pka(a){a=a|0;oka(a);cYc(a);return}function qka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0;c=u;u=u+1264|0;d=c+1256|0;e=c+192|0;g=c+128|0;h=c+64|0;i=c;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;p=Y(l,o)|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=g;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(i|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,l)|0)<<2)|0;f[h+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=h+4|0;D=h+8|0;E=h+12|0;F=a+136|0;G=a+20|0;H=a+48|0;I=l<<2;l=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;J=s;K=0;L=s;M=0;while(1){N=o+M|0;O=f[F>>2]|0;P=(N|0)>-1?((N|0)<(O|0)?N:O+-1|0):0;O=(K|0)<(M|0)?M:K;a:do if((O|0)<(L|0)){N=O;while(1){if((N|0)<16?(P|0)==(f[i+(N<<2)>>2]|0):0)break;Q=N+1|0;if((Q|0)<(L|0))N=Q;else{R=L;S=Q;break a}}if((N|0)>(M|0)){o1c(f[h+(M<<2)>>2]|0,f[h+(N<<2)>>2]|0,I|0)|0;R=f[m>>2]|0;S=N}else{R=L;S=N}}else{R=L;S=O}while(0);J=(M|0)<(J|0)&(S|0)==(R|0)?M:J;O=(f[G>>2]|0)+(Y(f[f[H>>2]>>2]|0,P)|0)|0;f[g+(M<<2)>>2]=O;f[i+(M<<2)>>2]=P;M=M+1|0;if((M|0)>=(R|0))break;else{K=S;L=R}}if((R|0)>(J|0))rka(d,g+(J<<2)|0,h+(J<<2)|0,R-J|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[k>>2]|0,j,f[y>>2]|0,f[z>>2]|0)}L=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;K=f[k>>2]|0;T=+n[l>>2];U=+n[l+4>>2];V=+n[l+8>>2];W=+n[l+12>>2];M=f[h>>2]|0;o=f[C>>2]|0;O=f[D>>2]|0;Q=f[E>>2]|0;if((K|0)>0){X=0;do{n[L+(X<<2)>>2]=T*+n[M+(X<<2)>>2]+U*+n[o+(X<<2)>>2]+V*+n[O+(X<<2)>>2]+W*+n[Q+(X<<2)>>2];X=X+1|0}while((X|0)!=(K|0))}a=a+1|0;K=f[m>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{l=l+(K<<2)|0;s=K}}Z=f[e>>2]|0}else Z=t;if((Z|0)==(q|0)){u=c;return}if(Z|0)dYc(Z);f[e>>2]=q;f[r>>2]=264;u=c;return}function rka(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;p=j*3|0;q=g;g=0;while(1){r=f[b+(g<<2)>>2]|0;s=f[c+(g<<2)>>2]|0;t=k;u=0;v=q;a:while(1){if((t|0)>(u|0)){w=t-u<<2;x=u;y=v;while(1){z=f[e+(x<<2)>>2]|0;A=z-j|0;if(A>>>0<h>>>0)B=A;else{C=A;while(1)if((C|0)<0)C=C+j|0;else{D=C;break}while(1)if((D|0)<(h|0)){B=D;break}else D=D-j|0}E=+n[r+(B<<2)>>2]*+n[y>>2]+0.0;if(z>>>0<h>>>0)F=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{G=C;break}while(1)if((G|0)<(h|0)){F=G;break}else G=G-j|0}H=E+ +n[r+(F<<2)>>2]*+n[y+4>>2];C=o+A|0;if(C>>>0<h>>>0)I=C;else{z=C;while(1)if((z|0)<0)z=z+j|0;else{J=z;break}while(1)if((J|0)<(h|0)){I=J;break}else J=J-j|0}E=H+ +n[r+(I<<2)>>2]*+n[y+8>>2];z=p+A|0;if(z>>>0<h>>>0)K=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{L=C;break}while(1)if((L|0)<(h|0)){K=L;break}else L=L-j|0}n[s+(x<<2)>>2]=E+ +n[r+(K<<2)>>2]*+n[y+12>>2];x=x+1|0;if((x|0)==(t|0))break;else y=y+16|0}M=t;N=v+(w<<2)|0}else{M=u;N=v}if((t|0)==(i|0))break;if((M|0)<(l|0)){O=M;P=N}else{t=i;u=M;v=N;continue}while(1){y=f[e+(O<<2)>>2]|0;n[s+(O<<2)>>2]=+n[r+(y-j<<2)>>2]*+n[P>>2]+ +n[r+(y<<2)>>2]*+n[P+4>>2]+ +n[r+(y+j<<2)>>2]*+n[P+8>>2]+ +n[r+(y+a<<2)>>2]*+n[P+12>>2];y=O+1|0;x=P+16|0;if((y|0)<(l|0)){O=y;P=x}else{t=i;u=l;v=x;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else q=N+(m<<2)|0}return}function ska(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52320;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function tka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52320;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function uka(a){a=a|0;tka(a);cYc(a);return}function vka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=bYc(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){g1c(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){o1c(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))wka(e,h+(K<<2)|0,i+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[l>>2]|0;U=+n[m>>2];V=+n[m+4>>2];W=+n[m+8>>2];X=+n[m+12>>2];N=f[i>>2]|0;p=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{_=ALc(U*+n[N+(Z<<2)>>2]+V*+n[p+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=(_+32768|0)>>>0<65536?_:(_|0)>0?32767:32768;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{m=m+(L<<2)|0;t=L}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)dYc($);f[g>>2]=r;f[s>>2]=264;u=c;return}function wka(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=k<<1;o=0-(j<<2)|0;p=k<<1;q=k*3|0;r=h;h=0;while(1){s=f[b+(h<<2)>>2]|0;t=f[c+(h<<2)>>2]|0;u=l;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=A-k|0;if(B>>>0<i>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(i|0)){C=E;break}else E=E-k|0}F=+(d[s+(C<<1)>>1]|0)*+n[z>>2]+0.0;if(A>>>0<i>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(i|0)){G=H;break}else H=H-k|0}I=F+ +(d[s+(G<<1)>>1]|0)*+n[z+4>>2];D=p+B|0;if(D>>>0<i>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(i|0)){J=K;break}else K=K-k|0}F=I+ +(d[s+(J<<1)>>1]|0)*+n[z+8>>2];A=q+B|0;if(A>>>0<i>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(i|0)){L=M;break}else M=M-k|0}n[t+(y<<2)>>2]=F+ +(d[s+(L<<1)>>1]|0)*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(j|0))break;if((N|0)<(m|0)){P=N;Q=O}else{u=j;v=N;w=O;continue}while(1){z=f[g+(P<<2)>>2]|0;n[t+(P<<2)>>2]=+(d[s+(z-k<<1)>>1]|0)*+n[Q>>2]+ +(d[s+(z<<1)>>1]|0)*+n[Q+4>>2]+ +(d[s+(z+k<<1)>>1]|0)*+n[Q+8>>2]+ +(d[s+(z+a<<1)>>1]|0)*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(m|0)){P=z;Q=y}else{u=j;v=m;w=y;continue a}}}h=h+1|0;if((h|0)==(e|0))break;else r=O+(o<<2)|0}return}function xka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52340;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function yka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52340;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function zka(a){a=a|0;yka(a);cYc(a);return}function Aka(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=bYc(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){g1c(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){o1c(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))Bka(e,h+(K<<2)|0,i+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[l>>2]|0;U=+n[m>>2];V=+n[m+4>>2];W=+n[m+8>>2];X=+n[m+12>>2];N=f[i>>2]|0;p=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{_=ALc(U*+n[N+(Z<<2)>>2]+V*+n[p+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=_>>>0<65536?_:(_|0)>0?65535:0;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{m=m+(L<<2)|0;t=L}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)dYc($);f[g>>2]=r;f[s>>2]=264;u=c;return}function Bka(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=k<<1;o=0-(i<<2)|0;p=k<<1;q=k*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=l;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=A-k|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-k|0}F=+(j[s+(C<<1)>>1]|0)*+n[z>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-k|0}I=F+ +(j[s+(G<<1)>>1]|0)*+n[z+4>>2];D=p+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-k|0}F=I+ +(j[s+(J<<1)>>1]|0)*+n[z+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-k|0}n[t+(y<<2)>>2]=F+ +(j[s+(L<<1)>>1]|0)*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(i|0))break;if((N|0)<(m|0)){P=N;Q=O}else{u=i;v=N;w=O;continue}while(1){z=f[e+(P<<2)>>2]|0;n[t+(P<<2)>>2]=+(j[s+(z-k<<1)>>1]|0)*+n[Q>>2]+ +(j[s+(z<<1)>>1]|0)*+n[Q+4>>2]+ +(j[s+(z+k<<1)>>1]|0)*+n[Q+8>>2]+ +(j[s+(z+a<<1)>>1]|0)*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(m|0)){P=z;Q=y}else{u=i;v=m;w=y;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=O+(o<<2)|0}return}function Cka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52360;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function Dka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52360;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Eka(a){a=a|0;Dka(a);cYc(a);return}function Fka(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=u;u=u+1264|0;g=e+1256|0;h=e+192|0;i=e+128|0;j=e+64|0;k=e;l=((f[a+4>>2]|0)>>>3&511)+1|0;m=a+140|0;n=(f[m>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(n,p)|0;r=h+8|0;f[h>>2]=r;s=h+4|0;f[s>>2]=q;if(q>>>0>264){t=bYc(q>>>0>1073741823?-1:q<<2)|0;f[h>>2]=t;v=t}else v=r;t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=j;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){g1c(k|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,n)|0)<<2)|0;f[j+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[c>>2]|0;q=c+4|0;if((t|0)<(f[q>>2]|0)){c=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=j+4|0;E=j+8|0;F=j+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=n<<2;n=(f[a+128>>2]|0)+((Y(t,p)|0)<<1)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[c>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[k+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){o1c(f[j+(N<<2)>>2]|0,f[j+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[i+(N<<2)>>2]=P;f[k+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))Gka(g,i+(K<<2)|0,j+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[m>>2]|0,l,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[m>>2]|0;N=d[n>>1]|0;p=d[n+2>>1]|0;P=d[n+4>>1]|0;R=d[n+6>>1]|0;U=f[j>>2]|0;V=f[D>>2]|0;W=f[E>>2]|0;X=f[F>>2]|0;if((L|0)>0){Z=0;do{_=Y(f[U+(Z<<2)>>2]|0,N)|0;$=Y(f[V+(Z<<2)>>2]|0,p)|0;aa=Y(f[W+(Z<<2)>>2]|0,P)|0;ba=_+2097152+$+aa+(Y(f[X+(Z<<2)>>2]|0,R)|0)>>22;b[M+Z>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{n=n+(L<<1)|0;t=L}}ca=f[h>>2]|0}else ca=v;if((ca|0)==(r|0)){u=e;return}if(ca|0)dYc(ca);f[h>>2]=r;f[s>>2]=264;u=e;return}function Gka(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=l<<1;o=0-(k<<2)|0;p=l<<1;q=l*3|0;r=i;i=0;while(1){s=f[b+(i<<2)>>2]|0;t=f[c+(i<<2)>>2]|0;u=m;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=A-l|0;if(B>>>0<j>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+l|0;else{E=D;break}while(1)if((E|0)<(j|0)){C=E;break}else E=E-l|0}D=Y(d[z>>1]|0,h[s+C>>0]|0)|0;if(A>>>0<j>>>0)F=A;else{G=A;while(1)if((G|0)<0)G=G+l|0;else{H=G;break}while(1)if((H|0)<(j|0)){F=H;break}else H=H-l|0}G=(Y(d[z+2>>1]|0,h[s+F>>0]|0)|0)+D|0;A=p+B|0;if(A>>>0<j>>>0)I=A;else{J=A;while(1)if((J|0)<0)J=J+l|0;else{K=J;break}while(1)if((K|0)<(j|0)){I=K;break}else K=K-l|0}J=(Y(d[z+4>>1]|0,h[s+I>>0]|0)|0)+G|0;D=q+B|0;if(D>>>0<j>>>0)L=D;else{A=D;while(1)if((A|0)<0)A=A+l|0;else{M=A;break}while(1)if((M|0)<(j|0)){L=M;break}else M=M-l|0}A=(Y(d[z+6>>1]|0,h[s+L>>0]|0)|0)+J|0;f[t+(y<<2)>>2]=A;y=y+1|0;if((y|0)==(u|0))break;else z=z+8|0}N=u;O=w+(x<<1)|0}else{N=v;O=w}if((u|0)==(k|0))break;if((N|0)<(n|0)){P=N;Q=O}else{u=k;v=N;w=O;continue}while(1){z=f[g+(P<<2)>>2]|0;y=Y(d[Q>>1]|0,h[s+(z-l)>>0]|0)|0;A=(Y(d[Q+2>>1]|0,h[s+z>>0]|0)|0)+y|0;y=A+(Y(d[Q+4>>1]|0,h[s+(z+l)>>0]|0)|0)|0;A=y+(Y(d[Q+6>>1]|0,h[s+(z+a)>>0]|0)|0)|0;f[t+(P<<2)>>2]=A;A=P+1|0;z=Q+8|0;if((A|0)<(n|0)){P=A;Q=z}else{u=k;v=n;w=z;continue a}}}i=i+1|0;if((i|0)==(e|0))break;else r=O+(o<<1)|0}return}function Hka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;ila(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);jla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);jla(o);u=k;return}function Ika(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;cla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);dla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);dla(o);u=k;return}function Jka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Yka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Zka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Zka(o);u=k;return}function Kka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Ska(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Tka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Tka(o);u=k;return}function Lka(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Mka(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Nka(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Nka(o);u=k;return}function Mka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52380;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function Nka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52380;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Oka(a){a=a|0;Nka(a);cYc(a);return}function Pka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=bYc(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Qka(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Rka(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function Qka(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;q=0;r=h;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(o){v=0;do{w=f[e+(v<<2)>>2]|0;p[u+(v<<3)>>3]=+p[t+(w<<3)>>3];p[s+(v<<3)>>3]=+p[r+(w<<3)>>3];v=v+1|0}while((v|0)!=(i|0))}if((q|0)==(k|0)){m=k;break a}}}q=(l|0)<(i|0);r=0;s=h;o=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=o;o=f[c+(r<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+j|0;A=y*+p[s+(w<<3)>>3]+z*+p[s+(x<<3)>>3];p[t+(u<<3)>>3]=y*+p[v+(w<<3)>>3]+z*+p[v+(x<<3)>>3];p[o+(u<<3)>>3]=A;u=u+1|0}while((u|0)!=(l|0));if(q){u=l;do{x=f[e+(u<<2)>>2]|0;p[t+(u<<3)>>3]=+p[v+(x<<3)>>3];p[o+(u<<3)>>3]=+p[s+(x<<3)>>3];u=u+1|0}while((u|0)!=(i|0))}}while((r|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;r=m;do{s=f[b+(r<<2)>>2]|0;o=f[c+(r<<2)>>2]|0;if(k){q=0;do{p[o+(q<<3)>>3]=+p[s+(f[e+(q<<2)>>2]<<3)>>3];q=q+1|0}while((q|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;q=f[c+(k<<2)>>2]|0;s=0;do{o=f[e+(s<<2)>>2]|0;a=s<<1;p[q+(s<<3)>>3]=+p[m+(o<<3)>>3]*+n[g+(a<<2)>>2]+ +p[m+(o+j<<3)>>3]*+n[g+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(l|0));if(r){s=l;do{p[q+(s<<3)>>3]=+p[m+(f[e+(s<<2)>>2]<<3)>>3];s=s+1|0}while((s|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function Rka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(j<<3)>>3]=g*+p[d+(j<<3)>>3]+h*+p[a+(j<<3)>>3];p[c+(k<<3)>>3]=l;k=j|2;m=j|3;l=g*+p[d+(m<<3)>>3]+h*+p[a+(m<<3)>>3];p[c+(k<<3)>>3]=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(m<<3)>>3]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{p[c+(o<<3)>>3]=g*+p[d+(o<<3)>>3]+h*+p[a+(o<<3)>>3];o=o+1|0}while((o|0)!=(e|0));return}function Ska(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52400;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function Tka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52400;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Uka(a){a=a|0;Tka(a);cYc(a);return}function Vka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Wka(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Xka(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Wka(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;p=0;q=a;r=h;while(1){p=p+1|0;s=r;r=f[b+(p<<2)>>2]|0;t=q;q=f[c+(p<<2)>>2]|0;if(o){u=0;do{v=f[e+(u<<2)>>2]|0;f[t+(u<<2)>>2]=f[s+(v<<2)>>2];f[q+(u<<2)>>2]=f[r+(v<<2)>>2];u=u+1|0}while((u|0)!=(i|0))}if((p|0)==(k|0)){m=k;break a}}}p=(l|0)<(i|0);r=0;q=h;o=a;do{r=r+1|0;u=q;q=f[b+(r<<2)>>2]|0;s=o;o=f[c+(r<<2)>>2]|0;t=0;do{v=f[e+(t<<2)>>2]|0;w=t<<1;x=+n[g+(w<<2)>>2];y=+n[g+((w|1)<<2)>>2];w=v+j|0;z=x*+n[q+(v<<2)>>2]+y*+n[q+(w<<2)>>2];n[s+(t<<2)>>2]=x*+n[u+(v<<2)>>2]+y*+n[u+(w<<2)>>2];n[o+(t<<2)>>2]=z;t=t+1|0}while((t|0)!=(l|0));if(p){t=l;do{w=f[e+(t<<2)>>2]|0;f[s+(t<<2)>>2]=f[u+(w<<2)>>2];f[o+(t<<2)>>2]=f[q+(w<<2)>>2];t=t+1|0}while((t|0)!=(i|0))}}while((r|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;r=m;do{q=f[b+(r<<2)>>2]|0;o=f[c+(r<<2)>>2]|0;if(k){p=0;do{f[o+(p<<2)>>2]=f[q+(f[e+(p<<2)>>2]<<2)>>2];p=p+1|0}while((p|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;p=f[c+(k<<2)>>2]|0;q=0;do{o=f[e+(q<<2)>>2]|0;a=q<<1;n[p+(q<<2)>>2]=+n[m+(o<<2)>>2]*+n[g+(a<<2)>>2]+ +n[m+(o+j<<2)>>2]*+n[g+((a|1)<<2)>>2];q=q+1|0}while((q|0)!=(l|0));if(r){q=l;do{f[p+(q<<2)>>2]=f[m+(f[e+(q<<2)>>2]<<2)>>2];q=q+1|0}while((q|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function Xka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(j<<2)>>2]=g*+n[d+(j<<2)>>2]+h*+n[a+(j<<2)>>2];n[c+(k<<2)>>2]=l;k=j|2;m=j|3;l=g*+n[d+(m<<2)>>2]+h*+n[a+(m<<2)>>2];n[c+(k<<2)>>2]=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(m<<2)>>2]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{n[c+(o<<2)>>2]=g*+n[d+(o<<2)>>2]+h*+n[a+(o<<2)>>2];o=o+1|0}while((o|0)!=(e|0));return}function Yka(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52420;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function Zka(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52420;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function _ka(a){a=a|0;Zka(a);cYc(a);return}function $ka(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))ala(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;bla(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function ala(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((e|0)<2)o=0;else{l=e+-1|0;i=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(j|0)>0;q=0;r=i;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(d[t+(w<<1)>>1]|0);n[s+(v<<2)>>2]=+(d[r+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(j|0))}if((q|0)==(l|0)){o=l;break a}}}q=(m|0)<(j|0);r=0;s=i;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=+n[h+(x<<2)>>2];z=+n[h+((x|1)<<2)>>2];x=w+k|0;A=y*+(d[s+(w<<1)>>1]|0)+z*+(d[s+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(d[v+(w<<1)>>1]|0)+z*+(d[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(q){u=m;do{x=f[g+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(d[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=+(d[s+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(j|0))}}while((r|0)!=(l|0));o=l}while(0);if((o|0)>=(e|0))return;if((m|0)<=0){l=(j|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(l){q=0;do{n[p+(q<<2)>>2]=+(d[s+(f[g+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(j|0))}r=r+1|0}while((r|0)!=(e|0));return}r=(m|0)<(j|0);l=o;do{o=f[b+(l<<2)>>2]|0;q=f[c+(l<<2)>>2]|0;s=0;do{p=f[g+(s<<2)>>2]|0;a=s<<1;n[q+(s<<2)>>2]=+(d[o+(p<<1)>>1]|0)*+n[h+(a<<2)>>2]+ +(d[o+(p+k<<1)>>1]|0)*+n[h+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(m|0));if(r){s=m;do{n[q+(s<<2)>>2]=+(d[o+(f[g+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0))}l=l+1|0}while((l|0)!=(e|0));return}function bla(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=ALc(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=ALc(m)|0;d[c+(l<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=ALc(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=ALc(m)|0;d[c+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=ALc(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;q=q+1|0}while((q|0)!=(g|0));return}function cla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52440;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function dla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52440;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function ela(a){a=a|0;dla(a);cYc(a);return}function fla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))gla(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;hla(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function gla(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)o=0;else{l=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(i|0)>0;q=0;r=h;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[e+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(j[t+(w<<1)>>1]|0);n[s+(v<<2)>>2]=+(j[r+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(i|0))}if((q|0)==(l|0)){o=l;break a}}}q=(m|0)<(i|0);r=0;s=h;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+k|0;A=y*+(j[s+(w<<1)>>1]|0)+z*+(j[s+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(j[v+(w<<1)>>1]|0)+z*+(j[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(q){u=m;do{x=f[e+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(j[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=+(j[s+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(i|0))}}while((r|0)!=(l|0));o=l}while(0);if((o|0)>=(d|0))return;if((m|0)<=0){l=(i|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(l){q=0;do{n[p+(q<<2)>>2]=+(j[s+(f[e+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(m|0)<(i|0);l=o;do{o=f[b+(l<<2)>>2]|0;q=f[c+(l<<2)>>2]|0;s=0;do{p=f[e+(s<<2)>>2]|0;a=s<<1;n[q+(s<<2)>>2]=+(j[o+(p<<1)>>1]|0)*+n[g+(a<<2)>>2]+ +(j[o+(p+k<<1)>>1]|0)*+n[g+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(m|0));if(r){s=m;do{n[q+(s<<2)>>2]=+(j[o+(f[e+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0))}l=l+1|0}while((l|0)!=(d|0));return}function hla(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=ALc(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=ALc(m)|0;d[c+(l<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=ALc(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;p=ALc(m)|0;d[c+(l<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=ALc(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;q=q+1|0}while((q|0)!=(g|0));return}function ila(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52460;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function jla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52460;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function kla(a){a=a|0;jla(a);cYc(a);return}function lla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))mla(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;nla(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<1)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function mla(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;a:do if((e|0)<2)o=0;else{m=e+-1|0;j=f[b>>2]|0;a=f[c>>2]|0;if((n|0)<=0){p=(k|0)>0;q=0;r=j;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;f[u+(v<<2)>>2]=h[t+w>>0]<<11;f[s+(v<<2)>>2]=h[r+w>>0]<<11;v=v+1|0}while((v|0)!=(k|0))}if((q|0)==(m|0)){o=m;break a}}}q=(n|0)<(k|0);r=0;s=j;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=d[i+(x<<1)>>1]|0;z=d[i+((x|1)<<1)>>1]|0;x=Y(h[v+w>>0]|0,y)|0;A=w+l|0;B=(Y(h[v+A>>0]|0,z)|0)+x|0;x=Y(h[s+w>>0]|0,y)|0;y=(Y(h[s+A>>0]|0,z)|0)+x|0;f[t+(u<<2)>>2]=B;f[p+(u<<2)>>2]=y;u=u+1|0}while((u|0)!=(n|0));if(q){u=n;do{y=f[g+(u<<2)>>2]|0;f[t+(u<<2)>>2]=h[v+y>>0]<<11;f[p+(u<<2)>>2]=h[s+y>>0]<<11;u=u+1|0}while((u|0)!=(k|0))}}while((r|0)!=(m|0));o=m}while(0);if((o|0)>=(e|0))return;if((n|0)<=0){m=(k|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(m){q=0;do{f[p+(q<<2)>>2]=h[s+(f[g+(q<<2)>>2]|0)>>0]<<11;q=q+1|0}while((q|0)!=(k|0))}r=r+1|0}while((r|0)!=(e|0));return}r=(n|0)<(k|0);m=o;do{o=f[b+(m<<2)>>2]|0;q=f[c+(m<<2)>>2]|0;s=0;do{p=f[g+(s<<2)>>2]|0;a=s<<1;j=Y(d[i+(a<<1)>>1]|0,h[o+p>>0]|0)|0;u=(Y(d[i+((a|1)<<1)>>1]|0,h[o+(p+l)>>0]|0)|0)+j|0;f[q+(s<<2)>>2]=u;s=s+1|0}while((s|0)!=(n|0));if(r){s=n;do{f[q+(s<<2)>>2]=h[o+(f[g+(s<<2)>>2]|0)>>0]<<11;s=s+1|0}while((s|0)!=(k|0))}m=m+1|0}while((m|0)!=(e|0));return}function nla(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=d[g>>1]|0;i=d[g+2>>1]|0;g=f[c>>2]|0;j=f[c+4>>2]|0;c=h+-4|0;if((h|0)<4)k=0;else{l=a<<16>>16;m=i<<16>>16;n=0;do{o=(Y(f[g+(n<<2)>>2]>>4,l)|0)>>>16;p=(o+2+((Y(f[j+(n<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+n>>0]=p;p=n|1;o=(Y(f[g+(p<<2)>>2]>>4,l)|0)>>>16;q=(o+2+((Y(f[j+(p<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+p>>0]=q;q=n|2;p=(Y(f[g+(q<<2)>>2]>>4,l)|0)>>>16;o=(p+2+((Y(f[j+(q<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+q>>0]=o;o=n|3;q=(Y(f[g+(o<<2)>>2]>>4,l)|0)>>>16;p=(q+2+((Y(f[j+(o<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+o>>0]=p;n=n+4|0}while((n|0)<=(c|0));k=h&-4}if((k|0)>=(h|0))return;c=a<<16>>16;a=i<<16>>16;i=k;do{k=(Y(f[g+(i<<2)>>2]>>4,c)|0)>>>16;n=(k+2+((Y(f[j+(i<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;b[e+i>>0]=n;i=i+1|0}while((i|0)!=(h|0));return}function ola(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Rla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Sla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Sla(o);u=k;return}function pla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Lla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Mla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Mla(o);u=k;return}function qla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Fla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Gla(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Gla(o);u=k;return}function rla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;zla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Ala(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);Ala(o);u=k;return}function sla(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;tla(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);ula(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;h3(n,o,y);ula(o);u=k;return}function tla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52480;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function ula(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52480;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function vla(a){a=a|0;ula(a);cYc(a);return}function wla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=bYc(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))xla(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;yla(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function xla(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;q=0-(i<<3)|0;r=0;s=g;while(1){g=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=k;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,j)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+j|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-j|0}B=B+ +p[g+(E<<3)>>3]*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);p[t+(y<<3)>>3]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(i|0))break;if((H|0)<(l|0)){J=H;K=I}else{u=i;v=H;w=I;continue}while(1){z=f[e+(J<<2)>>2]|0;p[t+(J<<3)>>3]=+p[g+(z-a<<3)>>3]*+n[K>>2]+ +p[g+(z-m<<3)>>3]*+n[K+4>>2]+ +p[g+(z-j<<3)>>3]*+n[K+8>>2]+ +p[g+(z<<3)>>3]*+n[K+12>>2]+ +p[g+(z+j<<3)>>3]*+n[K+16>>2]+ +p[g+(z+m<<3)>>3]*+n[K+20>>2]+ +p[g+(z+a<<3)>>3]*+n[K+24>>2]+ +p[g+(z+o<<3)>>3]*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(l|0)){J=z;K=y}else{u=i;v=l;w=y;continue a}}}r=r+1|0;if((r|0)==(d|0))break;else s=I+(q<<2)|0}return}function yla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0.0,o=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=+n[d>>2];i=f[b>>2]|0;j=f[b+16>>2]|0;k=+n[d+4>>2];l=f[b+4>>2]|0;m=+n[d+8>>2];o=f[b+8>>2]|0;q=+n[d+12>>2];r=f[b+12>>2]|0;s=+n[d+16>>2];t=+n[d+20>>2];u=f[b+20>>2]|0;v=+n[d+24>>2];w=f[b+24>>2]|0;x=+n[d+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=h*+p[i+(A<<3)>>3]+k*+p[l+(A<<3)>>3]+m*+p[o+(A<<3)>>3]+q*+p[r+(A<<3)>>3]+s*+p[j+(A<<3)>>3]+t*+p[u+(A<<3)>>3]+v*+p[w+(A<<3)>>3]+x*+p[y+(A<<3)>>3];E=h*+p[i+(B<<3)>>3]+k*+p[l+(B<<3)>>3]+m*+p[o+(B<<3)>>3]+q*+p[r+(B<<3)>>3]+s*+p[j+(B<<3)>>3]+t*+p[u+(B<<3)>>3]+v*+p[w+(B<<3)>>3]+x*+p[y+(B<<3)>>3];F=h*+p[i+(C<<3)>>3]+k*+p[l+(C<<3)>>3]+m*+p[o+(C<<3)>>3]+q*+p[r+(C<<3)>>3]+s*+p[j+(C<<3)>>3]+t*+p[u+(C<<3)>>3]+v*+p[w+(C<<3)>>3]+x*+p[y+(C<<3)>>3];p[c+(z<<3)>>3]=h*+p[i+(z<<3)>>3]+k*+p[l+(z<<3)>>3]+m*+p[o+(z<<3)>>3]+q*+p[r+(z<<3)>>3]+s*+p[j+(z<<3)>>3]+t*+p[u+(z<<3)>>3]+v*+p[w+(z<<3)>>3]+x*+p[y+(z<<3)>>3];p[c+(A<<3)>>3]=D;p[c+(B<<3)>>3]=E;p[c+(C<<3)>>3]=F;z=z+4|0}while((z|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=+n[d>>2];z=f[b+4>>2]|0;v=+n[d+4>>2];y=f[b+8>>2]|0;t=+n[d+8>>2];w=f[b+12>>2]|0;s=+n[d+12>>2];u=f[b+16>>2]|0;q=+n[d+16>>2];j=f[b+20>>2]|0;m=+n[d+20>>2];r=f[b+24>>2]|0;k=+n[d+24>>2];o=f[b+28>>2]|0;h=+n[d+28>>2];d=g;do{p[c+(d<<3)>>3]=+p[a+(d<<3)>>3]*x+ +p[z+(d<<3)>>3]*v+ +p[y+(d<<3)>>3]*t+ +p[w+(d<<3)>>3]*s+ +p[u+(d<<3)>>3]*q+ +p[j+(d<<3)>>3]*m+ +p[r+(d<<3)>>3]*k+ +p[o+(d<<3)>>3]*h;d=d+1|0}while((d|0)!=(e|0));return}function zla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52500;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function Ala(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52500;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Bla(a){a=a|0;Ala(a);cYc(a);return}function Cla(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Dla(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Ela(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Dla(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;p=0-(i<<3)|0;q=0;r=g;while(1){g=f[b+(q<<2)>>2]|0;s=f[c+(q<<2)>>2]|0;t=k;u=0;v=r;a:while(1){if((t|0)>(u|0)){w=t-u<<3;x=u;y=v;while(1){z=f[e+(x<<2)>>2]|0;A=0.0;B=0;do{C=(Y(B+-3|0,j)|0)+z|0;if(C>>>0<h>>>0)D=C;else{E=C;while(1)if((E|0)<0)E=E+j|0;else{F=E;break}while(1)if((F|0)<(h|0)){D=F;break}else F=F-j|0}A=A+ +n[g+(D<<2)>>2]*+n[y+(B<<2)>>2];B=B+1|0}while((B|0)!=8);n[s+(x<<2)>>2]=A;x=x+1|0;if((x|0)==(t|0))break;else y=y+32|0}G=t;H=v+(w<<2)|0}else{G=u;H=v}if((t|0)==(i|0))break;if((G|0)<(l|0)){I=G;J=H}else{t=i;u=G;v=H;continue}while(1){y=f[e+(I<<2)>>2]|0;n[s+(I<<2)>>2]=+n[g+(y-a<<2)>>2]*+n[J>>2]+ +n[g+(y-m<<2)>>2]*+n[J+4>>2]+ +n[g+(y-j<<2)>>2]*+n[J+8>>2]+ +n[g+(y<<2)>>2]*+n[J+12>>2]+ +n[g+(y+j<<2)>>2]*+n[J+16>>2]+ +n[g+(y+m<<2)>>2]*+n[J+20>>2]+ +n[g+(y+a<<2)>>2]*+n[J+24>>2]+ +n[g+(y+o<<2)>>2]*+n[J+28>>2];y=I+1|0;x=J+32|0;if((y|0)<(l|0)){I=y;J=x}else{t=i;u=l;v=x;continue a}}}q=q+1|0;if((q|0)==(d|0))break;else r=H+(p<<2)|0}return}function Ela(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=f[b>>2]|0;i=d+4|0;j=f[b+16>>2]|0;k=f[b+20>>2]|0;l=f[b+4>>2]|0;m=d+8|0;o=f[b+8>>2]|0;p=d+12|0;q=f[b+12>>2]|0;r=d+16|0;s=d+20|0;t=d+24|0;u=f[b+24>>2]|0;v=d+28|0;w=f[b+28>>2]|0;x=0;do{y=+n[d>>2];z=x|1;A=x|2;B=x|3;C=+n[i>>2];D=+n[m>>2];E=+n[p>>2];F=+n[r>>2];G=+n[s>>2];H=+n[t>>2];I=+n[v>>2];J=y*+n[h+(z<<2)>>2]+C*+n[l+(z<<2)>>2]+D*+n[o+(z<<2)>>2]+E*+n[q+(z<<2)>>2]+F*+n[j+(z<<2)>>2]+G*+n[k+(z<<2)>>2]+H*+n[u+(z<<2)>>2]+I*+n[w+(z<<2)>>2];K=y*+n[h+(A<<2)>>2]+C*+n[l+(A<<2)>>2]+D*+n[o+(A<<2)>>2]+E*+n[q+(A<<2)>>2]+F*+n[j+(A<<2)>>2]+G*+n[k+(A<<2)>>2]+H*+n[u+(A<<2)>>2]+I*+n[w+(A<<2)>>2];L=y*+n[h+(B<<2)>>2]+C*+n[l+(B<<2)>>2]+D*+n[o+(B<<2)>>2]+E*+n[q+(B<<2)>>2]+F*+n[j+(B<<2)>>2]+G*+n[k+(B<<2)>>2]+H*+n[u+(B<<2)>>2]+I*+n[w+(B<<2)>>2];n[c+(x<<2)>>2]=y*+n[h+(x<<2)>>2]+C*+n[l+(x<<2)>>2]+D*+n[o+(x<<2)>>2]+E*+n[q+(x<<2)>>2]+F*+n[j+(x<<2)>>2]+G*+n[k+(x<<2)>>2]+H*+n[u+(x<<2)>>2]+I*+n[w+(x<<2)>>2];n[c+(z<<2)>>2]=J;n[c+(A<<2)>>2]=K;n[c+(B<<2)>>2]=L;x=x+4|0}while((x|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=f[b+4>>2]|0;w=d+4|0;u=f[b+8>>2]|0;k=d+8|0;j=f[b+12>>2]|0;q=d+12|0;o=f[b+16>>2]|0;l=d+16|0;h=f[b+20>>2]|0;v=d+20|0;t=f[b+24>>2]|0;s=d+24|0;r=f[b+28>>2]|0;b=d+28|0;p=g;do{n[c+(p<<2)>>2]=+n[a+(p<<2)>>2]*+n[d>>2]+ +n[x+(p<<2)>>2]*+n[w>>2]+ +n[u+(p<<2)>>2]*+n[k>>2]+ +n[j+(p<<2)>>2]*+n[q>>2]+ +n[o+(p<<2)>>2]*+n[l>>2]+ +n[h+(p<<2)>>2]*+n[v>>2]+ +n[t+(p<<2)>>2]*+n[s>>2]+ +n[r+(p<<2)>>2]*+n[b>>2];p=p+1|0}while((p|0)!=(e|0));return}function Fla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52520;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function Gla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52520;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Hla(a){a=a|0;Gla(a);cYc(a);return}function Ila(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Jla(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Kla(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Jla(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(j<<3)|0;r=0;s=h;while(1){h=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=l;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,k)|0)+A|0;if(D>>>0<i>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(i|0)){E=G;break}else G=G-k|0}B=B+ +(d[h+(E<<1)>>1]|0)*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);n[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(j|0))break;if((H|0)<(m|0)){J=H;K=I}else{u=j;v=H;w=I;continue}while(1){z=f[g+(J<<2)>>2]|0;n[t+(J<<2)>>2]=+(d[h+(z-a<<1)>>1]|0)*+n[K>>2]+ +(d[h+(z-o<<1)>>1]|0)*+n[K+4>>2]+ +(d[h+(z-k<<1)>>1]|0)*+n[K+8>>2]+ +(d[h+(z<<1)>>1]|0)*+n[K+12>>2]+ +(d[h+(z+k<<1)>>1]|0)*+n[K+16>>2]+ +(d[h+(z+o<<1)>>1]|0)*+n[K+20>>2]+ +(d[h+(z+a<<1)>>1]|0)*+n[K+24>>2]+ +(d[h+(z+p<<1)>>1]|0)*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(m|0)){J=z;K=y}else{u=j;v=m;w=y;continue a}}}r=r+1|0;if((r|0)==(e|0))break;else s=I+(q<<2)|0}return}function Kla(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=ALc(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=ALc(D)|0;d[c+(A<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=ALc(E)|0;d[c+(B<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=ALc(F)|0;d[c+(C<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=ALc(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;e=e+1|0}while((e|0)!=(g|0));return}function Lla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52540;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}
function Zfc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=u;u=u+16|0;d=c;f[a>>2]=170956;e=a+4|0;g=f[e>>2]|0;h=f[g+28>>2]|0;i=a+(f[g+12>>2]|0)|0;g=f[i>>2]|0;if(g&1|0?(j=g&-2,g=j,!((j|0)==0|(f[g+4>>2]|0)!=0)):0){if(f[g>>2]|0)sqc(g);cYc(j)}f[i>>2]=0;i=f[(f[e>>2]|0)+16>>2]|0;if((i|0)!=-1)urc(a+i|0);i=h+52|0;j=f[i>>2]|0;if((j|0)<=0){u=c;return}g=h+20|0;h=d+4|0;k=d+8|0;l=d+12|0;m=d+4|0;n=d+8|0;o=d+12|0;p=d+4|0;q=d+8|0;r=d+12|0;s=d+4|0;t=d+8|0;v=d+12|0;w=d+4|0;x=d+8|0;y=d+12|0;z=d+4|0;A=d+8|0;B=d+12|0;C=0;D=j;do{j=f[g>>2]|0;E=j+(C*88|0)|0;F=f[j+(C*88|0)+52>>2]|0;G=f[e>>2]|0;a:do if(F){H=(F-(f[(f[F+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[a+((H<<2)+(f[G+8>>2]|0))>>2]|0)==(f[j+(C*88|0)+40>>2]|0)){I=a+(f[(f[G+32>>2]|0)+(H+D<<2)>>2]|0)|0;H=j+(C*88|0)+24|0;J=f[H>>2]|0;if(J|0?(f[J>>2]|0)!=2:0){f[d>>2]=80424;f[z>>2]=2231;b[A>>0]=0;f[B>>2]=E;J_b(J,d)}J=j+(C*88|0)+28|0;if((f[165644+(f[J>>2]<<2)>>2]|0)==9){K=f[e>>2]|0;L=f[I>>2]|0;if((L|0)==0?1:(L|0)==(f[(f[K+44>>2]|0)+(f[(f[K+32>>2]|0)+(C<<2)>>2]|0)>>2]|0))break;if((b[L+11>>0]|0)<0)cYc(f[L>>2]|0);cYc(L);break}L=f[H>>2]|0;if(L|0?(f[L>>2]|0)!=2:0){f[d>>2]=80424;f[w>>2]=2231;b[x>>0]=0;f[y>>2]=E;J_b(L,d)}if((f[165644+(f[J>>2]<<2)>>2]|0)==10?(J=f[I>>2]|0,J|0):0)Yi[f[(f[J>>2]|0)+4>>2]&4095](J)}}else{J=a+(f[(f[G+32>>2]|0)+(C<<2)>>2]|0)|0;I=j+(C*88|0)+24|0;L=f[I>>2]|0;H=(L|0)==0;if((f[j+(C*88|0)+32>>2]|0)!=3){if(!H?(f[L>>2]|0)!=2:0){f[d>>2]=80424;f[s>>2]=2231;b[t>>0]=0;f[v>>2]=E;J_b(L,d)}K=j+(C*88|0)+28|0;if((f[165644+(f[K>>2]<<2)>>2]|0)==9){M=f[e>>2]|0;N=f[J>>2]|0;if((N|0)==0?1:(N|0)==(f[(f[M+44>>2]|0)+(f[(f[M+32>>2]|0)+(C<<2)>>2]|0)>>2]|0))break;if((b[N+11>>0]|0)<0)cYc(f[N>>2]|0);cYc(N);break}N=f[I>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[d>>2]=80424;f[p>>2]=2231;b[q>>0]=0;f[r>>2]=E;J_b(N,d)}if((f[165644+(f[K>>2]<<2)>>2]|0)!=10)break;K=f[(f[e>>2]|0)+44>>2]|0;if((K|0)==(a|0)|(K|0)==0)break;K=f[J>>2]|0;if(!K)break;Yi[f[(f[K>>2]|0)+4>>2]&4095](K);break}if(!H?(f[L>>2]|0)!=2:0){f[d>>2]=80424;f[m>>2]=2231;b[n>>0]=0;f[o>>2]=E;J_b(L,d)}L=j+(C*88|0)+28|0;do switch(f[165644+(f[L>>2]<<2)>>2]|0){case 1:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 2:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 3:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 4:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 5:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 6:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 7:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 8:{H=f[J+8>>2]|0;if(!H)break a;if(f[H>>2]|0)break a;cYc(H);break a;break}case 9:{H=J+12|0;K=f[H>>2]|0;if(K|0?(f[J>>2]|0)==0:0){N=f[K>>2]|0;if((N|0)>0){M=0;do{O=f[K+4+(M<<2)>>2]|0;if(O|0){if((b[O+11>>0]|0)<0)cYc(f[O>>2]|0);cYc(O)}M=M+1|0}while((M|0)!=(N|0));P=f[H>>2]|0}else P=K;cYc(P)}f[H>>2]=0;break a;break}case 10:{N=f[I>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[d>>2]=80424;f[h>>2]=2231;b[k>>0]=0;f[l>>2]=E;J_b(N,d)}if((f[L>>2]|0)==11?D3b(E)|0:0){Yi[f[f[J>>2]>>2]&4095](J);break a}N=J+12|0;M=f[N>>2]|0;if(M|0?(f[J>>2]|0)==0:0){O=f[M>>2]|0;if((O|0)>0){Q=0;do{R=f[M+4+(Q<<2)>>2]|0;if(R|0)Yi[f[(f[R>>2]|0)+4>>2]&4095](R);Q=Q+1|0}while((Q|0)!=(O|0));S=f[N>>2]|0}else S=M;cYc(S)}f[N>>2]=0;break a;break}default:break a}while(0)}while(0);C=C+1|0;D=f[i>>2]|0}while((C|0)<(D|0));u=c;return}function _fc(a){a=a|0;Zfc(a);cYc(a);return}function $fc(a){a=a|0;var b=0,c=0;b=a+4|0;a=$Xc(f[f[b>>2]>>2]|0)|0;c=f[b>>2]|0;g1c(a|0,0,f[c>>2]|0)|0;f[a>>2]=170956;f[a+4>>2]=c;f[a+8>>2]=0;ggc(a,1);return a|0}function agc(a,b){a=a|0;b=b|0;var c=0;c=_i[f[(f[a>>2]|0)+12>>2]&2047](a)|0;if(!b)return c|0;fgc(b,c);return c|0}function bgc(a){a=a|0;return 0}function cgc(a){a=a|0;return f[a+8>>2]|0}function dgc(a,b){a=a|0;b=b|0;f[a+8>>2]=b;return}function egc(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;f[a>>2]=f[c+28>>2];f[a+4>>2]=f[c+40>>2];return}function fgc(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function ggc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=a+4|0;h=f[g>>2]|0;i=f[h+28>>2]|0;j=i+56|0;if((f[j>>2]|0)>0){k=0;l=h;while(1){f[a+((f[l+8>>2]|0)+(k<<2))>>2]=0;k=k+1|0;m=f[g>>2]|0;if((k|0)>=(f[j>>2]|0)){n=m;break}else l=m}}else n=h;f[a+(f[n+12>>2]|0)>>2]=0;n=f[(f[g>>2]|0)+16>>2]|0;if((n|0)!=-1)trc(a+n|0);n=i+52|0;if((f[n>>2]|0)<=0){u=d;return}h=i+20|0;i=e+4|0;l=e+8|0;j=e+12|0;k=e+4|0;m=e+8|0;o=e+12|0;q=0;do{r=f[h>>2]|0;s=r+(q*88|0)|0;t=a+(f[(f[(f[g>>2]|0)+32>>2]|0)+(q<<2)>>2]|0)|0;a:do if(!(f[r+(q*88|0)+52>>2]|0)){v=r+(q*88|0)+24|0;w=f[v>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[e>>2]=80424;f[k>>2]=2231;b[m>>0]=0;f[o>>2]=s;J_b(w,e)}w=r+(q*88|0)+28|0;do switch(f[165644+(f[w>>2]<<2)>>2]|0){case 1:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{f[t>>2]=f[r+(q*88|0)+80>>2];break a}break}case 2:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{x=r+(q*88|0)+80|0;y=f[x+4>>2]|0;z=t;f[z>>2]=f[x>>2];f[z+4>>2]=y;break a}break}case 3:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{f[t>>2]=f[r+(q*88|0)+80>>2];break a}break}case 4:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{y=r+(q*88|0)+80|0;z=f[y+4>>2]|0;x=t;f[x>>2]=f[y>>2];f[x+4>>2]=z;break a}break}case 5:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{p[t>>3]=+p[r+(q*88|0)+80>>3];break a}break}case 6:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{f[t>>2]=f[r+(q*88|0)+80>>2];break a}break}case 7:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{b[t>>0]=b[r+(q*88|0)+80>>0]|0;break a}break}case 8:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;break a}else{z=(E3b(s)|0)+8|0;f[t>>2]=f[z>>2];break a}break}case 9:{if((f[r+(q*88|0)+32>>2]|0)==3){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;break a}z=f[g>>2]|0;x=f[z+44>>2]|0;if((x|0)==(a|0)|(x|0)==0)A=r+(q*88|0)+80|0;else A=x+(f[(f[z+32>>2]|0)+(q<<2)>>2]|0)|0;f[t>>2]=f[A>>2];break a;break}case 10:{if((f[r+(q*88|0)+32>>2]|0)!=3){f[t>>2]=0;break a}z=f[v>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[e>>2]=80424;f[i>>2]=2231;b[l>>0]=0;f[j>>2]=s;J_b(z,e)}if((f[w>>2]|0)==11?D3b(s)|0:0){z=f[(f[g>>2]|0)+20>>2]|0;if(c){x=f[(f[z>>2]|0)+8>>2]|0;y=F3b(s)|0;flc(t,Mi[x&1023](z,y)|0);break a}else{flc(t,hgc(z,F3b(s)|0)|0);break a}};f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;break a;break}default:break a}while(0)}while(0);q=q+1|0}while((q|0)<(f[n>>2]|0));u=d;return}function hgc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=u;u=u+80|0;e=d+32|0;g=d+8|0;h=d+68|0;i=d;f[i>>2]=c;if(b[a+8>>0]|0?(j=f[(f[c+8>>2]|0)+8>>2]|0,(j|0)==(m3b()|0)):0){j=uoc()|0;k=Mi[f[(f[j>>2]|0)+8>>2]&1023](j,c)|0;u=d;return k|0}c=igc(f[a+12>>2]|0,i)|0;j=f[c>>2]|0;if(j|0){k=f[j+44>>2]|0;u=d;return k|0}j=$Xc(52)|0;l=j+32|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[c>>2]=j;c=f[i>>2]|0;m=j+28|0;f[m>>2]=c;n=f[a+4>>2]|0;if(!n)o=f[(f[c+8>>2]|0)+8>>2]|0;else o=n;n=j+24|0;f[n>>2]=o;f[j+20>>2]=a;o=(f[c+56>>2]|0)+(f[c+52>>2]|0)|0;p=bYc(o>>>0>1073741823?-1:o<<2)|0;o=f[l>>2]|0;if((o|0)==(p|0))q=c;else{if(!o)r=c;else{dYc(o);r=f[i>>2]|0}f[l>>2]=p;q=r}r=j+4|0;if((f[(f[q+8>>2]|0)+44>>2]|0)!=3){f[r>>2]=16;o=q+52|0;c=f[o>>2]|0;s=(((c+31|0)/32|0)<<2)+23|0;t=s-((s|0)%8|0)|0;s=bYc(c>>>0>1073741823?-1:c<<2)|0;if((f[o>>2]|0)>0){c=0;do{f[s+(c<<2)>>2]=c;c=c+1|0}while((c|0)<(f[o>>2]|0))}o=j+36|0;c=f[o>>2]|0;if((c|0)==(s|0)){v=t;w=q}else{if(!c)x=q;else{dYc(c);x=f[i>>2]|0}f[o>>2]=s;v=t;w=x}}else{f[r>>2]=-1;v=16;w=q}q=f[w+56>>2]|0;if((q|0)>0){f[j+8>>2]=v;x=v+7+(q<<2)|0;y=x-((x|0)%8|0)|0}else y=v;v=j+16|0;if((f[w+68>>2]|0)>0){f[v>>2]=y;x=y+23|0;z=x-((x|0)%8|0)|0}else{f[v>>2]=-1;z=y}y=f[w+52>>2]|0;if((y|0)>0){x=e+4|0;t=e+8|0;s=e+12|0;o=e+4|0;c=e+8|0;A=e+12|0;B=0;C=z;D=w;while(1){E=f[D+20>>2]|0;F=E+(B*88|0)|0;if(!(f[E+(B*88|0)+52>>2]|0)){G=(f[E+(B*88|0)+32>>2]|0)==3;H=E+(B*88|0)+24|0;I=f[H>>2]|0;if(I|0?(f[I>>2]|0)!=2:0){f[e>>2]=80424;f[o>>2]=2231;b[c>>0]=0;f[A>>2]=F;J_b(I,e)}I=E+(B*88|0)+28|0;E=f[165644+(f[I>>2]<<2)>>2]|0;a:do if(G){switch(E|0){case 8:case 7:case 6:case 5:case 4:case 3:case 2:case 1:{J=12;K=48;break a;break}case 10:break;case 9:{J=16;K=48;break a;break}default:{K=47;break a}}L=f[H>>2]|0;if(L|0?(f[L>>2]|0)!=2:0){f[e>>2]=80424;f[x>>2]=2231;b[t>>0]=0;f[s>>2]=F;J_b(L,e)}if((f[I>>2]|0)==11){L=D3b(F)|0;M=L?36:16}else{J=16;K=48}}else switch(E|0){case 9:case 10:case 8:case 6:case 3:case 1:{J=4;K=48;break a;break}case 2:{J=8;K=48;break a;break}case 4:{J=8;K=48;break a;break}case 5:{J=8;K=48;break a;break}case 7:{J=1;K=48;break a;break}default:{K=47;break a}}while(0);if((K|0)==47){K=0;u_b(g,2,496684,162);r_b(h,p_b(g,507741)|0);v_b(g);J=0;K=48}if((K|0)==48){K=0;M=J}E=(M|0)<8?M:8;F=C+-1+E|0;I=F-((F|0)%(E|0)|0)|0;f[p+(B<<2)>>2]=I;N=I+M|0;O=f[i>>2]|0}else{N=C;O=D}B=B+1|0;P=f[O+52>>2]|0;if((B|0)>=(P|0))break;else{C=N;D=O}}Q=N;R=O;S=f[O+56>>2]|0;T=P}else{Q=z;R=w;S=q;T=y}y=R+56|0;q=Q+7|0;Q=q-((q|0)%8|0)|0;if((S|0)>0){q=R+52|0;f[p+(T<<2)>>2]=Q;T=f[y>>2]|0;w=Q+15|0;z=w-((w|0)%8|0)|0;if((T|0)>1){w=1;P=z;while(1){f[p+((f[q>>2]|0)+w<<2)>>2]=P;w=w+1|0;O=f[y>>2]|0;N=P+15|0;D=N-((N|0)%8|0)|0;if((w|0)>=(O|0)){U=D;V=O;break}else P=D}}else{U=z;V=T}}else{U=Q;V=S}S=j+12|0;f[S>>2]=U;Q=U+4|0;U=j+48|0;f[U>>2]=-1;f[j>>2]=Q;if((V|0)>0){V=e+4|0;T=e+8|0;z=e+12|0;P=0;w=Q;y=R;while(1){R=f[y+24>>2]|0;b:do if((f[R+(P*28|0)+16>>2]|0)>0){q=0;D=w;O=R;while(1){N=f[(f[O+(P*28|0)+20>>2]|0)+(q<<2)>>2]|0;C=f[N+24>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[e>>2]=80424;f[V>>2]=2231;b[T>>0]=0;f[z>>2]=N;J_b(C,e)}switch(f[165644+(f[N+28>>2]<<2)>>2]|0){case 9:case 10:case 8:case 6:case 3:case 1:{W=4;break}case 2:{W=8;break}case 4:{W=8;break}case 5:{W=8;break}case 7:{W=1;break}default:{u_b(g,2,496684,192);r_b(h,p_b(g,507741)|0);v_b(g);W=0}}C=W>>>0<8?W:8;B=D+-1+C|0;M=B-((B|0)%(C|0)|0)|0;do if(b[N+38>>0]|0){C=f[N+56>>2]|0;B=N;if(!C){X=B-(f[(f[N+20>>2]|0)+80>>2]|0)|0;break}else{X=B-(f[C+40>>2]|0)|0;break}}else X=N-(f[(f[N+48>>2]|0)+20>>2]|0)|0;while(0);f[p+(((X|0)/88|0)<<2)>>2]=M;N=M+W|0;q=q+1|0;C=f[i>>2]|0;O=f[C+24>>2]|0;if((q|0)>=(f[O+(P*28|0)+16>>2]|0)){Y=N;Z=C;break b}else D=N}}else{Y=w;Z=y}while(0);P=P+1|0;if((P|0)>=(f[Z+56>>2]|0)){_=Y;break}else{w=Y;y=Z}}}else _=Q;Q=_+7|0;_=Q-((Q|0)%8|0)|0;Q=$Xc(_)|0;g1c(Q|0,0,_|0)|0;_=j+44|0;f[_>>2]=Q;f[Q>>2]=170956;f[Q+4>>2]=j;f[Q+8>>2]=0;ggc(Q,0);if((f[(f[i>>2]|0)+56>>2]|0)>0)jgc(f[m>>2]|0,f[l>>2]|0,Q);f[e>>2]=f[_>>2];f[e+4>>2]=f[l>>2];f[e+8>>2]=f[j+36>>2];f[e+12>>2]=f[r>>2];f[e+16>>2]=f[S>>2];f[e+20>>2]=f[v>>2];f[e+24>>2]=f[j+8>>2];f[e+28>>2]=f[j>>2];f[e+32>>2]=f[U>>2];U=$Xc(56)|0;djc(U,f[m>>2]|0,e,f[n>>2]|0,a);a=j+40|0;j=f[a>>2]|0;if((j|0)!=(U|0)){if(j|0)Yi[f[(f[j>>2]|0)+4>>2]&4095](j);f[a>>2]=U}kgc(Q);k=Q;u=d;return k|0}function igc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;c=f[b>>2]|0;b=a+4|0;d=f[b>>2]|0;e=(d|0)==0;g=c;a:do if(!e){h=d+-1|0;i=(h&d|0)==0;if(!i)if(c>>>0<d>>>0)j=c;else j=(c>>>0)%(d>>>0)|0;else j=h&c;k=f[(f[a>>2]|0)+(j<<2)>>2]|0;if(!k)l=j;else{if(i){i=k;while(1){m=f[i>>2]|0;if(!m){l=j;break a}o=f[m+4>>2]|0;if(!((o|0)==(c|0)|(o&h|0)==(j|0))){l=j;break a}if((f[m+8>>2]|0)==(g|0)){p=m;break}else i=m}q=p+12|0;return q|0}else r=k;while(1){i=f[r>>2]|0;if(!i){l=j;break a}h=f[i+4>>2]|0;if((h|0)!=(c|0)){if(h>>>0<d>>>0)s=h;else s=(h>>>0)%(d>>>0)|0;if((s|0)!=(j|0)){l=j;break a}}if((f[i+8>>2]|0)==(g|0)){p=i;break}else r=i}q=p+12|0;return q|0}}else l=0;while(0);r=$Xc(16)|0;f[r+8>>2]=c;f[r+12>>2]=0;f[r+4>>2]=c;f[r>>2]=0;g=a+12|0;t=+(((f[g>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(e|t>+(d>>>0)*u){j=(d>>>0<3|(d+-1&d|0)!=0)&1|d<<1;s=~~+X(+(t/u))>>>0;lgc(a,j>>>0<s>>>0?s:j);j=f[b>>2]|0;s=j+-1|0;if(!(s&j)){v=j;w=s&c;break}if(c>>>0<j>>>0){v=j;w=c}else{v=j;w=(c>>>0)%(j>>>0)|0}}else{v=d;w=l}while(0);l=(f[a>>2]|0)+(w<<2)|0;w=f[l>>2]|0;if(!w){d=a+8|0;f[r>>2]=f[d>>2];f[d>>2]=r;f[l>>2]=d;d=f[r>>2]|0;if(d|0){l=f[d+4>>2]|0;d=v+-1|0;if(d&v)if(l>>>0<v>>>0)x=l;else x=(l>>>0)%(v>>>0)|0;else x=l&d;y=(f[a>>2]|0)+(x<<2)|0;z=30}}else{f[r>>2]=f[w>>2];y=w;z=30}if((z|0)==30)f[y>>2]=r;f[g>>2]=(f[g>>2]|0)+1;p=r;q=p+12|0;return q|0}function jgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+56|0;if((f[h>>2]|0)<=0){u=e;return}i=a+24|0;a=g+4|0;j=g+8|0;k=g+12|0;l=0;m=f[i>>2]|0;while(1){a:do if((f[m+(l*28|0)+16>>2]|0)>0){n=0;o=m;while(1){q=f[(f[o+(l*28|0)+20>>2]|0)+(n<<2)>>2]|0;do if(b[q+38>>0]|0){r=f[q+56>>2]|0;s=q;if(!r){t=s-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{t=s-(f[r+40>>2]|0)|0;break}}else t=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);r=d+(f[c+(((t|0)/88|0)<<2)>>2]|0)|0;s=f[q+24>>2]|0;if(s|0?(f[s>>2]|0)!=2:0){f[g>>2]=80424;f[a>>2]=2231;b[j>>0]=0;f[k>>2]=q;J_b(s,g)}do switch(f[165644+(f[q+28>>2]<<2)>>2]|0){case 1:{f[r>>2]=f[q+80>>2];break}case 2:{s=q+80|0;v=f[s+4>>2]|0;w=r;f[w>>2]=f[s>>2];f[w+4>>2]=v;break}case 3:{f[r>>2]=f[q+80>>2];break}case 4:{v=q+80|0;w=f[v+4>>2]|0;s=r;f[s>>2]=f[v>>2];f[s+4>>2]=w;break}case 5:{p[r>>3]=+p[q+80>>3];break}case 6:{f[r>>2]=f[q+80>>2];break}case 7:{b[r>>0]=b[q+80>>0]|0;break}case 8:{w=(E3b(q)|0)+8|0;f[r>>2]=f[w>>2];break}case 9:{f[r>>2]=0;f[r>>2]=f[q+80>>2];break}case 10:{f[r>>2]=0;break}default:{}}while(0);n=n+1|0;r=f[i>>2]|0;if((n|0)>=(f[r+(l*28|0)+16>>2]|0)){x=r;break a}else o=r}}else x=m;while(0);l=l+1|0;if((l|0)>=(f[h>>2]|0))break;else m=x}u=e;return}function kgc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+24|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[h+44>>2]|0;if((i|0)==(a|0)|(i|0)==0)j=h;else{u_b(e,3,496684,550);r_b(c+40|0,p_b(e,496781)|0);v_b(e);j=f[g>>2]|0}e=f[j+20>>2]|0;h=f[j+28>>2]|0;i=h+52|0;if((f[i>>2]|0)<=0){u=c;return}k=h+20|0;h=d+4|0;l=d+8|0;m=d+12|0;n=0;o=j;while(1){j=f[k>>2]|0;p=j+(n*88|0)|0;q=a+(f[(f[o+32>>2]|0)+(n<<2)>>2]|0)|0;r=f[j+(n*88|0)+24>>2]|0;if(r|0?(f[r>>2]|0)!=2:0){f[d>>2]=80424;f[h>>2]=2231;b[l>>0]=0;f[m>>2]=p;J_b(r,d)}if((f[165644+(f[j+(n*88|0)+28>>2]<<2)>>2]|0)==10?(f[j+(n*88|0)+32>>2]|0)!=3:0){j=hgc(e,F3b(p)|0)|0;f[q>>2]=j}j=n+1|0;if((j|0)>=(f[i>>2]|0))break;n=j;o=f[g>>2]|0}u=c;return}function lgc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){mgc(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;mgc(a,d);return}function mgc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){b:do if(h){e=k;c=l;i=m;while(1){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if((f[o>>2]|0)==(f[u+8>>2]|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[e>>2]|0;if(!o){v=37;break a}else d=o}c=f[d>>2]|0;if(!c){v=37;break a}else{e=d;i=d}}}else{i=k;e=l;c=m;while(1){o=e;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=c;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if((f[w>>2]|0)==(f[z+8>>2]|0))y=z;else break}f[c>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=37;break a}else o=w}e=f[o>>2]|0;if(!e){v=37;break a}else{i=o;c=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=37;break}else{j=s;k=p;m=p}}if((v|0)==37)return}function ngc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;d=c;f[a>>2]=171064;e=a+12|0;g=f[(f[e>>2]|0)+8>>2]|0;if(g|0){h=d+4|0;i=d+8|0;j=d+12|0;k=g;do{g=k+12|0;l=f[g>>2]|0;m=f[l+28>>2]|0;n=m+56|0;o=f[n>>2]|0;if((o|0)>0){p=m+24|0;m=0;q=f[p>>2]|0;r=o;while(1){if((f[q+(m*28|0)+16>>2]|0)>0){o=0;s=q;do{t=f[(f[s+(m*28|0)+20>>2]|0)+(o<<2)>>2]|0;v=f[t+24>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[d>>2]=80424;f[h>>2]=2231;b[i>>0]=0;f[j>>2]=t;J_b(v,d)}o=o+1|0;s=f[p>>2]|0}while((o|0)<(f[s+(m*28|0)+16>>2]|0));w=f[n>>2]|0;x=s}else{w=r;x=q}m=m+1|0;if((m|0)>=(w|0))break;else{q=x;r=w}}y=f[g>>2]|0}else y=l;if(y|0){r=f[y+44>>2]|0;if(r|0)Yi[f[(f[r>>2]|0)+4>>2]&4095](r);r=f[y+40>>2]|0;if(r|0)Yi[f[(f[r>>2]|0)+4>>2]&4095](r);r=f[y+36>>2]|0;if(r|0)dYc(r);r=f[y+32>>2]|0;if(r|0)dYc(r);cYc(y)}k=f[k>>2]|0}while((k|0)!=0)}x_b(a+16|0);a=f[e>>2]|0;if(!a){u=c;return}e=f[a+8>>2]|0;if(e|0){k=e;do{e=k;k=f[k>>2]|0;cYc(e)}while((k|0)!=0)}k=f[a>>2]|0;f[a>>2]=0;if(k|0)cYc(k);cYc(a);u=c;return}function ogc(a){a=a|0;ngc(a);cYc(a);return}function pgc(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+16|0;g_b(c);d=hgc(a,b)|0;h_b(c);return d|0}function qgc(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!b)return;a=f[b+8>>2]|0;if(a|0){c=a;do{a=c;c=f[c>>2]|0;cYc(a)}while((c|0)!=0)}c=f[b>>2]|0;f[b>>2]=0;if(c|0)cYc(c);cYc(b);return}function rgc(a){a=a|0;var c=0;f[a>>2]=171064;f[a+4>>2]=0;b[a+8>>0]=0;c=$Xc(20)|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;n[c+16>>2]=1.0;f[a+12>>2]=c;w_b(a+16|0);return}function sgc(a){a=a|0;cYc(a);return}function tgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+40|0;j=q3b(f[a+4>>2]|0,f[a+12>>2]|0,c)|0;if(!j){k=0;u=e;return k|0}c=j+24|0;l=f[c>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=j;J_b(l,g)}l=j+28|0;b[d>>0]=f[l>>2];b[d+1>>0]=(f[j+32>>2]|0)==3&1;b[d+2>>0]=b[(f[j+68>>2]|0)+52>>0]|0;f[d+12>>2]=j;m=f[c>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=j;J_b(m,g)}if((f[165644+(f[l>>2]<<2)>>2]|0)==10){m=f[a+8>>2]|0;a=f[(f[m>>2]|0)+8>>2]|0;n=F3b(j)|0;o=Mi[a&1023](m,n)|0;f[d+4>>2]=o;if(o|0){k=1;u=e;return k|0}u_b(h,3,496889,303);o=p_b(p_b(h,496990)|0,497040)|0;r_b(i,q_b(o,f[j+4>>2]|0)|0);v_b(h);k=1;u=e;return k|0}h=f[c>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=j;J_b(h,g)}if((f[165644+(f[l>>2]<<2)>>2]|0)!=8){k=1;u=e;return k|0}f[d+4>>2]=622;l=G3b(j)|0;f[d+8>>2]=l;k=1;u=e;return k|0}function ugc(a,b){a=a|0;b=b|0;return (y3b(a,b)|0)!=0|0}function vgc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;j=a+4|0;if((i|0)==(j|0)){u=g;return}a=e+4|0;k=e+8|0;l=i;while(1){i=l+16|0;if(!(b[i+17>>0]|0)){if(!(b[i+18>>0]&1))m=7}else if((yrc(l+24|0)|0)>0)m=7;do if((m|0)==7){m=0;n=l+40|0;o=f[n>>2]|0;p=o;if(o|0){o=f[a>>2]|0;if((o|0)==(f[k>>2]|0)){n1b(e,n);break}else{f[o>>2]=p;f[a>>2]=(f[a>>2]|0)+4;break}}p=q3b(d,c,f[i>>2]|0)|0;f[h>>2]=p;o=f[a>>2]|0;if(o>>>0<(f[k>>2]|0)>>>0){f[o>>2]=p;f[a>>2]=(f[a>>2]|0)+4}else wgc(e,h)}while(0);i=f[l+4>>2]|0;if(!i){p=l+8|0;o=f[p>>2]|0;if((f[o>>2]|0)==(l|0))q=o;else{o=p;do{p=f[o>>2]|0;o=p+8|0;n=f[o>>2]|0}while((f[n>>2]|0)!=(p|0));q=n}}else{o=i;while(1){n=f[o>>2]|0;if(!n)break;else o=n}q=o}if((q|0)==(j|0))break;else l=q}u=g;return}function wgc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function xgc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=a+4|0;a=f[g>>2]|0;if(a|0){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(c=b[g+18>>0]|0,(c&1)==0):0){g=f[k+24>>2]|0;if(!(c&16)){l=g;return l|0}c=f[(f[g>>2]|0)+12>>2]|0;k=Mi[f[(f[e>>2]|0)+8>>2]&1023](e,d)|0;l=Mi[c&1023](g,k)|0;return l|0}}l=Mi[f[(f[e>>2]|0)+8>>2]&1023](e,d)|0;return l|0}function ygc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+8|0;h=e;if(!(Drc(a,f[c+40>>2]|0,c,h)|0)){i=f[h>>2]|0;j=i+10|0;k=b[j>>0]|0;b[j>>0]=k&-16;j=f[i>>2]|0;if(!(k&16)){l=j;u=e;return l|0}k=f[(f[j>>2]|0)+16>>2]|0;i=f[(f[d>>2]|0)+8>>2]|0;m=F3b(c)|0;n=Mi[i&1023](d,m)|0;l=Mi[k&1023](j,n)|0;u=e;return l|0}n=f[c+24>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(n,g)}g=f[h>>2]|0;b[g+8>>0]=f[c+28>>2];b[g+9>>0]=0;b[g+11>>0]=0;g=f[(f[d>>2]|0)+8>>2]|0;n=F3b(c)|0;c=Mi[g&1023](d,n)|0;n=(f[h>>2]|0)+10|0;b[n>>0]=b[n>>0]&15;n=Mi[f[(f[c>>2]|0)+16>>2]&1023](c,f[a+12>>2]|0)|0;f[f[h>>2]>>2]=n;n=f[h>>2]|0;h=n+10|0;b[h>>0]=b[h>>0]&-16;l=f[n>>2]|0;u=e;return l|0}function zgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=c+40|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;if(!i){j=0;return j|0}else{k=h;l=i}a:while(1){i=l;while(1){if((f[i+16>>2]|0)>=(g|0))break;m=f[i+4>>2]|0;if(!m){n=k;break a}else i=m}l=f[i>>2]|0;if(!l){n=i;break}else k=i}if((n|0)==(h|0)){j=0;return j|0}k=n+16|0;if((g|0)<(f[k>>2]|0)){j=0;return j|0}g=n+24|0;n=f[g>>2]|0;if(b[k+18>>0]&16){k=f[(f[n>>2]|0)+32>>2]|0;l=f[(f[d>>2]|0)+8>>2]|0;m=F3b(c)|0;c=Mi[l&1023](d,m)|0;m=Mi[k&1023](n,c)|0;if((f[a+12>>2]|0)==0?(c=f[g>>2]|0,(c|0)!=0):0){Yi[f[(f[c>>2]|0)+4>>2]&4095](c);o=m}else o=m}else o=n;n=f[e>>2]|0;e=f[h>>2]|0;if(!e){j=o;return j|0}else{p=h;q=e}b:while(1){m=q;while(1){if((f[m+16>>2]|0)>=(n|0))break;c=f[m+4>>2]|0;if(!c){r=p;break b}else m=c}q=f[m>>2]|0;if(!q){r=m;break}else p=m}if((r|0)==(h|0)){j=o;return j|0}if((n|0)<(f[r+16>>2]|0)){j=o;return j|0}n=f[r+4>>2]|0;if(!n){h=r+8|0;p=f[h>>2]|0;if((f[p>>2]|0)==(r|0))s=p;else{p=h;do{h=f[p>>2]|0;p=h+8|0;q=f[p>>2]|0}while((f[q>>2]|0)!=(h|0));s=q}}else{p=n;while(1){n=f[p>>2]|0;if(!n)break;else p=n}s=p}if((f[a>>2]|0)==(r|0))f[a>>2]=s;s=a+8|0;f[s>>2]=(f[s>>2]|0)+-1;XIa(e,r);cYc(r);j=o;return j|0}function Agc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+32|0;e=d+8|0;g=d;if(!(Drc(a,f[c+40>>2]|0,c,g)|0)){h=f[g>>2]|0;u=d;return h|0}i=f[c+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=c;J_b(i,e)}e=f[g>>2]|0;b[e+8>>0]=f[c+28>>2];b[e+9>>0]=1;c=f[a+12>>2]|0;if(!c){a=$Xc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;j=a;k=e}else{if(f[c+64>>2]|0)SXb(c,21424,16);e=RXb(c,16,2275)|0;f[e>>2]=c;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;j=e;k=f[g>>2]|0}f[k>>2]=j;h=f[g>>2]|0;u=d;return h|0}function Bgc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Cgc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=Agc(a,b)|0;i=f[h>>2]|0;j=f[i+12>>2]|0;if((j|0?(k=i+4|0,l=f[k>>2]|0,(l|0)<(f[j>>2]|0)):0)?(f[k>>2]=l+1,k=f[j+4+(l<<2)>>2]|0,k|0):0){m=k;u=d;return m|0}if(!(f[i+4>>2]|0)){k=f[(f[c>>2]|0)+8>>2]|0;l=F3b(b)|0;b=Mi[k&1023](c,l)|0;if(!b){u_b(e,3,496889,268);r_b(g,p_b(e,497221)|0);v_b(e);n=b}else n=b}else n=f[(f[i+12>>2]|0)+4>>2]|0;i=Mi[f[(f[n>>2]|0)+16>>2]&1023](n,f[a+12>>2]|0)|0;Dgc(f[h>>2]|0,i);m=i;u=d;return m|0}function Dgc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+12|0;d=f[c>>2]|0;do if(d){e=f[d>>2]|0;g=f[a+8>>2]|0;h=a+4|0;i=f[h>>2]|0;if((e|0)<(g|0)){if((i|0)<(e|0)){j=d+4+(i<<2)|0;f[d+4+(e<<2)>>2]=f[j>>2];k=j}else k=d+4+(i<<2)|0;f[k>>2]=b;f[h>>2]=i+1;j=f[c>>2]|0;f[j>>2]=(f[j>>2]|0)+1;return}if((i|0)==(g|0)){l=h;m=g;n=9}else{if((e|0)==(g|0)){g=f[d+4+(i<<2)>>2]|0;if((g|0)==0|(f[a>>2]|0)!=0){o=h;p=d;break}Yi[f[(f[g>>2]|0)+4>>2]&4095](g);o=h;p=f[c>>2]|0;break}if((i|0)<(e|0)){f[d+4+(e<<2)>>2]=f[d+4+(i<<2)>>2];i=f[c>>2]|0;q=i;r=f[i>>2]|0}else{q=d;r=e}f[q>>2]=r+1;o=h;p=q}}else{l=a+4|0;m=f[a+8>>2]|0;n=9}while(0);if((n|0)==9){XZb(a,m+1|0);m=f[c>>2]|0;f[m>>2]=(f[m>>2]|0)+1;o=l;p=m}m=f[o>>2]|0;f[o>>2]=m+1;f[p+4+(m<<2)>>2]=b;return}function Egc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=Agc(a,b)|0;Dgc(f[d>>2]|0,c);return}function Fgc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;h=g+24|0;i=g+16|0;j=g;f[i>>2]=172760;f[i+4>>2]=e;e=f[c+52>>2]|0;if(!e){f[h>>2]=172788;f[h+4>>2]=d;k=Rsc(a,b,c,h,i)|0;u=g;return k|0}else{l=f[c+56>>2]|0;mi[f[(f[d>>2]|0)+96>>2]&2047](h,d);d=f[h>>2]|0;f[j>>2]=171084;f[j+4>>2]=e;f[j+8>>2]=l;f[j+12>>2]=d;k=Rsc(a,b,c,j,i)|0;u=g;return k|0}return 0}function Ggc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[165644+(h[a+8>>0]<<2)>>2]|0;if(!(b[a+9>>0]|0))switch(c|0){case 9:{d=(VXb(f[a>>2]|0)|0)+12|0;return d|0}case 10:{if(!(b[a+10>>0]&16)){e=f[a>>2]|0;d=_i[f[(f[e>>2]|0)+84>>2]&2047](e)|0;return d|0}else{e=f[a>>2]|0;d=_i[f[(f[e>>2]|0)+44>>2]&2047](e)|0;return d|0}break}default:{d=0;return d|0}}do switch(c|0){case 1:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 2:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 3:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 4:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 6:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 5:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 7:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]|0)+16|0;return d|0}case 8:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 9:{e=f[a>>2]|0;g=f[e+8>>2]<<2;i=e+12|0;e=f[i>>2]|0;if(!e)j=g;else{if((f[e>>2]|0)>0){k=0;l=g;m=e;while(1){e=l+12+(VXb(f[m+4+(k<<2)>>2]|0)|0)|0;k=k+1|0;m=f[i>>2]|0;if((k|0)>=(f[m>>2]|0)){n=e;break}else l=e}}else n=g;j=n+4|0}d=j+16|0;return d|0}case 10:{l=f[a>>2]|0;m=f[l+8>>2]<<2;k=l+12|0;l=f[k>>2]|0;if(!l)o=m;else{if((f[l>>2]|0)>0){i=0;e=m;p=l;while(1){l=f[p+4+(i<<2)>>2]|0;q=(_i[f[(f[l>>2]|0)+84>>2]&2047](l)|0)+e|0;i=i+1|0;p=f[k>>2]|0;if((i|0)>=(f[p>>2]|0)){r=q;break}else e=q}}else r=m;o=r+4|0}d=o+16|0;return d|0}default:{d=0;return d|0}}while(0);return 0}function Hgc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+8>>2]<<5;c=f[a>>2]|0;d=a+4|0;if((c|0)==(d|0)){e=b;return e|0}else{g=b;h=c}while(1){c=(Ggc(h+24|0)|0)+g|0;b=f[h+4>>2]|0;if(!b){a=h+8|0;i=f[a>>2]|0;if((f[i>>2]|0)==(h|0))j=i;else{i=a;do{a=f[i>>2]|0;i=a+8|0;k=f[i>>2]|0}while((f[k>>2]|0)!=(a|0));j=k}}else{i=b;while(1){k=f[i>>2]|0;if(!k)break;else i=k}j=i}if((j|0)==(d|0)){e=c;break}else{g=c;h=j}}return e|0}function Igc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0;g=u;u=u+32|0;h=g;i=g+24|0;if(!(b[a+9>>0]|0)){j=b[a+10>>0]|0;if(j&1){k=e;u=g;return k|0}do switch(b[a+8>>0]|0){case 5:{l=f[a>>2]|0;m=c<<3;if(m>>>0>127){n=m;o=e;while(1){b[o>>0]=n|128;q=n>>>7;r=o+1|0;if(n>>>0>16383){n=q;o=r}else{t=r;v=q;break}}}else{t=e;v=m}b[t>>0]=v;o=t+1|0;n=l&255;if(l>>>0>127){q=o;r=n;w=l;x=((l|0)<0)<<31>>31;while(1){b[q>>0]=r|-128;y=w;w=l1c(w|0,x|0,7)|0;z=q+1|0;A=w&255;if(!(x>>>0>0|(x|0)==0&y>>>0>16383)){B=z;C=A;break}else{q=z;r=A;x=J}}}else{B=o;C=n}b[B>>0]=C;k=B+1|0;u=g;return k|0}case 3:{x=a;r=f[x>>2]|0;q=f[x+4>>2]|0;x=c<<3;if(x>>>0>127){w=x;l=e;while(1){b[l>>0]=w|128;m=w>>>7;A=l+1|0;if(w>>>0>16383){w=m;l=A}else{D=A;E=m;break}}}else{D=e;E=x}b[D>>0]=E;l=D+1|0;w=r&255;if(q>>>0>0|(q|0)==0&r>>>0>127){n=l;o=w;m=r;A=q;while(1){b[n>>0]=o|-128;z=m;m=l1c(m|0,A|0,7)|0;y=n+1|0;F=m&255;if(!(A>>>0>0|(A|0)==0&z>>>0>16383)){G=y;H=F;break}else{n=y;o=F;A=J}}}else{G=l;H=w}b[G>>0]=H;k=G+1|0;u=g;return k|0}case 13:{A=f[a>>2]|0;o=c<<3;if(o>>>0>127){n=o;m=e;while(1){b[m>>0]=n|128;q=n>>>7;r=m+1|0;if(n>>>0>16383){n=q;m=r}else{I=r;K=q;break}}}else{I=e;K=o}b[I>>0]=K;m=I+1|0;if(A>>>0>127){n=A;w=m;while(1){b[w>>0]=n|128;l=n>>>7;q=w+1|0;if(n>>>0>16383){n=l;w=q}else{L=q;M=l;break}}}else{L=m;M=A}b[L>>0]=M;k=L+1|0;u=g;return k|0}case 4:{w=a;n=f[w>>2]|0;o=f[w+4>>2]|0;w=c<<3;if(w>>>0>127){l=w;q=e;while(1){b[q>>0]=l|128;r=l>>>7;x=q+1|0;if(l>>>0>16383){l=r;q=x}else{N=x;O=r;break}}}else{N=e;O=w}b[N>>0]=O;q=N+1|0;l=n&255;if(o>>>0>0|(o|0)==0&n>>>0>127){A=q;m=l;r=n;x=o;while(1){b[A>>0]=m|-128;F=r;r=l1c(r|0,x|0,7)|0;y=A+1|0;z=r&255;if(!(x>>>0>0|(x|0)==0&F>>>0>16383)){P=y;Q=z;break}else{A=y;m=z;x=J}}}else{P=q;Q=l}b[P>>0]=Q;k=P+1|0;u=g;return k|0}case 17:{x=f[a>>2]|0;m=c<<3;if(m>>>0>127){A=m;r=e;while(1){b[r>>0]=A|128;o=A>>>7;n=r+1|0;if(A>>>0>16383){A=o;r=n}else{R=n;S=o;break}}}else{R=e;S=m}b[R>>0]=S;r=R+1|0;A=x<<1^x>>31;if(A>>>0>127){l=A;q=r;while(1){b[q>>0]=l|128;o=l>>>7;n=q+1|0;if(l>>>0>16383){l=o;q=n}else{T=n;U=o;break}}}else{T=r;U=A}b[T>>0]=U;k=T+1|0;u=g;return k|0}case 18:{q=a;l=f[q>>2]|0;x=f[q+4>>2]|0;q=c<<3;if(q>>>0>127){m=q;o=e;while(1){b[o>>0]=m|128;n=m>>>7;w=o+1|0;if(m>>>0>16383){m=n;o=w}else{V=w;W=n;break}}}else{V=e;W=q}b[V>>0]=W;o=V+1|0;m=u1c(l|0,x|0,1)|0;A=J;r=k1c(l|0,x|0,63)|0;n=m^r;r=A^J;A=n&255;if(r>>>0>0|(r|0)==0&n>>>0>127){m=o;w=A;z=n;n=r;while(1){b[m>>0]=w|-128;r=z;z=l1c(z|0,n|0,7)|0;y=m+1|0;F=z&255;if(!(n>>>0>0|(n|0)==0&r>>>0>16383)){X=y;Y=F;break}else{m=y;w=F;n=J}}}else{X=o;Y=A}b[X>>0]=Y;k=X+1|0;u=g;return k|0}case 7:{n=f[a>>2]|0;w=c<<3|5;if(w>>>0>127){m=w;z=e;while(1){b[z>>0]=m|128;x=m>>>7;l=z+1|0;if(m>>>0>16383){m=x;z=l}else{Z=l;_=x;break}}}else{Z=e;_=w}b[Z>>0]=_;z=Z+1|0;b[z>>0]=n;b[z+1>>0]=n>>8;b[z+2>>0]=n>>16;b[z+3>>0]=n>>24;k=Z+5|0;u=g;return k|0}case 6:{z=a;m=f[z>>2]|0;A=f[z+4>>2]|0;z=c<<3|1;if(z>>>0>127){o=z;x=e;while(1){b[x>>0]=o|128;l=o>>>7;q=x+1|0;if(o>>>0>16383){o=l;x=q}else{$=q;aa=l;break}}}else{$=e;aa=z}b[$>>0]=aa;x=$+1|0;o=x;b[o>>0]=m;b[o+1>>0]=m>>8;b[o+2>>0]=m>>16;b[o+3>>0]=m>>24;o=x+4|0;b[o>>0]=A;b[o+1>>0]=A>>8;b[o+2>>0]=A>>16;b[o+3>>0]=A>>24;k=$+9|0;u=g;return k|0}case 15:{o=f[a>>2]|0;x=c<<3|5;if(x>>>0>127){n=x;w=e;while(1){b[w>>0]=n|128;l=n>>>7;q=w+1|0;if(n>>>0>16383){n=l;w=q}else{ba=q;ca=l;break}}}else{ba=e;ca=x}b[ba>>0]=ca;w=ba+1|0;b[w>>0]=o;b[w+1>>0]=o>>8;b[w+2>>0]=o>>16;b[w+3>>0]=o>>24;k=ba+5|0;u=g;return k|0}case 16:{w=a;n=f[w>>2]|0;A=f[w+4>>2]|0;w=c<<3|1;if(w>>>0>127){m=w;z=e;while(1){b[z>>0]=m|128;l=m>>>7;q=z+1|0;if(m>>>0>16383){m=l;z=q}else{da=q;ea=l;break}}}else{da=e;ea=w}b[da>>0]=ea;z=da+1|0;m=z;b[m>>0]=n;b[m+1>>0]=n>>8;b[m+2>>0]=n>>16;b[m+3>>0]=n>>24;m=z+4|0;b[m>>0]=A;b[m+1>>0]=A>>8;b[m+2>>0]=A>>16;b[m+3>>0]=A>>24;k=da+9|0;u=g;return k|0}case 2:{m=f[a>>2]|0;z=c<<3|5;if(z>>>0>127){o=z;x=e;while(1){b[x>>0]=o|128;l=o>>>7;q=x+1|0;if(o>>>0>16383){o=l;x=q}else{fa=q;ga=l;break}}}else{fa=e;ga=z}b[fa>>0]=ga;x=fa+1|0;b[x>>0]=m;b[x+1>>0]=m>>8;b[x+2>>0]=m>>16;b[x+3>>0]=m>>24;k=fa+5|0;u=g;return k|0}case 1:{ha=+p[a>>3];x=c<<3|1;if(x>>>0>127){o=x;A=e;while(1){b[A>>0]=o|128;n=o>>>7;w=A+1|0;if(o>>>0>16383){o=n;A=w}else{ia=w;ja=n;break}}}else{ia=e;ja=x}b[ia>>0]=ja;A=ia+1|0;p[s>>3]=ha;b[A>>0]=b[s>>0];b[A+1>>0]=b[s+1>>0];b[A+2>>0]=b[s+2>>0];b[A+3>>0]=b[s+3>>0];b[A+4>>0]=b[s+4>>0];b[A+5>>0]=b[s+5>>0];b[A+6>>0]=b[s+6>>0];b[A+7>>0]=b[s+7>>0];k=ia+9|0;u=g;return k|0}case 8:{A=b[a>>0]|0;o=c<<3;if(o>>>0>127){m=o;z=e;while(1){b[z>>0]=m|128;n=m>>>7;w=z+1|0;if(m>>>0>16383){m=n;z=w}else{ka=w;la=n;break}}}else{ka=e;la=o}b[ka>>0]=la;b[ka+1>>0]=A;k=ka+2|0;u=g;return k|0}case 9:{z=f[a>>2]|0;m=c<<3|2;if(m>>>0>127){x=m;n=e;while(1){b[n>>0]=x|128;w=x>>>7;l=n+1|0;if(x>>>0>16383){x=w;n=l}else{ma=l;na=w;break}}}else{ma=e;na=m}b[ma>>0]=na;k=gZb(z,ma+1|0)|0;u=g;return k|0}case 12:{n=f[a>>2]|0;x=c<<3|2;if(x>>>0>127){A=x;o=e;while(1){b[o>>0]=A|128;w=A>>>7;l=o+1|0;if(A>>>0>16383){A=w;o=l}else{oa=l;pa=w;break}}}else{oa=e;pa=x}b[oa>>0]=pa;k=gZb(n,oa+1|0)|0;u=g;return k|0}case 14:{o=f[a>>2]|0;A=c<<3;if(A>>>0>127){z=A;m=e;while(1){b[m>>0]=z|128;w=z>>>7;l=m+1|0;if(z>>>0>16383){z=w;m=l}else{qa=l;ra=w;break}}}else{qa=e;ra=A}b[qa>>0]=ra;m=qa+1|0;z=o&255;if(o>>>0>127){n=m;x=z;w=o;l=((o|0)<0)<<31>>31;while(1){b[n>>0]=x|-128;q=w;w=l1c(w|0,l|0,7)|0;F=n+1|0;y=w&255;if(!(l>>>0>0|(l|0)==0&q>>>0>16383)){sa=F;ta=y;break}else{n=F;x=y;l=J}}}else{sa=m;ta=z}b[sa>>0]=ta;k=sa+1|0;u=g;return k|0}case 10:{l=f[a>>2]|0;x=c<<3;n=x|3;if(n>>>0>127){w=n;o=e;while(1){b[o>>0]=w|128;A=w>>>7;y=o+1|0;if(w>>>0>16383){w=A;o=y}else{ua=y;va=A;break}}}else{ua=e;va=n}b[ua>>0]=va;o=hj[f[(f[l>>2]|0)+64>>2]&511](l,0,ua+1|0)|0;w=x|4;if(w>>>0>127){z=w;m=o;while(1){b[m>>0]=z|128;A=z>>>7;y=m+1|0;if(z>>>0>16383){z=A;m=y}else{wa=y;xa=A;break}}}else{wa=o;xa=w}b[wa>>0]=xa;k=wa+1|0;u=g;return k|0}case 11:{m=f[a>>2]|0;if(j&16){k=hh[f[(f[m>>2]|0)+68>>2]&127](m,c,d,e)|0;u=g;return k|0}z=c<<3|2;if(z>>>0>127){x=z;l=e;while(1){b[l>>0]=x|128;n=x>>>7;A=l+1|0;if(x>>>0>16383){x=n;l=A}else{ya=A;za=n;break}}}else{ya=e;za=z}b[ya>>0]=za;l=ya+1|0;x=_i[f[(f[m>>2]|0)+60>>2]&2047](m)|0;if(x>>>0>127){w=x;o=l;while(1){b[o>>0]=w|128;n=w>>>7;A=o+1|0;if(w>>>0>16383){w=n;o=A}else{Aa=A;Ba=n;break}}}else{Aa=l;Ba=x}b[Aa>>0]=Ba;k=hj[f[(f[m>>2]|0)+64>>2]&511](m,d,Aa+1|0)|0;u=g;return k|0}default:{k=e;u=g;return k|0}}while(0)}if(b[a+11>>0]|0){Aa=a+12|0;if(!(f[Aa>>2]|0)){k=e;u=g;return k|0}Ba=c<<3|2;if(Ba>>>0>127){ya=Ba;za=e;while(1){b[za>>0]=ya|128;j=ya>>>7;wa=za+1|0;if(ya>>>0>16383){ya=j;za=wa}else{Ca=wa;Da=j;break}}}else{Ca=e;Da=Ba}b[Ca>>0]=Da;Da=Ca+1|0;Ca=f[Aa>>2]|0;Aa=Ca&255;if(Ca>>>0>127){Ba=Da;za=Aa;ya=Ca;j=((Ca|0)<0)<<31>>31;while(1){b[Ba>>0]=za|-128;Ca=ya;ya=l1c(ya|0,j|0,7)|0;wa=Ba+1|0;xa=ya&255;if(!(j>>>0>0|(j|0)==0&Ca>>>0>16383)){Ea=wa;Fa=xa;break}else{Ba=wa;za=xa;j=J}}}else{Ea=Da;Fa=Aa}b[Ea>>0]=Fa;Fa=Ea+1|0;do switch(b[a+8>>0]|0){case 5:{Ea=f[a>>2]|0;if((f[Ea>>2]|0)>0){Ga=Fa;Ha=0;Ia=Ea}else{k=Fa;u=g;return k|0}while(1){Ea=f[(f[Ia+8>>2]|0)+4+(Ha<<2)>>2]|0;Aa=Ea&255;if(Ea>>>0>127){Da=Ga;j=((Ea|0)<0)<<31>>31;za=Aa;Ba=Ea;while(1){b[Da>>0]=za|-128;Ea=Ba;Ba=l1c(Ba|0,j|0,7)|0;ya=Da+1|0;xa=Ba&255;if(!(j>>>0>0|(j|0)==0&Ea>>>0>16383)){Ja=ya;Ka=xa;break}else{Da=ya;j=J;za=xa}}}else{Ja=Ga;Ka=Aa}b[Ja>>0]=Ka;za=Ja+1|0;Ha=Ha+1|0;Ia=f[a>>2]|0;if((Ha|0)>=(f[Ia>>2]|0)){k=za;break}else Ga=za}u=g;return k|0}case 3:{m=f[a>>2]|0;if((f[m>>2]|0)>0){La=0;Ma=Fa;Na=m}else{k=Fa;u=g;return k|0}while(1){m=(f[Na+8>>2]|0)+8+(La<<3)|0;x=f[m>>2]|0;l=f[m+4>>2]|0;m=x&255;if(l>>>0>0|(l|0)==0&x>>>0>127){za=Ma;j=m;Da=x;x=l;while(1){b[za>>0]=j|-128;l=Da;Da=l1c(Da|0,x|0,7)|0;Ba=za+1|0;xa=Da&255;if(!(x>>>0>0|(x|0)==0&l>>>0>16383)){Oa=Ba;Pa=xa;break}else{za=Ba;j=xa;x=J}}}else{Oa=Ma;Pa=m}b[Oa>>0]=Pa;x=Oa+1|0;La=La+1|0;Na=f[a>>2]|0;if((La|0)>=(f[Na>>2]|0)){k=x;break}else Ma=x}u=g;return k|0}case 13:{x=f[a>>2]|0;if((f[x>>2]|0)>0){Qa=0;Ra=Fa;Sa=x}else{k=Fa;u=g;return k|0}while(1){x=f[(f[Sa+8>>2]|0)+4+(Qa<<2)>>2]|0;if(x>>>0>127){j=x;za=Ra;while(1){b[za>>0]=j|128;Da=j>>>7;Aa=za+1|0;if(j>>>0>16383){j=Da;za=Aa}else{Ta=Aa;Ua=Da;break}}}else{Ta=Ra;Ua=x}b[Ta>>0]=Ua;za=Ta+1|0;Qa=Qa+1|0;Sa=f[a>>2]|0;if((Qa|0)>=(f[Sa>>2]|0)){k=za;break}else Ra=za}u=g;return k|0}case 4:{za=f[a>>2]|0;if((f[za>>2]|0)>0){Va=0;Wa=Fa;Xa=za}else{k=Fa;u=g;return k|0}while(1){za=(f[Xa+8>>2]|0)+8+(Va<<3)|0;j=f[za>>2]|0;m=f[za+4>>2]|0;za=j&255;if(m>>>0>0|(m|0)==0&j>>>0>127){Da=Wa;Aa=za;xa=j;j=m;while(1){b[Da>>0]=Aa|-128;m=xa;xa=l1c(xa|0,j|0,7)|0;Ba=Da+1|0;l=xa&255;if(!(j>>>0>0|(j|0)==0&m>>>0>16383)){Ya=Ba;Za=l;break}else{Da=Ba;Aa=l;j=J}}}else{Ya=Wa;Za=za}b[Ya>>0]=Za;j=Ya+1|0;Va=Va+1|0;Xa=f[a>>2]|0;if((Va|0)>=(f[Xa>>2]|0)){k=j;break}else Wa=j}u=g;return k|0}case 17:{j=f[a>>2]|0;if((f[j>>2]|0)>0){_a=0;$a=Fa;ab=j}else{k=Fa;u=g;return k|0}while(1){j=f[(f[ab+8>>2]|0)+4+(_a<<2)>>2]|0;Aa=j<<1^j>>31;if(Aa>>>0>127){j=Aa;Da=$a;while(1){b[Da>>0]=j|128;xa=j>>>7;x=Da+1|0;if(j>>>0>16383){j=xa;Da=x}else{bb=x;cb=xa;break}}}else{bb=$a;cb=Aa}b[bb>>0]=cb;Da=bb+1|0;_a=_a+1|0;ab=f[a>>2]|0;if((_a|0)>=(f[ab>>2]|0)){k=Da;break}else $a=Da}u=g;return k|0}case 18:{Da=f[a>>2]|0;if((f[Da>>2]|0)>0){db=0;eb=Fa;fb=Da}else{k=Fa;u=g;return k|0}while(1){Da=(f[fb+8>>2]|0)+8+(db<<3)|0;j=f[Da>>2]|0;za=f[Da+4>>2]|0;Da=u1c(j|0,za|0,1)|0;xa=J;x=k1c(j|0,za|0,63)|0;za=Da^x;x=xa^J;xa=za&255;if(x>>>0>0|(x|0)==0&za>>>0>127){Da=eb;j=xa;l=za;za=x;while(1){b[Da>>0]=j|-128;x=l;l=l1c(l|0,za|0,7)|0;Ba=Da+1|0;m=l&255;if(!(za>>>0>0|(za|0)==0&x>>>0>16383)){gb=Ba;hb=m;break}else{Da=Ba;j=m;za=J}}}else{gb=eb;hb=xa}b[gb>>0]=hb;za=gb+1|0;db=db+1|0;fb=f[a>>2]|0;if((db|0)>=(f[fb>>2]|0)){k=za;break}else eb=za}u=g;return k|0}case 7:{za=f[a>>2]|0;if((f[za>>2]|0)>0){ib=0;jb=Fa;kb=za}else{k=Fa;u=g;return k|0}while(1){za=f[(f[kb+8>>2]|0)+4+(ib<<2)>>2]|0;b[jb>>0]=za;b[jb+1>>0]=za>>8;b[jb+2>>0]=za>>16;b[jb+3>>0]=za>>24;za=jb+4|0;ib=ib+1|0;kb=f[a>>2]|0;if((ib|0)>=(f[kb>>2]|0)){k=za;break}else jb=za}u=g;return k|0}case 6:{za=f[a>>2]|0;if((f[za>>2]|0)>0){lb=0;mb=Fa;nb=za}else{k=Fa;u=g;return k|0}while(1){za=(f[nb+8>>2]|0)+8+(lb<<3)|0;j=f[za>>2]|0;Da=f[za+4>>2]|0;za=mb;l=za;b[l>>0]=j;b[l+1>>0]=j>>8;b[l+2>>0]=j>>16;b[l+3>>0]=j>>24;j=za+4|0;b[j>>0]=Da;b[j+1>>0]=Da>>8;b[j+2>>0]=Da>>16;b[j+3>>0]=Da>>24;Da=mb+8|0;lb=lb+1|0;nb=f[a>>2]|0;if((lb|0)>=(f[nb>>2]|0)){k=Da;break}else mb=Da}u=g;return k|0}case 15:{Da=f[a>>2]|0;if((f[Da>>2]|0)>0){ob=0;pb=Fa;qb=Da}else{k=Fa;u=g;return k|0}while(1){Da=f[(f[qb+8>>2]|0)+4+(ob<<2)>>2]|0;b[pb>>0]=Da;b[pb+1>>0]=Da>>8;b[pb+2>>0]=Da>>16;b[pb+3>>0]=Da>>24;Da=pb+4|0;ob=ob+1|0;qb=f[a>>2]|0;if((ob|0)>=(f[qb>>2]|0)){k=Da;break}else pb=Da}u=g;return k|0}case 16:{Da=f[a>>2]|0;if((f[Da>>2]|0)>0){rb=0;sb=Fa;tb=Da}else{k=Fa;u=g;return k|0}while(1){Da=(f[tb+8>>2]|0)+8+(rb<<3)|0;j=f[Da>>2]|0;za=f[Da+4>>2]|0;Da=sb;l=Da;b[l>>0]=j;b[l+1>>0]=j>>8;b[l+2>>0]=j>>16;b[l+3>>0]=j>>24;j=Da+4|0;b[j>>0]=za;b[j+1>>0]=za>>8;b[j+2>>0]=za>>16;b[j+3>>0]=za>>24;za=sb+8|0;rb=rb+1|0;tb=f[a>>2]|0;if((rb|0)>=(f[tb>>2]|0)){k=za;break}else sb=za}u=g;return k|0}case 2:{za=f[a>>2]|0;if((f[za>>2]|0)>0){ub=0;vb=Fa;wb=za}else{k=Fa;u=g;return k|0}while(1){za=f[(f[wb+8>>2]|0)+4+(ub<<2)>>2]|0;b[vb>>0]=za;b[vb+1>>0]=za>>8;b[vb+2>>0]=za>>16;b[vb+3>>0]=za>>24;za=vb+4|0;ub=ub+1|0;wb=f[a>>2]|0;if((ub|0)>=(f[wb>>2]|0)){k=za;break}else vb=za}u=g;return k|0}case 1:{za=f[a>>2]|0;if((f[za>>2]|0)>0){xb=0;yb=Fa;zb=za}else{k=Fa;u=g;return k|0}while(1){p[s>>3]=+p[(f[zb+8>>2]|0)+8+(xb<<3)>>3];b[yb>>0]=b[s>>0];b[yb+1>>0]=b[s+1>>0];b[yb+2>>0]=b[s+2>>0];b[yb+3>>0]=b[s+3>>0];b[yb+4>>0]=b[s+4>>0];b[yb+5>>0]=b[s+5>>0];b[yb+6>>0]=b[s+6>>0];b[yb+7>>0]=b[s+7>>0];za=yb+8|0;xb=xb+1|0;zb=f[a>>2]|0;if((xb|0)>=(f[zb>>2]|0)){k=za;break}else yb=za}u=g;return k|0}case 8:{za=f[a>>2]|0;if((f[za>>2]|0)>0){Ab=0;Bb=Fa;Cb=za}else{k=Fa;u=g;return k|0}while(1){b[Bb>>0]=b[(f[Cb+8>>2]|0)+4+Ab>>0]|0;za=Bb+1|0;Ab=Ab+1|0;Cb=f[a>>2]|0;if((Ab|0)>=(f[Cb>>2]|0)){k=za;break}else Bb=za}u=g;return k|0}case 14:{za=f[a>>2]|0;if((f[za>>2]|0)>0){Db=0;Eb=Fa;Fb=za}else{k=Fa;u=g;return k|0}while(1){za=f[(f[Fb+8>>2]|0)+4+(Db<<2)>>2]|0;j=za&255;if(za>>>0>127){Da=Eb;l=j;Aa=za;m=((za|0)<0)<<31>>31;while(1){b[Da>>0]=l|-128;za=Aa;Aa=l1c(Aa|0,m|0,7)|0;Ba=Da+1|0;x=Aa&255;if(!(m>>>0>0|(m|0)==0&za>>>0>16383)){Gb=Ba;Hb=x;break}else{Da=Ba;l=x;m=J}}}else{Gb=Eb;Hb=j}b[Gb>>0]=Hb;m=Gb+1|0;Db=Db+1|0;Fb=f[a>>2]|0;if((Db|0)>=(f[Fb>>2]|0)){k=m;break}else Eb=m}u=g;return k|0}case 11:case 10:case 12:case 9:{u_b(h,3,496889,498);r_b(i,p_b(h,508217)|0);v_b(h);k=Fa;u=g;return k|0}default:{k=Fa;u=g;return k|0}}while(0)}do switch(b[a+8>>0]|0){case 5:{Fa=f[a>>2]|0;if((f[Fa>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3;if(h>>>0>127){Ib=0;Jb=e;Kb=Fa}else{i=h&255;Eb=0;Fb=e;Db=Fa;while(1){Fa=f[(f[Db+8>>2]|0)+4+(Eb<<2)>>2]|0;b[Fb>>0]=i;Gb=Fb+1|0;Hb=Fa&255;if(Fa>>>0>127){Bb=Gb;Cb=Hb;Ab=Fa;yb=((Fa|0)<0)<<31>>31;while(1){b[Bb>>0]=Cb|-128;Fa=Ab;Ab=l1c(Ab|0,yb|0,7)|0;zb=Bb+1|0;xb=Ab&255;if(!(yb>>>0>0|(yb|0)==0&Fa>>>0>16383)){Lb=zb;Mb=xb;break}else{Bb=zb;Cb=xb;yb=J}}}else{Lb=Gb;Mb=Hb}b[Lb>>0]=Mb;yb=Lb+1|0;Eb=Eb+1|0;Db=f[a>>2]|0;if((Eb|0)>=(f[Db>>2]|0)){k=yb;break}else Fb=yb}u=g;return k|0}while(1){Fb=f[(f[Kb+8>>2]|0)+4+(Ib<<2)>>2]|0;Db=h;Eb=Jb;while(1){b[Eb>>0]=Db|128;i=Db;Db=Db>>>7;Nb=Eb+1|0;if(i>>>0<=16383)break;else Eb=Nb}b[Nb>>0]=Db;Hb=Eb+2|0;Gb=Fb&255;if(Fb>>>0>127){i=Hb;yb=Gb;Cb=Fb;Bb=((Fb|0)<0)<<31>>31;while(1){b[i>>0]=yb|-128;Ab=Cb;Cb=l1c(Cb|0,Bb|0,7)|0;j=i+1|0;xb=Cb&255;if(!(Bb>>>0>0|(Bb|0)==0&Ab>>>0>16383)){Ob=j;Pb=xb;break}else{i=j;yb=xb;Bb=J}}}else{Ob=Hb;Pb=Gb}b[Ob>>0]=Pb;Bb=Ob+1|0;Ib=Ib+1|0;Kb=f[a>>2]|0;if((Ib|0)>=(f[Kb>>2]|0)){k=Bb;break}else Jb=Bb}u=g;return k|0}case 3:{h=f[a>>2]|0;if((f[h>>2]|0)<=0){k=e;u=g;return k|0}Bb=c<<3;if(Bb>>>0>127){Qb=0;Rb=e;Sb=h}else{yb=Bb&255;i=0;Cb=e;Fb=h;while(1){h=(f[Fb+8>>2]|0)+8+(i<<3)|0;Eb=f[h>>2]|0;Db=f[h+4>>2]|0;b[Cb>>0]=yb;h=Cb+1|0;xb=Eb&255;if(Db>>>0>0|(Db|0)==0&Eb>>>0>127){j=h;Ab=xb;zb=Eb;Eb=Db;while(1){b[j>>0]=Ab|-128;Db=zb;zb=l1c(zb|0,Eb|0,7)|0;Fa=j+1|0;vb=zb&255;if(!(Eb>>>0>0|(Eb|0)==0&Db>>>0>16383)){Tb=Fa;Ub=vb;break}else{j=Fa;Ab=vb;Eb=J}}}else{Tb=h;Ub=xb}b[Tb>>0]=Ub;Eb=Tb+1|0;i=i+1|0;Fb=f[a>>2]|0;if((i|0)>=(f[Fb>>2]|0)){k=Eb;break}else Cb=Eb}u=g;return k|0}while(1){Cb=(f[Sb+8>>2]|0)+8+(Qb<<3)|0;Fb=f[Cb>>2]|0;i=f[Cb+4>>2]|0;Cb=Bb;yb=Rb;while(1){b[yb>>0]=Cb|128;Eb=Cb;Cb=Cb>>>7;Vb=yb+1|0;if(Eb>>>0<=16383)break;else yb=Vb}b[Vb>>0]=Cb;xb=yb+2|0;h=Fb&255;if(i>>>0>0|(i|0)==0&Fb>>>0>127){Eb=xb;Ab=h;j=Fb;zb=i;while(1){b[Eb>>0]=Ab|-128;Gb=j;j=l1c(j|0,zb|0,7)|0;Hb=Eb+1|0;vb=j&255;if(!(zb>>>0>0|(zb|0)==0&Gb>>>0>16383)){Wb=Hb;Xb=vb;break}else{Eb=Hb;Ab=vb;zb=J}}}else{Wb=xb;Xb=h}b[Wb>>0]=Xb;zb=Wb+1|0;Qb=Qb+1|0;Sb=f[a>>2]|0;if((Qb|0)>=(f[Sb>>2]|0)){k=zb;break}else Rb=zb}u=g;return k|0}case 13:{Bb=f[a>>2]|0;if((f[Bb>>2]|0)<=0){k=e;u=g;return k|0}zb=c<<3;if(zb>>>0>127){Yb=0;Zb=e;_b=Bb}else{Ab=zb&255;Eb=0;j=e;i=Bb;while(1){Bb=f[(f[i+8>>2]|0)+4+(Eb<<2)>>2]|0;b[j>>0]=Ab;Fb=j+1|0;if(Bb>>>0>127){yb=Bb;Cb=Fb;while(1){b[Cb>>0]=yb|128;vb=yb>>>7;Hb=Cb+1|0;if(yb>>>0>16383){yb=vb;Cb=Hb}else{$b=Hb;ac=vb;break}}}else{$b=Fb;ac=Bb}b[$b>>0]=ac;Cb=$b+1|0;Eb=Eb+1|0;i=f[a>>2]|0;if((Eb|0)>=(f[i>>2]|0)){k=Cb;break}else j=Cb}u=g;return k|0}while(1){j=f[(f[_b+8>>2]|0)+4+(Yb<<2)>>2]|0;i=zb;Eb=Zb;while(1){b[Eb>>0]=i|128;Ab=i;i=i>>>7;bc=Eb+1|0;if(Ab>>>0<=16383)break;else Eb=bc}b[bc>>0]=i;Bb=Eb+2|0;if(j>>>0>127){Fb=j;Ab=Bb;while(1){b[Ab>>0]=Fb|128;Cb=Fb>>>7;yb=Ab+1|0;if(Fb>>>0>16383){Fb=Cb;Ab=yb}else{cc=yb;dc=Cb;break}}}else{cc=Bb;dc=j}b[cc>>0]=dc;Ab=cc+1|0;Yb=Yb+1|0;_b=f[a>>2]|0;if((Yb|0)>=(f[_b>>2]|0)){k=Ab;break}else Zb=Ab}u=g;return k|0}case 4:{zb=f[a>>2]|0;if((f[zb>>2]|0)<=0){k=e;u=g;return k|0}Ab=c<<3;if(Ab>>>0>127){ec=0;fc=e;gc=zb}else{Fb=Ab&255;Eb=0;i=e;Cb=zb;while(1){zb=(f[Cb+8>>2]|0)+8+(Eb<<3)|0;yb=f[zb>>2]|0;h=f[zb+4>>2]|0;b[i>>0]=Fb;zb=i+1|0;xb=yb&255;if(h>>>0>0|(h|0)==0&yb>>>0>127){vb=zb;Hb=xb;Gb=yb;yb=h;while(1){b[vb>>0]=Hb|-128;h=Gb;Gb=l1c(Gb|0,yb|0,7)|0;Fa=vb+1|0;Db=Gb&255;if(!(yb>>>0>0|(yb|0)==0&h>>>0>16383)){hc=Fa;ic=Db;break}else{vb=Fa;Hb=Db;yb=J}}}else{hc=zb;ic=xb}b[hc>>0]=ic;yb=hc+1|0;Eb=Eb+1|0;Cb=f[a>>2]|0;if((Eb|0)>=(f[Cb>>2]|0)){k=yb;break}else i=yb}u=g;return k|0}while(1){i=(f[gc+8>>2]|0)+8+(ec<<3)|0;Cb=f[i>>2]|0;Eb=f[i+4>>2]|0;i=Ab;Fb=fc;while(1){b[Fb>>0]=i|128;yb=i;i=i>>>7;jc=Fb+1|0;if(yb>>>0<=16383)break;else Fb=jc}b[jc>>0]=i;xb=Fb+2|0;zb=Cb&255;if(Eb>>>0>0|(Eb|0)==0&Cb>>>0>127){yb=xb;Hb=zb;vb=Cb;Gb=Eb;while(1){b[yb>>0]=Hb|-128;j=vb;vb=l1c(vb|0,Gb|0,7)|0;Bb=yb+1|0;Db=vb&255;if(!(Gb>>>0>0|(Gb|0)==0&j>>>0>16383)){kc=Bb;lc=Db;break}else{yb=Bb;Hb=Db;Gb=J}}}else{kc=xb;lc=zb}b[kc>>0]=lc;Gb=kc+1|0;ec=ec+1|0;gc=f[a>>2]|0;if((ec|0)>=(f[gc>>2]|0)){k=Gb;break}else fc=Gb}u=g;return k|0}case 17:{Ab=f[a>>2]|0;if((f[Ab>>2]|0)<=0){k=e;u=g;return k|0}Gb=c<<3;if(Gb>>>0>127){mc=0;nc=e;oc=Ab}else{Hb=Gb&255;yb=0;vb=e;Eb=Ab;while(1){Ab=f[(f[Eb+8>>2]|0)+4+(yb<<2)>>2]|0;b[vb>>0]=Hb;Cb=vb+1|0;Fb=Ab<<1^Ab>>31;if(Fb>>>0>127){Ab=Fb;i=Cb;while(1){b[i>>0]=Ab|128;Db=Ab>>>7;Bb=i+1|0;if(Ab>>>0>16383){Ab=Db;i=Bb}else{pc=Bb;qc=Db;break}}}else{pc=Cb;qc=Fb}b[pc>>0]=qc;i=pc+1|0;yb=yb+1|0;Eb=f[a>>2]|0;if((yb|0)>=(f[Eb>>2]|0)){k=i;break}else vb=i}u=g;return k|0}while(1){vb=f[(f[oc+8>>2]|0)+4+(mc<<2)>>2]|0;Eb=Gb;yb=nc;while(1){b[yb>>0]=Eb|128;Hb=Eb;Eb=Eb>>>7;rc=yb+1|0;if(Hb>>>0<=16383)break;else yb=rc}b[rc>>0]=Eb;Fb=yb+2|0;Cb=vb<<1^vb>>31;if(Cb>>>0>127){Hb=Cb;i=Fb;while(1){b[i>>0]=Hb|128;Ab=Hb>>>7;zb=i+1|0;if(Hb>>>0>16383){Hb=Ab;i=zb}else{sc=zb;tc=Ab;break}}}else{sc=Fb;tc=Cb}b[sc>>0]=tc;i=sc+1|0;mc=mc+1|0;oc=f[a>>2]|0;if((mc|0)>=(f[oc>>2]|0)){k=i;break}else nc=i}u=g;return k|0}case 18:{Gb=f[a>>2]|0;if((f[Gb>>2]|0)<=0){k=e;u=g;return k|0}i=c<<3;if(i>>>0>127){uc=0;vc=e;wc=Gb}else{Hb=i&255;vb=0;yb=e;Eb=Gb;while(1){Gb=(f[Eb+8>>2]|0)+8+(vb<<3)|0;Ab=f[Gb>>2]|0;zb=f[Gb+4>>2]|0;b[yb>>0]=Hb;Gb=yb+1|0;xb=u1c(Ab|0,zb|0,1)|0;Db=J;Bb=k1c(Ab|0,zb|0,63)|0;zb=xb^Bb;Bb=Db^J;Db=zb&255;if(Bb>>>0>0|(Bb|0)==0&zb>>>0>127){xb=Gb;Ab=Db;j=zb;zb=Bb;while(1){b[xb>>0]=Ab|-128;Bb=j;j=l1c(j|0,zb|0,7)|0;Fa=xb+1|0;h=j&255;if(!(zb>>>0>0|(zb|0)==0&Bb>>>0>16383)){xc=Fa;yc=h;break}else{xb=Fa;Ab=h;zb=J}}}else{xc=Gb;yc=Db}b[xc>>0]=yc;zb=xc+1|0;vb=vb+1|0;Eb=f[a>>2]|0;if((vb|0)>=(f[Eb>>2]|0)){k=zb;break}else yb=zb}u=g;return k|0}while(1){yb=(f[wc+8>>2]|0)+8+(uc<<3)|0;Eb=f[yb>>2]|0;vb=f[yb+4>>2]|0;yb=i;Hb=vc;while(1){b[Hb>>0]=yb|128;zb=yb;yb=yb>>>7;zc=Hb+1|0;if(zb>>>0<=16383)break;else Hb=zc}b[zc>>0]=yb;Db=Hb+2|0;Gb=u1c(Eb|0,vb|0,1)|0;zb=J;Ab=k1c(Eb|0,vb|0,63)|0;xb=Gb^Ab;Ab=zb^J;zb=xb&255;if(Ab>>>0>0|(Ab|0)==0&xb>>>0>127){Gb=Db;j=zb;Cb=xb;xb=Ab;while(1){b[Gb>>0]=j|-128;Ab=Cb;Cb=l1c(Cb|0,xb|0,7)|0;Fb=Gb+1|0;h=Cb&255;if(!(xb>>>0>0|(xb|0)==0&Ab>>>0>16383)){Ac=Fb;Bc=h;break}else{Gb=Fb;j=h;xb=J}}}else{Ac=Db;Bc=zb}b[Ac>>0]=Bc;xb=Ac+1|0;uc=uc+1|0;wc=f[a>>2]|0;if((uc|0)>=(f[wc>>2]|0)){k=xb;break}else vc=xb}u=g;return k|0}case 7:{i=f[a>>2]|0;if((f[i>>2]|0)<=0){k=e;u=g;return k|0}xb=c<<3|5;if(xb>>>0>127){Cc=0;Dc=e;Ec=i}else{j=xb&255;Gb=0;Cb=e;vb=i;while(1){i=f[(f[vb+8>>2]|0)+4+(Gb<<2)>>2]|0;b[Cb>>0]=j;Eb=Cb+1|0;b[Eb>>0]=i;b[Eb+1>>0]=i>>8;b[Eb+2>>0]=i>>16;b[Eb+3>>0]=i>>24;i=Cb+5|0;Gb=Gb+1|0;vb=f[a>>2]|0;if((Gb|0)>=(f[vb>>2]|0)){k=i;break}else Cb=i}u=g;return k|0}while(1){Cb=f[(f[Ec+8>>2]|0)+4+(Cc<<2)>>2]|0;vb=xb;Gb=Dc;while(1){b[Gb>>0]=vb|128;j=vb;vb=vb>>>7;Fc=Gb+1|0;if(j>>>0<=16383)break;else Gb=Fc}b[Fc>>0]=vb;zb=Gb+2|0;b[zb>>0]=Cb;b[zb+1>>0]=Cb>>8;b[zb+2>>0]=Cb>>16;b[zb+3>>0]=Cb>>24;zb=Gb+6|0;Cc=Cc+1|0;Ec=f[a>>2]|0;if((Cc|0)>=(f[Ec>>2]|0)){k=zb;break}else Dc=zb}u=g;return k|0}case 6:{xb=f[a>>2]|0;if((f[xb>>2]|0)<=0){k=e;u=g;return k|0}zb=c<<3|1;if(zb>>>0>127){Gc=0;Hc=e;Ic=xb}else{Db=zb&255;j=0;i=e;Eb=xb;while(1){xb=(f[Eb+8>>2]|0)+8+(j<<3)|0;Hb=f[xb>>2]|0;yb=f[xb+4>>2]|0;b[i>>0]=Db;xb=i+1|0;h=xb;b[h>>0]=Hb;b[h+1>>0]=Hb>>8;b[h+2>>0]=Hb>>16;b[h+3>>0]=Hb>>24;Hb=xb+4|0;b[Hb>>0]=yb;b[Hb+1>>0]=yb>>8;b[Hb+2>>0]=yb>>16;b[Hb+3>>0]=yb>>24;yb=i+9|0;j=j+1|0;Eb=f[a>>2]|0;if((j|0)>=(f[Eb>>2]|0)){k=yb;break}else i=yb}u=g;return k|0}while(1){i=(f[Ic+8>>2]|0)+8+(Gc<<3)|0;Eb=f[i>>2]|0;j=f[i+4>>2]|0;i=zb;Db=Hc;while(1){b[Db>>0]=i|128;yb=i;i=i>>>7;Jc=Db+1|0;if(yb>>>0<=16383)break;else Db=Jc}b[Jc>>0]=i;Gb=Db+2|0;Cb=Gb;b[Cb>>0]=Eb;b[Cb+1>>0]=Eb>>8;b[Cb+2>>0]=Eb>>16;b[Cb+3>>0]=Eb>>24;Cb=Gb+4|0;b[Cb>>0]=j;b[Cb+1>>0]=j>>8;b[Cb+2>>0]=j>>16;b[Cb+3>>0]=j>>24;Cb=Db+10|0;Gc=Gc+1|0;Ic=f[a>>2]|0;if((Gc|0)>=(f[Ic>>2]|0)){k=Cb;break}else Hc=Cb}u=g;return k|0}case 15:{zb=f[a>>2]|0;if((f[zb>>2]|0)<=0){k=e;u=g;return k|0}Cb=c<<3|5;if(Cb>>>0>127){Kc=0;Lc=e;Mc=zb}else{Gb=Cb&255;vb=0;yb=e;Hb=zb;while(1){zb=f[(f[Hb+8>>2]|0)+4+(vb<<2)>>2]|0;b[yb>>0]=Gb;xb=yb+1|0;b[xb>>0]=zb;b[xb+1>>0]=zb>>8;b[xb+2>>0]=zb>>16;b[xb+3>>0]=zb>>24;zb=yb+5|0;vb=vb+1|0;Hb=f[a>>2]|0;if((vb|0)>=(f[Hb>>2]|0)){k=zb;break}else yb=zb}u=g;return k|0}while(1){yb=f[(f[Mc+8>>2]|0)+4+(Kc<<2)>>2]|0;Hb=Cb;vb=Lc;while(1){b[vb>>0]=Hb|128;Gb=Hb;Hb=Hb>>>7;Nc=vb+1|0;if(Gb>>>0<=16383)break;else vb=Nc}b[Nc>>0]=Hb;Db=vb+2|0;b[Db>>0]=yb;b[Db+1>>0]=yb>>8;b[Db+2>>0]=yb>>16;b[Db+3>>0]=yb>>24;Db=vb+6|0;Kc=Kc+1|0;Mc=f[a>>2]|0;if((Kc|0)>=(f[Mc>>2]|0)){k=Db;break}else Lc=Db}u=g;return k|0}case 16:{Cb=f[a>>2]|0;if((f[Cb>>2]|0)<=0){k=e;u=g;return k|0}Db=c<<3|1;if(Db>>>0>127){Oc=0;Pc=e;Qc=Cb}else{j=Db&255;Eb=0;i=e;Gb=Cb;while(1){Cb=(f[Gb+8>>2]|0)+8+(Eb<<3)|0;zb=f[Cb>>2]|0;xb=f[Cb+4>>2]|0;b[i>>0]=j;Cb=i+1|0;h=Cb;b[h>>0]=zb;b[h+1>>0]=zb>>8;b[h+2>>0]=zb>>16;b[h+3>>0]=zb>>24;zb=Cb+4|0;b[zb>>0]=xb;b[zb+1>>0]=xb>>8;b[zb+2>>0]=xb>>16;b[zb+3>>0]=xb>>24;xb=i+9|0;Eb=Eb+1|0;Gb=f[a>>2]|0;if((Eb|0)>=(f[Gb>>2]|0)){k=xb;break}else i=xb}u=g;return k|0}while(1){i=(f[Qc+8>>2]|0)+8+(Oc<<3)|0;Gb=f[i>>2]|0;Eb=f[i+4>>2]|0;i=Db;j=Pc;while(1){b[j>>0]=i|128;xb=i;i=i>>>7;Rc=j+1|0;if(xb>>>0<=16383)break;else j=Rc}b[Rc>>0]=i;vb=j+2|0;yb=vb;b[yb>>0]=Gb;b[yb+1>>0]=Gb>>8;b[yb+2>>0]=Gb>>16;b[yb+3>>0]=Gb>>24;yb=vb+4|0;b[yb>>0]=Eb;b[yb+1>>0]=Eb>>8;b[yb+2>>0]=Eb>>16;b[yb+3>>0]=Eb>>24;yb=j+10|0;Oc=Oc+1|0;Qc=f[a>>2]|0;if((Oc|0)>=(f[Qc>>2]|0)){k=yb;break}else Pc=yb}u=g;return k|0}case 2:{Db=f[a>>2]|0;if((f[Db>>2]|0)<=0){k=e;u=g;return k|0}yb=c<<3|5;if(yb>>>0>127){Sc=0;Tc=e;Uc=Db}else{vb=yb&255;Hb=0;xb=e;zb=Db;while(1){Db=f[(f[zb+8>>2]|0)+4+(Hb<<2)>>2]|0;b[xb>>0]=vb;Cb=xb+1|0;b[Cb>>0]=Db;b[Cb+1>>0]=Db>>8;b[Cb+2>>0]=Db>>16;b[Cb+3>>0]=Db>>24;Db=xb+5|0;Hb=Hb+1|0;zb=f[a>>2]|0;if((Hb|0)>=(f[zb>>2]|0)){k=Db;break}else xb=Db}u=g;return k|0}while(1){xb=f[(f[Uc+8>>2]|0)+4+(Sc<<2)>>2]|0;zb=yb;Hb=Tc;while(1){b[Hb>>0]=zb|128;vb=zb;zb=zb>>>7;Vc=Hb+1|0;if(vb>>>0<=16383)break;else Hb=Vc}b[Vc>>0]=zb;j=Hb+2|0;b[j>>0]=xb;b[j+1>>0]=xb>>8;b[j+2>>0]=xb>>16;b[j+3>>0]=xb>>24;j=Hb+6|0;Sc=Sc+1|0;Uc=f[a>>2]|0;if((Sc|0)>=(f[Uc>>2]|0)){k=j;break}else Tc=j}u=g;return k|0}case 1:{yb=f[a>>2]|0;if((f[yb>>2]|0)<=0){k=e;u=g;return k|0}j=c<<3|1;if(j>>>0>127){Wc=0;Xc=e;Yc=yb}else{Eb=j&255;Gb=0;i=e;vb=yb;while(1){ha=+p[(f[vb+8>>2]|0)+8+(Gb<<3)>>3];b[i>>0]=Eb;yb=i+1|0;p[s>>3]=ha;b[yb>>0]=b[s>>0];b[yb+1>>0]=b[s+1>>0];b[yb+2>>0]=b[s+2>>0];b[yb+3>>0]=b[s+3>>0];b[yb+4>>0]=b[s+4>>0];b[yb+5>>0]=b[s+5>>0];b[yb+6>>0]=b[s+6>>0];b[yb+7>>0]=b[s+7>>0];yb=i+9|0;Gb=Gb+1|0;vb=f[a>>2]|0;if((Gb|0)>=(f[vb>>2]|0)){k=yb;break}else i=yb}u=g;return k|0}while(1){ha=+p[(f[Yc+8>>2]|0)+8+(Wc<<3)>>3];i=j;vb=Xc;while(1){b[vb>>0]=i|128;Gb=i;i=i>>>7;Zc=vb+1|0;if(Gb>>>0<=16383)break;else vb=Zc}b[Zc>>0]=i;Hb=vb+2|0;p[s>>3]=ha;b[Hb>>0]=b[s>>0];b[Hb+1>>0]=b[s+1>>0];b[Hb+2>>0]=b[s+2>>0];b[Hb+3>>0]=b[s+3>>0];b[Hb+4>>0]=b[s+4>>0];b[Hb+5>>0]=b[s+5>>0];b[Hb+6>>0]=b[s+6>>0];b[Hb+7>>0]=b[s+7>>0];Hb=vb+10|0;Wc=Wc+1|0;Yc=f[a>>2]|0;if((Wc|0)>=(f[Yc>>2]|0)){k=Hb;break}else Xc=Hb}u=g;return k|0}case 8:{j=f[a>>2]|0;if((f[j>>2]|0)<=0){k=e;u=g;return k|0}Hb=c<<3;if(Hb>>>0>127){_c=0;$c=e;ad=j}else{xb=Hb&255;zb=0;Gb=e;Eb=j;while(1){j=b[(f[Eb+8>>2]|0)+4+zb>>0]|0;b[Gb>>0]=xb;b[Gb+1>>0]=j;j=Gb+2|0;zb=zb+1|0;Eb=f[a>>2]|0;if((zb|0)>=(f[Eb>>2]|0)){k=j;break}else Gb=j}u=g;return k|0}while(1){Gb=b[(f[ad+8>>2]|0)+4+_c>>0]|0;Eb=Hb;zb=$c;while(1){b[zb>>0]=Eb|128;xb=Eb;Eb=Eb>>>7;bd=zb+1|0;if(xb>>>0<=16383)break;else zb=bd}b[bd>>0]=Eb;b[zb+2>>0]=Gb;vb=zb+3|0;_c=_c+1|0;ad=f[a>>2]|0;if((_c|0)>=(f[ad>>2]|0)){k=vb;break}else $c=vb}u=g;return k|0}case 9:{Hb=f[a>>2]|0;if((f[Hb+4>>2]|0)<=0){k=e;u=g;return k|0}vb=c<<3|2;if(vb>>>0>127){cd=0;dd=e;ed=Hb}else{i=vb&255;xb=0;j=e;yb=Hb;while(1){Hb=f[(f[yb+12>>2]|0)+4+(xb<<2)>>2]|0;b[j>>0]=i;Db=gZb(Hb,j+1|0)|0;xb=xb+1|0;yb=f[a>>2]|0;if((xb|0)>=(f[yb+4>>2]|0)){k=Db;break}else j=Db}u=g;return k|0}while(1){j=f[(f[ed+12>>2]|0)+4+(cd<<2)>>2]|0;yb=vb;xb=dd;while(1){b[xb>>0]=yb|128;i=yb;yb=yb>>>7;fd=xb+1|0;if(i>>>0<=16383)break;else xb=fd}b[fd>>0]=yb;zb=gZb(j,xb+2|0)|0;cd=cd+1|0;ed=f[a>>2]|0;if((cd|0)>=(f[ed+4>>2]|0)){k=zb;break}else dd=zb}u=g;return k|0}case 12:{vb=f[a>>2]|0;if((f[vb+4>>2]|0)<=0){k=e;u=g;return k|0}zb=c<<3|2;if(zb>>>0>127){gd=0;hd=e;id=vb}else{Gb=zb&255;Eb=0;i=e;Db=vb;while(1){vb=f[(f[Db+12>>2]|0)+4+(Eb<<2)>>2]|0;b[i>>0]=Gb;Hb=gZb(vb,i+1|0)|0;Eb=Eb+1|0;Db=f[a>>2]|0;if((Eb|0)>=(f[Db+4>>2]|0)){k=Hb;break}else i=Hb}u=g;return k|0}while(1){i=f[(f[id+12>>2]|0)+4+(gd<<2)>>2]|0;Db=zb;Eb=hd;while(1){b[Eb>>0]=Db|128;Gb=Db;Db=Db>>>7;jd=Eb+1|0;if(Gb>>>0<=16383)break;else Eb=jd}b[jd>>0]=Db;xb=gZb(i,Eb+2|0)|0;gd=gd+1|0;id=f[a>>2]|0;if((gd|0)>=(f[id+4>>2]|0)){k=xb;break}else hd=xb}u=g;return k|0}case 14:{zb=f[a>>2]|0;if((f[zb>>2]|0)<=0){k=e;u=g;return k|0}xb=c<<3;if(xb>>>0>127){kd=0;ld=e;md=zb}else{j=xb&255;yb=0;Gb=e;Hb=zb;while(1){zb=f[(f[Hb+8>>2]|0)+4+(yb<<2)>>2]|0;b[Gb>>0]=j;vb=Gb+1|0;Cb=zb&255;if(zb>>>0>127){h=vb;Fb=Cb;Ab=zb;Fa=((zb|0)<0)<<31>>31;while(1){b[h>>0]=Fb|-128;zb=Ab;Ab=l1c(Ab|0,Fa|0,7)|0;Bb=h+1|0;wb=Ab&255;if(!(Fa>>>0>0|(Fa|0)==0&zb>>>0>16383)){nd=Bb;od=wb;break}else{h=Bb;Fb=wb;Fa=J}}}else{nd=vb;od=Cb}b[nd>>0]=od;Fa=nd+1|0;yb=yb+1|0;Hb=f[a>>2]|0;if((yb|0)>=(f[Hb>>2]|0)){k=Fa;break}else Gb=Fa}u=g;return k|0}while(1){Gb=f[(f[md+8>>2]|0)+4+(kd<<2)>>2]|0;Hb=xb;yb=ld;while(1){b[yb>>0]=Hb|128;j=Hb;Hb=Hb>>>7;pd=yb+1|0;if(j>>>0<=16383)break;else yb=pd}b[pd>>0]=Hb;Cb=yb+2|0;vb=Gb&255;if(Gb>>>0>127){j=Cb;Fa=vb;Fb=Gb;h=((Gb|0)<0)<<31>>31;while(1){b[j>>0]=Fa|-128;Ab=Fb;Fb=l1c(Fb|0,h|0,7)|0;Eb=j+1|0;i=Fb&255;if(!(h>>>0>0|(h|0)==0&Ab>>>0>16383)){qd=Eb;rd=i;break}else{j=Eb;Fa=i;h=J}}}else{qd=Cb;rd=vb}b[qd>>0]=rd;h=qd+1|0;kd=kd+1|0;md=f[a>>2]|0;if((kd|0)>=(f[md>>2]|0)){k=h;break}else ld=h}u=g;return k|0}case 10:{xb=f[a>>2]|0;if((f[xb+4>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3;Fa=h|3;j=h|4;h=j>>>0>127;if(Fa>>>0>127){sd=0;td=e;ud=xb}else{Fb=Fa&255;Gb=0;yb=e;Hb=xb;while(1){xb=f[(f[Hb+12>>2]|0)+4+(Gb<<2)>>2]|0;b[yb>>0]=Fb;i=hj[f[(f[xb>>2]|0)+64>>2]&511](xb,d,yb+1|0)|0;if(h){xb=j;Eb=i;while(1){b[Eb>>0]=xb|128;Ab=xb>>>7;Db=Eb+1|0;if(xb>>>0>16383){xb=Ab;Eb=Db}else{vd=Db;wd=Ab;break}}}else{vd=i;wd=j}b[vd>>0]=wd;Eb=vd+1|0;Gb=Gb+1|0;Hb=f[a>>2]|0;if((Gb|0)>=(f[Hb+4>>2]|0)){k=Eb;break}else yb=Eb}u=g;return k|0}while(1){yb=f[(f[ud+12>>2]|0)+4+(sd<<2)>>2]|0;Hb=Fa;Gb=td;while(1){b[Gb>>0]=Hb|128;Fb=Hb;Hb=Hb>>>7;xd=Gb+1|0;if(Fb>>>0<=16383)break;else Gb=xd}b[xd>>0]=Hb;i=hj[f[(f[yb>>2]|0)+64>>2]&511](yb,d,Gb+2|0)|0;if(h){Fb=j;Eb=i;while(1){b[Eb>>0]=Fb|128;xb=Fb>>>7;vb=Eb+1|0;if(Fb>>>0>16383){Fb=xb;Eb=vb}else{yd=vb;zd=xb;break}}}else{yd=i;zd=j}b[yd>>0]=zd;Eb=yd+1|0;sd=sd+1|0;ud=f[a>>2]|0;if((sd|0)>=(f[ud+4>>2]|0)){k=Eb;break}else td=Eb}u=g;return k|0}case 11:{j=f[a>>2]|0;if((f[j+4>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3|2;if(h>>>0>127){Ad=0;Bd=e;Cd=j}else{Fa=h&255;Eb=0;Fb=e;Gb=j;while(1){j=f[(f[Gb+12>>2]|0)+4+(Eb<<2)>>2]|0;b[Fb>>0]=Fa;yb=Fb+1|0;Hb=_i[f[(f[j>>2]|0)+60>>2]&2047](j)|0;if(Hb>>>0>127){xb=Hb;vb=yb;while(1){b[vb>>0]=xb|128;Cb=xb>>>7;Ab=vb+1|0;if(xb>>>0>16383){xb=Cb;vb=Ab}else{Dd=Ab;Ed=Cb;break}}}else{Dd=yb;Ed=Hb}b[Dd>>0]=Ed;vb=hj[f[(f[j>>2]|0)+64>>2]&511](j,d,Dd+1|0)|0;Eb=Eb+1|0;Gb=f[a>>2]|0;if((Eb|0)>=(f[Gb+4>>2]|0)){k=vb;break}else Fb=vb}u=g;return k|0}while(1){Fb=f[(f[Cd+12>>2]|0)+4+(Ad<<2)>>2]|0;Gb=h;Eb=Bd;while(1){b[Eb>>0]=Gb|128;Fa=Gb;Gb=Gb>>>7;Fd=Eb+1|0;if(Fa>>>0<=16383)break;else Eb=Fd}b[Fd>>0]=Gb;j=Eb+2|0;Hb=_i[f[(f[Fb>>2]|0)+60>>2]&2047](Fb)|0;if(Hb>>>0>127){yb=Hb;Fa=j;while(1){b[Fa>>0]=yb|128;vb=yb>>>7;xb=Fa+1|0;if(yb>>>0>16383){yb=vb;Fa=xb}else{Gd=xb;Hd=vb;break}}}else{Gd=j;Hd=Hb}b[Gd>>0]=Hd;Fa=hj[f[(f[Fb>>2]|0)+64>>2]&511](Fb,d,Gd+1|0)|0;Ad=Ad+1|0;Cd=f[a>>2]|0;if((Ad|0)>=(f[Cd+4>>2]|0)){k=Fa;break}else Bd=Fa}u=g;return k|0}default:{k=e;u=g;return k|0}}while(0);return 0}function Jgc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=a+4|0;a=f[g>>2]|0;if(!a){h=e;return h|0}else{i=g;j=a}a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)==(g|0)){h=e;return h|0}else{m=e;n=l}while(1){l=f[n+16>>2]|0;if((l|0)>=(c|0)){h=m;o=14;break}e=Igc(n+24|0,l,d,m)|0;l=f[n+4>>2]|0;if(!l){i=n+8|0;j=f[i>>2]|0;if((f[j>>2]|0)==(n|0))p=j;else{j=i;do{i=f[j>>2]|0;j=i+8|0;b=f[j>>2]|0}while((f[b>>2]|0)!=(i|0));p=b}}else{j=l;while(1){a=f[j>>2]|0;if(!a)break;else j=a}p=j}if((p|0)==(g|0)){h=e;o=14;break}else{m=e;n=p}}if((o|0)==14)return h|0;return 0}function Kgc(a){a=a|0;return}function Lgc(a){a=a|0;cYc(a);return}function Mgc(a,c){a=a|0;c=c|0;var d=0,e=0;if(!(b[476924]|0?1:(f[(f[(f[a+4>>2]|0)+8>>2]|0)+44>>2]|0)!=3)){d=pqc()|0;return d|0}e=f[c+(f[a+24>>2]|0)>>2]|0;if(!(e&1)){d=pqc()|0;return d|0}else{d=e&-2;return d|0}return 0}function Ngc(a,b){a=a|0;b=b|0;var c=0,d=0;c=b+(f[a+24>>2]|0)|0;a=f[c>>2]|0;if(!(a&1)){d=lSa(c)|0;return d|0}else{d=a&-2;return d|0}return 0}function Ogc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;d=u;u=u+16|0;e=d;g=a+8|0;h=f[a+36>>2]|0;i=a+4|0;do if(b[476924]|0?1:(f[(f[(f[i>>2]|0)+8>>2]|0)+44>>2]|0)!=3){j=f[c+(f[a+24>>2]|0)>>2]|0;if(!(j&1)){k=pqc()|0;break}else{k=j&-2;break}}else k=pqc()|0;while(0);j=(xqc(k)|0)+h|0;h=f[a+28>>2]|0;if((h|0)==-1)l=j;else l=(Hgc(c+h|0)|0)+j|0;j=a+52|0;if((f[j>>2]|0)<0){m=l;u=d;return m|0}h=a+12|0;k=a+32|0;a=e+4|0;n=e+8|0;o=e+12|0;p=e+4|0;q=e+8|0;r=e+12|0;s=e+4|0;t=e+8|0;v=e+12|0;w=0;x=l;while(1){l=f[(f[i>>2]|0)+20>>2]|0;y=l+(w*88|0)|0;a:do if((f[l+(w*88|0)+32>>2]|0)!=3){z=l+(w*88|0)+52|0;A=f[z>>2]|0;if(A|0?(f[c+((((A-(f[(f[A+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[k>>2]|0))>>2]|0)!=(f[l+(w*88|0)+40>>2]|0):0){B=x;break}A=f[l+(w*88|0)+24>>2]|0;if(A|0?(f[A>>2]|0)!=2:0){f[e>>2]=80424;f[s>>2]=2231;b[t>>0]=0;f[v>>2]=y;J_b(A,e)}switch(f[165644+(f[l+(w*88|0)+28>>2]<<2)>>2]|0){case 10:{A=f[g>>2]|0;if((A|0)==(c|0)){B=x;break a}C=f[z>>2]|0;do if(!C){D=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){E=f[l+(w*88|0)+56>>2]|0;F=y;if(!E){G=F-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{G=F-(f[E+40>>2]|0)|0;break}}else G=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);H=c;I=D+(((G|0)/88|0)<<2)|0}else{E=(C-(f[(f[C+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){H=c;I=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){F=f[l+(w*88|0)+56>>2]|0;J=y;if(!F){K=J-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{K=J-(f[F+40>>2]|0)|0;break}}else K=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);H=A;I=E+(((K|0)/88|0)<<2)|0}while(0);A=f[H+(f[I>>2]|0)>>2]|0;if(!A){B=x;break a}B=(_i[f[(f[A>>2]|0)+84>>2]&2047](A)|0)+x|0;break a;break}case 9:break;default:{B=x;break a}}A=f[g>>2]|0;C=f[h>>2]|0;D=(b[l+(w*88|0)+38>>0]|0)==0;do if(!D){F=f[l+(w*88|0)+56>>2]|0;J=y;if(!F){L=J-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{L=J-(f[F+40>>2]|0)|0;break}}else L=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);F=f[A+(f[C+(((L|0)/88|0)<<2)>>2]|0)>>2]|0;J=f[z>>2]|0;do if(!J){do if(!D){M=f[l+(w*88|0)+56>>2]|0;N=y;if(!M){O=N-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{O=N-(f[M+40>>2]|0)|0;break}}else O=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);P=(O|0)/88|0;Q=c}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){P=(f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E|0;Q=c;break}do if(!D){E=f[l+(w*88|0)+56>>2]|0;M=y;if(!E){R=M-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{R=M-(f[E+40>>2]|0)|0;break}}else R=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);P=(R|0)/88|0;Q=A}while(0);A=f[Q+(f[C+(P<<2)>>2]|0)>>2]|0;if((A|0)==(F|0))B=x;else B=x+12+(VXb(A)|0)|0}else{A=l+(w*88|0)+24|0;D=f[A>>2]|0;if(D|0?(f[D>>2]|0)!=2:0){f[e>>2]=80424;f[p>>2]=2231;b[q>>0]=0;f[r>>2]=y;J_b(D,e)}D=l+(w*88|0)+28|0;do switch(f[165644+(f[D>>2]<<2)>>2]|0){case 1:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){E=f[l+(w*88|0)+56>>2]|0;M=y;if(!E){S=M-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{S=M-(f[E+40>>2]|0)|0;break}}else S=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);T=c;U=z+(((S|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){T=c;U=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){W=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{W=V-(f[N+40>>2]|0)|0;break}}else W=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);T=E;U=M+(((W|0)/88|0)<<2)|0}while(0);J=T+(f[U>>2]|0)|0;if(!(f[J+8>>2]|0))X=0;else X=(f[J+4>>2]<<2)+4|0;B=X+x|0;break a;break}case 2:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){Y=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Y=V-(f[N+40>>2]|0)|0;break}}else Y=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Z=c;_=z+(((Y|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){Z=c;_=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){$=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{$=V-(f[N+40>>2]|0)|0;break}}else $=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Z=M;_=E+((($|0)/88|0)<<2)|0}while(0);J=Z+(f[_>>2]|0)|0;if(!(f[J+8>>2]|0))aa=0;else aa=(f[J+4>>2]<<3)+8|0;B=aa+x|0;break a;break}case 3:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){ba=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ba=V-(f[N+40>>2]|0)|0;break}}else ba=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ca=c;da=z+(((ba|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){ca=c;da=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){ea=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ea=V-(f[N+40>>2]|0)|0;break}}else ea=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ca=E;da=M+(((ea|0)/88|0)<<2)|0}while(0);J=ca+(f[da>>2]|0)|0;if(!(f[J+8>>2]|0))fa=0;else fa=(f[J+4>>2]<<2)+4|0;B=fa+x|0;break a;break}case 4:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){ga=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ga=V-(f[N+40>>2]|0)|0;break}}else ga=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ha=c;ia=z+(((ga|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){ha=c;ia=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){ja=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ja=V-(f[N+40>>2]|0)|0;break}}else ja=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ha=M;ia=E+(((ja|0)/88|0)<<2)|0}while(0);J=ha+(f[ia>>2]|0)|0;if(!(f[J+8>>2]|0))ka=0;else ka=(f[J+4>>2]<<3)+8|0;B=ka+x|0;break a;break}case 5:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){la=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{la=V-(f[N+40>>2]|0)|0;break}}else la=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ma=c;na=z+(((la|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){ma=c;na=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){oa=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{oa=V-(f[N+40>>2]|0)|0;break}}else oa=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ma=E;na=M+(((oa|0)/88|0)<<2)|0}while(0);J=ma+(f[na>>2]|0)|0;if(!(f[J+8>>2]|0))pa=0;else pa=(f[J+4>>2]<<3)+8|0;B=pa+x|0;break a;break}case 6:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){qa=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{qa=V-(f[N+40>>2]|0)|0;break}}else qa=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ra=c;sa=z+(((qa|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){ra=c;sa=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){ta=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ta=V-(f[N+40>>2]|0)|0;break}}else ta=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);ra=M;sa=E+(((ta|0)/88|0)<<2)|0}while(0);J=ra+(f[sa>>2]|0)|0;if(!(f[J+8>>2]|0))ua=0;else ua=(f[J+4>>2]<<2)+4|0;B=ua+x|0;break a;break}case 7:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){va=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{va=V-(f[N+40>>2]|0)|0;break}}else va=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);wa=c;xa=z+(((va|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){wa=c;xa=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){ya=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{ya=V-(f[N+40>>2]|0)|0;break}}else ya=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);wa=E;xa=M+(((ya|0)/88|0)<<2)|0}while(0);J=wa+(f[xa>>2]|0)|0;if(!(f[J+8>>2]|0))za=0;else za=(f[J+4>>2]|0)+4|0;B=za+x|0;break a;break}case 8:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){Aa=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Aa=V-(f[N+40>>2]|0)|0;break}}else Aa=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ba=c;Ca=z+(((Aa|0)/88|0)<<2)|0}else{M=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){Ba=c;Ca=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){Da=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Da=V-(f[N+40>>2]|0)|0;break}}else Da=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ba=M;Ca=E+(((Da|0)/88|0)<<2)|0}while(0);J=Ba+(f[Ca>>2]|0)|0;if(!(f[J+8>>2]|0))Ea=0;else Ea=(f[J+4>>2]<<2)+4|0;B=Ea+x|0;break a;break}case 9:{J=f[l+(w*88|0)+52>>2]|0;do if(!J){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){Fa=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Fa=V-(f[N+40>>2]|0)|0;break}}else Fa=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ga=c;Ha=z+(((Fa|0)/88|0)<<2)|0}else{E=(J-(f[(f[J+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){Ga=c;Ha=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){N=f[l+(w*88|0)+56>>2]|0;V=y;if(!N){Ia=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Ia=V-(f[N+40>>2]|0)|0;break}}else Ia=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Ga=E;Ha=M+(((Ia|0)/88|0)<<2)|0}while(0);J=Ga+(f[Ha>>2]|0)|0;z=f[J+8>>2]<<2;N=J+12|0;J=f[N>>2]|0;if(!J)Ja=z;else{if((f[J>>2]|0)>0){V=0;Ka=z;La=J;while(1){J=Ka+12+(VXb(f[La+4+(V<<2)>>2]|0)|0)|0;V=V+1|0;La=f[N>>2]|0;if((V|0)>=(f[La>>2]|0)){Ma=J;break}else Ka=J}}else Ma=z;Ja=Ma+4|0}B=Ja+x|0;break a;break}case 10:{Ka=f[A>>2]|0;if(Ka|0?(f[Ka>>2]|0)!=2:0){f[e>>2]=80424;f[a>>2]=2231;b[n>>0]=0;f[o>>2]=y;J_b(Ka,e)}if((f[D>>2]|0)==11?D3b(y)|0:0){Ka=f[l+(w*88|0)+52>>2]|0;do if(!Ka){La=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){V=f[l+(w*88|0)+56>>2]|0;N=y;if(!V){Na=N-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Na=N-(f[V+40>>2]|0)|0;break}}else Na=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Oa=c;Pa=La+(((Na|0)/88|0)<<2)|0}else{M=(Ka-(f[(f[Ka+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((M<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){Oa=c;Pa=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+M<<2)|0;break}M=f[g>>2]|0;E=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){V=f[l+(w*88|0)+56>>2]|0;N=y;if(!V){Qa=N-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Qa=N-(f[V+40>>2]|0)|0;break}}else Qa=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Oa=M;Pa=E+(((Qa|0)/88|0)<<2)|0}while(0);B=(blc(Oa+(f[Pa>>2]|0)|0)|0)+x|0;break a}Ka=f[l+(w*88|0)+52>>2]|0;do if(!Ka){z=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){La=f[l+(w*88|0)+56>>2]|0;V=y;if(!La){Ra=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Ra=V-(f[La+40>>2]|0)|0;break}}else Ra=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Sa=c;Ta=z+(((Ra|0)/88|0)<<2)|0}else{E=(Ka-(f[(f[Ka+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((E<<2)+(f[k>>2]|0))>>2]|0)==(f[l+(w*88|0)+40>>2]|0)){Sa=c;Ta=(f[h>>2]|0)+((f[(f[l+(w*88|0)+48>>2]|0)+52>>2]|0)+E<<2)|0;break}E=f[g>>2]|0;M=f[h>>2]|0;do if(b[l+(w*88|0)+38>>0]|0){La=f[l+(w*88|0)+56>>2]|0;V=y;if(!La){Ua=V-(f[(f[l+(w*88|0)+20>>2]|0)+80>>2]|0)|0;break}else{Ua=V-(f[La+40>>2]|0)|0;break}}else Ua=y-(f[(f[l+(w*88|0)+48>>2]|0)+20>>2]|0)|0;while(0);Sa=E;Ta=M+(((Ua|0)/88|0)<<2)|0}while(0);Ka=Sa+(f[Ta>>2]|0)|0;z=f[Ka+8>>2]<<2;La=Ka+12|0;Ka=f[La>>2]|0;if(!Ka)Va=z;else{if((f[Ka>>2]|0)>0){V=0;N=z;J=Ka;while(1){Ka=f[J+4+(V<<2)>>2]|0;Wa=(_i[f[(f[Ka>>2]|0)+84>>2]&2047](Ka)|0)+N|0;V=V+1|0;J=f[La>>2]|0;if((V|0)>=(f[J>>2]|0)){Xa=Wa;break}else N=Wa}}else Xa=z;Va=Xa+4|0}B=Va+x|0;break a;break}default:{B=x;break a}}while(0)}while(0);if((w|0)<(f[j>>2]|0)){w=w+1|0;x=B}else{m=B;break}}u=d;return m|0}function Pgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=a+4|0;g=f[e>>2]|0;if((f[d+48>>2]|0)!=(g|0))tic(g,d,500196,498554);if((f[d+32>>2]|0)==3)tic(f[e>>2]|0,d,500196,499313);if(b[d+38>>0]|0){h=wrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0)|0;return h|0}e=f[d+52>>2]|0;if(!e){h=Mic(a,c,d)|0;return h|0}else{h=(f[c+((((e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0);return h|0}return 0}function Qgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+40|0;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,500186,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,500186,498006);k=d+38|0;if(b[k>>0]|0){m=xrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0)|0;u=e;return m|0}l=d+24|0;n=f[l>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(n,g)}n=d+28|0;do switch(f[165644+(f[n>>2]<<2)>>2]|0){case 1:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;r=d;if(!q){s=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=r-(f[q+40>>2]|0)|0;break}}else s=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);t=c;v=p+(((s|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){t=c;v=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){y=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{y=x-(f[w+40>>2]|0)|0;break}}else y=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);t=q;v=r+(((y|0)/88|0)<<2)|0}while(0);m=f[t+(f[v>>2]|0)>>2]|0;u=e;return m|0}case 2:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){z=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{z=x-(f[w+40>>2]|0)|0;break}}else z=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);A=c;B=p+(((z|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){A=c;B=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){C=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{C=x-(f[w+40>>2]|0)|0;break}}else C=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);A=r;B=q+(((C|0)/88|0)<<2)|0}while(0);m=f[A+(f[B>>2]|0)>>2]|0;u=e;return m|0}case 3:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){D=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{D=x-(f[w+40>>2]|0)|0;break}}else D=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);E=c;F=p+(((D|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){E=c;F=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){G=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{G=x-(f[w+40>>2]|0)|0;break}}else G=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);E=q;F=r+(((G|0)/88|0)<<2)|0}while(0);m=f[E+(f[F>>2]|0)>>2]|0;u=e;return m|0}case 4:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){H=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{H=x-(f[w+40>>2]|0)|0;break}}else H=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);I=c;J=p+(((H|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){I=c;J=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){K=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{K=x-(f[w+40>>2]|0)|0;break}}else K=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);I=r;J=q+(((K|0)/88|0)<<2)|0}while(0);m=f[I+(f[J>>2]|0)>>2]|0;u=e;return m|0}case 5:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){L=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{L=x-(f[w+40>>2]|0)|0;break}}else L=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);M=c;N=p+(((L|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){M=c;N=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){O=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{O=x-(f[w+40>>2]|0)|0;break}}else O=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);M=q;N=r+(((O|0)/88|0)<<2)|0}while(0);m=f[M+(f[N>>2]|0)>>2]|0;u=e;return m|0}case 6:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){P=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{P=x-(f[w+40>>2]|0)|0;break}}else P=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Q=c;R=p+(((P|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){Q=c;R=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){S=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{S=x-(f[w+40>>2]|0)|0;break}}else S=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Q=r;R=q+(((S|0)/88|0)<<2)|0}while(0);m=f[Q+(f[R>>2]|0)>>2]|0;u=e;return m|0}case 7:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){T=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{T=x-(f[w+40>>2]|0)|0;break}}else T=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);U=c;V=p+(((T|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){U=c;V=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){W=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{W=x-(f[w+40>>2]|0)|0;break}}else W=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);U=q;V=r+(((W|0)/88|0)<<2)|0}while(0);m=f[U+(f[V>>2]|0)>>2]|0;u=e;return m|0}case 8:{o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){X=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{X=x-(f[w+40>>2]|0)|0;break}}else X=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Y=c;Z=p+(((X|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){Y=c;Z=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){_=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{_=x-(f[w+40>>2]|0)|0;break}}else _=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Y=r;Z=q+(((_|0)/88|0)<<2)|0}while(0);m=f[Y+(f[Z>>2]|0)>>2]|0;u=e;return m|0}case 10:case 9:{o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(o,g)}if((f[n>>2]|0)==11?D3b(d)|0:0){o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){$=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{$=x-(f[w+40>>2]|0)|0;break}}else $=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);aa=c;ba=p+((($|0)/88|0)<<2)|0}else{q=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((q<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){aa=c;ba=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+q<<2)|0;break}q=f[a+8>>2]|0;r=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){ca=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ca=x-(f[w+40>>2]|0)|0;break}}else ca=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);aa=q;ba=r+(((ca|0)/88|0)<<2)|0}while(0);o=($kc(aa+(f[ba>>2]|0)|0)|0)+4|0;m=f[o>>2]|0;u=e;return m|0}o=f[d+52>>2]|0;do if(!o){p=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){da=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{da=x-(f[w+40>>2]|0)|0;break}}else da=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);ea=c;fa=p+(((da|0)/88|0)<<2)|0}else{r=(o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((r<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){ea=c;fa=(f[a+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+r<<2)|0;break}r=f[a+8>>2]|0;q=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;x=d;if(!w){ga=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ga=x-(f[w+40>>2]|0)|0;break}}else ga=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);ea=r;fa=q+(((ga|0)/88|0)<<2)|0}while(0);m=f[ea+(f[fa>>2]|0)+4>>2]|0;u=e;return m|0}default:{u_b(h,3,497294,747);r_b(i,p_b(h,507741)|0);v_b(h);m=0;u=e;return m|0}}while(0);return 0}function Rgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+16|0;g=e;h=d+48|0;i=f[a+4>>2]|0;if((f[h>>2]|0)!=(i|0))tic(i,d,500175,498554);i=d+38|0;if(b[i>>0]|0){zrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0);u=e;return}if((f[d+32>>2]|0)==3){j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(k,g)}k=d+28|0;do switch(f[165644+(f[k>>2]<<2)>>2]|0){case 1:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){n=f[d+56>>2]|0;o=d;if(!n){q=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=o-(f[n+40>>2]|0)|0;break}}else q=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);r=m+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[r>>2]|0)>>2]=0;u=e;return}case 2:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){v=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=t-(f[s+40>>2]|0)|0;break}}else v=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);w=o+(((v|0)/88|0)<<2)|0}else w=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[w>>2]|0)>>2]=0;u=e;return}case 3:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){x=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{x=t-(f[s+40>>2]|0)|0;break}}else x=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);y=m+(((x|0)/88|0)<<2)|0}else y=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[y>>2]|0)>>2]=0;u=e;return}case 4:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){z=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{z=t-(f[s+40>>2]|0)|0;break}}else z=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);A=o+(((z|0)/88|0)<<2)|0}else A=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[A>>2]|0)>>2]=0;u=e;return}case 5:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){B=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{B=t-(f[s+40>>2]|0)|0;break}}else B=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);C=m+(((B|0)/88|0)<<2)|0}else C=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[C>>2]|0)>>2]=0;u=e;return}case 6:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){D=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{D=t-(f[s+40>>2]|0)|0;break}}else D=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);E=o+(((D|0)/88|0)<<2)|0}else E=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[E>>2]|0)>>2]=0;u=e;return}case 7:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){F=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{F=t-(f[s+40>>2]|0)|0;break}}else F=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);G=m+(((F|0)/88|0)<<2)|0}else G=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[G>>2]|0)>>2]=0;u=e;return}case 8:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){H=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{H=t-(f[s+40>>2]|0)|0;break}}else H=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);I=o+(((H|0)/88|0)<<2)|0}else I=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[I>>2]|0)>>2]=0;u=e;return}case 9:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){J=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{J=t-(f[s+40>>2]|0)|0;break}}else J=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);K=m+(((J|0)/88|0)<<2)|0}else K=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[K>>2]|0)|0;o=n+4|0;s=f[o>>2]|0;if((s|0)<=0){u=e;return}t=f[n+12>>2]|0;n=0;do{L=f[t+4+(n<<2)>>2]|0;n=n+1|0;M=L+11|0;if((b[M>>0]|0)<0){b[f[L>>2]>>0]=0;f[L+4>>2]=0}else{b[L>>0]=0;b[M>>0]=0}}while((n|0)!=(s|0));f[o>>2]=0;u=e;return}case 10:{s=f[j>>2]|0;if(s|0?(f[s>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(s,g)}if((f[k>>2]|0)==11?D3b(d)|0:0){s=f[d+52>>2]|0;if(!s){n=f[a+12>>2]|0;do if(b[i>>0]|0){t=f[d+56>>2]|0;l=d;if(!t){N=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{N=l-(f[t+40>>2]|0)|0;break}}else N=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);O=n+(((N|0)/88|0)<<2)|0}else O=(f[a+12>>2]|0)+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;o=alc(c+(f[O>>2]|0)|0)|0;t=o+4|0;l=f[t>>2]|0;if((l|0)<=0){u=e;return}m=f[o+12>>2]|0;o=0;do{M=f[m+4+(o<<2)>>2]|0;o=o+1|0;Yi[f[(f[M>>2]|0)+28>>2]&4095](M)}while((o|0)!=(l|0));f[t>>2]=0;u=e;return}l=f[d+52>>2]|0;if(!l){o=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;s=d;if(!m){P=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{P=s-(f[m+40>>2]|0)|0;break}}else P=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);Q=o+(((P|0)/88|0)<<2)|0}else Q=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;t=c+(f[Q>>2]|0)|0;m=t+4|0;s=f[m>>2]|0;if((s|0)<=0){u=e;return}n=f[t+12>>2]|0;t=0;do{M=f[n+4+(t<<2)>>2]|0;t=t+1|0;Yi[f[(f[M>>2]|0)+28>>2]&4095](M)}while((t|0)!=(s|0));f[m>>2]=0;u=e;return}default:{u=e;return}}while(0)}Q=d+52|0;P=f[Q>>2]|0;if(P|0){if((f[c+((((P-(f[(f[P+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){u=e;return}Tgc(a,c,P);u=e;return}if(!(Mic(a,c,d)|0)){u=e;return}P=a+20|0;O=f[P>>2]|0;if((O|0)!=-1){N=f[a+16>>2]|0;do if(b[i>>0]|0){k=f[d+56>>2]|0;j=d;if(!k){R=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{R=j-(f[k+40>>2]|0)|0;break}}else R=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);k=f[N+(((R|0)/88|0)<<2)>>2]|0;R=c+O+(k>>>5<<2)|0;f[R>>2]=f[R>>2]&~(1<<(k&31))}k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(k,g)}do switch(f[165644+(f[d+28>>2]<<2)>>2]|0){case 1:{g=f[d+80>>2]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){O=f[d+56>>2]|0;N=d;if(!O){S=N-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{S=N-(f[O+40>>2]|0)|0;break}}else S=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);T=R+(((S|0)/88|0)<<2)|0}else T=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[T>>2]|0)>>2]=g;u=e;return}case 2:{m=d+80|0;O=f[m>>2]|0;N=f[m+4>>2]|0;m=f[Q>>2]|0;if(!m){j=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){U=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{U=J-(f[K+40>>2]|0)|0;break}}else U=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);V=j+(((U|0)/88|0)<<2)|0}else V=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;g=c+(f[V>>2]|0)|0;f[g>>2]=O;f[g+4>>2]=N;u=e;return}case 3:{g=f[d+80>>2]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){W=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{W=J-(f[K+40>>2]|0)|0;break}}else W=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);X=R+(((W|0)/88|0)<<2)|0}else X=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[X>>2]|0)>>2]=g;u=e;return}case 4:{N=d+80|0;O=f[N>>2]|0;m=f[N+4>>2]|0;N=f[Q>>2]|0;if(!N){j=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){Y=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Y=J-(f[K+40>>2]|0)|0;break}}else Y=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);Z=j+(((Y|0)/88|0)<<2)|0}else Z=(f[a+12>>2]|0)+(((N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;g=c+(f[Z>>2]|0)|0;f[g>>2]=O;f[g+4>>2]=m;u=e;return}case 6:{g=f[d+80>>2]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){K=f[d+56>>2]|0;J=d;if(!K){_=J-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{_=J-(f[K+40>>2]|0)|0;break}}else _=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);$=R+(((_|0)/88|0)<<2)|0}else $=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[$>>2]|0)>>2]=g;u=e;return}case 5:{aa=+p[d+80>>3];m=f[Q>>2]|0;if(!m){O=f[a+12>>2]|0;do if(b[i>>0]|0){N=f[d+56>>2]|0;j=d;if(!N){ba=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ba=j-(f[N+40>>2]|0)|0;break}}else ba=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ca=O+(((ba|0)/88|0)<<2)|0}else ca=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;p[c+(f[ca>>2]|0)>>3]=aa;u=e;return}case 7:{g=b[d+80>>0]|0;k=f[Q>>2]|0;if(!k){R=f[a+12>>2]|0;do if(b[i>>0]|0){N=f[d+56>>2]|0;j=d;if(!N){da=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{da=j-(f[N+40>>2]|0)|0;break}}else da=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ea=R+(((da|0)/88|0)<<2)|0}else ea=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;b[c+(f[ea>>2]|0)>>0]=g;u=e;return}case 8:{m=(E3b(d)|0)+8|0;O=f[m>>2]|0;m=f[Q>>2]|0;if(!m){N=f[a+12>>2]|0;do if(b[i>>0]|0){j=f[d+56>>2]|0;K=d;if(!j){fa=K-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{fa=K-(f[j+40>>2]|0)|0;break}}else fa=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ga=N+(((fa|0)/88|0)<<2)|0}else ga=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[ga>>2]|0)>>2]=O;u=e;return}case 9:{g=f[a+8>>2]|0;k=f[a+12>>2]|0;R=(b[i>>0]|0)==0;do if(!R){j=f[d+56>>2]|0;K=d;if(!j){ha=K-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ha=K-(f[j+40>>2]|0)|0;break}}else ha=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);O=f[g+(f[k+(((ha|0)/88|0)<<2)>>2]|0)>>2]|0;m=f[Q>>2]|0;if(!m){do if(!R){N=f[d+56>>2]|0;j=d;if(!N){ia=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ia=j-(f[N+40>>2]|0)|0;break}}else ia=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ja=(ia|0)/88|0}else ja=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)|0;R=c+(f[k+(ja<<2)>>2]|0)|0;g=f[c+(f[a+24>>2]|0)>>2]|0;N=g&-2;if(!(g&1))ka=N;else ka=f[N+4>>2]|0;if((ka|0)==0?(N=f[R>>2]|0,!((N|0)==(O|0)|(N|0)==0)):0){if((b[N+11>>0]|0)<0)cYc(f[N>>2]|0);cYc(N)}f[R>>2]=O;u=e;return}case 10:{if((f[P>>2]|0)!=-1){R=f[Q>>2]|0;if(!R){N=f[a+12>>2]|0;do if(b[i>>0]|0){g=f[d+56>>2]|0;j=d;if(!g){la=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{la=j-(f[g+40>>2]|0)|0;break}}else la=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ma=N+(((la|0)/88|0)<<2)|0}else ma=(f[a+12>>2]|0)+(((R-(f[(f[R+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;O=f[c+(f[ma>>2]|0)>>2]|0;Yi[f[(f[O>>2]|0)+28>>2]&4095](O);u=e;return}O=f[c+(f[a+24>>2]|0)>>2]|0;k=O&-2;if(!(O&1))na=k;else na=f[k+4>>2]|0;if(!na){k=f[Q>>2]|0;if(!k){O=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;g=d;if(!m){oa=g-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{oa=g-(f[m+40>>2]|0)|0;break}}else oa=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);pa=O+(((oa|0)/88|0)<<2)|0}else pa=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;R=f[c+(f[pa>>2]|0)>>2]|0;if(R|0)Yi[f[(f[R>>2]|0)+4>>2]&4095](R)}R=f[Q>>2]|0;if(!R){N=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;g=d;if(!m){qa=g-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{qa=g-(f[m+40>>2]|0)|0;break}}else qa=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);ra=N+(((qa|0)/88|0)<<2)|0}else ra=(f[a+12>>2]|0)+(((R-(f[(f[R+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[ra>>2]|0)>>2]=0;u=e;return}default:{u=e;return}}while(0)}function Sgc(a,b,c){a=a|0;b=b|0;c=c|0;return (f[b+((((c-(f[(f[c+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=0|0}function Tgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=a+32|0;i=d+8|0;j=d;d=f[c+((((j-(f[(f[i>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[h>>2]|0))>>2]|0;if(!d){u=e;return}k=s3b(f[a+4>>2]|0,d)|0;d=a+24|0;l=f[c+(f[d>>2]|0)>>2]|0;m=l&-2;if(!(l&1))n=m;else n=f[m+4>>2]|0;a:do if(!n){m=f[k+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=k;J_b(m,g)}switch(f[165644+(f[k+28>>2]<<2)>>2]|0){case 9:break;case 10:{m=f[k+52>>2]|0;if(!m){l=f[a+12>>2]|0;do if(b[k+38>>0]|0){o=f[k+56>>2]|0;p=k;if(!o){q=p-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{q=p-(f[o+40>>2]|0)|0;break}}else q=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);r=l+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[k+48>>2]|0)+52>>2]|0)<<2)|0;o=f[c+(f[r>>2]|0)>>2]|0;if(!o)break a;Yi[f[(f[o>>2]|0)+4>>2]&4095](o);break a;break}default:break a}o=f[a+8>>2]|0;p=f[a+12>>2]|0;s=(b[k+38>>0]|0)==0;do if(!s){t=f[k+56>>2]|0;v=k;if(!t){w=v-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{w=v-(f[t+40>>2]|0)|0;break}}else w=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);m=f[o+(f[p+(((w|0)/88|0)<<2)>>2]|0)>>2]|0;l=f[k+52>>2]|0;if(!l){t=f[a+20>>2]|0;if((t|0)!=-1){v=f[a+16>>2]|0;do if(!s){x=f[k+56>>2]|0;y=k;if(!x){z=y-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{z=y-(f[x+40>>2]|0)|0;break}}else z=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);o=f[v+(((z|0)/88|0)<<2)>>2]|0;x=c+t+(o>>>5<<2)|0;f[x>>2]=1<<(o&31)|f[x>>2]}do if(!s){x=f[k+56>>2]|0;o=k;if(!x){A=o-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{A=o-(f[x+40>>2]|0)|0;break}}else A=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);B=(A|0)/88|0}else{s=(l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((s<<2)+(f[h>>2]|0))>>2]=f[k+40>>2];B=s+(f[(f[k+48>>2]|0)+52>>2]|0)|0}s=f[c+(f[d>>2]|0)>>2]|0;t=s&-2;if(!(s&1))C=t;else C=f[t+4>>2]|0;if((C|0)==0?(t=f[c+(f[p+(B<<2)>>2]|0)>>2]|0,!((t|0)==(m|0)|(t|0)==0)):0){if((b[t+11>>0]|0)<0)cYc(f[t>>2]|0);cYc(t)}}while(0);f[c+((((j-(f[(f[i>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[h>>2]|0))>>2]=0;u=e;return}function Ugc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b+((((c-(f[(f[c+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0;if(!d){e=0;return e|0}e=s3b(f[a+4>>2]|0,d)|0;return e|0}function Vgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,500164,498554);if((f[d+32>>2]|0)!=3)tic(f[i>>2]|0,d,500164,498006);i=d+38|0;if(b[i>>0]|0){Hsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0);u=e;return}j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(k,g)}k=d+28|0;do switch(f[165644+(f[k>>2]<<2)>>2]|0){case 1:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){n=f[d+56>>2]|0;o=d;if(!n){p=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{p=o-(f[n+40>>2]|0)|0;break}}else p=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);q=m+(((p|0)/88|0)<<2)|0}else q=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[q>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 2:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){t=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{t=s-(f[r+40>>2]|0)|0;break}}else t=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);v=o+(((t|0)/88|0)<<2)|0}else v=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[v>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 3:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){w=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{w=s-(f[r+40>>2]|0)|0;break}}else w=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);x=m+(((w|0)/88|0)<<2)|0}else x=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[x>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 4:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){y=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{y=s-(f[r+40>>2]|0)|0;break}}else y=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);z=o+(((y|0)/88|0)<<2)|0}else z=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[z>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 5:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){A=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{A=s-(f[r+40>>2]|0)|0;break}}else A=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);B=m+(((A|0)/88|0)<<2)|0}else B=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[B>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 6:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){C=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{C=s-(f[r+40>>2]|0)|0;break}}else C=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);D=o+(((C|0)/88|0)<<2)|0}else D=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[D>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 7:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){E=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{E=s-(f[r+40>>2]|0)|0;break}}else E=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);F=m+(((E|0)/88|0)<<2)|0}else F=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[F>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+-1;u=e;return}case 8:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){G=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{G=s-(f[r+40>>2]|0)|0;break}}else G=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);H=o+(((G|0)/88|0)<<2)|0}else H=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=c+(f[H>>2]|0)|0;f[l>>2]=(f[l>>2]|0)+-1;u=e;return}case 9:{l=f[d+52>>2]|0;if(!l){m=f[a+12>>2]|0;do if(b[i>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){I=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{I=s-(f[r+40>>2]|0)|0;break}}else I=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);J=m+(((I|0)/88|0)<<2)|0}else J=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[J>>2]|0)|0;o=f[n+12>>2]|0;r=n+4|0;n=(f[r>>2]|0)+-1|0;f[r>>2]=n;r=f[o+4+(n<<2)>>2]|0;n=r+11|0;if((b[n>>0]|0)<0){b[f[r>>2]>>0]=0;f[r+4>>2]=0;u=e;return}else{b[r>>0]=0;b[n>>0]=0;u=e;return}break}case 10:{n=f[j>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(n,g)}if((f[k>>2]|0)==11?D3b(d)|0:0){n=f[d+52>>2]|0;if(!n){r=f[a+12>>2]|0;do if(b[i>>0]|0){o=f[d+56>>2]|0;s=d;if(!o){K=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{K=s-(f[o+40>>2]|0)|0;break}}else K=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);L=r+(((K|0)/88|0)<<2)|0}else L=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;l=alc(c+(f[L>>2]|0)|0)|0;m=f[l+12>>2]|0;o=l+4|0;l=(f[o>>2]|0)+-1|0;f[o>>2]=l;o=f[m+4+(l<<2)>>2]|0;Yi[f[(f[o>>2]|0)+28>>2]&4095](o);u=e;return}o=f[d+52>>2]|0;if(!o){l=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;s=d;if(!m){M=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{M=s-(f[m+40>>2]|0)|0;break}}else M=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);N=l+(((M|0)/88|0)<<2)|0}else N=(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;n=c+(f[N>>2]|0)|0;r=f[n+12>>2]|0;m=n+4|0;n=(f[m>>2]|0)+-1|0;f[m>>2]=n;m=f[r+4+(n<<2)>>2]|0;Yi[f[(f[m>>2]|0)+28>>2]&4095](m);u=e;return}default:{u=e;return}}while(0)}function Wgc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,500152,498554);if((f[d+32>>2]|0)!=3)tic(f[i>>2]|0,d,500152,498006);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(k,g)}k=d+28|0;if((f[165644+(f[k>>2]<<2)>>2]|0)!=10)wic(f[i>>2]|0,d,500152,10);i=d+38|0;if(b[i>>0]|0){l=Isc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0)|0;u=e;return l|0}m=f[j>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(m,g)}if((f[k>>2]|0)==11?D3b(d)|0:0){k=f[d+52>>2]|0;if(!k){g=f[a+12>>2]|0;do if(b[i>>0]|0){m=f[d+56>>2]|0;j=d;if(!m){n=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=j-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);o=g+(((n|0)/88|0)<<2)|0}else o=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;k=alc(c+(f[o>>2]|0)|0)|0;o=f[k+12>>2]|0;n=k+4|0;g=f[n>>2]|0;m=g+-1|0;f[n>>2]=m;n=o+4+(m<<2)|0;m=f[n>>2]|0;j=f[o>>2]|0;p=j+-1|0;f[o>>2]=p;if((g|0)<(j|0))f[n>>2]=f[o+4+(p<<2)>>2];if(!(f[k>>2]|0)){l=m;u=e;return l|0}k=Joc(m,0)|0;yic(m,k);l=k;u=e;return l|0}k=f[d+52>>2]|0;if(!k){m=f[a+12>>2]|0;do if(b[i>>0]|0){p=f[d+56>>2]|0;o=d;if(!p){q=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=o-(f[p+40>>2]|0)|0;break}}else q=d-(f[(f[h>>2]|0)+20>>2]|0)|0;while(0);r=m+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+52>>2]|0)<<2)|0;h=c+(f[r>>2]|0)|0;r=f[h+12>>2]|0;c=h+4|0;k=f[c>>2]|0;a=k+-1|0;f[c>>2]=a;c=r+4+(a<<2)|0;a=f[c>>2]|0;q=f[r>>2]|0;m=q+-1|0;f[r>>2]=m;if((k|0)<(q|0))f[c>>2]=f[r+4+(m<<2)>>2];if(!(f[h>>2]|0)){l=a;u=e;return l|0}h=Joc(a,0)|0;yic(a,h);l=h;u=e;return l|0}function Xgc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+64|0;e=d+48|0;g=d+24|0;h=d;if((b|0)==(c|0)){u=d;return}mi[f[(f[b>>2]|0)+96>>2]&2047](e,b);if((f[e+4>>2]|0)!=(a|0)){u_b(g,3,497294,577);i=p_b(p_b(g,499716)|0,500079)|0;mi[f[(f[b>>2]|0)+96>>2]&2047](e,b);j=p_b(q_b(i,f[(f[e>>2]|0)+4>>2]|0)|0,499812)|0;r_b(d+57|0,p_b(q_b(j,f[(f[a+4>>2]|0)+4>>2]|0)|0,499882)|0);v_b(g)}mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);if((f[e+4>>2]|0)!=(a|0)){u_b(h,3,497294,584);g=p_b(p_b(h,499961)|0,500115)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);j=p_b(q_b(g,f[(f[e>>2]|0)+4>>2]|0)|0,499812)|0;r_b(d+56|0,p_b(q_b(j,f[(f[a+4>>2]|0)+4>>2]|0)|0,499882)|0);v_b(h)}h=a+24|0;j=f[h>>2]|0;e=f[b+j>>2]|0;g=(e&1|0)==0;i=e&-2;if(g)k=i;else k=f[i+4>>2]|0;e=f[c+j>>2]|0;j=e&-2;if(!(e&1))l=j;else l=f[j+4>>2]|0;if((k|0)!=(l|0)){if(g)m=i;else m=f[i+4>>2]|0;i=Mi[f[(f[b>>2]|0)+16>>2]&1023](b,m)|0;mi[f[(f[i>>2]|0)+76>>2]&2047](i,c);mi[f[(f[c>>2]|0)+72>>2]&2047](c,b);Xgc(a,b,i);m=f[b+(f[h>>2]|0)>>2]|0;g=m&-2;if(!(m&1))n=g;else n=f[g+4>>2]|0;if((i|0)==0|(n|0)!=0){u=d;return}Yi[f[(f[i>>2]|0)+4>>2]&4095](i);u=d;return}i=f[a+20>>2]|0;if((i|0)!=-1){n=b+i|0;g=c+i|0;i=a+4|0;m=f[i>>2]|0;l=f[m+52>>2]|0;if((l|0)>0){k=f[m+20>>2]|0;j=0;e=0;while(1){if((f[k+(j*88|0)+32>>2]|0)==3)o=e;else o=((f[k+(j*88|0)+52>>2]|0)==0&1)+e|0;j=j+1|0;if((j|0)>=(l|0))break;else e=o}e=(o+31|0)/32|0;if((o|0)>0){o=0;do{l=n+(o<<2)|0;j=g+(o<<2)|0;k=f[l>>2]|0;f[l>>2]=f[j>>2];f[j>>2]=k;o=o+1|0}while((o|0)<(e|0));p=i;q=m}else{p=i;q=m}}else{p=i;q=m}}else{m=a+4|0;p=m;q=f[m>>2]|0}m=a+52|0;i=f[m>>2]|0;if((i|0)<0)r=q;else{e=0;o=q;q=i;while(1){i=f[o+20>>2]|0;if(!(f[i+(e*88|0)+52>>2]|0)){Sic(a,b,c,i+(e*88|0)|0);s=f[m>>2]|0;t=f[p>>2]|0}else{s=q;t=o}if((e|0)<(s|0)){e=e+1|0;o=t;q=s}else{r=t;break}}}t=f[r+56>>2]|0;if((t|0)>0?(Qic(a,b,c,f[r+24>>2]|0),(t|0)!=1):0){r=1;do{Qic(a,b,c,(f[(f[p>>2]|0)+24>>2]|0)+(r*28|0)|0);r=r+1|0}while((r|0)!=(t|0))}t=f[a+28>>2]|0;if((t|0)!=-1)Nsc(b+t|0,c+t|0);t=f[h>>2]|0;a=b+t|0;b=f[a>>2]|0;if(!(b&1)){r=lSa(a)|0;v=r;w=f[h>>2]|0}else{v=b&-2;w=t}t=c+w|0;w=f[t>>2]|0;if(!(w&1))x=lSa(t)|0;else x=w&-2;w=f[v>>2]|0;f[v>>2]=f[x>>2];f[x>>2]=w;u=d;return}function Ygc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+64|0;h=g+48|0;i=g+24|0;j=g;if((c|0)==(d|0)){u=g;return}mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);if((f[h+4>>2]|0)!=(a|0)){u_b(i,3,497294,651);k=p_b(p_b(i,499716)|0,499770)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](h,c);l=p_b(q_b(k,f[(f[h>>2]|0)+4>>2]|0)|0,499812)|0;r_b(g+61|0,p_b(q_b(l,f[(f[a+4>>2]|0)+4>>2]|0)|0,499882)|0);v_b(i)}mi[f[(f[d>>2]|0)+96>>2]&2047](h,d);if((f[h+4>>2]|0)!=(a|0)){u_b(j,3,497294,658);i=p_b(p_b(j,499961)|0,500015)|0;mi[f[(f[d>>2]|0)+96>>2]&2047](h,d);l=p_b(q_b(i,f[(f[h>>2]|0)+4>>2]|0)|0,499812)|0;r_b(g+60|0,p_b(q_b(l,f[(f[a+4>>2]|0)+4>>2]|0)|0,499882)|0);v_b(j)}j=h+4|0;f[j>>2]=0;l=h+8|0;f[l>>2]=0;i=h+4|0;f[h>>2]=i;k=f[e>>2]|0;m=(f[e+4>>2]|0)-k|0;n=m>>2;if((m|0)>0){m=a+28|0;o=0;p=k;while(1){k=f[p+(o<<2)>>2]|0;a:do if(!(b[k+38>>0]|0)){q=k+52|0;r=f[q>>2]|0;if(!r){if((f[k+32>>2]|0)!=3)Ric(a,c,d,k);Sic(a,c,d,k);break}s=(r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0;t=f[i>>2]|0;do if(t){v=i;w=t;b:while(1){x=w;while(1){if((f[x+16>>2]|0)>=(s|0))break;y=f[x+4>>2]|0;if(!y){z=v;break b}else x=y}w=f[x>>2]|0;if(!w){z=x;break}else v=x}if((z|0)!=(i|0)?(s|0)>=(f[z+16>>2]|0):0)break a;else{A=j;B=t}while(1){v=f[B+16>>2]|0;if((s|0)<(v|0)){w=f[B>>2]|0;if(!w){C=23;break}else{D=B;E=w}}else{if((v|0)>=(s|0)){C=27;break}F=B+4|0;v=f[F>>2]|0;if(!v){C=26;break}else{D=F;E=v}}A=D;B=E}if((C|0)==23){C=0;G=B;H=B;break}else if((C|0)==26){C=0;G=B;H=F;break}else if((C|0)==27){C=0;G=B;H=A;break}}else{G=i;H=i}while(0);if(!(f[H>>2]|0)){t=$Xc(20)|0;f[t+16>>2]=s;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=G;f[H>>2]=t;v=f[f[h>>2]>>2]|0;if(!v)I=t;else{f[h>>2]=v;I=f[H>>2]|0}UQ(f[j>>2]|0,I);f[l>>2]=(f[l>>2]|0)+1;J=f[q>>2]|0}else J=r;Qic(a,c,d,J)}else{v=f[m>>2]|0;Osc(c+v|0,d+v|0,f[k+40>>2]|0)}while(0);k=o+1|0;if((k|0)>=(n|0))break;o=k;p=f[e>>2]|0}K=f[i>>2]|0}else K=0;ILa(h,K);u=g;return}function Zgc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,499711,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,499711,498006);k=d+38|0;if(b[k>>0]|0){Jsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(m,i)}m=d+28|0;do switch(f[165644+(f[m>>2]<<2)>>2]|0){case 1:{n=f[d+52>>2]|0;if(!n){o=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;r=d;if(!q){s=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=r-(f[q+40>>2]|0)|0;break}}else s=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);t=o+(((s|0)/88|0)<<2)|0}else t=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;q=f[c+(f[t>>2]|0)+8>>2]|0;r=q+4+(e<<2)|0;v=q+4+(g<<2)|0;q=f[r>>2]|0;f[r>>2]=f[v>>2];f[v>>2]=q;u=h;return}case 2:{q=f[d+52>>2]|0;if(!q){v=f[a+12>>2]|0;do if(b[k>>0]|0){r=f[d+56>>2]|0;w=d;if(!r){x=w-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{x=w-(f[r+40>>2]|0)|0;break}}else x=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);y=v+(((x|0)/88|0)<<2)|0}else y=(f[a+12>>2]|0)+(((q-(f[(f[q+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;n=f[c+(f[y>>2]|0)+8>>2]|0;o=n+8+(e<<3)|0;r=n+8+(g<<3)|0;n=o;w=f[n>>2]|0;z=f[n+4>>2]|0;n=r;A=f[n+4>>2]|0;B=o;f[B>>2]=f[n>>2];f[B+4>>2]=A;A=r;f[A>>2]=w;f[A+4>>2]=z;u=h;return}case 3:{z=f[d+52>>2]|0;if(!z){A=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;r=d;if(!w){C=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{C=r-(f[w+40>>2]|0)|0;break}}else C=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);D=A+(((C|0)/88|0)<<2)|0}else D=(f[a+12>>2]|0)+(((z-(f[(f[z+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;q=f[c+(f[D>>2]|0)+8>>2]|0;v=q+4+(e<<2)|0;w=q+4+(g<<2)|0;q=f[v>>2]|0;f[v>>2]=f[w>>2];f[w>>2]=q;u=h;return}case 4:{q=f[d+52>>2]|0;if(!q){w=f[a+12>>2]|0;do if(b[k>>0]|0){v=f[d+56>>2]|0;r=d;if(!v){E=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{E=r-(f[v+40>>2]|0)|0;break}}else E=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);F=w+(((E|0)/88|0)<<2)|0}else F=(f[a+12>>2]|0)+(((q-(f[(f[q+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;z=f[c+(f[F>>2]|0)+8>>2]|0;A=z+8+(e<<3)|0;v=z+8+(g<<3)|0;z=A;r=f[z>>2]|0;B=f[z+4>>2]|0;z=v;n=f[z+4>>2]|0;o=A;f[o>>2]=f[z>>2];f[o+4>>2]=n;n=v;f[n>>2]=r;f[n+4>>2]=B;u=h;return}case 5:{B=f[d+52>>2]|0;if(!B){n=f[a+12>>2]|0;do if(b[k>>0]|0){r=f[d+56>>2]|0;v=d;if(!r){G=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{G=v-(f[r+40>>2]|0)|0;break}}else G=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);H=n+(((G|0)/88|0)<<2)|0}else H=(f[a+12>>2]|0)+(((B-(f[(f[B+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;q=f[c+(f[H>>2]|0)+8>>2]|0;w=q+8+(e<<3)|0;r=q+8+(g<<3)|0;I=+p[w>>3];p[w>>3]=+p[r>>3];p[r>>3]=I;u=h;return}case 6:{r=f[d+52>>2]|0;if(!r){w=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;v=d;if(!q){J=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{J=v-(f[q+40>>2]|0)|0;break}}else J=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);K=w+(((J|0)/88|0)<<2)|0}else K=(f[a+12>>2]|0)+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;B=f[c+(f[K>>2]|0)+8>>2]|0;n=B+4+(e<<2)|0;q=B+4+(g<<2)|0;B=f[n>>2]|0;f[n>>2]=f[q>>2];f[q>>2]=B;u=h;return}case 7:{B=f[d+52>>2]|0;if(!B){q=f[a+12>>2]|0;do if(b[k>>0]|0){n=f[d+56>>2]|0;v=d;if(!n){L=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{L=v-(f[n+40>>2]|0)|0;break}}else L=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);M=q+(((L|0)/88|0)<<2)|0}else M=(f[a+12>>2]|0)+(((B-(f[(f[B+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;r=f[c+(f[M>>2]|0)+8>>2]|0;w=r+4+e|0;n=r+4+g|0;r=b[w>>0]|0;b[w>>0]=b[n>>0]|0;b[n>>0]=r;u=h;return}case 8:{r=f[d+52>>2]|0;if(!r){n=f[a+12>>2]|0;do if(b[k>>0]|0){w=f[d+56>>2]|0;v=d;if(!w){N=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{N=v-(f[w+40>>2]|0)|0;break}}else N=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);O=n+(((N|0)/88|0)<<2)|0}else O=(f[a+12>>2]|0)+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;B=f[c+(f[O>>2]|0)+8>>2]|0;q=B+4+(e<<2)|0;w=B+4+(g<<2)|0;B=f[q>>2]|0;f[q>>2]=f[w>>2];f[w>>2]=B;u=h;return}case 10:case 9:{B=f[l>>2]|0;if(B|0?(f[B>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(B,i)}if((f[m>>2]|0)==11?D3b(d)|0:0){B=f[d+52>>2]|0;if(!B){w=f[a+12>>2]|0;do if(b[k>>0]|0){q=f[d+56>>2]|0;v=d;if(!q){P=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{P=v-(f[q+40>>2]|0)|0;break}}else P=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);Q=w+(((P|0)/88|0)<<2)|0}else Q=(f[a+12>>2]|0)+(((B-(f[(f[B+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;r=(alc(c+(f[Q>>2]|0)|0)|0)+12|0;n=f[r>>2]|0;r=n+4+(e<<2)|0;q=n+4+(g<<2)|0;n=f[r>>2]|0;f[r>>2]=f[q>>2];f[q>>2]=n;u=h;return}n=f[d+52>>2]|0;if(!n){q=f[a+12>>2]|0;do if(b[k>>0]|0){r=f[d+56>>2]|0;v=d;if(!r){R=v-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{R=v-(f[r+40>>2]|0)|0;break}}else R=d-(f[(f[j>>2]|0)+20>>2]|0)|0;while(0);S=q+(((R|0)/88|0)<<2)|0}else S=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+52>>2]|0)<<2)|0;B=f[c+(f[S>>2]|0)+12>>2]|0;w=B+4+(e<<2)|0;r=B+4+(g<<2)|0;B=f[w>>2]|0;f[w>>2]=f[r>>2];f[r>>2]=B;u=h;return}default:{u=h;return}}while(0)}function _gc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=c+4|0;i=f[h>>2]|0;if((i|0)!=(g|0))f[h>>2]=i+(~((i+-4-g|0)>>>2)<<2);if((f[a+8>>2]|0)==(b|0)){u=d;return}g=f[a+20>>2]|0;i=(g|0)==-1?0:b+g|0;g=f[a+16>>2]|0;j=b+(f[a+32>>2]|0)|0;k=a+4|0;Lic(c,f[(f[k>>2]|0)+52>>2]|0);l=a+52|0;if((f[l>>2]|0)>=0){m=c+8|0;n=(i|0)==0;o=0;while(1){p=f[(f[k>>2]|0)+20>>2]|0;q=p+(o*88|0)|0;f[e>>2]=q;r=q;do if((f[p+(o*88|0)+32>>2]|0)==3){if((Qgc(a,b,q)|0)>0){s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){n1b(c,e);break}else{f[s>>2]=f[e>>2];f[h>>2]=(f[h>>2]|0)+4;break}}}else{s=f[p+(o*88|0)+52>>2]|0;if(s|0){if((f[j+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[p+(o*88|0)+40>>2]|0))break;s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){n1b(c,e);break}else{f[s>>2]=r;f[h>>2]=(f[h>>2]|0)+4;break}}if(n){if(!(Mic(a,b,q)|0))break;s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){n1b(c,e);break}else{f[s>>2]=f[e>>2];f[h>>2]=(f[h>>2]|0)+4;break}}else{s=f[g+(o<<2)>>2]|0;if(!(1<<(s&31)&f[i+(s>>>5<<2)>>2]))break;s=f[h>>2]|0;if((s|0)==(f[m>>2]|0)){n1b(c,e);break}else{f[s>>2]=r;f[h>>2]=(f[h>>2]|0)+4;break}}}while(0);if((o|0)<(f[l>>2]|0))o=o+1|0;else break}}o=f[a+28>>2]|0;if((o|0)!=-1)vgc(b+o|0,f[k>>2]|0,f[a+44>>2]|0,c);Nic(f[c>>2]|0,f[h>>2]|0);u=d;return}function $gc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499665,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499665,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=1)wic(f[i>>2]|0,d,499665,1);if(b[d+38>>0]|0){k=Brc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[d+80>>2]|0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function ahc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499656,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499656,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=2)wic(f[i>>2]|0,d,499656,2);if(b[d+38>>0]|0){i=d+80|0;g=Irc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[i>>2]|0,f[i+4>>2]|0)|0;k=J;l=g;J=k;u=e;return l|0}g=f[d+52>>2]|0;do if(g){i=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((i<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+i<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);h=m+(f[n>>2]|0)|0;k=f[h+4>>2]|0;l=f[h>>2]|0;J=k;u=e;return l|0}function bhc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499646,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499646,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=3)wic(f[i>>2]|0,d,499646,3);if(b[d+38>>0]|0){k=Orc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[d+80>>2]|0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function chc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499636,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499636,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=4)wic(f[i>>2]|0,d,499636,4);if(b[d+38>>0]|0){i=d+80|0;g=Urc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[i>>2]|0,f[i+4>>2]|0)|0;k=J;l=g;J=k;u=e;return l|0}g=f[d+52>>2]|0;do if(g){i=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((i<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+i<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);h=m+(f[n>>2]|0)|0;k=f[h+4>>2]|0;l=f[h>>2]|0;J=k;u=e;return l|0}function dhc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499627,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499627,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=6)wic(f[i>>2]|0,d,499627,6);if(b[d+38>>0]|0){k=+_rc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,+n[d+80>>2]);u=e;return +k}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=+n[l+(f[m>>2]|0)>>2];u=e;return +k}function ehc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499617,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499617,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=5)wic(f[i>>2]|0,d,499617,5);if(b[d+38>>0]|0){k=+esc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,+p[d+80>>3]);u=e;return +k}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=+p[l+(f[m>>2]|0)>>3];u=e;return +k}function fhc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499609,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499609,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=7)wic(f[i>>2]|0,d,499609,7);if(b[d+38>>0]|0){k=ksc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,(b[d+80>>0]|0)!=0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=(b[l+(f[m>>2]|0)>>0]|0)!=0;u=e;return k|0}function ghc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;i=e+48|0;j=c+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,e,499599,498554);if((f[e+32>>2]|0)==3)tic(f[j>>2]|0,e,499599,499313);k=f[e+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(k,h)}if((f[165644+(f[e+28>>2]<<2)>>2]|0)!=9)wic(f[j>>2]|0,e,499599,9);if(b[e+38>>0]|0){lYc(a,xsc(d+(f[c+28>>2]|0)|0,f[e+40>>2]|0,f[e+80>>2]|0)|0);u=g;return}j=f[e+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((h<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){l=d;m=(f[c+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{l=f[c+8>>2]|0;m=(f[c+12>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=d;m=(f[c+12>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);lYc(a,f[l+(f[m>>2]|0)>>2]|0);u=g;return}function hhc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=ihc(a,b,c)|0;return z3b(G3b(c)|0,d)|0}function ihc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499586,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499586,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=8)wic(f[i>>2]|0,d,499586,8);if(b[d+38>>0]|0){i=c+(f[a+28>>2]|0)|0;g=f[d+40>>2]|0;j=(E3b(d)|0)+8|0;k=ssc(i,g,f[j>>2]|0)|0;u=e;return k|0}j=f[d+52>>2]|0;do if(j){g=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function jhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499575,498554);if((f[d+32>>2]|0)==3)tic(f[j>>2]|0,d,499575,499313);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,d,499575,10);if(!e)l=f[a+48>>2]|0;else l=e;if(b[d+38>>0]|0){e=c+(f[a+28>>2]|0)|0;j=f[d+40>>2]|0;m=xgc(e,j,F3b(d)|0,l)|0;u=g;return m|0}l=f[d+52>>2]|0;do if(l){j=(l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((j<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){e=f[i>>2]|0;h=f[a+12>>2]|0;n=c;o=h+((f[e+52>>2]|0)+j<<2)|0;p=e;q=h;break}else{h=f[a+12>>2]|0;e=f[i>>2]|0;n=f[a+8>>2]|0;o=h+(((d-(f[e+20>>2]|0)|0)/88|0)<<2)|0;p=e;q=h;break}}else{h=f[a+12>>2]|0;e=f[i>>2]|0;n=c;o=h+(((d-(f[e+20>>2]|0)|0)/88|0)<<2)|0;p=e;q=h}while(0);c=f[n+(f[o>>2]|0)>>2]|0;if(c|0){m=c;u=g;return m|0}m=f[(f[a+8>>2]|0)+(f[q+(((d-(f[p+20>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;u=g;return m|0}function khc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tic(j,d,499556,498554);if((f[d+32>>2]|0)==3)tic(f[i>>2]|0,d,499556,499313);j=f[d+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(j,g)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=9)wic(f[i>>2]|0,d,499556,9);if(b[d+38>>0]|0){k=xsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,f[d+80>>2]|0)|0;u=e;return k|0}i=f[d+52>>2]|0;do if(i){g=(i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((g<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[h>>2]|0)+52>>2]|0)+g<<2)|0;break}else{l=f[a+8>>2]|0;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{l=c;m=(f[a+12>>2]|0)+(((d-(f[(f[h>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);k=f[l+(f[m>>2]|0)>>2]|0;u=e;return k|0}function lhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+8|0;i=g;f[i>>2]=e;e=a+4|0;j=f[e>>2]|0;if((f[d+48>>2]|0)!=(j|0))tic(j,d,499547,498554);if((f[d+32>>2]|0)==3)tic(f[e>>2]|0,d,499547,499313);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}k=d+28|0;if((f[165644+(f[k>>2]<<2)>>2]|0)!=1)wic(f[e>>2]|0,d,499547,1);if(!(b[d+38>>0]|0)){Eic(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(c,h)}Crc(e,a,f[k>>2]&255,f[i>>2]|0,d);u=g;return}function mhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=j;f[k>>2]=e;f[k+4>>2]=g;g=a+4|0;k=f[g>>2]|0;if((f[d+48>>2]|0)!=(k|0))tic(k,d,499538,498554);if((f[d+32>>2]|0)==3)tic(f[g>>2]|0,d,499538,499313);k=d+24|0;e=f[k>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(e,i)}e=d+28|0;if((f[165644+(f[e>>2]<<2)>>2]|0)!=2)wic(f[g>>2]|0,d,499538,2);if(!(b[d+38>>0]|0)){Kic(a,c,d,j);u=h;return}g=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(c,i)}i=j;Jrc(g,a,f[e>>2]&255,f[i>>2]|0,f[i+4>>2]|0,d);u=h;return}function nhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+8|0;i=g;f[i>>2]=e;e=a+4|0;j=f[e>>2]|0;if((f[d+48>>2]|0)!=(j|0))tic(j,d,499528,498554);if((f[d+32>>2]|0)==3)tic(f[e>>2]|0,d,499528,499313);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}k=d+28|0;if((f[165644+(f[k>>2]<<2)>>2]|0)!=3)wic(f[e>>2]|0,d,499528,3);if(!(b[d+38>>0]|0)){Jic(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(c,h)}Prc(e,a,f[k>>2]&255,f[i>>2]|0,d);u=g;return}function ohc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=j;f[k>>2]=e;f[k+4>>2]=g;g=a+4|0;k=f[g>>2]|0;if((f[d+48>>2]|0)!=(k|0))tic(k,d,499518,498554);if((f[d+32>>2]|0)==3)tic(f[g>>2]|0,d,499518,499313);k=d+24|0;e=f[k>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(e,i)}e=d+28|0;if((f[165644+(f[e>>2]<<2)>>2]|0)!=4)wic(f[g>>2]|0,d,499518,4);if(!(b[d+38>>0]|0)){Iic(a,c,d,j);u=h;return}g=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(c,i)}i=j;Vrc(g,a,f[e>>2]&255,f[i>>2]|0,f[i+4>>2]|0,d);u=h;return}function phc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;h=g+8|0;i=g;n[i>>2]=e;j=a+4|0;k=f[j>>2]|0;if((f[d+48>>2]|0)!=(k|0))tic(k,d,499509,498554);if((f[d+32>>2]|0)==3)tic(f[j>>2]|0,d,499509,499313);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=6)wic(f[j>>2]|0,d,499509,6);if(!(b[d+38>>0]|0)){Hic(a,c,d,i);u=g;return}j=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(c,h)}$rc(j,a,f[l>>2]&255,+n[i>>2],d);u=g;return}function qhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;h=g+8|0;i=g;p[i>>3]=e;j=a+4|0;k=f[j>>2]|0;if((f[d+48>>2]|0)!=(k|0))tic(k,d,499499,498554);if((f[d+32>>2]|0)==3)tic(f[j>>2]|0,d,499499,499313);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=5)wic(f[j>>2]|0,d,499499,5);if(!(b[d+38>>0]|0)){Gic(a,c,d,i);u=g;return}j=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(c,h)}fsc(j,a,f[l>>2]&255,+p[i>>3],d);u=g;return}function rhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g;i=g+16|0;b[i>>0]=e&1;e=a+4|0;j=f[e>>2]|0;if((f[d+48>>2]|0)!=(j|0))tic(j,d,499491,498554);if((f[d+32>>2]|0)==3)tic(f[e>>2]|0,d,499491,499313);j=d+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}k=d+28|0;if((f[165644+(f[k>>2]<<2)>>2]|0)!=7)wic(f[e>>2]|0,d,499491,7);if(!(b[d+38>>0]|0)){Fic(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(c,h)}lsc(e,a,f[k>>2]&255,(b[i>>0]|0)!=0,d);u=g;return}function shc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499481,498554);if((f[d+32>>2]|0)==3)tic(f[j>>2]|0,d,499481,499313);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=9)wic(f[j>>2]|0,d,499481,9);j=d+38|0;if(b[j>>0]|0){m=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[k>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(o,h)}oYc(ysc(m,n,f[l>>2]&255,d)|0,e)|0;u=g;return}l=a+12|0;n=f[l>>2]|0;m=d;h=f[(f[a+8>>2]|0)+(f[n+(((m-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;o=d+52|0;k=f[o>>2]|0;a:do if(!k){p=n;q=33}else{r=a+32|0;s=d+40|0;do if((f[c+((((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[r>>2]|0))>>2]|0)==(f[s>>2]|0)){t=k;v=n}else{Tgc(a,c,k);w=f[o>>2]|0;if(w|0){x=(w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((x<<2)+(f[r>>2]|0))>>2]=f[s>>2];y=f[l>>2]|0;f[c+(f[y+(x+(f[(f[i>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=h;t=w;v=y;break}y=f[a+20>>2]|0;if((y|0)==-1)z=b[j>>0]|0;else{w=f[a+16>>2]|0;x=b[j>>0]|0;do if(x<<24>>24){A=f[d+56>>2]|0;if(!A){B=(f[d+20>>2]|0)+80|0;break}else{B=A+40|0;break}}else B=(f[i>>2]|0)+20|0;while(0);A=f[w+(((m-(f[B>>2]|0)|0)/88|0)<<2)>>2]|0;C=c+y+(A>>>5<<2)|0;f[C>>2]=1<<(A&31)|f[C>>2];z=x}C=f[l>>2]|0;do if(z<<24>>24){A=f[d+56>>2]|0;if(!A){D=(f[d+20>>2]|0)+80|0;break}else{D=A+40|0;break}}else D=(f[i>>2]|0)+20|0;while(0);f[c+(f[C+(((m-(f[D>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]=h;p=C;q=33;break a}while(0);x=(t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((x<<2)+(f[r>>2]|0))>>2]=f[s>>2];E=c;F=v+(x+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0}while(0);if((q|0)==33){q=f[a+20>>2]|0;if((q|0)==-1)G=b[j>>0]|0;else{v=f[a+16>>2]|0;t=b[j>>0]|0;do if(t<<24>>24){j=f[d+56>>2]|0;if(!j){H=(f[d+20>>2]|0)+80|0;break}else{H=j+40|0;break}}else H=(f[i>>2]|0)+20|0;while(0);j=f[v+(((m-(f[H>>2]|0)|0)/88|0)<<2)>>2]|0;H=c+q+(j>>>5<<2)|0;f[H>>2]=1<<(j&31)|f[H>>2];G=t}do if(G<<24>>24){t=f[d+56>>2]|0;if(!t){I=(f[d+20>>2]|0)+80|0;break}else{I=t+40|0;break}}else I=(f[i>>2]|0)+20|0;while(0);E=c;F=p+(((m-(f[I>>2]|0)|0)/88|0)<<2)|0}I=E+(f[F>>2]|0)|0;F=f[E+(f[a+24>>2]|0)>>2]|0;a=F&-2;if(!(F&1))J=a;else J=f[a+4>>2]|0;a=f[I>>2]|0;if((a|0)==(h|0)){xJa(I,J,e);u=g;return}else{oYc(a,e)|0;u=g;return}}function thc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[d+12>>2]|0;if((e|0)!=(G3b(c)|0))Aic(f[a+4>>2]|0,c,499473,d);Dic(a,b,c,f[d+8>>2]|0);return}function uhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;k=a+4|0;l=f[k>>2]|0;if((f[d+48>>2]|0)!=(l|0))tic(l,d,499405,498554);if((f[d+32>>2]|0)==3)tic(f[k>>2]|0,d,499405,499313);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=8)wic(f[k>>2]|0,d,499405,8);if((f[(f[(f[k>>2]|0)+8>>2]|0)+44>>2]|0)==3){m=e;Dic(a,c,d,m);u=g;return}if(y3b(G3b(d)|0,e)|0){m=e;Dic(a,c,d,m);u=g;return}u_b(i,2,497294,1297);k=p_b(s_b(p_b(i,499418)|0,e)|0,498663)|0;r_b(j,q_b(k,f[d+4>>2]|0)|0);v_b(i);i=(E3b(d)|0)+8|0;m=f[i>>2]|0;Dic(a,c,d,m);u=g;return}function vhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499390,498554);if((f[d+32>>2]|0)==3)tic(f[j>>2]|0,d,499390,499313);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,d,499390,10);if(!e)l=f[a+48>>2]|0;else l=e;e=d+38|0;if(b[e>>0]|0){m=ygc(c+(f[a+28>>2]|0)|0,d,l)|0;u=g;return m|0}l=d+52|0;j=f[l>>2]|0;h=a+12|0;k=f[h>>2]|0;n=f[i>>2]|0;if(!j){o=c+(f[k+(((d-(f[n+20>>2]|0)|0)/88|0)<<2)>>2]|0)|0;p=f[a+20>>2]|0;if((p|0)==-1)q=o;else{r=f[(f[a+16>>2]|0)+(((d-(f[n+20>>2]|0)|0)/88|0)<<2)>>2]|0;s=c+p+(r>>>5<<2)|0;f[s>>2]=1<<(r&31)|f[s>>2];q=o}}else{o=a+32|0;s=d+40|0;if((f[c+((((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[o>>2]|0))>>2]|0)==(f[s>>2]|0))q=c+(f[k+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[n+52>>2]|0)<<2)>>2]|0)|0;else{Tgc(a,c,j);j=f[l>>2]|0;if(!j){l=f[a+20>>2]|0;if((l|0)==-1)t=b[e>>0]|0;else{n=f[a+16>>2]|0;k=b[e>>0]|0;do if(k<<24>>24){r=f[d+56>>2]|0;p=d;if(!r){v=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=p-(f[r+40>>2]|0)|0;break}}else v=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);r=f[n+(((v|0)/88|0)<<2)>>2]|0;v=c+l+(r>>>5<<2)|0;f[v>>2]=1<<(r&31)|f[v>>2];t=k}k=f[h>>2]|0;do if(t<<24>>24){v=f[d+56>>2]|0;r=d;if(!v){w=r-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{w=r-(f[v+40>>2]|0)|0;break}}else w=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);x=k+(((w|0)/88|0)<<2)|0;y=t;z=k}else{k=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;f[c+((k<<2)+(f[o>>2]|0))>>2]=f[s>>2];s=f[h>>2]|0;x=s+(k+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;y=b[e>>0]|0;z=s}s=c+(f[x>>2]|0)|0;x=f[a+8>>2]|0;do if(y<<24>>24){k=f[d+56>>2]|0;o=d;if(!k){A=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{A=o-(f[k+40>>2]|0)|0;break}}else A=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);y=f[x+(f[z+(((A|0)/88|0)<<2)>>2]|0)>>2]|0;A=f[(f[y>>2]|0)+16>>2]|0;z=_i[f[(f[c>>2]|0)+20>>2]&2047](c)|0;x=Mi[A&1023](y,z)|0;f[s>>2]=x;q=s}}s=f[q>>2]|0;if(s|0){m=s;u=g;return m|0}s=f[a+8>>2]|0;a=f[h>>2]|0;do if(b[e>>0]|0){h=f[d+56>>2]|0;x=d;if(!h){B=x-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{B=x-(f[h+40>>2]|0)|0;break}}else B=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);i=f[s+(f[a+(((B|0)/88|0)<<2)>>2]|0)>>2]|0;B=f[(f[i>>2]|0)+16>>2]|0;a=_i[f[(f[c>>2]|0)+20>>2]&2047](c)|0;c=Mi[B&1023](i,a)|0;f[q>>2]=c;m=c;u=g;return m|0}function whc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(c|0?(e=_i[f[(f[c>>2]|0)+20>>2]&2047](c)|0,(e|0)!=(_i[f[(f[b>>2]|0)+20>>2]&2047](b)|0)):0){if((_i[f[(f[c>>2]|0)+20>>2]&2047](c)|0)==0?_i[f[(f[b>>2]|0)+20>>2]&2047](b)|0:0){fgc(_i[f[(f[b>>2]|0)+20>>2]&2047](b)|0,c);Cic(a,b,c,d);return}e=vhc(a,b,d,0)|0;mi[f[(f[e>>2]|0)+72>>2]&2047](e,c);return}Cic(a,b,c,d);return}function xhc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=Bic(a,b,c,d)|0;d=f[b+(f[a+24>>2]|0)>>2]|0;a=d&-2;if(!(d&1))g=a;else g=f[a+4>>2]|0;if(!((e|0)!=0&(g|0)!=0)){h=e;return h|0}g=_i[f[(f[e>>2]|0)+12>>2]&2047](e)|0;mi[f[(f[g>>2]|0)+72>>2]&2047](g,e);h=g;return h|0}function yhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499281,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499281,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=1)wic(f[j>>2]|0,d,499281,1);if(b[d+38>>0]|0){l=Erc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function zhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499264,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499264,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=2)wic(f[j>>2]|0,d,499264,2);if(b[d+38>>0]|0){j=Krc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;l=J;m=j;J=l;u=g;return m|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){n=c;o=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{n=f[a+8>>2]|0;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{n=c;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);i=(f[n+(f[o>>2]|0)+8>>2]|0)+8+(e<<3)|0;l=f[i+4>>2]|0;m=f[i>>2]|0;J=l;u=g;return m|0}function Ahc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499246,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499246,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=3)wic(f[j>>2]|0,d,499246,3);if(b[d+38>>0]|0){l=Qrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function Bhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499228,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499228,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=4)wic(f[j>>2]|0,d,499228,4);if(b[d+38>>0]|0){j=Wrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;l=J;m=j;J=l;u=g;return m|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){n=c;o=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{n=f[a+8>>2]|0;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{n=c;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);i=(f[n+(f[o>>2]|0)+8>>2]|0)+8+(e<<3)|0;l=f[i+4>>2]|0;m=f[i>>2]|0;J=l;u=g;return m|0}function Chc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499211,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499211,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=6)wic(f[j>>2]|0,d,499211,6);if(b[d+38>>0]|0){l=+asc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e);u=g;return +l}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;o=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;o=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=+n[(f[m+(f[o>>2]|0)+8>>2]|0)+4+(e<<2)>>2];u=g;return +l}function Dhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499193,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499193,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=5)wic(f[j>>2]|0,d,499193,5);if(b[d+38>>0]|0){l=+gsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e);u=g;return +l}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=+p[(f[m+(f[n>>2]|0)+8>>2]|0)+8+(e<<3)>>3];u=g;return +l}function Ehc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499177,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499177,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=7)wic(f[j>>2]|0,d,499177,7);if(b[d+38>>0]|0){l=msc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=(b[(f[m+(f[n>>2]|0)+8>>2]|0)+4+e>>0]|0)!=0;u=g;return l|0}function Fhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=e+48|0;k=c+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,e,499159,498554);if((f[e+32>>2]|0)!=3)tic(f[k>>2]|0,e,499159,498006);l=f[e+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=e;J_b(l,i)}if((f[165644+(f[e+28>>2]<<2)>>2]|0)!=9)wic(f[k>>2]|0,e,499159,9);if(b[e+38>>0]|0){lYc(a,zsc(d+(f[c+28>>2]|0)|0,f[e+40>>2]|0,g)|0);u=h;return}k=f[e+52>>2]|0;do if(k){i=(k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((i<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){m=d;n=(f[c+12>>2]|0)+((f[(f[j>>2]|0)+52>>2]|0)+i<<2)|0;break}else{m=f[c+8>>2]|0;n=(f[c+12>>2]|0)+(((e-(f[(f[j>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=d;n=(f[c+12>>2]|0)+(((e-(f[(f[j>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);lYc(a,f[(f[m+(f[n>>2]|0)+12>>2]|0)+4+(g<<2)>>2]|0);u=h;return}function Ghc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Hhc(a,b,c,d)|0;return z3b(G3b(c)|0,e)|0}function Hhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499138,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499138,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=8)wic(f[j>>2]|0,d,499138,8);if(b[d+38>>0]|0){l=usc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function Ihc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499119,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499119,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,d,499119,10);j=d+38|0;if(b[j>>0]|0){m=Esc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return m|0}n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(n,h)}if((f[l>>2]|0)==11?D3b(d)|0:0){l=f[d+52>>2]|0;do if(!l){h=f[a+12>>2]|0;do if(b[j>>0]|0){n=f[d+56>>2]|0;k=d;if(!n){o=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=k-(f[n+40>>2]|0)|0;break}}else o=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=c;q=h+(((o|0)/88|0)<<2)|0}else{n=(l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((n<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){p=c;q=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+n<<2)|0;break}n=f[a+8>>2]|0;k=f[a+12>>2]|0;do if(b[j>>0]|0){r=f[d+56>>2]|0;s=d;if(!r){t=s-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{t=s-(f[r+40>>2]|0)|0;break}}else t=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=n;q=k+(((t|0)/88|0)<<2)|0}while(0);t=($kc(p+(f[q>>2]|0)|0)|0)+12|0;m=f[(f[t>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}t=f[d+52>>2]|0;do if(!t){q=f[a+12>>2]|0;do if(b[j>>0]|0){p=f[d+56>>2]|0;l=d;if(!p){v=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=l-(f[p+40>>2]|0)|0;break}}else v=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);w=c;x=q+(((v|0)/88|0)<<2)|0}else{k=(t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((k<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){w=c;x=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+k<<2)|0;break}k=f[a+8>>2]|0;n=f[a+12>>2]|0;do if(b[j>>0]|0){p=f[d+56>>2]|0;l=d;if(!p){y=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{y=l-(f[p+40>>2]|0)|0;break}}else y=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);w=k;x=n+(((y|0)/88|0)<<2)|0}while(0);m=f[(f[w+(f[x>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}function Jhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499092,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,499092,498006);k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=9)wic(f[j>>2]|0,d,499092,9);if(b[d+38>>0]|0){l=zsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return l|0}j=f[d+52>>2]|0;do if(j){h=(j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((h<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[i>>2]|0)+52>>2]|0)+h<<2)|0;break}else{m=f[a+8>>2]|0;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0;break}}else{m=c;n=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);l=f[(f[m+(f[n>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;u=g;return l|0}function Khc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,499075,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,499075,498006);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(l,i)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=1)wic(f[k>>2]|0,d,499075,1);if(b[d+38>>0]|0){Frc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;u=h;return}function Lhc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+16|0;j=i;k=d+48|0;l=a+4|0;m=f[l>>2]|0;if((f[k>>2]|0)!=(m|0))tic(m,d,499058,498554);if((f[d+32>>2]|0)!=3)tic(f[l>>2]|0,d,499058,498006);m=f[d+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(m,j)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=2)wic(f[l>>2]|0,d,499058,2);if(b[d+38>>0]|0){Lrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g,h);u=i;return}l=f[d+52>>2]|0;j=f[k>>2]|0;if(!l)n=(d-(f[j+20>>2]|0)|0)/88|0;else n=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[j+52>>2]|0)|0;j=(f[c+(f[(f[a+12>>2]|0)+(n<<2)>>2]|0)+8>>2]|0)+8+(e<<3)|0;f[j>>2]=g;f[j+4>>2]=h;u=i;return}function Mhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,499040,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,499040,498006);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(l,i)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=3)wic(f[k>>2]|0,d,499040,3);if(b[d+38>>0]|0){Rrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;u=h;return}function Nhc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+16|0;j=i;k=d+48|0;l=a+4|0;m=f[l>>2]|0;if((f[k>>2]|0)!=(m|0))tic(m,d,499022,498554);if((f[d+32>>2]|0)!=3)tic(f[l>>2]|0,d,499022,498006);m=f[d+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(m,j)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=4)wic(f[l>>2]|0,d,499022,4);if(b[d+38>>0]|0){Xrc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g,h);u=i;return}l=f[d+52>>2]|0;j=f[k>>2]|0;if(!l)n=(d-(f[j+20>>2]|0)|0)/88|0;else n=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[j+52>>2]|0)|0;j=(f[c+(f[(f[a+12>>2]|0)+(n<<2)>>2]|0)+8>>2]|0)+8+(e<<3)|0;f[j>>2]=g;f[j+4>>2]=h;u=i;return}function Ohc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,499005,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,499005,498006);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(l,i)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=6)wic(f[k>>2]|0,d,499005,6);if(b[d+38>>0]|0){bsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;n[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;u=h;return}function Phc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,498987,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,498987,498006);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(l,i)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=5)wic(f[k>>2]|0,d,498987,5);if(b[d+38>>0]|0){hsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;p[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+8+(e<<3)>>3]=g;u=h;return}function Qhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,498971,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,498971,498006);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(l,i)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=7)wic(f[k>>2]|0,d,498971,7);if(b[d+38>>0]|0){nsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,g);u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;b[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+8>>2]|0)+4+e>>0]=g&1;u=h;return}function Rhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,498953,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,498953,498006);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(l,i)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=9)wic(f[k>>2]|0,d,498953,9);if(b[d+38>>0]|0){oYc(Asc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0,g)|0;u=h;return}k=f[d+52>>2]|0;i=f[j>>2]|0;if(!k)m=(d-(f[i+20>>2]|0)|0)/88|0;else m=((k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;oYc(f[(f[c+(f[(f[a+12>>2]|0)+(m<<2)>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0,g)|0;u=h;return}function Shc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[g+12>>2]|0;if((h|0)!=(G3b(d)|0))Aic(f[a+4>>2]|0,d,498873,g);h=f[g+8>>2]|0;if(b[d+38>>0]|0){vsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,h);return}g=f[d+52>>2]|0;i=f[d+48>>2]|0;if(!g)j=(d-(f[i+20>>2]|0)|0)/88|0;else j=((g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(j<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=h;return}function Thc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+48|0;i=h+24|0;j=h;k=h+40|0;l=d+48|0;m=a+4|0;n=f[m>>2]|0;if((f[l>>2]|0)!=(n|0))tic(n,d,498873,498554);if((f[d+32>>2]|0)!=3)tic(f[m>>2]|0,d,498873,498006);n=f[d+24>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(n,i)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=8)wic(f[m>>2]|0,d,498873,8);if((f[(f[(f[m>>2]|0)+8>>2]|0)+44>>2]|0)!=3?(y3b(G3b(d)|0,g)|0)==0:0){u_b(j,2,497294,1358);m=p_b(s_b(p_b(p_b(j,498889)|0,498946)|0,g)|0,498663)|0;r_b(k,q_b(m,f[d+4>>2]|0)|0);v_b(j);j=(E3b(d)|0)+8|0;o=f[j>>2]|0}else o=g;if(b[d+38>>0]|0){vsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e,o);u=h;return}g=f[d+52>>2]|0;j=f[l>>2]|0;if(!g)p=(d-(f[j+20>>2]|0)|0)/88|0;else p=((g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[j+52>>2]|0)|0;f[(f[c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=o;u=h;return}function Uhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498850,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498850,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,d,498850,10);j=d+38|0;if(b[j>>0]|0){m=Fsc(c+(f[a+28>>2]|0)|0,f[d+40>>2]|0,e)|0;u=g;return m|0}n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(n,h)}if((f[l>>2]|0)==11?D3b(d)|0:0){l=f[d+52>>2]|0;if(!l){h=f[a+12>>2]|0;do if(b[j>>0]|0){n=f[d+56>>2]|0;k=d;if(!n){o=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=k-(f[n+40>>2]|0)|0;break}}else o=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=h+(((o|0)/88|0)<<2)|0}else p=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;l=(alc(c+(f[p>>2]|0)|0)|0)+12|0;m=f[(f[l>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}l=f[d+52>>2]|0;if(!l){p=f[a+12>>2]|0;do if(b[j>>0]|0){o=f[d+56>>2]|0;h=d;if(!o){q=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=h-(f[o+40>>2]|0)|0;break}}else q=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);r=p+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;m=f[(f[c+(f[r>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;u=g;return m|0}function Vhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498841,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498841,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=1)wic(f[j>>2]|0,d,498841,1);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(n,h)}Grc(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)o=(d-(f[m+20>>2]|0)|0)/88|0;else o=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(o<<2)>>2]|0)|0;o=f[m>>2]|0;if((o|0)==(f[m+4>>2]|0)){qHa(m,o+1|0);p=f[m>>2]|0}else p=o;o=f[m+8>>2]|0;f[m>>2]=p+1;f[o+4+(p<<2)>>2]=e;u=g;return}function Whc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,498832,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,498832,498006);l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(m,i)}m=d+28|0;if((f[165644+(f[m>>2]<<2)>>2]|0)!=2)wic(f[k>>2]|0,d,498832,2);if(b[d+38>>0]|0){k=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(o,i)}Mrc(k,n,f[m>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,g,d);u=h;return}m=f[d+52>>2]|0;n=f[j>>2]|0;if(!m)p=(d-(f[n+20>>2]|0)|0)/88|0;else p=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[n+52>>2]|0)|0;n=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[n>>2]|0;if((p|0)==(f[n+4>>2]|0)){_Ma(n,p+1|0);q=f[n>>2]|0}else q=p;p=f[n+8>>2]|0;f[n>>2]=q+1;n=p+8+(q<<3)|0;f[n>>2]=e;f[n+4>>2]=g;u=h;return}function Xhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498822,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498822,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=3)wic(f[j>>2]|0,d,498822,3);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(n,h)}Src(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)o=(d-(f[m+20>>2]|0)|0)/88|0;else o=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(o<<2)>>2]|0)|0;o=f[m>>2]|0;if((o|0)==(f[m+4>>2]|0)){xHa(m,o+1|0);p=f[m>>2]|0}else p=o;o=f[m+8>>2]|0;f[m>>2]=p+1;f[o+4+(p<<2)>>2]=e;u=g;return}function Yhc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,498812,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,498812,498006);l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(m,i)}m=d+28|0;if((f[165644+(f[m>>2]<<2)>>2]|0)!=4)wic(f[k>>2]|0,d,498812,4);if(b[d+38>>0]|0){k=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(o,i)}Yrc(k,n,f[m>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,g,d);u=h;return}m=f[d+52>>2]|0;n=f[j>>2]|0;if(!m)p=(d-(f[n+20>>2]|0)|0)/88|0;else p=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[n+52>>2]|0)|0;n=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[n>>2]|0;if((p|0)==(f[n+4>>2]|0)){mob(n,p+1|0);q=f[n>>2]|0}else q=p;p=f[n+8>>2]|0;f[n>>2]=q+1;n=p+8+(q<<3)|0;f[n>>2]=e;f[n+4>>2]=g;u=h;return}function Zhc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498803,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498803,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=6)wic(f[j>>2]|0,d,498803,6);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;o=f[k>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(o,h)}csc(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)p=(d-(f[m+20>>2]|0)|0)/88|0;else p=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[m>>2]|0;if((p|0)==(f[m+4>>2]|0)){uHa(m,p+1|0);q=f[m>>2]|0}else q=p;p=f[m+8>>2]|0;f[m>>2]=q+1;n[p+4+(q<<2)>>2]=e;u=g;return}function _hc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498793,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498793,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=5)wic(f[j>>2]|0,d,498793,5);if(b[d+38>>0]|0){j=c+(f[a+28>>2]|0)|0;m=f[d+40>>2]|0;n=f[k>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(n,h)}isc(j,m,f[l>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}l=f[d+52>>2]|0;m=f[i>>2]|0;if(!l)o=(d-(f[m+20>>2]|0)|0)/88|0;else o=((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(o<<2)>>2]|0)|0;o=f[m>>2]|0;if((o|0)==(f[m+4>>2]|0)){ZMa(m,o+1|0);q=f[m>>2]|0}else q=o;o=f[m+8>>2]|0;f[m>>2]=q+1;p[o+8+(q<<3)>>3]=e;u=g;return}function $hc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=e&1;j=d+48|0;k=a+4|0;l=f[k>>2]|0;if((f[j>>2]|0)!=(l|0))tic(l,d,498785,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,498785,498006);l=d+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(m,h)}m=d+28|0;if((f[165644+(f[m>>2]<<2)>>2]|0)!=7)wic(f[k>>2]|0,d,498785,7);if(b[d+38>>0]|0){k=c+(f[a+28>>2]|0)|0;n=f[d+40>>2]|0;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(o,h)}osc(k,n,f[m>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}e=f[d+52>>2]|0;m=f[j>>2]|0;if(!e)p=(d-(f[m+20>>2]|0)|0)/88|0;else p=((e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;m=c+(f[(f[a+12>>2]|0)+(p<<2)>>2]|0)|0;p=f[m>>2]|0;if((p|0)==(f[m+4>>2]|0)){wSa(m,p+1|0);q=f[m>>2]|0}else q=p;p=f[m+8>>2]|0;f[m>>2]=q+1;b[p+4+q>>0]=i;u=g;return}function aic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498775,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498775,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=9)wic(f[j>>2]|0,d,498775,9);if(!(b[d+38>>0]|0)){j=f[d+52>>2]|0;m=f[i>>2]|0;if(!j)n=(d-(f[m+20>>2]|0)|0)/88|0;else n=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[m+52>>2]|0)|0;oYc(pHa(c+(f[(f[a+12>>2]|0)+(n<<2)>>2]|0)|0)|0,e)|0;u=g;return}else{n=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[k>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(c,h)}oYc(Bsc(n,a,f[l>>2]&255,d)|0,e)|0;u=g;return}}function bic(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[d+12>>2]|0;if((e|0)!=(G3b(c)|0))Aic(f[a+4>>2]|0,c,498600,d);zic(a,b,c,f[d+8>>2]|0);return}function cic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;k=a+4|0;l=f[k>>2]|0;if((f[d+48>>2]|0)!=(l|0))tic(l,d,498600,498554);if((f[d+32>>2]|0)!=3)tic(f[k>>2]|0,d,498600,498006);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=8)wic(f[k>>2]|0,d,498600,8);if((f[(f[(f[k>>2]|0)+8>>2]|0)+44>>2]|0)==3){m=e;zic(a,c,d,m);u=g;return}if(y3b(G3b(d)|0,e)|0){m=e;zic(a,c,d,m);u=g;return}u_b(i,2,497294,1399);k=p_b(s_b(p_b(i,498608)|0,e)|0,498663)|0;r_b(j,q_b(k,f[d+4>>2]|0)|0);v_b(i);i=(E3b(d)|0)+8|0;m=f[i>>2]|0;zic(a,c,d,m);u=g;return}function dic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498589,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498589,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,d,498589,10);if(!e)m=f[a+48>>2]|0;else m=e;e=d+38|0;if(b[e>>0]|0){n=Cgc(c+(f[a+28>>2]|0)|0,d,m)|0;u=g;return n|0}j=f[k>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(j,h)}if((f[l>>2]|0)==11?D3b(d)|0:0){l=f[d+52>>2]|0;if(!l){h=f[a+12>>2]|0;do if(b[e>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){o=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=k-(f[j+40>>2]|0)|0;break}}else o=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);p=h+(((o|0)/88|0)<<2)|0}else p=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;q=alc(c+(f[p>>2]|0)|0)|0}else{p=f[d+52>>2]|0;if(!p){l=f[a+12>>2]|0;do if(b[e>>0]|0){o=f[d+56>>2]|0;h=d;if(!o){r=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=h-(f[o+40>>2]|0)|0;break}}else r=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);s=l+(((r|0)/88|0)<<2)|0}else s=(f[a+12>>2]|0)+(((p-(f[(f[p+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;q=c+(f[s>>2]|0)|0}s=q+12|0;i=f[s>>2]|0;p=q+4|0;a=f[p>>2]|0;if((i|0)!=0?(a|0)<(f[i>>2]|0):0){r=a+1|0;f[p>>2]=r;l=f[i+4+(a<<2)>>2]|0;if(!l)t=r;else{n=l;u=g;return n|0}}else t=a;if(!t){t=f[(f[m>>2]|0)+8>>2]|0;a=F3b(d)|0;v=Mi[t&1023](m,a)|0}else v=f[i+4>>2]|0;i=f[(f[v>>2]|0)+16>>2]|0;a=_i[f[(f[c>>2]|0)+20>>2]&2047](c)|0;c=Mi[i&1023](v,a)|0;a=f[s>>2]|0;v=f[q+8>>2]|0;do if((a|0)!=0?(i=f[p>>2]|0,(i|0)!=(v|0)):0){m=f[a>>2]|0;if((m|0)==(v|0)){t=f[a+4+(i<<2)>>2]|0;if((t|0)==0|(f[q>>2]|0)!=0){w=a;break}Yi[f[(f[t>>2]|0)+4>>2]&4095](t);w=f[s>>2]|0;break}if((i|0)<(m|0)){f[a+4+(m<<2)>>2]=f[a+4+(i<<2)>>2];i=f[s>>2]|0;x=i;y=f[i>>2]|0}else{x=a;y=m}f[x>>2]=y+1;w=x}else z=45;while(0);if((z|0)==45){XZb(q,v+1|0);v=f[s>>2]|0;f[v>>2]=(f[v>>2]|0)+1;w=v}v=f[p>>2]|0;f[p>>2]=v+1;f[w+4+(v<<2)>>2]=c;n=c;u=g;return n|0}function eic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,498534,498554);if((f[d+32>>2]|0)!=3)tic(f[j>>2]|0,d,498534,498006);k=d+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,d,498534,10);j=d+38|0;if(b[j>>0]|0){Egc(c+(f[a+28>>2]|0)|0,d,e);u=g;return}m=f[k>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(m,h)}if((f[l>>2]|0)==11?D3b(d)|0:0){l=f[d+52>>2]|0;if(!l){h=f[a+12>>2]|0;do if(b[j>>0]|0){m=f[d+56>>2]|0;k=d;if(!m){n=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=k-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);o=h+(((n|0)/88|0)<<2)|0}else o=(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;p=alc(c+(f[o>>2]|0)|0)|0}else{o=f[d+52>>2]|0;if(!o){l=f[a+12>>2]|0;do if(b[j>>0]|0){n=f[d+56>>2]|0;h=d;if(!n){q=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=h-(f[n+40>>2]|0)|0;break}}else q=d-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);r=l+(((q|0)/88|0)<<2)|0}else r=(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;p=c+(f[r>>2]|0)|0}r=Loc(e)|0;c=f[p>>2]|0;if(((c|0)==(r|0)?(r=p+12|0,i=f[r>>2]|0,i|0):0)?(o=f[i>>2]|0,(o|0)<(f[p+8>>2]|0)):0){a=p+4|0;q=f[a>>2]|0;if((q|0)<(o|0)){l=i+4+(q<<2)|0;f[i+4+(o<<2)>>2]=f[l>>2];s=l}else s=i+4+(q<<2)|0;f[s>>2]=e;f[a>>2]=q+1;q=f[r>>2]|0;f[q>>2]=(f[q>>2]|0)+1;u=g;return}xic(p,e,Koc(e)|0,c);u=g;return}function fic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;if((f[a+28>>2]|0)==-1){g=0;u=d;return g|0}h=a+44|0;i=p3b(f[h>>2]|0,c)|0;if(i){j=a+4|0;k=f[j>>2]|0;if((f[i+48>>2]|0)==(k|0)){g=i;u=d;return g|0}else{l=j;m=k}}else{k=a+4|0;l=k;m=f[k>>2]|0}if(!(b[(f[m+16>>2]|0)+48>>0]|0)){g=0;u=d;return g|0}m=o3b(f[h>>2]|0,c)|0;if(!m){g=0;u=d;return g|0}c=f[m+72>>2]|0;if((c|0)<=0){g=0;u=d;return g|0}h=m+40|0;k=e+4|0;a=e+8|0;j=e+12|0;i=0;while(1){n=f[h>>2]|0;o=n+(i*88|0)|0;if((f[n+(i*88|0)+48>>2]|0)==(f[l>>2]|0)){p=f[n+(i*88|0)+24>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[e>>2]=80424;f[k>>2]=2231;b[a>>0]=0;f[j>>2]=o;J_b(p,e)}if(((f[n+(i*88|0)+28>>2]|0)==11?(f[n+(i*88|0)+32>>2]|0)==1:0)?(F3b(o)|0)==(m|0):0){g=o;q=17;break}}i=i+1|0;if((i|0)>=(c|0)){g=0;q=17;break}}if((q|0)==17){u=d;return g|0}return 0}function gic(a,b){a=a|0;b=b|0;var c=0;if((f[a+28>>2]|0)==-1){c=0;return c|0}c=q3b(f[a+44>>2]|0,f[a+4>>2]|0,b)|0;return c|0}function hic(a){a=a|0;return (f[(f[(f[a+4>>2]|0)+8>>2]|0)+44>>2]|0)==3|0}function iic(a){a=a|0;return f[a+48>>2]|0}function jic(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+80|0;j=i+48|0;k=i+24|0;l=i+65|0;m=i;n=i+64|0;if((f[d+32>>2]|0)!=3)tic(f[a+4>>2]|0,d,498484,498006);o=d+24|0;p=f[o>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(p,j)}p=d+28|0;if((f[165644+(f[p>>2]<<2)>>2]|0)!=(e|0))wic(f[a+4>>2]|0,d,498510,e);if((g|0)>-1?(f[(f[d+68>>2]|0)+48>>2]|0)!=(g|0):0){u_b(k,3,497294,1692);r_b(l,p_b(p_b(k,498083)|0,498137)|0);v_b(k)}if(h|0?(F3b(d)|0)!=(h|0):0){u_b(m,3,497294,1694);r_b(n,p_b(p_b(m,498154)|0,498204)|0);v_b(m)}m=d+38|0;if(b[m>>0]|0){n=c+(f[a+28>>2]|0)|0;h=f[d+40>>2]|0;k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(k,j)}k=f[p>>2]&255;q=qsc(n,h,k,H3b(d)|0,d)|0;u=i;return q|0}k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(k,j)}if((f[p>>2]|0)==11?D3b(d)|0:0){p=f[a+12>>2]|0;do if(b[m>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){r=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=k-(f[j+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=alc(c+(f[p+(((r|0)/88|0)<<2)>>2]|0)|0)|0;u=i;return q|0}r=f[a+12>>2]|0;do if(b[m>>0]|0){a=f[d+56>>2]|0;p=d;if(!a){s=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=p-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[r+(((s|0)/88|0)<<2)>>2]|0)|0;u=i;return q|0}function kic(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+80|0;j=i+48|0;k=i+24|0;l=i+65|0;m=i;n=i+64|0;if((f[d+32>>2]|0)!=3)tic(f[a+4>>2]|0,d,497984,498006);o=d+24|0;p=f[o>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(p,j)}p=d+28|0;if((f[165644+(f[p>>2]<<2)>>2]|0)!=(e|0))wic(f[a+4>>2]|0,d,498063,e);if((g|0)>-1?(f[(f[d+68>>2]|0)+48>>2]|0)!=(g|0):0){u_b(k,3,497294,1717);r_b(l,p_b(p_b(k,498083)|0,498137)|0);v_b(k)}if(h|0?(F3b(d)|0)!=(h|0):0){u_b(m,3,497294,1719);r_b(n,p_b(p_b(m,498154)|0,498204)|0);v_b(m)}m=d+38|0;if(b[m>>0]|0){n=c+(f[a+28>>2]|0)|0;h=f[d+40>>2]|0;k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(k,j)}k=f[p>>2]&255;q=qsc(n,h,k,H3b(d)|0,d)|0;u=i;return q|0}k=f[o>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[j>>2]=80424;f[j+4>>2]=2231;b[j+8>>0]=0;f[j+12>>2]=d;J_b(k,j)}if((f[p>>2]|0)==11?D3b(d)|0:0){p=f[a+12>>2]|0;do if(b[m>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){r=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=k-(f[j+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=$kc(c+(f[p+(((r|0)/88|0)<<2)>>2]|0)|0)|0;u=i;return q|0}r=f[a+12>>2]|0;do if(b[m>>0]|0){a=f[d+56>>2]|0;p=d;if(!a){s=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=p-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[r+(((s|0)/88|0)<<2)>>2]|0)|0;u=i;return q|0}function lic(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+96|0;i=h+72|0;j=h+48|0;k=h+24|0;l=h+89|0;m=h;n=h+88|0;if((f[d+32>>2]|0)!=3){u_b(j,3,497294,2183);r_b(h+90|0,p_b(j,503122)|0);v_b(j)}j=d+24|0;o=f[j>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(o,i)}o=d+28|0;if((f[165644+(f[o>>2]<<2)>>2]|0)!=(e|0)){p=f[j>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(p,i)}if(!((e|0)==1?(f[165644+(f[o>>2]<<2)>>2]|0)==8:0)){u_b(k,3,497294,2186);r_b(l,p_b(p_b(p_b(p_b(k,497634)|0,497782)|0,497845)|0,497910)|0);v_b(k)}}if(g|0?(F3b(d)|0)!=(g|0):0){u_b(m,3,497294,2191);r_b(n,p_b(m,497926)|0);v_b(m)}if(!(b[d+38>>0]|0)){q=c+(f[(f[a+12>>2]|0)+(((d-(f[(f[d+48>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0)|0;u=h;return q|0}m=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[j>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(c,i)}i=f[o>>2]&255;q=qsc(m,a,i,H3b(d)|0,d)|0;u=h;return q|0}function mic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;h=g;i=f[d+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(i,h)}if(!((f[d+28>>2]|0)==11?D3b(d)|0:0))tic(f[a+4>>2]|0,d,497617,497268);h=f[d+52>>2]|0;if(!h){i=f[a+12>>2]|0;do if(b[d+38>>0]|0){j=f[d+56>>2]|0;k=d;if(!j){l=k-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{l=k-(f[j+40>>2]|0)|0;break}}else l=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);m=c;n=i+(((l|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=Mi[s&1023](p,e)|0;u=g;return t|0}l=(h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((l<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){m=c;n=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+l<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=Mi[s&1023](p,e)|0;u=g;return t|0}l=f[a+8>>2]|0;c=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;h=d;if(!a){v=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=h-(f[a+40>>2]|0)|0;break}}else v=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);m=l;n=c+(((v|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=Mi[s&1023](p,e)|0;u=g;return t|0}function nic(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+32|0;i=h+16|0;j=h;k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=d;J_b(k,i)}if(!((f[d+28>>2]|0)==11?D3b(d)|0:0))tic(f[a+4>>2]|0,d,497592,497268);k=F3b(d)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;l=j+11|0;b[l>>0]=5;b[j>>0]=b[502066]|0;b[j+1>>0]=b[502067]|0;b[j+2>>0]=b[502068]|0;b[j+3>>0]=b[502069]|0;b[j+4>>0]=b[502070]|0;b[j+5>>0]=0;m=w3b(k,j)|0;k=f[m+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=m;J_b(k,i)}f[g+4>>2]=f[165644+(f[m+28>>2]<<2)>>2];if((b[l>>0]|0)<0)cYc(f[j>>2]|0);j=f[d+52>>2]|0;if(j|0){n=(f[a+12>>2]|0)+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)|0;o=f[n>>2]|0;p=c+o|0;q=f[p>>2]|0;r=q+12|0;s=f[r>>2]|0;t=hj[s&511](p,e,g)|0;u=h;return t|0}j=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){v=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=l-(f[a+40>>2]|0)|0;break}}else v=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);n=j+(((v|0)/88|0)<<2)|0;o=f[n>>2]|0;p=c+o|0;q=f[p>>2]|0;r=q+12|0;s=f[r>>2]|0;t=hj[s&511](p,e,g)|0;u=h;return t|0}function oic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=f[d+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(i,h)}if(!((f[d+28>>2]|0)==11?D3b(d)|0:0))tic(f[a+4>>2]|0,d,497575,497268);h=f[d+52>>2]|0;if(h|0){j=(f[a+12>>2]|0)+(((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)|0;k=f[j>>2]|0;l=c+k|0;m=f[l>>2]|0;n=m+16|0;o=f[n>>2]|0;p=Mi[o&1023](l,e)|0;u=g;return p|0}h=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;i=d;if(!a){q=i-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=i-(f[a+40>>2]|0)|0;break}}else q=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);j=h+(((q|0)/88|0)<<2)|0;k=f[j>>2]|0;l=c+k|0;m=f[l>>2]|0;n=m+16|0;o=f[n>>2]|0;p=Mi[o&1023](l,e)|0;u=g;return p|0}function pic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;i=f[e+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(i,h)}if(!((f[e+28>>2]|0)==11?D3b(e)|0:0))tic(f[c+4>>2]|0,e,497564,497268);uic(a,d,e);h=f[e+52>>2]|0;if(!h){i=f[c+12>>2]|0;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;k=e;if(!j){l=k-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{l=k-(f[j+40>>2]|0)|0;break}}else l=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=d;n=i+(((l|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+24|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=(h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((l<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){m=d;n=(f[c+12>>2]|0)+((f[(f[e+48>>2]|0)+52>>2]|0)+l<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+24|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=f[c+8>>2]|0;d=f[c+12>>2]|0;do if(b[e+38>>0]|0){c=f[e+56>>2]|0;h=e;if(!c){t=h-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{t=h-(f[c+40>>2]|0)|0;break}}else t=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=l;n=d+(((t|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+24|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}function qic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;i=f[e+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(i,h)}if(!((f[e+28>>2]|0)==11?D3b(e)|0:0))tic(f[c+4>>2]|0,e,497555,497268);uic(a,d,e);h=f[e+52>>2]|0;if(!h){i=f[c+12>>2]|0;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;k=e;if(!j){l=k-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{l=k-(f[j+40>>2]|0)|0;break}}else l=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=d;n=i+(((l|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+28|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=(h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((l<<2)+(f[c+32>>2]|0))>>2]|0)==(f[e+40>>2]|0)){m=d;n=(f[c+12>>2]|0)+((f[(f[e+48>>2]|0)+52>>2]|0)+l<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+28|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}l=f[c+8>>2]|0;d=f[c+12>>2]|0;do if(b[e+38>>0]|0){c=f[e+56>>2]|0;h=e;if(!c){t=h-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{t=h-(f[c+40>>2]|0)|0;break}}else t=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=l;n=d+(((t|0)/88|0)<<2)|0;o=f[n>>2]|0;p=m+o|0;q=f[p>>2]|0;r=q+28|0;s=f[r>>2]|0;mi[s&2047](p,a);u=g;return}function ric(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e;h=f[d+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(h,g)}if(!((f[d+28>>2]|0)==11?D3b(d)|0:0))tic(f[a+4>>2]|0,d,497545,497268);g=f[d+52>>2]|0;if(!g){h=f[a+12>>2]|0;do if(b[d+38>>0]|0){i=f[d+56>>2]|0;j=d;if(!i){k=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{k=j-(f[i+40>>2]|0)|0;break}}else k=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);l=c;m=h+(((k|0)/88|0)<<2)|0;n=f[m>>2]|0;o=l+n|0;p=f[o>>2]|0;q=p+32|0;r=f[q>>2]|0;s=_i[r&2047](o)|0;u=e;return s|0}k=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((k<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){l=c;m=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+k<<2)|0;n=f[m>>2]|0;o=l+n|0;p=f[o>>2]|0;q=p+32|0;r=f[q>>2]|0;s=_i[r&2047](o)|0;u=e;return s|0}k=f[a+8>>2]|0;c=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;g=d;if(!a){t=g-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{t=g-(f[a+40>>2]|0)|0;break}}else t=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);l=k;m=c+(((t|0)/88|0)<<2)|0;n=f[m>>2]|0;o=l+n|0;p=f[o>>2]|0;q=p+32|0;r=f[q>>2]|0;s=_i[r&2047](o)|0;u=e;return s|0}function sic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[d+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(h,g)}if(!((f[d+28>>2]|0)==11?D3b(d)|0:0))tic(f[a+4>>2]|0,d,497255,497268);g=f[d+52>>2]|0;if(g|0){i=(f[a+12>>2]|0)+(((g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)|0;j=f[i>>2]|0;k=c+j|0;u=e;return k|0}g=f[a+12>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;h=d;if(!a){l=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{l=h-(f[a+40>>2]|0)|0;break}}else l=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);i=g+(((l|0)/88|0)<<2)|0;j=f[i>>2]|0;k=c+j|0;u=e;return k|0}function tic(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;u_b(g,3,497294,101);h=p_b(p_b(p_b(g,497404)|0,c)|0,497491)|0;c=p_b(q_b(h,f[a+4>>2]|0)|0,497509)|0;r_b(e+24|0,p_b(p_b(q_b(c,f[b+4>>2]|0)|0,497527)|0,d)|0);v_b(g);u=e;return}function uic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+16|0;h=e;i=a+8|0;j=a+16|0;f[j>>2]=0;f[a+24>>2]=0;k=a+28|0;f[k>>2]=0;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);l=f[g+4>>2]|0;m=hj[f[(f[l>>2]|0)+364>>2]&511](l,c,d)|0;c=a+4|0;f[c>>2]=m;m=F3b(d)|0;l=h+4|0;f[l>>2]=0;f[l+4>>2]=0;l=h+11|0;b[l>>0]=3;b[h>>0]=b[502062]|0;b[h+1>>0]=b[502063]|0;b[h+2>>0]=b[502064]|0;b[h+3>>0]=0;n=w3b(m,h)|0;m=f[n+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=n;J_b(m,g)}m=f[165644+(f[n+28>>2]<<2)>>2]|0;n=f[j>>2]|0;if((n|0)!=(m|0)){if((n|0)==9?(n=f[i>>2]|0,n|0):0){if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);cYc(n)}f[j>>2]=m;if((m|0)==9){m=$Xc(12)|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[i>>2]=m}}if((b[l>>0]|0)<0)cYc(f[h>>2]|0);l=F3b(d)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d=h+11|0;b[d>>0]=5;b[h>>0]=b[502066]|0;b[h+1>>0]=b[502067]|0;b[h+2>>0]=b[502068]|0;b[h+3>>0]=b[502069]|0;b[h+4>>0]=b[502070]|0;b[h+5>>0]=0;m=w3b(l,h)|0;l=f[m+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=m;J_b(l,g)}f[k>>2]=f[165644+(f[m+28>>2]<<2)>>2];if((b[d>>0]|0)>=0){o=f[c>>2]|0;p=f[o>>2]|0;q=p+48|0;r=f[q>>2]|0;mi[r&2047](o,a);u=e;return}cYc(f[h>>2]|0);o=f[c>>2]|0;p=f[o>>2]|0;q=p+48|0;r=f[q>>2]|0;mi[r&2047](o,a);u=e;return}function vic(a){a=a|0;var c=0;if((f[a+8>>2]|0)!=9)return;c=f[a>>2]|0;if(!c)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function wic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;u_b(i,3,497294,127);k=p_b(p_b(p_b(i,497404)|0,d)|0,497491)|0;d=p_b(q_b(k,f[a+4>>2]|0)|0,497509)|0;a=p_b(q_b(d,f[c+4>>2]|0)|0,498226)|0;d=p_b(p_b(a,f[171472+(e<<2)>>2]|0)|0,498306)|0;e=f[c+24>>2]|0;if(e|0?(f[e>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=c;J_b(e,h)}r_b(j,p_b(d,f[171472+(f[165644+(f[c+28>>2]<<2)>>2]<<2)>>2]|0)|0);v_b(i);u=g;return}function xic(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){e=Joc(b,d)|0;yic(b,e);if((b|0)==0|(c|0)!=0)g=e;else{Yi[f[(f[b>>2]|0)+4>>2]&4095](b);g=e}}else g=b;else{fgc(d,b);g=b}b=a+12|0;d=f[b>>2]|0;e=f[a+8>>2]|0;c=a+4|0;do if((d|0)!=0?(h=f[c>>2]|0,(h|0)!=(e|0)):0){i=f[d>>2]|0;if((i|0)==(e|0)){j=f[d+4+(h<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;break}Yi[f[(f[j>>2]|0)+4>>2]&4095](j);k=f[b>>2]|0;break}if((h|0)<(i|0)){f[d+4+(i<<2)>>2]=f[d+4+(h<<2)>>2];h=f[b>>2]|0;l=h;m=f[h>>2]|0}else{l=d;m=i}f[l>>2]=m+1;k=l}else n=8;while(0);if((n|0)==8){XZb(a,e+1|0);e=f[b>>2]|0;f[e>>2]=(f[e>>2]|0)+1;k=e}e=f[c>>2]|0;f[c>>2]=e+1;f[k+4+(e<<2)>>2]=g;return}function yic(a,b){a=a|0;b=b|0;mi[f[(f[b>>2]|0)+76>>2]&2047](b,a);return}function zic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;if(b[d+38>>0]|0){i=c+(f[a+28>>2]|0)|0;j=f[d+40>>2]|0;k=f[d+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(k,h)}wsc(i,j,f[d+28>>2]&255,(b[(f[d+68>>2]|0)+52>>0]|0)!=0,e,d);u=g;return}j=f[d+52>>2]|0;i=f[d+48>>2]|0;if(!j)l=(d-(f[i+20>>2]|0)|0)/88|0;else l=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[i+52>>2]|0)|0;i=c+(f[(f[a+12>>2]|0)+(l<<2)>>2]|0)|0;l=f[i>>2]|0;if((l|0)==(f[i+4>>2]|0)){qHa(i,l+1|0);m=f[i>>2]|0}else m=l;l=f[i+8>>2]|0;f[i>>2]=m+1;f[l+4+(m<<2)>>2]=e;u=g;return}function Aic(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;u_b(g,3,497294,140);h=p_b(p_b(p_b(g,497404)|0,c)|0,497491)|0;c=p_b(q_b(h,f[a+4>>2]|0)|0,497509)|0;a=p_b(q_b(c,f[b+4>>2]|0)|0,498686)|0;c=(G3b(b)|0)+4|0;b=p_b(q_b(a,f[c>>2]|0)|0,498757)|0;r_b(e+24|0,q_b(b,f[d+4>>2]|0)|0);v_b(g);u=e;return}function Bic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,d,499298,498554);k=d+32|0;if((f[k>>2]|0)==3)tic(f[j>>2]|0,d,499298,499313);l=f[d+24>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(l,h)}if((f[165644+(f[d+28>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,d,499298,10);if(!e)m=f[a+48>>2]|0;else m=e;if(b[d+38>>0]|0){n=zgc(c+(f[a+28>>2]|0)|0,d,m)|0;u=g;return n|0}m=f[d+52>>2]|0;e=(m|0)==0;if((f[k>>2]|0)==3)if(e)o=21;else o=19;else if(e){e=f[a+20>>2]|0;if((e|0)==-1)o=21;else{k=f[(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0;j=c+e+(k>>>5<<2)|0;f[j>>2]=f[j>>2]&~(1<<(k&31));o=21}}else o=19;do if((o|0)==19){k=(m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0;j=c+((k<<2)+(f[a+32>>2]|0))|0;if((f[j>>2]|0)==(f[d+40>>2]|0)){f[j>>2]=0;p=c;q=(f[a+12>>2]|0)+(k+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;break}else{n=0;u=g;return n|0}}else if((o|0)==21){p=c;q=(f[a+12>>2]|0)+(((d-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)|0}while(0);i=p+(f[q>>2]|0)|0;q=f[i>>2]|0;f[i>>2]=0;n=q;u=g;return n|0}function Cic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g;i=e+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tic(k,e,499370,498554);if((f[e+32>>2]|0)==3)tic(f[j>>2]|0,e,499370,499313);k=e+24|0;l=f[k>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(l,h)}l=e+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)!=10)wic(f[j>>2]|0,e,499370,10);j=e+38|0;if(b[j>>0]|0){m=c+(f[a+28>>2]|0)|0;n=f[e+40>>2]|0;o=f[k>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(o,h)}Dsc(m,n,f[l>>2]&255,e,d);u=g;return}l=e+52|0;n=f[l>>2]|0;m=(d|0)==0;if(n|0){Tgc(a,c,n);if(m){u=g;return}n=f[l>>2]|0;if(!n){h=f[a+12>>2]|0;do if(b[j>>0]|0){o=f[e+56>>2]|0;k=e;if(!o){p=k-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{p=k-(f[o+40>>2]|0)|0;break}}else p=e-(f[(f[i>>2]|0)+20>>2]|0)|0;while(0);q=h+(((p|0)/88|0)<<2)|0}else q=(f[a+12>>2]|0)+(((n-(f[(f[n+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+52>>2]|0)<<2)|0;f[c+(f[q>>2]|0)>>2]=d;q=f[l>>2]|0;f[c+((((q-(f[(f[q+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[e+40>>2];u=g;return}q=f[a+20>>2]|0;l=(q|0)==-1;if(m){if(!l){m=f[(f[a+16>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0;n=c+q+(m>>>5<<2)|0;f[n>>2]=f[n>>2]&~(1<<(m&31))}}else if(!l){l=f[(f[a+16>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0;m=c+q+(l>>>5<<2)|0;f[m>>2]=1<<(l&31)|f[m>>2]}m=c+(f[(f[a+12>>2]|0)+(((e-(f[(f[i>>2]|0)+20>>2]|0)|0)/88|0)<<2)>>2]|0)|0;i=f[c+(f[a+24>>2]|0)>>2]|0;a=i&-2;if(!(i&1))r=a;else r=f[a+4>>2]|0;if((r|0)==0?(r=f[m>>2]|0,r|0):0)Yi[f[(f[r>>2]|0)+4>>2]&4095](r);f[m>>2]=d;u=g;return}function Dic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+8|0;i=g;f[i>>2]=e;if(!(b[d+38>>0]|0)){Eic(a,c,d,i);u=g;return}e=c+(f[a+28>>2]|0)|0;a=f[d+40>>2]|0;c=f[d+24>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=d;J_b(c,h)}tsc(e,a,f[d+28>>2]&255,f[i>>2]|0,d);u=g;return}function Eic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=f[e>>2]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Tgc(a,c,h);j=f[g>>2]|0;k=f[e>>2]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=f[e>>2]|0}f[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);f[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>2]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function Fic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=b[e>>0]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Tgc(a,c,h);j=f[g>>2]|0;k=b[e>>0]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=b[e>>0]|0}b[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>0]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);b[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>0]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function Gic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=+p[e>>3];else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Tgc(a,c,h);j=f[g>>2]|0;k=+p[e>>3];if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=+p[e>>3]}p[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>3]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){e=f[d+56>>2]|0;h=d;if(!e){n=h-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=h-(f[e+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);p[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>3]=i;n=f[a+20>>2]|0;if((n|0)==-1)return;l=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;e=d;if(!a){o=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=e-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[l+(((o|0)/88|0)<<2)>>2]|0;o=c+n+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function Hic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=f[e>>2]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Tgc(a,c,h);j=f[g>>2]|0;k=f[e>>2]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=f[e>>2]|0}f[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);f[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>2]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function Iic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=e;j=f[i>>2]|0;k=f[i+4>>2]|0}else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Tgc(a,c,h);i=f[g>>2]|0;l=e;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!i){j=m;k=n;break}else{o=i;p=m;q=n}}else{n=e;o=h;p=f[n>>2]|0;q=f[n+4>>2]|0}n=c+(f[(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;f[n>>2]=p;f[n+4>>2]=q;f[c+((((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);o=f[a+12>>2]|0;do if(b[d+38>>0]|0){q=f[d+56>>2]|0;p=d;if(!q){r=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=p-(f[q+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[o+(((r|0)/88|0)<<2)>>2]|0)|0;f[q>>2]=j;f[q+4>>2]=k;k=f[a+20>>2]|0;if((k|0)==-1)return;q=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;j=d;if(!a){s=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=j-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[q+(((s|0)/88|0)<<2)>>2]|0;s=c+k+(d>>>5<<2)|0;f[s>>2]=1<<(d&31)|f[s>>2];return}function Jic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=d+52|0;h=f[g>>2]|0;do if(!h)i=f[e>>2]|0;else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Tgc(a,c,h);j=f[g>>2]|0;k=f[e>>2]|0;if(!j){i=k;break}else{l=j;m=k}}else{l=h;m=f[e>>2]|0}f[c+(f[(f[a+12>>2]|0)+(((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)>>2]=m;f[c+((((l-(f[(f[l+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);l=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;e=d;if(!m){n=e-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{n=e-(f[m+40>>2]|0)|0;break}}else n=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);f[c+(f[l+(((n|0)/88|0)<<2)>>2]|0)>>2]=i;i=f[a+20>>2]|0;if((i|0)==-1)return;n=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;l=d;if(!a){o=l-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[a+40>>2]|0)|0;break}}else o=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[n+(((o|0)/88|0)<<2)>>2]|0;o=c+i+(d>>>5<<2)|0;f[o>>2]=1<<(d&31)|f[o>>2];return}function Kic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=e;j=f[i>>2]|0;k=f[i+4>>2]|0}else{if((f[c+((((h-(f[(f[h+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]|0)!=(f[d+40>>2]|0)){Tgc(a,c,h);i=f[g>>2]|0;l=e;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!i){j=m;k=n;break}else{o=i;p=m;q=n}}else{n=e;o=h;p=f[n>>2]|0;q=f[n+4>>2]|0}n=c+(f[(f[a+12>>2]|0)+(((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[d+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;f[n>>2]=p;f[n+4>>2]=q;f[c+((((o-(f[(f[o+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[a+32>>2]|0))>>2]=f[d+40>>2];return}while(0);o=f[a+12>>2]|0;do if(b[d+38>>0]|0){q=f[d+56>>2]|0;p=d;if(!q){r=p-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{r=p-(f[q+40>>2]|0)|0;break}}else r=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);q=c+(f[o+(((r|0)/88|0)<<2)>>2]|0)|0;f[q>>2]=j;f[q+4>>2]=k;k=f[a+20>>2]|0;if((k|0)==-1)return;q=f[a+16>>2]|0;do if(b[d+38>>0]|0){a=f[d+56>>2]|0;j=d;if(!a){s=j-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{s=j-(f[a+40>>2]|0)|0;break}}else s=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);d=f[q+(((s|0)/88|0)<<2)>>2]|0;s=c+k+(d>>>5<<2)|0;f[s>>2]=1<<(d&31)|f[s>>2];return}function Lic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>2;i=$Xc(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;cYc(d);return}function Mic(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+40|0;j=a+8|0;k=f[a+20>>2]|0;if((k|0)!=-1){l=c+k|0;k=f[a+16>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;o=d;if(!m){q=o-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{q=o-(f[m+40>>2]|0)|0;break}}else q=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);m=f[k+(((q|0)/88|0)<<2)>>2]|0;r=(1<<(m&31)&f[l+(m>>>5<<2)>>2]|0)!=0;u=e;return r|0}m=d+24|0;l=f[m>>2]|0;if(l|0?(f[l>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(l,g)}l=d+28|0;if((f[165644+(f[l>>2]<<2)>>2]|0)==10){q=f[j>>2]|0;if((q|0)==(c|0)){r=0;u=e;return r|0}k=f[d+52>>2]|0;do if(!k){o=f[a+12>>2]|0;do if(b[d+38>>0]|0){s=f[d+56>>2]|0;t=d;if(!s){v=t-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{v=t-(f[s+40>>2]|0)|0;break}}else v=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);w=c;x=o+(((v|0)/88|0)<<2)|0}else{s=(k-(f[(f[k+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((s<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){w=c;x=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+s<<2)|0;break}s=f[a+12>>2]|0;do if(b[d+38>>0]|0){t=f[d+56>>2]|0;y=d;if(!t){z=y-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{z=y-(f[t+40>>2]|0)|0;break}}else z=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);w=q;x=s+(((z|0)/88|0)<<2)|0}while(0);r=(f[w+(f[x>>2]|0)>>2]|0)!=0;u=e;return r|0}x=f[m>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=d;J_b(x,g)}do switch(f[165644+(f[l>>2]<<2)>>2]|0){case 9:{g=f[d+52>>2]|0;do if(!g){x=f[a+12>>2]|0;do if(b[d+38>>0]|0){m=f[d+56>>2]|0;w=d;if(!m){A=w-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{A=w-(f[m+40>>2]|0)|0;break}}else A=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);B=c;C=x+(((A|0)/88|0)<<2)|0}else{m=(g-(f[(f[g+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){B=c;C=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){z=f[d+56>>2]|0;q=d;if(!z){D=q-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{D=q-(f[z+40>>2]|0)|0;break}}else D=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);B=m;C=w+(((D|0)/88|0)<<2)|0}while(0);g=f[B+(f[C>>2]|0)>>2]|0;s=b[g+11>>0]|0;if(s<<24>>24<0)E=f[g+4>>2]|0;else E=s&255;r=(E|0)!=0;u=e;return r|0}case 7:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){F=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{F=z-(f[x+40>>2]|0)|0;break}}else F=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);G=c;H=g+(((F|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){G=c;H=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){I=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{I=z-(f[x+40>>2]|0)|0;break}}else I=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);G=w;H=m+(((I|0)/88|0)<<2)|0}while(0);r=(b[G+(f[H>>2]|0)>>0]|0)!=0;u=e;return r|0}case 1:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){J=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{J=z-(f[x+40>>2]|0)|0;break}}else J=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);K=c;L=g+(((J|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){K=c;L=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){M=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{M=z-(f[x+40>>2]|0)|0;break}}else M=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);K=m;L=w+(((M|0)/88|0)<<2)|0}while(0);r=(f[K+(f[L>>2]|0)>>2]|0)!=0;u=e;return r|0}case 2:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){N=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{N=z-(f[x+40>>2]|0)|0;break}}else N=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);O=c;P=g+(((N|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){O=c;P=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){Q=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Q=z-(f[x+40>>2]|0)|0;break}}else Q=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);O=w;P=m+(((Q|0)/88|0)<<2)|0}while(0);s=O+(f[P>>2]|0)|0;r=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0;u=e;return r|0}case 3:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){R=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{R=z-(f[x+40>>2]|0)|0;break}}else R=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);S=c;T=g+(((R|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){S=c;T=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){U=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{U=z-(f[x+40>>2]|0)|0;break}}else U=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);S=m;T=w+(((U|0)/88|0)<<2)|0}while(0);r=(f[S+(f[T>>2]|0)>>2]|0)!=0;u=e;return r|0}case 4:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){V=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{V=z-(f[x+40>>2]|0)|0;break}}else V=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);W=c;X=g+(((V|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){W=c;X=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){Y=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Y=z-(f[x+40>>2]|0)|0;break}}else Y=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);W=w;X=m+(((Y|0)/88|0)<<2)|0}while(0);s=W+(f[X>>2]|0)|0;r=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0;u=e;return r|0}case 6:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){Z=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{Z=z-(f[x+40>>2]|0)|0;break}}else Z=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);_=c;$=g+(((Z|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){_=c;$=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){aa=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{aa=z-(f[x+40>>2]|0)|0;break}}else aa=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);_=m;$=w+(((aa|0)/88|0)<<2)|0}while(0);r=+n[_+(f[$>>2]|0)>>2]!=0.0;u=e;return r|0}case 5:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){ba=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ba=z-(f[x+40>>2]|0)|0;break}}else ba=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ca=c;da=g+(((ba|0)/88|0)<<2)|0}else{w=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((w<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){ca=c;da=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+w<<2)|0;break}w=f[j>>2]|0;m=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){ea=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ea=z-(f[x+40>>2]|0)|0;break}}else ea=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ca=w;da=m+(((ea|0)/88|0)<<2)|0}while(0);r=+p[ca+(f[da>>2]|0)>>3]!=0.0;u=e;return r|0}case 8:{s=f[d+52>>2]|0;do if(!s){g=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){fa=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{fa=z-(f[x+40>>2]|0)|0;break}}else fa=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ga=c;ha=g+(((fa|0)/88|0)<<2)|0}else{m=(s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((m<<2)+(f[a+32>>2]|0))>>2]|0)==(f[d+40>>2]|0)){ga=c;ha=(f[a+12>>2]|0)+((f[(f[d+48>>2]|0)+52>>2]|0)+m<<2)|0;break}m=f[j>>2]|0;w=f[a+12>>2]|0;do if(b[d+38>>0]|0){x=f[d+56>>2]|0;z=d;if(!x){ia=z-(f[(f[d+20>>2]|0)+80>>2]|0)|0;break}else{ia=z-(f[x+40>>2]|0)|0;break}}else ia=d-(f[(f[d+48>>2]|0)+20>>2]|0)|0;while(0);ga=m;ha=w+(((ia|0)/88|0)<<2)|0}while(0);r=(f[ga+(f[ha>>2]|0)>>2]|0)!=0;u=e;return r|0}default:{u_b(h,3,497294,2002);r_b(i,p_b(h,499674)|0);v_b(h);r=0;u=e;return r|0}}while(0);return 0}function Nic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;c=a;a=b;a:while(1){b=a;d=a+-4|0;e=c;while(1){g=e;b:while(1){h=g;i=b-h|0;j=i>>2;switch(j|0){case 2:{k=5;break a;break}case 3:{k=7;break a;break}case 4:{k=15;break a;break}case 5:{k=27;break a;break}case 1:case 0:{k=87;break a;break}default:{}}if((i|0)<124){k=29;break a}l=g+(((j|0)/2|0)<<2)|0;do if((i|0)<=3996){m=f[l>>2]|0;n=f[g>>2]|0;o=f[m+40>>2]|0;p=f[n+40>>2]|0;q=f[d>>2]|0;r=(f[q+40>>2]|0)<(o|0);s=m;m=q;q=n;if((o|0)>=(p|0)){if(!r){t=0;break}f[l>>2]=m;f[d>>2]=s;o=f[l>>2]|0;n=f[g>>2]|0;if((f[o+40>>2]|0)>=(f[n+40>>2]|0)){t=1;break}f[g>>2]=o;f[l>>2]=n;t=2;break}if(r){f[g>>2]=m;f[d>>2]=q;t=1;break}f[g>>2]=s;f[l>>2]=q;s=f[d>>2]|0;if((f[s+40>>2]|0)<(p|0)){f[l>>2]=s;f[d>>2]=q;t=2}else t=1}else{q=(j|0)/4|0;t=Oic(g,g+(q<<2)|0,l,l+(q<<2)|0,d)|0}while(0);u=f[g>>2]|0;j=f[u+40>>2]|0;i=f[(f[l>>2]|0)+40>>2]|0;if((j|0)<(i|0)){v=d;w=t;break}else x=d;while(1){x=x+-4|0;if((g|0)==(x|0))break;y=f[x>>2]|0;if((f[y+40>>2]|0)<(i|0)){k=69;break b}}i=g+4|0;q=f[d>>2]|0;s=q;if((j|0)<(f[q+40>>2]|0))z=i;else{if((i|0)==(d|0)){k=87;break a}else A=i;while(1){B=f[A>>2]|0;if((j|0)<(f[B+40>>2]|0))break;i=A+4|0;if((i|0)==(d|0)){k=87;break a}else A=i}f[A>>2]=s;f[d>>2]=B;z=A+4|0}if((z|0)==(d|0)){k=87;break a}else{C=d;D=z}while(1){j=f[(f[g>>2]|0)+40>>2]|0;i=D;while(1){E=f[i>>2]|0;F=i+4|0;if((j|0)<(f[E+40>>2]|0))break;else i=F}q=E;p=C;do{p=p+-4|0;G=f[p>>2]|0}while((j|0)<(f[G+40>>2]|0));if(i>>>0>=p>>>0){g=i;continue b}f[i>>2]=G;f[p>>2]=q;C=p;D=F}}if((k|0)==69){k=0;f[g>>2]=y;f[x>>2]=u;v=x;w=t+1|0}s=g+4|0;c:do if(s>>>0<v>>>0){j=l;m=v;r=s;n=w;while(1){o=f[(f[j>>2]|0)+40>>2]|0;H=r;while(1){I=f[H>>2]|0;J=H+4|0;if((f[I+40>>2]|0)<(o|0))H=J;else break}p=I;q=m;do{q=q+-4|0;K=f[q>>2]|0}while((f[K+40>>2]|0)>=(o|0));if(H>>>0>q>>>0){L=j;M=n;N=H;break c}f[H>>2]=K;f[q>>2]=p;j=(j|0)==(H|0)?q:j;m=q;r=J;n=n+1|0}}else{L=l;M=w;N=s}while(0);if((N|0)!=(L|0)?(s=f[L>>2]|0,n=f[N>>2]|0,(f[s+40>>2]|0)<(f[n+40>>2]|0)):0){f[N>>2]=s;f[L>>2]=n;O=M+1|0}else O=M;if(!O){P=Pic(g,N)|0;n=N+4|0;if(Pic(n,a)|0){k=86;break}if(P){e=n;continue}}n=N;if((n-h|0)>=(b-n|0)){k=85;break}Nic(g,N);e=N+4|0}if((k|0)==85){k=0;Nic(N+4|0,a);c=g;a=N;continue}else if((k|0)==86){k=0;if(P){k=87;break}else{c=g;a=N;continue}}}if((k|0)==5){N=f[d>>2]|0;c=f[g>>2]|0;if((f[N+40>>2]|0)>=(f[c+40>>2]|0))return;f[g>>2]=N;f[d>>2]=c;return}else if((k|0)==7){c=g+4|0;N=f[c>>2]|0;P=f[g>>2]|0;h=f[N+40>>2]|0;O=f[P+40>>2]|0;M=f[d>>2]|0;L=(f[M+40>>2]|0)<(h|0);w=N;N=M;M=P;if((h|0)>=(O|0)){if(!L)return;f[c>>2]=N;f[d>>2]=w;h=f[c>>2]|0;P=f[g>>2]|0;if((f[h+40>>2]|0)>=(f[P+40>>2]|0))return;f[g>>2]=h;f[c>>2]=P;return}if(L){f[g>>2]=N;f[d>>2]=M;return}f[g>>2]=w;f[c>>2]=M;w=f[d>>2]|0;if((f[w+40>>2]|0)>=(O|0))return;f[c>>2]=w;f[d>>2]=M;return}else if((k|0)==15){M=g+4|0;w=g+8|0;c=f[M>>2]|0;O=f[g>>2]|0;N=f[c+40>>2]|0;L=f[O+40>>2]|0;P=f[w>>2]|0;h=f[P+40>>2]|0;l=(h|0)<(N|0);J=c;K=P;I=O;do if((N|0)<(L|0)){if(l){f[g>>2]=K;f[w>>2]=I;Q=O;R=I;break}f[g>>2]=J;f[M>>2]=I;if((h|0)<(L|0)){f[M>>2]=K;f[w>>2]=I;Q=O;R=I}else{Q=P;R=K}}else if(l){f[M>>2]=K;f[w>>2]=J;if((h|0)<(L|0)){f[g>>2]=K;f[M>>2]=I;Q=c;R=J}else{Q=c;R=J}}else{Q=P;R=K}while(0);K=f[d>>2]|0;if((f[K+40>>2]|0)>=(f[Q+40>>2]|0))return;f[w>>2]=K;f[d>>2]=R;R=f[w>>2]|0;K=f[M>>2]|0;Q=f[R+40>>2]|0;if((Q|0)>=(f[K+40>>2]|0))return;P=R;f[M>>2]=P;f[w>>2]=K;K=f[g>>2]|0;if((Q|0)>=(f[K+40>>2]|0))return;f[g>>2]=P;f[M>>2]=K;return}else if((k|0)==27){Oic(g,g+4|0,g+8|0,g+12|0,d)|0;return}else if((k|0)==29){d=g+8|0;K=g+4|0;M=f[K>>2]|0;P=f[g>>2]|0;Q=f[M+40>>2]|0;w=f[P+40>>2]|0;R=f[d>>2]|0;J=f[R+40>>2]|0;c=(J|0)<(Q|0);I=M;L=R;h=P;do if((Q|0)<(w|0)){if(c){f[g>>2]=L;f[d>>2]=h;S=P;break}f[g>>2]=I;f[K>>2]=h;if((J|0)<(w|0)){f[K>>2]=L;f[d>>2]=h;S=P}else S=R}else if(c){f[K>>2]=L;f[d>>2]=I;if((J|0)<(w|0)){f[g>>2]=L;f[K>>2]=h;S=M}else S=M}else S=R;while(0);R=g+12|0;if((R|0)==(a|0))return;else{T=R;U=d;V=S}while(1){S=f[T>>2]|0;d=f[S+40>>2]|0;R=S;if((d|0)<(f[V+40>>2]|0)){S=U;M=T;while(1){f[M>>2]=f[S>>2];if((S|0)==(g|0))break;h=S+-4|0;if((d|0)<(f[(f[h>>2]|0)+40>>2]|0)){K=S;S=h;M=K}else break}f[S>>2]=R}M=T+4|0;if((M|0)==(a|0))break;d=f[T>>2]|0;K=T;T=M;V=d;U=K}return}else if((k|0)==87)return}function Oic(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=f[b>>2]|0;h=f[a>>2]|0;i=f[g+40>>2]|0;j=f[h+40>>2]|0;k=f[c>>2]|0;l=(f[k+40>>2]|0)<(i|0);m=g;n=k;o=h;do if((i|0)<(j|0)){if(l){f[a>>2]=n;f[c>>2]=o;p=1;q=h;r=o;break}f[a>>2]=m;f[b>>2]=o;s=f[c>>2]|0;t=s;if((f[s+40>>2]|0)<(j|0)){f[b>>2]=t;f[c>>2]=o;p=2;q=h;r=o}else{p=1;q=s;r=t}}else if(l){f[b>>2]=n;f[c>>2]=m;t=f[b>>2]|0;s=f[a>>2]|0;if((f[t+40>>2]|0)<(f[s+40>>2]|0)){f[a>>2]=t;f[b>>2]=s;s=f[c>>2]|0;p=2;q=s;r=s}else{p=1;q=g;r=m}}else{p=0;q=k;r=n}while(0);n=f[d>>2]|0;if((f[n+40>>2]|0)<(f[q+40>>2]|0)){f[c>>2]=n;f[d>>2]=r;r=p+1|0;n=f[c>>2]|0;q=f[b>>2]|0;if((f[n+40>>2]|0)<(f[q+40>>2]|0)){f[b>>2]=n;f[c>>2]=q;q=f[b>>2]|0;n=f[a>>2]|0;if((f[q+40>>2]|0)<(f[n+40>>2]|0)){f[a>>2]=q;f[b>>2]=n;u=p+3|0}else u=p+2|0}else u=r}else u=p;p=f[e>>2]|0;r=f[d>>2]|0;if((f[p+40>>2]|0)>=(f[r+40>>2]|0)){v=u;return v|0}f[d>>2]=p;f[e>>2]=r;r=f[d>>2]|0;e=f[c>>2]|0;if((f[r+40>>2]|0)>=(f[e+40>>2]|0)){v=u+1|0;return v|0}f[c>>2]=r;f[d>>2]=e;e=f[c>>2]|0;d=f[b>>2]|0;if((f[e+40>>2]|0)>=(f[d+40>>2]|0)){v=u+2|0;return v|0}f[b>>2]=e;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;if((f[d+40>>2]|0)>=(f[c+40>>2]|0)){v=u+3|0;return v|0}f[a>>2]=d;f[b>>2]=c;v=u+4|0;return v|0}function Pic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;switch(b-a>>2|0){case 2:{c=b+-4|0;d=f[c>>2]|0;e=f[a>>2]|0;if((f[d+40>>2]|0)>=(f[e+40>>2]|0)){g=1;return g|0}f[a>>2]=d;f[c>>2]=e;g=1;return g|0}case 3:{e=a+4|0;c=b+-4|0;d=f[e>>2]|0;h=f[a>>2]|0;i=f[d+40>>2]|0;j=f[h+40>>2]|0;k=f[c>>2]|0;l=(f[k+40>>2]|0)<(i|0);m=d;d=k;k=h;if((i|0)>=(j|0)){if(!l){g=1;return g|0}f[e>>2]=d;f[c>>2]=m;i=f[e>>2]|0;h=f[a>>2]|0;if((f[i+40>>2]|0)>=(f[h+40>>2]|0)){g=1;return g|0}f[a>>2]=i;f[e>>2]=h;g=1;return g|0}if(l){f[a>>2]=d;f[c>>2]=k;g=1;return g|0}f[a>>2]=m;f[e>>2]=k;m=f[c>>2]|0;if((f[m+40>>2]|0)>=(j|0)){g=1;return g|0}f[e>>2]=m;f[c>>2]=k;g=1;return g|0}case 4:{k=a+4|0;c=a+8|0;m=b+-4|0;e=f[k>>2]|0;j=f[a>>2]|0;d=f[e+40>>2]|0;l=f[j+40>>2]|0;h=f[c>>2]|0;i=f[h+40>>2]|0;n=(i|0)<(d|0);o=e;p=h;q=j;do if((d|0)<(l|0)){if(n){f[a>>2]=p;f[c>>2]=q;r=j;s=q;break}f[a>>2]=o;f[k>>2]=q;if((i|0)<(l|0)){f[k>>2]=p;f[c>>2]=q;r=j;s=q}else{r=h;s=p}}else if(n){f[k>>2]=p;f[c>>2]=o;if((i|0)<(l|0)){f[a>>2]=p;f[k>>2]=q;r=e;s=o}else{r=e;s=o}}else{r=h;s=p}while(0);p=f[m>>2]|0;if((f[p+40>>2]|0)>=(f[r+40>>2]|0)){g=1;return g|0}f[c>>2]=p;f[m>>2]=s;s=f[c>>2]|0;m=f[k>>2]|0;p=f[s+40>>2]|0;if((p|0)>=(f[m+40>>2]|0)){g=1;return g|0}r=s;f[k>>2]=r;f[c>>2]=m;m=f[a>>2]|0;if((p|0)>=(f[m+40>>2]|0)){g=1;return g|0}f[a>>2]=r;f[k>>2]=m;g=1;return g|0}case 5:{Oic(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;g=1;return g|0}case 1:case 0:{g=1;return g|0}default:{m=a+8|0;k=a+4|0;r=f[k>>2]|0;p=f[a>>2]|0;c=f[r+40>>2]|0;s=f[p+40>>2]|0;h=f[m>>2]|0;o=f[h+40>>2]|0;e=(o|0)<(c|0);q=r;l=h;i=p;do if((c|0)<(s|0)){if(e){f[a>>2]=l;f[m>>2]=i;t=p;break}f[a>>2]=q;f[k>>2]=i;if((o|0)<(s|0)){f[k>>2]=l;f[m>>2]=i;t=p}else t=h}else if(e){f[k>>2]=l;f[m>>2]=q;if((o|0)<(s|0)){f[a>>2]=l;f[k>>2]=i;t=r}else t=r}else t=h;while(0);h=a+12|0;a:do if((h|0)==(b|0)){u=1;v=0}else{r=h;i=0;k=m;l=t;while(1){s=f[r>>2]|0;o=f[s+40>>2]|0;q=s;if((o|0)<(f[l+40>>2]|0)){s=k;e=r;while(1){f[e>>2]=f[s>>2];if((s|0)==(a|0))break;p=s+-4|0;if((o|0)<(f[(f[p>>2]|0)+40>>2]|0)){c=s;s=p;e=c}else break}f[s>>2]=q;e=i+1|0;if((e|0)==8){u=0;v=(r+4|0)==(b|0);break a}else w=e}else w=i;e=r+4|0;if((e|0)==(b|0)){u=1;v=0;break a}o=f[r>>2]|0;c=r;r=e;i=w;l=o;k=c}}while(0);g=v|u;return g|0}}return 0}function Qic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;g=u;u=u+160|0;h=g+136|0;i=g+132|0;j=g+16|0;k=g+128|0;l=g+8|0;m=g+96|0;n=g;o=g+154|0;q=g+64|0;r=g+24|0;s=g+104|0;t=g+155|0;v=g+72|0;w=g+153|0;x=g+40|0;y=g+152|0;z=a+32|0;A=(((e-(f[(f[e+8>>2]|0)+24>>2]|0)|0)/28|0)<<2)+(f[z>>2]|0)|0;B=f[c+A>>2]|0;C=f[d+A>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;A=(B|0)!=0;a:do if(A){D=s3b(f[a+4>>2]|0,B)|0;E=D+24|0;F=f[E>>2]|0;if(F|0?(f[F>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=D;J_b(F,h)}F=D+28|0;do switch(f[165644+(f[F>>2]<<2)>>2]|0){case 1:{G=f[D+52>>2]|0;do if(!G){H=f[a+12>>2]|0;do if(b[D+38>>0]|0){I=f[D+56>>2]|0;J=D;if(!I){K=J-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{K=J-(f[I+40>>2]|0)|0;break}}else K=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);L=c;M=H+(((K|0)/88|0)<<2)|0}else{I=(G-(f[(f[G+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){L=c;M=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){N=f[D+56>>2]|0;O=D;if(!N){P=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{P=O-(f[N+40>>2]|0)|0;break}}else P=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);L=I;M=J+(((P|0)/88|0)<<2)|0}while(0);f[i>>2]=f[L+(f[M>>2]|0)>>2];Q=0;R=D;break a;break}case 2:{G=f[D+52>>2]|0;do if(!G){H=f[a+12>>2]|0;do if(b[D+38>>0]|0){N=f[D+56>>2]|0;O=D;if(!N){S=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{S=O-(f[N+40>>2]|0)|0;break}}else S=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);T=c;U=H+(((S|0)/88|0)<<2)|0}else{J=(G-(f[(f[G+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){T=c;U=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){N=f[D+56>>2]|0;O=D;if(!N){V=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{V=O-(f[N+40>>2]|0)|0;break}}else V=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);T=J;U=I+(((V|0)/88|0)<<2)|0}while(0);G=T+(f[U>>2]|0)|0;H=f[G+4>>2]|0;N=j;f[N>>2]=f[G>>2];f[N+4>>2]=H;Q=0;R=D;break a;break}case 3:{H=f[D+52>>2]|0;do if(!H){N=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){W=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{W=O-(f[G+40>>2]|0)|0;break}}else W=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);X=c;Y=N+(((W|0)/88|0)<<2)|0}else{I=(H-(f[(f[H+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){X=c;Y=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){Z=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{Z=O-(f[G+40>>2]|0)|0;break}}else Z=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);X=I;Y=J+(((Z|0)/88|0)<<2)|0}while(0);f[k>>2]=f[X+(f[Y>>2]|0)>>2];Q=0;R=D;break a;break}case 4:{H=f[D+52>>2]|0;do if(!H){N=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){_=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{_=O-(f[G+40>>2]|0)|0;break}}else _=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);$=c;aa=N+(((_|0)/88|0)<<2)|0}else{J=(H-(f[(f[H+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){$=c;aa=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){G=f[D+56>>2]|0;O=D;if(!G){ba=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ba=O-(f[G+40>>2]|0)|0;break}}else ba=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);$=J;aa=I+(((ba|0)/88|0)<<2)|0}while(0);H=$+(f[aa>>2]|0)|0;N=f[H+4>>2]|0;G=l;f[G>>2]=f[H>>2];f[G+4>>2]=N;Q=0;R=D;break a;break}case 6:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ca=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ca=O-(f[H+40>>2]|0)|0;break}}else ca=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);da=c;ea=G+(((ca|0)/88|0)<<2)|0}else{I=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){da=c;ea=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){fa=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{fa=O-(f[H+40>>2]|0)|0;break}}else fa=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);da=I;ea=J+(((fa|0)/88|0)<<2)|0}while(0);f[m>>2]=f[da+(f[ea>>2]|0)>>2];Q=0;R=D;break a;break}case 5:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ga=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ga=O-(f[H+40>>2]|0)|0;break}}else ga=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);ha=c;ia=G+(((ga|0)/88|0)<<2)|0}else{J=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){ha=c;ia=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ja=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ja=O-(f[H+40>>2]|0)|0;break}}else ja=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);ha=J;ia=I+(((ja|0)/88|0)<<2)|0}while(0);p[n>>3]=+p[ha+(f[ia>>2]|0)>>3];Q=0;R=D;break a;break}case 7:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ka=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ka=O-(f[H+40>>2]|0)|0;break}}else ka=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);la=c;ma=G+(((ka|0)/88|0)<<2)|0}else{I=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){la=c;ma=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){na=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{na=O-(f[H+40>>2]|0)|0;break}}else na=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);la=I;ma=J+(((na|0)/88|0)<<2)|0}while(0);b[o>>0]=b[la+(f[ma>>2]|0)>>0]|0;Q=0;R=D;break a;break}case 8:{N=f[D+52>>2]|0;do if(!N){G=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){oa=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{oa=O-(f[H+40>>2]|0)|0;break}}else oa=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);pa=c;qa=G+(((oa|0)/88|0)<<2)|0}else{J=(N-(f[(f[N+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[c+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[D+40>>2]|0)){pa=c;qa=(f[a+12>>2]|0)+((f[(f[D+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[D+38>>0]|0){H=f[D+56>>2]|0;O=D;if(!H){ra=O-(f[(f[D+20>>2]|0)+80>>2]|0)|0;break}else{ra=O-(f[H+40>>2]|0)|0;break}}else ra=D-(f[(f[D+48>>2]|0)+20>>2]|0)|0;while(0);pa=J;qa=I+(((ra|0)/88|0)<<2)|0}while(0);f[q>>2]=f[pa+(f[qa>>2]|0)>>2];Q=0;R=D;break a;break}case 10:{N=Bic(a,c,D,0)|0;G=f[c+(f[a+24>>2]|0)>>2]|0;H=G&-2;if(!(G&1))sa=H;else sa=f[H+4>>2]|0;if(!((N|0)!=0&(sa|0)!=0)){Q=N;R=D;break a}H=_i[f[(f[N>>2]|0)+12>>2]&2047](N)|0;mi[f[(f[H>>2]|0)+72>>2]&2047](H,N);Q=H;R=D;break a;break}case 9:{ghc(h,a,c,D);H=r+11|0;if((b[H>>0]|0)<0){b[f[r>>2]>>0]=0;f[r+4>>2]=0}else{b[r>>0]=0;b[H>>0]=0}sYc(r,0);f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];Q=0;R=D;break a;break}default:{u_b(s,3,497294,498);H=p_b(s,500058)|0;N=f[E>>2]|0;if(N|0?(f[N>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=D;J_b(N,h)}r_b(t,s_b(H,f[165644+(f[F>>2]<<2)>>2]|0)|0);v_b(s);Q=0;R=D;break a}}while(0)}else{Q=0;R=0}while(0);b:do if(!C)Tgc(a,c,e);else{s=s3b(f[a+4>>2]|0,C)|0;t=s+24|0;sa=f[t>>2]|0;if(sa|0?(f[sa>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=s;J_b(sa,h)}sa=s+28|0;do switch(f[165644+(f[sa>>2]<<2)>>2]|0){case 1:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){ta=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{ta=oa-(f[ra+40>>2]|0)|0;break}}else ta=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);ua=d;va=pa+(((ta|0)/88|0)<<2)|0}else{I=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){ua=d;va=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){wa=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{wa=oa-(f[ra+40>>2]|0)|0;break}}else wa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);ua=I;va=J+(((wa|0)/88|0)<<2)|0}while(0);Eic(a,c,s,ua+(f[va>>2]|0)|0);break b;break}case 2:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){xa=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{xa=oa-(f[ra+40>>2]|0)|0;break}}else xa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);ya=d;za=pa+(((xa|0)/88|0)<<2)|0}else{J=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){ya=d;za=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Aa=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Aa=oa-(f[ra+40>>2]|0)|0;break}}else Aa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);ya=J;za=I+(((Aa|0)/88|0)<<2)|0}while(0);Kic(a,c,s,ya+(f[za>>2]|0)|0);break b;break}case 3:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ba=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ba=oa-(f[ra+40>>2]|0)|0;break}}else Ba=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ca=d;Da=pa+(((Ba|0)/88|0)<<2)|0}else{I=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Ca=d;Da=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ea=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ea=oa-(f[ra+40>>2]|0)|0;break}}else Ea=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ca=I;Da=J+(((Ea|0)/88|0)<<2)|0}while(0);Jic(a,c,s,Ca+(f[Da>>2]|0)|0);break b;break}case 4:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Fa=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Fa=oa-(f[ra+40>>2]|0)|0;break}}else Fa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ga=d;Ha=pa+(((Fa|0)/88|0)<<2)|0}else{J=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Ga=d;Ha=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ia=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ia=oa-(f[ra+40>>2]|0)|0;break}}else Ia=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ga=J;Ha=I+(((Ia|0)/88|0)<<2)|0}while(0);Iic(a,c,s,Ga+(f[Ha>>2]|0)|0);break b;break}case 6:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ja=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ja=oa-(f[ra+40>>2]|0)|0;break}}else Ja=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ka=d;La=pa+(((Ja|0)/88|0)<<2)|0}else{I=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Ka=d;La=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ma=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ma=oa-(f[ra+40>>2]|0)|0;break}}else Ma=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Ka=I;La=J+(((Ma|0)/88|0)<<2)|0}while(0);Hic(a,c,s,Ka+(f[La>>2]|0)|0);break b;break}case 5:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Na=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Na=oa-(f[ra+40>>2]|0)|0;break}}else Na=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Oa=d;Pa=pa+(((Na|0)/88|0)<<2)|0}else{J=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Oa=d;Pa=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Qa=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Qa=oa-(f[ra+40>>2]|0)|0;break}}else Qa=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Oa=J;Pa=I+(((Qa|0)/88|0)<<2)|0}while(0);Gic(a,c,s,Oa+(f[Pa>>2]|0)|0);break b;break}case 7:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ra=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ra=oa-(f[ra+40>>2]|0)|0;break}}else Ra=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Sa=d;Ta=pa+(((Ra|0)/88|0)<<2)|0}else{I=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((I<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Sa=d;Ta=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+I<<2)|0;break}I=f[a+8>>2]|0;J=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ua=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ua=oa-(f[ra+40>>2]|0)|0;break}}else Ua=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Sa=I;Ta=J+(((Ua|0)/88|0)<<2)|0}while(0);Fic(a,c,s,Sa+(f[Ta>>2]|0)|0);break b;break}case 8:{qa=f[s+52>>2]|0;do if(!qa){pa=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Va=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Va=oa-(f[ra+40>>2]|0)|0;break}}else Va=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Wa=d;Xa=pa+(((Va|0)/88|0)<<2)|0}else{J=(qa-(f[(f[qa+8>>2]|0)+24>>2]|0)|0)/28|0;if((f[d+((J<<2)+(f[z>>2]|0))>>2]|0)==(f[s+40>>2]|0)){Wa=d;Xa=(f[a+12>>2]|0)+((f[(f[s+48>>2]|0)+52>>2]|0)+J<<2)|0;break}J=f[a+8>>2]|0;I=f[a+12>>2]|0;do if(b[s+38>>0]|0){ra=f[s+56>>2]|0;oa=s;if(!ra){Ya=oa-(f[(f[s+20>>2]|0)+80>>2]|0)|0;break}else{Ya=oa-(f[ra+40>>2]|0)|0;break}}else Ya=s-(f[(f[s+48>>2]|0)+20>>2]|0)|0;while(0);Wa=J;Xa=I+(((Ya|0)/88|0)<<2)|0}while(0);Eic(a,c,s,Wa+(f[Xa>>2]|0)|0);break b;break}case 10:{qa=Bic(a,d,s,0)|0;pa=f[d+(f[a+24>>2]|0)>>2]|0;ra=pa&-2;if(!(pa&1))Za=ra;else Za=f[ra+4>>2]|0;if((qa|0)!=0&(Za|0)!=0){ra=_i[f[(f[qa>>2]|0)+12>>2]&2047](qa)|0;mi[f[(f[ra>>2]|0)+72>>2]&2047](ra,qa);_a=ra}else _a=qa;whc(a,c,_a,s);break b;break}case 9:{ghc(h,a,d,s);shc(a,c,s,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);break b;break}default:{u_b(v,3,497294,532);qa=p_b(v,500058)|0;ra=f[t>>2]|0;if(ra|0?(f[ra>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=s;J_b(ra,h)}r_b(w,s_b(qa,f[165644+(f[sa>>2]<<2)>>2]|0)|0);v_b(v);break b}}while(0)}while(0);c:do if(A){v=R+24|0;w=f[v>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=R;J_b(w,h)}w=R+28|0;do switch(f[165644+(f[w>>2]<<2)>>2]|0){case 1:{Eic(a,d,R,i);break c;break}case 2:{Kic(a,d,R,j);break c;break}case 3:{Jic(a,d,R,k);break c;break}case 4:{Iic(a,d,R,l);break c;break}case 6:{Hic(a,d,R,m);break c;break}case 5:{Gic(a,d,R,n);break c;break}case 7:{Fic(a,d,R,o);break c;break}case 8:{Eic(a,d,R,q);break c;break}case 10:{whc(a,d,Q,R);break c;break}case 9:{shc(a,d,R,r);break c;break}default:{u_b(x,3,497294,564);c=p_b(x,500058)|0;_a=f[v>>2]|0;if(_a|0?(f[_a>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=R;J_b(_a,h)}r_b(y,s_b(c,f[165644+(f[w>>2]<<2)>>2]|0)|0);v_b(x);break c}}while(0)}else Tgc(a,d,e);while(0);if((b[r+11>>0]|0)>=0){u=g;return}cYc(f[r>>2]|0);u=g;return}function Ric(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=a+20|0;if((f[g>>2]|0)==-1)return;h=Mic(a,c,e)|0;i=Mic(a,d,e)|0;j=f[g>>2]|0;k=(j|0)==-1;if(i){if(!k){i=f[a+16>>2]|0;do if(b[e+38>>0]|0){l=f[e+56>>2]|0;m=e;if(!l){n=m-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{n=m-(f[l+40>>2]|0)|0;break}}else n=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);l=f[i+(((n|0)/88|0)<<2)>>2]|0;n=c+j+(l>>>5<<2)|0;f[n>>2]=1<<(l&31)|f[n>>2]}}else if(!k){k=f[a+16>>2]|0;do if(b[e+38>>0]|0){n=f[e+56>>2]|0;l=e;if(!n){o=l-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{o=l-(f[n+40>>2]|0)|0;break}}else o=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);n=f[k+(((o|0)/88|0)<<2)>>2]|0;o=c+j+(n>>>5<<2)|0;f[o>>2]=f[o>>2]&~(1<<(n&31))}n=f[g>>2]|0;g=(n|0)==-1;if(h){if(g)return;h=f[a+16>>2]|0;do if(b[e+38>>0]|0){o=f[e+56>>2]|0;j=e;if(!o){p=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{p=j-(f[o+40>>2]|0)|0;break}}else p=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);o=f[h+(((p|0)/88|0)<<2)>>2]|0;p=d+n+(o>>>5<<2)|0;f[p>>2]=1<<(o&31)|f[p>>2];return}else{if(g)return;g=f[a+16>>2]|0;do if(b[e+38>>0]|0){a=f[e+56>>2]|0;p=e;if(!a){q=p-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{q=p-(f[a+40>>2]|0)|0;break}}else q=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);e=f[g+(((q|0)/88|0)<<2)>>2]|0;q=d+n+(e>>>5<<2)|0;f[q>>2]=f[q>>2]&~(1<<(e&31));return}}function Sic(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;g=u;u=u+80|0;h=g+48|0;i=g+24|0;j=g+65|0;k=g;l=g+64|0;m=(f[e+32>>2]|0)==3;n=e+24|0;o=f[n>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(o,h)}o=e+28|0;q=f[165644+(f[o>>2]<<2)>>2]|0;if(m)do switch(q|0){case 1:{m=f[e+52>>2]|0;if(!m){r=f[a+12>>2]|0;do if(b[e+38>>0]|0){s=f[e+56>>2]|0;t=e;if(!s){v=t-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{v=t-(f[s+40>>2]|0)|0;break}}else v=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);s=c+(f[r+(((v|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;w=e;if(!t){x=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{x=w-(f[t+40>>2]|0)|0;break}}else x=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);y=(x|0)/88|0;z=s;A=r}else{t=f[a+12>>2]|0;y=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;z=c+(f[t+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;A=t}Tic(z,d+(f[A+(y<<2)>>2]|0)|0);u=g;return}case 2:{t=f[e+52>>2]|0;if(!t){w=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){D=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{D=C-(f[B+40>>2]|0)|0;break}}else D=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=c+(f[w+(((D|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){r=f[e+56>>2]|0;s=e;if(!r){E=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{E=s-(f[r+40>>2]|0)|0;break}}else E=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);F=(E|0)/88|0;G=m;H=w}else{r=f[a+12>>2]|0;F=((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;G=c+(f[r+(((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;H=r}Uic(G,d+(f[H+(F<<2)>>2]|0)|0);u=g;return}case 3:{r=f[e+52>>2]|0;if(!r){s=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){I=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{I=C-(f[B+40>>2]|0)|0;break}}else I=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);t=c+(f[s+(((I|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){w=f[e+56>>2]|0;m=e;if(!w){J=m-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{J=m-(f[w+40>>2]|0)|0;break}}else J=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);K=(J|0)/88|0;L=t;M=s}else{w=f[a+12>>2]|0;K=((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;L=c+(f[w+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;M=w}Vic(L,d+(f[M+(K<<2)>>2]|0)|0);u=g;return}case 4:{w=f[e+52>>2]|0;if(!w){m=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){N=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{N=C-(f[B+40>>2]|0)|0;break}}else N=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);r=c+(f[m+(((N|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){s=f[e+56>>2]|0;t=e;if(!s){O=t-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{O=t-(f[s+40>>2]|0)|0;break}}else O=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);P=(O|0)/88|0;Q=r;R=m}else{s=f[a+12>>2]|0;P=((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Q=c+(f[s+(((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;R=s}Wic(Q,d+(f[R+(P<<2)>>2]|0)|0);u=g;return}case 6:{s=f[e+52>>2]|0;if(!s){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){S=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{S=C-(f[B+40>>2]|0)|0;break}}else S=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);w=c+(f[t+(((S|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){m=f[e+56>>2]|0;r=e;if(!m){T=r-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{T=r-(f[m+40>>2]|0)|0;break}}else T=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);U=(T|0)/88|0;V=w;W=t}else{m=f[a+12>>2]|0;U=((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;V=c+(f[m+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;W=m}Xic(V,d+(f[W+(U<<2)>>2]|0)|0);u=g;return}case 5:{m=f[e+52>>2]|0;if(!m){r=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){X=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{X=C-(f[B+40>>2]|0)|0;break}}else X=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);s=c+(f[r+(((X|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;w=e;if(!t){Y=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Y=w-(f[t+40>>2]|0)|0;break}}else Y=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Z=(Y|0)/88|0;_=s;$=r}else{t=f[a+12>>2]|0;Z=((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;_=c+(f[t+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;$=t}Yic(_,d+(f[$+(Z<<2)>>2]|0)|0);u=g;return}case 7:{t=f[e+52>>2]|0;if(!t){w=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){aa=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{aa=C-(f[B+40>>2]|0)|0;break}}else aa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);m=c+(f[w+(((aa|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){r=f[e+56>>2]|0;s=e;if(!r){ba=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ba=s-(f[r+40>>2]|0)|0;break}}else ba=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ca=(ba|0)/88|0;da=m;ea=w}else{r=f[a+12>>2]|0;ca=((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;da=c+(f[r+(((t-(f[(f[t+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ea=r}Zic(da,d+(f[ea+(ca<<2)>>2]|0)|0);u=g;return}case 8:{r=f[e+52>>2]|0;if(!r){s=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){fa=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{fa=C-(f[B+40>>2]|0)|0;break}}else fa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);t=c+(f[s+(((fa|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){w=f[e+56>>2]|0;m=e;if(!w){ga=m-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ga=m-(f[w+40>>2]|0)|0;break}}else ga=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ha=(ga|0)/88|0;ia=t;ja=s}else{w=f[a+12>>2]|0;ha=((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;ia=c+(f[w+(((r-(f[(f[r+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ja=w}Tic(ia,d+(f[ja+(ha<<2)>>2]|0)|0);u=g;return}case 9:{w=f[e+52>>2]|0;if(!w){m=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){ka=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ka=C-(f[B+40>>2]|0)|0;break}}else ka=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);r=c+(f[m+(((ka|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){s=f[e+56>>2]|0;t=e;if(!s){la=t-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{la=t-(f[s+40>>2]|0)|0;break}}else la=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ma=(la|0)/88|0;na=r;oa=m}else{s=f[a+12>>2]|0;ma=((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;na=c+(f[s+(((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;oa=s}s=d+(f[oa+(ma<<2)>>2]|0)|0;if((f[s>>2]|0)==(f[na>>2]|0)){t=na+12|0;B=s+12|0;C=f[t>>2]|0;f[t>>2]=f[B>>2];f[B>>2]=C;C=na+4|0;B=s+4|0;t=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=t;t=na+8|0;B=s+8|0;C=f[t>>2]|0;f[t>>2]=f[B>>2];f[B>>2]=C;u=g;return}else{_ic(na,s);u=g;return}break}case 10:{s=f[n>>2]|0;if(s|0?(f[s>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(s,h)}if((f[o>>2]|0)==11?D3b(e)|0:0){s=e+52|0;C=f[s>>2]|0;if(!C){B=f[a+12>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;pa=e;if(!t){qa=pa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{qa=pa-(f[t+40>>2]|0)|0;break}}else qa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ra=B+(((qa|0)/88|0)<<2)|0}else ra=(f[a+12>>2]|0)+(((C-(f[(f[C+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)|0;w=alc(c+(f[ra>>2]|0)|0)|0;m=f[s>>2]|0;if(!m){r=f[a+12>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;pa=e;if(!t){sa=pa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{sa=pa-(f[t+40>>2]|0)|0;break}}else sa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);ta=r+(((sa|0)/88|0)<<2)|0}else ta=(f[a+12>>2]|0)+(((m-(f[(f[m+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)|0;s=alc(d+(f[ta>>2]|0)|0)|0;if((f[s>>2]|0)==(f[w>>2]|0)){C=w+12|0;B=s+12|0;t=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=t;t=w+4|0;B=s+4|0;C=f[t>>2]|0;f[t>>2]=f[B>>2];f[B>>2]=C;C=w+8|0;B=s+8|0;t=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=t;u=g;return}else{$ic(w,s);u=g;return}}s=f[e+52>>2]|0;if(!s){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){B=f[e+56>>2]|0;C=e;if(!B){ua=C-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ua=C-(f[B+40>>2]|0)|0;break}}else ua=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);w=c+(f[t+(((ua|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){m=f[e+56>>2]|0;r=e;if(!m){va=r-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{va=r-(f[m+40>>2]|0)|0;break}}else va=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);wa=(va|0)/88|0;xa=w;ya=t}else{m=f[a+12>>2]|0;wa=((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;xa=c+(f[m+(((s-(f[(f[s+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ya=m}m=d+(f[ya+(wa<<2)>>2]|0)|0;if((f[m>>2]|0)==(f[xa>>2]|0)){r=xa+12|0;B=m+12|0;C=f[r>>2]|0;f[r>>2]=f[B>>2];f[B>>2]=C;C=xa+4|0;B=m+4|0;r=f[C>>2]|0;f[C>>2]=f[B>>2];f[B>>2]=r;r=xa+8|0;B=m+8|0;C=f[r>>2]|0;f[r>>2]=f[B>>2];f[B>>2]=C;u=g;return}else{$ic(xa,m);u=g;return}break}default:{u_b(i,3,497294,377);m=p_b(i,500058)|0;C=f[n>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(C,h)}r_b(j,s_b(m,f[165644+(f[o>>2]<<2)>>2]|0)|0);v_b(i);u=g;return}}while(0);do switch(q|0){case 1:{i=f[e+52>>2]|0;if(!i){j=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;wa=e;if(!xa){za=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{za=wa-(f[xa+40>>2]|0)|0;break}}else za=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);s=c+(f[j+(((za|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;w=e;if(!t){Aa=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Aa=w-(f[t+40>>2]|0)|0;break}}else Aa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Ba=(Aa|0)/88|0;Ca=s;Da=j}else{t=f[a+12>>2]|0;Ba=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ca=c+(f[t+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Da=t}t=d+(f[Da+(Ba<<2)>>2]|0)|0;w=f[Ca>>2]|0;f[Ca>>2]=f[t>>2];f[t>>2]=w;u=g;return}case 2:{w=f[e+52>>2]|0;if(!w){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;wa=e;if(!xa){Ea=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ea=wa-(f[xa+40>>2]|0)|0;break}}else Ea=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=c+(f[t+(((Ea|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;s=e;if(!j){Fa=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Fa=s-(f[j+40>>2]|0)|0;break}}else Fa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Ga=(Fa|0)/88|0;Ha=i;Ia=t}else{j=f[a+12>>2]|0;Ga=((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ha=c+(f[j+(((w-(f[(f[w+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Ia=j}j=d+(f[Ia+(Ga<<2)>>2]|0)|0;s=Ha;xa=f[s>>2]|0;wa=f[s+4>>2]|0;s=j;ya=f[s+4>>2]|0;va=Ha;f[va>>2]=f[s>>2];f[va+4>>2]=ya;ya=j;f[ya>>2]=xa;f[ya+4>>2]=wa;u=g;return}case 3:{wa=f[e+52>>2]|0;if(!wa){ya=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;j=e;if(!xa){Ja=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ja=j-(f[xa+40>>2]|0)|0;break}}else Ja=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);w=c+(f[ya+(((Ja|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;i=e;if(!t){Ka=i-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ka=i-(f[t+40>>2]|0)|0;break}}else Ka=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);La=(Ka|0)/88|0;Ma=w;Na=ya}else{t=f[a+12>>2]|0;La=((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ma=c+(f[t+(((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Na=t}t=d+(f[Na+(La<<2)>>2]|0)|0;i=f[Ma>>2]|0;f[Ma>>2]=f[t>>2];f[t>>2]=i;u=g;return}case 4:{i=f[e+52>>2]|0;if(!i){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;j=e;if(!xa){Oa=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Oa=j-(f[xa+40>>2]|0)|0;break}}else Oa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);wa=c+(f[t+(((Oa|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){ya=f[e+56>>2]|0;w=e;if(!ya){Pa=w-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Pa=w-(f[ya+40>>2]|0)|0;break}}else Pa=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Qa=(Pa|0)/88|0;Ra=wa;Sa=t}else{ya=f[a+12>>2]|0;Qa=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Ra=c+(f[ya+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;Sa=ya}ya=d+(f[Sa+(Qa<<2)>>2]|0)|0;w=Ra;xa=f[w>>2]|0;j=f[w+4>>2]|0;w=ya;va=f[w+4>>2]|0;s=Ra;f[s>>2]=f[w>>2];f[s+4>>2]=va;va=ya;f[va>>2]=xa;f[va+4>>2]=j;u=g;return}case 6:{j=f[e+52>>2]|0;if(!j){va=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){Ta=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ta=ya-(f[xa+40>>2]|0)|0;break}}else Ta=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=c+(f[va+(((Ta|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;wa=e;if(!t){Ua=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ua=wa-(f[t+40>>2]|0)|0;break}}else Ua=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);Va=(Ua|0)/88|0;Wa=va;Xa=i}else{t=f[a+12>>2]|0;Va=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;Wa=t;Xa=c+(f[t+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0}t=d+(f[Wa+(Va<<2)>>2]|0)|0;wa=f[Xa>>2]|0;f[Xa>>2]=f[t>>2];f[t>>2]=wa;u=g;return}case 5:{wa=f[e+52>>2]|0;if(!wa){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){Ya=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ya=ya-(f[xa+40>>2]|0)|0;break}}else Ya=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);j=c+(f[t+(((Ya|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){i=f[e+56>>2]|0;va=e;if(!i){Za=va-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Za=va-(f[i+40>>2]|0)|0;break}}else Za=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);_a=(Za|0)/88|0;$a=j;ab=t}else{i=f[a+12>>2]|0;_a=((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;$a=c+(f[i+(((wa-(f[(f[wa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;ab=i}i=d+(f[ab+(_a<<2)>>2]|0)|0;bb=+p[$a>>3];p[$a>>3]=+p[i>>3];p[i>>3]=bb;u=g;return}case 7:{i=f[e+52>>2]|0;if(!i){va=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){cb=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{cb=ya-(f[xa+40>>2]|0)|0;break}}else cb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);wa=c+(f[va+(((cb|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;j=e;if(!t){db=j-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{db=j-(f[t+40>>2]|0)|0;break}}else db=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);eb=(db|0)/88|0;fb=va;gb=wa}else{t=f[a+12>>2]|0;eb=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;fb=t;gb=c+(f[t+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0}t=d+(f[fb+(eb<<2)>>2]|0)|0;j=b[gb>>0]|0;b[gb>>0]=b[t>>0]|0;b[t>>0]=j;u=g;return}case 8:{j=f[e+52>>2]|0;if(!j){t=f[a+12>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;ya=e;if(!xa){hb=ya-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{hb=ya-(f[xa+40>>2]|0)|0;break}}else hb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=c+(f[t+(((hb|0)/88|0)<<2)>>2]|0)|0;do if(b[e+38>>0]|0){wa=f[e+56>>2]|0;va=e;if(!wa){ib=va-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ib=va-(f[wa+40>>2]|0)|0;break}}else ib=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);jb=(ib|0)/88|0;kb=i;lb=t}else{wa=f[a+12>>2]|0;jb=((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;kb=c+(f[wa+(((j-(f[(f[j+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0)|0;lb=wa}wa=d+(f[lb+(jb<<2)>>2]|0)|0;va=f[kb>>2]|0;f[kb>>2]=f[wa>>2];f[wa>>2]=va;u=g;return}case 10:{va=f[a+24>>2]|0;wa=f[c+va>>2]|0;xa=wa&-2;if(!(wa&1))mb=xa;else mb=f[xa+4>>2]|0;xa=f[d+va>>2]|0;va=xa&-2;if(!(xa&1))nb=va;else nb=f[va+4>>2]|0;va=(mb|0)==(nb|0);xa=f[e+52>>2]|0;if(!xa){wa=f[a+12>>2]|0;do if(b[e+38>>0]|0){ya=f[e+56>>2]|0;s=e;if(!ya){ob=s-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{ob=s-(f[ya+40>>2]|0)|0;break}}else ob=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);j=f[wa+(((ob|0)/88|0)<<2)>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;i=e;if(!t){pb=i-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{pb=i-(f[t+40>>2]|0)|0;break}}else pb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);qb=(pb|0)/88|0;rb=j;sb=wa}else{t=f[a+12>>2]|0;qb=((xa-(f[(f[xa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;rb=f[t+(((xa-(f[(f[xa+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0;sb=t}t=c+rb|0;i=d+(f[sb+(qb<<2)>>2]|0)|0;if(va){ya=f[t>>2]|0;f[t>>2]=f[i>>2];f[i>>2]=ya;u=g;return}ya=f[t>>2]|0;s=(f[i>>2]|0)==0;if(!ya){if(s){u=g;return}w=f[i>>2]|0;ua=f[(f[w>>2]|0)+16>>2]|0;ta=_i[f[(f[c>>2]|0)+20>>2]&2047](c)|0;sa=Mi[ua&1023](w,ta)|0;f[t>>2]=sa;mi[f[(f[sa>>2]|0)+72>>2]&2047](sa,f[i>>2]|0);Rgc(a,d,e);u=g;return}if(s){s=f[(f[ya>>2]|0)+16>>2]|0;sa=_i[f[(f[d>>2]|0)+20>>2]&2047](d)|0;ta=Mi[s&1023](ya,sa)|0;f[i>>2]=ta;mi[f[(f[ta>>2]|0)+72>>2]&2047](ta,f[t>>2]|0);Rgc(a,c,e);u=g;return}else{mi[f[(f[ya>>2]|0)+96>>2]&2047](h,ya);ya=f[h+4>>2]|0;Ti[f[(f[ya>>2]|0)+52>>2]&511](ya,f[t>>2]|0,f[i>>2]|0);u=g;return}break}case 9:{i=f[a+24>>2]|0;t=f[c+i>>2]|0;ya=t&-2;if(!(t&1))tb=ya;else tb=f[ya+4>>2]|0;ya=f[d+i>>2]|0;i=ya&-2;if(!(ya&1))ub=i;else ub=f[i+4>>2]|0;i=f[e+52>>2]|0;if(!i){ya=f[a+12>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;ta=e;if(!t){vb=ta-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{vb=ta-(f[t+40>>2]|0)|0;break}}else vb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);va=f[ya+(((vb|0)/88|0)<<2)>>2]|0;do if(b[e+38>>0]|0){xa=f[e+56>>2]|0;wa=e;if(!xa){wb=wa-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{wb=wa-(f[xa+40>>2]|0)|0;break}}else wb=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);xb=(wb|0)/88|0;yb=va;zb=ya}else{xa=f[a+12>>2]|0;xb=((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)|0;yb=f[xa+(((i-(f[(f[i+8>>2]|0)+24>>2]|0)|0)/28|0)+(f[(f[e+48>>2]|0)+52>>2]|0)<<2)>>2]|0;zb=xa}xa=c+yb|0;wa=d+(f[zb+(xb<<2)>>2]|0)|0;if((tb|0)==(ub|0)){j=f[xa>>2]|0;f[xa>>2]=f[wa>>2];f[wa>>2]=j;u=g;return}j=f[a+8>>2]|0;do if(b[e+38>>0]|0){t=f[e+56>>2]|0;ta=e;if(!t){Ab=ta-(f[(f[e+20>>2]|0)+80>>2]|0)|0;break}else{Ab=ta-(f[t+40>>2]|0)|0;break}}else Ab=e-(f[(f[e+48>>2]|0)+20>>2]|0)|0;while(0);i=f[j+(f[zb+(((Ab|0)/88|0)<<2)>>2]|0)>>2]|0;lYc(h,f[xa>>2]|0);ya=f[wa>>2]|0;va=f[xa>>2]|0;if((va|0)==(i|0))xJa(xa,tb,ya);else oYc(va,ya)|0;ya=f[wa>>2]|0;if((ya|0)==(i|0))xJa(wa,ub,h);else oYc(ya,h)|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);u=g;return}default:{u_b(k,3,497294,446);ya=p_b(k,500058)|0;i=f[n>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(i,h)}r_b(l,s_b(ya,f[165644+(f[o>>2]<<2)>>2]|0)|0);v_b(k);u=g;return}}while(0)}function Tic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)SXb(m,25456,8);h=QXb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){qHa(d,m);m=f[d>>2]|0;o1c((f[k>>2]|0)+4+(m<<2)|0,(f[e>>2]|0)+4|0,f[a>>2]<<2|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){qHa(a,m);o1c((f[e>>2]|0)+4+(f[a>>2]<<2)|0,(f[i>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)cYc(n);u=c;return}function Uic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)SXb(m,25456,8);h=QXb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){_Ma(d,m);m=f[d>>2]|0;o1c((f[k>>2]|0)+8+(m<<3)|0,(f[e>>2]|0)+8|0,f[a>>2]<<3|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){_Ma(a,m);o1c((f[e>>2]|0)+8+(f[a>>2]<<3)|0,(f[i>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)cYc(n);u=c;return}function Vic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)SXb(m,25456,8);h=QXb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){xHa(d,m);m=f[d>>2]|0;o1c((f[k>>2]|0)+4+(m<<2)|0,(f[e>>2]|0)+4|0,f[a>>2]<<2|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){xHa(a,m);o1c((f[e>>2]|0)+4+(f[a>>2]<<2)|0,(f[i>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)cYc(n);u=c;return}function Wic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)SXb(m,25456,8);h=QXb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){mob(d,m);m=f[d>>2]|0;o1c((f[k>>2]|0)+8+(m<<3)|0,(f[e>>2]|0)+8|0,f[a>>2]<<3|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){mob(a,m);o1c((f[e>>2]|0)+8+(f[a>>2]<<3)|0,(f[i>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)cYc(n);u=c;return}function Xic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)SXb(m,25456,8);h=QXb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){uHa(d,m);m=f[d>>2]|0;o1c((f[k>>2]|0)+4+(m<<2)|0,(f[e>>2]|0)+4|0,f[a>>2]<<2|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){uHa(a,m);o1c((f[e>>2]|0)+4+(f[a>>2]<<2)|0,(f[i>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)cYc(n);u=c;return}function Yic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)SXb(m,25456,8);h=QXb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){ZMa(d,m);m=f[d>>2]|0;o1c((f[k>>2]|0)+8+(m<<3)|0,(f[e>>2]|0)+8|0,f[a>>2]<<3|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){ZMa(a,m);o1c((f[e>>2]|0)+8+(f[a>>2]<<3)|0,(f[i>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)cYc(n);u=c;return}function Zic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;l=b+4|0;h=f[g>>2]|0;f[g>>2]=f[l>>2];f[l>>2]=h;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){if(f[m+64>>2]|0)SXb(m,25456,8);h=QXb(m,8)|0;f[k>>2]=h;f[h>>2]=m}m=f[a>>2]|0;if(m|0){wSa(d,m);m=f[d>>2]|0;o1c((f[k>>2]|0)+4+m|0,(f[e>>2]|0)+4|0,f[a>>2]|0)|0;f[d>>2]=m+(f[a>>2]|0)}f[a>>2]=0;m=f[b>>2]|0;if(m|0){wSa(a,m);o1c((f[a>>2]|0)+((f[e>>2]|0)+4)|0,(f[i>>2]|0)+4|0,f[b>>2]|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0)}if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)cYc(n);u=c;return}function _ic(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=e+4|0;f[g>>2]=0;h=e+8|0;f[h>>2]=0;i=e+12|0;f[i>>2]=0;bjc(e,a);j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[a+12>>2]|0;m=0;do{n=f[l+4+(m<<2)>>2]|0;m=m+1|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0}else{b[n>>0]=0;b[o>>0]=0}}while((m|0)!=(k|0));f[j>>2]=0}bjc(a,c);a=c+4|0;j=f[a>>2]|0;k=c+12|0;if((j|0)>0){m=f[k>>2]|0;l=0;do{o=f[m+4+(l<<2)>>2]|0;l=l+1|0;n=o+11|0;if((b[n>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[n>>0]=0}}while((l|0)!=(j|0));f[a>>2]=0;p=0}else p=j;j=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=j;f[a>>2]=f[g>>2];f[g>>2]=p;p=c+8|0;c=f[p>>2]|0;f[p>>2]=f[h>>2];f[h>>2]=c;c=j;if(!((j|0)!=0&(f[e>>2]|0)==0)){u=d;return}e=j;j=f[c>>2]|0;if((j|0)>0){h=0;do{p=f[c+4+(h<<2)>>2]|0;if(p|0){if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);cYc(p)}h=h+1|0}while((h|0)!=(j|0));q=f[i>>2]|0}else q=e;cYc(q);u=d;return}function $ic(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;ajc(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;Yi[f[(f[m>>2]|0)+28>>2]&4095](m)}while((l|0)!=(j|0));f[i>>2]=0}ajc(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{m=f[l+4+(k<<2)>>2]|0;k=k+1|0;Yi[f[(f[m>>2]|0)+28>>2]&4095](m)}while((k|0)!=(i|0));f[a>>2]=0;n=0}else n=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=n;n=b+8|0;b=f[n>>2]|0;f[n>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{n=f[b+4+(g<<2)>>2]|0;if(n|0)Yi[f[(f[n>>2]|0)+4>>2]&4095](n);g=g+1|0}while((g|0)!=(i|0));o=f[h>>2]|0}else o=d;cYc(o);u=c;return}function ajc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{yic(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Joc(h,i)|0;yic(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function bjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{VZb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;VZb(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)==(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,4984,16);l=RXb(i,16,2233)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;VZb(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function cjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=y3b(a,c)|0;if(g|0){h=f[g>>2]|0;u=d;return h|0}if((f[223513]|0)==2){h=537368;u=d;return h|0}f[e>>2]=165456;f[e+4>>2]=125;b[e+8>>0]=0;J_b(894052,e);a_b(e);h=537368;u=d;return h|0}function djc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;f[a>>2]=171104;g=a+4|0;f[g>>2]=b;h=a+8|0;i=c;c=h+36|0;do{f[h>>2]=f[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(c|0));if(!d){i=m3b()|0;j=i;k=f[g>>2]|0}else{j=d;k=b}f[a+44>>2]=j;f[a+48>>2]=e;f[a+52>>2]=(f[k+52>>2]|0)+-1;return}function ejc(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+64|0;l=k;m=k+8|0;n=k+32|0;o=j0b(m3b()|0,a)|0;if(!o){u_b(m,3,497294,2329);r_b(k+56|0,p_b(m,500261)|0);v_b(m)}if(!g)p=uoc()|0;else p=g;f[n>>2]=p;p=n+4|0;f[p>>2]=h;g=n+8|0;f[g>>2]=i;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;e=o+28|0;if((f[e>>2]|0)>0){d=o+68|0;c=0;do{fjc(n,(f[d>>2]|0)+(c*88|0)|0);c=c+1|0}while((c|0)<(f[e>>2]|0))}e=f[o+32>>2]|0;if((e|0)>0){c=o+72|0;d=0;n=f[g>>2]|0;do{f[n>>2]=(f[c>>2]|0)+(d*48|0);n=n+4|0;d=d+1|0}while((d|0)<(e|0));f[g>>2]=n}if(b[(f[o+84>>2]|0)+84>>0]|0?(n=f[o+36>>2]|0,(n|0)>0):0){g=o+76|0;o=0;do{f[j+(o<<2)>>2]=(f[g>>2]|0)+(o*24|0);o=o+1|0}while((o|0)<(n|0))}n=gjc()|0;o=f[p>>2]|0;g_b(n);f[l>>2]=h;f[l+4>>2]=o;o=n+8|0;h=f[o>>2]|0;if(h>>>0<(f[n+12>>2]|0)>>>0){p=l;g=f[p+4>>2]|0;j=h;f[j>>2]=f[p>>2];f[j+4>>2]=g;f[o>>2]=(f[o>>2]|0)+8;h_b(n);u=k;return}else{hjc(n+4|0,l);h_b(n);u=k;return}}function fjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=b+60|0;if((f[c>>2]|0)>0){d=b+28|0;e=0;do{fjc(a,(f[d>>2]|0)+(e*88|0)|0);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=a+4|0;f[f[c>>2]>>2]=b;e=$Xc(56)|0;d=a+16|0;g=f[a+20>>2]|0;h=a+12|0;i=f[h>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;l=f[i+8>>2]|0;i=f[f[d>>2]>>2]|0;m=g+(j<<2)|0;n=f[m>>2]|0;o=f[g+(j+1<<2)>>2]|0;p=f[g+(j+2<<2)>>2]|0;q=f[g+(j+3<<2)>>2]|0;r=f[g+(j+4<<2)>>2]|0;j=m3b()|0;s=f[a>>2]|0;f[e>>2]=171104;t=e+4|0;f[t>>2]=b;f[e+8>>2]=i;f[e+12>>2]=m+20;f[e+16>>2]=g+(k<<2);f[e+20>>2]=n;f[e+24>>2]=o;f[e+28>>2]=p;f[e+32>>2]=q;f[e+36>>2]=l;f[e+40>>2]=r;if(!j){r=m3b()|0;u=r;v=f[t>>2]|0}else{u=j;v=b}f[e+44>>2]=u;f[e+48>>2]=s;f[e+52>>2]=(f[v+52>>2]|0)+-1;v=f[c>>2]|0;f[v+4>>2]=e;e=f[b+64>>2]|0;if((e|0)<=0){w=v;x=f[h>>2]|0;y=x+12|0;f[h>>2]=y;z=f[d>>2]|0;A=z+4|0;f[d>>2]=A;B=w+8|0;f[c>>2]=B;return}v=b+32|0;b=a+8|0;a=0;s=f[b>>2]|0;do{f[s>>2]=(f[v>>2]|0)+(a*48|0);s=(f[b>>2]|0)+4|0;f[b>>2]=s;a=a+1|0}while((a|0)<(e|0));w=f[c>>2]|0;x=f[h>>2]|0;y=x+12|0;f[h>>2]=y;z=f[d>>2]|0;A=z+4|0;f[d>>2]=A;B=w+8|0;f[c>>2]=B;return}function gjc(){var a=0,c=0;if(b[539088]|0){a=f[223574]|0;return a|0}if(!(X0c(539088)|0)){a=f[223574]|0;return a|0}c=$Xc(16)|0;w_b(c);f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;l_b(164);f[223574]=c;a=f[223574]|0;return a|0}function hjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function ijc(){var a=0,b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=gjc()|0;if(!a)return;b=a+4|0;c=a+8|0;d=f[c>>2]|0;e=f[b>>2]|0;g=e;if((d|0)==(e|0)){h=d;i=g}else{j=0;k=g;g=d;d=e;while(1){e=f[k+(j<<3)>>2]|0;if(e>>>0<(f[k+(j<<3)+4>>2]|0)>>>0){l=e;e=d;m=k;while(1){n=f[l+4>>2]|0;if(!n){o=m;p=e}else{Yi[f[(f[n>>2]|0)+4>>2]&4095](n);n=f[b>>2]|0;o=n;p=n}l=l+8|0;if(l>>>0>=(f[o+(j<<3)+4>>2]|0)>>>0)break;else{e=p;m=o}}q=p;r=f[c>>2]|0}else{q=d;r=g}j=j+1|0;m=q;if(j>>>0>=r-q>>3>>>0){h=r;i=m;break}else{k=m;g=r;d=q}}}q=h;if(i|0){if((q|0)!=(i|0))f[c>>2]=q+(~((q+-8-i|0)>>>3)<<3);cYc(i)}x_b(a);cYc(a);return}function jjc(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)>0)c=0;else return;do{d=f[a+(c<<3)+4>>2]|0;if(d|0)Foc(f[a+(c<<3)>>2]|0,f[d+8>>2]|0);c=c+1|0}while((c|0)!=(b|0));return}function kjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0.0;d=u;u=u+128|0;e=d;g=d+104|0;h=d+72|0;i=d+48|0;j=d+24|0;k=d+20|0;l=d+8|0;m=+aLc(a,k);n=(c|0)!=0;o=f[k>>2]|0;if(n)f[c>>2]=o;if((b[o>>0]|0)!=46){q=m;u=d;return +q}p[e>>3]=1.5;k=cLc(g,500290,e)|0;if((b[g>>0]|0)!=49){u_b(h,3,500295,63);r_b(d+98|0,p_b(h,500386)|0);v_b(h)}if((b[g+(k+-1)>>0]|0)!=53){u_b(i,3,500295,64);r_b(d+97|0,p_b(i,500421)|0);v_b(i)}if((k|0)>=7){u_b(j,3,500295,65);r_b(d+96|0,p_b(j,500461)|0);v_b(j)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;sYc(l,k+-3+(dJc(a)|0)|0);ljc(l,a,o)|0;zYc(l,g+1|0,k+-2|0)|0;AYc(l,o+1|0)|0;k=l+11|0;g=(b[k>>0]|0)<0?f[l>>2]|0:l;m=+aLc(g,e);j=f[e>>2]|0;e=g;g=b[k>>0]|0;if(n&(j-e|0)>(o-a|0)){o=g<<24>>24<0?f[l+4>>2]|0:g&255;n=a+((dJc(a)|0)-(o+e)+j)|0;f[c>>2]=n}if(g<<24>>24<0)cYc(f[l>>2]|0);q=m;u=d;return +q}function ljc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=c;h=e;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[a+8>>2]&2147483647)+-1|0}else{l=j&255;m=10}n=d-g|0;if(!n){u=e;return a|0}if(k){k=f[a>>2]|0;o=k;p=f[a+4>>2]|0;q=k}else{o=a;p=j&255;q=a}if(q>>>0<=c>>>0&(o+p|0)>>>0>c>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(n>>>0>4294967279)jYc(h);if(n>>>0<11){b[h+11>>0]=n;r=h}else{p=n+16&-16;o=$Xc(p)|0;f[h>>2]=o;f[h+8>>2]=p|-2147483648;f[h+4>>2]=n;r=o}if((c|0)==(d|0))s=r;else{o=r;p=c;while(1){b[o>>0]=b[p>>0]|0;p=p+1|0;if((p|0)==(d|0))break;else o=o+1|0}s=r+n|0}b[s>>0]=0;s=h+11|0;r=b[s>>0]|0;o=r<<24>>24<0;zYc(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:r&255)|0;if((b[s>>0]|0)<0)cYc(f[h>>2]|0);u=e;return a|0}if((m-l|0)>>>0<n>>>0){wYc(a,m,l+n-m|0,l,l,0,0);t=b[i>>0]|0}else t=j;if(t<<24>>24<0)v=f[a>>2]|0;else v=a;t=v+l|0;if((c|0)==(d|0))w=t;else{j=d+(l-g)|0;g=c;c=t;while(1){b[c>>0]=b[g>>0]|0;g=g+1|0;if((g|0)==(d|0))break;else c=c+1|0}w=v+j|0}b[w>>0]=0;w=l+n|0;if((b[i>>0]|0)<0){f[a+4>>2]=w;u=e;return a|0}else{b[i>>0]=w;u=e;return a|0}return 0}function mjc(a){a=+a;var b=0.0;if(!(a>3402823466385288598117041.0e14))if(a<-3402823466385288598117041.0e14)b=-D;else b=a;else b=D;return +b}function njc(a){a=a|0;return}function ojc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=a+32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=a+56|0;f[h>>2]=c;f[a+60>>2]=d;d=a+68|0;i=a+72|0;j=a+80|0;f[a+84>>2]=0;f[a+88>>2]=0;f[a+92>>2]=0;k=d+4|0;f[k>>2]=0;f[k+4>>2]=0;b[k+8>>0]=0;f[a+96>>2]=-1;b[a+100>>0]=0;f[a+104>>2]=0;b[a+108>>0]=1;b[a+109>>0]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a>>2]=0;f[g>>2]=0;f[d>>2]=0;f[a+76>>2]=0;k=c;while(1){if(!(hj[f[(f[k>>2]|0)+8>>2]&511](k,g,i)|0)){l=3;break}if(f[i>>2]|0){l=6;break}k=f[h>>2]|0}if((l|0)==3){f[i>>2]=0;b[j>>0]=1;m=0;n=a+64|0;b[n>>0]=m;u=e;return}else if((l|0)==6){l=f[g>>2]|0;f[d>>2]=l;m=b[l>>0]|0;n=a+64|0;b[n>>0]=m;u=e;return}}function pjc(a){a=a|0;var c=0,d=0,e=0;c=f[a+72>>2]|0;d=f[a+76>>2]|0;if((c|0)>(d|0)){e=f[a+56>>2]|0;mi[f[(f[e>>2]|0)+12>>2]&2047](e,c-d|0)}d=a+32|0;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);d=a+4|0;if((b[d+11>>0]|0)>=0)return;cYc(f[d>>2]|0);return}function qjc(a){a=a|0;var c=0;c=a+4|0;if((b[c+11>>0]|0)>=0)return;cYc(f[c>>2]|0);return}function rjc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+64|0;g=b[e>>0]|0;if(g<<24>>24==10){h=a+84|0;f[h>>2]=(f[h>>2]|0)+1;f[a+88>>2]=0}else{h=a+88|0;i=f[h>>2]|0;if(g<<24>>24==9)j=8-((i|0)%8|0)|0;else j=1;f[h>>2]=j+i}i=a+76|0;j=(f[i>>2]|0)+1|0;f[i>>2]=j;h=a+72|0;g=f[h>>2]|0;if((j|0)<(g|0)){b[e>>0]=b[(f[a+68>>2]|0)+j>>0]|0;u=c;return}j=a+80|0;if(b[j>>0]|0){b[e>>0]=0;u=c;return}k=f[a+92>>2]|0;if(k|0?(l=a+96|0,m=f[l>>2]|0,(g|0)>(m|0)):0){zYc(k,(f[a+68>>2]|0)+m|0,g-m|0)|0;f[l>>2]=0}f[d>>2]=0;l=a+68|0;f[l>>2]=0;f[i>>2]=0;i=a+56|0;while(1){a=f[i>>2]|0;if(!(hj[f[(f[a>>2]|0)+8>>2]&511](a,d,h)|0)){n=15;break}if(f[h>>2]|0){n=17;break}}if((n|0)==15){f[h>>2]=0;b[j>>0]=1;o=0}else if((n|0)==17){n=f[d>>2]|0;f[l>>2]=n;o=b[n>>0]|0}b[e>>0]=o;u=c;return}function sjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;g=a+64|0;h=a+109|0;i=e+8|0;j=e+4|0;k=a+60|0;l=a+84|0;m=a+88|0;n=e+11|0;o=e+8|0;p=e+4|0;q=e+11|0;r=e+8|0;s=e+4|0;t=e+11|0;v=e+8|0;w=e+4|0;x=e+11|0;a:while(1){y=b[g>>0]|0;switch(y<<24>>24|0){case 0:{z=3;break a;break}case 10:{if(!(b[h>>0]|0)){z=7;break a}rjc(a);continue a;break}case 92:{rjc(a);A=b[g>>0]|0;switch(A<<24>>24){case 34:case 39:case 63:case 92:case 118:case 116:case 114:case 110:case 102:case 98:case 97:{rjc(a);continue a;break}default:{}}if((A&-8)<<24>>24==48){rjc(a);continue a}switch(A<<24>>24){case 120:{rjc(a);A=b[g>>0]|0;b:do if((A+-48&255)>=10){switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{break b;break}default:{}}B=$Xc(48)|0;f[e>>2]=B;f[i>>2]=-2147483600;f[j>>2]=40;C=B;D=500601;E=C+40|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+40>>0]=0;F=f[k>>2]|0;ei[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[n>>0]|0)<0)cYc(f[e>>2]|0);continue a}while(0);rjc(a);continue a;break}case 117:{rjc(a);A=b[g>>0]|0;if((A+-48&255)<10)z=24;else switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{z=24;break}default:{}}c:do if((z|0)==24){z=0;rjc(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}rjc(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}rjc(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}rjc(a);continue a}while(0);A=$Xc(64)|0;f[e>>2]=A;f[o>>2]=-2147483584;f[p>>2]=48;C=A;D=500642;E=C+48|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[A+48>>0]=0;F=f[k>>2]|0;ei[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[q>>0]|0)<0)cYc(f[e>>2]|0);continue a;break}case 85:{rjc(a);d:do if((b[g>>0]|0)==48?(rjc(a),(b[g>>0]|0)==48):0){rjc(a);switch(b[g>>0]|0){case 48:{rjc(a);break}case 49:{rjc(a);break}default:break d}F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}rjc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}rjc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}rjc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}rjc(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}rjc(a);continue a}while(0);A=$Xc(64)|0;f[e>>2]=A;f[r>>2]=-2147483584;f[s>>2]=61;C=A;D=500691;E=C+61|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[A+61>>0]=0;F=f[k>>2]|0;ei[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[t>>0]|0)<0)cYc(f[e>>2]|0);continue a;break}default:{F=$Xc(48)|0;f[e>>2]=F;f[v>>2]=-2147483600;f[w>>2]=42;C=F;D=500753;E=C+42|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[F+42>>0]=0;A=f[k>>2]|0;ei[f[(f[A>>2]|0)+8>>2]&511](A,f[l>>2]|0,f[m>>2]|0,e);if((b[x>>0]|0)<0)cYc(f[e>>2]|0);continue a}}break}default:{rjc(a);if(y<<24>>24==c<<24>>24){z=57;break a}else continue a}}}if((z|0)==3){c=$Xc(32)|0;f[e>>2]=c;f[e+8>>2]=-2147483616;f[e+4>>2]=25;C=c;D=500529;E=C+25|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[c+25>>0]=0;c=f[k>>2]|0;ei[f[(f[c>>2]|0)+8>>2]&511](c,f[l>>2]|0,f[m>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}else if((z|0)==7){c=$Xc(48)|0;f[e>>2]=c;f[e+8>>2]=-2147483600;f[e+4>>2]=45;C=c;D=500555;E=C+45|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[c+45>>0]=0;c=f[k>>2]|0;ei[f[(f[c>>2]|0)+8>>2]&511](c,f[l>>2]|0,f[m>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);u=d;return}else if((z|0)==57){u=d;return}}function tjc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+64|0;i=b[h>>0]|0;a:do if(c){switch(i<<24>>24){case 120:{rjc(a);break}case 88:{rjc(a);break}default:{if((i+-48&255)>=10){j=20;break a}if((i&-8)<<24>>24==48){do{rjc(a);k=b[h>>0]|0}while((k&-8)<<24>>24==48);l=k}else l=i;if((l+-48&255)>=10){m=0;break a}k=$Xc(64)|0;f[g>>2]=k;f[g+8>>2]=-2147483584;f[g+4>>2]=52;n=k;o=500833;p=n+52|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[k+52>>0]=0;q=f[a+60>>2]|0;ei[f[(f[q>>2]|0)+8>>2]&511](q,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if(((b[h>>0]|0)+-48&255)>=10){m=0;break a}while(1){rjc(a);if(((b[h>>0]|0)+-48&255)>=10){m=0;break a}}}}k=b[h>>0]|0;b:do if((k+-48&255)>=10){switch(k<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{break b;break}default:{}}q=$Xc(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=36;n=q;o=500796;p=n+36|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+36>>0]=0;r=f[a+60>>2]|0;ei[f[(f[r>>2]|0)+8>>2]&511](r,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);m=0;break a}while(0);while(1){rjc(a);k=b[h>>0]|0;if((k+-48&255)<10)continue;switch(k<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{m=0;break a}}}}else j=20;while(0);c:do if((j|0)==20){if((i+-48&255)<10){do{rjc(a);l=b[h>>0]|0}while((l+-48&255)<10);s=l}else s=i;if(!d)if(s<<24>>24==46){rjc(a);l=b[h>>0]|0;if((l+-48&255)<10){do{rjc(a);c=b[h>>0]|0}while((c+-48&255)<10);t=1;v=c}else{t=1;v=l}}else{t=0;v=s}else{t=1;v=s}switch(v<<24>>24){case 101:{rjc(a);j=29;break}case 69:{rjc(a);j=29;break}default:w=t}d:do if((j|0)==29){switch(b[h>>0]|0){case 45:{rjc(a);break}case 43:{rjc(a);break}default:{}}if(((b[h>>0]|0)+-48&255)<10)while(1){rjc(a);if(((b[h>>0]|0)+-48&255)>=10){w=1;break d}}q=$Xc(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=33;n=q;o=500886;p=n+33|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+33>>0]=0;c=f[a+60>>2]|0;ei[f[(f[c>>2]|0)+8>>2]&511](c,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);w=1}while(0);if(!(b[a+100>>0]|0))m=w;else switch(b[h>>0]|0){case 102:{rjc(a);m=1;break c;break}case 70:{rjc(a);m=1;break c;break}default:{m=w;break c}}}while(0);w=b[h>>0]|0;if(w<<24>>24==95|((w&-33)+-65&255)<26?b[a+108>>0]|0:0){h=$Xc(48)|0;f[g>>2]=h;f[g+8>>2]=-2147483600;f[g+4>>2]=41;n=h;o=500920;p=n+41|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+41>>0]=0;h=f[a+60>>2]|0;ei[f[(f[h>>2]|0)+8>>2]&511](h,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);x=m?4:3;u=e;return x|0}if(w<<24>>24!=46){x=m?4:3;u=e;return x|0}if(m){w=$Xc(64)|0;f[g>>2]=w;f[g+8>>2]=-2147483584;f[g+4>>2]=62;n=w;o=500962;p=n+62|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[w+62>>0]=0;w=f[a+60>>2]|0;ei[f[(f[w>>2]|0)+8>>2]&511](w,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);x=m?4:3;u=e;return x|0}else{w=$Xc(48)|0;f[g>>2]=w;f[g+8>>2]=-2147483600;f[g+4>>2]=39;n=w;o=501025;p=n+39|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[w+39>>0]=0;w=f[a+60>>2]|0;ei[f[(f[w>>2]|0)+8>>2]&511](w,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);x=m?4:3;u=e;return x|0}return 0}function ujc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=a+84|0;h=f[g>>2]|0;i=a+88|0;j=(f[i>>2]|0)+-2|0;k=(c|0)!=0;if(k){l=a+92|0;f[l>>2]=c;m=a+76|0;n=a+96|0;f[n>>2]=f[m>>2];o=l;p=n;q=m}else{o=a+92|0;p=a+96|0;q=a+76|0}m=a+64|0;n=a+68|0;l=e+8|0;r=e+4|0;s=a+60|0;t=e+11|0;while(1){a:while(1){v=b[m>>0]|0;switch(v<<24>>24){case 10:{w=8;break a;break}case 42:{w=19;break a;break}case 47:{w=27;break a;break}case 0:{x=v;break a;break}default:{}}rjc(a)}if((w|0)==8){w=0;rjc(a);if(k){v=f[q>>2]|0;y=f[p>>2]|0;if((v|0)!=(y|0))zYc(f[o>>2]|0,(f[n>>2]|0)+y|0,v-y|0)|0;f[o>>2]=0;f[p>>2]=-1}y=b[m>>0]|0;v=y+-9<<24>>24;if((v&255)>23|(8388637>>>(v&255)&1|0)==0)z=y;else{do{rjc(a);y=b[m>>0]|0;v=y+-9<<24>>24}while(!((v&255)>23|(8388637>>>(v&255)&1|0)==0));z=y}if(z<<24>>24==42?(rjc(a),(b[m>>0]|0)==47):0){w=16;break}if(!k)continue;f[o>>2]=c;f[p>>2]=f[q>>2];continue}else if((w|0)==19){w=0;rjc(a);y=b[m>>0]|0;if(y<<24>>24==47){w=20;break}else x=y}else if((w|0)==27){w=0;rjc(a);y=b[m>>0]|0;if(y<<24>>24==42){v=$Xc(64)|0;f[e>>2]=v;f[l>>2]=-2147483584;f[r>>2]=60;A=v;B=501065;C=A+60|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[v+60>>0]=0;D=f[s>>2]|0;ei[f[(f[D>>2]|0)+8>>2]&511](D,f[g>>2]|0,f[i>>2]|0,e);if((b[t>>0]|0)<0)cYc(f[e>>2]|0);continue}else x=y}if(!(x<<24>>24)){w=32;break}}if((w|0)==16){rjc(a);u=d;return}else if((w|0)==20){rjc(a);if(!k){u=d;return}a=f[q>>2]|0;x=f[p>>2]|0;if((a|0)!=(x|0))zYc(f[o>>2]|0,(f[n>>2]|0)+x|0,a-x|0)|0;f[o>>2]=0;f[p>>2]=-1;x=b[c+11>>0]|0;if(x<<24>>24<0)E=f[c+4>>2]|0;else E=x&255;FYc(c,E+-2|0,-1)|0;u=d;return}else if((w|0)==32){w=$Xc(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=33;A=w;B=501126;C=A+33|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[w+33>>0]=0;w=f[s>>2]|0;ei[f[(f[w>>2]|0)+8>>2]&511](w,f[g>>2]|0,f[i>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);i=f[s>>2]|0;s=f[(f[i>>2]|0)+8>>2]|0;g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=23;A=g;B=501160;C=A+23|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[g+23>>0]=0;ei[s&511](i,h,j,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if(!k){u=d;return}k=f[q>>2]|0;q=f[p>>2]|0;if((k|0)!=(q|0))zYc(f[o>>2]|0,(f[n>>2]|0)+q|0,k-q|0)|0;f[o>>2]=0;f[p>>2]=-1;u=d;return}}function vjc(a){a=a|0;var c=0,d=0;switch(f[a+104>>2]|0){case 0:{c=a+64|0;if((b[c>>0]|0)!=47){d=3;return d|0}rjc(a);switch(b[c>>0]|0){case 47:{rjc(a);d=0;return d|0}case 42:{rjc(a);d=1;return d|0}default:{f[a>>2]=6;tYc(a+4|0,528142)|0;f[a+16>>2]=f[a+84>>2];c=f[a+88>>2]|0;f[a+20>>2]=c+-1;f[a+24>>2]=c;d=2;return d|0}}break}case 1:{if((b[a+64>>0]|0)!=35){d=3;return d|0}rjc(a);d=0;return d|0}default:{d=3;return d|0}}return 0}function wjc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+16|0;d=c;e=c+4|0;g=a+28|0;f[g>>2]=f[a>>2];h=a+4|0;oYc(a+32|0,h)|0;i=a+44|0;j=a+16|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];k=a+80|0;a:do if(!(b[k>>0]|0)){l=a+64|0;m=e+8|0;n=e+4|0;o=a+60|0;p=a+84|0;q=a+88|0;r=e+11|0;b:while(1){s=(b[l>>0]|0)+-9<<24>>24;if(!((s&255)>23|(8388639>>>(s&255)&1|0)==0))do{rjc(a);s=(b[l>>0]|0)+-9<<24>>24}while(!((s&255)>23|(8388639>>>(s&255)&1|0)==0));c:do switch(vjc(a)|0){case 2:{t=1;v=59;break b;break}case 0:{d:while(1){switch(b[l>>0]|0){case 0:{break c;break}case 10:{break d;break}default:{}}rjc(a)}rjc(a);break}case 1:{ujc(a,0);break}default:{if(b[k>>0]|0){v=54;break a}w=b[l>>0]|0;if(!((w+-1&255)<31|w<<24>>24==0))break b;s=$Xc(48)|0;f[e>>2]=s;f[m>>2]=-2147483600;f[n>>2]=47;x=s;y=501184;z=x+47|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[s+47>>0]=0;A=f[o>>2]|0;ei[f[(f[A>>2]|0)+8>>2]&511](A,f[p>>2]|0,f[q>>2]|0,e);if((b[r>>0]|0)<0)cYc(f[e>>2]|0);rjc(a);while(1){A=b[l>>0]|0;if((A+-1&255)<31){rjc(a);continue}if(b[k>>0]|0){v=54;break a}if(A<<24>>24)break c;rjc(a)}}}while(0);if(b[k>>0]|0){v=54;break a}}if((v|0)==59){u=c;return t|0}f[a>>2]=0;r=h+11|0;if((b[r>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+8>>2]=0;B=b[l>>0]|0}else{b[h>>0]=0;b[r>>0]=0;B=w}f[j>>2]=f[p>>2];r=a+20|0;f[r>>2]=f[q>>2];n=a+92|0;f[n>>2]=h;m=a+76|0;s=a+96|0;f[s>>2]=f[m>>2];e:do if(B<<24>>24==95|((B&-33)+-65&255)<26){rjc(a);A=b[l>>0]|0;if(((A&-33)+-65&255)<26|(A<<24>>24==95|(A+-48&255)<10)){do{rjc(a);A=b[l>>0]|0}while(((A&-33)+-65&255)<26|(A<<24>>24==95|(A+-48&255)<10));C=2}else C=2}else{switch(B<<24>>24){case 48:{rjc(a);C=tjc(a,1,0)|0;break e;break}case 46:{rjc(a);D=1;E=b[l>>0]|0;break}default:{D=0;E=B}}if((E+-48&255)<10){rjc(a);F=1}else F=0;if(D){if(!F){C=6;break}if(((f[g>>2]|0)==2?(f[j>>2]|0)==(f[i>>2]|0):0)?(f[r>>2]|0)==(f[a+52>>2]|0):0){A=f[o>>2]|0;G=f[(f[A>>2]|0)+8>>2]|0;H=f[p>>2]|0;I=(f[q>>2]|0)+-2|0;J=$Xc(64)|0;f[e>>2]=J;f[e+8>>2]=-2147483584;f[e+4>>2]=48;x=J;y=501232;z=x+48|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[J+48>>0]=0;ei[G&511](A,H,I,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0)}C=tjc(a,0,1)|0;break}if(F){C=tjc(a,0,0)|0;break}K=b[l>>0]|0;switch(K<<24>>24){case 34:{rjc(a);sjc(a,34);C=5;break e;break}case 39:{rjc(a);sjc(a,39);C=5;break e;break}default:{if(K<<24>>24<0?(L=f[o>>2]|0,M=f[(f[L>>2]|0)+8>>2]|0,N=f[p>>2]|0,O=f[q>>2]|0,f[d>>2]=K&255,Zsc(e,501281,d),ei[M&511](L,N,O,e),(b[e+11>>0]|0)<0):0)cYc(f[e>>2]|0);rjc(a);C=6;break e}}}while(0);f[a>>2]=C;p=f[m>>2]|0;o=f[s>>2]|0;if((p|0)!=(o|0))zYc(f[n>>2]|0,(f[a+68>>2]|0)+o|0,p-o|0)|0;f[n>>2]=0;f[s>>2]=-1;P=1;Q=f[q>>2]|0}else v=54;while(0);if((v|0)==54){f[a>>2]=1;v=h+11|0;if((b[v>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+8>>2]=0}else{b[h>>0]=0;b[v>>0]=0}f[j>>2]=f[a+84>>2];j=f[a+88>>2]|0;f[a+20>>2]=j;P=0;Q=j}f[a+24>>2]=Q;t=P;u=c;return t|0}function xjc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=(b[a+11>>0]|0)<0?f[a>>2]|0:a;a=b[g>>0]|0;a:do if(a<<24>>24==48){switch(b[g+1>>0]|0){case 88:case 120:break;default:{h=8;i=g;j=48;k=5;break a}}l=g+2|0;m=16;n=l;o=b[l>>0]|0;k=4}else{m=10;n=g;o=a;k=4}while(0);if((k|0)==4)if(!(o<<24>>24)){p=0;q=0}else{h=m;i=n;j=o;k=5}b:do if((k|0)==5){o=i;n=j;m=0;a=0;while(1){g=n<<24>>24;if((n+-48&255)>=10)if((n+-97&255)<26){r=-87;k=9}else s=(n+-65&255)<26?g+-55|0:-1;else{r=-48;k=9}if((k|0)==9){k=0;s=r+g|0}if(s>>>0>=h>>>0){t=0;k=15;break}g=((s|0)<0)<<31>>31;if(g>>>0>d>>>0|(g|0)==(d|0)&s>>>0>c>>>0){t=0;k=15;break}l=c1c(c|0,d|0,s|0,g|0)|0;u=n1c(l|0,J|0,h|0,0)|0;l=J;if(m>>>0>l>>>0|(m|0)==(l|0)&a>>>0>u>>>0){t=0;k=15;break}u=x1c(a|0,m|0,h|0,0)|0;l=d1c(s|0,g|0,u|0,J|0)|0;u=J;o=o+1|0;n=b[o>>0]|0;if(!(n<<24>>24)){p=l;q=u;break b}else{m=u;a=l}}if((k|0)==15)return t|0}while(0);k=e;f[k>>2]=p;f[k+4>>2]=q;t=1;return t|0}function yjc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+36|0;e=c;g=c+24|0;h=c+40|0;i=a+11|0;j=(b[i>>0]|0)<0?f[a>>2]|0:a;k=+kjc(j,d);l=f[d>>2]|0;m=b[l>>0]|0;a:do switch(m<<24>>24){case 69:case 101:{n=l+1|0;f[d>>2]=n;o=b[n>>0]|0;switch(o<<24>>24){case 43:case 45:break;default:{p=n;q=o;break a}}o=l+2|0;f[d>>2]=o;p=o;q=b[o>>0]|0;break}default:{p=l;q=m}}while(0);switch(q<<24>>24){case 70:case 102:{q=p+1|0;f[d>>2]=q;r=q;break}default:r=p}p=b[i>>0]|0;if((r-j|0)==((p<<24>>24<0?f[a+4>>2]|0:p&255)|0)?(b[j>>0]|0)!=45:0){u=c;return +k}u_b(e,2,501318,919);j=p_b(e,501412)|0;gtc(g,a);r_b(h,q_b(j,g)|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);v_b(e);u=c;return +k}function zjc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+48|0;e=d;g=d+32|0;h=d+8|0;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[a+4>>2]|0:j&255;if(!k){u_b(h,2,501318,1044);l=p_b(h,501497)|0;gtc(g,a);r_b(d+44|0,q_b(l,g)|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);v_b(h);u=d;return}h=b[c+11>>0]|0;if(h<<24>>24<0){m=f[c+4>>2]|0;n=(f[c+8>>2]&2147483647)+-1|0}else{m=h&255;n=10}h=m+k|0;if(h>>>0>n>>>0){sYc(c,h);o=b[i>>0]|0}else o=j;j=g+4|0;h=o<<24>>24<0?f[a>>2]|0:a;a:while(1){o=h+1|0;n=b[o>>0]|0;switch(n<<24>>24){case 0:{break a;break}case 92:{k=h+2|0;m=b[k>>0]|0;if(m<<24>>24){if((m&-8)<<24>>24==48){l=m<<24>>24;if((m+-48&255)>=10)if((m+-97&255)<26){p=-87;q=17}else r=(m+-65&255)<26?l+-55|0:-1;else{p=-48;q=17}if((q|0)==17){q=0;r=p+l|0}l=h+3|0;s=b[l>>0]|0;if((s&-8)<<24>>24==48){t=r<<3;v=s<<24>>24;if((s+-48&255)>=10)if((s+-97&255)<26){w=-87;q=22}else x=(s+-65&255)<26?v+-55|0:-1;else{w=-48;q=22}if((q|0)==22){q=0;x=w+v|0}y=x+t|0;z=l}else{y=r;z=k}l=z+1|0;t=b[l>>0]|0;if((t&-8)<<24>>24==48){v=y<<3;s=t<<24>>24;if((t+-48&255)>=10)if((t+-97&255)<26){A=-87;q=28}else B=(t+-65&255)<26?s+-55|0:-1;else{A=-48;q=28}if((q|0)==28){q=0;B=A+s|0}C=B+v|0;D=l}else{C=y;D=z}BYc(c,C&255);h=D;continue a}switch(m<<24>>24){case 120:{l=h+3|0;v=b[l>>0]|0;b:do if((v+-48&255)>=10){switch(v<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{E=0;F=k;break b}}s=v<<24>>24;if((v+-97&255)<26){G=-87;H=s;q=37}else{E=(v+-65&255)<26?s+-55|0:-1;F=l}}else{G=-48;H=v<<24>>24;q=37}while(0);if((q|0)==37){q=0;E=G+H|0;F=l}v=F+1|0;s=b[v>>0]|0;c:do if((s+-48&255)>=10){switch(s<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{I=E;J=F;break c}}t=E<<4;K=s<<24>>24;if((s+-97&255)<26){L=-87;M=t;N=K;q=43}else{O=t;P=(s+-65&255)<26?K+-55|0:-1;q=44}}else{L=-48;M=E<<4;N=s<<24>>24;q=43}while(0);if((q|0)==43){q=0;O=M;P=L+N|0;q=44}if((q|0)==44){q=0;I=P+O|0;J=v}BYc(c,I&255);h=J;continue a;break}case 85:case 117:{s=h+3|0;l=m<<24>>24==117?4:m<<24>>24==85?8:0;d:do if(l|0){K=s+l|0;t=s;Q=0;do{R=b[t>>0]|0;if(!(R<<24>>24))break d;S=Q<<4;T=R<<24>>24;if((R+-48&255)>=10)if((R+-97&255)<26){U=-87;q=52}else V=(R+-65&255)<26?T+-55|0:-1;else{U=-48;q=52}if((q|0)==52){q=0;V=U+T|0}Q=V+S|0;t=t+1|0}while(t>>>0<K>>>0);do if((((Q&-1024|0)==55296?(b[K>>0]|0)==92:0)?(b[K+1>>0]|0)==117:0)?(t=b[K+2>>0]|0,t<<24>>24!=0):0){S=t<<24>>24;if((t+-48&255)>=10)if((t+-97&255)<26){W=-87;q=61}else X=(t+-65&255)<26?S+-55|0:-1;else{W=-48;q=61}if((q|0)==61){q=0;X=W+S|0}S=b[K+3>>0]|0;if(S<<24>>24){t=X<<4;T=S<<24>>24;if((S+-48&255)>=10)if((S+-97&255)<26){Y=-87;q=66}else Z=(S+-65&255)<26?T+-55|0:-1;else{Y=-48;q=66}if((q|0)==66){q=0;Z=Y+T|0}T=b[K+4>>0]|0;if(T<<24>>24){S=Z+t<<4;t=T<<24>>24;do if((T+-48&255)<10){_=-48;q=71}else{if((T+-97&255)<26){_=-87;q=71;break}$=(T+-65&255)<26?t+-55|0:-1}while(0);if((q|0)==71){q=0;$=_+t|0}T=b[K+5>>0]|0;if(!(T<<24>>24)){aa=K;ba=Q;break}R=$+S<<4;ca=T<<24>>24;do if((T+-48&255)<10){da=-48;q=76}else{if((T+-97&255)<26){da=-87;q=76;break}ea=(T+-65&255)<26?ca+-55|0:-1}while(0);if((q|0)==76){q=0;ea=da+ca|0}T=ea+R|0;S=(T&-1024|0)==56320;aa=S?K+6|0:K;ba=S?(T+-56320|(Q<<10)+-56623104)+65536|0:Q}else{aa=K;ba=Q}}else{aa=K;ba=Q}}else{aa=K;ba=Q}while(0);if((aa|0)!=(k|0)){f[g>>2]=0;do if(ba>>>0>=128){if(ba>>>0<2048){Q=ba&63|ba<<2&7936|49280;f[g>>2]=Q;fa=2;ga=Q;q=89;break}if(ba>>>0<65536){Q=ba&63|ba<<2&16128|ba<<4&983040|14712960;f[g>>2]=Q;fa=3;ga=Q;q=89;break}if(ba>>>0<2097152){Q=ba&63|ba<<4&4128768|ba<<6&117440512|ba<<2&16128|-260013952;f[g>>2]=Q;fa=4;ga=Q;q=89;break}else{f[e>>2]=ba;_sc(c,501590,e);break}}else{f[g>>2]=ba;fa=1;ga=ba;q=89}while(0);if((q|0)==89){q=0;Q=z_b(ga)|0;f[g>>2]=Q;zYc(c,j+(0-fa)|0,fa)|0}h=aa+-1|0;continue a}}while(0);BYc(c,m);h=k;continue a;break}default:{do switch(m<<24>>24|0){case 97:{ha=7;break}case 98:{ha=8;break}case 102:{ha=12;break}case 110:{ha=10;break}case 114:{ha=13;break}case 116:{ha=9;break}case 118:{ha=11;break}case 92:{ha=92;break}case 63:{ha=63;break}case 39:{ha=39;break}case 34:{ha=34;break}default:ha=63}while(0);BYc(c,ha);h=k;continue a}}}break}default:{}}if(n<<24>>24==(b[((b[i>>0]|0)<0?f[a>>2]|0:a)>>0]|0)?(b[h+2>>0]|0)==0:0){h=o;continue}BYc(c,n);h=o}u=d;return}function Ajc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=b[a+11>>0]|0;if(!((e<<24>>24<0?f[a+4>>2]|0:e&255)|0)){g=0;u=c;return g|0}e=xYc(a,0)|0;h=b[e>>0]|0;if(!(h<<24>>24==95|((h&-33)+-65&255)<26)){g=0;u=c;return g|0}mYc(d,a,1,-1,a);a=b[d+11>>0]|0;h=a<<24>>24<0;e=h?f[d+4>>2]|0:a&255;a:do if(!e)i=1;else{a=h?f[d>>2]|0:d;j=0;while(1){k=b[a+j>>0]|0;j=j+1|0;if(!(((k&-33)+-65&255)<26|(k<<24>>24==95|(k+-48&255)<10))){i=0;break a}if(j>>>0>=e>>>0){i=1;break}}}while(0);if(h)cYc(f[d>>2]|0);g=i;u=c;return g|0}function Bjc(a){a=a|0;f[a>>2]=171524;xZb(a+16|0);return}function Cjc(a){a=a|0;f[a>>2]=171524;xZb(a+16|0);cYc(a);return}function Djc(a,b,c){a=a|0;b=b|0;c=c|0;return zZb(a+16|0,b,c)|0}function Ejc(a,b){a=a|0;b=b|0;AZb(a+16|0,b);return}function Fjc(a,b){a=a|0;b=b|0;return BZb(a+16|0,b)|0}function Gjc(a){a=a|0;var b=0;b=CZb(a+16|0)|0;return b|0}function Hjc(a){a=a|0;return}function Ijc(a){a=a|0;cYc(a);return}function Jjc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=a+4|0;iOc(f[d>>2]|0,b,c)|0;c=f[d>>2]|0;d=f[c+4>>2]|0;if((d|0)==0?(b=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+16>>2]|0,!((b&5|0)==0|(b&2|0)!=0)):0){e=-1;return e|0}e=d;return e|0}function Kjc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;f[a>>2]=171524;d=a+4|0;f[d>>2]=171556;f[a+8>>2]=b;IZb(a+16|0,d,c);return}function Ljc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=171580;b=f[a+8>>2]|0;if(b|0?(f[a+4>>2]|0)==0:0){c=b+12|0;d=f[c>>2]|0;if(d|0?(f[b>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}cYc(b)}x_b(a+12|0);return}function Mjc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=171580;b=f[a+8>>2]|0;if(b|0?(f[a+4>>2]|0)==0:0){c=b+12|0;d=f[c>>2]|0;if(d|0?(f[b>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}cYc(b)}x_b(a+12|0);cYc(a);return}function Njc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+8>>2]|0;if(!b){c=0;return c|0}a=f[b+8>>2]<<2;d=b+12|0;b=f[d>>2]|0;if(!b){c=a;return c|0}if((f[b>>2]|0)>0){e=0;g=a;h=b;while(1){b=f[h+4+(e<<2)>>2]|0;i=(_i[f[(f[b>>2]|0)+84>>2]&2047](b)|0)+g|0;e=e+1|0;h=f[d>>2]|0;if((e|0)>=(f[h>>2]|0)){j=i;break}else g=i}}else j=a;c=j+4|0;return c|0}function Ojc(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;if(f[b>>2]|0)return;c=f[a+4>>2]|0;if(!c){a=$Xc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;d=a}else{if(f[c+64>>2]|0)SXb(c,15384,16);a=RXb(c,16,2244)|0;f[a>>2]=c;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;d=a}f[b>>2]=d;return}function Pjc(a){a=a|0;return}function Qjc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+16|0;c=b;f[a>>2]=171652;d=a+20|0;e=f[a+28>>2]|0;g=f[e+12>>2]|0;h=f[e+4>>2]|0;a:do if(h>>>0>g>>>0){i=f[e+16>>2]|0;j=g;while(1){k=f[i+(j<<2)>>2]|0;if(k|0)break;l=j+1|0;if(l>>>0<h>>>0)j=l;else{m=0;n=l;break a}}if((k|0)==(f[i+((j^1)<<2)>>2]|0)){m=f[(f[k>>2]|0)+16>>2]|0;n=j;break}else{m=k;n=j;break}}else{m=0;n=g}while(0);f[c>>2]=m;f[c+4>>2]=e;f[c+8>>2]=n;if(m|0){n=m;do{tkc((f[n+16>>2]|0)+16|0);ukc(c)|0;n=f[c>>2]|0}while((n|0)!=0)}skc(d);Zkc(d);f[a>>2]=171580;d=f[a+8>>2]|0;if(!d){o=a+12|0;x_b(o);u=b;return}if(f[a+4>>2]|0){o=a+12|0;x_b(o);u=b;return}n=d+12|0;c=f[n>>2]|0;if(c|0?(f[d>>2]|0)==0:0){m=f[c>>2]|0;if((m|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(m|0));p=f[n>>2]|0}else p=c;cYc(p)}cYc(d);o=a+12|0;x_b(o);u=b;return}function Rjc(a){a=a|0;Qjc(a);cYc(a);return}function Sjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=(_i[f[(f[a>>2]|0)+64>>2]&2047](a)|0)+8|0;jkc(d,f[e>>2]|0,b,0);u=c;return (f[d>>2]|0)!=0|0}function Tjc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;h=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;i=h+8|0;jkc(g,f[i>>2]|0,c,0);j=f[g>>2]|0;if(j|0){k=f[j+16>>2]|0;l=0;m=k+16|0;o=k+20|0;q=f[o>>2]|0;r=d+4|0;f[r>>2]=q;s=f[m>>2]|0;f[d>>2]=s;u=e;return l|0}k=vkc(f[i>>2]|0,c)|0;i=f[k>>2]|0;if(!i){j=wkc(h,c)|0;f[k>>2]=j;t=j}else t=i;i=t+16|0;j=a+32|0;a=f[j>>2]|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);a=f[g>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;k=g+11|0;b[k>>0]=5;b[g>>0]=b[502066]|0;b[g+1>>0]=b[502067]|0;b[g+2>>0]=b[502068]|0;b[g+3>>0]=b[502069]|0;b[g+4>>0]=b[502070]|0;b[g+5>>0]=0;c=w3b(a,g)|0;if((b[k>>0]|0)<0)cYc(f[g>>2]|0);k=c+24|0;a=f[k>>2]|0;if(a|0?(f[a>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(a,g)}a=c+28|0;h=t+20|0;f[h>>2]=f[165644+(f[a>>2]<<2)>>2];t=f[k>>2]|0;if(t|0?(f[t>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=c;J_b(t,g)}do switch(f[165644+(f[a>>2]<<2)>>2]|0){case 1:{t=$Xc(4)|0;f[t>>2]=0;v=t;break}case 2:{t=$Xc(8)|0;k=t;f[k>>2]=0;f[k+4>>2]=0;v=t;break}case 3:{t=$Xc(4)|0;f[t>>2]=0;v=t;break}case 4:{t=$Xc(8)|0;k=t;f[k>>2]=0;f[k+4>>2]=0;v=t;break}case 5:{t=$Xc(8)|0;p[t>>3]=0.0;v=t;break}case 6:{t=$Xc(4)|0;n[t>>2]=0.0;v=t;break}case 7:{t=$Xc(1)|0;b[t>>0]=0;v=t;break}case 9:{t=$Xc(12)|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;v=t;break}case 8:{t=$Xc(4)|0;f[t>>2]=0;v=t;break}case 10:{t=f[j>>2]|0;mi[f[(f[t>>2]|0)+96>>2]&2047](g,t);t=f[g+4>>2]|0;k=hh[f[(f[t>>2]|0)+108>>2]&127](t,f[j>>2]|0,c,0)|0;v=_i[f[(f[k>>2]|0)+12>>2]&2047](k)|0;break}default:{l=1;m=i;o=h;q=f[o>>2]|0;r=d+4|0;f[r>>2]=q;s=f[m>>2]|0;f[d>>2]=s;u=e;return l|0}}while(0);f[i>>2]=v;l=1;m=i;o=h;q=f[o>>2]|0;r=d+4|0;f[r>>2]=q;s=f[m>>2]|0;f[d>>2]=s;u=e;return l|0}function Ujc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=a+16|0;if((f[i>>2]|0)==1){j=a+12|0;g_b(j);if((f[i>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&4095](a);f[i>>2]=2}h_b(j)}j=a+28|0;jkc(e,f[j>>2]|0,c,0);c=f[e>>2]|0;k=f[e+4>>2]|0;l=f[e+8>>2]|0;if(!c){m=0;u=d;return m|0}f[i>>2]=0;i=c+16|0;tkc((f[i>>2]|0)+16|0);f[h>>2]=c;f[h+4>>2]=k;f[h+8>>2]=l;if((f[a+20>>2]|0)==0?(a=f[i>>2]|0,a|0):0){if((f[a+8>>2]|0)==9?(i=f[a>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}cYc(a)};f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];ukc(h)|0;h=f[j>>2]|0;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];Kkc(h,e);m=1;u=d;return m|0}function Vjc(a,b,c){a=a|0;b=b|0;c=c|0;return (f[f[b>>2]>>2]|0)==(f[f[c>>2]>>2]|0)|0}function Wjc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(_i[f[(f[a>>2]|0)+64>>2]&2047](a)|0)+8|0;d=f[c>>2]|0;c=f[d+12>>2]|0;e=f[d+4>>2]|0;a:do if(e>>>0>c>>>0){g=f[d+16>>2]|0;h=c;while(1){i=f[g+(h<<2)>>2]|0;if(i|0)break;j=h+1|0;if(j>>>0<e>>>0)h=j;else{k=0;l=j;break a}}if((i|0)==(f[g+((h^1)<<2)>>2]|0)){k=f[(f[i>>2]|0)+16>>2]|0;l=h;break}else{k=i;l=h;break}}else{k=0;l=c}while(0);c=f[b>>2]|0;f[c>>2]=k;f[c+4>>2]=d;f[c+8>>2]=l;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function Xjc(a,b){a=a|0;b=b|0;_i[f[(f[a>>2]|0)+64>>2]&2047](a)|0;a=f[b>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function Yjc(a){a=a|0;var b=0;b=(_i[f[(f[a>>2]|0)+64>>2]&2047](a)|0)+8|0;return f[f[b>>2]>>2]|0}function Zjc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;b=u;u=u+32|0;c=b+16|0;d=b;e=f[a+8>>2]|0;if(!e)g=12;else{h=f[e+8>>2]<<2;i=e+12|0;e=f[i>>2]|0;if(!e)j=h;else{if((f[e>>2]|0)>0){k=0;l=h;m=e;while(1){e=f[m+4+(k<<2)>>2]|0;n=(_i[f[(f[e>>2]|0)+84>>2]&2047](e)|0)+l|0;k=k+1|0;m=f[i>>2]|0;if((k|0)>=(f[m>>2]|0)){o=n;break}else l=n}}else o=h;j=o+4|0}g=j+12|0}j=f[a+28>>2]|0;a=f[j>>2]|0;if(!a){p=g;u=b;return p|0}o=f[j+12>>2]|0;h=f[j+4>>2]|0;a:do if(h>>>0>o>>>0){l=f[j+16>>2]|0;m=o;while(1){q=f[l+(m<<2)>>2]|0;if(q|0)break;k=m+1|0;if(k>>>0<h>>>0)m=k;else{r=0;s=k;break a}}if((q|0)==(f[l+((m^1)<<2)>>2]|0)){r=f[(f[q>>2]|0)+16>>2]|0;s=m;break}else{r=q;s=m;break}}else{r=0;s=o}while(0);f[d>>2]=r;f[d+4>>2]=j;f[d+8>>2]=s;s=a<<3;j=r;o=j+16|0;q=(hSa(f[o>>2]|0)|0)==9;h=a*12|0;k=(a<<4)+g+s+(q?h:0)|0;do switch(Ykc((f[o>>2]|0)+16|0)|0){case 1:{t=k+(a<<2)|0;break}case 2:{t=k+s|0;break}case 3:{t=k+(a<<2)|0;break}case 4:{t=k+s|0;break}case 5:{t=k+s|0;break}case 6:{t=k+(a<<2)|0;break}case 7:{t=k+a|0;break}case 9:{t=k+h|0;break}case 8:{t=k+(a<<2)|0;break}case 10:{if(!r)t=k;else{q=c+4|0;g=k;i=j;while(1){n=Xkc((f[i+16>>2]|0)+16|0)|0;mi[f[(f[n>>2]|0)+96>>2]&2047](c,n);e=f[q>>2]|0;v=(Mi[f[(f[e>>2]|0)+16>>2]&1023](e,n)|0)+g|0;ikc(d)|0;i=f[d>>2]|0;if(!i){t=v;break}else g=v}}break}default:t=k}while(0);p=t;u=b;return p|0}function _jc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0.0;c=u;u=u+64|0;d=c+40|0;e=c;g=c+16|0;h=c+56|0;i=a+32|0;j=f[i>>2]|0;mi[f[(f[j>>2]|0)+96>>2]&2047](d,j);j=f[d+4>>2]|0;k=f[i>>2]|0;mi[f[(f[k>>2]|0)+96>>2]&2047](d,k);k=f[d>>2]|0;l=d+4|0;f[l>>2]=0;f[l+4>>2]=0;l=d+11|0;b[l>>0]=3;b[d>>0]=b[502062]|0;b[d+1>>0]=b[502063]|0;b[d+2>>0]=b[502064]|0;b[d+3>>0]=0;m=w3b(k,d)|0;if((b[l>>0]|0)<0)cYc(f[d>>2]|0);l=f[i>>2]|0;mi[f[(f[l>>2]|0)+96>>2]&2047](d,l);l=f[d>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;k=d+11|0;b[k>>0]=5;b[d>>0]=b[502066]|0;b[d+1>>0]=b[502067]|0;b[d+2>>0]=b[502068]|0;b[d+3>>0]=b[502069]|0;b[d+4>>0]=b[502070]|0;b[d+5>>0]=0;n=w3b(l,d)|0;if((b[k>>0]|0)<0)cYc(f[d>>2]|0);k=a+8|0;l=f[k>>2]|0;if(!l){o=f[a+4>>2]|0;if(!o){p=$Xc(16)|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;q=p}else{if(f[o+64>>2]|0)SXb(o,15384,16);p=RXb(o,16,2244)|0;f[p>>2]=o;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;q=p}f[k>>2]=q;r=q}else r=l;l=r+4|0;q=f[l>>2]|0;if((q|0)>0){p=f[r+12>>2]|0;r=0;do{o=f[p+4+(r<<2)>>2]|0;r=r+1|0;Yi[f[(f[o>>2]|0)+28>>2]&4095](o)}while((r|0)!=(q|0));f[l>>2]=0}l=f[a+28>>2]|0;a=f[l+12>>2]|0;q=f[l+4>>2]|0;a:do if(q>>>0>a>>>0){r=f[l+16>>2]|0;p=a;while(1){s=f[r+(p<<2)>>2]|0;if(s|0)break;o=p+1|0;if(o>>>0<q>>>0)p=o;else{t=0;v=o;break a}}if((s|0)==(f[r+((p^1)<<2)>>2]|0)){t=f[(f[s>>2]|0)+16>>2]|0;v=p;break}else{t=s;v=p;break}}else{t=0;v=a}while(0);f[e>>2]=t;f[e+4>>2]=l;f[e+8>>2]=v;if(!t){u=c;return}t=m+24|0;v=m+28|0;l=n+24|0;a=n+28|0;s=d+4|0;q=d+8|0;o=d+12|0;w=d+4|0;x=d+8|0;y=d+12|0;do{z=f[i>>2]|0;A=_i[f[(f[z>>2]|0)+12>>2]&2047](z)|0;z=f[k>>2]|0;B=Loc(A)|0;C=f[z>>2]|0;if(((C|0)==(B|0)?(B=z+12|0,D=f[B>>2]|0,(D|0)!=0):0)?(E=f[D>>2]|0,(E|0)<(f[z+8>>2]|0)):0){F=z+4|0;G=f[F>>2]|0;if((G|0)<(E|0)){H=D+4+(G<<2)|0;f[D+4+(E<<2)>>2]=f[H>>2];I=H}else I=D+4+(G<<2)|0;f[I>>2]=A;f[F>>2]=G+1;G=f[B>>2]|0;f[G>>2]=(f[G>>2]|0)+1}else Nkc(z,A,Koc(A)|0,C);C=f[(f[e>>2]|0)+16>>2]|0;z=f[t>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[d>>2]=80424;f[w>>2]=2231;b[x>>0]=0;f[y>>2]=m;J_b(z,d)}switch(f[165644+(f[v>>2]<<2)>>2]|0){case 9:{z=f[(f[j>>2]|0)+144>>2]|0;G=OSa(C)|0;ei[z&511](j,A,m,G);break}case 2:{G=f[(f[j>>2]|0)+120>>2]|0;z=nkc(C)|0;gi[G&255](j,A,m,z,J);break}case 1:{z=f[(f[j>>2]|0)+116>>2]|0;G=okc(C)|0;ei[z&511](j,A,m,G);break}case 4:{G=f[(f[j>>2]|0)+128>>2]|0;z=pkc(C)|0;gi[G&255](j,A,m,z,J);break}case 3:{z=f[(f[j>>2]|0)+124>>2]|0;G=qkc(C)|0;ei[z&511](j,A,m,G);break}case 7:{G=f[(f[j>>2]|0)+140>>2]|0;z=rkc(C)|0;ei[G&511](j,A,m,z);break}case 10:case 8:case 6:case 5:{u_b(g,3,502072,284);r_b(h,p_b(g,507741)|0);v_b(g);break}default:{}}z=(f[(f[e>>2]|0)+16>>2]|0)+16|0;G=f[l>>2]|0;if(G|0?(f[G>>2]|0)!=2:0){f[d>>2]=80424;f[s>>2]=2231;b[q>>0]=0;f[o>>2]=n;J_b(G,d)}do switch(f[165644+(f[a>>2]<<2)>>2]|0){case 9:{G=f[(f[j>>2]|0)+144>>2]|0;C=Okc(z)|0;ei[G&511](j,A,n,C);break}case 2:{C=f[(f[j>>2]|0)+120>>2]|0;G=Pkc(z)|0;gi[C&255](j,A,n,G,J);break}case 1:{G=f[(f[j>>2]|0)+116>>2]|0;C=Qkc(z)|0;ei[G&511](j,A,n,C);break}case 4:{C=f[(f[j>>2]|0)+128>>2]|0;G=Rkc(z)|0;gi[C&255](j,A,n,G,J);break}case 3:{G=f[(f[j>>2]|0)+124>>2]|0;C=Skc(z)|0;ei[G&511](j,A,n,C);break}case 7:{C=f[(f[j>>2]|0)+140>>2]|0;G=Tkc(z)|0;ei[C&511](j,A,n,G);break}case 5:{G=f[(f[j>>2]|0)+136>>2]|0;K=+Ukc(z);$h[G&63](j,A,n,K);break}case 6:{G=f[(f[j>>2]|0)+132>>2]|0;K=+Vkc(z);$h[G&63](j,A,n,K);break}case 8:{G=f[(f[j>>2]|0)+152>>2]|0;C=Wkc(z)|0;ei[G&511](j,A,n,C);break}case 10:{C=Xkc(z)|0;G=hh[f[(f[j>>2]|0)+156>>2]&127](j,A,n,0)|0;mi[f[(f[G>>2]|0)+72>>2]&2047](G,C);break}default:{}}while(0);ikc(e)|0}while((f[e>>2]|0)!=0);u=c;return}function $jc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0;c=u;u=u+64|0;d=c+40|0;e=c;g=c+16|0;h=c+56|0;i=a+20|0;j=a+32|0;k=f[j>>2]|0;mi[f[(f[k>>2]|0)+96>>2]&2047](d,k);k=f[d+4>>2]|0;l=f[j>>2]|0;mi[f[(f[l>>2]|0)+96>>2]&2047](d,l);l=f[d>>2]|0;m=d+4|0;f[m>>2]=0;f[m+4>>2]=0;m=d+11|0;b[m>>0]=3;b[d>>0]=b[502062]|0;b[d+1>>0]=b[502063]|0;b[d+2>>0]=b[502064]|0;b[d+3>>0]=0;o=w3b(l,d)|0;if((b[m>>0]|0)<0)cYc(f[d>>2]|0);m=f[j>>2]|0;mi[f[(f[m>>2]|0)+96>>2]&2047](d,m);m=f[d>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[502066]|0;b[d+1>>0]=b[502067]|0;b[d+2>>0]=b[502068]|0;b[d+3>>0]=b[502069]|0;b[d+4>>0]=b[502070]|0;b[d+5>>0]=0;l=w3b(m,d)|0;if((b[j>>0]|0)<0)cYc(f[d>>2]|0);j=a+28|0;m=f[j>>2]|0;q=f[m+12>>2]|0;r=f[m+4>>2]|0;a:do if(r>>>0>q>>>0){s=f[m+16>>2]|0;t=q;while(1){v=f[s+(t<<2)>>2]|0;if(v|0)break;w=t+1|0;if(w>>>0<r>>>0)t=w;else{x=0;y=w;break a}}if((v|0)==(f[s+((t^1)<<2)>>2]|0)){x=f[(f[v>>2]|0)+16>>2]|0;y=t;break}else{x=v;y=t;break}}else{x=0;y=q}while(0);f[d>>2]=x;f[d+4>>2]=m;f[d+8>>2]=y;if(x|0){y=x;do{tkc((f[y+16>>2]|0)+16|0);ukc(d)|0;y=f[d>>2]|0}while((y|0)!=0)}skc(i);y=a+8|0;a=f[y>>2]|0;x=f[a+12>>2]|0;if(!(f[a+4>>2]|0)){u=c;return}a=e+8|0;m=o+24|0;q=o+28|0;v=l+24|0;r=l+28|0;w=d+4|0;z=d+8|0;A=d+12|0;B=d+4|0;C=d+8|0;D=d+12|0;E=d+11|0;F=d+4|0;G=d+8|0;H=d+12|0;I=(x|0)==0?0:x+4|0;do{f[a>>2]=0;x=f[m>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[d>>2]=80424;f[F>>2]=2231;b[G>>0]=0;f[H>>2]=o;J_b(x,d)}switch(f[165644+(f[q>>2]<<2)>>2]|0){case 9:{ei[f[(f[k>>2]|0)+96>>2]&511](d,k,f[I>>2]|0,o);if((f[a>>2]|0)==9)K=f[e>>2]|0;else{f[a>>2]=9;x=$Xc(12)|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[e>>2]=x;K=x}oYc(K,d)|0;if((b[E>>0]|0)<0)cYc(f[d>>2]|0);break}case 2:{x=hj[f[(f[k>>2]|0)+72>>2]&511](k,f[I>>2]|0,o)|0;L=J;switch(f[a>>2]|0){case 2:break;case 9:{M=f[e>>2]|0;if(!M)N=33;else{if((b[M+11>>0]|0)<0)cYc(f[M>>2]|0);cYc(M);N=33}break}default:N=33}if((N|0)==33){N=0;f[a>>2]=2}M=e;f[M>>2]=x;f[M+4>>2]=L;break}case 1:{L=hj[f[(f[k>>2]|0)+68>>2]&511](k,f[I>>2]|0,o)|0;switch(f[a>>2]|0){case 1:break;case 9:{M=f[e>>2]|0;if(!M)N=40;else{if((b[M+11>>0]|0)<0)cYc(f[M>>2]|0);cYc(M);N=40}break}default:N=40}if((N|0)==40){N=0;f[a>>2]=1}f[e>>2]=L;break}case 4:{L=hj[f[(f[k>>2]|0)+80>>2]&511](k,f[I>>2]|0,o)|0;M=J;switch(f[a>>2]|0){case 4:break;case 9:{x=f[e>>2]|0;if(!x)N=47;else{if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);cYc(x);N=47}break}default:N=47}if((N|0)==47){N=0;f[a>>2]=4}x=e;f[x>>2]=L;f[x+4>>2]=M;break}case 3:{M=hj[f[(f[k>>2]|0)+76>>2]&511](k,f[I>>2]|0,o)|0;switch(f[a>>2]|0){case 3:break;case 9:{x=f[e>>2]|0;if(!x)N=54;else{if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);cYc(x);N=54}break}default:N=54}if((N|0)==54){N=0;f[a>>2]=3}f[e>>2]=M;break}case 7:{M=(hj[f[(f[k>>2]|0)+92>>2]&511](k,f[I>>2]|0,o)|0)&1;switch(f[a>>2]|0){case 7:break;case 9:{x=f[e>>2]|0;if(!x)N=61;else{if((b[x+11>>0]|0)<0)cYc(f[x>>2]|0);cYc(x);N=61}break}default:N=61}if((N|0)==61){N=0;f[a>>2]=7}b[e>>0]=M;break}case 10:case 8:case 6:case 5:{u_b(g,3,502072,366);r_b(h,p_b(g,507741)|0);v_b(g);break}default:{}}jkc(d,f[j>>2]|0,e,0);M=f[d>>2]|0;if(M|0)tkc((f[M+16>>2]|0)+16|0);M=vkc(f[j>>2]|0,e)|0;x=f[M>>2]|0;if(!x){L=wkc(i,e)|0;f[M>>2]=L;O=L}else O=x;x=f[v>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[d>>2]=80424;f[B>>2]=2231;b[C>>0]=0;f[D>>2]=l;J_b(x,d)}f[O+20>>2]=f[165644+(f[r>>2]<<2)>>2];x=f[v>>2]|0;if(x|0?(f[x>>2]|0)!=2:0){f[d>>2]=80424;f[w>>2]=2231;b[z>>0]=0;f[A>>2]=l;J_b(x,d)}do switch(f[165644+(f[r>>2]<<2)>>2]|0){case 1:{x=$Xc(4)|0;L=hj[f[(f[k>>2]|0)+68>>2]&511](k,f[I>>2]|0,l)|0;f[x>>2]=L;P=x;N=88;break}case 2:{x=$Xc(8)|0;L=hj[f[(f[k>>2]|0)+72>>2]&511](k,f[I>>2]|0,l)|0;M=x;f[M>>2]=L;f[M+4>>2]=J;P=x;N=88;break}case 3:{x=$Xc(4)|0;M=hj[f[(f[k>>2]|0)+76>>2]&511](k,f[I>>2]|0,l)|0;f[x>>2]=M;P=x;N=88;break}case 4:{x=$Xc(8)|0;M=hj[f[(f[k>>2]|0)+80>>2]&511](k,f[I>>2]|0,l)|0;L=x;f[L>>2]=M;f[L+4>>2]=J;P=x;N=88;break}case 5:{x=$Xc(8)|0;Q=+Sh[f[(f[k>>2]|0)+88>>2]&31](k,f[I>>2]|0,l);p[x>>3]=Q;P=x;N=88;break}case 6:{x=$Xc(4)|0;Q=+Sh[f[(f[k>>2]|0)+84>>2]&31](k,f[I>>2]|0,l);n[x>>2]=Q;P=x;N=88;break}case 7:{x=$Xc(1)|0;L=(hj[f[(f[k>>2]|0)+92>>2]&511](k,f[I>>2]|0,l)|0)&1;b[x>>0]=L;P=x;N=88;break}case 9:{x=$Xc(12)|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;ei[f[(f[k>>2]|0)+96>>2]&511](d,k,f[I>>2]|0,l);L=x+11|0;if((b[L>>0]|0)<0){b[f[x>>2]>>0]=0;f[x+4>>2]=0}else{b[x>>0]=0;b[L>>0]=0}sYc(x,0);f[x>>2]=f[d>>2];f[x+4>>2]=f[d+4>>2];f[x+8>>2]=f[d+8>>2];P=x;N=88;break}case 8:{x=$Xc(4)|0;L=hj[f[(f[k>>2]|0)+104>>2]&511](k,f[I>>2]|0,l)|0;f[x>>2]=L;P=x;N=88;break}case 10:{x=hh[f[(f[k>>2]|0)+108>>2]&127](k,f[I>>2]|0,l,0)|0;L=_i[f[(f[x>>2]|0)+12>>2]&2047](x)|0;mi[f[(f[L>>2]|0)+72>>2]&2047](L,x);P=L;N=88;break}default:{}}while(0);if((N|0)==88){N=0;f[O+16>>2]=P}if((f[a>>2]|0)==9?(t=f[e>>2]|0,t|0):0){if((b[t+11>>0]|0)<0)cYc(f[t>>2]|0);cYc(t)}I=I+4|0;t=f[y>>2]|0;s=f[t+12>>2]|0}while((I|0)!=(((s|0)==0?0:s+4|0)+(f[t+4>>2]<<2)|0));u=c;return}function akc(a,b){a=a|0;b=b|0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[b>>2]=a;return}function bkc(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(!a)return;cYc(a);return}function ckc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=f[d>>2]|0;g=f[c>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];e=c+8|0;g=hSa(d+8|0)|0;h=c+16|0;i=f[h>>2]|0;if((i|0)!=(g|0)){if((i|0)==9?(i=f[e>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}f[h>>2]=g;if((g|0)==9){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=g}}f[c+28>>2]=f[d+28>>2];mi[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function dkc(a,b){a=a|0;b=b|0;ikc(f[b>>2]|0)|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function ekc(a){a=a|0;var b=0,c=0,d=0;b=a+16|0;if((f[b>>2]|0)!=1){c=a+20|0;return c|0}d=a+12|0;g_b(d);if((f[b>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&4095](a);f[b>>2]=2}h_b(d);c=a+20|0;return c|0}function fkc(a){a=a|0;var b=0,c=0,d=0;b=a+16|0;if((f[b>>2]|0)!=1){f[b>>2]=0;c=a+20|0;return c|0}d=a+12|0;g_b(d);if((f[b>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&4095](a);f[b>>2]=2}h_b(d);f[b>>2]=0;c=a+20|0;return c|0}function gkc(a,b){a=a|0;b=b|0;var c=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=a+16|0;hkc(b+8|0,f[c>>2]|0);a=f[c>>2]|0;f[b+28>>2]=f[a+20>>2];f[b+24>>2]=f[a+16>>2];return}function hkc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;g=d+24|0;h=hSa(c)|0;i=a+8|0;j=f[i>>2]|0;a:do if((j|0)==(h|0)){switch(h|0){case 10:case 8:case 6:case 5:{k=10;break a;break}case 9:{k=11;break a;break}case 2:{k=12;break a;break}case 1:{k=13;break a;break}case 4:{k=14;break a;break}case 3:{k=15;break a;break}case 7:{k=16;break a;break}default:{}}u=d;return}else{if((j|0)==9?(l=f[a>>2]|0,l|0):0){if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);cYc(l)}f[i>>2]=h;switch(h|0){case 10:case 8:case 6:case 5:{k=10;break a;break}case 2:{k=12;break a;break}case 1:{k=13;break a;break}case 4:{k=14;break a;break}case 3:{k=15;break a;break}case 7:{k=16;break a;break}case 9:{l=$Xc(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[a>>2]=l;k=11;break a;break}default:{u=d;return}}}while(0);if((k|0)==10){u_b(e,3,501750,501);r_b(g,p_b(e,507492)|0);v_b(e);u=d;return}else if((k|0)==11){oYc(f[a>>2]|0,f[c>>2]|0)|0;u=d;return}else if((k|0)==12){e=c;g=f[e+4>>2]|0;h=a;f[h>>2]=f[e>>2];f[h+4>>2]=g;u=d;return}else if((k|0)==13){f[a>>2]=f[c>>2];u=d;return}else if((k|0)==14){g=c;h=f[g+4>>2]|0;e=a;f[e>>2]=f[g>>2];f[e+4>>2]=h;u=d;return}else if((k|0)==15){f[a>>2]=f[c>>2];u=d;return}else if((k|0)==16){b[a>>0]=b[c>>0]|0;u=d;return}}function ikc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+24>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+24>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);jkc(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function jkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=kkc(b,c)|0;g=(f[b+4>>2]|0)+-1&(f[b+8>>2]|0)+e;e=f[b+16>>2]|0;h=f[e+(g<<2)>>2]|0;a:do if(h){if((h|0)!=(f[e+((g^1)<<2)>>2]|0)){i=h;while(1){if(lkc(i,c)|0)break;j=f[i+24>>2]|0;if(!j){k=g;l=18;break a}else i=j}f[a>>2]=i;m=g;n=g;o=b;break}if((h|0)==(f[e+((g^1)<<2)>>2]|0)){j=g&-2;p=(f[e+(j<<2)>>2]|0)+4|0;q=f[p>>2]|0;if(q){r=p;s=q;b:while(1){q=s;while(1){if(!(mkc(f[q+16>>2]|0,c)|0))break;t=f[q+4>>2]|0;if(!t){u=r;break b}else q=t}s=f[q>>2]|0;if(!s){u=q;break}else r=q}if((u|0)!=(p|0)?(r=u+16|0,!(mkc(c,f[r>>2]|0)|0)):0){if(d|0)f[d>>2]=u;f[a>>2]=f[r>>2];m=j;n=j;o=b}else{k=j;l=18}}else{k=j;l=18}}else{k=g;l=18}}else{k=g;l=18}while(0);if((l|0)==18){f[a>>2]=0;m=k;n=0;o=0}f[a+4>>2]=o;f[a+8>>2]=n;f[a+12>>2]=m;return}function kkc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;a=u;u=u+64|0;d=a+24|0;e=a;g=a+48|0;switch(hSa(c)|0){case 10:case 8:case 6:case 5:{u_b(d,3,501750,812);r_b(a+49|0,p_b(d,507492)|0);v_b(d);break}case 9:{d=OSa(c)|0;h=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=b[h>>0]|0;if(!(d<<24>>24)){i=0;u=a;return i|0}else{j=h;k=0;l=d}while(1){d=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=d;break}else k=d}u=a;return i|0}case 2:{k=nkc(c)|0;l=Y(k,1540483477)|0;k=Y(J,1540483477)|0;j=(Y((Y(l>>>24^l,1540483477)|0)^-561034072,1540483477)|0)^(Y(k>>>24^k,1540483477)|0);k=Y(j>>>13^j,1540483477)|0;i=k>>>15^k;u=a;return i|0}case 1:{i=okc(c)|0;u=a;return i|0}case 4:{k=pkc(c)|0;j=Y(k,1540483477)|0;k=Y(J,1540483477)|0;l=(Y((Y(j>>>24^j,1540483477)|0)^-561034072,1540483477)|0)^(Y(k>>>24^k,1540483477)|0);k=Y(l>>>13^l,1540483477)|0;i=k>>>15^k;u=a;return i|0}case 3:{i=qkc(c)|0;u=a;return i|0}case 7:{i=(rkc(c)|0)&1;u=a;return i|0}default:{}}u_b(e,3,501750,827);r_b(g,p_b(e,507741)|0);v_b(e);i=0;u=a;return i|0}function lkc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;i=d+72|0;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){u_b(e,3,501750,468);r_b(d+74|0,p_b(e,501840)|0);v_b(e)}switch(hSa(a)|0){case 10:case 8:case 6:case 5:{u_b(g,3,501750,475);r_b(d+73|0,p_b(g,507492)|0);v_b(g);break}case 9:{g=f[a>>2]|0;e=f[c>>2]|0;j=b[g+11>>0]|0;k=j<<24>>24<0;l=j&255;j=k?f[g+4>>2]|0:l;m=b[e+11>>0]|0;n=m<<24>>24<0;if((j|0)!=((n?f[e+4>>2]|0:m&255)|0)){o=0;u=d;return o|0}m=f[g>>2]|0;p=k?m:g;q=n?f[e>>2]|0:e;e=(j|0)==0;if(k){if(e){o=1;u=d;return o|0}o=(WKc(p,q,j)|0)==0;u=d;return o|0}if(e){o=1;u=d;return o|0}if((m&255)<<24>>24==(b[q>>0]|0)){r=g;s=l;t=q}else{o=0;u=d;return o|0}while(1){s=s+-1|0;r=r+1|0;if(!s){o=1;v=19;break}t=t+1|0;if((b[r>>0]|0)!=(b[t>>0]|0)){o=0;v=19;break}}if((v|0)==19){u=d;return o|0}break}case 2:{v=a;t=c;o=(f[v>>2]|0)==(f[t>>2]|0)?(f[v+4>>2]|0)==(f[t+4>>2]|0):0;u=d;return o|0}case 1:{o=(f[a>>2]|0)==(f[c>>2]|0);u=d;return o|0}case 4:{t=a;v=c;o=(f[t>>2]|0)==(f[v>>2]|0)?(f[t+4>>2]|0)==(f[v+4>>2]|0):0;u=d;return o|0}case 3:{o=(f[a>>2]|0)==(f[c>>2]|0);u=d;return o|0}case 7:{o=(b[a>>0]|0)==(b[c>>0]|0);u=d;return o|0}default:{}}u_b(h,3,501750,490);r_b(i,p_b(h,507741)|0);v_b(h);o=0;u=d;return o|0}function mkc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+24|0;g=d;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){u_b(e,3,501750,440);r_b(d+49|0,p_b(e,501840)|0);v_b(e)}switch(hSa(a)|0){case 10:case 8:case 6:case 5:{u_b(g,3,501750,447);r_b(d+48|0,p_b(g,507492)|0);v_b(g);i=0;u=d;return i|0}case 9:{g=f[a>>2]|0;e=f[c>>2]|0;j=b[e+11>>0]|0;k=j<<24>>24<0;l=k?f[e+4>>2]|0:j&255;j=b[g+11>>0]|0;m=j<<24>>24<0;n=m?f[g+4>>2]|0:j&255;j=l>>>0<n>>>0;o=j?l:n;if((o|0)!=0?(p=WKc(m?f[g>>2]|0:g,k?f[e>>2]|0:e,o)|0,(p|0)!=0):0)q=p;else q=n>>>0<l>>>0?-1:j&1;i=(q|0)<0;u=d;return i|0}case 2:{q=a;j=f[q+4>>2]|0;l=c;n=f[l+4>>2]|0;i=(j|0)<(n|0)|((j|0)==(n|0)?(f[q>>2]|0)>>>0<(f[l>>2]|0)>>>0:0);u=d;return i|0}case 1:{i=(f[a>>2]|0)<(f[c>>2]|0);u=d;return i|0}case 4:{l=a;q=f[l+4>>2]|0;n=c;j=f[n+4>>2]|0;i=q>>>0<j>>>0|((q|0)==(j|0)?(f[l>>2]|0)>>>0<(f[n>>2]|0)>>>0:0);u=d;return i|0}case 3:{i=(f[a>>2]|0)>>>0<(f[c>>2]|0)>>>0;u=d;return i|0}case 7:{i=(h[a>>0]|0)<(h[c>>0]|0);u=d;return i|0}default:{i=0;u=d;return i|0}}return 0}function nkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+32|0;c=b;if((hSa(a)|0)==2){d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}u_b(c,3,501750,407);k=p_b(p_b(p_b(p_b(c,501867)|0,502040)|0,501922)|0,501944)|0;l=p_b(p_b(p_b(k,f[41451]|0)|0,505563)|0,501958)|0;k=165796+((hSa(a)|0)<<2)|0;r_b(b+24|0,p_b(l,f[k>>2]|0)|0);v_b(c);d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}function okc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((hSa(a)|0)==1){d=f[a>>2]|0;u=b;return d|0}u_b(c,3,501750,417);e=p_b(p_b(p_b(p_b(c,501867)|0,502018)|0,501922)|0,501944)|0;g=p_b(p_b(p_b(e,f[41450]|0)|0,505563)|0,501958)|0;e=165796+((hSa(a)|0)<<2)|0;r_b(b+24|0,p_b(g,f[e>>2]|0)|0);v_b(c);d=f[a>>2]|0;u=b;return d|0}function pkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+32|0;c=b;if((hSa(a)|0)==4){d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}u_b(c,3,501750,412);k=p_b(p_b(p_b(p_b(c,501867)|0,501995)|0,501922)|0,501944)|0;l=p_b(p_b(p_b(k,f[41453]|0)|0,505563)|0,501958)|0;k=165796+((hSa(a)|0)<<2)|0;r_b(b+24|0,p_b(l,f[k>>2]|0)|0);v_b(c);d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}function qkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((hSa(a)|0)==3){d=f[a>>2]|0;u=b;return d|0}u_b(c,3,501750,422);e=p_b(p_b(p_b(p_b(c,501867)|0,501972)|0,501922)|0,501944)|0;g=p_b(p_b(p_b(e,f[41452]|0)|0,505563)|0,501958)|0;e=165796+((hSa(a)|0)<<2)|0;r_b(b+24|0,p_b(g,f[e>>2]|0)|0);v_b(c);d=f[a>>2]|0;u=b;return d|0}function rkc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;if((hSa(a)|0)==7){e=b[a>>0]|0;g=e<<24>>24!=0;u=c;return g|0}u_b(d,3,501750,427);h=p_b(p_b(p_b(p_b(d,501867)|0,501901)|0,501922)|0,501944)|0;i=p_b(p_b(p_b(h,f[41456]|0)|0,505563)|0,501958)|0;h=165796+((hSa(a)|0)<<2)|0;r_b(c+24|0,p_b(i,f[h>>2]|0)|0);v_b(d);e=b[a>>0]|0;g=e<<24>>24!=0;u=c;return g|0}function skc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+48|0;d=c+28|0;e=c+16|0;g=c;h=a+8|0;i=f[h>>2]|0;j=f[i+12>>2]|0;k=f[i+4>>2]|0;if(k>>>0<=j>>>0){u=c;return}l=f[i+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;j=m+1|0;if(j>>>0<k>>>0)m=j;else{o=19;break}}if((o|0)==19){u=c;return}if((n|0)==(f[l+((m^1)<<2)>>2]|0))p=f[(f[n>>2]|0)+16>>2]|0;else p=n;if(!p){u=c;return}n=g+4|0;l=g+8|0;o=p;p=i;i=m;while(1){f[g>>2]=o;f[n>>2]=p;f[l>>2]=i;if((f[a>>2]|0)==0?(m=f[o+16>>2]|0,m|0):0){if((f[m+8>>2]|0)==9?(k=f[m>>2]|0,k|0):0){if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);cYc(k)}cYc(m)};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];ukc(g)|0;m=f[h>>2]|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];Kkc(m,d);o=f[g>>2]|0;if(!o)break;else{p=f[n>>2]|0;i=f[l>>2]|0}}u=c;return}function tkc(a){a=a|0;var c=0;do switch(f[a+4>>2]|0){case 1:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 2:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 3:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 4:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 5:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 6:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 7:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 9:{c=f[a>>2]|0;if(!c)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}case 8:{c=f[a>>2]|0;if(!c)return;cYc(c);return}case 10:{c=f[a>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}default:return}while(0)}function ukc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=u;u=u+32|0;c=b+8|0;d=b;e=f[a>>2]|0;g=f[e+24>>2]|0;if(g|0){f[a>>2]=g;u=b;return a|0}g=a+4|0;h=f[g>>2]|0;i=a+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=f[h+16>>2]|0;l=f[k+(j<<2)>>2]|0;a:do if((l|0)!=(e|0)){b:do if(l|0?(l|0)!=(f[k+((j^1)<<2)>>2]|0):0){m=l;while(1){m=f[m+24>>2]|0;if(!m)break b;if((m|0)==(e|0)){n=j;o=h;p=9;break a}}}while(0);jkc(c,h,e,d);m=f[c+8>>2]|0;f[i>>2]=m;q=f[g>>2]|0;r=f[q+16>>2]|0;s=f[r+(m<<2)>>2]|0;if((s|0)!=0?(s|0)==(f[r+((m^1)<<2)>>2]|0):0){t=f[d>>2]|0;v=f[t+4>>2]|0;if(!v){w=t+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(t|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;t=f[x>>2]|0}while((f[t>>2]|0)!=(w|0));y=t}}else{x=v;while(1){t=f[x>>2]|0;if(!t)break;else x=t}y=x}f[d>>2]=y;if((y|0)!=(s+4|0)){f[a>>2]=f[y+16>>2];break}v=m+2|0;f[a>>2]=0;f[i>>2]=v;t=f[q+4>>2]|0;if(t>>>0>v>>>0){w=v;while(1){z=f[r+(w<<2)>>2]|0;if(z|0)break;v=w+1|0;f[i>>2]=v;if(v>>>0<t>>>0)w=v;else break a}if((z|0)==(f[r+((w^1)<<2)>>2]|0))A=f[(f[z>>2]|0)+16>>2]|0;else A=z;f[a>>2]=A}}else{n=m;o=q;p=9}}else{n=j;o=h;p=9}while(0);c:do if((p|0)==9?(h=n+1|0,f[a>>2]=0,f[i>>2]=h,j=f[o+4>>2]|0,j>>>0>h>>>0):0){A=f[o+16>>2]|0;z=h;while(1){B=f[A+(z<<2)>>2]|0;if(B|0)break;h=z+1|0;f[i>>2]=h;if(h>>>0<j>>>0)z=h;else break c}if((B|0)==(f[A+((z^1)<<2)>>2]|0))C=f[(f[B>>2]|0)+16>>2]|0;else C=B;f[a>>2]=C}while(0);u=b;return a|0}function vkc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d;g=d+24|0;h=e+8|0;f[h>>2]=0;hkc(e,c);f[e+16>>2]=0;Bkc(g,a,e);a=(f[g>>2]|0)+16|0;if((f[h>>2]|0)!=9){u=d;return a|0}h=f[e>>2]|0;if(!h){u=d;return a|0}if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h);u=d;return a|0}function wkc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;if(!c){d=$Xc(24)|0;f[d+8>>2]=0;hkc(d,b);f[d+16>>2]=0;f[d+20>>2]=0;e=d;return e|0}if(f[c+64>>2]|0)SXb(c,25480,24);d=QXb(c,24)|0;c=f[a>>2]|0;f[d+8>>2]=0;xkc(c,d);c=d+16|0;g=f[a>>2]|0;f[c>>2]=0;f[d+20>>2]=0;ykc(g,c);hkc(d,b);e=d;return e|0}function xkc(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2276);return}function ykc(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2277);return}function zkc(a){a=a|0;return}function Akc(a){a=a|0;var c=0;if((f[a+8>>2]|0)!=9)return;c=f[a>>2]|0;if(!c)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function Bkc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;jkc(g,c,d,0);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;b[a+12>>0]=0;u=e;return}k=(f[c>>2]|0)+1|0;j=f[c+4>>2]|0;i=j*12|0;l=i>>>4;if(l>>>0>k>>>0){if(j>>>0>8&i>>>6>>>0>=k>>>0){i=((k*5|0)>>>2)+1|0;k=1;while(1)if(i<<k>>>0<l>>>0)k=k+1|0;else break;l=j>>>k;k=l>>>0>8?l:8;if((k|0)!=(j|0)){Ckc(c,k);m=11}}}else if(j>>>0<=134217728){Ckc(c,j<<1);m=11}if((m|0)==11){jkc(h,c,d,0);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2]}m=f[g+12>>2]|0;g=f[c+20>>2]|0;if(!g)n=$Xc(32)|0;else{if(f[g+64>>2]|0)SXb(g,25480,32);n=QXb(g,32)|0}f[n+8>>2]=0;hkc(n,d);f[n+16>>2]=f[d+16>>2];Dkc(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];b[a+12>>0]=1;u=e;return}function Ckc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+16|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;f[h>>2]=b;j=a+20|0;k=f[j>>2]|0;l=b<<2;if(!k)m=$Xc(l)|0;else{b=l+7&-8;if(f[k+64>>2]|0)SXb(k,25480,b);m=QXb(k,b)|0}g1c(m|0,0,l|0)|0;f[e>>2]=m;m=a+12|0;e=f[m>>2]|0;f[m>>2]=f[h>>2];if(e>>>0<i>>>0){m=a+8|0;l=e;do{e=f[g+(l<<2)>>2]|0;do if(!e)n=l;else{if((e|0)==(f[g+((l^1)<<2)>>2]|0)){Jkc(a,g,l);n=l+1|0;break}b=e;do{k=b;b=f[b+24>>2]|0;o=kkc(a,k)|0;Dkc(d,a,(f[h>>2]|0)+-1&(f[m>>2]|0)+o,k)}while((b|0)!=0);n=l}while(0);l=n+1|0}while(l>>>0<i>>>0)}if(f[j>>2]|0){u=c;return}cYc(g);u=c;return}function Dkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e+8|0;h=e;i=b+16|0;j=f[i>>2]|0;k=j+(c<<2)|0;l=f[k>>2]|0;m=l;do if(!l){f[d+24>>2]=m;f[k>>2]=d;n=d;o=c}else{if((l|0)==(f[j+((c^1)<<2)>>2]|0)){f[d+24>>2]=0;p=f[k>>2]|0;f[h>>2]=d;Fkc(g,p,h,h);f[a>>2]=f[(f[g>>2]|0)+16>>2];f[a+4>>2]=b;f[a+8>>2]=c&-2;u=e;return}p=l;q=0;do{q=q+1|0;p=f[p+24>>2]|0}while((p|0)!=0);if(q>>>0>7){Ekc(b,c);f[d+24>>2]=0;p=f[(f[i>>2]|0)+(c<<2)>>2]|0;f[h>>2]=d;Fkc(g,p,h,h);n=f[(f[g>>2]|0)+16>>2]|0;o=c&-2;break}f[d+24>>2]=m;f[k>>2]=d;f[a>>2]=d;f[a+4>>2]=b;f[a+8>>2]=c;u=e;return}while(0);c=b+12|0;d=f[c>>2]|0;f[c>>2]=o>>>0<d>>>0?o:d;f[a>>2]=n;f[a+4>>2]=b;f[a+8>>2]=o;u=e;return}function Ekc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+32|0;d=c+24|0;e=c+16|0;g=c;h=a+20|0;i=f[h>>2]|0;if(!i)j=$Xc(16)|0;else{if(f[i+64>>2]|0)SXb(i,25480,16);j=QXb(i,16)|0}i=f[h>>2]|0;f[g+4>>2]=0;f[g+8>>2]=i;f[g+12>>2]=0;i=g+4|0;f[g>>2]=i;f[j>>2]=0;h=f[g+8>>2]|0;k=j+4|0;f[k>>2]=0;f[j+8>>2]=h;f[j+12>>2]=0;f[j>>2]=k;h=f[g>>2]|0;if((h|0)!=(i|0)){l=k;k=h;while(1){h=k+16|0;f[e>>2]=l;f[d>>2]=f[e>>2];Gkc(j,d,h,h)|0;h=f[k+4>>2]|0;if(!h){m=k+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(k|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=h;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}if((o|0)==(i|0))break;else k=o}}Hkc(g,f[i>>2]|0);i=a+16|0;a=f[i>>2]|0;g=f[a+(b<<2)>>2]|0;if(!g)q=a;else{a=g;do{f[e>>2]=a;Fkc(d,j,e,e);g=a+24|0;a=f[g>>2]|0;f[g>>2]=0}while((a|0)!=0);q=f[i>>2]|0}a=b^1;g=f[q+(a<<2)>>2]|0;if(!g){r=q;s=r+(a<<2)|0;f[s>>2]=j;t=f[i>>2]|0;v=t+(b<<2)|0;f[v>>2]=j;u=c;return}q=g;do{f[e>>2]=q;Fkc(d,j,e,e);g=q+24|0;q=f[g>>2]|0;f[g>>2]=0}while((q|0)!=0);r=f[i>>2]|0;s=r+(a<<2)|0;f[s>>2]=j;t=f[i>>2]|0;v=t+(b<<2)|0;f[v>>2]=j;u=c;return}function Fkc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=c+4|0;h=f[g>>2]|0;do if(h){i=c+4|0;j=h;while(1){k=j+16|0;if(mkc(f[d>>2]|0,f[k>>2]|0)|0){l=f[j>>2]|0;if(!l){m=6;break}else{n=j;o=l}}else{if(!(mkc(f[k>>2]|0,f[d>>2]|0)|0)){m=10;break}p=j+4|0;k=f[p>>2]|0;if(!k){m=9;break}else{n=p;o=k}}i=n;j=o}if((m|0)==6){q=j;r=j;break}else if((m|0)==9){q=j;r=p;break}else if((m|0)==10){q=j;r=i;break}}else{q=g;r=g}while(0);g=f[r>>2]|0;if(g|0){s=g;t=0;u=s;f[a>>2]=u;v=a+4|0;b[v>>0]=t;return}g=f[c+8>>2]|0;if(!g)w=$Xc(20)|0;else{if(f[g+64>>2]|0)SXb(g,25480,24);w=QXb(g,24)|0}f[w+16>>2]=f[e>>2];f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=q;f[r>>2]=w;q=f[f[c>>2]>>2]|0;if(!q)x=w;else{f[c>>2]=q;x=f[r>>2]|0}UQ(f[c+4>>2]|0,x);x=c+12|0;f[x>>2]=(f[x>>2]|0)+1;s=w;t=1;u=s;f[a>>2]=u;v=a+4|0;b[v>>0]=t;return}function Gkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;f[i>>2]=f[b>>2];f[g>>2]=f[i>>2];i=Ikc(a,g,h,e+4|0,c)|0;c=f[i>>2]|0;if(c|0){j=c;u=e;return j|0}c=f[a+8>>2]|0;if(!c)k=$Xc(20)|0;else{if(f[c+64>>2]|0)SXb(c,25480,24);k=QXb(c,24)|0}f[k+16>>2]=f[d>>2];d=f[h>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=d;f[i>>2]=k;d=f[f[a>>2]>>2]|0;if(!d)l=k;else{f[a>>2]=d;l=f[i>>2]|0}UQ(f[a+4>>2]|0,l);l=a+12|0;f[l>>2]=(f[l>>2]|0)+1;j=k;u=e;return j|0}function Hkc(a,b){a=a|0;b=b|0;if(!b)return;Hkc(a,f[b>>2]|0);Hkc(a,f[b+4>>2]|0);if(f[a+8>>2]|0)return;cYc(b);return}function Ikc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=h+16|0,!(mkc(f[e>>2]|0,f[i>>2]|0)|0)):0){if(!(mkc(f[i>>2]|0,f[e>>2]|0)|0)){f[c>>2]=b;f[d>>2]=b;j=d;return j|0}d=f[h+4>>2]|0;if(!d){i=h+8|0;k=f[i>>2]|0;if((f[k>>2]|0)==(h|0))l=k;else{k=i;do{i=f[k>>2]|0;k=i+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(i|0));l=m}}else{k=d;while(1){d=f[k>>2]|0;if(!d)break;else k=d}l=k}if((l|0)!=(g|0)?!(mkc(f[e>>2]|0,f[l+16>>2]|0)|0):0){k=f[g>>2]|0;if(!k){f[c>>2]=g;j=g;return j|0}d=a+4|0;m=k;while(1){k=m+16|0;if(mkc(f[e>>2]|0,f[k>>2]|0)|0){i=f[m>>2]|0;if(!i){n=39;break}else{o=m;p=i}}else{if(!(mkc(f[k>>2]|0,f[e>>2]|0)|0)){n=43;break}q=m+4|0;k=f[q>>2]|0;if(!k){n=42;break}else{o=q;p=k}}d=o;m=p}if((n|0)==39){f[c>>2]=m;j=m;return j|0}else if((n|0)==42){f[c>>2]=m;j=q;return j|0}else if((n|0)==43){f[c>>2]=m;j=d;return j|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;j=h+4|0;return j|0}else{f[c>>2]=l;j=l;return j|0}}if((h|0)!=(f[a>>2]|0)){l=f[h>>2]|0;if(!l){d=h;while(1){m=f[d+8>>2]|0;if((f[m>>2]|0)==(d|0))d=m;else{r=m;break}}}else{d=l;while(1){l=f[d+4>>2]|0;if(!l){r=d;break}else d=l}}if(!(mkc(f[r+16>>2]|0,f[e>>2]|0)|0)){d=f[g>>2]|0;if(!d){f[c>>2]=g;j=g;return j|0}g=a+4|0;a=d;while(1){d=a+16|0;if(mkc(f[e>>2]|0,f[d>>2]|0)|0){l=f[a>>2]|0;if(!l){n=17;break}else{s=a;t=l}}else{if(!(mkc(f[d>>2]|0,f[e>>2]|0)|0)){n=21;break}u=a+4|0;d=f[u>>2]|0;if(!d){n=20;break}else{s=u;t=d}}g=s;a=t}if((n|0)==17){f[c>>2]=a;j=a;return j|0}else if((n|0)==20){f[c>>2]=a;j=u;return j|0}else if((n|0)==21){f[c>>2]=a;j=g;return j|0}}else v=r}else v=b;if(!(f[h>>2]|0)){f[c>>2]=h;j=h;return j|0}else{h=v;f[c>>2]=h;j=h+4|0;return j|0}return 0}function Jkc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;g=f[b+(c<<2)>>2]|0;c=a+8|0;b=a+4|0;h=g+4|0;i=f[g>>2]|0;while(1){j=f[i+16>>2]|0;k=kkc(a,j)|0;Dkc(e,a,(f[b>>2]|0)+-1&(f[c>>2]|0)+k,j);j=f[i+4>>2]|0;if(!j){k=i+8|0;l=f[k>>2]|0;if((f[l>>2]|0)==(i|0))m=l;else{l=k;do{k=f[l>>2]|0;l=k+8|0;n=f[l>>2]|0}while((f[n>>2]|0)!=(k|0));m=n}}else{l=j;while(1){n=f[l>>2]|0;if(!n)break;else l=n}m=l}if((m|0)==(h|0))break;else i=m}m=f[a+20>>2]|0;Hkc(g,f[h>>2]|0);if(m|0){u=d;return}cYc(g);u=d;return}function Kkc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+8|0;g=d;h=f[c+4>>2]|0;i=c+8|0;j=f[i>>2]&(f[h+4>>2]|0)+-1;f[i>>2]=j;k=h+16|0;l=f[k>>2]|0;m=f[l+(j<<2)>>2]|0;n=f[c>>2]|0;a:do if((m|0)!=(n|0)){b:do if(m|0?(m|0)!=(f[l+((j^1)<<2)>>2]|0):0){c=m;while(1){c=f[c+24>>2]|0;if(!c)break b;if((c|0)==(n|0)){o=j;p=7;break a}}}while(0);jkc(e,h,n,g);c=f[e+8>>2]|0;f[i>>2]=c;q=f[k>>2]|0;r=f[q+(c<<2)>>2]|0;if(r){s=a+16|0;t=(f[s>>2]|0)+(c<<2)|0;if((r|0)==(f[q+((c^1)<<2)>>2]|0)){q=f[t>>2]|0;Mkc(q,(f[g>>2]|0)+16|0)|0;if(!(f[q+12>>2]|0)){r=c&-2;v=f[a+20>>2]|0;Hkc(q,f[q+4>>2]|0);if(!v)cYc(q);f[(f[s>>2]|0)+((c|1)<<2)>>2]=0;f[(f[s>>2]|0)+(r<<2)>>2]=0;w=r;x=s}else{w=c;x=s}}else{y=t;z=s;A=c;p=9}}else{o=c;p=7}}else{o=j;p=7}while(0);if((p|0)==7){j=a+16|0;y=(f[j>>2]|0)+(o<<2)|0;z=j;A=o;p=9}if((p|0)==9){o=Lkc(a,n,f[y>>2]|0)|0;f[(f[z>>2]|0)+(A<<2)>>2]=o;w=A;x=z}if((f[n+8>>2]|0)==9?(z=f[n>>2]|0,z|0):0){if((b[z+11>>0]|0)<0)cYc(f[z>>2]|0);cYc(z)}if(!(f[a+20>>2]|0))cYc(n);f[a>>2]=(f[a>>2]|0)+-1;n=a+12|0;if((w|0)!=(f[n>>2]|0)){u=d;return}z=f[a+4>>2]|0;if(w>>>0>=z>>>0){u=d;return}a=f[x>>2]|0;x=w;while(1){if(f[a+(x<<2)>>2]|0){p=26;break}x=x+1|0;f[n>>2]=x;if(x>>>0>=z>>>0){p=26;break}}if((p|0)==26){u=d;return}}function Lkc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=c+24|0;e=f[d>>2]|0;if((c|0)==(b|0))return e|0;else{g=Lkc(a,b,e)|0;f[d>>2]=g;return c|0}return 0}function Mkc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[c>>2]|0;if(!d){e=0;return e|0}else{g=c;h=d}a:while(1){d=h;while(1){if(!(mkc(f[d+16>>2]|0,f[b>>2]|0)|0))break;i=f[d+4>>2]|0;if(!i){j=g;break a}else d=i}h=f[d>>2]|0;if(!h){j=d;break}else g=d}if((j|0)==(c|0)){e=0;return e|0}if(mkc(f[b>>2]|0,f[j+16>>2]|0)|0){e=0;return e|0}b=f[j+4>>2]|0;if(!b){c=j+8|0;g=f[c>>2]|0;if((f[g>>2]|0)==(j|0))k=g;else{g=c;do{c=f[g>>2]|0;g=c+8|0;h=f[g>>2]|0}while((f[h>>2]|0)!=(c|0));k=h}}else{g=b;while(1){b=f[g>>2]|0;if(!b)break;else g=b}k=g}if((f[a>>2]|0)==(j|0))f[a>>2]=k;k=a+12|0;f[k>>2]=(f[k>>2]|0)+-1;XIa(f[a+4>>2]|0,j);if(f[a+8>>2]|0){e=1;return e|0}cYc(j);e=1;return e|0}function Nkc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){e=Joc(b,d)|0;yic(b,e);if((b|0)==0|(c|0)!=0)g=e;else{Yi[f[(f[b>>2]|0)+4>>2]&4095](b);g=e}}else g=b;else{fgc(d,b);g=b}b=a+12|0;d=f[b>>2]|0;e=f[a+8>>2]|0;c=a+4|0;do if((d|0)!=0?(h=f[c>>2]|0,(h|0)!=(e|0)):0){i=f[d>>2]|0;if((i|0)==(e|0)){j=f[d+4+(h<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;break}Yi[f[(f[j>>2]|0)+4>>2]&4095](j);k=f[b>>2]|0;break}if((h|0)<(i|0)){f[d+4+(i<<2)>>2]=f[d+4+(h<<2)>>2];h=f[b>>2]|0;l=h;m=f[h>>2]|0}else{l=d;m=i}f[l>>2]=m+1;k=l}else n=8;while(0);if((n|0)==8){XZb(a,e+1|0);e=f[b>>2]|0;f[e>>2]=(f[e>>2]|0)+1;k=e}e=f[c>>2]|0;f[c>>2]=e+1;f[k+4+(e<<2)>>2]=g;return}function Okc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==9){d=f[a>>2]|0;u=b;return d|0}u_b(c,3,501750,639);e=p_b(p_b(p_b(p_b(c,501867)|0,502459)|0,501922)|0,501944)|0;g=p_b(p_b(p_b(e,f[41458]|0)|0,505563)|0,501958)|0;e=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(g,f[e>>2]|0)|0);v_b(c);d=f[a>>2]|0;u=b;return d|0}function Pkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==2){d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}u_b(c,3,501750,609);l=p_b(p_b(p_b(p_b(c,501867)|0,502432)|0,501922)|0,501944)|0;m=p_b(p_b(p_b(l,f[41451]|0)|0,505563)|0,501958)|0;l=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(m,f[l>>2]|0)|0);v_b(c);d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}function Qkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==1){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}u_b(c,3,501750,619);g=p_b(p_b(p_b(p_b(c,501867)|0,502405)|0,501922)|0,501944)|0;h=p_b(p_b(p_b(g,f[41450]|0)|0,505563)|0,501958)|0;g=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(h,f[g>>2]|0)|0);v_b(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function Rkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==4){d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}u_b(c,3,501750,614);l=p_b(p_b(p_b(p_b(c,501867)|0,502377)|0,501922)|0,501944)|0;m=p_b(p_b(p_b(l,f[41453]|0)|0,505563)|0,501958)|0;l=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(m,f[l>>2]|0)|0);v_b(c);d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}function Skc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==3){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}u_b(c,3,501750,624);g=p_b(p_b(p_b(p_b(c,501867)|0,502349)|0,501922)|0,501944)|0;h=p_b(p_b(p_b(g,f[41452]|0)|0,505563)|0,501958)|0;g=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(h,f[g>>2]|0)|0);v_b(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function Tkc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c;if((Ykc(a)|0)==7){e=f[a>>2]|0;g=b[e>>0]|0;h=g<<24>>24!=0;u=c;return h|0}u_b(d,3,501750,629);i=p_b(p_b(p_b(p_b(d,501867)|0,502323)|0,501922)|0,501944)|0;j=p_b(p_b(p_b(i,f[41456]|0)|0,505563)|0,501958)|0;i=165796+((Ykc(a)|0)<<2)|0;r_b(c+24|0,p_b(j,f[i>>2]|0)|0);v_b(d);e=f[a>>2]|0;g=b[e>>0]|0;h=g<<24>>24!=0;u=c;return h|0}function Ukc(a){a=a|0;var b=0,c=0,d=0,e=0.0,g=0,h=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==5){d=f[a>>2]|0;e=+p[d>>3];u=b;return +e}u_b(c,3,501750,649);g=p_b(p_b(p_b(p_b(c,501867)|0,502295)|0,501922)|0,501944)|0;h=p_b(p_b(p_b(g,f[41454]|0)|0,505563)|0,501958)|0;g=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(h,f[g>>2]|0)|0);v_b(c);d=f[a>>2]|0;e=+p[d>>3];u=b;return +e}function Vkc(a){a=a|0;var b=0,c=0,d=0,e=0.0,g=0,h=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==6){d=f[a>>2]|0;e=+n[d>>2];u=b;return +e}u_b(c,3,501750,644);g=p_b(p_b(p_b(p_b(c,501867)|0,502268)|0,501922)|0,501944)|0;h=p_b(p_b(p_b(g,f[41455]|0)|0,505563)|0,501958)|0;g=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(h,f[g>>2]|0)|0);v_b(c);d=f[a>>2]|0;e=+n[d>>2];u=b;return +e}function Wkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==8){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}u_b(c,3,501750,634);g=p_b(p_b(p_b(p_b(c,501867)|0,502242)|0,501922)|0,501944)|0;h=p_b(p_b(p_b(g,f[41457]|0)|0,505563)|0,501958)|0;g=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(h,f[g>>2]|0)|0);v_b(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function Xkc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((Ykc(a)|0)==10){d=f[a>>2]|0;u=b;return d|0}u_b(c,3,501750,655);e=p_b(p_b(p_b(p_b(c,501867)|0,502163)|0,501922)|0,501944)|0;g=p_b(p_b(p_b(e,f[41459]|0)|0,505563)|0,501958)|0;e=165796+((Ykc(a)|0)<<2)|0;r_b(b+24|0,p_b(g,f[e>>2]|0)|0);v_b(c);d=f[a>>2]|0;u=b;return d|0}function Ykc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=b+24|0;e=a+4|0;g=f[e>>2]|0;if(g|0?f[a>>2]|0:0){h=g;u=b;return h|0}u_b(c,3,501750,683);r_b(d,p_b(p_b(c,501867)|0,502192)|0);v_b(c);h=f[e>>2]|0;u=b;return h|0}function Zkc(a){a=a|0;var b=0;skc(a);if(f[a>>2]|0)return;b=f[a+8>>2]|0;if(!b)return;a=b+16|0;if(f[a>>2]|0?(_kc(b),(f[b+20>>2]|0)==0):0)cYc(f[a>>2]|0);cYc(b);return}function _kc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!(f[c>>2]|0)){d=0;f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}g=a+16|0;h=a+20|0;i=0;while(1){j=f[g>>2]|0;k=j+(i<<2)|0;l=f[k>>2]|0;a:do if(l){if((l|0)!=(f[j+((i^1)<<2)>>2]|0)){f[k>>2]=0;m=l;while(1){n=m;m=f[m+24>>2]|0;if((f[n+8>>2]|0)==9?(o=f[n>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);cYc(o)}if(!(f[h>>2]|0))cYc(n);if(!m){p=i;break a}}}if((l|0)==(f[j+((i^1)<<2)>>2]|0)){m=i+1|0;f[j+(m<<2)>>2]=0;f[(f[g>>2]|0)+(i<<2)>>2]=0;n=l+12|0;o=l+4|0;q=l+8|0;r=l+4|0;s=f[l>>2]|0;do{t=s;u=f[t+16>>2]|0;v=s;w=f[v+4>>2]|0;if(!w){x=v+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(v|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=w;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}w=f[t+4>>2]|0;if(!w){A=t+8|0;x=f[A>>2]|0;if((f[x>>2]|0)==(v|0))B=x;else{x=A;do{A=f[x>>2]|0;x=A+8|0;C=f[x>>2]|0}while((f[C>>2]|0)!=(A|0));B=C}}else{x=w;while(1){y=f[x>>2]|0;if(!y)break;else x=y}B=x}if((f[l>>2]|0)==(t|0))f[l>>2]=B;f[n>>2]=(f[n>>2]|0)+-1;XIa(f[o>>2]|0,v);if(!(f[q>>2]|0))cYc(s);s=z;if((f[u+8>>2]|0)==9?(w=f[u>>2]|0,w|0):0){if((b[w+11>>0]|0)<0)cYc(f[w>>2]|0);cYc(w)}if(!(f[h>>2]|0))cYc(u)}while((z|0)!=(r|0));s=f[h>>2]|0;Hkc(l,f[r>>2]|0);if(!s){cYc(l);p=m}else p=m}else p=i}else p=i;while(0);i=p+1|0;l=f[c>>2]|0;if(i>>>0>=l>>>0){d=l;break}}f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}function $kc(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+16|0;if(f[b>>2]|0){c=a+8|0;d=f[c>>2]|0;return d|0}e=a+12|0;g_b(e);if(!(f[b>>2]|0)){Yi[f[(f[a>>2]|0)+40>>2]&4095](a);f[b>>2]=2}h_b(e);c=a+8|0;d=f[c>>2]|0;return d|0}function alc(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+16|0;if(f[b>>2]|0){f[b>>2]=1;c=a+8|0;d=f[c>>2]|0;return d|0}e=a+12|0;g_b(e);if(!(f[b>>2]|0)){Yi[f[(f[a>>2]|0)+40>>2]&4095](a);f[b>>2]=2}h_b(e);f[b>>2]=1;c=a+8|0;d=f[c>>2]|0;return d|0}function blc(a){a=a|0;var b=0,c=0;b=a+12|0;g_b(b);c=_i[f[(f[a>>2]|0)+36>>2]&2047](a)|0;h_b(b);return c|0}function clc(a){a=a|0;return (f[a+16>>2]|0)!=1|0}function dlc(a){a=a|0;f[a+16>>2]=0;return}function elc(a){a=a|0;var b=0,c=0;b=a+16|0;if((f[b>>2]|0)!=1)return;c=a+12|0;g_b(c);if((f[b>>2]|0)==1){Yi[f[(f[a>>2]|0)+44>>2]&4095](a);f[b>>2]=2}h_b(c);return}function flc(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=171580;f[a+4>>2]=0;f[a+8>>2]=0;w_b(a+12|0);f[a+16>>2]=0;f[a>>2]=171652;c=a+20|0;f[c>>2]=0;f[a+24>>2]=0;glc(c);f[a+32>>2]=b;return}function glc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a>>2]|0;c=b;if(!b){d=$Xc(24)|0;f[d>>2]=0;f[d+8>>2]=d;e=d+16|0;f[e>>2]=0;f[d+20>>2]=c;g=$Xc(32)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;h=g;i=d;j=e;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}e=b+64|0;if(f[e>>2]|0)SXb(b,21536,24);d=RXb(b,24,2278)|0;f[d>>2]=0;f[d+8>>2]=d;g=d+16|0;f[g>>2]=0;f[d+20>>2]=c;if(f[e>>2]|0)SXb(b,25480,32);e=QXb(b,32)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=e;i=d;j=g;f[j>>2]=h;k=i+12|0;f[k>>2]=8;l=i+4|0;f[l>>2]=8;m=a+8|0;f[m>>2]=i;return}function hlc(a){a=a|0;var b=0;b=a+16|0;if(!(f[b>>2]|0))return;_kc(a);if(f[a+20>>2]|0)return;cYc(f[b>>2]|0);return}function ilc(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);lYc(a,f[(f[d>>2]|0)+4>>2]|0);u=c;return}function jlc(a){a=a|0;Noc(a);return}function klc(a){a=a|0;return Poc(a)|0}function llc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d+16|0;g=d;f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Roc(c,e,g);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=f[g>>2]|0;i=f[h>>2]|0;if((c|0)==(i|0))j=c;else{k=e+4|0;l=c;do{if((l|0)!=(c|0))AYc(a,528271)|0;m=b[l+11>>0]|0;n=m<<24>>24<0;f[e>>2]=n?f[l>>2]|0:l;f[k>>2]=n?f[l+4>>2]|0:m&255;xtc(a,e);l=l+12|0}while((l|0)!=(i|0));j=f[g>>2]|0}if(!j){u=d;return}i=f[h>>2]|0;if((i|0)==(j|0))o=j;else{l=i;while(1){i=l+-12|0;f[h>>2]=i;if((b[i+11>>0]|0)<0){cYc(f[i>>2]|0);p=f[h>>2]|0}else p=i;if((p|0)==(j|0))break;else l=p}o=f[g>>2]|0}cYc(o);u=d;return}function mlc(a,b){a=a|0;b=b|0;mi[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function nlc(a,b){a=a|0;b=b|0;return Sqc(b,a)|0}function olc(a){a=a|0;var b=0;b=krc(a)|0;mi[f[(f[a>>2]|0)+88>>2]&2047](a,b);return b|0}function plc(a,b){a=a|0;b=b|0;var c=0;c=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;if(!c){Wqc(a,_i[f[(f[a>>2]|0)+60>>2]&2047](a)|0,b);return}else{XXb(a,(f[c+4>>2]|0)+20|0,(f[c>>2]|0)+-1|0,b);return}}function qlc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);if((f[d>>2]|0)==(g|0)){Moc(b,a);u=c;return}u_b(e,3,502719,80);h=p_b(p_b(e,502911)|0,503036)|0;i=p_b(q_b(h,f[g+4>>2]|0)|0,503027)|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);r_b(c+32|0,q_b(i,f[(f[d>>2]|0)+4>>2]|0)|0);v_b(e);Moc(b,a);u=c;return}function rlc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);if((f[d>>2]|0)==(g|0)){Ooc(b,a);u=c;return}u_b(e,3,502719,67);h=p_b(p_b(e,502911)|0,502966)|0;i=p_b(q_b(h,f[g+4>>2]|0)|0,503027)|0;mi[f[(f[b>>2]|0)+96>>2]&2047](d,b);r_b(c+32|0,q_b(i,f[(f[d>>2]|0)+4>>2]|0)|0);v_b(e);Ooc(b,a);u=c;return}function slc(a){a=a|0;Qoc(a);return}function tlc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;mi[f[(f[a>>2]|0)+96>>2]&2047](c,a);d=f[c+4>>2]|0;c=Mi[f[(f[d>>2]|0)+16>>2]&1023](d,a)|0;u=b;return c|0}function ulc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=u;u=u+48|0;c=b+24|0;d=b;u_b(d,3,502719,162);e=p_b(d,502808)|0;mi[f[(f[a>>2]|0)+96>>2]&2047](c,a);r_b(b+32|0,p_b(q_b(e,f[(f[c>>2]|0)+4>>2]|0)|0,502824)|0);v_b(d);u=b;return}function vlc(a){a=a|0;return}function wlc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+80|0;d=a+48|0;e=a+24|0;g=a;h=a+64|0;if((f[c+32>>2]|0)!=3){u_b(e,3,502719,406);r_b(a+65|0,p_b(e,503122)|0);v_b(e)}e=c+24|0;i=f[e>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[d>>2]=80424;f[d+4>>2]=2231;b[d+8>>0]=0;f[d+12>>2]=c;J_b(i,d)}i=c+28|0;do switch(f[165644+(f[i>>2]<<2)>>2]|0){case 1:{if((f[223575]|0)!=2){f[d>>2]=165456;f[d+4>>2]=165;b[d+8>>0]=0;J_b(894300,d);a_b(d)}j=f[223576]|0;u=a;return j|0}case 3:{if((f[223577]|0)!=2){f[d>>2]=165456;f[d+4>>2]=166;b[d+8>>0]=0;J_b(894308,d);a_b(d)}j=f[223578]|0;u=a;return j|0}case 2:{if((f[223579]|0)!=2){f[d>>2]=165456;f[d+4>>2]=167;b[d+8>>0]=0;J_b(894316,d);a_b(d)}j=f[223580]|0;u=a;return j|0}case 4:{if((f[223581]|0)!=2){f[d>>2]=165456;f[d+4>>2]=168;b[d+8>>0]=0;J_b(894324,d);a_b(d)}j=f[223582]|0;u=a;return j|0}case 6:{if((f[223583]|0)!=2){f[d>>2]=165456;f[d+4>>2]=169;b[d+8>>0]=0;J_b(894332,d);a_b(d)}j=f[223584]|0;u=a;return j|0}case 5:{if((f[223585]|0)!=2){f[d>>2]=165456;f[d+4>>2]=170;b[d+8>>0]=0;J_b(894340,d);a_b(d)}j=f[223586]|0;u=a;return j|0}case 7:{if((f[223587]|0)!=2){f[d>>2]=165456;f[d+4>>2]=171;b[d+8>>0]=0;J_b(894348,d);a_b(d)}j=f[223588]|0;u=a;return j|0}case 8:{if((f[223575]|0)!=2){f[d>>2]=165456;f[d+4>>2]=165;b[d+8>>0]=0;J_b(894300,d);a_b(d)}j=f[223576]|0;u=a;return j|0}case 9:{if((f[223589]|0)!=2){f[d>>2]=165456;f[d+4>>2]=172;b[d+8>>0]=0;J_b(894356,d);a_b(d)}j=f[223590]|0;u=a;return j|0}case 10:{k=f[e>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[d>>2]=80424;f[d+4>>2]=2231;b[d+8>>0]=0;f[d+12>>2]=c;J_b(k,d)}if((f[i>>2]|0)==11?D3b(c)|0:0){if((f[223591]|0)!=2){f[d>>2]=165456;f[d+4>>2]=173;b[d+8>>0]=0;J_b(894364,d);a_b(d)}j=f[223592]|0;u=a;return j|0}if((f[223593]|0)!=2){f[d>>2]=165456;f[d+4>>2]=174;b[d+8>>0]=0;J_b(894372,d);a_b(d)}j=f[223594]|0;u=a;return j|0}default:{u_b(g,3,502719,434);r_b(h,p_b(g,503159)|0);v_b(g);j=0;u=a;return j|0}}while(0);return 0}function xlc(){var a=0;a=$Xc(4)|0;f[a>>2]=172540;f[223576]=a;return}function ylc(){var a=0;a=$Xc(4)|0;f[a>>2]=172452;f[223578]=a;return}function zlc(){var a=0;a=$Xc(4)|0;f[a>>2]=172364;f[223580]=a;return}function Alc(){var a=0;a=$Xc(4)|0;f[a>>2]=172276;f[223582]=a;return}function Blc(){var a=0;a=$Xc(4)|0;f[a>>2]=172188;f[223584]=a;return}function Clc(){var a=0;a=$Xc(4)|0;f[a>>2]=172100;f[223586]=a;return}function Dlc(){var a=0;a=$Xc(4)|0;f[a>>2]=172012;f[223588]=a;return}function Elc(){var a=0;a=$Xc(4)|0;f[a>>2]=171920;f[223590]=a;return}function Flc(){var a=0;a=$Xc(4)|0;f[a>>2]=171828;f[223592]=a;return}function Glc(){var a=0;a=$Xc(4)|0;f[a>>2]=171736;f[223594]=a;return}function Hlc(a){a=a|0;return}function Ilc(a){a=a|0;cYc(a);return}function Jlc(a,b){a=a|0;b=b|0;return (f[b+4>>2]|0)==0|0}function Klc(a,b){a=a|0;b=b|0;return f[b+4>>2]|0}function Llc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+80>>2]&511](a,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0,d)|0}function Mlc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=b+4|0;c=f[a>>2]|0;if((c|0)<=0)return;d=f[b+12>>2]|0;b=0;do{e=f[d+4+(b<<2)>>2]|0;b=b+1|0;Yi[f[(f[e>>2]|0)+28>>2]&4095](e)}while((b|0)!=(c|0));f[a>>2]=0;return}function Nlc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,d,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0);return}function Olc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,c,d);c=_i[f[(f[d>>2]|0)+24>>2]&2047](d)|0;a=f[b>>2]|0;if(((a|0)==(c|0)?(c=b+12|0,e=f[c>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[b+8>>2]|0)):0){h=b+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[c>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}Nkc(b,d,_i[f[(f[d>>2]|0)+20>>2]&2047](d)|0,a);return}function Plc(a,b){a=a|0;b=b|0;var c=0;a=f[b+12>>2]|0;c=b+4|0;b=(f[c>>2]|0)+-1|0;f[c>>2]=b;c=f[a+4+(b<<2)>>2]|0;Yi[f[(f[c>>2]|0)+28>>2]&4095](c);return}function Qlc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+12>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function Rlc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;if((a|0)!=(c|0)){u_b(g,3,503182,358);r_b(e+24|0,p_b(g,503282)|0);v_b(g)}if((b|0)==(d|0)){u=e;return}if((f[d>>2]|0)==(f[b>>2]|0)){g=b+12|0;c=d+12|0;a=f[g>>2]|0;f[g>>2]=f[c>>2];f[c>>2]=a;a=b+4|0;c=d+4|0;g=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=g;g=b+8|0;c=d+8|0;a=f[g>>2]|0;f[g>>2]=f[c>>2];f[c>>2]=a;u=e;return}else{amc(b,d);u=e;return}}function Slc(a,b){a=a|0;b=b|0;return 0}function Tlc(a,b){a=a|0;b=b|0;return Mi[f[(f[a>>2]|0)+12>>2]&1023](a,b)|0}function Ulc(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function Vlc(a,b,c){a=a|0;b=b|0;c=c|0;return c+1|0}function Wlc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (c|0)==(d|0)|0}function Xlc(a,b,c){a=a|0;b=b|0;c=c|0;return}function Ylc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hh[f[(f[a>>2]|0)+16>>2]&127](a,b,c,d)|0}function Zlc(a,b){a=a|0;b=b|0;return _i[f[(f[b>>2]|0)+12>>2]&2047](b)|0}function _lc(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[(f[c>>2]|0)+72>>2]&2047](c,b);return}function $lc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function amc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;bmc(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;Yi[f[(f[m>>2]|0)+28>>2]&4095](m)}while((l|0)!=(j|0));f[i>>2]=0}bmc(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{m=f[l+4+(k<<2)>>2]|0;k=k+1|0;Yi[f[(f[m>>2]|0)+28>>2]&4095](m)}while((k|0)!=(i|0));f[a>>2]=0;n=0}else n=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=n;n=b+8|0;b=f[n>>2]|0;f[n>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{n=f[b+4+(g<<2)>>2]|0;if(n|0)Yi[f[(f[n>>2]|0)+4>>2]&4095](n);g=g+1|0}while((g|0)!=(i|0));o=f[h>>2]|0}else o=d;cYc(o);u=c;return}function bmc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{yic(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Mi[f[(f[h>>2]|0)+16>>2]&1023](h,i)|0;yic(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function cmc(a){a=a|0;cYc(a);return}function dmc(a,b){a=a|0;b=b|0;a=($kc(b)|0)+4|0;return (f[a>>2]|0)==0|0}function emc(a,b){a=a|0;b=b|0;a=($kc(b)|0)+4|0;return f[a>>2]|0}function fmc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[(f[a>>2]|0)+80>>2]|0;g=($kc(b)|0)+12|0;return hj[e&511](a,f[(f[g>>2]|0)+4+(c<<2)>>2]|0,d)|0}function gmc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=alc(b)|0;b=a+4|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a+12>>2]|0;a=0;do{e=f[d+4+(a<<2)>>2]|0;a=a+1|0;Yi[f[(f[e>>2]|0)+28>>2]&4095](e)}while((a|0)!=(c|0));f[b>>2]=0;return}function hmc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[(f[a>>2]|0)+76>>2]|0;g=(alc(b)|0)+12|0;Ti[e&511](a,d,f[(f[g>>2]|0)+4+(c<<2)>>2]|0);return}function imc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,c,d);c=alc(b)|0;b=_i[f[(f[d>>2]|0)+24>>2]&2047](d)|0;a=f[c>>2]|0;if(((a|0)==(b|0)?(b=c+12|0,e=f[b>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[c+8>>2]|0)):0){h=c+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[b>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}Nkc(c,d,_i[f[(f[d>>2]|0)+20>>2]&2047](d)|0,a);return}function jmc(a,b){a=a|0;b=b|0;var c=0;a=alc(b)|0;b=f[a+12>>2]|0;c=a+4|0;a=(f[c>>2]|0)+-1|0;f[c>>2]=a;c=f[b+4+(a<<2)>>2]|0;Yi[f[(f[c>>2]|0)+28>>2]&4095](c);return}function kmc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=(alc(b)|0)+12|0;b=f[a>>2]|0;a=b+4+(c<<2)|0;c=b+4+(d<<2)|0;d=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=d;return}function lmc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;if((a|0)!=(c|0)){u_b(g,3,503182,240);r_b(e+24|0,p_b(g,503282)|0);v_b(g)}g=alc(b)|0;b=alc(d)|0;if((g|0)==(b|0)){u=e;return}if((f[b>>2]|0)==(f[g>>2]|0)){d=g+12|0;c=b+12|0;a=f[d>>2]|0;f[d>>2]=f[c>>2];f[c>>2]=a;a=g+4|0;c=b+4|0;d=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=d;d=g+8|0;c=b+8|0;a=f[d>>2]|0;f[d>>2]=f[c>>2];f[c>>2]=a;u=e;return}else{amc(g,b);u=e;return}}function mmc(a,b){a=a|0;b=b|0;return _i[f[(f[b>>2]|0)+12>>2]&2047](b)|0}function nmc(a,b,c){a=a|0;b=b|0;c=c|0;mi[f[(f[c>>2]|0)+72>>2]&2047](c,b);return}function omc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function pmc(a){a=a|0;cYc(a);return}function qmc(a,b){a=a|0;b=b|0;return (f[b+4>>2]|0)==0|0}function rmc(a,b){a=a|0;b=b|0;return f[b+4>>2]|0}function smc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+80>>2]&511](a,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0,d)|0}function tmc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;a=c+4|0;d=f[a>>2]|0;if((d|0)<=0)return;e=f[c+12>>2]|0;c=0;do{g=f[e+4+(c<<2)>>2]|0;c=c+1|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[h>>0]=0}}while((c|0)!=(d|0));f[a>>2]=0;return}function umc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,d,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0);return}function vmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;Ti[f[(f[a>>2]|0)+76>>2]&511](a,c,d);c=f[b>>2]|0;if(((c|0)==0?(a=b+12|0,e=f[a>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[b+8>>2]|0)):0){h=b+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[a>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}Dmc(b,d,0,c);return}function wmc(a,c){a=a|0;c=c|0;var d=0;a=f[c+12>>2]|0;d=c+4|0;c=(f[d>>2]|0)+-1|0;f[d>>2]=c;d=f[a+4+(c<<2)>>2]|0;c=d+11|0;if((b[c>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;return}else{b[d>>0]=0;b[c>>0]=0;return}}function xmc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+12>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function ymc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;if((a|0)==(d|0)){if((c|0)==(e|0)){u=g;return}if((f[e>>2]|0)==(f[c>>2]|0)){k=c+12|0;l=e+12|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;m=c+4|0;l=e+4|0;k=f[m>>2]|0;f[m>>2]=f[l>>2];f[l>>2]=k;k=c+8|0;l=e+8|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;u=g;return}else{Cmc(c,e);u=g;return}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;do if((i|0)!=(c|0))if(!(f[c>>2]|0)){m=c+12|0;f[i+12>>2]=f[m>>2];f[m>>2]=0;m=c+4|0;f[i+4>>2]=f[m>>2];f[m>>2]=0;m=c+8|0;f[i+8>>2]=f[m>>2];f[m>>2]=0;break}else{Cmc(i,c);break}while(0);m=Mi[f[(f[d>>2]|0)+12>>2]&1023](d,e)|0;if((m|0)>0){l=h+11|0;k=h+11|0;n=j+11|0;o=0;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;lYc(j,hh[f[(f[d>>2]|0)+16>>2]&127](d,e,o,h)|0);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);lYc(h,j);Ti[f[(f[a>>2]|0)+28>>2]&511](a,c,h);if((b[k>>0]|0)<0)cYc(f[h>>2]|0);if((b[n>>0]|0)<0)cYc(f[j>>2]|0);o=o+1|0}while((o|0)<(m|0))}m=Mi[f[(f[a>>2]|0)+12>>2]&1023](a,c)|0;mi[f[(f[d>>2]|0)+20>>2]&2047](d,e);c=i+12|0;a=f[c>>2]|0;if((m|0)>0){o=h+11|0;j=0;n=a;while(1){lYc(h,f[n+4+(j<<2)>>2]|0);Ti[f[(f[d>>2]|0)+28>>2]&511](d,e,h);if((b[o>>0]|0)<0)cYc(f[h>>2]|0);j=j+1|0;k=f[c>>2]|0;if((j|0)>=(m|0)){p=k;break}else n=k}}else p=a;if(p|0?(f[i>>2]|0)==0:0){i=f[p>>2]|0;if((i|0)>0){a=0;do{n=f[p+4+(a<<2)>>2]|0;if(n|0){if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);cYc(n)}a=a+1|0}while((a|0)!=(i|0));q=f[c>>2]|0}else q=p;cYc(q)}u=g;return}function zmc(a,b){a=a|0;b=b|0;b=$Xc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;return b|0}function Amc(a,b,c){a=a|0;b=b|0;c=c|0;oYc(c,b)|0;return}function Bmc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Cmc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=e+4|0;f[g>>2]=0;h=e+8|0;f[h>>2]=0;i=e+12|0;f[i>>2]=0;vSa(e,a);j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[a+12>>2]|0;m=0;do{n=f[l+4+(m<<2)>>2]|0;m=m+1|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0}else{b[n>>0]=0;b[o>>0]=0}}while((m|0)!=(k|0));f[j>>2]=0}vSa(a,c);a=c+4|0;j=f[a>>2]|0;k=c+12|0;if((j|0)>0){m=f[k>>2]|0;l=0;do{o=f[m+4+(l<<2)>>2]|0;l=l+1|0;n=o+11|0;if((b[n>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[n>>0]=0}}while((l|0)!=(j|0));f[a>>2]=0;p=0}else p=j;j=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=j;f[a>>2]=f[g>>2];f[g>>2]=p;p=c+8|0;c=f[p>>2]|0;f[p>>2]=f[h>>2];f[h>>2]=c;c=j;if(!((j|0)!=0&(f[e>>2]|0)==0)){u=d;return}e=j;j=f[c>>2]|0;if((j|0)>0){h=0;do{p=f[c+4+(h<<2)>>2]|0;if(p|0){if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);cYc(p)}h=h+1|0}while((h|0)!=(j|0));q=f[i>>2]|0}else q=e;cYc(q);u=d;return}function Dmc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;if(!((d|0)==0&(e|0)!=0))if((e|0)!=(d|0)){if(!e){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g}else{if(f[e+64>>2]|0)SXb(e,4984,16);g=RXb(e,16,2233)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g}oYc(h,c)|0;if((c|0)==0|(d|0)!=0)i=h;else{if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);i=h}}else i=c;else{yJa(e,c);i=c}Emc(a,i);return}function Emc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+12|0;e=f[d>>2]|0;g=f[a+8>>2]|0;h=a+4|0;do if((e|0)!=0?(i=f[h>>2]|0,(i|0)!=(g|0)):0){j=f[e>>2]|0;if((j|0)!=(g|0)){if((i|0)<(j|0)){f[e+4+(j<<2)>>2]=f[e+4+(i<<2)>>2];k=f[d>>2]|0;l=k;m=f[k>>2]|0}else{l=e;m=j}f[l>>2]=m+1;n=l;break}j=f[e+4+(i<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0)n=e;else{if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(j);n=f[d>>2]|0}}else o=3;while(0);if((o|0)==3){XZb(a,g+1|0);g=f[d>>2]|0;f[g>>2]=(f[g>>2]|0)+1;n=g}g=f[h>>2]|0;f[h>>2]=g+1;f[n+4+(g<<2)>>2]=c;return}function Fmc(a){a=a|0;cYc(a);return}function Gmc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Hmc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Imc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+c|0,d)|0}function Jmc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Kmc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;g=(Mi[f[(f[a>>2]|0)+72>>2]&1023](a,e)|0)&1;b[(f[c+8>>2]|0)+4+d>>0]=g;return}function Lmc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=(Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0)&1;d=f[c>>2]|0;if((d|0)==(f[c+4>>2]|0)){wSa(c,d+1|0);g=f[c>>2]|0}else g=d;d=f[c+8>>2]|0;f[c>>2]=g+1;b[d+4+g>>0]=e;return}function Mmc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Nmc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=f[c+8>>2]|0;c=a+4+d|0;d=a+4+e|0;e=b[c>>0]|0;b[c>>0]=b[d>>0]|0;b[d>>0]=e;return}function Omc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Zic(b,d);u=e;return}u_b(f,3,503182,287);r_b(e+24|0,p_b(f,503282)|0);v_b(f);Zic(b,d);u=e;return}function Pmc(a,c){a=a|0;c=c|0;return (b[c>>0]|0)!=0|0}function Qmc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Rmc(a){a=a|0;cYc(a);return}function Smc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Tmc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Umc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function Vmc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Wmc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;e=+ch[f[(f[a>>2]|0)+72>>2]&31](a,d);p[(f[b+8>>2]|0)+8+(c<<3)>>3]=e;return}function Xmc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0;d=+ch[f[(f[a>>2]|0)+72>>2]&31](a,c);c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){ZMa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;p[c+8+(e<<3)>>3]=d;return}function Ymc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Zmc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;e=+p[b>>3];p[b>>3]=+p[c>>3];p[c>>3]=e;return}function _mc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Yic(b,d);u=e;return}u_b(f,3,503182,287);r_b(e+24|0,p_b(f,503282)|0);v_b(f);Yic(b,d);u=e;return}function $mc(a,b){a=a|0;b=b|0;return +(+p[b>>3])}function anc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function bnc(a){a=a|0;cYc(a);return}function cnc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function dnc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function enc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function fnc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function gnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;e=+ch[f[(f[a>>2]|0)+72>>2]&31](a,d);n[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function hnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0;d=+ch[f[(f[a>>2]|0)+72>>2]&31](a,c);c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){uHa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;n[c+4+(e<<2)>>2]=d;return}function inc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function jnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function knc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Xic(b,d);u=e;return}u_b(f,3,503182,287);r_b(e+24|0,p_b(f,503282)|0);v_b(f);Xic(b,d);u=e;return}function lnc(a,b){a=a|0;b=b|0;return +(+n[b>>2])}function mnc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function nnc(a){a=a|0;cYc(a);return}function onc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function pnc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function qnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function rnc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function snc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;d=(f[b+8>>2]|0)+8+(c<<3)|0;f[d>>2]=e;f[d+4>>2]=J;return}function tnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=J;a=f[b>>2]|0;if((a|0)==(f[b+4>>2]|0)){mob(b,a+1|0);e=f[b>>2]|0}else e=a;a=f[b+8>>2]|0;f[b>>2]=e+1;b=a+8+(e<<3)|0;f[b>>2]=d;f[b+4>>2]=c;return}function unc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function vnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;d=b;a=f[d>>2]|0;e=f[d+4>>2]|0;d=c;g=f[d+4>>2]|0;h=b;f[h>>2]=f[d>>2];f[h+4>>2]=g;g=c;f[g>>2]=a;f[g+4>>2]=e;return}function wnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Wic(b,d);u=e;return}u_b(f,3,503182,287);r_b(e+24|0,p_b(f,503282)|0);v_b(f);Wic(b,d);u=e;return}function xnc(a,b){a=a|0;b=b|0;a=b;J=f[a+4>>2]|0;return f[a>>2]|0}function ync(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function znc(a){a=a|0;cYc(a);return}function Anc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Bnc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Cnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function Dnc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Enc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;d=(f[b+8>>2]|0)+8+(c<<3)|0;f[d>>2]=e;f[d+4>>2]=J;return}function Fnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=J;a=f[b>>2]|0;if((a|0)==(f[b+4>>2]|0)){_Ma(b,a+1|0);e=f[b>>2]|0}else e=a;a=f[b+8>>2]|0;f[b>>2]=e+1;b=a+8+(e<<3)|0;f[b>>2]=d;f[b+4>>2]=c;return}function Gnc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Hnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;d=b;a=f[d>>2]|0;e=f[d+4>>2]|0;d=c;g=f[d+4>>2]|0;h=b;f[h>>2]=f[d>>2];f[h+4>>2]=g;g=c;f[g>>2]=a;f[g+4>>2]=e;return}function Inc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Uic(b,d);u=e;return}u_b(f,3,503182,287);r_b(e+24|0,p_b(f,503282)|0);v_b(f);Uic(b,d);u=e;return}function Jnc(a,b){a=a|0;b=b|0;a=b;J=f[a+4>>2]|0;return f[a>>2]|0}function Knc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Lnc(a){a=a|0;cYc(a);return}function Mnc(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Nnc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Onc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function Pnc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function Qnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;f[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function Rnc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){xHa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;f[c+4+(e<<2)>>2]=d;return}function Snc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function Tnc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function Unc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Vic(b,d);u=e;return}u_b(f,3,503182,287);r_b(e+24|0,p_b(f,503282)|0);v_b(f);Vic(b,d);u=e;return}function Vnc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Wnc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function Xnc(a){a=a|0;cYc(a);return}function Ync(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function Znc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function _nc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function $nc(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function aoc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;f[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function boc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Mi[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){qHa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;f[c+4+(e<<2)>>2]=d;return}function coc(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function doc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function eoc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){Tic(b,d);u=e;return}u_b(f,3,503182,287);r_b(e+24|0,p_b(f,503282)|0);v_b(f);Tic(b,d);u=e;return}function foc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function goc(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function hoc(a){a=a|0;return}function ioc(){l_b(175);return}function joc(){var a=0;a=f[223576]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223576]=0;a=f[223578]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223578]=0;a=f[223580]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223580]=0;a=f[223582]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223582]=0;a=f[223584]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223584]=0;a=f[223586]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223586]=0;a=f[223588]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223588]=0;a=f[223590]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223590]=0;a=f[223594]|0;if(a|0)Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223594]=0;a=f[223592]|0;if(!a){f[223592]=0;return}Yi[f[(f[a>>2]|0)+4>>2]&4095](a);f[223592]=0;return}function koc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Roc(a,e,c);if((b[e+11>>0]|0)>=0){u=d;return}cYc(f[e>>2]|0);u=d;return}function loc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+64|0;d=c;Kjc(d,b,-1);if(MZb(a,d)|0)e=(f[b+(f[(f[b>>2]|0)+-12>>2]|0)+16>>2]&2|0)!=0;else e=0;f[d>>2]=171524;xZb(d+16|0);Hjc(d+4|0);u=c;return e|0}function moc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,1,-1,0)|0}function noc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,2,-1,0)|0}function ooc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,3,-1,0)|0}function poc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,4,-1,0)|0}function qoc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,6,-1,0)|0}function roc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,5,-1,0)|0}function soc(a,b,c){a=a|0;b=b|0;c=c|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,7,-1,0)|0}function toc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xg[f[(f[a>>2]|0)+324>>2]&127](a,b,c,9,0,0)|0}function uoc(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[223595]|0)==2){d=f[223596]|0;u=a;return d|0}f[c>>2]=165456;f[c+4>>2]=176;b[c+8>>0]=0;J_b(894380,c);a_b(c);d=f[223596]|0;u=a;return d|0}function voc(){var a=0,b=0;a=$Xc(48)|0;f[a>>2]=172628;b=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+20>>2]=1.0;w_b(a+24|0);b=a+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+44>>2]=1.0;f[223596]=a;l_b(177);return}function woc(){var a=0;a=f[223596]|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function xoc(a){a=a|0;var b=0,c=0;f[a>>2]=172628;b=f[a+36>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;cYc(b)}while((c|0)!=0)}c=a+28|0;b=f[c>>2]|0;f[c>>2]=0;if(b|0)cYc(b);x_b(a+24|0);b=f[a+12>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;cYc(b)}while((c|0)!=0)}c=a+4|0;a=f[c>>2]|0;f[c>>2]=0;if(!a)return;cYc(a);return}function yoc(a){a=a|0;var b=0,c=0;f[a>>2]=172628;b=f[a+36>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;cYc(b)}while((c|0)!=0)}c=a+28|0;b=f[c>>2]|0;f[c>>2]=0;if(b|0)cYc(b);x_b(a+24|0);b=f[a+12>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;cYc(b)}while((c|0)!=0)}c=a+4|0;b=f[c>>2]|0;f[c>>2]=0;if(!b){cYc(a);return}cYc(b);cYc(a);return}function zoc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+64|0;e=d+48|0;g=d+24|0;h=d+53|0;i=d;j=d+52|0;k=c;l=a+24|0;g_b(l);m=a+28|0;n=a+32|0;o=f[n>>2]|0;a:do if(o){p=o+-1|0;q=(p&o|0)==0;if(!q)if(k>>>0<o>>>0)r=k;else r=(k>>>0)%(o>>>0)|0;else r=p&k;s=f[(f[m>>2]|0)+(r<<2)>>2]|0;if((s|0)!=0?(t=f[s>>2]|0,(t|0)!=0):0){b:do if(q){s=t;while(1){v=f[s+4>>2]|0;w=(v|0)==(k|0);if(!(w|(v&p|0)==(r|0))){x=0;break a}if(w?(f[s+8>>2]|0)==(c|0):0){y=s;break b}s=f[s>>2]|0;if(!s){x=0;break a}}}else{s=t;while(1){w=f[s+4>>2]|0;if((w|0)==(k|0)){if((f[s+8>>2]|0)==(c|0)){y=s;break b}}else{if(w>>>0<o>>>0)z=w;else z=(w>>>0)%(o>>>0)|0;if((z|0)!=(r|0)){x=0;break a}}s=f[s>>2]|0;if(!s){x=0;break a}}}while(0);x=f[y+12>>2]|0}else x=0}else x=0;while(0);h_b(l);if(x|0){A=x;u=d;return A|0}x=c+8|0;y=f[(f[x>>2]|0)+8>>2]|0;if((y|0)!=(m3b()|0)){A=0;u=d;return A|0}y=f[f[x>>2]>>2]|0;if((b[y+11>>0]|0)<0)B=f[y>>2]|0;else B=y;f[e>>2]=B;B=Aoc(a+4|0,e)|0;if(B){e=f[B+12>>2]|0;if(e|0){g_b(l);B=f[n>>2]|0;c:do if(B){a=B+-1|0;y=(a&B|0)==0;if(!y)if(k>>>0<B>>>0)C=k;else C=(k>>>0)%(B>>>0)|0;else C=a&k;r=f[(f[m>>2]|0)+(C<<2)>>2]|0;if((r|0)!=0?(z=f[r>>2]|0,(z|0)!=0):0){d:do if(y){r=z;while(1){o=f[r+4>>2]|0;t=(o|0)==(k|0);if(!(t|(o&a|0)==(C|0))){D=48;break c}if(t?(f[r+8>>2]|0)==(c|0):0){E=r;break d}r=f[r>>2]|0;if(!r){D=48;break c}}}else{r=z;while(1){t=f[r+4>>2]|0;if((t|0)==(k|0)){if((f[r+8>>2]|0)==(c|0)){E=r;break d}}else{if(t>>>0<B>>>0)F=t;else F=(t>>>0)%(B>>>0)|0;if((F|0)!=(C|0)){D=48;break c}}r=f[r>>2]|0;if(!r){D=48;break c}}}while(0);z=f[E+12>>2]|0;if(z)G=z;else D=48}else D=48}else D=48;while(0);e:do if((D|0)==48){Yi[e&4095](f[f[x>>2]>>2]|0);E=f[n>>2]|0;f:do if(E|0){C=E+-1|0;F=(C&E|0)==0;if(!F)if(k>>>0<E>>>0)H=k;else H=(k>>>0)%(E>>>0)|0;else H=C&k;B=f[(f[m>>2]|0)+(H<<2)>>2]|0;if(B|0?(z=f[B>>2]|0,z|0):0){g:do if(F){B=z;while(1){a=f[B+4>>2]|0;y=(a|0)==(k|0);if(!(y|(a&C|0)==(H|0)))break f;if(y?(f[B+8>>2]|0)==(c|0):0){I=B;break g}B=f[B>>2]|0;if(!B)break f}}else{B=z;while(1){y=f[B+4>>2]|0;if((y|0)==(k|0)){if((f[B+8>>2]|0)==(c|0)){I=B;break g}}else{if(y>>>0<E>>>0)J=y;else J=(y>>>0)%(E>>>0)|0;if((J|0)!=(H|0))break f}B=f[B>>2]|0;if(!B)break f}}while(0);z=f[I+12>>2]|0;if(z|0){G=z;break e}}}while(0);u_b(i,2,502719,361);E=p_b(p_b(i,504727)|0,504776)|0;r_b(j,q_b(E,f[c+4>>2]|0)|0);v_b(i);G=0}while(0);h_b(l);A=G;u=d;return A|0}}u_b(g,2,502719,344);G=p_b(g,504666)|0;r_b(h,q_b(G,f[f[x>>2]>>2]|0)|0);v_b(g);A=0;u=d;return A|0}function Aoc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(GIc(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(GIc(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function Boc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[223595]|0)!=2){f[e>>2]=165456;f[e+4>>2]=176;b[e+8>>0]=0;J_b(894380,e);a_b(e)}h=(f[223596]|0)+4|0;f[e>>2]=a;f[e+4>>2]=c;if(Coc(h,e)|0){u=d;return}u_b(g,3,502719,309);r_b(d+36|0,p_b(p_b(g,504847)|0,a)|0);v_b(g);u=d;return}function Coc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(GIc(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(GIc(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=$Xc(16)|0;r=c;c=f[r+4>>2]|0;l=d+8|0;f[l>>2]=f[r>>2];f[l+4>>2]=c;f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){l=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;r=~~+X(+(t/u))>>>0;Doc(a,l>>>0<r>>>0?r:l);l=f[i>>2]|0;r=l+-1|0;if(!(r&l)){v=l;w=r&g;break}if(g>>>0<l>>>0){v=l;w=g}else{v=l;w=(g>>>0)%(l>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function Doc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){Eoc(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;Eoc(a,d);return}function Eoc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){b:do if(h){e=k;c=l;i=m;while(1){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(GIc(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[e>>2]|0;if(!o){v=37;break a}else d=o}c=f[d>>2]|0;if(!c){v=37;break a}else{e=d;i=d}}}else{i=k;e=l;c=m;while(1){o=e;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=c;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(GIc(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[c>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=37;break a}else o=w}e=f[o>>2]|0;if(!e){v=37;break a}else{i=o;c=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=37;break}else{j=s;k=p;m=p}}if((v|0)==37)return}function Foc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[223595]|0)!=2){f[e>>2]=165456;f[e+4>>2]=176;b[e+8>>0]=0;J_b(894380,e);a_b(e)}h=(f[223596]|0)+28|0;f[e>>2]=a;f[e+4>>2]=c;if(Goc(h,e)|0){u=d;return}u_b(g,2,502719,324);e=p_b(g,504876)|0;r_b(d+36|0,q_b(e,f[a+4>>2]|0)|0);v_b(g);u=d;return}function Goc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0;c=f[b>>2]|0;d=a+4|0;e=f[d>>2]|0;g=(e|0)==0;h=c;a:do if(!g){i=e+-1|0;j=(i&e|0)==0;if(!j)if(c>>>0<e>>>0)k=c;else k=(c>>>0)%(e>>>0)|0;else k=i&c;l=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!l)m=k;else{if(j){j=l;while(1){j=f[j>>2]|0;if(!j){m=k;break a}o=f[j+4>>2]|0;if(!((o|0)==(c|0)|(o&i|0)==(k|0))){m=k;break a}if((f[j+8>>2]|0)==(h|0)){p=0;break}}return p|0}else q=l;while(1){q=f[q>>2]|0;if(!q){m=k;break a}j=f[q+4>>2]|0;if((j|0)!=(c|0)){if(j>>>0<e>>>0)r=j;else r=(j>>>0)%(e>>>0)|0;if((r|0)!=(k|0)){m=k;break a}}if((f[q+8>>2]|0)==(h|0)){p=0;break}}return p|0}}else m=0;while(0);h=$Xc(16)|0;q=b;b=f[q+4>>2]|0;k=h+8|0;f[k>>2]=f[q>>2];f[k+4>>2]=b;f[h+4>>2]=c;f[h>>2]=0;b=a+12|0;s=+(((f[b>>2]|0)+1|0)>>>0);t=+n[a+16>>2];do if(g|s>+(e>>>0)*t){k=(e>>>0<3|(e+-1&e|0)!=0)&1|e<<1;q=~~+X(+(s/t))>>>0;Hoc(a,k>>>0<q>>>0?q:k);k=f[d>>2]|0;q=k+-1|0;if(!(q&k)){u=k;v=q&c;break}if(c>>>0<k>>>0){u=k;v=c}else{u=k;v=(c>>>0)%(k>>>0)|0}}else{u=e;v=m}while(0);m=(f[a>>2]|0)+(v<<2)|0;v=f[m>>2]|0;if(!v){e=a+8|0;f[h>>2]=f[e>>2];f[e>>2]=h;f[m>>2]=e;e=f[h>>2]|0;if(e|0){m=f[e+4>>2]|0;e=u+-1|0;if(e&u)if(m>>>0<u>>>0)w=m;else w=(m>>>0)%(u>>>0)|0;else w=m&e;x=(f[a>>2]|0)+(w<<2)|0;y=30}}else{f[h>>2]=f[v>>2];x=v;y=30}if((y|0)==30)f[x>>2]=h;f[b>>2]=(f[b>>2]|0)+1;p=1;return p|0}function Hoc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){Ioc(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;Ioc(a,d);return}function Ioc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){b:do if(h){e=k;c=l;i=m;while(1){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if((f[o>>2]|0)==(f[u+8>>2]|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[e>>2]|0;if(!o){v=37;break a}else d=o}c=f[d>>2]|0;if(!c){v=37;break a}else{e=d;i=d}}}else{i=k;e=l;c=m;while(1){o=e;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=c;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if((f[w>>2]|0)==(f[z+8>>2]|0))y=z;else break}f[c>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=37;break a}else o=w}e=f[o>>2]|0;if(!e){v=37;break a}else{i=o;c=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=37;break}else{j=s;k=p;m=p}}if((v|0)==37)return}function Joc(a,b){a=a|0;b=b|0;return Mi[f[(f[a>>2]|0)+16>>2]&1023](a,b)|0}function Koc(a){a=a|0;return _i[f[(f[a>>2]|0)+20>>2]&2047](a)|0}function Loc(a){a=a|0;return _i[f[(f[a>>2]|0)+24>>2]&2047](a)|0}function Moc(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;Noc(b);Ooc(a,b);return}function Noc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=u;u=u+16|0;c=b;mi[f[(f[a>>2]|0)+96>>2]&2047](c,a);d=f[c+4>>2]|0;f[c>>2]=0;e=c+4|0;f[e>>2]=0;f[c+8>>2]=0;Ti[f[(f[d>>2]|0)+64>>2]&511](d,a,c);g=f[c>>2]|0;if((f[e>>2]|0)!=(g|0)){h=0;i=g;do{Ti[f[(f[d>>2]|0)+28>>2]&511](d,a,f[i+(h<<2)>>2]|0);h=h+1|0;i=f[c>>2]|0}while(h>>>0<(f[e>>2]|0)-i>>2>>>0)}i=Mi[f[(f[d>>2]|0)+12>>2]&1023](d,a)|0;if(f[i>>2]|0)sqc(i);i=f[c>>2]|0;if(!i){u=b;return}c=f[e>>2]|0;if((c|0)!=(i|0))f[e>>2]=c+(~((c+-4-i|0)>>>2)<<2);cYc(i);u=b;return}function Ooc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0;d=u;u=u+96|0;e=d+64|0;g=d+40|0;h=d+16|0;i=d;if((a|0)==(c|0)){u_b(g,3,504905,56);r_b(d+81|0,p_b(g,505001)|0);v_b(g)}mi[f[(f[a>>2]|0)+96>>2]&2047](e,a);g=f[e>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);if((f[e>>2]|0)!=(g|0)){u_b(h,3,504905,59);j=p_b(p_b(p_b(h,505033)|0,505087)|0,505131)|0;k=p_b(q_b(j,f[g+4>>2]|0)|0,505139)|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);r_b(d+80|0,p_b(q_b(k,f[(f[e>>2]|0)+4>>2]|0)|0,528047)|0);v_b(h)}mi[f[(f[a>>2]|0)+96>>2]&2047](e,a);h=f[e+4>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);k=f[e+4>>2]|0;f[i>>2]=0;g=i+4|0;f[g>>2]=0;f[i+8>>2]=0;Ti[f[(f[h>>2]|0)+64>>2]&511](h,a,i);j=f[i>>2]|0;if((f[g>>2]|0)!=(j|0)){l=e+11|0;m=e+4|0;n=e+8|0;o=e+12|0;p=e+11|0;q=e+4|0;r=e+8|0;s=e+12|0;t=0;v=j;do{j=f[v+(t<<2)>>2]|0;a:do if((f[j+32>>2]|0)==3){w=hj[f[(f[h>>2]|0)+24>>2]&511](h,a,j)|0;if((w|0)>0){x=j+24|0;y=j+28|0;z=0;while(1){A=f[x>>2]|0;if(A|0?(f[A>>2]|0)!=2:0){f[e>>2]=80424;f[m>>2]=2231;b[n>>0]=0;f[o>>2]=j;J_b(A,e)}do switch(f[165644+(f[y>>2]<<2)>>2]|0){case 1:{A=f[(f[k>>2]|0)+260>>2]|0;B=hh[f[(f[h>>2]|0)+168>>2]&127](h,a,j,z)|0;ei[A&511](k,c,j,B);break}case 2:{B=f[(f[k>>2]|0)+264>>2]|0;A=hh[f[(f[h>>2]|0)+172>>2]&127](h,a,j,z)|0;gi[B&255](k,c,j,A,J);break}case 3:{A=f[(f[k>>2]|0)+268>>2]|0;B=hh[f[(f[h>>2]|0)+176>>2]&127](h,a,j,z)|0;ei[A&511](k,c,j,B);break}case 4:{B=f[(f[k>>2]|0)+272>>2]|0;A=hh[f[(f[h>>2]|0)+180>>2]&127](h,a,j,z)|0;gi[B&255](k,c,j,A,J);break}case 6:{A=f[(f[k>>2]|0)+276>>2]|0;C=+Ai[f[(f[h>>2]|0)+184>>2]&15](h,a,j,z);$h[A&63](k,c,j,C);break}case 5:{A=f[(f[k>>2]|0)+280>>2]|0;C=+Ai[f[(f[h>>2]|0)+188>>2]&15](h,a,j,z);$h[A&63](k,c,j,C);break}case 7:{A=f[(f[k>>2]|0)+284>>2]|0;B=hh[f[(f[h>>2]|0)+192>>2]&127](h,a,j,z)|0;ei[A&511](k,c,j,B);break}case 9:{B=f[(f[k>>2]|0)+288>>2]|0;gi[f[(f[h>>2]|0)+196>>2]&255](e,h,a,j,z);ei[B&511](k,c,j,e);if((b[l>>0]|0)<0)cYc(f[e>>2]|0);break}case 8:{B=f[(f[k>>2]|0)+292>>2]|0;A=hh[f[(f[h>>2]|0)+200>>2]&127](h,a,j,z)|0;ei[B&511](k,c,j,A);break}case 10:{A=hh[f[(f[k>>2]|0)+300>>2]&127](k,c,j,0)|0;B=f[(f[A>>2]|0)+76>>2]|0;D=hh[f[(f[h>>2]|0)+208>>2]&127](h,a,j,z)|0;mi[B&2047](A,D);break}default:{}}while(0);z=z+1|0;if((z|0)>=(w|0))break a}}}else{w=f[j+24>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[e>>2]=80424;f[q>>2]=2231;b[r>>0]=0;f[s>>2]=j;J_b(w,e)}do switch(f[165644+(f[j+28>>2]<<2)>>2]|0){case 1:{w=f[(f[k>>2]|0)+116>>2]|0;z=hj[f[(f[h>>2]|0)+68>>2]&511](h,a,j)|0;ei[w&511](k,c,j,z);break a;break}case 2:{z=f[(f[k>>2]|0)+120>>2]|0;w=hj[f[(f[h>>2]|0)+72>>2]&511](h,a,j)|0;gi[z&255](k,c,j,w,J);break a;break}case 3:{w=f[(f[k>>2]|0)+124>>2]|0;z=hj[f[(f[h>>2]|0)+76>>2]&511](h,a,j)|0;ei[w&511](k,c,j,z);break a;break}case 4:{z=f[(f[k>>2]|0)+128>>2]|0;w=hj[f[(f[h>>2]|0)+80>>2]&511](h,a,j)|0;gi[z&255](k,c,j,w,J);break a;break}case 6:{w=f[(f[k>>2]|0)+132>>2]|0;C=+Sh[f[(f[h>>2]|0)+84>>2]&31](h,a,j);$h[w&63](k,c,j,C);break a;break}case 5:{w=f[(f[k>>2]|0)+136>>2]|0;C=+Sh[f[(f[h>>2]|0)+88>>2]&31](h,a,j);$h[w&63](k,c,j,C);break a;break}case 7:{w=f[(f[k>>2]|0)+140>>2]|0;z=hj[f[(f[h>>2]|0)+92>>2]&511](h,a,j)|0;ei[w&511](k,c,j,z);break a;break}case 9:{z=f[(f[k>>2]|0)+144>>2]|0;ei[f[(f[h>>2]|0)+96>>2]&511](e,h,a,j);ei[z&511](k,c,j,e);if((b[p>>0]|0)<0)cYc(f[e>>2]|0);break a;break}case 8:{z=f[(f[k>>2]|0)+148>>2]|0;w=hj[f[(f[h>>2]|0)+100>>2]&511](h,a,j)|0;ei[z&511](k,c,j,w);break a;break}case 10:{w=hh[f[(f[k>>2]|0)+156>>2]&127](k,c,j,0)|0;z=f[(f[w>>2]|0)+76>>2]|0;y=hh[f[(f[h>>2]|0)+108>>2]&127](h,a,j,0)|0;mi[z&2047](w,y);break a;break}default:break a}while(0)}while(0);t=t+1|0;v=f[i>>2]|0}while(t>>>0<(f[g>>2]|0)-v>>2>>>0)}v=Mi[f[(f[k>>2]|0)+12>>2]&1023](k,c)|0;vqc(v,Mi[f[(f[h>>2]|0)+8>>2]&1023](h,a)|0);a=f[i>>2]|0;if(!a){u=d;return}i=f[g>>2]|0;if((i|0)!=(a|0))f[g>>2]=i+(~((i+-4-a|0)>>>2)<<2);cYc(a);u=d;return}function Poc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=u;u=u+80|0;d=c+32|0;e=c+64|0;g=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);h=f[d>>2]|0;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);i=f[d+4>>2]|0;j=h+52|0;k=f[j>>2]|0;a:do if((k|0)>0){l=h+20|0;m=0;n=k;while(1){o=f[l>>2]|0;if((f[o+(m*88|0)+32>>2]|0)==2){if(!(hj[f[(f[i>>2]|0)+20>>2]&511](i,a,o+(m*88|0)|0)|0)){p=0;break}q=f[j>>2]|0}else q=n;m=m+1|0;if((m|0)>=(q|0))break a;else n=q}u=c;return p|0}while(0);f[e>>2]=0;q=e+4|0;f[q>>2]=0;f[e+8>>2]=0;Ti[f[(f[i>>2]|0)+64>>2]&511](i,a,e);j=f[e>>2]|0;k=j;if((f[q>>2]|0)==(j|0)){r=5;s=k}else{j=d+4|0;h=d+24|0;n=g+4|0;m=g+16|0;l=g+8|0;o=d+16|0;t=d+8|0;v=d+4|0;w=d+8|0;x=d+12|0;y=d+4|0;z=d+8|0;A=d+12|0;B=d+4|0;C=d+8|0;D=d+12|0;E=0;F=k;b:while(1){k=f[F+(E<<2)>>2]|0;G=k+24|0;H=f[G>>2]|0;if(H|0?(f[H>>2]|0)!=2:0){f[d>>2]=80424;f[B>>2]=2231;b[C>>0]=0;f[D>>2]=k;J_b(H,d)}H=k+28|0;do if((f[165644+(f[H>>2]<<2)>>2]|0)==10){I=f[G>>2]|0;if(I|0?(f[I>>2]|0)!=2:0){f[d>>2]=80424;f[y>>2]=2231;b[z>>0]=0;f[A>>2]=k;J_b(I,d)}if((f[H>>2]|0)==11?D3b(k)|0:0){I=(F3b(k)|0)+20|0;J=f[I>>2]|0;I=J+88|0;K=f[J+112>>2]|0;if(K|0?(f[K>>2]|0)!=2:0){f[d>>2]=80424;f[v>>2]=2231;b[w>>0]=0;f[x>>2]=I;J_b(K,d)}if((f[165644+(f[J+116>>2]<<2)>>2]|0)!=10)break;J=hj[f[(f[i>>2]|0)+364>>2]&511](i,a,k)|0;if(clc(J)|0){uic(d,a,k);uic(g,a,k);mi[f[(f[J>>2]|0)+24>>2]&2047](J,d);mi[f[(f[J>>2]|0)+28>>2]&2047](J,g);while(1){J=f[j>>2]|0;if(hj[f[(f[J>>2]|0)+20>>2]&511](J,d,g)|0){L=7;break}J=Xkc(h)|0;if(!(_i[f[(f[J>>2]|0)+32>>2]&2047](J)|0)){L=1;break}J=f[j>>2]|0;mi[f[(f[J>>2]|0)+60>>2]&2047](J,d)}J=f[n>>2]|0;mi[f[(f[J>>2]|0)+52>>2]&2047](J,g);if((f[m>>2]|0)==9?(J=f[l>>2]|0,J|0):0){if((b[J+11>>0]|0)<0)cYc(f[J>>2]|0);cYc(J)}J=f[j>>2]|0;mi[f[(f[J>>2]|0)+52>>2]&2047](J,d);if((f[o>>2]|0)==9?(J=f[t>>2]|0,J|0):0){if((b[J+11>>0]|0)<0)cYc(f[J>>2]|0);cYc(J)}if((L|0)==7)break;else{M=L;break b}}}if((f[k+32>>2]|0)!=3){J=hh[f[(f[i>>2]|0)+108>>2]&127](i,a,k,0)|0;if(_i[f[(f[J>>2]|0)+32>>2]&2047](J)|0)break;else{M=1;break b}}J=hj[f[(f[i>>2]|0)+24>>2]&511](i,a,k)|0;if((J|0)>0){K=0;do{I=hh[f[(f[i>>2]|0)+208>>2]&127](i,a,k,K)|0;K=K+1|0;if(!(_i[f[(f[I>>2]|0)+32>>2]&2047](I)|0)){M=1;break b}}while((K|0)<(J|0))}}while(0);E=E+1|0;F=f[e>>2]|0;if(E>>>0>=(f[q>>2]|0)-F>>2>>>0){M=5;break}}r=M;s=f[e>>2]|0}e=(r|0)==5;if(s|0){r=f[q>>2]|0;if((r|0)!=(s|0))f[q>>2]=r+(~((r+-4-s|0)>>>2)<<2);cYc(s)}p=e;u=c;return p|0}function Qoc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+32|0;d=c+16|0;e=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d+4>>2]|0;h=Mi[f[(f[g>>2]|0)+12>>2]&1023](g,a)|0;if(f[h>>2]|0)sqc(h);f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;Ti[f[(f[g>>2]|0)+64>>2]&511](g,a,e);i=f[h>>2]|0;j=f[e>>2]|0;k=j;if((i|0)==(j|0)){l=i;m=k}else{i=d+4|0;j=d+8|0;n=d+12|0;o=0;p=k;while(1){k=f[p+(o<<2)>>2]|0;q=f[k+24>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[d>>2]=80424;f[i>>2]=2231;b[j>>0]=0;f[n>>2]=k;J_b(q,d)}do if((f[165644+(f[k+28>>2]<<2)>>2]|0)==10){if((f[k+32>>2]|0)!=3){q=hh[f[(f[g>>2]|0)+156>>2]&127](g,a,k,0)|0;Yi[f[(f[q>>2]|0)+80>>2]&4095](q);break}q=hj[f[(f[g>>2]|0)+24>>2]&511](g,a,k)|0;if((q|0)>0){r=0;do{s=hh[f[(f[g>>2]|0)+256>>2]&127](g,a,k,r)|0;Yi[f[(f[s>>2]|0)+80>>2]&4095](s);r=r+1|0}while((r|0)<(q|0))}}while(0);o=o+1|0;k=f[h>>2]|0;q=f[e>>2]|0;r=q;if(o>>>0>=k-q>>2>>>0){l=k;m=r;break}else p=r}}p=l;if(!m){u=c;return}if((p|0)!=(m|0))f[h>>2]=p+(~((p+-4-m|0)>>>2)<<2);cYc(m);u=c;return}function Roc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e+16|0;h=e;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);i=f[g>>2]|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);j=f[g+4>>2]|0;k=i+52|0;if((f[k>>2]|0)>0){l=i+20|0;i=d+4|0;m=d+8|0;n=g+11|0;o=0;do{p=f[l>>2]|0;if((f[p+(o*88|0)+32>>2]|0)==2?!(hj[f[(f[j>>2]|0)+20>>2]&511](j,a,p+(o*88|0)|0)|0):0){nBb(g,c,f[(f[l>>2]|0)+(o*88|0)>>2]|0);p=f[i>>2]|0;if(p>>>0>=(f[m>>2]|0)>>>0){QA(d,g);if((b[n>>0]|0)<0)cYc(f[g>>2]|0)}else{f[p>>2]=f[g>>2];f[p+4>>2]=f[g+4>>2];f[p+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[i>>2]=(f[i>>2]|0)+12}}o=o+1|0}while((o|0)<(f[k>>2]|0))}f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;Ti[f[(f[j>>2]|0)+64>>2]&511](j,a,h);o=f[k>>2]|0;i=f[h>>2]|0;n=i;if((o|0)==(i|0)){q=o;r=n}else{o=g+11|0;i=g+11|0;m=g+4|0;l=g+8|0;p=g+12|0;s=0;t=n;while(1){n=f[t+(s<<2)>>2]|0;v=f[n+24>>2]|0;if(v|0?(f[v>>2]|0)!=2:0){f[g>>2]=80424;f[m>>2]=2231;b[l>>0]=0;f[p>>2]=n;J_b(v,g)}do if((f[165644+(f[n+28>>2]<<2)>>2]|0)==10){if((f[n+32>>2]|0)!=3){v=hh[f[(f[j>>2]|0)+108>>2]&127](j,a,n,0)|0;Soc(g,c,n,-1);Roc(v,g,d);if((b[i>>0]|0)<0)cYc(f[g>>2]|0);break}v=hj[f[(f[j>>2]|0)+24>>2]&511](j,a,n)|0;if((v|0)>0){w=0;do{x=hh[f[(f[j>>2]|0)+208>>2]&127](j,a,n,w)|0;Soc(g,c,n,w);Roc(x,g,d);if((b[o>>0]|0)<0)cYc(f[g>>2]|0);w=w+1|0}while((w|0)<(v|0))}}while(0);s=s+1|0;n=f[k>>2]|0;v=f[h>>2]|0;w=v;if(s>>>0>=n-v>>2>>>0){q=n;r=w;break}else t=w}}t=q;if(!r){u=e;return}if((t|0)!=(r|0))f[k>>2]=t+(~((t+-4-r|0)>>>2)<<2);cYc(r);u=e;return}function Soc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;lYc(a,c);if(!(b[d+38>>0]|0)){c=f[d>>2]|0;i=b[c+11>>0]|0;j=i<<24>>24<0;zYc(a,j?f[c>>2]|0:c,j?f[c+4>>2]|0:i&255)|0}else{AYc(a,528049)|0;i=f[d+4>>2]|0;d=b[i+11>>0]|0;c=d<<24>>24<0;zYc(a,c?f[i>>2]|0:i,c?f[i+4>>2]|0:d&255)|0;AYc(a,528047)|0}if((e|0)==-1){AYc(a,528338)|0;u=g;return}AYc(a,505467)|0;mtc(h,e);e=h+11|0;d=b[e>>0]|0;i=d<<24>>24<0;zYc(a,i?f[h>>2]|0:h,i?f[h+4>>2]|0:d&255)|0;if((b[e>>0]|0)<0)cYc(f[h>>2]|0);AYc(a,528096)|0;AYc(a,528338)|0;u=g;return}function Toc(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;Uoc(a,b,c,d,e,g,h,i,j,k,l,m);return}function Uoc(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;o=u;u=u+128|0;p=o+76|0;q=o+40|0;r=o+64|0;s=o+24|0;t=o+121|0;v=o;w=o+120|0;f[p>>2]=d;f[p+4>>2]=e;f[p+8>>2]=g;f[p+12>>2]=h;f[p+16>>2]=i;f[p+20>>2]=j;f[p+24>>2]=k;f[p+28>>2]=l;f[p+32>>2]=m;f[p+36>>2]=n;f[p+40>>2]=0;n=0;m=0;a:while(1){b:do switch(b[c+m>>0]|0){case 0:{x=32;break a;break}case 36:{l=m+1|0;k=b[c+l>>0]|0;if((k+-48&255)<10){y=(k<<24>>24)+-48|0;j=f[(f[p+(y<<2)>>2]|0)+4>>2]|0;if((j|0)==-1){x=5;break a}else{z=l;A=j;break b}}else if(k<<24>>24==36){z=l;A=1;break b}else{x=20;break a}break}default:{z=m;A=1}}while(0);n=A+n|0;m=z+1|0}if((x|0)==5){u_b(q,2,505144,84);z=p_b(s_b(p_b(q,505242)|0,y)|0,505298)|0;y=0;m=d;while(1){if((f[m+4>>2]|0)==-1){B=y;break}d=y+1|0;m=f[p+(d<<2)>>2]|0;if(!m){B=d;break}else y=d}y=p_b(s_b(z,B)|0,505311)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;B=dJc(c)|0;if(B>>>0>4294967279)jYc(s);if(B>>>0<11){b[s+11>>0]=B;if(!B)C=s;else{D=s;x=13}}else{z=B+16&-16;m=$Xc(z)|0;f[s>>2]=m;f[s+8>>2]=z|-2147483648;f[s+4>>2]=B;D=m;x=13}if((x|0)==13){o1c(D|0,c|0,B|0)|0;C=D}b[C+B>>0]=0;gtc(r,s);r_b(t,p_b(q_b(y,r)|0,506102)|0);if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);v_b(q);u=o;return}else if((x|0)==20){u_b(v,2,505144,97);q=p_b(v,505356)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;y=dJc(c)|0;if(y>>>0>4294967279)jYc(s);if(y>>>0<11){b[s+11>>0]=y;if(!y)E=s;else{F=s;x=25}}else{t=y+16&-16;B=$Xc(t)|0;f[s>>2]=B;f[s+8>>2]=t|-2147483648;f[s+4>>2]=y;F=B;x=25}if((x|0)==25){o1c(F|0,c|0,y|0)|0;E=F}b[E+y>>0]=0;gtc(r,s);r_b(w,p_b(q_b(q,r)|0,506102)|0);if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);v_b(v);u=o;return}else if((x|0)==32){if(!n){u=o;return}x=a+11|0;v=b[x>>0]|0;if(v<<24>>24<0)G=f[a+4>>2]|0;else G=v&255;uYc(a,G+n|0,0);n=b[x>>0]|0;x=n<<24>>24<0;if(x)H=f[a+4>>2]|0;else H=n&255;do if(H)if(x){I=f[a>>2]|0;break}else{I=a;break}else I=0;while(0);a=0;x=I+G|0;c:while(1){G=b[c+a>>0]|0;d:do switch(G<<24>>24){case 0:{break c;break}case 36:{I=a+1|0;H=b[c+I>>0]|0;if((H+-48&255)<10){n=f[p+((H<<24>>24)+-48<<2)>>2]|0;v=n+4|0;o1c(x|0,f[n>>2]|0,f[v>>2]|0)|0;J=I;K=x+(f[v>>2]|0)|0;break d}if(H<<24>>24==36){b[x>>0]=36;J=I;K=x+1|0}else{J=a;K=x}break}default:{b[x>>0]=G;J=a;K=x+1|0}}while(0);a=J+1|0;x=K}u=o;return}}function Voc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;d=u;u=u+16|0;c=d;if(!(b[e+38>>0]|0)){a=f[e+24>>2]|0;if(a|0?(f[a>>2]|0)!=2:0){f[c>>2]=80424;f[c+4>>2]=2231;b[c+8>>0]=0;f[c+12>>2]=e;J_b(a,c)}if((f[e+28>>2]|0)==10){a=F3b(e)|0;h=f[a>>2]|0;a=b[h+11>>0]|0;i=a<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,i?f[h>>2]|0:h,i?f[h+4>>2]|0:a&255);u=d;return}else{a=f[e>>2]|0;h=b[a+11>>0]|0;i=h<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,i?f[a>>2]|0:a,i?f[a+4>>2]|0:h&255);u=d;return}}Ti[f[(f[g>>2]|0)+8>>2]&511](g,505467,1);if(b[(f[(f[e+48>>2]|0)+16>>2]|0)+48>>0]|0){h=f[e+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[c>>2]=80424;f[c+4>>2]=2231;b[c+8>>0]=0;f[c+12>>2]=e;J_b(h,c)}if(((f[e+28>>2]|0)==11?(f[e+32>>2]|0)==1:0)?(c=f[e+56>>2]|0,(c|0)==(F3b(e)|0)):0){c=(F3b(e)|0)+4|0;h=f[c>>2]|0;c=b[h+11>>0]|0;a=c<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,a?f[h>>2]|0:h,a?f[h+4>>2]|0:c&255)}else j=10}else j=10;if((j|0)==10){j=f[e+4>>2]|0;e=b[j+11>>0]|0;c=e<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,c?f[j>>2]|0:j,c?f[j+4>>2]|0:e&255)}Ti[f[(f[g>>2]|0)+8>>2]&511](g,528096,1);u=d;return}function Woc(a){a=a|0;return}function Xoc(a){a=a|0;cYc(a);return}function Yoc(a,b,c){a=a|0;b=b|0;c=c|0;a=f[(f[c>>2]|0)+8>>2]|0;if(b){Ti[a&511](c,529255,4);return}else{Ti[a&511](c,529249,5);return}}function Zoc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=u;u=u+16|0;e=a;mtc(e,c);c=e+11|0;g=b[c>>0]|0;h=g<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,h?f[e>>2]|0:e,h?f[e+4>>2]|0:g&255);if((b[c>>0]|0)>=0){u=a;return}cYc(f[e>>2]|0);u=a;return}function _oc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=u;u=u+16|0;e=a;ntc(e,c);c=e+11|0;g=b[c>>0]|0;h=g<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,h?f[e>>2]|0:e,h?f[e+4>>2]|0:g&255);if((b[c>>0]|0)>=0){u=a;return}cYc(f[e>>2]|0);u=a;return}function $oc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;a=u;u=u+16|0;g=a;otc(g,c,d);d=g+11|0;c=b[d>>0]|0;h=c<<24>>24<0;Ti[f[(f[e>>2]|0)+8>>2]&511](e,h?f[g>>2]|0:g,h?f[g+4>>2]|0:c&255);if((b[d>>0]|0)>=0){u=a;return}cYc(f[g>>2]|0);u=a;return}function apc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;a=u;u=u+16|0;g=a;ptc(g,c,d);d=g+11|0;c=b[d>>0]|0;h=c<<24>>24<0;Ti[f[(f[e>>2]|0)+8>>2]&511](e,h?f[g>>2]|0:g,h?f[g+4>>2]|0:c&255);if((b[d>>0]|0)>=0){u=a;return}cYc(f[g>>2]|0);u=a;return}function bpc(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0;a=u;u=u+16|0;e=a;stc(e,c);g=e+11|0;h=b[g>>0]|0;i=h<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,i?f[e>>2]|0:e,i?f[e+4>>2]|0:h&255);if((b[g>>0]|0)>=0){u=a;return}cYc(f[e>>2]|0);u=a;return}function cpc(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0;a=u;u=u+16|0;e=a;qtc(e,c);g=e+11|0;h=b[g>>0]|0;i=h<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,i?f[e>>2]|0:e,i?f[e+4>>2]|0:h&255);if((b[g>>0]|0)>=0){u=a;return}cYc(f[e>>2]|0);u=a;return}function dpc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+16|0;e=a;Ti[f[(f[d>>2]|0)+8>>2]&511](d,505469,1);gtc(e,c);c=e+11|0;g=b[c>>0]|0;h=g<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,h?f[e>>2]|0:e,h?f[e+4>>2]|0:g&255);if((b[c>>0]|0)>=0){i=f[d>>2]|0;j=i+8|0;k=f[j>>2]|0;Ti[k&511](d,505469,1);u=a;return}cYc(f[e>>2]|0);i=f[d>>2]|0;j=i+8|0;k=f[j>>2]|0;Ti[k&511](d,505469,1);u=a;return}function epc(a,b,c){a=a|0;b=b|0;c=c|0;Ti[f[(f[a>>2]|0)+36>>2]&511](a,b,c);return}function fpc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;c=b[d+11>>0]|0;a=c<<24>>24<0;Ti[f[(f[e>>2]|0)+8>>2]&511](e,a?f[d>>2]|0:d,a?f[d+4>>2]|0:c&255);return}function gpc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;d=f[(f[g>>2]|0)+8>>2]|0;if(e){Ti[d&511](g,505459,3);return}else{Ti[d&511](g,505463,3);return}}function hpc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;d=f[(f[g>>2]|0)+8>>2]|0;if(e){Ti[d&511](g,505403,2);return}else{Ti[d&511](g,505406,2);return}}function ipc(a){a=a|0;return}function jpc(a,b){a=a|0;b=b|0;if(!b)return;else{jpc(a,f[b>>2]|0);jpc(a,f[b+4>>2]|0);cYc(b);return}}function kpc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);h=f[g>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);i=f[g+4>>2]|0;j=f[h+4>>2]|0;h=dJc(511565)|0;k=b[j+11>>0]|0;if((((h|0)==((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)?(LYc(j,0,-1,511565,h)|0)==0:0)?b[a+9>>0]|0:0)?lpc(a,c,d)|0:0){u=e;return}f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;Ti[f[(f[i>>2]|0)+64>>2]&511](i,c,g);if(b[a+8>>0]|0)mpc(f[g>>2]|0,f[h>>2]|0);j=f[g>>2]|0;k=j;if((f[h>>2]|0)==(j|0))l=k;else{j=0;m=k;while(1){npc(a,c,i,f[m+(j<<2)>>2]|0,d);j=j+1|0;k=f[g>>2]|0;n=k;if(j>>>0>=(f[h>>2]|0)-k>>2>>>0){l=n;break}else m=n}}if(!(b[a+7>>0]|0)){opc(a,Mi[f[(f[i>>2]|0)+8>>2]&1023](i,c)|0,d);o=f[g>>2]|0}else o=l;if(o|0){l=f[h>>2]|0;if((l|0)!=(o|0))f[h>>2]=l+(~((l+-4-o|0)>>>2)<<2);cYc(o)}u=e;return}function lpc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+144|0;g=e+112|0;h=e+138|0;i=e+108|0;j=e+104|0;k=e+68|0;l=e+56|0;m=e+80|0;n=e+137|0;o=e+36|0;p=e+24|0;q=e;r=e+136|0;if(!(ztc(c,i,j)|0)){s=0;u=e;return s|0}mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);t=f[g+4>>2]|0;ei[f[(f[t>>2]|0)+96>>2]&511](k,t,c,f[i>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;do if(ytc(k,l)|0){mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);i=o3b(f[(f[(f[g>>2]|0)+8>>2]|0)+8>>2]|0,l)|0;if(!i){u_b(m,1,505570,1820);r_b(n,p_b(q_b(p_b(m,505835)|0,k)|0,505847)|0);v_b(m);v=0;break}rgc(o);w=pgc(o,i)|0;i=_i[f[(f[w>>2]|0)+12>>2]&2047](w)|0;ei[f[(f[t>>2]|0)+96>>2]&511](p,t,c,f[j>>2]|0);if(NZb(i,p)|0){Ti[f[(f[d>>2]|0)+8>>2]&511](d,505467,1);w=b[k+11>>0]|0;x=w<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,x?f[k>>2]|0:k,x?f[k+4>>2]|0:w&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,528096,1);w=f[a+24>>2]|0;x=a+32|0;y=f[x>>2]|0;if(y){z=f[j>>2]|0;A=x;B=y;a:while(1){y=B;while(1){if((f[y+16>>2]|0)>>>0>=z>>>0)break;C=f[y+4>>2]|0;if(!C){D=A;break a}else y=C}B=f[y>>2]|0;if(!B){D=y;break}else A=y}if((D|0)!=(x|0)?z>>>0>=(f[D+16>>2]|0)>>>0:0)E=f[D+20>>2]|0;else E=w}else E=w;A=a+4|0;Fh[f[(f[E>>2]|0)+52>>2]&255](E,c,-1,0,(b[A>>0]|0)!=0,d);B=d+20|0;f[B>>2]=(f[B>>2]|0)+1;kpc(a,i,d);C=f[B>>2]|0;if((C|0)!=0?(C|0)>=(f[d+24>>2]|0):0)f[B>>2]=C+-1;else{u_b(g,2,505570,1200);r_b(h,p_b(g,505663)|0);v_b(g)}Fh[f[(f[E>>2]|0)+56>>2]&255](E,c,-1,0,(b[A>>0]|0)!=0,d);F=1}else{u_b(q,1,505570,1828);r_b(r,p_b(q_b(q,k)|0,505858)|0);v_b(q);F=0}if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);if(i|0)Yi[f[(f[i>>2]|0)+4>>2]&4095](i);ngc(o);v=F}else v=0;while(0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);s=v;u=e;return s|0}function mpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;d=a;a=c;a:while(1){c=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=c-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=17;break a;break}case 4:{l=18;break a;break}case 5:{l=19;break a;break}case 1:case 0:{l=207;break a;break}default:{}}if((j|0)<124){l=21;break a}m=h+(((k|0)/2|0)<<2)|0;if((j|0)>3996){j=(k|0)/4|0;n=Apc(h,h+(j<<2)|0,m,m+(j<<2)|0,e)|0}else n=ypc(h,m,e)|0;j=f[h>>2]|0;k=f[m>>2]|0;o=(b[j+38>>0]|0)==0;p=j;do if(!o){q=f[j+56>>2]|0;if(!q){r=(f[j+20>>2]|0)+80|0;break}else{r=q+40|0;break}}else r=(f[j+48>>2]|0)+20|0;while(0);q=p-(f[r>>2]|0)|0;s=(b[k+38>>0]|0)==0;do if(!s){t=f[k+56>>2]|0;u=k;if(!t){v=u-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{v=u-(f[t+40>>2]|0)|0;break}}else v=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((q|0)<(v|0)){w=e;x=n;break}t=k+48|0;u=k;y=k+56|0;z=k;A=k+20|0;B=e;while(1){B=B+-4|0;if((h|0)==(B|0))break;C=f[B>>2]|0;D=C;do if(b[C+38>>0]|0){E=f[C+56>>2]|0;if(!E){F=(f[C+20>>2]|0)+80|0;break}else{F=E+40|0;break}}else F=(f[C+48>>2]|0)+20|0;while(0);C=D-(f[F>>2]|0)|0;do if(!s){E=f[y>>2]|0;if(!E){G=z;H=(f[A>>2]|0)+80|0;break}else{G=z;H=E+40|0;break}}else{G=u;H=(f[t>>2]|0)+20|0}while(0);if((C|0)<(G-(f[H>>2]|0)|0)){l=149;break b}}t=h+4|0;u=f[e>>2]|0;z=u;do if(!o){A=f[j+56>>2]|0;if(!A){I=(f[j+20>>2]|0)+80|0;break}else{I=A+40|0;break}}else I=(f[j+48>>2]|0)+20|0;while(0);A=p-(f[I>>2]|0)|0;do if(b[u+38>>0]|0){y=f[u+56>>2]|0;if(!y){J=(f[u+20>>2]|0)+80|0;break}else{J=y+40|0;break}}else J=(f[u+48>>2]|0)+20|0;while(0);if((A|0)<(z-(f[J>>2]|0)|0))K=t;else{if((t|0)==(e|0)){l=207;break a}u=j+20|0;c:do if(o){y=p-(f[(f[j+48>>2]|0)+20>>2]|0)|0;s=t;while(1){k=f[s>>2]|0;do if(b[k+38>>0]|0){q=f[k+56>>2]|0;E=k;if(!q){L=E-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{L=E-(f[q+40>>2]|0)|0;break}}else L=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((y|0)<(L|0)){M=s;break c}s=s+4|0;if((s|0)==(e|0)){l=207;break a}}}else{s=f[j+56>>2]|0;y=(s|0)==0;C=s+40|0;s=t;while(1){k=f[s>>2]|0;if(y)N=(f[u>>2]|0)+80|0;else N=C;q=p-(f[N>>2]|0)|0;do if(b[k+38>>0]|0){E=f[k+56>>2]|0;O=k;if(!E){P=O-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{P=O-(f[E+40>>2]|0)|0;break}}else P=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((q|0)<(P|0)){M=s;break c}s=s+4|0;if((s|0)==(e|0)){l=207;break a}}}while(0);u=f[M>>2]|0;f[M>>2]=z;f[e>>2]=u;K=M+4|0}if((K|0)==(e|0)){l=207;break a}else{Q=e;R=K}while(1){u=f[h>>2]|0;t=(b[u+38>>0]|0)==0;j=u+48|0;o=u;A=u+56|0;s=u+20|0;if(t){u=o-(f[(f[j>>2]|0)+20>>2]|0)|0;C=R;while(1){y=f[C>>2]|0;do if(b[y+38>>0]|0){k=f[y+56>>2]|0;E=y;if(!k){S=E-(f[(f[y+20>>2]|0)+80>>2]|0)|0;break}else{S=E-(f[k+40>>2]|0)|0;break}}else S=y-(f[(f[y+48>>2]|0)+20>>2]|0)|0;while(0);if((u|0)<(S|0)){T=C;break}else C=C+4|0}}else{C=f[A>>2]|0;u=(C|0)==0;y=C+40|0;C=R;while(1){q=f[C>>2]|0;if(u)U=(f[s>>2]|0)+80|0;else U=y;k=o-(f[U>>2]|0)|0;do if(b[q+38>>0]|0){E=f[q+56>>2]|0;O=q;if(!E){V=O-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{V=O-(f[E+40>>2]|0)|0;break}}else V=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);if((k|0)<(V|0)){T=C;break}else C=C+4|0}}if(t){C=o-(f[(f[j>>2]|0)+20>>2]|0)|0;y=Q;while(1){u=y+-4|0;q=f[u>>2]|0;do if(b[q+38>>0]|0){E=f[q+56>>2]|0;O=q;if(!E){W=O-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{W=O-(f[E+40>>2]|0)|0;break}}else W=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);if((C|0)<(W|0))y=u;else{X=u;break}}}else{y=f[A>>2]|0;C=(y|0)==0;j=y+40|0;y=Q;while(1){t=y+-4|0;q=f[t>>2]|0;if(C)Y=(f[s>>2]|0)+80|0;else Y=j;k=o-(f[Y>>2]|0)|0;do if(b[q+38>>0]|0){E=f[q+56>>2]|0;O=q;if(!E){Z=O-(f[(f[q+20>>2]|0)+80>>2]|0)|0;break}else{Z=O-(f[E+40>>2]|0)|0;break}}else Z=q-(f[(f[q+48>>2]|0)+20>>2]|0)|0;while(0);if((k|0)<(Z|0))y=t;else{X=t;break}}}if(T>>>0>=X>>>0){h=T;continue b}y=f[T>>2]|0;f[T>>2]=f[X>>2];f[X>>2]=y;Q=X;R=T+4|0}}if((l|0)==149){l=0;f[h>>2]=D;f[B>>2]=p;w=B;x=n+1|0}z=h+4|0;d:do if(z>>>0<w>>>0){y=m;o=w;j=z;s=x;while(1){C=f[y>>2]|0;A=(b[C+38>>0]|0)==0;q=C+48|0;u=C;E=C+56|0;O=C+20|0;if(A){C=u-(f[(f[q>>2]|0)+20>>2]|0)|0;_=j;while(1){$=f[_>>2]|0;do if(b[$+38>>0]|0){aa=f[$+56>>2]|0;ba=$;if(!aa){ca=ba-(f[(f[$+20>>2]|0)+80>>2]|0)|0;break}else{ca=ba-(f[aa+40>>2]|0)|0;break}}else ca=$-(f[(f[$+48>>2]|0)+20>>2]|0)|0;while(0);if((ca|0)<(C|0))_=_+4|0;else{da=_;break}}}else{_=f[E>>2]|0;C=(_|0)==0;$=_+40|0;_=j;while(1){t=f[_>>2]|0;do if(b[t+38>>0]|0){k=f[t+56>>2]|0;aa=t;if(!k){ea=aa-(f[(f[t+20>>2]|0)+80>>2]|0)|0;break}else{ea=aa-(f[k+40>>2]|0)|0;break}}else ea=t-(f[(f[t+48>>2]|0)+20>>2]|0)|0;while(0);if(C)fa=(f[O>>2]|0)+80|0;else fa=$;if((ea|0)<(u-(f[fa>>2]|0)|0))_=_+4|0;else{da=_;break}}}if(A){_=u-(f[(f[q>>2]|0)+20>>2]|0)|0;$=o;while(1){C=$+-4|0;t=f[C>>2]|0;do if(b[t+38>>0]|0){k=f[t+56>>2]|0;aa=t;if(!k){ga=aa-(f[(f[t+20>>2]|0)+80>>2]|0)|0;break}else{ga=aa-(f[k+40>>2]|0)|0;break}}else ga=t-(f[(f[t+48>>2]|0)+20>>2]|0)|0;while(0);if((ga|0)<(_|0)){ha=C;break}else $=C}}else{$=f[E>>2]|0;_=($|0)==0;q=$+40|0;$=o;while(1){A=$+-4|0;t=f[A>>2]|0;do if(b[t+38>>0]|0){k=f[t+56>>2]|0;aa=t;if(!k){ia=aa-(f[(f[t+20>>2]|0)+80>>2]|0)|0;break}else{ia=aa-(f[k+40>>2]|0)|0;break}}else ia=t-(f[(f[t+48>>2]|0)+20>>2]|0)|0;while(0);if(_)ja=(f[O>>2]|0)+80|0;else ja=q;if((ia|0)<(u-(f[ja>>2]|0)|0)){ha=A;break}else $=A}}if(da>>>0>ha>>>0){ka=y;la=s;ma=da;break d}$=f[da>>2]|0;f[da>>2]=f[ha>>2];f[ha>>2]=$;y=(y|0)==(da|0)?ha:y;o=ha;j=da+4|0;s=s+1|0}}else{ka=m;la=x;ma=z}while(0);if((ma|0)!=(ka|0)){z=f[ka>>2]|0;s=f[ma>>2]|0;j=s;o=z;do if(b[z+38>>0]|0){y=f[z+56>>2]|0;if(!y){na=(f[z+20>>2]|0)+80|0;break}else{na=y+40|0;break}}else na=(f[z+48>>2]|0)+20|0;while(0);z=o-(f[na>>2]|0)|0;do if(b[s+38>>0]|0){y=f[s+56>>2]|0;if(!y){oa=(f[s+20>>2]|0)+80|0;break}else{oa=y+40|0;break}}else oa=(f[s+48>>2]|0)+20|0;while(0);if((z|0)<(j-(f[oa>>2]|0)|0)){f[ma>>2]=o;f[ka>>2]=j;pa=la+1|0}else pa=la}else pa=la;if(!pa){qa=Bpc(h,ma)|0;s=ma+4|0;if(Bpc(s,a)|0){l=206;break}if(qa){g=s;continue}}s=ma;if((s-i|0)>=(c-s|0)){l=205;break}mpc(h,ma);g=ma+4|0}if((l|0)==205){l=0;mpc(ma+4|0,a);d=h;a=ma;continue}else if((l|0)==206){l=0;if(qa){l=207;break}else{d=h;a=ma;continue}}}if((l|0)==5){ma=f[e>>2]|0;d=f[h>>2]|0;qa=d;i=ma;do if(b[ma+38>>0]|0){pa=f[ma+56>>2]|0;if(!pa){ra=(f[ma+20>>2]|0)+80|0;break}else{ra=pa+40|0;break}}else ra=(f[ma+48>>2]|0)+20|0;while(0);ma=i-(f[ra>>2]|0)|0;do if(b[d+38>>0]|0){ra=f[d+56>>2]|0;if(!ra){sa=(f[d+20>>2]|0)+80|0;break}else{sa=ra+40|0;break}}else sa=(f[d+48>>2]|0)+20|0;while(0);if((ma|0)>=(qa-(f[sa>>2]|0)|0))return;f[h>>2]=i;f[e>>2]=qa;return}else if((l|0)==17){ypc(h,h+4|0,e)|0;return}else if((l|0)==18){zpc(h,h+4|0,h+8|0,e)|0;return}else if((l|0)==19){Apc(h,h+4|0,h+8|0,h+12|0,e)|0;return}else if((l|0)==21){e=h+8|0;ypc(h,h+4|0,e)|0;qa=h+12|0;if((qa|0)==(a|0))return;else{ta=qa;ua=e}while(1){e=f[ta>>2]|0;qa=f[ua>>2]|0;i=(b[e+38>>0]|0)==0;sa=e;do if(!i){ma=f[e+56>>2]|0;if(!ma){va=(f[e+20>>2]|0)+80|0;break}else{va=ma+40|0;break}}else va=(f[e+48>>2]|0)+20|0;while(0);ma=sa-(f[va>>2]|0)|0;do if(b[qa+38>>0]|0){d=f[qa+56>>2]|0;ra=qa;if(!d){wa=ra-(f[(f[qa+20>>2]|0)+80>>2]|0)|0;break}else{wa=ra-(f[d+40>>2]|0)|0;break}}else wa=qa-(f[(f[qa+48>>2]|0)+20>>2]|0)|0;while(0);if((ma|0)<(wa|0)){qa=e+48|0;d=e+56|0;ra=e+20|0;e:do if(i){pa=ua;la=ta;while(1){f[la>>2]=f[pa>>2];if((pa|0)==(h|0)){xa=pa;break e}ka=pa+-4|0;oa=f[ka>>2]|0;na=sa-(f[(f[qa>>2]|0)+20>>2]|0)|0;do if(b[oa+38>>0]|0){x=f[oa+56>>2]|0;m=oa;if(!x){ya=m-(f[(f[oa+20>>2]|0)+80>>2]|0)|0;break}else{ya=m-(f[x+40>>2]|0)|0;break}}else ya=oa-(f[(f[oa+48>>2]|0)+20>>2]|0)|0;while(0);if((na|0)<(ya|0)){oa=pa;pa=ka;la=oa}else{xa=pa;break}}}else{pa=ua;la=ta;while(1){f[la>>2]=f[pa>>2];if((pa|0)==(h|0)){xa=pa;break e}j=pa+-4|0;o=f[j>>2]|0;z=f[d>>2]|0;if(!z)za=(f[ra>>2]|0)+80|0;else za=z+40|0;z=sa-(f[za>>2]|0)|0;do if(b[o+38>>0]|0){oa=f[o+56>>2]|0;x=o;if(!oa){Aa=x-(f[(f[o+20>>2]|0)+80>>2]|0)|0;break}else{Aa=x-(f[oa+40>>2]|0)|0;break}}else Aa=o-(f[(f[o+48>>2]|0)+20>>2]|0)|0;while(0);if((z|0)<(Aa|0)){o=pa;pa=j;la=o}else{xa=pa;break}}}while(0);f[xa>>2]=sa}ra=ta+4|0;if((ra|0)==(a|0))break;else{d=ta;ta=ra;ua=d}}return}else if((l|0)==207)return}function npc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;h=u;u=u+32|0;i=h;j=h+24|0;k=e+32|0;if(b[a+6>>0]|0?(f[k>>2]|0)==3:0){l=e+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=e;J_b(m,i)}m=e+28|0;if((f[165644+(f[m>>2]<<2)>>2]|0)!=9){n=f[l>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=e;J_b(n,i)}if((f[165644+(f[m>>2]<<2)>>2]|0)!=10){ppc(a,c,d,e,g);u=h;return}}}if((f[k>>2]|0)==3)o=hj[f[(f[d>>2]|0)+24>>2]&511](d,c,e)|0;else o=(hj[f[(f[d>>2]|0)+20>>2]&511](d,c,e)|0)&1;m=e+24|0;n=f[m>>2]|0;if(n|0?(f[n>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=e;J_b(n,i)}n=e+28|0;if((f[n>>2]|0)==11?D3b(e)|0:0){qpc(i,c,o,d,e);p=1;q=f[i>>2]|0}else{p=0;q=0}if((o|0)>0){l=a+24|0;r=a+32|0;s=q;t=a+4|0;v=g+20|0;w=g+24|0;x=i+4|0;y=i+8|0;z=i+12|0;A=0;do{B=(f[k>>2]|0)==3?A:-1;rpc(a,c,d,e,g);C=f[m>>2]|0;if(C|0?(f[C>>2]|0)!=2:0){f[i>>2]=80424;f[x>>2]=2231;b[y>>0]=0;f[z>>2]=e;J_b(C,i)}do if((f[165644+(f[n>>2]<<2)>>2]|0)!=10){Ti[f[(f[g>>2]|0)+8>>2]&511](g,518985,2);spc(a,c,d,e,B,g);C=f[(f[g>>2]|0)+8>>2]|0;if(!(b[t>>0]|0)){Ti[C&511](g,505563,1);break}else{Ti[C&511](g,528081,1);break}}else{C=f[l>>2]|0;D=f[r>>2]|0;if(D){E=r;F=D;a:while(1){D=F;while(1){if((f[D+16>>2]|0)>>>0>=e>>>0)break;G=f[D+4>>2]|0;if(!G){H=E;break a}else D=G}F=f[D>>2]|0;if(!F){H=D;break}else E=D}if((H|0)!=(r|0)?(f[H+16>>2]|0)>>>0<=e>>>0:0)I=f[H+20>>2]|0;else I=C}else I=C;do if((f[k>>2]|0)==3)if(p){J=f[s+(A<<2)>>2]|0;break}else{J=hh[f[(f[d>>2]|0)+208>>2]&127](d,c,e,A)|0;break}else J=hh[f[(f[d>>2]|0)+108>>2]&127](d,c,e,0)|0;while(0);Fh[f[(f[I>>2]|0)+52>>2]&255](I,J,B,o,(b[t>>0]|0)!=0,g);f[v>>2]=(f[v>>2]|0)+1;kpc(a,J,g);C=f[v>>2]|0;if((C|0)!=0?(C|0)>=(f[w>>2]|0):0)f[v>>2]=C+-1;else{u_b(i,2,505570,1200);r_b(j,p_b(i,505663)|0);v_b(i)}Fh[f[(f[I>>2]|0)+56>>2]&255](I,J,B,o,(b[t>>0]|0)!=0,g)}while(0);A=A+1|0}while((A|0)<(o|0))}if(!q){u=h;return}cYc(q);u=h;return}function opc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=u;u=u+128|0;g=e+32|0;h=e+108|0;i=e+96|0;j=e+56|0;k=e+16|0;l=e;m=i+11|0;n=i+4|0;o=g+11|0;p=g+4|0;q=a+4|0;r=k+8|0;s=j+4|0;t=h+11|0;v=h+4|0;w=h+8|0;x=l+8|0;y=j+4|0;z=h+11|0;A=h+4|0;B=h+8|0;C=g+11|0;D=g+4|0;E=d+20|0;F=d+24|0;G=0;a:while(1){H=f[c>>2]|0;if(!H)I=0;else I=(f[H+4>>2]|0)-(f[H>>2]|0)>>4;if((G|0)>=(I|0)){J=5;break}K=f[H>>2]|0;mtc(i,f[K+(G<<4)>>2]|0);b:do switch(f[K+(G<<4)+4>>2]|0){case 0:{H=b[m>>0]|0;L=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,L?f[i>>2]|0:i,L?f[n>>2]|0:H&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,518985,2);H=K+(G<<4)+8|0;ptc(g,f[H>>2]|0,f[H+4>>2]|0);H=b[o>>0]|0;L=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,L?f[g>>2]|0:g,L?f[p>>2]|0:H&255);if((b[o>>0]|0)<0)cYc(f[g>>2]|0);H=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[H&511](d,505563,1);break b}else{Ti[H&511](d,528081,1);break b}break}case 1:{H=b[m>>0]|0;L=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,L?f[i>>2]|0:i,L?f[n>>2]|0:H&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,505565,4);H=f[K+(G<<4)+8>>2]|0;f[r>>2]=8;L=k;f[L>>2]=H;f[L+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];wtc(j,g);L=f[j>>2]|0;H=f[s>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(H>>>0>4294967279){J=13;break a}if(H>>>0<11){b[t>>0]=H;if(!H)M=h;else{N=h;J=17}}else{O=H+16&-16;P=$Xc(O)|0;f[h>>2]=P;f[w>>2]=O|-2147483648;f[v>>2]=H;N=P;J=17}if((J|0)==17){J=0;o1c(N|0,L|0,H|0)|0;M=N}b[M+H>>0]=0;H=b[t>>0]|0;L=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,L?f[h>>2]|0:h,L?f[v>>2]|0:H&255);if((b[t>>0]|0)<0)cYc(f[h>>2]|0);H=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[H&511](d,505563,1);break b}else{Ti[H&511](d,528081,1);break b}break}case 2:{H=b[m>>0]|0;L=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,L?f[i>>2]|0:i,L?f[n>>2]|0:H&255);Ti[f[(f[d>>2]|0)+8>>2]&511](d,505565,4);H=K+(G<<4)+8|0;L=f[H>>2]|0;P=f[H+4>>2]|0;f[x>>2]=16;H=l;f[H>>2]=L;f[H+4>>2]=P;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];wtc(j,g);P=f[j>>2]|0;H=f[y>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(H>>>0>4294967279){J=24;break a}if(H>>>0<11){b[z>>0]=H;if(!H)Q=h;else{R=h;J=28}}else{L=H+16&-16;O=$Xc(L)|0;f[h>>2]=O;f[B>>2]=L|-2147483648;f[A>>2]=H;R=O;J=28}if((J|0)==28){J=0;o1c(R|0,P|0,H|0)|0;Q=R}b[Q+H>>0]=0;H=b[z>>0]|0;P=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,P?f[h>>2]|0:h,P?f[A>>2]|0:H&255);if((b[z>>0]|0)<0)cYc(f[h>>2]|0);H=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[H&511](d,505563,1);break b}else{Ti[H&511](d,528081,1);break b}break}case 3:{H=b[m>>0]|0;P=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,P?f[i>>2]|0:i,P?f[n>>2]|0:H&255);H=f[K+(G<<4)+8>>2]|0;f[j>>2]=0;P=b[H+11>>0]|0;O=P<<24>>24<0;if(O)S=f[H+4>>2]|0;else S=P&255;do if((S|0)!=0?Fqc(j,O?f[H>>2]|0:H,O?f[H+4>>2]|0:P&255)|0:0){L=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[L&511](d,505463,3);f[E>>2]=(f[E>>2]|0)+1}else Ti[L&511](d,505459,3);opc(a,j,d);if(b[q>>0]|0){Ti[f[(f[d>>2]|0)+8>>2]&511](d,505403,2);break}L=f[E>>2]|0;if((L|0)!=0?(L|0)>=(f[F>>2]|0):0)f[E>>2]=L+-1;else{u_b(g,2,505570,1200);r_b(h,p_b(g,505663)|0);v_b(g)}Ti[f[(f[d>>2]|0)+8>>2]&511](d,505406,2)}else J=49;while(0);do if((J|0)==49){J=0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,505701,3);gtc(g,H);P=b[C>>0]|0;O=P<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,O?f[g>>2]|0:g,O?f[D>>2]|0:P&255);if((b[C>>0]|0)<0)cYc(f[g>>2]|0);P=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[P&511](d,505708,2);break}else{Ti[P&511](d,505705,2);break}}while(0);if(f[j>>2]|0)sqc(j);break}case 4:{H=b[m>>0]|0;P=H<<24>>24<0;Ti[f[(f[d>>2]|0)+8>>2]&511](d,P?f[i>>2]|0:i,P?f[n>>2]|0:H&255);H=f[(f[d>>2]|0)+8>>2]|0;if(!(b[q>>0]|0)){Ti[H&511](d,505463,3);f[E>>2]=(f[E>>2]|0)+1}else Ti[H&511](d,505459,3);opc(a,f[K+(G<<4)+8>>2]|0,d);if(b[q>>0]|0){Ti[f[(f[d>>2]|0)+8>>2]&511](d,505403,2);break b}H=f[E>>2]|0;if((H|0)!=0?(H|0)>=(f[F>>2]|0):0)f[E>>2]=H+-1;else{u_b(g,2,505570,1200);r_b(h,p_b(g,505663)|0);v_b(g)}Ti[f[(f[d>>2]|0)+8>>2]&511](d,505406,2);break}default:{}}while(0);if((b[m>>0]|0)<0)cYc(f[i>>2]|0);G=G+1|0}if((J|0)==5){u=e;return}else if((J|0)==13)jYc(h);else if((J|0)==24)jYc(h)}function ppc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;rpc(a,c,d,e,g);h=hj[f[(f[d>>2]|0)+24>>2]&511](d,c,e)|0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,505828,3);if((h|0)>0){i=0;do{if((i|0)>0)Ti[f[(f[g>>2]|0)+8>>2]&511](g,528271,2);spc(a,c,d,e,i,g);i=i+1|0}while((i|0)!=(h|0))}h=f[(f[g>>2]|0)+8>>2]|0;if(!(b[a+4>>0]|0)){Ti[h&511](g,505832,2);return}else{Ti[h&511](g,518940,2);return}}function qpc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;f[a>>2]=0;m=a+4|0;f[m>>2]=0;f[a+8>>2]=0;if(c|0){if(c>>>0>1073741823)kWc(a);n=$Xc(c<<2)|0;f[m>>2]=n;f[a>>2]=n;f[a+8>>2]=n+(c<<2);o=c;c=n;do{f[c>>2]=0;c=(f[m>>2]|0)+4|0;f[m>>2]=c;o=o+-1|0}while((o|0)!=0)}o=xg[f[(f[d>>2]|0)+328>>2]&127](d,b,e,10,-1,0)|0;b=o+12|0;d=f[b>>2]|0;c=f[o+4>>2]|0;if(c|0){o=0;n=(d|0)==0?0:d+4|0;while(1){f[(f[a>>2]|0)+(o<<2)>>2]=f[n>>2];n=n+4|0;d=f[b>>2]|0;if((n|0)==(((d|0)==0?0:d+4|0)+(c<<2)|0))break;else o=o+1|0}}o=(F3b(e)|0)+20|0;e=f[a>>2]|0;a=f[m>>2]|0;f[l>>2]=f[o>>2];o=a-e|0;m=o>>2;if((o|0)>512){o=(m|0)<536870911?m:536870911;while(1){c=aYc(o<<2,1165590)|0;if(c|0){p=c;q=o;break}o=o>>>1;if(!o){p=0;q=0;break}}r=p;s=q;t=p}else{r=0;s=0;t=0}f[j>>2]=e;f[k>>2]=a;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];tpc(i,h,l,m,r,s);if(!r){u=g;return}cYc(t);u=g;return}function rpc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(b[a+5>>0]|0){mtc(i,f[e+40>>2]|0);j=i+11|0;k=b[j>>0]|0;l=k<<24>>24<0;Ti[f[(f[g>>2]|0)+8>>2]&511](g,l?f[i>>2]|0:i,l?f[i+4>>2]|0:k&255);if((b[j>>0]|0)<0)cYc(f[i>>2]|0);u=h;return}i=f[a+24>>2]|0;j=a+32|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>>>0>=e>>>0)break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)>>>0<=e>>>0:0)o=f[n+20>>2]|0;else o=i}else o=i;gi[f[(f[o>>2]|0)+48>>2]&255](o,c,d,e,g);u=h;return}function spc(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,K=0,L=0,M=0;j=u;u=u+64|0;k=j;l=j+40|0;m=j+28|0;n=j+16|0;o=j+4|0;p=f[a+24>>2]|0;q=a+32|0;r=f[q>>2]|0;if(r){s=q;t=r;a:while(1){r=t;while(1){if((f[r+16>>2]|0)>>>0>=g>>>0)break;v=f[r+4>>2]|0;if(!v){w=s;break a}else r=v}t=f[r>>2]|0;if(!t){w=r;break}else s=r}if((w|0)!=(q|0)?(f[w+16>>2]|0)>>>0<=g>>>0:0)x=f[w+20>>2]|0;else x=p}else x=p;p=g+24|0;w=f[p>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[l>>2]=80424;f[l+4>>2]=2231;b[l+8>>0]=0;f[l+12>>2]=g;J_b(w,l)}w=g+28|0;do switch(f[165644+(f[w>>2]<<2)>>2]|0){case 1:{q=f[(f[x>>2]|0)+12>>2]|0;if((f[g+32>>2]|0)==3)y=hh[f[(f[e>>2]|0)+168>>2]&127](e,c,g,h)|0;else y=hj[f[(f[e>>2]|0)+68>>2]&511](e,c,g)|0;Ti[q&511](x,y,i);u=j;return}case 2:{q=f[(f[x>>2]|0)+20>>2]|0;if((f[g+32>>2]|0)==3){s=hh[f[(f[e>>2]|0)+172>>2]&127](e,c,g,h)|0;z=s;A=J}else{s=hj[f[(f[e>>2]|0)+72>>2]&511](e,c,g)|0;z=s;A=J}ei[q&511](x,z,A,i);u=j;return}case 3:{q=f[(f[x>>2]|0)+16>>2]|0;if((f[g+32>>2]|0)==3)B=hh[f[(f[e>>2]|0)+176>>2]&127](e,c,g,h)|0;else B=hj[f[(f[e>>2]|0)+76>>2]&511](e,c,g)|0;Ti[q&511](x,B,i);u=j;return}case 4:{q=f[(f[x>>2]|0)+24>>2]|0;if((f[g+32>>2]|0)==3){s=hh[f[(f[e>>2]|0)+180>>2]&127](e,c,g,h)|0;C=s;D=J}else{s=hj[f[(f[e>>2]|0)+80>>2]&511](e,c,g)|0;C=s;D=J}ei[q&511](x,C,D,i);u=j;return}case 6:{q=f[(f[x>>2]|0)+28>>2]|0;if((f[g+32>>2]|0)==3)E=+Ai[f[(f[e>>2]|0)+184>>2]&15](e,c,g,h);else E=+Sh[f[(f[e>>2]|0)+84>>2]&31](e,c,g);Hg[q&15](x,E,i);u=j;return}case 5:{q=f[(f[x>>2]|0)+32>>2]|0;if((f[g+32>>2]|0)==3)F=+Ai[f[(f[e>>2]|0)+188>>2]&15](e,c,g,h);else F=+Sh[f[(f[e>>2]|0)+88>>2]&31](e,c,g);Hg[q&15](x,F,i);u=j;return}case 7:{q=f[(f[x>>2]|0)+8>>2]|0;if((f[g+32>>2]|0)==3)G=hh[f[(f[e>>2]|0)+192>>2]&127](e,c,g,h)|0;else G=hj[f[(f[e>>2]|0)+92>>2]&511](e,c,g)|0;Ti[q&511](x,G,i);u=j;return}case 9:{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if((f[g+32>>2]|0)==3)H=_h[f[(f[e>>2]|0)+212>>2]&127](e,c,g,h,m)|0;else H=hh[f[(f[e>>2]|0)+112>>2]&127](e,c,g,m)|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;q=a+16|0;s=f[q>>2]|0;t=f[q+4>>2]|0;if((t|0)>0|(t|0)==0&s>>>0>0){q=b[H+11>>0]|0;if(q<<24>>24<0)I=f[H+4>>2]|0;else I=q&255;if((t|0)<0|(t|0)==0&s>>>0<I>>>0){mYc(o,H,0,s,H);s=AYc(o,505711)|0;t=f[s>>2]|0;q=s+4|0;f[l>>2]=f[q>>2];d[l+4>>1]=d[q+4>>1]|0;b[l+6>>0]=b[q+6>>0]|0;q=b[s+11>>0]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;s=n+11|0;if((b[s>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0}else{b[n>>0]=0;b[s>>0]=0}sYc(n,0);f[n>>2]=t;t=n+4|0;f[t>>2]=f[l>>2];d[t+4>>1]=d[l+4>>1]|0;b[t+6>>0]=b[l+6>>0]|0;b[n+11>>0]=q;f[l>>2]=0;d[l+4>>1]=0;b[l+6>>0]=0;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);K=n}else K=H}else K=H;q=f[p>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[l>>2]=80424;f[l+4>>2]=2231;b[l+8>>0]=0;f[l+12>>2]=g;J_b(q,l)}q=f[x>>2]|0;if((f[w>>2]|0)==9)Ti[f[q+36>>2]&511](x,K,i);else Ti[f[q+40>>2]&511](x,K,i);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);u=j;return}case 8:{if((f[g+32>>2]|0)==3)L=hh[f[(f[e>>2]|0)+204>>2]&127](e,c,g,h)|0;else L=hj[f[(f[e>>2]|0)+104>>2]&511](e,c,g)|0;q=y3b(G3b(g)|0,L)|0;t=f[(f[x>>2]|0)+44>>2]|0;if(q|0){ei[t&511](x,L,f[q>>2]|0,i);u=j;return}f[k>>2]=L;Zsc(l,505729,k);ei[t&511](x,L,l,i);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);u=j;return}case 10:{if((f[g+32>>2]|0)==3)M=hh[f[(f[e>>2]|0)+208>>2]&127](e,c,g,h)|0;else M=hh[f[(f[e>>2]|0)+108>>2]&127](e,c,g,0)|0;kpc(a,M,i);u=j;return}default:{u=j;return}}while(0)}function tpc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+64|0;i=h+52|0;j=h+48|0;k=h+44|0;l=h+40|0;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;q=h+20|0;r=h+16|0;s=h+12|0;t=h+8|0;v=h+4|0;w=h;switch(d|0){case 2:{x=(f[b>>2]|0)+-4|0;f[b>>2]=x;y=f[a>>2]|0;if(!(upc(c,f[x>>2]|0,f[y>>2]|0)|0)){u=h;return}z=f[y>>2]|0;f[y>>2]=f[x>>2];f[x>>2]=z;u=h;return}case 1:case 0:{u=h;return}default:{if((d|0)<129){z=f[a>>2]|0;x=f[b>>2]|0;if((z|0)==(x|0)){u=h;return}y=z+4|0;if((y|0)==(x|0)){u=h;return}else A=y;do{y=A;B=f[A>>2]|0;a:do if((A|0)==(z|0))C=y;else{D=B;E=y;F=A;while(1){F=F+-4|0;if(!(upc(c,D,f[F>>2]|0)|0)){C=E;break a}f[E>>2]=f[F>>2];G=E+-4|0;if((F|0)==(z|0)){C=G;break}else E=G}}while(0);f[C>>2]=B;A=A+4|0}while((A|0)!=(x|0));u=h;return}x=d>>>1;A=f[a>>2]|0;a=A+(x<<2)|0;C=A;if((d|0)>(g|0)){f[p>>2]=C;f[q>>2]=a;f[j>>2]=f[p>>2];f[i>>2]=f[q>>2];tpc(j,i,c,x,e,g);f[r>>2]=a;q=f[b>>2]|0;f[s>>2]=q;p=d-x|0;f[j>>2]=f[r>>2];f[i>>2]=f[s>>2];tpc(j,i,c,p,e,g);f[t>>2]=C;f[v>>2]=a;f[w>>2]=q;f[k>>2]=f[t>>2];f[j>>2]=f[v>>2];f[i>>2]=f[w>>2];wpc(k,j,i,c,x,p,e,g);u=h;return}f[l>>2]=C;f[m>>2]=a;f[j>>2]=f[l>>2];f[i>>2]=f[m>>2];vpc(j,i,c,x,e);f[n>>2]=a;f[o>>2]=f[b>>2];b=e+(x<<2)|0;f[j>>2]=f[n>>2];f[i>>2]=f[o>>2];vpc(j,i,c,d-x|0,b);x=e+(d<<2)|0;d=b;i=e;e=C;while(1){if((d|0)==(x|0))break;if(upc(c,f[d>>2]|0,f[i>>2]|0)|0){C=e;f[C>>2]=f[d>>2];H=d+4|0;I=i;J=C}else{C=e;f[C>>2]=f[i>>2];H=d;I=i+4|0;J=C}K=J+4|0;if((I|0)==(b|0)){L=14;break}else{d=H;i=I;e=K}}if((L|0)==14){if((H|0)==(x|0)){u=h;return}else{M=H;N=K}while(1){f[N>>2]=f[M>>2];M=M+4|0;if((M|0)==(x|0))break;else N=N+4|0}u=h;return}if((i|0)==(b|0)){u=h;return}N=i;i=e;while(1){f[i>>2]=f[N>>2];N=N+4|0;if((N|0)==(b|0))break;else i=i+4|0}u=h;return}}}function upc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+64|0;g=e+40|0;h=e;i=e+16|0;j=e+56|0;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);k=f[g+4>>2]|0;l=f[a>>2]|0;m=f[l+24>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=l;J_b(m,g)}switch(f[165644+(f[l+28>>2]<<2)>>2]|0){case 7:{l=hj[f[(f[k>>2]|0)+92>>2]&511](k,c,f[a>>2]|0)|0;n=(hj[f[(f[k>>2]|0)+92>>2]&511](k,d,f[a>>2]|0)|0)&(l^1);u=e;return n|0}case 1:{n=(hj[f[(f[k>>2]|0)+68>>2]&511](k,c,f[a>>2]|0)|0)<(hj[f[(f[k>>2]|0)+68>>2]&511](k,d,f[a>>2]|0)|0);u=e;return n|0}case 2:{l=hj[f[(f[k>>2]|0)+72>>2]&511](k,c,f[a>>2]|0)|0;m=J;o=hj[f[(f[k>>2]|0)+72>>2]&511](k,d,f[a>>2]|0)|0;p=J;n=(m|0)<(p|0)|(m|0)==(p|0)&l>>>0<o>>>0;u=e;return n|0}case 3:{n=(hj[f[(f[k>>2]|0)+76>>2]&511](k,c,f[a>>2]|0)|0)>>>0<(hj[f[(f[k>>2]|0)+76>>2]&511](k,d,f[a>>2]|0)|0)>>>0;u=e;return n|0}case 4:{o=hj[f[(f[k>>2]|0)+80>>2]&511](k,c,f[a>>2]|0)|0;l=J;p=hj[f[(f[k>>2]|0)+80>>2]&511](k,d,f[a>>2]|0)|0;m=J;n=l>>>0<m>>>0|(l|0)==(m|0)&o>>>0<p>>>0;u=e;return n|0}case 9:{ei[f[(f[k>>2]|0)+96>>2]&511](g,k,c,f[a>>2]|0);ei[f[(f[k>>2]|0)+96>>2]&511](h,k,d,f[a>>2]|0);a=b[h+11>>0]|0;d=a<<24>>24<0;k=d?f[h+4>>2]|0:a&255;a=g+11|0;c=b[a>>0]|0;p=c<<24>>24<0;o=p?f[g+4>>2]|0:c&255;m=k>>>0<o>>>0;l=m?k:o;if((l|0)!=0?(q=WKc(p?f[g>>2]|0:g,d?f[h>>2]|0:h,l)|0,(q|0)!=0):0)r=q;else r=o>>>0<k>>>0?-1:m&1;if(d){cYc(f[h>>2]|0);s=b[a>>0]|0}else s=c;if(s<<24>>24<0)cYc(f[g>>2]|0);n=(r|0)<0;u=e;return n|0}default:{u_b(i,2,505732,223);r_b(j,p_b(i,507520)|0);v_b(i);n=1;u=e;return n|0}}return 0}function vpc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+32|0;h=g+8|0;i=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;switch(d|0){case 1:{f[e>>2]=f[f[a>>2]>>2];u=g;return}case 2:{n=(f[b>>2]|0)+-4|0;f[b>>2]=n;o=upc(c,f[n>>2]|0,f[f[a>>2]>>2]|0)|0;f[e>>2]=f[f[(o?b:a)>>2]>>2];f[e+4>>2]=f[f[(o?a:b)>>2]>>2];u=g;return}case 0:{u=g;return}default:{if((d|0)>=9){o=d>>>1;n=f[a>>2]|0;p=n+(o<<2)|0;q=n;f[j>>2]=q;f[k>>2]=p;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];tpc(i,h,c,o,e,o);f[l>>2]=p;k=f[b>>2]|0;f[m>>2]=k;j=d-o|0;f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];tpc(i,h,c,j,e+(o<<2)|0,j);f[h>>2]=p;f[i>>2]=q;q=k;a:do if(o){if((p|0)==(q|0)){r=e;s=n}else{k=e;j=p;m=n;while(1){l=upc(c,f[j>>2]|0,f[m>>2]|0)|0;d=l?h:i;l=f[d>>2]|0;f[k>>2]=f[l>>2];f[d>>2]=l+4;l=k+4|0;d=f[i>>2]|0;j=f[h>>2]|0;if((d|0)==(p|0)){t=l;v=j;w=16;break a}if((j|0)==(q|0)){r=l;s=d;break}else{k=l;m=d}}}if((s|0)!=(p|0)){m=r;k=s;while(1){f[m>>2]=f[k>>2];k=(f[i>>2]|0)+4|0;f[i>>2]=k;if((k|0)==(p|0))break;else m=m+4|0}}}else{t=e;v=n;w=16}while(0);if((w|0)==16?(v|0)!=(q|0):0){w=t;t=v;while(1){f[w>>2]=f[t>>2];t=(f[h>>2]|0)+4|0;f[h>>2]=t;if((t|0)==(q|0))break;else w=w+4|0}}u=g;return}w=f[a>>2]|0;a=f[b>>2]|0;if((w|0)==(a|0)){u=g;return}b=f[w>>2]|0;f[e>>2]=b;q=w+4|0;if((q|0)==(a|0)){u=g;return}w=e;t=q;q=b;while(1){b=w+4|0;b:do if(upc(c,f[t>>2]|0,q)|0){f[b>>2]=f[w>>2];if((w|0)==(e|0))x=e;else{h=w;while(1){v=h;h=h+-4|0;if(!(upc(c,f[t>>2]|0,f[h>>2]|0)|0)){x=v;break b}f[v>>2]=f[h>>2];if((h|0)==(e|0)){x=e;break}}}}else x=b;while(0);f[x>>2]=f[t>>2];h=t+4|0;if((h|0)==(a|0))break;w=b;t=h;q=f[b>>2]|0}u=g;return}}}function wpc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;j=u;u=u+64|0;k=j+52|0;l=j+48|0;m=j+44|0;n=j+40|0;o=j+36|0;p=j+32|0;q=j+20|0;r=j+12|0;s=j+28|0;t=j+24|0;v=j+16|0;w=j+8|0;x=j+4|0;y=j;if(!g){u=j;return}z=e;e=g;a:while(1){if(!((e|0)>(i|0)&(z|0)>(i|0))){A=6;break}if(!z){A=42;break}B=f[b>>2]|0;g=B;C=z;D=f[a>>2]|0;while(1){if(upc(d,f[B>>2]|0,f[D>>2]|0)|0)break;E=D+4|0;f[a>>2]=E;F=C+-1|0;if(!F){A=42;break a}else{C=F;D=E}}E=D;if((C|0)<(e|0)){F=(e|0)/2|0;G=B+(F<<2)|0;H=G;f[r>>2]=H;I=g-E>>2;if(!I)J=D;else{K=I;I=D;L=D;while(1){M=(K|0)/2|0;N=L+(M<<2)|0;O=upc(d,f[G>>2]|0,f[N>>2]|0)|0;P=N+4|0;N=O?I:P;K=O?M:K+-1-M|0;if(!K){J=N;break}else{I=N;L=O?L:P}}}L=J;f[q>>2]=L;Q=L-E>>2;R=F;S=H;T=L}else{if((C|0)==1){A=14;break}L=(C|0)/2|0;I=D+(L<<2)|0;K=I;f[q>>2]=K;G=(f[c>>2]|0)-g>>2;if(!G)U=B;else{P=G;G=B;O=B;while(1){N=(P|0)/2|0;M=O+(N<<2)|0;V=upc(d,f[M>>2]|0,f[I>>2]|0)|0;W=M+4|0;M=V?W:G;P=V?P+-1-N|0:N;if(!P){U=M;break}else{G=M;O=V?W:O}}}O=U;f[r>>2]=O;Q=L;R=O-g>>2;S=O;T=K}O=C-Q|0;G=e-R|0;P=T;I=S;b:do if((P|0)!=(B|0))if((B|0)==(I|0))X=P;else{if((P+4|0)==(B|0)){H=f[T>>2]|0;F=S-g|0;E=F>>2;if(E|0)q1c(T|0,B|0,F|0)|0;F=P+(E<<2)|0;f[F>>2]=H;X=F;break}if((B+4|0)==(I|0)){F=f[B>>2]|0;H=g-T|0;E=H>>2;W=I+(0-E<<2)|0;if(!E)Y=I;else{q1c(W|0,T|0,H|0)|0;Y=W}f[T>>2]=F;X=Y;break}F=g-T>>2;W=S-g>>2;if((F|0)==(W|0)){H=P;E=B;while(1){V=f[H>>2]|0;f[H>>2]=f[E>>2];f[E>>2]=V;H=H+4|0;if((H|0)==(B|0)){X=B;break b}else E=E+4|0}}else{Z=F;_=W}while(1){E=(Z|0)%(_|0)|0;if(!E)break;else{H=_;_=E;Z=H}}if(!_)$=P;else{H=(_<<2)+-4|0;E=P+(_<<2)|0;do{E=E+-4|0;V=f[E>>2]|0;M=E+(F<<2)|0;N=E;while(1){f[N>>2]=f[M>>2];N=M;aa=S-N>>2;ba=(F|0)<(aa|0)?M+(F<<2)|0:P+(F-aa<<2)|0;if((ba|0)==(E|0))break;else M=ba}f[M>>2]=V}while((E|0)!=(P|0));$=P+(_+-1-(H>>>2)<<2)|0}X=$+(W<<2)|0}else X=I;while(0);f[b>>2]=X;I=X;if((Q+R|0)<(O+G|0)){f[s>>2]=f[a>>2];f[t>>2]=f[q>>2];f[v>>2]=I;f[m>>2]=f[s>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];wpc(m,l,k,d,Q,R,h,i);ca=G;da=O;ea=r;fa=a}else{f[w>>2]=I;f[x>>2]=f[r>>2];f[y>>2]=f[c>>2];f[m>>2]=f[w>>2];f[l>>2]=f[x>>2];f[k>>2]=f[y>>2];wpc(m,l,k,d,O,G,h,i);ca=R;da=Q;ea=q;fa=c}f[fa>>2]=I;f[b>>2]=f[ea>>2];if(!ca){A=42;break}else{z=da;e=ca}}if((A|0)==6){f[n>>2]=f[a>>2];f[o>>2]=f[b>>2];f[p>>2]=f[c>>2];f[m>>2]=f[n>>2];f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];xpc(m,l,k,d,z,e,h);u=j;return}else if((A|0)==14){h=f[D>>2]|0;f[D>>2]=f[B>>2];f[B>>2]=h;u=j;return}else if((A|0)==42){u=j;return}}function xpc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+16|0;j=i;k=i+4|0;if((e|0)>(g|0)){g=f[b>>2]|0;e=g;l=f[c>>2]|0;if((e|0)==(l|0)){m=h;n=l;o=g}else{l=h;p=g;g=e;while(1){f[l>>2]=f[p>>2];e=g+4|0;q=l+4|0;r=f[c>>2]|0;if((e|0)==(r|0))break;else{l=q;p=e;g=e}}m=q;n=r;o=f[b>>2]|0}r=f[a>>2]|0;f[j>>2]=o;f[k>>2]=m;a:do if((m|0)!=(h|0)){q=o;if((q|0)==(r|0)){s=m;t=n}else{g=q;q=m;p=n;while(1){l=upc(d,f[g+-4>>2]|0,f[q+-4>>2]|0)|0;e=l?k:j;l=(f[e>>2]|0)+-4|0;v=p+-4|0;f[v>>2]=f[l>>2];f[e>>2]=l;l=f[k>>2]|0;if((l|0)==(h|0))break a;g=f[j>>2]|0;if((g|0)==(r|0)){s=l;t=v;break}else{q=l;p=v}}}if((s|0)!=(h|0)){p=s;q=t;do{p=p+-4|0;q=q+-4|0;f[q>>2]=f[p>>2]}while((p|0)!=(h|0))}}while(0);u=i;return}t=f[a>>2]|0;s=t;if((s|0)==(f[b>>2]|0)){w=h;x=t;y=s}else{r=h;k=t;t=s;while(1){f[r>>2]=f[k>>2];z=t+4|0;A=r+4|0;if((z|0)==(f[b>>2]|0))break;else{r=A;k=z;t=z}}w=A;x=f[a>>2]|0;y=z}z=f[c>>2]|0;f[j>>2]=f[d>>2];b:do if((w|0)!=(h|0)){d=h;c=x;a=y;A=y;while(1){if((a|0)==(z|0))break;if(upc(j,f[a>>2]|0,f[d>>2]|0)|0){t=c;f[t>>2]=f[A>>2];k=A+4|0;B=d;C=t;D=k;E=k}else{k=c;f[k>>2]=f[d>>2];B=d+4|0;C=k;D=A;E=a}if((B|0)==(w|0))break b;else{d=B;c=C+4|0;a=E;A=D}}A=w-d|0;if(A|0)q1c(c|0,d|0,A|0)|0}while(0);u=i;return}function ypc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[c>>2]|0;g=f[a>>2]|0;h=(b[e+38>>0]|0)==0;i=e;j=g;do if(!h){k=f[e+56>>2]|0;if(!k){l=(f[e+20>>2]|0)+80|0;break}else{l=k+40|0;break}}else l=(f[e+48>>2]|0)+20|0;while(0);k=i-(f[l>>2]|0)|0;l=(b[g+38>>0]|0)==0;do if(!l){m=f[g+56>>2]|0;if(!m){n=(f[g+20>>2]|0)+80|0;break}else{n=m+40|0;break}}else n=(f[g+48>>2]|0)+20|0;while(0);m=(k|0)<(j-(f[n>>2]|0)|0);n=f[d>>2]|0;k=n;do if(b[n+38>>0]|0){o=f[n+56>>2]|0;if(!o){p=(f[n+20>>2]|0)+80|0;break}else{p=o+40|0;break}}else p=(f[n+48>>2]|0)+20|0;while(0);n=k-(f[p>>2]|0)|0;do if(!h){p=f[e+56>>2]|0;if(!p){q=(f[e+20>>2]|0)+80|0;break}else{q=p+40|0;break}}else q=(f[e+48>>2]|0)+20|0;while(0);e=(n|0)<(i-(f[q>>2]|0)|0);if(!m){if(!e){r=0;return r|0}f[c>>2]=k;f[d>>2]=i;m=f[c>>2]|0;q=f[a>>2]|0;n=q;h=m;do if(b[m+38>>0]|0){p=f[m+56>>2]|0;if(!p){s=(f[m+20>>2]|0)+80|0;break}else{s=p+40|0;break}}else s=(f[m+48>>2]|0)+20|0;while(0);m=h-(f[s>>2]|0)|0;do if(b[q+38>>0]|0){s=f[q+56>>2]|0;if(!s){t=(f[q+20>>2]|0)+80|0;break}else{t=s+40|0;break}}else t=(f[q+48>>2]|0)+20|0;while(0);if((m|0)>=(n-(f[t>>2]|0)|0)){r=1;return r|0}f[a>>2]=h;f[c>>2]=n;r=2;return r|0}if(e){f[a>>2]=k;f[d>>2]=j;r=1;return r|0}f[a>>2]=i;f[c>>2]=j;i=f[d>>2]|0;a=i;do if(b[i+38>>0]|0){k=f[i+56>>2]|0;if(!k){u=(f[i+20>>2]|0)+80|0;break}else{u=k+40|0;break}}else u=(f[i+48>>2]|0)+20|0;while(0);i=a-(f[u>>2]|0)|0;do if(!l){u=f[g+56>>2]|0;if(!u){v=(f[g+20>>2]|0)+80|0;break}else{v=u+40|0;break}}else v=(f[g+48>>2]|0)+20|0;while(0);if((i|0)>=(j-(f[v>>2]|0)|0)){r=1;return r|0}f[c>>2]=a;f[d>>2]=j;r=2;return r|0}function zpc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=ypc(a,c,d)|0;h=f[e>>2]|0;i=f[d>>2]|0;j=i;k=h;do if(b[h+38>>0]|0){l=f[h+56>>2]|0;if(!l){m=(f[h+20>>2]|0)+80|0;break}else{m=l+40|0;break}}else m=(f[h+48>>2]|0)+20|0;while(0);h=k-(f[m>>2]|0)|0;do if(b[i+38>>0]|0){m=f[i+56>>2]|0;if(!m){n=(f[i+20>>2]|0)+80|0;break}else{n=m+40|0;break}}else n=(f[i+48>>2]|0)+20|0;while(0);if((h|0)>=(j-(f[n>>2]|0)|0)){o=g;return o|0}f[d>>2]=k;f[e>>2]=j;j=g+1|0;e=f[d>>2]|0;k=f[c>>2]|0;n=k;h=e;do if(b[e+38>>0]|0){i=f[e+56>>2]|0;if(!i){p=(f[e+20>>2]|0)+80|0;break}else{p=i+40|0;break}}else p=(f[e+48>>2]|0)+20|0;while(0);e=h-(f[p>>2]|0)|0;do if(b[k+38>>0]|0){p=f[k+56>>2]|0;if(!p){q=(f[k+20>>2]|0)+80|0;break}else{q=p+40|0;break}}else q=(f[k+48>>2]|0)+20|0;while(0);if((e|0)>=(n-(f[q>>2]|0)|0)){o=j;return o|0}f[c>>2]=h;f[d>>2]=n;n=g+2|0;d=f[c>>2]|0;h=f[a>>2]|0;j=h;q=d;do if(b[d+38>>0]|0){e=f[d+56>>2]|0;if(!e){r=(f[d+20>>2]|0)+80|0;break}else{r=e+40|0;break}}else r=(f[d+48>>2]|0)+20|0;while(0);d=q-(f[r>>2]|0)|0;do if(b[h+38>>0]|0){r=f[h+56>>2]|0;if(!r){s=(f[h+20>>2]|0)+80|0;break}else{s=r+40|0;break}}else s=(f[h+48>>2]|0)+20|0;while(0);if((d|0)>=(j-(f[s>>2]|0)|0)){o=n;return o|0}f[a>>2]=q;f[c>>2]=j;o=g+3|0;return o|0}function Apc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=zpc(a,c,d,e)|0;i=f[g>>2]|0;j=f[e>>2]|0;k=j;l=i;do if(b[i+38>>0]|0){m=f[i+56>>2]|0;if(!m){n=(f[i+20>>2]|0)+80|0;break}else{n=m+40|0;break}}else n=(f[i+48>>2]|0)+20|0;while(0);i=l-(f[n>>2]|0)|0;do if(b[j+38>>0]|0){n=f[j+56>>2]|0;if(!n){o=(f[j+20>>2]|0)+80|0;break}else{o=n+40|0;break}}else o=(f[j+48>>2]|0)+20|0;while(0);if((i|0)>=(k-(f[o>>2]|0)|0)){p=h;return p|0}f[e>>2]=l;f[g>>2]=k;k=h+1|0;g=f[e>>2]|0;l=f[d>>2]|0;o=l;i=g;do if(b[g+38>>0]|0){j=f[g+56>>2]|0;if(!j){q=(f[g+20>>2]|0)+80|0;break}else{q=j+40|0;break}}else q=(f[g+48>>2]|0)+20|0;while(0);g=i-(f[q>>2]|0)|0;do if(b[l+38>>0]|0){q=f[l+56>>2]|0;if(!q){r=(f[l+20>>2]|0)+80|0;break}else{r=q+40|0;break}}else r=(f[l+48>>2]|0)+20|0;while(0);if((g|0)>=(o-(f[r>>2]|0)|0)){p=k;return p|0}f[d>>2]=i;f[e>>2]=o;o=h+2|0;e=f[d>>2]|0;i=f[c>>2]|0;k=i;r=e;do if(b[e+38>>0]|0){g=f[e+56>>2]|0;if(!g){s=(f[e+20>>2]|0)+80|0;break}else{s=g+40|0;break}}else s=(f[e+48>>2]|0)+20|0;while(0);e=r-(f[s>>2]|0)|0;do if(b[i+38>>0]|0){s=f[i+56>>2]|0;if(!s){t=(f[i+20>>2]|0)+80|0;break}else{t=s+40|0;break}}else t=(f[i+48>>2]|0)+20|0;while(0);if((e|0)>=(k-(f[t>>2]|0)|0)){p=o;return p|0}f[c>>2]=r;f[d>>2]=k;k=h+3|0;d=f[c>>2]|0;r=f[a>>2]|0;o=r;t=d;do if(b[d+38>>0]|0){e=f[d+56>>2]|0;if(!e){u=(f[d+20>>2]|0)+80|0;break}else{u=e+40|0;break}}else u=(f[d+48>>2]|0)+20|0;while(0);d=t-(f[u>>2]|0)|0;do if(b[r+38>>0]|0){u=f[r+56>>2]|0;if(!u){v=(f[r+20>>2]|0)+80|0;break}else{v=u+40|0;break}}else v=(f[r+48>>2]|0)+20|0;while(0);if((d|0)>=(o-(f[v>>2]|0)|0)){p=k;return p|0}f[a>>2]=t;f[c>>2]=o;p=h+4|0;return p|0}function Bpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;switch(c-a>>2|0){case 2:{d=c+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;i=e;do if(b[e+38>>0]|0){j=f[e+56>>2]|0;if(!j){k=(f[e+20>>2]|0)+80|0;break}else{k=j+40|0;break}}else k=(f[e+48>>2]|0)+20|0;while(0);e=i-(f[k>>2]|0)|0;do if(b[g+38>>0]|0){k=f[g+56>>2]|0;if(!k){l=(f[g+20>>2]|0)+80|0;break}else{l=k+40|0;break}}else l=(f[g+48>>2]|0)+20|0;while(0);if((e|0)>=(h-(f[l>>2]|0)|0)){m=1;return m|0}f[a>>2]=i;f[d>>2]=h;m=1;return m|0}case 3:{ypc(a,a+4|0,c+-4|0)|0;m=1;return m|0}case 4:{zpc(a,a+4|0,a+8|0,c+-4|0)|0;m=1;return m|0}case 5:{Apc(a,a+4|0,a+8|0,a+12|0,c+-4|0)|0;m=1;return m|0}case 1:case 0:{m=1;return m|0}default:{h=a+8|0;ypc(a,a+4|0,h)|0;d=a+12|0;a:do if((d|0)==(c|0)){n=1;o=0}else{i=d;l=0;e=h;while(1){g=f[i>>2]|0;k=f[e>>2]|0;j=(b[g+38>>0]|0)==0;p=g;do if(!j){q=f[g+56>>2]|0;if(!q){r=(f[g+20>>2]|0)+80|0;break}else{r=q+40|0;break}}else r=(f[g+48>>2]|0)+20|0;while(0);q=p-(f[r>>2]|0)|0;do if(b[k+38>>0]|0){s=f[k+56>>2]|0;t=k;if(!s){u=t-(f[(f[k+20>>2]|0)+80>>2]|0)|0;break}else{u=t-(f[s+40>>2]|0)|0;break}}else u=k-(f[(f[k+48>>2]|0)+20>>2]|0)|0;while(0);if((q|0)<(u|0)){k=g+48|0;s=g+56|0;t=g+20|0;v=e;w=i;while(1){f[w>>2]=f[v>>2];if((v|0)==(a|0))break;x=v+-4|0;y=f[x>>2]|0;do if(!j){z=f[s>>2]|0;if(!z){A=(f[t>>2]|0)+80|0;break}else{A=z+40|0;break}}else A=(f[k>>2]|0)+20|0;while(0);z=p-(f[A>>2]|0)|0;do if(b[y+38>>0]|0){B=f[y+56>>2]|0;C=y;if(!B){D=C-(f[(f[y+20>>2]|0)+80>>2]|0)|0;break}else{D=C-(f[B+40>>2]|0)|0;break}}else D=y-(f[(f[y+48>>2]|0)+20>>2]|0)|0;while(0);if((z|0)<(D|0)){y=v;v=x;w=y}else break}f[v>>2]=p;w=l+1|0;if((w|0)==8){n=0;o=(i+4|0)==(c|0);break a}else E=w}else E=l;w=i+4|0;if((w|0)==(c|0)){n=1;o=0;break}else{k=i;i=w;l=E;e=k}}}while(0);m=o|n;return m|0}}return 0}function Cpc(a){a=a|0;var c=0,d=0;f[a>>2]=172716;if(b[a+17>>0]|0)return;c=f[a+12>>2]|0;if((c|0)<=0)return;d=f[a+4>>2]|0;mi[f[(f[d>>2]|0)+12>>2]&2047](d,c);return}function Dpc(a){a=a|0;var c=0,d=0;f[a>>2]=172716;if(b[a+17>>0]|0){cYc(a);return}c=f[a+12>>2]|0;if((c|0)<=0){cYc(a);return}d=f[a+4>>2]|0;mi[f[(f[d>>2]|0)+12>>2]&2047](d,c);cYc(a);return}function Epc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;if((f[a+20>>2]|0)<=0){Fpc(a,c,d);if(!d)return;if((b[c+(d+-1)>>0]|0)!=10)return;b[a+16>>0]=1;return}if(!d)e=0;else{g=a+16|0;h=0;i=0;while(1){j=i;i=i+1|0;if((b[c+j>>0]|0)==10){Fpc(a,c+h|0,1-h+j|0);b[g>>0]=1;k=i}else k=h;if((i|0)==(d|0)){e=k;break}else h=k}}Fpc(a,c+e|0,d-e|0);return}function Fpc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e;h=a+17|0;if((d|0)==0|(b[h>>0]|0)!=0){u=e;return}i=a+16|0;if(b[i>>0]|0?(b[i>>0]=0,i=f[a+20>>2]|0,i|0):0){j=i<<1;i=a+12|0;k=f[i>>2]|0;l=a+8|0;m=f[l>>2]|0;a:do if((j|0)>(k|0)){n=a+4|0;o=j;p=m;q=k;while(1){g1c(p|0,32,q|0)|0;r=f[i>>2]|0;s=f[n>>2]|0;t=hj[f[(f[s>>2]|0)+8>>2]&511](s,g,i)|0;v=(t^1)&1;b[h>>0]=v;if(!t)break;t=o-r|0;r=f[g>>2]|0;f[l>>2]=r;q=f[i>>2]|0;s=r;if((t|0)<=(q|0)){w=t;x=s;y=9;break a}else{o=t;p=s}}z=v}else{w=j;x=m;y=9}while(0);if((y|0)==9){g1c(x|0,32,w|0)|0;f[l>>2]=(f[l>>2]|0)+w;f[i>>2]=(f[i>>2]|0)-w;z=b[h>>0]|0}if(z<<24>>24){u=e;return}}z=a+12|0;w=f[z>>2]|0;i=a+8|0;do if(w>>>0<d>>>0){l=a+4|0;x=d;m=c;j=w;while(1){if((j|0)>0){o1c(f[i>>2]|0,m|0,j|0)|0;v=f[z>>2]|0;A=x-v|0;B=m+v|0}else{A=x;B=m}f[g>>2]=0;v=f[l>>2]|0;k=hj[f[(f[v>>2]|0)+8>>2]&511](v,g,z)|0;b[h>>0]=(k^1)&1;if(!k)break;C=f[g>>2]|0;f[i>>2]=C;j=f[z>>2]|0;if(A>>>0<=j>>>0){y=19;break}else{x=A;m=B}}if((y|0)==19){D=A;E=B;F=C;break}u=e;return}else{D=d;E=c;F=f[i>>2]|0}while(0);o1c(F|0,E|0,D|0)|0;f[i>>2]=(f[i>>2]|0)+D;f[z>>2]=(f[z>>2]|0)-D;u=e;return}function Gpc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=b;e=a+4|0;g=f[e>>2]|0;do if(g){h=a+4|0;i=g;while(1){j=f[i+16>>2]|0;if(j>>>0>b>>>0){k=f[i>>2]|0;if(!k){l=6;break}else{m=i;n=k}}else{if(j>>>0>=b>>>0){l=10;break}o=i+4|0;j=f[o>>2]|0;if(!j){l=9;break}else{m=o;n=j}}h=m;i=n}if((l|0)==6){p=i;q=i;break}else if((l|0)==9){p=i;q=o;break}else if((l|0)==10){p=i;q=h;break}}else{p=e;q=e}while(0);e=f[q>>2]|0;if(!e){l=$Xc(32)|0;f[l+16>>2]=d;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=p;f[q>>2]=l;p=f[f[a>>2]>>2]|0;if(!p)r=l;else{f[a>>2]=p;r=f[q>>2]|0}UQ(f[a+4>>2]|0,r);r=a+8|0;f[r>>2]=(f[r>>2]|0)+1;s=l}else s=e;e=s+24|0;l=f[e>>2]|0;if((l|0)==(f[s+28>>2]|0)){Hpc(s+20|0,c);return}else{s=c;c=f[s+4>>2]|0;r=l;f[r>>2]=f[s>>2];f[r+4>>2]=c;f[e>>2]=(f[e>>2]|0)+8;return}}function Hpc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function Ipc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+16|0;d=c;e=b;g=$Xc(24)|0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;f[g>>2]=h;h=g+16|0;f[h>>2]=0;f[g+20>>2]=0;f[g+12>>2]=h;f[d>>2]=g;g=a+12|0;h=a+16|0;i=f[h>>2]|0;do if(i){j=a+16|0;k=i;while(1){l=f[k+16>>2]|0;if(l>>>0>b>>>0){m=f[k>>2]|0;if(!m){n=6;break}else{o=k;p=m}}else{if(l>>>0>=b>>>0){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==6){r=k;s=k;break}else if((n|0)==9){r=k;s=q;break}else if((n|0)==10){r=k;s=j;break}}else{r=h;s=h}while(0);h=f[s>>2]|0;if(!h){n=$Xc(32)|0;f[n+16>>2]=e;f[n+20>>2]=0;f[n+24>>2]=0;f[n+28>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=r;f[s>>2]=n;r=f[f[g>>2]>>2]|0;if(!r)t=n;else{f[g>>2]=r;t=f[s>>2]|0}UQ(f[a+16>>2]|0,t);t=a+20|0;f[t>>2]=(f[t>>2]|0)+1;v=n}else v=h;h=v+24|0;n=f[h>>2]|0;if((n|0)==(f[v+28>>2]|0)){Jpc(v+20|0,d);w=f[d>>2]|0;u=c;return w|0}else{f[n>>2]=f[d>>2];f[h>>2]=(f[h>>2]|0)+4;w=f[d>>2]|0;u=c;return w|0}return 0}function Jpc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function Kpc(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d[a+12>>1]=0;b[a+14>>0]=c&1;c=a+15|0;b[c>>0]=0;b[c+1>>0]=0;b[c+2>>0]=0;b[c+3>>0]=0;return}function Lpc(a){a=a|0;return}function Mpc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+160|0;g=e+152|0;h=e;Yi[f[(f[d>>2]|0)+28>>2]&4095](d);i=b[a+18>>0]|0;mi[f[(f[d>>2]|0)+96>>2]&2047](g,d);j=f[g>>2]|0;g=f[a+4>>2]|0;k=f[a+8>>2]|0;l=b[a+13>>0]|0;m=b[a+14>>0]|0;n=b[a+15>>0]|0;o=b[a+16>>0]|0;p=b[a+17>>0]|0;q=b[a+12>>0]|0;f[h>>2]=f[a>>2];f[h+4>>2]=g;f[h+8>>2]=k;k=h+12|0;f[k>>2]=172736;f[h+16>>2]=h;g=h+20|0;ojc(g,c,k);f[h+132>>2]=j;f[h+136>>2]=(i^1)&255;b[h+140>>0]=l;b[h+141>>0]=m;b[h+142>>0]=n;b[h+143>>0]=o;b[h+144>>0]=q;b[h+145>>0]=0;b[h+120>>0]=1;f[h+124>>2]=1;if(!(p<<24>>24)){wjc(g)|0;r=Npc(a,0,d,h)|0;pjc(g);u=e;return r|0}b[h+128>>0]=0;b[h+129>>0]=1;wjc(g)|0;r=Npc(a,0,d,h)|0;pjc(g);u=e;return r|0}function Npc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+80|0;g=c+40|0;h=c+24|0;i=c+12|0;j=c;k=e+20|0;while(1){if((f[k>>2]|0)==1)break;if(!(Opc(e,d)|0)){l=0;m=24;break}}if((m|0)==24){u=c;return l|0}if(b[e+145>>0]|0){l=0;u=c;return l|0}if(b[a+12>>0]|0){l=1;u=c;return l|0}if(_i[f[(f[d>>2]|0)+32>>2]&2047](d)|0){l=1;u=c;return l|0}f[h>>2]=0;a=h+4|0;f[a>>2]=0;f[h+8>>2]=0;koc(d,h);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=f[h>>2]|0;m=f[a>>2]|0;if((d|0)!=(m|0)){k=g+4|0;n=d;do{if((n|0)!=(d|0))AYc(j,528271)|0;o=b[n+11>>0]|0;p=o<<24>>24<0;f[g>>2]=p?f[n>>2]|0:n;f[k>>2]=p?f[n+4>>2]|0:o&255;xtc(j,g);n=n+12|0}while((n|0)!=(m|0))}m=EYc(j,0,505939)|0;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];f[i+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;Ppc(e,-1,0,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);j=f[h>>2]|0;if(j|0){i=f[a>>2]|0;if((i|0)==(j|0))q=j;else{e=i;while(1){i=e+-12|0;f[a>>2]=i;if((b[i+11>>0]|0)<0){cYc(f[i>>2]|0);r=f[a>>2]|0}else r=i;if((r|0)==(j|0))break;else e=r}q=f[h>>2]|0}cYc(q)}l=0;u=c;return l|0}function Opc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;d=u;u=u+128|0;e=d+104|0;g=d;h=d+68|0;i=d+64|0;j=d+60|0;k=d+48|0;l=d+36|0;m=d+24|0;n=d+80|0;o=d+120|0;p=d+12|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);q=f[e+4>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);r=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=a+20|0;t=a+36|0;v=f[t>>2]|0;w=a+40|0;x=f[w>>2]|0;a:do if(ztc(c,i,j)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;y=a+24|0;z=y+11|0;A=b[z>>0]|0;B=A<<24>>24<0;C=a+28|0;D=A&255;b:do if(((B?f[C>>2]|0:D)|0)==1){A=f[y>>2]|0;c:do if(B){if((b[A>>0]|0)!=(b[e>>0]|0))break b}else{if((A&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break b;E=y;F=D;G=e;while(1){F=F+-1|0;E=E+1|0;if(!F)break c;G=G+1|0;if((b[E>>0]|0)!=(b[G>>0]|0))break b}}while(0);wjc(s)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(Qpc(a,g,k)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;A=e+11|0;b[A>>0]=1;b[e>>0]=93;b[e+1>>0]=0;G=Rpc(a,e)|0;if((b[A>>0]|0)<0)cYc(f[e>>2]|0);if(G){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;G=b[z>>0]|0;A=G<<24>>24<0;E=G&255;d:do if(((A?f[C>>2]|0:E)|0)==1){G=f[y>>2]|0;e:do if(A){if((b[G>>0]|0)!=(b[e>>0]|0))break d}else{if((G&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break d;F=y;H=E;I=e;while(1){H=H+-1|0;F=F+1|0;if(!H)break e;I=I+1|0;if((b[F>>0]|0)!=(b[I>>0]|0))break d}}while(0);wjc(s)|0}while(0);E=f[(f[c>>2]|0)+96>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;mi[E&2047](e,c);f:do if(Spc(a,g,f[(f[(f[e>>2]|0)+8>>2]|0)+8>>2]|0,l)|0){do if((f[a+136>>2]|0)==1){E=f[i>>2]|0;if(!((f[E+32>>2]|0)!=3?hj[f[(f[q>>2]|0)+20>>2]&511](q,c,E)|0:0))J=27;if((J|0)==27){E=f[j>>2]|0;if((f[E+32>>2]|0)==3)break;if(!(hj[f[(f[q>>2]|0)+20>>2]&511](q,c,E)|0))break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=$Xc(48)|0;f[e>>2]=E;f[e+8>>2]=-2147483600;f[e+4>>2]=42;A=E;G=506002;I=A+42|0;do{b[A>>0]=b[G>>0]|0;A=A+1|0;G=G+1|0}while((A|0)<(I|0));b[E+42>>0]=0;Ppc(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);K=0;break f}while(0);G=f[(f[q>>2]|0)+144>>2]|0;A=f[i>>2]|0;nBb(e,k,g);ei[G&511](q,c,A,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);ei[f[(f[q>>2]|0)+144>>2]&511](q,c,f[j>>2]|0,l);K=1}else K=0;while(0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);L=K}else L=0}else L=0;if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);M=L;break a}while(0);N=y;O=z;P=C;J=43}else{D=a+24|0;N=D;O=D+11|0;P=a+28|0;J=43}while(0);g:do if((J|0)==43){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;L=b[O>>0]|0;K=L<<24>>24<0;j=L&255;h:do if(((K?f[P>>2]|0:j)|0)==1){L=f[a+24>>2]|0;i:do if(K){if((b[L>>0]|0)!=(b[e>>0]|0)){J=77;break h}}else{if((L&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=77;break h}i=N;D=j;B=e;while(1){D=D+-1|0;i=i+1|0;if(!D)break i;B=B+1|0;if((b[i>>0]|0)!=(b[B>>0]|0)){J=77;break h}}}while(0);wjc(s)|0;if(!(Tpc(a,h)|0)){M=0;break g};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;L=e+11|0;b[L>>0]=1;b[e>>0]=93;b[e+1>>0]=0;B=Rpc(a,e)|0;if((b[L>>0]|0)<0)cYc(f[e>>2]|0);if(!B){M=0;break g}B=f[a+4>>2]|0;if(!B)Q=Mi[f[(f[q>>2]|0)+308>>2]&1023](q,h)|0;else Q=hj[f[(f[B>>2]|0)+8>>2]&511](B,c,h)|0;if(!Q)if(!(b[a+141>>0]|0)){SGa(l,506045,h);B=AYc(l,506057)|0;f[k>>2]=f[B>>2];f[k+4>>2]=f[B+4>>2];f[k+8>>2]=f[B+8>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;B=f[r+4>>2]|0;L=b[B+11>>0]|0;i=L<<24>>24<0;D=zYc(k,i?f[B>>2]|0:B,i?f[B+4>>2]|0:L&255)|0;f[g>>2]=f[D>>2];f[g+4>>2]=f[D+4>>2];f[g+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=AYc(g,506102)|0;f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;Ppc(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);M=0;break g}else{SGa(l,506045,h);D=AYc(l,506057)|0;f[k>>2]=f[D>>2];f[k+4>>2]=f[D+4>>2];f[k+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=f[r+4>>2]|0;L=b[D+11>>0]|0;B=L<<24>>24<0;i=zYc(k,B?f[D>>2]|0:D,B?f[D+4>>2]|0:L&255)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=AYc(g,506102)|0;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;Upc(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);R=0;J=133;break}else S=Q}else J=77;while(0);j:do if((J|0)==77){if(!(Vpc(a,h)|0)){M=0;break g}do if((b[a+143>>0]|0)!=0?utc(h,g)|0:0){j=(B3b(r,f[g>>2]|0)|0)==0;K=f[g>>2]|0;if(!j){T=0;U=Mi[f[(f[q>>2]|0)+312>>2]&1023](q,K)|0;J=119;break}if(!(C3b(r,K)|0)){T=0;U=s3b(r,f[g>>2]|0)|0;J=119}else V=1}else J=84;while(0);k:do if((J|0)==84){K=w3b(r,h)|0;if(!K){lYc(k,h);j=k+11|0;C=b[j>>0]|0;z=C<<24>>24<0;y=f[k>>2]|0;i=z?y+(f[k+4>>2]|0)|0:k+(C&255)|0;C=z?y:k;if((C|0)!=(i|0)){y=C;do{C=b[y>>0]|0;if((C+-65&255)<26)b[y>>0]=(C&255)+32;y=y+1|0}while((y|0)!=(i|0))}i=w3b(r,k)|0;if(!i)W=0;else{y=f[i+24>>2]|0;if(y|0?(f[y>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=i;J_b(y,e)}W=(f[i+28>>2]|0)==10?i:0}if((b[j>>0]|0)<0)cYc(f[k>>2]|0);if(!W)J=110;else{X=W;J=97}}else{X=K;J=97}l:do if((J|0)==97){i=f[X+24>>2]|0;if(i|0?(f[i>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=X;J_b(i,e)}if((f[X+28>>2]|0)==10){i=F3b(X)|0;y=f[i>>2]|0;i=b[y+11>>0]|0;C=i<<24>>24<0;z=i&255;i=C?f[y+4>>2]|0:z;L=b[h+11>>0]|0;D=L<<24>>24<0;if((i|0)==((D?f[h+4>>2]|0:L&255)|0)){L=f[y>>2]|0;B=C?L:y;A=D?f[h>>2]|0:h;D=(i|0)==0;if(C){if(D){Y=X;break}if(!(WKc(B,A,i)|0)){Y=X;break}else{J=110;break}}if(!D)if((L&255)<<24>>24==(b[A>>0]|0)){L=y;y=z;z=A;while(1){y=y+-1|0;L=L+1|0;if(!y)break;z=z+1|0;if((b[L>>0]|0)!=(b[z>>0]|0)){J=110;break l}}if(X)Y=X;else J=110}else J=110;else Y=X}else J=110}else Y=X}while(0);do if((J|0)==110){if(b[a+140>>0]|0){lYc(e,h);K=e+11|0;j=b[K>>0]|0;z=j<<24>>24<0;L=f[e>>2]|0;y=z?L+(f[e+4>>2]|0)|0:e+(j&255)|0;j=z?L:e;if((j|0)!=(y|0)){L=j;do{j=b[L>>0]|0;if((j+-65&255)<26)b[L>>0]=(j&255)+32;L=L+1|0}while((L|0)!=(y|0))}y=t3b(r,e)|0;if((b[K>>0]|0)<0)cYc(f[e>>2]|0);if(y|0){Y=y;break}}T=Wpc(r,h)|0;U=0;J=119;break k}while(0);S=Y;break j}while(0);if((J|0)==119){if((U|0)!=0|T)if(!U){R=T;J=133;break}else{S=U;break}if(!(b[a+141>>0]|0)){SGa(m,506105,f[r+4>>2]|0);y=AYc(m,506120)|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];f[l+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;y=b[h+11>>0]|0;L=y<<24>>24<0;j=zYc(l,L?f[h>>2]|0:h,L?f[h+4>>2]|0:y&255)|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];f[k+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;j=AYc(k,506102)|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Ppc(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);M=0;break g}else V=0}R=V;J=133}while(0);if((J|0)==133){if(!(R|(b[a+141>>0]|0)!=0)){u_b(n,3,505570,481);r_b(o,p_b(n,506143)|0);v_b(n)}j=Mi[f[(f[q>>2]|0)+12>>2]&1023](q,c)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;y=b[O>>0]|0;L=y<<24>>24<0;z=y&255;m:do if(((L?f[P>>2]|0:z)|0)==1){y=a+24|0;E=f[y>>2]|0;n:do if(L){if((b[E>>0]|0)!=(b[e>>0]|0)){J=153;break m}}else{if((E&255)<<24>>24==(f[e>>2]&255)<<24>>24){Z=N;_=z;$=e}else{J=153;break m}while(1){_=_+-1|0;Z=Z+1|0;if(!_)break n;$=$+1|0;if((b[Z>>0]|0)!=(b[$>>0]|0)){J=153;break m}}}while(0);wjc(s)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=123;b[g+1>>0]=0;E=b[O>>0]|0;A=E<<24>>24<0;D=E&255;E=((A?f[P>>2]|0:D)|0)==1;o:do if(E){i=f[y>>2]|0;p:do if(A){if((b[i>>0]|0)!=(b[g>>0]|0))break o}else{if((i&255)<<24>>24==(f[g>>2]&255)<<24>>24){aa=N;ba=D;ca=g}else break o;while(1){ba=ba+-1|0;aa=aa+1|0;if(!ba)break p;ca=ca+1|0;if((b[aa>>0]|0)!=(b[ca>>0]|0))break o}}while(0);break m}while(0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=1;b[k>>0]=60;b[k+1>>0]=0;q:do if(E){i=f[y>>2]|0;if(A)if((b[i>>0]|0)==(b[k>>0]|0))break m;else break;if((i&255)<<24>>24==(f[k>>2]&255)<<24>>24){i=N;K=D;B=k;while(1){K=K+-1|0;i=i+1|0;if(!K)break;B=B+1|0;if((b[i>>0]|0)!=(b[B>>0]|0)){J=155;break q}}break m}else J=155}else J=155;while(0);D=f[j>>2]|0;if(!D)da=0;else da=(f[D+4>>2]|0)-(f[D>>2]|0)>>4;D=Cqc(j,da)|0;oYc(Bqc(D,0)|0,h)|0;M=Xpc(a,D)|0;break g}else J=153;while(0);M=Ypc(a,j)|0;break}if((f[a+136>>2]|0)==1){if((f[S+32>>2]|0)!=3?hj[f[(f[q>>2]|0)+20>>2]&511](q,c,S)|0:0){SGa(g,506198,h);z=AYc(g,506219)|0;f[e>>2]=f[z>>2];f[e+4>>2]=f[z+4>>2];f[e+8>>2]=f[z+8>>2];f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;Ppc(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);M=0;break}z=f[S+52>>2]|0;if(z|0?hj[f[(f[q>>2]|0)+32>>2]&511](q,c,z)|0:0){L=hj[f[(f[q>>2]|0)+40>>2]&511](q,c,z)|0;SGa(p,506250,h);D=AYc(p,506258)|0;f[m>>2]=f[D>>2];f[m+4>>2]=f[D+4>>2];f[m+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=f[L>>2]|0;L=b[D+11>>0]|0;A=L<<24>>24<0;y=zYc(m,A?f[D>>2]|0:D,A?f[D+4>>2]|0:L&255)|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];f[l+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;y=AYc(l,506292)|0;f[k>>2]=f[y>>2];f[k+4>>2]=f[y+4>>2];f[k+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;y=f[z>>2]|0;z=b[y+11>>0]|0;L=z<<24>>24<0;D=zYc(k,L?f[y>>2]|0:y,L?f[y+4>>2]|0:z&255)|0;f[g>>2]=f[D>>2];f[g+4>>2]=f[D+4>>2];f[g+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;D=AYc(g,506102)|0;f[e>>2]=f[D>>2];f[e+4>>2]=f[D+4>>2];f[e+8>>2]=f[D+8>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;Ppc(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);M=0;break}}D=S+24|0;z=f[D>>2]|0;if(z|0?(f[z>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=S;J_b(z,e)}z=S+28|0;r:do if((f[165644+(f[z>>2]<<2)>>2]|0)!=10){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;y=e+11|0;b[y>>0]=1;b[e>>0]=58;b[e+1>>0]=0;L=Rpc(a,e)|0;if((b[y>>0]|0)<0)cYc(f[e>>2]|0);if(L)J=206;else{M=0;break g}}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;L=b[O>>0]|0;y=L<<24>>24<0;A=L&255;s:do if(((y?f[P>>2]|0:A)|0)==1){L=f[a+24>>2]|0;t:do if(y){if((b[L>>0]|0)!=(b[e>>0]|0))break s}else{if((L&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break s;E=N;B=A;i=e;while(1){B=B+-1|0;E=E+1|0;if(!B)break t;i=i+1|0;if((b[E>>0]|0)!=(b[i>>0]|0))break s}}while(0);wjc(s)|0;if(!(b[(f[S+68>>2]|0)+55>>0]|0)){J=206;break r}if((f[a+20>>2]|0)!=5){J=206;break r};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(Zpc(a,e)|0){NZb(hh[f[(f[q>>2]|0)+156>>2]&127](q,c,S,0)|0,e)|0;ea=2}else ea=1;if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((ea&3)==2)break r;else{M=0;break g}}while(0);J=206}while(0);u:do if((J|0)==206){if((f[S+32>>2]|0)==3){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;j=b[O>>0]|0;A=j<<24>>24<0;y=j&255;v:do if(((A?f[P>>2]|0:y)|0)==1){j=f[a+24>>2]|0;w:do if(A){if((b[j>>0]|0)!=(b[e>>0]|0))break v}else{if((j&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break v;L=N;i=y;E=e;while(1){i=i+-1|0;L=L+1|0;if(!i)break w;E=E+1|0;if((b[L>>0]|0)!=(b[E>>0]|0))break v}}while(0);wjc(s)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=93;b[e+1>>0]=0;j=b[O>>0]|0;E=j<<24>>24<0;L=j&255;x:do if(((E?f[P>>2]|0:L)|0)==1){j=f[a+24>>2]|0;y:do if(E){if((b[j>>0]|0)!=(b[e>>0]|0))break x}else{if((j&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break x;i=N;B=L;K=e;while(1){B=B+-1|0;i=i+1|0;if(!B)break y;K=K+1|0;if((b[i>>0]|0)!=(b[K>>0]|0))break x}}while(0);wjc(s)|0;break u}while(0);L=e+11|0;E=e+1|0;j=a+24|0;K=e+11|0;i=e+1|0;B=e+4|0;C=e+8|0;G=e+12|0;z:while(1){I=f[D>>2]|0;if(I|0?(f[I>>2]|0)!=2:0){f[e>>2]=80424;f[B>>2]=2231;b[C>>0]=0;f[G>>2]=S;J_b(I,e)}if((f[165644+(f[z>>2]<<2)>>2]|0)==10){if(!(_pc(a,c,q,S)|0)){M=0;break g}}else if(!($pc(a,c,q,S)|0)){M=0;break g};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[L>>0]=1;b[e>>0]=93;b[E>>0]=0;I=b[O>>0]|0;F=I<<24>>24<0;H=I&255;do if(((F?f[P>>2]|0:H)|0)==1){I=f[j>>2]|0;if(F)if((b[I>>0]|0)==(b[e>>0]|0))break z;else break;if((I&255)<<24>>24==(f[e>>2]&255)<<24>>24){I=N;fa=H;ga=e;do{fa=fa+-1|0;I=I+1|0;if(!fa)break z;ga=ga+1|0}while((b[I>>0]|0)==(b[ga>>0]|0))}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[K>>0]=1;b[e>>0]=44;b[i>>0]=0;H=Rpc(a,e)|0;if((b[K>>0]|0)<0)cYc(f[e>>2]|0);if(!H){M=0;break g}}wjc(s)|0;break u}while(0)}y=f[D>>2]|0;if(y|0?(f[y>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=S;J_b(y,e)}if((f[165644+(f[z>>2]<<2)>>2]|0)==10)if(_pc(a,c,q,S)|0)break;else{M=0;break g}else if($pc(a,c,q,S)|0)break;else{M=0;break g}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=59;b[e+1>>0]=0;z=b[O>>0]|0;D=z<<24>>24<0;y=z&255;z=((D?f[P>>2]|0:y)|0)==1;A:do if(z){A=f[a+24>>2]|0;B:do if(D){if((b[A>>0]|0)!=(b[e>>0]|0)){J=254;break A}}else{if((A&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=254;break A}K=N;i=y;j=e;while(1){i=i+-1|0;K=K+1|0;if(!i)break B;j=j+1|0;if((b[K>>0]|0)!=(b[j>>0]|0)){J=254;break A}}}while(0);wjc(s)|0}else J=254;while(0);if((J|0)==254){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=44;b[g+1>>0]=0;C:do if(z){A=f[a+24>>2]|0;D:do if(D){if((b[A>>0]|0)!=(b[g>>0]|0))break C}else{if((A&255)<<24>>24!=(f[g>>2]&255)<<24>>24)break C;j=N;K=y;i=g;while(1){K=K+-1|0;j=j+1|0;if(!K)break D;i=i+1|0;if((b[j>>0]|0)!=(b[i>>0]|0))break C}}while(0);wjc(s)|0}while(0)}if(b[(f[S+68>>2]|0)+54>>0]|0){SGa(g,506321,h);y=AYc(g,505469)|0;f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];f[e+8>>2]=f[y+8>>2];f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;Upc(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}y=f[a+8>>2]|0;if(!y)M=1;else{D=g;f[D>>2]=v;f[D+4>>2]=x;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];Gpc(y,S,e);M=1}}while(0);if((b[h+11>>0]|0)>=0){u=d;return M|0}cYc(f[h>>2]|0);u=d;return M|0}function Ppc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+64|0;h=g+24|0;i=g;b[a+145>>0]=1;j=f[a>>2]|0;if(j|0){ei[f[(f[j>>2]|0)+8>>2]&511](j,c,d,e);u=g;return}if((c|0)>-1){u_b(h,2,505570,288);j=p_b(h,505973)|0;r_b(g+49|0,q_b(p_b(s_b(p_b(s_b(p_b(q_b(j,f[(f[a+132>>2]|0)+4>>2]|0)|0,518985)|0,c+1|0)|0,506e3)|0,d+1|0)|0,518985)|0,e)|0);v_b(h);u=g;return}else{u_b(i,2,505570,293);h=p_b(i,505973)|0;r_b(g+48|0,q_b(p_b(q_b(h,f[(f[a+132>>2]|0)+4>>2]|0)|0,518985)|0,e)|0);v_b(i);u=g;return}}function Qpc(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+96|0;h=g+84|0;i=g+72|0;j=g+60|0;k=g+48|0;l=g+36|0;m=g+24|0;n=g+12|0;o=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;do if(Vpc(a,h)|0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=k+11|0;b[p>>0]=1;b[k>>0]=46;b[k+1>>0]=0;q=Rpc(a,k)|0;if((b[p>>0]|0)<0)cYc(f[k>>2]|0);if(q?Vpc(a,i)|0:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=k+11|0;b[q>>0]=1;b[k>>0]=46;b[k+1>>0]=0;p=Rpc(a,k)|0;if((b[q>>0]|0)<0)cYc(f[k>>2]|0);if(p?Vpc(a,j)|0:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=k+11|0;b[p>>0]=1;b[k>>0]=47;b[k+1>>0]=0;q=Rpc(a,k)|0;if((b[p>>0]|0)<0)cYc(f[k>>2]|0);if(q?Tpc(a,c)|0:0){AN(o,h,528338);q=b[i+11>>0]|0;p=q<<24>>24<0;r=zYc(o,p?f[i>>2]|0:i,p?f[i+4>>2]|0:q&255)|0;f[n>>2]=f[r>>2];f[n+4>>2]=f[r+4>>2];f[n+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=AYc(n,528338)|0;f[m>>2]=f[r>>2];f[m+4>>2]=f[r+4>>2];f[m+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=b[j+11>>0]|0;q=r<<24>>24<0;p=zYc(m,q?f[j>>2]|0:j,q?f[j+4>>2]|0:r&255)|0;f[l>>2]=f[p>>2];f[l+4>>2]=f[p+4>>2];f[l+8>>2]=f[p+8>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;p=AYc(l,528142)|0;r=f[p>>2]|0;q=p+4|0;f[k>>2]=f[q>>2];d[k+4>>1]=d[q+4>>1]|0;b[k+6>>0]=b[q+6>>0]|0;q=b[p+11>>0]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;p=e+11|0;if((b[p>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0}else{b[e>>0]=0;b[p>>0]=0}sYc(e,0);f[e>>2]=r;r=e+4|0;f[r>>2]=f[k>>2];d[r+4>>1]=d[k+4>>1]|0;b[r+6>>0]=b[k+6>>0]|0;b[e+11>>0]=q;f[k>>2]=0;d[k+4>>1]=0;b[k+6>>0]=0;if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);q=dJc(511585)|0;s=b[p>>0]|0;t=f[r>>2]|0;if((q|0)==((s<<24>>24<0?t:s&255)|0)){if(!(LYc(e,0,-1,511585,q)|0)){v=1;break}w=b[p>>0]|0;x=f[r>>2]|0}else{w=s;x=t}t=dJc(511606)|0;if((t|0)==((w<<24>>24<0?x:w&255)|0)?(LYc(e,0,-1,511606,t)|0)==0:0){v=1;break}SGa(l,506908,e);t=AYc(l,505469)|0;f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,k);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);v=0}else v=0}else v=0}else v=0}else v=0;while(0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=g;return v|0}cYc(f[h>>2]|0);u=g;return v|0}function Rpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+48|0;e=d+36|0;g=d+24|0;h=d+12|0;i=d;j=a+20|0;k=a+24|0;l=k+11|0;m=b[l>>0]|0;n=m<<24>>24<0;o=a+28|0;p=m&255;m=n?f[o>>2]|0:p;q=b[c+11>>0]|0;r=q<<24>>24<0;a:do if((m|0)==((r?f[c+4>>2]|0:q&255)|0)){s=f[k>>2]|0;t=n?s:k;v=r?f[c>>2]|0:c;w=(m|0)==0;b:do if(n){if(!w?WKc(t,v,m)|0:0)break a}else if(!w){if((s&255)<<24>>24==(b[v>>0]|0)){x=k;y=p;z=v}else break a;while(1){y=y+-1|0;x=x+1|0;if(!y)break b;z=z+1|0;if((b[x>>0]|0)!=(b[z>>0]|0))break a}}while(0);wjc(j)|0;A=1;u=d;return A|0}while(0);SGa(i,506886,c);c=AYc(i,506897)|0;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[h+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=b[l>>0]|0;l=c<<24>>24<0;j=zYc(h,l?f[k>>2]|0:k,l?f[o>>2]|0:c&255)|0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;j=AYc(g,506102)|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);A=0;u=d;return A|0}function Spc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+80|0;h=g+48|0;i=g+36|0;j=g+24|0;k=g+12|0;l=g;m=o3b(d,c)|0;if(!m){SGa(i,506755,c);d=AYc(i,506777)|0;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[h+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);n=0;u=g;return n|0}rgc(h);d=pgc(h,m)|0;if(d){m=_i[f[(f[d>>2]|0)+12>>2]&2047](d)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;do if(dqc(a,i)|0){lYc(j,i);d=eqc(a,m,j)|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if(d){if(b[a+144>>0]|0){SZb(m,e)|0;o=1;break}if(_i[f[(f[m>>2]|0)+32>>2]&2047](m)|0){RZb(m,e)|0;o=1;break}SGa(l,506810,c);d=AYc(l,506826)|0;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[k+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,k);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);o=0}else o=0}else o=0;while(0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if(!m)p=o;else{Yi[f[(f[m>>2]|0)+4>>2]&4095](m);p=o}}else p=0;ngc(h);n=p;u=g;return n|0}function Tpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;if(!(Vpc(a,c)|0)){g=0;u=d;return g|0}h=e+11|0;i=e+1|0;j=a+20|0;k=a+24|0;l=k+11|0;m=a+28|0;n=e+11|0;o=e+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[h>>0]=1;b[e>>0]=46;b[i>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;a:do if(((q?f[m>>2]|0:r)|0)==1){p=r;s=q;while(1){t=f[k>>2]|0;b:do if(s){if((b[t>>0]|0)!=(b[e>>0]|0))break a}else{if((t&255)<<24>>24==(f[e>>2]&255)<<24>>24){v=k;w=p;x=e}else break a;while(1){w=w+-1|0;v=v+1|0;if(!w)break b;x=x+1|0;if((b[v>>0]|0)!=(b[x>>0]|0))break a}}while(0);wjc(j)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(!(Vpc(a,e)|0))break;AYc(c,528338)|0;t=b[n>>0]|0;y=t<<24>>24<0;zYc(c,y?f[e>>2]|0:e,y?f[o>>2]|0:t&255)|0;if((b[n>>0]|0)<0)cYc(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[h>>0]=1;b[e>>0]=46;b[i>>0]=0;t=b[l>>0]|0;s=t<<24>>24<0;p=t&255;if(((s?f[m>>2]|0:p)|0)!=1)break a}if((b[n>>0]|0)<0)cYc(f[e>>2]|0);g=0;u=d;return g|0}while(0);g=1;u=d;return g|0}function Upc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+64|0;g=e+24|0;h=e;i=f[a>>2]|0;if(i|0){ei[f[(f[i>>2]|0)+12>>2]&511](i,b,c,d);u=e;return}if((b|0)>-1){u_b(g,1,505570,305);i=p_b(g,506726)|0;r_b(e+49|0,q_b(p_b(s_b(p_b(s_b(p_b(q_b(i,f[(f[a+132>>2]|0)+4>>2]|0)|0,518985)|0,b+1|0)|0,506e3)|0,c+1|0)|0,518985)|0,d)|0);v_b(g);u=e;return}else{u_b(h,1,505570,310);g=p_b(h,506726)|0;r_b(e+48|0,q_b(p_b(q_b(g,f[(f[a+132>>2]|0)+4>>2]|0)|0,518985)|0,d)|0);v_b(h);u=e;return}}function Vpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a+20>>2]|0;if((g|0)==2){oYc(c,a+24|0)|0;wjc(a+20|0)|0;h=1;u=d;return h|0}if(!(b[a+143>>0]|0)){if((b[a+141>>0]|0)!=0&(g|0)==3)i=6}else if((g|0)==3)i=6;if((i|0)==6){oYc(c,a+24|0)|0;wjc(a+20|0)|0;h=1;u=d;return h|0}SGa(e,506699,a+24|0);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=0;u=d;return h|0}function Wpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a+80>>2]|0;if((d|0)<=0){e=0;return e|0}g=f[a+48>>2]|0;a=b[c+11>>0]|0;h=a<<24>>24<0;i=a&255;a=h?f[c+4>>2]|0:i;j=h?f[c>>2]|0:c;k=(a|0)==0;if(h){if(k){h=0;while(1){l=f[g+(h<<2)>>2]|0;m=b[l+11>>0]|0;if(!((m<<24>>24<0?f[l+4>>2]|0:m&255)|0)){e=1;n=17;break}h=h+1|0;if((h|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0}else o=0;while(1){h=f[g+(o<<2)>>2]|0;m=b[h+11>>0]|0;l=m<<24>>24<0;if((a|0)==((l?f[h+4>>2]|0:m&255)|0)?(WKc(j,l?f[h>>2]|0:h,a)|0)==0:0){e=1;n=17;break}o=o+1|0;if((o|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0}if(k){k=0;while(1){o=f[g+(k<<2)>>2]|0;j=b[o+11>>0]|0;if(!((j<<24>>24<0?f[o+4>>2]|0:j&255)|0)){e=1;n=17;break}k=k+1|0;if((k|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0}else p=0;a:while(1){k=f[g+(p<<2)>>2]|0;j=b[k+11>>0]|0;o=j<<24>>24<0;b:do if((a|0)==((o?f[k+4>>2]|0:j&255)|0)){h=c;l=i;m=o?f[k>>2]|0:k;while(1){if((b[h>>0]|0)!=(b[m>>0]|0))break b;l=l+-1|0;if(!l){e=1;n=17;break a}else{h=h+1|0;m=m+1|0}}}while(0);p=p+1|0;if((p|0)>=(d|0)){e=0;n=17;break}}if((n|0)==17)return e|0;return 0}function Xpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+32|0;e=d+12|0;g=d;h=a+20|0;if((f[h>>2]|0)==5){i=a+20|0;do wjc(i)|0;while((f[h>>2]|0)==5);j=1;u=d;return j|0};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;i=a+20|0;k=a+24|0;l=k+11|0;m=b[l>>0]|0;n=m<<24>>24<0;o=a+28|0;p=m&255;a:do if(((n?f[o>>2]|0:p)|0)==1){m=f[k>>2]|0;b:do if(n){if((b[m>>0]|0)!=(b[e>>0]|0))break a}else{if((m&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break a;q=k;r=p;s=e;while(1){r=r+-1|0;q=q+1|0;if(!r)break b;s=s+1|0;if((b[q>>0]|0)!=(b[s>>0]|0))break a}}while(0);wjc(i)|0;m=e+11|0;s=e+1|0;q=e+11|0;r=e+1|0;t=e+11|0;v=e+1|0;w=g+11|0;x=g+1|0;c:while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[m>>0]=1;b[e>>0]=123;b[s>>0]=0;y=b[l>>0]|0;z=y<<24>>24<0;A=y&255;y=((z?f[o>>2]|0:A)|0)==1;d:do if(y){B=f[k>>2]|0;e:do if(z)if((b[B>>0]|0)==(b[e>>0]|0))C=24;else C=18;else if((B&255)<<24>>24==(f[e>>2]&255)<<24>>24){D=k;E=A;F=e;while(1){E=E+-1|0;D=D+1|0;if(!E){C=24;break e}F=F+1|0;if((b[D>>0]|0)!=(b[F>>0]|0)){C=18;break}}}else C=18;while(0);do if((C|0)==18){C=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[w>>0]=1;b[g>>0]=60;b[x>>0]=0;if(!y){C=26;break d}B=f[k>>2]|0;if(z)if((b[B>>0]|0)==(b[g>>0]|0))break;else{C=28;break d}if((B&255)<<24>>24==(f[g>>2]&255)<<24>>24){G=k;H=A;I=g}else{C=26;break d}while(1){H=H+-1|0;G=G+1|0;if(!H)break;I=I+1|0;if((b[G>>0]|0)!=(b[I>>0]|0)){C=26;break d}}}else if((C|0)==24)C=0;while(0);if(!(Ypc(a,c)|0)){j=0;C=72;break c}}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[w>>0]=1;b[g>>0]=60;b[x>>0]=0;C=26}while(0);if((C|0)==26){C=0;C=28}if((C|0)==28?(C=0,!(Xpc(a,c)|0)):0){j=0;C=72;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[q>>0]=1;b[e>>0]=93;b[r>>0]=0;A=b[l>>0]|0;z=A<<24>>24<0;y=A&255;do if(((z?f[o>>2]|0:y)|0)==1){A=f[k>>2]|0;if(z)if((b[A>>0]|0)==(b[e>>0]|0)){C=36;break c}else break;if((A&255)<<24>>24==(f[e>>2]&255)<<24>>24){A=k;B=y;F=e;do{B=B+-1|0;A=A+1|0;if(!B){C=36;break c}F=F+1|0}while((b[A>>0]|0)==(b[F>>0]|0))}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[t>>0]=1;b[e>>0]=44;b[v>>0]=0;y=Rpc(a,e)|0;if((b[t>>0]|0)<0)cYc(f[e>>2]|0);if(!y){j=0;C=72;break}}if((C|0)==36){wjc(i)|0;j=1;u=d;return j|0}else if((C|0)==72){u=d;return j|0}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=45;b[e+1>>0]=0;I=b[l>>0]|0;l=I<<24>>24<0;G=I&255;f:do if(((l?f[o>>2]|0:G)|0)==1){I=f[k>>2]|0;g:do if(l){if((b[I>>0]|0)!=(b[e>>0]|0)){J=0;break f}}else{if((I&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=0;break f}H=k;p=G;n=e;while(1){p=p+-1|0;H=H+1|0;if(!p)break g;n=n+1|0;if((b[H>>0]|0)!=(b[n>>0]|0)){J=0;break f}}}while(0);wjc(i)|0;J=1}else J=0;while(0);G=f[h>>2]|0;if((G+-2|0)>>>0>=3){j=0;u=d;return j|0}if(J&(G|0)==2){lYc(e,k);G=e+11|0;J=b[G>>0]|0;h=J<<24>>24<0;l=f[e>>2]|0;o=e+4|0;I=f[o>>2]|0;n=h?l+I|0:e+(J&255)|0;H=h?l:e;if((H|0)==(n|0)){K=J;L=I}else{I=H;do{H=b[I>>0]|0;if((H+-65&255)<26)b[I>>0]=(H&255)+32;I=I+1|0}while((I|0)!=(n|0));K=b[G>>0]|0;L=f[o>>2]|0}if(((K<<24>>24<0?L:K&255)|0)==3){if(LYc(e,0,-1,524109,3)|0){M=b[G>>0]|0;N=f[o>>2]|0;C=58}}else{M=K;N=L;C=58}do if((C|0)==58){if(((M<<24>>24<0?N:M&255)|0)==8){if(!(LYc(e,0,-1,524252,8)|0))break;O=b[G>>0]|0;P=f[o>>2]|0}else{O=M;P=N}if(((O<<24>>24<0?P:O&255)|0)==3?(LYc(e,0,-1,524261,3)|0)==0:0)break;SGa(g,506676,e);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[G>>0]|0)<0)cYc(f[e>>2]|0);j=0;u=d;return j|0}while(0);if((b[G>>0]|0)<0)cYc(f[e>>2]|0)}oYc(Bqc(c,1)|0,k)|0;wjc(i)|0;j=1;u=d;return j|0}function Ypc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a:do if(dqc(a,e)|0){i=g+11|0;j=g+1|0;k=a+24|0;l=k+11|0;m=a+28|0;n=h+11|0;o=h+1|0;b:while(1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[i>>0]=1;b[g>>0]=62;b[j>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;p=((q?f[m>>2]|0:r)|0)==1;do if(p){s=f[k>>2]|0;if(q){if((b[s>>0]|0)==(b[g>>0]|0)){t=15;break b}}else if((s&255)<<24>>24==(f[g>>2]&255)<<24>>24){s=k;v=r;w=g;do{v=v+-1|0;s=s+1|0;if(!v){t=15;break b}w=w+1|0}while((b[s>>0]|0)==(b[w>>0]|0))};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;if(p){w=f[k>>2]|0;if(q)if((b[w>>0]|0)==(b[h>>0]|0))break b;else break;if((w&255)<<24>>24==(f[h>>2]&255)<<24>>24){w=k;s=r;v=h;while(1){s=s+-1|0;w=w+1|0;if(!s){t=13;break b}v=v+1|0;if((b[w>>0]|0)!=(b[v>>0]|0)){t=17;break}}}else t=17}else t=17}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;t=17}while(0);if((t|0)==17)t=0;if(!(fqc(a,c)|0)){x=0;break a}}x=Rpc(a,e)|0}else x=0;while(0);if((b[e+11>>0]|0)>=0){u=d;return x|0}cYc(f[e>>2]|0);u=d;return x|0}function Zpc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+20|0;if((f[g>>2]|0)!=5){SGa(e,506653,a+24|0);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);h=0;u=d;return h|0}e=c+11|0;if((b[e>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[e>>0]=0}if((f[g>>2]|0)!=5){h=1;u=d;return h|0}e=a+20|0;i=a+24|0;do{zjc(i,c);wjc(e)|0}while((f[g>>2]|0)==5);h=1;u=d;return h|0}function _pc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;k=a+8|0;l=f[k>>2]|0;if(l|0){m=Ipc(l,e)|0;f[k>>2]=m};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;do if(dqc(a,h)|0){m=f[d>>2]|0;if((f[e+32>>2]|0)==3){n=hh[f[m+300>>2]&127](d,c,e,0)|0;lYc(i,h);o=eqc(a,n,i)|0;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if(!o){p=0;break}}else{o=hh[f[m+156>>2]&127](d,c,e,0)|0;lYc(j,h);m=eqc(a,o,j)|0;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if(!m){p=0;break}}f[k>>2]=l;p=1}else p=0;while(0);if((b[h+11>>0]|0)>=0){u=g;return p|0}cYc(f[h>>2]|0);u=g;return p|0}function $pc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+96|0;h=g;i=g+52|0;j=g+40|0;k=g+28|0;l=g+16|0;m=g+64|0;n=g+88|0;o=f[e+24>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=e;J_b(o,h)}a:do switch(f[165644+(f[e+28>>2]<<2)>>2]|0){case 1:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;o=a+20|0;q=a+24|0;r=b[q+11>>0]|0;s=r<<24>>24<0;t=r&255;b:do if(((s?f[a+28>>2]|0:t)|0)==1){r=f[q>>2]|0;c:do if(s){if((b[r>>0]|0)!=45){v=0;break b}}else{if((r&255)<<24>>24!=(f[h>>2]&255)<<24>>24){v=0;break b}w=q;x=t;y=h;while(1){x=x+-1|0;w=w+1|0;if(!x)break c;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){v=0;break b}}}while(0);wjc(o)|0;v=1}else v=0;while(0);if(!(aqc(a,h,v?-2147483648:2147483647,v?0:0)|0)){z=0;u=g;return z|0}o=h;t=f[o>>2]|0;q=f[o+4>>2]|0;o=(t|0)==0&(q|0)==-2147483648;s=c1c(0,0,t|0,q|0)|0;q=v?(o?0:s):t;t=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[t+260>>2]&511](d,c,e,q);break a}else{ei[f[t+116>>2]&511](d,c,e,q);break a}break}case 3:{if(!(aqc(a,h,-1,0)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;t=f[h>>2]|0;if((f[e+32>>2]|0)==3)ei[f[q+268>>2]&511](d,c,e,t);else ei[f[q+124>>2]&511](d,c,e,t);break}case 2:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;t=a+20|0;q=a+24|0;s=b[q+11>>0]|0;o=s<<24>>24<0;r=s&255;d:do if(((o?f[a+28>>2]|0:r)|0)==1){s=f[q>>2]|0;e:do if(o){if((b[s>>0]|0)!=45){A=0;break d}}else{if((s&255)<<24>>24!=(f[h>>2]&255)<<24>>24){A=0;break d}y=q;w=r;x=h;while(1){w=w+-1|0;y=y+1|0;if(!w)break e;x=x+1|0;if((b[y>>0]|0)!=(b[x>>0]|0)){A=0;break d}}}while(0);wjc(t)|0;A=1}else A=0;while(0);if(!(aqc(a,h,A?0:-1,A?-2147483648:2147483647)|0)){z=0;u=g;return z|0}t=h;r=f[t>>2]|0;q=f[t+4>>2]|0;t=(r|0)==0&(q|0)==-2147483648;o=c1c(0,0,r|0,q|0)|0;s=A?(t?0:o):r;r=A?(t?-2147483648:J):q;q=f[d>>2]|0;if((f[e+32>>2]|0)==3){gi[f[q+264>>2]&255](d,c,e,s,r);break a}else{gi[f[q+120>>2]&255](d,c,e,s,r);break a}break}case 4:{if(!(aqc(a,h,-1,-1)|0)){z=0;u=g;return z|0}r=f[d>>2]|0;s=h;q=f[s>>2]|0;t=f[s+4>>2]|0;if((f[e+32>>2]|0)==3)gi[f[r+272>>2]&255](d,c,e,q,t);else gi[f[r+128>>2]&255](d,c,e,q,t);break}case 6:{if(!(bqc(a,h)|0)){z=0;u=g;return z|0}t=f[d>>2]|0;B=+p[h>>3];if((f[e+32>>2]|0)==3){q=f[t+276>>2]|0;C=+mjc(B);$h[q&63](d,c,e,C)}else{q=f[t+132>>2]|0;C=+mjc(B);$h[q&63](d,c,e,C)}break}case 5:{if(!(bqc(a,h)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;C=+p[h>>3];if((f[e+32>>2]|0)==3)$h[f[q+280>>2]&63](d,c,e,C);else $h[f[q+136>>2]&63](d,c,e,C);break}case 9:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(!(Zpc(a,h)|0)){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);z=0;u=g;return z|0}q=f[d>>2]|0;if((f[e+32>>2]|0)==3)ei[f[q+288>>2]&511](d,c,e,h);else ei[f[q+144>>2]&511](d,c,e,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);break}case 7:{if((f[a+20>>2]|0)==3){if(!(aqc(a,h,1,0)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;t=h;r=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0;if((f[e+32>>2]|0)==3)ei[f[q+284>>2]&511](d,c,e,r);else ei[f[q+140>>2]&511](d,c,e,r);break a};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=Vpc(a,h)|0;q=h+11|0;t=b[q>>0]|0;s=t<<24>>24<0;if(!r){if(s)cYc(f[h>>2]|0);z=0;u=g;return z|0}r=h+4|0;o=f[r>>2]|0;if(((s?o:t&255)|0)==4)if(!(LYc(h,0,-1,529255,4)|0))D=72;else{E=b[q>>0]|0;F=f[r>>2]|0;D=66}else{E=t;F=o;D=66}do if((D|0)==66){if(((E<<24>>24<0?F:E&255)|0)==4){if(!(LYc(h,0,-1,506361,4)|0)){D=72;break}G=b[q>>0]|0;H=f[r>>2]|0}else{G=E;H=F}if(((G<<24>>24<0?H:G&255)|0)==1){if(!(LYc(h,0,-1,506366,1)|0)){D=72;break}I=b[q>>0]|0;K=f[r>>2]|0}else{I=G;K=H}if(((I<<24>>24<0?K:I&255)|0)==5){if(LYc(h,0,-1,529249,5)|0){L=b[q>>0]|0;M=f[r>>2]|0;D=78}}else{L=I;M=K;D=78}do if((D|0)==78){if(((L<<24>>24<0?M:L&255)|0)==5){if(!(LYc(h,0,-1,506368,5)|0))break;N=b[q>>0]|0;O=f[r>>2]|0}else{N=L;O=M}if(((N<<24>>24<0?O:N&255)|0)==1?(LYc(h,0,-1,506374,1)|0)==0:0)break;SGa(l,506376,f[e>>2]|0);o=AYc(l,506410)|0;f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;o=b[q>>0]|0;t=o<<24>>24<0;s=zYc(k,t?f[h>>2]|0:h,t?f[r>>2]|0:o&255)|0;f[j>>2]=f[s>>2];f[j+4>>2]=f[s+4>>2];f[j+8>>2]=f[s+8>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;s=AYc(j,506102)|0;f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[i+8>>2]=f[s+8>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[q>>0]|0)<0)cYc(f[h>>2]|0);z=0;u=g;return z|0}while(0);s=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[s+284>>2]&511](d,c,e,0);break}else{ei[f[s+140>>2]&511](d,c,e,0);break}}while(0);do if((D|0)==72){r=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[r+284>>2]&511](d,c,e,1);break}else{ei[f[r+140>>2]&511](d,c,e,1);break}}while(0);if((b[q>>0]|0)<0)cYc(f[h>>2]|0);break}case 8:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;r=G3b(e)|0;s=f[a+20>>2]|0;do if((s|0)==2)if(Vpc(a,i)|0){P=x3b(r,i)|0;D=129}else{Q=1;R=0}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;o=a+24|0;t=b[o+11>>0]|0;x=t<<24>>24<0;y=t&255;t=((x?f[a+28>>2]|0:y)|0)==1;f:do if(t){w=f[o>>2]|0;g:do if(x){if((b[w>>0]|0)!=(b[h>>0]|0)){D=110;break f}}else{if((w&255)<<24>>24!=(f[h>>2]&255)<<24>>24){D=110;break f}S=o;T=y;U=h;while(1){T=T+-1|0;S=S+1|0;if(!T)break g;U=U+1|0;if((b[S>>0]|0)!=(b[U>>0]|0)){D=110;break f}}}while(0)}else D=110;while(0);if((D|0)==110?(s|0)!=3:0){SGa(h,506422,o);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);Q=1;R=0;break};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;w=a+20|0;h:do if(t){U=f[o>>2]|0;i:do if(x){if((b[U>>0]|0)!=45){V=0;break h}}else{if((U&255)<<24>>24!=(f[h>>2]&255)<<24>>24){V=0;break h}S=o;T=y;W=h;while(1){T=T+-1|0;S=S+1|0;if(!T)break i;W=W+1|0;if((b[S>>0]|0)!=(b[W>>0]|0)){V=0;break h}}}while(0);wjc(w)|0;V=1}else V=0;while(0);if(!(aqc(a,h,V?-2147483648:2147483647,V?0:0)|0)){Q=1;R=0;break}w=h;y=f[w>>2]|0;o=f[w+4>>2]|0;w=(y|0)==0&(o|0)==-2147483648;x=c1c(0,0,y|0,o|0)|0;t=V?(w?0:x):y;otc(h,t,V?(w?-2147483648:J):o);o=i+11|0;if((b[o>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[o>>0]=0}sYc(i,0);f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];P=y3b(r,t)|0;D=129}while(0);do if((D|0)==129){if(P|0){r=f[d>>2]|0;if((f[e+32>>2]|0)==3){ei[f[r+292>>2]&511](d,c,e,P);Q=2;R=0;break}else{ei[f[r+148>>2]&511](d,c,e,P);Q=2;R=0;break}}if(!(b[a+142>>0]|0)){SGa(l,506460,i);r=AYc(l,506491)|0;f[k>>2]=f[r>>2];f[k+4>>2]=f[r+4>>2];f[k+8>>2]=f[r+8>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;r=f[e>>2]|0;s=b[r+11>>0]|0;q=s<<24>>24<0;t=zYc(k,q?f[r>>2]|0:r,q?f[r+4>>2]|0:s&255)|0;f[j>>2]=f[t>>2];f[j+4>>2]=f[t+4>>2];f[j+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;t=AYc(j,506102)|0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];f[h+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);Q=1;R=0;break}else{SGa(l,506460,i);t=AYc(l,506491)|0;f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;t=f[e>>2]|0;s=b[t+11>>0]|0;r=s<<24>>24<0;q=zYc(k,r?f[t>>2]|0:t,r?f[t+4>>2]|0:s&255)|0;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2];f[j+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;q=AYc(j,506102)|0;f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];f[h+8>>2]=f[q+8>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;Upc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);Q=1;R=1;break}}while(0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((Q|0)==1){z=R;u=g;return z|0}break}case 10:{u_b(m,3,505570,770);r_b(n,p_b(m,506505)|0);v_b(m);break}default:{}}while(0);z=1;u=g;return z|0}function aqc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+12|0;i=g;if((f[a+20>>2]|0)!=3){SGa(h,506573,a+24|0);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);j=0;u=g;return j|0}k=a+24|0;if(xjc(k,d,e,c)|0){wjc(a+20|0)|0;j=1;u=g;return j|0}SGa(i,506628,k);k=AYc(i,528047)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);j=0;u=g;return j|0}function bqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0;d=u;u=u+32|0;e=d;g=d+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=45;b[e+1>>0]=0;h=a+20|0;i=a+24|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=j&255;a:do if(((k?f[a+28>>2]|0:l)|0)==1){j=f[i>>2]|0;b:do if(k){if((b[j>>0]|0)!=(b[e>>0]|0)){m=0;break a}}else{if((j&255)<<24>>24!=(f[e>>2]&255)<<24>>24){m=0;break a}n=i;o=l;q=e;while(1){o=o+-1|0;n=n+1|0;if(!o)break b;q=q+1|0;if((b[n>>0]|0)!=(b[q>>0]|0)){m=0;break a}}}while(0);wjc(h)|0;m=1}else m=0;while(0);c:do switch(f[a+20>>2]|0){case 3:{if(cqc(a,e,-1,-1)|0){l=e;p[c>>3]=+((f[l>>2]|0)>>>0)+4294967296.0*+((f[l+4>>2]|0)>>>0);break c}r=0;u=d;return r|0}case 4:{s=+yjc(i);p[c>>3]=s;wjc(h)|0;break}case 2:{lYc(e,i);l=e+11|0;k=b[l>>0]|0;j=k<<24>>24<0;q=f[e>>2]|0;n=e+4|0;o=f[n>>2]|0;t=j?q+o|0:e+(k&255)|0;v=j?q:e;if((v|0)==(t|0)){w=k;x=o}else{o=v;do{v=b[o>>0]|0;if((v+-65&255)<26)b[o>>0]=(v&255)+32;o=o+1|0}while((o|0)!=(t|0));w=b[l>>0]|0;x=f[n>>2]|0}if(((w<<24>>24<0?x:w&255)|0)==3)if(!(LYc(e,0,-1,524109,3)|0))y=25;else{z=b[l>>0]|0;A=f[n>>2]|0;y=22}else{z=w;A=x;y=22}do if((y|0)==22){if(((z<<24>>24<0?A:z&255)|0)==8){if(!(LYc(e,0,-1,524252,8)|0)){y=25;break}B=b[l>>0]|0;E=f[n>>2]|0}else{B=z;E=A}if(((B<<24>>24<0?E:B&255)|0)==3?(LYc(e,0,-1,524261,3)|0)==0:0){p[c>>3]=C;wjc(h)|0;break}SGa(g,506550,e);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[l>>0]|0)<0)cYc(f[e>>2]|0);r=0;u=d;return r|0}while(0);if((y|0)==25){p[c>>3]=D;wjc(h)|0}if((b[l>>0]|0)<0)cYc(f[e>>2]|0);break}default:{SGa(e,506550,i);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);r=0;u=d;return r|0}}while(0);if(!m){r=1;u=d;return r|0}p[c>>3]=-+p[c>>3];r=1;u=d;return r|0}function cqc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+32|0;h=g+12|0;i=g;if((f[a+20>>2]|0)!=3){SGa(h,506573,a+24|0);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);j=0;u=g;return j|0}k=a+20|0;l=a+24|0;m=b[l+11>>0]|0;n=m<<24>>24<0;do if((n?f[a+28>>2]|0:m&255)>>>0>1){o=n?f[l>>2]|0:l;if(!((b[o>>0]|0)==48?(b[o+1>>0]|32)<<24>>24==120:0)){o=n?f[l>>2]|0:l;if((b[o>>0]|0)!=48)break;if((b[o+1>>0]&-8)<<24>>24!=48)break}SGa(h,506597,l);Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);j=0;u=g;return j|0}while(0);if(xjc(l,d,e,c)|0){wjc(k)|0;j=1;u=g;return j|0}SGa(i,506628,l);l=AYc(i,528047)|0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Ppc(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);j=0;u=g;return j|0}function dqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=60;b[e+1>>0]=0;g=a+20|0;h=a+24|0;i=b[h+11>>0]|0;j=i<<24>>24<0;k=i&255;a:do if(((j?f[a+28>>2]|0:k)|0)==1){i=f[h>>2]|0;b:do if(j){if((b[i>>0]|0)!=(b[e>>0]|0))break a}else{if((i&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break a;l=h;m=k;n=e;while(1){m=m+-1|0;l=l+1|0;if(!m)break b;n=n+1|0;if((b[l>>0]|0)!=(b[n>>0]|0))break a}}while(0);wjc(g)|0;tYc(c,528085)|0;o=1;u=d;return o|0}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=1;b[e>>0]=123;b[e+1>>0]=0;k=Rpc(a,e)|0;if((b[g>>0]|0)<0)cYc(f[e>>2]|0);if(!k){o=0;u=d;return o|0}tYc(c,506651)|0;o=1;u=d;return o|0}function eqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e+12|0;h=e;i=g+11|0;j=g+1|0;k=a+24|0;l=k+11|0;m=a+28|0;n=h+11|0;o=h+1|0;a:while(1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[i>>0]=1;b[g>>0]=62;b[j>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;p=((q?f[m>>2]|0:r)|0)==1;do if(p){s=f[k>>2]|0;if(q){if((b[s>>0]|0)==(b[g>>0]|0)){t=14;break a}}else if((s&255)<<24>>24==(f[g>>2]&255)<<24>>24){s=k;v=r;w=g;do{v=v+-1|0;s=s+1|0;if(!v){t=14;break a}w=w+1|0}while((b[s>>0]|0)==(b[w>>0]|0))};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;if(p){w=f[k>>2]|0;if(q)if((b[w>>0]|0)==(b[h>>0]|0))break a;else break;if((w&255)<<24>>24==(f[h>>2]&255)<<24>>24){w=k;s=r;v=h;while(1){s=s+-1|0;w=w+1|0;if(!s){t=12;break a}v=v+1|0;if((b[w>>0]|0)!=(b[v>>0]|0)){t=16;break}}}else t=16}else t=16}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;t=16}while(0);if((t|0)==16)t=0;if(!(Opc(a,c)|0)){x=0;t=20;break}}if((t|0)!=12)if((t|0)!=14)if((t|0)==20){u=e;return x|0}x=Rpc(a,d)|0;u=e;return x|0}function fqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+48|0;e=d+36|0;g=d+24|0;h=d+12|0;i=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=91;b[g+1>>0]=0;j=a+20|0;k=a+24|0;l=k+11|0;m=b[l>>0]|0;n=m<<24>>24<0;o=a+28|0;p=m&255;a:do if(((n?f[o>>2]|0:p)|0)==1){m=f[k>>2]|0;b:do if(n){if((b[m>>0]|0)!=(b[g>>0]|0)){q=12;break a}}else{if((m&255)<<24>>24!=(f[g>>2]&255)<<24>>24){q=12;break a}r=k;s=p;t=g;while(1){s=s+-1|0;r=r+1|0;if(!s)break b;t=t+1|0;if((b[r>>0]|0)!=(b[t>>0]|0)){q=12;break a}}}while(0);wjc(j)|0;if(Tpc(a,e)|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;m=g+11|0;b[m>>0]=1;b[g>>0]=93;b[g+1>>0]=0;t=Rpc(a,g)|0;if((b[m>>0]|0)<0)cYc(f[g>>2]|0);if(t)q=13;else v=0}else v=0}else q=12;while(0);if((q|0)==12)if(Vpc(a,e)|0)q=13;else v=0;c:do if((q|0)==13){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=58;b[g+1>>0]=0;p=b[l>>0]|0;n=p<<24>>24<0;t=p&255;d:do if(((n?f[o>>2]|0:t)|0)==1){p=f[k>>2]|0;e:do if(n){if((b[p>>0]|0)!=(b[g>>0]|0)){q=31;break d}}else{if((p&255)<<24>>24==(f[g>>2]&255)<<24>>24){w=k;x=t;y=g}else{q=31;break d}while(1){x=x+-1|0;w=w+1|0;if(!x)break e;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){q=31;break d}}}while(0);wjc(j)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=123;b[h+1>>0]=0;p=b[l>>0]|0;m=p<<24>>24<0;r=p&255;p=((m?f[o>>2]|0:r)|0)==1;f:do if(p){s=f[k>>2]|0;g:do if(m){if((b[s>>0]|0)!=(b[h>>0]|0))break f}else{if((s&255)<<24>>24==(f[h>>2]&255)<<24>>24){z=k;A=r;B=h}else break f;while(1){A=A+-1|0;z=z+1|0;if(!A)break g;B=B+1|0;if((b[z>>0]|0)!=(b[B>>0]|0))break f}}while(0);q=40;break d}while(0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[i+11>>0]=1;b[i>>0]=60;b[i+1>>0]=0;do if(p){s=f[k>>2]|0;if(m)if((b[s>>0]|0)==(b[i>>0]|0)){q=40;break d}else break;if((s&255)<<24>>24==(f[i>>2]&255)<<24>>24){C=k;D=r;E=i}else break;while(1){D=D+-1|0;C=C+1|0;if(!D){q=39;break}E=E+1|0;if((b[C>>0]|0)!=(b[E>>0]|0)){q=35;break}}if((q|0)==35)break;else if((q|0)==39){q=40;break d}}while(0);r=f[c>>2]|0;if(!r)F=0;else F=(f[r+4>>2]|0)-(f[r>>2]|0)>>4;r=Cqc(c,F)|0;oYc(Bqc(r,0)|0,e)|0;if(!(Xpc(a,r)|0)){v=0;break c}}else q=31;while(0);if((q|0)==31)q=40;if((q|0)==40?!(Ypc(a,c)|0):0){v=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=59;b[g+1>>0]=0;t=b[l>>0]|0;n=t<<24>>24<0;r=t&255;t=((n?f[o>>2]|0:r)|0)==1;h:do if(t){m=f[k>>2]|0;i:do if(n){if((b[m>>0]|0)!=(b[g>>0]|0)){q=49;break h}}else{if((m&255)<<24>>24!=(f[g>>2]&255)<<24>>24){q=49;break h}p=k;s=r;G=g;while(1){s=s+-1|0;p=p+1|0;if(!s)break i;G=G+1|0;if((b[p>>0]|0)!=(b[G>>0]|0)){q=49;break h}}}while(0);wjc(j)|0}else q=49;while(0);if((q|0)==49){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=44;b[h+1>>0]=0;j:do if(t){m=f[k>>2]|0;k:do if(n){if((b[m>>0]|0)!=(b[h>>0]|0))break j}else{if((m&255)<<24>>24!=(f[h>>2]&255)<<24>>24)break j;G=k;p=r;s=h;while(1){p=p+-1|0;G=G+1|0;if(!p)break k;s=s+1|0;if((b[G>>0]|0)!=(b[s>>0]|0))break j}}while(0);wjc(j)|0}while(0)}v=1}while(0);if((b[e+11>>0]|0)>=0){u=d;return v|0}cYc(f[e>>2]|0);u=d;return v|0}function gqc(a){a=a|0;cYc(a);return}function hqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ppc(f[a+4>>2]|0,b,c,d);return}function iqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Upc(f[a+4>>2]|0,b,c,d);return}function jqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e;h=b[c+11>>0]|0;i=h<<24>>24<0;FZb(g,i?f[c>>2]|0:c,i?f[c+4>>2]|0:h&255,-1);h=Mpc(a,g,d)|0;u=e;return h|0}function kqc(a,c){a=a|0;c=c|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;d[g+16>>1]=0;b[g+18>>0]=0;h=Mpc(g,a,c)|0;u=e;return h|0}function lqc(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;b=a+24|0;f[b>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a>>2]=0;f[a+4>>2]=0;d[a+8>>1]=0;f[a+28>>2]=a+32;a=$Xc(4)|0;f[a>>2]=172648;f[b>>2]=a;return}function mqc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+28|0;c=f[b>>2]|0;d=a+32|0;if((c|0)!=(d|0)){e=c;while(1){c=f[e+20>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[e+4>>2]|0;if(!c){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=c;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(d|0))break;else e=i}}jpc(b,f[d>>2]|0);f[a+36>>2]=0;f[b>>2]=d;f[d>>2]=0;jpc(b,0);b=f[a+24>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function nqc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+48|0;i=h+40|0;j=h+32|0;k=h;l=g+11|0;if((b[l>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[l>>0]=0}HZb(j,g);g=f[a>>2]|0;f[k>>2]=172716;l=k+4|0;f[l>>2]=j;f[k+8>>2]=0;j=k+12|0;f[j>>2]=0;b[k+16>>0]=1;m=k+17|0;b[m>>0]=0;f[k+20>>2]=g;f[k+24>>2]=g;mi[f[(f[c>>2]|0)+96>>2]&2047](i,c);spc(a,c,f[i+4>>2]|0,d,e,k);f[k>>2]=172716;if(b[m>>0]|0){u=h;return}m=f[j>>2]|0;if((m|0)<=0){u=h;return}j=f[l>>2]|0;mi[f[(f[j>>2]|0)+12>>2]&2047](j,m);u=h;return}function oqc(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+48|0;h=g;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;i=h+24|0;f[i>>2]=0;j=h+28|0;f[h+32>>2]=0;k=h+36|0;f[k>>2]=0;l=h+32|0;f[h>>2]=0;f[h+4>>2]=0;d[h+8>>1]=0;f[j>>2]=l;m=$Xc(4)|0;f[m>>2]=172648;f[i>>2]=m;nqc(h,a,b,c,e);e=f[j>>2]|0;if((e|0)!=(l|0)){c=e;while(1){e=f[c+20>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);e=f[c+4>>2]|0;if(!e){b=c+8|0;a=f[b>>2]|0;if((f[a>>2]|0)==(c|0))n=a;else{a=b;do{b=f[a>>2]|0;a=b+8|0;h=f[a>>2]|0}while((f[h>>2]|0)!=(b|0));n=h}}else{a=e;while(1){h=f[a>>2]|0;if(!h)break;else a=h}n=a}if((n|0)==(l|0))break;else c=n}}jpc(j,f[l>>2]|0);f[k>>2]=0;f[j>>2]=l;f[l>>2]=0;l=f[i>>2]|0;if(!l){u=g;return}Yi[f[(f[l>>2]|0)+4>>2]&4095](l);u=g;return}function pqc(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[223597]|0)==2){d=f[223598]|0;u=a;return d|0}f[c>>2]=165456;f[c+4>>2]=178;b[c+8>>0]=0;J_b(894388,c);a_b(c);d=f[223598]|0;u=a;return d|0}function qqc(){var a=0;a=$Xc(4)|0;f[a>>2]=0;f[223598]=a;l_b(179);return}function rqc(){var a=0;a=f[223598]|0;if(!a)return;if(f[a>>2]|0)sqc(a);cYc(a);return}function sqc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=(f[c+4>>2]|0)-(f[c>>2]|0)>>4;e=c;do{c=d;d=d+-1|0;g=f[e>>2]|0;switch(f[g+(d<<4)+4>>2]|0){case 3:{h=f[g+(d<<4)+8>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}break}case 4:{h=f[g+(d<<4)+8>>2]|0;if(h|0){if(f[h>>2]|0)sqc(h);cYc(h)}break}default:{}}e=f[a>>2]|0}while((c|0)>1);if(!e){f[a>>2]=0;return}d=f[e>>2]|0;if(d|0){c=e+4|0;h=f[c>>2]|0;if((h|0)!=(d|0))f[c>>2]=h+(~((h+-16-d|0)>>>4)<<4);cYc(d)}cYc(e);f[a>>2]=0;return}function tqc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;if(!c)return;d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;if((d|0)<=0)return;d=$Xc(12)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[a>>2]=d;e=0;g=d;while(1){d=(f[f[b>>2]>>2]|0)+(e<<4)|0;h=g+4|0;i=f[h>>2]|0;if((i|0)==(f[g+8>>2]|0))uqc(g,d);else{f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[h>>2]=(f[h>>2]|0)+16}h=f[(f[a>>2]|0)+4>>2]|0;switch(f[h+-12>>2]|0){case 3:{d=$Xc(12)|0;i=h+-8|0;lYc(d,f[i>>2]|0);j=d;k=i;l=10;break}case 4:{i=$Xc(4)|0;f[i>>2]=0;d=h+-8|0;tqc(i,f[d>>2]|0);j=i;k=d;l=10;break}default:{}}if((l|0)==10){l=0;f[k>>2]=j}d=e+1|0;if((d|0)>=(c|0))break;e=d;g=f[a>>2]|0}return}function uqc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;cYc(d);return}function vqc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;if(!c)return;d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;if((d|0)<=0)return;d=f[a>>2]|0;if(!d){e=$Xc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[a>>2]=e;g=0;h=e}else{g=0;h=d}while(1){d=(f[f[b>>2]>>2]|0)+(g<<4)|0;e=h+4|0;i=f[e>>2]|0;if((i|0)==(f[h+8>>2]|0))uqc(h,d);else{f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[e>>2]=(f[e>>2]|0)+16}e=f[(f[a>>2]|0)+4>>2]|0;switch(f[e+-12>>2]|0){case 3:{d=$Xc(12)|0;i=e+-8|0;lYc(d,f[i>>2]|0);j=d;k=i;l=11;break}case 4:{i=$Xc(4)|0;f[i>>2]=0;d=e+-8|0;tqc(i,f[d>>2]|0);j=i;k=d;l=11;break}default:{}}if((l|0)==11){l=0;f[k>>2]=j}d=g+1|0;if((d|0)>=(c|0))break;g=d;h=f[a>>2]|0}return}function wqc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;a:do if((d|0)>0){e=f[a>>2]|0;if(!e){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=0;i=g}else{h=0;i=e}while(1){e=(f[f[b>>2]>>2]|0)+(h<<4)|0;g=i+4|0;j=f[g>>2]|0;if((j|0)==(f[i+8>>2]|0))uqc(i,e);else{f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];f[g>>2]=(f[g>>2]|0)+16}g=f[f[b>>2]>>2]|0;switch(f[g+(h<<4)+4>>2]|0){case 3:{f[g+(h<<4)+8>>2]=0;break}case 4:{f[g+(h<<4)+8>>2]=0;break}default:{}}g=h+1|0;if((g|0)>=(c|0))break a;h=g;i=f[a>>2]|0}}while(0);a=f[b>>2]|0;if(!a){f[b>>2]=0;return}i=f[a>>2]|0;if(i|0){h=a+4|0;c=f[h>>2]|0;if((c|0)!=(i|0))f[h>>2]=c+(~((c+-16-i|0)>>>4)<<4);cYc(i)}cYc(a);f[b>>2]=0;return}function xqc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a>>2]|0;if(!b){c=0;return c|0}d=f[b+4>>2]|0;e=f[b>>2]|0;g=d-e|12;if((d|0)==(e|0)){c=g;return c|0}else{h=0;i=g;j=b}while(1){b=f[j>>2]|0;switch(f[b+(h<<4)+4>>2]|0){case 3:{k=i+12+(VXb(f[b+(h<<4)+8>>2]|0)|0)|0;break}case 4:{k=i+4+(xqc(f[b+(h<<4)+8>>2]|0)|0)|0;break}default:k=i}h=h+1|0;j=f[a>>2]|0;if(h>>>0>=(f[j+4>>2]|0)-(f[j>>2]|0)>>4>>>0){c=k;break}else i=k}return c|0}function yqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;f[g>>2]=b;f[g+4>>2]=0;b=g+8|0;f[b>>2]=c;f[b+4>>2]=d;d=f[a>>2]|0;if(!d){b=$Xc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;h=b}else h=d;d=h+4|0;b=f[d>>2]|0;if((b|0)==(f[h+8>>2]|0)){uqc(h,g);u=e;return}else{f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[d>>2]=(f[d>>2]|0)+16;u=e;return}}function zqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=b;f[e+4>>2]=1;f[e+8>>2]=c;c=f[a>>2]|0;if(!c){b=$Xc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;g=b}else g=c;c=g+4|0;b=f[c>>2]|0;if((b|0)==(f[g+8>>2]|0)){uqc(g,e);u=d;return}else{f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[c>>2]=(f[c>>2]|0)+16;u=d;return}}function Aqc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;f[g>>2]=b;f[g+4>>2]=2;b=g+8|0;f[b>>2]=c;f[b+4>>2]=d;d=f[a>>2]|0;if(!d){b=$Xc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;h=b}else h=d;d=h+4|0;b=f[d>>2]|0;if((b|0)==(f[h+8>>2]|0)){uqc(h,g);u=e;return}else{f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[d>>2]=(f[d>>2]|0)+16;u=e;return}}function Bqc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[d>>2]=b;f[d+4>>2]=3;b=$Xc(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;e=d+8|0;f[e>>2]=b;b=f[a>>2]|0;if(!b){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=g}else h=b;b=h+4|0;g=f[b>>2]|0;if((g|0)==(f[h+8>>2]|0)){uqc(h,d);i=f[e>>2]|0;u=c;return i|0}else{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[b>>2]=(f[b>>2]|0)+16;i=f[e>>2]|0;u=c;return i|0}return 0}function Cqc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[d>>2]=b;f[d+4>>2]=4;b=$Xc(4)|0;f[b>>2]=0;e=d+8|0;f[e>>2]=b;b=f[a>>2]|0;if(!b){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=g}else h=b;b=h+4|0;g=f[b>>2]|0;if((g|0)==(f[h+8>>2]|0)){uqc(h,d);i=f[e>>2]|0;u=c;return i|0}else{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[b>>2]=(f[b>>2]|0)+16;i=f[e>>2]|0;u=c;return i|0}return 0}function Dqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=0;if(Mqc(c,e)|0?(b[c+24>>0]|0)!=0:0){wqc(a,e);g=1}else g=0;if(!(f[e>>2]|0)){u=d;return g|0}sqc(e);u=d;return g|0}function Eqc(a,c){a=a|0;c=c|0;var e=0,g=0;e=u;u=u+64|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=c;c=g+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d[c+12>>1]=0;f[g+28>>2]=2147483647;f[g+32>>2]=0;f[g+36>>2]=2147483647;c=f[41322]|0;f[g+40>>2]=c;f[g+44>>2]=c;b[g+48>>0]=1;f[g+52>>2]=0;f[g+56>>2]=0;MYb(g)|0;if(f[a>>2]|0)sqc(a);c=Dqc(a,g)|0;a=c&(b[g+24>>0]|0)!=0;GYb(g);u=e;return a|0}function Fqc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;FZb(e,b,c,-1);c=Eqc(a,e)|0;u=d;return c|0}function Gqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+8>>2]|0;a=d+11|0;e=b[a>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;e=c+8|0;if((f[e>>2]|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else eZb(c,g);g=b[a>>0]|0;if(g<<24>>24<0){p=f[d>>2]|0;q=f[d+4>>2]|0}else{p=d;q=g&255}if(!(b[c+17>>0]|0)){aZb(c,p,q);return}else{bZb(c,p,q);return}}function Hqc(a){a=a|0;cYc(a);return}function Iqc(a,b,c){a=a|0;b=b|0;c=c|0;return Lqc(b,c,f[a+4>>2]|0)|0}function Jqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[a+4>>2]|0;a=c+4|0;e=c+20|0;while(1){g=f[c>>2]|0;if(g>>>0<(f[a>>2]|0)>>>0){h=b[g>>0]|0;i=h&255;if(h<<24>>24>-1){f[c>>2]=g+1;j=i}else{k=i;l=5}}else{k=0;l=5}if((l|0)==5){l=0;j=ZYb(c,k)|0}f[e>>2]=j;if((j|0)==0|(j&7|0)==4){m=1;l=8;break}if(!(Lqc(c,j,d)|0)){m=0;l=8;break}}if((l|0)==8)return m|0;return 0}function Kqc(a,b,c){a=a|0;b=b|0;c=c|0;yqc(f[a+4>>2]|0,b,c,((c|0)<0)<<31>>31);return}function Lqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;i=c>>>3;if(!i){j=0;u=e;return j|0}switch(c&7){case 0:{c=f[a>>2]|0;if(c>>>0<(f[a+4>>2]|0)>>>0?(k=b[c>>0]|0,k<<24>>24>-1):0){f[a>>2]=c+1;l=k&255;m=0}else{LYb(g,a);k=g;if(!(b[g+8>>0]|0)){j=0;u=e;return j|0}else{l=f[k>>2]|0;m=f[k+4>>2]|0}}if(!d){j=1;u=e;return j|0}yqc(d,i,l,m);j=1;u=e;return j|0}case 1:{m=f[a>>2]|0;if(((f[a+4>>2]|0)-m|0)<=7)if(XYb(a,g)|0)n=12;else o=0;else{l=m;k=l;c=l+4|0;l=h[c>>0]|h[c+1>>0]<<8|h[c+2>>0]<<16|h[c+3>>0]<<24;c=g;f[c>>2]=h[k>>0]|h[k+1>>0]<<8|h[k+2>>0]<<16|h[k+3>>0]<<24;f[c+4>>2]=l;f[a>>2]=m+8;n=12}if((n|0)==12)if(!d)o=1;else{m=g;Aqc(d,i,f[m>>2]|0,f[m+4>>2]|0);o=1}j=o;u=e;return j|0}case 2:{o=f[a>>2]|0;m=a+4|0;if(o>>>0<(f[m>>2]|0)>>>0){l=b[o>>0]|0;c=l&255;if(l<<24>>24>-1){f[a>>2]=o+1;p=c}else{q=c;n=18}}else{q=0;n=18}if((n|0)==18){c=KYb(a,q)|0;q=J;if((q|0)>-1|(q|0)==-1&c>>>0>4294967295)p=c;else{j=0;u=e;return j|0}}do if(!d){if((p|0)<0){j=0;u=e;return j|0}c=f[a>>2]|0;q=(f[m>>2]|0)-c|0;if((q|0)>=(p|0)){f[a>>2]=c+p;break}if(!(SYb(a,p,q)|0)){j=0;u=e;return j|0}}else if(!(UYb(a,Bqc(d,i)|0,p)|0)){j=0;u=e;return j|0}while(0);j=1;u=e;return j|0}case 3:{p=a+40|0;m=f[p>>2]|0;f[p>>2]=m+-1;if((m|0)<=0){j=0;u=e;return j|0}if(!d)r=0;else r=Cqc(d,i)|0;m=a+4|0;q=a+20|0;while(1){c=f[a>>2]|0;if(c>>>0<(f[m>>2]|0)>>>0){o=b[c>>0]|0;l=o&255;if(o<<24>>24>-1){f[a>>2]=c+1;s=l}else{t=l;n=33}}else{t=0;n=33}if((n|0)==33){n=0;s=ZYb(a,t)|0}f[q>>2]=s;if((s|0)==0|(s&7|0)==4)break;if(!(Lqc(a,s,r)|0)){j=0;n=45;break}}if((n|0)==45){u=e;return j|0}r=f[p>>2]|0;if((r|0)<(f[a+44>>2]|0))f[p>>2]=r+1;j=(s|0)==(i<<3|4|0);u=e;return j|0}case 5:{s=f[a>>2]|0;if(((f[a+4>>2]|0)-s|0)<=3)if(WYb(a,g)|0)n=42;else v=0;else{r=s;f[g>>2]=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[a>>2]=s+4;n=42}if((n|0)==42)if(!d)v=1;else{zqc(d,i,f[g>>2]|0);v=1}j=v;u=e;return j|0}default:{j=0;u=e;return j|0}}return 0}function Mqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=a+20|0;while(1){g=f[a>>2]|0;if(g>>>0<(f[d>>2]|0)>>>0){h=b[g>>0]|0;i=h&255;if(h<<24>>24>-1){f[a>>2]=g+1;j=i}else{k=i;l=5}}else{k=0;l=5}if((l|0)==5){l=0;j=ZYb(a,k)|0}f[e>>2]=j;if((j|0)==0|(j&7|0)==4){m=1;l=8;break}if(!(Lqc(a,j,c)|0)){m=0;l=8;break}}if((l|0)==8)return m|0;return 0}function Nqc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=f[a>>2]|0;i=a+4|0;if(h>>>0<(f[i>>2]|0)>>>0){j=b[h>>0]|0;k=j&255;if(j<<24>>24>-1){f[a>>2]=h+1;l=k}else{m=k;n=4}}else{m=0;n=4}if((n|0)==4){k=KYb(a,m)|0;m=J;if((m|0)>-1|(m|0)==-1&k>>>0>4294967295)l=k;else{o=0;return o|0}}k=HYb(a,l)|0;a:do if((PYb(a)|0)>0){l=g+4|0;m=g+8|0;if(!d){while(1){h=f[a>>2]|0;if(h>>>0<(f[i>>2]|0)>>>0){j=b[h>>0]|0;p=j&255;if(j<<24>>24>-1){f[a>>2]=h+1;q=p}else{r=p;n=9}}else{r=0;n=9}if((n|0)==9){n=0;p=KYb(a,r)|0;h=J;if((h|0)>-1|(h|0)==-1&p>>>0>4294967295)q=p;else{o=0;break}}p=f[g>>2]|0;if((p|0)==(f[l>>2]|0)){qHa(g,p+1|0);s=f[g>>2]|0}else s=p;p=f[m>>2]|0;f[g>>2]=s+1;f[p+4+(s<<2)>>2]=q;if((PYb(a)|0)<=0)break a}return o|0}while(1){p=f[a>>2]|0;if(p>>>0<(f[i>>2]|0)>>>0){h=b[p>>0]|0;j=h&255;if(h<<24>>24>-1){f[a>>2]=p+1;t=j}else{u=j;n=17}}else{u=0;n=17}if((n|0)==17){n=0;j=KYb(a,u)|0;p=J;if((p|0)>-1|(p|0)==-1&j>>>0>4294967295)t=j;else{o=0;break}}if(_i[d&2047](t)|0){j=f[g>>2]|0;if((j|0)==(f[l>>2]|0)){qHa(g,j+1|0);v=f[g>>2]|0}else v=j;j=f[m>>2]|0;f[g>>2]=v+1;f[j+4+(v<<2)>>2]=t}else yqc(e,c,t,((t|0)<0)<<31>>31);if((PYb(a)|0)<=0)break a}return o|0}while(0);IYb(a,k);o=1;return o|0}function Oqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=c+8|0;e=c+4|0;g=c+17|0;h=0;while(1){i=f[a>>2]|0;if(!i)j=0;else j=(f[i+4>>2]|0)-(f[i>>2]|0)>>4;if((h|0)>=(j|0))break;k=f[i>>2]|0;i=k+(h<<4)|0;a:do switch(f[k+(h<<4)+4>>2]|0){case 0:{l=f[i>>2]<<3;if((f[d>>2]|0)>4){m=f[e>>2]|0;if(l>>>0>127){n=l;o=m;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=m;s=l}b[r>>0]=s;o=r+1-m|0;f[e>>2]=(f[e>>2]|0)+o;n=(f[d>>2]|0)-o|0;f[d>>2]=n;t=n}else{eZb(c,l);t=f[d>>2]|0}n=k+(h<<4)+8|0;o=f[n>>2]|0;p=f[n+4>>2]|0;if((t|0)<=9){fZb(c,o,p);break a}n=f[e>>2]|0;q=o&255;if(p>>>0>0|(p|0)==0&o>>>0>127){u=n;v=q;w=o;o=p;while(1){b[u>>0]=v|-128;p=w;w=l1c(w|0,o|0,7)|0;x=u+1|0;y=w&255;if(!(o>>>0>0|(o|0)==0&p>>>0>16383)){z=x;A=y;break}else{u=x;v=y;o=J}}}else{z=n;A=q}b[z>>0]=A;o=z+1-n|0;f[e>>2]=(f[e>>2]|0)+o;f[d>>2]=(f[d>>2]|0)-o;break}case 1:{o=f[i>>2]<<3|5;if((f[d>>2]|0)>4){v=f[e>>2]|0;if(o>>>0>127){u=o;w=v;while(1){b[w>>0]=u|128;l=u>>>7;m=w+1|0;if(u>>>0>16383){u=l;w=m}else{B=m;C=l;break}}}else{B=v;C=o}b[B>>0]=C;w=B+1-v|0;f[e>>2]=(f[e>>2]|0)+w;f[d>>2]=(f[d>>2]|0)-w}else eZb(c,o);cZb(c,f[k+(h<<4)+8>>2]|0);break}case 2:{w=f[i>>2]<<3|1;if((f[d>>2]|0)>4){u=f[e>>2]|0;if(w>>>0>127){n=w;q=u;while(1){b[q>>0]=n|128;l=n>>>7;m=q+1|0;if(n>>>0>16383){n=l;q=m}else{D=m;E=l;break}}}else{D=u;E=w}b[D>>0]=E;q=D+1-u|0;f[e>>2]=(f[e>>2]|0)+q;f[d>>2]=(f[d>>2]|0)-q}else eZb(c,w);q=k+(h<<4)+8|0;dZb(c,f[q>>2]|0,f[q+4>>2]|0);break}case 3:{q=f[i>>2]<<3|2;if((f[d>>2]|0)>4){n=f[e>>2]|0;if(q>>>0>127){o=q;v=n;while(1){b[v>>0]=o|128;l=o>>>7;m=v+1|0;if(o>>>0>16383){o=l;v=m}else{F=m;G=l;break}}}else{F=n;G=q}b[F>>0]=G;v=F+1-n|0;f[e>>2]=(f[e>>2]|0)+v;f[d>>2]=(f[d>>2]|0)-v}else eZb(c,q);v=k+(h<<4)+8|0;o=f[v>>2]|0;w=b[o+11>>0]|0;if(w<<24>>24<0)H=f[o+4>>2]|0;else H=w&255;if((f[d>>2]|0)>4){w=f[e>>2]|0;if(H>>>0>127){o=H;u=w;while(1){b[u>>0]=o|128;l=o>>>7;m=u+1|0;if(o>>>0>16383){o=l;u=m}else{I=m;K=l;break}}}else{I=w;K=H}b[I>>0]=K;u=I+1-w|0;f[e>>2]=(f[e>>2]|0)+u;f[d>>2]=(f[d>>2]|0)-u}else eZb(c,H);u=f[v>>2]|0;o=b[u+11>>0]|0;if(o<<24>>24<0){L=f[u>>2]|0;M=f[u+4>>2]|0}else{L=u;M=o&255}if(!(b[g>>0]|0)){aZb(c,L,M);break a}else{bZb(c,L,M);break a}break}case 4:{o=f[i>>2]<<3|3;if((f[d>>2]|0)>4){u=f[e>>2]|0;if(o>>>0>127){q=o;n=u;while(1){b[n>>0]=q|128;l=q>>>7;m=n+1|0;if(q>>>0>16383){q=l;n=m}else{N=m;O=l;break}}}else{N=u;O=o}b[N>>0]=O;n=N+1-u|0;f[e>>2]=(f[e>>2]|0)+n;f[d>>2]=(f[d>>2]|0)-n}else eZb(c,o);Oqc(f[k+(h<<4)+8>>2]|0,c);n=f[i>>2]<<3|4;if((f[d>>2]|0)<=4){eZb(c,n);break a}q=f[e>>2]|0;if(n>>>0>127){v=n;w=q;while(1){b[w>>0]=v|128;l=v>>>7;m=w+1|0;if(v>>>0>16383){v=l;w=m}else{P=m;Q=l;break}}}else{P=q;Q=n}b[P>>0]=Q;w=P+1-q|0;f[e>>2]=(f[e>>2]|0)+w;f[d>>2]=(f[d>>2]|0)-w;break}default:{}}while(0);h=h+1|0}return}function Pqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=c;c=0;while(1){e=f[a>>2]|0;if(!e)g=0;else g=(f[e+4>>2]|0)-(f[e>>2]|0)>>4;if((c|0)>=(g|0))break;h=f[e>>2]|0;e=h+(c<<4)|0;switch(f[h+(c<<4)+4>>2]|0){case 0:{i=h+(c<<4)+8|0;j=f[i>>2]|0;k=f[i+4>>2]|0;i=f[e>>2]<<3;if(i>>>0>127){l=i;m=d;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=d;q=i}b[p>>0]=q;m=p+1|0;l=j&255;if(k>>>0>0|(k|0)==0&j>>>0>127){n=m;o=l;r=j;s=k;while(1){b[n>>0]=o|-128;t=r;r=l1c(r|0,s|0,7)|0;u=n+1|0;v=r&255;if(!(s>>>0>0|(s|0)==0&t>>>0>16383)){w=u;x=v;break}else{n=u;o=v;s=J}}}else{w=m;x=l}b[w>>0]=x;y=w+1|0;break}case 1:{s=f[h+(c<<4)+8>>2]|0;o=f[e>>2]<<3|5;if(o>>>0>127){n=o;r=d;while(1){b[r>>0]=n|128;k=n>>>7;j=r+1|0;if(n>>>0>16383){n=k;r=j}else{z=j;A=k;break}}}else{z=d;A=o}b[z>>0]=A;r=z+1|0;b[r>>0]=s;b[r+1>>0]=s>>8;b[r+2>>0]=s>>16;b[r+3>>0]=s>>24;y=z+5|0;break}case 2:{r=h+(c<<4)+8|0;n=f[r>>2]|0;l=f[r+4>>2]|0;r=f[e>>2]<<3|1;if(r>>>0>127){m=r;k=d;while(1){b[k>>0]=m|128;j=m>>>7;i=k+1|0;if(m>>>0>16383){m=j;k=i}else{B=i;C=j;break}}}else{B=d;C=r}b[B>>0]=C;k=B+1|0;m=k;b[m>>0]=n;b[m+1>>0]=n>>8;b[m+2>>0]=n>>16;b[m+3>>0]=n>>24;m=k+4|0;b[m>>0]=l;b[m+1>>0]=l>>8;b[m+2>>0]=l>>16;b[m+3>>0]=l>>24;y=B+9|0;break}case 3:{m=f[h+(c<<4)+8>>2]|0;k=f[e>>2]<<3|2;if(k>>>0>127){s=k;o=d;while(1){b[o>>0]=s|128;j=s>>>7;i=o+1|0;if(s>>>0>16383){s=j;o=i}else{D=i;E=j;break}}}else{D=d;E=k}b[D>>0]=E;y=gZb(m,D+1|0)|0;break}case 4:{o=f[e>>2]<<3|3;if(o>>>0>127){s=o;l=d;while(1){b[l>>0]=s|128;n=s>>>7;r=l+1|0;if(s>>>0>16383){s=n;l=r}else{F=r;G=n;break}}}else{F=d;G=o}b[F>>0]=G;l=Pqc(f[h+(c<<4)+8>>2]|0,F+1|0)|0;s=f[e>>2]<<3|4;if(s>>>0>127){m=s;k=l;while(1){b[k>>0]=m|128;n=m>>>7;r=k+1|0;if(m>>>0>16383){m=n;k=r}else{H=r;I=n;break}}}else{H=l;I=s}b[H>>0]=I;y=H+1|0;break}default:y=d}d=y;c=c+1|0}return d|0}function Qqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+8|0;e=c+4|0;g=0;while(1){h=f[a>>2]|0;if(!h)i=0;else i=(f[h+4>>2]|0)-(f[h>>2]|0)>>4;if((g|0)>=(i|0))break;j=f[h>>2]|0;h=j+(g<<4)|0;do if((f[j+(g<<4)+4>>2]|0)==3){if((f[d>>2]|0)>4){b[f[e>>2]>>0]=11;f[e>>2]=(f[e>>2]|0)+1;k=(f[d>>2]|0)+-1|0;f[d>>2]=k;l=k}else{eZb(c,11);l=f[d>>2]|0}if((l|0)>4){b[f[e>>2]>>0]=16;f[e>>2]=(f[e>>2]|0)+1;k=(f[d>>2]|0)+-1|0;f[d>>2]=k;m=k}else{eZb(c,16);m=f[d>>2]|0}k=f[h>>2]|0;if((m|0)>4){n=f[e>>2]|0;if(k>>>0>127){o=k;p=n;while(1){b[p>>0]=o|128;q=o>>>7;r=p+1|0;if(o>>>0>16383){o=q;p=r}else{s=r;t=q;break}}}else{s=n;t=k}b[s>>0]=t;p=s+1-n|0;f[e>>2]=(f[e>>2]|0)+p;o=(f[d>>2]|0)-p|0;f[d>>2]=o;u=o}else{eZb(c,k);u=f[d>>2]|0}if((u|0)>4){b[f[e>>2]>>0]=26;f[e>>2]=(f[e>>2]|0)+1;f[d>>2]=(f[d>>2]|0)+-1}else eZb(c,26);Gqc(h,c);if((f[d>>2]|0)>4){b[f[e>>2]>>0]=12;f[e>>2]=(f[e>>2]|0)+1;f[d>>2]=(f[d>>2]|0)+-1;break}else{eZb(c,12);break}}while(0);g=g+1|0}return}function Rqc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a>>2]|0;a=(c|0)==0;d=c+4|0;e=0;g=0;while(1){if(a)h=0;else h=(f[d>>2]|0)-(f[c>>2]|0)>>4;if((g|0)>=(h|0))break;i=f[c>>2]|0;j=i+(g<<4)|0;switch(f[i+(g<<4)+4>>2]|0){case 0:{k=((((($(f[j>>2]<<3|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;l=i+(g<<4)+8|0;m=k+(((((t1c(f[l>>2]|1|0,f[l+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)|0;break}case 1:{m=e+4+((((($(f[j>>2]<<3|5|0)|0)^31)*9|0)+73|0)>>>6)|0;break}case 2:{m=e+8+((((($(f[j>>2]<<3|1|0)|0)^31)*9|0)+73|0)>>>6)|0;break}case 3:{l=((((($(f[j>>2]<<3|3|0)|0)^31)*9|0)+73|0)>>>6)+e|0;k=f[i+(g<<4)+8>>2]|0;n=b[k+11>>0]|0;o=n<<24>>24<0;if(o)p=f[k+4>>2]|0;else p=n&255;q=l+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(o)r=f[k+4>>2]|0;else r=n&255;m=q+r|0;break}case 4:{q=f[j>>2]<<3;m=((((($(q|3|0)|0)^31)*9|0)+73|0)>>>6)+((Rqc(f[i+(g<<4)+8>>2]|0)|0)+e)+((((($(q|5|0)|0)^31)*9|0)+73|0)>>>6)|0;break}default:m=e}e=m;g=g+1|0}return e|0}function Sqc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);g=f[e>>2]|0;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);h=f[e+4>>2]|0;e=a+4|0;i=a+20|0;j=g+16|0;k=a+52|0;if(!g){l=0;while(1){m=f[a>>2]|0;if(m>>>0<(f[e>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>-1){f[a>>2]=m+1;p=o}else{q=o;r=4}}else{q=0;r=4}if((r|0)==4){r=0;p=ZYb(a,q)|0}f[i>>2]=p;if((p|0)==0|(p&7|0)==4){s=1;r=23;break}o=Tqc(p,0,c,a)|0;m=l&o;if(o)l=m;else{s=m;r=23;break}}if((r|0)==23){u=d;return s|0}}else t=0;a:while(1){l=f[a>>2]|0;if(l>>>0<(f[e>>2]|0)>>>0){p=b[l>>0]|0;q=p&255;if(p<<24>>24>-1){f[a>>2]=l+1;v=q}else{w=q;r=11}}else{w=0;r=11}if((r|0)==11){r=0;v=ZYb(a,w)|0}f[i>>2]=v;if((v|0)==0|(v&7|0)==4){s=1;r=23;break}q=v>>>3;l=s3b(g,q)|0;do if(!l){if(B3b(g,q)|0){p=f[k>>2]|0;if(!p)x=Mi[f[(f[h>>2]|0)+312>>2]&1023](h,q)|0;else x=q3b(p,g,q)|0;if(x|0){y=x;r=21;break}}if((v|0)==11?(b[(f[j>>2]|0)+48>>0]|0)!=0:0){p=Uqc(a,c)|0;z=p?2:1;A=p}else{y=0;r=21}}else{y=l;r=21}while(0);if((r|0)==21){r=0;l=Tqc(v,y,c,a)|0;z=(l^1)&1;A=l}l=t&A;switch(z&3){case 2:case 0:{t=l;break}default:{s=l;r=23;break a}}}if((r|0)==23){u=d;return s|0}return 0}function Tqc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;g=u;u=u+16|0;i=g;mi[f[(f[d>>2]|0)+96>>2]&2047](i,d);j=f[i+4>>2]|0;do if(c|0){k=a&7;l=c+24|0;m=f[l>>2]|0;if(m|0?(f[m>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=c;J_b(m,i)}m=c+28|0;if((k|0)!=(f[165568+(f[m>>2]<<2)>>2]|0)){if((f[c+32>>2]|0)!=3)break;o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=c;J_b(o,i)}if(!((k|0)==2?((f[m>>2]|0)+-9|0)>>>0>3:0))break;k=f[e>>2]|0;o=e+4|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;r=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;t=r}else{v=r;w=15}}else{v=0;w=15}if((w|0)==15){r=KYb(e,v)|0;k=J;if((k|0)>-1|(k|0)==-1&r>>>0>4294967295)t=r;else{x=0;u=g;return x|0}}r=HYb(e,t)|0;k=f[l>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=c;J_b(k,i)}a:do switch(f[m>>2]|0){case 5:{if((PYb(e)|0)>0){while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;y=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;z=y}else{A=y;w=51}}else{A=0;w=51}if((w|0)==51){w=0;y=KYb(e,A)|0;k=J;if((k|0)>-1|(k|0)==-1&y>>>0>4294967295)z=y;else{x=0;break}}ei[f[(f[j>>2]|0)+260>>2]&511](j,d,c,z);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 3:{if((PYb(e)|0)>0){y=i+8|0;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;B=q&255;C=0}else{LYb(i,e);q=i;if(!(b[y>>0]|0)){x=0;break}else{B=f[q>>2]|0;C=f[q+4>>2]|0}}gi[f[(f[j>>2]|0)+264>>2]&255](j,d,c,B,C);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 17:{if((PYb(e)|0)>0){while(1){y=f[e>>2]|0;if(y>>>0<(f[o>>2]|0)>>>0){q=b[y>>0]|0;k=q&255;if(q<<24>>24>-1){f[e>>2]=y+1;D=k>>>1^0-(k&1)}else{E=k;w=61}}else{E=0;w=61}if((w|0)==61){w=0;k=KYb(e,E)|0;y=J;if((y|0)>-1|(y|0)==-1&k>>>0>4294967295)D=k>>>1^0-(k&1);else{x=0;break}}ei[f[(f[j>>2]|0)+260>>2]&511](j,d,c,D);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 18:{if((PYb(e)|0)>0){k=i+8|0;while(1){y=f[e>>2]|0;if(y>>>0<(f[o>>2]|0)>>>0?(q=b[y>>0]|0,q<<24>>24>-1):0){F=q&255;f[e>>2]=y+1;y=l1c(F|0,0,1)|0;q=J;G=c1c(0,0,F&1|0,0)|0;H=y^G;I=q^J}else{LYb(i,e);q=i;G=f[q>>2]|0;y=(b[k>>0]|0)==0;F=l1c(G|0,f[q+4>>2]|0,1)|0;q=J;K=c1c(0,0,G&1|0,0)|0;if(y){x=0;break}else{H=F^K;I=q^J}}gi[f[(f[j>>2]|0)+264>>2]&255](j,d,c,H,I);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 13:{if((PYb(e)|0)>0){while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;K=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;L=K}else{M=K;w=71}}else{M=0;w=71}if((w|0)==71){w=0;K=KYb(e,M)|0;k=J;if((k|0)>-1|(k|0)==-1&K>>>0>4294967295)L=K;else{x=0;break}}ei[f[(f[j>>2]|0)+268>>2]&511](j,d,c,L);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 4:{if((PYb(e)|0)>0){K=i+8|0;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;N=q&255;O=0}else{LYb(i,e);q=i;if(!(b[K>>0]|0)){x=0;break}else{N=f[q>>2]|0;O=f[q+4>>2]|0}}gi[f[(f[j>>2]|0)+272>>2]&255](j,d,c,N,O);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 7:{if((PYb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){q=K;k=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;P=k}else{if(!(WYb(e,i)|0))break;P=f[i>>2]|0}ei[f[(f[j>>2]|0)+268>>2]&511](j,d,c,P);if((PYb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 6:{if((PYb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;q=K;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K+4|0;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=F;f[q+4>>2]=K;f[e>>2]=k+8;Q=F;R=K}else{if(!(XYb(e,i)|0))break;K=i;Q=f[K>>2]|0;R=f[K+4>>2]|0}gi[f[(f[j>>2]|0)+272>>2]&255](j,d,c,Q,R);if((PYb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 15:{if((PYb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){F=K;k=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;S=k}else{if(!(WYb(e,i)|0))break;S=f[i>>2]|0}ei[f[(f[j>>2]|0)+260>>2]&511](j,d,c,S);if((PYb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 16:{if((PYb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;F=K;q=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=K+4|0;K=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=i;f[F>>2]=q;f[F+4>>2]=K;f[e>>2]=k+8;T=q;U=K}else{if(!(XYb(e,i)|0))break;K=i;T=f[K>>2]|0;U=f[K+4>>2]|0}gi[f[(f[j>>2]|0)+264>>2]&255](j,d,c,T,U);if((PYb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 2:{if((PYb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){q=K;k=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;V=k}else{if(!(WYb(e,i)|0))break;V=f[i>>2]|0}$h[f[(f[j>>2]|0)+276>>2]&63](j,d,c,(f[s>>2]=V,+n[s>>2]));if((PYb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 1:{if((PYb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;q=K;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K+4|0;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=F;f[q+4>>2]=K;f[e>>2]=k+8;f[s>>2]=F;f[s+4>>2]=K;W=+p[s>>3]}else{if(!(XYb(e,i)|0))break;W=+p[i>>3]}$h[f[(f[j>>2]|0)+280>>2]&63](j,d,c,W);if((PYb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 8:{if((PYb(e)|0)>0){K=i+8|0;while(1){F=f[e>>2]|0;if(F>>>0<(f[o>>2]|0)>>>0?(k=b[F>>0]|0,k<<24>>24>-1):0){f[e>>2]=F+1;X=k<<24>>24!=0}else{LYb(i,e);k=i;if(!(b[K>>0]|0)){x=0;break}else X=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0}ei[f[(f[j>>2]|0)+284>>2]&511](j,d,c,X);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 14:{if((PYb(e)|0)>0){K=a>>>3;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){F=b[k>>0]|0;q=F&255;if(F<<24>>24>-1){f[e>>2]=k+1;Y=q}else{Z=q;w=122}}else{Z=0;w=122}if((w|0)==122){w=0;q=KYb(e,Z)|0;k=J;if((k|0)>-1|(k|0)==-1&q>>>0>4294967295)Y=q;else{x=0;break}}mi[f[(f[d>>2]|0)+96>>2]&2047](i,d);do if((f[(f[(f[i>>2]|0)+8>>2]|0)+44>>2]|0)!=3){q=y3b(G3b(c)|0,Y)|0;if(!q){yqc(Mi[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0,K,Y,((Y|0)<0)<<31>>31);break}else{ei[f[(f[j>>2]|0)+292>>2]&511](j,d,c,q);break}}else ei[f[(f[j>>2]|0)+296>>2]&511](j,d,c,Y);while(0);if((PYb(e)|0)<=0)break a}u=g;return x|0}break}case 12:case 11:case 10:case 9:{x=0;u=g;return x|0}default:{}}while(0);IYb(e,r);x=1;u=g;return x|0}o=f[l>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[i>>2]=80424;f[i+4>>2]=2231;b[i+8>>0]=0;f[i+12>>2]=c;J_b(o,i)}do switch(f[m>>2]|0){case 5:{o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0){K=b[o>>0]|0;q=K&255;if(K<<24>>24>-1){f[e>>2]=o+1;_=q}else{$=q;w=137}}else{$=0;w=137}if((w|0)==137){q=KYb(e,$)|0;o=J;if((o|0)>-1|(o|0)==-1&q>>>0>4294967295)_=q;else{x=0;u=g;return x|0}}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+260>>2]&511](j,d,c,_);x=1;u=g;return x|0}else{ei[f[q+116>>2]&511](j,d,c,_);x=1;u=g;return x|0}break}case 3:{q=f[e>>2]|0;if(q>>>0<(f[e+4>>2]|0)>>>0?(o=b[q>>0]|0,o<<24>>24>-1):0){f[e>>2]=q+1;aa=o&255;ba=0}else{LYb(i,e);o=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else{aa=f[o>>2]|0;ba=f[o+4>>2]|0}}o=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[o+264>>2]&255](j,d,c,aa,ba);x=1;u=g;return x|0}else{gi[f[o+120>>2]&255](j,d,c,aa,ba);x=1;u=g;return x|0}break}case 17:{o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0){q=b[o>>0]|0;K=q&255;if(q<<24>>24>-1){f[e>>2]=o+1;ca=K>>>1^0-(K&1)}else{da=K;w=151}}else{da=0;w=151}if((w|0)==151){K=KYb(e,da)|0;o=J;if((o|0)>-1|(o|0)==-1&K>>>0>4294967295)ca=K>>>1^0-(K&1);else{x=0;u=g;return x|0}}K=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[K+260>>2]&511](j,d,c,ca);x=1;u=g;return x|0}else{ei[f[K+116>>2]&511](j,d,c,ca);x=1;u=g;return x|0}break}case 18:{K=f[e>>2]|0;if(K>>>0<(f[e+4>>2]|0)>>>0?(o=b[K>>0]|0,o<<24>>24>-1):0){q=o&255;f[e>>2]=K+1;K=l1c(q|0,0,1)|0;o=J;k=c1c(0,0,q&1|0,0)|0;ea=K^k;fa=o^J}else{LYb(i,e);o=i;k=f[o>>2]|0;K=(b[i+8>>0]|0)==0;q=l1c(k|0,f[o+4>>2]|0,1)|0;o=J;F=c1c(0,0,k&1|0,0)|0;k=o^J;if(K){x=0;u=g;return x|0}else{ea=q^F;fa=k}}k=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[k+264>>2]&255](j,d,c,ea,fa);x=1;u=g;return x|0}else{gi[f[k+120>>2]&255](j,d,c,ea,fa);x=1;u=g;return x|0}break}case 13:{k=f[e>>2]|0;if(k>>>0<(f[e+4>>2]|0)>>>0){F=b[k>>0]|0;q=F&255;if(F<<24>>24>-1){f[e>>2]=k+1;ga=q}else{ha=q;w=165}}else{ha=0;w=165}if((w|0)==165){q=KYb(e,ha)|0;k=J;if((k|0)>-1|(k|0)==-1&q>>>0>4294967295)ga=q;else{x=0;u=g;return x|0}}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+268>>2]&511](j,d,c,ga);x=1;u=g;return x|0}else{ei[f[q+124>>2]&511](j,d,c,ga);x=1;u=g;return x|0}break}case 4:{q=f[e>>2]|0;if(q>>>0<(f[e+4>>2]|0)>>>0?(k=b[q>>0]|0,k<<24>>24>-1):0){f[e>>2]=q+1;ia=k&255;ja=0}else{LYb(i,e);k=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else{ia=f[k>>2]|0;ja=f[k+4>>2]|0}}k=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[k+272>>2]&255](j,d,c,ia,ja);x=1;u=g;return x|0}else{gi[f[k+128>>2]&255](j,d,c,ia,ja);x=1;u=g;return x|0}break}case 7:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>3){q=k;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=F;f[e>>2]=k+4;ka=F}else{if(WYb(e,i)|0){ka=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3)ei[f[k+268>>2]&511](j,d,c,ka);else ei[f[k+124>>2]&511](j,d,c,ka);x=1;u=g;return x|0}case 6:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>7){F=k;q=F;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=F+4|0;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=K;f[q+4>>2]=F;f[e>>2]=k+8;la=K;ma=F}else{if(XYb(e,i)|0){F=i;la=f[F>>2]|0;ma=f[F+4>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3)gi[f[k+272>>2]&255](j,d,c,la,ma);else gi[f[k+128>>2]&255](j,d,c,la,ma);x=1;u=g;return x|0}case 15:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>3){F=k;K=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;f[i>>2]=K;f[e>>2]=k+4;na=K}else{if(WYb(e,i)|0){na=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[k+260>>2]&511](j,d,c,na);x=1;u=g;return x|0}else{ei[f[k+116>>2]&511](j,d,c,na);x=1;u=g;return x|0}break}case 16:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>7){K=k;F=K;q=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=K+4|0;K=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=i;f[F>>2]=q;f[F+4>>2]=K;f[e>>2]=k+8;oa=q;pa=K}else{if(XYb(e,i)|0){K=i;oa=f[K>>2]|0;pa=f[K+4>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3){gi[f[k+264>>2]&255](j,d,c,oa,pa);x=1;u=g;return x|0}else{gi[f[k+120>>2]&255](j,d,c,oa,pa);x=1;u=g;return x|0}break}case 2:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>3){K=k;q=h[K>>0]|h[K+1>>0]<<8|h[K+2>>0]<<16|h[K+3>>0]<<24;f[i>>2]=q;f[e>>2]=k+4;qa=q}else{if(WYb(e,i)|0){qa=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;ra=(f[s>>2]=qa,+n[s>>2]);if((f[c+32>>2]|0)==3){$h[f[k+276>>2]&63](j,d,c,ra);x=1;u=g;return x|0}else{$h[f[k+132>>2]&63](j,d,c,ra);x=1;u=g;return x|0}break}case 1:{k=f[e>>2]|0;do if(((f[e+4>>2]|0)-k|0)>7){q=k;K=q;F=h[K>>0]|h[K+1>>0]<<8|h[K+2>>0]<<16|h[K+3>>0]<<24;K=q+4|0;q=h[K>>0]|h[K+1>>0]<<8|h[K+2>>0]<<16|h[K+3>>0]<<24;K=i;f[K>>2]=F;f[K+4>>2]=q;f[e>>2]=k+8;f[s>>2]=F;f[s+4>>2]=q;sa=+p[s>>3]}else{if(XYb(e,i)|0){sa=+p[i>>3];break}x=0;u=g;return x|0}while(0);k=f[j>>2]|0;if((f[c+32>>2]|0)==3){$h[f[k+280>>2]&63](j,d,c,sa);x=1;u=g;return x|0}else{$h[f[k+136>>2]&63](j,d,c,sa);x=1;u=g;return x|0}break}case 8:{k=f[e>>2]|0;if(k>>>0<(f[e+4>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;ta=q<<24>>24!=0}else{LYb(i,e);q=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else ta=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+284>>2]&511](j,d,c,ta);x=1;u=g;return x|0}else{ei[f[q+140>>2]&511](j,d,c,ta);x=1;u=g;return x|0}break}case 14:{q=f[e>>2]|0;if(q>>>0<(f[e+4>>2]|0)>>>0){k=b[q>>0]|0;F=k&255;if(k<<24>>24>-1){f[e>>2]=q+1;ua=F}else{va=F;w=230}}else{va=0;w=230}if((w|0)==230){F=KYb(e,va)|0;q=J;if((q|0)>-1|(q|0)==-1&F>>>0>4294967295)ua=F;else{x=0;u=g;return x|0}}mi[f[(f[d>>2]|0)+96>>2]&2047](i,d);if((f[(f[(f[i>>2]|0)+8>>2]|0)+44>>2]|0)==3){F=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[F+296>>2]&511](j,d,c,ua);x=1;u=g;return x|0}else{ei[f[F+152>>2]&511](j,d,c,ua);x=1;u=g;return x|0}}F=y3b(G3b(c)|0,ua)|0;if(!F){yqc(Mi[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0,a>>>3,ua,((ua|0)<0)<<31>>31);x=1;u=g;return x|0}q=f[j>>2]|0;if((f[c+32>>2]|0)==3){ei[f[q+292>>2]&511](j,d,c,F);x=1;u=g;return x|0}else{ei[f[q+148>>2]&511](j,d,c,F);x=1;u=g;return x|0}break}case 9:{F=(f[(f[c+20>>2]|0)+44>>2]|0)==3;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=l$b(e,i)|0;k=i+11|0;K=b[k>>0]|0;o=K<<24>>24<0;if(!q){if(o)cYc(f[i>>2]|0);x=0;u=g;return x|0}q=f[c+4>>2]|0;if((b[q+11>>0]|0)<0)wa=f[q>>2]|0;else wa=q;if(F?!(m$b(o?f[i>>2]|0:i,o?f[i+4>>2]|0:K&255,0,wa)|0):0){if((b[k>>0]|0)<0)cYc(f[i>>2]|0);x=0;u=g;return x|0}K=f[j>>2]|0;if((f[c+32>>2]|0)==3)ei[f[K+288>>2]&511](j,d,c,i);else ei[f[K+144>>2]&511](j,d,c,i);if((b[k>>0]|0)<0)cYc(f[i>>2]|0);x=1;u=g;return x|0}case 12:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(!(l$b(e,i)|0)){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);x=0;u=g;return x|0}k=f[j>>2]|0;if((f[c+32>>2]|0)==3)ei[f[k+288>>2]&511](j,d,c,i);else ei[f[k+144>>2]&511](j,d,c,i);if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);x=1;u=g;return x|0}case 10:{k=f[j>>2]|0;K=f[e+56>>2]|0;if((f[c+32>>2]|0)==3)xa=hh[f[k+300>>2]&127](j,d,c,K)|0;else xa=hh[f[k+156>>2]&127](j,d,c,K)|0;K=a&-8;k=e+40|0;o=f[k>>2]|0;f[k>>2]=o+-1;if((o|0)>0?Mi[f[(f[xa>>2]|0)+44>>2]&1023](xa,e)|0:0){o=f[k>>2]|0;if((o|0)<(f[e+44>>2]|0))f[k>>2]=o+1;if((f[e+20>>2]|0)==(K|4|0)){x=1;u=g;return x|0}}x=0;u=g;return x|0}case 11:{K=f[j>>2]|0;o=f[e+56>>2]|0;if((f[c+32>>2]|0)==3)ya=hh[f[K+300>>2]&127](j,d,c,o)|0;else ya=hh[f[K+156>>2]&127](j,d,c,o)|0;o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0?(K=b[o>>0]|0,K<<24>>24>-1):0){f[e>>2]=o+1;za=K&255;w=275}else w=274;if((w|0)==274?(K=YYb(e)|0,(K|0)>-1):0){za=K;w=275}do if(((w|0)==275?(JYb(i,e,za),(f[i+4>>2]|0)>=0):0)?Mi[f[(f[ya>>2]|0)+44>>2]&1023](ya,e)|0:0){if(OYb(e,f[i>>2]|0)|0)x=1;else break;u=g;return x|0}while(0);x=0;u=g;return x|0}default:{x=1;u=g;return x|0}}while(0)}while(0);x=Lqc(e,a,Mi[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0)|0;u=g;return x|0}function Uqc(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;e=u;u=u+128|0;g=e+104|0;h=e+80|0;i=e+20|0;j=e;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);k=f[g+4>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=a+4|0;m=a+20|0;n=j+8|0;o=j+4|0;p=h+11|0;q=h+4|0;r=g+11|0;s=g+4|0;t=i+4|0;v=i+8|0;w=i+12|0;x=i+28|0;y=i+32|0;z=i+36|0;A=i+40|0;B=i+44|0;C=i+48|0;D=i+52|0;E=i+56|0;F=0;G=0;a:while(1){H=(G|0)==0;b:while(1){if(!H){I=10;break}c:while(1){K=f[a>>2]|0;if(K>>>0<(f[l>>2]|0)>>>0){L=b[K>>0]|0;M=L&255;if(L<<24>>24>-1){f[a>>2]=K+1;N=M}else{O=M;I=6}}else{O=0;I=6}if((I|0)==6){I=0;N=ZYb(a,O)|0}f[m>>2]=N;switch(N|0){case 12:{P=1;break a;break}case 0:{I=42;break a;break}case 16:{break b;break}case 26:{break c;break}default:{}}if(!(Lqc(a,N,0)|0)){I=42;break a}}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=f[a>>2]|0;if(M>>>0<(f[l>>2]|0)>>>0){K=b[M>>0]|0;L=K&255;if(K<<24>>24>-1){f[a>>2]=M+1;Q=L;I=29}else{R=L;I=28}}else{R=0;I=28}if((I|0)==28){I=0;L=KYb(a,R)|0;M=J;if((M|0)>-1|(M|0)==-1&L>>>0>4294967295){Q=L;I=29}else S=1}if((I|0)==29){I=0;if(UYb(a,h,Q)|0){HZb(i,g);_Yb(j,i);if((f[n>>2]|0)>4){L=f[o>>2]|0;if(Q>>>0>127){M=Q;K=L;while(1){b[K>>0]=M|128;T=M>>>7;U=K+1|0;if(M>>>0>16383){M=T;K=U}else{V=U;W=T;break}}}else{V=L;W=Q}b[V>>0]=W;K=V+1-L|0;f[o>>2]=(f[o>>2]|0)+K;f[n>>2]=(f[n>>2]|0)-K}else eZb(j,Q);K=b[p>>0]|0;M=K<<24>>24<0;aZb(j,M?f[h>>2]|0:h,M?f[q>>2]|0:K&255);$Yb(j);S=0}else S=1}if((b[p>>0]|0)<0)cYc(f[h>>2]|0);if(S|0){P=0;break a}}d:do if((I|0)==10)e:while(1){I=0;H=f[a>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){K=b[H>>0]|0;M=K&255;if(K<<24>>24>-1){f[a>>2]=H+1;X=M}else{Y=M;I=13}}else{Y=0;I=13}if((I|0)==13){I=0;X=ZYb(a,Y)|0}f[m>>2]=X;switch(X|0){case 12:{P=1;break a;break}case 0:{I=43;break a;break}case 16:{break d;break}case 26:{if(Vqc(G,F,c,a)|0){I=10;continue e}else{I=43;break a}break}default:if(Lqc(a,X,0)|0){I=10;continue e}else{I=43;break a}}}while(0);L=f[a>>2]|0;if(L>>>0<(f[l>>2]|0)>>>0){M=b[L>>0]|0;H=M&255;if(M<<24>>24>-1){f[a>>2]=L+1;Z=H}else{_=H;I=18}}else{_=0;I=18}if((I|0)==18){I=0;H=KYb(a,_)|0;L=J;if((L|0)>-1|(L|0)==-1&H>>>0>4294967295)Z=H;else{P=0;break}}H=Mi[f[(f[k>>2]|0)+312>>2]&1023](k,Z)|0;L=b[r>>0]|0;M=L<<24>>24<0;K=f[s>>2]|0;T=L&255;if(!((M?K:T)|0)){F=H;G=Z;continue}FZb(h,M?f[g>>2]|0:g,M?K:T,-1);f[i>>2]=0;f[t>>2]=0;f[v>>2]=h;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;d[w+12>>1]=0;f[x>>2]=2147483647;f[y>>2]=0;f[z>>2]=2147483647;T=f[41322]|0;f[A>>2]=T;f[B>>2]=T;b[C>>0]=1;f[D>>2]=0;f[E>>2]=0;MYb(i)|0;if(!(Vqc(Z,H,c,i)|0)){I=41;break}if((b[r>>0]|0)<0){b[f[g>>2]>>0]=0;f[s>>2]=0}else{b[g>>0]=0;b[r>>0]=0}GYb(i);F=H;G=Z}if((I|0)==41){GYb(i);P=0}else if((I|0)==42)P=0;else if((I|0)==43)P=0;if((b[r>>0]|0)>=0){u=e;return P|0}cYc(f[g>>2]|0);u=e;return P|0}function Vqc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;mi[f[(f[d>>2]|0)+96>>2]&2047](h,d);k=f[h+4>>2]|0;if(!c){l=Mi[f[(f[k>>2]|0)+12>>2]&1023](k,d)|0;m=f[e>>2]|0;if(m>>>0<(f[e+4>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>-1){f[e>>2]=m+1;p=o}else{q=o;r=5}}else{q=0;r=5}if((r|0)==5){r=KYb(e,q)|0;q=J;if((q|0)>-1|(q|0)==-1&r>>>0>4294967295)p=r;else{s=0;u=g;return s|0}}s=UYb(e,Bqc(l,a)|0,p)|0;u=g;return s|0}if((f[c+32>>2]|0)!=3){p=f[c+24>>2]|0;if(p|0?(f[p>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=c;J_b(p,h)}if((f[c+28>>2]|0)==11){p=hh[f[(f[k>>2]|0)+156>>2]&127](k,d,c,f[e+56>>2]|0)|0;c=f[e>>2]|0;if(c>>>0<(f[e+4>>2]|0)>>>0?(d=b[c>>0]|0,d<<24>>24>-1):0){f[e>>2]=c+1;t=d&255}else{d=YYb(e)|0;if((d|0)>-1)t=d;else{s=0;u=g;return s|0}}JYb(h,e,t);if((f[h+4>>2]|0)>=0?Mi[f[(f[p>>2]|0)+44>>2]&1023](p,e)|0:0)v=OYb(e,f[h>>2]|0)|0;else v=0;s=v;u=g;return s|0}}u_b(i,2,507135,467);r_b(j,p_b(i,507228)|0);v_b(i);s=0;u=g;return s|0}function Wqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+48|0;g=e+32|0;h=e;i=e+8|0;j=e+44|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);k=f[g>>2]|0;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);l=f[g+4>>2]|0;m=d+12|0;n=d+8|0;o=(f[m>>2]|0)+c-(f[n>>2]|0)|0;f[g>>2]=0;c=g+4|0;f[c>>2]=0;f[g+8>>2]=0;p=k+16|0;a:do if(b[(f[p>>2]|0)+51>>0]|0){q=k+52|0;r=f[q>>2]|0;if((r|0)>0){s=k+20|0;t=g+8|0;v=0;w=0;x=0;y=r;while(1){r=(f[s>>2]|0)+(v*88|0)|0;f[h>>2]=r;if(w>>>0<x>>>0){f[w>>2]=r;f[c>>2]=(f[c>>2]|0)+4;z=y}else{wgc(g,h);z=f[q>>2]|0}r=v+1|0;if((r|0)>=(z|0))break a;v=r;w=f[c>>2]|0;x=f[t>>2]|0;y=z}}}else Ti[f[(f[l>>2]|0)+64>>2]&511](l,a,g);while(0);z=f[g>>2]|0;if((f[c>>2]|0)!=(z|0)){h=0;k=z;do{Xqc(f[k+(h<<2)>>2]|0,a,d);h=h+1|0;k=f[g>>2]|0}while(h>>>0<(f[c>>2]|0)-k>>2>>>0)}k=(b[(f[p>>2]|0)+48>>0]|0)==0;p=Mi[f[(f[l>>2]|0)+8>>2]&1023](l,a)|0;if(k)Oqc(p,d);else Qqc(p,d);if(((f[m>>2]|0)-(f[n>>2]|0)|0)!=(o|0)){u_b(i,3,507135,830);r_b(j,p_b(p_b(i,507281)|0,507342)|0);v_b(i)}i=f[g>>2]|0;if(!i){u=e;return}g=f[c>>2]|0;if((g|0)!=(i|0))f[c>>2]=g+(~((g+-4-i|0)>>>2)<<2);cYc(i);u=e;return}function Xqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;e=u;u=u+64|0;g=e+32|0;h=e;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);i=f[g+4>>2]|0;if(b[a+38>>0]|0?b[(f[(f[a+48>>2]|0)+16>>2]|0)+48>>0]|0:0){j=f[a+24>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=a;J_b(j,g)}if((f[165644+(f[a+28>>2]<<2)>>2]|0)==10?(f[a+32>>2]|0)!=3:0){Yqc(a,c,d);u=e;return}}j=a+24|0;k=f[j>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=a;J_b(k,g)}k=a+28|0;if(((f[k>>2]|0)==11?D3b(a)|0:0)?clc(hj[f[(f[i>>2]|0)+364>>2]&511](i,c,a)|0)|0:0){if(!(b[d+18>>0]|0)){if(!(f[223514]|0))l=33}else if(!(b[d+19>>0]|0))l=33;if((l|0)==33){ei[f[(f[i>>2]|0)+352>>2]&511](g,i,c,a);l=g+4|0;m=h+4|0;o=h+16|0;q=h+8|0;r=g+8|0;t=g+24|0;while(1){ei[f[(f[i>>2]|0)+356>>2]&511](h,i,c,a);v=f[l>>2]|0;w=hj[f[(f[v>>2]|0)+20>>2]&511](v,g,h)|0;v=f[m>>2]|0;mi[f[(f[v>>2]|0)+52>>2]&2047](v,h);if((f[o>>2]|0)==9?(v=f[q>>2]|0,v|0):0){if((b[v+11>>0]|0)<0)cYc(f[v>>2]|0);cYc(v)}if(w)break;_qc(a,r,t,d);w=f[l>>2]|0;mi[f[(f[w>>2]|0)+60>>2]&2047](w,g)}t=f[l>>2]|0;mi[f[(f[t>>2]|0)+52>>2]&2047](t,g);if((f[g+16>>2]|0)==9?(t=f[r>>2]|0,t|0):0){if((b[t+11>>0]|0)<0)cYc(f[t>>2]|0);cYc(t)}u=e;return}Zqc(g,c,i,a);t=f[g>>2]|0;r=g+4|0;if((t|0)==(f[r>>2]|0)){x=t;y=t}else{l=h+4|0;q=t;do{f[h>>2]=0;f[l>>2]=0;_h[f[(f[i>>2]|0)+344>>2]&127](i,c,a,q,h)|0;_qc(a,q,h,d);q=q+16|0}while((q|0)!=(f[r>>2]|0));x=f[g>>2]|0;y=q}if(x|0){if((y|0)==(x|0))z=x;else{q=y;while(1){y=q+-16|0;f[r>>2]=y;if((f[q+-8>>2]|0)==9?(l=f[y>>2]|0,(l|0)!=0):0){if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);cYc(l);A=f[r>>2]|0}else A=y;if((A|0)==(x|0))break;else q=A}z=f[g>>2]|0}cYc(z)}u=e;return}z=a+32|0;do if((f[z>>2]|0)==3){A=hj[f[(f[i>>2]|0)+24>>2]&511](i,c,a)|0;f[h>>2]=0;if((A|0)>1){q=f[j>>2]|0;if(q|0?(f[q>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=a;J_b(q,g)}if((f[k>>2]|0)==11?D3b(a)|0:0){if(!(b[d+18>>0]|0)){if(!(f[223514]|0)){B=A;C=0;D=0;E=h;break}}else if(!(b[d+19>>0]|0)){B=A;C=0;D=0;E=h;break}qpc(g,c,A,i,a);q=f[g>>2]|0;x=f[g+4>>2]|0;f[h>>2]=f[g+8>>2];B=A;C=q;D=x;E=h}else{B=A;C=0;D=0;E=h}}else{B=A;C=0;D=0;E=h}}else{if(!(b[(f[(f[a+48>>2]|0)+16>>2]|0)+51>>0]|0))F=(hj[f[(f[i>>2]|0)+20>>2]&511](i,c,a)|0)&1;else F=1;f[h>>2]=0;B=F;C=0;D=0;E=h}while(0);h=H3b(a)|0;E=(B|0)>0;do if(E&h){F=f[a+40>>2]<<3|2;A=d+8|0;if((f[A>>2]|0)>4){x=d+4|0;q=f[x>>2]|0;if(F>>>0>127){r=F;y=q;while(1){b[y>>0]=r|128;l=r>>>7;t=y+1|0;if(r>>>0>16383){r=l;y=t}else{G=t;H=l;break}}}else{G=q;H=F}b[G>>0]=H;y=G+1-q|0;f[x>>2]=(f[x>>2]|0)+y;f[A>>2]=(f[A>>2]|0)-y}else eZb(d,F);y=$qc(a,c)|0;if((f[A>>2]|0)<=4){eZb(d,y);break}r=d+4|0;l=f[r>>2]|0;if(y>>>0>127){t=y;o=l;while(1){b[o>>0]=t|128;m=t>>>7;w=o+1|0;if(t>>>0>16383){t=m;o=w}else{I=w;K=m;break}}}else{I=l;K=y}b[I>>0]=K;o=I+1-l|0;f[r>>2]=(f[r>>2]|0)+o;f[A>>2]=(f[A>>2]|0)-o}while(0);a:do if(E){I=d+8|0;K=d+4|0;G=a+40|0;H=C;o=(H|0)==(D|0);t=a+20|0;F=a+4|0;x=g+11|0;q=g+11|0;m=g+4|0;w=g+8|0;v=g+12|0;L=0;while(1){M=f[j>>2]|0;if(M|0?(f[M>>2]|0)!=2:0){f[g>>2]=80424;f[m>>2]=2231;b[w>>0]=0;f[v>>2]=a;J_b(M,g)}b:do switch(f[k>>2]|0){case 5:{if((f[z>>2]|0)==3)N=hh[f[(f[i>>2]|0)+168>>2]&127](i,c,a,L)|0;else N=hj[f[(f[i>>2]|0)+68>>2]&511](i,c,a)|0;if(!h){S_b(f[G>>2]|0,N,d);break b}M=((N|0)<0)<<31>>31;if((f[I>>2]|0)<=9){fZb(d,N,M);break b}O=f[K>>2]|0;P=N&255;if(N>>>0>127){Q=O;R=P;S=N;T=M;while(1){b[Q>>0]=R|-128;M=S;S=l1c(S|0,T|0,7)|0;U=Q+1|0;V=S&255;if(!(T>>>0>0|(T|0)==0&M>>>0>16383)){W=U;X=V;break}else{Q=U;R=V;T=J}}}else{W=O;X=P}b[W>>0]=X;T=W+1-O|0;f[K>>2]=(f[K>>2]|0)+T;f[I>>2]=(f[I>>2]|0)-T;break}case 3:{if((f[z>>2]|0)==3){T=hh[f[(f[i>>2]|0)+172>>2]&127](i,c,a,L)|0;Y=J;Z=T}else{T=hj[f[(f[i>>2]|0)+72>>2]&511](i,c,a)|0;Y=J;Z=T}if(!h){T_b(f[G>>2]|0,Z,Y,d);break b}if((f[I>>2]|0)<=9){fZb(d,Z,Y);break b}T=f[K>>2]|0;R=Z&255;if(Y>>>0>0|(Y|0)==0&Z>>>0>127){Q=T;S=R;V=Z;U=Y;while(1){b[Q>>0]=S|-128;M=V;V=l1c(V|0,U|0,7)|0;_=Q+1|0;$=V&255;if(!(U>>>0>0|(U|0)==0&M>>>0>16383)){aa=_;ba=$;break}else{Q=_;S=$;U=J}}}else{aa=T;ba=R}b[aa>>0]=ba;U=aa+1-T|0;f[K>>2]=(f[K>>2]|0)+U;f[I>>2]=(f[I>>2]|0)-U;break}case 17:{if((f[z>>2]|0)==3)ca=hh[f[(f[i>>2]|0)+168>>2]&127](i,c,a,L)|0;else ca=hj[f[(f[i>>2]|0)+68>>2]&511](i,c,a)|0;if(!h){W_b(f[G>>2]|0,ca,d);break b}U=ca<<1^ca>>31;if((f[I>>2]|0)<=4){eZb(d,U);break b}S=f[K>>2]|0;if(U>>>0>127){Q=U;V=S;while(1){b[V>>0]=Q|128;O=Q>>>7;P=V+1|0;if(Q>>>0>16383){Q=O;V=P}else{da=P;ea=O;break}}}else{da=S;ea=U}b[da>>0]=ea;V=da+1-S|0;f[K>>2]=(f[K>>2]|0)+V;f[I>>2]=(f[I>>2]|0)-V;break}case 18:{if((f[z>>2]|0)==3){V=hh[f[(f[i>>2]|0)+172>>2]&127](i,c,a,L)|0;fa=V;ga=J}else{V=hj[f[(f[i>>2]|0)+72>>2]&511](i,c,a)|0;fa=V;ga=J}if(!h){X_b(f[G>>2]|0,fa,ga,d);break b}V=u1c(fa|0,ga|0,1)|0;Q=J;T=k1c(fa|0,ga|0,63)|0;R=V^T;T=Q^J;if((f[I>>2]|0)<=9){fZb(d,R,T);break b}Q=f[K>>2]|0;V=R&255;if(T>>>0>0|(T|0)==0&R>>>0>127){O=Q;P=V;$=R;R=T;while(1){b[O>>0]=P|-128;T=$;$=l1c($|0,R|0,7)|0;_=O+1|0;M=$&255;if(!(R>>>0>0|(R|0)==0&T>>>0>16383)){ha=_;ia=M;break}else{O=_;P=M;R=J}}}else{ha=Q;ia=V}b[ha>>0]=ia;R=ha+1-Q|0;f[K>>2]=(f[K>>2]|0)+R;f[I>>2]=(f[I>>2]|0)-R;break}case 13:{if((f[z>>2]|0)==3)ja=hh[f[(f[i>>2]|0)+176>>2]&127](i,c,a,L)|0;else ja=hj[f[(f[i>>2]|0)+76>>2]&511](i,c,a)|0;if(!h){U_b(f[G>>2]|0,ja,d);break b}if((f[I>>2]|0)<=4){eZb(d,ja);break b}R=f[K>>2]|0;if(ja>>>0>127){P=ja;O=R;while(1){b[O>>0]=P|128;$=P>>>7;S=O+1|0;if(P>>>0>16383){P=$;O=S}else{ka=S;la=$;break}}}else{ka=R;la=ja}b[ka>>0]=la;O=ka+1-R|0;f[K>>2]=(f[K>>2]|0)+O;f[I>>2]=(f[I>>2]|0)-O;break}case 4:{if((f[z>>2]|0)==3){O=hh[f[(f[i>>2]|0)+180>>2]&127](i,c,a,L)|0;ma=J;na=O}else{O=hj[f[(f[i>>2]|0)+80>>2]&511](i,c,a)|0;ma=J;na=O}if(!h){V_b(f[G>>2]|0,na,ma,d);break b}if((f[I>>2]|0)<=9){fZb(d,na,ma);break b}O=f[K>>2]|0;P=na&255;if(ma>>>0>0|(ma|0)==0&na>>>0>127){Q=O;V=P;$=na;S=ma;while(1){b[Q>>0]=V|-128;U=$;$=l1c($|0,S|0,7)|0;M=Q+1|0;_=$&255;if(!(S>>>0>0|(S|0)==0&U>>>0>16383)){oa=M;pa=_;break}else{Q=M;V=_;S=J}}}else{oa=O;pa=P}b[oa>>0]=pa;S=oa+1-O|0;f[K>>2]=(f[K>>2]|0)+S;f[I>>2]=(f[I>>2]|0)-S;break}case 7:{if((f[z>>2]|0)==3)qa=hh[f[(f[i>>2]|0)+176>>2]&127](i,c,a,L)|0;else qa=hj[f[(f[i>>2]|0)+76>>2]&511](i,c,a)|0;if(h){cZb(d,qa);break b}else{Y_b(f[G>>2]|0,qa,d);break b}break}case 6:{if((f[z>>2]|0)==3){S=hh[f[(f[i>>2]|0)+180>>2]&127](i,c,a,L)|0;ra=S;sa=J}else{S=hj[f[(f[i>>2]|0)+80>>2]&511](i,c,a)|0;ra=S;sa=J}if(h){dZb(d,ra,sa);break b}else{Z_b(f[G>>2]|0,ra,sa,d);break b}break}case 15:{if((f[z>>2]|0)==3)ta=hh[f[(f[i>>2]|0)+168>>2]&127](i,c,a,L)|0;else ta=hj[f[(f[i>>2]|0)+68>>2]&511](i,c,a)|0;if(h){cZb(d,ta);break b}else{__b(f[G>>2]|0,ta,d);break b}break}case 16:{if((f[z>>2]|0)==3){S=hh[f[(f[i>>2]|0)+172>>2]&127](i,c,a,L)|0;ua=S;va=J}else{S=hj[f[(f[i>>2]|0)+72>>2]&511](i,c,a)|0;ua=S;va=J}if(h){dZb(d,ua,va);break b}else{$_b(f[G>>2]|0,ua,va,d);break b}break}case 2:{if((f[z>>2]|0)==3)wa=+Ai[f[(f[i>>2]|0)+184>>2]&15](i,c,a,L);else wa=+Sh[f[(f[i>>2]|0)+84>>2]&31](i,c,a);if(h){cZb(d,(n[s>>2]=wa,f[s>>2]|0));break b}else{a$b(f[G>>2]|0,wa,d);break b}break}case 1:{if((f[z>>2]|0)==3)xa=+Ai[f[(f[i>>2]|0)+188>>2]&15](i,c,a,L);else xa=+Sh[f[(f[i>>2]|0)+88>>2]&31](i,c,a);if(h){p[s>>3]=xa;dZb(d,f[s>>2]|0,f[s+4>>2]|0);break b}else{b$b(f[G>>2]|0,xa,d);break b}break}case 8:{if((f[z>>2]|0)==3)ya=hh[f[(f[i>>2]|0)+192>>2]&127](i,c,a,L)|0;else ya=hj[f[(f[i>>2]|0)+92>>2]&511](i,c,a)|0;if(!h){c$b(f[G>>2]|0,ya,d);break b}if((f[I>>2]|0)>4){b[f[K>>2]>>0]=ya&1;f[K>>2]=(f[K>>2]|0)+1;f[I>>2]=(f[I>>2]|0)+-1;break b}else{eZb(d,ya&1);break b}break}case 10:{S=f[G>>2]|0;do if((f[z>>2]|0)==3)if(o){za=hh[f[(f[i>>2]|0)+208>>2]&127](i,c,a,L)|0;break}else{za=f[H+(L<<2)>>2]|0;break}else za=hh[f[(f[i>>2]|0)+108>>2]&127](i,c,a,0)|0;while(0);i$b(S,za,d);break}case 11:{O=f[G>>2]|0;do if((f[z>>2]|0)==3)if(o){Aa=hh[f[(f[i>>2]|0)+208>>2]&127](i,c,a,L)|0;break}else{Aa=f[H+(L<<2)>>2]|0;break}else Aa=hh[f[(f[i>>2]|0)+108>>2]&127](i,c,a,0)|0;while(0);j$b(O,Aa,d);break}case 14:{if((f[z>>2]|0)==3)Ba=hh[f[(f[i>>2]|0)+200>>2]&127](i,c,a,L)|0;else Ba=hj[f[(f[i>>2]|0)+100>>2]&511](i,c,a)|0;if(!h){d$b(f[G>>2]|0,f[Ba+8>>2]|0,d);break b}S=f[Ba+8>>2]|0;P=((S|0)<0)<<31>>31;if((f[I>>2]|0)<=9){fZb(d,S,P);break b}V=f[K>>2]|0;Q=S&255;if(S>>>0>127){$=V;R=Q;_=S;S=P;while(1){b[$>>0]=R|-128;P=_;_=l1c(_|0,S|0,7)|0;M=$+1|0;U=_&255;if(!(S>>>0>0|(S|0)==0&P>>>0>16383)){Ca=M;Da=U;break}else{$=M;R=U;S=J}}}else{Ca=V;Da=Q}b[Ca>>0]=Da;S=Ca+1-V|0;f[K>>2]=(f[K>>2]|0)+S;f[I>>2]=(f[I>>2]|0)-S;break}case 9:{S=(f[(f[t>>2]|0)+44>>2]|0)==3;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if((f[z>>2]|0)==3)Ea=_h[f[(f[i>>2]|0)+212>>2]&127](i,c,a,L,g)|0;else Ea=hh[f[(f[i>>2]|0)+112>>2]&127](i,c,a,g)|0;R=b[Ea+11>>0]|0;if(R<<24>>24<0){Fa=f[Ea>>2]|0;Ga=f[Ea+4>>2]|0}else{Fa=Ea;Ga=R&255}R=f[F>>2]|0;if((b[R+11>>0]|0)<0)Ha=f[R>>2]|0;else Ha=R;if(S)m$b(Fa,Ga,1,Ha)|0;e$b(f[G>>2]|0,Ea,d);if((b[x>>0]|0)<0)cYc(f[g>>2]|0);break}case 12:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if((f[z>>2]|0)==3)Ia=_h[f[(f[i>>2]|0)+212>>2]&127](i,c,a,L,g)|0;else Ia=hh[f[(f[i>>2]|0)+112>>2]&127](i,c,a,g)|0;g$b(f[G>>2]|0,Ia,d);if((b[q>>0]|0)<0)cYc(f[g>>2]|0);break}default:{}}while(0);L=L+1|0;if((L|0)>=(B|0))break a}}while(0);if(C|0)cYc(C);u=e;return}function Yqc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e;mi[f[(f[c>>2]|0)+96>>2]&2047](g,c);h=f[g+4>>2]|0;g=d+8|0;if((f[g>>2]|0)>4){i=d+4|0;b[f[i>>2]>>0]=11;f[i>>2]=(f[i>>2]|0)+1;i=(f[g>>2]|0)+-1|0;f[g>>2]=i;j=i}else{eZb(d,11);j=f[g>>2]|0}if((j|0)>4){j=d+4|0;b[f[j>>2]>>0]=16;f[j>>2]=(f[j>>2]|0)+1;j=(f[g>>2]|0)+-1|0;f[g>>2]=j;k=j}else{eZb(d,16);k=f[g>>2]|0}j=f[a+40>>2]|0;if((k|0)>4){k=d+4|0;i=f[k>>2]|0;if(j>>>0>127){l=j;m=i;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=i;q=j}b[p>>0]=q;q=p+1-i|0;f[k>>2]=(f[k>>2]|0)+q;k=(f[g>>2]|0)-q|0;f[g>>2]=k;r=k}else{eZb(d,j);r=f[g>>2]|0}if((r|0)>4){r=d+4|0;b[f[r>>2]>>0]=26;f[r>>2]=(f[r>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1}else eZb(d,26);r=hh[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;a=_i[f[(f[r>>2]|0)+60>>2]&2047](r)|0;if((f[g>>2]|0)>4){c=d+4|0;h=f[c>>2]|0;if(a>>>0>127){j=a;k=h;while(1){b[k>>0]=j|128;q=j>>>7;i=k+1|0;if(j>>>0>16383){j=q;k=i}else{s=i;t=q;break}}}else{s=h;t=a}b[s>>0]=t;t=s+1-h|0;f[c>>2]=(f[c>>2]|0)+t;f[g>>2]=(f[g>>2]|0)-t}else eZb(d,a);mi[f[(f[r>>2]|0)+52>>2]&2047](r,d);if((f[g>>2]|0)>4){r=d+4|0;b[f[r>>2]>>0]=12;f[r>>2]=(f[r>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1;u=e;return}else{eZb(d,12);u=e;return}}function Zqc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+64|0;h=g+32|0;i=g;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;ei[f[(f[d>>2]|0)+352>>2]&511](h,d,c,e);k=h+4|0;l=i+4|0;m=i+16|0;n=i+8|0;o=h+8|0;p=a+8|0;while(1){ei[f[(f[d>>2]|0)+356>>2]&511](i,d,c,e);q=f[k>>2]|0;r=hj[f[(f[q>>2]|0)+20>>2]&511](q,h,i)|0;q=f[l>>2]|0;mi[f[(f[q>>2]|0)+52>>2]&2047](q,i);if((f[m>>2]|0)==9?(q=f[n>>2]|0,q|0):0){if((b[q+11>>0]|0)<0)cYc(f[q>>2]|0);cYc(q)}if(r)break;r=f[j>>2]|0;if((r|0)==(f[p>>2]|0))drc(a,o);else{f[r+8>>2]=0;hkc(r,o);f[j>>2]=(f[j>>2]|0)+16}r=f[k>>2]|0;mi[f[(f[r>>2]|0)+60>>2]&2047](r,h)}p=f[k>>2]|0;mi[f[(f[p>>2]|0)+52>>2]&2047](p,h);if((f[h+16>>2]|0)!=9){s=f[a>>2]|0;t=f[j>>2]|0;crc(s,t,h);u=g;return}p=f[o>>2]|0;if(!p){s=f[a>>2]|0;t=f[j>>2]|0;crc(s,t,h);u=g;return}if((b[p+11>>0]|0)<0)cYc(f[p>>2]|0);cYc(p);s=f[a>>2]|0;t=f[j>>2]|0;crc(s,t,h);u=g;return}function _qc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+40|0;k=(F3b(a)|0)+20|0;l=f[k>>2]|0;k=(F3b(a)|0)+20|0;m=f[k>>2]|0;k=m+88|0;n=f[a+40>>2]<<3|2;a=e+8|0;if((f[a>>2]|0)>4){o=e+4|0;p=f[o>>2]|0;if(n>>>0>127){q=n;r=p;while(1){b[r>>0]=q|128;s=q>>>7;t=r+1|0;if(q>>>0>16383){q=s;r=t}else{v=t;w=s;break}}}else{v=p;w=n}b[v>>0]=w;w=v+1-p|0;f[o>>2]=(f[o>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else eZb(e,n);n=(arc(l,c)|0)+2|0;w=n+(brc(k,d)|0)|0;if((f[a>>2]|0)>4){n=e+4|0;o=f[n>>2]|0;if(w>>>0>127){p=w;v=o;while(1){b[v>>0]=p|128;r=p>>>7;q=v+1|0;if(p>>>0>16383){p=r;v=q}else{x=q;y=r;break}}}else{x=o;y=w}b[x>>0]=y;y=x+1-o|0;f[n>>2]=(f[n>>2]|0)+y;f[a>>2]=(f[a>>2]|0)-y}else eZb(e,w);w=f[l+24>>2]|0;if(w|0?(f[w>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=l;J_b(w,h)}do switch(f[l+28>>2]|0){case 14:case 12:case 11:case 10:case 2:case 1:{u_b(i,3,507135,846);r_b(j,p_b(i,507492)|0);v_b(i);break}case 3:{T_b(1,nkc(c)|0,J,e);break}case 4:{V_b(1,pkc(c)|0,J,e);break}case 5:{S_b(1,okc(c)|0,e);break}case 6:{Z_b(1,pkc(c)|0,J,e);break}case 7:{Y_b(1,qkc(c)|0,e);break}case 8:{c$b(1,rkc(c)|0,e);break}case 13:{U_b(1,qkc(c)|0,e);break}case 15:{__b(1,okc(c)|0,e);break}case 16:{$_b(1,nkc(c)|0,J,e);break}case 17:{W_b(1,okc(c)|0,e);break}case 18:{X_b(1,nkc(c)|0,J,e);break}case 9:{e$b(1,OSa(c)|0,e);break}default:{}}while(0);c=f[m+112>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[h>>2]=80424;f[h+4>>2]=2231;b[h+8>>0]=0;f[h+12>>2]=k;J_b(c,h)}do switch(f[m+116>>2]|0){case 3:{T_b(2,Pkc(d)|0,J,e);u=g;return}case 4:{V_b(2,Rkc(d)|0,J,e);u=g;return}case 5:{S_b(2,Qkc(d)|0,e);u=g;return}case 6:{Z_b(2,Rkc(d)|0,J,e);u=g;return}case 7:{Y_b(2,Skc(d)|0,e);u=g;return}case 8:{c$b(2,Tkc(d)|0,e);u=g;return}case 13:{U_b(2,Skc(d)|0,e);u=g;return}case 15:{__b(2,Qkc(d)|0,e);u=g;return}case 16:{$_b(2,Pkc(d)|0,J,e);u=g;return}case 17:{W_b(2,Qkc(d)|0,e);u=g;return}case 18:{X_b(2,Pkc(d)|0,J,e);u=g;return}case 14:{d$b(2,Wkc(d)|0,e);u=g;return}case 1:{b$b(2,+Ukc(d),e);u=g;return}case 2:{a$b(2,+Vkc(d),e);u=g;return}case 9:{e$b(2,Okc(d)|0,e);u=g;return}case 12:{g$b(2,Okc(d)|0,e);u=g;return}case 11:{j$b(2,Xkc(d)|0,e);u=g;return}case 10:{i$b(2,Xkc(d)|0,e);u=g;return}default:{u=g;return}}while(0)}function $qc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+64|0;e=d+32|0;g=d;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);h=f[e+4>>2]|0;i=a+24|0;j=f[i>>2]|0;if(j|0?(f[j>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(j,e)}j=a+28|0;if(((f[j>>2]|0)==11?D3b(a)|0:0)?(k=hj[f[(f[h>>2]|0)+364>>2]&511](h,c,a)|0,clc(k)|0):0){uic(e,c,a);uic(g,c,a);l=(F3b(a)|0)+20|0;m=f[l>>2]|0;l=(F3b(a)|0)+20|0;n=(f[l>>2]|0)+88|0;mi[f[(f[k>>2]|0)+24>>2]&2047](k,e);mi[f[(f[k>>2]|0)+28>>2]&2047](k,g);k=e+4|0;l=e+8|0;o=e+24|0;p=0;while(1){q=f[k>>2]|0;if(hj[f[(f[q>>2]|0)+20>>2]&511](q,e,g)|0)break;q=arc(m,l)|0;r=q+2+(brc(n,o)|0)|0;q=r+p+((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=f[k>>2]|0;mi[f[(f[r>>2]|0)+60>>2]&2047](r,e);p=q}o=f[g+4>>2]|0;mi[f[(f[o>>2]|0)+52>>2]&2047](o,g);if((f[g+16>>2]|0)==9?(o=f[g+8>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);cYc(o)}o=f[k>>2]|0;mi[f[(f[o>>2]|0)+52>>2]&2047](o,e);if((f[e+16>>2]|0)==9?(o=f[l>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);cYc(o)}s=p;u=d;return s|0}p=a+32|0;if((f[p>>2]|0)!=3)if(!(b[(f[(f[a+48>>2]|0)+16>>2]|0)+51>>0]|0))t=(hj[f[(f[h>>2]|0)+20>>2]&511](h,c,a)|0)&1;else t=1;else t=hj[f[(f[h>>2]|0)+24>>2]&511](h,c,a)|0;o=f[i>>2]|0;if(o|0?(f[o>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(o,e)}do switch(f[j>>2]|0){case 5:{if((f[p>>2]|0)!=3){o=hj[f[(f[h>>2]|0)+68>>2]&511](h,c,a)|0;if((o|0)<0){s=10;u=d;return s|0}s=(((($(o|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}o=0;i=0;while(1){l=hh[f[(f[h>>2]|0)+168>>2]&127](h,c,a,o)|0;if((l|0)<0)v=10;else v=(((($(l|1|0)|0)^31)*9|0)+73|0)>>>6;l=v+i|0;o=o+1|0;if((o|0)==(t|0)){s=l;break}else i=l}u=d;return s|0}case 3:{if((f[p>>2]|0)!=3){i=hj[f[(f[h>>2]|0)+72>>2]&511](h,c,a)|0;o=t1c(i|1|0,J|0,1)|0;s=(((o^63)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}o=0;i=0;while(1){l=hh[f[(f[h>>2]|0)+172>>2]&127](h,c,a,o)|0;k=t1c(l|1|0,J|0,1)|0;l=((((k^63)*9|0)+73|0)>>>6)+i|0;o=o+1|0;if((o|0)==(t|0)){s=l;break}else i=l}u=d;return s|0}case 17:{if((f[p>>2]|0)!=3){i=hj[f[(f[h>>2]|0)+68>>2]&511](h,c,a)|0;s=(((($(i<<1^i>>31|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;o=0;while(1){l=hh[f[(f[h>>2]|0)+168>>2]&127](h,c,a,i)|0;k=((((($(l<<1^l>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+o|0;i=i+1|0;if((i|0)==(t|0)){s=k;break}else o=k}u=d;return s|0}case 18:{if((f[p>>2]|0)!=3){o=hj[f[(f[h>>2]|0)+72>>2]&511](h,c,a)|0;i=J;k=u1c(o|0,i|0,1)|0;l=J;g=k1c(o|0,i|0,63)|0;i=t1c(k^g|1|0,l^J|0,1)|0;s=(((i^63)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){g=hh[f[(f[h>>2]|0)+172>>2]&127](h,c,a,i)|0;k=J;o=u1c(g|0,k|0,1)|0;n=J;m=k1c(g|0,k|0,63)|0;k=t1c(o^m|1|0,n^J|0,1)|0;n=((((k^63)*9|0)+73|0)>>>6)+l|0;i=i+1|0;if((i|0)==(t|0)){s=n;break}else l=n}u=d;return s|0}case 13:{if((f[p>>2]|0)!=3){s=(((($(hj[f[(f[h>>2]|0)+76>>2]&511](h,c,a)|0|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}l=0;i=0;while(1){n=((((($(hh[f[(f[h>>2]|0)+176>>2]&127](h,c,a,l)|0|1|0)|0)^31)*9|0)+73|0)>>>6)+i|0;l=l+1|0;if((l|0)==(t|0)){s=n;break}else i=n}u=d;return s|0}case 4:{if((f[p>>2]|0)!=3){i=hj[f[(f[h>>2]|0)+80>>2]&511](h,c,a)|0;l=t1c(i|1|0,J|0,1)|0;s=(((l^63)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}l=0;i=0;while(1){n=hh[f[(f[h>>2]|0)+180>>2]&127](h,c,a,l)|0;k=t1c(n|1|0,J|0,1)|0;n=((((k^63)*9|0)+73|0)>>>6)+i|0;l=l+1|0;if((l|0)==(t|0)){s=n;break}else i=n}u=d;return s|0}case 7:{s=t<<2;u=d;return s|0}case 6:{s=t<<3;u=d;return s|0}case 15:{s=t<<2;u=d;return s|0}case 16:{s=t<<3;u=d;return s|0}case 2:{s=t<<2;u=d;return s|0}case 1:{s=t<<3;u=d;return s|0}case 8:{s=t;u=d;return s|0}case 10:{if((f[p>>2]|0)!=3){i=hh[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;s=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){n=hh[f[(f[h>>2]|0)+208>>2]&127](h,c,a,i)|0;k=(_i[f[(f[n>>2]|0)+48>>2]&2047](n)|0)+l|0;i=i+1|0;if((i|0)==(t|0)){s=k;break}else l=k}u=d;return s|0}case 11:{if((f[p>>2]|0)!=3){l=hh[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;i=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;s=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+i|0;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){k=hh[f[(f[h>>2]|0)+208>>2]&127](h,c,a,i)|0;n=_i[f[(f[k>>2]|0)+48>>2]&2047](k)|0;k=n+l+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(t|0)){s=k;break}else l=k}u=d;return s|0}case 14:{if((f[p>>2]|0)!=3){l=(hj[f[(f[h>>2]|0)+100>>2]&511](h,c,a)|0)+8|0;i=f[l>>2]|0;if((i|0)<0){s=10;u=d;return s|0}s=(((($(i|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return s|0}if(!t){s=0;u=d;return s|0}i=0;l=0;while(1){k=(hh[f[(f[h>>2]|0)+200>>2]&127](h,c,a,i)|0)+8|0;n=f[k>>2]|0;if((n|0)<0)w=10;else w=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;n=w+l|0;i=i+1|0;if((i|0)==(t|0)){s=n;break}else l=n}u=d;return s|0}case 12:case 9:{if(!t){s=0;u=d;return s|0}l=e+11|0;i=0;n=0;while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if((f[p>>2]|0)==3)x=_h[f[(f[h>>2]|0)+212>>2]&127](h,c,a,i,e)|0;else x=hh[f[(f[h>>2]|0)+112>>2]&127](h,c,a,e)|0;k=b[x+11>>0]|0;m=k<<24>>24<0?f[x+4>>2]|0:k&255;k=m+n+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if((b[l>>0]|0)<0)cYc(f[e>>2]|0);i=i+1|0;if(i>>>0>=t>>>0){s=k;break}else n=k}u=d;return s|0}default:{s=0;u=d;return s|0}}while(0);return 0}function arc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d+65|0;i=d;j=d+64|0;k=f[a+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(k,e)}do switch(f[a+28>>2]|0){case 14:case 12:case 11:case 10:case 2:case 1:{u_b(g,3,507135,1245);r_b(h,p_b(g,507492)|0);v_b(g);l=0;u=d;return l|0}case 5:{e=okc(c)|0;if((e|0)<0){l=10;u=d;return l|0}l=(((($(e|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 3:{l=((((t1c(nkc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 13:{l=(((($(qkc(c)|0|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 4:{l=((((t1c(pkc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 17:{e=okc(c)|0;l=(((($(e<<1^e>>31|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 18:{e=nkc(c)|0;k=J;m=u1c(e|0,k|0,1)|0;n=J;l=((((t1c(m^(k1c(e|0,k|0,63)|0)|1|0,n^J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 9:{n=OSa(c)|0;k=b[n+11>>0]|0;e=k<<24>>24<0?f[n+4>>2]|0:k&255;l=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;u=d;return l|0}case 6:{l=8;u=d;return l|0}case 16:{l=8;u=d;return l|0}case 8:{l=1;u=d;return l|0}case 15:case 7:{l=4;u=d;return l|0}default:{u_b(i,3,507135,1272);r_b(j,p_b(i,507504)|0);v_b(i);l=0;u=d;return l|0}}while(0);return 0}function brc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d+65|0;i=d;j=d+64|0;k=f[a+24>>2]|0;if(k|0?(f[k>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(k,e)}do switch(f[a+28>>2]|0){case 10:{u_b(g,3,507135,1280);r_b(h,p_b(g,507492)|0);v_b(g);l=0;u=d;return l|0}case 5:{e=Qkc(c)|0;if((e|0)<0){l=10;u=d;return l|0}l=(((($(e|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 3:{l=((((t1c(Pkc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 13:{l=(((($(Skc(c)|0|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 4:{l=((((t1c(Rkc(c)|0|1|0,J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 17:{e=Qkc(c)|0;l=(((($(e<<1^e>>31|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 18:{e=Pkc(c)|0;k=J;m=u1c(e|0,k|0,1)|0;n=J;l=((((t1c(m^(k1c(e|0,k|0,63)|0)|1|0,n^J|0,1)|0)^63)*9|0)+73|0)>>>6;u=d;return l|0}case 9:{n=Okc(c)|0;k=b[n+11>>0]|0;e=k<<24>>24<0?f[n+4>>2]|0:k&255;l=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;u=d;return l|0}case 12:{e=Okc(c)|0;k=b[e+11>>0]|0;n=k<<24>>24<0?f[e+4>>2]|0:k&255;l=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+n|0;u=d;return l|0}case 14:{n=Wkc(c)|0;if((n|0)<0){l=10;u=d;return l|0}l=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;u=d;return l|0}case 11:{n=Xkc(c)|0;k=_i[f[(f[n>>2]|0)+48>>2]&2047](n)|0;l=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+k|0;u=d;return l|0}case 6:{l=8;u=d;return l|0}case 16:{l=8;u=d;return l|0}case 1:{l=8;u=d;return l|0}case 8:{l=1;u=d;return l|0}case 2:case 15:case 7:{l=4;u=d;return l|0}default:{u_b(i,3,507135,1312);r_b(j,p_b(i,507504)|0);v_b(i);l=0;u=d;return l|0}}while(0);return 0}function crc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+16|0;g=e;h=g+8|0;i=g+8|0;j=g+8|0;k=g+8|0;l=g+8|0;m=a;a=c;a:while(1){c=a;n=a+-16|0;o=m;while(1){p=o;b:while(1){q=p;r=c-q|0;s=r>>4;switch(s|0){case 2:{t=5;break a;break}case 3:{t=12;break a;break}case 4:{t=13;break a;break}case 5:{t=14;break a;break}case 1:case 0:{t=76;break a;break}default:{}}if((r|0)<112){t=16;break a}v=p+(((s|0)/2|0)<<4)|0;if((r|0)>15984){r=(s|0)/4|0;w=hrc(p,p+(r<<4)|0,v,v+(r<<4)|0,n,d)|0}else w=frc(p,v,n,d)|0;if(erc(d,p,v)|0){x=n;y=w;break}else z=n;while(1){z=z+-16|0;if((p|0)==(z|0))break;if(erc(d,z,v)|0){t=44;break b}}r=p+16|0;if(erc(d,p,n)|0)A=r;else{if((r|0)==(n|0)){t=76;break a}else B=r;while(1){if(erc(d,p,B)|0)break;r=B+16|0;if((r|0)==(n|0)){t=76;break a}else B=r}f[i>>2]=0;hkc(g,B);hkc(B,n);hkc(n,g);if((f[i>>2]|0)==9?(r=f[g>>2]|0,r|0):0){if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);cYc(r)}A=B+16|0}if((A|0)==(n|0)){t=76;break a}else{C=n;D=A}while(1){r=D;while(1){E=r+16|0;if(erc(d,p,r)|0){F=C;break}else r=E}do F=F+-16|0;while(erc(d,p,F)|0);if(r>>>0>=F>>>0){p=r;continue b}f[h>>2]=0;hkc(g,r);hkc(r,F);hkc(F,g);if((f[h>>2]|0)==9?(s=f[g>>2]|0,s|0):0){if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);cYc(s)}C=F;D=E}}if((t|0)==44){t=0;f[l>>2]=0;hkc(g,p);hkc(p,z);hkc(z,g);if((f[l>>2]|0)==9?(s=f[g>>2]|0,s|0):0){if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);cYc(s)}x=z;y=w+1|0}s=p+16|0;c:do if(s>>>0<x>>>0){G=v;H=x;I=s;J=y;while(1){K=I;while(1){L=K+16|0;if(erc(d,K,G)|0)K=L;else{M=H;break}}do M=M+-16|0;while(!(erc(d,M,G)|0));if(K>>>0>M>>>0){N=G;O=J;P=K;break c}f[k>>2]=0;hkc(g,K);hkc(K,M);hkc(M,g);if((f[k>>2]|0)==9?(r=f[g>>2]|0,r|0):0){if((b[r+11>>0]|0)<0)cYc(f[r>>2]|0);cYc(r)}G=(G|0)==(K|0)?M:G;H=M;I=L;J=J+1|0}}else{N=v;O=y;P=s}while(0);if((P|0)!=(N|0)?erc(d,N,P)|0:0){f[j>>2]=0;hkc(g,P);hkc(P,N);hkc(N,g);if((f[j>>2]|0)==9?(s=f[g>>2]|0,s|0):0){if((b[s+11>>0]|0)<0)cYc(f[s>>2]|0);cYc(s)}Q=O+1|0}else Q=O;if(!Q){R=jrc(p,P,d)|0;s=P+16|0;if(jrc(s,a,d)|0){t=75;break}if(R){o=s;continue}}s=P;if((s-q|0)>=(c-s|0)){t=74;break}crc(p,P,d);o=P+16|0}if((t|0)==74){t=0;crc(P+16|0,a,d);m=p;a=P;continue}else if((t|0)==75){t=0;if(R){t=76;break}else{m=p;a=P;continue}}}if((t|0)==5){if(!(erc(d,n,p)|0)){u=e;return}P=g+8|0;f[P>>2]=0;hkc(g,p);hkc(p,n);hkc(n,g);if((f[P>>2]|0)==9?(P=f[g>>2]|0,P|0):0){if((b[P+11>>0]|0)<0)cYc(f[P>>2]|0);cYc(P)}u=e;return}else if((t|0)==12){frc(p,p+16|0,n,d)|0;u=e;return}else if((t|0)==13){grc(p,p+16|0,p+32|0,n,d)|0;u=e;return}else if((t|0)==14){hrc(p,p+16|0,p+32|0,p+48|0,n,d)|0;u=e;return}else if((t|0)==16){irc(p,a,d);u=e;return}else if((t|0)==76){u=e;return}}function drc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[a>>2]|0;g=(f[d>>2]|0)-e>>4;h=g+1|0;if(h>>>0>268435455)kWc(a);i=a+8|0;j=(f[i>>2]|0)-e|0;e=j>>3;k=j>>4>>>0<134217727?(e>>>0<h>>>0?h:e):268435455;if(k>>>0>268435455){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}e=$Xc(k<<4)|0;h=e+(g<<4)|0;j=h;l=e+(k<<4)|0;f[e+(g<<4)+8>>2]=0;hkc(h,c);c=h+16|0;g=f[a>>2]|0;e=f[d>>2]|0;if((e|0)==(g|0)){m=j;n=g;o=g}else{k=e;e=j;j=h;do{k=k+-16|0;f[j+-8>>2]=0;hkc(j+-16|0,k);j=e+-16|0;e=j}while((k|0)!=(g|0));m=e;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=l;l=n;if((o|0)!=(l|0)){i=o;do{o=i;i=i+-16|0;if((f[o+-8>>2]|0)==9?(o=f[i>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);cYc(o)}}while((i|0)!=(l|0))}if(!n)return;cYc(n);return}function erc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=u;u=u+32|0;e=a;g=a+24|0;switch(hSa(c)|0){case 9:{h=OSa(c)|0;i=OSa(d)|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=k?f[i+4>>2]|0:j&255;j=b[h+11>>0]|0;m=j<<24>>24<0;n=m?f[h+4>>2]|0:j&255;j=l>>>0<n>>>0;o=j?l:n;if((o|0)!=0?(p=WKc(m?f[h>>2]|0:h,k?f[i>>2]|0:i,o)|0,(p|0)!=0):0)q=p;else q=n>>>0<l>>>0?-1:j&1;r=(q|0)<0;u=a;return r|0}case 2:{q=nkc(c)|0;j=J;l=nkc(d)|0;n=J;r=(j|0)<(n|0)|(j|0)==(n|0)&q>>>0<l>>>0;u=a;return r|0}case 1:{r=(okc(c)|0)<(okc(d)|0);u=a;return r|0}case 4:{l=pkc(c)|0;q=J;n=pkc(d)|0;j=J;r=q>>>0<j>>>0|(q|0)==(j|0)&l>>>0<n>>>0;u=a;return r|0}case 3:{r=(qkc(c)|0)>>>0<(qkc(d)|0)>>>0;u=a;return r|0}case 7:{n=rkc(c)|0;r=(rkc(d)|0)&(n^1);u=a;return r|0}default:{u_b(e,2,507135,936);r_b(g,p_b(e,507520)|0);v_b(e);r=1;u=a;return r|0}}return 0}function frc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;i=erc(e,c,a)|0;j=erc(e,d,c)|0;if(!i){if(!j){k=0;u=g;return k|0}i=h+8|0;f[i>>2]=0;hkc(h,c);hkc(c,d);hkc(d,h);if((f[i>>2]|0)==9?(i=f[h>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}if(!(erc(e,c,a)|0)){k=1;u=g;return k|0}i=h+8|0;f[i>>2]=0;hkc(h,a);hkc(a,c);hkc(c,h);if((f[i>>2]|0)==9?(i=f[h>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}k=2;u=g;return k|0}if(j){j=h+8|0;f[j>>2]=0;hkc(h,a);hkc(a,d);hkc(d,h);if((f[j>>2]|0)==9?(j=f[h>>2]|0,j|0):0){if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(j)}k=1;u=g;return k|0}j=h+8|0;f[j>>2]=0;hkc(h,a);hkc(a,c);hkc(c,h);if((f[j>>2]|0)==9?(j=f[h>>2]|0,j|0):0){if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(j)}if(!(erc(e,d,c)|0)){k=1;u=g;return k|0}e=h+8|0;f[e>>2]=0;hkc(h,c);hkc(c,d);hkc(d,h);if((f[e>>2]|0)==9?(e=f[h>>2]|0,e|0):0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}k=2;u=g;return k|0}function grc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;j=frc(a,c,d,g)|0;if(!(erc(g,e,d)|0)){k=j;u=h;return k|0}l=i+8|0;f[l>>2]=0;hkc(i,d);hkc(d,e);hkc(e,i);if((f[l>>2]|0)==9?(l=f[i>>2]|0,l|0):0){if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);cYc(l)}if(!(erc(g,d,c)|0)){k=j+1|0;u=h;return k|0}l=i+8|0;f[l>>2]=0;hkc(i,c);hkc(c,d);hkc(d,i);if((f[l>>2]|0)==9?(l=f[i>>2]|0,l|0):0){if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);cYc(l)}if(!(erc(g,c,a)|0)){k=j+2|0;u=h;return k|0}g=i+8|0;f[g>>2]=0;hkc(i,a);hkc(a,c);hkc(c,i);if((f[g>>2]|0)==9?(g=f[i>>2]|0,g|0):0){if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);cYc(g)}k=j+3|0;u=h;return k|0}function hrc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+16|0;j=i;k=grc(a,c,d,e,h)|0;if(!(erc(h,g,e)|0)){l=k;u=i;return l|0}m=j+8|0;f[m>>2]=0;hkc(j,e);hkc(e,g);hkc(g,j);if((f[m>>2]|0)==9?(m=f[j>>2]|0,m|0):0){if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);cYc(m)}if(!(erc(h,e,d)|0)){l=k+1|0;u=i;return l|0}m=j+8|0;f[m>>2]=0;hkc(j,d);hkc(d,e);hkc(e,j);if((f[m>>2]|0)==9?(m=f[j>>2]|0,m|0):0){if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);cYc(m)}if(!(erc(h,d,c)|0)){l=k+2|0;u=i;return l|0}m=j+8|0;f[m>>2]=0;hkc(j,c);hkc(c,d);hkc(d,j);if((f[m>>2]|0)==9?(m=f[j>>2]|0,m|0):0){if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);cYc(m)}if(!(erc(h,c,a)|0)){l=k+3|0;u=i;return l|0}h=j+8|0;f[h>>2]=0;hkc(j,a);hkc(a,c);hkc(c,j);if((f[h>>2]|0)==9?(h=f[j>>2]|0,h|0):0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}l=k+4|0;u=i;return l|0}function irc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;h=a+32|0;frc(a,a+16|0,h,d)|0;i=a+48|0;if((i|0)==(c|0)){u=e;return}j=g+8|0;k=i;i=h;while(1){if(erc(d,k,i)|0){f[j>>2]=0;hkc(g,k);h=i;l=k;while(1){hkc(l,h);if((h|0)==(a|0)){m=a;break}n=h+-16|0;if(erc(d,g,n)|0){o=h;h=n;l=o}else{m=h;break}}hkc(m,g);if((f[j>>2]|0)==9?(h=f[g>>2]|0,h|0):0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}}h=k+16|0;if((h|0)==(c|0))break;else{l=k;k=h;i=l}}u=e;return}function jrc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e;switch(c-a>>4|0){case 2:{h=c+-16|0;if(!(erc(d,h,a)|0)){i=1;u=e;return i|0}j=g+8|0;f[j>>2]=0;hkc(g,a);hkc(a,h);hkc(h,g);if((f[j>>2]|0)==9?(j=f[g>>2]|0,j|0):0){if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(j)}i=1;u=e;return i|0}case 3:{frc(a,a+16|0,c+-16|0,d)|0;i=1;u=e;return i|0}case 4:{grc(a,a+16|0,a+32|0,c+-16|0,d)|0;i=1;u=e;return i|0}case 5:{hrc(a,a+16|0,a+32|0,a+48|0,c+-16|0,d)|0;i=1;u=e;return i|0}case 1:case 0:{i=1;u=e;return i|0}default:{j=a+32|0;frc(a,a+16|0,j,d)|0;h=a+48|0;a:do if((h|0)==(c|0)){k=1;l=0}else{m=g+8|0;n=h;o=0;p=j;while(1){if(erc(d,n,p)|0){f[m>>2]=0;hkc(g,n);q=p;r=n;while(1){hkc(r,q);if((q|0)==(a|0)){s=a;break}t=q+-16|0;if(erc(d,g,t)|0){v=q;q=t;r=v}else{s=q;break}}hkc(s,g);q=o+1|0;r=(q|0)==8;v=(n+16|0)==(c|0);if((f[m>>2]|0)==9?(t=f[g>>2]|0,t|0):0){if((b[t+11>>0]|0)<0)cYc(f[t>>2]|0);cYc(t)}if(r){k=0;l=v;break a}else w=q}else w=o;q=n+16|0;if((q|0)==(c|0)){k=1;l=0;break}else{v=n;n=q;o=w;p=v}}}while(0);i=k|l;u=e;return i|0}}return 0}function krc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c+4|0;e=c;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;mi[f[(f[a>>2]|0)+96>>2]&2047](d,a);h=f[d+4>>2]|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;f[d+8>>2]=0;j=g+16|0;a:do if(b[(f[j>>2]|0)+51>>0]|0){k=g+52|0;l=f[k>>2]|0;if((l|0)>0){m=g+20|0;n=d+8|0;o=0;p=l;l=0;q=0;while(1){r=(f[m>>2]|0)+(o*88|0)|0;f[e>>2]=r;if(l>>>0<q>>>0){f[l>>2]=r;f[i>>2]=(f[i>>2]|0)+4;s=p}else{wgc(d,e);s=f[k>>2]|0}r=o+1|0;if((r|0)>=(s|0))break a;o=r;p=s;l=f[i>>2]|0;q=f[n>>2]|0}}}else Ti[f[(f[h>>2]|0)+64>>2]&511](h,a,d);while(0);s=f[d>>2]|0;if((f[i>>2]|0)==(s|0))t=0;else{e=0;g=0;n=s;while(1){s=(lrc(f[n+(g<<2)>>2]|0,a)|0)+e|0;g=g+1|0;n=f[d>>2]|0;if(g>>>0>=(f[i>>2]|0)-n>>2>>>0){t=s;break}else e=s}}e=(b[(f[j>>2]|0)+48>>0]|0)==0;j=Mi[f[(f[h>>2]|0)+8>>2]&1023](h,a)|0;if(!e){e=f[j>>2]|0;a=f[41372]|0;if((e|0)!=0?(h=f[e>>2]|0,n=h,g=(f[e+4>>2]|0)-h|0,h=g>>4,(g|0)>0):0){g=0;e=0;while(1){if((f[n+(e<<4)+4>>2]|0)==3){s=g+a+((((($(f[n+(e<<4)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=f[n+(e<<4)+8>>2]|0;l=b[q+11>>0]|0;if(l<<24>>24<0)v=f[q+4>>2]|0;else v=l&255;w=s+v+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else w=g;e=e+1|0;if((e|0)>=(h|0)){x=w;break}else g=w}}else x=0}else x=Rqc(j)|0;j=x+t|0;t=f[d>>2]|0;if(!t){u=c;return j|0}d=f[i>>2]|0;if((d|0)!=(t|0))f[i>>2]=d+(~((d+-4-t|0)>>>2)<<2);cYc(t);u=c;return j|0}function lrc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);g=f[e+4>>2]|0;if(b[a+38>>0]|0?b[(f[(f[a+48>>2]|0)+16>>2]|0)+48>>0]|0:0){h=f[a+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(h,e)}if((f[165644+(f[a+28>>2]<<2)>>2]|0)==10?(f[a+32>>2]|0)!=3:0){mi[f[(f[c>>2]|0)+96>>2]&2047](e,c);h=f[e+4>>2]|0;i=((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+(f[41372]|0)|0;j=hh[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;h=_i[f[(f[j>>2]|0)+48>>2]&2047](j)|0;k=i+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return k|0}}if((f[a+32>>2]|0)!=3)if(!(b[(f[(f[a+48>>2]|0)+16>>2]|0)+51>>0]|0))l=(hj[f[(f[g>>2]|0)+20>>2]&511](g,c,a)|0)&1;else l=1;else l=hj[f[(f[g>>2]|0)+24>>2]&511](g,c,a)|0;g=$qc(a,c)|0;if(H3b(a)|0){if(!g){k=0;u=d;return k|0}k=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+g+((((($(f[a+40>>2]<<3|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return k|0}c=f[a+40>>2]|0;h=f[a+24>>2]|0;if(h|0?(f[h>>2]|0)!=2:0){f[e>>2]=80424;f[e+4>>2]=2231;b[e+8>>0]=0;f[e+12>>2]=a;J_b(h,e)}k=(Y((((($(c<<3|1|0)|0)^31)*9|0)+73|0)>>>6<<((f[a+28>>2]|0)==10&1),l)|0)+g|0;u=d;return k|0}function mrc(a){a=a|0;return}function nrc(a){a=a|0;cYc(a);return}function orc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+4>>2]|0;a=f[223599]|0;if(!a){e=0;return e|0}g=(d*65535|0)+b|0;h=f[a+4>>2]|0;if(!h){e=0;return e|0}i=h+-1|0;j=(i&h|0)==0;if(!j)if(g>>>0<h>>>0)k=g;else k=(g>>>0)%(h>>>0)|0;else k=i&g;l=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!l){e=0;return e|0}a=f[l>>2]|0;if(!a){e=0;return e|0}a:do if(j){l=a;while(1){m=f[l+4>>2]|0;n=(m|0)==(g|0);if(!(n|(m&i|0)==(k|0))){e=0;o=23;break}if((n?(f[l+8>>2]|0)==(d|0):0)?(f[l+12>>2]|0)==(b|0):0){p=l;break a}l=f[l>>2]|0;if(!l){e=0;o=23;break}}if((o|0)==23)return e|0}else{l=a;while(1){n=f[l+4>>2]|0;if((n|0)==(g|0)){if((f[l+8>>2]|0)==(d|0)?(f[l+12>>2]|0)==(b|0):0){p=l;break a}}else{if(n>>>0<h>>>0)q=n;else q=(n>>>0)%(h>>>0)|0;if((q|0)!=(k|0)){e=0;o=23;break}}l=f[l>>2]|0;if(!l){e=0;o=23;break}}if((o|0)==23)return e|0}while(0);o=p+16|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[c+8>>2]=f[o+8>>2];f[c+12>>2]=f[o+12>>2];e=1;return e|0}function prc(a,b){a=a|0;b=b|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;f[a+12>>2]=b;if(!b)return;qrc(b,a);return}function qrc(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2279);return}function rrc(a,b){a=a|0;b=b|0;if(!b)return;else{rrc(a,f[b>>2]|0);rrc(a,f[b+4>>2]|0);cYc(b);return}}function src(a){a=a|0;rrc(a,f[a+4>>2]|0);return}function trc(a){a=a|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;f[a+12>>2]=0;return}function urc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+12>>2]|0)){b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0))d=c;else{e=b;while(1){vrc(e+24|0);b=f[e+4>>2]|0;if(!b){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=b;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(c|0)){d=c;break}else e=i}}}else d=a+4|0;rrc(a,f[d>>2]|0);return}function vrc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[165492+(h[a+8>>0]<<2)>>2]|0;if(!(b[a+9>>0]|0))switch(c|0){case 9:{d=f[a>>2]|0;if(!d)return;if((b[d+11>>0]|0)<0)cYc(f[d>>2]|0);cYc(d);return}case 10:{d=f[a>>2]|0;e=(d|0)==0;if(!(b[a+10>>0]&16)){if(e)return;Yi[f[(f[d>>2]|0)+4>>2]&4095](d);return}else{if(e)return;Yi[f[(f[d>>2]|0)+4>>2]&4095](d);return}break}default:return}do switch(c|0){case 1:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 2:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 3:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 4:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 6:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 5:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 7:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 8:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)cYc(e);cYc(d);return}case 9:{d=f[a>>2]|0;if(!d)return;e=d+12|0;g=f[e>>2]|0;if(g|0?(f[d>>2]|0)==0:0){i=f[g>>2]|0;if((i|0)>0){j=0;do{k=f[g+4+(j<<2)>>2]|0;if(k|0){if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);cYc(k)}j=j+1|0}while((j|0)!=(i|0));l=f[e>>2]|0}else l=g;cYc(l)}cYc(d);return}case 10:{i=f[a>>2]|0;if(!i)return;j=i+12|0;k=f[j>>2]|0;if(k|0?(f[i>>2]|0)==0:0){m=f[k>>2]|0;if((m|0)>0){n=0;do{o=f[k+4+(n<<2)>>2]|0;if(o|0)Yi[f[(f[o>>2]|0)+4>>2]&4095](o);n=n+1|0}while((n|0)!=(m|0));p=f[j>>2]|0}else p=k;cYc(p)}cYc(i);return}default:return}while(0)}function wrc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;a=f[d>>2]|0;if(!a){e=0;return e|0}else{g=d;h=a}a:while(1){a=h;while(1){if((f[a+16>>2]|0)>=(c|0))break;i=f[a+4>>2]|0;if(!i){j=g;break a}else a=i}h=f[a>>2]|0;if(!h){j=a;break}else g=a}if((j|0)==(d|0)){e=0;return e|0}d=j+16|0;if((f[d>>2]|0)>(c|0)){e=0;return e|0}e=(b[d+18>>0]&1)==0;return e|0}function xrc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;a=f[c>>2]|0;if(!a){d=0;return d|0}else{e=c;g=a}a:while(1){a=g;while(1){if((f[a+16>>2]|0)>=(b|0))break;h=f[a+4>>2]|0;if(!h){i=e;break a}else a=h}g=f[a>>2]|0;if(!g){i=a;break}else e=a}if((i|0)==(c|0)){d=0;return d|0}if((f[i+16>>2]|0)>(b|0)){d=0;return d|0}d=yrc(i+24|0)|0;return d|0}function yrc(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;do switch(f[165492+((h[a+8>>0]|0)<<2)>>2]|0){case 1:{d=f[f[a>>2]>>2]|0;break}case 2:{d=f[f[a>>2]>>2]|0;break}case 3:{d=f[f[a>>2]>>2]|0;break}case 4:{d=f[f[a>>2]>>2]|0;break}case 6:{d=f[f[a>>2]>>2]|0;break}case 5:{d=f[f[a>>2]>>2]|0;break}case 7:{d=f[f[a>>2]>>2]|0;break}case 8:{d=f[f[a>>2]>>2]|0;break}case 9:{d=f[(f[a>>2]|0)+4>>2]|0;break}case 10:{d=f[(f[a>>2]|0)+4>>2]|0;break}default:{u_b(c,3,507646,1703);r_b(b+24|0,p_b(c,507741)|0);v_b(c);d=0}}while(0);u=b;return d|0}function zrc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;a=f[c>>2]|0;if(!a)return;else{d=c;e=a}a:while(1){a=e;while(1){if((f[a+16>>2]|0)>=(b|0))break;g=f[a+4>>2]|0;if(!g){h=d;break a}else a=g}e=f[a>>2]|0;if(!e){h=a;break}else d=a}if((h|0)==(c|0))return;if((f[h+16>>2]|0)>(b|0))return;Arc(h+24|0);return}function Arc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0;if(!(b[a+9>>0]|0)){c=a+10|0;d=b[c>>0]|0;if(d&1)return;a:do switch(f[165492+(h[a+8>>0]<<2)>>2]|0){case 9:{e=f[a>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break a}else{b[e>>0]=0;b[g>>0]=0;break a}break}case 10:{g=f[a>>2]|0;e=f[g>>2]|0;if(!(d&16)){Yi[f[e+28>>2]&4095](g);break a}else{Yi[f[e+52>>2]&4095](g);break a}break}default:{}}while(0);b[c>>0]=b[c>>0]&-16|1;return}do switch(f[165492+(h[a+8>>0]<<2)>>2]|0){case 1:{f[f[a>>2]>>2]=0;return}case 2:{f[f[a>>2]>>2]=0;return}case 3:{f[f[a>>2]>>2]=0;return}case 4:{f[f[a>>2]>>2]=0;return}case 6:{f[f[a>>2]>>2]=0;return}case 5:{f[f[a>>2]>>2]=0;return}case 7:{f[f[a>>2]>>2]=0;return}case 8:{f[f[a>>2]>>2]=0;return}case 9:{c=f[a>>2]|0;d=c+4|0;g=f[d>>2]|0;if((g|0)<=0)return;e=f[c+12>>2]|0;c=0;do{i=f[e+4+(c<<2)>>2]|0;c=c+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((c|0)!=(g|0));f[d>>2]=0;return}case 10:{g=f[a>>2]|0;c=g+4|0;e=f[c>>2]|0;if((e|0)<=0)return;j=f[g+12>>2]|0;g=0;do{i=f[j+4+(g<<2)>>2]|0;g=g+1|0;Yi[f[(f[i>>2]|0)+28>>2]&4095](i)}while((g|0)!=(e|0));f[c>>2]=0;return}default:return}while(0)}function Brc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function Crc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=m;v=s;break}else if((p|0)==10){t=m;v=l;break}}else{t=j;v=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=$Xc(48)|0;f[j+16>>2]=c;c=j+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=t;f[v>>2]=j;t=f[f[a>>2]>>2]|0;if(!t)A=j;else{f[a>>2]=t;A=f[v>>2]|0}UQ(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=c;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function Drc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;g=e+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;h=a+4|0;i=f[h>>2]|0;do if(i){j=a+4|0;k=i;while(1){l=f[k+16>>2]|0;if((l|0)>(b|0)){m=f[k>>2]|0;if(!m){n=5;break}else{o=k;p=m}}else{if((l|0)>=(b|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==5){r=k;s=k;break}else if((n|0)==9){r=k;s=q;break}else if((n|0)==10){r=k;s=j;break}}else{r=h;s=h}while(0);h=f[s>>2]|0;if(h|0){t=h;v=0;w=t+24|0;f[d>>2]=w;x=t+40|0;f[x>>2]=c;u=e;return v|0}h=$Xc(48)|0;f[h+16>>2]=b;b=h+24|0;f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[b+16>>2]=f[g+16>>2];f[b+20>>2]=f[g+20>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=r;f[s>>2]=h;r=f[f[a>>2]>>2]|0;if(!r)y=h;else{f[a>>2]=r;y=f[s>>2]|0}UQ(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;t=h;v=1;w=t+24|0;f[d>>2]=w;x=t+40|0;f[x>>2]=c;u=e;return v|0}function Erc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,326);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function Frc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}u_b(g,3,507646,326);r_b(h,p_b(p_b(g,507757)|0,507799)|0);v_b(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function Grc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=n;w=t;break}else if((q|0)==10){v=n;w=m;break}}else{v=k;w=k}while(0);k=f[w>>2]|0;if(!k){q=$Xc(48)|0;f[q+16>>2]=c;c=q+24|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=v;f[w>>2]=q;v=f[f[a>>2]>>2]|0;if(!v)x=q;else{f[a>>2]=v;x=f[w>>2]|0}UQ(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22040,16);q=RXb(e,16,2280)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[c>>2]=y;z=c}else{f[k+40>>2]=h;z=k+24|0}k=f[z>>2]|0;z=f[k>>2]|0;if((z|0)!=(f[k+4>>2]|0)){A=z;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}qHa(k,z+1|0);A=f[k>>2]|0;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}function Hrc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Irc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(b[g+18>>0]&1)==0:0){g=k+24|0;l=f[g+4>>2]|0;m=f[g>>2]|0}else{l=e;m=d}}else{l=e;m=d}J=l;return m|0}function Jrc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=n;w=t;break}else if((q|0)==10){v=n;w=m;break}}else{v=k;w=k}while(0);k=f[w>>2]|0;if(k|0){f[k+40>>2]=h;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}k=$Xc(48)|0;f[k+16>>2]=c;c=k+24|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=v;f[w>>2]=k;v=f[f[a>>2]>>2]|0;if(!v)F=k;else{f[a>>2]=v;F=f[w>>2]|0}UQ(f[a+4>>2]|0,F);F=a+8|0;f[F>>2]=(f[F>>2]|0)+1;f[k+40>>2]=h;b[k+32>>0]=d;b[k+33>>0]=0;x=c;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}function Krc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,327);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}h=(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;J=f[h+4>>2]|0;u=d;return f[h>>2]|0}function Lrc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g;i=g+24|0;j=a+4|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(b|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)<=(b|0):0)o=n;else p=8}else p=8;if((p|0)==8){u_b(h,3,507646,327);r_b(i,p_b(p_b(h,507757)|0,507799)|0);v_b(h);o=j}j=(f[(f[o+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;f[j>>2]=d;f[j+4>>2]=e;u=g;return}function Mrc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=u;u=u+32|0;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=o;x=v;break}else if((r|0)==10){w=o;x=n;break}}else{w=l;x=l}while(0);l=f[x>>2]|0;if(!l){r=$Xc(48)|0;f[r+16>>2]=c;c=r+24|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=w;f[x>>2]=r;w=f[f[a>>2]>>2]|0;if(!w)y=r;else{f[a>>2]=w;y=f[x>>2]|0}UQ(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[r+40>>2]=i;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22048,16);r=RXb(e,16,2281)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[c>>2]=z;A=c}else{f[l+40>>2]=i;A=l+24|0}l=f[A>>2]|0;A=f[l>>2]|0;if((A|0)!=(f[l+4>>2]|0)){B=A;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}_Ma(l,A+1|0);B=f[l>>2]|0;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}function Nrc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Orc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function Prc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=m;v=s;break}else if((p|0)==10){t=m;v=l;break}}else{t=j;v=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=$Xc(48)|0;f[j+16>>2]=c;c=j+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=t;f[v>>2]=j;t=f[f[a>>2]>>2]|0;if(!t)A=j;else{f[a>>2]=t;A=f[v>>2]|0}UQ(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=c;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function Qrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,328);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function Rrc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}u_b(g,3,507646,328);r_b(h,p_b(p_b(g,507757)|0,507799)|0);v_b(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function Src(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=n;w=t;break}else if((q|0)==10){v=n;w=m;break}}else{v=k;w=k}while(0);k=f[w>>2]|0;if(!k){q=$Xc(48)|0;f[q+16>>2]=c;c=q+24|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=v;f[w>>2]=q;v=f[f[a>>2]>>2]|0;if(!v)x=q;else{f[a>>2]=v;x=f[w>>2]|0}UQ(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22056,16);q=RXb(e,16,2282)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[c>>2]=y;z=c}else{f[k+40>>2]=h;z=k+24|0}k=f[z>>2]|0;z=f[k>>2]|0;if((z|0)!=(f[k+4>>2]|0)){A=z;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}xHa(k,z+1|0);A=f[k>>2]|0;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}function Trc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Urc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(b[g+18>>0]&1)==0:0){g=k+24|0;l=f[g+4>>2]|0;m=f[g>>2]|0}else{l=e;m=d}}else{l=e;m=d}J=l;return m|0}function Vrc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=n;w=t;break}else if((q|0)==10){v=n;w=m;break}}else{v=k;w=k}while(0);k=f[w>>2]|0;if(k|0){f[k+40>>2]=h;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}k=$Xc(48)|0;f[k+16>>2]=c;c=k+24|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=v;f[w>>2]=k;v=f[f[a>>2]>>2]|0;if(!v)F=k;else{f[a>>2]=v;F=f[w>>2]|0}UQ(f[a+4>>2]|0,F);F=a+8|0;f[F>>2]=(f[F>>2]|0)+1;f[k+40>>2]=h;b[k+32>>0]=d;b[k+33>>0]=0;x=c;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}function Wrc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,329);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}h=(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;J=f[h+4>>2]|0;u=d;return f[h>>2]|0}function Xrc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g;i=g+24|0;j=a+4|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(b|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)<=(b|0):0)o=n;else p=8}else p=8;if((p|0)==8){u_b(h,3,507646,329);r_b(i,p_b(p_b(h,507757)|0,507799)|0);v_b(h);o=j}j=(f[(f[o+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;f[j>>2]=d;f[j+4>>2]=e;u=g;return}function Yrc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=u;u=u+32|0;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=o;x=v;break}else if((r|0)==10){w=o;x=n;break}}else{w=l;x=l}while(0);l=f[x>>2]|0;if(!l){r=$Xc(48)|0;f[r+16>>2]=c;c=r+24|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=w;f[x>>2]=r;w=f[f[a>>2]>>2]|0;if(!w)y=r;else{f[a>>2]=w;y=f[x>>2]|0}UQ(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[r+40>>2]=i;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22064,16);r=RXb(e,16,2283)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[c>>2]=z;A=c}else{f[l+40>>2]=i;A=l+24|0}l=f[A>>2]|0;A=f[l>>2]|0;if((A|0)!=(f[l+4>>2]|0)){B=A;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}mob(l,A+1|0);B=f[l>>2]|0;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+8+(B<<3)|0;G=F;H=G;f[H>>2]=g;I=G+4|0;J=I;f[J>>2]=h;u=j;return}function Zrc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function _rc(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0.0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return +g}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return +g}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return +g}if(b[e+18>>0]&1){g=d;return +g}g=+n[k+24>>2];return +g}function $rc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){o=f[m+16>>2]|0;if((o|0)>(c|0)){p=f[m>>2]|0;if(!p){q=5;break}else{r=m;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=m+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}l=r;m=s}if((q|0)==5){v=m;w=m;break}else if((q|0)==9){v=m;w=t;break}else if((q|0)==10){v=m;w=l;break}}else{v=j;w=j}while(0);j=f[w>>2]|0;if(j|0){f[j+40>>2]=g;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;n[x>>2]=e;u=h;return}j=$Xc(48)|0;f[j+16>>2]=c;c=j+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[w>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)B=j;else{f[a>>2]=v;B=f[w>>2]|0}UQ(f[a+4>>2]|0,B);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;x=c;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;n[x>>2]=e;u=h;return}function asc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else o=8}else o=8;if((o|0)==8){u_b(e,3,507646,330);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return +(+n[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2])}function bsc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){o=m;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+(c<<2)|0;n[t>>2]=d;u=e;return}}u_b(g,3,507646,330);r_b(h,p_b(p_b(g,507757)|0,507799)|0);v_b(g);o=i;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+(c<<2)|0;n[t>>2]=d;u=e;return}function csc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;o=l;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}m=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=o;x=v;break}else if((r|0)==10){w=o;x=m;break}}else{w=k;x=k}while(0);k=f[x>>2]|0;if(!k){r=$Xc(48)|0;f[r+16>>2]=c;c=r+24|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=w;f[x>>2]=r;w=f[f[a>>2]>>2]|0;if(!w)y=r;else{f[a>>2]=w;y=f[x>>2]|0}UQ(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22072,16);r=RXb(e,16,2284)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[c>>2]=z;A=c}else{f[k+40>>2]=h;A=k+24|0}k=f[A>>2]|0;A=f[k>>2]|0;if((A|0)!=(f[k+4>>2]|0)){B=A;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+4+(B<<2)|0;n[F>>2]=g;u=i;return}uHa(k,A+1|0);B=f[k>>2]|0;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+4+(B<<2)|0;n[F>>2]=g;u=i;return}function dsc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function esc(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0.0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return +g}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return +g}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return +g}if(b[e+18>>0]&1){g=d;return +g}g=+p[k+24>>3];return +g}function fsc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){q=5;break}else{r=m;s=o}}else{if((n|0)>=(c|0)){q=10;break}t=m+4|0;n=f[t>>2]|0;if(!n){q=9;break}else{r=t;s=n}}l=r;m=s}if((q|0)==5){v=m;w=m;break}else if((q|0)==9){v=m;w=t;break}else if((q|0)==10){v=m;w=l;break}}else{v=j;w=j}while(0);j=f[w>>2]|0;if(j|0){f[j+40>>2]=g;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;p[x>>3]=e;u=h;return}j=$Xc(48)|0;f[j+16>>2]=c;c=j+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[w>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)B=j;else{f[a>>2]=v;B=f[w>>2]|0}UQ(f[a+4>>2]|0,B);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;x=c;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;p[x>>3]=e;u=h;return}function gsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,331);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return +(+p[(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)>>3])}function hsc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;q=f[o>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+8+(c<<3)|0;p[t>>3]=d;u=e;return}}u_b(g,3,507646,331);r_b(h,p_b(p_b(g,507757)|0,507799)|0);v_b(g);n=i;o=n+24|0;q=f[o>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+8+(c<<3)|0;p[t>>3]=d;u=e;return}function isc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){q=f[n>>2]|0;if(!q){r=5;break}else{s=n;t=q}}else{if((o|0)>=(c|0)){r=10;break}v=n+4|0;o=f[v>>2]|0;if(!o){r=9;break}else{s=v;t=o}}m=s;n=t}if((r|0)==5){w=n;x=n;break}else if((r|0)==9){w=n;x=v;break}else if((r|0)==10){w=n;x=m;break}}else{w=k;x=k}while(0);k=f[x>>2]|0;if(!k){r=$Xc(48)|0;f[r+16>>2]=c;c=r+24|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=w;f[x>>2]=r;w=f[f[a>>2]>>2]|0;if(!w)y=r;else{f[a>>2]=w;y=f[x>>2]|0}UQ(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;z=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22080,16);r=RXb(e,16,2285)|0;f[r>>2]=0;f[r+4>>2]=0;d=r+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;z=r}f[c>>2]=z;A=c}else{f[k+40>>2]=h;A=k+24|0}k=f[A>>2]|0;A=f[k>>2]|0;if((A|0)!=(f[k+4>>2]|0)){B=A;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+8+(B<<3)|0;p[F>>3]=g;u=i;return}ZMa(k,A+1|0);B=f[k>>2]|0;C=k+8|0;D=f[C>>2]|0;E=B+1|0;f[k>>2]=E;F=D+8+(B<<3)|0;p[F>>3]=g;u=i;return}function jsc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function ksc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=(b[k+24>>0]|0)!=0;return g|0}function lsc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=e&1;e=h+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=m;v=s;break}else if((p|0)==10){t=m;v=l;break}}else{t=j;v=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;b[w>>0]=i;u=h;return}j=$Xc(48)|0;f[j+16>>2]=c;c=j+24|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=t;f[v>>2]=j;t=f[f[a>>2]>>2]|0;if(!t)A=j;else{f[a>>2]=t;A=f[v>>2]|0}UQ(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=c;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;b[w>>0]=i;u=h;return}function msc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(c|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(c|0):0)n=m;else o=8}else o=8;if((o|0)==8){u_b(g,3,507646,332);r_b(h,p_b(p_b(g,507757)|0,507799)|0);v_b(g);n=i}u=e;return (b[(f[(f[n+24>>2]|0)+8>>2]|0)+4+d>>0]|0)!=0|0}function nsc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g;i=g+24|0;j=e&1;e=a+4|0;a=f[e>>2]|0;if(a|0){k=e;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(c|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(e|0)?(f[n+16>>2]|0)<=(c|0):0){o=n;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+d|0;b[t>>0]=j;u=g;return}}u_b(h,3,507646,332);r_b(i,p_b(p_b(h,507757)|0,507799)|0);v_b(h);o=e;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+d|0;b[t>>0]=j;u=g;return}function osc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=g&1;g=i+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=n;w=t;break}else if((q|0)==10){v=n;w=m;break}}else{v=k;w=k}while(0);k=f[w>>2]|0;if(!k){q=$Xc(48)|0;f[q+16>>2]=c;c=q+24|0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];f[c+8>>2]=f[g+8>>2];f[c+12>>2]=f[g+12>>2];f[c+16>>2]=f[g+16>>2];f[c+20>>2]=f[g+20>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=v;f[w>>2]=q;v=f[f[a>>2]>>2]|0;if(!v)x=q;else{f[a>>2]=v;x=f[w>>2]|0}UQ(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22088,16);q=RXb(e,16,2286)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[c>>2]=y;z=c}else{f[k+40>>2]=h;z=k+24|0}k=f[z>>2]|0;z=f[k>>2]|0;if((z|0)!=(f[k+4>>2]|0)){A=z;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+A|0;b[E>>0]=j;u=i;return}wSa(k,z+1|0);A=f[k>>2]|0;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+A|0;b[E>>0]=j;u=i;return}function psc(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function qsc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=m;v=s;break}else if((p|0)==10){t=m;v=l;break}}else{t=j;v=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=f[w>>2]|0;u=h;return x|0}j=$Xc(48)|0;f[j+16>>2]=c;c=j+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=t;f[v>>2]=j;t=f[f[a>>2]>>2]|0;if(!t)y=j;else{f[a>>2]=t;y=f[v>>2]|0}UQ(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[j+40>>2]=g;b[j+33>>0]=1;b[j+32>>0]=d;b[j+35>>0]=e&1;do switch(f[165492+((d&255)<<2)>>2]|0){case 1:{e=f[a+12>>2]|0;if(!e){j=$Xc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;z=j}else{j=e+64|0;if(f[j>>2]|0)SXb(e,22040,16);g=RXb(e,16,2280)|0;f[g>>2]=0;f[g+4>>2]=0;y=g+8|0;f[y>>2]=0;if(f[j>>2]|0)SXb(e,25456,8);j=QXb(e,8)|0;f[y>>2]=j;f[j>>2]=e;z=g}f[c>>2]=z;w=c;x=f[w>>2]|0;u=h;return x|0}case 2:{g=f[a+12>>2]|0;if(!g){e=$Xc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;A=e}else{e=g+64|0;if(f[e>>2]|0)SXb(g,22048,16);j=RXb(g,16,2281)|0;f[j>>2]=0;f[j+4>>2]=0;y=j+8|0;f[y>>2]=0;if(f[e>>2]|0)SXb(g,25456,8);e=QXb(g,8)|0;f[y>>2]=e;f[e>>2]=g;A=j}f[c>>2]=A;w=c;x=f[w>>2]|0;u=h;return x|0}case 3:{j=f[a+12>>2]|0;if(!j){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;B=g}else{g=j+64|0;if(f[g>>2]|0)SXb(j,22056,16);e=RXb(j,16,2282)|0;f[e>>2]=0;f[e+4>>2]=0;y=e+8|0;f[y>>2]=0;if(f[g>>2]|0)SXb(j,25456,8);g=QXb(j,8)|0;f[y>>2]=g;f[g>>2]=j;B=e}f[c>>2]=B;w=c;x=f[w>>2]|0;u=h;return x|0}case 4:{e=f[a+12>>2]|0;if(!e){j=$Xc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;C=j}else{j=e+64|0;if(f[j>>2]|0)SXb(e,22064,16);g=RXb(e,16,2283)|0;f[g>>2]=0;f[g+4>>2]=0;y=g+8|0;f[y>>2]=0;if(f[j>>2]|0)SXb(e,25456,8);j=QXb(e,8)|0;f[y>>2]=j;f[j>>2]=e;C=g}f[c>>2]=C;w=c;x=f[w>>2]|0;u=h;return x|0}case 5:{g=f[a+12>>2]|0;if(!g){e=$Xc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;D=e}else{e=g+64|0;if(f[e>>2]|0)SXb(g,22080,16);j=RXb(g,16,2285)|0;f[j>>2]=0;f[j+4>>2]=0;y=j+8|0;f[y>>2]=0;if(f[e>>2]|0)SXb(g,25456,8);e=QXb(g,8)|0;f[y>>2]=e;f[e>>2]=g;D=j}f[c>>2]=D;w=c;x=f[w>>2]|0;u=h;return x|0}case 6:{j=f[a+12>>2]|0;if(!j){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;E=g}else{g=j+64|0;if(f[g>>2]|0)SXb(j,22072,16);e=RXb(j,16,2284)|0;f[e>>2]=0;f[e+4>>2]=0;y=e+8|0;f[y>>2]=0;if(f[g>>2]|0)SXb(j,25456,8);g=QXb(j,8)|0;f[y>>2]=g;f[g>>2]=j;E=e}f[c>>2]=E;w=c;x=f[w>>2]|0;u=h;return x|0}case 7:{e=f[a+12>>2]|0;if(!e){j=$Xc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;F=j}else{j=e+64|0;if(f[j>>2]|0)SXb(e,22088,16);g=RXb(e,16,2286)|0;f[g>>2]=0;f[g+4>>2]=0;y=g+8|0;f[y>>2]=0;if(f[j>>2]|0)SXb(e,25456,8);j=QXb(e,8)|0;f[y>>2]=j;f[j>>2]=e;F=g}f[c>>2]=F;w=c;x=f[w>>2]|0;u=h;return x|0}case 8:{g=f[a+12>>2]|0;if(!g){e=$Xc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G=e}else{e=g+64|0;if(f[e>>2]|0)SXb(g,22040,16);j=RXb(g,16,2280)|0;f[j>>2]=0;f[j+4>>2]=0;y=j+8|0;f[y>>2]=0;if(f[e>>2]|0)SXb(g,25456,8);e=QXb(g,8)|0;f[y>>2]=e;f[e>>2]=g;G=j}f[c>>2]=G;w=c;x=f[w>>2]|0;u=h;return x|0}case 9:{j=f[a+12>>2]|0;if(!j){g=$Xc(16)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;H=g}else{if(f[j+64>>2]|0)SXb(j,22096,16);g=RXb(j,16,2287)|0;f[g>>2]=j;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;H=g}f[c>>2]=H;w=c;x=f[w>>2]|0;u=h;return x|0}case 10:{g=f[a+12>>2]|0;if(!g){j=$Xc(16)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;I=j}else{if(f[g+64>>2]|0)SXb(g,21424,16);j=RXb(g,16,2275)|0;f[j>>2]=g;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;I=j}f[c>>2]=I;w=c;x=f[w>>2]|0;u=h;return x|0}default:{w=c;x=f[w>>2]|0;u=h;return x|0}}while(0);return 0}function rsc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+12|0;d=f[c>>2]|0;if(!d){f[c>>2]=0;return}if(f[a>>2]|0){f[c>>2]=0;return}a=f[d>>2]|0;if((a|0)>0){e=0;do{g=f[d+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);cYc(g)}e=e+1|0}while((e|0)!=(a|0));h=f[c>>2]|0}else h=d;cYc(h);f[c>>2]=0;return}function ssc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function tsc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=m;v=s;break}else if((p|0)==10){t=m;v=l;break}}else{t=j;v=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=$Xc(48)|0;f[j+16>>2]=c;c=j+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=t;f[v>>2]=j;t=f[f[a>>2]>>2]|0;if(!t)A=j;else{f[a>>2]=t;A=f[v>>2]|0}UQ(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=c;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function usc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,450);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function vsc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}u_b(g,3,507646,457);r_b(h,p_b(p_b(g,507757)|0,507799)|0);v_b(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function wsc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=n;w=t;break}else if((q|0)==10){v=n;w=m;break}}else{v=k;w=k}while(0);k=f[w>>2]|0;if(!k){q=$Xc(48)|0;f[q+16>>2]=c;c=q+24|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=v;f[w>>2]=q;v=f[f[a>>2]>>2]|0;if(!v)x=q;else{f[a>>2]=v;x=f[w>>2]|0}UQ(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;f[q+40>>2]=h;b[q+32>>0]=d;b[q+33>>0]=1;b[q+35>>0]=e&1;e=f[a+12>>2]|0;if(!e){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;y=a}else{a=e+64|0;if(f[a>>2]|0)SXb(e,22040,16);q=RXb(e,16,2280)|0;f[q>>2]=0;f[q+4>>2]=0;d=q+8|0;f[d>>2]=0;if(f[a>>2]|0)SXb(e,25456,8);a=QXb(e,8)|0;f[d>>2]=a;f[a>>2]=e;y=q}f[c>>2]=y;z=c}else{f[k+40>>2]=h;z=k+24|0}k=f[z>>2]|0;z=f[k>>2]|0;if((z|0)!=(f[k+4>>2]|0)){A=z;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}qHa(k,z+1|0);A=f[k>>2]|0;B=k+8|0;C=f[B>>2]|0;D=A+1|0;f[k>>2]=D;E=C+4+(A<<2)|0;f[E>>2]=g;u=i;return}function xsc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function ysc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+32|0;h=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;i=a+4|0;j=f[i>>2]|0;do if(j){k=a+4|0;l=j;while(1){m=f[l+16>>2]|0;if((m|0)>(c|0)){n=f[l>>2]|0;if(!n){o=5;break}else{p=l;q=n}}else{if((m|0)>=(c|0)){o=10;break}r=l+4|0;m=f[r>>2]|0;if(!m){o=9;break}else{p=r;q=m}}k=p;l=q}if((o|0)==5){s=l;t=l;break}else if((o|0)==9){s=l;t=r;break}else if((o|0)==10){s=l;t=k;break}}else{s=i;t=i}while(0);i=f[t>>2]|0;if(i|0){f[i+40>>2]=e;v=i+24|0;w=v+10|0;x=b[w>>0]|0;y=x&-16;b[w>>0]=y;z=f[v>>2]|0;u=g;return z|0}i=$Xc(48)|0;f[i+16>>2]=c;c=i+24|0;f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=s;f[t>>2]=i;s=f[f[a>>2]>>2]|0;if(!s)A=i;else{f[a>>2]=s;A=f[t>>2]|0}UQ(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[i+40>>2]=e;b[i+32>>0]=d;b[i+33>>0]=0;i=f[a+12>>2]|0;if(!i){a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;B=a}else{if(f[i+64>>2]|0)SXb(i,4984,16);a=RXb(i,16,2233)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;B=a}f[c>>2]=B;v=c;w=v+10|0;x=b[w>>0]|0;y=x&-16;b[w>>0]=y;z=f[v>>2]|0;u=g;return z|0}function zsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,512);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function Asc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,519);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function Bsc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+32|0;h=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;i=a+4|0;j=f[i>>2]|0;do if(j){k=a+4|0;l=j;while(1){m=f[l+16>>2]|0;if((m|0)>(c|0)){n=f[l>>2]|0;if(!n){o=5;break}else{p=l;q=n}}else{if((m|0)>=(c|0)){o=10;break}r=l+4|0;m=f[r>>2]|0;if(!m){o=9;break}else{p=r;q=m}}k=p;l=q}if((o|0)==5){s=l;t=l;break}else if((o|0)==9){s=l;t=r;break}else if((o|0)==10){s=l;t=k;break}}else{s=i;t=i}while(0);i=f[t>>2]|0;if(i|0){f[i+40>>2]=e;v=i+24|0;w=f[v>>2]|0;x=pHa(w)|0;u=g;return x|0}i=$Xc(48)|0;f[i+16>>2]=c;c=i+24|0;f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=s;f[t>>2]=i;s=f[f[a>>2]>>2]|0;if(!s)y=i;else{f[a>>2]=s;y=f[t>>2]|0}UQ(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[i+40>>2]=e;b[i+32>>0]=d;b[i+33>>0]=1;b[i+35>>0]=0;i=f[a+12>>2]|0;if(!i){a=$Xc(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;z=a}else{if(f[i+64>>2]|0)SXb(i,22096,16);a=RXb(i,16,2287)|0;f[a>>2]=i;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;z=a}f[c>>2]=z;v=c;w=f[v>>2]|0;x=pHa(w)|0;u=g;return x|0}function Csc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=m;v=s;break}else if((p|0)==10){t=m;v=l;break}}else{t=j;v=j}while(0);j=f[v>>2]|0;if(!j){p=$Xc(48)|0;f[p+16>>2]=c;c=p+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=t;f[v>>2]=p;t=f[f[a>>2]>>2]|0;if(!t)w=p;else{f[a>>2]=t;w=f[v>>2]|0}UQ(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;f[p+40>>2]=g;b[p+32>>0]=d;b[p+33>>0]=0;d=p+34|0;b[d>>0]=b[d>>0]&15;p=Mi[f[(f[e>>2]|0)+16>>2]&1023](e,f[a+12>>2]|0)|0;f[c>>2]=p;b[d>>0]=b[d>>0]&-16;x=p;u=h;return x|0}else{f[j+40>>2]=g;g=j+34|0;p=b[g>>0]|0;b[g>>0]=p&-16;g=f[j+24>>2]|0;if(!(p&16)){x=g;u=h;return x|0}x=Mi[f[(f[g>>2]|0)+16>>2]&1023](g,e)|0;u=h;return x|0}return 0}function Dsc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+32|0;i=h;if(!g){j=a+4|0;k=f[j>>2]|0;if(!k){u=h;return}else{l=j;m=k}a:while(1){k=m;while(1){if((f[k+16>>2]|0)>=(c|0))break;n=f[k+4>>2]|0;if(!n){o=l;break a}else k=n}m=f[k>>2]|0;if(!m){o=k;break}else l=k}if((o|0)==(j|0)){u=h;return}if((f[o+16>>2]|0)>(c|0)){u=h;return}Arc(o+24|0);u=h;return}o=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;i=a+4|0;j=f[i>>2]|0;do if(j){l=a+4|0;m=j;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){p=f[m>>2]|0;if(!p){q=14;break}else{r=m;s=p}}else{if((n|0)>=(c|0)){q=19;break}t=m+4|0;n=f[t>>2]|0;if(!n){q=18;break}else{r=t;s=n}}l=r;m=s}if((q|0)==14){v=m;w=m;break}else if((q|0)==18){v=m;w=t;break}else if((q|0)==19){v=m;w=l;break}}else{v=i;w=i}while(0);i=f[w>>2]|0;do if(!i){q=$Xc(48)|0;f[q+16>>2]=c;t=q+24|0;f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];f[t+12>>2]=f[o+12>>2];f[t+16>>2]=f[o+16>>2];f[t+20>>2]=f[o+20>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=v;f[w>>2]=q;s=f[f[a>>2]>>2]|0;if(!s)x=q;else{f[a>>2]=s;x=f[w>>2]|0}UQ(f[a+4>>2]|0,x);s=a+8|0;f[s>>2]=(f[s>>2]|0)+1;f[q+40>>2]=e;b[q+32>>0]=d;b[q+33>>0]=0;s=q+34|0;b[s>>0]=b[s>>0]&15;f[t>>2]=g;y=q}else{q=i+24|0;f[i+40>>2]=e;if(b[i+34>>0]&16){t=f[q>>2]|0;mi[f[(f[t>>2]|0)+24>>2]&2047](t,g);y=i;break}if((f[a+12>>2]|0)==0?(t=f[q>>2]|0,t|0):0)Yi[f[(f[t>>2]|0)+4>>2]&4095](t);f[q>>2]=g;y=i}while(0);i=y+34|0;b[i>>0]=b[i>>0]&-16;u=h;return}function Esc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,725);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function Fsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){u_b(e,3,507646,732);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function Gsc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+32|0;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=m;v=s;break}else if((p|0)==10){t=m;v=l;break}}else{t=j;v=j}while(0);j=f[v>>2]|0;if(!j){p=$Xc(48)|0;f[p+16>>2]=c;c=p+24|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=t;f[v>>2]=p;t=f[f[a>>2]>>2]|0;if(!t)w=p;else{f[a>>2]=t;w=f[v>>2]|0}UQ(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;f[p+40>>2]=g;b[p+32>>0]=d;b[p+33>>0]=1;p=f[a+12>>2]|0;if(!p){d=$Xc(16)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;x=d}else{if(f[p+64>>2]|0)SXb(p,21424,16);d=RXb(p,16,2275)|0;f[d>>2]=p;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;x=d}f[c>>2]=x;y=c}else{f[j+40>>2]=g;y=j+24|0}j=f[y>>2]|0;g=f[j+12>>2]|0;if((g|0?(c=j+4|0,j=f[c>>2]|0,(j|0)<(f[g>>2]|0)):0)?(f[c>>2]=j+1,c=f[g+4+(j<<2)>>2]|0,c|0):0){z=c;u=h;return z|0}c=Mi[f[(f[e>>2]|0)+16>>2]&1023](e,f[a+12>>2]|0)|0;Dgc(f[y>>2]|0,c);z=c;u=h;return z|0}function Hsc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d;g=d+24|0;i=a+4|0;a=f[i>>2]|0;if(a){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(c|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(c|0):0)n=m;else o=8}else o=8;if((o|0)==8){u_b(e,3,507646,771);r_b(g,p_b(p_b(e,507757)|0,507799)|0);v_b(e);n=i}i=n+24|0;do switch(f[165492+(h[n+32>>0]<<2)>>2]|0){case 1:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 2:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 3:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 4:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 6:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 5:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 7:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 8:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 9:{e=f[i>>2]|0;g=f[e+12>>2]|0;o=e+4|0;e=(f[o>>2]|0)+-1|0;f[o>>2]=e;o=f[g+4+(e<<2)>>2]|0;e=o+11|0;if((b[e>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0;u=d;return}else{b[o>>0]=0;b[e>>0]=0;u=d;return}break}case 10:{e=f[i>>2]|0;o=f[e+12>>2]|0;g=e+4|0;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;g=f[o+4+(e<<2)>>2]|0;Yi[f[(f[g>>2]|0)+28>>2]&4095](g);u=d;return}default:{u=d;return}}while(0)}function Isc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=c+24|0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(b|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)!=(g|0)?(f[k+16>>2]|0)<=(b|0):0)l=k;else m=8}else m=8;if((m|0)==8){u_b(d,3,507646,812);r_b(e,p_b(p_b(d,507757)|0,507799)|0);v_b(d);l=g}g=f[l+24>>2]|0;l=f[g+12>>2]|0;d=g+4|0;g=f[d>>2]|0;e=g+-1|0;f[d>>2]=e;d=l+4+(e<<2)|0;e=f[d>>2]|0;m=f[l>>2]|0;k=m+-1|0;f[l>>2]=k;if((g|0)>=(m|0)){u=c;return e|0}f[d>>2]=f[l+4+(k<<2)>>2];u=c;return e|0}function Jsc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0;g=u;u=u+32|0;i=g;j=g+24|0;k=a+4|0;a=f[k>>2]|0;if(a){l=k;m=a;a:while(1){a=m;while(1){if((f[a+16>>2]|0)>=(c|0))break;n=f[a+4>>2]|0;if(!n){o=l;break a}else a=n}m=f[a>>2]|0;if(!m){o=a;break}else l=a}if((o|0)!=(k|0)?(f[o+16>>2]|0)<=(c|0):0)q=o;else r=8}else r=8;if((r|0)==8){u_b(i,3,507646,822);r_b(j,p_b(p_b(i,507757)|0,507799)|0);v_b(i);q=k}k=q+24|0;do switch(f[165492+((h[q+32>>0]|0)<<2)>>2]|0){case 1:{i=f[(f[k>>2]|0)+8>>2]|0;j=i+4+(d<<2)|0;r=i+4+(e<<2)|0;i=f[j>>2]|0;f[j>>2]=f[r>>2];f[r>>2]=i;u=g;return}case 2:{i=f[(f[k>>2]|0)+8>>2]|0;r=i+8+(d<<3)|0;j=i+8+(e<<3)|0;i=r;o=f[i>>2]|0;c=f[i+4>>2]|0;i=j;l=f[i+4>>2]|0;m=r;f[m>>2]=f[i>>2];f[m+4>>2]=l;l=j;f[l>>2]=o;f[l+4>>2]=c;u=g;return}case 3:{c=f[(f[k>>2]|0)+8>>2]|0;l=c+4+(d<<2)|0;o=c+4+(e<<2)|0;c=f[l>>2]|0;f[l>>2]=f[o>>2];f[o>>2]=c;u=g;return}case 4:{c=f[(f[k>>2]|0)+8>>2]|0;o=c+8+(d<<3)|0;l=c+8+(e<<3)|0;c=o;j=f[c>>2]|0;m=f[c+4>>2]|0;c=l;i=f[c+4>>2]|0;r=o;f[r>>2]=f[c>>2];f[r+4>>2]=i;i=l;f[i>>2]=j;f[i+4>>2]=m;u=g;return}case 6:{m=f[(f[k>>2]|0)+8>>2]|0;i=m+4+(d<<2)|0;j=m+4+(e<<2)|0;m=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=m;u=g;return}case 5:{m=f[(f[k>>2]|0)+8>>2]|0;j=m+8+(d<<3)|0;i=m+8+(e<<3)|0;s=+p[j>>3];p[j>>3]=+p[i>>3];p[i>>3]=s;u=g;return}case 7:{i=f[(f[k>>2]|0)+8>>2]|0;j=i+4+d|0;m=i+4+e|0;i=b[j>>0]|0;b[j>>0]=b[m>>0]|0;b[m>>0]=i;u=g;return}case 8:{i=f[(f[k>>2]|0)+8>>2]|0;m=i+4+(d<<2)|0;j=i+4+(e<<2)|0;i=f[m>>2]|0;f[m>>2]=f[j>>2];f[j>>2]=i;u=g;return}case 9:{i=f[(f[k>>2]|0)+12>>2]|0;j=i+4+(d<<2)|0;m=i+4+(e<<2)|0;i=f[j>>2]|0;f[j>>2]=f[m>>2];f[m>>2]=i;u=g;return}case 10:{i=f[(f[k>>2]|0)+12>>2]|0;m=i+4+(d<<2)|0;j=i+4+(e<<2)|0;i=f[m>>2]|0;f[m>>2]=f[j>>2];f[j>>2]=i;u=g;return}default:{u=g;return}}while(0)}function Ksc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0))return;else d=b;while(1){Arc(d+24|0);b=f[d+4>>2]|0;if(!b){a=d+8|0;e=f[a>>2]|0;if((f[e>>2]|0)==(d|0))g=e;else{e=a;do{a=f[e>>2]|0;e=a+8|0;h=f[e>>2]|0}while((f[h>>2]|0)!=(a|0));g=h}}else{e=b;while(1){h=f[e>>2]|0;if(!h)break;else e=h}g=e}if((g|0)==(c|0))break;else d=g}return}function Lsc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[b>>2]|0;d=b+4|0;if((c|0)==(d|0))return;else e=c;while(1){Msc(a,f[e+16>>2]|0,e+24|0);c=f[e+4>>2]|0;if(!c){b=e+8|0;g=f[b>>2]|0;if((f[g>>2]|0)==(e|0))h=g;else{g=b;do{b=f[g>>2]|0;g=b+8|0;i=f[g>>2]|0}while((f[i>>2]|0)!=(b|0));h=i}}else{g=c;while(1){i=f[g>>2]|0;if(!i)break;else g=i}h=g}if((h|0)==(d|0))break;else e=h}return}function Msc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;e=u;u=u+32|0;g=e;if(b[d+9>>0]|0){h=f[d+16>>2]|0;i=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){q=6;break}else{r=m;s=o}}else{if((n|0)>=(c|0)){q=11;break}t=m+4|0;n=f[t>>2]|0;if(!n){q=10;break}else{r=t;s=n}}l=r;m=s}if((q|0)==6){v=m;w=m;break}else if((q|0)==10){v=m;w=t;break}else if((q|0)==11){v=m;w=l;break}}else{v=j;w=j}while(0);j=f[w>>2]|0;if(!j){t=$Xc(48)|0;f[t+16>>2]=c;s=t+24|0;f[s>>2]=f[i>>2];f[s+4>>2]=f[i+4>>2];f[s+8>>2]=f[i+8>>2];f[s+12>>2]=f[i+12>>2];f[s+16>>2]=f[i+16>>2];f[s+20>>2]=f[i+20>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=v;f[w>>2]=t;v=f[f[a>>2]>>2]|0;if(!v)x=t;else{f[a>>2]=v;x=f[w>>2]|0}UQ(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;f[t+40>>2]=h;x=b[d+8>>0]|0;b[t+32>>0]=x;b[t+35>>0]=b[d+11>>0]|0;b[t+33>>0]=1;y=1;z=x;A=s}else{f[j+40>>2]=h;y=0;z=b[d+8>>0]|0;A=j+24|0}do switch(f[165492+((z&255)<<2)>>2]|0){case 1:{if(y){j=f[a+12>>2]|0;if(!j){h=$Xc(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=h}else{h=j+64|0;if(f[h>>2]|0)SXb(j,22040,16);s=RXb(j,16,2280)|0;f[s>>2]=0;f[s+4>>2]=0;x=s+8|0;f[x>>2]=0;if(f[h>>2]|0)SXb(j,25456,8);h=QXb(j,8)|0;f[x>>2]=h;f[h>>2]=j;B=s}f[A>>2]=B;C=B}else C=f[A>>2]|0;s=f[d>>2]|0;j=f[s>>2]|0;if(!j){u=e;return}qHa(C,(f[C>>2]|0)+j|0);o1c((f[C+8>>2]|0)+4+(f[C>>2]<<2)|0,(f[s+8>>2]|0)+4|0,f[s>>2]<<2|0)|0;f[C>>2]=(f[C>>2]|0)+(f[s>>2]|0);u=e;return}case 2:{if(y){s=f[a+12>>2]|0;if(!s){j=$Xc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;D=j}else{j=s+64|0;if(f[j>>2]|0)SXb(s,22048,16);h=RXb(s,16,2281)|0;f[h>>2]=0;f[h+4>>2]=0;x=h+8|0;f[x>>2]=0;if(f[j>>2]|0)SXb(s,25456,8);j=QXb(s,8)|0;f[x>>2]=j;f[j>>2]=s;D=h}f[A>>2]=D;E=D}else E=f[A>>2]|0;h=f[d>>2]|0;s=f[h>>2]|0;if(!s){u=e;return}_Ma(E,(f[E>>2]|0)+s|0);o1c((f[E+8>>2]|0)+8+(f[E>>2]<<3)|0,(f[h+8>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[E>>2]=(f[E>>2]|0)+(f[h>>2]|0);u=e;return}case 3:{if(y){h=f[a+12>>2]|0;if(!h){s=$Xc(12)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;F=s}else{s=h+64|0;if(f[s>>2]|0)SXb(h,22056,16);j=RXb(h,16,2282)|0;f[j>>2]=0;f[j+4>>2]=0;x=j+8|0;f[x>>2]=0;if(f[s>>2]|0)SXb(h,25456,8);s=QXb(h,8)|0;f[x>>2]=s;f[s>>2]=h;F=j}f[A>>2]=F;G=F}else G=f[A>>2]|0;j=f[d>>2]|0;h=f[j>>2]|0;if(!h){u=e;return}xHa(G,(f[G>>2]|0)+h|0);o1c((f[G+8>>2]|0)+4+(f[G>>2]<<2)|0,(f[j+8>>2]|0)+4|0,f[j>>2]<<2|0)|0;f[G>>2]=(f[G>>2]|0)+(f[j>>2]|0);u=e;return}case 4:{if(y){j=f[a+12>>2]|0;if(!j){h=$Xc(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=h}else{h=j+64|0;if(f[h>>2]|0)SXb(j,22064,16);s=RXb(j,16,2283)|0;f[s>>2]=0;f[s+4>>2]=0;x=s+8|0;f[x>>2]=0;if(f[h>>2]|0)SXb(j,25456,8);h=QXb(j,8)|0;f[x>>2]=h;f[h>>2]=j;H=s}f[A>>2]=H;I=H}else I=f[A>>2]|0;s=f[d>>2]|0;j=f[s>>2]|0;if(!j){u=e;return}mob(I,(f[I>>2]|0)+j|0);o1c((f[I+8>>2]|0)+8+(f[I>>2]<<3)|0,(f[s+8>>2]|0)+8|0,f[s>>2]<<3|0)|0;f[I>>2]=(f[I>>2]|0)+(f[s>>2]|0);u=e;return}case 6:{if(y){s=f[a+12>>2]|0;if(!s){j=$Xc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;J=j}else{j=s+64|0;if(f[j>>2]|0)SXb(s,22072,16);h=RXb(s,16,2284)|0;f[h>>2]=0;f[h+4>>2]=0;x=h+8|0;f[x>>2]=0;if(f[j>>2]|0)SXb(s,25456,8);j=QXb(s,8)|0;f[x>>2]=j;f[j>>2]=s;J=h}f[A>>2]=J;K=J}else K=f[A>>2]|0;h=f[d>>2]|0;s=f[h>>2]|0;if(!s){u=e;return}uHa(K,(f[K>>2]|0)+s|0);o1c((f[K+8>>2]|0)+4+(f[K>>2]<<2)|0,(f[h+8>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[K>>2]=(f[K>>2]|0)+(f[h>>2]|0);u=e;return}case 5:{if(y){h=f[a+12>>2]|0;if(!h){s=$Xc(12)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;L=s}else{s=h+64|0;if(f[s>>2]|0)SXb(h,22080,16);j=RXb(h,16,2285)|0;f[j>>2]=0;f[j+4>>2]=0;x=j+8|0;f[x>>2]=0;if(f[s>>2]|0)SXb(h,25456,8);s=QXb(h,8)|0;f[x>>2]=s;f[s>>2]=h;L=j}f[A>>2]=L;M=L}else M=f[A>>2]|0;j=f[d>>2]|0;h=f[j>>2]|0;if(!h){u=e;return}ZMa(M,(f[M>>2]|0)+h|0);o1c((f[M+8>>2]|0)+8+(f[M>>2]<<3)|0,(f[j+8>>2]|0)+8|0,f[j>>2]<<3|0)|0;f[M>>2]=(f[M>>2]|0)+(f[j>>2]|0);u=e;return}case 7:{if(y){j=f[a+12>>2]|0;if(!j){h=$Xc(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;N=h}else{h=j+64|0;if(f[h>>2]|0)SXb(j,22088,16);s=RXb(j,16,2286)|0;f[s>>2]=0;f[s+4>>2]=0;x=s+8|0;f[x>>2]=0;if(f[h>>2]|0)SXb(j,25456,8);h=QXb(j,8)|0;f[x>>2]=h;f[h>>2]=j;N=s}f[A>>2]=N;O=N}else O=f[A>>2]|0;s=f[d>>2]|0;j=f[s>>2]|0;if(!j){u=e;return}wSa(O,(f[O>>2]|0)+j|0);o1c((f[O>>2]|0)+((f[O+8>>2]|0)+4)|0,(f[s+8>>2]|0)+4|0,f[s>>2]|0)|0;f[O>>2]=(f[O>>2]|0)+(f[s>>2]|0);u=e;return}case 8:{if(y){s=f[a+12>>2]|0;if(!s){j=$Xc(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;P=j}else{j=s+64|0;if(f[j>>2]|0)SXb(s,22040,16);h=RXb(s,16,2280)|0;f[h>>2]=0;f[h+4>>2]=0;x=h+8|0;f[x>>2]=0;if(f[j>>2]|0)SXb(s,25456,8);j=QXb(s,8)|0;f[x>>2]=j;f[j>>2]=s;P=h}f[A>>2]=P;Q=P}else Q=f[A>>2]|0;h=f[d>>2]|0;s=f[h>>2]|0;if(!s){u=e;return}qHa(Q,(f[Q>>2]|0)+s|0);o1c((f[Q+8>>2]|0)+4+(f[Q>>2]<<2)|0,(f[h+8>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[Q>>2]=(f[Q>>2]|0)+(f[h>>2]|0);u=e;return}case 9:{if(y){h=f[a+12>>2]|0;if(!h){s=$Xc(16)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;R=s}else{if(f[h+64>>2]|0)SXb(h,22096,16);s=RXb(h,16,2287)|0;f[s>>2]=h;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;R=s}f[A>>2]=R;S=R}else S=f[A>>2]|0;vSa(S,f[d>>2]|0);u=e;return}case 10:{if(y){s=f[a+12>>2]|0;if(!s){h=$Xc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;T=h}else{if(f[s+64>>2]|0)SXb(s,21424,16);h=RXb(s,16,2275)|0;f[h>>2]=s;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;T=h}f[A>>2]=T}h=f[d>>2]|0;s=h+4|0;if((f[s>>2]|0)<=0){u=e;return}j=h+12|0;h=a+12|0;x=0;do{t=f[(f[j>>2]|0)+4+(x<<2)>>2]|0;w=f[A>>2]|0;v=f[w+12>>2]|0;if(((v|0)!=0?(i=w+4|0,w=f[i>>2]|0,(w|0)<(f[v>>2]|0)):0)?(f[i>>2]=w+1,i=f[v+4+(w<<2)>>2]|0,(i|0)!=0):0)U=i;else{i=Mi[f[(f[t>>2]|0)+16>>2]&1023](t,f[h>>2]|0)|0;Dgc(f[A>>2]|0,i);U=i}mi[f[(f[U>>2]|0)+40>>2]&2047](U,t);x=x+1|0}while((x|0)<(f[s>>2]|0));u=e;return}default:{u=e;return}}while(0)}U=d+10|0;if(b[U>>0]&1){u=e;return}A=d+8|0;T=b[A>>0]|0;do switch(f[165492+((T&255)<<2)>>2]|0){case 1:{y=f[d>>2]|0;S=f[d+16>>2]|0;R=g+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;f[R+16>>2]=0;f[R+20>>2]=0;Q=a+4|0;P=f[Q>>2]|0;do if(P){O=a+4|0;N=P;while(1){M=f[N+16>>2]|0;if((M|0)>(c|0)){L=f[N>>2]|0;if(!L){q=144;break}else{V=N;W=L}}else{if((M|0)>=(c|0)){q=149;break}X=N+4|0;M=f[X>>2]|0;if(!M){q=148;break}else{V=X;W=M}}O=V;N=W}if((q|0)==144){Y=N;Z=N;break}else if((q|0)==148){Y=N;Z=X;break}else if((q|0)==149){Y=N;Z=O;break}}else{Y=Q;Z=Q}while(0);Q=f[Z>>2]|0;if(!Q){P=$Xc(48)|0;f[P+16>>2]=c;M=P+24|0;f[M>>2]=f[R>>2];f[M+4>>2]=f[R+4>>2];f[M+8>>2]=f[R+8>>2];f[M+12>>2]=f[R+12>>2];f[M+16>>2]=f[R+16>>2];f[M+20>>2]=f[R+20>>2];f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=Y;f[Z>>2]=P;L=f[f[a>>2]>>2]|0;if(!L)_=P;else{f[a>>2]=L;_=f[Z>>2]|0}UQ(f[a+4>>2]|0,_);L=a+8|0;f[L>>2]=(f[L>>2]|0)+1;f[P+40>>2]=S;b[P+32>>0]=T;b[P+33>>0]=0;$=M}else{f[Q+40>>2]=S;$=Q+24|0}Q=$+10|0;b[Q>>0]=b[Q>>0]&-16;f[$>>2]=y;u=e;return}case 2:{Q=d;M=f[Q>>2]|0;P=f[Q+4>>2]|0;Q=f[d+16>>2]|0;L=g+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;K=a+4|0;J=f[K>>2]|0;do if(J){I=a+4|0;H=J;while(1){G=f[H+16>>2]|0;if((G|0)>(c|0)){F=f[H>>2]|0;if(!F){q=161;break}else{aa=H;ba=F}}else{if((G|0)>=(c|0)){q=166;break}ca=H+4|0;G=f[ca>>2]|0;if(!G){q=165;break}else{aa=ca;ba=G}}I=aa;H=ba}if((q|0)==161){da=H;ea=H;break}else if((q|0)==165){da=H;ea=ca;break}else if((q|0)==166){da=H;ea=I;break}}else{da=K;ea=K}while(0);K=f[ea>>2]|0;if(!K){J=$Xc(48)|0;f[J+16>>2]=c;y=J+24|0;f[y>>2]=f[L>>2];f[y+4>>2]=f[L+4>>2];f[y+8>>2]=f[L+8>>2];f[y+12>>2]=f[L+12>>2];f[y+16>>2]=f[L+16>>2];f[y+20>>2]=f[L+20>>2];f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=da;f[ea>>2]=J;S=f[f[a>>2]>>2]|0;if(!S)fa=J;else{f[a>>2]=S;fa=f[ea>>2]|0}UQ(f[a+4>>2]|0,fa);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[J+40>>2]=Q;b[J+32>>0]=T;b[J+33>>0]=0;ga=y}else{f[K+40>>2]=Q;ga=K+24|0}K=ga+10|0;b[K>>0]=b[K>>0]&-16;K=ga;f[K>>2]=M;f[K+4>>2]=P;u=e;return}case 3:{K=f[d>>2]|0;y=f[d+16>>2]|0;J=g+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;f[J+16>>2]=0;f[J+20>>2]=0;S=a+4|0;R=f[S>>2]|0;do if(R){O=a+4|0;N=R;while(1){G=f[N+16>>2]|0;if((G|0)>(c|0)){F=f[N>>2]|0;if(!F){q=178;break}else{ha=N;ia=F}}else{if((G|0)>=(c|0)){q=183;break}ja=N+4|0;G=f[ja>>2]|0;if(!G){q=182;break}else{ha=ja;ia=G}}O=ha;N=ia}if((q|0)==178){ka=N;la=N;break}else if((q|0)==182){ka=N;la=ja;break}else if((q|0)==183){ka=N;la=O;break}}else{ka=S;la=S}while(0);S=f[la>>2]|0;if(!S){R=$Xc(48)|0;f[R+16>>2]=c;P=R+24|0;f[P>>2]=f[J>>2];f[P+4>>2]=f[J+4>>2];f[P+8>>2]=f[J+8>>2];f[P+12>>2]=f[J+12>>2];f[P+16>>2]=f[J+16>>2];f[P+20>>2]=f[J+20>>2];f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=ka;f[la>>2]=R;M=f[f[a>>2]>>2]|0;if(!M)ma=R;else{f[a>>2]=M;ma=f[la>>2]|0}UQ(f[a+4>>2]|0,ma);M=a+8|0;f[M>>2]=(f[M>>2]|0)+1;f[R+40>>2]=y;b[R+32>>0]=T;b[R+33>>0]=0;na=P}else{f[S+40>>2]=y;na=S+24|0}S=na+10|0;b[S>>0]=b[S>>0]&-16;f[na>>2]=K;u=e;return}case 4:{S=d;P=f[S>>2]|0;R=f[S+4>>2]|0;S=f[d+16>>2]|0;M=g+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;Q=a+4|0;L=f[Q>>2]|0;do if(L){I=a+4|0;H=L;while(1){G=f[H+16>>2]|0;if((G|0)>(c|0)){F=f[H>>2]|0;if(!F){q=195;break}else{oa=H;pa=F}}else{if((G|0)>=(c|0)){q=200;break}qa=H+4|0;G=f[qa>>2]|0;if(!G){q=199;break}else{oa=qa;pa=G}}I=oa;H=pa}if((q|0)==195){ra=H;sa=H;break}else if((q|0)==199){ra=H;sa=qa;break}else if((q|0)==200){ra=H;sa=I;break}}else{ra=Q;sa=Q}while(0);Q=f[sa>>2]|0;if(!Q){L=$Xc(48)|0;f[L+16>>2]=c;K=L+24|0;f[K>>2]=f[M>>2];f[K+4>>2]=f[M+4>>2];f[K+8>>2]=f[M+8>>2];f[K+12>>2]=f[M+12>>2];f[K+16>>2]=f[M+16>>2];f[K+20>>2]=f[M+20>>2];f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=ra;f[sa>>2]=L;y=f[f[a>>2]>>2]|0;if(!y)ta=L;else{f[a>>2]=y;ta=f[sa>>2]|0}UQ(f[a+4>>2]|0,ta);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[L+40>>2]=S;b[L+32>>0]=T;b[L+33>>0]=0;ua=K}else{f[Q+40>>2]=S;ua=Q+24|0}Q=ua+10|0;b[Q>>0]=b[Q>>0]&-16;Q=ua;f[Q>>2]=P;f[Q+4>>2]=R;u=e;return}case 6:{Q=f[d>>2]|0;K=f[d+16>>2]|0;L=g+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;y=a+4|0;J=f[y>>2]|0;do if(J){O=a+4|0;N=J;while(1){G=f[N+16>>2]|0;if((G|0)>(c|0)){F=f[N>>2]|0;if(!F){q=212;break}else{va=N;wa=F}}else{if((G|0)>=(c|0)){q=217;break}xa=N+4|0;G=f[xa>>2]|0;if(!G){q=216;break}else{va=xa;wa=G}}O=va;N=wa}if((q|0)==212){ya=N;za=N;break}else if((q|0)==216){ya=N;za=xa;break}else if((q|0)==217){ya=N;za=O;break}}else{ya=y;za=y}while(0);y=f[za>>2]|0;if(!y){J=$Xc(48)|0;f[J+16>>2]=c;R=J+24|0;f[R>>2]=f[L>>2];f[R+4>>2]=f[L+4>>2];f[R+8>>2]=f[L+8>>2];f[R+12>>2]=f[L+12>>2];f[R+16>>2]=f[L+16>>2];f[R+20>>2]=f[L+20>>2];f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=ya;f[za>>2]=J;P=f[f[a>>2]>>2]|0;if(!P)Aa=J;else{f[a>>2]=P;Aa=f[za>>2]|0}UQ(f[a+4>>2]|0,Aa);P=a+8|0;f[P>>2]=(f[P>>2]|0)+1;f[J+40>>2]=K;b[J+32>>0]=T;b[J+33>>0]=0;Ba=R}else{f[y+40>>2]=K;Ba=y+24|0}y=Ba+10|0;b[y>>0]=b[y>>0]&-16;f[Ba>>2]=Q;u=e;return}case 5:{Ca=+p[d>>3];y=f[d+16>>2]|0;R=g+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;f[R+16>>2]=0;f[R+20>>2]=0;J=a+4|0;P=f[J>>2]|0;do if(P){S=a+4|0;M=P;while(1){I=f[M+16>>2]|0;if((I|0)>(c|0)){H=f[M>>2]|0;if(!H){q=229;break}else{Da=M;Ea=H}}else{if((I|0)>=(c|0)){q=234;break}Fa=M+4|0;I=f[Fa>>2]|0;if(!I){q=233;break}else{Da=Fa;Ea=I}}S=Da;M=Ea}if((q|0)==229){Ga=M;Ha=M;break}else if((q|0)==233){Ga=M;Ha=Fa;break}else if((q|0)==234){Ga=M;Ha=S;break}}else{Ga=J;Ha=J}while(0);J=f[Ha>>2]|0;if(!J){P=$Xc(48)|0;f[P+16>>2]=c;Q=P+24|0;f[Q>>2]=f[R>>2];f[Q+4>>2]=f[R+4>>2];f[Q+8>>2]=f[R+8>>2];f[Q+12>>2]=f[R+12>>2];f[Q+16>>2]=f[R+16>>2];f[Q+20>>2]=f[R+20>>2];f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=Ga;f[Ha>>2]=P;K=f[f[a>>2]>>2]|0;if(!K)Ia=P;else{f[a>>2]=K;Ia=f[Ha>>2]|0}UQ(f[a+4>>2]|0,Ia);K=a+8|0;f[K>>2]=(f[K>>2]|0)+1;f[P+40>>2]=y;b[P+32>>0]=T;b[P+33>>0]=0;Ja=Q}else{f[J+40>>2]=y;Ja=J+24|0}J=Ja+10|0;b[J>>0]=b[J>>0]&-16;p[Ja>>3]=Ca;u=e;return}case 7:{J=b[d>>0]|0;Q=f[d+16>>2]|0;P=g+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;K=a+4|0;L=f[K>>2]|0;do if(L){O=a+4|0;N=L;while(1){I=f[N+16>>2]|0;if((I|0)>(c|0)){H=f[N>>2]|0;if(!H){q=246;break}else{Ka=N;La=H}}else{if((I|0)>=(c|0)){q=251;break}Ma=N+4|0;I=f[Ma>>2]|0;if(!I){q=250;break}else{Ka=Ma;La=I}}O=Ka;N=La}if((q|0)==246){Na=N;Oa=N;break}else if((q|0)==250){Na=N;Oa=Ma;break}else if((q|0)==251){Na=N;Oa=O;break}}else{Na=K;Oa=K}while(0);K=f[Oa>>2]|0;if(!K){L=$Xc(48)|0;f[L+16>>2]=c;y=L+24|0;f[y>>2]=f[P>>2];f[y+4>>2]=f[P+4>>2];f[y+8>>2]=f[P+8>>2];f[y+12>>2]=f[P+12>>2];f[y+16>>2]=f[P+16>>2];f[y+20>>2]=f[P+20>>2];f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=Na;f[Oa>>2]=L;R=f[f[a>>2]>>2]|0;if(!R)Pa=L;else{f[a>>2]=R;Pa=f[Oa>>2]|0}UQ(f[a+4>>2]|0,Pa);R=a+8|0;f[R>>2]=(f[R>>2]|0)+1;f[L+40>>2]=Q;b[L+32>>0]=T;b[L+33>>0]=0;Qa=y}else{f[K+40>>2]=Q;Qa=K+24|0}K=Qa+10|0;b[K>>0]=b[K>>0]&-16;b[Qa>>0]=J;u=e;return}case 8:{K=f[d>>2]|0;y=f[d+16>>2]|0;L=g+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;R=a+4|0;S=f[R>>2]|0;do if(S){M=a+4|0;I=S;while(1){H=f[I+16>>2]|0;if((H|0)>(c|0)){G=f[I>>2]|0;if(!G){q=263;break}else{Ra=I;Sa=G}}else{if((H|0)>=(c|0)){q=268;break}Ta=I+4|0;H=f[Ta>>2]|0;if(!H){q=267;break}else{Ra=Ta;Sa=H}}M=Ra;I=Sa}if((q|0)==263){Ua=I;Va=I;break}else if((q|0)==267){Ua=I;Va=Ta;break}else if((q|0)==268){Ua=I;Va=M;break}}else{Ua=R;Va=R}while(0);R=f[Va>>2]|0;if(!R){S=$Xc(48)|0;f[S+16>>2]=c;J=S+24|0;f[J>>2]=f[L>>2];f[J+4>>2]=f[L+4>>2];f[J+8>>2]=f[L+8>>2];f[J+12>>2]=f[L+12>>2];f[J+16>>2]=f[L+16>>2];f[J+20>>2]=f[L+20>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=Ua;f[Va>>2]=S;Q=f[f[a>>2]>>2]|0;if(!Q)Wa=S;else{f[a>>2]=Q;Wa=f[Va>>2]|0}UQ(f[a+4>>2]|0,Wa);Q=a+8|0;f[Q>>2]=(f[Q>>2]|0)+1;f[S+40>>2]=y;b[S+32>>0]=T;b[S+33>>0]=0;Xa=J}else{f[R+40>>2]=y;Xa=R+24|0}R=Xa+10|0;b[R>>0]=b[R>>0]&-16;f[Xa>>2]=K;u=e;return}case 9:{R=f[d>>2]|0;oYc(ysc(a,c,T,f[d+16>>2]|0)|0,R)|0;u=e;return}case 10:{R=f[d+16>>2]|0;J=g+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;f[J+16>>2]=0;f[J+20>>2]=0;S=a+4|0;Q=f[S>>2]|0;do if(Q){P=a+4|0;O=Q;while(1){N=f[O+16>>2]|0;if((N|0)>(c|0)){H=f[O>>2]|0;if(!H){q=281;break}else{Ya=O;Za=H}}else{if((N|0)>=(c|0)){q=286;break}_a=O+4|0;N=f[_a>>2]|0;if(!N){q=285;break}else{Ya=_a;Za=N}}P=Ya;O=Za}if((q|0)==281){$a=O;ab=O;break}else if((q|0)==285){$a=O;ab=_a;break}else if((q|0)==286){$a=O;ab=P;break}}else{$a=S;ab=S}while(0);S=f[ab>>2]|0;do if(!S){Q=$Xc(48)|0;f[Q+16>>2]=c;K=Q+24|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2];f[K+8>>2]=f[J+8>>2];f[K+12>>2]=f[J+12>>2];f[K+16>>2]=f[J+16>>2];f[K+20>>2]=f[J+20>>2];f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=$a;f[ab>>2]=Q;y=f[f[a>>2]>>2]|0;if(!y)bb=Q;else{f[a>>2]=y;bb=f[ab>>2]|0}UQ(f[a+4>>2]|0,bb);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;f[Q+40>>2]=R;b[Q+32>>0]=b[A>>0]|0;b[Q+35>>0]=b[d+11>>0]|0;b[Q+33>>0]=0;y=Q+34|0;Q=b[y>>0]&15;L=f[a+12>>2]|0;if(!(b[U>>0]&16)){b[y>>0]=Q;M=f[d>>2]|0;I=Mi[f[(f[M>>2]|0)+16>>2]&1023](M,L)|0;f[K>>2]=I;mi[f[(f[I>>2]|0)+40>>2]&2047](I,f[d>>2]|0);cb=K;break}else{b[y>>0]=Q|16;Q=f[d>>2]|0;y=Mi[f[(f[Q>>2]|0)+8>>2]&1023](Q,L)|0;f[K>>2]=y;mi[f[(f[y>>2]|0)+48>>2]&2047](y,f[d>>2]|0);cb=K;break}}else{K=S+24|0;f[S+40>>2]=R;y=(b[S+34>>0]&16)!=0;L=f[K>>2]|0;if(!(b[U>>0]&16))if(y){Q=Mi[f[(f[L>>2]|0)+16>>2]&1023](L,f[d>>2]|0)|0;mi[f[(f[Q>>2]|0)+40>>2]&2047](Q,f[d>>2]|0);cb=K;break}else{mi[f[(f[L>>2]|0)+40>>2]&2047](L,f[d>>2]|0);cb=K;break}else{Q=f[L>>2]|0;if(y){mi[f[Q+48>>2]&2047](L,f[d>>2]|0);cb=K;break}else{y=f[Q+40>>2]|0;Q=f[d>>2]|0;I=Mi[f[(f[Q>>2]|0)+12>>2]&1023](Q,L)|0;mi[y&2047](L,I);cb=K;break}}}while(0);S=cb+10|0;b[S>>0]=b[S>>0]&-16;u=e;return}default:{u=e;return}}while(0)}function Nsc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;if((f[a+12>>2]|0)==(f[b+12>>2]|0)){e=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;g=b+4|0;h=f[e>>2]|0;f[e>>2]=f[g>>2];f[g>>2]=h;h=a+8|0;i=b+8|0;j=f[h>>2]|0;f[h>>2]=f[i>>2];f[i>>2]=j;if(!(f[h>>2]|0))k=a;else k=(f[e>>2]|0)+8|0;f[k>>2]=e;f[((j|0)==0?b:(f[g>>2]|0)+8|0)>>2]=g;u=c;return}f[d+4>>2]=0;f[d+8>>2]=0;g=d+4|0;f[d>>2]=g;j=d+12|0;f[j>>2]=0;e=f[b>>2]|0;k=b+4|0;if((e|0)==(k|0))l=e;else{h=e;while(1){Msc(d,f[h+16>>2]|0,h+24|0);e=f[h+4>>2]|0;if(!e){i=h+8|0;m=f[i>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=i;do{i=f[m>>2]|0;m=i+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(i|0));n=o}}else{m=e;while(1){o=f[m>>2]|0;if(!o)break;else m=o}n=m}if((n|0)==(k|0))break;else h=n}l=f[b>>2]|0}if((l|0)!=(k|0)){n=l;while(1){Arc(n+24|0);l=f[n+4>>2]|0;if(!l){h=n+8|0;e=f[h>>2]|0;if((f[e>>2]|0)==(n|0))p=e;else{e=h;do{h=f[e>>2]|0;e=h+8|0;o=f[e>>2]|0}while((f[o>>2]|0)!=(h|0));p=o}}else{e=l;while(1){m=f[e>>2]|0;if(!m)break;else e=m}p=e}if((p|0)==(k|0))break;else n=p}}p=f[a>>2]|0;n=a+4|0;if((p|0)==(n|0))q=p;else{k=p;while(1){Msc(b,f[k+16>>2]|0,k+24|0);p=f[k+4>>2]|0;if(!p){l=k+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(k|0))r=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));r=o}}else{m=p;while(1){e=f[m>>2]|0;if(!e)break;else m=e}r=m}if((r|0)==(n|0))break;else k=r}q=f[a>>2]|0}if((q|0)!=(n|0)){r=q;while(1){Arc(r+24|0);q=f[r+4>>2]|0;if(!q){k=r+8|0;b=f[k>>2]|0;if((f[b>>2]|0)==(r|0))s=b;else{b=k;do{k=f[b>>2]|0;b=k+8|0;p=f[b>>2]|0}while((f[p>>2]|0)!=(k|0));s=p}}else{b=q;while(1){m=f[b>>2]|0;if(!m)break;else b=m}s=b}if((s|0)==(n|0))break;else r=s}}s=f[d>>2]|0;if((s|0)!=(g|0)){r=s;while(1){Msc(a,f[r+16>>2]|0,r+24|0);s=f[r+4>>2]|0;if(!s){n=r+8|0;q=f[n>>2]|0;if((f[q>>2]|0)==(r|0))t=q;else{q=n;do{n=f[q>>2]|0;q=n+8|0;m=f[q>>2]|0}while((f[m>>2]|0)!=(n|0));t=m}}else{q=s;while(1){b=f[q>>2]|0;if(!b)break;else q=b}t=q}if((t|0)==(g|0))break;else r=t}}if((f[j>>2]|0)==0?(j=f[d>>2]|0,(j|0)!=(g|0)):0){t=j;while(1){vrc(t+24|0);j=f[t+4>>2]|0;if(!j){r=t+8|0;a=f[r>>2]|0;if((f[a>>2]|0)==(t|0))v=a;else{a=r;do{r=f[a>>2]|0;a=r+8|0;s=f[a>>2]|0}while((f[s>>2]|0)!=(r|0));v=s}}else{a=j;while(1){q=f[a>>2]|0;if(!q)break;else a=q}v=a}if((v|0)==(g|0))break;else t=v}}rrc(d,f[g>>2]|0);u=c;return}function Osc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+32|0;e=d;if((a|0)==(b|0)){u=d;return}g=a+4|0;h=f[g>>2]|0;i=(h|0)==0;if(!i){j=g;k=h;a:while(1){l=k;while(1){if((f[l+16>>2]|0)>=(c|0))break;m=f[l+4>>2]|0;if(!m){n=j;break a}else l=m}k=f[l>>2]|0;if(!k){n=l;break}else j=l}if((n|0)!=(g|0)?(f[n+16>>2]|0)<=(c|0):0)o=n;else p=9}else p=9;if((p|0)==9)o=g;n=b+4|0;j=f[n>>2]|0;k=(j|0)==0;if(!k){m=n;q=j;b:while(1){r=q;while(1){if((f[r+16>>2]|0)>=(c|0))break;s=f[r+4>>2]|0;if(!s){t=m;break b}else r=s}q=f[r>>2]|0;if(!q){t=r;break}else m=r}if((t|0)!=(n|0)?(f[t+16>>2]|0)<=(c|0):0)v=t;else p=17}else p=17;if((p|0)==17)v=n;t=(o|0)==(g|0);if(!((v|0)!=(n|0)|t^1)){u=d;return}m=(v|0)==(n|0);if(!(t|m)){if((f[a+12>>2]|0)==(f[b+12>>2]|0)){q=o+24|0;l=v+24|0;f[e>>2]=f[q>>2];f[e+4>>2]=f[q+4>>2];f[e+8>>2]=f[q+8>>2];f[e+12>>2]=f[q+12>>2];f[e+16>>2]=f[q+16>>2];f[e+20>>2]=f[q+20>>2];f[q>>2]=f[l>>2];f[q+4>>2]=f[l+4>>2];f[q+8>>2]=f[l+8>>2];f[q+12>>2]=f[l+12>>2];f[q+16>>2]=f[l+16>>2];f[q+20>>2]=f[l+20>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];f[l+16>>2]=f[e+16>>2];f[l+20>>2]=f[e+20>>2];u=d;return}f[e+4>>2]=0;f[e+8>>2]=0;l=e+4|0;f[e>>2]=l;q=e+12|0;f[q>>2]=0;s=v+24|0;Msc(e,c,s);w=f[l>>2]|0;if(w){x=l;y=w;c:while(1){w=y;while(1){if((f[w+16>>2]|0)>=(c|0))break;z=f[w+4>>2]|0;if(!z){A=x;break c}else w=z}y=f[w>>2]|0;if(!y){A=w;break}else x=w}if((A|0)!=(l|0)?(f[A+16>>2]|0)<=(c|0):0)B=A;else p=29}else p=29;if((p|0)==29)B=l;Arc(s);s=o+24|0;Msc(b,c,s);Arc(s);Msc(a,c,B+24|0);if((f[q>>2]|0)==0?(q=f[e>>2]|0,(q|0)!=(l|0)):0){B=q;while(1){vrc(B+24|0);q=f[B+4>>2]|0;if(!q){s=B+8|0;A=f[s>>2]|0;if((f[A>>2]|0)==(B|0))C=A;else{A=s;do{s=f[A>>2]|0;A=s+8|0;x=f[A>>2]|0}while((f[x>>2]|0)!=(s|0));C=x}}else{A=q;while(1){w=f[A>>2]|0;if(!w)break;else A=w}C=A}if((C|0)==(l|0))break;else B=C}}rrc(e,f[l>>2]|0);u=d;return}if(t){if((f[a+12>>2]|0)==(f[b+12>>2]|0)){t=v+24|0;l=e+4|0;f[l>>2]=f[t>>2];f[l+4>>2]=f[t+4>>2];f[l+8>>2]=f[t+8>>2];f[l+12>>2]=f[t+12>>2];f[l+16>>2]=f[t+16>>2];f[l+20>>2]=f[t+20>>2];do if(!i){t=a+4|0;C=h;while(1){B=f[C+16>>2]|0;if((B|0)>(c|0)){q=f[C>>2]|0;if(!q){p=45;break}else{D=C;E=q}}else{if((B|0)>=(c|0)){p=50;break}F=C+4|0;B=f[F>>2]|0;if(!B){p=49;break}else{D=F;E=B}}t=D;C=E}if((p|0)==45){G=C;H=C;break}else if((p|0)==49){G=C;H=F;break}else if((p|0)==50){G=C;H=t;break}}else{G=g;H=g}while(0);if(!(f[H>>2]|0)){F=$Xc(48)|0;f[F+16>>2]=c;E=F+24|0;f[E>>2]=f[l>>2];f[E+4>>2]=f[l+4>>2];f[E+8>>2]=f[l+8>>2];f[E+12>>2]=f[l+12>>2];f[E+16>>2]=f[l+16>>2];f[E+20>>2]=f[l+20>>2];f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=G;f[H>>2]=F;G=f[f[a>>2]>>2]|0;if(!G)I=F;else{f[a>>2]=G;I=f[H>>2]|0}UQ(f[a+4>>2]|0,I);I=a+8|0;f[I>>2]=(f[I>>2]|0)+1}}else Msc(a,c,v+24|0);v=f[n>>2]|0;if(!v){u=d;return}else{J=n;K=v}d:while(1){I=K;while(1){if((f[I+16>>2]|0)>=(c|0))break;H=f[I+4>>2]|0;if(!H){L=J;break d}else I=H}K=f[I>>2]|0;if(!K){L=I;break}else J=I}if((L|0)==(n|0)){u=d;return}if((f[L+16>>2]|0)>(c|0)){u=d;return}J=f[L+4>>2]|0;if(!J){K=L+8|0;t=f[K>>2]|0;if((f[t>>2]|0)==(L|0))M=t;else{t=K;do{K=f[t>>2]|0;t=K+8|0;C=f[t>>2]|0}while((f[C>>2]|0)!=(K|0));M=C}}else{t=J;while(1){J=f[t>>2]|0;if(!J)break;else t=J}M=t}if((f[b>>2]|0)==(L|0))f[b>>2]=M;M=b+8|0;f[M>>2]=(f[M>>2]|0)+-1;XIa(v,L);cYc(L);u=d;return}if(!m){u=d;return}if((f[a+12>>2]|0)==(f[b+12>>2]|0)){m=o+24|0;L=e+4|0;f[L>>2]=f[m>>2];f[L+4>>2]=f[m+4>>2];f[L+8>>2]=f[m+8>>2];f[L+12>>2]=f[m+12>>2];f[L+16>>2]=f[m+16>>2];f[L+20>>2]=f[m+20>>2];do if(!k){m=b+4|0;e=j;while(1){v=f[e+16>>2]|0;if((v|0)>(c|0)){M=f[e>>2]|0;if(!M){p=79;break}else{N=e;O=M}}else{if((v|0)>=(c|0)){p=84;break}P=e+4|0;v=f[P>>2]|0;if(!v){p=83;break}else{N=P;O=v}}m=N;e=O}if((p|0)==79){Q=e;R=e;break}else if((p|0)==83){Q=e;R=P;break}else if((p|0)==84){Q=e;R=m;break}}else{Q=n;R=n}while(0);if(!(f[R>>2]|0)){n=$Xc(48)|0;f[n+16>>2]=c;p=n+24|0;f[p>>2]=f[L>>2];f[p+4>>2]=f[L+4>>2];f[p+8>>2]=f[L+8>>2];f[p+12>>2]=f[L+12>>2];f[p+16>>2]=f[L+16>>2];f[p+20>>2]=f[L+20>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=Q;f[R>>2]=n;Q=f[f[b>>2]>>2]|0;if(!Q)S=n;else{f[b>>2]=Q;S=f[R>>2]|0}UQ(f[b+4>>2]|0,S);S=b+8|0;f[S>>2]=(f[S>>2]|0)+1}}else Msc(b,c,o+24|0);o=f[g>>2]|0;if(!o){u=d;return}else{T=g;U=o}e:while(1){b=U;while(1){if((f[b+16>>2]|0)>=(c|0))break;S=f[b+4>>2]|0;if(!S){V=T;break e}else b=S}U=f[b>>2]|0;if(!U){V=b;break}else T=b}if((V|0)==(g|0)){u=d;return}if((f[V+16>>2]|0)>(c|0)){u=d;return}c=f[V+4>>2]|0;if(!c){g=V+8|0;T=f[g>>2]|0;if((f[T>>2]|0)==(V|0))W=T;else{T=g;do{g=f[T>>2]|0;T=g+8|0;U=f[T>>2]|0}while((f[U>>2]|0)!=(g|0));W=U}}else{T=c;while(1){c=f[T>>2]|0;if(!c)break;else T=c}W=T}if((f[a>>2]|0)==(V|0))f[a>>2]=W;W=a+8|0;f[W>>2]=(f[W>>2]|0)+-1;XIa(o,V);cYc(V);u=d;return}function Psc(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a>>2]|0;d=a+4|0;if((c|0)==(d|0)){e=1;return e|0}else g=c;a:while(1){c=g+16|0;a=g+24|0;b:do if((f[165492+(h[g+32>>0]<<2)>>2]|0)==10){if(b[c+17>>0]|0){i=f[a>>2]|0;if((f[i+4>>2]|0)>0){j=0;k=i}else break;while(1){i=f[(f[k+12>>2]|0)+4+(j<<2)>>2]|0;j=j+1|0;if(!(_i[f[(f[i>>2]|0)+32>>2]&2047](i)|0)){e=0;l=17;break a}k=f[a>>2]|0;if((j|0)>=(f[k+4>>2]|0))break b}}i=b[c+18>>0]|0;if(!(i&1)){m=f[a>>2]|0;n=f[m>>2]|0;if(!(i&16))if(_i[f[n+32>>2]&2047](m)|0)break;else{e=0;l=17;break a}else if(_i[f[n+36>>2]&2047](m)|0)break;else{e=0;l=17;break a}}}while(0);a=f[g+4>>2]|0;if(!a){c=g+8|0;m=f[c>>2]|0;if((f[m>>2]|0)==(g|0))o=m;else{m=c;do{c=f[m>>2]|0;m=c+8|0;n=f[m>>2]|0}while((f[n>>2]|0)!=(c|0));o=n}}else{m=a;while(1){n=f[m>>2]|0;if(!n)break;else m=n}o=m}if((o|0)==(d|0)){e=1;l=17;break}else g=o}if((l|0)==17)return e|0;return 0}function Qsc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0;a=u;u=u+32|0;j=a;k=a+24|0;if(!(hj[f[(f[e>>2]|0)+8>>2]&511](e,d,g)|0)){l=0;u=a;return l|0}d=f[165568+(h[g>>0]<<2)>>2]|0;b[i>>0]=0;do if((c|0)==2&(b[g+1>>0]|0)!=0){if(d>>>0>=6){u_b(j,3,507646,74);r_b(k,p_b(j,508199)|0);v_b(j);break}if(35>>>(d&63)&1){b[i>>0]=1;l=1;u=a;return l|0}}while(0);l=(d|0)==(c|0);u=a;return l|0}function Rsc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h;k=c>>>3;if(Qsc(0,c&7,k,e,j,i)|0){l=Ssc(a,k,(b[i>>0]|0)!=0,j,d,g)|0;u=h;return l|0}else{l=hj[f[(f[g>>2]|0)+8>>2]&511](g,d,c)|0;u=h;return l|0}return 0}function Ssc(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0.0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0;j=u;u=u+80|0;k=j+8|0;l=j+40|0;m=j+64|0;o=j;a:do if(d){q=f[g>>2]|0;r=g+4|0;if(q>>>0<(f[r>>2]|0)>>>0){t=b[q>>0]|0;v=t&255;if(t<<24>>24>-1){f[g>>2]=q+1;w=v}else{x=v;y=5}}else{x=0;y=5}if((y|0)==5){v=KYb(g,x)|0;q=J;if((q|0)>-1|(q|0)==-1&v>>>0>4294967295)w=v;else{z=0;u=j;return z|0}}v=HYb(g,w)|0;b:do switch(b[e>>0]|0){case 5:{if((PYb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>-1){f[g>>2]=A+1;D=C}else{E=C;y=38}}else{E=0;y=38}if((y|0)==38){y=0;C=KYb(g,E)|0;A=J;if((A|0)>-1|(A|0)==-1&C>>>0>4294967295)D=C;else{z=0;break}}Grc(a,c,5,(b[q>>0]|0)!=0,D,f[t>>2]|0);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 3:{if((PYb(g)|0)>0){t=e+2|0;q=e+12|0;C=k+8|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){f[g>>2]=A+1;F=B&255;G=0}else{LYb(k,g);B=k;if(!(b[C>>0]|0)){z=0;break}else{F=f[B>>2]|0;G=f[B+4>>2]|0}}Mrc(a,c,3,(b[t>>0]|0)!=0,F,G,f[q>>2]|0);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 13:{if((PYb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(C>>>0<(f[r>>2]|0)>>>0){B=b[C>>0]|0;A=B&255;if(B<<24>>24>-1){f[g>>2]=C+1;H=A}else{I=A;y=48}}else{I=0;y=48}if((y|0)==48){y=0;A=KYb(g,I)|0;C=J;if((C|0)>-1|(C|0)==-1&A>>>0>4294967295)H=A;else{z=0;break}}Src(a,c,13,(b[q>>0]|0)!=0,H,f[t>>2]|0);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 4:{if((PYb(g)|0)>0){t=e+2|0;q=e+12|0;A=k+8|0;while(1){C=f[g>>2]|0;if(C>>>0<(f[r>>2]|0)>>>0?(B=b[C>>0]|0,B<<24>>24>-1):0){f[g>>2]=C+1;K=B&255;L=0}else{LYb(k,g);B=k;if(!(b[A>>0]|0)){z=0;break}else{K=f[B>>2]|0;L=f[B+4>>2]|0}}Yrc(a,c,4,(b[t>>0]|0)!=0,K,L,f[q>>2]|0);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 17:{if((PYb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>-1){f[g>>2]=A+1;M=C>>>1^0-(C&1)}else{N=C;y=58}}else{N=0;y=58}if((y|0)==58){y=0;C=KYb(g,N)|0;A=J;if((A|0)>-1|(A|0)==-1&C>>>0>4294967295)M=C>>>1^0-(C&1);else{z=0;break}}Grc(a,c,17,(b[q>>0]|0)!=0,M,f[t>>2]|0);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 18:{if((PYb(g)|0)>0){t=e+2|0;q=e+12|0;C=k+8|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){O=B&255;f[g>>2]=A+1;A=l1c(O|0,0,1)|0;B=J;P=c1c(0,0,O&1|0,0)|0;Q=A^P;R=B^J}else{LYb(k,g);B=k;P=f[B>>2]|0;A=(b[C>>0]|0)==0;O=l1c(P|0,f[B+4>>2]|0,1)|0;B=J;S=c1c(0,0,P&1|0,0)|0;if(A){z=0;break}else{Q=O^S;R=B^J}}Mrc(a,c,18,(b[t>>0]|0)!=0,Q,R,f[q>>2]|0);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 7:{if((PYb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){B=C;S=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;T=S}else{if(!(WYb(g,k)|0))break;T=f[k>>2]|0}Src(a,c,7,(b[q>>0]|0)!=0,T,f[t>>2]|0);if((PYb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 6:{if((PYb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;B=C;O=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=C+4|0;C=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=k;f[B>>2]=O;f[B+4>>2]=C;f[g>>2]=S+8;U=O;V=C}else{if(!(XYb(g,k)|0))break;C=k;U=f[C>>2]|0;V=f[C+4>>2]|0}Yrc(a,c,6,(b[t>>0]|0)!=0,U,V,f[q>>2]|0);if((PYb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 15:{if((PYb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){O=C;S=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;W=S}else{if(!(WYb(g,k)|0))break;W=f[k>>2]|0}Grc(a,c,15,(b[q>>0]|0)!=0,W,f[t>>2]|0);if((PYb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 16:{if((PYb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;O=C;B=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=C+4|0;C=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=k;f[O>>2]=B;f[O+4>>2]=C;f[g>>2]=S+8;X=B;Y=C}else{if(!(XYb(g,k)|0))break;C=k;X=f[C>>2]|0;Y=f[C+4>>2]|0}Mrc(a,c,16,(b[t>>0]|0)!=0,X,Y,f[q>>2]|0);if((PYb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 2:{if((PYb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){B=C;S=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;Z=S}else{if(!(WYb(g,k)|0))break;Z=f[k>>2]|0}csc(a,c,2,(b[q>>0]|0)!=0,(f[s>>2]=Z,+n[s>>2]),f[t>>2]|0);if((PYb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 1:{if((PYb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;B=C;O=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=C+4|0;C=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=k;f[B>>2]=O;f[B+4>>2]=C;f[g>>2]=S+8;f[s>>2]=O;f[s+4>>2]=C;_=+p[s>>3]}else{if(!(XYb(g,k)|0))break;_=+p[k>>3]}isc(a,c,1,(b[t>>0]|0)!=0,_,f[q>>2]|0);if((PYb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 8:{if((PYb(g)|0)>0){q=e+2|0;t=e+12|0;C=k+8|0;while(1){O=f[g>>2]|0;if(O>>>0<(f[r>>2]|0)>>>0?(S=b[O>>0]|0,S<<24>>24>-1):0){f[g>>2]=O+1;$=S<<24>>24!=0}else{LYb(k,g);S=k;if(!(b[C>>0]|0)){z=0;break}else $=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0}osc(a,c,8,(b[q>>0]|0)!=0,$,f[t>>2]|0);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 14:{if((PYb(g)|0)>0){t=e+4|0;q=e+8|0;C=e+2|0;S=e+12|0;while(1){O=f[g>>2]|0;if(O>>>0<(f[r>>2]|0)>>>0){B=b[O>>0]|0;A=B&255;if(B<<24>>24>-1){f[g>>2]=O+1;aa=A}else{ba=A;y=109}}else{ba=0;y=109}if((y|0)==109){y=0;A=KYb(g,ba)|0;O=J;if((O|0)>-1|(O|0)==-1&A>>>0>4294967295)aa=A;else{z=0;break}}if(Mi[f[t>>2]&1023](f[q>>2]|0,aa)|0)wsc(a,c,14,(b[C>>0]|0)!=0,aa,f[S>>2]|0);else Ti[f[(f[i>>2]|0)+16>>2]&511](i,c,aa);if((PYb(g)|0)<=0)break b}u=j;return z|0}break}case 11:case 10:case 12:case 9:{u_b(l,3,507646,1221);r_b(m,p_b(l,508217)|0);v_b(l);break}default:{}}while(0);IYb(g,v)}else do switch(b[e>>0]|0){case 5:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){S=b[r>>0]|0;C=S&255;if(S<<24>>24>-1){f[g>>2]=r+1;ca=C}else{da=C;y=120}}else{da=0;y=120}if((y|0)==120){C=KYb(g,da)|0;r=J;if((r|0)>-1|(r|0)==-1&C>>>0>4294967295)ca=C;else{z=0;u=j;return z|0}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){Grc(a,c,5,(b[e+2>>0]|0)!=0,ca,C);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;S=a+4|0;q=f[S>>2]|0;do if(q){t=a+4|0;A=q;while(1){O=f[A+16>>2]|0;if((O|0)>(c|0)){B=f[A>>2]|0;if(!B){y=127;break}else{ea=A;fa=B}}else{if((O|0)>=(c|0)){y=132;break}ga=A+4|0;O=f[ga>>2]|0;if(!O){y=131;break}else{ea=ga;fa=O}}t=ea;A=fa}if((y|0)==127){ha=A;ia=A;break}else if((y|0)==131){ha=A;ia=ga;break}else if((y|0)==132){ha=A;ia=t;break}}else{ha=S;ia=S}while(0);S=f[ia>>2]|0;if(!S){q=$Xc(48)|0;f[q+16>>2]=c;O=q+24|0;f[O>>2]=f[r>>2];f[O+4>>2]=f[r+4>>2];f[O+8>>2]=f[r+8>>2];f[O+12>>2]=f[r+12>>2];f[O+16>>2]=f[r+16>>2];f[O+20>>2]=f[r+20>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=ha;f[ia>>2]=q;B=f[f[a>>2]>>2]|0;if(!B)ja=q;else{f[a>>2]=B;ja=f[ia>>2]|0}UQ(f[a+4>>2]|0,ja);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[q+40>>2]=C;b[q+32>>0]=5;b[q+33>>0]=0;ka=O}else{f[S+40>>2]=C;ka=S+24|0}S=ka+10|0;b[S>>0]=b[S>>0]&-16;f[ka>>2]=ca;break a;break}case 3:{S=f[g>>2]|0;if(S>>>0<(f[g+4>>2]|0)>>>0?(O=b[S>>0]|0,O<<24>>24>-1):0){f[g>>2]=S+1;la=O&255;ma=0}else{LYb(k,g);O=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else{la=f[O>>2]|0;ma=f[O+4>>2]|0}}O=f[e+12>>2]|0;if(b[e+1>>0]|0){Mrc(a,c,3,(b[e+2>>0]|0)!=0,la,ma,O);break a}S=k+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;f[S+16>>2]=0;f[S+20>>2]=0;q=a+4|0;B=f[q>>2]|0;do if(B){P=a+4|0;na=B;while(1){oa=f[na+16>>2]|0;if((oa|0)>(c|0)){pa=f[na>>2]|0;if(!pa){y=150;break}else{qa=na;ra=pa}}else{if((oa|0)>=(c|0)){y=155;break}sa=na+4|0;oa=f[sa>>2]|0;if(!oa){y=154;break}else{qa=sa;ra=oa}}P=qa;na=ra}if((y|0)==150){ta=na;ua=na;break}else if((y|0)==154){ta=na;ua=sa;break}else if((y|0)==155){ta=na;ua=P;break}}else{ta=q;ua=q}while(0);q=f[ua>>2]|0;if(!q){B=$Xc(48)|0;f[B+16>>2]=c;C=B+24|0;f[C>>2]=f[S>>2];f[C+4>>2]=f[S+4>>2];f[C+8>>2]=f[S+8>>2];f[C+12>>2]=f[S+12>>2];f[C+16>>2]=f[S+16>>2];f[C+20>>2]=f[S+20>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=ta;f[ua>>2]=B;r=f[f[a>>2]>>2]|0;if(!r)va=B;else{f[a>>2]=r;va=f[ua>>2]|0}UQ(f[a+4>>2]|0,va);r=a+8|0;f[r>>2]=(f[r>>2]|0)+1;f[B+40>>2]=O;b[B+32>>0]=3;b[B+33>>0]=0;wa=C}else{f[q+40>>2]=O;wa=q+24|0}q=wa+10|0;b[q>>0]=b[q>>0]&-16;q=wa;f[q>>2]=la;f[q+4>>2]=ma;break a;break}case 13:{q=f[g>>2]|0;if(q>>>0<(f[g+4>>2]|0)>>>0){C=b[q>>0]|0;B=C&255;if(C<<24>>24>-1){f[g>>2]=q+1;xa=B}else{ya=B;y=166}}else{ya=0;y=166}if((y|0)==166){B=KYb(g,ya)|0;q=J;if((q|0)>-1|(q|0)==-1&B>>>0>4294967295)xa=B;else{z=0;u=j;return z|0}}B=f[e+12>>2]|0;if(b[e+1>>0]|0){Src(a,c,13,(b[e+2>>0]|0)!=0,xa,B);break a}q=k+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;C=a+4|0;r=f[C>>2]|0;do if(r){t=a+4|0;A=r;while(1){oa=f[A+16>>2]|0;if((oa|0)>(c|0)){pa=f[A>>2]|0;if(!pa){y=173;break}else{za=A;Aa=pa}}else{if((oa|0)>=(c|0)){y=178;break}Ba=A+4|0;oa=f[Ba>>2]|0;if(!oa){y=177;break}else{za=Ba;Aa=oa}}t=za;A=Aa}if((y|0)==173){Ca=A;Da=A;break}else if((y|0)==177){Ca=A;Da=Ba;break}else if((y|0)==178){Ca=A;Da=t;break}}else{Ca=C;Da=C}while(0);C=f[Da>>2]|0;if(!C){r=$Xc(48)|0;f[r+16>>2]=c;O=r+24|0;f[O>>2]=f[q>>2];f[O+4>>2]=f[q+4>>2];f[O+8>>2]=f[q+8>>2];f[O+12>>2]=f[q+12>>2];f[O+16>>2]=f[q+16>>2];f[O+20>>2]=f[q+20>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=Ca;f[Da>>2]=r;S=f[f[a>>2]>>2]|0;if(!S)Ea=r;else{f[a>>2]=S;Ea=f[Da>>2]|0}UQ(f[a+4>>2]|0,Ea);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[r+40>>2]=B;b[r+32>>0]=13;b[r+33>>0]=0;Fa=O}else{f[C+40>>2]=B;Fa=C+24|0}C=Fa+10|0;b[C>>0]=b[C>>0]&-16;f[Fa>>2]=xa;break a;break}case 4:{C=f[g>>2]|0;if(C>>>0<(f[g+4>>2]|0)>>>0?(O=b[C>>0]|0,O<<24>>24>-1):0){f[g>>2]=C+1;Ga=O&255;Ha=0}else{LYb(k,g);O=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else{Ga=f[O>>2]|0;Ha=f[O+4>>2]|0}}O=f[e+12>>2]|0;if(b[e+1>>0]|0){Yrc(a,c,4,(b[e+2>>0]|0)!=0,Ga,Ha,O);break a}C=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;r=a+4|0;S=f[r>>2]|0;do if(S){P=a+4|0;na=S;while(1){oa=f[na+16>>2]|0;if((oa|0)>(c|0)){pa=f[na>>2]|0;if(!pa){y=196;break}else{Ia=na;Ja=pa}}else{if((oa|0)>=(c|0)){y=201;break}Ka=na+4|0;oa=f[Ka>>2]|0;if(!oa){y=200;break}else{Ia=Ka;Ja=oa}}P=Ia;na=Ja}if((y|0)==196){La=na;Ma=na;break}else if((y|0)==200){La=na;Ma=Ka;break}else if((y|0)==201){La=na;Ma=P;break}}else{La=r;Ma=r}while(0);r=f[Ma>>2]|0;if(!r){S=$Xc(48)|0;f[S+16>>2]=c;B=S+24|0;f[B>>2]=f[C>>2];f[B+4>>2]=f[C+4>>2];f[B+8>>2]=f[C+8>>2];f[B+12>>2]=f[C+12>>2];f[B+16>>2]=f[C+16>>2];f[B+20>>2]=f[C+20>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=La;f[Ma>>2]=S;q=f[f[a>>2]>>2]|0;if(!q)Na=S;else{f[a>>2]=q;Na=f[Ma>>2]|0}UQ(f[a+4>>2]|0,Na);q=a+8|0;f[q>>2]=(f[q>>2]|0)+1;f[S+40>>2]=O;b[S+32>>0]=4;b[S+33>>0]=0;Oa=B}else{f[r+40>>2]=O;Oa=r+24|0}r=Oa+10|0;b[r>>0]=b[r>>0]&-16;r=Oa;f[r>>2]=Ga;f[r+4>>2]=Ha;break a;break}case 17:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){B=b[r>>0]|0;S=B&255;if(B<<24>>24>-1){f[g>>2]=r+1;Pa=S>>>1^0-(S&1)}else{Qa=S;y=212}}else{Qa=0;y=212}if((y|0)==212){S=KYb(g,Qa)|0;r=J;if((r|0)>-1|(r|0)==-1&S>>>0>4294967295)Pa=S>>>1^0-(S&1);else{z=0;u=j;return z|0}}S=f[e+12>>2]|0;if(b[e+1>>0]|0){Grc(a,c,17,(b[e+2>>0]|0)!=0,Pa,S);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;B=a+4|0;q=f[B>>2]|0;do if(q){t=a+4|0;A=q;while(1){oa=f[A+16>>2]|0;if((oa|0)>(c|0)){pa=f[A>>2]|0;if(!pa){y=219;break}else{Ra=A;Sa=pa}}else{if((oa|0)>=(c|0)){y=224;break}Ta=A+4|0;oa=f[Ta>>2]|0;if(!oa){y=223;break}else{Ra=Ta;Sa=oa}}t=Ra;A=Sa}if((y|0)==219){Ua=A;Va=A;break}else if((y|0)==223){Ua=A;Va=Ta;break}else if((y|0)==224){Ua=A;Va=t;break}}else{Ua=B;Va=B}while(0);B=f[Va>>2]|0;if(!B){q=$Xc(48)|0;f[q+16>>2]=c;O=q+24|0;f[O>>2]=f[r>>2];f[O+4>>2]=f[r+4>>2];f[O+8>>2]=f[r+8>>2];f[O+12>>2]=f[r+12>>2];f[O+16>>2]=f[r+16>>2];f[O+20>>2]=f[r+20>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=Ua;f[Va>>2]=q;C=f[f[a>>2]>>2]|0;if(!C)Wa=q;else{f[a>>2]=C;Wa=f[Va>>2]|0}UQ(f[a+4>>2]|0,Wa);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[q+40>>2]=S;b[q+32>>0]=17;b[q+33>>0]=0;Xa=O}else{f[B+40>>2]=S;Xa=B+24|0}B=Xa+10|0;b[B>>0]=b[B>>0]&-16;f[Xa>>2]=Pa;break a;break}case 18:{B=f[g>>2]|0;if(B>>>0<(f[g+4>>2]|0)>>>0?(O=b[B>>0]|0,O<<24>>24>-1):0){q=O&255;f[g>>2]=B+1;B=l1c(q|0,0,1)|0;O=J;C=c1c(0,0,q&1|0,0)|0;Ya=B^C;Za=O^J}else{LYb(k,g);O=k;C=f[O>>2]|0;B=(b[k+8>>0]|0)==0;q=l1c(C|0,f[O+4>>2]|0,1)|0;O=J;P=c1c(0,0,C&1|0,0)|0;C=O^J;if(B){z=0;u=j;return z|0}else{Ya=q^P;Za=C}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){Mrc(a,c,18,(b[e+2>>0]|0)!=0,Ya,Za,C);break a}P=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;q=a+4|0;B=f[q>>2]|0;do if(B){O=a+4|0;na=B;while(1){oa=f[na+16>>2]|0;if((oa|0)>(c|0)){pa=f[na>>2]|0;if(!pa){y=242;break}else{_a=na;$a=pa}}else{if((oa|0)>=(c|0)){y=247;break}ab=na+4|0;oa=f[ab>>2]|0;if(!oa){y=246;break}else{_a=ab;$a=oa}}O=_a;na=$a}if((y|0)==242){bb=na;cb=na;break}else if((y|0)==246){bb=na;cb=ab;break}else if((y|0)==247){bb=na;cb=O;break}}else{bb=q;cb=q}while(0);q=f[cb>>2]|0;if(!q){B=$Xc(48)|0;f[B+16>>2]=c;S=B+24|0;f[S>>2]=f[P>>2];f[S+4>>2]=f[P+4>>2];f[S+8>>2]=f[P+8>>2];f[S+12>>2]=f[P+12>>2];f[S+16>>2]=f[P+16>>2];f[S+20>>2]=f[P+20>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=bb;f[cb>>2]=B;r=f[f[a>>2]>>2]|0;if(!r)db=B;else{f[a>>2]=r;db=f[cb>>2]|0}UQ(f[a+4>>2]|0,db);r=a+8|0;f[r>>2]=(f[r>>2]|0)+1;f[B+40>>2]=C;b[B+32>>0]=18;b[B+33>>0]=0;eb=S}else{f[q+40>>2]=C;eb=q+24|0}q=eb+10|0;b[q>>0]=b[q>>0]&-16;q=eb;f[q>>2]=Ya;f[q+4>>2]=Za;break a;break}case 7:{q=f[g>>2]|0;do if(((f[g+4>>2]|0)-q|0)>3){S=q;B=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[o>>2]=B;f[g>>2]=q+4;fb=B}else{if(WYb(g,o)|0){fb=f[o>>2]|0;break}z=0;u=j;return z|0}while(0);q=f[e+12>>2]|0;if(!(b[e+1>>0]|0)){C=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;P=a+4|0;B=f[P>>2]|0;do if(B){S=a+4|0;r=B;while(1){t=f[r+16>>2]|0;if((t|0)>(c|0)){A=f[r>>2]|0;if(!A){y=265;break}else{gb=r;hb=A}}else{if((t|0)>=(c|0)){y=270;break}ib=r+4|0;t=f[ib>>2]|0;if(!t){y=269;break}else{gb=ib;hb=t}}S=gb;r=hb}if((y|0)==265){jb=r;kb=r;break}else if((y|0)==269){jb=r;kb=ib;break}else if((y|0)==270){jb=r;kb=S;break}}else{jb=P;kb=P}while(0);P=f[kb>>2]|0;if(!P){B=$Xc(48)|0;f[B+16>>2]=c;O=B+24|0;f[O>>2]=f[C>>2];f[O+4>>2]=f[C+4>>2];f[O+8>>2]=f[C+8>>2];f[O+12>>2]=f[C+12>>2];f[O+16>>2]=f[C+16>>2];f[O+20>>2]=f[C+20>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=jb;f[kb>>2]=B;na=f[f[a>>2]>>2]|0;if(!na)lb=B;else{f[a>>2]=na;lb=f[kb>>2]|0}UQ(f[a+4>>2]|0,lb);na=a+8|0;f[na>>2]=(f[na>>2]|0)+1;f[B+40>>2]=q;b[B+32>>0]=7;b[B+33>>0]=0;mb=O}else{f[P+40>>2]=q;mb=P+24|0}P=mb+10|0;b[P>>0]=b[P>>0]&-16;f[mb>>2]=fb}else Src(a,c,7,(b[e+2>>0]|0)!=0,fb,q);break a;break}case 6:{P=f[g>>2]|0;do if(((f[g+4>>2]|0)-P|0)>7){O=P;B=O;na=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=O+4|0;O=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=o;f[B>>2]=na;f[B+4>>2]=O;f[g>>2]=P+8;nb=na;ob=O}else{if(XYb(g,o)|0){O=o;nb=f[O>>2]|0;ob=f[O+4>>2]|0;break}z=0;u=j;return z|0}while(0);P=f[e+12>>2]|0;if(!(b[e+1>>0]|0)){q=k+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;C=a+4|0;O=f[C>>2]|0;do if(O){na=a+4|0;B=O;while(1){t=f[B+16>>2]|0;if((t|0)>(c|0)){A=f[B>>2]|0;if(!A){y=289;break}else{pb=B;qb=A}}else{if((t|0)>=(c|0)){y=294;break}rb=B+4|0;t=f[rb>>2]|0;if(!t){y=293;break}else{pb=rb;qb=t}}na=pb;B=qb}if((y|0)==289){sb=B;tb=B;break}else if((y|0)==293){sb=B;tb=rb;break}else if((y|0)==294){sb=B;tb=na;break}}else{sb=C;tb=C}while(0);C=f[tb>>2]|0;if(!C){O=$Xc(48)|0;f[O+16>>2]=c;S=O+24|0;f[S>>2]=f[q>>2];f[S+4>>2]=f[q+4>>2];f[S+8>>2]=f[q+8>>2];f[S+12>>2]=f[q+12>>2];f[S+16>>2]=f[q+16>>2];f[S+20>>2]=f[q+20>>2];f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=sb;f[tb>>2]=O;r=f[f[a>>2]>>2]|0;if(!r)ub=O;else{f[a>>2]=r;ub=f[tb>>2]|0}UQ(f[a+4>>2]|0,ub);r=a+8|0;f[r>>2]=(f[r>>2]|0)+1;f[O+40>>2]=P;b[O+32>>0]=6;b[O+33>>0]=0;vb=S}else{f[C+40>>2]=P;vb=C+24|0}C=vb+10|0;b[C>>0]=b[C>>0]&-16;C=vb;f[C>>2]=nb;f[C+4>>2]=ob}else Yrc(a,c,6,(b[e+2>>0]|0)!=0,nb,ob,P);break a;break}case 15:{C=f[g>>2]|0;do if(((f[g+4>>2]|0)-C|0)>3){S=C;O=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[k>>2]=O;f[g>>2]=C+4;wb=O}else{if(WYb(g,k)|0){wb=f[k>>2]|0;break}z=0;u=j;return z|0}while(0);C=f[e+12>>2]|0;if(b[e+1>>0]|0){Grc(a,c,15,(b[e+2>>0]|0)!=0,wb,C);break a}P=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;q=a+4|0;O=f[q>>2]|0;do if(O){S=a+4|0;r=O;while(1){t=f[r+16>>2]|0;if((t|0)>(c|0)){A=f[r>>2]|0;if(!A){y=313;break}else{xb=r;yb=A}}else{if((t|0)>=(c|0)){y=318;break}zb=r+4|0;t=f[zb>>2]|0;if(!t){y=317;break}else{xb=zb;yb=t}}S=xb;r=yb}if((y|0)==313){Ab=r;Bb=r;break}else if((y|0)==317){Ab=r;Bb=zb;break}else if((y|0)==318){Ab=r;Bb=S;break}}else{Ab=q;Bb=q}while(0);q=f[Bb>>2]|0;if(!q){O=$Xc(48)|0;f[O+16>>2]=c;na=O+24|0;f[na>>2]=f[P>>2];f[na+4>>2]=f[P+4>>2];f[na+8>>2]=f[P+8>>2];f[na+12>>2]=f[P+12>>2];f[na+16>>2]=f[P+16>>2];f[na+20>>2]=f[P+20>>2];f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=Ab;f[Bb>>2]=O;B=f[f[a>>2]>>2]|0;if(!B)Cb=O;else{f[a>>2]=B;Cb=f[Bb>>2]|0}UQ(f[a+4>>2]|0,Cb);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[O+40>>2]=C;b[O+32>>0]=15;b[O+33>>0]=0;Db=na}else{f[q+40>>2]=C;Db=q+24|0}q=Db+10|0;b[q>>0]=b[q>>0]&-16;f[Db>>2]=wb;break a;break}case 16:{q=f[g>>2]|0;do if(((f[g+4>>2]|0)-q|0)>7){na=q;O=na;B=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=na+4|0;na=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=k;f[O>>2]=B;f[O+4>>2]=na;f[g>>2]=q+8;Eb=B;Fb=na}else{if(XYb(g,k)|0){na=k;Eb=f[na>>2]|0;Fb=f[na+4>>2]|0;break}z=0;u=j;return z|0}while(0);q=f[e+12>>2]|0;if(b[e+1>>0]|0){Mrc(a,c,16,(b[e+2>>0]|0)!=0,Eb,Fb,q);break a}C=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;P=a+4|0;na=f[P>>2]|0;do if(na){B=a+4|0;O=na;while(1){t=f[O+16>>2]|0;if((t|0)>(c|0)){A=f[O>>2]|0;if(!A){y=336;break}else{Gb=O;Hb=A}}else{if((t|0)>=(c|0)){y=341;break}Ib=O+4|0;t=f[Ib>>2]|0;if(!t){y=340;break}else{Gb=Ib;Hb=t}}B=Gb;O=Hb}if((y|0)==336){Jb=O;Kb=O;break}else if((y|0)==340){Jb=O;Kb=Ib;break}else if((y|0)==341){Jb=O;Kb=B;break}}else{Jb=P;Kb=P}while(0);P=f[Kb>>2]|0;if(!P){na=$Xc(48)|0;f[na+16>>2]=c;S=na+24|0;f[S>>2]=f[C>>2];f[S+4>>2]=f[C+4>>2];f[S+8>>2]=f[C+8>>2];f[S+12>>2]=f[C+12>>2];f[S+16>>2]=f[C+16>>2];f[S+20>>2]=f[C+20>>2];f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=Jb;f[Kb>>2]=na;r=f[f[a>>2]>>2]|0;if(!r)Lb=na;else{f[a>>2]=r;Lb=f[Kb>>2]|0}UQ(f[a+4>>2]|0,Lb);r=a+8|0;f[r>>2]=(f[r>>2]|0)+1;f[na+40>>2]=q;b[na+32>>0]=16;b[na+33>>0]=0;Mb=S}else{f[P+40>>2]=q;Mb=P+24|0}P=Mb+10|0;b[P>>0]=b[P>>0]&-16;P=Mb;f[P>>2]=Eb;f[P+4>>2]=Fb;break a;break}case 2:{P=f[g>>2]|0;do if(((f[g+4>>2]|0)-P|0)>3){S=P;na=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;f[k>>2]=na;f[g>>2]=P+4;Nb=na}else{if(WYb(g,k)|0){Nb=f[k>>2]|0;break}z=0;u=j;return z|0}while(0);P=f[e+12>>2]|0;if(b[e+1>>0]|0){csc(a,c,2,(b[e+2>>0]|0)!=0,(f[s>>2]=Nb,+n[s>>2]),P);break a}q=k+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;C=a+4|0;na=f[C>>2]|0;do if(na){S=a+4|0;r=na;while(1){t=f[r+16>>2]|0;if((t|0)>(c|0)){A=f[r>>2]|0;if(!A){y=359;break}else{Ob=r;Pb=A}}else{if((t|0)>=(c|0)){y=364;break}Qb=r+4|0;t=f[Qb>>2]|0;if(!t){y=363;break}else{Ob=Qb;Pb=t}}S=Ob;r=Pb}if((y|0)==359){Rb=r;Sb=r;break}else if((y|0)==363){Rb=r;Sb=Qb;break}else if((y|0)==364){Rb=r;Sb=S;break}}else{Rb=C;Sb=C}while(0);C=f[Sb>>2]|0;if(!C){na=$Xc(48)|0;f[na+16>>2]=c;B=na+24|0;f[B>>2]=f[q>>2];f[B+4>>2]=f[q+4>>2];f[B+8>>2]=f[q+8>>2];f[B+12>>2]=f[q+12>>2];f[B+16>>2]=f[q+16>>2];f[B+20>>2]=f[q+20>>2];f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=Rb;f[Sb>>2]=na;O=f[f[a>>2]>>2]|0;if(!O)Tb=na;else{f[a>>2]=O;Tb=f[Sb>>2]|0}UQ(f[a+4>>2]|0,Tb);O=a+8|0;f[O>>2]=(f[O>>2]|0)+1;f[na+40>>2]=P;b[na+32>>0]=2;b[na+33>>0]=0;Ub=B}else{f[C+40>>2]=P;Ub=C+24|0}C=Ub+10|0;b[C>>0]=b[C>>0]&-16;f[Ub>>2]=Nb;break a;break}case 1:{C=f[g>>2]|0;do if(((f[g+4>>2]|0)-C|0)>7){B=C;na=B;O=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=B+4|0;B=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=k;f[na>>2]=O;f[na+4>>2]=B;f[g>>2]=C+8;f[s>>2]=O;f[s+4>>2]=B;Vb=+p[s>>3]}else{if(XYb(g,k)|0){Vb=+p[k>>3];break}z=0;u=j;return z|0}while(0);C=f[e+12>>2]|0;if(b[e+1>>0]|0){isc(a,c,1,(b[e+2>>0]|0)!=0,Vb,C);break a}P=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0;f[P+20>>2]=0;q=a+4|0;B=f[q>>2]|0;do if(B){O=a+4|0;na=B;while(1){t=f[na+16>>2]|0;if((t|0)>(c|0)){A=f[na>>2]|0;if(!A){y=382;break}else{Wb=na;Xb=A}}else{if((t|0)>=(c|0)){y=387;break}Yb=na+4|0;t=f[Yb>>2]|0;if(!t){y=386;break}else{Wb=Yb;Xb=t}}O=Wb;na=Xb}if((y|0)==382){Zb=na;_b=na;break}else if((y|0)==386){Zb=na;_b=Yb;break}else if((y|0)==387){Zb=na;_b=O;break}}else{Zb=q;_b=q}while(0);q=f[_b>>2]|0;if(!q){B=$Xc(48)|0;f[B+16>>2]=c;S=B+24|0;f[S>>2]=f[P>>2];f[S+4>>2]=f[P+4>>2];f[S+8>>2]=f[P+8>>2];f[S+12>>2]=f[P+12>>2];f[S+16>>2]=f[P+16>>2];f[S+20>>2]=f[P+20>>2];f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=Zb;f[_b>>2]=B;r=f[f[a>>2]>>2]|0;if(!r)$b=B;else{f[a>>2]=r;$b=f[_b>>2]|0}UQ(f[a+4>>2]|0,$b);r=a+8|0;f[r>>2]=(f[r>>2]|0)+1;f[B+40>>2]=C;b[B+32>>0]=1;b[B+33>>0]=0;ac=S}else{f[q+40>>2]=C;ac=q+24|0}q=ac+10|0;b[q>>0]=b[q>>0]&-16;p[ac>>3]=Vb;break a;break}case 8:{q=f[g>>2]|0;if(q>>>0<(f[g+4>>2]|0)>>>0?(S=b[q>>0]|0,S<<24>>24>-1):0){f[g>>2]=q+1;bc=S<<24>>24!=0}else{LYb(k,g);S=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else bc=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0}S=f[e+12>>2]|0;if(b[e+1>>0]|0){osc(a,c,8,(b[e+2>>0]|0)!=0,bc,S);break a}q=bc&1;B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;r=a+4|0;t=f[r>>2]|0;do if(t){A=a+4|0;oa=t;while(1){pa=f[oa+16>>2]|0;if((pa|0)>(c|0)){cc=f[oa>>2]|0;if(!cc){y=405;break}else{dc=oa;ec=cc}}else{if((pa|0)>=(c|0)){y=410;break}fc=oa+4|0;pa=f[fc>>2]|0;if(!pa){y=409;break}else{dc=fc;ec=pa}}A=dc;oa=ec}if((y|0)==405){gc=oa;hc=oa;break}else if((y|0)==409){gc=oa;hc=fc;break}else if((y|0)==410){gc=oa;hc=A;break}}else{gc=r;hc=r}while(0);r=f[hc>>2]|0;if(!r){t=$Xc(48)|0;f[t+16>>2]=c;C=t+24|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];f[C+8>>2]=f[B+8>>2];f[C+12>>2]=f[B+12>>2];f[C+16>>2]=f[B+16>>2];f[C+20>>2]=f[B+20>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=gc;f[hc>>2]=t;P=f[f[a>>2]>>2]|0;if(!P)ic=t;else{f[a>>2]=P;ic=f[hc>>2]|0}UQ(f[a+4>>2]|0,ic);P=a+8|0;f[P>>2]=(f[P>>2]|0)+1;f[t+40>>2]=S;b[t+32>>0]=8;b[t+33>>0]=0;jc=C}else{f[r+40>>2]=S;jc=r+24|0}r=jc+10|0;b[r>>0]=b[r>>0]&-16;b[jc>>0]=q;break a;break}case 14:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){C=b[r>>0]|0;t=C&255;if(C<<24>>24>-1){f[g>>2]=r+1;kc=t}else{lc=t;y=421}}else{lc=0;y=421}if((y|0)==421){t=KYb(g,lc)|0;r=J;if((r|0)>-1|(r|0)==-1&t>>>0>4294967295)kc=t;else{z=0;u=j;return z|0}}if(!(Mi[f[e+4>>2]&1023](f[e+8>>2]|0,kc)|0)){Ti[f[(f[i>>2]|0)+16>>2]&511](i,c,kc);break a}t=f[e+12>>2]|0;if(b[e+1>>0]|0){wsc(a,c,14,(b[e+2>>0]|0)!=0,kc,t);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;C=a+4|0;P=f[C>>2]|0;do if(P){O=a+4|0;na=P;while(1){pa=f[na+16>>2]|0;if((pa|0)>(c|0)){cc=f[na>>2]|0;if(!cc){y=430;break}else{mc=na;nc=cc}}else{if((pa|0)>=(c|0)){y=435;break}oc=na+4|0;pa=f[oc>>2]|0;if(!pa){y=434;break}else{mc=oc;nc=pa}}O=mc;na=nc}if((y|0)==430){pc=na;qc=na;break}else if((y|0)==434){pc=na;qc=oc;break}else if((y|0)==435){pc=na;qc=O;break}}else{pc=C;qc=C}while(0);C=f[qc>>2]|0;if(!C){P=$Xc(48)|0;f[P+16>>2]=c;q=P+24|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];f[q+20>>2]=f[r+20>>2];f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=pc;f[qc>>2]=P;S=f[f[a>>2]>>2]|0;if(!S)rc=P;else{f[a>>2]=S;rc=f[qc>>2]|0}UQ(f[a+4>>2]|0,rc);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[P+40>>2]=t;b[P+32>>0]=14;b[P+33>>0]=0;sc=q}else{f[C+40>>2]=t;sc=C+24|0}C=sc+10|0;b[C>>0]=b[C>>0]&-16;f[sc>>2]=kc;break a;break}case 9:{C=f[e+12>>2]|0;if(!(b[e+1>>0]|0))tc=ysc(a,c,9,C)|0;else tc=Bsc(a,c,9,C)|0;if(l$b(g,tc)|0)break a;else z=0;u=j;return z|0}case 12:{C=f[e+12>>2]|0;if(!(b[e+1>>0]|0))uc=ysc(a,c,12,C)|0;else uc=Bsc(a,c,12,C)|0;if(l$b(g,uc)|0)break a;else z=0;u=j;return z|0}case 10:{C=f[e+4>>2]|0;q=f[e+12>>2]|0;if(!(b[e+1>>0]|0))vc=Csc(a,c,10,C,q)|0;else vc=Gsc(a,c,10,C,q)|0;q=g+40|0;C=f[q>>2]|0;f[q>>2]=C+-1;if((C|0)<=0){z=0;u=j;return z|0}if(!(Mi[f[(f[vc>>2]|0)+44>>2]&1023](vc,g)|0)){z=0;u=j;return z|0}C=f[q>>2]|0;if((C|0)<(f[g+44>>2]|0))f[q>>2]=C+1;if((f[g+20>>2]|0)==(c<<3|4|0))break a;else z=0;u=j;return z|0}case 11:{C=f[e+4>>2]|0;q=f[e+12>>2]|0;if(!(b[e+1>>0]|0))wc=Csc(a,c,11,C,q)|0;else wc=Gsc(a,c,11,C,q)|0;q=f[g>>2]|0;if(q>>>0<(f[g+4>>2]|0)>>>0?(C=b[q>>0]|0,C<<24>>24>-1):0){f[g>>2]=q+1;xc=C&255}else{C=YYb(g)|0;if((C|0)>-1)xc=C;else{z=0;u=j;return z|0}}JYb(k,g,xc);if((f[k+4>>2]|0)>=0?Mi[f[(f[wc>>2]|0)+44>>2]&1023](wc,g)|0:0){if(OYb(g,f[k>>2]|0)|0)break a;else z=0;u=j;return z|0}z=0;u=j;return z|0}default:break a}while(0);while(0);z=1;u=j;return z|0}function Tsc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=a+4|0;a=f[e>>2]|0;if(!a)return;else{g=e;h=a}a:while(1){a=h;while(1){if((f[a+16>>2]|0)>=(b|0))break;i=f[a+4>>2]|0;if(!i){j=g;break a}else a=i}h=f[a>>2]|0;if(!h){j=a;break}else g=a}if((j|0)==(e|0))return;else k=j;while(1){j=f[k+16>>2]|0;if((j|0)>=(c|0)){l=14;break}Usc(k+24|0,j,d);j=f[k+4>>2]|0;if(!j){g=k+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(k|0))m=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;b=f[h>>2]|0}while((f[b>>2]|0)!=(g|0));m=b}}else{h=j;while(1){a=f[h>>2]|0;if(!a)break;else h=a}m=h}if((m|0)==(e|0)){l=14;break}else k=m}if((l|0)==14)return}function Usc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;e=u;u=u+32|0;g=e;h=e+24|0;if(!(b[a+9>>0]|0)){i=b[a+10>>0]|0;if(i&1){u=e;return}do switch(b[a+8>>0]|0){case 5:{S_b(c,f[a>>2]|0,d);u=e;return}case 3:{j=a;T_b(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 13:{U_b(c,f[a>>2]|0,d);u=e;return}case 4:{j=a;V_b(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 17:{W_b(c,f[a>>2]|0,d);u=e;return}case 18:{j=a;X_b(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 7:{Y_b(c,f[a>>2]|0,d);u=e;return}case 6:{j=a;Z_b(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 15:{__b(c,f[a>>2]|0,d);u=e;return}case 16:{j=a;$_b(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 2:{a$b(c,+n[a>>2],d);u=e;return}case 1:{b$b(c,+p[a>>3],d);u=e;return}case 8:{c$b(c,(b[a>>0]|0)!=0,d);u=e;return}case 9:{e$b(c,f[a>>2]|0,d);u=e;return}case 12:{g$b(c,f[a>>2]|0,d);u=e;return}case 14:{d$b(c,f[a>>2]|0,d);u=e;return}case 10:{i$b(c,f[a>>2]|0,d);u=e;return}case 11:{j=f[a>>2]|0;if(!(i&16)){j$b(c,j,d);u=e;return}else{Ti[f[(f[j>>2]|0)+60>>2]&511](j,c,d);u=e;return}break}default:{u=e;return}}while(0)}if(!(b[a+11>>0]|0))do switch(b[a+8>>0]|0){case 5:{i=f[a>>2]|0;if((f[i>>2]|0)>0){k=0;l=i}else{u=e;return}do{S_b(c,f[(f[l+8>>2]|0)+4+(k<<2)>>2]|0,d);k=k+1|0;l=f[a>>2]|0}while((k|0)<(f[l>>2]|0));u=e;return}case 3:{i=f[a>>2]|0;if((f[i>>2]|0)>0){m=0;o=i}else{u=e;return}do{i=(f[o+8>>2]|0)+8+(m<<3)|0;T_b(c,f[i>>2]|0,f[i+4>>2]|0,d);m=m+1|0;o=f[a>>2]|0}while((m|0)<(f[o>>2]|0));u=e;return}case 13:{i=f[a>>2]|0;if((f[i>>2]|0)>0){q=0;r=i}else{u=e;return}do{U_b(c,f[(f[r+8>>2]|0)+4+(q<<2)>>2]|0,d);q=q+1|0;r=f[a>>2]|0}while((q|0)<(f[r>>2]|0));u=e;return}case 4:{i=f[a>>2]|0;if((f[i>>2]|0)>0){s=0;t=i}else{u=e;return}do{i=(f[t+8>>2]|0)+8+(s<<3)|0;V_b(c,f[i>>2]|0,f[i+4>>2]|0,d);s=s+1|0;t=f[a>>2]|0}while((s|0)<(f[t>>2]|0));u=e;return}case 17:{i=f[a>>2]|0;if((f[i>>2]|0)>0){v=0;w=i}else{u=e;return}do{W_b(c,f[(f[w+8>>2]|0)+4+(v<<2)>>2]|0,d);v=v+1|0;w=f[a>>2]|0}while((v|0)<(f[w>>2]|0));u=e;return}case 18:{i=f[a>>2]|0;if((f[i>>2]|0)>0){x=0;y=i}else{u=e;return}do{i=(f[y+8>>2]|0)+8+(x<<3)|0;X_b(c,f[i>>2]|0,f[i+4>>2]|0,d);x=x+1|0;y=f[a>>2]|0}while((x|0)<(f[y>>2]|0));u=e;return}case 7:{i=f[a>>2]|0;if((f[i>>2]|0)>0){z=0;A=i}else{u=e;return}do{Y_b(c,f[(f[A+8>>2]|0)+4+(z<<2)>>2]|0,d);z=z+1|0;A=f[a>>2]|0}while((z|0)<(f[A>>2]|0));u=e;return}case 6:{i=f[a>>2]|0;if((f[i>>2]|0)>0){B=0;C=i}else{u=e;return}do{i=(f[C+8>>2]|0)+8+(B<<3)|0;Z_b(c,f[i>>2]|0,f[i+4>>2]|0,d);B=B+1|0;C=f[a>>2]|0}while((B|0)<(f[C>>2]|0));u=e;return}case 15:{i=f[a>>2]|0;if((f[i>>2]|0)>0){D=0;E=i}else{u=e;return}do{__b(c,f[(f[E+8>>2]|0)+4+(D<<2)>>2]|0,d);D=D+1|0;E=f[a>>2]|0}while((D|0)<(f[E>>2]|0));u=e;return}case 16:{i=f[a>>2]|0;if((f[i>>2]|0)>0){F=0;G=i}else{u=e;return}do{i=(f[G+8>>2]|0)+8+(F<<3)|0;$_b(c,f[i>>2]|0,f[i+4>>2]|0,d);F=F+1|0;G=f[a>>2]|0}while((F|0)<(f[G>>2]|0));u=e;return}case 2:{i=f[a>>2]|0;if((f[i>>2]|0)>0){H=0;I=i}else{u=e;return}do{a$b(c,+n[(f[I+8>>2]|0)+4+(H<<2)>>2],d);H=H+1|0;I=f[a>>2]|0}while((H|0)<(f[I>>2]|0));u=e;return}case 1:{i=f[a>>2]|0;if((f[i>>2]|0)>0){K=0;L=i}else{u=e;return}do{b$b(c,+p[(f[L+8>>2]|0)+8+(K<<3)>>3],d);K=K+1|0;L=f[a>>2]|0}while((K|0)<(f[L>>2]|0));u=e;return}case 8:{i=f[a>>2]|0;if((f[i>>2]|0)>0){M=0;N=i}else{u=e;return}do{c$b(c,(b[(f[N+8>>2]|0)+4+M>>0]|0)!=0,d);M=M+1|0;N=f[a>>2]|0}while((M|0)<(f[N>>2]|0));u=e;return}case 9:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){O=0;P=i}else{u=e;return}do{e$b(c,f[(f[P+12>>2]|0)+4+(O<<2)>>2]|0,d);O=O+1|0;P=f[a>>2]|0}while((O|0)<(f[P+4>>2]|0));u=e;return}case 12:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){Q=0;R=i}else{u=e;return}do{g$b(c,f[(f[R+12>>2]|0)+4+(Q<<2)>>2]|0,d);Q=Q+1|0;R=f[a>>2]|0}while((Q|0)<(f[R+4>>2]|0));u=e;return}case 14:{i=f[a>>2]|0;if((f[i>>2]|0)>0){S=0;T=i}else{u=e;return}do{d$b(c,f[(f[T+8>>2]|0)+4+(S<<2)>>2]|0,d);S=S+1|0;T=f[a>>2]|0}while((S|0)<(f[T>>2]|0));u=e;return}case 10:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){U=0;V=i}else{u=e;return}do{i$b(c,f[(f[V+12>>2]|0)+4+(U<<2)>>2]|0,d);U=U+1|0;V=f[a>>2]|0}while((U|0)<(f[V+4>>2]|0));u=e;return}case 11:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){W=0;X=i}else{u=e;return}do{j$b(c,f[(f[X+12>>2]|0)+4+(W<<2)>>2]|0,d);W=W+1|0;X=f[a>>2]|0}while((W|0)<(f[X+4>>2]|0));u=e;return}default:{u=e;return}}while(0);X=a+12|0;if(!(f[X>>2]|0)){u=e;return}W=c<<3|2;c=d+8|0;if((f[c>>2]|0)>4){V=d+4|0;U=f[V>>2]|0;if(W>>>0>127){T=W;S=U;while(1){b[S>>0]=T|128;R=T>>>7;Q=S+1|0;if(T>>>0>16383){T=R;S=Q}else{Y=Q;Z=R;break}}}else{Y=U;Z=W}b[Y>>0]=Z;Z=Y+1-U|0;f[V>>2]=(f[V>>2]|0)+Z;V=(f[c>>2]|0)-Z|0;f[c>>2]=V;_=V}else{eZb(d,W);_=f[c>>2]|0}W=f[X>>2]|0;if((_|0)>4){_=d+4|0;X=f[_>>2]|0;if(W>>>0>127){V=W;Z=X;while(1){b[Z>>0]=V|128;U=V>>>7;Y=Z+1|0;if(V>>>0>16383){V=U;Z=Y}else{$=Y;aa=U;break}}}else{$=X;aa=W}b[$>>0]=aa;aa=$+1-X|0;f[_>>2]=(f[_>>2]|0)+aa;f[c>>2]=(f[c>>2]|0)-aa}else eZb(d,W);do switch(b[a+8>>0]|0){case 5:{W=f[a>>2]|0;if((f[W>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;X=W;do{W=f[(f[X+8>>2]|0)+4+(_<<2)>>2]|0;$=((W|0)<0)<<31>>31;if((f[c>>2]|0)>9){Z=f[aa>>2]|0;V=W&255;if(W>>>0>127){U=Z;Y=V;S=W;T=$;while(1){b[U>>0]=Y|-128;R=S;S=l1c(S|0,T|0,7)|0;Q=U+1|0;P=S&255;if(!(T>>>0>0|(T|0)==0&R>>>0>16383)){ba=Q;ca=P;break}else{U=Q;Y=P;T=J}}}else{ba=Z;ca=V}b[ba>>0]=ca;T=ba+1-Z|0;f[aa>>2]=(f[aa>>2]|0)+T;f[c>>2]=(f[c>>2]|0)-T}else fZb(d,W,$);_=_+1|0;X=f[a>>2]|0}while((_|0)<(f[X>>2]|0));u=e;return}case 3:{X=f[a>>2]|0;if((f[X>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;T=X;do{X=(f[T+8>>2]|0)+8+(aa<<3)|0;Y=f[X>>2]|0;U=f[X+4>>2]|0;if((f[c>>2]|0)>9){X=f[_>>2]|0;S=Y&255;if(U>>>0>0|(U|0)==0&Y>>>0>127){P=X;Q=S;R=Y;O=U;while(1){b[P>>0]=Q|-128;N=R;R=l1c(R|0,O|0,7)|0;M=P+1|0;L=R&255;if(!(O>>>0>0|(O|0)==0&N>>>0>16383)){da=M;ea=L;break}else{P=M;Q=L;O=J}}}else{da=X;ea=S}b[da>>0]=ea;O=da+1-X|0;f[_>>2]=(f[_>>2]|0)+O;f[c>>2]=(f[c>>2]|0)-O}else fZb(d,Y,U);aa=aa+1|0;T=f[a>>2]|0}while((aa|0)<(f[T>>2]|0));u=e;return}case 13:{T=f[a>>2]|0;if((f[T>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;O=T;do{T=f[(f[O+8>>2]|0)+4+(_<<2)>>2]|0;if((f[c>>2]|0)>4){Q=f[aa>>2]|0;if(T>>>0>127){P=T;R=Q;while(1){b[R>>0]=P|128;$=P>>>7;W=R+1|0;if(P>>>0>16383){P=$;R=W}else{fa=W;ga=$;break}}}else{fa=Q;ga=T}b[fa>>0]=ga;R=fa+1-Q|0;f[aa>>2]=(f[aa>>2]|0)+R;f[c>>2]=(f[c>>2]|0)-R}else eZb(d,T);_=_+1|0;O=f[a>>2]|0}while((_|0)<(f[O>>2]|0));u=e;return}case 4:{O=f[a>>2]|0;if((f[O>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;R=O;do{O=(f[R+8>>2]|0)+8+(aa<<3)|0;P=f[O>>2]|0;U=f[O+4>>2]|0;if((f[c>>2]|0)>9){O=f[_>>2]|0;Y=P&255;if(U>>>0>0|(U|0)==0&P>>>0>127){X=O;S=Y;$=P;W=U;while(1){b[X>>0]=S|-128;Z=$;$=l1c($|0,W|0,7)|0;V=X+1|0;L=$&255;if(!(W>>>0>0|(W|0)==0&Z>>>0>16383)){ha=V;ia=L;break}else{X=V;S=L;W=J}}}else{ha=O;ia=Y}b[ha>>0]=ia;W=ha+1-O|0;f[_>>2]=(f[_>>2]|0)+W;f[c>>2]=(f[c>>2]|0)-W}else fZb(d,P,U);aa=aa+1|0;R=f[a>>2]|0}while((aa|0)<(f[R>>2]|0));u=e;return}case 17:{R=f[a>>2]|0;if((f[R>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;W=R;do{R=f[(f[W+8>>2]|0)+4+(_<<2)>>2]|0;S=R<<1^R>>31;if((f[c>>2]|0)>4){R=f[aa>>2]|0;if(S>>>0>127){X=S;$=R;while(1){b[$>>0]=X|128;T=X>>>7;Q=$+1|0;if(X>>>0>16383){X=T;$=Q}else{ja=Q;ka=T;break}}}else{ja=R;ka=S}b[ja>>0]=ka;$=ja+1-R|0;f[aa>>2]=(f[aa>>2]|0)+$;f[c>>2]=(f[c>>2]|0)-$}else eZb(d,S);_=_+1|0;W=f[a>>2]|0}while((_|0)<(f[W>>2]|0));u=e;return}case 18:{W=f[a>>2]|0;if((f[W>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;$=W;do{W=(f[$+8>>2]|0)+8+(aa<<3)|0;X=f[W>>2]|0;U=f[W+4>>2]|0;W=u1c(X|0,U|0,1)|0;P=J;O=k1c(X|0,U|0,63)|0;U=W^O;O=P^J;if((f[c>>2]|0)>9){P=f[_>>2]|0;W=U&255;if(O>>>0>0|(O|0)==0&U>>>0>127){X=P;Y=W;T=U;Q=O;while(1){b[X>>0]=Y|-128;L=T;T=l1c(T|0,Q|0,7)|0;V=X+1|0;Z=T&255;if(!(Q>>>0>0|(Q|0)==0&L>>>0>16383)){la=V;ma=Z;break}else{X=V;Y=Z;Q=J}}}else{la=P;ma=W}b[la>>0]=ma;Q=la+1-P|0;f[_>>2]=(f[_>>2]|0)+Q;f[c>>2]=(f[c>>2]|0)-Q}else fZb(d,U,O);aa=aa+1|0;$=f[a>>2]|0}while((aa|0)<(f[$>>2]|0));u=e;return}case 7:{$=f[a>>2]|0;if((f[$>>2]|0)>0){na=0;oa=$}else{u=e;return}do{cZb(d,f[(f[oa+8>>2]|0)+4+(na<<2)>>2]|0);na=na+1|0;oa=f[a>>2]|0}while((na|0)<(f[oa>>2]|0));u=e;return}case 6:{$=f[a>>2]|0;if((f[$>>2]|0)>0){pa=0;qa=$}else{u=e;return}do{$=(f[qa+8>>2]|0)+8+(pa<<3)|0;dZb(d,f[$>>2]|0,f[$+4>>2]|0);pa=pa+1|0;qa=f[a>>2]|0}while((pa|0)<(f[qa>>2]|0));u=e;return}case 15:{$=f[a>>2]|0;if((f[$>>2]|0)>0){ra=0;sa=$}else{u=e;return}do{cZb(d,f[(f[sa+8>>2]|0)+4+(ra<<2)>>2]|0);ra=ra+1|0;sa=f[a>>2]|0}while((ra|0)<(f[sa>>2]|0));u=e;return}case 16:{$=f[a>>2]|0;if((f[$>>2]|0)>0){ta=0;ua=$}else{u=e;return}do{$=(f[ua+8>>2]|0)+8+(ta<<3)|0;dZb(d,f[$>>2]|0,f[$+4>>2]|0);ta=ta+1|0;ua=f[a>>2]|0}while((ta|0)<(f[ua>>2]|0));u=e;return}case 2:{$=f[a>>2]|0;if((f[$>>2]|0)>0){va=0;wa=$}else{u=e;return}do{cZb(d,f[(f[wa+8>>2]|0)+4+(va<<2)>>2]|0);va=va+1|0;wa=f[a>>2]|0}while((va|0)<(f[wa>>2]|0));u=e;return}case 1:{$=f[a>>2]|0;if((f[$>>2]|0)>0){xa=0;ya=$}else{u=e;return}do{$=(f[ya+8>>2]|0)+8+(xa<<3)|0;dZb(d,f[$>>2]|0,f[$+4>>2]|0);xa=xa+1|0;ya=f[a>>2]|0}while((xa|0)<(f[ya>>2]|0));u=e;return}case 8:{$=f[a>>2]|0;if((f[$>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;Q=$;do{$=b[(f[Q+8>>2]|0)+4+_>>0]|0;if((f[c>>2]|0)>4){b[f[aa>>2]>>0]=$;f[aa>>2]=(f[aa>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+-1}else eZb(d,$&255);_=_+1|0;Q=f[a>>2]|0}while((_|0)<(f[Q>>2]|0));u=e;return}case 14:{Q=f[a>>2]|0;if((f[Q>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;$=Q;do{Q=f[(f[$+8>>2]|0)+4+(aa<<2)>>2]|0;Y=((Q|0)<0)<<31>>31;if((f[c>>2]|0)>9){X=f[_>>2]|0;T=Q&255;if(Q>>>0>127){S=X;R=T;Z=Q;V=Y;while(1){b[S>>0]=R|-128;L=Z;Z=l1c(Z|0,V|0,7)|0;M=S+1|0;N=Z&255;if(!(V>>>0>0|(V|0)==0&L>>>0>16383)){za=M;Aa=N;break}else{S=M;R=N;V=J}}}else{za=X;Aa=T}b[za>>0]=Aa;V=za+1-X|0;f[_>>2]=(f[_>>2]|0)+V;f[c>>2]=(f[c>>2]|0)-V}else fZb(d,Q,Y);aa=aa+1|0;$=f[a>>2]|0}while((aa|0)<(f[$>>2]|0));u=e;return}case 11:case 10:case 12:case 9:{u_b(g,3,507646,1469);r_b(h,p_b(g,508217)|0);v_b(g);u=e;return}default:{u=e;return}}while(0)}function Vsc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0)){d=0;return d|0}else{e=0;g=b}while(1){b=(Wsc(g+24|0,f[g+16>>2]|0)|0)+e|0;a=f[g+4>>2]|0;if(!a){h=g+8|0;i=f[h>>2]|0;if((f[i>>2]|0)==(g|0))j=i;else{i=h;do{h=f[i>>2]|0;i=h+8|0;k=f[i>>2]|0}while((f[k>>2]|0)!=(h|0));j=k}}else{i=a;while(1){k=f[i>>2]|0;if(!k)break;else i=k}j=i}if((j|0)==(c|0)){d=b;break}else{e=b;g=j}}return d|0}function Wsc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+32|0;e=d;g=d+24|0;if(!(b[a+9>>0]|0)){h=b[a+10>>0]|0;if(h&1){i=0;u=d;return i|0}j=b[a+8>>0]|0;k=(((($(c<<3|1|0)|0)^31)*9|0)+73|0)>>>6<<(j<<24>>24==10&1);do switch(j<<24>>24){case 5:{l=f[a>>2]|0;if((l|0)<0)m=10;else m=(((($(l|1|0)|0)^31)*9|0)+73|0)>>>6;i=m+k|0;u=d;return i|0}case 3:{l=a;i=(((((t1c(f[l>>2]|1|0,f[l+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 13:{i=((((($(f[a>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 4:{l=a;i=(((((t1c(f[l>>2]|1|0,f[l+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 17:{l=f[a>>2]|0;i=((((($(l<<1^l>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 18:{l=a;n=f[l>>2]|0;o=f[l+4>>2]|0;l=u1c(n|0,o|0,1)|0;p=J;i=(((((t1c(l^(k1c(n|0,o|0,63)|0)|1|0,p^J|0,1)|0)^63)*9|0)+73|0)>>>6)+k|0;u=d;return i|0}case 9:{p=f[a>>2]|0;o=b[p+11>>0]|0;n=o<<24>>24<0?f[p+4>>2]|0:o&255;i=n+k+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}case 12:{n=f[a>>2]|0;o=b[n+11>>0]|0;p=o<<24>>24<0?f[n+4>>2]|0:o&255;i=p+k+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}case 14:{p=f[a>>2]|0;if((p|0)<0)q=10;else q=(((($(p|1|0)|0)^31)*9|0)+73|0)>>>6;i=q+k|0;u=d;return i|0}case 10:{p=f[a>>2]|0;i=(_i[f[(f[p>>2]|0)+48>>2]&2047](p)|0)+k|0;u=d;return i|0}case 11:{p=f[a>>2]|0;o=f[p>>2]|0;if(!(h&16)){n=_i[f[o+48>>2]&2047](p)|0;i=n+k+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}else{n=_i[f[o+40>>2]&2047](p)|0;i=n+k+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}break}case 7:{i=k+4|0;u=d;return i|0}case 6:{i=k+8|0;u=d;return i|0}case 15:{i=k+4|0;u=d;return i|0}case 16:{i=k+8|0;u=d;return i|0}case 2:{i=k+4|0;u=d;return i|0}case 1:{i=k+8|0;u=d;return i|0}case 8:{i=k+1|0;u=d;return i|0}default:{i=k;u=d;return i|0}}while(0)}k=b[a+8>>0]|0;if(b[a+11>>0]|0){do switch(k<<24>>24){case 5:{h=f[a>>2]|0;q=f[h>>2]|0;if((q|0)>0){m=f[h+8>>2]|0;h=0;j=0;while(1){n=f[m+4+(h<<2)>>2]|0;if((n|0)<0)r=10;else r=(((($(n|1|0)|0)^31)*9|0)+73|0)>>>6;n=r+j|0;h=h+1|0;if((h|0)>=(q|0)){s=n;t=39;break}else j=n}}else t=38;break}case 3:{j=f[a>>2]|0;q=f[j>>2]|0;if((q|0)>0){h=f[j+8>>2]|0;j=0;m=0;while(1){n=h+8+(j<<3)|0;p=t1c(f[n>>2]|1|0,f[n+4>>2]|0,1)|0;n=((((p^63)*9|0)+73|0)>>>6)+m|0;j=j+1|0;if((j|0)>=(q|0)){s=n;t=39;break}else m=n}}else t=38;break}case 13:{m=f[a>>2]|0;q=f[m>>2]|0;if((q|0)>0){j=f[m+8>>2]|0;m=0;h=0;while(1){n=((((($(f[j+4+(m<<2)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+h|0;m=m+1|0;if((m|0)>=(q|0)){s=n;t=39;break}else h=n}}else t=38;break}case 4:{h=f[a>>2]|0;q=f[h>>2]|0;if((q|0)>0){m=f[h+8>>2]|0;h=0;j=0;while(1){n=m+8+(h<<3)|0;p=t1c(f[n>>2]|1|0,f[n+4>>2]|0,1)|0;n=((((p^63)*9|0)+73|0)>>>6)+j|0;h=h+1|0;if((h|0)>=(q|0)){s=n;t=39;break}else j=n}}else t=38;break}case 17:{j=f[a>>2]|0;q=f[j>>2]|0;if((q|0)>0){h=f[j+8>>2]|0;j=0;m=0;while(1){n=f[h+4+(j<<2)>>2]|0;p=((((($(n<<1^n>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+m|0;j=j+1|0;if((j|0)>=(q|0)){s=p;t=39;break}else m=p}}else t=38;break}case 18:{m=f[a>>2]|0;q=f[m>>2]|0;if((q|0)>0){j=f[m+8>>2]|0;m=0;h=0;while(1){p=j+8+(m<<3)|0;n=f[p>>2]|0;o=f[p+4>>2]|0;p=u1c(n|0,o|0,1)|0;l=J;v=k1c(n|0,o|0,63)|0;o=t1c(p^v|1|0,l^J|0,1)|0;l=((((o^63)*9|0)+73|0)>>>6)+h|0;m=m+1|0;if((m|0)>=(q|0)){s=l;t=39;break}else h=l}}else t=38;break}case 14:{h=f[a>>2]|0;q=f[h>>2]|0;if((q|0)>0){m=f[h+8>>2]|0;h=0;j=0;while(1){l=f[m+4+(h<<2)>>2]|0;if((l|0)<0)w=10;else w=(((($(l|1|0)|0)^31)*9|0)+73|0)>>>6;l=w+j|0;h=h+1|0;if((h|0)>=(q|0)){s=l;t=39;break}else j=l}}else t=38;break}case 7:{s=f[f[a>>2]>>2]<<2;t=39;break}case 6:{s=f[f[a>>2]>>2]<<3;t=39;break}case 15:{s=f[f[a>>2]>>2]<<2;t=39;break}case 16:{s=f[f[a>>2]>>2]<<3;t=39;break}case 2:{s=f[f[a>>2]>>2]<<2;t=39;break}case 1:{s=f[f[a>>2]>>2]<<3;t=39;break}case 8:{s=f[f[a>>2]>>2]|0;t=39;break}case 11:case 10:case 12:case 9:{u_b(e,3,507646,1581);r_b(g,p_b(e,508217)|0);v_b(e);t=37;break}default:t=37}while(0);if((t|0)==37){f[a+12>>2]=0;i=0;u=d;return i|0}else if((t|0)==38){f[a+12>>2]=0;i=0;u=d;return i|0}else if((t|0)==39){f[a+12>>2]=s;if(!s){i=0;u=d;return i|0}i=s+((((($(c<<3|3|0)|0)^31)*9|0)+73|0)>>>6)+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=d;return i|0}}s=(((($(c<<3|1|0)|0)^31)*9|0)+73|0)>>>6<<(k<<24>>24==10&1);do switch(k<<24>>24){case 5:{c=f[a>>2]|0;t=f[c>>2]|0;e=Y(t,s)|0;if((t|0)<=0){i=e;u=d;return i|0}g=f[c+8>>2]|0;c=0;w=e;while(1){e=f[g+4+(c<<2)>>2]|0;if((e|0)<0)x=10;else x=(((($(e|1|0)|0)^31)*9|0)+73|0)>>>6;e=x+w|0;c=c+1|0;if((c|0)>=(t|0)){i=e;break}else w=e}u=d;return i|0}case 3:{w=f[a>>2]|0;t=f[w>>2]|0;c=Y(t,s)|0;if((t|0)<=0){i=c;u=d;return i|0}g=f[w+8>>2]|0;w=0;e=c;while(1){c=g+8+(w<<3)|0;r=t1c(f[c>>2]|1|0,f[c+4>>2]|0,1)|0;c=((((r^63)*9|0)+73|0)>>>6)+e|0;w=w+1|0;if((w|0)>=(t|0)){i=c;break}else e=c}u=d;return i|0}case 13:{e=f[a>>2]|0;t=f[e>>2]|0;w=Y(t,s)|0;if((t|0)<=0){i=w;u=d;return i|0}g=f[e+8>>2]|0;e=0;c=w;while(1){w=((((($(f[g+4+(e<<2)>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)+c|0;e=e+1|0;if((e|0)>=(t|0)){i=w;break}else c=w}u=d;return i|0}case 4:{c=f[a>>2]|0;t=f[c>>2]|0;e=Y(t,s)|0;if((t|0)<=0){i=e;u=d;return i|0}g=f[c+8>>2]|0;c=0;w=e;while(1){e=g+8+(c<<3)|0;r=t1c(f[e>>2]|1|0,f[e+4>>2]|0,1)|0;e=((((r^63)*9|0)+73|0)>>>6)+w|0;c=c+1|0;if((c|0)>=(t|0)){i=e;break}else w=e}u=d;return i|0}case 17:{w=f[a>>2]|0;t=f[w>>2]|0;c=Y(t,s)|0;if((t|0)<=0){i=c;u=d;return i|0}g=f[w+8>>2]|0;w=0;e=c;while(1){c=f[g+4+(w<<2)>>2]|0;r=((((($(c<<1^c>>31|1|0)|0)^31)*9|0)+73|0)>>>6)+e|0;w=w+1|0;if((w|0)>=(t|0)){i=r;break}else e=r}u=d;return i|0}case 18:{e=f[a>>2]|0;t=f[e>>2]|0;w=Y(t,s)|0;if((t|0)<=0){i=w;u=d;return i|0}g=f[e+8>>2]|0;e=0;r=w;while(1){w=g+8+(e<<3)|0;c=f[w>>2]|0;j=f[w+4>>2]|0;w=u1c(c|0,j|0,1)|0;q=J;h=k1c(c|0,j|0,63)|0;j=t1c(w^h|1|0,q^J|0,1)|0;q=((((j^63)*9|0)+73|0)>>>6)+r|0;e=e+1|0;if((e|0)>=(t|0)){i=q;break}else r=q}u=d;return i|0}case 9:{r=f[a>>2]|0;t=f[r+4>>2]|0;e=Y(t,s)|0;if((t|0)<=0){i=e;u=d;return i|0}g=f[r+12>>2]|0;r=0;q=e;while(1){e=f[g+4+(r<<2)>>2]|0;j=b[e+11>>0]|0;h=j<<24>>24<0?f[e+4>>2]|0:j&255;j=h+q+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=r+1|0;if((r|0)>=(t|0)){i=j;break}else q=j}u=d;return i|0}case 12:{q=f[a>>2]|0;t=f[q+4>>2]|0;r=Y(t,s)|0;if((t|0)<=0){i=r;u=d;return i|0}g=f[q+12>>2]|0;q=0;j=r;while(1){r=f[g+4+(q<<2)>>2]|0;h=b[r+11>>0]|0;e=h<<24>>24<0?f[r+4>>2]|0:h&255;h=e+j+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=q+1|0;if((q|0)>=(t|0)){i=h;break}else j=h}u=d;return i|0}case 14:{j=f[a>>2]|0;t=f[j>>2]|0;q=Y(t,s)|0;if((t|0)<=0){i=q;u=d;return i|0}g=f[j+8>>2]|0;j=0;h=q;while(1){q=f[g+4+(j<<2)>>2]|0;if((q|0)<0)y=10;else y=(((($(q|1|0)|0)^31)*9|0)+73|0)>>>6;q=y+h|0;j=j+1|0;if((j|0)>=(t|0)){i=q;break}else h=q}u=d;return i|0}case 10:{h=f[a>>2]|0;t=f[h+4>>2]|0;j=Y(t,s)|0;if((t|0)>0){z=0;A=j;B=h}else{i=j;u=d;return i|0}while(1){j=f[(f[B+12>>2]|0)+4+(z<<2)>>2]|0;h=(_i[f[(f[j>>2]|0)+48>>2]&2047](j)|0)+A|0;z=z+1|0;B=f[a>>2]|0;if((z|0)>=(f[B+4>>2]|0)){i=h;break}else A=h}u=d;return i|0}case 11:{h=f[a>>2]|0;j=f[h+4>>2]|0;t=Y(j,s)|0;if((j|0)>0){C=0;D=t;E=h}else{i=t;u=d;return i|0}while(1){t=f[(f[E+12>>2]|0)+4+(C<<2)>>2]|0;h=_i[f[(f[t>>2]|0)+48>>2]&2047](t)|0;t=h+D+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;C=C+1|0;E=f[a>>2]|0;if((C|0)>=(f[E+4>>2]|0)){i=t;break}else D=t}u=d;return i|0}case 7:{i=Y(f[f[a>>2]>>2]|0,s+4|0)|0;u=d;return i|0}case 6:{i=Y(f[f[a>>2]>>2]|0,s+8|0)|0;u=d;return i|0}case 15:{i=Y(f[f[a>>2]>>2]|0,s+4|0)|0;u=d;return i|0}case 16:{i=Y(f[f[a>>2]>>2]|0,s+8|0)|0;u=d;return i|0}case 2:{i=Y(f[f[a>>2]>>2]|0,s+4|0)|0;u=d;return i|0}case 1:{i=Y(f[f[a>>2]>>2]|0,s+8|0)|0;u=d;return i|0}case 8:{i=Y(f[f[a>>2]>>2]|0,s+1|0)|0;u=d;return i|0}default:{i=0;u=d;return i|0}}while(0);return 0}function Xsc(a,b,c){a=a|0;b=b|0;c=c|0;c=u;u=u+32|0;b=c;u_b(b,3,508254,47);r_b(c+24|0,p_b(b,508355)|0);v_b(b);u=c;return 0}function Ysc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+1040|0;e=d+16|0;g=d;f[g>>2]=f[c>>2];h=pJc(e,1024,b,g)|0;if((h|0)<1024){if((h|0)<=-1){u=d;return}zYc(a,e,h)|0;u=d;return}else{e=h+1|0;i=bYc(e)|0;f[g>>2]=f[c>>2];c=pJc(i,e,b,g)|0;if(!((c|0)<0|(c|0)>(h|0)))zYc(a,i,c)|0;dYc(i);u=d;return}}function Zsc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;Ysc(a,b,e);u=d;return}function _sc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;Ysc(a,b,e);u=d;return}function $sc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f[e>>2]=0;if(!d){g=241;return g|0}i=f[a+16>>2]|0;j=c+d|0;d=j+-7|0;k=(f[a+32>>2]|0)+(f[a>>2]|0)|0;l=f[a+44>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=a+4|0;a=k;p=c;while(1){q=p&7;a:do if(p>>>0<j>>>0&(q|0)!=0){r=p;while(1){if(b[l+(h[r>>0]|0)>>0]|0){s=r;break a}t=r+1|0;u=t&7;if(t>>>0<j>>>0&(u|0)!=0)r=t;else{v=t;w=u;x=6;break}}}else{v=p;w=q;x=6}while(0);b:do if((x|0)==6){x=0;if((w|0)==0&v>>>0<d>>>0){q=v;while(1){r=f[q>>2]|0;u=q+4|0;t=f[u>>2]|0;y=q+8|0;if((r-m|r+n|t-m|t+n)&-2139062144|0){if((b[l+(h[q+1>>0]|0)>>0]|b[l+(r&255)>>0]|b[l+(h[q+2>>0]|0)>>0]|b[l+(h[q+3>>0]|0)>>0])<<24>>24){s=q;break b}if((b[l+(h[q+5>>0]|0)>>0]|b[l+(t&255)>>0]|b[l+(h[q+6>>0]|0)>>0]|b[l+(h[q+7>>0]|0)>>0])<<24>>24){s=u;break b}}if(y>>>0<d>>>0)q=y;else{s=y;break}}}else s=v}while(0);if(s>>>0<j>>>0){z=k;A=s}else{B=k;C=s;x=18;break}while(1){D=b[z+(h[A>>0]|0)>>0]|0;E=D&255;F=A+1|0;if((D&255)>239){G=z;break}q=k+(E<<i)|0;if(F>>>0<j>>>0){z=q;A=F}else{G=q;break}}if((D&255)<=239){B=G;C=F;x=18;break}c:do if((G-a|0)>>>0<(f[o>>2]|0)>>>0)H=A;else{q=A;while(1){y=q+-1|0;if(y>>>0<=c>>>0){H=y;break c}if((b[y>>0]&-64)<<24>>24==-128)q=y;else{H=y;break}}}while(0);if(D<<24>>24==-3)p=H;else{I=H;J=E;break}}d:do if((x|0)==18)if((B-k|0)>>>0<(f[o>>2]|0)>>>0){I=C;J=241}else{E=C;while(1){H=E+-1|0;if(H>>>0<=c>>>0){I=H;J=240;break d}if((b[H>>0]&-64)<<24>>24==-128)E=H;else{I=H;J=240;break}}}while(0);f[e>>2]=I-c;g=J;return g|0}function atc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!c){g=0;h=(g|0)==(c|0);u=d;return h|0}i=a+c|0;j=i+-7|0;k=a;l=k+c|0;m=a;do{a=m&7;a:do if(m>>>0<i>>>0&(a|0)!=0){n=m;while(1){if((b[n>>0]|0)<=-1){o=n;break a}p=n+1|0;q=p&7;if(p>>>0<i>>>0&(q|0)!=0)n=p;else{r=p;s=q;t=7;break}}}else{r=m;s=a;t=7}while(0);b:do if((t|0)==7){t=0;if(r>>>0<j>>>0&(s|0)==0){a=r;while(1){if((f[a+4>>2]|f[a>>2])&-2139062144|0){o=a;break b}n=a+8|0;if(n>>>0<j>>>0)a=n;else{o=n;break}}}else o=r}while(0);c:do if(o>>>0<i>>>0){a=o;while(1){if((b[a>>0]|0)<=-1){v=a;break c}n=a+1|0;if(n>>>0<i>>>0)a=n;else{v=n;break}}}else v=o;while(0);a=$sc(172800,v,l-v|0,e)|0;m=v+(f[e>>2]|0)|0}while((a|0)==253);g=m-k|0;h=(g|0)==(c|0);u=d;return h|0}function btc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+11|0;d=b[c>>0]|0;if(d<<24>>24<0)e=f[a+4>>2]|0;else e=d&255;a:do if((e|0)>0){d=0;while(1){g=yYc(a,d)|0;h=(b[g>>0]|0)+-9<<24>>24;if((h&255)>23|(8388639>>>(h&255)&1|0)==0){i=d;break a}h=d+1|0;if((e|0)>(h|0))d=h;else{i=h;break}}}else i=0;while(0);if((e|0)==(i|0))if((b[c>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0;return}else{b[a>>0]=0;b[c>>0]=0;return}if((i|0)>0){FYc(a,0,i)|0;j=e-i|0}else j=e;e=j+-1|0;if((j|0)>0)k=e;else return;while(1){j=yYc(a,k)|0;i=(b[j>>0]|0)+-9<<24>>24;if((i&255)>23|(8388639>>>(i&255)&1|0)==0)break;if((k|0)>0)k=k+-1|0;else{l=18;break}}if((l|0)==18)return;if((k|0)==(e|0))return;FYc(a,k+1|0,-1)|0;return}function ctc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+16|0;g=e;i=b[c>>0]|0;if(i<<24>>24?(b[c+1>>0]|0)==0:0){j=b[a+11>>0]|0;k=j<<24>>24<0;l=k?f[a>>2]|0:a;m=k?f[a+4>>2]|0:j&255;j=l+m|0;if(!m){u=e;return}m=g+11|0;k=g+8|0;n=g+4|0;o=d+4|0;p=d+8|0;q=l;while(1){if((b[q>>0]|0)==i<<24>>24)r=q+1|0;else{l=q;while(1){s=l+1|0;if((s|0)==(j|0)){t=j;break}if((b[s>>0]|0)==i<<24>>24){t=s;break}else l=s}l=t-q|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(l>>>0>4294967279){v=12;break}if(l>>>0<11){b[m>>0]=l;if(!l)w=g;else{x=g;v=16}}else{s=l+16&-16;y=$Xc(s)|0;f[g>>2]=y;f[k>>2]=s|-2147483648;f[n>>2]=l;x=y;v=16}if((v|0)==16){v=0;o1c(x|0,q|0,l|0)|0;w=x}b[w+l>>0]=0;l=f[o>>2]|0;if(l>>>0>=(f[p>>2]|0)>>>0){QA(d,g);if((b[m>>0]|0)<0)cYc(f[g>>2]|0)}else{f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[l+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[o>>2]=(f[o>>2]|0)+12}r=t}if((r|0)==(j|0)){v=44;break}else q=r}if((v|0)==12)jYc(g);else if((v|0)==44){u=e;return}}r=a+11|0;q=b[r>>0]|0;j=q<<24>>24<0;t=a+4|0;o=f[t>>2]|0;m=j?o:q&255;if(!m){u=e;return}p=dJc(c)|0;w=f[a>>2]|0;x=g+11|0;n=d+4|0;k=d+8|0;i=0;l=j?w:a;j=m;m=p;p=q;q=w;w=o;a:while(1){o=l+j|0;y=l+i|0;b:do if(!m)z=y;else{s=y;while(1){if(!(AJc(c,h[s>>0]|0,m)|0)){z=s;break b}s=s+1|0;if((s|0)==(o|0)){v=44;break a}}}while(0);A=z-l|0;if((A|0)==-1){v=44;break}o=p<<24>>24<0;y=o?q:a;s=o?w:p&255;o=dJc(c)|0;if(s>>>0<=A>>>0|(o|0)==0){v=34;break}B=y+A|0;C=y+s|0;D=c+o|0;c:do if((s|0)==(A|0))E=B;else{o=B;while(1){F=b[o>>0]|0;G=c;do{if(F<<24>>24==(b[G>>0]|0)){E=o;break c}G=G+1|0}while((G|0)!=(D|0));o=o+1|0;if((o|0)==(C|0)){v=34;break a}}}while(0);i=E-y|0;if((E|0)==(C|0)|(i|0)==-1){v=34;break}mYc(g,a,A,i-A|0,a);D=f[n>>2]|0;if(D>>>0>=(f[k>>2]|0)>>>0){QA(d,g);if((b[x>>0]|0)<0)cYc(f[g>>2]|0)}else{f[D>>2]=f[g>>2];f[D+4>>2]=f[g+4>>2];f[D+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[n>>2]=(f[n>>2]|0)+12}p=b[r>>0]|0;D=p<<24>>24<0;B=f[a>>2]|0;w=f[t>>2]|0;j=D?w:p&255;m=dJc(c)|0;if(j>>>0<=i>>>0){v=44;break}else{l=D?B:a;q=B}}if((v|0)==34){mYc(g,a,A,-1,a);a=f[n>>2]|0;if(a>>>0>=(f[k>>2]|0)>>>0){QA(d,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0)}else{f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[n>>2]=(f[n>>2]|0)+12}u=e;return}else if((v|0)==44){u=e;return}}function dtc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;a:do if((a|0)==(c|0)){d=a;e=a;while(1){switch(b[d>>0]|0){case 92:case 0:{f=d;g=e;break a;break}default:{}}h=d+1|0;i=e+1|0;if((d|0)==(e|0)){d=h;e=i}else{f=h;g=i;break a}}}else{f=a;g=c}while(0);a=b[f>>0]|0;if(!(a<<24>>24)){j=g;b[j>>0]=0;k=j;l=c;m=k-l|0;return m|0}else{n=f;o=g;p=a}b:while(1){a=n+1|0;if(p<<24>>24==92){g=b[a>>0]|0;c:do switch(g|0){case 0:{j=o;q=28;break b;break}case 97:{b[o>>0]=7;r=o+1|0;s=a;break}case 98:{b[o>>0]=8;r=o+1|0;s=a;break}case 102:{b[o>>0]=12;r=o+1|0;s=a;break}case 110:{b[o>>0]=10;r=o+1|0;s=a;break}case 114:{b[o>>0]=13;r=o+1|0;s=a;break}case 116:{b[o>>0]=9;r=o+1|0;s=a;break}case 118:{b[o>>0]=11;r=o+1|0;s=a;break}case 92:{b[o>>0]=92;r=o+1|0;s=a;break}case 63:{b[o>>0]=63;r=o+1|0;s=a;break}case 39:{b[o>>0]=39;r=o+1|0;s=a;break}case 34:{b[o>>0]=34;r=o+1|0;s=a;break}case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{f=g+208|0;e=n+2|0;d=b[e>>0]|0;i=(d&-8)<<24>>24==48;h=i?e:a;e=i?(f<<3)+208+(d&255)|0:f;f=h+1|0;d=b[f>>0]|0;i=(d&-8)<<24>>24==48;b[o>>0]=i?(d&255)+208+(e<<3)|0:e;r=o+1|0;s=i?f:h;break}case 88:case 120:{h=b[n+2>>0]|0;if((h+-48&255)<10){t=0;u=a}else switch(h<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{t=0;u=a;break}default:{r=o;s=a;break c}}d:while(1){h=u+1|0;f=b[h>>0]|0;if((f+-48&255)>=10)switch(f<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}i=f&255;t=((f&255)>57?i+9|0:i)&15|t<<4;u=h}b[o>>0]=t;r=o+1|0;s=u;break}default:{r=o;s=a}}while(0);v=s+1|0;w=r}else{b[o>>0]=p;v=a;w=o+1|0}p=b[v>>0]|0;if(!(p<<24>>24)){j=w;q=28;break}else{n=v;o=w}}if((q|0)==28){b[j>>0]=0;k=j;l=c;m=k-l|0;return m|0}return 0}function etc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=bYc((e?f[c+4>>2]|0:d&255)+1|0)|0;d=dtc(e?f[c>>2]|0:c,g,0)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(d>>>0>4294967279)jYc(a);if(d>>>0<11){b[a+11>>0]=d;if(!d){h=a;i=h+d|0;b[i>>0]=0;dYc(g);return}else j=a}else{c=d+16&-16;e=$Xc(c)|0;f[a>>2]=e;f[a+8>>2]=c|-2147483648;f[a+4>>2]=d;j=e}o1c(j|0,g|0,d|0)|0;h=j;i=h+d|0;b[i>>0]=0;dYc(g);return}function ftc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;g=f[e>>2]|0;i=(g|0)>0;if(i){j=0;k=0;while(1){l=(b[511082+(h[d+k>>0]|0)>>0]|0)+j|0;k=k+1|0;if((k|0)==(g|0)){m=l;break}else j=l}}else m=0;if((m|0)==(g|0)){zYc(c,d,g)|0;return}g=c+11|0;j=b[g>>0]|0;if(j<<24>>24<0)n=f[c+4>>2]|0;else n=j&255;uYc(c,n+m|0,0);if((b[g>>0]|0)<0)o=f[c>>2]|0;else o=c;if(!i)return;i=o+n|0;n=0;o=d;while(1){d=b[o+n>>0]|0;a:do switch(d<<24>>24){case 10:{b[i>>0]=92;b[i+1>>0]=110;p=i+2|0;break}case 13:{b[i>>0]=92;b[i+1>>0]=114;p=i+2|0;break}case 9:{b[i>>0]=92;b[i+1>>0]=116;p=i+2|0;break}case 34:{b[i>>0]=92;b[i+1>>0]=34;p=i+2|0;break}case 39:{b[i>>0]=92;b[i+1>>0]=39;p=i+2|0;break}case 92:{b[i>>0]=92;b[i+1>>0]=92;p=i+2|0;break}default:{c=i+1|0;if(d<<24>>24>31&d<<24>>24!=127){b[i>>0]=d;p=c;break a}else{b[i>>0]=92;b[c>>0]=(d&255)>>>6|48;b[i+2>>0]=(d&255)>>>3&7|48;b[i+3>>0]=d&7|48;p=i+4|0;break a}}}while(0);d=n+1|0;if((d|0)>=(f[e>>2]|0))break;i=p;n=d;o=f[a>>2]|0}return}function gtc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d+8|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=b[c+11>>0]|0;i=h<<24>>24<0;f[g>>2]=i?f[c>>2]|0:c;f[g+4>>2]=i?f[c+4>>2]|0:h&255;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];ftc(e,a);u=d;return}function htc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=d+20|0;b[d+21>>0]=0;if((c|0)>-1|(c|0)==-1&a>>>0>4294967295){f=e;g=a;h=c;while(1){i=j1c(g|0,h|0,10,0)|0;j=d1c(i|0,J|0,48,0)|0;b[f>>0]=j;j=g;g=v1c(g|0,h|0,10,0)|0;if(!((h|0)>0|(h|0)==0&j>>>0>9)){k=f;break}else{f=f+-1|0;h=J}}return k|0}if((c|0)>-1|(c|0)==-1&a>>>0>4294967286){h=c1c(48,0,a|0,c|0)|0;b[e>>0]=h;l=d+19|0}else{h=c1c(-10,-1,a|0,c|0)|0;c=J;a=j1c(h|0,c|0,10,0)|0;f=d1c(a|0,J|0,48,0)|0;b[e>>0]=f;f=v1c(h|0,c|0,10,0)|0;c=d1c(f|0,J|0,1,0)|0;f=d+19|0;d=c;c=J;while(1){h=j1c(d|0,c|0,10,0)|0;e=d1c(h|0,J|0,48,0)|0;h=f+-1|0;b[f>>0]=e;e=d;d=v1c(d|0,c|0,10,0)|0;if(!((c|0)>0|(c|0)==0&e>>>0>9)){l=h;break}else{f=h;c=J}}}b[l>>0]=45;k=l;return k|0}function itc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=c+10|0;b[c+11>>0]=0;if((a|0)>-1){e=d;f=a;while(1){b[e>>0]=((f|0)%10|0)+48;if((f|0)>9){e=e+-1|0;f=(f|0)/10|0}else{g=e;break}}return g|0}if((a|0)>-10){b[d>>0]=48-a;h=c+9|0}else{e=-10-a|0;b[d>>0]=((e|0)%10|0)+48;d=c+9|0;c=((e|0)/10|0)+1|0;while(1){e=d+-1|0;b[d>>0]=((c|0)%10|0)+48;if((c|0)>9){d=e;c=(c|0)/10|0}else{h=e;break}}}b[h>>0]=45;g=h;return g|0}function jtc(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;do if(a>>>0<=999999999){if(a>>>0<100){if(a>>>0>9){d=a;e=c;break}b[c>>0]=a+48;f=c+1|0;b[f>>0]=0;return f|0}if(a>>>0<1e4){if(a>>>0>999){g=a;h=c;i=8;break}j=(a>>>0)/100|0;b[c>>0]=j+48;k=j;l=a;m=c+1|0;i=9;break}if(a>>>0<1e6){if(a>>>0>99999){n=a;o=c;i=6;break}j=(a>>>0)/1e4|0;b[c>>0]=j+48;p=j;q=a;r=c+1|0;i=7;break}if(a>>>0>=1e8){j=(a>>>0)/1e8|0;b[c>>0]=j+48;s=j;t=c+1|0;i=3;break}if(a>>>0>9999999){u=a;v=c;i=4}else{j=(a>>>0)/1e6|0;b[c>>0]=j+48;w=j;x=a;y=c+1|0;i=5}}else{j=(a>>>0)/1e8|0;b[c>>0]=b[511355+(j<<1)>>0]|0;b[c+1>>0]=b[511355+(j<<1)+1>>0]|0;s=j;t=c+2|0;i=3}while(0);if((i|0)==3){u=(Y(s,-1e8)|0)+a|0;v=t;i=4}if((i|0)==4){t=(u>>>0)/1e6|0;b[v>>0]=b[511355+(t<<1)>>0]|0;b[v+1>>0]=b[511355+(t<<1)+1>>0]|0;w=t;x=u;y=v+2|0;i=5}if((i|0)==5){n=(Y(w,-1e6)|0)+x|0;o=y;i=6}if((i|0)==6){y=(n>>>0)/1e4|0;b[o>>0]=b[511355+(y<<1)>>0]|0;b[o+1>>0]=b[511355+(y<<1)+1>>0]|0;p=y;q=n;r=o+2|0;i=7}if((i|0)==7){g=(Y(p,-1e4)|0)+q|0;h=r;i=8}if((i|0)==8){r=(g>>>0)/100|0;b[h>>0]=b[511355+(r<<1)>>0]|0;b[h+1>>0]=b[511355+(r<<1)+1>>0]|0;k=r;l=g;m=h+2|0;i=9}if((i|0)==9){d=(Y(k,-100)|0)+l|0;e=m}b[e>>0]=b[511355+(d<<1)>>0]|0;b[e+1>>0]=b[511355+(d<<1)+1>>0]|0;f=e+2|0;b[f>>0]=0;return f|0}function ktc(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)<0){b[c>>0]=45;d=0-a|0;e=c+1|0}else{d=a;e=c}return jtc(d,e)|0}function ltc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;if((a|0)==(a|0)&0==(c|0))return jtc(a,d)|0;else{e=n1c(a|0,c|0,1e9,0)|0;f=J;g=ltc(e,f,d)|0;d=x1c(e|0,f|0,-1e9,-1)|0;f=d1c(d|0,J|0,a|0,c|0)|0;c=(f>>>0)/1e7|0;b[g>>0]=b[511355+(c<<1)>>0]|0;b[g+1>>0]=b[511355+(c<<1)+1>>0]|0;a=(Y(c,-1e7)|0)+f|0;f=(a>>>0)/1e5|0;b[g+2>>0]=b[511355+(f<<1)>>0]|0;b[g+3>>0]=b[511355+(f<<1)+1>>0]|0;c=(Y(f,-1e5)|0)+a|0;a=(c>>>0)/1e3|0;b[g+4>>0]=b[511355+(a<<1)>>0]|0;b[g+5>>0]=b[511355+(a<<1)+1>>0]|0;f=(Y(a,-1e3)|0)+c|0;c=(f>>>0)/10|0;b[g+6>>0]=b[511355+(c<<1)>>0]|0;b[g+7>>0]=b[511355+(c<<1)+1>>0]|0;a=f+48+(Y(c,-10)|0)&255;c=g+9|0;b[g+8>>0]=a;b[c>>0]=0;return c|0}return 0}function mtc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=e+10|0;b[e+11>>0]=0;if((c|0)>-1){h=g;i=c;while(1){b[h>>0]=((i|0)%10|0)+48;if((i|0)>9){h=h+-1|0;i=(i|0)/10|0}else{j=h;break}}}else{if((c|0)>-10){b[g>>0]=48-c;k=e+9|0}else{h=-10-c|0;b[g>>0]=((h|0)%10|0)+48;g=e+9|0;e=((h|0)/10|0)+1|0;while(1){h=g+-1|0;b[g>>0]=((e|0)%10|0)+48;if((e|0)>9){g=h;e=(e|0)/10|0}else{k=h;break}}}b[k>>0]=45;j=k};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;k=dJc(j)|0;if(k>>>0>4294967279)jYc(a);if(k>>>0<11){b[a+11>>0]=k;if(!k){l=a;m=l+k|0;b[m>>0]=0;u=d;return}else n=a}else{e=k+16&-16;g=$Xc(e)|0;f[a>>2]=g;f[a+8>>2]=e|-2147483648;f[a+4>>2]=k;n=g}o1c(n|0,j|0,k|0)|0;l=n;m=l+k|0;b[m>>0]=0;u=d;return}function ntc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d;g=jtc(c,e)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=g-e|0;if(c>>>0>4294967279)jYc(a);if(c>>>0<11){b[a+11>>0]=c;h=a}else{i=c+16&-16;j=$Xc(i)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=c;h=j}if((e|0)==(g|0)){k=h;b[k>>0]=0;u=d;return}else{l=h;m=e}while(1){b[l>>0]=b[m>>0]|0;m=m+1|0;if((m|0)==(g|0))break;else l=l+1|0}k=h+c|0;b[k>>0]=0;u=d;return}function otc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e;h=g+20|0;b[g+21>>0]=0;if((d|0)>-1|(d|0)==-1&c>>>0>4294967295){i=h;j=c;k=d;while(1){l=j1c(j|0,k|0,10,0)|0;m=d1c(l|0,J|0,48,0)|0;b[i>>0]=m;m=j;j=v1c(j|0,k|0,10,0)|0;if(!((k|0)>0|(k|0)==0&m>>>0>9)){n=i;break}else{i=i+-1|0;k=J}}}else{if((d|0)>-1|(d|0)==-1&c>>>0>4294967286){k=c1c(48,0,c|0,d|0)|0;b[h>>0]=k;o=g+19|0}else{k=c1c(-10,-1,c|0,d|0)|0;d=J;c=j1c(k|0,d|0,10,0)|0;i=d1c(c|0,J|0,48,0)|0;b[h>>0]=i;i=v1c(k|0,d|0,10,0)|0;d=d1c(i|0,J|0,1,0)|0;i=g+19|0;g=d;d=J;while(1){k=j1c(g|0,d|0,10,0)|0;h=d1c(k|0,J|0,48,0)|0;k=i+-1|0;b[i>>0]=h;h=g;g=v1c(g|0,d|0,10,0)|0;if(!((d|0)>0|(d|0)==0&h>>>0>9)){o=k;break}else{i=k;d=J}}}b[o>>0]=45;n=o};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;o=dJc(n)|0;if(o>>>0>4294967279)jYc(a);if(o>>>0<11){b[a+11>>0]=o;if(!o){p=a;q=p+o|0;b[q>>0]=0;u=e;return}else r=a}else{d=o+16&-16;i=$Xc(d)|0;f[a>>2]=i;f[a+8>>2]=d|-2147483648;f[a+4>>2]=o;r=i}o1c(r|0,n|0,o|0)|0;p=r;q=p+o|0;b[q>>0]=0;u=e;return}function ptc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=ltc(c,d,g)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d=h-g|0;if(d>>>0>4294967279)jYc(a);if(d>>>0<11){b[a+11>>0]=d;i=a}else{c=d+16&-16;j=$Xc(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=d;i=j}if((g|0)==(h|0)){k=i;b[k>>0]=0;u=e;return}else{l=i;m=g}while(1){b[l>>0]=b[m>>0]|0;m=m+1|0;if((m|0)==(h|0))break;else l=l+1|0}k=i+d|0;b[k>>0]=0;u=e;return}function qtc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=rtc(c,d)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=dJc(e)|0;if(g>>>0>4294967279)jYc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;u=d;return}else j=a}else{k=g+16&-16;l=$Xc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}o1c(j|0,e|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;u=d;return}function rtc(a,c){a=+a;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0,k=0;d=u;u=u+32|0;e=d+16|0;g=d;if(a==D){b[c>>0]=105;b[c+1>>0]=110;b[c+2>>0]=102;b[c+3>>0]=0;u=d;return c|0}if(a==-D){b[c>>0]=b[511555]|0;b[c+1>>0]=b[511556]|0;b[c+2>>0]=b[511557]|0;b[c+3>>0]=b[511558]|0;b[c+4>>0]=b[511559]|0;u=d;return c|0}p[s>>3]=a;h=f[s+4>>2]&2147483647;if(h>>>0>2146435072|(h|0)==2146435072&(f[s>>2]|0)>>>0>0){b[c>>0]=110;b[c+1>>0]=97;b[c+2>>0]=110;b[c+3>>0]=0;u=d;return c|0}f[g>>2]=15;p[g+8>>3]=a;oJc(c,32,511560,g)|0;i=+aLc(c,0);p[g>>3]=i;if(+p[g>>3]!=a){f[e>>2]=17;p[e+8>>3]=a;oJc(c,32,511560,e)|0}a:do if(!(OJc(c,46)|0)){e=c;b:while(1){g=b[e>>0]|0;if((g+-48&255)>=10)switch(g<<24>>24){case 0:{break a;break}case 45:case 43:case 69:case 101:break;default:break b}e=e+1|0}b[e>>0]=46;g=e+1|0;h=b[g>>0]|0;if((h+-48&255)>=10){switch(h<<24>>24){case 0:case 45:case 43:case 69:case 101:{break a;break}default:j=g}c:while(1){k=j+1|0;h=b[k>>0]|0;if((h+-48&255)<10)break;switch(h<<24>>24){case 0:case 45:case 43:case 69:case 101:{break c;break}default:j=k}}q1c(g|0,k|0,(dJc(k)|0)+1|0)|0}}while(0);u=d;return c|0}function stc(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=ttc(c,d)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=dJc(e)|0;if(g>>>0>4294967279)jYc(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;u=d;return}else j=a}else{k=g+16&-16;l=$Xc(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}o1c(j|0,e|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;u=d;return}function ttc(a,c){a=+a;c=c|0;var d=0,e=0,g=0,h=0.0,i=0,j=0.0,k=0,l=0,m=0,o=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a;if(a==D){b[c>>0]=105;b[c+1>>0]=110;b[c+2>>0]=102;b[c+3>>0]=0;u=d;return c|0}if(a==-D){b[c>>0]=b[511555]|0;b[c+1>>0]=b[511556]|0;b[c+2>>0]=b[511557]|0;b[c+3>>0]=b[511558]|0;b[c+4>>0]=b[511559]|0;u=d;return c|0}if(((n[s>>2]=a,f[s>>2]|0)&2147483647)>>>0>2139095040){b[c>>0]=110;b[c+1>>0]=97;b[c+2>>0]=110;b[c+3>>0]=0;u=d;return c|0}f[g>>2]=6;p[g+8>>3]=h;oJc(c,24,511560,g)|0;i=vIc()|0;f[i>>2]=0;j=+eLc(c,g);if((b[c>>0]|0)!=0?(b[f[g>>2]>>0]|0)==0:0){g=vIc()|0;if(j!=a|(f[g>>2]|0)!=0)k=11}else k=11;if((k|0)==11){f[e>>2]=9;p[e+8>>3]=h;oJc(c,24,511560,e)|0}if(!(OJc(c,46)|0))l=c;else{u=d;return c|0}a:while(1){e=b[l>>0]|0;if((e+-48&255)>=10)switch(e<<24>>24){case 0:{k=21;break a;break}case 45:case 43:case 69:case 101:break;default:break a}l=l+1|0}if((k|0)==21){u=d;return c|0}b[l>>0]=46;k=l+1|0;l=b[k>>0]|0;if((l+-48&255)<10){u=d;return c|0}switch(l<<24>>24){case 0:case 45:case 43:case 69:case 101:{u=d;return c|0}default:m=k}b:while(1){o=m+1|0;l=b[o>>0]|0;if((l+-48&255)<10)break;switch(l<<24>>24){case 0:case 45:case 43:case 69:case 101:{break b;break}default:m=o}}q1c(k|0,o|0,(dJc(o)|0)+1|0)|0;u=d;return c|0}function utc(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;lYc(e,a);a=vtc(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return a|0}cYc(f[e>>2]|0);u=d;return a|0}function vtc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+32|0;e=d+12|0;g=d;f[c>>2]=0;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a>>2]|0;l=f[a+4>>2]|0}else{k=a;l=i&255}i=k+l|0;a:do if((l|0)>0){m=k;while(1){if((b[m>>0]|0)!=32){n=m;break a}o=m+1|0;if(o>>>0<i>>>0)m=o;else{n=o;break}}}else n=k;while(0);k=i;while(1){if(n>>>0>=k>>>0){p=0;q=32;break}i=k+-1|0;if((b[i>>0]|0)==32)k=i;else break}if((q|0)==32){u=d;return p|0}q=b[n>>0]|0;i=q<<24>>24==45;switch(q<<24>>24){case 43:case 45:{q=n+1|0;if(q>>>0<k>>>0)r=q;else{p=0;u=d;return p|0}break}default:r=n}if(j)s=f[a>>2]|0;else s=a;j=r;mYc(e,a,j-s|0,k-j|0,a);if((b[h>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0}else{b[a>>0]=0;b[h>>0]=0}sYc(a,0);f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];f[a+8>>2]=f[e+8>>2];if(i){i=b[h>>0]|0;h=i<<24>>24<0;e=h?f[a>>2]|0:a;j=h?f[a+4>>2]|0:i&255;i=e+j|0;b:do if((j|0)>0){h=0;k=e;while(1){s=b[k>>0]|0;r=s&255;n=r+-48|0;if((s&255)<48|(n|0)>9){t=0;v=h;break b}if((h|0)<-214748364){t=0;v=-2147483648;break b}s=h*10|0;if((s|0)<(r+2147483600|0)){t=0;v=-2147483648;break b}r=s-n|0;k=k+1|0;if(k>>>0>=i>>>0){t=1;v=r;break}else h=r}}else{t=1;v=0}while(0);f[c>>2]=v;p=t;u=d;return p|0}lYc(g,a);a=b[g+11>>0]|0;t=a<<24>>24<0;v=f[g>>2]|0;i=t?v:g;e=t?f[g+4>>2]|0:a&255;a=i+e|0;c:do if((e|0)>0){g=0;j=i;while(1){h=b[j>>0]|0;k=h&255;r=k+-48|0;if((h&255)<48|(r|0)>9){w=0;x=g;break c}if((g|0)>214748364){w=0;x=2147483647;break c}h=g*10|0;if((h|0)>(-2147483601-k|0)){w=0;x=2147483647;break c}k=r+h|0;j=j+1|0;if(j>>>0>=a>>>0){w=1;x=k;break}else g=k}}else{w=1;x=0}while(0);f[c>>2]=x;if(!t){p=w;u=d;return p|0}cYc(v);p=w;u=d;return p|0}function wtc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+40|0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=u1c(f[c+8>>2]|0,0,2)|0;c=d1c(e|0,J|0,-4,-1)|0;e=u1c(1,0,c|0)|0;c=d;i=g;j=h;k=e|g;g=J|h;do{c=c+-1|0;b[c>>0]=b[511338+(i&15)>>0]|0;i=l1c(i|0,j|0,4)|0;j=J;k=l1c(k|0,g|0,4)|0;g=J}while(!((k|0)==0&(g|0)==0));f[a>>2]=c;f[a+4>>2]=d-c;return}function xtc(a,b){a=a|0;b=b|0;zYc(a,f[b>>2]|0,f[b+4>>2]|0)|0;return}function ytc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=b[a+11>>0]|0;i=g<<24>>24<0;j=i?f[a>>2]|0:a;k=i?f[a+4>>2]|0:g&255;g=j;i=j+k|0;do{if((i|0)==(j|0)){l=0;m=10;break}i=i+-1|0}while(!(AJc(528142,h[i>>0]|0,1)|0));if((m|0)==10){u=d;return l|0}m=i-g|0;if((m|0)==-1){l=0;u=d;return l|0}g=m+1|0;if((g|0)==(k|0)){l=0;u=d;return l|0}mYc(e,a,g,-1,a);a=c+11|0;if((b[a>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[a>>0]=0}sYc(c,0);f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];l=1;u=d;return l|0}function ztc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;mi[f[(f[a>>2]|0)+96>>2]&2047](g,a);a=f[g>>2]|0;h=f[a+4>>2]|0;i=b[h+11>>0]|0;if(((i<<24>>24<0?f[h+4>>2]|0:i&255)|0)!=19){j=0;u=e;return j|0}if(LYc(h,0,-1,511565,19)|0){j=0;u=e;return j|0}h=s3b(a,1)|0;f[c>>2]=h;h=s3b(a,2)|0;f[d>>2]=h;h=f[c>>2]|0;if(!h){j=0;u=e;return j|0}c=f[h+24>>2]|0;if(c|0?(f[c>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=h;J_b(c,g)}if((f[h+28>>2]|0)!=9){j=0;u=e;return j|0}h=f[d>>2]|0;if(!h){j=0;u=e;return j|0}d=f[h+24>>2]|0;if(d|0?(f[d>>2]|0)!=2:0){f[g>>2]=80424;f[g+4>>2]=2231;b[g+8>>0]=0;f[g+12>>2]=h;J_b(d,g)}j=(f[h+28>>2]|0)==12;u=e;return j|0}function Atc(a){a=a|0;f[a>>2]=172856;Htc(a);return}function Btc(a){a=a|0;f[a>>2]=172856;Htc(a);cYc(a);return}function Ctc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+80|0;h=g+24|0;i=g;j=g+12|0;Yi[f[(f[a>>2]|0)+28>>2]&4095](a);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=h+11|0;b[k>>0]=9;l=h;m=512094;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+9>>0]=0;o=f[d>>2]|0;p=jFc(o,h)|0;do if((p|0)!=(o+4|0)){q=p+28|0;r=f[q>>2]|0;s=(_i[f[(f[r>>2]|0)+28>>2]&2047](r)|0)+4|0;if((f[s>>2]|0)==515430){s=f[q>>2]|0;q=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,p+32|0)|0;t=f[q>>2]|0;break}else ig(af(1)|0,22144,0)}else t=0;while(0);p=a+8|0;f[p>>2]=t;if((b[k>>0]|0)<0){cYc(f[h>>2]|0);v=f[p>>2]|0}else v=t;if((v|0)==254){v=f[(f[a>>2]|0)+24>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;t=i+11|0;b[t>>0]=8;k=i;f[k>>2]=1701603686;f[k+4>>2]=1701667182;b[i+8>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=f[d>>2]|0;o=jFc(k,i)|0;do if((o|0)!=(k+4|0)){q=o+28|0;s=f[q>>2]|0;r=(_i[f[(f[s>>2]|0)+28>>2]&2047](s)|0)+4|0;if((f[r>>2]|0)==213802){r=f[q>>2]|0;lYc(h,Mi[f[(f[r>>2]|0)+20>>2]&1023](r,o+32|0)|0);break}else ig(af(1)|0,22144,0)}else lYc(h,j);while(0);hj[v&511](a,c,h)|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[t>>0]|0)<0)cYc(f[i>>2]|0);u=g;return}do if((eS(c)|0)==65536){t=f[c+4>>2]|0;f[h>>2]=f[t>>2];j=h+4|0;v=t+4|0;f[j>>2]=f[v>>2];o=h+8|0;f[o>>2]=f[t+8>>2];f[h+12>>2]=f[t+12>>2];f[h+16>>2]=f[t+16>>2];f[h+20>>2]=f[t+20>>2];f[h+24>>2]=f[t+24>>2];f[h+28>>2]=f[t+28>>2];f[h+32>>2]=f[t+32>>2];k=f[t+36>>2]|0;f[h+36>>2]=k;f[h+40>>2]=o;o=h+48|0;r=h+44|0;f[r>>2]=o;f[o>>2]=0;f[h+52>>2]=0;if(k|0){o=k+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[v>>2]|0)<3){v=f[t+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[v>>2];f[o+4>>2]=f[v+4>>2];w=h;break}else{f[j>>2]=0;U$(h,t);w=h;break}}else{bS(h,c,-1);w=h}while(0);c=a+16|0;f[c>>2]=0;f[a+12>>2]=f[w>>2]&4095;w=(f[p>>2]|0)==6?9:e;f[a+4>>2]=w;switch(w|0){case 9:{kFc(c,h,d,i);break}case 1:{lFc(c,h,d,i);break}case 2:{mFc(c,h,d,i);break}default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=$Xc(48)|0;f[i>>2]=d;f[i+8>>2]=-2147483600;f[i+4>>2]=33;l=d;m=511627;n=l+33|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[d+33>>0]=0;vM(-5,i,517712,511669,417)}}i=h+36|0;d=f[i>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)V$(h);f[i>>2]=0;i=h+16|0;d=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[d>>2]|0)>0){i=f[h+40>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[d>>2]|0))}d=f[h+44>>2]|0;if((d|0)!=(h+48|0))wL(d);u=g;return}function Dtc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;i=u;u=u+192|0;j=i+128|0;k=i+72|0;l=i+16|0;m=i;do if((eS(c)|0)==65536){n=f[c+4>>2]|0;f[j>>2]=f[n>>2];o=j+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=j+8|0;f[q>>2]=f[n+8>>2];f[j+12>>2]=f[n+12>>2];f[j+16>>2]=f[n+16>>2];f[j+20>>2]=f[n+20>>2];f[j+24>>2]=f[n+24>>2];f[j+28>>2]=f[n+28>>2];f[j+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[j+36>>2]=r;f[j+40>>2]=q;s=j+48|0;t=j+44|0;f[t>>2]=s;f[s>>2]=0;f[j+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[p>>2];f[s+4>>2]=f[p+4>>2];v=q;break}else{f[o>>2]=0;U$(j,n);v=q;break}}else{bS(j,c,-1);v=j+8|0}while(0);f[k>>2]=1124007936;c=k+4|0;q=k+8|0;n=k+40|0;o=c;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=q;q=k+48|0;s=k+44|0;f[s>>2]=q;f[q>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;t=l+4|0;r=l+8|0;w=l+40|0;o=t;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[w>>2]=r;r=l+48|0;x=l+44|0;f[x>>2]=r;f[r>>2]=0;f[l+52>>2]=0;y=a+4|0;cFc(d,e,k,l,f[v>>2]|0,g,g,(f[y>>2]|0)==9?4:5);switch(f[y>>2]|0){case 9:{gFc(f[a+16>>2]|0,j,k,l,g,h);break}case 1:{hFc(f[a+16>>2]|0,j,k,l,g,h);break}case 2:{iFc(f[a+16>>2]|0,j,k,l,g,h);break}default:{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;h=$Xc(48)|0;f[m>>2]=h;f[m+8>>2]=-2147483600;f[m+4>>2]=33;o=h;g=511627;p=o+33|0;do{b[o>>0]=b[g>>0]|0;o=o+1|0;g=g+1|0}while((o|0)<(p|0));b[h+33>>0]=0;vM(-5,m,517658,511669,609)}}m=l+36|0;h=f[m>>2]|0;if(h|0?(g=h+12|0,h=f[g>>2]|0,f[g>>2]=h+-1,(h|0)==1):0)V$(l);f[m>>2]=0;m=l+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[t>>2]|0)>0){m=f[w>>2]|0;w=0;do{f[m+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[x>>2]|0;if((t|0)!=(r|0))wL(t);t=k+36|0;r=f[t>>2]|0;if(r|0?(x=r+12|0,r=f[x>>2]|0,f[x>>2]=r+-1,(r|0)==1):0)V$(k);f[t>>2]=0;t=k+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[c>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[c>>2]|0))}c=f[s>>2]|0;if((c|0)!=(q|0))wL(c);c=j+36|0;q=f[c>>2]|0;if(q|0?(s=q+12|0,q=f[s>>2]|0,f[s>>2]=q+-1,(q|0)==1):0)V$(j);f[c>>2]=0;c=j+16|0;q=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[j+40>>2]|0;s=0;do{f[c+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[j+44>>2]|0;if((q|0)==(j+48|0)){u=i;return}wL(q);u=i;return}function Etc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=u;u=u+192|0;k=j+128|0;l=j+72|0;m=j+16|0;n=j;do if((eS(c)|0)==65536){o=f[c+4>>2]|0;f[k>>2]=f[o>>2];p=k+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=k+8|0;f[r>>2]=f[o+8>>2];f[k+12>>2]=f[o+12>>2];f[k+16>>2]=f[o+16>>2];f[k+20>>2]=f[o+20>>2];f[k+24>>2]=f[o+24>>2];f[k+28>>2]=f[o+28>>2];f[k+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=r;r=k+48|0;t=k+44|0;f[t>>2]=r;f[r>>2]=0;f[k+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(k,o);break}}else bS(k,c,-1);while(0);f[l>>2]=1124007936;c=l+4|0;o=l+8|0;p=l+40|0;q=c;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=l+48|0;t=l+44|0;f[t>>2]=o;f[o>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;s=m+4|0;v=m+8|0;w=m+40|0;q=s;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[w>>2]=v;v=m+48|0;x=m+44|0;f[x>>2]=v;f[v>>2]=0;f[m+52>>2]=0;y=a+4|0;if((h|0)<=0){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;z=$Xc(16)|0;f[n>>2]=z;f[n+8>>2]=-2147483632;f[n+4>>2]=14;q=z;A=517418;r=q+14|0;do{b[q>>0]=b[A>>0]|0;q=q+1|0;A=A+1|0}while((q|0)<(r|0));b[z+14>>0]=0;vM(-215,n,517433,511669,621)}cFc(d,e,l,m,f[k+8>>2]|0,h,2147483647,(f[y>>2]|0)==9?4:5);if((f[a+8>>2]|0)==6){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;h=$Xc(64)|0;f[n>>2]=h;f[n+8>>2]=-2147483584;f[n+4>>2]=49;q=h;A=517446;r=q+49|0;do{b[q>>0]=b[A>>0]|0;q=q+1|0;A=A+1|0}while((q|0)<(r|0));b[h+49>>0]=0;vM(-213,n,517433,511669,625)}switch(f[y>>2]|0){case 9:{B=dFc(f[a+16>>2]|0,k,l,m,g,i)|0;break}case 1:{B=eFc(f[a+16>>2]|0,k,l,m,g,i)|0;break}case 2:{B=fFc(f[a+16>>2]|0,k,l,m,g,i)|0;break}default:{f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;i=$Xc(48)|0;f[n>>2]=i;f[n+8>>2]=-2147483600;f[n+4>>2]=33;q=i;A=511627;r=q+33|0;do{b[q>>0]=b[A>>0]|0;q=q+1|0;A=A+1|0}while((q|0)<(r|0));b[i+33>>0]=0;vM(-5,n,517433,511669,649)}}n=m+36|0;i=f[n>>2]|0;if(i|0?(A=i+12|0,i=f[A>>2]|0,f[A>>2]=i+-1,(i|0)==1):0)V$(m);f[n>>2]=0;n=m+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[s>>2]|0)>0){n=f[w>>2]|0;w=0;do{f[n+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[s>>2]|0))}s=f[x>>2]|0;if((s|0)!=(v|0))wL(s);s=l+36|0;v=f[s>>2]|0;if(v|0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0)V$(l);f[s>>2]=0;s=l+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[c>>2]|0)>0){s=f[p>>2]|0;p=0;do{f[s+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[t>>2]|0;if((c|0)!=(o|0))wL(c);c=k+36|0;o=f[c>>2]|0;if(o|0?(t=o+12|0,o=f[t>>2]|0,f[t>>2]=o+-1,(o|0)==1):0)V$(k);f[c>>2]=0;c=k+16|0;o=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[o>>2]|0)>0){c=f[k+40>>2]|0;t=0;do{f[c+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[o>>2]|0))}o=f[k+44>>2]|0;if((o|0)==(k+48|0)){u=j;return B|0}wL(o);u=j;return B|0}function Ftc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+64|0;e=d;g=d+8|0;h=c+11|0;i=iKc((b[h>>0]|0)<0?f[c>>2]|0:c,517357)|0;if(!i){f[e>>2]=(b[h>>0]|0)<0?f[c>>2]|0:c;DM(g,517360,e);vM(-2,g,517406,511669,686)}e=a+4|0;switch(f[e>>2]|0){case 9:{c=f[a+16>>2]|0;f[g+12>>2]=0;j=g;k=517309;l=j+12|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));h=g+16|0;j=g+23|0;l=j+9|0;do{b[j>>0]=0;j=j+1|0}while((j|0)<(l|0));b[h>>0]=b[517411]|0;b[h+1>>0]=b[517412]|0;b[h+2>>0]=b[517413]|0;b[h+3>>0]=b[517414]|0;b[h+4>>0]=b[517415]|0;b[h+5>>0]=b[517416]|0;b[h+6>>0]=b[517417]|0;f[g+32>>2]=4;h=_i[f[(f[c>>2]|0)+40>>2]&2047](c)|0;f[g+36>>2]=h;h=_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0;f[g+40>>2]=h;h=_i[f[(f[c>>2]|0)+32>>2]&2047](c)|0;f[g+44>>2]=h;eKc(g,48,1,i)|0;f[g>>2]=f[e>>2];eKc(g,4,1,i)|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,i);oKc(i)|0;u=d;return}case 1:{c=f[a+16>>2]|0;f[g+12>>2]=0;j=g;k=517309;l=j+12|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));h=g+16|0;j=g+23|0;l=j+9|0;do{b[j>>0]=0;j=j+1|0}while((j|0)<(l|0));b[h>>0]=b[517411]|0;b[h+1>>0]=b[517412]|0;b[h+2>>0]=b[517413]|0;b[h+3>>0]=b[517414]|0;b[h+4>>0]=b[517415]|0;b[h+5>>0]=b[517416]|0;b[h+6>>0]=b[517417]|0;f[g+32>>2]=8;h=_i[f[(f[c>>2]|0)+40>>2]&2047](c)|0;f[g+36>>2]=h;h=_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0;f[g+40>>2]=h;h=_i[f[(f[c>>2]|0)+32>>2]&2047](c)|0;f[g+44>>2]=h;eKc(g,48,1,i)|0;f[g>>2]=f[e>>2];eKc(g,4,1,i)|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,i);oKc(i)|0;u=d;return}case 2:{c=f[a+16>>2]|0;f[g+12>>2]=0;j=g;k=517309;l=j+12|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));a=g+16|0;j=g+23|0;l=j+9|0;do{b[j>>0]=0;j=j+1|0}while((j|0)<(l|0));b[a>>0]=b[517411]|0;b[a+1>>0]=b[517412]|0;b[a+2>>0]=b[517413]|0;b[a+3>>0]=b[517414]|0;b[a+4>>0]=b[517415]|0;b[a+5>>0]=b[517416]|0;b[a+6>>0]=b[517417]|0;f[g+32>>2]=8;a=_i[f[(f[c>>2]|0)+40>>2]&2047](c)|0;f[g+36>>2]=a;a=_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0;f[g+40>>2]=a;a=_i[f[(f[c>>2]|0)+32>>2]&2047](c)|0;f[g+44>>2]=a;eKc(g,48,1,i)|0;f[g>>2]=f[e>>2];eKc(g,4,1,i)|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,i);oKc(i)|0;u=d;return}default:{oKc(i)|0;i=$Xc(48)|0;f[g>>2]=i;f[g+8>>2]=-2147483600;f[g+4>>2]=33;j=i;k=511627;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+33>>0]=0;vM(-5,g,517406,511669,719)}}}function Gtc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+160|0;g=e+32|0;h=e+24|0;i=e;j=e+88|0;k=e+40|0;l=e+36|0;m=e+144|0;do if((eS(c)|0)==65536){n=f[c+4>>2]|0;f[j>>2]=f[n>>2];o=j+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=j+8|0;f[q>>2]=f[n+8>>2];f[j+12>>2]=f[n+12>>2];f[j+16>>2]=f[n+16>>2];f[j+20>>2]=f[n+20>>2];f[j+24>>2]=f[n+24>>2];f[j+28>>2]=f[n+28>>2];f[j+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[j+36>>2]=r;f[j+40>>2]=q;q=j+48|0;s=j+44|0;f[s>>2]=q;f[q>>2]=0;f[j+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;U$(j,n);break}}else bS(j,c,-1);while(0);Yi[f[(f[a>>2]|0)+28>>2]&4095](a);c=iKc((b[d+11>>0]|0)<0?f[d>>2]|0:d,511741)|0;if(!c)t=0;else{Itc(k,c);d=a+8|0;f[d>>2]=f[k+36>>2];n=f[k+32>>2]|0;switch(n|0){case 4:{v=0;break}case 0:{v=1;break}case 5:{v=2;break}case 1:{v=3;break}case 2:{v=4;break}case 8:{v=5;break}default:v=(n|0)==9?6:-1}n=a+12|0;f[n>>2]=v;o=f[k+40>>2]|0;p=f[j+8>>2]|0;q=f[k+44>>2]|0;k=f[j+12>>2]|0;if((o|0)==(p|0)&(q|0)==(k|0))if((v|0)==(f[j>>2]&4095|0)){f[l>>2]=0;if((NLc(l,4,1,c)|0)!=1){s=af(60)|0;Jtc(s,511860);ig(s|0,22128,1)}s=f[l>>2]|0;f[a+4>>2]=s;l=f[n>>2]|0;a:do if((s|0)==9&(l|0)==0){Ktc(a,a+16|0,j,c,m)|0;w=1;x=29}else{if(!((s|0)!=9&(l|0)==5)){n=f[46249]|0;r=f[d>>2]|0;f[h>>2]=l;f[h+4>>2]=r;OKc(n,511882,h)|0;oKc(c)|0;y=0;break}switch(s|0){case 2:{Mtc(a,a+16|0,j,c,m)|0;w=1;x=29;break a;break}case 1:{Ltc(a,a+16|0,j,c,m)|0;w=1;x=29;break a;break}default:{n=f[46249]|0;f[g>>2]=s;OKc(n,511960,g)|0;w=0;x=29;break a}}}while(0);if((x|0)==29){oKc(c)|0;y=w}z=y}else{A=q;x=18}else{A=k;x=18}if((x|0)==18){x=f[46249]|0;k=f[j>>2]&4095;f[i>>2]=o;f[i+4>>2]=q;f[i+8>>2]=v;f[i+12>>2]=p;f[i+16>>2]=A;f[i+20>>2]=k;OKc(x,511744,i)|0;oKc(c)|0;z=0}t=z}z=j+36|0;c=f[z>>2]|0;if(c|0?(i=c+12|0,c=f[i>>2]|0,f[i>>2]=c+-1,(c|0)==1):0)V$(j);f[z>>2]=0;z=j+16|0;c=j+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[c>>2]|0)>0){z=f[j+40>>2]|0;i=0;do{f[z+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)==(j+48|0)){u=e;return t|0}wL(c);u=e;return t|0}function Htc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=a+16|0;g=f[e>>2]|0;if(!g){u=c;return}switch(f[a+4>>2]|0){case 9:{Yi[f[(f[g>>2]|0)+4>>2]&4095](g);break}case 1:{Yi[f[(f[g>>2]|0)+4>>2]&4095](g);break}case 2:{Yi[f[(f[g>>2]|0)+4>>2]&4095](g);break}default:{g=$Xc(48)|0;f[d>>2]=g;f[d+8>>2]=-2147483600;f[d+4>>2]=33;a=g;h=511627;i=a+33|0;do{b[a>>0]=b[h>>0]|0;a=a+1|0;h=h+1|0}while((a|0)<(i|0));b[g+33>>0]=0;vM(-5,d,511661,511669,472)}}f[e>>2]=0;u=c;return}function Itc(a,b){a=a|0;b=b|0;if((NLc(a,48,1,b)|0)!=1){b=af(60)|0;Jtc(b,517277);ig(b|0,22128,1)}if(!(GIc(a,517309)|0))return;else{a=af(60)|0;Jtc(a,517321);ig(a|0,22128,1)}}function Jtc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=dJc(c)|0;if(i>>>0>4294967279)jYc(e);if(i>>>0<11){b[e+11>>0]=i;if(!i)j=e;else{k=e;l=6}}else{m=i+16&-16;n=$Xc(m)|0;f[e>>2]=n;f[e+8>>2]=m|-2147483648;f[e+4>>2]=i;k=n;l=6}if((l|0)==6){o1c(k|0,c|0,i|0)|0;j=k}b[j+i>>0]=0;i=g+11|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(96)|0;f[h>>2]=j;f[h+8>>2]=-2147483552;f[h+4>>2]=85;k=j;c=513408;l=k+85|0;do{b[k>>0]=b[c>>0]|0;k=k+1|0;c=c+1|0}while((k|0)<(l|0));b[j+85>>0]=0;wM(a,0,e,g,h,42);if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);if((b[i>>0]|0)<0)cYc(f[g>>2]|0);if((b[e+11>>0]|0)>=0){f[a>>2]=173604;u=d;return}cYc(f[e>>2]|0);f[a>>2]=173604;u=d;return}function Ktc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g+12|0;l=g;m=g+60|0;if((f[d>>2]&20479|0)!=16384){n=$Xc(80)|0;f[h>>2]=n;f[h+8>>2]=-2147483568;f[h+4>>2]=65;o=n;p=512017;q=o+65|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+65>>0]=0;vM(-215,h,512083,511669,730)}n=f[d+16>>2]|0;r=f[d+12>>2]|0;f[i>>2]=f[d+8>>2];f[i+4>>2]=r;f[i+12>>2]=n;f[i+8>>2]=r;r=j+4|0;f[r>>2]=0;n=j+8|0;f[n>>2]=0;d=j+4|0;f[j>>2]=d;f[k>>2]=f[a+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;a=l+11|0;b[a>>0]=9;o=l;p=512094;q=o+9|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+9>>0]=0;p=Ntc(j,h,l)|0;o=f[p>>2]|0;if(!o){q=$Xc(36)|0;s=q+16|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];f[s+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;s=f[h>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=s;f[p>>2]=q;s=f[f[j>>2]>>2]|0;if(!s)t=q;else{f[j>>2]=s;t=f[p>>2]|0}UQ(f[r>>2]|0,t);f[n>>2]=(f[n>>2]|0)+1;v=q}else v=o;o=v+28|0;q=f[o>>2]|0;n=v+32|0;mi[f[f[q>>2]>>2]&2047](q,n);f[o>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,k,n);if((b[a>>0]|0)>=0){w=$Xc(24)|0;b[h>>0]=b[m>>0]|0;qDc(w,i,j,h);x=f[w>>2]|0;y=x+24|0;z=f[y>>2]|0;mi[z&2047](w,e);f[c>>2]=w;A=f[d>>2]|0;Ptc(j,A);u=g;return 1}cYc(f[l>>2]|0);w=$Xc(24)|0;b[h>>0]=b[m>>0]|0;qDc(w,i,j,h);x=f[w>>2]|0;y=x+24|0;z=f[y>>2]|0;mi[z&2047](w,e);f[c>>2]=w;A=f[d>>2]|0;Ptc(j,A);u=g;return 1}function Ltc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g+12|0;l=g;m=g+60|0;if((f[d>>2]&20479|0)!=16389){n=$Xc(80)|0;f[h>>2]=n;f[h+8>>2]=-2147483568;f[h+4>>2]=65;o=n;p=512017;q=o+65|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+65>>0]=0;vM(-215,h,512083,511669,730)}n=f[d+16>>2]|0;r=f[d+12>>2]|0;f[i>>2]=f[d+8>>2];f[i+4>>2]=r;f[i+12>>2]=n;f[i+8>>2]=r;r=j+4|0;f[r>>2]=0;n=j+8|0;f[n>>2]=0;d=j+4|0;f[j>>2]=d;f[k>>2]=f[a+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;a=l+11|0;b[a>>0]=9;o=l;p=512094;q=o+9|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+9>>0]=0;p=Ntc(j,h,l)|0;o=f[p>>2]|0;if(!o){q=$Xc(36)|0;s=q+16|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];f[s+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;s=f[h>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=s;f[p>>2]=q;s=f[f[j>>2]>>2]|0;if(!s)t=q;else{f[j>>2]=s;t=f[p>>2]|0}UQ(f[r>>2]|0,t);f[n>>2]=(f[n>>2]|0)+1;v=q}else v=o;o=v+28|0;q=f[o>>2]|0;n=v+32|0;mi[f[f[q>>2]>>2]&2047](q,n);f[o>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,k,n);if((b[a>>0]|0)>=0){w=$Xc(24)|0;b[h>>0]=b[m>>0]|0;Pzc(w,i,j,h);x=f[w>>2]|0;y=x+24|0;z=f[y>>2]|0;mi[z&2047](w,e);f[c>>2]=w;A=f[d>>2]|0;Ptc(j,A);u=g;return 1}cYc(f[l>>2]|0);w=$Xc(24)|0;b[h>>0]=b[m>>0]|0;Pzc(w,i,j,h);x=f[w>>2]|0;y=x+24|0;z=f[y>>2]|0;mi[z&2047](w,e);f[c>>2]=w;A=f[d>>2]|0;Ptc(j,A);u=g;return 1}function Mtc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g+12|0;l=g;m=g+60|0;if((f[d>>2]&20479|0)!=16389){n=$Xc(80)|0;f[h>>2]=n;f[h+8>>2]=-2147483568;f[h+4>>2]=65;o=n;p=512017;q=o+65|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[n+65>>0]=0;vM(-215,h,512083,511669,730)}n=f[d+16>>2]|0;r=f[d+12>>2]|0;f[i>>2]=f[d+8>>2];f[i+4>>2]=r;f[i+12>>2]=n;f[i+8>>2]=r;r=j+4|0;f[r>>2]=0;n=j+8|0;f[n>>2]=0;d=j+4|0;f[j>>2]=d;f[k>>2]=f[a+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;a=l+11|0;b[a>>0]=9;o=l;p=512094;q=o+9|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[l+9>>0]=0;p=Ntc(j,h,l)|0;o=f[p>>2]|0;if(!o){q=$Xc(36)|0;s=q+16|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];f[s+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;s=f[h>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=s;f[p>>2]=q;s=f[f[j>>2]>>2]|0;if(!s)t=q;else{f[j>>2]=s;t=f[p>>2]|0}UQ(f[r>>2]|0,t);f[n>>2]=(f[n>>2]|0)+1;v=q}else v=o;o=v+28|0;q=f[o>>2]|0;n=v+32|0;mi[f[f[q>>2]>>2]&2047](q,n);f[o>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,k,n);if((b[a>>0]|0)>=0){w=$Xc(24)|0;b[h>>0]=b[m>>0]|0;Otc(w,i,j,h);x=f[w>>2]|0;y=x+24|0;z=f[y>>2]|0;mi[z&2047](w,e);f[c>>2]=w;A=f[d>>2]|0;Ptc(j,A);u=g;return 1}cYc(f[l>>2]|0);w=$Xc(24)|0;b[h>>0]=b[m>>0]|0;Otc(w,i,j,h);x=f[w>>2]|0;y=x+24|0;z=f[y>>2]|0;mi[z&2047](w,e);f[c>>2]=w;A=f[d>>2]|0;Ptc(j,A);u=g;return 1}function Ntc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function Otc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+36|0;i=g+12|0;j=g+24|0;k=g;l=g+40|0;f[a>>2]=172904;m=a+12|0;f[a+16>>2]=0;f[a+20>>2]=0;n=a+16|0;f[m>>2]=n;o=f[d>>2]|0;p=d+4|0;if((o|0)!=(p|0)){q=n;n=o;while(1){o=n+16|0;f[i>>2]=q;f[h>>2]=f[i>>2];Qtc(m,h,o,o)|0;o=f[n+4>>2]|0;if(!o){r=n+8|0;s=f[r>>2]|0;if((f[s>>2]|0)==(n|0))t=s;else{s=r;do{r=f[s>>2]|0;s=r+8|0;v=f[s>>2]|0}while((f[v>>2]|0)!=(r|0));t=v}}else{s=o;while(1){v=f[s>>2]|0;if(!v)break;else s=v}t=s}if((t|0)==(p|0))break;else n=t}};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=j+11|0;b[t>>0]=9;n=j;p=512094;m=n+9|0;do{b[n>>0]=b[p>>0]|0;n=n+1|0;p=p+1|0}while((n|0)<(m|0));b[j+9>>0]=0;p=Rtc(d,j)|0;if((b[t>>0]|0)<0)cYc(f[j>>2]|0);j=a+8|0;b[j>>0]=0;if((p|0)!=254){p=Utc(c,d,e)|0;f[a+4>>2]=p;u=g;return};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=k+11|0;b[p>>0]=8;e=k;f[e>>2]=1701603686;f[e+4>>2]=1701667182;b[k+8>>0]=0;Stc(i,d,k);b[h>>0]=b[l>>0]|0;l=Ttc(c,i,h)|0;f[a+4>>2]=l;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[p>>0]|0)<0)cYc(f[k>>2]|0);b[j>>0]=1;u=g;return}function Ptc(a,c){a=a|0;c=c|0;var d=0;if(!c)return;Ptc(a,f[c>>2]|0);Ptc(a,f[c+4>>2]|0);a=c+16|0;d=f[c+28>>2]|0;mi[f[f[d>>2]>>2]&2047](d,c+32|0);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function Qtc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;f[i>>2]=f[b>>2];f[g>>2]=f[i>>2];i=hzc(a,g,h,e+4|0,c)|0;c=f[i>>2]|0;if(c|0){j=c;u=e;return j|0}c=$Xc(36)|0;lYc(c+16|0,d);g=c+28|0;f[g>>2]=172888;b=c+32|0;f[b>>2]=0;mi[f[f[43222]>>2]&2047](172888,b);k=f[d+12>>2]|0;f[g>>2]=k;Ti[f[(f[k>>2]|0)+8>>2]&511](k,d+16|0,b);b=f[h>>2]|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=b;f[i>>2]=c;b=f[f[a>>2]>>2]|0;if(!b)l=c;else{f[a>>2]=b;l=f[i>>2]|0}UQ(f[a+4>>2]|0,l);l=a+8|0;f[l>>2]=(f[l>>2]|0)+1;j=c;u=e;return j|0}function Rtc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=auc(a,c)|0;if((i|0)==(a+4|0)){a=af(60)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=19;k=j;l=513362;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+19>>0]=0;j=b[c+11>>0]|0;n=j<<24>>24<0;o=zYc(h,n?f[c>>2]|0:c,n?f[c+4>>2]|0:j&255)|0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];f[g+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;o=$Xc(32)|0;k=o;l=513382;m=k+25|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[o+25>>0]=0;l=zYc(g,o,25)|0;f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Dwc(a,e);ig(a|0,22128,1)}a=i+28|0;e=f[a>>2]|0;l=(_i[f[(f[e>>2]|0)+28>>2]&2047](e)|0)+4|0;if((f[l>>2]|0)==515430){l=f[a>>2]|0;a=Mi[f[(f[l>>2]|0)+20>>2]&1023](l,i+32|0)|0;u=d;return f[a>>2]|0}else ig(af(1)|0,22144,0);return 0}function Stc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;j=auc(c,d)|0;if((j|0)==(c+4|0)){c=af(60)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=$Xc(32)|0;f[i>>2]=k;f[i+8>>2]=-2147483616;f[i+4>>2]=19;l=k;m=513362;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+19>>0]=0;k=b[d+11>>0]|0;o=k<<24>>24<0;p=zYc(i,o?f[d>>2]|0:d,o?f[d+4>>2]|0:k&255)|0;f[h>>2]=f[p>>2];f[h+4>>2]=f[p+4>>2];f[h+8>>2]=f[p+8>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;p=$Xc(32)|0;l=p;m=513382;n=l+25|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[p+25>>0]=0;m=zYc(h,p,25)|0;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;Dwc(c,g);ig(c|0,22128,1)}c=j+28|0;g=f[c>>2]|0;m=(_i[f[(f[g>>2]|0)+28>>2]&2047](g)|0)+4|0;if((f[m>>2]|0)==213802){m=f[c>>2]|0;lYc(a,Mi[f[(f[m>>2]|0)+20>>2]&1023](m,j+32|0)|0);u=e;return}else ig(af(1)|0,22144,0)}function Ttc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+80|0;g=e+72|0;h=e+24|0;i=e+12|0;j=e;k=iKc((b[c+11>>0]|0)<0?f[c>>2]|0:c,511741)|0;if(!k){l=0;u=e;return l|0}Itc(h,k);if((f[h+32>>2]|0)!=8){oKc(k)|0;c=af(60)|0;Jtc(c,515315);ig(c|0,22128,1)}if((f[h+40>>2]|0)!=(f[a>>2]|0)){oKc(k)|0;m=af(60)|0;Jtc(m,515383);ig(m|0,22128,1)}if((f[h+44>>2]|0)!=(f[a+4>>2]|0)){oKc(k)|0;m=af(60)|0;Jtc(m,515383);ig(m|0,22128,1)}m=i+4|0;f[m>>2]=0;c=i+8|0;f[c>>2]=0;n=i+4|0;f[i>>2]=n;o=h+36|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;h=j+11|0;b[h>>0]=9;p=j;q=512094;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[j+9>>0]=0;q=Ntc(i,g,j)|0;p=f[q>>2]|0;if(!p){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[s+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[g>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[q>>2]=r;s=f[f[i>>2]>>2]|0;if(!s)t=r;else{f[i>>2]=s;t=f[q>>2]|0}UQ(f[m>>2]|0,t);f[c>>2]=(f[c>>2]|0)+1;v=r}else v=p;p=v+28|0;r=f[p>>2]|0;c=v+32|0;mi[f[f[r>>2]>>2]&2047](r,c);f[p>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,o,c);if((b[h>>0]|0)<0)cYc(f[j>>2]|0);j=Utc(a,i,d)|0;mi[f[(f[j>>2]|0)+24>>2]&2047](j,k);oKc(k)|0;Ptc(i,f[n>>2]|0);l=j;u=e;return l|0}function Utc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+32|0;e=d+16|0;g=d;h=d+4|0;i=d+26|0;j=d+25|0;k=d+24|0;l=d+23|0;m=d+22|0;n=d+21|0;o=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;p=h+11|0;b[p>>0]=9;q=h;r=512094;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[h+9>>0]=0;r=Rtc(c,h)|0;if((b[p>>0]|0)<0)cYc(f[h>>2]|0);switch(r|0){case 0:{r=$Xc(36)|0;f[r>>2]=172964;h=r+4|0;f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];h=r+20|0;p=r+24|0;f[p>>2]=0;f[r+28>>2]=0;f[h>>2]=p;q=f[c>>2]|0;s=c+4|0;if((q|0)==(s|0)){t=r;u=d;return t|0}v=p;p=q;while(1){q=p+16|0;f[g>>2]=v;f[e>>2]=f[g>>2];Qtc(h,e,q,q)|0;q=f[p+4>>2]|0;if(!q){w=p+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(p|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;z=f[x>>2]|0}while((f[z>>2]|0)!=(w|0));y=z}}else{x=q;while(1){z=f[x>>2]|0;if(!z)break;else x=z}y=x}if((y|0)==(s|0)){t=r;break}else p=y}u=d;return t|0}case 4:{y=$Xc(120)|0;b[e>>0]=b[i>>0]|0;Vtc(y,a,c,e);t=y;u=d;return t|0}case 1:{y=$Xc(96)|0;b[e>>0]=b[j>>0]|0;Wtc(y,a,c,e);t=y;u=d;return t|0}case 2:{y=$Xc(104)|0;b[e>>0]=b[k>>0]|0;Xtc(y,a,c,e);t=y;u=d;return t|0}case 3:{y=$Xc(24)|0;b[e>>0]=b[l>>0]|0;Ytc(y,a,c,e);t=y;u=d;return t|0}case 255:{y=$Xc(120)|0;b[e>>0]=b[m>>0]|0;Ztc(y,a,c,e);t=y;u=d;return t|0}case 5:{y=$Xc(104)|0;b[e>>0]=b[n>>0]|0;_tc(y,a,c,e);t=y;u=d;return t|0}case 6:{y=$Xc(76)|0;b[e>>0]=b[o>>0]|0;$tc(y,a,c,e);t=y;u=d;return t|0}default:{t=af(60)|0;Jtc(t,512104);ig(t|0,22128,1)}}return 0}function Vtc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+48|0;g=e+40|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;f[a>>2]=173964;l=a+4|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+20|0;f[a+24>>2]=0;f[a+28>>2]=0;m=a+24|0;f[c>>2]=m;n=f[d>>2]|0;o=d+4|0;if((n|0)!=(o|0)){p=m;m=n;while(1){n=m+16|0;f[h>>2]=p;f[g>>2]=f[h>>2];Qtc(c,g,n,n)|0;n=f[m+4>>2]|0;if(!n){q=m+8|0;r=f[q>>2]|0;if((f[r>>2]|0)==(m|0))s=r;else{r=q;do{q=f[r>>2]|0;r=q+8|0;t=f[r>>2]|0}while((f[t>>2]|0)!=(q|0));s=t}}else{r=n;while(1){t=f[r>>2]|0;if(!t)break;else r=t}s=r}if((s|0)==(o|0))break;else m=s}}s=a+40|0;m=a+44|0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+88>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[a+104>>2]=8192;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;g=a+68|0;f[g>>2]=f[l>>2];l=a+72|0;f[l>>2]=f[a+8>>2];f[a+76>>2]=0;c=i+4|0;f[c>>2]=0;f[c+4>>2]=0;c=i+11|0;b[c>>0]=3;b[i>>0]=b[515177]|0;b[i+1>>0]=b[515178]|0;b[i+2>>0]=b[515179]|0;b[i+3>>0]=0;h=auc(d,i)|0;do if((h|0)!=(o|0)){p=h+28|0;n=f[p>>2]|0;t=(_i[f[(f[n>>2]|0)+28>>2]&2047](n)|0)+4|0;if((f[t>>2]|0)==(f[6379]|0)){t=f[p>>2]|0;p=Mi[f[(f[t>>2]|0)+20>>2]&1023](t,h+32|0)|0;v=f[p>>2]|0;break}else ig(af(1)|0,22144,0)}else v=-1;while(0);if((b[c>>0]|0)<0)cYc(f[i>>2]|0);if((v|0)>0)f[l>>2]=v;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=$Xc(16)|0;f[j>>2]=v;f[j+8>>2]=-2147483632;f[j+4>>2]=13;l=v;i=515181;c=l+13|0;do{b[l>>0]=b[i>>0]|0;l=l+1|0;i=i+1|0}while((l|0)<(c|0));b[v+13>>0]=0;v=auc(d,j)|0;do if((v|0)!=(o|0)){i=v+28|0;l=f[i>>2]|0;c=(_i[f[(f[l>>2]|0)+28>>2]&2047](l)|0)+4|0;if((f[c>>2]|0)==(f[6379]|0)){c=f[i>>2]|0;i=Mi[f[(f[c>>2]|0)+20>>2]&1023](c,v+32|0)|0;w=f[i>>2]|0;break}else ig(af(1)|0,22144,0)}else w=10;while(0);f[a+32>>2]=w;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);f[k+8>>2]=0;j=k+11|0;b[j>>0]=7;b[k>>0]=b[515195]|0;b[k+1>>0]=b[515196]|0;b[k+2>>0]=b[515197]|0;b[k+3>>0]=b[515198]|0;b[k+4>>0]=b[515199]|0;b[k+5>>0]=b[515200]|0;b[k+6>>0]=b[515201]|0;b[k+7>>0]=0;w=auc(d,k)|0;do if((w|0)!=(o|0)){d=w+28|0;v=f[d>>2]|0;i=(_i[f[(f[v>>2]|0)+28>>2]&2047](v)|0)+4|0;if((f[i>>2]|0)==(f[6363]|0)){i=f[d>>2]|0;d=Mi[f[(f[i>>2]|0)+20>>2]&1023](i,w+32|0)|0;x=(b[d>>0]|0)!=0&1;break}else ig(af(1)|0,22144,0)}else x=1;while(0);b[a+36>>0]=x;if((b[j>>0]|0)<0)cYc(f[k>>2]|0);k=f[g>>2]|0;j=f[m>>2]|0;x=f[s>>2]|0;a=j-x>>2;w=x;x=j;if(k>>>0<=a>>>0)if(k>>>0<a>>>0?(j=w+(k<<2)|0,(x|0)!=(j|0)):0){f[m>>2]=x+(~((x+-4-j|0)>>>2)<<2);y=k}else y=k;else{CS(s,k-a|0);y=f[g>>2]|0}if(!y){u=e;return}y=f[s>>2]|0;s=0;do{f[y+(s<<2)>>2]=s;s=s+1|0}while(s>>>0<(f[g>>2]|0)>>>0);u=e;return}function Wtc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+32|0;g=e+16|0;h=e+12|0;i=e;f[a>>2]=173672;j=a+8|0;f[j>>2]=0;k=a+12|0;f[k>>2]=0;f[a+16>>2]=0;l=a+20|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+36|0;f[a+40>>2]=0;f[a+44>>2]=0;m=a+40|0;f[c>>2]=m;n=f[d>>2]|0;o=d+4|0;if((n|0)!=(o|0)){d=m;p=n;while(1){n=p+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,n,n)|0;n=f[p+4>>2]|0;if(!n){q=p+8|0;r=f[q>>2]|0;if((f[r>>2]|0)==(p|0))s=r;else{r=q;do{q=f[r>>2]|0;r=q+8|0;t=f[r>>2]|0}while((f[t>>2]|0)!=(q|0));s=t}}else{r=n;while(1){t=f[r>>2]|0;if(!t)break;else r=t}s=r}if((s|0)==(o|0))break;else p=s}}f[a+80>>2]=8192;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+84>>2]=0;f[a+88>>2]=0;s=a+48|0;f[s>>2]=f[l>>2];l=a+52|0;f[l>>2]=f[a+24>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=i+11|0;b[p>>0]=5;b[i>>0]=b[512723]|0;b[i+1>>0]=b[512724]|0;b[i+2>>0]=b[512725]|0;b[i+3>>0]=b[512726]|0;b[i+4>>0]=b[512727]|0;b[i+5>>0]=0;o=auc(c,i)|0;do if((o|0)!=(m|0)){c=o+28|0;g=f[c>>2]|0;h=(_i[f[(f[g>>2]|0)+28>>2]&2047](g)|0)+4|0;if((f[h>>2]|0)==(f[6379]|0)){h=f[c>>2]|0;c=Mi[f[(f[h>>2]|0)+20>>2]&1023](h,o+32|0)|0;v=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else v=4;while(0);o=a+4|0;f[o>>2]=v;if((b[p>>0]|0)<0){cYc(f[i>>2]|0);w=f[o>>2]|0}else w=v;v=bYc(w>>>0>1073741823?-1:w<<2)|0;f[a+64>>2]=v;v=f[s>>2]|0;w=f[k>>2]|0;o=f[j>>2]|0;i=w-o>>2;p=o;o=w;if(v>>>0<=i>>>0)if(v>>>0<i>>>0?(w=p+(v<<2)|0,(o|0)!=(w|0)):0){f[k>>2]=o+(~((o+-4-w|0)>>>2)<<2);x=v}else x=v;else{CS(j,v-i|0);x=f[s>>2]|0}if(!x){y=f[l>>2]|0;z=y<<2;A=y>>>0>1073741823;B=A?-1:z;C=bYc(B)|0;D=a+56|0;f[D>>2]=C;E=bYc(B)|0;F=a+60|0;f[F>>2]=E;u=e;return}x=f[j>>2]|0;j=0;do{f[x+(j<<2)>>2]=j;j=j+1|0}while(j>>>0<(f[s>>2]|0)>>>0);y=f[l>>2]|0;z=y<<2;A=y>>>0>1073741823;B=A?-1:z;C=bYc(B)|0;D=a+56|0;f[D>>2]=C;E=bYc(B)|0;F=a+60|0;f[F>>2]=E;u=e;return}function Xtc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+48|0;g=e+40|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;f[a>>2]=173824;l=a+28|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+44|0;f[a+48>>2]=0;f[a+52>>2]=0;m=a+48|0;f[c>>2]=m;o=f[d>>2]|0;p=d+4|0;if((o|0)!=(p|0)){q=m;m=o;while(1){o=m+16|0;f[h>>2]=q;f[g>>2]=f[h>>2];Qtc(c,g,o,o)|0;o=f[m+4>>2]|0;if(!o){r=m+8|0;s=f[r>>2]|0;if((f[s>>2]|0)==(m|0))t=s;else{s=r;do{r=f[s>>2]|0;s=r+8|0;v=f[s>>2]|0}while((f[v>>2]|0)!=(r|0));t=v}}else{s=o;while(1){v=f[s>>2]|0;if(!v)break;else s=v}t=s}if((t|0)==(p|0))break;else m=t}}f[a+64>>2]=0;f[a+68>>2]=0;f[a+88>>2]=8192;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+56>>2]=f[l>>2];f[a+60>>2]=f[a+32>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=i+11|0;b[l>>0]=9;t=i;m=512667;g=t+9|0;do{b[t>>0]=b[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(g|0));b[i+9>>0]=0;c=auc(d,i)|0;do if((c|0)!=(p|0)){h=c+28|0;q=f[h>>2]|0;o=(_i[f[(f[q>>2]|0)+28>>2]&2047](q)|0)+4|0;if((f[o>>2]|0)==(f[6379]|0)){o=f[h>>2]|0;h=Mi[f[(f[o>>2]|0)+20>>2]&1023](o,c+32|0)|0;w=f[h>>2]|0;break}else ig(af(1)|0,22144,0)}else w=32;while(0);f[a+12>>2]=w;if((b[l>>0]|0)<0)cYc(f[i>>2]|0);i=j+11|0;b[i>>0]=10;t=j;m=514827;g=t+10|0;do{b[t>>0]=b[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(g|0));b[j+10>>0]=0;l=auc(d,j)|0;do if((l|0)!=(p|0)){w=l+28|0;c=f[w>>2]|0;h=(_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0)+4|0;if((f[h>>2]|0)==(f[6379]|0)){h=f[w>>2]|0;w=Mi[f[(f[h>>2]|0)+20>>2]&1023](h,l+32|0)|0;x=f[w>>2]|0;break}else ig(af(1)|0,22144,0)}else x=11;while(0);l=a+16|0;f[l>>2]=x;if((b[i>>0]|0)<0){cYc(f[j>>2]|0);y=f[l>>2]|0}else y=x;if((y|0)<0)f[l>>2]=2147483647;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;l=$Xc(16)|0;f[k>>2]=l;f[k+8>>2]=-2147483632;f[k+4>>2]=12;t=l;m=512677;g=t+12|0;do{b[t>>0]=b[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(g|0));b[l+12>>0]=0;l=auc(d,k)|0;do if((l|0)!=(p|0)){d=l+28|0;m=f[d>>2]|0;t=(_i[f[(f[m>>2]|0)+28>>2]&2047](m)|0)+4|0;if((f[t>>2]|0)==512690){t=f[d>>2]|0;d=Mi[f[(f[t>>2]|0)+20>>2]&1023](t,l+32|0)|0;z=f[d>>2]|0;break}else ig(af(1)|0,22144,0)}else z=0;while(0);l=a+20|0;f[l>>2]=z;if((b[k+11>>0]|0)<0){cYc(f[k>>2]|0);A=f[l>>2]|0}else A=z;switch(A|0){case 1:{B=172;C=0;D=a+4|0;f[D>>2]=B;E=a+8|0;f[E>>2]=C;F=a+24|0;n[F>>2]=.4000000059604645;u=e;return}case 2:{B=173;C=0;D=a+4|0;f[D>>2]=B;E=a+8|0;f[E>>2]=C;F=a+24|0;n[F>>2]=.4000000059604645;u=e;return}case 0:{B=171;C=0;D=a+4|0;f[D>>2]=B;E=a+8|0;f[E>>2]=C;F=a+24|0;n[F>>2]=.4000000059604645;u=e;return}default:{e=af(60)|0;Jtc(e,512739);ig(e|0,22128,1)}}}function Ytc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e+4|0;h=e;i=e+9|0;j=e+8|0;f[a>>2]=173904;k=a+12|0;f[a+16>>2]=0;f[a+20>>2]=0;l=a+16|0;f[k>>2]=l;m=f[d>>2]|0;n=d+4|0;if((m|0)!=(n|0)){o=l;l=m;while(1){m=l+16|0;f[h>>2]=o;f[g>>2]=f[h>>2];Qtc(k,g,m,m)|0;m=f[l+4>>2]|0;if(!m){p=l+8|0;q=f[p>>2]|0;if((f[q>>2]|0)==(l|0))r=q;else{q=p;do{p=f[q>>2]|0;q=p+8|0;s=f[q>>2]|0}while((f[s>>2]|0)!=(p|0));r=s}}else{q=m;while(1){s=f[q>>2]|0;if(!s)break;else q=s}r=q}if((r|0)==(n|0))break;else l=r}}r=$Xc(96)|0;b[g>>0]=b[i>>0]|0;Wtc(r,c,d,g);f[a+8>>2]=r;r=$Xc(104)|0;b[g>>0]=b[j>>0]|0;Xtc(r,c,d,g);f[a+4>>2]=r;u=e;return}function Ztc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;f[a>>2]=173432;f[a+12>>2]=0;f[a+16>>2]=0;f[a+8>>2]=a+12;Yvc(a+20|0,32,0.0,1);k=a+84|0;l=a+32|0;m=l+48|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[k+8>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=$Xc(32)|0;f[g>>2]=c;f[g+8>>2]=-2147483616;f[g+4>>2]=16;l=c;k=513128;m=l+16|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[c+16>>0]=0;c=auc(d,g)|0;o=d+4|0;do if((c|0)!=(o|0)){p=c+28|0;q=f[p>>2]|0;r=(_i[f[(f[q>>2]|0)+28>>2]&2047](q)|0)+4|0;if((f[r>>2]|0)==(f[6387]|0)){r=f[p>>2]|0;p=Mi[f[(f[r>>2]|0)+20>>2]&1023](r,c+32|0)|0;s=+n[p>>2];break}else ig(af(1)|0,22144,0)}else s=.800000011920929;while(0);n[a+100>>2]=s;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;g=$Xc(16)|0;f[h>>2]=g;f[h+8>>2]=-2147483632;f[h+4>>2]=12;l=g;k=513145;m=l+12|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[g+12>>0]=0;g=auc(d,h)|0;do if((g|0)!=(o|0)){c=g+28|0;p=f[c>>2]|0;r=(_i[f[(f[p>>2]|0)+28>>2]&2047](p)|0)+4|0;if((f[r>>2]|0)==(f[6387]|0)){r=f[c>>2]|0;c=Mi[f[(f[r>>2]|0)+20>>2]&1023](r,g+32|0)|0;t=+n[c>>2];break}else ig(af(1)|0,22144,0)}else t=.009999999776482582;while(0);n[a+104>>2]=t;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;h=$Xc(16)|0;f[i>>2]=h;f[i+8>>2]=-2147483632;f[i+4>>2]=13;l=h;k=513158;m=l+13|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[h+13>>0]=0;h=auc(d,i)|0;do if((h|0)!=(o|0)){g=h+28|0;c=f[g>>2]|0;r=(_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0)+4|0;if((f[r>>2]|0)==(f[6387]|0)){r=f[g>>2]|0;g=Mi[f[(f[r>>2]|0)+20>>2]&1023](r,h+32|0)|0;v=+n[g>>2];break}else ig(af(1)|0,22144,0)}else v=0.0;while(0);n[a+108>>2]=v;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=$Xc(16)|0;f[j>>2]=i;f[j+8>>2]=-2147483632;f[j+4>>2]=15;l=i;k=513172;m=l+15|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[i+15>>0]=0;i=auc(d,j)|0;do if((i|0)!=(o|0)){d=i+28|0;k=f[d>>2]|0;l=(_i[f[(f[k>>2]|0)+28>>2]&2047](k)|0)+4|0;if((f[l>>2]|0)==(f[6387]|0)){l=f[d>>2]|0;d=Mi[f[(f[l>>2]|0)+20>>2]&1023](l,i+32|0)|0;w=+n[d>>2];break}else ig(af(1)|0,22144,0)}else w=.10000000149011612;while(0);n[a+112>>2]=w;if((b[j+11>>0]|0)>=0){x=a+4|0;f[x>>2]=0;y=a+80|0;n[y>>2]=0.0;u=e;return}cYc(f[j>>2]|0);x=a+4|0;f[x>>2]=0;y=a+80|0;n[y>>2]=0.0;u=e;return}function _tc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+80|0;g=e+64|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;f[a>>2]=173260;n=a+12|0;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];f[n+8>>2]=f[c+8>>2];f[n+12>>2]=f[c+12>>2];c=a+28|0;f[a+32>>2]=0;f[a+36>>2]=0;o=a+32|0;f[c>>2]=o;p=f[d>>2]|0;q=d+4|0;if((p|0)!=(q|0)){d=o;r=p;while(1){p=r+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,p,p)|0;p=f[r+4>>2]|0;if(!p){s=r+8|0;t=f[s>>2]|0;if((f[t>>2]|0)==(r|0))v=t;else{t=s;do{s=f[t>>2]|0;t=s+8|0;w=f[t>>2]|0}while((f[w>>2]|0)!=(s|0));v=w}}else{t=p;while(1){w=f[t>>2]|0;if(!w)break;else t=w}v=t}if((v|0)==(q|0))break;else r=v}}v=a+48|0;f[v>>2]=0;r=a+52|0;f[r>>2]=0;f[a+72>>2]=8192;f[a+60>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+40>>2]=f[n>>2];f[a+44>>2]=f[a+16>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=i+11|0;b[n>>0]=9;q=i;g=512667;h=q+9|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[i+9>>0]=0;d=auc(c,i)|0;do if((d|0)!=(o|0)){p=d+28|0;w=f[p>>2]|0;s=(_i[f[(f[w>>2]|0)+28>>2]&2047](w)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[p>>2]|0;p=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,d+32|0)|0;x=f[p>>2]|0;break}else ig(af(1)|0,22144,0)}else x=32;while(0);f[a+88>>2]=x;if((b[n>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=$Xc(16)|0;f[j>>2]=i;f[j+8>>2]=-2147483632;f[j+4>>2]=12;q=i;g=512677;h=q+12|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[i+12>>0]=0;i=auc(c,j)|0;do if((i|0)!=(o|0)){n=i+28|0;x=f[n>>2]|0;d=(_i[f[(f[x>>2]|0)+28>>2]&2047](x)|0)+4|0;if((f[d>>2]|0)==512690){d=f[n>>2]|0;n=Mi[f[(f[d>>2]|0)+20>>2]&1023](d,i+32|0)|0;y=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else y=0;while(0);i=a+96|0;f[i>>2]=y;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=k+11|0;b[j>>0]=5;b[k>>0]=b[512723]|0;b[k+1>>0]=b[512724]|0;b[k+2>>0]=b[512725]|0;b[k+3>>0]=b[512726]|0;b[k+4>>0]=b[512727]|0;b[k+5>>0]=0;y=auc(c,k)|0;do if((y|0)!=(o|0)){n=y+28|0;d=f[n>>2]|0;x=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)+4|0;if((f[x>>2]|0)==(f[6379]|0)){x=f[n>>2]|0;n=Mi[f[(f[x>>2]|0)+20>>2]&1023](x,y+32|0)|0;z=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else z=4;while(0);y=a+92|0;f[y>>2]=z;if((b[j>>0]|0)<0)cYc(f[k>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;k=l+11|0;b[k>>0]=9;q=l;g=512729;h=q+9|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[l+9>>0]=0;g=auc(c,l)|0;do if((g|0)!=(o|0)){q=g+28|0;h=f[q>>2]|0;j=(_i[f[(f[h>>2]|0)+28>>2]&2047](h)|0)+4|0;if((f[j>>2]|0)==(f[6379]|0)){j=f[q>>2]|0;q=Mi[f[(f[j>>2]|0)+20>>2]&1023](j,g+32|0)|0;A=f[q>>2]|0;break}else ig(af(1)|0,22144,0)}else A=100;while(0);f[a+100>>2]=A;if((b[k>>0]|0)<0)cYc(f[l>>2]|0);switch(f[i>>2]|0){case 0:{B=174;C=0;break}case 1:{B=175;C=0;break}case 2:{B=176;C=0;break}case 3:{B=177;C=0;break}default:{i=af(60)|0;Jtc(i,512739);ig(i|0,22128,1)}}f[a+4>>2]=B;f[a+8>>2]=C;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;C=m+11|0;b[C>>0]=5;b[m>>0]=b[512723]|0;b[m+1>>0]=b[512724]|0;b[m+2>>0]=b[512725]|0;b[m+3>>0]=b[512726]|0;b[m+4>>0]=b[512727]|0;b[m+5>>0]=0;a=auc(c,m)|0;do if((a|0)!=(o|0)){c=a+28|0;B=f[c>>2]|0;i=(_i[f[(f[B>>2]|0)+28>>2]&2047](B)|0)+4|0;if((f[i>>2]|0)==(f[6379]|0)){i=f[c>>2]|0;c=Mi[f[(f[i>>2]|0)+20>>2]&1023](i,a+32|0)|0;D=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else D=4;while(0);f[y>>2]=D;if((b[C>>0]|0)<0){cYc(f[m>>2]|0);E=f[y>>2]|0}else E=D;D=E>>>0>1073741823?-1:E<<2;y=bYc(D)|0;f[v>>2]=y;m=bYc(D)|0;f[r>>2]=m;if((E|0)<=0){u=e;return}f[y>>2]=0;f[f[r>>2]>>2]=0;if((E|0)==1){u=e;return}else F=1;do{f[(f[v>>2]|0)+(F<<2)>>2]=0;f[(f[r>>2]|0)+(F<<2)>>2]=0;F=F+1|0}while((F|0)!=(E|0));u=e;return}function $tc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+40|0;h=e+36|0;i=e+24|0;j=e;k=e+12|0;f[a>>2]=173024;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;l=a+16|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+36|0;f[a+40>>2]=0;f[a+44>>2]=0;l=a+40|0;f[c>>2]=l;m=f[d>>2]|0;n=d+4|0;if((m|0)!=(n|0)){d=l;o=m;while(1){m=o+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,m,m)|0;m=f[o+4>>2]|0;if(!m){p=o+8|0;q=f[p>>2]|0;if((f[q>>2]|0)==(o|0))r=q;else{q=p;do{p=f[q>>2]|0;q=p+8|0;s=f[q>>2]|0}while((f[s>>2]|0)!=(p|0));r=s}}else{q=m;while(1){s=f[q>>2]|0;if(!s)break;else q=s}r=q}if((r|0)==(n|0))break;else o=r}}r=a+60|0;f[r>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;o=$Xc(16)|0;f[i>>2]=o;f[i+8>>2]=-2147483632;f[i+4>>2]=12;n=o;g=512123;h=n+12|0;do{b[n>>0]=b[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(h|0));b[o+12>>0]=0;o=auc(c,i)|0;do if((o|0)!=(l|0)){d=o+28|0;m=f[d>>2]|0;s=(_i[f[(f[m>>2]|0)+28>>2]&2047](m)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[d>>2]|0;d=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,o+32|0)|0;t=f[d>>2]|0;break}else ig(af(1)|0,22144,0)}else t=12;while(0);f[a+48>>2]=t;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=j+11|0;b[i>>0]=8;t=j;f[t>>2]=1601791339;f[t+4>>2]=1702521203;b[j+8>>0]=0;t=auc(c,j)|0;do if((t|0)!=(l|0)){o=t+28|0;d=f[o>>2]|0;s=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[o>>2]|0;o=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,t+32|0)|0;v=f[o>>2]|0;break}else ig(af(1)|0,22144,0)}else v=20;while(0);t=a+52|0;f[t>>2]=v;if((b[i>>0]|0)<0)cYc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(32)|0;f[k>>2]=j;f[k+8>>2]=-2147483616;f[k+4>>2]=17;n=j;g=512136;h=n+17|0;do{b[n>>0]=b[g>>0]|0;n=n+1|0;g=g+1|0}while((n|0)<(h|0));b[j+17>>0]=0;j=auc(c,k)|0;do if((j|0)!=(l|0)){c=j+28|0;g=f[c>>2]|0;n=(_i[f[(f[g>>2]|0)+28>>2]&2047](g)|0)+4|0;if((f[n>>2]|0)==(f[6379]|0)){n=f[c>>2]|0;c=Mi[f[(f[n>>2]|0)+20>>2]&1023](n,j+32|0)|0;w=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else w=2;while(0);j=a+56|0;f[j>>2]=w;if((b[k+11>>0]|0)>=0){x=w;y=a+20|0;z=f[y>>2]|0;A=a+32|0;f[A>>2]=z;B=f[t>>2]|0;buc(a,0,B,x,r);u=e;return}cYc(f[k>>2]|0);x=f[j>>2]|0;y=a+20|0;z=f[y>>2]|0;A=a+32|0;f[A>>2]=z;B=f[t>>2]|0;buc(a,0,B,x,r);u=e;return}function auc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function buc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;f[h>>2]=b;i=e+4|0;j=f[i>>2]|0;if((j|0)==(f[e+8>>2]|0))P3(e,h);else{f[j>>2]=b;f[i>>2]=j+4}if(!((d|0)!=0&(c|0)>0)){u=g;return}j=d+-1|0;d=c;do{c=d;d=d+-1|0;buc(a,f[h>>2]|1<<d,d,j,e)}while((c|0)>1);u=g;return}function cuc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+36>>2]|0;if(b|0){d=a+40|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;d=f[b+12>>2]|0;if(d|0){e=b+16|0;g=f[e>>2]|0;if((g|0)!=(d|0))f[e>>2]=g+(~((g+-4-d|0)>>>2)<<2);cYc(d)}cYc(b)}while((c|0)!=0)}c=a+12|0;b=f[c>>2]|0;f[c>>2]=0;if(b|0)cYc(b);b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))h=b;else{g=d;while(1){d=g+-12|0;f[c>>2]=d;e=f[d>>2]|0;if(!e)i=d;else{d=g+-8|0;j=f[d>>2]|0;if((j|0)!=(e|0))f[d>>2]=j+(~((j+-4-e|0)>>>2)<<2);cYc(e);i=f[c>>2]|0}if((i|0)==(b|0))break;else g=i}h=f[a>>2]|0}cYc(h);return}function duc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=173024;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}Ptc(a+36|0,f[a+40>>2]|0);b=a+4|0;d=f[b>>2]|0;if(!d)return;c=a+8|0;a=f[c>>2]|0;if((a|0)==(d|0))e=d;else{g=a;do{a=g+-72|0;f[c>>2]=a;cuc(a);g=f[c>>2]|0}while((g|0)!=(d|0));e=f[b>>2]|0}cYc(e);return}function euc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=173024;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}Ptc(a+36|0,f[a+40>>2]|0);b=a+4|0;d=f[b>>2]|0;if(!d){cYc(a);return}c=a+8|0;e=f[c>>2]|0;if((e|0)==(d|0))g=d;else{h=e;do{e=h+-72|0;f[c>>2]=e;cuc(e);h=f[c>>2]|0}while((h|0)!=(d|0));g=f[b>>2]|0}cYc(g);cYc(a);return}function fuc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=u;u=u+80|0;c=b;d=a+4|0;e=a+48|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;j=f[d>>2]|0;k=(i-j|0)/72|0;l=j;j=i;if(g>>>0<=k>>>0){if(g>>>0<k>>>0?(i=l+(g*72|0)|0,(j|0)!=(i|0)):0){l=j;do{j=l+-72|0;f[h>>2]=j;cuc(j);l=f[h>>2]|0}while((l|0)!=(i|0))}}else Wuc(d,g-k|0);if(!(f[e>>2]|0)){u=b;return}k=a+32|0;g=a+52|0;i=a+16|0;l=a+24|0;h=a+28|0;a=0;do{j=f[d>>2]|0;m=j+(a*72|0)|0;Xuc(c,f[k>>2]|0,f[g>>2]|0);Yuc(m,c)|0;cuc(c);n=f[i>>2]|0;o=f[l>>2]|0;p=f[h>>2]|0;Zuc(j+(a*72|0)+12|0,~~(+(((f[j+(a*72|0)+24>>2]|0)+n|0)>>>0)*1.2)>>>0);if(n|0){j=0;do{_uc(m,j,p+((Y(j,o)|0)<<2)|0);j=j+1|0}while((j|0)!=(n|0))}$uc(m);a=a+1|0}while(a>>>0<(f[e>>2]|0)>>>0);u=b;return}function guc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;i=u;u=u+48|0;j=i+12|0;k=i;l=j+4|0;m=j+8|0;o=j+20|0;p=j+16|0;q=j+12|0;f[j>>2]=173220;f[j+24>>2]=g;r=j+12|0;f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;if(!(f[c>>2]|0)){s=0;f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}v=d+12|0;w=d+8|0;d=(g|0)>0;x=c+12|0;y=c+8|0;z=k+11|0;A=k+6|0;B=h+4|0;C=(g|0)<0;D=(g|0)!=0;E=e+12|0;F=e+8|0;e=~g;G=(((e|0)>-2?e:-2)+g<<2)+8|0;e=0;H=0;while(1){Fuc(r,H);f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;if(d){g1c((f[v>>2]|0)+((Y(f[w>>2]|0,e)|0)<<2)|0,-1,G|0)|0;I=g;J=(f[E>>2]|0)+((Y(f[F>>2]|0,e)|0)<<2)|0;while(1){f[J>>2]=2139095039;if((I|0)>1){I=I+-1|0;J=J+4|0}else break}}J=(f[x>>2]|0)+((Y(f[y>>2]|0,e)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,J,h);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[z>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[A>>0]=0;J=auc(h,k)|0;if((J|0)==(B|0))K=1;else{I=J+28|0;L=f[I>>2]|0;M=(_i[f[(f[L>>2]|0)+28>>2]&2047](L)|0)+4|0;if((f[M>>2]|0)!=(f[6363]|0)){N=9;break}M=f[I>>2]|0;I=Mi[f[(f[M>>2]|0)+20>>2]&1023](M,J+32|0)|0;K=b[I>>0]|0}if((b[z>>0]|0)<0)cYc(f[k>>2]|0);I=(f[v>>2]|0)+((Y(f[w>>2]|0,e)|0)<<2)|0;J=(f[E>>2]|0)+((Y(f[F>>2]|0,e)|0)<<2)|0;do if(!(K<<24>>24)){M=f[q>>2]|0;if(C){if((M|0)==(p|0))break;else{O=I;P=J;Q=M}while(1){f[O>>2]=f[Q+20>>2];f[P>>2]=f[Q+16>>2];L=f[Q+4>>2]|0;if(!L){R=Q+8|0;S=f[R>>2]|0;if((f[S>>2]|0)==(Q|0))T=S;else{S=R;do{R=f[S>>2]|0;S=R+8|0;U=f[S>>2]|0}while((f[U>>2]|0)!=(R|0));T=U}}else{S=L;while(1){U=f[S>>2]|0;if(!U)break;else S=U}T=S}if((T|0)==(p|0))break;else{O=O+4|0;P=P+4|0;Q=T}}}else{if(D&(M|0)!=(p|0)){V=0;W=J;X=I;Z=M}else break;while(1){f[X>>2]=f[Z+20>>2];f[W>>2]=f[Z+16>>2];L=f[Z+4>>2]|0;if(!L){U=Z+8|0;R=f[U>>2]|0;if((f[R>>2]|0)==(Z|0))_=R;else{R=U;do{U=f[R>>2]|0;R=U+8|0;$=f[R>>2]|0}while((f[$>>2]|0)!=(U|0));_=$}}else{R=L;while(1){S=f[R>>2]|0;if(!S)break;else R=S}_=R}V=V+1|0;if(!((V|0)<(g|0)&(_|0)!=(p|0)))break;else{W=W+4|0;X=X+4|0;Z=_}}}}else ei[f[(f[j>>2]|0)+24>>2]&511](j,I,J,g);while(0);e=e+1|0;J=f[p>>2]|0;if(e>>>0>=(f[c>>2]|0)>>>0){s=J;N=3;break}else H=J}if((N|0)==3){f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}else if((N|0)==9)ig(af(1)|0,22144,0)}function huc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+48|0;j=i+12|0;k=i;if((f[c>>2]|0)!=1){eKc(512345,57,1,f[46249]|0)|0;l=-1;u=i;return l|0}m=f[d+4>>2]|0;o=(m|0)==0;p=o?0:f[d+12>>2]|0;d=o?0:f[e+12>>2]|0;n[j+8>>2]=3402823466385288598117041.0e14;f[j+16>>2]=0;e=j+20|0;f[e>>2]=0;o=j+16|0;q=j+12|0;f[q>>2]=o;f[j>>2]=173140;n[j+24>>2]=g;b[j+4>>0]=1;r=j+12|0;Fuc(r,0);f[e>>2]=0;f[r>>2]=o;f[o>>2]=0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,f[c+12>>2]|0,h);do if((m|0)>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;c=k+11|0;b[c>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[k+6>>0]=0;a=auc(h,k)|0;do if((a|0)!=(h+4|0)){r=a+28|0;s=f[r>>2]|0;t=(_i[f[(f[s>>2]|0)+28>>2]&2047](s)|0)+4|0;if((f[t>>2]|0)==(f[6363]|0)){t=f[r>>2]|0;r=Mi[f[(f[t>>2]|0)+20>>2]&1023](t,a+32|0)|0;v=(b[r>>0]|0)!=0;break}else ig(af(1)|0,22144,0)}else v=1;while(0);if((b[c>>0]|0)<0)cYc(f[k>>2]|0);if(v){ei[f[(f[j>>2]|0)+24>>2]&511](j,p,d,m);break}a=f[q>>2]|0;if((m|0)<0){if((a|0)==(o|0))break;else{w=p;x=d;y=a}while(1){f[w>>2]=f[y+20>>2];f[x>>2]=f[y+16>>2];r=f[y+4>>2]|0;if(!r){t=y+8|0;s=f[t>>2]|0;if((f[s>>2]|0)==(y|0))z=s;else{s=t;do{t=f[s>>2]|0;s=t+8|0;A=f[s>>2]|0}while((f[A>>2]|0)!=(t|0));z=A}}else{s=r;while(1){A=f[s>>2]|0;if(!A)break;else s=A}z=s}if((z|0)==(o|0))break;else{w=w+4|0;x=x+4|0;y=z}}}else{if((m|0)!=0&(a|0)!=(o|0)){B=0;C=d;D=p;E=a}else break;while(1){f[D>>2]=f[E+20>>2];f[C>>2]=f[E+16>>2];c=f[E+4>>2]|0;if(!c){r=E+8|0;A=f[r>>2]|0;if((f[A>>2]|0)==(E|0))F=A;else{A=r;do{r=f[A>>2]|0;A=r+8|0;t=f[A>>2]|0}while((f[t>>2]|0)!=(r|0));F=t}}else{A=c;while(1){s=f[A>>2]|0;if(!s)break;else A=s}F=A}B=B+1|0;if(!((B|0)<(m|0)&(F|0)!=(o|0)))break;else{C=C+4|0;D=D+4|0;E=F}}}}while(0);F=f[e>>2]|0;f[j>>2]=173180;Fuc(j+12|0,f[o>>2]|0);l=F;u=i;return l|0}function iuc(a,b){a=a|0;b=b|0;var c=0;eKc(a+48|0,4,1,b)|0;eKc(a+52|0,4,1,b)|0;eKc(a+56|0,4,1,b)|0;c=a+16|0;eKc(c,16,1,b)|0;eKc(f[a+28>>2]|0,4,Y(f[a+20>>2]|0,f[c>>2]|0)|0,b)|0;return}function juc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+32|0;e=d+24|0;g=d;h=d+12|0;i=a+48|0;if((NLc(i,4,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+52|0;if((NLc(j,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=a+56|0;if((NLc(k,4,1,c)|0)!=1){l=af(60)|0;Jtc(l,511860);ig(l|0,22128,1)}tuc(c,a+16|0);Yi[f[(f[a>>2]|0)+8>>2]&4095](a);c=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=c;c=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=9;m=h;n=512094;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[h+9>>0]=0;p=Ntc(c,e,h)|0;q=f[p>>2]|0;if(!q){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[s+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[p>>2]=r;s=f[f[c>>2]>>2]|0;if(!s)t=r;else{f[c>>2]=s;t=f[p>>2]|0}UQ(f[a+40>>2]|0,t);t=a+44|0;f[t>>2]=(f[t>>2]|0)+1;v=r}else v=q;q=v+28|0;r=f[q>>2]|0;t=v+32|0;mi[f[f[r>>2]>>2]&2047](r,t);f[q>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,t);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;m=h;n=512123;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[h+12>>0]=0;h=Ntc(c,e,g)|0;l=f[h>>2]|0;if(!l){t=$Xc(36)|0;q=t+16|0;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];f[q+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[h>>2]=t;q=f[f[c>>2]>>2]|0;if(!q)w=t;else{f[c>>2]=q;w=f[h>>2]|0}UQ(f[a+40>>2]|0,w);w=a+44|0;f[w>>2]=(f[w>>2]|0)+1;x=t}else x=l;l=x+28|0;t=f[l>>2]|0;w=x+32|0;mi[f[f[t>>2]>>2]&2047](t,w);f[l>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,i,w);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;w=g+11|0;b[w>>0]=8;i=g;f[i>>2]=1601791339;f[i+4>>2]=1702521203;b[g+8>>0]=0;i=Ntc(c,e,g)|0;l=f[i>>2]|0;if(!l){t=$Xc(36)|0;x=t+16|0;f[x>>2]=f[g>>2];f[x+4>>2]=f[g+4>>2];f[x+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;x=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=x;f[i>>2]=t;x=f[f[c>>2]>>2]|0;if(!x)y=t;else{f[c>>2]=x;y=f[i>>2]|0}UQ(f[a+40>>2]|0,y);y=a+44|0;f[y>>2]=(f[y>>2]|0)+1;z=t}else z=l;l=z+28|0;t=f[l>>2]|0;y=z+32|0;mi[f[f[t>>2]>>2]&2047](t,y);f[l>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,j,y);if((b[w>>0]|0)<0)cYc(f[g>>2]|0);w=$Xc(32)|0;f[g>>2]=w;f[g+8>>2]=-2147483616;f[g+4>>2]=17;m=w;n=512136;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[w+17>>0]=0;w=Ntc(c,e,g)|0;n=f[w>>2]|0;if(!n){m=$Xc(36)|0;o=m+16|0;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[m+28>>2]=172888;f[m+32>>2]=0;o=f[e>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=o;f[w>>2]=m;o=f[f[c>>2]>>2]|0;if(!o)A=m;else{f[c>>2]=o;A=f[w>>2]|0}UQ(f[a+40>>2]|0,A);A=a+44|0;f[A>>2]=(f[A>>2]|0)+1;B=m}else B=n;n=B+28|0;m=f[n>>2]|0;A=B+32|0;mi[f[f[m>>2]>>2]&2047](m,A);f[n>>2]=173076;Ti[f[(f[43269]|0)+4>>2]&511](173076,k,A);if((b[g+11>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function kuc(a){a=a|0;return f[a+16>>2]|0}function luc(a){a=a|0;return f[a+32>>2]|0}function muc(a){a=a|0;return f[a+16>>2]<<2|0}function nuc(a){a=a|0;return 6}function ouc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+36>>2]|0;i=b+40|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function puc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;quc(a,c,b);return}function quc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;d=f[a+4>>2]|0;e=f[a+8>>2]|0;if((d|0)==(e|0))return;g=a+64|0;h=a+28|0;i=a+24|0;j=a+20|0;k=3-b|0;l=a+60|0;a=d;do{d=ruc(a,b)|0;m=f[l>>2]|0;o=f[g>>2]|0;if((m|0)!=(o|0)){p=m;do{m=suc(a,f[p>>2]^d)|0;if(m|0?(q=f[m>>2]|0,r=f[m+4>>2]|0,q>>>0<r>>>0):0){m=q;do{q=f[m>>2]|0;s=(f[h>>2]|0)+((Y(f[i>>2]|0,q)|0)<<2)|0;t=b+(f[j>>2]<<2)|0;u=t+-12|0;v=((u>>>0<b>>>0?b:u)+12+k|0)>>>4<<2;w=s+(v<<2)|0;if(u>>>0>b>>>0){x=b;y=s;z=0.0;while(1){A=+L(+(+n[x>>2]-+n[y>>2]));B=+L(+(+n[x+4>>2]-+n[y+4>>2]));C=+L(+(+n[x+8>>2]-+n[y+8>>2]));D=z+(A+B+C+ +L(+(+n[x+12>>2]-+n[y+12>>2])));x=x+16|0;if(x>>>0>=u>>>0){E=D;break}else{y=y+16|0;z=D}}}else E=0.0;y=b+(v<<2)|0;if(y>>>0<t>>>0){u=w;z=E;x=y;while(1){D=z+ +L(+(+n[x>>2]-+n[u>>2]));x=x+4|0;if(x>>>0>=t>>>0){F=D;break}else{u=u+4|0;z=D}}}else F=E;Hg[f[(f[c>>2]|0)+12>>2]&15](c,F,q);m=m+4|0}while(m>>>0<r>>>0)}p=p+4|0}while((p|0)!=(o|0))}a=a+72|0}while((a|0)!=(e|0));return}function ruc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=u;u=u+16|0;a=b;c=BM(895384,512187,36)|0;ZNc(a,c+(f[(f[c>>2]|0)+-12>>2]|0)|0);d=DPc(a,896088)|0;e=Mi[f[(f[d>>2]|0)+28>>2]&1023](d,10)|0;EPc(a);sOc(c,e)|0;dOc(c)|0;u=b;return 1}function suc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;switch(f[a+32>>2]|0){case 0:{c=(f[a>>2]|0)+(b*12|0)|0;return c|0}case 1:{if(!(f[(f[a+36>>2]|0)+(b>>>5<<2)>>2]&1<<(b&31))){c=0;return c|0}d=f[a+16>>2]|0;a:do if(d){e=d+-1|0;g=(e&d|0)==0;if(!g)if(d>>>0>b>>>0)h=b;else h=(b>>>0)%(d>>>0)|0;else h=e&b;i=f[(f[a+12>>2]|0)+(h<<2)>>2]|0;if((i|0)!=0?(j=f[i>>2]|0,(j|0)!=0):0){if(g){g=j;while(1){i=f[g+4>>2]|0;k=(i|0)==(b|0);if(!(k|(i&e|0)==(h|0))){l=0;break a}if(k?(f[g+8>>2]|0)==(b|0):0){l=g;break a}g=f[g>>2]|0;if(!g){l=0;break a}}}else m=j;while(1){g=f[m+4>>2]|0;if((g|0)==(b|0)){if((f[m+8>>2]|0)==(b|0)){l=m;break a}}else{if(g>>>0<d>>>0)n=g;else n=(g>>>0)%(d>>>0)|0;if((n|0)!=(h|0)){l=0;break a}}m=f[m>>2]|0;if(!m){l=0;break}}}else l=0}else l=0;while(0);c=l+12|0;return c|0}case 2:{l=f[a+16>>2]|0;if(!l){c=0;return c|0}m=l+-1|0;h=(m&l|0)==0;if(!h)if(l>>>0>b>>>0)o=b;else o=(b>>>0)%(l>>>0)|0;else o=m&b;n=f[(f[a+12>>2]|0)+(o<<2)>>2]|0;if(!n){c=0;return c|0}a=f[n>>2]|0;if(!a){c=0;return c|0}b:do if(h){n=a;while(1){d=f[n+4>>2]|0;j=(d|0)==(b|0);if(!(j|(d&m|0)==(o|0))){c=0;p=42;break}if(j?(f[n+8>>2]|0)==(b|0):0){q=n;break b}n=f[n>>2]|0;if(!n){c=0;p=42;break}}if((p|0)==42)return c|0}else{n=a;while(1){j=f[n+4>>2]|0;if((j|0)==(b|0)){if((f[n+8>>2]|0)==(b|0)){q=n;break b}}else{if(j>>>0<l>>>0)r=j;else r=(j>>>0)%(l>>>0)|0;if((r|0)!=(o|0)){c=0;p=42;break}}n=f[n>>2]|0;if(!n){c=0;p=42;break}}if((p|0)==42)return c|0}while(0);c=q+12|0;return c|0}default:{c=0;return c|0}}return 0}function tuc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((NLc(b,16,1,a)|0)!=1){c=af(60)|0;Jtc(c,511860);ig(c|0,22128,1)}c=b+4|0;d=Y(f[c>>2]|0,f[b>>2]|0)|0;e=bYc(d>>>0>1073741823?-1:d<<2)|0;f[b+12>>2]=e;g=NLc(e,4,d,a)|0;if((g|0)==(Y(f[c>>2]|0,f[b>>2]|0)|0))return;else{b=af(60)|0;Jtc(b,511860);ig(b|0,22128,1)}}function uuc(a,b){a=a|0;b=b|0;return}function vuc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function wuc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function xuc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function yuc(a,b){a=a|0;b=b|0;return b|0}function zuc(a,b){a=a|0;b=b|0;return b|0}function Auc(a){a=a|0;return 4}function Buc(a){a=a|0;return 25520}function Cuc(a,b,c){a=a|0;b=b|0;c=c|0;oOc(b,f[c>>2]|0)|0;return}function Duc(a){a=a|0;return}function Euc(a){a=a|0;cYc(a);return}function Fuc(a,b){a=a|0;b=b|0;if(!b)return;else{Fuc(a,f[b>>2]|0);Fuc(a,f[b+4>>2]|0);cYc(b);return}}function Guc(a){a=a|0;f[a>>2]=173180;Fuc(a+12|0,f[a+16>>2]|0);return}function Huc(a){a=a|0;f[a>>2]=173180;Fuc(a+12|0,f[a+16>>2]|0);cYc(a);return}function Iuc(a){a=a|0;return (b[a+4>>0]|0)!=0|0}function Juc(a){a=a|0;return +(+n[a+8>>2])}function Kuc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+12>>2]|0;g=a+16|0;if((d|0)<0){if((e|0)==(g|0))return;else{h=b;i=c;j=e}while(1){f[h>>2]=f[j+20>>2];f[i>>2]=f[j+16>>2];a=f[j+4>>2]|0;if(!a){k=j+8|0;l=f[k>>2]|0;if((f[l>>2]|0)==(j|0))m=l;else{l=k;do{k=f[l>>2]|0;l=k+8|0;n=f[l>>2]|0}while((f[n>>2]|0)!=(k|0));m=n}}else{l=a;while(1){n=f[l>>2]|0;if(!n)break;else l=n}m=l}if((m|0)==(g|0))break;else{h=h+4|0;i=i+4|0;j=m}}return}else{if((e|0)!=(g|0)&(d|0)!=0){o=0;p=c;q=b;r=e}else return;while(1){f[q>>2]=f[r+20>>2];f[p>>2]=f[r+16>>2];e=f[r+4>>2]|0;if(!e){b=r+8|0;c=f[b>>2]|0;if((f[c>>2]|0)==(r|0))s=c;else{c=b;do{b=f[c>>2]|0;c=b+8|0;m=f[c>>2]|0}while((f[m>>2]|0)!=(b|0));s=m}}else{c=e;while(1){l=f[c>>2]|0;if(!l)break;else c=l}s=c}o=o+1|0;if(!((s|0)!=(g|0)&(o|0)<(d|0)))break;else{p=p+4|0;q=q+4|0;r=s}}return}}function Luc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ei[f[(f[a>>2]|0)+24>>2]&511](a,b,c,d);return}function Muc(a){a=a|0;f[a>>2]=173180;Fuc(a+12|0,f[a+16>>2]|0);cYc(a);return}function Nuc(a){a=a|0;return 1}function Ouc(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!(+n[a+24>>2]>=b)){u=d;return}n[e>>2]=b;f[e+4>>2]=c;Ruc(d+8|0,a+12|0,e,e);u=d;return}function Puc(a){a=a|0;return +(+n[a+24>>2])}function Quc(a){a=a|0;var b=0,c=0;b=a+12|0;c=a+16|0;Fuc(b,f[c>>2]|0);f[a+20>>2]=0;f[b>>2]=c;f[c>>2]=0;return}function Ruc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=c+4|0;h=f[g>>2]|0;do if(h){i=+n[d>>2];j=f[d+4>>2]|0;k=d;l=f[k+4>>2]|0;m=+n[k>>2];k=c+4|0;o=h;while(1){p=o+16|0;q=+n[p>>2];if(!(i<q)?!(i==q?j>>>0<(f[p+4>>2]|0)>>>0:0):0){if(!(q<m)){if(!(q==m)){r=13;break}if((f[o+20>>2]|0)>>>0>=l>>>0){r=13;break}}s=o+4|0;p=f[s>>2]|0;if(!p){r=12;break}else{t=s;u=p}}else{p=f[o>>2]|0;if(!p){r=7;break}else{t=o;u=p}}k=t;o=u}if((r|0)==7){v=o;w=o;break}else if((r|0)==12){v=o;w=s;break}else if((r|0)==13){v=o;w=k;break}}else{v=g;w=g}while(0);g=f[w>>2]|0;if(g|0){x=g;y=0;z=x;f[a>>2]=z;A=a+4|0;b[A>>0]=y;return}g=$Xc(24)|0;r=e;e=f[r+4>>2]|0;s=g+16|0;f[s>>2]=f[r>>2];f[s+4>>2]=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=v;f[w>>2]=g;v=f[f[c>>2]>>2]|0;if(!v)B=g;else{f[c>>2]=v;B=f[w>>2]|0}UQ(f[c+4>>2]|0,B);B=c+8|0;f[B>>2]=(f[B>>2]|0)+1;x=g;y=1;z=x;f[a>>2]=z;A=a+4|0;b[A>>0]=y;return}function Suc(a){a=a|0;f[a>>2]=173180;Fuc(a+12|0,f[a+16>>2]|0);cYc(a);return}function Tuc(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;e=u;u=u+16|0;g=e;h=a+8|0;if(+n[h>>2]<=c){u=e;return}n[g>>2]=c;f[g+4>>2]=d;d=a+12|0;Ruc(e+8|0,d,g,g);g=a+4|0;i=f[a+20>>2]|0;j=f[a+24>>2]|0;if(!(b[g>>0]|0)){if((i|0)!=(j|0)){u=e;return}b[g>>0]=1;g=a+16|0;k=f[g>>2]|0;if(!k){l=g;while(1){g=f[l+8>>2]|0;if((f[g>>2]|0)==(l|0))l=g;else{m=g;break}}}else{l=k;while(1){k=f[l+4>>2]|0;if(!k){m=l;break}else l=k}}f[h>>2]=f[m+16>>2];u=e;return}if(i>>>0<=j>>>0){u=e;return}j=a+16|0;a=f[j>>2]|0;if(!a){i=j;while(1){m=f[i+8>>2]|0;if((f[m>>2]|0)==(i|0))i=m;else{o=m;break}}}else{i=a;while(1){a=f[i+4>>2]|0;if(!a){o=i;break}else i=a}}Vuc(d,o+16|0)|0;o=f[j>>2]|0;if(!o){d=j;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{p=j;break}}}else{d=o;while(1){o=f[d+4>>2]|0;if(!o){p=d;break}else d=o}}f[h>>2]=f[p+16>>2];u=e;return}function Uuc(a){a=a|0;var c=0,d=0;c=a+12|0;d=a+16|0;Fuc(c,f[d>>2]|0);f[a+20>>2]=0;f[c>>2]=d;f[d>>2]=0;n[a+8>>2]=3402823466385288598117041.0e14;b[a+4>>0]=0;return}function Vuc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0.0,j=0,k=0,l=0.0,m=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;if(!d){e=0;return e|0}g=b;h=f[g+4>>2]|0;i=+n[g>>2];g=c;j=d;a:while(1){k=j;while(1){l=+n[k+16>>2];if(!(l<i)){if(!(l==i))break;if((f[k+20>>2]|0)>>>0>=h>>>0)break}m=f[k+4>>2]|0;if(!m){o=g;break a}else k=m}j=f[k>>2]|0;if(!j){o=k;break}else g=k}if((o|0)==(c|0)){e=0;return e|0}c=o+16|0;l=+n[c>>2];if(i<l){e=0;return e|0}if(i==l?(f[b+4>>2]|0)>>>0<(f[c+4>>2]|0)>>>0:0){e=0;return e|0}c=f[o+4>>2]|0;if(!c){b=o+8|0;g=f[b>>2]|0;if((f[g>>2]|0)==(o|0))p=g;else{g=b;do{b=f[g>>2]|0;g=b+8|0;j=f[g>>2]|0}while((f[j>>2]|0)!=(b|0));p=j}}else{g=c;while(1){c=f[g>>2]|0;if(!c)break;else g=c}p=g}if((f[a>>2]|0)==(o|0))f[a>>2]=p;p=a+8|0;f[p>>2]=(f[p>>2]|0)+-1;XIa(d,o);cYc(o);e=1;return e|0}function Wuc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/72|0)>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;n[j+28>>2]=1.0;k=j+32|0;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));j=(f[g>>2]|0)+72|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);u=c;return}i=f[a>>2]|0;j=(h-i|0)/72|0;h=j+b|0;if(h>>>0>59652323)kWc(a);g=(e-i|0)/72|0;i=g<<1;e=g>>>0<29826161?(i>>>0<h>>>0?h:i):59652323;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>59652323){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{m=$Xc(e*72|0)|0;break}else m=0;while(0);f[d>>2]=m;i=m+(j*72|0)|0;j=d+8|0;f[j>>2]=i;g=d+4|0;f[g>>2]=i;f[d+12>>2]=m+(e*72|0);e=b;b=i;while(1){f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;n[b+28>>2]=1.0;k=b+32|0;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));e=e+-1|0;if(!e)break;else b=b+72|0}f[j>>2]=m+(h*72|0);evc(a,d);a=f[g>>2]|0;g=f[j>>2]|0;if((g|0)!=(a|0)){h=g;do{g=h+-72|0;f[j>>2]=g;cuc(g);h=f[j>>2]|0}while((h|0)!=(a|0))}a=f[d>>2]|0;if(a|0)cYc(a);u=c;return}function Xuc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;n[a+28>>2]=1.0;e=a+36|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+56>>2]=b;b=BM(895384,512187,36)|0;ZNc(d,b+(f[(f[b>>2]|0)+-12>>2]|0)|0);a=DPc(d,896088)|0;e=Mi[f[(f[a>>2]|0)+28>>2]&1023](a,10)|0;EPc(d);sOc(b,e)|0;dOc(b)|0;u=c;return}function Yuc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d+1|0;g=d;h=f[a>>2]|0;if(!h){i=a+4|0;j=a+8|0}else{k=a+4|0;l=f[k>>2]|0;if((l|0)==(h|0))m=h;else{n=l;while(1){l=n+-12|0;f[k>>2]=l;o=f[l>>2]|0;if(!o)p=l;else{l=n+-8|0;q=f[l>>2]|0;if((q|0)!=(o|0))f[l>>2]=q+(~((q+-4-o|0)>>>2)<<2);cYc(o);p=f[k>>2]|0}if((p|0)==(h|0))break;else n=p}m=f[a>>2]|0}cYc(m);m=a+8|0;f[m>>2]=0;f[k>>2]=0;f[a>>2]=0;i=k;j=m}f[a>>2]=f[c>>2];m=c+4|0;f[i>>2]=f[m>>2];i=c+8|0;f[j>>2]=f[i>>2];f[i>>2]=0;f[m>>2]=0;f[c>>2]=0;b[e>>0]=b[g>>0]|0;dvc(a+12|0,c+12|0,e);f[a+32>>2]=f[c+32>>2];e=a+36|0;g=c+36|0;m=f[e>>2]|0;i=a+40|0;if(!m)r=a+44|0;else{j=f[i>>2]|0;if((j|0)!=(m|0))f[i>>2]=j+(~((j+-4-m|0)>>>2)<<2);cYc(m);m=a+44|0;f[m>>2]=0;f[i>>2]=0;f[e>>2]=0;r=m}f[e>>2]=f[g>>2];e=c+40|0;f[i>>2]=f[e>>2];i=c+44|0;f[r>>2]=f[i>>2];f[i>>2]=0;f[e>>2]=0;f[g>>2]=0;f[a+48>>2]=f[c+48>>2];g=c+52|0;e=f[g+4>>2]|0;i=a+52|0;f[i>>2]=f[g>>2];f[i+4>>2]=e;e=a+60|0;i=c+60|0;g=f[e>>2]|0;r=a+64|0;if(!g){s=a+68|0;t=f[i>>2]|0;f[e>>2]=t;v=c+64|0;w=f[v>>2]|0;f[r>>2]=w;x=c+68|0;y=f[x>>2]|0;f[s>>2]=y;f[x>>2]=0;f[v>>2]=0;f[i>>2]=0;u=d;return a|0}m=f[r>>2]|0;if((m|0)!=(g|0))f[r>>2]=m+(~((m+-4-g|0)>>>2)<<2);cYc(g);g=a+68|0;f[g>>2]=0;f[r>>2]=0;f[e>>2]=0;s=g;t=f[i>>2]|0;f[e>>2]=t;v=c+64|0;w=f[v>>2]|0;f[r>>2]=w;x=c+68|0;y=f[x>>2]|0;f[s>>2]=y;f[x>>2]=0;f[v>>2]=0;f[i>>2]=0;u=d;return a|0}function Zuc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=EMc(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){cvc(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=EMc(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;cvc(a,d);return}function _uc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=d+4|0;f[e>>2]=b;h=ruc(a,c)|0;f[g>>2]=h;switch(f[a+32>>2]|0){case 0:{c=f[a>>2]|0;i=c+(h*12|0)+4|0;j=f[i>>2]|0;if((j|0)==(f[c+(h*12|0)+8>>2]|0)){P3(c+(h*12|0)|0,e);u=d;return}else{f[j>>2]=b;f[i>>2]=j+4;u=d;return}break}case 1:{j=(f[a+36>>2]|0)+(h>>>5<<2)|0;f[j>>2]=f[j>>2]|1<<(h&31);h=bvc(a+12|0,g)|0;j=h+4|0;i=f[j>>2]|0;if((i|0)==(f[h+8>>2]|0)){P3(h,e);u=d;return}else{f[i>>2]=f[e>>2];f[j>>2]=i+4;u=d;return}break}case 2:{i=bvc(a+12|0,g)|0;g=i+4|0;a=f[g>>2]|0;if((a|0)==(f[i+8>>2]|0)){P3(i,e);u=d;return}else{f[a>>2]=f[e>>2];f[g>>2]=a+4;u=d;return}break}default:{u=d;return}}}function $uc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=a+32|0;if(!(f[b>>2]|0))return;c=a+24|0;d=f[c>>2]|0;e=f[a+52>>2]|0;g=1<<e;if(d>>>0<=g>>>1>>>0){h=((f[a+4>>2]|0)-(f[a>>2]|0)|0)/12|0;if(!(e>>>0<33?1:((((d>>>0<h>>>0?h:d)*96|0)>>>0)/10|0)>>>0>=g>>>0)){f[b>>2]=2;d=f[a+36>>2]|0;h=(f[a+40>>2]|0)-d|0;e=h>>>2;if((h|0)<=0)return;g1c(d|0,0,(((e|0)==0?e^1073741823:1073741822)+e<<2)+8|0)|0;return}f[b>>2]=1;e=a+36|0;f[a+48>>2]=g;d=(g>>>5)+1|0;h=a+40|0;i=f[h>>2]|0;j=f[e>>2]|0;k=i-j>>2;l=j;j=i;if(d>>>0<=k>>>0)if(d>>>0<k>>>0?(m=l+(d<<2)|0,(j|0)!=(m|0)):0){n=j+(~((j+-4-m|0)>>>2)<<2)|0;f[h>>2]=n;o=l;p=n}else{o=l;p=i}else{oaa(e,d-k|0);o=f[e>>2]|0;p=f[h>>2]|0}h=p-o|0;p=h>>>2;if((h|0)>0)g1c(o|0,0,(((p|0)==0?p^1073741823:1073741822)+p<<2)+8|0)|0;p=f[a+20>>2]|0;if(!p)return;o=f[e>>2]|0;e=p;do{p=f[e+8>>2]|0;h=o+(p>>>5<<2)|0;f[h>>2]=f[h>>2]|1<<(p&31);e=f[e>>2]|0}while((e|0)!=0);return}f[b>>2]=0;b=a+4|0;e=f[b>>2]|0;o=f[a>>2]|0;p=(e-o|0)/12|0;h=o;o=e;if(g>>>0<=p>>>0){if(g>>>0<p>>>0?(e=h+(g*12|0)|0,(o|0)!=(e|0)):0){h=o;while(1){o=h+-12|0;f[b>>2]=o;k=f[o>>2]|0;if(!k)q=o;else{o=h+-8|0;d=f[o>>2]|0;if((d|0)!=(k|0))f[o>>2]=d+(~((d+-4-k|0)>>>2)<<2);cYc(k);q=f[b>>2]|0}if((q|0)==(e|0))break;else h=q}}}else avc(a,g-p|0);p=a+20|0;g=f[p>>2]|0;if(g|0){q=g;do{g=q;h=g+12|0;e=(f[a>>2]|0)+((f[g+8>>2]|0)*12|0)|0;if((e|0)!=(h|0))paa(e,f[h>>2]|0,f[g+16>>2]|0);q=f[q>>2]|0}while((q|0)!=0)}if(!(f[c>>2]|0))return;q=f[p>>2]|0;if(q|0){g=q;do{q=g;g=f[g>>2]|0;h=f[q+12>>2]|0;if(h|0){e=q+16|0;b=f[e>>2]|0;if((b|0)!=(h|0))f[e>>2]=b+(~((b+-4-h|0)>>>2)<<2);cYc(h)}cYc(q)}while((g|0)!=0)}f[p>>2]=0;p=f[a+16>>2]|0;if(p|0){g=a+12|0;a=0;do{f[(f[g>>2]|0)+(a<<2)>>2]=0;a=a+1|0}while((a|0)!=(p|0))}f[c>>2]=0;return}function avc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){g1c(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)kWc(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=d;g=n+(m*12|0)|0;g1c(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=j+-12|0;b=i;i=i+-12|0;f[d>>2]=0;n=j+-8|0;f[n>>2]=0;f[j+-4>>2]=0;f[d>>2]=f[i>>2];d=b+-8|0;f[n>>2]=f[d>>2];n=b+-4|0;f[j+-4>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[i>>2]=0;j=h+-12|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=c;c=c+-12|0;m=f[c>>2]|0;if(m|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(m|0))f[e>>2]=q+(~((q+-4-m|0)>>>2)<<2);cYc(m)}}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function bvc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0;c=f[b>>2]|0;b=a+4|0;d=f[b>>2]|0;e=(d|0)==0;a:do if(!e){g=d+-1|0;h=(g&d|0)==0;if(!h)if(c>>>0<d>>>0)i=c;else i=(c>>>0)%(d>>>0)|0;else i=g&c;j=f[(f[a>>2]|0)+(i<<2)>>2]|0;if(!j)k=i;else{if(h){h=j;while(1){l=f[h>>2]|0;if(!l){k=i;break a}m=f[l+4>>2]|0;if(!((m|0)==(c|0)|(m&g|0)==(i|0))){k=i;break a}if((f[l+8>>2]|0)==(c|0)){o=l;break}else h=l}p=o+12|0;return p|0}else q=j;while(1){h=f[q>>2]|0;if(!h){k=i;break a}g=f[h+4>>2]|0;if((g|0)!=(c|0)){if(g>>>0<d>>>0)r=g;else r=(g>>>0)%(d>>>0)|0;if((r|0)!=(i|0)){k=i;break a}}if((f[h+8>>2]|0)==(c|0)){o=h;break}else q=h}p=o+12|0;return p|0}}else k=0;while(0);q=$Xc(24)|0;f[q+8>>2]=c;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+4>>2]=c;f[q>>2]=0;i=a+12|0;s=+(((f[i>>2]|0)+1|0)>>>0);t=+n[a+16>>2];do if(e|s>+(d>>>0)*t){r=(d>>>0<3|(d+-1&d|0)!=0)&1|d<<1;j=~~+X(+(s/t))>>>0;Zuc(a,r>>>0<j>>>0?j:r);r=f[b>>2]|0;j=r+-1|0;if(!(j&r)){u=r;v=j&c;break}if(c>>>0<r>>>0){u=r;v=c}else{u=r;v=(c>>>0)%(r>>>0)|0}}else{u=d;v=k}while(0);k=(f[a>>2]|0)+(v<<2)|0;v=f[k>>2]|0;if(!v){d=a+8|0;f[q>>2]=f[d>>2];f[d>>2]=q;f[k>>2]=d;d=f[q>>2]|0;if(d|0){k=f[d+4>>2]|0;d=u+-1|0;if(d&u)if(k>>>0<u>>>0)w=k;else w=(k>>>0)%(u>>>0)|0;else w=k&d;x=(f[a>>2]|0)+(w<<2)|0;y=30}}else{f[q>>2]=f[v>>2];x=v;y=30}if((y|0)==30)f[x>>2]=q;f[i>>2]=(f[i>>2]|0)+1;o=q;p=o+12|0;return p|0}function cvc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+4|0;if(!b){d=f[a>>2]|0;f[a>>2]=0;if(d|0)cYc(d);f[c>>2]=0;return}if(b>>>0>1073741823){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}d=$Xc(b<<2)|0;e=f[a>>2]|0;f[a>>2]=d;if(e|0)cYc(e);f[c>>2]=b;c=0;do{f[(f[a>>2]|0)+(c<<2)>>2]=0;c=c+1|0}while((c|0)!=(b|0));c=a+8|0;e=f[c>>2]|0;if(!e)return;d=f[e+4>>2]|0;g=b+-1|0;h=(g&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&g;f[(f[a>>2]|0)+(i<<2)>>2]=c;c=f[e>>2]|0;if(!c)return;else{j=i;k=e;l=c;m=e}a:while(1){b:do if(h){e=k;c=l;i=m;while(1){d=c;while(1){n=f[d+4>>2]&g;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if((f[o>>2]|0)==(f[u+8>>2]|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[e>>2]|0;if(!o){v=37;break a}else d=o}c=f[d>>2]|0;if(!c){v=37;break a}else{e=d;i=d}}}else{i=k;e=l;c=m;while(1){o=e;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=c;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if((f[w>>2]|0)==(f[z+8>>2]|0))y=z;else break}f[c>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=37;break a}else o=w}e=f[o>>2]|0;if(!e){v=37;break a}else{i=o;c=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=37;break}else{j=s;k=p;m=p}}if((v|0)==37)return}function dvc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+12|0;if(f[c>>2]|0){d=a+8|0;e=f[d>>2]|0;if(e|0){g=e;do{e=g;g=f[g>>2]|0;h=f[e+12>>2]|0;if(h|0){i=e+16|0;j=f[i>>2]|0;if((j|0)!=(h|0))f[i>>2]=j+(~((j+-4-h|0)>>>2)<<2);cYc(h)}cYc(e)}while((g|0)!=0)}f[d>>2]=0;d=f[a+4>>2]|0;if(d|0){g=0;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(d|0))}f[c>>2]=0}d=f[b>>2]|0;f[b>>2]=0;g=f[a>>2]|0;f[a>>2]=d;if(g|0)cYc(g);g=b+4|0;d=a+4|0;f[d>>2]=f[g>>2];f[g>>2]=0;g=b+12|0;e=f[g>>2]|0;f[c>>2]=e;f[a+16>>2]=f[b+16>>2];c=b+8|0;b=f[c>>2]|0;h=a+8|0;f[h>>2]=b;if(!e)return;e=f[b+4>>2]|0;b=f[d>>2]|0;d=b+-1|0;if(d&b)if(e>>>0<b>>>0)k=e;else k=(e>>>0)%(b>>>0)|0;else k=d&e;f[(f[a>>2]|0)+(k<<2)>>2]=h;f[c>>2]=0;f[g>>2]=0;return}function evc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;if((e|0)==(c|0)){h=g;i=a;j=f[g>>2]|0;k=c;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}t=e;e=f[g>>2]|0;do{u=e+-72|0;v=t;t=t+-72|0;f[u>>2]=0;w=e+-68|0;f[w>>2]=0;f[e+-64>>2]=0;f[u>>2]=f[t>>2];u=v+-68|0;f[w>>2]=f[u>>2];w=v+-64|0;f[e+-64>>2]=f[w>>2];f[w>>2]=0;f[u>>2]=0;f[t>>2]=0;u=v+-60|0;w=f[u>>2]|0;f[u>>2]=0;u=v+-56|0;x=f[u>>2]|0;f[u>>2]=0;f[e+-60>>2]=w;f[e+-56>>2]=x;u=e+-52|0;y=v+-52|0;z=f[y>>2]|0;f[u>>2]=z;A=v+-48|0;B=f[A>>2]|0;f[e+-48>>2]=B;f[e+-44>>2]=f[v+-44>>2];C=w;if(B|0){B=f[z+4>>2]|0;z=x+-1|0;if(z&x)if(B>>>0<x>>>0)D=B;else D=(B>>>0)%(x>>>0)|0;else D=B&z;f[C+(D<<2)>>2]=u;f[y>>2]=0;f[A>>2]=0}f[e+-40>>2]=f[v+-40>>2];A=e+-36|0;y=v+-36|0;f[A>>2]=0;u=e+-32|0;f[u>>2]=0;f[e+-28>>2]=0;f[A>>2]=f[y>>2];A=v+-32|0;f[u>>2]=f[A>>2];u=v+-28|0;f[e+-28>>2]=f[u>>2];f[u>>2]=0;f[A>>2]=0;f[y>>2]=0;f[e+-24>>2]=f[v+-24>>2];y=v+-20|0;A=f[y+4>>2]|0;u=e+-20|0;f[u>>2]=f[y>>2];f[u+4>>2]=A;A=e+-12|0;u=v+-12|0;f[A>>2]=0;y=e+-8|0;f[y>>2]=0;f[e+-4>>2]=0;f[A>>2]=f[u>>2];A=v+-8|0;f[y>>2]=f[A>>2];y=v+-4|0;f[e+-4>>2]=f[y>>2];f[y>>2]=0;f[A>>2]=0;f[u>>2]=0;e=(f[g>>2]|0)+-72|0;f[g>>2]=e}while((t|0)!=(c|0));h=g;i=a;j=e;k=f[a>>2]|0;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}function fvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0;h=u;u=u+32|0;i=h;jvc(i,d);a:do if((b|0)>0){d=i+16|0;j=f[i>>2]|0;k=a+24|0;l=a+20|0;m=a+16|0;o=f[i+12>>2]|0;p=f[d>>2]|0;q=0;b:while(1){r=e+(q<<2)|0;s=(q|0)>0;if((p|0)==(o|0)){t=q;v=j;w=22;break a}else x=p;while(1){y=x;x=x+1|0;f[d>>2]=x;z=f[j+(y<<2)>>2]|0;if((z|0)<0)break b;y=f[c+(z<<2)>>2]|0;f[r>>2]=y;if(!s)break;z=f[k>>2]|0;A=f[l>>2]|0;B=z+((Y(A,y)|0)<<2)|0;y=B+(f[m>>2]<<2)|0;C=y+-12|0;D=((C>>>0<B>>>0?B:C)+12+(3-B)|0)>>>4<<2;E=B+(D<<2)|0;F=E>>>0<y>>>0;if(B>>>0>=C>>>0){if(F){G=0;H=0;while(1){I=z+((Y(f[e+(G<<2)>>2]|0,A)|0)<<2)+(D<<2)|0;J=0.0;K=E;while(1){M=K;K=K+4|0;J=J+ +L(+(+n[M>>2]-+n[I>>2]));if(K>>>0>=y>>>0)break;else I=I+4|0}I=J<1.0e-16?1:H;G=G+1|0;if((G|0)==(q|0)){N=I;w=19;break}else H=I}}}else{H=0;G=0;while(1){I=z+((Y(f[e+(H<<2)>>2]|0,A)|0)<<2)|0;K=B;M=I;O=0.0;while(1){P=+L(+(+n[K>>2]-+n[M>>2]));Q=+L(+(+n[K+4>>2]-+n[M+4>>2]));R=+L(+(+n[K+8>>2]-+n[M+8>>2]));O=O+(P+Q+R+ +L(+(+n[K+12>>2]-+n[M+12>>2])));K=K+16|0;if(K>>>0>=C>>>0)break;else M=M+16|0}if(F){M=I+(D<<2)|0;J=O;K=E;while(1){R=J+ +L(+(+n[K>>2]-+n[M>>2]));K=K+4|0;if(K>>>0>=y>>>0){S=R;break}else{M=M+4|0;J=R}}}else S=O;M=S<1.0e-16?1:G;H=H+1|0;if((H|0)==(q|0)){N=M;w=19;break}else G=M}}if((w|0)==19?(w=0,(N&1)==0):0)break;if((x|0)==(o|0)){t=q;v=j;w=22;break a}}s=q+1|0;if((s|0)<(b|0)){p=x;q=s}else{t=s;v=j;w=22;break a}}f[g>>2]=q;T=j}else{t=0;v=f[i>>2]|0;w=22}while(0);if((w|0)==22){f[g>>2]=t;if(!v){u=h;return}else T=v}v=i+4|0;i=f[v>>2]|0;if((i|0)!=(T|0))f[v>>2]=i+(~((i+-4-T|0)>>>2)<<2);cYc(T);u=h;return}function gvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,K=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0;h=OR()|0;i=h;j=f[i+4>>2]|0;k=x1c(f[i>>2]|0,0,-130063606,0)|0;i=d1c(k|0,J|0,j|0,0)|0;j=h;f[j>>2]=i;f[j+4>>2]=J;f[e>>2]=f[c+(~~(+(d|0)*(+(i&2147483647|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){l=1;f[g>>2]=l;return}i=(d|0)>0;j=a+24|0;h=a+20|0;k=a+16|0;a=1;while(1){if(!i){l=a;m=18;break}o=f[j>>2]|0;p=f[h>>2]|0;q=o+((Y(p,f[e>>2]|0)|0)<<2)|0;r=f[k>>2]|0;s=q+(r<<2)|0;t=s+-12|0;u=((t>>>0<q>>>0?q:t)+12+(3-q)|0)>>>4<<2;v=q>>>0<t>>>0;w=q+(u<<2)|0;x=w>>>0<s>>>0;y=(a|0)>1;z=0;A=0.0;B=-1;while(1){C=o+((Y(f[c+(z<<2)>>2]|0,p)|0)<<2)|0;D=C+(u<<2)|0;if(v){E=q;F=C;G=0.0;while(1){H=+L(+(+n[E>>2]-+n[F>>2]));I=+L(+(+n[E+4>>2]-+n[F+4>>2]));K=+L(+(+n[E+8>>2]-+n[F+8>>2]));M=G+(H+I+K+ +L(+(+n[E+12>>2]-+n[F+12>>2])));E=E+16|0;if(E>>>0>=t>>>0){N=M;break}else{F=F+16|0;G=M}}}else N=0.0;if(x){F=D;G=N;E=w;while(1){M=G+ +L(+(+n[E>>2]-+n[F>>2]));E=E+4|0;if(E>>>0>=s>>>0){O=M;break}else{F=F+4|0;G=M}}}else O=N;if(y){F=1;G=O;while(1){E=o+((Y(p,f[e+(F<<2)>>2]|0)|0)<<2)|0;D=E+(r<<2)|0;P=D+-12|0;Q=((P>>>0<E>>>0?E:P)+12+(3-E)|0)>>>4<<2;R=C+(Q<<2)|0;if(E>>>0<P>>>0){S=E;T=C;M=0.0;while(1){K=+L(+(+n[S>>2]-+n[T>>2]));I=+L(+(+n[S+4>>2]-+n[T+4>>2]));H=+L(+(+n[S+8>>2]-+n[T+8>>2]));U=M+(K+I+H+ +L(+(+n[S+12>>2]-+n[T+12>>2])));S=S+16|0;if(S>>>0>=P>>>0){V=U;break}else{T=T+16|0;M=U}}}else V=0.0;T=E+(Q<<2)|0;if(T>>>0<D>>>0){P=R;M=V;S=T;while(1){U=M+ +L(+(+n[S>>2]-+n[P>>2]));S=S+4|0;if(S>>>0>=D>>>0){W=U;break}else{P=P+4|0;M=U}}}else W=V;M=W<G?W:G;F=F+1|0;if((F|0)==(a|0)){X=M;break}else G=M}}else X=O;F=X>A;B=F?z:B;z=z+1|0;if((z|0)==(d|0))break;else A=F?X:A}if((B|0)==-1){l=a;m=18;break}f[e+(a<<2)>>2]=f[c+(B<<2)>>2];z=a+1|0;if((z|0)<(b|0))a=z;else{l=z;m=18;break}}if((m|0)==18){f[g>>2]=l;return}}function hvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0;h=u;u=u+16|0;i=h;j=bYc(d>>>0>1073741823?-1:d<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;o=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(o|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=c+(~~(+(d|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[e>>2]=f[m>>2];l=(d|0)>0;if(l){k=f[a+24>>2]|0;o=f[a+20>>2]|0;p=k+((Y(f[m>>2]|0,o)|0)<<2)|0;m=f[a+16>>2]|0;q=0;r=0.0;while(1){s=k+((Y(o,f[c+(q<<2)>>2]|0)|0)<<2)|0;t=s+(m<<2)|0;v=t+-12|0;w=((v>>>0<s>>>0?s:v)+12+(3-s)|0)>>>4<<2;x=p+(w<<2)|0;if(s>>>0<v>>>0){y=s;z=p;A=0.0;while(1){B=+L(+(+n[y>>2]-+n[z>>2]));C=+L(+(+n[y+4>>2]-+n[z+4>>2]));D=+L(+(+n[y+8>>2]-+n[z+8>>2]));E=A+(B+C+D+ +L(+(+n[y+12>>2]-+n[z+12>>2])));y=y+16|0;if(y>>>0>=v>>>0){F=E;break}else{z=z+16|0;A=E}}}else F=0.0;z=s+(w<<2)|0;if(z>>>0<t>>>0){v=x;A=F;y=z;while(1){E=A+ +L(+(+n[y>>2]-+n[v>>2]));y=y+4|0;if(y>>>0>=t>>>0){G=E;break}else{v=v+4|0;A=E}}}else G=F;A=G*G;n[j+(q<<2)>>2]=A;E=r+A;q=q+1|0;if((q|0)==(d|0)){H=E;break}else r=E}}else H=0.0;if((b|0)<=1){I=1;f[g>>2]=I;dYc(j);u=h;return}q=d+-1|0;p=(d|0)>1;m=a+24|0;o=a+20|0;k=a+16|0;a=1;r=H;while(1){v=OR()|0;t=v;y=f[t+4>>2]|0;x=x1c(f[t>>2]|0,0,-130063606,0)|0;t=d1c(x|0,J|0,y|0,0)|0;y=v;f[y>>2]=t;f[y+4>>2]=J;a:do if(p){y=0;H=r*(+(t&2147483647|0)*4.656612873077393e-10)+0.0;while(1){G=+n[j+(y<<2)>>2];if(H<=G){K=y;break a}v=y+1|0;if((v|0)<(q|0)){y=v;H=H-G}else{K=v;break}}}else K=0;while(0);if(l){t=f[m>>2]|0;y=f[o>>2]|0;v=c+(K<<2)|0;x=f[v>>2]|0;w=t+((Y(x,y)|0)<<2)|0;s=f[k>>2]|0;z=0;H=0.0;do{M=t+((Y(y,f[c+(z<<2)>>2]|0)|0)<<2)|0;N=M+(s<<2)|0;O=N+-12|0;P=((O>>>0<M>>>0?M:O)+12+(3-M)|0)>>>4<<2;Q=w+(P<<2)|0;if(M>>>0<O>>>0){R=M;S=w;G=0.0;while(1){F=+L(+(+n[R>>2]-+n[S>>2]));E=+L(+(+n[R+4>>2]-+n[S+4>>2]));A=+L(+(+n[R+8>>2]-+n[S+8>>2]));D=G+(F+E+A+ +L(+(+n[R+12>>2]-+n[S+12>>2])));R=R+16|0;if(R>>>0>=O>>>0){T=D;break}else{S=S+16|0;G=D}}}else T=0.0;S=M+(P<<2)|0;if(S>>>0<N>>>0){O=Q;G=T;R=S;while(1){D=G+ +L(+(+n[R>>2]-+n[O>>2]));R=R+4|0;if(R>>>0>=N>>>0){U=D;break}else{O=O+4|0;G=D}}}else U=T;G=U*U;D=+n[j+(z<<2)>>2];H=H+(D<G?D:G);z=z+1|0}while((z|0)!=(d|0));f[e+(a<<2)>>2]=x;if(l){z=f[m>>2]|0;w=f[o>>2]|0;s=z+((Y(f[v>>2]|0,w)|0)<<2)|0;y=f[k>>2]|0;t=0;do{O=z+((Y(w,f[c+(t<<2)>>2]|0)|0)<<2)|0;N=O+(y<<2)|0;R=N+-12|0;Q=((R>>>0<O>>>0?O:R)+12+(3-O)|0)>>>4<<2;P=s+(Q<<2)|0;if(O>>>0<R>>>0){M=O;S=s;G=0.0;while(1){D=+L(+(+n[M>>2]-+n[S>>2]));A=+L(+(+n[M+4>>2]-+n[S+4>>2]));E=+L(+(+n[M+8>>2]-+n[S+8>>2]));F=G+(D+A+E+ +L(+(+n[M+12>>2]-+n[S+12>>2])));M=M+16|0;if(M>>>0>=R>>>0){V=F;break}else{S=S+16|0;G=F}}}else V=0.0;S=O+(Q<<2)|0;if(S>>>0<N>>>0){R=P;G=V;M=S;while(1){F=G+ +L(+(+n[M>>2]-+n[R>>2]));M=M+4|0;if(M>>>0>=N>>>0){W=F;break}else{R=R+4|0;G=F}}}else W=V;G=W*W;n[i>>2]=G;R=j+(t<<2)|0;f[R>>2]=f[(+n[R>>2]<G?R:i)>>2];t=t+1|0}while((t|0)!=(d|0));X=H}else X=H}else{f[e+(a<<2)>>2]=f[c+(K<<2)>>2];X=0.0}a=a+1|0;if((a|0)==(b|0)){I=b;break}else r=X}f[g>>2]=I;dYc(j);u=h;return}function ivc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,K=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;h=u;u=u+16|0;i=h;j=bYc(d>>>0>1073741823?-1:d<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;o=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(o|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=c+(~~(+(d|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[e>>2]=f[m>>2];l=(d|0)>0;if(l){k=f[a+24>>2]|0;o=f[a+20>>2]|0;p=k+((Y(f[m>>2]|0,o)|0)<<2)|0;m=f[a+16>>2]|0;q=0;do{r=k+((Y(o,f[c+(q<<2)>>2]|0)|0)<<2)|0;s=r+(m<<2)|0;t=s+-12|0;v=((t>>>0<r>>>0?r:t)+12+(3-r)|0)>>>4<<2;w=p+(v<<2)|0;if(r>>>0<t>>>0){x=r;y=p;z=0.0;while(1){A=+L(+(+n[x>>2]-+n[y>>2]));B=+L(+(+n[x+4>>2]-+n[y+4>>2]));C=+L(+(+n[x+8>>2]-+n[y+8>>2]));D=z+(A+B+C+ +L(+(+n[x+12>>2]-+n[y+12>>2])));x=x+16|0;if(x>>>0>=t>>>0){E=D;break}else{y=y+16|0;z=D}}}else E=0.0;y=r+(v<<2)|0;if(y>>>0<s>>>0){t=w;z=E;x=y;while(1){D=z+ +L(+(+n[x>>2]-+n[t>>2]));x=x+4|0;if(x>>>0>=s>>>0){F=D;break}else{t=t+4|0;z=D}}}else F=E;n[j+(q<<2)>>2]=F;q=q+1|0}while((q|0)!=(d|0))}if((b|0)<=1){G=1;f[g>>2]=G;dYc(j);u=h;return}q=a+24|0;p=a+20|0;m=a+16|0;a=1;do{if(l){F=0.0;o=0;E=-1.0;k=0;while(1){z=+n[j+(k<<2)>>2];if(z>F*1.2999999523162842){t=f[q>>2]|0;s=f[p>>2]|0;x=t+((Y(f[c+(k<<2)>>2]|0,s)|0)<<2)|0;w=f[m>>2]|0;v=0;D=0.0;do{r=t+((Y(s,f[c+(v<<2)>>2]|0)|0)<<2)|0;y=r+(w<<2)|0;H=y+-12|0;I=((H>>>0<r>>>0?r:H)+12+(3-r)|0)>>>4<<2;K=x+(I<<2)|0;if(r>>>0<H>>>0){M=r;N=x;C=0.0;while(1){B=+L(+(+n[M>>2]-+n[N>>2]));A=+L(+(+n[M+4>>2]-+n[N+4>>2]));O=+L(+(+n[M+8>>2]-+n[N+8>>2]));P=C+(B+A+O+ +L(+(+n[M+12>>2]-+n[N+12>>2])));M=M+16|0;if(M>>>0>=H>>>0){Q=P;break}else{N=N+16|0;C=P}}}else Q=0.0;N=r+(I<<2)|0;if(N>>>0<y>>>0){H=K;C=Q;M=N;while(1){P=C+ +L(+(+n[M>>2]-+n[H>>2]));M=M+4|0;if(M>>>0>=y>>>0){R=P;break}else{H=H+4|0;C=P}}}else R=Q;C=+n[j+(v<<2)>>2];D=D+(C<R?C:R);v=v+1|0}while((v|0)!=(d|0));v=!(E<0.0)&!(D<=E);S=v?F:z;T=v?o:k;U=v?E:D}else{S=F;T=o;U=E}k=k+1|0;if((k|0)==(d|0))break;else{F=S;o=T;E=U}}o=c+(T<<2)|0;f[e+(a<<2)>>2]=f[o>>2];if(l){k=f[q>>2]|0;v=f[p>>2]|0;x=k+((Y(f[o>>2]|0,v)|0)<<2)|0;o=f[m>>2]|0;w=0;do{s=k+((Y(v,f[c+(w<<2)>>2]|0)|0)<<2)|0;t=s+(o<<2)|0;H=t+-12|0;y=((H>>>0<s>>>0?s:H)+12+(3-s)|0)>>>4<<2;M=x+(y<<2)|0;if(s>>>0<H>>>0){K=s;I=x;E=0.0;while(1){F=+L(+(+n[K>>2]-+n[I>>2]));C=+L(+(+n[K+4>>2]-+n[I+4>>2]));P=+L(+(+n[K+8>>2]-+n[I+8>>2]));O=E+(F+C+P+ +L(+(+n[K+12>>2]-+n[I+12>>2])));K=K+16|0;if(K>>>0>=H>>>0){V=O;break}else{I=I+16|0;E=O}}}else V=0.0;I=s+(y<<2)|0;if(I>>>0<t>>>0){H=M;E=V;K=I;while(1){D=E+ +L(+(+n[K>>2]-+n[H>>2]));K=K+4|0;if(K>>>0>=t>>>0){W=D;break}else{H=H+4|0;E=D}}}else W=V;n[i>>2]=W;H=j+(w<<2)|0;f[H>>2]=f[(+n[H>>2]<W?H:i)>>2];w=w+1|0}while((w|0)!=(d|0))}}else f[e+(a<<2)>>2]=f[c>>2];a=a+1|0}while((a|0)!=(b|0));G=b;f[g>>2]=G;dYc(j);u=h;return}function jvc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(b){CS(a,b);e=a+12|0;f[e>>2]=b;if((b|0)>0){g=f[a>>2]|0;h=0;do{f[g+(h<<2)>>2]=h;h=h+1|0}while((h|0)<(f[e>>2]|0))}}else f[a+12>>2]=b;b=d+8|0;f[b>>2]=0;f[b+4>>2]=0;f[d>>2]=-2096955388;f[d+4>>2]=a;SR(d,1.0,0);f[a+16>>2]=0;u=c;return}function kvc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=173260;b=a+52|0;c=f[b>>2]|0;a:do if(c|0?(d=a+92|0,e=f[d>>2]|0,(e|0)>0):0){g=0;h=e;e=c;while(1){i=f[e+(g<<2)>>2]|0;if(!i)j=h;else{dYc(i);f[(f[b>>2]|0)+(g<<2)>>2]=0;j=f[d>>2]|0}i=g+1|0;if((i|0)>=(j|0))break a;g=i;h=j;e=f[b>>2]|0}}while(0);j=f[a+48>>2]|0;if(j|0)dYc(j);j=f[b>>2]|0;if(j|0)dYc(j);j=a+64|0;b=f[j>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;kIc(b);f[j>>2]=c}while((c|0)!=0)}Ptc(a+28|0,f[a+32>>2]|0);return}function lvc(a){a=a|0;kvc(a);cYc(a);return}function mvc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=a+88|0;if((f[b>>2]|0)<2){c=af(60)|0;Jtc(c,513040);ig(c|0,22128,1)}c=a+52|0;d=f[c>>2]|0;e=a+92|0;g=f[e>>2]|0;a:do if(!d)h=g;else{if((g|0)>0){i=0;j=d;k=g}else return;while(1){l=f[j+(i<<2)>>2]|0;if(!l)m=k;else{dYc(l);f[(f[c>>2]|0)+(i<<2)>>2]=0;m=f[e>>2]|0}l=i+1|0;if((l|0)>=(m|0)){h=m;break a}i=l;j=f[c>>2]|0;k=m}}while(0);if((h|0)<=0)return;h=a+40|0;m=a+60|0;k=a+80|0;j=f[46249]|0;i=a+64|0;g=a+68|0;d=a+48|0;l=a+76|0;n=0;do{o=f[h>>2]|0;p=bYc(o>>>0>1073741823?-1:o<<2)|0;f[(f[c>>2]|0)+(n<<2)>>2]=p;if(!o)q=0;else{o=f[(f[c>>2]|0)+(n<<2)>>2]|0;p=0;do{f[o+(p<<2)>>2]=p;p=p+1|0;r=f[h>>2]|0}while(p>>>0<r>>>0);q=r}p=f[m>>2]|0;do if((p|0)<32){f[k>>2]=(f[k>>2]|0)+p;o=jIc(8192)|0;if(!o){eKc(513012,27,1,j)|0;s=0;t=f[h>>2]|0;break}else{f[o>>2]=f[i>>2];f[i>>2]=o;f[m>>2]=8188;r=o+4|0;f[g>>2]=r;u=r;v=8188;w=19;break}}else{u=f[g>>2]|0;v=p;w=19}while(0);if((w|0)==19){w=0;f[g>>2]=u+32;f[m>>2]=v+-32;f[l>>2]=(f[l>>2]|0)+32;s=u;t=q}f[(f[d>>2]|0)+(n<<2)>>2]=s;Wvc(a,f[(f[d>>2]|0)+(n<<2)>>2]|0,f[(f[c>>2]|0)+(n<<2)>>2]|0,t,f[b>>2]|0,0);n=n+1|0}while((n|0)<(f[e>>2]|0));return}function nvc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;i=u;u=u+48|0;j=i+12|0;k=i;l=j+4|0;m=j+8|0;o=j+20|0;p=j+16|0;q=j+12|0;f[j>>2]=173220;f[j+24>>2]=g;r=j+12|0;f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;if(!(f[c>>2]|0)){s=0;f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}v=c+12|0;w=c+8|0;x=k+11|0;y=k+6|0;z=h+4|0;A=d+12|0;B=d+8|0;d=e+12|0;C=e+8|0;e=(g|0)<0;D=(g|0)!=0;E=0;F=0;while(1){Fuc(r,F);f[o>>2]=0;f[r>>2]=p;f[p>>2]=0;n[m>>2]=3402823466385288598117041.0e14;b[l>>0]=0;G=(f[v>>2]|0)+((Y(f[w>>2]|0,E)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,j,G,h);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[x>>0]=6;b[k>>0]=b[512403]|0;b[k+1>>0]=b[512404]|0;b[k+2>>0]=b[512405]|0;b[k+3>>0]=b[512406]|0;b[k+4>>0]=b[512407]|0;b[k+5>>0]=b[512408]|0;b[y>>0]=0;G=auc(h,k)|0;if((G|0)==(z|0))H=1;else{I=G+28|0;J=f[I>>2]|0;K=(_i[f[(f[J>>2]|0)+28>>2]&2047](J)|0)+4|0;if((f[K>>2]|0)!=(f[6363]|0)){L=6;break}K=f[I>>2]|0;I=Mi[f[(f[K>>2]|0)+20>>2]&1023](K,G+32|0)|0;H=b[I>>0]|0}if((b[x>>0]|0)<0)cYc(f[k>>2]|0);I=(f[A>>2]|0)+((Y(f[B>>2]|0,E)|0)<<2)|0;G=(f[d>>2]|0)+((Y(f[C>>2]|0,E)|0)<<2)|0;do if(!(H<<24>>24)){K=f[q>>2]|0;if(e){if((K|0)==(p|0))break;else{M=I;N=G;O=K}while(1){f[M>>2]=f[O+20>>2];f[N>>2]=f[O+16>>2];J=f[O+4>>2]|0;if(!J){P=O+8|0;Q=f[P>>2]|0;if((f[Q>>2]|0)==(O|0))R=Q;else{Q=P;do{P=f[Q>>2]|0;Q=P+8|0;S=f[Q>>2]|0}while((f[S>>2]|0)!=(P|0));R=S}}else{Q=J;while(1){S=f[Q>>2]|0;if(!S)break;else Q=S}R=Q}if((R|0)==(p|0))break;else{M=M+4|0;N=N+4|0;O=R}}}else{if(D&(K|0)!=(p|0)){T=0;U=G;V=I;W=K}else break;while(1){f[V>>2]=f[W+20>>2];f[U>>2]=f[W+16>>2];J=f[W+4>>2]|0;if(!J){S=W+8|0;P=f[S>>2]|0;if((f[P>>2]|0)==(W|0))X=P;else{P=S;do{S=f[P>>2]|0;P=S+8|0;Z=f[P>>2]|0}while((f[Z>>2]|0)!=(S|0));X=Z}}else{P=J;while(1){Q=f[P>>2]|0;if(!Q)break;else P=Q}X=P}T=T+1|0;if(!((T|0)<(g|0)&(X|0)!=(p|0)))break;else{U=U+4|0;V=V+4|0;W=X}}}}else ei[f[(f[j>>2]|0)+24>>2]&511](j,I,G,g);while(0);E=E+1|0;G=f[p>>2]|0;if(E>>>0>=(f[c>>2]|0)>>>0){s=G;L=3;break}else F=G}if((L|0)==3){f[j>>2]=173180;t=j+12|0;Fuc(t,s);u=i;return}else if((L|0)==6)ig(af(1)|0,22144,0)}function ovc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;eKc(a+88|0,4,1,b)|0;c=a+92|0;eKc(c,4,1,b)|0;eKc(a+96|0,4,1,b)|0;eKc(a+100|0,4,1,b)|0;eKc(a+84|0,4,1,b)|0;if((f[c>>2]|0)<=0)return;d=a+52|0;e=a+40|0;g=a+48|0;h=0;do{eKc(f[(f[d>>2]|0)+(h<<2)>>2]|0,4,f[e>>2]|0,b)|0;Vvc(a,b,f[(f[g>>2]|0)+(h<<2)>>2]|0,h);h=h+1|0}while((h|0)<(f[c>>2]|0));return}function pvc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;i=a+52|0;j=f[i>>2]|0;a:do if(j|0?(k=a+92|0,l=f[k>>2]|0,(l|0)>0):0){m=0;n=j;o=l;while(1){l=f[n+(m<<2)>>2]|0;if(!l)p=o;else{dYc(l);f[(f[i>>2]|0)+(m<<2)>>2]=0;p=f[k>>2]|0}l=m+1|0;if((l|0)>=(p|0))break a;m=l;n=f[i>>2]|0;o=p}}while(0);p=a+48|0;j=f[p>>2]|0;if(j|0)dYc(j);j=f[i>>2]|0;if(j|0)dYc(j);j=a+88|0;if((NLc(j,4,1,c)|0)!=1){o=af(60)|0;Jtc(o,511860);ig(o|0,22128,1)}o=a+92|0;if((NLc(o,4,1,c)|0)!=1){n=af(60)|0;Jtc(n,511860);ig(n|0,22128,1)}n=a+96|0;if((NLc(n,4,1,c)|0)!=1){m=af(60)|0;Jtc(m,511860);ig(m|0,22128,1)}m=a+100|0;if((NLc(m,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if((NLc(a+84|0,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=f[o>>2]|0;l=k>>>0>1073741823?-1:k<<2;q=bYc(l)|0;f[i>>2]=q;r=bYc(l)|0;f[p>>2]=r;b:do if((k|0)>0){r=a+40|0;l=0;s=q;while(1){t=f[r>>2]|0;v=bYc(t>>>0>1073741823?-1:t<<2)|0;f[s+(l<<2)>>2]=v;if((NLc(f[(f[i>>2]|0)+(l<<2)>>2]|0,4,t,c)|0)!=(t|0))break;Avc(a,c,(f[p>>2]|0)+(l<<2)|0,l);t=l+1|0;if((t|0)>=(f[o>>2]|0))break b;l=t;s=f[i>>2]|0}s=af(60)|0;Jtc(s,511860);ig(s|0,22128,1)}while(0);i=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=i;i=a+28|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;p=h+11|0;b[p>>0]=9;c=h;q=512094;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[h+9>>0]=0;s=Ntc(i,e,h)|0;l=f[s>>2]|0;if(!l){r=$Xc(36)|0;t=r+16|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];f[t+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;t=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=t;f[s>>2]=r;t=f[f[i>>2]>>2]|0;if(!t)w=r;else{f[i>>2]=t;w=f[s>>2]|0}UQ(f[a+32>>2]|0,w);w=a+36|0;f[w>>2]=(f[w>>2]|0)+1;x=r}else x=l;l=x+28|0;r=f[l>>2]|0;w=x+32|0;mi[f[f[r>>2]>>2]&2047](r,w);f[l>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,w);if((b[p>>0]|0)<0)cYc(f[h>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=9;c=g;q=512667;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[g+9>>0]=0;p=Ntc(i,e,g)|0;w=f[p>>2]|0;if(!w){l=$Xc(36)|0;r=l+16|0;f[r>>2]=f[g>>2];f[r+4>>2]=f[g+4>>2];f[r+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;r=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=r;f[p>>2]=l;r=f[f[i>>2]>>2]|0;if(!r)y=l;else{f[i>>2]=r;y=f[p>>2]|0}UQ(f[a+32>>2]|0,y);y=a+36|0;f[y>>2]=(f[y>>2]|0)+1;z=l}else z=w;w=z+28|0;l=f[w>>2]|0;y=z+32|0;mi[f[f[l>>2]>>2]&2047](l,y);f[w>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,j,y);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=5;b[g>>0]=b[512723]|0;b[g+1>>0]=b[512724]|0;b[g+2>>0]=b[512725]|0;b[g+3>>0]=b[512726]|0;b[g+4>>0]=b[512727]|0;b[g+5>>0]=0;y=Ntc(i,e,g)|0;j=f[y>>2]|0;if(!j){w=$Xc(36)|0;l=w+16|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[l+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[w+28>>2]=172888;f[w+32>>2]=0;l=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=l;f[y>>2]=w;l=f[f[i>>2]>>2]|0;if(!l)A=w;else{f[i>>2]=l;A=f[y>>2]|0}UQ(f[a+32>>2]|0,A);A=a+36|0;f[A>>2]=(f[A>>2]|0)+1;B=w}else B=j;j=B+28|0;w=f[j>>2]|0;A=B+32|0;mi[f[f[w>>2]>>2]&2047](w,A);f[j>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,o,A);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;c=h;q=512677;k=c+12|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[h+12>>0]=0;h=Ntc(i,e,g)|0;A=f[h>>2]|0;if(!A){o=$Xc(36)|0;j=o+16|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[o+28>>2]=172888;f[o+32>>2]=0;j=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=j;f[h>>2]=o;j=f[f[i>>2]>>2]|0;if(!j)C=o;else{f[i>>2]=j;C=f[h>>2]|0}UQ(f[a+32>>2]|0,C);C=a+36|0;f[C>>2]=(f[C>>2]|0)+1;D=o}else D=A;A=D+28|0;o=f[A>>2]|0;C=D+32|0;mi[f[f[o>>2]>>2]&2047](o,C);f[A>>2]=173316;Ti[f[(f[43329]|0)+4>>2]&511](173316,n,C);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;C=g+11|0;b[C>>0]=9;c=g;q=512729;k=c+9|0;do{b[c>>0]=b[q>>0]|0;c=c+1|0;q=q+1|0}while((c|0)<(k|0));b[g+9>>0]=0;q=Ntc(i,e,g)|0;c=f[q>>2]|0;if(!c){k=$Xc(36)|0;n=k+16|0;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[k+28>>2]=172888;f[k+32>>2]=0;n=f[e>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=n;f[q>>2]=k;n=f[f[i>>2]>>2]|0;if(!n)E=k;else{f[i>>2]=n;E=f[q>>2]|0}UQ(f[a+32>>2]|0,E);E=a+36|0;f[E>>2]=(f[E>>2]|0)+1;F=k}else F=c;c=F+28|0;k=f[c>>2]|0;E=F+32|0;mi[f[f[k>>2]>>2]&2047](k,E);f[c>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,m,E);if((b[C>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function qvc(a){a=a|0;return f[a+40>>2]|0}function rvc(a){a=a|0;return f[a+44>>2]|0}function svc(a){a=a|0;return (f[a+80>>2]|0)+(f[a+76>>2]|0)+(f[a+84>>2]|0)|0}function tvc(a){a=a|0;return 5}function uvc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+28>>2]|0;i=b+32|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function vvc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+12|0;i=g+24|0;j=g+8|0;k=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;m=auc(e,h)|0;do if((m|0)!=(e+4|0)){n=m+28|0;o=f[n>>2]|0;p=(_i[f[(f[o>>2]|0)+28>>2]&2047](o)|0)+4|0;if((f[p>>2]|0)==(f[6379]|0)){p=f[n>>2]|0;n=Mi[f[(f[p>>2]|0)+20>>2]&1023](p,m+32|0)|0;q=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else q=32;while(0);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(20)|0;l=a+40|0;m=f[l>>2]|0;f[h>>2]=0;e=h+4|0;f[e>>2]=0;f[h+8>>2]=0;f[h+12>>2]=m;wvc(h,m);f[h+16>>2]=0;m=f[l>>2]|0;f[i>>2]=0;l=i+4|0;f[l>>2]=0;n=i+8|0;f[n>>2]=0;if(m|0){if((m|0)<0)kWc(i);p=((m+-1|0)>>>5)+1|0;o=$Xc(p<<2)|0;f[i>>2]=o;f[n>>2]=p;f[l>>2]=m;l=m>>>5;g1c(o|0,0,l<<2|0)|0;p=m-(l<<5)|0;m=o+(l<<2)|0;if(p|0)f[m>>2]=f[m>>2]&~(-1>>>(32-p|0))}f[j>>2]=0;p=a+92|0;if((f[p>>2]|0)>0){m=a+48|0;l=0;do{xvc(a,f[(f[m>>2]|0)+(l<<2)>>2]|0,c,d,j,q,h,i);l=l+1|0}while((l|0)<(f[p>>2]|0))}while(1){if(!(yvc(h,k)|0))break;if((f[j>>2]|0)>=(q|0)?_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0:0)break;xvc(a,f[k>>2]|0,c,d,j,q,h,i)}q=f[h>>2]|0;if(q|0){j=f[e>>2]|0;if((j|0)!=(q|0))f[e>>2]=j+(~((j+-8-q|0)>>>3)<<3);cYc(q)}cYc(h);h=f[i>>2]|0;if(!h){u=g;return}cYc(h);u=g;return}function wvc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function xvc(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0;j=u;u=u+16|0;k=j;l=b+8|0;m=f[l>>2]|0;if(!m){if((f[e>>2]|0)>=(g|0)?_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0:0){u=j;return}o=b+4|0;p=f[o>>2]|0;if((p|0)<=0){u=j;return}q=b+12|0;b=a+24|0;r=a+20|0;s=a+44|0;t=0;v=f[i>>2]|0;w=p;while(1){p=f[(f[q>>2]|0)+(t<<2)>>2]|0;x=p>>>5;y=1<<(p&31);if(!(y&f[v+(x<<2)>>2])){z=(f[b>>2]|0)+((Y(f[r>>2]|0,p)|0)<<2)|0;A=z+(f[s>>2]<<2)|0;B=A+-12|0;C=((B>>>0<z>>>0?z:B)+12+(3-z)|0)>>>4<<2;D=d+(C<<2)|0;if(z>>>0<B>>>0){E=z;F=d;G=0.0;while(1){H=+L(+(+n[E>>2]-+n[F>>2]));I=+L(+(+n[E+4>>2]-+n[F+4>>2]));J=+L(+(+n[E+8>>2]-+n[F+8>>2]));K=G+(H+I+J+ +L(+(+n[E+12>>2]-+n[F+12>>2])));E=E+16|0;if(E>>>0>=B>>>0){M=K;break}else{F=F+16|0;G=K}}}else M=0.0;F=z+(C<<2)|0;if(F>>>0<A>>>0){B=D;G=M;E=F;while(1){K=G+ +L(+(+n[E>>2]-+n[B>>2]));E=E+4|0;if(E>>>0>=A>>>0){N=K;break}else{B=B+4|0;G=K}}}else N=M;Hg[f[(f[c>>2]|0)+12>>2]&15](c,N,p);B=f[i>>2]|0;A=B+(x<<2)|0;f[A>>2]=f[A>>2]|y;f[e>>2]=(f[e>>2]|0)+1;O=B;P=f[o>>2]|0}else{O=v;P=w}t=t+1|0;if((t|0)>=(P|0))break;else{v=O;w=P}}u=j;return}P=a+88|0;w=f[P>>2]|0;O=bYc(w>>>0>1073741823?-1:w<<2)|0;v=f[a+24>>2]|0;t=f[a+20>>2]|0;o=v+((Y(t,f[f[m>>2]>>2]|0)|0)<<2)|0;s=d+(f[a+44>>2]<<2)|0;r=s+-12|0;b=((r>>>0<d>>>0?d:r)+12+(3-d)|0)>>>4<<2;q=o+(b<<2)|0;B=r>>>0>d>>>0;if(B){A=d;E=o;N=0.0;while(1){M=+L(+(+n[A>>2]-+n[E>>2]));G=+L(+(+n[A+4>>2]-+n[E+4>>2]));K=+L(+(+n[A+8>>2]-+n[E+8>>2]));J=N+(M+G+K+ +L(+(+n[A+12>>2]-+n[E+12>>2])));A=A+16|0;if(A>>>0>=r>>>0){Q=J;break}else{E=E+16|0;N=J}}}else Q=0.0;E=d+(b<<2)|0;A=E>>>0<s>>>0;if(A){o=q;N=Q;q=E;while(1){J=N+ +L(+(+n[q>>2]-+n[o>>2]));q=q+4|0;if(q>>>0>=s>>>0){R=J;break}else{o=o+4|0;N=J}}}else R=Q;n[O>>2]=R;a:do if((w|0)>1){if(B){S=1;T=0}else{if(A){U=1;V=0}else{o=1;q=0;while(1){n[O+(o<<2)>>2]=0.0;D=+n[O+(q<<2)>>2]>0.0?o:q;o=o+1|0;if((o|0)>=(w|0)){W=D;break a}else q=D}}while(1){q=v+((Y(t,f[f[m+(U<<2)>>2]>>2]|0)|0)<<2)+(b<<2)|0;R=0.0;o=E;while(1){y=o;o=o+4|0;R=R+ +L(+(+n[y>>2]-+n[q>>2]));if(o>>>0>=s>>>0)break;else q=q+4|0}n[O+(U<<2)>>2]=R;q=R<+n[O+(V<<2)>>2]?U:V;U=U+1|0;if((U|0)>=(w|0)){W=q;break a}else V=q}}while(1){q=v+((Y(t,f[f[m+(S<<2)>>2]>>2]|0)|0)<<2)|0;o=d;y=q;Q=0.0;while(1){N=+L(+(+n[o>>2]-+n[y>>2]));J=+L(+(+n[o+4>>2]-+n[y+4>>2]));K=+L(+(+n[o+8>>2]-+n[y+8>>2]));Q=Q+(N+J+K+ +L(+(+n[o+12>>2]-+n[y+12>>2])));o=o+16|0;if(o>>>0>=r>>>0)break;else y=y+16|0}if(A){y=q+(b<<2)|0;R=Q;o=E;while(1){K=R+ +L(+(+n[o>>2]-+n[y>>2]));o=o+4|0;if(o>>>0>=s>>>0){X=K;break}else{y=y+4|0;R=K}}}else X=Q;n[O+(S<<2)>>2]=X;y=X<+n[O+(T<<2)>>2]?S:T;S=S+1|0;if((S|0)>=(w|0)){W=y;break}else T=y}}else W=0;while(0);if((w|0)>0){T=k+4|0;S=h+16|0;s=h+12|0;E=h+4|0;b=h+8|0;A=0;r=w;while(1){if((A|0)==(W|0))Z=r;else{w=f[O+(A<<2)>>2]|0;f[k>>2]=f[(f[l>>2]|0)+(A<<2)>>2];f[T>>2]=w;if((f[S>>2]|0)==(f[s>>2]|0))_=r;else{w=f[E>>2]|0;if((w|0)==(f[b>>2]|0)){zvc(h,k);$=f[E>>2]|0}else{m=k;t=f[m+4>>2]|0;v=w;f[v>>2]=f[m>>2];f[v+4>>2]=t;t=(f[E>>2]|0)+8|0;f[E>>2]=t;$=t}t=f[h>>2]|0;v=$-t|0;if((v|0)>8?(m=((v>>>3)+-2|0)/2|0,v=$+-8|0,X=+n[$+-4>>2],X<+n[t+(m<<3)+4>>2]):0){w=f[v>>2]|0;V=v;v=m;while(1){m=V;V=t+(v<<3)|0;U=V;B=f[U+4>>2]|0;y=m;f[y>>2]=f[U>>2];f[y+4>>2]=B;if(!v){aa=0;break}B=(v+-1|0)/2|0;if(!(X<+n[t+(B<<3)+4>>2])){aa=v;break}else v=B}f[V>>2]=w;n[t+(aa<<3)+4>>2]=X}f[S>>2]=(f[S>>2]|0)+1;_=f[P>>2]|0}Z=_}A=A+1|0;if((A|0)>=(Z|0))break;else r=Z}}dYc(O);xvc(a,f[(f[l>>2]|0)+(W<<2)>>2]|0,c,d,e,g,h,i);u=j;return}function yvc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0;c=a+16|0;if(!(f[c>>2]|0)){d=0;return d|0}e=f[a>>2]|0;g=f[e+4>>2]|0;h=b;f[h>>2]=f[e>>2];f[h+4>>2]=g;g=f[a>>2]|0;h=a+4|0;a=f[h>>2]|0;e=a-g|0;b=e>>3;if(((e|0)>8?(e=a+-8|0,a=g,i=f[a>>2]|0,j=f[a+4>>2]|0,a=e,k=f[a+4>>2]|0,l=g,f[l>>2]=f[a>>2],f[l+4>>2]=k,k=e,f[k>>2]=i,f[k+4>>2]=j,j=b+-1|0,(b|0)!=2):0)?(k=b+-3|0,b=(k|0)/2|0,(k|0)>=-1):0){k=g+8|0;if((j|0)>2?+n[g+20>>2]<+n[g+12>>2]:0){m=2;o=g+16|0}else{m=1;o=k}p=+n[g+4>>2];if(!(p<+n[o+4>>2])){k=f[g>>2]|0;i=m;m=o;o=g;while(1){e=o;o=m;l=o;a=f[l+4>>2]|0;q=e;f[q>>2]=f[l>>2];f[q+4>>2]=a;if((b|0)<(i|0))break;a=i<<1|1;q=g+(a<<3)|0;l=q;e=a+1|0;if((e|0)<(j|0)?(r=q+8|0,+n[r+4>>2]<+n[g+(a<<3)+4>>2]):0){s=e;t=r}else{s=a;t=l}if(p<+n[t+4>>2])break;else{i=s;m=t}}f[m>>2]=k;n[m+4>>2]=p}}f[h>>2]=(f[h>>2]|0)+-8;f[c>>2]=(f[c>>2]|0)+-1;d=1;return d|0}function zvc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function Avc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;h=a+60|0;i=f[h>>2]|0;do if((i|0)<32){j=a+80|0;f[j>>2]=(f[j>>2]|0)+i;j=jIc(8192)|0;if(!j){eKc(513012,27,1,f[46249]|0)|0;k=0;break}else{l=a+64|0;f[j>>2]=f[l>>2];f[l>>2]=j;f[h>>2]=8188;l=j+4|0;j=a+68|0;f[j>>2]=l;m=j;n=l;o=8156;p=6;break}}else{l=a+68|0;m=l;n=f[l>>2]|0;o=i+-32|0;p=6}while(0);if((p|0)==6){f[m>>2]=n+32;f[h>>2]=o;o=a+76|0;f[o>>2]=(f[o>>2]|0)+32;k=n}f[c>>2]=k;if((NLc(k,20,1,b)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if(!(f[(f[c>>2]|0)+8>>2]|0)){if((NLc(g,4,1,b)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}f[(f[c>>2]|0)+12>>2]=(f[(f[a+52>>2]|0)+(d<<2)>>2]|0)+(f[g>>2]<<2);u=e;return}g=a+88|0;k=(f[g>>2]<<2)+15&-16;n=f[h>>2]|0;do if((k|0)>(n|0)){o=a+80|0;f[o>>2]=(f[o>>2]|0)+n;o=(k|4)+15|0;m=o>>>0>8192?o:8192;o=jIc(m)|0;if(!o){eKc(513012,27,1,f[46249]|0)|0;q=0;break}else{i=a+64|0;f[o>>2]=f[i>>2];f[i>>2]=o;i=m+-4|0;f[h>>2]=i;m=o+4|0;o=a+68|0;f[o>>2]=m;r=o;s=m;t=i;p=18;break}}else{i=a+68|0;r=i;s=f[i>>2]|0;t=n;p=18}while(0);if((p|0)==18){f[r>>2]=s+k;f[h>>2]=t-k;t=a+76|0;f[t>>2]=(f[t>>2]|0)+k;q=s}f[(f[c>>2]|0)+8>>2]=q;if((f[g>>2]|0)>0)v=0;else{u=e;return}do{Avc(a,b,(f[(f[c>>2]|0)+8>>2]|0)+(v<<2)|0,d);v=v+1|0}while((v|0)<(f[g>>2]|0));u=e;return}function Bvc(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(a|0)cYc(a);f[b>>2]=0;return}function Cvc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(4)|0;f[a>>2]=f[b>>2];f[c>>2]=a;return}function Dvc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(4)|0;f[a>>2]=f[f[b>>2]>>2];f[c>>2]=a;return}function Evc(a,b,c){a=a|0;b=b|0;c=c|0;f[f[c>>2]>>2]=f[f[b>>2]>>2];return}function Fvc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Gvc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Hvc(a){a=a|0;return 4}function Ivc(a){a=a|0;return 22304}function Jvc(a,b,c){a=a|0;b=b|0;c=c|0;nOc(b,f[f[c>>2]>>2]|0)|0;return}function Kvc(a){a=a|0;cYc(a);return}function Lvc(a,b){a=a|0;b=b|0;return}function Mvc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function Nvc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function Ovc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function Pvc(a,b){a=a|0;b=b|0;return b|0}function Qvc(a,b){a=a|0;b=b|0;return b|0}function Rvc(a){a=a|0;return 4}function Svc(a){a=a|0;return 25512}function Tvc(a,b,c){a=a|0;b=b|0;c=c|0;nOc(b,f[c>>2]|0)|0;return}function Uvc(a){a=a|0;cYc(a);return}function Vvc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;eKc(c,20,1,b)|0;h=c+8|0;i=f[h>>2]|0;if(!i){f[g>>2]=(f[c+12>>2]|0)-(f[(f[a+52>>2]|0)+(d<<2)>>2]|0)>>2;eKc(g,4,1,b)|0;u=e;return}g=a+88|0;if((f[g>>2]|0)<=0){u=e;return}Vvc(a,b,f[i>>2]|0,d);if((f[g>>2]|0)>1)j=1;else{u=e;return}do{Vvc(a,b,f[(f[h>>2]|0)+(j<<2)>>2]|0,d);j=j+1|0}while((j|0)<(f[g>>2]|0));u=e;return}function Wvc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=u;u=u+32|0;i=h;j=h+20|0;k=h+8|0;l=h+4|0;f[b+4>>2]=d;f[b+16>>2]=g;if((f[a+100>>2]|0)>(d|0)){f[b+12>>2]=c;mMc(c,c+(d<<2)|0,i);f[b+8>>2]=0;u=h;return}f[j>>2]=0;m=j+4|0;f[m>>2]=0;f[j+8>>2]=0;do if(e)if(e>>>0>1073741823)kWc(j);else{n=e<<2;o=$Xc(n)|0;f[j>>2]=o;p=o+(e<<2)|0;f[j+8>>2]=p;g1c(o|0,0,n|0)|0;f[m>>2]=p;q=o;break}else q=0;while(0);f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;do if(d|0)if(d>>>0>1073741823)kWc(k);else{p=d<<2;n=$Xc(p)|0;f[k>>2]=n;r=n+(d<<2)|0;f[k+8>>2]=r;g1c(n|0,0,p|0)|0;f[o>>2]=r;break}while(0);r=f[a+4>>2]|0;p=f[a+8>>2]|0;n=a+(p>>1)|0;if(!(p&1))s=r;else s=f[(f[n>>2]|0)+r>>2]|0;Fh[s&255](n,e,c,d,q,l);q=f[l>>2]|0;if((q|0)<(e|0)){f[b+12>>2]=c;mMc(c,c+(d<<2)|0,i);f[b+8>>2]=0}else{Xvc(a,c,d,f[j>>2]|0,q,f[k>>2]|0,i);i=(e<<2)+15&-16;q=a+60|0;l=f[q>>2]|0;do if((i|0)>(l|0)){n=a+80|0;f[n>>2]=(f[n>>2]|0)+l;n=(i|4)+15|0;s=n>>>0>8192?n:8192;n=jIc(s)|0;if(!n){eKc(513012,27,1,f[46249]|0)|0;t=0;break}else{r=a+64|0;f[n>>2]=f[r>>2];f[r>>2]=n;r=s+-4|0;f[q>>2]=r;s=n+4|0;n=a+68|0;f[n>>2]=s;v=n;w=s;x=r;y=21;break}}else{r=a+68|0;v=r;w=f[r>>2]|0;x=l;y=21}while(0);if((y|0)==21){f[v>>2]=w+i;f[q>>2]=x-i;x=a+76|0;f[x>>2]=(f[x>>2]|0)+i;t=w}w=b+8|0;f[w>>2]=t;a:do if((e|0)>0){t=a+80|0;b=f[46249]|0;i=a+64|0;x=a+68|0;v=g+1|0;l=a+76|0;if((d|0)>0){z=0;A=0}else{r=0;while(1){s=f[q>>2]|0;do if((s|0)<32){f[t>>2]=(f[t>>2]|0)+s;n=jIc(8192)|0;if(!n){eKc(513012,27,1,b)|0;B=0;break}else{f[n>>2]=f[i>>2];f[i>>2]=n;f[q>>2]=8188;p=n+4|0;f[x>>2]=p;C=p;D=8188;y=41;break}}else{C=f[x>>2]|0;D=s;y=41}while(0);if((y|0)==41){y=0;f[x>>2]=C+32;f[q>>2]=D+-32;f[l>>2]=(f[l>>2]|0)+32;B=C}f[(f[w>>2]|0)+(r<<2)>>2]=B;s=(f[w>>2]|0)+(r<<2)|0;p=f[s>>2]|0;f[p>>2]=f[(f[j>>2]|0)+(r<<2)>>2];f[p+12>>2]=0;Wvc(a,f[s>>2]|0,c,0,e,v);r=r+1|0;if((r|0)>=(e|0))break a}}while(1){r=f[k>>2]|0;s=0;p=A;while(1){n=r+(s<<2)|0;if((f[n>>2]|0)==(z|0)){E=c+(s<<2)|0;F=c+(p<<2)|0;G=f[E>>2]|0;f[E>>2]=f[F>>2];f[F>>2]=G;G=r+(p<<2)|0;F=f[n>>2]|0;f[n>>2]=f[G>>2];f[G>>2]=F;H=p+1|0}else H=p;s=s+1|0;if((s|0)==(d|0))break;else p=H}p=f[q>>2]|0;do if((p|0)<32){f[t>>2]=(f[t>>2]|0)+p;s=jIc(8192)|0;if(!s){eKc(513012,27,1,b)|0;I=0;break}else{f[s>>2]=f[i>>2];f[i>>2]=s;f[q>>2]=8188;r=s+4|0;f[x>>2]=r;J=r;K=8188;y=28;break}}else{J=f[x>>2]|0;K=p;y=28}while(0);if((y|0)==28){y=0;f[x>>2]=J+32;f[q>>2]=K+-32;f[l>>2]=(f[l>>2]|0)+32;I=J}f[(f[w>>2]|0)+(z<<2)>>2]=I;p=(f[w>>2]|0)+(z<<2)|0;r=f[p>>2]|0;f[r>>2]=f[(f[j>>2]|0)+(z<<2)>>2];f[r+12>>2]=0;Wvc(a,f[p>>2]|0,c+(A<<2)|0,H-A|0,e,v);z=z+1|0;if((z|0)>=(e|0))break;else A=H}}while(0)}H=f[k>>2]|0;if(H|0){k=f[o>>2]|0;if((k|0)!=(H|0))f[o>>2]=k+(~((k+-4-H|0)>>>2)<<2);cYc(H)}H=f[j>>2]|0;if(H|0){j=f[m>>2]|0;if((j|0)!=(H|0))f[m>>2]=j+(~((j+-4-H|0)>>>2)<<2);cYc(H)}u=h;return}function Xvc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;n[h>>2]=0.0;if((c|0)<=0)return;i=f[a+24>>2]|0;j=a+20|0;k=a+44|0;a=(e|0)>1;l=0;m=0.0;do{o=f[j>>2]|0;p=i+((Y(o,f[b+(l<<2)>>2]|0)|0)<<2)|0;q=i+((Y(f[d>>2]|0,o)|0)<<2)|0;o=p+(f[k>>2]<<2)|0;r=o+-12|0;s=3-p|0;t=((r>>>0<p>>>0?p:r)+12+s|0)>>>4<<2;u=q+(t<<2)|0;if(p>>>0<r>>>0){v=p;w=q;x=0.0;while(1){y=+L(+(+n[v>>2]-+n[w>>2]));z=+L(+(+n[v+4>>2]-+n[w+4>>2]));A=+L(+(+n[v+8>>2]-+n[w+8>>2]));B=x+(y+z+A+ +L(+(+n[v+12>>2]-+n[w+12>>2])));v=v+16|0;if(v>>>0>=r>>>0){C=B;break}else{w=w+16|0;x=B}}}else C=0.0;w=p+(t<<2)|0;if(w>>>0<o>>>0){r=u;x=C;v=w;while(1){B=x+ +L(+(+n[v>>2]-+n[r>>2]));v=v+4|0;if(v>>>0>=o>>>0){D=B;break}else{r=r+4|0;x=B}}}else D=C;r=g+(l<<2)|0;f[r>>2]=0;if(a){o=1;x=D;while(1){v=i+((Y(f[j>>2]|0,f[d+(o<<2)>>2]|0)|0)<<2)|0;u=p+(f[k>>2]<<2)|0;t=u+-12|0;w=((t>>>0<p>>>0?p:t)+12+s|0)>>>4<<2;q=v+(w<<2)|0;if(p>>>0<t>>>0){E=p;F=v;B=0.0;while(1){A=+L(+(+n[E>>2]-+n[F>>2]));z=+L(+(+n[E+4>>2]-+n[F+4>>2]));y=+L(+(+n[E+8>>2]-+n[F+8>>2]));G=B+(A+z+y+ +L(+(+n[E+12>>2]-+n[F+12>>2])));E=E+16|0;if(E>>>0>=t>>>0){H=G;break}else{F=F+16|0;B=G}}}else H=0.0;F=p+(w<<2)|0;if(F>>>0<u>>>0){t=q;B=H;E=F;while(1){G=B+ +L(+(+n[E>>2]-+n[t>>2]));E=E+4|0;if(E>>>0>=u>>>0){I=G;break}else{t=t+4|0;B=G}}}else I=H;if(x>I){f[r>>2]=o;J=I}else J=x;o=o+1|0;if((o|0)==(e|0)){K=J;break}else x=J}}else K=D;m=K+m;n[h>>2]=m;l=l+1|0}while((l|0)!=(c|0));return}function Yvc(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+32|0;h=g+20|0;i=g+16|0;j=g+12|0;k=g+24|0;l=g;f[i>>2]=c;n[j>>2]=d;b[k>>0]=e&1;e=a+4|0;f[e>>2]=0;c=a+8|0;f[c>>2]=0;f[a>>2]=a+4;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;m=l+11|0;b[m>>0]=6;b[l>>0]=b[512787]|0;b[l+1>>0]=b[512788]|0;b[l+2>>0]=b[512789]|0;b[l+3>>0]=b[512790]|0;b[l+4>>0]=b[512791]|0;b[l+5>>0]=b[512792]|0;b[l+6>>0]=0;o=Ntc(a,h,l)|0;p=f[o>>2]|0;if(!p){q=$Xc(36)|0;r=q+16|0;f[r>>2]=f[l>>2];f[r+4>>2]=f[l+4>>2];f[r+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;r=f[h>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=r;f[o>>2]=q;r=f[f[a>>2]>>2]|0;if(!r)s=q;else{f[a>>2]=r;s=f[o>>2]|0}UQ(f[e>>2]|0,s);f[c>>2]=(f[c>>2]|0)+1;t=q}else t=p;p=t+28|0;q=f[p>>2]|0;s=t+32|0;mi[f[f[q>>2]>>2]&2047](q,s);f[p>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,i,s);if((b[m>>0]|0)<0)cYc(f[l>>2]|0);m=l+4|0;f[m>>2]=0;f[m+4>>2]=0;m=l+11|0;b[m>>0]=3;b[l>>0]=b[513188]|0;b[l+1>>0]=b[513189]|0;b[l+2>>0]=b[513190]|0;b[l+3>>0]=0;s=Ntc(a,h,l)|0;i=f[s>>2]|0;if(!i){p=$Xc(36)|0;q=p+16|0;f[q>>2]=f[l>>2];f[q+4>>2]=f[l+4>>2];f[q+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[p+28>>2]=172888;f[p+32>>2]=0;q=f[h>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=q;f[s>>2]=p;q=f[f[a>>2]>>2]|0;if(!q)v=p;else{f[a>>2]=q;v=f[s>>2]|0}UQ(f[e>>2]|0,v);f[c>>2]=(f[c>>2]|0)+1;w=p}else w=i;i=w+28|0;p=f[i>>2]|0;v=w+32|0;mi[f[f[p>>2]>>2]&2047](p,v);f[i>>2]=173484;Ti[f[(f[43371]|0)+4>>2]&511](173484,j,v);if((b[m>>0]|0)<0)cYc(f[l>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;m=l+11|0;b[m>>0]=6;b[l>>0]=b[512403]|0;b[l+1>>0]=b[512404]|0;b[l+2>>0]=b[512405]|0;b[l+3>>0]=b[512406]|0;b[l+4>>0]=b[512407]|0;b[l+5>>0]=b[512408]|0;b[l+6>>0]=0;v=Ntc(a,h,l)|0;j=f[v>>2]|0;if(!j){i=$Xc(36)|0;p=i+16|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[i+28>>2]=172888;f[i+32>>2]=0;p=f[h>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=p;f[v>>2]=i;p=f[f[a>>2]>>2]|0;if(!p)x=i;else{f[a>>2]=p;x=f[v>>2]|0}UQ(f[e>>2]|0,x);f[c>>2]=(f[c>>2]|0)+1;y=i}else y=j;j=y+28|0;i=f[j>>2]|0;c=y+32|0;mi[f[f[i>>2]>>2]&2047](i,c);f[j>>2]=173488;Ti[f[(f[43372]|0)+4>>2]&511](173488,k,c);if((b[m>>0]|0)>=0){u=g;return}cYc(f[l>>2]|0);u=g;return}function Zvc(a,b){a=a|0;b=b|0;return}function _vc(a,c,d){a=a|0;c=c|0;d=d|0;b[d>>0]=b[c>>0]|0;return}function $vc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function awc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function bwc(a,b){a=a|0;b=b|0;return b|0}function cwc(a,b){a=a|0;b=b|0;return b|0}function dwc(a){a=a|0;return 1}function ewc(a){a=a|0;return 25448}function fwc(a,c,d){a=a|0;c=c|0;d=d|0;mOc(c,(b[d>>0]|0)!=0)|0;return}function gwc(a){a=a|0;cYc(a);return}function hwc(a,b){a=a|0;b=b|0;return}function iwc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function jwc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function kwc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function lwc(a,b){a=a|0;b=b|0;return b|0}function mwc(a,b){a=a|0;b=b|0;return b|0}function nwc(a){a=a|0;return 4}function owc(a){a=a|0;return 25544}function pwc(a,b,c){a=a|0;b=b|0;c=c|0;pOc(b,+n[c>>2])|0;return}function qwc(a){a=a|0;cYc(a);return}function rwc(a){a=a|0;var b=0,c=0;f[a>>2]=173432;b=a+4|0;c=f[b>>2]|0;if(c|0){Yi[f[(f[c>>2]|0)+4>>2]&4095](c);f[b>>2]=0}Ptc(a+20|0,f[a+24>>2]|0);Ptc(a+8|0,f[a+12>>2]|0);return}function swc(a){a=a|0;var b=0,c=0;f[a>>2]=173432;b=a+4|0;c=f[b>>2]|0;if(c|0){Yi[f[(f[c>>2]|0)+4>>2]&4095](c);f[b>>2]=0}Ptc(a+20|0,f[a+24>>2]|0);Ptc(a+8|0,f[a+12>>2]|0);cYc(a);return}function twc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0;c=u;u=u+240|0;d=c+72|0;e=c+56|0;g=c+32|0;h=c+24|0;i=c+8|0;j=c+224|0;k=c+88|0;l=k+56|0;m=k+4|0;f[k>>2]=6884;f[l>>2]=6904;XNc(k+56|0,m);f[k+128>>2]=0;f[k+132>>2]=-1;f[k>>2]=36020;f[l>>2]=36040;aOc(m);f[m>>2]=35912;o=k+36|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[k+52>>2]=16;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;AM(m,j);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);Fwc(j,a);p=a+8|0;q=a+12|0;Ptc(p,f[q>>2]|0);f[p>>2]=f[j>>2];r=j+4|0;s=f[r>>2]|0;f[q>>2]=s;t=j+8|0;v=f[t>>2]|0;f[a+16>>2]=v;if(!v){f[p>>2]=q;w=s}else{f[s+8>>2]=q;f[j>>2]=r;f[r>>2]=0;f[t>>2]=0;w=0}Ptc(j,w);Gwc(p,k);Hwc(513494,c)|0;Hwc(513548,i)|0;CM(i,m);w=i+11|0;f[h>>2]=(b[w>>0]|0)<0?f[i>>2]|0:i;Hwc(518975,h)|0;if((b[w>>0]|0)<0)cYc(f[i>>2]|0);Hwc(513494,g)|0;i=Utc(a+84|0,p,a+116|0)|0;f[a+4>>2]=i;Yi[f[(f[i>>2]|0)+8>>2]&4095](i);i=a+20|0;x=+Iwc(a,i);n[a+80>>2]=x;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;AM(m,g);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);Gwc(i,k);Hwc(513494,c+48|0)|0;Hwc(513571,e)|0;CM(e,m);i=e+11|0;f[d>>2]=(b[i>>0]|0)<0?f[e>>2]|0:e;Hwc(518975,d)|0;if((b[i>>0]|0)<0)cYc(f[e>>2]|0);Hwc(513494,c+80|0)|0;f[k>>2]=36020;f[l>>2]=36040;f[m>>2]=35912;if((b[o+11>>0]|0)>=0){LMc(m);HNc(k,36052);GMc(l);u=c;return}cYc(f[o>>2]|0);LMc(m);HNc(k,36052);GMc(l);u=c;return}function uwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+12|0;g=d;h=a+4|0;i=f[h>>2]|0;j=_i[f[(f[i>>2]|0)+40>>2]&2047](i)|0;f[e>>2]=j;eKc(e,4,1,c)|0;j=f[h>>2]|0;mi[f[(f[j>>2]|0)+20>>2]&2047](j,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=6;b[g>>0]=b[512787]|0;b[g+1>>0]=b[512788]|0;b[g+2>>0]=b[512789]|0;b[g+3>>0]=b[512790]|0;b[g+4>>0]=b[512791]|0;b[g+5>>0]=b[512792]|0;b[g+6>>0]=0;h=Cwc(a+20|0,g)|0;f[e>>2]=h;eKc(e,4,1,c)|0;if((b[j>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function vwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+48|0;e=d+32|0;g=d+28|0;h=d+16|0;i=d+12|0;j=d;if((NLc(g,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=h+4|0;f[k>>2]=0;l=h+8|0;f[l>>2]=0;m=h+4|0;f[h>>2]=m;f[i>>2]=f[g>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;g=j+11|0;b[g>>0]=9;n=j;o=512094;p=n+9|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[j+9>>0]=0;o=Ntc(h,e,j)|0;n=f[o>>2]|0;if(!n){p=$Xc(36)|0;q=p+16|0;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[p+28>>2]=172888;f[p+32>>2]=0;q=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=q;f[o>>2]=p;q=f[f[h>>2]>>2]|0;if(!q)r=p;else{f[h>>2]=q;r=f[o>>2]|0}UQ(f[k>>2]|0,r);f[l>>2]=(f[l>>2]|0)+1;s=p}else s=n;n=s+28|0;p=f[n>>2]|0;l=s+32|0;mi[f[f[p>>2]>>2]&2047](p,l);f[n>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,i,l);if((b[g>>0]|0)<0)cYc(f[j>>2]|0);g=Utc(a+84|0,h,a+116|0)|0;f[a+4>>2]=g;mi[f[(f[g>>2]|0)+24>>2]&2047](g,c);if((NLc(i,4,1,c)|0)!=1){c=af(60)|0;Jtc(c,511860);ig(c|0,22128,1)};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=j+11|0;b[c>>0]=6;b[j>>0]=b[512787]|0;b[j+1>>0]=b[512788]|0;b[j+2>>0]=b[512789]|0;b[j+3>>0]=b[512790]|0;b[j+4>>0]=b[512791]|0;b[j+5>>0]=b[512792]|0;b[j+6>>0]=0;g=a+20|0;l=Ntc(g,e,j)|0;n=f[l>>2]|0;if(!n){p=$Xc(36)|0;s=p+16|0;f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[s+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[p+28>>2]=172888;f[p+32>>2]=0;s=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=s;f[l>>2]=p;s=f[f[g>>2]>>2]|0;if(!s)t=p;else{f[g>>2]=s;t=f[l>>2]|0}UQ(f[a+24>>2]|0,t);t=a+28|0;f[t>>2]=(f[t>>2]|0)+1;v=p}else v=n;n=v+28|0;p=f[n>>2]|0;t=v+32|0;mi[f[f[p>>2]>>2]&2047](p,t);f[n>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,i,t);if((b[c>>0]|0)>=0){w=f[m>>2]|0;Ptc(h,w);u=d;return}cYc(f[j>>2]|0);w=f[m>>2]|0;Ptc(h,w);u=d;return}function wwc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+28>>2]&2047](b)|0}function xwc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&2047](b)|0}function ywc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+36>>2]&2047](b)|0}function zwc(a){a=a|0;return 255}function Awc(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;mi[f[(f[c>>2]|0)+44>>2]&2047](a,c);return}function Bwc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;i=h+11|0;b[i>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;j=auc(e,h)|0;do if((j|0)!=(e+4|0)){k=j+28|0;l=f[k>>2]|0;m=(_i[f[(f[l>>2]|0)+28>>2]&2047](l)|0)+4|0;if((f[m>>2]|0)==(f[6379]|0)){m=f[k>>2]|0;k=Mi[f[(f[m>>2]|0)+20>>2]&1023](m,j+32|0)|0;n=f[k>>2]|0;break}else ig(af(1)|0,22144,0)}else n=-2;while(0);if((b[i>>0]|0)<0)cYc(f[h>>2]|0);h=f[a+4>>2]|0;i=f[(f[h>>2]|0)+48>>2]|0;if((n|0)==-2){ei[i&511](h,c,d,a+20|0);u=g;return}else{ei[i&511](h,c,d,e);u=g;return}}function Cwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;i=auc(a,c)|0;if((i|0)==(a+4|0)){a=af(60)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=19;k=j;l=513362;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+19>>0]=0;j=b[c+11>>0]|0;n=j<<24>>24<0;o=zYc(h,n?f[c>>2]|0:c,n?f[c+4>>2]|0:j&255)|0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];f[g+8>>2]=f[o+8>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;o=$Xc(32)|0;k=o;l=513382;m=k+25|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[o+25>>0]=0;l=zYc(g,o,25)|0;f[e>>2]=f[l>>2];f[e+4>>2]=f[l+4>>2];f[e+8>>2]=f[l+8>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;Dwc(a,e);ig(a|0,22128,1)}a=i+28|0;e=f[a>>2]|0;l=(_i[f[(f[e>>2]|0)+28>>2]&2047](e)|0)+4|0;if((f[l>>2]|0)==(f[6379]|0)){l=f[a>>2]|0;a=Mi[f[(f[l>>2]|0)+20>>2]&1023](l,i+32|0)|0;u=d;return f[a>>2]|0}else ig(af(1)|0,22144,0);return 0}function Dwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d+12|0;g=d;h=e+11|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=$Xc(96)|0;f[g>>2]=i;f[g+8>>2]=-2147483552;f[g+4>>2]=85;j=i;k=513408;l=j+85|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+85>>0]=0;wM(a,0,c,e,g,44);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);if((b[h>>0]|0)>=0){f[a>>2]=173604;u=d;return}cYc(f[e>>2]|0);f[a>>2]=173604;u=d;return}function Ewc(a){a=a|0;qM(a);cYc(a);return}function Fwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0;d=u;u=u+128|0;e=d+48|0;g=d+40|0;h=d+24|0;i=d;j=d+104|0;k=d+92|0;l=d+64|0;m=d+52|0;f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;q=c+84|0;r=f[q>>2]|0;s=~~(+n[c+112>>2]*+(r>>>0));t=(s|0)/10|0;v=(t|0)<1e3?t:1e3;w=+n[c+100>>2];f[i>>2]=r;f[i+4>>2]=s;f[i+8>>2]=v;p[i+16>>3]=w;Hwc(514100,i)|0;if((v|0)<10){Hwc(514197,h)|0;Uwc(h);f[a>>2]=f[h>>2];r=f[h+4>>2]|0;f[a+4>>2]=r;t=h+8|0;x=f[t>>2]|0;f[a+8>>2]=x;y=a+4|0;if(!x){f[a>>2]=y;z=r}else{f[r+8>>2]=y;y=h+4|0;f[h>>2]=y;f[y>>2]=0;f[t>>2]=0;z=0}Ptc(h,z)}else{Jwc(i,q,s);s=c+32|0;f[s>>2]=f[i>>2];f[s+4>>2]=f[i+4>>2];f[s+8>>2]=f[i+8>>2];f[s+12>>2]=f[i+12>>2];Vwc(i,s,v,1);v=c+48|0;f[v>>2]=f[i>>2];f[v+4>>2]=f[i+4>>2];f[v+8>>2]=f[i+8>>2];f[v+12>>2]=f[i+12>>2];Hwc(514233,e)|0;q=f[v>>2]|0;z=bYc(q>>>0>1073741823?-1:q<<2)|0;f[c+64>>2]=q;q=c+68|0;f[q>>2]=1;h=c+72|0;f[h>>2]=1;t=c+76|0;f[t>>2]=z;z=xN()|0;y=J;if(f[v>>2]|0){r=c+60|0;x=c+56|0;A=0;do{B=(f[r>>2]|0)+((Y(f[x>>2]|0,A)|0)<<2)|0;C=(f[t>>2]|0)+((Y(f[h>>2]|0,A)|0)<<2)|0;D=f[q>>2]|0;b[e>>0]=b[i>>0]|0;Kwc(s,B,C,D,0,e);A=A+1|0}while(A>>>0<(f[v>>2]|0)>>>0)}v=xN()|0;A=J;w=(+(v>>>0)+4294967296.0*+(A|0)-(+(z>>>0)+4294967296.0*+(y|0)))/+yN()+0.0;y=l+20|0;f[y>>2]=0;z=l+24|0;f[z>>2]=0;A=l+20|0;v=l+16|0;f[v>>2]=A;n[l>>2]=w;n[l+4>>2]=0.0;n[l+8>>2]=0.0;f[i>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;s=j+11|0;b[s>>0]=9;q=j;h=512094;x=q+9|0;do{b[q>>0]=b[h>>0]|0;q=q+1|0;h=h+1|0}while((q|0)<(x|0));b[j+9>>0]=0;h=l+16|0;q=Ntc(h,e,j)|0;x=f[q>>2]|0;if(!x){r=$Xc(36)|0;D=r+16|0;f[D>>2]=f[j>>2];f[D+4>>2]=f[j+4>>2];f[D+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;D=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=D;f[q>>2]=r;D=f[f[h>>2]>>2]|0;if(!D)E=r;else{f[h>>2]=D;E=f[q>>2]|0}UQ(f[y>>2]|0,E);f[z>>2]=(f[z>>2]|0)+1;F=r}else F=x;x=F+28|0;r=f[x>>2]|0;z=F+32|0;mi[f[f[r>>2]>>2]&2047](r,z);f[x>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,i,z);if((b[s>>0]|0)<0)cYc(f[j>>2]|0);s=f[o>>2]|0;if((s|0)==(f[k+8>>2]|0))Wwc(k,l);else{f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];f[s+8>>2]=f[l+8>>2];f[s+12>>2]=f[l+12>>2];z=s+16|0;f[s+20>>2]=0;f[s+24>>2]=0;x=s+20|0;f[z>>2]=x;r=f[v>>2]|0;if((r|0)==(A|0))G=s;else{s=x;x=r;while(1){r=x+16|0;f[i>>2]=s;f[e>>2]=f[i>>2];Qtc(z,e,r,r)|0;r=f[x+4>>2]|0;if(!r){v=x+8|0;F=f[v>>2]|0;if((f[F>>2]|0)==(x|0))H=F;else{F=v;do{v=f[F>>2]|0;F=v+8|0;E=f[F>>2]|0}while((f[E>>2]|0)!=(v|0));H=E}}else{F=r;while(1){E=f[F>>2]|0;if(!E)break;else F=E}H=F}if((H|0)==(A|0))break;else x=H}G=f[o>>2]|0}f[o>>2]=G+28}Hwc(514261,g)|0;Xwc(c,k);Ywc(c,k);G=f[k>>2]|0;w=+n[G>>2];H=f[o>>2]|0;x=G;if((H|0)!=(x|0)){I=+n[c+104>>2];z=(H-x|0)/28|0;K=+n[G+4>>2]*I+w;L=K<w?K:w;if(z>>>0>1){K=L;x=1;while(1){M=+n[G+(x*28|0)+4>>2]*I+ +n[G+(x*28|0)>>2];N=M<K?M:K;x=x+1|0;if(x>>>0>=z>>>0){O=N;break}else K=N}}else O=L}else O=w;L=w/O;f[m+4>>2]=0;z=m+8|0;f[z>>2]=0;x=m+4|0;f[m>>2]=x;H=f[G+16>>2]|0;s=G+20|0;if((H|0)!=(s|0)){G=x;r=H;while(1){H=r+16|0;f[g>>2]=G;f[e>>2]=f[g>>2];Qtc(m,e,H,H)|0;H=f[r+4>>2]|0;if(!H){E=r+8|0;v=f[E>>2]|0;if((f[v>>2]|0)==(r|0))P=v;else{v=E;do{E=f[v>>2]|0;v=E+8|0;y=f[v>>2]|0}while((f[y>>2]|0)!=(E|0));P=y}}else{v=H;while(1){F=f[v>>2]|0;if(!F)break;else v=F}P=v}if((P|0)==(s|0))break;else r=P}}if(O>0.0?(P=f[o>>2]|0,r=f[k>>2]|0,(P|0)!=(r|0)):0){s=c+104|0;G=c+108|0;H=0;w=L;F=r;r=P;while(1){P=F;L=(+n[P+(H*28|0)+4>>2]*+n[s>>2]+ +n[P+(H*28|0)>>2])/O+ +n[G>>2]*+n[P+(H*28|0)+8>>2];if(L<w){y=P+(H*28|0)+16|0;if((m|0)==(y|0)){Q=r;R=F}else{f[i>>2]=f[y>>2];f[j>>2]=P+(H*28|0)+20;f[g>>2]=f[i>>2];f[e>>2]=f[j>>2];Zwc(m,g,e);Q=f[o>>2]|0;R=f[k>>2]|0}S=L;T=R;U=Q}else{S=w;T=F;U=r}H=H+1|0;if(H>>>0>=((U-T|0)/28|0)>>>0)break;else{w=S;F=T;r=U}}}U=f[t>>2]|0;if(U|0)dYc(U);U=f[c+60>>2]|0;if(U|0)dYc(U);U=f[c+44>>2]|0;if(U|0)dYc(U);f[a>>2]=f[m>>2];U=f[m+4>>2]|0;f[a+4>>2]=U;c=f[z>>2]|0;f[a+8>>2]=c;t=a+4|0;if(!c){f[a>>2]=t;V=U}else{f[U+8>>2]=t;f[m>>2]=x;f[x>>2]=0;f[z>>2]=0;V=0}Ptc(m,V);Ptc(l+16|0,f[A>>2]|0)}A=f[k>>2]|0;if(!A){u=d;return}l=f[o>>2]|0;if((l|0)==(A|0))W=A;else{V=l;do{f[o>>2]=V+-28;Ptc(V+-12|0,f[V+-8>>2]|0);V=f[o>>2]|0}while((V|0)!=(A|0));W=f[k>>2]|0}cYc(W);u=d;return}function Gwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;if((g|0)==(h|0)){u=d;return}a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;j=i<<24>>24<0;k=BM(BM(c,j?f[g>>2]|0:g,j?f[a+20>>2]|0:i&255)|0,514096,3)|0;i=f[a+28>>2]|0;Ti[f[(f[i>>2]|0)+32>>2]&511](i,k,a+32|0);ZNc(e,k+(f[(f[k>>2]|0)+-12>>2]|0)|0);i=DPc(e,896088)|0;j=Mi[f[(f[i>>2]|0)+28>>2]&1023](i,10)|0;EPc(e);sOc(k,j)|0;dOc(k)|0;k=f[a+4>>2]|0;if(!k){j=a+8|0;i=f[j>>2]|0;if((f[i>>2]|0)==(a|0))l=i;else{i=j;do{j=f[i>>2]|0;i=j+8|0;g=f[i>>2]|0}while((f[g>>2]|0)!=(j|0));l=g}}else{i=k;while(1){g=f[i>>2]|0;if(!g)break;else i=g}l=i}if((l|0)==(h|0))break;else a=l}u=d;return}function Hwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=c;if((b[539096]|0)==0?X0c(539096)|0:0){f[223600]=f[46123];f[223601]=3;be(2288,894400,x|0)|0}if((f[223601]|0)<4){g=-1;u=d;return g|0}g=qJc(f[223600]|0,a,e)|0;u=d;return g|0}function Iwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,K=0.0,L=0,M=0;d=u;u=u+96|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d+8|0;j=d;k=d+88|0;l=d+72|0;m=d+56|0;o=a+84|0;q=((f[o>>2]|0)>>>0)/10|0;r=q>>>0<1e3?q:1e3;if((r|0)<=0){s=0.0;u=d;return +s}Jwc(l,o,r);Hwc(513591,e)|0;r=f[l>>2]|0;q=bYc(r>>>0>1073741823?-1:r<<2)|0;f[m>>2]=r;r=m+4|0;f[r>>2]=1;t=m+8|0;v=m+12|0;f[v>>2]=q;f[t>>2]=1;q=xN()|0;w=J;if(f[l>>2]|0){x=l+12|0;y=l+8|0;z=0;do{A=(f[x>>2]|0)+((Y(f[y>>2]|0,z)|0)<<2)|0;B=(f[v>>2]|0)+((Y(f[t>>2]|0,z)|0)<<2)|0;C=f[r>>2]|0;b[e>>0]=b[k>>0]|0;Kwc(o,A,B,C,1,e);z=z+1|0}while(z>>>0<(f[l>>2]|0)>>>0)}z=xN()|0;D=+(z>>>0)+4294967296.0*+(J|0)-(+(q>>>0)+4294967296.0*+(w|0));E=D/+yN()+0.0;Hwc(513615,j)|0;w=a+4|0;q=f[w>>2]|0;if((_i[f[(f[q>>2]|0)+40>>2]&2047](q)|0)==2){Hwc(513644,i)|0;i=f[w>>2]|0;n[j>>2]=0.0;q=i+24|0;z=a+100|0;r=a+116|0;n[q>>2]=0.0;D=+Lwc(i,o,l,m,+n[z>>2],k,r,1,1);t=f[k>>2]|0;n[j>>2]=.20000000298023224;n[q>>2]=.20000000298023224;F=+Lwc(i,o,l,m,+n[z>>2],k,r,1,1);y=D==-1.0|F<D;G=y?F:D;x=y?f[k>>2]|0:t;n[j>>2]=.4000000059604645;n[q>>2]=.4000000059604645;D=+Lwc(i,o,l,m,+n[z>>2],k,r,1,1);t=G==-1.0|D<G;F=t?D:G;C=t?f[k>>2]|0:x;n[j>>2]=.6000000238418579;n[q>>2]=.6000000238418579;G=+Lwc(i,o,l,m,+n[z>>2],k,r,1,1);x=F==-1.0|G<F;D=x?G:F;B=x?f[k>>2]|0:C;n[j>>2]=.800000011920929;n[q>>2]=.800000011920929;F=+Lwc(i,o,l,m,+n[z>>2],k,r,1,1);C=D==-1.0|F<D;G=C?F:D;A=C?f[k>>2]|0:B;n[j>>2]=1.0;n[q>>2]=1.0;D=+Lwc(i,o,l,m,+n[z>>2],k,r,1,1);r=G==-1.0|D<G;F=r?D:G;G=r?1.0:C?.800000011920929:x?.6000000238418579:t?.4000000059604645:y?.20000000298023224:0.0;y=r?f[k>>2]|0:A;n[j>>2]=G;f[k>>2]=y;n[q>>2]=G;p[h>>3]=G;Hwc(513696,h)|0;q=a+8|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=h+11|0;b[y>>0]=8;A=h;f[A>>2]=1767858787;f[A+4>>2]=2019910766;b[h+8>>0]=0;A=Ntc(q,e,h)|0;r=f[A>>2]|0;if(!r){t=$Xc(36)|0;x=t+16|0;f[x>>2]=f[h>>2];f[x+4>>2]=f[h+4>>2];f[x+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;x=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=x;f[A>>2]=t;x=f[f[q>>2]>>2]|0;if(!x)H=t;else{f[q>>2]=x;H=f[A>>2]|0}UQ(f[a+12>>2]|0,H);H=a+16|0;f[H>>2]=(f[H>>2]|0)+1;I=t}else I=r;r=I+28|0;t=f[r>>2]|0;H=I+32|0;mi[f[f[t>>2]>>2]&2047](t,H);f[r>>2]=173484;Ti[f[(f[43371]|0)+4>>2]&511](173484,j,H);if((b[y>>0]|0)<0)cYc(f[h>>2]|0);K=F}else K=+Lwc(f[w>>2]|0,o,l,m,+n[a+100>>2],k,a+116|0,1,1);f[g>>2]=f[k>>2];Hwc(513718,g)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=g+11|0;b[a>>0]=6;b[g>>0]=b[512787]|0;b[g+1>>0]=b[512788]|0;b[g+2>>0]=b[512789]|0;b[g+3>>0]=b[512790]|0;b[g+4>>0]=b[512791]|0;b[g+5>>0]=b[512792]|0;b[g+6>>0]=0;m=Ntc(c,e,g)|0;o=f[m>>2]|0;if(!o){w=$Xc(36)|0;h=w+16|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[w+28>>2]=172888;f[w+32>>2]=0;h=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=h;f[m>>2]=w;h=f[f[c>>2]>>2]|0;if(!h)L=w;else{f[c>>2]=h;L=f[m>>2]|0}UQ(f[c+4>>2]|0,L);L=c+8|0;f[L>>2]=(f[L>>2]|0)+1;M=w}else M=o;o=M+28|0;w=f[o>>2]|0;L=M+32|0;mi[f[f[w>>2]>>2]&2047](w,L);f[o>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,k,L);if((b[a>>0]|0)<0)cYc(f[g>>2]|0);g=f[v>>2]|0;if(g|0)dYc(g);g=f[l+12>>2]|0;if(g|0)dYc(g);s=E/K;u=d;return +s}function Jwc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+32|0;e=d;jvc(e,f[b>>2]|0);g=b+4|0;h=f[g>>2]|0;i=Y(h,c)|0;j=bYc(i>>>0>1073741823?-1:i<<2)|0;f[a>>2]=c;f[a+4>>2]=h;i=a+8|0;f[a+12>>2]=j;f[i>>2]=h;if(!c)k=e;else{h=e+16|0;a=e+12|0;l=b+12|0;m=b+8|0;b=0;do{n=f[h>>2]|0;if((n|0)==(f[a>>2]|0))o=-1;else{f[h>>2]=n+1;o=f[(f[e>>2]|0)+(n<<2)>>2]|0}n=f[g>>2]|0;if(n|0){p=(f[l>>2]|0)+((Y(f[m>>2]|0,o)|0)<<2)|0;q1c(j+((Y(f[i>>2]|0,b)|0)<<2)|0,p|0,n<<2|0)|0}b=b+1|0}while((b|0)!=(c|0));k=e}c=f[k>>2]|0;if(!c){u=d;return}k=e+4|0;e=f[k>>2]|0;if((e|0)!=(c|0))f[k>>2]=e+(~((e+-4-c|0)>>>2)<<2);cYc(c);u=d;return}function Kwc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0;g=u;u=u+32|0;h=g+12|0;i=g;j=e+d|0;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;l=(j|0)==0;do if(!l)if(j>>>0>1073741823)kWc(h);else{m=j<<2;o=$Xc(m)|0;f[h>>2]=o;p=o+(j<<2)|0;f[h+8>>2]=p;g1c(o|0,0,m|0)|0;f[k>>2]=p;q=p;r=o;break}else{q=0;r=0}while(0);f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;if(l){s=0;t=0}else{l=j<<2;p=$Xc(l)|0;f[i>>2]=p;m=p+(j<<2)|0;f[i+8>>2]=m;g1c(p|0,0,l|0)|0;f[o>>2]=m;s=m;t=p}p=f[a+12>>2]|0;m=a+8|0;l=a+4|0;v=p+(f[l>>2]<<2)|0;w=v+-12|0;x=((w>>>0<p>>>0?p:w)+12+(3-p)|0)>>>4<<2;y=b+(x<<2)|0;if(p>>>0<w>>>0){z=p;A=b;B=0.0;while(1){C=+L(+(+n[z>>2]-+n[A>>2]));D=+L(+(+n[z+4>>2]-+n[A+4>>2]));E=+L(+(+n[z+8>>2]-+n[A+8>>2]));F=B+(C+D+E+ +L(+(+n[z+12>>2]-+n[A+12>>2])));z=z+16|0;if(z>>>0>=w>>>0){G=F;break}else{A=A+16|0;B=F}}}else G=0.0;A=p+(x<<2)|0;if(A>>>0<v>>>0){x=y;B=G;y=A;while(1){F=B+ +L(+(+n[y>>2]-+n[x>>2]));y=y+4|0;if(y>>>0>=v>>>0){H=F;break}else{x=x+4|0;B=F}}}else H=G;n[t>>2]=H;f[r>>2]=0;if((f[a>>2]|0)>>>0>1){x=f[h>>2]|0;v=f[i>>2]|0;i=1;y=1;while(1){A=p+((Y(f[m>>2]|0,y)|0)<<2)|0;w=A+(f[l>>2]<<2)|0;z=w+-12|0;I=((z>>>0<A>>>0?A:z)+12+(3-A)|0)>>>4<<2;J=b+(I<<2)|0;if(A>>>0<z>>>0){K=A;M=b;H=0.0;while(1){G=+L(+(+n[K>>2]-+n[M>>2]));B=+L(+(+n[K+4>>2]-+n[M+4>>2]));F=+L(+(+n[K+8>>2]-+n[M+8>>2]));E=H+(G+B+F+ +L(+(+n[K+12>>2]-+n[M+12>>2])));K=K+16|0;if(K>>>0>=z>>>0){N=E;break}else{M=M+16|0;H=E}}}else N=0.0;M=A+(I<<2)|0;if(M>>>0<w>>>0){z=J;H=N;K=M;while(1){E=H+ +L(+(+n[K>>2]-+n[z>>2]));K=K+4|0;if(K>>>0>=w>>>0){O=E;break}else{z=z+4|0;H=E}}}else O=N;if((i|0)>=(j|0)){z=i+-1|0;w=v+(z<<2)|0;if(O<+n[w>>2]){n[w>>2]=O;f[x+(z<<2)>>2]=y;P=i}else P=i}else{f[x+(i<<2)>>2]=y;n[v+(i<<2)>>2]=O;P=i+1|0}a:do if((P|0)>1){z=P;do{w=z;z=z+-1|0;K=v+(z<<2)|0;H=+n[K>>2];J=w+-2|0;w=v+(J<<2)|0;E=+n[w>>2];if(!(H<E))break a;n[K>>2]=E;n[w>>2]=H;w=x+(z<<2)|0;K=x+(J<<2)|0;J=f[w>>2]|0;f[w>>2]=f[K>>2];f[K>>2]=J}while((z|0)>1)}while(0);y=y+1|0;if(y>>>0>=(f[a>>2]|0)>>>0){Q=v;R=x;break}else i=P}}else{Q=t;R=r}if((d|0)>0){r=f[h>>2]|0;h=0;do{f[c+(h<<2)>>2]=f[r+(h+e<<2)>>2];h=h+1|0}while((h|0)!=(d|0));S=r}else S=R;if(Q|0){if((s|0)!=(Q|0))f[o>>2]=s+(~((s+-4-Q|0)>>>2)<<2);cYc(Q)}if(!S){u=g;return}if((q|0)!=(S|0))f[k>>2]=q+(~((q+-4-S|0)>>>2)<<2);cYc(S);u=g;return}function Lwc(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0;k=u;u=u+48|0;l=k+40|0;m=k+32|0;o=k+24|0;p=k+8|0;q=k;Hwc(513750,q)|0;Hwc(513809,p)|0;r=+Mwc(a,b,c,d,i,1,p,q,h,j);if(r>e){Hwc(513868,k+16|0)|0;s=1;f[g>>2]=s;t=+n[p>>2];u=k;return +t}if(r<e){v=1;while(1){w=v<<1;x=+Mwc(a,b,c,d,i,w,p,q,h,j);if(x<e)v=w;else{y=v;z=x;A=w;break}}}else{y=1;z=r;A=1}if(!(+L(+(z-e))>1.0000000474974513e-03)){Hwc(513916,l)|0;s=A;f[g>>2]=s;t=+n[p>>2];u=k;return +t}Hwc(513891,o)|0;o=y;l=A;v=(y+A|0)/2|0;do{z=+Mwc(a,b,c,d,i,v,p,q,h,j);if(!(+L(+(z-e))>1.0000000474974513e-03)){s=v;B=11;break}A=z<e;l=A?l:v;o=A?v:o;v=(o+l|0)/2|0}while((v|0)!=(o|0));if((B|0)==11){f[g>>2]=s;t=+n[p>>2];u=k;return +t}Hwc(513868,m)|0;s=o;f[g>>2]=s;t=+n[p>>2];u=k;return +t}function Mwc(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,K=0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0;l=u;u=u+96|0;m=l+8|0;o=l;q=l+72|0;r=l+60|0;s=l+48|0;t=f[d+4>>2]|0;if(t>>>0<e>>>0){f[o>>2]=t;f[o+4>>2]=e;Hwc(513947,o)|0;o=af(60)|0;Jtc(o,513971);ig(o|0,22128,1)}o=k+e|0;f[q>>2]=173624;t=q+12|0;f[t>>2]=o;v=q+16|0;f[v>>2]=0;Yvc(r,g,0.0,1);f[s>>2]=0;w=s+4|0;f[w>>2]=0;f[s+8>>2]=0;do if(o)if(o>>>0>1073741823)kWc(s);else{x=o<<2;y=$Xc(x)|0;f[s>>2]=y;z=y+(o<<2)|0;f[s+8>>2]=z;g1c(y|0,0,x|0)|0;f[w>>2]=z;z=o<<2;x=$Xc(z)|0;g1c(x|0,0,z|0)|0;A=x;B=y;C=x;break}else{A=0;B=0;C=0}while(0);o=B+(k<<2)|0;k=q+4|0;B=q+8|0;x=q+20|0;y=c+12|0;z=c+8|0;D=d+12|0;E=d+8|0;d=(e|0)>0;F=c+4|0;G=0;H=0.0;do{G=G+1|0;I=xN()|0;K=J;a:do if(!(f[c>>2]|0)){L=0.0;M=0.0}else{if(d){N=0;O=0.0;P=0}else{Q=0;R=0.0;while(1){f[k>>2]=f[s>>2];f[B>>2]=C;f[v>>2]=0;n[x>>2]=3402823466385288598117041.0e14;n[C+((f[t>>2]|0)+-1<<2)>>2]=3402823466385288598117041.0e14;S=(f[y>>2]|0)+((Y(f[z>>2]|0,Q)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,q,S,r);S=(f[y>>2]|0)+((Y(f[z>>2]|0,Q)|0)<<2)|0;T=(f[D>>2]|0)+((Y(f[E>>2]|0,Q)|0)<<2)|0;U=R+ +Nwc(b,S,o,T,f[F>>2]|0,e,j);Q=Q+1|0;if(Q>>>0>=(f[c>>2]|0)>>>0){L=U;M=0.0;break a}else R=U}}do{f[k>>2]=f[s>>2];f[B>>2]=C;f[v>>2]=0;n[x>>2]=3402823466385288598117041.0e14;n[C+((f[t>>2]|0)+-1<<2)>>2]=3402823466385288598117041.0e14;Q=(f[y>>2]|0)+((Y(f[z>>2]|0,N)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,q,Q,r);Q=(f[D>>2]|0)+((Y(f[E>>2]|0,N)|0)<<2)|0;T=0;S=0;while(1){V=f[o+(T<<2)>>2]|0;W=0;while(1){if((V|0)==(f[Q+(W<<2)>>2]|0)){X=14;break}W=W+1|0;if((W|0)>=(e|0)){Z=S;break}}if((X|0)==14){X=0;Z=S+1|0}T=T+1|0;if((T|0)==(e|0))break;else S=Z}P=Z+P|0;S=(f[y>>2]|0)+((Y(f[z>>2]|0,N)|0)<<2)|0;O=O+ +Nwc(b,S,o,Q,f[F>>2]|0,e,j);N=N+1|0}while(N>>>0<(f[c>>2]|0)>>>0);L=O;M=+(P|0)}while(0);S=xN()|0;T=J;H=H+(+(S>>>0)+4294967296.0*+(T|0)-(+(I>>>0)+4294967296.0*+(K|0)))/+yN()}while(H<.2);n[h>>2]=H/+(G|0);G=f[c>>2]|0;H=+((Y(G,e)|0)>>>0);O=M/H;M=L/H;n[i>>2]=M;H=+n[h>>2];f[m>>2]=g;p[m+8>>3]=O;p[m+16>>3]=H;p[m+24>>3]=H*1.0e3/+(G>>>0);p[m+32>>3]=M;Hwc(514035,m)|0;if(C|0)cYc(A);A=f[s>>2]|0;if(!A){_=r+4|0;$=f[_>>2]|0;Ptc(r,$);u=l;return +O}s=f[w>>2]|0;if((s|0)!=(A|0))f[w>>2]=s+(~((s+-4-A|0)>>>2)<<2);cYc(A);_=r+4|0;$=f[_>>2]|0;Ptc(r,$);u=l;return +O}function Nwc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;if((g|0)<=0){i=0.0;return +i}h=f[a+12>>2]|0;j=f[a+8>>2]|0;a=0;k=0.0;while(1){l=h+((Y(j,f[d+(a<<2)>>2]|0)|0)<<2)|0;m=l+(e<<2)|0;o=m+-12|0;p=((o>>>0<l>>>0?l:o)+12+(3-l)|0)>>>4<<2;q=b+(p<<2)|0;if(l>>>0<o>>>0){r=l;s=b;t=0.0;while(1){u=+L(+(+n[r>>2]-+n[s>>2]));v=+L(+(+n[r+4>>2]-+n[s+4>>2]));w=+L(+(+n[r+8>>2]-+n[s+8>>2]));x=t+(u+v+w+ +L(+(+n[r+12>>2]-+n[s+12>>2])));r=r+16|0;if(r>>>0>=o>>>0){y=x;break}else{s=s+16|0;t=x}}}else y=0.0;s=l+(p<<2)|0;if(s>>>0<m>>>0){o=q;t=y;r=s;while(1){x=t+ +L(+(+n[r>>2]-+n[o>>2]));r=r+4|0;if(r>>>0>=m>>>0){z=x;break}else{o=o+4|0;t=x}}}else z=y;o=h+((Y(j,f[c+(a<<2)>>2]|0)|0)<<2)|0;m=o+(e<<2)|0;r=m+-12|0;q=((r>>>0<o>>>0?o:r)+12+(3-o)|0)>>>4<<2;p=b+(q<<2)|0;if(o>>>0<r>>>0){l=o;s=b;t=0.0;while(1){x=+L(+(+n[l>>2]-+n[s>>2]));w=+L(+(+n[l+4>>2]-+n[s+4>>2]));v=+L(+(+n[l+8>>2]-+n[s+8>>2]));u=t+(x+w+v+ +L(+(+n[l+12>>2]-+n[s+12>>2])));l=l+16|0;if(l>>>0>=r>>>0){A=u;break}else{s=s+16|0;t=u}}}else A=0.0;s=o+(q<<2)|0;if(s>>>0<m>>>0){r=p;t=A;l=s;while(1){u=t+ +L(+(+n[l>>2]-+n[r>>2]));l=l+4|0;if(l>>>0>=m>>>0){B=u;break}else{r=r+4|0;t=u}}}else B=A;t=k+(z==0.0&B==0.0?1.0:B/z);a=a+1|0;if((a|0)==(g|0)){i=t;break}else k=t}return +i}function Owc(a){a=a|0;return}function Pwc(a){a=a|0;cYc(a);return}function Qwc(a){a=a|0;return (f[a+16>>2]|0)==(f[a+12>>2]|0)|0}function Rwc(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0;d=a+20|0;if(+n[d>>2]<=b)return;e=a+16|0;g=f[e>>2]|0;h=a+8|0;i=g;while(1){if((i|0)<=0)break;j=f[h>>2]|0;k=i+-1|0;l=+n[j+(k<<2)>>2];if(!(l<=b))i=k;else{m=5;break}}a:do if((m|0)==5?l==b:0){o=f[a+4>>2]|0;p=k;while(1){if((f[o+(p<<2)>>2]|0)==(c|0))break;if((p|0)<=0)break a;p=p+-1|0;if(!(+n[j+(p<<2)>>2]==b))break a}return}while(0);j=a+12|0;if((g|0)<(f[j>>2]|0)){k=g+1|0;f[e>>2]=k;q=k}else q=g;g=q+-1|0;k=f[h>>2]|0;h=f[a+4>>2]|0;if((g|0)>(i|0)){a=q;q=g;while(1){g=a+-2|0;f[k+(q<<2)>>2]=f[k+(g<<2)>>2];f[h+(q<<2)>>2]=f[h+(g<<2)>>2];g=q+-1|0;if((g|0)>(i|0)){e=q;q=g;a=e}else break}}n[k+(i<<2)>>2]=b;f[h+(i<<2)>>2]=c;f[d>>2]=f[k+((f[j>>2]|0)+-1<<2)>>2];return}function Swc(a){a=a|0;return +(+n[a+20>>2])}function Twc(a){a=a|0;var b=0;b=f[a>>2]|0;if((b|0)==0|(b|0)==(f[46123]|0))return;oKc(b)|0;return}function Uwc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c+16|0;e=c+12|0;g=c;h=a+4|0;f[h>>2]=0;i=a+8|0;f[i>>2]=0;f[a>>2]=a+4;f[e>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=9;k=g;l=512094;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[g+9>>0]=0;l=Ntc(a,d,g)|0;k=f[l>>2]|0;if(!k){m=$Xc(36)|0;n=m+16|0;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[m+28>>2]=172888;f[m+32>>2]=0;n=f[d>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=n;f[l>>2]=m;n=f[f[a>>2]>>2]|0;if(!n)o=m;else{f[a>>2]=n;o=f[l>>2]|0}UQ(f[h>>2]|0,o);f[i>>2]=(f[i>>2]|0)+1;p=m}else p=k;k=p+28|0;m=f[k>>2]|0;i=p+32|0;mi[f[f[m>>2]>>2]&2047](m,i);f[k>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,e,i);if((b[j>>0]|0)>=0){u=c;return}cYc(f[g>>2]|0);u=c;return}function Vwc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;e=b+4|0;g=f[e>>2]|0;h=Y(g,c)|0;i=bYc(h>>>0>1073741823?-1:h<<2)|0;f[a>>2]=c;f[a+4>>2]=g;h=a+8|0;f[a+12>>2]=i;f[h>>2]=g;a:do if((c|0)>0){g=b+12|0;a=b+8|0;if(d)j=0;else{k=0;while(1){l=f[b>>2]|0;m=OR()|0;n=m;o=f[n+4>>2]|0;p=x1c(f[n>>2]|0,0,-130063606,0)|0;n=d1c(p|0,J|0,o|0,0)|0;o=m;f[o>>2]=n;f[o+4>>2]=J;o=f[e>>2]|0;if(o|0){m=(f[g>>2]|0)+((Y(f[a>>2]|0,~~(+(l-k|0)*(+(n&2147483647|0)*4.656612873077393e-10)))|0)<<2)|0;q1c(i+((Y(f[h>>2]|0,k)|0)<<2)|0,m|0,o<<2|0)|0}k=k+1|0;if((k|0)==(c|0))break a}}do{q=+((f[b>>2]|0)-j|0);k=OR()|0;o=k;m=f[o+4>>2]|0;n=x1c(f[o>>2]|0,0,-130063606,0)|0;o=d1c(n|0,J|0,m|0,0)|0;m=k;f[m>>2]=o;f[m+4>>2]=J;m=~~(q*(+(o&2147483647|0)*4.656612873077393e-10));o=f[e>>2]|0;if(o|0?(k=(f[g>>2]|0)+((Y(f[a>>2]|0,m)|0)<<2)|0,q1c(i+((Y(f[h>>2]|0,j)|0)<<2)|0,k|0,o<<2|0)|0,o=f[e>>2]|0,k=f[g>>2]|0,n=f[a>>2]|0,o|0):0)q1c(k+((Y(n,m)|0)<<2)|0,k+((Y((f[b>>2]|0)+~j|0,n)|0)<<2)|0,o<<2|0)|0;j=j+1|0}while((j|0)!=(c|0))}while(0);if(!d)return;f[b>>2]=(f[b>>2]|0)-c;return}function Wwc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[a>>2]|0;j=(h-i|0)/28|0;k=j+1|0;l=i;m=h;if(k>>>0>153391689)kWc(a);h=a+8|0;n=((f[h>>2]|0)-i|0)/28|0;i=n<<1;o=n>>>0<76695844?(i>>>0<k>>>0?k:i):153391689;do if(o)if(o>>>0>153391689){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{p=$Xc(o*28|0)|0;break}else p=0;while(0);i=p+(j*28|0)|0;k=i;n=p+(o*28|0)|0;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];o=p+(j*28|0)+16|0;f[p+(j*28|0)+20>>2]=0;f[p+(j*28|0)+24>>2]=0;q=p+(j*28|0)+20|0;f[o>>2]=q;j=f[b+16>>2]|0;p=b+20|0;if((j|0)==(p|0)){r=m;s=l}else{l=q;q=j;while(1){j=q+16|0;f[e>>2]=l;f[d>>2]=f[e>>2];Qtc(o,d,j,j)|0;j=f[q+4>>2]|0;if(!j){m=q+8|0;b=f[m>>2]|0;if((f[b>>2]|0)==(q|0))t=b;else{b=m;do{m=f[b>>2]|0;b=m+8|0;v=f[b>>2]|0}while((f[v>>2]|0)!=(m|0));t=v}}else{b=j;while(1){v=f[b>>2]|0;if(!v)break;else b=v}t=b}if((t|0)==(p|0))break;else q=t}r=f[g>>2]|0;s=f[a>>2]|0}t=i+28|0;if((r|0)==(s|0)){w=k;x=r;y=r}else{q=r;r=k;k=i;do{i=k+-28|0;p=q;q=q+-28|0;f[i>>2]=f[q>>2];f[i+4>>2]=f[q+4>>2];f[i+8>>2]=f[q+8>>2];f[i+12>>2]=f[q+12>>2];i=k+-12|0;d=p+-12|0;f[i>>2]=f[d>>2];o=f[p+-8>>2]|0;f[k+-8>>2]=o;e=p+-4|0;l=f[e>>2]|0;f[k+-4>>2]=l;j=k+-8|0;if(!l)f[i>>2]=j;else{f[o+8>>2]=j;j=p+-8|0;f[d>>2]=j;f[j>>2]=0;f[e>>2]=0}k=r+-28|0;r=k}while((q|0)!=(s|0));w=r;x=f[a>>2]|0;y=f[g>>2]|0}f[a>>2]=w;f[g>>2]=t;f[h>>2]=n;n=x;if((y|0)!=(n|0)){h=y;do{Ptc(h+-12|0,f[h+-8>>2]|0);h=h+-28|0}while((h|0)!=(n|0))}if(!x){u=c;return}cYc(x);u=c;return}function Xwc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+96|0;e=d;g=d+80|0;h=d+64|0;i=d+44|0;j=d+16|0;k=d+4|0;Hwc(514784,e)|0;f[h>>2]=f[43445];f[h+4>>2]=f[43446];f[h+8>>2]=f[43447];f[h+12>>2]=f[43448];f[i>>2]=f[43449];f[i+4>>2]=f[43450];f[i+8>>2]=f[43451];f[i+12>>2]=f[43452];f[i+16>>2]=f[43453];l=c+4|0;Hxc(c,(((f[l>>2]|0)-(f[c>>2]|0)|0)/28|0)+20|0);m=j+20|0;n=j+24|0;o=j+20|0;p=j+16|0;q=j+16|0;r=k+11|0;s=k+9|0;t=k+8|0;v=k+4|0;w=k+11|0;x=g+11|0;y=g+10|0;z=g+11|0;A=g+9|0;B=c+8|0;C=j+16|0;D=0;do{E=h+(D<<2)|0;F=0;do{f[m>>2]=0;f[n>>2]=0;f[p>>2]=o;f[g>>2]=2;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[r>>0]=9;G=k;H=512094;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[s>>0]=0;J=Ntc(q,e,k)|0;K=f[J>>2]|0;if(!K){L=$Xc(36)|0;M=L+16|0;f[M>>2]=f[k>>2];f[M+4>>2]=f[k+4>>2];f[M+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[L+28>>2]=172888;f[L+32>>2]=0;M=f[e>>2]|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=M;f[J>>2]=L;M=f[f[q>>2]>>2]|0;if(!M)N=L;else{f[q>>2]=M;N=f[J>>2]|0}UQ(f[m>>2]|0,N);f[n>>2]=(f[n>>2]|0)+1;O=L}else O=K;K=O+28|0;L=f[K>>2]|0;J=O+32|0;mi[f[f[L>>2]>>2]&2047](L,J);f[K>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,J);if((b[r>>0]|0)<0)cYc(f[k>>2]|0);f[g>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;J=$Xc(16)|0;f[k>>2]=J;f[t>>2]=-2147483632;f[v>>2]=12;G=J;H=512677;I=G+12|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[J+12>>0]=0;K=Ntc(q,e,k)|0;L=f[K>>2]|0;if(!L){M=$Xc(36)|0;P=M+16|0;f[P>>2]=f[k>>2];f[P+4>>2]=f[k+4>>2];f[P+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[M+28>>2]=172888;f[M+32>>2]=0;P=f[e>>2]|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=P;f[K>>2]=M;P=f[f[q>>2]>>2]|0;if(!P)Q=M;else{f[q>>2]=P;Q=f[K>>2]|0}UQ(f[m>>2]|0,Q);f[n>>2]=(f[n>>2]|0)+1;R=M}else R=L;L=R+28|0;M=f[L>>2]|0;K=R+32|0;mi[f[f[M>>2]>>2]&2047](M,K);f[L>>2]=173316;Ti[f[(f[43329]|0)+4>>2]&511](173316,g,K);if((b[w>>0]|0)<0)cYc(f[k>>2]|0);b[x>>0]=10;G=g;H=514827;I=G+10|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[y>>0]=0;J=Ntc(q,e,g)|0;K=f[J>>2]|0;if(!K){L=$Xc(36)|0;M=L+16|0;f[M>>2]=f[g>>2];f[M+4>>2]=f[g+4>>2];f[M+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[L+28>>2]=172888;f[L+32>>2]=0;M=f[e>>2]|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=M;f[J>>2]=L;M=f[f[q>>2]>>2]|0;if(!M)S=L;else{f[q>>2]=M;S=f[J>>2]|0}UQ(f[m>>2]|0,S);f[n>>2]=(f[n>>2]|0)+1;T=L}else T=K;K=T+28|0;L=f[K>>2]|0;J=T+32|0;mi[f[f[L>>2]>>2]&2047](L,J);f[K>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,E,J);if((b[x>>0]|0)<0)cYc(f[g>>2]|0);J=i+(F<<2)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[z>>0]=9;G=g;H=512667;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));b[A>>0]=0;H=Ntc(q,e,g)|0;G=f[H>>2]|0;if(!G){I=$Xc(36)|0;K=I+16|0;f[K>>2]=f[g>>2];f[K+4>>2]=f[g+4>>2];f[K+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[I+28>>2]=172888;f[I+32>>2]=0;K=f[e>>2]|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=K;f[H>>2]=I;K=f[f[q>>2]>>2]|0;if(!K)U=I;else{f[q>>2]=K;U=f[H>>2]|0}UQ(f[m>>2]|0,U);f[n>>2]=(f[n>>2]|0)+1;V=I}else V=G;G=V+28|0;I=f[G>>2]|0;H=V+32|0;mi[f[f[I>>2]>>2]&2047](I,H);f[G>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,J,H);if((b[z>>0]|0)<0)cYc(f[g>>2]|0);Ixc(a,j);H=f[l>>2]|0;if((H|0)==(f[B>>2]|0))Wwc(c,j);else{f[H>>2]=f[j>>2];f[H+4>>2]=f[j+4>>2];f[H+8>>2]=f[j+8>>2];f[H+12>>2]=f[j+12>>2];G=H+16|0;f[H+20>>2]=0;f[H+24>>2]=0;I=H+20|0;f[G>>2]=I;H=f[p>>2]|0;if((H|0)!=(o|0)){K=I;I=H;while(1){H=I+16|0;f[g>>2]=K;f[e>>2]=f[g>>2];Qtc(G,e,H,H)|0;H=f[I+4>>2]|0;if(!H){L=I+8|0;M=f[L>>2]|0;if((f[M>>2]|0)==(I|0))W=M;else{M=L;do{L=f[M>>2]|0;M=L+8|0;P=f[M>>2]|0}while((f[P>>2]|0)!=(L|0));W=P}}else{M=H;while(1){P=f[M>>2]|0;if(!P)break;else M=P}W=M}if((W|0)==(o|0))break;else I=W}}f[l>>2]=(f[l>>2]|0)+28}Ptc(C,f[o>>2]|0);F=F+1|0}while(F>>>0<5);D=D+1|0}while(D>>>0<4);u=d;return}function Ywc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+80|0;e=d;g=d+64|0;h=d+44|0;i=d+16|0;j=d+4|0;Hwc(514287,e)|0;f[h>>2]=f[43411];f[h+4>>2]=f[43412];f[h+8>>2]=f[43413];f[h+12>>2]=f[43414];f[h+16>>2]=f[43415];k=i+20|0;l=i+24|0;m=i+20|0;n=i+16|0;o=i+16|0;p=j+11|0;q=j+9|0;r=g+11|0;s=g+5|0;t=c+4|0;v=c+8|0;w=i+16|0;x=0;do{f[k>>2]=0;f[l>>2]=0;f[n>>2]=m;f[g>>2]=1;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[p>>0]=9;y=j;z=512094;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[q>>0]=0;z=Ntc(o,e,j)|0;y=f[z>>2]|0;if(!y){A=$Xc(36)|0;B=A+16|0;f[B>>2]=f[j>>2];f[B+4>>2]=f[j+4>>2];f[B+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[A+28>>2]=172888;f[A+32>>2]=0;B=f[e>>2]|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=B;f[z>>2]=A;B=f[f[o>>2]>>2]|0;if(!B)C=A;else{f[o>>2]=B;C=f[z>>2]|0}UQ(f[k>>2]|0,C);f[l>>2]=(f[l>>2]|0)+1;D=A}else D=y;y=D+28|0;A=f[y>>2]|0;z=D+32|0;mi[f[f[A>>2]>>2]&2047](A,z);f[y>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,z);if((b[p>>0]|0)<0)cYc(f[j>>2]|0);z=h+(x<<2)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[r>>0]=5;b[g>>0]=b[512723]|0;b[g+1>>0]=b[512724]|0;b[g+2>>0]=b[512725]|0;b[g+3>>0]=b[512726]|0;b[g+4>>0]=b[512727]|0;b[s>>0]=0;y=Ntc(o,e,g)|0;A=f[y>>2]|0;if(!A){B=$Xc(36)|0;E=B+16|0;f[E>>2]=f[g>>2];f[E+4>>2]=f[g+4>>2];f[E+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[B+28>>2]=172888;f[B+32>>2]=0;E=f[e>>2]|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=E;f[y>>2]=B;E=f[f[o>>2]>>2]|0;if(!E)F=B;else{f[o>>2]=E;F=f[y>>2]|0}UQ(f[k>>2]|0,F);f[l>>2]=(f[l>>2]|0)+1;G=B}else G=A;A=G+28|0;B=f[A>>2]|0;y=G+32|0;mi[f[f[B>>2]>>2]&2047](B,y);f[A>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,z,y);if((b[r>>0]|0)<0)cYc(f[g>>2]|0);$wc(a,i);y=f[t>>2]|0;if((y|0)==(f[v>>2]|0))Wwc(c,i);else{f[y>>2]=f[i>>2];f[y+4>>2]=f[i+4>>2];f[y+8>>2]=f[i+8>>2];f[y+12>>2]=f[i+12>>2];z=y+16|0;f[y+20>>2]=0;f[y+24>>2]=0;A=y+20|0;f[z>>2]=A;y=f[n>>2]|0;if((y|0)!=(m|0)){B=A;A=y;while(1){y=A+16|0;f[g>>2]=B;f[e>>2]=f[g>>2];Qtc(z,e,y,y)|0;y=f[A+4>>2]|0;if(!y){E=A+8|0;H=f[E>>2]|0;if((f[H>>2]|0)==(A|0))I=H;else{H=E;do{E=f[H>>2]|0;H=E+8|0;J=f[H>>2]|0}while((f[J>>2]|0)!=(E|0));I=J}}else{H=y;while(1){J=f[H>>2]|0;if(!J)break;else H=J}I=H}if((I|0)==(m|0))break;else A=I}}f[t>>2]=(f[t>>2]|0)+28}Ptc(w,f[m>>2]|0);x=x+1|0}while(x>>>0<5);u=d;return}function Zwc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=a+8|0;a:do if(f[e>>2]|0?(g=f[a>>2]|0,h=a+4|0,f[a>>2]=h,f[(f[h>>2]|0)+8>>2]=0,f[h>>2]=0,f[e>>2]=0,i=f[g+4>>2]|0,j=(i|0)==0?g:i,j|0):0){i=a+4|0;g=j;j=f[c>>2]|0;while(1){if((j|0)==(f[d>>2]|0))break;k=g+16|0;oYc(k,j+16|0)|0;l=g+28|0;m=f[l>>2]|0;n=g+32|0;mi[f[f[m>>2]>>2]&2047](m,n);f[l>>2]=172888;m=f[j+28>>2]|0;f[l>>2]=m;Ti[f[(f[m>>2]|0)+8>>2]&511](m,j+32|0,n);n=g+8|0;m=f[n>>2]|0;do if(m){l=f[m>>2]|0;if((l|0)==(g|0)){f[m>>2]=0;o=f[m+4>>2]|0;if(!o){p=m;break}else q=o;while(1){o=f[q>>2]|0;if(o|0){q=o;continue}o=f[q+4>>2]|0;if(!o)break;else q=o}p=q;break}else{f[m+4>>2]=0;if(!l){p=m;break}else r=l;while(1){o=f[r>>2]|0;if(o|0){r=o;continue}o=f[r+4>>2]|0;if(!o)break;else r=o}p=r;break}}else p=0;while(0);m=f[h>>2]|0;do if(m){l=b[k+11>>0]|0;o=l<<24>>24<0;s=o?f[g+20>>2]|0:l&255;l=o?f[k>>2]|0:k;o=m;while(1){t=o+16|0;u=b[t+11>>0]|0;v=u<<24>>24<0;w=v?f[o+20>>2]|0:u&255;u=w>>>0<s>>>0?w:s;if((u|0)!=0?(x=WKc(l,v?f[t>>2]|0:t,u)|0,(x|0)!=0):0)if((x|0)<0)y=24;else y=26;else if(s>>>0<w>>>0)y=24;else y=26;if((y|0)==24){y=0;w=f[o>>2]|0;if(!w){y=25;break}else z=w}else if((y|0)==26){y=0;A=o+4|0;w=f[A>>2]|0;if(!w){y=28;break}else z=w}o=z}if((y|0)==25){y=0;B=o;C=o;break}else if((y|0)==28){y=0;B=A;C=o;break}}else{B=h;C=h}while(0);f[g>>2]=0;f[g+4>>2]=0;f[n>>2]=C;f[B>>2]=g;m=f[f[a>>2]>>2]|0;if(!m)D=g;else{f[a>>2]=m;D=f[B>>2]|0}UQ(f[i>>2]|0,D);f[e>>2]=(f[e>>2]|0)+1;m=f[j+4>>2]|0;if(!m){k=j+8|0;s=f[k>>2]|0;if((f[s>>2]|0)==(j|0))E=s;else{s=k;do{k=f[s>>2]|0;s=k+8|0;l=f[s>>2]|0}while((f[l>>2]|0)!=(k|0));E=l}}else{s=m;while(1){n=f[s>>2]|0;if(!n)break;else s=n}E=s}f[c>>2]=E;if(!p)break a;else{g=p;j=E}}j=f[g+8>>2]|0;if(!j)F=g;else{i=j;while(1){j=f[i+8>>2]|0;if(!j)break;else i=j}F=i}Ptc(a,F)}while(0);F=f[c>>2]|0;E=f[d>>2]|0;if((F|0)==(E|0))return;else G=F;while(1){_wc(a,G+16|0)|0;F=f[G+4>>2]|0;if(!F){d=G+8|0;p=f[d>>2]|0;if((f[p>>2]|0)==(G|0))H=p;else{p=d;do{d=f[p>>2]|0;p=d+8|0;e=f[p>>2]|0}while((f[e>>2]|0)!=(d|0));H=e}}else{p=F;while(1){i=f[p>>2]|0;if(!i)break;else p=i}H=p}f[c>>2]=H;if((H|0)==(E|0))break;else G=H}return}function _wc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=$Xc(36)|0;e=d+16|0;lYc(e,c);g=d+28|0;f[g>>2]=172888;h=d+32|0;f[h>>2]=0;mi[f[f[43222]>>2]&2047](172888,h);i=f[c+12>>2]|0;f[g>>2]=i;Ti[f[(f[i>>2]|0)+8>>2]&511](i,c+16|0,h);h=a+4|0;c=f[h>>2]|0;do if(c){i=b[d+27>>0]|0;g=i<<24>>24<0;j=g?f[d+20>>2]|0:i&255;i=g?f[e>>2]|0:e;g=c;while(1){k=g+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[g+20>>2]|0:l&255;l=n>>>0<j>>>0?n:j;if((l|0)!=0?(o=WKc(i,m?f[k>>2]|0:k,l)|0,(o|0)!=0):0)if((o|0)<0)p=7;else p=9;else if(j>>>0<n>>>0)p=7;else p=9;if((p|0)==7){p=0;n=f[g>>2]|0;if(!n){p=8;break}else q=n}else if((p|0)==9){p=0;r=g+4|0;n=f[r>>2]|0;if(!n){p=11;break}else q=n}g=q}if((p|0)==8){s=g;t=g;break}else if((p|0)==11){s=g;t=r;break}}else{s=h;t=h}while(0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=s;f[t>>2]=d;s=f[f[a>>2]>>2]|0;if(!s){u=d;v=a+4|0;w=f[v>>2]|0;UQ(w,u);x=a+8|0;y=f[x>>2]|0;z=y+1|0;f[x>>2]=z;return d|0}f[a>>2]=s;u=f[t>>2]|0;v=a+4|0;w=f[v>>2]|0;UQ(w,u);x=a+8|0;y=f[x>>2]|0;z=y+1|0;f[x>>2]=z;return d|0}function $wc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0;d=u;u=u+160|0;e=d+16|0;g=d;h=d+128|0;i=d+132|0;j=d+32|0;k=c+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=i+11|0;b[l>>0]=5;b[i>>0]=b[512723]|0;b[i+1>>0]=b[512724]|0;b[i+2>>0]=b[512725]|0;b[i+3>>0]=b[512726]|0;b[i+4>>0]=b[512727]|0;b[i+5>>0]=0;m=Cwc(k,i)|0;f[e>>2]=m;Hwc(514331,e)|0;if((b[l>>0]|0)<0)cYc(f[i>>2]|0);i=a+32|0;b[e>>0]=b[d+144>>0]|0;Wtc(j,i,k,e);k=xN()|0;l=J;m=j+4|0;if((f[m>>2]|0)>0){o=j+8|0;q=e+8|0;r=e+4|0;s=j+48|0;t=j+64|0;v=0;do{w=q;f[w>>2]=0;f[w+4>>2]=0;f[e>>2]=-2096955388;f[r>>2]=o;SR(e,1.0,0);w=axc(j,f[o>>2]|0,f[s>>2]|0)|0;f[(f[t>>2]|0)+(v<<2)>>2]=w;v=v+1|0}while((v|0)<(f[m>>2]|0))}m=xN()|0;v=J;x=(+(m>>>0)+4294967296.0*+(v|0)-(+(k>>>0)+4294967296.0*+(l|0)))/+yN()+0.0;y=+Lwc(j,i,a+48|0,a+64|0,+n[a+100>>2],h,a+116|0,1,0);z=+((Y(f[i>>2]<<2,f[a+36>>2]|0)|0)>>>0);n[c+8>>2]=(z+ +((f[j+88>>2]|0)+(f[j+84>>2]|0)+(f[j+20>>2]<<2)|0))/z;n[c>>2]=y;n[c+4>>2]=x;p[g>>3]=x;p[g+8>>3]=y;Hwc(514362,g)|0;bxc(j);u=d;return}function axc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;i=a+68|0;j=f[i>>2]|0;do if((j|0)<16){k=a+88|0;f[k>>2]=(f[k>>2]|0)+j;k=jIc(8192)|0;if(!k){eKc(513012,27,1,f[46249]|0)|0;l=0;break}else{m=a+72|0;f[k>>2]=f[m>>2];f[m>>2]=k;f[i>>2]=8188;m=k+4|0;k=a+76|0;f[k>>2]=m;n=k;o=m;p=8172;q=6;break}}else{m=a+76|0;n=m;o=f[m>>2]|0;p=j+-16|0;q=6}while(0);if((q|0)==6){f[n>>2]=o+16;f[i>>2]=p;p=a+84|0;f[p>>2]=(f[p>>2]|0)+16;l=o}if((c|0)==1){f[l+12>>2]=0;f[l+8>>2]=0;f[l>>2]=f[b>>2];u=d;return l|0}else{Exc(a,b,c,e,g,h);f[l>>2]=f[g>>2];f[l+4>>2]=f[h>>2];h=axc(a,b,f[e>>2]|0)|0;f[l+8>>2]=h;h=f[e>>2]|0;e=axc(a,b+(h<<2)|0,c-h|0)|0;f[l+12>>2]=e;u=d;return l|0}return 0}function bxc(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=173672;b=f[a+64>>2]|0;if(b|0)dYc(b);b=f[a+56>>2]|0;if(b|0)dYc(b);b=f[a+60>>2]|0;if(b|0)dYc(b);b=a+72|0;c=f[b>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;kIc(c);f[b>>2]=d}while((d|0)!=0)}Ptc(a+36|0,f[a+40>>2]|0);d=f[a+8>>2]|0;if(!d)return;b=a+12|0;a=f[b>>2]|0;if((a|0)!=(d|0))f[b>>2]=a+(~((a+-4-d|0)>>>2)<<2);cYc(d);return}function cxc(a){a=a|0;bxc(a);cYc(a);return}function dxc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+16|0;c=b;d=a+4|0;if((f[d>>2]|0)<=0){u=b;return}e=a+8|0;g=c+8|0;h=c+4|0;i=a+48|0;j=a+64|0;k=0;do{l=g;f[l>>2]=0;f[l+4>>2]=0;f[c>>2]=-2096955388;f[h>>2]=e;SR(c,1.0,0);l=axc(a,f[e>>2]|0,f[i>>2]|0)|0;f[(f[j>>2]|0)+(k<<2)>>2]=l;k=k+1|0}while((k|0)<(f[d>>2]|0));u=b;return}function exc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+4|0;eKc(c,4,1,b)|0;if((f[c>>2]|0)<=0)return;d=a+64|0;e=0;do{Dxc(a,b,f[(f[d>>2]|0)+(e<<2)>>2]|0);e=e+1|0}while((e|0)<(f[c>>2]|0));return}function fxc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;i=a+4|0;if((NLc(i,4,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+64|0;k=f[j>>2]|0;if(k|0)dYc(k);k=f[i>>2]|0;l=bYc(k>>>0>1073741823?-1:k<<2)|0;f[j>>2]=l;if((k|0)>0?(sxc(a,c,l),(f[i>>2]|0)>1):0){l=1;do{sxc(a,c,(f[j>>2]|0)+(l<<2)|0);l=l+1|0}while((l|0)<(f[i>>2]|0))}i=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=i;i=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=h+11|0;b[l>>0]=9;c=h;k=512094;m=c+9|0;do{b[c>>0]=b[k>>0]|0;c=c+1|0;k=k+1|0}while((c|0)<(m|0));b[h+9>>0]=0;k=Ntc(i,e,h)|0;c=f[k>>2]|0;if(!c){m=$Xc(36)|0;n=m+16|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[m+28>>2]=172888;f[m+32>>2]=0;n=f[e>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=n;f[k>>2]=m;n=f[f[i>>2]>>2]|0;if(!n)o=m;else{f[i>>2]=n;o=f[k>>2]|0}UQ(f[a+40>>2]|0,o);o=a+44|0;f[o>>2]=(f[o>>2]|0)+1;p=m}else p=c;c=p+28|0;m=f[c>>2]|0;o=p+32|0;mi[f[f[m>>2]>>2]&2047](m,o);f[c>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,o);if((b[l>>0]|0)<0)cYc(f[h>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=5;b[g>>0]=b[512723]|0;b[g+1>>0]=b[512724]|0;b[g+2>>0]=b[512725]|0;b[g+3>>0]=b[512726]|0;b[g+4>>0]=b[512727]|0;b[g+5>>0]=0;l=Ntc(i,e,g)|0;o=f[l>>2]|0;if(!o){c=$Xc(36)|0;m=c+16|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[c+28>>2]=172888;f[c+32>>2]=0;m=f[e>>2]|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=m;f[l>>2]=c;m=f[f[i>>2]>>2]|0;if(!m)q=c;else{f[i>>2]=m;q=f[l>>2]|0}UQ(f[a+40>>2]|0,q);q=a+44|0;f[q>>2]=(f[q>>2]|0)+1;r=c}else r=o;o=r+28|0;c=f[o>>2]|0;q=r+32|0;mi[f[f[c>>2]>>2]&2047](c,q);f[o>>2]=173724;Ti[f[(f[43431]|0)+4>>2]&511](173724,j,q);if((b[h>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function gxc(a){a=a|0;return f[a+48>>2]|0}function hxc(a){a=a|0;return f[a+52>>2]|0}function ixc(a){a=a|0;return (f[a+88>>2]|0)+(f[a+84>>2]|0)+(f[a+20>>2]<<2)|0}function jxc(a){a=a|0;return 1}function kxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+36>>2]|0;i=b+40|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function lxc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0;g=u;u=u+32|0;h=g+12|0;i=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=h+11|0;b[j>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;k=auc(e,h)|0;l=e+4|0;do if((k|0)!=(l|0)){m=k+28|0;o=f[m>>2]|0;p=(_i[f[(f[o>>2]|0)+28>>2]&2047](o)|0)+4|0;if((f[p>>2]|0)==(f[6379]|0)){p=f[m>>2]|0;m=Mi[f[(f[p>>2]|0)+20>>2]&1023](p,k+32|0)|0;q=f[m>>2]|0;break}else ig(af(1)|0,22144,0)}else q=32;while(0);if((b[j>>0]|0)<0)cYc(f[h>>2]|0);h=i+4|0;f[h>>2]=0;f[h+4>>2]=0;h=i+11|0;b[h>>0]=3;b[i>>0]=b[513188]|0;b[i+1>>0]=b[513189]|0;b[i+2>>0]=b[513190]|0;b[i+3>>0]=0;j=auc(e,i)|0;do if((j|0)!=(l|0)){e=j+28|0;k=f[e>>2]|0;m=(_i[f[(f[k>>2]|0)+28>>2]&2047](k)|0)+4|0;if((f[m>>2]|0)==(f[6387]|0)){m=f[e>>2]|0;e=Mi[f[(f[m>>2]|0)+20>>2]&1023](m,j+32|0)|0;r=+n[e>>2]+1.0;break}else ig(af(1)|0,22144,0)}else r=1.0;while(0);if((b[h>>0]|0)<0)cYc(f[i>>2]|0);if((q|0)!=-1){nxc(a,c,d,q,r);u=g;return}q=a+4|0;i=f[q>>2]|0;if((i|0)>1){eKc(514398,68,1,f[46249]|0)|0;s=f[q>>2]|0}else s=i;if((s|0)<=0){u=g;return}mxc(a,c,d,f[f[a+64>>2]>>2]|0,0.0,r);u=g;return}function mxc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0;h=d;i=e;while(1){d=h+8|0;j=h+12|0;if((f[d>>2]|0)==0?(f[j>>2]|0)==0:0)break;e=+n[c+(f[h>>2]<<2)>>2]-+n[h+4>>2];k=e<0.0;l=f[(k?j:d)>>2]|0;m=i;i=i+ +L(+e);mxc(a,b,c,f[(k?d:j)>>2]|0,m,g);if(!(i*g<=+Vg[f[(f[b>>2]|0)+16>>2]&31](b))){o=10;break}else h=l}if((o|0)==10)return;o=f[h>>2]|0;h=(f[a+32>>2]|0)+((Y(f[a+28>>2]|0,o)|0)<<2)|0;l=h+(f[a+52>>2]<<2)|0;a=l+-12|0;j=((a>>>0<h>>>0?h:a)+12+(3-h)|0)>>>4<<2;d=c+(j<<2)|0;if(h>>>0<a>>>0){k=h;p=c;g=0.0;while(1){i=+L(+(+n[k>>2]-+n[p>>2]));m=+L(+(+n[k+4>>2]-+n[p+4>>2]));e=+L(+(+n[k+8>>2]-+n[p+8>>2]));q=g+(i+m+e+ +L(+(+n[k+12>>2]-+n[p+12>>2])));k=k+16|0;if(k>>>0>=a>>>0){r=q;break}else{p=p+16|0;g=q}}}else r=0.0;p=h+(j<<2)|0;if(p>>>0<l>>>0){j=d;g=r;d=p;while(1){q=g+ +L(+(+n[d>>2]-+n[j>>2]));d=d+4|0;if(d>>>0>=l>>>0){s=q;break}else{j=j+4|0;g=q}}}else s=r;Hg[f[(f[b>>2]|0)+12>>2]&15](b,s,o);return}function nxc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+24|0;i=g+16|0;j=g;f[i>>2]=0;k=$Xc(20)|0;l=a+48|0;m=f[l>>2]|0;f[k>>2]=0;o=k+4|0;f[o>>2]=0;f[k+8>>2]=0;f[k+12>>2]=m;oxc(k,m);f[k+16>>2]=0;m=f[l>>2]|0;f[j>>2]=0;l=j+4|0;f[l>>2]=0;f[j+8>>2]=0;f[j+12>>2]=m;oaa(j,(m>>>5)+1|0);m=f[j>>2]|0;p=(f[l>>2]|0)-m|0;q=p>>>2;if((p|0)>0)g1c(m|0,0,(((q|0)==0?q^1073741823:1073741822)+q<<2)+8|0)|0;q=a+4|0;if((f[q>>2]|0)>0){m=a+64|0;p=0;do{pxc(a,b,c,f[(f[m>>2]|0)+(p<<2)>>2]|0,0.0,i,d,e,k,j);p=p+1|0}while((p|0)<(f[q>>2]|0))}q=h+4|0;while(1){if(!(qxc(k,h)|0))break;if((f[i>>2]|0)>=(d|0)?_i[f[(f[b>>2]|0)+8>>2]&2047](b)|0:0)break;pxc(a,b,c,f[h>>2]|0,+n[q>>2],i,d,e,k,j)}d=f[k>>2]|0;if(d|0){i=f[o>>2]|0;if((i|0)!=(d|0))f[o>>2]=i+(~((i+-8-d|0)>>>3)<<3);cYc(d)}cYc(k);k=f[j>>2]|0;if(!k){u=g;return}j=f[l>>2]|0;if((j|0)!=(k|0))f[l>>2]=j+(~((j+-4-k|0)>>>2)<<2);cYc(k);u=g;return}function oxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function pxc(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0;l=u;u=u+16|0;m=l;if(+Vg[f[(f[b>>2]|0)+16>>2]&31](b)<e){u=l;return}o=d+8|0;p=d+12|0;if((f[o>>2]|0)==0?(f[p>>2]|0)==0:0){q=f[d>>2]|0;r=q>>>5;s=f[k>>2]|0;t=f[s+(r<<2)>>2]|0;v=1<<(q&31);if(t&v|0){u=l;return}do if((f[g>>2]|0)>=(h|0))if(_i[f[(f[b>>2]|0)+8>>2]&2047](b)|0){u=l;return}else{w=f[k>>2]|0;x=w;y=f[w+(r<<2)>>2]|0;break}else{x=s;y=t}while(0);f[x+(r<<2)>>2]=y|v;f[g>>2]=(f[g>>2]|0)+1;v=(f[a+32>>2]|0)+((Y(f[a+28>>2]|0,q)|0)<<2)|0;y=v+(f[a+52>>2]<<2)|0;r=y+-12|0;x=((r>>>0<v>>>0?v:r)+12+(3-v)|0)>>>4<<2;t=c+(x<<2)|0;if(v>>>0<r>>>0){s=v;w=c;z=0.0;while(1){A=+L(+(+n[s>>2]-+n[w>>2]));B=+L(+(+n[s+4>>2]-+n[w+4>>2]));C=+L(+(+n[s+8>>2]-+n[w+8>>2]));D=z+(A+B+C+ +L(+(+n[s+12>>2]-+n[w+12>>2])));s=s+16|0;if(s>>>0>=r>>>0){E=D;break}else{w=w+16|0;z=D}}}else E=0.0;w=v+(x<<2)|0;if(w>>>0<y>>>0){x=t;z=E;t=w;while(1){D=z+ +L(+(+n[t>>2]-+n[x>>2]));t=t+4|0;if(t>>>0>=y>>>0){F=D;break}else{x=x+4|0;z=D}}}else F=E;Hg[f[(f[b>>2]|0)+12>>2]&15](b,F,q);u=l;return}F=+n[c+(f[d>>2]<<2)>>2]-+n[d+4>>2];d=F<0.0;q=f[(d?o:p)>>2]|0;x=f[(d?p:o)>>2]|0;E=+L(+F)+e;if(!(!(E*i<+Vg[f[(f[b>>2]|0)+16>>2]&31](b))?_i[f[(f[b>>2]|0)+8>>2]&2047](b)|0:0))G=15;if((G|0)==15?(f[m>>2]=x,n[m+4>>2]=E,x=j+16|0,(f[x>>2]|0)!=(f[j+12>>2]|0)):0){G=j+4|0;o=f[G>>2]|0;if((o|0)==(f[j+8>>2]|0)){rxc(j,m);H=f[G>>2]|0}else{p=m;m=f[p+4>>2]|0;d=o;f[d>>2]=f[p>>2];f[d+4>>2]=m;m=(f[G>>2]|0)+8|0;f[G>>2]=m;H=m}m=f[j>>2]|0;G=H-m|0;if((G|0)>8?(d=((G>>>3)+-2|0)/2|0,G=H+-8|0,E=+n[H+-4>>2],E<+n[m+(d<<3)+4>>2]):0){H=f[G>>2]|0;p=G;G=d;while(1){d=p;p=m+(G<<3)|0;o=p;y=f[o+4>>2]|0;t=d;f[t>>2]=f[o>>2];f[t+4>>2]=y;if(!G){I=0;break}y=(G+-1|0)/2|0;if(!(E<+n[m+(y<<3)+4>>2])){I=G;break}else G=y}f[p>>2]=H;n[m+(I<<3)+4>>2]=E}f[x>>2]=(f[x>>2]|0)+1}pxc(a,b,c,q,e,g,h,i,j,k);u=l;return}function qxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0;c=a+16|0;if(!(f[c>>2]|0)){d=0;return d|0}e=f[a>>2]|0;g=f[e+4>>2]|0;h=b;f[h>>2]=f[e>>2];f[h+4>>2]=g;g=f[a>>2]|0;h=a+4|0;a=f[h>>2]|0;e=a-g|0;b=e>>3;if(((e|0)>8?(e=a+-8|0,a=g,i=f[a>>2]|0,j=f[a+4>>2]|0,a=e,k=f[a+4>>2]|0,l=g,f[l>>2]=f[a>>2],f[l+4>>2]=k,k=e,f[k>>2]=i,f[k+4>>2]=j,j=b+-1|0,(b|0)!=2):0)?(k=b+-3|0,b=(k|0)/2|0,(k|0)>=-1):0){k=g+8|0;if((j|0)>2?+n[g+20>>2]<+n[g+12>>2]:0){m=2;o=g+16|0}else{m=1;o=k}p=+n[g+4>>2];if(!(p<+n[o+4>>2])){k=f[g>>2]|0;i=m;m=o;o=g;while(1){e=o;o=m;l=o;a=f[l+4>>2]|0;q=e;f[q>>2]=f[l>>2];f[q+4>>2]=a;if((b|0)<(i|0))break;a=i<<1|1;q=g+(a<<3)|0;l=q;e=a+1|0;if((e|0)<(j|0)?(r=q+8|0,+n[r+4>>2]<+n[g+(a<<3)+4>>2]):0){s=e;t=r}else{s=a;t=l}if(p<+n[t+4>>2])break;else{i=s;m=t}}f[m>>2]=k;n[m+4>>2]=p}}f[h>>2]=(f[h>>2]|0)+-8;f[c>>2]=(f[c>>2]|0)+-1;d=1;return d|0}function rxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function sxc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+68|0;e=a+88|0;g=f[46249]|0;h=a+72|0;i=a+76|0;j=a+84|0;k=c;while(1){c=f[d>>2]|0;do if((c|0)<16){f[e>>2]=(f[e>>2]|0)+c;l=jIc(8192)|0;if(!l){eKc(513012,27,1,g)|0;m=0;break}else{f[l>>2]=f[h>>2];f[h>>2]=l;f[d>>2]=8188;n=l+4|0;f[i>>2]=n;o=n;p=8172;q=7;break}}else{o=f[i>>2]|0;p=c+-16|0;q=7}while(0);if((q|0)==7){q=0;f[i>>2]=o+16;f[d>>2]=p;f[j>>2]=(f[j>>2]|0)+16;m=o}f[k>>2]=m;if((NLc(m,16,1,b)|0)!=1){q=9;break}c=f[k>>2]|0;n=c+8|0;if(!(f[n>>2]|0))r=c;else{sxc(a,b,n);r=f[k>>2]|0}k=r+12|0;if(!(f[k>>2]|0)){q=13;break}}if((q|0)==9){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}else if((q|0)==13)return}function txc(a,b){a=a|0;b=b|0;return}function uxc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function vxc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function wxc(a,b,c){a=a|0;b=b|0;c=c|0;f[c>>2]=f[b>>2];return}function xxc(a,b){a=a|0;b=b|0;return b|0}function yxc(a,b){a=a|0;b=b|0;return b|0}function zxc(a){a=a|0;return 4}function Axc(a){a=a|0;return 22488}function Bxc(a,b,c){a=a|0;b=b|0;c=c|0;rOc(b,f[c>>2]|0)|0;return}function Cxc(a){a=a|0;cYc(a);return}function Dxc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=c;do{eKc(d,16,1,b)|0;c=f[d+8>>2]|0;if(c|0)Dxc(a,b,c);d=f[d+12>>2]|0}while((d|0)!=0);return}function Exc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+56|0;l=a+52|0;g1c(f[k>>2]|0,0,f[l>>2]<<2|0)|0;m=a+60|0;g1c(f[m>>2]|0,0,f[l>>2]<<2|0)|0;o=(c|0)<101?c:101;p=(c|0)>0;if(p){q=f[a+32>>2]|0;r=f[a+28>>2]|0;t=f[l>>2]|0;if(t|0){v=f[k>>2]|0;w=0;do{x=q+((Y(r,f[b+(w<<2)>>2]|0)|0)<<2)|0;y=0;do{z=v+(y<<2)|0;n[z>>2]=+n[x+(y<<2)>>2]+ +n[z>>2];y=y+1|0}while(y>>>0<t>>>0);w=w+1|0}while((w|0)<(o|0));A=t;B=8}}else{A=f[l>>2]|0;B=8}if((B|0)==8){B=(A|0)==0;if(B){C=0;D=1}else{E=+(o|0);l=f[k>>2]|0;t=0;do{w=l+(t<<2)|0;n[w>>2]=+n[w>>2]/E;t=t+1|0}while(t>>>0<A>>>0);C=A;D=B}if(p?(p=f[a+32>>2]|0,B=f[a+28>>2]|0,!D):0){D=f[k>>2]|0;A=f[m>>2]|0;t=0;do{l=p+((Y(B,f[b+(t<<2)>>2]|0)|0)<<2)|0;w=0;do{E=+n[l+(w<<2)>>2]-+n[D+(w<<2)>>2];v=A+(w<<2)|0;n[v>>2]=+n[v>>2]+E*E;w=w+1|0}while(w>>>0<C>>>0);t=t+1|0}while((t|0)<(o|0))}}o=Fxc(a,f[m>>2]|0)|0;f[e>>2]=o;e=f[(f[k>>2]|0)+(o<<2)>>2]|0;f[g>>2]=e;Gxc(a,b,c,o,(f[s>>2]=e,+n[s>>2]),i,j);e=f[i>>2]|0;i=(c|0)/2|0;o=f[j>>2]|0;f[d>>2]=(e|0)==(c|0)|(o|0)==0?i:(e|0)>(i|0)?e:(o|0)<(i|0)?o:i;u=h;return}function Fxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c;e=f[a+52>>2]|0;if(!e)g=0;else{a=0;h=0;while(1){if((h|0)<5){i=h+1|0;f[d+(h<<2)>>2]=a;if((h|0)>0){j=i;k=7}else l=i}else{i=h+-1|0;if(+n[b+(a<<2)>>2]>+n[b+(f[d+(i<<2)>>2]<<2)>>2]){f[d+(i<<2)>>2]=a;j=h;k=7}else l=h}a:do if((k|0)==7){k=0;i=j;while(1){m=i;i=i+-1|0;o=d+(i<<2)|0;p=f[o>>2]|0;q=d+(m+-2<<2)|0;m=f[q>>2]|0;if(!(+n[b+(p<<2)>>2]>+n[b+(m<<2)>>2])){l=j;break a}f[o>>2]=m;f[q>>2]=p;if((i|0)<=1){l=j;break}}}while(0);a=a+1|0;if(a>>>0>=e>>>0){g=l;break}else h=l}}l=OR()|0;h=l;e=f[h+4>>2]|0;a=x1c(f[h>>2]|0,0,-130063606,0)|0;h=d1c(a|0,J|0,e|0,0)|0;e=l;f[e>>2]=h;f[e+4>>2]=J;u=c;return f[d+(~~(+(g|0)*(+(h&2147483647|0)*4.656612873077393e-10))<<2)>>2]|0}function Gxc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+-1|0;c=a+32|0;j=a+28|0;a=i;k=0;a:while(1){b:do if((k|0)>(a|0))l=k;else{m=f[c>>2]|0;o=f[j>>2]|0;p=k;while(1){q=m+((Y(o,f[b+(p<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]<e)){l=p;break b}q=p+1|0;if((p|0)<(a|0))p=q;else{l=q;break}}}while(0);if((l|0)>(a|0))break;p=f[c>>2]|0;o=f[j>>2]|0;m=a;while(1){r=b+(m<<2)|0;s=f[r>>2]|0;q=p+((Y(o,s)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]>=e))break;if((l|0)<(m|0))m=m+-1|0;else break a}o=b+(l<<2)|0;p=f[o>>2]|0;f[o>>2]=s;f[r>>2]=p;a=m+-1|0;k=l+1|0}f[g>>2]=l;g=i;i=l;c:while(1){d:do if((i|0)>(g|0))t=i;else{l=f[c>>2]|0;k=f[j>>2]|0;a=i;while(1){r=l+((Y(k,f[b+(a<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[r>>2]<=e)){t=a;break d}r=a+1|0;if((a|0)<(g|0))a=r;else{t=r;break}}}while(0);if((t|0)>(g|0)){u=21;break}m=f[c>>2]|0;a=f[j>>2]|0;k=g;while(1){v=b+(k<<2)|0;w=f[v>>2]|0;l=m+((Y(a,w)|0)<<2)+(d<<2)|0;if(!(+n[l>>2]>e))break;if((t|0)<(k|0))k=k+-1|0;else{u=21;break c}}a=b+(t<<2)|0;m=f[a>>2]|0;f[a>>2]=w;f[v>>2]=m;g=k+-1|0;i=t+1|0}if((u|0)==21){f[h>>2]=t;return}}function Hxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[a>>2]|0;e=d;if((((f[c>>2]|0)-d|0)/28|0)>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>153391689){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}h=f[g>>2]|0;i=$Xc(b*28|0)|0;j=i+(((h-d|0)/28|0)*28|0)|0;d=j;k=i+(b*28|0)|0;b=h;if((b|0)==(e|0)){l=d;m=h;n=e}else{h=b;b=d;i=j;do{j=i+-28|0;o=h;h=h+-28|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];f[j+12>>2]=f[h+12>>2];j=i+-12|0;p=o+-12|0;f[j>>2]=f[p>>2];q=f[o+-8>>2]|0;f[i+-8>>2]=q;r=o+-4|0;s=f[r>>2]|0;f[i+-4>>2]=s;t=i+-8|0;if(!s)f[j>>2]=t;else{f[q+8>>2]=t;t=o+-8|0;f[p>>2]=t;f[t>>2]=0;f[r>>2]=0}i=b+-28|0;b=i}while((h|0)!=(e|0));l=b;m=f[a>>2]|0;n=f[g>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;k=m;if((n|0)!=(k|0)){c=n;do{Ptc(c+-12|0,f[c+-8>>2]|0);c=c+-28|0}while((c|0)!=(k|0))}if(!m)return;cYc(m);return}function Ixc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0;d=u;u=u+176|0;e=d+24|0;g=d;h=d+152|0;i=d+156|0;j=d+32|0;k=d+48|0;l=d+168|0;m=c+16|0;o=i+11|0;b[o>>0]=10;q=i;r=514827;s=q+10|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[i+10>>0]=0;t=Cwc(m,i)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=j+11|0;b[v>>0]=9;q=j;r=512667;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[j+9>>0]=0;r=Cwc(m,j)|0;f[e>>2]=t;f[e+4>>2]=r;Hwc(514838,e)|0;if((b[v>>0]|0)<0)cYc(f[j>>2]|0);if((b[o>>0]|0)<0)cYc(f[i>>2]|0);i=a+32|0;b[e>>0]=b[l>>0]|0;Xtc(k,i,m,e);e=xN()|0;m=J;Jxc(k);l=xN()|0;o=J;w=(+(l>>>0)+4294967296.0*+(o|0)-(+(e>>>0)+4294967296.0*+(m|0)))/+yN()+0.0;x=+Lwc(k,i,a+48|0,a+64|0,+n[a+100>>2],h,a+116|0,1,0);y=+((Y(f[i>>2]<<2,f[a+36>>2]|0)|0)>>>0);n[c+8>>2]=(y+ +((f[k+96>>2]|0)+(f[k+92>>2]|0)+(f[k+100>>2]|0)|0))/y;n[c>>2]=x;n[c+4>>2]=w;y=+n[a+104>>2];p[g>>3]=w;p[g+8>>3]=x;p[g+16>>3]=y;Hwc(514896,g)|0;Kxc(k);u=d;return}function Jxc(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+12|0;if((f[b>>2]|0)<2){c=af(60)|0;Jtc(c,513040);ig(c|0,22128,1)}c=a+56|0;d=f[c>>2]|0;e=bYc(d>>>0>1073741823?-1:d<<2)|0;g=a+68|0;f[g>>2]=e;if(d|0){d=f[c>>2]|0;h=0;do{f[e+(h<<2)>>2]=h;h=h+1|0}while(h>>>0<d>>>0)}d=a+76|0;h=f[d>>2]|0;do if((h|0)<32){e=a+96|0;f[e>>2]=(f[e>>2]|0)+h;e=jIc(8192)|0;if(!e){eKc(513012,27,1,f[46249]|0)|0;i=0;break}else{j=a+80|0;f[e>>2]=f[j>>2];f[j>>2]=e;f[d>>2]=8188;j=e+4|0;e=a+84|0;f[e>>2]=j;k=e;l=j;m=8156;n=10;break}}else{j=a+84|0;k=j;l=f[j>>2]|0;m=h+-32|0;n=10}while(0);if((n|0)==10){f[k>>2]=l+32;f[d>>2]=m;m=a+92|0;f[m>>2]=(f[m>>2]|0)+32;i=l}l=a+64|0;f[l>>2]=i;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;eyc(a,f[l>>2]|0,f[g>>2]|0,f[c>>2]|0);fyc(a,f[l>>2]|0,f[g>>2]|0,f[c>>2]|0,f[b>>2]|0,0);return}function Kxc(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=173824;b=f[a+64>>2]|0;if(b|0)Lxc(a,b);b=f[a+68>>2]|0;if(b|0)dYc(b);b=a+80|0;c=f[b>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;kIc(c);f[b>>2]=d}while((d|0)!=0)}Ptc(a+44|0,f[a+48>>2]|0);return}function Lxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;if(c|0)dYc(c);c=b+20|0;b=f[c>>2]|0;if(!b)return;d=a+12|0;if((f[d>>2]|0)<=0)return;Lxc(a,f[b>>2]|0);if((f[d>>2]|0)>1)e=1;else return;do{Lxc(a,f[(f[c>>2]|0)+(e<<2)>>2]|0);e=e+1|0}while((e|0)<(f[d>>2]|0));return}function Mxc(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;if(!a)return;c=a;do{a=c;c=f[c>>2]|0;kIc(a);f[b>>2]=c}while((c|0)!=0);return}function Nxc(a){a=a|0;Ptc(a,f[a+4>>2]|0);return}function Oxc(a){a=a|0;Kxc(a);cYc(a);return}function Pxc(a,b){a=a|0;b=b|0;eKc(a+12|0,4,1,b)|0;eKc(a+16|0,4,1,b)|0;eKc(a+100|0,4,1,b)|0;eKc(a+24|0,4,1,b)|0;eKc(f[a+68>>2]|0,4,f[a+56>>2]|0,b)|0;dyc(a,b,f[a+64>>2]|0);return}function Qxc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+32|0;e=d+24|0;g=d;h=d+12|0;i=a+12|0;if((NLc(i,4,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+16|0;if((NLc(j,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}if((NLc(a+100|0,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}k=a+24|0;if((NLc(k,4,1,c)|0)!=1){l=af(60)|0;Jtc(l,511860);ig(l|0,22128,1)}l=a+68|0;m=f[l>>2]|0;if(m|0)dYc(m);m=f[a+56>>2]|0;n=bYc(m>>>0>1073741823?-1:m<<2)|0;f[l>>2]=n;if((NLc(n,4,m,c)|0)!=(m|0)){m=af(60)|0;Jtc(m,511860);ig(m|0,22128,1)}m=a+64|0;n=f[m>>2]|0;if(n|0)Lxc(a,n);cyc(a,c,m);m=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=m;m=a+44|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=h+11|0;b[c>>0]=9;n=h;l=512094;o=n+9|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[h+9>>0]=0;p=Ntc(m,e,h)|0;q=f[p>>2]|0;if(!q){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[s+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[p>>2]=r;s=f[f[m>>2]>>2]|0;if(!s)t=r;else{f[m>>2]=s;t=f[p>>2]|0}UQ(f[a+48>>2]|0,t);t=a+52|0;f[t>>2]=(f[t>>2]|0)+1;v=r}else v=q;q=v+28|0;r=f[q>>2]|0;t=v+32|0;mi[f[f[r>>2]>>2]&2047](r,t);f[q>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,t);if((b[c>>0]|0)<0)cYc(f[h>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g+11|0;b[h>>0]=9;n=g;l=512667;o=n+9|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[g+9>>0]=0;c=Ntc(m,e,g)|0;t=f[c>>2]|0;if(!t){q=$Xc(36)|0;r=q+16|0;f[r>>2]=f[g>>2];f[r+4>>2]=f[g+4>>2];f[r+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;r=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=r;f[c>>2]=q;r=f[f[m>>2]>>2]|0;if(!r)w=q;else{f[m>>2]=r;w=f[c>>2]|0}UQ(f[a+48>>2]|0,w);w=a+52|0;f[w>>2]=(f[w>>2]|0)+1;x=q}else x=t;t=x+28|0;q=f[t>>2]|0;w=x+32|0;mi[f[f[q>>2]>>2]&2047](q,w);f[t>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,i,w);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=g+11|0;b[h>>0]=10;n=g;l=514827;o=n+10|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[g+10>>0]=0;w=Ntc(m,e,g)|0;i=f[w>>2]|0;if(!i){t=$Xc(36)|0;q=t+16|0;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];f[q+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[t+28>>2]=172888;f[t+32>>2]=0;q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[w>>2]=t;q=f[f[m>>2]>>2]|0;if(!q)y=t;else{f[m>>2]=q;y=f[w>>2]|0}UQ(f[a+48>>2]|0,y);y=a+52|0;f[y>>2]=(f[y>>2]|0)+1;z=t}else z=i;i=z+28|0;t=f[i>>2]|0;y=z+32|0;mi[f[f[t>>2]>>2]&2047](t,y);f[i>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,j,y);if((b[h>>0]|0)<0)cYc(f[g>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=12;n=h;l=512677;o=n+12|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));b[h+12>>0]=0;h=Ntc(m,e,g)|0;l=f[h>>2]|0;if(!l){n=$Xc(36)|0;o=n+16|0;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[n+28>>2]=172888;f[n+32>>2]=0;o=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=o;f[h>>2]=n;o=f[f[m>>2]>>2]|0;if(!o)A=n;else{f[m>>2]=o;A=f[h>>2]|0}UQ(f[a+48>>2]|0,A);A=a+52|0;f[A>>2]=(f[A>>2]|0)+1;B=n}else B=l;l=B+28|0;n=f[l>>2]|0;A=B+32|0;mi[f[f[n>>2]>>2]&2047](n,A);f[l>>2]=173316;Ti[f[(f[43329]|0)+4>>2]&511](173316,a+20|0,A);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;A=g+11|0;b[A>>0]=8;l=g;f[l>>2]=1767858787;f[l+4>>2]=2019910766;b[g+8>>0]=0;l=Ntc(m,e,g)|0;n=f[l>>2]|0;if(!n){B=$Xc(36)|0;h=B+16|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[B+28>>2]=172888;f[B+32>>2]=0;h=f[e>>2]|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=h;f[l>>2]=B;h=f[f[m>>2]>>2]|0;if(!h)C=B;else{f[m>>2]=h;C=f[l>>2]|0}UQ(f[a+48>>2]|0,C);C=a+52|0;f[C>>2]=(f[C>>2]|0)+1;D=B}else D=n;n=D+28|0;B=f[n>>2]|0;C=D+32|0;mi[f[f[B>>2]>>2]&2047](B,C);f[n>>2]=173484;Ti[f[(f[43371]|0)+4>>2]&511](173484,k,C);if((b[A>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function Rxc(a){a=a|0;return f[a+56>>2]|0}function Sxc(a){a=a|0;return f[a+60>>2]|0}function Txc(a){a=a|0;return (f[a+96>>2]|0)+(f[a+92>>2]|0)+(f[a+100>>2]|0)|0}function Uxc(a){a=a|0;return 2}function Vxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+44>>2]|0;i=b+48|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function Wxc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g+8|0;i=g+20|0;j=g;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=h+11|0;b[k>>0]=6;b[h>>0]=b[512787]|0;b[h+1>>0]=b[512788]|0;b[h+2>>0]=b[512789]|0;b[h+3>>0]=b[512790]|0;b[h+4>>0]=b[512791]|0;b[h+5>>0]=b[512792]|0;b[h+6>>0]=0;l=auc(e,h)|0;do if((l|0)!=(e+4|0)){m=l+28|0;n=f[m>>2]|0;o=(_i[f[(f[n>>2]|0)+28>>2]&2047](n)|0)+4|0;if((f[o>>2]|0)==(f[6379]|0)){o=f[m>>2]|0;m=Mi[f[(f[o>>2]|0)+20>>2]&1023](o,l+32|0)|0;p=f[m>>2]|0;break}else ig(af(1)|0,22144,0)}else p=32;while(0);if((b[k>>0]|0)<0)cYc(f[h>>2]|0);if((p|0)==-1){Xxc(a,f[a+64>>2]|0,c,d);u=g;return}h=$Xc(20)|0;k=f[a+56>>2]|0;f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;f[h+12>>2]=k;Yxc(h,k);f[h+16>>2]=0;f[i>>2]=0;Zxc(a,f[a+64>>2]|0,c,d,i,p,h);a:do if(_xc(h,j)|0)do{if((f[i>>2]|0)>=(p|0)?_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0:0)break a;Zxc(a,f[j>>2]|0,c,d,i,p,h)}while(_xc(h,j)|0);while(0);j=f[h>>2]|0;if(j|0){p=f[l>>2]|0;if((p|0)!=(j|0))f[l>>2]=p+(~((p+-8-j|0)>>>3)<<3);cYc(j)}cYc(h);u=g;return}function Xxc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;e=f[b>>2]|0;g=a+60|0;h=d+(f[g>>2]<<2)|0;i=h+-12|0;j=((i>>>0<d>>>0?d:i)+12+(3-d)|0)>>>4<<2;k=e+(j<<2)|0;if(i>>>0>d>>>0){l=d;m=e;o=0.0;while(1){p=+L(+(+n[l>>2]-+n[m>>2]));q=+L(+(+n[l+4>>2]-+n[m+4>>2]));r=+L(+(+n[l+8>>2]-+n[m+8>>2]));s=o+(p+q+r+ +L(+(+n[l+12>>2]-+n[m+12>>2])));l=l+16|0;if(l>>>0>=i>>>0){t=s;break}else{m=m+16|0;o=s}}}else t=0.0;m=d+(j<<2)|0;if(m>>>0<h>>>0){j=k;o=t;k=m;while(1){s=o+ +L(+(+n[k>>2]-+n[j>>2]));k=k+4|0;if(k>>>0>=h>>>0){u=s;break}else{j=j+4|0;o=s}}}else u=t;t=+n[b+4>>2];o=+Vg[f[(f[c>>2]|0)+16>>2]&31](c);s=u-t-o;if(!(s>0.0?!(s*s-t*4.0*o>0.0):1))return;j=b+20|0;if(f[j>>2]|0){h=a+12|0;k=f[h>>2]|0;m=bYc(k>>>0>1073741823?-1:k<<2)|0;byc(a,b,d,m);if((f[h>>2]|0)>0){k=0;do{Xxc(a,f[(f[j>>2]|0)+(f[m+(k<<2)>>2]<<2)>>2]|0,c,d);k=k+1|0}while((k|0)<(f[h>>2]|0))}dYc(m);return}m=b+16|0;if((f[m>>2]|0)<=0)return;h=b+24|0;b=a+40|0;k=a+36|0;a=0;do{j=f[(f[h>>2]|0)+(a<<2)>>2]|0;i=(f[b>>2]|0)+((Y(f[k>>2]|0,j)|0)<<2)|0;l=i+(f[g>>2]<<2)|0;e=l+-12|0;v=((e>>>0<i>>>0?i:e)+12+(3-i)|0)>>>4<<2;w=d+(v<<2)|0;if(i>>>0<e>>>0){x=i;y=d;o=0.0;while(1){t=+L(+(+n[x>>2]-+n[y>>2]));s=+L(+(+n[x+4>>2]-+n[y+4>>2]));u=+L(+(+n[x+8>>2]-+n[y+8>>2]));r=o+(t+s+u+ +L(+(+n[x+12>>2]-+n[y+12>>2])));x=x+16|0;if(x>>>0>=e>>>0){z=r;break}else{y=y+16|0;o=r}}}else z=0.0;y=i+(v<<2)|0;if(y>>>0<l>>>0){e=w;o=z;x=y;while(1){r=o+ +L(+(+n[x>>2]-+n[e>>2]));x=x+4|0;if(x>>>0>=l>>>0){A=r;break}else{e=e+4|0;o=r}}}else A=z;Hg[f[(f[c>>2]|0)+12>>2]&15](c,A,j);a=a+1|0}while((a|0)<(f[m>>2]|0));return}function Yxc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>536870911){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>3;i=$Xc(b<<3)|0;j=i+(h<<3)|0;k=j+(0-h<<3)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<3);if(!d)return;cYc(d);return}function Zxc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0;i=a+60|0;j=3-d|0;k=a+12|0;l=b;while(1){b=f[l>>2]|0;m=d+(f[i>>2]<<2)|0;o=m+-12|0;p=((o>>>0<d>>>0?d:o)+12+j|0)>>>4<<2;q=b+(p<<2)|0;if(o>>>0>d>>>0){r=d;s=b;t=0.0;while(1){u=+L(+(+n[r>>2]-+n[s>>2]));v=+L(+(+n[r+4>>2]-+n[s+4>>2]));w=+L(+(+n[r+8>>2]-+n[s+8>>2]));x=t+(u+v+w+ +L(+(+n[r+12>>2]-+n[s+12>>2])));r=r+16|0;if(r>>>0>=o>>>0){y=x;break}else{s=s+16|0;t=x}}}else y=0.0;s=d+(p<<2)|0;if(s>>>0<m>>>0){o=q;t=y;r=s;while(1){x=t+ +L(+(+n[r>>2]-+n[o>>2]));r=r+4|0;if(r>>>0>=m>>>0){z=x;break}else{o=o+4|0;t=x}}}else z=y;t=+n[l+4>>2];x=+Vg[f[(f[c>>2]|0)+16>>2]&31](c);w=z-t-x;if(!(w>0.0?!(w*w-t*4.0*x>0.0):1)){A=19;break}o=l+20|0;if(!(f[o>>2]|0))break;m=f[k>>2]|0;r=bYc(m>>>0>1073741823?-1:m<<2)|0;m=$xc(a,l,d,r,h)|0;dYc(r);l=f[(f[o>>2]|0)+(m<<2)>>2]|0}if((A|0)==19)return;A=f[e>>2]|0;do if((A|0)>=(g|0))if(_i[f[(f[c>>2]|0)+8>>2]&2047](c)|0)return;else{B=f[e>>2]|0;break}else B=A;while(0);A=l+16|0;f[e>>2]=B+(f[A>>2]|0);if((f[A>>2]|0)<=0)return;B=l+24|0;l=a+40|0;e=a+36|0;a=0;do{g=f[(f[B>>2]|0)+(a<<2)>>2]|0;h=(f[l>>2]|0)+((Y(f[e>>2]|0,g)|0)<<2)|0;k=h+(f[i>>2]<<2)|0;j=k+-12|0;m=((j>>>0<h>>>0?h:j)+12+(3-h)|0)>>>4<<2;o=d+(m<<2)|0;if(h>>>0<j>>>0){r=h;q=d;z=0.0;while(1){y=+L(+(+n[r>>2]-+n[q>>2]));x=+L(+(+n[r+4>>2]-+n[q+4>>2]));t=+L(+(+n[r+8>>2]-+n[q+8>>2]));w=z+(y+x+t+ +L(+(+n[r+12>>2]-+n[q+12>>2])));r=r+16|0;if(r>>>0>=j>>>0){C=w;break}else{q=q+16|0;z=w}}}else C=0.0;q=h+(m<<2)|0;if(q>>>0<k>>>0){j=o;z=C;r=q;while(1){w=z+ +L(+(+n[r>>2]-+n[j>>2]));r=r+4|0;if(r>>>0>=k>>>0){D=w;break}else{j=j+4|0;z=w}}}else D=C;Hg[f[(f[c>>2]|0)+12>>2]&15](c,D,g);a=a+1|0}while((a|0)<(f[A>>2]|0));return}function _xc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0;c=a+16|0;if(!(f[c>>2]|0)){d=0;return d|0}e=f[a>>2]|0;g=f[e+4>>2]|0;h=b;f[h>>2]=f[e>>2];f[h+4>>2]=g;g=f[a>>2]|0;h=a+4|0;a=f[h>>2]|0;e=a-g|0;b=e>>3;if(((e|0)>8?(e=a+-8|0,a=g,i=f[a>>2]|0,j=f[a+4>>2]|0,a=e,k=f[a+4>>2]|0,l=g,f[l>>2]=f[a>>2],f[l+4>>2]=k,k=e,f[k>>2]=i,f[k+4>>2]=j,j=b+-1|0,(b|0)!=2):0)?(k=b+-3|0,b=(k|0)/2|0,(k|0)>=-1):0){k=g+8|0;if((j|0)>2?+n[g+20>>2]<+n[g+12>>2]:0){m=2;o=g+16|0}else{m=1;o=k}p=+n[g+4>>2];if(!(p<+n[o+4>>2])){k=f[g>>2]|0;i=m;m=o;o=g;while(1){e=o;o=m;l=o;a=f[l+4>>2]|0;q=e;f[q>>2]=f[l>>2];f[q+4>>2]=a;if((b|0)<(i|0))break;a=i<<1|1;q=g+(a<<3)|0;l=q;e=a+1|0;if((e|0)<(j|0)?(r=q+8|0,+n[r+4>>2]<+n[g+(a<<3)+4>>2]):0){s=e;t=r}else{s=a;t=l}if(p<+n[t+4>>2])break;else{i=s;m=t}}f[m>>2]=k;n[m+4>>2]=p}}f[h>>2]=(f[h>>2]|0)+-8;f[c>>2]=(f[c>>2]|0)+-1;d=1;return d|0}function $xc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,M=0,N=0;g=u;u=u+16|0;h=g;i=b+20|0;b=f[i>>2]|0;j=f[f[b>>2]>>2]|0;k=c+(f[a+60>>2]<<2)|0;l=k+-12|0;m=((l>>>0<c>>>0?c:l)+12+(3-c)|0)>>>4<<2;o=j+(m<<2)|0;p=l>>>0>c>>>0;if(p){q=c;r=j;s=0.0;while(1){t=+L(+(+n[q>>2]-+n[r>>2]));v=+L(+(+n[q+4>>2]-+n[r+4>>2]));w=+L(+(+n[q+8>>2]-+n[r+8>>2]));x=s+(t+v+w+ +L(+(+n[q+12>>2]-+n[r+12>>2])));q=q+16|0;if(q>>>0>=l>>>0){y=x;break}else{r=r+16|0;s=x}}}else y=0.0;r=c+(m<<2)|0;q=r>>>0<k>>>0;if(q){j=o;s=y;o=r;while(1){x=s+ +L(+(+n[o>>2]-+n[j>>2]));o=o+4|0;if(o>>>0>=k>>>0){z=x;break}else{j=j+4|0;s=x}}}else z=y;n[d>>2]=z;j=a+12|0;o=f[j>>2]|0;a:do if((o|0)>1){if(p){A=1;B=0}else{if(q){C=1;D=0}else{E=1;F=0;while(1){n[d+(E<<2)>>2]=0.0;G=+n[d+(F<<2)>>2]>0.0?E:F;E=E+1|0;if((E|0)>=(o|0)){H=G;break a}else F=G}}while(1){F=(f[f[b+(C<<2)>>2]>>2]|0)+(m<<2)|0;z=0.0;E=r;while(1){G=E;E=E+4|0;z=z+ +L(+(+n[G>>2]-+n[F>>2]));if(E>>>0>=k>>>0)break;else F=F+4|0}n[d+(C<<2)>>2]=z;F=z<+n[d+(D<<2)>>2]?C:D;C=C+1|0;if((C|0)>=(o|0)){H=F;break a}else D=F}}while(1){F=f[f[b+(A<<2)>>2]>>2]|0;E=c;G=F;y=0.0;while(1){s=+L(+(+n[E>>2]-+n[G>>2]));x=+L(+(+n[E+4>>2]-+n[G+4>>2]));w=+L(+(+n[E+8>>2]-+n[G+8>>2]));y=y+(s+x+w+ +L(+(+n[E+12>>2]-+n[G+12>>2])));E=E+16|0;if(E>>>0>=l>>>0)break;else G=G+16|0}if(q){G=F+(m<<2)|0;z=y;E=r;while(1){w=z+ +L(+(+n[E>>2]-+n[G>>2]));E=E+4|0;if(E>>>0>=k>>>0){I=w;break}else{G=G+4|0;z=w}}}else I=y;n[d+(A<<2)>>2]=I;G=I<+n[d+(B<<2)>>2]?A:B;A=A+1|0;if((A|0)>=(o|0)){H=G;break}else B=G}}else H=0;while(0);if((o|0)<=0){u=g;return H|0}B=a+24|0;a=h+4|0;A=e+16|0;k=e+12|0;r=e+4|0;m=e+8|0;q=0;l=o;while(1){if((q|0)==(H|0))J=l;else{o=f[(f[i>>2]|0)+(q<<2)>>2]|0;c=d+(q<<2)|0;I=+n[c>>2]-+n[B>>2]*+n[o+12>>2];n[c>>2]=I;f[h>>2]=o;n[a>>2]=I;if((f[A>>2]|0)==(f[k>>2]|0))K=l;else{o=f[r>>2]|0;if((o|0)==(f[m>>2]|0)){ayc(e,h);M=f[r>>2]|0}else{c=h;b=f[c+4>>2]|0;D=o;f[D>>2]=f[c>>2];f[D+4>>2]=b;b=(f[r>>2]|0)+8|0;f[r>>2]=b;M=b}b=f[e>>2]|0;D=M-b|0;if((D|0)>8?(c=((D>>>3)+-2|0)/2|0,D=M+-8|0,I=+n[M+-4>>2],I<+n[b+(c<<3)+4>>2]):0){o=f[D>>2]|0;C=D;D=c;while(1){c=C;C=b+(D<<3)|0;p=C;G=f[p+4>>2]|0;E=c;f[E>>2]=f[p>>2];f[E+4>>2]=G;if(!D){N=0;break}G=(D+-1|0)/2|0;if(!(I<+n[b+(G<<3)+4>>2])){N=D;break}else D=G}f[C>>2]=o;n[b+(N<<3)+4>>2]=I}f[A>>2]=(f[A>>2]|0)+1;K=f[j>>2]|0}J=K}q=q+1|0;if((q|0)>=(J|0))break;else l=J}u=g;return H|0}function ayc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function byc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=a+12|0;g=f[e>>2]|0;h=bYc(g>>>0>1073741823?-1:g<<2)|0;if((g|0)<=0){dYc(h);return}g=f[b+20>>2]|0;b=a+60|0;a=3-c|0;i=0;do{j=f[f[g+(i<<2)>>2]>>2]|0;k=c+(f[b>>2]<<2)|0;l=k+-12|0;m=((l>>>0<c>>>0?c:l)+12+a|0)>>>4<<2;o=j+(m<<2)|0;if(l>>>0>c>>>0){p=c;q=j;r=0.0;while(1){s=+L(+(+n[p>>2]-+n[q>>2]));t=+L(+(+n[p+4>>2]-+n[q+4>>2]));u=+L(+(+n[p+8>>2]-+n[q+8>>2]));v=r+(s+t+u+ +L(+(+n[p+12>>2]-+n[q+12>>2])));p=p+16|0;if(p>>>0>=l>>>0){w=v;break}else{q=q+16|0;r=v}}}else w=0.0;q=c+(m<<2)|0;if(q>>>0<k>>>0){l=o;r=w;p=q;while(1){v=r+ +L(+(+n[p>>2]-+n[l>>2]));p=p+4|0;if(p>>>0>=k>>>0){x=v;break}else{l=l+4|0;r=v}}}else x=w;l=0;while(1){y=h+(l<<2)|0;z=(l|0)<(i|0);if(z&+n[y>>2]<x)l=l+1|0;else break}if(z){k=i;do{p=k;k=k+-1|0;f[h+(p<<2)>>2]=f[h+(k<<2)>>2];f[d+(p<<2)>>2]=f[d+(k<<2)>>2]}while((k|0)>(l|0))}n[y>>2]=x;f[d+(l<<2)>>2]=i;i=i+1|0}while((i|0)<(f[e>>2]|0));dYc(h);return}function cyc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=a+76|0;h=f[g>>2]|0;do if((h|0)<32){i=a+96|0;f[i>>2]=(f[i>>2]|0)+h;i=jIc(8192)|0;if(!i){eKc(513012,27,1,f[46249]|0)|0;j=0;break}else{k=a+80|0;f[i>>2]=f[k>>2];f[k>>2]=i;f[g>>2]=8188;k=i+4|0;i=a+84|0;f[i>>2]=k;l=i;m=k;n=8156;o=6;break}}else{k=a+84|0;l=k;m=f[k>>2]|0;n=h+-32|0;o=6}while(0);if((o|0)==6){f[l>>2]=m+32;f[g>>2]=n;n=a+92|0;f[n>>2]=(f[n>>2]|0)+32;j=m}f[c>>2]=j;if((NLc(j,32,1,b)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=f[a+60>>2]|0;m=bYc(j>>>0>1073741823?-1:j<<2)|0;f[f[c>>2]>>2]=m;if((NLc(f[f[c>>2]>>2]|0,4,j,b)|0)!=(j|0)){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}if(!(f[(f[c>>2]|0)+20>>2]|0)){if((NLc(e,4,1,b)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}f[(f[c>>2]|0)+24>>2]=(f[a+68>>2]|0)+(f[e>>2]<<2);u=d;return}e=a+12|0;j=(f[e>>2]<<2)+15&-16;m=f[g>>2]|0;do if((j|0)>(m|0)){n=a+96|0;f[n>>2]=(f[n>>2]|0)+m;n=(j|4)+15|0;l=n>>>0>8192?n:8192;n=jIc(l)|0;if(!n){eKc(513012,27,1,f[46249]|0)|0;p=0;break}else{h=a+80|0;f[n>>2]=f[h>>2];f[h>>2]=n;h=l+-4|0;f[g>>2]=h;l=n+4|0;n=a+84|0;f[n>>2]=l;q=n;r=l;s=h;o=20;break}}else{h=a+84|0;q=h;r=f[h>>2]|0;s=m;o=20}while(0);if((o|0)==20){f[q>>2]=r+j;f[g>>2]=s-j;s=a+92|0;f[s>>2]=(f[s>>2]|0)+j;p=r}f[(f[c>>2]|0)+20>>2]=p;if((f[e>>2]|0)>0)t=0;else{u=d;return}do{cyc(a,b,(f[(f[c>>2]|0)+20>>2]|0)+(t<<2)|0);t=t+1|0}while((t|0)<(f[e>>2]|0));u=d;return}function dyc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;eKc(c,32,1,b)|0;eKc(f[c>>2]|0,4,f[a+60>>2]|0,b)|0;g=c+20|0;h=f[g>>2]|0;if(!h){f[e>>2]=(f[c+24>>2]|0)-(f[a+68>>2]|0)>>2;eKc(e,4,1,b)|0;u=d;return}e=a+12|0;if((f[e>>2]|0)<=0){u=d;return}dyc(a,b,f[h>>2]|0);if((f[e>>2]|0)>1)i=1;else{u=d;return}do{dyc(a,b,f[(f[g>>2]|0)+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(f[e>>2]|0));u=d;return}function eyc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0,K=0.0,M=0,N=0.0;e=f[a+60>>2]|0;g=bYc(e>>>0>1073741823?-1:e<<2)|0;h=e<<2;i=a+100|0;f[i>>2]=(f[i>>2]|0)+h;g1c(g|0,0,h|0)|0;h=f[a+56>>2]|0;a:do if(!h){j=0.0;k=0}else{i=f[a+40>>2]|0;l=f[a+36>>2]|0;if(!e){m=0;o=0.0;while(1){p=i+((Y(l,f[c+(m<<2)>>2]|0)|0)<<2)|0;q=p+((p+12+(3-p)|0)>>>4<<2<<2)|0;if(q>>>0<p>>>0){r=0.0;s=q;while(1){t=r+ +L(+(+n[s>>2]));s=s+4|0;if(s>>>0>=p>>>0){u=t;break}else r=t}}else u=0.0;r=o+u;m=m+1|0;if(m>>>0>=h>>>0){j=r;k=h;break a}else o=r}}else{v=0;w=0.0}while(1){m=i+((Y(l,f[c+(v<<2)>>2]|0)|0)<<2)|0;p=0;do{s=g+(p<<2)|0;n[s>>2]=+n[m+(p<<2)>>2]+ +n[s>>2];p=p+1|0}while(p>>>0<e>>>0);p=m+(e<<2)|0;s=p+-12|0;q=((s>>>0<m>>>0?m:s)+12+(3-m)|0)>>>4<<2;if(m>>>0<s>>>0){x=m;o=0.0;while(1){r=+L(+(+n[x>>2]));t=+L(+(+n[x+4>>2]));y=+L(+(+n[x+8>>2]));z=o+(r+t+y+ +L(+(+n[x+12>>2])));x=x+16|0;if(x>>>0>=s>>>0){A=z;break}else o=z}}else A=0.0;s=m+(q<<2)|0;if(s>>>0<p>>>0){o=A;x=s;while(1){z=o+ +L(+(+n[x>>2]));x=x+4|0;if(x>>>0>=p>>>0){B=z;break}else o=z}}else B=A;o=w+B;v=v+1|0;if(v>>>0>=h>>>0){j=o;k=h;break}else w=o}}while(0);w=+(k>>>0);if(!e)C=0;else{k=0;do{h=g+(k<<2)|0;n[h>>2]=+n[h>>2]/w;k=k+1|0}while(k>>>0<e>>>0);C=e}B=j/w;k=g+(C<<2)|0;C=k+-12|0;h=3-g|0;v=((C>>>0<g>>>0?g:C)+12+h|0)>>>4<<2;if(g>>>0<C>>>0){l=g;w=0.0;while(1){j=+L(+(+n[l>>2]));A=+L(+(+n[l+4>>2]));u=+L(+(+n[l+8>>2]));o=w+(j+A+u+ +L(+(+n[l+12>>2])));l=l+16|0;if(l>>>0>=C>>>0){D=o;break}else w=o}}else D=0.0;C=g+(v<<2)|0;if(C>>>0<k>>>0){w=D;v=C;while(1){o=w+ +L(+(+n[v>>2]));v=v+4|0;if(v>>>0>=k>>>0){E=o;break}else w=o}}else E=D;D=B-E;if((d|0)<=0){F=0.0;G=b+12|0;n[G>>2]=D;H=b+4|0;n[H>>2]=F;f[b>>2]=g;return}k=f[a+40>>2]|0;v=f[a+36>>2]|0;a=g+(e<<2)|0;e=a+-12|0;C=((e>>>0<g>>>0?g:e)+12+h|0)>>>4<<2;h=g+(C<<2)|0;l=h>>>0<a>>>0;if(g>>>0<e>>>0){I=0.0;J=0}else{if(l){K=0.0;M=0}else{F=0.0;G=b+12|0;n[G>>2]=D;H=b+4|0;n[H>>2]=F;f[b>>2]=g;return}while(1){i=k+((Y(v,f[c+(M<<2)>>2]|0)|0)<<2)+(C<<2)|0;E=0.0;p=h;while(1){x=p;p=p+4|0;E=E+ +L(+(+n[x>>2]-+n[i>>2]));if(p>>>0>=a>>>0)break;else i=i+4|0}B=E>K?E:K;M=M+1|0;if((M|0)==(d|0)){F=B;break}else K=B}G=b+12|0;n[G>>2]=D;H=b+4|0;n[H>>2]=F;f[b>>2]=g;return}while(1){M=k+((Y(v,f[c+(J<<2)>>2]|0)|0)<<2)|0;i=g;p=M;K=0.0;while(1){B=+L(+(+n[i>>2]-+n[p>>2]));w=+L(+(+n[i+4>>2]-+n[p+4>>2]));o=+L(+(+n[i+8>>2]-+n[p+8>>2]));K=K+(B+w+o+ +L(+(+n[i+12>>2]-+n[p+12>>2])));i=i+16|0;if(i>>>0>=e>>>0)break;else p=p+16|0}if(l){p=M+(C<<2)|0;E=K;i=h;while(1){o=E+ +L(+(+n[i>>2]-+n[p>>2]));i=i+4|0;if(i>>>0>=a>>>0){N=o;break}else{p=p+4|0;E=o}}}else N=K;E=N>I?N:I;J=J+1|0;if((J|0)==(d|0)){F=E;break}else I=E}G=b+12|0;n[G>>2]=D;H=b+4|0;n[H>>2]=F;f[b>>2]=g;return}function fyc(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0;i=u;u=u+4400|0;j=i;k=i+3320|0;l=i+3312|0;m=i+3296|0;o=i+3280|0;q=i+2216|0;r=i+1152|0;s=i+4384|0;t=i+1104|0;v=i+1096|0;f[c+16>>2]=e;f[c+28>>2]=h;if((e|0)<(g|0)){f[c+24>>2]=d;mMc(d,d+(e<<2)|0,j);f[c+20>>2]=0;u=i;return}w=k+8|0;f[k>>2]=w;x=k+4|0;y=g>>>0>264;f[x>>2]=g;if(y){z=bYc(g>>>0>1073741823?-1:g<<2)|0;f[k>>2]=z;A=z}else A=w;z=f[a+4>>2]|0;B=f[a+8>>2]|0;C=a+(B>>1)|0;if(!(B&1))D=z;else D=f[(f[C>>2]|0)+z>>2]|0;Fh[D&255](C,g,d,e,A,l);C=f[l>>2]|0;if((C|0)>=(g|0)){l=a+60|0;D=f[l>>2]|0;z=Y(D,g)|0;B=j+8|0;f[j>>2]=B;E=j+4|0;f[E>>2]=z;if(z>>>0>136){F=bYc(z>>>0>536870911?-1:z<<3)|0;f[j>>2]=F;G=F}else G=B;f[m>>2]=g;f[m+4>>2]=D;F=m+8|0;z=m+12|0;f[z>>2]=G;f[F>>2]=D;H=G;if((C|0)>0?(G=f[a+40>>2]|0,I=f[a+36>>2]|0,D|0):0){J=0;do{K=G+((Y(I,f[A+(J<<2)>>2]|0)|0)<<2)|0;N=H+((Y(D,J)|0)<<3)|0;O=0;do{p[N+(O<<3)>>3]=+n[K+(O<<2)>>2];O=O+1|0}while(O>>>0<D>>>0);J=J+1|0}while((J|0)<(C|0))}f[o>>2]=0;C=o+4|0;f[C>>2]=0;f[o+8>>2]=0;do if(g)if(g>>>0>1073741823)kWc(o);else{J=g<<2;D=$Xc(J)|0;f[o>>2]=D;H=D+(g<<2)|0;f[o+8>>2]=H;g1c(D|0,0,J|0)|0;f[C>>2]=H;P=D;break}else P=0;while(0);D=q+8|0;f[q>>2]=D;H=q+4|0;f[H>>2]=g;if(!y)if(!g){Q=D;R=0}else{S=D;T=24}else{y=bYc(g>>>0>1073741823?-1:g<<2)|0;f[q>>2]=y;S=y;T=24}if((T|0)==24){y=0;do{n[P+(y<<2)>>2]=0.0;f[S+(y<<2)>>2]=0;y=y+1|0}while((y|0)!=(g|0));Q=S;R=1}S=r+8|0;f[r>>2]=S;y=r+4|0;f[y>>2]=e;if(e>>>0>264){J=bYc(e>>>0>1073741823?-1:e<<2)|0;f[r>>2]=J;U=J}else U=S;J=(e|0)>0;A=a+40|0;if(J){I=f[A>>2]|0;G=a+36|0;O=f[z>>2]|0;K=(g|0)>1;N=0;do{V=d+(N<<2)|0;W=I+((Y(f[G>>2]|0,f[V>>2]|0)|0)<<2)|0;X=W+(f[l>>2]<<2)|0;Z=X+-12|0;_=((Z>>>0<W>>>0?W:Z)+12+(3-W)|0)>>>4<<2;$=O+(_<<3)|0;if(W>>>0<Z>>>0){aa=W;ba=O;ca=0.0;while(1){da=+L(+(+n[aa>>2]-+p[ba>>3]));ea=+L(+(+n[aa+4>>2]-+p[ba+8>>3]));fa=+L(+(+n[aa+8>>2]-+p[ba+16>>3]));ga=ca+(da+ea+fa+ +L(+(+n[aa+12>>2]-+p[ba+24>>3])));aa=aa+16|0;if(aa>>>0>=Z>>>0){ha=ga;break}else{ba=ba+32|0;ca=ga}}}else ha=0.0;ba=W+(_<<2)|0;if(ba>>>0<X>>>0){Z=$;ca=ha;aa=ba;while(1){ga=ca+ +L(+(+n[aa>>2]-+p[Z>>3]));aa=aa+4|0;if(aa>>>0>=X>>>0){ia=ga;break}else{Z=Z+8|0;ca=ga}}}else ia=ha;Z=U+(N<<2)|0;f[Z>>2]=0;if(K){X=I+((Y(f[G>>2]|0,f[V>>2]|0)|0)<<2)|0;aa=f[F>>2]|0;$=X+(f[l>>2]<<2)|0;_=$+-12|0;W=((_>>>0<X>>>0?X:_)+12+(3-X)|0)>>>4<<2;ba=X>>>0<_>>>0;ja=X+(W<<2)|0;ka=ja>>>0<$>>>0;la=1;ca=ia;ma=0;while(1){na=O+((Y(aa,la)|0)<<3)|0;oa=na+(W<<3)|0;if(ba){pa=X;qa=na;ga=0.0;while(1){fa=+L(+(+n[pa>>2]-+p[qa>>3]));ea=+L(+(+n[pa+4>>2]-+p[qa+8>>3]));da=+L(+(+n[pa+8>>2]-+p[qa+16>>3]));ra=ga+(fa+ea+da+ +L(+(+n[pa+12>>2]-+p[qa+24>>3])));pa=pa+16|0;if(pa>>>0>=_>>>0){sa=ra;break}else{qa=qa+32|0;ga=ra}}}else sa=0.0;if(ka){qa=oa;ga=sa;pa=ja;while(1){ra=ga+ +L(+(+n[pa>>2]-+p[qa>>3]));pa=pa+4|0;if(pa>>>0>=$>>>0){ta=ra;break}else{qa=qa+8|0;ga=ra}}}else ta=sa;if(ca>ta){f[Z>>2]=la;ua=ta;va=la}else{ua=ca;va=ma}la=la+1|0;if((la|0)==(g|0)){wa=ua;xa=va;break}else{ca=ua;ma=va}}}else{wa=ia;xa=0}ma=P+(xa<<2)|0;if(wa>+n[ma>>2])n[ma>>2]=wa;ma=Q+(xa<<2)|0;f[ma>>2]=(f[ma>>2]|0)+1;N=N+1|0}while((N|0)!=(e|0));ya=G}else ya=a+36|0;b[s>>0]=0;G=a+16|0;N=a+28|0;xa=t+8|0;P=t+12|0;va=t+16|0;O=t+20|0;I=t+24|0;K=t+28|0;ma=t+32|0;la=t+36|0;Z=t+40|0;$=v+4|0;ja=0;do{if((ja|0)>=(f[G>>2]|0))break;b[s>>0]=1;ja=ja+1|0;if(R){ka=0;do{_=(f[z>>2]|0)+((Y(f[F>>2]|0,ka)|0)<<3)|0;g1c(_|0,0,f[l>>2]<<3|0)|0;n[(f[o>>2]|0)+(ka<<2)>>2]=0.0;ka=ka+1|0}while((ka|0)!=(g|0))}if(J?(ka=f[A>>2]|0,_=f[ya>>2]|0,X=f[z>>2]|0,ba=f[F>>2]|0,W=f[l>>2]|0,W|0):0){aa=0;do{V=ka+((Y(_,f[d+(aa<<2)>>2]|0)|0)<<2)|0;qa=X+((Y(ba,f[U+(aa<<2)>>2]|0)|0)<<3)|0;pa=0;do{oa=qa+(pa<<3)|0;p[oa>>3]=+p[oa>>3]+ +n[V+(pa<<2)>>2];pa=pa+1|0}while(pa>>>0<W>>>0);aa=aa+1|0}while((aa|0)!=(e|0))}aa=f[l>>2]|0;if(R){W=f[z>>2]|0;ba=f[F>>2]|0;if(!aa)za=0;else{X=0;do{wa=+(f[Q+(X<<2)>>2]|0);_=W+((Y(ba,X)|0)<<3)|0;ka=0;do{pa=_+(ka<<3)|0;p[pa>>3]=+p[pa>>3]/wa;ka=ka+1|0}while(ka>>>0<aa>>>0);X=X+1|0}while((X|0)!=(g|0));za=aa}}else za=aa;f[t>>2]=173884;f[xa>>2]=N;f[P>>2]=g;f[va>>2]=d;f[O>>2]=m;f[I>>2]=za;f[K>>2]=Q;f[ma>>2]=U;f[la>>2]=o;f[Z>>2]=s;f[v>>2]=0;f[$>>2]=e;h3(v,t,-1.0);if(R){X=f[z>>2]|0;ba=f[o>>2]|0;W=0;do{ka=Q+(W<<2)|0;if(!(f[ka>>2]|0)){_=W;do{_=(_+1|0)%(g|0)|0;Aa=Q+(_<<2)|0}while((f[Aa>>2]|0)<2);a:do if(J){pa=X+((Y(f[F>>2]|0,_)|0)<<3)|0;V=ba+(_<<2)|0;qa=0;while(1){Ba=U+(qa<<2)|0;if((f[Ba>>2]|0)==(_|0)){oa=(f[A>>2]|0)+((Y(f[ya>>2]|0,f[d+(qa<<2)>>2]|0)|0)<<2)|0;na=oa+(f[l>>2]<<2)|0;Ca=na+-12|0;Da=((Ca>>>0<oa>>>0?oa:Ca)+12+(3-oa)|0)>>>4<<2;Ea=pa+(Da<<3)|0;if(oa>>>0<Ca>>>0){Fa=oa;Ga=pa;wa=0.0;while(1){ia=+L(+(+n[Fa>>2]-+p[Ga>>3]));ua=+L(+(+n[Fa+4>>2]-+p[Ga+8>>3]));ta=+L(+(+n[Fa+8>>2]-+p[Ga+16>>3]));sa=wa+(ia+ua+ta+ +L(+(+n[Fa+12>>2]-+p[Ga+24>>3])));Fa=Fa+16|0;if(Fa>>>0>=Ca>>>0){Ha=sa;break}else{Ga=Ga+32|0;wa=sa}}}else Ha=0.0;Ga=oa+(Da<<2)|0;if(Ga>>>0<na>>>0){Ca=Ea;wa=Ha;Fa=Ga;while(1){sa=wa+ +L(+(+n[Fa>>2]-+p[Ca>>3]));Fa=Fa+4|0;if(Fa>>>0>=na>>>0){Ia=sa;break}else{Ca=Ca+8|0;wa=sa}}}else Ia=Ha;if(Ia==+n[V>>2])break}qa=qa+1|0;if((qa|0)>=(e|0))break a}f[Ba>>2]=W;f[Aa>>2]=(f[Aa>>2]|0)+-1;f[ka>>2]=(f[ka>>2]|0)+1}while(0);b[s>>0]=0}W=W+1|0}while((W|0)!=(g|0))}}while(!(b[s>>0]|0));s=bYc(g>>>0>1073741823?-1:g<<2)|0;if(R){Aa=a+100|0;Ba=f[z>>2]|0;z=f[F>>2]|0;F=f[l>>2]|0;t=0;v=F;while(1){$=bYc(v>>>0>1073741823?-1:v<<2)|0;f[s+(t<<2)>>2]=$;f[Aa>>2]=(f[Aa>>2]|0)+(v<<2);if(!v)Ja=0;else{Z=Ba+((Y(z,t)|0)<<3)|0;la=0;do{n[$+(la<<2)>>2]=+p[Z+(la<<3)>>3];la=la+1|0}while(la>>>0<F>>>0);Ja=F}t=t+1|0;if((t|0)>=(g|0))break;else v=Ja}}Ja=(g<<2)+15&-16;v=a+76|0;t=f[v>>2]|0;do if((Ja|0)>(t|0)){F=a+96|0;f[F>>2]=(f[F>>2]|0)+t;F=(Ja|4)+15|0;z=F>>>0>8192?F:8192;F=jIc(z)|0;if(!F){eKc(513012,27,1,f[46249]|0)|0;Ka=0;break}else{Ba=a+80|0;f[F>>2]=f[Ba>>2];f[Ba>>2]=F;Ba=z+-4|0;f[v>>2]=Ba;z=F+4|0;F=a+84|0;f[F>>2]=z;La=F;Ma=z;Na=Ba;T=85;break}}else{Ba=a+84|0;La=Ba;Ma=f[Ba>>2]|0;Na=t;T=85}while(0);if((T|0)==85){f[La>>2]=Ma+Ja;f[v>>2]=Na-Ja;Na=a+92|0;f[Na>>2]=(f[Na>>2]|0)+Ja;Ka=Ma}Ma=c+20|0;f[Ma>>2]=Ka;if(R){R=a+96|0;Ka=f[46249]|0;Ja=a+80|0;Na=a+84|0;La=h+1|0;h=a+92|0;t=0;Ba=0;while(1){z=f[Q+(t<<2)>>2]|0;if(J){F=0;Ia=0.0;Ha=0.0;Aa=Ba;while(1){la=U+(F<<2)|0;if((f[la>>2]|0)==(t|0)){Z=d+(F<<2)|0;$=f[Z>>2]|0;ma=(f[A>>2]|0)+((Y(f[ya>>2]|0,$)|0)<<2)|0;K=ma+(f[l>>2]<<2)|0;za=K+-12|0;I=((za>>>0<ma>>>0?ma:za)+12+(3-ma)|0)>>>4<<2;if(ma>>>0<za>>>0){m=ma;wa=0.0;while(1){sa=+L(+(+n[m>>2]));ta=+L(+(+n[m+4>>2]));ua=+L(+(+n[m+8>>2]));ia=wa+(sa+ta+ua+ +L(+(+n[m+12>>2])));m=m+16|0;if(m>>>0>=za>>>0){Oa=ia;break}else wa=ia}}else Oa=0.0;za=ma+(I<<2)|0;if(za>>>0<K>>>0){wa=Oa;m=za;while(1){ia=wa+ +L(+(+n[m>>2]));m=m+4|0;if(m>>>0>=K>>>0){Pa=ia;break}else wa=ia}}else Pa=Oa;wa=Ia+ +M(+Pa);K=d+(Aa<<2)|0;f[Z>>2]=f[K>>2];f[K>>2]=$;K=U+(Aa<<2)|0;m=f[la>>2]|0;f[la>>2]=f[K>>2];f[K>>2]=m;Qa=wa;Ra=Ha+Pa;Sa=Aa+1|0}else{Qa=Ia;Ra=Ha;Sa=Aa}F=F+1|0;if((F|0)==(e|0)){Ta=Qa;Ua=Ra;Va=Sa;break}else{Ia=Qa;Ha=Ra;Aa=Sa}}}else{Ta=0.0;Ua=0.0;Va=Ba}Ha=+(z|0);Aa=s+(t<<2)|0;F=f[Aa>>2]|0;m=F+(f[l>>2]<<2)|0;K=m+-12|0;I=((K>>>0<F>>>0?F:K)+12+(3-F)|0)>>>4<<2;if(F>>>0<K>>>0){ma=F;Ia=0.0;while(1){wa=+L(+(+n[ma>>2]));ia=+L(+(+n[ma+4>>2]));ua=+L(+(+n[ma+8>>2]));ta=Ia+(wa+ia+ua+ +L(+(+n[ma+12>>2])));ma=ma+16|0;if(ma>>>0>=K>>>0){Wa=ta;break}else Ia=ta}}else Wa=0.0;K=F+(I<<2)|0;if(K>>>0<m>>>0){Ia=Wa;ma=K;while(1){ta=Ia+ +L(+(+n[ma>>2]));ma=ma+4|0;if(ma>>>0>=m>>>0){Xa=ta;break}else Ia=ta}}else Xa=Wa;m=f[v>>2]|0;do if((m|0)<32){f[R>>2]=(f[R>>2]|0)+m;ma=jIc(8192)|0;if(!ma){eKc(513012,27,1,Ka)|0;Ya=0;break}else{f[ma>>2]=f[Ja>>2];f[Ja>>2]=ma;f[v>>2]=8188;I=ma+4|0;f[Na>>2]=I;Za=I;_a=8188;T=102;break}}else{Za=f[Na>>2]|0;_a=m;T=102}while(0);if((T|0)==102){T=0;f[Na>>2]=Za+32;f[v>>2]=_a+-32;f[h>>2]=(f[h>>2]|0)+32;Ya=Za}f[(f[Ma>>2]|0)+(t<<2)>>2]=Ya;m=f[(f[Ma>>2]|0)+(t<<2)>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;m=(f[Ma>>2]|0)+(t<<2)|0;I=f[m>>2]|0;f[I+4>>2]=f[(f[o>>2]|0)+(t<<2)>>2];f[I>>2]=f[Aa>>2];I=f[m>>2]|0;n[I+12>>2]=Ua/Ha-Xa;n[I+8>>2]=Ta/Ha;fyc(a,I,d+(Ba<<2)|0,Va-Ba|0,g,La);t=t+1|0;if((t|0)>=(g|0))break;else Ba=Va}}dYc(s);s=f[r>>2]|0;if((s|0)!=(S|0)){if(s|0)dYc(s);f[r>>2]=S;f[y>>2]=264}y=f[q>>2]|0;if((y|0)!=(D|0)){if(y|0)dYc(y);f[q>>2]=D;f[H>>2]=264}H=f[o>>2]|0;if(H|0){o=f[C>>2]|0;if((o|0)!=(H|0))f[C>>2]=o+(~((o+-4-H|0)>>>2)<<2);cYc(H)}H=f[j>>2]|0;if((H|0)!=(B|0)){if(H|0)dYc(H);f[j>>2]=B;f[E>>2]=136}}else{f[c+24>>2]=d;mMc(d,d+(e<<2)|0,j);f[c+20>>2]=0}c=f[k>>2]|0;if((c|0)!=(w|0)){if(c|0)dYc(c);f[k>>2]=w;f[x>>2]=264}u=i;return}function gyc(a){a=a|0;cYc(a);return}function hyc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0,J=0,K=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0;d=f[c>>2]|0;e=f[c+4>>2]|0;if((d|0)>=(e|0))return;c=a+8|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+12|0;k=a+36|0;l=a+32|0;m=a+28|0;o=a+40|0;a=d;do{d=f[c>>2]|0;q=(f[d+12>>2]|0)+((Y(f[d+8>>2]|0,f[(f[g>>2]|0)+(a<<2)>>2]|0)|0)<<2)|0;d=f[h>>2]|0;r=f[d+12>>2]|0;s=q+(f[i>>2]<<2)|0;t=s+-12|0;u=((t>>>0<q>>>0?q:t)+12+(3-q)|0)>>>4<<2;v=r+(u<<3)|0;w=q>>>0<t>>>0;if(w){x=q;y=r;z=0.0;while(1){A=+L(+(+n[x>>2]-+p[y>>3]));B=+L(+(+n[x+4>>2]-+p[y+8>>3]));C=+L(+(+n[x+8>>2]-+p[y+16>>3]));D=z+(A+B+C+ +L(+(+n[x+12>>2]-+p[y+24>>3])));x=x+16|0;if(x>>>0>=t>>>0){E=D;break}else{y=y+32|0;z=D}}}else E=0.0;y=q+(u<<2)|0;x=y>>>0<s>>>0;if(x){F=v;z=E;G=y;while(1){D=z+ +L(+(+n[G>>2]-+p[F>>3]));G=G+4|0;if(G>>>0>=s>>>0){H=D;break}else{F=F+8|0;z=D}}}else H=E;F=f[j>>2]|0;a:do if((F|0)>1){G=f[d+8>>2]|0;if(w){I=1;J=0;K=H}else{v=1;M=0;z=H;while(1){if(x){N=r+((Y(G,v)|0)<<3)+(u<<3)|0;D=0.0;O=y;while(1){C=D+ +L(+(+n[O>>2]-+p[N>>3]));O=O+4|0;if(O>>>0>=s>>>0){P=C;break}else{N=N+8|0;D=C}}}else P=0.0;N=z>P;D=N?P:z;O=N?v:M;v=v+1|0;if((v|0)>=(F|0)){Q=O;R=D;break a}else{M=O;z=D}}}while(1){M=r+((Y(G,I)|0)<<3)|0;v=q;O=M;z=0.0;while(1){D=+L(+(+n[v>>2]-+p[O>>3]));C=+L(+(+n[v+4>>2]-+p[O+8>>3]));B=+L(+(+n[v+8>>2]-+p[O+16>>3]));z=z+(D+C+B+ +L(+(+n[v+12>>2]-+p[O+24>>3])));v=v+16|0;if(v>>>0>=t>>>0)break;else O=O+32|0}if(x){O=M+(u<<3)|0;B=z;v=y;while(1){C=B+ +L(+(+n[v>>2]-+p[O>>3]));v=v+4|0;if(v>>>0>=s>>>0){S=C;break}else{O=O+8|0;B=C}}}else S=z;O=K>S;B=O?S:K;v=O?I:J;I=I+1|0;if((I|0)>=(F|0)){Q=v;R=B;break}else{J=v;K=B}}}else{Q=0;R=H}while(0);F=(f[f[k>>2]>>2]|0)+(Q<<2)|0;if(R>+n[F>>2])n[F>>2]=R;F=f[(f[l>>2]|0)+(a<<2)>>2]|0;if((Q|0)!=(F|0)){s=(f[m>>2]|0)+(F<<2)|0;f[s>>2]=(f[s>>2]|0)+-1;s=(f[m>>2]|0)+(Q<<2)|0;f[s>>2]=(f[s>>2]|0)+1;f[(f[l>>2]|0)+(a<<2)>>2]=Q;b[f[o>>2]>>0]=0}a=a+1|0}while((a|0)!=(e|0));return}function iyc(a){a=a|0;var b=0;f[a>>2]=173904;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);return}function jyc(a){a=a|0;var b=0;f[a>>2]=173904;b=f[a+8>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);cYc(a);return}function kyc(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;Hwc(515088,b)|0;c=f[a+4>>2]|0;Yi[f[(f[c>>2]|0)+8>>2]&4095](c);Hwc(515113,b+8|0)|0;c=f[a+8>>2]|0;Yi[f[(f[c>>2]|0)+8>>2]&4095](c);u=b;return}function lyc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,b);c=f[a+8>>2]|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,b);return}function myc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+24>>2]&2047](c,b);c=f[a+8>>2]|0;mi[f[(f[c>>2]|0)+24>>2]&2047](c,b);return}function nyc(a){a=a|0;var b=0;b=f[a+8>>2]|0;return _i[f[(f[b>>2]|0)+28>>2]&2047](b)|0}function oyc(a){a=a|0;var b=0;b=f[a+8>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&2047](b)|0}function pyc(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;c=_i[f[(f[b>>2]|0)+36>>2]&2047](b)|0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+36>>2]&2047](b)|0)+c|0}function qyc(a){a=a|0;return 3}function ryc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+12>>2]|0;i=b+16|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function syc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[a+4>>2]|0;ei[f[(f[e>>2]|0)+48>>2]&511](e,b,c,d);e=f[a+8>>2]|0;ei[f[(f[e>>2]|0)+48>>2]&511](e,b,c,d);return}function tyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0;h=u;u=u+32|0;i=h;jvc(i,d);a:do if((b|0)>0){d=i+16|0;j=f[i>>2]|0;k=a+40|0;l=a+36|0;m=a+32|0;o=f[i+12>>2]|0;p=f[d>>2]|0;q=0;b:while(1){r=e+(q<<2)|0;s=(q|0)>0;if((p|0)==(o|0)){t=q;v=j;w=22;break a}else x=p;while(1){y=x;x=x+1|0;f[d>>2]=x;z=f[j+(y<<2)>>2]|0;if((z|0)<0)break b;y=f[c+(z<<2)>>2]|0;f[r>>2]=y;if(!s)break;z=f[k>>2]|0;A=f[l>>2]|0;B=z+((Y(A,y)|0)<<2)|0;y=B+(f[m>>2]<<2)|0;C=y+-12|0;D=((C>>>0<B>>>0?B:C)+12+(3-B)|0)>>>4<<2;E=B+(D<<2)|0;F=E>>>0<y>>>0;if(B>>>0>=C>>>0){if(F){G=0;H=0;while(1){I=z+((Y(f[e+(G<<2)>>2]|0,A)|0)<<2)+(D<<2)|0;J=0.0;K=E;while(1){M=K;K=K+4|0;J=J+ +L(+(+n[M>>2]-+n[I>>2]));if(K>>>0>=y>>>0)break;else I=I+4|0}I=J<1.0e-16?1:H;G=G+1|0;if((G|0)==(q|0)){N=I;w=19;break}else H=I}}}else{H=0;G=0;while(1){I=z+((Y(f[e+(H<<2)>>2]|0,A)|0)<<2)|0;K=B;M=I;O=0.0;while(1){P=+L(+(+n[K>>2]-+n[M>>2]));Q=+L(+(+n[K+4>>2]-+n[M+4>>2]));R=+L(+(+n[K+8>>2]-+n[M+8>>2]));O=O+(P+Q+R+ +L(+(+n[K+12>>2]-+n[M+12>>2])));K=K+16|0;if(K>>>0>=C>>>0)break;else M=M+16|0}if(F){M=I+(D<<2)|0;J=O;K=E;while(1){R=J+ +L(+(+n[K>>2]-+n[M>>2]));K=K+4|0;if(K>>>0>=y>>>0){S=R;break}else{M=M+4|0;J=R}}}else S=O;M=S<1.0e-16?1:G;H=H+1|0;if((H|0)==(q|0)){N=M;w=19;break}else G=M}}if((w|0)==19?(w=0,(N&1)==0):0)break;if((x|0)==(o|0)){t=q;v=j;w=22;break a}}s=q+1|0;if((s|0)<(b|0)){p=x;q=s}else{t=s;v=j;w=22;break a}}f[g>>2]=q;T=j}else{t=0;v=f[i>>2]|0;w=22}while(0);if((w|0)==22){f[g>>2]=t;if(!v){u=h;return}else T=v}v=i+4|0;i=f[v>>2]|0;if((i|0)!=(T|0))f[v>>2]=i+(~((i+-4-T|0)>>>2)<<2);cYc(T);u=h;return}function uyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,K=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0;h=OR()|0;i=h;j=f[i+4>>2]|0;k=x1c(f[i>>2]|0,0,-130063606,0)|0;i=d1c(k|0,J|0,j|0,0)|0;j=h;f[j>>2]=i;f[j+4>>2]=J;f[e>>2]=f[c+(~~(+(d|0)*(+(i&2147483647|0)*4.656612873077393e-10))<<2)>>2];if((b|0)<=1){l=1;f[g>>2]=l;return}i=(d|0)>0;j=a+40|0;h=a+36|0;k=a+32|0;a=1;while(1){if(!i){l=a;m=18;break}o=f[j>>2]|0;p=f[h>>2]|0;q=o+((Y(p,f[e>>2]|0)|0)<<2)|0;r=f[k>>2]|0;s=q+(r<<2)|0;t=s+-12|0;u=((t>>>0<q>>>0?q:t)+12+(3-q)|0)>>>4<<2;v=q>>>0<t>>>0;w=q+(u<<2)|0;x=w>>>0<s>>>0;y=(a|0)>1;z=0;A=0.0;B=-1;while(1){C=o+((Y(f[c+(z<<2)>>2]|0,p)|0)<<2)|0;D=C+(u<<2)|0;if(v){E=q;F=C;G=0.0;while(1){H=+L(+(+n[E>>2]-+n[F>>2]));I=+L(+(+n[E+4>>2]-+n[F+4>>2]));K=+L(+(+n[E+8>>2]-+n[F+8>>2]));M=G+(H+I+K+ +L(+(+n[E+12>>2]-+n[F+12>>2])));E=E+16|0;if(E>>>0>=t>>>0){N=M;break}else{F=F+16|0;G=M}}}else N=0.0;if(x){F=D;G=N;E=w;while(1){M=G+ +L(+(+n[E>>2]-+n[F>>2]));E=E+4|0;if(E>>>0>=s>>>0){O=M;break}else{F=F+4|0;G=M}}}else O=N;if(y){F=1;G=O;while(1){E=o+((Y(p,f[e+(F<<2)>>2]|0)|0)<<2)|0;D=E+(r<<2)|0;P=D+-12|0;Q=((P>>>0<E>>>0?E:P)+12+(3-E)|0)>>>4<<2;R=C+(Q<<2)|0;if(E>>>0<P>>>0){S=E;T=C;M=0.0;while(1){K=+L(+(+n[S>>2]-+n[T>>2]));I=+L(+(+n[S+4>>2]-+n[T+4>>2]));H=+L(+(+n[S+8>>2]-+n[T+8>>2]));U=M+(K+I+H+ +L(+(+n[S+12>>2]-+n[T+12>>2])));S=S+16|0;if(S>>>0>=P>>>0){V=U;break}else{T=T+16|0;M=U}}}else V=0.0;T=E+(Q<<2)|0;if(T>>>0<D>>>0){P=R;M=V;S=T;while(1){U=M+ +L(+(+n[S>>2]-+n[P>>2]));S=S+4|0;if(S>>>0>=D>>>0){W=U;break}else{P=P+4|0;M=U}}}else W=V;M=W<G?W:G;F=F+1|0;if((F|0)==(a|0)){X=M;break}else G=M}}else X=O;F=X>A;B=F?z:B;z=z+1|0;if((z|0)==(d|0))break;else A=F?X:A}if((B|0)==-1){l=a;m=18;break}f[e+(a<<2)>>2]=f[c+(B<<2)>>2];z=a+1|0;if((z|0)<(b|0))a=z;else{l=z;m=18;break}}if((m|0)==18){f[g>>2]=l;return}}function vyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0;h=u;u=u+16|0;i=h;j=bYc(d>>>0>1073741823?-1:d<<2)|0;k=OR()|0;l=k;m=f[l+4>>2]|0;o=x1c(f[l>>2]|0,0,-130063606,0)|0;l=d1c(o|0,J|0,m|0,0)|0;m=k;f[m>>2]=l;f[m+4>>2]=J;m=c+(~~(+(d|0)*(+(l&2147483647|0)*4.656612873077393e-10))<<2)|0;f[e>>2]=f[m>>2];l=(d|0)>0;if(l){k=f[a+40>>2]|0;o=f[a+36>>2]|0;p=k+((Y(f[m>>2]|0,o)|0)<<2)|0;m=f[a+32>>2]|0;q=0;r=0.0;while(1){s=k+((Y(o,f[c+(q<<2)>>2]|0)|0)<<2)|0;t=s+(m<<2)|0;v=t+-12|0;w=((v>>>0<s>>>0?s:v)+12+(3-s)|0)>>>4<<2;x=p+(w<<2)|0;if(s>>>0<v>>>0){y=s;z=p;A=0.0;while(1){B=+L(+(+n[y>>2]-+n[z>>2]));C=+L(+(+n[y+4>>2]-+n[z+4>>2]));D=+L(+(+n[y+8>>2]-+n[z+8>>2]));E=A+(B+C+D+ +L(+(+n[y+12>>2]-+n[z+12>>2])));y=y+16|0;if(y>>>0>=v>>>0){F=E;break}else{z=z+16|0;A=E}}}else F=0.0;z=s+(w<<2)|0;if(z>>>0<t>>>0){v=x;A=F;y=z;while(1){E=A+ +L(+(+n[y>>2]-+n[v>>2]));y=y+4|0;if(y>>>0>=t>>>0){G=E;break}else{v=v+4|0;A=E}}}else G=F;A=G*G;n[j+(q<<2)>>2]=A;E=r+A;q=q+1|0;if((q|0)==(d|0)){H=E;break}else r=E}}else H=0.0;if((b|0)<=1){I=1;f[g>>2]=I;dYc(j);u=h;return}q=d+-1|0;p=(d|0)>1;m=a+40|0;o=a+36|0;k=a+32|0;a=1;r=H;while(1){v=OR()|0;t=v;y=f[t+4>>2]|0;x=x1c(f[t>>2]|0,0,-130063606,0)|0;t=d1c(x|0,J|0,y|0,0)|0;y=v;f[y>>2]=t;f[y+4>>2]=J;a:do if(p){y=0;H=r*(+(t&2147483647|0)*4.656612873077393e-10)+0.0;while(1){G=+n[j+(y<<2)>>2];if(H<=G){K=y;break a}v=y+1|0;if((v|0)<(q|0)){y=v;H=H-G}else{K=v;break}}}else K=0;while(0);if(l){t=f[m>>2]|0;y=f[o>>2]|0;v=c+(K<<2)|0;x=f[v>>2]|0;w=t+((Y(x,y)|0)<<2)|0;s=f[k>>2]|0;z=0;H=0.0;do{M=t+((Y(y,f[c+(z<<2)>>2]|0)|0)<<2)|0;N=M+(s<<2)|0;O=N+-12|0;P=((O>>>0<M>>>0?M:O)+12+(3-M)|0)>>>4<<2;Q=w+(P<<2)|0;if(M>>>0<O>>>0){R=M;S=w;G=0.0;while(1){F=+L(+(+n[R>>2]-+n[S>>2]));E=+L(+(+n[R+4>>2]-+n[S+4>>2]));A=+L(+(+n[R+8>>2]-+n[S+8>>2]));D=G+(F+E+A+ +L(+(+n[R+12>>2]-+n[S+12>>2])));R=R+16|0;if(R>>>0>=O>>>0){T=D;break}else{S=S+16|0;G=D}}}else T=0.0;S=M+(P<<2)|0;if(S>>>0<N>>>0){O=Q;G=T;R=S;while(1){D=G+ +L(+(+n[R>>2]-+n[O>>2]));R=R+4|0;if(R>>>0>=N>>>0){U=D;break}else{O=O+4|0;G=D}}}else U=T;G=U*U;D=+n[j+(z<<2)>>2];H=H+(D<G?D:G);z=z+1|0}while((z|0)!=(d|0));f[e+(a<<2)>>2]=x;if(l){z=f[m>>2]|0;w=f[o>>2]|0;s=z+((Y(f[v>>2]|0,w)|0)<<2)|0;y=f[k>>2]|0;t=0;do{O=z+((Y(w,f[c+(t<<2)>>2]|0)|0)<<2)|0;N=O+(y<<2)|0;R=N+-12|0;Q=((R>>>0<O>>>0?O:R)+12+(3-O)|0)>>>4<<2;P=s+(Q<<2)|0;if(O>>>0<R>>>0){M=O;S=s;G=0.0;while(1){D=+L(+(+n[M>>2]-+n[S>>2]));A=+L(+(+n[M+4>>2]-+n[S+4>>2]));E=+L(+(+n[M+8>>2]-+n[S+8>>2]));F=G+(D+A+E+ +L(+(+n[M+12>>2]-+n[S+12>>2])));M=M+16|0;if(M>>>0>=R>>>0){V=F;break}else{S=S+16|0;G=F}}}else V=0.0;S=O+(Q<<2)|0;if(S>>>0<N>>>0){R=P;G=V;M=S;while(1){F=G+ +L(+(+n[M>>2]-+n[R>>2]));M=M+4|0;if(M>>>0>=N>>>0){W=F;break}else{R=R+4|0;G=F}}}else W=V;G=W*W;n[i>>2]=G;R=j+(t<<2)|0;f[R>>2]=f[(+n[R>>2]<G?R:i)>>2];t=t+1|0}while((t|0)!=(d|0));X=H}else X=H}else{f[e+(a<<2)>>2]=f[c+(K<<2)>>2];X=0.0}a=a+1|0;if((a|0)==(b|0)){I=b;break}else r=X}f[g>>2]=I;dYc(j);u=h;return}function wyc(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=173964;if(b[a+36>>0]|0?(c=f[a+64>>2]|0,c|0):0)dYc(c);c=a+96|0;d=f[c>>2]|0;if(d|0){e=d;do{d=e;e=f[e>>2]|0;kIc(d);f[c>>2]=e}while((e|0)!=0)}e=f[a+80>>2]|0;if(e|0){c=a+84|0;d=f[c>>2]|0;if((d|0)!=(e|0))f[c>>2]=d+(~((d+-8-e|0)>>>3)<<3);cYc(e)}e=f[a+40>>2]|0;if(e|0){d=a+44|0;c=f[d>>2]|0;if((c|0)!=(e|0))f[d>>2]=c+(~((c+-4-e|0)>>>2)<<2);cYc(e)}Ptc(a+20|0,f[a+24>>2]|0);return}function xyc(a){a=a|0;wyc(a);cYc(a);return}function yyc(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+80|0;Tyc(a,c);d=a+68|0;e=Uyc(a,0,f[d>>2]|0,c)|0;f[a+76>>2]=e;if(!(b[a+36>>0]|0)){e=a+4|0;c=a+52|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];return}e=a+64|0;c=f[e>>2]|0;if(c|0)dYc(c);c=f[d>>2]|0;d=f[a+72>>2]|0;g=Y(d,c)|0;h=bYc(g>>>0>1073741823?-1:g<<2)|0;f[a+52>>2]=c;f[a+56>>2]=d;f[a+60>>2]=d;f[e>>2]=h;if((c|0)==0|(d|0)==0)return;e=f[a+40>>2]|0;g=f[a+16>>2]|0;i=f[a+12>>2]|0;a=0;do{j=g+((Y(i,f[e+(a<<2)>>2]|0)|0)<<2)|0;k=h+((Y(d,a)|0)<<2)|0;l=0;do{f[k+(l<<2)>>2]=f[j+(l<<2)>>2];l=l+1|0}while(l>>>0<d>>>0);a=a+1|0}while(a>>>0<c>>>0);return}function zyc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;f[i>>2]=174024;j=i+12|0;f[j>>2]=e;k=i+16|0;f[k>>2]=0;if(!(f[b>>2]|0)){u=h;return}l=c+12|0;m=c+8|0;c=d+12|0;o=d+8|0;d=i+4|0;p=i+8|0;q=i+20|0;r=b+12|0;s=b+8|0;t=0;v=e;while(1){e=(f[l>>2]|0)+((Y(f[m>>2]|0,t)|0)<<2)|0;w=(f[c>>2]|0)+((Y(f[o>>2]|0,t)|0)<<2)|0;f[d>>2]=e;f[p>>2]=w;f[k>>2]=0;n[q>>2]=3402823466385288598117041.0e14;n[w+(v+-1<<2)>>2]=3402823466385288598117041.0e14;w=(f[r>>2]|0)+((Y(f[s>>2]|0,t)|0)<<2)|0;ei[f[(f[a>>2]|0)+48>>2]&511](a,i,w,g);w=t+1|0;if(w>>>0>=(f[b>>2]|0)>>>0)break;t=w;v=f[j>>2]|0}u=h;return}function Ayc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;eKc(a+68|0,4,1,c)|0;eKc(a+72|0,4,1,c)|0;g=a+80|0;f[e>>2]=(f[a+84>>2]|0)-(f[g>>2]|0)>>3;eKc(e,4,1,c)|0;eKc(f[g>>2]|0,8,f[e>>2]|0,c)|0;g=a+36|0;ILc(b[g>>0]|0,c)|0;eKc(a+32|0,4,1,c)|0;h=a+40|0;f[e>>2]=(f[a+44>>2]|0)-(f[h>>2]|0)>>2;eKc(e,4,1,c)|0;eKc(f[h>>2]|0,4,f[e>>2]|0,c)|0;if(!(b[g>>0]|0)){i=a+76|0;j=f[i>>2]|0;Oyc(a,c,j);u=d;return}g=a+52|0;eKc(g,16,1,c)|0;eKc(f[a+64>>2]|0,4,Y(f[a+56>>2]|0,f[g>>2]|0)|0,c)|0;i=a+76|0;j=f[i>>2]|0;Oyc(a,c,j);u=d;return}function Byc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;if((NLc(a+68|0,4,1,c)|0)!=1){i=af(60)|0;Jtc(i,511860);ig(i|0,22128,1)}if((NLc(a+72|0,4,1,c)|0)!=1){i=af(60)|0;Jtc(i,511860);ig(i|0,22128,1)}Kyc(c,a+80|0);i=a+36|0;if((NLc(i,1,1,c)|0)!=1){j=af(60)|0;Jtc(j,511860);ig(j|0,22128,1)}j=a+32|0;if((NLc(j,4,1,c)|0)!=1){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}Lyc(c,a+40|0);if(!(b[i>>0]|0)){k=a+4|0;l=a+52|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2]}else tuc(c,a+52|0);Myc(a,c,a+76|0);c=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[g>>2]=c;c=a+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=h+11|0;b[k>>0]=9;l=h;m=512094;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+9>>0]=0;o=Ntc(c,e,h)|0;p=f[o>>2]|0;if(!p){q=$Xc(36)|0;r=q+16|0;f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[r+8>>2]=f[h+8>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[q+28>>2]=172888;f[q+32>>2]=0;r=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=r;f[o>>2]=q;r=f[f[c>>2]>>2]|0;if(!r)s=q;else{f[c>>2]=r;s=f[o>>2]|0}UQ(f[a+24>>2]|0,s);s=a+28|0;f[s>>2]=(f[s>>2]|0)+1;t=q}else t=p;p=t+28|0;q=f[p>>2]|0;s=t+32|0;mi[f[f[q>>2]>>2]&2047](q,s);f[p>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,g,s);if((b[k>>0]|0)<0)cYc(f[h>>2]|0);h=$Xc(16)|0;f[g>>2]=h;f[g+8>>2]=-2147483632;f[g+4>>2]=13;l=h;m=515181;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+13>>0]=0;h=Ntc(c,e,g)|0;m=f[h>>2]|0;if(!m){l=$Xc(36)|0;n=l+16|0;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;n=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=n;f[h>>2]=l;n=f[f[c>>2]>>2]|0;if(!n)v=l;else{f[c>>2]=n;v=f[h>>2]|0}UQ(f[a+24>>2]|0,v);v=a+28|0;f[v>>2]=(f[v>>2]|0)+1;w=l}else w=m;m=w+28|0;l=f[m>>2]|0;v=w+32|0;mi[f[f[l>>2]>>2]&2047](l,v);f[m>>2]=173312;Ti[f[(f[43328]|0)+4>>2]&511](173312,j,v);if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[g+8>>2]=0;v=g+11|0;b[v>>0]=7;b[g>>0]=b[515195]|0;b[g+1>>0]=b[515196]|0;b[g+2>>0]=b[515197]|0;b[g+3>>0]=b[515198]|0;b[g+4>>0]=b[515199]|0;b[g+5>>0]=b[515200]|0;b[g+6>>0]=b[515201]|0;b[g+7>>0]=0;j=Ntc(c,e,g)|0;m=f[j>>2]|0;if(!m){l=$Xc(36)|0;w=l+16|0;f[w>>2]=f[g>>2];f[w+4>>2]=f[g+4>>2];f[w+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;w=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=w;f[j>>2]=l;w=f[f[c>>2]>>2]|0;if(!w)x=l;else{f[c>>2]=w;x=f[j>>2]|0}UQ(f[a+24>>2]|0,x);x=a+28|0;f[x>>2]=(f[x>>2]|0)+1;y=l}else y=m;m=y+28|0;l=f[m>>2]|0;x=y+32|0;mi[f[f[l>>2]>>2]&2047](l,x);f[m>>2]=173488;Ti[f[(f[43372]|0)+4>>2]&511](173488,i,x);if((b[v>>0]|0)>=0){u=d;return}cYc(f[g>>2]|0);u=d;return}function Cyc(a){a=a|0;return f[a+68>>2]|0}function Dyc(a){a=a|0;return f[a+72>>2]|0}function Eyc(a){a=a|0;return (f[a+112>>2]|0)+(f[a+108>>2]|0)+(f[a+4>>2]<<2)|0}function Fyc(a){a=a|0;return 4}function Gyc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+20>>2]|0;i=b+24|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function Hyc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0;g=u;u=u+32|0;h=g;i=g+12|0;j=h+4|0;f[j>>2]=0;f[j+4>>2]=0;j=h+11|0;b[j>>0]=3;b[h>>0]=b[513188]|0;b[h+1>>0]=b[513189]|0;b[h+2>>0]=b[513190]|0;b[h+3>>0]=0;k=auc(e,h)|0;do if((k|0)!=(e+4|0)){l=k+28|0;m=f[l>>2]|0;o=(_i[f[(f[m>>2]|0)+28>>2]&2047](m)|0)+4|0;if((f[o>>2]|0)==(f[6387]|0)){o=f[l>>2]|0;l=Mi[f[(f[o>>2]|0)+20>>2]&1023](o,k+32|0)|0;p=+n[l>>2]+1.0;break}else ig(af(1)|0,22144,0)}else p=1.0;while(0);if((b[j>>0]|0)<0)cYc(f[h>>2]|0);h=f[a+72>>2]|0;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;if(!h)q=0.0;else{if(h>>>0>1073741823)kWc(i);k=h<<2;e=$Xc(k)|0;f[i>>2]=e;f[i+8>>2]=e+(h<<2);g1c(e|0,0,k|0)|0;f[j>>2]=e+(h<<2);k=f[a+80>>2]|0;r=0.0;l=0;while(1){o=d+(l<<2)|0;s=+n[o>>2];t=+n[k+(l<<3)>>2];if(s<t){v=+L(+(s-t));n[e+(l<<2)>>2]=v;w=r+v;x=+n[o>>2]}else{w=r;x=s}s=+n[k+(l<<3)+4>>2];if(x>s){v=+L(+(x-s));n[e+(l<<2)>>2]=v;y=w+v}else y=w;l=l+1|0;if((l|0)==(h|0)){q=y;break}else r=y}}Iyc(a,c,d,f[a+76>>2]|0,q,i,p);a=f[i>>2]|0;if(!a){u=g;return}i=f[j>>2]|0;if((i|0)!=(a|0))f[j>>2]=i+(~((i+-4-a|0)>>>2)<<2);cYc(a);u=g;return}function Iyc(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=+i;var j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0,u=0;j=f[e+20>>2]|0;k=f[e+24>>2]|0;if(!((j|0)==0&(k|0)==0)){l=f[e+8>>2]|0;m=+n[d+(l<<2)>>2];o=+n[e+12>>2];p=+n[e+16>>2];q=m-o+(m-p)<0.0;r=+L(+(m-(q?p:o)));Iyc(a,c,d,q?j:k,g,h,i);s=(f[h>>2]|0)+(l<<2)|0;o=+n[s>>2];p=r+g-o;n[s>>2]=r;if(p*i<=+Vg[f[(f[c>>2]|0)+16>>2]&31](c))Iyc(a,c,d,q?k:j,p,h,i);n[(f[h>>2]|0)+(l<<2)>>2]=o;return}o=+Vg[f[(f[c>>2]|0)+16>>2]&31](c);l=f[e>>2]|0;h=e+4|0;if((l|0)>=(f[h>>2]|0))return;e=a+36|0;j=a+40|0;k=a+116|0;q=a+64|0;s=a+60|0;t=a+72|0;a=l;do{if(!(b[e>>0]|0))u=f[(f[j>>2]|0)+(a<<2)>>2]|0;else u=a;l=(f[q>>2]|0)+((Y(f[s>>2]|0,u)|0)<<2)|0;i=+Jyc(k,d,l,f[t>>2]|0,o);if(i<o)Hg[f[(f[c>>2]|0)+12>>2]&15](c,i,f[(f[j>>2]|0)+(a<<2)>>2]|0);a=a+1|0}while((a|0)<(f[h>>2]|0));return}function Jyc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0.0,w=0;a=b+(d<<2)|0;d=a+-12|0;a:do if(e>0.0){f=b;g=c;h=0.0;while(1){if(f>>>0>=d>>>0){i=f;j=g;k=h;break a}l=+L(+(+n[f>>2]-+n[g>>2]));m=+L(+(+n[f+4>>2]-+n[g+4>>2]));o=+L(+(+n[f+8>>2]-+n[g+8>>2]));p=h+(l+m+o+ +L(+(+n[f+12>>2]-+n[g+12>>2])));if(p>e){q=p;break}else{f=f+16|0;g=g+16|0;h=p}}return +q}else{g=((d>>>0<b>>>0?b:d)+12+(3-b)|0)>>>4<<2;f=c+(g<<2)|0;if(d>>>0>b>>>0){r=b;s=c;h=0.0;while(1){p=+L(+(+n[r>>2]-+n[s>>2]));o=+L(+(+n[r+4>>2]-+n[s+4>>2]));m=+L(+(+n[r+8>>2]-+n[s+8>>2]));l=h+(p+o+m+ +L(+(+n[r+12>>2]-+n[s+12>>2])));r=r+16|0;if(r>>>0>=d>>>0){t=l;break}else{s=s+16|0;h=l}}}else t=0.0;i=b+(g<<2)|0;j=f;k=t}while(0);if(i>>>0<a>>>0){u=j;v=k;w=i}else{q=k;return +q}while(1){k=v+ +L(+(+n[w>>2]-+n[u>>2]));w=w+4|0;if(w>>>0>=a>>>0){q=k;break}else{u=u+4|0;v=k}}return +q}function Kyc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;if((NLc(d,4,1,a)|0)!=1){e=af(60)|0;Jtc(e,511860);ig(e|0,22128,1)}e=f[d>>2]|0;d=b+4|0;g=f[d>>2]|0;h=f[b>>2]|0;i=g-h>>3;j=h;k=g;g=h;if(e>>>0<=i>>>0)if(e>>>0<i>>>0?(h=j+(e<<3)|0,(k|0)!=(h|0)):0){f[d>>2]=k+(~((k+-8-h|0)>>>3)<<3);l=g}else l=g;else{Nyc(b,e-i|0);l=f[b>>2]|0}if((NLc(l,8,e,a)|0)==(e|0)){u=c;return}else{c=af(60)|0;Jtc(c,511860);ig(c|0,22128,1)}}function Lyc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;if((NLc(d,4,1,a)|0)!=1){e=af(60)|0;Jtc(e,511860);ig(e|0,22128,1)}e=f[d>>2]|0;d=b+4|0;g=f[d>>2]|0;h=f[b>>2]|0;i=g-h>>2;j=h;k=g;g=h;if(e>>>0<=i>>>0)if(e>>>0<i>>>0?(h=j+(e<<2)|0,(k|0)!=(h|0)):0){f[d>>2]=k+(~((k+-4-h|0)>>>2)<<2);l=g}else l=g;else{CS(b,e-i|0);l=f[b>>2]|0}if((NLc(l,4,e,a)|0)==(e|0)){u=c;return}else{c=af(60)|0;Jtc(c,511860);ig(c|0,22128,1)}}function Myc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+92|0;e=a+112|0;g=f[46249]|0;h=a+96|0;i=a+100|0;j=a+108|0;k=c;while(1){c=f[d>>2]|0;do if((c|0)<32){f[e>>2]=(f[e>>2]|0)+c;l=jIc(8192)|0;if(!l){eKc(513012,27,1,g)|0;m=0;break}else{f[l>>2]=f[h>>2];f[h>>2]=l;f[d>>2]=8188;n=l+4|0;f[i>>2]=n;o=n;p=8156;q=7;break}}else{o=f[i>>2]|0;p=c+-32|0;q=7}while(0);if((q|0)==7){q=0;f[i>>2]=o+32;f[d>>2]=p;f[j>>2]=(f[j>>2]|0)+32;m=o}f[k>>2]=m;if((NLc(m,28,1,b)|0)!=1){q=9;break}c=f[k>>2]|0;n=c+20|0;if(!(f[n>>2]|0))r=c;else{Myc(a,b,n);r=f[k>>2]|0}k=r+24|0;if(!(f[k>>2]|0)){q=13;break}}if((q|0)==9){k=af(60)|0;Jtc(k,511860);ig(k|0,22128,1)}else if((q|0)==13)return}function Nyc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){h=b;i=g;do{j=i;f[j>>2]=0;f[j+4>>2]=0;i=(f[e>>2]|0)+8|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>3;g=i+b|0;if(g>>>0>536870911)kWc(a);j=d-h|0;h=j>>2;d=j>>3>>>0<268435455?(h>>>0<g>>>0?g:h):536870911;do if(d)if(d>>>0>536870911){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<3)|0;break}else k=0;while(0);h=k+(i<<3)|0;i=k+(d<<3)|0;d=b;b=h;k=h;do{g=b;f[g>>2]=0;f[g+4>>2]=0;b=k+8|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(0-(b>>3)<<3)|0;if((b|0)>0)o1c(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;cYc(d);return}function Oyc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=c;do{eKc(d,28,1,b)|0;c=f[d+20>>2]|0;if(c|0)Oyc(a,b,c);d=f[d+24>>2]|0}while((d|0)!=0);return}function Pyc(a){a=a|0;cYc(a);return}function Qyc(a){a=a|0;return (f[a+16>>2]|0)==(f[a+12>>2]|0)|0}function Ryc(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=a+20|0;if(+n[d>>2]<=b)return;e=a+16|0;g=f[e>>2]|0;h=a+12|0;i=f[h>>2]|0;if((g|0)>0){j=f[a+8>>2]|0;k=a+4|0;l=g;m=i;while(1){o=l+-1|0;p=+n[j+(o<<2)>>2];if(!(p>b)){q=l;r=m;break}if((l|0)<(m|0)){n[j+(l<<2)>>2]=p;s=f[k>>2]|0;f[s+(l<<2)>>2]=f[s+(o<<2)>>2];t=f[h>>2]|0}else t=m;if((l|0)>1){l=o;m=t}else{q=o;r=t;break}}u=q;v=r;w=f[e>>2]|0}else{u=g;v=i;w=g}if((w|0)<(v|0))f[e>>2]=w+1;w=f[a+8>>2]|0;n[w+(u<<2)>>2]=b;f[(f[a+4>>2]|0)+(u<<2)>>2]=c;f[d>>2]=f[w+((f[h>>2]|0)+-1<<2)>>2];return}function Syc(a){a=a|0;return +(+n[a+20>>2])}function Tyc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0;c=a+72|0;d=f[c>>2]|0;e=b+4|0;g=f[e>>2]|0;h=f[b>>2]|0;i=g-h>>3;j=h;h=g;if(d>>>0<=i>>>0)if(d>>>0<i>>>0?(g=j+(d<<3)|0,(h|0)!=(g|0)):0){f[e>>2]=h+(~((h+-8-g|0)>>>3)<<3);k=d}else k=d;else{Nyc(b,d-i|0);k=f[c>>2]|0}c=(k|0)==0;if(!c){i=f[a+16>>2]|0;d=f[b>>2]|0;g=0;do{h=i+(g<<2)|0;f[d+(g<<3)>>2]=f[h>>2];f[d+(g<<3)+4>>2]=f[h>>2];g=g+1|0}while(g>>>0<k>>>0)}g=f[a+4>>2]|0;if(g>>>0<=1)return;d=f[b>>2]|0;if(c)return;c=f[a+16>>2]|0;b=f[a+12>>2]|0;a=1;do{i=c+((Y(b,a)|0)<<2)|0;h=0;do{e=i+(h<<2)|0;l=+n[e>>2];j=d+(h<<3)|0;if(l<+n[j>>2]){n[j>>2]=l;m=+n[e>>2]}else m=l;e=d+(h<<3)+4|0;if(m>+n[e>>2])n[e>>2]=m;h=h+1|0}while(h>>>0<k>>>0);a=a+1|0}while(a>>>0<g>>>0);return}function Uyc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;e=u;u=u+48|0;g=e+32|0;h=e+28|0;i=e+24|0;j=e+12|0;k=e;l=a+92|0;m=f[l>>2]|0;do if((m|0)<32){o=a+112|0;f[o>>2]=(f[o>>2]|0)+m;o=jIc(8192)|0;if(!o){eKc(513012,27,1,f[46249]|0)|0;p=0;break}else{q=a+96|0;f[o>>2]=f[q>>2];f[q>>2]=o;f[l>>2]=8188;q=o+4|0;o=a+100|0;f[o>>2]=q;r=o;s=q;t=8188;v=6;break}}else{q=a+100|0;r=q;s=f[q>>2]|0;t=m;v=6}while(0);if((v|0)==6){f[r>>2]=s+32;f[l>>2]=t+-32;t=a+108|0;f[t>>2]=(f[t>>2]|0)+32;p=s}s=c-b|0;if((s|0)>(f[a+32>>2]|0)){Vyc(a,(f[a+40>>2]|0)+(b<<2)|0,s,g,h,i,d);f[p+8>>2]=f[h>>2];Wyc(j,d);f[(f[j>>2]|0)+(f[h>>2]<<3)+4>>2]=f[i>>2];s=Uyc(a,b,(f[g>>2]|0)+b|0,j)|0;f[p+20>>2]=s;Wyc(k,d);f[(f[k>>2]|0)+(f[h>>2]<<3)>>2]=f[i>>2];i=Uyc(a,(f[g>>2]|0)+b|0,c,k)|0;f[p+24>>2]=i;i=f[h>>2]|0;h=f[j>>2]|0;f[p+12>>2]=f[h+(i<<3)+4>>2];g=f[k>>2]|0;f[p+16>>2]=f[g+(i<<3)>>2];i=f[a+72>>2]|0;if(!i)if(!g)w=h;else v=24;else{s=f[d>>2]|0;t=0;do{l=h+(t<<3)|0;r=g+(t<<3)|0;f[s+(t<<3)>>2]=f[(+n[r>>2]<+n[l>>2]?r:l)>>2];l=h+(t<<3)+4|0;r=g+(t<<3)+4|0;f[s+(t<<3)+4>>2]=f[(+n[l>>2]<+n[r>>2]?r:l)>>2];t=t+1|0}while(t>>>0<i>>>0);v=24}if((v|0)==24){v=k+4|0;k=f[v>>2]|0;if((k|0)!=(g|0))f[v>>2]=k+(~((k+-8-g|0)>>>3)<<3);cYc(g);w=f[j>>2]|0}if(w|0){g=j+4|0;j=f[g>>2]|0;if((j|0)!=(w|0))f[g>>2]=j+(~((j+-8-w|0)>>>3)<<3);cYc(w)}u=e;return p|0}f[p+24>>2]=0;f[p+20>>2]=0;f[p>>2]=b;f[p+4>>2]=c;w=f[a+72>>2]|0;j=(w|0)==0;if(!j){g=(f[a+16>>2]|0)+((Y(f[a+12>>2]|0,f[(f[a+40>>2]|0)+(b<<2)>>2]|0)|0)<<2)|0;k=f[d>>2]|0;v=0;do{i=g+(v<<2)|0;f[k+(v<<3)>>2]=f[i>>2];f[k+(v<<3)+4>>2]=f[i>>2];v=v+1|0}while(v>>>0<w>>>0)}v=b+1|0;if((v|0)>=(c|0)){u=e;return p|0}b=f[d>>2]|0;if(j){u=e;return p|0}j=f[a+40>>2]|0;d=f[a+16>>2]|0;k=f[a+12>>2]|0;a=v;do{v=d+((Y(k,f[j+(a<<2)>>2]|0)|0)<<2)|0;g=0;do{i=b+(g<<3)|0;t=v+(g<<2)|0;x=+n[t>>2];if(+n[i>>2]>x){n[i>>2]=x;y=+n[t>>2]}else y=x;t=b+(g<<3)+4|0;if(+n[t>>2]<y)n[t>>2]=y;g=g+1|0}while(g>>>0<w>>>0);a=a+1|0}while((a|0)!=(c|0));u=e;return p|0}function Vyc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0;i=u;u=u+16|0;j=i+4|0;k=i;l=f[h>>2]|0;m=+n[l+4>>2];o=+n[l>>2];p=m-o;h=a+72|0;q=f[h>>2]|0;if(q>>>0>1){r=1;t=p;while(1){v=+n[l+(r<<3)+4>>2]-+n[l+(r<<3)>>2];w=v>t?v:t;r=r+1|0;if(r>>>0>=q>>>0){x=w;break}else t=w}}else x=p;f[e>>2]=0;q=f[h>>2]|0;a:do if(!q){y=a+12|0;z=a+16|0;A=0}else{p=x*.9999899864196777;r=a+16|0;B=a+12|0;if((c|0)>1){C=-1.0;D=0;E=q;F=o;G=m;H=0}else{t=-1.0;I=0;w=o;v=m;J=0;K=q;while(1){if(v-w>p?(L=(f[r>>2]|0)+((Y(f[B>>2]|0,f[b>>2]|0)|0)<<2)+(J<<2)|0,M=+n[L>>2],N=M-M,N>t):0){f[e>>2]=I;O=N;P=f[h>>2]|0;Q=I}else{O=t;P=K;Q=J}L=I+1|0;if(L>>>0>=P>>>0){y=B;z=r;A=Q;break a}t=O;I=L;w=+n[l+(L<<3)>>2];v=+n[l+(L<<3)+4>>2];J=Q;K=P}}while(1){if(G-F>p){K=f[r>>2]|0;J=f[B>>2]|0;I=K+((Y(J,f[b>>2]|0)|0)<<2)+(H<<2)|0;L=f[I>>2]|0;I=1;R=L;S=L;v=(f[s>>2]=L,+n[s>>2]);while(1){L=K+((Y(f[b+(I<<2)>>2]|0,J)|0)<<2)+(H<<2)|0;w=+n[L>>2];L=w<(f[s>>2]=S,+n[s>>2]);T=(n[s>>2]=w,f[s>>2]|0);S=L?T:S;t=L?(f[s>>2]=R,+n[s>>2]):v;L=w>t;R=L?T:R;I=I+1|0;if((I|0)==(c|0))break;else v=L?w:t}v=(f[s>>2]=R,+n[s>>2]);t=v-(f[s>>2]=S,+n[s>>2]);if(t>C){f[e>>2]=D;U=t;V=D;W=f[h>>2]|0}else{U=C;V=H;W=E}}else{U=C;V=H;W=E}I=D+1|0;if(I>>>0>=W>>>0){y=B;z=r;A=V;break a}C=U;D=I;E=W;F=+n[l+(I<<3)>>2];G=+n[l+(I<<3)+4>>2];H=V}}while(0);G=(+n[l+(A<<3)>>2]+ +n[l+(A<<3)+4>>2])*.5;l=f[z>>2]|0;z=f[y>>2]|0;y=l+((Y(z,f[b>>2]|0)|0)<<2)+(A<<2)|0;V=f[y>>2]|0;if((c|0)>1){y=1;H=V;W=V;F=(f[s>>2]=V,+n[s>>2]);while(1){E=l+((Y(f[b+(y<<2)>>2]|0,z)|0)<<2)+(A<<2)|0;U=+n[E>>2];E=U<(f[s>>2]=W,+n[s>>2]);D=(n[s>>2]=U,f[s>>2]|0);h=E?D:W;C=E?(f[s>>2]=H,+n[s>>2]):F;E=U>C;e=E?D:H;y=y+1|0;if((y|0)==(c|0)){X=e;Z=h;break}else{H=e;W=h;F=E?U:C}}}else{X=V;Z=V}F=(f[s>>2]=Z,+n[s>>2]);C=(f[s>>2]=X,+n[s>>2]);U=G<F?F:G>C?C:G;n[g>>2]=U;Xyc(a,b,c,A,U,j,k);A=f[j>>2]|0;j=(c|0)/2|0;if((A|0)>(j|0)){_=A;f[d>>2]=_;u=i;return}A=f[k>>2]|0;_=(A|0)<(j|0)?A:j;f[d>>2]=_;u=i;return}function Wyc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;o1c(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function Xyc(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+-1|0;c=a+16|0;j=a+12|0;a=i;k=0;a:while(1){b:do if((k|0)>(a|0))l=k;else{m=f[c>>2]|0;o=f[j>>2]|0;p=k;while(1){q=m+((Y(o,f[b+(p<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]<e)){l=p;break b}q=p+1|0;if((p|0)<(a|0))p=q;else{l=q;break}}}while(0);if((l|0)>(a|0))break;p=f[c>>2]|0;o=f[j>>2]|0;m=a;while(1){r=b+(m<<2)|0;s=f[r>>2]|0;q=p+((Y(o,s)|0)<<2)+(d<<2)|0;if(!(+n[q>>2]>=e))break;if((l|0)<(m|0))m=m+-1|0;else break a}o=b+(l<<2)|0;p=f[o>>2]|0;f[o>>2]=s;f[r>>2]=p;a=m+-1|0;k=l+1|0}f[g>>2]=l;g=i;i=l;c:while(1){d:do if((i|0)>(g|0))t=i;else{l=f[c>>2]|0;k=f[j>>2]|0;a=i;while(1){r=l+((Y(k,f[b+(a<<2)>>2]|0)|0)<<2)+(d<<2)|0;if(!(+n[r>>2]<=e)){t=a;break d}r=a+1|0;if((a|0)<(g|0))a=r;else{t=r;break}}}while(0);if((t|0)>(g|0)){u=21;break}m=f[c>>2]|0;a=f[j>>2]|0;k=g;while(1){v=b+(k<<2)|0;w=f[v>>2]|0;l=m+((Y(a,w)|0)<<2)+(d<<2)|0;if(!(+n[l>>2]>e))break;if((t|0)<(k|0))k=k+-1|0;else{u=21;break c}}a=b+(t<<2)|0;m=f[a>>2]|0;f[a>>2]=w;f[v>>2]=m;g=k+-1|0;i=t+1|0}if((u|0)==21){f[h>>2]=t;return}}function Yyc(a){a=a|0;f[a>>2]=172964;Ptc(a+20|0,f[a+24>>2]|0);return}function Zyc(a){a=a|0;f[a>>2]=172964;Ptc(a+20|0,f[a+24>>2]|0);cYc(a);return}function _yc(a){a=a|0;return}function $yc(a,b){a=a|0;b=b|0;return}function azc(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+32|0;d=c+16|0;e=c+12|0;g=c;h=_i[f[(f[a>>2]|0)+40>>2]&2047](a)|0;f[e>>2]=h;h=a+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=g+11|0;b[i>>0]=9;j=g;k=512094;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[g+9>>0]=0;k=Ntc(h,d,g)|0;j=f[k>>2]|0;if(!j){l=$Xc(36)|0;m=l+16|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[l+28>>2]=172888;f[l+32>>2]=0;m=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=m;f[k>>2]=l;m=f[f[h>>2]>>2]|0;if(!m)n=l;else{f[h>>2]=m;n=f[k>>2]|0}UQ(f[a+24>>2]|0,n);n=a+28|0;f[n>>2]=(f[n>>2]|0)+1;o=l}else o=j;j=o+28|0;l=f[j>>2]|0;n=o+32|0;mi[f[f[l>>2]>>2]&2047](l,n);f[j>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,e,n);if((b[i>>0]|0)>=0){u=c;return}cYc(f[g>>2]|0);u=c;return}function bzc(a){a=a|0;return f[a+4>>2]|0}function czc(a){a=a|0;return f[a+8>>2]|0}function dzc(a){a=a|0;return 0}function ezc(a){a=a|0;return 0}function fzc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;f[a+4>>2]=0;f[a+8>>2]=0;g=a+4|0;f[a>>2]=g;h=f[b+20>>2]|0;i=b+24|0;if((h|0)==(i|0)){u=c;return}b=g;g=h;while(1){h=g+16|0;f[e>>2]=b;f[d>>2]=f[e>>2];Qtc(a,d,h,h)|0;h=f[g+4>>2]|0;if(!h){j=g+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(g|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==(i|0))break;else g=l}u=c;return}function gzc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0;d=a+4|0;if(!(f[d>>2]|0))return;e=a+8|0;g=0;h=f[a+16>>2]|0;a=f[e>>2]|0;while(1){i=h+(a<<2)|0;j=i+-12|0;k=((j>>>0<h>>>0?h:j)+12+(3-h)|0)>>>4<<2;l=c+(k<<2)|0;if(h>>>0<j>>>0){m=h;o=c;p=0.0;while(1){q=+L(+(+n[m>>2]-+n[o>>2]));r=+L(+(+n[m+4>>2]-+n[o+4>>2]));s=+L(+(+n[m+8>>2]-+n[o+8>>2]));t=p+(q+r+s+ +L(+(+n[m+12>>2]-+n[o+12>>2])));m=m+16|0;if(m>>>0>=j>>>0){u=t;break}else{o=o+16|0;p=t}}}else u=0.0;o=h+(k<<2)|0;if(o>>>0<i>>>0){j=l;p=u;m=o;while(1){t=p+ +L(+(+n[m>>2]-+n[j>>2]));m=m+4|0;if(m>>>0>=i>>>0){v=t;break}else{j=j+4|0;p=t}}}else v=u;Hg[f[(f[b>>2]|0)+12>>2]&15](b,v,g);g=g+1|0;j=f[e>>2]|0;if(g>>>0>=(f[d>>2]|0)>>>0)break;else{h=h+(j<<2)|0;a=j}}return}function hzc(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=i+16|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[i+20>>2]|0:k&255;k=b[g+11>>0]|0;n=k<<24>>24<0;o=n?f[g+4>>2]|0:k&255;k=m>>>0<o>>>0;p=k?m:o;if((p|0)!=0?(q=WKc(n?f[g>>2]|0:g,l?f[j>>2]|0:j,p)|0,(q|0)!=0):0){if((q|0)<0)break}else r=4;if((r|0)==4?o>>>0<m>>>0:0)break;q=o>>>0<m>>>0?o:m;if((q|0)!=0?(m=WKc(l?f[j>>2]|0:j,n?f[g>>2]|0:g,q)|0,(m|0)!=0):0){if((m|0)>=0)r=36}else r=20;if((r|0)==20?!k:0)r=36;if((r|0)==36){f[d>>2]=c;f[e>>2]=c;s=e;return s|0}k=i+4|0;m=f[k>>2]|0;if(!m){q=i+8|0;j=f[q>>2]|0;if((f[j>>2]|0)==(i|0))t=j;else{j=q;do{q=f[j>>2]|0;j=q+8|0;l=f[j>>2]|0}while((f[l>>2]|0)!=(q|0));t=l}}else{j=m;while(1){l=f[j>>2]|0;if(!l)break;else j=l}t=j}do if((t|0)!=(h|0)){m=t+16|0;l=b[m+11>>0]|0;q=l<<24>>24<0;p=q?f[t+20>>2]|0:l&255;l=p>>>0<o>>>0?p:o;if((l|0)!=0?(u=WKc(n?f[g>>2]|0:g,q?f[m>>2]|0:m,l)|0,(u|0)!=0):0){if((u|0)<0)break}else r=30;if((r|0)==30?o>>>0<p>>>0:0)break;s=Ntc(a,d,g)|0;return s|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;s=k;return s|0}else{f[d>>2]=t;s=t;return s|0}}while(0);t=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))v=c;else{if(!t){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{w=e;break}}}else{h=t;while(1){k=f[h+4>>2]|0;if(!k){w=h;break}else h=k}}h=w;k=w+16|0;e=b[g+11>>0]|0;o=e<<24>>24<0;n=o?f[g+4>>2]|0:e&255;e=b[k+11>>0]|0;j=e<<24>>24<0;p=j?f[w+20>>2]|0:e&255;e=n>>>0<p>>>0?n:p;if((e|0)!=0?(u=WKc(j?f[k>>2]|0:k,o?f[g>>2]|0:g,e)|0,(u|0)!=0):0){if((u|0)<0){v=h;break}}else r=12;if((r|0)==12?p>>>0<n>>>0:0){v=h;break}s=Ntc(a,d,g)|0;return s|0}while(0);if(!t){f[d>>2]=i;s=i;return s|0}else{i=v;f[d>>2]=i;s=i+4|0;return s|0}return 0}function izc(a){a=a|0;var b=0;f[a>>2]=172904;b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);return}function jzc(a){a=a|0;var b=0;f[a>>2]=172904;b=f[a+4>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);Ptc(a+12|0,f[a+16>>2]|0);cYc(a);return}function kzc(a){a=a|0;var c=0;if(b[a+8>>0]|0)return;c=f[a+4>>2]|0;Yi[f[(f[c>>2]|0)+8>>2]&4095](c);return}function lzc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;h=f[a+4>>2]|0;Fh[f[(f[h>>2]|0)+12>>2]&255](h,b,c,d,e,g);return}function mzc(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0;h=f[a+4>>2]|0;return uj[f[(f[h>>2]|0)+16>>2]&7](h,b,c,d,e,g)|0}function nzc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+20>>2]&2047](c,b);return}function ozc(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;mi[f[(f[c>>2]|0)+24>>2]&2047](c,b);return}function pzc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+28>>2]&2047](b)|0}function qzc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+32>>2]&2047](b)|0}function rzc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+36>>2]&2047](b)|0}function szc(a){a=a|0;var b=0;b=f[a+4>>2]|0;return _i[f[(f[b>>2]|0)+40>>2]&2047](b)|0}function tzc(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;mi[f[(f[c>>2]|0)+44>>2]&2047](a,c);return}function uzc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[a+4>>2]|0;ei[f[(f[e>>2]|0)+48>>2]&511](e,b,c,d);return}function vzc(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(a|0)cYc(a);f[b>>2]=0;return}function wzc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(4)|0;f[a>>2]=f[b>>2];f[c>>2]=a;return}function xzc(a,b,c){a=a|0;b=b|0;c=c|0;a=$Xc(4)|0;f[a>>2]=f[f[b>>2]>>2];f[c>>2]=a;return}function yzc(a,b,c){a=a|0;b=b|0;c=c|0;f[f[c>>2]>>2]=f[f[b>>2]>>2];return}function zzc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Azc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Bzc(a){a=a|0;return 4}function Czc(a){a=a|0;return 22672}function Dzc(a,b,c){a=a|0;b=b|0;c=c|0;nOc(b,f[f[c>>2]>>2]|0)|0;return}function Ezc(a){a=a|0;cYc(a);return}function Fzc(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(a|0)cYc(a);f[b>>2]=0;return}function Gzc(a,b,c){a=a|0;b=b|0;c=c|0;b=$Xc(1)|0;f[c>>2]=b;return}function Hzc(a,b,c){a=a|0;b=b|0;c=c|0;b=$Xc(1)|0;f[c>>2]=b;return}function Izc(a,b,c){a=a|0;b=b|0;c=c|0;return}function Jzc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Kzc(a,b){a=a|0;b=b|0;return f[b>>2]|0}function Lzc(a){a=a|0;return 1}function Mzc(a){a=a|0;return 22712}function Nzc(a,b,c){a=a|0;b=b|0;c=c|0;BM(b,515616,11)|0;return}function Ozc(a){a=a|0;cYc(a);return}function Pzc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+36|0;i=g+12|0;j=g+24|0;k=g;l=g+40|0;f[a>>2]=174156;m=a+12|0;f[a+16>>2]=0;f[a+20>>2]=0;n=a+16|0;f[m>>2]=n;o=f[d>>2]|0;p=d+4|0;if((o|0)!=(p|0)){q=n;n=o;while(1){o=n+16|0;f[i>>2]=q;f[h>>2]=f[i>>2];Qtc(m,h,o,o)|0;o=f[n+4>>2]|0;if(!o){r=n+8|0;s=f[r>>2]|0;if((f[s>>2]|0)==(n|0))t=s;else{s=r;do{r=f[s>>2]|0;s=r+8|0;v=f[s>>2]|0}while((f[v>>2]|0)!=(r|0));t=v}}else{s=o;while(1){v=f[s>>2]|0;if(!v)break;else s=v}t=s}if((t|0)==(p|0))break;else n=t}};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=j+11|0;b[t>>0]=9;n=j;p=512094;m=n+9|0;do{b[n>>0]=b[p>>0]|0;n=n+1|0;p=p+1|0}while((n|0)<(m|0));b[j+9>>0]=0;p=Rtc(d,j)|0;if((b[t>>0]|0)<0)cYc(f[j>>2]|0);j=a+8|0;b[j>>0]=0;if((p|0)!=254){p=Rzc(c,d,e)|0;f[a+4>>2]=p;u=g;return};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=k+11|0;b[p>>0]=8;e=k;f[e>>2]=1701603686;f[e+4>>2]=1701667182;b[k+8>>0]=0;Stc(i,d,k);b[h>>0]=b[l>>0]|0;l=Qzc(c,i,h)|0;f[a+4>>2]=l;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[p>>0]|0)<0)cYc(f[k>>2]|0);b[j>>0]=1;u=g;return}function Qzc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+80|0;g=e+72|0;h=e+24|0;i=e+12|0;j=e;k=iKc((b[c+11>>0]|0)<0?f[c>>2]|0:c,511741)|0;if(!k){l=0;u=e;return l|0}Itc(h,k);if((f[h+32>>2]|0)!=8){oKc(k)|0;c=af(60)|0;Jtc(c,515315);ig(c|0,22128,1)}if((f[h+40>>2]|0)!=(f[a>>2]|0)){oKc(k)|0;m=af(60)|0;Jtc(m,515383);ig(m|0,22128,1)}if((f[h+44>>2]|0)!=(f[a+4>>2]|0)){oKc(k)|0;m=af(60)|0;Jtc(m,515383);ig(m|0,22128,1)}m=i+4|0;f[m>>2]=0;c=i+8|0;f[c>>2]=0;n=i+4|0;f[i>>2]=n;o=h+36|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;h=j+11|0;b[h>>0]=9;p=j;q=512094;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[j+9>>0]=0;q=Ntc(i,g,j)|0;p=f[q>>2]|0;if(!p){r=$Xc(36)|0;s=r+16|0;f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[s+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[r+28>>2]=172888;f[r+32>>2]=0;s=f[g>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[q>>2]=r;s=f[f[i>>2]>>2]|0;if(!s)t=r;else{f[i>>2]=s;t=f[q>>2]|0}UQ(f[m>>2]|0,t);f[c>>2]=(f[c>>2]|0)+1;v=r}else v=p;p=v+28|0;r=f[p>>2]|0;c=v+32|0;mi[f[f[r>>2]>>2]&2047](r,c);f[p>>2]=172892;Ti[f[(f[43223]|0)+4>>2]&511](172892,o,c);if((b[h>>0]|0)<0)cYc(f[j>>2]|0);j=Rzc(a,i,d)|0;mi[f[(f[j>>2]|0)+24>>2]&2047](j,k);oKc(k)|0;Ptc(i,f[n>>2]|0);l=j;u=e;return l|0}function Rzc(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+32|0;e=d+16|0;g=d;h=d+4|0;i=d+26|0;j=d+25|0;k=d+24|0;l=d+23|0;m=d+22|0;n=d+21|0;o=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;p=h+11|0;b[p>>0]=9;q=h;r=512094;s=q+9|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[h+9>>0]=0;r=Rtc(c,h)|0;if((b[p>>0]|0)<0)cYc(f[h>>2]|0);switch(r|0){case 0:{r=$Xc(36)|0;f[r>>2]=174216;h=r+4|0;f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];h=r+20|0;p=r+24|0;f[p>>2]=0;f[r+28>>2]=0;f[h>>2]=p;q=f[c>>2]|0;s=c+4|0;if((q|0)==(s|0)){t=r;u=d;return t|0}v=p;p=q;while(1){q=p+16|0;f[g>>2]=v;f[e>>2]=f[g>>2];Qtc(h,e,q,q)|0;q=f[p+4>>2]|0;if(!q){w=p+8|0;x=f[w>>2]|0;if((f[x>>2]|0)==(p|0))y=x;else{x=w;do{w=f[x>>2]|0;x=w+8|0;z=f[x>>2]|0}while((f[z>>2]|0)!=(w|0));y=z}}else{x=q;while(1){z=f[x>>2]|0;if(!z)break;else x=z}y=x}if((y|0)==(s|0)){t=r;break}else p=y}u=d;return t|0}case 4:{y=$Xc(120)|0;b[e>>0]=b[i>>0]|0;Szc(y,a,c,e);t=y;u=d;return t|0}case 1:{y=$Xc(96)|0;b[e>>0]=b[j>>0]|0;Tzc(y,a,c,e);t=y;u=d;return t|0}case 2:{y=$Xc(104)|0;b[e>>0]=b[k>>0]|0;Uzc(y,a,c,e);t=y;u=d;return t|0}case 3:{y=$Xc(24)|0;b[e>>0]=b[l>>0]|0;Vzc(y,a,c,e);t=y;u=d;return t|0}case 255:{y=$Xc(120)|0;b[e>>0]=b[m>>0]|0;Wzc(y,a,c,e);t=y;u=d;return t|0}case 5:{y=$Xc(104)|0;b[e>>0]=b[n>>0]|0;Xzc(y,a,c,e);t=y;u=d;return t|0}case 6:{y=$Xc(76)|0;b[e>>0]=b[o>>0]|0;Yzc(y,a,c,e);t=y;u=d;return t|0}default:{t=af(60)|0;Jtc(t,512104);ig(t|0,22128,1)}}return 0}function Szc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+48|0;g=e+40|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;f[a>>2]=174712;l=a+4|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+20|0;f[a+24>>2]=0;f[a+28>>2]=0;m=a+24|0;f[c>>2]=m;n=f[d>>2]|0;o=d+4|0;if((n|0)!=(o|0)){p=m;m=n;while(1){n=m+16|0;f[h>>2]=p;f[g>>2]=f[h>>2];Qtc(c,g,n,n)|0;n=f[m+4>>2]|0;if(!n){q=m+8|0;r=f[q>>2]|0;if((f[r>>2]|0)==(m|0))s=r;else{r=q;do{q=f[r>>2]|0;r=q+8|0;t=f[r>>2]|0}while((f[t>>2]|0)!=(q|0));s=t}}else{r=n;while(1){t=f[r>>2]|0;if(!t)break;else r=t}s=r}if((s|0)==(o|0))break;else m=s}}s=a+40|0;m=a+44|0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+88>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[a+104>>2]=8192;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;g=a+68|0;f[g>>2]=f[l>>2];l=a+72|0;f[l>>2]=f[a+8>>2];f[a+76>>2]=0;c=i+4|0;f[c>>2]=0;f[c+4>>2]=0;c=i+11|0;b[c>>0]=3;b[i>>0]=b[515177]|0;b[i+1>>0]=b[515178]|0;b[i+2>>0]=b[515179]|0;b[i+3>>0]=0;h=auc(d,i)|0;do if((h|0)!=(o|0)){p=h+28|0;n=f[p>>2]|0;t=(_i[f[(f[n>>2]|0)+28>>2]&2047](n)|0)+4|0;if((f[t>>2]|0)==(f[6379]|0)){t=f[p>>2]|0;p=Mi[f[(f[t>>2]|0)+20>>2]&1023](t,h+32|0)|0;v=f[p>>2]|0;break}else ig(af(1)|0,22144,0)}else v=-1;while(0);if((b[c>>0]|0)<0)cYc(f[i>>2]|0);if((v|0)>0)f[l>>2]=v;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=$Xc(16)|0;f[j>>2]=v;f[j+8>>2]=-2147483632;f[j+4>>2]=13;l=v;i=515181;c=l+13|0;do{b[l>>0]=b[i>>0]|0;l=l+1|0;i=i+1|0}while((l|0)<(c|0));b[v+13>>0]=0;v=auc(d,j)|0;do if((v|0)!=(o|0)){i=v+28|0;l=f[i>>2]|0;c=(_i[f[(f[l>>2]|0)+28>>2]&2047](l)|0)+4|0;if((f[c>>2]|0)==(f[6379]|0)){c=f[i>>2]|0;i=Mi[f[(f[c>>2]|0)+20>>2]&1023](c,v+32|0)|0;w=f[i>>2]|0;break}else ig(af(1)|0,22144,0)}else w=10;while(0);f[a+32>>2]=w;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);f[k+8>>2]=0;j=k+11|0;b[j>>0]=7;b[k>>0]=b[515195]|0;b[k+1>>0]=b[515196]|0;b[k+2>>0]=b[515197]|0;b[k+3>>0]=b[515198]|0;b[k+4>>0]=b[515199]|0;b[k+5>>0]=b[515200]|0;b[k+6>>0]=b[515201]|0;b[k+7>>0]=0;w=auc(d,k)|0;do if((w|0)!=(o|0)){d=w+28|0;v=f[d>>2]|0;i=(_i[f[(f[v>>2]|0)+28>>2]&2047](v)|0)+4|0;if((f[i>>2]|0)==(f[6363]|0)){i=f[d>>2]|0;d=Mi[f[(f[i>>2]|0)+20>>2]&1023](i,w+32|0)|0;x=(b[d>>0]|0)!=0&1;break}else ig(af(1)|0,22144,0)}else x=1;while(0);b[a+36>>0]=x;if((b[j>>0]|0)<0)cYc(f[k>>2]|0);k=f[g>>2]|0;j=f[m>>2]|0;x=f[s>>2]|0;a=j-x>>2;w=x;x=j;if(k>>>0<=a>>>0)if(k>>>0<a>>>0?(j=w+(k<<2)|0,(x|0)!=(j|0)):0){f[m>>2]=x+(~((x+-4-j|0)>>>2)<<2);y=k}else y=k;else{CS(s,k-a|0);y=f[g>>2]|0}if(!y){u=e;return}y=f[s>>2]|0;s=0;do{f[y+(s<<2)>>2]=s;s=s+1|0}while(s>>>0<(f[g>>2]|0)>>>0);u=e;return}function Tzc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+32|0;g=e+16|0;h=e+12|0;i=e;f[a>>2]=174456;j=a+8|0;f[j>>2]=0;k=a+12|0;f[k>>2]=0;f[a+16>>2]=0;l=a+20|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+36|0;f[a+40>>2]=0;f[a+44>>2]=0;m=a+40|0;f[c>>2]=m;n=f[d>>2]|0;o=d+4|0;if((n|0)!=(o|0)){d=m;p=n;while(1){n=p+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,n,n)|0;n=f[p+4>>2]|0;if(!n){q=p+8|0;r=f[q>>2]|0;if((f[r>>2]|0)==(p|0))s=r;else{r=q;do{q=f[r>>2]|0;r=q+8|0;t=f[r>>2]|0}while((f[t>>2]|0)!=(q|0));s=t}}else{r=n;while(1){t=f[r>>2]|0;if(!t)break;else r=t}s=r}if((s|0)==(o|0))break;else p=s}}f[a+80>>2]=8192;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+84>>2]=0;f[a+88>>2]=0;s=a+48|0;f[s>>2]=f[l>>2];l=a+52|0;f[l>>2]=f[a+24>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=i+11|0;b[p>>0]=5;b[i>>0]=b[512723]|0;b[i+1>>0]=b[512724]|0;b[i+2>>0]=b[512725]|0;b[i+3>>0]=b[512726]|0;b[i+4>>0]=b[512727]|0;b[i+5>>0]=0;o=auc(c,i)|0;do if((o|0)!=(m|0)){c=o+28|0;g=f[c>>2]|0;h=(_i[f[(f[g>>2]|0)+28>>2]&2047](g)|0)+4|0;if((f[h>>2]|0)==(f[6379]|0)){h=f[c>>2]|0;c=Mi[f[(f[h>>2]|0)+20>>2]&1023](h,o+32|0)|0;v=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else v=4;while(0);o=a+4|0;f[o>>2]=v;if((b[p>>0]|0)<0){cYc(f[i>>2]|0);w=f[o>>2]|0}else w=v;v=bYc(w>>>0>1073741823?-1:w<<2)|0;f[a+64>>2]=v;v=f[s>>2]|0;w=f[k>>2]|0;o=f[j>>2]|0;i=w-o>>2;p=o;o=w;if(v>>>0<=i>>>0)if(v>>>0<i>>>0?(w=p+(v<<2)|0,(o|0)!=(w|0)):0){f[k>>2]=o+(~((o+-4-w|0)>>>2)<<2);x=v}else x=v;else{CS(j,v-i|0);x=f[s>>2]|0}if(!x){y=f[l>>2]|0;z=y<<2;A=y>>>0>1073741823;B=A?-1:z;C=bYc(B)|0;D=a+56|0;f[D>>2]=C;E=bYc(B)|0;F=a+60|0;f[F>>2]=E;u=e;return}x=f[j>>2]|0;j=0;do{f[x+(j<<2)>>2]=j;j=j+1|0}while(j>>>0<(f[s>>2]|0)>>>0);y=f[l>>2]|0;z=y<<2;A=y>>>0>1073741823;B=A?-1:z;C=bYc(B)|0;D=a+56|0;f[D>>2]=C;E=bYc(B)|0;F=a+60|0;f[F>>2]=E;u=e;return}function Uzc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+48|0;g=e+40|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;f[a>>2]=174572;l=a+28|0;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=a+44|0;f[a+48>>2]=0;f[a+52>>2]=0;m=a+48|0;f[c>>2]=m;o=f[d>>2]|0;p=d+4|0;if((o|0)!=(p|0)){q=m;m=o;while(1){o=m+16|0;f[h>>2]=q;f[g>>2]=f[h>>2];Qtc(c,g,o,o)|0;o=f[m+4>>2]|0;if(!o){r=m+8|0;s=f[r>>2]|0;if((f[s>>2]|0)==(m|0))t=s;else{s=r;do{r=f[s>>2]|0;s=r+8|0;v=f[s>>2]|0}while((f[v>>2]|0)!=(r|0));t=v}}else{s=o;while(1){v=f[s>>2]|0;if(!v)break;else s=v}t=s}if((t|0)==(p|0))break;else m=t}}f[a+64>>2]=0;f[a+68>>2]=0;f[a+88>>2]=8192;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+56>>2]=f[l>>2];f[a+60>>2]=f[a+32>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;l=i+11|0;b[l>>0]=9;t=i;m=512667;g=t+9|0;do{b[t>>0]=b[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(g|0));b[i+9>>0]=0;c=auc(d,i)|0;do if((c|0)!=(p|0)){h=c+28|0;q=f[h>>2]|0;o=(_i[f[(f[q>>2]|0)+28>>2]&2047](q)|0)+4|0;if((f[o>>2]|0)==(f[6379]|0)){o=f[h>>2]|0;h=Mi[f[(f[o>>2]|0)+20>>2]&1023](o,c+32|0)|0;w=f[h>>2]|0;break}else ig(af(1)|0,22144,0)}else w=32;while(0);f[a+12>>2]=w;if((b[l>>0]|0)<0)cYc(f[i>>2]|0);i=j+11|0;b[i>>0]=10;t=j;m=514827;g=t+10|0;do{b[t>>0]=b[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(g|0));b[j+10>>0]=0;l=auc(d,j)|0;do if((l|0)!=(p|0)){w=l+28|0;c=f[w>>2]|0;h=(_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0)+4|0;if((f[h>>2]|0)==(f[6379]|0)){h=f[w>>2]|0;w=Mi[f[(f[h>>2]|0)+20>>2]&1023](h,l+32|0)|0;x=f[w>>2]|0;break}else ig(af(1)|0,22144,0)}else x=11;while(0);l=a+16|0;f[l>>2]=x;if((b[i>>0]|0)<0){cYc(f[j>>2]|0);y=f[l>>2]|0}else y=x;if((y|0)<0)f[l>>2]=2147483647;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;l=$Xc(16)|0;f[k>>2]=l;f[k+8>>2]=-2147483632;f[k+4>>2]=12;t=l;m=512677;g=t+12|0;do{b[t>>0]=b[m>>0]|0;t=t+1|0;m=m+1|0}while((t|0)<(g|0));b[l+12>>0]=0;l=auc(d,k)|0;do if((l|0)!=(p|0)){d=l+28|0;m=f[d>>2]|0;t=(_i[f[(f[m>>2]|0)+28>>2]&2047](m)|0)+4|0;if((f[t>>2]|0)==512690){t=f[d>>2]|0;d=Mi[f[(f[t>>2]|0)+20>>2]&1023](t,l+32|0)|0;z=f[d>>2]|0;break}else ig(af(1)|0,22144,0)}else z=0;while(0);l=a+20|0;f[l>>2]=z;if((b[k+11>>0]|0)<0){cYc(f[k>>2]|0);A=f[l>>2]|0}else A=z;switch(A|0){case 1:{B=179;C=0;D=a+4|0;f[D>>2]=B;E=a+8|0;f[E>>2]=C;F=a+24|0;n[F>>2]=.4000000059604645;u=e;return}case 2:{B=180;C=0;D=a+4|0;f[D>>2]=B;E=a+8|0;f[E>>2]=C;F=a+24|0;n[F>>2]=.4000000059604645;u=e;return}case 0:{B=178;C=0;D=a+4|0;f[D>>2]=B;E=a+8|0;f[E>>2]=C;F=a+24|0;n[F>>2]=.4000000059604645;u=e;return}default:{e=af(60)|0;Jtc(e,512739);ig(e|0,22128,1)}}}function Vzc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e+4|0;h=e;i=e+9|0;j=e+8|0;f[a>>2]=174652;k=a+12|0;f[a+16>>2]=0;f[a+20>>2]=0;l=a+16|0;f[k>>2]=l;m=f[d>>2]|0;n=d+4|0;if((m|0)!=(n|0)){o=l;l=m;while(1){m=l+16|0;f[h>>2]=o;f[g>>2]=f[h>>2];Qtc(k,g,m,m)|0;m=f[l+4>>2]|0;if(!m){p=l+8|0;q=f[p>>2]|0;if((f[q>>2]|0)==(l|0))r=q;else{q=p;do{p=f[q>>2]|0;q=p+8|0;s=f[q>>2]|0}while((f[s>>2]|0)!=(p|0));r=s}}else{q=m;while(1){s=f[q>>2]|0;if(!s)break;else q=s}r=q}if((r|0)==(n|0))break;else l=r}}r=$Xc(96)|0;b[g>>0]=b[i>>0]|0;Tzc(r,c,d,g);f[a+8>>2]=r;r=$Xc(104)|0;b[g>>0]=b[j>>0]|0;Uzc(r,c,d,g);f[a+4>>2]=r;u=e;return}function Wzc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0,y=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;f[a>>2]=174396;f[a+12>>2]=0;f[a+16>>2]=0;f[a+8>>2]=a+12;Yvc(a+20|0,32,0.0,1);k=a+84|0;l=a+32|0;m=l+48|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[k+8>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=$Xc(32)|0;f[g>>2]=c;f[g+8>>2]=-2147483616;f[g+4>>2]=16;l=c;k=513128;m=l+16|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[c+16>>0]=0;c=auc(d,g)|0;o=d+4|0;do if((c|0)!=(o|0)){p=c+28|0;q=f[p>>2]|0;r=(_i[f[(f[q>>2]|0)+28>>2]&2047](q)|0)+4|0;if((f[r>>2]|0)==(f[6387]|0)){r=f[p>>2]|0;p=Mi[f[(f[r>>2]|0)+20>>2]&1023](r,c+32|0)|0;s=+n[p>>2];break}else ig(af(1)|0,22144,0)}else s=.800000011920929;while(0);n[a+100>>2]=s;if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;g=$Xc(16)|0;f[h>>2]=g;f[h+8>>2]=-2147483632;f[h+4>>2]=12;l=g;k=513145;m=l+12|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[g+12>>0]=0;g=auc(d,h)|0;do if((g|0)!=(o|0)){c=g+28|0;p=f[c>>2]|0;r=(_i[f[(f[p>>2]|0)+28>>2]&2047](p)|0)+4|0;if((f[r>>2]|0)==(f[6387]|0)){r=f[c>>2]|0;c=Mi[f[(f[r>>2]|0)+20>>2]&1023](r,g+32|0)|0;t=+n[c>>2];break}else ig(af(1)|0,22144,0)}else t=.009999999776482582;while(0);n[a+104>>2]=t;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;h=$Xc(16)|0;f[i>>2]=h;f[i+8>>2]=-2147483632;f[i+4>>2]=13;l=h;k=513158;m=l+13|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[h+13>>0]=0;h=auc(d,i)|0;do if((h|0)!=(o|0)){g=h+28|0;c=f[g>>2]|0;r=(_i[f[(f[c>>2]|0)+28>>2]&2047](c)|0)+4|0;if((f[r>>2]|0)==(f[6387]|0)){r=f[g>>2]|0;g=Mi[f[(f[r>>2]|0)+20>>2]&1023](r,h+32|0)|0;v=+n[g>>2];break}else ig(af(1)|0,22144,0)}else v=0.0;while(0);n[a+108>>2]=v;if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=$Xc(16)|0;f[j>>2]=i;f[j+8>>2]=-2147483632;f[j+4>>2]=15;l=i;k=513172;m=l+15|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(m|0));b[i+15>>0]=0;i=auc(d,j)|0;do if((i|0)!=(o|0)){d=i+28|0;k=f[d>>2]|0;l=(_i[f[(f[k>>2]|0)+28>>2]&2047](k)|0)+4|0;if((f[l>>2]|0)==(f[6387]|0)){l=f[d>>2]|0;d=Mi[f[(f[l>>2]|0)+20>>2]&1023](l,i+32|0)|0;w=+n[d>>2];break}else ig(af(1)|0,22144,0)}else w=.10000000149011612;while(0);n[a+112>>2]=w;if((b[j+11>>0]|0)>=0){x=a+4|0;f[x>>2]=0;y=a+80|0;n[y>>2]=0.0;u=e;return}cYc(f[j>>2]|0);x=a+4|0;f[x>>2]=0;y=a+80|0;n[y>>2]=0.0;u=e;return}function Xzc(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+80|0;g=e+64|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;f[a>>2]=174336;n=a+12|0;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];f[n+8>>2]=f[c+8>>2];f[n+12>>2]=f[c+12>>2];c=a+28|0;f[a+32>>2]=0;f[a+36>>2]=0;o=a+32|0;f[c>>2]=o;p=f[d>>2]|0;q=d+4|0;if((p|0)!=(q|0)){d=o;r=p;while(1){p=r+16|0;f[h>>2]=d;f[g>>2]=f[h>>2];Qtc(c,g,p,p)|0;p=f[r+4>>2]|0;if(!p){s=r+8|0;t=f[s>>2]|0;if((f[t>>2]|0)==(r|0))v=t;else{t=s;do{s=f[t>>2]|0;t=s+8|0;w=f[t>>2]|0}while((f[w>>2]|0)!=(s|0));v=w}}else{t=p;while(1){w=f[t>>2]|0;if(!w)break;else t=w}v=t}if((v|0)==(q|0))break;else r=v}}v=a+48|0;f[v>>2]=0;r=a+52|0;f[r>>2]=0;f[a+72>>2]=8192;f[a+60>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+40>>2]=f[n>>2];f[a+44>>2]=f[a+16>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=i+11|0;b[n>>0]=9;q=i;g=512667;h=q+9|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[i+9>>0]=0;d=auc(c,i)|0;do if((d|0)!=(o|0)){p=d+28|0;w=f[p>>2]|0;s=(_i[f[(f[w>>2]|0)+28>>2]&2047](w)|0)+4|0;if((f[s>>2]|0)==(f[6379]|0)){s=f[p>>2]|0;p=Mi[f[(f[s>>2]|0)+20>>2]&1023](s,d+32|0)|0;x=f[p>>2]|0;break}else ig(af(1)|0,22144,0)}else x=32;while(0);f[a+88>>2]=x;if((b[n>>0]|0)<0)cYc(f[i>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;i=$Xc(16)|0;f[j>>2]=i;f[j+8>>2]=-2147483632;f[j+4>>2]=12;q=i;g=512677;h=q+12|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[i+12>>0]=0;i=auc(c,j)|0;do if((i|0)!=(o|0)){n=i+28|0;x=f[n>>2]|0;d=(_i[f[(f[x>>2]|0)+28>>2]&2047](x)|0)+4|0;if((f[d>>2]|0)==512690){d=f[n>>2]|0;n=Mi[f[(f[d>>2]|0)+20>>2]&1023](d,i+32|0)|0;y=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else y=0;while(0);i=a+96|0;f[i>>2]=y;if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=k+11|0;b[j>>0]=5;b[k>>0]=b[512723]|0;b[k+1>>0]=b[512724]|0;b[k+2>>0]=b[512725]|0;b[k+3>>0]=b[512726]|0;b[k+4>>0]=b[512727]|0;b[k+5>>0]=0;y=auc(c,k)|0;do if((y|0)!=(o|0)){n=y+28|0;d=f[n>>2]|0;x=(_i[f[(f[d>>2]|0)+28>>2]&2047](d)|0)+4|0;if((f[x>>2]|0)==(f[6379]|0)){x=f[n>>2]|0;n=Mi[f[(f[x>>2]|0)+20>>2]&1023](x,y+32|0)|0;z=f[n>>2]|0;break}else ig(af(1)|0,22144,0)}else z=4;while(0);y=a+92|0;f[y>>2]=z;if((b[j>>0]|0)<0)cYc(f[k>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;k=l+11|0;b[k>>0]=9;q=l;g=512729;h=q+9|0;do{b[q>>0]=b[g>>0]|0;q=q+1|0;g=g+1|0}while((q|0)<(h|0));b[l+9>>0]=0;g=auc(c,l)|0;do if((g|0)!=(o|0)){q=g+28|0;h=f[q>>2]|0;j=(_i[f[(f[h>>2]|0)+28>>2]&2047](h)|0)+4|0;if((f[j>>2]|0)==(f[6379]|0)){j=f[q>>2]|0;q=Mi[f[(f[j>>2]|0)+20>>2]&1023](j,g+32|0)|0;A=f[q>>2]|0;break}else ig(af(1)|0,22144,0)}else A=100;while(0);f[a+100>>2]=A;if((b[k>>0]|0)<0)cYc(f[l>>2]|0);switch(f[i>>2]|0){case 0:{B=181;C=0;break}case 1:{B=182;C=0;break}case 2:{B=183;C=0;break}case 3:{B=184;C=0;break}default:{i=af(60)|0;Jtc(i,512739);ig(i|0,22128,1)}}f[a+4>>2]=B;f[a+8>>2]=C;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;C=m+11|0;b[C>>0]=5;b[m>>0]=b[512723]|0;b[m+1>>0]=b[512724]|0;b[m+2>>0]=b[512725]|0;b[m+3>>0]=b[512726]|0;b[m+4>>0]=b[512727]|0;b[m+5>>0]=0;a=auc(c,m)|0;do if((a|0)!=(o|0)){c=a+28|0;B=f[c>>2]|0;i=(_i[f[(f[B>>2]|0)+28>>2]&2047](B)|0)+4|0;if((f[i>>2]|0)==(f[6379]|0)){i=f[c>>2]|0;c=Mi[f[(f[i>>2]|0)+20>>2]&1023](i,a+32|0)|0;D=f[c>>2]|0;break}else ig(af(1)|0,22144,0)}else D=4;while(0);f[y>>2]=D;if((b[C>>0]|0)<0){cYc(f[m>>2]|0);E=f[y>>2]|0}else E=D;D=E>>>0>1073741823?-1:E<<2;y=bYc(D)|0;f[v>>2]=y;m=bYc(D)|0;f[r>>2]=m;if((E|0)<=0){u=e;return}f[y>>2]=0;f[f[r>>2]>>2]=0;if((E|0)==1){u=e;return}else F=1;do{f[(f[v>>2]|0)+(F<<2)>>2]=0;f[(f[r>>2]|0)+(F<<2)>>2]=0;F=F+1|0}while((F|0)!=(E|0));u=e;return}
function wOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!b)return;wOa(a,f[b>>2]|0);wOa(a,f[b+4>>2]|0);a=b+24|0;c=b+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(a);f[c>>2]=0;c=b+40|0;a=b+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[b+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[b+68>>2]|0;if((a|0)!=(b+72|0))wL(a);cYc(b);return}function xOa(a,b){a=a|0;b=b|0;if(!b)return;else{xOa(a,f[b>>2]|0);xOa(a,f[b+4>>2]|0);cYc(b);return}}function yOa(a,b){a=a|0;b=b|0;if(!b)return;else{yOa(a,f[b>>2]|0);yOa(a,f[b+4>>2]|0);cYc(b);return}}function zOa(a,b){a=a|0;b=b|0;if(!b)return;else{zOa(a,f[b>>2]|0);zOa(a,f[b+4>>2]|0);AOa(b+20|0);cYc(b);return}}function AOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;BOa(a+204|0,f[a+208>>2]|0);hx(a+192|0);c=f[a+180>>2]|0;if(c|0){d=a+184|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-4-c|0)>>>2)<<2);cYc(c)}hx(a+168|0);c=f[a+164>>2]|0;if(c|0)UXc(c);c=a+148|0;e=f[c>>2]|0;if(e|0){d=a+152|0;g=f[d>>2]|0;if((g|0)==(e|0))h=e;else{i=g;while(1){g=i+-8|0;f[d>>2]=g;j=f[i+-4>>2]|0;if(!j)k=g;else{UXc(j);k=f[d>>2]|0}if((k|0)==(e|0))break;else i=k}h=f[c>>2]|0}cYc(h)}h=a+136|0;c=f[h>>2]|0;if(c|0){k=a+140|0;i=f[k>>2]|0;if((i|0)==(c|0))l=c;else{e=i;while(1){i=e+-8|0;f[k>>2]=i;d=f[e+-4>>2]|0;if(!d)m=i;else{UXc(d);m=f[k>>2]|0}if((m|0)==(c|0))break;else e=m}l=f[h>>2]|0}cYc(l)}l=a+124|0;h=f[l>>2]|0;if(h|0){m=a+128|0;e=f[m>>2]|0;if((e|0)==(h|0))n=h;else{c=e;while(1){e=c+-8|0;f[m>>2]=e;k=f[c+-4>>2]|0;if(!k)o=e;else{UXc(k);o=f[m>>2]|0}if((o|0)==(h|0))break;else c=o}n=f[l>>2]|0}cYc(n)}n=f[a+112>>2]|0;if(n|0){l=a+116|0;o=f[l>>2]|0;if((o|0)!=(n|0))f[l>>2]=o+(~((o+-8-n|0)>>>3)<<3);cYc(n)}ILa(a+100|0,f[a+104>>2]|0);ILa(a+88|0,f[a+92>>2]|0);n=f[a+76>>2]|0;if(n|0){o=a+80|0;l=f[o>>2]|0;if((l|0)!=(n|0))f[o>>2]=l+(~((l+-8-n|0)>>>3)<<3);cYc(n)}n=a+64|0;if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);n=a+52|0;if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);hx(a+40|0);QGa(a+28|0,f[a+32>>2]|0);n=a+16|0;if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);n=a+4|0;if((b[n+11>>0]|0)>=0)return;cYc(f[n>>2]|0);return}function BOa(a,b){a=a|0;b=b|0;if(!b)return;BOa(a,f[b>>2]|0);BOa(a,f[b+4>>2]|0);a=f[b+24>>2]|0;if(a|0)UXc(a);cYc(b);return}function COa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f[a>>2]=f[b>>2];c=a+4|0;d=b+4|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;d=a+16|0;c=b+16|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];f[d+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=a+28|0;d=b+28|0;f[c>>2]=f[d>>2];e=f[b+32>>2]|0;f[a+32>>2]=e;g=b+36|0;h=f[g>>2]|0;f[a+36>>2]=h;i=a+32|0;if(!h)f[c>>2]=i;else{f[e+8>>2]=i;i=b+32|0;f[d>>2]=i;f[i>>2]=0;f[g>>2]=0}g=a+40|0;i=b+40|0;f[g>>2]=0;d=a+44|0;f[d>>2]=0;f[a+48>>2]=0;f[g>>2]=f[i>>2];g=b+44|0;f[d>>2]=f[g>>2];d=b+48|0;f[a+48>>2]=f[d>>2];f[d>>2]=0;f[g>>2]=0;f[i>>2]=0;i=a+52|0;g=b+52|0;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=a+64|0;i=b+64|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=a+76|0;g=b+76|0;f[i>>2]=0;d=a+80|0;f[d>>2]=0;f[a+84>>2]=0;f[i>>2]=f[g>>2];i=b+80|0;f[d>>2]=f[i>>2];d=b+84|0;f[a+84>>2]=f[d>>2];f[d>>2]=0;f[i>>2]=0;f[g>>2]=0;g=a+88|0;i=b+88|0;f[g>>2]=f[i>>2];d=f[b+92>>2]|0;f[a+92>>2]=d;e=b+96|0;c=f[e>>2]|0;f[a+96>>2]=c;h=a+92|0;if(!c)f[g>>2]=h;else{f[d+8>>2]=h;h=b+92|0;f[i>>2]=h;f[h>>2]=0;f[e>>2]=0}e=a+100|0;h=b+100|0;f[e>>2]=f[h>>2];i=f[b+104>>2]|0;f[a+104>>2]=i;d=b+108|0;g=f[d>>2]|0;f[a+108>>2]=g;c=a+104|0;if(!g)f[e>>2]=c;else{f[i+8>>2]=c;c=b+104|0;f[h>>2]=c;f[c>>2]=0;f[d>>2]=0}d=a+112|0;c=b+112|0;f[d>>2]=0;h=a+116|0;f[h>>2]=0;f[a+120>>2]=0;f[d>>2]=f[c>>2];d=b+116|0;f[h>>2]=f[d>>2];h=b+120|0;f[a+120>>2]=f[h>>2];f[h>>2]=0;f[d>>2]=0;f[c>>2]=0;c=a+124|0;d=b+124|0;f[c>>2]=0;h=a+128|0;f[h>>2]=0;f[a+132>>2]=0;f[c>>2]=f[d>>2];c=b+128|0;f[h>>2]=f[c>>2];h=b+132|0;f[a+132>>2]=f[h>>2];f[h>>2]=0;f[c>>2]=0;f[d>>2]=0;d=a+136|0;c=b+136|0;f[d>>2]=0;h=a+140|0;f[h>>2]=0;f[a+144>>2]=0;f[d>>2]=f[c>>2];d=b+140|0;f[h>>2]=f[d>>2];h=b+144|0;f[a+144>>2]=f[h>>2];f[h>>2]=0;f[d>>2]=0;f[c>>2]=0;c=a+148|0;d=b+148|0;f[c>>2]=0;h=a+152|0;f[h>>2]=0;f[a+156>>2]=0;f[c>>2]=f[d>>2];c=b+152|0;f[h>>2]=f[c>>2];h=b+156|0;f[a+156>>2]=f[h>>2];f[h>>2]=0;f[c>>2]=0;f[d>>2]=0;d=b+160|0;f[a+160>>2]=f[d>>2];c=b+164|0;f[a+164>>2]=f[c>>2];f[d>>2]=0;f[c>>2]=0;c=a+168|0;d=b+168|0;f[c>>2]=0;h=a+172|0;f[h>>2]=0;f[a+176>>2]=0;f[c>>2]=f[d>>2];c=b+172|0;f[h>>2]=f[c>>2];h=b+176|0;f[a+176>>2]=f[h>>2];f[h>>2]=0;f[c>>2]=0;f[d>>2]=0;d=a+180|0;c=b+180|0;f[d>>2]=0;h=a+184|0;f[h>>2]=0;f[a+188>>2]=0;f[d>>2]=f[c>>2];d=b+184|0;f[h>>2]=f[d>>2];h=b+188|0;f[a+188>>2]=f[h>>2];f[h>>2]=0;f[d>>2]=0;f[c>>2]=0;c=a+192|0;d=b+192|0;f[c>>2]=0;h=a+196|0;f[h>>2]=0;f[a+200>>2]=0;f[c>>2]=f[d>>2];c=b+196|0;f[h>>2]=f[c>>2];h=b+200|0;f[a+200>>2]=f[h>>2];f[h>>2]=0;f[c>>2]=0;f[d>>2]=0;d=a+204|0;c=b+204|0;f[d>>2]=f[c>>2];h=f[b+208>>2]|0;f[a+208>>2]=h;i=b+212|0;e=f[i>>2]|0;f[a+212>>2]=e;g=a+208|0;if(!e){f[d>>2]=g;j=a+216|0;k=b+216|0;l=k;m=l;n=f[m>>2]|0;o=l+4|0;p=o;q=f[p>>2]|0;r=j;s=r;f[s>>2]=n;t=r+4|0;u=t;f[u>>2]=q;return}else{f[h+8>>2]=g;g=b+208|0;f[c>>2]=g;f[g>>2]=0;f[i>>2]=0;j=a+216|0;k=b+216|0;l=k;m=l;n=f[m>>2]|0;o=l+4|0;p=o;q=f[p>>2]|0;r=j;s=r;f[s>>2]=n;t=r+4|0;u=t;f[u>>2]=q;return}}function DOa(a){a=a|0;NXc(a);cYc(a);return}function EOa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function FOa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==392438?a+12|0:0)|0}function GOa(a){a=a|0;cYc(a);return}function HOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=82400;hx(a+80|0);c=f[a+68>>2]|0;if(c|0){d=a+72|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-32-c|0)>>>5)<<5);cYc(c)}c=f[a+56>>2]|0;if(c|0){e=a+60|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);cYc(c)}c=a+44|0;d=f[c>>2]|0;if(d|0){e=a+48|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;while(1){g=i+-12|0;f[e>>2]=g;if((b[g+11>>0]|0)<0){cYc(f[g>>2]|0);j=f[e>>2]|0}else j=g;if((j|0)==(d|0))break;else i=j}h=f[c>>2]|0}cYc(h)}f[a>>2]=82204;h=a+28|0;if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);h=a+16|0;if((b[h+11>>0]|0)>=0){k=a+4|0;hx(k);qP(a);return}cYc(f[h>>2]|0);k=a+4|0;hx(k);qP(a);return}function IOa(a){a=a|0;HOa(a);cYc(a);return}function JOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;c=u;u=u+32|0;e=c+12|0;g=c;f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[e+8>>2]=0;gS(d,e);d=f[e>>2]|0;i=(f[h>>2]|0)-d|0;h=(i|0)/56|0;j=f[a+56>>2]|0;k=d;d=j;if((h|0)!=((f[a+60>>2]|0)-j>>3|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(48)|0;f[g>>2]=j;f[g+8>>2]=-2147483600;f[g+4>>2]=37;l=j;m=392830;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+37>>0]=0;vM(-215,g,455619,391289,592)}j=f[a+68>>2]|0;o=j;if((h|0)!=((f[a+72>>2]|0)-j>>5|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(32)|0;f[g>>2]=j;f[g+8>>2]=-2147483616;f[g+4>>2]=30;l=j;m=392868;n=l+30|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+30>>0]=0;vM(-215,g,455619,391289,592)}j=f[a+80>>2]|0;q=j;if((((f[a+84>>2]|0)-j|0)/56|0|0)!=(h|0)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=$Xc(48)|0;f[g>>2]=j;f[g+8>>2]=-2147483600;f[g+4>>2]=35;l=j;m=392899;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[j+35>>0]=0;vM(-215,g,455619,391289,592)}g=a+92|0;b[g>>0]=1;if(!i){hx(e);u=c;return}else r=0;while(1){if((f[q+(r*56|0)+16>>2]|0)!=(f[k+(r*56|0)+16>>2]|0))break;if(+p[d+(r<<3)>>3]!=1.0)break;if(+p[o+(r<<5)>>3]!=0.0)break;if(+p[o+(r<<5)+8>>3]!=0.0)break;if(+p[o+(r<<5)+16>>3]!=0.0)break;if(+p[o+(r<<5)+24>>3]!=0.0)break;r=r+1|0;if(r>>>0>=h>>>0){s=9;break}}if((s|0)==9){hx(e);u=c;return}b[g>>0]=0;hx(e);u=c;return}function KOa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;g=u;u=u+272|0;h=g+136|0;i=g+124|0;j=g+112|0;k=g+56|0;l=g;if((qS(d,-1)|0)==3){fOa(a,c,d,e);u=g;return}f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;gS(d,i);gS(e,j);e=a+80|0;d=a+84|0;c=f[e>>2]|0;a:do if((f[d>>2]|0)!=(c|0)){m=a+56|0;n=a+68|0;o=h+8|0;q=h+4|0;r=h+8|0;s=h+4|0;t=l+36|0;v=l+16|0;w=l+4|0;x=l+40|0;y=l+44|0;z=l+48|0;A=k+36|0;B=k+16|0;C=k+4|0;D=k+40|0;E=k+44|0;F=k+48|0;G=0;H=c;b:while(1){I=H;J=+p[(f[m>>2]|0)+(G<<3)>>3];K=f[n>>2]|0;L=K+(G<<5)|0;M=+p[L>>3];if(!(((M==0.0?+p[K+(G<<5)+8>>3]==0.0:0)?+p[K+(G<<5)+16>>3]==0.0:0)?+p[K+(G<<5)+24>>3]==0.0:0))N=10;if((N|0)==10?(N=0,(f[(f[I+(G*56|0)+40>>2]|0)+4>>2]|0)>=5):0){N=11;break}O=f[i>>2]|0;P=f[O+(G*56|0)>>2]&4095;if((P|0)!=5){N=16;break}if((f[(f[I+(G*56|0)+40>>2]|0)+4>>2]|0)>1){Q=f[(f[I+(G*56|0)+40>>2]|0)+4>>2]|0;if((Q|0)<4){R=1;S=M;do{T=S;S=+p[K+(G<<5)+(R<<3)>>3];U=S==T;R=R+1|0}while(U&(R|0)<(Q|0));V=U}else{Q=1;S=M;do{T=S;S=+p[K+(G<<5)+(Q<<3)>>3];R=S==T;Q=Q+1|0}while(R&(Q|0)<4);V=R}if(!V)if((f[f[I+(G*56|0)+40>>2]>>2]|0)>0){Q=0;R=f[I+(G*56|0)+40>>2]|0;U=I;W=H;while(1){if((f[R+4>>2]|0)>0){X=0;Z=U;do{_=f[Z+(G*56|0)+4>>2]|0;if((_|0)<=2){N=27;break b}$=f[Z+(G*56|0)+40>>2]|0;aa=2;do{f[h+(aa+-2<<2)>>2]=f[$+(aa<<2)>>2];aa=aa+1|0}while((aa|0)!=(_|0));aa=f[Z+(G*56|0)+44>>2]|0;$=(f[Z+(G*56|0)+16>>2]|0)+(Y(f[aa>>2]|0,Q)|0)|0;_$(k,_+-2|0,h,f[Z+(G*56|0)>>2]&4095,$+(Y(f[aa+4>>2]|0,X)|0)|0,0);aa=f[i>>2]|0;$=f[aa+(G*56|0)+4>>2]|0;if(($|0)<=2){N=31;break b}ba=f[aa+(G*56|0)+40>>2]|0;ca=2;do{f[h+(ca+-2<<2)>>2]=f[ba+(ca<<2)>>2];ca=ca+1|0}while((ca|0)!=($|0));ca=f[aa+(G*56|0)+44>>2]|0;ba=(f[aa+(G*56|0)+16>>2]|0)+(Y(f[ca>>2]|0,Q)|0)|0;_$(l,$+-2|0,h,f[aa+(G*56|0)>>2]&4095,ba+(Y(f[ca+4>>2]|0,X)|0)|0,0);ca=r;f[ca>>2]=0;f[ca+4>>2]=0;f[h>>2]=33619968;f[s>>2]=l;dY(k,h,5,J,-(J*+p[K+(G<<5)+(X<<3)>>3]));ca=f[t>>2]|0;if(ca|0?(ba=ca+12|0,ca=f[ba>>2]|0,f[ba>>2]=ca+-1,(ca|0)==1):0)V$(l);f[t>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){ca=f[x>>2]|0;ba=0;do{f[ca+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[w>>2]|0))}ba=f[y>>2]|0;if((ba|0)!=(z|0))wL(ba);ba=f[A>>2]|0;do if(ba|0){ca=ba+12|0;aa=f[ca>>2]|0;f[ca>>2]=aa+-1;if((aa|0)!=1)break;V$(k)}while(0);f[A>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){ba=f[D>>2]|0;aa=0;do{f[ba+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[C>>2]|0))}aa=f[E>>2]|0;if((aa|0)!=(F|0))wL(aa);X=X+1|0;Z=f[e>>2]|0;da=f[Z+(G*56|0)+40>>2]|0}while((X|0)<(f[da+4>>2]|0));ea=da;fa=Z;ga=Z}else{ea=f[U+(G*56|0)+40>>2]|0;fa=W;ga=U}Q=Q+1|0;if((Q|0)>=(f[ea>>2]|0)){ha=fa;break}else{R=ea;U=ga;W=fa}}}else ha=H;else N=21}else N=21;if((N|0)==21){N=0;W=o;f[W>>2]=0;f[W+4>>2]=0;f[h>>2]=33619968;f[q>>2]=O+(G*56|0);dY(I+(G*56|0)|0,h,5,J,-(J*+p[L>>3]));ha=f[e>>2]|0}G=G+1|0;if(G>>>0>=(((f[d>>2]|0)-ha|0)/56|0)>>>0)break a;else H=ha}if((N|0)==11){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=$Xc(48)|0;f[h>>2]=H;f[h+8>>2]=-2147483600;f[h+4>>2]=46;ia=H;ja=392646;ka=ia+46|0;do{b[ia>>0]=b[ja>>0]|0;ia=ia+1|0;ja=ja+1|0}while((ia|0)<(ka|0));b[H+46>>0]=0;vM(-215,h,456135,391289,460)}else if((N|0)==16)kV(P,5,82532);else if((N|0)==27){b[h+11>>0]=10;ia=h;ja=450129;ka=ia+10|0;do{b[ia>>0]=b[ja>>0]|0;ia=ia+1|0;ja=ja+1|0}while((ia|0)<(ka|0));b[h+10>>0]=0;vM(-215,h,450140,454620,110)}else if((N|0)==31){b[h+11>>0]=10;ia=h;ja=450129;ka=ia+10|0;do{b[ia>>0]=b[ja>>0]|0;ia=ia+1|0;ja=ja+1|0}while((ia|0)<(ka|0));b[h+10>>0]=0;vM(-215,h,450140,454620,110)}}while(0);hx(j);hx(i);u=g;return}function LOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+44>>2]|0;e=f[a+48>>2]|0;a=d;g=e;a:do if((d|0)==(e|0))h=d;else{i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c+4>>2]|0:i&255;i=j?f[c>>2]|0:c;j=(k|0)==0;l=d;while(1){m=b[l+11>>0]|0;n=m<<24>>24<0;o=m&255;do if(((n?f[l+4>>2]|0:o)|0)==(k|0)){m=f[l>>2]|0;p=n?m:l;if(n){if(j){h=l;break a}if(!(WKc(p,i,k)|0)){h=l;break a}else break}if(j){h=l;break a}if((m&255)<<24>>24==(b[i>>0]|0)){m=l;p=o;q=i;do{p=p+-1|0;m=m+1|0;if(!p){h=l;break a}q=q+1|0}while((b[m>>0]|0)==(b[q>>0]|0))}}while(0);l=l+12|0;if((l|0)==(e|0)){h=e;break}}}while(0);e=(h-a|0)/12|0;return ((e|0)<((g-a|0)/12|0|0)?e:-1)|0}function MOa(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 3:{c=1;break}case 2:{c=((f[a+84>>2]|0)-(f[a+80>>2]|0)|0)==56;break}default:c=0}return c|0}function NOa(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function OOa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;a=g+12|0;h=g+8|0;i=g+4|0;j=g;k=f[c+4>>2]|0;l=f[c>>2]|0;if(((k-l|0)/12|0|0)==(d|0)){f[i>>2]=l;f[j>>2]=k;f[h>>2]=f[i>>2];f[a>>2]=f[j>>2];POa(e,h,a);u=g;return 0}else{g=$Xc(48)|0;f[a>>2]=g;f[a+8>>2]=-2147483600;f[a+4>>2]=32;h=g;e=392613;j=h+32|0;do{b[h>>0]=b[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(j|0));b[g+32>>0]=0;vM(-215,a,456079,391289,581)}return 0}function POa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[b>>2]|0;e=f[c>>2]|0;g=(e-d|0)/12|0;h=a+8|0;i=f[h>>2]|0;j=f[a>>2]|0;k=d;d=j;l=e;if(g>>>0>((i-j|0)/12|0)>>>0){if(!j)m=i;else{i=a+4|0;n=f[i>>2]|0;if((n|0)==(d|0))o=j;else{p=n;while(1){n=p+-12|0;f[i>>2]=n;q=f[n>>2]|0;if(!q)r=n;else{n=p+-8|0;s=f[n>>2]|0;if((s|0)!=(q|0))f[n>>2]=s+(~((s+-4-q|0)>>>2)<<2);cYc(q);r=f[i>>2]|0}if((r|0)==(d|0))break;else p=r}o=f[a>>2]|0}cYc(o);f[h>>2]=0;f[i>>2]=0;f[a>>2]=0;m=0}if(g>>>0>357913941)kWc(a);i=(m|0)/12|0;m=i<<1;o=i>>>0<178956970?(m>>>0<g>>>0?g:m):357913941;if(o>>>0>357913941)kWc(a);m=$Xc(o*12|0)|0;i=a+4|0;f[i>>2]=m;f[a>>2]=m;f[h>>2]=m+(o*12|0);o=f[b>>2]|0;b=f[c>>2]|0;if((o|0)==(b|0))return;c=m;m=o;do{eKa(c,m);m=m+12|0;c=(f[i>>2]|0)+12|0;f[i>>2]=c}while((m|0)!=(b|0));return}else{b=a+4|0;a=((f[b>>2]|0)-j|0)/12|0;j=g>>>0>a>>>0;g=j?k+(a*12|0)|0:e;if((k|0)==(g|0))t=d;else{e=d;d=k;while(1){if((e|0)!=(d|0))eEa(e,f[d>>2]|0,f[d+4>>2]|0);d=d+12|0;k=e+12|0;if((d|0)==(g|0)){t=k;break}else e=k}}if(j){if((g|0)==(l|0))return;j=f[b>>2]|0;e=g;do{eKa(j,e);e=e+12|0;j=(f[b>>2]|0)+12|0;f[b>>2]=j}while((e|0)!=(l|0));return}l=f[b>>2]|0;if((l|0)==(t|0))return;else u=l;while(1){l=u+-12|0;f[b>>2]=l;e=f[l>>2]|0;if(!e)v=l;else{l=u+-8|0;j=f[l>>2]|0;if((j|0)!=(e|0))f[l>>2]=j+(~((j+-4-e|0)>>>2)<<2);cYc(e);v=f[b>>2]|0}if((v|0)==(t|0))break;else u=v}return}}function QOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;d=u;u=u+16|0;c=d;d=$Xc(96)|0;f[c>>2]=d;f[c+8>>2]=-2147483552;f[c+4>>2]=81;a=d;e=392971;g=a+81|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));b[d+81>>0]=0;vM(-2,c,393053,391289,2538)}function ROa(a){a=a|0;var b=0;b=f[a+4>>2]|0;if(!b)return;UXc(b);return}function SOa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+464|0;h=g+224|0;i=g;j=f[a>>2]|0;k=CHa(j+32|0,c)|0;if((k|0)!=(j+36|0)?(f[k+28>>2]|0)>-1:0){SGa(i,393076,c);k=AYc(i,393084)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;vM(-5,h,393103,391289,2592)}k=f[a>>2]|0;j=k+116|0;l=(f[j>>2]|0)+1|0;f[j>>2]=l;j=k+32|0;lYc(i,c);m=i+12|0;f[m>>2]=l;n=ZGa(j,h,i)|0;if(!(f[n>>2]|0)){o=$Xc(32)|0;p=o+16|0;f[p>>2]=f[i>>2];f[p+4>>2]=f[i+4>>2];f[p+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[o+28>>2]=f[m>>2];m=f[h>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=m;f[n>>2]=o;m=f[f[j>>2]>>2]|0;if(!m)q=o;else{f[j>>2]=m;q=f[n>>2]|0}UQ(f[k+36>>2]|0,q);q=k+40|0;f[q>>2]=(f[q>>2]|0)+1}if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);q=f[a>>2]|0;TOa(i,l,c,d,e);f[h>>2]=l;e=h+4|0;f[e>>2]=f[i>>2];d=h+8|0;c=i+4|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];f[d+8>>2]=f[c+8>>2];f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=h+20|0;d=i+16|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;d=h+32|0;c=i+28|0;f[d>>2]=f[c>>2];a=f[i+32>>2]|0;f[h+36>>2]=a;k=i+36|0;n=f[k>>2]|0;f[h+40>>2]=n;m=h+36|0;if(!n)f[d>>2]=m;else{f[a+8>>2]=m;m=i+32|0;f[c>>2]=m;f[m>>2]=0;f[k>>2]=0}k=i+40|0;f[h+44>>2]=f[k>>2];m=i+44|0;f[h+48>>2]=f[m>>2];c=i+48|0;f[h+52>>2]=f[c>>2];f[c>>2]=0;f[m>>2]=0;f[k>>2]=0;k=h+56|0;m=i+52|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;m=h+68|0;k=i+64|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];f[m+8>>2]=f[k+8>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;k=i+76|0;f[h+80>>2]=f[k>>2];m=i+80|0;f[h+84>>2]=f[m>>2];c=i+84|0;f[h+88>>2]=f[c>>2];f[c>>2]=0;f[m>>2]=0;f[k>>2]=0;k=h+92|0;m=i+88|0;f[k>>2]=f[m>>2];c=f[i+92>>2]|0;f[h+96>>2]=c;a=i+96|0;d=f[a>>2]|0;f[h+100>>2]=d;n=h+96|0;if(!d)f[k>>2]=n;else{f[c+8>>2]=n;n=i+92|0;f[m>>2]=n;f[n>>2]=0;f[a>>2]=0}a=h+104|0;n=i+100|0;f[a>>2]=f[n>>2];m=f[i+104>>2]|0;f[h+108>>2]=m;c=i+108|0;k=f[c>>2]|0;f[h+112>>2]=k;d=h+108|0;if(!k)f[a>>2]=d;else{f[m+8>>2]=d;d=i+104|0;f[n>>2]=d;f[d>>2]=0;f[c>>2]=0}c=i+112|0;f[h+116>>2]=f[c>>2];d=i+116|0;f[h+120>>2]=f[d>>2];n=i+120|0;f[h+124>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[c>>2]=0;c=i+124|0;f[h+128>>2]=f[c>>2];d=i+128|0;f[h+132>>2]=f[d>>2];n=i+132|0;f[h+136>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[c>>2]=0;c=i+136|0;f[h+140>>2]=f[c>>2];d=i+140|0;f[h+144>>2]=f[d>>2];n=i+144|0;f[h+148>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[c>>2]=0;c=i+148|0;f[h+152>>2]=f[c>>2];d=i+152|0;f[h+156>>2]=f[d>>2];n=i+156|0;f[h+160>>2]=f[n>>2];f[n>>2]=0;f[d>>2]=0;f[c>>2]=0;c=i+160|0;f[h+164>>2]=f[c>>2];d=i+164|0;f[h+168>>2]=f[d>>2];f[c>>2]=0;f[d>>2]=0;d=i+168|0;f[h+172>>2]=f[d>>2];c=i+172|0;f[h+176>>2]=f[c>>2];n=i+176|0;f[h+180>>2]=f[n>>2];f[n>>2]=0;f[c>>2]=0;f[d>>2]=0;d=i+180|0;f[h+184>>2]=f[d>>2];c=i+184|0;f[h+188>>2]=f[c>>2];n=i+188|0;f[h+192>>2]=f[n>>2];f[n>>2]=0;f[c>>2]=0;f[d>>2]=0;d=i+192|0;f[h+196>>2]=f[d>>2];c=i+196|0;f[h+200>>2]=f[c>>2];n=i+200|0;f[h+204>>2]=f[n>>2];f[n>>2]=0;f[c>>2]=0;f[d>>2]=0;d=h+208|0;c=i+204|0;f[d>>2]=f[c>>2];n=f[i+208>>2]|0;f[h+212>>2]=n;m=i+212|0;a=f[m>>2]|0;f[h+216>>2]=a;k=h+212|0;if(!a)f[d>>2]=k;else{f[n+8>>2]=k;k=i+208|0;f[c>>2]=k;f[k>>2]=0;f[m>>2]=0}m=i+216|0;k=f[m+4>>2]|0;c=h+220|0;f[c>>2]=f[m>>2];f[c+4>>2]=k;k=q+20|0;c=q+24|0;m=f[c>>2]|0;do if(m){n=f[h>>2]|0;d=q+24|0;a=m;while(1){j=f[a+16>>2]|0;if((n|0)<(j|0)){o=f[a>>2]|0;if(!o){r=27;break}else{s=a;t=o}}else{if((j|0)>=(n|0)){r=31;break}v=a+4|0;j=f[v>>2]|0;if(!j){r=30;break}else{s=v;t=j}}d=s;a=t}if((r|0)==27){w=a;x=a;break}else if((r|0)==30){w=a;x=v;break}else if((r|0)==31){w=a;x=d;break}}else{w=c;x=c}while(0);if(f[x>>2]|0){AOa(e);AOa(i);u=g;return l|0}c=$Xc(244)|0;f[c+16>>2]=f[h>>2];COa(c+20|0,e);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=w;f[x>>2]=c;w=f[f[k>>2]>>2]|0;if(!w)y=c;else{f[k>>2]=w;y=f[x>>2]|0}UQ(f[q+24>>2]|0,y);y=q+28|0;f[y>>2]=(f[y>>2]|0)+1;AOa(e);AOa(i);u=g;return l|0}function TOa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;f[a>>2]=c;c=a+4|0;lYc(c,d);d=a+16|0;lYc(d,e);ENa(a+28|0,g);f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+88>>2]=a+92;f[a+104>>2]=0;f[a+108>>2]=0;f[a+100>>2]=a+104;g=a+204|0;f[a+208>>2]=0;f[a+212>>2]=0;e=a+208|0;h=a+112|0;i=h+92|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;b[a+216>>0]=0;f[a+220>>2]=0;oYc(a+52|0,c)|0;oYc(a+64|0,d)|0;return}function UOa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+48|0;i=h+16|0;j=h+8|0;k=h;l=h+32|0;if((c|0)>=(e|0)){m=$Xc(32)|0;f[i>>2]=m;f[i+8>>2]=-2147483616;f[i+4>>2]=22;n=m;o=393112;p=n+22|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+22>>0]=0;vM(-215,i,393135,391289,1279)}m=a+24|0;a=f[m>>2]|0;if(!a){f[k>>2]=c;DM(i,393143,k);vM(-204,i,393180,391289,1204)}else{q=m;r=a}a:while(1){o=r;while(1){if((f[o+16>>2]|0)>=(c|0))break;n=f[o+4>>2]|0;if(!n){s=q;break a}else o=n}r=f[o>>2]|0;if(!r){s=o;break}else q=o}if((s|0)==(m|0)){f[k>>2]=c;DM(i,393143,k);vM(-204,i,393180,391289,1204)}if((f[s+16>>2]|0)>(c|0)){f[k>>2]=c;DM(i,393143,k);vM(-204,i,393180,391289,1204)}else{t=m;v=a}b:while(1){a=v;while(1){if((f[a+16>>2]|0)>=(e|0))break;k=f[a+4>>2]|0;if(!k){w=t;break b}else a=k}v=f[a>>2]|0;if(!v){w=a;break}else t=a}if((w|0)==(m|0)){f[j>>2]=e;DM(i,393143,j);vM(-204,i,393180,391289,1204)}if((f[w+16>>2]|0)>(e|0)){f[j>>2]=e;DM(i,393143,j);vM(-204,i,393180,391289,1204)}f[l>>2]=c;f[l+4>>2]=d;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];VOa(w+20|0,g,i);g=s+120|0;w=s+124|0;l=f[w>>2]|0;do if(l){c=s+124|0;j=l;while(1){m=f[j+16>>2]|0;if((m|0)>(d|0)){t=f[j>>2]|0;if(!t){x=23;break}else{y=j;z=t}}else{if((m|0)>=(d|0)){x=27;break}A=j+4|0;m=f[A>>2]|0;if(!m){x=26;break}else{y=A;z=m}}c=y;j=z}if((x|0)==23){B=j;C=j;break}else if((x|0)==26){B=j;C=A;break}else if((x|0)==27){B=j;C=c;break}}else{B=w;C=w}while(0);if(!(f[C>>2]|0)){w=$Xc(20)|0;f[w+16>>2]=d;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=B;f[C>>2]=w;B=f[f[g>>2]>>2]|0;if(!B)D=w;else{f[g>>2]=B;D=f[C>>2]|0}UQ(f[s+124>>2]|0,D);D=s+128|0;f[D>>2]=(f[D>>2]|0)+1}f[i>>2]=e;f[i+4>>2]=d;d=s+136|0;e=f[d>>2]|0;if(e>>>0<(f[s+140>>2]|0)>>>0){D=i;C=f[D+4>>2]|0;B=e;f[B>>2]=f[D>>2];f[B+4>>2]=C;f[d>>2]=(f[d>>2]|0)+8;u=h;return}else{WOa(s+132|0,i);u=h;return}}function VOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+32|0;g=e;h=e+8|0;i=a+76|0;j=a+80|0;k=f[j>>2]|0;l=f[i>>2]|0;m=k-l>>3;n=l;do if((m|0)>(c|0)){l=n+(c<<3)|0;o=f[l>>2]|0;p=f[l+4>>2]|0;if((p|o|0)<0)q=n;else{if((o|0)==(f[d>>2]|0)?(p|0)==(f[d+4>>2]|0):0){q=n;break}p=a+4|0;o=(b[p+11>>0]|0)<0?f[p>>2]|0:p;f[g>>2]=c;f[g+4>>2]=o;DM(h,393193,g);vM(-2,h,393239,391289,1239)}}else{o=c+1|0;p=k;if(o>>>0>m>>>0){XOa(i,o-m|0);q=f[i>>2]|0;break}if(o>>>0<m>>>0?(l=n+(o<<3)|0,(p|0)!=(l|0)):0){f[j>>2]=p+(~((p+-8-l|0)>>>3)<<3);q=n}else q=n}while(0);n=d;d=f[n+4>>2]|0;j=q+(c<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=d;u=e;return}function WOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;cYc(d);return}function XOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){g1c(g|0,-1,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)kWc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;g1c(d|0,-1,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;cYc(h);return}function YOa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;UOa(f[a>>2]|0,b,c,d,e);return}function ZOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=e+4|0;f[a>>2]=-1;i=a+4|0;f[i>>2]=-1;j=d+11|0;k=b[j>>0]|0;l=d+4|0;do if((k<<24>>24<0?f[l>>2]|0:k&255)|0){m=CHa(c+32|0,d)|0;if((m|0)==(c+36|0)){f[a>>2]=-1;u=e;return}else{n=f[m+28>>2]|0;f[a>>2]=n;if((n|0)>-1){o=n;break}u=e;return}}else{f[a>>2]=0;o=0}while(0);a=c+24|0;c=f[a>>2]|0;if(c|0){k=a;n=c;a:while(1){c=n;while(1){if((f[c+16>>2]|0)>=(o|0))break;m=f[c+4>>2]|0;if(!m){p=k;break a}else c=m}n=f[c>>2]|0;if(!n){p=c;break}else k=c}if((p|0)!=(a|0)?(f[p+16>>2]|0)<=(o|0):0){a=b[j>>0]|0;if((a<<24>>24<0?f[l>>2]|0:a&255)|0){_Oa(h,p+20|0);p=f[h>>2]|0;a=Mi[f[(f[p>>2]|0)+52>>2]&1023](p,d)|0;d=f[h+4>>2]|0;if(!d)q=a;else{UXc(d);q=a}}else q=0;f[i>>2]=q;u=e;return}}f[g>>2]=o;DM(h,393143,g);vM(-204,h,393180,391289,1204)}function _Oa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+48|0;e=d+36|0;g=d+24|0;h=d+12|0;i=d;j=c+160|0;k=f[j>>2]|0;if(k|0){f[a>>2]=k;k=f[c+164>>2]|0;f[a+4>>2]=k;if(!k){u=d;return}TXc(k);u=d;return}k=c+16|0;$Oa(e,k,c+28|0);l=f[e>>2]|0;m=e+4|0;n=f[m>>2]|0;if(n|0)TXc(n);f[j>>2]=l;l=c+164|0;o=f[l>>2]|0;f[l>>2]=n;if(o|0)UXc(o);o=f[m>>2]|0;if(o|0)UXc(o);o=f[j>>2]|0;if(!o){SGa(i,393253,c+4|0);j=AYc(i,393274)|0;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;j=b[k+11>>0]|0;i=j<<24>>24<0;m=zYc(h,i?f[k>>2]|0:k,i?f[c+20>>2]|0:j&255)|0;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;m=AYc(g,505469)|0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;vM(-2,e,393286,391289,413)}f[a>>2]=o;o=f[l>>2]|0;f[a+4>>2]=o;if(!o){u=d;return}TXc(o);u=d;return}function $Oa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e+12|0;h=e;i=aPa()|0;YXc(i);lYc(g,c);c=g+11|0;j=b[c>>0]|0;k=j<<24>>24<0;l=f[g>>2]|0;m=k?l+(f[g+4>>2]|0)|0:g+(j&255)|0;j=k?l:g;if((j|0)!=(m|0)){l=j;do{j=(OIc(b[l>>0]|0)|0)&255;b[l>>0]=j;l=l+1|0}while((l|0)!=(m|0))}m=cPa(bPa()|0,g)|0;do if((m|0)!=((bPa()|0)+4|0)){l=f[m+32>>2]|0;if((f[m+28>>2]|0)==(l|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=19;k=j;n=393303;o=k+19|0;do{b[k>>0]=b[n>>0]|0;k=k+1|0;n=n+1|0}while((k|0)<(o|0));b[j+19>>0]=0;vM(-215,h,393323,391289,3569)}else{mi[f[l+-4>>2]&2047](a,d);break}}else{f[a>>2]=0;f[a+4>>2]=0}while(0);if((b[c>>0]|0)>=0){ZXc(i);u=e;return}cYc(f[g>>2]|0);ZXc(i);u=e;return}function aPa(){var a=0,b=0,c=0;if(f[223021]|0){a=f[223021]|0;return a|0}b=BQa()|0;YXc(b);if(!(f[223021]|0)){c=$Xc(28)|0;WXc(c);f[223021]=c}ZXc(b);a=f[223021]|0;return a|0}function bPa(){var a=0,c=0;if(f[223017]|0){a=f[223017]|0;return a|0}c=aPa()|0;YXc(c);if(!(f[223017]|0)){if((b[530536]|0)==0?X0c(530536)|0:0){f[223019]=0;f[223020]=0;f[223018]=892076;be(2241,892072,x|0)|0}f[223017]=892072;CQa()}ZXc(c);a=f[223017]|0;return a|0}function cPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=WKc(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=WKc(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function dPa(a){a=a|0;ePa(a,f[a+4>>2]|0);return}function ePa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(!c)return;ePa(a,f[c>>2]|0);ePa(a,f[c+4>>2]|0);a=c+16|0;d=f[c+28>>2]|0;if(d|0){e=c+32|0;g=f[e>>2]|0;if((g|0)!=(d|0))f[e>>2]=g+(~((g+-4-d|0)>>>2)<<2);cYc(d)}if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(c);return}function fPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+48|0;g=e;h=e+36|0;i=e+12|0;j=e+24|0;lYc(h,d);d=h+11|0;k=b[d>>0]|0;if(((k<<24>>24<0?f[h+4>>2]|0:k&255)|0)==0?(gPa(g,c),k=g+4|0,oYc(h,(f[k>>2]|0)+-12|0)|0,l=f[g>>2]|0,l|0):0){m=f[k>>2]|0;if((m|0)==(l|0))n=l;else{o=m;while(1){m=o+-12|0;f[k>>2]=m;if((b[m+11>>0]|0)<0){cYc(f[m>>2]|0);p=f[k>>2]|0}else p=m;if((p|0)==(l|0))break;else o=p}n=f[g>>2]|0}cYc(n)}ZOa(g,f[c>>2]|0,h);f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;p=$Xc(8)|0;f[i>>2]=p;f[i+8>>2]=p+8;o=g;l=f[o+4>>2]|0;k=p;f[k>>2]=f[o>>2];f[k+4>>2]=l;f[n>>2]=p+8;hPa(f[c>>2]|0,i);p=f[c>>2]|0;jPa(p,iPa(p,h)|0,1);p=f[c>>2]|0;lYc(j,h);ZOa(g,p,j);kPa(a,p,g);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);j=f[i>>2]|0;if(j|0){i=f[n>>2]|0;if((i|0)!=(j|0))f[n>>2]=i+(~((i+-8-j|0)>>>3)<<3);cYc(j)}if((b[d>>0]|0)>=0){u=e;return}cYc(f[h>>2]|0);u=e;return}function gPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;B5(a,f[(f[b>>2]|0)+28>>2]|0);d=f[b>>2]|0;e=f[d+20>>2]|0;if((e|0)==(d+24|0))return;d=a+8|0;g=e;while(1){do if(f[g+20>>2]|0){e=g+24|0;h=f[c>>2]|0;if((h|0)==(f[d>>2]|0)){NN(a,e);break}else{lYc(h,e);f[c>>2]=(f[c>>2]|0)+12;break}}while(0);e=f[g+4>>2]|0;if(!e){h=g+8|0;i=f[h>>2]|0;if((f[i>>2]|0)==(g|0))j=i;else{i=h;do{h=f[i>>2]|0;i=h+8|0;k=f[i>>2]|0}while((f[k>>2]|0)!=(h|0));j=k}}else{i=e;while(1){k=f[i>>2]|0;if(!k)break;else i=k}j=i}if((j|0)==((f[b>>2]|0)+24|0))break;else g=j}return}function hPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+160|0;e=d+144|0;g=d;h=a+80|0;i=f[h>>2]|0;if(!i){j=f[223016]|0;f[h>>2]=j;k=j}else k=i;switch(k|0){case 3:{if((f[a+84>>2]|0)>>>0>=3){i=$Xc(176)|0;f[e>>2]=i;f[e+8>>2]=-2147483472;f[e+4>>2]=164;o1c(i|0,393865,164)|0;b[i+164>>0]=0;vM(-215,e,394030,391289,1099)}break}case 1:{if((f[a+84>>2]|0)>>>0>=2){i=$Xc(128)|0;f[e>>2]=i;f[e+8>>2]=-2147483520;f[e+4>>2]=118;l=i;m=394039;n=l+118|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[i+118>>0]=0;vM(-215,e,394030,391289,1102)}break}case 2:{if((f[a+84>>2]|0)>>>0>=4){i=$Xc(224)|0;f[e>>2]=i;f[e+8>>2]=-2147483424;f[e+4>>2]=215;o1c(i|0,394158,215)|0;b[i+215>>0]=0;vM(-215,e,394030,391289,1107)}break}case 4:{if((f[a+84>>2]|0)!=4){i=$Xc(80)|0;f[e>>2]=i;f[e+8>>2]=-2147483568;f[e+4>>2]=79;l=i;m=394374;n=l+79|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[i+79>>0]=0;vM(-215,e,394030,391289,1109)}break}default:{}}i=a+120|0;a:do if(b[i>>0]|0?(j=f[a+12>>2]|0,o=f[a+8>>2]|0,p=f[c>>2]|0,q=o,r=j,(j-o|0)==((f[c+4>>2]|0)-p|0)):0){if((q|0)==(r|0)){u=d;return}o=q;q=p;while(1){if((f[o>>2]|0)!=(f[q>>2]|0))break a;if((f[o+4>>2]|0)!=(f[q+4>>2]|0))break a;o=o+8|0;if((o|0)==(r|0))break;else q=q+8|0}u=d;return}while(0);if((k|0)==3){q=a+84|0;if(((f[q>>2]|0)+-1|0)>>>0<2){if((jHc()|0)>=3){r=g+64|0;o=g+8|0;f[o>>2]=35876;p=g+12|0;f[g>>2]=6740;f[r>>2]=6760;f[g+4>>2]=0;XNc(g+64|0,p);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=35856;f[r>>2]=35896;f[o>>2]=35876;aOc(p);f[p>>2]=35912;o=g+44|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[g+60>>2]=24;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;AM(p,e);if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);j=g+8|0;BM(j,394454,75)|0;CM(e,p);s=e+11|0;kHc(3,(b[s>>0]|0)<0?f[e>>2]|0:e);if((b[s>>0]|0)<0)cYc(f[e>>2]|0);f[g>>2]=35856;f[r>>2]=35896;f[j>>2]=35876;f[p>>2]=35912;if((b[o+11>>0]|0)<0)cYc(f[o>>2]|0);LMc(p);TNc(g,35972);GMc(r)}f[q>>2]=0;t=f[h>>2]|0;v=30}}else{t=k;v=30}if(((v|0)==30?(t|0)==4:0)?!(nrb()|0):0){f[h>>2]=3;f[a+84>>2]=0}sPa(a);tPa(a,c);t=a+24|0;v=f[t>>2]|0;if(!v){w=$Xc(32)|0;f[e>>2]=w;x=e+8|0;f[x>>2]=-2147483616;y=e+4|0;f[y>>2]=18;l=w;m=394530;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z=w+18|0;b[z>>0]=0;vM(-215,e,394030,391289,1150)}else{A=t;B=v}b:while(1){v=B;while(1){if((f[v+16>>2]|0)>=0)break;k=f[v+4>>2]|0;if(!k){C=A;break b}else v=k}B=f[v>>2]|0;if(!B){C=v;break}else A=v}if((C|0)==(t|0)){w=$Xc(32)|0;f[e>>2]=w;x=e+8|0;f[x>>2]=-2147483616;y=e+4|0;f[y>>2]=18;l=w;m=394530;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z=w+18|0;b[z>>0]=0;vM(-215,e,394030,391289,1150)}if((f[C+16>>2]|0)>=1){w=$Xc(32)|0;f[e>>2]=w;x=e+8|0;f[x>>2]=-2147483616;y=e+4|0;f[y>>2]=18;l=w;m=394530;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));z=w+18|0;b[z>>0]=0;vM(-215,e,394030,391289,1150)}b[C+236>>0]=b[(f[a>>2]|0)+92>>0]|0;uPa(a);if((b[i>>0]|0)==0?(f[h>>2]|0)==1:0){h=$Xc(48)|0;f[e>>2]=h;f[e+8>>2]=-2147483600;f[e+4>>2]=39;l=h;m=394549;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[h+39>>0]=0;vM(-215,e,394030,391289,1161)}b[i>>0]=1;i=a+8|0;if((i|0)==(c|0)){u=d;return}vPa(i,f[c>>2]|0,f[c+4>>2]|0);u=d;return}function iPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=c+16|0;g=c+4|0;h=CHa(a+32|0,b)|0;if((h|0)!=(a+36|0)?(i=f[h+28>>2]|0,(i|0)>=0):0){h=a+24|0;a=f[h>>2]|0;if(a|0){j=h;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(i|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(h|0)?(f[m+16>>2]|0)<=(i|0):0){u=c;return m+20|0}}f[d>>2]=i;DM(e,393143,d);vM(-204,e,393180,391289,1204)}SGa(g,393835,b);b=AYc(g,393853)|0;f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;vM(-2,e,393180,391289,1214);return 0}function jPa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(c?(c=f[a+20>>2]|0,d=a+24|0,(c|0)!=(d|0)):0){e=c;while(1){f[e+240>>2]=0;c=f[e+4>>2]|0;if(!c){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=c;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(d|0))break;else e=i}}if(f[b+220>>2]|0)return;i=f[a+20>>2]|0;e=a+24|0;a:do if((i|0)!=(e|0)){d=i;while(1){c=d+20|0;if((f[c>>2]|0)>=(f[b>>2]|0))break a;if(!(f[d+240>>2]|0))mPa(a,c);c=f[d+4>>2]|0;if(!c){j=d+8|0;g=f[j>>2]|0;if((f[g>>2]|0)==(d|0))k=g;else{g=j;do{j=f[g>>2]|0;g=j+8|0;l=f[g>>2]|0}while((f[l>>2]|0)!=(j|0));k=l}}else{g=c;while(1){l=f[g>>2]|0;if(!l)break;else g=l}k=g}if((k|0)==(e|0))break;else d=k}}while(0);mPa(a,b);return}function kPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+64|0;g=e;h=e+32|0;i=e+16|0;j=e+48|0;if((f[d>>2]|0)<=-1){k=$Xc(32)|0;f[h>>2]=k;l=h+8|0;f[l>>2]=-2147483616;m=h+4|0;f[m>>2]=24;n=k;o=393343;p=n+24|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+24|0;b[q>>0]=0;vM(-204,h,393368,391289,2500)}r=d+4|0;if((f[r>>2]|0)<=-1){k=$Xc(32)|0;f[h>>2]=k;l=h+8|0;f[l>>2]=-2147483616;m=h+4|0;f[m>>2]=24;n=k;o=393343;p=n+24|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+24|0;b[q>>0]=0;vM(-204,h,393368,391289,2500)}f[i>>2]=d;lPa(h,c+20|0,d,1163514,i,j);j=f[h>>2]|0;d=f[r>>2]|0;q=j+188|0;k=f[q>>2]|0;m=((f[j+192>>2]|0)-k|0)/56|0;l=k;if(d>>>0>=m>>>0){k=j+24|0;if((b[k+11>>0]|0)<0){s=f[k>>2]|0;f[g>>2]=s;t=g+4|0;f[t>>2]=m;v=g+8|0;f[v>>2]=d;DM(h,393376,g);vM(-211,h,393368,391289,2507)}else{s=k;f[g>>2]=s;t=g+4|0;f[t>>2]=m;v=g+8|0;f[v>>2]=d;DM(h,393376,g);vM(-211,h,393368,391289,2507)}}do if(f[c+84>>2]|0){g=f[j+144>>2]|0;if((g|0)==(f[j+148>>2]|0)){w=$Xc(80)|0;f[h>>2]=w;x=h+8|0;f[x>>2]=-2147483568;y=h+4|0;f[y>>2]=75;n=w;o=393435;p=n+75|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z=w+75|0;b[z>>0]=0;vM(-215,h,393368,391289,2511)}v=f[g+(d<<3)>>2]|0;if(!v){w=$Xc(80)|0;f[h>>2]=w;x=h+8|0;f[x>>2]=-2147483568;y=h+4|0;f[y>>2]=75;n=w;o=393435;p=n+75|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));z=w+75|0;b[z>>0]=0;vM(-215,h,393368,391289,2511)}else{Yi[f[(f[v>>2]|0)+8>>2]&4095](v);A=q;B=f[q>>2]|0;C=f[r>>2]|0;break}}else{A=q;B=l;C=d}while(0);d=B+(C*56|0)|0;l=f[d>>2]|0;if((l&7|0)==3){q=(f[A>>2]|0)+(C*56|0)|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=q;q=c+136|0;A=i+8|0;f[A>>2]=0;f[A+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;eY(h,i);f[a>>2]=f[q>>2];i=a+4|0;h=c+140|0;A=f[h>>2]|0;f[i>>2]=A;r=a+8|0;f[r>>2]=f[c+144>>2];f[a+12>>2]=f[c+148>>2];f[a+16>>2]=f[c+152>>2];f[a+20>>2]=f[c+156>>2];f[a+24>>2]=f[c+160>>2];f[a+28>>2]=f[c+164>>2];f[a+32>>2]=f[c+168>>2];z=f[c+172>>2]|0;f[a+36>>2]=z;f[a+40>>2]=r;r=a+48|0;w=a+44|0;f[w>>2]=r;f[r>>2]=0;f[a+52>>2]=0;if(!z)D=A;else{A=z+12|0;f[A>>2]=(f[A>>2]|0)+1;D=f[h>>2]|0}if((D|0)<3){D=f[c+180>>2]|0;c=f[w>>2]|0;f[c>>2]=f[D>>2];f[c+4>>2]=f[D+4>>2];u=e;return}else{f[i>>2]=0;U$(a,q);u=e;return}}else{f[a>>2]=l;l=a+4|0;q=B+(C*56|0)+4|0;f[l>>2]=f[q>>2];i=a+8|0;f[i>>2]=f[B+(C*56|0)+8>>2];f[a+12>>2]=f[B+(C*56|0)+12>>2];f[a+16>>2]=f[B+(C*56|0)+16>>2];f[a+20>>2]=f[B+(C*56|0)+20>>2];f[a+24>>2]=f[B+(C*56|0)+24>>2];f[a+28>>2]=f[B+(C*56|0)+28>>2];f[a+32>>2]=f[B+(C*56|0)+32>>2];D=f[B+(C*56|0)+36>>2]|0;f[a+36>>2]=D;f[a+40>>2]=i;i=a+48|0;c=a+44|0;f[c>>2]=i;f[i>>2]=0;f[a+52>>2]=0;if(D|0){i=D+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[q>>2]|0)<3){q=f[B+(C*56|0)+44>>2]|0;C=f[c>>2]|0;f[C>>2]=f[q>>2];f[C+4>>2]=f[q+4>>2];u=e;return}else{f[l>>2]=0;U$(a,d);u=e;return}}}function lPa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=c+4|0;e=f[h>>2]|0;do if(e){i=f[d>>2]|0;j=c+4|0;k=e;while(1){l=f[k+16>>2]|0;if((i|0)<(l|0)){m=f[k>>2]|0;if(!m){n=6;break}else{o=k;p=m}}else{if((l|0)>=(i|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==6){r=k;s=k;break}else if((n|0)==9){r=k;s=q;break}else if((n|0)==10){r=k;s=j;break}}else{r=h;s=h}while(0);h=f[s>>2]|0;if(h|0){t=h;u=0;v=t;f[a>>2]=v;w=a+4|0;b[w>>0]=u;return}h=$Xc(244)|0;f[h+16>>2]=f[f[g>>2]>>2];f[h+20>>2]=-1;g=h+24|0;n=h+52|0;f[n>>2]=0;f[h+56>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[h+48>>2]=n;n=h+112|0;f[n>>2]=0;f[h+116>>2]=0;g=h+108|0;q=h+60|0;p=q+48|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(p|0));f[g>>2]=n;n=h+124|0;f[n>>2]=0;f[h+128>>2]=0;f[h+120>>2]=n;n=h+228|0;f[n>>2]=0;f[h+232>>2]=0;g=h+224|0;q=h+132|0;p=q+92|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(p|0));f[g>>2]=n;b[h+236>>0]=0;f[h+240>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=r;f[s>>2]=h;r=f[f[c>>2]>>2]|0;if(!r)x=h;else{f[c>>2]=r;x=f[s>>2]|0}UQ(f[c+4>>2]|0,x);x=c+8|0;f[x>>2]=(f[x>>2]|0)+1;t=h;u=1;v=t;f[a>>2]=v;w=a+4|0;b[w>>0]=u;return}function mPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0;d=u;u=u+320|0;e=d+256|0;g=d+240|0;h=d+184|0;i=d+168|0;j=d+112|0;k=d+56|0;l=d;m=f[c+160>>2]|0;n=f[c+164>>2]|0;o=(n|0)==0;if(!o)TXc(n);p=xN()|0;q=J;do if(!(b[c+216>>0]|0)){r=a+80|0;s=c+208|0;t=f[s>>2]|0;v=f[r>>2]|0;if(t){w=s;x=t;a:while(1){t=x;while(1){if((f[t+16>>2]|0)>=(v|0))break;y=f[t+4>>2]|0;if(!y){z=w;break a}else t=y}x=f[t>>2]|0;if(!x){z=t;break}else w=t}if((z|0)!=(s|0)?(v|0)>=(f[z+16>>2]|0):0)A=z;else B=11}else B=11;if((B|0)==11)A=s;if((v|0)==3){if(((f[a+84>>2]|0)+-1|0)>>>0<2){nPa(g,c+136|0);w=c+124|0;nPa(h,w);nPa(i,c+148|0);x=m;y=f[(f[m>>2]|0)+44>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17498112;f[e+4>>2]=g;C=j+8|0;f[C>>2]=0;f[C+4>>2]=0;f[j>>2]=34275328;f[j+4>>2]=h;C=k+8|0;f[C>>2]=0;f[C+4>>2]=0;f[k>>2]=34275328;f[k+4>>2]=i;ei[y&511](x,e,j,k);if(b[1163511]|0?(y=h+4|0,(f[y>>2]|0)!=(f[h>>2]|0)):0){C=j+4|0;D=j+8|0;E=j+40|0;F=j+48|0;G=j+44|0;H=j+52|0;I=e+8|0;K=e+12|0;L=e+4|0;M=k+8|0;N=k+4|0;O=e+8|0;P=e+12|0;Q=e+4|0;R=e+8|0;S=e+12|0;T=e+4|0;U=x+16|0;V=U+11|0;W=x+20|0;x=k+4|0;X=k+8|0;Y=j+36|0;Z=j+16|0;_=k+4|0;$=k+8|0;aa=e+4|0;ba=e+8|0;ca=e+12|0;da=j+12|0;ea=e+16|0;fa=e+20|0;ga=j+20|0;ha=e+24|0;ia=j+24|0;ja=e+28|0;ka=j+28|0;la=e+32|0;ma=j+32|0;na=e+36|0;oa=j+44|0;pa=e+44|0;qa=e+40|0;ra=e+48|0;sa=j+40|0;ta=j+52|0;ua=0;va=0;wa=f[h>>2]|0;while(1){xa=wa+(va*48|0)|0;f[j>>2]=1124007936;ya=C;za=ya+36|0;do{f[ya>>2]=0;ya=ya+4|0}while((ya|0)<(za|0));f[E>>2]=D;f[G>>2]=F;f[F>>2]=0;f[H>>2]=0;if((f[xa>>2]&7|0)!=3){NQ(e,xa,16777216);t=f[Y>>2]|0;if(t|0?(Aa=t+12|0,t=f[Aa>>2]|0,f[Aa>>2]=t+-1,(t|0)==1):0)V$(j);f[Y>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[C>>2]|0)>0){t=f[E>>2]|0;Aa=0;do{f[t+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[C>>2]|0))}f[j>>2]=f[e>>2];Aa=f[aa>>2]|0;f[C>>2]=Aa;f[D>>2]=f[ba>>2];f[da>>2]=f[ca>>2];f[Z>>2]=f[ea>>2];f[ga>>2]=f[fa>>2];f[ia>>2]=f[ha>>2];f[ka>>2]=f[ja>>2];f[ma>>2]=f[la>>2];f[Y>>2]=f[na>>2];t=f[oa>>2]|0;if((t|0)==(F|0))Ba=Aa;else{wL(t);f[oa>>2]=F;f[E>>2]=D;Ba=f[aa>>2]|0}if((Ba|0)<3){t=f[pa>>2]|0;f[F>>2]=f[t>>2];f[ta>>2]=f[t+4>>2];Ca=t}else{f[oa>>2]=f[pa>>2];f[sa>>2]=f[qa>>2];f[pa>>2]=ra;f[qa>>2]=ba;Ca=ra}f[e>>2]=1124007936;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;f[aa+16>>2]=0;f[aa+20>>2]=0;f[aa+24>>2]=0;f[aa+28>>2]=0;f[na>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((Ca|0)!=(ra|0))wL(Ca)}else{f[I>>2]=0;f[K>>2]=0;f[e>>2]=17432576;f[L>>2]=xa;t=M;f[t>>2]=0;f[t+4>>2]=0;f[k>>2]=33619968;f[N>>2]=j;eY(e,k)}f[O>>2]=0;f[P>>2]=0;f[e>>2]=16842752;f[Q>>2]=j;if(ZL(e,1,0,-1797693134862315708145274.0e284,1797693134862315708145274.0e284)|0){f[R>>2]=0;f[S>>2]=0;f[e>>2]=16842752;f[T>>2]=j;if(ZL(e,1,0,-1.0e6,1.0e6)|0)Da=ua;else{t=BM(895384,393587,42)|0;Aa=BM(nOc(t,f[c>>2]|0)|0,393554,6)|0;t=b[V>>0]|0;Ea=t<<24>>24<0;Fa=BM(Aa,Ea?f[U>>2]|0:U,Ea?f[W>>2]|0:t&255)|0;ZNc(e,Fa+(f[(f[Fa>>2]|0)+-12>>2]|0)|0);t=DPc(e,896088)|0;Ea=Mi[f[(f[t>>2]|0)+28>>2]&1023](t,10)|0;EPc(e);sOc(Fa,Ea)|0;dOc(Fa)|0;Fa=BM(oOc(BM(895384,393561,10)|0,va)|0,393572,14)|0;Ea=f[C>>2]|0;t=f[E>>2]|0;f[k>>2]=0;f[x>>2]=0;f[X>>2]=0;gOa(k,t,t+(Ea<<2)|0);Ea=oPa(Fa,k)|0;ZNc(e,Fa+(f[(f[Fa>>2]|0)+-12>>2]|0)|0);Fa=DPc(e,896088)|0;t=Mi[f[(f[Fa>>2]|0)+28>>2]&1023](Fa,10)|0;EPc(e);sOc(Ea,t)|0;dOc(Ea)|0;Ea=f[k>>2]|0;if(Ea|0){t=f[x>>2]|0;if((t|0)!=(Ea|0))f[x>>2]=t+(~((t+-4-Ea|0)>>>2)<<2);cYc(Ea)}Da=1}}else{Ea=BM(895384,393511,42)|0;t=BM(nOc(Ea,f[c>>2]|0)|0,393554,6)|0;Ea=b[V>>0]|0;Fa=Ea<<24>>24<0;Aa=BM(t,Fa?f[U>>2]|0:U,Fa?f[W>>2]|0:Ea&255)|0;ZNc(e,Aa+(f[(f[Aa>>2]|0)+-12>>2]|0)|0);Ea=DPc(e,896088)|0;Fa=Mi[f[(f[Ea>>2]|0)+28>>2]&1023](Ea,10)|0;EPc(e);sOc(Aa,Fa)|0;dOc(Aa)|0;Aa=BM(oOc(BM(895384,393561,10)|0,va)|0,393572,14)|0;Fa=f[C>>2]|0;Ea=f[E>>2]|0;f[k>>2]=0;f[_>>2]=0;f[$>>2]=0;gOa(k,Ea,Ea+(Fa<<2)|0);Fa=oPa(Aa,k)|0;ZNc(e,Aa+(f[(f[Aa>>2]|0)+-12>>2]|0)|0);Aa=DPc(e,896088)|0;Ea=Mi[f[(f[Aa>>2]|0)+28>>2]&1023](Aa,10)|0;EPc(e);sOc(Fa,Ea)|0;dOc(Fa)|0;Fa=f[k>>2]|0;if(Fa|0){Ea=f[_>>2]|0;if((Ea|0)!=(Fa|0))f[_>>2]=Ea+(~((Ea+-4-Fa|0)>>>2)<<2);cYc(Fa)}Da=1}Fa=f[Y>>2]|0;if(Fa|0?(Ea=Fa+12|0,Fa=f[Ea>>2]|0,f[Ea>>2]=Fa+-1,(Fa|0)==1):0)V$(j);f[Y>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[C>>2]|0)>0){Fa=f[E>>2]|0;Ea=0;do{f[Fa+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[C>>2]|0))}Ea=f[G>>2]|0;if((Ea|0)!=(F|0))wL(Ea);va=va+1|0;Ga=f[y>>2]|0;Ha=f[h>>2]|0;wa=Ha;if(va>>>0>=((Ga-Ha|0)/48|0)>>>0)break;else ua=Da}if(Da){ua=g+4|0;va=f[g>>2]|0;if((f[ua>>2]|0)==(va|0)){Ia=wa;Ja=Ga;Ka=Ha}else{F=j+4|0;G=j+8|0;C=j+40|0;E=j+48|0;Z=j+44|0;Y=j+52|0;_=e+8|0;$=e+12|0;W=e+4|0;U=k+8|0;V=k+4|0;x=k+11|0;X=k+4|0;T=l+4|0;S=l+8|0;R=j+36|0;Q=j+16|0;P=k+36|0;O=k+16|0;N=k+4|0;M=k+40|0;L=k+44|0;K=k+48|0;I=e+4|0;ra=e+8|0;ea=e+12|0;na=j+12|0;aa=e+16|0;ba=e+20|0;qa=j+20|0;pa=e+24|0;sa=j+24|0;oa=e+28|0;ta=j+28|0;D=e+32|0;la=j+32|0;ma=e+36|0;ja=j+44|0;ka=e+44|0;ha=e+40|0;ia=e+48|0;fa=j+40|0;ga=j+52|0;ca=0;da=va;do{va=da+(ca*48|0)|0;f[j>>2]=1124007936;ya=F;za=ya+36|0;do{f[ya>>2]=0;ya=ya+4|0}while((ya|0)<(za|0));f[C>>2]=G;f[Z>>2]=E;f[E>>2]=0;f[Y>>2]=0;if((f[va>>2]&7|0)!=3){NQ(e,va,16777216);H=f[R>>2]|0;if(H|0?(v=H+12|0,H=f[v>>2]|0,f[v>>2]=H+-1,(H|0)==1):0)V$(j);f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[F>>2]|0)>0){H=f[C>>2]|0;v=0;do{f[H+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[F>>2]|0))}f[j>>2]=f[e>>2];v=f[I>>2]|0;f[F>>2]=v;f[G>>2]=f[ra>>2];f[na>>2]=f[ea>>2];f[Q>>2]=f[aa>>2];f[qa>>2]=f[ba>>2];f[sa>>2]=f[pa>>2];f[ta>>2]=f[oa>>2];f[la>>2]=f[D>>2];f[R>>2]=f[ma>>2];H=f[ja>>2]|0;if((H|0)==(E|0))La=v;else{wL(H);f[ja>>2]=E;f[C>>2]=G;La=f[I>>2]|0}if((La|0)<3){H=f[ka>>2]|0;f[E>>2]=f[H>>2];f[ga>>2]=f[H+4>>2];Ma=H}else{f[ja>>2]=f[ka>>2];f[fa>>2]=f[ha>>2];f[ka>>2]=ia;f[ha>>2]=ra;Ma=ia}f[e>>2]=1124007936;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[I+16>>2]=0;f[I+20>>2]=0;f[I+24>>2]=0;f[I+28>>2]=0;f[ma>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((Ma|0)!=(ia|0))wL(Ma)}else{f[_>>2]=0;f[$>>2]=0;f[e>>2]=17432576;f[W>>2]=va;H=U;f[H>>2]=0;f[H+4>>2]=0;f[k>>2]=33619968;f[V>>2]=j;eY(e,k)}H=BM(oOc(BM(895216,393630,6)|0,ca)|0,528081,1)|0;jV(k,f[va>>2]&4095);v=b[x>>0]|0;Ea=v<<24>>24<0;Fa=BM(BM(H,Ea?f[k>>2]|0:k,Ea?f[X>>2]|0:v&255)|0,528081,1)|0;v=f[F>>2]|0;Ea=f[C>>2]|0;f[l>>2]=0;f[T>>2]=0;f[S>>2]=0;gOa(l,Ea,Ea+(v<<2)|0);v=oPa(Fa,l)|0;ZNc(e,Fa+(f[(f[Fa>>2]|0)+-12>>2]|0)|0);Fa=DPc(e,896088)|0;Ea=Mi[f[(f[Fa>>2]|0)+28>>2]&1023](Fa,10)|0;EPc(e);sOc(v,Ea)|0;dOc(v)|0;v=f[l>>2]|0;if(v|0){Ea=f[T>>2]|0;if((Ea|0)!=(v|0))f[T>>2]=Ea+(~((Ea+-4-v|0)>>>2)<<2);cYc(v)}if((b[x>>0]|0)<0)cYc(f[k>>2]|0);if(b[1163512]|0){g0(k,j,1,1);v=pPa(895216,k)|0;ZNc(e,895216+(f[(f[223804]|0)+-12>>2]|0)|0);Ea=DPc(e,896088)|0;Fa=Mi[f[(f[Ea>>2]|0)+28>>2]&1023](Ea,10)|0;EPc(e);sOc(v,Fa)|0;dOc(v)|0;v=f[P>>2]|0;do if(v|0){Fa=v+12|0;Ea=f[Fa>>2]|0;f[Fa>>2]=Ea+-1;if((Ea|0)!=1)break;V$(k)}while(0);f[P>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[N>>2]|0)>0){v=f[M>>2]|0;va=0;do{f[v+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[N>>2]|0))}va=f[L>>2]|0;if((va|0)!=(K|0))wL(va)}va=f[R>>2]|0;do if(va|0){v=va+12|0;Ea=f[v>>2]|0;f[v>>2]=Ea+-1;if((Ea|0)!=1)break;V$(j)}while(0);f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[F>>2]|0)>0){va=f[C>>2]|0;Ea=0;do{f[va+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[F>>2]|0))}Ea=f[Z>>2]|0;if((Ea|0)!=(E|0))wL(Ea);ca=ca+1|0;da=f[g>>2]|0}while(ca>>>0<(((f[ua>>2]|0)-da|0)/48|0)>>>0);da=f[h>>2]|0;Ia=da;Ja=f[y>>2]|0;Ka=da}if((Ja|0)!=(Ka|0)){da=j+4|0;ua=j+8|0;ca=j+40|0;E=j+48|0;Z=j+44|0;F=j+52|0;C=e+8|0;Q=e+12|0;R=e+4|0;K=k+8|0;L=k+4|0;N=k+11|0;M=k+4|0;O=l+4|0;P=l+8|0;x=j+36|0;T=j+16|0;S=k+36|0;X=k+16|0;V=k+4|0;U=k+40|0;W=k+44|0;$=k+48|0;_=e+4|0;ia=e+8|0;aa=e+12|0;ma=j+12|0;I=e+16|0;ra=e+20|0;ha=j+20|0;ka=e+24|0;fa=j+24|0;ja=e+28|0;ga=j+28|0;G=e+32|0;D=j+32|0;la=e+36|0;oa=j+44|0;ta=e+44|0;pa=e+40|0;sa=e+48|0;ba=j+40|0;qa=j+52|0;ea=0;na=Ia;do{Y=na+(ea*48|0)|0;f[j>>2]=1124007936;ya=da;za=ya+36|0;do{f[ya>>2]=0;ya=ya+4|0}while((ya|0)<(za|0));f[ca>>2]=ua;f[Z>>2]=E;f[E>>2]=0;f[F>>2]=0;if((f[Y>>2]&7|0)!=3){NQ(e,Y,16777216);wa=f[x>>2]|0;if(wa|0?(Ea=wa+12|0,wa=f[Ea>>2]|0,f[Ea>>2]=wa+-1,(wa|0)==1):0)V$(j);f[x>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[da>>2]|0)>0){wa=f[ca>>2]|0;Ea=0;do{f[wa+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[da>>2]|0))}f[j>>2]=f[e>>2];Ea=f[_>>2]|0;f[da>>2]=Ea;f[ua>>2]=f[ia>>2];f[ma>>2]=f[aa>>2];f[T>>2]=f[I>>2];f[ha>>2]=f[ra>>2];f[fa>>2]=f[ka>>2];f[ga>>2]=f[ja>>2];f[D>>2]=f[G>>2];f[x>>2]=f[la>>2];wa=f[oa>>2]|0;if((wa|0)==(E|0))Na=Ea;else{wL(wa);f[oa>>2]=E;f[ca>>2]=ua;Na=f[_>>2]|0}if((Na|0)<3){wa=f[ta>>2]|0;f[E>>2]=f[wa>>2];f[qa>>2]=f[wa+4>>2];Oa=wa}else{f[oa>>2]=f[ta>>2];f[ba>>2]=f[pa>>2];f[ta>>2]=sa;f[pa>>2]=ia;Oa=sa}f[e>>2]=1124007936;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;f[_+16>>2]=0;f[_+20>>2]=0;f[_+24>>2]=0;f[_+28>>2]=0;f[la>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((Oa|0)!=(sa|0))wL(Oa)}else{f[C>>2]=0;f[Q>>2]=0;f[e>>2]=17432576;f[R>>2]=Y;wa=K;f[wa>>2]=0;f[wa+4>>2]=0;f[k>>2]=33619968;f[L>>2]=j;eY(e,k)}wa=BM(oOc(BM(895216,393637,7)|0,ea)|0,528081,1)|0;jV(k,f[Y>>2]&4095);Ea=b[N>>0]|0;va=Ea<<24>>24<0;v=BM(BM(wa,va?f[k>>2]|0:k,va?f[M>>2]|0:Ea&255)|0,528081,1)|0;Ea=f[da>>2]|0;va=f[ca>>2]|0;f[l>>2]=0;f[O>>2]=0;f[P>>2]=0;gOa(l,va,va+(Ea<<2)|0);Ea=oPa(v,l)|0;ZNc(e,v+(f[(f[v>>2]|0)+-12>>2]|0)|0);v=DPc(e,896088)|0;va=Mi[f[(f[v>>2]|0)+28>>2]&1023](v,10)|0;EPc(e);sOc(Ea,va)|0;dOc(Ea)|0;Ea=f[l>>2]|0;if(Ea|0){va=f[O>>2]|0;if((va|0)!=(Ea|0))f[O>>2]=va+(~((va+-4-Ea|0)>>>2)<<2);cYc(Ea)}if((b[N>>0]|0)<0)cYc(f[k>>2]|0);if(b[1163512]|0){g0(k,j,1,1);Ea=pPa(895216,k)|0;ZNc(e,895216+(f[(f[223804]|0)+-12>>2]|0)|0);va=DPc(e,896088)|0;v=Mi[f[(f[va>>2]|0)+28>>2]&1023](va,10)|0;EPc(e);sOc(Ea,v)|0;dOc(Ea)|0;Ea=f[S>>2]|0;do if(Ea|0){v=Ea+12|0;va=f[v>>2]|0;f[v>>2]=va+-1;if((va|0)!=1)break;V$(k)}while(0);f[S>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[V>>2]|0)>0){Ea=f[U>>2]|0;Y=0;do{f[Ea+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[V>>2]|0))}Y=f[W>>2]|0;if((Y|0)!=($|0))wL(Y)}Y=f[x>>2]|0;do if(Y|0){Ea=Y+12|0;va=f[Ea>>2]|0;f[Ea>>2]=va+-1;if((va|0)!=1)break;V$(j)}while(0);f[x>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[da>>2]|0)>0){Y=f[ca>>2]|0;va=0;do{f[Y+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[da>>2]|0))}va=f[Z>>2]|0;if((va|0)!=(E|0))wL(va);ea=ea+1|0;na=f[h>>2]|0}while(ea>>>0<(((f[y>>2]|0)-na|0)/48|0)>>>0)}na=i+4|0;y=f[i>>2]|0;if((f[na>>2]|0)!=(y|0)){ea=j+4|0;E=j+8|0;Z=j+40|0;da=j+48|0;ca=j+44|0;T=j+52|0;x=e+8|0;$=e+12|0;W=e+4|0;V=k+8|0;U=k+4|0;X=k+4|0;S=k+8|0;N=j+36|0;O=j+16|0;P=k+11|0;M=k+4|0;L=l+36|0;K=l+16|0;R=l+4|0;Q=l+40|0;C=l+44|0;sa=l+48|0;I=e+4|0;la=e+8|0;_=e+12|0;ia=j+12|0;pa=e+16|0;ta=e+20|0;ba=j+20|0;oa=e+24|0;qa=j+24|0;ua=e+28|0;G=j+28|0;D=e+32|0;ja=j+32|0;ga=e+36|0;ka=j+44|0;fa=e+44|0;ra=e+40|0;ha=e+48|0;aa=j+40|0;ma=j+52|0;F=0;va=y;do{y=va+(F*48|0)|0;f[j>>2]=1124007936;ya=ea;za=ya+36|0;do{f[ya>>2]=0;ya=ya+4|0}while((ya|0)<(za|0));f[Z>>2]=E;f[ca>>2]=da;f[da>>2]=0;f[T>>2]=0;if((f[y>>2]&7|0)!=3){NQ(e,y,16777216);Y=f[N>>2]|0;do if(Y|0){Ea=Y+12|0;v=f[Ea>>2]|0;f[Ea>>2]=v+-1;if((v|0)!=1)break;V$(j)}while(0);f[N>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[ea>>2]|0)>0){Y=f[Z>>2]|0;v=0;do{f[Y+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[ea>>2]|0))}f[j>>2]=f[e>>2];v=f[I>>2]|0;f[ea>>2]=v;f[E>>2]=f[la>>2];f[ia>>2]=f[_>>2];f[O>>2]=f[pa>>2];f[ba>>2]=f[ta>>2];f[qa>>2]=f[oa>>2];f[G>>2]=f[ua>>2];f[ja>>2]=f[D>>2];f[N>>2]=f[ga>>2];Y=f[ka>>2]|0;if((Y|0)==(da|0))Pa=v;else{wL(Y);f[ka>>2]=da;f[Z>>2]=E;Pa=f[I>>2]|0}if((Pa|0)<3){Y=f[fa>>2]|0;f[da>>2]=f[Y>>2];f[ma>>2]=f[Y+4>>2];Qa=Y}else{f[ka>>2]=f[fa>>2];f[aa>>2]=f[ra>>2];f[fa>>2]=ha;f[ra>>2]=la;Qa=ha}f[e>>2]=1124007936;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[I+16>>2]=0;f[I+20>>2]=0;f[I+24>>2]=0;f[I+28>>2]=0;f[ga>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((Qa|0)!=(ha|0))wL(Qa)}else{f[x>>2]=0;f[$>>2]=0;f[e>>2]=17432576;f[W>>2]=y;Y=V;f[Y>>2]=0;f[Y+4>>2]=0;f[k>>2]=33619968;f[U>>2]=j;eY(e,k)}Y=BM(oOc(BM(895216,393645,9)|0,F)|0,528081,1)|0;v=f[ea>>2]|0;Ea=f[Z>>2]|0;f[k>>2]=0;f[X>>2]=0;f[S>>2]=0;gOa(k,Ea,Ea+(v<<2)|0);v=oPa(Y,k)|0;ZNc(e,Y+(f[(f[Y>>2]|0)+-12>>2]|0)|0);Y=DPc(e,896088)|0;Ea=Mi[f[(f[Y>>2]|0)+28>>2]&1023](Y,10)|0;EPc(e);sOc(v,Ea)|0;dOc(v)|0;v=f[k>>2]|0;if(v|0){Ea=f[X>>2]|0;if((Ea|0)!=(v|0))f[X>>2]=Ea+(~((Ea+-4-v|0)>>>2)<<2);cYc(v)}if(b[1163512]|0){jV(k,f[y>>2]&4095);v=b[P>>0]|0;Ea=v<<24>>24<0;Y=BM(BM(895216,Ea?f[k>>2]|0:k,Ea?f[M>>2]|0:v&255)|0,528081,1)|0;g0(l,j,1,1);v=pPa(Y,l)|0;ZNc(e,Y+(f[(f[Y>>2]|0)+-12>>2]|0)|0);Y=DPc(e,896088)|0;Ea=Mi[f[(f[Y>>2]|0)+28>>2]&1023](Y,10)|0;EPc(e);sOc(v,Ea)|0;dOc(v)|0;v=f[L>>2]|0;do if(v|0){Ea=v+12|0;Y=f[Ea>>2]|0;f[Ea>>2]=Y+-1;if((Y|0)!=1)break;V$(l)}while(0);f[L>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[R>>2]|0)>0){v=f[Q>>2]|0;y=0;do{f[v+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[R>>2]|0))}y=f[C>>2]|0;if((y|0)!=(sa|0))wL(y);if((b[P>>0]|0)<0)cYc(f[k>>2]|0)}y=f[N>>2]|0;do if(y|0){v=y+12|0;Y=f[v>>2]|0;f[v>>2]=Y+-1;if((Y|0)!=1)break;V$(j)}while(0);f[N>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[ea>>2]|0)>0){y=f[Z>>2]|0;Y=0;do{f[y+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[ea>>2]|0))}Y=f[ca>>2]|0;if((Y|0)!=(da|0))wL(Y);F=F+1|0;va=f[i>>2]|0}while(F>>>0<(((f[na>>2]|0)-va|0)/48|0)>>>0)}if(b[1163513]|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[393655]|0;b[e+1>>0]=b[393656]|0;b[e+2>>0]=b[393657]|0;b[e+3>>0]=b[393658]|0;b[e+4>>0]=b[393659]|0;b[e+5>>0]=0;vM(-215,e,393661,391289,2284)}}}qPa(w,h);va=f[i>>2]|0;if(va|0){na=i+4|0;F=f[na>>2]|0;if((F|0)==(va|0))Ra=va;else{da=F;do{F=da+-48|0;f[na>>2]=F;EQ(F);da=f[na>>2]|0}while((da|0)!=(va|0));Ra=f[i>>2]|0}cYc(Ra)}va=f[h>>2]|0;if(va|0){da=h+4|0;na=f[da>>2]|0;if((na|0)==(va|0))Sa=va;else{w=na;do{na=w+-48|0;f[da>>2]=na;EQ(na);w=f[da>>2]|0}while((w|0)!=(va|0));Sa=f[h>>2]|0}cYc(Sa)}va=f[g>>2]|0;if(va|0){w=g+4|0;da=f[w>>2]|0;if((da|0)==(va|0))Ta=va;else{na=da;do{da=na+-48|0;f[w>>2]=da;EQ(da);na=f[w>>2]|0}while((na|0)!=(va|0));Ta=f[g>>2]|0}cYc(Ta)}Ua=p;Va=q;break}}else if((A|0)!=(s|0)?(va=f[A+20>>2]|0,va|0):0){f[e>>2]=va;va=e+4|0;na=f[A+24>>2]|0;f[va>>2]=na;if(na|0)TXc(na);switch(f[r>>2]|0){case 1:break;case 2:{prb(e);break}case 4:break;default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;na=$Xc(32)|0;f[g>>2]=na;f[g+8>>2]=-2147483616;f[g+4>>2]=26;ya=na;w=393683;za=ya+26|0;do{b[ya>>0]=b[w>>0]|0;ya=ya+1|0;w=w+1|0}while((ya|0)<(za|0));b[na+26>>0]=0;vM(-213,g,393661,391289,2388)}}w=f[va>>2]|0;if(w|0)UXc(w);Ua=p;Va=q;break}w=c+136|0;r=f[w>>2]|0;s=(f[c+140>>2]|0)-r|0;da=s>>3;b:do if((s|0)>0){F=0;ca=r;while(1){ea=f[ca+(F<<3)>>2]|0;if(ea|0)Yi[f[(f[ea>>2]|0)+8>>2]&4095](ea);ea=F+1|0;if((ea|0)>=(da|0))break b;F=ea;ca=f[w>>2]|0}}while(0);w=c+180|0;da=c+184|0;r=f[da>>2]|0;s=f[w>>2]|0;va=r-s>>2;f[g>>2]=0;na=g+4|0;f[na>>2]=0;f[g+8>>2]=0;if(!va){Wa=s;Xa=0;Ya=r}else{if(va>>>0>76695844)kWc(g);r=va*56|0;s=$Xc(r)|0;f[na>>2]=s;f[g>>2]=s;f[g+8>>2]=s+(va*56|0);ca=s+r|0;r=va;va=s;while(1){f[va>>2]=1124007936;F=va+8|0;ea=va+40|0;ya=va+4|0;za=ya+36|0;do{f[ya>>2]=0;ya=ya+4|0}while((ya|0)<(za|0));f[ea>>2]=F;Z=va+48|0;f[va+44>>2]=Z;f[Z>>2]=0;f[va+52>>2]=0;r=r+-1|0;if(!r)break;else va=va+56|0}f[na>>2]=ca;Wa=f[w>>2]|0;Xa=s;Ya=f[da>>2]|0}c:do if((Ya|0)!=(Wa|0)){va=0;r=Ya;Z=Wa;O=Xa;while(1){N=f[Z+(va<<2)>>2]|0;P=O+(va*56|0)|0;if((P|0)==(N|0)){Za=Z;_a=r}else{sa=N+36|0;C=f[sa>>2]|0;if(C|0){R=C+12|0;f[R>>2]=(f[R>>2]|0)+1}R=O+(va*56|0)+36|0;C=f[R>>2]|0;if(C|0?(Q=C+12|0,C=f[Q>>2]|0,f[Q>>2]=C+-1,(C|0)==1):0)V$(P);f[R>>2]=0;C=O+(va*56|0)+16|0;Q=O+(va*56|0)+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[Q>>2]|0)>0){K=f[O+(va*56|0)+40>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0;$a=f[Q>>2]|0}while((L|0)<($a|0));f[P>>2]=f[N>>2];if(($a|0)<3)B=229;else B=231}else{f[P>>2]=f[N>>2];B=229}if((B|0)==229){B=0;L=f[N+4>>2]|0;if((L|0)<3){f[Q>>2]=L;f[O+(va*56|0)+8>>2]=f[N+8>>2];f[O+(va*56|0)+12>>2]=f[N+12>>2];L=f[N+44>>2]|0;K=f[O+(va*56|0)+44>>2]|0;f[K>>2]=f[L>>2];f[K+4>>2]=f[L+4>>2]}else B=231}if((B|0)==231){B=0;U$(P,N)}f[C>>2]=f[N+16>>2];f[O+(va*56|0)+20>>2]=f[N+20>>2];f[O+(va*56|0)+24>>2]=f[N+24>>2];f[O+(va*56|0)+28>>2]=f[N+28>>2];f[O+(va*56|0)+32>>2]=f[N+32>>2];f[R>>2]=f[sa>>2];Za=f[w>>2]|0;_a=f[da>>2]|0}L=va+1|0;if(L>>>0>=_a-Za>>2>>>0)break c;va=L;r=_a;Z=Za;O=f[g>>2]|0}}while(0);s=m;ca=f[(f[m>>2]|0)+44>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=g;na=c+168|0;O=h+8|0;f[O>>2]=0;f[O+4>>2]=0;f[h>>2]=33882112;f[h+4>>2]=na;O=c+192|0;Z=i+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=O;ei[ca&511](s,e,h,i);if(b[1163511]|0?(ca=c+172|0,Z=f[na>>2]|0,(f[ca>>2]|0)!=(Z|0)):0){r=e+8|0;va=e+12|0;F=e+4|0;ea=e+8|0;L=e+12|0;K=e+4|0;M=s+16|0;X=M+11|0;S=s+20|0;s=h+4|0;U=h+8|0;V=h+4|0;W=h+8|0;$=0;x=0;ha=Z;while(1){Z=ha+($*56|0)|0;f[r>>2]=0;f[va>>2]=0;f[e>>2]=16842752;f[F>>2]=Z;if(ZL(e,1,0,-1797693134862315708145274.0e284,1797693134862315708145274.0e284)|0){f[ea>>2]=0;f[L>>2]=0;f[e>>2]=16842752;f[K>>2]=Z;if(ZL(e,1,0,-1.0e6,1.0e6)|0)ab=x;else{Z=BM(895384,393587,42)|0;pa=BM(nOc(Z,f[c>>2]|0)|0,393554,6)|0;Z=b[X>>0]|0;ga=Z<<24>>24<0;I=BM(pa,ga?f[M>>2]|0:M,ga?f[S>>2]|0:Z&255)|0;ZNc(e,I+(f[(f[I>>2]|0)+-12>>2]|0)|0);Z=DPc(e,896088)|0;ga=Mi[f[(f[Z>>2]|0)+28>>2]&1023](Z,10)|0;EPc(e);sOc(I,ga)|0;dOc(I)|0;I=BM(oOc(BM(895384,393561,10)|0,$)|0,393572,14)|0;ga=f[ha+($*56|0)+4>>2]|0;Z=f[ha+($*56|0)+40>>2]|0;f[h>>2]=0;f[s>>2]=0;f[U>>2]=0;gOa(h,Z,Z+(ga<<2)|0);ga=oPa(I,h)|0;ZNc(e,I+(f[(f[I>>2]|0)+-12>>2]|0)|0);I=DPc(e,896088)|0;Z=Mi[f[(f[I>>2]|0)+28>>2]&1023](I,10)|0;EPc(e);sOc(ga,Z)|0;dOc(ga)|0;ga=f[h>>2]|0;if(ga|0){Z=f[s>>2]|0;if((Z|0)!=(ga|0))f[s>>2]=Z+(~((Z+-4-ga|0)>>>2)<<2);cYc(ga)}ab=1}}else{ga=BM(895384,393511,42)|0;Z=BM(nOc(ga,f[c>>2]|0)|0,393554,6)|0;ga=b[X>>0]|0;I=ga<<24>>24<0;pa=BM(Z,I?f[M>>2]|0:M,I?f[S>>2]|0:ga&255)|0;ZNc(e,pa+(f[(f[pa>>2]|0)+-12>>2]|0)|0);ga=DPc(e,896088)|0;I=Mi[f[(f[ga>>2]|0)+28>>2]&1023](ga,10)|0;EPc(e);sOc(pa,I)|0;dOc(pa)|0;pa=BM(oOc(BM(895384,393561,10)|0,$)|0,393572,14)|0;I=f[ha+($*56|0)+4>>2]|0;ga=f[ha+($*56|0)+40>>2]|0;f[h>>2]=0;f[V>>2]=0;f[W>>2]=0;gOa(h,ga,ga+(I<<2)|0);I=oPa(pa,h)|0;ZNc(e,pa+(f[(f[pa>>2]|0)+-12>>2]|0)|0);pa=DPc(e,896088)|0;ga=Mi[f[(f[pa>>2]|0)+28>>2]&1023](pa,10)|0;EPc(e);sOc(I,ga)|0;dOc(I)|0;I=f[h>>2]|0;if(I|0){ga=f[V>>2]|0;if((ga|0)!=(I|0))f[V>>2]=ga+(~((ga+-4-I|0)>>>2)<<2);cYc(I)}ab=1}$=$+1|0;bb=f[ca>>2]|0;cb=f[na>>2]|0;ha=cb;if($>>>0>=((bb-cb|0)/56|0)>>>0)break;else x=ab}if(ab){x=f[w>>2]|0;if((f[da>>2]|0)==(x|0)){db=bb;eb=cb;fb=ha}else{$=h+11|0;V=h+4|0;W=i+4|0;S=i+8|0;M=h+36|0;X=h+16|0;s=h+4|0;U=h+40|0;K=h+44|0;L=h+48|0;ea=0;F=x;do{x=f[F+(ea<<2)>>2]|0;va=oOc(BM(895216,393630,6)|0,ea)|0;if(x){r=BM(va,528081,1)|0;jV(h,f[x>>2]&4095);I=b[$>>0]|0;ga=I<<24>>24<0;pa=BM(BM(r,ga?f[h>>2]|0:h,ga?f[V>>2]|0:I&255)|0,528081,1)|0;I=f[x+4>>2]|0;ga=f[x+40>>2]|0;f[i>>2]=0;f[W>>2]=0;f[S>>2]=0;gOa(i,ga,ga+(I<<2)|0);I=oPa(pa,i)|0;ZNc(e,pa+(f[(f[pa>>2]|0)+-12>>2]|0)|0);pa=DPc(e,896088)|0;ga=Mi[f[(f[pa>>2]|0)+28>>2]&1023](pa,10)|0;EPc(e);sOc(I,ga)|0;dOc(I)|0;I=f[i>>2]|0;if(I|0){ga=f[W>>2]|0;if((ga|0)!=(I|0))f[W>>2]=ga+(~((ga+-4-I|0)>>>2)<<2);cYc(I)}if((b[$>>0]|0)<0)cYc(f[h>>2]|0);if(b[1163512]|0){g0(h,x,1,1);x=pPa(895216,h)|0;ZNc(e,895216+(f[(f[223804]|0)+-12>>2]|0)|0);I=DPc(e,896088)|0;ga=Mi[f[(f[I>>2]|0)+28>>2]&1023](I,10)|0;EPc(e);sOc(x,ga)|0;dOc(x)|0;x=f[M>>2]|0;do if(x|0){ga=x+12|0;I=f[ga>>2]|0;f[ga>>2]=I+-1;if((I|0)!=1)break;V$(h)}while(0);f[M>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[s>>2]|0)>0){x=f[U>>2]|0;I=0;do{f[x+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[s>>2]|0))}I=f[K>>2]|0;if((I|0)!=(L|0))wL(I)}}else{I=BM(va,393674,8)|0;ZNc(e,I+(f[(f[I>>2]|0)+-12>>2]|0)|0);x=DPc(e,896088)|0;ga=Mi[f[(f[x>>2]|0)+28>>2]&1023](x,10)|0;EPc(e);sOc(I,ga)|0;dOc(I)|0}ea=ea+1|0;F=f[w>>2]|0}while(ea>>>0<(f[da>>2]|0)-F>>2>>>0);F=f[na>>2]|0;db=f[ca>>2]|0;eb=F;fb=F}if((db|0)!=(eb|0)){F=h+11|0;da=h+4|0;ea=i+4|0;w=i+8|0;L=h+36|0;K=h+16|0;s=h+4|0;U=h+40|0;X=h+44|0;M=h+48|0;$=0;W=fb;do{S=W+($*56|0)|0;V=BM(oOc(BM(895216,393637,7)|0,$)|0,528081,1)|0;jV(h,f[S>>2]&4095);ha=b[F>>0]|0;I=ha<<24>>24<0;ga=BM(BM(V,I?f[h>>2]|0:h,I?f[da>>2]|0:ha&255)|0,528081,1)|0;ha=f[W+($*56|0)+4>>2]|0;I=f[W+($*56|0)+40>>2]|0;f[i>>2]=0;f[ea>>2]=0;f[w>>2]=0;gOa(i,I,I+(ha<<2)|0);ha=oPa(ga,i)|0;ZNc(e,ga+(f[(f[ga>>2]|0)+-12>>2]|0)|0);ga=DPc(e,896088)|0;I=Mi[f[(f[ga>>2]|0)+28>>2]&1023](ga,10)|0;EPc(e);sOc(ha,I)|0;dOc(ha)|0;ha=f[i>>2]|0;if(ha|0){I=f[ea>>2]|0;if((I|0)!=(ha|0))f[ea>>2]=I+(~((I+-4-ha|0)>>>2)<<2);cYc(ha)}if((b[F>>0]|0)<0)cYc(f[h>>2]|0);if(b[1163512]|0){g0(h,S,1,1);S=pPa(895216,h)|0;ZNc(e,895216+(f[(f[223804]|0)+-12>>2]|0)|0);ha=DPc(e,896088)|0;I=Mi[f[(f[ha>>2]|0)+28>>2]&1023](ha,10)|0;EPc(e);sOc(S,I)|0;dOc(S)|0;S=f[L>>2]|0;do if(S|0){I=S+12|0;ha=f[I>>2]|0;f[I>>2]=ha+-1;if((ha|0)!=1)break;V$(h)}while(0);f[L>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[s>>2]|0)>0){S=f[U>>2]|0;va=0;do{f[S+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[s>>2]|0))}va=f[X>>2]|0;if((va|0)!=(M|0))wL(va)}$=$+1|0;W=f[na>>2]|0}while($>>>0<(((f[ca>>2]|0)-W|0)/56|0)>>>0)}W=c+196|0;ca=f[O>>2]|0;if((f[W>>2]|0)!=(ca|0)){$=h+11|0;na=h+4|0;M=i+4|0;X=i+8|0;s=h+36|0;U=h+16|0;K=h+4|0;L=h+40|0;F=h+44|0;ea=h+48|0;w=0;da=ca;do{ca=da;va=ca+(w*56|0)|0;S=BM(oOc(BM(895216,393645,9)|0,w)|0,528081,1)|0;jV(h,f[va>>2]&4095);ha=b[$>>0]|0;I=ha<<24>>24<0;ga=BM(BM(S,I?f[h>>2]|0:h,I?f[na>>2]|0:ha&255)|0,528081,1)|0;ha=f[ca+(w*56|0)+4>>2]|0;I=f[ca+(w*56|0)+40>>2]|0;f[i>>2]=0;f[M>>2]=0;f[X>>2]=0;gOa(i,I,I+(ha<<2)|0);ha=oPa(ga,i)|0;ZNc(e,ga+(f[(f[ga>>2]|0)+-12>>2]|0)|0);ga=DPc(e,896088)|0;I=Mi[f[(f[ga>>2]|0)+28>>2]&1023](ga,10)|0;EPc(e);sOc(ha,I)|0;dOc(ha)|0;ha=f[i>>2]|0;if(ha|0){I=f[M>>2]|0;if((I|0)!=(ha|0))f[M>>2]=I+(~((I+-4-ha|0)>>>2)<<2);cYc(ha)}if((b[$>>0]|0)<0)cYc(f[h>>2]|0);if(b[1163512]|0){g0(h,va,1,1);va=pPa(895216,h)|0;ZNc(e,895216+(f[(f[223804]|0)+-12>>2]|0)|0);ha=DPc(e,896088)|0;I=Mi[f[(f[ha>>2]|0)+28>>2]&1023](ha,10)|0;EPc(e);sOc(va,I)|0;dOc(va)|0;va=f[s>>2]|0;do if(va|0){I=va+12|0;ha=f[I>>2]|0;f[I>>2]=ha+-1;if((ha|0)!=1)break;V$(h)}while(0);f[s>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[K>>2]|0)>0){va=f[L>>2]|0;ha=0;do{f[va+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[K>>2]|0))}ha=f[F>>2]|0;if((ha|0)!=(ea|0))wL(ha)}w=w+1|0;da=f[O>>2]|0}while(w>>>0<(((f[W>>2]|0)-da|0)/56|0)>>>0)}if(b[1163513]|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=5;b[e>>0]=b[393655]|0;b[e+1>>0]=b[393656]|0;b[e+2>>0]=b[393657]|0;b[e+3>>0]=b[393658]|0;b[e+4>>0]=b[393659]|0;b[e+5>>0]=0;vM(-215,e,393661,391289,2350)}}}da=c+124|0;W=f[da>>2]|0;w=(f[c+128>>2]|0)-W|0;O=w>>3;d:do if((w|0)>0){ea=0;F=W;while(1){K=f[F+(ea<<3)>>2]|0;if(K|0)Yi[f[(f[K>>2]|0)+12>>2]&4095](K);K=ea+1|0;if((K|0)>=(O|0))break d;ea=K;F=f[da>>2]|0}}while(0);hx(g);Ua=p;Va=q}else{Ua=0;Va=0}while(0);q=xN()|0;p=(Ua|0)==0&(Va|0)==0;g=c1c(q|0,J|0,Ua|0,Va|0)|0;Va=(f[a+124>>2]|0)+(f[c>>2]<<3)|0;f[Va>>2]=p?0:g;f[Va+4>>2]=p?0:J;f[c+220>>2]=1;if(o){u=d;return}UXc(n);u=d;return}function nPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=(f[c+4>>2]|0)-(f[c>>2]|0)|0;h=g>>3;rPa(a,h);if((g|0)<=0){u=d;return}g=e+8|0;i=e+4|0;j=0;while(1){k=f[c>>2]|0;l=f[k+(j<<3)>>2]|0;if(!l){m=8;break}n=kZc(l,15176,15232,0)|0;if(!n){m=8;break}l=f[k+(j<<3)+4>>2]|0;if(l|0)TXc(l);if(!n){m=8;break}k=n+64|0;if(!(b[k>>0]|0))o=n+12|0;else{p=f[n+60>>2]|0;q=n+12|0;r=g;f[r>>2]=0;f[r+4>>2]=0;f[e>>2]=34209792;f[i>>2]=q;jR(p,e);b[k>>0]=0;o=q}q=f[a>>2]|0;k=q+(j*48|0)|0;if((k|0)!=(o|0)){p=n+36|0;r=f[p>>2]|0;if(r|0){s=r+8|0;f[s>>2]=(f[s>>2]|0)+1}s=q+(j*48|0)+24|0;r=f[s>>2]|0;if(r|0?(t=r+8|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)FQ(k);r=q+(j*48|0)+4|0;if((f[r>>2]|0)>0){t=f[q+(j*48|0)+32>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0;w=f[r>>2]|0}while((v|0)<(w|0));f[s>>2]=0;f[k>>2]=f[n+12>>2];if((w|0)<3)m=23;else m=25}else{f[s>>2]=0;f[k>>2]=f[n+12>>2];m=23}if((m|0)==23){m=0;v=f[n+16>>2]|0;if((v|0)<3){f[r>>2]=v;f[q+(j*48|0)+8>>2]=f[n+20>>2];f[q+(j*48|0)+12>>2]=f[n+24>>2];v=f[n+48>>2]|0;t=f[q+(j*48|0)+36>>2]|0;f[t>>2]=f[v>>2];f[t+4>>2]=f[v+4>>2]}else m=25}if((m|0)==25){m=0;DQ(k,o)}f[q+(j*48|0)+16>>2]=f[n+28>>2];v=q+(j*48|0)+20|0;if(!(f[v>>2]|0))f[v>>2]=f[n+32>>2];f[s>>2]=f[p>>2];f[q+(j*48|0)+28>>2]=f[n+40>>2]}if(l|0)UXc(l);j=j+1|0;if((j|0)>=(h|0)){m=32;break}}if((m|0)==8){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=$Xc(32)|0;f[e>>2]=h;f[e+8>>2]=-2147483616;f[e+4>>2]=20;j=h;o=393749;w=j+20|0;do{b[j>>0]=b[o>>0]|0;j=j+1|0;o=o+1|0}while((j|0)<(w|0));b[h+20>>0]=0;vM(-215,e,393821,391289,288)}else if((m|0)==32){u=d;return}}function oPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+176|0;e=d+160|0;g=d+24|0;h=d+12|0;i=d;j=i+11|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=g+56|0;l=g+4|0;f[g>>2]=6884;f[k>>2]=6904;XNc(g+56|0,l);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=36020;f[k>>2]=36040;aOc(l);f[l>>2]=35912;m=g+36|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;AM(l,e);if((b[e+11>>0]|0)<0){cYc(f[e>>2]|0);n=b[j>>0]|0;o=f[i+4>>2]|0}else{n=0;o=0}p=n<<24>>24<0;q=p?o:n&255;if(q|0){n=BM(g,p?f[i>>2]|0:i,q)|0;b[e>>0]=32;BM(n,e,1)|0}b[e>>0]=91;BM(g,e,1)|0;n=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;if(n|0){q=0;do{b[e>>0]=32;p=BM(g,e,1)|0;nOc(p,f[(f[c>>2]|0)+(q<<2)>>2]|0)|0;q=q+1|0}while(q>>>0<n>>>0)}BM(g,393818,2)|0;CM(h,l);f[g>>2]=36020;f[k>>2]=36040;f[l>>2]=35912;if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);LMc(l);HNc(g,36052);GMc(k);k=h+11|0;g=b[k>>0]|0;l=g<<24>>24<0;BM(a,l?f[h>>2]|0:h,l?f[h+4>>2]|0:g&255)|0;if((b[k>>0]|0)<0)cYc(f[h>>2]|0);if((b[j>>0]|0)>=0){u=d;return a|0}cYc(f[i>>2]|0);u=d;return a|0}function pPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c+8|0;e=c;W1(e,0);g=f[e>>2]|0;Ti[f[(f[g>>2]|0)+8>>2]&511](d,g,b);b=f[d>>2]|0;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[d>>2]|0;g=_i[f[f[b>>2]>>2]&2047](b)|0;if(g|0){b=g;do{BM(a,b,dJc(b)|0)|0;g=f[d>>2]|0;b=_i[f[f[g>>2]>>2]&2047](g)|0}while((b|0)!=0)}b=f[d+4>>2]|0;if(b|0)UXc(b);b=f[e+4>>2]|0;if(!b){u=c;return a|0}UXc(b);u=c;return a|0}function qPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=(f[a+4>>2]|0)-g>>3;i=(f[c+4>>2]|0)-(f[c>>2]|0)|0;j=g;if((h|0)!=((i|0)/48|0|0)){g=$Xc(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=31;k=g;l=393710;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[g+31>>0]=0;vM(-215,e,393742,391289,299)}if((i|0)<=0){u=d;return}i=f[j>>2]|0;a:do if(i|0){g=0;n=i;o=j;while(1){p=kZc(n,15176,15232,0)|0;if(!p)break a;q=f[o+(g<<3)+4>>2]|0;if(q|0)TXc(q);if(!p)break a;r=f[c>>2]|0;s=r+(g*48|0)|0;t=p+12|0;if((t|0)!=(s|0)){v=r+(g*48|0)+24|0;w=f[v>>2]|0;if(w|0){x=w+8|0;f[x>>2]=(f[x>>2]|0)+1}x=p+36|0;w=f[x>>2]|0;if(w|0?(y=w+8|0,w=f[y>>2]|0,f[y>>2]=w+-1,(w|0)==1):0)FQ(t);w=p+16|0;if((f[w>>2]|0)>0){y=f[p+44>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0;A=f[w>>2]|0}while((z|0)<(A|0));f[x>>2]=0;f[t>>2]=f[s>>2];if((A|0)<3)B=22;else B=24}else{f[x>>2]=0;f[t>>2]=f[s>>2];B=22}if((B|0)==22){B=0;z=f[r+(g*48|0)+4>>2]|0;if((z|0)<3){f[w>>2]=z;f[p+20>>2]=f[r+(g*48|0)+8>>2];f[p+24>>2]=f[r+(g*48|0)+12>>2];z=f[r+(g*48|0)+36>>2]|0;y=f[p+48>>2]|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2]}else B=24}if((B|0)==24){B=0;DQ(t,s)}f[p+28>>2]=f[r+(g*48|0)+16>>2];z=p+32|0;if(!(f[z>>2]|0))f[z>>2]=f[r+(g*48|0)+20>>2];f[x>>2]=f[v>>2];f[p+40>>2]=f[r+(g*48|0)+28>>2]}if(q|0)UXc(q);g=g+1|0;if((g|0)>=(h|0))break;o=f[a>>2]|0;n=f[o+(g<<3)>>2]|0;if(!n)break a}u=d;return}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=20;k=d;l=393749;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[d+20>>0]=0;vM(-215,e,393742,391289,303)}function rPa(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>89478485)kWc(a);d=$Xc(b*48|0)|0;f[c>>2]=d;f[a>>2]=d;f[a+8>>2]=d+(b*48|0);a=b;b=d;do{f[b>>2]=1124007936;d=b+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[b+32>>2]=b+8;d=b+40|0;f[b+36>>2]=d;f[b+44>>2]=0;f[d>>2]=0;b=(f[c>>2]|0)+48|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function sPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+20>>2]|0;d=a+24|0;if((c|0)!=(d|0)){e=c;while(1){if(f[e+20>>2]|0){c=f[e+200>>2]|0;g=e+204|0;h=f[g>>2]|0;if((h|0)!=(c|0))f[g>>2]=h+(~((h+-4-c|0)>>>2)<<2);c=f[e+188>>2]|0;h=e+192|0;g=f[h>>2]|0;if((g|0)!=(c|0)){i=g;do{g=i+-56|0;f[h>>2]=g;j=i+-20|0;k=f[j>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)V$(g);f[j>>2]=0;j=i+-40|0;g=i+-52|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[g>>2]|0)>0){j=f[i+-16>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i+-12>>2]|0;if((g|0)!=(i+-8|0))wL(g);i=f[h>>2]|0}while((i|0)!=(c|0))}c=f[e+212>>2]|0;i=e+216|0;h=f[i>>2]|0;if((h|0)!=(c|0)){g=h;do{h=g+-56|0;f[i>>2]=h;k=g+-20|0;j=f[k>>2]|0;if(j|0?(l=j+12|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)V$(h);f[k>>2]=0;k=g+-40|0;h=g+-52|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[g+-16>>2]|0;j=0;do{f[k+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[g+-12>>2]|0;if((h|0)!=(g+-8|0))wL(h);g=f[i>>2]|0}while((g|0)!=(c|0))}}b[e+236>>0]=0;c=f[e+180>>2]|0;g=f[e+184>>2]|0;i=(g|0)==0;if(!i)TXc(g);if(c|0?(Yi[f[(f[c>>2]|0)+92>>2]&4095](c),h=kZc(c,15160,15280,0)|0,h|0):0){if(!i)TXc(g);if(h|0)b[h+89>>0]=1;if(g|0)UXc(g)}if(!i)UXc(g);g=f[e+4>>2]|0;if(!g){i=e+8|0;h=f[i>>2]|0;if((f[h>>2]|0)==(e|0))m=h;else{h=i;do{i=f[h>>2]|0;h=i+8|0;c=f[h>>2]|0}while((f[c>>2]|0)!=(i|0));m=c}}else{h=g;while(1){c=f[h>>2]|0;if(!c)break;else h=c}m=h}if((m|0)==(d|0))break;else e=m}}m=f[a+124>>2]|0;e=a+128|0;a=f[e>>2]|0;if((a|0)==(m|0))return;f[e>>2]=a+(~((a+-8-m|0)>>>3)<<3);return}function tPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;d=u;u=u+48|0;e=d;g=d+40|0;h=d+44|0;i=d+28|0;j=d+16|0;k=d+12|0;l=a+20|0;m=f[l>>2]|0;n=a+24|0;if((m|0)!=(n|0)){o=m;while(1){f[o+240>>2]=0;m=f[o+4>>2]|0;if(!m){p=o+8|0;q=f[p>>2]|0;if((f[q>>2]|0)==(o|0))r=q;else{q=p;do{p=f[q>>2]|0;q=p+8|0;s=f[q>>2]|0}while((f[s>>2]|0)!=(p|0));r=s}}else{q=m;while(1){s=f[q>>2]|0;if(!s)break;else q=s}r=q}if((r|0)==(n|0))break;else o=r}}f[i>>2]=0;f[g>>2]=i;zPa(e,l,i,1163514,g,h);r=f[e>>2]|0;if((f[r+188>>2]|0)==(f[r+192>>2]|0)){r=$Xc(32)|0;f[e>>2]=r;f[e+8>>2]=-2147483616;f[e+4>>2]=30;t=r;v=394867;w=t+30|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[r+30>>0]=0;vM(-215,e,394898,391289,2160)}f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;o=a+80|0;m=a+84|0;s=e+4|0;p=e+8|0;x=i+8|0;y=e+8|0;z=0;while(1){f[j>>2]=0;f[g>>2]=j;zPa(e,l,j,1163514,g,h);A=f[e>>2]|0;if(z>>>0>=(((f[A+192>>2]|0)-(f[A+188>>2]|0)|0)/56|0)>>>0)break;f[j>>2]=0;f[g>>2]=j;zPa(e,l,j,1163514,g,h);A=f[(f[e>>2]|0)+188>>2]|0;B=A+(z*56|0)+4|0;C=f[B>>2]|0;if((C|0)<3)D=Y(f[A+(z*56|0)+12>>2]|0,f[A+(z*56|0)+8>>2]|0)|0;else{E=f[A+(z*56|0)+40>>2]|0;F=0;G=1;while(1){H=Y(f[E+(F<<2)>>2]|0,G)|0;F=F+1|0;if((F|0)==(C|0)){D=H;break}else G=H}}if(!D){I=18;break}if((f[o>>2]|0)==3?(f[m>>2]|0)==2:0){f[j>>2]=0;f[g>>2]=j;zPa(e,l,j,1163514,g,h);S$((f[(f[e>>2]|0)+188>>2]|0)+(z*56|0)|0,f[B>>2]|0,f[A+(z*56|0)+40>>2]|0,3);J=f[B>>2]|0}else J=C;G=f[A+(z*56|0)+40>>2]|0;f[e>>2]=0;f[s>>2]=0;f[p>>2]=0;gOa(e,G,G+(J<<2)|0);G=f[r>>2]|0;if(G>>>0>=(f[x>>2]|0)>>>0){BPa(i,e);F=f[e>>2]|0;if(F|0){E=f[s>>2]|0;if((E|0)!=(F|0))f[s>>2]=E+(~((E+-4-F|0)>>>2)<<2);cYc(F)}}else{f[G>>2]=0;F=G+4|0;f[F>>2]=0;f[G+8>>2]=0;f[G>>2]=f[e>>2];f[F>>2]=f[s>>2];f[G+8>>2]=f[y>>2];f[y>>2]=0;f[s>>2]=0;f[e>>2]=0;f[r>>2]=G+12}z=z+1|0}if((I|0)==18){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=$Xc(16)|0;f[e>>2]=z;f[e+8>>2]=-2147483632;f[e+4>>2]=11;t=z;v=394913;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[z+11>>0]=0;vM(-215,e,394898,391289,2165)}f[j+4>>2]=0;f[j+8>>2]=0;z=j+4|0;f[j>>2]=z;APa(a,i,j);v=a+44|0;t=a+48|0;yOa(v,f[t>>2]|0);w=a+52|0;f[w>>2]=0;f[v>>2]=t;f[t>>2]=0;s=a+56|0;y=a+60|0;xOa(s,f[y>>2]|0);f[a+64>>2]=0;f[s>>2]=y;f[y>>2]=0;y=a+68|0;s=a+72|0;wOa(y,f[s>>2]|0);f[a+76>>2]=0;f[y>>2]=s;f[s>>2]=0;s=a+104|0;y=a+108|0;vOa(s,f[y>>2]|0);f[a+112>>2]=0;f[s>>2]=y;f[y>>2]=0;y=a+48|0;s=0;while(1){f[k>>2]=0;f[g>>2]=k;zPa(e,l,k,1163514,g,h);x=f[e>>2]|0;if(s>>>0>=(((f[x+192>>2]|0)-(f[x+188>>2]|0)|0)/56|0)>>>0)break;x=f[t>>2]|0;J=(x|0)==0;a:do if(!J){p=t;m=x;b:while(1){o=m;while(1){D=f[o+16>>2]|0;if((D|0)>=0){if(D|0)break;if((f[o+20>>2]|0)>=(s|0))break}D=f[o+4>>2]|0;if(!D){K=p;break b}else o=D}m=f[o>>2]|0;if(!m){K=o;break}else p=o}do if((K|0)!=(t|0)?(p=f[K+16>>2]|0,(p|0)<=0):0){if((p|0)==0?(s|0)<(f[K+20>>2]|0):0)break;p=K+24|0;f[p>>2]=(f[p>>2]|0)+1;break a}while(0);if(!J){p=y;m=x;c:while(1){D=f[m+16>>2]|0;do if((D|0)<=0){if(!D){G=f[m+20>>2]|0;if((s|0)<(G|0)){I=48;break}if((G|0)>=(s|0)){I=53;break c}}L=m+4|0;G=f[L>>2]|0;if(!G){I=52;break c}else{M=L;N=G}}else I=48;while(0);if((I|0)==48){I=0;D=f[m>>2]|0;if(!D){I=49;break}else{M=m;N=D}}p=M;m=N}if((I|0)==49){I=0;O=m;P=m;I=54;break}else if((I|0)==52){I=0;O=m;P=L;I=54;break}else if((I|0)==53){I=0;O=m;P=p;I=54;break}}else{O=t;P=t;I=54}}else{O=t;P=t;I=54}while(0);if((I|0)==54){I=0;x=f[P>>2]|0;if(!x){J=$Xc(28)|0;A=J+16|0;f[A>>2]=0;f[A+4>>2]=s;f[J+24>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=O;f[P>>2]=J;A=f[f[v>>2]>>2]|0;if(!A)Q=J;else{f[v>>2]=A;Q=f[P>>2]|0}UQ(f[y>>2]|0,Q);f[w>>2]=(f[w>>2]|0)+1;R=J}else R=x;f[R+24>>2]=1}s=s+1|0}s=f[l>>2]|0;if((s|0)!=(n|0)){R=s;while(1){s=R+96|0;w=R+100|0;Q=f[w>>2]|0;y=f[s>>2]|0;if((Q|0)!=(y|0)){P=0;O=y;y=Q;while(1){Q=O;L=Q+(P<<3)|0;N=f[t>>2]|0;do if(N){M=f[L>>2]|0;K=f[Q+(P<<3)+4>>2]|0;h=t;g=N;d:while(1){k=g;while(1){x=f[k+16>>2]|0;if((x|0)>=(M|0)){if((x|0)!=(M|0))break;if((f[k+20>>2]|0)>=(K|0))break}x=f[k+4>>2]|0;if(!x){S=h;break d}else k=x}g=f[k>>2]|0;if(!g){S=k;break}else h=k}if((S|0)!=(t|0)?(h=f[S+16>>2]|0,(M|0)>=(h|0)):0){if((M|0)==(h|0)?(K|0)<(f[S+20>>2]|0):0){I=76;break}h=S+24|0;f[h>>2]=(f[h>>2]|0)+1;T=O;U=y}else I=76}else I=76;while(0);if((I|0)==76){I=0;N=CPa(v,L)|0;f[N>>2]=1;T=f[s>>2]|0;U=f[w>>2]|0}P=P+1|0;if(P>>>0>=U-T>>3>>>0)break;else{O=T;y=U}}}y=f[R+4>>2]|0;if(!y){O=R+8|0;P=f[O>>2]|0;if((f[P>>2]|0)==(R|0))V=P;else{P=O;do{O=f[P>>2]|0;P=O+8|0;w=f[P>>2]|0}while((f[w>>2]|0)!=(O|0));V=w}}else{P=y;while(1){w=f[P>>2]|0;if(!w)break;else P=w}V=P}if((V|0)==(n|0))break;else R=V}}V=c+4|0;R=f[V>>2]|0;U=f[c>>2]|0;if((R|0)!=(U|0)){T=0;S=U;U=R;while(1){R=S;y=R+(T<<3)|0;w=f[t>>2]|0;do if(w){O=f[y>>2]|0;s=f[R+(T<<3)+4>>2]|0;N=t;Q=w;e:while(1){p=Q;while(1){m=f[p+16>>2]|0;if((m|0)>=(O|0)){if((m|0)!=(O|0))break;if((f[p+20>>2]|0)>=(s|0))break}m=f[p+4>>2]|0;if(!m){W=N;break e}else p=m}Q=f[p>>2]|0;if(!Q){W=p;break}else N=p}if((W|0)!=(t|0)?(N=f[W+16>>2]|0,(O|0)>=(N|0)):0){if((O|0)==(N|0)?(s|0)<(f[W+20>>2]|0):0){I=98;break}N=W+24|0;f[N>>2]=(f[N>>2]|0)+1;X=S;Z=U}else I=98}else I=98;while(0);if((I|0)==98){I=0;w=CPa(v,y)|0;f[w>>2]=1;X=f[c>>2]|0;Z=f[V>>2]|0}T=T+1|0;if(T>>>0>=Z-X>>3>>>0)break;else{S=X;U=Z}}}Z=f[l>>2]|0;if((Z|0)!=(n|0)){l=Z;while(1){DPa(a,f[l+16>>2]|0,j);Z=f[l+4>>2]|0;if(!Z){U=l+8|0;X=f[U>>2]|0;if((f[X>>2]|0)==(l|0))_=X;else{X=U;do{U=f[X>>2]|0;X=U+8|0;S=f[X>>2]|0}while((f[S>>2]|0)!=(U|0));_=S}}else{X=Z;while(1){y=f[X>>2]|0;if(!y)break;else X=y}_=X}if((_|0)==(n|0))break;else l=_}}_=a+124|0;l=(f[a+116>>2]|0)+1|0;n=e;f[n>>2]=0;f[n+4>>2]=0;n=a+128|0;Z=f[n>>2]|0;y=f[_>>2]|0;S=Z-y>>3;U=y;y=Z;if(l>>>0<=S>>>0){if(l>>>0<S>>>0?(Z=U+(l<<3)|0,(y|0)!=(Z|0)):0)f[n>>2]=y+(~((y+-8-Z|0)>>>3)<<3)}else EPa(_,l-S|0,e);FPa(a,c);GPa(j,f[z>>2]|0);z=f[i>>2]|0;if(!z){u=d;return}j=f[r>>2]|0;if((j|0)==(z|0))$=z;else{c=j;while(1){j=c+-12|0;f[r>>2]=j;a=f[j>>2]|0;if(!a)aa=j;else{j=c+-8|0;e=f[j>>2]|0;if((e|0)!=(a|0))f[j>>2]=e+(~((e+-4-a|0)>>>2)<<2);cYc(a);aa=f[r>>2]|0}if((aa|0)==(z|0))break;else c=aa}$=f[i>>2]|0}cYc($);u=d;return}function uPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;switch(f[a+80>>2]|0){case 3:{if((f[a+84>>2]|0)>>>0<3){u=c;return}else{e=$Xc(80)|0;f[d>>2]=e;f[d+8>>2]=-2147483568;f[d+4>>2]=76;g=e;h=394589;i=g+76|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[e+76>>0]=0;vM(-215,d,394666,391289,1292)}break}case 1:{wPa(a);u=c;return}case 2:{xPa(a);u=c;return}case 4:{u=c;return}default:{c=$Xc(32)|0;f[d>>2]=c;f[d+8>>2]=-2147483616;f[d+4>>2]=26;g=c;h=393683;i=g+26|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));b[c+26>>0]=0;vM(-213,d,394666,391289,1300)}}}function vPa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>3>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>3;o=h>>>0>n>>>0;p=o?b+(n<<3)|0:c;c=p;n=c-e|0;e=n>>3;if(e|0)q1c(k|0,b|0,n|0)|0;n=l+(e<<3)|0;if(o){o=d-c|0;if((o|0)<=0)return;o1c(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>3<<3);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);cYc(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>536870911)kWc(a);j=q>>2;n=q>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(n>>>0>536870911)kWc(a);j=$Xc(n<<3)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<3);if((g|0)<=0)return;o1c(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>3<<3);return}function wPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+80|0;if((f[g>>2]|0)!=1){h=$Xc(48)|0;f[d>>2]=h;f[d+8>>2]=-2147483600;f[d+4>>2]=39;i=h;j=394749;k=i+39|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+39>>0]=0;vM(-215,d,394789,391289,1306)}if(!(zQa()|0)){h=$Xc(16)|0;f[d>>2]=h;f[d+8>>2]=-2147483632;f[d+4>>2]=12;i=h;j=394807;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+12>>0]=0;vM(-215,d,394789,391289,1306)}h=a+20|0;l=f[h>>2]|0;m=l;f[d>>2]=m;n=a+24|0;if((m|0)==(n|0)){u=c;return}a=e+4|0;o=e+4|0;p=l;l=m;while(1){m=p;q=f[m+180>>2]|0;r=f[m+184>>2]|0;s=(r|0)==0;if(!s)TXc(r);if(Mi[f[(f[q>>2]|0)+56>>2]&1023](q,f[g>>2]|0)|0){t=f[d>>2]|0;v=f[t+180>>2]|0;w=f[t+184>>2]|0;x=(w|0)==0;if(!x)TXc(w);if(((((l|0)!=(f[h>>2]|0)?Mi[f[(f[v>>2]|0)+56>>2]&1023](v,f[g>>2]|0)|0:0)?(v=f[m+200>>2]|0,y=v,((f[m+204>>2]|0)-v|0)==4):0)?(v=f[t+188>>2]|0,((f[t+192>>2]|0)-v|0)==56):0)?(f[(f[y>>2]|0)+16>>2]|0)==(f[v+16>>2]|0):0){v=t+224|0;y=t+228|0;z=f[y>>2]|0;do if(z){A=f[g>>2]|0;B=t+228|0;C=z;while(1){D=f[C+16>>2]|0;if((A|0)<(D|0)){E=f[C>>2]|0;if(!E){F=23;break}else{G=C;H=E}}else{if((D|0)>=(A|0)){F=27;break}I=C+4|0;D=f[I>>2]|0;if(!D){F=26;break}else{G=I;H=D}}B=G;C=H}if((F|0)==23){F=0;J=C;K=C;break}else if((F|0)==26){F=0;J=C;K=I;break}else if((F|0)==27){F=0;J=C;K=B;break}}else{J=y;K=y}while(0);z=f[K>>2]|0;if(!z){A=$Xc(28)|0;f[A+16>>2]=f[g>>2];f[A+20>>2]=0;f[A+24>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=J;f[K>>2]=A;D=f[f[v>>2]>>2]|0;if(!D)L=A;else{f[v>>2]=D;L=f[K>>2]|0}UQ(f[t+228>>2]|0,L);D=t+232|0;f[D>>2]=(f[D>>2]|0)+1;M=A}else M=z;if(!(f[M+20>>2]|0)){F=34;break}z=f[(f[q>>2]|0)+76>>2]|0;A=f[y>>2]|0;do if(A){D=f[g>>2]|0;E=t+228|0;N=A;while(1){O=f[N+16>>2]|0;if((D|0)<(O|0)){P=f[N>>2]|0;if(!P){F=40;break}else{Q=N;R=P}}else{if((O|0)>=(D|0)){F=44;break}S=N+4|0;O=f[S>>2]|0;if(!O){F=43;break}else{Q=S;R=O}}E=Q;N=R}if((F|0)==40){F=0;T=N;U=N;break}else if((F|0)==43){F=0;T=N;U=S;break}else if((F|0)==44){F=0;T=N;U=E;break}}else{T=y;U=y}while(0);A=f[U>>2]|0;if(!A){D=$Xc(28)|0;f[D+16>>2]=f[g>>2];f[D+20>>2]=0;f[D+24>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=T;f[U>>2]=D;B=f[f[v>>2]>>2]|0;if(!B)V=D;else{f[v>>2]=B;V=f[U>>2]|0}UQ(f[t+228>>2]|0,V);B=t+232|0;f[B>>2]=(f[B>>2]|0)+1;W=D}else W=A;Ti[z&511](e,q,W+20|0);A=f[e>>2]|0;D=A;do if(!A)X=0;else{b[m+236>>0]=1;B=f[y>>2]|0;do if(B){C=f[g>>2]|0;O=t+228|0;P=B;while(1){Y=f[P+16>>2]|0;if((C|0)<(Y|0)){Z=f[P>>2]|0;if(!Z){F=56;break}else{_=P;$=Z}}else{if((Y|0)>=(C|0)){F=60;break}aa=P+4|0;Y=f[aa>>2]|0;if(!Y){F=59;break}else{_=aa;$=Y}}O=_;P=$}if((F|0)==56){F=0;ba=P;ca=P;break}else if((F|0)==59){F=0;ba=P;ca=aa;break}else if((F|0)==60){F=0;ba=P;ca=O;break}}else{ba=y;ca=y}while(0);B=f[ca>>2]|0;if(!B){E=$Xc(28)|0;f[E+16>>2]=f[g>>2];f[E+20>>2]=0;f[E+24>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=ba;f[ca>>2]=E;N=f[f[v>>2]>>2]|0;if(!N)da=E;else{f[v>>2]=N;da=f[ca>>2]|0}UQ(f[t+228>>2]|0,da);N=t+232|0;f[N>>2]=(f[N>>2]|0)+1;ea=E;fa=f[e>>2]|0}else{ea=B;fa=D}B=f[o>>2]|0;if(B|0)TXc(B);f[ea+20>>2]=fa;E=ea+24|0;N=f[E>>2]|0;f[E>>2]=B;if(N|0)UXc(N);if((t|0)==(m|0)){X=10;break}yPa(t+144|0,f[m+144>>2]|0,f[m+148>>2]|0);X=10}while(0);t=f[o>>2]|0;if(t|0)UXc(t);if(!X)F=75}else F=75;if((F|0)==75){F=0;b[m+236>>0]=0;Ti[f[(f[q>>2]|0)+60>>2]&511](e,q,m+156|0);t=m+224|0;D=m+228|0;v=f[D>>2]|0;do if(v){y=m+228|0;A=v;while(1){z=f[A+16>>2]|0;if((z|0)>1){N=f[A>>2]|0;if(!N){F=80;break}else{ga=A;ha=N}}else{if((z|0)==1){F=84;break}ia=A+4|0;z=f[ia>>2]|0;if(!z){F=83;break}else{ga=ia;ha=z}}y=ga;A=ha}if((F|0)==80){F=0;ja=A;ka=A;break}else if((F|0)==83){F=0;ja=A;ka=ia;break}else if((F|0)==84){F=0;ja=A;ka=y;break}}else{ja=D;ka=D}while(0);D=f[ka>>2]|0;if(!D){v=$Xc(28)|0;f[v+16>>2]=1;f[v+20>>2]=0;f[v+24>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=ja;f[ka>>2]=v;q=f[f[t>>2]>>2]|0;if(!q)la=v;else{f[t>>2]=q;la=f[ka>>2]|0}UQ(f[m+228>>2]|0,la);q=m+232|0;f[q>>2]=(f[q>>2]|0)+1;ma=v}else ma=D;D=f[e>>2]|0;v=f[a>>2]|0;if(v|0)TXc(v);f[ma+20>>2]=D;D=ma+24|0;q=f[D>>2]|0;f[D>>2]=v;if(q|0)UXc(q);q=f[a>>2]|0;if(q|0)UXc(q);f[d>>2]=p}if(!x)UXc(w)}else f[d>>2]=p;if(!s)UXc(r);q=f[l+4>>2]|0;if(!q){v=l+8|0;D=f[v>>2]|0;if((f[D>>2]|0)==(p|0))na=D;else{D=v;do{v=f[D>>2]|0;D=v+8|0;z=f[D>>2]|0}while((f[z>>2]|0)!=(v|0));na=z}}else{D=q;while(1){r=f[D>>2]|0;if(!r)break;else D=r}na=D}if((na|0)==(n|0)){F=107;break}else{p=na;l=na}}if((F|0)==34){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;na=$Xc(48)|0;f[e>>2]=na;f[e+8>>2]=-2147483600;f[e+4>>2]=46;i=na;j=394820;k=i+46|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[na+46>>0]=0;vM(-215,e,394789,391289,1338)}else if((F|0)==107){u=c;return}}function xPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if((f[a+80>>2]|0)!=2){a=$Xc(64)|0;f[d>>2]=a;f[d+8>>2]=-2147483584;f[d+4>>2]=49;e=a;g=394678;h=e+49|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[a+49>>0]=0;vM(-215,d,394728,391289,1459)}if(orb()|0){u=c;return}else{c=$Xc(16)|0;f[d>>2]=c;f[d+8>>2]=-2147483632;f[d+4>>2]=15;e=c;g=427943;h=e+15|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[c+15>>0]=0;vM(-215,d,394728,391289,1459)}}function yPa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c-b>>3;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>g-h>>3>>>0){if(!h)j=g;else{g=a+4|0;k=f[g>>2]|0;if((k|0)==(i|0))l=h;else{m=k;while(1){k=m+-8|0;f[g>>2]=k;n=f[m+-4>>2]|0;if(!n)o=k;else{UXc(n);o=f[g>>2]|0}if((o|0)==(i|0))break;else m=o}l=f[a>>2]|0}cYc(l);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>536870911)kWc(a);g=j>>2;l=j>>3>>>0<268435455?(g>>>0<d>>>0?d:g):536870911;if(l>>>0>536870911)kWc(a);g=$Xc(l<<3)|0;j=a+4|0;f[j>>2]=g;f[a>>2]=g;f[e>>2]=g+(l<<3);if((b|0)==(c|0))return;l=b;e=g;do{f[e>>2]=f[l>>2];g=f[l+4>>2]|0;f[e+4>>2]=g;if(g|0)TXc(g);l=l+8|0;e=(f[j>>2]|0)+8|0;f[j>>2]=e}while((l|0)!=(c|0));return}l=a+4|0;a=(f[l>>2]|0)-h>>3;h=d>>>0>a>>>0;d=b+(a<<3)|0;a=h?d:c;if((a|0)==(b|0))p=i;else{e=b;b=i;while(1){i=f[e>>2]|0;j=f[e+4>>2]|0;if(j|0)TXc(j);f[b>>2]=i;i=b+4|0;g=f[i>>2]|0;f[i>>2]=j;if(g|0)UXc(g);e=e+8|0;g=b+8|0;if((e|0)==(a|0)){p=g;break}else b=g}}if(!h){h=f[l>>2]|0;if((h|0)==(p|0))return;else q=h;while(1){h=q+-8|0;f[l>>2]=h;b=f[q+-4>>2]|0;if(!b)r=h;else{UXc(b);r=f[l>>2]|0}if((r|0)==(p|0))break;else q=r}return}if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{f[d>>2]=f[a>>2];r=f[a+4>>2]|0;f[d+4>>2]=r;if(r|0)TXc(r);a=a+8|0;d=(f[l>>2]|0)+8|0;f[l>>2]=d}while((a|0)!=(c|0));return}function zPa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=c+4|0;e=f[h>>2]|0;do if(e){i=f[d>>2]|0;j=c+4|0;k=e;while(1){l=f[k+16>>2]|0;if((i|0)<(l|0)){m=f[k>>2]|0;if(!m){n=6;break}else{o=k;p=m}}else{if((l|0)>=(i|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==6){r=k;s=k;break}else if((n|0)==9){r=k;s=q;break}else if((n|0)==10){r=k;s=j;break}}else{r=h;s=h}while(0);h=f[s>>2]|0;if(h|0){t=h;u=0;v=t;f[a>>2]=v;w=a+4|0;b[w>>0]=u;return}h=$Xc(244)|0;f[h+16>>2]=f[f[g>>2]>>2];f[h+20>>2]=-1;g=h+24|0;n=h+52|0;f[n>>2]=0;f[h+56>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[h+48>>2]=n;n=h+112|0;f[n>>2]=0;f[h+116>>2]=0;g=h+108|0;q=h+60|0;p=q+48|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(p|0));f[g>>2]=n;n=h+124|0;f[n>>2]=0;f[h+128>>2]=0;f[h+120>>2]=n;n=h+228|0;f[n>>2]=0;f[h+232>>2]=0;g=h+224|0;q=h+132|0;p=q+92|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(p|0));f[g>>2]=n;b[h+236>>0]=0;f[h+240>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=r;f[s>>2]=h;r=f[f[c>>2]>>2]|0;if(!r)x=h;else{f[c>>2]=r;x=f[s>>2]|0}UQ(f[c+4>>2]|0,x);x=c+8|0;f[x>>2]=(f[x>>2]|0)+1;t=h;u=1;v=t;f[a>>2]=v;w=a+4|0;b[w>>0]=u;return}function APa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=d+4|0;GPa(d,f[e>>2]|0);g=d+8|0;f[g>>2]=0;f[d>>2]=e;f[e>>2]=0;h=$Xc(60)|0;i=h+16|0;f[h>>2]=0;f[h+4>>2]=0;j=h+8|0;k=i;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));b[i+40>>0]=0;f[j>>2]=e;f[e>>2]=h;f[d>>2]=h;UQ(h,h);f[g>>2]=(f[g>>2]|0)+1;g=h+20|0;if((g|0)!=(c|0))hQa(g,f[c>>2]|0,f[c+4>>2]|0);c=f[a+20>>2]|0;g=a+24|0;if((c|0)==(g|0))return;else m=c;while(1){iQa(a,f[m+16>>2]|0,d);c=f[m+4>>2]|0;if(!c){h=m+8|0;e=f[h>>2]|0;if((f[e>>2]|0)==(m|0))n=e;else{e=h;do{h=f[e>>2]|0;e=h+8|0;j=f[e>>2]|0}while((f[j>>2]|0)!=(h|0));n=j}}else{e=c;while(1){j=f[e>>2]|0;if(!j)break;else e=j}n=e}if((n|0)==(g|0))break;else m=n}return}function BPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)kWc(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{k=$Xc(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;g=d;i=k+(j*12|0)|0;f[k+(e*12|0)+8>>2]=0;f[d>>2]=f[b>>2];j=b+4|0;f[k+(e*12|0)+4>>2]=f[j>>2];l=b+8|0;f[k+(e*12|0)+8>>2]=f[l>>2];f[l>>2]=0;f[j>>2]=0;f[b>>2]=0;b=d+12|0;j=f[a>>2]|0;l=f[c>>2]|0;if((l|0)==(j|0)){m=g;n=j;o=j}else{e=l;l=g;g=d;do{d=g+-12|0;k=e;e=e+-12|0;f[d>>2]=0;p=g+-8|0;f[p>>2]=0;f[g+-4>>2]=0;f[d>>2]=f[e>>2];d=k+-8|0;f[p>>2]=f[d>>2];p=k+-4|0;f[g+-4>>2]=f[p>>2];f[p>>2]=0;f[d>>2]=0;f[e>>2]=0;g=l+-12|0;l=g}while((e|0)!=(j|0));m=l;n=f[a>>2]|0;o=f[c>>2]|0}f[a>>2]=m;f[c>>2]=b;f[h>>2]=i;i=n;if((o|0)!=(i|0)){h=o;do{o=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=o+-8|0;o=f[c>>2]|0;if((o|0)!=(b|0))f[c>>2]=o+(~((o+-4-b|0)>>>2)<<2);cYc(b)}}while((h|0)!=(i|0))}if(!n)return;cYc(n);return}function CPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;a:while(1){j=f[i+16>>2]|0;do if((e|0)>=(j|0)){k=(e|0)==(j|0);if(k?(g|0)<(f[i+20>>2]|0):0){l=7;break}if((j|0)>=(e|0)){if(!k){l=14;break a}if((f[i+20>>2]|0)>=(g|0)){l=14;break a}}m=i+4|0;k=f[m>>2]|0;if(!k){l=13;break a}else{n=m;o=k}}else l=7;while(0);if((l|0)==7){l=0;j=f[i>>2]|0;if(!j){l=8;break}else{n=i;o=j}}h=n;i=o}if((l|0)==8){p=i;q=i;break}else if((l|0)==13){p=i;q=m;break}else if((l|0)==14){p=i;q=h;break}}else{p=c;q=c}while(0);c=f[q>>2]|0;if(c|0){r=c;s=r+24|0;return s|0}c=$Xc(28)|0;l=b;b=f[l+4>>2]|0;m=c+16|0;f[m>>2]=f[l>>2];f[m+4>>2]=b;f[c+24>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=p;f[q>>2]=c;p=f[f[a>>2]>>2]|0;if(!p)t=c;else{f[a>>2]=p;t=f[q>>2]|0}UQ(f[a+4>>2]|0,t);t=a+8|0;f[t>>2]=(f[t>>2]|0)+1;r=c;s=r+24|0;return s|0}function DPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;e=u;u=u+160|0;g=e+16|0;h=e+144|0;i=e+132|0;j=e;k=e+120|0;l=e+112|0;m=e+108|0;n=e+104|0;o=e+48|0;p=e+116|0;q=e+32|0;f[p>>2]=c;c=a+20|0;f[h>>2]=p;lPa(g,c,p,1163514,h,i);r=f[g>>2]|0;s=r+20|0;t=r+240|0;if(f[t>>2]|0){u=e;return}v=r+96|0;w=r+100|0;x=f[v>>2]|0;y=(f[w>>2]|0)-x>>3;z=(y|0)==0;a:do if(z)A=r+112|0;else{B=r+108|0;C=r+112|0;D=r+112|0;E=r+116|0;F=0;G=x;while(1){H=G+(F<<3)|0;I=f[C>>2]|0;do if(I){J=f[H>>2]|0;K=D;L=I;while(1){M=f[L+16>>2]|0;if((J|0)<(M|0)){N=f[L>>2]|0;if(!N){O=11;break}else{P=L;Q=N}}else{if((M|0)>=(J|0)){O=15;break}R=L+4|0;M=f[R>>2]|0;if(!M){O=14;break}else{P=R;Q=M}}K=P;L=Q}if((O|0)==11){O=0;S=L;T=L;break}else if((O|0)==14){O=0;S=L;T=R;break}else if((O|0)==15){O=0;S=L;T=K;break}}else{S=C;T=C}while(0);if(!(f[T>>2]|0)){I=$Xc(20)|0;f[I+16>>2]=f[H>>2];f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=S;f[T>>2]=I;J=f[f[B>>2]>>2]|0;if(!J)U=I;else{f[B>>2]=J;U=f[T>>2]|0}UQ(f[D>>2]|0,U);f[E>>2]=(f[E>>2]|0)+1}J=F+1|0;if((J|0)==(y|0)){A=C;break a}F=J;G=f[v>>2]|0}}while(0);U=f[r+108>>2]|0;if((U|0)!=(A|0)){T=U;while(1){DPa(a,f[T+16>>2]|0,d);U=f[T+4>>2]|0;if(!U){S=T+8|0;R=f[S>>2]|0;if((f[R>>2]|0)==(T|0))V=R;else{R=S;do{S=f[R>>2]|0;R=S+8|0;Q=f[R>>2]|0}while((f[Q>>2]|0)!=(S|0));V=Q}}else{R=U;while(1){Q=f[R>>2]|0;if(!Q)break;else R=Q}V=R}if((V|0)==(A|0))break;else T=V}}b:do if(!(f[s>>2]|0)){V=f[a>>2]|0;T=(f[V+84>>2]|0)-(f[V+80>>2]|0)|0;V=(T|0)/56|0;A=r+156|0;U=r+160|0;Q=f[U>>2]|0;S=f[A>>2]|0;P=Q-S>>3;x=S;S=Q;if(V>>>0<=P>>>0){if(V>>>0<P>>>0?(Q=x+(V<<3)|0,(S|0)!=(Q|0)):0){x=S;while(1){S=x+-8|0;f[U>>2]=S;G=f[x+-4>>2]|0;if(!G)W=S;else{UXc(G);W=f[U>>2]|0}if((W|0)==(Q|0))break;else x=W}}}else XPa(A,V-P|0);if(T|0){x=g+4|0;Q=0;do{LPa(g,a,(f[(f[a>>2]|0)+80>>2]|0)+(Q*56|0)|0);U=f[A>>2]|0;R=f[g>>2]|0;G=f[x>>2]|0;if(G|0)TXc(G);f[U+(Q<<3)>>2]=R;R=U+(Q<<3)+4|0;U=f[R>>2]|0;f[R>>2]=G;if(U|0)UXc(U);U=f[x>>2]|0;if(U|0)UXc(U);Q=Q+1|0}while(Q>>>0<V>>>0)}}else{V=r+200|0;Q=r+204|0;x=f[Q>>2]|0;A=f[V>>2]|0;T=x-A>>2;P=A;A=x;if(y>>>0<=T>>>0){if(y>>>0<T>>>0?(x=P+(y<<2)|0,(A|0)!=(x|0)):0)f[Q>>2]=A+(~((A+-4-x|0)>>>2)<<2)}else hOa(V,y-T|0);T=r+156|0;x=r+160|0;A=f[x>>2]|0;Q=f[T>>2]|0;P=A-Q>>3;U=Q;Q=A;if(y>>>0<=P>>>0){if(y>>>0<P>>>0?(A=U+(y<<3)|0,(Q|0)!=(A|0)):0){U=Q;while(1){Q=U+-8|0;f[x>>2]=Q;G=f[U+-4>>2]|0;if(!G)X=Q;else{UXc(G);X=f[x>>2]|0}if((X|0)==(A|0))break;else U=X}}}else XPa(T,y-P|0);if(!z){U=j+4|0;A=0;while(1){x=(f[v>>2]|0)+(A<<3)|0;G=f[x>>2]|0;Q=f[x+4>>2]|0;x=j;f[x>>2]=G;f[x+4>>2]=Q;if((G|Q|0)<=-1)break;f[h>>2]=j;lPa(g,c,j,1163514,h,i);f[(f[V>>2]|0)+(A<<2)>>2]=(f[(f[g>>2]|0)+188>>2]|0)+((f[U>>2]|0)*56|0);f[h>>2]=j;lPa(g,c,j,1163514,h,i);Q=f[U>>2]|0;G=f[(f[g>>2]|0)+144>>2]|0;x=f[T>>2]|0;R=f[G+(Q<<3)>>2]|0;S=f[G+(Q<<3)+4>>2]|0;if(S|0)TXc(S);f[x+(A<<3)>>2]=R;R=x+(A<<3)+4|0;x=f[R>>2]|0;f[R>>2]=S;if(x|0)UXc(x);A=A+1|0;if(A>>>0>=y>>>0)break b}A=$Xc(16)|0;f[g>>2]=A;f[g+8>>2]=-2147483632;f[g+4>>2]=12;Z=A;_=395692;$=Z+12|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));b[A+12>>0]=0;vM(-215,g,395705,391289,1746)}}while(0);y=f[p>>2]|0;p=d+4|0;d=f[p>>2]|0;if(!d){aa=$Xc(48)|0;f[g>>2]=aa;ba=g+8|0;f[ba>>2]=-2147483600;ca=g+4|0;f[ca>>2]=35;Z=aa;_=395719;$=Z+35|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));da=aa+35|0;b[da>>0]=0;vM(-215,g,395705,391289,1755)}else{ea=p;fa=d}c:while(1){d=fa;while(1){if((f[d+16>>2]|0)>=(y|0))break;c=f[d+4>>2]|0;if(!c){ga=ea;break c}else d=c}fa=f[d>>2]|0;if(!fa){ga=d;break}else ea=d}if((ga|0)==(p|0)){aa=$Xc(48)|0;f[g>>2]=aa;ba=g+8|0;f[ba>>2]=-2147483600;ca=g+4|0;f[ca>>2]=35;Z=aa;_=395719;$=Z+35|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));da=aa+35|0;b[da>>0]=0;vM(-215,g,395705,391289,1755)}if((f[ga+16>>2]|0)>(y|0)){aa=$Xc(48)|0;f[g>>2]=aa;ba=g+8|0;f[ba>>2]=-2147483600;ca=g+4|0;f[ca>>2]=35;Z=aa;_=395719;$=Z+35|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));da=aa+35|0;b[da>>0]=0;vM(-215,g,395705,391289,1755)}f[q>>2]=0;da=q+4|0;f[da>>2]=0;f[q+8>>2]=0;aa=a+44|0;if((f[a+80>>2]|0)==3)ha=(f[a+84>>2]|0)==2;else ha=0;ca=r+188|0;ba=r+212|0;y=ga+32|0;YPa(j,ga+44|0);p=ga+36|0;ea=((f[p>>2]|0)-(f[y>>2]|0)|0)/12|0;hS(ca,ea>>>0>1?ea:1);ea=j+4|0;hS(ba,((f[ea>>2]|0)-(f[j>>2]|0)|0)/12|0);if((f[r+128>>2]|0)>>>0>(((f[p>>2]|0)-(f[y>>2]|0)|0)/12|0)>>>0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;fa=$Xc(48)|0;f[g>>2]=fa;f[g+8>>2]=-2147483600;f[g+4>>2]=45;Z=fa;_=395755;$=Z+45|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));b[fa+45>>0]=0;vM(-215,g,395801,391289,784)}if((b[ga+56>>0]|0)!=0?((f[r+204>>2]|0)-(f[r+200>>2]|0)|0)==4:0)ia=(ZPa(aa,f[r+96>>2]|0)|0)==1;else ia=0;YPa(k,y);ga=k+4|0;f[l>>2]=f[ga>>2];f[m>>2]=f[j>>2];f[n>>2]=f[ea>>2];f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];f[g>>2]=f[n>>2];_Pa(k,i,h,g)|0;f[h>>2]=0;n=h+4|0;f[n>>2]=0;f[h+8>>2]=0;m=r+192|0;l=f[ca>>2]|0;d:do if((f[m>>2]|0)!=(l|0)){fa=h+8|0;A=0;c=l;z=0;X=0;while(1){W=c+(A*56|0)|0;f[g>>2]=W;if(z>>>0<X>>>0){f[z>>2]=W;f[n>>2]=(f[n>>2]|0)+4}else $Pa(h,g);W=A+1|0;T=f[ca>>2]|0;if(W>>>0>=(((f[m>>2]|0)-T|0)/56|0)>>>0)break d;A=W;c=T;z=f[n>>2]|0;X=f[fa>>2]|0}}while(0);l=r+216|0;fa=f[ba>>2]|0;e:do if((f[l>>2]|0)!=(fa|0)){X=h+8|0;z=g+4|0;c=q+8|0;A=0;d=fa;f:while(1){T=d+(A*56|0)|0;f[g>>2]=T;W=f[n>>2]|0;if(W>>>0<(f[X>>2]|0)>>>0){f[W>>2]=T;f[n>>2]=(f[n>>2]|0)+4}else $Pa(h,g);T=f[j>>2]|0;W=f[T+(A*12|0)+4>>2]|0;U=f[T+(A*12|0)>>2]|0;T=W-U|0;V=T>>2;P=U;do if((P|0)!=(W|0)){if((T|0)<=-4)break f;if((T|0)>0){U=0;x=1;do{x=Y(f[P+(U<<2)>>2]|0,x)|0;U=U+1|0}while((U|0)<(V|0));if(!x)break}U=(((f[m>>2]|0)-(f[ca>>2]|0)|0)/56|0)+A|0;f[g>>2]=f[s>>2];f[z>>2]=U;U=f[da>>2]|0;if(U>>>0<(f[c>>2]|0)>>>0){K=g;L=f[K+4>>2]|0;S=U;f[S>>2]=f[K>>2];f[S+4>>2]=L;f[da>>2]=(f[da>>2]|0)+8}else WOa(q,g)}while(0);A=A+1|0;d=f[ba>>2]|0;if(A>>>0>=(((f[l>>2]|0)-d|0)/56|0)>>>0)break e}d=$Xc(80)|0;f[g>>2]=d;f[g+8>>2]=-2147483568;f[g+4>>2]=70;Z=d;_=454543;$=Z+70|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));b[d+70>>0]=0;vM(-215,g,454614,454620,161)}while(0);fa=f[da>>2]|0;A=f[q>>2]|0;if((fa|0)!=(A|0)){c=a+48|0;z=0;X=A;A=fa;while(1){fa=X;V=fa+(z<<3)|0;P=f[c>>2]|0;do if(P){T=f[V>>2]|0;W=f[fa+(z<<3)+4>>2]|0;H=c;L=P;g:while(1){S=L;while(1){K=f[S+16>>2]|0;if((K|0)>=(T|0)){if((K|0)!=(T|0))break;if((f[S+20>>2]|0)>=(W|0))break}K=f[S+4>>2]|0;if(!K){ja=H;break g}else S=K}L=f[S>>2]|0;if(!L){ja=S;break}else H=S}if((ja|0)!=(c|0)?(H=f[ja+16>>2]|0,(T|0)>=(H|0)):0){if((T|0)==(H|0)?(W|0)<(f[ja+20>>2]|0):0){O=104;break}H=ja+24|0;f[H>>2]=(f[H>>2]|0)+1;ka=X;la=A}else O=104}else O=104;while(0);if((O|0)==104){O=0;P=CPa(aa,V)|0;f[P>>2]=1;ka=f[q>>2]|0;la=f[da>>2]|0}z=z+1|0;if(z>>>0>=la-ka>>3>>>0)break;else{X=ka;A=la}}}la=i+4|0;f[la>>2]=0;A=i+8|0;f[A>>2]=0;ka=i+4|0;f[i>>2]=ka;f[o>>2]=0;X=f[k>>2]|0;do if((f[ga>>2]|0)!=(X|0)){z=X;ja=0;while(1){c=z;P=f[c+(ja*12|0)+4>>2]|0;fa=f[c+(ja*12|0)>>2]|0;c=P-fa|0;d=c>>2;H=fa;if((H|0)!=(P|0)){if((c|0)<=-4){O=129;break}if((c|0)>0){c=0;P=1;while(1){fa=Y(f[H+(c<<2)>>2]|0,P)|0;c=c+1|0;if((c|0)>=(d|0)){ma=fa;break}else P=fa}}else ma=1}else ma=0;P=f[ka>>2]|0;do if(P){d=la;c=P;while(1){H=f[c+16>>2]|0;if((ma|0)<(H|0)){W=f[c>>2]|0;if(!W){O=135;break}else{na=c;oa=W}}else{if((H|0)>=(ma|0)){O=139;break}pa=c+4|0;H=f[pa>>2]|0;if(!H){O=138;break}else{na=pa;oa=H}}d=na;c=oa}if((O|0)==135){O=0;qa=c;ra=c;break}else if((O|0)==138){O=0;qa=c;ra=pa;break}else if((O|0)==139){O=0;qa=c;ra=d;break}}else{qa=ka;ra=ka}while(0);P=f[ra>>2]|0;if(!P){S=$Xc(32)|0;f[S+16>>2]=ma;f[S+20>>2]=0;f[S+24>>2]=0;f[S+28>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=qa;f[ra>>2]=S;H=f[f[i>>2]>>2]|0;if(!H)sa=S;else{f[i>>2]=H;sa=f[ra>>2]|0}UQ(f[la>>2]|0,sa);f[A>>2]=(f[A>>2]|0)+1;ta=S}else ta=P;P=ta+24|0;S=f[P>>2]|0;if((S|0)==(f[ta+28>>2]|0))Tv(ta+20|0,o);else{f[S>>2]=f[o>>2];f[P>>2]=S+4}ja=(f[o>>2]|0)+1|0;f[o>>2]=ja;z=f[k>>2]|0;if(ja>>>0>=(((f[ga>>2]|0)-z|0)/12|0)>>>0){O=123;break}}if((O|0)==123){ua=f[i>>2]|0;break}else if((O|0)==129){z=$Xc(80)|0;f[g>>2]=z;f[g+8>>2]=-2147483568;f[g+4>>2]=70;Z=z;_=454543;$=Z+70|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));b[z+70>>0]=0;vM(-215,g,454614,454620,161)}}else ua=ka;while(0);h:do if((ka|0)!=(ua|0)){ta=g+4|0;A=ia^1;sa=r+200|0;la=o+36|0;ra=o+16|0;qa=o+4|0;ma=o+40|0;pa=o+44|0;oa=o+48|0;na=r+96|0;X=o+8|0;ja=o+12|0;V=o+20|0;S=o+24|0;P=o+28|0;H=o+32|0;W=o+44|0;T=ka;fa=ka;i:while(1){L=T;x=0;while(1){va=f[fa>>2]|0;wa=(va|0)==0;if(wa){K=L;while(1){U=f[K+8>>2]|0;if((f[U>>2]|0)==(K|0))K=U;else{xa=U;break}}}else{K=va;while(1){d=f[K+4>>2]|0;if(!d){xa=K;break}else K=d}}K=xa+20|0;if(x>>>0>=(f[K+4>>2]|0)-(f[K>>2]|0)>>2>>>0)break;if(wa){K=L;while(1){d=f[K+8>>2]|0;if((f[d>>2]|0)==(K|0))K=d;else{ya=d;break}}}else{K=va;while(1){d=f[K+4>>2]|0;if(!d){ya=K;break}else K=d}}K=f[(f[ya+20>>2]|0)+(x<<2)>>2]|0;d=f[k>>2]|0;c=d+(K*12|0)|0;U=f[d+(K*12|0)+4>>2]|0;d=f[c>>2]|0;R=U-d|0;Q=R>>2;G=d;do if((G|0)!=(U|0)){if((R|0)<=-4){O=162;break i}d=(R|0)>0;if(d){F=0;C=1;do{C=Y(f[G+(F<<2)>>2]|0,C)|0;F=F+1|0}while((F|0)<(Q|0));if(!C)break}f[g>>2]=f[s>>2];f[ta>>2]=K;if(K>>>0>=(((f[p>>2]|0)-(f[y>>2]|0)|0)/12|0)>>>0|A)bQa(aa,c,g,f[(f[h>>2]|0)+(K<<2)>>2]|0,ha);else{F=f[f[sa>>2]>>2]|0;E=f[F+4>>2]|0;if((E|0)<3)za=Y(f[F+12>>2]|0,f[F+8>>2]|0)|0;else{D=f[F+40>>2]|0;B=0;J=1;while(1){I=Y(f[D+(B<<2)>>2]|0,J)|0;B=B+1|0;if((B|0)==(E|0)){za=I;break}else J=I}}if(d){J=0;E=1;while(1){B=Y(f[G+(J<<2)>>2]|0,E)|0;J=J+1|0;if((J|0)>=(Q|0)){Aa=B;break}else E=B}}else Aa=1;if((za|0)!=(Aa|0)){O=173;break i}i0(o,F,1,c);E=f[ca>>2]|0;J=E+(K*56|0)|0;do if((J|0)==(o|0)){d=f[la>>2]|0;if(!d)break;B=d+12|0;d=f[B>>2]|0;f[B>>2]=d+-1;if((d|0)!=1)break;V$(o)}else{d=E+(K*56|0)+36|0;B=f[d>>2]|0;do if(B|0){D=B+12|0;C=f[D>>2]|0;f[D>>2]=C+-1;if((C|0)!=1)break;V$(J)}while(0);f[d>>2]=0;B=E+(K*56|0)+16|0;C=E+(K*56|0)+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){D=f[E+(K*56|0)+40>>2]|0;I=0;do{f[D+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[C>>2]|0))}f[J>>2]=f[o>>2];f[C>>2]=f[qa>>2];I=E+(K*56|0)+8|0;f[I>>2]=f[X>>2];f[E+(K*56|0)+12>>2]=f[ja>>2];f[B>>2]=f[ra>>2];f[E+(K*56|0)+20>>2]=f[V>>2];f[E+(K*56|0)+24>>2]=f[S>>2];f[E+(K*56|0)+28>>2]=f[P>>2];f[E+(K*56|0)+32>>2]=f[H>>2];f[d>>2]=f[la>>2];D=E+(K*56|0)+44|0;M=f[D>>2]|0;N=E+(K*56|0)+48|0;if((M|0)==(N|0))Ba=M;else{wL(M);f[D>>2]=N;f[E+(K*56|0)+40>>2]=I;Ba=N}if((f[qa>>2]|0)<3){N=f[W>>2]|0;f[Ba>>2]=f[N>>2];f[Ba+4>>2]=f[N+4>>2]}else{f[D>>2]=f[W>>2];f[E+(K*56|0)+40>>2]=f[ma>>2];f[W>>2]=oa;f[ma>>2]=X}f[o>>2]=1124007936;Z=qa;$=Z+36|0;do{f[Z>>2]=0;Z=Z+4|0}while((Z|0)<($|0))}while(0);f[la>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[qa>>2]|0)>0){E=f[ma>>2]|0;J=0;do{f[E+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[qa>>2]|0))}J=f[pa>>2]|0;if((J|0)!=(oa|0))wL(J);aQa(aa,f[na>>2]|0,g)}}while(0);x=x+1|0}if(wa){x=L;while(1){K=f[x+8>>2]|0;if((f[K>>2]|0)==(x|0))x=K;else{Ca=K;break}}}else{x=va;while(1){L=f[x+4>>2]|0;if(!L){Ca=x;break}else x=L}}if((Ca|0)==(f[i>>2]|0))break h;else{T=Ca;fa=Ca}}if((O|0)==162){fa=$Xc(80)|0;f[g>>2]=fa;f[g+8>>2]=-2147483568;f[g+4>>2]=70;Z=fa;_=454543;$=Z+70|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));b[fa+70>>0]=0;vM(-215,g,454614,454620,161)}else if((O|0)==173){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;T=$Xc(64)|0;f[o>>2]=T;f[o+8>>2]=-2147483584;f[o+4>>2]=49;Z=T;_=395823;$=Z+49|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));b[T+49>>0]=0;vM(-215,o,395801,391289,835)}}while(0);cQa(i,f[ka>>2]|0);ka=f[h>>2]|0;if(ka|0){o=f[n>>2]|0;if((o|0)!=(ka|0))f[n>>2]=o+(~((o+-4-ka|0)>>>2)<<2);cYc(ka)}ka=f[k>>2]|0;if(ka|0){o=f[ga>>2]|0;if((o|0)==(ka|0))Da=ka;else{n=o;while(1){o=n+-12|0;f[ga>>2]=o;_=f[o>>2]|0;if(!_)Ea=o;else{o=n+-8|0;Ca=f[o>>2]|0;if((Ca|0)!=(_|0))f[o>>2]=Ca+(~((Ca+-4-_|0)>>>2)<<2);cYc(_);Ea=f[ga>>2]|0}if((Ea|0)==(ka|0))break;else n=Ea}Da=f[k>>2]|0}cYc(Da)}Da=f[j>>2]|0;if(Da|0){k=f[ea>>2]|0;if((k|0)==(Da|0))Fa=Da;else{Ea=k;while(1){k=Ea+-12|0;f[ea>>2]=k;n=f[k>>2]|0;if(!n)Ga=k;else{k=Ea+-8|0;ka=f[k>>2]|0;if((ka|0)!=(n|0))f[k>>2]=ka+(~((ka+-4-n|0)>>>2)<<2);cYc(n);Ga=f[ea>>2]|0}if((Ga|0)==(Da|0))break;else Ea=Ga}Fa=f[j>>2]|0}cYc(Fa)}Fa=r+144|0;Ga=((f[m>>2]|0)-(f[ca>>2]|0)|0)/56|0;Ea=r+148|0;Da=f[Ea>>2]|0;ea=f[Fa>>2]|0;n=Da-ea>>3;ka=ea;ea=Da;do if(Ga>>>0>n>>>0)XPa(Fa,Ga-n|0);else{if(Ga>>>0>=n>>>0)break;Da=ka+(Ga<<3)|0;if((ea|0)==(Da|0))break;else Ha=ea;while(1){k=Ha+-8|0;f[Ea>>2]=k;ga=f[Ha+-4>>2]|0;if(!ga)Ia=k;else{UXc(ga);Ia=f[Ea>>2]|0}if((Ia|0)==(Da|0))break;else Ha=Ia}}while(0);Ia=f[ca>>2]|0;if((f[m>>2]|0)!=(Ia|0)){Ha=g+4|0;Ea=0;ea=Ia;do{LPa(g,a,ea+(Ea*56|0)|0);Ia=f[Fa>>2]|0;Ga=f[g>>2]|0;ka=f[Ha>>2]|0;if(ka|0)TXc(ka);f[Ia+(Ea<<3)>>2]=Ga;Ga=Ia+(Ea<<3)+4|0;Ia=f[Ga>>2]|0;f[Ga>>2]=ka;if(Ia|0)UXc(Ia);Ia=f[Ha>>2]|0;if(Ia|0)UXc(Ia);Ea=Ea+1|0;ea=f[ca>>2]|0}while(Ea>>>0<(((f[m>>2]|0)-ea|0)/56|0)>>>0)}ea=r+168|0;m=((f[l>>2]|0)-(f[ba>>2]|0)|0)/56|0;Ea=r+172|0;Ha=f[Ea>>2]|0;Fa=f[ea>>2]|0;Ia=Ha-Fa>>3;ka=Fa;Fa=Ha;do if(m>>>0>Ia>>>0)XPa(ea,m-Ia|0);else{if(m>>>0>=Ia>>>0)break;Ha=ka+(m<<3)|0;if((Fa|0)==(Ha|0))break;else Ja=Fa;while(1){Ga=Ja+-8|0;f[Ea>>2]=Ga;n=f[Ja+-4>>2]|0;if(!n)Ka=Ga;else{UXc(n);Ka=f[Ea>>2]|0}if((Ka|0)==(Ha|0))break;else Ja=Ka}}while(0);Ka=f[ba>>2]|0;if((f[l>>2]|0)!=(Ka|0)){Ja=g+4|0;Ea=0;Fa=Ka;do{LPa(g,a,Fa+(Ea*56|0)|0);Ka=f[ea>>2]|0;m=f[g>>2]|0;ka=f[Ja>>2]|0;if(ka|0)TXc(ka);f[Ka+(Ea<<3)>>2]=m;m=Ka+(Ea<<3)+4|0;Ka=f[m>>2]|0;f[m>>2]=ka;if(Ka|0)UXc(Ka);Ka=f[Ja>>2]|0;if(Ka|0)UXc(Ka);Ea=Ea+1|0;Fa=f[ba>>2]|0}while(Ea>>>0<(((f[l>>2]|0)-Fa|0)/56|0)>>>0)}_Oa(i,s);s=r+200|0;Fa=r+204|0;r=f[Fa>>2]|0;l=f[s>>2]|0;Ea=r-l>>2;f[j>>2]=0;ba=j+4|0;f[ba>>2]=0;f[j+8>>2]=0;if(!Ea){La=l;Ma=r;Na=0}else{if(Ea>>>0>76695844)kWc(j);r=Ea*56|0;l=$Xc(r)|0;f[ba>>2]=l;f[j>>2]=l;f[j+8>>2]=l+(Ea*56|0);Ja=l+r|0;r=Ea;Ea=l;while(1){f[Ea>>2]=1124007936;ea=Ea+8|0;Ka=Ea+40|0;Z=Ea+4|0;$=Z+36|0;do{f[Z>>2]=0;Z=Z+4|0}while((Z|0)<($|0));f[Ka>>2]=ea;ka=Ea+48|0;f[Ea+44>>2]=ka;f[ka>>2]=0;f[Ea+52>>2]=0;r=r+-1|0;if(!r)break;else Ea=Ea+56|0}f[ba>>2]=Ja;La=f[s>>2]|0;Ma=f[Fa>>2]|0;Na=l}j:do if((Ma|0)!=(La|0)){l=0;Ja=La;ba=Na;Ea=Ma;while(1){r=f[Ja+(l<<2)>>2]|0;Z=ba+(l*56|0)|0;if((Z|0)==(r|0)){Oa=Ja;Pa=Ea}else{$=r+36|0;ka=f[$>>2]|0;if(ka|0){m=ka+12|0;f[m>>2]=(f[m>>2]|0)+1}m=ba+(l*56|0)+36|0;ka=f[m>>2]|0;do if(ka|0){Ia=ka+12|0;Ha=f[Ia>>2]|0;f[Ia>>2]=Ha+-1;if((Ha|0)!=1)break;V$(Z)}while(0);f[m>>2]=0;ka=ba+(l*56|0)+16|0;Ha=ba+(l*56|0)+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[Ha>>2]|0)>0){Ia=f[ba+(l*56|0)+40>>2]|0;n=0;do{f[Ia+(n<<2)>>2]=0;n=n+1|0;Qa=f[Ha>>2]|0}while((n|0)<(Qa|0));f[Z>>2]=f[r>>2];if((Qa|0)<3)O=273;else O=275}else{f[Z>>2]=f[r>>2];O=273}do if((O|0)==273){O=0;n=f[r+4>>2]|0;if((n|0)>=3){O=275;break}f[Ha>>2]=n;f[ba+(l*56|0)+8>>2]=f[r+8>>2];f[ba+(l*56|0)+12>>2]=f[r+12>>2];n=f[r+44>>2]|0;Ia=f[ba+(l*56|0)+44>>2]|0;f[Ia>>2]=f[n>>2];f[Ia+4>>2]=f[n+4>>2]}while(0);if((O|0)==275){O=0;U$(Z,r)}f[ka>>2]=f[r+16>>2];f[ba+(l*56|0)+20>>2]=f[r+20>>2];f[ba+(l*56|0)+24>>2]=f[r+24>>2];f[ba+(l*56|0)+28>>2]=f[r+28>>2];f[ba+(l*56|0)+32>>2]=f[r+32>>2];f[m>>2]=f[$>>2];Oa=f[s>>2]|0;Pa=f[Fa>>2]|0}Ha=l+1|0;if(Ha>>>0>=Pa-Oa>>2>>>0)break j;l=Ha;Ja=Oa;ba=f[j>>2]|0;Ea=Pa}}while(0);Pa=f[i>>2]|0;Oa=f[(f[Pa>>2]|0)+36>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=17104896;f[g+4>>2]=j;Fa=h+8|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[h>>2]=33882112;f[h+4>>2]=ca;Ti[Oa&511](Pa,g,h);f[(f[i>>2]|0)+40>>2]=f[a+84>>2];hx(j);j=f[v>>2]|0;if((f[w>>2]|0)!=(j|0)){a=0;h=j;do{dQa(aa,h+(a<<3)|0);a=a+1|0;h=f[v>>2]|0}while(a>>>0<(f[w>>2]|0)-h>>3>>>0)}h=f[q>>2]|0;if((f[da>>2]|0)==(h|0))Ra=h;else{w=0;a=h;while(1){dQa(aa,a+(w<<3)|0);w=w+1|0;h=f[q>>2]|0;if(w>>>0>=(f[da>>2]|0)-h>>3>>>0){Ra=h;break}else a=h}}f[t>>2]=1;t=f[i+4>>2]|0;if(!t)Sa=Ra;else{UXc(t);Sa=f[q>>2]|0}if(Sa|0){q=f[da>>2]|0;if((q|0)!=(Sa|0))f[da>>2]=q+(~((q+-8-Sa|0)>>>3)<<3);cYc(Sa)}u=e;return}function EPa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=b;k=i;while(1){l=c;m=f[l+4>>2]|0;n=k;f[n>>2]=f[l>>2];f[n+4>>2]=m;j=j+-1|0;if(!j)break;else k=k+8|0}f[g>>2]=i+(b<<3);return}i=f[a>>2]|0;k=h-i|0;h=k>>3;j=h+b|0;if(j>>>0>536870911)kWc(a);m=e-i|0;e=m>>2;n=m>>3>>>0<268435455?(e>>>0<j>>>0?j:e):536870911;do if(n)if(n>>>0>536870911){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{o=$Xc(n<<3)|0;break}else o=0;while(0);e=o+(h<<3)|0;j=o+(n<<3)|0;n=b;o=e;while(1){m=c;l=f[m+4>>2]|0;p=o;f[p>>2]=f[m>>2];f[p+4>>2]=l;n=n+-1|0;if(!n)break;else o=o+8|0}o=e+(0-h<<3)|0;if((k|0)>0)o1c(o|0,i|0,k|0)|0;f[a>>2]=o;f[g>>2]=e+(b<<3);f[d>>2]=j;if(!i)return;cYc(i);return}function FPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0;d=u;u=u+288|0;e=d+232|0;g=d+176|0;h=d+128|0;i=d+116|0;j=d+104|0;k=d+56|0;l=d+40|0;m=d+8|0;n=d+120|0;o=d;if(!(b[a+121>>0]|0)){u=d;return}p=a+80|0;if((f[p>>2]&-2|0)!=2){u=d;return}q=f[c>>2]|0;r=f[c+4>>2]|0;c=j+4|0;f[c>>2]=0;s=j+8|0;f[s>>2]=0;t=j+4|0;f[j>>2]=t;if((q|0)!=(r|0)){v=t;w=q;do{f[i>>2]=v;f[e>>2]=f[i>>2];q=HPa(j,e,g,h,w)|0;if(!(f[q>>2]|0)){x=$Xc(24)|0;y=w;z=f[y+4>>2]|0;A=x+16|0;f[A>>2]=f[y>>2];f[A+4>>2]=z;z=f[g>>2]|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=z;f[q>>2]=x;z=f[f[j>>2]>>2]|0;if(!z)B=x;else{f[j>>2]=z;B=f[q>>2]|0}UQ(f[c>>2]|0,B);f[s>>2]=(f[s>>2]|0)+1}w=w+8|0}while((w|0)!=(r|0))}r=a+20|0;w=f[r>>2]|0;s=a+24|0;a:do if((w|0)!=(s|0)){B=k+4|0;c=l+4|0;v=a+84|0;q=l+4|0;z=g+4|0;x=g+8|0;A=g+40|0;y=g+48|0;C=g+44|0;D=g+52|0;E=e+8|0;F=e+4|0;G=g+36|0;H=g+16|0;I=e+4|0;J=g+12|0;K=g+20|0;L=g+24|0;M=g+28|0;N=g+32|0;O=g+44|0;P=l+4|0;Q=k+4|0;R=k+8|0;S=k+20|0;T=k+24|0;U=k+28|0;V=k+32|0;W=k+40|0;X=k+36|0;Y=k+44|0;Z=l+4|0;_=l+8|0;$=l+8|0;aa=g+4|0;ba=g+8|0;ca=g+40|0;da=g+48|0;ea=g+44|0;fa=g+52|0;ga=e+8|0;ha=e+4|0;ia=g+36|0;ja=g+16|0;ka=g+4|0;la=g+8|0;ma=g+8|0;na=h+4|0;oa=h+8|0;pa=h+32|0;qa=h+40|0;ra=h+36|0;sa=h+44|0;ta=e+8|0;ua=e+4|0;va=h+12|0;wa=k+12|0;xa=h+16|0;ya=k+16|0;za=h+20|0;Aa=h+24|0;Ba=h+28|0;Ca=k+36|0;Da=h+36|0;Ea=k+32|0;Fa=m+4|0;Ga=m+8|0;Ha=m+12|0;Ia=m+16|0;Ja=m+20|0;Ka=m+24|0;La=m+28|0;Ma=o+4|0;Na=e+40|0;Oa=g+4|0;Pa=h+4|0;Qa=h+8|0;Ra=h+12|0;Sa=h+16|0;Ta=h+20|0;Ua=h+24|0;Va=h+28|0;Wa=h+36|0;Xa=h+32|0;Ya=h+40|0;Za=e+16|0;_a=e+36|0;$a=e+4|0;ab=e+44|0;bb=e+48|0;cb=e+8|0;db=e+12|0;eb=e+20|0;fb=e+24|0;gb=e+28|0;hb=e+32|0;ib=g+12|0;jb=g+20|0;kb=g+24|0;lb=g+28|0;mb=g+32|0;nb=g+44|0;ob=e+4|0;pb=n+4|0;qb=k+44|0;rb=w;b:while(1){f[i>>2]=f[rb+16>>2];f[g>>2]=i;lPa(e,r,i,1163514,g,h);sb=f[e>>2]|0;tb=sb+236|0;c:do if(!(b[tb>>0]|0)){ub=sb+180|0;vb=sb+132|0;wb=sb+136|0;xb=f[vb>>2]|0;yb=xb;d:do if(((f[wb>>2]|0)-xb|0)==8){zb=f[i>>2]|0;Ab=f[t>>2]|0;if(Ab|0){Bb=Ab;do{Ab=f[Bb+16>>2]|0;do if((zb|0)<(Ab|0))Cb=19;else{Db=(zb|0)==(Ab|0);if(Db?(f[Bb+20>>2]|0)>0:0){Cb=19;break}if((Ab|0)>=(zb|0)){if(!Db)break d;if((f[Bb+20>>2]|0)>=0)break d}Eb=Bb+4|0}while(0);if((Cb|0)==19){Cb=0;Eb=Bb}Bb=f[Eb>>2]|0}while((Bb|0)!=0)}f[g>>2]=yb;lPa(e,r,yb,1163514,g,h);Bb=(f[e>>2]|0)+20|0;f[k>>2]=f[f[vb>>2]>>2];f[B>>2]=0;zb=sb+144|0;Ab=sb+188|0;Db=Bb;while(1){f[l>>2]=f[Db+160>>2];Bb=f[Db+164>>2]|0;f[c>>2]=Bb;if(Bb|0)TXc(Bb);Bb=f[ub>>2]|0;if(Mi[f[(f[Bb>>2]|0)+84>>2]&1023](Bb,l)|0){b[Db+216>>0]=1;f[g>>2]=k;lPa(e,r,k,1163514,g,h);Bb=f[e>>2]|0;if((sb|0)!=(Bb|0))JPa(Ab,f[Bb+188>>2]|0,f[Bb+192>>2]|0);f[g>>2]=k;lPa(e,r,k,1163514,g,h);Bb=f[e>>2]|0;if((sb|0)!=(Bb|0))yPa(zb,f[Bb+144>>2]|0,f[Bb+148>>2]|0);Bb=f[Db+112>>2]|0;if(((f[Db+116>>2]|0)-Bb|0)==8){f[m>>2]=f[Bb>>2];f[g>>2]=m;lPa(e,r,m,1163514,g,h);Bb=(f[e>>2]|0)+20|0;Fb=k;f[Fb>>2]=f[m>>2];f[Fb+4>>2]=0;Gb=1;Hb=Bb}else{Gb=0;Hb=0}}else{Gb=0;Hb=Db}Bb=f[c>>2]|0;if(Bb|0)UXc(Bb);if(Gb&(Hb|0)!=0)Db=Hb;else break}if((f[p>>2]|0)!=3)break c;do if(((f[v>>2]|0)+-1|0)>>>0<2){if(!(QQ()|0))break c;Db=f[ub>>2]|0;Bb=Db+28|0;Fb=b[Bb+11>>0]|0;Ib=f[Db+32>>2]|0;if(((Fb<<24>>24<0?Ib:Fb&255)|0)==11){if(!(LYc(Bb,0,-1,429163,11)|0))break;Bb=f[ub>>2]|0;Jb=b[Bb+28+11>>0]|0;Kb=f[Bb+32>>2]|0;Lb=Bb}else{Jb=Fb;Kb=Ib;Lb=Db}if(((Jb<<24>>24<0?Kb:Jb&255)|0)==3){if(!(LYc(Lb+28|0,0,-1,396591,3)|0))break;Db=f[ub>>2]|0;Mb=b[Db+28+11>>0]|0;Nb=f[Db+32>>2]|0;Ob=Db}else{Mb=Jb;Nb=Kb;Ob=Lb}if(((Mb<<24>>24<0?Nb:Mb&255)|0)==7){if(!(LYc(Ob+28|0,0,-1,429057,7)|0))break;Db=f[ub>>2]|0;Pb=b[Db+28+11>>0]|0;Qb=f[Db+32>>2]|0;Rb=Db}else{Pb=Mb;Qb=Nb;Rb=Ob}if(((Pb<<24>>24<0?Qb:Pb&255)|0)==6?(LYc(Rb+28|0,0,-1,428960,6)|0)==0:0)break;break c}while(0);e:do if(!Hb)Sb=0;else{Db=Hb;while(1){do if(((f[v>>2]|0)+-1|0)>>>0<2){Ib=Db+16|0;Fb=Ib+11|0;Bb=b[Fb>>0]|0;Tb=Db+20|0;Ub=f[Tb>>2]|0;if(((Bb<<24>>24<0?Ub:Bb&255)|0)==4){if(!(LYc(Ib,0,-1,429133,4)|0))break;Vb=b[Fb>>0]|0;Wb=f[Tb>>2]|0}else{Vb=Bb;Wb=Ub}if(((Vb<<24>>24<0?Wb:Vb&255)|0)==13){if(!(LYc(Ib,0,-1,396601,13)|0))break;Xb=b[Fb>>0]|0;Yb=f[Tb>>2]|0}else{Xb=Vb;Yb=Wb}if(((Xb<<24>>24<0?Yb:Xb&255)|0)==5){if(!(LYc(Ib,0,-1,396595,5)|0))break;Zb=b[Fb>>0]|0;_b=f[Tb>>2]|0}else{Zb=Xb;_b=Yb}if(((Zb<<24>>24<0?_b:Zb&255)|0)==4){if(!(LYc(Ib,0,-1,394925,4)|0))break;$b=b[Fb>>0]|0;ac=f[Tb>>2]|0}else{$b=Zb;ac=_b}if((($b<<24>>24<0?ac:$b&255)|0)!=5){Sb=Db;break e}if(LYc(Ib,0,-1,439430,5)|0){Sb=Db;break e}}while(0);Ib=f[Db+160>>2]|0;do if((Ib|0)!=0?(Tb=kZc(Ib,15160,15248,0)|0,(Tb|0)!=0):0){Fb=f[Db+164>>2]|0;if(Fb|0)TXc(Fb);f[l>>2]=Tb;f[P>>2]=Fb;if(!Tb){bc=0;cc=Db;dc=Fb;break}Fb=f[ub>>2]|0;do if(Mi[f[(f[Fb>>2]|0)+80>>2]&1023](Fb,l)|0){b[Db+216>>0]=1;f[g>>2]=k;lPa(e,r,k,1163514,g,h);Tb=f[e>>2]|0;if((sb|0)!=(Tb|0))JPa(Ab,f[Tb+188>>2]|0,f[Tb+192>>2]|0);f[g>>2]=k;lPa(e,r,k,1163514,g,h);Tb=f[e>>2]|0;if((sb|0)!=(Tb|0))yPa(zb,f[Tb+144>>2]|0,f[Tb+148>>2]|0);Tb=f[Db+112>>2]|0;if(((f[Db+116>>2]|0)-Tb|0)!=8){ec=0;fc=0;break}f[m>>2]=f[Tb>>2];f[g>>2]=m;lPa(e,r,m,1163514,g,h);Tb=(f[e>>2]|0)+20|0;Ub=k;f[Ub>>2]=f[m>>2];f[Ub+4>>2]=0;ec=1;fc=Tb}else{ec=0;fc=Db}while(0);bc=ec;cc=fc;dc=f[P>>2]|0}else Cb=72;while(0);if((Cb|0)==72){Cb=0;f[l>>2]=0;f[P>>2]=0;bc=0;cc=Db;dc=0}if(dc|0)UXc(dc);if(bc&(cc|0)!=0)Db=cc;else{Sb=cc;break}}}while(0);do if((((((f[v>>2]|0)+-1|0)>>>0<2?(Db=f[ub>>2]|0,Ib=Db+28|0,Fb=b[Ib+11>>0]|0,((Fb<<24>>24<0?f[Db+32>>2]|0:Fb&255)|0)==11):0)?(LYc(Ib,0,-1,429163,11)|0)==0:0)?(Ib=(Sb|0)!=0,Ib):0)?(Fb=f[Sb+160>>2]|0,Fb|0):0){Db=kZc(Fb,15160,15264,0)|0;if(!Db)break;Fb=f[Sb+164>>2]|0;if(!Fb)gc=0;else{TXc(Fb);TXc(Fb);UXc(Fb);gc=Fb}f:do if(Db|0){Fb=f[t>>2]|0;if(Fb|0){Tb=f[k>>2]|0;Ub=f[B>>2]|0;Bb=Fb;do{Fb=f[Bb+16>>2]|0;do if((Tb|0)<(Fb|0))Cb=99;else{hc=(Tb|0)==(Fb|0);if(hc?(Ub|0)<(f[Bb+20>>2]|0):0){Cb=99;break}if((Fb|0)>=(Tb|0)){if(!hc)break f;if((f[Bb+20>>2]|0)>=(Ub|0))break f}ic=Bb+4|0}while(0);if((Cb|0)==99){Cb=0;ic=Bb}Bb=f[ic>>2]|0}while((Bb|0)!=0)}if(!Ib)break;Bb=Sb+76|0;Ub=f[Bb>>2]|0;if(((f[Sb+80>>2]|0)-Ub|0)!=16)break;Tb=Ub;Ub=sb+20|0;f[g>>2]=Tb;lPa(e,r,Tb,1163514,g,h);Tb=f[e>>2]|0;g:do if(!(b[Tb+236>>0]|0)){jc=Tb;Cb=110}else{Fb=Tb;while(1){hc=f[Fb+96>>2]|0;if(((f[Fb+100>>2]|0)-hc|0)!=8){Cb=112;break g}kc=hc;f[g>>2]=kc;lPa(e,r,kc,1163514,g,h);kc=f[e>>2]|0;if(!(b[kc+236>>0]|0)){jc=kc;Cb=110;break}else Fb=kc}}while(0);if((Cb|0)==110){Cb=0;if((f[Ub>>2]|0)==(f[jc+20>>2]|0))lc=1;else Cb=112}if((Cb|0)==112){Cb=0;Tb=(f[Bb>>2]|0)+8|0;f[g>>2]=Tb;lPa(e,r,Tb,1163514,g,h);Tb=f[e>>2]|0;if(!(b[Tb+236>>0]|0))mc=Tb;else{Fb=Tb;while(1){Tb=f[Fb+96>>2]|0;if(((f[Fb+100>>2]|0)-Tb|0)!=8){Cb=412;break b}kc=Tb;f[g>>2]=kc;lPa(e,r,kc,1163514,g,h);kc=f[e>>2]|0;if(!(b[kc+236>>0]|0)){mc=kc;break}else Fb=kc}}if((f[Ub>>2]|0)==(f[mc+20>>2]|0))lc=0;else{Cb=412;break b}}Fb=(f[Bb>>2]|0)+(lc<<3)|0;f[g>>2]=Fb;lPa(e,r,Fb,1163514,g,h);Fb=f[e>>2]|0;kc=Sb+112|0;Tb=f[kc>>2]|0;hc=Tb;if(((f[Sb+116>>2]|0)-Tb|0)!=8)break;if((f[Fb+20>>2]|0)>=(f[Ub>>2]|0))break;f[g>>2]=hc;lPa(e,r,hc,1163514,g,h);hc=f[e>>2]|0;Tb=k;f[Tb>>2]=f[f[kc>>2]>>2];f[Tb+4>>2]=0;f[l>>2]=0;f[q>>2]=0;Tb=f[hc+180>>2]|0;do if(!Tb){nc=0;oc=0;pc=1;qc=0}else{kc=kZc(Tb,15160,15248,0)|0;if(!kc){nc=0;oc=0;pc=1;qc=0;break}rc=kc;kc=f[hc+184>>2]|0;if(!kc){nc=rc;oc=0;pc=1;qc=kc;break}TXc(kc);TXc(kc);nc=rc;oc=kc;pc=0;qc=kc}while(0);f[l>>2]=nc;Tb=f[q>>2]|0;f[q>>2]=oc;if(Tb|0)UXc(Tb);if(!pc)UXc(qc);h:do if(f[l>>2]|0){Tb=f[t>>2]|0;if(Tb|0){Ub=f[k>>2]|0;Bb=f[B>>2]|0;kc=Tb;do{Tb=f[kc+16>>2]|0;do if((Ub|0)<(Tb|0))Cb=128;else{rc=(Ub|0)==(Tb|0);if(rc?(Bb|0)<(f[kc+20>>2]|0):0){Cb=128;break}if((Tb|0)>=(Ub|0)){if(!rc)break h;if((f[kc+20>>2]|0)>=(Bb|0))break h}sc=kc+4|0}while(0);if((Cb|0)==128){Cb=0;sc=kc}kc=f[sc>>2]|0}while((kc|0)!=0)}kc=hc+36|0;do if(MYc(kc,429133)|0){if(!(MYc(kc,396601)|0))break;if(MYc(kc,439430)|0)break h}while(0);kc=f[ub>>2]|0;if(!(Mi[f[(f[kc>>2]|0)+80>>2]&1023](kc,l)|0))break;kc=f[Fb+144>>2]|0;Bb=kc;if(((f[Fb+148>>2]|0)-kc|0)!=8){Cb=139;break b}Ub=sb+156|0;Tb=sb+160|0;rc=f[Tb>>2]|0;tc=rc;if((rc-(f[Ub>>2]|0)|0)!=8){Cb=141;break b}if((tc|0)==(f[sb+164>>2]|0))KPa(Ub,Bb);else{f[rc>>2]=f[kc>>2];kc=f[Bb+4>>2]|0;f[tc+4>>2]=kc;if(!kc)uc=tc;else{TXc(kc);uc=f[Tb>>2]|0}f[Tb>>2]=uc+8}b[Sb+216>>0]=1;b[hc+236>>0]=1;Tb=sb+192|0;kc=f[Ab>>2]|0;tc=kc;if(((f[Tb>>2]|0)-kc|0)!=56){Cb=148;break b}kc=sb+148|0;if(((f[kc>>2]|0)-(f[zb>>2]|0)|0)!=8){Cb=150;break b}f[g>>2]=1124007936;vc=z;wc=vc+36|0;do{f[vc>>2]=0;vc=vc+4|0}while((vc|0)<(wc|0));f[A>>2]=x;f[C>>2]=y;f[y>>2]=0;f[D>>2]=0;Bb=E;f[Bb>>2]=0;f[Bb+4>>2]=0;f[e>>2]=33619968;f[F>>2]=g;jR(tc,e);Bb=f[Ab>>2]|0;do if((Bb|0)==(g|0)){rc=f[G>>2]|0;if(!rc)break;Ub=rc+12|0;rc=f[Ub>>2]|0;f[Ub>>2]=rc+-1;if((rc|0)!=1)break;V$(g)}else{rc=Bb+36|0;Ub=f[rc>>2]|0;do if(Ub|0){xc=Ub+12|0;yc=f[xc>>2]|0;f[xc>>2]=yc+-1;if((yc|0)!=1)break;V$(Bb)}while(0);f[rc>>2]=0;Ub=Bb+16|0;yc=Bb+4|0;f[Ub>>2]=0;f[Ub+4>>2]=0;f[Ub+8>>2]=0;f[Ub+12>>2]=0;if((f[yc>>2]|0)>0){xc=f[Bb+40>>2]|0;zc=0;do{f[xc+(zc<<2)>>2]=0;zc=zc+1|0}while((zc|0)<(f[yc>>2]|0))}f[Bb>>2]=f[g>>2];f[yc>>2]=f[z>>2];zc=Bb+8|0;f[zc>>2]=f[x>>2];f[Bb+12>>2]=f[J>>2];f[Ub>>2]=f[H>>2];f[Bb+20>>2]=f[K>>2];f[Bb+24>>2]=f[L>>2];f[Bb+28>>2]=f[M>>2];f[Bb+32>>2]=f[N>>2];f[rc>>2]=f[G>>2];xc=Bb+44|0;Ac=f[xc>>2]|0;Bc=Bb+48|0;if((Ac|0)==(Bc|0))Cc=Ac;else{wL(Ac);f[xc>>2]=Bc;f[Bb+40>>2]=zc;Cc=Bc}if((f[z>>2]|0)<3){Bc=f[O>>2]|0;f[Cc>>2]=f[Bc>>2];f[Cc+4>>2]=f[Bc+4>>2]}else{f[xc>>2]=f[O>>2];f[Bb+40>>2]=f[A>>2];f[O>>2]=y;f[A>>2]=x}f[g>>2]=1124007936;vc=z;wc=vc+36|0;do{f[vc>>2]=0;vc=vc+4|0}while((vc|0)<(wc|0))}while(0);f[G>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[z>>2]|0)>0){Bb=f[A>>2]|0;tc=0;do{f[Bb+(tc<<2)>>2]=0;tc=tc+1|0}while((tc|0)<(f[z>>2]|0))}tc=f[C>>2]|0;if((tc|0)!=(y|0))wL(tc);LPa(e,a,f[Ab>>2]|0);tc=f[zb>>2]|0;Bb=f[e>>2]|0;rc=f[I>>2]|0;if(rc|0)TXc(rc);f[tc>>2]=Bb;Bb=tc+4|0;tc=f[Bb>>2]|0;f[Bb>>2]=rc;if(tc|0)UXc(tc);tc=f[I>>2]|0;if(tc|0)UXc(tc);tc=Sb+168|0;if((tc|0)!=(Ab|0))JPa(tc,f[Ab>>2]|0,f[Tb>>2]|0);tc=(hc|0)==(sb|0);if(!tc)JPa(hc+188|0,f[Ab>>2]|0,f[Tb>>2]|0);rc=Sb+124|0;if((rc|0)!=(zb|0))yPa(rc,f[zb>>2]|0,f[kc>>2]|0);if(!tc)yPa(hc+144|0,f[zb>>2]|0,f[kc>>2]|0);tc=hc+132|0;rc=hc+136|0;Bb=f[tc>>2]|0;if((f[rc>>2]|0)==(Bb|0))break;else{Dc=0;Ec=Bb}do{Bb=Ec+(Dc<<3)|0;f[g>>2]=Bb;lPa(e,r,Bb,1163514,g,h);Bb=f[e>>2]|0;Ub=f[Bb+100>>2]|0;yc=f[Bb+96>>2]|0;xc=yc;i:do if((Ub|0)!=(yc|0)){Bc=f[k>>2]|0;zc=Ub-yc>>3;Ac=0;while(1){if((f[xc+(Ac<<3)>>2]|0)==(Bc|0))break;Fc=Ac+1|0;if(Fc>>>0<zc>>>0)Ac=Fc;else break i}f[(f[Bb+200>>2]|0)+(Ac<<2)>>2]=f[Ab>>2];zc=f[zb>>2]|0;Bc=f[Bb+156>>2]|0;Fc=f[zc>>2]|0;Gc=f[zc+4>>2]|0;if(Gc|0)TXc(Gc);f[Bc+(Ac<<3)>>2]=Fc;Fc=Bc+(Ac<<3)+4|0;Bc=f[Fc>>2]|0;f[Fc>>2]=Gc;if(!Bc)break;UXc(Bc)}while(0);Dc=Dc+1|0;Ec=f[tc>>2]|0}while(Dc>>>0<(f[rc>>2]|0)-Ec>>3>>>0)}while(0);hc=f[q>>2]|0;if(hc|0)UXc(hc)}while(0);if(!gc)break;UXc(gc)}while(0)}while(0);if((f[p>>2]|0)==3?(yb=f[ub>>2]|0,yb|0):0){xb=kZc(yb,15160,15280,0)|0;j:do if(xb){yb=f[sb+184>>2]|0;zb=yb;if(yb|0)TXc(yb);if((xb|0)!=0?(yb=f[vb>>2]|0,Ab=f[wb>>2]|0,(yb|0)!=(Ab|0)):0){Ib=Ab-yb>>3;if(Ib|0){Ab=0;do{if((f[yb+(Ab<<3)+4>>2]|0)>0){Hc=zb;break j}Ab=Ab+1|0}while(Ab>>>0<Ib>>>0)}b[xb+89>>0]=0;Hc=zb}else Hc=zb}else Hc=0;while(0);xb=f[ub>>2]|0;if(xb|0?(wb=kZc(xb,15160,15296,0)|0,wb|0):0){xb=f[sb+184>>2]|0;if(xb|0)TXc(xb);do if((wb|0?(f[wb+44>>2]|0)==1:0)?(b[wb+48>>0]|0)==0:0){vb=f[sb+188>>2]|0;Ib=vb;if(((f[sb+192>>2]|0)-vb|0)!=56)break;f[k>>2]=1124007936;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;f[Q+16>>2]=0;f[Q+20>>2]=0;f[Q+24>>2]=0;f[V>>2]=R;f[X>>2]=W;f[Y>>2]=0;f[W>>2]=0;vb=sb+144|0;do if((f[vb>>2]|0)==(f[sb+148>>2]|0))Cb=259;else{if((f[p>>2]|0)!=3){Cb=259;break}if(((f[v>>2]|0)+-1|0)>>>0>=2){Cb=259;break}Ab=sb+96|0;yb=f[Ab>>2]|0;Db=(f[sb+100>>2]|0)-yb>>3;if(Db|0){hc=1;Fb=0;rc=yb;while(1){yb=rc+(Fb<<3)|0;tc=f[yb+4>>2]|0;kc=l;f[kc>>2]=f[yb>>2];f[kc+4>>2]=tc;f[g>>2]=l;lPa(e,r,l,1163514,g,h);tc=f[e>>2]|0;kc=tc+20|0;k:do if(!(b[tc+236>>0]|0))Ic=kc;else{yb=kc;Tb=tc;while(1){Bb=f[Tb+96>>2]|0;if(((f[Tb+100>>2]|0)-Bb|0)!=8){Ic=yb;break k}if(((f[Tb+136>>2]|0)-(f[Tb+132>>2]|0)|0)!=8){Ic=yb;break k}xc=Bb;Bb=f[xc+4>>2]|0;yc=l;f[yc>>2]=f[xc>>2];f[yc+4>>2]=Bb;f[g>>2]=l;lPa(e,r,l,1163514,g,h);Tb=f[e>>2]|0;Bb=Tb+20|0;if(!(b[Tb+236>>0]|0)){Ic=Bb;break}else yb=Bb}}while(0);do if(hc){_Oa(n,Ic);tc=f[n>>2]|0;kc=tc+28|0;yb=b[kc+11>>0]|0;if(((yb<<24>>24<0?f[tc+32>>2]|0:yb&255)|0)==11)Jc=(LYc(kc,0,-1,429163,11)|0)==0;else Jc=0;kc=f[pb>>2]|0;if(!kc){Kc=Jc;break}UXc(kc);Kc=Jc}else Kc=0;while(0);kc=Fb+1|0;if(kc>>>0>=Db>>>0)break;hc=Kc;Fb=kc;rc=f[Ab>>2]|0}if(!Kc)break}nPa(e,vb);Ab=f[e>>2]|0;rc=f[ob>>2]|0;Fb=Ab;if((k|0)==(Fb|0)){if(!Ab){Cb=259;break}}else{hc=Fb+24|0;Db=f[hc>>2]|0;if(Db|0){kc=Db+8|0;f[kc>>2]=(f[kc>>2]|0)+1}kc=f[T>>2]|0;do if(kc|0){Db=kc+8|0;yb=f[Db>>2]|0;f[Db>>2]=yb+-1;if((yb|0)!=1)break;FQ(k)}while(0);if((f[Q>>2]|0)>0){kc=f[V>>2]|0;yb=0;do{f[kc+(yb<<2)>>2]=0;yb=yb+1|0;Lc=f[Q>>2]|0}while((yb|0)<(Lc|0));f[T>>2]=0;f[k>>2]=f[Fb>>2];if((Lc|0)<3)Cb=249;else Cb=251}else{f[T>>2]=0;f[k>>2]=f[Fb>>2];Cb=249}do if((Cb|0)==249){Cb=0;yb=f[Fb+4>>2]|0;if((yb|0)>=3){Cb=251;break}f[Q>>2]=yb;f[R>>2]=f[Fb+8>>2];f[wa>>2]=f[Fb+12>>2];yb=f[Fb+36>>2]|0;kc=f[X>>2]|0;f[kc>>2]=f[yb>>2];f[kc+4>>2]=f[yb+4>>2]}while(0);if((Cb|0)==251){Cb=0;DQ(k,Fb)}f[ya>>2]=f[Fb+16>>2];if(!(f[S>>2]|0))f[S>>2]=f[Fb+20>>2];f[T>>2]=f[hc>>2];f[U>>2]=f[Fb+28>>2]}yb=rc;if((yb|0)!=(Fb|0)){kc=yb;do{kc=kc+-48|0;EQ(kc)}while((kc|0)!=(Fb|0))}cYc(Ab);Cb=259}while(0);do if((Cb|0)==259){Cb=0;zb=Ib+4|0;if((f[zb>>2]|0)!=4)break;Fb=Ib+40|0;if((f[f[Fb>>2]>>2]|0)!=1)break;kc=sb+96|0;rc=(f[sb+100>>2]|0)-(f[kc>>2]|0)|0;hc=rc>>3;f[l>>2]=0;f[Z>>2]=0;f[_>>2]=0;yb=(hc|0)==0;l:do if(yb)Cb=272;else{if(hc>>>0>536870911){Cb=263;break b}Db=$Xc(rc)|0;f[l>>2]=Db;tc=Db+(hc<<3)|0;f[$>>2]=tc;g1c(Db|0,-1,rc|0)|0;f[Z>>2]=tc;tc=0;m:while(1){Db=(f[kc>>2]|0)+(tc<<3)|0;Tb=f[Db+4>>2]|0;Bb=m;f[Bb>>2]=f[Db>>2];f[Bb+4>>2]=Tb;f[g>>2]=m;lPa(e,r,m,1163514,g,h);Tb=f[e>>2]|0;if(!(b[Tb+236>>0]|0))Mc=Tb;else{Bb=Tb;while(1){Tb=f[Bb+96>>2]|0;if(((f[Bb+100>>2]|0)-Tb|0)!=8)break m;if(((f[Bb+136>>2]|0)-(f[Bb+132>>2]|0)|0)!=8)break m;Db=Tb;Tb=f[Db+4>>2]|0;yc=m;f[yc>>2]=f[Db>>2];f[yc+4>>2]=Tb;f[g>>2]=m;lPa(e,r,m,1163514,g,h);Tb=f[e>>2]|0;if(!(b[Tb+236>>0]|0)){Mc=Tb;break}else Bb=Tb}}if(((f[Mc+136>>2]|0)-(f[Mc+132>>2]|0)|0)!=8)break;Bb=m;Tb=f[Bb+4>>2]|0;yc=(f[l>>2]|0)+(tc<<3)|0;f[yc>>2]=f[Bb>>2];f[yc+4>>2]=Tb;tc=tc+1|0;if(tc>>>0>=hc>>>0){Cb=272;break l}}}while(0);if((Cb|0)==272){Cb=0;f[g>>2]=1124007936;vc=aa;wc=vc+36|0;do{f[vc>>2]=0;vc=vc+4|0}while((vc|0)<(wc|0));f[ca>>2]=ba;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;kc=ga;f[kc>>2]=0;f[kc+4>>2]=0;f[e>>2]=33619968;f[ha>>2]=g;jR(Ib,e);do if((Ib|0)==(g|0)){kc=f[ia>>2]|0;if(!kc)break;rc=kc+12|0;kc=f[rc>>2]|0;f[rc>>2]=kc+-1;if((kc|0)!=1)break;V$(g)}else{kc=Ib+36|0;rc=f[kc>>2]|0;do if(rc|0){Ab=rc+12|0;tc=f[Ab>>2]|0;f[Ab>>2]=tc+-1;if((tc|0)!=1)break;V$(Ib)}while(0);f[kc>>2]=0;rc=Ib+16|0;f[rc>>2]=0;f[rc+4>>2]=0;f[rc+8>>2]=0;f[rc+12>>2]=0;if((f[zb>>2]|0)>0){tc=f[Ib+40>>2]|0;Ab=0;do{f[tc+(Ab<<2)>>2]=0;Ab=Ab+1|0}while((Ab|0)<(f[zb>>2]|0))}f[Ib>>2]=f[g>>2];f[zb>>2]=f[aa>>2];Ab=Ib+8|0;f[Ab>>2]=f[ba>>2];f[Ib+12>>2]=f[ib>>2];f[rc>>2]=f[ja>>2];f[Ib+20>>2]=f[jb>>2];f[Ib+24>>2]=f[kb>>2];f[Ib+28>>2]=f[lb>>2];f[Ib+32>>2]=f[mb>>2];f[kc>>2]=f[ia>>2];tc=Ib+44|0;Tb=f[tc>>2]|0;yc=Ib+48|0;if((Tb|0)==(yc|0))Nc=Tb;else{wL(Tb);f[tc>>2]=yc;f[Ib+40>>2]=Ab;Nc=yc}if((f[aa>>2]|0)<3){yc=f[nb>>2]|0;f[Nc>>2]=f[yc>>2];f[Nc+4>>2]=f[yc+4>>2]}else{f[tc>>2]=f[nb>>2];f[Fb>>2]=f[ca>>2];f[nb>>2]=da;f[ca>>2]=ba}f[g>>2]=1124007936;vc=aa;wc=vc+36|0;do{f[vc>>2]=0;vc=vc+4|0}while((vc|0)<(wc|0))}while(0);f[ia>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[aa>>2]|0)>0){Fb=f[ca>>2]|0;zb=0;do{f[Fb+(zb<<2)>>2]=0;zb=zb+1|0}while((zb|0)<(f[aa>>2]|0))}zb=f[ea>>2]|0;if((zb|0)!=(da|0))wL(zb);do if((f[p>>2]|0)==3){if(((f[v>>2]|0)+-1|0)>>>0>=2)break;f[g>>2]=0;f[ka>>2]=0;f[la>>2]=0;zb=$Xc(48)|0;f[g>>2]=zb;Fb=zb+48|0;f[ma>>2]=Fb;f[zb>>2]=1124007936;kc=zb+4|0;f[kc>>2]=0;f[kc+4>>2]=0;f[kc+8>>2]=0;f[kc+12>>2]=0;f[kc+16>>2]=0;f[kc+20>>2]=0;f[kc+24>>2]=0;f[zb+32>>2]=zb+8;kc=zb+40|0;f[zb+36>>2]=kc;f[zb+44>>2]=0;f[kc>>2]=0;f[ka>>2]=Fb;f[h>>2]=1124007936;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;f[na+16>>2]=0;f[na+20>>2]=0;f[na+24>>2]=0;f[pa>>2]=oa;f[ra>>2]=qa;f[sa>>2]=0;f[qa>>2]=0;Fb=ta;f[Fb>>2]=0;f[Fb+4>>2]=0;f[e>>2]=34209792;f[ua>>2]=h;LQ(k,e);Fb=f[T>>2]|0;do if(Fb|0){kc=Fb+8|0;zb=f[kc>>2]|0;f[kc>>2]=zb+-1;if((zb|0)!=1)break;FQ(k)}while(0);if((f[Q>>2]|0)>0){Fb=f[V>>2]|0;zb=0;do{f[Fb+(zb<<2)>>2]=0;zb=zb+1|0}while((zb|0)<(f[Q>>2]|0))}f[k>>2]=f[h>>2];zb=f[na>>2]|0;f[Q>>2]=zb;f[R>>2]=f[oa>>2];f[wa>>2]=f[va>>2];f[ya>>2]=f[xa>>2];f[S>>2]=f[za>>2];f[T>>2]=f[Aa>>2];f[U>>2]=f[Ba>>2];Fb=f[Ca>>2]|0;if((Fb|0)==(W|0))Oc=zb;else{wL(Fb);f[Ca>>2]=W;f[V>>2]=R;Oc=f[na>>2]|0}if((Oc|0)<3){Fb=f[Da>>2]|0;f[W>>2]=f[Fb>>2];f[qb>>2]=f[Fb+4>>2]}else{f[Ca>>2]=f[Da>>2];f[Ea>>2]=f[pa>>2];f[Da>>2]=qa;f[pa>>2]=oa}f[h>>2]=1124007936;f[Aa>>2]=0;f[Ba>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;EQ(h);Fb=f[g>>2]|0;if((Fb|0)!=(k|0)){zb=f[T>>2]|0;if(zb|0){kc=zb+8|0;f[kc>>2]=(f[kc>>2]|0)+1}kc=Fb+24|0;zb=f[kc>>2]|0;do if(zb|0){rc=zb+8|0;tc=f[rc>>2]|0;f[rc>>2]=tc+-1;if((tc|0)!=1)break;FQ(Fb)}while(0);zb=Fb+4|0;if((f[zb>>2]|0)>0){tc=f[Fb+32>>2]|0;rc=0;do{f[tc+(rc<<2)>>2]=0;rc=rc+1|0;Pc=f[zb>>2]|0}while((rc|0)<(Pc|0));f[kc>>2]=0;f[Fb>>2]=f[k>>2];if((Pc|0)<3)Cb=317;else Cb=319}else{f[kc>>2]=0;f[Fb>>2]=f[k>>2];Cb=317}do if((Cb|0)==317){Cb=0;rc=f[Q>>2]|0;if((rc|0)>=3){Cb=319;break}f[zb>>2]=rc;f[Fb+8>>2]=f[R>>2];f[Fb+12>>2]=f[wa>>2];rc=f[X>>2]|0;tc=f[Fb+36>>2]|0;f[tc>>2]=f[rc>>2];f[tc+4>>2]=f[rc+4>>2]}while(0);if((Cb|0)==319){Cb=0;DQ(Fb,k)}f[Fb+16>>2]=f[ya>>2];zb=Fb+20|0;if(!(f[zb>>2]|0))f[zb>>2]=f[S>>2];f[kc>>2]=f[T>>2];f[Fb+28>>2]=f[U>>2]}qPa(vb,g);zb=f[g>>2]|0;if(zb|0){rc=f[ka>>2]|0;if((rc|0)==(zb|0))Qc=zb;else{tc=rc;do{rc=tc+-48|0;f[ka>>2]=rc;EQ(rc);tc=f[ka>>2]|0}while((tc|0)!=(zb|0));Qc=f[g>>2]|0}cYc(Qc)}}while(0);f[m>>2]=-2147483648;f[Fa>>2]=2147483647;f[Ga>>2]=-2147483648;f[Ha>>2]=2147483647;f[Ia>>2]=-2147483648;f[Ja>>2]=2147483647;f[Ka>>2]=-2147483648;f[La>>2]=2147483647;if(!yb){zb=sb+200|0;tc=0;Fb=0;do{kc=(f[l>>2]|0)+(Fb<<3)|0;rc=f[kc+4>>2]|0;yc=o;f[yc>>2]=f[kc>>2];f[yc+4>>2]=rc;f[g>>2]=o;lPa(e,r,o,1163514,g,h);rc=f[e>>2]|0;yc=tc;tc=(f[(f[(f[(f[zb>>2]|0)+(Fb<<2)>>2]|0)+40>>2]|0)+4>>2]|0)+tc|0;kc=Ga;f[kc>>2]=yc;f[kc+4>>2]=tc;X$(e,Ib,m);kc=f[Ma>>2]|0;yc=f[rc+188>>2]|0;Ab=yc+(kc*56|0)|0;if(!(f[e>>2]&16384)){Cb=339;break b}Tb=f[Na>>2]|0;Bb=f[Tb+-4>>2]|0;Db=yc+(kc*56|0)+40|0;xc=f[Db>>2]|0;if((Bb|0)!=(f[xc+-4>>2]|0)){Cb=339;break b}do if((Bb|0)==2){if((f[Tb>>2]|0)!=(f[xc>>2]|0)){Cb=339;break b}if((f[Tb+4>>2]|0)!=(f[xc+4>>2]|0)){Cb=339;break b}}else{if((Bb|0)>0)Rc=0;else break;do{if((f[Tb+(Rc<<2)>>2]|0)!=(f[xc+(Rc<<2)>>2]|0)){Cb=339;break b}Rc=Rc+1|0}while((Rc|0)<(Bb|0))}while(0);if((Ab|0)!=(e|0)){Bb=f[_a>>2]|0;if(Bb|0){xc=Bb+12|0;f[xc>>2]=(f[xc>>2]|0)+1}xc=yc+(kc*56|0)+36|0;Bb=f[xc>>2]|0;do if(Bb|0){Tb=Bb+12|0;Ub=f[Tb>>2]|0;f[Tb>>2]=Ub+-1;if((Ub|0)!=1)break;V$(Ab)}while(0);f[xc>>2]=0;Bb=yc+(kc*56|0)+16|0;Ub=yc+(kc*56|0)+4|0;f[Bb>>2]=0;f[Bb+4>>2]=0;f[Bb+8>>2]=0;f[Bb+12>>2]=0;if((f[Ub>>2]|0)>0){Tb=f[Db>>2]|0;Bc=0;do{f[Tb+(Bc<<2)>>2]=0;Bc=Bc+1|0;Sc=f[Ub>>2]|0}while((Bc|0)<(Sc|0));f[Ab>>2]=f[e>>2];if((Sc|0)<3)Cb=351;else Cb=353}else{f[Ab>>2]=f[e>>2];Cb=351}do if((Cb|0)==351){Cb=0;Bc=f[$a>>2]|0;if((Bc|0)>=3){Cb=353;break}f[Ub>>2]=Bc;f[yc+(kc*56|0)+8>>2]=f[cb>>2];f[yc+(kc*56|0)+12>>2]=f[db>>2];Bc=f[ab>>2]|0;Tb=f[yc+(kc*56|0)+44>>2]|0;f[Tb>>2]=f[Bc>>2];f[Tb+4>>2]=f[Bc+4>>2]}while(0);if((Cb|0)==353){Cb=0;U$(Ab,e)}f[Bb>>2]=f[Za>>2];f[yc+(kc*56|0)+20>>2]=f[eb>>2];f[yc+(kc*56|0)+24>>2]=f[fb>>2];f[yc+(kc*56|0)+28>>2]=f[gb>>2];f[yc+(kc*56|0)+32>>2]=f[hb>>2];f[xc>>2]=f[_a>>2]}do if((f[p>>2]|0)==3){if(((f[v>>2]|0)+-1|0)>>>0>=2)break;Ub=rc+144|0;rPa(g,(f[rc+148>>2]|0)-(f[Ub>>2]|0)>>3);HQ(h,k,m);Bc=f[Ma>>2]|0;Tb=f[g>>2]|0;Db=Tb+(Bc*48|0)|0;if((Db|0)!=(h|0)){Gc=Tb+(Bc*48|0)+24|0;Fc=f[Gc>>2]|0;do if(Fc|0){zc=Fc+8|0;Tc=f[zc>>2]|0;f[zc>>2]=Tc+-1;if((Tc|0)!=1)break;FQ(Db)}while(0);Fc=Tb+(Bc*48|0)+4|0;if((f[Fc>>2]|0)>0){Tc=f[Tb+(Bc*48|0)+32>>2]|0;zc=0;do{f[Tc+(zc<<2)>>2]=0;zc=zc+1|0}while((zc|0)<(f[Fc>>2]|0))}f[Gc>>2]=0;f[Db>>2]=f[h>>2];f[Fc>>2]=f[Pa>>2];zc=Tb+(Bc*48|0)+8|0;f[zc>>2]=f[Qa>>2];f[Tb+(Bc*48|0)+12>>2]=f[Ra>>2];f[Tb+(Bc*48|0)+16>>2]=f[Sa>>2];f[Tb+(Bc*48|0)+20>>2]=f[Ta>>2];f[Gc>>2]=f[Ua>>2];f[Tb+(Bc*48|0)+28>>2]=f[Va>>2];Tc=Tb+(Bc*48|0)+36|0;Uc=f[Tc>>2]|0;Vc=Tb+(Bc*48|0)+40|0;if((Uc|0)==(Vc|0))Wc=Uc;else{wL(Uc);f[Tc>>2]=Vc;f[Tb+(Bc*48|0)+32>>2]=zc;Wc=Vc}if((f[Pa>>2]|0)<3){Vc=f[Wa>>2]|0;f[Wc>>2]=f[Vc>>2];f[Wc+4>>2]=f[Vc+4>>2]}else{f[Tc>>2]=f[Wa>>2];f[Tb+(Bc*48|0)+32>>2]=f[Xa>>2];f[Wa>>2]=Ya;f[Xa>>2]=Qa}f[h>>2]=1124007936;f[Ua>>2]=0;f[Va>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0}EQ(h);qPa(Ub,g);Tc=f[g>>2]|0;if(Tc|0){Vc=f[Oa>>2]|0;if((Vc|0)==(Tc|0))Xc=Tc;else{zc=Vc;do{Vc=zc+-48|0;f[Oa>>2]=Vc;EQ(Vc);zc=f[Oa>>2]|0}while((zc|0)!=(Tc|0));Xc=f[g>>2]|0}cYc(Xc)}}while(0);if((f[yc+(kc*56|0)+16>>2]|0)!=(f[Za>>2]|0)){Cb=377;break b}rc=f[_a>>2]|0;do if(rc|0){xc=rc+12|0;Bb=f[xc>>2]|0;f[xc>>2]=Bb+-1;if((Bb|0)!=1)break;V$(e)}while(0);f[_a>>2]=0;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;if((f[$a>>2]|0)>0){rc=f[Na>>2]|0;kc=0;do{f[rc+(kc<<2)>>2]=0;kc=kc+1|0}while((kc|0)<(f[$a>>2]|0))}kc=f[ab>>2]|0;if((kc|0)!=(bb|0))wL(kc);Fb=Fb+1|0}while(Fb>>>0<hc>>>0)}b[tb>>0]=1}hc=f[l>>2]|0;if(hc|0){Fb=f[Z>>2]|0;if((Fb|0)!=(hc|0))f[Z>>2]=Fb+(~((Fb+-8-hc|0)>>>3)<<3);cYc(hc)}}while(0);EQ(k)}while(0);if(xb|0)UXc(xb)}if(Hc|0)UXc(Hc)}}while(0);tb=f[rb+4>>2]|0;if(!tb){sb=rb+8|0;wb=f[sb>>2]|0;if((f[wb>>2]|0)==(rb|0))Yc=wb;else{wb=sb;do{sb=f[wb>>2]|0;wb=sb+8|0;ub=f[wb>>2]|0}while((f[ub>>2]|0)!=(sb|0));Yc=ub}}else{wb=tb;while(1){ub=f[wb>>2]|0;if(!ub)break;else wb=ub}Yc=wb}if((Yc|0)==(s|0)){Zc=t;break a}else rb=Yc}if((Cb|0)==139){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;rb=$Xc(48)|0;f[e>>2]=rb;f[e+8>>2]=-2147483600;f[e+4>>2]=46;vc=rb;_c=394955;wc=vc+46|0;do{b[vc>>0]=b[_c>>0]|0;vc=vc+1|0;_c=_c+1|0}while((vc|0)<(wc|0));b[rb+46>>0]=0;vM(-215,e,394944,391289,1964)}else if((Cb|0)==141){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Z=$Xc(48)|0;f[e>>2]=Z;f[e+8>>2]=-2147483600;f[e+4>>2]=33;vc=Z;_c=395002;wc=vc+33|0;do{b[vc>>0]=b[_c>>0]|0;vc=vc+1|0;_c=_c+1|0}while((vc|0)<(wc|0));b[Z+33>>0]=0;vM(-215,e,394944,391289,1964)}else if((Cb|0)==148){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;rb=$Xc(32)|0;f[e>>2]=rb;f[e+8>>2]=-2147483616;f[e+4>>2]=26;vc=rb;_c=395036;wc=vc+26|0;do{b[vc>>0]=b[_c>>0]|0;vc=vc+1|0;_c=_c+1|0}while((vc|0)<(wc|0));b[rb+26>>0]=0;vM(-215,e,394944,391289,1985)}else if((Cb|0)==150){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Z=$Xc(48)|0;f[e>>2]=Z;f[e+8>>2]=-2147483600;f[e+4>>2]=34;vc=Z;_c=395063;wc=vc+34|0;do{b[vc>>0]=b[_c>>0]|0;vc=vc+1|0;_c=_c+1|0}while((vc|0)<(wc|0));b[Z+34>>0]=0;vM(-215,e,394944,391289,1985)}else if((Cb|0)==263)kWc(l);else if((Cb|0)==339){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;rb=$Xc(80)|0;f[g>>2]=rb;f[g+8>>2]=-2147483568;f[g+4>>2]=68;vc=rb;_c=395098;wc=vc+68|0;do{b[vc>>0]=b[_c>>0]|0;vc=vc+1|0;_c=_c+1|0}while((vc|0)<(wc|0));b[rb+68>>0]=0;vM(-215,g,394944,391289,2131)}else if((Cb|0)==377){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Z=$Xc(48)|0;f[g>>2]=Z;f[g+8>>2]=-2147483600;f[g+4>>2]=37;vc=Z;_c=395167;wc=vc+37|0;do{b[vc>>0]=b[_c>>0]|0;vc=vc+1|0;_c=_c+1|0}while((vc|0)<(wc|0));b[Z+37>>0]=0;vM(-215,g,394944,391289,2142)}else if((Cb|0)==412){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;rb=$Xc(16)|0;f[e>>2]=rb;f[e+8>>2]=-2147483632;f[e+4>>2]=13;vc=rb;_c=394930;wc=vc+13|0;do{b[vc>>0]=b[_c>>0]|0;vc=vc+1|0;_c=_c+1|0}while((vc|0)<(wc|0));b[rb+13>>0]=0;vM(-215,e,394944,391289,1945)}}else Zc=t;while(0);IPa(j,f[Zc>>2]|0);u=d;return}function GPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!b)return;GPa(a,f[b>>2]|0);GPa(a,f[b+4>>2]|0);a=b+44|0;c=f[a>>2]|0;if(c|0){d=b+48|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-4-i|0)>>>2)<<2);cYc(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[a>>2]|0}cYc(g)}g=b+32|0;a=f[g>>2]|0;if(a|0){j=b+36|0;h=f[j>>2]|0;if((h|0)==(a|0))l=a;else{c=h;while(1){h=c+-12|0;f[j>>2]=h;d=f[h>>2]|0;if(!d)m=h;else{h=c+-8|0;i=f[h>>2]|0;if((i|0)!=(d|0))f[h>>2]=i+(~((i+-4-d|0)>>>2)<<2);cYc(d);m=f[j>>2]|0}if((m|0)==(a|0))break;else c=m}l=f[g>>2]|0}cYc(l)}l=b+20|0;g=f[l>>2]|0;if(g|0){m=b+24|0;c=f[m>>2]|0;if((c|0)==(g|0))n=g;else{a=c;while(1){c=a+-12|0;f[m>>2]=c;j=f[c>>2]|0;if(!j)o=c;else{c=a+-8|0;d=f[c>>2]|0;if((d|0)!=(j|0))f[c>>2]=d+(~((d+-4-j|0)>>>2)<<2);cYc(j);o=f[m>>2]|0}if((o|0)==(g|0))break;else a=o}n=f[l>>2]|0}cYc(n)}cYc(b);return}function HPa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=a+4|0;h=f[b>>2]|0;b=h;do if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){k=(i|0)==(j|0);if(k?(f[e+4>>2]|0)<(f[h+20>>2]|0):0)break;do if((j|0)>=(i|0)){if(k?(f[h+20>>2]|0)<(f[e+4>>2]|0):0)break;f[c>>2]=b;f[d>>2]=b;l=d;return l|0}while(0);k=h+4|0;j=f[k>>2]|0;if(!j){m=h+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(h|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=j;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}do if((o|0)!=(g|0)?(j=f[o+16>>2]|0,(i|0)>=(j|0)):0){if((i|0)==(j|0)?(f[e+4>>2]|0)<(f[o+20>>2]|0):0)break;j=f[g>>2]|0;if(!j){f[c>>2]=g;l=g;return l|0}p=f[e+4>>2]|0;m=a+4|0;q=j;a:while(1){j=f[q+16>>2]|0;do if((i|0)>=(j|0)){r=(i|0)==(j|0);if(r?(p|0)<(f[q+20>>2]|0):0){s=51;break}if((j|0)>=(i|0)){if(!r){s=58;break a}if((f[q+20>>2]|0)>=(p|0)){s=58;break a}}t=q+4|0;r=f[t>>2]|0;if(!r){s=57;break a}else{u=t;v=r}}else s=51;while(0);if((s|0)==51){s=0;j=f[q>>2]|0;if(!j){s=52;break}else{u=q;v=j}}m=u;q=v}if((s|0)==52){f[c>>2]=q;l=q;return l|0}else if((s|0)==57){f[c>>2]=q;l=t;return l|0}else if((s|0)==58){f[c>>2]=q;l=m;return l|0}}while(0);if(!(f[h+4>>2]|0)){f[c>>2]=b;l=k;return l|0}else{f[c>>2]=o;l=o;return l|0}}while(0);o=f[h>>2]|0;do if((h|0)!=(f[a>>2]|0)){if(!o){t=h;while(1){v=f[t+8>>2]|0;if((f[v>>2]|0)==(t|0))t=v;else{w=v;break}}}else{t=o;while(1){k=f[t+4>>2]|0;if(!k){w=t;break}else t=k}}t=w;k=f[w+16>>2]|0;v=f[e>>2]|0;if((k|0)>=(v|0)){if((k|0)==(v|0)?(f[w+20>>2]|0)<(f[e+4>>2]|0):0){x=t;break}k=f[g>>2]|0;if(!k){f[c>>2]=g;l=g;return l|0}u=f[e+4>>2]|0;d=a+4|0;i=k;b:while(1){k=f[i+16>>2]|0;do if((v|0)>=(k|0)){n=(v|0)==(k|0);if(n?(u|0)<(f[i+20>>2]|0):0){s=21;break}if((k|0)>=(v|0)){if(!n){s=28;break b}if((f[i+20>>2]|0)>=(u|0)){s=28;break b}}y=i+4|0;n=f[y>>2]|0;if(!n){s=27;break b}else{z=y;A=n}}else s=21;while(0);if((s|0)==21){s=0;k=f[i>>2]|0;if(!k){s=22;break}else{z=i;A=k}}d=z;i=A}if((s|0)==22){f[c>>2]=i;l=i;return l|0}else if((s|0)==27){f[c>>2]=i;l=y;return l|0}else if((s|0)==28){f[c>>2]=i;l=d;return l|0}}else x=t}else x=b;while(0);if(!o){f[c>>2]=h;l=h;return l|0}else{h=x;f[c>>2]=h;l=h+4|0;return l|0}return 0}function IPa(a,b){a=a|0;b=b|0;if(!b)return;else{IPa(a,f[b>>2]|0);IPa(a,f[b+4>>2]|0);cYc(b);return}}function JPa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/56|0;e=a+8|0;g=f[a>>2]|0;h=g;if(d>>>0>(((f[e>>2]|0)-g|0)/56|0)>>>0){oNa(a);if(d>>>0>76695844)kWc(a);i=((f[e>>2]|0)-(f[a>>2]|0)|0)/56|0;j=i<<1;k=i>>>0<38347922?(j>>>0<d>>>0?d:j):76695844;if(k>>>0>76695844)kWc(a);j=$Xc(k*56|0)|0;i=a+4|0;f[i>>2]=j;f[a>>2]=j;f[e>>2]=j+(k*56|0);if((b|0)==(c|0))return;k=b;e=j;do{f[e>>2]=f[k>>2];j=e+4|0;l=k+4|0;f[j>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[e+20>>2]=f[k+20>>2];f[e+24>>2]=f[k+24>>2];f[e+28>>2]=f[k+28>>2];f[e+32>>2]=f[k+32>>2];n=f[k+36>>2]|0;f[e+36>>2]=n;f[e+40>>2]=m;m=e+48|0;o=e+44|0;f[o>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[k+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2]}else{f[j>>2]=0;U$(e,k)}k=k+56|0;e=(f[i>>2]|0)+56|0;f[i>>2]=e}while((k|0)!=(c|0));return}k=a+4|0;a=((f[k>>2]|0)-g|0)/56|0;g=d>>>0>a>>>0;d=b+(a*56|0)|0;a=g?d:c;if((a|0)==(b|0))p=h;else{e=h;h=b;while(1){if((e|0)!=(h|0)){b=h+36|0;i=f[b>>2]|0;if(i|0){j=i+12|0;f[j>>2]=(f[j>>2]|0)+1}j=e+36|0;i=f[j>>2]|0;if(i|0?(l=i+12|0,i=f[l>>2]|0,f[l>>2]=i+-1,(i|0)==1):0)V$(e);f[j>>2]=0;i=e+16|0;l=e+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[l>>2]|0)>0){m=f[e+40>>2]|0;o=0;do{f[m+(o<<2)>>2]=0;o=o+1|0;q=f[l>>2]|0}while((o|0)<(q|0));f[e>>2]=f[h>>2];if((q|0)<3)r=14;else r=16}else{f[e>>2]=f[h>>2];r=14}if((r|0)==14){r=0;o=f[h+4>>2]|0;if((o|0)<3){f[l>>2]=o;f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];o=f[h+44>>2]|0;m=f[e+44>>2]|0;f[m>>2]=f[o>>2];f[m+4>>2]=f[o+4>>2]}else r=16}if((r|0)==16){r=0;U$(e,h)}f[i>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];f[j>>2]=f[b>>2]}h=h+56|0;o=e+56|0;if((h|0)==(a|0)){p=o;break}else e=o}}if(g){if((a|0)==(c|0))return;a=d;d=f[k>>2]|0;do{f[d>>2]=f[a>>2];g=d+4|0;e=a+4|0;f[g>>2]=f[e>>2];h=d+8|0;f[h>>2]=f[a+8>>2];f[d+12>>2]=f[a+12>>2];f[d+16>>2]=f[a+16>>2];f[d+20>>2]=f[a+20>>2];f[d+24>>2]=f[a+24>>2];f[d+28>>2]=f[a+28>>2];f[d+32>>2]=f[a+32>>2];r=f[a+36>>2]|0;f[d+36>>2]=r;f[d+40>>2]=h;h=d+48|0;q=d+44|0;f[q>>2]=h;f[h>>2]=0;f[d+52>>2]=0;if(r|0){h=r+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[e>>2]|0)<3){e=f[a+44>>2]|0;h=f[q>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2]}else{f[g>>2]=0;U$(d,a)}a=a+56|0;d=(f[k>>2]|0)+56|0;f[k>>2]=d}while((a|0)!=(c|0));return}c=f[k>>2]|0;if((c|0)==(p|0))return;else s=c;do{c=s+-56|0;f[k>>2]=c;a=s+-20|0;d=f[a>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)V$(c);f[a>>2]=0;a=s+-40|0;c=s+-52|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){a=f[s+-16>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[s+-12>>2]|0;if((c|0)!=(s+-8|0))wL(c);s=f[k>>2]|0}while((s|0)!=(p|0));return}function KPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;f[e>>2]=f[b>>2];l=f[b+4>>2]|0;f[m+(g<<3)+4>>2]=l;if(!l){n=j;o=i}else{TXc(l);n=f[c>>2]|0;o=f[a>>2]|0}l=e+8|0;if((n|0)==(o|0)){p=h;q=o;r=n}else{i=n;n=h;h=e;do{e=i;i=i+-8|0;f[h+-8>>2]=f[i>>2];j=e+-4|0;f[h+-4>>2]=f[j>>2];f[i>>2]=0;f[j>>2]=0;h=n+-8|0;n=h}while((i|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=l;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=f[d+-4>>2]|0;d=d+-8|0;if(r|0)UXc(r)}while((d|0)!=(k|0))}if(!q)return;cYc(q);return}function LPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e;j=c+80|0;if((f[j>>2]|0)==3?(f[c+84>>2]|0)==0:0){f[a>>2]=0;f[a+4>>2]=0;u=e;return}k=d+4|0;l=f[k>>2]|0;f[g>>2]=0;m=g+4|0;f[m>>2]=0;f[g+8>>2]=0;if(l|0){if(l>>>0>1073741823)kWc(g);n=l<<2;o=$Xc(n)|0;f[g>>2]=o;p=o+(l<<2)|0;f[g+8>>2]=p;g1c(o|0,0,n|0)|0;f[m>>2]=p;p=f[d+40>>2]|0;n=0;do{f[o+(n<<2)>>2]=f[p+(n<<2)>>2];n=n+1|0}while((n|0)<(f[k>>2]|0))}k=f[d+16>>2]|0;n=c+104|0;p=c+108|0;o=f[p>>2]|0;a:do if(o){l=k;q=p;r=o;b:while(1){s=r;while(1){if((f[s+16>>2]|0)>>>0>=l>>>0)break;t=f[s+4>>2]|0;if(!t){v=q;break b}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)!=(p|0)?l>>>0>=(f[v+16>>2]|0)>>>0:0){q=c+108|0;r=o;while(1){t=f[r+16>>2]|0;if(l>>>0<t>>>0){w=f[r>>2]|0;if(!w){x=r;break}else{y=r;z=w}}else{if(t>>>0>=l>>>0){x=q;break}t=r+4|0;w=f[t>>2]|0;if(!w){x=t;break}else{y=t;z=w}}q=y;r=z}q=f[x>>2]|0;if(!q){l=$Xc(28)|0;f[l+16>>2]=k;f[l+20>>2]=0;f[l+24>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=r;f[x>>2]=l;w=f[f[n>>2]>>2]|0;if(!w)A=l;else{f[n>>2]=w;A=f[x>>2]|0}UQ(f[c+108>>2]|0,A);w=c+112|0;f[w>>2]=(f[w>>2]|0)+1;B=l}else B=q;f[h>>2]=f[B+20>>2];q=h+4|0;l=f[B+24>>2]|0;f[q>>2]=l;if(l|0)TXc(l);c:do switch(f[j>>2]|0){case 3:{if(((f[c+84>>2]|0)+-1|0)>>>0>=2){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(48)|0;f[i>>2]=w;f[i+8>>2]=-2147483600;f[i+4>>2]=38;C=w;D=395284;E=C+38|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[w+38>>0]=0;vM(-215,i,395323,391289,980)}s=$Xc(68)|0;MPa(s,h,d);f[a>>2]=s;t=$Xc(16)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=82568;f[t+12>>2]=s;f[a+4>>2]=t;t=f[q>>2]|0;if(t|0)UXc(t);break a;break}case 1:{if(zQa()|0){F=f[q>>2]|0;break c}else{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;t=$Xc(16)|0;f[i>>2]=t;f[i+8>>2]=-2147483632;f[i+4>>2]=12;C=t;D=394807;E=C+12|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[t+12>>0]=0;vM(-215,i,395323,391289,985)}break}case 2:{NPa(a,2,f[c+84>>2]|0,d);w=f[q>>2]|0;if(w|0)UXc(w);break a;break}case 4:{F=l;break}default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;w=$Xc(32)|0;f[i>>2]=w;f[i+8>>2]=-2147483616;f[i+4>>2]=26;C=w;D=393683;E=C+26|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[w+26>>0]=0;vM(-213,i,395323,391289,1001)}}while(0);if(F|0)UXc(F);G=41}else G=41}else G=41;while(0);if((G|0)==41){NPa(h,f[j>>2]|0,f[c+84>>2]|0,d);d=f[p>>2]|0;do if(d){j=k;F=c+108|0;i=d;while(1){D=f[i+16>>2]|0;if(j>>>0<D>>>0){C=f[i>>2]|0;if(!C){G=46;break}else{H=i;I=C}}else{if(D>>>0>=j>>>0){G=50;break}J=i+4|0;D=f[J>>2]|0;if(!D){G=49;break}else{H=J;I=D}}F=H;i=I}if((G|0)==46){K=i;L=i;break}else if((G|0)==49){K=i;L=J;break}else if((G|0)==50){K=i;L=F;break}}else{K=p;L=p}while(0);p=f[L>>2]|0;if(!p){G=$Xc(28)|0;f[G+16>>2]=k;f[G+20>>2]=0;f[G+24>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=K;f[L>>2]=G;K=f[f[n>>2]>>2]|0;if(!K)M=G;else{f[n>>2]=K;M=f[L>>2]|0}UQ(f[c+108>>2]|0,M);M=c+112|0;f[M>>2]=(f[M>>2]|0)+1;N=G}else N=p;p=f[h>>2]|0;G=h+4|0;M=f[G>>2]|0;if(M|0)TXc(M);f[N+20>>2]=p;p=N+24|0;N=f[p>>2]|0;f[p>>2]=M;if(N|0)UXc(N);f[a>>2]=f[h>>2];f[a+4>>2]=f[G>>2]}G=f[g>>2]|0;if(G|0){g=f[m>>2]|0;if((g|0)!=(G|0))f[m>>2]=g+(~((g+-4-G|0)>>>2)<<2);cYc(G)}u=e;return}function MPa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+176|0;g=e+160|0;h=e+152|0;i=e+144|0;j=e+96|0;k=e+48|0;l=e;f[a+4>>2]=3;f[a+8>>2]=1;f[a>>2]=82596;m=a+12|0;f[m>>2]=1124007936;n=a+16|0;o=a+20|0;p=a+32|0;q=a+36|0;r=a+40|0;s=a+44|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[s>>2]=o;t=a+52|0;f[a+48>>2]=t;f[a+56>>2]=0;f[t>>2]=0;v=f[c>>2]|0;if(v|0?(w=kZc(v,15176,15232,0)|0,w|0):0){v=f[c+4>>2]|0;if(v|0)TXc(v);if(w|0){c=a+60|0;f[c>>2]=d;f[i>>2]=1;d=i+4|0;x=w+12|0;y=f[w+16>>2]|0;if((y|0)<3)z=Y(f[w+24>>2]|0,f[w+20>>2]|0)|0;else{A=f[w+44>>2]|0;w=0;B=1;while(1){C=Y(f[A+(w<<2)>>2]|0,B)|0;w=w+1|0;if((w|0)==(y|0)){z=C;break}else B=C}}f[d>>2]=z;OQ(l,x,1,2,i);i=f[c>>2]|0;x=f[i+4>>2]|0;if((x|0)<3)D=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{z=f[i+40>>2]|0;i=0;d=1;while(1){B=Y(f[z+(i<<2)>>2]|0,d)|0;i=i+1|0;if((i|0)==(x|0)){D=B;break}else d=B}}f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=D;GQ(k,l,g,h);h=f[c>>2]|0;OQ(j,k,1,f[h+4>>2]|0,f[h+40>>2]|0);if((m|0)!=(j|0)){h=f[q>>2]|0;if(h|0?(c=h+8|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)FQ(m);if((f[n>>2]|0)>0){h=f[s>>2]|0;c=0;do{f[h+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[n>>2]|0))}f[m>>2]=f[j>>2];m=j+4|0;c=f[m>>2]|0;f[n>>2]=c;n=j+8|0;f[o>>2]=f[n>>2];f[a+24>>2]=f[j+12>>2];f[a+28>>2]=f[j+16>>2];f[p>>2]=f[j+20>>2];p=j+24|0;f[q>>2]=f[p>>2];q=j+28|0;f[r>>2]=f[q>>2];r=a+48|0;h=f[r>>2]|0;if((h|0)==(t|0))E=c;else{wL(h);f[r>>2]=t;f[s>>2]=o;E=f[m>>2]|0}o=j+36|0;if((E|0)<3){E=f[o>>2]|0;f[t>>2]=f[E>>2];f[a+56>>2]=f[E+4>>2]}else{f[r>>2]=f[o>>2];r=j+32|0;f[a+44>>2]=f[r>>2];f[o>>2]=j+40;f[r>>2]=n}f[j>>2]=1124007936;f[p>>2]=0;f[q>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0}EQ(j);EQ(k);EQ(l);b[a+64>>0]=0;if(!v){u=e;return}UXc(v);u=e;return}};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;e=$Xc(16)|0;f[g>>2]=e;f[g+8>>2]=-2147483632;f[g+4>>2]=13;v=e;a=395574;l=v+13|0;do{b[v>>0]=b[a>>0]|0;v=v+1|0;a=a+1|0}while((v|0)<(l|0));b[e+13>>0]=0;vM(-215,g,395588,391289,260)}function NPa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;switch(c|0){case 3:{if(!d){f[a>>2]=0;f[a+4>>2]=0;u=g;return}if((d+-1|0)>>>0>=2){d=$Xc(32)|0;f[h>>2]=d;f[h+8>>2]=-2147483616;f[h+4>>2]=25;i=d;j=395527;k=i+25|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[d+25>>0]=0;vM(-213,h,395553,391289,881)}SPa(a,e);u=g;return}case 1:{if(!(zQa()|0)){e=$Xc(16)|0;f[h>>2]=e;f[h+8>>2]=-2147483632;f[h+4>>2]=12;i=e;j=394807;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[e+12>>0]=0;vM(-215,h,395553,391289,885)}break}case 2:{if(!(orb()|0)){e=$Xc(16)|0;f[h>>2]=e;f[h+8>>2]=-2147483632;f[h+4>>2]=15;i=e;j=427943;k=i+15|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[e+15>>0]=0;vM(-215,h,395553,391289,892)}break}case 4:{if(!(nrb()|0)){e=$Xc(16)|0;f[h>>2]=e;f[h+8>>2]=-2147483632;f[h+4>>2]=12;i=e;j=395561;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[e+12>>0]=0;vM(-215,h,395553,391289,899)}break}default:{e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=26;i=e;j=393683;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[e+26>>0]=0;vM(-213,h,395553,391289,905)}}f[a>>2]=0;f[a+4>>2]=0;u=g;return}function OPa(a){a=a|0;NXc(a);cYc(a);return}function PPa(a){a=a|0;var b=0;b=f[a+12>>2]|0;if(!b)return;Yi[f[(f[b>>2]|0)+4>>2]&4095](b);return}function QPa(a,b){a=a|0;b=b|0;return ((f[b+4>>2]|0)==395328?a+12|0:0)|0}function RPa(a){a=a|0;cYc(a);return}function SPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=$Xc(68)|0;f[g+4>>2]=3;f[g+8>>2]=1;f[g>>2]=82596;h=g+12|0;f[h>>2]=1124007936;i=g+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[g+44>>2]=g+20;i=g+52|0;f[g+48>>2]=i;f[g+56>>2]=0;f[i>>2]=0;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=h;jR(c,e);f[g+60>>2]=c;b[g+64>>0]=0;f[a>>2]=g;c=$Xc(16)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=82568;f[c+12>>2]=g;f[a+4>>2]=c;u=d;return}function TPa(a){a=a|0;f[a>>2]=82596;EQ(a+12|0);return}function UPa(a){a=a|0;f[a>>2]=82596;EQ(a+12|0);cYc(a);return}function VPa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;d=f[a+60>>2]|0;e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=33619968;f[c+4>>2]=d;LQ(a+12|0,c);u=b;return}function WPa(a){a=a|0;b[a+64>>0]=1;return}function XPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){g1c(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)kWc(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=d;g=n+(m<<3)|0;g1c(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=j;p=i;q=h}else{i=h;h=j;j=d;do{d=i;i=i+-8|0;f[j+-8>>2]=f[i>>2];b=d+-4|0;f[j+-4>>2]=f[b>>2];f[i>>2]=0;f[b>>2]=0;j=h+-8|0;h=j}while((i|0)!=(k|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=g;g=p;if((q|0)!=(g|0)){c=q;do{q=f[c+-4>>2]|0;c=c+-8|0;if(q|0)UXc(q)}while((c|0)!=(g|0))}if(!p)return;cYc(p);return}function YPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/12|0;if(!e)return;if(g>>>0>357913941)kWc(a);h=$Xc(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*12|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{eKa(g,d);d=d+12|0;g=(f[c>>2]|0)+12|0;f[c>>2]=g}while((d|0)!=(b|0));return}function ZPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;do if(h|0){i=f[c>>2]|0;j=f[c+4>>2]|0;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)>=(i|0)){if((n|0)!=(i|0))break;if((f[m+20>>2]|0)>=(j|0))break}n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)?(k=f[o+16>>2]|0,(i|0)>=(k|0)):0){if((i|0)==(k|0)?(j|0)<(f[o+20>>2]|0):0)break;k=o+24|0;l=f[k>>2]|0;n=f[k+4>>2]|0;k=a+4|0;p=f[k>>2]|0;if(p|0){q=k;r=p;b:while(1){p=r;while(1){s=f[p+16>>2]|0;if((s|0)>=(l|0)){if((s|0)!=(l|0))break;if((f[p+20>>2]|0)>=(n|0))break}s=f[p+4>>2]|0;if(!s){t=q;break b}else p=s}r=f[p>>2]|0;if(!r){t=p;break}else q=p}if((t|0)!=(k|0)?(q=f[t+16>>2]|0,(l|0)>=(q|0)):0){if((l|0)!=(q|0)){v=t+24|0;w=f[v>>2]|0;u=d;return w|0}if((n|0)>=(f[t+20>>2]|0)){v=t+24|0;w=f[v>>2]|0;u=d;return w|0}}}q=$Xc(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=25;x=q;y=395914;z=x+25|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[q+25>>0]=0;vM(-215,e,396084,391289,677)}}while(0);w=$Xc(32)|0;f[e>>2]=w;f[e+8>>2]=-2147483616;f[e+4>>2]=23;x=w;y=395873;z=x+23|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[w+23>>0]=0;vM(-215,e,396084,391289,673);return 0}function _Pa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(((h|0)/12|0)*12|0)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=(d|0)/12|0;l=i;i=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;p=f[o>>2]|0;q=p;if((k|0)<=((n-q|0)/12|0|0)){r=q-b|0;s=(r|0)/12|0;if((k|0)>(s|0)){t=l+(s*12|0)|0;s=t;if((t|0)==(i|0))u=p;else{v=p;w=t;while(1){eKa(v,w);w=w+12|0;t=(f[o>>2]|0)+12|0;f[o>>2]=t;if((w|0)==(i|0)){u=t;break}else v=t}}if((r|0)>0){x=s;y=u}else{m=b;return m|0}}else{x=j;y=p}j=y-(b+(k*12|0))|0;u=b+(((j|0)/12|0)*12|0)|0;if(u>>>0<p>>>0){s=u;r=y;do{f[r>>2]=0;v=r+4|0;f[v>>2]=0;f[r+8>>2]=0;f[r>>2]=f[s>>2];w=s+4|0;f[v>>2]=f[w>>2];v=s+8|0;f[r+8>>2]=f[v>>2];f[v>>2]=0;f[w>>2]=0;f[s>>2]=0;s=s+12|0;r=(f[o>>2]|0)+12|0;f[o>>2]=r}while(s>>>0<p>>>0)}if(j|0){j=u;u=y;do{y=j;j=j+-12|0;p=u;u=u+-12|0;s=f[u>>2]|0;r=p+-8|0;if(!s)z=p+-4|0;else{w=f[r>>2]|0;if((w|0)!=(s|0))f[r>>2]=w+(~((w+-4-s|0)>>>2)<<2);cYc(s);s=p+-4|0;f[s>>2]=0;f[r>>2]=0;f[u>>2]=0;z=s}f[u>>2]=f[j>>2];s=y+-8|0;f[r>>2]=f[s>>2];r=y+-4|0;f[z>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[j>>2]=0}while((j|0)!=(b|0))}j=f[c>>2]|0;c=x;if((j|0)==(c|0)){m=b;return m|0}else{A=b;B=j}while(1){if((A|0)!=(B|0))eEa(A,f[B>>2]|0,f[B+4>>2]|0);B=B+12|0;if((B|0)==(c|0)){m=b;break}else A=A+12|0}return m|0}A=((q-g|0)/12|0)+k|0;if(A>>>0>357913941)kWc(a);k=(n-g|0)/12|0;g=k<<1;n=k>>>0<178956970?(g>>>0<A>>>0?A:g):357913941;g=(h|0)/12|0;do if(n)if(n>>>0>357913941){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{C=$Xc(n*12|0)|0;break}else C=0;while(0);h=C+(g*12|0)|0;g=h;A=C+(n*12|0)|0;if((l|0)==(i|0)){D=g;E=e}else{e=g;n=h;C=l;do{eKa(n,C);n=e+12|0;e=n;C=C+12|0}while((C|0)!=(i|0));D=e;E=f[a>>2]|0}if((E|0)==(b|0)){F=h;G=g}else{e=b;i=g;g=h;while(1){C=g+-12|0;n=e;e=e+-12|0;f[C>>2]=0;l=g+-8|0;f[l>>2]=0;f[g+-4>>2]=0;f[C>>2]=f[e>>2];C=n+-8|0;f[l>>2]=f[C>>2];l=n+-4|0;f[g+-4>>2]=f[l>>2];f[l>>2]=0;f[C>>2]=0;f[e>>2]=0;C=i+-12|0;l=C;if((e|0)==(E|0)){F=C;G=l;break}else{i=l;g=C}}}g=f[o>>2]|0;if((g|0)==(b|0)){H=D;I=F;J=b}else{F=b;b=D;i=D;do{f[i>>2]=0;D=i+4|0;f[D>>2]=0;f[i+8>>2]=0;f[i>>2]=f[F>>2];E=F+4|0;f[D>>2]=f[E>>2];D=F+8|0;f[i+8>>2]=f[D>>2];f[D>>2]=0;f[E>>2]=0;f[F>>2]=0;F=F+12|0;i=b+12|0;b=i}while((F|0)!=(g|0));H=b;I=G;J=f[o>>2]|0}G=f[a>>2]|0;f[a>>2]=I;f[o>>2]=H;f[d>>2]=A;if((J|0)!=(G|0)){A=J;do{J=A;A=A+-12|0;d=f[A>>2]|0;if(d|0){H=J+-8|0;J=f[H>>2]|0;if((J|0)!=(d|0))f[H>>2]=J+(~((J+-4-d|0)>>>2)<<2);cYc(d)}}while((A|0)!=(G|0))}if(!G){m=h;return m|0}cYc(G);m=h;return m|0}function $Pa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function aQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+16|0;g=e;h=a+12|0;i=a+16|0;j=f[i>>2]|0;if(!j){k=$Xc(48)|0;f[g>>2]=k;l=g+8|0;f[l>>2]=-2147483600;m=g+4|0;f[m>>2]=37;n=k;o=396046;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+37|0;b[q>>0]=0;vM(-215,g,396040,391289,685)}r=f[d>>2]|0;s=d+4|0;t=f[s>>2]|0;v=i;w=j;a:while(1){x=w;while(1){y=f[x+16>>2]|0;if((y|0)>=(r|0)){if((y|0)!=(r|0))break;if((f[x+20>>2]|0)>=(t|0))break}y=f[x+4>>2]|0;if(!y){z=v;break a}else x=y}w=f[x>>2]|0;if(!w){z=x;break}else v=x}if((z|0)!=(i|0)?(v=f[z+16>>2]|0,(r|0)>=(v|0)):0){if((r|0)!=(v|0)){A=$Xc(48)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483600;C=g+4|0;f[C>>2]=37;n=A;o=396002;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));D=A+37|0;b[D>>0]=0;vM(-215,g,396040,391289,684)}if((t|0)>=(f[z+20>>2]|0)){A=$Xc(48)|0;f[g>>2]=A;B=g+8|0;f[B>>2]=-2147483600;C=g+4|0;f[C>>2]=37;n=A;o=396002;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));D=A+37|0;b[D>>0]=0;vM(-215,g,396040,391289,684)}}D=f[c>>2]|0;A=f[c+4>>2]|0;C=i;B=j;b:while(1){j=B;while(1){z=f[j+16>>2]|0;if((z|0)>=(D|0)){if((z|0)!=(D|0))break;if((f[j+20>>2]|0)>=(A|0))break}z=f[j+4>>2]|0;if(!z){E=C;break b}else j=z}B=f[j>>2]|0;if(!B){E=j;break}else C=j}if((E|0)==(i|0)){k=$Xc(48)|0;f[g>>2]=k;l=g+8|0;f[l>>2]=-2147483600;m=g+4|0;f[m>>2]=37;n=k;o=396046;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+37|0;b[q>>0]=0;vM(-215,g,396040,391289,685)}i=f[E+16>>2]|0;if((D|0)<(i|0)){k=$Xc(48)|0;f[g>>2]=k;l=g+8|0;f[l>>2]=-2147483600;m=g+4|0;f[m>>2]=37;n=k;o=396046;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+37|0;b[q>>0]=0;vM(-215,g,396040,391289,685)}if((D|0)==(i|0)?(A|0)<(f[E+20>>2]|0):0){k=$Xc(48)|0;f[g>>2]=k;l=g+8|0;f[l>>2]=-2147483600;m=g+4|0;f[m>>2]=37;n=k;o=396046;p=n+37|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));q=k+37|0;b[q>>0]=0;vM(-215,g,396040,391289,685)}g=fQa(h,c)|0;c=f[g>>2]|0;q=f[g+4>>2]|0;g=fQa(h,d)|0;f[g>>2]=c;f[g+4>>2]=q;g=a+4|0;h=f[g>>2]|0;if(!h){u=e;return}else{F=g;G=h}c:while(1){k=G;while(1){o=f[k+16>>2]|0;if((o|0)>=(c|0)){if((o|0)!=(c|0))break;if((f[k+20>>2]|0)>=(q|0))break}o=f[k+4>>2]|0;if(!o){H=F;break c}else k=o}G=f[k>>2]|0;if(!G){H=k;break}else F=k}if((H|0)==(g|0)){u=e;return}F=f[H+16>>2]|0;if((c|0)<(F|0)){u=e;return}if((c|0)==(F|0)?(q|0)<(f[H+20>>2]|0):0){u=e;return}H=f[d>>2]|0;d=f[s>>2]|0;s=g;F=h;d:while(1){G=F;while(1){j=f[G+16>>2]|0;if((j|0)>=(H|0)){if((j|0)!=(H|0))break;if((f[G+20>>2]|0)>=(d|0))break}j=f[G+4>>2]|0;if(!j){I=s;break d}else G=j}F=f[G>>2]|0;if(!F){I=G;break}else s=G}do if((I|0)!=(g|0)?(s=f[I+16>>2]|0,(H|0)>=(s|0)):0){if((H|0)==(s|0)?(d|0)<(f[I+20>>2]|0):0)break;s=f[I+24>>2]|0;F=a+4|0;k=h;e:while(1){j=f[k+16>>2]|0;do if((c|0)>=(j|0)){o=(c|0)==(j|0);if(o?(q|0)<(f[k+20>>2]|0):0){J=53;break}if((j|0)>=(c|0)){if(!o){K=F;break e}if((f[k+20>>2]|0)>=(q|0)){K=F;break e}}o=k+4|0;n=f[o>>2]|0;if(!n){K=o;break e}else{L=o;M=n}}else J=53;while(0);if((J|0)==53){J=0;j=f[k>>2]|0;if(!j){K=k;break}else{L=k;M=j}}F=L;k=M}F=f[K>>2]|0;if(!F){G=$Xc(28)|0;j=G+16|0;f[j>>2]=c;f[j+4>>2]=q;f[G+24>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=k;f[K>>2]=G;j=f[f[a>>2]>>2]|0;if(!j)N=G;else{f[a>>2]=j;N=f[K>>2]|0}UQ(f[a+4>>2]|0,N);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;O=G}else O=F;F=O+24|0;f[F>>2]=(f[F>>2]|0)+s;F=f[I+4>>2]|0;if(!F){G=I+8|0;j=f[G>>2]|0;if((f[j>>2]|0)==(I|0))P=j;else{j=G;do{G=f[j>>2]|0;j=G+8|0;n=f[j>>2]|0}while((f[n>>2]|0)!=(G|0));P=n}}else{j=F;while(1){s=f[j>>2]|0;if(!s)break;else j=s}P=j}if((f[a>>2]|0)==(I|0))f[a>>2]=P;F=a+8|0;f[F>>2]=(f[F>>2]|0)+-1;XIa(f[a+4>>2]|0,I);cYc(I);u=e;return}while(0);I=a+4|0;P=h;f:while(1){h=f[P+16>>2]|0;do if((c|0)>=(h|0)){O=(c|0)==(h|0);if(O?(q|0)<(f[P+20>>2]|0):0){J=75;break}if((h|0)>=(c|0)){if(!O){Q=I;break f}if((f[P+20>>2]|0)>=(q|0)){Q=I;break f}}O=P+4|0;N=f[O>>2]|0;if(!N){Q=O;break f}else{R=O;S=N}}else J=75;while(0);if((J|0)==75){J=0;h=f[P>>2]|0;if(!h){Q=P;break}else{R=P;S=h}}I=R;P=S}S=f[Q>>2]|0;if(!S){R=$Xc(28)|0;I=R+16|0;f[I>>2]=c;f[I+4>>2]=q;f[R+24>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=P;f[Q>>2]=R;P=f[f[a>>2]>>2]|0;if(!P)T=R;else{f[a>>2]=P;T=f[Q>>2]|0}UQ(f[a+4>>2]|0,T);T=a+8|0;f[T>>2]=(f[T>>2]|0)+1;U=R}else U=S;S=U+24|0;f[S>>2]=(f[S>>2]|0)+1;u=e;return}function bQa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;h=u;u=u+256|0;i=h+240|0;j=h+232|0;k=h+176|0;l=h;m=h+120|0;n=h+64|0;o=h+8|0;if(!(b[1163510]|0)){f[k>>2]=1124007936;p=k+4|0;q=k+8|0;r=k+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;v=k+48|0;w=k+44|0;f[w>>2]=v;f[v>>2]=0;f[k+52>>2]=0;f[l>>2]=-1;f[l+4>>2]=-1;x=f[c+4>>2]|0;y=f[c>>2]|0;z=x-y|0;A=z>>2;B=y;if((B|0)!=(x|0)){if((z|0)<=-4){x=$Xc(80)|0;f[i>>2]=x;f[i+8>>2]=-2147483568;f[i+4>>2]=70;s=x;y=454543;t=s+70|0;do{b[s>>0]=b[y>>0]|0;s=s+1|0;y=y+1|0}while((s|0)<(t|0));b[x+70>>0]=0;vM(-215,i,454614,454620,161)}if((z|0)>0){z=0;x=1;while(1){y=Y(f[B+(z<<2)>>2]|0,x)|0;z=z+1|0;if((z|0)>=(A|0)){C=y;break}else x=y}}else C=1}else C=0;x=f[a+24>>2]|0;A=a+28|0;if((x|0)!=(A|0)){z=a+4|0;B=k+36|0;y=k+16|0;D=k+12|0;E=k+20|0;F=k+24|0;G=k+28|0;H=k+32|0;I=2147483647;J=x;x=0;K=0;L=0;while(1){M=J+16|0;N=f[z>>2]|0;do if(N){O=f[M>>2]|0;P=f[J+20>>2]|0;Q=z;R=N;a:while(1){S=R;while(1){T=f[S+16>>2]|0;if((T|0)>=(O|0)){if((T|0)!=(O|0))break;if((f[S+20>>2]|0)>=(P|0))break}T=f[S+4>>2]|0;if(!T){U=Q;break a}else S=T}R=f[S>>2]|0;if(!R){U=S;break}else Q=S}if((U|0)!=(z|0)?(Q=f[U+16>>2]|0,(O|0)>=(Q|0)):0){if((O|0)==(Q|0)?(P|0)<(f[U+20>>2]|0):0){V=I;W=K;X=x;Z=L;break}if(!(f[U+24>>2]|0)){Q=J+24|0;R=J+28|0;T=f[R>>2]|0;_=(T|0)<3;if(_)$=Y(f[J+36>>2]|0,f[J+32>>2]|0)|0;else{aa=f[J+64>>2]|0;ba=0;ca=1;while(1){da=Y(f[aa+(ba<<2)>>2]|0,ca)|0;ba=ba+1|0;if((ba|0)==(T|0)){$=da;break}else ca=da}}if($>>>0>=C>>>0){if(_)ea=Y(f[J+36>>2]|0,f[J+32>>2]|0)|0;else{ca=f[J+64>>2]|0;ba=0;aa=1;while(1){P=Y(f[ca+(ba<<2)>>2]|0,aa)|0;ba=ba+1|0;if((ba|0)==(T|0)){ea=P;break}else aa=P}}if(ea>>>0<I>>>0){aa=M;ba=f[aa+4>>2]|0;ca=l;f[ca>>2]=f[aa>>2];f[ca+4>>2]=ba;if((k|0)==(Q|0)){fa=T;ga=x;ha=K;ia=L}else{ba=J+60|0;ca=f[ba>>2]|0;if(!ca)ja=L;else{aa=ca+12|0;f[aa>>2]=(f[aa>>2]|0)+1;ja=f[B>>2]|0}do if(ja|0){aa=ja+12|0;ca=f[aa>>2]|0;f[aa>>2]=ca+-1;if((ca|0)!=1)break;V$(k)}while(0);f[B>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[p>>2]|0)>0){T=f[r>>2]|0;ca=0;do{f[T+(ca<<2)>>2]=0;ca=ca+1|0;ka=f[p>>2]|0}while((ca|0)<(ka|0));f[k>>2]=f[Q>>2];if((ka|0)<3)la=44;else la=46}else{f[k>>2]=f[Q>>2];la=44}do if((la|0)==44){la=0;ca=f[R>>2]|0;if((ca|0)>=3){la=46;break}f[p>>2]=ca;f[q>>2]=f[J+32>>2];f[D>>2]=f[J+36>>2];ca=f[J+68>>2]|0;T=f[w>>2]|0;f[T>>2]=f[ca>>2];f[T+4>>2]=f[ca+4>>2]}while(0);if((la|0)==46){la=0;U$(k,Q)}ca=f[J+40>>2]|0;f[y>>2]=ca;f[E>>2]=f[J+44>>2];f[F>>2]=f[J+48>>2];f[G>>2]=f[J+52>>2];f[H>>2]=f[J+56>>2];T=f[ba>>2]|0;f[B>>2]=T;aa=T;fa=f[R>>2]|0;ga=aa;ha=ca;ia=aa}if((fa|0)<3){V=Y(f[J+36>>2]|0,f[J+32>>2]|0)|0;W=ha;X=ga;Z=ia;break}aa=f[J+64>>2]|0;ca=0;T=1;while(1){_=Y(f[aa+(ca<<2)>>2]|0,T)|0;ca=ca+1|0;if((ca|0)==(fa|0)){V=_;W=ha;X=ga;Z=ia;break}else T=_}}else{V=I;W=K;X=x;Z=L}}else{V=I;W=K;X=x;Z=L}}else{V=I;W=K;X=x;Z=L}}else{V=I;W=K;X=x;Z=L}}else{V=I;W=K;X=x;Z=L}while(0);M=f[J+4>>2]|0;if(!M){N=J+8|0;T=f[N>>2]|0;if((f[T>>2]|0)==(J|0))ma=T;else{T=N;do{N=f[T>>2]|0;T=N+8|0;ca=f[T>>2]|0}while((f[ca>>2]|0)!=(N|0));ma=ca}}else{T=M;while(1){ca=f[T>>2]|0;if(!ca)break;else T=ca}ma=T}if((ma|0)==(A|0))break;else{I=V;J=ma;x=X;K=W;L=Z}}if(W|0){W=f[p>>2]|0;if((W|0)<3)na=Y(f[k+12>>2]|0,f[q>>2]|0)|0;else{q=f[r>>2]|0;Z=0;L=1;while(1){K=Y(f[q+(Z<<2)>>2]|0,L)|0;Z=Z+1|0;if((Z|0)==(W|0)){na=K;break}else L=K}}if(!((W|0)==0|(na|0)==0)){aQa(a,l,d);g0(o,k,1,1);f[i>>2]=-2147483648;f[i+4>>2]=2147483647;f[j>>2]=0;f[j+4>>2]=C;W$(n,o,i,j);i0(m,n,1,c);j=e+36|0;i=f[j>>2]|0;if((m|0)==(e|0)){C=m+36|0;if((i|0)!=0?(l=i+12|0,na=f[l>>2]|0,f[l>>2]=na+-1,(na|0)==1):0){V$(m);oa=C}else oa=C}else{if(i|0?(C=i+12|0,i=f[C>>2]|0,f[C>>2]=i+-1,(i|0)==1):0)V$(e);f[j>>2]=0;i=e+16|0;C=e+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[C>>2]|0)>0){na=f[e+40>>2]|0;l=0;do{f[na+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[C>>2]|0))}f[e>>2]=f[m>>2];l=m+4|0;na=f[l>>2]|0;f[C>>2]=na;C=m+8|0;W=e+8|0;f[W>>2]=f[C>>2];f[e+12>>2]=f[m+12>>2];f[i>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[e+32>>2]=f[m+32>>2];i=m+36|0;f[j>>2]=f[i>>2];j=e+44|0;L=f[j>>2]|0;Z=e+48|0;if((L|0)==(Z|0)){pa=na;qa=L}else{wL(L);f[j>>2]=Z;f[e+40>>2]=W;pa=f[l>>2]|0;qa=Z}Z=m+44|0;if((pa|0)<3){pa=f[Z>>2]|0;f[qa>>2]=f[pa>>2];f[qa+4>>2]=f[pa+4>>2]}else{f[j>>2]=f[Z>>2];j=m+40|0;f[e+40>>2]=f[j>>2];f[Z>>2]=m+48;f[j>>2]=C}f[m>>2]=1124007936;s=l;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));oa=i}f[oa>>2]=0;oa=m+16|0;i=m+4|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[i>>2]|0)>0){oa=f[m+40>>2]|0;s=0;do{f[oa+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[i>>2]|0))}i=f[m+44>>2]|0;if((i|0)!=(m+48|0))wL(i);i=n+36|0;m=f[i>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)V$(n);f[i>>2]=0;i=n+16|0;m=n+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[m>>2]|0)>0){i=f[n+40>>2]|0;s=0;do{f[i+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[m>>2]|0))}m=f[n+44>>2]|0;if((m|0)!=(n+48|0))wL(m);m=o+36|0;n=f[m>>2]|0;if(n|0?(s=n+12|0,n=f[s>>2]|0,f[s>>2]=n+-1,(n|0)==1):0)V$(o);f[m>>2]=0;m=o+16|0;n=o+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[n>>2]|0)>0){m=f[o+40>>2]|0;s=0;do{f[m+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[n>>2]|0))}n=f[o+44>>2]|0;if((n|0)!=(o+48|0))wL(n);n=k+36|0;o=f[n>>2]|0;do if(o|0){s=o+12|0;m=f[s>>2]|0;f[s>>2]=m+-1;if((m|0)!=1)break;V$(k)}while(0);f[n>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[p>>2]|0)>0){n=f[r>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[p>>2]|0))}o=f[w>>2]|0;if((o|0)!=(v|0))wL(o);u=h;return}}o=k+36|0;if((X|0)!=0?(n=X+12|0,X=f[n>>2]|0,f[n>>2]=X+-1,(X|0)==1):0){V$(k);ra=y;sa=o}else{ra=y;sa=o}}else{ra=k+16|0;sa=k+36|0}f[sa>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[p>>2]|0)>0){ra=f[r>>2]|0;r=0;do{f[ra+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[w>>2]|0;if((p|0)!=(v|0))wL(p)}T$(e,c,g?3:5);eQa(a,d,e);u=h;return}function cQa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;cQa(a,f[b>>2]|0);cQa(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0){c=b+24|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~((d+-4-a|0)>>>2)<<2);cYc(a)}cYc(b);return}function dQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;do if(h|0){i=f[c>>2]|0;j=f[c+4>>2]|0;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)>=(i|0)){if((n|0)!=(i|0))break;if((f[m+20>>2]|0)>=(j|0))break}n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)?(k=f[o+16>>2]|0,(i|0)>=(k|0)):0){if((i|0)==(k|0)?(j|0)<(f[o+20>>2]|0):0)break;k=a+4|0;l=f[k>>2]|0;do if(l|0){n=f[o+24>>2]|0;p=f[o+28>>2]|0;q=k;r=l;b:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)>=(n|0)){if((t|0)!=(n|0))break;if((f[s+20>>2]|0)>=(p|0))break}t=f[s+4>>2]|0;if(!t){v=q;break b}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)!=(k|0)?(q=f[v+16>>2]|0,(n|0)>=(q|0)):0){if((n|0)==(q|0)?(p|0)<(f[v+20>>2]|0):0)break;q=v+24|0;r=f[q>>2]|0;if((r|0)>0){f[q>>2]=r+-1;u=d;return}else{r=$Xc(32)|0;f[e>>2]=r;f[e+8>>2]=-2147483616;f[e+4>>2]=17;w=r;x=395940;y=w+17|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[r+17>>0]=0;vM(-215,e,395897,391289,709)}}}while(0);k=$Xc(32)|0;f[e>>2]=k;f[e+8>>2]=-2147483616;f[e+4>>2]=25;w=k;x=395914;y=w+25|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[k+25>>0]=0;vM(-215,e,395897,391289,708)}}while(0);d=$Xc(32)|0;f[e>>2]=d;f[e+8>>2]=-2147483616;f[e+4>>2]=23;w=d;x=395873;y=w+23|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[d+23>>0]=0;vM(-215,e,395897,391289,705)}function eQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+32|0;g=e+4|0;h=e;i=e+16|0;j=a+28|0;k=f[j>>2]|0;if(k|0){l=f[c>>2]|0;m=f[c+4>>2]|0;n=j;o=k;a:while(1){k=o;while(1){p=f[k+16>>2]|0;if((p|0)>=(l|0)){if((p|0)!=(l|0))break;if((f[k+20>>2]|0)>=(m|0))break}p=f[k+4>>2]|0;if(!p){q=n;break a}else k=p}o=f[k>>2]|0;if(!o){q=k;break}else n=k}if((q|0)!=(j|0)?(j=f[q+16>>2]|0,(l|0)>=(j|0)):0){if((l|0)!=(j|0)){r=$Xc(48)|0;f[g>>2]=r;s=g+8|0;f[s>>2]=-2147483600;t=g+4|0;f[t>>2]=35;v=r;w=395958;x=v+35|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+35|0;b[y>>0]=0;vM(-215,g,395994,391289,860)}if((m|0)>=(f[q+20>>2]|0)){r=$Xc(48)|0;f[g>>2]=r;s=g+8|0;f[s>>2]=-2147483600;t=g+4|0;f[t>>2]=35;v=r;w=395958;x=v+35|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=r+35|0;b[y>>0]=0;vM(-215,g,395994,391289,860)}}}y=fQa(a+12|0,c)|0;r=c;w=f[r+4>>2]|0;v=y;f[v>>2]=f[r>>2];f[v+4>>2]=w;f[h>>2]=c;gQa(g,a+24|0,c,1163514,h,i);i=f[g>>2]|0;g=i+24|0;if((g|0)==(d|0)){u=e;return}h=d+36|0;c=f[h>>2]|0;if(c|0){a=c+12|0;f[a>>2]=(f[a>>2]|0)+1}a=i+60|0;c=f[a>>2]|0;if(c|0?(w=c+12|0,c=f[w>>2]|0,f[w>>2]=c+-1,(c|0)==1):0)V$(g);f[a>>2]=0;c=i+40|0;w=i+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[w>>2]|0)>0){v=f[i+64>>2]|0;r=0;do{f[v+(r<<2)>>2]=0;r=r+1|0;z=f[w>>2]|0}while((r|0)<(z|0));f[g>>2]=f[d>>2];if((z|0)<3)A=25;else A=27}else{f[g>>2]=f[d>>2];A=25}if((A|0)==25){z=f[d+4>>2]|0;if((z|0)<3){f[w>>2]=z;f[i+32>>2]=f[d+8>>2];f[i+36>>2]=f[d+12>>2];z=f[d+44>>2]|0;w=f[i+68>>2]|0;f[w>>2]=f[z>>2];f[w+4>>2]=f[z+4>>2]}else A=27}if((A|0)==27)U$(g,d);f[c>>2]=f[d+16>>2];f[i+44>>2]=f[d+20>>2];f[i+48>>2]=f[d+24>>2];f[i+52>>2]=f[d+28>>2];f[i+56>>2]=f[d+32>>2];f[a>>2]=f[h>>2];u=e;return}function fQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;a:while(1){j=f[i+16>>2]|0;do if((e|0)>=(j|0)){k=(e|0)==(j|0);if(k?(g|0)<(f[i+20>>2]|0):0){l=7;break}if((j|0)>=(e|0)){if(!k){l=14;break a}if((f[i+20>>2]|0)>=(g|0)){l=14;break a}}m=i+4|0;k=f[m>>2]|0;if(!k){l=13;break a}else{n=m;o=k}}else l=7;while(0);if((l|0)==7){l=0;j=f[i>>2]|0;if(!j){l=8;break}else{n=i;o=j}}h=n;i=o}if((l|0)==8){p=i;q=i;break}else if((l|0)==13){p=i;q=m;break}else if((l|0)==14){p=i;q=h;break}}else{p=c;q=c}while(0);c=f[q>>2]|0;if(c|0){r=c;s=r+24|0;return s|0}c=$Xc(32)|0;l=b;b=f[l+4>>2]|0;m=c+16|0;f[m>>2]=f[l>>2];f[m+4>>2]=b;f[c+24>>2]=-1;f[c+28>>2]=-1;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=p;f[q>>2]=c;p=f[f[a>>2]>>2]|0;if(!p)t=c;else{f[a>>2]=p;t=f[q>>2]|0}UQ(f[a+4>>2]|0,t);t=a+8|0;f[t>>2]=(f[t>>2]|0)+1;r=c;s=r+24|0;return s|0}function gQa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=c+4|0;e=f[h>>2]|0;do if(e){i=f[d>>2]|0;j=f[d+4>>2]|0;k=c+4|0;l=e;a:while(1){m=f[l+16>>2]|0;do if((i|0)>=(m|0)){n=(i|0)==(m|0);if(n?(j|0)<(f[l+20>>2]|0):0){o=7;break}if((m|0)>=(i|0)){if(!n){o=14;break a}if((f[l+20>>2]|0)>=(j|0)){o=14;break a}}p=l+4|0;n=f[p>>2]|0;if(!n){o=13;break a}else{q=p;r=n}}else o=7;while(0);if((o|0)==7){o=0;m=f[l>>2]|0;if(!m){o=8;break}else{q=l;r=m}}k=q;l=r}if((o|0)==8){s=l;t=l;break}else if((o|0)==13){s=l;t=p;break}else if((o|0)==14){s=l;t=k;break}}else{s=h;t=h}while(0);h=f[t>>2]|0;if(h|0){u=h;v=0;w=u;f[a>>2]=w;x=a+4|0;b[x>>0]=v;return}h=$Xc(80)|0;o=f[g>>2]|0;g=f[o+4>>2]|0;p=h+16|0;f[p>>2]=f[o>>2];f[p+4>>2]=g;f[h+24>>2]=1124007936;g=h+32|0;p=h+64|0;o=h+28|0;r=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(r|0));f[p>>2]=g;g=h+72|0;f[h+68>>2]=g;f[g>>2]=0;f[h+76>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=s;f[t>>2]=h;s=f[f[c>>2]>>2]|0;if(!s)y=h;else{f[c>>2]=s;y=f[t>>2]|0}UQ(f[c+4>>2]|0,y);y=c+8|0;f[y>>2]=(f[y>>2]|0)+1;u=h;v=1;w=u;f[a>>2]=w;x=a+4|0;b[x>>0]=v;return}function hQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/12|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>((g-h|0)/12|0)>>>0){if(!h)j=g;else{g=a+4|0;k=f[g>>2]|0;if((k|0)==(i|0))l=h;else{m=k;while(1){k=m+-12|0;f[g>>2]=k;n=f[k>>2]|0;if(!n)o=k;else{k=m+-8|0;p=f[k>>2]|0;if((p|0)!=(n|0))f[k>>2]=p+(~((p+-4-n|0)>>>2)<<2);cYc(n);o=f[g>>2]|0}if((o|0)==(i|0))break;else m=o}l=f[a>>2]|0}cYc(l);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>357913941)kWc(a);g=(j|0)/12|0;j=g<<1;l=g>>>0<178956970?(j>>>0<d>>>0?d:j):357913941;if(l>>>0>357913941)kWc(a);j=$Xc(l*12|0)|0;g=a+4|0;f[g>>2]=j;f[a>>2]=j;f[e>>2]=j+(l*12|0);if((b|0)==(c|0))return;l=b;e=j;do{eKa(e,l);l=l+12|0;e=(f[g>>2]|0)+12|0;f[g>>2]=e}while((l|0)!=(c|0));return}else{l=a+4|0;a=((f[l>>2]|0)-h|0)/12|0;h=d>>>0>a>>>0;d=b+(a*12|0)|0;a=h?d:c;if((a|0)==(b|0))q=i;else{e=b;b=i;while(1){if((b|0)!=(e|0))eEa(b,f[e>>2]|0,f[e+4>>2]|0);e=e+12|0;i=b+12|0;if((e|0)==(a|0)){q=i;break}else b=i}}if(h){if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{eKa(d,a);a=a+12|0;d=(f[l>>2]|0)+12|0;f[l>>2]=d}while((a|0)!=(c|0));return}c=f[l>>2]|0;if((c|0)==(q|0))return;else r=c;while(1){c=r+-12|0;f[l>>2]=c;a=f[c>>2]|0;if(!a)s=c;else{c=r+-8|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~((d+-4-a|0)>>>2)<<2);cYc(a);s=f[l>>2]|0}if((s|0)==(q|0))break;else r=s}return}}function iQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;e=u;u=u+32|0;g=e+16|0;h=e+12|0;i=e+24|0;j=e+8|0;k=e;f[j>>2]=c;c=a+20|0;f[h>>2]=j;lPa(g,c,j,1163514,h,i);l=f[g>>2]|0;m=l+96|0;n=f[j>>2]|0;o=d+4|0;p=f[o>>2]|0;do if(p){q=d+4|0;r=p;while(1){s=f[r+16>>2]|0;if((s|0)>(n|0)){t=f[r>>2]|0;if(!t){v=6;break}else{w=r;x=t}}else{if((s|0)>=(n|0)){v=10;break}y=r+4|0;s=f[y>>2]|0;if(!s){v=9;break}else{w=y;x=s}}q=w;r=x}if((v|0)==6){z=r;A=r;break}else if((v|0)==9){z=r;A=y;break}else if((v|0)==10){z=r;A=q;break}}else{z=o;A=o}while(0);y=f[A>>2]|0;if(!y){x=$Xc(60)|0;f[x+16>>2]=n;n=x+20|0;B=n;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));b[n+36>>0]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=z;f[A>>2]=x;z=f[f[d>>2]>>2]|0;if(!z)D=x;else{f[d>>2]=z;D=f[A>>2]|0}UQ(f[d+4>>2]|0,D);D=d+8|0;f[D>>2]=(f[D>>2]|0)+1;E=x}else E=y;if((f[E+20>>2]|0)==(f[E+24>>2]|0)?(E=l+100|0,l=f[m>>2]|0,(f[E>>2]|0)!=(l|0)):0){y=d+4|0;x=d+8|0;D=0;A=l;do{l=f[A+(D<<3)>>2]|0;z=f[o>>2]|0;if(z){n=o;w=z;a:while(1){p=w;while(1){if((f[p+16>>2]|0)>=(l|0))break;s=f[p+4>>2]|0;if(!s){F=n;break a}else p=s}w=f[p>>2]|0;if(!w){F=p;break}else n=p}if(((F|0)!=(o|0)?(f[F+16>>2]|0)<=(l|0):0)?(f[F+32>>2]|0)!=(f[F+36>>2]|0):0)G=z;else v=27}else v=27;if((v|0)==27){v=0;iQa(a,l,d);G=f[o>>2]|0}do if(G){n=y;w=G;while(1){q=f[w+16>>2]|0;if((q|0)>(l|0)){r=f[w>>2]|0;if(!r){v=32;break}else{H=w;I=r}}else{if((q|0)>=(l|0)){v=36;break}J=w+4|0;q=f[J>>2]|0;if(!q){v=35;break}else{H=J;I=q}}n=H;w=I}if((v|0)==32){v=0;K=w;L=w;break}else if((v|0)==35){v=0;K=w;L=J;break}else if((v|0)==36){v=0;K=w;L=n;break}}else{K=o;L=o}while(0);z=f[L>>2]|0;if(!z){p=$Xc(60)|0;f[p+16>>2]=l;q=p+20|0;B=q;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));b[q+36>>0]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=K;f[L>>2]=p;l=f[f[d>>2]>>2]|0;if(!l)M=p;else{f[d>>2]=l;M=f[L>>2]|0}UQ(f[y>>2]|0,M);f[x>>2]=(f[x>>2]|0)+1;N=p;O=f[o>>2]|0}else{N=z;O=G}l=(f[N+32>>2]|0)+((f[(f[m>>2]|0)+(D<<3)+4>>2]|0)*12|0)|0;r=f[j>>2]|0;do if(O){s=y;t=O;while(1){P=f[t+16>>2]|0;if((P|0)>(r|0)){Q=f[t>>2]|0;if(!Q){v=45;break}else{R=t;S=Q}}else{if((P|0)>=(r|0)){v=49;break}T=t+4|0;P=f[T>>2]|0;if(!P){v=48;break}else{R=T;S=P}}s=R;t=S}if((v|0)==45){v=0;U=t;V=t;break}else if((v|0)==48){v=0;U=t;V=T;break}else if((v|0)==49){v=0;U=t;V=s;break}}else{U=o;V=o}while(0);z=f[V>>2]|0;if(!z){p=$Xc(60)|0;f[p+16>>2]=r;q=p+20|0;B=q;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));b[q+36>>0]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=U;f[V>>2]=p;r=f[f[d>>2]>>2]|0;if(!r)W=p;else{f[d>>2]=r;W=f[V>>2]|0}UQ(f[y>>2]|0,W);f[x>>2]=(f[x>>2]|0)+1;X=p}else X=z;r=X+24|0;n=f[r>>2]|0;if((n|0)==(f[X+28>>2]|0))fKa(X+20|0,l);else{eKa(n,l);f[r>>2]=(f[r>>2]|0)+12}D=D+1|0;A=f[m>>2]|0}while(D>>>0<(f[E>>2]|0)-A>>3>>>0)}A=f[j>>2]|0;E=f[o>>2]|0;do if(E){D=d+4|0;m=E;while(1){X=f[m+16>>2]|0;if((X|0)>(A|0)){x=f[m>>2]|0;if(!x){v=63;break}else{Y=m;Z=x}}else{if((X|0)>=(A|0)){v=67;break}_=m+4|0;X=f[_>>2]|0;if(!X){v=66;break}else{Y=_;Z=X}}D=Y;m=Z}if((v|0)==63){$=m;aa=m;break}else if((v|0)==66){$=m;aa=_;break}else if((v|0)==67){$=m;aa=D;break}}else{$=o;aa=o}while(0);_=f[aa>>2]|0;if(!_){Z=$Xc(60)|0;f[Z+16>>2]=A;Y=Z+20|0;B=Y;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));b[Y+36>>0]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=$;f[aa>>2]=Z;$=f[f[d>>2]>>2]|0;if(!$)ba=Z;else{f[d>>2]=$;ba=f[aa>>2]|0}UQ(f[d+4>>2]|0,ba);ba=d+8|0;f[ba>>2]=(f[ba>>2]|0)+1;ca=Z;da=f[j>>2]|0;ea=f[o>>2]|0}else{ca=_;da=A;ea=E}E=ca+20|0;do if(ea){ca=d+4|0;A=ea;while(1){_=f[A+16>>2]|0;if((_|0)>(da|0)){Z=f[A>>2]|0;if(!Z){v=78;break}else{fa=A;ga=Z}}else{if((_|0)>=(da|0)){v=82;break}ha=A+4|0;_=f[ha>>2]|0;if(!_){v=81;break}else{fa=ha;ga=_}}ca=fa;A=ga}if((v|0)==78){ia=A;ja=A;break}else if((v|0)==81){ia=A;ja=ha;break}else if((v|0)==82){ia=A;ja=ca;break}}else{ia=o;ja=o}while(0);ha=f[ja>>2]|0;if(!ha){ga=$Xc(60)|0;f[ga+16>>2]=da;fa=ga+20|0;B=fa;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));b[fa+36>>0]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=ia;f[ja>>2]=ga;ia=f[f[d>>2]>>2]|0;if(!ia)ka=ga;else{f[d>>2]=ia;ka=f[ja>>2]|0}UQ(f[d+4>>2]|0,ka);ka=d+8|0;f[ka>>2]=(f[ka>>2]|0)+1;la=ga;ma=f[j>>2]|0;na=f[o>>2]|0}else{la=ha;ma=da;na=ea}ea=la+32|0;do if(na){la=d+4|0;da=na;while(1){ha=f[da+16>>2]|0;if((ha|0)>(ma|0)){ga=f[da>>2]|0;if(!ga){v=93;break}else{oa=da;pa=ga}}else{if((ha|0)>=(ma|0)){v=97;break}qa=da+4|0;ha=f[qa>>2]|0;if(!ha){v=96;break}else{oa=qa;pa=ha}}la=oa;da=pa}if((v|0)==93){ra=da;sa=da;break}else if((v|0)==96){ra=da;sa=qa;break}else if((v|0)==97){ra=da;sa=la;break}}else{ra=o;sa=o}while(0);qa=f[sa>>2]|0;if(!qa){pa=$Xc(60)|0;f[pa+16>>2]=ma;ma=pa+20|0;B=ma;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));b[ma+36>>0]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=ra;f[sa>>2]=pa;ra=f[f[d>>2]>>2]|0;if(!ra)ta=pa;else{f[d>>2]=ra;ta=f[sa>>2]|0}UQ(f[d+4>>2]|0,ta);ta=d+8|0;f[ta>>2]=(f[ta>>2]|0)+1;ua=pa}else ua=qa;f[h>>2]=j;lPa(g,c,j,1163514,h,i);qa=f[(f[g>>2]|0)+128>>2]|0;f[h>>2]=j;lPa(g,c,j,1163514,h,i);_Oa(k,(f[g>>2]|0)+20|0);g=f[k>>2]|0;i=_h[f[(f[g>>2]|0)+96>>2]&127](g,E,qa,ea,ua+44|0)|0;ua=f[j>>2]|0;j=f[o>>2]|0;do if(j){ea=d+4|0;qa=j;while(1){E=f[qa+16>>2]|0;if((E|0)>(ua|0)){g=f[qa>>2]|0;if(!g){v=108;break}else{va=qa;wa=g}}else{if((E|0)>=(ua|0)){v=112;break}xa=qa+4|0;E=f[xa>>2]|0;if(!E){v=111;break}else{va=xa;wa=E}}ea=va;qa=wa}if((v|0)==108){ya=qa;za=qa;break}else if((v|0)==111){ya=qa;za=xa;break}else if((v|0)==112){ya=qa;za=ea;break}}else{ya=o;za=o}while(0);o=f[za>>2]|0;if(!o){v=$Xc(60)|0;f[v+16>>2]=ua;ua=v+20|0;B=ua;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));b[ua+36>>0]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=ya;f[za>>2]=v;ya=f[f[d>>2]>>2]|0;if(!ya)Aa=v;else{f[d>>2]=ya;Aa=f[za>>2]|0}UQ(f[d+4>>2]|0,Aa);Aa=d+8|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Ba=v}else Ba=o;b[Ba+56>>0]=i&1;i=f[k+4>>2]|0;if(!i){u=e;return}UXc(i);u=e;return}function jQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=u;u=u+144|0;g=e;h=e+88|0;i=e+72|0;j=e+60|0;k=e+24|0;l=e+16|0;m=e+48|0;n=e+36|0;lYc(j,d);d=j+11|0;o=b[d>>0]|0;if(((o<<24>>24<0?f[j+4>>2]|0:o&255)|0)==0?(gPa(g,a),o=g+4|0,oYc(j,(f[o>>2]|0)+-12|0)|0,p=f[g>>2]|0,p|0):0){q=f[o>>2]|0;if((q|0)==(p|0))r=p;else{s=q;while(1){q=s+-12|0;f[o>>2]=q;if((b[q+11>>0]|0)<0){cYc(f[q>>2]|0);t=f[o>>2]|0}else t=q;if((t|0)==(p|0))break;else s=t}r=f[g>>2]|0}cYc(r)}ZOa(g,f[a>>2]|0,j);f[k>>2]=0;r=k+4|0;f[r>>2]=0;f[k+8>>2]=0;t=$Xc(8)|0;f[k>>2]=t;f[k+8>>2]=t+8;s=g;p=f[s+4>>2]|0;o=t;f[o>>2]=f[s>>2];f[o+4>>2]=p;f[r>>2]=t+8;hPa(f[a>>2]|0,k);t=f[a>>2]|0;jPa(t,iPa(t,j)|0,1);ZOa(l,f[a>>2]|0,j);t=(f[a>>2]|0)+20|0;f[h>>2]=l;lPa(g,t,l,1163514,h,i);l=f[g>>2]|0;a:do if((eS(c)|0)==655360){t=f[a>>2]|0;lYc(m,j);ZOa(g,t,m);kPa(h,t,g);jR(h,c);t=h+36|0;p=f[t>>2]|0;if(p|0?(o=p+12|0,p=f[o>>2]|0,f[o>>2]=p+-1,(p|0)==1):0)V$(h);f[t>>2]=0;t=h+16|0;p=h+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[p>>2]|0)>0){t=f[h+40>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[p>>2]|0))}p=f[h+44>>2]|0;if((p|0)!=(h+48|0))wL(p);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0)}else{if((eS(c)|0)==65536){p=f[a>>2]|0;lYc(n,j);ZOa(g,p,n);kPa(h,p,g);cT(c,h);p=h+36|0;o=f[p>>2]|0;if(o|0?(t=o+12|0,o=f[t>>2]|0,f[t>>2]=o+-1,(o|0)==1):0)V$(h);f[p>>2]=0;p=h+16|0;o=h+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[o>>2]|0)>0){p=f[h+40>>2]|0;t=0;do{f[p+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[o>>2]|0))}o=f[h+44>>2]|0;if((o|0)!=(h+48|0))wL(o);if((b[n+11>>0]|0)<0)cYc(f[n>>2]|0);break}if((eS(c)|0)==327680){b:do if(f[(f[a>>2]|0)+84>>2]|0?(o=l+144|0,t=l+148|0,p=f[o>>2]|0,(f[t>>2]|0)!=(p|0)):0){s=0;q=p;while(1){p=f[q+(s<<3)>>2]|0;if(!p)break;Yi[f[(f[p>>2]|0)+8>>2]&4095](p);s=s+1|0;q=f[o>>2]|0;if(s>>>0>=(f[t>>2]|0)-q>>3>>>0)break b}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;q=$Xc(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=34;t=q;s=396098;o=t+34|0;do{b[t>>0]=b[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(o|0));b[q+34>>0]=0;vM(-215,g,456135,391289,2678)}while(0);s=l+188|0;t=f[s>>2]|0;o=f[c+4>>2]|0;if((f[t>>2]&7|0)==5){if((o|0)==(s|0))break;JPa(o,t,f[l+192>>2]|0);break}hS(o,((f[l+192>>2]|0)-t|0)/56|0);t=o+4|0;p=f[o>>2]|0;if((f[t>>2]|0)==(p|0))break;v=g+8|0;w=g+12|0;x=g+4|0;y=h+8|0;z=h+4|0;A=0;B=p;while(1){p=(f[s>>2]|0)+(A*56|0)|0;f[v>>2]=0;f[w>>2]=0;f[g>>2]=16842752;f[x>>2]=p;p=y;f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=33619968;f[z>>2]=B+(A*56|0);eY(g,h);A=A+1|0;B=f[o>>2]|0;if(A>>>0>=(((f[t>>2]|0)-B|0)/56|0)>>>0)break a}}if((eS(c)|0)==720896){B=f[c+4>>2]|0;t=f[a>>2]|0;if((f[t+80>>2]|0)==3?(A=f[t+84>>2]|0,(A+-1|0)>>>0<2):0){switch(A|0){case 1:{nPa(g,l+144|0);A=f[B>>2]|0;if(!A){C=B+4|0;D=B+8|0}else{t=B+4|0;o=f[t>>2]|0;if((o|0)==(A|0))E=A;else{z=o;do{o=z+-48|0;f[t>>2]=o;EQ(o);z=f[t>>2]|0}while((z|0)!=(A|0));E=f[B>>2]|0}cYc(E);A=B+8|0;f[A>>2]=0;f[t>>2]=0;f[B>>2]=0;C=t;D=A}f[B>>2]=f[g>>2];f[C>>2]=f[g+4>>2];f[D>>2]=f[g+8>>2];break a;break}case 2:break;default:break a}nPa(g,l+144|0);A=g+4|0;z=((f[A>>2]|0)-(f[g>>2]|0)|0)/48|0;o=B+4|0;y=f[o>>2]|0;x=f[B>>2]|0;w=(y-x|0)/48|0;v=x;x=y;if(z>>>0<=w>>>0){if(z>>>0<w>>>0?(y=v+(z*48|0)|0,(x|0)!=(y|0)):0){v=x;do{x=v+-48|0;f[o>>2]=x;EQ(x);v=f[o>>2]|0}while((v|0)!=(y|0))}}else kS(B,z-w|0);y=f[A>>2]|0;v=f[g>>2]|0;o=v;if((y|0)==(v|0)){F=y;G=o}else{y=h+8|0;v=h+12|0;t=h+4|0;x=i+8|0;s=i+4|0;p=0;H=o;while(1){f[y>>2]=0;f[v>>2]=0;f[h>>2]=17432576;f[t>>2]=H+(p*48|0);o=(f[B>>2]|0)+(p*48|0)|0;I=x;f[I>>2]=0;f[I+4>>2]=0;f[i>>2]=34209792;f[s>>2]=o;eY(h,i);p=p+1|0;o=f[A>>2]|0;I=f[g>>2]|0;J=I;if(p>>>0>=((o-I|0)/48|0)>>>0){F=o;G=J;break}else H=J}}H=F;if(G|0){if((H|0)==(G|0))K=G;else{p=H;do{H=p+-48|0;f[A>>2]=H;EQ(H);p=f[A>>2]|0}while((p|0)!=(G|0));K=f[g>>2]|0}cYc(K)}break}p=l+188|0;A=((f[l+192>>2]|0)-(f[p>>2]|0)|0)/56|0;H=B+4|0;s=f[H>>2]|0;x=f[B>>2]|0;t=(s-x|0)/48|0;v=x;x=s;if(A>>>0<=t>>>0)if(A>>>0<t>>>0?(y=v+(A*48|0)|0,(x|0)!=(y|0)):0){v=x;do{x=v+-48|0;f[H>>2]=x;EQ(x);v=f[H>>2]|0}while((v|0)!=(y|0));L=v}else L=s;else{kS(B,A-t|0);L=f[H>>2]|0}y=f[B>>2]|0;if((L|0)!=(y|0)){x=g+8|0;w=g+4|0;z=0;J=y;do{y=(f[p>>2]|0)+(z*56|0)|0;o=x;f[o>>2]=0;f[o+4>>2]=0;f[g>>2]=34209792;f[w>>2]=J+(z*48|0);jR(y,g);z=z+1|0;J=f[B>>2]|0}while(z>>>0<(((f[H>>2]|0)-J|0)/48|0)>>>0)}}}while(0);g=f[k>>2]|0;if(g|0){k=f[r>>2]|0;if((k|0)!=(g|0))f[r>>2]=k+(~((k+-8-g|0)>>>3)<<3);cYc(g)}if((b[d>>0]|0)>=0){u=e;return}cYc(f[j>>2]|0);u=e;return}function kQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+96|0;e=d+16|0;g=d;h=d+80|0;i=d+24|0;f[h>>2]=0;j=h+4|0;f[j>>2]=0;f[h+8>>2]=0;k=c+4|0;l=f[c>>2]|0;if((f[k>>2]|0)==(l|0))m=a;else{n=h+8|0;o=0;p=l;do{ZOa(g,f[a>>2]|0,p+(o*12|0)|0);l=f[j>>2]|0;if(l>>>0<(f[n>>2]|0)>>>0){q=g;r=f[q+4>>2]|0;s=l;f[s>>2]=f[q>>2];f[s+4>>2]=r;f[j>>2]=(f[j>>2]|0)+8}else WOa(h,g);o=o+1|0;p=f[c>>2]|0}while(o>>>0<(((f[k>>2]|0)-p|0)/12|0)>>>0);m=a}hPa(f[m>>2]|0,h);a=f[h>>2]|0;p=f[j>>2]|0;a:do if((a|0)!=(p|0)?(k=a+8|0,(k|0)!=(p|0)):0){o=a;c=k;k=f[a>>2]|0;while(1){n=o+4|0;r=o;s=c;while(1){q=f[s>>2]|0;if((k|0)<(q|0)){t=q;break}if((k|0)==(q|0)?(f[n>>2]|0)<(f[r+12>>2]|0):0){t=k;break}q=s+8|0;if((q|0)==(p|0)){v=o;break a}else{l=s;s=q;r=l}}c=s+8|0;if((c|0)==(p|0)){v=s;break}else{o=s;k=t}}}else v=a;while(0);a=f[v>>2]|0;v=f[m>>2]|0;t=v+24|0;p=f[t>>2]|0;if(!p){f[e>>2]=a;DM(g,393143,e);vM(-204,g,393180,391289,1204)}else{w=t;x=p}b:while(1){p=x;while(1){if((f[p+16>>2]|0)>=(a|0))break;k=f[p+4>>2]|0;if(!k){y=w;break b}else p=k}x=f[p>>2]|0;if(!x){y=p;break}else w=p}if((y|0)==(t|0)){f[e>>2]=a;DM(g,393143,e);vM(-204,g,393180,391289,1204)}if((f[y+16>>2]|0)>(a|0)){f[e>>2]=a;DM(g,393143,e);vM(-204,g,393180,391289,1204)}jPa(v,y+20|0,1);f[g>>2]=0;y=g+4|0;f[y>>2]=0;f[g+8>>2]=0;v=f[h>>2]|0;if((f[j>>2]|0)!=(v|0)){e=g+8|0;a=i+4|0;t=i+8|0;w=i+12|0;x=i+16|0;k=i+20|0;o=i+24|0;c=i+28|0;r=i+32|0;n=i+36|0;l=i+44|0;q=i+40|0;z=i+48|0;A=i+44|0;B=0;C=v;do{kPa(i,f[m>>2]|0,C+(B<<3)|0);v=f[y>>2]|0;if(v>>>0>=(f[e>>2]|0)>>>0){XLa(g,i);D=f[n>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)V$(i)}else{f[v>>2]=f[i>>2];f[v+4>>2]=f[a>>2];D=v+8|0;f[D>>2]=f[t>>2];f[v+12>>2]=f[w>>2];f[v+16>>2]=f[x>>2];f[v+20>>2]=f[k>>2];f[v+24>>2]=f[o>>2];f[v+28>>2]=f[c>>2];f[v+32>>2]=f[r>>2];f[v+36>>2]=f[n>>2];E=v+40|0;f[E>>2]=D;D=v+44|0;F=v+48|0;f[D>>2]=F;G=v+52|0;f[G>>2]=0;f[F>>2]=0;if((f[a>>2]|0)<3){H=f[l>>2]|0;f[F>>2]=f[H>>2];f[G>>2]=f[H+4>>2]}else{f[D>>2]=f[l>>2];f[E>>2]=f[q>>2];f[l>>2]=z;f[q>>2]=t}f[i>>2]=1124007936;E=a;D=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(D|0));f[y>>2]=v+56}f[n>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[a>>2]|0)>0){E=f[q>>2]|0;D=0;do{f[E+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[a>>2]|0))}D=f[A>>2]|0;if((D|0)!=(z|0))wL(D);B=B+1|0;C=f[h>>2]|0}while(B>>>0<(f[j>>2]|0)-C>>3>>>0)}C=f[b+4>>2]|0;if((C|0)!=(g|0))JPa(C,f[g>>2]|0,f[y>>2]|0);hx(g);g=f[h>>2]|0;if(!g){u=d;return}h=f[j>>2]|0;if((h|0)!=(g|0))f[j>>2]=h+(~((h+-8-g|0)>>>3)<<3);cYc(g);u=d;return}function lQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=(f[f[a>>2]>>2]|0)+44|0;f[g>>2]=f[b>>2];f[h>>2]=f[b+4>>2];f[e>>2]=f[g>>2];f[d>>2]=f[h>>2];mQa(i,e,d);u=c;return}function mQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[c>>2]|0;c=f[d>>2]|0;d=(c-e|0)/12|0;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=e;e=i;k=c;if(d>>>0<=((h-i|0)/12|0)>>>0){l=a+4|0;m=((f[l>>2]|0)-i|0)/12|0;n=d>>>0>m>>>0;o=n?j+(m*12|0)|0:c;if((j|0)==(o|0))p=e;else{c=e;m=j;while(1){oYc(c,m)|0;m=m+12|0;q=c+12|0;if((m|0)==(o|0)){p=q;break}else c=q}}if(n){if((o|0)==(k|0))return;n=f[l>>2]|0;c=o;do{lYc(n,c);c=c+12|0;n=(f[l>>2]|0)+12|0;f[l>>2]=n}while((c|0)!=(k|0));return}c=f[l>>2]|0;if((c|0)==(p|0))return;else r=c;while(1){c=r+-12|0;f[l>>2]=c;if((b[c+11>>0]|0)<0){cYc(f[c>>2]|0);s=f[l>>2]|0}else s=c;if((s|0)==(p|0))break;else r=s}return}if(!i)t=h;else{h=a+4|0;s=f[h>>2]|0;if((s|0)==(e|0))u=i;else{i=s;while(1){s=i+-12|0;f[h>>2]=s;if((b[s+11>>0]|0)<0){cYc(f[s>>2]|0);v=f[h>>2]|0}else v=s;if((v|0)==(e|0))break;else i=v}u=f[a>>2]|0}cYc(u);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;t=0}if(d>>>0>357913941)kWc(a);h=(t|0)/12|0;t=h<<1;u=h>>>0<178956970?(t>>>0<d>>>0?d:t):357913941;if(u>>>0>357913941)kWc(a);t=$Xc(u*12|0)|0;d=a+4|0;f[d>>2]=t;f[a>>2]=t;f[g>>2]=t+(u*12|0);if((j|0)==(k|0))return;u=t;t=j;do{lYc(u,t);t=t+12|0;u=(f[d>>2]|0)+12|0;f[d>>2]=u}while((t|0)!=(k|0));return}function nQa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=u;u=u+160|0;i=h;j=h+144|0;k=h+128|0;l=h+72|0;m=h+64|0;n=h+8|0;o=m+4|0;f[o>>2]=-1;f[m>>2]=0;q=(f[a>>2]|0)+24|0;r=f[q>>2]|0;if(!r){f[i>>2]=0;DM(j,393143,i);vM(-204,j,393180,391289,1204)}else{s=q;t=r}a:while(1){r=t;while(1){if((f[r+16>>2]|0)>=0)break;v=f[r+4>>2]|0;if(!v){w=s;break a}else r=v}t=f[r>>2]|0;if(!t){w=r;break}else s=r}if((w|0)==(q|0)){f[i>>2]=0;DM(j,393143,i);vM(-204,j,393180,391289,1204)}if((f[w+16>>2]|0)>0){f[i>>2]=0;DM(j,393143,i);vM(-204,j,393180,391289,1204)}i=b[d+11>>0]|0;if((i<<24>>24<0?f[d+4>>2]|0:i&255)|0){_Oa(j,w+20|0);w=f[j>>2]|0;i=Mi[f[(f[w>>2]|0)+52>>2]&1023](w,d)|0;w=f[j+4>>2]|0;if(!w)x=i;else{UXc(w);x=i}}else x=0;f[o>>2]=x;if((f[m>>2]|x|0)<0){SGa(k,396133,d);d=AYc(k,393853)|0;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;vM(-204,j,396150,391289,2834)}d=(f[a>>2]|0)+20|0;f[k>>2]=m;lPa(j,d,m,1163514,k,l);m=f[j>>2]|0;d=(f[o>>2]|0)+1|0;x=f[m+128>>2]|0;i=(d|0)<(x|0)?x:d;d=m+188|0;hS(d,i);x=m+144|0;w=m+148|0;m=f[w>>2]|0;q=f[x>>2]|0;s=m-q>>3;t=q;q=m;if(i>>>0<=s>>>0){if(i>>>0<s>>>0?(m=t+(i<<3)|0,(q|0)!=(m|0)):0){t=q;while(1){q=t+-8|0;f[w>>2]=q;v=f[t+-4>>2]|0;if(!v)y=q;else{UXc(v);y=f[w>>2]|0}if((y|0)==(m|0))break;else t=y}}}else XPa(x,i-s|0);hS((f[f[a>>2]>>2]|0)+80|0,i);s=f[f[a>>2]>>2]|0;y=s+56|0;t=s+60|0;m=f[t>>2]|0;w=f[y>>2]|0;v=m-w>>3;q=w;w=m;if(i>>>0<=v>>>0)if(i>>>0<v>>>0?(m=q+(i<<3)|0,(w|0)!=(m|0)):0){f[t>>2]=w+(~((w+-8-m|0)>>>3)<<3);z=s}else z=s;else{Voa(y,i-v|0);z=f[f[a>>2]>>2]|0}v=z+68|0;y=z+72|0;s=f[y>>2]|0;m=f[v>>2]|0;w=s-m>>5;t=m;m=s;if(i>>>0<=w>>>0)if(i>>>0<w>>>0?(s=t+(i<<5)|0,(m|0)!=(s|0)):0){f[y>>2]=m+(~((m+-32-s|0)>>>5)<<5);A=z}else A=z;else{oQa(v,i-w|0);A=f[f[a>>2]>>2]|0}w=f[o>>2]|0;i=f[A+80>>2]|0;A=f[i+(w*56|0)+4>>2]|0;v=f[i+(w*56|0)+40>>2]|0;f[k>>2]=0;w=k+4|0;f[w>>2]=0;f[k+8>>2]=0;gOa(k,v,v+(A<<2)|0);do if((eS(c)|0)==65536){A=f[c+4>>2]|0;f[l>>2]=f[A>>2];v=l+4|0;i=A+4|0;f[v>>2]=f[i>>2];z=l+8|0;f[z>>2]=f[A+8>>2];f[l+12>>2]=f[A+12>>2];f[l+16>>2]=f[A+16>>2];f[l+20>>2]=f[A+20>>2];f[l+24>>2]=f[A+24>>2];f[l+28>>2]=f[A+28>>2];f[l+32>>2]=f[A+32>>2];s=f[A+36>>2]|0;f[l+36>>2]=s;m=l+40|0;f[m>>2]=z;z=l+48|0;y=l+44|0;f[y>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(s|0){z=s+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[i>>2]|0)<3){i=f[A+44>>2]|0;z=f[y>>2]|0;f[z>>2]=f[i>>2];f[z+4>>2]=f[i+4>>2];B=v;C=m;break}else{f[v>>2]=0;U$(l,A);B=v;C=m;break}}else{bS(l,c,-1);B=l+4|0;C=l+40|0}while(0);c=f[B>>2]|0;m=f[C>>2]|0;f[j>>2]=0;v=j+4|0;f[v>>2]=0;f[j+8>>2]=0;gOa(j,m,m+(c<<2)|0);c=f[w>>2]|0;m=f[k>>2]|0;A=f[v>>2]|0;i=f[j>>2]|0;z=m;y=c;s=i;t=A;b:do if((c-m|0)==(A-i|0))if((z|0)==(y|0))D=1;else{q=z;E=s;while(1){if((f[q>>2]|0)!=(f[E>>2]|0)){D=0;break b}q=q+4|0;if((q|0)==(y|0)){D=1;break}else E=E+4|0}}else D=0;while(0);y=i;if(i|0){if((t|0)!=(s|0))f[v>>2]=t+(~((t+-4-i|0)>>>2)<<2);cYc(y)}if(!D){f[n>>2]=1124007936;y=n+4|0;i=n+8|0;t=n+40|0;v=y;s=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(s|0));f[t>>2]=i;z=n+48|0;A=n+44|0;f[A>>2]=z;f[z>>2]=0;f[n+52>>2]=0;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=n;jR(l,j);m=f[o>>2]|0;c=f[d>>2]|0;E=c+(m*56|0)|0;if((E|0)==(n|0)){q=n+36|0;r=f[q>>2]|0;if((r|0)!=0?(F=r+12|0,r=f[F>>2]|0,f[F>>2]=r+-1,(r|0)==1):0){V$(n);G=q}else G=q}else{q=c+(m*56|0)+36|0;r=f[q>>2]|0;if(r|0?(F=r+12|0,r=f[F>>2]|0,f[F>>2]=r+-1,(r|0)==1):0)V$(E);f[q>>2]=0;r=c+(m*56|0)+16|0;F=c+(m*56|0)+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[F>>2]|0)>0){H=f[c+(m*56|0)+40>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[F>>2]|0))}f[E>>2]=f[n>>2];f[F>>2]=f[y>>2];F=c+(m*56|0)+8|0;f[F>>2]=f[i>>2];f[c+(m*56|0)+12>>2]=f[n+12>>2];f[r>>2]=f[n+16>>2];f[c+(m*56|0)+20>>2]=f[n+20>>2];f[c+(m*56|0)+24>>2]=f[n+24>>2];f[c+(m*56|0)+28>>2]=f[n+28>>2];f[c+(m*56|0)+32>>2]=f[n+32>>2];r=n+36|0;f[q>>2]=f[r>>2];q=c+(m*56|0)+44|0;E=f[q>>2]|0;I=c+(m*56|0)+48|0;if((E|0)==(I|0))J=E;else{wL(E);f[q>>2]=I;f[c+(m*56|0)+40>>2]=F;J=I}I=n+44|0;if((f[y>>2]|0)<3){F=f[I>>2]|0;f[J>>2]=f[F>>2];f[J+4>>2]=f[F+4>>2]}else{f[q>>2]=f[I>>2];f[c+(m*56|0)+40>>2]=f[t>>2];f[I>>2]=z;f[t>>2]=i}f[n>>2]=1124007936;v=y;s=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(s|0));G=r}f[G>>2]=0;G=n+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[y>>2]|0)>0){G=f[t>>2]|0;t=0;do{f[G+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[y>>2]|0))}y=f[A>>2]|0;if((y|0)!=(z|0))wL(y);y=f[o>>2]|0;z=f[d>>2]|0;d=z+(y*56|0)|0;A=f[(f[f[a>>2]>>2]|0)+80>>2]|0;t=A+(y*56|0)|0;if((A|0)!=(z|0)){G=z+(y*56|0)+36|0;n=f[G>>2]|0;if(n|0){r=n+12|0;f[r>>2]=(f[r>>2]|0)+1}r=A+(y*56|0)+36|0;n=f[r>>2]|0;do if(n|0){v=n+12|0;s=f[v>>2]|0;f[v>>2]=s+-1;if((s|0)!=1)break;V$(t)}while(0);f[r>>2]=0;n=A+(y*56|0)+16|0;s=A+(y*56|0)+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[s>>2]|0)>0){v=f[A+(y*56|0)+40>>2]|0;i=0;do{f[v+(i<<2)>>2]=0;i=i+1|0;K=f[s>>2]|0}while((i|0)<(K|0));f[t>>2]=f[d>>2];if((K|0)<3)L=80;else L=82}else{f[t>>2]=f[d>>2];L=80}do if((L|0)==80){K=f[z+(y*56|0)+4>>2]|0;if((K|0)>=3){L=82;break}f[s>>2]=K;f[A+(y*56|0)+8>>2]=f[z+(y*56|0)+8>>2];f[A+(y*56|0)+12>>2]=f[z+(y*56|0)+12>>2];K=f[z+(y*56|0)+44>>2]|0;i=f[A+(y*56|0)+44>>2]|0;f[i>>2]=f[K>>2];f[i+4>>2]=f[K+4>>2]}while(0);if((L|0)==82)U$(t,d);f[n>>2]=f[z+(y*56|0)+16>>2];f[A+(y*56|0)+20>>2]=f[z+(y*56|0)+20>>2];f[A+(y*56|0)+24>>2]=f[z+(y*56|0)+24>>2];f[A+(y*56|0)+28>>2]=f[z+(y*56|0)+28>>2];f[A+(y*56|0)+32>>2]=f[z+(y*56|0)+32>>2];f[r>>2]=f[G>>2]}}else{G=(f[(f[f[a>>2]>>2]|0)+80>>2]|0)+((f[o>>2]|0)*56|0)|0;r=j+8|0;f[r>>2]=0;f[r+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=G;jR(l,j)}j=f[o>>2]|0;G=f[(f[x>>2]|0)+(j<<3)>>2]|0;if(!G)M=j;else{Yi[f[(f[G>>2]|0)+12>>2]&4095](G);M=f[o>>2]|0}o=f[a>>2]|0;a=f[o>>2]|0;p[(f[a+56>>2]|0)+(M<<3)>>3]=e;G=f[a+68>>2]|0;p[G+(M<<5)>>3]=+p[g>>3];p[G+(M<<5)+8>>3]=+p[g+8>>3];p[G+(M<<5)+16>>3]=+p[g+16>>3];p[G+(M<<5)+24>>3]=+p[g+24>>3];g=o+120|0;b[g>>0]=D&(b[g>>0]|0)!=0&1;g=l+36|0;D=f[g>>2]|0;if(D|0?(o=D+12|0,D=f[o>>2]|0,f[o>>2]=D+-1,(D|0)==1):0)V$(l);f[g>>2]=0;g=l+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[B>>2]|0)>0){g=f[C>>2]|0;C=0;do{f[g+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[B>>2]|0))}B=f[l+44>>2]|0;if((B|0)!=(l+48|0))wL(B);B=f[k>>2]|0;if(!B){u=h;return}k=f[w>>2]|0;if((k|0)!=(B|0))f[w>>2]=k+(~((k+-4-B|0)>>>2)<<2);cYc(B);u=h;return}function oQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>5>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;i=(f[e>>2]|0)+32|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>5;g=i+b|0;if(g>>>0>134217727)kWc(a);j=d-h|0;h=j>>4;d=j>>5>>>0<67108863?(h>>>0<g>>>0?g:h):134217727;do if(d)if(d>>>0>134217727){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<5)|0;break}else k=0;while(0);h=k+(i<<5)|0;i=h;g=k+(d<<5)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;b=k+32|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{j=b;b=i;i=h;do{h=i+-32|0;n=j;j=j+-32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;p[h>>3]=+p[j>>3];p[i+-24>>3]=+p[n+-24>>3];p[i+-16>>3]=+p[n+-16>>3];p[i+-8>>3]=+p[n+-8>>3];i=b+-32|0;b=i}while((j|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function pQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;f[a>>2]=0;e=a+4|0;f[e>>2]=0;f[a+8>>2]=0;g=f[b>>2]|0;h=f[g+20>>2]|0;if((h|0)==(g+24|0)){u=c;return}g=a+8|0;i=h;while(1){h=f[i+16>>2]|0;f[d>>2]=h;do if(!(f[i+128>>2]|0)){j=f[e>>2]|0;if((j|0)==(f[g>>2]|0)){Tv(a,d);break}else{f[j>>2]=h;f[e>>2]=j+4;break}}while(0);h=f[i+4>>2]|0;if(!h){j=i+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(i|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==((f[b>>2]|0)+24|0))break;else i=l}u=c;return}function qQa(a){a=a|0;var b=0;yP(a);f[a>>2]=82204;b=a+4|0;a=b+40|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function rQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=b+12|0;d=a+4|0;if((d|0)!=(c|0))JPa(d,f[c>>2]|0,f[b+16>>2]|0);oYc(a+16|0,b+24|0)|0;oYc(a+28|0,b+36|0)|0;return}function sQa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+36>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33882112;f[g+4>>2]=c;Ti[h&511](a,e,g);u=d;return}function tQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d+28|0;i=d;f[g>>2]=c;c=aPa()|0;YXc(c);lYc(h,a);a=h+11|0;j=b[a>>0]|0;k=j<<24>>24<0;l=f[h>>2]|0;m=k?l+(f[h+4>>2]|0)|0:h+(j&255)|0;j=k?l:h;if((j|0)!=(m|0)){l=j;do{j=(OIc(b[l>>0]|0)|0)&255;b[l>>0]=j;l=l+1|0}while((l|0)!=(m|0))}m=cPa(bPa()|0,h)|0;do if((m|0)!=((bPa()|0)+4|0)){l=m+32|0;j=f[l>>2]|0;k=f[g>>2]|0;if((f[j+-4>>2]|0)==(k|0)){SGa(i,393076,h);n=AYc(i,396159)|0;f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];f[e+8>>2]=f[n+8>>2];f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;vM(-5,e,396184,391289,3534)}if((j|0)==(f[m+36>>2]|0)){uQa(m+28|0,g);break}else{f[j>>2]=k;f[l>>2]=(f[l>>2]|0)+4;break}}while(0);m=bPa()|0;l=$Xc(4)|0;f[l>>2]=f[g>>2];lYc(i,h);g=i+12|0;k=i+16|0;f[g>>2]=l;f[k>>2]=l+4;j=i+20|0;f[j>>2]=l+4;l=vQa(m,e,i)|0;if(!(f[l>>2]|0)){n=$Xc(40)|0;o=n+16|0;f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];f[o+8>>2]=f[i+8>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[n+28>>2]=f[g>>2];f[n+32>>2]=f[k>>2];f[n+36>>2]=f[j>>2];f[j>>2]=0;f[k>>2]=0;f[g>>2]=0;g=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=g;f[l>>2]=n;g=f[f[m>>2]>>2]|0;if(!g)p=n;else{f[m>>2]=g;p=f[l>>2]|0}UQ(f[m+4>>2]|0,p);p=m+8|0;f[p>>2]=(f[p>>2]|0)+1}p=f[i+12>>2]|0;if(p|0){m=f[k>>2]|0;if((m|0)!=(p|0))f[k>>2]=m+(~((m+-4-p|0)>>>2)<<2);cYc(p)}if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);if((b[a>>0]|0)>=0){ZXc(c);u=d;return}cYc(f[h>>2]|0);ZXc(c);u=d;return}function uQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;cYc(d);return}function vQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=WKc(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=WKc(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function wQa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+96|0;h=g;i=g+84|0;j=g+72|0;k=g+60|0;l=g+48|0;m=g+36|0;n=g+24|0;o=g+12|0;lYc(i,e);e=i+11|0;p=b[e>>0]|0;q=p<<24>>24<0;r=f[i>>2]|0;s=i+4|0;t=q?r+(f[s>>2]|0)|0:i+(p&255)|0;p=q?r:i;if((p|0)!=(t|0)){r=p;do{p=(OIc(b[r>>0]|0)|0)&255;b[r>>0]=p;r=r+1|0}while((r|0)!=(t|0))}lYc(j,c);lYc(k,d);mYc(l,j,(KYc(j,46,-1)|0)+1|0,-1,j);mYc(m,k,(KYc(k,46,-1)|0)+1|0,-1,k);d=b[e>>0]|0;if(((d<<24>>24<0?f[s>>2]|0:d&255)|0)==5?(LYc(i,0,-1,396198,5)|0)==0:0){v=l+11|0;w=l+4|0;x=14}else x=6;a:do if((x|0)==6){d=l+11|0;c=b[d>>0]|0;t=l+4|0;if(((c<<24>>24<0?f[t>>2]|0:c&255)|0)==10?(LYc(l,0,-1,396204,10)|0)==0:0){v=d;w=t;x=14;break}c=m+11|0;r=b[c>>0]|0;p=m+4|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==10?(LYc(m,0,-1,396204,10)|0)==0:0){v=d;w=t;x=14;break}r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==8?(LYc(l,0,-1,396215,8)|0)==0:0){v=d;w=t;x=14;break}r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==8?(LYc(m,0,-1,396215,8)|0)==0:0){v=d;w=t;x=14;break}r=b[e>>0]|0;if(!(((r<<24>>24<0?f[s>>2]|0:r&255)|0)==10?!(LYc(i,0,-1,396224,10)|0):0))x=22;do if((x|0)==22){r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==2?(LYc(l,0,-1,396235,2)|0)==0:0)break;r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==2?(LYc(m,0,-1,396235,2)|0)==0:0)break;r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==5?(LYc(l,0,-1,396238,5)|0)==0:0)break;r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==5?(LYc(m,0,-1,396238,5)|0)==0:0)break;r=b[e>>0]|0;if(!(((r<<24>>24<0?f[s>>2]|0:r&255)|0)==5?!(LYc(i,0,-1,396244,5)|0):0))x=38;do if((x|0)==38){r=b[d>>0]|0;q=f[t>>2]|0;if(((r<<24>>24<0?q:r&255)|0)==2){if(!(LYc(l,0,-1,396250,2)|0))break;y=b[d>>0]|0;z=f[t>>2]|0}else{y=r;z=q}if(((y<<24>>24<0?z:y&255)|0)==3?(LYc(l,0,-1,396253,3)|0)==0:0)break;q=b[c>>0]|0;r=f[p>>2]|0;if(((q<<24>>24<0?r:q&255)|0)==2){if(!(LYc(m,0,-1,396250,2)|0))break;A=b[c>>0]|0;B=f[p>>2]|0}else{A=q;B=r}if(((A<<24>>24<0?B:A&255)|0)==3?(LYc(m,0,-1,396253,3)|0)==0:0)break;r=b[e>>0]|0;if(!(((r<<24>>24<0?f[s>>2]|0:r&255)|0)==7?!(LYc(i,0,-1,396257,7)|0):0))x=51;do if((x|0)==51){r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==7?(LYc(l,0,-1,396265,7)|0)==0:0)break;r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==7?(LYc(m,0,-1,396265,7)|0)==0:0)break;r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==3?(LYc(l,0,-1,396273,3)|0)==0:0)break;r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==3?(LYc(m,0,-1,396273,3)|0)==0:0)break;r=b[e>>0]|0;if(!(((r<<24>>24<0?f[s>>2]|0:r&255)|0)==4?!(LYc(i,0,-1,396277,4)|0):0))x=67;do if((x|0)==67){r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==3?(LYc(l,0,-1,396282,3)|0)==0:0)break;r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==3?(LYc(m,0,-1,396282,3)|0)==0:0)break;r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==3?(LYc(l,0,-1,396286,3)|0)==0:0)break;r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)==3?(LYc(m,0,-1,396286,3)|0)==0:0)break;r=b[e>>0]|0;if(!(((r<<24>>24<0?f[s>>2]|0:r&255)|0)==4?!(LYc(i,0,-1,396290,4)|0):0))x=83;do if((x|0)==83){r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==4?(LYc(l,0,-1,396290,4)|0)==0:0)break;SGa(n,396295,j);r=b[k+11>>0]|0;if(!((r<<24>>24<0?f[k+4>>2]|0:r&255)|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;C=0;D=0;E=C<<24>>24<0;F=f[o>>2]|0;G=E?F:o;H=C&255;I=E?D:H;J=zYc(n,G,I)|0;f[h>>2]=f[J>>2];f[h+4>>2]=f[J+4>>2];f[h+8>>2]=f[J+8>>2];f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;vM(-2,h,396343,391289,3644)}else{SGa(o,528271,k);C=b[o+11>>0]|0;D=f[o+4>>2]|0;E=C<<24>>24<0;F=f[o>>2]|0;G=E?F:o;H=C&255;I=E?D:H;J=zYc(n,G,I)|0;f[h>>2]=f[J>>2];f[h+4>>2]=f[J+4>>2];f[h+8>>2]=f[J+8>>2];f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;vM(-2,h,396343,391289,3644)}}while(0);pNa(a,j);K=c;break a}while(0);r=b[d>>0]|0;if(!(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==3?!(LYc(l,0,-1,396286,3)|0):0))x=77;do if((x|0)==77){r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)!=3)QOa(0,0,0);if(!(LYc(m,0,-1,396282,3)|0))break;QOa(0,0,0)}while(0);f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];QOa(0,0,0)}while(0);r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==3?(LYc(l,0,-1,396273,3)|0)==0:0)x=63;else x=61;do if((x|0)==61){r=b[c>>0]|0;if(((r<<24>>24<0?f[p>>2]|0:r&255)|0)!=7)break;if(!(LYc(m,0,-1,396265,7)|0))x=63}while(0);if((x|0)==63){f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2]}xNa(a,k,j);K=c;break a}while(0);r=b[j+11>>0]|0;iMa(a,((r<<24>>24<0?f[j+4>>2]|0:r&255)|0)==0?k:j,1);K=c;break a}while(0);r=b[d>>0]|0;if(((r<<24>>24<0?f[t>>2]|0:r&255)|0)==5?(LYc(l,0,-1,396238,5)|0)==0:0)x=34;else x=32;if(((x|0)==32?(r=b[c>>0]|0,((r<<24>>24<0?f[p>>2]|0:r&255)|0)==2):0)?(LYc(m,0,-1,396235,2)|0)==0:0)x=34;if((x|0)==34){f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2]}lIa(a,j,k);K=c}while(0);if((x|0)==14){J=b[v>>0]|0;if(((J<<24>>24<0?f[w>>2]|0:J&255)|0)==8?(LYc(l,0,-1,396215,8)|0)==0:0)x=18;else x=16;if(((x|0)==16?(J=b[m+11>>0]|0,((J<<24>>24<0?f[m+4>>2]|0:J&255)|0)==10):0)?(LYc(m,0,-1,396204,10)|0)==0:0)x=18;if((x|0)==18){f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2]}DGa(a,k,j);K=m+11|0}if((b[K>>0]|0)<0)cYc(f[m>>2]|0);if((b[l+11>>0]|0)<0)cYc(f[l>>2]|0);if((b[k+11>>0]|0)<0)cYc(f[k>>2]|0);if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);if((b[e>>0]|0)>=0){u=g;return}cYc(f[i>>2]|0);u=g;return}function xQa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+32|0;h=g+12|0;i=g;lYc(h,c);c=h+11|0;j=b[c>>0]|0;k=j<<24>>24<0;l=f[h>>2]|0;m=h+4|0;n=f[m>>2]|0;o=k?l+n|0:h+(j&255)|0;p=k?l:h;if((p|0)==(o|0)){q=j;r=n}else{n=p;do{p=(OIc(b[n>>0]|0)|0)&255;b[n>>0]=p;n=n+1|0}while((n|0)!=(o|0));q=b[c>>0]|0;r=f[m>>2]|0}do if(((q<<24>>24<0?r:q&255)|0)==5)if(!(LYc(h,0,-1,396198,5)|0)){jHa(a,e,d);break}else{s=b[c>>0]|0;t=f[m>>2]|0;v=8;break}else{s=q;t=r;v=8}while(0);a:do if((v|0)==8){do if(((s<<24>>24<0?t:s&255)|0)==10)if(!(LYc(h,0,-1,396224,10)|0)){BJa(a,d,e);break a}else{w=b[c>>0]|0;x=f[m>>2]|0;break}else{w=s;x=t}while(0);do if(((w<<24>>24<0?x:w&255)|0)==7)if(!(LYc(h,0,-1,396257,7)|0)){LNa(a,e,d);break a}else{y=b[c>>0]|0;z=f[m>>2]|0;break}else{y=w;z=x}while(0);do if(((y<<24>>24<0?z:y&255)|0)==5)if(!(LYc(h,0,-1,396244,5)|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;r=$Xc(48)|0;f[i>>2]=r;f[i+8>>2]=-2147483600;f[i+4>>2]=33;A=r;B=396351;C=A+33|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[r+33>>0]=0;vM(-213,i,396343,391289,3658)}else{D=b[c>>0]|0;E=f[m>>2]|0;break}else{D=y;E=z}while(0);if(((D<<24>>24<0?E:D&255)|0)!=4){SGa(i,396437,h);vM(-2,i,396343,391289,3661)}if(!(LYc(h,0,-1,396277,4)|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=$Xc(64)|0;f[i>>2]=q;f[i+8>>2]=-2147483584;f[i+4>>2]=51;A=q;B=396385;C=A+51|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[q+51>>0]=0;vM(-213,i,396343,391289,3660)}else{SGa(i,396437,h);vM(-2,i,396343,391289,3661)}}while(0);if((b[c>>0]|0)>=0){u=g;return}cYc(f[h>>2]|0);u=g;return}function yQa(a,b){a=a|0;b=b|0;return}function zQa(){return 0}function AQa(){var a=0,b=0;a=f[223023]|0;if(a|0){b=a;f[223022]=b;return}a=$Xc(28)|0;WXc(a);f[223023]=a;b=a;f[223022]=b;return}function BQa(){var a=0,b=0;a=f[223023]|0;if(a|0){b=a;return b|0}a=$Xc(28)|0;WXc(a);f[223023]=a;b=a;return b|0}function CQa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0;a=u;u=u+16|0;c=a;if((b[530544]|0)==0?X0c(530544)|0:0){b[1163515]=1;be(2242,1163515,x|0)|0};f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[396487]|0;b[c+1>>0]=b[396488]|0;b[c+2>>0]=b[396489]|0;b[c+3>>0]=b[396490]|0;b[c+4>>0]=b[396491]|0;b[c+5>>0]=0;tQa(c,1286);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[396493]|0;b[c+1>>0]=b[396494]|0;b[c+2>>0]=b[396495]|0;b[c+3>>0]=b[396496]|0;b[c+4>>0]=b[396497]|0;b[c+5>>0]=0;tQa(c,1287);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=6;b[c>>0]=b[428960]|0;b[c+1>>0]=b[428961]|0;b[c+2>>0]=b[428962]|0;b[c+3>>0]=b[428963]|0;b[c+4>>0]=b[428964]|0;b[c+5>>0]=b[428965]|0;b[c+6>>0]=0;tQa(c,1288);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[396499]|0;b[c+1>>0]=b[396500]|0;b[c+2>>0]=b[396501]|0;b[c+3>>0]=b[396502]|0;b[c+4>>0]=b[396503]|0;b[c+5>>0]=b[396504]|0;b[c+6>>0]=b[396505]|0;b[c+7>>0]=0;tQa(c,1289);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[396507]|0;b[c+1>>0]=b[396508]|0;b[c+2>>0]=b[396509]|0;b[c+3>>0]=b[396510]|0;b[c+4>>0]=b[396511]|0;b[c+5>>0]=b[396512]|0;b[c+6>>0]=b[396513]|0;b[c+7>>0]=0;tQa(c,1290);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=6;b[c>>0]=b[428823]|0;b[c+1>>0]=b[428824]|0;b[c+2>>0]=b[428825]|0;b[c+3>>0]=b[428826]|0;b[c+4>>0]=b[428827]|0;b[c+5>>0]=b[428828]|0;b[c+6>>0]=0;tQa(c,1291);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=6;b[c>>0]=b[396515]|0;b[c+1>>0]=b[396516]|0;b[c+2>>0]=b[396517]|0;b[c+3>>0]=b[396518]|0;b[c+4>>0]=b[396519]|0;b[c+5>>0]=b[396520]|0;b[c+6>>0]=0;tQa(c,1292);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=13;e=d;g=396522;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+13>>0]=0;tQa(c,1293);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=11;e=d;g=429163;h=e+11|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+11>>0]=0;tQa(c,1294);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=13;e=d;g=396536;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+13>>0]=0;tQa(c,1295);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[429057]|0;b[c+1>>0]=b[429058]|0;b[c+2>>0]=b[429059]|0;b[c+3>>0]=b[429060]|0;b[c+4>>0]=b[429061]|0;b[c+5>>0]=b[429062]|0;b[c+6>>0]=b[429063]|0;b[c+7>>0]=0;tQa(c,1296);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=c+11|0;b[d>>0]=10;e=c;g=396550;h=e+10|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[c+10>>0]=0;tQa(c,1296);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=12;e=d;g=396561;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+12>>0]=0;tQa(c,1296);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);d=c+4|0;f[d>>2]=0;f[d+4>>2]=0;d=c+11|0;b[d>>0]=3;b[c>>0]=b[396574]|0;b[c+1>>0]=b[396575]|0;b[c+2>>0]=b[396576]|0;b[c+3>>0]=0;tQa(c,1297);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=12;e=d;g=396578;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+12>>0]=0;tQa(c,1298);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[429025]|0;b[c+1>>0]=b[429026]|0;b[c+2>>0]=b[429027]|0;b[c+3>>0]=b[429028]|0;b[c+4>>0]=b[429029]|0;b[c+5>>0]=b[429030]|0;b[c+6>>0]=b[429031]|0;b[c+7>>0]=0;tQa(c,1299);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=c+4|0;f[d>>2]=0;f[d+4>>2]=0;d=c+11|0;b[d>>0]=3;b[c>>0]=b[396591]|0;b[c+1>>0]=b[396592]|0;b[c+2>>0]=b[396593]|0;b[c+3>>0]=0;tQa(c,1300);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=4;f[c>>2]=1431070034;b[c+4>>0]=0;tQa(c,1301);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[396595]|0;b[c+1>>0]=b[396596]|0;b[c+2>>0]=b[396597]|0;b[c+3>>0]=b[396598]|0;b[c+4>>0]=b[396599]|0;b[c+5>>0]=0;tQa(c,1302);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=13;e=d;g=396601;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+13>>0]=0;tQa(c,1303);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[396615]|0;b[c+1>>0]=b[396616]|0;b[c+2>>0]=b[396617]|0;b[c+3>>0]=b[396618]|0;b[c+4>>0]=b[396619]|0;b[c+5>>0]=0;tQa(c,1303);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[396621]|0;b[c+1>>0]=b[396622]|0;b[c+2>>0]=b[396623]|0;b[c+3>>0]=b[396624]|0;b[c+4>>0]=b[396625]|0;b[c+5>>0]=b[396626]|0;b[c+6>>0]=b[396627]|0;b[c+7>>0]=0;tQa(c,1304);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=4;f[c>>2]=1215193428;b[c+4>>0]=0;tQa(c,1305);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=c+4|0;f[d>>2]=0;f[d+4>>2]=0;d=c+11|0;b[d>>0]=3;b[c>>0]=b[396629]|0;b[c+1>>0]=b[396630]|0;b[c+2>>0]=b[396631]|0;b[c+3>>0]=0;tQa(c,1306);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=4;f[c>>2]=1280069186;b[c+4>>0]=0;tQa(c,1307);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=6;b[c>>0]=b[396633]|0;b[c+1>>0]=b[396634]|0;b[c+2>>0]=b[396635]|0;b[c+3>>0]=b[396636]|0;b[c+4>>0]=b[396637]|0;b[c+5>>0]=b[396638]|0;b[c+6>>0]=0;tQa(c,1308);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[439430]|0;b[c+1>>0]=b[439431]|0;b[c+2>>0]=b[439432]|0;b[c+3>>0]=b[439433]|0;b[c+4>>0]=b[439434]|0;b[c+5>>0]=0;tQa(c,1309);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=9;e=c;g=429107;h=e+9|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[c+9>>0]=0;tQa(c,1310);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=9;e=c;g=396640;h=e+9|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[c+9>>0]=0;tQa(c,1311);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[396650]|0;b[c+1>>0]=b[396651]|0;b[c+2>>0]=b[396652]|0;b[c+3>>0]=b[396653]|0;b[c+4>>0]=b[396654]|0;b[c+5>>0]=b[396655]|0;b[c+6>>0]=b[396656]|0;b[c+7>>0]=0;tQa(c,1312);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=8;i=c;f[i>>2]=1852138569;f[i+4>>2]=2037672308;b[c+8>>0]=0;tQa(c,1312);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[396658]|0;b[c+1>>0]=b[396659]|0;b[c+2>>0]=b[396660]|0;b[c+3>>0]=b[396661]|0;b[c+4>>0]=b[396662]|0;b[c+5>>0]=b[396663]|0;b[c+6>>0]=b[396664]|0;b[c+7>>0]=0;tQa(c,1312);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=4;f[c>>2]=1886351939;b[c+4>>0]=0;tQa(c,1313);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[428856]|0;b[c+1>>0]=b[428857]|0;b[c+2>>0]=b[428858]|0;b[c+3>>0]=b[428859]|0;b[c+4>>0]=b[428860]|0;b[c+5>>0]=b[428861]|0;b[c+6>>0]=b[428862]|0;b[c+7>>0]=0;tQa(c,1314);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[428903]|0;b[c+1>>0]=b[428904]|0;b[c+2>>0]=b[428905]|0;b[c+3>>0]=b[428906]|0;b[c+4>>0]=b[428907]|0;b[c+5>>0]=b[428908]|0;b[c+6>>0]=b[428909]|0;b[c+7>>0]=0;tQa(c,1315);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=14;e=d;g=396666;h=e+14|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+14>>0]=0;tQa(c,1316);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=8;i=c;f[i>>2]=1869181520;f[i+4>>2]=2020557426;b[c+8>>0]=0;tQa(c,1317);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=17;e=d;g=396681;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+17>>0]=0;tQa(c,1317);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[428933]|0;b[c+1>>0]=b[428934]|0;b[c+2>>0]=b[428935]|0;b[c+3>>0]=b[428936]|0;b[c+4>>0]=b[428937]|0;b[c+5>>0]=0;tQa(c,1318);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=6;b[c>>0]=b[428794]|0;b[c+1>>0]=b[428795]|0;b[c+2>>0]=b[428796]|0;b[c+3>>0]=b[428797]|0;b[c+4>>0]=b[428798]|0;b[c+5>>0]=b[428799]|0;b[c+6>>0]=0;tQa(c,1319);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=15;e=d;g=447224;h=e+15|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+15>>0]=0;tQa(c,1320);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=13;e=d;g=396699;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+13>>0]=0;tQa(c,1321);if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=9;e=c;g=396713;h=e+9|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[c+9>>0]=0;tQa(c,1321);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[396723]|0;b[c+1>>0]=b[396724]|0;b[c+2>>0]=b[396725]|0;b[c+3>>0]=b[396726]|0;b[c+4>>0]=b[396727]|0;b[c+5>>0]=0;tQa(c,1322);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c+8>>2]=0;d=c+11|0;b[d>>0]=7;b[c>>0]=b[396729]|0;b[c+1>>0]=b[396730]|0;b[c+2>>0]=b[396731]|0;b[c+3>>0]=b[396732]|0;b[c+4>>0]=b[396733]|0;b[c+5>>0]=b[396734]|0;b[c+6>>0]=b[396735]|0;b[c+7>>0]=0;tQa(c,1323);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=8;g=c;f[g>>2]=1886351952;f[g+4>>2]=1818325871;b[c+8>>0]=0;tQa(c,1324);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=5;b[c>>0]=b[446585]|0;b[c+1>>0]=b[446586]|0;b[c+2>>0]=b[446587]|0;b[c+3>>0]=b[446588]|0;b[c+4>>0]=b[446589]|0;b[c+5>>0]=0;tQa(c,1325);if((b[d>>0]|0)<0)cYc(f[c>>2]|0);f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;d=c+11|0;b[d>>0]=4;f[c>>2]=1297371980;b[c+4>>0]=0;tQa(c,1326);if((b[d>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function DQa(a){a=a|0;b[a>>0]=0;E_b();return}function EQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zCb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function FQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;eFb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function GQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;_vb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function HQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Hyb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function IQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Dxb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function JQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;qwb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function KQa(a,b){a=a|0;b=b|0;Dwb(a,b);return}function LQa(a,b){a=a|0;b=b|0;Rvb(a,b);return}function MQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;ADb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function NQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;cEb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function OQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Vzb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function PQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Uyb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function QQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;yvb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function RQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Ywb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function SQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Hzb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function TQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Urb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function UQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;lsb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function VQa(a,b){a=a|0;b=b|0;Mub(a,b);return}function WQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Xsb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function XQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Esb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function YQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;otb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function ZQa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;_tb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function _Qa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Htb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function $Qa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;rub(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function aRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;uAb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function bRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;hyb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function cRa(a,b){a=a|0;b=b|0;Zxb(a,b);return}function dRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;REb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function eRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;kxb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function fRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;iDb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function gRa(a,b){a=a|0;b=b|0;Nwb(a,b);return}function hRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;mzb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function iRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;syb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function jRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Oxb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function kRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;wBb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function lRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;MAb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function mRa(a,b){a=a|0;b=b|0;mBb(a,b);return}function nRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;TCb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function oRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;gvb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function pRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;YAb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function qRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;yEb(d,b);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return}function rRa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=82796;c=a+116|0;d=f[c>>2]|0;if(d|0?(f[a+104>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+100|0;i=f[c>>2]|0;if(i|0?(f[a+88>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=f[a+80>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+64>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+48>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+32>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+20|0;j=f[c>>2]|0;if(j|0?(f[a+8>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)cYc(f[e>>2]|0);cYc(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(k);f[c>>2]=0;return}function sRa(a){a=a|0;rRa(a);cYc(a);return}function tRa(a){a=a|0;a=$Xc(124)|0;BSa(a);return a|0}function uRa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(124)|0;BSa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15328,128);a=QXb(b,128)|0;CSa(a,b);c=a;return c|0}function vRa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function wRa(a){a=a|0;return f[a+4>>2]|0}function xRa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;f[a+40>>2]=0;f[a+56>>2]=0;f[a+72>>2]=0;c=a+92|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+100>>2]|0;e=0;do{oXa(f[g+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(d|0));f[c>>2]=0}c=a+108|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+116>>2]|0;g=0;do{wUa(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function yRa(a){a=a|0;return 1}function zRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+24|0;k=a+28|0;l=a+32|0;m=e+8|0;n=a+40|0;o=a+44|0;p=a+48|0;q=a+56|0;r=a+60|0;s=a+64|0;t=e+8|0;v=a+72|0;w=a+76|0;x=a+80|0;y=a+88|0;z=a+100|0;A=a+96|0;B=a+92|0;C=e+4|0;D=a+104|0;E=a+116|0;F=a+112|0;G=a+108|0;H=e+4|0;I=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){K=b[a>>0]|0;L=K&255;if(K<<24>>24>0){f[c>>2]=a+1;M=L;N=6}else{O=L;N=5}}else{O=0;N=5}if((N|0)==5){N=0;L=ZYb(c,O)|0;if((L+-1|0)>>>0<127){M=L;N=6}else P=L}b:do if((N|0)==6){N=0;switch(M>>>3&536870911|0){case 2:{if((M&255|0)!=18){P=M;break b}if(l$b(c,pHa(i)|0)|0)continue a;else{Q=0;N=130;break a}break}case 3:{switch((M&255)<<24>>24){case 26:break;case 24:{if(dUa(1,26,c,j)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(a=b[L>>0]|0,a<<24>>24>-1):0){f[c>>2]=L+1;R=a&255}else{a=YYb(c)|0;if((a|0)>-1)R=a;else{Q=0;N=130;break a}}a=HYb(c,R)|0;if((PYb(c)|0)>0)do{L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;S=K&255;T=0}else{LYb(e,c);K=e;if(!(b[m>>0]|0)){Q=0;N=130;break a}else{S=f[K>>2]|0;T=f[K+4>>2]|0}}K=f[j>>2]|0;if((K|0)==(f[k>>2]|0)){_Ma(j,K+1|0);U=f[j>>2]|0}else U=K;K=f[l>>2]|0;f[j>>2]=U+1;L=K+8+(U<<3)|0;f[L>>2]=S;f[L+4>>2]=T}while((PYb(c)|0)>0);IYb(c,a);continue a;break}case 4:{switch((M&255)<<24>>24){case 34:break;case 37:{if(eUa(1,34,c,n)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0?(K=b[L>>0]|0,K<<24>>24>-1):0){f[c>>2]=L+1;V=K&255}else{K=YYb(c)|0;if((K|0)>-1)V=K;else{Q=0;N=130;break a}}W=f[n>>2]|0;K=(V|0)/4|0;if((K<<2|0)!=(V|0)){Q=0;N=130;break a}L=RYb(c)|0;X=PYb(c)|0;if((((L|0)==-1|(X|0)<(L|0)?X:L)|0)>=(V|0)){L=W+K|0;if((f[n>>2]|0)<(L|0)?(uHa(n,L),X=f[n>>2]|0,Y=L-X|0,(Y<<2|0)>0):0)g1c((f[p>>2]|0)+((X<<2)+4)|0,0,(((Y|-1073741824|0)==-1073741824?1073741823:1073741822)+Y<<2)+8|0)|0;f[n>>2]=L;L=f[p>>2]|0;if(TYb(c,((L|0)==0?0:L+4|0)+(W<<2)|0,V)|0)continue a;else{N=36;break a}}if((V|0)>3)Z=0;else continue a;while(1){L=f[c>>2]|0;if(((f[g>>2]|0)-L|0)>3){Y=L;X=h[Y>>0]|h[Y+1>>0]<<8|h[Y+2>>0]<<16|h[Y+3>>0]<<24;f[e>>2]=X;f[c>>2]=L+4;_=X}else{if(!(WYb(c,e)|0)){N=45;break a}_=f[e>>2]|0}X=f[n>>2]|0;if((X|0)==(f[o>>2]|0)){uHa(n,X+1|0);$=f[n>>2]|0}else $=X;X=f[p>>2]|0;f[n>>2]=$+1;f[X+4+($<<2)>>2]=_;X=Z+1|0;if((X|0)<(K|0))Z=X;else continue a}break}case 5:{switch((M&255)<<24>>24){case 42:break;case 40:{if(fUa(1,42,c,q)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(a=b[K>>0]|0,a<<24>>24>-1):0){f[c>>2]=K+1;aa=a&255}else{a=YYb(c)|0;if((a|0)>-1)aa=a;else{Q=0;N=130;break a}}a=HYb(c,aa)|0;if((PYb(c)|0)>0)do{K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(X=b[K>>0]|0,X<<24>>24>-1):0){f[c>>2]=K+1;ba=X<<24>>24!=0}else{LYb(e,c);X=e;if(!(b[t>>0]|0)){Q=0;N=130;break a}else ba=(f[X>>2]|0)!=0|(f[X+4>>2]|0)!=0}X=f[q>>2]|0;if((X|0)==(f[r>>2]|0)){wSa(q,X+1|0);ca=f[q>>2]|0}else ca=X;X=f[s>>2]|0;f[q>>2]=ca+1;b[X+4+ca>>0]=ba&1}while((PYb(c)|0)>0);IYb(c,a);continue a;break}case 6:{switch((M&255)<<24>>24){case 50:break;case 48:{X=f[c>>2]|0;if(X>>>0<(f[g>>2]|0)>>>0){K=b[X>>0]|0;L=K&255;if(K<<24>>24>-1){f[c>>2]=X+1;da=L}else{ea=L;N=79}}else{ea=0;N=79}if((N|0)==79){N=0;L=KYb(c,ea)|0;X=J;if((X|0)>-1|(X|0)==-1&L>>>0>4294967295)da=L;else{Q=0;N=130;break a}}L=f[v>>2]|0;if((L|0)==(f[w>>2]|0)){qHa(v,L+1|0);fa=f[v>>2]|0}else fa=L;L=f[x>>2]|0;f[v>>2]=fa+1;f[L+4+(fa<<2)>>2]=da;continue a;break}default:{P=M;break b}}L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){X=b[L>>0]|0;K=X&255;if(X<<24>>24>-1){f[c>>2]=L+1;ga=K}else{ha=K;N=66}}else{ha=0;N=66}if((N|0)==66){N=0;K=KYb(c,ha)|0;L=J;if((L|0)>-1|(L|0)==-1&K>>>0>4294967295)ga=K;else{Q=0;N=130;break a}}K=HYb(c,ga)|0;if((PYb(c)|0)>0)do{L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){X=b[L>>0]|0;Y=X&255;if(X<<24>>24>-1){f[c>>2]=L+1;ia=Y}else{ja=Y;N=71}}else{ja=0;N=71}if((N|0)==71){N=0;Y=KYb(c,ja)|0;L=J;if((L|0)>-1|(L|0)==-1&Y>>>0>4294967295)ia=Y;else{Q=0;N=130;break a}}Y=f[v>>2]|0;if((Y|0)==(f[w>>2]|0)){qHa(v,Y+1|0);ka=f[v>>2]|0}else ka=Y;Y=f[x>>2]|0;f[v>>2]=ka+1;f[Y+4+(ka<<2)>>2]=ia}while((PYb(c)|0)>0);IYb(c,K);continue a;break}case 7:{if((M&255|0)!=58){P=M;break b}a=f[z>>2]|0;do if(a){Y=f[B>>2]|0;L=f[a>>2]|0;if((Y|0)>=(L|0))if((L|0)==(f[A>>2]|0)){la=L;N=89;break}else{ma=L;na=a;N=90;break}else{f[B>>2]=Y+1;oa=f[a+4+(Y<<2)>>2]|0;break}}else{la=f[A>>2]|0;N=89}while(0);if((N|0)==89){N=0;XZb(y,la+1|0);a=f[z>>2]|0;ma=f[a>>2]|0;na=a;N=90}if((N|0)==90){N=0;f[na>>2]=ma+1;a=f[y>>2]|0;if(!a){K=$Xc(32)|0;EXa(K);pa=K}else{if(f[a+64>>2]|0)SXb(a,15648,32);K=QXb(a,32)|0;FXa(K,a);pa=K}K=f[z>>2]|0;a=f[B>>2]|0;f[B>>2]=a+1;f[K+4+(a<<2)>>2]=pa;oa=pa}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(K=b[a>>0]|0,K<<24>>24>-1):0){f[c>>2]=a+1;qa=K&255}else{K=YYb(c)|0;if((K|0)>-1)qa=K;else{Q=0;N=130;break a}}JYb(e,c,qa);if((f[C>>2]|0)<0){N=102;break a}if(!(Mi[f[(f[oa>>2]|0)+44>>2]&1023](oa,c)|0)){N=102;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Q=0;N=130;break a}break}case 8:{if((M&255|0)!=66){P=M;break b}K=f[E>>2]|0;do if(K){a=f[G>>2]|0;Y=f[K>>2]|0;if((a|0)>=(Y|0))if((Y|0)==(f[F>>2]|0)){ra=Y;N=110;break}else{sa=Y;ta=K;N=111;break}else{f[G>>2]=a+1;ua=f[K+4+(a<<2)>>2]|0;break}}else{ra=f[F>>2]|0;N=110}while(0);if((N|0)==110){N=0;XZb(D,ra+1|0);K=f[E>>2]|0;sa=f[K>>2]|0;ta=K;N=111}if((N|0)==111){N=0;f[ta>>2]=sa+1;K=f[D>>2]|0;if(!K){a=$Xc(172)|0;PUa(a);va=a}else{if(f[K+64>>2]|0)SXb(K,15504,176);a=QXb(K,176)|0;QUa(a,K);va=a}a=f[E>>2]|0;K=f[G>>2]|0;f[G>>2]=K+1;f[a+4+(K<<2)>>2]=va;ua=va}K=f[c>>2]|0;if(K>>>0<(f[g>>2]|0)>>>0?(a=b[K>>0]|0,a<<24>>24>-1):0){f[c>>2]=K+1;wa=a&255}else{a=YYb(c)|0;if((a|0)>-1)wa=a;else{Q=0;N=130;break a}}JYb(e,c,wa);if((f[H>>2]|0)<0){N=123;break a}if(!(Mi[f[(f[ua>>2]|0)+44>>2]&1023](ua,c)|0)){N=123;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Q=0;N=130;break a}break}default:{P=M;break b}}}while(0);if(!P){Q=1;N=130;break}a=f[I>>2]|0;if(!(a&1))xa=lSa(I)|0;else xa=a&-2;if(!(Lqc(c,P,xa)|0)){Q=0;N=130;break}}if((N|0)==36){if((f[n>>2]|0)<=0){Q=0;u=d;return Q|0}f[n>>2]=W;Q=0;u=d;return Q|0}else if((N|0)==45){Q=0;u=d;return Q|0}else if((N|0)==102){Q=0;u=d;return Q|0}else if((N|0)==123){Q=0;u=d;return Q|0}else if((N|0)==130){u=d;return Q|0}return 0}function ARa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+20>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+24>>2]|0;if((e|0)>0){h=f[a+32>>2]|0;c=0;g=0;do{d=h+8+(g<<3)|0;j=t1c(f[d>>2]|1|0,f[d+4>>2]|0,1)|0;c=((((j^63)*9|0)+73|0)>>>6)+c|0;g=g+1|0}while((g|0)!=(e|0));if(c){if((c|0)<0)m=11;else m=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=c;o=m+l|0}else{n=0;o=l}}else{n=0;o=l}f[a+36>>2]=n;l=o+n|0;n=f[a+40>>2]<<2;if(!n)p=l;else{if((n|0)<0)q=11;else q=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=q+l|0}f[a+52>>2]=n;l=p+n|0;n=f[a+56>>2]|0;if(!n)r=l;else{if((n|0)<0)s=11;else s=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+l|0}f[a+68>>2]=n;l=r+n|0;n=f[a+72>>2]|0;if(n){r=f[a+80>>2]|0;s=0;p=0;do{q=f[r+4+(p<<2)>>2]|0;if((q|0)<0)t=10;else t=(((($(q|1|0)|0)^31)*9|0)+73|0)>>>6;s=t+s|0;p=p+1|0}while((p|0)!=(n|0));if(s){if((s|0)<0)u=11;else u=((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;v=s;w=u+l|0}else{v=0;w=l}}else{v=0;w=l}f[a+84>>2]=v;l=f[a+92>>2]|0;u=w+v+l|0;if(!l)x=u;else{v=a+100|0;w=0;s=u;while(1){u=f[(f[v>>2]|0)+4+(w<<2)>>2]|0;n=_i[f[(f[u>>2]|0)+48>>2]&2047](u)|0;u=n+s+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=w+1|0;if((w|0)==(l|0)){x=u;break}else s=u}}s=f[a+108>>2]|0;l=s+x|0;if(!s){y=l;z=a+120|0;f[z>>2]=y;return y|0}x=a+116|0;w=0;v=l;while(1){l=f[(f[x>>2]|0)+4+(w<<2)>>2]|0;u=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;l=u+v+((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=w+1|0;if((w|0)==(s|0)){y=l;break}else v=l}z=a+120|0;f[z>>2]=y;return y|0}function BRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=f[a+12>>2]|0;if((d|0)>0){e=a+20|0;g=0;do{g$b(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=a+24|0;if((f[d>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=26;f[e>>2]=(f[e>>2]|0)+1;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;h=e}else{eZb(c,26);h=f[g>>2]|0}e=f[a+36>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else eZb(c,e);e=f[d>>2]|0;if((e|0)>0){d=a+32|0;o=c+8|0;g=c+4|0;h=0;do{i=(f[d>>2]|0)+8+(h<<3)|0;n=f[i>>2]|0;k=f[i+4>>2]|0;if((f[o>>2]|0)>9){i=f[g>>2]|0;j=n&255;if(k>>>0>0|(k|0)==0&n>>>0>127){l=i;m=j;p=n;q=k;while(1){b[l>>0]=m|-128;r=p;p=l1c(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=i;v=j}b[u>>0]=v;q=u+1-i|0;f[g>>2]=(f[g>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else fZb(c,n,k);h=h+1|0}while((h|0)!=(e|0))}}e=a+40|0;if((f[e>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){o=c+4|0;b[f[o>>2]>>0]=34;f[o>>2]=(f[o>>2]|0)+1;o=(f[h>>2]|0)+-1|0;f[h>>2]=o;w=o}else{eZb(c,34);w=f[h>>2]|0}o=f[a+52>>2]|0;if((w|0)>4){w=c+4|0;g=f[w>>2]|0;if(o>>>0>127){u=o;v=g;while(1){b[v>>0]=u|128;d=u>>>7;q=v+1|0;if(u>>>0>16383){u=d;v=q}else{x=q;y=d;break}}}else{x=g;y=o}b[x>>0]=y;y=x+1-g|0;f[w>>2]=(f[w>>2]|0)+y;f[h>>2]=(f[h>>2]|0)-y}else eZb(c,o);o=f[a+48>>2]|0;P_b((o|0)==0?0:o+4|0,f[e>>2]|0,c)}e=a+56|0;if((f[e>>2]|0)>0){o=c+8|0;if((f[o>>2]|0)>4){y=c+4|0;b[f[y>>2]>>0]=42;f[y>>2]=(f[y>>2]|0)+1;y=(f[o>>2]|0)+-1|0;f[o>>2]=y;z=y}else{eZb(c,42);z=f[o>>2]|0}y=f[a+68>>2]|0;if((z|0)>4){z=c+4|0;h=f[z>>2]|0;if(y>>>0>127){w=y;g=h;while(1){b[g>>0]=w|128;x=w>>>7;v=g+1|0;if(w>>>0>16383){w=x;g=v}else{A=v;B=x;break}}}else{A=h;B=y}b[A>>0]=B;B=A+1-h|0;f[z>>2]=(f[z>>2]|0)+B;f[o>>2]=(f[o>>2]|0)-B}else eZb(c,y);y=f[a+64>>2]|0;R_b((y|0)==0?0:y+4|0,f[e>>2]|0,c)}e=a+72|0;if((f[e>>2]|0)>0){y=c+8|0;if((f[y>>2]|0)>4){B=c+4|0;b[f[B>>2]>>0]=50;f[B>>2]=(f[B>>2]|0)+1;B=(f[y>>2]|0)+-1|0;f[y>>2]=B;C=B}else{eZb(c,50);C=f[y>>2]|0}B=f[a+84>>2]|0;if((C|0)>4){C=c+4|0;o=f[C>>2]|0;if(B>>>0>127){z=B;h=o;while(1){b[h>>0]=z|128;A=z>>>7;g=h+1|0;if(z>>>0>16383){z=A;h=g}else{D=g;E=A;break}}}else{D=o;E=B}b[D>>0]=E;E=D+1-o|0;f[C>>2]=(f[C>>2]|0)+E;f[y>>2]=(f[y>>2]|0)-E}else eZb(c,B);B=f[e>>2]|0;if((B|0)>0){e=a+80|0;E=c+8|0;y=c+4|0;C=0;do{o=f[(f[e>>2]|0)+4+(C<<2)>>2]|0;D=((o|0)<0)<<31>>31;if((f[E>>2]|0)>9){h=f[y>>2]|0;z=o&255;if(o>>>0>127){A=h;g=z;w=o;x=D;while(1){b[A>>0]=g|-128;v=w;w=l1c(w|0,x|0,7)|0;u=A+1|0;d=w&255;if(!(x>>>0>0|(x|0)==0&v>>>0>16383)){F=u;G=d;break}else{A=u;g=d;x=J}}}else{F=h;G=z}b[F>>0]=G;x=F+1-h|0;f[y>>2]=(f[y>>2]|0)+x;f[E>>2]=(f[E>>2]|0)-x}else fZb(c,o,D);C=C+1|0}while((C|0)!=(B|0))}}B=f[a+92>>2]|0;if(B|0){C=a+100|0;E=0;do{k$b(7,f[(f[C>>2]|0)+4+(E<<2)>>2]|0,c);E=E+1|0}while((E|0)!=(B|0))}B=f[a+108>>2]|0;if(B|0){E=a+116|0;C=0;do{k$b(8,f[(f[E>>2]|0)+4+(C<<2)>>2]|0,c);C=C+1|0}while((C|0)!=(B|0))}B=f[a+4>>2]|0;if(!((B&1|0)!=0&(b[476924]|0)!=0))return;Oqc(B&-2,c);return}function CRa(a){a=a|0;return f[a+120>>2]|0}function DRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;e=f[a+12>>2]|0;if((e|0)>0){g=a+20|0;h=d;i=0;while(1){j=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[h>>0]=18;k=gZb(j,h+1|0)|0;i=i+1|0;if((i|0)==(e|0)){l=k;break}else h=k}}else l=d;d=a+24|0;if((f[d>>2]|0)>0){b[l>>0]=26;h=l+1|0;e=f[a+36>>2]|0;if(e>>>0>127){i=e;g=h;while(1){b[g>>0]=i|128;k=i>>>7;j=g+1|0;if(i>>>0>16383){i=k;g=j}else{m=j;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=f[d>>2]|0;d=f[a+32>>2]|0;e=0;h=m+1|0;while(1){m=d+8+(e<<3)|0;g=f[m>>2]|0;i=f[m+4>>2]|0;m=g&255;if(i>>>0>0|(i|0)==0&g>>>0>127){k=h;j=m;o=g;g=i;while(1){b[k>>0]=j|-128;i=o;o=l1c(o|0,g|0,7)|0;p=k+1|0;q=o&255;if(!(g>>>0>0|(g|0)==0&i>>>0>16383)){r=p;s=q;break}else{k=p;j=q;g=J}}}else{r=h;s=m}b[r>>0]=s;g=r+1|0;e=e+1|0;if((e|0)>=(n|0)){t=g;break}else h=g}}else t=l;l=a+40|0;if((f[l>>2]|0)>0){b[t>>0]=34;h=t+1|0;n=f[a+52>>2]|0;if(n>>>0>127){e=n;r=h;while(1){b[r>>0]=e|128;s=e>>>7;d=r+1|0;if(e>>>0>16383){e=s;r=d}else{u=d;v=s;break}}}else{u=h;v=n}b[u>>0]=v;v=u+1|0;u=f[l>>2]<<2;o1c(v|0,(f[a+48>>2]|0)+4|0,u|0)|0;w=v+u|0}else w=t;t=a+56|0;if((f[t>>2]|0)>0){b[w>>0]=42;u=w+1|0;v=f[a+68>>2]|0;if(v>>>0>127){l=v;n=u;while(1){b[n>>0]=l|128;h=l>>>7;r=n+1|0;if(l>>>0>16383){l=h;n=r}else{x=r;y=h;break}}}else{x=u;y=v}b[x>>0]=y;y=f[t>>2]|0;t=f[a+64>>2]|0;v=0;u=x+1|0;while(1){b[u>>0]=b[t+4+v>>0]|0;x=u+1|0;v=v+1|0;if((v|0)>=(y|0)){z=x;break}else u=x}}else z=w;w=a+72|0;if((f[w>>2]|0)>0){b[z>>0]=50;u=z+1|0;y=f[a+84>>2]|0;if(y>>>0>127){v=y;t=u;while(1){b[t>>0]=v|128;x=v>>>7;n=t+1|0;if(v>>>0>16383){v=x;t=n}else{A=n;B=x;break}}}else{A=u;B=y}b[A>>0]=B;B=f[w>>2]|0;w=f[a+80>>2]|0;y=0;u=A+1|0;while(1){A=f[w+4+(y<<2)>>2]|0;t=A&255;if(A>>>0>127){v=u;x=t;n=A;l=((A|0)<0)<<31>>31;while(1){b[v>>0]=x|-128;A=n;n=l1c(n|0,l|0,7)|0;h=v+1|0;r=n&255;if(!(l>>>0>0|(l|0)==0&A>>>0>16383)){C=h;D=r;break}else{v=h;x=r;l=J}}}else{C=u;D=t}b[C>>0]=D;l=C+1|0;y=y+1|0;if((y|0)>=(B|0)){E=l;break}else u=l}}else E=z;z=f[a+92>>2]|0;if(!z)F=E;else{u=a+100|0;B=0;y=E;while(1){E=f[(f[u>>2]|0)+4+(B<<2)>>2]|0;b[y>>0]=58;C=y+1|0;D=_i[f[(f[E>>2]|0)+60>>2]&2047](E)|0;if(D>>>0>127){w=D;l=C;while(1){b[l>>0]=w|128;x=w>>>7;v=l+1|0;if(w>>>0>16383){w=x;l=v}else{G=v;H=x;break}}}else{G=C;H=D}b[G>>0]=H;l=hj[f[(f[E>>2]|0)+64>>2]&511](E,c,G+1|0)|0;B=B+1|0;if((B|0)==(z|0)){F=l;break}else y=l}}y=f[a+108>>2]|0;if(!y)I=F;else{z=a+116|0;B=0;G=F;while(1){F=f[(f[z>>2]|0)+4+(B<<2)>>2]|0;b[G>>0]=66;H=G+1|0;u=_i[f[(f[F>>2]|0)+60>>2]&2047](F)|0;if(u>>>0>127){l=u;w=H;while(1){b[w>>0]=l|128;t=l>>>7;x=w+1|0;if(l>>>0>16383){l=t;w=x}else{K=x;L=t;break}}}else{K=H;L=u}b[K>>0]=L;w=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,K+1|0)|0;B=B+1|0;if((B|0)==(y|0)){I=w;break}else G=w}}G=f[a+4>>2]|0;if(!((G&1|0)!=0&(b[476924]|0)!=0)){M=I;return M|0}M=Pqc(G&-2,I)|0;return M|0}function ERa(a){a=a|0;return 0}function FRa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;xRa(a);c=kZc(b,21568,15328,0)|0;if(!c){Ooc(b,a);return}else{oSa(a,c);return}}function GRa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15328,0)|0;if(!c){Ooc(b,a);return}else{oSa(a,c);return}}function HRa(a,b){a=a|0;b=b|0;f[a+120>>2]=b;return}function IRa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;mi[f[(f[a>>2]|0)+96>>2]&2047](c,a);u=b;return f[c+4>>2]|0}function JRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223024]|0)!=2){f[d>>2]=165456;f[d+4>>2]=3;b[d+8>>0]=0;J_b(892096,d);a_b(d)}d=530832;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function KRa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223025]|0)!=2){f[c>>2]=165456;f[c+4>>2]=4;b[c+8>>0]=0;J_b(892100,c);a_b(c)}d=$Xc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=16;e=d;g=396737;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+16>>0]=0;ejc(c,82896,82944,82612,0,530832,0,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function LRa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223026]|0)!=2){f[c>>2]=165456;f[c+4>>2]=5;b[c+8>>0]=0;J_b(892104,c);a_b(c)}if((f[223027]|0)!=2){f[c>>2]=165456;f[c+4>>2]=6;b[c+8>>0]=0;J_b(892108,c);a_b(c)}n3b(396754,874);Boc(396737,2243);TUa();IXa();pUa();u=a;return}function MRa(){var a=0,b=0;d_b(3005001,3005e3,397629);WXb();HXa();SUa();f[132638]=82796;f[132648]=0;f[132649]=0;f[132650]=0;f[132652]=0;f[132653]=0;f[132654]=0;f[132656]=0;f[132657]=0;f[132658]=0;f[132639]=0;f[132640]=0;f[132641]=0;f[132642]=0;f[132643]=0;f[132644]=0;f[132645]=0;f[132646]=0;a=530640;b=a+36|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(b|0));C_b(530552);return}function NRa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,397629);WXb();HXa();SUa();if((f[223026]|0)!=2){f[c>>2]=165456;f[c+4>>2]=5;b[c+8>>0]=0;J_b(892104,c);a_b(c)}f[132670]=82968;f[132671]=0;f[132675]=0;f[132674]=0;C_b(530680);f[132691]=0;f[132689]=537368;f[132690]=0;f[132692]=0;f[132693]=0;f[132688]=83076;PRa(530776);C_b(530776);f[132676]=537368;c=530712;f[c>>2]=0;f[c+4>>2]=0;n[132680]=0.0;b[530724]=0;f[132682]=0;f[132683]=531248;f[132684]=530864;f[132685]=530552;f[132686]=530776;f[132687]=537368;f[132690]=530680;u=a;return}function ORa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223024]|0)!=2){f[c>>2]=165456;f[c+4>>2]=3;b[c+8>>0]=0;J_b(892096,c);a_b(c)}jjc(530832,4);u=a;return}function PRa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=83192;f[a+4>>2]=0;e=a+8|0;f[e>>2]=171580;f[a+12>>2]=0;f[a+16>>2]=0;w_b(a+20|0);f[a+24>>2]=0;f[e>>2]=83300;f[a+28>>2]=0;e=a+32|0;f[e>>2]=0;g=a+36|0;f[g>>2]=0;aJa(e);f[g>>2]=0;if((a|0)!=530776?(f[223027]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=6;b[d+8>>0]=0;J_b(892108,d);a_b(d)}f[a+44>>2]=537368;f[a+48>>2]=0;u=c;return}function QRa(a){a=a|0;f[a>>2]=83300;zIa(a+24|0);Ljc(a);return}function RRa(a){a=a|0;f[a>>2]=83300;zIa(a+24|0);Ljc(a);cYc(a);return}function SRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;lYc(g,OSa(c)|0);yIa(e,f[a+32>>2]|0,g,0);a=(f[e>>2]|0)!=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}cYc(f[g>>2]|0);u=d;return a|0}function TRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e+16|0;h=e;i=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;lYc(h,OSa(c)|0);yIa(g,f[i+8>>2]|0,h,0);c=f[g>>2]|0;if(!c){j=1;k=bJa(i,h)|0}else{j=0;k=(f[c+12>>2]|0)+16|0}f[d>>2]=k;if((b[h+11>>0]|0)>=0){u=e;return j|0}cYc(f[h>>2]|0);u=e;return j|0}function URa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;lYc(e,OSa(c)|0);c=(PSa(_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0,e)|0)!=0;if((b[e+11>>0]|0)>=0){u=d;return c|0}cYc(f[e>>2]|0);u=d;return c|0}function VRa(a,b,c){a=a|0;b=b|0;c=c|0;return (f[f[b>>2]>>2]|0)==(f[f[c>>2]>>2]|0)|0}function WRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=(_i[f[(f[a>>2]|0)+64>>2]&2047](a)|0)+8|0;d=f[c>>2]|0;c=f[d+12>>2]|0;e=f[d+4>>2]|0;a:do if(e>>>0>c>>>0){g=f[d+16>>2]|0;h=c;while(1){i=f[g+(h<<2)>>2]|0;if(i|0)break;j=h+1|0;if(j>>>0<e>>>0)h=j;else{k=0;l=j;break a}}if((i|0)==(f[g+((h^1)<<2)>>2]|0)){k=f[(f[i>>2]|0)+16>>2]|0;l=h;break}else{k=i;l=h;break}}else{k=0;l=c}while(0);c=f[b>>2]|0;f[c>>2]=k;f[c+4>>2]=d;f[c+8>>2]=l;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function XRa(a,b){a=a|0;b=b|0;_i[f[(f[a>>2]|0)+64>>2]&2047](a)|0;a=f[b>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function YRa(a){a=a|0;elc(a);return f[f[a+32>>2]>>2]|0}function ZRa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;d=f[a+8>>2]|0;if(!d)e=12;else{g=f[d+8>>2]<<2;h=d+12|0;d=f[h>>2]|0;if(!d)i=g;else{if((f[d>>2]|0)>0){j=0;k=g;l=d;while(1){d=f[l+4+(j<<2)>>2]|0;m=(_i[f[(f[d>>2]|0)+84>>2]&2047](d)|0)+k|0;j=j+1|0;l=f[h>>2]|0;if((j|0)>=(f[l>>2]|0)){n=m;break}else k=m}}else n=g;i=n+4|0}e=i+12|0}i=f[a+32>>2]|0;a=f[i+12>>2]|0;n=f[i+4>>2]|0;a:do if(n>>>0>a>>>0){g=f[i+16>>2]|0;k=a;while(1){o=f[g+(k<<2)>>2]|0;if(o|0)break;l=k+1|0;if(l>>>0<n>>>0)k=l;else{p=0;q=l;break a}}if((o|0)==(f[g+((k^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=k;break}else{p=o;q=k;break}}else{p=0;q=a}while(0);f[c>>2]=p;f[c+4>>2]=i;f[c+8>>2]=q;if(!p){r=e;u=b;return r|0}q=e;e=p;while(1){p=(f[e+12>>2]|0)+16|0;i=q+12+(_i[f[(f[p>>2]|0)+84>>2]&2047](p)|0)|0;UIa(c)|0;e=f[c>>2]|0;if(!e){r=i;break}else q=i}u=b;return r|0}function _Ra(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;b=u;u=u+16|0;c=b;d=a+8|0;e=f[d>>2]|0;if(!e){g=f[a+4>>2]|0;if(!g){h=$Xc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}else{if(f[g+64>>2]|0)SXb(g,15384,16);h=RXb(g,16,2244)|0;f[h>>2]=g;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}f[d>>2]=i;j=i}else j=e;e=j+4|0;i=f[e>>2]|0;if((i|0)>0){d=f[j+12>>2]|0;h=0;do{g=f[d+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[g>>2]|0)+28>>2]&4095](g)}while((h|0)!=(i|0));f[e>>2]=0}i=f[a+32>>2]|0;h=f[i+12>>2]|0;d=f[i+4>>2]|0;a:do if(d>>>0>h>>>0){g=f[i+16>>2]|0;k=h;while(1){l=f[g+(k<<2)>>2]|0;if(l|0)break;m=k+1|0;if(m>>>0<d>>>0)k=m;else{n=0;o=m;break a}}if((l|0)==(f[g+((k^1)<<2)>>2]|0)){n=f[(f[l>>2]|0)+16>>2]|0;o=k;break}else{n=l;o=k;break}}else{n=0;o=h}while(0);f[c>>2]=n;f[c+4>>2]=i;f[c+8>>2]=o;if(!n){u=b;return}n=a+4|0;a=j+12|0;o=j+8|0;do{i=Mi[f[(f[132688]|0)+16>>2]&1023](530752,f[n>>2]|0)|0;h=i+12|0;l=f[h>>2]|0;d=f[j>>2]|0;if(((d|0)==(l|0)?(m=f[a>>2]|0,(m|0)!=0):0)?(p=f[m>>2]|0,(p|0)<(f[o>>2]|0)):0){q=f[e>>2]|0;if((q|0)<(p|0)){r=m+4+(q<<2)|0;f[m+4+(p<<2)>>2]=f[r>>2];s=r}else s=m+4+(q<<2)|0;f[s>>2]=i;f[e>>2]=q+1;q=f[a>>2]|0;f[q>>2]=(f[q>>2]|0)+1}else HSa(j,i,l,d);d=f[(f[c>>2]|0)+12>>2]|0;l=i+16|0;f[l>>2]=f[l>>2]|1;q=i+4|0;m=f[q>>2]|0;if((m|0)==537368){xJa(q,f[h>>2]|0,537368);t=f[q>>2]|0}else t=m;oYc(t,d)|0;d=(f[(f[c>>2]|0)+12>>2]|0)+16|0;f[l>>2]=f[l>>2]|2;l=i+8|0;i=f[h>>2]|0;h=f[l>>2]|0;if(!h){if(!i){m=$Xc(24)|0;ISa(m);v=m}else{if(f[i+64>>2]|0)SXb(i,15400,24);m=QXb(i,24)|0;JSa(m,i);v=m}f[l>>2]=v;w=v}else w=h;if((d|0)!=(w|0)){jSa(w);h=f[w+4>>2]|0;if(h&1|0?(l=h&-2,f[l>>2]|0):0)sqc(l);kSa(w,d)}RIa(c)|0}while((f[c>>2]|0)!=0);u=b;return}function $Ra(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+32|0;c=b;d=a+24|0;e=f[a+8>>2]|0;if(!e){u_b(c,3,457044,306);r_b(b+24|0,p_b(c,457138)|0);v_b(c)}iSa(d);c=e+12|0;a=f[c>>2]|0;g=e+4|0;if(!(f[g>>2]|0)){u=b;return}e=(a|0)==0?0:a+4|0;do{a=f[e>>2]|0;h=_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0;a=f[e>>2]|0;i=bJa(d,_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0)|0;if((h|0)!=(i|0)){jSa(i);a=f[i+4>>2]|0;if(a&1|0?(j=a&-2,f[j>>2]|0):0)sqc(j);kSa(i,h)}e=e+4|0;h=f[c>>2]|0}while((e|0)!=(((h|0)==0?0:h+4|0)+(f[g>>2]<<2)|0));u=b;return}function aSa(a,b){a=a|0;b=b|0;a=$Xc(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[b>>2]=a;return}function bSa(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(!a)return;cYc(a);return}function cSa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=f[d>>2]|0;g=f[c>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];e=c+8|0;g=hSa(d+8|0)|0;h=c+16|0;i=f[h>>2]|0;if((i|0)!=(g|0)){if((i|0)==9?(i=f[e>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}f[h>>2]=g;if((g|0)==9){g=$Xc(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=g}}f[c+28>>2]=f[d+28>>2];mi[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function dSa(a,b){a=a|0;b=b|0;RIa(f[b>>2]|0)|0;mi[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function eSa(a){a=a|0;elc(a);return a+24|0}function fSa(a){a=a|0;elc(a);dlc(a);return a+24|0}function gSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=b+8|0;d=a+12|0;a=f[d>>2]|0;e=b+16|0;if((f[e>>2]|0)==9)g=f[c>>2]|0;else{f[e>>2]=9;e=$Xc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[c>>2]=e;g=e}oYc(g,a)|0;f[b+24>>2]=(f[d>>2]|0)+16;return}function hSa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+32|0;c=b;d=a+8|0;a=f[d>>2]|0;if(a|0){e=a;u=b;return e|0}u_b(c,3,501750,372);r_b(b+24|0,p_b(p_b(p_b(c,501867)|0,397714)|0,397755)|0);v_b(c);e=f[d>>2]|0;u=b;return e|0}function iSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+48|0;d=c+28|0;e=c+16|0;g=c;h=a+8|0;i=f[h>>2]|0;j=f[i+12>>2]|0;k=f[i+4>>2]|0;if(k>>>0<=j>>>0){u=c;return}l=f[i+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;j=m+1|0;if(j>>>0<k>>>0)m=j;else{o=16;break}}if((o|0)==16){u=c;return}if((n|0)==(f[l+((m^1)<<2)>>2]|0))p=f[(f[n>>2]|0)+16>>2]|0;else p=n;if(!p){u=c;return}n=g+4|0;l=g+8|0;o=p;p=i;i=m;while(1){f[g>>2]=o;f[n>>2]=p;f[l>>2]=i;if((f[a>>2]|0)==0?(m=f[o+12>>2]|0,m|0):0){ESa(m+16|0);if((b[m+11>>0]|0)<0)cYc(f[m>>2]|0);cYc(m)};f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];UIa(g)|0;m=f[h>>2]|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];VIa(m,d);o=f[g>>2]|0;if(!o)break;else{p=f[n>>2]|0;i=f[l>>2]|0}}u=c;return}function jSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+20|0;switch(f[c>>2]|0){case 2:{d=f[a+4>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if((g|0)==0?(g=f[a+8>>2]|0,!((g|0)==537368|(g|0)==0)):0){if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);cYc(g)}break}case 9:{g=f[a+4>>2]|0;e=g&-2;if(!(g&1))h=e;else h=f[e+4>>2]|0;if((h|0)==0?(h=f[a+8>>2]|0,!((h|0)==537368|(h|0)==0)):0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}break}case 10:{h=f[a+4>>2]|0;e=h&-2;if(!(h&1))i=e;else i=f[e+4>>2]|0;if((i|0)==0?(i=f[a+8>>2]|0,i|0):0)Yi[f[(f[i>>2]|0)+4>>2]&4095](i);break}case 1:{i=f[a+4>>2]|0;e=i&-2;if(!(i&1))j=e;else j=f[e+4>>2]|0;if((j|0)==0?(j=f[a+8>>2]|0,j|0):0)Yi[f[(f[j>>2]|0)+4>>2]&4095](j);break}case 8:{j=f[a+4>>2]|0;e=j&-2;if(!(j&1))k=e;else k=f[e+4>>2]|0;if((k|0)==0?(k=f[a+8>>2]|0,k|0):0)Yi[f[(f[k>>2]|0)+4>>2]&4095](k);break}case 7:{k=f[a+4>>2]|0;e=k&-2;if(!(k&1))l=e;else l=f[e+4>>2]|0;if((l|0)==0?(l=f[a+8>>2]|0,l|0):0)Yi[f[(f[l>>2]|0)+4>>2]&4095](l);break}default:{}}f[c>>2]=0;return}function kSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=c+20|0;do switch(f[e>>2]|0){case 2:{h=f[c+8>>2]|0;g=a+20|0;if((f[g>>2]|0)==2)i=a+8|0;else{jSa(a);f[g>>2]=2;g=a+8|0;f[g>>2]=537368;i=g}g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[i>>2]|0;if((j|0)==537368){xJa(i,k,h);return}else{oYc(j,h)|0;return}break}case 3:{h=c+8|0;j=f[h>>2]|0;g=f[h+4>>2]|0;h=a+20|0;if((f[h>>2]|0)!=3){jSa(a);f[h>>2]=3}h=a+8|0;f[h>>2]=j;f[h+4>>2]=g;return}case 4:{g=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)!=4){jSa(a);f[h>>2]=4}f[a+8>>2]=g;return}case 5:{g=b[c+8>>0]|0;h=a+20|0;if((f[h>>2]|0)!=5){jSa(a);f[h>>2]=5}b[a+8>>0]=g;return}case 6:{g=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)!=6){jSa(a);f[h>>2]=6}f[a+8>>2]=g;return}case 7:{JXa(mSa(a)|0,(f[e>>2]|0)==7?f[c+8>>2]|0:531248);return}case 8:{LUa(vJa(a)|0,(f[e>>2]|0)==8?f[c+8>>2]|0:530864);return}case 1:{oSa(nSa(a)|0,(f[e>>2]|0)==1?f[c+8>>2]|0:530552);return}case 10:{qSa(pSa(a)|0,(f[e>>2]|0)==10?f[c+8>>2]|0:530776);return}case 9:{g=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)==9)l=a+8|0;else{jSa(a);f[h>>2]=9;h=a+8|0;f[h>>2]=537368;l=h}h=f[d>>2]|0;j=h&-2;if(!(h&1))m=j;else m=f[j+4>>2]|0;j=f[l>>2]|0;if((j|0)==537368){xJa(l,m,g);return}else{oYc(j,g)|0;return}break}default:return}while(0)}function lSa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(8)|0;b=c;f[b>>2]=0;f[b+4>>2]=0;e=c}else{if(f[d+64>>2]|0)SXb(d,15376,8);c=RXb(d,8,2245)|0;b=c;f[b>>2]=0;f[b+4>>2]=0;e=c}f[e>>2]=0;f[a>>2]=e|1;f[e+4>>2]=d;return e|0}function mSa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==7){c=f[a+8>>2]|0;return c|0}jSa(a);f[b>>2]=7;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=$Xc(32)|0;EXa(d);g=d}else{if(f[e+64>>2]|0)SXb(e,15648,32);d=QXb(e,32)|0;FXa(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function nSa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==1){c=f[a+8>>2]|0;return c|0}jSa(a);f[b>>2]=1;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=$Xc(124)|0;BSa(d);g=d}else{if(f[e+64>>2]|0)SXb(e,15328,128);d=QXb(e,128)|0;CSa(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function oSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}vSa(a+8|0,b+8|0);d=a+24|0;g=b+24|0;e=f[g>>2]|0;if(e|0){_Ma(d,(f[d>>2]|0)+e|0);o1c((f[a+32>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+32>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+40|0;d=b+40|0;e=f[d>>2]|0;if(e|0){uHa(g,(f[g>>2]|0)+e|0);o1c((f[a+48>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+48>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+56|0;g=b+56|0;e=f[g>>2]|0;if(e|0){wSa(d,(f[d>>2]|0)+e|0);o1c((f[d>>2]|0)+((f[a+64>>2]|0)+4)|0,(f[b+64>>2]|0)+4|0,f[g>>2]|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+72|0;d=b+72|0;e=f[d>>2]|0;if(!e){h=a+88|0;i=b+88|0;xSa(h,i);j=a+104|0;k=b+104|0;ySa(j,k);return}qHa(g,(f[g>>2]|0)+e|0);o1c((f[a+80>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+80>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0);h=a+88|0;i=b+88|0;xSa(h,i);j=a+104|0;k=b+104|0;ySa(j,k);return}function pSa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;if((f[b>>2]|0)==10){c=f[a+8>>2]|0;return c|0}jSa(a);f[b>>2]=10;b=f[a+4>>2]|0;d=b&-2;if(!(b&1))e=d;else e=f[d+4>>2]|0;if(!e){d=$Xc(52)|0;PRa(d);g=d}else{if(f[e+64>>2]|0)SXb(e,15360,56);d=QXb(e,56)|0;sSa(d,e);g=d}f[a+8>>2]=g;c=g;return c|0}function qSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=a+8|0;elc(e);elc(c+8|0);rSa(a+28|0,c+28|0);dlc(e);e=f[c+44>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)i=f[e+4>>2]|0;else i=c&255;if(!i)return;i=a+44|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))j=d;else j=f[d+4>>2]|0;d=f[i>>2]|0;if((d|0)==537368){xJa(i,j,e);return}else{oYc(d,e)|0;return}}function rSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;e=f[b+12>>2]|0;b=f[e+12>>2]|0;g=f[e+4>>2]|0;a:do if(g>>>0>b>>>0){h=f[e+16>>2]|0;i=b;while(1){j=f[h+(i<<2)>>2]|0;if(j|0)break;k=i+1|0;if(k>>>0<g>>>0)i=k;else{l=0;m=k;break a}}if((j|0)==(f[h+((i^1)<<2)>>2]|0)){l=f[(f[j>>2]|0)+16>>2]|0;m=i;break}else{l=j;m=i;break}}else{l=0;m=b}while(0);f[d>>2]=l;f[d+4>>2]=e;f[d+8>>2]=m;if(!l){u=c;return}m=a+4|0;a=l;do{l=f[a+12>>2]|0;e=l+16|0;b=bJa(m,l)|0;if((e|0)!=(b|0)){jSa(b);l=f[b+4>>2]|0;if(l&1|0?(j=l&-2,f[j>>2]|0):0)sqc(j);kSa(b,e)}RIa(d)|0;a=f[d>>2]|0}while((a|0)!=0);u=c;return}function sSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;f[a>>2]=83192;f[a+4>>2]=c;g=a+8|0;f[g>>2]=171580;f[a+12>>2]=c;f[a+16>>2]=0;h=a+20|0;w_b(h);f[a+24>>2]=0;tSa(c,h);f[g>>2]=83300;f[a+28>>2]=c;g=a+32|0;f[g>>2]=c;c=a+36|0;f[c>>2]=0;aJa(g);f[c>>2]=0;if((f[223027]|0)==2){i=a+44|0;f[i>>2]=537368;j=a+48|0;f[j>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=6;b[e+8>>0]=0;J_b(892108,e);a_b(e);i=a+44|0;f[i>>2]=537368;j=a+48|0;f[j>>2]=0;u=d;return}function tSa(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2246);return}function uSa(a){a=a|0;x_b(a);return}function vSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{oYc(f[b+(i<<2)>>2]|0,f[d+4+(i<<2)>>2]|0)|0;i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;oYc(l,k)|0;f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)==(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,4984,16);l=RXb(i,16,2233)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;oYc(l,j)|0;f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function wSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+4|0;d=f[c>>2]|0;if((d|0)>=(b|0))return;e=a+8|0;g=f[e>>2]|0;h=(g|0)==0;if(!h){i=f[g>>2]|0;j=d<<1;k=(j|0)<(b|0)?b:j;j=(k|0)>4?k:4;if(!i){l=j;m=5}else{k=j+11&-8;if(f[i+64>>2]|0)SXb(i,25456,k);n=QXb(i,k)|0;o=i;p=j}}else{j=d<<1;d=(j|0)<(b|0)?b:j;l=(d|0)>4?d:4;m=5}if((m|0)==5){n=$Xc(l+4|0)|0;o=0;p=l}f[e>>2]=n;f[n>>2]=o;f[c>>2]=p;p=f[a>>2]|0;if((p|0)>0)o1c(n+4|0,g+4|0,p|0)|0;if(h)return;if(f[g>>2]|0)return;cYc(g);return}function xSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{ASa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(32)|0;EXa(l);ASa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15648,32);l=QXb(i,32)|0;FXa(l,i);ASa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function ySa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{zSa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(172)|0;PUa(l);zSa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15504,176);l=QXb(i,176)|0;QUa(l,i);zSa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function zSa(a,b){a=a|0;b=b|0;LUa(b,a);return}function ASa(a,b){a=a|0;b=b|0;JXa(b,a);return}function BSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=82796;e=a+4|0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;g=a+88|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;if((a|0)==530552){h=a+120|0;f[h>>2]=0;u=c;return}if((f[223026]|0)==2){h=a+120|0;f[h>>2]=0;u=c;return}f[d>>2]=165456;f[d+4>>2]=5;b[d+8>>0]=0;J_b(892104,d);a_b(d);h=a+120|0;f[h>>2]=0;u=c;return}function CSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[a>>2]=82796;f[a+4>>2]=c;f[a+8>>2]=c;g=a+12|0;h=a+32|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;if(!c){f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0}else{if(f[c+64>>2]|0)SXb(c,25456,8);g=QXb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+40>>2]=0;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+56>>2]=0;f[a+60>>2]=0;h=a+64|0;f[h>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);g=QXb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+72>>2]=0;f[a+76>>2]=0;g=a+80|0;f[g>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c}f[a+88>>2]=c;f[a+92>>2]=0;f[a+96>>2]=0;f[a+100>>2]=0;f[a+104>>2]=c;f[a+108>>2]=0;f[a+112>>2]=0;f[a+116>>2]=0;if((f[223026]|0)==2){i=a+120|0;f[i>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=5;b[e+8>>0]=0;J_b(892104,e);a_b(e);i=a+120|0;f[i>>2]=0;u=d;return}function DSa(a){a=a|0;if(!(f[a>>2]|0))return;sqc(a);return}function ESa(a){a=a|0;var b=0,c=0;f[a>>2]=82968;if(f[a+20>>2]|0)jSa(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function FSa(a){a=a|0;var b=0,c=0;b=f[a>>2]|0;if(!(b&1)){f[a>>2]=0;return}c=b&-2;b=c;if((f[b+4>>2]|0)!=0|(c|0)==0){f[a>>2]=0;return}if(f[b>>2]|0)sqc(b);cYc(c);f[a>>2]=0;return}function GSa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function HSa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){if(!d){e=$Xc(24)|0;f[e+12>>2]=0;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)SXb(d,15416,24);e=QXb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=83076;LSa(b,g);if((b|0)==0|(c|0)!=0)i=g;else{Yi[f[(f[b>>2]|0)+4>>2]&4095](b);i=g}}else i=b;else{KSa(d,b);i=b}b=a+12|0;d=f[b>>2]|0;g=f[a+8>>2]|0;c=a+4|0;if(d|0?(e=f[c>>2]|0,(e|0)!=(g|0)):0){h=f[d>>2]|0;if((h|0)==(g|0)){j=f[d+4+(e<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}Yi[f[(f[j>>2]|0)+4>>2]&4095](j);k=f[b>>2]|0;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}else{if((e|0)<(h|0)){f[d+4+(h<<2)>>2]=f[d+4+(e<<2)>>2];e=f[b>>2]|0;o=e;p=f[e>>2]|0}else{o=d;p=h}f[o>>2]=p+1;k=o;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}}XZb(a,g+1|0);g=f[b>>2]|0;f[g>>2]=(f[g>>2]|0)+1;k=g;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}function ISa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=82968;f[a+4>>2]=0;if((a|0)!=530680?(f[223027]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=6;b[d+8>>0]=0;J_b(892108,d);a_b(d)}f[a+20>>2]=0;f[a+16>>2]=0;u=c;return}function JSa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=82968;f[a+4>>2]=c;if((f[223027]|0)!=2){f[e>>2]=165456;f[e+4>>2]=6;b[e+8>>0]=0;J_b(892108,e);a_b(e)}f[a+20>>2]=0;f[a+16>>2]=0;u=d;return}function KSa(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function LSa(a,b){a=a|0;b=b|0;MSa(b,a);return}function MSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+16|0;d=f[c>>2]|0;if(!d)return;if(!(d&1))e=d;else{d=a+4|0;g=a+12|0;if((f[d>>2]|0)==537368)xJa(d,f[g>>2]|0,537368);h=_i[f[(f[b>>2]|0)+100>>2]&2047](b)|0;i=f[d>>2]|0;if((i|0)==537368)xJa(d,f[g>>2]|0,h);else oYc(i,h)|0;h=a+16|0;f[h>>2]=f[h>>2]|1;e=f[c>>2]|0}if(!(e&2))return;e=a+8|0;c=f[a+12>>2]|0;if(!(f[e>>2]|0)){if(!c){h=$Xc(24)|0;ISa(h);j=h}else{if(f[c+64>>2]|0)SXb(c,15400,24);h=QXb(c,24)|0;JSa(h,c);j=h}f[e>>2]=j}j=_i[f[(f[b>>2]|0)+104>>2]&2047](b)|0;kSa(f[e>>2]|0,j);j=a+16|0;f[j>>2]=f[j>>2]|2;return}function NSa(a){a=a|0;if(!a)return;Yi[f[(f[a>>2]|0)+4>>2]&4095](a);return}function OSa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((hSa(a)|0)==9){d=f[a>>2]|0;u=b;return d|0}u_b(c,3,501750,432);e=p_b(p_b(p_b(p_b(c,501867)|0,398596)|0,501922)|0,501944)|0;g=p_b(p_b(p_b(e,f[41458]|0)|0,505563)|0,501958)|0;e=165796+((hSa(a)|0)<<2)|0;r_b(b+24|0,p_b(g,f[e>>2]|0)|0);v_b(c);d=f[a>>2]|0;u=b;return d|0}function PSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=a+8|0;yIa(e,f[i>>2]|0,c,0);c=f[e>>2]|0;j=f[e+4>>2]|0;k=f[e+8>>2]|0;if(!c){l=0;u=d;return l|0}f[h>>2]=c;f[h+4>>2]=j;f[h+8>>2]=k;if((f[a>>2]|0)==0?(a=f[c+12>>2]|0,a|0):0){ESa(a+16|0);if((b[a+11>>0]|0)<0)cYc(f[a>>2]|0);cYc(a)};f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];UIa(h)|0;h=f[i>>2]|0;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];VIa(h,e);l=1;u=d;return l|0}function QSa(a){a=a|0;var c=0,d=0;f[a>>2]=83192;c=f[a+44>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+8|0;f[c>>2]=83300;zIa(a+32|0);Ljc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function RSa(a){a=a|0;QSa(a);cYc(a);return}function SSa(a){a=a|0;a=$Xc(52)|0;PRa(a);return a|0}function TSa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(52)|0;PRa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15360,56);a=QXb(b,56)|0;sSa(a,b);c=a;return c|0}function USa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function VSa(a){a=a|0;return f[a+4>>2]|0}function WSa(a){a=a|0;var c=0,d=0;c=a+8|0;elc(c);iSa(a+32|0);dlc(c);c=a+4|0;d=f[a+44>>2]|0;do if((d|0)!=537368){a=d+11|0;if((b[a>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[a>>0]=0;break}}while(0);d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;sqc(c);return}function XSa(a){a=a|0;return 1}function YSa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=a+44|0;j=a+4|0;k=a+44|0;l=a+8|0;a=g+4|0;m=g+8|0;n=g+24|0;o=e+4|0;p=m+11|0;q=g+12|0;a:while(1){r=f[c>>2]|0;if(r>>>0<(f[h>>2]|0)>>>0){s=b[r>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=r+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=ZYb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}t=f[j>>2]|0;r=t&-2;if(!(t&1))z=r;else z=f[r+4>>2]|0;r=f[i>>2]|0;if((r|0)==537368){xJa(i,z,537368);A=f[i>>2]|0}else A=r;if(!(l$b(c,A)|0)){B=0;w=39;break a}r=f[k>>2]|0;t=b[r+11>>0]|0;if(t<<24>>24<0){C=f[r>>2]|0;D=f[r+4>>2]|0}else{C=r;D=t&255}if(m$b(C,D,0,398986)|0)continue a;else{B=0;w=39;break a}break}case 2:break;default:{y=v;break b}}if((v&255|0)==18){f[g>>2]=l;t=_i[f[(f[l>>2]|0)+68>>2]&2047](l)|0;f[a>>2]=t;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[n>>2]=0;t=f[c>>2]|0;if(t>>>0<(f[h>>2]|0)>>>0?(r=b[t>>0]|0,r<<24>>24>-1):0){f[c>>2]=t+1;E=r&255;w=23}else{r=YYb(c)|0;if((r|0)>-1){E=r;w=23}else F=6}do if((w|0)==23){w=0;JYb(e,c,E);if((f[o>>2]|0)>=0?MTa(g,c)|0:0){if(!(OYb(c,f[e>>2]|0)|0)){F=6;break}r=b[p>>0]|0;t=r<<24>>24<0;s=m$b(t?f[m>>2]|0:m,t?f[q>>2]|0:r&255,0,399022)|0;F=s?0:6;break}F=6}while(0);s=f[n>>2]|0;if(s|0)Yi[f[(f[s>>2]|0)+4>>2]&4095](s);if((b[p>>0]|0)<0)cYc(f[m>>2]|0);switch(F&7){case 0:{continue a;break}case 6:{B=0;w=39;break a;break}default:{w=38;break a}}}else y=v}while(0);if(!y){w=38;break}s=f[j>>2]|0;if(!(s&1))G=lSa(j)|0;else G=s&-2;if(!(Lqc(c,y,G)|0)){B=0;w=39;break}}if((w|0)==38){B=1;u=d;return B|0}else if((w|0)==39){u=d;return B|0}return 0}function ZSa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;if((e&1|0)!=0&(b[476924]|0)!=0)g=Rqc(e&-2)|0;else g=0;e=a+8|0;elc(e);h=a+40|0;i=f[f[h>>2]>>2]|0;elc(e);j=i+g|0;g=f[h>>2]|0;h=f[g+12>>2]|0;i=f[g+4>>2]|0;a:do if(i>>>0>h>>>0){k=f[g+16>>2]|0;l=h;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<i>>>0)l=n;else{o=0;p=n;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){o=f[(f[m>>2]|0)+16>>2]|0;p=l;break}else{o=m;p=l;break}}else{o=0;p=h}while(0);f[d>>2]=o;f[d+4>>2]=g;f[d+8>>2]=p;p=a+28|0;g=j;j=0;while(1){elc(e);o=f[d>>2]|0;if(!o)break;if(!j){q=0;r=o}else{o=(_i[f[(f[j>>2]|0)+20>>2]&2047](j)|0)==0;q=o?j:0;r=f[d>>2]|0}o=f[r+12>>2]|0;h=o+16|0;m=f[p>>2]|0;if(!m){i=$Xc(32)|0;f[i+12>>2]=0;f[i+4>>2]=537368;f[i+8>>2]=0;f[i+20>>2]=0;s=i}else{if(f[m+64>>2]|0)SXb(m,15488,32);i=QXb(m,32)|0;n=m;f[i+12>>2]=n;f[i+4>>2]=537368;f[i+8>>2]=0;f[i+20>>2]=n;s=i}f[s>>2]=83384;f[s+24>>2]=o;f[s+28>>2]=h;f[s+16>>2]=3;if((q|0)!=(s|0))if(!q)t=s;else{Yi[f[(f[q>>2]|0)+4>>2]&4095](q);t=s}else t=q;h=t+16|0;o=f[h>>2]|0;if(!(o&1)){v=0;w=o}else{o=_i[f[(f[t>>2]|0)+100>>2]&2047](t)|0;i=b[o+11>>0]|0;n=i<<24>>24<0?f[o+4>>2]|0:i&255;i=n+1+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=i;w=f[h>>2]|0}if(!(w&2))x=0;else{h=ATa(_i[f[(f[t>>2]|0)+104>>2]&2047](t)|0)|0;x=h+1+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=x+v|0;i=h+g+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;RIa(d)|0;g=i;j=t}if(j|0?(_i[f[(f[j>>2]|0)+20>>2]&2047](j)|0)==0:0)Yi[f[(f[j>>2]|0)+4>>2]&4095](j);j=f[a+44>>2]|0;t=b[j+11>>0]|0;d=t<<24>>24<0;if(d)y=f[j+4>>2]|0;else y=t&255;if(!y){z=g;A=a+48|0;f[A>>2]=z;u=c;return z|0}y=d?f[j+4>>2]|0:t&255;z=g+1+y+((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;A=a+48|0;f[A>>2]=z;u=c;return z|0}function _Sa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=a+44|0;h=f[g>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;if(j)k=f[h+4>>2]|0;else k=i&255;if(k|0){if(j){l=f[h>>2]|0;m=f[h+4>>2]|0}else{l=h;m=i&255}m$b(l,m,1,398986)|0;f$b(1,f[g>>2]|0,c)}g=a+8|0;elc(g);m=a+40|0;do if(f[f[m>>2]>>2]|0){if(!(b[c+18>>0]|0)){if(f[223514]|0)n=13}else if(b[c+19>>0]|0)n=13;if((n|0)==13?(elc(g),(f[f[m>>2]>>2]|0)>>>0>1):0){elc(g);l=f[f[m>>2]>>2]|0;i=bYc(l>>>0>1073741823?-1:l<<2)|0;elc(g);l=f[m>>2]|0;h=f[l+12>>2]|0;j=f[l+4>>2]|0;a:do if(j>>>0>h>>>0){k=f[l+16>>2]|0;o=h;while(1){p=f[k+(o<<2)>>2]|0;if(p|0)break;q=o+1|0;if(q>>>0<j>>>0)o=q;else{r=0;s=q;break a}}if((p|0)==(f[k+((o^1)<<2)>>2]|0)){r=f[(f[p>>2]|0)+16>>2]|0;s=o;break}else{r=p;s=o;break}}else{r=0;s=h}while(0);f[e>>2]=r;f[e+4>>2]=l;f[e+8>>2]=s;h=0;while(1){elc(g);j=f[e>>2]|0;if(!j)break;f[i+(h<<2)>>2]=f[j+12>>2];RIa(e)|0;h=h+1|0}fTa(i,i+(h<<2)|0,e);if(h|0){l=a+28|0;j=0;q=0;do{t=i+(j<<2)|0;v=f[t>>2]|0;w=v+16|0;x=f[l>>2]|0;if(!x){y=$Xc(32)|0;f[y+12>>2]=0;f[y+4>>2]=537368;f[y+8>>2]=0;f[y+20>>2]=0;z=y}else{if(f[x+64>>2]|0)SXb(x,15488,32);y=QXb(x,32)|0;A=x;f[y+12>>2]=A;f[y+4>>2]=537368;f[y+8>>2]=0;f[y+20>>2]=A;z=y}f[z>>2]=83384;f[z+24>>2]=v;f[z+28>>2]=w;f[z+16>>2]=3;if((q|0)!=(z|0))if(!q)B=z;else{Yi[f[(f[q>>2]|0)+4>>2]&4095](q);B=z}else B=q;k$b(2,B,c);w=(_i[f[(f[B>>2]|0)+20>>2]&2047](B)|0)==0;q=w?B:0;w=f[t>>2]|0;t=b[w+11>>0]|0;if(t<<24>>24<0){C=f[w>>2]|0;D=f[w+4>>2]|0}else{C=w;D=t&255}m$b(C,D,1,399022)|0;j=j+1|0}while(j>>>0<h>>>0);if(q|0)Yi[f[(f[q>>2]|0)+4>>2]&4095](q)}dYc(i);break}elc(g);h=f[m>>2]|0;j=f[h+12>>2]|0;l=f[h+4>>2]|0;b:do if(l>>>0>j>>>0){t=f[h+16>>2]|0;w=j;while(1){E=f[t+(w<<2)>>2]|0;if(E|0)break;v=w+1|0;if(v>>>0<l>>>0)w=v;else{F=0;G=v;break b}}if((E|0)==(f[t+((w^1)<<2)>>2]|0)){F=f[(f[E>>2]|0)+16>>2]|0;G=w;break}else{F=E;G=w;break}}else{F=0;G=j}while(0);f[e>>2]=F;f[e+4>>2]=h;f[e+8>>2]=G;j=a+28|0;l=0;while(1){elc(g);i=f[e>>2]|0;if(!i)break;q=f[i+12>>2]|0;i=q+16|0;o=f[j>>2]|0;if(!o){k=$Xc(32)|0;f[k+12>>2]=0;f[k+4>>2]=537368;f[k+8>>2]=0;f[k+20>>2]=0;H=k}else{if(f[o+64>>2]|0)SXb(o,15488,32);k=QXb(o,32)|0;v=o;f[k+12>>2]=v;f[k+4>>2]=537368;f[k+8>>2]=0;f[k+20>>2]=v;H=k}f[H>>2]=83384;f[H+24>>2]=q;f[H+28>>2]=i;f[H+16>>2]=3;if((l|0)!=(H|0))if(!l)I=H;else{Yi[f[(f[l>>2]|0)+4>>2]&4095](l);I=H}else I=l;k$b(2,I,c);i=(_i[f[(f[I>>2]|0)+20>>2]&2047](I)|0)==0;q=f[(f[e>>2]|0)+12>>2]|0;k=b[q+11>>0]|0;if(k<<24>>24<0){J=f[q>>2]|0;K=f[q+4>>2]|0}else{J=q;K=k&255}m$b(J,K,1,399022)|0;RIa(e)|0;l=i?I:0}if(l|0)Yi[f[(f[l>>2]|0)+4>>2]&4095](l)}while(0);I=f[a+4>>2]|0;if(!((I&1|0)!=0&(b[476924]|0)!=0)){u=d;return}Oqc(I&-2,c);u=d;return}function $Sa(a){a=a|0;return f[a+48>>2]|0}function aTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0;e=u;u=u+16|0;g=e;h=a+44|0;i=f[h>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;if(k)l=f[i+4>>2]|0;else l=j&255;if(!l)m=d;else{if(k){n=f[i>>2]|0;o=f[i+4>>2]|0}else{n=i;o=j&255}m$b(n,o,1,398986)|0;o=f[h>>2]|0;b[d>>0]=10;m=gZb(o,d+1|0)|0}d=a+8|0;elc(d);o=a+40|0;do if(f[f[o>>2]>>2]|0){if(c?(elc(d),(f[f[o>>2]>>2]|0)>>>0>1):0){elc(d);h=f[f[o>>2]>>2]|0;n=bYc(h>>>0>1073741823?-1:h<<2)|0;elc(d);h=f[o>>2]|0;j=f[h+12>>2]|0;i=f[h+4>>2]|0;a:do if(i>>>0>j>>>0){k=f[h+16>>2]|0;l=j;while(1){p=f[k+(l<<2)>>2]|0;if(p|0)break;q=l+1|0;if(q>>>0<i>>>0)l=q;else{r=0;s=q;break a}}if((p|0)==(f[k+((l^1)<<2)>>2]|0)){r=f[(f[p>>2]|0)+16>>2]|0;s=l;break}else{r=p;s=l;break}}else{r=0;s=j}while(0);f[g>>2]=r;f[g+4>>2]=h;f[g+8>>2]=s;j=0;while(1){elc(d);i=f[g>>2]|0;if(!i)break;f[n+(j<<2)>>2]=f[i+12>>2];RIa(g)|0;j=j+1|0}fTa(n,n+(j<<2)|0,g);if(j){h=a+28|0;i=0;q=m;t=0;do{v=n+(i<<2)|0;w=f[v>>2]|0;x=w+16|0;y=f[h>>2]|0;if(!y){z=$Xc(32)|0;f[z+12>>2]=0;f[z+4>>2]=537368;f[z+8>>2]=0;f[z+20>>2]=0;A=z}else{if(f[y+64>>2]|0)SXb(y,15488,32);z=QXb(y,32)|0;B=y;f[z+12>>2]=B;f[z+4>>2]=537368;f[z+8>>2]=0;f[z+20>>2]=B;A=z}f[A>>2]=83384;f[A+24>>2]=w;f[A+28>>2]=x;f[A+16>>2]=3;if((t|0)!=(A|0))if(!t)C=A;else{Yi[f[(f[t>>2]|0)+4>>2]&4095](t);C=A}else C=t;b[q>>0]=18;x=q+1|0;w=C+16|0;z=f[w>>2]|0;if(!(z&1)){D=z;E=0}else{z=_i[f[(f[C>>2]|0)+100>>2]&2047](C)|0;B=b[z+11>>0]|0;y=B<<24>>24<0?f[z+4>>2]|0:B&255;B=y+1+((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)|0;D=f[w>>2]|0;E=B}if(!(D&2))F=0;else{B=(_i[f[(f[C>>2]|0)+104>>2]&2047](C)|0)+16|0;w=f[B>>2]|0;F=w+1+((((($(w|1|0)|0)^31)*9|0)+73|0)>>>6)|0}w=F+E|0;if(w>>>0>127){B=w;y=x;while(1){b[y>>0]=B|128;z=B>>>7;G=y+1|0;if(B>>>0>16383){B=z;y=G}else{H=G;I=z;break}}}else{H=x;I=w}b[H>>0]=I;y=_i[f[(f[C>>2]|0)+100>>2]&2047](C)|0;b[H+1>>0]=10;B=gZb(y,H+2|0)|0;y=_i[f[(f[C>>2]|0)+104>>2]&2047](C)|0;b[B>>0]=18;l=B+1|0;B=_i[f[(f[y>>2]|0)+60>>2]&2047](y)|0;if(B>>>0>127){k=B;z=l;while(1){b[z>>0]=k|128;G=k>>>7;J=z+1|0;if(k>>>0>16383){k=G;z=J}else{K=J;L=G;break}}}else{K=l;L=B}b[K>>0]=L;q=hj[f[(f[y>>2]|0)+64>>2]&511](y,1,K+1|0)|0;z=(_i[f[(f[C>>2]|0)+20>>2]&2047](C)|0)==0;t=z?C:0;z=f[v>>2]|0;k=b[z+11>>0]|0;if(k<<24>>24<0){M=f[z>>2]|0;N=f[z+4>>2]|0}else{M=z;N=k&255}m$b(M,N,1,399022)|0;i=i+1|0}while(i>>>0<j>>>0);if(!t)O=q;else{Yi[f[(f[t>>2]|0)+4>>2]&4095](t);O=q}}else O=m;dYc(n);P=O;break}elc(d);j=f[o>>2]|0;i=f[j+12>>2]|0;h=f[j+4>>2]|0;b:do if(h>>>0>i>>>0){k=f[j+16>>2]|0;z=i;while(1){Q=f[k+(z<<2)>>2]|0;if(Q|0)break;w=z+1|0;if(w>>>0<h>>>0)z=w;else{R=0;S=w;break b}}if((Q|0)==(f[k+((z^1)<<2)>>2]|0)){R=f[(f[Q>>2]|0)+16>>2]|0;S=z;break}else{R=Q;S=z;break}}else{R=0;S=i}while(0);f[g>>2]=R;f[g+4>>2]=j;f[g+8>>2]=S;i=a+28|0;h=m;n=0;while(1){elc(d);q=f[g>>2]|0;if(!q)break;t=f[q+12>>2]|0;q=t+16|0;v=f[i>>2]|0;if(!v){y=$Xc(32)|0;f[y+12>>2]=0;f[y+4>>2]=537368;f[y+8>>2]=0;f[y+20>>2]=0;T=y}else{if(f[v+64>>2]|0)SXb(v,15488,32);y=QXb(v,32)|0;B=v;f[y+12>>2]=B;f[y+4>>2]=537368;f[y+8>>2]=0;f[y+20>>2]=B;T=y}f[T>>2]=83384;f[T+24>>2]=t;f[T+28>>2]=q;f[T+16>>2]=3;if((n|0)!=(T|0))if(!n)U=T;else{Yi[f[(f[n>>2]|0)+4>>2]&4095](n);U=T}else U=n;b[h>>0]=18;q=h+1|0;t=U+16|0;y=f[t>>2]|0;if(!(y&1)){V=y;W=0}else{y=_i[f[(f[U>>2]|0)+100>>2]&2047](U)|0;B=b[y+11>>0]|0;v=B<<24>>24<0?f[y+4>>2]|0:B&255;B=v+1+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0;V=f[t>>2]|0;W=B}if(!(V&2))X=0;else{B=(_i[f[(f[U>>2]|0)+104>>2]&2047](U)|0)+16|0;t=f[B>>2]|0;X=t+1+((((($(t|1|0)|0)^31)*9|0)+73|0)>>>6)|0}t=X+W|0;if(t>>>0>127){B=t;v=q;while(1){b[v>>0]=B|128;y=B>>>7;l=v+1|0;if(B>>>0>16383){B=y;v=l}else{Y=l;Z=y;break}}}else{Y=q;Z=t}b[Y>>0]=Z;v=_i[f[(f[U>>2]|0)+100>>2]&2047](U)|0;b[Y+1>>0]=10;B=gZb(v,Y+2|0)|0;v=_i[f[(f[U>>2]|0)+104>>2]&2047](U)|0;b[B>>0]=18;z=B+1|0;B=_i[f[(f[v>>2]|0)+60>>2]&2047](v)|0;if(B>>>0>127){k=B;y=z;while(1){b[y>>0]=k|128;l=k>>>7;w=y+1|0;if(k>>>0>16383){k=l;y=w}else{_=w;aa=l;break}}}else{_=z;aa=B}b[_>>0]=aa;y=hj[f[(f[v>>2]|0)+64>>2]&511](v,c,_+1|0)|0;k=(_i[f[(f[U>>2]|0)+20>>2]&2047](U)|0)==0;t=f[(f[g>>2]|0)+12>>2]|0;q=b[t+11>>0]|0;if(q<<24>>24<0){ba=f[t>>2]|0;ca=f[t+4>>2]|0}else{ba=t;ca=q&255}m$b(ba,ca,1,399022)|0;RIa(g)|0;h=y;n=k?U:0}if(!n)P=h;else{Yi[f[(f[n>>2]|0)+4>>2]&4095](n);P=h}}else P=m;while(0);m=f[a+4>>2]|0;if(!((m&1|0)!=0&(b[476924]|0)!=0)){da=P;u=e;return da|0}da=Pqc(m&-2,P)|0;u=e;return da|0}function bTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;elc(d);iSa(a+32|0);dlc(d);d=a+4|0;e=f[a+44>>2]|0;do if((e|0)!=537368){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);e=f[d>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d);d=kZc(c,21568,15360,0)|0;if(!d){Ooc(c,a);return}else{qSa(a,d);return}}function cTa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15360,0)|0;if(!c){Ooc(b,a);return}else{qSa(a,c);return}}function dTa(a,b){a=a|0;b=b|0;f[a+48>>2]=b;return}function eTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223024]|0)!=2){f[d>>2]=165456;f[d+4>>2]=3;b[d+8>>0]=0;J_b(892096,d);a_b(d)}d=530856;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function fTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=a;a=c;a:while(1){c=a;g=a+-4|0;h=a+-8|0;i=e;while(1){j=i;b:while(1){k=j;l=c-k|0;m=l>>2;switch(m|0){case 2:{n=5;break a;break}case 3:{n=10;break a;break}case 4:{n=11;break a;break}case 5:{n=12;break a;break}case 1:case 0:{n=111;break a;break}default:{}}if((l|0)<124){n=14;break a}o=j+(((m|0)/2|0)<<2)|0;if((l|0)>3996){l=(m|0)/4|0;p=JTa(j,j+(l<<2)|0,o,o+(l<<2)|0,g,d)|0}else p=HTa(j,o,g,d)|0;q=f[j>>2]|0;l=f[o>>2]|0;m=b[l+11>>0]|0;r=m<<24>>24<0;s=r?f[l+4>>2]|0:m&255;m=b[q+11>>0]|0;t=m<<24>>24<0;u=t?f[q+4>>2]|0:m&255;m=s>>>0<u>>>0?s:u;if((m|0)!=0?(v=WKc(t?f[q>>2]|0:q,r?f[l>>2]|0:l,m)|0,(v|0)!=0):0){if((v|0)<0){w=g;x=p;break}}else n=20;if((n|0)==20?(n=0,u>>>0<s>>>0):0){w=g;x=p;break}if((j|0)!=(h|0))if(r){r=h;do{v=f[r>>2]|0;m=b[v+11>>0]|0;y=m<<24>>24<0;z=y?f[v+4>>2]|0:m&255;m=s>>>0<z>>>0?s:z;if((m|0)!=0?(A=WKc(y?f[v>>2]|0:v,f[l>>2]|0,m)|0,(A|0)!=0):0){if((A|0)<0){B=r;n=74;break b}}else n=27;if((n|0)==27?(n=0,z>>>0<s>>>0):0){B=r;n=74;break b}r=r+-4|0}while((j|0)!=(r|0))}else{r=h;do{z=f[r>>2]|0;A=b[z+11>>0]|0;m=A<<24>>24<0;v=m?f[z+4>>2]|0:A&255;A=s>>>0<v>>>0?s:v;if((A|0)!=0?(y=WKc(m?f[z>>2]|0:z,l,A)|0,(y|0)!=0):0){if((y|0)<0){B=r;n=74;break b}}else n=71;if((n|0)==71?(n=0,v>>>0<s>>>0):0){B=r;n=74;break b}r=r+-4|0}while((j|0)!=(r|0))}r=j+4|0;s=f[g>>2]|0;l=b[s+11>>0]|0;v=l<<24>>24<0;y=v?f[s+4>>2]|0:l&255;l=y>>>0<u>>>0?y:u;A=s;if((l|0)!=0?(z=WKc(t?f[q>>2]|0:q,v?f[s>>2]|0:s,l)|0,(z|0)!=0):0)if((z|0)<0)C=r;else n=33;else if(u>>>0<y>>>0)C=r;else n=33;if((n|0)==33){n=0;if((r|0)==(g|0)){n=111;break a}c:do if(t){y=r;while(1){z=f[y>>2]|0;l=b[z+11>>0]|0;s=l<<24>>24<0;v=s?f[z+4>>2]|0:l&255;l=v>>>0<u>>>0?v:u;if((l|0)!=0?(m=WKc(f[q>>2]|0,s?f[z>>2]|0:z,l)|0,(m|0)!=0):0){if((m|0)<0){D=y;break c}}else n=38;if((n|0)==38?(n=0,u>>>0<v>>>0):0){D=y;break c}y=y+4|0;if((y|0)==(g|0)){n=111;break a}}}else{y=r;while(1){v=f[y>>2]|0;m=b[v+11>>0]|0;l=m<<24>>24<0;z=l?f[v+4>>2]|0:m&255;m=z>>>0<u>>>0?z:u;if((m|0)!=0?(s=WKc(q,l?f[v>>2]|0:v,m)|0,(s|0)!=0):0){if((s|0)<0){D=y;break c}}else n=42;if((n|0)==42?(n=0,u>>>0<z>>>0):0){D=y;break c}y=y+4|0;if((y|0)==(g|0)){n=111;break a}}}while(0);u=f[D>>2]|0;f[D>>2]=A;f[g>>2]=u;C=D+4|0}if((C|0)==(g|0)){n=111;break a}else{E=g;F=C}while(1){u=f[j>>2]|0;r=b[u+11>>0]|0;t=r<<24>>24<0;y=t?f[u+4>>2]|0:r&255;d:do if(t){r=F;while(1){z=f[r>>2]|0;s=b[z+11>>0]|0;m=s<<24>>24<0;v=m?f[z+4>>2]|0:s&255;s=v>>>0<y>>>0?v:y;if((s|0)!=0?(l=WKc(f[u>>2]|0,m?f[z>>2]|0:z,s)|0,(l|0)!=0):0){if((l|0)<0){G=r;break d}}else n=51;if((n|0)==51?(n=0,y>>>0<v>>>0):0){G=r;break d}r=r+4|0}}else{r=F;while(1){v=f[r>>2]|0;l=b[v+11>>0]|0;s=l<<24>>24<0;z=s?f[v+4>>2]|0:l&255;l=z>>>0<y>>>0?z:y;if((l|0)!=0?(m=WKc(u,s?f[v>>2]|0:v,l)|0,(m|0)!=0):0){if((m|0)<0){G=r;break d}}else n=55;if((n|0)==55?(n=0,y>>>0<z>>>0):0){G=r;break d}r=r+4|0}}while(0);e:do if(t){r=E;while(1){z=r+-4|0;m=f[z>>2]|0;l=b[m+11>>0]|0;v=l<<24>>24<0;s=v?f[m+4>>2]|0:l&255;l=s>>>0<y>>>0?s:y;if(l|0?(H=WKc(f[u>>2]|0,v?f[m>>2]|0:m,l)|0,H|0):0)if((H|0)<0){r=z;continue}else{I=z;break e}if(y>>>0<s>>>0)r=z;else{I=z;break}}}else{r=E;while(1){z=r+-4|0;s=f[z>>2]|0;H=b[s+11>>0]|0;l=H<<24>>24<0;m=l?f[s+4>>2]|0:H&255;H=m>>>0<y>>>0?m:y;if(H|0?(v=WKc(u,l?f[s>>2]|0:s,H)|0,v|0):0)if((v|0)<0){r=z;continue}else{I=z;break e}if(y>>>0<m>>>0)r=z;else{I=z;break}}}while(0);if(G>>>0>=I>>>0){j=G;continue b}y=f[G>>2]|0;f[G>>2]=f[I>>2];f[I>>2]=y;E=I;F=G+4|0}}if((n|0)==74){n=0;f[j>>2]=f[B>>2];f[B>>2]=q;w=B;x=p+1|0}A=j+4|0;f:do if(A>>>0<w>>>0){y=o;u=w;t=A;r=x;while(1){z=f[y>>2]|0;m=b[z+11>>0]|0;v=m<<24>>24<0;H=v?f[z+4>>2]|0:m&255;g:do if(v){m=t;while(1){s=f[m>>2]|0;l=b[s+11>>0]|0;J=l<<24>>24<0;K=J?f[s+4>>2]|0:l&255;l=H>>>0<K>>>0?H:K;if((l|0)!=0?(L=WKc(J?f[s>>2]|0:s,f[z>>2]|0,l)|0,(L|0)!=0):0){if((L|0)>=0){M=m;break g}}else n=80;if((n|0)==80?(n=0,K>>>0>=H>>>0):0){M=m;break g}m=m+4|0}}else{m=t;while(1){K=f[m>>2]|0;L=b[K+11>>0]|0;l=L<<24>>24<0;s=l?f[K+4>>2]|0:L&255;L=H>>>0<s>>>0?H:s;if((L|0)!=0?(J=WKc(l?f[K>>2]|0:K,z,L)|0,(J|0)!=0):0){if((J|0)>=0){M=m;break g}}else n=84;if((n|0)==84?(n=0,s>>>0>=H>>>0):0){M=m;break g}m=m+4|0}}while(0);h:do if(v){m=u;while(1){s=m+-4|0;J=f[s>>2]|0;L=b[J+11>>0]|0;K=L<<24>>24<0;l=K?f[J+4>>2]|0:L&255;L=H>>>0<l>>>0?H:l;if(L|0?(N=WKc(K?f[J>>2]|0:J,f[z>>2]|0,L)|0,N|0):0)if((N|0)<0){O=s;break h}else{m=s;continue}if(l>>>0<H>>>0){O=s;break}else m=s}}else{m=u;while(1){s=m+-4|0;l=f[s>>2]|0;N=b[l+11>>0]|0;L=N<<24>>24<0;J=L?f[l+4>>2]|0:N&255;N=H>>>0<J>>>0?H:J;if(N|0?(K=WKc(L?f[l>>2]|0:l,z,N)|0,K|0):0)if((K|0)<0){O=s;break h}else{m=s;continue}if(J>>>0<H>>>0){O=s;break}else m=s}}while(0);if(M>>>0>O>>>0){P=y;Q=r;R=M;break f}H=f[M>>2]|0;f[M>>2]=f[O>>2];f[O>>2]=H;y=(y|0)==(M|0)?O:y;u=O;t=M+4|0;r=r+1|0}}else{P=o;Q=x;R=A}while(0);do if((R|0)==(P|0))S=Q;else{A=f[P>>2]|0;r=f[R>>2]|0;t=b[r+11>>0]|0;u=t<<24>>24<0;y=u?f[r+4>>2]|0:t&255;t=b[A+11>>0]|0;H=t<<24>>24<0;z=H?f[A+4>>2]|0:t&255;t=y>>>0<z>>>0?y:z;v=r;m=A;if((t|0)!=0?(s=WKc(H?f[A>>2]|0:A,u?f[r>>2]|0:r,t)|0,(s|0)!=0):0){if((s|0)>=0){S=Q;break}}else n=101;if((n|0)==101?(n=0,z>>>0>=y>>>0):0){S=Q;break}f[R>>2]=m;f[P>>2]=v;S=Q+1|0}while(0);if(!S){T=LTa(j,R,d)|0;v=R+4|0;if(LTa(v,a,d)|0){n=110;break}if(T){i=v;continue}}v=R;if((v-k|0)>=(c-v|0)){n=109;break}fTa(j,R,d);i=R+4|0}if((n|0)==109){n=0;fTa(R+4|0,a,d);e=j;a=R;continue}else if((n|0)==110){n=0;if(T){n=111;break}else{e=j;a=R;continue}}}if((n|0)==5){R=f[g>>2]|0;e=f[j>>2]|0;T=b[e+11>>0]|0;k=T<<24>>24<0;S=k?f[e+4>>2]|0:T&255;T=b[R+11>>0]|0;Q=T<<24>>24<0;P=Q?f[R+4>>2]|0:T&255;T=S>>>0<P>>>0?S:P;x=e;o=R;if((T|0)!=0?(M=WKc(Q?f[R>>2]|0:R,k?f[e>>2]|0:e,T)|0,(M|0)!=0):0){if((M|0)>=0)return}else n=7;if((n|0)==7?P>>>0>=S>>>0:0)return;f[j>>2]=o;f[g>>2]=x;return}else if((n|0)==10){HTa(j,j+4|0,g,d)|0;return}else if((n|0)==11){ITa(j,j+4|0,j+8|0,g,d)|0;return}else if((n|0)==12){JTa(j,j+4|0,j+8|0,j+12|0,g,d)|0;return}else if((n|0)==14){KTa(j,a,d);return}else if((n|0)==111)return}function gTa(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=83500;c=a+20|0;d=f[c>>2]|0;if(d&1|0?(e=d&-2,d=e,!((e|0)==0|(f[d+4>>2]|0)!=0)):0){if(f[d>>2]|0)sqc(d);cYc(e)}f[c>>2]=0;f[a>>2]=83616;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function hTa(a){a=a|0;gTa(a);cYc(a);return}function iTa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function jTa(a){a=a|0;a=$Xc(24)|0;f[a+12>>2]=0;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a>>2]=83076;return a|0}function kTa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=$Xc(24)|0;f[a+12>>2]=0;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;c=a;f[c>>2]=83076;return c|0}if(f[b+64>>2]|0)SXb(b,15416,24);a=QXb(b,24)|0;d=b;f[a+12>>2]=d;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=d;c=a;f[c>>2]=83076;return c|0}function lTa(a){a=a|0;return f[a+12>>2]|0}function mTa(a){a=a|0;return _i[f[(f[a>>2]|0)+20>>2]&2047](a)|0}function nTa(a){a=a|0;var c=0,d=0;c=f[a+4>>2]|0;do if((c|0)!=537368){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+8>>2]|0;if((c|0?(jSa(c),d=f[c+4>>2]|0,d&1|0):0)?(c=d&-2,f[c>>2]|0):0)sqc(c);c=a+16|0;f[c>>2]=f[c>>2]&-4;return}function oTa(a){a=a|0;return 1}function pTa(a,b){a=a|0;b=b|0;MSa(a,b);return}function qTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+4|0;j=a+12|0;k=a+8|0;a=e+4|0;l=c+32|0;m=c+12|0;n=c+28|0;a:while(1){o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;r=q}else{s=q;t=5}}else{s=0;t=5}if((t|0)==5){t=0;r=ZYb(c,s)|0}switch(r|0){case 0:{v=1;t=35;break a;break}case 10:{f[h>>2]=f[h>>2]|1;q=f[i>>2]|0;if((q|0)==537368){xJa(i,f[j>>2]|0,537368);w=f[i>>2]|0}else w=q;if(!(l$b(c,w)|0)){v=0;t=35;break a}q=f[h>>2]|1;f[h>>2]=q;o=f[c>>2]|0;if(o>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[o>>0]|0)!=18)continue a;f[c>>2]=o+1;x=q;break}case 18:{x=f[h>>2]|0;break}default:{if((r&7|0)==4){v=1;t=35;break a}if(O_b(c,r)|0)continue a;else{v=0;t=35;break a}}}f[h>>2]=x|2;q=f[j>>2]|0;o=f[k>>2]|0;if(!o){if(!q){p=$Xc(24)|0;ISa(p);y=p}else{if(f[q+64>>2]|0)SXb(q,15400,24);p=QXb(q,24)|0;JSa(p,q);y=p}f[k>>2]=y;z=y}else z=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(p=b[o>>0]|0,p<<24>>24>-1):0){f[c>>2]=o+1;A=p&255}else{p=YYb(c)|0;if((p|0)>-1)A=p;else{v=0;t=35;break}}JYb(e,c,A);if((f[a>>2]|0)<0){t=27;break}if(!(BTa(z,c)|0)){t=27;break}if(!(OYb(c,f[e>>2]|0)|0)){v=0;t=35;break}f[h>>2]=f[h>>2]|2;if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[l>>2]|0){t=32;break}if((f[m>>2]|0)==(f[n>>2]|0)){t=32;break}}if((t|0)==27){v=0;u=d;return v|0}else if((t|0)==32){f[c+20>>2]=0;b[c+24>>0]=1;v=1;u=d;return v|0}else if((t|0)==35){u=d;return v|0}return 0}function rTa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=ATa(_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0)|0;j=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function sTa(a,b){a=a|0;b=b|0;e$b(1,_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0,b);k$b(2,_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0,b);return}function tTa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=(_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0)+16|0;a=f[e>>2]|0;j=a+1+((((($(a|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function uTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;b[d>>0]=10;g=gZb(e,d+1|0)|0;d=_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0;b[g>>0]=18;a=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(g>>>0>127){e=g;h=a;while(1){b[h>>0]=e|128;i=e>>>7;j=h+1|0;if(e>>>0>16383){e=i;h=j}else{k=j;l=i;break}}}else{k=a;l=g}b[k>>0]=l;return hj[f[(f[d>>2]|0)+64>>2]&511](d,c,k+1|0)|0}function vTa(a,b){a=a|0;b=b|0;rlc(a,b);return}function wTa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+84>>2]&2047](b)|0)+28|0}function xTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223024]|0)!=2){f[d>>2]=165456;f[d+4>>2]=3;b[d+8>>0]=0;J_b(892096,d);a_b(d)}d=530848;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function yTa(a){a=a|0;return f[a+24>>2]|0}function zTa(a){a=a|0;return f[a+28>>2]|0}function ATa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;do switch(f[a+20>>2]|0){case 2:{c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0?f[c+4>>2]|0:e&255;h=d+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 3:{g=a+8|0;h=d+1+(((((t1c(f[g>>2]|1|0,f[g+4>>2]|0,1)|0)^63)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 4:{h=d+5|0;i=a+16|0;f[i>>2]=h;return h|0}case 5:{h=d+2|0;i=a+16|0;f[i>>2]=h;return h|0}case 6:{g=f[a+8>>2]|0;if((g|0)<0)j=11;else j=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=j+d|0;i=a+16|0;f[i>>2]=h;return h|0}case 7:{g=f[a+8>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;h=d+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 8:{e=f[a+8>>2]|0;g=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;h=d+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 1:{g=f[a+8>>2]|0;e=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;h=d+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 10:{e=f[a+8>>2]|0;g=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;h=d+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}case 9:{g=f[a+8>>2]|0;e=b[g+11>>0]|0;c=e<<24>>24<0?f[g+4>>2]|0:e&255;h=d+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=a+16|0;f[i>>2]=h;return h|0}default:{h=d;i=a+16|0;f[i>>2]=h;return h|0}}while(0);return 0}function BTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+16|0;e=d;g=c+4|0;i=e+4|0;j=a+20|0;k=a+8|0;l=a+4|0;m=a+8|0;n=e+8|0;o=e+8|0;p=e+4|0;q=e+4|0;r=e+4|0;a:while(1){s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){t=b[s>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=s+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=ZYb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;do switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=10){z=w;break b}v=nSa(a)|0;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(t=b[s>>0]|0,t<<24>>24>-1):0){f[c>>2]=s+1;A=t&255}else{t=YYb(c)|0;if((t|0)>-1)A=t;else{B=0;x=104;break a}}JYb(e,c,A);if((f[i>>2]|0)<0){x=14;break a}if(!(Mi[f[(f[v>>2]|0)+44>>2]&1023](v,c)|0)){x=14;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}case 2:{if((w&255|0)!=18){z=w;break b}if((f[j>>2]|0)!=2){jSa(a);f[j>>2]=2;f[k>>2]=537368}v=f[l>>2]|0;t=v&-2;if(!(v&1))C=t;else C=f[t+4>>2]|0;t=f[k>>2]|0;if((t|0)==537368){xJa(k,C,537368);D=f[k>>2]|0}else D=t;if(l$b(c,D)|0)continue a;else{B=0;x=104;break a}break}case 3:{if((w&255|0)!=24){z=w;break b}jSa(a);t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;E=v&255;F=0}else{LYb(e,c);v=e;if(!(b[n>>0]|0)){B=0;x=104;break a}else{E=f[v>>2]|0;F=f[v+4>>2]|0}}v=m;f[v>>2]=E;f[v+4>>2]=F;f[j>>2]=3;continue a;break}case 4:{if((w&255|0)!=37){z=w;break b}jSa(a);v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){t=v;s=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=s;f[c>>2]=v+4;G=s}else{if(!(WYb(c,e)|0)){x=36;break a}G=f[e>>2]|0}f[k>>2]=G;f[j>>2]=4;continue a;break}case 5:{if((w&255|0)!=40){z=w;break b}jSa(a);s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;H=v<<24>>24!=0}else{LYb(e,c);v=e;if(!(b[o>>0]|0)){B=0;x=104;break a}else H=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[k>>0]=H&1;f[j>>2]=5;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){s=b[v>>0]|0;t=s&255;if(s<<24>>24>-1){f[c>>2]=v+1;I=t}else{K=t;x=48}}else{K=0;x=48}if((x|0)==48){x=0;t=KYb(c,K)|0;v=J;if((v|0)>-1|(v|0)==-1&t>>>0>4294967295)I=t;else{B=0;x=104;break a}}if((f[j>>2]|0)!=6){jSa(a);f[j>>2]=6}f[k>>2]=I;continue a;break}case 7:{if((w&255|0)!=58){z=w;break b}t=mSa(a)|0;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(s=b[v>>0]|0,s<<24>>24>-1):0){f[c>>2]=v+1;L=s&255}else{s=YYb(c)|0;if((s|0)>-1)L=s;else{B=0;x=104;break a}}JYb(e,c,L);if((f[p>>2]|0)<0){x=59;break a}if(!(Mi[f[(f[t>>2]|0)+44>>2]&1023](t,c)|0)){x=59;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}case 8:{if((w&255|0)!=66){z=w;break b}t=vJa(a)|0;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;M=v&255}else{v=YYb(c)|0;if((v|0)>-1)M=v;else{B=0;x=104;break a}}JYb(e,c,M);if((f[q>>2]|0)<0){x=68;break a}if(!(Mi[f[(f[t>>2]|0)+44>>2]&1023](t,c)|0)){x=68;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}case 9:{if((w&255|0)!=74){z=w;break b}if((f[j>>2]|0)!=9){jSa(a);f[j>>2]=9;f[k>>2]=537368}t=f[l>>2]|0;v=t&-2;if(!(t&1))N=v;else N=f[v+4>>2]|0;v=f[k>>2]|0;if((v|0)==537368){xJa(k,N,537368);O=f[k>>2]|0}else O=v;if(!(l$b(c,O)|0)){B=0;x=104;break a}v=(f[j>>2]|0)==9;if(v){t=f[k>>2]|0;P=t;Q=t}else{P=537368;Q=537368}if((b[Q+11>>0]|0)<0)R=f[P>>2]|0;else R=P;if(v){v=f[k>>2]|0;S=v;T=v}else{S=537368;T=537368}v=b[T+11>>0]|0;if(v<<24>>24<0)U=f[S+4>>2]|0;else U=v&255;if(m$b(R,U,0,399067)|0)continue a;else{B=0;x=104;break a}break}case 10:{if((w&255|0)!=82){z=w;break b}v=pSa(a)|0;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(s=b[t>>0]|0,s<<24>>24>-1):0){f[c>>2]=t+1;V=s&255}else{s=YYb(c)|0;if((s|0)>-1)V=s;else{B=0;x=104;break a}}JYb(e,c,V);if((f[r>>2]|0)<0){x=97;break a}if(!(Mi[f[(f[v>>2]|0)+44>>2]&1023](v,c)|0)){x=97;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=104;break a}break}default:{z=w;break b}}while(0)}while(0);if(!z){B=1;x=104;break}v=f[l>>2]|0;if(!(v&1))W=lSa(l)|0;else W=v&-2;if(!(Lqc(c,z,W)|0)){B=0;x=104;break}}if((x|0)==14){B=0;u=d;return B|0}else if((x|0)==36){B=0;u=d;return B|0}else if((x|0)==59){B=0;u=d;return B|0}else if((x|0)==68){B=0;u=d;return B|0}else if((x|0)==97){B=0;u=d;return B|0}else if((x|0)==104){u=d;return B|0}return 0}function CTa(a){a=a|0;var c=0;f[a>>2]=83616;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function DTa(a){a=a|0;var c=0;f[a>>2]=83616;if(f[a+12>>2]|0){cYc(a);return}c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c){cYc(a);return}Yi[f[(f[c>>2]|0)+4>>2]&4095](c);cYc(a);return}function ETa(a){a=a|0;return f[a+4>>2]|0}function FTa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (b|0?b:f[132690]|0)|0}function GTa(a){a=a|0;gTa(a);cYc(a);return}function HTa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=f[c>>2]|0;g=f[a>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0;j=g+4|0;k=i?f[j>>2]|0:h&255;h=b[e+11>>0]|0;l=h<<24>>24<0;m=l?f[e+4>>2]|0:h&255;h=k>>>0<m>>>0;n=h?k:m;o=e;p=g;if((n|0)!=0?(q=WKc(l?f[e>>2]|0:e,i?f[g>>2]|0:g,n)|0,(q|0)!=0):0)r=q;else r=m>>>0<k>>>0?-1:h&1;h=(r|0)<0;r=f[d>>2]|0;k=b[r+11>>0]|0;q=k<<24>>24<0;n=q?f[r+4>>2]|0:k&255;k=m>>>0<n>>>0;i=k?m:n;s=r;if((i|0)!=0?(t=WKc(q?f[r>>2]|0:r,l?f[e>>2]|0:e,i)|0,(t|0)!=0):0)u=t;else u=n>>>0<m>>>0?-1:k&1;k=(u|0)<0;if(!h){if(!k){v=0;return v|0}f[c>>2]=s;f[d>>2]=o;h=f[c>>2]|0;u=f[a>>2]|0;m=b[u+11>>0]|0;n=m<<24>>24<0;t=n?f[u+4>>2]|0:m&255;m=b[h+11>>0]|0;i=m<<24>>24<0;e=i?f[h+4>>2]|0:m&255;m=t>>>0<e>>>0?t:e;l=u;r=h;if((m|0)!=0?(q=WKc(i?f[h>>2]|0:h,n?f[u>>2]|0:u,m)|0,(q|0)!=0):0){if((q|0)>=0){v=1;return v|0}}else w=11;if((w|0)==11?e>>>0>=t>>>0:0){v=1;return v|0}f[a>>2]=r;f[c>>2]=l;v=2;return v|0}if(k){f[a>>2]=s;f[d>>2]=p;v=1;return v|0}f[a>>2]=o;f[c>>2]=p;o=f[d>>2]|0;a=b[g+11>>0]|0;s=a<<24>>24<0;k=s?f[j>>2]|0:a&255;a=b[o+11>>0]|0;j=a<<24>>24<0;l=j?f[o+4>>2]|0:a&255;a=k>>>0<l>>>0?k:l;r=o;if((a|0)!=0?(t=WKc(j?f[o>>2]|0:o,s?f[g>>2]|0:g,a)|0,(t|0)!=0):0){if((t|0)>=0){v=1;return v|0}}else w=18;if((w|0)==18?l>>>0>=k>>>0:0){v=1;return v|0}f[c>>2]=r;f[d>>2]=p;v=2;return v|0}function ITa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=HTa(a,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=k?f[i+4>>2]|0:j&255;j=b[g+11>>0]|0;m=j<<24>>24<0;n=m?f[g+4>>2]|0:j&255;j=l>>>0<n>>>0?l:n;o=i;p=g;if((j|0)!=0?(q=WKc(m?f[g>>2]|0:g,k?f[i>>2]|0:i,j)|0,(q|0)!=0):0){if((q|0)>=0){r=h;return r|0}}else s=3;if((s|0)==3?n>>>0>=l>>>0:0){r=h;return r|0}f[d>>2]=p;f[e>>2]=o;o=h+1|0;e=f[d>>2]|0;p=f[c>>2]|0;l=b[p+11>>0]|0;n=l<<24>>24<0;q=n?f[p+4>>2]|0:l&255;l=b[e+11>>0]|0;j=l<<24>>24<0;i=j?f[e+4>>2]|0:l&255;l=q>>>0<i>>>0?q:i;k=p;g=e;if((l|0)!=0?(m=WKc(j?f[e>>2]|0:e,n?f[p>>2]|0:p,l)|0,(m|0)!=0):0){if((m|0)>=0){r=o;return r|0}}else s=7;if((s|0)==7?i>>>0>=q>>>0:0){r=o;return r|0}f[c>>2]=g;f[d>>2]=k;k=h+2|0;d=f[c>>2]|0;g=f[a>>2]|0;o=b[g+11>>0]|0;q=o<<24>>24<0;i=q?f[g+4>>2]|0:o&255;o=b[d+11>>0]|0;m=o<<24>>24<0;l=m?f[d+4>>2]|0:o&255;o=i>>>0<l>>>0?i:l;p=g;n=d;if((o|0)!=0?(e=WKc(m?f[d>>2]|0:d,q?f[g>>2]|0:g,o)|0,(e|0)!=0):0){if((e|0)>=0){r=k;return r|0}}else s=11;if((s|0)==11?l>>>0>=i>>>0:0){r=k;return r|0}f[a>>2]=n;f[c>>2]=p;r=h+3|0;return r|0}function JTa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=ITa(a,c,d,e,h)|0;h=f[g>>2]|0;j=f[e>>2]|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[j+4>>2]|0:k&255;k=b[h+11>>0]|0;n=k<<24>>24<0;o=n?f[h+4>>2]|0:k&255;k=m>>>0<o>>>0?m:o;p=j;q=h;if((k|0)!=0?(r=WKc(n?f[h>>2]|0:h,l?f[j>>2]|0:j,k)|0,(r|0)!=0):0){if((r|0)>=0){s=i;return s|0}}else t=3;if((t|0)==3?o>>>0>=m>>>0:0){s=i;return s|0}f[e>>2]=q;f[g>>2]=p;p=i+1|0;g=f[e>>2]|0;q=f[d>>2]|0;m=b[q+11>>0]|0;o=m<<24>>24<0;r=o?f[q+4>>2]|0:m&255;m=b[g+11>>0]|0;k=m<<24>>24<0;j=k?f[g+4>>2]|0:m&255;m=r>>>0<j>>>0?r:j;l=q;h=g;if((m|0)!=0?(n=WKc(k?f[g>>2]|0:g,o?f[q>>2]|0:q,m)|0,(n|0)!=0):0){if((n|0)>=0){s=p;return s|0}}else t=7;if((t|0)==7?j>>>0>=r>>>0:0){s=p;return s|0}f[d>>2]=h;f[e>>2]=l;l=i+2|0;e=f[d>>2]|0;h=f[c>>2]|0;p=b[h+11>>0]|0;r=p<<24>>24<0;j=r?f[h+4>>2]|0:p&255;p=b[e+11>>0]|0;n=p<<24>>24<0;m=n?f[e+4>>2]|0:p&255;p=j>>>0<m>>>0?j:m;q=h;o=e;if((p|0)!=0?(g=WKc(n?f[e>>2]|0:e,r?f[h>>2]|0:h,p)|0,(g|0)!=0):0){if((g|0)>=0){s=l;return s|0}}else t=11;if((t|0)==11?m>>>0>=j>>>0:0){s=l;return s|0}f[c>>2]=o;f[d>>2]=q;q=i+3|0;d=f[c>>2]|0;o=f[a>>2]|0;l=b[o+11>>0]|0;j=l<<24>>24<0;m=j?f[o+4>>2]|0:l&255;l=b[d+11>>0]|0;g=l<<24>>24<0;p=g?f[d+4>>2]|0:l&255;l=m>>>0<p>>>0?m:p;h=o;r=d;if((l|0)!=0?(e=WKc(g?f[d>>2]|0:d,j?f[o>>2]|0:o,l)|0,(e|0)!=0):0){if((e|0)>=0){s=q;return s|0}}else t=15;if((t|0)==15?p>>>0>=m>>>0:0){s=q;return s|0}f[a>>2]=r;f[c>>2]=h;s=i+4|0;return s|0}function KTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=a+8|0;HTa(a,a+4|0,e,d)|0;d=a+12|0;if((d|0)==(c|0))return;else{g=d;h=e}while(1){e=f[g>>2]|0;d=f[h>>2]|0;i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d+4>>2]|0:i&255;i=b[e+11>>0]|0;l=i<<24>>24<0;m=e+4|0;n=l?f[m>>2]|0:i&255;i=k>>>0<n>>>0?k:n;o=e;p=d;if((i|0)!=0?(q=WKc(l?f[e>>2]|0:e,j?f[d>>2]|0:d,i)|0,(q|0)!=0):0){if((q|0)<0)r=7}else r=5;if((r|0)==5?(r=0,n>>>0<k>>>0):0)r=7;if((r|0)==7){r=0;f[g>>2]=p;a:do if((h|0)==(a|0))s=h;else{p=b[e+11>>0]|0;k=p<<24>>24<0;n=p&255;p=h;q=h;while(1){i=q;q=p+-4|0;d=f[q>>2]|0;j=b[d+11>>0]|0;l=j<<24>>24<0;t=l?f[d+4>>2]|0:j&255;j=k?f[m>>2]|0:n;u=t>>>0<j>>>0?t:j;v=d;if((u|0)!=0?(w=WKc(k?f[e>>2]|0:e,l?f[d>>2]|0:d,u)|0,(w|0)!=0):0){if((w|0)>=0){s=i;break a}}else r=11;if((r|0)==11?(r=0,j>>>0>=t>>>0):0){s=i;break a}f[i>>2]=v;if((q|0)==(a|0)){s=q;break}else p=q}}while(0);f[s>>2]=o}e=g+4|0;if((e|0)==(c|0))break;else{m=g;g=e;h=m}}return}function LTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;switch(c-a>>2|0){case 2:{e=c+-4|0;g=f[e>>2]|0;h=f[a>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;k=j?f[h+4>>2]|0:i&255;i=b[g+11>>0]|0;l=i<<24>>24<0;m=l?f[g+4>>2]|0:i&255;i=k>>>0<m>>>0?k:m;n=h;o=g;if((i|0)!=0?(p=WKc(l?f[g>>2]|0:g,j?f[h>>2]|0:h,i)|0,(p|0)!=0):0){if((p|0)>=0){q=1;return q|0}}else r=4;if((r|0)==4?m>>>0>=k>>>0:0){q=1;return q|0}f[a>>2]=o;f[e>>2]=n;q=1;return q|0}case 3:{HTa(a,a+4|0,c+-4|0,d)|0;q=1;return q|0}case 4:{ITa(a,a+4|0,a+8|0,c+-4|0,d)|0;q=1;return q|0}case 5:{JTa(a,a+4|0,a+8|0,a+12|0,c+-4|0,d)|0;q=1;return q|0}case 1:case 0:{q=1;return q|0}default:{n=a+8|0;HTa(a,a+4|0,n,d)|0;d=a+12|0;a:do if((d|0)==(c|0)){s=1;t=0}else{e=d;o=0;k=n;while(1){m=f[e>>2]|0;p=f[k>>2]|0;i=b[p+11>>0]|0;h=i<<24>>24<0;j=h?f[p+4>>2]|0:i&255;i=b[m+11>>0]|0;g=i<<24>>24<0;l=m+4|0;u=g?f[l>>2]|0:i&255;i=j>>>0<u>>>0?j:u;v=m;w=p;if((i|0)!=0?(x=WKc(g?f[m>>2]|0:m,h?f[p>>2]|0:p,i)|0,(x|0)!=0):0)if((x|0)<0)r=15;else y=o;else if(u>>>0<j>>>0)r=15;else y=o;if((r|0)==15){r=0;f[e>>2]=w;b:do if((k|0)==(a|0))z=k;else{w=b[m+11>>0]|0;j=w<<24>>24<0;u=w&255;w=k;x=k;while(1){x=x+-4|0;i=f[x>>2]|0;p=b[i+11>>0]|0;h=p<<24>>24<0;g=h?f[i+4>>2]|0:p&255;p=j?f[l>>2]|0:u;A=g>>>0<p>>>0?g:p;B=i;if((A|0)!=0?(C=WKc(j?f[m>>2]|0:m,h?f[i>>2]|0:i,A)|0,(C|0)!=0):0){if((C|0)>=0){z=w;break b}}else r=19;if((r|0)==19?(r=0,p>>>0>=g>>>0):0){z=w;break b}f[w>>2]=B;if((x|0)==(a|0)){z=x;break}else w=x}}while(0);f[z>>2]=v;m=o+1|0;if((m|0)==8){s=0;t=(e+4|0)==(c|0);break a}else y=m}m=e+4|0;if((m|0)==(c|0)){s=1;t=0;break}else{l=e;e=m;o=y;k=l}}}while(0);q=t|s;return q|0}}return 0}function MTa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;i=c+4|0;if(h>>>0<(f[i>>2]|0)>>>0?(b[h>>0]|0)==10:0){f[c>>2]=h+1;h=a+8|0;if(!(l$b(c,h)|0)){j=0;u=e;return j|0}k=f[c>>2]|0;if((((f[i>>2]|0)-k|0)>0?(b[k>>0]|0)==18:0)?(k=a+4|0,l=f[k>>2]|0,m=f[f[l+8>>2]>>2]|0,n=bJa(l,h)|0,l=a+20|0,f[l>>2]=n,(m|0)!=(f[f[(f[k>>2]|0)+8>>2]>>2]|0)):0){m=f[i>>2]|0;o=f[c>>2]|0;p=m-o|0;if((p|0)<1){SYb(c,1,p)|0;q=f[c>>2]|0;r=f[i>>2]|0;s=f[l>>2]|0}else{l=o+1|0;f[c>>2]=l;q=l;r=m;s=n}if(q>>>0<r>>>0?(r=b[q>>0]|0,r<<24>>24>-1):0){f[c>>2]=q+1;t=r&255;v=14}else v=13;if((v|0)==13?(r=YYb(c)|0,(r|0)>-1):0){t=r;v=14}do if(((v|0)==14?(JYb(g,c,t),(f[g+4>>2]|0)>=0):0)?BTa(s,c)|0:0){if(!(OYb(c,f[g>>2]|0)|0))break;do if((f[c>>2]|0)==(f[i>>2]|0)){if((f[c+32>>2]|0)==0?(f[c+12>>2]|0)!=(f[c+28>>2]|0):0)break;f[c+20>>2]=0;b[c+24>>0]=1;j=1;u=e;return j|0}while(0);j=NTa(a,c)|0;u=e;return j|0}while(0);PSa(f[k>>2]|0,h)|0;j=0;u=e;return j|0}}else{f[g>>2]=0;d[g+4>>1]=0;b[g+6>>0]=0;h=a+8|0;k=h+11|0;if((b[k>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+12>>2]=0}else{b[h>>0]=0;b[k>>0]=0}sYc(h,0);f[a+8>>2]=0;h=a+12|0;f[h>>2]=f[g>>2];d[h+4>>1]=d[g+4>>1]|0;b[h+6>>0]=b[g+6>>0]|0;b[a+19>>0]=0}g=f[(f[a>>2]|0)+20>>2]|0;if(!g){h=$Xc(24)|0;f[h+12>>2]=0;f[h+4>>2]=537368;f[h+8>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;w=h}else{if(f[g+64>>2]|0)SXb(g,15416,24);h=QXb(g,24)|0;k=g;f[h+12>>2]=k;f[h+4>>2]=537368;f[h+8>>2]=0;f[h+16>>2]=0;f[h+20>>2]=k;w=h}f[w>>2]=83076;h=a+24|0;k=f[h>>2]|0;if((k|0)==(w|0))x=w;else{if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&4095](k);f[h>>2]=w;x=w}w=x+16|0;f[w>>2]=f[w>>2]|1;w=x+4|0;k=f[w>>2]|0;if((k|0)==537368){xJa(w,f[x+12>>2]|0,537368);y=f[w>>2]|0}else y=k;oYc(y,a+8|0)|0;y=f[h>>2]|0;k=Mi[f[(f[y>>2]|0)+44>>2]&1023](y,c)|0;if(k)OTa(a);a=f[h>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0)){j=k;u=e;return j|0}f[h>>2]=0;j=k;u=e;return j|0}function NTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[(f[a>>2]|0)+20>>2]|0;if(!d){e=$Xc(24)|0;f[e+12>>2]=0;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)SXb(d,15416,24);e=QXb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=83076;e=a+24|0;h=f[e>>2]|0;if((h|0)==(g|0))i=g;else{if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);f[e>>2]=g;i=g}g=f[a+20>>2]|0;h=i+16|0;f[h>>2]=f[h>>2]|2;h=i+8|0;d=f[i+12>>2]|0;i=f[h>>2]|0;if(!i){if(!d){j=$Xc(24)|0;ISa(j);k=j}else{if(f[d+64>>2]|0)SXb(d,15400,24);j=QXb(d,24)|0;JSa(j,d);k=j}f[h>>2]=k;l=k}else l=i;PTa(l,g);g=a+8|0;PSa(f[a+4>>2]|0,g)|0;l=f[e>>2]|0;i=l+16|0;f[i>>2]=f[i>>2]|1;i=l+4|0;k=f[i>>2]|0;if((k|0)==537368){xJa(i,f[l+12>>2]|0,537368);m=f[i>>2]|0}else m=k;k=m+11|0;if((b[k>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0}else{b[m>>0]=0;b[k>>0]=0}sYc(m,0);f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=f[e>>2]|0;m=Mi[f[(f[g>>2]|0)+44>>2]&1023](g,c)|0;if(m)OTa(a);a=f[e>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0))return m|0;f[e>>2]=0;return m|0}function OTa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+24|0;c=f[b>>2]|0;d=a+8|0;oYc(d,_i[f[(f[c>>2]|0)+100>>2]&2047](c)|0)|0;c=bJa(f[a+4>>2]|0,d)|0;d=a+20|0;f[d>>2]=c;a=f[b>>2]|0;b=a+16|0;f[b>>2]=f[b>>2]|2;b=a+8|0;e=f[a+12>>2]|0;a=f[b>>2]|0;if(a|0){g=c;h=a;PTa(g,h);return}if(!e){a=$Xc(24)|0;ISa(a);i=a}else{if(f[e+64>>2]|0)SXb(e,15400,24);a=QXb(e,24)|0;JSa(a,e);i=a}f[b>>2]=i;g=f[d>>2]|0;h=i;PTa(g,h);return}function PTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if((b|0)==(a|0))return;c=a+4|0;d=f[c>>2]|0;e=(d&1|0)==0;g=d&-2;if(e)h=g;else h=f[g+4>>2]|0;d=b+4|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;if((h|0)==(k|0)){k=a+8|0;h=k;j=f[h>>2]|0;i=f[h+4>>2]|0;h=b+8|0;l=h;m=f[l+4>>2]|0;n=k;f[n>>2]=f[l>>2];f[n+4>>2]=m;m=h;f[m>>2]=j;f[m+4>>2]=i;i=a+20|0;m=b+20|0;j=f[i>>2]|0;f[i>>2]=f[m>>2];f[m>>2]=j;j=b+4|0;m=f[c>>2]|0;i=f[j>>2]|0;if((i|m)&1|0){if(!(i&1)){h=lSa(j)|0;o=h;p=f[c>>2]|0}else{o=i&-2;p=m}if(!(p&1))q=lSa(c)|0;else q=p&-2;p=f[q>>2]|0;f[q>>2]=f[o>>2];f[o>>2]=p}p=a+16|0;o=b+16|0;q=f[p>>2]|0;f[p>>2]=f[o>>2];f[o>>2]=q;return}if(e)r=g;else r=f[g+4>>2]|0;if(!r){g=$Xc(24)|0;ISa(g);s=g}else{if(f[r+64>>2]|0)SXb(r,15400,24);g=QXb(r,24)|0;JSa(g,r);s=g}kSa(s,b);jSa(b);g=f[d>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)sqc(d);kSa(b,a);b=a+8|0;d=b;g=f[d>>2]|0;r=f[d+4>>2]|0;d=s+8|0;e=d;q=f[e+4>>2]|0;o=b;f[o>>2]=f[e>>2];f[o+4>>2]=q;q=d;f[q>>2]=g;f[q+4>>2]=r;r=a+20|0;q=s+20|0;g=f[r>>2]|0;f[r>>2]=f[q>>2];f[q>>2]=g;g=s+4|0;q=f[c>>2]|0;r=f[g>>2]|0;if(!((r|q)&1))t=q;else{if(!(r&1)){d=lSa(g)|0;u=d;v=f[c>>2]|0}else{u=r&-2;v=q}if(!(v&1))w=lSa(c)|0;else w=v&-2;v=f[w>>2]|0;f[w>>2]=f[u>>2];f[u>>2]=v;t=f[c>>2]|0}c=a+16|0;a=s+16|0;v=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=v;v=t&-2;if(!(t&1))x=v;else x=f[v+4>>2]|0;if(x|0)return;Yi[f[(f[s>>2]|0)+4>>2]&4095](s);return}function QTa(a){a=a|0;gTa(a);cYc(a);return}function RTa(a){a=a|0;ESa(a);cYc(a);return}function STa(a){a=a|0;a=$Xc(24)|0;ISa(a);return a|0}function TTa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(24)|0;ISa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15400,24);a=QXb(b,24)|0;JSa(a,b);c=a;return c|0}function UTa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function VTa(a){a=a|0;return f[a+4>>2]|0}function WTa(a){a=a|0;var b=0;jSa(a);b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function XTa(a){a=a|0;return 1}function YTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;d=a+20|0;e=f[d>>2]|0;if((e|0)==1){k$b(1,f[a+8>>2]|0,c);g=f[d>>2]|0}else g=e;if((g|0)==2){h$b(2,f[a+8>>2]|0,c);h=f[d>>2]|0}else h=g;if((h|0)==3){g=a+8|0;T_b(3,f[g>>2]|0,f[g+4>>2]|0,c);i=f[d>>2]|0}else i=h;if((i|0)==4){a$b(4,+n[a+8>>2],c);j=f[d>>2]|0}else j=i;if((j|0)==5){c$b(5,(b[a+8>>0]|0)!=0,c);k=f[d>>2]|0}else k=j;if((k|0)==6){d$b(6,f[a+8>>2]|0,c);l=f[d>>2]|0}else l=k;if((l|0)==7){k$b(7,f[a+8>>2]|0,c);m=f[d>>2]|0}else m=l;if((m|0)==8){k$b(8,f[a+8>>2]|0,c);o=f[d>>2]|0}else o=m;if((o|0)==9){m=a+8|0;l=f[m>>2]|0;k=b[l+11>>0]|0;if(k<<24>>24<0){p=f[l>>2]|0;q=f[l+4>>2]|0}else{p=l;q=k&255}m$b(p,q,1,399067)|0;if((f[d>>2]|0)==9)r=f[m>>2]|0;else r=537368;f$b(9,r,c);s=f[d>>2]|0}else s=o;if((s|0)==10)k$b(10,f[a+8>>2]|0,c);s=f[a+4>>2]|0;if(!((s&1|0)!=0&(b[476924]|0)!=0))return;Oqc(s&-2,c);return}function ZTa(a){a=a|0;return f[a+16>>2]|0}function _Ta(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=a+20|0;g=f[e>>2]|0;if((g|0)==1){h=f[a+8>>2]|0;b[d>>0]=10;i=d+1|0;j=_i[f[(f[h>>2]|0)+60>>2]&2047](h)|0;if(j>>>0>127){k=j;l=i;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=i;p=j}b[o>>0]=p;p=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,o+1|0)|0;q=p;r=f[e>>2]|0}else{q=d;r=g}if((r|0)==2){g=f[a+8>>2]|0;b[q>>0]=18;d=gZb(g,q+1|0)|0;s=d;t=f[e>>2]|0}else{s=q;t=r}if((t|0)==3){r=a+8|0;q=f[r>>2]|0;d=f[r+4>>2]|0;b[s>>0]=24;r=s+1|0;g=q&255;if(d>>>0>0|(d|0)==0&q>>>0>127){p=r;o=g;h=q;q=d;while(1){b[p>>0]=o|-128;d=h;h=l1c(h|0,q|0,7)|0;j=p+1|0;i=h&255;if(!(q>>>0>0|(q|0)==0&d>>>0>16383)){u=j;v=i;break}else{p=j;o=i;q=J}}}else{u=r;v=g}b[u>>0]=v;w=u+1|0;x=f[e>>2]|0}else{w=s;x=t}if((x|0)==4){t=f[a+8>>2]|0;b[w>>0]=37;s=w+1|0;b[s>>0]=t;b[s+1>>0]=t>>8;b[s+2>>0]=t>>16;b[s+3>>0]=t>>24;y=w+5|0;z=f[e>>2]|0}else{y=w;z=x}if((z|0)==5){x=b[a+8>>0]|0;b[y>>0]=40;b[y+1>>0]=x;A=y+2|0;B=f[e>>2]|0}else{A=y;B=z}if((B|0)==6){z=f[a+8>>2]|0;b[A>>0]=48;y=A+1|0;x=z&255;if(z>>>0>127){w=y;t=x;s=z;u=((z|0)<0)<<31>>31;while(1){b[w>>0]=t|-128;z=s;s=l1c(s|0,u|0,7)|0;v=w+1|0;g=s&255;if(!(u>>>0>0|(u|0)==0&z>>>0>16383)){C=v;D=g;break}else{w=v;t=g;u=J}}}else{C=y;D=x}b[C>>0]=D;E=C+1|0;F=f[e>>2]|0}else{E=A;F=B}if((F|0)==7){B=f[a+8>>2]|0;b[E>>0]=58;A=E+1|0;C=_i[f[(f[B>>2]|0)+60>>2]&2047](B)|0;if(C>>>0>127){D=C;x=A;while(1){b[x>>0]=D|128;y=D>>>7;u=x+1|0;if(D>>>0>16383){D=y;x=u}else{G=u;H=y;break}}}else{G=A;H=C}b[G>>0]=H;H=hj[f[(f[B>>2]|0)+64>>2]&511](B,c,G+1|0)|0;I=H;K=f[e>>2]|0}else{I=E;K=F}if((K|0)==8){F=f[a+8>>2]|0;b[I>>0]=66;E=I+1|0;H=_i[f[(f[F>>2]|0)+60>>2]&2047](F)|0;if(H>>>0>127){G=H;B=E;while(1){b[B>>0]=G|128;C=G>>>7;A=B+1|0;if(G>>>0>16383){G=C;B=A}else{L=A;M=C;break}}}else{L=E;M=H}b[L>>0]=M;M=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,L+1|0)|0;N=M;O=f[e>>2]|0}else{N=I;O=K}if((O|0)==9){K=a+8|0;I=f[K>>2]|0;M=b[I+11>>0]|0;if(M<<24>>24<0){P=f[I>>2]|0;Q=f[I+4>>2]|0}else{P=I;Q=M&255}m$b(P,Q,1,399067)|0;if((f[e>>2]|0)==9)R=f[K>>2]|0;else R=537368;b[N>>0]=74;K=gZb(R,N+1|0)|0;S=K;T=f[e>>2]|0}else{S=N;T=O}if((T|0)==10){T=f[a+8>>2]|0;b[S>>0]=82;O=S+1|0;N=_i[f[(f[T>>2]|0)+60>>2]&2047](T)|0;if(N>>>0>127){e=N;K=O;while(1){b[K>>0]=e|128;R=e>>>7;Q=K+1|0;if(e>>>0>16383){e=R;K=Q}else{U=Q;V=R;break}}}else{U=O;V=N}b[U>>0]=V;W=hj[f[(f[T>>2]|0)+64>>2]&511](T,c,U+1|0)|0}else W=S;S=f[a+4>>2]|0;if(!((S&1|0)!=0&(b[476924]|0)!=0)){X=W;return X|0}X=Pqc(S&-2,W)|0;return X|0}function $Ta(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;jSa(a);c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,15400,0)|0;if(!d){Ooc(b,a);return}else{kSa(a,d);return}}function aUa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15400,0)|0;if(!c){Ooc(b,a);return}else{kSa(a,c);return}}function bUa(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function cUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223024]|0)!=2){f[d>>2]=165456;f[d+4>>2]=3;b[d+8>>0]=0;J_b(892096,d);a_b(d)}d=530840;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function dUa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k&255;m=0}else{LYb(g,d);k=g;if(!(b[g+8>>0]|0)){n=0;u=a;return n|0}else{l=f[k>>2]|0;m=f[k+4>>2]|0}}k=f[e>>2]|0;i=e+4|0;o=f[i>>2]|0;if((k|0)==(o|0)){_Ma(e,k+1|0);p=f[e>>2]|0;q=f[i>>2]|0}else{p=k;q=o}o=e+8|0;k=f[o>>2]|0;i=p+1|0;f[e>>2]=i;r=k+8+(p<<3)|0;f[r>>2]=l;f[r+4>>2]=m;m=q-i|0;if((m|0)<=0){n=1;u=a;return n|0}q=g+8|0;r=c&127|128;l=c>>>7&255;if(c>>>0<128){p=m;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){n=1;x=27;break}if((h[v>>0]|0)!=(c|0)){n=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=s;A=t;B=w&255;C=0}else{LYb(g,d);w=g;if(!(b[q>>0]|0)){n=0;x=27;break}z=f[e>>2]|0;A=f[o>>2]|0;B=f[w>>2]|0;C=f[w+4>>2]|0}s=z+1|0;f[e>>2]=s;w=A+8+(z<<3)|0;f[w>>2]=B;f[w+4>>2]=C;if((p|0)<=1){n=1;x=27;break}else{p=p+-1|0;t=A}}if((x|0)==27){u=a;return n|0}}if(c>>>0<16384){D=m;E=i;F=k}else{n=1;u=a;return n|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;m=i;if((k-i|0)<=1){n=1;x=27;break}if((h[m>>0]|0)!=(r|0)){n=1;x=27;break}if((b[m+1>>0]|0)!=l<<24>>24){n=1;x=27;break}i=m+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=m+3;G=E;H=F;I=k&255;J=0}else{LYb(g,d);k=g;if(!(b[q>>0]|0)){n=0;x=27;break}G=f[e>>2]|0;H=f[o>>2]|0;I=f[k>>2]|0;J=f[k+4>>2]|0}E=G+1|0;f[e>>2]=E;k=H+8+(G<<3)|0;f[k>>2]=I;f[k+4>>2]=J;if((D|0)<=1){n=1;x=27;break}else{D=D+-1|0;F=H}}if((x|0)==27){u=a;return n|0}return 0}function eUa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;i=g;j=d+4|0;k=f[d>>2]|0;do if(((f[j>>2]|0)-k|0)>3){l=k;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;f[i>>2]=m;f[d>>2]=k+4;n=m}else{if(WYb(d,i)|0){n=f[i>>2]|0;break}o=0;u=g;return o|0}while(0);i=f[e>>2]|0;k=e+4|0;if((i|0)==(f[k>>2]|0)){uHa(e,i+1|0);p=f[e>>2]|0}else p=i;i=f[e+8>>2]|0;m=p+1|0;f[e>>2]=m;f[i+4+(p<<2)>>2]=n;n=f[d>>2]|0;p=(f[j>>2]|0)-n|0;if((p|0)<=0){o=1;u=g;return o|0}j=n;n=a+4|0;a=(f[k>>2]|0)-m|0;k=(p|0)/(n|0)|0;l=(k|0)<(a|0)?k:a;a:do if((l|0)>0){a=c&127|128;k=c>>>7&255;if(c>>>0<128){q=0;r=j;s=m;while(1){if((h[r>>0]|0)!=(c|0)){t=q;break a}v=r+1|0;w=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;v=s;s=s+1|0;f[e>>2]=s;f[i+4+(v<<2)>>2]=w;w=q+1|0;if((w|0)>=(l|0)){t=w;break a}else{q=w;r=r+5|0}}}if(c>>>0<16384){r=0;q=j;s=m;while(1){if((h[q>>0]|0)!=(a|0)){t=r;break a}if((b[q+1>>0]|0)!=k<<24>>24){t=r;break a}w=q+2|0;v=h[w>>0]|h[w+1>>0]<<8|h[w+2>>0]<<16|h[w+3>>0]<<24;w=s;s=s+1|0;f[e>>2]=s;f[i+4+(w<<2)>>2]=v;v=r+1|0;if((v|0)>=(l|0)){t=v;break}else{r=v;q=q+6|0}}}else t=0}else t=0;while(0);l=Y(t,n)|0;if((l|0)<=0){o=1;u=g;return o|0}if((p|0)<(l|0)){SYb(d,l,p)|0;o=1;u=g;return o|0}else{f[d>>2]=j+l;o=1;u=g;return o|0}return 0}function fUa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k<<24>>24!=0}else{LYb(g,d);k=g;if(!(b[g+8>>0]|0)){m=0;u=a;return m|0}else l=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0}k=f[e>>2]|0;i=e+4|0;n=f[i>>2]|0;if((k|0)==(n|0)){wSa(e,k+1|0);o=f[e>>2]|0;p=f[i>>2]|0}else{o=k;p=n}n=e+8|0;k=f[n>>2]|0;i=o+1|0;f[e>>2]=i;b[k+4+o>>0]=l&1;l=p-i|0;if((l|0)<=0){m=1;u=a;return m|0}p=g+8|0;o=c&127|128;q=c>>>7&255;if(c>>>0<128){r=l;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){m=1;x=27;break}if((h[v>>0]|0)!=(c|0)){m=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=w<<24>>24!=0;A=s;B=t}else{LYb(g,d);w=g;if(!(b[p>>0]|0)){m=0;x=27;break}z=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0;A=f[e>>2]|0;B=f[n>>2]|0}s=A+1|0;f[e>>2]=s;b[B+4+A>>0]=z&1;if((r|0)<=1){m=1;x=27;break}else{r=r+-1|0;t=B}}if((x|0)==27){u=a;return m|0}}if(c>>>0<16384){C=l;D=i;E=k}else{m=1;u=a;return m|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;l=i;if((k-i|0)<=1){m=1;x=27;break}if((h[l>>0]|0)!=(o|0)){m=1;x=27;break}if((b[l+1>>0]|0)!=q<<24>>24){m=1;x=27;break}i=l+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=l+3;F=k<<24>>24!=0;G=D;H=E}else{LYb(g,d);k=g;if(!(b[p>>0]|0)){m=0;x=27;break}F=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0;G=f[e>>2]|0;H=f[n>>2]|0}D=G+1|0;f[e>>2]=D;b[H+4+G>>0]=F&1;if((C|0)<=1){m=1;x=27;break}else{C=C+-1|0;E=H}}if((x|0)==27){u=a;return m|0}return 0}function gUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223025]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=4;b[c+8>>0]=0;J_b(892100,c);a_b(c);u=a;return}function hUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223027]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=6;b[c+8>>0]=0;J_b(892108,c);a_b(c);u=a;return}function iUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223025]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=4;b[c+8>>0]=0;J_b(892100,c);a_b(c);u=a;return}function jUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=82968;d=a+4|0;f[d>>2]=0;f[a+16>>2]=0;e=f[c+4>>2]|0;if(e&1|0)vqc(lSa(d)|0,e&-2);e=a+20|0;f[e>>2]=0;d=c+20|0;do switch(f[d>>2]|0){case 2:{g=f[c+8>>2]|0;jSa(a);f[e>>2]=2;h=a+8|0;f[h>>2]=537368;i=f[a+4>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,g);return}else{oYc(j,g)|0;return}break}case 3:{g=c+8|0;j=f[g>>2]|0;h=f[g+4>>2]|0;jSa(a);f[e>>2]=3;g=a+8|0;f[g>>2]=j;f[g+4>>2]=h;return}case 4:{h=f[c+8>>2]|0;jSa(a);f[e>>2]=4;f[a+8>>2]=h;return}case 5:{h=b[c+8>>0]|0;jSa(a);f[e>>2]=5;b[a+8>>0]=h;return}case 6:{h=f[c+8>>2]|0;jSa(a);f[e>>2]=6;f[a+8>>2]=h;return}case 7:{JXa(mSa(a)|0,(f[d>>2]|0)==7?f[c+8>>2]|0:531248);return}case 8:{LUa(vJa(a)|0,(f[d>>2]|0)==8?f[c+8>>2]|0:530864);return}case 1:{oSa(nSa(a)|0,(f[d>>2]|0)==1?f[c+8>>2]|0:530552);return}case 10:{qSa(pSa(a)|0,(f[d>>2]|0)==10?f[c+8>>2]|0:530776);return}case 9:{h=f[c+8>>2]|0;jSa(a);f[e>>2]=9;g=a+8|0;f[g>>2]=537368;j=f[a+4>>2]|0;i=j&-2;if(!(j&1))l=i;else l=f[i+4>>2]|0;i=f[g>>2]|0;if((i|0)==537368){xJa(g,l,h);return}else{oYc(i,h)|0;return}break}default:return}while(0)}function kUa(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;jSa(a);c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);kSa(a,b);return}function lUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223030]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=7;b[c+8>>0]=0;J_b(892120,c);a_b(c);u=a;return}function mUa(){n3b(399402,757);Boc(400160,2248);return}function nUa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223031]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=8;b[c+8>>0]=0;J_b(892124,c);a_b(c);u=a;return}function oUa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223030]|0)!=2){f[c>>2]=165456;f[c+4>>2]=7;b[c+8>>0]=0;J_b(892120,c);a_b(c)}d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=11;e=d;g=400160;h=e+11|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+11>>0]=0;ejc(c,0,0,892116,0,0,892112,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function pUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223030]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=7;b[c+8>>0]=0;J_b(892120,c);a_b(c);u=a;return}function qUa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=83804;c=f[a+152>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=530864?(c=f[a+156>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+144>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+128>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+112>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+96>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+80>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+68|0;d=f[c>>2]|0;if(d|0?(f[a+56>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=f[a+48>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+32>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+16>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[c>>2]=0;return}function rUa(a){a=a|0;qUa(a);cYc(a);return}function sUa(a){a=a|0;a=$Xc(172)|0;PUa(a);return a|0}function tUa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(172)|0;PUa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15504,176);a=QXb(b,176)|0;QUa(a,b);c=a;return c|0}function uUa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function vUa(a){a=a|0;return f[a+4>>2]|0}function wUa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a+8>>2]=0;f[a+24>>2]=0;f[a+40>>2]=0;c=a+60|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+68>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+72>>2]=0;f[a+88>>2]=0;f[a+104>>2]=0;f[a+120>>2]=0;f[a+136>>2]=0;c=a+4|0;d=f[a+152>>2]|0;do if((d|0)!=537368){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[c>>2]|0;g=d&-2;if(!(d&1))j=g;else j=f[g+4>>2]|0;g=a+156|0;if((j|0)==0?(j=f[g>>2]|0,(j|0)!=0):0){Yi[f[(f[j>>2]|0)+4>>2]&4095](j);k=f[c>>2]|0}else k=d;f[g>>2]=0;g=a+160|0;f[g>>2]=0;f[g+4>>2]=0;if(!(k&1))return;g=k&-2;if(!(f[g>>2]|0))return;sqc(g);return}function xUa(a){a=a|0;return 1}function yUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+160|0;j=a+156|0;k=e+4|0;l=a+164|0;m=a+152|0;n=a+4|0;o=a+8|0;q=a+12|0;r=a+16|0;t=a+24|0;v=a+28|0;w=a+32|0;x=a+40|0;y=a+44|0;z=a+48|0;A=a+56|0;B=a+72|0;C=a+76|0;D=a+80|0;E=a+88|0;F=a+92|0;G=a+96|0;H=e+8|0;I=a+104|0;K=a+108|0;L=a+112|0;M=e+8|0;N=a+120|0;O=a+124|0;P=a+128|0;Q=a+136|0;R=a+140|0;S=a+144|0;a:while(1){T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0){U=b[T>>0]|0;V=U&255;if(U<<24>>24>0){f[c>>2]=T+1;W=V;X=6}else{Y=V;X=5}}else{Y=0;X=5}if((X|0)==5){X=0;V=ZYb(c,Y)|0;if((V+-1|0)>>>0<127){W=V;X=6}else Z=V}b:do if((X|0)==6){X=0;do switch(W>>>3&536870911|0){case 1:{if((W&255|0)!=8){Z=W;break b}V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0){T=b[V>>0]|0;U=T&255;if(T<<24>>24>-1){f[c>>2]=V+1;_=U}else{$=U;X=11}}else{$=0;X=11}if((X|0)==11){X=0;U=KYb(c,$)|0;V=J;if((V|0)>-1|(V|0)==-1&U>>>0>4294967295)_=U;else{aa=0;X=196;break a}}f[i>>2]=_;continue a;break}case 2:{if((W&255|0)!=18){Z=W;break b}U=f[j>>2]|0;if(!U){MUa(a);ba=f[j>>2]|0}else ba=U;U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(V=b[U>>0]|0,V<<24>>24>-1):0){f[c>>2]=U+1;ca=V&255}else{V=YYb(c)|0;if((V|0)>-1)ca=V;else{aa=0;X=196;break a}}JYb(e,c,ca);if((f[k>>2]|0)<0){X=22;break a}if(!(Mi[f[(f[ba>>2]|0)+44>>2]&1023](ba,c)|0)){X=22;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{aa=0;X=196;break a}break}case 3:{if((W&255|0)!=24){Z=W;break b}V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0){U=b[V>>0]|0;T=U&255;if(U<<24>>24>-1){f[c>>2]=V+1;da=T}else{ea=T;X=28}}else{ea=0;X=28}if((X|0)==28){X=0;T=KYb(c,ea)|0;V=J;if((V|0)>-1|(V|0)==-1&T>>>0>4294967295)da=T;else{aa=0;X=196;break a}}f[l>>2]=da;continue a;break}case 4:{if((W&255|0)!=34){Z=W;break b}T=f[n>>2]|0;V=T&-2;if(!(T&1))fa=V;else fa=f[V+4>>2]|0;V=f[m>>2]|0;if((V|0)==537368){xJa(m,fa,537368);ga=f[m>>2]|0}else ga=V;if(l$b(c,ga)|0)continue a;else{aa=0;X=196;break a}break}case 5:{switch((W&255)<<24>>24){case 42:break;case 45:{if(eUa(1,42,c,o)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0?(T=b[V>>0]|0,T<<24>>24>-1):0){f[c>>2]=V+1;ha=T&255}else{T=YYb(c)|0;if((T|0)>-1)ha=T;else{aa=0;X=196;break a}}ia=f[o>>2]|0;T=(ha|0)/4|0;if((T<<2|0)!=(ha|0)){aa=0;X=196;break a}V=RYb(c)|0;U=PYb(c)|0;if((((V|0)==-1|(U|0)<(V|0)?U:V)|0)>=(ha|0)){V=ia+T|0;if((f[o>>2]|0)<(V|0)?(uHa(o,V),U=f[o>>2]|0,ja=V-U|0,(ja<<2|0)>0):0)g1c((f[r>>2]|0)+((U<<2)+4)|0,0,(((ja|-1073741824|0)==-1073741824?1073741823:1073741822)+ja<<2)+8|0)|0;f[o>>2]=V;V=f[r>>2]|0;if(TYb(c,((V|0)==0?0:V+4|0)+(ia<<2)|0,ha)|0)continue a;else{X=49;break a}}if((ha|0)>3)ka=0;else continue a;while(1){V=f[c>>2]|0;if(((f[g>>2]|0)-V|0)>3){ja=V;U=h[ja>>0]|h[ja+1>>0]<<8|h[ja+2>>0]<<16|h[ja+3>>0]<<24;f[e>>2]=U;f[c>>2]=V+4;la=U}else{if(!(WYb(c,e)|0)){X=58;break a}la=f[e>>2]|0}U=f[o>>2]|0;if((U|0)==(f[q>>2]|0)){uHa(o,U+1|0);ma=f[o>>2]|0}else ma=U;U=f[r>>2]|0;f[o>>2]=ma+1;f[U+4+(ma<<2)>>2]=la;U=ka+1|0;if((U|0)<(T|0))ka=U;else continue a}break}case 6:{switch((W&255)<<24>>24){case 50:break;case 49:{if(NUa(1,50,c,t)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0?(U=b[T>>0]|0,U<<24>>24>-1):0){f[c>>2]=T+1;na=U&255}else{U=YYb(c)|0;if((U|0)>-1)na=U;else{aa=0;X=196;break a}}oa=f[t>>2]|0;U=(na|0)/8|0;if((U<<3|0)!=(na|0)){aa=0;X=196;break a}T=RYb(c)|0;V=PYb(c)|0;if((((T|0)==-1|(V|0)<(T|0)?V:T)|0)>=(na|0)){T=oa+U|0;if((f[t>>2]|0)<(T|0)?(ZMa(t,T),V=f[t>>2]|0,ja=T-V|0,(ja<<3|0)>0):0)g1c((f[w>>2]|0)+((V<<3)+8)|0,0,(((ja|-536870912|0)==-536870912?536870911:536870910)+ja<<3)+16|0)|0;f[t>>2]=T;T=f[w>>2]|0;if(TYb(c,((T|0)==0?0:T+8|0)+(oa<<3)|0,na)|0)continue a;else{X=72;break a}}if((na|0)>7)pa=0;else continue a;while(1){T=f[c>>2]|0;if(((f[g>>2]|0)-T|0)>7){ja=T;V=ja;qa=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;V=ja+4|0;ja=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;V=e;f[V>>2]=qa;f[V+4>>2]=ja;f[c>>2]=T+8;f[s>>2]=qa;f[s+4>>2]=ja;ra=+p[s>>3]}else{if(!(XYb(c,e)|0)){X=81;break a}ra=+p[e>>3]}ja=f[t>>2]|0;if((ja|0)==(f[v>>2]|0)){ZMa(t,ja+1|0);sa=f[t>>2]|0}else sa=ja;ja=f[w>>2]|0;f[t>>2]=sa+1;p[ja+8+(sa<<3)>>3]=ra;ja=pa+1|0;if((ja|0)<(U|0))pa=ja;else continue a}break}case 7:{switch((W&255)<<24>>24){case 58:break;case 56:{if(OUa(1,58,c,x)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(ja=b[U>>0]|0,ja<<24>>24>-1):0){f[c>>2]=U+1;ta=ja&255}else{ja=YYb(c)|0;if((ja|0)>-1)ta=ja;else{aa=0;X=196;break a}}ja=HYb(c,ta)|0;if((PYb(c)|0)>0)do{U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0){qa=b[U>>0]|0;T=qa&255;if(qa<<24>>24>-1){f[c>>2]=U+1;ua=T}else{va=T;X=92}}else{va=0;X=92}if((X|0)==92){X=0;T=KYb(c,va)|0;U=J;if((U|0)>-1|(U|0)==-1&T>>>0>4294967295)ua=T;else{aa=0;X=196;break a}}T=f[x>>2]|0;if((T|0)==(f[y>>2]|0)){qHa(x,T+1|0);wa=f[x>>2]|0}else wa=T;T=f[z>>2]|0;f[x>>2]=wa+1;f[T+4+(wa<<2)>>2]=ua}while((PYb(c)|0)>0);IYb(c,ja);continue a;break}case 8:{if((W&255|0)!=66){Z=W;break b}if(l$b(c,pHa(A)|0)|0)continue a;else{aa=0;X=196;break a}break}case 9:{switch((W&255)<<24>>24){case 74:break;case 77:{if(eUa(1,74,c,B)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0?(U=b[T>>0]|0,U<<24>>24>-1):0){f[c>>2]=T+1;xa=U&255}else{U=YYb(c)|0;if((U|0)>-1)xa=U;else{aa=0;X=196;break a}}ya=f[B>>2]|0;U=(xa|0)/4|0;if((U<<2|0)!=(xa|0)){aa=0;X=196;break a}T=RYb(c)|0;qa=PYb(c)|0;if((((T|0)==-1|(qa|0)<(T|0)?qa:T)|0)>=(xa|0)){T=ya+U|0;if((f[B>>2]|0)<(T|0)?(uHa(B,T),qa=f[B>>2]|0,V=T-qa|0,(V<<2|0)>0):0)g1c((f[D>>2]|0)+((qa<<2)+4)|0,0,(((V|-1073741824|0)==-1073741824?1073741823:1073741822)+V<<2)+8|0)|0;f[B>>2]=T;T=f[D>>2]|0;if(TYb(c,((T|0)==0?0:T+4|0)+(ya<<2)|0,xa)|0)continue a;else{X=112;break a}}if((xa|0)>3)za=0;else continue a;while(1){T=f[c>>2]|0;if(((f[g>>2]|0)-T|0)>3){V=T;qa=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;f[e>>2]=qa;f[c>>2]=T+4;Aa=qa}else{if(!(WYb(c,e)|0)){X=121;break a}Aa=f[e>>2]|0}qa=f[B>>2]|0;if((qa|0)==(f[C>>2]|0)){uHa(B,qa+1|0);Ba=f[B>>2]|0}else Ba=qa;qa=f[D>>2]|0;f[B>>2]=Ba+1;f[qa+4+(Ba<<2)>>2]=Aa;qa=za+1|0;if((qa|0)<(U|0))za=qa;else continue a}break}case 10:{switch((W&255)<<24>>24){case 82:break;case 80:{if(dUa(1,82,c,E)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(ja=b[U>>0]|0,ja<<24>>24>-1):0){f[c>>2]=U+1;Ca=ja&255}else{ja=YYb(c)|0;if((ja|0)>-1)Ca=ja;else{aa=0;X=196;break a}}ja=HYb(c,Ca)|0;if((PYb(c)|0)>0)do{U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(qa=b[U>>0]|0,qa<<24>>24>-1):0){f[c>>2]=U+1;Da=qa&255;Ea=0}else{LYb(e,c);qa=e;if(!(b[H>>0]|0)){aa=0;X=196;break a}else{Da=f[qa>>2]|0;Ea=f[qa+4>>2]|0}}qa=f[E>>2]|0;if((qa|0)==(f[F>>2]|0)){_Ma(E,qa+1|0);Fa=f[E>>2]|0}else Fa=qa;qa=f[G>>2]|0;f[E>>2]=Fa+1;U=qa+8+(Fa<<3)|0;f[U>>2]=Da;f[U+4>>2]=Ea}while((PYb(c)|0)>0);IYb(c,ja);continue a;break}case 11:{switch((W&255)<<24>>24){case 90:break;case 88:{if(fUa(1,90,c,I)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(qa=b[U>>0]|0,qa<<24>>24>-1):0){f[c>>2]=U+1;Ga=qa&255}else{qa=YYb(c)|0;if((qa|0)>-1)Ga=qa;else{aa=0;X=196;break a}}qa=HYb(c,Ga)|0;if((PYb(c)|0)>0)do{U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(T=b[U>>0]|0,T<<24>>24>-1):0){f[c>>2]=U+1;Ha=T<<24>>24!=0}else{LYb(e,c);T=e;if(!(b[M>>0]|0)){aa=0;X=196;break a}else Ha=(f[T>>2]|0)!=0|(f[T+4>>2]|0)!=0}T=f[I>>2]|0;if((T|0)==(f[K>>2]|0)){wSa(I,T+1|0);Ia=f[I>>2]|0}else Ia=T;T=f[L>>2]|0;f[I>>2]=Ia+1;b[T+4+Ia>>0]=Ha&1}while((PYb(c)|0)>0);IYb(c,qa);continue a;break}case 12:{switch((W&255)<<24>>24){case 98:break;case 97:{if(NUa(1,98,c,N)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(T=b[ja>>0]|0,T<<24>>24>-1):0){f[c>>2]=ja+1;Ja=T&255}else{T=YYb(c)|0;if((T|0)>-1)Ja=T;else{aa=0;X=196;break a}}Ka=f[N>>2]|0;T=(Ja|0)/8|0;if((T<<3|0)!=(Ja|0)){aa=0;X=196;break a}ja=RYb(c)|0;U=PYb(c)|0;if((((ja|0)==-1|(U|0)<(ja|0)?U:ja)|0)>=(Ja|0)){ja=Ka+T|0;if((f[N>>2]|0)<(ja|0)?(ZMa(N,ja),U=f[N>>2]|0,V=ja-U|0,(V<<3|0)>0):0)g1c((f[P>>2]|0)+((U<<3)+8)|0,0,(((V|-536870912|0)==-536870912?536870911:536870910)+V<<3)+16|0)|0;f[N>>2]=ja;ja=f[P>>2]|0;if(TYb(c,((ja|0)==0?0:ja+8|0)+(Ka<<3)|0,Ja)|0)continue a;else{X=165;break a}}if((Ja|0)>7)La=0;else continue a;while(1){ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>7){V=ja;U=V;Ma=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=V+4|0;V=h[U>>0]|h[U+1>>0]<<8|h[U+2>>0]<<16|h[U+3>>0]<<24;U=e;f[U>>2]=Ma;f[U+4>>2]=V;f[c>>2]=ja+8;f[s>>2]=Ma;f[s+4>>2]=V;Na=+p[s>>3]}else{if(!(XYb(c,e)|0)){X=174;break a}Na=+p[e>>3]}V=f[N>>2]|0;if((V|0)==(f[O>>2]|0)){ZMa(N,V+1|0);Oa=f[N>>2]|0}else Oa=V;V=f[P>>2]|0;f[N>>2]=Oa+1;p[V+8+(Oa<<3)>>3]=Na;V=La+1|0;if((V|0)<(T|0))La=V;else continue a}break}case 13:{switch((W&255)<<24>>24){case 106:break;case 104:{if(OUa(1,106,c,Q)|0)continue a;else{aa=0;X=196;break a}break}default:{Z=W;break b}}T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0?(qa=b[T>>0]|0,qa<<24>>24>-1):0){f[c>>2]=T+1;Pa=qa&255}else{qa=YYb(c)|0;if((qa|0)>-1)Pa=qa;else{aa=0;X=196;break a}}qa=HYb(c,Pa)|0;if((PYb(c)|0)>0)do{T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0){V=b[T>>0]|0;Ma=V&255;if(V<<24>>24>-1){f[c>>2]=T+1;Qa=Ma}else{Ra=Ma;X=185}}else{Ra=0;X=185}if((X|0)==185){X=0;Ma=KYb(c,Ra)|0;T=J;if((T|0)>-1|(T|0)==-1&Ma>>>0>4294967295)Qa=Ma;else{aa=0;X=196;break a}}Ma=f[Q>>2]|0;if((Ma|0)==(f[R>>2]|0)){qHa(Q,Ma+1|0);Sa=f[Q>>2]|0}else Sa=Ma;Ma=f[S>>2]|0;f[Q>>2]=Sa+1;f[Ma+4+(Sa<<2)>>2]=Qa}while((PYb(c)|0)>0);IYb(c,qa);continue a;break}default:{Z=W;break b}}while(0)}while(0);if(!Z){aa=1;X=196;break}Ma=f[n>>2]|0;if(!(Ma&1))Ta=lSa(n)|0;else Ta=Ma&-2;if(!(Lqc(c,Z,Ta)|0)){aa=0;X=196;break}}switch(X|0){case 22:{aa=0;u=d;return aa|0}case 49:{if((f[o>>2]|0)<=0){aa=0;u=d;return aa|0}f[o>>2]=ia;aa=0;u=d;return aa|0}case 58:{aa=0;u=d;return aa|0}case 72:{if((f[t>>2]|0)<=0){aa=0;u=d;return aa|0}f[t>>2]=oa;aa=0;u=d;return aa|0}case 81:{aa=0;u=d;return aa|0}case 112:{if((f[B>>2]|0)<=0){aa=0;u=d;return aa|0}f[B>>2]=ya;aa=0;u=d;return aa|0}case 121:{aa=0;u=d;return aa|0}case 165:{if((f[N>>2]|0)<=0){aa=0;u=d;return aa|0}f[N>>2]=Ka;aa=0;u=d;return aa|0}case 174:{aa=0;u=d;return aa|0}case 196:{u=d;return aa|0}}return 0}function zUa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+8>>2]<<2;if(!c)e=d;else{if((c|0)<0)g=10;else g=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;e=d+1+g|0}f[a+20>>2]=c;g=e+c|0;c=f[a+24>>2]<<3;if(!c)h=g;else{if((c|0)<0)i=10;else i=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;h=g+1+i|0}f[a+36>>2]=c;i=h+c|0;c=n$b(a+40|0)|0;if(!c)j=i;else{if((c|0)<0)k=10;else k=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;j=i+1+k|0}f[a+52>>2]=c;k=f[a+60>>2]|0;i=j+c+k|0;if((k|0)>0){c=f[a+68>>2]|0;j=0;h=i;while(1){g=f[c+4+(j<<2)>>2]|0;e=b[g+11>>0]|0;d=e<<24>>24<0?f[g+4>>2]|0:e&255;e=d+h+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=j+1|0;if((j|0)==(k|0)){l=e;break}else h=e}}else l=i;i=f[a+72>>2]<<2;if(!i)m=l;else{if((i|0)<0)n=10;else n=(((($(i|1|0)|0)^31)*9|0)+73|0)>>>6;m=l+1+n|0}f[a+84>>2]=i;n=m+i|0;i=f[a+88>>2]|0;if((i|0)>0){m=f[a+96>>2]|0;l=0;h=0;do{k=m+8+(h<<3)|0;j=t1c(f[k>>2]|1|0,f[k+4>>2]|0,1)|0;l=((((j^63)*9|0)+73|0)>>>6)+l|0;h=h+1|0}while((h|0)!=(i|0));if(l){if((l|0)<0)o=11;else o=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=l;q=o+n|0}else{p=0;q=n}}else{p=0;q=n}f[a+100>>2]=p;n=q+p|0;p=f[a+104>>2]|0;if(!p)r=n;else{if((p|0)<0)s=11;else s=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+n|0}f[a+116>>2]=p;n=r+p|0;p=f[a+120>>2]<<3;if(!p)t=n;else{if((p|0)<0)u=11;else u=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;t=u+n|0}f[a+132>>2]=p;n=t+p|0;p=n$b(a+136|0)|0;if(!p)v=n;else{if((p|0)<0)w=11;else w=((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;v=w+n|0}f[a+148>>2]=p;n=v+p|0;p=f[a+152>>2]|0;v=b[p+11>>0]|0;w=v<<24>>24<0;if(w)x=f[p+4>>2]|0;else x=v&255;if(!x)y=n;else{x=w?f[p+4>>2]|0:v&255;y=n+1+x+((((($(x|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if((a|0)!=530864?(x=f[a+156>>2]|0,(x|0)!=0):0){n=_i[f[(f[x>>2]|0)+48>>2]&2047](x)|0;z=y+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else z=y;y=f[a+160>>2]|0;if(!y)A=z;else{if((y|0)<0)B=11;else B=((((($(y|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;A=B+z|0}z=f[a+164>>2]|0;if(!z){C=A;D=a+168|0;f[D>>2]=C;return C|0}if((z|0)<0)E=11;else E=((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;C=E+A|0;D=a+168|0;f[D>>2]=C;return C|0}function AUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=f[a+160>>2]|0;if(d|0)d$b(1,d,c);if((a|0)!=530864?(d=f[a+156>>2]|0,d|0):0)k$b(2,d,c);d=f[a+164>>2]|0;if(d|0)S_b(3,d,c);d=f[a+152>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;if(g|0)h$b(4,d,c);d=a+8|0;if((f[d>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=42;f[e>>2]=(f[e>>2]|0)+1;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;h=e}else{eZb(c,42);h=f[g>>2]|0}e=f[a+20>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else eZb(c,e);e=f[a+16>>2]|0;P_b((e|0)==0?0:e+4|0,f[d>>2]|0,c)}d=a+24|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){o=c+4|0;b[f[o>>2]>>0]=50;f[o>>2]=(f[o>>2]|0)+1;o=(f[e>>2]|0)+-1|0;f[e>>2]=o;p=o}else{eZb(c,50);p=f[e>>2]|0}o=f[a+36>>2]|0;if((p|0)>4){p=c+4|0;g=f[p>>2]|0;if(o>>>0>127){h=o;i=g;while(1){b[i>>0]=h|128;n=h>>>7;k=i+1|0;if(h>>>0>16383){h=n;i=k}else{q=k;r=n;break}}}else{q=g;r=o}b[q>>0]=r;r=q+1-g|0;f[p>>2]=(f[p>>2]|0)+r;f[e>>2]=(f[e>>2]|0)-r}else eZb(c,o);o=f[a+32>>2]|0;Q_b((o|0)==0?0:o+8|0,f[d>>2]|0,c)}d=a+40|0;if((f[d>>2]|0)>0){o=c+8|0;if((f[o>>2]|0)>4){r=c+4|0;b[f[r>>2]>>0]=58;f[r>>2]=(f[r>>2]|0)+1;r=(f[o>>2]|0)+-1|0;f[o>>2]=r;s=r}else{eZb(c,58);s=f[o>>2]|0}r=f[a+52>>2]|0;if((s|0)>4){s=c+4|0;e=f[s>>2]|0;if(r>>>0>127){p=r;g=e;while(1){b[g>>0]=p|128;q=p>>>7;i=g+1|0;if(p>>>0>16383){p=q;g=i}else{t=i;u=q;break}}}else{t=e;u=r}b[t>>0]=u;u=t+1-e|0;f[s>>2]=(f[s>>2]|0)+u;f[o>>2]=(f[o>>2]|0)-u}else eZb(c,r);r=f[d>>2]|0;if((r|0)>0){d=a+48|0;u=c+8|0;o=c+4|0;s=0;do{e=f[(f[d>>2]|0)+4+(s<<2)>>2]|0;t=((e|0)<0)<<31>>31;if((f[u>>2]|0)>9){g=f[o>>2]|0;p=e&255;if(e>>>0>127){q=g;i=p;h=e;n=t;while(1){b[q>>0]=i|-128;k=h;h=l1c(h|0,n|0,7)|0;j=q+1|0;l=h&255;if(!(n>>>0>0|(n|0)==0&k>>>0>16383)){v=j;w=l;break}else{q=j;i=l;n=J}}}else{v=g;w=p}b[v>>0]=w;n=v+1-g|0;f[o>>2]=(f[o>>2]|0)+n;f[u>>2]=(f[u>>2]|0)-n}else fZb(c,e,t);s=s+1|0}while((s|0)!=(r|0))}}r=f[a+60>>2]|0;if((r|0)>0){s=a+68|0;u=0;do{g$b(8,f[(f[s>>2]|0)+4+(u<<2)>>2]|0,c);u=u+1|0}while((u|0)!=(r|0))}r=a+72|0;if((f[r>>2]|0)>0){u=c+8|0;if((f[u>>2]|0)>4){s=c+4|0;b[f[s>>2]>>0]=74;f[s>>2]=(f[s>>2]|0)+1;s=(f[u>>2]|0)+-1|0;f[u>>2]=s;x=s}else{eZb(c,74);x=f[u>>2]|0}s=f[a+84>>2]|0;if((x|0)>4){x=c+4|0;o=f[x>>2]|0;if(s>>>0>127){v=s;w=o;while(1){b[w>>0]=v|128;d=v>>>7;n=w+1|0;if(v>>>0>16383){v=d;w=n}else{y=n;z=d;break}}}else{y=o;z=s}b[y>>0]=z;z=y+1-o|0;f[x>>2]=(f[x>>2]|0)+z;f[u>>2]=(f[u>>2]|0)-z}else eZb(c,s);s=f[a+80>>2]|0;P_b((s|0)==0?0:s+4|0,f[r>>2]|0,c)}r=a+88|0;if((f[r>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){z=c+4|0;b[f[z>>2]>>0]=82;f[z>>2]=(f[z>>2]|0)+1;z=(f[s>>2]|0)+-1|0;f[s>>2]=z;A=z}else{eZb(c,82);A=f[s>>2]|0}z=f[a+100>>2]|0;if((A|0)>4){A=c+4|0;u=f[A>>2]|0;if(z>>>0>127){x=z;o=u;while(1){b[o>>0]=x|128;y=x>>>7;w=o+1|0;if(x>>>0>16383){x=y;o=w}else{B=w;C=y;break}}}else{B=u;C=z}b[B>>0]=C;C=B+1-u|0;f[A>>2]=(f[A>>2]|0)+C;f[s>>2]=(f[s>>2]|0)-C}else eZb(c,z);z=f[r>>2]|0;if((z|0)>0){r=a+96|0;C=c+8|0;s=c+4|0;A=0;do{u=(f[r>>2]|0)+8+(A<<3)|0;B=f[u>>2]|0;o=f[u+4>>2]|0;if((f[C>>2]|0)>9){u=f[s>>2]|0;x=B&255;if(o>>>0>0|(o|0)==0&B>>>0>127){y=u;w=x;v=B;d=o;while(1){b[y>>0]=w|-128;n=v;v=l1c(v|0,d|0,7)|0;i=y+1|0;q=v&255;if(!(d>>>0>0|(d|0)==0&n>>>0>16383)){D=i;E=q;break}else{y=i;w=q;d=J}}}else{D=u;E=x}b[D>>0]=E;d=D+1-u|0;f[s>>2]=(f[s>>2]|0)+d;f[C>>2]=(f[C>>2]|0)-d}else fZb(c,B,o);A=A+1|0}while((A|0)!=(z|0))}}z=a+104|0;if((f[z>>2]|0)>0){A=c+8|0;if((f[A>>2]|0)>4){C=c+4|0;b[f[C>>2]>>0]=90;f[C>>2]=(f[C>>2]|0)+1;C=(f[A>>2]|0)+-1|0;f[A>>2]=C;F=C}else{eZb(c,90);F=f[A>>2]|0}C=f[a+116>>2]|0;if((F|0)>4){F=c+4|0;s=f[F>>2]|0;if(C>>>0>127){D=C;E=s;while(1){b[E>>0]=D|128;r=D>>>7;d=E+1|0;if(D>>>0>16383){D=r;E=d}else{G=d;H=r;break}}}else{G=s;H=C}b[G>>0]=H;H=G+1-s|0;f[F>>2]=(f[F>>2]|0)+H;f[A>>2]=(f[A>>2]|0)-H}else eZb(c,C);C=f[a+112>>2]|0;R_b((C|0)==0?0:C+4|0,f[z>>2]|0,c)}z=a+120|0;if((f[z>>2]|0)>0){C=c+8|0;if((f[C>>2]|0)>4){H=c+4|0;b[f[H>>2]>>0]=98;f[H>>2]=(f[H>>2]|0)+1;H=(f[C>>2]|0)+-1|0;f[C>>2]=H;I=H}else{eZb(c,98);I=f[C>>2]|0}H=f[a+132>>2]|0;if((I|0)>4){I=c+4|0;A=f[I>>2]|0;if(H>>>0>127){F=H;s=A;while(1){b[s>>0]=F|128;G=F>>>7;E=s+1|0;if(F>>>0>16383){F=G;s=E}else{K=E;L=G;break}}}else{K=A;L=H}b[K>>0]=L;L=K+1-A|0;f[I>>2]=(f[I>>2]|0)+L;f[C>>2]=(f[C>>2]|0)-L}else eZb(c,H);H=f[a+128>>2]|0;Q_b((H|0)==0?0:H+8|0,f[z>>2]|0,c)}z=a+136|0;if((f[z>>2]|0)>0){H=c+8|0;if((f[H>>2]|0)>4){L=c+4|0;b[f[L>>2]>>0]=106;f[L>>2]=(f[L>>2]|0)+1;L=(f[H>>2]|0)+-1|0;f[H>>2]=L;M=L}else{eZb(c,106);M=f[H>>2]|0}L=f[a+148>>2]|0;if((M|0)>4){M=c+4|0;C=f[M>>2]|0;if(L>>>0>127){I=L;A=C;while(1){b[A>>0]=I|128;K=I>>>7;s=A+1|0;if(I>>>0>16383){I=K;A=s}else{N=s;O=K;break}}}else{N=C;O=L}b[N>>0]=O;O=N+1-C|0;f[M>>2]=(f[M>>2]|0)+O;f[H>>2]=(f[H>>2]|0)-O}else eZb(c,L);L=f[z>>2]|0;if((L|0)>0){z=a+144|0;O=c+8|0;H=c+4|0;M=0;do{C=f[(f[z>>2]|0)+4+(M<<2)>>2]|0;N=((C|0)<0)<<31>>31;if((f[O>>2]|0)>9){A=f[H>>2]|0;I=C&255;if(C>>>0>127){K=A;s=I;F=C;G=N;while(1){b[K>>0]=s|-128;E=F;F=l1c(F|0,G|0,7)|0;D=K+1|0;r=F&255;if(!(G>>>0>0|(G|0)==0&E>>>0>16383)){P=D;Q=r;break}else{K=D;s=r;G=J}}}else{P=A;Q=I}b[P>>0]=Q;G=P+1-A|0;f[H>>2]=(f[H>>2]|0)+G;f[O>>2]=(f[O>>2]|0)-G}else fZb(c,C,N);M=M+1|0}while((M|0)!=(L|0))}}L=f[a+4>>2]|0;if(!((L&1|0)!=0&(b[476924]|0)!=0))return;Oqc(L&-2,c);return}function BUa(a){a=a|0;return f[a+168>>2]|0}function CUa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=f[a+160>>2]|0;if(!e)g=d;else{b[d>>0]=8;h=d+1|0;d=e&255;if(e>>>0>127){i=h;j=d;k=e;l=((e|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;e=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&e>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;g=o+1|0}if((a|0)!=530864?(o=f[a+156>>2]|0,(o|0)!=0):0){b[g>>0]=18;p=g+1|0;d=_i[f[(f[o>>2]|0)+60>>2]&2047](o)|0;if(d>>>0>127){h=d;l=p;while(1){b[l>>0]=h|128;j=h>>>7;i=l+1|0;if(h>>>0>16383){h=j;l=i}else{q=i;r=j;break}}}else{q=p;r=d}b[q>>0]=r;s=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,q+1|0)|0}else s=g;g=f[a+164>>2]|0;if(!g)t=s;else{b[s>>0]=24;q=s+1|0;s=g&255;if(g>>>0>127){c=q;o=s;r=g;d=((g|0)<0)<<31>>31;while(1){b[c>>0]=o|-128;g=r;r=l1c(r|0,d|0,7)|0;p=c+1|0;l=r&255;if(!(d>>>0>0|(d|0)==0&g>>>0>16383)){u=p;v=l;break}else{c=p;o=l;d=J}}}else{u=q;v=s}b[u>>0]=v;t=u+1|0}u=f[a+152>>2]|0;v=b[u+11>>0]|0;if(v<<24>>24<0)w=f[u+4>>2]|0;else w=v&255;if(!w)x=t;else{b[t>>0]=34;x=gZb(u,t+1|0)|0}t=a+8|0;if((f[t>>2]|0)>0){b[x>>0]=42;u=x+1|0;w=f[a+20>>2]|0;if(w>>>0>127){v=w;s=u;while(1){b[s>>0]=v|128;q=v>>>7;d=s+1|0;if(v>>>0>16383){v=q;s=d}else{y=d;z=q;break}}}else{y=u;z=w}b[y>>0]=z;z=y+1|0;y=f[t>>2]<<2;o1c(z|0,(f[a+16>>2]|0)+4|0,y|0)|0;A=z+y|0}else A=x;x=a+24|0;if((f[x>>2]|0)>0){b[A>>0]=50;y=A+1|0;z=f[a+36>>2]|0;if(z>>>0>127){t=z;w=y;while(1){b[w>>0]=t|128;u=t>>>7;s=w+1|0;if(t>>>0>16383){t=u;w=s}else{B=s;C=u;break}}}else{B=y;C=z}b[B>>0]=C;C=B+1|0;B=f[x>>2]<<3;o1c(C|0,(f[a+32>>2]|0)+8|0,B|0)|0;D=C+B|0}else D=A;A=a+40|0;if((f[A>>2]|0)>0){b[D>>0]=58;B=D+1|0;C=f[a+52>>2]|0;if(C>>>0>127){x=C;z=B;while(1){b[z>>0]=x|128;y=x>>>7;w=z+1|0;if(x>>>0>16383){x=y;z=w}else{E=w;F=y;break}}}else{E=B;F=C}b[E>>0]=F;F=f[A>>2]|0;A=f[a+48>>2]|0;C=0;B=E+1|0;while(1){E=f[A+4+(C<<2)>>2]|0;z=E&255;if(E>>>0>127){x=B;y=z;w=E;t=((E|0)<0)<<31>>31;while(1){b[x>>0]=y|-128;E=w;w=l1c(w|0,t|0,7)|0;u=x+1|0;s=w&255;if(!(t>>>0>0|(t|0)==0&E>>>0>16383)){G=u;H=s;break}else{x=u;y=s;t=J}}}else{G=B;H=z}b[G>>0]=H;t=G+1|0;C=C+1|0;if((C|0)>=(F|0)){I=t;break}else B=t}}else I=D;D=f[a+60>>2]|0;if((D|0)>0){B=a+68|0;F=0;C=I;while(1){G=f[(f[B>>2]|0)+4+(F<<2)>>2]|0;b[C>>0]=66;H=gZb(G,C+1|0)|0;F=F+1|0;if((F|0)==(D|0)){K=H;break}else C=H}}else K=I;I=a+72|0;if((f[I>>2]|0)>0){b[K>>0]=74;C=K+1|0;D=f[a+84>>2]|0;if(D>>>0>127){F=D;B=C;while(1){b[B>>0]=F|128;H=F>>>7;G=B+1|0;if(F>>>0>16383){F=H;B=G}else{L=G;M=H;break}}}else{L=C;M=D}b[L>>0]=M;M=L+1|0;L=f[I>>2]<<2;o1c(M|0,(f[a+80>>2]|0)+4|0,L|0)|0;N=M+L|0}else N=K;K=a+88|0;if((f[K>>2]|0)>0){b[N>>0]=82;L=N+1|0;M=f[a+100>>2]|0;if(M>>>0>127){I=M;D=L;while(1){b[D>>0]=I|128;C=I>>>7;B=D+1|0;if(I>>>0>16383){I=C;D=B}else{O=B;P=C;break}}}else{O=L;P=M}b[O>>0]=P;P=f[K>>2]|0;K=f[a+96>>2]|0;M=0;L=O+1|0;while(1){O=K+8+(M<<3)|0;D=f[O>>2]|0;I=f[O+4>>2]|0;O=D&255;if(I>>>0>0|(I|0)==0&D>>>0>127){C=L;B=O;F=D;D=I;while(1){b[C>>0]=B|-128;I=F;F=l1c(F|0,D|0,7)|0;H=C+1|0;G=F&255;if(!(D>>>0>0|(D|0)==0&I>>>0>16383)){Q=H;R=G;break}else{C=H;B=G;D=J}}}else{Q=L;R=O}b[Q>>0]=R;D=Q+1|0;M=M+1|0;if((M|0)>=(P|0)){S=D;break}else L=D}}else S=N;N=a+104|0;if((f[N>>2]|0)>0){b[S>>0]=90;L=S+1|0;P=f[a+116>>2]|0;if(P>>>0>127){M=P;Q=L;while(1){b[Q>>0]=M|128;R=M>>>7;K=Q+1|0;if(M>>>0>16383){M=R;Q=K}else{T=K;U=R;break}}}else{T=L;U=P}b[T>>0]=U;U=f[N>>2]|0;N=f[a+112>>2]|0;P=0;L=T+1|0;while(1){b[L>>0]=b[N+4+P>>0]|0;T=L+1|0;P=P+1|0;if((P|0)>=(U|0)){V=T;break}else L=T}}else V=S;S=a+120|0;if((f[S>>2]|0)>0){b[V>>0]=98;L=V+1|0;U=f[a+132>>2]|0;if(U>>>0>127){P=U;N=L;while(1){b[N>>0]=P|128;T=P>>>7;Q=N+1|0;if(P>>>0>16383){P=T;N=Q}else{W=Q;X=T;break}}}else{W=L;X=U}b[W>>0]=X;X=W+1|0;W=f[S>>2]<<3;o1c(X|0,(f[a+128>>2]|0)+8|0,W|0)|0;Y=X+W|0}else Y=V;V=a+136|0;if((f[V>>2]|0)>0){b[Y>>0]=106;W=Y+1|0;X=f[a+148>>2]|0;if(X>>>0>127){S=X;U=W;while(1){b[U>>0]=S|128;L=S>>>7;N=U+1|0;if(S>>>0>16383){S=L;U=N}else{Z=N;_=L;break}}}else{Z=W;_=X}b[Z>>0]=_;_=f[V>>2]|0;V=f[a+144>>2]|0;X=0;W=Z+1|0;while(1){Z=f[V+4+(X<<2)>>2]|0;U=Z&255;if(Z>>>0>127){S=W;L=U;N=Z;P=((Z|0)<0)<<31>>31;while(1){b[S>>0]=L|-128;Z=N;N=l1c(N|0,P|0,7)|0;T=S+1|0;Q=N&255;if(!(P>>>0>0|(P|0)==0&Z>>>0>16383)){$=T;aa=Q;break}else{S=T;L=Q;P=J}}}else{$=W;aa=U}b[$>>0]=aa;P=$+1|0;X=X+1|0;if((X|0)>=(_|0)){ba=P;break}else W=P}}else ba=Y;Y=f[a+4>>2]|0;if(!((Y&1|0)!=0&(b[476924]|0)!=0)){ca=ba;return ca|0}ca=Pqc(Y&-2,ba)|0;return ca|0}function DUa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;wUa(a);c=kZc(b,21568,15504,0)|0;if(!c){Ooc(b,a);return}else{LUa(a,c);return}}function EUa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15504,0)|0;if(!c){Ooc(b,a);return}else{LUa(a,c);return}}function FUa(a,b){a=a|0;b=b|0;f[a+168>>2]=b;return}function GUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223032]|0)!=2){f[d>>2]=165456;f[d+4>>2]=9;b[d+8>>0]=0;J_b(892128,d);a_b(d)}d=531040;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function HUa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223033]|0)!=2){f[c>>2]=165456;f[c+4>>2]=10;b[c+8>>0]=0;J_b(892132,c);a_b(c)}d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=12;e=d;g=400172;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+12>>0]=0;ejc(c,83904,83916,83724,0,531040,0,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function IUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223034]|0)!=2){f[c>>2]=165456;f[c+4>>2]=11;b[c+8>>0]=0;J_b(892136,c);a_b(c)}n3b(400185,495);Boc(400172,2249);IXa();pUa();u=a;return}function JUa(){d_b(3005001,3005e3,400681);WXb();HXa();f[132716]=83804;f[132722]=0;f[132723]=0;f[132724]=0;f[132726]=0;f[132727]=0;f[132728]=0;f[132738]=0;f[132739]=0;f[132740]=0;f[132742]=0;f[132743]=0;f[132744]=0;f[132746]=0;f[132747]=0;f[132748]=0;f[132750]=0;f[132751]=0;f[132752]=0;f[132717]=0;f[132718]=0;f[132719]=0;f[132720]=0;f[132730]=0;f[132731]=0;f[132732]=0;f[132733]=0;f[132734]=0;f[132735]=0;f[132736]=0;f[132754]=537368;f[132755]=0;f[132756]=0;f[132757]=0;f[132758]=0;C_b(530864);f[132755]=531248;return}function KUa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223032]|0)!=2){f[c>>2]=165456;f[c+4>>2]=9;b[c+8>>0]=0;J_b(892128,c);a_b(c)}jjc(531040,1);u=a;return}function LUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=a+8|0;h=c+8|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+16>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+16>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+24|0;e=c+24|0;g=f[e>>2]|0;if(g|0){ZMa(h,(f[h>>2]|0)+g|0);o1c((f[a+32>>2]|0)+8+(f[h>>2]<<3)|0,(f[c+32>>2]|0)+8|0,f[e>>2]<<3|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+40|0;h=c+40|0;g=f[h>>2]|0;if(g|0){qHa(e,(f[e>>2]|0)+g|0);o1c((f[a+48>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}vSa(a+56|0,c+56|0);h=a+72|0;e=c+72|0;g=f[e>>2]|0;if(g|0){uHa(h,(f[h>>2]|0)+g|0);o1c((f[a+80>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+80>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+88|0;h=c+88|0;g=f[h>>2]|0;if(g|0){_Ma(e,(f[e>>2]|0)+g|0);o1c((f[a+96>>2]|0)+8+(f[e>>2]<<3)|0,(f[c+96>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+104|0;e=c+104|0;g=f[e>>2]|0;if(g|0){wSa(h,(f[h>>2]|0)+g|0);o1c((f[h>>2]|0)+((f[a+112>>2]|0)+4)|0,(f[c+112>>2]|0)+4|0,f[e>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+120|0;h=c+120|0;g=f[h>>2]|0;if(g|0){ZMa(e,(f[e>>2]|0)+g|0);o1c((f[a+128>>2]|0)+8+(f[e>>2]<<3)|0,(f[c+128>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+136|0;e=c+136|0;g=f[e>>2]|0;if(g|0){qHa(h,(f[h>>2]|0)+g|0);o1c((f[a+144>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+144>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+152>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+152|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);if((c|0)!=530864?(e=c+156|0,k=f[e>>2]|0,k|0):0){d=a+156|0;i=f[d>>2]|0;if(!i){MUa(a);l=f[e>>2]|0;m=f[d>>2]|0}else{l=k;m=i}JXa(m,l|0?l:531248)}l=f[c+160>>2]|0;if(l|0)f[a+160>>2]=l;l=f[c+164>>2]|0;if(!l)return;f[a+164>>2]=l;return}function MUa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(32)|0;EXa(c);e=c;g=a+156|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,15648,32);c=QXb(d,32)|0;FXa(c,d);e=c;g=a+156|0;f[g>>2]=e;return}function NUa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;i=g;j=d+4|0;k=f[d>>2]|0;do if(((f[j>>2]|0)-k|0)>7){l=k;m=l;n=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;m=l+4|0;l=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;m=i;f[m>>2]=n;f[m+4>>2]=l;f[d>>2]=k+8;f[s>>2]=n;f[s+4>>2]=l;o=+p[s>>3]}else{if(XYb(d,i)|0){o=+p[i>>3];break}q=0;u=g;return q|0}while(0);i=f[e>>2]|0;k=e+4|0;if((i|0)==(f[k>>2]|0)){ZMa(e,i+1|0);r=f[e>>2]|0}else r=i;i=f[e+8>>2]|0;l=r+1|0;f[e>>2]=l;p[i+8+(r<<3)>>3]=o;r=f[d>>2]|0;n=(f[j>>2]|0)-r|0;if((n|0)<=0){q=1;u=g;return q|0}j=r;r=a+8|0;a=(f[k>>2]|0)-l|0;k=(n|0)/(r|0)|0;m=(k|0)<(a|0)?k:a;a:do if((m|0)>0){a=c&127|128;k=c>>>7&255;if(c>>>0<128){t=0;v=j;w=l;while(1){if((h[v>>0]|0)!=(c|0)){x=t;break a}y=v+1|0;b[s>>0]=b[y>>0];b[s+1>>0]=b[y+1>>0];b[s+2>>0]=b[y+2>>0];b[s+3>>0]=b[y+3>>0];b[s+4>>0]=b[y+4>>0];b[s+5>>0]=b[y+5>>0];b[s+6>>0]=b[y+6>>0];b[s+7>>0]=b[y+7>>0];o=+p[s>>3];y=w;w=w+1|0;f[e>>2]=w;p[i+8+(y<<3)>>3]=o;y=t+1|0;if((y|0)>=(m|0)){x=y;break a}else{t=y;v=v+9|0}}}if(c>>>0<16384){v=0;t=j;w=l;while(1){if((h[t>>0]|0)!=(a|0)){x=v;break a}if((b[t+1>>0]|0)!=k<<24>>24){x=v;break a}y=t+2|0;b[s>>0]=b[y>>0];b[s+1>>0]=b[y+1>>0];b[s+2>>0]=b[y+2>>0];b[s+3>>0]=b[y+3>>0];b[s+4>>0]=b[y+4>>0];b[s+5>>0]=b[y+5>>0];b[s+6>>0]=b[y+6>>0];b[s+7>>0]=b[y+7>>0];o=+p[s>>3];y=w;w=w+1|0;f[e>>2]=w;p[i+8+(y<<3)>>3]=o;y=v+1|0;if((y|0)>=(m|0)){x=y;break}else{v=y;t=t+10|0}}}else x=0}else x=0;while(0);m=Y(x,r)|0;if((m|0)<=0){q=1;u=g;return q|0}if((n|0)<(m|0)){SYb(d,m,n)|0;q=1;u=g;return q|0}else{f[d>>2]=j+m;q=1;u=g;return q|0}return 0}function OUa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;a=f[d>>2]|0;g=d+4|0;if(a>>>0<(f[g>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>-1){f[d>>2]=a+1;k=j}else{l=j;m=4}}else{l=0;m=4}if((m|0)==4){j=KYb(d,l)|0;l=J;if((l|0)>-1|(l|0)==-1&j>>>0>4294967295)k=j;else{n=0;return n|0}}j=f[e>>2]|0;l=e+4|0;if((j|0)==(f[l>>2]|0)){qHa(e,j+1|0);o=f[e>>2]|0}else o=j;j=e+8|0;a=f[j>>2]|0;f[e>>2]=o+1;f[a+4+(o<<2)>>2]=k;k=(f[l>>2]|0)-(f[e>>2]|0)|0;if((k|0)<=0){n=1;return n|0}l=c&127|128;o=c>>>7&255;if(c>>>0<128){i=k;p=a;while(1){q=f[d>>2]|0;r=f[g>>2]|0;if(q>>>0>=r>>>0){n=1;m=27;break}if((h[q>>0]|0)!=(c|0)){n=1;m=27;break}s=q+1|0;f[d>>2]=s;if(s>>>0<r>>>0){r=b[s>>0]|0;s=r&255;if(r<<24>>24>-1){f[d>>2]=q+2;t=s;u=p}else{v=s;m=13}}else{v=0;m=13}if((m|0)==13){m=0;s=KYb(d,v)|0;q=J;if(!((q|0)>-1|(q|0)==-1&s>>>0>4294967295)){n=0;m=27;break}t=s;u=f[j>>2]|0}s=f[e>>2]|0;f[e>>2]=s+1;f[u+4+(s<<2)>>2]=t;if((i|0)>1){i=i+-1|0;p=u}else{n=1;m=27;break}}if((m|0)==27)return n|0}if(c>>>0<16384){w=k;x=a}else{n=1;return n|0}while(1){a=f[g>>2]|0;k=f[d>>2]|0;c=k;if((a-k|0)<=1){n=1;m=27;break}if((h[c>>0]|0)!=(l|0)){n=1;m=27;break}if((b[c+1>>0]|0)!=o<<24>>24){n=1;m=27;break}k=c+2|0;f[d>>2]=k;if(k>>>0<a>>>0){a=b[k>>0]|0;k=a&255;if(a<<24>>24>-1){f[d>>2]=c+3;y=k;z=x}else{A=k;m=23}}else{A=0;m=23}if((m|0)==23){m=0;k=KYb(d,A)|0;c=J;if(!((c|0)>-1|(c|0)==-1&k>>>0>4294967295)){n=0;m=27;break}y=k;z=f[j>>2]|0}k=f[e>>2]|0;f[e>>2]=k+1;f[z+4+(k<<2)>>2]=y;if((w|0)>1){w=w+-1|0;x=z}else{n=1;m=27;break}}if((m|0)==27)return n|0;return 0}function PUa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=83804;e=a+4|0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;g=a+56|0;f[a+88>>2]=0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;f[a+144>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;if((a|0)!=530864?(f[223034]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=11;b[d+8>>0]=0;J_b(892136,d);a_b(d)}f[a+152>>2]=537368;d=a+156|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function QUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=83804;f[a+4>>2]=c;f[a+8>>2]=0;f[a+12>>2]=0;g=a+16|0;f[g>>2]=0;h=(c|0)==0;if(h){f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0}else{if(f[c+64>>2]|0)SXb(c,25456,8);i=QXb(c,8)|0;f[g>>2]=i;f[i>>2]=c;f[a+24>>2]=0;f[a+28>>2]=0;i=a+32|0;f[i>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);g=QXb(c,8)|0;f[i>>2]=g;f[g>>2]=c;f[a+40>>2]=0;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);i=QXb(c,8)|0;f[g>>2]=i;f[i>>2]=c}f[a+56>>2]=c;i=a+60|0;g=a+80|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;if(h){f[a+88>>2]=0;f[a+92>>2]=0;f[a+96>>2]=0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;f[a+144>>2]=0}else{if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+88>>2]=0;f[a+92>>2]=0;h=a+96|0;f[h>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);g=QXb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+104>>2]=0;f[a+108>>2]=0;g=a+112|0;f[g>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c;f[a+120>>2]=0;f[a+124>>2]=0;h=a+128|0;f[h>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);g=QXb(c,8)|0;f[h>>2]=g;f[g>>2]=c;f[a+136>>2]=0;f[a+140>>2]=0;g=a+144|0;f[g>>2]=0;if(f[c+64>>2]|0)SXb(c,25456,8);h=QXb(c,8)|0;f[g>>2]=h;f[h>>2]=c}if((f[223034]|0)==2){j=a+152|0;f[j>>2]=537368;k=a+156|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=11;b[e+8>>0]=0;J_b(892136,e);a_b(e);j=a+152|0;f[j>>2]=537368;k=a+156|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;u=d;return}function RUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223033]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=10;b[c+8>>0]=0;J_b(892132,c);a_b(c);u=a;return}function SUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223034]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=11;b[c+8>>0]=0;J_b(892136,c);a_b(c);u=a;return}function TUa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223033]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=10;b[c+8>>0]=0;J_b(892132,c);a_b(c);u=a;return}function UUa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=84040;if((a|0)!=531048){b=f[a+24>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+28>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function VUa(a){a=a|0;UUa(a);cYc(a);return}function WUa(a){a=a|0;a=$Xc(40)|0;IWa(a);return a|0}function XUa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(40)|0;IWa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15520,40);a=QXb(b,40)|0;JWa(a,b);c=a;return c|0}function YUa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function ZUa(a){a=a|0;return f[a+4>>2]|0}function _Ua(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{hWa(f[d+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)!=(c|0));f[b>>2]=0}b=a+4|0;c=f[b>>2]|0;e=c&-2;if(!(c&1))g=e;else g=f[e+4>>2]|0;e=a+24|0;if((g|0)==0?(g=f[e>>2]|0,(g|0)!=0):0){Yi[f[(f[g>>2]|0)+4>>2]&4095](g);h=f[b>>2]|0}else h=c;f[e>>2]=0;e=h&-2;if(!(h&1))i=e;else i=f[e+4>>2]|0;e=a+28|0;if((i|0)==0?(i=f[e>>2]|0,(i|0)!=0):0){Yi[f[(f[i>>2]|0)+4>>2]&4095](i);j=f[b>>2]|0}else j=h;f[e>>2]=0;f[a+32>>2]=0;if(!(j&1))return;a=j&-2;if(!(f[a>>2]|0))return;sqc(a);return}function $Ua(a){a=a|0;return 1}function aVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+24|0;n=e+4|0;o=a+32|0;p=a+28|0;q=e+4|0;r=a+4|0;a:while(1){s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){t=b[s>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=s+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=ZYb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=10){z=w;break b}v=f[i>>2]|0;do if(v){s=f[k>>2]|0;t=f[v>>2]|0;if((s|0)>=(t|0))if((t|0)==(f[j>>2]|0)){A=t;x=13;break}else{B=t;C=v;x=14;break}else{f[k>>2]=s+1;D=f[v+4+(s<<2)>>2]|0;break}}else{A=f[j>>2]|0;x=13}while(0);if((x|0)==13){x=0;XZb(h,A+1|0);v=f[i>>2]|0;B=f[v>>2]|0;C=v;x=14}if((x|0)==14){x=0;f[C>>2]=B+1;v=f[h>>2]|0;if(!v){s=$Xc(76)|0;qVa(s);E=s}else{if(f[v+64>>2]|0)SXb(v,15600,80);s=QXb(v,80)|0;AWa(s,v);E=s}s=f[i>>2]|0;v=f[k>>2]|0;f[k>>2]=v+1;f[s+4+(v<<2)>>2]=E;D=E}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(s=b[v>>0]|0,s<<24>>24>-1):0){f[c>>2]=v+1;F=s&255}else{s=YYb(c)|0;if((s|0)>-1)F=s;else{G=0;x=61;break a}}JYb(e,c,F);if((f[l>>2]|0)<0){x=26;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){x=26;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{G=0;x=61;break a}break}case 2:{if((w&255|0)!=18){z=w;break b}s=f[m>>2]|0;if(!s){FWa(a);H=f[m>>2]|0}else H=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(v=b[s>>0]|0,v<<24>>24>-1):0){f[c>>2]=s+1;I=v&255}else{v=YYb(c)|0;if((v|0)>-1)I=v;else{G=0;x=61;break a}}JYb(e,c,I);if((f[n>>2]|0)<0){x=37;break a}if(!(Mi[f[(f[H>>2]|0)+44>>2]&1023](H,c)|0)){x=37;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{G=0;x=61;break a}break}case 3:{if((w&255|0)!=24){z=w;break b}v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){s=b[v>>0]|0;t=s&255;if(s<<24>>24>-1){f[c>>2]=v+1;K=t}else{L=t;x=43}}else{L=0;x=43}if((x|0)==43){x=0;t=KYb(c,L)|0;v=J;if((v|0)>-1|(v|0)==-1&t>>>0>4294967295)K=t;else{G=0;x=61;break a}}f[o>>2]=K;continue a;break}case 4:{if((w&255|0)!=34){z=w;break b}t=f[p>>2]|0;if(!t){GWa(a);M=f[p>>2]|0}else M=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;N=v&255}else{v=YYb(c)|0;if((v|0)>-1)N=v;else{G=0;x=61;break a}}JYb(e,c,N);if((f[q>>2]|0)<0){x=54;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){x=54;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{G=0;x=61;break a}break}default:{z=w;break b}}}while(0);if(!z){G=1;x=61;break}v=f[r>>2]|0;if(!(v&1))O=lSa(r)|0;else O=v&-2;if(!(Lqc(c,z,O)|0)){G=0;x=61;break}}if((x|0)==26){G=0;u=d;return G|0}else if((x|0)==37){G=0;u=d;return G|0}else if((x|0)==54){G=0;u=d;return G|0}else if((x|0)==61){u=d;return G|0}return 0}function bVa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c)g=e;else{d=a+20|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}if((a|0)!=531048){i=f[a+24>>2]|0;if(!i)k=g;else{c=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;k=g+1+c+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0}c=f[a+28>>2]|0;if(!c)l=k;else{i=_i[f[(f[c>>2]|0)+48>>2]&2047](c)|0;l=k+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}}else l=g;g=f[a+32>>2]|0;if(!g){m=l;n=a+36|0;f[n>>2]=m;return m|0}if((g|0)<0)o=11;else o=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=o+l|0;n=a+36|0;f[n>>2]=m;return m|0}function cVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{k$b(1,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}d=(a|0)==531048;if(!d?(g=f[a+24>>2]|0,g|0):0)k$b(2,g,c);g=f[a+32>>2]|0;if(g|0)S_b(3,g,c);if(!d?(d=f[a+28>>2]|0,d|0):0)k$b(4,d,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function dVa(a){a=a|0;return f[a+36>>2]|0}function eVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=(a|0)==531048;if(!j?(e=f[a+24>>2]|0,(e|0)!=0):0){b[g>>0]=18;i=g+1|0;q=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(q>>>0>127){r=q;h=i;while(1){b[h>>0]=r|128;n=r>>>7;m=h+1|0;if(r>>>0>16383){r=n;h=m}else{s=m;t=n;break}}}else{s=i;t=q}b[s>>0]=t;u=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,s+1|0)|0}else u=g;g=f[a+32>>2]|0;if(!g)v=u;else{b[u>>0]=24;s=u+1|0;u=g&255;if(g>>>0>127){e=s;t=u;q=g;i=((g|0)<0)<<31>>31;while(1){b[e>>0]=t|-128;g=q;q=l1c(q|0,i|0,7)|0;h=e+1|0;r=q&255;if(!(i>>>0>0|(i|0)==0&g>>>0>16383)){w=h;x=r;break}else{e=h;t=r;i=J}}}else{w=s;x=u}b[w>>0]=x;v=w+1|0}if(!j?(j=f[a+28>>2]|0,(j|0)!=0):0){b[v>>0]=34;w=v+1|0;x=_i[f[(f[j>>2]|0)+60>>2]&2047](j)|0;if(x>>>0>127){u=x;s=w;while(1){b[s>>0]=u|128;i=u>>>7;t=s+1|0;if(u>>>0>16383){u=i;s=t}else{y=t;z=i;break}}}else{y=w;z=x}b[y>>0]=z;A=hj[f[(f[j>>2]|0)+64>>2]&511](j,c,y+1|0)|0}else A=v;v=f[a+4>>2]|0;if(!((v&1|0)!=0&(b[476924]|0)!=0)){B=A;return B|0}B=Pqc(v&-2,A)|0;return B|0}function fVa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;_Ua(a);c=kZc(b,21568,15520,0)|0;if(!c){Ooc(b,a);return}else{DWa(a,c);return}}function gVa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15520,0)|0;if(!c){Ooc(b,a);return}else{DWa(a,c);return}}function hVa(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function iVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223035]|0)!=2){f[d>>2]=165456;f[d+4>>2]=12;b[d+8>>0]=0;J_b(892140,d);a_b(d)}d=531192;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function jVa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223036]|0)!=2){f[c>>2]=165456;f[c+4>>2]=13;b[c+8>>0]=0;J_b(892144,c);a_b(c)}d=$Xc(16)|0;f[c>>2]=d;f[c+8>>2]=-2147483632;f[c+4>>2]=11;e=d;g=400797;h=e+11|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+11>>0]=0;ejc(c,84140,84176,83920,0,531192,0,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function kVa(){lVa();n3b(400809,513);Boc(400797,2250);iUa();WHb();NKb();return}function lVa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223037]|0)!=2){f[c>>2]=165456;f[c+4>>2]=14;b[c+8>>0]=0;J_b(892148,c);a_b(c)}if((f[223038]|0)!=2){f[c>>2]=165456;f[c+4>>2]=15;b[c+8>>0]=0;J_b(892152,c);a_b(c)}if((f[223039]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=16;b[c+8>>0]=0;J_b(892156,c);a_b(c);u=a;return}function mVa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223035]|0)!=2){f[c>>2]=165456;f[c+4>>2]=12;b[c+8>>0]=0;J_b(892140,c);a_b(c)}jjc(531192,3);u=a;return}function nVa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,401323);WXb();if((f[223039]|0)!=2){f[c>>2]=165456;f[c+4>>2]=16;b[c+8>>0]=0;J_b(892156,c);a_b(c)}MKb();VHb();f[132762]=84040;f[132763]=0;f[132764]=0;f[132765]=0;f[132766]=0;f[132767]=0;f[132768]=0;f[132769]=0;f[132770]=0;f[132771]=0;C_b(531048);f[132769]=537288;f[132768]=536752;u=a;return}function oVa(){d_b(3005001,3005e3,401323);WXb();hUa();f[132775]=0;f[132773]=537368;f[132776]=0;f[132777]=0;f[132772]=84388;f[132774]=530680;return}function pVa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,401323);WXb();if((f[223038]|0)!=2){f[c>>2]=165456;f[c+4>>2]=15;b[c+8>>0]=0;J_b(892152,c);a_b(c)}qVa(531112);C_b(531112);u=a;return}function qVa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=84196;e=a+4|0;g=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[g>>2]=171580;f[a+28>>2]=0;f[a+32>>2]=0;w_b(a+36|0);f[a+40>>2]=0;f[g>>2]=84304;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;e=a+52|0;f[e>>2]=0;aJa(g);f[e>>2]=0;if((a|0)!=531112?(f[223039]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=16;b[d+8>>0]=0;J_b(892156,d);a_b(d)}f[a+60>>2]=537368;f[a+64>>2]=537368;f[a+68>>2]=537368;f[a+72>>2]=0;u=c;return}function rVa(a){a=a|0;f[a>>2]=84304;zIa(a+24|0);Ljc(a);return}function sVa(a){a=a|0;f[a>>2]=84304;zIa(a+24|0);Ljc(a);cYc(a);return}function tVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;lYc(g,OSa(c)|0);yIa(e,f[a+32>>2]|0,g,0);a=(f[e>>2]|0)!=0;if((b[g+11>>0]|0)>=0){u=d;return a|0}cYc(f[g>>2]|0);u=d;return a|0}function uVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e+16|0;h=e;i=_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0;lYc(h,OSa(c)|0);yIa(g,f[i+8>>2]|0,h,0);c=f[g>>2]|0;if(!c){j=1;k=bJa(i,h)|0}else{j=0;k=(f[c+12>>2]|0)+16|0}f[d>>2]=k;if((b[h+11>>0]|0)>=0){u=e;return j|0}cYc(f[h>>2]|0);u=e;return j|0}function vVa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;lYc(e,OSa(c)|0);c=(PSa(_i[f[(f[a>>2]|0)+68>>2]&2047](a)|0,e)|0)!=0;if((b[e+11>>0]|0)>=0){u=d;return c|0}cYc(f[e>>2]|0);u=d;return c|0}function wVa(a){a=a|0;elc(a);return f[f[a+32>>2]>>2]|0}function xVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;d=f[a+8>>2]|0;if(!d)e=12;else{g=f[d+8>>2]<<2;h=d+12|0;d=f[h>>2]|0;if(!d)i=g;else{if((f[d>>2]|0)>0){j=0;k=g;l=d;while(1){d=f[l+4+(j<<2)>>2]|0;m=(_i[f[(f[d>>2]|0)+84>>2]&2047](d)|0)+k|0;j=j+1|0;l=f[h>>2]|0;if((j|0)>=(f[l>>2]|0)){n=m;break}else k=m}}else n=g;i=n+4|0}e=i+12|0}i=f[a+32>>2]|0;a=f[i+12>>2]|0;n=f[i+4>>2]|0;a:do if(n>>>0>a>>>0){g=f[i+16>>2]|0;k=a;while(1){o=f[g+(k<<2)>>2]|0;if(o|0)break;l=k+1|0;if(l>>>0<n>>>0)k=l;else{p=0;q=l;break a}}if((o|0)==(f[g+((k^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=k;break}else{p=o;q=k;break}}else{p=0;q=a}while(0);f[c>>2]=p;f[c+4>>2]=i;f[c+8>>2]=q;if(!p){r=e;u=b;return r|0}q=e;e=p;while(1){p=(f[e+12>>2]|0)+16|0;i=q+12+(_i[f[(f[p>>2]|0)+84>>2]&2047](p)|0)|0;UIa(c)|0;e=f[c>>2]|0;if(!e){r=i;break}else q=i}u=b;return r|0}function yVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;b=u;u=u+16|0;c=b;d=a+8|0;e=f[d>>2]|0;if(!e){g=f[a+4>>2]|0;if(!g){h=$Xc(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}else{if(f[g+64>>2]|0)SXb(g,15384,16);h=RXb(g,16,2244)|0;f[h>>2]=g;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;i=h}f[d>>2]=i;j=i}else j=e;e=j+4|0;i=f[e>>2]|0;if((i|0)>0){d=f[j+12>>2]|0;h=0;do{g=f[d+4+(h<<2)>>2]|0;h=h+1|0;Yi[f[(f[g>>2]|0)+28>>2]&4095](g)}while((h|0)!=(i|0));f[e>>2]=0}i=f[a+32>>2]|0;h=f[i+12>>2]|0;d=f[i+4>>2]|0;a:do if(d>>>0>h>>>0){g=f[i+16>>2]|0;k=h;while(1){l=f[g+(k<<2)>>2]|0;if(l|0)break;m=k+1|0;if(m>>>0<d>>>0)k=m;else{n=0;o=m;break a}}if((l|0)==(f[g+((k^1)<<2)>>2]|0)){n=f[(f[l>>2]|0)+16>>2]|0;o=k;break}else{n=l;o=k;break}}else{n=0;o=h}while(0);f[c>>2]=n;f[c+4>>2]=i;f[c+8>>2]=o;if(!n){u=b;return}n=a+4|0;a=j+12|0;o=j+8|0;do{i=Mi[f[(f[132772]|0)+16>>2]&1023](531088,f[n>>2]|0)|0;h=i+12|0;l=f[h>>2]|0;d=f[j>>2]|0;if(((d|0)==(l|0)?(m=f[a>>2]|0,(m|0)!=0):0)?(p=f[m>>2]|0,(p|0)<(f[o>>2]|0)):0){q=f[e>>2]|0;if((q|0)<(p|0)){r=m+4+(q<<2)|0;f[m+4+(p<<2)>>2]=f[r>>2];s=r}else s=m+4+(q<<2)|0;f[s>>2]=i;f[e>>2]=q+1;q=f[a>>2]|0;f[q>>2]=(f[q>>2]|0)+1}else DVa(j,i,l,d);d=f[(f[c>>2]|0)+12>>2]|0;l=i+16|0;f[l>>2]=f[l>>2]|1;q=i+4|0;m=f[q>>2]|0;if((m|0)==537368){xJa(q,f[h>>2]|0,537368);t=f[q>>2]|0}else t=m;oYc(t,d)|0;d=(f[(f[c>>2]|0)+12>>2]|0)+16|0;f[l>>2]=f[l>>2]|2;l=i+8|0;i=f[h>>2]|0;h=f[l>>2]|0;if(!h){if(!i){m=$Xc(24)|0;ISa(m);v=m}else{if(f[i+64>>2]|0)SXb(i,15400,24);m=QXb(i,24)|0;JSa(m,i);v=m}f[l>>2]=v;w=v}else w=h;kUa(w,d);RIa(c)|0}while((f[c>>2]|0)!=0);u=b;return}function zVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=a+24|0;e=f[a+8>>2]|0;if(!e){u_b(c,3,457044,306);r_b(b+24|0,p_b(c,457138)|0);v_b(c)}iSa(d);c=e+12|0;a=f[c>>2]|0;g=e+4|0;if(!(f[g>>2]|0)){u=b;return}e=(a|0)==0?0:a+4|0;do{a=f[e>>2]|0;h=_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0;a=f[e>>2]|0;kUa(bJa(d,_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0)|0,h);e=e+4|0;h=f[c>>2]|0}while((e|0)!=(((h|0)==0?0:h+4|0)+(f[g>>2]<<2)|0));u=b;return}function AVa(a){a=a|0;elc(a);return a+24|0}function BVa(a){a=a|0;elc(a);dlc(a);return a+24|0}function CVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;a=f[f[b>>2]>>2]|0;if(!a)return;c=b+8|0;d=a+12|0;a=f[d>>2]|0;e=b+16|0;if((f[e>>2]|0)==9)g=f[c>>2]|0;else{f[e>>2]=9;e=$Xc(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[c>>2]=e;g=e}oYc(g,a)|0;f[b+24>>2]=(f[d>>2]|0)+16;return}function DVa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){if(!d){e=$Xc(24)|0;f[e+12>>2]=0;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)SXb(d,15552,24);e=QXb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=84388;FVa(b,g);if((b|0)==0|(c|0)!=0)i=g;else{Yi[f[(f[b>>2]|0)+4>>2]&4095](b);i=g}}else i=b;else{EVa(d,b);i=b}b=a+12|0;d=f[b>>2]|0;g=f[a+8>>2]|0;c=a+4|0;if(d|0?(e=f[c>>2]|0,(e|0)!=(g|0)):0){h=f[d>>2]|0;if((h|0)==(g|0)){j=f[d+4+(e<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}Yi[f[(f[j>>2]|0)+4>>2]&4095](j);k=f[b>>2]|0;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}else{if((e|0)<(h|0)){f[d+4+(h<<2)>>2]=f[d+4+(e<<2)>>2];e=f[b>>2]|0;o=e;p=f[e>>2]|0}else{o=d;p=h}f[o>>2]=p+1;k=o;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}}XZb(a,g+1|0);g=f[b>>2]|0;f[g>>2]=(f[g>>2]|0)+1;k=g;l=f[c>>2]|0;m=l+1|0;f[c>>2]=m;n=k+4+(l<<2)|0;f[n>>2]=i;return}function EVa(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function FVa(a,b){a=a|0;b=b|0;GVa(b,a);return}function GVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+16|0;d=f[c>>2]|0;if(!d)return;if(!(d&1))e=d;else{d=a+4|0;g=a+12|0;if((f[d>>2]|0)==537368)xJa(d,f[g>>2]|0,537368);h=_i[f[(f[b>>2]|0)+100>>2]&2047](b)|0;i=f[d>>2]|0;if((i|0)==537368)xJa(d,f[g>>2]|0,h);else oYc(i,h)|0;h=a+16|0;f[h>>2]=f[h>>2]|1;e=f[c>>2]|0}if(!(e&2))return;e=a+8|0;c=f[a+12>>2]|0;if(!(f[e>>2]|0)){if(!c){h=$Xc(24)|0;ISa(h);j=h}else{if(f[c+64>>2]|0)SXb(c,15400,24);h=QXb(c,24)|0;JSa(h,c);j=h}f[e>>2]=j}j=_i[f[(f[b>>2]|0)+104>>2]&2047](b)|0;kSa(f[e>>2]|0,j);j=a+16|0;f[j>>2]=f[j>>2]|2;return}function HVa(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=84504;c=a+20|0;d=f[c>>2]|0;if(d&1|0?(e=d&-2,d=e,!((e|0)==0|(f[d+4>>2]|0)!=0)):0){if(f[d>>2]|0)sqc(d);cYc(e)}f[c>>2]=0;f[a>>2]=84620;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function IVa(a){a=a|0;HVa(a);cYc(a);return}function JVa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function KVa(a){a=a|0;a=$Xc(24)|0;f[a+12>>2]=0;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a>>2]=84388;return a|0}function LVa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=$Xc(24)|0;f[a+12>>2]=0;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;c=a;f[c>>2]=84388;return c|0}if(f[b+64>>2]|0)SXb(b,15552,24);a=QXb(b,24)|0;d=b;f[a+12>>2]=d;f[a+4>>2]=537368;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=d;c=a;f[c>>2]=84388;return c|0}function MVa(a){a=a|0;return f[a+12>>2]|0}function NVa(a){a=a|0;var c=0,d=0;c=f[a+4>>2]|0;do if((c|0)!=537368){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+8>>2]|0;if(c|0)WTa(c);c=a+16|0;f[c>>2]=f[c>>2]&-4;return}function OVa(a){a=a|0;return XTa(f[a+8>>2]|0)|0}function PVa(a,b){a=a|0;b=b|0;GVa(a,b);return}function QVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+4|0;j=a+12|0;k=a+8|0;a=e+4|0;l=c+32|0;m=c+12|0;n=c+28|0;a:while(1){o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){p=b[o>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=o+1;r=q}else{s=q;t=5}}else{s=0;t=5}if((t|0)==5){t=0;r=ZYb(c,s)|0}switch(r|0){case 0:{v=1;t=35;break a;break}case 10:{f[h>>2]=f[h>>2]|1;q=f[i>>2]|0;if((q|0)==537368){xJa(i,f[j>>2]|0,537368);w=f[i>>2]|0}else w=q;if(!(l$b(c,w)|0)){v=0;t=35;break a}q=f[h>>2]|1;f[h>>2]=q;o=f[c>>2]|0;if(o>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[o>>0]|0)!=18)continue a;f[c>>2]=o+1;x=q;break}case 18:{x=f[h>>2]|0;break}default:{if((r&7|0)==4){v=1;t=35;break a}if(O_b(c,r)|0)continue a;else{v=0;t=35;break a}}}f[h>>2]=x|2;q=f[j>>2]|0;o=f[k>>2]|0;if(!o){if(!q){p=$Xc(24)|0;ISa(p);y=p}else{if(f[q+64>>2]|0)SXb(q,15400,24);p=QXb(q,24)|0;JSa(p,q);y=p}f[k>>2]=y;z=y}else z=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(p=b[o>>0]|0,p<<24>>24>-1):0){f[c>>2]=o+1;A=p&255}else{p=YYb(c)|0;if((p|0)>-1)A=p;else{v=0;t=35;break}}JYb(e,c,A);if((f[a>>2]|0)<0){t=27;break}if(!(BTa(z,c)|0)){t=27;break}if(!(OYb(c,f[e>>2]|0)|0)){v=0;t=35;break}f[h>>2]=f[h>>2]|2;if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[l>>2]|0){t=32;break}if((f[m>>2]|0)==(f[n>>2]|0)){t=32;break}}if((t|0)==27){v=0;u=d;return v|0}else if((t|0)==32){f[c+20>>2]=0;b[c+24>>0]=1;v=1;u=d;return v|0}else if((t|0)==35){u=d;return v|0}return 0}function RVa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=ATa(_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0)|0;j=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function SVa(a,b){a=a|0;b=b|0;e$b(1,_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0,b);k$b(2,_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0,b);return}function TVa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;h=b[d+11>>0]|0;i=h<<24>>24<0?f[d+4>>2]|0:h&255;h=i+1+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=f[c>>2]|0;g=h}if(!(e&2)){j=0;k=j+g|0;return k|0}e=(_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0)+16|0;a=f[e>>2]|0;j=a+1+((((($(a|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=j+g|0;return k|0}function UVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=_i[f[(f[a>>2]|0)+100>>2]&2047](a)|0;b[d>>0]=10;g=gZb(e,d+1|0)|0;d=_i[f[(f[a>>2]|0)+104>>2]&2047](a)|0;b[g>>0]=18;a=g+1|0;g=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(g>>>0>127){e=g;h=a;while(1){b[h>>0]=e|128;i=e>>>7;j=h+1|0;if(e>>>0>16383){e=i;h=j}else{k=j;l=i;break}}}else{k=a;l=g}b[k>>0]=l;return hj[f[(f[d>>2]|0)+64>>2]&511](d,c,k+1|0)|0}function VVa(a,b){a=a|0;b=b|0;rlc(a,b);return}function WVa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (_i[f[(f[b>>2]|0)+84>>2]&2047](b)|0)+28|0}function XVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223035]|0)!=2){f[d>>2]=165456;f[d+4>>2]=12;b[d+8>>0]=0;J_b(892140,d);a_b(d)}d=531200;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function YVa(a){a=a|0;return f[a+4>>2]|0}function ZVa(a){a=a|0;var b=0;b=f[a+8>>2]|0;return (b|0?b:f[132774]|0)|0}function _Va(a){a=a|0;var c=0;f[a>>2]=84620;if(f[a+12>>2]|0)return;c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function $Va(a){a=a|0;var c=0;f[a>>2]=84620;if(f[a+12>>2]|0){cYc(a);return}c=f[a+4>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+8>>2]|0;if(!c){cYc(a);return}Yi[f[(f[c>>2]|0)+4>>2]&4095](c);cYc(a);return}function aWa(a){a=a|0;HVa(a);cYc(a);return}function bWa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=84196;BWa(a);c=a+24|0;f[c>>2]=84304;zIa(a+48|0);Ljc(c);c=a+20|0;d=f[c>>2]|0;if(d|0?(f[a+8>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[c>>2]=0;return}function cWa(a){a=a|0;bWa(a);cYc(a);return}function dWa(a){a=a|0;a=$Xc(76)|0;qVa(a);return a|0}function eWa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(76)|0;qVa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15600,80);a=QXb(b,80)|0;AWa(a,b);c=a;return c|0}function fWa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function gWa(a){a=a|0;return f[a+4>>2]|0}function hWa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;elc(c);iSa(a+48|0);dlc(c);c=a+4|0;d=f[a+60>>2]|0;do if((d|0)!=537368){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[a+64>>2]|0;do if((d|0)!=537368){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);d=f[a+68>>2]|0;do if((d|0)!=537368){a=d+11|0;if((b[a>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[a>>0]=0;break}}while(0);d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;sqc(c);return}function iWa(a){a=a|0;return 1}function jWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=a+60|0;j=a+4|0;k=a+60|0;l=a+64|0;m=a+64|0;n=a+8|0;o=a+12|0;p=a+20|0;q=a+68|0;r=a+68|0;s=a+24|0;a=g+4|0;t=g+8|0;v=g+24|0;w=e+4|0;x=t+11|0;y=g+12|0;a:while(1){z=f[c>>2]|0;if(z>>>0<(f[h>>2]|0)>>>0){A=b[z>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=z+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=ZYb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=10){F=C;break b}B=f[j>>2]|0;z=B&-2;if(!(B&1))G=z;else G=f[z+4>>2]|0;z=f[i>>2]|0;if((z|0)==537368){xJa(i,G,537368);H=f[i>>2]|0}else H=z;if(!(l$b(c,H)|0)){I=0;D=67;break a}z=f[k>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0){J=f[z>>2]|0;K=f[z+4>>2]|0}else{J=z;K=B&255}if(m$b(J,K,0,402107)|0)continue a;else{I=0;D=67;break a}break}case 2:{if((C&255|0)!=18){F=C;break b}B=f[j>>2]|0;z=B&-2;if(!(B&1))L=z;else L=f[z+4>>2]|0;z=f[l>>2]|0;if((z|0)==537368){xJa(l,L,537368);M=f[l>>2]|0}else M=z;if(!(l$b(c,M)|0)){I=0;D=67;break a}z=f[m>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0){N=f[z>>2]|0;O=f[z+4>>2]|0}else{N=z;O=B&255}if(m$b(N,O,0,402138)|0)continue a;else{I=0;D=67;break a}break}case 3:{if((C&255|0)!=26){F=C;break b}if(!(l$b(c,pHa(n)|0)|0)){I=0;D=67;break a}B=f[(f[p>>2]|0)+4+((f[o>>2]|0)+-1<<2)>>2]|0;z=b[B+11>>0]|0;if(z<<24>>24<0){P=f[B>>2]|0;Q=f[B+4>>2]|0}else{P=B;Q=z&255}if(m$b(P,Q,0,402167)|0)continue a;else{I=0;D=67;break a}break}case 4:{if((C&255|0)!=34){F=C;break b}z=f[j>>2]|0;B=z&-2;if(!(z&1))R=B;else R=f[B+4>>2]|0;B=f[q>>2]|0;if((B|0)==537368){xJa(q,R,537368);S=f[q>>2]|0}else S=B;if(!(l$b(c,S)|0)){I=0;D=67;break a}B=f[r>>2]|0;z=b[B+11>>0]|0;if(z<<24>>24<0){T=f[B>>2]|0;U=f[B+4>>2]|0}else{T=B;U=z&255}if(m$b(T,U,0,402199)|0)continue a;else{I=0;D=67;break a}break}case 5:{if((C&255|0)!=42){F=C;break b}f[g>>2]=s;z=_i[f[(f[s>>2]|0)+68>>2]&2047](s)|0;f[a>>2]=z;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[v>>2]=0;z=f[c>>2]|0;if(z>>>0<(f[h>>2]|0)>>>0?(B=b[z>>0]|0,B<<24>>24>-1):0){f[c>>2]=z+1;V=B&255;D=51}else{B=YYb(c)|0;if((B|0)>-1){V=B;D=51}else W=6}do if((D|0)==51){D=0;JYb(e,c,V);if((f[w>>2]|0)>=0?xWa(g,c)|0:0){if(!(OYb(c,f[e>>2]|0)|0)){W=6;break}B=b[x>>0]|0;z=B<<24>>24<0;A=m$b(z?f[t>>2]|0:t,z?f[y>>2]|0:B&255,0,402232)|0;W=A?0:6;break}W=6}while(0);A=f[v>>2]|0;if(A|0)Yi[f[(f[A>>2]|0)+4>>2]&4095](A);if((b[x>>0]|0)<0)cYc(f[t>>2]|0);switch(W&7){case 0:{continue a;break}case 6:{I=0;D=67;break a;break}default:{D=66;break a}}break}default:{F=C;break b}}}while(0);if(!F){D=66;break}A=f[j>>2]|0;if(!(A&1))X=lSa(j)|0;else X=A&-2;if(!(Lqc(c,F,X)|0)){I=0;D=67;break}}if((D|0)==66){I=1;u=d;return I|0}else if((D|0)==67){u=d;return I|0}return 0}function kWa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;if((e&1|0)!=0&(b[476924]|0)!=0)g=Rqc(e&-2)|0;else g=0;e=f[a+12>>2]|0;h=e+g|0;if((e|0)>0){g=f[a+20>>2]|0;i=0;j=h;while(1){k=f[g+4+(i<<2)>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0?f[k+4>>2]|0:l&255;l=m+j+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(e|0)){n=l;break}else j=l}}else n=h;h=a+24|0;elc(h);j=a+56|0;e=f[f[j>>2]>>2]|0;elc(h);i=e+n|0;n=f[j>>2]|0;j=f[n+12>>2]|0;e=f[n+4>>2]|0;a:do if(e>>>0>j>>>0){g=f[n+16>>2]|0;l=j;while(1){o=f[g+(l<<2)>>2]|0;if(o|0)break;m=l+1|0;if(m>>>0<e>>>0)l=m;else{p=0;q=m;break a}}if((o|0)==(f[g+((l^1)<<2)>>2]|0)){p=f[(f[o>>2]|0)+16>>2]|0;q=l;break}else{p=o;q=l;break}}else{p=0;q=j}while(0);f[d>>2]=p;f[d+4>>2]=n;f[d+8>>2]=q;q=a+44|0;n=i;i=0;while(1){elc(h);p=f[d>>2]|0;if(!p)break;if(!i){r=0;s=p}else{p=(_i[f[(f[i>>2]|0)+20>>2]&2047](i)|0)==0;r=p?i:0;s=f[d>>2]|0}p=f[s+12>>2]|0;j=p+16|0;o=f[q>>2]|0;if(!o){e=$Xc(32)|0;f[e+12>>2]=0;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+20>>2]=0;t=e}else{if(f[o+64>>2]|0)SXb(o,15616,32);e=QXb(o,32)|0;m=o;f[e+12>>2]=m;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+20>>2]=m;t=e}f[t>>2]=84736;f[t+24>>2]=p;f[t+28>>2]=j;f[t+16>>2]=3;if((r|0)!=(t|0))if(!r)v=t;else{Yi[f[(f[r>>2]|0)+4>>2]&4095](r);v=t}else v=r;j=v+16|0;p=f[j>>2]|0;if(!(p&1)){w=p;x=0}else{p=_i[f[(f[v>>2]|0)+100>>2]&2047](v)|0;e=b[p+11>>0]|0;m=e<<24>>24<0?f[p+4>>2]|0:e&255;e=m+1+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=f[j>>2]|0;x=e}if(!(w&2))y=0;else{e=ATa(_i[f[(f[v>>2]|0)+104>>2]&2047](v)|0)|0;y=e+1+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}e=y+x|0;j=e+n+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0;RIa(d)|0;n=j;i=v}if(i|0?(_i[f[(f[i>>2]|0)+20>>2]&2047](i)|0)==0:0)Yi[f[(f[i>>2]|0)+4>>2]&4095](i);i=f[a+60>>2]|0;v=b[i+11>>0]|0;d=v<<24>>24<0;if(d)z=f[i+4>>2]|0;else z=v&255;if(!z)A=n;else{z=d?f[i+4>>2]|0:v&255;A=n+1+z+((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)|0}z=f[a+64>>2]|0;n=b[z+11>>0]|0;v=n<<24>>24<0;if(v)B=f[z+4>>2]|0;else B=n&255;if(!B)C=A;else{B=v?f[z+4>>2]|0:n&255;C=A+1+B+((((($(B|1|0)|0)^31)*9|0)+73|0)>>>6)|0}B=f[a+68>>2]|0;A=b[B+11>>0]|0;n=A<<24>>24<0;if(n)D=f[B+4>>2]|0;else D=A&255;if(!D){E=C;F=a+72|0;f[F>>2]=E;u=c;return E|0}D=n?f[B+4>>2]|0:A&255;E=C+1+D+((((($(D|1|0)|0)^31)*9|0)+73|0)>>>6)|0;F=a+72|0;f[F>>2]=E;u=c;return E|0}function lWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+16|0;e=d;g=a+60|0;h=f[g>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;if(j)k=f[h+4>>2]|0;else k=i&255;if(k|0){if(j){l=f[h>>2]|0;m=f[h+4>>2]|0}else{l=h;m=i&255}m$b(l,m,1,402107)|0;f$b(1,f[g>>2]|0,c)}g=a+64|0;m=f[g>>2]|0;l=b[m+11>>0]|0;i=l<<24>>24<0;if(i)n=f[m+4>>2]|0;else n=l&255;if(n|0){if(i){o=f[m>>2]|0;p=f[m+4>>2]|0}else{o=m;p=l&255}m$b(o,p,1,402138)|0;f$b(2,f[g>>2]|0,c)}g=f[a+12>>2]|0;if((g|0)>0){p=a+20|0;o=0;do{l=f[(f[p>>2]|0)+4+(o<<2)>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){q=f[l>>2]|0;r=f[l+4>>2]|0}else{q=l;r=m&255}m$b(q,r,1,402167)|0;e$b(3,f[(f[p>>2]|0)+4+(o<<2)>>2]|0,c);o=o+1|0}while((o|0)!=(g|0))}g=a+68|0;o=f[g>>2]|0;p=b[o+11>>0]|0;r=p<<24>>24<0;if(r)s=f[o+4>>2]|0;else s=p&255;if(s|0){if(r){t=f[o>>2]|0;v=f[o+4>>2]|0}else{t=o;v=p&255}m$b(t,v,1,402199)|0;f$b(4,f[g>>2]|0,c)}g=a+24|0;elc(g);v=a+56|0;do if(f[f[v>>2]>>2]|0){if(!(b[c+18>>0]|0)){if(f[223514]|0)w=35}else if(b[c+19>>0]|0)w=35;if((w|0)==35?(elc(g),(f[f[v>>2]>>2]|0)>>>0>1):0){elc(g);t=f[f[v>>2]>>2]|0;p=bYc(t>>>0>1073741823?-1:t<<2)|0;elc(g);t=f[v>>2]|0;o=f[t+12>>2]|0;r=f[t+4>>2]|0;a:do if(r>>>0>o>>>0){s=f[t+16>>2]|0;q=o;while(1){x=f[s+(q<<2)>>2]|0;if(x|0)break;m=q+1|0;if(m>>>0<r>>>0)q=m;else{y=0;z=m;break a}}if((x|0)==(f[s+((q^1)<<2)>>2]|0)){y=f[(f[x>>2]|0)+16>>2]|0;z=q;break}else{y=x;z=q;break}}else{y=0;z=o}while(0);f[e>>2]=y;f[e+4>>2]=t;f[e+8>>2]=z;o=0;while(1){elc(g);r=f[e>>2]|0;if(!r)break;f[p+(o<<2)>>2]=f[r+12>>2];RIa(e)|0;o=o+1|0}fTa(p,p+(o<<2)|0,e);if(o|0){t=a+44|0;r=0;m=0;do{l=p+(r<<2)|0;i=f[l>>2]|0;n=i+16|0;h=f[t>>2]|0;if(!h){j=$Xc(32)|0;f[j+12>>2]=0;f[j+4>>2]=537368;f[j+8>>2]=0;f[j+20>>2]=0;A=j}else{if(f[h+64>>2]|0)SXb(h,15616,32);j=QXb(h,32)|0;k=h;f[j+12>>2]=k;f[j+4>>2]=537368;f[j+8>>2]=0;f[j+20>>2]=k;A=j}f[A>>2]=84736;f[A+24>>2]=i;f[A+28>>2]=n;f[A+16>>2]=3;if((m|0)!=(A|0))if(!m)B=A;else{Yi[f[(f[m>>2]|0)+4>>2]&4095](m);B=A}else B=m;k$b(5,B,c);n=(_i[f[(f[B>>2]|0)+20>>2]&2047](B)|0)==0;m=n?B:0;n=f[l>>2]|0;l=b[n+11>>0]|0;if(l<<24>>24<0){C=f[n>>2]|0;D=f[n+4>>2]|0}else{C=n;D=l&255}m$b(C,D,1,402232)|0;r=r+1|0}while(r>>>0<o>>>0);if(m|0)Yi[f[(f[m>>2]|0)+4>>2]&4095](m)}dYc(p);break}elc(g);o=f[v>>2]|0;r=f[o+12>>2]|0;t=f[o+4>>2]|0;b:do if(t>>>0>r>>>0){l=f[o+16>>2]|0;n=r;while(1){E=f[l+(n<<2)>>2]|0;if(E|0)break;i=n+1|0;if(i>>>0<t>>>0)n=i;else{F=0;G=i;break b}}if((E|0)==(f[l+((n^1)<<2)>>2]|0)){F=f[(f[E>>2]|0)+16>>2]|0;G=n;break}else{F=E;G=n;break}}else{F=0;G=r}while(0);f[e>>2]=F;f[e+4>>2]=o;f[e+8>>2]=G;r=a+44|0;t=0;while(1){elc(g);p=f[e>>2]|0;if(!p)break;m=f[p+12>>2]|0;p=m+16|0;q=f[r>>2]|0;if(!q){s=$Xc(32)|0;f[s+12>>2]=0;f[s+4>>2]=537368;f[s+8>>2]=0;f[s+20>>2]=0;H=s}else{if(f[q+64>>2]|0)SXb(q,15616,32);s=QXb(q,32)|0;i=q;f[s+12>>2]=i;f[s+4>>2]=537368;f[s+8>>2]=0;f[s+20>>2]=i;H=s}f[H>>2]=84736;f[H+24>>2]=m;f[H+28>>2]=p;f[H+16>>2]=3;if((t|0)!=(H|0))if(!t)I=H;else{Yi[f[(f[t>>2]|0)+4>>2]&4095](t);I=H}else I=t;k$b(5,I,c);p=(_i[f[(f[I>>2]|0)+20>>2]&2047](I)|0)==0;m=f[(f[e>>2]|0)+12>>2]|0;s=b[m+11>>0]|0;if(s<<24>>24<0){J=f[m>>2]|0;K=f[m+4>>2]|0}else{J=m;K=s&255}m$b(J,K,1,402232)|0;RIa(e)|0;t=p?I:0}if(t|0)Yi[f[(f[t>>2]|0)+4>>2]&4095](t)}while(0);I=f[a+4>>2]|0;if(!((I&1|0)!=0&(b[476924]|0)!=0)){u=d;return}Oqc(I&-2,c);u=d;return}function mWa(a){a=a|0;return f[a+72>>2]|0}function nWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+16|0;g=e;h=a+60|0;i=f[h>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;if(k)l=f[i+4>>2]|0;else l=j&255;if(!l)m=d;else{if(k){n=f[i>>2]|0;o=f[i+4>>2]|0}else{n=i;o=j&255}m$b(n,o,1,402107)|0;o=f[h>>2]|0;b[d>>0]=10;m=gZb(o,d+1|0)|0}d=a+64|0;o=f[d>>2]|0;h=b[o+11>>0]|0;n=h<<24>>24<0;if(n)p=f[o+4>>2]|0;else p=h&255;if(!p)q=m;else{if(n){r=f[o>>2]|0;s=f[o+4>>2]|0}else{r=o;s=h&255}m$b(r,s,1,402138)|0;s=f[d>>2]|0;b[m>>0]=18;q=gZb(s,m+1|0)|0}m=f[a+12>>2]|0;if((m|0)>0){s=a+20|0;d=0;r=q;while(1){h=f[(f[s>>2]|0)+4+(d<<2)>>2]|0;o=b[h+11>>0]|0;if(o<<24>>24<0){t=f[h>>2]|0;v=f[h+4>>2]|0}else{t=h;v=o&255}m$b(t,v,1,402167)|0;o=f[(f[s>>2]|0)+4+(d<<2)>>2]|0;b[r>>0]=26;h=gZb(o,r+1|0)|0;d=d+1|0;if((d|0)==(m|0)){w=h;break}else r=h}}else w=q;q=a+68|0;r=f[q>>2]|0;m=b[r+11>>0]|0;d=m<<24>>24<0;if(d)x=f[r+4>>2]|0;else x=m&255;if(!x)y=w;else{if(d){z=f[r>>2]|0;A=f[r+4>>2]|0}else{z=r;A=m&255}m$b(z,A,1,402199)|0;A=f[q>>2]|0;b[w>>0]=34;y=gZb(A,w+1|0)|0}w=a+24|0;elc(w);A=a+56|0;do if(f[f[A>>2]>>2]|0){if(c?(elc(w),(f[f[A>>2]>>2]|0)>>>0>1):0){elc(w);q=f[f[A>>2]>>2]|0;z=bYc(q>>>0>1073741823?-1:q<<2)|0;elc(w);q=f[A>>2]|0;m=f[q+12>>2]|0;r=f[q+4>>2]|0;a:do if(r>>>0>m>>>0){d=f[q+16>>2]|0;x=m;while(1){B=f[d+(x<<2)>>2]|0;if(B|0)break;s=x+1|0;if(s>>>0<r>>>0)x=s;else{C=0;D=s;break a}}if((B|0)==(f[d+((x^1)<<2)>>2]|0)){C=f[(f[B>>2]|0)+16>>2]|0;D=x;break}else{C=B;D=x;break}}else{C=0;D=m}while(0);f[g>>2]=C;f[g+4>>2]=q;f[g+8>>2]=D;m=0;while(1){elc(w);r=f[g>>2]|0;if(!r)break;f[z+(m<<2)>>2]=f[r+12>>2];RIa(g)|0;m=m+1|0}fTa(z,z+(m<<2)|0,g);if(m){q=a+44|0;r=0;s=y;v=0;do{t=z+(r<<2)|0;h=f[t>>2]|0;o=h+16|0;n=f[q>>2]|0;if(!n){p=$Xc(32)|0;f[p+12>>2]=0;f[p+4>>2]=537368;f[p+8>>2]=0;f[p+20>>2]=0;E=p}else{if(f[n+64>>2]|0)SXb(n,15616,32);p=QXb(n,32)|0;j=n;f[p+12>>2]=j;f[p+4>>2]=537368;f[p+8>>2]=0;f[p+20>>2]=j;E=p}f[E>>2]=84736;f[E+24>>2]=h;f[E+28>>2]=o;f[E+16>>2]=3;if((v|0)!=(E|0))if(!v)F=E;else{Yi[f[(f[v>>2]|0)+4>>2]&4095](v);F=E}else F=v;b[s>>0]=42;o=s+1|0;h=F+16|0;p=f[h>>2]|0;if(!(p&1)){G=p;H=0}else{p=_i[f[(f[F>>2]|0)+100>>2]&2047](F)|0;j=b[p+11>>0]|0;n=j<<24>>24<0?f[p+4>>2]|0:j&255;j=n+1+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;G=f[h>>2]|0;H=j}if(!(G&2))I=0;else{j=(_i[f[(f[F>>2]|0)+104>>2]&2047](F)|0)+16|0;h=f[j>>2]|0;I=h+1+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=I+H|0;if(h>>>0>127){j=h;n=o;while(1){b[n>>0]=j|128;p=j>>>7;i=n+1|0;if(j>>>0>16383){j=p;n=i}else{J=i;K=p;break}}}else{J=o;K=h}b[J>>0]=K;n=_i[f[(f[F>>2]|0)+100>>2]&2047](F)|0;b[J+1>>0]=10;j=gZb(n,J+2|0)|0;n=_i[f[(f[F>>2]|0)+104>>2]&2047](F)|0;b[j>>0]=18;x=j+1|0;j=_i[f[(f[n>>2]|0)+60>>2]&2047](n)|0;if(j>>>0>127){d=j;p=x;while(1){b[p>>0]=d|128;i=d>>>7;k=p+1|0;if(d>>>0>16383){d=i;p=k}else{L=k;M=i;break}}}else{L=x;M=j}b[L>>0]=M;s=hj[f[(f[n>>2]|0)+64>>2]&511](n,1,L+1|0)|0;p=(_i[f[(f[F>>2]|0)+20>>2]&2047](F)|0)==0;v=p?F:0;p=f[t>>2]|0;d=b[p+11>>0]|0;if(d<<24>>24<0){N=f[p>>2]|0;O=f[p+4>>2]|0}else{N=p;O=d&255}m$b(N,O,1,402232)|0;r=r+1|0}while(r>>>0<m>>>0);if(!v)P=s;else{Yi[f[(f[v>>2]|0)+4>>2]&4095](v);P=s}}else P=y;dYc(z);Q=P;break}elc(w);m=f[A>>2]|0;r=f[m+12>>2]|0;q=f[m+4>>2]|0;b:do if(q>>>0>r>>>0){d=f[m+16>>2]|0;p=r;while(1){R=f[d+(p<<2)>>2]|0;if(R|0)break;h=p+1|0;if(h>>>0<q>>>0)p=h;else{S=0;T=h;break b}}if((R|0)==(f[d+((p^1)<<2)>>2]|0)){S=f[(f[R>>2]|0)+16>>2]|0;T=p;break}else{S=R;T=p;break}}else{S=0;T=r}while(0);f[g>>2]=S;f[g+4>>2]=m;f[g+8>>2]=T;r=a+44|0;q=y;z=0;while(1){elc(w);s=f[g>>2]|0;if(!s)break;v=f[s+12>>2]|0;s=v+16|0;t=f[r>>2]|0;if(!t){n=$Xc(32)|0;f[n+12>>2]=0;f[n+4>>2]=537368;f[n+8>>2]=0;f[n+20>>2]=0;U=n}else{if(f[t+64>>2]|0)SXb(t,15616,32);n=QXb(t,32)|0;j=t;f[n+12>>2]=j;f[n+4>>2]=537368;f[n+8>>2]=0;f[n+20>>2]=j;U=n}f[U>>2]=84736;f[U+24>>2]=v;f[U+28>>2]=s;f[U+16>>2]=3;if((z|0)!=(U|0))if(!z)V=U;else{Yi[f[(f[z>>2]|0)+4>>2]&4095](z);V=U}else V=z;b[q>>0]=42;s=q+1|0;v=V+16|0;n=f[v>>2]|0;if(!(n&1)){W=n;X=0}else{n=_i[f[(f[V>>2]|0)+100>>2]&2047](V)|0;j=b[n+11>>0]|0;t=j<<24>>24<0?f[n+4>>2]|0:j&255;j=t+1+((((($(t|1|0)|0)^31)*9|0)+73|0)>>>6)|0;W=f[v>>2]|0;X=j}if(!(W&2))Y=0;else{j=(_i[f[(f[V>>2]|0)+104>>2]&2047](V)|0)+16|0;v=f[j>>2]|0;Y=v+1+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0}v=Y+X|0;if(v>>>0>127){j=v;t=s;while(1){b[t>>0]=j|128;n=j>>>7;x=t+1|0;if(j>>>0>16383){j=n;t=x}else{Z=x;_=n;break}}}else{Z=s;_=v}b[Z>>0]=_;t=_i[f[(f[V>>2]|0)+100>>2]&2047](V)|0;b[Z+1>>0]=10;j=gZb(t,Z+2|0)|0;t=_i[f[(f[V>>2]|0)+104>>2]&2047](V)|0;b[j>>0]=18;p=j+1|0;j=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(j>>>0>127){d=j;n=p;while(1){b[n>>0]=d|128;x=d>>>7;h=n+1|0;if(d>>>0>16383){d=x;n=h}else{aa=h;ba=x;break}}}else{aa=p;ba=j}b[aa>>0]=ba;n=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,aa+1|0)|0;d=(_i[f[(f[V>>2]|0)+20>>2]&2047](V)|0)==0;v=f[(f[g>>2]|0)+12>>2]|0;s=b[v+11>>0]|0;if(s<<24>>24<0){ca=f[v>>2]|0;da=f[v+4>>2]|0}else{ca=v;da=s&255}m$b(ca,da,1,402232)|0;RIa(g)|0;q=n;z=d?V:0}if(!z)Q=q;else{Yi[f[(f[z>>2]|0)+4>>2]&4095](z);Q=q}}else Q=y;while(0);y=f[a+4>>2]|0;if(!((y&1|0)!=0&(b[476924]|0)!=0)){ea=Q;u=e;return ea|0}ea=Pqc(y&-2,Q)|0;u=e;return ea|0}function oWa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;hWa(a);c=kZc(b,21568,15600,0)|0;if(!c){Ooc(b,a);return}else{sWa(a,c);return}}function pWa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15600,0)|0;if(!c){Ooc(b,a);return}else{sWa(a,c);return}}function qWa(a,b){a=a|0;b=b|0;f[a+72>>2]=b;return}function rWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223035]|0)!=2){f[d>>2]=165456;f[d+4>>2]=12;b[d+8>>0]=0;J_b(892140,d);a_b(d)}d=531208;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function sWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}vSa(a+8|0,c+8|0);tWa(a+24|0,c+24|0);e=f[c+60>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+60|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+64>>2]|0;k=b[e+11>>0]|0;if(k<<24>>24<0)l=f[e+4>>2]|0;else l=k&255;do if(l|0){k=a+64|0;i=f[d>>2]|0;j=i&-2;if(!(i&1))m=j;else m=f[j+4>>2]|0;j=f[k>>2]|0;if((j|0)==537368){xJa(k,m,e);break}else{oYc(j,e)|0;break}}while(0);e=f[c+68>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)n=f[e+4>>2]|0;else n=c&255;if(!n)return;n=a+68|0;a=f[d>>2]|0;d=a&-2;if(!(a&1))o=d;else o=f[d+4>>2]|0;d=f[n>>2]|0;if((d|0)==537368){xJa(n,o,e);return}else{oYc(d,e)|0;return}}function tWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;elc(a);elc(b);e=f[b+32>>2]|0;b=f[e+12>>2]|0;g=f[e+4>>2]|0;a:do if(g>>>0>b>>>0){h=f[e+16>>2]|0;i=b;while(1){j=f[h+(i<<2)>>2]|0;if(j|0)break;k=i+1|0;if(k>>>0<g>>>0)i=k;else{l=0;m=k;break a}}if((j|0)==(f[h+((i^1)<<2)>>2]|0)){l=f[(f[j>>2]|0)+16>>2]|0;m=i;break}else{l=j;m=i;break}}else{l=0;m=b}while(0);f[d>>2]=l;f[d+4>>2]=e;f[d+8>>2]=m;if(!l){dlc(a);u=c;return}m=a+24|0;e=l;do{l=f[e+12>>2]|0;kUa(bJa(m,l)|0,l+16|0);RIa(d)|0;e=f[d>>2]|0}while((e|0)!=0);dlc(a);u=c;return}function uWa(a){a=a|0;HVa(a);cYc(a);return}function vWa(a){a=a|0;return f[a+24>>2]|0}function wWa(a){a=a|0;return f[a+28>>2]|0}function xWa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;i=c+4|0;if(h>>>0<(f[i>>2]|0)>>>0?(b[h>>0]|0)==10:0){f[c>>2]=h+1;h=a+8|0;if(!(l$b(c,h)|0)){j=0;u=e;return j|0}k=f[c>>2]|0;if((((f[i>>2]|0)-k|0)>0?(b[k>>0]|0)==18:0)?(k=a+4|0,l=f[k>>2]|0,m=f[f[l+8>>2]>>2]|0,n=bJa(l,h)|0,l=a+20|0,f[l>>2]=n,(m|0)!=(f[f[(f[k>>2]|0)+8>>2]>>2]|0)):0){m=f[i>>2]|0;o=f[c>>2]|0;p=m-o|0;if((p|0)<1){SYb(c,1,p)|0;q=f[c>>2]|0;r=f[i>>2]|0;s=f[l>>2]|0}else{l=o+1|0;f[c>>2]=l;q=l;r=m;s=n}if(q>>>0<r>>>0?(r=b[q>>0]|0,r<<24>>24>-1):0){f[c>>2]=q+1;t=r&255;v=14}else v=13;if((v|0)==13?(r=YYb(c)|0,(r|0)>-1):0){t=r;v=14}do if(((v|0)==14?(JYb(g,c,t),(f[g+4>>2]|0)>=0):0)?BTa(s,c)|0:0){if(!(OYb(c,f[g>>2]|0)|0))break;do if((f[c>>2]|0)==(f[i>>2]|0)){if((f[c+32>>2]|0)==0?(f[c+12>>2]|0)!=(f[c+28>>2]|0):0)break;f[c+20>>2]=0;b[c+24>>0]=1;j=1;u=e;return j|0}while(0);j=yWa(a,c)|0;u=e;return j|0}while(0);PSa(f[k>>2]|0,h)|0;j=0;u=e;return j|0}}else{f[g>>2]=0;d[g+4>>1]=0;b[g+6>>0]=0;h=a+8|0;k=h+11|0;if((b[k>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+12>>2]=0}else{b[h>>0]=0;b[k>>0]=0}sYc(h,0);f[a+8>>2]=0;h=a+12|0;f[h>>2]=f[g>>2];d[h+4>>1]=d[g+4>>1]|0;b[h+6>>0]=b[g+6>>0]|0;b[a+19>>0]=0}g=f[(f[a>>2]|0)+20>>2]|0;if(!g){h=$Xc(24)|0;f[h+12>>2]=0;f[h+4>>2]=537368;f[h+8>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;w=h}else{if(f[g+64>>2]|0)SXb(g,15552,24);h=QXb(g,24)|0;k=g;f[h+12>>2]=k;f[h+4>>2]=537368;f[h+8>>2]=0;f[h+16>>2]=0;f[h+20>>2]=k;w=h}f[w>>2]=84388;h=a+24|0;k=f[h>>2]|0;if((k|0)==(w|0))x=w;else{if(k|0)Yi[f[(f[k>>2]|0)+4>>2]&4095](k);f[h>>2]=w;x=w}w=x+16|0;f[w>>2]=f[w>>2]|1;w=x+4|0;k=f[w>>2]|0;if((k|0)==537368){xJa(w,f[x+12>>2]|0,537368);y=f[w>>2]|0}else y=k;oYc(y,a+8|0)|0;y=f[h>>2]|0;k=Mi[f[(f[y>>2]|0)+44>>2]&1023](y,c)|0;if(k)zWa(a);a=f[h>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0)){j=k;u=e;return j|0}f[h>>2]=0;j=k;u=e;return j|0}function yWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[(f[a>>2]|0)+20>>2]|0;if(!d){e=$Xc(24)|0;f[e+12>>2]=0;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;g=e}else{if(f[d+64>>2]|0)SXb(d,15552,24);e=QXb(d,24)|0;h=d;f[e+12>>2]=h;f[e+4>>2]=537368;f[e+8>>2]=0;f[e+16>>2]=0;f[e+20>>2]=h;g=e}f[g>>2]=84388;e=a+24|0;h=f[e>>2]|0;if((h|0)==(g|0))i=g;else{if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);f[e>>2]=g;i=g}g=f[a+20>>2]|0;h=i+16|0;f[h>>2]=f[h>>2]|2;h=i+8|0;d=f[i+12>>2]|0;i=f[h>>2]|0;if(!i){if(!d){j=$Xc(24)|0;ISa(j);k=j}else{if(f[d+64>>2]|0)SXb(d,15400,24);j=QXb(d,24)|0;JSa(j,d);k=j}f[h>>2]=k;l=k}else l=i;PTa(l,g);g=a+8|0;PSa(f[a+4>>2]|0,g)|0;l=f[e>>2]|0;i=l+16|0;f[i>>2]=f[i>>2]|1;i=l+4|0;k=f[i>>2]|0;if((k|0)==537368){xJa(i,f[l+12>>2]|0,537368);m=f[i>>2]|0}else m=k;k=m+11|0;if((b[k>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0}else{b[m>>0]=0;b[k>>0]=0}sYc(m,0);f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=f[e>>2]|0;m=Mi[f[(f[g>>2]|0)+44>>2]&1023](g,c)|0;if(m)zWa(a);a=f[e>>2]|0;if(!(_i[f[(f[a>>2]|0)+20>>2]&2047](a)|0))return m|0;f[e>>2]=0;return m|0}function zWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+24|0;c=f[b>>2]|0;d=a+8|0;oYc(d,_i[f[(f[c>>2]|0)+100>>2]&2047](c)|0)|0;c=bJa(f[a+4>>2]|0,d)|0;d=a+20|0;f[d>>2]=c;a=f[b>>2]|0;b=a+16|0;f[b>>2]=f[b>>2]|2;b=a+8|0;e=f[a+12>>2]|0;a=f[b>>2]|0;if(a|0){g=c;h=a;PTa(g,h);return}if(!e){a=$Xc(24)|0;ISa(a);i=a}else{if(f[e+64>>2]|0)SXb(e,15400,24);a=QXb(e,24)|0;JSa(a,e);i=a}f[b>>2]=i;g=f[d>>2]|0;h=i;PTa(g,h);return}function AWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;f[a>>2]=84196;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=a+24|0;f[g>>2]=171580;f[a+28>>2]=c;f[a+32>>2]=0;h=a+36|0;w_b(h);f[a+40>>2]=0;tSa(c,h);f[g>>2]=84304;f[a+44>>2]=c;g=a+48|0;f[g>>2]=c;c=a+52|0;f[c>>2]=0;aJa(g);f[c>>2]=0;if((f[223039]|0)==2){i=a+60|0;f[i>>2]=537368;j=a+64|0;f[j>>2]=537368;k=a+68|0;f[k>>2]=537368;l=a+72|0;f[l>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=16;b[e+8>>0]=0;J_b(892156,e);a_b(e);i=a+60|0;f[i>>2]=537368;j=a+64|0;f[j>>2]=537368;k=a+68|0;f[k>>2]=537368;l=a+72|0;f[l>>2]=0;u=d;return}function BWa(a){a=a|0;var c=0;c=f[a+60>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+64>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+68>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function CWa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+12|0;d=f[c>>2]|0;if(!d){f[c>>2]=0;return}if(f[a>>2]|0){f[c>>2]=0;return}a=f[d>>2]|0;if((a|0)>0){e=0;do{g=f[d+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);cYc(g)}e=e+1|0}while((e|0)!=(a|0));h=f[c>>2]|0}else h=d;cYc(h);f[c>>2]=0;return}function DWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}EWa(a+8|0,b+8|0);if((b|0)!=531048){d=b+24|0;g=f[d>>2]|0;if(g|0){e=a+24|0;c=f[e>>2]|0;if(!c){FWa(a);h=f[d>>2]|0;i=f[e>>2]|0}else{h=g;i=c}XHb(i,h|0?h:536752)}h=b+28|0;i=f[h>>2]|0;if(i|0){c=a+28|0;g=f[c>>2]|0;if(!g){GWa(a);j=f[h>>2]|0;k=f[c>>2]|0}else{j=i;k=g}OKb(k,j|0?j:537288)}}j=f[b+32>>2]|0;if(!j)return;f[a+32>>2]=j;return}function EWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{HWa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(76)|0;qVa(l);HWa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15600,80);l=QXb(i,80)|0;AWa(l,i);HWa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function FWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(44)|0;SHb(c);e=c;g=a+24|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,19168,48);c=QXb(d,48)|0;THb(c,d);e=c;g=a+24|0;f[g>>2]=e;return}function GWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=$Xc(36)|0;JKb(c);e=c;g=a+28|0;f[g>>2]=e;return}if(f[d+64>>2]|0)SXb(d,19392,40);c=QXb(d,40)|0;KKb(c,d);e=c;g=a+28|0;f[g>>2]=e;return}function HWa(a,b){a=a|0;b=b|0;sWa(b,a);return}function IWa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=84040;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=531048?(f[223037]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=14;b[d+8>>0]=0;J_b(892148,d);a_b(d)}d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function JWa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=84040;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[223037]|0)!=2){f[e>>2]=165456;f[e+4>>2]=14;b[e+8>>0]=0;J_b(892148,e);a_b(e)}e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;u=d;return}function KWa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223036]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=13;b[c+8>>0]=0;J_b(892144,c);a_b(c);u=a;return}function LWa(a){a=a|0;var b=0;b=a+24|0;elc(b);iSa(a+48|0);dlc(b);return}function MWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;f[a>>2]=84196;d=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;vSa(a+8|0,c+8|0);e=a+24|0;f[e>>2]=171580;f[a+28>>2]=0;f[a+32>>2]=0;w_b(a+36|0);f[a+40>>2]=0;f[e>>2]=84304;f[a+44>>2]=0;g=a+48|0;f[g>>2]=0;h=a+52|0;f[h>>2]=0;aJa(g);f[h>>2]=0;f[a+72>>2]=0;h=f[c+4>>2]|0;if(h&1|0){g=f[d>>2]|0;if(!(g&1))i=lSa(d)|0;else i=g&-2;vqc(i,h&-2)}tWa(e,c+24|0);e=a+60|0;f[e>>2]=537368;h=f[c+60>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0)j=f[h+4>>2]|0;else j=i&255;if(j|0){j=f[a+4>>2]|0;i=j&-2;if(!(j&1))k=i;else k=f[i+4>>2]|0;xJa(e,k,h)}h=a+64|0;f[h>>2]=537368;k=f[c+64>>2]|0;e=b[k+11>>0]|0;if(e<<24>>24<0)l=f[k+4>>2]|0;else l=e&255;if(l|0){l=f[a+4>>2]|0;e=l&-2;if(!(l&1))m=e;else m=f[e+4>>2]|0;xJa(h,m,k)}k=a+68|0;f[k>>2]=537368;m=f[c+68>>2]|0;c=b[m+11>>0]|0;if(c<<24>>24<0)n=f[m+4>>2]|0;else n=c&255;if(!n)return;n=f[a+4>>2]|0;a=n&-2;if(!(n&1))o=a;else o=f[a+4>>2]|0;xJa(k,o,m);return}function NWa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;hWa(a);sWa(a,b);return}function OWa(a){a=a|0;var c=0,d=0;f[a>>2]=84908;c=f[a+8>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function PWa(a){a=a|0;OWa(a);cYc(a);return}function QWa(a){a=a|0;a=$Xc(32)|0;AXa(a);return a|0}function RWa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(32)|0;AXa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15632,32);a=QXb(b,32)|0;CXa(a,b);c=a;return c|0}function SWa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function TWa(a){a=a|0;return f[a+4>>2]|0}function UWa(a){a=a|0;var c=0,d=0,e=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=537368){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;d=f[c>>2]|0;if(!(d&1))return;c=d&-2;if(!(f[c>>2]|0))return;sqc(c);return}function VWa(a){a=a|0;return 1}function WWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=e+8|0;j=a+8|0;k=a+4|0;l=a+8|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)!=8){r=o;break b}n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;s=a&255;t=0}else{LYb(e,c);a=e;if(!(b[i>>0]|0)){v=0;p=29;break a}else{s=f[a>>2]|0;t=f[a+4>>2]|0}}a=h;f[a>>2]=s;f[a+4>>2]=t;continue a;break}case 2:break;default:{r=o;break b}}if((o&255|0)==18){a=f[k>>2]|0;n=a&-2;if(!(a&1))w=n;else w=f[n+4>>2]|0;n=f[j>>2]|0;if((n|0)==537368){xJa(j,w,537368);x=f[j>>2]|0}else x=n;if(!(l$b(c,x)|0)){v=0;p=29;break a}n=f[l>>2]|0;a=b[n+11>>0]|0;if(a<<24>>24<0){y=f[n>>2]|0;z=f[n+4>>2]|0}else{y=n;z=a&255}if(m$b(y,z,0,402958)|0)continue a;else{v=0;p=29;break a}}else r=o}while(0);if(!r){v=1;p=29;break}a=f[k>>2]|0;if(!(a&1))A=lSa(k)|0;else A=a&-2;if(!(Lqc(c,r,A)|0)){v=0;p=29;break}}if((p|0)==29){u=d;return v|0}return 0}function XWa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h)i=d;else{h=g?f[c+4>>2]|0:e&255;i=d+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}h=a+16|0;d=f[h>>2]|0;e=f[h+4>>2]|0;if((d|0)==0&(e|0)==0){j=i;k=a+24|0;f[k>>2]=j;return j|0}h=t1c(d|1|0,e|0,1)|0;j=i+1+((((h^63)*9|0)+73|0)>>>6)|0;k=a+24|0;f[k>>2]=j;return j|0}function YWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+16|0;e=f[d>>2]|0;g=f[d+4>>2]|0;if(!((e|0)==0&(g|0)==0))T_b(1,e,g,c);g=a+8|0;e=f[g>>2]|0;d=b[e+11>>0]|0;h=d<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=d&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=d&255}m$b(j,k,1,402958)|0;f$b(2,f[g>>2]|0,c)}g=f[a+4>>2]|0;if(!((g&1|0)!=0&(b[476924]|0)!=0))return;Oqc(g&-2,c);return}function ZWa(a){a=a|0;return f[a+24>>2]|0}function _Wa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+16|0;e=f[c>>2]|0;g=f[c+4>>2]|0;if((e|0)==0&(g|0)==0)h=d;else{b[d>>0]=8;c=d+1|0;d=e&255;if(g>>>0>0|(g|0)==0&e>>>0>127){i=c;j=d;k=e;e=g;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,e|0,7)|0;l=i+1|0;m=k&255;if(!(e>>>0>0|(e|0)==0&g>>>0>16383)){n=l;o=m;break}else{i=l;j=m;e=J}}}else{n=c;o=d}b[n>>0]=o;h=n+1|0}n=a+8|0;o=f[n>>2]|0;d=b[o+11>>0]|0;c=d<<24>>24<0;if(c)p=f[o+4>>2]|0;else p=d&255;if(!p)q=h;else{if(c){r=f[o>>2]|0;s=f[o+4>>2]|0}else{r=o;s=d&255}m$b(r,s,1,402958)|0;s=f[n>>2]|0;b[h>>0]=18;q=gZb(s,h+1|0)|0}h=f[a+4>>2]|0;if(!((h&1|0)!=0&(b[476924]|0)!=0)){t=q;return t|0}t=Pqc(h&-2,q)|0;return t|0}function $Wa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+4|0;e=f[a+8>>2]|0;do if((e|0)!=537368){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;e=f[d>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d);d=kZc(c,21568,15632,0)|0;if(!d){Ooc(c,a);return}else{DXa(a,d);return}}function aXa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15632,0)|0;if(!c){Ooc(b,a);return}else{DXa(a,c);return}}function bXa(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function cXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223040]|0)!=2){f[d>>2]=165456;f[d+4>>2]=17;b[d+8>>0]=0;J_b(892160,d);a_b(d)}d=531280;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function dXa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223041]|0)!=2){f[c>>2]=165456;f[c+4>>2]=18;b[c+8>>0]=0;J_b(892164,c);a_b(c)}d=$Xc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=18;e=d;g=402580;h=e+18|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+18>>0]=0;ejc(c,85008,85032,84844,0,531280,0,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function eXa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223042]|0)!=2){f[c>>2]=165456;f[c+4>>2]=19;b[c+8>>0]=0;J_b(892168,c);a_b(c)}if((f[223043]|0)!=2){f[c>>2]=165456;f[c+4>>2]=20;b[c+8>>0]=0;J_b(892172,c);a_b(c)}n3b(402599,231);Boc(402580,2251);u=a;return}function fXa(){var a=0;d_b(3005001,3005e3,402831);WXb();f[132804]=84908;f[132805]=0;f[132806]=537368;a=531232;f[a>>2]=0;f[a+4>>2]=0;f[132810]=0;C_b(531216);return}function gXa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,402831);WXb();if((f[223042]|0)!=2){f[c>>2]=165456;f[c+4>>2]=19;b[c+8>>0]=0;J_b(892168,c);a_b(c)}f[132812]=85048;f[132813]=0;f[132814]=0;f[132815]=0;f[132816]=0;f[132817]=0;b[531272]=0;f[132819]=0;C_b(531248);u=a;return}function hXa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223040]|0)!=2){f[c>>2]=165456;f[c+4>>2]=17;b[c+8>>0]=0;J_b(892160,c);a_b(c)}jjc(531280,2);u=a;return}function iXa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=85048;b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function jXa(a){a=a|0;iXa(a);cYc(a);return}function kXa(a){a=a|0;a=$Xc(32)|0;EXa(a);return a|0}function lXa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=$Xc(32)|0;EXa(a);c=a;return c|0}if(f[b+64>>2]|0)SXb(b,15648,32);a=QXb(b,32)|0;FXa(a,b);c=a;return c|0}function mXa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function nXa(a){a=a|0;return f[a+4>>2]|0}function oXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+4|0;j=f[h+8>>2]|0;do if((j|0)!=537368){k=j+11|0;if((b[k>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[k>>0]=0;break}}while(0);j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;j=f[i>>2]|0;if(j&1|0?(k=j&-2,f[k>>2]|0):0)sqc(k)}while((g|0)!=(d|0));f[c>>2]=0}b[a+24>>0]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function pXa(a){a=a|0;return 1}function qXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=e+4|0;m=a+24|0;n=e+8|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=ZYb(c,t)|0;if((q+-1|0)>>>0<127){r=q;s=6}else v=q}b:do if((s|0)==6){s=0;switch(r>>>3&536870911|0){case 2:break;case 3:{if((r&255|0)!=24){v=r;break b}q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0?(a=b[q>>0]|0,a<<24>>24>-1):0){f[c>>2]=q+1;w=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[n>>0]|0)){x=0;s=39;break a}else w=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[m>>0]=w&1;continue a;break}default:{v=r;break b}}if((r&255|0)==18){a=f[i>>2]|0;do if(a){q=f[k>>2]|0;p=f[a>>2]|0;if((q|0)>=(p|0))if((p|0)==(f[j>>2]|0)){y=p;s=13;break}else{z=p;A=a;s=14;break}else{f[k>>2]=q+1;B=f[a+4+(q<<2)>>2]|0;break}}else{y=f[j>>2]|0;s=13}while(0);if((s|0)==13){s=0;XZb(h,y+1|0);a=f[i>>2]|0;z=f[a>>2]|0;A=a;s=14}if((s|0)==14){s=0;f[A>>2]=z+1;a=f[h>>2]|0;if(!a){q=$Xc(32)|0;AXa(q);C=q}else{if(f[a+64>>2]|0)SXb(a,15632,32);q=QXb(a,32)|0;CXa(q,a);C=q}q=f[i>>2]|0;a=f[k>>2]|0;f[k>>2]=a+1;f[q+4+(a<<2)>>2]=C;B=C}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;D=q&255}else{q=YYb(c)|0;if((q|0)>-1)D=q;else{x=0;s=39;break a}}JYb(e,c,D);if((f[l>>2]|0)<0){s=26;break a}if(!(Mi[f[(f[B>>2]|0)+44>>2]&1023](B,c)|0)){s=26;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{x=0;s=39;break a}}else v=r}while(0);if(!v){x=1;s=39;break}q=f[o>>2]|0;if(!(q&1))E=lSa(o)|0;else E=q&-2;if(!(Lqc(c,v,E)|0)){x=0;s=39;break}}if((s|0)==26){x=0;u=d;return x|0}else if((s|0)==39){u=d;return x|0}return 0}function rXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+4>>2]|0;if((c&1|0)!=0&(b[476924]|0)!=0)d=Rqc(c&-2)|0;else d=0;c=f[a+12>>2]|0;e=c+d|0;if(!c){g=e;h=a+24|0;i=b[h>>0]|0;j=i<<24>>24!=0;k=g+2|0;l=j?k:g;m=a+28|0;f[m>>2]=l;return l|0}d=a+20|0;n=0;o=e;while(1){e=f[(f[d>>2]|0)+4+(n<<2)>>2]|0;p=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=p+o+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=n+1|0;if((n|0)==(c|0)){g=e;break}else o=e}h=a+24|0;i=b[h>>0]|0;j=i<<24>>24!=0;k=g+2|0;l=j?k:g;m=a+28|0;f[m>>2]=l;return l|0}function sXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{k$b(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}if(b[a+24>>0]|0)c$b(3,1,c);d=f[a+4>>2]|0;if(!((d&1|0)!=0&(b[476924]|0)!=0))return;Oqc(d&-2,c);return}function tXa(a){a=a|0;return f[a+28>>2]|0}function uXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=f[a+12>>2]|0;if(!e)g=d;else{h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}if(!(b[a+24>>0]|0))s=g;else{b[g>>0]=24;b[g+1>>0]=1;s=g+2|0}g=f[a+4>>2]|0;if(!((g&1|0)!=0&(b[476924]|0)!=0)){t=s;return t|0}t=Pqc(g&-2,s)|0;return t|0}function vXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((a|0)==(c|0))return;d=a+12|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+20>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+4|0;k=f[i+8>>2]|0;do if((k|0)!=537368){l=k+11|0;if((b[l>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[l>>0]=0;break}}while(0);k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;k=f[j>>2]|0;if(k&1|0?(l=k&-2,f[l>>2]|0):0)sqc(l)}while((h|0)!=(e|0));f[d>>2]=0}d=a+24|0;b[d>>0]=0;e=a+4|0;h=f[e>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g);g=kZc(c,21568,15648,0)|0;if(!g){Ooc(c,a);return}c=f[g+4>>2]|0;if(c&1|0){h=f[e>>2]|0;if(!(h&1))m=lSa(e)|0;else m=h&-2;vqc(m,c&-2)}zXa(a+8|0,g+8|0);if(!(b[g+24>>0]|0))return;b[d>>0]=1;return}function wXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,15648,0)|0;if(!d){Ooc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}zXa(a+8|0,d+8|0);if(!(b[d+24>>0]|0))return;b[a+24>>0]=1;return}function xXa(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function yXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223040]|0)!=2){f[d>>2]=165456;f[d+4>>2]=17;b[d+8>>0]=0;J_b(892160,d);a_b(d)}d=531288;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function zXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{BXa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(32)|0;AXa(l);BXa(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15632,32);l=QXb(i,32)|0;CXa(l,i);BXa(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function AXa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=84908;f[a+4>>2]=0;if((a|0)!=531216?(f[223042]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=19;b[d+8>>0]=0;J_b(892168,d);a_b(d)}f[a+8>>2]=537368;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=0;u=c;return}function BXa(a,b){a=a|0;b=b|0;DXa(b,a);return}function CXa(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=84908;f[a+4>>2]=c;if((f[223042]|0)!=2){f[e>>2]=165456;f[e+4>>2]=19;b[e+8>>0]=0;J_b(892168,e);a_b(e)}f[a+8>>2]=537368;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[a+24>>2]=0;u=d;return}function DXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;h=b[e+11>>0]|0;if(h<<24>>24<0)i=f[e+4>>2]|0;else i=h&255;do if(i|0){h=a+8|0;g=f[d>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;j=f[h>>2]|0;if((j|0)==537368){xJa(h,k,e);break}else{oYc(j,e)|0;break}}while(0);e=c+16|0;c=f[e>>2]|0;k=f[e+4>>2]|0;if((c|0)==0&(k|0)==0)return;e=a+16|0;f[e>>2]=c;f[e+4>>2]=k;return}function EXa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=85048;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=531248?(f[223043]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=20;b[d+8>>0]=0;J_b(892172,d);a_b(d)}b[a+24>>0]=0;f[a+28>>2]=0;u=c;return}function FXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[a>>2]=85048;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;if((f[223043]|0)==2){g=a+24|0;b[g>>0]=0;h=a+28|0;f[h>>2]=0;u=d;return}f[e>>2]=165456;f[e+4>>2]=20;b[e+8>>0]=0;J_b(892172,e);a_b(e);g=a+24|0;b[g>>0]=0;h=a+28|0;f[h>>2]=0;u=d;return}function GXa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223041]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=18;b[c+8>>0]=0;J_b(892164,c);a_b(c);u=a;return}function HXa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223043]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=20;b[c+8>>0]=0;J_b(892172,c);a_b(c);u=a;return}function IXa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223041]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=18;b[c+8>>0]=0;J_b(892164,c);a_b(c);u=a;return}function JXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}zXa(a+8|0,c+8|0);if(!(b[c+24>>0]|0))return;b[a+24>>0]=1;return}function KXa(a){a=a|0;var b=0,c=0;f[a>>2]=90488;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function LXa(a){a=a|0;var b=0,c=0;f[a>>2]=90488;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function MXa(a){a=a|0;a=$Xc(32)|0;p0a(a);return a|0}function NXa(a,b){a=a|0;b=b|0;a=$Xc(32)|0;p0a(a);if(!b)return a|0;Xkb(b,a);return a|0}function OXa(a){a=a|0;return 0}function PXa(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function QXa(a){a=a|0;return 1}function RXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+20|0;j=a+24|0;k=e+8|0;l=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;if((o&-8|0)==8){switch((o&255)<<24>>24){case 10:break;case 8:{if(dUa(1,10,c,h)|0)continue a;else{s=0;p=27;break a}break}default:{r=o;break b}}n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(a=b[n>>0]|0,a<<24>>24>-1):0){f[c>>2]=n+1;t=a&255}else{a=YYb(c)|0;if((a|0)>-1)t=a;else{s=0;p=27;break a}}a=HYb(c,t)|0;if((PYb(c)|0)>0)do{n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(m=b[n>>0]|0,m<<24>>24>-1):0){f[c>>2]=n+1;v=m&255;w=0}else{LYb(e,c);m=e;if(!(b[k>>0]|0)){s=0;p=27;break a}else{v=f[m>>2]|0;w=f[m+4>>2]|0}}m=f[h>>2]|0;if((m|0)==(f[i>>2]|0)){_Ma(h,m+1|0);x=f[h>>2]|0}else x=m;m=f[j>>2]|0;f[h>>2]=x+1;n=m+8+(x<<3)|0;f[n>>2]=v;f[n+4>>2]=w}while((PYb(c)|0)>0);IYb(c,a);continue a}else r=o}while(0);if(!r){s=1;p=27;break}n=f[l>>2]|0;if(!(n&1))y=lSa(l)|0;else y=n&-2;if(!(Lqc(c,r,y)|0)){s=0;p=27;break}}if((p|0)==27){u=d;return s|0}return 0}function SXa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+16>>2]|0;if((b|0)>0){d=f[a+24>>2]|0;e=0;g=0;do{h=d+8+(g<<3)|0;i=t1c(f[h>>2]|1|0,f[h+4>>2]|0,1)|0;e=((((i^63)*9|0)+73|0)>>>6)+e|0;g=g+1|0}while((g|0)!=(b|0));if(e){if((e|0)<0)j=11;else j=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=e;l=j+c|0}else{k=0;l=c}}else{k=0;l=c}f[a+28>>2]=k;c=l+k|0;f[a+12>>2]=c;return c|0}function TXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{eZb(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else eZb(c,g);g=f[d>>2]|0;if((g|0)>0){d=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=(f[d>>2]|0)+8+(h<<3)|0;n=f[i>>2]|0;k=f[i+4>>2]|0;if((f[o>>2]|0)>9){i=f[e>>2]|0;j=n&255;if(k>>>0>0|(k|0)==0&n>>>0>127){l=i;m=j;p=n;q=k;while(1){b[l>>0]=m|-128;r=p;p=l1c(p|0,q|0,7)|0;s=l+1|0;t=p&255;if(!(q>>>0>0|(q|0)==0&r>>>0>16383)){u=s;v=t;break}else{l=s;m=t;q=J}}}else{u=i;v=j}b[u>>0]=v;q=u+1-i|0;f[e>>2]=(f[e>>2]|0)+q;f[o>>2]=(f[o>>2]|0)-q}else fZb(c,n,k);h=h+1|0}while((h|0)!=(g|0))}}g=f[a+4>>2]|0;if(!(g&1))return;Oqc(g&-2,c);return}function UXa(a){a=a|0;return f[a+12>>2]|0}function VXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=f[c>>2]|0;c=f[a+24>>2]|0;g=0;e=l+1|0;while(1){l=c+8+(g<<3)|0;i=f[l>>2]|0;h=f[l+4>>2]|0;l=i&255;if(h>>>0>0|(h|0)==0&i>>>0>127){j=e;k=l;n=i;i=h;while(1){b[j>>0]=k|-128;h=n;n=l1c(n|0,i|0,7)|0;o=j+1|0;p=n&255;if(!(i>>>0>0|(i|0)==0&h>>>0>16383)){q=o;r=p;break}else{j=o;k=p;i=J}}}else{q=e;r=l}b[q>>0]=r;i=q+1|0;g=g+1|0;if((g|0)>=(m|0)){s=i;break}else e=i}}else s=d;d=f[a+4>>2]|0;if(!(d&1)){t=s;return t|0}t=Pqc(d&-2,s)|0;return t|0}function WXa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;f[a+16>>2]=0;f[a+8>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);XXa(a,b);return}function XXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15664,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=c+16|0;e=f[g>>2]|0;if(!e)return;_Ma(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+8+(f[d>>2]<<3)|0,(f[c+24>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);return}function YXa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ZXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535248;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function _Xa(){var a=0,c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((f[223072]|0)!=2){f[c>>2]=165456;f[c+4>>2]=22;b[c+8>>0]=0;J_b(892288,c);a_b(c)}d=$Xc(32)|0;f[c>>2]=d;f[c+8>>2]=-2147483616;f[c+4>>2]=18;e=d;g=403046;h=e+18|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));b[d+18>>0]=0;ejc(c,90588,91440,85148,0,535248,892176,0);if((b[c+11>>0]|0)>=0){u=a;return}cYc(f[c>>2]|0);u=a;return}function $Xa(){aYa();n3b(403065,18833);Boc(403046,2252);return}function aYa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[223073]|0)!=2){f[c>>2]=165456;f[c+4>>2]=23;b[c+8>>0]=0;J_b(892292,c);a_b(c)}if((f[223074]|0)!=2){f[c>>2]=165456;f[c+4>>2]=24;b[c+8>>0]=0;J_b(892296,c);a_b(c)}if((f[223075]|0)!=2){f[c>>2]=165456;f[c+4>>2]=25;b[c+8>>0]=0;J_b(892300,c);a_b(c)}if((f[223076]|0)!=2){f[c>>2]=165456;f[c+4>>2]=26;b[c+8>>0]=0;J_b(892304,c);a_b(c)}if((f[223077]|0)!=2){f[c>>2]=165456;f[c+4>>2]=27;b[c+8>>0]=0;J_b(892308,c);a_b(c)}if((f[223078]|0)!=2){f[c>>2]=165456;f[c+4>>2]=28;b[c+8>>0]=0;J_b(892312,c);a_b(c)}if((f[223079]|0)!=2){f[c>>2]=165456;f[c+4>>2]=29;b[c+8>>0]=0;J_b(892316,c);a_b(c)}if((f[223080]|0)!=2){f[c>>2]=165456;f[c+4>>2]=30;b[c+8>>0]=0;J_b(892320,c);a_b(c)}if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}if((f[223082]|0)!=2){f[c>>2]=165456;f[c+4>>2]=32;b[c+8>>0]=0;J_b(892328,c);a_b(c)}if((f[223083]|0)!=2){f[c>>2]=165456;f[c+4>>2]=33;b[c+8>>0]=0;J_b(892332,c);a_b(c)}if((f[223084]|0)!=2){f[c>>2]=165456;f[c+4>>2]=34;b[c+8>>0]=0;J_b(892336,c);a_b(c)}if((f[223085]|0)!=2){f[c>>2]=165456;f[c+4>>2]=35;b[c+8>>0]=0;J_b(892340,c);a_b(c)}if((f[223086]|0)!=2){f[c>>2]=165456;f[c+4>>2]=36;b[c+8>>0]=0;J_b(892344,c);a_b(c)}if((f[223087]|0)!=2){f[c>>2]=165456;f[c+4>>2]=37;b[c+8>>0]=0;J_b(892348,c);a_b(c)}if((f[223088]|0)!=2){f[c>>2]=165456;f[c+4>>2]=38;b[c+8>>0]=0;J_b(892352,c);a_b(c)}if((f[223089]|0)!=2){f[c>>2]=165456;f[c+4>>2]=39;b[c+8>>0]=0;J_b(892356,c);a_b(c)}if((f[223090]|0)!=2){f[c>>2]=165456;f[c+4>>2]=40;b[c+8>>0]=0;J_b(892360,c);a_b(c)}if((f[223091]|0)!=2){f[c>>2]=165456;f[c+4>>2]=41;b[c+8>>0]=0;J_b(892364,c);a_b(c)}if((f[223092]|0)!=2){f[c>>2]=165456;f[c+4>>2]=42;b[c+8>>0]=0;J_b(892368,c);a_b(c)}if((f[223093]|0)!=2){f[c>>2]=165456;f[c+4>>2]=43;b[c+8>>0]=0;J_b(892372,c);a_b(c)}if((f[223094]|0)!=2){f[c>>2]=165456;f[c+4>>2]=44;b[c+8>>0]=0;J_b(892376,c);a_b(c)}if((f[223095]|0)!=2){f[c>>2]=165456;f[c+4>>2]=45;b[c+8>>0]=0;J_b(892380,c);a_b(c)}if((f[223096]|0)!=2){f[c>>2]=165456;f[c+4>>2]=46;b[c+8>>0]=0;J_b(892384,c);a_b(c)}if((f[223097]|0)!=2){f[c>>2]=165456;f[c+4>>2]=47;b[c+8>>0]=0;J_b(892388,c);a_b(c)}if((f[223098]|0)!=2){f[c>>2]=165456;f[c+4>>2]=48;b[c+8>>0]=0;J_b(892392,c);a_b(c)}if((f[223099]|0)!=2){f[c>>2]=165456;f[c+4>>2]=49;b[c+8>>0]=0;J_b(892396,c);a_b(c)}if((f[223100]|0)!=2){f[c>>2]=165456;f[c+4>>2]=50;b[c+8>>0]=0;J_b(892400,c);a_b(c)}if((f[223101]|0)!=2){f[c>>2]=165456;f[c+4>>2]=51;b[c+8>>0]=0;J_b(892404,c);a_b(c)}if((f[223102]|0)!=2){f[c>>2]=165456;f[c+4>>2]=52;b[c+8>>0]=0;J_b(892408,c);a_b(c)}if((f[223103]|0)!=2){f[c>>2]=165456;f[c+4>>2]=53;b[c+8>>0]=0;J_b(892412,c);a_b(c)}if((f[223104]|0)!=2){f[c>>2]=165456;f[c+4>>2]=54;b[c+8>>0]=0;J_b(892416,c);a_b(c)}if((f[223105]|0)!=2){f[c>>2]=165456;f[c+4>>2]=55;b[c+8>>0]=0;J_b(892420,c);a_b(c)}if((f[223106]|0)!=2){f[c>>2]=165456;f[c+4>>2]=56;b[c+8>>0]=0;J_b(892424,c);a_b(c)}if((f[223107]|0)!=2){f[c>>2]=165456;f[c+4>>2]=57;b[c+8>>0]=0;J_b(892428,c);a_b(c)}if((f[223108]|0)!=2){f[c>>2]=165456;f[c+4>>2]=58;b[c+8>>0]=0;J_b(892432,c);a_b(c)}if((f[223109]|0)!=2){f[c>>2]=165456;f[c+4>>2]=59;b[c+8>>0]=0;J_b(892436,c);a_b(c)}if((f[223110]|0)!=2){f[c>>2]=165456;f[c+4>>2]=60;b[c+8>>0]=0;J_b(892440,c);a_b(c)}if((f[223111]|0)!=2){f[c>>2]=165456;f[c+4>>2]=61;b[c+8>>0]=0;J_b(892444,c);a_b(c)}if((f[223112]|0)!=2){f[c>>2]=165456;f[c+4>>2]=62;b[c+8>>0]=0;J_b(892448,c);a_b(c)}if((f[223113]|0)!=2){f[c>>2]=165456;f[c+4>>2]=63;b[c+8>>0]=0;J_b(892452,c);a_b(c)}if((f[223114]|0)!=2){f[c>>2]=165456;f[c+4>>2]=64;b[c+8>>0]=0;J_b(892456,c);a_b(c)}if((f[223115]|0)!=2){f[c>>2]=165456;f[c+4>>2]=65;b[c+8>>0]=0;J_b(892460,c);a_b(c)}if((f[223116]|0)!=2){f[c>>2]=165456;f[c+4>>2]=66;b[c+8>>0]=0;J_b(892464,c);a_b(c)}if((f[223117]|0)!=2){f[c>>2]=165456;f[c+4>>2]=67;b[c+8>>0]=0;J_b(892468,c);a_b(c)}if((f[223118]|0)!=2){f[c>>2]=165456;f[c+4>>2]=68;b[c+8>>0]=0;J_b(892472,c);a_b(c)}if((f[223119]|0)!=2){f[c>>2]=165456;f[c+4>>2]=69;b[c+8>>0]=0;J_b(892476,c);a_b(c)}if((f[223120]|0)!=2){f[c>>2]=165456;f[c+4>>2]=70;b[c+8>>0]=0;J_b(892480,c);a_b(c)}if((f[223121]|0)!=2){f[c>>2]=165456;f[c+4>>2]=71;b[c+8>>0]=0;J_b(892484,c);a_b(c)}if((f[223122]|0)!=2){f[c>>2]=165456;f[c+4>>2]=72;b[c+8>>0]=0;J_b(892488,c);a_b(c)}if((f[223123]|0)!=2){f[c>>2]=165456;f[c+4>>2]=73;b[c+8>>0]=0;J_b(892492,c);a_b(c)}if((f[223124]|0)!=2){f[c>>2]=165456;f[c+4>>2]=74;b[c+8>>0]=0;J_b(892496,c);a_b(c)}if((f[223125]|0)!=2){f[c>>2]=165456;f[c+4>>2]=75;b[c+8>>0]=0;J_b(892500,c);a_b(c)}if((f[223126]|0)!=2){f[c>>2]=165456;f[c+4>>2]=76;b[c+8>>0]=0;J_b(892504,c);a_b(c)}if((f[223127]|0)!=2){f[c>>2]=165456;f[c+4>>2]=77;b[c+8>>0]=0;J_b(892508,c);a_b(c)}if((f[223128]|0)!=2){f[c>>2]=165456;f[c+4>>2]=78;b[c+8>>0]=0;J_b(892512,c);a_b(c)}if((f[223129]|0)!=2){f[c>>2]=165456;f[c+4>>2]=79;b[c+8>>0]=0;J_b(892516,c);a_b(c)}if((f[223130]|0)!=2){f[c>>2]=165456;f[c+4>>2]=80;b[c+8>>0]=0;J_b(892520,c);a_b(c)}if((f[223131]|0)!=2){f[c>>2]=165456;f[c+4>>2]=81;b[c+8>>0]=0;J_b(892524,c);a_b(c)}if((f[223132]|0)!=2){f[c>>2]=165456;f[c+4>>2]=82;b[c+8>>0]=0;J_b(892528,c);a_b(c)}if((f[223133]|0)!=2){f[c>>2]=165456;f[c+4>>2]=83;b[c+8>>0]=0;J_b(892532,c);a_b(c)}if((f[223134]|0)!=2){f[c>>2]=165456;f[c+4>>2]=84;b[c+8>>0]=0;J_b(892536,c);a_b(c)}if((f[223135]|0)!=2){f[c>>2]=165456;f[c+4>>2]=85;b[c+8>>0]=0;J_b(892540,c);a_b(c)}if((f[223136]|0)!=2){f[c>>2]=165456;f[c+4>>2]=86;b[c+8>>0]=0;J_b(892544,c);a_b(c)}if((f[223137]|0)!=2){f[c>>2]=165456;f[c+4>>2]=87;b[c+8>>0]=0;J_b(892548,c);a_b(c)}if((f[223138]|0)!=2){f[c>>2]=165456;f[c+4>>2]=88;b[c+8>>0]=0;J_b(892552,c);a_b(c)}if((f[223139]|0)!=2){f[c>>2]=165456;f[c+4>>2]=89;b[c+8>>0]=0;J_b(892556,c);a_b(c)}if((f[223140]|0)!=2){f[c>>2]=165456;f[c+4>>2]=90;b[c+8>>0]=0;J_b(892560,c);a_b(c)}if((f[223141]|0)!=2){f[c>>2]=165456;f[c+4>>2]=91;b[c+8>>0]=0;J_b(892564,c);a_b(c)}if((f[223142]|0)!=2){f[c>>2]=165456;f[c+4>>2]=92;b[c+8>>0]=0;J_b(892568,c);a_b(c)}if((f[223143]|0)==2){u=a;return}f[c>>2]=165456;f[c+4>>2]=93;b[c+8>>0]=0;J_b(892572,c);a_b(c);u=a;return}function bYa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[223071]|0)!=2){f[c>>2]=165456;f[c+4>>2]=21;b[c+8>>0]=0;J_b(892284,c);a_b(c)}jjc(535248,71);u=a;return}function cYa(){d_b(3005001,3005e3,421899);WXb();f[132824]=90488;f[132825]=0;f[132826]=0;f[132827]=0;f[132828]=0;f[132829]=0;f[132830]=0;C_b(531296);return}function dYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223073]|0)!=2){f[c>>2]=165456;f[c+4>>2]=23;b[c+8>>0]=0;J_b(892292,c);a_b(c)}f[132832]=92596;f[132833]=0;f[132840]=0;f[132841]=0;f[132842]=0;f[132844]=0;f[132845]=0;f[132846]=0;f[132848]=0;f[132849]=0;f[132850]=0;f[132834]=0;f[132835]=0;f[132836]=0;f[132837]=0;f[132838]=0;f[132852]=537368;f[132853]=0;f[132854]=0;f[132855]=0;f[132856]=0;f[132857]=0;f[132858]=0;C_b(531328);f[132853]=531296;u=a;return}function eYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223074]|0)!=2){f[c>>2]=165456;f[c+4>>2]=24;b[c+8>>0]=0;J_b(892296,c);a_b(c)}f[132860]=99184;f[132861]=0;f[132862]=0;f[132863]=0;f[132864]=0;f[132865]=0;f[132866]=0;f[132867]=0;C_b(531440);u=a;return}function fYa(){d_b(3005001,3005e3,421899);WXb();f[132868]=98320;f[132869]=0;f[132870]=0;f[132871]=0;f[132872]=0;f[132873]=0;f[132874]=0;C_b(531472);return}function gYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[132876]=98212;f[132877]=0;f[132878]=0;f[132879]=0;f[132880]=0;b[531524]=1;b[531525]=1;n[132882]=1.000000013351432e-10;C_b(531504);f[132880]=531776;u=a;return}function hYa(){var a=0,c=0;d_b(3005001,3005e3,421899);WXb();f[132884]=98104;f[132885]=0;a=531544;c=a+112|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(c|0));b[531656]=1;b[531657]=1;n[132915]=.5;C_b(531536);return}function iYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223100]|0)!=2){f[c>>2]=165456;f[c+4>>2]=50;b[c+8>>0]=0;J_b(892400,c);a_b(c)}if((f[223101]|0)!=2){f[c>>2]=165456;f[c+4>>2]=51;b[c+8>>0]=0;J_b(892404,c);a_b(c)}f[132916]=98428;f[132917]=0;f[132918]=0;f[132919]=0;f[132920]=0;f[132921]=0;f[132922]=0;f[132923]=0;f[132924]=0;f[132925]=0;f[132926]=-1;f[132927]=1;b[531712]=1;b[531713]=1;C_b(531664);f[132920]=533176;f[132921]=533208;u=a;return}function jYa(){d_b(3005001,3005e3,421899);WXb();f[132930]=99076;f[132931]=0;f[132932]=0;f[132933]=0;f[132934]=0;f[132935]=0;f[132936]=0;f[132937]=537368;f[132938]=0;f[132939]=0;f[132940]=0;f[132941]=0;b[531768]=0;C_b(531720);return}function kYa(){d_b(3005001,3005e3,421899);WXb();f[133792]=0;f[133793]=0;f[133794]=0;b[535168]=0;b[535179]=0;sYc(535168,0);f[133792]=1936617315;f[133793]=1953390964;b[535176]=0;b[535177]=0;b[535178]=0;b[535179]=8;A_b(535168);f[132944]=92272;f[132945]=0;f[132946]=0;f[132947]=0;f[132948]=535168;f[132949]=0;f[132950]=0;f[132951]=0;f[132952]=0;f[132953]=-1;n[132954]=1.0;n[132955]=1.0;C_b(531776);return}function lYa(){var a=0,c=0,e=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223073]|0)!=2){f[c>>2]=165456;f[c+4>>2]=23;b[c+8>>0]=0;J_b(892292,c);a_b(c)}if((f[223085]|0)!=2){f[c>>2]=165456;f[c+4>>2]=35;b[c+8>>0]=0;J_b(892340,c);a_b(c)}if((f[223088]|0)!=2){f[c>>2]=165456;f[c+4>>2]=38;b[c+8>>0]=0;J_b(892352,c);a_b(c)}if((f[223137]|0)!=2){f[c>>2]=165456;f[c+4>>2]=87;b[c+8>>0]=0;J_b(892548,c);a_b(c)}f[132956]=98968;f[132957]=0;c=531832;e=c+84|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(e|0));f[132979]=537368;f[132980]=0;d[265962]=0;C_b(531824);f[132980]=532208;u=a;return}function mYa(){var a=0,c=0,e=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223082]|0)!=2){f[c>>2]=165456;f[c+4>>2]=32;b[c+8>>0]=0;J_b(892328,c);a_b(c)}if((f[223085]|0)!=2){f[c>>2]=165456;f[c+4>>2]=35;b[c+8>>0]=0;J_b(892340,c);a_b(c)};f[133796]=0;f[133797]=0;f[133798]=0;f[c>>2]=0;d[c+4>>1]=0;b[c+6>>0]=0;b[535184]=0;b[535195]=0;sYc(535184,0);f[133796]=12876;f[133797]=f[c>>2];d[267596]=d[c+4>>1]|0;b[535194]=b[c+6>>0]|0;b[535195]=2;A_b(535184);f[133800]=0;f[133801]=0;f[133802]=0;f[c>>2]=0;d[c+4>>1]=0;b[c+6>>0]=0;b[535200]=0;b[535211]=0;sYc(535200,0);f[133800]=4474707;f[133801]=f[c>>2];d[267604]=d[c+4>>1]|0;b[535210]=b[c+6>>0]|0;b[535211]=3;A_b(535200);f[132982]=98860;c=531932;e=c+84|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(e|0));f[133004]=537368;f[133005]=537368;f[133006]=537368;f[133007]=537368;f[133008]=535184;f[133009]=535200;c=532040;e=c+64|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(e|0));n[133026]=.9990000128746033;c=532112;f[c>>2]=-1;f[c+4>>2]=-1;f[133030]=1;b[532124]=1;b[532125]=1;n[133032]=9.99999993922529e-09;f[133033]=1;n[133034]=-1.0;f[133035]=1;f[133036]=1;n[133037]=.9900000095367432;f[133038]=0;C_b(531928);f[133011]=531824;f[133010]=531824;f[133012]=532208;u=a;return}function nYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223074]|0)!=2){f[c>>2]=165456;f[c+4>>2]=24;b[c+8>>0]=0;J_b(892296,c);a_b(c)}f[133040]=98752;f[133041]=0;f[133042]=0;f[133043]=0;f[133044]=0;f[133045]=0;f[133046]=0;f[133047]=0;f[133048]=537368;c=532196;f[c>>2]=0;f[c+4>>2]=0;C_b(532160);u=a;return}function oYa(){d_b(3005001,3005e3,421899);WXb();f[133052]=98644;f[133053]=0;f[133054]=0;f[133055]=0;f[133056]=0;f[133057]=0;f[133058]=0;f[133059]=0;f[133060]=0;f[133061]=1;C_b(532208);return}function pYa(){var a=0,b=0;d_b(3005001,3005e3,421899);WXb();f[133062]=95944;f[133063]=0;a=532256;b=a+52|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(b|0));C_b(532248);return}function qYa(){d_b(3005001,3005e3,421899);WXb();f[133078]=98536;f[133079]=0;f[133080]=0;f[133081]=0;f[133082]=537368;f[133083]=0;n[133084]=1.0;n[133085]=1.0;C_b(532312);return}function rYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223087]|0)!=2){f[c>>2]=165456;f[c+4>>2]=37;b[c+8>>0]=0;J_b(892348,c);a_b(c)}if((f[223074]|0)!=2){f[c>>2]=165456;f[c+4>>2]=24;b[c+8>>0]=0;J_b(892296,c);a_b(c)}if((f[223086]|0)!=2){f[c>>2]=165456;f[c+4>>2]=36;b[c+8>>0]=0;J_b(892344,c);a_b(c)}if((f[223089]|0)!=2){f[c>>2]=165456;f[c+4>>2]=39;b[c+8>>0]=0;J_b(892356,c);a_b(c)}if((f[223090]|0)!=2){f[c>>2]=165456;f[c+4>>2]=40;b[c+8>>0]=0;J_b(892360,c);a_b(c)}if((f[223091]|0)!=2){f[c>>2]=165456;f[c+4>>2]=41;b[c+8>>0]=0;J_b(892364,c);a_b(c)}if((f[223092]|0)!=2){f[c>>2]=165456;f[c+4>>2]=42;b[c+8>>0]=0;J_b(892368,c);a_b(c)}if((f[223094]|0)!=2){f[c>>2]=165456;f[c+4>>2]=44;b[c+8>>0]=0;J_b(892376,c);a_b(c)}if((f[223095]|0)!=2){f[c>>2]=165456;f[c+4>>2]=45;b[c+8>>0]=0;J_b(892380,c);a_b(c)}if((f[223093]|0)!=2){f[c>>2]=165456;f[c+4>>2]=43;b[c+8>>0]=0;J_b(892372,c);a_b(c)}if((f[223096]|0)!=2){f[c>>2]=165456;f[c+4>>2]=46;b[c+8>>0]=0;J_b(892384,c);a_b(c)}if((f[223097]|0)!=2){f[c>>2]=165456;f[c+4>>2]=47;b[c+8>>0]=0;J_b(892388,c);a_b(c)}if((f[223098]|0)!=2){f[c>>2]=165456;f[c+4>>2]=48;b[c+8>>0]=0;J_b(892392,c);a_b(c)}if((f[223099]|0)!=2){f[c>>2]=165456;f[c+4>>2]=49;b[c+8>>0]=0;J_b(892396,c);a_b(c)}if((f[223079]|0)!=2){f[c>>2]=165456;f[c+4>>2]=29;b[c+8>>0]=0;J_b(892316,c);a_b(c)}if((f[223102]|0)!=2){f[c>>2]=165456;f[c+4>>2]=52;b[c+8>>0]=0;J_b(892408,c);a_b(c)}if((f[223103]|0)!=2){f[c>>2]=165456;f[c+4>>2]=53;b[c+8>>0]=0;J_b(892412,c);a_b(c)}if((f[223104]|0)!=2){f[c>>2]=165456;f[c+4>>2]=54;b[c+8>>0]=0;J_b(892416,c);a_b(c)}if((f[223105]|0)!=2){f[c>>2]=165456;f[c+4>>2]=55;b[c+8>>0]=0;J_b(892420,c);a_b(c)}if((f[223106]|0)!=2){f[c>>2]=165456;f[c+4>>2]=56;b[c+8>>0]=0;J_b(892424,c);a_b(c)}if((f[223107]|0)!=2){f[c>>2]=165456;f[c+4>>2]=57;b[c+8>>0]=0;J_b(892428,c);a_b(c)}if((f[223108]|0)!=2){f[c>>2]=165456;f[c+4>>2]=58;b[c+8>>0]=0;J_b(892432,c);a_b(c)}if((f[223109]|0)!=2){f[c>>2]=165456;f[c+4>>2]=59;b[c+8>>0]=0;J_b(892436,c);a_b(c)}if((f[223110]|0)!=2){f[c>>2]=165456;f[c+4>>2]=60;b[c+8>>0]=0;J_b(892440,c);a_b(c)}if((f[223111]|0)!=2){f[c>>2]=165456;f[c+4>>2]=61;b[c+8>>0]=0;J_b(892444,c);a_b(c)}if((f[223112]|0)!=2){f[c>>2]=165456;f[c+4>>2]=62;b[c+8>>0]=0;J_b(892448,c);a_b(c)}if((f[223113]|0)!=2){f[c>>2]=165456;f[c+4>>2]=63;b[c+8>>0]=0;J_b(892452,c);a_b(c)}if((f[223114]|0)!=2){f[c>>2]=165456;f[c+4>>2]=64;b[c+8>>0]=0;J_b(892456,c);a_b(c)}if((f[223115]|0)!=2){f[c>>2]=165456;f[c+4>>2]=65;b[c+8>>0]=0;J_b(892460,c);a_b(c)}if((f[223116]|0)!=2){f[c>>2]=165456;f[c+4>>2]=66;b[c+8>>0]=0;J_b(892464,c);a_b(c)}if((f[223117]|0)!=2){f[c>>2]=165456;f[c+4>>2]=67;b[c+8>>0]=0;J_b(892468,c);a_b(c)}if((f[223118]|0)!=2){f[c>>2]=165456;f[c+4>>2]=68;b[c+8>>0]=0;J_b(892472,c);a_b(c)}if((f[223119]|0)!=2){f[c>>2]=165456;f[c+4>>2]=69;b[c+8>>0]=0;J_b(892476,c);a_b(c)}if((f[223077]|0)!=2){f[c>>2]=165456;f[c+4>>2]=27;b[c+8>>0]=0;J_b(892308,c);a_b(c)}if((f[223076]|0)!=2){f[c>>2]=165456;f[c+4>>2]=26;b[c+8>>0]=0;J_b(892304,c);a_b(c)}if((f[223120]|0)!=2){f[c>>2]=165456;f[c+4>>2]=70;b[c+8>>0]=0;J_b(892480,c);a_b(c)}if((f[223121]|0)!=2){f[c>>2]=165456;f[c+4>>2]=71;b[c+8>>0]=0;J_b(892484,c);a_b(c)}if((f[223122]|0)!=2){f[c>>2]=165456;f[c+4>>2]=72;b[c+8>>0]=0;J_b(892488,c);a_b(c)}if((f[223139]|0)!=2){f[c>>2]=165456;f[c+4>>2]=89;b[c+8>>0]=0;J_b(892556,c);a_b(c)}if((f[223078]|0)!=2){f[c>>2]=165456;f[c+4>>2]=28;b[c+8>>0]=0;J_b(892312,c);a_b(c)}if((f[223142]|0)!=2){f[c>>2]=165456;f[c+4>>2]=92;b[c+8>>0]=0;J_b(892568,c);a_b(c)}if((f[223143]|0)!=2){f[c>>2]=165456;f[c+4>>2]=93;b[c+8>>0]=0;J_b(892572,c);a_b(c)}if((f[223123]|0)!=2){f[c>>2]=165456;f[c+4>>2]=73;b[c+8>>0]=0;J_b(892492,c);a_b(c)}if((f[223124]|0)!=2){f[c>>2]=165456;f[c+4>>2]=74;b[c+8>>0]=0;J_b(892496,c);a_b(c)}if((f[223125]|0)!=2){f[c>>2]=165456;f[c+4>>2]=75;b[c+8>>0]=0;J_b(892500,c);a_b(c)}if((f[223126]|0)!=2){f[c>>2]=165456;f[c+4>>2]=76;b[c+8>>0]=0;J_b(892504,c);a_b(c)}if((f[223127]|0)!=2){f[c>>2]=165456;f[c+4>>2]=77;b[c+8>>0]=0;J_b(892508,c);a_b(c)}if((f[223141]|0)!=2){f[c>>2]=165456;f[c+4>>2]=91;b[c+8>>0]=0;J_b(892564,c);a_b(c)}if((f[223128]|0)!=2){f[c>>2]=165456;f[c+4>>2]=78;b[c+8>>0]=0;J_b(892512,c);a_b(c)}if((f[223129]|0)!=2){f[c>>2]=165456;f[c+4>>2]=79;b[c+8>>0]=0;J_b(892516,c);a_b(c)}if((f[223131]|0)!=2){f[c>>2]=165456;f[c+4>>2]=81;b[c+8>>0]=0;J_b(892524,c);a_b(c)}if((f[223136]|0)!=2){f[c>>2]=165456;f[c+4>>2]=86;b[c+8>>0]=0;J_b(892544,c);a_b(c)}if((f[223130]|0)!=2){f[c>>2]=165456;f[c+4>>2]=80;b[c+8>>0]=0;J_b(892520,c);a_b(c)}if((f[223132]|0)!=2){f[c>>2]=165456;f[c+4>>2]=82;b[c+8>>0]=0;J_b(892528,c);a_b(c)}if((f[223134]|0)!=2){f[c>>2]=165456;f[c+4>>2]=84;b[c+8>>0]=0;J_b(892536,c);a_b(c)}if((f[223133]|0)!=2){f[c>>2]=165456;f[c+4>>2]=83;b[c+8>>0]=0;J_b(892532,c);a_b(c)}if((f[223135]|0)==2){f[133086]=97996;g1c(532348,0,132)|0;f[133120]=537368;f[133121]=537368;g1c(532488,0,224)|0;C_b(532344);f[133122]=532712;f[133123]=532760;f[133124]=532792;f[133125]=532824;f[133161]=532880;f[133163]=532912;f[133126]=532856;f[133127]=532944;f[133128]=532968;f[133166]=533088;f[133129]=533120;f[133169]=531664;f[133130]=533248;f[133131]=533272;f[133132]=533368;f[133162]=533408;f[133159]=533432;f[133133]=533472;f[133157]=533504;f[133134]=533528;f[133135]=533560;f[133136]=533584;f[133137]=533608;f[133138]=533672;f[133139]=533696;f[133165]=533736;f[133156]=533768;f[133140]=533800;f[133141]=533840;f[133142]=533872;f[133171]=531504;f[133170]=531472;f[133167]=533896;f[133143]=533920;f[133144]=533992;f[133153]=534968;f[133172]=531536;f[133173]=535072;f[133174]=535136;f[133152]=534024;f[133168]=534056;f[133158]=534088;f[133145]=534120;f[133155]=534144;f[133175]=535040;f[133164]=534176;f[133146]=534216;f[133147]=534280;f[133154]=534440;f[133148]=534240;f[133149]=534304;f[133150]=534352;f[133160]=534328;f[133151]=534376;u=a;return}f[c>>2]=165456;f[c+4>>2]=85;b[c+8>>0]=0;J_b(892540,c);a_b(c);f[133086]=97996;g1c(532348,0,132)|0;f[133120]=537368;f[133121]=537368;g1c(532488,0,224)|0;C_b(532344);f[133122]=532712;f[133123]=532760;f[133124]=532792;f[133125]=532824;f[133161]=532880;f[133163]=532912;f[133126]=532856;f[133127]=532944;f[133128]=532968;f[133166]=533088;f[133129]=533120;f[133169]=531664;f[133130]=533248;f[133131]=533272;f[133132]=533368;f[133162]=533408;f[133159]=533432;f[133133]=533472;f[133157]=533504;f[133134]=533528;f[133135]=533560;f[133136]=533584;f[133137]=533608;f[133138]=533672;f[133139]=533696;f[133165]=533736;f[133156]=533768;f[133140]=533800;f[133141]=533840;f[133142]=533872;f[133171]=531504;f[133170]=531472;f[133167]=533896;f[133143]=533920;f[133144]=533992;f[133153]=534968;f[133172]=531536;f[133173]=535072;f[133174]=535136;f[133152]=534024;f[133168]=534056;f[133158]=534088;f[133145]=534120;f[133155]=534144;f[133175]=535040;f[133164]=534176;f[133146]=534216;f[133147]=534280;f[133154]=534440;f[133148]=534240;f[133149]=534304;f[133150]=534352;f[133160]=534328;f[133151]=534376;u=a;return}function sYa(){d_b(3005001,3005e3,421899);WXb();f[133178]=93460;f[133179]=0;f[133180]=0;f[133181]=0;f[133182]=0;f[133183]=0;f[133184]=0;f[133185]=537368;f[133186]=0;d[266374]=0;b[532750]=0;n[133188]=1.0;C_b(532712);return}function tYa(){d_b(3005001,3005e3,421899);WXb();f[133190]=92812;f[133191]=0;f[133192]=0;f[133193]=0;f[133194]=0;b[532780]=0;f[133196]=1;C_b(532760);return}function uYa(){d_b(3005001,3005e3,421899);WXb();f[133198]=94e3;f[133199]=0;f[133200]=0;f[133201]=0;f[133202]=0;f[133203]=1;f[133204]=1;C_b(532792);return}function vYa(){d_b(3005001,3005e3,421899);WXb();f[133206]=94432;f[133207]=0;f[133208]=0;f[133209]=0;f[133210]=0;f[133211]=0;f[133212]=1;C_b(532824);return}function wYa(){d_b(3005001,3005e3,421899);WXb();f[133214]=95836;f[133215]=0;f[133216]=0;f[133217]=0;f[133218]=1;f[133219]=1;C_b(532856);return}function xYa(){d_b(3005001,3005e3,421899);WXb();f[133220]=97888;f[133221]=0;f[133222]=0;f[133223]=0;d[266448]=0;n[133225]=.9990000128746033;n[133226]=9.999999747378752e-06;C_b(532880);return}function yYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[133228]=97780;f[133229]=0;f[133230]=0;f[133231]=0;f[133232]=0;f[133233]=1;f[133234]=1;C_b(532912);f[133232]=531776;u=a;return}function zYa(){d_b(3005001,3005e3,421899);WXb();f[133236]=93028;f[133237]=0;f[133238]=0;f[133239]=0;b[532960]=0;n[133241]=1.0;C_b(532944);return}function AYa(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[133242]=95728;f[133243]=0;c=532976;d=c+96|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));b[533072]=0;f[133269]=1;b[533080]=1;f[133271]=1;C_b(532968);f[133258]=531776;f[133259]=531776;u=a;return}function BYa(){d_b(3005001,3005e3,421899);WXb();f[133272]=97672;f[133273]=0;f[133274]=0;f[133275]=0;f[133276]=0;f[133277]=0;f[133278]=0;f[133279]=2;C_b(533088);return}function CYa(){d_b(3005001,3005e3,421899);WXb();f[133280]=95620;f[133281]=0;f[133282]=0;f[133283]=0;f[133284]=537368;f[133285]=537368;f[133286]=0;f[133287]=0;f[133288]=0;f[133289]=0;f[133290]=0;n[133291]=1.0;f[133292]=4;C_b(533120);return}function DYa(){d_b(3005001,3005e3,421899);WXb();f[133294]=97564;f[133295]=0;f[133296]=0;f[133297]=0;f[133298]=0;n[133299]=.30000001192092896;n[133300]=1.0;C_b(533176);return}function EYa(){d_b(3005001,3005e3,421899);WXb();f[133302]=97456;f[133303]=0;f[133304]=0;f[133305]=0;f[133306]=537368;f[133307]=537368;f[133308]=537368;f[133309]=537368;f[133310]=537368;f[133311]=0;C_b(533208);return}function FYa(){d_b(3005001,3005e3,421899);WXb();f[133312]=95512;f[133313]=0;f[133314]=0;f[133315]=0;n[133316]=.5;b[533268]=1;C_b(533248);return}function GYa(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}if((f[223073]|0)!=2){f[c>>2]=165456;f[c+4>>2]=23;b[c+8>>0]=0;J_b(892292,c);a_b(c)}f[133318]=94108;f[133319]=0;c=533280;d=c+88|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));C_b(533272);u=a;return}function HYa(){d_b(3005001,3005e3,421899);WXb();f[133342]=94324;f[133343]=0;f[133344]=0;f[133345]=0;f[133346]=0;f[133347]=0;f[133348]=0;f[133349]=1;b[533400]=1;C_b(533368);return}function IYa(){d_b(3005001,3005e3,421899);WXb();f[133352]=97348;f[133353]=0;f[133354]=0;f[133355]=0;n[133356]=1.0;C_b(533408);return}function JYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[133358]=97240;f[133359]=0;f[133360]=0;f[133361]=0;f[133362]=0;f[133363]=0;f[133364]=0;f[133365]=0;b[533464]=1;C_b(533432);f[133362]=531776;f[133363]=531776;u=a;return}function KYa(){d_b(3005001,3005e3,421899);WXb();f[133368]=92920;f[133369]=0;f[133370]=0;f[133371]=0;n[133372]=0.0;n[133373]=-1.0;n[133374]=1.0;C_b(533472);return}function LYa(){d_b(3005001,3005e3,421899);WXb();f[133376]=97132;f[133377]=0;f[133378]=0;f[133379]=0;f[133380]=1;f[133381]=-1;C_b(533504);return}function MYa(){d_b(3005001,3005e3,421899);WXb();f[133382]=95404;f[133383]=0;f[133384]=0;f[133385]=0;f[133386]=537368;f[133387]=0;b[533552]=0;C_b(533528);return}function NYa(){d_b(3005001,3005e3,421899);WXb();f[133390]=92488;f[133391]=0;f[133392]=0;f[133393]=0;f[133394]=537368;C_b(533560);return}function OYa(){d_b(3005001,3005e3,421899);WXb();f[133396]=93892;f[133397]=0;f[133398]=0;f[133399]=0;f[133400]=1;C_b(533584);return}function PYa(){d_b(3005001,3005e3,421899);WXb();f[133402]=95296;f[133403]=0;f[133404]=0;f[133405]=0;f[133406]=537368;f[133407]=537368;f[133408]=537368;f[133409]=0;f[133410]=0;f[133411]=0;f[133412]=0;f[133413]=0;b[533656]=1;n[133415]=1.0;f[133416]=1;C_b(533608);return}function QYa(){d_b(3005001,3005e3,421899);WXb();f[133418]=95188;f[133419]=0;f[133420]=0;f[133421]=0;f[133422]=537368;C_b(533672);return}function RYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[133424]=95080;f[133425]=0;f[133426]=0;f[133427]=0;f[133428]=0;f[133429]=0;f[133430]=0;b[533724]=0;b[533725]=1;f[133432]=1;C_b(533696);f[133428]=531776;f[133429]=531776;u=a;return}function SYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223073]|0)!=2){f[c>>2]=165456;f[c+4>>2]=23;b[c+8>>0]=0;J_b(892292,c);a_b(c)}f[133434]=97024;f[133435]=0;f[133436]=0;f[133437]=0;f[133438]=0;f[133439]=0;f[133440]=0;f[133441]=0;C_b(533736);u=a;return}function TYa(){d_b(3005001,3005e3,421899);WXb();f[133442]=96916;f[133443]=0;f[133444]=0;f[133445]=0;n[133446]=0.0;n[133447]=-1.0;n[133448]=1.0;C_b(533768);return}function UYa(){d_b(3005001,3005e3,421899);WXb();f[133450]=94972;f[133451]=0;f[133452]=0;f[133453]=0;f[133454]=0;f[133455]=0;f[133456]=5;n[133457]=1.0;n[133458]=.75;n[133459]=1.0;C_b(533800);return}function VYa(){d_b(3005001,3005e3,421899);WXb();f[133460]=94540;f[133461]=0;f[133462]=0;f[133463]=0;f[133464]=0;f[133465]=0;f[133466]=0;f[133467]=0;C_b(533840);return}function WYa(){d_b(3005001,3005e3,421899);WXb();f[133468]=93568;f[133469]=0;f[133470]=0;f[133471]=0;b[533888]=0;b[533889]=1;n[133473]=9.999999717180685e-10;C_b(533872);return}function XYa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223073]|0)!=2){f[c>>2]=165456;f[c+4>>2]=23;b[c+8>>0]=0;J_b(892292,c);a_b(c)}f[133474]=96808;f[133475]=0;f[133476]=0;f[133477]=0;f[133478]=0;C_b(533896);f[133478]=531296;u=a;return}function YYa(){var a=0,c=0;d_b(3005001,3005e3,421899);WXb();f[133480]=94864;f[133481]=0;a=533928;c=a+48|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(c|0));b[533976]=0;f[133495]=1;b[533984]=1;C_b(533920);return}function ZYa(){d_b(3005001,3005e3,421899);WXb();f[133498]=94648;f[133499]=0;f[133500]=0;f[133501]=0;n[133502]=0.0;n[133503]=1.0;n[133504]=1.0;C_b(533992);return}function _Ya(){d_b(3005001,3005e3,421899);WXb();f[133506]=96700;f[133507]=0;f[133508]=0;f[133509]=0;f[133510]=537368;f[133511]=537368;f[133512]=537368;b[534052]=0;C_b(534024);return}function $Ya(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[133514]=96592;f[133515]=0;f[133516]=0;f[133517]=0;f[133518]=0;f[133519]=0;f[133520]=0;d[267042]=0;C_b(534056);f[133518]=531776;f[133519]=531776;u=a;return}function aZa(){d_b(3005001,3005e3,421899);WXb();f[133522]=96484;f[133523]=0;f[133524]=0;f[133525]=0;f[133526]=0;f[133527]=1;n[133528]=1.0;C_b(534088);return}function bZa(){d_b(3005001,3005e3,421899);WXb();f[133530]=93784;f[133531]=0;f[133532]=0;f[133533]=0;f[133534]=0;f[133535]=0;C_b(534120);return}function cZa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223073]|0)!=2){f[c>>2]=165456;f[c+4>>2]=23;b[c+8>>0]=0;J_b(892292,c);a_b(c)}f[133536]=96376;f[133537]=0;f[133538]=0;f[133539]=0;f[133540]=0;f[133541]=0;f[133542]=-1;C_b(534144);f[133540]=531296;u=a;return}function dZa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[133544]=96268;f[133545]=0;f[133546]=0;f[133547]=0;f[133548]=0;f[133549]=0;b[534200]=0;f[133551]=1;f[133552]=1;C_b(534176);f[133548]=531776;f[133549]=531776;u=a;return}function eZa(){d_b(3005001,3005e3,421899);WXb();f[133554]=93244;f[133555]=0;f[133556]=0;f[133557]=0;f[133558]=0;C_b(534216);return}function fZa(){d_b(3005001,3005e3,421899);WXb();f[133560]=93676;f[133561]=0;f[133562]=0;f[133563]=0;f[133564]=0;f[133565]=0;f[133566]=0;f[133567]=1;f[133568]=1;C_b(534240);return}function gZa(){d_b(3005001,3005e3,421899);WXb();f[133570]=93136;f[133571]=0;f[133572]=0;f[133573]=0;f[133574]=0;f[133575]=1;C_b(534280);return}function hZa(){d_b(3005001,3005e3,421899);WXb();f[133576]=93352;f[133577]=0;f[133578]=0;f[133579]=0;f[133580]=0;C_b(534304);return}function iZa(){d_b(3005001,3005e3,421899);WXb();f[133582]=96160;f[133583]=0;f[133584]=0;f[133585]=0;f[133586]=0;f[133587]=1;C_b(534328);return}function jZa(){d_b(3005001,3005e3,421899);WXb();f[133588]=94216;f[133589]=0;f[133590]=0;f[133591]=0;n[133592]=0.0;C_b(534352);return}function kZa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();f[133804]=0;f[133805]=0;f[133806]=0;b[c>>0]=0;b[c+1>>0]=0;b[c+2>>0]=0;b[c+3>>0]=0;b[c+4>>0]=0;b[c+5>>0]=0;b[535216]=0;b[535227]=0;sYc(535216,0);f[133804]=1886544247;b[535220]=0;b[535221]=b[c>>0]|0;b[535222]=b[c+1>>0]|0;b[535223]=b[c+2>>0]|0;b[535224]=b[c+3>>0]|0;b[535225]=b[c+4>>0]|0;b[535226]=b[c+5>>0]|0;b[535227]=4;A_b(535216);f[133594]=94756;f[133595]=0;f[133596]=0;f[133597]=0;f[133598]=537368;f[133599]=537368;f[133600]=535216;f[133601]=537368;f[133602]=0;f[133603]=0;f[133604]=0;f[133605]=0;n[133606]=1.0;n[133607]=.5;n[133608]=.5;n[133609]=.25;C_b(534376);u=a;return}function lZa(){d_b(3005001,3005e3,421899);WXb();f[133610]=96052;f[133611]=0;f[133612]=0;f[133613]=0;f[133614]=0;f[133615]=0;f[133616]=0;C_b(534440);return}function mZa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223086]|0)!=2){f[c>>2]=165456;f[c+4>>2]=36;b[c+8>>0]=0;J_b(892344,c);a_b(c)}if((f[223074]|0)!=2){f[c>>2]=165456;f[c+4>>2]=24;b[c+8>>0]=0;J_b(892296,c);a_b(c)}if((f[223091]|0)!=2){f[c>>2]=165456;f[c+4>>2]=41;b[c+8>>0]=0;J_b(892364,c);a_b(c)}if((f[223092]|0)!=2){f[c>>2]=165456;f[c+4>>2]=42;b[c+8>>0]=0;J_b(892368,c);a_b(c)}if((f[223093]|0)!=2){f[c>>2]=165456;f[c+4>>2]=43;b[c+8>>0]=0;J_b(892372,c);a_b(c)}if((f[223096]|0)!=2){f[c>>2]=165456;f[c+4>>2]=46;b[c+8>>0]=0;J_b(892384,c);a_b(c)}if((f[223097]|0)!=2){f[c>>2]=165456;f[c+4>>2]=47;b[c+8>>0]=0;J_b(892388,c);a_b(c)}if((f[223099]|0)!=2){f[c>>2]=165456;f[c+4>>2]=49;b[c+8>>0]=0;J_b(892396,c);a_b(c)}if((f[223102]|0)!=2){f[c>>2]=165456;f[c+4>>2]=52;b[c+8>>0]=0;J_b(892408,c);a_b(c)}if((f[223103]|0)!=2){f[c>>2]=165456;f[c+4>>2]=53;b[c+8>>0]=0;J_b(892412,c);a_b(c)}if((f[223104]|0)!=2){f[c>>2]=165456;f[c+4>>2]=54;b[c+8>>0]=0;J_b(892416,c);a_b(c)}if((f[223107]|0)!=2){f[c>>2]=165456;f[c+4>>2]=57;b[c+8>>0]=0;J_b(892428,c);a_b(c)}if((f[223109]|0)!=2){f[c>>2]=165456;f[c+4>>2]=59;b[c+8>>0]=0;J_b(892436,c);a_b(c)}if((f[223110]|0)!=2){f[c>>2]=165456;f[c+4>>2]=60;b[c+8>>0]=0;J_b(892440,c);a_b(c)}if((f[223111]|0)!=2){f[c>>2]=165456;f[c+4>>2]=61;b[c+8>>0]=0;J_b(892444,c);a_b(c)}if((f[223112]|0)!=2){f[c>>2]=165456;f[c+4>>2]=62;b[c+8>>0]=0;J_b(892448,c);a_b(c)}if((f[223113]|0)!=2){f[c>>2]=165456;f[c+4>>2]=63;b[c+8>>0]=0;J_b(892452,c);a_b(c)}if((f[223114]|0)!=2){f[c>>2]=165456;f[c+4>>2]=64;b[c+8>>0]=0;J_b(892456,c);a_b(c)}if((f[223117]|0)!=2){f[c>>2]=165456;f[c+4>>2]=67;b[c+8>>0]=0;J_b(892468,c);a_b(c)}if((f[223118]|0)!=2){f[c>>2]=165456;f[c+4>>2]=68;b[c+8>>0]=0;J_b(892472,c);a_b(c)}if((f[223119]|0)!=2){f[c>>2]=165456;f[c+4>>2]=69;b[c+8>>0]=0;J_b(892476,c);a_b(c)}if((f[223121]|0)!=2){f[c>>2]=165456;f[c+4>>2]=71;b[c+8>>0]=0;J_b(892484,c);a_b(c)}if((f[223122]|0)!=2){f[c>>2]=165456;f[c+4>>2]=72;b[c+8>>0]=0;J_b(892488,c);a_b(c)}if((f[223126]|0)!=2){f[c>>2]=165456;f[c+4>>2]=76;b[c+8>>0]=0;J_b(892504,c);a_b(c)}if((f[223129]|0)!=2){f[c>>2]=165456;f[c+4>>2]=79;b[c+8>>0]=0;J_b(892516,c);a_b(c)}if((f[223131]|0)!=2){f[c>>2]=165456;f[c+4>>2]=81;b[c+8>>0]=0;J_b(892524,c);a_b(c)}if((f[223130]|0)!=2){f[c>>2]=165456;f[c+4>>2]=80;b[c+8>>0]=0;J_b(892520,c);a_b(c)}if((f[223132]|0)!=2){f[c>>2]=165456;f[c+4>>2]=82;b[c+8>>0]=0;J_b(892528,c);a_b(c)}if((f[223134]|0)!=2){f[c>>2]=165456;f[c+4>>2]=84;b[c+8>>0]=0;J_b(892536,c);a_b(c)}if((f[223135]|0)!=2){f[c>>2]=165456;f[c+4>>2]=85;b[c+8>>0]=0;J_b(892540,c);a_b(c)}if((f[223089]|0)!=2){f[c>>2]=165456;f[c+4>>2]=39;b[c+8>>0]=0;J_b(892356,c);a_b(c)}if((f[223090]|0)!=2){f[c>>2]=165456;f[c+4>>2]=40;b[c+8>>0]=0;J_b(892360,c);a_b(c)}if((f[223138]|0)==2){f[133618]=92704;g1c(534476,0,156)|0;f[133658]=537368;g1c(534636,0,132)|0;C_b(534472);f[133678]=532792;f[133674]=532824;f[133660]=532856;f[133687]=532944;f[133661]=532968;f[133662]=533120;f[133663]=533248;f[133677]=533272;f[133675]=533368;f[133688]=533472;f[133664]=533528;f[133665]=533560;f[133679]=533584;f[133666]=533608;f[133667]=533672;f[133668]=533696;f[133669]=533800;f[133673]=533840;f[133682]=533872;f[133670]=533920;f[133672]=533992;f[133680]=534120;f[133685]=534216;f[133686]=534280;f[133681]=534240;f[133684]=534304;f[133676]=534352;f[133671]=534376;f[133683]=532712;f[133689]=532760;f[133659]=534768;u=a;return}f[c>>2]=165456;f[c+4>>2]=88;b[c+8>>0]=0;J_b(892552,c);a_b(c);f[133618]=92704;g1c(534476,0,156)|0;f[133658]=537368;g1c(534636,0,132)|0;C_b(534472);f[133678]=532792;f[133674]=532824;f[133660]=532856;f[133687]=532944;f[133661]=532968;f[133662]=533120;f[133663]=533248;f[133677]=533272;f[133675]=533368;f[133688]=533472;f[133664]=533528;f[133665]=533560;f[133679]=533584;f[133666]=533608;f[133667]=533672;f[133668]=533696;f[133669]=533800;f[133673]=533840;f[133682]=533872;f[133670]=533920;f[133672]=533992;f[133680]=534120;f[133685]=534216;f[133686]=534280;f[133681]=534240;f[133684]=534304;f[133676]=534352;f[133671]=534376;f[133683]=532712;f[133689]=532760;f[133659]=534768;u=a;return}function nZa(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}if((f[223074]|0)!=2){f[c>>2]=165456;f[c+4>>2]=24;b[c+8>>0]=0;J_b(892296,c);a_b(c)}if((f[223110]|0)!=2){f[c>>2]=165456;f[c+4>>2]=60;b[c+8>>0]=0;J_b(892440,c);a_b(c)};f[133808]=0;f[133809]=0;f[133810]=0;b[c>>0]=0;b[c+1>>0]=0;b[c+2>>0]=0;b[c+3>>0]=0;b[c+4>>0]=0;b[c+5>>0]=0;b[535232]=0;b[535243]=0;sYc(535232,0);f[133808]=1886544247;b[535236]=0;b[535237]=b[c>>0]|0;b[535238]=b[c+1>>0]|0;b[535239]=b[c+2>>0]|0;b[535240]=b[c+3>>0]|0;b[535241]=b[c+4>>0]|0;b[535242]=b[c+5>>0]|0;b[535243]=4;A_b(535232);f[133692]=92380;c=534772;d=c+52|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[133706]=537368;f[133707]=537368;f[133708]=537368;f[133709]=537368;f[133710]=535232;c=534844;d=c+64|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[133727]=1;b[534912]=1;f[133729]=1;f[133730]=1;n[133731]=.5;f[133732]=5;n[133733]=1.0;n[133734]=.75;n[133735]=1.0;n[133736]=1.0;n[133737]=.5;n[133738]=.5;n[133739]=.25;f[133740]=0;C_b(534768);f[133711]=531776;f[133712]=531776;f[133713]=533560;u=a;return}function oZa(){var a=0,c=0;a=u;u=u+16|0;c=a;d_b(3005001,3005e3,421899);WXb();if((f[223081]|0)!=2){f[c>>2]=165456;f[c+4>>2]=31;b[c+8>>0]=0;J_b(892324,c);a_b(c)}f[133742]=92164;f[133743]=0;f[133744]=0;f[133745]=0;f[133746]=0;b[534988]=0;C_b(534968);f[133746]=531776;u=a;return}function pZa(){var a=0,b=0;d_b(3005001,3005e3,421899);WXb();f[133748]=92056;f[133749]=0;a=535e3;b=a+40|0;do{f[a>>2]=0;a=a+4|0}while((a|0)<(b|0));C_b(534992);return}function qZa(){d_b(3005001,3005e3,421899);WXb();f[133760]=91948;f[133761]=0;f[133762]=0;f[133763]=0;f[133764]=0;f[133765]=0;n[133766]=1.0;C_b(535040);return}function rZa(){d_b(3005001,3005e3,421899);WXb();f[133768]=91840;f[133769]=0;f[133770]=0;f[133771]=0;f[133772]=0;f[133773]=0;f[133774]=0;f[133775]=0;f[133776]=0;f[133777]=0;f[133778]=16;f[133779]=16;f[133780]=16;f[133781]=6e3;f[133782]=300;n[133783]=.699999988079071;C_b(535072);return}function sZa(){d_b(3005001,3005e3,421899);WXb();f[133784]=91732;f[133785]=0;f[133786]=0;f[133787]=0;f[133788]=0;f[133789]=0;f[133790]=0;C_b(535136);return}function tZa(a){a=a|0;var b=0,c=0;f[a>>2]=91732;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function uZa(a){a=a|0;var b=0,c=0;f[a>>2]=91732;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function vZa(a){a=a|0;a=$Xc(28)|0;IZa(a);return a|0}function wZa(a,b){a=a|0;b=b|0;a=$Xc(28)|0;IZa(a);if(!b)return a|0;JZa(b,a);return a|0}function xZa(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function yZa(a){a=a|0;return (f[a+8>>2]&7|0)==7|0}function zZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(WYb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;v=a}else{w=a;q=18}}else{w=0;q=18}if((q|0)==18){q=0;a=KYb(c,w)|0;n=J;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)v=a;else{x=0;q=31;break a}}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=24){s=p;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=a+1;y=o}else{z=o;q=24}}else{z=0;q=24}if((q|0)==24){q=0;o=KYb(c,z)|0;a=J;if((a|0)>-1|(a|0)==-1&o>>>0>4294967295)y=o;else{x=0;q=31;break a}}f[l>>2]=y;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=31;break}o=f[m>>2]|0;if(!(o&1))A=lSa(m)|0;else A=o&-2;if(!(Lqc(c,s,A)|0)){x=0;q=31;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==31){u=d;return x|0}return 0}function AZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if((b&7|0)==7){d=f[a+20>>2]|0;if((d|0)<0)e=10;else e=(((($(d|1|0)|0)^31)*9|0)+73|0)>>>6;d=f[a+24>>2]|0;if((d|0)<0)g=10;else g=(((($(d|1|0)|0)^31)*9|0)+73|0)>>>6;h=c+7+e+g|0;i=a+12|0;f[i>>2]=h;return h|0}g=b&1|0?5:0;if(!(b&2))j=g;else{e=f[a+20>>2]|0;if((e|0)<0)k=11;else k=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+g|0}if(!(b&4))l=j;else{b=f[a+24>>2]|0;if((b|0)<0)m=11;else m=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+j|0}h=l+c|0;i=a+12|0;f[i>>2]=h;return h|0}function BZa(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)a$b(1,+n[a+16>>2],b);if(c&2|0)S_b(2,f[a+20>>2]|0,b);if(c&4|0)S_b(3,f[a+24>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function CZa(a){a=a|0;return f[a+12>>2]|0}function DZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{d=f[a+20>>2]|0;b[e>>0]=16;g=e+1|0;e=d&255;if(d>>>0>127){h=g;j=e;k=d;l=((d|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;d=k;k=l1c(k|0,l|0,7)|0;m=h+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&d>>>0>16383)){o=m;p=n;break}else{h=m;j=n;l=J}}}else{o=g;p=e}b[o>>0]=p;i=o+1|0}if(!(c&4))q=i;else{c=f[a+24>>2]|0;b[i>>0]=24;o=i+1|0;i=c&255;if(c>>>0>127){p=o;e=i;g=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=e|-128;c=g;g=l1c(g|0,l|0,7)|0;j=p+1|0;h=g&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=h;break}else{p=j;e=h;l=J}}}else{r=o;s=i}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function EZa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);FZa(a,b);return}function FZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15680,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function GZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function HZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535808;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function IZa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91732;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=535136?(f[223143]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=93;b[d+8>>0]=0;J_b(892572,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function JZa(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function KZa(a){a=a|0;var b=0,c=0;f[a>>2]=91840;b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function LZa(a){a=a|0;KZa(a);cYc(a);return}function MZa(a){a=a|0;a=$Xc(64)|0;$Za(a);return a|0}function NZa(a,b){a=a|0;b=b|0;a=$Xc(64)|0;$Za(a);if(!b)return a|0;a_a(b,a);return a|0}function OZa(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+28>>2]=0;b=a+8|0;if(f[b>>2]&63|0){f[a+40>>2]=16;f[a+44>>2]=16;f[a+48>>2]=16;f[a+52>>2]=6e3;f[a+56>>2]=300;n[a+60>>2]=.699999988079071}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function PZa(a){a=a|0;return 1}function QZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+40|0;k=a+44|0;l=a+48|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+32|0;r=a+36|0;s=a+52|0;t=a+56|0;v=a+60|0;w=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=ZYb(c,B)|0;if((y+-1|0)>>>0<127){z=y;A=6}else C=y}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{if((z&255|0)!=8){C=z;break b}f[i>>2]=f[i>>2]|1;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){a=b[y>>0]|0;x=a&255;if(a<<24>>24>-1){f[j>>2]=x;f[c>>2]=y+1;continue a}else D=x}else D=0;x=KYb(c,D)|0;y=J;f[j>>2]=x;if((y|0)>-1|(y|0)==-1&x>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 2:{if((z&255|0)!=16){C=z;break b}f[i>>2]=f[i>>2]|2;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;a=y&255;if(y<<24>>24>-1){f[k>>2]=a;f[c>>2]=x+1;continue a}else F=a}else F=0;a=KYb(c,F)|0;x=J;f[k>>2]=a;if((x|0)>-1|(x|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 3:{if((z&255|0)!=24){C=z;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>-1){f[l>>2]=y;f[c>>2]=a+1;continue a}else G=y}else G=0;y=KYb(c,G)|0;a=J;f[l>>2]=y;if((a|0)>-1|(a|0)==-1&y>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 4:{switch((z&255)<<24>>24){case 37:break;case 34:{if(_Za(c,m)|0)continue a;else{E=0;A=78;break a}break}default:{C=z;break b}}y=f[c>>2]|0;if(((f[g>>2]|0)-y|0)>3){a=y;x=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=x;f[c>>2]=y+4;H=x}else{if(!(WYb(c,e)|0)){A=37;break a}H=f[e>>2]|0}x=f[m>>2]|0;if((x|0)==(f[n>>2]|0)){uHa(m,x+1|0);I=f[m>>2]|0}else I=x;x=f[o>>2]|0;y=I+1|0;f[m>>2]=y;f[x+4+(I<<2)>>2]=H;a=f[c>>2]|0;K=(f[g>>2]|0)-a|0;if((K|0)<=0)continue a;L=a;a=(f[n>>2]|0)-y|0;M=(K>>>0)/5|0;N=(M|0)<(a|0)?M:a;if((N|0)>0){O=0;P=L;Q=y}else continue a;while(1){if((b[P>>0]|0)!=37){R=O;break}y=P+1|0;a=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;y=Q;Q=Q+1|0;f[m>>2]=Q;f[x+4+(y<<2)>>2]=a;a=O+1|0;if((a|0)>=(N|0)){R=a;break}else{O=a;P=P+5|0}}N=R*5|0;if((R|0)<=0)continue a;if((K|0)<(N|0)){SYb(c,N,K)|0;continue a}else{f[c>>2]=L+N;continue a}break}case 5:{switch((z&255)<<24>>24){case 45:break;case 42:{if(_Za(c,p)|0)continue a;else{E=0;A=78;break a}break}default:{C=z;break b}}N=f[c>>2]|0;if(((f[g>>2]|0)-N|0)>3){x=N;a=h[x>>0]|h[x+1>>0]<<8|h[x+2>>0]<<16|h[x+3>>0]<<24;f[e>>2]=a;f[c>>2]=N+4;S=a}else{if(!(WYb(c,e)|0)){A=54;break a}S=f[e>>2]|0}a=f[p>>2]|0;if((a|0)==(f[q>>2]|0)){uHa(p,a+1|0);T=f[p>>2]|0}else T=a;a=f[r>>2]|0;N=T+1|0;f[p>>2]=N;f[a+4+(T<<2)>>2]=S;x=f[c>>2]|0;y=(f[g>>2]|0)-x|0;if((y|0)<=0)continue a;M=x;x=(f[q>>2]|0)-N|0;U=(y>>>0)/5|0;V=(U|0)<(x|0)?U:x;if((V|0)>0){W=0;X=M;Y=N}else continue a;while(1){if((b[X>>0]|0)!=45){Z=W;break}N=X+1|0;x=h[N>>0]|h[N+1>>0]<<8|h[N+2>>0]<<16|h[N+3>>0]<<24;N=Y;Y=Y+1|0;f[p>>2]=Y;f[a+4+(N<<2)>>2]=x;x=W+1|0;if((x|0)>=(V|0)){Z=x;break}else{W=x;X=X+5|0}}V=Z*5|0;if((Z|0)<=0)continue a;if((y|0)<(V|0)){SYb(c,V,y)|0;continue a}else{f[c>>2]=M+V;continue a}break}case 6:{if((z&255|0)!=48){C=z;break b}f[i>>2]=f[i>>2]|8;V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0){a=b[V>>0]|0;L=a&255;if(a<<24>>24>-1){f[s>>2]=L;f[c>>2]=V+1;continue a}else _=L}else _=0;L=KYb(c,_)|0;V=J;f[s>>2]=L;if((V|0)>-1|(V|0)==-1&L>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 7:{if((z&255|0)!=56){C=z;break b}f[i>>2]=f[i>>2]|16;L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){V=b[L>>0]|0;a=V&255;if(V<<24>>24>-1){f[t>>2]=a;f[c>>2]=L+1;continue a}else $=a}else $=0;a=KYb(c,$)|0;L=J;f[t>>2]=a;if((L|0)>-1|(L|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=78;break a}break}case 8:{if((z&255|0)!=69){C=z;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){L=a;V=h[L>>0]|h[L+1>>0]<<8|h[L+2>>0]<<16|h[L+3>>0]<<24;f[e>>2]=V;f[c>>2]=a+4;aa=V}else{if(!(WYb(c,e)|0)){A=72;break a}aa=f[e>>2]|0}f[v>>2]=aa;continue a;break}default:{C=z;break b}}}while(0);if(!C){E=1;A=78;break}V=f[w>>2]|0;if(!(V&1))ba=lSa(w)|0;else ba=V&-2;if(!(Lqc(c,C,ba)|0)){E=0;A=78;break}}if((A|0)==37){E=0;u=d;return E|0}else if((A|0)==54){E=0;u=d;return E|0}else if((A|0)==72){E=0;u=d;return E|0}else if((A|0)==78){u=d;return E|0}return 0}function RZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+16>>2]|0;d=f[a+28>>2]|0;e=b+c+(b<<2)+d+(d<<2)|0;d=f[a+8>>2]|0;if(!(d&63)){g=e;h=a+12|0;f[h>>2]=g;return g|0}if(!(d&1))i=e;else i=e+1+((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&2))j=i;else j=i+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&4))k=j;else k=j+1+((((($(f[a+48>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&8))l=k;else l=k+1+((((($(f[a+52>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(d&16))m=l;else m=l+1+((((($(f[a+56>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=d&32|0?m+5|0:m;h=a+12|0;f[h>>2]=g;return g|0}function SZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)U_b(1,f[a+40>>2]|0,b);if(c&2|0)U_b(2,f[a+44>>2]|0,b);if(c&4|0)U_b(3,f[a+48>>2]|0,b);d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{a$b(4,+n[(f[e>>2]|0)+4+(g<<2)>>2],b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+28>>2]|0;if((d|0)>0){g=a+36|0;e=0;do{a$b(5,+n[(f[g>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)!=(d|0))}if(c&8|0)U_b(6,f[a+52>>2]|0,b);if(c&16|0)U_b(7,f[a+56>>2]|0,b);if(c&32|0)a$b(8,+n[a+60>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function TZa(a){a=a|0;return f[a+12>>2]|0}function UZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+40>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+44>>2]|0;b[e>>0]=16;m=e+1|0;if(l>>>0>127){e=l;g=m;while(1){b[g>>0]=e|128;h=e>>>7;i=g+1|0;if(e>>>0>16383){e=h;g=i}else{o=i;p=h;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{o=f[a+48>>2]|0;b[n>>0]=24;p=n+1|0;if(o>>>0>127){n=o;l=p;while(1){b[l>>0]=n|128;m=n>>>7;g=l+1|0;if(n>>>0>16383){n=m;l=g}else{r=g;s=m;break}}}else{r=p;s=o}b[r>>0]=s;q=r+1|0}r=f[a+16>>2]|0;if(!r)t=q;else{s=f[a+24>>2]|0;o=0;p=q;while(1){q=f[s+4+(o<<2)>>2]|0;b[p>>0]=37;l=p+1|0;b[l>>0]=q;b[l+1>>0]=q>>8;b[l+2>>0]=q>>16;b[l+3>>0]=q>>24;q=p+5|0;o=o+1|0;if((o|0)>=(r|0)){t=q;break}else p=q}}p=f[a+28>>2]|0;if(!p)u=t;else{r=f[a+36>>2]|0;o=0;s=t;while(1){t=f[r+4+(o<<2)>>2]|0;b[s>>0]=45;q=s+1|0;b[q>>0]=t;b[q+1>>0]=t>>8;b[q+2>>0]=t>>16;b[q+3>>0]=t>>24;t=s+5|0;o=o+1|0;if((o|0)>=(p|0)){u=t;break}else s=t}}if(!(c&8))v=u;else{s=f[a+52>>2]|0;b[u>>0]=48;p=u+1|0;if(s>>>0>127){u=s;o=p;while(1){b[o>>0]=u|128;r=u>>>7;t=o+1|0;if(u>>>0>16383){u=r;o=t}else{w=t;x=r;break}}}else{w=p;x=s}b[w>>0]=x;v=w+1|0}if(!(c&16))y=v;else{w=f[a+56>>2]|0;b[v>>0]=56;x=v+1|0;if(w>>>0>127){v=w;s=x;while(1){b[s>>0]=v|128;p=v>>>7;o=s+1|0;if(v>>>0>16383){v=p;s=o}else{z=o;A=p;break}}}else{z=x;A=w}b[z>>0]=A;y=z+1|0}if(!(c&32))B=y;else{c=f[a+60>>2]|0;b[y>>0]=69;z=y+1|0;b[z>>0]=c;b[z+1>>0]=c>>8;b[z+2>>0]=c>>16;b[z+3>>0]=c>>24;B=y+5|0}y=f[a+4>>2]|0;if(!(y&1)){C=B;return C|0}C=Pqc(y&-2,B)|0;return C|0}function VZa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;f[a+16>>2]=0;f[a+28>>2]=0;c=a+8|0;if(f[c>>2]&63|0){f[a+40>>2]=16;f[a+44>>2]=16;f[a+48>>2]=16;f[a+52>>2]=6e3;f[a+56>>2]=300;n[a+60>>2]=.699999988079071}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,15696,0)|0;if(!d){Ooc(b,a);return}else{ZZa(a,d);return}}function WZa(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15696,0)|0;if(!c){Ooc(b,a);return}else{ZZa(a,c);return}}function XZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function YZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535800;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function ZZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){uHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+28|0;d=b+28|0;e=f[d>>2]|0;if(e|0){uHa(g,(f[g>>2]|0)+e|0);o1c((f[a+36>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+36>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&63))return;if(d&1|0)f[a+40>>2]=f[b+40>>2];if(d&2|0)f[a+44>>2]=f[b+44>>2];if(d&4|0)f[a+48>>2]=f[b+48>>2];if(d&8|0)f[a+52>>2]=f[b+52>>2];if(d&16|0)f[a+56>>2]=f[b+56>>2];if(d&32|0)f[a+60>>2]=f[b+60>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function _Za(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;i=a+4|0;if(g>>>0<(f[i>>2]|0)>>>0?(j=b[g>>0]|0,j<<24>>24>-1):0){f[a>>2]=g+1;k=j&255}else{j=YYb(a)|0;if((j|0)>-1)k=j;else{l=0;u=d;return l|0}}j=f[c>>2]|0;g=(k|0)/4|0;if((g<<2|0)!=(k|0)){l=0;u=d;return l|0}m=RYb(a)|0;n=PYb(a)|0;if((((m|0)==-1|(n|0)<(m|0)?n:m)|0)>=(k|0)){m=j+g|0;if((f[c>>2]|0)<(m|0)?(uHa(c,m),n=f[c>>2]|0,o=m-n|0,(o<<2|0)>0):0)g1c((f[c+8>>2]|0)+((n<<2)+4)|0,0,(((o|-1073741824|0)==-1073741824?1073741823:1073741822)+o<<2)+8|0)|0;f[c>>2]=m;m=f[c+8>>2]|0;if(TYb(a,((m|0)==0?0:m+4|0)+(j<<2)|0,k)|0){l=1;u=d;return l|0}if((f[c>>2]|0)<=0){l=0;u=d;return l|0}f[c>>2]=j;l=0;u=d;return l|0}if((k|0)<=3){l=1;u=d;return l|0}k=c+4|0;j=c+8|0;m=0;while(1){o=f[a>>2]|0;if(((f[i>>2]|0)-o|0)>3){n=o;p=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=p;f[a>>2]=o+4;q=p}else{if(!(WYb(a,e)|0))break;q=f[e>>2]|0}p=f[c>>2]|0;if((p|0)==(f[k>>2]|0)){uHa(c,p+1|0);r=f[c>>2]|0}else r=p;p=f[j>>2]|0;f[c>>2]=r+1;f[p+4+(r<<2)>>2]=q;m=m+1|0;if((m|0)>=(g|0)){l=1;s=23;break}}if((s|0)==23){u=d;return l|0}l=0;u=d;return l|0}function $Za(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=91840;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;if((a|0)!=535072?(f[223142]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=92;b[d+8>>0]=0;J_b(892568,d);a_b(d)}f[a+12>>2]=0;f[a+40>>2]=16;f[a+44>>2]=16;f[a+48>>2]=16;f[a+52>>2]=6e3;f[a+56>>2]=300;n[a+60>>2]=.699999988079071;u=c;return}function a_a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function b_a(a){a=a|0;var b=0,c=0;f[a>>2]=91948;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function c_a(a){a=a|0;var b=0,c=0;f[a>>2]=91948;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function d_a(a){a=a|0;a=$Xc(28)|0;q_a(a);return a|0}function e_a(a,b){a=a|0;b=b|0;a=$Xc(28)|0;q_a(a);if(!b)return a|0;r_a(b,a);return a|0}function f_a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function g_a(a){a=a|0;return 1}function h_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[j>>2]=n;f[c>>2]=o+1;continue a}else t=n}else t=0;n=KYb(c,t)|0;o=J;f[j>>2]=n;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)continue a;else{v=0;q=29;break a}break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[k>>2]=a;f[c>>2]=n+1;continue a}else w=a}else w=0;a=KYb(c,w)|0;n=J;f[k>>2]=a;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)continue a;else{v=0;q=29;break a}break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;x=o}else{if(!(WYb(c,e)|0)){q=23;break a}x=f[e>>2]|0}f[l>>2]=x;continue a;break}default:{s=p;break b}}}while(0);if(!s){v=1;q=29;break}o=f[m>>2]|0;if(!(o&1))y=lSa(m)|0;else y=o&-2;if(!(Lqc(c,s,y)|0)){v=0;q=29;break}}if((q|0)==23){v=0;u=d;return v|0}else if((q|0)==29){u=d;return v|0}return 0}function i_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2))h=g;else h=g+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;d=b&4|0?h+5|0:h;e=a+12|0;f[e>>2]=d;return d|0}function j_a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)U_b(1,f[a+16>>2]|0,b);if(c&2|0)U_b(2,f[a+20>>2]|0,b);if(c&4|0)a$b(3,+n[a+24>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function k_a(a){a=a|0;return f[a+12>>2]|0}function l_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+20>>2]|0;b[e>>0]=16;m=e+1|0;if(l>>>0>127){e=l;g=m;while(1){b[g>>0]=e|128;h=e>>>7;i=g+1|0;if(e>>>0>16383){e=h;g=i}else{o=i;p=h;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{c=f[a+24>>2]|0;b[n>>0]=29;o=n+1|0;b[o>>0]=c;b[o+1>>0]=c>>8;b[o+2>>0]=c>>16;b[o+3>>0]=c>>24;q=n+5|0}n=f[a+4>>2]|0;if(!(n&1)){r=q;return r|0}r=Pqc(n&-2,q)|0;return r|0}function m_a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;n[a+24>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);n_a(a,b);return}function n_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15712,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function o_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function p_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535792;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function q_a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=91948;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=535040?(f[223141]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=91;b[d+8>>0]=0;J_b(892564,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;n[a+24>>2]=1.0;u=c;return}function r_a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function s_a(a){a=a|0;var b=0,c=0;f[a>>2]=92056;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function t_a(a){a=a|0;var b=0,c=0;f[a>>2]=92056;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function u_a(a){a=a|0;a=$Xc(48)|0;I_a(a);return a|0}function v_a(a,b){a=a|0;b=b|0;a=$Xc(48)|0;I_a(a);if(!b)return a|0;J_a(b,a);return a|0}function w_a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&255|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function x_a(a){a=a|0;return 1}function y_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+28|0;n=a+32|0;o=a+36|0;p=e+8|0;q=a+40|0;r=a+44|0;s=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){t=b[a>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=a+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=ZYb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=13){z=w;break b}f[i>>2]=f[i>>2]|1;v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){a=v;t=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=t;f[c>>2]=v+4;A=t}else{if(!(WYb(c,e)|0)){x=13;break a}A=f[e>>2]|0}f[j>>2]=A;continue a;break}case 2:{if((w&255|0)!=21){z=w;break b}f[i>>2]=f[i>>2]|2;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){v=t;a=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;f[e>>2]=a;f[c>>2]=t+4;B=a}else{if(!(WYb(c,e)|0)){x=20;break a}B=f[e>>2]|0}f[k>>2]=B;continue a;break}case 3:{if((w&255|0)!=29){z=w;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){t=a;v=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=v;f[c>>2]=a+4;C=v}else{if(!(WYb(c,e)|0)){x=27;break a}C=f[e>>2]|0}f[l>>2]=C;continue a;break}case 4:{if((w&255|0)!=37){z=w;break b}f[i>>2]=f[i>>2]|8;v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){a=v;t=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=t;f[c>>2]=v+4;D=t}else{if(!(WYb(c,e)|0)){x=34;break a}D=f[e>>2]|0}f[m>>2]=D;continue a;break}case 5:{if((w&255|0)!=40){z=w;break b}f[i>>2]=f[i>>2]|16;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){v=b[t>>0]|0;a=v&255;if(v<<24>>24>-1){f[c>>2]=t+1;E=a}else{F=a;x=39}}else{F=0;x=39}if((x|0)==39){x=0;a=KYb(c,F)|0;t=J;if((t|0)>-1|(t|0)==-1&a>>>0>4294967295)E=a;else{G=0;x=66;break a}}f[n>>2]=E;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(t=b[a>>0]|0,t<<24>>24>-1):0){f[c>>2]=a+1;H=t<<24>>24!=0}else{LYb(e,c);t=e;if(!(b[p>>0]|0)){G=0;x=66;break a}else H=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0}b[o>>0]=H&1;continue a;break}case 7:{if((w&255|0)!=61){z=w;break b}f[i>>2]=f[i>>2]|64;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){a=t;v=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=v;f[c>>2]=t+4;I=v}else{if(!(WYb(c,e)|0)){x=53;break a}I=f[e>>2]|0}f[q>>2]=I;continue a;break}case 8:{if((w&255|0)!=69){z=w;break b}f[i>>2]=f[i>>2]|128;v=f[c>>2]|0;if(((f[g>>2]|0)-v|0)>3){t=v;a=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=a;f[c>>2]=v+4;K=a}else{if(!(WYb(c,e)|0)){x=60;break a}K=f[e>>2]|0}f[r>>2]=K;continue a;break}default:{z=w;break b}}}while(0);if(!z){G=1;x=66;break}a=f[s>>2]|0;if(!(a&1))L=lSa(s)|0;else L=a&-2;if(!(Lqc(c,z,L)|0)){G=0;x=66;break}}if((x|0)==13){G=0;u=d;return G|0}else if((x|0)==20){G=0;u=d;return G|0}else if((x|0)==27){G=0;u=d;return G|0}else if((x|0)==34){G=0;u=d;return G|0}else if((x|0)==53){G=0;u=d;return G|0}else if((x|0)==60){G=0;u=d;return G|0}else if((x|0)==66){u=d;return G|0}return 0}function z_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&255)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;g=b&4|0?c+5|0:c;c=b&8|0?g+5|0:g;if(!(b&16))h=c;else{g=f[a+32>>2]|0;if((g|0)<0)i=11;else i=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+c|0}c=b&32|0?h+2|0:h;h=b&64|0?c+5|0:c;d=b&128|0?h+5|0:h;e=a+12|0;f[e>>2]=d;return d|0}function A_a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)a$b(1,+n[a+16>>2],c);if(d&2|0)a$b(2,+n[a+20>>2],c);if(d&4|0)a$b(3,+n[a+24>>2],c);if(d&8|0)a$b(4,+n[a+28>>2],c);if(d&16|0)S_b(5,f[a+32>>2]|0,c);if(d&32|0)c$b(6,(b[a+36>>0]|0)!=0,c);if(d&64|0)a$b(7,+n[a+40>>2],c);if(d&128|0)a$b(8,+n[a+44>>2],c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function B_a(a){a=a|0;return f[a+12>>2]|0}function C_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{d=f[a+20>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&4))j=i;else{e=f[a+24>>2]|0;b[i>>0]=29;d=i+1|0;b[d>>0]=e;b[d+1>>0]=e>>8;b[d+2>>0]=e>>16;b[d+3>>0]=e>>24;j=i+5|0}if(!(c&8))k=j;else{i=f[a+28>>2]|0;b[j>>0]=37;e=j+1|0;b[e>>0]=i;b[e+1>>0]=i>>8;b[e+2>>0]=i>>16;b[e+3>>0]=i>>24;k=j+5|0}if(!(c&16))l=k;else{j=f[a+32>>2]|0;b[k>>0]=40;i=k+1|0;k=j&255;if(j>>>0>127){e=i;d=k;g=j;h=((j|0)<0)<<31>>31;while(1){b[e>>0]=d|-128;j=g;g=l1c(g|0,h|0,7)|0;m=e+1|0;n=g&255;if(!(h>>>0>0|(h|0)==0&j>>>0>16383)){o=m;p=n;break}else{e=m;d=n;h=J}}}else{o=i;p=k}b[o>>0]=p;l=o+1|0}if(!(c&32))q=l;else{o=b[a+36>>0]|0;b[l>>0]=48;b[l+1>>0]=o;q=l+2|0}if(!(c&64))r=q;else{l=f[a+40>>2]|0;b[q>>0]=61;o=q+1|0;b[o>>0]=l;b[o+1>>0]=l>>8;b[o+2>>0]=l>>16;b[o+3>>0]=l>>24;r=q+5|0}if(!(c&128))s=r;else{c=f[a+44>>2]|0;b[r>>0]=69;q=r+1|0;b[q>>0]=c;b[q+1>>0]=c>>8;b[q+2>>0]=c>>16;b[q+3>>0]=c>>24;s=r+5|0}r=f[a+4>>2]|0;if(!(r&1)){t=s;return t|0}t=Pqc(r&-2,s)|0;return t|0}function D_a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&255|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,15728,0)|0;if(!d){Ooc(b,a);return}else{H_a(a,d);return}}function E_a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15728,0)|0;if(!c){Ooc(b,a);return}else{H_a(a,c);return}}function F_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function G_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535784;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function H_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&255))return;if(e&1|0)f[a+16>>2]=f[c+16>>2];if(e&2|0)f[a+20>>2]=f[c+20>>2];if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)b[a+36>>0]=b[c+36>>0]|0;if(e&64|0)f[a+40>>2]=f[c+40>>2];if(e&128|0)f[a+44>>2]=f[c+44>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function I_a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92056;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534992?(f[223140]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=90;b[d+8>>0]=0;J_b(892560,d);a_b(d)}d=a+12|0;a=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(a|0));u=c;return}function J_a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function K_a(a){a=a|0;var b=0,c=0;f[a>>2]=92164;if((a|0)!=534968?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function L_a(a){a=a|0;var b=0,c=0;f[a>>2]=92164;if((a|0)!=534968?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function M_a(a){a=a|0;a=$Xc(24)|0;q$a(a);return a|0}function N_a(a,b){a=a|0;b=b|0;a=$Xc(24)|0;q$a(a);if(!b)return a|0;r$a(b,a);return a|0}function O_a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+8|0;g=f[e>>2]|0;if(g&1|0)oYc(f[d+16>>2]|0,535168)|0;if(g&254|0){g=d+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[d+36>>2]=-1;n[d+40>>2]=1.0;n[d+44>>2]=1.0}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)sqc(d)}b[a+20>>0]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function P_a(a){a=a|0;return 1}function Q_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+20|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:break;case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;t=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[l>>0]|0)){v=0;q=29;break a}else t=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[k>>0]=t&1;continue a;break}default:{s=p;break b}}if((p&255|0)==10){f[h>>2]=f[h>>2]|1;a=f[i>>2]|0;if(!a){o=$Xc(48)|0;__a(o);f[i>>2]=o;w=o}else w=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(o=b[a>>0]|0,o<<24>>24>-1):0){f[c>>2]=a+1;x=o&255}else{o=YYb(c)|0;if((o|0)>-1)x=o;else{v=0;q=29;break a}}JYb(e,c,x);if((f[j>>2]|0)<0){q=16;break a}if(!(Mi[f[(f[w>>2]|0)+44>>2]&1023](w,c)|0)){q=16;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{v=0;q=29;break a}}else s=p}while(0);if(!s){v=1;q=29;break}o=f[m>>2]|0;if(!(o&1))y=lSa(m)|0;else y=o&-2;if(!(Lqc(c,s,y)|0)){v=0;q=29;break}}if((q|0)==16){v=0;u=d;return v|0}else if((q|0)==29){u=d;return v|0}return 0}function R_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&3)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}e=i&2|0?h+2|0:h;g=a+12|0;f[g>>2]=e;return e|0}function S_a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)k$b(1,f[a+16>>2]|0,c);if(d&2|0)c$b(2,(b[a+20>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function T_a(a){a=a|0;return f[a+12>>2]|0}function U_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;i=d+1|0;d=_i[f[(f[h>>2]|0)+60>>2]&2047](h)|0;if(d>>>0>127){j=d;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=d}b[n>>0]=o;g=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,n+1|0)|0}if(!(e&2))p=g;else{e=b[a+20>>0]|0;b[g>>0]=16;b[g+1>>0]=e;p=g+2|0}g=f[a+4>>2]|0;if(!(g&1)){q=p;return q|0}q=Pqc(g&-2,p)|0;return q|0}function V_a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;O_a(a);c=kZc(b,21568,15744,0)|0;if(!c){Ooc(b,a);return}else{Z_a(a,c);return}}function W_a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15744,0)|0;if(!c){Ooc(b,a);return}else{Z_a(a,c);return}}function X_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535776;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&3))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;$_a(i,g|0?g:531776)}if(e&2|0)b[a+20>>0]=b[c+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function __a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92272;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=531776?(f[223081]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=31;b[d+8>>0]=0;J_b(892324,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=535168;d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[a+36>>2]=-1;n[a+40>>2]=1.0;n[a+44>>2]=1.0;u=c;return}function $_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&255))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==535168){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];if(d&8|0)f[a+28>>2]=f[b+28>>2];if(d&16|0)f[a+32>>2]=f[b+32>>2];if(d&32|0)f[a+36>>2]=f[b+36>>2];if(d&64|0)f[a+40>>2]=f[b+40>>2];if(d&128|0)f[a+44>>2]=f[b+44>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function a$a(a){a=a|0;var c=0,d=0;f[a>>2]=92272;c=f[a+16>>2]|0;if(!((c|0)==535168|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function b$a(a){a=a|0;a$a(a);cYc(a);return}function c$a(a){a=a|0;a=$Xc(48)|0;__a(a);return a|0}function d$a(a,b){a=a|0;b=b|0;a=$Xc(48)|0;__a(a);if(!b)return a|0;p$a(b,a);return a|0}function e$a(a){a=a|0;var b=0,c=0;b=a+8|0;c=f[b>>2]|0;if(c&1|0)oYc(f[a+16>>2]|0,535168)|0;if(c&254|0){c=a+20|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[a+36>>2]=-1;n[a+40>>2]=1.0;n[a+44>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function f$a(a){a=a|0;return 1}function g$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+40|0;n=a+28|0;o=a+44|0;p=a+36|0;q=a+32|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=ZYb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=10){y=v;break b}f[i>>2]=f[i>>2]|1;t=f[j>>2]|0;if((t|0)==535168){mHa(j,535168);z=f[j>>2]|0}else z=t;if(l$b(c,z)|0)continue a;else{A=0;w=68;break a}break}case 2:{if((v&255|0)!=21){y=v;break b}f[i>>2]=f[i>>2]|2;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){a=t;s=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=s;f[c>>2]=t+4;B=s}else{if(!(WYb(c,e)|0)){w=17;break a}B=f[e>>2]|0}f[k>>2]=B;continue a;break}case 3:{if((v&255|0)!=29){y=v;break b}f[i>>2]=f[i>>2]|4;s=f[c>>2]|0;if(((f[g>>2]|0)-s|0)>3){t=s;a=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=a;f[c>>2]=s+4;C=a}else{if(!(WYb(c,e)|0)){w=24;break a}C=f[e>>2]|0}f[l>>2]=C;continue a;break}case 4:{if((v&255|0)!=37){y=v;break b}f[i>>2]=f[i>>2]|64;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){s=a;t=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=t;f[c>>2]=a+4;D=t}else{if(!(WYb(c,e)|0)){w=31;break a}D=f[e>>2]|0}f[m>>2]=D;continue a;break}case 5:{if((v&255|0)!=45){y=v;break b}f[i>>2]=f[i>>2]|8;t=f[c>>2]|0;if(((f[g>>2]|0)-t|0)>3){a=t;s=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=s;f[c>>2]=t+4;E=s}else{if(!(WYb(c,e)|0)){w=38;break a}E=f[e>>2]|0}f[n>>2]=E;continue a;break}case 6:{if((v&255|0)!=53){y=v;break b}f[i>>2]=f[i>>2]|128;s=f[c>>2]|0;if(((f[g>>2]|0)-s|0)>3){t=s;a=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=a;f[c>>2]=s+4;F=a}else{if(!(WYb(c,e)|0)){w=45;break a}F=f[e>>2]|0}f[o>>2]=F;continue a;break}case 7:{if((v&255|0)!=56){y=v;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>-1){f[c>>2]=a+1;G=t}else{H=t;w=50}}else{H=0;w=50}if((w|0)==50){w=0;t=KYb(c,H)|0;a=J;if((a|0)>-1|(a|0)==-1&t>>>0>4294967295)G=t;else{A=0;w=68;break a}}f[p>>2]=G;continue a;break}case 8:{if((v&255|0)!=64){y=v;break b}t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){a=b[t>>0]|0;s=a&255;if(a<<24>>24>-1){f[c>>2]=t+1;I=s}else{K=s;w=56}}else{K=0;w=56}if((w|0)==56){w=0;s=KYb(c,K)|0;t=J;if((t|0)>-1|(t|0)==-1&s>>>0>4294967295)I=s;else{A=0;w=68;break a}}if(I>>>0<3){f[i>>2]=f[i>>2]|16;f[q>>2]=I;continue a}s=f[r>>2]|0;if(!(s&1))L=lSa(r)|0;else L=s&-2;yqc(L,8,I,((I|0)<0)<<31>>31);continue a;break}default:{y=v;break b}}}while(0);if(!y){A=1;w=68;break}s=f[r>>2]|0;if(!(s&1))M=lSa(r)|0;else M=s&-2;if(!(Lqc(c,y,M)|0)){A=0;w=68;break}}if((w|0)==17){A=0;u=d;return A|0}else if((w|0)==24){A=0;u=d;return A|0}else if((w|0)==31){A=0;u=d;return A|0}else if((w|0)==38){A=0;u=d;return A|0}else if((w|0)==45){A=0;u=d;return A|0}else if((w|0)==68){u=d;return A|0}return 0}function h$a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&255)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}k=c&2|0?h+5|0:h;h=c&4|0?k+5|0:k;k=c&8|0?h+5|0:h;if(!(c&16))l=k;else{h=f[a+32>>2]|0;if((h|0)<0)m=11;else m=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+k|0}if(!(c&32))n=l;else{k=f[a+36>>2]|0;if((k|0)<0)o=11;else o=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+l|0}l=c&64|0?n+5|0:n;e=c&128|0?l+5|0:l;g=a+12|0;f[g>>2]=e;return e|0}function i$a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&2|0)a$b(2,+n[a+20>>2],b);if(c&4|0)a$b(3,+n[a+24>>2],b);if(c&64|0)a$b(4,+n[a+40>>2],b);if(c&8|0)a$b(5,+n[a+28>>2],b);if(c&128|0)a$b(6,+n[a+44>>2],b);if(c&32|0)S_b(7,f[a+36>>2]|0,b);if(c&16|0)d$b(8,f[a+32>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function j$a(a){a=a|0;return f[a+12>>2]|0}function k$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&4))i=h;else{e=f[a+24>>2]|0;b[h>>0]=29;d=h+1|0;b[d>>0]=e;b[d+1>>0]=e>>8;b[d+2>>0]=e>>16;b[d+3>>0]=e>>24;i=h+5|0}if(!(c&64))j=i;else{h=f[a+40>>2]|0;b[i>>0]=37;e=i+1|0;b[e>>0]=h;b[e+1>>0]=h>>8;b[e+2>>0]=h>>16;b[e+3>>0]=h>>24;j=i+5|0}if(!(c&8))k=j;else{i=f[a+28>>2]|0;b[j>>0]=45;h=j+1|0;b[h>>0]=i;b[h+1>>0]=i>>8;b[h+2>>0]=i>>16;b[h+3>>0]=i>>24;k=j+5|0}if(!(c&128))l=k;else{j=f[a+44>>2]|0;b[k>>0]=53;i=k+1|0;b[i>>0]=j;b[i+1>>0]=j>>8;b[i+2>>0]=j>>16;b[i+3>>0]=j>>24;l=k+5|0}if(!(c&32))m=l;else{k=f[a+36>>2]|0;b[l>>0]=56;j=l+1|0;l=k&255;if(k>>>0>127){i=j;h=l;e=k;d=((k|0)<0)<<31>>31;while(1){b[i>>0]=h|-128;k=e;e=l1c(e|0,d|0,7)|0;g=i+1|0;n=e&255;if(!(d>>>0>0|(d|0)==0&k>>>0>16383)){o=g;p=n;break}else{i=g;h=n;d=J}}}else{o=j;p=l}b[o>>0]=p;m=o+1|0}if(!(c&16))q=m;else{c=f[a+32>>2]|0;b[m>>0]=64;o=m+1|0;m=c&255;if(c>>>0>127){p=o;l=m;j=c;d=((c|0)<0)<<31>>31;while(1){b[p>>0]=l|-128;c=j;j=l1c(j|0,d|0,7)|0;h=p+1|0;i=j&255;if(!(d>>>0>0|(d|0)==0&c>>>0>16383)){r=h;s=i;break}else{p=h;l=i;d=J}}}else{r=o;s=m}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function l$a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;d=f[c>>2]|0;if(d&1|0)oYc(f[a+16>>2]|0,535168)|0;if(d&254|0){d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[a+36>>2]=-1;n[a+40>>2]=1.0;n[a+44>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,15760,0)|0;if(!d){Ooc(b,a);return}else{$_a(a,d);return}}function m$a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15760,0)|0;if(!c){Ooc(b,a);return}else{$_a(a,c);return}}function n$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function o$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535312;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function p$a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function q$a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92164;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534968?(f[223139]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=89;b[d+8>>0]=0;J_b(892556,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;u=c;return}function r$a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function s$a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=92380;t0a(a);b=f[a+52>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+40>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function t$a(a){a=a|0;s$a(a);cYc(a);return}function u$a(a){a=a|0;a=$Xc(196)|0;r0a(a);return a|0}function v$a(a,b){a=a|0;b=b|0;a=$Xc(196)|0;r0a(a);if(!b)return a|0;s0a(b,a);return a|0}function w$a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{d0a(f[e+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(d|0));f[c>>2]=0}f[a+32>>2]=0;f[a+44>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){do if(d&1|0){g=f[a+56>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&2|0){e=f[a+60>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&4|0){g=f[a+64>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&8|0){e=f[a+68>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&16|0)oYc(f[a+72>>2]|0,535232)|0;if(d&32|0){g=f[a+76>>2]|0;e=g+8|0;h=f[e>>2]|0;if(h&1|0)oYc(f[g+16>>2]|0,535168)|0;if(h&254|0){h=g+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+36>>2]=-1;n[g+40>>2]=1.0;n[g+44>>2]=1.0}f[e>>2]=0;e=f[g+4>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g)}if(d&64|0){g=f[a+80>>2]|0;e=g+8|0;h=f[e>>2]|0;if(h&1|0)oYc(f[g+16>>2]|0,535168)|0;if(h&254|0){h=g+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+36>>2]=-1;n[g+40>>2]=1.0;n[g+44>>2]=1.0}f[e>>2]=0;e=f[g+4>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g)}if(d&128|0){g=f[a+84>>2]|0;e=g+8|0;do if(f[e>>2]&1|0){h=f[g+16>>2]|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[i>>0]=0;break}}while(0);f[e>>2]=0;e=f[g+4>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g)}}if(d&65280|0){g=a+88|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;b[g+28>>0]=0}if(d&16711680|0){g=a+117|0;e=g+23|0;do{b[g>>0]=0;g=g+1|0}while((g|0)<(e|0));f[a+140>>2]=1;b[a+144>>0]=1}if(d>>>0>16777215){f[a+148>>2]=1;f[a+152>>2]=1;n[a+156>>2]=.5;f[a+160>>2]=5;n[a+164>>2]=1.0;n[a+168>>2]=.75;n[a+172>>2]=1.0;n[a+176>>2]=1.0}if(f[a+12>>2]&7|0){n[a+180>>2]=.5;n[a+184>>2]=.5;n[a+188>>2]=.25}d=c;f[d>>2]=0;f[d+4>>2]=0;d=f[a+4>>2]|0;if(!(d&1))return;a=d&-2;if(!(f[a>>2]|0))return;sqc(a);return}function x$a(a){a=a|0;return 1}function y$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+56|0;k=a+60|0;l=a+88|0;m=a+144|0;n=e+8|0;o=a+76|0;p=e+4|0;q=a+80|0;r=e+4|0;s=a+92|0;t=a+96|0;v=a+148|0;w=a+152|0;x=a+100|0;y=a+4|0;z=a+156|0;A=a+160|0;B=a+164|0;C=a+168|0;D=a+64|0;E=a+172|0;F=a+68|0;G=a+104|0;H=a+108|0;I=a+116|0;K=e+8|0;L=a+176|0;M=a+16|0;N=e+4|0;O=a+32|0;P=a+36|0;Q=a+40|0;R=a+44|0;S=a+48|0;T=a+52|0;U=a+120|0;V=a+12|0;W=a+180|0;X=a+184|0;Y=a+188|0;Z=a+124|0;_=a+72|0;$=a+128|0;aa=a+132|0;ba=a+136|0;ca=a+112|0;da=a+117|0;ea=e+8|0;fa=a+140|0;ga=a+84|0;a=e+4|0;a:while(1){ha=f[c>>2]|0;ia=f[g>>2]|0;do if(ha>>>0<ia>>>0){ja=b[ha>>0]|0;ka=ja&255;la=ha+1|0;if(ja<<24>>24>0){ma=la;na=ka}else{if(la>>>0>=ia>>>0){oa=ka;pa=7;break}ja=h[la>>0]|0;if(((ja^128)&ka)>>>0<=127){oa=ka;pa=7;break}ma=ha+2|0;na=ka+-128+(ja<<7)|0}f[c>>2]=ma;qa=na;pa=9}else{oa=0;pa=7}while(0);if((pa|0)==7){pa=0;ha=ZYb(c,oa)|0;if((ha+-1|0)>>>0<16383){qa=ha;pa=9}else ra=ha}b:do if((pa|0)==9){pa=0;do switch(qa>>>3&536870911|0){case 1:{if((qa&255|0)!=10){ra=qa;break b}f[i>>2]=f[i>>2]|1;ha=f[j>>2]|0;if((ha|0)==537368){mHa(j,537368);sa=f[j>>2]|0}else sa=ha;if(l$b(c,sa)|0)continue a;else{ta=0;pa=277;break a}break}case 2:{if((qa&255|0)!=18){ra=qa;break b}f[i>>2]=f[i>>2]|2;ha=f[k>>2]|0;if((ha|0)==537368){mHa(k,537368);ua=f[k>>2]|0}else ua=ha;if(l$b(c,ua)|0)continue a;else{ta=0;pa=277;break a}break}case 3:{if((qa&255|0)!=24){ra=qa;break b}f[i>>2]=f[i>>2]|256;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ia=b[ha>>0]|0;ja=ia&255;if(ia<<24>>24>-1){f[l>>2]=ja;f[c>>2]=ha+1;continue a}else va=ja}else va=0;ja=KYb(c,va)|0;ha=J;f[l>>2]=ja;if((ha|0)>-1|(ha|0)==-1&ja>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 4:{if((qa&255|0)!=32){ra=qa;break b}f[i>>2]=f[i>>2]|8388608;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(ha=b[ja>>0]|0,ha<<24>>24>-1):0){f[c>>2]=ja+1;wa=ha<<24>>24!=0}else{LYb(e,c);ha=e;if(!(b[n>>0]|0)){ta=0;pa=277;break a}else wa=(f[ha>>2]|0)!=0|(f[ha+4>>2]|0)!=0}b[m>>0]=wa&1;continue a;break}case 5:{if((qa&255|0)!=42){ra=qa;break b}f[i>>2]=f[i>>2]|32;ha=f[o>>2]|0;if(!ha){ja=$Xc(48)|0;__a(ja);f[o>>2]=ja;xa=ja}else xa=ha;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0?(ja=b[ha>>0]|0,ja<<24>>24>-1):0){f[c>>2]=ha+1;ya=ja&255}else{ja=YYb(c)|0;if((ja|0)>-1)ya=ja;else{ta=0;pa=277;break a}}JYb(e,c,ya);if((f[p>>2]|0)<0){pa=38;break a}if(!(Mi[f[(f[xa>>2]|0)+44>>2]&1023](xa,c)|0)){pa=38;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}case 6:{if((qa&255|0)!=50){ra=qa;break b}f[i>>2]=f[i>>2]|64;ja=f[q>>2]|0;if(!ja){ha=$Xc(48)|0;__a(ha);f[q>>2]=ha;za=ha}else za=ja;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(ha=b[ja>>0]|0,ha<<24>>24>-1):0){f[c>>2]=ja+1;Aa=ha&255}else{ha=YYb(c)|0;if((ha|0)>-1)Aa=ha;else{ta=0;pa=277;break a}}JYb(e,c,Aa);if((f[r>>2]|0)<0){pa=49;break a}if(!(Mi[f[(f[za>>2]|0)+44>>2]&1023](za,c)|0)){pa=49;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}case 7:{if((qa&255|0)!=56){ra=qa;break b}f[i>>2]=f[i>>2]|512;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ja=b[ha>>0]|0;ia=ja&255;if(ja<<24>>24>-1){f[s>>2]=ia;f[c>>2]=ha+1;continue a}else Ba=ia}else Ba=0;ia=KYb(c,Ba)|0;ha=J;f[s>>2]=ia;if((ha|0)>-1|(ha|0)==-1&ia>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 8:{if((qa&255|0)!=64){ra=qa;break b}f[i>>2]=f[i>>2]|1024;ia=f[c>>2]|0;if(ia>>>0<(f[g>>2]|0)>>>0){ha=b[ia>>0]|0;ja=ha&255;if(ha<<24>>24>-1){f[t>>2]=ja;f[c>>2]=ia+1;continue a}else Ca=ja}else Ca=0;ja=KYb(c,Ca)|0;ia=J;f[t>>2]=ja;if((ia|0)>-1|(ia|0)==-1&ja>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 9:{if((qa&255|0)!=72){ra=qa;break b}f[i>>2]=f[i>>2]|16777216;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0){ia=b[ja>>0]|0;ha=ia&255;if(ia<<24>>24>-1){f[v>>2]=ha;f[c>>2]=ja+1;continue a}else Da=ha}else Da=0;ha=KYb(c,Da)|0;ja=J;f[v>>2]=ha;if((ja|0)>-1|(ja|0)==-1&ha>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 10:{if((qa&255|0)!=80){ra=qa;break b}f[i>>2]=f[i>>2]|33554432;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ja=b[ha>>0]|0;ia=ja&255;if(ja<<24>>24>-1){f[w>>2]=ia;f[c>>2]=ha+1;continue a}else Ea=ia}else Ea=0;ia=KYb(c,Ea)|0;ha=J;f[w>>2]=ia;if((ha|0)>-1|(ha|0)==-1&ia>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 11:{if((qa&255|0)!=88){ra=qa;break b}ia=f[c>>2]|0;if(ia>>>0<(f[g>>2]|0)>>>0){ha=b[ia>>0]|0;ja=ha&255;if(ha<<24>>24>-1){f[c>>2]=ia+1;Fa=ja}else{Ga=ja;pa=75}}else{Ga=0;pa=75}if((pa|0)==75){pa=0;ja=KYb(c,Ga)|0;ia=J;if((ia|0)>-1|(ia|0)==-1&ja>>>0>4294967295)Fa=ja;else{ta=0;pa=277;break a}}if(Fa>>>0<3){f[i>>2]=f[i>>2]|2048;f[x>>2]=Fa;continue a}ja=f[y>>2]|0;if(!(ja&1))Ha=lSa(y)|0;else Ha=ja&-2;yqc(Ha,11,Fa,((Fa|0)<0)<<31>>31);continue a;break}case 12:{if((qa&255|0)!=101){ra=qa;break b}f[i>>2]=f[i>>2]|67108864;ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>3){ia=ja;ha=h[ia>>0]|h[ia+1>>0]<<8|h[ia+2>>0]<<16|h[ia+3>>0]<<24;f[e>>2]=ha;f[c>>2]=ja+4;Ia=ha}else{if(!(WYb(c,e)|0)){pa=88;break a}Ia=f[e>>2]|0}f[z>>2]=Ia;continue a;break}case 13:{if((qa&255|0)!=104){ra=qa;break b}f[i>>2]=f[i>>2]|134217728;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){ja=b[ha>>0]|0;ia=ja&255;if(ja<<24>>24>-1){f[A>>2]=ia;f[c>>2]=ha+1;continue a}else Ja=ia}else Ja=0;ia=KYb(c,Ja)|0;ha=J;f[A>>2]=ia;if((ha|0)>-1|(ha|0)==-1&ia>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 14:{if((qa&255|0)!=117){ra=qa;break b}f[i>>2]=f[i>>2]|268435456;ia=f[c>>2]|0;if(((f[g>>2]|0)-ia|0)>3){ha=ia;ja=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=ja;f[c>>2]=ia+4;Ka=ja}else{if(!(WYb(c,e)|0)){pa=100;break a}Ka=f[e>>2]|0}f[B>>2]=Ka;continue a;break}case 15:{if((qa&255|0)!=125){ra=qa;break b}f[i>>2]=f[i>>2]|536870912;ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>3){ia=ja;ha=h[ia>>0]|h[ia+1>>0]<<8|h[ia+2>>0]<<16|h[ia+3>>0]<<24;f[e>>2]=ha;f[c>>2]=ja+4;La=ha}else{if(!(WYb(c,e)|0)){pa=107;break a}La=f[e>>2]|0}f[C>>2]=La;continue a;break}case 16:{if((qa&255|0)!=130){ra=qa;break b}f[i>>2]=f[i>>2]|4;ha=f[D>>2]|0;if((ha|0)==537368){mHa(D,537368);Ma=f[D>>2]|0}else Ma=ha;if(l$b(c,Ma)|0)continue a;else{ta=0;pa=277;break a}break}case 17:{if((qa&255|0)!=141){ra=qa;break b}f[i>>2]=f[i>>2]|1073741824;ha=f[c>>2]|0;if(((f[g>>2]|0)-ha|0)>3){ja=ha;ia=h[ja>>0]|h[ja+1>>0]<<8|h[ja+2>>0]<<16|h[ja+3>>0]<<24;f[e>>2]=ia;f[c>>2]=ha+4;Na=ia}else{if(!(WYb(c,e)|0)){pa=118;break a}Na=f[e>>2]|0}f[E>>2]=Na;continue a;break}case 18:{if((qa&255|0)!=146){ra=qa;break b}f[i>>2]=f[i>>2]|8;ia=f[F>>2]|0;if((ia|0)==537368){mHa(F,537368);Oa=f[F>>2]|0}else Oa=ia;if(l$b(c,Oa)|0)continue a;else{ta=0;pa=277;break a}break}case 19:{if((qa&255|0)!=152){ra=qa;break b}f[i>>2]=f[i>>2]|4096;ia=f[c>>2]|0;if(ia>>>0<(f[g>>2]|0)>>>0){ha=b[ia>>0]|0;ja=ha&255;if(ha<<24>>24>-1){f[G>>2]=ja;f[c>>2]=ia+1;continue a}else Pa=ja}else Pa=0;ja=KYb(c,Pa)|0;ia=J;f[G>>2]=ja;if((ia|0)>-1|(ia|0)==-1&ja>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 20:{if((qa&255|0)!=160){ra=qa;break b}f[i>>2]=f[i>>2]|8192;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0){ia=b[ja>>0]|0;ha=ia&255;if(ia<<24>>24>-1){f[H>>2]=ha;f[c>>2]=ja+1;continue a}else Qa=ha}else Qa=0;ha=KYb(c,Qa)|0;ja=J;f[H>>2]=ha;if((ja|0)>-1|(ja|0)==-1&ha>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 21:{if((qa&255|0)!=168){ra=qa;break b}f[i>>2]=f[i>>2]|32768;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0?(ja=b[ha>>0]|0,ja<<24>>24>-1):0){f[c>>2]=ha+1;Ra=ja<<24>>24!=0}else{LYb(e,c);ja=e;if(!(b[K>>0]|0)){ta=0;pa=277;break a}else Ra=(f[ja>>2]|0)!=0|(f[ja+4>>2]|0)!=0}b[I>>0]=Ra&1;continue a;break}case 22:{if((qa&255|0)!=181){ra=qa;break b}f[i>>2]=f[i>>2]|-2147483648;ja=f[c>>2]|0;if(((f[g>>2]|0)-ja|0)>3){ha=ja;ia=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=ia;f[c>>2]=ja+4;Sa=ia}else{if(!(WYb(c,e)|0)){pa=145;break a}Sa=f[e>>2]|0}f[L>>2]=Sa;continue a;break}case 50:{if((qa&255|0)!=146){ra=qa;break b}ia=Z$a(M)|0;ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(ha=b[ja>>0]|0,ha<<24>>24>-1):0){f[c>>2]=ja+1;Ta=ha&255}else{ha=YYb(c)|0;if((ha|0)>-1)Ta=ha;else{ta=0;pa=277;break a}}JYb(e,c,Ta);if((f[N>>2]|0)<0){pa=153;break a}if(!(Mi[f[(f[ia>>2]|0)+44>>2]&1023](ia,c)|0)){pa=153;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}case 51:{switch((qa&255)<<24>>24){case -99:break;case -102:{if(_Za(c,O)|0)continue a;else{ta=0;pa=277;break a}break}default:{ra=qa;break b}}ia=f[c>>2]|0;if(((f[g>>2]|0)-ia|0)>3){ha=ia;ja=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=ja;f[c>>2]=ia+4;Ua=ja}else{if(!(WYb(c,e)|0)){pa=171;break a}Ua=f[e>>2]|0}ja=f[O>>2]|0;if((ja|0)==(f[P>>2]|0)){uHa(O,ja+1|0);Va=f[O>>2]|0}else Va=ja;ja=f[Q>>2]|0;ia=Va+1|0;f[O>>2]=ia;f[ja+4+(Va<<2)>>2]=Ua;ha=f[c>>2]|0;ka=(f[g>>2]|0)-ha|0;if((ka|0)<=0)continue a;la=ha;ha=(f[P>>2]|0)-ia|0;Wa=(ka>>>0)/6|0;Xa=(Wa|0)<(ha|0)?Wa:ha;if((Xa|0)>0){Ya=0;Za=la;_a=ia}else continue a;while(1){if((b[Za>>0]|0)!=-99){$a=Ya;break}if((b[Za+1>>0]|0)!=3){$a=Ya;break}ia=Za+2|0;ha=h[ia>>0]|h[ia+1>>0]<<8|h[ia+2>>0]<<16|h[ia+3>>0]<<24;ia=_a;_a=_a+1|0;f[O>>2]=_a;f[ja+4+(ia<<2)>>2]=ha;ha=Ya+1|0;if((ha|0)>=(Xa|0)){$a=ha;break}else{Ya=ha;Za=Za+6|0}}Xa=$a*6|0;if(($a|0)<=0)continue a;if((ka|0)<(Xa|0)){SYb(c,Xa,ka)|0;continue a}else{f[c>>2]=la+Xa;continue a}break}case 52:{switch((qa&255)<<24>>24){case -91:break;case -94:{if(_Za(c,R)|0)continue a;else{ta=0;pa=277;break a}break}default:{ra=qa;break b}}Xa=f[c>>2]|0;if(((f[g>>2]|0)-Xa|0)>3){ja=Xa;ha=h[ja>>0]|h[ja+1>>0]<<8|h[ja+2>>0]<<16|h[ja+3>>0]<<24;f[e>>2]=ha;f[c>>2]=Xa+4;ab=ha}else{if(!(WYb(c,e)|0)){pa=189;break a}ab=f[e>>2]|0}ha=f[R>>2]|0;if((ha|0)==(f[S>>2]|0)){uHa(R,ha+1|0);bb=f[R>>2]|0}else bb=ha;ha=f[T>>2]|0;Xa=bb+1|0;f[R>>2]=Xa;f[ha+4+(bb<<2)>>2]=ab;ja=f[c>>2]|0;ia=(f[g>>2]|0)-ja|0;if((ia|0)<=0)continue a;Wa=ja;ja=(f[S>>2]|0)-Xa|0;cb=(ia>>>0)/6|0;db=(cb|0)<(ja|0)?cb:ja;if((db|0)>0){eb=0;fb=Wa;gb=Xa}else continue a;while(1){if((b[fb>>0]|0)!=-91){hb=eb;break}if((b[fb+1>>0]|0)!=3){hb=eb;break}Xa=fb+2|0;ja=h[Xa>>0]|h[Xa+1>>0]<<8|h[Xa+2>>0]<<16|h[Xa+3>>0]<<24;Xa=gb;gb=gb+1|0;f[R>>2]=gb;f[ha+4+(Xa<<2)>>2]=ja;ja=eb+1|0;if((ja|0)>=(db|0)){hb=ja;break}else{eb=ja;fb=fb+6|0}}db=hb*6|0;if((hb|0)<=0)continue a;if((ia|0)<(db|0)){SYb(c,db,ia)|0;continue a}else{f[c>>2]=Wa+db;continue a}break}case 53:{if((qa&255|0)!=168){ra=qa;break b}f[i>>2]=f[i>>2]|131072;db=f[c>>2]|0;if(db>>>0<(f[g>>2]|0)>>>0){ha=b[db>>0]|0;la=ha&255;if(ha<<24>>24>-1){f[U>>2]=la;f[c>>2]=db+1;continue a}else ib=la}else ib=0;la=KYb(c,ib)|0;db=J;f[U>>2]=la;if((db|0)>-1|(db|0)==-1&la>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 54:{if((qa&255|0)!=181){ra=qa;break b}f[V>>2]=f[V>>2]|1;la=f[c>>2]|0;if(((f[g>>2]|0)-la|0)>3){db=la;ha=h[db>>0]|h[db+1>>0]<<8|h[db+2>>0]<<16|h[db+3>>0]<<24;f[e>>2]=ha;f[c>>2]=la+4;jb=ha}else{if(!(WYb(c,e)|0)){pa=202;break a}jb=f[e>>2]|0}f[W>>2]=jb;continue a;break}case 55:{if((qa&255|0)!=189){ra=qa;break b}f[V>>2]=f[V>>2]|2;ha=f[c>>2]|0;if(((f[g>>2]|0)-ha|0)>3){la=ha;db=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;f[e>>2]=db;f[c>>2]=ha+4;kb=db}else{if(!(WYb(c,e)|0)){pa=209;break a}kb=f[e>>2]|0}f[X>>2]=kb;continue a;break}case 56:{if((qa&255|0)!=197){ra=qa;break b}f[V>>2]=f[V>>2]|4;db=f[c>>2]|0;if(((f[g>>2]|0)-db|0)>3){ha=db;la=h[ha>>0]|h[ha+1>>0]<<8|h[ha+2>>0]<<16|h[ha+3>>0]<<24;f[e>>2]=la;f[c>>2]=db+4;lb=la}else{if(!(WYb(c,e)|0)){pa=216;break a}lb=f[e>>2]|0}f[Y>>2]=lb;continue a;break}case 58:{if((qa&255|0)!=208){ra=qa;break b}f[i>>2]=f[i>>2]|262144;la=f[c>>2]|0;if(la>>>0<(f[g>>2]|0)>>>0){db=b[la>>0]|0;ha=db&255;if(db<<24>>24>-1){f[Z>>2]=ha;f[c>>2]=la+1;continue a}else mb=ha}else mb=0;ha=KYb(c,mb)|0;la=J;f[Z>>2]=ha;if((la|0)>-1|(la|0)==-1&ha>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 59:{if((qa&255|0)!=218){ra=qa;break b}f[i>>2]=f[i>>2]|16;ha=f[_>>2]|0;if((ha|0)==535232){mHa(_,535232);nb=f[_>>2]|0}else nb=ha;if(l$b(c,nb)|0)continue a;else{ta=0;pa=277;break a}break}case 60:{if((qa&255|0)!=224){ra=qa;break b}f[i>>2]=f[i>>2]|524288;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){la=b[ha>>0]|0;db=la&255;if(la<<24>>24>-1){f[c>>2]=ha+1;ob=db}else{pb=db;pa=230}}else{pb=0;pa=230}if((pa|0)==230){pa=0;db=KYb(c,pb)|0;ha=J;if((ha|0)>-1|(ha|0)==-1&db>>>0>4294967295)ob=db;else{ta=0;pa=277;break a}}f[$>>2]=ob;continue a;break}case 61:{if((qa&255|0)!=232){ra=qa;break b}f[i>>2]=f[i>>2]|1048576;db=f[c>>2]|0;if(db>>>0<(f[g>>2]|0)>>>0){ha=b[db>>0]|0;la=ha&255;if(ha<<24>>24>-1){f[c>>2]=db+1;qb=la}else{rb=la;pa=236}}else{rb=0;pa=236}if((pa|0)==236){pa=0;la=KYb(c,rb)|0;db=J;if((db|0)>-1|(db|0)==-1&la>>>0>4294967295)qb=la;else{ta=0;pa=277;break a}}f[aa>>2]=qb;continue a;break}case 62:{if((qa&255|0)!=240){ra=qa;break b}f[i>>2]=f[i>>2]|2097152;la=f[c>>2]|0;if(la>>>0<(f[g>>2]|0)>>>0){db=b[la>>0]|0;ha=db&255;if(db<<24>>24>-1){f[c>>2]=la+1;sb=ha}else{tb=ha;pa=242}}else{tb=0;pa=242}if((pa|0)==242){pa=0;ha=KYb(c,tb)|0;la=J;if((la|0)>-1|(la|0)==-1&ha>>>0>4294967295)sb=ha;else{ta=0;pa=277;break a}}f[ba>>2]=sb;continue a;break}case 63:{if((qa&255|0)!=248){ra=qa;break b}f[i>>2]=f[i>>2]|16384;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){la=b[ha>>0]|0;db=la&255;if(la<<24>>24>-1){f[c>>2]=ha+1;ub=db}else{vb=db;pa=248}}else{vb=0;pa=248}if((pa|0)==248){pa=0;db=KYb(c,vb)|0;ha=J;if((ha|0)>-1|(ha|0)==-1&db>>>0>4294967295)ub=db;else{ta=0;pa=277;break a}}f[ca>>2]=ub;continue a;break}case 64:{if(qa&255|0){ra=qa;break b}f[i>>2]=f[i>>2]|65536;db=f[c>>2]|0;if(db>>>0<(f[g>>2]|0)>>>0?(ha=b[db>>0]|0,ha<<24>>24>-1):0){f[c>>2]=db+1;wb=ha<<24>>24!=0}else{LYb(e,c);ha=e;if(!(b[ea>>0]|0)){ta=0;pa=277;break a}else wb=(f[ha>>2]|0)!=0|(f[ha+4>>2]|0)!=0}b[da>>0]=wb&1;continue a;break}case 65:{if((qa&255|0)!=8){ra=qa;break b}f[i>>2]=f[i>>2]|4194304;ha=f[c>>2]|0;if(ha>>>0<(f[g>>2]|0)>>>0){db=b[ha>>0]|0;la=db&255;if(db<<24>>24>-1){f[fa>>2]=la;f[c>>2]=ha+1;continue a}else xb=la}else xb=0;la=KYb(c,xb)|0;ha=J;f[fa>>2]=la;if((ha|0)>-1|(ha|0)==-1&la>>>0>4294967295)continue a;else{ta=0;pa=277;break a}break}case 1001:{if((qa&255|0)!=74){ra=qa;break b}f[i>>2]=f[i>>2]|128;la=f[ga>>2]|0;if(!la){ha=$Xc(20)|0;I$a(ha);f[ga>>2]=ha;yb=ha}else yb=la;la=f[c>>2]|0;if(la>>>0<(f[g>>2]|0)>>>0?(ha=b[la>>0]|0,ha<<24>>24>-1):0){f[c>>2]=la+1;zb=ha&255}else{ha=YYb(c)|0;if((ha|0)>-1)zb=ha;else{ta=0;pa=277;break a}}JYb(e,c,zb);if((f[a>>2]|0)<0){pa=270;break a}if(!(Mi[f[(f[yb>>2]|0)+44>>2]&1023](yb,c)|0)){pa=270;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{ta=0;pa=277;break a}break}default:{ra=qa;break b}}while(0)}while(0);if(!ra){ta=1;pa=277;break}ha=f[y>>2]|0;if(!(ha&1))Ab=lSa(y)|0;else Ab=ha&-2;if(!(Lqc(c,ra,Ab)|0)){ta=0;pa=277;break}}switch(pa|0){case 38:{ta=0;u=d;return ta|0}case 49:{ta=0;u=d;return ta|0}case 88:{ta=0;u=d;return ta|0}case 100:{ta=0;u=d;return ta|0}case 107:{ta=0;u=d;return ta|0}case 118:{ta=0;u=d;return ta|0}case 145:{ta=0;u=d;return ta|0}case 153:{ta=0;u=d;return ta|0}case 171:{ta=0;u=d;return ta|0}case 189:{ta=0;u=d;return ta|0}case 202:{ta=0;u=d;return ta|0}case 209:{ta=0;u=d;return ta|0}case 216:{ta=0;u=d;return ta|0}case 270:{ta=0;u=d;return ta|0}case 277:{u=d;return ta|0}}return 0}function z$a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=(c<<1)+d|0;if(!c)g=e;else{d=a+28|0;h=0;i=e;while(1){e=f[(f[d>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(c|0)){g=e;break}else i=e}}i=f[a+32>>2]|0;c=f[a+44>>2]|0;h=(i<<2)+g+(c<<2)+(c+i<<1)|0;i=a+8|0;c=f[i>>2]|0;if(c&255){if(!(c&1))k=h;else{g=f[a+56>>2]|0;d=b[g+11>>0]|0;e=d<<24>>24<0?f[g+4>>2]|0:d&255;k=h+1+e+((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=k;else{e=f[a+60>>2]|0;d=b[e+11>>0]|0;g=d<<24>>24<0?f[e+4>>2]|0:d&255;l=k+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))m=l;else{g=f[a+64>>2]|0;k=b[g+11>>0]|0;d=k<<24>>24<0?f[g+4>>2]|0:k&255;m=l+2+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))n=m;else{d=f[a+68>>2]|0;l=b[d+11>>0]|0;k=l<<24>>24<0?f[d+4>>2]|0:l&255;n=m+2+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&16))o=n;else{k=f[a+72>>2]|0;m=b[k+11>>0]|0;l=m<<24>>24<0?f[k+4>>2]|0:m&255;o=n+2+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&32)){p=o;q=c}else{l=f[a+76>>2]|0;n=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;l=o+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=l;q=f[i>>2]|0}if(!(q&64)){r=p;s=q}else{q=f[a+80>>2]|0;l=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=p+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;r=q;s=f[i>>2]|0}if(!(s&128)){t=r;u=s}else{s=f[a+84>>2]|0;q=_i[f[(f[s>>2]|0)+48>>2]&2047](s)|0;s=r+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;t=s;u=f[i>>2]|0}}else{t=h;u=c}if(!(u&65280))v=t;else{if(!(u&256))w=t;else w=t+1+((((($(f[a+88>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&512))x=w;else x=w+1+((((($(f[a+92>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&1024))y=x;else y=x+1+((((($(f[a+96>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&2048))z=y;else{x=f[a+100>>2]|0;if((x|0)<0)A=10;else A=(((($(x|1|0)|0)^31)*9|0)+73|0)>>>6;z=y+1+A|0}if(!(u&4096))B=z;else B=z+2+((((($(f[a+104>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&8192))C=B;else C=B+2+((((($(f[a+108>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&16384))D=C;else{B=f[a+112>>2]|0;if((B|0)<0)E=10;else E=(((($(B|1|0)|0)^31)*9|0)+73|0)>>>6;D=C+2+E|0}v=u&32768|0?D+3|0:D}if(!(u&16711680))F=v;else{D=u&65536|0?v+3|0:v;if(!(u&131072))G=D;else G=D+2+((((($(f[a+120>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&262144))H=G;else H=G+2+((((($(f[a+124>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&524288))I=H;else{G=f[a+128>>2]|0;if((G|0)<0)J=12;else J=((((($(G|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;I=J+H|0}if(!(u&1048576))K=I;else{H=f[a+132>>2]|0;if((H|0)<0)L=12;else L=((((($(H|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;K=L+I|0}if(!(u&2097152))M=K;else{I=f[a+136>>2]|0;if((I|0)<0)N=12;else N=((((($(I|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;M=N+K|0}if(!(u&4194304))O=M;else O=M+2+((((($(f[a+140>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;F=u&8388608|0?O+2|0:O}if(u>>>0>16777215){if(!(u&16777216))P=F;else P=F+1+((((($(f[a+148>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(u&33554432))Q=P;else Q=P+1+((((($(f[a+152>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;P=u&67108864|0?Q+5|0:Q;if(!(u&134217728))R=P;else R=P+1+((((($(f[a+160>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;P=u&268435456|0?R+5|0:R;R=u&536870912|0?P+5|0:P;P=u&1073741824|0?R+6|0:R;S=(u|0)<0?P+6|0:P}else S=F;F=f[a+12>>2]|0;if(!(F&7)){T=S;U=a+192|0;f[U>>2]=T;return T|0}P=F&1|0?S+6|0:S;S=F&2|0?P+6|0:P;T=F&4|0?S+6|0:S;U=a+192|0;f[U>>2]=T;return T|0}function A$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(e&1|0)f$b(1,f[a+56>>2]|0,c);if(e&2|0)f$b(2,f[a+60>>2]|0,c);if(e&256|0)U_b(3,f[a+88>>2]|0,c);if(e&8388608|0)c$b(4,(b[a+144>>0]|0)!=0,c);if(e&32|0)k$b(5,f[a+76>>2]|0,c);if(e&64|0)k$b(6,f[a+80>>2]|0,c);if(e&512|0)U_b(7,f[a+92>>2]|0,c);if(e&1024|0)U_b(8,f[a+96>>2]|0,c);if(e&16777216|0)U_b(9,f[a+148>>2]|0,c);if(e&33554432|0)U_b(10,f[a+152>>2]|0,c);if(e&2048|0)d$b(11,f[a+100>>2]|0,c);if(e&67108864|0)a$b(12,+n[a+156>>2],c);if(e&134217728|0)U_b(13,f[a+160>>2]|0,c);if(e&268435456|0)a$b(14,+n[a+164>>2],c);if(e&536870912|0)a$b(15,+n[a+168>>2],c);if(e&4|0)f$b(16,f[a+64>>2]|0,c);if(e&1073741824|0)a$b(17,+n[a+172>>2],c);if(e&8|0)f$b(18,f[a+68>>2]|0,c);if(e&4096|0)U_b(19,f[a+104>>2]|0,c);if(e&8192|0)U_b(20,f[a+108>>2]|0,c);if(e&32768|0)c$b(21,(b[a+116>>0]|0)!=0,c);if((e|0)<0)a$b(22,+n[a+176>>2],c);g=f[a+20>>2]|0;if(g|0){h=a+28|0;i=0;do{k$b(50,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(g|0))}g=f[a+32>>2]|0;if((g|0)>0){i=a+40|0;h=0;do{a$b(51,+n[(f[i>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(g|0))}g=f[a+44>>2]|0;if((g|0)>0){h=a+52|0;i=0;do{a$b(52,+n[(f[h>>2]|0)+4+(i<<2)>>2],c);i=i+1|0}while((i|0)!=(g|0))}if(e&131072|0)U_b(53,f[a+120>>2]|0,c);e=f[a+12>>2]|0;if(e&1|0)a$b(54,+n[a+180>>2],c);if(e&2|0)a$b(55,+n[a+184>>2],c);if(e&4|0)a$b(56,+n[a+188>>2],c);e=f[d>>2]|0;if(e&262144|0)U_b(58,f[a+124>>2]|0,c);if(e&16|0)f$b(59,f[a+72>>2]|0,c);if(e&524288|0)S_b(60,f[a+128>>2]|0,c);if(e&1048576|0)S_b(61,f[a+132>>2]|0,c);if(e&2097152|0)S_b(62,f[a+136>>2]|0,c);if(e&16384|0)S_b(63,f[a+112>>2]|0,c);if(e&65536|0)c$b(64,(b[a+117>>0]|0)!=0,c);if(e&4194304|0)U_b(65,f[a+140>>2]|0,c);if(e&128|0)k$b(1001,f[a+84>>2]|0,c);e=f[a+4>>2]|0;if(!(e&1))return;Oqc(e&-2,c);return}function B$a(a){a=a|0;return f[a+192>>2]|0}function C$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;e=a+8|0;g=f[e>>2]|0;if(!(g&1))h=d;else{i=f[a+56>>2]|0;b[d>>0]=10;h=gZb(i,d+1|0)|0}if(!(g&2))j=h;else{d=f[a+60>>2]|0;b[h>>0]=18;j=gZb(d,h+1|0)|0}if(!(g&256))k=j;else{h=f[a+88>>2]|0;b[j>>0]=24;d=j+1|0;if(h>>>0>127){j=h;i=d;while(1){b[i>>0]=j|128;l=j>>>7;m=i+1|0;if(j>>>0>16383){j=l;i=m}else{n=m;o=l;break}}}else{n=d;o=h}b[n>>0]=o;k=n+1|0}if(!(g&8388608))p=k;else{n=b[a+144>>0]|0;b[k>>0]=32;b[k+1>>0]=n;p=k+2|0}if(!(g&32))q=p;else{k=f[a+76>>2]|0;b[p>>0]=42;n=p+1|0;p=_i[f[(f[k>>2]|0)+60>>2]&2047](k)|0;if(p>>>0>127){o=p;h=n;while(1){b[h>>0]=o|128;d=o>>>7;i=h+1|0;if(o>>>0>16383){o=d;h=i}else{r=i;s=d;break}}}else{r=n;s=p}b[r>>0]=s;q=hj[f[(f[k>>2]|0)+64>>2]&511](k,c,r+1|0)|0}if(!(g&64))t=q;else{r=f[a+80>>2]|0;b[q>>0]=50;k=q+1|0;q=_i[f[(f[r>>2]|0)+60>>2]&2047](r)|0;if(q>>>0>127){s=q;p=k;while(1){b[p>>0]=s|128;n=s>>>7;h=p+1|0;if(s>>>0>16383){s=n;p=h}else{u=h;v=n;break}}}else{u=k;v=q}b[u>>0]=v;t=hj[f[(f[r>>2]|0)+64>>2]&511](r,c,u+1|0)|0}if(!(g&512))w=t;else{u=f[a+92>>2]|0;b[t>>0]=56;r=t+1|0;if(u>>>0>127){t=u;v=r;while(1){b[v>>0]=t|128;q=t>>>7;k=v+1|0;if(t>>>0>16383){t=q;v=k}else{x=k;y=q;break}}}else{x=r;y=u}b[x>>0]=y;w=x+1|0}if(!(g&1024))z=w;else{x=f[a+96>>2]|0;b[w>>0]=64;y=w+1|0;if(x>>>0>127){w=x;u=y;while(1){b[u>>0]=w|128;r=w>>>7;v=u+1|0;if(w>>>0>16383){w=r;u=v}else{A=v;B=r;break}}}else{A=y;B=x}b[A>>0]=B;z=A+1|0}if(!(g&16777216))C=z;else{A=f[a+148>>2]|0;b[z>>0]=72;B=z+1|0;if(A>>>0>127){z=A;x=B;while(1){b[x>>0]=z|128;y=z>>>7;u=x+1|0;if(z>>>0>16383){z=y;x=u}else{D=u;E=y;break}}}else{D=B;E=A}b[D>>0]=E;C=D+1|0}if(!(g&33554432))F=C;else{D=f[a+152>>2]|0;b[C>>0]=80;E=C+1|0;if(D>>>0>127){C=D;A=E;while(1){b[A>>0]=C|128;B=C>>>7;x=A+1|0;if(C>>>0>16383){C=B;A=x}else{G=x;H=B;break}}}else{G=E;H=D}b[G>>0]=H;F=G+1|0}if(!(g&2048))I=F;else{G=f[a+100>>2]|0;b[F>>0]=88;H=F+1|0;F=G&255;if(G>>>0>127){D=H;E=F;A=G;C=((G|0)<0)<<31>>31;while(1){b[D>>0]=E|-128;G=A;A=l1c(A|0,C|0,7)|0;B=D+1|0;x=A&255;if(!(C>>>0>0|(C|0)==0&G>>>0>16383)){K=B;L=x;break}else{D=B;E=x;C=J}}}else{K=H;L=F}b[K>>0]=L;I=K+1|0}if(!(g&67108864))M=I;else{K=f[a+156>>2]|0;b[I>>0]=101;L=I+1|0;b[L>>0]=K;b[L+1>>0]=K>>8;b[L+2>>0]=K>>16;b[L+3>>0]=K>>24;M=I+5|0}if(!(g&134217728))N=M;else{I=f[a+160>>2]|0;b[M>>0]=104;K=M+1|0;if(I>>>0>127){M=I;L=K;while(1){b[L>>0]=M|128;F=M>>>7;H=L+1|0;if(M>>>0>16383){M=F;L=H}else{O=H;P=F;break}}}else{O=K;P=I}b[O>>0]=P;N=O+1|0}if(!(g&268435456))Q=N;else{O=f[a+164>>2]|0;b[N>>0]=117;P=N+1|0;b[P>>0]=O;b[P+1>>0]=O>>8;b[P+2>>0]=O>>16;b[P+3>>0]=O>>24;Q=N+5|0}if(!(g&536870912))R=Q;else{N=f[a+168>>2]|0;b[Q>>0]=125;O=Q+1|0;b[O>>0]=N;b[O+1>>0]=N>>8;b[O+2>>0]=N>>16;b[O+3>>0]=N>>24;R=Q+5|0}if(!(g&4))S=R;else{Q=f[a+64>>2]|0;b[R>>0]=-126;b[R+1>>0]=1;S=gZb(Q,R+2|0)|0}if(!(g&1073741824))T=S;else{R=f[a+172>>2]|0;b[S>>0]=-115;b[S+1>>0]=1;Q=S+2|0;b[Q>>0]=R;b[Q+1>>0]=R>>8;b[Q+2>>0]=R>>16;b[Q+3>>0]=R>>24;T=S+6|0}if(!(g&8))U=T;else{S=f[a+68>>2]|0;b[T>>0]=-110;b[T+1>>0]=1;U=gZb(S,T+2|0)|0}if(!(g&4096))V=U;else{T=f[a+104>>2]|0;b[U>>0]=-104;b[U+1>>0]=1;S=U+2|0;if(T>>>0>127){U=T;R=S;while(1){b[R>>0]=U|128;Q=U>>>7;N=R+1|0;if(U>>>0>16383){U=Q;R=N}else{W=N;X=Q;break}}}else{W=S;X=T}b[W>>0]=X;V=W+1|0}if(!(g&8192))Y=V;else{W=f[a+108>>2]|0;b[V>>0]=-96;b[V+1>>0]=1;X=V+2|0;if(W>>>0>127){V=W;T=X;while(1){b[T>>0]=V|128;S=V>>>7;R=T+1|0;if(V>>>0>16383){V=S;T=R}else{Z=R;_=S;break}}}else{Z=X;_=W}b[Z>>0]=_;Y=Z+1|0}if(!(g&32768))$=Y;else{Z=b[a+116>>0]|0;b[Y>>0]=-88;b[Y+1>>0]=1;b[Y+2>>0]=Z;$=Y+3|0}if((g|0)<0){Y=f[a+176>>2]|0;b[$>>0]=-75;b[$+1>>0]=1;Z=$+2|0;b[Z>>0]=Y;b[Z+1>>0]=Y>>8;b[Z+2>>0]=Y>>16;b[Z+3>>0]=Y>>24;aa=$+6|0}else aa=$;$=f[a+20>>2]|0;if(!$)ba=aa;else{Y=a+28|0;Z=0;_=aa;while(1){aa=f[(f[Y>>2]|0)+4+(Z<<2)>>2]|0;b[_>>0]=-110;b[_+1>>0]=3;W=_+2|0;X=_i[f[(f[aa>>2]|0)+60>>2]&2047](aa)|0;if(X>>>0>127){T=X;V=W;while(1){b[V>>0]=T|128;S=T>>>7;R=V+1|0;if(T>>>0>16383){T=S;V=R}else{ca=R;da=S;break}}}else{ca=W;da=X}b[ca>>0]=da;V=hj[f[(f[aa>>2]|0)+64>>2]&511](aa,c,ca+1|0)|0;Z=Z+1|0;if((Z|0)==($|0)){ba=V;break}else _=V}}_=f[a+32>>2]|0;if(!_)ea=ba;else{$=f[a+40>>2]|0;Z=0;ca=ba;while(1){ba=f[$+4+(Z<<2)>>2]|0;b[ca>>0]=-99;b[ca+1>>0]=3;da=ca+2|0;b[da>>0]=ba;b[da+1>>0]=ba>>8;b[da+2>>0]=ba>>16;b[da+3>>0]=ba>>24;ba=ca+6|0;Z=Z+1|0;if((Z|0)>=(_|0)){ea=ba;break}else ca=ba}}ca=f[a+44>>2]|0;if(!ca)fa=ea;else{_=f[a+52>>2]|0;Z=0;$=ea;while(1){ea=f[_+4+(Z<<2)>>2]|0;b[$>>0]=-91;b[$+1>>0]=3;ba=$+2|0;b[ba>>0]=ea;b[ba+1>>0]=ea>>8;b[ba+2>>0]=ea>>16;b[ba+3>>0]=ea>>24;ea=$+6|0;Z=Z+1|0;if((Z|0)>=(ca|0)){fa=ea;break}else $=ea}}if(!(g&131072))ga=fa;else{g=f[a+120>>2]|0;b[fa>>0]=-88;b[fa+1>>0]=3;$=fa+2|0;if(g>>>0>127){fa=g;ca=$;while(1){b[ca>>0]=fa|128;Z=fa>>>7;_=ca+1|0;if(fa>>>0>16383){fa=Z;ca=_}else{ha=_;ia=Z;break}}}else{ha=$;ia=g}b[ha>>0]=ia;ga=ha+1|0}ha=f[a+12>>2]|0;if(!(ha&1))ja=ga;else{ia=f[a+180>>2]|0;b[ga>>0]=-75;b[ga+1>>0]=3;g=ga+2|0;b[g>>0]=ia;b[g+1>>0]=ia>>8;b[g+2>>0]=ia>>16;b[g+3>>0]=ia>>24;ja=ga+6|0}if(!(ha&2))ka=ja;else{ga=f[a+184>>2]|0;b[ja>>0]=-67;b[ja+1>>0]=3;ia=ja+2|0;b[ia>>0]=ga;b[ia+1>>0]=ga>>8;b[ia+2>>0]=ga>>16;b[ia+3>>0]=ga>>24;ka=ja+6|0}if(!(ha&4))la=ka;else{ha=f[a+188>>2]|0;b[ka>>0]=-59;b[ka+1>>0]=3;ja=ka+2|0;b[ja>>0]=ha;b[ja+1>>0]=ha>>8;b[ja+2>>0]=ha>>16;b[ja+3>>0]=ha>>24;la=ka+6|0}ka=f[e>>2]|0;if(!(ka&262144))ma=la;else{e=f[a+124>>2]|0;b[la>>0]=-48;b[la+1>>0]=3;ha=la+2|0;if(e>>>0>127){la=e;ja=ha;while(1){b[ja>>0]=la|128;ga=la>>>7;ia=ja+1|0;if(la>>>0>16383){la=ga;ja=ia}else{na=ia;oa=ga;break}}}else{na=ha;oa=e}b[na>>0]=oa;ma=na+1|0}if(!(ka&16))pa=ma;else{na=f[a+72>>2]|0;b[ma>>0]=-38;b[ma+1>>0]=3;pa=gZb(na,ma+2|0)|0}if(!(ka&524288))qa=pa;else{ma=f[a+128>>2]|0;b[pa>>0]=-32;b[pa+1>>0]=3;na=pa+2|0;pa=ma&255;if(ma>>>0>127){oa=na;e=pa;ha=ma;ja=((ma|0)<0)<<31>>31;while(1){b[oa>>0]=e|-128;ma=ha;ha=l1c(ha|0,ja|0,7)|0;la=oa+1|0;ga=ha&255;if(!(ja>>>0>0|(ja|0)==0&ma>>>0>16383)){ra=la;sa=ga;break}else{oa=la;e=ga;ja=J}}}else{ra=na;sa=pa}b[ra>>0]=sa;qa=ra+1|0}if(!(ka&1048576))ta=qa;else{ra=f[a+132>>2]|0;b[qa>>0]=-24;b[qa+1>>0]=3;sa=qa+2|0;qa=ra&255;if(ra>>>0>127){pa=sa;na=qa;ja=ra;e=((ra|0)<0)<<31>>31;while(1){b[pa>>0]=na|-128;ra=ja;ja=l1c(ja|0,e|0,7)|0;oa=pa+1|0;ha=ja&255;if(!(e>>>0>0|(e|0)==0&ra>>>0>16383)){ua=oa;va=ha;break}else{pa=oa;na=ha;e=J}}}else{ua=sa;va=qa}b[ua>>0]=va;ta=ua+1|0}if(!(ka&2097152))wa=ta;else{ua=f[a+136>>2]|0;b[ta>>0]=-16;b[ta+1>>0]=3;va=ta+2|0;ta=ua&255;if(ua>>>0>127){qa=va;sa=ta;e=ua;na=((ua|0)<0)<<31>>31;while(1){b[qa>>0]=sa|-128;ua=e;e=l1c(e|0,na|0,7)|0;pa=qa+1|0;ja=e&255;if(!(na>>>0>0|(na|0)==0&ua>>>0>16383)){xa=pa;ya=ja;break}else{qa=pa;sa=ja;na=J}}}else{xa=va;ya=ta}b[xa>>0]=ya;wa=xa+1|0}if(!(ka&16384))za=wa;else{xa=f[a+112>>2]|0;b[wa>>0]=-8;b[wa+1>>0]=3;ya=wa+2|0;wa=xa&255;if(xa>>>0>127){ta=ya;va=wa;na=xa;sa=((xa|0)<0)<<31>>31;while(1){b[ta>>0]=va|-128;xa=na;na=l1c(na|0,sa|0,7)|0;qa=ta+1|0;e=na&255;if(!(sa>>>0>0|(sa|0)==0&xa>>>0>16383)){Aa=qa;Ba=e;break}else{ta=qa;va=e;sa=J}}}else{Aa=ya;Ba=wa}b[Aa>>0]=Ba;za=Aa+1|0}if(!(ka&65536))Ca=za;else{Aa=b[a+117>>0]|0;b[za>>0]=-128;b[za+1>>0]=4;b[za+2>>0]=Aa;Ca=za+3|0}if(!(ka&4194304))Da=Ca;else{za=f[a+140>>2]|0;b[Ca>>0]=-120;b[Ca+1>>0]=4;Aa=Ca+2|0;if(za>>>0>127){Ca=za;Ba=Aa;while(1){b[Ba>>0]=Ca|128;wa=Ca>>>7;ya=Ba+1|0;if(Ca>>>0>16383){Ca=wa;Ba=ya}else{Ea=ya;Fa=wa;break}}}else{Ea=Aa;Fa=za}b[Ea>>0]=Fa;Da=Ea+1|0}if(!(ka&128))Ga=Da;else{ka=f[a+84>>2]|0;b[Da>>0]=-54;b[Da+1>>0]=62;Ea=Da+2|0;Da=_i[f[(f[ka>>2]|0)+60>>2]&2047](ka)|0;if(Da>>>0>127){Fa=Da;za=Ea;while(1){b[za>>0]=Fa|128;Aa=Fa>>>7;Ba=za+1|0;if(Fa>>>0>16383){Fa=Aa;za=Ba}else{Ha=Ba;Ia=Aa;break}}}else{Ha=Ea;Ia=Da}b[Ha>>0]=Ia;Ga=hj[f[(f[ka>>2]|0)+64>>2]&511](ka,c,Ha+1|0)|0}Ha=f[a+4>>2]|0;if(!(Ha&1)){Ja=Ga;return Ja|0}Ja=Pqc(Ha&-2,Ga)|0;return Ja|0}function D$a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;w$a(a);c=kZc(b,21568,15776,0)|0;if(!c){Ooc(b,a);return}else{H$a(a,c);return}}function E$a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15776,0)|0;if(!c){Ooc(b,a);return}else{H$a(a,c);return}}function F$a(a,b){a=a|0;b=b|0;f[a+192>>2]=b;return}function G$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535768;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function H$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}yHa(a+16|0,c+16|0);e=a+32|0;h=c+32|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+40>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+40>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+44|0;e=c+44|0;g=f[e>>2]|0;if(g|0){uHa(h,(f[h>>2]|0)+g|0);o1c((f[a+52>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+52>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;do if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+56|0,g=f[c+56>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+60|0,d=f[c+60>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==537368){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+64|0,h=f[c+64>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==537368){mHa(d,h);break}else{oYc(g,h)|0;break}while(0);do if(e&8|0?(h=a+8|0,f[h>>2]=f[h>>2]|8,h=a+68|0,g=f[c+68>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&16|0?(g=a+8|0,f[g>>2]=f[g>>2]|16,g=a+72|0,d=f[c+72>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==535232){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);if(e&32|0){d=a+8|0;f[d>>2]=f[d>>2]|32;d=a+76|0;h=f[d>>2]|0;if(!h){g=$Xc(48)|0;__a(g);f[d>>2]=g;i=g}else i=h;h=f[c+76>>2]|0;$_a(i,h|0?h:531776)}if(e&64|0){h=a+8|0;f[h>>2]=f[h>>2]|64;h=a+80|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;j=d}else j=g;g=f[c+80>>2]|0;$_a(j,g|0?g:531776)}if(e&128|0){g=a+8|0;f[g>>2]=f[g>>2]|128;g=a+84|0;d=f[g>>2]|0;if(!d){h=$Xc(20)|0;I$a(h);f[g>>2]=h;k=h}else k=d;d=f[c+84>>2]|0;h=d|0?d:533560;d=k+4|0;g=f[h+4>>2]|0;if(g&1|0){l=f[d>>2]|0;if(!(l&1))m=lSa(d)|0;else m=l&-2;vqc(m,g&-2)}if(f[h+8>>2]&1|0?(g=k+8|0,f[g>>2]=f[g>>2]|1,g=k+16|0,l=f[h+16>>2]|0,h=f[g>>2]|0,(h|0)!=(l|0)):0)if((h|0)==537368){mHa(g,l);break}else{oYc(h,l)|0;break}}}while(0);if(e&65280|0){if(e&256|0)f[a+88>>2]=f[c+88>>2];if(e&512|0)f[a+92>>2]=f[c+92>>2];if(e&1024|0)f[a+96>>2]=f[c+96>>2];if(e&2048|0)f[a+100>>2]=f[c+100>>2];if(e&4096|0)f[a+104>>2]=f[c+104>>2];if(e&8192|0)f[a+108>>2]=f[c+108>>2];if(e&16384|0)f[a+112>>2]=f[c+112>>2];if(e&32768|0)b[a+116>>0]=b[c+116>>0]|0;k=a+8|0;f[k>>2]=f[k>>2]|e}if(e&16711680|0){if(e&65536|0)b[a+117>>0]=b[c+117>>0]|0;if(e&131072|0)f[a+120>>2]=f[c+120>>2];if(e&262144|0)f[a+124>>2]=f[c+124>>2];if(e&524288|0)f[a+128>>2]=f[c+128>>2];if(e&1048576|0)f[a+132>>2]=f[c+132>>2];if(e&2097152|0)f[a+136>>2]=f[c+136>>2];if(e&4194304|0)f[a+140>>2]=f[c+140>>2];if(e&8388608|0)b[a+144>>0]=b[c+144>>0]|0;k=a+8|0;f[k>>2]=f[k>>2]|e}if(e>>>0>16777215){if(e&16777216|0)f[a+148>>2]=f[c+148>>2];if(e&33554432|0)f[a+152>>2]=f[c+152>>2];if(e&67108864|0)f[a+156>>2]=f[c+156>>2];if(e&134217728|0)f[a+160>>2]=f[c+160>>2];if(e&268435456|0)f[a+164>>2]=f[c+164>>2];if(e&536870912|0)f[a+168>>2]=f[c+168>>2];if(e&1073741824|0)f[a+172>>2]=f[c+172>>2];if((e|0)<0)f[a+176>>2]=f[c+176>>2];k=a+8|0;f[k>>2]=f[k>>2]|e}e=f[c+12>>2]|0;if(!(e&7))return;if(e&1|0)f[a+180>>2]=f[c+180>>2];if(e&2|0)f[a+184>>2]=f[c+184>>2];if(e&4|0)f[a+188>>2]=f[c+188>>2];c=a+12|0;f[c>>2]=f[c>>2]|e;return}function I$a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92488;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533560?(f[223110]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=60;b[d+8>>0]=0;J_b(892440,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;u=c;return}function J$a(a){a=a|0;var c=0,d=0;f[a>>2]=92488;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function K$a(a){a=a|0;J$a(a);cYc(a);return}function L$a(a){a=a|0;a=$Xc(20)|0;I$a(a);return a|0}function M$a(a,b){a=a|0;b=b|0;a=$Xc(20)|0;I$a(a);if(!b)return a|0;Y$a(b,a);return a|0}function N$a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function O$a(a){a=a|0;return 1}function P$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=ZYb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==10){f[e>>2]=f[e>>2]|1;j=f[g>>2]|0;if((j|0)==537368){mHa(g,537368);o=f[g>>2]|0}else o=j;if(l$b(c,o)|0)continue;else{p=0;l=15;break}}else n=k}if(!n){p=1;l=15;break}j=f[h>>2]|0;if(!(j&1))q=lSa(h)|0;else q=j&-2;if(!(Lqc(c,n,q)|0)){p=0;l=15;break}}if((l|0)==15)return p|0;return 0}function Q$a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;if(!(f[a+8>>2]&1)){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+16>>2]|0;h=b[c+11>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function R$a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)f$b(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function S$a(a){a=a|0;return f[a+12>>2]|0}function T$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=10;e=gZb(c,d+1|0)|0}d=f[a+4>>2]|0;if(!(d&1)){g=e;return g|0}g=Pqc(d&-2,e)|0;return g|0}function U$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;do if(f[d>>2]&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);V$a(a,c);return}function V$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15792,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[c+16>>2]|0;c=f[d>>2]|0;if((c|0)==(a|0))return;if((c|0)==537368){mHa(d,a);return}else{oYc(c,a)|0;return}}function W$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function X$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535544;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Y$a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Z$a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(108)|0;_$a(a);o=a}else{if(f[l+64>>2]|0)SXb(l,15808,112);a=RXb(l,112,2234)|0;_$a(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function _$a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92596;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;f[a+56>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+72>>2]=0;if((a|0)!=531328?(f[223074]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=24;b[d+8>>0]=0;J_b(892296,d);a_b(d)}f[a+12>>2]=0;f[a+80>>2]=537368;d=a+84|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function $$a(a){a=a|0;var c=0,d=0;f[a>>2]=92596;c=f[a+80>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)!=531328?(c=f[a+84>>2]|0,c|0):0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+72>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function a0a(a){a=a|0;$$a(a);cYc(a);return}function b0a(a){a=a|0;a=$Xc(108)|0;_$a(a);return a|0}function c0a(a,b){a=a|0;b=b|0;a=$Xc(108)|0;_$a(a);if(!b)return a|0;q0a(b,a);return a|0}function d0a(a){a=a|0;var c=0,d=0,e=0,g=0;f[a+16>>2]=0;f[a+32>>2]=0;f[a+48>>2]=0;f[a+64>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0){e=f[a+80>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if((d&2|0?(g=f[a+84>>2]|0,f[g+16>>2]=0,f[g+8>>2]=0,e=f[g+4>>2]|0,e&1|0):0)?(g=e&-2,f[g>>2]|0):0)sqc(g)}if(d&124|0){d=a+88|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function e0a(a){a=a|0;return 1}function f0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+88|0;k=a+92|0;l=a+96|0;m=a+100|0;n=a+16|0;o=a+20|0;q=a+24|0;r=a+32|0;t=a+36|0;v=a+40|0;w=a+84|0;x=e+4|0;y=a+48|0;z=a+52|0;A=a+56|0;B=a+64|0;C=a+68|0;D=a+72|0;E=a+104|0;F=a+4|0;G=a+80|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){H=b[a>>0]|0;I=H&255;if(H<<24>>24>0){f[c>>2]=a+1;K=I;L=6}else{M=I;L=5}}else{M=0;L=5}if((L|0)==5){L=0;I=ZYb(c,M)|0;if((I+-1|0)>>>0<127){K=I;L=6}else N=I}b:do if((L|0)==6){L=0;do switch(K>>>3&536870911|0){case 1:{if((K&255|0)!=8){N=K;break b}f[i>>2]=f[i>>2]|4;I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0){a=b[I>>0]|0;H=a&255;if(a<<24>>24>-1){f[c>>2]=I+1;O=H}else{P=H;L=11}}else{P=0;L=11}if((L|0)==11){L=0;H=KYb(c,P)|0;I=J;if((I|0)>-1|(I|0)==-1&H>>>0>4294967295)O=H;else{Q=0;L=154;break a}}f[j>>2]=O;continue a;break}case 2:{if((K&255|0)!=16){N=K;break b}f[i>>2]=f[i>>2]|8;H=f[c>>2]|0;if(H>>>0<(f[g>>2]|0)>>>0){I=b[H>>0]|0;a=I&255;if(I<<24>>24>-1){f[c>>2]=H+1;R=a}else{S=a;L=17}}else{S=0;L=17}if((L|0)==17){L=0;a=KYb(c,S)|0;H=J;if((H|0)>-1|(H|0)==-1&a>>>0>4294967295)R=a;else{Q=0;L=154;break a}}f[k>>2]=R;continue a;break}case 3:{if((K&255|0)!=24){N=K;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){H=b[a>>0]|0;I=H&255;if(H<<24>>24>-1){f[c>>2]=a+1;T=I}else{U=I;L=23}}else{U=0;L=23}if((L|0)==23){L=0;I=KYb(c,U)|0;a=J;if((a|0)>-1|(a|0)==-1&I>>>0>4294967295)T=I;else{Q=0;L=154;break a}}f[l>>2]=T;continue a;break}case 4:{if((K&255|0)!=32){N=K;break b}f[i>>2]=f[i>>2]|32;I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0){a=b[I>>0]|0;H=a&255;if(a<<24>>24>-1){f[c>>2]=I+1;V=H}else{W=H;L=29}}else{W=0;L=29}if((L|0)==29){L=0;H=KYb(c,W)|0;I=J;if((I|0)>-1|(I|0)==-1&H>>>0>4294967295)V=H;else{Q=0;L=154;break a}}f[m>>2]=V;continue a;break}case 5:{switch((K&255)<<24>>24){case 42:break;case 45:{if(eUa(1,42,c,n)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}H=f[c>>2]|0;if(H>>>0<(f[g>>2]|0)>>>0?(I=b[H>>0]|0,I<<24>>24>-1):0){f[c>>2]=H+1;X=I&255}else{I=YYb(c)|0;if((I|0)>-1)X=I;else{Q=0;L=154;break a}}Y=f[n>>2]|0;I=(X|0)/4|0;if((I<<2|0)!=(X|0)){Q=0;L=154;break a}H=RYb(c)|0;a=PYb(c)|0;if((((H|0)==-1|(a|0)<(H|0)?a:H)|0)>=(X|0)){H=Y+I|0;if((f[n>>2]|0)<(H|0)?(uHa(n,H),a=f[n>>2]|0,Z=H-a|0,(Z<<2|0)>0):0)g1c((f[q>>2]|0)+((a<<2)+4)|0,0,(((Z|-1073741824|0)==-1073741824?1073741823:1073741822)+Z<<2)+8|0)|0;f[n>>2]=H;H=f[q>>2]|0;if(TYb(c,((H|0)==0?0:H+4|0)+(Y<<2)|0,X)|0)continue a;else{L=43;break a}}if((X|0)>3)_=0;else continue a;while(1){H=f[c>>2]|0;if(((f[g>>2]|0)-H|0)>3){Z=H;a=h[Z>>0]|h[Z+1>>0]<<8|h[Z+2>>0]<<16|h[Z+3>>0]<<24;f[e>>2]=a;f[c>>2]=H+4;$=a}else{if(!(WYb(c,e)|0)){L=52;break a}$=f[e>>2]|0}a=f[n>>2]|0;if((a|0)==(f[o>>2]|0)){uHa(n,a+1|0);aa=f[n>>2]|0}else aa=a;a=f[q>>2]|0;f[n>>2]=aa+1;f[a+4+(aa<<2)>>2]=$;a=_+1|0;if((a|0)<(I|0))_=a;else continue a}break}case 6:{switch((K&255)<<24>>24){case 50:break;case 53:{if(eUa(1,50,c,r)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}I=f[c>>2]|0;if(I>>>0<(f[g>>2]|0)>>>0?(a=b[I>>0]|0,a<<24>>24>-1):0){f[c>>2]=I+1;ba=a&255}else{a=YYb(c)|0;if((a|0)>-1)ba=a;else{Q=0;L=154;break a}}ca=f[r>>2]|0;a=(ba|0)/4|0;if((a<<2|0)!=(ba|0)){Q=0;L=154;break a}I=RYb(c)|0;H=PYb(c)|0;if((((I|0)==-1|(H|0)<(I|0)?H:I)|0)>=(ba|0)){I=ca+a|0;if((f[r>>2]|0)<(I|0)?(uHa(r,I),H=f[r>>2]|0,Z=I-H|0,(Z<<2|0)>0):0)g1c((f[v>>2]|0)+((H<<2)+4)|0,0,(((Z|-1073741824|0)==-1073741824?1073741823:1073741822)+Z<<2)+8|0)|0;f[r>>2]=I;I=f[v>>2]|0;if(TYb(c,((I|0)==0?0:I+4|0)+(ca<<2)|0,ba)|0)continue a;else{L=66;break a}}if((ba|0)>3)da=0;else continue a;while(1){I=f[c>>2]|0;if(((f[g>>2]|0)-I|0)>3){Z=I;H=h[Z>>0]|h[Z+1>>0]<<8|h[Z+2>>0]<<16|h[Z+3>>0]<<24;f[e>>2]=H;f[c>>2]=I+4;ea=H}else{if(!(WYb(c,e)|0)){L=75;break a}ea=f[e>>2]|0}H=f[r>>2]|0;if((H|0)==(f[t>>2]|0)){uHa(r,H+1|0);fa=f[r>>2]|0}else fa=H;H=f[v>>2]|0;f[r>>2]=fa+1;f[H+4+(fa<<2)>>2]=ea;H=da+1|0;if((H|0)<(a|0))da=H;else continue a}break}case 7:{if((K&255|0)!=58){N=K;break b}f[i>>2]=f[i>>2]|2;a=f[w>>2]|0;if(!a){H=$Xc(32)|0;p0a(H);f[w>>2]=H;ga=H}else ga=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(H=b[a>>0]|0,H<<24>>24>-1):0){f[c>>2]=a+1;ha=H&255}else{H=YYb(c)|0;if((H|0)>-1)ha=H;else{Q=0;L=154;break a}}JYb(e,c,ha);if((f[x>>2]|0)<0){L=86;break a}if(!(Mi[f[(f[ga>>2]|0)+44>>2]&1023](ga,c)|0)){L=86;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{Q=0;L=154;break a}break}case 8:{switch((K&255)<<24>>24){case 66:break;case 65:{if(NUa(1,66,c,y)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}H=f[c>>2]|0;if(H>>>0<(f[g>>2]|0)>>>0?(a=b[H>>0]|0,a<<24>>24>-1):0){f[c>>2]=H+1;ia=a&255}else{a=YYb(c)|0;if((a|0)>-1)ia=a;else{Q=0;L=154;break a}}ja=f[y>>2]|0;a=(ia|0)/8|0;if((a<<3|0)!=(ia|0)){Q=0;L=154;break a}H=RYb(c)|0;I=PYb(c)|0;if((((H|0)==-1|(I|0)<(H|0)?I:H)|0)>=(ia|0)){H=ja+a|0;if((f[y>>2]|0)<(H|0)?(ZMa(y,H),I=f[y>>2]|0,Z=H-I|0,(Z<<3|0)>0):0)g1c((f[A>>2]|0)+((I<<3)+8)|0,0,(((Z|-536870912|0)==-536870912?536870911:536870910)+Z<<3)+16|0)|0;f[y>>2]=H;H=f[A>>2]|0;if(TYb(c,((H|0)==0?0:H+8|0)+(ja<<3)|0,ia)|0)continue a;else{L=100;break a}}if((ia|0)>7)ka=0;else continue a;while(1){H=f[c>>2]|0;if(((f[g>>2]|0)-H|0)>7){Z=H;I=Z;la=h[I>>0]|h[I+1>>0]<<8|h[I+2>>0]<<16|h[I+3>>0]<<24;I=Z+4|0;Z=h[I>>0]|h[I+1>>0]<<8|h[I+2>>0]<<16|h[I+3>>0]<<24;I=e;f[I>>2]=la;f[I+4>>2]=Z;f[c>>2]=H+8;f[s>>2]=la;f[s+4>>2]=Z;ma=+p[s>>3]}else{if(!(XYb(c,e)|0)){L=109;break a}ma=+p[e>>3]}Z=f[y>>2]|0;if((Z|0)==(f[z>>2]|0)){ZMa(y,Z+1|0);na=f[y>>2]|0}else na=Z;Z=f[A>>2]|0;f[y>>2]=na+1;p[Z+8+(na<<3)>>3]=ma;Z=ka+1|0;if((Z|0)<(a|0))ka=Z;else continue a}break}case 9:{switch((K&255)<<24>>24){case 74:break;case 73:{if(NUa(1,74,c,B)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Z=b[a>>0]|0,Z<<24>>24>-1):0){f[c>>2]=a+1;oa=Z&255}else{Z=YYb(c)|0;if((Z|0)>-1)oa=Z;else{Q=0;L=154;break a}}pa=f[B>>2]|0;Z=(oa|0)/8|0;if((Z<<3|0)!=(oa|0)){Q=0;L=154;break a}a=RYb(c)|0;la=PYb(c)|0;if((((a|0)==-1|(la|0)<(a|0)?la:a)|0)>=(oa|0)){a=pa+Z|0;if((f[B>>2]|0)<(a|0)?(ZMa(B,a),la=f[B>>2]|0,H=a-la|0,(H<<3|0)>0):0)g1c((f[D>>2]|0)+((la<<3)+8)|0,0,(((H|-536870912|0)==-536870912?536870911:536870910)+H<<3)+16|0)|0;f[B>>2]=a;a=f[D>>2]|0;if(TYb(c,((a|0)==0?0:a+8|0)+(pa<<3)|0,oa)|0)continue a;else{L=123;break a}}if((oa|0)>7)qa=0;else continue a;while(1){a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>7){H=a;la=H;I=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;la=H+4|0;H=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;la=e;f[la>>2]=I;f[la+4>>2]=H;f[c>>2]=a+8;f[s>>2]=I;f[s+4>>2]=H;ra=+p[s>>3]}else{if(!(XYb(c,e)|0)){L=132;break a}ra=+p[e>>3]}H=f[B>>2]|0;if((H|0)==(f[C>>2]|0)){ZMa(B,H+1|0);sa=f[B>>2]|0}else sa=H;H=f[D>>2]|0;f[B>>2]=sa+1;p[H+8+(sa<<3)>>3]=ra;H=qa+1|0;if((H|0)<(Z|0))qa=H;else continue a}break}case 10:{if((K&255|0)!=80){N=K;break b}Z=f[c>>2]|0;if(Z>>>0<(f[g>>2]|0)>>>0){H=b[Z>>0]|0;I=H&255;if(H<<24>>24>-1){f[c>>2]=Z+1;ta=I}else{ua=I;L=138}}else{ua=0;L=138}if((L|0)==138){L=0;I=KYb(c,ua)|0;Z=J;if((Z|0)>-1|(Z|0)==-1&I>>>0>4294967295)ta=I;else{Q=0;L=154;break a}}if(ta>>>0<5){f[i>>2]=f[i>>2]|64;f[E>>2]=ta;continue a}I=f[F>>2]|0;if(!(I&1))va=lSa(F)|0;else va=I&-2;yqc(va,10,ta,((ta|0)<0)<<31>>31);continue a;break}case 12:{if((K&255|0)!=98){N=K;break b}f[i>>2]=f[i>>2]|1;I=f[G>>2]|0;if((I|0)==537368){mHa(G,537368);wa=f[G>>2]|0}else wa=I;if(l$b(c,wa)|0)continue a;else{Q=0;L=154;break a}break}default:{N=K;break b}}while(0)}while(0);if(!N){Q=1;L=154;break}I=f[F>>2]|0;if(!(I&1))xa=lSa(F)|0;else xa=I&-2;if(!(Lqc(c,N,xa)|0)){Q=0;L=154;break}}switch(L|0){case 43:{if((f[n>>2]|0)<=0){Q=0;u=d;return Q|0}f[n>>2]=Y;Q=0;u=d;return Q|0}case 52:{Q=0;u=d;return Q|0}case 66:{if((f[r>>2]|0)<=0){Q=0;u=d;return Q|0}f[r>>2]=ca;Q=0;u=d;return Q|0}case 75:{Q=0;u=d;return Q|0}case 86:{Q=0;u=d;return Q|0}case 100:{if((f[y>>2]|0)<=0){Q=0;u=d;return Q|0}f[y>>2]=ja;Q=0;u=d;return Q|0}case 109:{Q=0;u=d;return Q|0}case 123:{if((f[B>>2]|0)<=0){Q=0;u=d;return Q|0}f[B>>2]=pa;Q=0;u=d;return Q|0}case 132:{Q=0;u=d;return Q|0}case 154:{u=d;return Q|0}}return 0}function g0a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+16>>2]<<2;if(!c)e=d;else{if((c|0)<0)g=10;else g=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;e=d+1+g|0}f[a+28>>2]=c;g=e+c|0;c=f[a+32>>2]<<2;if(!c)h=g;else{if((c|0)<0)i=10;else i=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;h=g+1+i|0}f[a+44>>2]=c;i=h+c|0;c=f[a+48>>2]<<3;if(!c)j=i;else{if((c|0)<0)k=11;else k=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+i|0}f[a+60>>2]=c;i=j+c|0;c=f[a+64>>2]<<3;if(!c)l=i;else{if((c|0)<0)m=11;else m=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;l=m+i|0}f[a+76>>2]=c;i=l+c|0;c=a+8|0;l=f[c>>2]|0;if(!(l&127)){n=i;o=a+12|0;f[o>>2]=n;return n|0}if(!(l&1))p=i;else{m=f[a+80>>2]|0;j=b[m+11>>0]|0;k=j<<24>>24<0?f[m+4>>2]|0:j&255;p=i+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(l&2)){q=p;r=l}else{l=f[a+84>>2]|0;k=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;l=p+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=l;r=f[c>>2]|0}if(!(r&4))s=q;else{c=f[a+88>>2]|0;if((c|0)<0)t=11;else t=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;s=t+q|0}if(!(r&8))u=s;else{q=f[a+92>>2]|0;if((q|0)<0)v=11;else v=((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;u=v+s|0}if(!(r&16))w=u;else{s=f[a+96>>2]|0;if((s|0)<0)x=11;else x=((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;w=x+u|0}if(!(r&32))y=w;else{u=f[a+100>>2]|0;if((u|0)<0)z=11;else z=((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;y=z+w|0}if(!(r&64)){n=y;o=a+12|0;f[o>>2]=n;return n|0}r=f[a+104>>2]|0;if((r|0)<0)A=11;else A=((((($(r|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=A+y|0;o=a+12|0;f[o>>2]=n;return n|0}function h0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[a+8>>2]|0;if(d&4|0)S_b(1,f[a+88>>2]|0,c);if(d&8|0)S_b(2,f[a+92>>2]|0,c);if(d&16|0)S_b(3,f[a+96>>2]|0,c);if(d&32|0)S_b(4,f[a+100>>2]|0,c);e=a+16|0;if((f[e>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){h=c+4|0;b[f[h>>2]>>0]=42;f[h>>2]=(f[h>>2]|0)+1;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;i=h}else{eZb(c,42);i=f[g>>2]|0}h=f[a+28>>2]|0;if((i|0)>4){i=c+4|0;j=f[i>>2]|0;if(h>>>0>127){k=h;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=h}b[o>>0]=p;p=o+1-j|0;f[i>>2]=(f[i>>2]|0)+p;f[g>>2]=(f[g>>2]|0)-p}else eZb(c,h);h=f[a+24>>2]|0;P_b((h|0)==0?0:h+4|0,f[e>>2]|0,c)}e=a+32|0;if((f[e>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){p=c+4|0;b[f[p>>2]>>0]=50;f[p>>2]=(f[p>>2]|0)+1;p=(f[h>>2]|0)+-1|0;f[h>>2]=p;q=p}else{eZb(c,50);q=f[h>>2]|0}p=f[a+44>>2]|0;if((q|0)>4){q=c+4|0;g=f[q>>2]|0;if(p>>>0>127){i=p;j=g;while(1){b[j>>0]=i|128;o=i>>>7;l=j+1|0;if(i>>>0>16383){i=o;j=l}else{r=l;s=o;break}}}else{r=g;s=p}b[r>>0]=s;s=r+1-g|0;f[q>>2]=(f[q>>2]|0)+s;f[h>>2]=(f[h>>2]|0)-s}else eZb(c,p);p=f[a+40>>2]|0;P_b((p|0)==0?0:p+4|0,f[e>>2]|0,c)}if(d&2|0)k$b(7,f[a+84>>2]|0,c);e=a+48|0;if((f[e>>2]|0)>0){p=c+8|0;if((f[p>>2]|0)>4){s=c+4|0;b[f[s>>2]>>0]=66;f[s>>2]=(f[s>>2]|0)+1;s=(f[p>>2]|0)+-1|0;f[p>>2]=s;t=s}else{eZb(c,66);t=f[p>>2]|0}s=f[a+60>>2]|0;if((t|0)>4){t=c+4|0;h=f[t>>2]|0;if(s>>>0>127){q=s;g=h;while(1){b[g>>0]=q|128;r=q>>>7;j=g+1|0;if(q>>>0>16383){q=r;g=j}else{u=j;v=r;break}}}else{u=h;v=s}b[u>>0]=v;v=u+1-h|0;f[t>>2]=(f[t>>2]|0)+v;f[p>>2]=(f[p>>2]|0)-v}else eZb(c,s);s=f[a+56>>2]|0;Q_b((s|0)==0?0:s+8|0,f[e>>2]|0,c)}e=a+64|0;if((f[e>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){v=c+4|0;b[f[v>>2]>>0]=74;f[v>>2]=(f[v>>2]|0)+1;v=(f[s>>2]|0)+-1|0;f[s>>2]=v;w=v}else{eZb(c,74);w=f[s>>2]|0}v=f[a+76>>2]|0;if((w|0)>4){w=c+4|0;p=f[w>>2]|0;if(v>>>0>127){t=v;h=p;while(1){b[h>>0]=t|128;u=t>>>7;g=h+1|0;if(t>>>0>16383){t=u;h=g}else{x=g;y=u;break}}}else{x=p;y=v}b[x>>0]=y;y=x+1-p|0;f[w>>2]=(f[w>>2]|0)+y;f[s>>2]=(f[s>>2]|0)-y}else eZb(c,v);v=f[a+72>>2]|0;Q_b((v|0)==0?0:v+8|0,f[e>>2]|0,c)}if(d&64|0)d$b(10,f[a+104>>2]|0,c);if(d&1|0)h$b(12,f[a+80>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function i0a(a){a=a|0;return f[a+12>>2]|0}function j0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+88>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&8))r=g;else{p=f[a+92>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=l1c(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&16))u=r;else{s=f[a+96>>2]|0;b[r>>0]=24;t=r+1|0;r=s&255;if(s>>>0>127){g=t;q=r;k=s;i=((s|0)<0)<<31>>31;while(1){b[g>>0]=q|-128;s=k;k=l1c(k|0,i|0,7)|0;d=g+1|0;m=k&255;if(!(i>>>0>0|(i|0)==0&s>>>0>16383)){v=d;w=m;break}else{g=d;q=m;i=J}}}else{v=t;w=r}b[v>>0]=w;u=v+1|0}if(!(e&32))x=u;else{v=f[a+100>>2]|0;b[u>>0]=32;w=u+1|0;u=v&255;if(v>>>0>127){r=w;t=u;i=v;q=((v|0)<0)<<31>>31;while(1){b[r>>0]=t|-128;v=i;i=l1c(i|0,q|0,7)|0;g=r+1|0;k=i&255;if(!(q>>>0>0|(q|0)==0&v>>>0>16383)){y=g;z=k;break}else{r=g;t=k;q=J}}}else{y=w;z=u}b[y>>0]=z;x=y+1|0}y=a+16|0;if((f[y>>2]|0)>0){b[x>>0]=42;z=x+1|0;u=f[a+28>>2]|0;if(u>>>0>127){w=u;q=z;while(1){b[q>>0]=w|128;t=w>>>7;r=q+1|0;if(w>>>0>16383){w=t;q=r}else{A=r;B=t;break}}}else{A=z;B=u}b[A>>0]=B;B=A+1|0;A=f[y>>2]<<2;o1c(B|0,(f[a+24>>2]|0)+4|0,A|0)|0;C=B+A|0}else C=x;x=a+32|0;if((f[x>>2]|0)>0){b[C>>0]=50;A=C+1|0;B=f[a+44>>2]|0;if(B>>>0>127){y=B;u=A;while(1){b[u>>0]=y|128;z=y>>>7;q=u+1|0;if(y>>>0>16383){y=z;u=q}else{D=q;E=z;break}}}else{D=A;E=B}b[D>>0]=E;E=D+1|0;D=f[x>>2]<<2;o1c(E|0,(f[a+40>>2]|0)+4|0,D|0)|0;F=E+D|0}else F=C;if(!(e&2))G=F;else{C=f[a+84>>2]|0;b[F>>0]=58;D=F+1|0;F=_i[f[(f[C>>2]|0)+60>>2]&2047](C)|0;if(F>>>0>127){E=F;x=D;while(1){b[x>>0]=E|128;B=E>>>7;A=x+1|0;if(E>>>0>16383){E=B;x=A}else{H=A;I=B;break}}}else{H=D;I=F}b[H>>0]=I;G=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,H+1|0)|0}H=a+48|0;if((f[H>>2]|0)>0){b[G>>0]=66;c=G+1|0;C=f[a+60>>2]|0;if(C>>>0>127){I=C;F=c;while(1){b[F>>0]=I|128;D=I>>>7;x=F+1|0;if(I>>>0>16383){I=D;F=x}else{K=x;L=D;break}}}else{K=c;L=C}b[K>>0]=L;L=K+1|0;K=f[H>>2]<<3;o1c(L|0,(f[a+56>>2]|0)+8|0,K|0)|0;M=L+K|0}else M=G;G=a+64|0;if((f[G>>2]|0)>0){b[M>>0]=74;K=M+1|0;L=f[a+76>>2]|0;if(L>>>0>127){H=L;C=K;while(1){b[C>>0]=H|128;c=H>>>7;F=C+1|0;if(H>>>0>16383){H=c;C=F}else{N=F;O=c;break}}}else{N=K;O=L}b[N>>0]=O;O=N+1|0;N=f[G>>2]<<3;o1c(O|0,(f[a+72>>2]|0)+8|0,N|0)|0;P=O+N|0}else P=M;if(!(e&64))Q=P;else{M=f[a+104>>2]|0;b[P>>0]=80;N=P+1|0;P=M&255;if(M>>>0>127){O=N;G=P;L=M;K=((M|0)<0)<<31>>31;while(1){b[O>>0]=G|-128;M=L;L=l1c(L|0,K|0,7)|0;C=O+1|0;H=L&255;if(!(K>>>0>0|(K|0)==0&M>>>0>16383)){R=C;S=H;break}else{O=C;G=H;K=J}}}else{R=N;S=P}b[R>>0]=S;Q=R+1|0}if(!(e&1))T=Q;else{e=f[a+80>>2]|0;b[Q>>0]=98;T=gZb(e,Q+1|0)|0}Q=f[a+4>>2]|0;if(!(Q&1)){U=T;return U|0}U=Pqc(Q&-2,T)|0;return U|0}function k0a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;d0a(a);c=kZc(b,21568,15808,0)|0;if(!c){Ooc(b,a);return}else{o0a(a,c);return}}function l0a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15808,0)|0;if(!c){Ooc(b,a);return}else{o0a(a,c);return}}function m0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function n0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535256;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function o0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){uHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+32|0;d=b+32|0;e=f[d>>2]|0;if(e|0){uHa(g,(f[g>>2]|0)+e|0);o1c((f[a+40>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+48|0;g=b+48|0;e=f[g>>2]|0;if(e|0){ZMa(d,(f[d>>2]|0)+e|0);o1c((f[a+56>>2]|0)+8+(f[d>>2]<<3)|0,(f[b+56>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+64|0;d=b+64|0;e=f[d>>2]|0;if(e|0){ZMa(g,(f[g>>2]|0)+e|0);o1c((f[a+72>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+72>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=f[b+8>>2]|0;if(!(d&127))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+80|0,e=f[b+80>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);if(d&2|0){e=a+8|0;f[e>>2]=f[e>>2]|2;e=a+84|0;c=f[e>>2]|0;if(!c){g=$Xc(32)|0;p0a(g);f[e>>2]=g;h=g}else h=c;c=f[b+84>>2]|0;g=c|0?c:531296;c=h+4|0;e=f[g+4>>2]|0;if(e&1|0){i=f[c>>2]|0;if(!(i&1))j=lSa(c)|0;else j=i&-2;vqc(j,e&-2)}e=h+16|0;j=g+16|0;i=f[j>>2]|0;if(i|0){_Ma(e,(f[e>>2]|0)+i|0);o1c((f[h+24>>2]|0)+8+(f[e>>2]<<3)|0,(f[g+24>>2]|0)+8|0,f[j>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[j>>2]|0)}}if(d&4|0)f[a+88>>2]=f[b+88>>2];if(d&8|0)f[a+92>>2]=f[b+92>>2];if(d&16|0)f[a+96>>2]=f[b+96>>2];if(d&32|0)f[a+100>>2]=f[b+100>>2];if(d&64|0)f[a+104>>2]=f[b+104>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function p0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=90488;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=531296?(f[223073]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=23;b[d+8>>0]=0;J_b(892292,d);a_b(d)}f[a+12>>2]=0;u=c;return}function q0a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function r0a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=92380;e=(a|0)==534768;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223138]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=88;b[d+8>>0]=0;J_b(892552,d);a_b(d)}f[a+56>>2]=537368;f[a+60>>2]=537368;f[a+64>>2]=537368;f[a+68>>2]=537368;f[a+72>>2]=535232;g=a+76|0;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[a+140>>2]=1;b[a+144>>0]=1;f[a+148>>2]=1;f[a+152>>2]=1;n[a+156>>2]=.5;f[a+160>>2]=5;n[a+164>>2]=1.0;n[a+168>>2]=.75;n[a+172>>2]=1.0;n[a+176>>2]=1.0;n[a+180>>2]=.5;n[a+184>>2]=.5;n[a+188>>2]=.25;f[a+192>>2]=0;u=c;return}function s0a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function t0a(a){a=a|0;var c=0;c=f[a+56>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+60>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+64>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+68>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+72>>2]|0;if(!((c|0)==535232|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==534768)return;c=f[a+76>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+80>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+84>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function u0a(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function v0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function w0a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=92704;Kab(a);c=f[a+156>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+144|0;d=f[c>>2]|0;if(d|0?(f[a+132>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=f[a+128>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+116|0;i=f[c>>2]|0;if(i|0?(f[a+104>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+100|0;j=f[c>>2]|0;if(j|0?(f[a+88>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=f[a+84>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=f[a+72>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+60|0;k=f[c>>2]|0;if(k|0?(f[a+48>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;cYc(l)}f[c>>2]=0;c=a+44|0;l=f[c>>2]|0;if(l|0?(f[a+32>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;cYc(m)}f[c>>2]=0;c=a+28|0;m=f[c>>2]|0;if(m|0?(f[a+16>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0){if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(j)}k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;cYc(n)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}n=a&-2;a=n;if((n|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(n);f[c>>2]=0;return}function x0a(a){a=a|0;w0a(a);cYc(a);return}function y0a(a){a=a|0;a=$Xc(296)|0;Iab(a);return a|0}function z0a(a,b){a=a|0;b=b|0;a=$Xc(296)|0;Iab(a);if(!b)return a|0;Jab(b,a);return a|0}function A0a(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+20|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((h|0)!=(e|0));f[c>>2]=0}c=a+36|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+44>>2]|0;g=0;do{j=f[h+4+(g<<2)>>2]|0;g=g+1|0;i=j+11|0;if((b[i>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0}else{b[j>>0]=0;b[i>>0]=0}}while((g|0)!=(e|0));f[c>>2]=0}c=a+52|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+60>>2]|0;h=0;do{d0a(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[c>>2]=0}f[a+64>>2]=0;f[a+76>>2]=0;c=a+92|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+100>>2]|0;g=0;do{vab(f[h+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(e|0));f[c>>2]=0}c=a+108|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+116>>2]|0;h=0;do{vab(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[c>>2]=0}f[a+120>>2]=0;c=a+136|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+144>>2]|0;g=0;do{i=f[h+4+(g<<2)>>2]|0;g=g+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((g|0)!=(e|0));f[c>>2]=0}f[a+148>>2]=0;c=a+8|0;e=f[c>>2]|0;if(e&255|0){do if(e&1|0){g=f[a+160>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&2|0)w$a(f[a+164>>2]|0);if(e&4|0){h=f[a+168>>2]|0;g=h+8|0;if(f[g>>2]&3|0){f[h+16>>2]=1;f[h+20>>2]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&8|0)O9a(f[a+172>>2]|0);if(e&16|0){h=f[a+176>>2]|0;g=h+8|0;j=f[g>>2]|0;do if(j&3|0){do if(j&1|0){i=f[h+16>>2]|0;k=i+11|0;if((b[k>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[k>>0]=0;break}}while(0);if(j&2|0){k=f[h+20>>2]|0;i=k+11|0;if((b[i>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[i>>0]=0;break}}}while(0);if(j&252|0){i=h+24|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0}if(j&768|0){n[h+44>>2]=1.0;f[h+48>>2]=4}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&32|0){h=f[a+180>>2]|0;g=h+8|0;if(f[g>>2]&3|0){n[h+16>>2]=.5;b[h+20>>0]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&64|0){h=f[a+184>>2]|0;g=h+8|0;j=f[g>>2]|0;do if(j&1|0){i=f[h+16>>2]|0;k=i+11|0;if((b[k>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[k>>0]=0;break}}while(0);if(j&6|0){j=h+20|0;f[j>>2]=0;b[j+4>>0]=0}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&128|0){h=f[a+188>>2]|0;g=h+8|0;do if(f[g>>2]&1|0){j=f[h+16>>2]|0;k=j+11|0;if((b[k>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[k>>0]=0;break}}while(0);f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}}if(e&65280|0){if(e&256|0)D8a(f[a+192>>2]|0);if(e&512|0){h=f[a+196>>2]|0;g=h+8|0;do if(f[g>>2]&1|0){k=f[h+16>>2]|0;j=k+11|0;if((b[j>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[j>>0]=0;break}}while(0);f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&1024|0)Z7a(f[a+200>>2]|0);if(e&2048|0){h=f[a+204>>2]|0;g=h+8|0;if(f[g>>2]&63|0){j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[h+24>>2]=5;n[h+28>>2]=1.0;n[h+32>>2]=.75;n[h+36>>2]=1.0}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&4096|0){h=f[a+208>>2]|0;g=h+8|0;j=f[g>>2]|0;if(j&255|0){k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0}if(j&7936|0){j=h+48|0;f[j>>2]=0;f[j+4>>2]=0;b[j+8>>0]=0;f[h+60>>2]=1;b[h+64>>0]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&8192|0)c7a(f[a+212>>2]|0);if(e&16384|0){h=f[a+216>>2]|0;g=h+8|0;if(f[g>>2]&7|0){n[h+16>>2]=0.0;n[h+20>>2]=1.0;n[h+24>>2]=1.0}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&32768|0){h=f[a+220>>2]|0;g=h+8|0;if(f[g>>2]&15|0){j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}}do if(e&16711680|0){if(e&65536|0){h=f[a+224>>2]|0;g=h+8|0;if(f[g>>2]&7|0){j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[h+24>>2]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&131072|0){h=f[a+228>>2]|0;f[h+16>>2]=0;g=h+8|0;if(f[g>>2]&3|0){f[h+28>>2]=1;b[h+32>>0]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if((e&262144|0?(h=f[a+232>>2]|0,n[h+16>>2]=0.0,f[h+8>>2]=0,g=f[h+4>>2]|0,g&1|0):0)?(h=g&-2,f[h>>2]|0):0)sqc(h);if(e&524288|0)n5a(f[a+236>>2]|0);if(e&1048576|0){h=f[a+240>>2]|0;g=h+8|0;if(f[g>>2]&7|0){f[h+16>>2]=0;f[h+20>>2]=1;f[h+24>>2]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if((e&2097152|0?(h=f[a+244>>2]|0,f[h+16>>2]=1,f[h+8>>2]=0,g=f[h+4>>2]|0,g&1|0):0)?(h=g&-2,f[h>>2]|0):0)sqc(h);do if(e&4194304|0){h=f[a+248>>2]|0;g=h+8|0;if(f[g>>2]&3|0){j=h+16|0;f[j>>2]=0;f[j+4>>2]=0}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0){h=g&-2;if(!(f[h>>2]|0))break;sqc(h)}}while(0);if(e&8388608|0){h=f[a+252>>2]|0;f[h+16>>2]=0;g=h+8|0;if(f[g>>2]&3|0){f[h+28>>2]=1;f[h+32>>2]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0){h=g&-2;if(!(f[h>>2]|0))break;sqc(h)}}}while(0);do if(e>>>0>16777215){if(e&16777216|0){h=f[a+256>>2]|0;g=h+8|0;if(f[g>>2]&7|0){b[h+16>>0]=0;b[h+17>>0]=1;n[h+20>>2]=9.999999717180685e-10}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&33554432|0){h=f[a+260>>2]|0;f[h+16>>2]=0;g=h+8|0;j=f[g>>2]|0;do if(j&1|0){k=f[h+28>>2]|0;i=k+11|0;if((b[i>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[i>>0]=0;break}}while(0);if(j&62|0){i=h+32|0;f[i>>2]=0;d[i+4>>1]=0;b[i+6>>0]=0;n[h+40>>2]=1.0}f[g>>2]=0;i=f[h+4>>2]|0;if(i&1|0?(k=i&-2,f[k>>2]|0):0)sqc(k)}if((e&67108864|0?(k=f[a+264>>2]|0,f[k+16>>2]=0,f[k+8>>2]=0,i=f[k+4>>2]|0,i&1|0):0)?(k=i&-2,f[k>>2]|0):0)sqc(k);if((e&134217728|0?(k=f[a+268>>2]|0,f[k+16>>2]=0,f[k+8>>2]=0,i=f[k+4>>2]|0,i&1|0):0)?(k=i&-2,f[k>>2]|0):0)sqc(k);if(e&268435456|0){k=f[a+272>>2]|0;i=k+8|0;if(f[i>>2]&3|0){f[k+16>>2]=0;f[k+20>>2]=1}f[i>>2]=0;i=f[k+4>>2]|0;if(i&1|0?(k=i&-2,f[k>>2]|0):0)sqc(k)}do if(e&536870912|0){k=f[a+276>>2]|0;i=k+8|0;if(f[i>>2]&3|0){b[k+16>>0]=0;n[k+20>>2]=1.0}f[i>>2]=0;i=f[k+4>>2]|0;if(i&1|0){k=i&-2;if(!(f[k>>2]|0))break;sqc(k)}}while(0);do if(e&1073741824|0){h=f[a+280>>2]|0;g=h+8|0;if(f[g>>2]&7|0){n[h+16>>2]=0.0;n[h+20>>2]=-1.0;n[h+24>>2]=1.0}f[g>>2]=0;g=f[h+4>>2]|0;if(!(g&1))break;h=g&-2;if(!(f[h>>2]|0))break;sqc(h)}while(0);if((e|0)<0){h=f[a+284>>2]|0;g=h+8|0;if(f[g>>2]&7|0){j=h+16|0;f[j>>2]=0;b[j+4>>0]=0;f[h+24>>2]=1}f[g>>2]=0;g=f[h+4>>2]|0;if(!(g&1))break;h=g&-2;if(!(f[h>>2]|0))break;sqc(h)}}while(0);f[a+288>>2]=0;e=c;f[e>>2]=0;f[e+4>>2]=0;e=f[a+4>>2]|0;if(!(e&1))return;a=e&-2;if(!(f[a>>2]|0))return;sqc(a);return}function B0a(a){a=a|0;return 1}function C0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+164|0;k=e+4|0;l=a+16|0;m=a+32|0;n=a+160|0;o=a+12|0;p=a+288|0;q=a+4|0;r=a+48|0;s=e+4|0;t=a+64|0;v=a+68|0;w=a+72|0;x=a+76|0;y=a+80|0;z=a+84|0;A=a+168|0;B=e+4|0;C=a+172|0;D=e+4|0;E=a+176|0;F=e+4|0;G=a+180|0;H=e+4|0;I=a+184|0;K=e+4|0;L=a+188|0;M=e+4|0;N=a+192|0;O=e+4|0;P=a+196|0;Q=e+4|0;R=a+200|0;S=e+4|0;T=a+204|0;U=e+4|0;V=a+208|0;W=e+4|0;X=a+212|0;Y=e+4|0;Z=a+216|0;_=e+4|0;$=a+220|0;aa=e+4|0;ba=a+224|0;ca=e+4|0;da=a+228|0;ea=e+4|0;fa=a+232|0;ga=e+4|0;ha=a+236|0;ia=e+4|0;ja=a+240|0;ka=e+4|0;la=a+244|0;ma=e+4|0;na=a+248|0;oa=e+4|0;pa=a+252|0;qa=e+4|0;ra=a+88|0;sa=e+4|0;ta=a+104|0;ua=e+4|0;va=a+256|0;wa=e+4|0;xa=a+120|0;ya=a+124|0;za=a+128|0;Aa=a+260|0;Ba=e+4|0;Ca=a+264|0;Da=e+4|0;Ea=a+268|0;Fa=e+4|0;Ga=a+272|0;Ha=e+4|0;Ia=a+276|0;Ja=e+4|0;Ka=a+280|0;La=e+4|0;Ma=a+284|0;Na=e+4|0;Oa=a+132|0;Pa=a+148|0;Qa=a+152|0;Ra=a+156|0;a:while(1){a=f[c>>2]|0;Sa=f[g>>2]|0;do if(a>>>0<Sa>>>0){Ta=b[a>>0]|0;Ua=Ta&255;Va=a+1|0;if(Ta<<24>>24>0){Wa=Va;Xa=Ua}else{if(Va>>>0>=Sa>>>0){Ya=Ua;Za=7;break}Ta=h[Va>>0]|0;if(((Ta^128)&Ua)>>>0<=127){Ya=Ua;Za=7;break}Wa=a+2|0;Xa=Ua+-128+(Ta<<7)|0}f[c>>2]=Wa;_a=Xa;Za=9}else{Ya=0;Za=7}while(0);if((Za|0)==7){Za=0;a=ZYb(c,Ya)|0;if((a+-1|0)>>>0<16383){_a=a;Za=9}else $a=a}b:do if((Za|0)==9){Za=0;do switch(_a>>>3&536870911|0){case 1:{if((_a&255|0)!=10){$a=_a;break b}f[i>>2]=f[i>>2]|2;a=f[j>>2]|0;if(!a){Sa=$Xc(196)|0;r0a(Sa);f[j>>2]=Sa;ab=Sa}else ab=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Sa=b[a>>0]|0,Sa<<24>>24>-1):0){f[c>>2]=a+1;bb=Sa&255}else{Sa=YYb(c)|0;if((Sa|0)>-1)bb=Sa;else{cb=0;Za=473;break a}}JYb(e,c,bb);if((f[k>>2]|0)<0){Za=19;break a}if(!(Mi[f[(f[ab>>2]|0)+44>>2]&1023](ab,c)|0)){Za=19;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 2:{if((_a&255|0)!=18){$a=_a;break b}if(l$b(c,pHa(l)|0)|0)continue a;else{cb=0;Za=473;break a}break}case 3:{if((_a&255|0)!=26){$a=_a;break b}if(l$b(c,pHa(m)|0)|0)continue a;else{cb=0;Za=473;break a}break}case 4:{if((_a&255|0)!=34){$a=_a;break b}f[i>>2]=f[i>>2]|1;Sa=f[n>>2]|0;if((Sa|0)==537368){mHa(n,537368);db=f[n>>2]|0}else db=Sa;if(l$b(c,db)|0)continue a;else{cb=0;Za=473;break a}break}case 5:{if((_a&255|0)!=40){$a=_a;break b}Sa=f[c>>2]|0;if(Sa>>>0<(f[g>>2]|0)>>>0){a=b[Sa>>0]|0;Ta=a&255;if(a<<24>>24>-1){f[c>>2]=Sa+1;eb=Ta}else{fb=Ta;Za=33}}else{fb=0;Za=33}if((Za|0)==33){Za=0;Ta=KYb(c,fb)|0;Sa=J;if((Sa|0)>-1|(Sa|0)==-1&Ta>>>0>4294967295)eb=Ta;else{cb=0;Za=473;break a}}if(eb>>>0<40){f[o>>2]=f[o>>2]|1;f[p>>2]=eb;continue a}Ta=f[q>>2]|0;if(!(Ta&1))gb=lSa(q)|0;else gb=Ta&-2;yqc(gb,5,eb,((eb|0)<0)<<31>>31);continue a;break}case 6:{if((_a&255|0)!=50){$a=_a;break b}Ta=Z$a(r)|0;Sa=f[c>>2]|0;if(Sa>>>0<(f[g>>2]|0)>>>0?(a=b[Sa>>0]|0,a<<24>>24>-1):0){f[c>>2]=Sa+1;hb=a&255}else{a=YYb(c)|0;if((a|0)>-1)hb=a;else{cb=0;Za=473;break a}}JYb(e,c,hb);if((f[s>>2]|0)<0){Za=47;break a}if(!(Mi[f[(f[Ta>>2]|0)+44>>2]&1023](Ta,c)|0)){Za=47;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 7:{switch((_a&255)<<24>>24){case 61:break;case 58:{if(_Za(c,t)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}Ta=f[c>>2]|0;if(((f[g>>2]|0)-Ta|0)>3){a=Ta;Sa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=Sa;f[c>>2]=Ta+4;ib=Sa}else{if(!(WYb(c,e)|0)){Za=64;break a}ib=f[e>>2]|0}Sa=f[t>>2]|0;if((Sa|0)==(f[v>>2]|0)){uHa(t,Sa+1|0);jb=f[t>>2]|0}else jb=Sa;Sa=f[w>>2]|0;Ta=jb+1|0;f[t>>2]=Ta;f[Sa+4+(jb<<2)>>2]=ib;a=f[c>>2]|0;Ua=(f[g>>2]|0)-a|0;if((Ua|0)<=0)continue a;Va=a;a=(f[v>>2]|0)-Ta|0;kb=(Ua>>>0)/5|0;lb=(kb|0)<(a|0)?kb:a;if((lb|0)>0){mb=0;nb=Va;ob=Ta}else continue a;while(1){if((b[nb>>0]|0)!=61){pb=mb;break}Ta=nb+1|0;a=h[Ta>>0]|h[Ta+1>>0]<<8|h[Ta+2>>0]<<16|h[Ta+3>>0]<<24;Ta=ob;ob=ob+1|0;f[t>>2]=ob;f[Sa+4+(Ta<<2)>>2]=a;a=mb+1|0;if((a|0)>=(lb|0)){pb=a;break}else{mb=a;nb=nb+5|0}}lb=pb*5|0;if((pb|0)<=0)continue a;if((Ua|0)<(lb|0)){SYb(c,lb,Ua)|0;continue a}else{f[c>>2]=Va+lb;continue a}break}case 8:{switch((_a&255)<<24>>24){case 69:break;case 66:{if(_Za(c,x)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}lb=f[c>>2]|0;if(((f[g>>2]|0)-lb|0)>3){Sa=lb;a=h[Sa>>0]|h[Sa+1>>0]<<8|h[Sa+2>>0]<<16|h[Sa+3>>0]<<24;f[e>>2]=a;f[c>>2]=lb+4;qb=a}else{if(!(WYb(c,e)|0)){Za=81;break a}qb=f[e>>2]|0}a=f[x>>2]|0;if((a|0)==(f[y>>2]|0)){uHa(x,a+1|0);rb=f[x>>2]|0}else rb=a;a=f[z>>2]|0;lb=rb+1|0;f[x>>2]=lb;f[a+4+(rb<<2)>>2]=qb;Sa=f[c>>2]|0;Ta=(f[g>>2]|0)-Sa|0;if((Ta|0)<=0)continue a;kb=Sa;Sa=(f[y>>2]|0)-lb|0;sb=(Ta>>>0)/5|0;tb=(sb|0)<(Sa|0)?sb:Sa;if((tb|0)>0){ub=0;vb=kb;wb=lb}else continue a;while(1){if((b[vb>>0]|0)!=69){xb=ub;break}lb=vb+1|0;Sa=h[lb>>0]|h[lb+1>>0]<<8|h[lb+2>>0]<<16|h[lb+3>>0]<<24;lb=wb;wb=wb+1|0;f[x>>2]=wb;f[a+4+(lb<<2)>>2]=Sa;Sa=ub+1|0;if((Sa|0)>=(tb|0)){xb=Sa;break}else{ub=Sa;vb=vb+5|0}}tb=xb*5|0;if((xb|0)<=0)continue a;if((Ta|0)<(tb|0)){SYb(c,tb,Ta)|0;continue a}else{f[c>>2]=kb+tb;continue a}break}case 9:{if((_a&255|0)!=74){$a=_a;break b}f[i>>2]=f[i>>2]|4;tb=f[A>>2]|0;if(!tb){a=$Xc(24)|0;N0a(a);f[A>>2]=a;yb=a}else yb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;zb=a&255}else{a=YYb(c)|0;if((a|0)>-1)zb=a;else{cb=0;Za=473;break a}}JYb(e,c,zb);if((f[B>>2]|0)<0){Za=92;break a}if(!(Mi[f[(f[yb>>2]|0)+44>>2]&1023](yb,c)|0)){Za=92;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 10:{if((_a&255|0)!=82){$a=_a;break b}f[i>>2]=f[i>>2]|8;a=f[C>>2]|0;if(!a){tb=$Xc(120)|0;O0a(tb);f[C>>2]=tb;Ab=tb}else Ab=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Bb=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)Bb=tb;else{cb=0;Za=473;break a}}JYb(e,c,Bb);if((f[D>>2]|0)<0){Za=103;break a}if(!(Mi[f[(f[Ab>>2]|0)+44>>2]&1023](Ab,c)|0)){Za=103;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 11:{if((_a&255|0)!=90){$a=_a;break b}f[i>>2]=f[i>>2]|16;tb=f[E>>2]|0;if(!tb){a=$Xc(52)|0;Q0a(a);f[E>>2]=a;Cb=a}else Cb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Db=a&255}else{a=YYb(c)|0;if((a|0)>-1)Db=a;else{cb=0;Za=473;break a}}JYb(e,c,Db);if((f[F>>2]|0)<0){Za=114;break a}if(!(Mi[f[(f[Cb>>2]|0)+44>>2]&1023](Cb,c)|0)){Za=114;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 12:{if((_a&255|0)!=98){$a=_a;break b}f[i>>2]=f[i>>2]|32;a=f[G>>2]|0;if(!a){tb=$Xc(24)|0;S0a(tb);f[G>>2]=tb;Eb=tb}else Eb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Fb=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)Fb=tb;else{cb=0;Za=473;break a}}JYb(e,c,Fb);if((f[H>>2]|0)<0){Za=125;break a}if(!(Mi[f[(f[Eb>>2]|0)+44>>2]&1023](Eb,c)|0)){Za=125;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 13:{if((_a&255|0)!=106){$a=_a;break b}f[i>>2]=f[i>>2]|64;tb=f[I>>2]|0;if(!tb){a=$Xc(28)|0;T0a(a);f[I>>2]=a;Gb=a}else Gb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Hb=a&255}else{a=YYb(c)|0;if((a|0)>-1)Hb=a;else{cb=0;Za=473;break a}}JYb(e,c,Hb);if((f[K>>2]|0)<0){Za=136;break a}if(!(Mi[f[(f[Gb>>2]|0)+44>>2]&1023](Gb,c)|0)){Za=136;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 14:{if((_a&255|0)!=114){$a=_a;break b}f[i>>2]=f[i>>2]|128;a=f[L>>2]|0;if(!a){tb=$Xc(20)|0;I$a(tb);f[L>>2]=tb;Ib=tb}else Ib=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Jb=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)Jb=tb;else{cb=0;Za=473;break a}}JYb(e,c,Jb);if((f[M>>2]|0)<0){Za=147;break a}if(!(Mi[f[(f[Ib>>2]|0)+44>>2]&1023](Ib,c)|0)){Za=147;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 15:{if((_a&255|0)!=122){$a=_a;break b}f[i>>2]=f[i>>2]|256;tb=f[N>>2]|0;if(!tb){a=$Xc(60)|0;V0a(a);f[N>>2]=a;Kb=a}else Kb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Lb=a&255}else{a=YYb(c)|0;if((a|0)>-1)Lb=a;else{cb=0;Za=473;break a}}JYb(e,c,Lb);if((f[O>>2]|0)<0){Za=158;break a}if(!(Mi[f[(f[Kb>>2]|0)+44>>2]&1023](Kb,c)|0)){Za=158;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 16:{if((_a&255|0)!=130){$a=_a;break b}f[i>>2]=f[i>>2]|512;a=f[P>>2]|0;if(!a){tb=$Xc(20)|0;X0a(tb);f[P>>2]=tb;Mb=tb}else Mb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Nb=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)Nb=tb;else{cb=0;Za=473;break a}}JYb(e,c,Nb);if((f[Q>>2]|0)<0){Za=169;break a}if(!(Mi[f[(f[Mb>>2]|0)+44>>2]&1023](Mb,c)|0)){Za=169;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 17:{if((_a&255|0)!=138){$a=_a;break b}f[i>>2]=f[i>>2]|1024;tb=f[R>>2]|0;if(!tb){a=$Xc(36)|0;Y0a(a);f[R>>2]=a;Ob=a}else Ob=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Pb=a&255}else{a=YYb(c)|0;if((a|0)>-1)Pb=a;else{cb=0;Za=473;break a}}JYb(e,c,Pb);if((f[S>>2]|0)<0){Za=180;break a}if(!(Mi[f[(f[Ob>>2]|0)+44>>2]&1023](Ob,c)|0)){Za=180;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 18:{if((_a&255|0)!=146){$a=_a;break b}f[i>>2]=f[i>>2]|2048;a=f[T>>2]|0;if(!a){tb=$Xc(40)|0;_0a(tb);f[T>>2]=tb;Qb=tb}else Qb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Rb=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)Rb=tb;else{cb=0;Za=473;break a}}JYb(e,c,Rb);if((f[U>>2]|0)<0){Za=191;break a}if(!(Mi[f[(f[Qb>>2]|0)+44>>2]&1023](Qb,c)|0)){Za=191;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 19:{if((_a&255|0)!=154){$a=_a;break b}f[i>>2]=f[i>>2]|4096;tb=f[V>>2]|0;if(!tb){a=$Xc(68)|0;a1a(a);f[V>>2]=a;Sb=a}else Sb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Tb=a&255}else{a=YYb(c)|0;if((a|0)>-1)Tb=a;else{cb=0;Za=473;break a}}JYb(e,c,Tb);if((f[W>>2]|0)<0){Za=202;break a}if(!(Mi[f[(f[Sb>>2]|0)+44>>2]&1023](Sb,c)|0)){Za=202;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 20:{if((_a&255|0)!=162){$a=_a;break b}f[i>>2]=f[i>>2]|8192;a=f[X>>2]|0;if(!a){tb=$Xc(64)|0;c1a(tb);f[X>>2]=tb;Ub=tb}else Ub=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Vb=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)Vb=tb;else{cb=0;Za=473;break a}}JYb(e,c,Vb);if((f[Y>>2]|0)<0){Za=213;break a}if(!(Mi[f[(f[Ub>>2]|0)+44>>2]&1023](Ub,c)|0)){Za=213;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 21:{if((_a&255|0)!=170){$a=_a;break b}f[i>>2]=f[i>>2]|16384;tb=f[Z>>2]|0;if(!tb){a=$Xc(28)|0;e1a(a);f[Z>>2]=a;Wb=a}else Wb=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;Xb=a&255}else{a=YYb(c)|0;if((a|0)>-1)Xb=a;else{cb=0;Za=473;break a}}JYb(e,c,Xb);if((f[_>>2]|0)<0){Za=224;break a}if(!(Mi[f[(f[Wb>>2]|0)+44>>2]&1023](Wb,c)|0)){Za=224;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 22:{if((_a&255|0)!=178){$a=_a;break b}f[i>>2]=f[i>>2]|32768;a=f[$>>2]|0;if(!a){tb=$Xc(32)|0;f1a(tb);f[$>>2]=tb;Yb=tb}else Yb=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;Zb=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)Zb=tb;else{cb=0;Za=473;break a}}JYb(e,c,Zb);if((f[aa>>2]|0)<0){Za=235;break a}if(!(Mi[f[(f[Yb>>2]|0)+44>>2]&1023](Yb,c)|0)){Za=235;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 23:{if((_a&255|0)!=186){$a=_a;break b}f[i>>2]=f[i>>2]|65536;tb=f[ba>>2]|0;if(!tb){a=$Xc(28)|0;g1a(a);f[ba>>2]=a;_b=a}else _b=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;$b=a&255}else{a=YYb(c)|0;if((a|0)>-1)$b=a;else{cb=0;Za=473;break a}}JYb(e,c,$b);if((f[ca>>2]|0)<0){Za=246;break a}if(!(Mi[f[(f[_b>>2]|0)+44>>2]&1023](_b,c)|0)){Za=246;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 24:{if((_a&255|0)!=194){$a=_a;break b}f[i>>2]=f[i>>2]|131072;a=f[da>>2]|0;if(!a){tb=$Xc(36)|0;h1a(tb);f[da>>2]=tb;ac=tb}else ac=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;bc=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)bc=tb;else{cb=0;Za=473;break a}}JYb(e,c,bc);if((f[ea>>2]|0)<0){Za=257;break a}if(!(Mi[f[(f[ac>>2]|0)+44>>2]&1023](ac,c)|0)){Za=257;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 25:{if((_a&255|0)!=202){$a=_a;break b}f[i>>2]=f[i>>2]|262144;tb=f[fa>>2]|0;if(!tb){a=$Xc(20)|0;j1a(a);f[fa>>2]=a;cc=a}else cc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;dc=a&255}else{a=YYb(c)|0;if((a|0)>-1)dc=a;else{cb=0;Za=473;break a}}JYb(e,c,dc);if((f[ga>>2]|0)<0){Za=268;break a}if(!(Mi[f[(f[cc>>2]|0)+44>>2]&1023](cc,c)|0)){Za=268;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 26:{if((_a&255|0)!=210){$a=_a;break b}f[i>>2]=f[i>>2]|524288;a=f[ha>>2]|0;if(!a){tb=$Xc(96)|0;k1a(tb);f[ha>>2]=tb;ec=tb}else ec=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;fc=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)fc=tb;else{cb=0;Za=473;break a}}JYb(e,c,fc);if((f[ia>>2]|0)<0){Za=279;break a}if(!(Mi[f[(f[ec>>2]|0)+44>>2]&1023](ec,c)|0)){Za=279;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 27:{if((_a&255|0)!=218){$a=_a;break b}f[i>>2]=f[i>>2]|1048576;tb=f[ja>>2]|0;if(!tb){a=$Xc(28)|0;m1a(a);f[ja>>2]=a;gc=a}else gc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;hc=a&255}else{a=YYb(c)|0;if((a|0)>-1)hc=a;else{cb=0;Za=473;break a}}JYb(e,c,hc);if((f[ka>>2]|0)<0){Za=290;break a}if(!(Mi[f[(f[gc>>2]|0)+44>>2]&1023](gc,c)|0)){Za=290;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 29:{if((_a&255|0)!=234){$a=_a;break b}f[i>>2]=f[i>>2]|2097152;a=f[la>>2]|0;if(!a){tb=$Xc(20)|0;n1a(tb);f[la>>2]=tb;ic=tb}else ic=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;jc=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)jc=tb;else{cb=0;Za=473;break a}}JYb(e,c,jc);if((f[ma>>2]|0)<0){Za=301;break a}if(!(Mi[f[(f[ic>>2]|0)+44>>2]&1023](ic,c)|0)){Za=301;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 30:{if((_a&255|0)!=242){$a=_a;break b}f[i>>2]=f[i>>2]|4194304;tb=f[na>>2]|0;if(!tb){a=$Xc(24)|0;o1a(a);f[na>>2]=a;kc=a}else kc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;lc=a&255}else{a=YYb(c)|0;if((a|0)>-1)lc=a;else{cb=0;Za=473;break a}}JYb(e,c,lc);if((f[oa>>2]|0)<0){Za=312;break a}if(!(Mi[f[(f[kc>>2]|0)+44>>2]&1023](kc,c)|0)){Za=312;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 31:{if((_a&255|0)!=250){$a=_a;break b}f[i>>2]=f[i>>2]|8388608;a=f[pa>>2]|0;if(!a){tb=$Xc(36)|0;p1a(tb);f[pa>>2]=tb;mc=tb}else mc=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(tb=b[a>>0]|0,tb<<24>>24>-1):0){f[c>>2]=a+1;nc=tb&255}else{tb=YYb(c)|0;if((tb|0)>-1)nc=tb;else{cb=0;Za=473;break a}}JYb(e,c,nc);if((f[qa>>2]|0)<0){Za=323;break a}if(!(Mi[f[(f[mc>>2]|0)+44>>2]&1023](mc,c)|0)){Za=323;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 32:{if((_a&255|0)!=2){$a=_a;break b}tb=KHa(ra)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Va=b[a>>0]|0,Va<<24>>24>-1):0){f[c>>2]=a+1;oc=Va&255}else{Va=YYb(c)|0;if((Va|0)>-1)oc=Va;else{cb=0;Za=473;break a}}JYb(e,c,oc);if((f[sa>>2]|0)<0){Za=332;break a}if(!(Mi[f[(f[tb>>2]|0)+44>>2]&1023](tb,c)|0)){Za=332;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 33:{if((_a&255|0)!=10){$a=_a;break b}tb=KHa(ta)|0;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(a=b[Va>>0]|0,a<<24>>24>-1):0){f[c>>2]=Va+1;pc=a&255}else{a=YYb(c)|0;if((a|0)>-1)pc=a;else{cb=0;Za=473;break a}}JYb(e,c,pc);if((f[ua>>2]|0)<0){Za=341;break a}if(!(Mi[f[(f[tb>>2]|0)+44>>2]&1023](tb,c)|0)){Za=341;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 34:{if((_a&255|0)!=18){$a=_a;break b}f[i>>2]=f[i>>2]|16777216;tb=f[va>>2]|0;if(!tb){a=$Xc(24)|0;r1a(a);f[va>>2]=a;qc=a}else qc=tb;tb=f[c>>2]|0;if(tb>>>0<(f[g>>2]|0)>>>0?(a=b[tb>>0]|0,a<<24>>24>-1):0){f[c>>2]=tb+1;rc=a&255}else{a=YYb(c)|0;if((a|0)>-1)rc=a;else{cb=0;Za=473;break a}}JYb(e,c,rc);if((f[wa>>2]|0)<0){Za=352;break a}if(!(Mi[f[(f[qc>>2]|0)+44>>2]&1023](qc,c)|0)){Za=352;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 35:{switch((_a&255)<<24>>24){case 29:break;case 26:{if(_Za(c,xa)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){tb=a;Va=h[tb>>0]|h[tb+1>>0]<<8|h[tb+2>>0]<<16|h[tb+3>>0]<<24;f[e>>2]=Va;f[c>>2]=a+4;sc=Va}else{if(!(WYb(c,e)|0)){Za=370;break a}sc=f[e>>2]|0}Va=f[xa>>2]|0;if((Va|0)==(f[ya>>2]|0)){uHa(xa,Va+1|0);tc=f[xa>>2]|0}else tc=Va;Va=f[za>>2]|0;a=tc+1|0;f[xa>>2]=a;f[Va+4+(tc<<2)>>2]=sc;tb=f[c>>2]|0;Ua=(f[g>>2]|0)-tb|0;if((Ua|0)<=0)continue a;Sa=tb;tb=(f[ya>>2]|0)-a|0;lb=(Ua>>>0)/6|0;sb=(lb|0)<(tb|0)?lb:tb;if((sb|0)>0){uc=0;vc=Sa;wc=a}else continue a;while(1){if((b[vc>>0]|0)!=-99){xc=uc;break}if((b[vc+1>>0]|0)!=2){xc=uc;break}a=vc+2|0;tb=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=wc;wc=wc+1|0;f[xa>>2]=wc;f[Va+4+(a<<2)>>2]=tb;tb=uc+1|0;if((tb|0)>=(sb|0)){xc=tb;break}else{uc=tb;vc=vc+6|0}}sb=xc*6|0;if((xc|0)<=0)continue a;if((Ua|0)<(sb|0)){SYb(c,sb,Ua)|0;continue a}else{f[c>>2]=Sa+sb;continue a}break}case 36:{if((_a&255|0)!=34){$a=_a;break b}f[i>>2]=f[i>>2]|33554432;sb=f[Aa>>2]|0;if(!sb){Va=$Xc(44)|0;s1a(Va);f[Aa>>2]=Va;yc=Va}else yc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;zc=Va&255}else{Va=YYb(c)|0;if((Va|0)>-1)zc=Va;else{cb=0;Za=473;break a}}JYb(e,c,zc);if((f[Ba>>2]|0)<0){Za=381;break a}if(!(Mi[f[(f[yc>>2]|0)+44>>2]&1023](yc,c)|0)){Za=381;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 37:{if((_a&255|0)!=42){$a=_a;break b}f[i>>2]=f[i>>2]|67108864;Va=f[Ca>>2]|0;if(!Va){sb=$Xc(20)|0;u1a(sb);f[Ca>>2]=sb;Ac=sb}else Ac=Va;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(sb=b[Va>>0]|0,sb<<24>>24>-1):0){f[c>>2]=Va+1;Bc=sb&255}else{sb=YYb(c)|0;if((sb|0)>-1)Bc=sb;else{cb=0;Za=473;break a}}JYb(e,c,Bc);if((f[Da>>2]|0)<0){Za=392;break a}if(!(Mi[f[(f[Ac>>2]|0)+44>>2]&1023](Ac,c)|0)){Za=392;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 38:{if((_a&255|0)!=50){$a=_a;break b}f[i>>2]=f[i>>2]|134217728;sb=f[Ea>>2]|0;if(!sb){Va=$Xc(20)|0;v1a(Va);f[Ea>>2]=Va;Cc=Va}else Cc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;Dc=Va&255}else{Va=YYb(c)|0;if((Va|0)>-1)Dc=Va;else{cb=0;Za=473;break a}}JYb(e,c,Dc);if((f[Fa>>2]|0)<0){Za=403;break a}if(!(Mi[f[(f[Cc>>2]|0)+44>>2]&1023](Cc,c)|0)){Za=403;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 39:{if((_a&255|0)!=58){$a=_a;break b}f[i>>2]=f[i>>2]|268435456;Va=f[Ga>>2]|0;if(!Va){sb=$Xc(24)|0;w1a(sb);f[Ga>>2]=sb;Ec=sb}else Ec=Va;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(sb=b[Va>>0]|0,sb<<24>>24>-1):0){f[c>>2]=Va+1;Fc=sb&255}else{sb=YYb(c)|0;if((sb|0)>-1)Fc=sb;else{cb=0;Za=473;break a}}JYb(e,c,Fc);if((f[Ha>>2]|0)<0){Za=414;break a}if(!(Mi[f[(f[Ec>>2]|0)+44>>2]&1023](Ec,c)|0)){Za=414;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 40:{if((_a&255|0)!=66){$a=_a;break b}f[i>>2]=f[i>>2]|536870912;sb=f[Ia>>2]|0;if(!sb){Va=$Xc(24)|0;x1a(Va);f[Ia>>2]=Va;Gc=Va}else Gc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;Hc=Va&255}else{Va=YYb(c)|0;if((Va|0)>-1)Hc=Va;else{cb=0;Za=473;break a}}JYb(e,c,Hc);if((f[Ja>>2]|0)<0){Za=425;break a}if(!(Mi[f[(f[Gc>>2]|0)+44>>2]&1023](Gc,c)|0)){Za=425;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 41:{if((_a&255|0)!=74){$a=_a;break b}f[i>>2]=f[i>>2]|1073741824;Va=f[Ka>>2]|0;if(!Va){sb=$Xc(28)|0;y1a(sb);f[Ka>>2]=sb;Ic=sb}else Ic=Va;Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0?(sb=b[Va>>0]|0,sb<<24>>24>-1):0){f[c>>2]=Va+1;Jc=sb&255}else{sb=YYb(c)|0;if((sb|0)>-1)Jc=sb;else{cb=0;Za=473;break a}}JYb(e,c,Jc);if((f[La>>2]|0)<0){Za=436;break a}if(!(Mi[f[(f[Ic>>2]|0)+44>>2]&1023](Ic,c)|0)){Za=436;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 42:{if((_a&255|0)!=82){$a=_a;break b}f[i>>2]=f[i>>2]|-2147483648;sb=f[Ma>>2]|0;if(!sb){Va=$Xc(28)|0;z1a(Va);f[Ma>>2]=Va;Kc=Va}else Kc=sb;sb=f[c>>2]|0;if(sb>>>0<(f[g>>2]|0)>>>0?(Va=b[sb>>0]|0,Va<<24>>24>-1):0){f[c>>2]=sb+1;Lc=Va&255}else{Va=YYb(c)|0;if((Va|0)>-1)Lc=Va;else{cb=0;Za=473;break a}}JYb(e,c,Lc);if((f[Na>>2]|0)<0){Za=447;break a}if(!(Mi[f[(f[Kc>>2]|0)+44>>2]&1023](Kc,c)|0)){Za=447;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{cb=0;Za=473;break a}break}case 1001:{if((_a&255|0)!=74){$a=_a;break b}if(l$b(c,pHa(Oa)|0)|0)continue a;else{cb=0;Za=473;break a}break}case 1002:{switch((_a&255)<<24>>24){case 80:break;case 82:{Va=f[q>>2]|0;if(!(Va&1))Mc=lSa(q)|0;else Mc=Va&-2;if(Nqc(c,1002,1070,Mc,Pa)|0)continue a;else{cb=0;Za=473;break a}break}default:{$a=_a;break b}}Va=f[c>>2]|0;if(Va>>>0<(f[g>>2]|0)>>>0){sb=b[Va>>0]|0;kb=sb&255;if(sb<<24>>24>-1){f[c>>2]=Va+1;Nc=kb}else{Oc=kb;Za=455}}else{Oc=0;Za=455}if((Za|0)==455){Za=0;kb=KYb(c,Oc)|0;Va=J;if((Va|0)>-1|(Va|0)==-1&kb>>>0>4294967295)Nc=kb;else{cb=0;Za=473;break a}}if(Nc>>>0<2){kb=f[Pa>>2]|0;if((kb|0)==(f[Qa>>2]|0)){qHa(Pa,kb+1|0);Pc=f[Pa>>2]|0}else Pc=kb;kb=f[Ra>>2]|0;f[Pa>>2]=Pc+1;f[kb+4+(Pc<<2)>>2]=Nc;continue a}kb=f[q>>2]|0;if(!(kb&1))Qc=lSa(q)|0;else Qc=kb&-2;yqc(Qc,1002,Nc,((Nc|0)<0)<<31>>31);continue a;break}default:{$a=_a;break b}}while(0)}while(0);if(!$a){cb=1;Za=473;break}kb=f[q>>2]|0;if(!(kb&1))Rc=lSa(q)|0;else Rc=kb&-2;if(!(Lqc(c,$a,Rc)|0)){cb=0;Za=473;break}}switch(Za|0){case 19:{cb=0;u=d;return cb|0}case 47:{cb=0;u=d;return cb|0}case 64:{cb=0;u=d;return cb|0}case 81:{cb=0;u=d;return cb|0}case 92:{cb=0;u=d;return cb|0}case 103:{cb=0;u=d;return cb|0}case 114:{cb=0;u=d;return cb|0}case 125:{cb=0;u=d;return cb|0}case 136:{cb=0;u=d;return cb|0}case 147:{cb=0;u=d;return cb|0}case 158:{cb=0;u=d;return cb|0}case 169:{cb=0;u=d;return cb|0}case 180:{cb=0;u=d;return cb|0}case 191:{cb=0;u=d;return cb|0}case 202:{cb=0;u=d;return cb|0}case 213:{cb=0;u=d;return cb|0}case 224:{cb=0;u=d;return cb|0}case 235:{cb=0;u=d;return cb|0}case 246:{cb=0;u=d;return cb|0}case 257:{cb=0;u=d;return cb|0}case 268:{cb=0;u=d;return cb|0}case 279:{cb=0;u=d;return cb|0}case 290:{cb=0;u=d;return cb|0}case 301:{cb=0;u=d;return cb|0}case 312:{cb=0;u=d;return cb|0}case 323:{cb=0;u=d;return cb|0}case 332:{cb=0;u=d;return cb|0}case 341:{cb=0;u=d;return cb|0}case 352:{cb=0;u=d;return cb|0}case 370:{cb=0;u=d;return cb|0}case 381:{cb=0;u=d;return cb|0}case 392:{cb=0;u=d;return cb|0}case 403:{cb=0;u=d;return cb|0}case 414:{cb=0;u=d;return cb|0}case 425:{cb=0;u=d;return cb|0}case 436:{cb=0;u=d;return cb|0}case 447:{cb=0;u=d;return cb|0}case 473:{u=d;return cb|0}}return 0}function D0a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+52>>2]|0;g=h+m|0;if(!h)n=g;else{m=a+60|0;e=0;c=g;while(1){g=f[(f[m>>2]|0)+4+(e<<2)>>2]|0;l=_i[f[(f[g>>2]|0)+48>>2]&2047](g)|0;g=l+c+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=e+1|0;if((e|0)==(h|0)){n=g;break}else c=g}}c=f[a+64>>2]|0;h=f[a+76>>2]|0;e=f[a+92>>2]|0;m=c+n+h+(e<<1)+(h+c<<2)|0;if(!e)o=m;else{c=a+100|0;h=0;n=m;while(1){m=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;g=_i[f[(f[m>>2]|0)+48>>2]&2047](m)|0;m=g+n+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(e|0)){o=m;break}else n=m}}n=f[a+108>>2]|0;e=(n<<1)+o|0;if(!n)p=e;else{o=a+116|0;h=0;c=e;while(1){e=f[(f[o>>2]|0)+4+(h<<2)>>2]|0;m=_i[f[(f[e>>2]|0)+48>>2]&2047](e)|0;e=m+c+((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(n|0)){p=e;break}else c=e}}c=f[a+120>>2]|0;n=f[a+136>>2]|0;h=(c<<2)+p+(n+c<<1)|0;if((n|0)>0){c=f[a+144>>2]|0;p=0;o=h;while(1){e=f[c+4+(p<<2)>>2]|0;m=b[e+11>>0]|0;g=m<<24>>24<0?f[e+4>>2]|0:m&255;m=g+o+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=p+1|0;if((p|0)==(n|0)){q=m;break}else o=m}}else q=h;h=f[a+148>>2]|0;if(!h)r=0;else{o=f[a+156>>2]|0;n=0;p=0;while(1){c=f[o+4+(n<<2)>>2]|0;if((c|0)<0)s=10;else s=(((($(c|1|0)|0)^31)*9|0)+73|0)>>>6;c=s+p|0;n=n+1|0;if((n|0)==(h|0)){r=c;break}else p=c}}p=(h<<1)+q+r|0;r=a+8|0;q=f[r>>2]|0;if(q&255){if(!(q&1))t=p;else{h=f[a+160>>2]|0;n=b[h+11>>0]|0;s=n<<24>>24<0?f[h+4>>2]|0:n&255;t=p+1+s+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(q&2)){u=t;v=q}else{s=f[a+164>>2]|0;n=_i[f[(f[s>>2]|0)+48>>2]&2047](s)|0;s=t+1+n+((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)|0;u=s;v=f[r>>2]|0}if(!(v&4)){w=u;x=v}else{v=f[a+168>>2]|0;s=_i[f[(f[v>>2]|0)+48>>2]&2047](v)|0;v=u+1+s+((((($(s|1|0)|0)^31)*9|0)+73|0)>>>6)|0;w=v;x=f[r>>2]|0}if(!(x&8)){y=w;z=x}else{x=f[a+172>>2]|0;v=_i[f[(f[x>>2]|0)+48>>2]&2047](x)|0;x=w+1+v+((((($(v|1|0)|0)^31)*9|0)+73|0)>>>6)|0;y=x;z=f[r>>2]|0}if(!(z&16)){A=y;B=z}else{z=f[a+176>>2]|0;x=_i[f[(f[z>>2]|0)+48>>2]&2047](z)|0;z=y+1+x+((((($(x|1|0)|0)^31)*9|0)+73|0)>>>6)|0;A=z;B=f[r>>2]|0}if(!(B&32)){C=A;D=B}else{B=f[a+180>>2]|0;z=_i[f[(f[B>>2]|0)+48>>2]&2047](B)|0;B=A+1+z+((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)|0;C=B;D=f[r>>2]|0}if(!(D&64)){E=C;F=D}else{D=f[a+184>>2]|0;B=_i[f[(f[D>>2]|0)+48>>2]&2047](D)|0;D=C+1+B+((((($(B|1|0)|0)^31)*9|0)+73|0)>>>6)|0;E=D;F=f[r>>2]|0}if(!(F&128)){G=E;H=F}else{F=f[a+188>>2]|0;D=_i[f[(f[F>>2]|0)+48>>2]&2047](F)|0;F=E+1+D+((((($(D|1|0)|0)^31)*9|0)+73|0)>>>6)|0;G=F;H=f[r>>2]|0}}else{G=p;H=q}if(H&65280){if(!(H&256)){I=G;J=H}else{q=f[a+192>>2]|0;p=_i[f[(f[q>>2]|0)+48>>2]&2047](q)|0;q=G+1+p+((((($(p|1|0)|0)^31)*9|0)+73|0)>>>6)|0;I=q;J=f[r>>2]|0}if(!(J&512)){K=I;L=J}else{J=f[a+196>>2]|0;q=_i[f[(f[J>>2]|0)+48>>2]&2047](J)|0;J=I+2+q+((((($(q|1|0)|0)^31)*9|0)+73|0)>>>6)|0;K=J;L=f[r>>2]|0}if(!(L&1024)){M=K;N=L}else{L=f[a+200>>2]|0;J=_i[f[(f[L>>2]|0)+48>>2]&2047](L)|0;L=K+2+J+((((($(J|1|0)|0)^31)*9|0)+73|0)>>>6)|0;M=L;N=f[r>>2]|0}if(!(N&2048)){O=M;P=N}else{N=f[a+204>>2]|0;L=_i[f[(f[N>>2]|0)+48>>2]&2047](N)|0;N=M+2+L+((((($(L|1|0)|0)^31)*9|0)+73|0)>>>6)|0;O=N;P=f[r>>2]|0}if(!(P&4096)){Q=O;R=P}else{P=f[a+208>>2]|0;N=_i[f[(f[P>>2]|0)+48>>2]&2047](P)|0;P=O+2+N+((((($(N|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Q=P;R=f[r>>2]|0}if(!(R&8192)){S=Q;T=R}else{R=f[a+212>>2]|0;P=_i[f[(f[R>>2]|0)+48>>2]&2047](R)|0;R=Q+2+P+((((($(P|1|0)|0)^31)*9|0)+73|0)>>>6)|0;S=R;T=f[r>>2]|0}if(!(T&16384)){U=S;V=T}else{T=f[a+216>>2]|0;R=_i[f[(f[T>>2]|0)+48>>2]&2047](T)|0;T=S+2+R+((((($(R|1|0)|0)^31)*9|0)+73|0)>>>6)|0;U=T;V=f[r>>2]|0}if(!(V&32768)){W=U;X=V}else{V=f[a+220>>2]|0;T=_i[f[(f[V>>2]|0)+48>>2]&2047](V)|0;V=U+2+T+((((($(T|1|0)|0)^31)*9|0)+73|0)>>>6)|0;W=V;X=f[r>>2]|0}}else{W=G;X=H}if(X&16711680){if(!(X&65536)){Y=W;Z=X}else{H=f[a+224>>2]|0;G=_i[f[(f[H>>2]|0)+48>>2]&2047](H)|0;H=W+2+G+((((($(G|1|0)|0)^31)*9|0)+73|0)>>>6)|0;Y=H;Z=f[r>>2]|0}if(!(Z&131072)){_=Y;aa=Z}else{Z=f[a+228>>2]|0;H=_i[f[(f[Z>>2]|0)+48>>2]&2047](Z)|0;Z=Y+2+H+((((($(H|1|0)|0)^31)*9|0)+73|0)>>>6)|0;_=Z;aa=f[r>>2]|0}if(!(aa&262144)){ba=_;ca=aa}else{aa=f[a+232>>2]|0;Z=_i[f[(f[aa>>2]|0)+48>>2]&2047](aa)|0;aa=_+2+Z+((((($(Z|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ba=aa;ca=f[r>>2]|0}if(!(ca&524288)){da=ba;ea=ca}else{ca=f[a+236>>2]|0;aa=_i[f[(f[ca>>2]|0)+48>>2]&2047](ca)|0;ca=ba+2+aa+((((($(aa|1|0)|0)^31)*9|0)+73|0)>>>6)|0;da=ca;ea=f[r>>2]|0}if(!(ea&1048576)){fa=da;ga=ea}else{ea=f[a+240>>2]|0;ca=_i[f[(f[ea>>2]|0)+48>>2]&2047](ea)|0;ea=da+2+ca+((((($(ca|1|0)|0)^31)*9|0)+73|0)>>>6)|0;fa=ea;ga=f[r>>2]|0}if(!(ga&2097152)){ha=fa;ia=ga}else{ga=f[a+244>>2]|0;ea=_i[f[(f[ga>>2]|0)+48>>2]&2047](ga)|0;ga=fa+2+ea+((((($(ea|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ha=ga;ia=f[r>>2]|0}if(!(ia&4194304)){ja=ha;ka=ia}else{ia=f[a+248>>2]|0;ga=_i[f[(f[ia>>2]|0)+48>>2]&2047](ia)|0;ia=ha+2+ga+((((($(ga|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ja=ia;ka=f[r>>2]|0}if(!(ka&8388608)){la=ja;ma=ka}else{ka=f[a+252>>2]|0;ia=_i[f[(f[ka>>2]|0)+48>>2]&2047](ka)|0;ka=ja+2+ia+((((($(ia|1|0)|0)^31)*9|0)+73|0)>>>6)|0;la=ka;ma=f[r>>2]|0}}else{la=W;ma=X}do if(ma>>>0>16777215){if(!(ma&16777216)){na=la;oa=ma}else{X=f[a+256>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;X=la+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;na=X;oa=f[r>>2]|0}if(!(oa&33554432)){pa=na;qa=oa}else{X=f[a+260>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;X=na+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;pa=X;qa=f[r>>2]|0}if(!(qa&67108864)){ra=pa;sa=qa}else{X=f[a+264>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;X=pa+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ra=X;sa=f[r>>2]|0}if(!(sa&134217728)){ta=ra;ua=sa}else{X=f[a+268>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;X=ra+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;ta=X;ua=f[r>>2]|0}if(!(ua&268435456)){va=ta;wa=ua}else{X=f[a+272>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;X=ta+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;va=X;wa=f[r>>2]|0}if(!(wa&536870912)){xa=va;ya=wa}else{X=f[a+276>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;X=va+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;xa=X;ya=f[r>>2]|0}if(!(ya&1073741824)){za=xa;Aa=ya}else{X=f[a+280>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;X=xa+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0;za=X;Aa=f[r>>2]|0}if((Aa|0)>=0){Ba=za;break}X=f[a+284>>2]|0;W=_i[f[(f[X>>2]|0)+48>>2]&2047](X)|0;Ba=za+2+W+((((($(W|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else Ba=la;while(0);if(!(f[a+12>>2]&1)){Ca=Ba;Da=a+292|0;f[Da>>2]=Ca;return Ca|0}la=f[a+288>>2]|0;if((la|0)<0)Ea=11;else Ea=((((($(la|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;Ca=Ea+Ba|0;Da=a+292|0;f[Da>>2]=Ca;return Ca|0}function E0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&2|0)k$b(1,f[a+164>>2]|0,b);e=f[a+20>>2]|0;if((e|0)>0){g=a+28|0;h=0;do{e$b(2,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,b);h=h+1|0}while((h|0)!=(e|0))}e=f[a+36>>2]|0;if((e|0)>0){h=a+44|0;g=0;do{e$b(3,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(e|0))}if(d&1|0)f$b(4,f[a+160>>2]|0,b);if(f[a+12>>2]&1|0)d$b(5,f[a+288>>2]|0,b);d=f[a+52>>2]|0;if(d|0){e=a+60|0;g=0;do{k$b(6,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+64>>2]|0;if((d|0)>0){g=a+72|0;e=0;do{a$b(7,+n[(f[g>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+76>>2]|0;if((d|0)>0){e=a+84|0;g=0;do{a$b(8,+n[(f[e>>2]|0)+4+(g<<2)>>2],b);g=g+1|0}while((g|0)!=(d|0))}d=f[c>>2]|0;if(d&4|0)k$b(9,f[a+168>>2]|0,b);if(d&8|0)k$b(10,f[a+172>>2]|0,b);if(d&16|0)k$b(11,f[a+176>>2]|0,b);if(d&32|0)k$b(12,f[a+180>>2]|0,b);if(d&64|0)k$b(13,f[a+184>>2]|0,b);if(d&128|0)k$b(14,f[a+188>>2]|0,b);if(d&256|0)k$b(15,f[a+192>>2]|0,b);if(d&512|0)k$b(16,f[a+196>>2]|0,b);if(d&1024|0)k$b(17,f[a+200>>2]|0,b);if(d&2048|0)k$b(18,f[a+204>>2]|0,b);if(d&4096|0)k$b(19,f[a+208>>2]|0,b);if(d&8192|0)k$b(20,f[a+212>>2]|0,b);if(d&16384|0)k$b(21,f[a+216>>2]|0,b);if(d&32768|0)k$b(22,f[a+220>>2]|0,b);if(d&65536|0)k$b(23,f[a+224>>2]|0,b);if(d&131072|0)k$b(24,f[a+228>>2]|0,b);if(d&262144|0)k$b(25,f[a+232>>2]|0,b);if(d&524288|0)k$b(26,f[a+236>>2]|0,b);if(d&1048576|0)k$b(27,f[a+240>>2]|0,b);if(d&2097152|0)k$b(29,f[a+244>>2]|0,b);if(d&4194304|0)k$b(30,f[a+248>>2]|0,b);if(d&8388608|0)k$b(31,f[a+252>>2]|0,b);c=f[a+92>>2]|0;if(c|0){g=a+100|0;e=0;do{k$b(32,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+108>>2]|0;if(c|0){e=a+116|0;g=0;do{k$b(33,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}if(d&16777216|0)k$b(34,f[a+256>>2]|0,b);c=f[a+120>>2]|0;if((c|0)>0){g=a+128|0;e=0;do{a$b(35,+n[(f[g>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)!=(c|0))}if(d&33554432|0)k$b(36,f[a+260>>2]|0,b);if(d&67108864|0)k$b(37,f[a+264>>2]|0,b);if(d&134217728|0)k$b(38,f[a+268>>2]|0,b);if(d&268435456|0)k$b(39,f[a+272>>2]|0,b);if(d&536870912|0)k$b(40,f[a+276>>2]|0,b);if(d&1073741824|0)k$b(41,f[a+280>>2]|0,b);if((d|0)<0)k$b(42,f[a+284>>2]|0,b);d=f[a+136>>2]|0;if((d|0)>0){c=a+144|0;e=0;do{e$b(1001,f[(f[c>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+148>>2]|0;if((d|0)>0){e=a+156|0;c=0;do{d$b(1002,f[(f[e>>2]|0)+4+(c<<2)>>2]|0,b);c=c+1|0}while((c|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,b);return}function F0a(a){a=a|0;return f[a+292>>2]|0}function G0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;e=a+8|0;g=f[e>>2]|0;if(!(g&2))h=d;else{i=f[a+164>>2]|0;b[d>>0]=10;j=d+1|0;d=_i[f[(f[i>>2]|0)+60>>2]&2047](i)|0;if(d>>>0>127){k=d;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=d}b[o>>0]=p;h=hj[f[(f[i>>2]|0)+64>>2]&511](i,c,o+1|0)|0}o=f[a+20>>2]|0;if((o|0)>0){i=a+28|0;p=0;d=h;while(1){j=f[(f[i>>2]|0)+4+(p<<2)>>2]|0;b[d>>0]=18;l=gZb(j,d+1|0)|0;p=p+1|0;if((p|0)==(o|0)){q=l;break}else d=l}}else q=h;h=f[a+36>>2]|0;if((h|0)>0){d=a+44|0;o=0;p=q;while(1){i=f[(f[d>>2]|0)+4+(o<<2)>>2]|0;b[p>>0]=26;l=gZb(i,p+1|0)|0;o=o+1|0;if((o|0)==(h|0)){r=l;break}else p=l}}else r=q;if(!(g&1))s=r;else{g=f[a+160>>2]|0;b[r>>0]=34;s=gZb(g,r+1|0)|0}if(!(f[a+12>>2]&1))t=s;else{r=f[a+288>>2]|0;b[s>>0]=40;g=s+1|0;s=r&255;if(r>>>0>127){q=g;p=s;h=r;o=((r|0)<0)<<31>>31;while(1){b[q>>0]=p|-128;r=h;h=l1c(h|0,o|0,7)|0;d=q+1|0;l=h&255;if(!(o>>>0>0|(o|0)==0&r>>>0>16383)){u=d;v=l;break}else{q=d;p=l;o=J}}}else{u=g;v=s}b[u>>0]=v;t=u+1|0}u=f[a+52>>2]|0;if(!u)w=t;else{v=a+60|0;s=0;g=t;while(1){t=f[(f[v>>2]|0)+4+(s<<2)>>2]|0;b[g>>0]=50;o=g+1|0;p=_i[f[(f[t>>2]|0)+60>>2]&2047](t)|0;if(p>>>0>127){q=p;h=o;while(1){b[h>>0]=q|128;l=q>>>7;d=h+1|0;if(q>>>0>16383){q=l;h=d}else{x=d;y=l;break}}}else{x=o;y=p}b[x>>0]=y;h=hj[f[(f[t>>2]|0)+64>>2]&511](t,c,x+1|0)|0;s=s+1|0;if((s|0)==(u|0)){w=h;break}else g=h}}g=f[a+64>>2]|0;if(!g)z=w;else{u=f[a+72>>2]|0;s=0;x=w;while(1){w=f[u+4+(s<<2)>>2]|0;b[x>>0]=61;y=x+1|0;b[y>>0]=w;b[y+1>>0]=w>>8;b[y+2>>0]=w>>16;b[y+3>>0]=w>>24;w=x+5|0;s=s+1|0;if((s|0)>=(g|0)){z=w;break}else x=w}}x=f[a+76>>2]|0;if(!x)A=z;else{g=f[a+84>>2]|0;s=0;u=z;while(1){z=f[g+4+(s<<2)>>2]|0;b[u>>0]=69;w=u+1|0;b[w>>0]=z;b[w+1>>0]=z>>8;b[w+2>>0]=z>>16;b[w+3>>0]=z>>24;z=u+5|0;s=s+1|0;if((s|0)>=(x|0)){A=z;break}else u=z}}u=f[e>>2]|0;if(!(u&4))B=A;else{e=f[a+168>>2]|0;b[A>>0]=74;x=A+1|0;A=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(A>>>0>127){s=A;g=x;while(1){b[g>>0]=s|128;z=s>>>7;w=g+1|0;if(s>>>0>16383){s=z;g=w}else{C=w;D=z;break}}}else{C=x;D=A}b[C>>0]=D;B=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,C+1|0)|0}if(!(u&8))E=B;else{C=f[a+172>>2]|0;b[B>>0]=82;e=B+1|0;B=_i[f[(f[C>>2]|0)+60>>2]&2047](C)|0;if(B>>>0>127){D=B;A=e;while(1){b[A>>0]=D|128;x=D>>>7;g=A+1|0;if(D>>>0>16383){D=x;A=g}else{F=g;G=x;break}}}else{F=e;G=B}b[F>>0]=G;E=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,F+1|0)|0}if(!(u&16))H=E;else{F=f[a+176>>2]|0;b[E>>0]=90;C=E+1|0;E=_i[f[(f[F>>2]|0)+60>>2]&2047](F)|0;if(E>>>0>127){G=E;B=C;while(1){b[B>>0]=G|128;e=G>>>7;A=B+1|0;if(G>>>0>16383){G=e;B=A}else{I=A;K=e;break}}}else{I=C;K=E}b[I>>0]=K;H=hj[f[(f[F>>2]|0)+64>>2]&511](F,c,I+1|0)|0}if(!(u&32))L=H;else{I=f[a+180>>2]|0;b[H>>0]=98;F=H+1|0;H=_i[f[(f[I>>2]|0)+60>>2]&2047](I)|0;if(H>>>0>127){K=H;E=F;while(1){b[E>>0]=K|128;C=K>>>7;B=E+1|0;if(K>>>0>16383){K=C;E=B}else{M=B;N=C;break}}}else{M=F;N=H}b[M>>0]=N;L=hj[f[(f[I>>2]|0)+64>>2]&511](I,c,M+1|0)|0}if(!(u&64))O=L;else{M=f[a+184>>2]|0;b[L>>0]=106;I=L+1|0;L=_i[f[(f[M>>2]|0)+60>>2]&2047](M)|0;if(L>>>0>127){N=L;H=I;while(1){b[H>>0]=N|128;F=N>>>7;E=H+1|0;if(N>>>0>16383){N=F;H=E}else{P=E;Q=F;break}}}else{P=I;Q=L}b[P>>0]=Q;O=hj[f[(f[M>>2]|0)+64>>2]&511](M,c,P+1|0)|0}if(!(u&128))R=O;else{P=f[a+188>>2]|0;b[O>>0]=114;M=O+1|0;O=_i[f[(f[P>>2]|0)+60>>2]&2047](P)|0;if(O>>>0>127){Q=O;L=M;while(1){b[L>>0]=Q|128;I=Q>>>7;H=L+1|0;if(Q>>>0>16383){Q=I;L=H}else{S=H;T=I;break}}}else{S=M;T=O}b[S>>0]=T;R=hj[f[(f[P>>2]|0)+64>>2]&511](P,c,S+1|0)|0}if(!(u&256))U=R;else{S=f[a+192>>2]|0;b[R>>0]=122;P=R+1|0;R=_i[f[(f[S>>2]|0)+60>>2]&2047](S)|0;if(R>>>0>127){T=R;O=P;while(1){b[O>>0]=T|128;M=T>>>7;L=O+1|0;if(T>>>0>16383){T=M;O=L}else{V=L;W=M;break}}}else{V=P;W=R}b[V>>0]=W;U=hj[f[(f[S>>2]|0)+64>>2]&511](S,c,V+1|0)|0}if(!(u&512))X=U;else{V=f[a+196>>2]|0;b[U>>0]=-126;b[U+1>>0]=1;S=U+2|0;U=_i[f[(f[V>>2]|0)+60>>2]&2047](V)|0;if(U>>>0>127){W=U;R=S;while(1){b[R>>0]=W|128;P=W>>>7;O=R+1|0;if(W>>>0>16383){W=P;R=O}else{Y=O;Z=P;break}}}else{Y=S;Z=U}b[Y>>0]=Z;X=hj[f[(f[V>>2]|0)+64>>2]&511](V,c,Y+1|0)|0}if(!(u&1024))_=X;else{Y=f[a+200>>2]|0;b[X>>0]=-118;b[X+1>>0]=1;V=X+2|0;X=_i[f[(f[Y>>2]|0)+60>>2]&2047](Y)|0;if(X>>>0>127){Z=X;U=V;while(1){b[U>>0]=Z|128;S=Z>>>7;R=U+1|0;if(Z>>>0>16383){Z=S;U=R}else{$=R;aa=S;break}}}else{$=V;aa=X}b[$>>0]=aa;_=hj[f[(f[Y>>2]|0)+64>>2]&511](Y,c,$+1|0)|0}if(!(u&2048))ba=_;else{$=f[a+204>>2]|0;b[_>>0]=-110;b[_+1>>0]=1;Y=_+2|0;_=_i[f[(f[$>>2]|0)+60>>2]&2047]($)|0;if(_>>>0>127){aa=_;X=Y;while(1){b[X>>0]=aa|128;V=aa>>>7;U=X+1|0;if(aa>>>0>16383){aa=V;X=U}else{ca=U;da=V;break}}}else{ca=Y;da=_}b[ca>>0]=da;ba=hj[f[(f[$>>2]|0)+64>>2]&511]($,c,ca+1|0)|0}if(!(u&4096))ea=ba;else{ca=f[a+208>>2]|0;b[ba>>0]=-102;b[ba+1>>0]=1;$=ba+2|0;ba=_i[f[(f[ca>>2]|0)+60>>2]&2047](ca)|0;if(ba>>>0>127){da=ba;_=$;while(1){b[_>>0]=da|128;Y=da>>>7;X=_+1|0;if(da>>>0>16383){da=Y;_=X}else{fa=X;ga=Y;break}}}else{fa=$;ga=ba}b[fa>>0]=ga;ea=hj[f[(f[ca>>2]|0)+64>>2]&511](ca,c,fa+1|0)|0}if(!(u&8192))ha=ea;else{fa=f[a+212>>2]|0;b[ea>>0]=-94;b[ea+1>>0]=1;ca=ea+2|0;ea=_i[f[(f[fa>>2]|0)+60>>2]&2047](fa)|0;if(ea>>>0>127){ga=ea;ba=ca;while(1){b[ba>>0]=ga|128;$=ga>>>7;_=ba+1|0;if(ga>>>0>16383){ga=$;ba=_}else{ia=_;ja=$;break}}}else{ia=ca;ja=ea}b[ia>>0]=ja;ha=hj[f[(f[fa>>2]|0)+64>>2]&511](fa,c,ia+1|0)|0}if(!(u&16384))ka=ha;else{ia=f[a+216>>2]|0;b[ha>>0]=-86;b[ha+1>>0]=1;fa=ha+2|0;ha=_i[f[(f[ia>>2]|0)+60>>2]&2047](ia)|0;if(ha>>>0>127){ja=ha;ea=fa;while(1){b[ea>>0]=ja|128;ca=ja>>>7;ba=ea+1|0;if(ja>>>0>16383){ja=ca;ea=ba}else{la=ba;ma=ca;break}}}else{la=fa;ma=ha}b[la>>0]=ma;ka=hj[f[(f[ia>>2]|0)+64>>2]&511](ia,c,la+1|0)|0}if(!(u&32768))na=ka;else{la=f[a+220>>2]|0;b[ka>>0]=-78;b[ka+1>>0]=1;ia=ka+2|0;ka=_i[f[(f[la>>2]|0)+60>>2]&2047](la)|0;if(ka>>>0>127){ma=ka;ha=ia;while(1){b[ha>>0]=ma|128;fa=ma>>>7;ea=ha+1|0;if(ma>>>0>16383){ma=fa;ha=ea}else{oa=ea;pa=fa;break}}}else{oa=ia;pa=ka}b[oa>>0]=pa;na=hj[f[(f[la>>2]|0)+64>>2]&511](la,c,oa+1|0)|0}if(!(u&65536))qa=na;else{oa=f[a+224>>2]|0;b[na>>0]=-70;b[na+1>>0]=1;la=na+2|0;na=_i[f[(f[oa>>2]|0)+60>>2]&2047](oa)|0;if(na>>>0>127){pa=na;ka=la;while(1){b[ka>>0]=pa|128;ia=pa>>>7;ha=ka+1|0;if(pa>>>0>16383){pa=ia;ka=ha}else{ra=ha;sa=ia;break}}}else{ra=la;sa=na}b[ra>>0]=sa;qa=hj[f[(f[oa>>2]|0)+64>>2]&511](oa,c,ra+1|0)|0}if(!(u&131072))ta=qa;else{ra=f[a+228>>2]|0;b[qa>>0]=-62;b[qa+1>>0]=1;oa=qa+2|0;qa=_i[f[(f[ra>>2]|0)+60>>2]&2047](ra)|0;if(qa>>>0>127){sa=qa;na=oa;while(1){b[na>>0]=sa|128;la=sa>>>7;ka=na+1|0;if(sa>>>0>16383){sa=la;na=ka}else{ua=ka;va=la;break}}}else{ua=oa;va=qa}b[ua>>0]=va;ta=hj[f[(f[ra>>2]|0)+64>>2]&511](ra,c,ua+1|0)|0}if(!(u&262144))wa=ta;else{ua=f[a+232>>2]|0;b[ta>>0]=-54;b[ta+1>>0]=1;ra=ta+2|0;ta=_i[f[(f[ua>>2]|0)+60>>2]&2047](ua)|0;if(ta>>>0>127){va=ta;qa=ra;while(1){b[qa>>0]=va|128;oa=va>>>7;na=qa+1|0;if(va>>>0>16383){va=oa;qa=na}else{xa=na;ya=oa;break}}}else{xa=ra;ya=ta}b[xa>>0]=ya;wa=hj[f[(f[ua>>2]|0)+64>>2]&511](ua,c,xa+1|0)|0}if(!(u&524288))za=wa;else{xa=f[a+236>>2]|0;b[wa>>0]=-46;b[wa+1>>0]=1;ua=wa+2|0;wa=_i[f[(f[xa>>2]|0)+60>>2]&2047](xa)|0;if(wa>>>0>127){ya=wa;ta=ua;while(1){b[ta>>0]=ya|128;ra=ya>>>7;qa=ta+1|0;if(ya>>>0>16383){ya=ra;ta=qa}else{Aa=qa;Ba=ra;break}}}else{Aa=ua;Ba=wa}b[Aa>>0]=Ba;za=hj[f[(f[xa>>2]|0)+64>>2]&511](xa,c,Aa+1|0)|0}if(!(u&1048576))Ca=za;else{Aa=f[a+240>>2]|0;b[za>>0]=-38;b[za+1>>0]=1;xa=za+2|0;za=_i[f[(f[Aa>>2]|0)+60>>2]&2047](Aa)|0;if(za>>>0>127){Ba=za;wa=xa;while(1){b[wa>>0]=Ba|128;ua=Ba>>>7;ta=wa+1|0;if(Ba>>>0>16383){Ba=ua;wa=ta}else{Da=ta;Ea=ua;break}}}else{Da=xa;Ea=za}b[Da>>0]=Ea;Ca=hj[f[(f[Aa>>2]|0)+64>>2]&511](Aa,c,Da+1|0)|0}if(!(u&2097152))Fa=Ca;else{Da=f[a+244>>2]|0;b[Ca>>0]=-22;b[Ca+1>>0]=1;Aa=Ca+2|0;Ca=_i[f[(f[Da>>2]|0)+60>>2]&2047](Da)|0;if(Ca>>>0>127){Ea=Ca;za=Aa;while(1){b[za>>0]=Ea|128;xa=Ea>>>7;wa=za+1|0;if(Ea>>>0>16383){Ea=xa;za=wa}else{Ga=wa;Ha=xa;break}}}else{Ga=Aa;Ha=Ca}b[Ga>>0]=Ha;Fa=hj[f[(f[Da>>2]|0)+64>>2]&511](Da,c,Ga+1|0)|0}if(!(u&4194304))Ia=Fa;else{Ga=f[a+248>>2]|0;b[Fa>>0]=-14;b[Fa+1>>0]=1;Da=Fa+2|0;Fa=_i[f[(f[Ga>>2]|0)+60>>2]&2047](Ga)|0;if(Fa>>>0>127){Ha=Fa;Ca=Da;while(1){b[Ca>>0]=Ha|128;Aa=Ha>>>7;za=Ca+1|0;if(Ha>>>0>16383){Ha=Aa;Ca=za}else{Ja=za;Ka=Aa;break}}}else{Ja=Da;Ka=Fa}b[Ja>>0]=Ka;Ia=hj[f[(f[Ga>>2]|0)+64>>2]&511](Ga,c,Ja+1|0)|0}if(!(u&8388608))La=Ia;else{Ja=f[a+252>>2]|0;b[Ia>>0]=-6;b[Ia+1>>0]=1;Ga=Ia+2|0;Ia=_i[f[(f[Ja>>2]|0)+60>>2]&2047](Ja)|0;if(Ia>>>0>127){Ka=Ia;Fa=Ga;while(1){b[Fa>>0]=Ka|128;Da=Ka>>>7;Ca=Fa+1|0;if(Ka>>>0>16383){Ka=Da;Fa=Ca}else{Ma=Ca;Na=Da;break}}}else{Ma=Ga;Na=Ia}b[Ma>>0]=Na;La=hj[f[(f[Ja>>2]|0)+64>>2]&511](Ja,c,Ma+1|0)|0}Ma=f[a+92>>2]|0;if(!Ma)Oa=La;else{Ja=a+100|0;Na=0;Ia=La;while(1){La=f[(f[Ja>>2]|0)+4+(Na<<2)>>2]|0;b[Ia>>0]=-126;b[Ia+1>>0]=2;Ga=Ia+2|0;Fa=_i[f[(f[La>>2]|0)+60>>2]&2047](La)|0;if(Fa>>>0>127){Ka=Fa;Da=Ga;while(1){b[Da>>0]=Ka|128;Ca=Ka>>>7;Ha=Da+1|0;if(Ka>>>0>16383){Ka=Ca;Da=Ha}else{Pa=Ha;Qa=Ca;break}}}else{Pa=Ga;Qa=Fa}b[Pa>>0]=Qa;Da=hj[f[(f[La>>2]|0)+64>>2]&511](La,c,Pa+1|0)|0;Na=Na+1|0;if((Na|0)==(Ma|0)){Oa=Da;break}else Ia=Da}}Ia=f[a+108>>2]|0;if(!Ia)Ra=Oa;else{Ma=a+116|0;Na=0;Pa=Oa;while(1){Oa=f[(f[Ma>>2]|0)+4+(Na<<2)>>2]|0;b[Pa>>0]=-118;b[Pa+1>>0]=2;Qa=Pa+2|0;Ja=_i[f[(f[Oa>>2]|0)+60>>2]&2047](Oa)|0;if(Ja>>>0>127){Da=Ja;Ka=Qa;while(1){b[Ka>>0]=Da|128;t=Da>>>7;p=Ka+1|0;if(Da>>>0>16383){Da=t;Ka=p}else{Sa=p;Ta=t;break}}}else{Sa=Qa;Ta=Ja}b[Sa>>0]=Ta;Ka=hj[f[(f[Oa>>2]|0)+64>>2]&511](Oa,c,Sa+1|0)|0;Na=Na+1|0;if((Na|0)==(Ia|0)){Ra=Ka;break}else Pa=Ka}}if(!(u&16777216))Ua=Ra;else{Pa=f[a+256>>2]|0;b[Ra>>0]=-110;b[Ra+1>>0]=2;Ia=Ra+2|0;Ra=_i[f[(f[Pa>>2]|0)+60>>2]&2047](Pa)|0;if(Ra>>>0>127){Na=Ra;Sa=Ia;while(1){b[Sa>>0]=Na|128;Ta=Na>>>7;Ma=Sa+1|0;if(Na>>>0>16383){Na=Ta;Sa=Ma}else{Va=Ma;Wa=Ta;break}}}else{Va=Ia;Wa=Ra}b[Va>>0]=Wa;Ua=hj[f[(f[Pa>>2]|0)+64>>2]&511](Pa,c,Va+1|0)|0}Va=f[a+120>>2]|0;if(!Va)Xa=Ua;else{Pa=f[a+128>>2]|0;Wa=0;Ra=Ua;while(1){Ua=f[Pa+4+(Wa<<2)>>2]|0;b[Ra>>0]=-99;b[Ra+1>>0]=2;Ia=Ra+2|0;b[Ia>>0]=Ua;b[Ia+1>>0]=Ua>>8;b[Ia+2>>0]=Ua>>16;b[Ia+3>>0]=Ua>>24;Ua=Ra+6|0;Wa=Wa+1|0;if((Wa|0)>=(Va|0)){Xa=Ua;break}else Ra=Ua}}if(!(u&33554432))Ya=Xa;else{Ra=f[a+260>>2]|0;b[Xa>>0]=-94;b[Xa+1>>0]=2;Va=Xa+2|0;Xa=_i[f[(f[Ra>>2]|0)+60>>2]&2047](Ra)|0;if(Xa>>>0>127){Wa=Xa;Pa=Va;while(1){b[Pa>>0]=Wa|128;Ua=Wa>>>7;Ia=Pa+1|0;if(Wa>>>0>16383){Wa=Ua;Pa=Ia}else{Za=Ia;_a=Ua;break}}}else{Za=Va;_a=Xa}b[Za>>0]=_a;Ya=hj[f[(f[Ra>>2]|0)+64>>2]&511](Ra,c,Za+1|0)|0}if(!(u&67108864))$a=Ya;else{Za=f[a+264>>2]|0;b[Ya>>0]=-86;b[Ya+1>>0]=2;Ra=Ya+2|0;Ya=_i[f[(f[Za>>2]|0)+60>>2]&2047](Za)|0;if(Ya>>>0>127){_a=Ya;Xa=Ra;while(1){b[Xa>>0]=_a|128;Va=_a>>>7;Pa=Xa+1|0;if(_a>>>0>16383){_a=Va;Xa=Pa}else{ab=Pa;bb=Va;break}}}else{ab=Ra;bb=Ya}b[ab>>0]=bb;$a=hj[f[(f[Za>>2]|0)+64>>2]&511](Za,c,ab+1|0)|0}if(!(u&134217728))cb=$a;else{ab=f[a+268>>2]|0;b[$a>>0]=-78;b[$a+1>>0]=2;Za=$a+2|0;$a=_i[f[(f[ab>>2]|0)+60>>2]&2047](ab)|0;if($a>>>0>127){bb=$a;Ya=Za;while(1){b[Ya>>0]=bb|128;Ra=bb>>>7;Xa=Ya+1|0;if(bb>>>0>16383){bb=Ra;Ya=Xa}else{db=Xa;eb=Ra;break}}}else{db=Za;eb=$a}b[db>>0]=eb;cb=hj[f[(f[ab>>2]|0)+64>>2]&511](ab,c,db+1|0)|0}if(!(u&268435456))fb=cb;else{db=f[a+272>>2]|0;b[cb>>0]=-70;b[cb+1>>0]=2;ab=cb+2|0;cb=_i[f[(f[db>>2]|0)+60>>2]&2047](db)|0;if(cb>>>0>127){eb=cb;$a=ab;while(1){b[$a>>0]=eb|128;Za=eb>>>7;Ya=$a+1|0;if(eb>>>0>16383){eb=Za;$a=Ya}else{gb=Ya;hb=Za;break}}}else{gb=ab;hb=cb}b[gb>>0]=hb;fb=hj[f[(f[db>>2]|0)+64>>2]&511](db,c,gb+1|0)|0}if(!(u&536870912))ib=fb;else{gb=f[a+276>>2]|0;b[fb>>0]=-62;b[fb+1>>0]=2;db=fb+2|0;fb=_i[f[(f[gb>>2]|0)+60>>2]&2047](gb)|0;if(fb>>>0>127){hb=fb;cb=db;while(1){b[cb>>0]=hb|128;ab=hb>>>7;$a=cb+1|0;if(hb>>>0>16383){hb=ab;cb=$a}else{jb=$a;kb=ab;break}}}else{jb=db;kb=fb}b[jb>>0]=kb;ib=hj[f[(f[gb>>2]|0)+64>>2]&511](gb,c,jb+1|0)|0}if(!(u&1073741824))lb=ib;else{jb=f[a+280>>2]|0;b[ib>>0]=-54;b[ib+1>>0]=2;gb=ib+2|0;ib=_i[f[(f[jb>>2]|0)+60>>2]&2047](jb)|0;if(ib>>>0>127){kb=ib;fb=gb;while(1){b[fb>>0]=kb|128;db=kb>>>7;cb=fb+1|0;if(kb>>>0>16383){kb=db;fb=cb}else{mb=cb;nb=db;break}}}else{mb=gb;nb=ib}b[mb>>0]=nb;lb=hj[f[(f[jb>>2]|0)+64>>2]&511](jb,c,mb+1|0)|0}if((u|0)<0){u=f[a+284>>2]|0;b[lb>>0]=-46;b[lb+1>>0]=2;mb=lb+2|0;jb=_i[f[(f[u>>2]|0)+60>>2]&2047](u)|0;if(jb>>>0>127){nb=jb;ib=mb;while(1){b[ib>>0]=nb|128;gb=nb>>>7;fb=ib+1|0;if(nb>>>0>16383){nb=gb;ib=fb}else{ob=fb;pb=gb;break}}}else{ob=mb;pb=jb}b[ob>>0]=pb;qb=hj[f[(f[u>>2]|0)+64>>2]&511](u,c,ob+1|0)|0}else qb=lb;lb=f[a+136>>2]|0;if((lb|0)>0){ob=a+144|0;c=0;u=qb;while(1){pb=f[(f[ob>>2]|0)+4+(c<<2)>>2]|0;b[u>>0]=-54;b[u+1>>0]=62;jb=gZb(pb,u+2|0)|0;c=c+1|0;if((c|0)==(lb|0)){rb=jb;break}else u=jb}}else rb=qb;qb=f[a+148>>2]|0;if(!qb)sb=rb;else{u=f[a+156>>2]|0;lb=0;c=rb;while(1){rb=f[u+4+(lb<<2)>>2]|0;b[c>>0]=-48;b[c+1>>0]=62;ob=c+2|0;jb=rb&255;if(rb>>>0>127){pb=ob;mb=jb;ib=rb;nb=((rb|0)<0)<<31>>31;while(1){b[pb>>0]=mb|-128;rb=ib;ib=l1c(ib|0,nb|0,7)|0;gb=pb+1|0;fb=ib&255;if(!(nb>>>0>0|(nb|0)==0&rb>>>0>16383)){tb=gb;ub=fb;break}else{pb=gb;mb=fb;nb=J}}}else{tb=ob;ub=jb}b[tb>>0]=ub;nb=tb+1|0;lb=lb+1|0;if((lb|0)>=(qb|0)){sb=nb;break}else c=nb}}c=f[a+4>>2]|0;if(!(c&1)){vb=sb;return vb|0}vb=Pqc(c&-2,sb)|0;return vb|0}function H0a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;A0a(a);c=kZc(b,21568,15824,0)|0;if(!c){Ooc(b,a);return}else{L0a(a,c);return}}function I0a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15824,0)|0;if(!c){Ooc(b,a);return}else{L0a(a,c);return}}function J0a(a,b){a=a|0;b=b|0;f[a+292>>2]=b;return}function K0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535760;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function L0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}vSa(a+16|0,c+16|0);vSa(a+32|0,c+32|0);yHa(a+48|0,c+48|0);e=a+64|0;h=c+64|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+72>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+72>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+76|0;e=c+76|0;g=f[e>>2]|0;if(g|0){uHa(h,(f[h>>2]|0)+g|0);o1c((f[a+84>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}M0a(a+88|0,c+88|0);M0a(a+104|0,c+104|0);e=a+120|0;h=c+120|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+128>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+128>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}vSa(a+132|0,c+132|0);h=a+148|0;e=c+148|0;g=f[e>>2]|0;if(g|0){qHa(h,(f[h>>2]|0)+g|0);o1c((f[a+156>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+156>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;do if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+160|0,g=f[c+160>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+164|0;d=f[g>>2]|0;if(!d){h=$Xc(196)|0;r0a(h);f[g>>2]=h;i=h}else i=d;d=f[c+164>>2]|0;H$a(i,d|0?d:534768)}if(e&4|0){d=a+8|0;f[d>>2]=f[d>>2]|4;d=a+168|0;h=f[d>>2]|0;if(!h){g=$Xc(24)|0;N0a(g);f[d>>2]=g;j=g}else j=h;h=f[c+168>>2]|0;g=h|0?h:532856;h=j+4|0;d=f[g+4>>2]|0;if(d&1|0){k=f[h>>2]|0;if(!(k&1))l=lSa(h)|0;else l=k&-2;vqc(l,d&-2)}d=f[g+8>>2]|0;if(d&3|0){if(d&1|0)f[j+16>>2]=f[g+16>>2];if(d&2|0)f[j+20>>2]=f[g+20>>2];g=j+8|0;f[g>>2]=f[g>>2]|d}}if(e&8|0){d=a+8|0;f[d>>2]=f[d>>2]|8;d=a+172|0;g=f[d>>2]|0;if(!g){k=$Xc(120)|0;O0a(k);f[d>>2]=k;m=k}else m=g;g=f[c+172>>2]|0;P0a(m,g|0?g:532968)}if(e&16|0){g=a+8|0;f[g>>2]=f[g>>2]|16;g=a+176|0;k=f[g>>2]|0;if(!k){d=$Xc(52)|0;Q0a(d);f[g>>2]=d;n=d}else n=k;k=f[c+176>>2]|0;R0a(n,k|0?k:533120)}if(e&32|0){k=a+8|0;f[k>>2]=f[k>>2]|32;k=a+180|0;d=f[k>>2]|0;if(!d){g=$Xc(24)|0;S0a(g);f[k>>2]=g;o=g}else o=d;d=f[c+180>>2]|0;g=d|0?d:533248;d=o+4|0;k=f[g+4>>2]|0;if(k&1|0){h=f[d>>2]|0;if(!(h&1))p=lSa(d)|0;else p=h&-2;vqc(p,k&-2)}k=f[g+8>>2]|0;if(k&3|0){if(k&1|0)f[o+16>>2]=f[g+16>>2];if(k&2|0)b[o+20>>0]=b[g+20>>0]|0;g=o+8|0;f[g>>2]=f[g>>2]|k}}if(e&64|0){k=a+8|0;f[k>>2]=f[k>>2]|64;k=a+184|0;g=f[k>>2]|0;if(!g){h=$Xc(28)|0;T0a(h);f[k>>2]=h;q=h}else q=g;g=f[c+184>>2]|0;U0a(q,g|0?g:533528)}if(e&128|0){g=a+8|0;f[g>>2]=f[g>>2]|128;g=a+188|0;h=f[g>>2]|0;if(!h){k=$Xc(20)|0;I$a(k);f[g>>2]=k;r=k}else r=h;h=f[c+188>>2]|0;k=h|0?h:533560;h=r+4|0;g=f[k+4>>2]|0;if(g&1|0){d=f[h>>2]|0;if(!(d&1))s=lSa(h)|0;else s=d&-2;vqc(s,g&-2)}if(f[k+8>>2]&1|0?(g=r+8|0,f[g>>2]=f[g>>2]|1,g=r+16|0,d=f[k+16>>2]|0,k=f[g>>2]|0,(k|0)!=(d|0)):0)if((k|0)==537368){mHa(g,d);break}else{oYc(k,d)|0;break}}}while(0);if(e&65280|0){if(e&256|0){r=a+8|0;f[r>>2]=f[r>>2]|256;r=a+192|0;s=f[r>>2]|0;if(!s){q=$Xc(60)|0;V0a(q);f[r>>2]=q;t=q}else t=s;s=f[c+192>>2]|0;W0a(t,s|0?s:533608)}do if(e&512|0){s=a+8|0;f[s>>2]=f[s>>2]|512;s=a+196|0;t=f[s>>2]|0;if(!t){q=$Xc(20)|0;X0a(q);f[s>>2]=q;u=q}else u=t;t=f[c+196>>2]|0;q=t|0?t:533672;t=u+4|0;s=f[q+4>>2]|0;if(s&1|0){r=f[t>>2]|0;if(!(r&1))v=lSa(t)|0;else v=r&-2;vqc(v,s&-2)}if(f[q+8>>2]&1|0?(s=u+8|0,f[s>>2]=f[s>>2]|1,s=u+16|0,r=f[q+16>>2]|0,q=f[s>>2]|0,(q|0)!=(r|0)):0)if((q|0)==537368){mHa(s,r);break}else{oYc(q,r)|0;break}}while(0);if(e&1024|0){u=a+8|0;f[u>>2]=f[u>>2]|1024;u=a+200|0;v=f[u>>2]|0;if(!v){r=$Xc(36)|0;Y0a(r);f[u>>2]=r;w=r}else w=v;v=f[c+200>>2]|0;Z0a(w,v|0?v:533696)}if(e&2048|0){v=a+8|0;f[v>>2]=f[v>>2]|2048;v=a+204|0;w=f[v>>2]|0;if(!w){r=$Xc(40)|0;_0a(r);f[v>>2]=r;x=r}else x=w;w=f[c+204>>2]|0;$0a(x,w|0?w:533800)}if(e&4096|0){w=a+8|0;f[w>>2]=f[w>>2]|4096;w=a+208|0;x=f[w>>2]|0;if(!x){r=$Xc(68)|0;a1a(r);f[w>>2]=r;y=r}else y=x;x=f[c+208>>2]|0;b1a(y,x|0?x:533920)}if(e&8192|0){x=a+8|0;f[x>>2]=f[x>>2]|8192;x=a+212|0;y=f[x>>2]|0;if(!y){r=$Xc(64)|0;c1a(r);f[x>>2]=r;z=r}else z=y;y=f[c+212>>2]|0;d1a(z,y|0?y:534376)}if(e&16384|0){y=a+8|0;f[y>>2]=f[y>>2]|16384;y=a+216|0;z=f[y>>2]|0;if(!z){r=$Xc(28)|0;e1a(r);f[y>>2]=r;A=r}else A=z;z=f[c+216>>2]|0;r=z|0?z:533992;z=A+4|0;y=f[r+4>>2]|0;if(y&1|0){x=f[z>>2]|0;if(!(x&1))B=lSa(z)|0;else B=x&-2;vqc(B,y&-2)}y=f[r+8>>2]|0;if(y&7|0){if(y&1|0)f[A+16>>2]=f[r+16>>2];if(y&2|0)f[A+20>>2]=f[r+20>>2];if(y&4|0)f[A+24>>2]=f[r+24>>2];r=A+8|0;f[r>>2]=f[r>>2]|y}}if(e&32768|0){y=a+8|0;f[y>>2]=f[y>>2]|32768;y=a+220|0;r=f[y>>2]|0;if(!r){A=$Xc(32)|0;f1a(A);f[y>>2]=A;C=A}else C=r;r=f[c+220>>2]|0;A=r|0?r:533840;r=C+4|0;y=f[A+4>>2]|0;if(y&1|0){B=f[r>>2]|0;if(!(B&1))D=lSa(r)|0;else D=B&-2;vqc(D,y&-2)}y=f[A+8>>2]|0;if(y&15|0){if(y&1|0)f[C+16>>2]=f[A+16>>2];if(y&2|0)f[C+20>>2]=f[A+20>>2];if(y&4|0)f[C+24>>2]=f[A+24>>2];if(y&8|0)f[C+28>>2]=f[A+28>>2];A=C+8|0;f[A>>2]=f[A>>2]|y}}}if(e&16711680|0){if(e&65536|0){y=a+8|0;f[y>>2]=f[y>>2]|65536;y=a+224|0;A=f[y>>2]|0;if(!A){C=$Xc(28)|0;g1a(C);f[y>>2]=C;E=C}else E=A;A=f[c+224>>2]|0;C=A|0?A:532824;A=E+4|0;y=f[C+4>>2]|0;if(y&1|0){D=f[A>>2]|0;if(!(D&1))F=lSa(A)|0;else F=D&-2;vqc(F,y&-2)}y=f[C+8>>2]|0;if(y&7|0){if(y&1|0)b[E+16>>0]=b[C+16>>0]|0;if(y&2|0)f[E+20>>2]=f[C+20>>2];if(y&4|0)f[E+24>>2]=f[C+24>>2];C=E+8|0;f[C>>2]=f[C>>2]|y}}if(e&131072|0){y=a+8|0;f[y>>2]=f[y>>2]|131072;y=a+228|0;C=f[y>>2]|0;if(!C){E=$Xc(36)|0;h1a(E);f[y>>2]=E;G=E}else G=C;C=f[c+228>>2]|0;i1a(G,C|0?C:533368)}if(e&262144|0){C=a+8|0;f[C>>2]=f[C>>2]|262144;C=a+232|0;G=f[C>>2]|0;if(!G){E=$Xc(20)|0;j1a(E);f[C>>2]=E;H=E}else H=G;G=f[c+232>>2]|0;E=G|0?G:534352;G=H+4|0;C=f[E+4>>2]|0;if(C&1|0){y=f[G>>2]|0;if(!(y&1))I=lSa(G)|0;else I=y&-2;vqc(I,C&-2)}if(f[E+8>>2]&1|0){C=f[E+16>>2]|0;E=H+8|0;f[E>>2]=f[E>>2]|1;f[H+16>>2]=C}}if(e&524288|0){C=a+8|0;f[C>>2]=f[C>>2]|524288;C=a+236|0;H=f[C>>2]|0;if(!H){E=$Xc(96)|0;k1a(E);f[C>>2]=E;J=E}else J=H;H=f[c+236>>2]|0;l1a(J,H|0?H:533272)}if(e&1048576|0){H=a+8|0;f[H>>2]=f[H>>2]|1048576;H=a+240|0;J=f[H>>2]|0;if(!J){E=$Xc(28)|0;m1a(E);f[H>>2]=E;K=E}else K=J;J=f[c+240>>2]|0;E=J|0?J:532792;J=K+4|0;H=f[E+4>>2]|0;if(H&1|0){C=f[J>>2]|0;if(!(C&1))L=lSa(J)|0;else L=C&-2;vqc(L,H&-2)}H=f[E+8>>2]|0;if(H&7|0){if(H&1|0)f[K+16>>2]=f[E+16>>2];if(H&2|0)f[K+20>>2]=f[E+20>>2];if(H&4|0)f[K+24>>2]=f[E+24>>2];E=K+8|0;f[E>>2]=f[E>>2]|H}}if(e&2097152|0){H=a+8|0;f[H>>2]=f[H>>2]|2097152;H=a+244|0;E=f[H>>2]|0;if(!E){K=$Xc(20)|0;n1a(K);f[H>>2]=K;M=K}else M=E;E=f[c+244>>2]|0;K=E|0?E:533584;E=M+4|0;H=f[K+4>>2]|0;if(H&1|0){L=f[E>>2]|0;if(!(L&1))N=lSa(E)|0;else N=L&-2;vqc(N,H&-2)}if(f[K+8>>2]&1|0){H=f[K+16>>2]|0;K=M+8|0;f[K>>2]=f[K>>2]|1;f[M+16>>2]=H}}if(e&4194304|0){H=a+8|0;f[H>>2]=f[H>>2]|4194304;H=a+248|0;M=f[H>>2]|0;if(!M){K=$Xc(24)|0;o1a(K);f[H>>2]=K;O=K}else O=M;M=f[c+248>>2]|0;K=M|0?M:534120;M=O+4|0;H=f[K+4>>2]|0;if(H&1|0){N=f[M>>2]|0;if(!(N&1))P=lSa(M)|0;else P=N&-2;vqc(P,H&-2)}H=f[K+8>>2]|0;if(H&3|0){if(H&1|0)f[O+16>>2]=f[K+16>>2];if(H&2|0)f[O+20>>2]=f[K+20>>2];K=O+8|0;f[K>>2]=f[K>>2]|H}}if(e&8388608|0){H=a+8|0;f[H>>2]=f[H>>2]|8388608;H=a+252|0;K=f[H>>2]|0;if(!K){O=$Xc(36)|0;p1a(O);f[H>>2]=O;Q=O}else Q=K;K=f[c+252>>2]|0;q1a(Q,K|0?K:534240)}}do if(e>>>0>16777215){if(e&16777216|0){K=a+8|0;f[K>>2]=f[K>>2]|16777216;K=a+256|0;Q=f[K>>2]|0;if(!Q){O=$Xc(24)|0;r1a(O);f[K>>2]=O;R=O}else R=Q;Q=f[c+256>>2]|0;O=Q|0?Q:533872;Q=R+4|0;K=f[O+4>>2]|0;if(K&1|0){H=f[Q>>2]|0;if(!(H&1))S=lSa(Q)|0;else S=H&-2;vqc(S,K&-2)}K=f[O+8>>2]|0;if(K&7|0){if(K&1|0)b[R+16>>0]=b[O+16>>0]|0;if(K&2|0)b[R+17>>0]=b[O+17>>0]|0;if(K&4|0)f[R+20>>2]=f[O+20>>2];O=R+8|0;f[O>>2]=f[O>>2]|K}}if(e&33554432|0){K=a+8|0;f[K>>2]=f[K>>2]|33554432;K=a+260|0;O=f[K>>2]|0;if(!O){H=$Xc(44)|0;s1a(H);f[K>>2]=H;T=H}else T=O;O=f[c+260>>2]|0;t1a(T,O|0?O:532712)}if(e&67108864|0){O=a+8|0;f[O>>2]=f[O>>2]|67108864;O=a+264|0;H=f[O>>2]|0;if(!H){K=$Xc(20)|0;u1a(K);f[O>>2]=K;U=K}else U=H;H=f[c+264>>2]|0;K=H|0?H:534304;H=U+4|0;O=f[K+4>>2]|0;if(O&1|0){Q=f[H>>2]|0;if(!(Q&1))V=lSa(H)|0;else V=Q&-2;vqc(V,O&-2)}if(f[K+8>>2]&1|0){O=f[K+16>>2]|0;K=U+8|0;f[K>>2]=f[K>>2]|1;f[U+16>>2]=O}}if(e&134217728|0){O=a+8|0;f[O>>2]=f[O>>2]|134217728;O=a+268|0;K=f[O>>2]|0;if(!K){Q=$Xc(20)|0;v1a(Q);f[O>>2]=Q;W=Q}else W=K;K=f[c+268>>2]|0;Q=K|0?K:534216;K=W+4|0;O=f[Q+4>>2]|0;if(O&1|0){H=f[K>>2]|0;if(!(H&1))X=lSa(K)|0;else X=H&-2;vqc(X,O&-2)}if(f[Q+8>>2]&1|0){O=f[Q+16>>2]|0;Q=W+8|0;f[Q>>2]=f[Q>>2]|1;f[W+16>>2]=O}}if(e&268435456|0){O=a+8|0;f[O>>2]=f[O>>2]|268435456;O=a+272|0;Q=f[O>>2]|0;if(!Q){H=$Xc(24)|0;w1a(H);f[O>>2]=H;Y=H}else Y=Q;Q=f[c+272>>2]|0;H=Q|0?Q:534280;Q=Y+4|0;O=f[H+4>>2]|0;if(O&1|0){K=f[Q>>2]|0;if(!(K&1))Z=lSa(Q)|0;else Z=K&-2;vqc(Z,O&-2)}O=f[H+8>>2]|0;if(O&3|0){if(O&1|0)f[Y+16>>2]=f[H+16>>2];if(O&2|0)f[Y+20>>2]=f[H+20>>2];H=Y+8|0;f[H>>2]=f[H>>2]|O}}if(e&536870912|0){O=a+8|0;f[O>>2]=f[O>>2]|536870912;O=a+276|0;H=f[O>>2]|0;if(!H){K=$Xc(24)|0;x1a(K);f[O>>2]=K;_=K}else _=H;H=f[c+276>>2]|0;K=H|0?H:532944;H=_+4|0;O=f[K+4>>2]|0;if(O&1|0){Q=f[H>>2]|0;if(!(Q&1))$=lSa(H)|0;else $=Q&-2;vqc($,O&-2)}O=f[K+8>>2]|0;if(O&3|0){if(O&1|0)b[_+16>>0]=b[K+16>>0]|0;if(O&2|0)f[_+20>>2]=f[K+20>>2];K=_+8|0;f[K>>2]=f[K>>2]|O}}do if(e&1073741824|0){O=a+8|0;f[O>>2]=f[O>>2]|1073741824;O=a+280|0;K=f[O>>2]|0;if(!K){Q=$Xc(28)|0;y1a(Q);f[O>>2]=Q;aa=Q}else aa=K;K=f[c+280>>2]|0;Q=K|0?K:533472;K=aa+4|0;O=f[Q+4>>2]|0;if(O&1|0){H=f[K>>2]|0;if(!(H&1))ba=lSa(K)|0;else ba=H&-2;vqc(ba,O&-2)}O=f[Q+8>>2]|0;if(!(O&7))break;if(O&1|0)f[aa+16>>2]=f[Q+16>>2];if(O&2|0)f[aa+20>>2]=f[Q+20>>2];if(O&4|0)f[aa+24>>2]=f[Q+24>>2];Q=aa+8|0;f[Q>>2]=f[Q>>2]|O}while(0);if((e|0)<0){O=a+8|0;f[O>>2]=f[O>>2]|-2147483648;O=a+284|0;Q=f[O>>2]|0;if(!Q){H=$Xc(28)|0;z1a(H);f[O>>2]=H;ca=H}else ca=Q;Q=f[c+284>>2]|0;H=Q|0?Q:532760;Q=ca+4|0;O=f[H+4>>2]|0;if(O&1|0){K=f[Q>>2]|0;if(!(K&1))da=lSa(Q)|0;else da=K&-2;vqc(da,O&-2)}O=f[H+8>>2]|0;if(!(O&7))break;if(O&1|0)f[ca+16>>2]=f[H+16>>2];if(O&2|0)b[ca+20>>0]=b[H+20>>0]|0;if(O&4|0)f[ca+24>>2]=f[H+24>>2];H=ca+8|0;f[H>>2]=f[H>>2]|O}}while(0);if(!(f[c+12>>2]&1))return;ca=f[c+288>>2]|0;c=a+12|0;f[c>>2]=f[c>>2]|1;f[a+288>>2]=ca;return}function M0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{pab(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(60)|0;oab(l);pab(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,16304,64);l=RXb(i,64,2236)|0;oab(l);pab(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function N0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95836;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532856?(f[223093]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=43;b[d+8>>0]=0;J_b(892372,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=1;f[a+20>>2]=1;u=c;return}function O0a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=95728;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==532968;g=a+16|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223097]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=47;b[d+8>>0]=0;J_b(892388,d);a_b(d)}f[a+12>>2]=0;d=a+64|0;g=d;h=g+40|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));b[d+40>>0]=0;f[a+108>>2]=1;b[a+112>>0]=1;f[a+116>>2]=1;u=c;return}function P0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){xHa(e,(f[e>>2]|0)+g|0);o1c((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+28|0;e=c+28|0;g=f[e>>2]|0;if(g|0){xHa(h,(f[h>>2]|0)+g|0);o1c((f[a+36>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+36>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=a+40|0;h=c+40|0;g=f[h>>2]|0;if(g|0){xHa(e,(f[e>>2]|0)+g|0);o1c((f[a+48>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=a+52|0;e=c+52|0;g=f[e>>2]|0;if(g|0){xHa(h,(f[h>>2]|0)+g|0);o1c((f[a+60>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+60>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[e>>2]|0)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+64|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;i=d}else i=g;g=f[c+64>>2]|0;$_a(i,g|0?g:531776)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+68|0;i=f[g>>2]|0;if(!i){d=$Xc(48)|0;__a(d);f[g>>2]=d;j=d}else j=i;i=f[c+68>>2]|0;$_a(j,i|0?i:531776)}if(e&4|0)f[a+72>>2]=f[c+72>>2];if(e&8|0)f[a+76>>2]=f[c+76>>2];if(e&16|0)f[a+80>>2]=f[c+80>>2];if(e&32|0)f[a+84>>2]=f[c+84>>2];if(e&64|0)f[a+88>>2]=f[c+88>>2];if(e&128|0)f[a+92>>2]=f[c+92>>2];i=a+8|0;f[i>>2]=f[i>>2]|e}if(!(e&16128))return;if(e&256|0)f[a+96>>2]=f[c+96>>2];if(e&512|0)f[a+100>>2]=f[c+100>>2];if(e&1024|0)b[a+104>>0]=b[c+104>>0]|0;if(e&2048|0)f[a+108>>2]=f[c+108>>2];if(e&4096|0)b[a+112>>0]=b[c+112>>0]|0;if(e&8192|0)f[a+116>>2]=f[c+116>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Q0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95620;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533120?(f[223099]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=49;b[d+8>>0]=0;J_b(892396,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;n[a+44>>2]=1.0;f[a+48>>2]=4;u=c;return}function R0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==537368){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)b[a+36>>0]=b[c+36>>0]|0;if(e&64|0)b[a+37>>0]=b[c+37>>0]|0;if(e&128|0)f[a+40>>2]=f[c+40>>2];d=a+8|0;f[d>>2]=f[d>>2]|e}if(!(e&768))return;if(e&256|0)f[a+44>>2]=f[c+44>>2];if(e&512|0)f[a+48>>2]=f[c+48>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function S0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95512;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533248?(f[223102]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=52;b[d+8>>0]=0;J_b(892408,d);a_b(d)}f[a+12>>2]=0;n[a+16>>2]=.5;b[a+20>>0]=1;u=c;return}function T0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95404;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533528?(f[223109]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=59;b[d+8>>0]=0;J_b(892436,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;d=a+20|0;f[d>>2]=0;b[d+4>>0]=0;u=c;return}function U0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&7))return;do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);if(e&2|0)f[a+20>>2]=f[c+20>>2];if(e&4|0)b[a+24>>0]=b[c+24>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function V0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95296;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533608?(f[223112]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=62;b[d+8>>0]=0;J_b(892448,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;d=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;b[a+48>>0]=1;n[a+52>>2]=1.0;f[a+56>>2]=1;u=c;return}function W0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==537368){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+24|0,h=f[c+24>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==537368){mHa(d,h);break}else{oYc(g,h)|0;break}while(0);if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)b[a+36>>0]=b[c+36>>0]|0;if(e&64|0)b[a+37>>0]=b[c+37>>0]|0;if(e&128|0)f[a+40>>2]=f[c+40>>2];h=a+8|0;f[h>>2]=f[h>>2]|e}if(!(e&3840))return;if(e&256|0)f[a+44>>2]=f[c+44>>2];if(e&512|0)b[a+48>>0]=b[c+48>>0]|0;if(e&1024|0)f[a+52>>2]=f[c+52>>2];if(e&2048|0)f[a+56>>2]=f[c+56>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function X0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95188;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533672?(f[223113]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=63;b[d+8>>0]=0;J_b(892452,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;u=c;return}function Y0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=95080;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533696?(f[223114]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=64;b[d+8>>0]=0;J_b(892456,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0;b[a+29>>0]=1;f[a+32>>2]=1;u=c;return}function Z0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&63))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;$_a(i,g|0?g:531776)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=$Xc(48)|0;__a(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;$_a(j,i|0?i:531776)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)b[a+28>>0]=b[c+28>>0]|0;if(e&16|0)b[a+29>>0]=b[c+29>>0]|0;if(e&32|0)f[a+32>>2]=f[c+32>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function _0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94972;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533800?(f[223117]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=67;b[d+8>>0]=0;J_b(892468,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0;u=c;return}function $0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&63))return;if(d&1|0)f[a+16>>2]=f[b+16>>2];if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];if(d&8|0)f[a+28>>2]=f[b+28>>2];if(d&16|0)f[a+32>>2]=f[b+32>>2];if(d&32|0)f[a+36>>2]=f[b+36>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function a1a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=94864;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533920?(f[223121]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=71;b[d+8>>0]=0;J_b(892484,d);a_b(d)}d=a+12|0;e=a+60|0;g=d;h=g+44|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));b[d+44>>0]=0;f[e>>2]=1;b[a+64>>0]=1;u=c;return}function b1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){if(e&1|0)f[a+16>>2]=f[c+16>>2];if(e&2|0)f[a+20>>2]=f[c+20>>2];if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)f[a+36>>2]=f[c+36>>2];if(e&64|0)f[a+40>>2]=f[c+40>>2];if(e&128|0)f[a+44>>2]=f[c+44>>2];h=a+8|0;f[h>>2]=f[h>>2]|e}if(!(e&7936))return;if(e&256|0)f[a+48>>2]=f[c+48>>2];if(e&512|0)f[a+52>>2]=f[c+52>>2];if(e&1024|0)b[a+56>>0]=b[c+56>>0]|0;if(e&2048|0)f[a+60>>2]=f[c+60>>2];if(e&4096|0)b[a+64>>0]=b[c+64>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function c1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94756;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534376?(f[223135]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=85;b[d+8>>0]=0;J_b(892540,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=535216;f[a+28>>2]=537368;d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;n[a+48>>2]=1.0;n[a+52>>2]=.5;n[a+56>>2]=.5;n[a+60>>2]=.25;u=c;return}function d1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(e&255|0){do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==537368){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+24|0,h=f[c+24>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==535216){mHa(d,h);break}else{oYc(g,h)|0;break}while(0);do if(e&8|0?(h=a+8|0,f[h>>2]=f[h>>2]|8,h=a+28|0,g=f[c+28>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);if(e&16|0)f[a+32>>2]=f[c+32>>2];if(e&32|0)f[a+36>>2]=f[c+36>>2];if(e&64|0)b[a+40>>0]=b[c+40>>0]|0;if(e&128|0)b[a+41>>0]=b[c+41>>0]|0;g=a+8|0;f[g>>2]=f[g>>2]|e}if(!(e&7936))return;if(e&256|0)f[a+44>>2]=f[c+44>>2];if(e&512|0)f[a+48>>2]=f[c+48>>2];if(e&1024|0)f[a+52>>2]=f[c+52>>2];if(e&2048|0)f[a+56>>2]=f[c+56>>2];if(e&4096|0)f[a+60>>2]=f[c+60>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function e1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94648;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533992?(f[223122]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=72;b[d+8>>0]=0;J_b(892488,d);a_b(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=1.0;n[a+24>>2]=1.0;u=c;return}function f1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94540;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533840?(f[223118]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=68;b[d+8>>0]=0;J_b(892472,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;u=c;return}function g1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94432;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532824?(f[223092]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=42;b[d+8>>0]=0;J_b(892368,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=1;u=c;return}function h1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94324;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=533368?(f[223104]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=54;b[d+8>>0]=0;J_b(892416,d);a_b(d)}f[a+12>>2]=0;f[a+28>>2]=1;b[a+32>>0]=1;u=c;return}function i1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=f[c+8>>2]|0;if(!(h&3))return;if(h&1|0)f[a+28>>2]=f[c+28>>2];if(h&2|0)b[a+32>>0]=b[c+32>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|h;return}function j1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94216;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534352?(f[223134]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=84;b[d+8>>0]=0;J_b(892536,d);a_b(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;u=c;return}function k1a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=94108;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==533272;g=a+16|0;h=g+80|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[223103]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=53;b[d+8>>0]=0;J_b(892412,d);a_b(d)}f[a+12>>2]=0;u=c;return}function l1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d5a(a+16|0,b+16|0);d=a+32|0;g=b+32|0;e=f[g>>2]|0;if(e|0){xHa(d,(f[d>>2]|0)+e|0);o1c((f[a+40>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+44|0;d=b+44|0;e=f[d>>2]|0;if(e|0){xHa(g,(f[g>>2]|0)+e|0);o1c((f[a+52>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+52>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0)}d=a+56|0;g=b+56|0;e=f[g>>2]|0;if(e|0){xHa(d,(f[d>>2]|0)+e|0);o1c((f[a+64>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+64>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=a+68|0;d=b+68|0;e=f[d>>2]|0;if(!e){h=a+80|0;i=b+80|0;e5a(h,i);return}xHa(g,(f[g>>2]|0)+e|0);o1c((f[a+76>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+76>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[d>>2]|0);h=a+80|0;i=b+80|0;e5a(h,i);return}function m1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=94e3;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532792?(f[223091]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=41;b[d+8>>0]=0;J_b(892364,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1;u=c;return}function n1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93892;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533584?(f[223111]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=61;b[d+8>>0]=0;J_b(892444,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=1;u=c;return}function o1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93784;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534120?(f[223126]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=76;b[d+8>>0]=0;J_b(892504,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function p1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93676;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=534240?(f[223130]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=80;b[d+8>>0]=0;J_b(892520,d);a_b(d)}f[a+12>>2]=0;f[a+28>>2]=1;f[a+32>>2]=1;u=c;return}function q1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){xHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}g=f[b+8>>2]|0;if(!(g&3))return;if(g&1|0)f[a+28>>2]=f[b+28>>2];if(g&2|0)f[a+32>>2]=f[b+32>>2];b=a+8|0;f[b>>2]=f[b>>2]|g;return}function r1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93568;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533872?(f[223119]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=69;b[d+8>>0]=0;J_b(892476,d);a_b(d)}f[a+12>>2]=0;b[a+16>>0]=0;b[a+17>>0]=1;n[a+20>>2]=9.999999717180685e-10;u=c;return}function s1a(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=93460;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=532712?(f[223089]|0)!=2:0){f[e>>2]=165456;f[e+4>>2]=39;b[e+8>>0]=0;J_b(892356,e);a_b(e)}f[a+12>>2]=0;f[a+28>>2]=537368;e=a+32|0;f[e>>2]=0;d[e+4>>1]=0;b[e+6>>0]=0;n[a+40>>2]=1.0;u=c;return}function t1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=a+16|0;h=c+16|0;g=f[h>>2]|0;if(g|0){uHa(e,(f[e>>2]|0)+g|0);o1c((f[a+24>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[h>>2]|0)}h=f[c+8>>2]|0;if(!(h&63))return;do if(h&1|0?(e=a+8|0,f[e>>2]=f[e>>2]|1,e=a+28|0,g=f[c+28>>2]|0,d=f[e>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(e,g);break}else{oYc(d,g)|0;break}while(0);if(h&2|0)f[a+32>>2]=f[c+32>>2];if(h&4|0)b[a+36>>0]=b[c+36>>0]|0;if(h&8|0)b[a+37>>0]=b[c+37>>0]|0;if(h&16|0)b[a+38>>0]=b[c+38>>0]|0;if(h&32|0)f[a+40>>2]=f[c+40>>2];c=a+8|0;f[c>>2]=f[c>>2]|h;return}function u1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93352;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534304?(f[223132]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=82;b[d+8>>0]=0;J_b(892528,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function v1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93244;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534216?(f[223129]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=79;b[d+8>>0]=0;J_b(892516,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function w1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93136;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534280?(f[223131]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=81;b[d+8>>0]=0;J_b(892524,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;u=c;return}function x1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=93028;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532944?(f[223096]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=46;b[d+8>>0]=0;J_b(892384,d);a_b(d)}f[a+12>>2]=0;b[a+16>>0]=0;n[a+20>>2]=1.0;u=c;return}function y1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92920;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533472?(f[223107]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=57;b[d+8>>0]=0;J_b(892428,d);a_b(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0;u=c;return}function z1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92812;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532760?(f[223090]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=40;b[d+8>>0]=0;J_b(892360,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+24>>2]=1;u=c;return}function A1a(a){a=a|0;var b=0,c=0;f[a>>2]=92812;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function B1a(a){a=a|0;var b=0,c=0;f[a>>2]=92812;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function C1a(a){a=a|0;a=$Xc(28)|0;z1a(a);return a|0}function D1a(a,b){a=a|0;b=b|0;a=$Xc(28)|0;z1a(a);if(!b)return a|0;P1a(b,a);return a|0}function E1a(a){a=a|0;var c=0,d=0;c=a+8|0;if(f[c>>2]&7|0){d=a+16|0;f[d>>2]=0;b[d+4>>0]=0;f[a+24>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function F1a(a){a=a|0;return 1}function G1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+20|0;k=e+8|0;l=a+4|0;m=a+24|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=7}else{r=o;q=6}}else{r=0;q=6}if((q|0)==6){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=7}else s=o}c:do if((q|0)==7){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break c}f[h>>2]=f[h>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;t=n}else{v=n;q=12}}else{v=0;q=12}if((q|0)==12){q=0;n=KYb(c,v)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)t=n;else{w=0;q=36;break a}}f[i>>2]=t;continue b;break}case 2:{if((p&255|0)!=16){s=p;break c}f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;x=o<<24>>24!=0}else{LYb(e,c);o=e;if(!(b[k>>0]|0)){w=0;q=36;break a}else x=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[j>>0]=x&1;continue b;break}case 3:{if((p&255|0)==24)break b;else{s=p;break c}break}default:{s=p;break c}}}while(0);if(!s){w=1;q=36;break a}o=f[l>>2]|0;if(!(o&1))y=lSa(l)|0;else y=o&-2;if(!(Lqc(c,s,y)|0)){w=0;q=36;break a}}o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){n=b[o>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=o+1;z=a}else{A=a;q=24}}else{A=0;q=24}if((q|0)==24){q=0;a=KYb(c,A)|0;o=J;if((o|0)>-1|(o|0)==-1&a>>>0>4294967295)z=a;else{w=0;q=36;break}}if(z>>>0<4){f[h>>2]=f[h>>2]|4;f[m>>2]=z;continue}a=f[l>>2]|0;if(!(a&1))B=lSa(l)|0;else B=a&-2;yqc(B,3,z,((z|0)<0)<<31>>31)}if((q|0)==36){u=d;return w|0}return 0}function H1a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}c=b&2|0?g+2|0:g;if(!(b&4)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+24>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+c|0;e=a+12|0;f[e>>2]=d;return d|0}function I1a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)S_b(1,f[a+16>>2]|0,c);if(d&2|0)c$b(2,(b[a+20>>0]|0)!=0,c);if(d&4|0)d$b(3,f[a+24>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function J1a(a){a=a|0;return f[a+12>>2]|0}function K1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{o=b[a+20>>0]|0;b[e>>0]=16;b[e+1>>0]=o;q=e+2|0}if(!(c&4))r=q;else{c=f[a+24>>2]|0;b[q>>0]=24;e=q+1|0;q=c&255;if(c>>>0>127){o=e;p=q;d=c;h=((c|0)<0)<<31>>31;while(1){b[o>>0]=p|-128;c=d;d=l1c(d|0,h|0,7)|0;l=o+1|0;j=d&255;if(!(h>>>0>0|(h|0)==0&c>>>0>16383)){s=l;t=j;break}else{o=l;p=j;h=J}}}else{s=e;t=q}b[s>>0]=t;r=s+1|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Pqc(s&-2,r)|0;return u|0}function L1a(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))return;d=a+8|0;if(f[d>>2]&7|0){e=a+16|0;f[e>>2]=0;b[e+4>>0]=0;f[a+24>>2]=1}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);M1a(a,c);return}function M1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,15840,0)|0;if(!d){Ooc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&7))return;if(e&1|0)f[a+16>>2]=f[d+16>>2];if(e&2|0)b[a+20>>0]=b[d+20>>0]|0;if(e&4|0)f[a+24>>2]=f[d+24>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function N1a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function O1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535384;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function P1a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Q1a(a){a=a|0;var b=0,c=0;f[a>>2]=92920;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function R1a(a){a=a|0;var b=0,c=0;f[a>>2]=92920;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function S1a(a){a=a|0;a=$Xc(28)|0;y1a(a);return a|0}function T1a(a,b){a=a|0;b=b|0;a=$Xc(28)|0;y1a(a);if(!b)return a|0;d2a(b,a);return a|0}function U1a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function V1a(a){a=a|0;return 1}function W1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+24|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(WYb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=21){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;v=a}else{if(!(WYb(c,e)|0)){q=20;break a}v=f[e>>2]|0}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;w=o}else{if(!(WYb(c,e)|0)){q=27;break a}w=f[e>>2]|0}f[l>>2]=w;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=33;break}o=f[m>>2]|0;if(!(o&1))y=lSa(m)|0;else y=o&-2;if(!(Lqc(c,s,y)|0)){x=0;q=33;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==20){x=0;u=d;return x|0}else if((q|0)==27){x=0;u=d;return x|0}else if((q|0)==33){u=d;return x|0}return 0}function X1a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function Y1a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)a$b(1,+n[a+20>>2],b);if(c&4|0)a$b(2,+n[a+24>>2],b);if(c&1|0)a$b(3,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Z1a(a){a=a|0;return f[a+12>>2]|0}function _1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=f[a+24>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&1))j=i;else{c=f[a+16>>2]|0;b[i>>0]=29;e=i+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;j=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Pqc(i&-2,j)|0;return k|0}function $1a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);a2a(a,b);return}function a2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15856,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function b2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function c2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535520;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function d2a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function e2a(a){a=a|0;var b=0,c=0;f[a>>2]=93028;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function f2a(a){a=a|0;var b=0,c=0;f[a>>2]=93028;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function g2a(a){a=a|0;a=$Xc(24)|0;x1a(a);return a|0}function h2a(a,b){a=a|0;b=b|0;a=$Xc(24)|0;x1a(a);if(!b)return a|0;t2a(b,a);return a|0}function i2a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&3|0){b[a+16>>0]=0;n[a+20>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function j2a(a){a=a|0;return 1}function k2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+16|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(WYb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|1;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;v=o<<24>>24!=0}else{LYb(e,c);o=e;if(!(b[l>>0]|0)){w=0;q=25;break a}else v=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[k>>0]=v&1;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=25;break}o=f[m>>2]|0;if(!(o&1))x=lSa(m)|0;else x=o&-2;if(!(Lqc(c,s,x)|0)){w=0;q=25;break}}if((q|0)==13){w=0;u=d;return w|0}else if((q|0)==25){u=d;return w|0}return 0}function l2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;d=b&2|0?g+5|0:g;e=a+12|0;f[e>>2]=d;return d|0}function m2a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&2|0)a$b(1,+n[a+20>>2],c);if(d&1|0)c$b(2,(b[a+16>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function n2a(a){a=a|0;return f[a+12>>2]|0}function o2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&1))i=e;else{c=b[a+16>>0]|0;b[e>>0]=16;b[e+1>>0]=c;i=e+2|0}e=f[a+4>>2]|0;if(!(e&1)){j=i;return j|0}j=Pqc(e&-2,i)|0;return j|0}function p2a(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))return;d=a+8|0;if(f[d>>2]&3|0){b[a+16>>0]=0;n[a+20>>2]=1.0}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);q2a(a,c);return}function q2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,15872,0)|0;if(!d){Ooc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&3))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)f[a+20>>2]=f[d+20>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function r2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535432;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function t2a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function u2a(a){a=a|0;var b=0,c=0;f[a>>2]=93136;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function v2a(a){a=a|0;var b=0,c=0;f[a>>2]=93136;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function w2a(a){a=a|0;a=$Xc(24)|0;w1a(a);return a|0}function x2a(a,b){a=a|0;b=b|0;a=$Xc(24)|0;w1a(a);if(!b)return a|0;J2a(b,a);return a|0}function y2a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function z2a(a){a=a|0;return 1}function A2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=c+4|0;e=a+8|0;g=a+20|0;h=a+4|0;i=a+16|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=7}else{n=k;m=6}}else{n=0;m=6}if((m|0)==6){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=7}else o=k}c:do if((m|0)==7){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)==8)break b;else{o=l;break c}break}case 2:break;default:{o=l;break c}}if((l&255|0)==16){f[e>>2]=f[e>>2]|2;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=23}}else{q=0;m=23}if((m|0)==23){m=0;j=KYb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=30;break a}}f[g>>2]=p;continue b}else o=l}while(0);if(!o){r=1;m=30;break a}j=f[h>>2]|0;if(!(j&1))s=lSa(h)|0;else s=j&-2;if(!(Lqc(c,o,s)|0)){r=0;m=30;break a}}j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;t=a}else{u=a;m=12}}else{u=0;m=12}if((m|0)==12){m=0;a=KYb(c,u)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)t=a;else{r=0;m=30;break}}if(t>>>0<3){f[e>>2]=f[e>>2]|1;f[i>>2]=t;continue}a=f[h>>2]|0;if(!(a&1))v=lSa(h)|0;else v=a&-2;yqc(v,1,t,((t|0)<0)<<31>>31)}if((m|0)==30)return r|0;return 0}function B2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function C2a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)d$b(1,f[a+16>>2]|0,b);if(c&2|0)S_b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function D2a(a){a=a|0;return f[a+12>>2]|0}function E2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=l1c(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function F2a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);G2a(a,b);return}function G2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15888,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function H2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function I2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535712;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function J2a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function K2a(a){a=a|0;var b=0,c=0;f[a>>2]=93244;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function L2a(a){a=a|0;var b=0,c=0;f[a>>2]=93244;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function M2a(a){a=a|0;a=$Xc(20)|0;v1a(a);return a|0}function N2a(a,b){a=a|0;b=b|0;a=$Xc(20)|0;v1a(a);if(!b)return a|0;Z2a(b,a);return a|0}function O2a(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function P2a(a){a=a|0;return 1}function Q2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=ZYb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==8){j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){a=b[j>>0]|0;i=a&255;if(a<<24>>24>-1){f[c>>2]=j+1;o=i}else{p=i;l=10}}else{p=0;l=10}if((l|0)==10){l=0;i=KYb(c,p)|0;j=J;if((j|0)>-1|(j|0)==-1&i>>>0>4294967295)o=i;else{q=0;l=22;break}}if(o>>>0<3){f[e>>2]=f[e>>2]|1;f[g>>2]=o;continue}i=f[h>>2]|0;if(!(i&1))r=lSa(h)|0;else r=i&-2;yqc(r,1,o,((o|0)<0)<<31>>31);continue}else n=k}if(!n){q=1;l=22;break}i=f[h>>2]|0;if(!(i&1))s=lSa(h)|0;else s=i&-2;if(!(Lqc(c,n,s)|0)){q=0;l=22;break}}if((l|0)==22)return q|0;return 0}function R2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;if((b|0)<0)g=11;else g=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0;e=a+12|0;f[e>>2]=d;return d|0}function S2a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)d$b(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function T2a(a){a=a|0;return f[a+12>>2]|0}function U2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=l1c(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=e;return p|0}p=Pqc(n&-2,e)|0;return p|0}function V2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((a|0)==(b|0))return;c=a+16|0;f[c>>2]=0;d=a+8|0;f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=kZc(b,21568,15904,0)|0;if(!h){Ooc(b,a);return}a=f[h+4>>2]|0;if(a&1|0){b=f[e>>2]|0;if(!(b&1))i=lSa(e)|0;else i=b&-2;vqc(i,a&-2)}if(!(f[h+8>>2]&1))return;a=f[h+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=a;return}function W2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15904,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function X2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535696;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z2a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function _2a(a){a=a|0;var b=0,c=0;f[a>>2]=93352;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function $2a(a){a=a|0;var b=0,c=0;f[a>>2]=93352;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function a3a(a){a=a|0;a=$Xc(20)|0;u1a(a);return a|0}function b3a(a,b){a=a|0;b=b|0;a=$Xc(20)|0;u1a(a);if(!b)return a|0;n3a(b,a);return a|0}function c3a(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function d3a(a){a=a|0;return 1}function e3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=ZYb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==8){j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){a=b[j>>0]|0;i=a&255;if(a<<24>>24>-1){f[c>>2]=j+1;o=i}else{p=i;l=10}}else{p=0;l=10}if((l|0)==10){l=0;i=KYb(c,p)|0;j=J;if((j|0)>-1|(j|0)==-1&i>>>0>4294967295)o=i;else{q=0;l=22;break}}if(o>>>0<3){f[e>>2]=f[e>>2]|1;f[g>>2]=o;continue}i=f[h>>2]|0;if(!(i&1))r=lSa(h)|0;else r=i&-2;yqc(r,1,o,((o|0)<0)<<31>>31);continue}else n=k}if(!n){q=1;l=22;break}i=f[h>>2]|0;if(!(i&1))s=lSa(h)|0;else s=i&-2;if(!(Lqc(c,n,s)|0)){q=0;l=22;break}}if((l|0)==22)return q|0;return 0}function f3a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;if((b|0)<0)g=11;else g=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0;e=a+12|0;f[e>>2]=d;return d|0}function g3a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)d$b(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function h3a(a){a=a|0;return f[a+12>>2]|0}function i3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=l1c(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=e;return p|0}p=Pqc(n&-2,e)|0;return p|0}function j3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((a|0)==(b|0))return;c=a+16|0;f[c>>2]=0;d=a+8|0;f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=kZc(b,21568,15920,0)|0;if(!h){Ooc(b,a);return}a=f[h+4>>2]|0;if(a&1|0){b=f[e>>2]|0;if(!(b&1))i=lSa(e)|0;else i=b&-2;vqc(i,a&-2)}if(!(f[h+8>>2]&1))return;a=f[h+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=a;return}function k3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15920,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function l3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function m3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535720;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function n3a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function o3a(a){a=a|0;var c=0,d=0;f[a>>2]=93460;c=f[a+28>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function p3a(a){a=a|0;o3a(a);cYc(a);return}function q3a(a){a=a|0;a=$Xc(44)|0;s1a(a);return a|0}function r3a(a,b){a=a|0;b=b|0;a=$Xc(44)|0;s1a(a);if(!b)return a|0;D3a(b,a);return a|0}function s3a(a){a=a|0;var c=0,e=0,g=0,h=0;f[a+16>>2]=0;c=a+8|0;e=f[c>>2]|0;do if(e&1|0){g=f[a+28>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&62|0){e=a+32|0;f[e>>2]=0;d[e+4>>1]=0;b[e+6>>0]=0;n[a+40>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function t3a(a){a=a|0;return 1}function u3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+40|0;k=a+36|0;l=e+8|0;m=a+32|0;n=a+28|0;o=a+16|0;p=a+20|0;q=a+24|0;r=a+37|0;s=e+8|0;t=a+38|0;v=e+8|0;w=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=ZYb(c,B)|0;if((y+-1|0)>>>0<127){z=y;A=6}else C=y}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{if((z&255|0)!=13){C=z;break b}f[i>>2]=f[i>>2]|32;y=f[c>>2]|0;if(((f[g>>2]|0)-y|0)>3){a=y;x=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=x;f[c>>2]=y+4;D=x}else{if(!(WYb(c,e)|0)){A=13;break a}D=f[e>>2]|0}f[j>>2]=D;continue a;break}case 2:{if((z&255|0)!=16){C=z;break b}f[i>>2]=f[i>>2]|4;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(y=b[x>>0]|0,y<<24>>24>-1):0){f[c>>2]=x+1;E=y<<24>>24!=0}else{LYb(e,c);y=e;if(!(b[l>>0]|0)){F=0;A=63;break a}else E=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0}b[k>>0]=E&1;continue a;break}case 3:{if((z&255|0)!=24){C=z;break b}f[i>>2]=f[i>>2]|2;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){x=b[y>>0]|0;a=x&255;if(x<<24>>24>-1){f[m>>2]=a;f[c>>2]=y+1;continue a}else G=a}else G=0;a=KYb(c,G)|0;y=J;f[m>>2]=a;if((y|0)>-1|(y|0)==-1&a>>>0>4294967295)continue a;else{F=0;A=63;break a}break}case 4:{if((z&255|0)!=34){C=z;break b}f[i>>2]=f[i>>2]|1;a=f[n>>2]|0;if((a|0)==537368){mHa(n,537368);H=f[n>>2]|0}else H=a;if(l$b(c,H)|0)continue a;else{F=0;A=63;break a}break}case 5:{switch((z&255)<<24>>24){case 45:break;case 42:{if(_Za(c,o)|0)continue a;else{F=0;A=63;break a}break}default:{C=z;break b}}a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){y=a;x=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=x;f[c>>2]=a+4;I=x}else{if(!(WYb(c,e)|0)){A=44;break a}I=f[e>>2]|0}x=f[o>>2]|0;if((x|0)==(f[p>>2]|0)){uHa(o,x+1|0);K=f[o>>2]|0}else K=x;x=f[q>>2]|0;a=K+1|0;f[o>>2]=a;f[x+4+(K<<2)>>2]=I;y=f[c>>2]|0;L=(f[g>>2]|0)-y|0;if((L|0)<=0)continue a;M=y;y=(f[p>>2]|0)-a|0;N=(L>>>0)/5|0;O=(N|0)<(y|0)?N:y;if((O|0)>0){P=0;Q=M;R=a}else continue a;while(1){if((b[Q>>0]|0)!=45){S=P;break}a=Q+1|0;y=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=R;R=R+1|0;f[o>>2]=R;f[x+4+(a<<2)>>2]=y;y=P+1|0;if((y|0)>=(O|0)){S=y;break}else{P=y;Q=Q+5|0}}O=S*5|0;if((S|0)<=0)continue a;if((L|0)<(O|0)){SYb(c,O,L)|0;continue a}else{f[c>>2]=M+O;continue a}break}case 6:{if((z&255|0)!=48){C=z;break b}f[i>>2]=f[i>>2]|8;O=f[c>>2]|0;if(O>>>0<(f[g>>2]|0)>>>0?(x=b[O>>0]|0,x<<24>>24>-1):0){f[c>>2]=O+1;T=x<<24>>24!=0}else{LYb(e,c);x=e;if(!(b[s>>0]|0)){F=0;A=63;break a}else T=(f[x>>2]|0)!=0|(f[x+4>>2]|0)!=0}b[r>>0]=T&1;continue a;break}case 7:{if((z&255|0)!=56){C=z;break b}f[i>>2]=f[i>>2]|16;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(O=b[x>>0]|0,O<<24>>24>-1):0){f[c>>2]=x+1;U=O<<24>>24!=0}else{LYb(e,c);O=e;if(!(b[v>>0]|0)){F=0;A=63;break a}else U=(f[O>>2]|0)!=0|(f[O+4>>2]|0)!=0}b[t>>0]=U&1;continue a;break}default:{C=z;break b}}}while(0);if(!C){F=1;A=63;break}O=f[w>>2]|0;if(!(O&1))V=lSa(w)|0;else V=O&-2;if(!(Lqc(c,C,V)|0)){F=0;A=63;break}}if((A|0)==13){F=0;u=d;return F|0}else if((A|0)==44){F=0;u=d;return F|0}else if((A|0)==63){u=d;return F|0}return 0}function v3a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+16>>2]|0;e=c+d+(c<<2)|0;c=f[a+8>>2]|0;if(!(c&63)){g=e;h=a+12|0;f[h>>2]=g;return g|0}if(!(c&1))i=e;else{d=f[a+28>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;i=e+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=i;else l=i+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=c&4|0?l+2|0:l;l=c&8|0?i+2|0:i;i=c&16|0?l+2|0:l;g=c&32|0?i+5|0:i;h=a+12|0;f[h>>2]=g;return g|0}function w3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&32|0)a$b(1,+n[a+40>>2],c);if(d&4|0)c$b(2,(b[a+36>>0]|0)!=0,c);if(d&2|0)U_b(3,f[a+32>>2]|0,c);if(d&1|0)f$b(4,f[a+28>>2]|0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{a$b(5,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&8|0)c$b(6,(b[a+37>>0]|0)!=0,c);if(d&16|0)c$b(7,(b[a+38>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function x3a(a){a=a|0;return f[a+12>>2]|0}function y3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+8>>2]|0;if(!(c&32))e=d;else{g=f[a+40>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=b[a+36>>0]|0;b[e>>0]=16;b[e+1>>0]=d;i=e+2|0}if(!(c&2))j=i;else{e=f[a+32>>2]|0;b[i>>0]=24;d=i+1|0;if(e>>>0>127){i=e;g=d;while(1){b[g>>0]=i|128;h=i>>>7;k=g+1|0;if(i>>>0>16383){i=h;g=k}else{l=k;m=h;break}}}else{l=d;m=e}b[l>>0]=m;j=l+1|0}if(!(c&1))n=j;else{l=f[a+28>>2]|0;b[j>>0]=34;n=gZb(l,j+1|0)|0}j=f[a+16>>2]|0;if(!j)o=n;else{l=f[a+24>>2]|0;m=0;e=n;while(1){n=f[l+4+(m<<2)>>2]|0;b[e>>0]=45;d=e+1|0;b[d>>0]=n;b[d+1>>0]=n>>8;b[d+2>>0]=n>>16;b[d+3>>0]=n>>24;n=e+5|0;m=m+1|0;if((m|0)>=(j|0)){o=n;break}else e=n}}if(!(c&8))p=o;else{e=b[a+37>>0]|0;b[o>>0]=48;b[o+1>>0]=e;p=o+2|0}if(!(c&16))q=p;else{c=b[a+38>>0]|0;b[p>>0]=56;b[p+1>>0]=c;q=p+2|0}p=f[a+4>>2]|0;if(!(p&1)){r=q;return r|0}r=Pqc(p&-2,q)|0;return r|0}function z3a(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0;if((a|0)==(c|0))return;f[a+16>>2]=0;e=a+8|0;g=f[e>>2]|0;do if(g&1|0){h=f[a+28>>2]|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[i>>0]=0;break}}while(0);if(g&62|0){g=a+32|0;f[g>>2]=0;d[g+4>>1]=0;b[g+6>>0]=0;n[a+40>>2]=1.0}f[e>>2]=0;e=f[a+4>>2]|0;if(e&1|0?(g=e&-2,f[g>>2]|0):0)sqc(g);g=kZc(c,21568,15936,0)|0;if(!g){Ooc(c,a);return}else{t1a(a,g);return}}function A3a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15936,0)|0;if(!c){Ooc(b,a);return}else{t1a(a,c);return}}function B3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function C3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535376;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function D3a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function E3a(a){a=a|0;var b=0,c=0;f[a>>2]=93568;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function F3a(a){a=a|0;var b=0,c=0;f[a>>2]=93568;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function G3a(a){a=a|0;a=$Xc(24)|0;r1a(a);return a|0}function H3a(a,b){a=a|0;b=b|0;a=$Xc(24)|0;r1a(a);if(!b)return a|0;T3a(b,a);return a|0}function I3a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&7|0){b[a+16>>0]=0;b[a+17>>0]=1;n[a+20>>2]=9.999999717180685e-10}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function J3a(a){a=a|0;return 1}function K3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+17|0;k=e+8|0;l=a+16|0;m=e+8|0;n=a+20|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=ZYb(c,t)|0;if((q+-1|0)>>>0<127){r=q;s=6}else v=q}b:do if((s|0)==6){s=0;switch(r>>>3&536870911|0){case 1:{if((r&255|0)!=8){v=r;break b}f[i>>2]=f[i>>2]|2;q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0?(a=b[q>>0]|0,a<<24>>24>-1):0){f[c>>2]=q+1;w=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[k>>0]|0)){x=0;s=31;break a}else w=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[j>>0]=w&1;continue a;break}case 2:{if((r&255|0)!=16){v=r;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(q=b[a>>0]|0,q<<24>>24>-1):0){f[c>>2]=a+1;y=q<<24>>24!=0}else{LYb(e,c);q=e;if(!(b[m>>0]|0)){x=0;s=31;break a}else y=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}b[l>>0]=y&1;continue a;break}case 3:{if((r&255|0)!=29){v=r;break b}f[i>>2]=f[i>>2]|4;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){a=q;p=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=p;f[c>>2]=q+4;z=p}else{if(!(WYb(c,e)|0)){s=25;break a}z=f[e>>2]|0}f[n>>2]=z;continue a;break}default:{v=r;break b}}}while(0);if(!v){x=1;s=31;break}p=f[o>>2]|0;if(!(p&1))A=lSa(o)|0;else A=p&-2;if(!(Lqc(c,v,A)|0)){x=0;s=31;break}}if((s|0)==25){x=0;u=d;return x|0}else if((s|0)==31){u=d;return x|0}return 0}function L3a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;c=b&2|0?g+2|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function M3a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&2|0)c$b(1,(b[a+17>>0]|0)!=0,c);if(d&1|0)c$b(2,(b[a+16>>0]|0)!=0,c);if(d&4|0)a$b(3,+n[a+20>>2],c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function N3a(a){a=a|0;return f[a+12>>2]|0}function O3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=b[a+17>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}if(!(c&1))h=e;else{d=b[a+16>>0]|0;b[e>>0]=16;b[e+1>>0]=d;h=e+2|0}if(!(c&4))i=h;else{c=f[a+20>>2]|0;b[h>>0]=29;e=h+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;i=h+5|0}h=f[a+4>>2]|0;if(!(h&1)){j=i;return j|0}j=Pqc(h&-2,i)|0;return j|0}function P3a(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))return;d=a+8|0;if(f[d>>2]&7|0){b[a+16>>0]=0;b[a+17>>0]=1;n[a+20>>2]=9.999999717180685e-10}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);Q3a(a,c);return}function Q3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,15952,0)|0;if(!d){Ooc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&7))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)b[a+17>>0]=b[d+17>>0]|0;if(e&4|0)f[a+20>>2]=f[d+20>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function R3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function S3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535616;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function T3a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function U3a(a){a=a|0;var b=0,c=0;f[a>>2]=93676;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function V3a(a){a=a|0;var b=0,c=0;f[a>>2]=93676;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function W3a(a){a=a|0;a=$Xc(36)|0;p1a(a);return a|0}function X3a(a,b){a=a|0;b=b|0;a=$Xc(36)|0;p1a(a);if(!b)return a|0;i4a(b,a);return a|0}function Y3a(a){a=a|0;var b=0;f[a+16>>2]=0;b=a+8|0;if(f[b>>2]&3|0){f[a+28>>2]=1;f[a+32>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Z3a(a){a=a|0;return 1}function _3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=c+4|0;e=a+8|0;g=a+28|0;h=a+16|0;i=a+20|0;j=a+24|0;k=a+32|0;l=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}b:do if((p|0)==6){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)!=8){r=o;break b}f[e>>2]=f[e>>2]|1;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[g>>2]=m;f[c>>2]=n+1;continue a}else s=m}else s=0;m=KYb(c,s)|0;n=J;f[g>>2]=m;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)continue a;else{t=0;p=40;break a}break}case 2:{switch((o&255)<<24>>24){case 16:break;case 18:{if(h4a(c,h)|0)continue a;else{t=0;p=40;break a}break}default:{r=o;break b}}m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){n=b[m>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=m+1;u=a}else{v=a;p=16}}else{v=0;p=16}if((p|0)==16){p=0;a=KYb(c,v)|0;m=J;if((m|0)>-1|(m|0)==-1&a>>>0>4294967295)u=a;else{t=0;p=40;break a}}a=f[h>>2]|0;if((a|0)==(f[i>>2]|0)){xHa(h,a+1|0);w=f[h>>2]|0}else w=a;a=f[j>>2]|0;f[h>>2]=w+1;f[a+4+(w<<2)>>2]=u;m=(f[i>>2]|0)-(f[h>>2]|0)|0;if((m|0)>0){x=m;y=a}else continue a;while(1){a=f[c>>2]|0;m=f[d>>2]|0;if(a>>>0>=m>>>0)continue a;if((b[a>>0]|0)!=16)continue a;n=a+1|0;f[c>>2]=n;if(n>>>0<m>>>0){m=b[n>>0]|0;n=m&255;if(m<<24>>24>-1){f[c>>2]=a+2;z=n;A=y}else{B=n;p=24}}else{B=0;p=24}if((p|0)==24){p=0;n=KYb(c,B)|0;a=J;if(!((a|0)>-1|(a|0)==-1&n>>>0>4294967295)){t=0;p=40;break a}z=n;A=f[j>>2]|0}n=f[h>>2]|0;f[h>>2]=n+1;f[A+4+(n<<2)>>2]=z;if((x|0)>1){x=x+-1|0;y=A}else continue a}break}case 3:{if((o&255|0)!=24){r=o;break b}f[e>>2]=f[e>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;C=m}else{D=m;p=33}}else{D=0;p=33}if((p|0)==33){p=0;m=KYb(c,D)|0;n=J;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)C=m;else{t=0;p=40;break a}}f[k>>2]=C;continue a;break}default:{r=o;break b}}}while(0);if(!r){t=1;p=40;break}m=f[l>>2]|0;if(!(m&1))E=lSa(l)|0;else E=m&-2;if(!(Lqc(c,r,E)|0)){t=0;p=40;break}}if((p|0)==40)return t|0;return 0}function $3a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=o$b(a+16|0)|0;d=b+c+(f[a+16>>2]|0)|0;c=f[a+8>>2]|0;if(!(c&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else h=d+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&2)){e=h;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+32>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=i+h|0;g=a+12|0;f[g>>2]=e;return e|0}function a4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+8>>2]|0;if(c&1|0)U_b(1,f[a+28>>2]|0,b);d=f[a+16>>2]|0;if((d|0)>0){e=a+24|0;g=0;do{U_b(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(c&2|0)S_b(3,f[a+32>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function b4a(a){a=a|0;return f[a+12>>2]|0}function c4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+28>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}l=f[a+16>>2]|0;if(!l)n=e;else{m=f[a+24>>2]|0;g=0;h=e;while(1){e=f[m+4+(g<<2)>>2]|0;b[h>>0]=16;i=h+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;o=j+1|0;if(d>>>0>16383){d=k;j=o}else{p=o;q=k;break}}}else{p=i;q=e}b[p>>0]=q;j=p+1|0;g=g+1|0;if((g|0)>=(l|0)){n=j;break}else h=j}}if(!(c&2))r=n;else{c=f[a+32>>2]|0;b[n>>0]=24;h=n+1|0;n=c&255;if(c>>>0>127){l=h;g=n;p=c;q=((c|0)<0)<<31>>31;while(1){b[l>>0]=g|-128;c=p;p=l1c(p|0,q|0,7)|0;m=l+1|0;j=p&255;if(!(q>>>0>0|(q|0)==0&c>>>0>16383)){s=m;t=j;break}else{l=m;g=j;q=J}}}else{s=h;t=n}b[s>>0]=t;r=s+1|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=Pqc(s&-2,r)|0;return u|0}function d4a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;f[a+16>>2]=0;c=a+8|0;if(f[c>>2]&3|0){f[a+28>>2]=1;f[a+32>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,15968,0)|0;if(!d){Ooc(b,a);return}else{q1a(a,d);return}}function e4a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,15968,0)|0;if(!c){Ooc(b,a);return}else{q1a(a,c);return}}function f4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function g4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535704;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function h4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;if(d>>>0<(f[e>>2]|0)>>>0?(g=b[d>>0]|0,g<<24>>24>-1):0){f[a>>2]=d+1;h=g&255}else{g=YYb(a)|0;if((g|0)>-1)h=g;else{i=0;return i|0}}g=HYb(a,h)|0;a:do if((PYb(a)|0)>0){h=c+4|0;d=c+8|0;while(1){j=f[a>>2]|0;if(j>>>0<(f[e>>2]|0)>>>0){k=b[j>>0]|0;l=k&255;if(k<<24>>24>-1){f[a>>2]=j+1;m=l}else{n=l;o=10}}else{n=0;o=10}if((o|0)==10){o=0;l=KYb(a,n)|0;j=J;if((j|0)>-1|(j|0)==-1&l>>>0>4294967295)m=l;else{i=0;break}}l=f[c>>2]|0;if((l|0)==(f[h>>2]|0)){xHa(c,l+1|0);p=f[c>>2]|0}else p=l;l=f[d>>2]|0;f[c>>2]=p+1;f[l+4+(p<<2)>>2]=m;if((PYb(a)|0)<=0)break a}return i|0}while(0);IYb(a,g);i=1;return i|0}function i4a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function j4a(a){a=a|0;var b=0,c=0;f[a>>2]=93784;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function k4a(a){a=a|0;var b=0,c=0;f[a>>2]=93784;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function l4a(a){a=a|0;a=$Xc(24)|0;o1a(a);return a|0}function m4a(a,b){a=a|0;b=b|0;a=$Xc(24)|0;o1a(a);if(!b)return a|0;y4a(b,a);return a|0}function n4a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&3|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function o4a(a){a=a|0;return 1}function p4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+4|0;l=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=7}else{q=n;p=6}}else{q=0;p=6}if((p|0)==6){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=7}else r=n}c:do if((p|0)==7){p=0;switch(o>>>3&536870911|0){case 1:break;case 2:{if((o&255|0)==16)break b;else{r=o;break c}break}default:{r=o;break c}}if((o&255|0)==13){f[i>>2]=f[i>>2]|1;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){a=n;m=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=m;f[c>>2]=n+4;s=m}else{if(!(WYb(c,e)|0)){p=14;break a}s=f[e>>2]|0}f[j>>2]=s;continue b}else r=o}while(0);if(!r){t=1;p=31;break a}m=f[k>>2]|0;if(!(m&1))v=lSa(k)|0;else v=m&-2;if(!(Lqc(c,r,v)|0)){t=0;p=31;break a}}m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n=b[m>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=m+1;w=a}else{x=a;p=19}}else{x=0;p=19}if((p|0)==19){p=0;a=KYb(c,x)|0;m=J;if((m|0)>-1|(m|0)==-1&a>>>0>4294967295)w=a;else{t=0;p=31;break}}if(w>>>0<3){f[i>>2]=f[i>>2]|2;f[l>>2]=w;continue}a=f[k>>2]|0;if(!(a&1))y=lSa(k)|0;else y=a&-2;yqc(y,2,w,((w|0)<0)<<31>>31)}if((p|0)==14){t=0;u=d;return t|0}else if((p|0)==31){u=d;return t|0}return 0}function q4a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)h=11;else h=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=h+g|0;e=a+12|0;f[e>>2]=d;return d|0}function r4a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)a$b(1,+n[a+16>>2],b);if(c&2|0)d$b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function s4a(a){a=a|0;return f[a+12>>2]|0}function t4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{c=f[a+20>>2]|0;b[e>>0]=16;d=e+1|0;e=c&255;if(c>>>0>127){g=d;h=e;j=c;k=((c|0)<0)<<31>>31;while(1){b[g>>0]=h|-128;c=j;j=l1c(j|0,k|0,7)|0;l=g+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{g=l;h=m;k=J}}}else{n=d;o=e}b[n>>0]=o;i=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=i;return p|0}p=Pqc(n&-2,i)|0;return p|0}function u4a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);v4a(a,b);return}function v4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,15984,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function w4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function x4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535672;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function y4a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function z4a(a){a=a|0;var b=0,c=0;f[a>>2]=93892;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function A4a(a){a=a|0;var b=0,c=0;f[a>>2]=93892;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function B4a(a){a=a|0;a=$Xc(20)|0;n1a(a);return a|0}function C4a(a,b){a=a|0;b=b|0;a=$Xc(20)|0;n1a(a);if(!b)return a|0;O4a(b,a);return a|0}function D4a(a){a=a|0;var b=0;f[a+16>>2]=1;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function E4a(a){a=a|0;return 1}function F4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=ZYb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==8){j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){a=b[j>>0]|0;i=a&255;if(a<<24>>24>-1){f[c>>2]=j+1;o=i}else{p=i;l=10}}else{p=0;l=10}if((l|0)==10){l=0;i=KYb(c,p)|0;j=J;if((j|0)>-1|(j|0)==-1&i>>>0>4294967295)o=i;else{q=0;l=22;break}}if((o+-1|0)>>>0<2){f[e>>2]=f[e>>2]|1;f[g>>2]=o;continue}i=f[h>>2]|0;if(!(i&1))r=lSa(h)|0;else r=i&-2;yqc(r,1,o,((o|0)<0)<<31>>31);continue}else n=k}if(!n){q=1;l=22;break}i=f[h>>2]|0;if(!(i&1))s=lSa(h)|0;else s=i&-2;if(!(Lqc(c,n,s)|0)){q=0;l=22;break}}if((l|0)==22)return q|0;return 0}function G4a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;if((b|0)<0)g=11;else g=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0;e=a+12|0;f[e>>2]=d;return d|0}function H4a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)d$b(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function I4a(a){a=a|0;return f[a+12>>2]|0}function J4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=l1c(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+4>>2]|0;if(!(n&1)){p=e;return p|0}p=Pqc(n&-2,e)|0;return p|0}function K4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((a|0)==(b|0))return;c=a+16|0;f[c>>2]=1;d=a+8|0;f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=kZc(b,21568,16e3,0)|0;if(!h){Ooc(b,a);return}a=f[h+4>>2]|0;if(a&1|0){b=f[e>>2]|0;if(!(b&1))i=lSa(e)|0;else i=b&-2;vqc(i,a&-2)}if(!(f[h+8>>2]&1))return;a=f[h+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=a;return}function L4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16e3,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function M4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function N4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535552;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function O4a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function P4a(a){a=a|0;var b=0,c=0;f[a>>2]=94e3;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Q4a(a){a=a|0;var b=0,c=0;f[a>>2]=94e3;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function R4a(a){a=a|0;a=$Xc(28)|0;m1a(a);return a|0}function S4a(a,b){a=a|0;b=b|0;a=$Xc(28)|0;m1a(a);if(!b)return a|0;c5a(b,a);return a|0}function T4a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function U4a(a){a=a|0;return 1}function V4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+8|0;g=a+20|0;h=a+24|0;i=a+16|0;j=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=ZYb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}b:do if((n|0)==6){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)!=8){p=m;break b}f[e>>2]=f[e>>2]|2;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){a=b[l>>0]|0;k=a&255;if(a<<24>>24>-1){f[g>>2]=k;f[c>>2]=l+1;continue a}else q=k}else q=0;k=KYb(c,q)|0;l=J;f[g>>2]=k;if((l|0)>-1|(l|0)==-1&k>>>0>4294967295)continue a;else{r=0;n=29;break a}break}case 2:{if((m&255|0)!=16){p=m;break b}f[e>>2]=f[e>>2]|4;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){l=b[k>>0]|0;a=l&255;if(l<<24>>24>-1){f[c>>2]=k+1;s=a}else{t=a;n=16}}else{t=0;n=16}if((n|0)==16){n=0;a=KYb(c,t)|0;k=J;if((k|0)>-1|(k|0)==-1&a>>>0>4294967295)s=a;else{r=0;n=29;break a}}f[h>>2]=s;continue a;break}case 3:{if((m&255|0)!=24){p=m;break b}f[e>>2]=f[e>>2]|1;a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>-1){f[c>>2]=a+1;u=l}else{v=l;n=22}}else{v=0;n=22}if((n|0)==22){n=0;l=KYb(c,v)|0;a=J;if((a|0)>-1|(a|0)==-1&l>>>0>4294967295)u=l;else{r=0;n=29;break a}}f[i>>2]=u;continue a;break}default:{p=m;break b}}}while(0);if(!p){r=1;n=29;break}l=f[j>>2]|0;if(!(l&1))w=lSa(j)|0;else w=l&-2;if(!(Lqc(c,p,w)|0)){r=0;n=29;break}}if((n|0)==29)return r|0;return 0}function W4a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2))j=g;else j=g+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&4)){d=j;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+24>>2]|0;if((b|0)<0)k=11;else k=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=k+j|0;e=a+12|0;f[e>>2]=d;return d|0}function X4a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)U_b(1,f[a+20>>2]|0,b);if(c&4|0)S_b(2,f[a+24>>2]|0,b);if(c&1|0)S_b(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Y4a(a){a=a|0;return f[a+12>>2]|0}function Z4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&4))n=e;else{l=f[a+24>>2]|0;b[e>>0]=16;m=e+1|0;e=l&255;if(l>>>0>127){g=m;h=e;i=l;d=((l|0)<0)<<31>>31;while(1){b[g>>0]=h|-128;l=i;i=l1c(i|0,d|0,7)|0;j=g+1|0;k=i&255;if(!(d>>>0>0|(d|0)==0&l>>>0>16383)){o=j;p=k;break}else{g=j;h=k;d=J}}}else{o=m;p=e}b[o>>0]=p;n=o+1|0}if(!(c&1))q=n;else{c=f[a+16>>2]|0;b[n>>0]=24;o=n+1|0;n=c&255;if(c>>>0>127){p=o;e=n;m=c;d=((c|0)<0)<<31>>31;while(1){b[p>>0]=e|-128;c=m;m=l1c(m|0,d|0,7)|0;h=p+1|0;g=m&255;if(!(d>>>0>0|(d|0)==0&c>>>0>16383)){r=h;s=g;break}else{p=h;e=g;d=J}}}else{r=o;s=n}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function _4a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);$4a(a,b);return}function $4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16016,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function a5a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function b5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535392;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function c5a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function d5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{h5a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(48)|0;__a(l);h5a(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15760,48);l=RXb(i,48,2253)|0;__a(l);h5a(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function e5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=WZb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{f5a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;a:do if((h|0)<(c|0)){a=i+64|0;if(!i){j=h;while(1){k=f[d+4+(j<<2)>>2]|0;l=$Xc(32)|0;p0a(l);f5a(k,l);f[b+(j<<2)>>2]=l;j=j+1|0;if((j|0)>=(c|0))break a}}else m=h;do{j=f[d+4+(m<<2)>>2]|0;if(f[a>>2]|0)SXb(i,15664,32);l=RXb(i,32,2254)|0;p0a(l);f5a(j,l);f[b+(m<<2)>>2]=l;m=m+1|0}while((m|0)!=(c|0))}while(0);m=(f[g>>2]|0)+c|0;f[g>>2]=m;g=f[e>>2]|0;if((f[g>>2]|0)>=(m|0))return;f[g>>2]=m;return}function f5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=b+4|0;d=f[a+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=b+16|0;g=a+16|0;e=f[g>>2]|0;if(!e)return;_Ma(d,(f[d>>2]|0)+e|0);o1c((f[b+24>>2]|0)+8+(f[d>>2]<<3)|0,(f[a+24>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);return}function g5a(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function h5a(a,b){a=a|0;b=b|0;$_a(b,a);return}function i5a(a){a=a|0;Yi[f[f[a>>2]>>2]&4095](a);return}function j5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=94108;b=a+92|0;c=f[b>>2]|0;if(c|0?(f[a+80>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=f[a+76>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+64>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+52>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+40>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+28|0;h=f[b>>2]|0;if(h|0?(f[a+16>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;cYc(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(i);f[b>>2]=0;return}function k5a(a){a=a|0;j5a(a);cYc(a);return}function l5a(a){a=a|0;a=$Xc(96)|0;k1a(a);return a|0}function m5a(a,b){a=a|0;b=b|0;a=$Xc(96)|0;k1a(a);if(!b)return a|0;z5a(b,a);return a|0}function n5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;h=g+8|0;i=f[h>>2]|0;if(i&1|0)oYc(f[g+16>>2]|0,535168)|0;if(i&254|0){i=g+20|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[g+36>>2]=-1;n[g+40>>2]=1.0;n[g+44>>2]=1.0}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+32>>2]=0;f[a+44>>2]=0;f[a+56>>2]=0;f[a+68>>2]=0;b=a+84|0;c=f[b>>2]|0;if((c|0)>0){e=f[a+92>>2]|0;d=0;do{g=f[e+4+(d<<2)>>2]|0;d=d+1|0;f[g+16>>2]=0;f[g+8>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}while((d|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function o5a(a){a=a|0;return 1}function p5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=e+4|0;m=a+32|0;n=a+36|0;o=a+40|0;p=a+44|0;q=a+48|0;r=a+52|0;s=a+56|0;t=a+60|0;v=a+64|0;w=a+68|0;x=a+72|0;y=a+76|0;z=a+80|0;A=e+4|0;B=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){C=b[a>>0]|0;D=C&255;if(C<<24>>24>0){f[c>>2]=a+1;E=D;F=6}else{G=D;F=5}}else{G=0;F=5}if((F|0)==5){F=0;D=ZYb(c,G)|0;if((D+-1|0)>>>0<127){E=D;F=6}else H=D}b:do if((F|0)==6){F=0;switch(E>>>3&536870911|0){case 1:{if((E&255|0)!=10){H=E;break b}D=f[i>>2]|0;do if(D){a=f[k>>2]|0;C=f[D>>2]|0;if((a|0)>=(C|0))if((C|0)==(f[j>>2]|0)){I=C;F=13;break}else{K=C;L=D;F=14;break}else{f[k>>2]=a+1;M=f[D+4+(a<<2)>>2]|0;break}}else{I=f[j>>2]|0;F=13}while(0);if((F|0)==13){F=0;XZb(h,I+1|0);D=f[i>>2]|0;K=f[D>>2]|0;L=D;F=14}if((F|0)==14){F=0;f[L>>2]=K+1;D=f[h>>2]|0;if(!D){a=$Xc(48)|0;__a(a);N=a}else{if(f[D+64>>2]|0)SXb(D,15760,48);a=RXb(D,48,2253)|0;__a(a);N=a}a=f[i>>2]|0;D=f[k>>2]|0;f[k>>2]=D+1;f[a+4+(D<<2)>>2]=N;M=N}D=f[c>>2]|0;if(D>>>0<(f[g>>2]|0)>>>0?(a=b[D>>0]|0,a<<24>>24>-1):0){f[c>>2]=D+1;O=a&255}else{a=YYb(c)|0;if((a|0)>-1)O=a;else{P=0;F=110;break a}}JYb(e,c,O);if((f[l>>2]|0)<0){F=26;break a}if(!(Mi[f[(f[M>>2]|0)+44>>2]&1023](M,c)|0)){F=26;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{P=0;F=110;break a}break}case 2:{switch((E&255)<<24>>24){case 16:break;case 18:{if(h4a(c,m)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){D=b[a>>0]|0;C=D&255;if(D<<24>>24>-1){f[c>>2]=a+1;Q=C}else{R=C;F=32}}else{R=0;F=32}if((F|0)==32){F=0;C=KYb(c,R)|0;a=J;if((a|0)>-1|(a|0)==-1&C>>>0>4294967295)Q=C;else{P=0;F=110;break a}}C=f[m>>2]|0;if((C|0)==(f[n>>2]|0)){xHa(m,C+1|0);S=f[m>>2]|0}else S=C;C=f[o>>2]|0;f[m>>2]=S+1;f[C+4+(S<<2)>>2]=Q;a=(f[n>>2]|0)-(f[m>>2]|0)|0;if((a|0)>0){T=a;U=C}else continue a;while(1){C=f[c>>2]|0;a=f[g>>2]|0;if(C>>>0>=a>>>0)continue a;if((b[C>>0]|0)!=16)continue a;D=C+1|0;f[c>>2]=D;if(D>>>0<a>>>0){a=b[D>>0]|0;D=a&255;if(a<<24>>24>-1){f[c>>2]=C+2;V=D;W=U}else{X=D;F=40}}else{X=0;F=40}if((F|0)==40){F=0;D=KYb(c,X)|0;C=J;if(!((C|0)>-1|(C|0)==-1&D>>>0>4294967295)){P=0;F=110;break a}V=D;W=f[o>>2]|0}D=f[m>>2]|0;f[m>>2]=D+1;f[W+4+(D<<2)>>2]=V;if((T|0)>1){T=T+-1|0;U=W}else continue a}break}case 3:{switch((E&255)<<24>>24){case 24:break;case 26:{if(h4a(c,p)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}D=f[c>>2]|0;if(D>>>0<(f[g>>2]|0)>>>0){C=b[D>>0]|0;a=C&255;if(C<<24>>24>-1){f[c>>2]=D+1;Y=a}else{Z=a;F=49}}else{Z=0;F=49}if((F|0)==49){F=0;a=KYb(c,Z)|0;D=J;if((D|0)>-1|(D|0)==-1&a>>>0>4294967295)Y=a;else{P=0;F=110;break a}}a=f[p>>2]|0;if((a|0)==(f[q>>2]|0)){xHa(p,a+1|0);_=f[p>>2]|0}else _=a;a=f[r>>2]|0;f[p>>2]=_+1;f[a+4+(_<<2)>>2]=Y;D=(f[q>>2]|0)-(f[p>>2]|0)|0;if((D|0)>0){$=D;aa=a}else continue a;while(1){a=f[c>>2]|0;D=f[g>>2]|0;if(a>>>0>=D>>>0)continue a;if((b[a>>0]|0)!=24)continue a;C=a+1|0;f[c>>2]=C;if(C>>>0<D>>>0){D=b[C>>0]|0;C=D&255;if(D<<24>>24>-1){f[c>>2]=a+2;ba=C;ca=aa}else{da=C;F=57}}else{da=0;F=57}if((F|0)==57){F=0;C=KYb(c,da)|0;a=J;if(!((a|0)>-1|(a|0)==-1&C>>>0>4294967295)){P=0;F=110;break a}ba=C;ca=f[r>>2]|0}C=f[p>>2]|0;f[p>>2]=C+1;f[ca+4+(C<<2)>>2]=ba;if(($|0)>1){$=$+-1|0;aa=ca}else continue a}break}case 4:{switch((E&255)<<24>>24){case 32:break;case 34:{if(h4a(c,s)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0){a=b[C>>0]|0;D=a&255;if(a<<24>>24>-1){f[c>>2]=C+1;ea=D}else{fa=D;F=66}}else{fa=0;F=66}if((F|0)==66){F=0;D=KYb(c,fa)|0;C=J;if((C|0)>-1|(C|0)==-1&D>>>0>4294967295)ea=D;else{P=0;F=110;break a}}D=f[s>>2]|0;if((D|0)==(f[t>>2]|0)){xHa(s,D+1|0);ga=f[s>>2]|0}else ga=D;D=f[v>>2]|0;f[s>>2]=ga+1;f[D+4+(ga<<2)>>2]=ea;C=(f[t>>2]|0)-(f[s>>2]|0)|0;if((C|0)>0){ha=C;ia=D}else continue a;while(1){D=f[c>>2]|0;C=f[g>>2]|0;if(D>>>0>=C>>>0)continue a;if((b[D>>0]|0)!=32)continue a;a=D+1|0;f[c>>2]=a;if(a>>>0<C>>>0){C=b[a>>0]|0;a=C&255;if(C<<24>>24>-1){f[c>>2]=D+2;ja=a;ka=ia}else{la=a;F=74}}else{la=0;F=74}if((F|0)==74){F=0;a=KYb(c,la)|0;D=J;if(!((D|0)>-1|(D|0)==-1&a>>>0>4294967295)){P=0;F=110;break a}ja=a;ka=f[v>>2]|0}a=f[s>>2]|0;f[s>>2]=a+1;f[ka+4+(a<<2)>>2]=ja;if((ha|0)>1){ha=ha+-1|0;ia=ka}else continue a}break}case 5:{switch((E&255)<<24>>24){case 40:break;case 42:{if(h4a(c,w)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){D=b[a>>0]|0;C=D&255;if(D<<24>>24>-1){f[c>>2]=a+1;ma=C}else{na=C;F=83}}else{na=0;F=83}if((F|0)==83){F=0;C=KYb(c,na)|0;a=J;if((a|0)>-1|(a|0)==-1&C>>>0>4294967295)ma=C;else{P=0;F=110;break a}}C=f[w>>2]|0;if((C|0)==(f[x>>2]|0)){xHa(w,C+1|0);oa=f[w>>2]|0}else oa=C;C=f[y>>2]|0;f[w>>2]=oa+1;f[C+4+(oa<<2)>>2]=ma;a=(f[x>>2]|0)-(f[w>>2]|0)|0;if((a|0)>0){pa=a;qa=C}else continue a;while(1){C=f[c>>2]|0;a=f[g>>2]|0;if(C>>>0>=a>>>0)continue a;if((b[C>>0]|0)!=40)continue a;D=C+1|0;f[c>>2]=D;if(D>>>0<a>>>0){a=b[D>>0]|0;D=a&255;if(a<<24>>24>-1){f[c>>2]=C+2;ra=D;sa=qa}else{ta=D;F=91}}else{ta=0;F=91}if((F|0)==91){F=0;D=KYb(c,ta)|0;C=J;if(!((C|0)>-1|(C|0)==-1&D>>>0>4294967295)){P=0;F=110;break a}ra=D;sa=f[y>>2]|0}D=f[w>>2]|0;f[w>>2]=D+1;f[sa+4+(D<<2)>>2]=ra;if((pa|0)>1){pa=pa+-1|0;qa=sa}else continue a}break}case 6:{if((E&255|0)!=50){H=E;break b}D=y5a(z)|0;C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0?(a=b[C>>0]|0,a<<24>>24>-1):0){f[c>>2]=C+1;ua=a&255}else{a=YYb(c)|0;if((a|0)>-1)ua=a;else{P=0;F=110;break a}}JYb(e,c,ua);if((f[A>>2]|0)<0){F=103;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){F=103;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{P=0;F=110;break a}break}default:{H=E;break b}}}while(0);if(!H){P=1;F=110;break}D=f[B>>2]|0;if(!(D&1))va=lSa(B)|0;else va=D&-2;if(!(Lqc(c,H,va)|0)){P=0;F=110;break}}if((F|0)==26){P=0;u=d;return P|0}else if((F|0)==103){P=0;u=d;return P|0}else if((F|0)==110){u=d;return P|0}return 0}function q5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b)e=d;else{c=a+28|0;g=0;h=d;while(1){d=f[(f[c>>2]|0)+4+(g<<2)>>2]|0;i=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=i+h+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(b|0)){e=d;break}else h=d}}h=o$b(a+32|0)|0;b=f[a+32>>2]|0;g=o$b(a+44|0)|0;c=f[a+44>>2]|0;d=o$b(a+56|0)|0;i=f[a+56>>2]|0;j=o$b(a+68|0)|0;k=f[a+84>>2]|0;l=h+e+b+g+c+d+i+j+(f[a+68>>2]|0)+k|0;if(!k){m=l;n=a+12|0;f[n>>2]=m;return m|0}j=a+92|0;i=0;d=l;while(1){l=f[(f[j>>2]|0)+4+(i<<2)>>2]|0;c=_i[f[(f[l>>2]|0)+48>>2]&2047](l)|0;l=c+d+((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)|0;i=i+1|0;if((i|0)==(k|0)){m=l;break}else d=l}n=a+12|0;f[n>>2]=m;return m|0}function r5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+32>>2]|0;if((c|0)>0){e=a+40|0;d=0;do{U_b(2,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+44>>2]|0;if((c|0)>0){d=a+52|0;e=0;do{U_b(3,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+56>>2]|0;if((c|0)>0){e=a+64|0;d=0;do{U_b(4,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+68>>2]|0;if((c|0)>0){d=a+76|0;e=0;do{U_b(5,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+84>>2]|0;if(c|0){e=a+92|0;d=0;do{k$b(6,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function s5a(a){a=a|0;return f[a+12>>2]|0}function t5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+32>>2]|0;if(!j)s=g;else{e=f[a+40>>2]|0;i=0;q=g;while(1){g=f[e+4+(i<<2)>>2]|0;b[q>>0]=16;r=q+1|0;if(g>>>0>127){h=g;n=r;while(1){b[n>>0]=h|128;m=h>>>7;o=n+1|0;if(h>>>0>16383){h=m;n=o}else{t=o;u=m;break}}}else{t=r;u=g}b[t>>0]=u;n=t+1|0;i=i+1|0;if((i|0)>=(j|0)){s=n;break}else q=n}}q=f[a+44>>2]|0;if(!q)v=s;else{j=f[a+52>>2]|0;i=0;t=s;while(1){s=f[j+4+(i<<2)>>2]|0;b[t>>0]=24;u=t+1|0;if(s>>>0>127){e=s;n=u;while(1){b[n>>0]=e|128;h=e>>>7;d=n+1|0;if(e>>>0>16383){e=h;n=d}else{w=d;x=h;break}}}else{w=u;x=s}b[w>>0]=x;n=w+1|0;i=i+1|0;if((i|0)>=(q|0)){v=n;break}else t=n}}t=f[a+56>>2]|0;if(!t)y=v;else{q=f[a+64>>2]|0;i=0;w=v;while(1){v=f[q+4+(i<<2)>>2]|0;b[w>>0]=32;x=w+1|0;if(v>>>0>127){j=v;n=x;while(1){b[n>>0]=j|128;e=j>>>7;g=n+1|0;if(j>>>0>16383){j=e;n=g}else{z=g;A=e;break}}}else{z=x;A=v}b[z>>0]=A;n=z+1|0;i=i+1|0;if((i|0)>=(t|0)){y=n;break}else w=n}}w=f[a+68>>2]|0;if(!w)B=y;else{t=f[a+76>>2]|0;i=0;z=y;while(1){y=f[t+4+(i<<2)>>2]|0;b[z>>0]=40;A=z+1|0;if(y>>>0>127){q=y;n=A;while(1){b[n>>0]=q|128;j=q>>>7;s=n+1|0;if(q>>>0>16383){q=j;n=s}else{C=s;D=j;break}}}else{C=A;D=y}b[C>>0]=D;n=C+1|0;i=i+1|0;if((i|0)>=(w|0)){B=n;break}else z=n}}z=f[a+84>>2]|0;if(!z)E=B;else{w=a+92|0;i=0;C=B;while(1){B=f[(f[w>>2]|0)+4+(i<<2)>>2]|0;b[C>>0]=50;D=C+1|0;t=_i[f[(f[B>>2]|0)+60>>2]&2047](B)|0;if(t>>>0>127){n=t;q=D;while(1){b[q>>0]=n|128;v=n>>>7;x=q+1|0;if(n>>>0>16383){n=v;q=x}else{F=x;G=v;break}}}else{F=D;G=t}b[F>>0]=G;q=hj[f[(f[B>>2]|0)+64>>2]&511](B,c,F+1|0)|0;i=i+1|0;if((i|0)==(z|0)){E=q;break}else C=q}}C=f[a+4>>2]|0;if(!(C&1)){H=E;return H|0}H=Pqc(C&-2,E)|0;return H|0}function u5a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;n5a(a);c=kZc(b,21568,16032,0)|0;if(!c){Ooc(b,a);return}else{l1a(a,c);return}}function v5a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16032,0)|0;if(!c){Ooc(b,a);return}else{l1a(a,c);return}}function w5a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function x5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535488;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function y5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=a+4|0;e=f[a+8>>2]|0;g=6}else{h=a+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)>=(j|0))if((j|0)==(f[a+8>>2]|0)){d=h;e=j;g=6;break}else{k=h;l=j;m=c;break}f[h>>2]=i+1;n=f[c+4+(i<<2)>>2]|0;return n|0}while(0);if((g|0)==6){XZb(a,e+1|0);e=f[b>>2]|0;k=d;l=f[e>>2]|0;m=e}f[m>>2]=l+1;l=f[a>>2]|0;if(!l){a=$Xc(32)|0;p0a(a);o=a}else{if(f[l+64>>2]|0)SXb(l,15664,32);a=RXb(l,32,2254)|0;p0a(a);o=a}a=f[b>>2]|0;b=f[k>>2]|0;f[k>>2]=b+1;f[a+4+(b<<2)>>2]=o;n=o;return n|0}function z5a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function A5a(a){a=a|0;var b=0,c=0;f[a>>2]=94216;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function B5a(a){a=a|0;var b=0,c=0;f[a>>2]=94216;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function C5a(a){a=a|0;a=$Xc(20)|0;j1a(a);return a|0}function D5a(a,b){a=a|0;b=b|0;a=$Xc(20)|0;j1a(a);if(!b)return a|0;P5a(b,a);return a|0}function E5a(a){a=a|0;var b=0;n[a+16>>2]=0.0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function F5a(a){a=a|0;return 1}function G5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=ZYb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}if((o|0)==6){o=0;if((n|0)==13){f[i>>2]=f[i>>2]|1;m=f[c>>2]|0;if(((f[g>>2]|0)-m|0)>3){a=m;l=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=l;f[c>>2]=m+4;r=l}else{if(!(WYb(c,e)|0)){o=12;break}r=f[e>>2]|0}f[j>>2]=r;continue}else q=n}if(!q){s=1;o=18;break}l=f[k>>2]|0;if(!(l&1))t=lSa(k)|0;else t=l&-2;if(!(Lqc(c,q,t)|0)){s=0;o=18;break}}if((o|0)==12){s=0;u=d;return s|0}else if((o|0)==18){u=d;return s|0}return 0}function H5a(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]&1|0?c+5|0:c;f[a+12>>2]=b;return b|0}function I5a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)a$b(1,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function J5a(a){a=a|0;return f[a+12>>2]|0}function K5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=13;g=d+1|0;b[g>>0]=c;b[g+1>>0]=c>>8;b[g+2>>0]=c>>16;b[g+3>>0]=c>>24;e=d+5|0}d=f[a+4>>2]|0;if(!(d&1)){h=e;return h|0}h=Pqc(d&-2,e)|0;return h|0}function L5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((a|0)==(b|0))return;c=a+16|0;n[c>>2]=0.0;d=a+8|0;f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=kZc(b,21568,16048,0)|0;if(!h){Ooc(b,a);return}a=f[h+4>>2]|0;if(a&1|0){b=f[e>>2]|0;if(!(b&1))i=lSa(e)|0;else i=b&-2;vqc(i,a&-2)}if(!(f[h+8>>2]&1))return;a=f[h+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=a;return}function M5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16048,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function N5a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function O5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535736;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function P5a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Q5a(a){a=a|0;var b=0,c=0;f[a>>2]=94324;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function R5a(a){a=a|0;var b=0,c=0;f[a>>2]=94324;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function S5a(a){a=a|0;a=$Xc(36)|0;h1a(a);return a|0}function T5a(a,b){a=a|0;b=b|0;a=$Xc(36)|0;h1a(a);if(!b)return a|0;d6a(b,a);return a|0}function U5a(a){a=a|0;var c=0;f[a+16>>2]=0;c=a+8|0;if(f[c>>2]&3|0){f[a+28>>2]=1;b[a+32>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function V5a(a){a=a|0;return 1}function W5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+28|0;k=a+4|0;l=a+16|0;m=a+20|0;n=a+24|0;o=a+32|0;a=e+8|0;a:while(1){p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=p+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=ZYb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=8){w=s;break b}r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){p=b[r>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=r+1;x=q}else{y=q;t=11}}else{y=0;t=11}if((t|0)==11){t=0;q=KYb(c,y)|0;r=J;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)x=q;else{z=0;t=46;break a}}if(x>>>0<3){f[i>>2]=f[i>>2]|1;f[j>>2]=x;continue a}q=f[k>>2]|0;if(!(q&1))A=lSa(k)|0;else A=q&-2;yqc(A,1,x,((x|0)<0)<<31>>31);continue a;break}case 2:{switch((s&255)<<24>>24){case 21:break;case 18:{if(_Za(c,l)|0)continue a;else{z=0;t=46;break a}break}default:{w=s;break b}}q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){r=q;p=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=p;f[c>>2]=q+4;B=p}else{if(!(WYb(c,e)|0)){t=33;break a}B=f[e>>2]|0}p=f[l>>2]|0;if((p|0)==(f[m>>2]|0)){uHa(l,p+1|0);C=f[l>>2]|0}else C=p;p=f[n>>2]|0;q=C+1|0;f[l>>2]=q;f[p+4+(C<<2)>>2]=B;r=f[c>>2]|0;D=(f[g>>2]|0)-r|0;if((D|0)<=0)continue a;E=r;r=(f[m>>2]|0)-q|0;F=(D>>>0)/5|0;G=(F|0)<(r|0)?F:r;if((G|0)>0){H=0;I=E;K=q}else continue a;while(1){if((b[I>>0]|0)!=21){L=H;break}q=I+1|0;r=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K;K=K+1|0;f[l>>2]=K;f[p+4+(q<<2)>>2]=r;r=H+1|0;if((r|0)>=(G|0)){L=r;break}else{H=r;I=I+5|0}}G=L*5|0;if((L|0)<=0)continue a;if((D|0)<(G|0)){SYb(c,G,D)|0;continue a}else{f[c>>2]=E+G;continue a}break}case 3:{if((s&255|0)!=24){w=s;break b}f[i>>2]=f[i>>2]|2;G=f[c>>2]|0;if(G>>>0<(f[g>>2]|0)>>>0?(p=b[G>>0]|0,p<<24>>24>-1):0){f[c>>2]=G+1;M=p<<24>>24!=0}else{LYb(e,c);p=e;if(!(b[a>>0]|0)){z=0;t=46;break a}else M=(f[p>>2]|0)!=0|(f[p+4>>2]|0)!=0}b[o>>0]=M&1;continue a;break}default:{w=s;break b}}}while(0);if(!w){z=1;t=46;break}p=f[k>>2]|0;if(!(p&1))N=lSa(k)|0;else N=p&-2;if(!(Lqc(c,w,N)|0)){z=0;t=46;break}}if((t|0)==33){z=0;u=d;return z|0}else if((t|0)==46){u=d;return z|0}return 0}function X5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+16>>2]|0;d=b+c+(b<<2)|0;b=f[a+8>>2]|0;if(!(b&3)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(b&1))h=d;else{c=f[a+28>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+d|0}e=b&2|0?h+2|0:h;g=a+12|0;f[g>>2]=e;return e|0}function Y5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&1|0)d$b(1,f[a+28>>2]|0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{a$b(2,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)!=(e|0))}if(d&2|0)c$b(3,(b[a+32>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function Z5a(a){a=a|0;return f[a+12>>2]|0}function _5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+28>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}o=f[a+16>>2]|0;if(!o)q=e;else{p=f[a+24>>2]|0;d=0;h=e;while(1){e=f[p+4+(d<<2)>>2]|0;b[h>>0]=21;l=h+1|0;b[l>>0]=e;b[l+1>>0]=e>>8;b[l+2>>0]=e>>16;b[l+3>>0]=e>>24;e=h+5|0;d=d+1|0;if((d|0)>=(o|0)){q=e;break}else h=e}}if(!(c&2))r=q;else{c=b[a+32>>0]|0;b[q>>0]=24;b[q+1>>0]=c;r=q+2|0}q=f[a+4>>2]|0;if(!(q&1)){s=r;return s|0}s=Pqc(q&-2,r)|0;return s|0}function $5a(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))return;f[a+16>>2]=0;d=a+8|0;if(f[d>>2]&3|0){f[a+28>>2]=1;b[a+32>>0]=1}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16064,0)|0;if(!e){Ooc(c,a);return}else{i1a(a,e);return}}function a6a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16064,0)|0;if(!c){Ooc(b,a);return}else{i1a(a,c);return}}function b6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function c6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535496;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function d6a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function e6a(a){a=a|0;var b=0,c=0;f[a>>2]=94432;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function f6a(a){a=a|0;var b=0,c=0;f[a>>2]=94432;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function g6a(a){a=a|0;a=$Xc(28)|0;g1a(a);return a|0}function h6a(a,b){a=a|0;b=b|0;a=$Xc(28)|0;g1a(a);if(!b)return a|0;t6a(b,a);return a|0}function i6a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function j6a(a){a=a|0;return 1}function k6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+8|0;k=a+24|0;l=a+20|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;t=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[j>>0]|0)){v=0;q=29;break a}else t=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[i>>0]=t&1;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;n=o&255;if(o<<24>>24>-1){f[k>>2]=n;f[c>>2]=a+1;continue a}else w=n}else w=0;n=KYb(c,w)|0;a=J;f[k>>2]=n;if((a|0)>-1|(a|0)==-1&n>>>0>4294967295)continue a;else{v=0;q=29;break a}break}case 3:{if((p&255|0)!=24){s=p;break b}f[h>>2]=f[h>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){a=b[n>>0]|0;o=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;x=o}else{y=o;q=22}}else{y=0;q=22}if((q|0)==22){q=0;o=KYb(c,y)|0;n=J;if((n|0)>-1|(n|0)==-1&o>>>0>4294967295)x=o;else{v=0;q=29;break a}}f[l>>2]=x;continue a;break}default:{s=p;break b}}}while(0);if(!s){v=1;q=29;break}o=f[m>>2]|0;if(!(o&1))z=lSa(m)|0;else z=o&-2;if(!(Lqc(c,s,z)|0)){v=0;q=29;break}}if((q|0)==29){u=d;return v|0}return 0}function l6a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;if(!(b&2))h=g;else{c=f[a+20>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+g|0}if(!(b&4)){d=h;e=a+12|0;f[e>>2]=d;return d|0}d=h+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function m6a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)c$b(1,(b[a+16>>0]|0)!=0,c);if(d&4|0)U_b(2,f[a+24>>2]|0,c);if(d&2|0)S_b(3,f[a+20>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function n6a(a){a=a|0;return f[a+12>>2]|0}function o6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=b[a+16>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}if(!(c&4))h=e;else{d=f[a+24>>2]|0;b[e>>0]=16;g=e+1|0;if(d>>>0>127){e=d;i=g;while(1){b[i>>0]=e|128;j=e>>>7;k=i+1|0;if(e>>>0>16383){e=j;i=k}else{l=k;m=j;break}}}else{l=g;m=d}b[l>>0]=m;h=l+1|0}if(!(c&2))n=h;else{c=f[a+20>>2]|0;b[h>>0]=24;l=h+1|0;h=c&255;if(c>>>0>127){m=l;d=h;g=c;i=((c|0)<0)<<31>>31;while(1){b[m>>0]=d|-128;c=g;g=l1c(g|0,i|0,7)|0;e=m+1|0;j=g&255;if(!(i>>>0>0|(i|0)==0&c>>>0>16383)){o=e;p=j;break}else{m=e;d=j;i=J}}}else{o=l;p=h}b[o>>0]=p;n=o+1|0}o=f[a+4>>2]|0;if(!(o&1)){q=n;return q|0}q=Pqc(o&-2,n)|0;return q|0}function p6a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);q6a(a,b);return}function q6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,16080,0)|0;if(!d){Ooc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&7))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)f[a+20>>2]=f[d+20>>2];if(e&4|0)f[a+24>>2]=f[d+24>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function r6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535400;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function t6a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function u6a(a){a=a|0;var b=0,c=0;f[a>>2]=94540;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function v6a(a){a=a|0;var b=0,c=0;f[a>>2]=94540;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function w6a(a){a=a|0;a=$Xc(32)|0;f1a(a);return a|0}function x6a(a,b){a=a|0;b=b|0;a=$Xc(32)|0;f1a(a);if(!b)return a|0;J6a(b,a);return a|0}function y6a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&15|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function z6a(a){a=a|0;return 1}function A6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+28|0;k=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=ZYb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}b:do if((o|0)==6){o=0;switch(n>>>3&536870911|0){case 1:{if((n&255|0)!=8){q=n;break b}f[e>>2]=f[e>>2]|1;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[g>>2]=l;f[c>>2]=m+1;continue a}else r=l}else r=0;l=KYb(c,r)|0;m=J;f[g>>2]=l;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)continue a;else{s=0;o=32;break a}break}case 2:{if((n&255|0)!=16){q=n;break b}f[e>>2]=f[e>>2]|2;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){m=b[l>>0]|0;a=m&255;if(m<<24>>24>-1){f[h>>2]=a;f[c>>2]=l+1;continue a}else t=a}else t=0;a=KYb(c,t)|0;l=J;f[h>>2]=a;if((l|0)>-1|(l|0)==-1&a>>>0>4294967295)continue a;else{s=0;o=32;break a}break}case 3:{if((n&255|0)!=24){q=n;break b}f[e>>2]=f[e>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>-1){f[i>>2]=m;f[c>>2]=a+1;continue a}else u=m}else u=0;m=KYb(c,u)|0;a=J;f[i>>2]=m;if((a|0)>-1|(a|0)==-1&m>>>0>4294967295)continue a;else{s=0;o=32;break a}break}case 4:{if((n&255|0)!=32){q=n;break b}f[e>>2]=f[e>>2]|8;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[j>>2]=l;f[c>>2]=m+1;continue a}else v=l}else v=0;l=KYb(c,v)|0;m=J;f[j>>2]=l;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)continue a;else{s=0;o=32;break a}break}default:{q=n;break b}}}while(0);if(!q){s=1;o=32;break}l=f[k>>2]|0;if(!(l&1))w=lSa(k)|0;else w=l&-2;if(!(Lqc(c,q,w)|0)){s=0;o=32;break}}if((o|0)==32)return s|0;return 0}function B6a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&15)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2))h=g;else h=g+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&4))i=h;else i=h+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&8)){d=i;e=a+12|0;f[e>>2]=d;return d|0}d=i+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function C6a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)U_b(1,f[a+16>>2]|0,b);if(c&2|0)U_b(2,f[a+20>>2]|0,b);if(c&4|0)U_b(3,f[a+24>>2]|0,b);if(c&8|0)U_b(4,f[a+28>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function D6a(a){a=a|0;return f[a+12>>2]|0}function E6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+20>>2]|0;b[e>>0]=16;m=e+1|0;if(l>>>0>127){e=l;g=m;while(1){b[g>>0]=e|128;h=e>>>7;i=g+1|0;if(e>>>0>16383){e=h;g=i}else{o=i;p=h;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{o=f[a+24>>2]|0;b[n>>0]=24;p=n+1|0;if(o>>>0>127){n=o;l=p;while(1){b[l>>0]=n|128;m=n>>>7;g=l+1|0;if(n>>>0>16383){n=m;l=g}else{r=g;s=m;break}}}else{r=p;s=o}b[r>>0]=s;q=r+1|0}if(!(c&8))t=q;else{c=f[a+28>>2]|0;b[q>>0]=32;r=q+1|0;if(c>>>0>127){q=c;s=r;while(1){b[s>>0]=q|128;o=q>>>7;p=s+1|0;if(q>>>0>16383){q=o;s=p}else{u=p;v=o;break}}}else{u=r;v=c}b[u>>0]=v;t=u+1|0}u=f[a+4>>2]|0;if(!(u&1)){w=t;return w|0}w=Pqc(u&-2,t)|0;return w|0}function F6a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&15|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);G6a(a,b);return}function G6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16096,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&15))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];if(d&8|0)f[a+28>>2]=f[c+28>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function H6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function I6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535608;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function J6a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function K6a(a){a=a|0;var b=0,c=0;f[a>>2]=94648;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function L6a(a){a=a|0;var b=0,c=0;f[a>>2]=94648;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function M6a(a){a=a|0;a=$Xc(28)|0;e1a(a);return a|0}function N6a(a,b){a=a|0;b=b|0;a=$Xc(28)|0;e1a(a);if(!b)return a|0;Z6a(b,a);return a|0}function O6a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=1.0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function P6a(a){a=a|0;return 1}function Q6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+24|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(WYb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=21){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;v=a}else{if(!(WYb(c,e)|0)){q=20;break a}v=f[e>>2]|0}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;w=o}else{if(!(WYb(c,e)|0)){q=27;break a}w=f[e>>2]|0}f[l>>2]=w;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=33;break}o=f[m>>2]|0;if(!(o&1))y=lSa(m)|0;else y=o&-2;if(!(Lqc(c,s,y)|0)){x=0;q=33;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==20){x=0;u=d;return x|0}else if((q|0)==27){x=0;u=d;return x|0}else if((q|0)==33){u=d;return x|0}return 0}function R6a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function S6a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)a$b(1,+n[a+20>>2],b);if(c&4|0)a$b(2,+n[a+24>>2],b);if(c&1|0)a$b(3,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function T6a(a){a=a|0;return f[a+12>>2]|0}function U6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=f[a+24>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&1))j=i;else{c=f[a+16>>2]|0;b[i>>0]=29;e=i+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;j=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Pqc(i&-2,j)|0;return k|0}function V6a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=1.0;n[a+24>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);W6a(a,b);return}function W6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16112,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function X6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535640;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z6a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function _6a(a){a=a|0;var b=0,c=0;f[a>>2]=94756;o7a(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function $6a(a){a=a|0;_6a(a);cYc(a);return}function a7a(a){a=a|0;a=$Xc(64)|0;c1a(a);return a|0}function b7a(a,b){a=a|0;b=b|0;a=$Xc(64)|0;c1a(a);if(!b)return a|0;n7a(b,a);return a|0}function c7a(a){a=a|0;var c=0,e=0,g=0,h=0;c=a+8|0;e=f[c>>2]|0;do if(e&15|0){do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);do if(e&2|0){h=f[a+20>>2]|0;g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);if(e&4|0)oYc(f[a+24>>2]|0,535216)|0;if(e&8|0){g=f[a+28>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}}while(0);if(e&240|0){h=a+32|0;f[h>>2]=0;f[h+4>>2]=0;d[h+8>>1]=0}if(e&7936|0){f[a+44>>2]=0;n[a+48>>2]=1.0;n[a+52>>2]=.5;n[a+56>>2]=.5;n[a+60>>2]=.25}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function d7a(a){a=a|0;return 1}function e7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+48|0;l=a+20|0;m=a+32|0;n=a+36|0;o=a+40|0;p=e+8|0;q=a+52|0;r=a+56|0;s=a+60|0;t=a+44|0;v=a+24|0;w=a+41|0;x=e+8|0;y=a+28|0;z=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=a+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=ZYb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;do switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=10){F=C;break b}f[i>>2]=f[i>>2]|1;B=f[j>>2]|0;if((B|0)==537368){mHa(j,537368);G=f[j>>2]|0}else G=B;if(l$b(c,G)|0)continue a;else{H=0;D=83;break a}break}case 2:{if((C&255|0)!=21){F=C;break b}f[i>>2]=f[i>>2]|512;B=f[c>>2]|0;if(((f[g>>2]|0)-B|0)>3){a=B;A=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=A;f[c>>2]=B+4;I=A}else{if(!(WYb(c,e)|0)){D=17;break a}I=f[e>>2]|0}f[k>>2]=I;continue a;break}case 3:{if((C&255|0)!=26){F=C;break b}f[i>>2]=f[i>>2]|2;A=f[l>>2]|0;if((A|0)==537368){mHa(l,537368);K=f[l>>2]|0}else K=A;if(l$b(c,K)|0)continue a;else{H=0;D=83;break a}break}case 4:{if((C&255|0)!=32){F=C;break b}f[i>>2]=f[i>>2]|16;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){B=b[A>>0]|0;a=B&255;if(B<<24>>24>-1){f[m>>2]=a;f[c>>2]=A+1;continue a}else L=a}else L=0;a=KYb(c,L)|0;A=J;f[m>>2]=a;if((A|0)>-1|(A|0)==-1&a>>>0>4294967295)continue a;else{H=0;D=83;break a}break}case 5:{if((C&255|0)!=40){F=C;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>-1){f[n>>2]=B;f[c>>2]=a+1;continue a}else M=B}else M=0;B=KYb(c,M)|0;a=J;f[n>>2]=B;if((a|0)>-1|(a|0)==-1&B>>>0>4294967295)continue a;else{H=0;D=83;break a}break}case 6:{if((C&255|0)!=48){F=C;break b}f[i>>2]=f[i>>2]|64;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){f[c>>2]=B+1;N=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[p>>0]|0)){H=0;D=83;break a}else N=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=N&1;continue a;break}case 7:{if((C&255|0)!=61){F=C;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){B=a;A=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=A;f[c>>2]=a+4;O=A}else{if(!(WYb(c,e)|0)){D=44;break a}O=f[e>>2]|0}f[q>>2]=O;continue a;break}case 8:{if((C&255|0)!=69){F=C;break b}f[i>>2]=f[i>>2]|2048;A=f[c>>2]|0;if(((f[g>>2]|0)-A|0)>3){a=A;B=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=B;f[c>>2]=A+4;P=B}else{if(!(WYb(c,e)|0)){D=51;break a}P=f[e>>2]|0}f[r>>2]=P;continue a;break}case 9:{if((C&255|0)!=77){F=C;break b}f[i>>2]=f[i>>2]|4096;B=f[c>>2]|0;if(((f[g>>2]|0)-B|0)>3){A=B;a=h[A>>0]|h[A+1>>0]<<8|h[A+2>>0]<<16|h[A+3>>0]<<24;f[e>>2]=a;f[c>>2]=B+4;Q=a}else{if(!(WYb(c,e)|0)){D=58;break a}Q=f[e>>2]|0}f[s>>2]=Q;continue a;break}case 10:{if((C&255|0)!=80){F=C;break b}f[i>>2]=f[i>>2]|256;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){B=b[a>>0]|0;A=B&255;if(B<<24>>24>-1){f[t>>2]=A;f[c>>2]=a+1;continue a}else R=A}else R=0;A=KYb(c,R)|0;a=J;f[t>>2]=A;if((a|0)>-1|(a|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=83;break a}break}case 11:{if((C&255|0)!=90){F=C;break b}f[i>>2]=f[i>>2]|4;A=f[v>>2]|0;if((A|0)==535216){mHa(v,535216);S=f[v>>2]|0}else S=A;if(l$b(c,S)|0)continue a;else{H=0;D=83;break a}break}case 12:{if((C&255|0)!=96){F=C;break b}f[i>>2]=f[i>>2]|128;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;T=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[x>>0]|0)){H=0;D=83;break a}else T=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[w>>0]=T&1;continue a;break}case 13:{if((C&255|0)!=106){F=C;break b}f[i>>2]=f[i>>2]|8;a=f[y>>2]|0;if((a|0)==537368){mHa(y,537368);U=f[y>>2]|0}else U=a;if(l$b(c,U)|0)continue a;else{H=0;D=83;break a}break}default:{F=C;break b}}while(0)}while(0);if(!F){H=1;D=83;break}a=f[z>>2]|0;if(!(a&1))V=lSa(z)|0;else V=a&-2;if(!(Lqc(c,F,V)|0)){H=0;D=83;break}}if((D|0)==17){H=0;u=d;return H|0}else if((D|0)==44){H=0;u=d;return H|0}else if((D|0)==51){H=0;u=d;return H|0}else if((D|0)==58){H=0;u=d;return H|0}else if((D|0)==83){u=d;return H|0}return 0}function f7a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&255))e=d;else{if(!(c&1))g=d;else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0?f[h+4>>2]|0:i&255;g=d+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))k=g;else{j=f[a+20>>2]|0;d=b[j+11>>0]|0;i=d<<24>>24<0?f[j+4>>2]|0:d&255;k=g+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))l=k;else{i=f[a+24>>2]|0;g=b[i+11>>0]|0;d=g<<24>>24<0?f[i+4>>2]|0:g&255;l=k+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))m=l;else{d=f[a+28>>2]|0;k=b[d+11>>0]|0;g=k<<24>>24<0?f[d+4>>2]|0:k&255;m=l+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&16))n=m;else n=m+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&32))o=n;else o=n+1+((((($(f[a+36>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=c&64|0?o+2|0:o;e=c&128|0?n+2|0:n}if(!(c&7936)){p=e;q=a+12|0;f[q>>2]=p;return p|0}if(!(c&256))r=e;else r=e+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=c&512|0?r+5|0:r;r=c&1024|0?e+5|0:e;e=c&2048|0?r+5|0:r;p=c&4096|0?e+5|0:e;q=a+12|0;f[q>>2]=p;return p|0}function g7a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+16>>2]|0,c);if(d&512|0)a$b(2,+n[a+48>>2],c);if(d&2|0)f$b(3,f[a+20>>2]|0,c);if(d&16|0)U_b(4,f[a+32>>2]|0,c);if(d&32|0)U_b(5,f[a+36>>2]|0,c);if(d&64|0)c$b(6,(b[a+40>>0]|0)!=0,c);if(d&1024|0)a$b(7,+n[a+52>>2],c);if(d&2048|0)a$b(8,+n[a+56>>2],c);if(d&4096|0)a$b(9,+n[a+60>>2],c);if(d&256|0)U_b(10,f[a+44>>2]|0,c);if(d&4|0)f$b(11,f[a+24>>2]|0,c);if(d&128|0)c$b(12,(b[a+41>>0]|0)!=0,c);if(d&8|0)f$b(13,f[a+28>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function h7a(a){a=a|0;return f[a+12>>2]|0}function i7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&512))h=e;else{d=f[a+48>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&2))i=h;else{e=f[a+20>>2]|0;b[h>>0]=26;i=gZb(e,h+1|0)|0}if(!(c&16))j=i;else{h=f[a+32>>2]|0;b[i>>0]=32;e=i+1|0;if(h>>>0>127){i=h;d=e;while(1){b[d>>0]=i|128;g=i>>>7;k=d+1|0;if(i>>>0>16383){i=g;d=k}else{l=k;m=g;break}}}else{l=e;m=h}b[l>>0]=m;j=l+1|0}if(!(c&32))n=j;else{l=f[a+36>>2]|0;b[j>>0]=40;m=j+1|0;if(l>>>0>127){j=l;h=m;while(1){b[h>>0]=j|128;e=j>>>7;d=h+1|0;if(j>>>0>16383){j=e;h=d}else{o=d;p=e;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&64))q=n;else{o=b[a+40>>0]|0;b[n>>0]=48;b[n+1>>0]=o;q=n+2|0}if(!(c&1024))r=q;else{n=f[a+52>>2]|0;b[q>>0]=61;o=q+1|0;b[o>>0]=n;b[o+1>>0]=n>>8;b[o+2>>0]=n>>16;b[o+3>>0]=n>>24;r=q+5|0}if(!(c&2048))s=r;else{q=f[a+56>>2]|0;b[r>>0]=69;n=r+1|0;b[n>>0]=q;b[n+1>>0]=q>>8;b[n+2>>0]=q>>16;b[n+3>>0]=q>>24;s=r+5|0}if(!(c&4096))t=s;else{r=f[a+60>>2]|0;b[s>>0]=77;q=s+1|0;b[q>>0]=r;b[q+1>>0]=r>>8;b[q+2>>0]=r>>16;b[q+3>>0]=r>>24;t=s+5|0}if(!(c&256))u=t;else{s=f[a+44>>2]|0;b[t>>0]=80;r=t+1|0;if(s>>>0>127){t=s;q=r;while(1){b[q>>0]=t|128;n=t>>>7;o=q+1|0;if(t>>>0>16383){t=n;q=o}else{v=o;w=n;break}}}else{v=r;w=s}b[v>>0]=w;u=v+1|0}if(!(c&4))x=u;else{v=f[a+24>>2]|0;b[u>>0]=90;x=gZb(v,u+1|0)|0}if(!(c&128))y=x;else{u=b[a+41>>0]|0;b[x>>0]=96;b[x+1>>0]=u;y=x+2|0}if(!(c&8))z=y;else{c=f[a+28>>2]|0;b[y>>0]=106;z=gZb(c,y+1|0)|0}y=f[a+4>>2]|0;if(!(y&1)){A=z;return A|0}A=Pqc(y&-2,z)|0;return A|0}function j7a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;c7a(a);c=kZc(b,21568,16128,0)|0;if(!c){Ooc(b,a);return}else{d1a(a,c);return}}function k7a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16128,0)|0;if(!c){Ooc(b,a);return}else{d1a(a,c);return}}function l7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function m7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535744;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function n7a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function o7a(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if(!((c|0)==535216|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+28>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function p7a(a){a=a|0;var b=0,c=0;f[a>>2]=94864;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function q7a(a){a=a|0;var b=0,c=0;f[a>>2]=94864;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function r7a(a){a=a|0;a=$Xc(68)|0;a1a(a);return a|0}function s7a(a,b){a=a|0;b=b|0;a=$Xc(68)|0;a1a(a);if(!b)return a|0;E7a(b,a);return a|0}function t7a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0}if(d&7936|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+60>>2]=1;b[a+64>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function u7a(a){a=a|0;return 1}function v7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+4|0;k=a+20|0;l=a+60|0;m=a+24|0;n=a+28|0;o=a+32|0;p=a+36|0;q=a+40|0;r=a+44|0;s=a+48|0;t=a+52|0;v=a+56|0;w=e+8|0;x=a+64|0;a=e+8|0;a:while(1){y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>0){f[c>>2]=y+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=ZYb(c,D)|0;if((A+-1|0)>>>0<127){B=A;C=6}else E=A}b:do if((C|0)==6){C=0;do switch(B>>>3&536870911|0){case 1:{if((B&255|0)!=8){E=B;break b}A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[c>>2]=A+1;F=z}else{G=z;C=11}}else{G=0;C=11}if((C|0)==11){C=0;z=KYb(c,G)|0;A=J;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)F=z;else{H=0;C=91;break a}}if(F>>>0<3){f[h>>2]=f[h>>2]|1;f[i>>2]=F;continue a}z=f[j>>2]|0;if(!(z&1))I=lSa(j)|0;else I=z&-2;yqc(I,1,F,((F|0)<0)<<31>>31);continue a;break}case 2:{if((B&255|0)!=16){E=B;break b}f[h>>2]=f[h>>2]|2;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[k>>2]=y;f[c>>2]=z+1;continue a}else K=y}else K=0;y=KYb(c,K)|0;z=J;f[k>>2]=y;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 3:{if((B&255|0)!=24){E=B;break b}f[h>>2]=f[h>>2]|2048;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>-1){f[l>>2]=A;f[c>>2]=y+1;continue a}else L=A}else L=0;A=KYb(c,L)|0;y=J;f[l>>2]=A;if((y|0)>-1|(y|0)==-1&A>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 4:{if((B&255|0)!=32){E=B;break b}f[h>>2]=f[h>>2]|4;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[m>>2]=z;f[c>>2]=A+1;continue a}else M=z}else M=0;z=KYb(c,M)|0;A=J;f[m>>2]=z;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 5:{if((B&255|0)!=40){E=B;break b}f[h>>2]=f[h>>2]|8;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[n>>2]=y;f[c>>2]=z+1;continue a}else N=y}else N=0;y=KYb(c,N)|0;z=J;f[n>>2]=y;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 6:{if((B&255|0)!=48){E=B;break b}f[h>>2]=f[h>>2]|16;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>-1){f[o>>2]=A;f[c>>2]=y+1;continue a}else O=A}else O=0;A=KYb(c,O)|0;y=J;f[o>>2]=A;if((y|0)>-1|(y|0)==-1&A>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 7:{if((B&255|0)!=56){E=B;break b}f[h>>2]=f[h>>2]|32;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[p>>2]=z;f[c>>2]=A+1;continue a}else P=z}else P=0;z=KYb(c,P)|0;A=J;f[p>>2]=z;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 8:{if((B&255|0)!=64){E=B;break b}f[h>>2]=f[h>>2]|64;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[q>>2]=y;f[c>>2]=z+1;continue a}else Q=y}else Q=0;y=KYb(c,Q)|0;z=J;f[q>>2]=y;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 9:{if((B&255|0)!=72){E=B;break b}f[h>>2]=f[h>>2]|128;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>-1){f[r>>2]=A;f[c>>2]=y+1;continue a}else R=A}else R=0;A=KYb(c,R)|0;y=J;f[r>>2]=A;if((y|0)>-1|(y|0)==-1&A>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 10:{if((B&255|0)!=80){E=B;break b}f[h>>2]=f[h>>2]|256;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){y=b[A>>0]|0;z=y&255;if(y<<24>>24>-1){f[s>>2]=z;f[c>>2]=A+1;continue a}else S=z}else S=0;z=KYb(c,S)|0;A=J;f[s>>2]=z;if((A|0)>-1|(A|0)==-1&z>>>0>4294967295)continue a;else{H=0;C=91;break a}break}case 11:{if((B&255|0)!=88){E=B;break b}z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){A=b[z>>0]|0;y=A&255;if(A<<24>>24>-1){f[c>>2]=z+1;T=y}else{U=y;C=67}}else{U=0;C=67}if((C|0)==67){C=0;y=KYb(c,U)|0;z=J;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)T=y;else{H=0;C=91;break a}}if(T>>>0<3){f[h>>2]=f[h>>2]|512;f[t>>2]=T;continue a}y=f[j>>2]|0;if(!(y&1))V=lSa(j)|0;else V=y&-2;yqc(V,11,T,((T|0)<0)<<31>>31);continue a;break}case 12:{if((B&255|0)!=96){E=B;break b}f[h>>2]=f[h>>2]|1024;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(z=b[y>>0]|0,z<<24>>24>-1):0){f[c>>2]=y+1;W=z<<24>>24!=0}else{LYb(e,c);z=e;if(!(b[w>>0]|0)){H=0;C=91;break a}else W=(f[z>>2]|0)!=0|(f[z+4>>2]|0)!=0}b[v>>0]=W&1;continue a;break}case 13:{if((B&255|0)!=104){E=B;break b}f[h>>2]=f[h>>2]|4096;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(y=b[z>>0]|0,y<<24>>24>-1):0){f[c>>2]=z+1;X=y<<24>>24!=0}else{LYb(e,c);y=e;if(!(b[a>>0]|0)){H=0;C=91;break a}else X=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0}b[x>>0]=X&1;continue a;break}default:{E=B;break b}}while(0)}while(0);if(!E){H=1;C=91;break}y=f[j>>2]|0;if(!(y&1))Y=lSa(j)|0;else Y=y&-2;if(!(Lqc(c,E,Y)|0)){H=0;C=91;break}}if((C|0)==91){u=d;return H|0}return 0}function w7a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(b&255){if(!(b&1))d=c;else{e=f[a+16>>2]|0;if((e|0)<0)g=11;else g=((((($(e|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=g+c|0}if(!(b&2))h=d;else h=d+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&4))i=h;else i=h+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&8))j=i;else j=i+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&16))k=j;else k=j+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&32))l=k;else l=k+1+((((($(f[a+36>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&64))m=l;else m=l+1+((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&128))n=m;else n=m+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else n=c;if(!(b&7936)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(b&256))q=n;else q=n+1+((((($(f[a+48>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&512))r=q;else{n=f[a+52>>2]|0;if((n|0)<0)s=11;else s=((((($(n|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+q|0}q=b&1024|0?r+2|0:r;if(!(b&2048))t=q;else t=q+1+((((($(f[a+60>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;o=b&4096|0?t+2|0:t;p=a+12|0;f[p>>2]=o;return o|0}function x7a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)d$b(1,f[a+16>>2]|0,c);if(d&2|0)U_b(2,f[a+20>>2]|0,c);if(d&2048|0)U_b(3,f[a+60>>2]|0,c);if(d&4|0)U_b(4,f[a+24>>2]|0,c);if(d&8|0)U_b(5,f[a+28>>2]|0,c);if(d&16|0)U_b(6,f[a+32>>2]|0,c);if(d&32|0)U_b(7,f[a+36>>2]|0,c);if(d&64|0)U_b(8,f[a+40>>2]|0,c);if(d&128|0)U_b(9,f[a+44>>2]|0,c);if(d&256|0)U_b(10,f[a+48>>2]|0,c);if(d&512|0)d$b(11,f[a+52>>2]|0,c);if(d&1024|0)c$b(12,(b[a+56>>0]|0)!=0,c);if(d&4096|0)c$b(13,(b[a+64>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function y7a(a){a=a|0;return f[a+12>>2]|0}function z7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{o=f[a+20>>2]|0;b[e>>0]=16;p=e+1|0;if(o>>>0>127){e=o;d=p;while(1){b[d>>0]=e|128;h=e>>>7;l=d+1|0;if(e>>>0>16383){e=h;d=l}else{r=l;s=h;break}}}else{r=p;s=o}b[r>>0]=s;q=r+1|0}if(!(c&2048))t=q;else{r=f[a+60>>2]|0;b[q>>0]=24;s=q+1|0;if(r>>>0>127){q=r;o=s;while(1){b[o>>0]=q|128;p=q>>>7;d=o+1|0;if(q>>>0>16383){q=p;o=d}else{u=d;v=p;break}}}else{u=s;v=r}b[u>>0]=v;t=u+1|0}if(!(c&4))w=t;else{u=f[a+24>>2]|0;b[t>>0]=32;v=t+1|0;if(u>>>0>127){t=u;r=v;while(1){b[r>>0]=t|128;s=t>>>7;o=r+1|0;if(t>>>0>16383){t=s;r=o}else{x=o;y=s;break}}}else{x=v;y=u}b[x>>0]=y;w=x+1|0}if(!(c&8))z=w;else{x=f[a+28>>2]|0;b[w>>0]=40;y=w+1|0;if(x>>>0>127){w=x;u=y;while(1){b[u>>0]=w|128;v=w>>>7;r=u+1|0;if(w>>>0>16383){w=v;u=r}else{A=r;B=v;break}}}else{A=y;B=x}b[A>>0]=B;z=A+1|0}if(!(c&16))C=z;else{A=f[a+32>>2]|0;b[z>>0]=48;B=z+1|0;if(A>>>0>127){z=A;x=B;while(1){b[x>>0]=z|128;y=z>>>7;u=x+1|0;if(z>>>0>16383){z=y;x=u}else{D=u;E=y;break}}}else{D=B;E=A}b[D>>0]=E;C=D+1|0}if(!(c&32))F=C;else{D=f[a+36>>2]|0;b[C>>0]=56;E=C+1|0;if(D>>>0>127){C=D;A=E;while(1){b[A>>0]=C|128;B=C>>>7;x=A+1|0;if(C>>>0>16383){C=B;A=x}else{G=x;H=B;break}}}else{G=E;H=D}b[G>>0]=H;F=G+1|0}if(!(c&64))I=F;else{G=f[a+40>>2]|0;b[F>>0]=64;H=F+1|0;if(G>>>0>127){F=G;D=H;while(1){b[D>>0]=F|128;E=F>>>7;A=D+1|0;if(F>>>0>16383){F=E;D=A}else{K=A;L=E;break}}}else{K=H;L=G}b[K>>0]=L;I=K+1|0}if(!(c&128))M=I;else{K=f[a+44>>2]|0;b[I>>0]=72;L=I+1|0;if(K>>>0>127){I=K;G=L;while(1){b[G>>0]=I|128;H=I>>>7;D=G+1|0;if(I>>>0>16383){I=H;G=D}else{N=D;O=H;break}}}else{N=L;O=K}b[N>>0]=O;M=N+1|0}if(!(c&256))P=M;else{N=f[a+48>>2]|0;b[M>>0]=80;O=M+1|0;if(N>>>0>127){M=N;K=O;while(1){b[K>>0]=M|128;L=M>>>7;G=K+1|0;if(M>>>0>16383){M=L;K=G}else{Q=G;R=L;break}}}else{Q=O;R=N}b[Q>>0]=R;P=Q+1|0}if(!(c&512))S=P;else{Q=f[a+52>>2]|0;b[P>>0]=88;R=P+1|0;P=Q&255;if(Q>>>0>127){N=R;O=P;K=Q;M=((Q|0)<0)<<31>>31;while(1){b[N>>0]=O|-128;Q=K;K=l1c(K|0,M|0,7)|0;L=N+1|0;G=K&255;if(!(M>>>0>0|(M|0)==0&Q>>>0>16383)){T=L;U=G;break}else{N=L;O=G;M=J}}}else{T=R;U=P}b[T>>0]=U;S=T+1|0}if(!(c&1024))V=S;else{T=b[a+56>>0]|0;b[S>>0]=96;b[S+1>>0]=T;V=S+2|0}if(!(c&4096))W=V;else{c=b[a+64>>0]|0;b[V>>0]=104;b[V+1>>0]=c;W=V+2|0}V=f[a+4>>2]|0;if(!(V&1)){X=W;return X|0}X=Pqc(V&-2,W)|0;return X|0}function A7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;e=f[d>>2]|0;if(e&255|0){g=a+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0}if(e&7936|0){e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;b[e+8>>0]=0;f[a+60>>2]=1;b[a+64>>0]=1}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16144,0)|0;if(!e){Ooc(c,a);return}else{b1a(a,e);return}}function B7a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16144,0)|0;if(!c){Ooc(b,a);return}else{b1a(a,c);return}}function C7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function D7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535632;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function E7a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function F7a(a){a=a|0;var b=0,c=0;f[a>>2]=94972;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function G7a(a){a=a|0;var b=0,c=0;f[a>>2]=94972;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function H7a(a){a=a|0;a=$Xc(40)|0;_0a(a);return a|0}function I7a(a,b){a=a|0;b=b|0;a=$Xc(40)|0;_0a(a);if(!b)return a|0;U7a(b,a);return a|0}function J7a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&63|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function K7a(a){a=a|0;return 1}function L7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+24|0;k=a+28|0;l=a+32|0;m=a+16|0;n=a+4|0;o=a+36|0;p=a+20|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=a+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=ZYb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=8){w=s;break b}f[i>>2]=f[i>>2]|4;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){a=b[r>>0]|0;q=a&255;if(a<<24>>24>-1){f[j>>2]=q;f[c>>2]=r+1;continue a}else x=q}else x=0;q=KYb(c,x)|0;r=J;f[j>>2]=q;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)continue a;else{y=0;t=60;break a}break}case 2:{if((s&255|0)!=21){w=s;break b}f[i>>2]=f[i>>2]|8;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){r=q;a=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=a;f[c>>2]=q+4;z=a}else{if(!(WYb(c,e)|0)){t=18;break a}z=f[e>>2]|0}f[k>>2]=z;continue a;break}case 3:{if((s&255|0)!=29){w=s;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){q=a;r=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[e>>2]=r;f[c>>2]=a+4;A=r}else{if(!(WYb(c,e)|0)){t=25;break a}A=f[e>>2]|0}f[l>>2]=A;continue a;break}case 4:{if((s&255|0)!=32){w=s;break b}r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){a=b[r>>0]|0;q=a&255;if(a<<24>>24>-1){f[c>>2]=r+1;B=q}else{C=q;t=30}}else{C=0;t=30}if((t|0)==30){t=0;q=KYb(c,C)|0;r=J;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)B=q;else{y=0;t=60;break a}}if(B>>>0<2){f[i>>2]=f[i>>2]|1;f[m>>2]=B;continue a}q=f[n>>2]|0;if(!(q&1))D=lSa(n)|0;else D=q&-2;yqc(D,4,B,((B|0)<0)<<31>>31);continue a;break}case 5:{if((s&255|0)!=45){w=s;break b}f[i>>2]=f[i>>2]|32;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){r=q;a=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=a;f[c>>2]=q+4;E=a}else{if(!(WYb(c,e)|0)){t=43;break a}E=f[e>>2]|0}f[o>>2]=E;continue a;break}case 6:{if((s&255|0)!=48){w=s;break b}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>-1){f[c>>2]=a+1;F=r}else{G=r;t=48}}else{G=0;t=48}if((t|0)==48){t=0;r=KYb(c,G)|0;a=J;if((a|0)>-1|(a|0)==-1&r>>>0>4294967295)F=r;else{y=0;t=60;break a}}if(F>>>0<3){f[i>>2]=f[i>>2]|2;f[p>>2]=F;continue a}r=f[n>>2]|0;if(!(r&1))H=lSa(n)|0;else H=r&-2;yqc(H,6,F,((F|0)<0)<<31>>31);continue a;break}default:{w=s;break b}}}while(0);if(!w){y=1;t=60;break}r=f[n>>2]|0;if(!(r&1))I=lSa(n)|0;else I=r&-2;if(!(Lqc(c,w,I)|0)){y=0;t=60;break}}if((t|0)==18){y=0;u=d;return y|0}else if((t|0)==25){y=0;u=d;return y|0}else if((t|0)==43){y=0;u=d;return y|0}else if((t|0)==60){u=d;return y|0}return 0}function M7a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&63)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2))j=g;else{c=f[a+20>>2]|0;if((c|0)<0)k=11;else k=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+g|0}if(!(b&4))l=j;else l=j+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;j=b&8|0?l+5|0:l;l=b&16|0?j+5|0:j;d=b&32|0?l+5|0:l;e=a+12|0;f[e>>2]=d;return d|0}function N7a(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&4|0)U_b(1,f[a+24>>2]|0,b);if(c&8|0)a$b(2,+n[a+28>>2],b);if(c&16|0)a$b(3,+n[a+32>>2],b);if(c&1|0)d$b(4,f[a+16>>2]|0,b);if(c&32|0)a$b(5,+n[a+36>>2],b);if(c&2|0)d$b(6,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function O7a(a){a=a|0;return f[a+12>>2]|0}function P7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=f[a+8>>2]|0;if(!(c&4))e=d;else{g=f[a+24>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&8))n=e;else{l=f[a+28>>2]|0;b[e>>0]=21;m=e+1|0;b[m>>0]=l;b[m+1>>0]=l>>8;b[m+2>>0]=l>>16;b[m+3>>0]=l>>24;n=e+5|0}if(!(c&16))o=n;else{e=f[a+32>>2]|0;b[n>>0]=29;l=n+1|0;b[l>>0]=e;b[l+1>>0]=e>>8;b[l+2>>0]=e>>16;b[l+3>>0]=e>>24;o=n+5|0}if(!(c&1))p=o;else{n=f[a+16>>2]|0;b[o>>0]=32;e=o+1|0;o=n&255;if(n>>>0>127){l=e;m=o;g=n;h=((n|0)<0)<<31>>31;while(1){b[l>>0]=m|-128;n=g;g=l1c(g|0,h|0,7)|0;i=l+1|0;d=g&255;if(!(h>>>0>0|(h|0)==0&n>>>0>16383)){q=i;r=d;break}else{l=i;m=d;h=J}}}else{q=e;r=o}b[q>>0]=r;p=q+1|0}if(!(c&32))s=p;else{q=f[a+36>>2]|0;b[p>>0]=45;r=p+1|0;b[r>>0]=q;b[r+1>>0]=q>>8;b[r+2>>0]=q>>16;b[r+3>>0]=q>>24;s=p+5|0}if(!(c&2))t=s;else{c=f[a+20>>2]|0;b[s>>0]=48;p=s+1|0;s=c&255;if(c>>>0>127){q=p;r=s;o=c;e=((c|0)<0)<<31>>31;while(1){b[q>>0]=r|-128;c=o;o=l1c(o|0,e|0,7)|0;h=q+1|0;m=o&255;if(!(e>>>0>0|(e|0)==0&c>>>0>16383)){u=h;v=m;break}else{q=h;r=m;e=J}}}else{u=p;v=s}b[u>>0]=v;t=u+1|0}u=f[a+4>>2]|0;if(!(u&1)){w=t;return w|0}w=Pqc(u&-2,t)|0;return w|0}function Q7a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&63|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,16160,0)|0;if(!d){Ooc(b,a);return}else{$0a(a,d);return}}function R7a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16160,0)|0;if(!c){Ooc(b,a);return}else{$0a(a,c);return}}function S7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function T7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535600;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function U7a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function V7a(a){a=a|0;var b=0,c=0;f[a>>2]=95080;if((a|0)!=533696){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function W7a(a){a=a|0;var b=0,c=0;f[a>>2]=95080;if((a|0)!=533696){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function X7a(a){a=a|0;a=$Xc(36)|0;Y0a(a);return a|0}function Y7a(a,b){a=a|0;b=b|0;a=$Xc(36)|0;Y0a(a);if(!b)return a|0;i8a(b,a);return a|0}function Z7a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}if(d&2|0){e=f[a+20>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}}if(d&60|0){d=a+24|0;f[d>>2]=0;b[d+4>>0]=0;b[a+29>>0]=1;f[a+32>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function _7a(a){a=a|0;return 1}function $7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+24|0;j=a+29|0;k=e+8|0;l=a+16|0;m=e+4|0;n=a+20|0;o=e+4|0;p=a+32|0;q=a+28|0;r=e+8|0;s=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){t=b[a>>0]|0;v=t&255;if(t<<24>>24>0){f[c>>2]=a+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=ZYb(c,y)|0;if((v+-1|0)>>>0<127){w=v;x=6}else z=v}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{if((w&255|0)!=8){z=w;break b}f[h>>2]=f[h>>2]|4;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){a=b[v>>0]|0;t=a&255;if(a<<24>>24>-1){f[i>>2]=t;f[c>>2]=v+1;continue a}else A=t}else A=0;t=KYb(c,A)|0;v=J;f[i>>2]=t;if((v|0)>-1|(v|0)==-1&t>>>0>4294967295)continue a;else{B=0;x=57;break a}break}case 2:{if((w&255|0)!=16){z=w;break b}f[h>>2]=f[h>>2]|16;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;C=v<<24>>24!=0}else{LYb(e,c);v=e;if(!(b[k>>0]|0)){B=0;x=57;break a}else C=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[j>>0]=C&1;continue a;break}case 3:{if((w&255|0)!=26){z=w;break b}f[h>>2]=f[h>>2]|1;v=f[l>>2]|0;if(!v){t=$Xc(48)|0;__a(t);f[l>>2]=t;D=t}else D=v;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(t=b[v>>0]|0,t<<24>>24>-1):0){f[c>>2]=v+1;E=t&255}else{t=YYb(c)|0;if((t|0)>-1)E=t;else{B=0;x=57;break a}}JYb(e,c,E);if((f[m>>2]|0)<0){x=27;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){x=27;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=57;break a}break}case 4:{if((w&255|0)!=34){z=w;break b}f[h>>2]=f[h>>2]|2;t=f[n>>2]|0;if(!t){v=$Xc(48)|0;__a(v);f[n>>2]=v;F=v}else F=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(v=b[t>>0]|0,v<<24>>24>-1):0){f[c>>2]=t+1;G=v&255}else{v=YYb(c)|0;if((v|0)>-1)G=v;else{B=0;x=57;break a}}JYb(e,c,G);if((f[o>>2]|0)<0){x=38;break a}if(!(Mi[f[(f[F>>2]|0)+44>>2]&1023](F,c)|0)){x=38;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{B=0;x=57;break a}break}case 5:{if((w&255|0)!=40){z=w;break b}f[h>>2]=f[h>>2]|32;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0){t=b[v>>0]|0;a=t&255;if(t<<24>>24>-1){f[c>>2]=v+1;H=a}else{I=a;x=44}}else{I=0;x=44}if((x|0)==44){x=0;a=KYb(c,I)|0;v=J;if((v|0)>-1|(v|0)==-1&a>>>0>4294967295)H=a;else{B=0;x=57;break a}}f[p>>2]=H;continue a;break}case 6:{if((w&255|0)!=48){z=w;break b}f[h>>2]=f[h>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(v=b[a>>0]|0,v<<24>>24>-1):0){f[c>>2]=a+1;K=v<<24>>24!=0}else{LYb(e,c);v=e;if(!(b[r>>0]|0)){B=0;x=57;break a}else K=(f[v>>2]|0)!=0|(f[v+4>>2]|0)!=0}b[q>>0]=K&1;continue a;break}default:{z=w;break b}}}while(0);if(!z){B=1;x=57;break}v=f[s>>2]|0;if(!(v&1))L=lSa(s)|0;else L=v&-2;if(!(Lqc(c,z,L)|0)){B=0;x=57;break}}if((x|0)==27){B=0;u=d;return B|0}else if((x|0)==38){B=0;u=d;return B|0}else if((x|0)==57){u=d;return B|0}return 0}function a8a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&63)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}if(!(l&4))m=k;else m=k+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=l&8|0?m+2|0:m;m=l&16|0?k+2|0:k;if(!(l&32)){e=m;g=a+12|0;f[g>>2]=e;return e|0}l=f[a+32>>2]|0;if((l|0)<0)n=11;else n=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=n+m|0;g=a+12|0;f[g>>2]=e;return e|0}function b8a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)U_b(1,f[a+24>>2]|0,c);if(d&16|0)c$b(2,(b[a+29>>0]|0)!=0,c);if(d&1|0)k$b(3,f[a+16>>2]|0,c);if(d&2|0)k$b(4,f[a+20>>2]|0,c);if(d&32|0)S_b(5,f[a+32>>2]|0,c);if(d&8|0)c$b(6,(b[a+28>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function c8a(a){a=a|0;return f[a+12>>2]|0}function d8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&16))o=g;else{m=b[a+29>>0]|0;b[g>>0]=16;b[g+1>>0]=m;o=g+2|0}if(!(e&1))p=o;else{g=f[a+16>>2]|0;b[o>>0]=26;m=o+1|0;o=_i[f[(f[g>>2]|0)+60>>2]&2047](g)|0;if(o>>>0>127){n=o;h=m;while(1){b[h>>0]=n|128;i=n>>>7;j=h+1|0;if(n>>>0>16383){n=i;h=j}else{q=j;r=i;break}}}else{q=m;r=o}b[q>>0]=r;p=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,q+1|0)|0}if(!(e&2))s=p;else{q=f[a+20>>2]|0;b[p>>0]=34;g=p+1|0;p=_i[f[(f[q>>2]|0)+60>>2]&2047](q)|0;if(p>>>0>127){r=p;o=g;while(1){b[o>>0]=r|128;m=r>>>7;h=o+1|0;if(r>>>0>16383){r=m;o=h}else{t=h;u=m;break}}}else{t=g;u=p}b[t>>0]=u;s=hj[f[(f[q>>2]|0)+64>>2]&511](q,c,t+1|0)|0}if(!(e&32))v=s;else{t=f[a+32>>2]|0;b[s>>0]=40;c=s+1|0;s=t&255;if(t>>>0>127){q=c;u=s;p=t;g=((t|0)<0)<<31>>31;while(1){b[q>>0]=u|-128;t=p;p=l1c(p|0,g|0,7)|0;o=q+1|0;r=p&255;if(!(g>>>0>0|(g|0)==0&t>>>0>16383)){w=o;x=r;break}else{q=o;u=r;g=J}}}else{w=c;x=s}b[w>>0]=x;v=w+1|0}if(!(e&8))y=v;else{e=b[a+28>>0]|0;b[v>>0]=48;b[v+1>>0]=e;y=v+2|0}v=f[a+4>>2]|0;if(!(v&1)){z=y;return z|0}z=Pqc(v&-2,y)|0;return z|0}function e8a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Z7a(a);c=kZc(b,21568,16176,0)|0;if(!c){Ooc(b,a);return}else{Z0a(a,c);return}}function f8a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16176,0)|0;if(!c){Ooc(b,a);return}else{Z0a(a,c);return}}function g8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function h8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535576;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function i8a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function j8a(a){a=a|0;var c=0,d=0;f[a>>2]=95188;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function k8a(a){a=a|0;j8a(a);cYc(a);return}function l8a(a){a=a|0;a=$Xc(20)|0;X0a(a);return a|0}function m8a(a,b){a=a|0;b=b|0;a=$Xc(20)|0;X0a(a);if(!b)return a|0;y8a(b,a);return a|0}function n8a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0){d=f[a+16>>2]|0;e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function o8a(a){a=a|0;return 1}function p8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>0){f[c>>2]=a+1;k=j;l=6}else{m=j;l=5}}else{m=0;l=5}if((l|0)==5){l=0;j=ZYb(c,m)|0;if((j+-1|0)>>>0<127){k=j;l=6}else n=j}if((l|0)==6){l=0;if((k|0)==10){f[e>>2]=f[e>>2]|1;j=f[g>>2]|0;if((j|0)==537368){mHa(g,537368);o=f[g>>2]|0}else o=j;if(l$b(c,o)|0)continue;else{p=0;l=15;break}}else n=k}if(!n){p=1;l=15;break}j=f[h>>2]|0;if(!(j&1))q=lSa(h)|0;else q=j&-2;if(!(Lqc(c,n,q)|0)){p=0;l=15;break}}if((l|0)==15)return p|0;return 0}function q8a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;if(!(f[a+8>>2]&1)){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+16>>2]|0;h=b[c+11>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function r8a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)f$b(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function s8a(a){a=a|0;return f[a+12>>2]|0}function t8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=10;e=gZb(c,d+1|0)|0}d=f[a+4>>2]|0;if(!(d&1)){g=e;return g|0}g=Pqc(d&-2,e)|0;return g|0}function u8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))return;d=a+8|0;do if(f[d>>2]&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);v8a(a,c);return}function v8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16192,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[c+16>>2]|0;c=f[d>>2]|0;if((c|0)==(a|0))return;if((c|0)==537368){mHa(d,a);return}else{oYc(c,a)|0;return}}function w8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function x8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535568;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function y8a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function z8a(a){a=a|0;var b=0,c=0;f[a>>2]=95296;P8a(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function A8a(a){a=a|0;z8a(a);cYc(a);return}function B8a(a){a=a|0;a=$Xc(60)|0;V0a(a);return a|0}function C8a(a,b){a=a|0;b=b|0;a=$Xc(60)|0;V0a(a);if(!b)return a|0;O8a(b,a);return a|0}function D8a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&7|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&4|0){e=f[a+24>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);if(d&248|0){g=a+28|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0}if(d&3840|0){f[a+44>>2]=0;b[a+48>>0]=1;n[a+52>>2]=1.0;f[a+56>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function E8a(a){a=a|0;return 1}function F8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+52|0;l=a+20|0;m=a+56|0;n=a+28|0;o=a+37|0;p=e+8|0;q=a+32|0;r=a+36|0;s=e+8|0;t=a+40|0;v=a+44|0;w=a+48|0;x=e+8|0;y=a+24|0;z=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>0){f[c>>2]=a+1;C=B;D=6}else{E=B;D=5}}else{E=0;D=5}if((D|0)==5){D=0;B=ZYb(c,E)|0;if((B+-1|0)>>>0<127){C=B;D=6}else F=B}b:do if((D|0)==6){D=0;do switch(C>>>3&536870911|0){case 1:{if((C&255|0)!=10){F=C;break b}f[i>>2]=f[i>>2]|1;B=f[j>>2]|0;if((B|0)==537368){mHa(j,537368);G=f[j>>2]|0}else G=B;if(l$b(c,G)|0)continue a;else{H=0;D=74;break a}break}case 2:{if((C&255|0)!=21){F=C;break b}f[i>>2]=f[i>>2]|1024;B=f[c>>2]|0;if(((f[g>>2]|0)-B|0)>3){a=B;A=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=A;f[c>>2]=B+4;I=A}else{if(!(WYb(c,e)|0)){D=17;break a}I=f[e>>2]|0}f[k>>2]=I;continue a;break}case 3:{if((C&255|0)!=26){F=C;break b}f[i>>2]=f[i>>2]|2;A=f[l>>2]|0;if((A|0)==537368){mHa(l,537368);K=f[l>>2]|0}else K=A;if(l$b(c,K)|0)continue a;else{H=0;D=74;break a}break}case 4:{if((C&255|0)!=32){F=C;break b}f[i>>2]=f[i>>2]|2048;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){B=b[A>>0]|0;a=B&255;if(B<<24>>24>-1){f[m>>2]=a;f[c>>2]=A+1;continue a}else L=a}else L=0;a=KYb(c,L)|0;A=J;f[m>>2]=a;if((A|0)>-1|(A|0)==-1&a>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 5:{if((C&255|0)!=40){F=C;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>-1){f[n>>2]=B;f[c>>2]=a+1;continue a}else M=B}else M=0;B=KYb(c,M)|0;a=J;f[n>>2]=B;if((a|0)>-1|(a|0)==-1&B>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 6:{if((C&255|0)!=48){F=C;break b}f[i>>2]=f[i>>2]|64;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0?(a=b[B>>0]|0,a<<24>>24>-1):0){f[c>>2]=B+1;N=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[p>>0]|0)){H=0;D=74;break a}else N=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=N&1;continue a;break}case 7:{if((C&255|0)!=56){F=C;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){B=b[a>>0]|0;A=B&255;if(B<<24>>24>-1){f[q>>2]=A;f[c>>2]=a+1;continue a}else O=A}else O=0;A=KYb(c,O)|0;a=J;f[q>>2]=A;if((a|0)>-1|(a|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 8:{if((C&255|0)!=64){F=C;break b}f[i>>2]=f[i>>2]|32;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){f[c>>2]=A+1;P=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[s>>0]|0)){H=0;D=74;break a}else P=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[r>>0]=P&1;continue a;break}case 9:{if((C&255|0)!=72){F=C;break b}f[i>>2]=f[i>>2]|128;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>-1){f[t>>2]=B;f[c>>2]=a+1;continue a}else Q=B}else Q=0;B=KYb(c,Q)|0;a=J;f[t>>2]=B;if((a|0)>-1|(a|0)==-1&B>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 10:{if((C&255|0)!=80){F=C;break b}f[i>>2]=f[i>>2]|256;B=f[c>>2]|0;if(B>>>0<(f[g>>2]|0)>>>0){a=b[B>>0]|0;A=a&255;if(a<<24>>24>-1){f[v>>2]=A;f[c>>2]=B+1;continue a}else R=A}else R=0;A=KYb(c,R)|0;B=J;f[v>>2]=A;if((B|0)>-1|(B|0)==-1&A>>>0>4294967295)continue a;else{H=0;D=74;break a}break}case 11:{if((C&255|0)!=88){F=C;break b}f[i>>2]=f[i>>2]|512;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){f[c>>2]=A+1;S=B<<24>>24!=0}else{LYb(e,c);B=e;if(!(b[x>>0]|0)){H=0;D=74;break a}else S=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0}b[w>>0]=S&1;continue a;break}case 12:{if((C&255|0)!=98){F=C;break b}f[i>>2]=f[i>>2]|4;B=f[y>>2]|0;if((B|0)==537368){mHa(y,537368);T=f[y>>2]|0}else T=B;if(l$b(c,T)|0)continue a;else{H=0;D=74;break a}break}default:{F=C;break b}}while(0)}while(0);if(!F){H=1;D=74;break}B=f[z>>2]|0;if(!(B&1))U=lSa(z)|0;else U=B&-2;if(!(Lqc(c,F,U)|0)){H=0;D=74;break}}if((D|0)==17){H=0;u=d;return H|0}else if((D|0)==74){u=d;return H|0}return 0}function G8a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(c&255){if(!(c&1))e=d;else{g=f[a+16>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0?f[g+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))j=e;else{i=f[a+20>>2]|0;h=b[i+11>>0]|0;g=h<<24>>24<0?f[i+4>>2]|0:h&255;j=e+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))k=j;else{g=f[a+24>>2]|0;e=b[g+11>>0]|0;h=e<<24>>24<0?f[g+4>>2]|0:e&255;k=j+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))l=k;else l=k+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&16))m=l;else m=l+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=c&32|0?m+2|0:m;m=c&64|0?l+2|0:l;if(!(c&128))n=m;else n=m+1+((((($(f[a+40>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0}else n=d;if(!(c&3840)){o=n;p=a+12|0;f[p>>2]=o;return o|0}if(!(c&256))q=n;else q=n+1+((((($(f[a+44>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=c&512|0?q+2|0:q;q=c&1024|0?n+5|0:n;if(!(c&2048)){o=q;p=a+12|0;f[p>>2]=o;return o|0}o=q+1+((((($(f[a+56>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;p=a+12|0;f[p>>2]=o;return o|0}function H8a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+16>>2]|0,c);if(d&1024|0)a$b(2,+n[a+52>>2],c);if(d&2|0)f$b(3,f[a+20>>2]|0,c);if(d&2048|0)U_b(4,f[a+56>>2]|0,c);if(d&8|0)U_b(5,f[a+28>>2]|0,c);if(d&64|0)c$b(6,(b[a+37>>0]|0)!=0,c);if(d&16|0)U_b(7,f[a+32>>2]|0,c);if(d&32|0)c$b(8,(b[a+36>>0]|0)!=0,c);if(d&128|0)U_b(9,f[a+40>>2]|0,c);if(d&256|0)U_b(10,f[a+44>>2]|0,c);if(d&512|0)c$b(11,(b[a+48>>0]|0)!=0,c);if(d&4|0)f$b(12,f[a+24>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function I8a(a){a=a|0;return f[a+12>>2]|0}function J8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&1024))h=e;else{d=f[a+52>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&2))i=h;else{e=f[a+20>>2]|0;b[h>>0]=26;i=gZb(e,h+1|0)|0}if(!(c&2048))j=i;else{h=f[a+56>>2]|0;b[i>>0]=32;e=i+1|0;if(h>>>0>127){i=h;d=e;while(1){b[d>>0]=i|128;g=i>>>7;k=d+1|0;if(i>>>0>16383){i=g;d=k}else{l=k;m=g;break}}}else{l=e;m=h}b[l>>0]=m;j=l+1|0}if(!(c&8))n=j;else{l=f[a+28>>2]|0;b[j>>0]=40;m=j+1|0;if(l>>>0>127){j=l;h=m;while(1){b[h>>0]=j|128;e=j>>>7;d=h+1|0;if(j>>>0>16383){j=e;h=d}else{o=d;p=e;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&64))q=n;else{o=b[a+37>>0]|0;b[n>>0]=48;b[n+1>>0]=o;q=n+2|0}if(!(c&16))r=q;else{n=f[a+32>>2]|0;b[q>>0]=56;o=q+1|0;if(n>>>0>127){q=n;p=o;while(1){b[p>>0]=q|128;l=q>>>7;m=p+1|0;if(q>>>0>16383){q=l;p=m}else{s=m;t=l;break}}}else{s=o;t=n}b[s>>0]=t;r=s+1|0}if(!(c&32))u=r;else{s=b[a+36>>0]|0;b[r>>0]=64;b[r+1>>0]=s;u=r+2|0}if(!(c&128))v=u;else{r=f[a+40>>2]|0;b[u>>0]=72;s=u+1|0;if(r>>>0>127){u=r;t=s;while(1){b[t>>0]=u|128;n=u>>>7;o=t+1|0;if(u>>>0>16383){u=n;t=o}else{w=o;x=n;break}}}else{w=s;x=r}b[w>>0]=x;v=w+1|0}if(!(c&256))y=v;else{w=f[a+44>>2]|0;b[v>>0]=80;x=v+1|0;if(w>>>0>127){v=w;r=x;while(1){b[r>>0]=v|128;s=v>>>7;t=r+1|0;if(v>>>0>16383){v=s;r=t}else{z=t;A=s;break}}}else{z=x;A=w}b[z>>0]=A;y=z+1|0}if(!(c&512))B=y;else{z=b[a+48>>0]|0;b[y>>0]=88;b[y+1>>0]=z;B=y+2|0}if(!(c&4))C=B;else{c=f[a+24>>2]|0;b[B>>0]=98;C=gZb(c,B+1|0)|0}B=f[a+4>>2]|0;if(!(B&1)){D=C;return D|0}D=Pqc(B&-2,C)|0;return D|0}function K8a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;D8a(a);c=kZc(b,21568,16208,0)|0;if(!c){Ooc(b,a);return}else{W0a(a,c);return}}function L8a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16208,0)|0;if(!c){Ooc(b,a);return}else{W0a(a,c);return}}function M8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function N8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535560;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function O8a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function P8a(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function Q8a(a){a=a|0;var c=0,d=0;f[a>>2]=95404;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function R8a(a){a=a|0;Q8a(a);cYc(a);return}function S8a(a){a=a|0;a=$Xc(28)|0;T0a(a);return a|0}function T8a(a,b){a=a|0;b=b|0;a=$Xc(28)|0;T0a(a);if(!b)return a|0;d9a(b,a);return a|0}function U8a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&6|0){d=a+20|0;f[d>>2]=0;b[d+4>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function V8a(a){a=a|0;return 1}function W8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+24|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[i>>2]|0;if((o|0)==537368){mHa(i,537368);t=f[i>>2]|0}else t=o;if(l$b(c,t)|0)continue a;else{v=0;q=27;break a}break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[j>>2]=n;f[c>>2]=o+1;continue a}else w=n}else w=0;n=KYb(c,w)|0;o=J;f[j>>2]=n;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)continue a;else{v=0;q=27;break a}break}case 3:{if((p&255|0)!=24){s=p;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;x=o<<24>>24!=0}else{LYb(e,c);o=e;if(!(b[l>>0]|0)){v=0;q=27;break a}else x=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[k>>0]=x&1;continue a;break}default:{s=p;break b}}}while(0);if(!s){v=1;q=27;break}o=f[m>>2]|0;if(!(o&1))y=lSa(m)|0;else y=o&-2;if(!(Lqc(c,s,y)|0)){v=0;q=27;break}}if((q|0)==27){u=d;return v|0}return 0}function X8a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&7)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else l=h+1+((((($(f[a+20>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=c&4|0?l+2|0:l;g=a+12|0;f[g>>2]=e;return e|0}function Y8a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+16>>2]|0,c);if(d&2|0)U_b(2,f[a+20>>2]|0,c);if(d&4|0)c$b(3,(b[a+24>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function Z8a(a){a=a|0;return f[a+12>>2]|0}function _8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=16;g=e+1|0;if(d>>>0>127){e=d;i=g;while(1){b[i>>0]=e|128;j=e>>>7;k=i+1|0;if(e>>>0>16383){e=j;i=k}else{l=k;m=j;break}}}else{l=g;m=d}b[l>>0]=m;h=l+1|0}if(!(c&4))n=h;else{c=b[a+24>>0]|0;b[h>>0]=24;b[h+1>>0]=c;n=h+2|0}h=f[a+4>>2]|0;if(!(h&1)){o=n;return o|0}o=Pqc(h&-2,n)|0;return o|0}function $8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;d=a+8|0;e=f[d>>2]|0;do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&6|0){e=a+20|0;f[e>>2]=0;b[e+4>>0]=0}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16224,0)|0;if(!e){Ooc(c,a);return}else{U0a(a,e);return}}function a9a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16224,0)|0;if(!c){Ooc(b,a);return}else{U0a(a,c);return}}function b9a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function c9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535536;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function d9a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function e9a(a){a=a|0;var b=0,c=0;f[a>>2]=95512;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function f9a(a){a=a|0;var b=0,c=0;f[a>>2]=95512;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function g9a(a){a=a|0;a=$Xc(24)|0;S0a(a);return a|0}function h9a(a,b){a=a|0;b=b|0;a=$Xc(24)|0;S0a(a);if(!b)return a|0;t9a(b,a);return a|0}function i9a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&3|0){n[a+16>>2]=.5;b[a+20>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function j9a(a){a=a|0;return 1}function k9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+20|0;l=e+8|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(WYb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0?(o=b[n>>0]|0,o<<24>>24>-1):0){f[c>>2]=n+1;v=o<<24>>24!=0}else{LYb(e,c);o=e;if(!(b[l>>0]|0)){w=0;q=25;break a}else v=(f[o>>2]|0)!=0|(f[o+4>>2]|0)!=0}b[k>>0]=v&1;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=25;break}o=f[m>>2]|0;if(!(o&1))x=lSa(m)|0;else x=o&-2;if(!(Lqc(c,s,x)|0)){w=0;q=25;break}}if((q|0)==13){w=0;u=d;return w|0}else if((q|0)==25){u=d;return w|0}return 0}function l9a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;d=b&2|0?g+2|0:g;e=a+12|0;f[e>>2]=d;return d|0}function m9a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)a$b(1,+n[a+16>>2],c);if(d&2|0)c$b(2,(b[a+20>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function n9a(a){a=a|0;return f[a+12>>2]|0}function o9a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&2))i=e;else{c=b[a+20>>0]|0;b[e>>0]=16;b[e+1>>0]=c;i=e+2|0}e=f[a+4>>2]|0;if(!(e&1)){j=i;return j|0}j=Pqc(e&-2,i)|0;return j|0}function p9a(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))return;d=a+8|0;if(f[d>>2]&3|0){n[a+16>>2]=.5;b[a+20>>0]=1}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);q9a(a,c);return}function q9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,16240,0)|0;if(!d){Ooc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&3))return;if(e&1|0)f[a+16>>2]=f[d+16>>2];if(e&2|0)b[a+20>>0]=b[d+20>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|e;return}function r9a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535480;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function t9a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function u9a(a){a=a|0;var c=0,d=0;f[a>>2]=95620;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(d);f[c>>2]=0;return}function v9a(a){a=a|0;u9a(a);cYc(a);return}function w9a(a){a=a|0;a=$Xc(52)|0;Q0a(a);return a|0}function x9a(a,b){a=a|0;b=b|0;a=$Xc(52)|0;Q0a(a);if(!b)return a|0;J9a(b,a);return a|0}function y9a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);if(d&252|0){e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0}if(d&768|0){n[a+44>>2]=1.0;f[a+48>>2]=4}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function z9a(a){a=a|0;return 1}function A9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+44|0;l=a+20|0;m=a+24|0;n=a+28|0;o=a+36|0;p=e+8|0;q=a+32|0;r=a+40|0;s=a+4|0;t=a+37|0;v=e+8|0;w=a+48|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=ZYb(c,B)|0;if((y+-1|0)>>>0<127){z=y;A=6}else C=y}b:do if((A|0)==6){A=0;do switch(z>>>3&536870911|0){case 1:{if((z&255|0)!=10){C=z;break b}f[i>>2]=f[i>>2]|1;y=f[j>>2]|0;if((y|0)==537368){mHa(j,537368);D=f[j>>2]|0}else D=y;if(l$b(c,D)|0)continue a;else{E=0;A=70;break a}break}case 2:{if((z&255|0)!=21){C=z;break b}f[i>>2]=f[i>>2]|256;y=f[c>>2]|0;if(((f[g>>2]|0)-y|0)>3){a=y;x=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=x;f[c>>2]=y+4;F=x}else{if(!(WYb(c,e)|0)){A=17;break a}F=f[e>>2]|0}f[k>>2]=F;continue a;break}case 3:{if((z&255|0)!=26){C=z;break b}f[i>>2]=f[i>>2]|2;x=f[l>>2]|0;if((x|0)==537368){mHa(l,537368);G=f[l>>2]|0}else G=x;if(l$b(c,G)|0)continue a;else{E=0;A=70;break a}break}case 4:{if((z&255|0)!=32){C=z;break b}f[i>>2]=f[i>>2]|4;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;a=y&255;if(y<<24>>24>-1){f[m>>2]=a;f[c>>2]=x+1;continue a}else H=a}else H=0;a=KYb(c,H)|0;x=J;f[m>>2]=a;if((x|0)>-1|(x|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=70;break a}break}case 5:{if((z&255|0)!=40){C=z;break b}f[i>>2]=f[i>>2]|8;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>-1){f[n>>2]=y;f[c>>2]=a+1;continue a}else I=y}else I=0;y=KYb(c,I)|0;a=J;f[n>>2]=y;if((a|0)>-1|(a|0)==-1&y>>>0>4294967295)continue a;else{E=0;A=70;break a}break}case 6:{if((z&255|0)!=48){C=z;break b}f[i>>2]=f[i>>2]|32;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(a=b[y>>0]|0,a<<24>>24>-1):0){f[c>>2]=y+1;K=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[p>>0]|0)){E=0;A=70;break a}else K=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[o>>0]=K&1;continue a;break}case 7:{if((z&255|0)!=56){C=z;break b}f[i>>2]=f[i>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){y=b[a>>0]|0;x=y&255;if(y<<24>>24>-1){f[q>>2]=x;f[c>>2]=a+1;continue a}else L=x}else L=0;x=KYb(c,L)|0;a=J;f[q>>2]=x;if((a|0)>-1|(a|0)==-1&x>>>0>4294967295)continue a;else{E=0;A=70;break a}break}case 8:{if((z&255|0)!=64){C=z;break b}x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){a=b[x>>0]|0;y=a&255;if(a<<24>>24>-1){f[c>>2]=x+1;M=y}else{N=y;A=47}}else{N=0;A=47}if((A|0)==47){A=0;y=KYb(c,N)|0;x=J;if((x|0)>-1|(x|0)==-1&y>>>0>4294967295)M=y;else{E=0;A=70;break a}}if(M>>>0<2){f[i>>2]=f[i>>2]|128;f[r>>2]=M;continue a}y=f[s>>2]|0;if(!(y&1))O=lSa(s)|0;else O=y&-2;yqc(O,8,M,((M|0)<0)<<31>>31);continue a;break}case 9:{if((z&255|0)!=72){C=z;break b}f[i>>2]=f[i>>2]|64;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(x=b[y>>0]|0,x<<24>>24>-1):0){f[c>>2]=y+1;P=x<<24>>24!=0}else{LYb(e,c);x=e;if(!(b[v>>0]|0)){E=0;A=70;break a}else P=(f[x>>2]|0)!=0|(f[x+4>>2]|0)!=0}b[t>>0]=P&1;continue a;break}case 10:{if((z&255|0)!=80){C=z;break b}f[i>>2]=f[i>>2]|512;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;a=y&255;if(y<<24>>24>-1){f[w>>2]=a;f[c>>2]=x+1;continue a}else Q=a}else Q=0;a=KYb(c,Q)|0;x=J;f[w>>2]=a;if((x|0)>-1|(x|0)==-1&a>>>0>4294967295)continue a;else{E=0;A=70;break a}break}default:{C=z;break b}}while(0)}while(0);if(!C){E=1;A=70;break}a=f[s>>2]|0;if(!(a&1))R=lSa(s)|0;else R=a&-2;if(!(Lqc(c,C,R)|0)){E=0;A=70;break}}if((A|0)==17){E=0;u=d;return E|0}else if((A|0)==70){u=d;return E|0}return 0}function B9a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(c&255){if(!(c&1))e=d;else{g=f[a+16>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0?f[g+4>>2]|0:h&255;e=d+1+i+((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))j=e;else{i=f[a+20>>2]|0;h=b[i+11>>0]|0;g=h<<24>>24<0?f[i+4>>2]|0:h&255;j=e+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))k=j;else k=j+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&8))l=k;else l=k+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(c&16))m=l;else m=l+1+((((($(f[a+32>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=c&32|0?m+2|0:m;m=c&64|0?l+2|0:l;if(!(c&128))n=m;else{l=f[a+40>>2]|0;if((l|0)<0)o=11;else o=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=o+m|0}}else n=d;if(!(c&768)){p=n;q=a+12|0;f[q>>2]=p;return p|0}d=c&256|0?n+5|0:n;if(!(c&512)){p=d;q=a+12|0;f[q>>2]=p;return p|0}p=d+1+((((($(f[a+48>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;q=a+12|0;f[q>>2]=p;return p|0}function C9a(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+16>>2]|0,c);if(d&256|0)a$b(2,+n[a+44>>2],c);if(d&2|0)f$b(3,f[a+20>>2]|0,c);if(d&4|0)U_b(4,f[a+24>>2]|0,c);if(d&8|0)U_b(5,f[a+28>>2]|0,c);if(d&32|0)c$b(6,(b[a+36>>0]|0)!=0,c);if(d&16|0)U_b(7,f[a+32>>2]|0,c);if(d&128|0)d$b(8,f[a+40>>2]|0,c);if(d&64|0)c$b(9,(b[a+37>>0]|0)!=0,c);if(d&512|0)U_b(10,f[a+48>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function D9a(a){a=a|0;return f[a+12>>2]|0}function E9a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&256))h=e;else{d=f[a+44>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&2))i=h;else{e=f[a+20>>2]|0;b[h>>0]=26;i=gZb(e,h+1|0)|0}if(!(c&4))j=i;else{h=f[a+24>>2]|0;b[i>>0]=32;e=i+1|0;if(h>>>0>127){i=h;d=e;while(1){b[d>>0]=i|128;g=i>>>7;k=d+1|0;if(i>>>0>16383){i=g;d=k}else{l=k;m=g;break}}}else{l=e;m=h}b[l>>0]=m;j=l+1|0}if(!(c&8))n=j;else{l=f[a+28>>2]|0;b[j>>0]=40;m=j+1|0;if(l>>>0>127){j=l;h=m;while(1){b[h>>0]=j|128;e=j>>>7;d=h+1|0;if(j>>>0>16383){j=e;h=d}else{o=d;p=e;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}if(!(c&32))q=n;else{o=b[a+36>>0]|0;b[n>>0]=48;b[n+1>>0]=o;q=n+2|0}if(!(c&16))r=q;else{n=f[a+32>>2]|0;b[q>>0]=56;o=q+1|0;if(n>>>0>127){q=n;p=o;while(1){b[p>>0]=q|128;l=q>>>7;m=p+1|0;if(q>>>0>16383){q=l;p=m}else{s=m;t=l;break}}}else{s=o;t=n}b[s>>0]=t;r=s+1|0}if(!(c&128))u=r;else{s=f[a+40>>2]|0;b[r>>0]=64;t=r+1|0;r=s&255;if(s>>>0>127){n=t;o=r;p=s;q=((s|0)<0)<<31>>31;while(1){b[n>>0]=o|-128;s=p;p=l1c(p|0,q|0,7)|0;l=n+1|0;m=p&255;if(!(q>>>0>0|(q|0)==0&s>>>0>16383)){v=l;w=m;break}else{n=l;o=m;q=J}}}else{v=t;w=r}b[v>>0]=w;u=v+1|0}if(!(c&64))x=u;else{v=b[a+37>>0]|0;b[u>>0]=72;b[u+1>>0]=v;x=u+2|0}if(!(c&512))y=x;else{c=f[a+48>>2]|0;b[x>>0]=80;u=x+1|0;if(c>>>0>127){x=c;v=u;while(1){b[v>>0]=x|128;w=x>>>7;r=v+1|0;if(x>>>0>16383){x=w;v=r}else{z=r;A=w;break}}}else{z=u;A=c}b[z>>0]=A;y=z+1|0}z=f[a+4>>2]|0;if(!(z&1)){B=y;return B|0}B=Pqc(z&-2,y)|0;return B|0}function F9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))return;d=a+8|0;e=f[d>>2]|0;do if(e&3|0){do if(e&1|0){g=f[a+16>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(e&2|0){h=f[a+20>>2]|0;g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}}while(0);if(e&252|0){g=a+24|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0}if(e&768|0){n[a+44>>2]=1.0;f[a+48>>2]=4}f[d>>2]=0;d=f[a+4>>2]|0;if(d&1|0?(e=d&-2,f[e>>2]|0):0)sqc(e);e=kZc(c,21568,16256,0)|0;if(!e){Ooc(c,a);return}else{R0a(a,e);return}}function G9a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16256,0)|0;if(!c){Ooc(b,a);return}else{R0a(a,c);return}}function H9a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function I9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535456;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function J9a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function K9a(a){a=a|0;var b=0,c=0;f[a>>2]=95728;if((a|0)!=532968){b=f[a+64>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+68>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=f[a+60>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+48>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function L9a(a){a=a|0;K9a(a);cYc(a);return}function M9a(a){a=a|0;a=$Xc(120)|0;O0a(a);return a|0}function N9a(a,b){a=a|0;b=b|0;a=$Xc(120)|0;O0a(a);if(!b)return a|0;Z9a(b,a);return a|0}function O9a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;f[a+16>>2]=0;f[a+28>>2]=0;f[a+40>>2]=0;f[a+52>>2]=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+64>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}if(d&2|0){e=f[a+68>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}}if(d&252|0){e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0}if(d&16128|0){d=a+96|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+108>>2]=1;b[a+112>>0]=1;f[a+116>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function P9a(a){a=a|0;return 1}function Q9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+72|0;k=a+112|0;l=e+8|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+32|0;r=a+36|0;s=a+116|0;t=a+40|0;v=a+44|0;w=a+48|0;x=a+64|0;y=e+4|0;z=a+68|0;A=e+4|0;B=a+76|0;C=a+80|0;D=a+84|0;E=a+88|0;F=a+92|0;G=a+96|0;H=a+100|0;I=a+4|0;K=a+108|0;L=a+104|0;M=e+8|0;N=a+52|0;O=a+56|0;P=a+60|0;a:while(1){a=f[c>>2]|0;Q=f[g>>2]|0;do if(a>>>0<Q>>>0){R=b[a>>0]|0;S=R&255;T=a+1|0;if(R<<24>>24>0){U=T;V=S}else{if(T>>>0>=Q>>>0){W=S;X=7;break}R=h[T>>0]|0;if(((R^128)&S)>>>0<=127){W=S;X=7;break}U=a+2|0;V=S+-128+(R<<7)|0}f[c>>2]=U;Y=V;X=9}else{W=0;X=7}while(0);if((X|0)==7){X=0;a=ZYb(c,W)|0;if((a+-1|0)>>>0<16383){Y=a;X=9}else Z=a}b:do if((X|0)==9){X=0;do switch(Y>>>3&536870911|0){case 1:{if((Y&255|0)!=8){Z=Y;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){Q=b[a>>0]|0;R=Q&255;if(Q<<24>>24>-1){f[j>>2]=R;f[c>>2]=a+1;continue a}else _=R}else _=0;R=KYb(c,_)|0;a=J;f[j>>2]=R;if((a|0)>-1|(a|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 2:{if((Y&255|0)!=16){Z=Y;break b}f[i>>2]=f[i>>2]|4096;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0?(a=b[R>>0]|0,a<<24>>24>-1):0){f[c>>2]=R+1;aa=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[l>>0]|0)){$=0;X=175;break a}else aa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[k>>0]=aa&1;continue a;break}case 3:{switch((Y&255)<<24>>24){case 24:break;case 26:{if(h4a(c,m)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=a+1;ba=Q}else{ca=Q;X=25}}else{ca=0;X=25}if((X|0)==25){X=0;Q=KYb(c,ca)|0;a=J;if((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)ba=Q;else{$=0;X=175;break a}}Q=f[m>>2]|0;if((Q|0)==(f[n>>2]|0)){xHa(m,Q+1|0);da=f[m>>2]|0}else da=Q;Q=f[o>>2]|0;f[m>>2]=da+1;f[Q+4+(da<<2)>>2]=ba;a=(f[n>>2]|0)-(f[m>>2]|0)|0;if((a|0)>0){ea=a;fa=Q}else continue a;while(1){Q=f[c>>2]|0;a=f[g>>2]|0;if(Q>>>0>=a>>>0)continue a;if((b[Q>>0]|0)!=24)continue a;R=Q+1|0;f[c>>2]=R;if(R>>>0<a>>>0){a=b[R>>0]|0;R=a&255;if(a<<24>>24>-1){f[c>>2]=Q+2;ga=R;ha=fa}else{ia=R;X=33}}else{ia=0;X=33}if((X|0)==33){X=0;R=KYb(c,ia)|0;Q=J;if(!((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)){$=0;X=175;break a}ga=R;ha=f[o>>2]|0}R=f[m>>2]|0;f[m>>2]=R+1;f[ha+4+(R<<2)>>2]=ga;if((ea|0)>1){ea=ea+-1|0;fa=ha}else continue a}break}case 4:{switch((Y&255)<<24>>24){case 32:break;case 34:{if(h4a(c,p)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[c>>2]=R+1;ja=a}else{ka=a;X=42}}else{ka=0;X=42}if((X|0)==42){X=0;a=KYb(c,ka)|0;R=J;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)ja=a;else{$=0;X=175;break a}}a=f[p>>2]|0;if((a|0)==(f[q>>2]|0)){xHa(p,a+1|0);la=f[p>>2]|0}else la=a;a=f[r>>2]|0;f[p>>2]=la+1;f[a+4+(la<<2)>>2]=ja;R=(f[q>>2]|0)-(f[p>>2]|0)|0;if((R|0)>0){ma=R;na=a}else continue a;while(1){a=f[c>>2]|0;R=f[g>>2]|0;if(a>>>0>=R>>>0)continue a;if((b[a>>0]|0)!=32)continue a;Q=a+1|0;f[c>>2]=Q;if(Q>>>0<R>>>0){R=b[Q>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=a+2;oa=Q;pa=na}else{qa=Q;X=50}}else{qa=0;X=50}if((X|0)==50){X=0;Q=KYb(c,qa)|0;a=J;if(!((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)){$=0;X=175;break a}oa=Q;pa=f[r>>2]|0}Q=f[p>>2]|0;f[p>>2]=Q+1;f[pa+4+(Q<<2)>>2]=oa;if((ma|0)>1){ma=ma+-1|0;na=pa}else continue a}break}case 5:{if((Y&255|0)!=40){Z=Y;break b}f[i>>2]=f[i>>2]|8192;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[s>>2]=R;f[c>>2]=Q+1;continue a}else ra=R}else ra=0;R=KYb(c,ra)|0;Q=J;f[s>>2]=R;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 6:{switch((Y&255)<<24>>24){case 48:break;case 50:{if(h4a(c,t)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[c>>2]=R+1;sa=a}else{ta=a;X=64}}else{ta=0;X=64}if((X|0)==64){X=0;a=KYb(c,ta)|0;R=J;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)sa=a;else{$=0;X=175;break a}}a=f[t>>2]|0;if((a|0)==(f[v>>2]|0)){xHa(t,a+1|0);ua=f[t>>2]|0}else ua=a;a=f[w>>2]|0;f[t>>2]=ua+1;f[a+4+(ua<<2)>>2]=sa;R=(f[v>>2]|0)-(f[t>>2]|0)|0;if((R|0)>0){va=R;wa=a}else continue a;while(1){a=f[c>>2]|0;R=f[g>>2]|0;if(a>>>0>=R>>>0)continue a;if((b[a>>0]|0)!=48)continue a;Q=a+1|0;f[c>>2]=Q;if(Q>>>0<R>>>0){R=b[Q>>0]|0;Q=R&255;if(R<<24>>24>-1){f[c>>2]=a+2;xa=Q;ya=wa}else{za=Q;X=72}}else{za=0;X=72}if((X|0)==72){X=0;Q=KYb(c,za)|0;a=J;if(!((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)){$=0;X=175;break a}xa=Q;ya=f[w>>2]|0}Q=f[t>>2]|0;f[t>>2]=Q+1;f[ya+4+(Q<<2)>>2]=xa;if((va|0)>1){va=va+-1|0;wa=ya}else continue a}break}case 7:{if((Y&255|0)!=58){Z=Y;break b}f[i>>2]=f[i>>2]|1;Q=f[x>>2]|0;if(!Q){a=$Xc(48)|0;__a(a);f[x>>2]=a;Aa=a}else Aa=Q;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0?(a=b[Q>>0]|0,a<<24>>24>-1):0){f[c>>2]=Q+1;Ba=a&255}else{a=YYb(c)|0;if((a|0)>-1)Ba=a;else{$=0;X=175;break a}}JYb(e,c,Ba);if((f[y>>2]|0)<0){X=86;break a}if(!(Mi[f[(f[Aa>>2]|0)+44>>2]&1023](Aa,c)|0)){X=86;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{$=0;X=175;break a}break}case 8:{if((Y&255|0)!=66){Z=Y;break b}f[i>>2]=f[i>>2]|2;a=f[z>>2]|0;if(!a){Q=$Xc(48)|0;__a(Q);f[z>>2]=Q;Ca=Q}else Ca=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(Q=b[a>>0]|0,Q<<24>>24>-1):0){f[c>>2]=a+1;Da=Q&255}else{Q=YYb(c)|0;if((Q|0)>-1)Da=Q;else{$=0;X=175;break a}}JYb(e,c,Da);if((f[A>>2]|0)<0){X=97;break a}if(!(Mi[f[(f[Ca>>2]|0)+44>>2]&1023](Ca,c)|0)){X=97;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{$=0;X=175;break a}break}case 9:{if((Y&255|0)!=72){Z=Y;break b}f[i>>2]=f[i>>2]|8;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[B>>2]=R;f[c>>2]=Q+1;continue a}else Ea=R}else Ea=0;R=KYb(c,Ea)|0;Q=J;f[B>>2]=R;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 10:{if((Y&255|0)!=80){Z=Y;break b}f[i>>2]=f[i>>2]|16;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[C>>2]=a;f[c>>2]=R+1;continue a}else Fa=a}else Fa=0;a=KYb(c,Fa)|0;R=J;f[C>>2]=a;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 11:{if((Y&255|0)!=88){Z=Y;break b}f[i>>2]=f[i>>2]|32;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;Q=R&255;if(R<<24>>24>-1){f[D>>2]=Q;f[c>>2]=a+1;continue a}else Ga=Q}else Ga=0;Q=KYb(c,Ga)|0;a=J;f[D>>2]=Q;if((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 12:{if((Y&255|0)!=96){Z=Y;break b}f[i>>2]=f[i>>2]|64;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[E>>2]=R;f[c>>2]=Q+1;continue a}else Ha=R}else Ha=0;R=KYb(c,Ha)|0;Q=J;f[E>>2]=R;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 13:{if((Y&255|0)!=104){Z=Y;break b}f[i>>2]=f[i>>2]|128;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[F>>2]=a;f[c>>2]=R+1;continue a}else Ia=a}else Ia=0;a=KYb(c,Ia)|0;R=J;f[F>>2]=a;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 14:{if((Y&255|0)!=112){Z=Y;break b}f[i>>2]=f[i>>2]|256;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){R=b[a>>0]|0;Q=R&255;if(R<<24>>24>-1){f[G>>2]=Q;f[c>>2]=a+1;continue a}else Ja=Q}else Ja=0;Q=KYb(c,Ja)|0;a=J;f[G>>2]=Q;if((a|0)>-1|(a|0)==-1&Q>>>0>4294967295)continue a;else{$=0;X=175;break a}break}case 15:{if((Y&255|0)!=120){Z=Y;break b}Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0){a=b[Q>>0]|0;R=a&255;if(a<<24>>24>-1){f[c>>2]=Q+1;Ka=R}else{La=R;X=133}}else{La=0;X=133}if((X|0)==133){X=0;R=KYb(c,La)|0;Q=J;if((Q|0)>-1|(Q|0)==-1&R>>>0>4294967295)Ka=R;else{$=0;X=175;break a}}if(Ka>>>0<3){f[i>>2]=f[i>>2]|512;f[H>>2]=Ka;continue a}R=f[I>>2]|0;if(!(R&1))Ma=lSa(I)|0;else Ma=R&-2;yqc(Ma,15,Ka,((Ka|0)<0)<<31>>31);continue a;break}case 16:{if((Y&255|0)!=128){Z=Y;break b}f[i>>2]=f[i>>2]|2048;R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){Q=b[R>>0]|0;a=Q&255;if(Q<<24>>24>-1){f[c>>2]=R+1;Na=a}else{Oa=a;X=144}}else{Oa=0;X=144}if((X|0)==144){X=0;a=KYb(c,Oa)|0;R=J;if((R|0)>-1|(R|0)==-1&a>>>0>4294967295)Na=a;else{$=0;X=175;break a}}f[K>>2]=Na;continue a;break}case 17:{if((Y&255|0)!=136){Z=Y;break b}f[i>>2]=f[i>>2]|1024;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(R=b[a>>0]|0,R<<24>>24>-1):0){f[c>>2]=a+1;Pa=R<<24>>24!=0}else{LYb(e,c);R=e;if(!(b[M>>0]|0)){$=0;X=175;break a}else Pa=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0}b[L>>0]=Pa&1;continue a;break}case 18:{switch((Y&255)<<24>>24){case -112:break;case -110:{if(h4a(c,N)|0)continue a;else{$=0;X=175;break a}break}default:{Z=Y;break b}}R=f[c>>2]|0;if(R>>>0<(f[g>>2]|0)>>>0){a=b[R>>0]|0;Q=a&255;if(a<<24>>24>-1){f[c>>2]=R+1;Qa=Q}else{Ra=Q;X=156}}else{Ra=0;X=156}if((X|0)==156){X=0;Q=KYb(c,Ra)|0;R=J;if((R|0)>-1|(R|0)==-1&Q>>>0>4294967295)Qa=Q;else{$=0;X=175;break a}}Q=f[N>>2]|0;if((Q|0)==(f[O>>2]|0)){xHa(N,Q+1|0);Sa=f[N>>2]|0}else Sa=Q;Q=f[P>>2]|0;f[N>>2]=Sa+1;f[Q+4+(Sa<<2)>>2]=Qa;R=(f[O>>2]|0)-(f[N>>2]|0)|0;if((R|0)>0){Ta=R;Ua=Q}else continue a;while(1){Q=f[g>>2]|0;R=f[c>>2]|0;a=R;if((Q-R|0)<=1)continue a;if((b[a>>0]|0)!=-112)continue a;if((b[a+1>>0]|0)!=1)continue a;R=a+2|0;f[c>>2]=R;if(R>>>0<Q>>>0){Q=b[R>>0]|0;R=Q&255;if(Q<<24>>24>-1){f[c>>2]=a+3;Va=R;Wa=Ua}else{Xa=R;X=165}}else{Xa=0;X=165}if((X|0)==165){X=0;R=KYb(c,Xa)|0;a=J;if(!((a|0)>-1|(a|0)==-1&R>>>0>4294967295)){$=0;X=175;break a}Va=R;Wa=f[P>>2]|0}R=f[N>>2]|0;f[N>>2]=R+1;f[Wa+4+(R<<2)>>2]=Va;if((Ta|0)>1){Ta=Ta+-1|0;Ua=Wa}else continue a}break}default:{Z=Y;break b}}while(0)}while(0);if(!Z){$=1;X=175;break}R=f[I>>2]|0;if(!(R&1))Ya=lSa(I)|0;else Ya=R&-2;if(!(Lqc(c,Z,Ya)|0)){$=0;X=175;break}}if((X|0)==86){$=0;u=d;return $|0}else if((X|0)==97){$=0;u=d;return $|0}else if((X|0)==175){u=d;return $|0}return 0}function R9a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=o$b(a+16|0)|0;d=f[a+16>>2]|0;e=o$b(a+28|0)|0;g=f[a+28>>2]|0;h=o$b(a+40|0)|0;i=f[a+40>>2]|0;j=o$b(a+52|0)|0;k=b+c+d+e+g+h+i+j+(f[a+52>>2]<<1)|0;j=a+8|0;i=f[j>>2]|0;if(i&255){if(!(i&1)){l=k;m=i}else{h=f[a+64>>2]|0;g=_i[f[(f[h>>2]|0)+48>>2]&2047](h)|0;h=k+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;l=h;m=f[j>>2]|0}if(!(m&2)){n=l;o=m}else{m=f[a+68>>2]|0;h=_i[f[(f[m>>2]|0)+48>>2]&2047](m)|0;m=l+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0;n=m;o=f[j>>2]|0}if(!(o&4))p=n;else p=n+1+((((($(f[a+72>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&8))q=p;else q=p+1+((((($(f[a+76>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&16))r=q;else r=q+1+((((($(f[a+80>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&32))s=r;else s=r+1+((((($(f[a+84>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&64))t=s;else t=s+1+((((($(f[a+88>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(o&128)){u=t;v=o}else{u=t+1+((((($(f[a+92>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;v=o}}else{u=k;v=i}if(!(v&16128)){w=u;x=a+12|0;f[x>>2]=w;return w|0}if(!(v&256))y=u;else y=u+1+((((($(f[a+96>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(v&512))z=y;else{u=f[a+100>>2]|0;if((u|0)<0)A=11;else A=((((($(u|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;z=A+y|0}y=v&1024|0?z+3|0:z;if(!(v&2048))B=y;else{z=f[a+108>>2]|0;if((z|0)<0)C=12;else C=((((($(z|1|0)|0)^31)*9|0)+73|0)>>>6)+2|0;B=C+y|0}y=v&4096|0?B+2|0:B;if(!(v&8192)){w=y;x=a+12|0;f[x>>2]=w;return w|0}w=y+1+((((($(f[a+116>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;x=a+12|0;f[x>>2]=w;return w|0}function S9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[a+8>>2]|0;if(d&4|0)U_b(1,f[a+72>>2]|0,c);if(d&4096|0)c$b(2,(b[a+112>>0]|0)!=0,c);e=f[a+16>>2]|0;if((e|0)>0){g=a+24|0;h=0;do{U_b(3,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=f[a+28>>2]|0;if((e|0)>0){h=a+36|0;g=0;do{U_b(4,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(e|0))}if(d&8192|0)U_b(5,f[a+116>>2]|0,c);e=f[a+40>>2]|0;if((e|0)>0){g=a+48|0;h=0;do{U_b(6,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}if(d&1|0)k$b(7,f[a+64>>2]|0,c);if(d&2|0)k$b(8,f[a+68>>2]|0,c);if(d&8|0)U_b(9,f[a+76>>2]|0,c);if(d&16|0)U_b(10,f[a+80>>2]|0,c);if(d&32|0)U_b(11,f[a+84>>2]|0,c);if(d&64|0)U_b(12,f[a+88>>2]|0,c);if(d&128|0)U_b(13,f[a+92>>2]|0,c);if(d&256|0)U_b(14,f[a+96>>2]|0,c);if(d&512|0)d$b(15,f[a+100>>2]|0,c);if(d&2048|0)S_b(16,f[a+108>>2]|0,c);if(d&1024|0)c$b(17,(b[a+104>>0]|0)!=0,c);d=f[a+52>>2]|0;if((d|0)>0){e=a+60|0;h=0;do{U_b(18,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(d|0))}d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function T9a(a){a=a|0;return f[a+12>>2]|0}function U9a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+72>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&4096))o=g;else{m=b[a+112>>0]|0;b[g>>0]=16;b[g+1>>0]=m;o=g+2|0}g=f[a+16>>2]|0;if(!g)p=o;else{m=f[a+24>>2]|0;n=0;h=o;while(1){o=f[m+4+(n<<2)>>2]|0;b[h>>0]=24;i=h+1|0;if(o>>>0>127){j=o;d=i;while(1){b[d>>0]=j|128;k=j>>>7;l=d+1|0;if(j>>>0>16383){j=k;d=l}else{q=l;r=k;break}}}else{q=i;r=o}b[q>>0]=r;d=q+1|0;n=n+1|0;if((n|0)>=(g|0)){p=d;break}else h=d}}h=f[a+28>>2]|0;if(!h)s=p;else{g=f[a+36>>2]|0;n=0;q=p;while(1){p=f[g+4+(n<<2)>>2]|0;b[q>>0]=32;r=q+1|0;if(p>>>0>127){m=p;d=r;while(1){b[d>>0]=m|128;j=m>>>7;k=d+1|0;if(m>>>0>16383){m=j;d=k}else{t=k;u=j;break}}}else{t=r;u=p}b[t>>0]=u;d=t+1|0;n=n+1|0;if((n|0)>=(h|0)){s=d;break}else q=d}}if(!(e&8192))v=s;else{q=f[a+116>>2]|0;b[s>>0]=40;h=s+1|0;if(q>>>0>127){s=q;n=h;while(1){b[n>>0]=s|128;t=s>>>7;u=n+1|0;if(s>>>0>16383){s=t;n=u}else{w=u;x=t;break}}}else{w=h;x=q}b[w>>0]=x;v=w+1|0}w=f[a+40>>2]|0;if(!w)y=v;else{x=f[a+48>>2]|0;q=0;h=v;while(1){v=f[x+4+(q<<2)>>2]|0;b[h>>0]=48;n=h+1|0;if(v>>>0>127){s=v;t=n;while(1){b[t>>0]=s|128;u=s>>>7;g=t+1|0;if(s>>>0>16383){s=u;t=g}else{z=g;A=u;break}}}else{z=n;A=v}b[z>>0]=A;t=z+1|0;q=q+1|0;if((q|0)>=(w|0)){y=t;break}else h=t}}if(!(e&1))B=y;else{h=f[a+64>>2]|0;b[y>>0]=58;w=y+1|0;y=_i[f[(f[h>>2]|0)+60>>2]&2047](h)|0;if(y>>>0>127){q=y;z=w;while(1){b[z>>0]=q|128;A=q>>>7;x=z+1|0;if(q>>>0>16383){q=A;z=x}else{C=x;D=A;break}}}else{C=w;D=y}b[C>>0]=D;B=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,C+1|0)|0}if(!(e&2))E=B;else{C=f[a+68>>2]|0;b[B>>0]=66;h=B+1|0;B=_i[f[(f[C>>2]|0)+60>>2]&2047](C)|0;if(B>>>0>127){D=B;y=h;while(1){b[y>>0]=D|128;w=D>>>7;z=y+1|0;if(D>>>0>16383){D=w;y=z}else{F=z;G=w;break}}}else{F=h;G=B}b[F>>0]=G;E=hj[f[(f[C>>2]|0)+64>>2]&511](C,c,F+1|0)|0}if(!(e&8))H=E;else{F=f[a+76>>2]|0;b[E>>0]=72;c=E+1|0;if(F>>>0>127){E=F;C=c;while(1){b[C>>0]=E|128;G=E>>>7;B=C+1|0;if(E>>>0>16383){E=G;C=B}else{I=B;K=G;break}}}else{I=c;K=F}b[I>>0]=K;H=I+1|0}if(!(e&16))L=H;else{I=f[a+80>>2]|0;b[H>>0]=80;K=H+1|0;if(I>>>0>127){H=I;F=K;while(1){b[F>>0]=H|128;c=H>>>7;C=F+1|0;if(H>>>0>16383){H=c;F=C}else{M=C;N=c;break}}}else{M=K;N=I}b[M>>0]=N;L=M+1|0}if(!(e&32))O=L;else{M=f[a+84>>2]|0;b[L>>0]=88;N=L+1|0;if(M>>>0>127){L=M;I=N;while(1){b[I>>0]=L|128;K=L>>>7;F=I+1|0;if(L>>>0>16383){L=K;I=F}else{P=F;Q=K;break}}}else{P=N;Q=M}b[P>>0]=Q;O=P+1|0}if(!(e&64))R=O;else{P=f[a+88>>2]|0;b[O>>0]=96;Q=O+1|0;if(P>>>0>127){O=P;M=Q;while(1){b[M>>0]=O|128;N=O>>>7;I=M+1|0;if(O>>>0>16383){O=N;M=I}else{S=I;T=N;break}}}else{S=Q;T=P}b[S>>0]=T;R=S+1|0}if(!(e&128))U=R;else{S=f[a+92>>2]|0;b[R>>0]=104;T=R+1|0;if(S>>>0>127){R=S;P=T;while(1){b[P>>0]=R|128;Q=R>>>7;M=P+1|0;if(R>>>0>16383){R=Q;P=M}else{V=M;W=Q;break}}}else{V=T;W=S}b[V>>0]=W;U=V+1|0}if(!(e&256))X=U;else{V=f[a+96>>2]|0;b[U>>0]=112;W=U+1|0;if(V>>>0>127){U=V;S=W;while(1){b[S>>0]=U|128;T=U>>>7;P=S+1|0;if(U>>>0>16383){U=T;S=P}else{Y=P;Z=T;break}}}else{Y=W;Z=V}b[Y>>0]=Z;X=Y+1|0}if(!(e&512))_=X;else{Y=f[a+100>>2]|0;b[X>>0]=120;Z=X+1|0;X=Y&255;if(Y>>>0>127){V=Z;W=X;S=Y;U=((Y|0)<0)<<31>>31;while(1){b[V>>0]=W|-128;Y=S;S=l1c(S|0,U|0,7)|0;T=V+1|0;P=S&255;if(!(U>>>0>0|(U|0)==0&Y>>>0>16383)){$=T;aa=P;break}else{V=T;W=P;U=J}}}else{$=Z;aa=X}b[$>>0]=aa;_=$+1|0}if(!(e&2048))ba=_;else{$=f[a+108>>2]|0;b[_>>0]=-128;b[_+1>>0]=1;aa=_+2|0;_=$&255;if($>>>0>127){X=aa;Z=_;U=$;W=(($|0)<0)<<31>>31;while(1){b[X>>0]=Z|-128;$=U;U=l1c(U|0,W|0,7)|0;V=X+1|0;S=U&255;if(!(W>>>0>0|(W|0)==0&$>>>0>16383)){ca=V;da=S;break}else{X=V;Z=S;W=J}}}else{ca=aa;da=_}b[ca>>0]=da;ba=ca+1|0}if(!(e&1024))ea=ba;else{e=b[a+104>>0]|0;b[ba>>0]=-120;b[ba+1>>0]=1;b[ba+2>>0]=e;ea=ba+3|0}ba=f[a+52>>2]|0;if(!ba)fa=ea;else{e=f[a+60>>2]|0;ca=0;da=ea;while(1){ea=f[e+4+(ca<<2)>>2]|0;b[da>>0]=-112;b[da+1>>0]=1;_=da+2|0;if(ea>>>0>127){aa=ea;W=_;while(1){b[W>>0]=aa|128;Z=aa>>>7;X=W+1|0;if(aa>>>0>16383){aa=Z;W=X}else{ga=X;ha=Z;break}}}else{ga=_;ha=ea}b[ga>>0]=ha;W=ga+1|0;ca=ca+1|0;if((ca|0)>=(ba|0)){fa=W;break}else da=W}}da=f[a+4>>2]|0;if(!(da&1)){ia=fa;return ia|0}ia=Pqc(da&-2,fa)|0;return ia|0}function V9a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;O9a(a);c=kZc(b,21568,16272,0)|0;if(!c){Ooc(b,a);return}else{P0a(a,c);return}}function W9a(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16272,0)|0;if(!c){Ooc(b,a);return}else{P0a(a,c);return}}function X9a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535440;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Z9a(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function _9a(a){a=a|0;var b=0,c=0;f[a>>2]=95836;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function $9a(a){a=a|0;var b=0,c=0;f[a>>2]=95836;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function aab(a){a=a|0;a=$Xc(24)|0;N0a(a);return a|0}function bab(a,b){a=a|0;b=b|0;a=$Xc(24)|0;N0a(a);if(!b)return a|0;nab(b,a);return a|0}function cab(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function dab(a){a=a|0;return 1}function eab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[g>>2]=j;f[c>>2]=k+1;continue a}else p=j}else p=0;j=KYb(c,p)|0;k=J;f[g>>2]=j;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)continue a;else{q=0;m=23;break a}break}case 2:break;default:{o=l;break b}}if((l&255|0)==16){f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;r=a}else{s=a;m=16}}else{s=0;m=16}if((m|0)==16){m=0;a=KYb(c,s)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)r=a;else{q=0;m=23;break a}}f[h>>2]=r;continue a}else o=l}while(0);if(!o){q=1;m=23;break}a=f[i>>2]|0;if(!(a&1))t=lSa(i)|0;else t=a&-2;if(!(Lqc(c,o,t)|0)){q=0;m=23;break}}if((m|0)==23)return q|0;return 0}function fab(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)h=11;else h=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=h+g|0;e=a+12|0;f[e>>2]=d;return d|0}function gab(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)U_b(1,f[a+16>>2]|0,b);if(c&2|0)S_b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function hab(a){a=a|0;return f[a+12>>2]|0}function iab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{c=f[a+20>>2]|0;b[e>>0]=16;l=e+1|0;e=c&255;if(c>>>0>127){m=l;g=e;h=c;i=((c|0)<0)<<31>>31;while(1){b[m>>0]=g|-128;c=h;h=l1c(h|0,i|0,7)|0;d=m+1|0;j=h&255;if(!(i>>>0>0|(i|0)==0&c>>>0>16383)){o=d;p=j;break}else{m=d;g=j;i=J}}}else{o=l;p=e}b[o>>0]=p;n=o+1|0}o=f[a+4>>2]|0;if(!(o&1)){q=n;return q|0}q=Pqc(o&-2,n)|0;return q|0}function jab(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);kab(a,b);return}function kab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16288,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function lab(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function mab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535408;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function nab(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function oab(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=95944;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((a|0)!=532248?(f[223086]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=36;b[d+8>>0]=0;J_b(892344,d);a_b(d)}f[a+12>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;u=c;return}function pab(a,b){a=a|0;b=b|0;qab(b,a);return}function qab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}vSa(a+16|0,b+16|0);vSa(a+32|0,b+32|0);d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+48>>2]=f[b+48>>2];if(d&2|0)f[a+52>>2]=f[b+52>>2];if(d&4|0)f[a+56>>2]=f[b+56>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function rab(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=95944;c=a+44|0;d=f[c>>2]|0;if(d|0?(f[a+32>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)cYc(f[h>>2]|0);cYc(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+28|0;i=f[c>>2]|0;if(i|0?(f[a+16>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)cYc(f[g>>2]|0);cYc(g)}e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}j=a&-2;a=j;if((j|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(j);f[c>>2]=0;return}function sab(a){a=a|0;rab(a);cYc(a);return}function tab(a){a=a|0;a=$Xc(60)|0;oab(a);return a|0}function uab(a,b){a=a|0;b=b|0;a=$Xc(60)|0;oab(a);if(!b)return a|0;Gab(b,a);return a|0}function vab(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+8|0;if(f[c>>2]&7|0){d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function wab(a){a=a|0;return 1}function xab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=c+4|0;e=a+8|0;g=a+52|0;h=a+56|0;i=a+16|0;j=a+32|0;k=a+4|0;l=a+48|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[c>>2]=a+1;o=n;p=7}else{q=n;p=6}}else{q=0;p=6}if((p|0)==6){p=0;n=ZYb(c,q)|0;if((n+-1|0)>>>0<127){o=n;p=7}else r=n}c:do if((p|0)==7){p=0;switch(o>>>3&536870911|0){case 1:{if((o&255|0)==8)break b;else{r=o;break c}break}case 2:{if((o&255|0)!=16){r=o;break c}f[e>>2]=f[e>>2]|2;n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;s=m}else{t=m;p=23}}else{t=0;p=23}if((p|0)==23){p=0;m=KYb(c,t)|0;n=J;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)s=m;else{u=0;p=40;break a}}f[g>>2]=s;continue b;break}case 3:{if((o&255|0)!=24){r=o;break c}f[e>>2]=f[e>>2]|4;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){n=b[m>>0]|0;a=n&255;if(n<<24>>24>-1){f[c>>2]=m+1;v=a}else{w=a;p=29}}else{w=0;p=29}if((p|0)==29){p=0;a=KYb(c,w)|0;m=J;if((m|0)>-1|(m|0)==-1&a>>>0>4294967295)v=a;else{u=0;p=40;break a}}f[h>>2]=v;continue b;break}case 4:{if((o&255|0)!=34){r=o;break c}if(l$b(c,pHa(i)|0)|0)continue b;else{u=0;p=40;break a}break}case 5:{if((o&255|0)!=42){r=o;break c}if(l$b(c,pHa(j)|0)|0)continue b;else{u=0;p=40;break a}break}default:{r=o;break c}}}while(0);if(!r){u=1;p=40;break a}a=f[k>>2]|0;if(!(a&1))x=lSa(k)|0;else x=a&-2;if(!(Lqc(c,r,x)|0)){u=0;p=40;break a}}a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>-1){f[c>>2]=a+1;y=n}else{z=n;p=12}}else{z=0;p=12}if((p|0)==12){p=0;n=KYb(c,z)|0;a=J;if((a|0)>-1|(a|0)==-1&n>>>0>4294967295)y=n;else{u=0;p=40;break}}if(y>>>0<2){f[e>>2]=f[e>>2]|1;f[l>>2]=y;continue}n=f[k>>2]|0;if(!(n&1))A=lSa(k)|0;else A=n&-2;yqc(A,1,y,((y|0)<0)<<31>>31)}if((p|0)==40)return u|0;return 0}function yab(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+20>>2]|0;e=c+d|0;if((c|0)>0){d=f[a+28>>2]|0;g=0;h=e;while(1){i=f[d+4+(g<<2)>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;j=k+h+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=g+1|0;if((g|0)==(c|0)){l=j;break}else h=j}}else l=e;e=f[a+36>>2]|0;h=e+l|0;if((e|0)>0){l=f[a+44>>2]|0;c=0;g=h;while(1){d=f[l+4+(c<<2)>>2]|0;j=b[d+11>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+g+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0;c=c+1|0;if((c|0)==(e|0)){m=j;break}else g=j}}else m=h;h=f[a+8>>2]|0;if(!(h&7)){n=m;o=a+12|0;f[o>>2]=n;return n|0}if(!(h&1))p=m;else{g=f[a+48>>2]|0;if((g|0)<0)q=11;else q=((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;p=q+m|0}if(!(h&2))r=p;else{m=f[a+52>>2]|0;if((m|0)<0)s=11;else s=((((($(m|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;r=s+p|0}if(!(h&4)){n=r;o=a+12|0;f[o>>2]=n;return n|0}h=f[a+56>>2]|0;if((h|0)<0)t=11;else t=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;n=t+r|0;o=a+12|0;f[o>>2]=n;return n|0}function zab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;if(c&1|0)d$b(1,f[a+48>>2]|0,b);if(c&2|0)S_b(2,f[a+52>>2]|0,b);if(c&4|0)S_b(3,f[a+56>>2]|0,b);c=f[a+20>>2]|0;if((c|0)>0){d=a+28|0;e=0;do{e$b(4,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+36>>2]|0;if((c|0)>0){e=a+44|0;d=0;do{e$b(5,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Aab(a){a=a|0;return f[a+12>>2]|0}function Bab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+48>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{o=f[a+52>>2]|0;b[e>>0]=16;p=e+1|0;e=o&255;if(o>>>0>127){d=p;h=e;l=o;j=((o|0)<0)<<31>>31;while(1){b[d>>0]=h|-128;o=l;l=l1c(l|0,j|0,7)|0;i=d+1|0;k=l&255;if(!(j>>>0>0|(j|0)==0&o>>>0>16383)){r=i;s=k;break}else{d=i;h=k;j=J}}}else{r=p;s=e}b[r>>0]=s;q=r+1|0}if(!(c&4))t=q;else{c=f[a+56>>2]|0;b[q>>0]=24;r=q+1|0;q=c&255;if(c>>>0>127){s=r;e=q;p=c;j=((c|0)<0)<<31>>31;while(1){b[s>>0]=e|-128;c=p;p=l1c(p|0,j|0,7)|0;h=s+1|0;d=p&255;if(!(j>>>0>0|(j|0)==0&c>>>0>16383)){u=h;v=d;break}else{s=h;e=d;j=J}}}else{u=r;v=q}b[u>>0]=v;t=u+1|0}u=f[a+20>>2]|0;if((u|0)>0){v=a+28|0;q=0;r=t;while(1){j=f[(f[v>>2]|0)+4+(q<<2)>>2]|0;b[r>>0]=34;e=gZb(j,r+1|0)|0;q=q+1|0;if((q|0)==(u|0)){w=e;break}else r=e}}else w=t;t=f[a+36>>2]|0;if((t|0)>0){r=a+44|0;u=0;q=w;while(1){v=f[(f[r>>2]|0)+4+(u<<2)>>2]|0;b[q>>0]=42;e=gZb(v,q+1|0)|0;u=u+1|0;if((u|0)==(t|0)){x=e;break}else q=e}}else x=w;w=f[a+4>>2]|0;if(!(w&1)){y=x;return y|0}y=Pqc(w&-2,x)|0;return y|0}function Cab(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;vab(a);c=kZc(b,21568,16304,0)|0;if(!c){Ooc(b,a);return}else{qab(a,c);return}}function Dab(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16304,0)|0;if(!c){Ooc(b,a);return}else{qab(a,c);return}}function Eab(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Fab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535352;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Gab(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Hab(a){a=a|0;return a>>>0<2|0}function Iab(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=92704;g1c(a+4|0,0,156)|0;if((a|0)!=534472?(f[223137]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=87;b[d+8>>0]=0;J_b(892548,d);a_b(d)}f[a+160>>2]=537368;g1c(a+164|0,0,132)|0;u=c;return}function Jab(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Kab(a){a=a|0;var c=0;c=f[a+160>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}if((a|0)==534472)return;c=f[a+164>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+168>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+172>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+176>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+180>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+184>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+188>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+192>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+196>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+200>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+204>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+208>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+212>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+216>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+220>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+224>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+228>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+232>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+236>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+240>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+244>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+248>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+252>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+256>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+260>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+264>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+268>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+272>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+276>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+280>>2]|0;if(c|0)Yi[f[(f[c>>2]|0)+4>>2]&4095](c);c=f[a+284>>2]|0;if(!c)return;Yi[f[(f[c>>2]|0)+4>>2]&4095](c);return}function Lab(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;cYc(b);return}function Mab(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;cYc(g);f[b>>2]=0;return}function Nab(a){a=a|0;var b=0,c=0;f[a>>2]=96052;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Oab(a){a=a|0;var b=0,c=0;f[a>>2]=96052;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Pab(a){a=a|0;a=$Xc(28)|0;abb(a);return a|0}function Qab(a,b){a=a|0;b=b|0;a=$Xc(28)|0;abb(a);if(!b)return a|0;bbb(b,a);return a|0}function Rab(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Sab(a){a=a|0;return 1}function Tab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+4|0;i=a+24|0;j=a+20|0;a:while(1){b:while(1){c:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=8}else{o=l;n=7}}else{o=0;n=7}if((n|0)==7){n=0;l=ZYb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=8}else p=l}d:do if((n|0)==8){n=0;switch(m>>>3&536870911|0){case 1:{if((m&255|0)!=8){p=m;break d}f[e>>2]=f[e>>2]|1;l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){a=b[l>>0]|0;k=a&255;if(a<<24>>24>-1){f[g>>2]=k;f[c>>2]=l+1;continue c}else q=k}else q=0;k=KYb(c,q)|0;l=J;f[g>>2]=k;if((l|0)>-1|(l|0)==-1&k>>>0>4294967295)continue c;else{r=0;n=41;break a}break}case 2:{if((m&255|0)==16)break b;else{p=m;break d}break}case 6:{if((m&255|0)==48)break c;else{p=m;break d}break}default:{p=m;break d}}}while(0);if(!p){r=1;n=41;break a}k=f[h>>2]|0;if(!(k&1))s=lSa(h)|0;else s=k&-2;if(!(Lqc(c,p,s)|0)){r=0;n=41;break a}}k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){l=b[k>>0]|0;a=l&255;if(l<<24>>24>-1){f[c>>2]=k+1;t=a}else{u=a;n=29}}else{u=0;n=29}if((n|0)==29){n=0;a=KYb(c,u)|0;k=J;if((k|0)>-1|(k|0)==-1&a>>>0>4294967295)t=a;else{r=0;n=41;break a}}if(t>>>0<3){f[e>>2]=f[e>>2]|4;f[i>>2]=t;continue}a=f[h>>2]|0;if(!(a&1))v=lSa(h)|0;else v=a&-2;yqc(v,6,t,((t|0)<0)<<31>>31)}a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>-1){f[c>>2]=a+1;w=l}else{x=l;n=18}}else{x=0;n=18}if((n|0)==18){n=0;l=KYb(c,x)|0;a=J;if((a|0)>-1|(a|0)==-1&l>>>0>4294967295)w=l;else{r=0;n=41;break}}if(w>>>0<3){f[e>>2]=f[e>>2]|2;f[j>>2]=w;continue}l=f[h>>2]|0;if(!(l&1))y=lSa(h)|0;else y=l&-2;yqc(y,2,w,((w|0)<0)<<31>>31)}if((n|0)==41)return r|0;return 0}function Uab(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else g=c+1+((((($(f[a+16>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(b&2))h=g;else{c=f[a+20>>2]|0;if((c|0)<0)i=11;else i=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;h=i+g|0}if(!(b&4)){d=h;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+24>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+h|0;e=a+12|0;f[e>>2]=d;return d|0}function Vab(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)U_b(1,f[a+16>>2]|0,b);if(c&2|0)d$b(2,f[a+20>>2]|0,b);if(c&4|0)d$b(6,f[a+24>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Wab(a){a=a|0;return f[a+12>>2]|0}function Xab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}if(!(c&2))n=e;else{l=f[a+20>>2]|0;b[e>>0]=16;m=e+1|0;e=l&255;if(l>>>0>127){g=m;h=e;i=l;d=((l|0)<0)<<31>>31;while(1){b[g>>0]=h|-128;l=i;i=l1c(i|0,d|0,7)|0;j=g+1|0;k=i&255;if(!(d>>>0>0|(d|0)==0&l>>>0>16383)){o=j;p=k;break}else{g=j;h=k;d=J}}}else{o=m;p=e}b[o>>0]=p;n=o+1|0}if(!(c&4))q=n;else{c=f[a+24>>2]|0;b[n>>0]=48;o=n+1|0;n=c&255;if(c>>>0>127){p=o;e=n;m=c;d=((c|0)<0)<<31>>31;while(1){b[p>>0]=e|-128;c=m;m=l1c(m|0,d|0,7)|0;h=p+1|0;g=m&255;if(!(d>>>0>0|(d|0)==0&c>>>0>16383)){r=h;s=g;break}else{p=h;e=g;d=J}}}else{r=o;s=n}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function Yab(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Zab(a,b);return}function Zab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16320,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function _ab(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function $ab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535752;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function abb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96052;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534440?(f[223136]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=86;b[d+8>>0]=0;J_b(892544,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function bbb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function cbb(a){a=a|0;var b=0,c=0;f[a>>2]=96160;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function dbb(a){a=a|0;var b=0,c=0;f[a>>2]=96160;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function ebb(a){a=a|0;a=$Xc(24)|0;rbb(a);return a|0}function fbb(a,b){a=a|0;b=b|0;a=$Xc(24)|0;rbb(a);if(!b)return a|0;sbb(b,a);return a|0}function gbb(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function hbb(a){a=a|0;return 1}function ibb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+20|0;h=a+16|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|2;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=KYb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|1;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=KYb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=lSa(i)|0;else u=a&-2;if(!(Lqc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function jbb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function kbb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)S_b(1,f[a+20>>2]|0,b);if(c&1|0)S_b(2,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function lbb(a){a=a|0;return f[a+12>>2]|0}function mbb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&1))q=e;else{c=f[a+16>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=l1c(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function nbb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);obb(a,b);return}function obb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16336,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function pbb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function qbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535728;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function rbb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96160;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534328?(f[223133]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=83;b[d+8>>0]=0;J_b(892532,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;u=c;return}function sbb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function tbb(a){a=a|0;var b=0,c=0;f[a>>2]=96268;if((a|0)!=534176){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function ubb(a){a=a|0;var b=0,c=0;f[a>>2]=96268;if((a|0)!=534176){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function vbb(a){a=a|0;a=$Xc(36)|0;Jbb(a);return a|0}function wbb(a,b){a=a|0;b=b|0;a=$Xc(36)|0;Jbb(a);if(!b)return a|0;Kbb(b,a);return a|0}function xbb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}if(d&2|0){e=f[a+20>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}}if(d&28|0){b[a+24>>0]=0;f[a+28>>2]=1;f[a+32>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function ybb(a){a=a|0;return 1}function zbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+28|0;j=a+32|0;k=a+16|0;l=e+4|0;m=a+24|0;n=e+8|0;o=a+20|0;p=e+4|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=ZYb(c,w)|0;if((s+-1|0)>>>0<127){t=s;v=6}else x=s}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{if((t&255|0)!=8){x=t;break b}f[h>>2]=f[h>>2]|8;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){a=b[s>>0]|0;r=a&255;if(a<<24>>24>-1){f[c>>2]=s+1;y=r}else{z=r;v=11}}else{z=0;v=11}if((v|0)==11){v=0;r=KYb(c,z)|0;s=J;if((s|0)>-1|(s|0)==-1&r>>>0>4294967295)y=r;else{A=0;v=52;break a}}f[i>>2]=y;continue a;break}case 2:{if((t&255|0)!=16){x=t;break b}f[h>>2]=f[h>>2]|16;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;a=s&255;if(s<<24>>24>-1){f[c>>2]=r+1;B=a}else{C=a;v=17}}else{C=0;v=17}if((v|0)==17){v=0;a=KYb(c,C)|0;r=J;if((r|0)>-1|(r|0)==-1&a>>>0>4294967295)B=a;else{A=0;v=52;break a}}f[j>>2]=B;continue a;break}case 3:{if((t&255|0)!=26){x=t;break b}f[h>>2]=f[h>>2]|1;a=f[k>>2]|0;if(!a){r=$Xc(48)|0;__a(r);f[k>>2]=r;D=r}else D=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;E=r&255}else{r=YYb(c)|0;if((r|0)>-1)E=r;else{A=0;v=52;break a}}JYb(e,c,E);if((f[l>>2]|0)<0){v=28;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){v=28;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{A=0;v=52;break a}break}case 4:{if((t&255|0)!=32){x=t;break b}f[h>>2]=f[h>>2]|4;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;F=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[n>>0]|0)){A=0;v=52;break a}else F=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[m>>0]=F&1;continue a;break}case 5:{if((t&255|0)!=42){x=t;break b}f[h>>2]=f[h>>2]|2;a=f[o>>2]|0;if(!a){r=$Xc(48)|0;__a(r);f[o>>2]=r;G=r}else G=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;H=r&255}else{r=YYb(c)|0;if((r|0)>-1)H=r;else{A=0;v=52;break a}}JYb(e,c,H);if((f[p>>2]|0)<0){v=45;break a}if(!(Mi[f[(f[G>>2]|0)+44>>2]&1023](G,c)|0)){v=45;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{A=0;v=52;break a}break}default:{x=t;break b}}}while(0);if(!x){A=1;v=52;break}r=f[q>>2]|0;if(!(r&1))I=lSa(q)|0;else I=r&-2;if(!(Lqc(c,x,I)|0)){A=0;v=52;break}}if((v|0)==28){A=0;u=d;return A|0}else if((v|0)==45){A=0;u=d;return A|0}else if((v|0)==52){u=d;return A|0}return 0}function Abb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&31)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}b=l&4|0?k+2|0:k;if(!(l&8))m=b;else{k=f[a+28>>2]|0;if((k|0)<0)n=11;else n=((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;m=n+b|0}if(!(l&16)){e=m;g=a+12|0;f[g>>2]=e;return e|0}l=f[a+32>>2]|0;if((l|0)<0)o=11;else o=((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=o+m|0;g=a+12|0;f[g>>2]=e;return e|0}function Bbb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&8|0)S_b(1,f[a+28>>2]|0,c);if(d&16|0)S_b(2,f[a+32>>2]|0,c);if(d&1|0)k$b(3,f[a+16>>2]|0,c);if(d&4|0)c$b(4,(b[a+24>>0]|0)!=0,c);if(d&2|0)k$b(5,f[a+20>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function Cbb(a){a=a|0;return f[a+12>>2]|0}function Dbb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=f[a+8>>2]|0;if(!(e&8))g=d;else{h=f[a+28>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&16))r=g;else{p=f[a+32>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=l1c(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&1))u=r;else{s=f[a+16>>2]|0;b[r>>0]=26;t=r+1|0;r=_i[f[(f[s>>2]|0)+60>>2]&2047](s)|0;if(r>>>0>127){g=r;q=t;while(1){b[q>>0]=g|128;k=g>>>7;i=q+1|0;if(g>>>0>16383){g=k;q=i}else{v=i;w=k;break}}}else{v=t;w=r}b[v>>0]=w;u=hj[f[(f[s>>2]|0)+64>>2]&511](s,c,v+1|0)|0}if(!(e&4))x=u;else{v=b[a+24>>0]|0;b[u>>0]=32;b[u+1>>0]=v;x=u+2|0}if(!(e&2))y=x;else{e=f[a+20>>2]|0;b[x>>0]=42;u=x+1|0;x=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(x>>>0>127){v=x;s=u;while(1){b[s>>0]=v|128;w=v>>>7;r=s+1|0;if(v>>>0>16383){v=w;s=r}else{z=r;A=w;break}}}else{z=u;A=x}b[z>>0]=A;y=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,z+1|0)|0}z=f[a+4>>2]|0;if(!(z&1)){B=y;return B|0}B=Pqc(z&-2,y)|0;return B|0}function Ebb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;xbb(a);c=kZc(b,21568,16352,0)|0;if(!c){Ooc(b,a);return}else{Ibb(a,c);return}}function Fbb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16352,0)|0;if(!c){Ooc(b,a);return}else{Ibb(a,c);return}}function Gbb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Hbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535688;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Ibb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&31))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;$_a(i,g|0?g:531776)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=$Xc(48)|0;__a(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;$_a(j,i|0?i:531776)}if(e&4|0)b[a+24>>0]=b[c+24>>0]|0;if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)f[a+32>>2]=f[c+32>>2];c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Jbb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96268;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534176?(f[223128]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=78;b[d+8>>0]=0;J_b(892512,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[d+12>>0]=0;f[a+28>>2]=1;f[a+32>>2]=1;u=c;return}function Kbb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Lbb(a){a=a|0;var b=0,c=0;f[a>>2]=96376;if((a|0)!=534144?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Mbb(a){a=a|0;var b=0,c=0;f[a>>2]=96376;if((a|0)!=534144?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Nbb(a){a=a|0;a=$Xc(28)|0;$bb(a);return a|0}function Obb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;$bb(a);if(!b)return a|0;acb(b,a);return a|0}function Pbb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+8|0;c=f[b>>2]|0;if((c&1|0?(d=f[a+16>>2]|0,f[d+16>>2]=0,f[d+8>>2]=0,e=f[d+4>>2]|0,e&1|0):0)?(d=e&-2,f[d>>2]|0):0)sqc(d);if(c&6|0){f[a+20>>2]=0;f[a+24>>2]=-1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Qbb(a){a=a|0;return 1}function Rbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+20|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[h>>2]=f[h>>2]|1;o=f[i>>2]|0;if(!o){a=$Xc(32)|0;p0a(a);f[i>>2]=a;t=a}else t=o;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0?(a=b[o>>0]|0,a<<24>>24>-1):0){f[c>>2]=o+1;v=a&255}else{a=YYb(c)|0;if((a|0)>-1)v=a;else{w=0;q=35;break a}}JYb(e,c,v);if((f[j>>2]|0)<0){q=16;break a}if(!(Mi[f[(f[t>>2]|0)+44>>2]&1023](t,c)|0)){q=16;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{w=0;q=35;break a}break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|2;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;n=o&255;if(o<<24>>24>-1){f[c>>2]=a+1;x=n}else{y=n;q=22}}else{y=0;q=22}if((q|0)==22){q=0;n=KYb(c,y)|0;a=J;if((a|0)>-1|(a|0)==-1&n>>>0>4294967295)x=n;else{w=0;q=35;break a}}f[k>>2]=x;continue a;break}case 3:{if((p&255|0)!=24){s=p;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){a=b[n>>0]|0;o=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;z=o}else{A=o;q=28}}else{A=0;q=28}if((q|0)==28){q=0;o=KYb(c,A)|0;n=J;if((n|0)>-1|(n|0)==-1&o>>>0>4294967295)z=o;else{w=0;q=35;break a}}f[l>>2]=z;continue a;break}default:{s=p;break b}}}while(0);if(!s){w=1;q=35;break}o=f[m>>2]|0;if(!(o&1))B=lSa(m)|0;else B=o&-2;if(!(Lqc(c,s,B)|0)){w=0;q=35;break}}if((q|0)==16){w=0;u=d;return w|0}else if((q|0)==35){u=d;return w|0}return 0}function Sbb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&7)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2))k=h;else{b=f[a+20>>2]|0;if((b|0)<0)l=11;else l=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=l+h|0}if(!(i&4)){e=k;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+24>>2]|0;if((i|0)<0)m=11;else m=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=m+k|0;g=a+12|0;f[g>>2]=e;return e|0}function Tbb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)k$b(1,f[a+16>>2]|0,b);if(c&2|0)S_b(2,f[a+20>>2]|0,b);if(c&4|0)S_b(3,f[a+24>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Ubb(a){a=a|0;return f[a+12>>2]|0}function Vbb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[a+8>>2]|0;if(!(e&1))g=d;else{h=f[a+16>>2]|0;b[d>>0]=10;i=d+1|0;d=_i[f[(f[h>>2]|0)+60>>2]&2047](h)|0;if(d>>>0>127){j=d;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=d}b[n>>0]=o;g=hj[f[(f[h>>2]|0)+64>>2]&511](h,c,n+1|0)|0}if(!(e&2))p=g;else{n=f[a+20>>2]|0;b[g>>0]=16;c=g+1|0;g=n&255;if(n>>>0>127){h=c;o=g;d=n;i=((n|0)<0)<<31>>31;while(1){b[h>>0]=o|-128;n=d;d=l1c(d|0,i|0,7)|0;k=h+1|0;j=d&255;if(!(i>>>0>0|(i|0)==0&n>>>0>16383)){q=k;r=j;break}else{h=k;o=j;i=J}}}else{q=c;r=g}b[q>>0]=r;p=q+1|0}if(!(e&4))s=p;else{e=f[a+24>>2]|0;b[p>>0]=24;q=p+1|0;p=e&255;if(e>>>0>127){r=q;g=p;c=e;i=((e|0)<0)<<31>>31;while(1){b[r>>0]=g|-128;e=c;c=l1c(c|0,i|0,7)|0;o=r+1|0;h=c&255;if(!(i>>>0>0|(i|0)==0&e>>>0>16383)){t=o;u=h;break}else{r=o;g=h;i=J}}}else{t=q;u=p}b[t>>0]=u;s=t+1|0}t=f[a+4>>2]|0;if(!(t&1)){v=s;return v|0}v=Pqc(t&-2,s)|0;return v|0}function Wbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))return;c=a+8|0;d=f[c>>2]|0;if((d&1|0?(e=f[a+16>>2]|0,f[e+16>>2]=0,f[e+8>>2]=0,g=f[e+4>>2]|0,g&1|0):0)?(e=g&-2,f[e>>2]|0):0)sqc(e);if(d&6|0){f[a+20>>2]=0;f[a+24>>2]=-1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,16368,0)|0;if(!d){Ooc(b,a);return}else{_bb(a,d);return}}function Xbb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16368,0)|0;if(!c){Ooc(b,a);return}else{_bb(a,c);return}}function Ybb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Zbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535680;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function _bb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){c=$Xc(32)|0;p0a(c);f[g>>2]=c;h=c}else h=e;e=f[b+16>>2]|0;c=e|0?e:531296;e=h+4|0;g=f[c+4>>2]|0;if(g&1|0){i=f[e>>2]|0;if(!(i&1))j=lSa(e)|0;else j=i&-2;vqc(j,g&-2)}g=h+16|0;j=c+16|0;i=f[j>>2]|0;if(i|0){_Ma(g,(f[g>>2]|0)+i|0);o1c((f[h+24>>2]|0)+8+(f[g>>2]<<3)|0,(f[c+24>>2]|0)+8|0,f[j>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[j>>2]|0)}}if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function $bb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96376;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534144?(f[223127]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=77;b[d+8>>0]=0;J_b(892508,d);a_b(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=-1;u=c;return}function acb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function bcb(a){a=a|0;var b=0,c=0;f[a>>2]=96484;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function ccb(a){a=a|0;var b=0,c=0;f[a>>2]=96484;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function dcb(a){a=a|0;a=$Xc(28)|0;qcb(a);return a|0}function ecb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;qcb(a);if(!b)return a|0;rcb(b,a);return a|0}function fcb(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+16>>2]=0;f[a+20>>2]=1;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function gcb(a){a=a|0;return 1}function hcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+24|0;l=a+4|0;m=a+20|0;a:while(1){b:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=7}else{r=o;q=6}}else{r=0;q=6}if((q|0)==6){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=7}else s=o}c:do if((q|0)==7){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)==8)break b;else{s=p;break c}break}case 2:{if((p&255|0)!=16){s=p;break c}f[i>>2]=f[i>>2]|1;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;t=n}else{v=n;q=23}}else{v=0;q=23}if((q|0)==23){q=0;n=KYb(c,v)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)t=n;else{w=0;q=37;break a}}f[j>>2]=t;continue b;break}case 3:{if((p&255|0)!=29){s=p;break c}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;x=a}else{if(!(WYb(c,e)|0)){q=31;break a}x=f[e>>2]|0}f[k>>2]=x;continue b;break}default:{s=p;break c}}}while(0);if(!s){w=1;q=37;break a}a=f[l>>2]|0;if(!(a&1))y=lSa(l)|0;else y=a&-2;if(!(Lqc(c,s,y)|0)){w=0;q=37;break a}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=a+1;z=o}else{A=o;q=12}}else{A=0;q=12}if((q|0)==12){q=0;o=KYb(c,A)|0;a=J;if((a|0)>-1|(a|0)==-1&o>>>0>4294967295)z=o;else{w=0;q=37;break}}if((z+-1|0)>>>0<4){f[i>>2]=f[i>>2]|2;f[m>>2]=z;continue}o=f[l>>2]|0;if(!(o&1))B=lSa(l)|0;else B=o&-2;yqc(B,1,z,((z|0)<0)<<31>>31)}if((q|0)==31){w=0;u=d;return w|0}else if((q|0)==37){u=d;return w|0}return 0}function icb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2))j=g;else{c=f[a+20>>2]|0;if((c|0)<0)k=11;else k=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;j=k+g|0}d=b&4|0?j+5|0:j;e=a+12|0;f[e>>2]=d;return d|0}function jcb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)d$b(1,f[a+20>>2]|0,b);if(c&1|0)S_b(2,f[a+16>>2]|0,b);if(c&4|0)a$b(3,+n[a+24>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function kcb(a){a=a|0;return f[a+12>>2]|0}function lcb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&1))q=e;else{o=f[a+16>>2]|0;b[e>>0]=16;p=e+1|0;e=o&255;if(o>>>0>127){d=p;h=e;l=o;j=((o|0)<0)<<31>>31;while(1){b[d>>0]=h|-128;o=l;l=l1c(l|0,j|0,7)|0;i=d+1|0;k=l&255;if(!(j>>>0>0|(j|0)==0&o>>>0>16383)){r=i;s=k;break}else{d=i;h=k;j=J}}}else{r=p;s=e}b[r>>0]=s;q=r+1|0}if(!(c&4))t=q;else{c=f[a+24>>2]|0;b[q>>0]=29;r=q+1|0;b[r>>0]=c;b[r+1>>0]=c>>8;b[r+2>>0]=c>>16;b[r+3>>0]=c>>24;t=q+5|0}q=f[a+4>>2]|0;if(!(q&1)){u=t;return u|0}u=Pqc(q&-2,t)|0;return u|0}function mcb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){f[a+16>>2]=0;f[a+20>>2]=1;n[a+24>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);ncb(a,b);return}function ncb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16384,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function ocb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function pcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535664;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function qcb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96484;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534088?(f[223125]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=75;b[d+8>>0]=0;J_b(892500,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;n[a+24>>2]=1.0;u=c;return}function rcb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function scb(a){a=a|0;var b=0,c=0;f[a>>2]=96592;if((a|0)!=534056){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function tcb(a){a=a|0;var b=0,c=0;f[a>>2]=96592;if((a|0)!=534056){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function ucb(a){a=a|0;a=$Xc(32)|0;Icb(a);return a|0}function vcb(a,b){a=a|0;b=b|0;a=$Xc(32)|0;Icb(a);if(!b)return a|0;Jcb(b,a);return a|0}function wcb(a){a=a|0;var b=0,c=0,e=0,g=0,h=0;b=a+8|0;c=f[b>>2]|0;if(c&3|0){if(c&1|0){e=f[a+16>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}if(c&2|0){e=f[a+20>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}}if(c&28|0){c=a+24|0;f[c>>2]=0;d[c+4>>1]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function xcb(a){a=a|0;return 1}function ycb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+24|0;j=a+16|0;k=e+4|0;l=a+20|0;m=e+4|0;n=a+28|0;o=e+8|0;p=a+29|0;q=e+8|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=ZYb(c,x)|0;if((t+-1|0)>>>0<127){v=t;w=6}else y=t}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{if((v&255|0)!=8){y=v;break b}f[h>>2]=f[h>>2]|4;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){a=b[t>>0]|0;s=a&255;if(a<<24>>24>-1){f[i>>2]=s;f[c>>2]=t+1;continue a}else z=s}else z=0;s=KYb(c,z)|0;t=J;f[i>>2]=s;if((t|0)>-1|(t|0)==-1&s>>>0>4294967295)continue a;else{A=0;w=51;break a}break}case 2:{if((v&255|0)!=18){y=v;break b}f[h>>2]=f[h>>2]|1;s=f[j>>2]|0;if(!s){t=$Xc(48)|0;__a(t);f[j>>2]=t;B=t}else B=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(t=b[s>>0]|0,t<<24>>24>-1):0){f[c>>2]=s+1;C=t&255}else{t=YYb(c)|0;if((t|0)>-1)C=t;else{A=0;w=51;break a}}JYb(e,c,C);if((f[k>>2]|0)<0){w=21;break a}if(!(Mi[f[(f[B>>2]|0)+44>>2]&1023](B,c)|0)){w=21;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{A=0;w=51;break a}break}case 3:{if((v&255|0)!=26){y=v;break b}f[h>>2]=f[h>>2]|2;t=f[l>>2]|0;if(!t){s=$Xc(48)|0;__a(s);f[l>>2]=s;D=s}else D=t;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(s=b[t>>0]|0,s<<24>>24>-1):0){f[c>>2]=t+1;E=s&255}else{s=YYb(c)|0;if((s|0)>-1)E=s;else{A=0;w=51;break a}}JYb(e,c,E);if((f[m>>2]|0)<0){w=32;break a}if(!(Mi[f[(f[D>>2]|0)+44>>2]&1023](D,c)|0)){w=32;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{A=0;w=51;break a}break}case 4:{if((v&255|0)!=32){y=v;break b}f[h>>2]=f[h>>2]|8;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(t=b[s>>0]|0,t<<24>>24>-1):0){f[c>>2]=s+1;F=t<<24>>24!=0}else{LYb(e,c);t=e;if(!(b[o>>0]|0)){A=0;w=51;break a}else F=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0}b[n>>0]=F&1;continue a;break}case 5:{if((v&255|0)!=40){y=v;break b}f[h>>2]=f[h>>2]|16;t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0?(s=b[t>>0]|0,s<<24>>24>-1):0){f[c>>2]=t+1;G=s<<24>>24!=0}else{LYb(e,c);s=e;if(!(b[q>>0]|0)){A=0;w=51;break a}else G=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0}b[p>>0]=G&1;continue a;break}default:{y=v;break b}}}while(0);if(!y){A=1;w=51;break}s=f[r>>2]|0;if(!(s&1))H=lSa(r)|0;else H=s&-2;if(!(Lqc(c,y,H)|0)){A=0;w=51;break}}if((w|0)==21){A=0;u=d;return A|0}else if((w|0)==32){A=0;u=d;return A|0}else if((w|0)==51){u=d;return A|0}return 0}function zcb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&31)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}if(!(l&4))m=k;else m=k+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=l&8|0?m+2|0:m;e=l&16|0?k+2|0:k;g=a+12|0;f[g>>2]=e;return e|0}function Acb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)U_b(1,f[a+24>>2]|0,c);if(d&1|0)k$b(2,f[a+16>>2]|0,c);if(d&2|0)k$b(3,f[a+20>>2]|0,c);if(d&8|0)c$b(4,(b[a+28>>0]|0)!=0,c);if(d&16|0)c$b(5,(b[a+29>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function Bcb(a){a=a|0;return f[a+12>>2]|0}function Ccb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&1))o=g;else{m=f[a+16>>2]|0;b[g>>0]=18;n=g+1|0;g=_i[f[(f[m>>2]|0)+60>>2]&2047](m)|0;if(g>>>0>127){h=g;i=n;while(1){b[i>>0]=h|128;j=h>>>7;d=i+1|0;if(h>>>0>16383){h=j;i=d}else{p=d;q=j;break}}}else{p=n;q=g}b[p>>0]=q;o=hj[f[(f[m>>2]|0)+64>>2]&511](m,c,p+1|0)|0}if(!(e&2))r=o;else{p=f[a+20>>2]|0;b[o>>0]=26;m=o+1|0;o=_i[f[(f[p>>2]|0)+60>>2]&2047](p)|0;if(o>>>0>127){q=o;g=m;while(1){b[g>>0]=q|128;n=q>>>7;i=g+1|0;if(q>>>0>16383){q=n;g=i}else{s=i;t=n;break}}}else{s=m;t=o}b[s>>0]=t;r=hj[f[(f[p>>2]|0)+64>>2]&511](p,c,s+1|0)|0}if(!(e&8))u=r;else{s=b[a+28>>0]|0;b[r>>0]=32;b[r+1>>0]=s;u=r+2|0}if(!(e&16))v=u;else{e=b[a+29>>0]|0;b[u>>0]=40;b[u+1>>0]=e;v=u+2|0}u=f[a+4>>2]|0;if(!(u&1)){w=v;return w|0}w=Pqc(u&-2,v)|0;return w|0}function Dcb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;wcb(a);c=kZc(b,21568,16400,0)|0;if(!c){Ooc(b,a);return}else{Hcb(a,c);return}}function Ecb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16400,0)|0;if(!c){Ooc(b,a);return}else{Hcb(a,c);return}}function Fcb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Gcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535656;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Hcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&31))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;$_a(i,g|0?g:531776)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=$Xc(48)|0;__a(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;$_a(j,i|0?i:531776)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)b[a+28>>0]=b[c+28>>0]|0;if(e&16|0)b[a+29>>0]=b[c+29>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Icb(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=96592;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534056?(f[223124]|0)!=2:0){f[e>>2]=165456;f[e+4>>2]=74;b[e+8>>0]=0;J_b(892496,e);a_b(e)}e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;d[e+16>>1]=0;u=c;return}function Jcb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Kcb(a){a=a|0;var b=0,c=0;f[a>>2]=96700;adb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Lcb(a){a=a|0;Kcb(a);cYc(a);return}function Mcb(a){a=a|0;a=$Xc(32)|0;_cb(a);return a|0}function Ncb(a,b){a=a|0;b=b|0;a=$Xc(32)|0;_cb(a);if(!b)return a|0;$cb(b,a);return a|0}function Ocb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&7|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&4|0){e=f[a+24>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);b[a+28>>0]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Pcb(a){a=a|0;return 1}function Qcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+24|0;l=a+28|0;m=e+8|0;n=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[c>>2]=a+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=ZYb(c,s)|0;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{if((q&255|0)!=10){t=q;break b}f[h>>2]=f[h>>2]|1;p=f[i>>2]|0;if((p|0)==537368){mHa(i,537368);v=f[i>>2]|0}else v=p;if(l$b(c,v)|0)continue a;else{w=0;r=30;break a}break}case 2:{if((q&255|0)!=18){t=q;break b}f[h>>2]=f[h>>2]|2;p=f[j>>2]|0;if((p|0)==537368){mHa(j,537368);x=f[j>>2]|0}else x=p;if(l$b(c,x)|0)continue a;else{w=0;r=30;break a}break}case 3:{if((q&255|0)!=26){t=q;break b}f[h>>2]=f[h>>2]|4;p=f[k>>2]|0;if((p|0)==537368){mHa(k,537368);y=f[k>>2]|0}else y=p;if(l$b(c,y)|0)continue a;else{w=0;r=30;break a}break}case 4:{if((q&255|0)!=32){t=q;break b}f[h>>2]=f[h>>2]|8;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(a=b[p>>0]|0,a<<24>>24>-1):0){f[c>>2]=p+1;z=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[m>>0]|0)){w=0;r=30;break a}else z=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[l>>0]=z&1;continue a;break}default:{t=q;break b}}}while(0);if(!t){w=1;r=30;break}a=f[n>>2]|0;if(!(a&1))A=lSa(n)|0;else A=a&-2;if(!(Lqc(c,t,A)|0)){w=0;r=30;break}}if((r|0)==30){u=d;return w|0}return 0}function Rcb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&15)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;d=b[k+11>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;l=h+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))m=l;else{j=f[a+24>>2]|0;h=b[j+11>>0]|0;d=h<<24>>24<0?f[j+4>>2]|0:h&255;m=l+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}e=c&8|0?m+2|0:m;g=a+12|0;f[g>>2]=e;return e|0}function Scb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)f$b(1,f[a+16>>2]|0,c);if(d&2|0)f$b(2,f[a+20>>2]|0,c);if(d&4|0)f$b(3,f[a+24>>2]|0,c);if(d&8|0)c$b(4,(b[a+28>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function Tcb(a){a=a|0;return f[a+12>>2]|0}function Ucb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=18;h=gZb(d,e+1|0)|0}if(!(c&4))i=h;else{e=f[a+24>>2]|0;b[h>>0]=26;i=gZb(e,h+1|0)|0}if(!(c&8))j=i;else{c=b[a+28>>0]|0;b[i>>0]=32;b[i+1>>0]=c;j=i+2|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Pqc(i&-2,j)|0;return k|0}function Vcb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;Ocb(a);c=kZc(b,21568,16416,0)|0;if(!c){Ooc(b,a);return}else{Zcb(a,c);return}}function Wcb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16416,0)|0;if(!c){Ooc(b,a);return}else{Zcb(a,c);return}}function Xcb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Ycb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535648;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Zcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&15))return;do if(e&1|0?(h=a+8|0,f[h>>2]=f[h>>2]|1,h=a+16|0,g=f[c+16>>2]|0,d=f[h>>2]|0,(d|0)!=(g|0)):0)if((d|0)==537368){mHa(h,g);break}else{oYc(d,g)|0;break}while(0);do if(e&2|0?(g=a+8|0,f[g>>2]=f[g>>2]|2,g=a+20|0,d=f[c+20>>2]|0,h=f[g>>2]|0,(h|0)!=(d|0)):0)if((h|0)==537368){mHa(g,d);break}else{oYc(h,d)|0;break}while(0);do if(e&4|0?(d=a+8|0,f[d>>2]=f[d>>2]|4,d=a+24|0,h=f[c+24>>2]|0,g=f[d>>2]|0,(g|0)!=(h|0)):0)if((g|0)==537368){mHa(d,h);break}else{oYc(g,h)|0;break}while(0);if(e&8|0)b[a+28>>0]=b[c+28>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function _cb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96700;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=534024?(f[223123]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=73;b[d+8>>0]=0;J_b(892492,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;b[a+28>>0]=0;u=c;return}function $cb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function adb(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function bdb(a){a=a|0;var b=0,c=0;f[a>>2]=96808;if((a|0)!=533896?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function cdb(a){a=a|0;var b=0,c=0;f[a>>2]=96808;if((a|0)!=533896?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function ddb(a){a=a|0;a=$Xc(20)|0;rdb(a);return a|0}function edb(a,b){a=a|0;b=b|0;a=$Xc(20)|0;rdb(a);if(!b)return a|0;sdb(b,a);return a|0}function fdb(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;if((f[b>>2]&1|0?(c=f[a+16>>2]|0,f[c+16>>2]=0,f[c+8>>2]=0,d=f[c+4>>2]|0,d&1|0):0)?(c=d&-2,f[c>>2]|0):0)sqc(c);f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function gdb(a){a=a|0;return 1}function hdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+16|0;j=e+4|0;k=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=ZYb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}if((o|0)==6){o=0;if((n|0)==10){f[h>>2]=f[h>>2]|1;m=f[i>>2]|0;if(!m){a=$Xc(32)|0;p0a(a);f[i>>2]=a;r=a}else r=m;m=f[c>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0?(a=b[m>>0]|0,a<<24>>24>-1):0){f[c>>2]=m+1;s=a&255}else{a=YYb(c)|0;if((a|0)>-1)s=a;else{t=0;o=22;break}}JYb(e,c,s);if((f[j>>2]|0)<0){o=15;break}if(!(Mi[f[(f[r>>2]|0)+44>>2]&1023](r,c)|0)){o=15;break}if(OYb(c,f[e>>2]|0)|0)continue;else{t=0;o=22;break}}else q=n}if(!q){t=1;o=22;break}a=f[k>>2]|0;if(!(a&1))v=lSa(k)|0;else v=a&-2;if(!(Lqc(c,q,v)|0)){t=0;o=22;break}}if((o|0)==15){t=0;u=d;return t|0}else if((o|0)==22){u=d;return t|0}return 0}function idb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;if(!(f[a+8>>2]&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+16>>2]|0;g=_i[f[(f[b>>2]|0)+48>>2]&2047](b)|0;d=c+1+g+((((($(g|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=a+12|0;f[e>>2]=d;return d|0}function jdb(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)k$b(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function kdb(a){a=a|0;return f[a+12>>2]|0}function ldb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!(f[a+8>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;h=d+1|0;d=_i[f[(f[g>>2]|0)+60>>2]&2047](g)|0;if(d>>>0>127){i=d;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=d}b[m>>0]=n;e=hj[f[(f[g>>2]|0)+64>>2]&511](g,c,m+1|0)|0}m=f[a+4>>2]|0;if(!(m&1)){o=e;return o|0}o=Pqc(m&-2,e)|0;return o|0}function mdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)==(b|0))return;c=a+8|0;if((f[c>>2]&1|0?(d=f[a+16>>2]|0,f[d+16>>2]=0,f[d+8>>2]=0,e=f[d+4>>2]|0,e&1|0):0)?(d=e&-2,f[d>>2]|0):0)sqc(d);f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,16432,0)|0;if(!d){Ooc(b,a);return}else{qdb(a,d);return}}function ndb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16432,0)|0;if(!c){Ooc(b,a);return}else{qdb(a,c);return}}function odb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function pdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535624;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function qdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[b+8>>2]&1))return;d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;a=f[d>>2]|0;if(!a){g=$Xc(32)|0;p0a(g);f[d>>2]=g;h=g}else h=a;a=f[b+16>>2]|0;b=a|0?a:531296;a=h+4|0;g=f[b+4>>2]|0;if(g&1|0){d=f[a>>2]|0;if(!(d&1))i=lSa(a)|0;else i=d&-2;vqc(i,g&-2)}g=h+16|0;i=b+16|0;d=f[i>>2]|0;if(!d)return;_Ma(g,(f[g>>2]|0)+d|0);o1c((f[h+24>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+24>>2]|0)+8|0,f[i>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[i>>2]|0);return}function rdb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96808;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533896?(f[223120]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=70;b[d+8>>0]=0;J_b(892480,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function sdb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function tdb(a){a=a|0;var b=0,c=0;f[a>>2]=96916;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function udb(a){a=a|0;var b=0,c=0;f[a>>2]=96916;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function vdb(a){a=a|0;a=$Xc(28)|0;Idb(a);return a|0}function wdb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;Idb(a);if(!b)return a|0;Jdb(b,a);return a|0}function xdb(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function ydb(a){a=a|0;return 1}function zdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+24|0;l=a+16|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(WYb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=21){s=p;break b}f[i>>2]=f[i>>2]|4;n=f[c>>2]|0;if(((f[g>>2]|0)-n|0)>3){o=n;a=h[o>>0]|h[o+1>>0]<<8|h[o+2>>0]<<16|h[o+3>>0]<<24;f[e>>2]=a;f[c>>2]=n+4;v=a}else{if(!(WYb(c,e)|0)){q=20;break a}v=f[e>>2]|0}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|1;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;w=o}else{if(!(WYb(c,e)|0)){q=27;break a}w=f[e>>2]|0}f[l>>2]=w;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=33;break}o=f[m>>2]|0;if(!(o&1))y=lSa(m)|0;else y=o&-2;if(!(Lqc(c,s,y)|0)){x=0;q=33;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==20){x=0;u=d;return x|0}else if((q|0)==27){x=0;u=d;return x|0}else if((q|0)==33){u=d;return x|0}return 0}function Adb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+5|0:c;c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function Bdb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)a$b(1,+n[a+20>>2],b);if(c&4|0)a$b(2,+n[a+24>>2],b);if(c&1|0)a$b(3,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Cdb(a){a=a|0;return f[a+12>>2]|0}function Ddb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&4))i=e;else{d=f[a+24>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;i=e+5|0}if(!(c&1))j=i;else{c=f[a+16>>2]|0;b[i>>0]=29;e=i+1|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;j=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Pqc(i&-2,j)|0;return k|0}function Edb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Fdb(a,b);return}function Fdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16448,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function Gdb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Hdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535592;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Idb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=96916;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533768?(f[223116]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=66;b[d+8>>0]=0;J_b(892464,d);a_b(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0;u=c;return}function Jdb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Kdb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=97024;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;cYc(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(h);f[b>>2]=0;return}function Ldb(a){a=a|0;Kdb(a);cYc(a);return}function Mdb(a){a=a|0;a=$Xc(32)|0;Zdb(a);return a|0}function Ndb(a,b){a=a|0;b=b|0;a=$Xc(32)|0;Zdb(a);if(!b)return a|0;_db(b,a);return a|0}function Odb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;f[g+16>>2]=0;f[g+8>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Pdb(a){a=a|0;return 1}function Qdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+16|0;i=e+4|0;j=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){k=b[a>>0]|0;l=k&255;if(k<<24>>24>0){f[c>>2]=a+1;m=l;n=6}else{o=l;n=5}}else{o=0;n=5}if((n|0)==5){n=0;l=ZYb(c,o)|0;if((l+-1|0)>>>0<127){m=l;n=6}else p=l}if((n|0)==6){n=0;if((m|0)==10){l=y5a(h)|0;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(k=b[a>>0]|0,k<<24>>24>-1):0){f[c>>2]=a+1;q=k&255}else{k=YYb(c)|0;if((k|0)>-1)q=k;else{r=0;n=20;break}}JYb(e,c,q);if((f[i>>2]|0)<0){n=13;break}if(!(Mi[f[(f[l>>2]|0)+44>>2]&1023](l,c)|0)){n=13;break}if(OYb(c,f[e>>2]|0)|0)continue;else{r=0;n=20;break}}else p=m}if(!p){r=1;n=20;break}l=f[j>>2]|0;if(!(l&1))s=lSa(j)|0;else s=l&-2;if(!(Lqc(c,p,s)|0)){r=0;n=20;break}}if((n|0)==13){r=0;u=d;return r|0}else if((n|0)==20){u=d;return r|0}return 0}function Rdb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+20>>2]|0;d=b+c|0;if(!b){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=a+28|0;h=0;i=d;while(1){d=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=j+i+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=h+1|0;if((h|0)==(b|0)){e=d;break}else i=d}g=a+12|0;f[g>>2]=e;return e|0}function Sdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{k$b(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Tdb(a){a=a|0;return f[a+12>>2]|0}function Udb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=f[a+20>>2]|0;if(!e)g=d;else{h=a+28|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=10;k=j+1|0;l=_i[f[(f[d>>2]|0)+60>>2]&2047](d)|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=hj[f[(f[d>>2]|0)+64>>2]&511](d,c,q+1|0)|0;i=i+1|0;if((i|0)==(e|0)){g=n;break}else j=n}}j=f[a+4>>2]|0;if(!(j&1)){s=g;return s|0}s=Pqc(j&-2,g)|0;return s|0}function Vdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;if((a|0)==(b|0))return;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;f[h+16>>2]=0;f[h+8>>2]=0;i=f[h+4>>2]|0;if(i&1|0?(h=i&-2,f[h>>2]|0):0)sqc(h)}while((g|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=a+4|0;d=f[c>>2]|0;if(d&1|0?(g=d&-2,f[g>>2]|0):0)sqc(g);g=kZc(b,21568,16464,0)|0;if(!g){Ooc(b,a);return}b=f[g+4>>2]|0;if(b&1|0){d=f[c>>2]|0;if(!(d&1))j=lSa(c)|0;else j=d&-2;vqc(j,b&-2)}e5a(a+16|0,g+16|0);return}function Wdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16464,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}e5a(a+16|0,c+16|0);return}function Xdb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Ydb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535584;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Zdb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=97024;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=533736?(f[223115]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=65;b[d+8>>0]=0;J_b(892460,d);a_b(d)}f[a+12>>2]=0;u=c;return}function _db(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function $db(a){a=a|0;var b=0,c=0;f[a>>2]=97132;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function aeb(a){a=a|0;var b=0,c=0;f[a>>2]=97132;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function beb(a){a=a|0;a=$Xc(24)|0;oeb(a);return a|0}function ceb(a,b){a=a|0;b=b|0;a=$Xc(24)|0;oeb(a);if(!b)return a|0;peb(b,a);return a|0}function deb(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=-1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function eeb(a){a=a|0;return 1}function feb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){j=b[a>>0]|0;k=j&255;if(j<<24>>24>0){f[c>>2]=a+1;l=k;m=6}else{n=k;m=5}}else{n=0;m=5}if((m|0)==5){m=0;k=ZYb(c,n)|0;if((k+-1|0)>>>0<127){l=k;m=6}else o=k}b:do if((m|0)==6){m=0;switch(l>>>3&536870911|0){case 1:{if((l&255|0)!=8){o=l;break b}f[e>>2]=f[e>>2]|1;k=f[c>>2]|0;if(k>>>0<(f[d>>2]|0)>>>0){a=b[k>>0]|0;j=a&255;if(a<<24>>24>-1){f[c>>2]=k+1;p=j}else{q=j;m=11}}else{q=0;m=11}if((m|0)==11){m=0;j=KYb(c,q)|0;k=J;if((k|0)>-1|(k|0)==-1&j>>>0>4294967295)p=j;else{r=0;m=24;break a}}f[g>>2]=p;continue a;break}case 2:{if((l&255|0)!=16){o=l;break b}f[e>>2]=f[e>>2]|2;j=f[c>>2]|0;if(j>>>0<(f[d>>2]|0)>>>0){k=b[j>>0]|0;a=k&255;if(k<<24>>24>-1){f[c>>2]=j+1;s=a}else{t=a;m=17}}else{t=0;m=17}if((m|0)==17){m=0;a=KYb(c,t)|0;j=J;if((j|0)>-1|(j|0)==-1&a>>>0>4294967295)s=a;else{r=0;m=24;break a}}f[h>>2]=s;continue a;break}default:{o=l;break b}}}while(0);if(!o){r=1;m=24;break}a=f[i>>2]|0;if(!(a&1))u=lSa(i)|0;else u=a&-2;if(!(Lqc(c,o,u)|0)){r=0;m=24;break}}if((m|0)==24)return r|0;return 0}function geb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&3)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}if(!(b&2)){d=g;e=a+12|0;f[e>>2]=d;return d|0}b=f[a+20>>2]|0;if((b|0)<0)j=11;else j=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;d=j+g|0;e=a+12|0;f[e>>2]=d;return d|0}function heb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)S_b(1,f[a+16>>2]|0,b);if(c&2|0)S_b(2,f[a+20>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function ieb(a){a=a|0;return f[a+12>>2]|0}function jeb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;d=g&255;if(g>>>0>127){i=h;j=d;k=g;l=((g|0)<0)<<31>>31;while(1){b[i>>0]=j|-128;g=k;k=l1c(k|0,l|0,7)|0;m=i+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&g>>>0>16383)){o=m;p=n;break}else{i=m;j=n;l=J}}}else{o=h;p=d}b[o>>0]=p;e=o+1|0}if(!(c&2))q=e;else{c=f[a+20>>2]|0;b[e>>0]=16;o=e+1|0;e=c&255;if(c>>>0>127){p=o;d=e;h=c;l=((c|0)<0)<<31>>31;while(1){b[p>>0]=d|-128;c=h;h=l1c(h|0,l|0,7)|0;j=p+1|0;i=h&255;if(!(l>>>0>0|(l|0)==0&c>>>0>16383)){r=j;s=i;break}else{p=j;d=i;l=J}}}else{r=o;s=e}b[r>>0]=s;q=r+1|0}r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=Pqc(r&-2,q)|0;return t|0}function keb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=-1}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);leb(a,b);return}function leb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16480,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&3))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function meb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function neb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535528;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function oeb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97132;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533504?(f[223108]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=58;b[d+8>>0]=0;J_b(892432,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=1;f[a+20>>2]=-1;u=c;return}function peb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function qeb(a){a=a|0;var b=0,c=0;f[a>>2]=97240;if((a|0)!=533432){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function reb(a){a=a|0;var b=0,c=0;f[a>>2]=97240;if((a|0)!=533432){b=f[a+16>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+20>>2]|0;if(b|0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b)}b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function seb(a){a=a|0;a=$Xc(36)|0;Geb(a);return a|0}function teb(a,b){a=a|0;b=b|0;a=$Xc(36)|0;Geb(a);if(!b)return a|0;Heb(b,a);return a|0}function ueb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0){e=f[a+16>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}if(d&2|0){e=f[a+20>>2]|0;g=e+8|0;h=f[g>>2]|0;if(h&1|0)oYc(f[e+16>>2]|0,535168)|0;if(h&254|0){h=e+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+36>>2]=-1;n[e+40>>2]=1.0;n[e+44>>2]=1.0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)sqc(e)}}if(d&28|0){d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;b[a+32>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function veb(a){a=a|0;return 1}function web(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+24|0;j=a+28|0;k=a+32|0;l=e+8|0;m=a+16|0;n=e+4|0;o=a+20|0;p=e+4|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=ZYb(c,w)|0;if((s+-1|0)>>>0<127){t=s;v=6}else x=s}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{if((t&255|0)!=8){x=t;break b}f[h>>2]=f[h>>2]|4;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){a=b[s>>0]|0;r=a&255;if(a<<24>>24>-1){f[i>>2]=r;f[c>>2]=s+1;continue a}else y=r}else y=0;r=KYb(c,y)|0;s=J;f[i>>2]=r;if((s|0)>-1|(s|0)==-1&r>>>0>4294967295)continue a;else{z=0;v=50;break a}break}case 2:{if((t&255|0)!=16){x=t;break b}f[h>>2]=f[h>>2]|8;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;a=s&255;if(s<<24>>24>-1){f[j>>2]=a;f[c>>2]=r+1;continue a}else A=a}else A=0;a=KYb(c,A)|0;r=J;f[j>>2]=a;if((r|0)>-1|(r|0)==-1&a>>>0>4294967295)continue a;else{z=0;v=50;break a}break}case 3:{if((t&255|0)!=24){x=t;break b}f[h>>2]=f[h>>2]|16;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;B=r<<24>>24!=0}else{LYb(e,c);r=e;if(!(b[l>>0]|0)){z=0;v=50;break a}else B=(f[r>>2]|0)!=0|(f[r+4>>2]|0)!=0}b[k>>0]=B&1;continue a;break}case 4:{if((t&255|0)!=34){x=t;break b}f[h>>2]=f[h>>2]|1;r=f[m>>2]|0;if(!r){a=$Xc(48)|0;__a(a);f[m>>2]=a;C=a}else C=r;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;D=a&255}else{a=YYb(c)|0;if((a|0)>-1)D=a;else{z=0;v=50;break a}}JYb(e,c,D);if((f[n>>2]|0)<0){v=32;break a}if(!(Mi[f[(f[C>>2]|0)+44>>2]&1023](C,c)|0)){v=32;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{z=0;v=50;break a}break}case 5:{if((t&255|0)!=42){x=t;break b}f[h>>2]=f[h>>2]|2;a=f[o>>2]|0;if(!a){r=$Xc(48)|0;__a(r);f[o>>2]=r;E=r}else E=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(r=b[a>>0]|0,r<<24>>24>-1):0){f[c>>2]=a+1;F=r&255}else{r=YYb(c)|0;if((r|0)>-1)F=r;else{z=0;v=50;break a}}JYb(e,c,F);if((f[p>>2]|0)<0){v=43;break a}if(!(Mi[f[(f[E>>2]|0)+44>>2]&1023](E,c)|0)){v=43;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{z=0;v=50;break a}break}default:{x=t;break b}}}while(0);if(!x){z=1;v=50;break}r=f[q>>2]|0;if(!(r&1))G=lSa(q)|0;else G=r&-2;if(!(Lqc(c,x,G)|0)){z=0;v=50;break}}if((v|0)==32){z=0;u=d;return z|0}else if((v|0)==43){z=0;u=d;return z|0}else if((v|0)==50){u=d;return z|0}return 0}function xeb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&31)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2)){k=h;l=i}else{i=f[a+20>>2]|0;d=_i[f[(f[i>>2]|0)+48>>2]&2047](i)|0;i=h+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0;k=i;l=f[b>>2]|0}if(!(l&4))m=k;else m=k+1+((((($(f[a+24>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;if(!(l&8))n=m;else n=m+1+((((($(f[a+28>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;e=l&16|0?n+2|0:n;g=a+12|0;f[g>>2]=e;return e|0}function yeb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&4|0)U_b(1,f[a+24>>2]|0,c);if(d&8|0)U_b(2,f[a+28>>2]|0,c);if(d&16|0)c$b(3,(b[a+32>>0]|0)!=0,c);if(d&1|0)k$b(4,f[a+16>>2]|0,c);if(d&2|0)k$b(5,f[a+20>>2]|0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function zeb(a){a=a|0;return f[a+12>>2]|0}function Aeb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[a+8>>2]|0;if(!(e&4))g=d;else{h=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(h>>>0>127){d=h;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=h}b[m>>0]=n;g=m+1|0}if(!(e&8))o=g;else{m=f[a+28>>2]|0;b[g>>0]=16;n=g+1|0;if(m>>>0>127){g=m;h=n;while(1){b[h>>0]=g|128;i=g>>>7;j=h+1|0;if(g>>>0>16383){g=i;h=j}else{p=j;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}if(!(e&16))r=o;else{p=b[a+32>>0]|0;b[o>>0]=24;b[o+1>>0]=p;r=o+2|0}if(!(e&1))s=r;else{o=f[a+16>>2]|0;b[r>>0]=34;p=r+1|0;r=_i[f[(f[o>>2]|0)+60>>2]&2047](o)|0;if(r>>>0>127){q=r;m=p;while(1){b[m>>0]=q|128;n=q>>>7;h=m+1|0;if(q>>>0>16383){q=n;m=h}else{t=h;u=n;break}}}else{t=p;u=r}b[t>>0]=u;s=hj[f[(f[o>>2]|0)+64>>2]&511](o,c,t+1|0)|0}if(!(e&2))v=s;else{e=f[a+20>>2]|0;b[s>>0]=42;t=s+1|0;s=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(s>>>0>127){o=s;u=t;while(1){b[u>>0]=o|128;r=o>>>7;p=u+1|0;if(o>>>0>16383){o=r;u=p}else{w=p;x=r;break}}}else{w=t;x=s}b[w>>0]=x;v=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,w+1|0)|0}w=f[a+4>>2]|0;if(!(w&1)){y=v;return y|0}y=Pqc(w&-2,v)|0;return y|0}function Beb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;ueb(a);c=kZc(b,21568,16496,0)|0;if(!c){Ooc(b,a);return}else{Feb(a,c);return}}function Ceb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16496,0)|0;if(!c){Ooc(b,a);return}else{Feb(a,c);return}}function Deb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Eeb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535512;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Feb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[c+4>>2]|0;if(e&1|0){g=f[d>>2]|0;if(!(g&1))h=lSa(d)|0;else h=g&-2;vqc(h,e&-2)}e=f[c+8>>2]|0;if(!(e&31))return;if(e&1|0){h=a+8|0;f[h>>2]=f[h>>2]|1;h=a+16|0;g=f[h>>2]|0;if(!g){d=$Xc(48)|0;__a(d);f[h>>2]=d;i=d}else i=g;g=f[c+16>>2]|0;$_a(i,g|0?g:531776)}if(e&2|0){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;i=f[g>>2]|0;if(!i){d=$Xc(48)|0;__a(d);f[g>>2]=d;j=d}else j=i;i=f[c+20>>2]|0;$_a(j,i|0?i:531776)}if(e&4|0)f[a+24>>2]=f[c+24>>2];if(e&8|0)f[a+28>>2]=f[c+28>>2];if(e&16|0)b[a+32>>0]=b[c+32>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|e;return}function Geb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97240;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533432?(f[223106]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=56;b[d+8>>0]=0;J_b(892424,d);a_b(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;b[a+32>>0]=1;u=c;return}function Heb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Ieb(a){a=a|0;var b=0,c=0;f[a>>2]=97348;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Jeb(a){a=a|0;var b=0,c=0;f[a>>2]=97348;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Keb(a){a=a|0;a=$Xc(20)|0;Xeb(a);return a|0}function Leb(a,b){a=a|0;b=b|0;a=$Xc(20)|0;Xeb(a);if(!b)return a|0;Yeb(b,a);return a|0}function Meb(a){a=a|0;var b=0;n[a+16>>2]=1.0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Neb(a){a=a|0;return 1}function Oeb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=ZYb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}if((o|0)==6){o=0;if((n|0)==13){f[i>>2]=f[i>>2]|1;m=f[c>>2]|0;if(((f[g>>2]|0)-m|0)>3){a=m;l=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=l;f[c>>2]=m+4;r=l}else{if(!(WYb(c,e)|0)){o=12;break}r=f[e>>2]|0}f[j>>2]=r;continue}else q=n}if(!q){s=1;o=18;break}l=f[k>>2]|0;if(!(l&1))t=lSa(k)|0;else t=l&-2;if(!(Lqc(c,q,t)|0)){s=0;o=18;break}}if((o|0)==12){s=0;u=d;return s|0}else if((o|0)==18){u=d;return s|0}return 0}function Peb(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]&1|0?c+5|0:c;f[a+12>>2]=b;return b|0}function Qeb(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)a$b(1,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Reb(a){a=a|0;return f[a+12>>2]|0}function Seb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=13;g=d+1|0;b[g>>0]=c;b[g+1>>0]=c>>8;b[g+2>>0]=c>>16;b[g+3>>0]=c>>24;e=d+5|0}d=f[a+4>>2]|0;if(!(d&1)){h=e;return h|0}h=Pqc(d&-2,e)|0;return h|0}function Teb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((a|0)==(b|0))return;c=a+16|0;n[c>>2]=1.0;d=a+8|0;f[d>>2]=0;e=a+4|0;g=f[e>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h);h=kZc(b,21568,16512,0)|0;if(!h){Ooc(b,a);return}a=f[h+4>>2]|0;if(a&1|0){b=f[e>>2]|0;if(!(b&1))i=lSa(e)|0;else i=b&-2;vqc(i,a&-2)}if(!(f[h+8>>2]&1))return;a=f[h+16>>2]|0;f[d>>2]=f[d>>2]|1;f[c>>2]=a;return}function Ueb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16512,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}if(!(f[c+8>>2]&1))return;d=f[c+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|1;f[a+16>>2]=d;return}function Veb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Web(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535504;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Xeb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97348;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533408?(f[223105]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=55;b[d+8>>0]=0;J_b(892420,d);a_b(d)}f[a+12>>2]=0;n[a+16>>2]=1.0;u=c;return}function Yeb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Zeb(a){a=a|0;var b=0,c=0;f[a>>2]=97456;pfb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function _eb(a){a=a|0;Zeb(a);cYc(a);return}function $eb(a){a=a|0;a=$Xc(40)|0;nfb(a);return a|0}function afb(a,b){a=a|0;b=b|0;a=$Xc(40)|0;nfb(a);if(!b)return a|0;ofb(b,a);return a|0}function bfb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&31|0){do if(d&1|0){e=f[a+16>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&2|0){g=f[a+20>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(d&4|0){e=f[a+24>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(d&8|0){g=f[a+28>>2]|0;e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(d&16|0){e=f[a+32>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);f[a+36>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;sqc(a);return}function cfb(a){a=a|0;return 1}function dfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=c+4|0;e=a+8|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+28|0;k=a+32|0;l=a+36|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=10){s=p;break b}f[e>>2]=f[e>>2]|1;o=f[g>>2]|0;if((o|0)==537368){mHa(g,537368);t=f[g>>2]|0}else t=o;if(l$b(c,t)|0)continue a;else{u=0;q=37;break a}break}case 2:{if((p&255|0)!=18){s=p;break b}f[e>>2]=f[e>>2]|2;o=f[h>>2]|0;if((o|0)==537368){mHa(h,537368);v=f[h>>2]|0}else v=o;if(l$b(c,v)|0)continue a;else{u=0;q=37;break a}break}case 3:{if((p&255|0)!=26){s=p;break b}f[e>>2]=f[e>>2]|4;o=f[i>>2]|0;if((o|0)==537368){mHa(i,537368);w=f[i>>2]|0}else w=o;if(l$b(c,w)|0)continue a;else{u=0;q=37;break a}break}case 4:{if((p&255|0)!=34){s=p;break b}f[e>>2]=f[e>>2]|8;o=f[j>>2]|0;if((o|0)==537368){mHa(j,537368);x=f[j>>2]|0}else x=o;if(l$b(c,x)|0)continue a;else{u=0;q=37;break a}break}case 5:{if((p&255|0)!=42){s=p;break b}f[e>>2]=f[e>>2]|16;o=f[k>>2]|0;if((o|0)==537368){mHa(k,537368);y=f[k>>2]|0}else y=o;if(l$b(c,y)|0)continue a;else{u=0;q=37;break a}break}case 6:{if((p&255|0)!=48){s=p;break b}f[e>>2]=f[e>>2]|32;o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[l>>2]=n;f[c>>2]=o+1;continue a}else z=n}else z=0;n=KYb(c,z)|0;o=J;f[l>>2]=n;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)continue a;else{u=0;q=37;break a}break}default:{s=p;break b}}}while(0);if(!s){u=1;q=37;break}n=f[m>>2]|0;if(!(n&1))A=lSa(m)|0;else A=n&-2;if(!(Lqc(c,s,A)|0)){u=0;q=37;break}}if((q|0)==37)return u|0;return 0}function efb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+4>>2]|0;if(!(c&1))d=0;else d=Rqc(c&-2)|0;c=f[a+8>>2]|0;if(!(c&63)){e=d;g=a+12|0;f[g>>2]=e;return e|0}if(!(c&1))h=d;else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0?f[i+4>>2]|0:j&255;h=d+1+k+((((($(k|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&2))l=h;else{k=f[a+20>>2]|0;d=b[k+11>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;l=h+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&4))m=l;else{j=f[a+24>>2]|0;h=b[j+11>>0]|0;d=h<<24>>24<0?f[j+4>>2]|0:h&255;m=l+1+d+((((($(d|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&8))n=m;else{d=f[a+28>>2]|0;l=b[d+11>>0]|0;h=l<<24>>24<0?f[d+4>>2]|0:l&255;n=m+1+h+((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&16))o=n;else{h=f[a+32>>2]|0;m=b[h+11>>0]|0;l=m<<24>>24<0?f[h+4>>2]|0:m&255;o=n+1+l+((((($(l|1|0)|0)^31)*9|0)+73|0)>>>6)|0}if(!(c&32)){e=o;g=a+12|0;f[g>>2]=e;return e|0}e=o+1+((((($(f[a+36>>2]|1|0)|0)^31)*9|0)+73|0)>>>6)|0;g=a+12|0;f[g>>2]=e;return e|0}function ffb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&1|0)f$b(1,f[a+16>>2]|0,b);if(c&2|0)f$b(2,f[a+20>>2]|0,b);if(c&4|0)f$b(3,f[a+24>>2]|0,b);if(c&8|0)f$b(4,f[a+28>>2]|0,b);if(c&16|0)f$b(5,f[a+32>>2]|0,b);if(c&32|0)U_b(6,f[a+36>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function gfb(a){a=a|0;return f[a+12>>2]|0}function hfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=10;e=gZb(g,d+1|0)|0}if(!(c&2))h=e;else{d=f[a+20>>2]|0;b[e>>0]=18;h=gZb(d,e+1|0)|0}if(!(c&4))i=h;else{e=f[a+24>>2]|0;b[h>>0]=26;i=gZb(e,h+1|0)|0}if(!(c&8))j=i;else{h=f[a+28>>2]|0;b[i>>0]=34;j=gZb(h,i+1|0)|0}if(!(c&16))k=j;else{i=f[a+32>>2]|0;b[j>>0]=42;k=gZb(i,j+1|0)|0}if(!(c&32))l=k;else{c=f[a+36>>2]|0;b[k>>0]=48;j=k+1|0;if(c>>>0>127){k=c;i=j;while(1){b[i>>0]=k|128;h=k>>>7;e=i+1|0;if(k>>>0>16383){k=h;i=e}else{m=e;n=h;break}}}else{m=j;n=c}b[m>>0]=n;l=m+1|0}m=f[a+4>>2]|0;if(!(m&1)){o=l;return o|0}o=Pqc(m&-2,l)|0;return o|0}function ifb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;bfb(a);c=kZc(b,21568,16528,0)|0;if(!c){Ooc(b,a);return}else{mfb(a,c);return}}function jfb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16528,0)|0;if(!c){Ooc(b,a);return}else{mfb(a,c);return}}function kfb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function lfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535472;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function mfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&63))return;do if(d&1|0?(g=a+8|0,f[g>>2]=f[g>>2]|1,g=a+16|0,e=f[b+16>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);do if(d&2|0?(e=a+8|0,f[e>>2]=f[e>>2]|2,e=a+20|0,c=f[b+20>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==537368){mHa(e,c);break}else{oYc(g,c)|0;break}while(0);do if(d&4|0?(c=a+8|0,f[c>>2]=f[c>>2]|4,c=a+24|0,g=f[b+24>>2]|0,e=f[c>>2]|0,(e|0)!=(g|0)):0)if((e|0)==537368){mHa(c,g);break}else{oYc(e,g)|0;break}while(0);do if(d&8|0?(g=a+8|0,f[g>>2]=f[g>>2]|8,g=a+28|0,e=f[b+28>>2]|0,c=f[g>>2]|0,(c|0)!=(e|0)):0)if((c|0)==537368){mHa(g,e);break}else{oYc(c,e)|0;break}while(0);do if(d&16|0?(e=a+8|0,f[e>>2]=f[e>>2]|16,e=a+32|0,c=f[b+32>>2]|0,g=f[e>>2]|0,(g|0)!=(c|0)):0)if((g|0)==537368){mHa(e,c);break}else{oYc(g,c)|0;break}while(0);if(d&32|0)f[a+36>>2]=f[b+36>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function nfb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97456;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533208?(f[223101]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=51;b[d+8>>0]=0;J_b(892404,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=537368;f[a+20>>2]=537368;f[a+24>>2]=537368;f[a+28>>2]=537368;f[a+32>>2]=537368;f[a+36>>2]=0;u=c;return}function ofb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function pfb(a){a=a|0;var c=0;c=f[a+16>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+20>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+24>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+28>>2]|0;if(!((c|0)==537368|(c|0)==0)){if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c)}c=f[a+32>>2]|0;if((c|0)==537368|(c|0)==0)return;if((b[c+11>>0]|0)<0)cYc(f[c>>2]|0);cYc(c);return}function qfb(a){a=a|0;var b=0,c=0;f[a>>2]=97564;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function rfb(a){a=a|0;var b=0,c=0;f[a>>2]=97564;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function sfb(a){a=a|0;a=$Xc(28)|0;Ffb(a);return a|0}function tfb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;Ffb(a);if(!b)return a|0;Gfb(b,a);return a|0}function ufb(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+16>>2]=0;n[a+20>>2]=.30000001192092896;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function vfb(a){a=a|0;return 1}function wfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+20|0;k=a+16|0;l=a+24|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=13){s=p;break b}f[i>>2]=f[i>>2]|2;o=f[c>>2]|0;if(((f[g>>2]|0)-o|0)>3){a=o;n=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=n;f[c>>2]=o+4;t=n}else{if(!(WYb(c,e)|0)){q=13;break a}t=f[e>>2]|0}f[j>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[i>>2]=f[i>>2]|1;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;v=a}else{w=a;q=18}}else{w=0;q=18}if((q|0)==18){q=0;a=KYb(c,w)|0;n=J;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)v=a;else{x=0;q=32;break a}}f[k>>2]=v;continue a;break}case 3:{if((p&255|0)!=29){s=p;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){n=a;o=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=o;f[c>>2]=a+4;y=o}else{if(!(WYb(c,e)|0)){q=26;break a}y=f[e>>2]|0}f[l>>2]=y;continue a;break}default:{s=p;break b}}}while(0);if(!s){x=1;q=32;break}o=f[m>>2]|0;if(!(o&1))z=lSa(m)|0;else z=o&-2;if(!(Lqc(c,s,z)|0)){x=0;q=32;break}}if((q|0)==13){x=0;u=d;return x|0}else if((q|0)==26){x=0;u=d;return x|0}else if((q|0)==32){u=d;return x|0}return 0}function xfb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&7)){d=c;e=a+12|0;f[e>>2]=d;return d|0}if(!(b&1))g=c;else{h=f[a+16>>2]|0;if((h|0)<0)i=11;else i=((((($(h|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;g=i+c|0}c=b&2|0?g+5|0:g;d=b&4|0?c+5|0:c;e=a+12|0;f[e>>2]=d;return d|0}function yfb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)a$b(1,+n[a+20>>2],b);if(c&1|0)S_b(2,f[a+16>>2]|0,b);if(c&4|0)a$b(3,+n[a+24>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function zfb(a){a=a|0;return f[a+12>>2]|0}function Afb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+8>>2]|0;if(!(c&2))e=d;else{g=f[a+20>>2]|0;b[d>>0]=13;h=d+1|0;b[h>>0]=g;b[h+1>>0]=g>>8;b[h+2>>0]=g>>16;b[h+3>>0]=g>>24;e=d+5|0}if(!(c&1))i=e;else{d=f[a+16>>2]|0;b[e>>0]=16;g=e+1|0;e=d&255;if(d>>>0>127){h=g;j=e;k=d;l=((d|0)<0)<<31>>31;while(1){b[h>>0]=j|-128;d=k;k=l1c(k|0,l|0,7)|0;m=h+1|0;n=k&255;if(!(l>>>0>0|(l|0)==0&d>>>0>16383)){o=m;p=n;break}else{h=m;j=n;l=J}}}else{o=g;p=e}b[o>>0]=p;i=o+1|0}if(!(c&4))q=i;else{c=f[a+24>>2]|0;b[i>>0]=29;o=i+1|0;b[o>>0]=c;b[o+1>>0]=c>>8;b[o+2>>0]=c>>16;b[o+3>>0]=c>>24;q=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){r=q;return r|0}r=Pqc(i&-2,q)|0;return r|0}function Bfb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;c=a+8|0;if(f[c>>2]&7|0){f[a+16>>2]=0;n[a+20>>2]=.30000001192092896;n[a+24>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);Cfb(a,b);return}function Cfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=kZc(b,21568,16544,0)|0;if(!c){Ooc(b,a);return}b=a+4|0;d=f[c+4>>2]|0;if(d&1|0){e=f[b>>2]|0;if(!(e&1))g=lSa(b)|0;else g=e&-2;vqc(g,d&-2)}d=f[c+8>>2]|0;if(!(d&7))return;if(d&1|0)f[a+16>>2]=f[c+16>>2];if(d&2|0)f[a+20>>2]=f[c+20>>2];if(d&4|0)f[a+24>>2]=f[c+24>>2];c=a+8|0;f[c>>2]=f[c>>2]|d;return}function Dfb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Efb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535464;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Ffb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97564;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=533176?(f[223100]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=50;b[d+8>>0]=0;J_b(892400,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;n[a+20>>2]=.30000001192092896;n[a+24>>2]=1.0;u=c;return}function Gfb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Hfb(a){a=a|0;var b=0,c=0;f[a>>2]=97672;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function Ifb(a){a=a|0;var b=0,c=0;f[a>>2]=97672;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)cYc(b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function Jfb(a){a=a|0;a=$Xc(32)|0;Xfb(a);return a|0}function Kfb(a,b){a=a|0;b=b|0;a=$Xc(32)|0;Xfb(a);if(!b)return a|0;Yfb(b,a);return a|0}function Lfb(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+28>>2]=2;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Mfb(a){a=a|0;return 1}function Nfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=c+4|0;e=a+8|0;g=a+28|0;h=a+16|0;i=a+20|0;j=a+24|0;k=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){l=b[a>>0]|0;m=l&255;if(l<<24>>24>0){f[c>>2]=a+1;n=m;o=6}else{p=m;o=5}}else{p=0;o=5}if((o|0)==5){o=0;m=ZYb(c,p)|0;if((m+-1|0)>>>0<127){n=m;o=6}else q=m}b:do if((o|0)==6){o=0;switch(n>>>3&536870911|0){case 1:{if((n&255|0)!=8){q=n;break b}f[e>>2]=f[e>>2]|1;m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){a=b[m>>0]|0;l=a&255;if(a<<24>>24>-1){f[c>>2]=m+1;r=l}else{s=l;o=11}}else{s=0;o=11}if((o|0)==11){o=0;l=KYb(c,s)|0;m=J;if((m|0)>-1|(m|0)==-1&l>>>0>4294967295)r=l;else{t=0;o=35;break a}}f[g>>2]=r;continue a;break}case 2:break;default:{q=n;break b}}switch((n&255)<<24>>24){case 16:break;case 18:{if(h4a(c,h)|0)continue a;else{t=0;o=35;break a}break}default:{q=n;break b}}l=f[c>>2]|0;if(l>>>0<(f[d>>2]|0)>>>0){m=b[l>>0]|0;a=m&255;if(m<<24>>24>-1){f[c>>2]=l+1;u=a}else{v=a;o=17}}else{v=0;o=17}if((o|0)==17){o=0;a=KYb(c,v)|0;l=J;if((l|0)>-1|(l|0)==-1&a>>>0>4294967295)u=a;else{t=0;o=35;break a}}a=f[h>>2]|0;if((a|0)==(f[i>>2]|0)){xHa(h,a+1|0);w=f[h>>2]|0}else w=a;a=f[j>>2]|0;f[h>>2]=w+1;f[a+4+(w<<2)>>2]=u;l=(f[i>>2]|0)-(f[h>>2]|0)|0;if((l|0)>0){x=l;y=a}else continue a;while(1){a=f[c>>2]|0;l=f[d>>2]|0;if(a>>>0>=l>>>0)continue a;if((b[a>>0]|0)!=16)continue a;m=a+1|0;f[c>>2]=m;if(m>>>0<l>>>0){l=b[m>>0]|0;m=l&255;if(l<<24>>24>-1){f[c>>2]=a+2;z=m;A=y}else{B=m;o=25}}else{B=0;o=25}if((o|0)==25){o=0;m=KYb(c,B)|0;a=J;if(!((a|0)>-1|(a|0)==-1&m>>>0>4294967295)){t=0;o=35;break a}z=m;A=f[j>>2]|0}m=f[h>>2]|0;f[h>>2]=m+1;f[A+4+(m<<2)>>2]=z;if((x|0)>1){x=x+-1|0;y=A}else continue a}}while(0);if(!q){t=1;o=35;break}m=f[k>>2]|0;if(!(m&1))C=lSa(k)|0;else C=m&-2;if(!(Lqc(c,q,C)|0)){t=0;o=35;break}}if((o|0)==35)return t|0;return 0}function Ofb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=o$b(a+16|0)|0;d=b+c+(f[a+16>>2]|0)|0;if(!(f[a+8>>2]&1)){e=d;g=a+12|0;f[g>>2]=e;return e|0}c=f[a+28>>2]|0;if((c|0)<0)h=11;else h=((((($(c|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=h+d|0;g=a+12|0;f[g>>2]=e;return e|0}function Pfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(f[a+8>>2]&1|0)S_b(1,f[a+28>>2]|0,b);c=f[a+16>>2]|0;if((c|0)>0){d=a+24|0;e=0;do{U_b(2,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function Qfb(a){a=a|0;return f[a+12>>2]|0}function Rfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+28>>2]|0;b[d>>0]=8;g=d+1|0;d=c&255;if(c>>>0>127){h=g;i=d;j=c;k=((c|0)<0)<<31>>31;while(1){b[h>>0]=i|-128;c=j;j=l1c(j|0,k|0,7)|0;l=h+1|0;m=j&255;if(!(k>>>0>0|(k|0)==0&c>>>0>16383)){n=l;o=m;break}else{h=l;i=m;k=J}}}else{n=g;o=d}b[n>>0]=o;e=n+1|0}n=f[a+16>>2]|0;if(!n)p=e;else{o=f[a+24>>2]|0;d=0;g=e;while(1){e=f[o+4+(d<<2)>>2]|0;b[g>>0]=16;k=g+1|0;if(e>>>0>127){i=e;h=k;while(1){b[h>>0]=i|128;j=i>>>7;m=h+1|0;if(i>>>0>16383){i=j;h=m}else{q=m;r=j;break}}}else{q=k;r=e}b[q>>0]=r;h=q+1|0;d=d+1|0;if((d|0)>=(n|0)){p=h;break}else g=h}}g=f[a+4>>2]|0;if(!(g&1)){s=p;return s|0}s=Pqc(g&-2,p)|0;return s|0}function Sfb(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))return;f[a+16>>2]=0;f[a+28>>2]=2;f[a+8>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(d=c&-2,f[d>>2]|0):0)sqc(d);d=kZc(b,21568,16560,0)|0;if(!d){Ooc(b,a);return}else{Wfb(a,d);return}}function Tfb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16560,0)|0;if(!c){Ooc(b,a);return}else{Wfb(a,c);return}}function Ufb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Vfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535448;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Wfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=a+16|0;g=b+16|0;e=f[g>>2]|0;if(e|0){xHa(d,(f[d>>2]|0)+e|0);o1c((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0)}if(!(f[b+8>>2]&1))return;g=f[b+28>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|1;f[a+28>>2]=g;return}function Xfb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97672;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=533088?(f[223098]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=48;b[d+8>>0]=0;J_b(892392,d);a_b(d)}f[a+12>>2]=0;f[a+28>>2]=2;u=c;return}function Yfb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Zfb(a){a=a|0;var b=0,c=0;f[a>>2]=97780;if((a|0)!=532912?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function _fb(a){a=a|0;var b=0,c=0;f[a>>2]=97780;if((a|0)!=532912?(b=f[a+16>>2]|0,b|0):0)Yi[f[(f[b>>2]|0)+4>>2]&4095](b);b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function $fb(a){a=a|0;a=$Xc(28)|0;ngb(a);return a|0}function agb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;ngb(a);if(!b)return a|0;ogb(b,a);return a|0}function bgb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+8|0;c=f[b>>2]|0;if(c&7|0){if(c&1|0){c=f[a+16>>2]|0;d=c+8|0;e=f[d>>2]|0;if(e&1|0)oYc(f[c+16>>2]|0,535168)|0;if(e&254|0){e=c+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[c+36>>2]=-1;n[c+40>>2]=1.0;n[c+44>>2]=1.0}f[d>>2]=0;d=f[c+4>>2]|0;if(d&1|0?(c=d&-2,f[c>>2]|0):0)sqc(c)}f[a+20>>2]=1;f[a+24>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function cgb(a){a=a|0;return 1}function dgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=a+8|0;i=a+20|0;j=a+24|0;k=a+16|0;l=e+4|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=ZYb(c,r)|0;if((o+-1|0)>>>0<127){p=o;q=6}else s=o}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{if((p&255|0)!=8){s=p;break b}f[h>>2]=f[h>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[g>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[c>>2]=o+1;t=n}else{v=n;q=11}}else{v=0;q=11}if((q|0)==11){q=0;n=KYb(c,v)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)t=n;else{w=0;q=35;break a}}f[i>>2]=t;continue a;break}case 2:{if((p&255|0)!=16){s=p;break b}f[h>>2]=f[h>>2]|4;n=f[c>>2]|0;if(n>>>0<(f[g>>2]|0)>>>0){o=b[n>>0]|0;a=o&255;if(o<<24>>24>-1){f[c>>2]=n+1;x=a}else{y=a;q=17}}else{y=0;q=17}if((q|0)==17){q=0;a=KYb(c,y)|0;n=J;if((n|0)>-1|(n|0)==-1&a>>>0>4294967295)x=a;else{w=0;q=35;break a}}f[j>>2]=x;continue a;break}case 3:{if((p&255|0)!=26){s=p;break b}f[h>>2]=f[h>>2]|1;a=f[k>>2]|0;if(!a){n=$Xc(48)|0;__a(n);f[k>>2]=n;z=n}else z=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(n=b[a>>0]|0,n<<24>>24>-1):0){f[c>>2]=a+1;A=n&255}else{n=YYb(c)|0;if((n|0)>-1)A=n;else{w=0;q=35;break a}}JYb(e,c,A);if((f[l>>2]|0)<0){q=28;break a}if(!(Mi[f[(f[z>>2]|0)+44>>2]&1023](z,c)|0)){q=28;break a}if(OYb(c,f[e>>2]|0)|0)continue a;else{w=0;q=35;break a}break}default:{s=p;break b}}}while(0);if(!s){w=1;q=35;break}n=f[m>>2]|0;if(!(n&1))B=lSa(m)|0;else B=n&-2;if(!(Lqc(c,s,B)|0)){w=0;q=35;break}}if((q|0)==28){w=0;u=d;return w|0}else if((q|0)==35){u=d;return w|0}return 0}function egb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=a+8|0;d=f[b>>2]|0;if(!(d&7)){e=c;g=a+12|0;f[g>>2]=e;return e|0}if(!(d&1)){h=c;i=d}else{d=f[a+16>>2]|0;j=_i[f[(f[d>>2]|0)+48>>2]&2047](d)|0;d=c+1+j+((((($(j|1|0)|0)^31)*9|0)+73|0)>>>6)|0;h=d;i=f[b>>2]|0}if(!(i&2))k=h;else{b=f[a+20>>2]|0;if((b|0)<0)l=11;else l=((((($(b|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;k=l+h|0}if(!(i&4)){e=k;g=a+12|0;f[g>>2]=e;return e|0}i=f[a+24>>2]|0;if((i|0)<0)m=11;else m=((((($(i|1|0)|0)^31)*9|0)+73|0)>>>6)+1|0;e=m+k|0;g=a+12|0;f[g>>2]=e;return e|0}function fgb(a,b){a=a|0;b=b|0;var c=0;c=f[a+8>>2]|0;if(c&2|0)S_b(1,f[a+20>>2]|0,b);if(c&4|0)S_b(2,f[a+24>>2]|0,b);if(c&1|0)k$b(3,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;Oqc(c&-2,b);return}function ggb(a){a=a|0;return f[a+12>>2]|0}function hgb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[a+8>>2]|0;if(!(e&2))g=d;else{h=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;d=h&255;if(h>>>0>127){j=i;k=d;l=h;m=((h|0)<0)<<31>>31;while(1){b[j>>0]=k|-128;h=l;l=l1c(l|0,m|0,7)|0;n=j+1|0;o=l&255;if(!(m>>>0>0|(m|0)==0&h>>>0>16383)){p=n;q=o;break}else{j=n;k=o;m=J}}}else{p=i;q=d}b[p>>0]=q;g=p+1|0}if(!(e&4))r=g;else{p=f[a+24>>2]|0;b[g>>0]=16;q=g+1|0;g=p&255;if(p>>>0>127){d=q;i=g;m=p;k=((p|0)<0)<<31>>31;while(1){b[d>>0]=i|-128;p=m;m=l1c(m|0,k|0,7)|0;j=d+1|0;l=m&255;if(!(k>>>0>0|(k|0)==0&p>>>0>16383)){s=j;t=l;break}else{d=j;i=l;k=J}}}else{s=q;t=g}b[s>>0]=t;r=s+1|0}if(!(e&1))u=r;else{e=f[a+16>>2]|0;b[r>>0]=26;s=r+1|0;r=_i[f[(f[e>>2]|0)+60>>2]&2047](e)|0;if(r>>>0>127){t=r;g=s;while(1){b[g>>0]=t|128;q=t>>>7;k=g+1|0;if(t>>>0>16383){t=q;g=k}else{v=k;w=q;break}}}else{v=s;w=r}b[v>>0]=w;u=hj[f[(f[e>>2]|0)+64>>2]&511](e,c,v+1|0)|0}v=f[a+4>>2]|0;if(!(v&1)){x=u;return x|0}x=Pqc(v&-2,u)|0;return x|0}function igb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))return;bgb(a);c=kZc(b,21568,16576,0)|0;if(!c){Ooc(b,a);return}else{mgb(a,c);return}}function jgb(a,b){a=a|0;b=b|0;var c=0;c=kZc(b,21568,16576,0)|0;if(!c){Ooc(b,a);return}else{mgb(a,c);return}}function kgb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function lgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535424;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function mgb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;d=f[b+4>>2]|0;if(d&1|0){e=f[c>>2]|0;if(!(e&1))g=lSa(c)|0;else g=e&-2;vqc(g,d&-2)}d=f[b+8>>2]|0;if(!(d&7))return;if(d&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;e=f[g>>2]|0;if(!e){c=$Xc(48)|0;__a(c);f[g>>2]=c;h=c}else h=e;e=f[b+16>>2]|0;$_a(h,e|0?e:531776)}if(d&2|0)f[a+20>>2]=f[b+20>>2];if(d&4|0)f[a+24>>2]=f[b+24>>2];b=a+8|0;f[b>>2]=f[b>>2]|d;return}function ngb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=97780;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532912?(f[223095]|0)!=2:0){f[d>>2]=165456;f[d+4>>2]=45;b[d+8>>0]=0;J_b(892380,d);a_b(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1;u=c;return}function ogb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function pgb(a){a=a|0;var b=0,c=0;f[a>>2]=97888;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(c);f[b>>2]=0;return}function qgb(a){a=a|0;var b=0,c=0;f[a>>2]=97888;b=f[a+4>>2]|0;if(!(b&1)){cYc(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){cYc(a);return}if(f[b>>2]|0)sqc(b);cYc(c);cYc(a);return}function rgb(a){a=a|0;a=$Xc(28)|0;Egb(a);return a|0}function sgb(a,b){a=a|0;b=b|0;a=$Xc(28)|0;Egb(a);if(!b)return a|0;Fgb(b,a);return a|0}function tgb(a){a=a|0;var b=0;d[a+16>>1]=0;b=a+8|0;if(f[b>>2]&12|0){n[a+20>>2]=.9990000128746033;n[a+24>>2]=9.999999747378752e-06}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;sqc(a);return}function ugb(a){a=a|0;return 1}function vgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;i=a+8|0;j=a+16|0;k=e+8|0;l=a+20|0;m=a+24|0;n=a+17|0;o=e+8|0;p=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[c>>2]=a+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=ZYb(c,v)|0;if((r+-1|0)>>>0<127){s=r;t=6}else w=r}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{if((s&255|0)!=8){w=s;break b}f[i>>2]=f[i>>2]|1;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;x=a<<24>>24!=0}else{LYb(e,c);a=e;if(!(b[k>>0]|0)){y=0;t=38;break a}else x=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0}b[j>>0]=x&1;continue a;break}case 2:{if((s&255|0)!=21){w=s;break b}f[i>>2]=f[i>>2]|4;a=f[c>>2]|0;if(((f[g>>2]|0)-a|0)>3){r=a;q=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=q;f[c>>2]=a+4;z=q}else{if(!(WYb(c,e)|0)){t=19;break a}z=f[e>>2]|0}f[l>>2]=z;continue a;break}case 3:{if((s&255|0)!=29){w=s;break b}f[i>>2]=f[i>>2]|8;q=f[c>>2]|0;if(((f[g>>2]|0)-q|0)>3){a=q;r=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=r;f[c>>2]=q+4;A=r}else{if(!(WYb(c,e)|0)){t=26;break a}A=f[e>>2]|0}f[m>>2]=A;continue a;break}case 7:{if((s&255|0)!=56){w=s;break b}f[i>>2]=f[i>>2]|2;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(q=b[r>>0]|0,q<<24>>24>-1):0){f[c>>2]=r+1;B=q<<24>>24!=0}else{LYb(e,c);q=e;if(!(b[o>>0]|0)){y=0;t=38;break a}else B=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0}b[n>>0]=B&1;continue a;break}default:{w=s;break b}}}while(0);if(!w){y=1;t=38;break}q=f[p>>2]|0;if(!(q&1))C=lSa(p)|0;else C=q&-2;if(!(Lqc(c,w,C)|0)){y=0;t=38;break}}if((t|0)==19){y=0;u=d;return y|0}else if((t|0)==26){y=0;u=d;return y|0}else if((t|0)==38){u=d;return y|0}return 0}function wgb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if(!(b&1))c=0;else c=Rqc(b&-2)|0;b=f[a+8>>2]|0;if(!(b&15)){d=c;e=a+12|0;f[e>>2]=d;return d|0}g=b&1|0?c+2|0:c;c=b&2|0?g+2|0:g;g=b&4|0?c+5|0:c;d=b&8|0?g+5|0:g;e=a+12|0;f[e>>2]=d;return d|0}function xgb(a,c){a=a|0;c=c|0;var d=0;d=f[a+8>>2]|0;if(d&1|0)c$b(1,(b[a+16>>0]|0)!=0,c);if(d&4|0)a$b(2,+n[a+20>>2],c);if(d&8|0)a$b(3,+n[a+24>>2],c);if(d&2|0)c$b(7,(b[a+17>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;Oqc(d&-2,c);return}function ygb(a){a=a|0;return f[a+12>>2]|0}function zgb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+8>>2]|0;if(!(c&1))e=d;else{g=b[a+16>>0]|0;b[d>>0]=8;b[d+1>>0]=g;e=d+2|0}if(!(c&4))h=e;else{d=f[a+20>>2]|0;b[e>>0]=21;g=e+1|0;b[g>>0]=d;b[g+1>>0]=d>>8;b[g+2>>0]=d>>16;b[g+3>>0]=d>>24;h=e+5|0}if(!(c&8))i=h;else{e=f[a+24>>2]|0;b[h>>0]=29;d=h+1|0;b[d>>0]=e;b[d+1>>0]=e>>8;b[d+2>>0]=e>>16;b[d+3>>0]=e>>24;i=h+5|0}if(!(c&2))j=i;else{c=b[a+17>>0]|0;b[i>>0]=56;b[i+1>>0]=c;j=i+2|0}i=f[a+4>>2]|0;if(!(i&1)){k=j;return k|0}k=Pqc(i&-2,j)|0;return k|0}function Agb(a,b){a=a|0;b=b|0;var c=0,e=0;if((a|0)==(b|0))return;d[a+16>>1]=0;c=a+8|0;if(f[c>>2]&12|0){n[a+20>>2]=.9990000128746033;n[a+24>>2]=9.999999747378752e-06}f[c>>2]=0;c=f[a+4>>2]|0;if(c&1|0?(e=c&-2,f[e>>2]|0):0)sqc(e);Bgb(a,b);return}function Bgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=kZc(c,21568,16592,0)|0;if(!d){Ooc(c,a);return}c=a+4|0;e=f[d+4>>2]|0;if(e&1|0){g=f[c>>2]|0;if(!(g&1))h=lSa(c)|0;else h=g&-2;vqc(h,e&-2)}e=f[d+8>>2]|0;if(!(e&15))return;if(e&1|0)b[a+16>>0]=b[d+16>>0]|0;if(e&2|0)b[a+17>>0]=b[d+17>>0]|0;if(e&4|0)f[a+20>>2]=f[d+20>>2];if(e&8|0)f[a+24>>2]=f[d+24>>2];d=a+8|0;f[d>>2]=f[d>>2]|e;return}function Cgb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Dgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;if((f[223071]|0)!=2){f[d>>2]=165456;f[d+4>>2]=21;b[d+8>>0]=0;J_b(892284,d);a_b(d)}d=535416;e=f[d+4>>2]|0;g=a;f[g>>2]=f[d>>2];f[g+4>>2]=e;u=c;return}function Egb(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=97888;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=532880?(f[223094]|0)!=2:0){f[e>>2]=165456;f[e+4>>2]=44;b[e+8>>0]=0;J_b(892376,e);a_b(e)}f[a+12>>2]=0;d[a+16>>1]=0;n[a+20>>2]=.9990000128746033;n[a+24>>2]=9.999999747378752e-06;u=c;return}function Fgb(a,b){a=a|0;b=b|0;if(!b)return;PXb(a,b,2247);return}function Ggb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=97996;Iib(a);c=f[a+132>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+120|0;d=f[c>>2]|0;if(d|0?(f[a+108>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)Yi[f[(f[h>>2]|0)+4>>2]&4095](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;cYc(i)}f[c>>2]=0;c=a+104|0;i=f[c>>2]|0;if(i|0?(f[a+92>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)Yi[f[(f[g>>2]|0)+4>>2]&4095](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;cYc(j)}f[c>>2]=0;c=a+88|0;j=f[c>>2]|0;if(j|0?(f[a+76>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)Yi[f[(f[e>>2]|0)+4>>2]&4095](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;cYc(k)}f[c>>2]=0;c=a+72|0;k=f[c>>2]|0;if(k|0?(f[a+60>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)Yi[f[(f[d>>2]|0)+4>>2]&4095](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;cYc(l)}f[c>>2]=0;c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)cYc(c);c=a+44|0;l=f[c>>2]|0;if(l|0?(f[a+32>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)cYc(f[i>>2]|0);cYc(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;cYc(m)}f[c>>2]=0;c=a+28|0;m=f[c>>2]|0;if(m|0?(f[a+16>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0){if((b[j+11>>0]|0)<0)cYc(f[j>>2]|0);cYc(j)}k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;cYc(n)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}n=a&-2;a=n;if((n|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)sqc(a);cYc(n);f[c>>2]=0;return}function Hgb(a){a=a|0;Ggb(a);cYc(a);return}function Igb(a){a=a|0;a=$Xc(368)|0;Gib(a);return a|0}function Jgb(a,b){a=a|0;b=b|0;a=$Xc(368)|0;Gib(a);if(!b)return a|0;Hib(b,a);return a|0}function Kgb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=a+20|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((h|0)!=(e|0));f[c>>2]=0}c=a+36|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+44>>2]|0;g=0;do{j=f[h+4+(g<<2)>>2]|0;g=g+1|0;i=j+11|0;if((b[i>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0}else{b[j>>0]=0;b[i>>0]=0}}while((g|0)!=(e|0));f[c>>2]=0}f[a+48>>2]=0;c=a+64|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+72>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+8|0;k=f[j>>2]|0;do if(k&1|0){l=f[i+16>>2]|0;m=l+11|0;if((b[m>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0;break}else{b[l>>0]=0;b[m>>0]=0;break}}while(0);if(k&14|0){f[i+20>>2]=0;n[i+24>>2]=1.0;n[i+28>>2]=1.0}f[j>>2]=0;m=f[i+4>>2]|0;if(m&1|0?(l=m&-2,f[l>>2]|0):0)sqc(l)}while((h|0)!=(e|0));f[c>>2]=0}c=a+80|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+88>>2]|0;g=0;do{d0a(f[h+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(e|0));f[c>>2]=0}c=a+96|0;e=f[c>>2]|0;if((e|0)>0){g=f[a+104>>2]|0;h=0;do{vab(f[g+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)!=(e|0));f[c>>2]=0}c=a+112|0;e=f[c>>2]|0;if((e|0)>0){h=f[a+120>>2]|0;g=0;do{vab(f[h+4+(g<<2)>>2]|0);g=g+1|0}while((g|0)!=(e|0));f[c>>2]=0}f[a+124>>2]=0;c=a+8|0;e=f[c>>2]|0;if(e&255|0){do if(e&1|0){g=f[a+136>>2]|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);do if(e&2|0){h=f[a+140>>2]|0;g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);if(e&4|0){g=f[a+144>>2]|0;f[g+16>>2]=0;h=g+8|0;l=f[h>>2]|0;do if(l&1|0){m=f[g+28>>2]|0;o=m+11|0;if((b[o>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0;break}else{b[m>>0]=0;b[o>>0]=0;break}}while(0);if(l&62|0){l=g+32|0;f[l>>2]=0;d[l+4>>1]=0;b[l+6>>0]=0;n[g+40>>2]=1.0}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&8|0){g=f[a+148>>2]|0;h=g+8|0;if(f[h>>2]&7|0){l=g+16|0;f[l>>2]=0;b[l+4>>0]=0;f[g+24>>2]=1}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&16|0){g=f[a+152>>2]|0;h=g+8|0;if(f[h>>2]&7|0){f[g+16>>2]=0;f[g+20>>2]=1;f[g+24>>2]=1}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&32|0){g=f[a+156>>2]|0;h=g+8|0;if(f[h>>2]&7|0){l=g+16|0;f[l>>2]=0;f[l+4>>2]=0;f[g+24>>2]=1}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&64|0){g=f[a+160>>2]|0;h=g+8|0;if(f[h>>2]&3|0){f[g+16>>2]=1;f[g+20>>2]=1}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&128|0){g=f[a+164>>2]|0;h=g+8|0;if(f[h>>2]&3|0){b[g+16>>0]=0;n[g+20>>2]=1.0}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}}if(e&65280|0){if(e&256|0)O9a(f[a+168>>2]|0);if(e&512|0){g=f[a+172>>2]|0;h=g+8|0;l=f[h>>2]|0;do if(l&3|0){do if(l&1|0){o=f[g+16>>2]|0;m=o+11|0;if((b[m>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0;break}else{b[o>>0]=0;b[m>>0]=0;break}}while(0);if(l&2|0){i=f[g+20>>2]|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[j>>0]=0;break}}}while(0);if(l&252|0){j=g+24|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0}if(l&768|0){n[g+44>>2]=1.0;f[g+48>>2]=4}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&1024|0){g=f[a+176>>2]|0;h=g+8|0;if(f[h>>2]&3|0){n[g+16>>2]=.5;b[g+20>>0]=1}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&2048|0)n5a(f[a+180>>2]|0);if(e&4096|0){g=f[a+184>>2]|0;f[g+16>>2]=0;h=g+8|0;if(f[h>>2]&3|0){f[g+28>>2]=1;b[g+32>>0]=1}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}if(e&8192|0){g=f[a+188>>2]|0;h=g+8|0;if(f[h>>2]&7|0){n[g+16>>2]=0.0;n[g+20>>2]=-1.0;n[g+24>>2]=1.0}f[h>>2]=0;h=f[g+4>>2]|0;if(h&1|0?(g=h&-2,f[g>>2]|0):0)sqc(g)}do if(e&16384|0){g=f[a+192>>2]|0;h=g+8|0;l=f[h>>2]|0;do if(l&1|0){j=f[g+16>>2]|0;i=j+11|0;if((b[i>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[i>>0]=0;break}}while(0);if(l&6|0){i=g+20|0;f[i>>2]=0;b[i+4>>0]=0}f[h>>2]=0;i=f[g+4>>2]|0;if(i&1|0){j=i&-2;if(!(f[j>>2]|0))break;sqc(j)}}while(0);if(e&32768|0){j=f[a+196>>2]|0;i=j+8|0;do if(f[i>>2]&1|0){k=f[j+16>>2]|0;m=k+11|0;if((b[m>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[m>>0]=0;break}}while(0);f[i>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)sqc(j)}}do if(e&16711680|0){if((e&65536|0?(j=f[a+200>>2]|0,f[j+16>>2]=1,f[j+8>>2]=0,i=f[j+4>>2]|0,i&1|0):0)?(j=i&-2,f[j>>2]|0):0)sqc(j);if(e&131072|0)D8a(f[a+204>>2]|0);if(e&262144|0){j=f[a+208>>2]|0;i=j+8|0;do if(f[i>>2]&1|0){m=f[j+16>>2]|0;k=m+11|0;if((b[k>>0]|0)<0){b[f[m>>2]>>0]=0;f[m+4>>2]=0;break}else{b[m>>0]=0;b[k>>0]=0;break}}while(0);f[i>>2]=0;g=f[j+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&524288|0)Z7a(f[a+212>>2]|0);if(e&1048576|0){h=f[a+216>>2]|0;g=h+8|0;if(f[g>>2]&63|0){l=h+16|0;f[l>>2]=0;f[l+4>>2]=0;f[h+24>>2]=5;n[h+28>>2]=1.0;n[h+32>>2]=.75;n[h+36>>2]=1.0}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}if(e&2097152|0){h=f[a+220>>2]|0;g=h+8|0;if(f[g>>2]&15|0){l=h+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)sqc(h)}do if(e&4194304|0){h=f[a+224>>2]|0;g=h+8|0;if(f[g>>2]&7|0){b[h+16>>0]=0;b[h+17>>0]=1;n[h+20>>2]=9.999999717180685e-10}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0){h=g&-2;if(!(f[h>>2]|0))break;sqc(h)}}while(0);if(e&8388608|0){j=f[a+228>>2]|0;i=j+8|0;h=f[i>>2]|0;if(h&255|0){g=j+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0}if(h&7936|0){h=j+48|0;f[h>>2]=0;f[h+4>>2]=0;b[h+8>>0]=0;f[j+60>>2]=1;b[j+64>>0]=1}f[i>>2]=0;i=f[j+4>>2]|0;if(!(i&1))break;j=i&-2;if(!(f[j>>2]|0))break;sqc(j)}}while(0);if(e>>>0>16777215){if(e&16777216|0){j=f[a+232>>2]|0;i=j+8|0;if(f[i>>2]&7|0){n[j+16>>2]=0.0;n[j+20>>2]=1.0;n[j+24>>2]=1.0}f[i>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)sqc(j)}if(e&33554432|0){j=f[a+236>>2]|0;i=j+8|0;if(f[i>>2]&3|0){h=j+16|0;f[h>>2]=0;f[h+4>>2]=0}f[i>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)sqc(j)}if((e&67108864|0?(j=f[a+240>>2]|0,f[j+16>>2]=0,f[j+8>>2]=0,i=f[j+4>>2]|0,i&1|0):0)?(j=i&-2,f[j>>2]|0):0)sqc(j);if(e&134217728|0){j=f[a+244>>2]|0;i=j+8|0;if(f[i>>2]&3|0){f[j+16>>2]=0;f[j+20>>2]=1}f[i>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)sqc(j)}if(e&268435456|0){j=f[a+248>>2]|0;f[j+16>>2]=0;i=j+8|0;if(f[i>>2]&3|0){f[j+28>>2]=1;f[j+32>>2]=1}f[i>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)sqc(j)}if((e&536870912|0?(j=f[a+252>>2]|0,f[j+16>>2]=0,f[j+8>>2]=0,i=f[j+4>>2]|0,i&1|0):0)?(j=i&-2,f[j>>2]|0):0)sqc(j);do if(e&1073741824|0?(j=f[a+256>>2]|0,n[j+16>>2]=0.0,f[j+8>>2]=0,i=f[j+4>>2]|0,i&1|0):0){j=i&-2;if(!(f[j>>2]|0))break;sqc(j)}while(0);if((e|0)<0)c7a(f[a+260>>2]|0)}e=f[a+12>>2]|0;if(e&255|0){if(e&1|0)Ocb(f[a+264>>2]|0);if(e&2|0)O_a(f[a+268>>2]|0);if(e&4|0){j=f[a+272>>2]|0;i=j+8|0;if(f[i>>2]&7|0){h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0}f[i>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)sqc(j)}do if(e&8|0){j=f[a+276>>2]|0;i=j+8|0;h=f[i>>2]|0;do if(h&1|0?(g=f[j+16>>2]|0,f[g+16>>2]=0,f[g+8>>2]=0,l=f[g+4>>2]|0,l&1|0):0){g=l&-2;if(!(f[g>>2]|0))break;sqc(g)}while(0);if(h&6|0){f[j+20>>2]=0;f[j+24>>2]=-1}f[i>>2]=0;g=f[j+4>>2]|0;if(g&1|0){l=g&-2;if(!(f[l>>2]|0))break;sqc(l)}}while(0);do if(e&16|0){l=f[a+280>>2]|0;g=l+8|0;if(f[g>>2]&7|0){n[l+16>>2]=0.0;n[l+20>>2]=-1.0;n[l+24>>2]=1.0}f[g>>2]=0;g=f[l+4>>2]|0;if(g&1|0){l=g&-2;if(!(f[l>>2]|0))break;sqc(l)}}while(0);do if(e&32|0){l=f[a+284>>2]|0;g=l+8|0;if(f[g>>2]&3|0){f[l+16>>2]=1;f[l+20>>2]=-1}f[g>>2]=0;g=f[l+4>>2]|0;if(!(g&1))break;l=g&-2;if(!(f[l>>2]|0))break;sqc(l)}while(0);do if(e&64|0){l=f[a+288>>2]|0;g=l+8|0;if(f[g>>2]&7|0){f[l+16>>2]=0;f[l+20>>2]=1;n[l+24>>2]=1.0}f[g>>2]=0;g=f[l+4>>2]|0;if(!(g&1))break;l=g&-2;if(!(f[l>>2]|0))break;sqc(l)}while(0);if(e&128|0)ueb(f[a+292>>2]|0)}do if(e&65280|0){if(e&256|0){l=f[a+296>>2]|0;g=l+8|0;if(f[g>>2]&3|0){f[l+16>>2]=0;f[l+20>>2]=1}f[g>>2]=0;g=f[l+4>>2]|0;if(g&1|0?(l=g&-2,f[l>>2]|0):0)sqc(l)}if(e&512|0){l=f[a+300>>2]|0;d[l+16>>1]=0;g=l+8|0;if(f[g>>2]&12|0){n[l+20>>2]=.9990000128746033;n[l+24>>2]=9.999999747378752e-06}f[g>>2]=0;g=f[l+4>>2]|0;if(g&1|0?(l=g&-2,f[l>>2]|0):0)sqc(l)}if((e&1024|0?(l=f[a+304>>2]|0,n[l+16>>2]=1.0,f[l+8>>2]=0,g=f[l+4>>2]|0,g&1|0):0)?(l=g&-2,f[l>>2]|0):0)sqc(l);if(e&2048|0)bgb(f[a+308>>2]|0);if(e&4096|0)xbb(f[a+312>>2]|0);do if(e&8192|0){l=f[a+316>>2]|0;g=l+20|0;k=f[g>>2]|0;if((k|0)>0){m=f[l+28>>2]|0;o=0;do{p=f[m+4+(o<<2)>>2]|0;o=o+1|0;f[p+16>>2]=0;f[p+8>>2]=0;q=f[p+4>>2]|0;do if(q&1|0){p=q&-2;if(!(f[p>>2]|0))break;sqc(p)}while(0)}while((o|0)!=(k|0));f[g>>2]=0}f[l+8>>2]=0;k=f[l+4>>2]|0;if(!(k&1))break;o=k&-2;if(!(f[o>>2]|0))break;sqc(o)}while(0);do if(e&16384|0){j=f[a+320>>2]|0;f[j+16>>2]=0;f[j+28>>2]=2;f[j+8>>2]=0;i=f[j+4>>2]|0;if(!(i&1))break;j=i&-2;if(!(f[j>>2]|0))break;sqc(j)}while(0);if(!(e&32768))break;j=f[a+324>>2]|0;i=j+8|0;do if(f[i>>2]&1|0){h=f[j+16>>2]|0;f[h+16>>2]=0;f[h+8>>2]=0;o=f[h+4>>2]|0;if(!(o&1))break;h=o&-2;if(!(f[h>>2]|0))break;sqc(h)}while(0);f[i>>2]=0;h=f[j+4>>2]|0;if(!(h&1))break;o=h&-2;if(!(f[o>>2]|0))break;sqc(o)}while(0);do if(e&16711680|0){if(e&65536|0)wcb(f[a+328>>2]|0);if(e&131072|0)aib(f[a+332>>2]|0);if((e&262144|0?(o=f[a+336>>2]|0,f[o+16>>2]=0,f[o+8>>2]=0,h=f[o+4>>2]|0,h&1|0):0)?(o=h&-2,f[o>>2]|0):0)sqc(o);if(e&524288|0)whb(f[a+340>>2]|0);do if(e&1048576|0){o=f[a+344>>2]|0;f[o+16>>2]=0;f[o+28>>2]=0;f[o+40>>2]=0;f[o+52>>2]=0;f[o+64>>2]=0;f[o+76>>2]=0;h=o+8|0;k=f[h>>2]|0;if(k&255|0){m=o+88|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0}if(k&1792|0){b[o+120>>0]=1;b[o+121>>0]=1;n[o+124>>2]=.5}f[h>>2]=0;h=f[o+4>>2]|0;if(!(h&1))break;o=h&-2;if(!(f[o>>2]|0))break;sqc(o)}while(0);do if(e&2097152|0){j=f[a+348>>2]|0;f[j+16>>2]=0;f[j+28>>2]=0;i=j+8|0;if(f[i>>2]&63|0){f[j+40>>2]=16;f[j+44>>2]=16;f[j+48>>2]=16;f[j+52>>2]=6e3;f[j+56>>2]=300;n[j+60>>2]=.699999988079071}f[i>>2]=0;i=f[j+4>>2]|0;if(!(i&1))break;j=i&-2;if(!(f[j>>2]|0))break;sqc(j)}while(0);do if(e&4194304|0){j=f[a+352>>2]|0;i=j+8|0;if(f[i>>2]&7|0){o=j+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0}f[i>>2]=0;i=f[j+4>>2]|0;if(!(i&1))break;j=i&-2;if(!(f[j>>2]|0))break;sqc(j)}while(0);if(!(e&8388608))break;j=f[a+356>>2]|0;i=j+8|0;if(f[i>>2]&7|0){o=j+16|0;f[o>>2]=0;f[o+4>>2]=0;n[j+24>>2]=1.0}f[i>>2]=0;i=f[j+4>>2]|0;if(!(i&1))break;j=i&-2;if(!(f[j>>2]|0))break;sqc(j)}while(0);f[a+360>>2]=0;e=c;f[e>>2]=0;f[e+4>>2]=0;e=f[a+4>>2]|0;if(!(e&1))return;a=e&-2;if(!(f[a>>2]|0))return;sqc(a);return}function Lgb(a){a=a|0;var b=0;if(f[a+12>>2]&4194304|0?(f[(f[a+352>>2]|0)+8>>2]&7|0)!=7:0){b=0;return b|0}b=1;return b|0}
function Mla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52540;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Nla(a){a=a|0;Mla(a);cYc(a);return}function Ola(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Pla(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Qla(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Pla(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(i<<3)|0;r=0;s=g;while(1){g=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=l;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,k)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-k|0}B=B+ +(j[g+(E<<1)>>1]|0)*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);n[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(i|0))break;if((H|0)<(m|0)){J=H;K=I}else{u=i;v=H;w=I;continue}while(1){z=f[e+(J<<2)>>2]|0;n[t+(J<<2)>>2]=+(j[g+(z-a<<1)>>1]|0)*+n[K>>2]+ +(j[g+(z-o<<1)>>1]|0)*+n[K+4>>2]+ +(j[g+(z-k<<1)>>1]|0)*+n[K+8>>2]+ +(j[g+(z<<1)>>1]|0)*+n[K+12>>2]+ +(j[g+(z+k<<1)>>1]|0)*+n[K+16>>2]+ +(j[g+(z+o<<1)>>1]|0)*+n[K+20>>2]+ +(j[g+(z+a<<1)>>1]|0)*+n[K+24>>2]+ +(j[g+(z+p<<1)>>1]|0)*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(m|0)){J=z;K=y}else{u=i;v=m;w=y;continue a}}}r=r+1|0;if((r|0)==(d|0))break;else s=I+(q<<2)|0}return}function Qla(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=ALc(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=ALc(D)|0;d[c+(A<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=ALc(E)|0;d[c+(B<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=ALc(F)|0;d[c+(C<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=ALc(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;e=e+1|0}while((e|0)!=(g|0));return}function Rla(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=52560;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;U$(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;U$(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;o=$Xc(32)|0;f[p>>2]=o;f[p+8>>2]=-2147483616;f[p+4>>2]=18;l=o;n=264725;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));b[o+18>>0]=0;vM(-215,p,264744,264471,1862)}}function Sla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52560;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Tla(a){a=a|0;Sla(a);cYc(a);return}function Ula(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){g1c(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){o1c(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Vla(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Wla(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<1)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)dYc(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Vla(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=l*3|0;o=l<<1;p=l<<2;q=0-(k<<3)|0;r=0;s=i;while(1){i=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=m;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=0;C=0;do{D=(Y(C+-3|0,l)|0)+A|0;if(D>>>0<j>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+l|0;else{G=F;break}while(1)if((G|0)<(j|0)){E=G;break}else G=G-l|0}B=(Y(d[z+(C<<1)>>1]|0,h[i+E>>0]|0)|0)+B|0;C=C+1|0}while((C|0)!=8);f[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}H=u;I=w+(x<<1)|0}else{H=v;I=w}if((u|0)==(k|0))break;if((H|0)<(n|0)){J=H;K=I}else{u=k;v=H;w=I;continue}while(1){z=f[g+(J<<2)>>2]|0;y=Y(d[K>>1]|0,h[i+(z-a)>>0]|0)|0;C=(Y(d[K+2>>1]|0,h[i+(z-o)>>0]|0)|0)+y|0;y=C+(Y(d[K+4>>1]|0,h[i+(z-l)>>0]|0)|0)|0;C=y+(Y(d[K+6>>1]|0,h[i+z>>0]|0)|0)|0;y=C+(Y(d[K+8>>1]|0,h[i+(z+l)>>0]|0)|0)|0;C=y+(Y(d[K+10>>1]|0,h[i+(z+o)>>0]|0)|0)|0;y=C+(Y(d[K+12>>1]|0,h[i+(z+a)>>0]|0)|0)|0;C=y+(Y(d[K+14>>1]|0,h[i+(z+p)>>0]|0)|0)|0;f[t+(J<<2)>>2]=C;C=J+1|0;z=K+16|0;if((C|0)<(n|0)){J=C;K=z}else{u=k;v=n;w=z;continue a}}}r=r+1|0;if((r|0)==(e|0))break;else s=I+(q<<1)|0}return}function Wla(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=h+-4|0;if((h|0)<4)i=0;else{j=g+2|0;k=c+4|0;l=g+4|0;m=c+8|0;n=g+6|0;o=c+12|0;p=g+8|0;q=c+16|0;r=g+10|0;s=c+20|0;t=g+12|0;u=c+24|0;v=g+14|0;w=c+28|0;x=0;do{y=d[g>>1]|0;z=f[c>>2]|0;A=Y(f[z+(x<<2)>>2]|0,y)|0;B=x|1;C=Y(f[z+(B<<2)>>2]|0,y)|0;D=x|2;E=Y(f[z+(D<<2)>>2]|0,y)|0;F=x|3;G=Y(f[z+(F<<2)>>2]|0,y)|0;y=d[j>>1]|0;z=f[k>>2]|0;H=(Y(f[z+(x<<2)>>2]|0,y)|0)+A|0;A=(Y(f[z+(B<<2)>>2]|0,y)|0)+C|0;C=(Y(f[z+(D<<2)>>2]|0,y)|0)+E|0;E=(Y(f[z+(F<<2)>>2]|0,y)|0)+G|0;G=d[l>>1]|0;y=f[m>>2]|0;z=(Y(f[y+(x<<2)>>2]|0,G)|0)+H|0;H=(Y(f[y+(B<<2)>>2]|0,G)|0)+A|0;A=(Y(f[y+(D<<2)>>2]|0,G)|0)+C|0;C=(Y(f[y+(F<<2)>>2]|0,G)|0)+E|0;E=d[n>>1]|0;G=f[o>>2]|0;y=(Y(f[G+(x<<2)>>2]|0,E)|0)+z|0;z=(Y(f[G+(B<<2)>>2]|0,E)|0)+H|0;H=(Y(f[G+(D<<2)>>2]|0,E)|0)+A|0;A=(Y(f[G+(F<<2)>>2]|0,E)|0)+C|0;C=d[p>>1]|0;E=f[q>>2]|0;G=(Y(f[E+(x<<2)>>2]|0,C)|0)+y|0;y=(Y(f[E+(B<<2)>>2]|0,C)|0)+z|0;z=(Y(f[E+(D<<2)>>2]|0,C)|0)+H|0;H=(Y(f[E+(F<<2)>>2]|0,C)|0)+A|0;A=d[r>>1]|0;C=f[s>>2]|0;E=(Y(f[C+(x<<2)>>2]|0,A)|0)+G|0;G=(Y(f[C+(B<<2)>>2]|0,A)|0)+y|0;y=(Y(f[C+(D<<2)>>2]|0,A)|0)+z|0;z=(Y(f[C+(F<<2)>>2]|0,A)|0)+H|0;H=d[t>>1]|0;A=f[u>>2]|0;C=(Y(f[A+(x<<2)>>2]|0,H)|0)+E|0;E=(Y(f[A+(B<<2)>>2]|0,H)|0)+G|0;G=(Y(f[A+(D<<2)>>2]|0,H)|0)+y|0;y=(Y(f[A+(F<<2)>>2]|0,H)|0)+z|0;z=d[v>>1]|0;H=f[w>>2]|0;A=(Y(f[H+(x<<2)>>2]|0,z)|0)+C|0;C=(Y(f[H+(B<<2)>>2]|0,z)|0)+E|0;E=(Y(f[H+(D<<2)>>2]|0,z)|0)+G|0;G=(Y(f[H+(F<<2)>>2]|0,z)|0)+y|0;y=A+2097152>>22;b[e+x>>0]=y>>>0<256?y:(y|0)>0?255:0;y=C+2097152>>22;b[e+B>>0]=y>>>0<256?y:(y|0)>0?255:0;y=E+2097152>>22;b[e+D>>0]=y>>>0<256?y:(y|0)>0?255:0;y=G+2097152>>22;b[e+F>>0]=y>>>0<256?y:(y|0)>0?255:0;x=x+4|0}while((x|0)<=(a|0));i=h&-4}if((i|0)>=(h|0))return;a=c+4|0;x=g+2|0;w=c+8|0;v=g+4|0;u=c+12|0;t=g+6|0;s=c+16|0;r=g+8|0;q=c+20|0;p=g+10|0;o=c+24|0;n=g+12|0;m=c+28|0;l=g+14|0;k=i;do{i=Y(d[g>>1]|0,f[(f[c>>2]|0)+(k<<2)>>2]|0)|0;j=Y(d[x>>1]|0,f[(f[a>>2]|0)+(k<<2)>>2]|0)|0;y=Y(d[v>>1]|0,f[(f[w>>2]|0)+(k<<2)>>2]|0)|0;F=Y(d[t>>1]|0,f[(f[u>>2]|0)+(k<<2)>>2]|0)|0;G=Y(d[r>>1]|0,f[(f[s>>2]|0)+(k<<2)>>2]|0)|0;D=Y(d[p>>1]|0,f[(f[q>>2]|0)+(k<<2)>>2]|0)|0;E=Y(d[n>>1]|0,f[(f[o>>2]|0)+(k<<2)>>2]|0)|0;B=i+2097152+j+y+F+G+D+E+(Y(d[l>>1]|0,f[(f[m>>2]|0)+(k<<2)>>2]|0)|0)>>22;b[e+k>>0]=B>>>0<256?B:(B|0)>0?255:0;k=k+1|0}while((k|0)!=(h|0));return}function Xla(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=52660;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}function Yla(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=52640;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}function Zla(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=52620;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}function _la(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=52600;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}function $la(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=52580;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;h3(j,k,o);u=i;return}function ama(a){a=a|0;cYc(a);return}function bma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1104|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>136){m=bYc(g>>>0>536870911?-1:g<<3)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;q=o+(j<<3)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(j|0)>0;if(v)g1c(q|0,0,j<<3|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=h&65535;A=(g|0)>0;B=j<<3;C=r;D=s;while(1){E=+n[w+(D*12|0)+8>>2];F=f[w+(D*12|0)+4>>2]|0;G=y+(Y(z,f[w+(D*12|0)>>2]|0)|0)|0;if(v)g1c(o|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=o+(f[m+(H*12|0)+4>>2]<<3)|0;p[I>>3]=+p[I>>3]+ +n[m+(H*12|0)+8>>2]*+p[G+(f[m+(H*12|0)>>2]<<3)>>3];H=H+1|0}while((H|0)!=(g|0))}break}case 1:{if(A){H=0;do{I=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=o+(J<<3)|0;M=o+(J+1<<3)|0;N=+p[M>>3]+K*+p[G+(I+1<<3)>>3];p[L>>3]=+p[L>>3]+K*+p[G+(I<<3)>>3];p[M>>3]=N;H=H+1|0}while((H|0)!=(g|0))}break}case 2:{if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;I=f[m+(H*12|0)+4>>2]|0;N=+n[m+(H*12|0)+8>>2];L=o+(I<<3)|0;J=o+(I+1<<3)|0;K=+p[J>>3]+N*+p[G+(M+1<<3)>>3];O=o+(I+2<<3)|0;P=+p[O>>3]+N*+p[G+(M+2<<3)>>3];p[L>>3]=+p[L>>3]+N*+p[G+(M<<3)>>3];p[J>>3]=K;p[O>>3]=P;H=H+1|0}while((H|0)!=(g|0))}break}case 3:{if(A){H=0;do{O=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;P=+n[m+(H*12|0)+8>>2];M=o+(J<<3)|0;L=o+(J+1<<3)|0;K=+p[L>>3]+P*+p[G+(O+1<<3)>>3];p[M>>3]=+p[M>>3]+P*+p[G+(O<<3)>>3];p[L>>3]=K;L=o+(J+2<<3)|0;M=o+(J+3<<3)|0;K=+p[M>>3]+P*+p[G+(O+3<<3)>>3];p[L>>3]=+p[L>>3]+P*+p[G+(O+2<<3)>>3];p[M>>3]=K;H=H+1|0}while((H|0)!=(g|0))}break}default:if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;O=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=0;do{J=o+(L+O<<3)|0;p[J>>3]=+p[J>>3]+K*+p[G+(L+M<<3)>>3];L=L+1|0}while((L|0)!=(i|0));H=H+1|0}while((H|0)!=(g|0))}}if((F|0)==(C|0))if(v){H=0;do{G=q+(H<<3)|0;p[G>>3]=+p[G>>3]+E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=C}else Q=C;else{H=f[e>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,C)|0)|0;if(v){H=0;do{L=q+(H<<3)|0;p[G+(H<<3)>>3]=+p[L>>3];p[L>>3]=E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=F}else Q=F}D=D+1|0;if((D|0)==(t|0)){R=Q;break a}else C=Q}}else R=r;while(0);r=f[e>>2]|0;e=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{p[e+(v<<3)>>3]=+p[q+(v<<3)>>3];v=v+1|0}while((v|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)dYc(j);f[d>>2]=k;f[l>>2]=136;u=c;return}function cma(a){a=a|0;cYc(a);return}function dma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;c=u;u=u+1072|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>264){m=bYc(g>>>0>1073741823?-1:g<<2)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;p=o+(j<<2)|0;q=f[a+28>>2]|0;r=f[q+(f[b>>2]<<2)>>2]|0;s=f[q+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;q=f[(f[b>>2]|0)+(r*12|0)+4>>2]|0;t=(j|0)>0;if(t)g1c(p|0,0,j<<2|0)|0;a:do if((r|0)<(s|0)){v=f[b>>2]|0;w=f[a+4>>2]|0;x=f[w+16>>2]|0;y=f[f[w+44>>2]>>2]|0;w=h&65535;z=(g|0)>0;A=j<<2;B=q;C=r;while(1){D=+n[v+(C*12|0)+8>>2];E=f[v+(C*12|0)+4>>2]|0;F=x+(Y(y,f[v+(C*12|0)>>2]|0)|0)|0;if(t)g1c(o|0,0,A|0)|0;switch(w&511){case 0:{if(z){G=0;do{H=o+(f[m+(G*12|0)+4>>2]<<2)|0;n[H>>2]=+n[H>>2]+ +n[m+(G*12|0)+8>>2]*+n[F+(f[m+(G*12|0)>>2]<<2)>>2];G=G+1|0}while((G|0)!=(g|0))}break}case 1:{if(z){G=0;do{H=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=o+(I<<2)|0;L=o+(I+1<<2)|0;M=+n[L>>2]+J*+n[F+(H+1<<2)>>2];n[K>>2]=+n[K>>2]+J*+n[F+(H<<2)>>2];n[L>>2]=M;G=G+1|0}while((G|0)!=(g|0))}break}case 2:{if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;H=f[m+(G*12|0)+4>>2]|0;M=+n[m+(G*12|0)+8>>2];K=o+(H<<2)|0;I=o+(H+1<<2)|0;J=+n[I>>2]+M*+n[F+(L+1<<2)>>2];N=o+(H+2<<2)|0;O=+n[N>>2]+M*+n[F+(L+2<<2)>>2];n[K>>2]=+n[K>>2]+M*+n[F+(L<<2)>>2];n[I>>2]=J;n[N>>2]=O;G=G+1|0}while((G|0)!=(g|0))}break}case 3:{if(z){G=0;do{N=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;O=+n[m+(G*12|0)+8>>2];L=o+(I<<2)|0;K=o+(I+1<<2)|0;J=+n[K>>2]+O*+n[F+(N+1<<2)>>2];n[L>>2]=+n[L>>2]+O*+n[F+(N<<2)>>2];n[K>>2]=J;K=o+(I+2<<2)|0;L=o+(I+3<<2)|0;J=+n[L>>2]+O*+n[F+(N+3<<2)>>2];n[K>>2]=+n[K>>2]+O*+n[F+(N+2<<2)>>2];n[L>>2]=J;G=G+1|0}while((G|0)!=(g|0))}break}default:if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;N=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=0;do{I=o+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+n[F+(K+L<<2)>>2];K=K+1|0}while((K|0)!=(i|0));G=G+1|0}while((G|0)!=(g|0))}}if((E|0)==(B|0))if(t){G=0;do{F=p+(G<<2)|0;n[F>>2]=+n[F>>2]+D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=B}else P=B;else{G=f[e>>2]|0;F=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,B)|0)|0;if(t){G=0;do{K=p+(G<<2)|0;f[F+(G<<2)>>2]=f[K>>2];n[K>>2]=D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=E}else P=E}C=C+1|0;if((C|0)==(s|0)){Q=P;break a}else B=P}}else Q=q;while(0);q=f[e>>2]|0;e=(f[q+16>>2]|0)+(Y(f[f[q+44>>2]>>2]|0,Q)|0)|0;if(t){t=0;do{f[e+(t<<2)>>2]=f[p+(t<<2)>>2];t=t+1|0}while((t|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)dYc(j);f[d>>2]=k;f[l>>2]=264;u=c;return}function ema(a){a=a|0;cYc(a);return}function fma(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;j=(i&511)+1|0;k=Y(j,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=k<<1;l=e+8|0;f[e>>2]=l;m=e+4|0;f[m>>2]=h;if(h>>>0>264){o=bYc(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=o;p=o}else p=l;o=f[a+12>>2]|0;h=f[a+20>>2]|0;q=p+(k<<2)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(k|0)>0;if(v)g1c(q|0,0,k<<2|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=i&65535;A=(h|0)>0;B=k<<2;C=s;D=r;while(1){E=+n[w+(C*12|0)+8>>2];F=f[w+(C*12|0)+4>>2]|0;G=y+(Y(z,f[w+(C*12|0)>>2]|0)|0)|0;if(v)g1c(p|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=p+(f[o+(H*12|0)+4>>2]<<2)|0;n[I>>2]=+n[I>>2]+ +n[o+(H*12|0)+8>>2]*+(d[G+(f[o+(H*12|0)>>2]<<1)>>1]|0);H=H+1|0}while((H|0)!=(h|0))}break}case 1:{if(A){H=0;do{I=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=p+(J<<2)|0;M=p+(J+1<<2)|0;N=+n[M>>2]+K*+(d[G+(I+1<<1)>>1]|0);n[L>>2]=+n[L>>2]+K*+(d[G+(I<<1)>>1]|0);n[M>>2]=N;H=H+1|0}while((H|0)!=(h|0))}break}case 2:{if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;I=f[o+(H*12|0)+4>>2]|0;N=+n[o+(H*12|0)+8>>2];L=p+(I<<2)|0;J=p+(I+1<<2)|0;K=+n[J>>2]+N*+(d[G+(M+1<<1)>>1]|0);O=p+(I+2<<2)|0;P=+n[O>>2]+N*+(d[G+(M+2<<1)>>1]|0);n[L>>2]=+n[L>>2]+N*+(d[G+(M<<1)>>1]|0);n[J>>2]=K;n[O>>2]=P;H=H+1|0}while((H|0)!=(h|0))}break}case 3:{if(A){H=0;do{O=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;P=+n[o+(H*12|0)+8>>2];M=p+(J<<2)|0;L=p+(J+1<<2)|0;K=+n[L>>2]+P*+(d[G+(O+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+P*+(d[G+(O<<1)>>1]|0);n[L>>2]=K;L=p+(J+2<<2)|0;M=p+(J+3<<2)|0;K=+n[M>>2]+P*+(d[G+(O+3<<1)>>1]|0);n[L>>2]=+n[L>>2]+P*+(d[G+(O+2<<1)>>1]|0);n[M>>2]=K;H=H+1|0}while((H|0)!=(h|0))}break}default:if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;O=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=0;do{J=p+(L+O<<2)|0;n[J>>2]=+n[J>>2]+K*+(d[G+(L+M<<1)>>1]|0);L=L+1|0}while((L|0)!=(j|0));H=H+1|0}while((H|0)!=(h|0))}}if((F|0)==(D|0))if(v){H=0;do{G=q+(H<<2)|0;n[G>>2]=+n[G>>2]+E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=D}else Q=D;else{H=f[g>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,D)|0)|0;if(v){H=0;do{L=q+(H<<2)|0;M=ALc(+n[L>>2])|0;d[G+(H<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;n[L>>2]=E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=F}else Q=F}C=C+1|0;if((C|0)==(t|0)){R=Q;break a}else D=Q}}else R=r;while(0);r=f[g>>2]|0;g=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{R=ALc(+n[q+(v<<2)>>2])|0;d[g+(v<<1)>>1]=(R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768;v=v+1|0}while((v|0)!=(k|0))}k=f[e>>2]|0;if((k|0)==(l|0)){u=c;return}if(k|0)dYc(k);f[e>>2]=l;f[m>>2]=264;u=c;return}function gma(a){a=a|0;cYc(a);return}function hma(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;k=(i&511)+1|0;l=Y(k,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=h;if(h>>>0>264){p=bYc(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;h=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[b>>2]<<2)>>2]|0;v=f[s+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;s=f[(f[b>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)g1c(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=f[b>>2]|0;y=f[a+4>>2]|0;z=f[y+16>>2]|0;A=f[f[y+44>>2]>>2]|0;y=i&65535;B=(h|0)>0;C=l<<2;D=t;E=s;while(1){F=+n[x+(D*12|0)+8>>2];G=f[x+(D*12|0)+4>>2]|0;H=z+(Y(A,f[x+(D*12|0)>>2]|0)|0)|0;if(w)g1c(q|0,0,C|0)|0;switch(y&511){case 0:{if(B){I=0;do{J=q+(f[p+(I*12|0)+4>>2]<<2)|0;n[J>>2]=+n[J>>2]+ +n[p+(I*12|0)+8>>2]*+(j[H+(f[p+(I*12|0)>>2]<<1)>>1]|0);I=I+1|0}while((I|0)!=(h|0))}break}case 1:{if(B){I=0;do{J=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=q+(K<<2)|0;N=q+(K+1<<2)|0;O=+n[N>>2]+L*+(j[H+(J+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+L*+(j[H+(J<<1)>>1]|0);n[N>>2]=O;I=I+1|0}while((I|0)!=(h|0))}break}case 2:{if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;J=f[p+(I*12|0)+4>>2]|0;O=+n[p+(I*12|0)+8>>2];M=q+(J<<2)|0;K=q+(J+1<<2)|0;L=+n[K>>2]+O*+(j[H+(N+1<<1)>>1]|0);P=q+(J+2<<2)|0;Q=+n[P>>2]+O*+(j[H+(N+2<<1)>>1]|0);n[M>>2]=+n[M>>2]+O*+(j[H+(N<<1)>>1]|0);n[K>>2]=L;n[P>>2]=Q;I=I+1|0}while((I|0)!=(h|0))}break}case 3:{if(B){I=0;do{P=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;Q=+n[p+(I*12|0)+8>>2];N=q+(K<<2)|0;M=q+(K+1<<2)|0;L=+n[M>>2]+Q*+(j[H+(P+1<<1)>>1]|0);n[N>>2]=+n[N>>2]+Q*+(j[H+(P<<1)>>1]|0);n[M>>2]=L;M=q+(K+2<<2)|0;N=q+(K+3<<2)|0;L=+n[N>>2]+Q*+(j[H+(P+3<<1)>>1]|0);n[M>>2]=+n[M>>2]+Q*+(j[H+(P+2<<1)>>1]|0);n[N>>2]=L;I=I+1|0}while((I|0)!=(h|0))}break}default:if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;P=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=0;do{K=q+(M+P<<2)|0;n[K>>2]=+n[K>>2]+L*+(j[H+(M+N<<1)>>1]|0);M=M+1|0}while((M|0)!=(k|0));I=I+1|0}while((I|0)!=(h|0))}}if((G|0)==(E|0))if(w){I=0;do{H=r+(I<<2)|0;n[H>>2]=+n[H>>2]+F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=E}else R=E;else{I=f[g>>2]|0;H=(f[I+16>>2]|0)+(Y(f[f[I+44>>2]>>2]|0,E)|0)|0;if(w){I=0;do{M=r+(I<<2)|0;N=ALc(+n[M>>2])|0;d[H+(I<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;n[M>>2]=F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=G}else R=G}D=D+1|0;if((D|0)==(v|0)){S=R;break a}else E=R}}else S=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,S)|0)|0;if(w){w=0;do{S=ALc(+n[r+(w<<2)>>2])|0;d[g+(w<<1)>>1]=S>>>0<65536?S:(S|0)>0?65535:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=c;return}if(l|0)dYc(l);f[e>>2]=m;f[o>>2]=264;u=c;return}function ima(a){a=a|0;cYc(a);return}function jma(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;d=u;u=u+1072|0;e=d;g=a+8|0;i=f[g>>2]|0;j=(f[i>>2]|0)>>>3;k=(j&511)+1|0;l=Y(k,f[(f[i+40>>2]|0)+4>>2]|0)|0;i=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=i;if(i>>>0>264){p=bYc(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;i=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[c>>2]<<2)>>2]|0;v=f[s+(f[c+4>>2]<<2)>>2]|0;c=a+16|0;s=f[(f[c>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)g1c(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=a+4|0;y=j&65535;z=(i|0)>0;A=l<<2;B=s;C=t;while(1){D=f[c>>2]|0;E=+n[D+(C*12|0)+8>>2];F=f[D+(C*12|0)+4>>2]|0;G=f[x>>2]|0;H=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,f[D+(C*12|0)>>2]|0)|0)|0;if(w)g1c(q|0,0,A|0)|0;switch(y&511){case 0:{if(z){D=0;do{G=q+(f[p+(D*12|0)+4>>2]<<2)|0;n[G>>2]=+n[G>>2]+ +n[p+(D*12|0)+8>>2]*+(h[H+(f[p+(D*12|0)>>2]|0)>>0]|0);D=D+1|0}while((D|0)!=(i|0))}break}case 1:{if(z){D=0;do{G=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=q+(I<<2)|0;L=q+(I+1<<2)|0;M=+n[L>>2]+J*+(h[H+(G+1)>>0]|0);n[K>>2]=+n[K>>2]+J*+(h[H+G>>0]|0);n[L>>2]=M;D=D+1|0}while((D|0)!=(i|0))}break}case 2:{if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;G=f[p+(D*12|0)+4>>2]|0;M=+n[p+(D*12|0)+8>>2];K=q+(G<<2)|0;I=q+(G+1<<2)|0;J=+n[I>>2]+M*+(h[H+(L+1)>>0]|0);N=q+(G+2<<2)|0;O=+n[N>>2]+M*+(h[H+(L+2)>>0]|0);n[K>>2]=+n[K>>2]+M*+(h[H+L>>0]|0);n[I>>2]=J;n[N>>2]=O;D=D+1|0}while((D|0)!=(i|0))}break}case 3:{if(z){D=0;do{N=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;O=+n[p+(D*12|0)+8>>2];L=q+(I<<2)|0;K=q+(I+1<<2)|0;J=+n[K>>2]+O*+(h[H+(N+1)>>0]|0);n[L>>2]=+n[L>>2]+O*+(h[H+N>>0]|0);n[K>>2]=J;K=q+(I+2<<2)|0;L=q+(I+3<<2)|0;J=+n[L>>2]+O*+(h[H+(N+3)>>0]|0);n[K>>2]=+n[K>>2]+O*+(h[H+(N+2)>>0]|0);n[L>>2]=J;D=D+1|0}while((D|0)!=(i|0))}break}default:if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;N=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=0;do{I=q+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+(h[H+(K+L)>>0]|0);K=K+1|0}while((K|0)!=(k|0));D=D+1|0}while((D|0)!=(i|0))}}if((F|0)==(B|0))if(w){D=0;do{H=r+(D<<2)|0;n[H>>2]=+n[H>>2]+E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=B}else P=B;else{D=f[g>>2]|0;H=(f[D+16>>2]|0)+(Y(f[f[D+44>>2]>>2]|0,B)|0)|0;if(w){D=0;do{K=r+(D<<2)|0;L=ALc(+n[K>>2])|0;b[H+D>>0]=L>>>0<256?L:(L|0)>0?255:0;n[K>>2]=E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=F}else P=F}C=C+1|0;if((C|0)==(v|0)){Q=P;break a}else B=P}}else Q=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,Q)|0)|0;if(w){w=0;do{Q=ALc(+n[r+(w<<2)>>2])|0;b[g+w>>0]=Q>>>0<256?Q:(Q|0)>0?255:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=d;return}if(l|0)dYc(l);f[e>>2]=m;f[o>>2]=264;u=d;return}function kma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;f[j>>2]=52760;l=j+4|0;f[l>>2]=f[a>>2];m=j+8|0;n=a+4|0;o=f[n>>2]|0;f[m>>2]=o;p=j+12|0;f[p>>2]=f[a+8>>2];f[j+16>>2]=f[a+12>>2];f[j+20>>2]=f[a+16>>2];f[j+24>>2]=f[a+20>>2];f[j+28>>2]=f[a+24>>2];f[j+32>>2]=f[a+28>>2];f[j+36>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[j+40>>2]=q;f[j+44>>2]=p;p=j+52|0;r=j+48|0;f[r>>2]=p;f[p>>2]=0;f[j+56>>2]=0;if(!q)s=o;else{o=q+12|0;f[o>>2]=(f[o>>2]|0)+1;s=f[n>>2]|0}if((s|0)<3){s=f[a+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2]}else{f[m>>2]=0;U$(l,a)}a=j+60|0;f[a>>2]=f[b>>2];l=j+64|0;m=b+4|0;s=f[m>>2]|0;f[l>>2]=s;n=j+68|0;f[n>>2]=f[k>>2];r=b+12|0;f[j+72>>2]=f[r>>2];f[j+76>>2]=f[b+16>>2];f[j+80>>2]=f[b+20>>2];f[j+84>>2]=f[b+24>>2];f[j+88>>2]=f[b+28>>2];f[j+92>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+96>>2]=o;f[j+100>>2]=n;n=j+108|0;q=j+104|0;f[q>>2]=n;f[n>>2]=0;f[j+112>>2]=0;if(!o)t=s;else{s=o+12|0;f[s>>2]=(f[s>>2]|0)+1;t=f[m>>2]|0}if((t|0)<3){t=f[b+44>>2]|0;s=f[q>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else{f[l>>2]=0;U$(a,b)}f[j+116>>2]=e;f[j+120>>2]=g;f[j+124>>2]=c;f[j+128>>2]=d;d=f[m>>2]|0;if((d|0)<3){v=Y(f[r>>2]|0,f[k>>2]|0)|0;w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);Dma(j);u=h;return}k=f[b+40>>2]|0;b=0;r=1;while(1){m=Y(f[k+(b<<2)>>2]|0,r)|0;b=b+1|0;if((b|0)==(d|0)){v=m;break}else r=m}w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);Dma(j);u=h;return}function lma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;f[j>>2]=52740;l=j+4|0;f[l>>2]=f[a>>2];m=j+8|0;n=a+4|0;o=f[n>>2]|0;f[m>>2]=o;p=j+12|0;f[p>>2]=f[a+8>>2];f[j+16>>2]=f[a+12>>2];f[j+20>>2]=f[a+16>>2];f[j+24>>2]=f[a+20>>2];f[j+28>>2]=f[a+24>>2];f[j+32>>2]=f[a+28>>2];f[j+36>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[j+40>>2]=q;f[j+44>>2]=p;p=j+52|0;r=j+48|0;f[r>>2]=p;f[p>>2]=0;f[j+56>>2]=0;if(!q)s=o;else{o=q+12|0;f[o>>2]=(f[o>>2]|0)+1;s=f[n>>2]|0}if((s|0)<3){s=f[a+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2]}else{f[m>>2]=0;U$(l,a)}a=j+60|0;f[a>>2]=f[b>>2];l=j+64|0;m=b+4|0;s=f[m>>2]|0;f[l>>2]=s;n=j+68|0;f[n>>2]=f[k>>2];r=b+12|0;f[j+72>>2]=f[r>>2];f[j+76>>2]=f[b+16>>2];f[j+80>>2]=f[b+20>>2];f[j+84>>2]=f[b+24>>2];f[j+88>>2]=f[b+28>>2];f[j+92>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+96>>2]=o;f[j+100>>2]=n;n=j+108|0;q=j+104|0;f[q>>2]=n;f[n>>2]=0;f[j+112>>2]=0;if(!o)t=s;else{s=o+12|0;f[s>>2]=(f[s>>2]|0)+1;t=f[m>>2]|0}if((t|0)<3){t=f[b+44>>2]|0;s=f[q>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else{f[l>>2]=0;U$(a,b)}f[j+116>>2]=e;f[j+120>>2]=g;f[j+124>>2]=c;f[j+128>>2]=d;d=f[m>>2]|0;if((d|0)<3){v=Y(f[r>>2]|0,f[k>>2]|0)|0;w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);zma(j);u=h;return}k=f[b+40>>2]|0;b=0;r=1;while(1){m=Y(f[k+(b<<2)>>2]|0,r)|0;b=b+1|0;if((b|0)==(d|0)){v=m;break}else r=m}w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);zma(j);u=h;return}function mma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;f[j>>2]=52720;l=j+4|0;f[l>>2]=f[a>>2];m=j+8|0;n=a+4|0;o=f[n>>2]|0;f[m>>2]=o;p=j+12|0;f[p>>2]=f[a+8>>2];f[j+16>>2]=f[a+12>>2];f[j+20>>2]=f[a+16>>2];f[j+24>>2]=f[a+20>>2];f[j+28>>2]=f[a+24>>2];f[j+32>>2]=f[a+28>>2];f[j+36>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[j+40>>2]=q;f[j+44>>2]=p;p=j+52|0;r=j+48|0;f[r>>2]=p;f[p>>2]=0;f[j+56>>2]=0;if(!q)s=o;else{o=q+12|0;f[o>>2]=(f[o>>2]|0)+1;s=f[n>>2]|0}if((s|0)<3){s=f[a+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2]}else{f[m>>2]=0;U$(l,a)}a=j+60|0;f[a>>2]=f[b>>2];l=j+64|0;m=b+4|0;s=f[m>>2]|0;f[l>>2]=s;n=j+68|0;f[n>>2]=f[k>>2];r=b+12|0;f[j+72>>2]=f[r>>2];f[j+76>>2]=f[b+16>>2];f[j+80>>2]=f[b+20>>2];f[j+84>>2]=f[b+24>>2];f[j+88>>2]=f[b+28>>2];f[j+92>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+96>>2]=o;f[j+100>>2]=n;n=j+108|0;q=j+104|0;f[q>>2]=n;f[n>>2]=0;f[j+112>>2]=0;if(!o)t=s;else{s=o+12|0;f[s>>2]=(f[s>>2]|0)+1;t=f[m>>2]|0}if((t|0)<3){t=f[b+44>>2]|0;s=f[q>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else{f[l>>2]=0;U$(a,b)}f[j+116>>2]=e;f[j+120>>2]=g;f[j+124>>2]=c;f[j+128>>2]=d;d=f[m>>2]|0;if((d|0)<3){v=Y(f[r>>2]|0,f[k>>2]|0)|0;w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);vma(j);u=h;return}k=f[b+40>>2]|0;b=0;r=1;while(1){m=Y(f[k+(b<<2)>>2]|0,r)|0;b=b+1|0;if((b|0)==(d|0)){v=m;break}else r=m}w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);vma(j);u=h;return}function nma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;f[j>>2]=52700;l=j+4|0;f[l>>2]=f[a>>2];m=j+8|0;n=a+4|0;o=f[n>>2]|0;f[m>>2]=o;p=j+12|0;f[p>>2]=f[a+8>>2];f[j+16>>2]=f[a+12>>2];f[j+20>>2]=f[a+16>>2];f[j+24>>2]=f[a+20>>2];f[j+28>>2]=f[a+24>>2];f[j+32>>2]=f[a+28>>2];f[j+36>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[j+40>>2]=q;f[j+44>>2]=p;p=j+52|0;r=j+48|0;f[r>>2]=p;f[p>>2]=0;f[j+56>>2]=0;if(!q)s=o;else{o=q+12|0;f[o>>2]=(f[o>>2]|0)+1;s=f[n>>2]|0}if((s|0)<3){s=f[a+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2]}else{f[m>>2]=0;U$(l,a)}a=j+60|0;f[a>>2]=f[b>>2];l=j+64|0;m=b+4|0;s=f[m>>2]|0;f[l>>2]=s;n=j+68|0;f[n>>2]=f[k>>2];r=b+12|0;f[j+72>>2]=f[r>>2];f[j+76>>2]=f[b+16>>2];f[j+80>>2]=f[b+20>>2];f[j+84>>2]=f[b+24>>2];f[j+88>>2]=f[b+28>>2];f[j+92>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+96>>2]=o;f[j+100>>2]=n;n=j+108|0;q=j+104|0;f[q>>2]=n;f[n>>2]=0;f[j+112>>2]=0;if(!o)t=s;else{s=o+12|0;f[s>>2]=(f[s>>2]|0)+1;t=f[m>>2]|0}if((t|0)<3){t=f[b+44>>2]|0;s=f[q>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else{f[l>>2]=0;U$(a,b)}f[j+116>>2]=e;f[j+120>>2]=g;f[j+124>>2]=c;f[j+128>>2]=d;d=f[m>>2]|0;if((d|0)<3){v=Y(f[r>>2]|0,f[k>>2]|0)|0;w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);sma(j);u=h;return}k=f[b+40>>2]|0;b=0;r=1;while(1){m=Y(f[k+(b<<2)>>2]|0,r)|0;b=b+1|0;if((b|0)==(d|0)){v=m;break}else r=m}w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);sma(j);u=h;return}function oma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;f[j>>2]=52680;l=j+4|0;f[l>>2]=f[a>>2];m=j+8|0;n=a+4|0;o=f[n>>2]|0;f[m>>2]=o;p=j+12|0;f[p>>2]=f[a+8>>2];f[j+16>>2]=f[a+12>>2];f[j+20>>2]=f[a+16>>2];f[j+24>>2]=f[a+20>>2];f[j+28>>2]=f[a+24>>2];f[j+32>>2]=f[a+28>>2];f[j+36>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[j+40>>2]=q;f[j+44>>2]=p;p=j+52|0;r=j+48|0;f[r>>2]=p;f[p>>2]=0;f[j+56>>2]=0;if(!q)s=o;else{o=q+12|0;f[o>>2]=(f[o>>2]|0)+1;s=f[n>>2]|0}if((s|0)<3){s=f[a+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2]}else{f[m>>2]=0;U$(l,a)}a=j+60|0;f[a>>2]=f[b>>2];l=j+64|0;m=b+4|0;s=f[m>>2]|0;f[l>>2]=s;n=j+68|0;f[n>>2]=f[k>>2];r=b+12|0;f[j+72>>2]=f[r>>2];f[j+76>>2]=f[b+16>>2];f[j+80>>2]=f[b+20>>2];f[j+84>>2]=f[b+24>>2];f[j+88>>2]=f[b+28>>2];f[j+92>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[j+96>>2]=o;f[j+100>>2]=n;n=j+108|0;q=j+104|0;f[q>>2]=n;f[n>>2]=0;f[j+112>>2]=0;if(!o)t=s;else{s=o+12|0;f[s>>2]=(f[s>>2]|0)+1;t=f[m>>2]|0}if((t|0)<3){t=f[b+44>>2]|0;s=f[q>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else{f[l>>2]=0;U$(a,b)}f[j+116>>2]=e;f[j+120>>2]=g;f[j+124>>2]=c;f[j+128>>2]=d;d=f[m>>2]|0;if((d|0)<3){v=Y(f[r>>2]|0,f[k>>2]|0)|0;w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);pma(j);u=h;return}k=f[b+40>>2]|0;b=0;r=1;while(1){m=Y(f[k+(b<<2)>>2]|0,r)|0;b=b+1|0;if((b|0)==(d|0)){v=m;break}else r=m}w=+(v>>>0);x=w*.0000152587890625;h3(i,j,x);pma(j);u=h;return}function pma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52680;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function qma(a){a=a|0;pma(a);cYc(a);return}function rma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;m=Y(c,d)|0;d=f[b>>2]|0;n=f[b+4>>2]|0;if((d|0)>=(n|0))return;b=f[a+76>>2]|0;o=f[a+108>>2]|0;q=a+20|0;r=a+48|0;s=a+128|0;t=k+-4|0;u=(k|0)<4;v=1.0/+(k|0);w=a+124|0;a=(h|0)>0;x=h<<3;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(o,d+D|0)|0)|0;F=b+(Y(o,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?l:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,G)|0)|0;J=f[s>>2]|0;if(u){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<3)|0;if(A){M=f[w>>2]|0;N=0.0;O=0;while(1){P=N+ +p[L+(f[M+(O<<2)>>2]<<3)>>3];O=O+1|0;if((O|0)==(k|0)){Q=P;break}else N=P}}else Q=0.0;p[F+(K<<3)>>3]=v*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;O=0;do{M=I+(f[J+(O<<2)>>2]<<3)|0;N=0.0;L=0;do{N=N+(+p[M+(f[K+(L<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|1)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|2)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|3)<<2)>>2]<<3)>>3]);L=L+4|0}while((L|0)<=(t|0));if(z){P=N;L=y;while(1){S=P+ +p[M+(f[K+(L<<2)>>2]<<3)>>3];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=N;p[F+(O<<3)>>3]=v*T;O=O+1|0}while((O|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){O=f[s>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<3)|0;if((f[O+(J<<2)>>2]|0)>=(m|0))p[I>>3]=0.0;p[I>>3]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[O+(U<<2)>>2]|0;c:do if((J|0)<(m|0)){I=0;L=0;P=0.0;while(1){M=I+G|0;if((M|0)>=(e|0)){V=L;W=P;break c}X=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,M)|0)+(J<<3)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=0;_=L;S=P;while(1){$=S+ +p[X+(Z<<3)>>3];aa=_+1|0;Z=Z+c|0;if(!((Z+J|0)<(m|0)&(Z|0)<(M|0))){ba=aa;ca=$;break}else{_=aa;S=$}}}else{ba=L;ca=P}I=I+1|0;if((I|0)>=(K|0)){V=ba;W=ca;break}else{L=ba;P=ca}}}else{p[F+(U<<3)>>3]=0.0;V=0;W=0.0}while(0);p[F+(U<<3)>>3]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)g1c(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(n|0))break;else D=D+1|0}return}function sma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52700;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function tma(a){a=a|0;sma(a);cYc(a);return}function uma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=1.0/+(k|0);m=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;o=Y(c,d)|0;d=f[b>>2]|0;p=f[b+4>>2]|0;if((d|0)>=(p|0))return;b=f[a+76>>2]|0;q=f[a+108>>2]|0;r=a+20|0;s=a+48|0;t=a+128|0;u=k+-4|0;v=(k|0)<4;w=a+124|0;a=(h|0)>0;x=h<<2;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(q,d+D|0)|0)|0;F=b+(Y(q,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?m:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,G)|0)|0;J=f[t>>2]|0;if(v){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<2)|0;if(A){M=f[w>>2]|0;N=0.0;O=0;while(1){P=N+ +n[L+(f[M+(O<<2)>>2]<<2)>>2];O=O+1|0;if((O|0)==(k|0)){Q=P;break}else N=P}}else Q=0.0;n[F+(K<<2)>>2]=l*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;O=0;do{M=I+(f[J+(O<<2)>>2]<<2)|0;N=0.0;L=0;do{N=N+(+n[M+(f[K+(L<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|1)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|2)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|3)<<2)>>2]<<2)>>2]);L=L+4|0}while((L|0)<=(u|0));if(z){P=N;L=y;while(1){S=P+ +n[M+(f[K+(L<<2)>>2]<<2)>>2];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=N;n[F+(O<<2)>>2]=l*T;O=O+1|0}while((O|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){O=f[t>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<2)|0;if((f[O+(J<<2)>>2]|0)>=(o|0))n[I>>2]=0.0;n[I>>2]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[O+(U<<2)>>2]|0;c:do if((J|0)<(o|0)){I=0;L=0;P=0.0;while(1){M=I+G|0;if((M|0)>=(e|0)){V=L;W=P;break c}X=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,M)|0)+(J<<2)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=0;_=L;S=P;while(1){$=S+ +n[X+(Z<<2)>>2];aa=_+1|0;Z=Z+c|0;if(!((Z+J|0)<(o|0)&(Z|0)<(M|0))){ba=aa;ca=$;break}else{_=aa;S=$}}}else{ba=L;ca=P}I=I+1|0;if((I|0)>=(K|0)){V=ba;W=ca;break}else{L=ba;P=ca}}}else{n[F+(U<<2)>>2]=0.0;V=0;W=0.0}while(0);n[F+(U<<2)>>2]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)g1c(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(p|0))break;else D=D+1|0}return}function vma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52720;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function wma(a){a=a|0;vma(a);cYc(a);return}function xma(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0,X=0,Z=0.0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;k=(h&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[g+8>>2]=k;f[g+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(h&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[g+12>>0]=v;v=f[c>>2]|0;h=c+4|0;if((v|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=s<<1;D=p&-4;E=(D|0)<(p|0);F=(p|0)>0;G=v;v=o;while(1){o=(f[c>>2]|0)+(Y(f[m>>2]|0,G)|0)|0;H=Y(v,G)|0;I=(H+v|0)<=(j|0)?r:0;b:do if((H|0)<(j|0)){J=yma(g,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0,o,I)|0;c:do if((J|0)<(I|0)){K=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0;L=f[x>>2]|0;if(z){M=J;while(1){N=K+(f[L+(M<<2)>>2]<<1)|0;if(F){O=f[A>>2]|0;P=0.0;Q=0;while(1){R=P+ +(d[N+(f[O+(Q<<2)>>2]<<1)>>1]|0);Q=Q+1|0;if((Q|0)==(p|0)){S=R;break}else P=R}}else S=0.0;Q=ALc(q*S)|0;d[o+(M<<1)>>1]=(Q+32768|0)>>>0<65536?Q:(Q|0)>0?32767:32768;M=M+1|0;if((M|0)==(I|0)){T=I;break c}}}M=f[A>>2]|0;Q=J;do{O=K+(f[L+(Q<<2)>>2]<<1)|0;P=0.0;N=0;do{P=P+ +((d[O+(f[M+((N|1)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|2)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|3)<<2)>>2]<<1)>>1]|0)|0);N=N+4|0}while((N|0)<=(y|0));if(E){R=P;N=D;while(1){U=R+ +(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0);N=N+1|0;if((N|0)==(p|0)){V=U;break}else R=U}}else V=P;N=ALc(q*V)|0;d[o+(Q<<1)>>1]=(N+32768|0)>>>0<65536?N:(N|0)>0?32767:32768;Q=Q+1|0}while((Q|0)!=(I|0));T=I}else T=J;while(0);if((T|0)<(s|0)){J=f[x>>2]|0;Q=f[n>>2]|0;if((Q|0)>0)W=T;else{M=ALc(C)|0;L=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=T;while(1){K=o+(M<<1)|0;if((f[J+(M<<2)>>2]|0)>=(t|0))d[K>>1]=0;d[K>>1]=L;M=M+1|0;if((M|0)==(s|0))break b}}do{M=f[J+(W<<2)>>2]|0;d:do if((M|0)<(t|0)){L=0;K=0;R=0.0;while(1){N=L+H|0;if((N|0)>=(j|0)){X=K;Z=R;break d}O=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,N)|0)+(M<<1)|0;N=Y(f[l>>2]|0,k)|0;if((N|0)>0){_=0;$=K;U=R;while(1){aa=U+ +(d[O+(_<<1)>>1]|0);ba=$+1|0;_=_+k|0;if(!((_+M|0)<(t|0)&(_|0)<(N|0))){ca=ba;da=aa;break}else{$=ba;U=aa}}}else{ca=K;da=R}L=L+1|0;if((L|0)>=(Q|0)){X=ca;Z=da;break}else{K=ca;R=da}}}else{d[o+(W<<1)>>1]=0;X=0;Z=0.0}while(0);M=ALc(Z/+(X|0))|0;d[o+(W<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;W=W+1|0}while((W|0)!=(s|0))}}else if(a)g1c(o|0,0,B|0)|0;while(0);o=G+1|0;if((o|0)>=(f[h>>2]|0))break;G=o;v=f[n>>2]|0}u=e;return}function yma(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){j=0;u=h;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)l=0;else{j=0;u=h;return j|0}do{a=l<<1;m=a|1;d[e+(l<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;l=l+1|0}while((l|0)!=(g|0));j=g;u=h;return j|0}case 3:{if((g|0)>0)n=0;else{j=0;u=h;return j|0}while(1){l=n<<1;m=l+3|0;d[e+(n<<1)>>1]=((d[c+(l<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(l<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=l|1;a=l+4|0;d[e+(n+1<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;a=l+2|0;m=l+5|0;d[e+(n+2<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n+3|0;if((m|0)<(g|0))n=m;else{j=m;break}}u=h;return j|0}case 4:{if((g|0)>0)o=0;else{j=0;u=h;return j|0}do{n=o<<1;m=n|4;d[e+(o<<1)>>1]=((d[c+(n<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n|1;a=n|5;d[e+((o|1)<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;a=n|2;m=n|6;d[e+((o|2)<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n|3;a=n|7;d[e+((o|3)<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;o=o+4|0}while((o|0)<(g|0));j=g+3&-4;u=h;return j|0}default:{f[i+8>>2]=0;b[i+11>>0]=7;b[i>>0]=b[266746]|0;b[i+1>>0]=b[266747]|0;b[i+2>>0]=b[266748]|0;b[i+3>>0]=b[266749]|0;b[i+4>>0]=b[266750]|0;b[i+5>>0]=b[266751]|0;b[i+6>>0]=b[266752]|0;b[i+7>>0]=0;vM(-215,i,528391,264471,2630)}}return 0}function zma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52740;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Ama(a){a=a|0;zma(a);cYc(a);return}function Bma(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0,Z=0,_=0.0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;k=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;l=(h&511)+1|0;m=a+116|0;n=f[m>>2]|0;o=a+120|0;p=f[o>>2]|0;q=Y(p,n)|0;r=1.0/+(q|0);s=Y((i|0)/(n|0)|0,l)|0;t=Y(l,f[(f[a+100>>2]|0)+4>>2]|0)|0;v=Y(l,i)|0;i=f[a+52>>2]|0;f[g>>2]=n;f[g+4>>2]=p;f[g+8>>2]=l;f[g+16>>2]=i;a:do if((n|0)==2&(p|0)==2){switch(h&511){case 2:case 0:{w=1;break a;break}default:{}}w=(l|0)==4&1}else w=0;while(0);b[g+12>>0]=w;w=f[c>>2]|0;h=c+4|0;if((w|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;n=a+108|0;i=a+20|0;x=a+48|0;y=a+128|0;z=q+-4|0;A=(q|0)<4;B=a+124|0;a=(t|0)>0;D=t<<1;E=q&-4;F=(E|0)<(q|0);G=(q|0)>0;H=w;w=p;while(1){p=(f[c>>2]|0)+(Y(f[n>>2]|0,H)|0)|0;I=Y(w,H)|0;J=(I+w|0)<=(k|0)?s:0;b:do if((I|0)<(k|0)){K=Cma(g,(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0,p,J)|0;c:do if((K|0)<(J|0)){L=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0;M=f[y>>2]|0;if(A){N=K;while(1){O=L+(f[M+(N<<2)>>2]<<1)|0;if(G){P=f[B>>2]|0;Q=0.0;R=0;while(1){S=Q+ +(j[O+(f[P+(R<<2)>>2]<<1)>>1]|0);R=R+1|0;if((R|0)==(q|0)){T=S;break}else Q=S}}else T=0.0;R=ALc(r*T)|0;d[p+(N<<1)>>1]=R>>>0<65536?R:(R|0)>0?65535:0;N=N+1|0;if((N|0)==(J|0)){U=J;break c}}}N=f[B>>2]|0;R=K;do{P=L+(f[M+(R<<2)>>2]<<1)|0;Q=0.0;O=0;do{Q=Q+ +((j[P+(f[N+((O|1)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|2)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|3)<<2)>>2]<<1)>>1]|0)|0);O=O+4|0}while((O|0)<=(z|0));if(F){S=Q;O=E;while(1){V=S+ +(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0);O=O+1|0;if((O|0)==(q|0)){W=V;break}else S=V}}else W=Q;O=ALc(r*W)|0;d[p+(R<<1)>>1]=O>>>0<65536?O:(O|0)>0?65535:0;R=R+1|0}while((R|0)!=(J|0));U=J}else U=K;while(0);if((U|0)<(t|0)){K=f[y>>2]|0;R=f[o>>2]|0;if((R|0)>0)X=U;else{N=ALc(C)|0;M=(N>>>0<65536?N:(N|0)>0?65535:0)&65535;N=U;while(1){L=p+(N<<1)|0;if((f[K+(N<<2)>>2]|0)>=(v|0))d[L>>1]=0;d[L>>1]=M;N=N+1|0;if((N|0)==(t|0))break b}}do{N=f[K+(X<<2)>>2]|0;d:do if((N|0)<(v|0)){M=0;L=0;S=0.0;while(1){O=M+I|0;if((O|0)>=(k|0)){Z=L;_=S;break d}P=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,O)|0)+(N<<1)|0;O=Y(f[m>>2]|0,l)|0;if((O|0)>0){$=0;aa=L;V=S;while(1){ba=V+ +(j[P+($<<1)>>1]|0);ca=aa+1|0;$=$+l|0;if(!(($+N|0)<(v|0)&($|0)<(O|0))){da=ca;ea=ba;break}else{aa=ca;V=ba}}}else{da=L;ea=S}M=M+1|0;if((M|0)>=(R|0)){Z=da;_=ea;break}else{L=da;S=ea}}}else{d[p+(X<<1)>>1]=0;Z=0;_=0.0}while(0);N=ALc(_/+(Z|0))|0;d[p+(X<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;X=X+1|0}while((X|0)!=(t|0))}}else if(a)g1c(p|0,0,D|0)|0;while(0);p=H+1|0;if((p|0)>=(f[h>>2]|0))break;H=p;w=f[o>>2]|0}u=e;return}function Cma(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){k=0;u=h;return k|0}l=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)m=0;else{k=0;u=h;return k|0}do{a=m<<1;n=a|1;d[e+(m<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;m=m+1|0}while((m|0)!=(g|0));k=g;u=h;return k|0}case 3:{if((g|0)>0)o=0;else{k=0;u=h;return k|0}while(1){m=o<<1;n=m+3|0;d[e+(o<<1)>>1]=((j[c+(m<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(m<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=m|1;a=m+4|0;d[e+(o+1<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;a=m+2|0;n=m+5|0;d[e+(o+2<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o+3|0;if((n|0)<(g|0))o=n;else{k=n;break}}u=h;return k|0}case 4:{if((g|0)>0)p=0;else{k=0;u=h;return k|0}do{o=p<<1;n=o|4;d[e+(p<<1)>>1]=((j[c+(o<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o|1;a=o|5;d[e+((p|1)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;a=o|2;n=o|6;d[e+((p|2)<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o|3;a=o|7;d[e+((p|3)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;p=p+4|0}while((p|0)<(g|0));k=g+3&-4;u=h;return k|0}default:{f[i+8>>2]=0;b[i+11>>0]=7;b[i>>0]=b[266746]|0;b[i+1>>0]=b[266747]|0;b[i+2>>0]=b[266748]|0;b[i+3>>0]=b[266749]|0;b[i+4>>0]=b[266750]|0;b[i+5>>0]=b[266751]|0;b[i+6>>0]=b[266752]|0;b[i+7>>0]=0;vM(-215,i,528391,264471,2630)}}return 0}function Dma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52760;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Ema(a){a=a|0;Dma(a);cYc(a);return}function Fma(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+32|0;e=d;g=f[a+44>>2]|0;i=f[g+4>>2]|0;j=f[g>>2]|0;g=(f[a+4>>2]|0)>>>3;k=(g&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[e>>2]=m;f[e+4>>2]=o;f[e+8>>2]=k;f[e+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(g&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[e+12>>0]=v;v=f[c>>2]|0;g=c+4|0;if((v|0)>=(f[g>>2]|0)){u=d;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=p&-4;C=(p|0)>0;D=(B|0)<(p|0);E=v;v=o;while(1){o=(f[c>>2]|0)+(Y(f[m>>2]|0,E)|0)|0;F=Y(v,E)|0;G=(F+v|0)<=(j|0)?r:0;if((F|0)<(j|0)){H=Gma(e,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0,o,G)|0;b:do if((H|0)<(G|0)){if(z){I=H;while(1){J=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;K=J+(f[(f[x>>2]|0)+(I<<2)>>2]|0)|0;if(C){J=f[A>>2]|0;L=0;M=0;while(1){N=(h[K+(f[J+(M<<2)>>2]|0)>>0]|0)+L|0;M=M+1|0;if((M|0)==(p|0)){O=N;break}else L=N}}else O=0;L=ALc(q*+(O|0))|0;b[o+I>>0]=L>>>0<256?L:(L|0)>0?255:0;I=I+1|0;if((I|0)==(G|0)){P=G;break b}}}else Q=H;do{I=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;L=I+(f[(f[x>>2]|0)+(Q<<2)>>2]|0)|0;I=f[A>>2]|0;M=0;J=0;do{M=(h[L+(f[I+(J<<2)>>2]|0)>>0]|0)+M+(h[L+(f[I+((J|1)<<2)>>2]|0)>>0]|0)+(h[L+(f[I+((J|2)<<2)>>2]|0)>>0]|0)+(h[L+(f[I+((J|3)<<2)>>2]|0)>>0]|0)|0;J=J+4|0}while((J|0)<=(y|0));if(D){J=M;K=B;while(1){N=(h[L+(f[I+(K<<2)>>2]|0)>>0]|0)+J|0;K=K+1|0;if((K|0)==(p|0)){R=N;break}else J=N}}else R=M;J=ALc(q*+(R|0))|0;b[o+Q>>0]=J>>>0<256?J:(J|0)>0?255:0;Q=Q+1|0}while((Q|0)!=(G|0));P=G}else P=H;while(0);if((P|0)<(s|0)){H=P;do{G=f[(f[x>>2]|0)+(H<<2)>>2]|0;J=(G|0)<(t|0);if(!J)b[o+H>>0]=0;K=f[n>>2]|0;c:do if((K|0)<1|J^1){S=0;T=0}else{I=0;L=0;N=0;while(1){U=I+F|0;if((U|0)>=(j|0)){S=L;T=N;break c}V=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,U)|0)+G|0;U=Y(f[l>>2]|0,k)|0;if((U|0)>0){W=0;X=L;Z=N;while(1){_=(h[V+W>>0]|0)+Z|0;$=X+1|0;W=W+k|0;if(!((W+G|0)<(t|0)&(W|0)<(U|0))){aa=$;ba=_;break}else{X=$;Z=_}}}else{aa=L;ba=N}I=I+1|0;if((I|0)>=(K|0)){S=aa;T=ba;break}else{L=aa;N=ba}}}while(0);K=ALc(+(T|0)/+(S|0))|0;b[o+H>>0]=K>>>0<256?K:(K|0)>0?255:0;H=H+1|0}while((H|0)!=(s|0))}}else if(a)g1c(o|0,0,s|0)|0;H=E+1|0;if((H|0)>=(f[g>>2]|0))break;E=H;v=f[n>>2]|0}u=d;return}function Gma(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;i=g;if(!(b[a+12>>0]|0)){j=0;u=g;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((e|0)>0)l=0;else{j=0;u=g;return j|0}do{a=l<<1;m=a|1;b[d+l>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;l=l+1|0}while((l|0)!=(e|0));j=e;u=g;return j|0}case 3:{if((e|0)>0)n=0;else{j=0;u=g;return j|0}while(1){l=n<<1;m=l+3|0;b[d+n>>0]=((h[c+l>>0]|0)+2+(h[c+m>>0]|0)+(h[k+l>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=l|1;a=l+4|0;b[d+(n+1)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;a=l+2|0;m=l+5|0;b[d+(n+2)>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n+3|0;if((m|0)<(e|0))n=m;else{j=m;break}}u=g;return j|0}case 4:{if((e|0)>0)o=0;else{j=0;u=g;return j|0}do{n=o<<1;m=n|4;b[d+o>>0]=((h[c+n>>0]|0)+2+(h[c+m>>0]|0)+(h[k+n>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n|1;a=n|5;b[d+(o|1)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;a=n|2;m=n|6;b[d+(o|2)>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n|3;a=n|7;b[d+(o|3)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;o=o+4|0}while((o|0)<(e|0));j=e+3&-4;u=g;return j|0}default:{f[i+8>>2]=0;b[i+11>>0]=7;b[i>>0]=b[266746]|0;b[i+1>>0]=b[266747]|0;b[i+2>>0]=b[266748]|0;b[i+3>>0]=b[266749]|0;b[i+4>>0]=b[266750]|0;b[i+5>>0]=b[266751]|0;b[i+6>>0]=b[266752]|0;b[i+7>>0]=0;vM(-215,i,528391,264471,2630)}}return 0}function Hma(a){a=a|0;aka(a);cYc(a);return}function Ima(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=f[(f[a+100>>2]|0)+4>>2]|0;g=f[a+8>>2]|0;if((g|0)>0)h=f[(f[a+48>>2]|0)+(g+-1<<2)>>2]|0;else h=0;g=f[c>>2]|0;i=c+4|0;if((g|0)>=(f[i>>2]|0))return;c=a+76|0;j=a+108|0;k=a+128|0;l=(f[f[a+44>>2]>>2]|0)+-1|0;m=a+20|0;n=a+48|0;o=(e|0)>0;q=a+116|0;r=a+120|0;a=e+-2|0;s=(e|0)<2;t=e&-2;u=g;do{g=(f[c>>2]|0)+(Y(f[j>>2]|0,u)|0)|0;v=+(u|0)*+p[k>>3];w=~~v;x=w-(+(w|0)>v&1)|0;w=(f[m>>2]|0)+(Y((l|0)<(x|0)?l:x,f[f[n>>2]>>2]|0)|0)|0;switch(h|0){case 1:{if(s)y=0;else{x=0;do{z=f[q>>2]|0;A=x|1;B=b[w+(f[z+(A<<2)>>2]|0)>>0]|0;b[g+x>>0]=b[w+(f[z+(x<<2)>>2]|0)>>0]|0;b[g+A>>0]=B;x=x+2|0}while((x|0)<=(a|0));y=t}if((y|0)<(e|0)){x=y;do{b[g+x>>0]=b[w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)>>0]|0;x=x+1|0}while((x|0)!=(e|0))}break}case 2:{if(o){x=f[q>>2]|0;B=0;do{d[g+(B<<1)>>1]=d[w+(f[x+(B<<2)>>2]|0)>>1]|0;B=B+1|0}while((B|0)!=(e|0))}break}case 3:{if(o){B=g;x=0;while(1){A=w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;x=x+1|0;if((x|0)==(e|0))break;else B=B+3|0}}break}case 4:{if(o){B=f[q>>2]|0;x=0;do{f[g+(x<<2)>>2]=f[w+(f[B+(x<<2)>>2]|0)>>2];x=x+1|0}while((x|0)!=(e|0))}break}case 6:{if(o){x=f[q>>2]|0;B=g;A=0;while(1){z=w+(f[x+(A<<2)>>2]|0)|0;d[B>>1]=d[z>>1]|0;d[B+2>>1]=d[z+2>>1]|0;d[B+4>>1]=d[z+4>>1]|0;A=A+1|0;if((A|0)==(e|0))break;else B=B+6|0}}break}case 8:{if(o){B=f[q>>2]|0;A=g;x=0;while(1){z=w+(f[B+(x<<2)>>2]|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];x=x+1|0;if((x|0)==(e|0))break;else A=A+8|0}}break}case 12:{if(o){A=f[q>>2]|0;x=g;B=0;while(1){z=w+(f[A+(B<<2)>>2]|0)|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2];f[x+8>>2]=f[z+8>>2];B=B+1|0;if((B|0)==(e|0))break;else x=x+12|0}}break}default:if(o){x=f[q>>2]|0;B=g;A=0;z=f[r>>2]|0;while(1){C=w+(f[x+(A<<2)>>2]|0)|0;if((z|0)>0){D=0;do{f[B+(D<<2)>>2]=f[C+(D<<2)>>2];D=D+1|0;E=f[r>>2]|0}while((D|0)<(E|0));F=E}else F=z;A=A+1|0;if((A|0)==(e|0))break;else{B=B+h|0;z=F}}}}u=u+1|0}while((u|0)<(f[i>>2]|0));return}function Jma(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?173:172;break}case 2:{t=(c|0)>2?175:174;break}case 3:{t=(c|0)>2?177:176;break}case 4:{t=(c|0)>2?179:178;break}default:t=(c|0)>2?181:180}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;_Gc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;_Gc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=i+h<<3;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=bYc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<2)|0;if((h|0)>0){F=0;do{Wna(q,F,D+(F<<2)|0,z+(F<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Wna(r,w,C+(w<<2)|0,E+(w<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=52860;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;h3(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)dYc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function Kma(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?183:182;break}case 2:{t=(c|0)>2?185:184;break}case 3:{t=(c|0)>2?187:186;break}case 4:{t=(c|0)>2?189:188;break}default:t=(c|0)>2?191:190}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;_Gc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;_Gc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=bYc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{Jna(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Jna(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=52840;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;h3(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)dYc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function Lma(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?193:192;break}case 2:{t=(c|0)>2?195:194;break}case 3:{t=(c|0)>2?197:196;break}case 4:{t=(c|0)>2?199:198;break}default:t=(c|0)>2?201:200}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;_Gc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;_Gc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=bYc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{wna(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{wna(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=52820;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;h3(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)dYc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function Mma(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?203:202;break}case 2:{t=(c|0)>2?205:204;break}case 3:{t=(c|0)>2?207:206;break}case 4:{t=(c|0)>2?209:208;break}default:t=(c|0)>2?211:210}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;_Gc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;_Gc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=bYc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{jna(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{jna(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=52800;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;h3(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)dYc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function Nma(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?213:212;break}case 2:{t=(c|0)>2?215:214;break}case 3:{t=(c|0)>2?217:216;break}case 4:{t=(c|0)>2?219:218;break}default:t=(c|0)>2?221:220}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;_Gc(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;_Gc(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*20|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=bYc(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<3)|0;if((h|0)>0){F=0;do{Yma(q,F,D+(F<<2)|0,z+(F<<1<<3)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Yma(r,w,C+(w<<2)|0,E+(w<<1<<3)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=52780;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;h3(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)dYc(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function Oma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=f[a>>2]|0;if((g|0)>0){j=0;k=e;while(1){l=k;f[l>>2]=0;f[l+4>>2]=b;j=j+1|0;if((j|0)==(g|0))break;else k=k+8|0}m=d+(g<<1<<3)|0;n=g;o=e+(g<<3)|0}else{m=d;n=0;o=e}if((n|0)<(h|0)){e=m;m=n;d=o;while(1){g=a+(f[c+(m<<2)>>2]<<2)|0;k=e;j=f[k>>2]|0;b=f[k+4>>2]|0;k=f[g>>2]|0;l=(b|0)<0;p=(k|0)<0;q=c1c(0,0,j|0,b|0)|0;r=l?q:j;q=l?J:b;l=c1c(0,0,0,k|0)|0;l=J;s=p?l:k;l=k^b;b=x1c(s|0,0,r|0,0)|0;r=J;k=x1c(s|0,0,q|0,0)|0;q=J;s=d1c(k|0,0,r|0,0)|0;r=J|q;if(r>>>0>0|(r|0)==0&(s|k)>>>0>2147483647){k=l1c(j|0,l|0,63)|0;j=d1c(k|0,J|0,-1,2147483647)|0;t=J;u=j}else{j=(l|0)<0;l=c1c(0,0,b|0,s|0)|0;t=j?J:s;u=j?l:b}b=e+8|0;l=f[b>>2]|0;j=f[b+4>>2]|0;b=f[g+4>>2]|0;g=(j|0)<0;s=(b|0)<0;k=c1c(0,0,l|0,j|0)|0;r=g?k:l;k=g?J:j;g=c1c(0,0,0,b|0)|0;g=J;q=s?g:b;g=b^j;j=x1c(q|0,0,r|0,0)|0;r=J;b=x1c(q|0,0,k|0,0)|0;k=J;q=d1c(b|0,0,r|0,0)|0;r=J|k;if(r>>>0>0|(r|0)==0&(q|b)>>>0>2147483647){b=l1c(l|0,g|0,63)|0;l=d1c(b|0,J|0,-1,2147483647)|0;v=l;w=J}else{l=(g|0)<0;g=c1c(0,0,j|0,q|0)|0;v=l?g:j;w=l?J:q}q=d1c(v|0,w|0,u|0,t|0)|0;l=J;j=((l^t)&(l^w)|0)<0;g=d;f[g>>2]=j?-1:q;f[g+4>>2]=j?(l|2147483647)^-2147483648:l;m=m+1|0;if((m|0)==(h|0))break;else{e=e+16|0;d=d+8|0}}x=h;y=o+(h-n<<3)|0}else{x=n;y=o}o=f[a+(f[c+(i+-1<<2)>>2]<<2)>>2]|0;if((x|0)<(i|0)){z=x;A=y}else return;while(1){y=A;f[y>>2]=0;f[y+4>>2]=o;z=z+1|0;if((z|0)==(i|0))break;else A=A+8|0}return}function Pma(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xma(a,b,c,d,e,f,g,h);return}function Qma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=f[a>>2]|0;j=f[a+4>>2]|0;if((g|0)>0){k=g<<1;l=0;m=e;while(1){n=m;f[n>>2]=0;f[n+4>>2]=b;n=m+8|0;f[n>>2]=0;f[n+4>>2]=j;l=l+1|0;if((l|0)==(g|0))break;else m=m+16|0}o=d+(k<<3)|0;p=g;q=e+(k<<3)|0}else{o=d;p=0;q=e}if((p|0)<(h|0)){e=h-p|0;d=p;k=q;g=o;while(1){o=a+(f[c+(d<<2)>>2]<<1<<2)|0;m=g;l=f[m>>2]|0;j=f[m+4>>2]|0;m=f[o>>2]|0;b=(j|0)<0;n=(m|0)<0;r=c1c(0,0,l|0,j|0)|0;s=b?r:l;r=b?J:j;b=c1c(0,0,0,m|0)|0;b=J;t=n?b:m;b=m^j;j=x1c(t|0,0,s|0,0)|0;s=J;m=x1c(t|0,0,r|0,0)|0;r=J;t=d1c(m|0,0,s|0,0)|0;s=J|r;if(s>>>0>0|(s|0)==0&(t|m)>>>0>2147483647){m=l1c(l|0,b|0,63)|0;l=d1c(m|0,J|0,-1,2147483647)|0;u=l;v=J}else{l=(b|0)<0;b=c1c(0,0,j|0,t|0)|0;u=l?b:j;v=l?J:t}t=g+8|0;l=t;j=f[l>>2]|0;b=f[l+4>>2]|0;l=f[o+8>>2]|0;m=(b|0)<0;s=(l|0)<0;r=c1c(0,0,j|0,b|0)|0;n=m?r:j;r=m?J:b;m=c1c(0,0,0,l|0)|0;m=J;w=s?m:l;m=l^b;b=x1c(w|0,0,n|0,0)|0;n=J;l=x1c(w|0,0,r|0,0)|0;r=J;w=d1c(l|0,0,n|0,0)|0;n=J|r;if(n>>>0>0|(n|0)==0&(w|l)>>>0>2147483647){l=l1c(j|0,m|0,63)|0;j=d1c(l|0,J|0,-1,2147483647)|0;x=j;y=J}else{j=(m|0)<0;m=c1c(0,0,b|0,w|0)|0;x=j?m:b;y=j?J:w}w=d1c(x|0,y|0,u|0,v|0)|0;j=J;b=((j^v)&(j^y)|0)<0;m=k;f[m>>2]=b?-1:w;f[m+4>>2]=b?(j|2147483647)^-2147483648:j;j=g;b=f[j>>2]|0;m=f[j+4>>2]|0;j=f[o+4>>2]|0;w=(m|0)<0;l=(j|0)<0;n=c1c(0,0,b|0,m|0)|0;r=w?n:b;n=w?J:m;w=c1c(0,0,0,j|0)|0;w=J;s=l?w:j;w=j^m;m=x1c(s|0,0,r|0,0)|0;r=J;j=x1c(s|0,0,n|0,0)|0;n=J;s=d1c(j|0,0,r|0,0)|0;r=J|n;if(r>>>0>0|(r|0)==0&(s|j)>>>0>2147483647){j=l1c(b|0,w|0,63)|0;b=d1c(j|0,J|0,-1,2147483647)|0;z=b;A=J}else{b=(w|0)<0;w=c1c(0,0,m|0,s|0)|0;z=b?w:m;A=b?J:s}s=t;t=f[s>>2]|0;b=f[s+4>>2]|0;s=f[o+12>>2]|0;o=(b|0)<0;m=(s|0)<0;w=c1c(0,0,t|0,b|0)|0;j=o?w:t;w=o?J:b;o=c1c(0,0,0,s|0)|0;o=J;r=m?o:s;o=s^b;b=x1c(r|0,0,j|0,0)|0;j=J;s=x1c(r|0,0,w|0,0)|0;w=J;r=d1c(s|0,0,j|0,0)|0;j=J|w;if(j>>>0>0|(j|0)==0&(r|s)>>>0>2147483647){s=l1c(t|0,o|0,63)|0;t=d1c(s|0,J|0,-1,2147483647)|0;B=t;C=J}else{t=(o|0)<0;o=c1c(0,0,b|0,r|0)|0;B=t?o:b;C=t?J:r}r=d1c(B|0,C|0,z|0,A|0)|0;t=J;b=((t^A)&(t^C)|0)<0;o=k+8|0;f[o>>2]=b?-1:r;f[o+4>>2]=b?(t|2147483647)^-2147483648:t;d=d+1|0;if((d|0)==(h|0))break;else{k=k+16|0;g=g+16|0}}D=h;E=q+(e<<1<<3)|0}else{D=p;E=q}q=a+(f[c+(i+-1<<2)>>2]<<1<<2)|0;c=f[q>>2]|0;a=f[q+4>>2]|0;if((D|0)<(i|0)){F=E;G=D}else return;while(1){D=F;f[D>>2]=0;f[D+4>>2]=c;D=F+8|0;f[D>>2]=0;f[D+4>>2]=a;G=G+1|0;if((G|0)==(i|0))break;else F=F+16|0}return}function Rma(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xma(a,b,c,d,e,f,g,h);return}function Sma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;b=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;if((g|0)>0){l=g*3|0;m=0;n=e;while(1){o=n;f[o>>2]=0;f[o+4>>2]=b;o=n+8|0;f[o>>2]=0;f[o+4>>2]=j;o=n+16|0;f[o>>2]=0;f[o+4>>2]=k;m=m+1|0;if((m|0)==(g|0))break;else n=n+24|0}p=d+(g<<1<<3)|0;q=g;r=e+(l<<3)|0}else{p=d;q=0;r=e}if((q|0)<(h|0)){e=h-q|0;d=q;l=r;g=p;while(1){p=a+((f[c+(d<<2)>>2]|0)*3<<2)|0;n=g;m=f[n>>2]|0;k=f[n+4>>2]|0;n=f[p>>2]|0;j=(k|0)<0;b=(n|0)<0;o=c1c(0,0,m|0,k|0)|0;s=j?o:m;o=j?J:k;j=c1c(0,0,0,n|0)|0;j=J;t=b?j:n;j=n^k;k=x1c(t|0,0,s|0,0)|0;s=J;n=x1c(t|0,0,o|0,0)|0;o=J;t=d1c(n|0,0,s|0,0)|0;s=J|o;if(s>>>0>0|(s|0)==0&(t|n)>>>0>2147483647){n=l1c(m|0,j|0,63)|0;m=d1c(n|0,J|0,-1,2147483647)|0;u=m;v=J}else{m=(j|0)<0;j=c1c(0,0,k|0,t|0)|0;u=m?j:k;v=m?J:t}t=g+8|0;m=t;k=f[m>>2]|0;j=f[m+4>>2]|0;m=f[p+12>>2]|0;n=(j|0)<0;s=(m|0)<0;o=c1c(0,0,k|0,j|0)|0;b=n?o:k;o=n?J:j;n=c1c(0,0,0,m|0)|0;n=J;w=s?n:m;n=m^j;j=x1c(w|0,0,b|0,0)|0;b=J;m=x1c(w|0,0,o|0,0)|0;o=J;w=d1c(m|0,0,b|0,0)|0;b=J|o;if(b>>>0>0|(b|0)==0&(w|m)>>>0>2147483647){m=l1c(k|0,n|0,63)|0;k=d1c(m|0,J|0,-1,2147483647)|0;x=k;y=J}else{k=(n|0)<0;n=c1c(0,0,j|0,w|0)|0;x=k?n:j;y=k?J:w}w=d1c(x|0,y|0,u|0,v|0)|0;k=J;j=((k^v)&(k^y)|0)<0;n=l;f[n>>2]=j?-1:w;f[n+4>>2]=j?(k|2147483647)^-2147483648:k;k=g;j=f[k>>2]|0;n=f[k+4>>2]|0;k=f[p+4>>2]|0;w=(n|0)<0;m=(k|0)<0;b=c1c(0,0,j|0,n|0)|0;o=w?b:j;b=w?J:n;w=c1c(0,0,0,k|0)|0;w=J;s=m?w:k;w=k^n;n=x1c(s|0,0,o|0,0)|0;o=J;k=x1c(s|0,0,b|0,0)|0;b=J;s=d1c(k|0,0,o|0,0)|0;o=J|b;if(o>>>0>0|(o|0)==0&(s|k)>>>0>2147483647){k=l1c(j|0,w|0,63)|0;j=d1c(k|0,J|0,-1,2147483647)|0;z=j;A=J}else{j=(w|0)<0;w=c1c(0,0,n|0,s|0)|0;z=j?w:n;A=j?J:s}s=t;j=f[s>>2]|0;n=f[s+4>>2]|0;s=f[p+16>>2]|0;w=(n|0)<0;k=(s|0)<0;o=c1c(0,0,j|0,n|0)|0;b=w?o:j;o=w?J:n;w=c1c(0,0,0,s|0)|0;w=J;m=k?w:s;w=s^n;n=x1c(m|0,0,b|0,0)|0;b=J;s=x1c(m|0,0,o|0,0)|0;o=J;m=d1c(s|0,0,b|0,0)|0;b=J|o;if(b>>>0>0|(b|0)==0&(m|s)>>>0>2147483647){s=l1c(j|0,w|0,63)|0;j=d1c(s|0,J|0,-1,2147483647)|0;B=j;C=J}else{j=(w|0)<0;w=c1c(0,0,n|0,m|0)|0;B=j?w:n;C=j?J:m}m=d1c(B|0,C|0,z|0,A|0)|0;j=J;n=((j^A)&(j^C)|0)<0;w=l+8|0;f[w>>2]=n?-1:m;f[w+4>>2]=n?(j|2147483647)^-2147483648:j;j=g;n=f[j>>2]|0;w=f[j+4>>2]|0;j=f[p+8>>2]|0;m=(w|0)<0;s=(j|0)<0;b=c1c(0,0,n|0,w|0)|0;o=m?b:n;b=m?J:w;m=c1c(0,0,0,j|0)|0;m=J;k=s?m:j;m=j^w;w=x1c(k|0,0,o|0,0)|0;o=J;j=x1c(k|0,0,b|0,0)|0;b=J;k=d1c(j|0,0,o|0,0)|0;o=J|b;if(o>>>0>0|(o|0)==0&(k|j)>>>0>2147483647){j=l1c(n|0,m|0,63)|0;n=d1c(j|0,J|0,-1,2147483647)|0;D=n;E=J}else{n=(m|0)<0;m=c1c(0,0,w|0,k|0)|0;D=n?m:w;E=n?J:k}k=t;t=f[k>>2]|0;n=f[k+4>>2]|0;k=f[p+20>>2]|0;p=(n|0)<0;w=(k|0)<0;m=c1c(0,0,t|0,n|0)|0;j=p?m:t;m=p?J:n;p=c1c(0,0,0,k|0)|0;p=J;o=w?p:k;p=k^n;n=x1c(o|0,0,j|0,0)|0;j=J;k=x1c(o|0,0,m|0,0)|0;m=J;o=d1c(k|0,0,j|0,0)|0;j=J|m;if(j>>>0>0|(j|0)==0&(o|k)>>>0>2147483647){k=l1c(t|0,p|0,63)|0;t=d1c(k|0,J|0,-1,2147483647)|0;F=t;G=J}else{t=(p|0)<0;p=c1c(0,0,n|0,o|0)|0;F=t?p:n;G=t?J:o}o=d1c(F|0,G|0,D|0,E|0)|0;t=J;n=((t^E)&(t^G)|0)<0;p=l+16|0;f[p>>2]=n?-1:o;f[p+4>>2]=n?(t|2147483647)^-2147483648:t;d=d+1|0;if((d|0)==(h|0))break;else{l=l+24|0;g=g+16|0}}H=h;I=r+(e*3<<3)|0}else{H=q;I=r}r=a+((f[c+(i+-1<<2)>>2]|0)*3<<2)|0;c=f[r>>2]|0;a=f[r+4>>2]|0;q=f[r+8>>2]|0;if((H|0)<(i|0)){K=I;L=H}else return;while(1){H=K;f[H>>2]=0;f[H+4>>2]=c;H=K+8|0;f[H>>2]=0;f[H+4>>2]=a;H=K+16|0;f[H>>2]=0;f[H+4>>2]=q;L=L+1|0;if((L|0)==(i|0))break;else K=K+24|0}return}function Tma(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xma(a,b,c,d,e,f,g,h);return}function Uma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;b=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;l=f[a+12>>2]|0;if((g|0)>0){m=g<<2;n=0;o=e;while(1){p=o;f[p>>2]=0;f[p+4>>2]=b;p=o+8|0;f[p>>2]=0;f[p+4>>2]=j;p=o+16|0;f[p>>2]=0;f[p+4>>2]=k;p=o+24|0;f[p>>2]=0;f[p+4>>2]=l;n=n+1|0;if((n|0)==(g|0))break;else o=o+32|0}q=d+(g<<1<<3)|0;r=g;s=e+(m<<3)|0}else{q=d;r=0;s=e}if((r|0)<(h|0)){e=h-r|0;d=q;q=r;m=s;while(1){g=a+(f[c+(q<<2)>>2]<<2<<2)|0;o=d;n=f[o>>2]|0;l=f[o+4>>2]|0;o=f[g>>2]|0;k=(l|0)<0;j=(o|0)<0;b=c1c(0,0,n|0,l|0)|0;p=k?b:n;b=k?J:l;k=c1c(0,0,0,o|0)|0;k=J;t=j?k:o;k=o^l;l=x1c(t|0,0,p|0,0)|0;p=J;o=x1c(t|0,0,b|0,0)|0;b=J;t=d1c(o|0,0,p|0,0)|0;p=J|b;if(p>>>0>0|(p|0)==0&(t|o)>>>0>2147483647){o=l1c(n|0,k|0,63)|0;n=d1c(o|0,J|0,-1,2147483647)|0;u=n;v=J}else{n=(k|0)<0;k=c1c(0,0,l|0,t|0)|0;u=n?k:l;v=n?J:t}t=d+8|0;n=t;l=f[n>>2]|0;k=f[n+4>>2]|0;n=f[g+16>>2]|0;o=(k|0)<0;p=(n|0)<0;b=c1c(0,0,l|0,k|0)|0;j=o?b:l;b=o?J:k;o=c1c(0,0,0,n|0)|0;o=J;w=p?o:n;o=n^k;k=x1c(w|0,0,j|0,0)|0;j=J;n=x1c(w|0,0,b|0,0)|0;b=J;w=d1c(n|0,0,j|0,0)|0;j=J|b;if(j>>>0>0|(j|0)==0&(w|n)>>>0>2147483647){n=l1c(l|0,o|0,63)|0;l=d1c(n|0,J|0,-1,2147483647)|0;x=l;y=J}else{l=(o|0)<0;o=c1c(0,0,k|0,w|0)|0;x=l?o:k;y=l?J:w}w=d1c(x|0,y|0,u|0,v|0)|0;l=J;k=((l^v)&(l^y)|0)<0;o=m;f[o>>2]=k?-1:w;f[o+4>>2]=k?(l|2147483647)^-2147483648:l;l=d;k=f[l>>2]|0;o=f[l+4>>2]|0;l=f[g+4>>2]|0;w=(o|0)<0;n=(l|0)<0;j=c1c(0,0,k|0,o|0)|0;b=w?j:k;j=w?J:o;w=c1c(0,0,0,l|0)|0;w=J;p=n?w:l;w=l^o;o=x1c(p|0,0,b|0,0)|0;b=J;l=x1c(p|0,0,j|0,0)|0;j=J;p=d1c(l|0,0,b|0,0)|0;b=J|j;if(b>>>0>0|(b|0)==0&(p|l)>>>0>2147483647){l=l1c(k|0,w|0,63)|0;k=d1c(l|0,J|0,-1,2147483647)|0;z=k;A=J}else{k=(w|0)<0;w=c1c(0,0,o|0,p|0)|0;z=k?w:o;A=k?J:p}p=t;k=f[p>>2]|0;o=f[p+4>>2]|0;p=f[g+20>>2]|0;w=(o|0)<0;l=(p|0)<0;b=c1c(0,0,k|0,o|0)|0;j=w?b:k;b=w?J:o;w=c1c(0,0,0,p|0)|0;w=J;n=l?w:p;w=p^o;o=x1c(n|0,0,j|0,0)|0;j=J;p=x1c(n|0,0,b|0,0)|0;b=J;n=d1c(p|0,0,j|0,0)|0;j=J|b;if(j>>>0>0|(j|0)==0&(n|p)>>>0>2147483647){p=l1c(k|0,w|0,63)|0;k=d1c(p|0,J|0,-1,2147483647)|0;B=k;C=J}else{k=(w|0)<0;w=c1c(0,0,o|0,n|0)|0;B=k?w:o;C=k?J:n}n=d1c(B|0,C|0,z|0,A|0)|0;k=J;o=((k^A)&(k^C)|0)<0;w=m+8|0;f[w>>2]=o?-1:n;f[w+4>>2]=o?(k|2147483647)^-2147483648:k;k=d;o=f[k>>2]|0;w=f[k+4>>2]|0;k=f[g+8>>2]|0;n=(w|0)<0;p=(k|0)<0;j=c1c(0,0,o|0,w|0)|0;b=n?j:o;j=n?J:w;n=c1c(0,0,0,k|0)|0;n=J;l=p?n:k;n=k^w;w=x1c(l|0,0,b|0,0)|0;b=J;k=x1c(l|0,0,j|0,0)|0;j=J;l=d1c(k|0,0,b|0,0)|0;b=J|j;if(b>>>0>0|(b|0)==0&(l|k)>>>0>2147483647){k=l1c(o|0,n|0,63)|0;o=d1c(k|0,J|0,-1,2147483647)|0;D=o;E=J}else{o=(n|0)<0;n=c1c(0,0,w|0,l|0)|0;D=o?n:w;E=o?J:l}l=t;o=f[l>>2]|0;w=f[l+4>>2]|0;l=f[g+24>>2]|0;n=(w|0)<0;k=(l|0)<0;b=c1c(0,0,o|0,w|0)|0;j=n?b:o;b=n?J:w;n=c1c(0,0,0,l|0)|0;n=J;p=k?n:l;n=l^w;w=x1c(p|0,0,j|0,0)|0;j=J;l=x1c(p|0,0,b|0,0)|0;b=J;p=d1c(l|0,0,j|0,0)|0;j=J|b;if(j>>>0>0|(j|0)==0&(p|l)>>>0>2147483647){l=l1c(o|0,n|0,63)|0;o=d1c(l|0,J|0,-1,2147483647)|0;F=o;G=J}else{o=(n|0)<0;n=c1c(0,0,w|0,p|0)|0;F=o?n:w;G=o?J:p}p=d1c(F|0,G|0,D|0,E|0)|0;o=J;w=((o^E)&(o^G)|0)<0;n=m+16|0;f[n>>2]=w?-1:p;f[n+4>>2]=w?(o|2147483647)^-2147483648:o;o=d;w=f[o>>2]|0;n=f[o+4>>2]|0;o=f[g+12>>2]|0;p=(n|0)<0;l=(o|0)<0;j=c1c(0,0,w|0,n|0)|0;b=p?j:w;j=p?J:n;p=c1c(0,0,0,o|0)|0;p=J;k=l?p:o;p=o^n;n=x1c(k|0,0,b|0,0)|0;b=J;o=x1c(k|0,0,j|0,0)|0;j=J;k=d1c(o|0,0,b|0,0)|0;b=J|j;if(b>>>0>0|(b|0)==0&(k|o)>>>0>2147483647){o=l1c(w|0,p|0,63)|0;w=d1c(o|0,J|0,-1,2147483647)|0;H=w;I=J}else{w=(p|0)<0;p=c1c(0,0,n|0,k|0)|0;H=w?p:n;I=w?J:k}k=t;t=f[k>>2]|0;w=f[k+4>>2]|0;k=f[g+28>>2]|0;g=(w|0)<0;n=(k|0)<0;p=c1c(0,0,t|0,w|0)|0;o=g?p:t;p=g?J:w;g=c1c(0,0,0,k|0)|0;g=J;b=n?g:k;g=k^w;w=x1c(b|0,0,o|0,0)|0;o=J;k=x1c(b|0,0,p|0,0)|0;p=J;b=d1c(k|0,0,o|0,0)|0;o=J|p;if(o>>>0>0|(o|0)==0&(b|k)>>>0>2147483647){k=l1c(t|0,g|0,63)|0;t=d1c(k|0,J|0,-1,2147483647)|0;K=t;L=J}else{t=(g|0)<0;g=c1c(0,0,w|0,b|0)|0;K=t?g:w;L=t?J:b}b=d1c(K|0,L|0,H|0,I|0)|0;t=J;w=((t^I)&(t^L)|0)<0;g=m+24|0;f[g>>2]=w?-1:b;f[g+4>>2]=w?(t|2147483647)^-2147483648:t;q=q+1|0;if((q|0)==(h|0))break;else{d=d+16|0;m=m+32|0}}M=h;N=s+(e<<2<<3)|0}else{M=r;N=s}s=a+(f[c+(i+-1<<2)>>2]<<2<<2)|0;c=f[s>>2]|0;a=f[s+4>>2]|0;r=f[s+8>>2]|0;e=f[s+12>>2]|0;if((M|0)<(i|0)){O=N;P=M}else return;while(1){M=O;f[M>>2]=0;f[M+4>>2]=c;M=O+8|0;f[M>>2]=0;f[M+4>>2]=a;M=O+16|0;f[M>>2]=0;f[M+4>>2]=r;M=O+24|0;f[M>>2]=0;f[M+4>>2]=e;P=P+1|0;if((P|0)==(i|0))break;else O=O+32|0}return}function Vma(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Xma(a,b,c,d,e,f,g,h);return}function Wma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;do if((g|0)>0){j=g<<1;if((b|0)<=0){k=d+(j<<3)|0;l=e;m=g;break}n=Y(g,b)|0;o=e;p=0;while(1){q=0;r=o;while(1){s=f[a+(q<<2)>>2]|0;t=r;f[t>>2]=0;f[t+4>>2]=s;q=q+1|0;if((q|0)==(b|0))break;else r=r+8|0}p=p+1|0;if((p|0)==(g|0))break;else o=o+(b<<3)|0}k=d+(j<<3)|0;l=e+(n<<3)|0;m=g}else{k=d;l=e;m=0}while(0);if((m|0)<(h|0)){e=(b|0)>0;d=k;k=m;g=l;while(1){o=a+((Y(f[c+(k<<2)>>2]|0,b)|0)<<2)|0;if(e){p=d+8|0;r=0;q=g;while(1){s=d;t=f[s>>2]|0;u=f[s+4>>2]|0;s=f[o+(r<<2)>>2]|0;v=(u|0)<0;w=(s|0)<0;x=c1c(0,0,t|0,u|0)|0;y=v?x:t;x=v?J:u;v=c1c(0,0,0,s|0)|0;v=J;z=w?v:s;v=s^u;u=x1c(z|0,0,y|0,0)|0;y=J;s=x1c(z|0,0,x|0,0)|0;x=J;z=d1c(s|0,0,y|0,0)|0;y=J|x;if(y>>>0>0|(y|0)==0&(z|s)>>>0>2147483647){s=l1c(t|0,v|0,63)|0;t=d1c(s|0,J|0,-1,2147483647)|0;A=t;B=J}else{t=(v|0)<0;v=c1c(0,0,u|0,z|0)|0;A=t?v:u;B=t?J:z}z=q;f[z>>2]=A;f[z+4>>2]=B;z=p;t=f[z>>2]|0;u=f[z+4>>2]|0;z=f[o+(r+b<<2)>>2]|0;v=(u|0)<0;s=(z|0)<0;y=c1c(0,0,t|0,u|0)|0;x=v?y:t;y=v?J:u;v=c1c(0,0,0,z|0)|0;v=J;w=s?v:z;v=z^u;u=x1c(w|0,0,x|0,0)|0;x=J;z=x1c(w|0,0,y|0,0)|0;y=J;w=d1c(z|0,0,x|0,0)|0;x=J|y;if(x>>>0>0|(x|0)==0&(w|z)>>>0>2147483647){z=l1c(t|0,v|0,63)|0;t=d1c(z|0,J|0,-1,2147483647)|0;C=t;D=J}else{t=(v|0)<0;v=c1c(0,0,u|0,w|0)|0;C=t?v:u;D=t?J:w}w=d1c(A|0,B|0,C|0,D|0)|0;t=J;u=((t^B)&(t^D)|0)<0;v=q;f[v>>2]=u?-1:w;f[v+4>>2]=u?(t|2147483647)^-2147483648:t;r=r+1|0;if((r|0)==(b|0))break;else q=q+8|0}E=g+(b<<3)|0}else E=g;k=k+1|0;if((k|0)==(h|0)){F=h;G=E;break}else{d=d+16|0;g=E}}}else{F=m;G=l}l=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<2)|0;if((F|0)<(i|0)&(b|0)>0){H=F;I=G}else return;while(1){G=0;F=I;while(1){c=f[l+(G<<2)>>2]|0;a=F;f[a>>2]=0;f[a+4>>2]=c;G=G+1|0;if((G|0)==(b|0))break;else F=F+8|0}H=H+1|0;if((H|0)==(i|0))break;else I=I+(b<<3)|0}return}function Xma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;do if((g|0)>0){j=g<<1;if((b|0)<=0){k=d+(j<<3)|0;l=e;m=g;break}n=Y(g,b)|0;o=e;p=0;while(1){q=0;r=o;while(1){s=f[a+(q<<2)>>2]|0;t=r;f[t>>2]=0;f[t+4>>2]=s;q=q+1|0;if((q|0)==(b|0))break;else r=r+8|0}p=p+1|0;if((p|0)==(g|0))break;else o=o+(b<<3)|0}k=d+(j<<3)|0;l=e+(n<<3)|0;m=g}else{k=d;l=e;m=0}while(0);if((m|0)<(h|0)){e=(b|0)>0;d=k;k=m;g=l;while(1){o=a+((Y(f[c+(k<<2)>>2]|0,b)|0)<<2)|0;if(e){p=d+8|0;r=0;q=g;while(1){s=d;t=f[s>>2]|0;u=f[s+4>>2]|0;do if(!((t|0)==0&(u|0)==0)){s=f[o+(r<<2)>>2]|0;v=(u|0)<0;w=(s|0)<0;x=c1c(0,0,t|0,u|0)|0;y=v?x:t;x=v?J:u;v=c1c(0,0,0,s|0)|0;v=J;z=w?v:s;v=s^u;s=x1c(z|0,0,y|0,0)|0;y=J;w=x1c(z|0,0,x|0,0)|0;x=J;z=d1c(w|0,0,y|0,0)|0;y=J|x;if(y>>>0>0|(y|0)==0&(z|w)>>>0>2147483647){w=l1c(t|0,v|0,63)|0;y=d1c(w|0,J|0,-1,2147483647)|0;A=y;B=J;break}else{y=(v|0)<0;v=c1c(0,0,s|0,z|0)|0;A=y?v:s;B=y?J:z;break}}else{A=0;B=0}while(0);t=q;f[t>>2]=A;f[t+4>>2]=B;t=p;u=f[t>>2]|0;z=f[t+4>>2]|0;do if(!((u|0)==0&(z|0)==0)){t=f[o+(r+b<<2)>>2]|0;y=(z|0)<0;s=(t|0)<0;v=c1c(0,0,u|0,z|0)|0;w=y?v:u;v=y?J:z;y=c1c(0,0,0,t|0)|0;y=J;x=s?y:t;y=t^z;t=x1c(x|0,0,w|0,0)|0;w=J;s=x1c(x|0,0,v|0,0)|0;v=J;x=d1c(s|0,0,w|0,0)|0;w=J|v;if(w>>>0>0|(w|0)==0&(x|s)>>>0>2147483647){s=l1c(u|0,y|0,63)|0;w=d1c(s|0,J|0,-1,2147483647)|0;C=w;D=J;break}else{w=(y|0)<0;y=c1c(0,0,t|0,x|0)|0;C=w?y:t;D=w?J:x;break}}else{C=0;D=0}while(0);u=d1c(A|0,B|0,C|0,D|0)|0;z=J;x=((z^B)&(z^D)|0)<0;w=q;f[w>>2]=x?-1:u;f[w+4>>2]=x?(z|2147483647)^-2147483648:z;r=r+1|0;if((r|0)==(b|0))break;else q=q+8|0}E=g+(b<<3)|0}else E=g;k=k+1|0;if((k|0)==(h|0)){F=h;G=E;break}else{d=d+16|0;g=E}}}else{F=m;G=l}l=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<2)|0;if((F|0)<(i|0)&(b|0)>0){H=F;I=G}else return;while(1){G=0;F=I;while(1){c=f[l+(G<<2)>>2]|0;a=F;f[a>>2]=0;f[a+4>>2]=c;G=G+1|0;if((G|0)==(b|0))break;else F=F+8|0}H=H+1|0;if((H|0)==(i|0))break;else I=I+(b<<3)|0}return}function Yma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;NGc(j,b);p[h>>3]=.5;VGc(g,j,h);ZGc(k,a,g);p[l>>3]=.5;YGc(i,k,l);k=SGc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;NGc(m,k);YGc(l,i,m);OGc(h,0,1);ZGc(g,l,h);h=TGc(g)|0;g=J;l=d+8|0;f[l>>2]=h;f[l+4>>2]=g;l=c1c(0,1,h|0,g|0)|0;h=J;m=(h&g|0)<0;g=d;f[g>>2]=m?-1:l;f[g+4>>2]=m?(h|2147483647)^-2147483648:h;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function Zma(a){a=a|0;cYc(a);return}function _ma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;c=u;u=u+1120|0;d=c+16|0;e=c;g=a+28|0;h=f[g>>2]|0;i=a+36|0;j=f[i>>2]|0;k=Y(h<<1,j)|0;l=d+8|0;g1c(l|0,0,1088)|0;f[d>>2]=l;m=d+4|0;f[m>>2]=k;if(k>>>0>136){n=bYc(k>>>0>536870911?-1:k<<3)|0;g1c(n|0,0,k<<3|0)|0;f[d>>2]=n;o=n}else o=l;n=f[a+64>>2]|0;k=f[b>>2]|0;p=(n|0)<(k|0)?k:n;q=b+4|0;r=f[q>>2]|0;s=f[a+68>>2]|0;t=(r|0)<(s|0)?r:s;if((k|0)<(n|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,j,f[a+40>>2]|0,f[a+48>>2]|0,o,f[a+56>>2]|0,f[a+60>>2]|0,h);v=-1;w=1;x=f[b>>2]|0}else{v=-2;w=0;x=k}if((x|0)<(p|0)){k=f[d>>2]|0;b=f[a+20>>2]|0;h=a+24|0;o=x;do{j=b+(Y(f[h>>2]|0,o)|0)|0;n=Y(f[i>>2]|0,f[g>>2]|0)|0;if((n|0)>0){s=0;do{r=k+(s<<3)|0;y=d1c(f[r>>2]|0,f[r+4>>2]|0,-2147483648,0)|0;r=k1c(y|0,J|0,32)|0;y=J;z=d1c(r|0,y|0,-2147483648,0)|0;A=J;f[j+(s<<2)>>2]=A>>>0<1|(A|0)==1&z>>>0<0?r:(y|0)>0|(y|0)==0&r>>>0>0?2147483647:-2147483648;s=s+1|0}while((s|0)!=(n|0))}o=o+1|0}while((o|0)<(p|0));B=p}else B=x;if((B|0)<(t|0)){x=a+44|0;p=a+16|0;o=a+20|0;k=a+24|0;h=e+8|0;b=a+52|0;n=a+72|0;s=a+4|0;j=a+8|0;r=a+40|0;y=a+48|0;z=a+56|0;A=a+60|0;C=v;D=w;E=B;F=0;while(1){G=B+F<<1;H=(f[x>>2]|0)+(E<<2)|0;I=C+2|0;K=f[H>>2]|0;L=(K|0)<(I|0)?I:K;I=K+2|0;M=f[p>>2]|0;if((L|0)<(((M|0)<(I|0)?M:I)|0)){I=L;L=D;while(1){N=(f[s>>2]|0)+(Y(f[j>>2]|0,I)|0)|0;O=f[i>>2]|0;P=f[g>>2]|0;Q=(f[d>>2]|0)+((Y(Y(O,L)|0,P)|0)<<3)|0;wi[f[n>>2]&255](N,O,f[r>>2]|0,f[y>>2]|0,Q,f[z>>2]|0,f[A>>2]|0,P);I=I+1|0;P=(L+1|0)%2|0;Q=f[H>>2]|0;O=Q+2|0;N=f[p>>2]|0;if((I|0)>=(((N|0)<(O|0)?N:O)|0)){R=P;S=N;T=Q;break}else L=P}}else{R=D;S=M;T=K}L=S+-2|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;I=(((T|0)<(L|0)?L:T)+R-((C|0)<(L|0)?L:C)|0)%2|0;if((I|0)>0){o1c(e|0,(f[b>>2]|0)+((E<<1)+2-I<<3)|0,I<<3|0)|0;U=I}else U=0;o1c(e+(U<<3)|0,(f[b>>2]|0)+(U+G-I<<3)|0,16-(U<<3)|0)|0;L=f[d>>2]|0;H=Y(f[i>>2]|0,f[g>>2]|0)|0;P=(f[o>>2]|0)+(Y(f[k>>2]|0,E)|0)|0;if((H|0)>0){Q=e;N=f[Q>>2]|0;O=f[Q+4>>2]|0;Q=(O|0)<0;V=c1c(0,0,N|0,O|0)|0;W=Q?V:N;V=Q?J:O;Q=h;X=f[Q>>2]|0;Z=f[Q+4>>2]|0;Q=(Z|0)<0;_=c1c(0,0,X|0,Z|0)|0;$=Q?_:X;_=Q?J:Z;Q=0;do{aa=L+(Q<<3)|0;ba=f[aa>>2]|0;ca=f[aa+4>>2]|0;aa=(ca|0)<0;da=c1c(0,0,ba|0,ca|0)|0;ea=aa?da:ba;da=aa?J:ca;aa=ca^O;ca=x1c(ea|0,0,W|0,0)|0;d1c(ca|0,J|0,-2147483648,0)|0;ca=J;fa=x1c(da|0,0,W|0,0)|0;ga=J;ha=x1c(ea|0,0,V|0,0)|0;ea=J;ia=x1c(da|0,0,V|0,0)|0;da=J;ja=d1c(fa|0,0,ha|0,0)|0;ha=d1c(ja|0,J|0,ca|0,0)|0;ca=J;ja=d1c(ia|0,0,ga|0,0)|0;ga=d1c(ja|0,J|0,ea|0,0)|0;ea=d1c(ga|0,J|0,ca|0,0)|0;ca=J|da;if(ca>>>0>0|(ca|0)==0&(ea|ia)>>>0>2147483647){ia=l1c(ba^N|0,aa|0,63)|0;ba=d1c(ia|0,J|0,-1,2147483647)|0;ka=ba;la=J}else{ba=(aa|0)<0;aa=c1c(0,0,ha|0,ea|0)|0;ka=ba?aa:ha;la=ba?J:ea}ea=L+(Q+H<<3)|0;ba=f[ea>>2]|0;ha=f[ea+4>>2]|0;ea=(ha|0)<0;aa=c1c(0,0,ba|0,ha|0)|0;ia=ea?aa:ba;aa=ea?J:ha;ea=ha^Z;ha=x1c(ia|0,0,$|0,0)|0;d1c(ha|0,J|0,-2147483648,0)|0;ha=J;ca=x1c(aa|0,0,$|0,0)|0;da=J;ga=x1c(ia|0,0,_|0,0)|0;ia=J;ja=x1c(aa|0,0,_|0,0)|0;aa=J;fa=d1c(ca|0,0,ga|0,0)|0;ga=d1c(fa|0,J|0,ha|0,0)|0;ha=J;fa=d1c(ja|0,0,da|0,0)|0;da=d1c(fa|0,J|0,ia|0,0)|0;ia=d1c(da|0,J|0,ha|0,0)|0;ha=J|aa;if(ha>>>0>0|(ha|0)==0&(ia|ja)>>>0>2147483647){ja=l1c(ba^X|0,ea|0,63)|0;ba=d1c(ja|0,J|0,-1,2147483647)|0;ma=ba;na=J}else{ba=(ea|0)<0;ea=c1c(0,0,ga|0,ia|0)|0;ma=ba?ea:ga;na=ba?J:ia}ia=d1c(ma|0,na|0,ka|0,la|0)|0;ba=J;ga=((ba^la)&(ba^na)|0)<0;ea=d1c((ga?-1:ia)|0,(ga?(ba|2147483647)^-2147483648:ba)|0,-2147483648,0)|0;ba=k1c(ea|0,J|0,32)|0;ea=J;ga=d1c(ba|0,ea|0,-2147483648,0)|0;ia=J;f[P+(Q<<2)>>2]=ia>>>0<1|(ia|0)==1&ga>>>0<0?ba:(ea|0)>0|(ea|0)==0&ba>>>0>0?2147483647:-2147483648;Q=Q+1|0}while((Q|0)!=(H|0))}H=E+1|0;if((H|0)<(t|0)){C=T;D=I;E=H;F=F+1|0}else{oa=T;pa=I;qa=H;ra=L;sa=p;break}}}else{oa=v;pa=w;qa=B;ra=f[d>>2]|0;sa=a+16|0}B=f[sa>>2]|0;if((oa+2|0)>(B|0))ta=ra+((Y(Y(f[g>>2]|0,(pa+~oa+B|0)%2|0)|0,f[i>>2]|0)|0)<<3)|0;else{oa=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,B+-1|0)|0)|0;wi[f[a+72>>2]&255](oa,f[i>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,ra,f[a+56>>2]|0,f[a+60>>2]|0,f[g>>2]|0);ta=ra}ra=f[q>>2]|0;if((qa|0)<(ra|0)){oa=f[a+20>>2]|0;B=a+24|0;a=qa;qa=ra;while(1){ra=oa+(Y(f[B>>2]|0,a)|0)|0;pa=Y(f[i>>2]|0,f[g>>2]|0)|0;if((pa|0)>0){sa=0;do{w=ta+(sa<<3)|0;v=d1c(f[w>>2]|0,f[w+4>>2]|0,-2147483648,0)|0;w=k1c(v|0,J|0,32)|0;v=J;p=d1c(w|0,v|0,-2147483648,0)|0;T=J;f[ra+(sa<<2)>>2]=T>>>0<1|(T|0)==1&p>>>0<0?w:(v|0)>0|(v|0)==0&w>>>0>0?2147483647:-2147483648;sa=sa+1|0}while((sa|0)!=(pa|0));ua=f[q>>2]|0}else ua=qa;a=a+1|0;if((a|0)>=(ua|0))break;else qa=ua}}ua=f[d>>2]|0;if((ua|0)==(l|0)){u=c;return}if(ua|0)dYc(ua);f[d>>2]=l;f[m>>2]=136;u=c;return}function $ma(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=j[a>>1]<<16;if((h|0)>0){l=0;m=g;while(1){f[m>>2]=b;l=l+1|0;if((l|0)==(h|0))break;else m=m+4|0}n=e+(h<<1<<2)|0;o=h;p=g+(h<<2)|0}else{n=e;o=0;p=g}if((o|0)<(i|0)){g=n;n=o;e=p;while(1){h=a+(f[c+(n<<2)>>2]<<1)|0;m=f[g>>2]|0;l=d[h>>1]|0;b=x1c(l|0,((l|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=J;l=d1c(b|0,m|0,-2147483648,0)|0;q=J;r=q>>>0<1|(q|0)==1&l>>>0<0?b:(m|0)>0|(m|0)==0&b>>>0>0?2147483647:-2147483648;b=f[g+4>>2]|0;m=d[h+2>>1]|0;h=x1c(m|0,((m|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;m=d1c(h|0,b|0,-2147483648,0)|0;l=J;q=l>>>0<1|(l|0)==1&m>>>0<0?h:(b|0)>0|(b|0)==0&h>>>0>0?2147483647:-2147483648;h=q+r|0;f[e>>2]=((h^r)&(h^q)|0)<0?(h|2147483647)^-2147483648:h;n=n+1|0;if((n|0)==(i|0))break;else{g=g+8|0;e=e+4|0}}s=i;t=p+(i-o<<2)|0}else{s=o;t=p}p=j[a+(f[c+(k+-1<<2)>>2]<<1)>>1]<<16;if((s|0)<(k|0)){u=s;v=t}else return;while(1){f[v>>2]=p;u=u+1|0;if((u|0)==(k|0))break;else v=v+4|0}return}function ana(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ina(a,b,c,d,e,f,g,h);return}function bna(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;if((h|0)>0){m=h<<1;n=0;o=g;while(1){f[o>>2]=b;f[o+4>>2]=l;n=n+1|0;if((n|0)==(h|0))break;else o=o+8|0}p=e+(m<<2)|0;q=h;r=g+(m<<2)|0}else{p=e;q=0;r=g}if((q|0)<(i|0)){g=i-q|0;e=q;m=r;h=p;while(1){p=a+(f[c+(e<<2)>>2]<<1<<1)|0;o=f[h>>2]|0;n=d[p>>1]|0;l=x1c(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=d1c(l|0,o|0,-2147483648,0)|0;b=J;s=b>>>0<1|(b|0)==1&n>>>0<0?l:(o|0)>0|(o|0)==0&l>>>0>0?2147483647:-2147483648;l=h+4|0;o=f[l>>2]|0;n=d[p+4>>1]|0;b=x1c(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=d1c(b|0,o|0,-2147483648,0)|0;t=J;u=t>>>0<1|(t|0)==1&n>>>0<0?b:(o|0)>0|(o|0)==0&b>>>0>0?2147483647:-2147483648;b=u+s|0;f[m>>2]=((b^s)&(b^u)|0)<0?(b|2147483647)^-2147483648:b;b=f[h>>2]|0;u=d[p+2>>1]|0;s=x1c(u|0,((u|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;u=d1c(s|0,b|0,-2147483648,0)|0;o=J;n=o>>>0<1|(o|0)==1&u>>>0<0?s:(b|0)>0|(b|0)==0&s>>>0>0?2147483647:-2147483648;s=f[l>>2]|0;l=d[p+6>>1]|0;p=x1c(l|0,((l|0)<0)<<31>>31|0,s|0,((s|0)<0)<<31>>31|0)|0;s=J;l=d1c(p|0,s|0,-2147483648,0)|0;b=J;u=b>>>0<1|(b|0)==1&l>>>0<0?p:(s|0)>0|(s|0)==0&p>>>0>0?2147483647:-2147483648;p=u+n|0;f[m+4>>2]=((p^n)&(p^u)|0)<0?(p|2147483647)^-2147483648:p;e=e+1|0;if((e|0)==(i|0))break;else{m=m+8|0;h=h+8|0}}v=i;w=r+(g<<1<<2)|0}else{v=q;w=r}r=a+(f[c+(k+-1<<2)>>2]<<1<<1)|0;c=j[r>>1]<<16;a=j[r+2>>1]<<16;if((v|0)<(k|0)){x=w;y=v}else return;while(1){f[x>>2]=c;f[x+4>>2]=a;y=y+1|0;if((y|0)==(k|0))break;else x=x+8|0}return}function cna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ina(a,b,c,d,e,f,g,h);return}function dna(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;m=j[a+4>>1]<<16;if((h|0)>0){n=h*3|0;o=0;p=g;while(1){f[p>>2]=b;f[p+4>>2]=l;f[p+8>>2]=m;o=o+1|0;if((o|0)==(h|0))break;else p=p+12|0}q=e+(h<<1<<2)|0;r=h;s=g+(n<<2)|0}else{q=e;r=0;s=g}if((r|0)<(i|0)){g=i-r|0;e=r;n=s;h=q;while(1){q=a+((f[c+(e<<2)>>2]|0)*3<<1)|0;p=f[h>>2]|0;o=d[q>>1]|0;m=x1c(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=d1c(m|0,p|0,-2147483648,0)|0;l=J;b=l>>>0<1|(l|0)==1&o>>>0<0?m:(p|0)>0|(p|0)==0&m>>>0>0?2147483647:-2147483648;m=h+4|0;p=f[m>>2]|0;o=d[q+6>>1]|0;l=x1c(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=d1c(l|0,p|0,-2147483648,0)|0;t=J;u=t>>>0<1|(t|0)==1&o>>>0<0?l:(p|0)>0|(p|0)==0&l>>>0>0?2147483647:-2147483648;l=u+b|0;f[n>>2]=((l^b)&(l^u)|0)<0?(l|2147483647)^-2147483648:l;l=f[h>>2]|0;u=d[q+2>>1]|0;b=x1c(u|0,((u|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;u=d1c(b|0,l|0,-2147483648,0)|0;p=J;o=p>>>0<1|(p|0)==1&u>>>0<0?b:(l|0)>0|(l|0)==0&b>>>0>0?2147483647:-2147483648;b=f[m>>2]|0;l=d[q+8>>1]|0;u=x1c(l|0,((l|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;l=d1c(u|0,b|0,-2147483648,0)|0;p=J;t=p>>>0<1|(p|0)==1&l>>>0<0?u:(b|0)>0|(b|0)==0&u>>>0>0?2147483647:-2147483648;u=t+o|0;f[n+4>>2]=((u^o)&(u^t)|0)<0?(u|2147483647)^-2147483648:u;u=f[h>>2]|0;t=d[q+4>>1]|0;o=x1c(t|0,((t|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;t=d1c(o|0,u|0,-2147483648,0)|0;b=J;l=b>>>0<1|(b|0)==1&t>>>0<0?o:(u|0)>0|(u|0)==0&o>>>0>0?2147483647:-2147483648;o=f[m>>2]|0;m=d[q+10>>1]|0;q=x1c(m|0,((m|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;m=d1c(q|0,o|0,-2147483648,0)|0;u=J;t=u>>>0<1|(u|0)==1&m>>>0<0?q:(o|0)>0|(o|0)==0&q>>>0>0?2147483647:-2147483648;q=t+l|0;f[n+8>>2]=((q^l)&(q^t)|0)<0?(q|2147483647)^-2147483648:q;e=e+1|0;if((e|0)==(i|0))break;else{n=n+12|0;h=h+8|0}}v=i;w=s+(g*3<<2)|0}else{v=r;w=s}s=a+((f[c+(k+-1<<2)>>2]|0)*3<<1)|0;c=j[s>>1]<<16;a=j[s+2>>1]<<16;r=j[s+4>>1]<<16;if((v|0)<(k|0)){x=w;y=v}else return;while(1){f[x>>2]=c;f[x+4>>2]=a;f[x+8>>2]=r;y=y+1|0;if((y|0)==(k|0))break;else x=x+12|0}return}function ena(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ina(a,b,c,d,e,f,g,h);return}function fna(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;m=j[a+4>>1]<<16;n=j[a+6>>1]<<16;if((h|0)>0){o=h<<2;p=0;q=g;while(1){f[q>>2]=b;f[q+4>>2]=l;f[q+8>>2]=m;f[q+12>>2]=n;p=p+1|0;if((p|0)==(h|0))break;else q=q+16|0}r=e+(h<<1<<2)|0;s=h;t=g+(o<<2)|0}else{r=e;s=0;t=g}if((s|0)<(i|0)){g=i-s|0;e=r;r=s;o=t;while(1){h=a+(f[c+(r<<2)>>2]<<2<<1)|0;q=f[e>>2]|0;p=d[h>>1]|0;n=x1c(p|0,((p|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;q=J;p=d1c(n|0,q|0,-2147483648,0)|0;m=J;l=m>>>0<1|(m|0)==1&p>>>0<0?n:(q|0)>0|(q|0)==0&n>>>0>0?2147483647:-2147483648;n=e+4|0;q=f[n>>2]|0;p=d[h+8>>1]|0;m=x1c(p|0,((p|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;q=J;p=d1c(m|0,q|0,-2147483648,0)|0;b=J;u=b>>>0<1|(b|0)==1&p>>>0<0?m:(q|0)>0|(q|0)==0&m>>>0>0?2147483647:-2147483648;m=u+l|0;f[o>>2]=((m^l)&(m^u)|0)<0?(m|2147483647)^-2147483648:m;m=f[e>>2]|0;u=d[h+2>>1]|0;l=x1c(u|0,((u|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=J;u=d1c(l|0,m|0,-2147483648,0)|0;q=J;p=q>>>0<1|(q|0)==1&u>>>0<0?l:(m|0)>0|(m|0)==0&l>>>0>0?2147483647:-2147483648;l=f[n>>2]|0;m=d[h+10>>1]|0;u=x1c(m|0,((m|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;m=d1c(u|0,l|0,-2147483648,0)|0;q=J;b=q>>>0<1|(q|0)==1&m>>>0<0?u:(l|0)>0|(l|0)==0&u>>>0>0?2147483647:-2147483648;u=b+p|0;f[o+4>>2]=((u^p)&(u^b)|0)<0?(u|2147483647)^-2147483648:u;u=f[e>>2]|0;b=d[h+4>>1]|0;p=x1c(b|0,((b|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;b=d1c(p|0,u|0,-2147483648,0)|0;l=J;m=l>>>0<1|(l|0)==1&b>>>0<0?p:(u|0)>0|(u|0)==0&p>>>0>0?2147483647:-2147483648;p=f[n>>2]|0;u=d[h+12>>1]|0;b=x1c(u|0,((u|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;u=d1c(b|0,p|0,-2147483648,0)|0;l=J;q=l>>>0<1|(l|0)==1&u>>>0<0?b:(p|0)>0|(p|0)==0&b>>>0>0?2147483647:-2147483648;b=q+m|0;f[o+8>>2]=((b^m)&(b^q)|0)<0?(b|2147483647)^-2147483648:b;b=f[e>>2]|0;q=d[h+6>>1]|0;m=x1c(q|0,((q|0)<0)<<31>>31|0,b|0,((b|0)<0)<<31>>31|0)|0;b=J;q=d1c(m|0,b|0,-2147483648,0)|0;p=J;u=p>>>0<1|(p|0)==1&q>>>0<0?m:(b|0)>0|(b|0)==0&m>>>0>0?2147483647:-2147483648;m=f[n>>2]|0;n=d[h+14>>1]|0;h=x1c(n|0,((n|0)<0)<<31>>31|0,m|0,((m|0)<0)<<31>>31|0)|0;m=J;n=d1c(h|0,m|0,-2147483648,0)|0;b=J;q=b>>>0<1|(b|0)==1&n>>>0<0?h:(m|0)>0|(m|0)==0&h>>>0>0?2147483647:-2147483648;h=q+u|0;f[o+12>>2]=((h^u)&(h^q)|0)<0?(h|2147483647)^-2147483648:h;r=r+1|0;if((r|0)==(i|0))break;else{e=e+8|0;o=o+16|0}}v=i;w=t+(g<<2<<2)|0}else{v=s;w=t}t=a+(f[c+(k+-1<<2)>>2]<<2<<1)|0;c=j[t>>1]<<16;a=j[t+2>>1]<<16;s=j[t+4>>1]<<16;g=j[t+6>>1]<<16;if((v|0)<(k|0)){x=w;y=v}else return;while(1){f[x>>2]=c;f[x+4>>2]=a;f[x+8>>2]=s;f[x+12>>2]=g;y=y+1|0;if((y|0)==(k|0))break;else x=x+16|0}return}function gna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ina(a,b,c,d,e,f,g,h);return}function hna(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;do if((h|0)>0){l=h<<1;if((b|0)<=0){m=e+(l<<2)|0;n=g;o=h;break}p=Y(h,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){f[t>>2]=j[a+(s<<1)>>1]<<16;s=s+1|0;if((s|0)==(b|0))break;else t=t+4|0}r=r+1|0;if((r|0)==(h|0))break;else q=q+(b<<2)|0}m=e+(l<<2)|0;n=g+(p<<2)|0;o=h}else{m=e;n=g;o=0}while(0);if((o|0)<(i|0))if((b|0)>0){g=n+((Y(i-o|0,b)|0)<<2)|0;e=m;m=o;h=n;while(1){q=a+((Y(f[c+(m<<2)>>2]|0,b)|0)<<1)|0;r=e+4|0;t=0;s=h;while(1){u=f[e>>2]|0;v=d[q+(t<<1)>>1]|0;w=x1c(v|0,((v|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;v=d1c(w|0,u|0,-2147483648,0)|0;x=J;y=x>>>0<1|(x|0)==1&v>>>0<0?w:(u|0)>0|(u|0)==0&w>>>0>0?2147483647:-2147483648;f[s>>2]=y;w=f[r>>2]|0;u=d[q+(t+b<<1)>>1]|0;v=x1c(u|0,((u|0)<0)<<31>>31|0,w|0,((w|0)<0)<<31>>31|0)|0;w=J;u=d1c(v|0,w|0,-2147483648,0)|0;x=J;z=x>>>0<1|(x|0)==1&u>>>0<0?v:(w|0)>0|(w|0)==0&v>>>0>0?2147483647:-2147483648;v=z+y|0;f[s>>2]=((v^y)&(v^z)|0)<0?(v|2147483647)^-2147483648:v;t=t+1|0;if((t|0)==(b|0))break;else s=s+4|0}m=m+1|0;if((m|0)==(i|0)){A=i;B=g;break}else{e=e+8|0;h=h+(b<<2)|0}}}else{A=i;B=n}else{A=o;B=n}n=a+((Y(f[c+(k+-1<<2)>>2]|0,b)|0)<<1)|0;if((A|0)<(k|0)&(b|0)>0){C=A;D=B}else return;while(1){B=0;A=D;while(1){f[A>>2]=j[n+(B<<1)>>1]<<16;B=B+1|0;if((B|0)==(b|0))break;else A=A+4|0}C=C+1|0;if((C|0)==(k|0))break;else D=D+(b<<2)|0}return}function ina(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;do if((h|0)>0){l=h<<1;if((b|0)<=0){m=e+(l<<2)|0;n=g;o=h;break}p=Y(h,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){f[t>>2]=j[a+(s<<1)>>1]<<16;s=s+1|0;if((s|0)==(b|0))break;else t=t+4|0}r=r+1|0;if((r|0)==(h|0))break;else q=q+(b<<2)|0}m=e+(l<<2)|0;n=g+(p<<2)|0;o=h}else{m=e;n=g;o=0}while(0);if((o|0)<(i|0)){g=(b|0)>0;e=m;m=o;h=n;while(1){q=a+((Y(f[c+(m<<2)>>2]|0,b)|0)<<1)|0;if(g){r=e+4|0;t=0;s=h;while(1){u=f[e>>2]|0;if(!u)v=0;else{w=d[q+(t<<1)>>1]|0;x=x1c(w|0,((w|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;u=J;w=d1c(x|0,u|0,-2147483648,0)|0;y=J;v=y>>>0<1|(y|0)==1&w>>>0<0?x:(u|0)>0|(u|0)==0&x>>>0>0?2147483647:-2147483648}f[s>>2]=v;x=f[r>>2]|0;if(!x)z=0;else{u=d[q+(t+b<<1)>>1]|0;w=x1c(u|0,((u|0)<0)<<31>>31|0,x|0,((x|0)<0)<<31>>31|0)|0;x=J;u=d1c(w|0,x|0,-2147483648,0)|0;y=J;z=y>>>0<1|(y|0)==1&u>>>0<0?w:(x|0)>0|(x|0)==0&w>>>0>0?2147483647:-2147483648}w=v+z|0;f[s>>2]=((w^v)&(w^z)|0)<0?(w|2147483647)^-2147483648:w;t=t+1|0;if((t|0)==(b|0))break;else s=s+4|0}A=h+(b<<2)|0}else A=h;m=m+1|0;if((m|0)==(i|0)){B=i;C=A;break}else{e=e+8|0;h=A}}}else{B=o;C=n}n=a+((Y(f[c+(k+-1<<2)>>2]|0,b)|0)<<1)|0;if((B|0)<(k|0)&(b|0)>0){D=B;E=C}else return;while(1){C=0;B=E;while(1){f[B>>2]=j[n+(C<<1)>>1]<<16;C=C+1|0;if((C|0)==(b|0))break;else B=B+4|0}D=D+1|0;if((D|0)==(k|0))break;else E=E+(b<<2)|0}return}function jna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;NGc(j,b);p[h>>3]=.5;VGc(g,j,h);ZGc(k,a,g);p[l>>3]=.5;YGc(i,k,l);k=SGc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;NGc(m,k);YGc(l,i,m);NGc(h,65536);ZGc(g,l,h);h=RGc(g)|0;f[d+4>>2]=h;g=65536-h|0;f[d>>2]=(g&h|0)<0?(g|2147483647)^-2147483648:g;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function kna(a){a=a|0;cYc(a);return}function lna(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=u;u=u+1072|0;e=c+8|0;g=c;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;g1c(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=bYc(l>>>0>1073741823?-1:l<<2)|0;g1c(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[b>>2]|0;q=(o|0)<(l|0)?l:o;r=b+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[b>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=f[e>>2]|0;b=f[a+20>>2]|0;i=f[a+24>>2]|0;p=Y(f[j>>2]|0,f[h>>2]|0)|0;if((p|0)>0){k=y;do{o=b+(Y(i,k)|0)|0;t=0;do{s=(f[l+(t<<2)>>2]|0)+32768>>16;d[o+(t<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;t=t+1|0}while((t|0)!=(p|0));k=k+1|0}while((k|0)<(q|0));z=q}else z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;k=a+20|0;p=a+24|0;l=g+4|0;i=a+52|0;b=a+72|0;t=a+4|0;o=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[t>>2]|0)+(Y(f[o>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;wi[f[b>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){o1c(g|0,(f[i>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;o1c(g+(V<<2)|0,(f[i>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[k>>2]|0)+(Y(f[p>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=((R|0)<0)<<31>>31;P=f[l>>2]|0;W=((P|0)<0)<<31>>31;X=0;do{Z=f[M+(X<<2)>>2]|0;_=x1c(Z|0,((Z|0)<0)<<31>>31|0,R|0,O|0)|0;Z=J;$=f[M+(X+I<<2)>>2]|0;aa=x1c($|0,(($|0)<0)<<31>>31|0,P|0,W|0)|0;$=J;ba=d1c(aa|0,$|0,_|0,Z|0)|0;_=J;aa=((_^Z)&(_^$)|0)<0;$=d1c((aa?-1:ba)|0,(aa?(_|2147483647)^-2147483648:_)|0,-2147483648,0)|0;_=k1c($|0,J|0,32)|0;$=J;aa=d1c(_|0,$|0,32768,0)|0;ba=J;d[Q+(X<<1)>>1]=ba>>>0<0|(ba|0)==0&aa>>>0<65536?_&65535:($|0)>0|($|0)==0&_>>>0>0?32767:-32768;X=X+1|0}while((X|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{ca=U;da=K;ea=I;fa=M;ga=T;break}}}else{ca=w;da=x;ea=z;fa=f[e>>2]|0;ga=f[a+16>>2]|0}if((ca+2|0)>(ga|0))ha=fa+((Y(Y(f[h>>2]|0,(da+~ca+ga|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{ca=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,ga+-1|0)|0)|0;wi[f[a+72>>2]&255](ca,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,fa,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ha=fa}fa=f[r>>2]|0;if((ea|0)<(fa|0)?(r=f[a+20>>2]|0,ca=f[a+24>>2]|0,a=Y(f[j>>2]|0,f[h>>2]|0)|0,(a|0)>0):0){h=ea;do{ea=r+(Y(ca,h)|0)|0;j=0;do{ga=(f[ha+(j<<2)>>2]|0)+32768>>16;d[ea+(j<<1)>>1]=(ga+32768|0)>>>0<65536?ga:(ga|0)>0?32767:32768;j=j+1|0}while((j|0)!=(a|0));h=h+1|0}while((h|0)<(fa|0))}fa=f[e>>2]|0;if((fa|0)==(m|0)){u=c;return}if(fa|0)dYc(fa);f[e>>2]=m;f[n>>2]=264;u=c;return}function mna(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=(j[a>>1]|0)<<16;if((g|0)>0){k=g<<1;l=0;m=e;while(1){f[m>>2]=b;l=l+1|0;if((l|0)==(g|0))break;else m=m+4|0}n=d+(k<<2)|0;o=g;p=e+(g<<2)|0}else{n=d;o=0;p=e}if((o|0)<(h|0)){e=h-o|0;d=o;g=p;k=n;while(1){n=a+(f[c+(d<<2)>>2]<<1)|0;m=x1c(j[n>>1]|0|0,0,f[k>>2]|0,0)|0;l=J;b=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=b?m:-1;m=x1c(j[n+2>>1]|0|0,0,f[k+4>>2]|0,0)|0;n=J;b=n>>>0<0|(n|0)==0&m>>>0<4294967295;n=b?m:-1;m=n+l|0;f[g>>2]=m>>>0<l>>>0?-1:m;d=d+1|0;if((d|0)==(h|0))break;else{g=g+4|0;k=k+8|0}}q=h;r=p+(e<<2)|0}else{q=o;r=p}p=(j[a+(f[c+(i+-1<<2)>>2]<<1)>>1]|0)<<16;if((q|0)<(i|0)){s=r;t=q}else return;while(1){f[s>>2]=p;t=t+1|0;if((t|0)==(i|0))break;else s=s+4|0}return}function nna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;vna(a,b,c,d,e,f,g,h);return}function ona(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;if((g|0)>0){l=g<<1;m=0;n=e;while(1){f[n>>2]=b;f[n+4>>2]=k;m=m+1|0;if((m|0)==(g|0))break;else n=n+8|0}o=d+(l<<2)|0;p=g;q=e+(l<<2)|0}else{o=d;p=0;q=e}if((p|0)<(h|0)){e=h-p|0;d=p;l=q;g=o;while(1){o=a+(f[c+(d<<2)>>2]<<1<<1)|0;n=x1c(j[o>>1]|0|0,0,f[g>>2]|0,0)|0;m=J;k=m>>>0<0|(m|0)==0&n>>>0<4294967295;m=k?n:-1;n=g+4|0;k=x1c(j[o+4>>1]|0|0,0,f[n>>2]|0,0)|0;b=J;r=b>>>0<0|(b|0)==0&k>>>0<4294967295;b=r?k:-1;k=b+m|0;f[l>>2]=k>>>0<m>>>0?-1:k;k=x1c(j[o+2>>1]|0|0,0,f[g>>2]|0,0)|0;m=J;b=m>>>0<0|(m|0)==0&k>>>0<4294967295;m=b?k:-1;k=x1c(j[o+6>>1]|0|0,0,f[n>>2]|0,0)|0;n=J;o=n>>>0<0|(n|0)==0&k>>>0<4294967295;n=o?k:-1;k=n+m|0;f[l+4>>2]=k>>>0<m>>>0?-1:k;d=d+1|0;if((d|0)==(h|0))break;else{l=l+8|0;g=g+8|0}}s=h;t=q+(e<<1<<2)|0}else{s=p;t=q}q=a+(f[c+(i+-1<<2)>>2]<<1<<1)|0;c=(j[q>>1]|0)<<16;a=(j[q+2>>1]|0)<<16;if((s|0)<(i|0)){u=s;v=t}else return;while(1){f[v>>2]=c;f[v+4>>2]=a;u=u+1|0;if((u|0)==(i|0))break;else v=v+8|0}return}function pna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;vna(a,b,c,d,e,f,g,h);return}function qna(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;l=(j[a+4>>1]|0)<<16;if((g|0)>0){m=g*3|0;n=0;o=e;while(1){f[o>>2]=b;f[o+4>>2]=k;f[o+8>>2]=l;n=n+1|0;if((n|0)==(g|0))break;else o=o+12|0}p=d+(g<<1<<2)|0;q=g;r=e+(m<<2)|0}else{p=d;q=0;r=e}if((q|0)<(h|0)){e=h-q|0;d=q;m=r;g=p;while(1){p=a+((f[c+(d<<2)>>2]|0)*3<<1)|0;o=x1c(j[p>>1]|0|0,0,f[g>>2]|0,0)|0;n=J;l=n>>>0<0|(n|0)==0&o>>>0<4294967295;n=l?o:-1;o=g+4|0;l=x1c(j[p+6>>1]|0|0,0,f[o>>2]|0,0)|0;k=J;b=k>>>0<0|(k|0)==0&l>>>0<4294967295;k=b?l:-1;l=k+n|0;f[m>>2]=l>>>0<n>>>0?-1:l;l=x1c(j[p+2>>1]|0|0,0,f[g>>2]|0,0)|0;n=J;k=n>>>0<0|(n|0)==0&l>>>0<4294967295;n=k?l:-1;l=x1c(j[p+8>>1]|0|0,0,f[o>>2]|0,0)|0;k=J;b=k>>>0<0|(k|0)==0&l>>>0<4294967295;k=b?l:-1;l=k+n|0;f[m+4>>2]=l>>>0<n>>>0?-1:l;l=x1c(j[p+4>>1]|0|0,0,f[g>>2]|0,0)|0;n=J;k=n>>>0<0|(n|0)==0&l>>>0<4294967295;n=k?l:-1;l=x1c(j[p+10>>1]|0|0,0,f[o>>2]|0,0)|0;o=J;p=o>>>0<0|(o|0)==0&l>>>0<4294967295;o=p?l:-1;l=o+n|0;f[m+8>>2]=l>>>0<n>>>0?-1:l;d=d+1|0;if((d|0)==(h|0))break;else{m=m+12|0;g=g+8|0}}s=h;t=r+(e*3<<2)|0}else{s=q;t=r}r=a+((f[c+(i+-1<<2)>>2]|0)*3<<1)|0;c=(j[r>>1]|0)<<16;a=(j[r+2>>1]|0)<<16;q=(j[r+4>>1]|0)<<16;if((s|0)<(i|0)){u=t;v=s}else return;while(1){f[u>>2]=c;f[u+4>>2]=a;f[u+8>>2]=q;v=v+1|0;if((v|0)==(i|0))break;else u=u+12|0}return}function rna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;vna(a,b,c,d,e,f,g,h);return}function sna(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;l=(j[a+4>>1]|0)<<16;m=(j[a+6>>1]|0)<<16;if((g|0)>0){n=g<<2;o=0;p=e;while(1){f[p>>2]=b;f[p+4>>2]=k;f[p+8>>2]=l;f[p+12>>2]=m;o=o+1|0;if((o|0)==(g|0))break;else p=p+16|0}q=d+(g<<1<<2)|0;r=g;s=e+(n<<2)|0}else{q=d;r=0;s=e}if((r|0)<(h|0)){e=h-r|0;d=r;n=s;g=q;while(1){q=a+(f[c+(d<<2)>>2]<<2<<1)|0;p=x1c(j[q>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;m=o>>>0<0|(o|0)==0&p>>>0<4294967295;o=m?p:-1;p=g+4|0;m=x1c(j[q+8>>1]|0|0,0,f[p>>2]|0,0)|0;l=J;k=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=k?m:-1;m=l+o|0;f[n>>2]=m>>>0<o>>>0?-1:m;m=x1c(j[q+2>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;l=o>>>0<0|(o|0)==0&m>>>0<4294967295;o=l?m:-1;m=x1c(j[q+10>>1]|0|0,0,f[p>>2]|0,0)|0;l=J;k=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=k?m:-1;m=l+o|0;f[n+4>>2]=m>>>0<o>>>0?-1:m;m=x1c(j[q+4>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;l=o>>>0<0|(o|0)==0&m>>>0<4294967295;o=l?m:-1;m=x1c(j[q+12>>1]|0|0,0,f[p>>2]|0,0)|0;l=J;k=l>>>0<0|(l|0)==0&m>>>0<4294967295;l=k?m:-1;m=l+o|0;f[n+8>>2]=m>>>0<o>>>0?-1:m;m=x1c(j[q+6>>1]|0|0,0,f[g>>2]|0,0)|0;o=J;l=o>>>0<0|(o|0)==0&m>>>0<4294967295;o=l?m:-1;m=x1c(j[q+14>>1]|0|0,0,f[p>>2]|0,0)|0;p=J;q=p>>>0<0|(p|0)==0&m>>>0<4294967295;p=q?m:-1;m=p+o|0;f[n+12>>2]=m>>>0<o>>>0?-1:m;d=d+1|0;if((d|0)==(h|0))break;else{n=n+16|0;g=g+8|0}}t=h;u=s+(e<<2<<2)|0}else{t=r;u=s}s=a+(f[c+(i+-1<<2)>>2]<<2<<1)|0;c=(j[s>>1]|0)<<16;a=(j[s+2>>1]|0)<<16;r=(j[s+4>>1]|0)<<16;e=(j[s+6>>1]|0)<<16;if((t|0)<(i|0)){v=u;w=t}else return;while(1){f[v>>2]=c;f[v+4>>2]=a;f[v+8>>2]=r;f[v+12>>2]=e;w=w+1|0;if((w|0)==(i|0))break;else v=v+16|0}return}function tna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;vna(a,b,c,d,e,f,g,h);return}function una(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;do if((g|0)>0){k=g<<1;if((b|0)<=0){l=d+(k<<2)|0;m=e;n=g;break}o=Y(g,b)|0;p=e;q=0;while(1){r=0;s=p;while(1){f[s>>2]=(j[a+(r<<1)>>1]|0)<<16;r=r+1|0;if((r|0)==(b|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(g|0))break;else p=p+(b<<2)|0}l=d+(k<<2)|0;m=e+(o<<2)|0;n=g}else{l=d;m=e;n=0}while(0);if((n|0)<(h|0))if((b|0)>0){e=m+((Y(h-n|0,b)|0)<<2)|0;d=l;l=n;g=m;while(1){p=a+((Y(f[c+(l<<2)>>2]|0,b)|0)<<1)|0;q=d+4|0;s=0;r=g;while(1){t=x1c(j[p+(s<<1)>>1]|0|0,0,f[d>>2]|0,0)|0;u=J;v=u>>>0<0|(u|0)==0&t>>>0<4294967295;u=v?t:-1;f[r>>2]=u;t=x1c(j[p+(s+b<<1)>>1]|0|0,0,f[q>>2]|0,0)|0;v=J;w=v>>>0<0|(v|0)==0&t>>>0<4294967295;v=w?t:-1;t=v+u|0;f[r>>2]=t>>>0<u>>>0?-1:t;s=s+1|0;if((s|0)==(b|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(h|0)){x=h;y=e;break}else{d=d+8|0;g=g+(b<<2)|0}}}else{x=h;y=m}else{x=n;y=m}m=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<1)|0;if((x|0)<(i|0)&(b|0)>0){z=x;A=y}else return;while(1){y=0;x=A;while(1){f[x>>2]=(j[m+(y<<1)>>1]|0)<<16;y=y+1|0;if((y|0)==(b|0))break;else x=x+4|0}z=z+1|0;if((z|0)==(i|0))break;else A=A+(b<<2)|0}return}function vna(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;do if((g|0)>0){k=g<<1;if((b|0)<=0){l=d+(k<<2)|0;m=e;n=g;break}o=Y(g,b)|0;p=e;q=0;while(1){r=0;s=p;while(1){f[s>>2]=(j[a+(r<<1)>>1]|0)<<16;r=r+1|0;if((r|0)==(b|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(g|0))break;else p=p+(b<<2)|0}l=d+(k<<2)|0;m=e+(o<<2)|0;n=g}else{l=d;m=e;n=0}while(0);if((n|0)<(h|0))if((b|0)>0){e=m+((Y(h-n|0,b)|0)<<2)|0;d=l;l=n;g=m;while(1){p=a+((Y(f[c+(l<<2)>>2]|0,b)|0)<<1)|0;q=d+4|0;s=0;r=g;while(1){t=f[d>>2]|0;if(!t)u=0;else{v=x1c(j[p+(s<<1)>>1]|0|0,0,t|0,0)|0;t=J;w=t>>>0<0|(t|0)==0&v>>>0<4294967295;t=w?v:-1;u=t}f[r>>2]=u;t=f[q>>2]|0;if(!t)x=0;else{v=x1c(j[p+(s+b<<1)>>1]|0|0,0,t|0,0)|0;t=J;w=t>>>0<0|(t|0)==0&v>>>0<4294967295;t=w?v:-1;x=t}t=u+x|0;f[r>>2]=t>>>0<u>>>0?-1:t;s=s+1|0;if((s|0)==(b|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(h|0)){y=h;z=e;break}else{d=d+8|0;g=g+(b<<2)|0}}}else{y=h;z=m}else{y=n;z=m}m=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<1)|0;if((y|0)<(i|0)&(b|0)>0){A=y;B=z}else return;while(1){z=0;y=B;while(1){f[y>>2]=(j[m+(z<<1)>>1]|0)<<16;z=z+1|0;if((z|0)==(b|0))break;else y=y+4|0}A=A+1|0;if((A|0)==(i|0))break;else B=B+(b<<2)|0}return}function wna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;NGc(j,b);p[h>>3]=.5;VGc(g,j,h);ZGc(k,a,g);p[l>>3]=.5;YGc(i,k,l);k=SGc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)>=(n|0)){f[c>>2]=n;n=a+16|0;j=f[n>>2]|0;f[n>>2]=(j|0)>(b|0)?b:j;u=e;return}f[c>>2]=k;NGc(m,k);YGc(l,i,m);if((f[l+4>>2]|0)<0)o=0;else{NGc(h,65536);ZGc(g,l,h);o=RGc(g)|0}f[d+4>>2]=o;f[d>>2]=o>>>0<65536?65536-o|0:0;u=e;return}o=a+12|0;a=b+1|0;b=f[o>>2]|0;f[o>>2]=(b|0)<(a|0)?a:b;u=e;return}function xna(a){a=a|0;cYc(a);return}function yna(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;c=u;u=u+1072|0;e=c+8|0;g=c;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;g1c(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=bYc(l>>>0>1073741823?-1:l<<2)|0;g1c(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[b>>2]|0;q=(o|0)<(l|0)?l:o;r=b+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[b>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=f[e>>2]|0;b=f[a+20>>2]|0;i=f[a+24>>2]|0;p=Y(f[j>>2]|0,f[h>>2]|0)|0;if((p|0)>0){k=y;do{o=b+(Y(i,k)|0)|0;t=0;do{d[o+(t<<1)>>1]=((f[l+(t<<2)>>2]|0)+32768|0)>>>16;t=t+1|0}while((t|0)!=(p|0));k=k+1|0}while((k|0)<(q|0));z=q}else z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;k=a+20|0;p=a+24|0;l=g+4|0;i=a+52|0;b=a+72|0;t=a+4|0;o=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[t>>2]|0)+(Y(f[o>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;wi[f[b>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){o1c(g|0,(f[i>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;o1c(g+(V<<2)|0,(f[i>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[k>>2]|0)+(Y(f[p>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=f[l>>2]|0;P=0;do{W=x1c(f[M+(P<<2)>>2]|0,0,R|0,0)|0;X=J;Z=x1c(f[M+(P+I<<2)>>2]|0,0,O|0,0)|0;_=d1c(Z|0,J|0,W|0,X|0)|0;Z=J;$=Z>>>0<X>>>0|(Z|0)==(X|0)&_>>>0<W>>>0;d1c(_|0,Z|0,-2147483648,0)|0;Z=$?0:J;_=$?0:0;$=_>>>0<0|(_|0)==0&Z>>>0<65535;_=$?Z:65535;d[Q+(P<<1)>>1]=_;P=P+1|0}while((P|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{aa=U;ba=K;ca=I;da=M;ea=T;break}}}else{aa=w;ba=x;ca=z;da=f[e>>2]|0;ea=f[a+16>>2]|0}if((aa+2|0)>(ea|0))fa=da+((Y(Y(f[h>>2]|0,(ba+~aa+ea|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{aa=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,ea+-1|0)|0)|0;wi[f[a+72>>2]&255](aa,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,da,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);fa=da}da=f[r>>2]|0;if((ca|0)<(da|0)?(r=f[a+20>>2]|0,aa=f[a+24>>2]|0,a=Y(f[j>>2]|0,f[h>>2]|0)|0,(a|0)>0):0){h=ca;do{ca=r+(Y(aa,h)|0)|0;j=0;do{d[ca+(j<<1)>>1]=((f[fa+(j<<2)>>2]|0)+32768|0)>>>16;j=j+1|0}while((j|0)!=(a|0));h=h+1|0}while((h|0)<(da|0))}da=f[e>>2]|0;if((da|0)==(m|0)){u=c;return}if(da|0)dYc(da);f[e>>2]=m;f[n>>2]=264;u=c;return}function zna(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=b[a>>0]<<16;if((h|0)>0){k=0;l=g;while(1){f[l>>2]=c;k=k+1|0;if((k|0)==(h|0))break;else l=l+4|0}m=e+(h<<1<<2)|0;n=h;o=g+(h<<2)|0}else{m=e;n=0;o=g}if((n|0)<(i|0)){g=m;m=n;e=o;while(1){h=a+(f[d+(m<<2)>>2]|0)|0;l=f[g>>2]|0;k=b[h>>0]|0;c=x1c(k|0,((k|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;k=d1c(c|0,l|0,-2147483648,0)|0;p=J;q=p>>>0<1|(p|0)==1&k>>>0<0?c:(l|0)>0|(l|0)==0&c>>>0>0?2147483647:-2147483648;c=f[g+4>>2]|0;l=b[h+1>>0]|0;h=x1c(l|0,((l|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;l=d1c(h|0,c|0,-2147483648,0)|0;k=J;p=k>>>0<1|(k|0)==1&l>>>0<0?h:(c|0)>0|(c|0)==0&h>>>0>0?2147483647:-2147483648;h=p+q|0;f[e>>2]=((h^q)&(h^p)|0)<0?(h|2147483647)^-2147483648:h;m=m+1|0;if((m|0)==(i|0))break;else{g=g+8|0;e=e+4|0}}r=i;s=o+(i-n<<2)|0}else{r=n;s=o}o=b[a+(f[d+(j+-1<<2)>>2]|0)>>0]<<16;if((r|0)<(j|0)){t=r;u=s}else return;while(1){f[u>>2]=o;t=t+1|0;if((t|0)==(j|0))break;else u=u+4|0}return}function Ana(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ina(a,b,c,d,e,f,g,h);return}function Bna(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;if((h|0)>0){l=h<<1;m=0;n=g;while(1){f[n>>2]=c;f[n+4>>2]=k;m=m+1|0;if((m|0)==(h|0))break;else n=n+8|0}o=e+(l<<2)|0;p=h;q=g+(l<<2)|0}else{o=e;p=0;q=g}if((p|0)<(i|0)){g=i-p|0;e=p;l=q;h=o;while(1){o=a+(f[d+(e<<2)>>2]<<1)|0;n=f[h>>2]|0;m=b[o>>0]|0;k=x1c(m|0,((m|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;n=J;m=d1c(k|0,n|0,-2147483648,0)|0;c=J;r=c>>>0<1|(c|0)==1&m>>>0<0?k:(n|0)>0|(n|0)==0&k>>>0>0?2147483647:-2147483648;k=h+4|0;n=f[k>>2]|0;m=b[o+2>>0]|0;c=x1c(m|0,((m|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;n=J;m=d1c(c|0,n|0,-2147483648,0)|0;s=J;t=s>>>0<1|(s|0)==1&m>>>0<0?c:(n|0)>0|(n|0)==0&c>>>0>0?2147483647:-2147483648;c=t+r|0;f[l>>2]=((c^r)&(c^t)|0)<0?(c|2147483647)^-2147483648:c;c=f[h>>2]|0;t=b[o+1>>0]|0;r=x1c(t|0,((t|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;t=d1c(r|0,c|0,-2147483648,0)|0;n=J;m=n>>>0<1|(n|0)==1&t>>>0<0?r:(c|0)>0|(c|0)==0&r>>>0>0?2147483647:-2147483648;r=f[k>>2]|0;k=b[o+3>>0]|0;o=x1c(k|0,((k|0)<0)<<31>>31|0,r|0,((r|0)<0)<<31>>31|0)|0;r=J;k=d1c(o|0,r|0,-2147483648,0)|0;c=J;t=c>>>0<1|(c|0)==1&k>>>0<0?o:(r|0)>0|(r|0)==0&o>>>0>0?2147483647:-2147483648;o=t+m|0;f[l+4>>2]=((o^m)&(o^t)|0)<0?(o|2147483647)^-2147483648:o;e=e+1|0;if((e|0)==(i|0))break;else{l=l+8|0;h=h+8|0}}u=i;v=q+(g<<1<<2)|0}else{u=p;v=q}q=a+(f[d+(j+-1<<2)>>2]<<1)|0;d=b[q>>0]<<16;a=b[q+1>>0]<<16;if((u|0)<(j|0)){w=v;x=u}else return;while(1){f[w>>2]=d;f[w+4>>2]=a;x=x+1|0;if((x|0)==(j|0))break;else w=w+8|0}return}function Cna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ina(a,b,c,d,e,f,g,h);return}function Dna(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;l=b[a+2>>0]<<16;if((h|0)>0){m=h*3|0;n=0;o=g;while(1){f[o>>2]=c;f[o+4>>2]=k;f[o+8>>2]=l;n=n+1|0;if((n|0)==(h|0))break;else o=o+12|0}p=e+(h<<1<<2)|0;q=h;r=g+(m<<2)|0}else{p=e;q=0;r=g}if((q|0)<(i|0)){g=i-q|0;e=q;m=r;h=p;while(1){p=a+((f[d+(e<<2)>>2]|0)*3|0)|0;o=f[h>>2]|0;n=b[p>>0]|0;l=x1c(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=d1c(l|0,o|0,-2147483648,0)|0;k=J;c=k>>>0<1|(k|0)==1&n>>>0<0?l:(o|0)>0|(o|0)==0&l>>>0>0?2147483647:-2147483648;l=h+4|0;o=f[l>>2]|0;n=b[p+3>>0]|0;k=x1c(n|0,((n|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;n=d1c(k|0,o|0,-2147483648,0)|0;s=J;t=s>>>0<1|(s|0)==1&n>>>0<0?k:(o|0)>0|(o|0)==0&k>>>0>0?2147483647:-2147483648;k=t+c|0;f[m>>2]=((k^c)&(k^t)|0)<0?(k|2147483647)^-2147483648:k;k=f[h>>2]|0;t=b[p+1>>0]|0;c=x1c(t|0,((t|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;k=J;t=d1c(c|0,k|0,-2147483648,0)|0;o=J;n=o>>>0<1|(o|0)==1&t>>>0<0?c:(k|0)>0|(k|0)==0&c>>>0>0?2147483647:-2147483648;c=f[l>>2]|0;k=b[p+4>>0]|0;t=x1c(k|0,((k|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;k=d1c(t|0,c|0,-2147483648,0)|0;o=J;s=o>>>0<1|(o|0)==1&k>>>0<0?t:(c|0)>0|(c|0)==0&t>>>0>0?2147483647:-2147483648;t=s+n|0;f[m+4>>2]=((t^n)&(t^s)|0)<0?(t|2147483647)^-2147483648:t;t=f[h>>2]|0;s=b[p+2>>0]|0;n=x1c(s|0,((s|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;s=d1c(n|0,t|0,-2147483648,0)|0;c=J;k=c>>>0<1|(c|0)==1&s>>>0<0?n:(t|0)>0|(t|0)==0&n>>>0>0?2147483647:-2147483648;n=f[l>>2]|0;l=b[p+5>>0]|0;p=x1c(l|0,((l|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;n=J;l=d1c(p|0,n|0,-2147483648,0)|0;t=J;s=t>>>0<1|(t|0)==1&l>>>0<0?p:(n|0)>0|(n|0)==0&p>>>0>0?2147483647:-2147483648;p=s+k|0;f[m+8>>2]=((p^k)&(p^s)|0)<0?(p|2147483647)^-2147483648:p;e=e+1|0;if((e|0)==(i|0))break;else{m=m+12|0;h=h+8|0}}u=i;v=r+(g*3<<2)|0}else{u=q;v=r}r=a+((f[d+(j+-1<<2)>>2]|0)*3|0)|0;d=b[r>>0]<<16;a=b[r+1>>0]<<16;q=b[r+2>>0]<<16;if((u|0)<(j|0)){w=v;x=u}else return;while(1){f[w>>2]=d;f[w+4>>2]=a;f[w+8>>2]=q;x=x+1|0;if((x|0)==(j|0))break;else w=w+12|0}return}function Ena(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ina(a,b,c,d,e,f,g,h);return}function Fna(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;l=b[a+2>>0]<<16;m=b[a+3>>0]<<16;if((h|0)>0){n=h<<2;o=0;p=g;while(1){f[p>>2]=c;f[p+4>>2]=k;f[p+8>>2]=l;f[p+12>>2]=m;o=o+1|0;if((o|0)==(h|0))break;else p=p+16|0}q=e+(h<<1<<2)|0;r=h;s=g+(n<<2)|0}else{q=e;r=0;s=g}if((r|0)<(i|0)){g=i-r|0;e=q;q=r;n=s;while(1){h=a+(f[d+(q<<2)>>2]<<2)|0;p=f[e>>2]|0;o=b[h>>0]|0;m=x1c(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=d1c(m|0,p|0,-2147483648,0)|0;l=J;k=l>>>0<1|(l|0)==1&o>>>0<0?m:(p|0)>0|(p|0)==0&m>>>0>0?2147483647:-2147483648;m=e+4|0;p=f[m>>2]|0;o=b[h+4>>0]|0;l=x1c(o|0,((o|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;p=J;o=d1c(l|0,p|0,-2147483648,0)|0;c=J;t=c>>>0<1|(c|0)==1&o>>>0<0?l:(p|0)>0|(p|0)==0&l>>>0>0?2147483647:-2147483648;l=t+k|0;f[n>>2]=((l^k)&(l^t)|0)<0?(l|2147483647)^-2147483648:l;l=f[e>>2]|0;t=b[h+1>>0]|0;k=x1c(t|0,((t|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;t=d1c(k|0,l|0,-2147483648,0)|0;p=J;o=p>>>0<1|(p|0)==1&t>>>0<0?k:(l|0)>0|(l|0)==0&k>>>0>0?2147483647:-2147483648;k=f[m>>2]|0;l=b[h+5>>0]|0;t=x1c(l|0,((l|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;k=J;l=d1c(t|0,k|0,-2147483648,0)|0;p=J;c=p>>>0<1|(p|0)==1&l>>>0<0?t:(k|0)>0|(k|0)==0&t>>>0>0?2147483647:-2147483648;t=c+o|0;f[n+4>>2]=((t^o)&(t^c)|0)<0?(t|2147483647)^-2147483648:t;t=f[e>>2]|0;c=b[h+2>>0]|0;o=x1c(c|0,((c|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;c=d1c(o|0,t|0,-2147483648,0)|0;k=J;l=k>>>0<1|(k|0)==1&c>>>0<0?o:(t|0)>0|(t|0)==0&o>>>0>0?2147483647:-2147483648;o=f[m>>2]|0;t=b[h+6>>0]|0;c=x1c(t|0,((t|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;o=J;t=d1c(c|0,o|0,-2147483648,0)|0;k=J;p=k>>>0<1|(k|0)==1&t>>>0<0?c:(o|0)>0|(o|0)==0&c>>>0>0?2147483647:-2147483648;c=p+l|0;f[n+8>>2]=((c^l)&(c^p)|0)<0?(c|2147483647)^-2147483648:c;c=f[e>>2]|0;p=b[h+3>>0]|0;l=x1c(p|0,((p|0)<0)<<31>>31|0,c|0,((c|0)<0)<<31>>31|0)|0;c=J;p=d1c(l|0,c|0,-2147483648,0)|0;o=J;t=o>>>0<1|(o|0)==1&p>>>0<0?l:(c|0)>0|(c|0)==0&l>>>0>0?2147483647:-2147483648;l=f[m>>2]|0;m=b[h+7>>0]|0;h=x1c(m|0,((m|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;l=J;m=d1c(h|0,l|0,-2147483648,0)|0;c=J;p=c>>>0<1|(c|0)==1&m>>>0<0?h:(l|0)>0|(l|0)==0&h>>>0>0?2147483647:-2147483648;h=p+t|0;f[n+12>>2]=((h^t)&(h^p)|0)<0?(h|2147483647)^-2147483648:h;q=q+1|0;if((q|0)==(i|0))break;else{e=e+8|0;n=n+16|0}}u=i;v=s+(g<<2<<2)|0}else{u=r;v=s}s=a+(f[d+(j+-1<<2)>>2]<<2)|0;d=b[s>>0]<<16;a=b[s+1>>0]<<16;r=b[s+2>>0]<<16;g=b[s+3>>0]<<16;if((u|0)<(j|0)){w=v;x=u}else return;while(1){f[w>>2]=d;f[w+4>>2]=a;f[w+8>>2]=r;f[w+12>>2]=g;x=x+1|0;if((x|0)==(j|0))break;else w=w+16|0}return}function Gna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ina(a,b,c,d,e,f,g,h);return}function Hna(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;do if((h|0)>0){k=h<<1;if((c|0)<=0){l=e+(k<<2)|0;m=g;n=h;break}o=Y(h,c)|0;p=g;q=0;while(1){r=0;s=p;while(1){f[s>>2]=b[a+r>>0]<<16;r=r+1|0;if((r|0)==(c|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(h|0))break;else p=p+(c<<2)|0}l=e+(k<<2)|0;m=g+(o<<2)|0;n=h}else{l=e;m=g;n=0}while(0);if((n|0)<(i|0))if((c|0)>0){g=m+((Y(i-n|0,c)|0)<<2)|0;e=l;l=n;h=m;while(1){p=a+(Y(f[d+(l<<2)>>2]|0,c)|0)|0;q=e+4|0;s=0;r=h;while(1){t=f[e>>2]|0;u=b[p+s>>0]|0;v=x1c(u|0,((u|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;u=d1c(v|0,t|0,-2147483648,0)|0;w=J;x=w>>>0<1|(w|0)==1&u>>>0<0?v:(t|0)>0|(t|0)==0&v>>>0>0?2147483647:-2147483648;f[r>>2]=x;v=f[q>>2]|0;t=b[p+(s+c)>>0]|0;u=x1c(t|0,((t|0)<0)<<31>>31|0,v|0,((v|0)<0)<<31>>31|0)|0;v=J;t=d1c(u|0,v|0,-2147483648,0)|0;w=J;y=w>>>0<1|(w|0)==1&t>>>0<0?u:(v|0)>0|(v|0)==0&u>>>0>0?2147483647:-2147483648;u=y+x|0;f[r>>2]=((u^x)&(u^y)|0)<0?(u|2147483647)^-2147483648:u;s=s+1|0;if((s|0)==(c|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(i|0)){z=i;A=g;break}else{e=e+8|0;h=h+(c<<2)|0}}}else{z=i;A=m}else{z=n;A=m}m=a+(Y(f[d+(j+-1<<2)>>2]|0,c)|0)|0;if((z|0)<(j|0)&(c|0)>0){B=z;C=A}else return;while(1){A=0;z=C;while(1){f[z>>2]=b[m+A>>0]<<16;A=A+1|0;if((A|0)==(c|0))break;else z=z+4|0}B=B+1|0;if((B|0)==(j|0))break;else C=C+(c<<2)|0}return}function Ina(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;do if((h|0)>0){k=h<<1;if((c|0)<=0){l=e+(k<<2)|0;m=g;n=h;break}o=Y(h,c)|0;p=g;q=0;while(1){r=0;s=p;while(1){f[s>>2]=b[a+r>>0]<<16;r=r+1|0;if((r|0)==(c|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(h|0))break;else p=p+(c<<2)|0}l=e+(k<<2)|0;m=g+(o<<2)|0;n=h}else{l=e;m=g;n=0}while(0);if((n|0)<(i|0))if((c|0)>0){g=m+((Y(i-n|0,c)|0)<<2)|0;e=l;l=n;h=m;while(1){p=a+(Y(f[d+(l<<2)>>2]|0,c)|0)|0;q=e+4|0;s=0;r=h;while(1){t=f[e>>2]|0;if(!t)u=0;else{v=b[p+s>>0]|0;w=x1c(v|0,((v|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;t=J;v=d1c(w|0,t|0,-2147483648,0)|0;x=J;u=x>>>0<1|(x|0)==1&v>>>0<0?w:(t|0)>0|(t|0)==0&w>>>0>0?2147483647:-2147483648}f[r>>2]=u;w=f[q>>2]|0;if(!w)y=0;else{t=b[p+(s+c)>>0]|0;v=x1c(t|0,((t|0)<0)<<31>>31|0,w|0,((w|0)<0)<<31>>31|0)|0;w=J;t=d1c(v|0,w|0,-2147483648,0)|0;x=J;y=x>>>0<1|(x|0)==1&t>>>0<0?v:(w|0)>0|(w|0)==0&v>>>0>0?2147483647:-2147483648}v=u+y|0;f[r>>2]=((v^u)&(v^y)|0)<0?(v|2147483647)^-2147483648:v;s=s+1|0;if((s|0)==(c|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(i|0)){z=i;A=g;break}else{e=e+8|0;h=h+(c<<2)|0}}}else{z=i;A=m}else{z=n;A=m}m=a+(Y(f[d+(j+-1<<2)>>2]|0,c)|0)|0;if((z|0)<(j|0)&(c|0)>0){B=z;C=A}else return;while(1){A=0;z=C;while(1){f[z>>2]=b[m+A>>0]<<16;A=A+1|0;if((A|0)==(c|0))break;else z=z+4|0}B=B+1|0;if((B|0)==(j|0))break;else C=C+(c<<2)|0}return}function Jna(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;NGc(j,b);p[h>>3]=.5;VGc(g,j,h);ZGc(k,a,g);p[l>>3]=.5;YGc(i,k,l);k=SGc(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;NGc(m,k);YGc(l,i,m);NGc(h,65536);ZGc(g,l,h);h=RGc(g)|0;f[d+4>>2]=h;g=65536-h|0;f[d>>2]=(g&h|0)<0?(g|2147483647)^-2147483648:g;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function Kna(a){a=a|0;cYc(a);return}function Lna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+1072|0;e=d+8|0;g=d;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;g1c(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=bYc(l>>>0>1073741823?-1:l<<2)|0;g1c(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[c>>2]|0;q=(o|0)<(l|0)?l:o;r=c+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[c>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=a+20|0;c=a+24|0;i=y;do{p=f[e>>2]|0;k=(f[l>>2]|0)+(Y(f[c>>2]|0,i)|0)|0;o=Y(f[j>>2]|0,f[h>>2]|0)|0;if((o|0)>0){t=0;do{s=(f[p+(t<<2)>>2]|0)+32768>>16;b[k+t>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;t=t+1|0}while((t|0)!=(o|0))}i=i+1|0}while((i|0)<(q|0));z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;i=a+20|0;c=a+24|0;l=g+4|0;o=a+52|0;t=a+72|0;k=a+4|0;p=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[k>>2]|0)+(Y(f[p>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;wi[f[t>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){o1c(g|0,(f[o>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;o1c(g+(V<<2)|0,(f[o>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[i>>2]|0)+(Y(f[c>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=f[l>>2]|0;P=((R|0)<0)<<31>>31;W=((O|0)<0)<<31>>31;X=0;do{Z=f[M+(X<<2)>>2]|0;_=x1c(R|0,P|0,Z|0,((Z|0)<0)<<31>>31|0)|0;Z=J;$=f[M+(X+I<<2)>>2]|0;aa=x1c(O|0,W|0,$|0,(($|0)<0)<<31>>31|0)|0;$=J;ba=d1c(aa|0,$|0,_|0,Z|0)|0;_=J;aa=((_^Z)&(_^$)|0)<0;$=d1c((aa?-1:ba)|0,(aa?(_|2147483647)^-2147483648:_)|0,-2147483648,0)|0;_=k1c($|0,J|0,32)|0;$=J;aa=d1c(_|0,$|0,128,0)|0;ba=J;b[Q+X>>0]=ba>>>0<0|(ba|0)==0&aa>>>0<256?_&255:($|0)>0|($|0)==0&_>>>0>0?127:-128;X=X+1|0}while((X|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{ca=U;da=K;ea=I;fa=q;break}}}else{ca=w;da=x;ea=z;fa=a+16|0}z=f[e>>2]|0;x=f[fa>>2]|0;if((ca+2|0)>(x|0))ga=z+((Y(Y(f[h>>2]|0,(da+~ca+x|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{ca=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,x+-1|0)|0)|0;wi[f[a+72>>2]&255](ca,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,z,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ga=z}z=f[r>>2]|0;if((ea|0)<(z|0)){ca=a+20|0;x=a+24|0;a=ea;ea=z;while(1){z=(f[ca>>2]|0)+(Y(f[x>>2]|0,a)|0)|0;da=Y(f[j>>2]|0,f[h>>2]|0)|0;if((da|0)>0){fa=0;do{w=(f[ga+(fa<<2)>>2]|0)+32768>>16;b[z+fa>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;fa=fa+1|0}while((fa|0)!=(da|0));ha=f[r>>2]|0}else ha=ea;a=a+1|0;if((a|0)>=(ha|0))break;else ea=ha}}ha=f[e>>2]|0;if((ha|0)==(m|0)){u=d;return}if(ha|0)dYc(ha);f[e>>2]=m;f[n>>2]=264;u=d;return}function Mna(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=(h[a>>0]|0)<<8&65535;if((i|0)>0){m=i<<1;n=0;o=g;while(1){d[o>>1]=b;n=n+1|0;if((n|0)==(i|0))break;else o=o+2|0}p=e+(m<<1)|0;q=i;r=g+(i<<1)|0}else{p=e;q=0;r=g}if((q|0)<(k|0)){g=k-q|0;e=q;i=r;m=p;while(1){p=a+(f[c+(e<<2)>>2]|0)|0;o=Y(h[p>>0]|0,j[m>>1]|0)|0;n=o>>>0<65535?o:65535;o=Y(h[p+1>>0]|0,j[m+2>>1]|0)|0;p=(o>>>0<65535?o:65535)+n|0;d[i>>1]=n>>>0>(p&65535)>>>0?-1:p&65535;e=e+1|0;if((e|0)==(k|0))break;else{i=i+2|0;m=m+4|0}}s=k;t=r+(g<<1)|0}else{s=q;t=r}r=(h[a+(f[c+(l+-1<<2)>>2]|0)>>0]|0)<<8&65535;if((s|0)<(l|0)){u=t;v=s}else return;while(1){d[u>>1]=r;v=v+1|0;if((v|0)==(l|0))break;else u=u+2|0}return}function Nna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Vna(a,b,c,d,e,f,g,h);return}function Ona(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=(h[a>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;if((i|0)>0){n=i<<1;o=g+(n<<1)|0;p=0;q=g;while(1){d[q>>1]=b;d[q+2>>1]=m;p=p+1|0;if((p|0)==(i|0))break;else q=q+4|0}r=e+(n<<1)|0;s=i;t=o}else{r=e;s=0;t=g}if((s|0)<(k|0)){g=k-s<<1;e=s;o=t;i=r;while(1){r=a+(f[c+(e<<2)>>2]<<1)|0;n=Y(h[r>>0]|0,j[i>>1]|0)|0;q=n>>>0<65535?n:65535;n=i+2|0;p=Y(h[r+2>>0]|0,j[n>>1]|0)|0;m=(p>>>0<65535?p:65535)+q|0;d[o>>1]=q>>>0>(m&65535)>>>0?-1:m&65535;m=Y(h[r+1>>0]|0,j[i>>1]|0)|0;q=m>>>0<65535?m:65535;m=Y(h[r+3>>0]|0,j[n>>1]|0)|0;n=(m>>>0<65535?m:65535)+q|0;d[o+2>>1]=q>>>0>(n&65535)>>>0?-1:n&65535;e=e+1|0;if((e|0)==(k|0))break;else{o=o+4|0;i=i+4|0}}u=k;v=t+(g<<1)|0}else{u=s;v=t}t=a+(f[c+(l+-1<<2)>>2]<<1)|0;c=(h[t>>0]|0)<<8&65535;a=(h[t+1>>0]|0)<<8&65535;if((u|0)<(l|0)){w=v;x=u}else return;while(1){d[w>>1]=c;d[w+2>>1]=a;x=x+1|0;if((x|0)==(l|0))break;else w=w+4|0}return}function Pna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Vna(a,b,c,d,e,f,g,h);return}function Qna(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=(h[a>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;n=(h[a+2>>0]|0)<<8&65535;if((i|0)>0){o=i*3|0;p=0;q=g;while(1){d[q>>1]=b;d[q+2>>1]=m;d[q+4>>1]=n;p=p+1|0;if((p|0)==(i|0))break;else q=q+6|0}r=e+(i<<1<<1)|0;s=i;t=g+(o<<1)|0}else{r=e;s=0;t=g}if((s|0)<(k|0)){g=k-s|0;e=s;o=t;i=r;while(1){r=a+((f[c+(e<<2)>>2]|0)*3|0)|0;q=Y(h[r>>0]|0,j[i>>1]|0)|0;p=q>>>0<65535?q:65535;q=i+2|0;n=Y(h[r+3>>0]|0,j[q>>1]|0)|0;m=(n>>>0<65535?n:65535)+p|0;d[o>>1]=p>>>0>(m&65535)>>>0?-1:m&65535;m=Y(h[r+1>>0]|0,j[i>>1]|0)|0;p=m>>>0<65535?m:65535;m=Y(h[r+4>>0]|0,j[q>>1]|0)|0;n=(m>>>0<65535?m:65535)+p|0;d[o+2>>1]=p>>>0>(n&65535)>>>0?-1:n&65535;n=Y(h[r+2>>0]|0,j[i>>1]|0)|0;p=n>>>0<65535?n:65535;n=Y(h[r+5>>0]|0,j[q>>1]|0)|0;q=(n>>>0<65535?n:65535)+p|0;d[o+4>>1]=p>>>0>(q&65535)>>>0?-1:q&65535;e=e+1|0;if((e|0)==(k|0))break;else{o=o+6|0;i=i+4|0}}u=k;v=t+(g*3<<1)|0}else{u=s;v=t}t=a+((f[c+(l+-1<<2)>>2]|0)*3|0)|0;c=(h[t>>0]|0)<<8&65535;a=(h[t+1>>0]|0)<<8&65535;s=(h[t+2>>0]|0)<<8&65535;if((u|0)<(l|0)){w=v;x=u}else return;while(1){d[w>>1]=c;d[w+2>>1]=a;d[w+4>>1]=s;x=x+1|0;if((x|0)==(l|0))break;else w=w+6|0}return}function Rna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Vna(a,b,c,d,e,f,g,h);return}function Sna(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((i|0)>0){i=(h[a+3>>0]|0)<<8&65535;b=(h[a+2>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;d[g>>1]=(h[a>>0]|0)<<8;d[g+2>>1]=m;d[g+4>>1]=b;d[g+6>>1]=i;n=e+4|0;o=1;p=g+8|0}else{n=e;o=0;p=g}if((o|0)<(k|0)){g=k-o<<2;e=n;n=o;i=p;while(1){b=a+(f[c+(n<<2)>>2]<<2)|0;m=Y(h[b>>0]|0,j[e>>1]|0)|0;q=m>>>0<65535?m:65535;m=e+2|0;r=Y(h[b+4>>0]|0,j[m>>1]|0)|0;s=(r>>>0<65535?r:65535)+q|0;d[i>>1]=q>>>0>(s&65535)>>>0?-1:s&65535;s=Y(h[b+1>>0]|0,j[e>>1]|0)|0;q=s>>>0<65535?s:65535;s=Y(h[b+5>>0]|0,j[m>>1]|0)|0;r=(s>>>0<65535?s:65535)+q|0;d[i+2>>1]=q>>>0>(r&65535)>>>0?-1:r&65535;r=Y(h[b+2>>0]|0,j[e>>1]|0)|0;q=r>>>0<65535?r:65535;r=Y(h[b+6>>0]|0,j[m>>1]|0)|0;s=(r>>>0<65535?r:65535)+q|0;d[i+4>>1]=q>>>0>(s&65535)>>>0?-1:s&65535;s=Y(h[b+3>>0]|0,j[e>>1]|0)|0;q=s>>>0<65535?s:65535;s=Y(h[b+7>>0]|0,j[m>>1]|0)|0;m=(s>>>0<65535?s:65535)+q|0;d[i+6>>1]=q>>>0>(m&65535)>>>0?-1:m&65535;n=n+1|0;if((n|0)==(k|0))break;else{e=e+4|0;i=i+8|0}}t=k;u=p+(g<<1)|0}else{t=o;u=p}p=a+(f[c+(l+-1<<2)>>2]<<2)|0;if((t|0)>=(l|0))return;l=(h[p+3>>0]|0)<<8&65535;t=(h[p+2>>0]|0)<<8&65535;c=(h[p+1>>0]|0)<<8&65535;d[u>>1]=(h[p>>0]|0)<<8;d[u+2>>1]=c;d[u+4>>1]=t;d[u+6>>1]=l;return}function Tna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Vna(a,b,c,d,e,f,g,h);return}function Una(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;do if((i|0)>0){m=i<<1;if((b|0)<=0){n=e+(m<<1)|0;o=g;p=i;break}q=Y(i,b)|0;r=g;s=0;while(1){t=0;u=r;while(1){d[u>>1]=(h[a+t>>0]|0)<<8;t=t+1|0;if((t|0)==(b|0))break;else u=u+2|0}s=s+1|0;if((s|0)==(i|0))break;else r=r+(b<<1)|0}n=e+(m<<1)|0;o=g+(q<<1)|0;p=i}else{n=e;o=g;p=0}while(0);if((p|0)<(k|0))if((b|0)>0){g=o+((Y(k-p|0,b)|0)<<1)|0;e=n;n=p;i=o;while(1){r=a+(Y(f[c+(n<<2)>>2]|0,b)|0)|0;s=e+2|0;u=0;t=i;while(1){v=Y(h[r+u>>0]|0,j[e>>1]|0)|0;w=v>>>0<65535?v:65535;d[t>>1]=w;v=Y(h[r+(u+b)>>0]|0,j[s>>1]|0)|0;x=(v>>>0<65535?v:65535)+w|0;d[t>>1]=w>>>0>(x&65535)>>>0?-1:x&65535;u=u+1|0;if((u|0)==(b|0))break;else t=t+2|0}n=n+1|0;if((n|0)==(k|0)){y=k;z=g;break}else{e=e+4|0;i=i+(b<<1)|0}}}else{y=k;z=o}else{y=p;z=o}o=a+(Y(f[c+(l+-1<<2)>>2]|0,b)|0)|0;if((y|0)<(l|0)&(b|0)>0){A=y;B=z}else return;while(1){z=0;y=B;while(1){d[y>>1]=(h[o+z>>0]|0)<<8;z=z+1|0;if((z|0)==(b|0))break;else y=y+2|0}A=A+1|0;if((A|0)==(l|0))break;else B=B+(b<<1)|0}return}function Vna(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;do if((i|0)>0){l=i<<1;if((b|0)<=0){m=e+(l<<1)|0;n=g;o=i;break}p=Y(i,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){d[t>>1]=(h[a+s>>0]|0)<<8;s=s+1|0;if((s|0)==(b|0))break;else t=t+2|0}r=r+1|0;if((r|0)==(i|0))break;else q=q+(b<<1)|0}m=e+(l<<1)|0;n=g+(p<<1)|0;o=i}else{m=e;n=g;o=0}while(0);if((o|0)<(j|0))if((b|0)>0){g=n+((Y(j-o|0,b)|0)<<1)|0;e=m;m=o;i=n;while(1){q=a+(Y(f[c+(m<<2)>>2]|0,b)|0)|0;r=e+2|0;t=0;s=i;while(1){u=d[e>>1]|0;if(!(u<<16>>16))v=0;else{w=Y(h[q+t>>0]|0,u&65535)|0;v=(w>>>0<65535?w:65535)&65535}d[s>>1]=v;w=d[r>>1]|0;if(!(w<<16>>16))x=0;else{u=Y(h[q+(t+b)>>0]|0,w&65535)|0;x=u>>>0<65535?u:65535}u=v&65535;w=u+x|0;d[s>>1]=u>>>0>(w&65535)>>>0?-1:w&65535;t=t+1|0;if((t|0)==(b|0))break;else s=s+2|0}m=m+1|0;if((m|0)==(j|0)){y=j;z=g;break}else{e=e+4|0;i=i+(b<<1)|0}}}else{y=j;z=n}else{y=o;z=n}n=a+(Y(f[c+(k+-1<<2)>>2]|0,b)|0)|0;if((y|0)<(k|0)&(b|0)>0){A=y;B=z}else return;while(1){z=0;y=B;while(1){d[y>>1]=(h[n+z>>0]|0)<<8;z=z+1|0;if((z|0)==(b|0))break;else y=y+2|0}A=A+1|0;if((A|0)==(k|0))break;else B=B+(b<<1)|0}return}function Wna(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=u;u=u+64|0;h=g+48|0;i=g+40|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;NGc(k,b);p[i>>3]=.5;VGc(h,k,i);ZGc(l,a,h);p[m>>3]=.5;YGc(j,l,m);l=SGc(j)|0;if((l|0)>-1?(k=f[a+8>>2]|0,(k|0)>1):0){o=k+-1|0;if((l|0)>=(o|0)){f[c>>2]=o;o=a+16|0;k=f[o>>2]|0;f[o>>2]=(k|0)>(b|0)?b:k;u=g;return}f[c>>2]=l;NGc(n,l);YGc(m,j,n);if((f[m+4>>2]|0)<0)q=0;else{NGc(i,256);ZGc(h,m,i);q=(RGc(h)|0)&65535}d[e+2>>1]=q;d[e>>1]=(q&65535)<256?256-(q&65535)&65535:0;u=g;return}q=a+12|0;a=b+1|0;b=f[q>>2]|0;f[q>>2]=(b|0)<(a|0)?a:b;u=g;return}function Xna(a){a=a|0;cYc(a);return}function Yna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;d=u;u=u+1056|0;e=d+8|0;g=d;h=a+28|0;i=f[h>>2]|0;k=a+36|0;l=f[k>>2]|0;m=Y(i<<1,l)|0;n=e+8|0;g1c(n|0,0,1040)|0;f[e>>2]=n;o=e+4|0;f[o>>2]=m;if(m>>>0>520){p=bYc(m>>>0>2147483647?-1:m<<1)|0;g1c(p|0,0,m<<1|0)|0;f[e>>2]=p;q=p}else q=n;p=f[a+64>>2]|0;m=f[c>>2]|0;r=(p|0)<(m|0)?m:p;s=c+4|0;t=f[s>>2]|0;v=f[a+68>>2]|0;w=(t|0)<(v|0)?t:v;if((m|0)<(p|0)){wi[f[a+72>>2]&255](f[a+4>>2]|0,l,f[a+40>>2]|0,f[a+48>>2]|0,q,f[a+56>>2]|0,f[a+60>>2]|0,i);x=-1;y=1;z=f[c>>2]|0}else{x=-2;y=0;z=m}if((z|0)<(r|0)){m=a+20|0;c=a+24|0;i=z;do{q=Y(f[k>>2]|0,f[h>>2]|0)|0;if((q|0)>0){l=(f[m>>2]|0)+(Y(f[c>>2]|0,i)|0)|0;p=f[e>>2]|0;v=l;l=0;while(1){b[v>>0]=((j[p>>1]|0)+128|0)>>>8;l=l+1|0;if((l|0)==(q|0))break;else{p=p+2|0;v=v+1|0}}}i=i+1|0}while((i|0)<(r|0));A=r}else A=z;if((A|0)<(w|0)){z=a+44|0;r=a+16|0;i=a+20|0;c=a+24|0;m=g+2|0;v=a+52|0;p=a+72|0;q=a+4|0;l=a+8|0;t=a+40|0;B=a+48|0;C=a+56|0;D=a+60|0;E=x;F=y;G=A;H=0;while(1){I=A+H<<1;J=(f[z>>2]|0)+(G<<2)|0;K=E+2|0;L=f[J>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[r>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=F;while(1){O=(f[q>>2]|0)+(Y(f[l>>2]|0,K)|0)|0;P=f[k>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<1)|0;wi[f[p>>2]&255](O,P,f[t>>2]|0,f[B>>2]|0,R,f[C>>2]|0,f[D>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[J>>2]|0;P=R+2|0;O=f[r>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=F;T=N;U=L}M=T+-2|0;f[g>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((E|0)<(M|0)?M:E)|0)%2|0;if((K|0)>0){o1c(g|0,(f[v>>2]|0)+((G<<1)+2-K<<1)|0,K<<1|0)|0;V=K}else V=0;o1c(g+(V<<1)|0,(f[v>>2]|0)+(V+I-K<<1)|0,4-(V<<1)|0)|0;M=f[e>>2]|0;J=Y(f[k>>2]|0,f[h>>2]|0)|0;if((J|0)>0){Q=0;R=M;O=(f[i>>2]|0)+(Y(f[c>>2]|0,G)|0)|0;P=M+(J<<1)|0;while(1){M=Y(j[g>>1]|0,j[R>>1]|0)|0;W=(Y(j[m>>1]|0,j[P>>1]|0)|0)+M|0;X=W>>>0<M>>>0?0:(W+32768|0)>>>16;b[O>>0]=X>>>0<255?X:255;Q=Q+1|0;if((Q|0)==(J|0))break;else{R=R+2|0;O=O+1|0;P=P+2|0}}}P=G+1|0;if((P|0)<(w|0)){E=U;F=K;G=P;H=H+1|0}else{Z=U;_=K;$=P;aa=r;break}}}else{Z=x;_=y;$=A;aa=a+16|0}A=f[e>>2]|0;y=f[aa>>2]|0;if((Z+2|0)>(y|0))ba=A+((Y(Y(f[h>>2]|0,(_+~Z+y|0)%2|0)|0,f[k>>2]|0)|0)<<1)|0;else{Z=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,y+-1|0)|0)|0;wi[f[a+72>>2]&255](Z,f[k>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,A,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ba=A}A=f[s>>2]|0;if(($|0)<(A|0)){Z=a+20|0;y=a+24|0;a=$;$=A;while(1){A=Y(f[k>>2]|0,f[h>>2]|0)|0;if((A|0)>0){_=ba;aa=(f[Z>>2]|0)+(Y(f[y>>2]|0,a)|0)|0;x=0;while(1){b[aa>>0]=((j[_>>1]|0)+128|0)>>>8;x=x+1|0;if((x|0)==(A|0))break;else{_=_+2|0;aa=aa+1|0}}ca=f[s>>2]|0}else ca=$;a=a+1|0;if((a|0)>=(ca|0))break;else $=ca}}ca=f[e>>2]|0;if((ca|0)==(n|0)){u=d;return}if(ca|0)dYc(ca);f[e>>2]=n;f[o>>2]=520;u=d;return}function Zna(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0;i=u;u=u+144|0;j=i+136|0;k=i+80|0;l=i+72|0;m=i+16|0;n=i;cS(j,a,-1);o=f[j>>2]|0;if((o|0)<1){p=$Xc(16)|0;f[k>>2]=p;q=k+8|0;f[q>>2]=-2147483632;r=k+4|0;f[r>>2]=14;s=p;t=267376;v=s+14|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+14|0;b[w>>0]=0;vM(-215,k,264464,264471,3784)}x=j+4|0;y=f[x>>2]|0;if((y|0)<1){p=$Xc(16)|0;f[k>>2]=p;q=k+8|0;f[q>>2]=-2147483632;r=k+4|0;f[r>>2]=14;s=p;t=267376;v=s+14|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=p+14|0;b[w>>0]=0;vM(-215,k,264464,264471,3784)}w=f[d>>2]|0;p=(w|0)<1;if(!p?(f[d+4>>2]|0)>=1:0)z=10;else{if(!(e>0.0&g>0.0)){r=$Xc(64)|0;f[k>>2]=r;f[k+8>>2]=-2147483584;f[k+4>>2]=54;s=r;t=267391;v=s+54|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+54>>0]=0;vM(-215,k,264464,264471,3785)}if(p){A=d+4|0;z=11}else z=10}if((z|0)==10){p=d+4|0;r=f[p>>2]|0;if((r|0)<1){A=p;z=11}else{B=+(r|0)/+(y|0);C=+(w|0)/+(o|0)}}if((z|0)==11){z=zLc(+(o|0)*e)|0;o=zLc(+(y|0)*g)|0;f[d>>2]=z;f[A>>2]=o;if((z|0)<1|(o|0)<1){o=$Xc(16)|0;f[k>>2]=o;f[k+8>>2]=-2147483632;f[k+4>>2]=14;s=o;t=264542;v=s+14|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[o+14>>0]=0;vM(-215,k,264464,264471,3790)}else{B=g;C=e}}do if((h|0)==5){if((qS(a,-1)|0)!=5?(qS(a,-1)|0)!=6:0){D=5;break}D=1}else D=h;while(0);do if((eS(a)|0)==65536){h=f[a+4>>2]|0;f[k>>2]=f[h>>2];o=k+4|0;t=h+4|0;f[o>>2]=f[t>>2];s=k+8|0;f[s>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];f[k+16>>2]=f[h+16>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];v=f[h+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=s;s=k+48|0;z=k+44|0;f[z>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(v|0){s=v+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[t>>2]|0)<3){t=f[h+44>>2]|0;s=f[z>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2];E=k;break}else{f[o>>2]=0;U$(k,h);E=k;break}}else{bS(k,a,-1);E=k}while(0);f[l>>2]=f[d>>2];a=d+4|0;f[l+4>>2]=f[a>>2];wS(c,l,f[E>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];h=m+4|0;o=l+4|0;f[h>>2]=f[o>>2];t=m+8|0;f[t>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];s=f[l+36>>2]|0;f[m+36>>2]=s;f[m+40>>2]=t;t=m+48|0;z=m+44|0;f[z>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[o>>2]|0)<3){o=f[l+44>>2]|0;t=f[z>>2]|0;f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];break}else{f[h>>2]=0;U$(m,l);break}}else bS(m,c,-1);while(0);if((f[d>>2]|0)==(f[j>>2]|0)?(f[a>>2]|0)==(f[x>>2]|0):0){x=n+8|0;f[x>>2]=0;f[x+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=m;jR(k,n)}else $ja(f[E>>2]&4095,f[k+16>>2]|0,f[k+48>>2]|0,f[k+12>>2]|0,f[k+8>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,f[m+12>>2]|0,f[m+8>>2]|0,C,B,D);D=m+36|0;E=f[D>>2]|0;if(E|0?(n=E+12|0,E=f[n>>2]|0,f[n>>2]=E+-1,(E|0)==1):0)V$(m);f[D>>2]=0;D=m+16|0;E=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[E>>2]|0)>0){D=f[m+40>>2]|0;n=0;do{f[D+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[E>>2]|0))}E=f[m+44>>2]|0;if((E|0)!=(m+48|0))wL(E);E=k+36|0;m=f[E>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)V$(k);f[E>>2]=0;E=k+16|0;m=k+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[m>>2]|0)>0){E=f[k+40>>2]|0;n=0;do{f[E+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)==(k+48|0)){u=i;return}wL(m);u=i;return}function _na(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;i=u;u=u+1360|0;j=i+336|0;k=i+280|0;l=i+272|0;m=i+144|0;n=i;o=i+216|0;q=i+160|0;do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[k>>2]=f[r>>2];s=k+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=k+8|0;f[v>>2]=f[r+8>>2];f[k+12>>2]=f[r+12>>2];f[k+16>>2]=f[r+16>>2];f[k+20>>2]=f[r+20>>2];f[k+24>>2]=f[r+24>>2];f[k+28>>2]=f[r+28>>2];f[k+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[k+36>>2]=w;f[k+40>>2]=v;v=k+48|0;x=k+44|0;f[x>>2]=v;f[v>>2]=0;f[k+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;U$(k,r);break}}else bS(k,a,-1);while(0);a=g&7;switch(g&-8|0){case 24:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;r=$Xc(64)|0;f[j>>2]=r;f[j+8>>2]=-2147483584;f[j+4>>2]=57;y=r;z=267446;A=y+57|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[r+57>>0]=0;vM(-215,j,470916,267504,1386);break}case 8:{r=f[k>>2]|0;if(r&4095|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;s=$Xc(32)|0;f[j>>2]=s;f[j+8>>2]=-2147483616;f[j+4>>2]=21;y=s;z=369201;A=y+21|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[s+21>>0]=0;vM(-215,j,470916,267504,1389)}s=k+40|0;t=f[s>>2]|0;v=f[t+4>>2]|0;x=f[t>>2]|0;w=(r&16384|0)!=0;B=Y(x,v)|0;C=w?B:v;v=w?1:x;x=w?B:f[k+48>>2]|0;g1c(j|0,0,1024)|0;a:do if((v|0)>0){w=f[k+16>>2]|0;D=C+-4|0;if((C|0)<4){if((C|0)>0)E=0;else{F=0.0;G=0;break}while(1){H=w+(Y(E,x)|0)|0;I=0;do{J=j+((h[H+I>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;I=I+1|0}while((I|0)!=(C|0));E=E+1|0;if((E|0)==(v|0)){F=0.0;G=0;break a}}}I=C&-4;if((I|0)<(C|0))K=0;else{H=0;while(1){J=w+(Y(H,x)|0)|0;L=0;do{M=h[J+(L|1)>>0]|0;N=j+((h[J+L>>0]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=j+(M<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=h[J+(L|3)>>0]|0;M=j+((h[J+(L|2)>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=j+(N<<2)|0;f[M>>2]=(f[M>>2]|0)+1;L=L+4|0}while((L|0)<=(D|0));H=H+1|0;if((H|0)==(v|0)){F=0.0;G=0;break a}}}do{H=w+(Y(K,x)|0)|0;L=0;do{J=h[H+(L|1)>>0]|0;M=j+((h[H+L>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=j+(J<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[H+(L|3)>>0]|0;J=j+((h[H+(L|2)>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;J=j+(M<<2)|0;f[J>>2]=(f[J>>2]|0)+1;L=L+4|0}while((L|0)<=(D|0));O=I;do{L=j+((h[H+O>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;O=O+1|0}while((O|0)!=(C|0));K=K+1|0}while((K|0)!=(v|0));F=0.0;G=0}else{F=0.0;G=0}while(0);do{F=F+ +(G|0)*+(f[j+(G<<2)>>2]|0);G=G+1|0}while((G|0)!=256);P=1.0/+(B|0);Q=P*F;F=0.0;R=0.0;S=0.0;T=0.0;B=0;while(1){U=P*+(f[j+(B<<2)>>2]|0);V=T*F;F=F+U;W=1.0-F;if(!((W<F?W:F)<1.1920928955078125e-07)?!((F<W?W:F)>.9999998807907104):0){X=+(B|0);Z=(V+X*U)/F;U=Z-(Q-F*Z)/W;_=U*(F*W*U);G=_>S;$=Z;aa=G?X:R;ba=G?_:S}else{$=V;aa=R;ba=S}B=B+1|0;if((B|0)==256)break;else{R=aa;S=ba;T=$}}ca=aa;da=k;ea=s;fa=t;ga=r;break}case 16:{r=f[k>>2]|0;if(r&4095|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;t=$Xc(32)|0;f[j>>2]=t;f[j+8>>2]=-2147483616;f[j+4>>2]=21;y=t;z=369201;A=y+21|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[t+21>>0]=0;vM(-215,j,470916,267504,1394)}t=k+40|0;z=f[t>>2]|0;y=f[z+4>>2]|0;A=f[z>>2]|0;s=(r&16384|0)!=0;B=Y(A,y)|0;G=s?1:A;A=s?B:y;y=s?B:f[k+48>>2]|0;g1c(j|0,0,1024)|0;b:do if((G|0)>0){B=f[k+16>>2]|0;s=A+-4|0;if((A|0)<4){if((A|0)>0)ha=0;else{ia=0;break}while(1){v=B+(Y(ha,y)|0)|0;K=0;do{C=j+((h[v+K>>0]|0)<<2)|0;f[C>>2]=(f[C>>2]|0)+1;K=K+1|0}while((K|0)!=(A|0));ha=ha+1|0;if((ha|0)==(G|0)){ia=0;break b}}}K=A&-4;if((K|0)<(A|0))ja=0;else{v=0;while(1){C=B+(Y(v,y)|0)|0;O=0;do{x=h[C+(O|1)>>0]|0;E=j+((h[C+O>>0]|0)<<2)|0;f[E>>2]=(f[E>>2]|0)+1;E=j+(x<<2)|0;f[E>>2]=(f[E>>2]|0)+1;E=h[C+(O|3)>>0]|0;x=j+((h[C+(O|2)>>0]|0)<<2)|0;f[x>>2]=(f[x>>2]|0)+1;x=j+(E<<2)|0;f[x>>2]=(f[x>>2]|0)+1;O=O+4|0}while((O|0)<=(s|0));v=v+1|0;if((v|0)==(G|0)){ia=0;break b}}}do{v=B+(Y(ja,y)|0)|0;O=0;do{C=h[v+(O|1)>>0]|0;x=j+((h[v+O>>0]|0)<<2)|0;f[x>>2]=(f[x>>2]|0)+1;x=j+(C<<2)|0;f[x>>2]=(f[x>>2]|0)+1;x=h[v+(O|3)>>0]|0;C=j+((h[v+(O|2)>>0]|0)<<2)|0;f[C>>2]=(f[C>>2]|0)+1;C=j+(x<<2)|0;f[C>>2]=(f[C>>2]|0)+1;O=O+4|0}while((O|0)<=(s|0));ka=K;do{O=j+((h[v+ka>>0]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;ka=ka+1|0}while((ka|0)!=(A|0));ja=ja+1|0}while((ja|0)!=(G|0));ia=0}else ia=0;while(0);while(1){if((f[j+(ia<<2)>>2]|0)>0){la=ia;break}ia=ia+1|0;if((ia|0)>=256){la=0;break}}ia=(((la|0)>0)<<31>>31)+la|0;la=255;while(1){if((f[j+(la<<2)>>2]|0)>0){ma=la;break}if((la|0)>1)la=la+-1|0;else{ma=0;break}}la=(ma|0)<255;G=0;ja=0;A=0;do{ka=f[j+(A<<2)>>2]|0;y=(ka|0)>(G|0);ja=y?A:ja;G=y?ka:G;A=A+1|0}while((A|0)!=256);A=(la&1)+ma|0;if((ja-ia|0)<(A-ja|0)){ma=255;la=0;do{ka=j+(la<<2)|0;y=f[ka>>2]|0;ha=j+(ma<<2)|0;f[ka>>2]=f[ha>>2];f[ha>>2]=y;la=la+1|0;ma=ma+-1|0}while((la|0)<(ma|0));na=1;oa=255-A|0;pa=255-ja|0}else{na=0;oa=ia;pa=ja}aa=+(oa|0);$=+(G|0);T=+(oa-pa|0);if((oa|0)<(pa|0)){ba=0.0;S=aa;G=oa;while(1){G=G+1|0;R=+(G|0);F=$*R+T*+(f[j+(G<<2)>>2]|0);oa=F>ba;Q=oa?R:S;if((G|0)==(pa|0)){qa=Q;break}else{ba=oa?F:ba;S=Q}}}else qa=aa;aa=qa+-1.0;ca=na?255.0-aa:aa;da=k;ea=t;fa=z;ga=r;break}default:{r=k+40|0;ca=d;da=k;ea=r;fa=f[r>>2]|0;ga=f[k>>2]|0}}r=f[fa>>2]|0;f[l>>2]=f[fa+4>>2];f[l+4>>2]=r;wS(c,l,ga&4095,-1,0,0);do if((eS(c)|0)==65536){ga=f[c+4>>2]|0;f[j>>2]=f[ga>>2];l=j+4|0;r=ga+4|0;f[l>>2]=f[r>>2];fa=j+8|0;f[fa>>2]=f[ga+8>>2];f[j+12>>2]=f[ga+12>>2];f[j+16>>2]=f[ga+16>>2];f[j+20>>2]=f[ga+20>>2];f[j+24>>2]=f[ga+24>>2];f[j+28>>2]=f[ga+28>>2];f[j+32>>2]=f[ga+32>>2];z=f[ga+36>>2]|0;f[j+36>>2]=z;f[j+40>>2]=fa;fa=j+48|0;t=j+44|0;f[t>>2]=fa;f[fa>>2]=0;f[j+52>>2]=0;if(z|0){fa=z+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[r>>2]|0)<3){r=f[ga+44>>2]|0;fa=f[t>>2]|0;f[fa>>2]=f[r>>2];f[fa+4>>2]=f[r+4>>2];break}else{f[l>>2]=0;U$(j,ga);break}}else bS(j,c,-1);while(0);c=f[da>>2]|0;c:do switch(c&7){case 0:{da=~~ca;ga=da-(+(da|0)>ca&1)|0;d=+(ga|0);da=zLc(e)|0;l=(a|0)==2;r=l?ga:da;da=r>>>0<256?r:(r|0)>0?255:0;r=da&255;fa=(ga|0)>254;if(ga>>>0<=254){ra=+(da&255);sa=d;ta=101;break c}if((a|1|0)!=1?!((l|(a|0)==4)&(ga|0)<0|(a|0)==3&fa):0){ga=m+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;jR(k,m);ua=d;break c}switch(g&7){case 0:{va=fa?0:r;break}case 1:{va=fa?r:0;break}default:va=0}p[n>>3]=+(va|0);f[m>>2]=-1056833530;f[m+4>>2]=n;f[m+8>>2]=1;f[m+12>>2]=1;mR(j,m,fT()|0)|0;ua=d;break}case 3:{r=~~ca;fa=r-(+(r|0)>ca&1)|0;d=+(fa|0);r=zLc(e)|0;ga=(a|0)==2;l=ga?fa:r;r=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;l=r<<16>>16;da=(fa|0)>32766;if((fa+32768|0)>>>0<=65534){ra=+((r&65535)<<16>>16);sa=d;ta=101;break c}if((a|1|0)!=1?!((ga|(a|0)==4)&(fa|0)<-32768|(a|0)==3&da):0){fa=m+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;jR(k,m);ua=d;break c}switch(g&7){case 0:{wa=da?0:l;break}case 1:{wa=da?l:0;break}default:wa=0}p[n>>3]=+(wa|0);f[m>>2]=-1056833530;f[m+4>>2]=n;f[m+8>>2]=1;f[m+12>>2]=1;mR(j,m,fT()|0)|0;ua=d;break}case 2:{l=~~ca;da=l-(+(l|0)>ca&1)|0;d=+(da|0);l=zLc(e)|0;fa=(a|0)==2?da:l;l=fa>>>0<65536?fa:(fa|0)>0?65535:0;fa=l&65535;ga=(da|0)>65534;if(da>>>0<=65534){ra=+(l&65535);sa=d;ta=101;break c}l=g&255;d:do if((a|1|0)==1)ta=94;else{switch(l&7){case 2:case 4:{if((a|0)==3&ga|(da|0)<0){ta=94;break d}break}default:if((a|0)==3&ga){xa=0;break d}}r=m+8|0;f[r>>2]=0;f[r+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;jR(k,m);ua=d;break c}while(0);e:do if((ta|0)==94)switch(l&7){case 0:{xa=ga?0:fa;break e;break}case 1:{xa=ga?fa:0;break e;break}default:{xa=0;break e}}while(0);p[n>>3]=+(xa|0);f[m>>2]=-1056833530;f[m+4>>2]=n;f[m+8>>2]=1;f[m+12>>2]=1;mR(j,m,fT()|0)|0;ua=d;break}case 6:case 5:{ra=e;sa=ca;ta=101;break}default:{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;vM(-210,m,470916,267504,1492)}}while(0);if((ta|0)==101){ta=j+8|0;xa=f[ta>>2]|0;f[m>>2]=0;f[m+4>>2]=xa;f[o>>2]=c;c=o+4|0;xa=k+4|0;g=f[xa>>2]|0;f[c>>2]=g;wa=o+8|0;f[wa>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];va=o+16|0;f[va>>2]=f[k+16>>2];f[o+20>>2]=f[k+20>>2];f[o+24>>2]=f[k+24>>2];f[o+28>>2]=f[k+28>>2];f[o+32>>2]=f[k+32>>2];fa=o+36|0;ga=f[k+36>>2]|0;f[fa>>2]=ga;l=o+40|0;f[l>>2]=wa;wa=o+48|0;da=o+44|0;f[da>>2]=wa;f[wa>>2]=0;f[o+52>>2]=0;if(!ga)ya=g;else{g=ga+12|0;f[g>>2]=(f[g>>2]|0)+1;ya=f[xa>>2]|0}if((ya|0)<3){ya=f[k+44>>2]|0;xa=f[da>>2]|0;f[xa>>2]=f[ya>>2];f[xa+4>>2]=f[ya+4>>2]}else{f[c>>2]=0;U$(o,k)}f[q>>2]=f[j>>2];ya=q+4|0;xa=j+4|0;g=f[xa>>2]|0;f[ya>>2]=g;ga=q+8|0;f[ga>>2]=f[ta>>2];r=j+12|0;f[q+12>>2]=f[r>>2];t=q+16|0;f[t>>2]=f[j+16>>2];f[q+20>>2]=f[j+20>>2];f[q+24>>2]=f[j+24>>2];f[q+28>>2]=f[j+28>>2];f[q+32>>2]=f[j+32>>2];z=q+36|0;na=f[j+36>>2]|0;f[z>>2]=na;pa=q+40|0;f[pa>>2]=ga;ga=q+48|0;G=q+44|0;f[G>>2]=ga;f[ga>>2]=0;f[q+52>>2]=0;if(!na)za=g;else{g=na+12|0;f[g>>2]=(f[g>>2]|0)+1;za=f[xa>>2]|0}if((za|0)<3){za=f[j+44>>2]|0;g=f[G>>2]|0;f[g>>2]=f[za>>2];f[g+4>>2]=f[za+4>>2]}else{f[ya>>2]=0;U$(q,j)}$na(n,o,q,sa,ra,a);a=f[xa>>2]|0;if((a|0)<3)Aa=Y(f[r>>2]|0,f[ta>>2]|0)|0;else{ta=f[j+40>>2]|0;r=0;xa=1;while(1){za=Y(f[ta+(r<<2)>>2]|0,xa)|0;r=r+1|0;if((r|0)==(a|0)){Aa=za;break}else xa=za}}h3(m,n,+(Aa>>>0)*.0000152587890625);aoa(n);n=f[z>>2]|0;if(n|0?(Aa=n+12|0,n=f[Aa>>2]|0,f[Aa>>2]=n+-1,(n|0)==1):0)V$(q);f[z>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[ya>>2]|0)>0){t=f[pa>>2]|0;pa=0;do{f[t+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[ya>>2]|0))}ya=f[G>>2]|0;if((ya|0)!=(ga|0))wL(ya);ya=f[fa>>2]|0;if(ya|0?(ga=ya+12|0,ya=f[ga>>2]|0,f[ga>>2]=ya+-1,(ya|0)==1):0)V$(o);f[fa>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[c>>2]|0)>0){va=f[l>>2]|0;l=0;do{f[va+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[c>>2]|0))}c=f[da>>2]|0;if((c|0)!=(wa|0))wL(c);ua=sa}c=j+36|0;wa=f[c>>2]|0;if(wa|0?(da=wa+12|0,wa=f[da>>2]|0,f[da>>2]=wa+-1,(wa|0)==1):0)V$(j);f[c>>2]=0;c=j+16|0;wa=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[wa>>2]|0)>0){c=f[j+40>>2]|0;da=0;do{f[c+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[wa>>2]|0))}wa=f[j+44>>2]|0;if((wa|0)!=(j+48|0))wL(wa);wa=k+36|0;j=f[wa>>2]|0;if(j|0?(da=j+12|0,j=f[da>>2]|0,f[da>>2]=j+-1,(j|0)==1):0)V$(k);f[wa>>2]=0;wa=k+16|0;j=k+4|0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[j>>2]|0)>0){wa=f[ea>>2]|0;ea=0;do{f[wa+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[j>>2]|0))}j=f[k+44>>2]|0;if((j|0)==(k+48|0)){u=i;return +ua}wL(j);u=i;return +ua}function $na(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f[a>>2]=52880;h=a+4|0;f[h>>2]=1124007936;i=a+8|0;j=a+12|0;k=a+44|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;n=a+52|0;o=a+48|0;f[o>>2]=n;f[n>>2]=0;f[a+56>>2]=0;n=a+60|0;f[n>>2]=1124007936;q=a+64|0;r=a+68|0;s=a+100|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=a+108|0;m=a+104|0;f[m>>2]=l;f[l>>2]=0;f[a+112>>2]=0;if((h|0)!=(b|0)){l=b+36|0;t=f[l>>2]|0;if(t){u=t+12|0;f[u>>2]=(f[u>>2]|0)+1;u=a+40|0;t=f[u>>2]|0;if((t|0)!=0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0){V$(h);w=u}else w=u}else w=a+40|0;f[w>>2]=0;u=a+20|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;if((f[i>>2]|0)>0){t=f[k>>2]|0;k=0;do{f[t+(k<<2)>>2]=0;k=k+1|0;x=f[i>>2]|0}while((k|0)<(x|0));f[h>>2]=f[b>>2];if((x|0)<3)y=12;else y=14}else{f[h>>2]=f[b>>2];y=12}if((y|0)==12){x=f[b+4>>2]|0;if((x|0)<3){f[i>>2]=x;f[j>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];j=f[b+44>>2]|0;x=f[o>>2]|0;f[x>>2]=f[j>>2];f[x+4>>2]=f[j+4>>2]}else y=14}if((y|0)==14)U$(h,b);f[u>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];f[w>>2]=f[l>>2]}if((n|0)==(c|0)){z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}l=c+36|0;w=f[l>>2]|0;if(w|0){b=w+12|0;f[b>>2]=(f[b>>2]|0)+1}b=a+96|0;w=f[b>>2]|0;if(w|0?(u=w+12|0,w=f[u>>2]|0,f[u>>2]=w+-1,(w|0)==1):0)V$(n);f[b>>2]=0;w=a+76|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[q>>2]|0)>0){u=f[s>>2]|0;s=0;do{f[u+(s<<2)>>2]=0;s=s+1|0;C=f[q>>2]|0}while((s|0)<(C|0));f[n>>2]=f[c>>2];if((C|0)<3)y=27;else y=29}else{f[n>>2]=f[c>>2];y=27}if((y|0)==27){C=f[c+4>>2]|0;if((C|0)<3){f[q>>2]=C;f[r>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];r=f[c+44>>2]|0;C=f[m>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2]}else y=29}if((y|0)==29)U$(n,c);f[w>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];f[b>>2]=f[l>>2];z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}function aoa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=52880;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function boa(a){a=a|0;aoa(a);cYc(a);return}function coa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0;e=u;u=u+384|0;g=e+120|0;i=e+112|0;k=e+56|0;l=e;m=f[c>>2]|0;o=f[c+4>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;W$(k,a+4|0,g,i);f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;W$(l,a+60|0,g,i);i=k+16|0;o=l+16|0;m=f[k>>2]|0;c=m>>>3&511;q=a+120|0;r=a+128|0;s=a+136|0;a:do switch(m&7){case 0:{a=~~+p[q>>3]&255;t=~~+p[r>>3]&255;v=f[s>>2]|0;w=f[k+40>>2]|0;x=f[w>>2]|0;y=Y(f[w+4>>2]|0,c+1|0)|0;w=f[k+48>>2]|0;z=f[l+48>>2]|0;if(!(m&16384)){A=w;B=z;C=y;D=x}else{E=(f[l>>2]&16384|0)!=0;F=Y(y,x)|0;A=E?F:w;B=E?F:z;C=E?F:y;D=E?1:x}if((C|0)>0){x=a&255;E=x+1|0;g1c(g|0,0,256)|0;switch(v|0){case 0:{g1c(g|0,0,E|0)|0;if(E>>>0<256)g1c(g+E|0,t|0,x^255|0)|0;break}case 1:{g1c(g|0,t|0,E|0)|0;if(E>>>0<256)g1c(g+E|0,0,x^255|0)|0;break}case 2:{t=0;do{b[g+t>>0]=t;t=t+1|0}while((t|0)!=(E|0));if(E>>>0<256)g1c(g+E|0,a|0,x^255|0)|0;break}case 3:{g1c(g|0,0,E|0)|0;if(E>>>0<256){t=E;do{b[g+t>>0]=t;t=t+1|0}while((t|0)!=256)}break}case 4:{t=0;do{b[g+t>>0]=t;t=t+1|0}while((t|0)!=(E|0));if(E>>>0<256)g1c(g+E|0,0,x^255|0)|0;break}default:{}}t=f[i>>2]|0;a=f[o>>2]|0;b:do if((D|0)>0){v=C+-4|0;if((C|0)<4){y=0;F=t;z=a;while(1){w=0;do{b[z+w>>0]=b[g+(h[F+w>>0]|0)>>0]|0;w=w+1|0}while((w|0)!=(C|0));y=y+1|0;if((y|0)==(D|0))break b;else{F=F+A|0;z=z+B|0}}}z=C&-4;if((z|0)<(C|0)){G=0;H=t;I=a}else{F=0;y=t;w=a;while(1){J=0;do{K=J|1;L=b[g+(h[y+K>>0]|0)>>0]|0;b[w+J>>0]=b[g+(h[y+J>>0]|0)>>0]|0;b[w+K>>0]=L;L=J|2;K=J|3;M=b[g+(h[y+K>>0]|0)>>0]|0;b[w+L>>0]=b[g+(h[y+L>>0]|0)>>0]|0;b[w+K>>0]=M;J=J+4|0}while((J|0)<=(v|0));F=F+1|0;if((F|0)==(D|0))break b;else{y=y+A|0;w=w+B|0}}}while(1){w=0;do{y=w|1;F=b[g+(h[H+y>>0]|0)>>0]|0;b[I+w>>0]=b[g+(h[H+w>>0]|0)>>0]|0;b[I+y>>0]=F;F=w|2;y=w|3;J=b[g+(h[H+y>>0]|0)>>0]|0;b[I+F>>0]=b[g+(h[H+F>>0]|0)>>0]|0;b[I+y>>0]=J;w=w+4|0}while((w|0)<=(v|0));N=z;do{b[I+N>>0]=b[g+(h[H+N>>0]|0)>>0]|0;N=N+1|0}while((N|0)!=(C|0));G=G+1|0;if((G|0)==(D|0))break;else{H=H+A|0;I=I+B|0}}}while(0)}break}case 3:{a=~~+p[q>>3];t=~~+p[r>>3];x=f[k+40>>2]|0;E=f[x>>2]|0;z=Y(f[x+4>>2]|0,c+1|0)|0;x=f[i>>2]|0;v=f[o>>2]|0;w=(f[k+48>>2]|0)>>>1;J=(f[l+48>>2]|0)>>>1;if(!(m&16384)){O=J;P=w;Q=z;R=E}else{y=(f[l>>2]&16384|0)!=0;F=Y(z,E)|0;O=y?F:J;P=y?F:w;Q=y?F:z;R=y?1:E}switch(f[s>>2]|0){case 0:{if((Q|0)>0&(R|0)>0){S=x;T=v;U=0}else break a;while(1){E=0;do{d[T+(E<<1)>>1]=(d[S+(E<<1)>>1]|0)>a<<16>>16?t:0;E=E+1|0}while((E|0)!=(Q|0));U=U+1|0;if((U|0)==(R|0))break;else{S=S+(P<<1)|0;T=T+(O<<1)|0}}break}case 1:{if((Q|0)>0&(R|0)>0){V=x;W=v;X=0}else break a;while(1){E=0;do{d[W+(E<<1)>>1]=(d[V+(E<<1)>>1]|0)>a<<16>>16?0:t;E=E+1|0}while((E|0)!=(Q|0));X=X+1|0;if((X|0)==(R|0))break;else{V=V+(P<<1)|0;W=W+(O<<1)|0}}break}case 2:{if((Q|0)>0&(R|0)>0){Z=x;_=v;$=0}else break a;while(1){t=0;do{E=d[Z+(t<<1)>>1]|0;d[_+(t<<1)>>1]=E<<16>>16>a<<16>>16?a:E;t=t+1|0}while((t|0)!=(Q|0));$=$+1|0;if(($|0)==(R|0))break;else{Z=Z+(P<<1)|0;_=_+(O<<1)|0}}break}case 3:{if((Q|0)>0&(R|0)>0){aa=x;ba=v;ca=0}else break a;while(1){t=0;do{E=d[aa+(t<<1)>>1]|0;d[ba+(t<<1)>>1]=E<<16>>16>a<<16>>16?E:0;t=t+1|0}while((t|0)!=(Q|0));ca=ca+1|0;if((ca|0)==(R|0))break;else{aa=aa+(P<<1)|0;ba=ba+(O<<1)|0}}break}case 4:{if((Q|0)>0&(R|0)>0){da=x;ea=v;fa=0}else break a;while(1){t=0;do{E=d[da+(t<<1)>>1]|0;d[ea+(t<<1)>>1]=E<<16>>16>a<<16>>16?0:E;t=t+1|0}while((t|0)!=(Q|0));fa=fa+1|0;if((fa|0)==(R|0))break;else{da=da+(P<<1)|0;ea=ea+(O<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-5,g,267575,267504,120)}}break}case 2:{a=~~+p[q>>3]&65535;v=~~+p[r>>3]&65535;x=f[k+40>>2]|0;t=f[x>>2]|0;E=Y(f[x+4>>2]|0,c+1|0)|0;x=((f[k+48>>2]|0)>>>0)/((675553809>>>(m<<2&28)&15)>>>0)|0;y=f[l>>2]|0;z=((f[l+48>>2]|0)>>>0)/((675553809>>>(y<<2&28)&15)>>>0)|0;F=(m&16384|0)==0;w=(y&16384|0)!=0;y=Y(E,t)|0;J=F?E:w?y:E;E=F?t:w?1:t;t=F?z:w?y:z;z=F?x:w?y:x;x=f[i>>2]|0;y=f[o>>2]|0;switch(f[s>>2]|0){case 0:{if((J|0)>0&(E|0)>0){ga=x;ha=y;ia=0}else break a;while(1){w=0;do{d[ha+(w<<1)>>1]=(j[ga+(w<<1)>>1]|0)>(a&65535)?v:0;w=w+1|0}while((w|0)!=(J|0));ia=ia+1|0;if((ia|0)==(E|0))break;else{ga=ga+(z<<1)|0;ha=ha+(t<<1)|0}}break}case 1:{if((J|0)>0&(E|0)>0){ja=x;ka=y;la=0}else break a;while(1){w=0;do{d[ka+(w<<1)>>1]=(j[ja+(w<<1)>>1]|0)>(a&65535)?0:v;w=w+1|0}while((w|0)!=(J|0));la=la+1|0;if((la|0)==(E|0))break;else{ja=ja+(z<<1)|0;ka=ka+(t<<1)|0}}break}case 2:{if((J|0)>0&(E|0)>0){ma=x;na=y;oa=0}else break a;while(1){v=0;do{w=d[ma+(v<<1)>>1]|0;d[na+(v<<1)>>1]=(w&65535)>(a&65535)?a:w;v=v+1|0}while((v|0)!=(J|0));oa=oa+1|0;if((oa|0)==(E|0))break;else{ma=ma+(z<<1)|0;na=na+(t<<1)|0}}break}case 3:{if((J|0)>0&(E|0)>0){pa=x;qa=y;ra=0}else break a;while(1){v=0;do{w=d[pa+(v<<1)>>1]|0;d[qa+(v<<1)>>1]=(w&65535)>(a&65535)?w:0;v=v+1|0}while((v|0)!=(J|0));ra=ra+1|0;if((ra|0)==(E|0))break;else{pa=pa+(z<<1)|0;qa=qa+(t<<1)|0}}break}case 4:{if((J|0)>0&(E|0)>0){sa=x;ta=y;ua=0}else break a;while(1){v=0;do{w=d[sa+(v<<1)>>1]|0;d[ta+(v<<1)>>1]=(w&65535)>(a&65535)?0:w;v=v+1|0}while((v|0)!=(J|0));ua=ua+1|0;if((ua|0)==(E|0))break;else{sa=sa+(z<<1)|0;ta=ta+(t<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-5,g,267575,267504,120)}}break}case 5:{va=+p[q>>3];wa=+p[r>>3];t=f[k+40>>2]|0;z=f[t>>2]|0;E=Y(f[t+4>>2]|0,c+1|0)|0;t=f[i>>2]|0;J=f[o>>2]|0;a=(f[k+48>>2]|0)>>>2;y=(f[l+48>>2]|0)>>>2;if(!(m&16384)){xa=E;ya=z}else{x=(f[l>>2]&16384|0)!=0;v=Y(x?z:1,E)|0;xa=v;ya=x?1:z}switch(f[s>>2]|0){case 0:{if((xa|0)>0&(ya|0)>0){za=t;Aa=J;Ba=0}else break a;while(1){z=0;do{n[Aa+(z<<2)>>2]=+n[za+(z<<2)>>2]>va?wa:0.0;z=z+1|0}while((z|0)!=(xa|0));Ba=Ba+1|0;if((Ba|0)==(ya|0))break;else{za=za+(a<<2)|0;Aa=Aa+(y<<2)|0}}break}case 1:{if((xa|0)>0&(ya|0)>0){Ca=t;Da=J;Ea=0}else break a;while(1){z=0;do{n[Da+(z<<2)>>2]=!(+n[Ca+(z<<2)>>2]<=va)?0.0:wa;z=z+1|0}while((z|0)!=(xa|0));Ea=Ea+1|0;if((Ea|0)==(ya|0))break;else{Ca=Ca+(a<<2)|0;Da=Da+(y<<2)|0}}break}case 2:{if((xa|0)>0&(ya|0)>0){Fa=t;Ga=J;Ha=0}else break a;while(1){z=0;do{wa=+n[Fa+(z<<2)>>2];n[Ga+(z<<2)>>2]=wa>va?va:wa;z=z+1|0}while((z|0)!=(xa|0));Ha=Ha+1|0;if((Ha|0)==(ya|0))break;else{Fa=Fa+(a<<2)|0;Ga=Ga+(y<<2)|0}}break}case 3:{if((xa|0)>0&(ya|0)>0){Ia=t;Ja=J;Ka=0}else break a;while(1){z=0;do{wa=+n[Ia+(z<<2)>>2];n[Ja+(z<<2)>>2]=wa>va?wa:0.0;z=z+1|0}while((z|0)!=(xa|0));Ka=Ka+1|0;if((Ka|0)==(ya|0))break;else{Ia=Ia+(a<<2)|0;Ja=Ja+(y<<2)|0}}break}case 4:{if((xa|0)>0&(ya|0)>0){La=t;Ma=J;Na=0}else break a;while(1){z=0;do{wa=+n[La+(z<<2)>>2];n[Ma+(z<<2)>>2]=!(wa<=va)?0.0:wa;z=z+1|0}while((z|0)!=(xa|0));Na=Na+1|0;if((Na|0)==(ya|0))break;else{La=La+(a<<2)|0;Ma=Ma+(y<<2)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-5,g,267575,267504,120)}}break}case 6:{va=+p[q>>3];wa=+p[r>>3];y=f[k+40>>2]|0;a=f[y>>2]|0;J=Y(f[y+4>>2]|0,c+1|0)|0;y=f[i>>2]|0;t=f[o>>2]|0;z=(f[k+48>>2]|0)>>>3;x=(f[l+48>>2]|0)>>>3;if(!(m&16384)){Oa=J;Pa=a}else{v=(f[l>>2]&16384|0)!=0;E=Y(v?a:1,J)|0;Oa=E;Pa=v?1:a}switch(f[s>>2]|0){case 0:{if((Oa|0)>0&(Pa|0)>0){Qa=y;Ra=t;Sa=0}else break a;while(1){a=0;do{p[Ra+(a<<3)>>3]=+p[Qa+(a<<3)>>3]>va?wa:0.0;a=a+1|0}while((a|0)!=(Oa|0));Sa=Sa+1|0;if((Sa|0)==(Pa|0))break;else{Qa=Qa+(z<<3)|0;Ra=Ra+(x<<3)|0}}break}case 1:{if((Oa|0)>0&(Pa|0)>0){Ta=y;Ua=t;Va=0}else break a;while(1){a=0;do{p[Ua+(a<<3)>>3]=!(+p[Ta+(a<<3)>>3]<=va)?0.0:wa;a=a+1|0}while((a|0)!=(Oa|0));Va=Va+1|0;if((Va|0)==(Pa|0))break;else{Ta=Ta+(z<<3)|0;Ua=Ua+(x<<3)|0}}break}case 2:{if((Oa|0)>0&(Pa|0)>0){Wa=y;Xa=t;Ya=0}else break a;while(1){a=0;do{wa=+p[Wa+(a<<3)>>3];p[Xa+(a<<3)>>3]=wa>va?va:wa;a=a+1|0}while((a|0)!=(Oa|0));Ya=Ya+1|0;if((Ya|0)==(Pa|0))break;else{Wa=Wa+(z<<3)|0;Xa=Xa+(x<<3)|0}}break}case 3:{if((Oa|0)>0&(Pa|0)>0){Za=y;_a=t;$a=0}else break a;while(1){a=0;do{wa=+p[Za+(a<<3)>>3];p[_a+(a<<3)>>3]=wa>va?wa:0.0;a=a+1|0}while((a|0)!=(Oa|0));$a=$a+1|0;if(($a|0)==(Pa|0))break;else{Za=Za+(z<<3)|0;_a=_a+(x<<3)|0}}break}case 4:{if((Oa|0)>0&(Pa|0)>0){ab=y;bb=t;cb=0}else break a;while(1){a=0;do{wa=+p[ab+(a<<3)>>3];p[bb+(a<<3)>>3]=!(wa<=va)?0.0:wa;a=a+1|0}while((a|0)!=(Oa|0));cb=cb+1|0;if((cb|0)==(Pa|0))break;else{ab=ab+(z<<3)|0;bb=bb+(x<<3)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-5,g,267575,267504,120)}}break}default:{}}while(0);g=l+36|0;bb=f[g>>2]|0;if(bb|0?(ab=bb+12|0,bb=f[ab>>2]|0,f[ab>>2]=bb+-1,(bb|0)==1):0)V$(l);f[g>>2]=0;g=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[g>>2]|0)>0){o=f[l+40>>2]|0;bb=0;do{f[o+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[g>>2]|0))}g=f[l+44>>2]|0;if((g|0)!=(l+48|0))wL(g);g=k+36|0;l=f[g>>2]|0;if(l|0?(bb=l+12|0,l=f[bb>>2]|0,f[bb>>2]=l+-1,(l|0)==1):0)V$(k);f[g>>2]=0;g=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[g>>2]|0)>0){i=f[k+40>>2]|0;l=0;do{f[i+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[k+44>>2]|0;if((g|0)==(k+48|0)){u=e;return}wL(g);u=e;return}function doa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;k=u;u=u+1056|0;l=k+1e3|0;m=k+944|0;n=k+936|0;o=k;p=k+160|0;q=k+96|0;r=k+928|0;s=k+152|0;t=k+72|0;v=k+56|0;w=k+88|0;do if((eS(a)|0)==65536){x=f[a+4>>2]|0;f[l>>2]=f[x>>2];y=l+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[x+8>>2];f[l+12>>2]=f[x+12>>2];f[l+16>>2]=f[x+16>>2];f[l+20>>2]=f[x+20>>2];f[l+24>>2]=f[x+24>>2];f[l+28>>2]=f[x+28>>2];f[l+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;C=l+44|0;f[C>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];D=l;break}else{f[y>>2]=0;U$(l,x);D=l;break}}else{bS(l,a,-1);D=l}while(0);if(f[D>>2]&4095|0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;a=$Xc(32)|0;f[m>>2]=a;f[m+8>>2]=-2147483616;f[m+4>>2]=21;E=a;F=369201;G=E+21|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[a+21>>0]=0;vM(-215,m,267612,267504,1507)}if(!((i|0)>1&((i|0)%2|0|0)==1)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;a=$Xc(48)|0;f[m>>2]=a;f[m+8>>2]=-2147483600;f[m+4>>2]=35;E=a;F=267630;G=E+35|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[a+35>>0]=0;vM(-215,m,267612,267504,1508)}a=l+40|0;x=f[a>>2]|0;y=f[x+4>>2]|0;z=f[x>>2]|0;f[n>>2]=y;f[n+4>>2]=z;wS(c,n,0,-1,0,0);do if((eS(c)|0)==65536){n=f[c+4>>2]|0;f[m>>2]=f[n>>2];x=m+4|0;A=n+4|0;f[x>>2]=f[A>>2];C=m+8|0;f[C>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[m+16>>2]=f[n+16>>2];f[m+20>>2]=f[n+20>>2];f[m+24>>2]=f[n+24>>2];f[m+28>>2]=f[n+28>>2];f[m+32>>2]=f[n+32>>2];B=f[n+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=C;C=m+48|0;H=m+44|0;f[H>>2]=C;f[C>>2]=0;f[m+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[A>>2]|0)<3){A=f[n+44>>2]|0;C=f[H>>2]|0;f[C>>2]=f[A>>2];f[C+4>>2]=f[A+4>>2];break}else{f[x>>2]=0;U$(m,n);break}}else bS(m,c,-1);while(0);if(!(d<0.0)){c=l+16|0;n=m+16|0;f[o>>2]=1124007936;x=o+4|0;A=o+8|0;C=o+40|0;E=x;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[C>>2]=A;H=o+48|0;B=o+44|0;f[B>>2]=H;f[H>>2]=0;f[o+52>>2]=0;if((f[c>>2]|0)!=(f[n>>2]|0)){I=m+36|0;J=f[I>>2]|0;if(J){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1;K=o+36|0;J=f[K>>2]|0;if((J|0)!=0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0){V$(o);M=K}else M=K}else M=o+36|0;f[M>>2]=0;K=o+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[x>>2]|0)>0){J=f[C>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;N=f[x>>2]|0}while((L|0)<(N|0));f[o>>2]=f[m>>2];if((N|0)<3)O=32;else O=34}else{f[o>>2]=f[m>>2];O=32}if((O|0)==32){N=f[m+4>>2]|0;if((N|0)<3){f[x>>2]=N;f[A>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];A=f[m+44>>2]|0;N=f[B>>2]|0;f[N>>2]=f[A>>2];f[N+4>>2]=f[A+4>>2]}else O=34}if((O|0)==34)U$(o,m);f[K>>2]=f[n>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];f[o+32>>2]=f[m+32>>2];f[M>>2]=f[I>>2]}switch(e|0){case 0:{f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=l;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;e=f[D>>2]&4095;f[r>>2]=i;f[r+4>>2]=i;f[s>>2]=-1;f[s+4>>2]=-1;Uua(p,q,e,r,s,1,17);break}case 1:{f[p>>2]=1124007936;s=p+4|0;r=p+8|0;e=p+40|0;E=s;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[e>>2]=r;I=p+48|0;M=p+44|0;f[M>>2]=I;f[I>>2]=0;f[p+52>>2]=0;f[q>>2]=1124007936;K=q+4|0;A=q+8|0;N=q+40|0;E=K;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[N>>2]=A;L=q+48|0;J=q+44|0;f[J>>2]=L;f[L>>2]=0;f[q+52>>2]=0;P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;dY(l,t,5,1.0,0.0);P=p+36|0;Q=f[P>>2]|0;if(Q|0){R=Q+12|0;f[R>>2]=(f[R>>2]|0)+1}R=q+36|0;Q=f[R>>2]|0;if(Q|0?(S=Q+12|0,Q=f[S>>2]|0,f[S>>2]=Q+-1,(Q|0)==1):0)V$(q);f[R>>2]=0;Q=q+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[K>>2]|0)>0){S=f[N>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0;U=f[K>>2]|0}while((T|0)<(U|0));f[q>>2]=f[p>>2];if((U|0)<3)O=48;else O=50}else{f[q>>2]=f[p>>2];O=48}if((O|0)==48){U=f[s>>2]|0;if((U|0)<3){f[K>>2]=U;f[A>>2]=f[r>>2];f[q+12>>2]=f[p+12>>2];r=f[M>>2]|0;A=f[J>>2]|0;f[A>>2]=f[r>>2];f[A+4>>2]=f[r+4>>2]}else O=50}if((O|0)==50)U$(q,p);r=p+16|0;f[Q>>2]=f[r>>2];f[q+20>>2]=f[p+20>>2];f[q+24>>2]=f[p+24>>2];f[q+28>>2]=f[p+28>>2];f[q+32>>2]=f[p+32>>2];f[R>>2]=f[P>>2];f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=p;A=v+8|0;f[A>>2]=0;f[A+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=q;f[w>>2]=i;f[w+4>>2]=i;Jqa(t,v,w,0.0,0.0,17);w=t+8|0;f[w>>2]=0;f[w+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=o;dY(q,t,f[D>>2]&4095,1.0,0.0);t=f[R>>2]|0;if(t|0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)V$(q);f[R>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[K>>2]|0)>0){Q=f[N>>2]|0;N=0;do{f[Q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[J>>2]|0;if((K|0)!=(L|0))wL(K);K=f[P>>2]|0;if(K|0?(L=K+12|0,K=f[L>>2]|0,f[L>>2]=K+-1,(K|0)==1):0)V$(p);f[P>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[e>>2]|0;e=0;do{f[r+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[s>>2]|0))}s=f[M>>2]|0;if((s|0)!=(I|0))wL(s);break}default:{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;s=$Xc(48)|0;f[p>>2]=s;f[p+8>>2]=-2147483600;f[p+4>>2]=45;E=s;F=267666;G=E+45|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[s+45>>0]=0;vM(-206,p,267612,267504,1540)}}s=zLc(d)|0;I=(s>>>0<256?s:(s|0)>0?255:0)&255;s=~~j;d=+(s|0);if(!g){M=0-(s+(d<j&1))|0;e=0;do{b[p+e>>0]=(e+-255|0)>(M|0)?I:0;e=e+1|0}while((e|0)!=768);V=p}else{if((g|0)!=1){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;g=$Xc(48)|0;f[q>>2]=g;f[q+8>>2]=-2147483600;f[q+4>>2]=34;E=g;F=267712;G=E+34|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[g+34>>0]=0;vM(-206,q,267612,267504,1554)}q=(d>j&1)-s|0;s=0;do{b[p+s>>0]=(s+-255|0)<=(q|0)?I:0;s=s+1|0}while((s|0)!=768);V=p}if((f[D>>2]&16384|0)!=0?(f[o>>2]&16384|0)!=0:0){D=(f[m>>2]&16384|0)!=0;V=Y(D?z:1,y)|0;if(D){W=V;X=1;O=80}else{Z=V;O=79}}else{Z=y;O=79}if((O|0)==79?(z|0)>0:0){W=Z;X=z;O=80}if((O|0)==80?(O=l+44|0,z=o+16|0,Z=m+44|0,(W|0)>0):0){y=0;do{V=(f[c>>2]|0)+(Y(f[f[O>>2]>>2]|0,y)|0)|0;D=(f[z>>2]|0)+(Y(f[f[B>>2]>>2]|0,y)|0)|0;s=(f[n>>2]|0)+(Y(f[f[Z>>2]>>2]|0,y)|0)|0;I=0;do{b[s+I>>0]=b[p+((h[V+I>>0]|0)+255-(h[D+I>>0]|0))>>0]|0;I=I+1|0}while((I|0)!=(W|0));y=y+1|0}while((y|0)!=(X|0))}X=o+36|0;y=f[X>>2]|0;if(y|0?(W=y+12|0,y=f[W>>2]|0,f[W>>2]=y+-1,(y|0)==1):0)V$(o);f[X>>2]=0;X=o+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[x>>2]|0)>0){X=f[C>>2]|0;C=0;do{f[X+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[x>>2]|0))}x=f[B>>2]|0;if((x|0)!=(H|0))wL(x)}else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;lR(m,o)|0}o=m+36|0;x=f[o>>2]|0;if(x|0?(H=x+12|0,x=f[H>>2]|0,f[H>>2]=x+-1,(x|0)==1):0)V$(m);f[o>>2]=0;o=m+16|0;x=m+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[x>>2]|0)>0){o=f[m+40>>2]|0;H=0;do{f[o+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[x>>2]|0))}x=f[m+44>>2]|0;if((x|0)!=(m+48|0))wL(x);x=l+36|0;m=f[x>>2]|0;if(m|0?(H=m+12|0,m=f[H>>2]|0,f[H>>2]=m+-1,(m|0)==1):0)V$(l);f[x>>2]=0;x=l+16|0;m=l+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[m>>2]|0)>0){x=f[a>>2]|0;a=0;do{f[x+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=k;return}wL(m);u=k;return}function eoa(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;h=u;u=u+208|0;i=h+144|0;j=h+88|0;k=h+32|0;l=h+16|0;m=h;gT(i,a,0,1,0,0);gT(j,c,0,1,0,0);f[k>>2]=f[j>>2];c=k+4|0;a=j+4|0;n=f[a>>2]|0;f[c>>2]=n;o=k+8|0;f[o>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];p=k+16|0;q=j+16|0;f[p>>2]=f[q>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];r=k+36|0;s=j+36|0;t=f[s>>2]|0;f[r>>2]=t;v=k+40|0;f[v>>2]=o;o=k+48|0;w=k+44|0;f[w>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(!t)x=n;else{n=t+12|0;f[n>>2]=(f[n>>2]|0)+1;x=f[a>>2]|0}if((x|0)<3){x=f[j+44>>2]|0;n=f[w>>2]|0;f[n>>2]=f[x>>2];f[n+4>>2]=f[x+4>>2]}else{f[c>>2]=0;U$(k,j)}x=i+40|0;n=f[x>>2]|0;t=f[n+-4>>2]|0;y=j+40|0;z=f[y>>2]|0;a:do if((t|0)==(f[z+-4>>2]|0)){if((t|0)==2){if((f[n>>2]|0)!=(f[z>>2]|0))break;if((f[n+4>>2]|0)!=(f[z+4>>2]|0))break}else if((t|0)>0){A=0;do{if((f[n+(A<<2)>>2]|0)!=(f[z+(A<<2)>>2]|0))break a;A=A+1|0}while((A|0)<(t|0))}A=f[i>>2]|0;B=f[j>>2]|0;if(((B^A)&4088|0)==0?(C=B&7,(A&7|0)==(C|0)|(C|0)==0):0){f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;C=m+8|0;f[C>>2]=0;f[C+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;D=+_na(l,m,d,e,g);if((f[p>>2]|0)!=(f[q>>2]|0)){C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;dY(j,l,f[k>>2]&7,1.0,0.0)}C=f[r>>2]|0;if(C|0?(A=C+12|0,C=f[A>>2]|0,f[A>>2]=C+-1,(C|0)==1):0)V$(k);f[r>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){C=f[v>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}A=f[w>>2]|0;if((A|0)!=(o|0))wL(A);A=f[s>>2]|0;if(A|0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0)V$(j);f[s>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[a>>2]|0)>0){A=f[y>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[a>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))wL(C);C=i+36|0;A=f[C>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)V$(i);f[C>>2]=0;C=i+16|0;A=i+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[A>>2]|0)>0){C=f[x>>2]|0;B=0;do{f[C+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[A>>2]|0))}A=f[i+44>>2]|0;if((A|0)==(i+48|0)){u=h;return +D}wL(A);u=h;return +D}}while(0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;h=$Xc(128)|0;f[l>>2]=h;f[l+8>>2]=-2147483520;f[l+4>>2]=112;i=h;x=267747;j=i+112|0;do{b[i>>0]=b[x>>0]|0;i=i+1|0;x=x+1|0}while((i|0)<(j|0));b[h+112>>0]=0;vM(-215,l,267860,267504,1579);return +(0.0)}function foa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0;e=u;u=u+80|0;g=e+16|0;h=e+4|0;i=e;do if((eS(a)|0)==65536){j=f[a+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=m;m=g+48|0;p=g+44|0;f[p>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;U$(g,j);break}}else bS(g,a,-1);while(0);a=k0(g,2,-1,1)|0;j=f[g>>2]&7;if((a|0)<=-1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=$Xc(64)|0;f[h>>2]=q;r=h+8|0;f[r>>2]=-2147483584;t=h+4|0;f[t>>2]=50;v=q;w=267872;x=v+50|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=q+50|0;b[y>>0]=0;vM(-215,h,267923,267942,158)}k=(j|0)==5;if((j|1|0)!=5){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=$Xc(64)|0;f[h>>2]=q;r=h+8|0;f[r>>2]=-2147483584;t=h+4|0;f[t>>2]=50;v=q;w=267872;x=v+50|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));y=q+50|0;b[y>>0]=0;vM(-215,h,267923,267942,158)}y=c+4|0;n[y>>2]=0.0;n[c>>2]=0.0;n[d>>2]=0.0;a:do if(a|0){q=f[g+16>>2]|0;switch(a|0){case 1:{w=f[q>>2]|0;if(k){z=w;A=f[q+4>>2]|0}else{v=(n[s>>2]=+(w|0),f[s>>2]|0);z=v;A=(n[s>>2]=+(f[q+4>>2]|0),f[s>>2]|0)}f[c>>2]=z;f[y>>2]=A;n[d>>2]=9.999999747378752e-05;break a;break}case 2:{if(k){B=+n[q+12>>2];C=+n[q+4>>2];D=+n[q+8>>2];E=+n[q>>2]}else{B=+(f[q+12>>2]|0);C=+(f[q+4>>2]|0);D=+(f[q+8>>2]|0);E=+(f[q>>2]|0)}n[c>>2]=(E+D)*.5;n[y>>2]=(C+B)*.5;F=E-D;G=C-B;H=+M(+(G*G+F*F))*.5+9.999999747378752e-05;n[d>>2]=H;break a;break}default:{n[h>>2]=0.0;v=h+4|0;n[v>>2]=0.0;n[i>>2]=0.0;b:do if(k){H=+n[q+8>>2];F=(+n[q>>2]+H)*.5;n[h>>2]=F;w=q+4|0;G=+n[q+12>>2];I=(+n[w>>2]+G)*.5;n[v>>2]=I;J=+n[q>>2]-H;H=+n[w>>2]-G;G=+M(+(J*J+H*H))*.5+9.999999747378752e-05;n[i>>2]=G;w=2;H=F;F=I;I=G;while(1){G=+n[q+(w<<3)>>2]-H;J=+n[q+(w<<3)+4>>2]-F;if(!(+M(+(G*G+J*J))<I))goa(q,w,h,i);x=w+1|0;if((x|0)==(a|0))break b;w=x;H=+n[h>>2];F=+n[v>>2];I=+n[i>>2]}}else{w=f[q>>2]|0;x=f[q+8>>2]|0;I=+(x+w|0)*.5;n[h>>2]=I;t=f[q+4>>2]|0;r=f[q+12>>2]|0;F=+(r+t|0)*.5;n[v>>2]=F;H=+(w-x|0);J=+(t-r|0);G=+M(+(H*H+J*J))*.5+9.999999747378752e-05;n[i>>2]=G;r=2;J=I;I=F;F=G;while(1){G=+(f[q+(r<<3)>>2]|0)-J;H=+(f[q+(r<<3)+4>>2]|0)-I;if(!(+M(+(G*G+H*H))<F))hoa(q,r,h,i);t=r+1|0;if((t|0)==(a|0))break b;r=t;J=+n[h>>2];I=+n[v>>2];F=+n[i>>2]}}while(0);f[c>>2]=f[h>>2];f[y>>2]=f[v>>2];f[d>>2]=f[i>>2];break a}}}while(0);i=g+36|0;d=f[i>>2]|0;if(d|0?(y=d+12|0,d=f[y>>2]|0,f[y>>2]=d+-1,(d|0)==1):0)V$(g);f[i>>2]=0;i=g+16|0;d=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[d>>2]|0)>0){i=f[g+40>>2]|0;y=0;do{f[i+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[d>>2]|0))}d=f[g+44>>2]|0;if((d|0)==(g+48|0)){u=e;return}wL(d);u=e;return}function goa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0.0,j=0.0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0;e=a+(b<<3)|0;n[c>>2]=(+n[a>>2]+ +n[e>>2])*.5;f=a+4|0;g=a+(b<<3)+4|0;h=c+4|0;n[h>>2]=(+n[f>>2]+ +n[g>>2])*.5;i=+n[a>>2]-+n[e>>2];j=+n[f>>2]-+n[g>>2];k=+M(+(i*i+j*j))*.5+9.999999747378752e-05;n[d>>2]=k;if((b|0)>1){l=1;m=k}else return;while(1){f=a+(l<<3)|0;k=+n[f>>2];o=a+(l<<3)+4|0;j=+n[o>>2];i=+n[c>>2]-k;p=+n[h>>2]-j;if(+M(+(i*i+p*p))<m)q=m;else{n[c>>2]=(k+ +n[e>>2])*.5;n[h>>2]=(j+ +n[g>>2])*.5;j=+n[f>>2]-+n[e>>2];k=+n[o>>2]-+n[g>>2];p=+M(+(j*j+k*k))*.5+9.999999747378752e-05;n[d>>2]=p;r=0;k=p;while(1){p=+n[a+(r<<3)>>2];j=+n[a+(r<<3)+4>>2];i=+n[c>>2]-p;s=+n[h>>2]-j;if(+M(+(i*i+s*s))<k)t=k;else{s=+n[e>>2];i=+n[g>>2];u=+n[f>>2];v=+n[o>>2];w=u-s;x=v-i;y=p-s;z=j-i;A=w*((s+u)*.5)+x*((i+v)*.5);v=y*((p+s)*.5)+z*((j+i)*.5);j=z*w-y*x;p=(z*A-x*v)/j;x=(w*v-y*A)/j;n[c>>2]=p;n[h>>2]=x;j=p-s;s=x-i;i=+M(+(j*j+s*s))+9.999999747378752e-05;n[d>>2]=i;t=i}r=r+1|0;if((r|0)==(l|0)){q=t;break}else k=t}}l=l+1|0;if((l|0)==(b|0))break;else m=q}return}function hoa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;e=f[a>>2]|0;g=f[a+(b<<3)>>2]|0;n[c>>2]=+(g+e|0)*.5;h=f[a+4>>2]|0;i=f[a+(b<<3)+4>>2]|0;j=c+4|0;n[j>>2]=+(i+h|0)*.5;k=+(e-g|0);l=+(h-i|0);m=+M(+(k*k+l*l))*.5+9.999999747378752e-05;n[d>>2]=m;if((b|0)<=1)return;l=+(g|0);k=+(i|0);h=1;o=m;while(1){e=f[a+(h<<3)>>2]|0;m=+(e|0);p=f[a+(h<<3)+4>>2]|0;q=+(p|0);r=+n[c>>2]-m;s=+n[j>>2]-q;if(+M(+(r*r+s*s))<o)t=o;else{n[c>>2]=+(g+e|0)*.5;n[j>>2]=+(i+p|0)*.5;s=+(e-g|0);r=+(p-i|0);u=+M(+(s*s+r*r))*.5+9.999999747378752e-05;n[d>>2]=u;r=m-l;s=q-k;v=r*((m+l)*.5)+s*((q+k)*.5);p=0;q=u;while(1){u=+(f[a+(p<<3)>>2]|0);m=+(f[a+(p<<3)+4>>2]|0);w=+n[c>>2]-u;x=+n[j>>2]-m;if(+M(+(w*w+x*x))<q)y=q;else{x=u-l;w=m-k;z=x*((l+u)*.5)+w*((k+m)*.5);m=r*w-s*x;u=(v*w-s*z)/m;w=(r*z-v*x)/m;n[c>>2]=u;n[j>>2]=w;m=u-l;u=w-k;w=+M(+(m*m+u*u))+9.999999747378752e-05;n[d>>2]=w;y=w}p=p+1|0;if((p|0)==(h|0)){t=y;break}else q=y}}h=h+1|0;if((h|0)==(b|0))break;else o=t}return}function ioa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;d=u;u=u+80|0;e=d+16|0;g=d;do if((eS(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;U$(e,h);break}}else bS(e,a,-1);while(0);a=k0(e,2,-1,1)|0;h=f[e>>2]&7;if((a|0)<=-1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=$Xc(64)|0;f[g>>2]=o;p=g+8|0;f[p>>2]=-2147483584;q=g+4|0;f[q>>2]=50;r=o;t=267872;v=r+50|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));w=o+50|0;b[w>>0]=0;vM(-215,g,268017,267942,237)}i=(h|0)==5;if((h|1|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=$Xc(64)|0;f[g>>2]=o;p=g+8|0;f[p>>2]=-2147483584;q=g+4|0;f[q>>2]=50;r=o;t=267872;v=r+50|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));w=o+50|0;b[w>>0]=0;vM(-215,g,268017,267942,237)}if((a|0)>=2){g=c?a+-1|0:0;c=f[e+16>>2]|0;if(i){x=0.0;i=0;w=f[c+(g<<3)>>2]|0;o=f[c+(g<<3)+4>>2]|0;while(1){t=w;w=f[c+(i<<3)>>2]|0;y=(f[s>>2]=w,+n[s>>2]);r=o;o=f[c+(i<<3)+4>>2]|0;z=(f[s>>2]=o,+n[s>>2]);A=y-(f[s>>2]=t,+n[s>>2]);y=z-(f[s>>2]=r,+n[s>>2]);z=x+ +M(+(y*y+A*A));i=i+1|0;if((i|0)==(a|0)){B=z;break}else x=z}}else{x=0.0;i=0;z=+(f[c+(g<<3)>>2]|0);A=+(f[c+(g<<3)+4>>2]|0);while(1){y=z;z=+(f[c+(i<<3)>>2]|0);C=A;A=+(f[c+(i<<3)+4>>2]|0);D=z-y;y=A-C;C=x+ +M(+(y*y+D*D));i=i+1|0;if((i|0)==(a|0)){B=C;break}else x=C}}}else B=0.0;a=e+36|0;i=f[a>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)V$(e);f[a>>2]=0;a=e+16|0;i=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[e+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)==(e+48|0)){u=d;return +B}wL(i);u=d;return +B}function joa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;d=u;u=u+80|0;e=d+16|0;g=d;do if((eS(a)|0)==65536){h=f[a+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;U$(e,h);break}}else bS(e,a,-1);while(0);a=k0(e,2,-1,1)|0;h=f[e>>2]&7;if((a|0)<=-1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=$Xc(64)|0;f[g>>2]=o;p=g+8|0;f[p>>2]=-2147483584;q=g+4|0;f[q>>2]=52;r=o;t=268027;v=r+52|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));w=o+52|0;b[w>>0]=0;vM(-215,g,268080,267942,272)}i=(h|0)==5;if((h|1|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;o=$Xc(64)|0;f[g>>2]=o;p=g+8|0;f[p>>2]=-2147483584;q=g+4|0;f[q>>2]=52;r=o;t=268027;v=r+52|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));w=o+52|0;b[w>>0]=0;vM(-215,g,268080,267942,272)}if(a){g=f[e+16>>2]|0;w=a+-1|0;if(i){x=0.0;i=0;o=f[g+(w<<3)+4>>2]|0;y=+n[g+(w<<3)>>2];while(1){z=y;y=+n[g+(i<<3)>>2];t=o;o=f[g+(i<<3)+4>>2]|0;A=z*(f[s>>2]=o,+n[s>>2]);z=x+(A-(f[s>>2]=t,+n[s>>2])*y);i=i+1|0;if((i|0)==(a|0)){B=z;break}else x=z}}else{x=0.0;i=0;y=+(f[g+(w<<3)>>2]|0);z=+(f[g+(w<<3)+4>>2]|0);while(1){A=y;y=+(f[g+(i<<3)>>2]|0);C=z;z=+(f[g+(i<<3)+4>>2]|0);D=x+(A*z-C*y);i=i+1|0;if((i|0)==(a|0)){B=D;break}else x=D}}x=B*.5;if(c)E=x;else E=+L(+x)}else E=0.0;c=e+36|0;a=f[c>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)V$(e);f[c>>2]=0;c=e+16|0;a=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[e+40>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[a>>2]|0))}a=f[e+44>>2]|0;if((a|0)==(e+48|0)){u=d;return +E}wL(a);u=d;return +E}function koa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0.0,_a=0.0,$a=0.0,ab=0,bb=0.0,cb=0.0;d=u;u=u+2592|0;e=d+2528|0;g=d+2232|0;h=d+2192|0;i=d+1096|0;j=d;k=d+2472|0;l=d+2416|0;m=d+2360|0;o=d+2304|0;q=d+2288|0;r=d+2272|0;do if((eS(c)|0)==65536){s=f[c+4>>2]|0;f[e>>2]=f[s>>2];t=e+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=e+8|0;f[w>>2]=f[s+8>>2];f[e+12>>2]=f[s+12>>2];f[e+16>>2]=f[s+16>>2];f[e+20>>2]=f[s+20>>2];f[e+24>>2]=f[s+24>>2];f[e+28>>2]=f[s+28>>2];f[e+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[e+36>>2]=x;f[e+40>>2]=w;w=e+48|0;y=e+44|0;f[y>>2]=w;f[w>>2]=0;f[e+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;U$(e,s);break}}else bS(e,c,-1);while(0);c=k0(e,2,-1,1)|0;s=f[e>>2]&7;if((c|0)<=-1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(48)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483600;B=g+4|0;f[B>>2]=46;C=z;D=268092;E=C+46|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+46|0;b[F>>0]=0;vM(-215,g,268139,267942,305)}t=(s|0)==5;if((s|1|0)!=5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=$Xc(48)|0;f[g>>2]=z;A=g+8|0;f[A>>2]=-2147483600;B=g+4|0;f[B>>2]=46;C=z;D=268092;E=C+46|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+46|0;b[F>>0]=0;vM(-215,g,268139,267942,305)};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;if((c|0)<5){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;F=$Xc(64)|0;f[g>>2]=F;f[g+8>>2]=-2147483584;f[g+4>>2]=52;C=F;D=268150;E=C+52|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[F+52>>0]=0;vM(-201,g,268139,267942,310)}C=g;E=C+40|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));C=h;E=C+40|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));C=e+16|0;E=f[C>>2]|0;F=e+44|0;D=c*5|0;z=i+8|0;f[i>>2]=z;B=i+4|0;f[B>>2]=D;if(D>>>0>136){A=bYc(D>>>0>536870911?-1:D<<3)|0;f[i>>2]=A;G=A}else G=z;A=j+8|0;f[j>>2]=A;s=j+4|0;f[s>>2]=c;if(c>>>0>136){v=bYc(c>>>0>536870911?-1:c<<3)|0;f[j>>2]=v;H=v}else H=A;f[k>>2]=1124007942;v=k+4|0;f[v>>2]=2;w=k+8|0;f[w>>2]=c;y=k+12|0;f[y>>2]=5;x=k+16|0;f[x>>2]=G;I=k+20|0;f[I>>2]=G;J=k+24|0;K=k+28|0;N=k+40|0;O=J+8|0;f[O>>2]=0;f[O+4>>2]=0;f[N>>2]=w;O=k+48|0;Q=k+44|0;f[Q>>2]=O;f[O>>2]=40;f[k+52>>2]=8;R=G+(D<<3)|0;f[K>>2]=R;f[J>>2]=R+-40+40;R$(k);f[l>>2]=1124007942;R=l+4|0;f[R>>2]=2;D=l+8|0;f[D>>2]=c;S=l+12|0;f[S>>2]=1;T=l+16|0;f[T>>2]=H;V=l+20|0;f[V>>2]=H;W=l+24|0;X=l+28|0;Y=l+40|0;Z=W+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Y>>2]=D;Z=l+48|0;_=l+44|0;f[_>>2]=Z;f[Z>>2]=8;f[l+52>>2]=8;$=H+(c<<3)|0;f[X>>2]=$;aa=$+-8+8|0;f[W>>2]=aa;R$(l);f[m>>2]=1124007942;ba=m+4|0;f[ba>>2]=2;ca=m+8|0;f[ca>>2]=5;da=m+12|0;f[da>>2]=1;ea=m+16|0;f[ea>>2]=g;fa=m+20|0;f[fa>>2]=g;ga=m+24|0;ha=m+28|0;ia=m+40|0;ja=ga+8|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ia>>2]=ca;ja=m+48|0;ka=m+44|0;f[ka>>2]=ja;f[ja>>2]=8;f[m+52>>2]=8;f[ha>>2]=g+40;f[ga>>2]=g+40;R$(m);la=(c|0)>0;if(la){if(t){ma=0;na=0.0;oa=0.0;while(1){pa=na+ +n[E+(ma<<3)>>2];qa=oa+ +n[E+(ma<<3)+4>>2];ma=ma+1|0;if((ma|0)==(c|0)){ra=pa;sa=qa;break}else{na=pa;oa=qa}}}else{ma=0;oa=0.0;na=0.0;while(1){qa=oa+ +(f[E+(ma<<3)>>2]|0);pa=na+ +(f[E+(ma<<3)+4>>2]|0);ma=ma+1|0;if((ma|0)==(c|0)){ra=qa;sa=pa;break}else{oa=qa;na=pa}}}na=+(c|0);oa=ra/na;ra=sa/na;if(la)if(t){ma=0;do{na=+n[E+(ma<<3)>>2]-oa;sa=+n[E+(ma<<3)+4>>2]-ra;p[H+(ma<<3)>>3]=1.0e4;pa=na;ta=ma*5|0;p[G+(ta<<3)>>3]=-(pa*pa);na=sa;p[G+(ta+1<<3)>>3]=-(na*na);p[G+(ta+2<<3)>>3]=-(na*pa);p[G+(ta+3<<3)>>3]=pa;p[G+(ta+4<<3)>>3]=na;ma=ma+1|0}while((ma|0)!=(c|0));ua=oa;va=ra}else{ma=0;do{na=+(f[E+(ma<<3)>>2]|0)-oa;pa=+(f[E+(ma<<3)+4>>2]|0)-ra;p[H+(ma<<3)>>3]=1.0e4;sa=na;ta=ma*5|0;p[G+(ta<<3)>>3]=-(sa*sa);na=pa;p[G+(ta+1<<3)>>3]=-(na*na);p[G+(ta+2<<3)>>3]=-(na*sa);p[G+(ta+3<<3)>>3]=sa;p[G+(ta+4<<3)>>3]=na;ma=ma+1|0}while((ma|0)!=(c|0));ua=oa;va=ra}else{ua=oa;va=ra}}else{ra=+(c|0);ua=0.0/ra;va=0.0/ra}f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;ma=r+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;pM(o,q,r,1)|0;f[o>>2]=1124007942;ma=o+4|0;f[ma>>2]=2;ta=o+8|0;f[ta>>2]=2;wa=o+12|0;f[wa>>2]=2;xa=o+16|0;f[xa>>2]=G;ya=o+20|0;f[ya>>2]=G;za=o+24|0;Aa=o+28|0;Ba=o+40|0;Ca=za+8|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ba>>2]=ta;Ca=o+48|0;f[o+44>>2]=Ca;f[Ca>>2]=16;f[o+52>>2]=8;Da=G+32|0;f[Aa>>2]=Da;f[za>>2]=Da;R$(o);Da=k+36|0;Ea=f[Da>>2]|0;if(Ea|0?(Fa=Ea+12|0,Ea=f[Fa>>2]|0,f[Fa>>2]=Ea+-1,(Ea|0)==1):0)V$(k);f[Da>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[v>>2]|0)>0){Ea=f[N>>2]|0;Fa=0;do{f[Ea+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[v>>2]|0))}f[k>>2]=f[o>>2];Fa=f[ma>>2]|0;f[v>>2]=Fa;f[w>>2]=f[ta>>2];f[y>>2]=f[wa>>2];f[x>>2]=f[xa>>2];f[I>>2]=f[ya>>2];f[J>>2]=f[za>>2];f[K>>2]=f[Aa>>2];Aa=k+32|0;f[Aa>>2]=f[o+32>>2];za=o+36|0;f[Da>>2]=f[za>>2];ya=k+44|0;wa=f[ya>>2]|0;if((wa|0)==(O|0))Ga=Fa;else{wL(wa);f[ya>>2]=O;f[N>>2]=w;Ga=f[ma>>2]|0}wa=o+44|0;if((Ga|0)<3){Ga=f[wa>>2]|0;f[O>>2]=f[Ga>>2];f[k+52>>2]=f[Ga+4>>2];Ha=Ga}else{f[ya>>2]=f[wa>>2];f[k+40>>2]=f[Ba>>2];f[wa>>2]=Ca;f[Ba>>2]=ta;Ha=Ca}f[o>>2]=1124007936;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;f[ma+16>>2]=0;f[ma+20>>2]=0;f[ma+24>>2]=0;f[ma+28>>2]=0;f[za>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((Ha|0)!=(Ca|0))wL(Ha);f[o>>2]=1124007942;Ha=o+4|0;f[Ha>>2]=2;Ca=o+8|0;f[Ca>>2]=2;xa=o+12|0;f[xa>>2]=1;za=o+16|0;f[za>>2]=H;ma=o+20|0;f[ma>>2]=H;ta=o+24|0;Ba=o+28|0;wa=o+40|0;Ga=ta+8|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[wa>>2]=Ca;Ga=o+48|0;f[o+44>>2]=Ga;f[Ga>>2]=8;f[o+52>>2]=8;Fa=H+16|0;f[Ba>>2]=Fa;f[ta>>2]=Fa;R$(o);Fa=l+36|0;Ea=f[Fa>>2]|0;if(Ea|0?(Ia=Ea+12|0,Ea=f[Ia>>2]|0,f[Ia>>2]=Ea+-1,(Ea|0)==1):0)V$(l);f[Fa>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[R>>2]|0)>0){Ea=f[Y>>2]|0;Ia=0;do{f[Ea+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[R>>2]|0))}f[l>>2]=f[o>>2];Ia=f[Ha>>2]|0;f[R>>2]=Ia;f[D>>2]=f[Ca>>2];f[S>>2]=f[xa>>2];f[T>>2]=f[za>>2];f[V>>2]=f[ma>>2];f[W>>2]=f[ta>>2];f[X>>2]=f[Ba>>2];Ba=l+32|0;f[Ba>>2]=f[o+32>>2];ta=o+36|0;f[Fa>>2]=f[ta>>2];ma=l+44|0;xa=f[ma>>2]|0;if((xa|0)==(Z|0))Ja=Ia;else{wL(xa);f[ma>>2]=Z;f[Y>>2]=D;Ja=f[Ha>>2]|0}xa=o+44|0;if((Ja|0)<3){Ja=f[xa>>2]|0;f[Z>>2]=f[Ja>>2];f[l+52>>2]=f[Ja+4>>2];Ka=Ja}else{f[ma>>2]=f[xa>>2];f[l+40>>2]=f[wa>>2];f[xa>>2]=Ga;f[wa>>2]=Ca;Ka=Ga}f[o>>2]=1124007936;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;f[Ha+16>>2]=0;f[Ha+20>>2]=0;f[Ha+24>>2]=0;f[Ha+28>>2]=0;f[ta>>2]=0;f[za>>2]=0;f[za+4>>2]=0;f[za+8>>2]=0;f[za+12>>2]=0;if((Ka|0)!=(Ga|0))wL(Ka);f[o>>2]=1124007942;Ka=o+4|0;f[Ka>>2]=2;Ga=o+8|0;f[Ga>>2]=2;za=o+12|0;f[za>>2]=1;ta=o+16|0;f[ta>>2]=h;Ha=o+20|0;f[Ha>>2]=h;Ca=o+24|0;wa=o+28|0;xa=o+40|0;Ja=Ca+8|0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[xa>>2]=Ga;Ja=o+48|0;f[o+44>>2]=Ja;f[Ja>>2]=8;f[o+52>>2]=8;Ia=h+16|0;f[wa>>2]=Ia;f[Ca>>2]=Ia;R$(o);Ea=m+36|0;La=f[Ea>>2]|0;if(La|0?(Ma=La+12|0,La=f[Ma>>2]|0,f[Ma>>2]=La+-1,(La|0)==1):0)V$(m);f[Ea>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[ba>>2]|0)>0){La=f[ia>>2]|0;Ma=0;do{f[La+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[ba>>2]|0))}f[m>>2]=f[o>>2];Ma=f[Ka>>2]|0;f[ba>>2]=Ma;f[ca>>2]=f[Ga>>2];f[da>>2]=f[za>>2];f[ea>>2]=f[ta>>2];f[fa>>2]=f[Ha>>2];f[ga>>2]=f[Ca>>2];f[ha>>2]=f[wa>>2];wa=m+32|0;f[wa>>2]=f[o+32>>2];Ca=o+36|0;f[Ea>>2]=f[Ca>>2];Ha=m+44|0;za=f[Ha>>2]|0;if((za|0)==(ja|0))Na=Ma;else{wL(za);f[Ha>>2]=ja;f[ia>>2]=ca;Na=f[Ka>>2]|0}za=o+44|0;if((Na|0)<3){Na=f[za>>2]|0;f[ja>>2]=f[Na>>2];f[m+52>>2]=f[Na+4>>2];Oa=Na}else{f[Ha>>2]=f[za>>2];f[m+40>>2]=f[xa>>2];f[za>>2]=Ja;f[xa>>2]=Ga;Oa=Ja}f[o>>2]=1124007936;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;f[Ka+16>>2]=0;f[Ka+20>>2]=0;f[Ka+24>>2]=0;f[Ka+28>>2]=0;f[Ca>>2]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((Oa|0)!=(Ja|0))wL(Oa);p[G>>3]=+p[g>>3]*2.0;Oa=g+16|0;ra=+p[Oa>>3];p[G+16>>3]=ra;p[G+8>>3]=ra;Ja=g+8|0;p[G+24>>3]=+p[Ja>>3]*2.0;ta=g+24|0;p[H>>3]=+p[ta>>3];p[H+8>>3]=+p[g+32>>3];f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;Ca=r+8|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;pM(o,q,r,1)|0;f[o>>2]=1124007942;Ca=o+4|0;f[Ca>>2]=2;Ka=o+8|0;f[Ka>>2]=c;Ga=o+12|0;f[Ga>>2]=3;xa=o+16|0;f[xa>>2]=G;za=o+20|0;f[za>>2]=G;Na=o+24|0;Ma=o+28|0;La=o+40|0;Pa=Na+8|0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[La>>2]=Ka;Pa=o+48|0;f[o+44>>2]=Pa;f[Pa>>2]=24;f[o+52>>2]=8;Qa=G+(c*3<<3)|0;f[Ma>>2]=Qa;f[Na>>2]=Qa+-24+24;R$(o);Qa=f[Da>>2]|0;do if(Qa|0){Ra=Qa+12|0;Sa=f[Ra>>2]|0;f[Ra>>2]=Sa+-1;if((Sa|0)!=1)break;V$(k)}while(0);f[Da>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[v>>2]|0)>0){Qa=f[N>>2]|0;Sa=0;do{f[Qa+(Sa<<2)>>2]=0;Sa=Sa+1|0}while((Sa|0)<(f[v>>2]|0))}f[k>>2]=f[o>>2];Sa=f[Ca>>2]|0;f[v>>2]=Sa;f[w>>2]=f[Ka>>2];f[y>>2]=f[Ga>>2];f[x>>2]=f[xa>>2];f[I>>2]=f[za>>2];f[J>>2]=f[Na>>2];f[K>>2]=f[Ma>>2];f[Aa>>2]=f[o+32>>2];Aa=o+36|0;f[Da>>2]=f[Aa>>2];Ma=f[ya>>2]|0;if((Ma|0)==(O|0))Ta=Sa;else{wL(Ma);f[ya>>2]=O;f[N>>2]=w;Ta=f[Ca>>2]|0}w=o+44|0;if((Ta|0)<3){Ta=f[w>>2]|0;f[O>>2]=f[Ta>>2];f[k+52>>2]=f[Ta+4>>2];Ua=Ta}else{f[ya>>2]=f[w>>2];f[k+40>>2]=f[La>>2];f[w>>2]=Pa;f[La>>2]=Ka;Ua=Pa}f[o>>2]=1124007936;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;f[Ca+16>>2]=0;f[Ca+20>>2]=0;f[Ca+24>>2]=0;f[Ca+28>>2]=0;f[Aa>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((Ua|0)!=(Pa|0))wL(Ua);f[o>>2]=1124007942;Ua=o+4|0;f[Ua>>2]=2;Pa=o+8|0;f[Pa>>2]=c;xa=o+12|0;f[xa>>2]=1;Aa=o+16|0;f[Aa>>2]=H;Ca=o+20|0;f[Ca>>2]=H;Ka=o+24|0;La=o+28|0;w=o+40|0;ya=Ka+8|0;f[ya>>2]=0;f[ya+4>>2]=0;f[w>>2]=Pa;ya=o+48|0;f[o+44>>2]=ya;f[ya>>2]=8;f[o+52>>2]=8;f[La>>2]=$;f[Ka>>2]=aa;R$(o);aa=f[Fa>>2]|0;do if(aa|0){$=aa+12|0;Ta=f[$>>2]|0;f[$>>2]=Ta+-1;if((Ta|0)!=1)break;V$(l)}while(0);f[Fa>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[R>>2]|0)>0){aa=f[Y>>2]|0;Ta=0;do{f[aa+(Ta<<2)>>2]=0;Ta=Ta+1|0}while((Ta|0)<(f[R>>2]|0))}f[l>>2]=f[o>>2];Ta=f[Ua>>2]|0;f[R>>2]=Ta;f[D>>2]=f[Pa>>2];f[S>>2]=f[xa>>2];f[T>>2]=f[Aa>>2];f[V>>2]=f[Ca>>2];f[W>>2]=f[Ka>>2];f[X>>2]=f[La>>2];f[Ba>>2]=f[o+32>>2];Ba=o+36|0;f[Fa>>2]=f[Ba>>2];La=f[ma>>2]|0;if((La|0)==(Z|0))Va=Ta;else{wL(La);f[ma>>2]=Z;f[Y>>2]=D;Va=f[Ua>>2]|0}D=o+44|0;if((Va|0)<3){Va=f[D>>2]|0;f[Z>>2]=f[Va>>2];f[l+52>>2]=f[Va+4>>2];Wa=Va}else{f[ma>>2]=f[D>>2];f[l+40>>2]=f[w>>2];f[D>>2]=ya;f[w>>2]=Pa;Wa=ya}f[o>>2]=1124007936;f[Ua>>2]=0;f[Ua+4>>2]=0;f[Ua+8>>2]=0;f[Ua+12>>2]=0;f[Ua+16>>2]=0;f[Ua+20>>2]=0;f[Ua+24>>2]=0;f[Ua+28>>2]=0;f[Ba>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((Wa|0)!=(ya|0))wL(Wa);f[o>>2]=1124007942;Wa=o+4|0;f[Wa>>2]=2;ya=o+8|0;f[ya>>2]=3;Aa=o+12|0;f[Aa>>2]=1;Ba=o+16|0;f[Ba>>2]=g;Ua=o+20|0;f[Ua>>2]=g;Pa=o+24|0;w=o+28|0;D=o+40|0;ma=Pa+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[D>>2]=ya;ma=o+48|0;f[o+44>>2]=ma;f[ma>>2]=8;f[o+52>>2]=8;f[w>>2]=ta;f[Pa>>2]=ta;R$(o);ta=f[Ea>>2]|0;do if(ta|0){Va=ta+12|0;La=f[Va>>2]|0;f[Va>>2]=La+-1;if((La|0)!=1)break;V$(m)}while(0);f[Ea>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[ba>>2]|0)>0){ta=f[ia>>2]|0;La=0;do{f[ta+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[ba>>2]|0))}f[m>>2]=f[o>>2];La=f[Wa>>2]|0;f[ba>>2]=La;f[ca>>2]=f[ya>>2];f[da>>2]=f[Aa>>2];f[ea>>2]=f[Ba>>2];f[fa>>2]=f[Ua>>2];f[ga>>2]=f[Pa>>2];f[ha>>2]=f[w>>2];f[wa>>2]=f[o+32>>2];wa=o+36|0;f[Ea>>2]=f[wa>>2];w=f[Ha>>2]|0;if((w|0)==(ja|0))Xa=La;else{wL(w);f[Ha>>2]=ja;f[ia>>2]=ca;Xa=f[Wa>>2]|0}ca=o+44|0;if((Xa|0)<3){Xa=f[ca>>2]|0;f[ja>>2]=f[Xa>>2];f[m+52>>2]=f[Xa+4>>2];Ya=Xa}else{f[Ha>>2]=f[ca>>2];f[m+40>>2]=f[D>>2];f[ca>>2]=ma;f[D>>2]=ya;Ya=ma}f[o>>2]=1124007936;f[Wa>>2]=0;f[Wa+4>>2]=0;f[Wa+8>>2]=0;f[Wa+12>>2]=0;f[Wa+16>>2]=0;f[Wa+20>>2]=0;f[Wa+24>>2]=0;f[Wa+28>>2]=0;f[wa>>2]=0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;if((Ya|0)!=(ma|0))wL(Ya);if(la){ra=+p[h>>3];oa=+p[h+8>>3];if(t){t=0;do{na=+n[E+(t<<3)>>2]-ua;sa=+n[E+(t<<3)+4>>2]-va;p[H+(t<<3)>>3]=1.0;pa=na;na=pa-ra;la=t*3|0;p[G+(la<<3)>>3]=na*na;na=sa;sa=na-oa;p[G+(la+1<<3)>>3]=sa*sa;p[G+(la+2<<3)>>3]=(pa-ra)*(na-oa);t=t+1|0}while((t|0)!=(c|0))}else{t=0;do{na=+(f[E+(t<<3)>>2]|0)-ua;pa=+(f[E+(t<<3)+4>>2]|0)-va;p[H+(t<<3)>>3]=1.0;sa=na;na=sa-ra;la=t*3|0;p[G+(la<<3)>>3]=na*na;na=pa;pa=na-oa;p[G+(la+1<<3)>>3]=pa*pa;p[G+(la+2<<3)>>3]=(sa-ra)*(na-oa);t=t+1|0}while((t|0)!=(c|0))}}f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;pM(o,q,r,1)|0;oa=+p[Oa>>3];ra=+p[Ja>>3];na=+p[g>>3];sa=ra-na;pa=+U(+oa,+sa)*-.5;p[h+32>>3]=pa;if(+L(+oa)>1.0e-08)Za=oa/+P(+(pa*-2.0));else Za=sa;sa=na+ra;ra=+L(+(sa-Za));if(ra>1.0e-08)_a=+M(+(2.0/ra));else _a=ra;p[Ia>>3]=_a;ra=+L(+(sa+Za));if(ra>1.0e-08)$a=+M(+(2.0/ra));else $a=ra;p[h+24>>3]=$a;n[a>>2]=ua+ +p[h>>3];n[a+4>>2]=va+ +p[h+8>>3];va=_a*2.0;h=a+8|0;n[h>>2]=va;_a=$a*2.0;Ia=a+12|0;n[Ia>>2]=_a;if(va>_a){n[h>>2]=_a;n[Ia>>2]=va;va=pa*180.0/3.141592653589793+90.0;Ia=a+16|0;n[Ia>>2]=va;ab=Ia;bb=va}else{Ia=a+16|0;ab=Ia;bb=+n[Ia>>2]}va=bb+360.0;if(bb<-180.0){n[ab>>2]=va;cb=va}else cb=bb;if(cb>360.0)n[ab>>2]=cb+-360.0;ab=f[Ea>>2]|0;do if(ab|0){Ia=ab+12|0;a=f[Ia>>2]|0;f[Ia>>2]=a+-1;if((a|0)!=1)break;V$(m)}while(0);f[Ea>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[ba>>2]|0)>0){ea=f[ia>>2]|0;ia=0;do{f[ea+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ba>>2]|0))}ba=f[ka>>2]|0;if((ba|0)!=(ja|0))wL(ba);ba=f[Fa>>2]|0;do if(ba|0){ja=ba+12|0;ka=f[ja>>2]|0;f[ja>>2]=ka+-1;if((ka|0)!=1)break;V$(l)}while(0);f[Fa>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[R>>2]|0)>0){T=f[Y>>2]|0;Y=0;do{f[T+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[R>>2]|0))}R=f[_>>2]|0;if((R|0)!=(Z|0))wL(R);R=f[Da>>2]|0;do if(R|0){Z=R+12|0;_=f[Z>>2]|0;f[Z>>2]=_+-1;if((_|0)!=1)break;V$(k)}while(0);f[Da>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[v>>2]|0)>0){x=f[N>>2]|0;N=0;do{f[x+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[v>>2]|0))}v=f[Q>>2]|0;if((v|0)!=(O|0))wL(v);v=f[j>>2]|0;if((v|0)!=(A|0)){if(v|0)dYc(v);f[j>>2]=A;f[s>>2]=136}s=f[i>>2]|0;if((s|0)!=(z|0)){if(s|0)dYc(s);f[i>>2]=z;f[B>>2]=136}B=e+36|0;z=f[B>>2]|0;do if(z|0){i=z+12|0;s=f[i>>2]|0;f[i>>2]=s+-1;if((s|0)!=1)break;V$(e)}while(0);f[B>>2]=0;B=e+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[e+40>>2]|0;z=0;do{f[C+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[B>>2]|0))}B=f[F>>2]|0;if((B|0)==(e+48|0)){u=d;return}wL(B);u=d;return}function loa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c;do if((eS(b)|0)==65536){e=f[b+4>>2]|0;f[d>>2]=f[e>>2];g=d+4|0;h=e+4|0;f[g>>2]=f[h>>2];i=d+8|0;f[i>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[d+16>>2]=f[e+16>>2];f[d+20>>2]=f[e+20>>2];f[d+24>>2]=f[e+24>>2];f[d+28>>2]=f[e+28>>2];f[d+32>>2]=f[e+32>>2];j=f[e+36>>2]|0;f[d+36>>2]=j;f[d+40>>2]=i;i=d+48|0;k=d+44|0;f[k>>2]=i;f[i>>2]=0;f[d+52>>2]=0;if(j|0){i=j+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[h>>2]|0)<3){h=f[e+44>>2]|0;i=f[k>>2]|0;f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];l=d;break}else{f[g>>2]=0;U$(d,e);l=d;break}}else{bS(d,b,-1);l=d}while(0);if(!(f[l>>2]&7))moa(a,d);else noa(a,d);a=d+36|0;l=f[a>>2]|0;if(l|0?(b=l+12|0,l=f[b>>2]|0,f[b>>2]=l+-1,(l|0)==1):0)V$(d);f[a>>2]=0;a=d+16|0;l=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[l>>2]|0)>0){a=f[d+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[l>>2]|0))}l=f[d+44>>2]|0;if((l|0)==(d+48|0)){u=c;return}wL(l);u=c;return}function moa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;if(!((g&6)>>>0<2&(g&4088|0)==0)){g=$Xc(48)|0;f[e>>2]=g;f[e+8>>2]=-2147483600;f[e+4>>2]=43;h=g;i=268224;j=h+43|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));b[g+43>>0]=0;vM(-215,e,268268,267942,859)}e=f[c+40>>2]|0;g=f[e+4>>2]|0;i=f[e>>2]|0;if((i|0)<=0){k=g;l=-1;m=-1;n=0;o=(k|0)<(g|0);p=o?l:0;q=o?k:0;r=m+1|0;s=r-q|0;t=n-p|0;f[a>>2]=q;v=a+4|0;f[v>>2]=p;w=a+8|0;f[w>>2]=s;x=a+12|0;f[x>>2]=t;u=d;return}e=f[c+16>>2]|0;h=f[f[c+44>>2]>>2]|0;c=-1;j=-1;y=0;z=-1;A=g;while(1){B=e+(Y(h,y)|0)|0;C=B;D=C+3&-4;E=D;F=D-C|0;C=(F|0)>(g|0)?g:F;a:do if((C|0)>0){D=0;while(1){if(b[B+D>>0]|0)break;G=D+1|0;if((G|0)<(C|0))D=G;else{H=0;I=j;J=A;break a}}H=1;I=(D|0)>(j|0)?D:j;J=(D|0)<(A|0)?D:A}else{H=0;I=j;J=A}while(0);if((g|0)>(F|0)){B=J-C|0;G=I-C|0;K=g-C|0;L=B+-4|0;b:do if((B|0)<4)M=0;else{N=0;while(1){if(f[E+N>>2]|0){M=N;break b}O=N+4|0;if((O|0)>(L|0)){M=O;break}else N=O}}while(0);c:do if((M|0)<(B|0)){L=M;while(1){if(b[E+L>>0]|0)break;F=L+1|0;if((F|0)<(B|0))L=F;else{P=H;Q=F;R=B;S=G;break c}}P=1;Q=L;R=L;S=(L|0)>(G|0)?L:G}else{P=H;Q=M;R=B;S=G}while(0);G=Q+-1|0;B=(G|0)<(S|0)?S:G;G=K;while(1){T=G+-1|0;U=(T|0)>(B|0);V=(T&3|0)==3;if(V|U^1){W=20;break}if(!(b[E+T>>0]|0))G=T;else{X=T;break}}d:do if((W|0)==20){W=0;if(U&V?(G=B+3|0,(T|0)>(G|0)):0){K=T;while(1){if(f[E+K+-3>>2]|0){X=K;break d}F=K+-4|0;if((F|0)>(G|0))K=F;else{X=F;break}}}else X=T}while(0);e:do if((X|0)>(B|0)){K=X;while(1){if(b[E+K>>0]|0){Z=1;_=K;break e}G=K+-1|0;if((G|0)>(B|0))K=G;else{$=G;W=27;break}}}else{$=X;W=27}while(0);f:do if((W|0)==27){W=0;if(!P){B=Q&-4;K=$+-3|0;g:do if((B|0)>(K|0))aa=B;else{G=B;while(1){if(f[E+G>>2]|0){aa=G;break g}L=G+4|0;if((L|0)>(K|0)){aa=L;break}else G=L}}while(0);if((aa|0)>($|0)){Z=0;_=S}else{K=aa;while(1){if(b[E+K>>0]|0){Z=1;_=S;break f}if((K|0)<($|0))K=K+1|0;else{Z=0;_=S;break}}}}else{Z=P;_=S}}while(0);ba=R+C|0;ca=Z;da=_+C|0}else{ba=J;ca=H;da=I}E=(ca|0)==0;z=E?z:y;c=E?c:(c|0)<0?y:c;y=y+1|0;if((y|0)==(i|0))break;else{j=da;A=ba}}k=ba;l=c;m=da;n=z+1|0;o=(k|0)<(g|0);p=o?l:0;q=o?k:0;r=m+1|0;s=r-q|0;t=n-p|0;f[a>>2]=q;v=a+4|0;f[v>>2]=p;w=a+8|0;f[w>>2]=s;x=a+12|0;f[x>>2]=t;u=d;return}function noa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0;d=u;u=u+16|0;e=d;g=k0(c,2,-1,1)|0;h=f[c>>2]&7;if((g|0)<=-1){i=$Xc(64)|0;f[e>>2]=i;j=e+8|0;f[j>>2]=-2147483584;k=e+4|0;f[k>>2]=52;l=i;m=268027;o=l+52|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));p=i+52|0;b[p>>0]=0;vM(-215,e,268203,267942,741)}q=(h|0)==5;if((h|1|0)!=5){i=$Xc(64)|0;f[e>>2]=i;j=e+8|0;f[j>>2]=-2147483584;k=e+4|0;f[k>>2]=52;l=i;m=268027;o=l+52|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));p=i+52|0;b[p>>0]=0;vM(-215,e,268203,267942,741)}if(!g){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;u=d;return}e=f[c+16>>2]|0;c=f[e>>2]|0;p=f[e+4>>2]|0;if(!q)if((g|0)>1){q=c;i=p;m=c;l=1;o=p;while(1){k=f[e+(l<<3)>>2]|0;j=f[e+(l<<3)+4>>2]|0;h=(q|0)>(k|0)?k:q;r=(m|0)<(k|0)?k:m;k=(i|0)>(j|0)?j:i;t=(o|0)<(j|0)?j:o;l=l+1|0;if((l|0)==(g|0)){v=h;w=k;x=r;y=t;break}else{q=h;i=k;m=r;o=t}}}else{v=c;w=p;x=c;y=p}else{o=c>>31&2147483647^c;c=p>>31&2147483647^p;if((g|0)>1){p=1;m=c;i=o;q=c;l=o;while(1){t=f[e+(p<<3)>>2]|0;r=f[e+(p<<3)+4>>2]|0;k=t>>31&2147483647^t;t=r>>31&2147483647^r;r=(l|0)>(k|0)?k:l;h=(i|0)<(k|0)?k:i;k=(m|0)>(t|0)?t:m;j=(q|0)<(t|0)?t:q;p=p+1|0;if((p|0)==(g|0)){z=r;A=k;B=h;C=j;break}else{m=k;i=h;q=j;l=r}}}else{z=o;A=c;B=o;C=c}D=(f[s>>2]=z>>31&2147483647^z,+n[s>>2]);z=~~D;E=(f[s>>2]=A>>31&2147483647^A,+n[s>>2]);A=~~E;F=(f[s>>2]=B>>31&2147483647^B,+n[s>>2]);B=~~F;G=(f[s>>2]=C>>31&2147483647^C,+n[s>>2]);C=~~G;v=z-(+(z|0)>D&1)|0;w=A-(+(A|0)>E&1)|0;x=B-(+(B|0)>F&1)|0;y=C-(+(C|0)>G&1)|0}f[a>>2]=v;f[a+4>>2]=w;f[a+8>>2]=x+1-v;f[a+12>>2]=y+1-w;u=d;return}function ooa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+1344|0;g=e+1256|0;h=e+1236|0;i=e+1208|0;j=e;k=e+1152|0;l=e+1096|0;if((c|0)!=0?(m=f[c>>2]|0,(m&-65536|0)==1117323264):0){if((m&4094|0)!=12){m=$Xc(32)|0;f[j>>2]=m;f[j+8>>2]=-2147483616;f[j+4>>2]=25;n=m;o=268285;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+25>>0]=0;vM(-5,j,268311,267942,1316)}if((f[c+4>>2]|0)>=88)if(!d){m=c+56|0;f[a>>2]=f[m>>2];f[a+4>>2]=f[m+4>>2];f[a+8>>2]=f[m+8>>2];f[a+12>>2]=f[m+12>>2];u=e;return}else{q=d;r=c;s=21}else{q=0;r=c;s=21}}else s=6;a:do if((s|0)==6){d=n3(c,i,0,0)|0;switch(f[d>>2]&4095){case 13:case 12:{q=0;r=fpa(0,d,g,h)|0;s=21;break a;break}case 1:case 0:{if(!d){q=0;r=0;s=21;break a}gT(k,d,0,1,0,0);moa(j,k);d=f[j>>2]|0;m=f[j+4>>2]|0;t=f[j+8>>2]|0;v=f[j+12>>2]|0;w=k+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)V$(k);f[w>>2]=0;w=k+16|0;x=k+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[k+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[k+44>>2]|0;if((x|0)!=(k+48|0))wL(x);z=d;A=t;B=v;C=m;break a;break}default:{x=$Xc(64)|0;f[j>>2]=x;f[j+8>>2]=-2147483584;f[j+4>>2]=56;n=x;o=268326;p=n+56|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[x+56>>0]=0;vM(-210,j,268311,267942,1336)}}}while(0);if((s|0)==21){if(!(f[r+24>>2]|0)){D=0;E=0;F=0;G=0}else{s=j+8|0;f[j>>2]=s;o=j+4|0;f[o>>2]=136;gT(l,r,0,0,0,j);noa(k,l);n=f[k>>2]|0;p=f[k+4>>2]|0;h=f[k+8>>2]|0;g=f[k+12>>2]|0;k=l+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)V$(l);f[k>>2]=0;k=l+16|0;i=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[l+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[l+44>>2]|0;if((i|0)!=(l+48|0))wL(i);i=f[j>>2]|0;if((i|0)!=(s|0)){if(i|0)dYc(i);f[j>>2]=s;f[o>>2]=136}D=n;E=h;F=g;G=p}if(!q){z=D;A=E;B=F;C=G}else{f[r+56>>2]=D;f[r+60>>2]=G;f[r+64>>2]=E;f[r+68>>2]=F;z=D;A=E;B=F;C=G}}f[a>>2]=z;f[a+4>>2]=C;f[a+8>>2]=A;f[a+12>>2]=B;u=e;return}function poa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;if((e|0)<1){qoa(a,b,c,d,f,g);return}else{roa(a,b,c,d,e,f,g);return}}function qoa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;i=u;u=u+208|0;j=i+144|0;k=i+88|0;l=i+72|0;m=i+16|0;n=i;if((h+-5|0)>>>0>=2){o=$Xc(48)|0;f[j>>2]=o;f[j+8>>2]=-2147483600;f[j+4>>2]=34;p=o;q=272993;r=p+34|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+34>>0]=0;vM(-215,j,268566,268399,61)}ZS(a,3,1,h,-1,1,0);ZS(c,3,1,h,-1,1,0);do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[j>>2]=f[o>>2];s=j+4|0;t=o+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[j+16>>2]=f[o+16>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];w=f[o+36>>2]|0;f[j+36>>2]=w;f[j+40>>2]=v;v=j+48|0;x=j+44|0;f[x>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[o+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;U$(j,o);break}}else bS(j,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];o=k+4|0;s=a+4|0;f[o>>2]=f[s>>2];t=k+8|0;f[t>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;x=k+44|0;f[x>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[o>>2]=0;U$(k,a);break}}else bS(k,c,-1);while(0);if(!((e|d|0)>-1&(e+d|0)==1)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c=$Xc(48)|0;f[l>>2]=c;f[l+8>>2]=-2147483600;f[l+4>>2]=32;p=c;q=268583;r=p+32|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[c+32>>0]=0;vM(-215,l,268566,268399,67)}c=m+4|0;q=m+8|0;p=m+12|0;r=m+16|0;a=m+20|0;o=m+24|0;s=m+28|0;t=m+40|0;x=m+48|0;v=m+44|0;w=m+52|0;y=n+8|0;z=n+4|0;A=m+36|0;B=l+4|0;C=l+8|0;if(g){switch(d|0){case 0:{D=3;E=10;F=3;G=51;break}case 1:{D=1;E=0;F=-1;G=51;break}default:{}}if((G|0)==51){f[l>>2]=F;f[B>>2]=E;f[C>>2]=D}D=f[j+8>>2]|0;E=f[j+12>>2]|0;f[m>>2]=1124007940;f[c>>2]=2;f[q>>2]=D;f[p>>2]=E;f[r>>2]=l;f[a>>2]=l;F=o+8|0;f[F>>2]=0;f[F+4>>2]=0;f[t>>2]=q;f[v>>2]=x;F=E<<2;f[x>>2]=F;f[w>>2]=4;g=l+((Y(E,D)|0)<<2)|0;f[s>>2]=g;f[o>>2]=g+(0-F)+F;R$(m);F=y;f[F>>2]=0;f[F+4>>2]=0;f[n>>2]=33619968;f[z>>2]=j;dY(m,n,h,(d|0)==1?1.0:.03125,0.0);F=f[A>>2]|0;if(F|0?(g=F+12|0,F=f[g>>2]|0,f[g>>2]=F+-1,(F|0)==1):0)V$(m);f[A>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){F=f[t>>2]|0;g=0;do{f[F+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[c>>2]|0))}g=f[v>>2]|0;if((g|0)!=(x|0))wL(g);switch(e|0){case 0:{H=3;I=10;J=3;G=62;break}case 1:{H=1;I=0;J=-1;G=62;break}default:{}}if((G|0)==62){f[l>>2]=J;f[B>>2]=I;f[C>>2]=H}H=f[k+8>>2]|0;I=f[k+12>>2]|0;f[m>>2]=1124007940;f[c>>2]=2;f[q>>2]=H;f[p>>2]=I;f[r>>2]=l;f[a>>2]=l;J=o+8|0;f[J>>2]=0;f[J+4>>2]=0;f[t>>2]=q;f[v>>2]=x;J=I<<2;f[x>>2]=J;f[w>>2]=4;g=l+((Y(I,H)|0)<<2)|0;f[s>>2]=g;f[o>>2]=g+(0-J)+J;R$(m);J=y;f[J>>2]=0;f[J+4>>2]=0;f[n>>2]=33619968;f[z>>2]=k;dY(m,n,h,(e|0)==1?1.0:.03125,0.0);J=f[A>>2]|0;if(J|0?(g=J+12|0,J=f[g>>2]|0,f[g>>2]=J+-1,(J|0)==1):0)V$(m);f[A>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){J=f[t>>2]|0;g=0;do{f[J+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[c>>2]|0))}g=f[v>>2]|0;if((g|0)!=(x|0))wL(g)}else{switch(d|0){case 0:{K=3;L=10;M=3;G=22;break}case 1:{K=1;L=0;M=-1;G=22;break}default:{}}if((G|0)==22){f[l>>2]=M;f[B>>2]=L;f[C>>2]=K}K=f[j+8>>2]|0;L=f[j+12>>2]|0;f[m>>2]=1124007940;f[c>>2]=2;f[q>>2]=K;f[p>>2]=L;f[r>>2]=l;f[a>>2]=l;M=o+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=q;f[v>>2]=x;M=L<<2;f[x>>2]=M;f[w>>2]=4;d=l+((Y(L,K)|0)<<2)|0;f[s>>2]=d;f[o>>2]=d+(0-M)+M;R$(m);M=y;f[M>>2]=0;f[M+4>>2]=0;f[n>>2]=33619968;f[z>>2]=j;dY(m,n,h,1.0,0.0);M=f[A>>2]|0;if(M|0?(d=M+12|0,M=f[d>>2]|0,f[d>>2]=M+-1,(M|0)==1):0)V$(m);f[A>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){M=f[t>>2]|0;d=0;do{f[M+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}d=f[v>>2]|0;if((d|0)!=(x|0))wL(d);switch(e|0){case 0:{N=3;O=10;P=3;G=73;break}case 1:{N=1;O=0;P=-1;G=73;break}default:{}}if((G|0)==73){f[l>>2]=P;f[B>>2]=O;f[C>>2]=N}N=f[k+8>>2]|0;C=f[k+12>>2]|0;f[m>>2]=1124007940;f[c>>2]=2;f[q>>2]=N;f[p>>2]=C;f[r>>2]=l;f[a>>2]=l;a=o+8|0;f[a>>2]=0;f[a+4>>2]=0;f[t>>2]=q;f[v>>2]=x;q=C<<2;f[x>>2]=q;f[w>>2]=4;w=l+((Y(C,N)|0)<<2)|0;f[s>>2]=w;f[o>>2]=w+(0-q)+q;R$(m);q=y;f[q>>2]=0;f[q+4>>2]=0;f[n>>2]=33619968;f[z>>2]=k;dY(m,n,h,1.0,0.0);h=f[A>>2]|0;if(h|0?(n=h+12|0,h=f[n>>2]|0,f[n>>2]=h+-1,(h|0)==1):0)V$(m);f[A>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[t>>2]|0;t=0;do{f[r+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[c>>2]|0))}c=f[v>>2]|0;if((c|0)!=(x|0))wL(c)}c=k+36|0;x=f[c>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)V$(k);f[c>>2]=0;c=k+16|0;x=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[x>>2]|0)>0){c=f[k+40>>2]|0;v=0;do{f[c+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[k+44>>2]|0;if((x|0)!=(k+48|0))wL(x);x=j+36|0;k=f[x>>2]|0;if(k|0?(v=k+12|0,k=f[v>>2]|0,f[v>>2]=k+-1,(k|0)==1):0)V$(j);f[x>>2]=0;x=j+16|0;k=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){x=f[j+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=i;return}wL(k);u=i;return}function roa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0;j=u;u=u+208|0;k=j+184|0;l=j+128|0;m=j+72|0;n=j+56|0;o=j;p=(g|0)==1;q=(d|0)>0&p?3:g;r=(e|0)>0&p?3:g;if((i+-5|0)>>>0>=2){p=$Xc(48)|0;f[k>>2]=p;f[k+8>>2]=-2147483600;f[k+4>>2]=34;s=p;t=272993;v=s+34|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[p+34>>0]=0;vM(-215,k,268383,268399,96)}ZS(a,q,1,i,-1,1,0);ZS(c,r,1,i,-1,1,0);do if((eS(a)|0)==65536){p=f[a+4>>2]|0;f[l>>2]=f[p>>2];w=l+4|0;x=p+4|0;f[w>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[p+8>>2];f[l+12>>2]=f[p+12>>2];f[l+16>>2]=f[p+16>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];z=f[p+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;A=l+44|0;f[A>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[p+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;U$(l,p);break}}else bS(l,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];p=m+4|0;w=a+4|0;f[p>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=x;x=m+48|0;A=m+44|0;f[A>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[p>>2]=0;U$(m,a);break}}else bS(m,c,-1);while(0);if((g|0)>31|(g&1|0)==0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(64)|0;f[k>>2]=g;f[k+8>>2]=-2147483584;f[k+4>>2]=50;s=g;t=268469;v=s+50|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[g+50>>0]=0;vM(-211,k,268383,268399,104)}g=((q|0)<(r|0)?r:q)+1|0;f[n>>2]=0;c=n+4|0;f[c>>2]=0;f[n+8>>2]=0;do if(g|0)if(g>>>0>1073741823)kWc(n);else{a=g<<2;p=$Xc(a)|0;f[n>>2]=p;w=p+(g<<2)|0;f[n+8>>2]=w;g1c(p|0,0,a|0)|0;f[c>>2]=w;break}while(0);if(!((e|d|0)>-1&(e+d|0)>0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;g=$Xc(32)|0;f[k>>2]=g;f[k+8>>2]=-2147483616;f[k+4>>2]=31;s=g;t=268520;v=s+31|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[g+31>>0]=0;vM(-215,k,268383,268399,107)}g=o+4|0;w=o+8|0;a=o+12|0;p=o+16|0;x=o+20|0;A=o+24|0;y=o+40|0;z=o+48|0;B=o+44|0;C=o+52|0;D=o+28|0;E=k+8|0;F=k+4|0;G=o+36|0;H=0;while(1){I=(H|0)==0;J=I?l:m;K=I?d:e;L=I?q:r;if((L|0)<=(K|0)){M=48;break}switch(L|0){case 1:{I=f[n>>2]|0;N=0;O=I;P=I;M=69;break}case 3:{do if(K){I=f[n>>2]|0;if((K|0)==1){f[I>>2]=-1;Q=0;R=I;S=I;break}else{f[I>>2]=1;Q=-2;R=I;S=I;break}}else{I=f[n>>2]|0;f[I>>2]=1;Q=2;R=I;S=I}while(0);f[R+4>>2]=Q;N=2;O=R;P=S;M=69;break}default:{I=f[n>>2]|0;T=1;U=0;while(1){f[I+(U<<2)>>2]=T;if((U|0)<(L|0)){T=0;U=U+1|0}else break}U=L+~K|0;if((U|0)>0){T=f[n>>2]|0;if((L|0)<1)V=T;else{W=0;do{X=f[T>>2]|0;Z=X;_=1;$=X;while(1){X=f[T+(_<<2)>>2]|0;f[T+(_+-1<<2)>>2]=Z;if((_|0)==(L|0))break;else{Z=$+X|0;_=_+1|0;$=X}}W=W+1|0}while((W|0)!=(U|0));V=T}}else V=I;if((K|0)>0){T=f[n>>2]|0;if((L|0)<1)aa=T;else{U=0;do{W=f[T>>2]|0;$=0-W|0;_=1;Z=W;while(1){W=f[T+(_<<2)>>2]|0;f[T+(_+-1<<2)>>2]=$;if((_|0)==(L|0))break;else{$=Z-W|0;_=_+1|0;Z=W}}U=U+1|0}while((U|0)!=(K|0));aa=T}}else aa=V}}if((M|0)==69){M=0;f[O+(N<<2)>>2]=1;aa=P}T=f[J+8>>2]|0;U=f[J+12>>2]|0;f[o>>2]=1124007940;f[g>>2]=2;f[w>>2]=T;f[a>>2]=U;f[p>>2]=aa;f[x>>2]=aa;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[y>>2]=w;f[B>>2]=z;f[C>>2]=0;f[z>>2]=0;if((Y(U,T)|0)!=0&(aa|0)==0){M=71;break}I=U<<2;f[z>>2]=I;f[C>>2]=4;U=aa+(Y(I,T)|0)|0;f[D>>2]=U;f[A>>2]=U+(0-I)+I;R$(o);if(h)ba=1.0/+(1<<L+~K|0);else ba=1.0;I=E;f[I>>2]=0;f[I+4>>2]=0;f[k>>2]=33619968;f[F>>2]=J;dY(o,k,i,ba,0.0);I=f[G>>2]|0;if(I|0?(U=I+12|0,I=f[U>>2]|0,f[U>>2]=I+-1,(I|0)==1):0)V$(o);f[G>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[g>>2]|0)>0){I=f[y>>2]|0;U=0;do{f[I+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[g>>2]|0))}U=f[B>>2]|0;if((U|0)!=(z|0))wL(U);H=H+1|0;if((H|0)>=2){M=26;break}}if((M|0)==26){H=f[n>>2]|0;if(H|0){n=f[c>>2]|0;if((n|0)!=(H|0))f[c>>2]=n+(~((n+-4-H|0)>>>2)<<2);cYc(H)}H=m+36|0;n=f[H>>2]|0;if(n|0?(c=n+12|0,n=f[c>>2]|0,f[c>>2]=n+-1,(n|0)==1):0)V$(m);f[H>>2]=0;H=m+16|0;n=m+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[n>>2]|0)>0){H=f[m+40>>2]|0;c=0;do{f[H+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))wL(n);n=l+36|0;m=f[n>>2]|0;if(m|0?(c=m+12|0,m=f[c>>2]|0,f[c>>2]=m+-1,(m|0)==1):0)V$(l);f[n>>2]=0;n=l+16|0;m=l+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[m>>2]|0)>0){n=f[l+40>>2]|0;c=0;do{f[n+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=j;return}wL(m);u=j;return}else if((M|0)==48){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;j=$Xc(16)|0;f[k>>2]=j;f[k+8>>2]=-2147483632;f[k+4>>2]=13;s=j;t=268552;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[j+13>>0]=0;vM(-215,k,268383,268399,115)}else if((M|0)==71){M=$Xc(32)|0;f[k>>2]=M;f[k+8>>2]=-2147483616;f[k+4>>2]=28;s=M;t=470314;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[M+28>>0]=0;vM(-215,k,470343,470347,548)}}function soa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+320|0;l=k+264|0;m=k+256|0;n=k+200|0;o=k+144|0;p=k+88|0;q=k+80|0;r=k+72|0;s=k+56|0;t=k+32|0;v=k+16|0;w=k;x=k+48|0;y=dS(a,-1)|0;z=y&7;A=(c|0)<0?z:c;cS(m,a,-1);wS(b,m,A&7|y&4088,-1,0,0);y=(A|0)<(z|0)?z:A;z=(y|0)>5?y:5;f[n>>2]=1124007936;y=n+4|0;m=n+8|0;c=n+40|0;B=y;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[c>>2]=m;m=n+48|0;D=n+44|0;f[D>>2]=m;f[m>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;E=o+4|0;F=o+8|0;G=o+40|0;B=E;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[G>>2]=F;F=o+48|0;B=o+44|0;f[B>>2]=F;f[F>>2]=0;f[o+52>>2]=0;C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;C=p+8|0;f[C>>2]=0;f[C+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=o;if((g|0)<1)qoa(l,p,d,e,0,z);else roa(l,p,d,e,g,0,z);do if(h!=1.0)if(!d){z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;dY(n,l,-1,h,0.0);break}else{z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=o;dY(o,l,-1,h,0.0);break}while(0);do if((eS(a)|0)==65536){d=f[a+4>>2]|0;f[l>>2]=f[d>>2];z=l+4|0;g=d+4|0;f[z>>2]=f[g>>2];e=l+8|0;f[e>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];C=f[d+36>>2]|0;f[l+36>>2]=C;f[l+40>>2]=e;e=l+48|0;H=l+44|0;f[H>>2]=e;f[e>>2]=0;f[l+52>>2]=0;if(C|0){e=C+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[g>>2]|0)<3){g=f[d+44>>2]|0;e=f[H>>2]|0;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];break}else{f[z>>2]=0;U$(l,d);break}}else bS(l,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[p>>2]=f[a>>2];d=p+4|0;z=a+4|0;f[d>>2]=f[z>>2];g=p+8|0;f[g>>2]=f[a+8>>2];f[p+12>>2]=f[a+12>>2];f[p+16>>2]=f[a+16>>2];f[p+20>>2]=f[a+20>>2];f[p+24>>2]=f[a+24>>2];f[p+28>>2]=f[a+28>>2];f[p+32>>2]=f[a+32>>2];e=f[a+36>>2]|0;f[p+36>>2]=e;f[p+40>>2]=g;g=p+48|0;H=p+44|0;f[H>>2]=g;f[g>>2]=0;f[p+52>>2]=0;if(e|0){g=e+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;g=f[H>>2]|0;f[g>>2]=f[z>>2];f[g+4>>2]=f[z+4>>2];break}else{f[d>>2]=0;U$(p,a);break}}else bS(p,b,-1);while(0);f[q>>2]=0;f[q+4>>2]=0;b=f[l+8>>2]|0;f[r>>2]=f[l+12>>2];f[r+4>>2]=b;if(!(j&16))e0(l,r,q);q=l+16|0;r=l+44|0;b=p+16|0;a=p+44|0;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=l;d=t+8|0;f[d>>2]=0;f[d+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=n;f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=o;f[x>>2]=-1;f[x+4>>2]=-1;Aja(s,t,A,v,w,x,i,j);j=p+36|0;x=f[j>>2]|0;if(x|0?(w=x+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0)V$(p);f[j>>2]=0;j=p+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){b=f[p+40>>2]|0;x=0;do{f[b+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[j>>2]|0))}j=f[a>>2]|0;if((j|0)!=(p+48|0))wL(j);j=l+36|0;p=f[j>>2]|0;if(p|0?(a=p+12|0,p=f[a>>2]|0,f[a>>2]=p+-1,(p|0)==1):0)V$(l);f[j>>2]=0;j=l+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[l+40>>2]|0;p=0;do{f[q+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}j=f[r>>2]|0;if((j|0)!=(l+48|0))wL(j);j=o+36|0;l=f[j>>2]|0;if(l|0?(r=l+12|0,l=f[r>>2]|0,f[r>>2]=l+-1,(l|0)==1):0)V$(o);f[j>>2]=0;j=o+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[E>>2]|0)>0){j=f[G>>2]|0;G=0;do{f[j+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[B>>2]|0;if((E|0)!=(F|0))wL(E);E=n+36|0;F=f[E>>2]|0;if(F|0?(B=F+12|0,F=f[B>>2]|0,f[B>>2]=F+-1,(F|0)==1):0)V$(n);f[E>>2]=0;E=n+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[y>>2]|0)>0){E=f[c>>2]|0;c=0;do{f[E+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[y>>2]|0))}y=f[D>>2]|0;if((y|0)==(m|0)){u=k;return}wL(y);u=k;return}function toa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=u;u=u+320|0;k=j+264|0;l=j+256|0;m=j+200|0;n=j+144|0;o=j+88|0;p=j+80|0;q=j+72|0;r=j+56|0;s=j+32|0;t=j+16|0;v=j;w=j+48|0;x=dS(a,-1)|0;y=x&7;z=(c|0)<0?y:c;cS(l,a,-1);wS(b,l,z&7|x&4088,-1,0,0);x=(z|0)<(y|0)?y:z;y=(x|0)>5?x:5;f[m>>2]=1124007936;x=m+4|0;l=m+8|0;c=m+40|0;A=x;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[c>>2]=l;l=m+48|0;C=m+44|0;f[C>>2]=l;f[l>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;D=n+4|0;E=n+8|0;F=n+40|0;A=D;B=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(B|0));f[F>>2]=E;E=n+48|0;A=n+44|0;f[A>>2]=E;f[E>>2]=0;f[n+52>>2]=0;B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=m;B=o+8|0;f[B>>2]=0;f[B+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=n;qoa(k,o,d,e,0,y);do if(g!=1.0)if(!d){y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=m;dY(m,k,-1,g,0.0);break}else{y=k+8|0;f[y>>2]=0;f[y+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=n;dY(n,k,-1,g,0.0);break}while(0);do if((eS(a)|0)==65536){d=f[a+4>>2]|0;f[k>>2]=f[d>>2];y=k+4|0;e=d+4|0;f[y>>2]=f[e>>2];B=k+8|0;f[B>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];f[k+16>>2]=f[d+16>>2];f[k+20>>2]=f[d+20>>2];f[k+24>>2]=f[d+24>>2];f[k+28>>2]=f[d+28>>2];f[k+32>>2]=f[d+32>>2];G=f[d+36>>2]|0;f[k+36>>2]=G;f[k+40>>2]=B;B=k+48|0;H=k+44|0;f[H>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(G|0){B=G+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[e>>2]|0)<3){e=f[d+44>>2]|0;B=f[H>>2]|0;f[B>>2]=f[e>>2];f[B+4>>2]=f[e+4>>2];break}else{f[y>>2]=0;U$(k,d);break}}else bS(k,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[o>>2]=f[a>>2];d=o+4|0;y=a+4|0;f[d>>2]=f[y>>2];e=o+8|0;f[e>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=e;e=o+48|0;H=o+44|0;f[H>>2]=e;f[e>>2]=0;f[o+52>>2]=0;if(B|0){e=B+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;e=f[H>>2]|0;f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];break}else{f[d>>2]=0;U$(o,a);break}}else bS(o,b,-1);while(0);f[p>>2]=0;f[p+4>>2]=0;b=f[k+8>>2]|0;f[q>>2]=f[k+12>>2];f[q+4>>2]=b;if(!(i&16))e0(k,q,p);p=k+16|0;q=k+44|0;b=o+16|0;a=o+44|0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=k;d=s+8|0;f[d>>2]=0;f[d+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=m;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=n;f[w>>2]=-1;f[w+4>>2]=-1;Aja(r,s,z,t,v,w,h,i);i=o+36|0;w=f[i>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)V$(o);f[i>>2]=0;i=o+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[o+40>>2]|0;w=0;do{f[b+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[a>>2]|0;if((i|0)!=(o+48|0))wL(i);i=k+36|0;o=f[i>>2]|0;if(o|0?(a=o+12|0,o=f[a>>2]|0,f[a>>2]=o+-1,(o|0)==1):0)V$(k);f[i>>2]=0;i=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[i>>2]|0)>0){p=f[k+40>>2]|0;o=0;do{f[p+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[q>>2]|0;if((i|0)!=(k+48|0))wL(i);i=n+36|0;k=f[i>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)V$(n);f[i>>2]=0;i=n+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[D>>2]|0)>0){i=f[F>>2]|0;F=0;do{f[i+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[A>>2]|0;if((D|0)!=(E|0))wL(D);D=m+36|0;E=f[D>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)V$(m);f[D>>2]=0;D=m+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[x>>2]|0)>0){D=f[c>>2]|0;c=0;do{f[D+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[x>>2]|0))}x=f[C>>2]|0;if((x|0)==(l|0)){u=j;return}wL(x);u=j;return}function uoa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;i=u;u=u+608|0;j=i+584|0;k=i+512|0;l=i;m=i+504|0;n=i+496|0;o=i+432|0;p=i+368|0;q=i+312|0;r=i+256|0;s=i+248|0;t=i+240|0;v=i+232|0;w=i+488|0;x=i+224|0;y=i+424|0;z=i+168|0;A=i+112|0;B=i+56|0;C=dS(a,-1)|0;D=C&7;E=C>>>3&511;F=E+1|0;G=(c|0)<0?D:c;cS(m,a,-1);c=E<<3;wS(b,m,G&7|c,-1,0,0);if((d|2|0)==3){m=(d|0)==3;H=k;E=52892;I=H+72|0;do{f[H>>2]=f[E>>2];H=H+4|0;E=E+4|0}while((H|0)<(I|0));J=m&1;m=k+(J*36|0)|0;f[l>>2]=1124007941;K=l+4|0;f[K>>2]=2;L=l+8|0;f[L>>2]=3;f[l+12>>2]=3;M=l+16|0;f[M>>2]=m;f[l+20>>2]=m;m=l+24|0;N=l+40|0;O=m+8|0;f[O>>2]=0;f[O+4>>2]=0;f[N>>2]=L;L=l+48|0;O=l+44|0;f[O>>2]=L;f[L>>2]=12;f[l+52>>2]=4;P=k+(J*36|0)+36|0;f[l+28>>2]=P;f[m>>2]=P;R$(l);P=e!=1.0;if(P){m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;dY(l,j,-1,e,0.0)}m=l+36|0;Q=f[m>>2]|0;if(Q|0?(R=Q+12|0,Q=f[R>>2]|0,f[R>>2]=Q+-1,(Q|0)==1):0)V$(l);f[m>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[K>>2]|0)>0){M=f[N>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[O>>2]|0;if((K|0)!=(L|0))wL(K);H=k;E=52892;I=H+72|0;do{f[H>>2]=f[E>>2];H=H+4|0;E=E+4|0}while((H|0)<(I|0));E=k+(J*36|0)|0;f[l>>2]=1124007941;K=l+4|0;f[K>>2]=2;L=l+8|0;f[L>>2]=3;f[l+12>>2]=3;O=l+16|0;f[O>>2]=E;f[l+20>>2]=E;E=l+24|0;N=l+40|0;M=E+8|0;f[M>>2]=0;f[M+4>>2]=0;f[N>>2]=L;L=l+48|0;M=l+44|0;f[M>>2]=L;f[L>>2]=12;f[l+52>>2]=4;m=k+(J*36|0)+36|0;f[l+28>>2]=m;f[E>>2]=m;R$(l);if(P){P=j+8|0;f[P>>2]=0;f[P+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;dY(l,j,-1,e,0.0)}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=l;f[n>>2]=-1;f[n+4>>2]=-1;zja(a,b,G,j,n,g,h);n=l+36|0;P=f[n>>2]|0;if(P|0?(m=P+12|0,P=f[m>>2]|0,f[m>>2]=P+-1,(P|0)==1):0)V$(l);f[n>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[K>>2]|0)>0){O=f[N>>2]|0;N=0;do{f[O+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[M>>2]|0;if((K|0)!=(L|0))wL(K);u=i;return}K=(G|0)<(D|0)?D:G;L=(K|0)>5?K:5;K=((d|0)<6&(D|0)==0?3:D>>>0<6?5:6)|c;f[o>>2]=1124007936;c=o+4|0;M=o+8|0;N=o+40|0;H=c;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[N>>2]=M;O=o+48|0;n=o+44|0;f[n>>2]=O;f[O>>2]=0;f[o+52>>2]=0;f[p>>2]=1124007936;P=p+4|0;m=p+8|0;E=p+40|0;H=P;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[E>>2]=m;m=p+48|0;J=p+44|0;f[J>>2]=m;f[m>>2]=0;f[p+52>>2]=0;Q=j+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=o;Q=k+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=p;roa(j,k,2,0,d,0,L);do if((eS(a)|0)==65536){L=f[a+4>>2]|0;f[q>>2]=f[L>>2];d=q+4|0;Q=L+4|0;f[d>>2]=f[Q>>2];R=q+8|0;f[R>>2]=f[L+8>>2];f[q+12>>2]=f[L+12>>2];f[q+16>>2]=f[L+16>>2];f[q+20>>2]=f[L+20>>2];f[q+24>>2]=f[L+24>>2];f[q+28>>2]=f[L+28>>2];f[q+32>>2]=f[L+32>>2];S=f[L+36>>2]|0;f[q+36>>2]=S;f[q+40>>2]=R;R=q+48|0;T=q+44|0;f[T>>2]=R;f[R>>2]=0;f[q+52>>2]=0;if(S|0){R=S+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[Q>>2]|0)<3){Q=f[L+44>>2]|0;R=f[T>>2]|0;f[R>>2]=f[Q>>2];f[R+4>>2]=f[Q+4>>2];break}else{f[d>>2]=0;U$(q,L);break}}else bS(q,a,-1);while(0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[r>>2]=f[a>>2];L=r+4|0;d=a+4|0;f[L>>2]=f[d>>2];Q=r+8|0;f[Q>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];R=f[a+36>>2]|0;f[r+36>>2]=R;f[r+40>>2]=Q;Q=r+48|0;T=r+44|0;f[T>>2]=Q;f[Q>>2]=0;f[r+52>>2]=0;if(R|0){Q=R+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[d>>2]|0)<3){d=f[a+44>>2]|0;Q=f[T>>2]|0;f[Q>>2]=f[d>>2];f[Q+4>>2]=f[d+4>>2];break}else{f[L>>2]=0;U$(r,a);break}}else bS(r,b,-1);while(0);f[s>>2]=0;f[s+4>>2]=0;b=q+12|0;a=q+8|0;L=f[a>>2]|0;f[t>>2]=f[b>>2];f[t+4>>2]=L;if(!(h&16))e0(q,t,s);L=h&-17;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=o;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=p;f[w>>2]=-1;f[w+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;pha(v,C,K,j,k,w,0.0,L,L,l);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=p;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=o;f[y>>2]=-1;f[y+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;pha(x,C,K,j,k,y,0.0,L,L,l);L=f[v>>2]|0;y=hh[f[(f[L>>2]|0)+12>>2]&127](L,q,t,s)|0;L=f[x>>2]|0;hh[f[(f[L>>2]|0)+12>>2]&127](L,q,t,s)|0;s=q+16|0;t=q+44|0;L=(f[s>>2]|0)+(Y(f[f[t>>2]>>2]|0,y)|0)|0;y=Y(675553809>>>(D<<2)&15,F)|0;F=f[b>>2]|0;D=Y(y,F)|0;y=f[a>>2]|0;C=D>>>0>16384?1:16384/(D>>>0)|0;D=(y|0)<(C|0)?y:C;C=(f[M>>2]|0)+-1+D|0;f[z>>2]=1124007936;y=z+4|0;w=z+8|0;h=z+40|0;H=y;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[h>>2]=w;d=z+48|0;Q=z+44|0;f[Q>>2]=d;f[d>>2]=0;f[z+52>>2]=0;f[j>>2]=C;C=j+4|0;f[C>>2]=F;S$(z,2,j,K);F=D+-1+(f[M>>2]|0)|0;M=f[b>>2]|0;f[A>>2]=1124007936;b=A+4|0;T=A+8|0;R=A+40|0;H=b;I=H+36|0;do{f[H>>2]=0;H=H+4|0}while((H|0)<(I|0));f[R>>2]=T;H=A+48|0;I=A+44|0;f[I>>2]=H;f[H>>2]=0;f[A+52>>2]=0;f[j>>2]=F;f[C>>2]=M;S$(A,2,j,K);if((f[a>>2]|0)>0){K=q+48|0;M=z+16|0;C=A+16|0;F=j+4|0;S=k+4|0;U=j+8|0;V=j+12|0;W=j+4|0;X=k+8|0;Z=k+12|0;_=k+4|0;$=l+8|0;aa=l+4|0;ba=j+8|0;ca=j+4|0;da=B+36|0;ea=B+16|0;fa=B+4|0;ga=B+40|0;ha=B+44|0;ia=B+48|0;ja=L;L=0;ka=f[K>>2]|0;while(1){la=f[v>>2]|0;xg[f[(f[la>>2]|0)+16>>2]&127](la,ja,ka,D,f[M>>2]|0,f[d>>2]|0)|0;la=f[x>>2]|0;ma=xg[f[(f[la>>2]|0)+16>>2]&127](la,ja,f[K>>2]|0,D,f[C>>2]|0,f[H>>2]|0)|0;if((ma|0)>0){la=ma+L|0;f[j>>2]=L;f[F>>2]=la;f[k>>2]=-2147483648;f[S>>2]=2147483647;W$(B,r,j,k);f[T>>2]=ma;f[w>>2]=ma;f[U>>2]=0;f[V>>2]=0;f[j>>2]=16842752;f[W>>2]=z;f[X>>2]=0;f[Z>>2]=0;f[k>>2]=16842752;f[_>>2]=A;na=$;f[na>>2]=0;f[na+4>>2]=0;f[l>>2]=33619968;f[aa>>2]=z;E1(j,k,l,fT()|0,-1);na=ba;f[na>>2]=0;f[na+4>>2]=0;f[j>>2]=33619968;f[ca>>2]=B;dY(z,j,G,e,g);na=f[da>>2]|0;if(na|0?(oa=na+12|0,na=f[oa>>2]|0,f[oa>>2]=na+-1,(na|0)==1):0)V$(B);f[da>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[fa>>2]|0)>0){na=f[ga>>2]|0;oa=0;do{f[na+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[fa>>2]|0))}oa=f[ha>>2]|0;if((oa|0)!=(ia|0))wL(oa);pa=la}else pa=ma+L|0;ka=f[K>>2]|0;ja=ja+(Y(ka,D)|0)|0;if((pa|0)>=(f[a>>2]|0))break;else L=pa}}pa=A+36|0;L=f[pa>>2]|0;if(L|0?(a=L+12|0,L=f[a>>2]|0,f[a>>2]=L+-1,(L|0)==1):0)V$(A);f[pa>>2]=0;pa=A+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[b>>2]|0)>0){pa=f[R>>2]|0;R=0;do{f[pa+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[b>>2]|0))}b=f[I>>2]|0;if((b|0)!=(H|0))wL(b);b=z+36|0;H=f[b>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)V$(z);f[b>>2]=0;b=z+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[y>>2]|0)>0){b=f[h>>2]|0;h=0;do{f[b+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[y>>2]|0))}y=f[Q>>2]|0;if((y|0)!=(d|0))wL(y);y=f[x+4>>2]|0;if(y|0)UXc(y);y=f[v+4>>2]|0;if(y|0)UXc(y);y=r+36|0;v=f[y>>2]|0;if(v|0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0)V$(r);f[y>>2]=0;y=r+16|0;v=r+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[v>>2]|0)>0){y=f[r+40>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[r+44>>2]|0;if((v|0)!=(r+48|0))wL(v);v=q+36|0;r=f[v>>2]|0;if(r|0?(x=r+12|0,r=f[x>>2]|0,f[x>>2]=r+-1,(r|0)==1):0)V$(q);f[v>>2]=0;v=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[v>>2]|0)>0){s=f[q+40>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[v>>2]|0))}v=f[t>>2]|0;if((v|0)!=(q+48|0))wL(v);v=p+36|0;q=f[v>>2]|0;do if(q|0){t=q+12|0;r=f[t>>2]|0;f[t>>2]=r+-1;if((r|0)!=1)break;V$(p)}while(0);f[v>>2]=0;v=p+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[P>>2]|0)>0){v=f[E>>2]|0;E=0;do{f[v+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[P>>2]|0))}P=f[J>>2]|0;if((P|0)!=(m|0))wL(P);P=o+36|0;m=f[P>>2]|0;do if(m|0){J=m+12|0;E=f[J>>2]|0;f[J>>2]=E+-1;if((E|0)!=1)break;V$(o)}while(0);f[P>>2]=0;P=o+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[c>>2]|0)>0){P=f[N>>2]|0;N=0;do{f[P+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[c>>2]|0))}c=f[n>>2]|0;if((c|0)!=(O|0))wL(c);u=i;return}function voa(a,c,d,e,g,h){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;i=u;u=u+368|0;j=i+344|0;k=i+280|0;l=i+336|0;m=i+216|0;n=i+160|0;o=i+272|0;p=i+104|0;q=i+80|0;r=i+72|0;s=i;if(qS(a,-1)|0){t=$Xc(32)|0;f[j>>2]=t;f[j+8>>2]=-2147483616;f[j+4>>2]=21;v=t;w=268616;x=v+21|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+21>>0]=0;vM(-215,j,268638,268644,947)}cS(j,a,-1);t=c+4|0;y=a+4|0;if((f[t>>2]|0)==(f[y>>2]|0)?dS(a,-1)|0:0){z=$Xc(112)|0;f[k>>2]=z;f[k+8>>2]=-2147483536;f[k+4>>2]=100;v=z;w=268714;x=v+100|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[z+100>>0]=0;vM(-215,k,268638,268644,952)}f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];wS(c,l,0,-1,0,0);l=(g|0)<0&(h^1);j=l|h;h=l?g&2147483647:g;if(!(h&1)){A=$Xc(48)|0;f[k>>2]=A;B=k+8|0;f[B>>2]=-2147483600;C=k+4|0;f[C>>2]=43;v=A;w=268815;x=v+43|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));D=A+43|0;b[D>>0]=0;vM(-206,k,268638,268644,964)}switch(h|0){case 7:{E=d*.0625;F=e*.0625;break}case -1:case 6:case 5:case 4:case 3:{E=d;F=e;break}default:{A=$Xc(48)|0;f[k>>2]=A;B=k+8|0;f[B>>2]=-2147483600;C=k+4|0;f[C>>2]=43;v=A;w=268815;x=v+43|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));D=A+43|0;b[D>>0]=0;vM(-206,k,268638,268644,964)}}D=E>F;e=D?E:F;d=D?F:E;do if((eS(a)|0)==65536){D=f[y>>2]|0;f[k>>2]=f[D>>2];A=k+4|0;w=D+4|0;f[A>>2]=f[w>>2];C=k+8|0;f[C>>2]=f[D+8>>2];f[k+12>>2]=f[D+12>>2];f[k+16>>2]=f[D+16>>2];f[k+20>>2]=f[D+20>>2];f[k+24>>2]=f[D+24>>2];f[k+28>>2]=f[D+28>>2];f[k+32>>2]=f[D+32>>2];B=f[D+36>>2]|0;f[k+36>>2]=B;f[k+40>>2]=C;C=k+48|0;g=k+44|0;f[g>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[w>>2]|0)<3){w=f[D+44>>2]|0;C=f[g>>2]|0;f[C>>2]=f[w>>2];f[C+4>>2]=f[w+4>>2];break}else{f[A>>2]=0;U$(k,D);break}}else bS(k,a,-1);while(0);do if((eS(c)|0)==65536){a=f[t>>2]|0;f[m>>2]=f[a>>2];y=m+4|0;D=a+4|0;f[y>>2]=f[D>>2];A=m+8|0;f[A>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];w=f[a+36>>2]|0;f[m+36>>2]=w;f[m+40>>2]=A;A=m+48|0;C=m+44|0;f[C>>2]=A;f[A>>2]=0;f[m+52>>2]=0;if(w|0){A=w+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[D>>2]|0)<3){D=f[a+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[D>>2];f[A+4>>2]=f[D+4>>2];break}else{f[y>>2]=0;U$(m,a);break}}else bS(m,c,-1);while(0);c=k+40|0;t=f[c>>2]|0;a=f[t>>2]|0;f[o>>2]=f[t+4>>2];f[o+4>>2]=a;a=k+16|0;t=k+48|0;cM(n,o,f[k>>2]&4095,f[a>>2]|0,f[t>>2]|0);o=n+16|0;y=m+16|0;D=n+12|0;A=n+8|0;if(j){E=d<32767.0?d:32767.0;F=e<32767.0?e:32767.0;G=E>0.0?E*E:E;if(F>0.0){H=F*F;I=G}else{H=F;I=G}}else{H=e;I=d}C=~~I;w=C-(+(C|0)>I&1)|0;C=~~H;g=C-(+(C|0)>H&1)|0;C=i3()|0;B=j3()|0;l=(B|0)<(C|0)?B:C;C=(l|0)>1?l:1;l=f[A>>2]|0;B=(h|0)<0?4:(((h|0)/2|0)<<1)+2|0;if(((l|0)/(C|0)|0|0)<(B|0)){z=(l|0)/(B|0)|0;J=(z|0)>1?z:1}else J=C;f[p>>2]=1124007936;C=p+4|0;z=p+8|0;B=p+40|0;v=C;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[B>>2]=z;z=p+48|0;v=p+44|0;f[v>>2]=z;f[z>>2]=0;f[p+52>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[r>>2]=0;f[r+4>>2]=l;woa(s,n,p,q,w,g,h,j);h3(r,s,+(J|0));f[s>>2]=52972;XXc(s+44|0);J=f[p+12>>2]|0;j=q+20|0;h=f[j>>2]|0;if(h|0){g=q+16|0;w=q+4|0;l=q+8|0;x=0-J|0;K=~J;L=1-J|0;M=J+-1|0;N=J+1|0;O=h;while(1){h=f[g>>2]|0;P=O+-1|0;Q=h+P|0;R=f[w>>2]|0;S=f[(f[R+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]|0;f[j>>2]=P;P=f[l>>2]|0;Q=P-R|0;if((1-O-h+((Q|0)==0?0:(Q<<8)+-1|0)|0)>>>0>2047){cYc(f[P+-4>>2]|0);f[l>>2]=(f[l>>2]|0)+-4}P=S+x|0;if(!(b[S+K>>0]|0)){Q=P+-1|0;b[Q>>0]=2;h=f[w>>2]|0;R=(f[l>>2]|0)-h|0;T=f[g>>2]|0;U=f[j>>2]|0;if((((R|0)==0?0:(R<<8)+-1|0)|0)==(U+T|0)){xoa(q);V=f[g>>2]|0;W=f[j>>2]|0;X=f[w>>2]|0}else{V=T;W=U;X=h}h=W+V|0;f[(f[X+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=Q;f[j>>2]=W+1}if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[w>>2]|0;h=(f[l>>2]|0)-Q|0;U=f[g>>2]|0;T=f[j>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(T+U|0)){xoa(q);Z=f[g>>2]|0;_=f[j>>2]|0;$=f[w>>2]|0}else{Z=U;_=T;$=Q}Q=_+Z|0;f[(f[$+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=_+1}if(!(b[S+L>>0]|0)){P=S+x+1|0;b[P>>0]=2;Q=f[w>>2]|0;T=(f[l>>2]|0)-Q|0;U=f[g>>2]|0;h=f[j>>2]|0;if((((T|0)==0?0:(T<<8)+-1|0)|0)==(h+U|0)){xoa(q);aa=f[g>>2]|0;ba=f[j>>2]|0;ca=f[w>>2]|0}else{aa=U;ba=h;ca=Q}Q=ba+aa|0;f[(f[ca+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=ba+1}P=S+-1|0;if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[w>>2]|0;h=(f[l>>2]|0)-Q|0;U=f[g>>2]|0;T=f[j>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(T+U|0)){xoa(q);da=f[g>>2]|0;ea=f[j>>2]|0;fa=f[w>>2]|0}else{da=U;ea=T;fa=Q}Q=ea+da|0;f[(f[fa+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=ea+1}P=S+1|0;if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[w>>2]|0;T=(f[l>>2]|0)-Q|0;U=f[g>>2]|0;h=f[j>>2]|0;if((((T|0)==0?0:(T<<8)+-1|0)|0)==(h+U|0)){xoa(q);ga=f[g>>2]|0;ha=f[j>>2]|0;ia=f[w>>2]|0}else{ga=U;ha=h;ia=Q}Q=ha+ga|0;f[(f[ia+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=ha+1}P=S+J|0;if(!(b[S+M>>0]|0)){Q=P+-1|0;b[Q>>0]=2;h=f[w>>2]|0;U=(f[l>>2]|0)-h|0;T=f[g>>2]|0;R=f[j>>2]|0;if((((U|0)==0?0:(U<<8)+-1|0)|0)==(R+T|0)){xoa(q);ja=f[g>>2]|0;ka=f[j>>2]|0;la=f[w>>2]|0}else{ja=T;ka=R;la=h}h=ka+ja|0;f[(f[la+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=Q;f[j>>2]=ka+1}if(!(b[P>>0]|0)){b[P>>0]=2;Q=f[w>>2]|0;h=(f[l>>2]|0)-Q|0;R=f[g>>2]|0;T=f[j>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(T+R|0)){xoa(q);ma=f[g>>2]|0;na=f[j>>2]|0;oa=f[w>>2]|0}else{ma=R;na=T;oa=Q}Q=na+ma|0;f[(f[oa+(Q>>>10<<2)>>2]|0)+((Q&1023)<<2)>>2]=P;f[j>>2]=na+1}if(!(b[S+N>>0]|0)){P=S+J+1|0;b[P>>0]=2;S=f[w>>2]|0;Q=(f[l>>2]|0)-S|0;T=f[g>>2]|0;R=f[j>>2]|0;if((((Q|0)==0?0:(Q<<8)+-1|0)|0)==(R+T|0)){xoa(q);pa=f[g>>2]|0;qa=f[j>>2]|0;ra=f[w>>2]|0}else{pa=T;qa=R;ra=S}S=qa+pa|0;f[(f[ra+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]=P;P=qa+1|0;f[j>>2]=P;sa=P}else sa=f[j>>2]|0;if(!sa)break;else O=sa}}sa=f[A>>2]|0;f[r>>2]=0;f[r+4>>2]=sa;f[s>>2]=52992;f[s+4>>2]=p;f[s+8>>2]=m;A=n+4|0;O=f[A>>2]|0;if((O|0)<3)ta=Y(f[D>>2]|0,sa)|0;else{sa=f[n+40>>2]|0;D=0;j=1;while(1){qa=Y(f[sa+(D<<2)>>2]|0,j)|0;D=D+1|0;if((D|0)==(O|0)){ta=qa;break}else j=qa}}h3(r,s,+(ta>>>0)*.0000152587890625);yoa(q);q=p+36|0;ta=f[q>>2]|0;if(ta|0?(s=ta+12|0,ta=f[s>>2]|0,f[s>>2]=ta+-1,(ta|0)==1):0)V$(p);f[q>>2]=0;q=p+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[C>>2]|0)>0){q=f[B>>2]|0;B=0;do{f[q+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[C>>2]|0))}C=f[v>>2]|0;if((C|0)!=(z|0))wL(C);C=n+36|0;z=f[C>>2]|0;if(z|0?(v=z+12|0,z=f[v>>2]|0,f[v>>2]=z+-1,(z|0)==1):0)V$(n);f[C>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[A>>2]|0)>0){o=f[n+40>>2]|0;C=0;do{f[o+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[n+44>>2]|0;if((A|0)!=(n+48|0))wL(A);A=m+36|0;n=f[A>>2]|0;if(n|0?(C=n+12|0,n=f[C>>2]|0,f[C>>2]=n+-1,(n|0)==1):0)V$(m);f[A>>2]=0;A=m+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[A>>2]|0)>0){y=f[m+40>>2]|0;n=0;do{f[y+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[A>>2]|0))}A=f[m+44>>2]|0;if((A|0)!=(m+48|0))wL(A);A=k+36|0;m=f[A>>2]|0;do if(m|0){n=m+12|0;y=f[n>>2]|0;f[n>>2]=y+-1;if((y|0)!=1)break;V$(k)}while(0);f[A>>2]=0;A=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[A>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[A>>2]|0))}A=f[k+44>>2]|0;if((A|0)==(t|0)){u=i;return}wL(A);u=i;return}function woa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+80|0;l=k+64|0;m=k;n=k+8|0;f[a>>2]=52972;o=a+4|0;f[o>>2]=c;f[a+8>>2]=c;c=a+12|0;f[c>>2]=d;f[a+16>>2]=e;f[a+20>>2]=g;f[a+24>>2]=h;f[a+28>>2]=i;b[a+32>>0]=j&1;WXc(a+44|0);j=f[o>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=d+4|0;if(!(((((f[j>>2]|0)<3?(f[d+8>>2]|0)==(i|0):0)?(f[d+12>>2]|0)==(h|0):0)?(f[d>>2]&4095|0)==0:0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;S$(d,2,l,0)}h=f[c>>2]|0;if((h|0)==(d|0))q=d;else{i=d+36|0;g=f[i>>2]|0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}e=h+36|0;g=f[e>>2]|0;if(g|0?(r=g+12|0,g=f[r>>2]|0,f[r>>2]=g+-1,(g|0)==1):0)V$(h);f[e>>2]=0;g=h+16|0;r=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){s=f[h+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0;v=f[r>>2]|0}while((t|0)<(v|0));f[h>>2]=f[d>>2];if((v|0)<3)w=18;else w=20}else{f[h>>2]=f[d>>2];w=18}if((w|0)==18){v=f[j>>2]|0;if((v|0)<3){f[r>>2]=v;f[h+8>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];v=f[d+44>>2]|0;r=f[h+44>>2]|0;f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2]}else w=20}if((w|0)==20)U$(h,d);f[g>>2]=f[d+16>>2];f[h+20>>2]=f[d+20>>2];f[h+24>>2]=f[d+24>>2];f[h+28>>2]=f[d+28>>2];f[h+32>>2]=f[d+32>>2];f[e>>2]=f[i>>2];q=f[c>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;W$(n,q,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;mR(n,l,fT()|0)|0;q=n+36|0;i=f[q>>2]|0;if(i|0?(e=i+12|0,i=f[e>>2]|0,f[e>>2]=i+-1,(i|0)==1):0)V$(n);f[q>>2]=0;q=n+16|0;i=n+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[i>>2]|0)>0){q=f[n+40>>2]|0;e=0;do{f[q+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))wL(i);i=f[c>>2]|0;e=f[(f[o>>2]|0)+8>>2]|0;f[l>>2]=e+1;f[l+4>>2]=e+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;W$(n,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;mR(n,l,fT()|0)|0;l=n+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)V$(n);f[l>>2]=0;l=n+16|0;m=n+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[n+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[n+44>>2]|0;if((m|0)==(n+48|0)){x=f[c>>2]|0;y=x+12|0;z=f[y>>2]|0;A=a+36|0;f[A>>2]=z;B=a+33|0;b[B>>0]=1;C=f[o>>2]|0;D=f[C>>2]|0;E=D>>>3;F=E&511;G=F+1|0;H=a+40|0;f[H>>2]=G;u=k;return}wL(m);x=f[c>>2]|0;y=x+12|0;z=f[y>>2]|0;A=a+36|0;f[A>>2]=z;B=a+33|0;b[B>>0]=1;C=f[o>>2]|0;D=f[C>>2]|0;E=D>>>3;F=E&511;G=F+1|0;H=a+40|0;f[H>>2]=G;u=k;return}function xoa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=u;u=u+32|0;c=b+4|0;d=b;e=a+16|0;g=f[e>>2]|0;if(g>>>0>1023){f[e>>2]=g+-1024;g=a+4|0;e=f[g>>2]|0;h=f[e>>2]|0;i=e+4|0;f[g>>2]=i;e=a+8|0;j=f[e>>2]|0;k=a+12|0;l=f[k>>2]|0;m=l;n=j;do if((j|0)==(l|0)){o=f[a>>2]|0;p=o;if(i>>>0>o>>>0){q=i;r=((q-p>>2)+1|0)/-2|0;s=i+(r<<2)|0;t=n-q|0;q=t>>2;if(!q)v=i;else{q1c(s|0,i|0,t|0)|0;v=f[g>>2]|0}t=s+(q<<2)|0;f[e>>2]=t;f[g>>2]=v+(r<<2);w=t;break}t=m-p>>1;p=(t|0)==0?1:t;if(p>>>0>1073741823){t=af(8)|0;hYc(t,512536);f[t>>2]=192348;ig(t|0,25336,2140)}t=$Xc(p<<2)|0;r=t;q=t+(p>>>2<<2)|0;s=q;x=t+(p<<2)|0;if((i|0)==(j|0)){y=s;z=o}else{o=q;q=s;p=i;do{f[o>>2]=f[p>>2];o=q+4|0;q=o;p=p+4|0}while((p|0)!=(j|0));y=q;z=f[a>>2]|0}f[a>>2]=r;f[g>>2]=s;f[e>>2]=y;f[k>>2]=x;if(!z)w=y;else{cYc(z);w=f[e>>2]|0}}else w=j;while(0);f[w>>2]=h;f[e>>2]=(f[e>>2]|0)+4;u=b;return}e=a+8|0;h=f[e>>2]|0;w=a+4|0;j=h-(f[w>>2]|0)|0;z=a+12|0;y=f[z>>2]|0;k=y-(f[a>>2]|0)|0;if(j>>>0>=k>>>0){g=k>>1;k=(g|0)==0?1:g;f[c+12>>2]=0;f[c+16>>2]=a+12;if(k>>>0>1073741823){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=$Xc(k<<2)|0;f[c>>2]=g;i=g+(j>>2<<2)|0;j=c+8|0;f[j>>2]=i;m=c+4|0;f[m>>2]=i;i=c+12|0;f[i>>2]=g+(k<<2);k=$Xc(4096)|0;f[d>>2]=k;Doa(c,d);d=f[e>>2]|0;while(1){A=f[w>>2]|0;if((d|0)==(A|0))break;k=d+-4|0;Eoa(c,k);d=k}k=A;A=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=A;f[w>>2]=f[m>>2];f[m>>2]=k;m=f[e>>2]|0;f[e>>2]=f[j>>2];f[j>>2]=m;g=f[z>>2]|0;f[z>>2]=f[i>>2];f[i>>2]=g;g=m;if((g|0)!=(d|0))f[j>>2]=g+(~((g+-4-k|0)>>>2)<<2);if(A|0)cYc(A);u=b;return}if((y|0)!=(h|0)){h=$Xc(4096)|0;f[c>>2]=h;Boa(a,c);u=b;return}h=$Xc(4096)|0;f[c>>2]=h;Coa(a,c);c=f[w>>2]|0;h=f[c>>2]|0;y=c+4|0;f[w>>2]=y;c=f[e>>2]|0;A=f[z>>2]|0;k=A;g=c;do if((c|0)==(A|0)){j=f[a>>2]|0;d=j;if(y>>>0>j>>>0){m=y;i=((m-d>>2)+1|0)/-2|0;v=y+(i<<2)|0;n=g-m|0;m=n>>2;if(!m)B=y;else{q1c(v|0,y|0,n|0)|0;B=f[w>>2]|0}n=v+(m<<2)|0;f[e>>2]=n;f[w>>2]=B+(i<<2);C=n;break}n=k-d>>1;d=(n|0)==0?1:n;if(d>>>0>1073741823){n=af(8)|0;hYc(n,512536);f[n>>2]=192348;ig(n|0,25336,2140)}n=$Xc(d<<2)|0;i=n;m=n+(d>>>2<<2)|0;v=m;l=n+(d<<2)|0;if((y|0)==(c|0)){D=v;E=j}else{j=m;m=v;d=y;do{f[j>>2]=f[d>>2];j=m+4|0;m=j;d=d+4|0}while((d|0)!=(c|0));D=m;E=f[a>>2]|0}f[a>>2]=i;f[w>>2]=v;f[e>>2]=D;f[z>>2]=l;if(!E)C=D;else{cYc(E);C=f[e>>2]|0}}else C=c;while(0);f[C>>2]=h;f[e>>2]=(f[e>>2]|0)+4;u=b;return}function yoa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=a+4|0;c=f[b>>2]|0;d=a+16|0;e=f[d>>2]|0;g=c+(e>>>10<<2)|0;h=a+8|0;i=f[h>>2]|0;j=i;k=c;if((i|0)==(c|0)){l=0;m=a+20|0;n=0}else{i=a+20|0;o=(f[i>>2]|0)+e|0;l=(f[c+(o>>>10<<2)>>2]|0)+((o&1023)<<2)|0;m=i;n=(f[g>>2]|0)+((e&1023)<<2)|0}e=g;g=n;a:while(1){n=g;do{i=n;if((i|0)==(l|0))break a;n=i+4|0}while((n-(f[e>>2]|0)|0)!=4096);n=e+4|0;e=n;g=f[n>>2]|0}f[m>>2]=0;m=j-k>>2;if(m>>>0>2){k=c;do{cYc(f[k>>2]|0);k=(f[b>>2]|0)+4|0;f[b>>2]=k;c=(f[h>>2]|0)-k>>2}while(c>>>0>2);p=c}else p=m;switch(p|0){case 1:{q=512;r=13;break}case 2:{q=1024;r=13;break}default:{}}if((r|0)==13)f[d>>2]=q;q=f[b>>2]|0;d=f[h>>2]|0;if((q|0)!=(d|0)){r=q;do{cYc(f[r>>2]|0);r=r+4|0}while((r|0)!=(d|0));d=f[b>>2]|0;b=f[h>>2]|0;if((b|0)!=(d|0))f[h>>2]=b+(~((b+-4-d|0)>>>2)<<2)}d=f[a>>2]|0;if(!d)return;cYc(d);return}function zoa(a){a=a|0;cYc(a);return}function Aoa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=c+4|0;c=f[e>>2]|0;if((d|0)>=(c|0))return;g=a+8|0;i=a+4|0;a=d;d=f[g>>2]|0;j=c;while(1){c=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,a)|0)|0;k=f[i>>2]|0;a=a+1|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,a)|0)+1|0;if((f[d+12>>2]|0)>0){k=0;do{b[c+k>>0]=0-((h[l+k>>0]|0)>>>1);k=k+1|0;m=f[g>>2]|0}while((k|0)<(f[m+12>>2]|0));n=f[e>>2]|0;o=m}else{n=j;o=d}if((a|0)>=(n|0))break;else{d=o;j=n}}return}function Boa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;i=d;do if((d|0)==(g|0)){j=a+4|0;k=f[j>>2]|0;l=f[a>>2]|0;m=l;if(k>>>0>l>>>0){n=k;o=((n-m>>2)+1|0)/-2|0;p=k+(o<<2)|0;q=i-n|0;n=q>>2;if(!n)r=k;else{q1c(p|0,k|0,q|0)|0;r=f[j>>2]|0}q=p+(n<<2)|0;f[c>>2]=q;f[j>>2]=r+(o<<2);s=q;break}q=h-m>>1;m=(q|0)==0?1:q;if(m>>>0>1073741823){q=af(8)|0;hYc(q,512536);f[q>>2]=192348;ig(q|0,25336,2140)}q=$Xc(m<<2)|0;o=q;n=q+(m>>>2<<2)|0;p=n;t=q+(m<<2)|0;if((k|0)==(d|0)){u=p;v=l}else{l=n;n=p;m=k;do{f[l>>2]=f[m>>2];l=n+4|0;n=l;m=m+4|0}while((m|0)!=(d|0));u=n;v=f[a>>2]|0}f[a>>2]=o;f[j>>2]=p;f[c>>2]=u;f[e>>2]=t;if(!v)s=u;else{cYc(v);s=f[c>>2]|0}}else s=d;while(0);f[s>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+4;return}function Coa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{q1c(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}m=$Xc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{cYc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function Doa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;d=f[c>>2]|0;e=a+12|0;g=f[e>>2]|0;h=g;i=d;do if((d|0)==(g|0)){j=a+4|0;k=f[j>>2]|0;l=f[a>>2]|0;m=l;if(k>>>0>l>>>0){n=k;o=((n-m>>2)+1|0)/-2|0;p=k+(o<<2)|0;q=i-n|0;n=q>>2;if(!n)r=k;else{q1c(p|0,k|0,q|0)|0;r=f[j>>2]|0}q=p+(n<<2)|0;f[c>>2]=q;f[j>>2]=r+(o<<2);s=q;break}q=h-m>>1;m=(q|0)==0?1:q;if(m>>>0>1073741823){q=af(8)|0;hYc(q,512536);f[q>>2]=192348;ig(q|0,25336,2140)}q=$Xc(m<<2)|0;o=q;n=q+(m>>>2<<2)|0;p=n;t=q+(m<<2)|0;if((k|0)==(d|0)){u=p;v=l}else{l=n;n=p;m=k;do{f[l>>2]=f[m>>2];l=n+4|0;n=l;m=m+4|0}while((m|0)!=(d|0));u=n;v=f[a>>2]|0}f[a>>2]=o;f[j>>2]=p;f[c>>2]=u;f[e>>2]=t;if(!v)s=u;else{cYc(v);s=f[c>>2]|0}}else s=d;while(0);f[s>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+4;return}function Eoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{q1c(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}m=$Xc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{cYc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function Foa(a){a=a|0;f[a>>2]=52972;XXc(a+44|0);return}function Goa(a){a=a|0;f[a>>2]=52972;XXc(a+44|0);cYc(a);return}function Hoa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0;e=u;u=u+3440|0;g=e+3416|0;h=e+3408|0;i=e+3352|0;j=e+3280|0;k=e+3216|0;l=e+2168|0;m=e+1120|0;n=e+1096|0;o=e+1072|0;p=e+8|0;q=e+3344|0;r=e+3336|0;s=e+3272|0;t=e;f[j>>2]=1124007936;v=j+4|0;w=j+8|0;x=j+40|0;y=v;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[x>>2]=w;A=j+48|0;B=j+44|0;f[B>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;C=k+4|0;D=k+8|0;E=k+40|0;y=C;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[E>>2]=D;y=k+48|0;z=k+44|0;f[z>>2]=y;f[y>>2]=0;f[k+52>>2]=0;F=l+8|0;f[l>>2]=F;G=l+4|0;f[G>>2]=0;H=m+8|0;f[m>>2]=H;I=m+4|0;f[I>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;J=f[c>>2]|0;K=J+-1|0;L=(K|0)>0?K:0;K=a+4|0;M=f[K>>2]|0;N=c+4|0;O=(f[N>>2]|0)+1|0;P=f[M+8>>2]|0;Q=(O|0)<(P|0)?O:P;if(!(b[a+33>>0]|0)){f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(i,M,g,h);P=j+36|0;O=f[P>>2]|0;if(O|0?(R=O+12|0,O=f[R>>2]|0,f[R>>2]=O+-1,(O|0)==1):0)V$(j);f[P>>2]=0;O=j+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[v>>2]|0)>0){R=f[x>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[v>>2]|0))}f[j>>2]=f[i>>2];S=i+4|0;R=f[S>>2]|0;f[v>>2]=R;T=i+8|0;f[w>>2]=f[T>>2];f[j+12>>2]=f[i+12>>2];U=i+16|0;f[O>>2]=f[U>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];O=i+36|0;f[P>>2]=f[O>>2];P=j+44|0;V=f[P>>2]|0;if((V|0)==(A|0))W=R;else{wL(V);f[P>>2]=A;f[x>>2]=w;W=f[S>>2]|0}w=i+44|0;if((W|0)<3){W=f[w>>2]|0;f[A>>2]=f[W>>2];f[j+52>>2]=f[W+4>>2];X=W}else{f[P>>2]=f[w>>2];P=i+40|0;f[j+40>>2]=f[P>>2];W=i+48|0;f[w>>2]=W;f[P>>2]=T;X=W}f[i>>2]=1124007936;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;f[S+16>>2]=0;f[S+20>>2]=0;f[S+24>>2]=0;f[S+28>>2]=0;f[O>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((X|0)!=(i+48|0))wL(X);X=f[a+8>>2]|0;f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(i,X,g,h);X=k+36|0;U=f[X>>2]|0;if(U|0?(O=U+12|0,U=f[O>>2]|0,f[O>>2]=U+-1,(U|0)==1):0)V$(k);f[X>>2]=0;U=k+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[C>>2]|0)>0){O=f[E>>2]|0;S=0;do{f[O+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[C>>2]|0))}f[k>>2]=f[i>>2];S=i+4|0;O=f[S>>2]|0;f[C>>2]=O;W=i+8|0;f[D>>2]=f[W>>2];f[k+12>>2]=f[i+12>>2];T=i+16|0;f[U>>2]=f[T>>2];f[k+20>>2]=f[i+20>>2];f[k+24>>2]=f[i+24>>2];f[k+28>>2]=f[i+28>>2];f[k+32>>2]=f[i+32>>2];U=i+36|0;f[X>>2]=f[U>>2];X=k+44|0;P=f[X>>2]|0;if((P|0)==(y|0))Z=O;else{wL(P);f[X>>2]=y;f[E>>2]=D;Z=f[S>>2]|0}D=i+44|0;if((Z|0)<3){Z=f[D>>2]|0;f[y>>2]=f[Z>>2];f[k+52>>2]=f[Z+4>>2];_=Z}else{f[X>>2]=f[D>>2];X=i+40|0;f[k+40>>2]=f[X>>2];Z=i+48|0;f[D>>2]=Z;f[X>>2]=W;_=Z}f[i>>2]=1124007936;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;f[S+16>>2]=0;f[S+20>>2]=0;f[S+24>>2]=0;f[S+28>>2]=0;f[U>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((_|0)!=(i+48|0))wL(_)}else{_=a+28|0;$=(f[_>>2]|0)==7?.0625:1.0;f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(p,M,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=p;M=g+8|0;f[M>>2]=0;f[M+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;soa(i,g,3,1,0,f[_>>2]|0,$,0.0,1);M=p+36|0;T=f[M>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)V$(p);f[M>>2]=0;M=p+16|0;T=p+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[T>>2]|0)>0){M=f[p+40>>2]|0;U=0;do{f[M+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[T>>2]|0))}T=f[p+44>>2]|0;if((T|0)!=(p+48|0))wL(T);T=f[K>>2]|0;f[g>>2]=L;f[g+4>>2]=Q;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;W$(p,T,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=p;T=g+8|0;f[T>>2]=0;f[T+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;soa(i,g,3,0,1,f[_>>2]|0,$,0.0,1);_=p+36|0;T=f[_>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)V$(p);f[_>>2]=0;_=p+16|0;T=p+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[T>>2]|0)>0){_=f[p+40>>2]|0;U=0;do{f[_+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[T>>2]|0))}T=f[p+44>>2]|0;if((T|0)!=(p+48|0))wL(T)}T=a+40|0;U=f[T>>2]|0;if((U|0)>1){_=j+12|0;M=f[_>>2]<<1;if((f[G>>2]|0)>>>0<M>>>0){S=f[l>>2]|0;if((S|0)!=(F|0)){if(S|0)dYc(S);f[l>>2]=F;f[G>>2]=520}f[G>>2]=M;if(M>>>0>520){S=bYc(M>>>0>2147483647?-1:M<<1)|0;f[l>>2]=S}}else f[G>>2]=M;M=k+12|0;S=f[M>>2]<<1;if((f[I>>2]|0)>>>0<S>>>0){Z=f[m>>2]|0;if((Z|0)!=(H|0)){if(Z|0)dYc(Z);f[m>>2]=H;f[I>>2]=520}f[I>>2]=S;if(S>>>0>520){Z=bYc(S>>>0>2147483647?-1:S<<1)|0;f[m>>2]=Z;aa=Z}else aa=H}else{f[I>>2]=S;aa=f[m>>2]|0}S=f[l>>2]|0;ba=aa+(f[M>>2]<<1)|0;ca=S+(f[_>>2]<<1)|0;da=aa;ea=S;fa=f[T>>2]|0}else{ba=0;ca=0;da=0;ea=0;fa=U}U=a+36|0;S=f[U>>2]|0;aa=Y(S*3|0,fa)|0;_=p+8|0;f[p>>2]=_;M=p+4|0;f[M>>2]=aa;if(aa>>>0>264){Z=bYc(aa>>>0>1073741823?-1:aa<<2)|0;f[p>>2]=Z;ga=Z}else ga=_;Z=ga+4|0;aa=Y(fa,S)|0;fa=Z+(aa<<2)|0;W=fa+(aa<<2)|0;aa=W+-4|0;if((L|0)==(f[c>>2]|0))g1c(aa|0,0,S<<2|0)|0;else{f[aa>>2]=0;f[W+(f[(f[K>>2]|0)+12>>2]<<2)>>2]=0}f[ga>>2]=0;f[Z+(f[(f[K>>2]|0)+12>>2]<<2)>>2]=0;f[fa+-4>>2]=0;f[fa+(f[(f[K>>2]|0)+12>>2]<<2)>>2]=0;ga=f[N>>2]|0;if((L|0)>(ga|0)){ha=ga;ia=a+12|0}else{ga=j+16|0;aa=k+16|0;S=a+32|0;X=a+12|0;D=a+20|0;P=a+24|0;O=n+8|0;w=n+4|0;V=n+16|0;R=n+20|0;ja=L;ka=ba;ba=ca;ca=da;da=ea;ea=W;W=fa;fa=Z;while(1){if((ja|0)<(Q|0)){Z=ja-L|0;la=(f[ga>>2]|0)+(Y(f[f[B>>2]>>2]|0,Z)|0)|0;ma=(f[aa>>2]|0)+(Y(f[f[z>>2]>>2]|0,Z)|0)|0;Z=Y(f[T>>2]|0,f[(f[K>>2]|0)+12>>2]|0)|0;na=(Z|0)>0;if(!(b[S>>0]|0)){if(na){oa=fa;pa=0;do{qa=d[la+(pa<<1)>>1]|0;ra=qa<<16>>16;sa=d[ma+(pa<<1)>>1]|0;ta=sa<<16>>16;f[oa+(pa<<2)>>2]=(sa<<16>>16>-1?ta:0-ta|0)+(qa<<16>>16>-1?ra:0-ra|0);pa=pa+1|0}while((pa|0)!=(Z|0))}}else if(na){pa=fa;oa=0;do{ra=d[la+(oa<<1)>>1]|0;qa=Y(ra,ra)|0;ra=d[ma+(oa<<1)>>1]|0;ta=(Y(ra,ra)|0)+qa|0;f[pa+(oa<<2)>>2]=ta;oa=oa+1|0}while((oa|0)!=(Z|0))}Z=f[T>>2]|0;if((Z|0)>1){oa=f[(f[K>>2]|0)+12>>2]|0;pa=fa;if((oa|0)>0){na=da;ta=ca;qa=0;ra=0;sa=Z;while(1){Z=f[pa+(ra<<2)>>2]|0;if((sa|0)>1){ua=ra;va=1;wa=Z;while(1){xa=va+ra|0;ya=(f[pa+(xa<<2)>>2]|0)>(wa|0)?xa:ua;va=va+1|0;xa=f[pa+(ya<<2)>>2]|0;if((va|0)>=(sa|0)){za=ya;Aa=xa;break}else{ua=ya;wa=xa}}}else{za=ra;Aa=Z}f[pa+(qa<<2)>>2]=Aa;d[na+(qa<<1)>>1]=d[la+(za<<1)>>1]|0;d[ta+(qa<<1)>>1]=d[ma+(za<<1)>>1]|0;qa=qa+1|0;wa=f[T>>2]|0;ua=f[(f[K>>2]|0)+12>>2]|0;if((qa|0)>=(ua|0)){Ba=ua;break}else{ra=wa+ra|0;sa=wa}}}else Ba=oa;f[pa+(Ba<<2)>>2]=0;Ca=ca;Da=da;Ea=ka;Fa=ba}else{Ca=ka;Da=ba;Ea=ca;Fa=da}if((ja|0)>(f[c>>2]|0)){Ga=Ca;Ha=Da;Ia=Ea;Ja=Fa;Ka=90}else{La=Ca;Ma=Da;Na=Ea;Oa=Fa}}else{g1c(fa+-4|0,0,f[U>>2]<<2|0)|0;sa=(f[T>>2]|0)>1;Ga=sa?ca:ka;Ha=sa?da:ba;Ia=sa?ka:ca;Ja=sa?ba:da;Ka=90}if((Ka|0)==90){Ka=0;sa=f[X>>2]|0;ra=(f[sa+16>>2]|0)+(Y(f[f[sa+44>>2]>>2]|0,ja)|0)|0;sa=ra+1|0;b[ra>>0]=1;b[sa+(f[(f[K>>2]|0)+12>>2]|0)>>0]=1;if((f[T>>2]|0)==1){ra=ja-L+-1|0;qa=(f[ga>>2]|0)+(Y(f[f[B>>2]>>2]|0,ra)|0)|0;Pa=qa;Qa=(f[aa>>2]|0)+(Y(f[f[z>>2]>>2]|0,ra)|0)|0}else{Pa=Ja;Qa=Ia}if((f[(f[K>>2]|0)+12>>2]|0)>0){ra=ea;qa=W;ma=fa;ta=0;do{la=f[ra+(ta<<2)>>2]|0;do if((la|0)>(f[D>>2]|0)){na=d[Pa+(ta<<1)>>1]|0;wa=d[Qa+(ta<<1)>>1]|0;ua=na<<16>>16;va=na<<16>>16>-1?ua:0-ua|0;ua=wa<<16>>16;xa=(wa<<16>>16>-1?ua:0-ua|0)<<15;if((xa|0)<(va*13573|0)){if((la|0)<=(f[ra+(ta+-1<<2)>>2]|0)){Ka=119;break}if((la|0)<(f[ra+(ta+1<<2)>>2]|0)){Ka=119;break}ua=sa+ta|0;if((la|0)<=(f[P>>2]|0)){b[ua>>0]=0;break}b[ua>>0]=2;ya=f[w>>2]|0;Ra=(f[O>>2]|0)-ya|0;Sa=f[V>>2]|0;Ta=f[R>>2]|0;if((((Ra|0)==0?0:(Ra<<8)+-1|0)|0)==(Ta+Sa|0)){xoa(n);Ua=f[V>>2]|0;Va=f[R>>2]|0;Wa=f[w>>2]|0}else{Ua=Sa;Va=Ta;Wa=ya}ya=Va+Ua|0;f[(f[Wa+(ya>>>10<<2)>>2]|0)+((ya&1023)<<2)>>2]=ua;f[R>>2]=Va+1;break}if((xa|0)>(va*79109|0)){if((la|0)<=(f[qa+(ta<<2)>>2]|0)){Ka=119;break}if((la|0)<(f[ma+(ta<<2)>>2]|0)){Ka=119;break}va=sa+ta|0;if((la|0)<=(f[P>>2]|0)){b[va>>0]=0;break}b[va>>0]=2;xa=f[w>>2]|0;ua=(f[O>>2]|0)-xa|0;ya=f[V>>2]|0;Ta=f[R>>2]|0;if((((ua|0)==0?0:(ua<<8)+-1|0)|0)==(Ta+ya|0)){xoa(n);Xa=f[V>>2]|0;Ya=f[R>>2]|0;Za=f[w>>2]|0}else{Xa=ya;Ya=Ta;Za=xa}xa=Ya+Xa|0;f[(f[Za+(xa>>>10<<2)>>2]|0)+((xa&1023)<<2)>>2]=va;f[R>>2]=Ya+1;break}else{va=(wa^na)<<16>>16<0?-1:1;if((la|0)<=(f[qa+(ta-va<<2)>>2]|0)){Ka=119;break}if((la|0)<=(f[ma+(va+ta<<2)>>2]|0)){Ka=119;break}va=sa+ta|0;if((la|0)<=(f[P>>2]|0)){b[va>>0]=0;break}b[va>>0]=2;na=f[w>>2]|0;wa=(f[O>>2]|0)-na|0;xa=f[V>>2]|0;Ta=f[R>>2]|0;if((((wa|0)==0?0:(wa<<8)+-1|0)|0)==(Ta+xa|0)){xoa(n);_a=f[V>>2]|0;$a=f[R>>2]|0;ab=f[w>>2]|0}else{_a=xa;$a=Ta;ab=na}na=$a+_a|0;f[(f[ab+(na>>>10<<2)>>2]|0)+((na&1023)<<2)>>2]=va;f[R>>2]=$a+1;break}}else Ka=119;while(0);if((Ka|0)==119){Ka=0;b[sa+ta>>0]=1}ta=ta+1|0}while((ta|0)<(f[(f[K>>2]|0)+12>>2]|0));La=Ga;Ma=Ha;Na=Ia;Oa=Ja}else{La=Ga;Ma=Ha;Na=Ia;Oa=Ja}}ta=f[N>>2]|0;if((ja|0)<(ta|0)){sa=fa;ja=ja+1|0;ka=La;ba=Ma;ca=Na;da=Oa;fa=W;W=ea;ea=sa}else{ha=ta;ia=X;break}}}X=f[ia>>2]|0;ia=f[X+16>>2]|0;if((J|0)<2)bb=ia;else bb=ia+(Y((f[c>>2]|0)+2|0,f[U>>2]|0)|0)|0;if((Q|0)==(f[(f[K>>2]|0)+8>>2]|0))cb=f[X+28>>2]|0;else cb=ia+(Y(f[U>>2]|0,ha)|0)|0;ha=bb;ia=cb-ha|0;cb=n+20|0;X=f[cb>>2]|0;if(!X)db=o+20|0;else{K=n+16|0;Q=n+4|0;c=n+8|0;J=o+8|0;ea=o+4|0;W=o+16|0;fa=o+20|0;Oa=X;while(1){X=f[K>>2]|0;da=Oa+-1|0;Na=X+da|0;ca=f[Q>>2]|0;Ma=f[(f[ca+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]|0;f[cb>>2]=da;da=f[c>>2]|0;Na=da-ca|0;if((1-Oa-X+((Na|0)==0?0:(Na<<8)+-1|0)|0)>>>0>2047){cYc(f[da+-4>>2]|0);f[c>>2]=(f[c>>2]|0)+-4}da=Ma;do if((Ma-ha|0)>>>0>=ia>>>0){Na=f[ea>>2]|0;X=(f[J>>2]|0)-Na|0;ca=f[W>>2]|0;ba=f[fa>>2]|0;if((((X|0)==0?0:(X<<8)+-1|0)|0)==(ba+ca|0)){xoa(o);eb=f[W>>2]|0;fb=f[fa>>2]|0;gb=f[ea>>2]|0}else{eb=ca;fb=ba;gb=Na}Na=fb+eb|0;f[(f[gb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=Ma;f[fa>>2]=fb+1;Na=f[U>>2]|0;ba=da>>>0<bb>>>0?Na:0-Na|0;Na=da+-1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;ca=f[Q>>2]|0;X=(f[c>>2]|0)-ca|0;La=f[K>>2]|0;ka=f[cb>>2]|0;if((((X|0)==0?0:(X<<8)+-1|0)|0)==(ka+La|0)){xoa(n);hb=f[K>>2]|0;ib=f[cb>>2]|0;jb=f[Q>>2]|0}else{hb=La;ib=ka;jb=ca}ca=ib+hb|0;f[(f[jb+(ca>>>10<<2)>>2]|0)+((ca&1023)<<2)>>2]=Na;f[cb>>2]=ib+1}Na=da+1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;ca=f[Q>>2]|0;ka=(f[c>>2]|0)-ca|0;La=f[K>>2]|0;X=f[cb>>2]|0;if((((ka|0)==0?0:(ka<<8)+-1|0)|0)==(X+La|0)){xoa(n);kb=f[K>>2]|0;lb=f[cb>>2]|0;mb=f[Q>>2]|0}else{kb=La;lb=X;mb=ca}ca=lb+kb|0;f[(f[mb+(ca>>>10<<2)>>2]|0)+((ca&1023)<<2)>>2]=Na;f[cb>>2]=lb+1}Na=da+ba|0;if(!(b[da+(ba+-1)>>0]|0)){ca=Na+-1|0;b[ca>>0]=2;X=f[Q>>2]|0;La=(f[c>>2]|0)-X|0;ka=f[K>>2]|0;ja=f[cb>>2]|0;if((((La|0)==0?0:(La<<8)+-1|0)|0)==(ja+ka|0)){xoa(n);nb=f[K>>2]|0;ob=f[cb>>2]|0;pb=f[Q>>2]|0}else{nb=ka;ob=ja;pb=X}X=ob+nb|0;f[(f[pb+(X>>>10<<2)>>2]|0)+((X&1023)<<2)>>2]=ca;f[cb>>2]=ob+1}if(!(b[Na>>0]|0)){b[Na>>0]=2;ca=f[Q>>2]|0;X=(f[c>>2]|0)-ca|0;ja=f[K>>2]|0;ka=f[cb>>2]|0;if((((X|0)==0?0:(X<<8)+-1|0)|0)==(ka+ja|0)){xoa(n);qb=f[K>>2]|0;rb=f[cb>>2]|0;sb=f[Q>>2]|0}else{qb=ja;rb=ka;sb=ca}ca=rb+qb|0;f[(f[sb+(ca>>>10<<2)>>2]|0)+((ca&1023)<<2)>>2]=Na;f[cb>>2]=rb+1}if(!(b[da+(ba+1)>>0]|0)){Na=da+ba+1|0;b[Na>>0]=2;ba=f[Q>>2]|0;ca=(f[c>>2]|0)-ba|0;ka=f[K>>2]|0;ja=f[cb>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(ja+ka|0)){xoa(n);tb=f[K>>2]|0;ub=f[cb>>2]|0;vb=f[Q>>2]|0}else{tb=ka;ub=ja;vb=ba}ba=ub+tb|0;f[(f[vb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Na;Na=ub+1|0;f[cb>>2]=Na;wb=Na}else Ka=186}else{Na=f[U>>2]|0;if(!(b[da+~Na>>0]|0)){b[da+(0-Na)+-1>>0]=2;ba=f[U>>2]|0;ja=f[Q>>2]|0;ka=(f[c>>2]|0)-ja|0;ca=f[K>>2]|0;X=f[cb>>2]|0;if((((ka|0)==0?0:(ka<<8)+-1|0)|0)==(X+ca|0)){xoa(n);xb=f[U>>2]|0;yb=f[K>>2]|0;zb=f[cb>>2]|0;Ab=f[Q>>2]|0}else{xb=ba;yb=ca;zb=X;Ab=ja}ja=zb+yb|0;f[(f[Ab+(ja>>>10<<2)>>2]|0)+((ja&1023)<<2)>>2]=da+(0-ba)+-1;f[cb>>2]=zb+1;Bb=xb}else Bb=Na;Na=da+(0-Bb)|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;Na=f[U>>2]|0;ba=f[Q>>2]|0;ja=(f[c>>2]|0)-ba|0;X=f[K>>2]|0;ca=f[cb>>2]|0;if((((ja|0)==0?0:(ja<<8)+-1|0)|0)==(ca+X|0)){xoa(n);Cb=f[U>>2]|0;Db=f[K>>2]|0;Eb=f[cb>>2]|0;Fb=f[Q>>2]|0}else{Cb=Na;Db=X;Eb=ca;Fb=ba}ba=Eb+Db|0;f[(f[Fb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=da+(0-Na);f[cb>>2]=Eb+1;Gb=Cb}else Gb=Bb;if(!(b[da+(1-Gb)>>0]|0)){b[da+(0-Gb)+1>>0]=2;Na=da+(0-(f[U>>2]|0))+1|0;ba=f[Q>>2]|0;ca=(f[c>>2]|0)-ba|0;X=f[K>>2]|0;ja=f[cb>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(ja+X|0)){xoa(n);Hb=f[K>>2]|0;Ib=f[cb>>2]|0;Jb=f[Q>>2]|0}else{Hb=X;Ib=ja;Jb=ba}ba=Ib+Hb|0;f[(f[Jb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Na;f[cb>>2]=Ib+1}Na=da+-1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;ba=f[Q>>2]|0;ja=(f[c>>2]|0)-ba|0;X=f[K>>2]|0;ca=f[cb>>2]|0;if((((ja|0)==0?0:(ja<<8)+-1|0)|0)==(ca+X|0)){xoa(n);Kb=f[K>>2]|0;Lb=f[cb>>2]|0;Mb=f[Q>>2]|0}else{Kb=X;Lb=ca;Mb=ba}ba=Lb+Kb|0;f[(f[Mb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Na;f[cb>>2]=Lb+1}Na=da+1|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;ba=f[Q>>2]|0;ca=(f[c>>2]|0)-ba|0;X=f[K>>2]|0;ja=f[cb>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(ja+X|0)){xoa(n);Nb=f[K>>2]|0;Ob=f[cb>>2]|0;Pb=f[Q>>2]|0}else{Nb=X;Ob=ja;Pb=ba}ba=Ob+Nb|0;f[(f[Pb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Na;f[cb>>2]=Ob+1}Na=f[U>>2]|0;if(!(b[da+(Na+-1)>>0]|0)){b[da+Na+-1>>0]=2;ba=f[U>>2]|0;ja=f[Q>>2]|0;X=(f[c>>2]|0)-ja|0;ca=f[K>>2]|0;ka=f[cb>>2]|0;if((((X|0)==0?0:(X<<8)+-1|0)|0)==(ka+ca|0)){xoa(n);Qb=f[U>>2]|0;Rb=f[K>>2]|0;Sb=f[cb>>2]|0;Tb=f[Q>>2]|0}else{Qb=ba;Rb=ca;Sb=ka;Tb=ja}ja=Sb+Rb|0;f[(f[Tb+(ja>>>10<<2)>>2]|0)+((ja&1023)<<2)>>2]=da+ba+-1;f[cb>>2]=Sb+1;Ub=Qb}else Ub=Na;Na=da+Ub|0;if(!(b[Na>>0]|0)){b[Na>>0]=2;Na=f[U>>2]|0;ba=f[Q>>2]|0;ja=(f[c>>2]|0)-ba|0;ka=f[K>>2]|0;ca=f[cb>>2]|0;if((((ja|0)==0?0:(ja<<8)+-1|0)|0)==(ca+ka|0)){xoa(n);Vb=f[U>>2]|0;Wb=f[K>>2]|0;Xb=f[cb>>2]|0;Yb=f[Q>>2]|0}else{Vb=Na;Wb=ka;Xb=ca;Yb=ba}ba=Xb+Wb|0;f[(f[Yb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=da+Na;f[cb>>2]=Xb+1;Zb=Vb}else Zb=Ub;if(b[da+(Zb+1)>>0]|0){Ka=186;break}b[da+Zb+1>>0]=2;Na=da+(f[U>>2]|0)+1|0;ba=f[Q>>2]|0;ca=(f[c>>2]|0)-ba|0;ka=f[K>>2]|0;ja=f[cb>>2]|0;if((((ca|0)==0?0:(ca<<8)+-1|0)|0)==(ja+ka|0)){xoa(n);_b=f[K>>2]|0;$b=f[cb>>2]|0;ac=f[Q>>2]|0}else{_b=ka;$b=ja;ac=ba}ba=$b+_b|0;f[(f[ac+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=Na;Na=$b+1|0;f[cb>>2]=Na;wb=Na}while(0);if((Ka|0)==186){Ka=0;wb=f[cb>>2]|0}if(!wb){db=fa;break}else Oa=wb}}if(f[db>>2]|0){wb=a+44|0;YXc(wb);Oa=f[a+16>>2]|0;a=(f[Oa+16>>2]|0)+(f[Oa+20>>2]|0)|0;fa=f[Oa+4>>2]|0;cb=fa+(a>>>10<<2)|0;if((f[Oa+8>>2]|0)==(fa|0))bc=0;else bc=(f[cb>>2]|0)+((a&1023)<<2)|0;f[q>>2]=cb;f[q+4>>2]=bc;bc=f[o+4>>2]|0;cb=f[o+16>>2]|0;a=bc+(cb>>>10<<2)|0;fa=(f[o+8>>2]|0)==(bc|0);if(fa)cc=0;else cc=(f[a>>2]|0)+((cb&1023)<<2)|0;f[r>>2]=a;f[r+4>>2]=cc;cc=cb+(f[db>>2]|0)|0;db=bc+(cc>>>10<<2)|0;if(fa)dc=0;else dc=(f[db>>2]|0)+((cc&1023)<<2)|0;f[s>>2]=db;f[s+4>>2]=dc;f[i>>2]=f[q>>2];f[i+4>>2]=f[q+4>>2];f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2];f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2];Ioa(t,Oa,i,h,g,0);ZXc(wb)}wb=f[p>>2]|0;if((wb|0)!=(_|0)){if(wb|0)dYc(wb);f[p>>2]=_;f[M>>2]=264}yoa(o);yoa(n);n=f[m>>2]|0;if((n|0)!=(H|0)){if(n|0)dYc(n);f[m>>2]=H;f[I>>2]=520}I=f[l>>2]|0;if((I|0)!=(F|0)){if(I|0)dYc(I);f[l>>2]=F;f[G>>2]=520}G=k+36|0;F=f[G>>2]|0;if(F|0?(l=F+12|0,F=f[l>>2]|0,f[l>>2]=F+-1,(F|0)==1):0)V$(k);f[G>>2]=0;G=k+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[C>>2]|0)>0){G=f[E>>2]|0;E=0;do{f[G+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[z>>2]|0;if((C|0)!=(y|0))wL(C);C=j+36|0;y=f[C>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)V$(j);f[C>>2]=0;C=j+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[x>>2]|0;x=0;do{f[C+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)==(A|0)){u=e;return}wL(v);u=e;return}function Ioa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;g=u;u=u+128|0;h=g+120|0;i=g+112|0;j=g+104|0;k=g+24|0;l=g+96|0;m=g+88|0;n=g+80|0;o=g+72|0;p=g+64|0;q=g+56|0;r=g+48|0;s=g+40|0;t=g+32|0;v=g+16|0;w=g+8|0;x=g;y=d;z=f[y>>2]|0;A=f[y+4>>2]|0;y=e;B=f[y>>2]|0;C=f[y+4>>2]|0;if((C|0)==(A|0))D=0;else D=(C-(f[B>>2]|0)>>2)+(B-z<<8)-(A-(f[z>>2]|0)>>2)|0;y=b+4|0;E=f[y>>2]|0;F=b+16|0;G=f[F>>2]|0;H=E+(G>>>10<<2)|0;I=b+8|0;J=f[I>>2]|0;K=J;L=E;if((J|0)==(E|0))M=0;else M=(f[H>>2]|0)+((G&1023)<<2)|0;N=f[c+4>>2]|0;if((N|0)==(M|0))O=0;else{P=f[c>>2]|0;O=(N-(f[P>>2]|0)>>2)+(P-H<<8)-(M-(f[H>>2]|0)>>2)|0}H=b+20|0;M=f[H>>2]|0;if(O>>>0<(M-O|0)>>>0){if(D>>>0>G>>>0){Joa(b,D-G|0);Q=f[F>>2]|0;R=f[y>>2]|0;S=f[I>>2]|0}else{Q=G;R=E;S=J}P=R+(Q>>>10<<2)|0;if((S|0)==(R|0))T=0;else T=(f[P>>2]|0)+((Q&1023)<<2)|0;R=P;S=T;if(D>>>0>O>>>0){if(O>>>0<D>>>1>>>0)if(!O){U=B;V=C}else{N=B;c=(C-(f[B>>2]|0)>>2)-O|0;if((c|0)>0){W=N+(c>>>10<<2)|0;X=(f[W>>2]|0)+((c&1023)<<2)|0;Y=W}else{W=1023-c|0;c=N+(((W|0)/-1024|0)<<2)|0;X=(f[c>>2]|0)+(1023-((W|0)%1024|0)<<2)|0;Y=c}U=Y;V=X}else{X=D-O|0;if(!X){U=z;V=A}else{Y=z;c=(A-(f[z>>2]|0)>>2)+X|0;if((c|0)>0){X=Y+(c>>>10<<2)|0;Z=(f[X>>2]|0)+((c&1023)<<2)|0;_=X}else{X=1023-c|0;c=Y+(((X|0)/-1024|0)<<2)|0;Z=(f[c>>2]|0)+(1023-((X|0)%1024|0)<<2)|0;_=c}U=_;V=Z}}Z=V;_=d+4|0;if((Z|0)==(f[_>>2]|0)){$=O;aa=Q;ba=R;ca=S;da=U;ea=V}else{c=U;X=R;Y=S;W=Z;Z=Q;N=f[H>>2]|0;while(1){fa=Y;ga=X;if((fa|0)==(f[ga>>2]|0)){ha=ga+-4|0;ia=ha;ja=(f[ha>>2]|0)+4096|0}else{ia=X;ja=fa}fa=ja+-4|0;Y=fa;ha=c;if((W|0)==(f[ha>>2]|0)){ga=ha+-4|0;ka=ga;la=(f[ga>>2]|0)+4096|0}else{ka=c;la=W}W=la+-4|0;f[fa>>2]=f[W>>2];Z=Z+-1|0;N=N+1|0;if((W|0)==(f[_>>2]|0))break;else{c=ka;X=ia}}f[F>>2]=Z;f[H>>2]=N;$=O;aa=Z;ba=ia;ca=Y;da=U;ea=V}}else{$=D;aa=Q;ba=R;ca=S;da=z;ea=A}if($|0){Q=(S-(f[P>>2]|0)>>2)+$|0;if((Q|0)>0){V=P+(Q>>>10<<2)|0;ma=(f[V>>2]|0)+((Q&1023)<<2)|0;na=V}else{V=1023-Q|0;Q=P+(((V|0)/-1024|0)<<2)|0;ma=(f[Q>>2]|0)+(1023-((V|0)%1024|0)<<2)|0;na=Q}Q=na;na=ma;if((ma|0)!=(T|0)){V=Q;U=ba;ba=ca;ca=ma;ma=aa;aa=f[H>>2]|0;while(1){Y=ba;ia=U;if((Y|0)==(f[ia>>2]|0)){Z=ia+-4|0;oa=Z;pa=(f[Z>>2]|0)+4096|0}else{oa=U;pa=Y}ba=pa+-4|0;Y=V;if((ca|0)==(f[Y>>2]|0)){Z=Y+-4|0;qa=Z;ra=(f[Z>>2]|0)+4096|0}else{qa=V;ra=ca}ca=ra+-4|0;f[ba>>2]=f[ca>>2];ma=ma+-1|0;aa=aa+1|0;if((ca|0)==(T|0))break;else{V=qa;U=oa}}f[F>>2]=ma;f[H>>2]=aa}if($>>>0<O>>>0){f[l>>2]=Q;f[l+4>>2]=na;na=m;f[na>>2]=R;f[na+4>>2]=S;na=(S-(f[P>>2]|0)>>2)+O|0;if((na|0)>0){Q=P+(na>>>10<<2)|0;f[m>>2]=Q;sa=(f[Q>>2]|0)+((na&1023)<<2)|0}else{Q=1023-na|0;na=P+(((Q|0)/-1024|0)<<2)|0;f[m>>2]=na;sa=(f[na>>2]|0)+(1023-((Q|0)%1024|0)<<2)|0}f[m+4>>2]=sa;f[n>>2]=R;f[n+4>>2]=S;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];Koa(k,j,i,h);ta=f[k>>2]|0;ua=f[k+4>>2]|0}else{ta=R;ua=S}S=o;f[S>>2]=da;f[S+4>>2]=ea;ea=e;S=f[ea+4>>2]|0;da=p;f[da>>2]=f[ea>>2];f[da+4>>2]=S;f[q>>2]=ta;f[q+4>>2]=ua;f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];Loa(k,j,i,h)}}else{q=K-L|0;L=((q|0)==0?0:(q<<8)+-1|0)-(M+G)|0;if(D>>>0>L>>>0){Moa(b,D-L|0);va=f[H>>2]|0;wa=f[F>>2]|0;xa=f[y>>2]|0;ya=f[I>>2]|0}else{va=M;wa=G;xa=E;ya=J}J=wa+va|0;wa=xa+(J>>>10<<2)|0;if((ya|0)==(xa|0))za=0;else za=(f[wa>>2]|0)+((J&1023)<<2)|0;J=wa;xa=za;ya=va-O|0;if(D>>>0>ya>>>0){if(ya>>>0<D>>>1>>>0)if(!ya){Aa=z;Ba=A}else{E=z;G=(A-(f[z>>2]|0)>>2)+ya|0;if((G|0)>0){z=E+(G>>>10<<2)|0;Ca=(f[z>>2]|0)+((G&1023)<<2)|0;Da=z}else{z=1023-G|0;G=E+(((z|0)/-1024|0)<<2)|0;Ca=(f[G>>2]|0)+(1023-((z|0)%1024|0)<<2)|0;Da=G}Aa=Da;Ba=Ca}else{Ca=D-ya|0;if(!Ca){Aa=B;Ba=C}else{Da=B;G=(C-(f[B>>2]|0)>>2)-Ca|0;if((G|0)>0){Ca=Da+(G>>>10<<2)|0;Ea=(f[Ca>>2]|0)+((G&1023)<<2)|0;Fa=Ca}else{Ca=1023-G|0;G=Da+(((Ca|0)/-1024|0)<<2)|0;Ea=(f[G>>2]|0)+(1023-((Ca|0)%1024|0)<<2)|0;Fa=G}Aa=Fa;Ba=Ea}}Ea=Ba;Fa=e+4|0;if((Ea|0)==(f[Fa>>2]|0)){Ga=ya;Ha=va;Ia=J;Ja=xa;Ka=Aa;La=Ba}else{e=Aa;G=J;Ca=Ba;Da=xa;z=Ea;Ea=va;while(1){f[Da>>2]=f[Ca>>2];E=Da+4|0;if((E-(f[G>>2]|0)|0)==4096){A=G+4|0;Ma=A;Na=f[A>>2]|0}else{Ma=G;Na=E}E=z+4|0;if((E-(f[e>>2]|0)|0)==4096){A=e+4|0;Oa=A;Pa=f[A>>2]|0}else{Oa=e;Pa=E}Ea=Ea+1|0;z=Pa;if((z|0)==(f[Fa>>2]|0))break;else{e=Oa;G=Ma;Ca=Pa;Da=Na}}f[H>>2]=Ea;Ga=ya;Ha=Ea;Ia=Ma;Ja=Na;Ka=Aa;La=Ba}}else{Ga=D;Ha=va;Ia=J;Ja=xa;Ka=B;La=C}if(Ga|0){C=(xa-(f[wa>>2]|0)>>2)-Ga|0;if((C|0)>0){B=wa+(C>>>10<<2)|0;Qa=(f[B>>2]|0)+((C&1023)<<2)|0;Ra=B}else{B=1023-C|0;C=wa+(((B|0)/-1024|0)<<2)|0;Qa=(f[C>>2]|0)+(1023-((B|0)%1024|0)<<2)|0;Ra=C}C=Ra;Ra=Qa;if((Qa|0)!=(za|0)){B=C;va=Ia;Ia=Ra;D=Ja;Ja=Qa;Qa=Ha;while(1){f[D>>2]=f[Ia>>2];Ha=D+4|0;if((Ha-(f[va>>2]|0)|0)==4096){Ba=va+4|0;Sa=Ba;Ta=f[Ba>>2]|0}else{Sa=va;Ta=Ha}Ha=Ja+4|0;if((Ha-(f[B>>2]|0)|0)==4096){Ba=B+4|0;Ua=Ba;Va=f[Ba>>2]|0}else{Ua=B;Va=Ha}Qa=Qa+1|0;Ja=Va;if((Ja|0)==(za|0))break;else{B=Ua;va=Sa;Ia=Va;D=Ta}}f[H>>2]=Qa}if(Ga>>>0<ya>>>0){Ga=r;f[Ga>>2]=J;f[Ga+4>>2]=xa;Ga=(xa-(f[wa>>2]|0)>>2)-ya|0;if((Ga|0)>0){ya=wa+(Ga>>>10<<2)|0;f[r>>2]=ya;Wa=(f[ya>>2]|0)+((Ga&1023)<<2)|0}else{ya=1023-Ga|0;Ga=wa+(((ya|0)/-1024|0)<<2)|0;f[r>>2]=Ga;Wa=(f[Ga>>2]|0)+(1023-((ya|0)%1024|0)<<2)|0}f[r+4>>2]=Wa;f[s>>2]=C;f[s+4>>2]=Ra;f[t>>2]=J;f[t+4>>2]=xa;f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2];f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];Noa(k,j,i,h);Xa=f[k>>2]|0;Ya=f[k+4>>2]|0}else{Xa=J;Ya=xa}xa=d;d=f[xa+4>>2]|0;J=v;f[J>>2]=f[xa>>2];f[J+4>>2]=d;d=w;f[d>>2]=Ka;f[d+4>>2]=La;f[x>>2]=Xa;f[x+4>>2]=Ya;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2];f[i>>2]=f[w>>2];f[i+4>>2]=f[w+4>>2];f[h>>2]=f[x>>2];f[h+4>>2]=f[x+4>>2];Ooa(k,j,i,h)}}h=f[y>>2]|0;y=f[F>>2]|0;F=h+(y>>>10<<2)|0;if((f[I>>2]|0)==(h|0)){Za=0;_a=0}else{Za=0;_a=(f[F>>2]|0)+((y&1023)<<2)|0}y=a;f[y>>2]=Za|F;f[y+4>>2]=_a;if(!O){u=g;return}y=(_a-(f[F>>2]|0)>>2)+O|0;if((y|0)>0){O=F+(y>>>10<<2)|0;f[a>>2]=O;$a=(f[O>>2]|0)+((y&1023)<<2)|0}else{O=1023-y|0;y=F+(((O|0)/-1024|0)<<2)|0;f[a>>2]=y;$a=(f[y>>2]|0)+(1023-((O|0)%1024|0)<<2)|0}f[a+4>>2]=$a;u=g;return}function Joa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=u;u=u+32|0;d=c+4|0;e=c;g=a+8|0;h=f[g>>2]|0;i=a+4|0;j=f[i>>2]|0;k=(h|0)==(j|0);l=(k&1)+b|0;b=((l&1023|0)!=0&1)+(l>>>10)|0;l=j;j=h-l|0;m=a+16|0;n=f[m>>2]|0;o=(((j|0)==0?0:(j<<8)+-1|0)-((f[a+20>>2]|0)+n)|0)>>>10;p=b>>>0<o>>>0?b:o;q=b-p|0;if(!q){f[m>>2]=(p<<10)+n;if(!p){u=c;return}n=h+-4|0;f[d>>2]=f[n>>2];f[g>>2]=n;Poa(a,d);n=p+-1|0;if(!n){u=c;return}else r=n;do{n=(f[g>>2]|0)+-4|0;f[d>>2]=f[n>>2];f[g>>2]=n;Poa(a,d);r=r+-1|0}while((r|0)!=0);u=c;return}r=a+12|0;n=f[a>>2]|0;h=(f[r>>2]|0)-n|0;s=j>>2;if(q>>>0<=((h>>2)-s|0)>>>0){a:do if((l|0)==(n|0)){t=q;v=7}else{j=q;while(1){w=$Xc(4096)|0;f[d>>2]=w;Coa(a,d);w=j+-1|0;x=f[i>>2]|0;y=(f[m>>2]|0)+1024+((((f[g>>2]|0)-x|0)==4)<<31>>31)|0;f[m>>2]=y;if(!w){z=p;A=y;break a}if((x|0)==(f[a>>2]|0)){t=w;v=7;break}else j=w}}while(0);if((v|0)==7){n=~(b>>>0>o>>>0?o:b);o=t;do{l=$Xc(4096)|0;f[d>>2]=l;Boa(a,d);o=o+-1|0}while((o|0)!=0);z=t+-1-n|0;A=f[m>>2]|0}f[m>>2]=A+(z<<10);if(!z){u=c;return}A=z;do{z=(f[g>>2]|0)+-4|0;f[d>>2]=f[z>>2];f[g>>2]=z;Poa(a,d);A=A+-1|0}while((A|0)!=0);u=c;return}A=(b<<10)+(k<<31>>31)|0;k=h>>1;h=s+q|0;s=k>>>0<h>>>0?h:k;f[d+12>>2]=0;f[d+16>>2]=a+12;do if(s)if(s>>>0>1073741823){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{B=$Xc(s<<2)|0;break}else B=0;while(0);f[d>>2]=B;k=d+8|0;f[k>>2]=B;h=d+4|0;f[h>>2]=B;b=d+12|0;f[b>>2]=B+(s<<2);s=q;do{q=$Xc(4096)|0;f[e>>2]=q;Doa(d,e);s=s+-1|0}while((s|0)!=0);b:do if(!p)C=f[g>>2]|0;else{s=p;e=f[g>>2]|0;q=f[k>>2]|0;c:while(1){B=e+-4|0;z=f[b>>2]|0;n=z;t=q;do if((q|0)==(z|0)){o=f[h>>2]|0;l=f[d>>2]|0;j=l;if(o>>>0>l>>>0){w=o;x=((w-j>>2)+1|0)/-2|0;y=o+(x<<2)|0;D=t-w|0;w=D>>2;if(!w)E=o;else{q1c(y|0,o|0,D|0)|0;E=f[h>>2]|0}D=y+(w<<2)|0;f[k>>2]=D;f[h>>2]=E+(x<<2);F=D;break}D=n-j>>1;j=(D|0)==0?1:D;if(j>>>0>1073741823)break c;D=$Xc(j<<2)|0;x=D;w=D+(j>>>2<<2)|0;y=w;G=D+(j<<2)|0;if((o|0)==(q|0))H=y;else{j=w;w=y;D=o;while(1){f[j>>2]=f[D>>2];j=w+4|0;o=j;D=D+4|0;if((D|0)==(q|0)){H=o;break}else w=o}}f[d>>2]=x;f[h>>2]=y;f[k>>2]=H;f[b>>2]=G;if(!l)F=H;else{cYc(l);F=f[k>>2]|0}}else F=q;while(0);f[F>>2]=f[B>>2];q=(f[k>>2]|0)+4|0;f[k>>2]=q;n=(f[g>>2]|0)+-4|0;f[g>>2]=n;s=s+-1|0;if(!s){C=n;break b}else e=n}e=af(8)|0;hYc(e,512536);f[e>>2]=192348;ig(e|0,25336,2140)}while(0);F=f[i>>2]|0;do if((F|0)!=(C|0)){H=F;E=f[k>>2]|0;d:while(1){p=f[b>>2]|0;e=p;s=E;do if((E|0)==(p|0)){q=f[h>>2]|0;n=f[d>>2]|0;t=n;if(q>>>0>n>>>0){z=q;w=((z-t>>2)+1|0)/-2|0;D=q+(w<<2)|0;j=s-z|0;z=j>>2;if(!z)I=q;else{q1c(D|0,q|0,j|0)|0;I=f[h>>2]|0}j=D+(z<<2)|0;f[k>>2]=j;f[h>>2]=I+(w<<2);J=j;break}j=e-t>>1;t=(j|0)==0?1:j;if(t>>>0>1073741823){v=51;break d}j=$Xc(t<<2)|0;w=j;z=j+(t>>>2<<2)|0;D=z;o=j+(t<<2)|0;if((q|0)==(E|0))K=D;else{t=z;z=D;j=q;while(1){f[t>>2]=f[j>>2];t=z+4|0;q=t;j=j+4|0;if((j|0)==(E|0)){K=q;break}else z=q}}f[d>>2]=w;f[h>>2]=D;f[k>>2]=K;f[b>>2]=o;if(!n)J=K;else{cYc(n);J=f[k>>2]|0}}else J=E;while(0);f[J>>2]=f[H>>2];E=(f[k>>2]|0)+4|0;f[k>>2]=E;H=H+4|0;L=f[g>>2]|0;if((H|0)==(L|0)){v=39;break}}if((v|0)==39){M=L;N=h;O=k;P=b;Q=d;R=f[i>>2]|0;S=E;break}else if((v|0)==51){H=af(8)|0;hYc(H,512536);f[H>>2]=192348;ig(H|0,25336,2140)}}else{M=C;N=h;O=k;P=b;Q=d;R=F;S=f[k>>2]|0}while(0);F=f[a>>2]|0;f[a>>2]=f[Q>>2];f[Q>>2]=F;f[i>>2]=f[N>>2];f[N>>2]=R;f[g>>2]=S;f[O>>2]=M;O=f[r>>2]|0;f[r>>2]=f[P>>2];f[P>>2]=O;f[m>>2]=A+(f[m>>2]|0);if((M|0)!=(R|0))f[k>>2]=M+(~((M+-4-R|0)>>>2)<<2);if(F|0)cYc(F);u=c;return}function Koa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=j;j=f[c>>2]|0;e=f[c+4>>2]|0;c=h;while(1){h=(f[f[b>>2]>>2]|0)+4096|0;k=h-c>>2;l=(k|0)>(i|0);m=l?c+(i<<2)|0:h;h=l?i:k;if((c|0)==(m|0)){n=j;o=e}else{k=m;l=c;p=e;q=j;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-p>>2;u=l;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=l;l=w?l+(t<<2)|0:m;t=l-u|0;if(t|0)q1c(p|0,v|0,t|0)|0;if(!x){y=p;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((l|0)==(m|0)){n=z;o=A;break}else{p=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=i-h|0;if(h|0){q=f[b>>2]|0;p=((f[g>>2]|0)-(f[q>>2]|0)>>2)+h|0;if((p|0)>0){m=q+(p>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((p&1023)<<2)|0}else{m=1023-p|0;p=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=p;D=(f[p>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=r;j=n;e=o;c=f[g>>2]|0}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}g=d;E=f[g>>2]|0;F=f[g+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function Loa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=j;j=f[c>>2]|0;e=f[c+4>>2]|0;c=h;while(1){h=(f[f[b>>2]>>2]|0)+4096|0;k=h-c>>2;l=(k|0)>(i|0);m=l?c+(i<<2)|0:h;h=l?i:k;if((c|0)==(m|0)){n=j;o=e}else{k=m;l=c;p=e;q=j;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-p>>2;u=l;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=l;l=w?l+(t<<2)|0:m;t=l-u|0;if(t|0)q1c(p|0,v|0,t|0)|0;if(!x){y=p;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((l|0)==(m|0)){n=z;o=A;break}else{p=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=i-h|0;if(h|0){q=f[b>>2]|0;p=((f[g>>2]|0)-(f[q>>2]|0)>>2)+h|0;if((p|0)>0){m=q+(p>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((p&1023)<<2)|0}else{m=1023-p|0;p=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=p;D=(f[p>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=r;j=n;e=o;c=f[g>>2]|0}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}g=d;E=f[g>>2]|0;F=f[g+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function Moa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;c=u;u=u+32|0;d=c+4|0;e=c;g=a+8|0;h=f[g>>2]|0;i=a+4|0;j=f[i>>2]|0;k=((h|0)==(j|0)&1)+b|0;b=((k&1023|0)!=0&1)+(k>>>10)|0;k=a+16|0;l=f[k>>2]|0;m=l>>>10;n=b>>>0<m>>>0?b:m;o=b-n|0;p=h;if(!o){f[k>>2]=l-(n<<10);if(!n){u=c;return}l=a+12|0;q=n;r=j;s=h;a:while(1){h=f[r>>2]|0;t=r+4|0;f[i>>2]=t;v=f[l>>2]|0;w=v;x=s;do if((s|0)==(v|0)){y=f[a>>2]|0;z=y;if(t>>>0>y>>>0){A=t;B=((A-z>>2)+1|0)/-2|0;C=t+(B<<2)|0;D=x-A|0;A=D>>2;if(!A)E=t;else{q1c(C|0,t|0,D|0)|0;E=f[i>>2]|0}D=C+(A<<2)|0;f[g>>2]=D;f[i>>2]=E+(B<<2);F=D;break}D=w-z>>1;z=(D|0)==0?1:D;if(z>>>0>1073741823){G=10;break a}D=$Xc(z<<2)|0;B=D;A=D+(z>>>2<<2)|0;C=A;H=D+(z<<2)|0;if((t|0)==(s|0)){I=C;J=y}else{y=A;A=C;z=t;do{f[y>>2]=f[z>>2];y=A+4|0;A=y;z=z+4|0}while((z|0)!=(s|0));I=A;J=f[a>>2]|0}f[a>>2]=B;f[i>>2]=C;f[g>>2]=I;f[l>>2]=H;if(!J)F=I;else{cYc(J);F=f[g>>2]|0}}else F=s;while(0);f[F>>2]=h;t=(f[g>>2]|0)+4|0;f[g>>2]=t;w=q+-1|0;if(!w){G=69;break}q=w;r=f[i>>2]|0;s=t}if((G|0)==10){s=af(8)|0;hYc(s,512536);f[s>>2]=192348;ig(s|0,25336,2140)}else if((G|0)==69){u=c;return}}s=a+12|0;r=f[s>>2]|0;q=r-(f[a>>2]|0)|0;F=p-j>>2;if(o>>>0<=((q>>2)-F|0)>>>0){b:do if((r|0)==(p|0)){K=o;G=21}else{j=o;while(1){J=$Xc(4096)|0;f[d>>2]=J;Boa(a,d);J=j+-1|0;if(!J)break;if((f[s>>2]|0)==(f[g>>2]|0)){K=J;G=21;break b}else j=J}L=n;M=f[k>>2]|0}while(0);if((G|0)==21){p=~(b>>>0>m>>>0?m:b);b=K;do{m=$Xc(4096)|0;f[d>>2]=m;Coa(a,d);b=b+-1|0;N=(f[k>>2]|0)+1024+((((f[g>>2]|0)-(f[i>>2]|0)|0)==4)<<31>>31)|0;f[k>>2]=N}while((b|0)!=0);L=K+-1-p|0;M=N}f[k>>2]=M-(L<<10);if(!L){u=c;return}M=L;L=f[g>>2]|0;c:while(1){N=f[i>>2]|0;p=f[N>>2]|0;K=N+4|0;f[i>>2]=K;N=f[s>>2]|0;b=N;m=L;do if((L|0)==(N|0)){r=f[a>>2]|0;j=r;if(K>>>0>r>>>0){h=K;J=((h-j>>2)+1|0)/-2|0;I=K+(J<<2)|0;l=m-h|0;h=l>>2;if(!h)O=K;else{q1c(I|0,K|0,l|0)|0;O=f[i>>2]|0}l=I+(h<<2)|0;f[g>>2]=l;f[i>>2]=O+(J<<2);P=l;break}l=b-j>>1;j=(l|0)==0?1:l;if(j>>>0>1073741823){G=34;break c}l=$Xc(j<<2)|0;J=l;h=l+(j>>>2<<2)|0;I=h;E=l+(j<<2)|0;if((K|0)==(L|0)){Q=I;R=r}else{r=h;h=I;j=K;do{f[r>>2]=f[j>>2];r=h+4|0;h=r;j=j+4|0}while((j|0)!=(L|0));Q=h;R=f[a>>2]|0}f[a>>2]=J;f[i>>2]=I;f[g>>2]=Q;f[s>>2]=E;if(!R)P=Q;else{cYc(R);P=f[g>>2]|0}}else P=L;while(0);f[P>>2]=p;L=(f[g>>2]|0)+4|0;f[g>>2]=L;M=M+-1|0;if(!M){G=69;break}}if((G|0)==34){M=af(8)|0;hYc(M,512536);f[M>>2]=192348;ig(M|0,25336,2140)}else if((G|0)==69){u=c;return}}G=n<<10;M=q>>1;q=F+o|0;L=M>>>0<q>>>0?q:M;M=F-n|0;f[d+12>>2]=0;f[d+16>>2]=a+12;do if(L)if(L>>>0>1073741823){F=af(8)|0;hYc(F,512536);f[F>>2]=192348;ig(F|0,25336,2140)}else{S=$Xc(L<<2)|0;break}else S=0;while(0);f[d>>2]=S;F=S+(M<<2)|0;M=d+8|0;f[M>>2]=F;q=d+4|0;f[q>>2]=F;F=d+12|0;f[F>>2]=S+(L<<2);L=o;do{o=$Xc(4096)|0;f[e>>2]=o;Doa(d,e);L=L+-1|0}while((L|0)!=0);d:do if(n|0){L=n;e=f[M>>2]|0;o=f[i>>2]|0;e:while(1){S=f[F>>2]|0;P=S;R=e;do if((e|0)==(S|0)){Q=f[q>>2]|0;O=f[d>>2]|0;K=O;if(Q>>>0>O>>>0){b=Q;m=((b-K>>2)+1|0)/-2|0;N=Q+(m<<2)|0;j=R-b|0;b=j>>2;if(!b)T=Q;else{q1c(N|0,Q|0,j|0)|0;T=f[q>>2]|0}j=N+(b<<2)|0;f[M>>2]=j;f[q>>2]=T+(m<<2);U=j;break}j=P-K>>1;K=(j|0)==0?1:j;if(K>>>0>1073741823)break e;j=$Xc(K<<2)|0;m=j;b=j+(K>>>2<<2)|0;N=b;r=j+(K<<2)|0;if((Q|0)==(e|0))V=N;else{K=b;b=N;j=Q;while(1){f[K>>2]=f[j>>2];K=b+4|0;Q=K;j=j+4|0;if((j|0)==(e|0)){V=Q;break}else b=Q}}f[d>>2]=m;f[q>>2]=N;f[M>>2]=V;f[F>>2]=r;if(!O)U=V;else{cYc(O);U=f[M>>2]|0}}else U=e;while(0);f[U>>2]=f[o>>2];e=(f[M>>2]|0)+4|0;f[M>>2]=e;o=(f[i>>2]|0)+4|0;f[i>>2]=o;L=L+-1|0;if(!L)break d}L=af(8)|0;hYc(L,512536);f[L>>2]=192348;ig(L|0,25336,2140)}while(0);U=f[g>>2]|0;while(1){W=f[i>>2]|0;if((U|0)==(W|0))break;V=U+-4|0;Eoa(d,V);U=V}V=W;W=f[a>>2]|0;f[a>>2]=f[d>>2];f[d>>2]=W;f[i>>2]=f[q>>2];f[q>>2]=V;q=f[g>>2]|0;f[g>>2]=f[M>>2];f[M>>2]=q;g=f[s>>2]|0;f[s>>2]=f[F>>2];f[F>>2]=g;f[k>>2]=(f[k>>2]|0)-G;G=q;if((G|0)!=(U|0))f[M>>2]=G+(~((G+-4-V|0)>>>2)<<2);if(W|0)cYc(W);u=c;return}function Noa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=b;b=f[c>>2]|0;h=g;while(1){if((h|0)==(f[b>>2]|0)){g=b+-4|0;f[c>>2]=g;i=(f[g>>2]|0)+4096|0;f[e>>2]=i;k=i;l=g}else{k=h;l=b}g=k+-4|0;f[e>>2]=g;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(j|0);o=n?k+(0-j<<2)|0:i;i=n?j:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=g;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)q1c(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;j=j-i|0;n=i+-1|0;if(!n){I=l;J=g}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=(f[n>>2]|0)+((u&1023)<<2)|0;L=n}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0;L=u}f[e>>2]=K;I=L;J=K}if((j|0)<=0){M=q;N=r;break}else{b=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function Ooa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=b;b=f[c>>2]|0;h=g;while(1){if((h|0)==(f[b>>2]|0)){g=b+-4|0;f[c>>2]=g;i=(f[g>>2]|0)+4096|0;f[e>>2]=i;k=i;l=g}else{k=h;l=b}g=k+-4|0;f[e>>2]=g;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(j|0);o=n?k+(0-j<<2)|0:i;i=n?j:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=g;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)q1c(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;j=j-i|0;n=i+-1|0;if(!n){I=l;J=g}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=(f[n>>2]|0)+((u&1023)<<2)|0;L=n}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0;L=u}f[e>>2]=K;I=L;J=K}if((j|0)<=0){M=q;N=r;break}else{b=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function Poa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{q1c(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=af(8)|0;hYc(m,512536);f[m>>2]=192348;ig(m|0,25336,2140)}m=$Xc(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{cYc(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function Qoa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;i=u;u=u+352|0;j=i+336|0;k=i+328|0;l=i+272|0;m=i+216|0;n=i+160|0;o=i+136|0;p=i+80|0;q=i+72|0;r=i;if((oS(a,-1)|0)!=2){s=$Xc(16)|0;f[j>>2]=s;f[j+8>>2]=-2147483632;f[j+4>>2]=15;t=s;v=268896;w=t+15|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+15>>0]=0;vM(-215,j,268638,268644,1056)}if((dS(a,-1)|0)!=3?(dS(a,-1)|0)!=19:0){s=$Xc(64)|0;f[j>>2]=s;f[j+8>>2]=-2147483584;f[j+4>>2]=48;t=s;v=268912;w=t+48|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+48>>0]=0;vM(-215,j,268638,268644,1057)}s=dS(c,-1)|0;if((s|0)!=(dS(a,-1)|0)){s=$Xc(32)|0;f[j>>2]=s;f[j+8>>2]=-2147483616;f[j+4>>2]=24;t=s;v=268961;w=t+24|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+24>>0]=0;vM(-215,j,268638,268644,1058)}if(!(nS(a,c)|0)){s=$Xc(32)|0;f[j>>2]=s;f[j+8>>2]=-2147483616;f[j+4>>2]=17;t=s;v=268986;w=t+17|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+17>>0]=0;vM(-215,j,268638,268644,1059)}s=e>g;x=s?e:g;y=s?g:e;cS(j,a,-1);f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];wS(d,k,0,-1,0,0);do if((eS(d)|0)==65536){k=f[d+4>>2]|0;f[l>>2]=f[k>>2];j=l+4|0;s=k+4|0;f[j>>2]=f[s>>2];v=l+8|0;f[v>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];z=f[k+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=v;v=l+48|0;A=l+44|0;f[A>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(z|0){v=z+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[s>>2]|0)<3){s=f[k+44>>2]|0;v=f[A>>2]|0;f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2];break}else{f[j>>2]=0;U$(l,k);break}}else bS(l,d,-1);while(0);do if((eS(a)|0)==65536){d=f[a+4>>2]|0;f[m>>2]=f[d>>2];k=m+4|0;j=d+4|0;f[k>>2]=f[j>>2];s=m+8|0;f[s>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=s;s=m+48|0;A=m+44|0;f[A>>2]=s;f[s>>2]=0;f[m+52>>2]=0;if(v|0){s=v+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[j>>2]|0)<3){j=f[d+44>>2]|0;s=f[A>>2]|0;f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];break}else{f[k>>2]=0;U$(m,d);break}}else bS(m,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[n>>2]=f[a>>2];d=n+4|0;k=a+4|0;f[d>>2]=f[k>>2];j=n+8|0;f[j>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[n+36>>2]=s;f[n+40>>2]=j;j=n+48|0;A=n+44|0;f[A>>2]=j;f[j>>2]=0;f[n+52>>2]=0;if(s|0){j=s+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+44>>2]|0;j=f[A>>2]|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];break}else{f[d>>2]=0;U$(n,a);break}}else bS(n,c,-1);while(0);if(h){e=y<32767.0?y:32767.0;g=x<32767.0?x:32767.0;B=e>0.0?e*e:e;if(g>0.0){C=g*g;D=B}else{C=g;D=B}}else{C=x;D=y}c=~~D;a=c-(+(c|0)>D&1)|0;c=~~C;d=c-(+(c|0)>C&1)|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[p>>2]=1124007936;c=p+4|0;k=p+8|0;j=p+40|0;t=c;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[j>>2]=k;k=p+48|0;t=p+44|0;f[t>>2]=k;f[k>>2]=0;f[p+52>>2]=0;w=i3()|0;A=j3()|0;s=(A|0)<(w|0)?A:w;w=(s|0)>1?s:1;s=m+8|0;A=f[s>>2]|0;if(((A|0)/(w|0)|0|0)<3){v=(A|0)/3|0;E=(v|0)>1?v:1}else E=w;f[q>>2]=0;f[q+4>>2]=A;Roa(r,m,n,p,o,a,d,h);h3(q,r,+(E|0));f[r>>2]=52972;XXc(r+44|0);E=f[p+12>>2]|0;h=o+20|0;d=f[h>>2]|0;if(d|0){a=o+16|0;A=o+4|0;w=o+8|0;v=0-E|0;z=~E;F=1-E|0;G=E+-1|0;H=E+1|0;I=d;while(1){d=f[a>>2]|0;J=I+-1|0;K=d+J|0;L=f[A>>2]|0;M=f[(f[L+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]|0;f[h>>2]=J;J=f[w>>2]|0;K=J-L|0;if((1-I-d+((K|0)==0?0:(K<<8)+-1|0)|0)>>>0>2047){cYc(f[J+-4>>2]|0);f[w>>2]=(f[w>>2]|0)+-4}J=M+v|0;if(!(b[M+z>>0]|0)){K=J+-1|0;b[K>>0]=2;d=f[A>>2]|0;L=(f[w>>2]|0)-d|0;N=f[a>>2]|0;O=f[h>>2]|0;if((((L|0)==0?0:(L<<8)+-1|0)|0)==(O+N|0)){xoa(o);P=f[a>>2]|0;Q=f[h>>2]|0;R=f[A>>2]|0}else{P=N;Q=O;R=d}d=Q+P|0;f[(f[R+(d>>>10<<2)>>2]|0)+((d&1023)<<2)>>2]=K;f[h>>2]=Q+1}if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;d=(f[w>>2]|0)-K|0;O=f[a>>2]|0;N=f[h>>2]|0;if((((d|0)==0?0:(d<<8)+-1|0)|0)==(N+O|0)){xoa(o);S=f[a>>2]|0;T=f[h>>2]|0;U=f[A>>2]|0}else{S=O;T=N;U=K}K=T+S|0;f[(f[U+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=T+1}if(!(b[M+F>>0]|0)){J=M+v+1|0;b[J>>0]=2;K=f[A>>2]|0;N=(f[w>>2]|0)-K|0;O=f[a>>2]|0;d=f[h>>2]|0;if((((N|0)==0?0:(N<<8)+-1|0)|0)==(d+O|0)){xoa(o);V=f[a>>2]|0;W=f[h>>2]|0;X=f[A>>2]|0}else{V=O;W=d;X=K}K=W+V|0;f[(f[X+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=W+1}J=M+-1|0;if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;d=(f[w>>2]|0)-K|0;O=f[a>>2]|0;N=f[h>>2]|0;if((((d|0)==0?0:(d<<8)+-1|0)|0)==(N+O|0)){xoa(o);Z=f[a>>2]|0;_=f[h>>2]|0;$=f[A>>2]|0}else{Z=O;_=N;$=K}K=_+Z|0;f[(f[$+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=_+1}J=M+1|0;if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;N=(f[w>>2]|0)-K|0;O=f[a>>2]|0;d=f[h>>2]|0;if((((N|0)==0?0:(N<<8)+-1|0)|0)==(d+O|0)){xoa(o);aa=f[a>>2]|0;ba=f[h>>2]|0;ca=f[A>>2]|0}else{aa=O;ba=d;ca=K}K=ba+aa|0;f[(f[ca+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=ba+1}J=M+E|0;if(!(b[M+G>>0]|0)){K=J+-1|0;b[K>>0]=2;d=f[A>>2]|0;O=(f[w>>2]|0)-d|0;N=f[a>>2]|0;L=f[h>>2]|0;if((((O|0)==0?0:(O<<8)+-1|0)|0)==(L+N|0)){xoa(o);da=f[a>>2]|0;ea=f[h>>2]|0;fa=f[A>>2]|0}else{da=N;ea=L;fa=d}d=ea+da|0;f[(f[fa+(d>>>10<<2)>>2]|0)+((d&1023)<<2)>>2]=K;f[h>>2]=ea+1}if(!(b[J>>0]|0)){b[J>>0]=2;K=f[A>>2]|0;d=(f[w>>2]|0)-K|0;L=f[a>>2]|0;N=f[h>>2]|0;if((((d|0)==0?0:(d<<8)+-1|0)|0)==(N+L|0)){xoa(o);ga=f[a>>2]|0;ha=f[h>>2]|0;ia=f[A>>2]|0}else{ga=L;ha=N;ia=K}K=ha+ga|0;f[(f[ia+(K>>>10<<2)>>2]|0)+((K&1023)<<2)>>2]=J;f[h>>2]=ha+1}if(!(b[M+H>>0]|0)){J=M+E+1|0;b[J>>0]=2;M=f[A>>2]|0;K=(f[w>>2]|0)-M|0;N=f[a>>2]|0;L=f[h>>2]|0;if((((K|0)==0?0:(K<<8)+-1|0)|0)==(L+N|0)){xoa(o);ja=f[a>>2]|0;ka=f[h>>2]|0;la=f[A>>2]|0}else{ja=N;ka=L;la=M}M=ka+ja|0;f[(f[la+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=J;J=ka+1|0;f[h>>2]=J;ma=J}else ma=f[h>>2]|0;if(!ma)break;else I=ma}}ma=f[s>>2]|0;f[q>>2]=0;f[q+4>>2]=ma;f[r>>2]=52992;f[r+4>>2]=p;f[r+8>>2]=l;s=m+4|0;I=f[s>>2]|0;if((I|0)<3)na=Y(f[m+12>>2]|0,ma)|0;else{ma=f[m+40>>2]|0;h=0;ka=1;while(1){la=Y(f[ma+(h<<2)>>2]|0,ka)|0;h=h+1|0;if((h|0)==(I|0)){na=la;break}else ka=la}}h3(q,r,+(na>>>0)*.0000152587890625);na=p+36|0;r=f[na>>2]|0;if(r|0?(q=r+12|0,r=f[q>>2]|0,f[q>>2]=r+-1,(r|0)==1):0)V$(p);f[na>>2]=0;na=p+16|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[c>>2]|0)>0){na=f[j>>2]|0;j=0;do{f[na+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=f[t>>2]|0;if((c|0)!=(k|0))wL(c);yoa(o);o=n+36|0;c=f[o>>2]|0;if(c|0?(k=c+12|0,c=f[k>>2]|0,f[k>>2]=c+-1,(c|0)==1):0)V$(n);f[o>>2]=0;o=n+16|0;c=n+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[c>>2]|0)>0){o=f[n+40>>2]|0;k=0;do{f[o+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[n+44>>2]|0;if((c|0)!=(n+48|0))wL(c);c=m+36|0;n=f[c>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)V$(m);f[c>>2]=0;c=m+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[s>>2]|0)>0){c=f[m+40>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[s>>2]|0))}s=f[m+44>>2]|0;if((s|0)!=(m+48|0))wL(s);s=l+36|0;m=f[s>>2]|0;do if(m|0){n=m+12|0;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1)break;V$(l)}while(0);f[s>>2]=0;s=l+16|0;m=l+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[m>>2]|0)>0){s=f[l+40>>2]|0;c=0;do{f[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=i;return}wL(m);u=i;return}function Roa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+80|0;l=k+64|0;m=k;n=k+8|0;f[a>>2]=52972;o=a+4|0;f[o>>2]=c;f[a+8>>2]=d;d=a+12|0;f[d>>2]=e;f[a+16>>2]=g;f[a+20>>2]=h;f[a+24>>2]=i;f[a+28>>2]=0;b[a+32>>0]=j&1;WXc(a+44|0);j=f[o>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=e+4|0;if(!(((((f[j>>2]|0)<3?(f[e+8>>2]|0)==(i|0):0)?(f[e+12>>2]|0)==(h|0):0)?(f[e>>2]&4095|0)==0:0)?(f[e+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;S$(e,2,l,0)}h=f[d>>2]|0;if((h|0)==(e|0))q=e;else{i=e+36|0;g=f[i>>2]|0;if(g|0){c=g+12|0;f[c>>2]=(f[c>>2]|0)+1}c=h+36|0;g=f[c>>2]|0;if(g|0?(r=g+12|0,g=f[r>>2]|0,f[r>>2]=g+-1,(g|0)==1):0)V$(h);f[c>>2]=0;g=h+16|0;r=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[r>>2]|0)>0){s=f[h+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0;v=f[r>>2]|0}while((t|0)<(v|0));f[h>>2]=f[e>>2];if((v|0)<3)w=18;else w=20}else{f[h>>2]=f[e>>2];w=18}if((w|0)==18){v=f[j>>2]|0;if((v|0)<3){f[r>>2]=v;f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];v=f[e+44>>2]|0;r=f[h+44>>2]|0;f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2]}else w=20}if((w|0)==20)U$(h,e);f[g>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];f[c>>2]=f[i>>2];q=f[d>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;W$(n,q,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;mR(n,l,fT()|0)|0;q=n+36|0;i=f[q>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)V$(n);f[q>>2]=0;q=n+16|0;i=n+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[i>>2]|0)>0){q=f[n+40>>2]|0;c=0;do{f[q+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))wL(i);i=f[d>>2]|0;c=f[(f[o>>2]|0)+8>>2]|0;f[l>>2]=c+1;f[l+4>>2]=c+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;W$(n,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;mR(n,l,fT()|0)|0;l=n+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)V$(n);f[l>>2]=0;l=n+16|0;m=n+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[n+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[n+44>>2]|0;if((m|0)==(n+48|0)){x=f[d>>2]|0;y=x+12|0;z=f[y>>2]|0;A=a+36|0;f[A>>2]=z;B=a+33|0;b[B>>0]=0;C=f[o>>2]|0;D=f[C>>2]|0;E=D>>>3;F=E&511;G=F+1|0;H=a+40|0;f[H>>2]=G;u=k;return}wL(m);x=f[d>>2]|0;y=x+12|0;z=f[y>>2]|0;A=a+36|0;f[A>>2]=z;B=a+33|0;b[B>>0]=0;C=f[o>>2]|0;D=f[C>>2]|0;E=D>>>3;F=E&511;G=F+1|0;H=a+40|0;f[H>>2]=G;u=k;return}function Soa(a,c,d,e,g,i,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0;q=u;u=u+1504|0;r=q;s=q+472|0;t=q+344|0;v=q+288|0;w=q+232|0;x=q+176|0;y=q+160|0;z=q+148|0;A=q+136|0;B=q+128|0;do if((eS(e)|0)==65536){C=f[e+4>>2]|0;f[v>>2]=f[C>>2];D=v+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=v+8|0;f[F>>2]=f[C+8>>2];f[v+12>>2]=f[C+12>>2];f[v+16>>2]=f[C+16>>2];f[v+20>>2]=f[C+20>>2];f[v+24>>2]=f[C+24>>2];f[v+28>>2]=f[C+28>>2];f[v+32>>2]=f[C+32>>2];G=f[C+36>>2]|0;f[v+36>>2]=G;f[v+40>>2]=F;F=v+48|0;H=v+44|0;f[H>>2]=F;f[F>>2]=0;f[v+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[D>>2]=0;U$(v,C);break}}else bS(v,e,-1);while(0);if(!((i|0)>0&(k|0)!=0)){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;e=$Xc(32)|0;f[r>>2]=e;f[r+8>>2]=-2147483616;f[r+4>>2]=20;I=e;J=269004;K=I+20|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[e+20>>0]=0;vM(-215,r,269025,269034,877)}do if((eS(g)|0)==65536){e=f[g+4>>2]|0;f[r>>2]=f[e>>2];C=r+4|0;D=e+4|0;f[C>>2]=f[D>>2];E=r+8|0;f[E>>2]=f[e+8>>2];f[r+12>>2]=f[e+12>>2];F=r+16|0;f[F>>2]=f[e+16>>2];f[r+20>>2]=f[e+20>>2];f[r+24>>2]=f[e+24>>2];f[r+28>>2]=f[e+28>>2];f[r+32>>2]=f[e+32>>2];H=r+36|0;G=f[e+36>>2]|0;f[H>>2]=G;f[r+40>>2]=E;E=r+48|0;L=r+44|0;f[L>>2]=E;f[E>>2]=0;f[r+52>>2]=0;if(G|0){E=G+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[e+44>>2]|0;E=f[L>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];M=L;N=H;O=F;break}else{f[C>>2]=0;U$(r,e);M=L;N=H;O=F;break}}else{bS(r,g,-1);M=r+44|0;N=r+36|0;O=r+16|0}while(0);F=f[O>>2]|0;H=f[N>>2]|0;if(H|0?(L=H+12|0,H=f[L>>2]|0,f[L>>2]=H+-1,(H|0)==1):0)V$(r);f[N>>2]=0;N=r+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[N>>2]|0)>0){O=f[r+40>>2]|0;H=0;do{f[O+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[N>>2]|0))}N=f[M>>2]|0;if((N|0)!=(r+48|0))wL(N);xS(g,i,k,5,-1,0,0);do if((eS(g)|0)==65536){k=f[g+4>>2]|0;f[w>>2]=f[k>>2];N=w+4|0;M=k+4|0;f[N>>2]=f[M>>2];H=w+8|0;f[H>>2]=f[k+8>>2];O=w+12|0;f[O>>2]=f[k+12>>2];L=w+16|0;f[L>>2]=f[k+16>>2];e=w+20|0;f[e>>2]=f[k+20>>2];C=w+24|0;f[C>>2]=f[k+24>>2];D=w+28|0;f[D>>2]=f[k+28>>2];E=w+32|0;f[E>>2]=f[k+32>>2];G=w+36|0;P=f[k+36>>2]|0;f[G>>2]=P;f[w+40>>2]=H;Q=w+48|0;R=w+44|0;f[R>>2]=Q;f[Q>>2]=0;f[w+52>>2]=0;if(P|0){Q=P+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[M>>2]|0)<3){M=f[k+44>>2]|0;Q=f[R>>2]|0;f[Q>>2]=f[M>>2];f[Q+4>>2]=f[M+4>>2];S=L;T=w;U=N;V=H;W=O;X=e;Z=C;_=D;$=E;aa=G;ba=G;break}else{f[N>>2]=0;U$(w,k);S=L;T=w;U=N;V=H;W=O;X=e;Z=C;_=D;$=E;aa=G;ba=G;break}}else{bS(w,g,-1);G=w+36|0;S=w+16|0;T=w;U=w+4|0;V=w+8|0;W=w+12|0;X=w+20|0;Z=w+24|0;_=w+28|0;$=w+32|0;aa=G;ba=G}while(0);g=f[S>>2]|0;f[x>>2]=f[T>>2];T=x+4|0;G=f[U>>2]|0;f[T>>2]=G;E=x+8|0;f[E>>2]=f[V>>2];f[x+12>>2]=f[W>>2];W=x+16|0;f[W>>2]=g;f[x+20>>2]=f[X>>2];f[x+24>>2]=f[Z>>2];f[x+28>>2]=f[_>>2];f[x+32>>2]=f[$>>2];$=x+36|0;_=f[ba>>2]|0;f[$>>2]=_;ba=x+40|0;f[ba>>2]=E;E=x+48|0;Z=x+44|0;f[Z>>2]=E;f[E>>2]=0;f[x+52>>2]=0;if(!_)ca=G;else{G=_+12|0;f[G>>2]=(f[G>>2]|0)+1;ca=f[U>>2]|0}if((ca|0)<3){ca=f[w+44>>2]|0;G=f[Z>>2]|0;f[G>>2]=f[ca>>2];f[G+4>>2]=f[ca+4>>2]}else{f[T>>2]=0;U$(x,w)}f[x>>2]=f[x>>2]&-4096|4;if((F|0)==(g|0)&o){o=r+8|0;f[o>>2]=0;f[o+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=x;dY(w,r,4,1.0,0.0)}else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;lR(w,r)|0}f[y>>2]=0;o=y+4|0;f[o>>2]=0;f[y+8>>2]=0;f[z>>2]=0;g=z+4|0;f[g>>2]=0;f[z+8>>2]=0;f[A>>2]=0;F=A+4|0;f[F>>2]=0;f[A+8>>2]=0;f[B>>2]=0;ca=B+4|0;f[ca>>2]=0;G=v+16|0;if(f[G>>2]|0){_=f[v+4>>2]|0;if((_|0)<3)da=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{X=f[v+40>>2]|0;V=0;D=1;while(1){C=Y(f[X+(V<<2)>>2]|0,D)|0;V=V+1|0;if((V|0)==(_|0)){da=C;break}else D=C}}if(!((_|0)==0|(da|0)==0)?f[v>>2]&4095|0:0){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;da=$Xc(48)|0;f[r>>2]=da;f[r+8>>2]=-2147483600;f[r+4>>2]=38;I=da;J=269108;K=I+38|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[da+38>>0]=0;vM(-215,r,269025,269034,904)}}da=w+40|0;Toa(a,c,d,v,i,f[da>>2]|0,l,m,y,z,B,A);d=m?f[A>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[B>>2]|0;c=f[ca>>2]|0;_=f[y>>2]|0;D=f[z>>2]|0;V=f[W>>2]|0;X=f[_+(i<<2)>>2]|0;C=f[D+((i<<1|1)<<2)>>2]|0;f[r>>2]=0;e=r+4|0;f[e>>2]=0;f[r+8>>2]=0;f[s>>2]=1123876864;f[s+4>>2]=0;Uoa(x,s,i,l,d,m,0,r);O=f[r>>2]|0;switch(i|0){case 1:{H=f[D>>2]|0;N=f[D+4>>2]|0;g1c(s|0,0,1024)|0;a:do if(!c)ea=0;else{L=f[_>>2]|0;k=(H|0)==1;M=H<<1;Q=(a|0)<4;R=a+-4|0;if((a|0)<=0){P=a&-4;fa=Y(H,P)|0;ga=X;ha=L;ia=c;while(1){ia=ia+-1|0;do if(!ga){do if(k){if(Q){ja=0;ka=ha;break}else{la=0;ma=ha}while(1){na=h[ha+(la|1)>>0]|0;oa=s+(h[ma>>0]<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=s+(na<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=h[ha+(la|3)>>0]|0;na=s+(h[ha+(la|2)>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=s+(oa<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=la+4|0;if((na|0)>(R|0))break;else{la=na;ma=ha+na|0}}ja=P;ka=ha+P|0}else{if(Q){ja=0;ka=ha;break}else{pa=ha;qa=0}while(1){na=h[pa+H>>0]|0;oa=s+(h[pa>>0]<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=s+(na<<2)|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=pa+M|0;na=h[oa+H>>0]|0;ra=s+(h[oa>>0]<<2)|0;f[ra>>2]=(f[ra>>2]|0)+1;ra=s+(na<<2)|0;f[ra>>2]=(f[ra>>2]|0)+1;qa=qa+4|0;if((qa|0)>(R|0))break;else pa=oa+M|0}ja=P;ka=ha+fa|0}while(0);if((a|0)<=(ja|0)){sa=ka;break}oa=Y(H,a-ja|0)|0;ra=ka;na=ja;while(1){ta=s+(h[ra>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;na=na+1|0;if((na|0)==(a|0))break;else ra=ra+H|0}sa=ka+oa|0}else sa=ha;while(0);if(!ia){ea=0;break a}else{ga=ga+C|0;ha=sa+N|0}}}ha=Y(a,H)|0;ga=a&-4;ia=Y(H,ga)|0;fa=X;P=L;ra=c;while(1){ra=ra+-1|0;do if(!fa){do if(k){if(Q){ua=0;va=P;break}else{wa=0;xa=P}while(1){na=h[P+(wa|1)>>0]|0;ta=s+(h[xa>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=s+(na<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=h[P+(wa|3)>>0]|0;na=s+(h[P+(wa|2)>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=s+(ta<<2)|0;f[na>>2]=(f[na>>2]|0)+1;na=wa+4|0;if((na|0)>(R|0))break;else{wa=na;xa=P+na|0}}ua=ga;va=P+ga|0}else{if(Q){ua=0;va=P;break}else{ya=P;za=0}while(1){na=h[ya+H>>0]|0;ta=s+(h[ya>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=s+(na<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=ya+M|0;na=h[ta+H>>0]|0;Aa=s+(h[ta>>0]<<2)|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=s+(na<<2)|0;f[Aa>>2]=(f[Aa>>2]|0)+1;za=za+4|0;if((za|0)>(R|0))break;else ya=ta+M|0}ua=ga;va=P+ia|0}while(0);if((a|0)<=(ua|0)){Ba=va;break}oa=Y(H,a-ua|0)|0;ta=va;Aa=ua;while(1){na=s+(h[ta>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1;Aa=Aa+1|0;if((Aa|0)==(a|0))break;else ta=ta+H|0}Ba=va+oa|0}else{ta=P;Aa=0;while(1){if(b[fa+Aa>>0]|0){na=s+(h[ta>>0]<<2)|0;f[na>>2]=(f[na>>2]|0)+1}Aa=Aa+1|0;if((Aa|0)==(a|0))break;else ta=ta+H|0}Ba=P+ha|0}while(0);if(!ra){ea=0;break}else{fa=fa+C|0;P=Ba+N|0}}}while(0);do{N=f[O+(ea<<2)>>2]|0;Ba=V+N|0;if(N>>>0<1073741824)f[Ba>>2]=(f[Ba>>2]|0)+(f[s+(ea<<2)>>2]|0);ea=ea+1|0}while((ea|0)!=256);Ca=134;break}case 2:{ea=f[D>>2]|0;Ba=f[D+4>>2]|0;N=f[D+8>>2]|0;H=f[D+12>>2]|0;if((c|0)!=0&(a|0)>0){va=a+-1|0;ua=Y(ea,va)|0;ya=Y(N,va)|0;va=f[_>>2]|0;za=f[_+4>>2]|0;xa=X;wa=c;while(1){wa=wa+-1|0;if(!xa){sa=va;ka=za;ja=0;while(1){pa=(f[O+((h[ka>>0]|256)<<2)>>2]|0)+(f[O+(h[sa>>0]<<2)>>2]|0)|0;if(pa>>>0<1073741824){qa=V+pa|0;f[qa>>2]=(f[qa>>2]|0)+1}ja=ja+1|0;if((ja|0)==(a|0))break;else{sa=sa+ea|0;ka=ka+N|0}}}else{ka=va;sa=za;ja=0;while(1){do if(b[xa+ja>>0]|0){qa=(f[O+((h[sa>>0]|256)<<2)>>2]|0)+(f[O+(h[ka>>0]<<2)>>2]|0)|0;if(qa>>>0>=1073741824)break;pa=V+qa|0;f[pa>>2]=(f[pa>>2]|0)+1}while(0);ja=ja+1|0;if((ja|0)==(a|0))break;else{ka=ka+ea|0;sa=sa+N|0}}}if(!wa){Ca=133;break}else{va=va+ua+ea+Ba|0;za=za+ya+N+H|0;xa=xa+C|0}}}else Ca=133;break}case 3:{xa=f[D>>2]|0;H=f[D+4>>2]|0;N=f[D+8>>2]|0;ya=f[D+12>>2]|0;za=f[D+16>>2]|0;Ba=f[D+20>>2]|0;if((c|0)!=0&(a|0)>0){ea=a+-1|0;ua=Y(za,ea)|0;va=Y(N,ea)|0;wa=Y(xa,ea)|0;ea=f[_+8>>2]|0;sa=f[_+4>>2]|0;ka=f[_>>2]|0;ja=X;pa=c;while(1){pa=pa+-1|0;if(!ja){qa=ea;ma=sa;la=ka;P=0;while(1){fa=(f[O+((h[ma>>0]|256)<<2)>>2]|0)+(f[O+(h[la>>0]<<2)>>2]|0)+(f[O+((h[qa>>0]|512)<<2)>>2]|0)|0;if(fa>>>0<1073741824){ra=V+fa|0;f[ra>>2]=(f[ra>>2]|0)+1}P=P+1|0;if((P|0)==(a|0))break;else{qa=qa+za|0;ma=ma+N|0;la=la+xa|0}}}else{la=ea;ma=sa;qa=ka;P=0;while(1){do if(b[ja+P>>0]|0){ra=(f[O+((h[ma>>0]|256)<<2)>>2]|0)+(f[O+(h[qa>>0]<<2)>>2]|0)+(f[O+((h[la>>0]|512)<<2)>>2]|0)|0;if(ra>>>0>=1073741824)break;fa=V+ra|0;f[fa>>2]=(f[fa>>2]|0)+1}while(0);P=P+1|0;if((P|0)==(a|0))break;else{la=la+za|0;ma=ma+N|0;qa=qa+xa|0}}}if(!pa){Ca=133;break}else{ea=ea+ua+za+Ba|0;sa=sa+va+N+ya|0;ka=ka+wa+xa+H|0;ja=ja+C|0}}}else Ca=133;break}default:if(!c)Ca=133;else{ja=(a|0)>0;H=X;X=c;while(1){X=X+-1|0;if(!H)if(ja){c=0;do{xa=0;wa=V;while(1){ka=_+(xa<<2)|0;ya=f[ka>>2]|0;N=f[O+((h[ya>>0]|xa<<8)<<2)>>2]|0;if(N>>>0>1073741823){Da=xa;Ea=wa;break}va=wa+N|0;f[ka>>2]=ya+(f[D+(xa<<1<<2)>>2]|0);ya=xa+1|0;if((ya|0)<(i|0)){xa=ya;wa=va}else{Da=ya;Ea=va;break}}do if((Da|0)==(i|0))f[Ea>>2]=(f[Ea>>2]|0)+1;else{if((Da|0)<(i|0))Fa=Da;else break;do{wa=_+(Fa<<2)|0;f[wa>>2]=(f[wa>>2]|0)+(f[D+(Fa<<1<<2)>>2]|0);Fa=Fa+1|0}while((Fa|0)!=(i|0))}while(0);c=c+1|0}while((c|0)!=(a|0));Ga=0}else Ga=0;else if(ja){c=0;while(1){b:do if(!(b[H+c>>0]|0)){Ha=0;Ia=V}else{wa=0;xa=V;while(1){va=_+(wa<<2)|0;ya=f[va>>2]|0;ka=f[O+((h[ya>>0]|wa<<8)<<2)>>2]|0;if(ka>>>0>1073741823){Ha=wa;Ia=xa;break b}N=xa+ka|0;f[va>>2]=ya+(f[D+(wa<<1<<2)>>2]|0);ya=wa+1|0;if((ya|0)<(i|0)){wa=ya;xa=N}else{Ha=ya;Ia=N;break}}}while(0);do if((Ha|0)==(i|0))f[Ia>>2]=(f[Ia>>2]|0)+1;else{if((Ha|0)<(i|0))Ja=Ha;else break;do{xa=_+(Ja<<2)|0;f[xa>>2]=(f[xa>>2]|0)+(f[D+(Ja<<1<<2)>>2]|0);Ja=Ja+1|0}while((Ja|0)!=(i|0))}while(0);c=c+1|0;if((c|0)==(a|0)){Ga=0;break}}}else Ga=0;do{c=_+(Ga<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[D+((Ga<<1|1)<<2)>>2]|0);Ga=Ga+1|0}while((Ga|0)!=(i|0));if(!X){Ca=133;break}else H=H+C|0}}}if((Ca|0)==133?O|0:0)Ca=134;if((Ca|0)==134){Ca=f[e>>2]|0;if((Ca|0)!=(O|0))f[e>>2]=Ca+(~((Ca+-4-O|0)>>>2)<<2);cYc(O)}break}case 2:{O=f[B>>2]|0;Ca=f[ca>>2]|0;e=f[y>>2]|0;C=f[z>>2]|0;H=f[W>>2]|0;X=f[e+(i<<2)>>2]|0;Ga=f[C+((i<<1|1)<<2)>>2]|0;D=i<<2;_=f[Z>>2]|0;o1c(s|0,f[ba>>2]|0,D|0)|0;o1c(t|0,_|0,D|0)|0;c:do if(!m){if(!l){_=$Xc(64)|0;f[r>>2]=_;f[r+8>>2]=-2147483584;f[r+4>>2]=55;I=_;J=269147;K=I+55|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[_+55>>0]=0;vM(-5,r,269203,269034,431)}o1c(r|0,l|0,D|0)|0;if(Ca|0){a=(O|0)>0;Ja=X;Ha=Ca;while(1){Ha=Ha+-1|0;if(a)if(!Ja){Ia=0;do{V=H;ja=0;while(1){Fa=e+(ja<<2)|0;Da=f[Fa>>2]|0;Ka=+(j[Da>>1]|0);Ea=f[r+(ja<<2)>>2]|0;c=f[s+(ja<<2)>>2]|0;xa=-1;while(1){wa=xa+1|0;if(!(Ka>=+n[Ea+(wa<<2)>>2])){La=xa;break}if((wa|0)<(c|0))xa=wa;else{La=wa;break}}if(La>>>0>=c>>>0){Ma=V;Na=ja;break}f[Fa>>2]=Da+(f[C+(ja<<1<<2)>>2]<<1);xa=V+(Y(f[t+(ja<<2)>>2]|0,La)|0)|0;Ea=ja+1|0;if((Ea|0)<(i|0)){V=xa;ja=Ea}else{Ma=xa;Na=Ea;break}}do if((Na|0)==(i|0))f[Ma>>2]=(f[Ma>>2]|0)+1;else{if((Na|0)<(i|0))Oa=Na;else break;do{ja=e+(Oa<<2)|0;f[ja>>2]=(f[ja>>2]|0)+(f[C+(Oa<<1<<2)>>2]<<1);Oa=Oa+1|0}while((Oa|0)!=(i|0))}while(0);Ia=Ia+1|0}while((Ia|0)!=(O|0));Pa=0}else{Ia=0;while(1){d:do if(!(b[Ja+Ia>>0]|0)){Qa=H;Ra=0}else{Da=H;Fa=0;while(1){c=e+(Fa<<2)|0;ja=f[c>>2]|0;Ka=+(j[ja>>1]|0);V=f[r+(Fa<<2)>>2]|0;Ea=f[s+(Fa<<2)>>2]|0;xa=-1;while(1){wa=xa+1|0;if(!(Ka>=+n[V+(wa<<2)>>2])){Sa=xa;break}if((wa|0)<(Ea|0))xa=wa;else{Sa=wa;break}}if(Sa>>>0>=Ea>>>0){Qa=Da;Ra=Fa;break d}f[c>>2]=ja+(f[C+(Fa<<1<<2)>>2]<<1);xa=Da+(Y(f[t+(Fa<<2)>>2]|0,Sa)|0)|0;V=Fa+1|0;if((V|0)<(i|0)){Da=xa;Fa=V}else{Qa=xa;Ra=V;break}}}while(0);do if((Ra|0)==(i|0))f[Qa>>2]=(f[Qa>>2]|0)+1;else{if((Ra|0)<(i|0))Ta=Ra;else break;do{Fa=e+(Ta<<2)|0;f[Fa>>2]=(f[Fa>>2]|0)+(f[C+(Ta<<1<<2)>>2]<<1);Ta=Ta+1|0}while((Ta|0)!=(i|0))}while(0);Ia=Ia+1|0;if((Ia|0)==(O|0)){Pa=0;break}}}else Pa=0;do{Ia=e+(Pa<<2)|0;f[Ia>>2]=(f[Ia>>2]|0)+(f[C+((Pa<<1|1)<<2)>>2]<<1);Pa=Pa+1|0}while((Pa|0)!=(i|0));if(!Ha)break;else Ja=Ja+Ga|0}}}else switch(i|0){case 1:{Ka=+p[d>>3];Ua=+p[d+8>>3];Ja=f[s>>2]|0;Ha=f[C>>2]|0;a=f[C+4>>2]|0;if(!Ca)break c;if((O|0)<=0)break c;_=Y(Ha,O+-1|0)|0;Ia=X;Fa=f[e>>2]|0;Da=Ca;while(1){Da=Da+-1|0;if(!Ia){V=0;xa=Fa;while(1){Va=Ua+Ka*+(j[xa>>1]|0);wa=~~Va;N=wa-(+(wa|0)>Va&1)|0;wa=H+(N<<2)|0;if(N>>>0<Ja>>>0)f[wa>>2]=(f[wa>>2]|0)+1;V=V+1|0;if((V|0)==(O|0))break;else xa=xa+(Ha<<1)|0}}else{xa=0;V=Fa;while(1){do if(b[Ia+xa>>0]|0){Va=Ua+Ka*+(j[V>>1]|0);wa=~~Va;N=wa-(+(wa|0)>Va&1)|0;wa=H+(N<<2)|0;if(N>>>0>=Ja>>>0)break;f[wa>>2]=(f[wa>>2]|0)+1}while(0);xa=xa+1|0;if((xa|0)==(O|0))break;else V=V+(Ha<<1)|0}}if(!Da)break;else{Ia=Ia+Ga|0;Fa=Fa+(_<<1)+(Ha<<1)+(a<<1)|0}}break}case 2:{Ka=+p[d>>3];Ua=+p[d+8>>3];Va=+p[d+16>>3];Wa=+p[d+24>>3];a=f[s>>2]|0;Ha=f[s+4>>2]|0;_=f[C>>2]|0;Fa=f[C+4>>2]|0;Ia=f[C+8>>2]|0;Da=f[C+12>>2]|0;Ja=f[t>>2]|0;if(!((Ca|0)!=0&(O|0)>0))break c;V=O+-1|0;xa=Y(_,V)|0;wa=Y(Ia,V)|0;V=f[e>>2]|0;N=f[e+4>>2]|0;ya=X;va=Ca;while(1){va=va+-1|0;if(!ya){ka=V;sa=N;Ba=0;while(1){Xa=Ua+Ka*+(j[ka>>1]|0);za=~~Xa;ua=za-(+(za|0)>Xa&1)|0;Xa=Wa+Va*+(j[sa>>1]|0);za=~~Xa;ea=za-(+(za|0)>Xa&1)|0;za=H+(Y(ua,Ja)|0)+(ea<<2)|0;if(ua>>>0<a>>>0&ea>>>0<Ha>>>0)f[za>>2]=(f[za>>2]|0)+1;Ba=Ba+1|0;if((Ba|0)==(O|0))break;else{ka=ka+(_<<1)|0;sa=sa+(Ia<<1)|0}}}else{sa=V;ka=N;Ba=0;while(1){do if(b[ya+Ba>>0]|0){Xa=Ua+Ka*+(j[sa>>1]|0);za=~~Xa;ea=za-(+(za|0)>Xa&1)|0;Xa=Wa+Va*+(j[ka>>1]|0);za=~~Xa;ua=za-(+(za|0)>Xa&1)|0;za=H+(Y(ea,Ja)|0)+(ua<<2)|0;if(!(ea>>>0<a>>>0&ua>>>0<Ha>>>0))break;f[za>>2]=(f[za>>2]|0)+1}while(0);Ba=Ba+1|0;if((Ba|0)==(O|0))break;else{sa=sa+(_<<1)|0;ka=ka+(Ia<<1)|0}}}if(!va)break;else{V=V+(xa<<1)+(_<<1)+(Fa<<1)|0;N=N+(wa<<1)+(Ia<<1)+(Da<<1)|0;ya=ya+Ga|0}}break}case 3:{Va=+p[d>>3];Wa=+p[d+8>>3];Ka=+p[d+16>>3];Ua=+p[d+24>>3];Xa=+p[d+32>>3];Ya=+p[d+40>>3];ya=f[s>>2]|0;Da=f[s+4>>2]|0;Ia=f[s+8>>2]|0;wa=f[C>>2]|0;N=f[C+4>>2]|0;Fa=f[C+8>>2]|0;_=f[C+12>>2]|0;xa=f[C+16>>2]|0;V=f[C+20>>2]|0;va=f[t>>2]|0;Ha=f[t+4>>2]|0;if(!Ca)break c;a=(O|0)>0;Ja=Y(O,wa)|0;ka=Y(O,Fa)|0;sa=Y(O,xa)|0;Ba=f[e>>2]|0;za=f[e+4>>2]|0;ua=f[e+8>>2]|0;ea=X;pa=Ca;while(1){pa=pa+-1|0;if(!ea)if(a){qa=za+(ka<<1)|0;ma=Ba;la=za;P=ua;fa=0;while(1){Za=Wa+Va*+(j[ma>>1]|0);ra=~~Za;ha=ra-(+(ra|0)>Za&1)|0;Za=Ua+Ka*+(j[la>>1]|0);ra=~~Za;ia=ra-(+(ra|0)>Za&1)|0;Za=Ya+Xa*+(j[P>>1]|0);ra=~~Za;ga=ra-(+(ra|0)>Za&1)|0;ra=H+(Y(ha,va)|0)+(Y(ia,Ha)|0)+(ga<<2)|0;if(ha>>>0<ya>>>0&ia>>>0<Da>>>0&ga>>>0<Ia>>>0)f[ra>>2]=(f[ra>>2]|0)+1;fa=fa+1|0;if((fa|0)==(O|0))break;else{ma=ma+(wa<<1)|0;la=la+(Fa<<1)|0;P=P+(xa<<1)|0}}_a=Ba+(Ja<<1)|0;$a=qa;ab=ua+(sa<<1)|0}else{_a=Ba;$a=za;ab=ua}else if(a){P=za+(ka<<1)|0;la=Ba;ma=za;fa=ua;ra=0;while(1){do if(b[ea+ra>>0]|0){Za=Wa+Va*+(j[la>>1]|0);ga=~~Za;ia=ga-(+(ga|0)>Za&1)|0;Za=Ua+Ka*+(j[ma>>1]|0);ga=~~Za;ha=ga-(+(ga|0)>Za&1)|0;Za=Ya+Xa*+(j[fa>>1]|0);ga=~~Za;M=ga-(+(ga|0)>Za&1)|0;ga=H+(Y(ia,va)|0)+(Y(ha,Ha)|0)+(M<<2)|0;if(!(ia>>>0<ya>>>0&ha>>>0<Da>>>0&M>>>0<Ia>>>0))break;f[ga>>2]=(f[ga>>2]|0)+1}while(0);ra=ra+1|0;if((ra|0)==(O|0))break;else{la=la+(wa<<1)|0;ma=ma+(Fa<<1)|0;fa=fa+(xa<<1)|0}}_a=Ba+(Ja<<1)|0;$a=P;ab=ua+(sa<<1)|0}else{_a=Ba;$a=za;ab=ua}if(!pa)break;else{Ba=_a+(N<<1)|0;za=$a+(_<<1)|0;ua=ab+(V<<1)|0;ea=ea+Ga|0}}break}default:{if(!Ca)break c;ea=(O|0)>0;V=X;ua=Ca;while(1){ua=ua+-1|0;if(!V)if(ea){_=0;do{za=H;N=0;while(1){Ba=e+(N<<2)|0;pa=f[Ba>>2]|0;sa=N<<1;Xa=+(j[pa>>1]|0)*+p[d+(sa<<3)>>3]+ +p[d+((sa|1)<<3)>>3];Ja=~~Xa;xa=Ja-(+(Ja|0)>Xa&1)|0;if(xa>>>0>=(f[s+(N<<2)>>2]|0)>>>0){bb=za;cb=N;break}f[Ba>>2]=pa+(f[C+(sa<<2)>>2]<<1);sa=za+(Y(f[t+(N<<2)>>2]|0,xa)|0)|0;xa=N+1|0;if((xa|0)<(i|0)){za=sa;N=xa}else{bb=sa;cb=xa;break}}do if((cb|0)==(i|0))f[bb>>2]=(f[bb>>2]|0)+1;else{if((cb|0)<(i|0))db=cb;else break;do{N=e+(db<<2)|0;f[N>>2]=(f[N>>2]|0)+(f[C+(db<<1<<2)>>2]<<1);db=db+1|0}while((db|0)!=(i|0))}while(0);_=_+1|0}while((_|0)!=(O|0));eb=0}else eb=0;else if(ea){_=0;while(1){e:do if(!(b[V+_>>0]|0)){fb=H;gb=0}else{P=H;N=0;while(1){za=e+(N<<2)|0;xa=f[za>>2]|0;sa=N<<1;Xa=+(j[xa>>1]|0)*+p[d+(sa<<3)>>3]+ +p[d+((sa|1)<<3)>>3];pa=~~Xa;Ba=pa-(+(pa|0)>Xa&1)|0;if(Ba>>>0>=(f[s+(N<<2)>>2]|0)>>>0){fb=P;gb=N;break e}f[za>>2]=xa+(f[C+(sa<<2)>>2]<<1);sa=P+(Y(f[t+(N<<2)>>2]|0,Ba)|0)|0;Ba=N+1|0;if((Ba|0)<(i|0)){P=sa;N=Ba}else{fb=sa;gb=Ba;break}}}while(0);do if((gb|0)==(i|0))f[fb>>2]=(f[fb>>2]|0)+1;else{if((gb|0)<(i|0))hb=gb;else break;do{N=e+(hb<<2)|0;f[N>>2]=(f[N>>2]|0)+(f[C+(hb<<1<<2)>>2]<<1);hb=hb+1|0}while((hb|0)!=(i|0))}while(0);_=_+1|0;if((_|0)==(O|0)){eb=0;break}}}else eb=0;do{_=e+(eb<<2)|0;f[_>>2]=(f[_>>2]|0)+(f[C+((eb<<1|1)<<2)>>2]<<1);eb=eb+1|0}while((eb|0)!=(i|0));if(!ua)break;else V=V+Ga|0}}}while(0);break}case 5:{Ga=f[B>>2]|0;B=f[ca>>2]|0;ca=f[y>>2]|0;eb=f[z>>2]|0;C=f[W>>2]|0;e=f[ca+(i<<2)>>2]|0;O=f[eb+((i<<1|1)<<2)>>2]|0;hb=i<<2;gb=f[Z>>2]|0;o1c(s|0,f[ba>>2]|0,hb|0)|0;o1c(t|0,gb|0,hb|0)|0;f:do if(!m){if(!l){gb=$Xc(64)|0;f[r>>2]=gb;f[r+8>>2]=-2147483584;f[r+4>>2]=55;I=gb;J=269147;K=I+55|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[gb+55>>0]=0;vM(-5,r,269203,269034,431)}o1c(r|0,l|0,hb|0)|0;if(B|0){fb=(Ga|0)>0;H=e;db=B;while(1){db=db+-1|0;if(fb)if(!H){cb=0;do{bb=C;Ca=0;while(1){X=ca+(Ca<<2)|0;ab=f[X>>2]|0;Xa=+n[ab>>2];$a=f[r+(Ca<<2)>>2]|0;_a=f[s+(Ca<<2)>>2]|0;Pa=-1;while(1){Ta=Pa+1|0;if(!(Xa>=+n[$a+(Ta<<2)>>2])){ib=Pa;break}if((Ta|0)<(_a|0))Pa=Ta;else{ib=Ta;break}}if(ib>>>0>=_a>>>0){jb=bb;kb=Ca;break}f[X>>2]=ab+(f[eb+(Ca<<1<<2)>>2]<<2);Pa=bb+(Y(f[t+(Ca<<2)>>2]|0,ib)|0)|0;$a=Ca+1|0;if(($a|0)<(i|0)){bb=Pa;Ca=$a}else{jb=Pa;kb=$a;break}}do if((kb|0)==(i|0))f[jb>>2]=(f[jb>>2]|0)+1;else{if((kb|0)<(i|0))lb=kb;else break;do{Ca=ca+(lb<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+(f[eb+(lb<<1<<2)>>2]<<2);lb=lb+1|0}while((lb|0)!=(i|0))}while(0);cb=cb+1|0}while((cb|0)!=(Ga|0));mb=0}else{cb=0;while(1){g:do if(!(b[H+cb>>0]|0)){nb=C;ob=0}else{ab=C;X=0;while(1){_a=ca+(X<<2)|0;Ca=f[_a>>2]|0;Xa=+n[Ca>>2];bb=f[r+(X<<2)>>2]|0;$a=f[s+(X<<2)>>2]|0;Pa=-1;while(1){Ta=Pa+1|0;if(!(Xa>=+n[bb+(Ta<<2)>>2])){pb=Pa;break}if((Ta|0)<($a|0))Pa=Ta;else{pb=Ta;break}}if(pb>>>0>=$a>>>0){nb=ab;ob=X;break g}f[_a>>2]=Ca+(f[eb+(X<<1<<2)>>2]<<2);Pa=ab+(Y(f[t+(X<<2)>>2]|0,pb)|0)|0;bb=X+1|0;if((bb|0)<(i|0)){ab=Pa;X=bb}else{nb=Pa;ob=bb;break}}}while(0);do if((ob|0)==(i|0))f[nb>>2]=(f[nb>>2]|0)+1;else{if((ob|0)<(i|0))qb=ob;else break;do{X=ca+(qb<<2)|0;f[X>>2]=(f[X>>2]|0)+(f[eb+(qb<<1<<2)>>2]<<2);qb=qb+1|0}while((qb|0)!=(i|0))}while(0);cb=cb+1|0;if((cb|0)==(Ga|0)){mb=0;break}}}else mb=0;do{cb=ca+(mb<<2)|0;f[cb>>2]=(f[cb>>2]|0)+(f[eb+((mb<<1|1)<<2)>>2]<<2);mb=mb+1|0}while((mb|0)!=(i|0));if(!db)break;else H=H+O|0}}}else switch(i|0){case 1:{Xa=+p[d>>3];Ya=+p[d+8>>3];H=f[s>>2]|0;db=f[eb>>2]|0;fb=f[eb+4>>2]|0;if(!B)break f;if((Ga|0)<=0)break f;gb=Y(db,Ga+-1|0)|0;cb=e;X=f[ca>>2]|0;ab=B;while(1){ab=ab+-1|0;if(!cb){bb=0;Pa=X;while(1){Ka=Ya+Xa*+n[Pa>>2];ja=~~Ka;c=ja-(+(ja|0)>Ka&1)|0;ja=C+(c<<2)|0;if(c>>>0<H>>>0)f[ja>>2]=(f[ja>>2]|0)+1;bb=bb+1|0;if((bb|0)==(Ga|0))break;else Pa=Pa+(db<<2)|0}}else{Pa=0;bb=X;while(1){do if(b[cb+Pa>>0]|0){Ka=Ya+Xa*+n[bb>>2];ja=~~Ka;c=ja-(+(ja|0)>Ka&1)|0;ja=C+(c<<2)|0;if(c>>>0>=H>>>0)break;f[ja>>2]=(f[ja>>2]|0)+1}while(0);Pa=Pa+1|0;if((Pa|0)==(Ga|0))break;else bb=bb+(db<<2)|0}}if(!ab)break;else{cb=cb+O|0;X=X+(gb<<2)+(db<<2)+(fb<<2)|0}}break}case 2:{Xa=+p[d>>3];Ya=+p[d+8>>3];Ka=+p[d+16>>3];Ua=+p[d+24>>3];fb=f[s>>2]|0;db=f[s+4>>2]|0;gb=f[eb>>2]|0;X=f[eb+4>>2]|0;cb=f[eb+8>>2]|0;ab=f[eb+12>>2]|0;H=f[t>>2]|0;if(!((B|0)!=0&(Ga|0)>0))break f;bb=Ga+-1|0;Pa=Y(gb,bb)|0;ja=Y(cb,bb)|0;bb=f[ca>>2]|0;c=f[ca+4>>2]|0;Ea=e;Ta=B;while(1){Ta=Ta+-1|0;if(!Ea){Ra=bb;Qa=c;Sa=0;while(1){Va=Ya+Xa*+n[Ra>>2];Oa=~~Va;Na=Oa-(+(Oa|0)>Va&1)|0;Va=Ua+Ka*+n[Qa>>2];Oa=~~Va;Ma=Oa-(+(Oa|0)>Va&1)|0;Oa=C+(Y(Na,H)|0)+(Ma<<2)|0;if(Na>>>0<fb>>>0&Ma>>>0<db>>>0)f[Oa>>2]=(f[Oa>>2]|0)+1;Sa=Sa+1|0;if((Sa|0)==(Ga|0))break;else{Ra=Ra+(gb<<2)|0;Qa=Qa+(cb<<2)|0}}}else{Qa=bb;Ra=c;Sa=0;while(1){do if(b[Ea+Sa>>0]|0){Va=Ya+Xa*+n[Qa>>2];Oa=~~Va;Ma=Oa-(+(Oa|0)>Va&1)|0;Va=Ua+Ka*+n[Ra>>2];Oa=~~Va;Na=Oa-(+(Oa|0)>Va&1)|0;Oa=C+(Y(Ma,H)|0)+(Na<<2)|0;if(!(Ma>>>0<fb>>>0&Na>>>0<db>>>0))break;f[Oa>>2]=(f[Oa>>2]|0)+1}while(0);Sa=Sa+1|0;if((Sa|0)==(Ga|0))break;else{Qa=Qa+(gb<<2)|0;Ra=Ra+(cb<<2)|0}}}if(!Ta)break;else{bb=bb+(Pa<<2)+(gb<<2)+(X<<2)|0;c=c+(ja<<2)+(cb<<2)+(ab<<2)|0;Ea=Ea+O|0}}break}case 3:{Ka=+p[d>>3];Ua=+p[d+8>>3];Xa=+p[d+16>>3];Ya=+p[d+24>>3];Va=+p[d+32>>3];Wa=+p[d+40>>3];Ea=f[s>>2]|0;ab=f[s+4>>2]|0;cb=f[s+8>>2]|0;ja=f[eb>>2]|0;c=f[eb+4>>2]|0;X=f[eb+8>>2]|0;gb=f[eb+12>>2]|0;Pa=f[eb+16>>2]|0;bb=f[eb+20>>2]|0;Ta=f[t>>2]|0;db=f[t+4>>2]|0;if(!B)break f;fb=(Ga|0)>0;H=Y(Ga,ja)|0;Ra=Y(Ga,X)|0;Qa=Y(Ga,Pa)|0;Sa=f[ca>>2]|0;Oa=f[ca+4>>2]|0;Na=f[ca+8>>2]|0;Ma=e;La=B;while(1){La=La+-1|0;if(!Ma)if(fb){D=Oa+(Ra<<2)|0;V=Sa;ua=Oa;ea=Na;_=0;while(1){Za=Ua+Ka*+n[V>>2];N=~~Za;P=N-(+(N|0)>Za&1)|0;Za=Ya+Xa*+n[ua>>2];N=~~Za;Ba=N-(+(N|0)>Za&1)|0;Za=Wa+Va*+n[ea>>2];N=~~Za;sa=N-(+(N|0)>Za&1)|0;N=C+(Y(P,Ta)|0)+(Y(Ba,db)|0)+(sa<<2)|0;if(P>>>0<Ea>>>0&Ba>>>0<ab>>>0&sa>>>0<cb>>>0)f[N>>2]=(f[N>>2]|0)+1;_=_+1|0;if((_|0)==(Ga|0))break;else{V=V+(ja<<2)|0;ua=ua+(X<<2)|0;ea=ea+(Pa<<2)|0}}rb=Sa+(H<<2)|0;sb=D;tb=Na+(Qa<<2)|0}else{rb=Sa;sb=Oa;tb=Na}else if(fb){ea=Oa+(Ra<<2)|0;ua=Sa;V=Oa;_=Na;N=0;while(1){do if(b[Ma+N>>0]|0){Za=Ua+Ka*+n[ua>>2];sa=~~Za;Ba=sa-(+(sa|0)>Za&1)|0;Za=Ya+Xa*+n[V>>2];sa=~~Za;P=sa-(+(sa|0)>Za&1)|0;Za=Wa+Va*+n[_>>2];sa=~~Za;xa=sa-(+(sa|0)>Za&1)|0;sa=C+(Y(Ba,Ta)|0)+(Y(P,db)|0)+(xa<<2)|0;if(!(Ba>>>0<Ea>>>0&P>>>0<ab>>>0&xa>>>0<cb>>>0))break;f[sa>>2]=(f[sa>>2]|0)+1}while(0);N=N+1|0;if((N|0)==(Ga|0))break;else{ua=ua+(ja<<2)|0;V=V+(X<<2)|0;_=_+(Pa<<2)|0}}rb=Sa+(H<<2)|0;sb=ea;tb=Na+(Qa<<2)|0}else{rb=Sa;sb=Oa;tb=Na}if(!La)break;else{Sa=rb+(c<<2)|0;Oa=sb+(gb<<2)|0;Na=tb+(bb<<2)|0;Ma=Ma+O|0}}break}default:{if(!B)break f;Ma=(Ga|0)>0;bb=e;Na=B;while(1){Na=Na+-1|0;if(!bb)if(Ma){gb=0;do{Oa=C;c=0;while(1){Sa=ca+(c<<2)|0;La=f[Sa>>2]|0;Qa=c<<1;Va=+n[La>>2]*+p[d+(Qa<<3)>>3]+ +p[d+((Qa|1)<<3)>>3];H=~~Va;Pa=H-(+(H|0)>Va&1)|0;if(Pa>>>0>=(f[s+(c<<2)>>2]|0)>>>0){ub=Oa;vb=c;break}f[Sa>>2]=La+(f[eb+(Qa<<2)>>2]<<2);Qa=Oa+(Y(f[t+(c<<2)>>2]|0,Pa)|0)|0;Pa=c+1|0;if((Pa|0)<(i|0)){Oa=Qa;c=Pa}else{ub=Qa;vb=Pa;break}}do if((vb|0)==(i|0))f[ub>>2]=(f[ub>>2]|0)+1;else{if((vb|0)<(i|0))wb=vb;else break;do{c=ca+(wb<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[eb+(wb<<1<<2)>>2]<<2);wb=wb+1|0}while((wb|0)!=(i|0))}while(0);gb=gb+1|0}while((gb|0)!=(Ga|0));xb=0}else xb=0;else if(Ma){gb=0;while(1){h:do if(!(b[bb+gb>>0]|0)){yb=C;zb=0}else{ea=C;c=0;while(1){Oa=ca+(c<<2)|0;Pa=f[Oa>>2]|0;Qa=c<<1;Va=+n[Pa>>2]*+p[d+(Qa<<3)>>3]+ +p[d+((Qa|1)<<3)>>3];La=~~Va;Sa=La-(+(La|0)>Va&1)|0;if(Sa>>>0>=(f[s+(c<<2)>>2]|0)>>>0){yb=ea;zb=c;break h}f[Oa>>2]=Pa+(f[eb+(Qa<<2)>>2]<<2);Qa=ea+(Y(f[t+(c<<2)>>2]|0,Sa)|0)|0;Sa=c+1|0;if((Sa|0)<(i|0)){ea=Qa;c=Sa}else{yb=Qa;zb=Sa;break}}}while(0);do if((zb|0)==(i|0))f[yb>>2]=(f[yb>>2]|0)+1;else{if((zb|0)<(i|0))Ab=zb;else break;do{c=ca+(Ab<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[eb+(Ab<<1<<2)>>2]<<2);Ab=Ab+1|0}while((Ab|0)!=(i|0))}while(0);gb=gb+1|0;if((gb|0)==(Ga|0)){xb=0;break}}}else xb=0;do{gb=ca+(xb<<2)|0;f[gb>>2]=(f[gb>>2]|0)+(f[eb+((xb<<1|1)<<2)>>2]<<2);xb=xb+1|0}while((xb|0)!=(i|0));if(!Na)break;else bb=bb+O|0}}}while(0);break}default:{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;vM(-210,r,269025,269034,918)}}O=r+8|0;f[O>>2]=0;f[O+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=w;dY(x,r,5,1.0,0.0);r=f[A>>2]|0;if(r|0){A=f[F>>2]|0;if((A|0)!=(r|0))f[F>>2]=A+(~((A+-8-r|0)>>>3)<<3);cYc(r)}r=f[z>>2]|0;if(r|0){z=f[g>>2]|0;if((z|0)!=(r|0))f[g>>2]=z+(~((z+-4-r|0)>>>2)<<2);cYc(r)}r=f[y>>2]|0;if(r|0){y=f[o>>2]|0;if((y|0)!=(r|0))f[o>>2]=y+(~((y+-4-r|0)>>>2)<<2);cYc(r)}r=f[$>>2]|0;if(r|0?(y=r+12|0,r=f[y>>2]|0,f[y>>2]=r+-1,(r|0)==1):0)V$(x);f[$>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[T>>2]|0)>0){W=f[ba>>2]|0;ba=0;do{f[W+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[T>>2]|0))}T=f[Z>>2]|0;if((T|0)!=(E|0))wL(T);T=f[aa>>2]|0;if(T|0?(E=T+12|0,T=f[E>>2]|0,f[E>>2]=T+-1,(T|0)==1):0)V$(w);f[aa>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[U>>2]|0)>0){S=f[da>>2]|0;da=0;do{f[S+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[U>>2]|0))}U=f[w+44>>2]|0;if((U|0)!=(w+48|0))wL(U);U=v+36|0;w=f[U>>2]|0;do if(w|0){da=w+12|0;S=f[da>>2]|0;f[da>>2]=S+-1;if((S|0)!=1)break;V$(v)}while(0);f[U>>2]=0;U=v+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[U>>2]|0)>0){G=f[v+40>>2]|0;w=0;do{f[G+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[U>>2]|0))}U=f[v+44>>2]|0;if((U|0)==(v+48|0)){u=q;return}wL(U);u=q;return}function Toa(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0;q=u;u=u+16|0;r=q;s=(d|0)!=0;if(!(s|(c|0)==(g|0))){t=$Xc(48)|0;f[r>>2]=t;f[r+8>>2]=-2147483600;f[r+4>>2]=32;v=t;w=269237;x=v+32|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+32>>0]=0;vM(-215,r,269270,269034,128)}t=f[a+40>>2]|0;y=f[t>>2]|0;f[m>>2]=f[t+4>>2];t=m+4|0;f[t>>2]=y;y=f[a>>2]|0;z=y&7;A=675553809>>>(y<<2&28)&15;y=g+1|0;B=k+4|0;C=f[B>>2]|0;D=f[k>>2]|0;E=C-D>>2;F=D;D=C;if(y>>>0<=E>>>0){if(y>>>0<E>>>0?(C=F+(y<<2)|0,(D|0)!=(C|0)):0)f[B>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else Vba(k,y-E|0);E=y<<1;y=l+4|0;C=f[y>>2]|0;D=f[l>>2]|0;B=C-D>>2;F=D;D=C;if(E>>>0<=B>>>0){if(E>>>0<B>>>0?(C=F+(E<<2)|0,(D|0)!=(C|0)):0)f[y>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else CS(l,E-B|0);B=(g|0)>0;a:do if(B){E=(c|0)>0;if(!s){C=0;D=1;while(1){y=f[a+(C*56|0)>>2]|0;if(y&4088|0){G=22;break}F=f[a+(C*56|0)+40>>2]|0;if(!(((f[F>>2]|0)==(f[t>>2]|0)?(f[F+4>>2]|0)==(f[m>>2]|0):0)&(y&7|0)==(z|0))){G=26;break}F=D&(y&16384|0)!=0;f[(f[k>>2]|0)+(C<<2)>>2]=f[a+(C*56|0)+16>>2];H=(y>>>3&511)+1|0;y=C<<1;I=f[l>>2]|0;f[I+(y<<2)>>2]=H;J=(((f[a+(C*56|0)+48>>2]|0)>>>0)/(A>>>0)|0)-(Y(H,f[m>>2]|0)|0)|0;f[I+((y|1)<<2)>>2]=J;C=C+1|0;if((C|0)>=(g|0)){K=F;break a}else D=F}if((G|0)==22){D=$Xc(32)|0;f[r>>2]=D;f[r+8>>2]=-2147483616;f[r+4>>2]=25;v=D;w=269288;x=v+25|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[D+25>>0]=0;vM(-215,r,269270,269034,143)}else if((G|0)==26){L=$Xc(64)|0;f[r>>2]=L;M=r+8|0;f[M>>2]=-2147483584;N=r+4|0;f[N>>2]=56;v=L;w=269333;x=v+56|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));O=L+56|0;b[O>>0]=0;vM(-215,r,269270,269034,155)}}else{P=0;Q=1}b:while(1){D=f[d+(P<<2)>>2]|0;if((D|0)<=-1){G=23;break}if(E){R=0;S=D}else{G=24;break}while(1){T=f[a+(R*56|0)>>2]|0;U=T>>>3&511;if((S|0)<=(U|0))break;D=R+1|0;if((D|0)<(c|0)){R=D;S=S+-1-U|0}else{G=24;break b}}D=f[a+(R*56|0)+40>>2]|0;if(!(((f[D>>2]|0)==(f[t>>2]|0)?(f[D+4>>2]|0)==(f[m>>2]|0):0)&(T&7|0)==(z|0))){G=26;break}D=Q&(T&16384|0)!=0;C=(f[a+(R*56|0)+16>>2]|0)+(Y(S,A)|0)|0;f[(f[k>>2]|0)+(P<<2)>>2]=C;C=U+1|0;F=P<<1;J=f[l>>2]|0;f[J+(F<<2)>>2]=C;y=(((f[a+(R*56|0)+48>>2]|0)>>>0)/(A>>>0)|0)-(Y(C,f[m>>2]|0)|0)|0;f[J+((F|1)<<2)>>2]=y;P=P+1|0;if((P|0)>=(g|0)){K=D;break a}else Q=D}if((G|0)==23){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;b[r+11>>0]=6;b[r>>0]=b[269314]|0;b[r+1>>0]=b[269315]|0;b[r+2>>0]=b[269316]|0;b[r+3>>0]=b[269317]|0;b[r+4>>0]=b[269318]|0;b[r+5>>0]=b[269319]|0;b[r+6>>0]=0;vM(-215,r,269270,269034,148)}else if((G|0)==24){E=$Xc(16)|0;f[r>>2]=E;f[r+8>>2]=-2147483632;f[r+4>>2]=11;v=E;w=269321;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[E+11>>0]=0;vM(-215,r,269270,269034,152)}else if((G|0)==26){L=$Xc(64)|0;f[r>>2]=L;M=r+8|0;f[M>>2]=-2147483584;N=r+4|0;f[N>>2]=56;v=L;w=269333;x=v+56|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));O=L+56|0;b[O>>0]=0;vM(-215,r,269270,269034,155)}}else K=1;while(0);O=f[e+16>>2]|0;L=O;do if(!O){if(K)G=40}else{N=f[e+4>>2]|0;if((N|0)<3)V=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{M=f[e+40>>2]|0;Q=0;P=1;while(1){A=Y(f[M+(Q<<2)>>2]|0,P)|0;Q=Q+1|0;if((Q|0)==(N|0)){V=A;break}else P=A}}if((N|0)==0|(V|0)==0)if(K){G=40;break}else break;P=f[e+40>>2]|0;if(!((f[P>>2]|0)==(f[t>>2]|0)?(f[P+4>>2]|0)==(f[m>>2]|0):0)){W=$Xc(48)|0;f[r>>2]=W;X=r+8|0;f[X>>2]=-2147483600;Z=r+4|0;f[Z>>2]=45;v=W;w=269390;x=v+45|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));_=W+45|0;b[_>>0]=0;vM(-215,r,269270,269034,165)}N=f[e>>2]|0;if(!(N&4088)){f[(f[k>>2]|0)+(g<<2)>>2]=L;P=g<<1;Q=f[l>>2]|0;f[Q+(P<<2)>>2]=1;f[Q+((P|1)<<2)>>2]=((f[e+48>>2]|0)>>>0)/((675553809>>>(f[e>>2]<<2&28)&15)>>>0)|0;if(K&(N&16384|0)!=0){G=40;break}else break}else{W=$Xc(48)|0;f[r>>2]=W;X=r+8|0;f[X>>2]=-2147483600;Z=r+4|0;f[Z>>2]=45;v=W;w=269390;x=v+45|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));_=W+45|0;b[_>>0]=0;vM(-215,r,269270,269034,165)}}while(0);if((G|0)==40){_=Y(f[m>>2]|0,f[t>>2]|0)|0;f[m>>2]=_;f[t>>2]=1}if(!i){if(z|0){z=$Xc(16)|0;f[r>>2]=z;f[r+8>>2]=-2147483632;f[r+4>>2]=14;v=z;w=473858;x=v+14|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[z+14>>0]=0;vM(-215,r,269270,269034,180)}z=g<<1;t=o+4|0;_=f[t>>2]|0;m=f[o>>2]|0;W=_-m>>3;Z=m;m=_;if(z>>>0<=W>>>0){if(z>>>0<W>>>0?(_=Z+(z<<3)|0,(m|0)!=(_|0)):0)f[t>>2]=m+(~((m+-8-_|0)>>>3)<<3)}else Voa(o,z-W|0);if(!B){u=q;return}W=f[o>>2]|0;z=0;do{_=z<<1;p[W+(_<<3)>>3]=+(f[h+(z<<2)>>2]|0)*.00390625;p[W+((_|1)<<3)>>3]=0.0;z=z+1|0}while((z|0)!=(g|0));u=q;return}if(!j){if(B)$=0;else{u=q;return}c:while(1){j=f[h+($<<2)>>2]|0;z=i+($<<2)|0;W=0;while(1){if(W>>>0>=j>>>0)break;_=f[z>>2]|0;m=W;W=W+1|0;if(!(+n[_+(m<<2)>>2]<+n[_+(W<<2)>>2])){G=69;break c}}$=$+1|0;if(($|0)>=(g|0)){G=70;break}}if((G|0)==69){$=$Xc(32)|0;f[r>>2]=$;f[r+8>>2]=-2147483616;f[r+4>>2]=29;v=$;w=269477;x=v+29|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[$+29>>0]=0;vM(-215,r,269270,269034,207)}else if((G|0)==70){u=q;return}}$=g<<1;W=o+4|0;z=f[W>>2]|0;j=f[o>>2]|0;_=z-j>>3;m=j;j=z;if($>>>0<=_>>>0){if($>>>0<_>>>0?(z=m+($<<3)|0,(j|0)!=(z|0)):0)f[W>>2]=j+(~((j+-8-z|0)>>>3)<<3)}else Voa(o,$-_|0);if(!B){u=q;return}B=f[o>>2]|0;o=0;while(1){_=f[i+(o<<2)>>2]|0;if(!_){G=63;break}aa=+n[_>>2];ba=+n[_+4>>2];if(!(aa<ba)){G=63;break}ca=aa;aa=+(f[h+(o<<2)>>2]|0)/(ba-ca);_=o<<1;p[B+(_<<3)>>3]=aa;p[B+((_|1)<<3)>>3]=-(ca*aa);o=o+1|0;if((o|0)>=(g|0)){G=70;break}}if((G|0)==63){g=$Xc(48)|0;f[r>>2]=g;f[r+8>>2]=-2147483600;f[r+4>>2]=40;v=g;w=269436;x=v+40|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[g+40>>0]=0;vM(-215,r,269270,269034,194)}else if((G|0)==70){u=q;return}}function Uoa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+16|0;l=k;m=d<<8;o=j+4|0;q=f[o>>2]|0;r=f[j>>2]|0;s=q-r>>2;t=r;r=q;if(m>>>0<=s>>>0)if(m>>>0<s>>>0?(q=t+(m<<2)|0,(r|0)!=(q|0)):0){f[o>>2]=r+(~((r+-4-q|0)>>>2)<<2);v=t}else v=t;else{oaa(j,m-s|0);v=f[j>>2]|0}if(h){if((d|0)<=0){u=k;return}h=f[c+4>>2]|0;j=(h|0)==0;s=f[a+40>>2]|0;m=f[a+44>>2]|0;if(i)w=0;else{t=0;do{q=t<<1;x=+p[g+(q<<3)>>3];y=+p[g+((q|1)<<3)>>3];q=f[s+(t<<2)>>2]|0;r=f[m+(t<<2)>>2]|0;o=t<<8;z=0;do{A=y+x*+(z|0);B=~~A;C=B-(+(B|0)>A&1)|0;B=Y(C,r)|0;f[v+(z+o<<2)>>2]=C>>>0<q>>>0?B:1073741824;z=z+1|0}while((z|0)!=256);t=t+1|0}while((t|0)!=(d|0));u=k;return}do{t=w<<1;x=+p[g+(t<<3)>>3];y=+p[g+((t|1)<<3)>>3];if(j)D=0;else D=f[h+48+(w<<2)>>2]|0;t=w<<8;m=0;do{A=y+x*+(m|0);s=~~A;z=s-(+(s|0)>A&1)|0;f[v+(m+t<<2)>>2]=z>>>0<D>>>0?z:1073741824;m=m+1|0}while((m|0)!=256);w=w+1|0}while((w|0)!=(d|0));u=k;return}if(!e){w=$Xc(64)|0;f[l>>2]=w;f[l+8>>2]=-2147483584;f[l+4>>2]=55;D=w;h=269147;j=D+55|0;do{b[D>>0]=b[h>>0]|0;D=D+1|0;h=h+1|0}while((D|0)<(j|0));b[w+55>>0]=0;vM(-5,l,269213,269034,116)}if((d|0)<=0){u=k;return}l=f[c+4>>2]|0;c=(l|0)==0;w=f[a+40>>2]|0;h=f[a+44>>2]|0;if(i)E=0;else{i=0;do{a=f[e+(i<<2)>>2]|0;x=+n[a>>2];D=~~x;j=(+(D|0)<x&1)+D|0;D=f[w+(i<<2)>>2]|0;g=f[h+(i<<2)>>2]|0;m=i<<8;t=1073741824;z=(j|0)<256?j:256;j=-1;s=0;while(1){if((s|0)<(z|0)){q=s;do{f[v+(q+m<<2)>>2]=t;q=q+1|0}while((q|0)!=(z|0));F=z}else F=s;q=j+1|0;if(q>>>0>=D>>>0)break;x=+n[a+(j+2<<2)>>2];o=~~x;r=(+(o|0)<x&1)+o|0;t=Y(q,g)|0;z=(r|0)<256?r:256;j=q;s=F}if((F|0)<256){s=F;do{f[v+(s+m<<2)>>2]=1073741824;s=s+1|0}while((s|0)!=256)}i=i+1|0}while((i|0)!=(d|0));u=k;return}do{i=f[e+(E<<2)>>2]|0;x=+n[i>>2];F=~~x;h=(+(F|0)<x&1)+F|0;if(c)G=0;else G=f[l+48+(E<<2)>>2]|0;F=E<<8;w=1073741824;s=(h|0)<256?h:256;h=-1;m=0;while(1){if((m|0)<(s|0)){j=m;do{f[v+(j+F<<2)>>2]=w;j=j+1|0}while((j|0)!=(s|0));H=s}else H=m;j=h+1|0;if(j>>>0>=G>>>0)break;x=+n[i+(h+2<<2)>>2];z=~~x;g=(+(z|0)<x&1)+z|0;w=j;s=(g|0)<256?g:256;h=j;m=H}if((H|0)<256){m=H;do{f[v+(m+F<<2)>>2]=1073741824;m=m+1|0}while((m|0)!=256)}E=E+1|0}while((E|0)!=(d|0));u=k;return}function Voa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){g1c(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)kWc(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=af(8)|0;hYc(d,512536);f[d>>2]=192348;ig(d|0,25336,2140)}else{m=$Xc(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;g1c(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;cYc(h);return}function Woa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;j=u;u=u+1648|0;k=j+1520|0;l=j+56|0;m=j;n=(f[g+4>>2]|0)-(f[g>>2]|0)|0;o=n>>2;p=(f[h+4>>2]|0)-(f[h>>2]|0)|0;q=p>>2;r=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;s=pS(a,-1)|0;if(!((n|0)>0&(s|0)>0)){t=$Xc(32)|0;f[k>>2]=t;f[k+8>>2]=-2147483616;f[k+4>>2]=23;v=t;w=269507;x=v+23|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[t+23>>0]=0;vM(-215,k,269025,269034,1200)}if((q|0)!=(n>>>1|0)){if(q|0){y=$Xc(64)|0;f[k>>2]=y;z=k+8|0;f[z>>2]=-2147483584;A=k+4|0;f[A>>2]=55;v=y;w=269531;x=v+55|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));B=y+55|0;b[B>>0]=0;vM(-215,k,269025,269034,1201)}if(qS(a,0)|0){y=$Xc(64)|0;f[k>>2]=y;z=k+8|0;f[z>>2]=-2147483584;A=k+4|0;f[A>>2]=55;v=y;w=269531;x=v+55|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));B=y+55|0;b[B>>0]=0;vM(-215,k,269025,269034,1201)}}B=(r|0)==0;if(!(B|(r|0)==(o|0))){r=$Xc(32)|0;f[k>>2]=r;f[k+8>>2]=-2147483616;f[k+4>>2]=23;v=r;w=269587;x=v+23|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[r+23>>0]=0;vM(-215,k,269025,269034,1202)}if((p|0)>0?(r=(q|0)/2|0,(p|0)>4):0){p=f[h>>2]|0;h=0;do{f[k+(h<<2)>>2]=p+(h<<1<<2);h=h+1|0}while((h|0)<(r|0))}i1(l,s);r=m+4|0;h=m+8|0;p=m+12|0;w=m+16|0;y=m+20|0;A=m+24|0;z=m+28|0;n=m+32|0;t=m+36|0;C=m+40|0;D=m+48|0;E=m+44|0;F=m+44|0;G=0;do{bS(m,a,G);H=f[l>>2]|0;I=H+(G*56|0)|0;if((I|0)==(m|0)){J=f[t>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)V$(m)}else{J=H+(G*56|0)+36|0;K=f[J>>2]|0;if(K|0?(L=K+12|0,K=f[L>>2]|0,f[L>>2]=K+-1,(K|0)==1):0)V$(I);f[J>>2]=0;K=H+(G*56|0)+16|0;L=H+(G*56|0)+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[L>>2]|0)>0){M=f[H+(G*56|0)+40>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[L>>2]|0))}f[I>>2]=f[m>>2];f[L>>2]=f[r>>2];N=H+(G*56|0)+8|0;f[N>>2]=f[h>>2];f[H+(G*56|0)+12>>2]=f[p>>2];f[K>>2]=f[w>>2];f[H+(G*56|0)+20>>2]=f[y>>2];f[H+(G*56|0)+24>>2]=f[A>>2];f[H+(G*56|0)+28>>2]=f[z>>2];f[H+(G*56|0)+32>>2]=f[n>>2];f[J>>2]=f[t>>2];M=H+(G*56|0)+44|0;O=f[M>>2]|0;P=H+(G*56|0)+48|0;if((O|0)==(P|0))Q=O;else{wL(O);f[M>>2]=P;f[H+(G*56|0)+40>>2]=N;Q=P}if((f[r>>2]|0)<3){P=f[F>>2]|0;f[Q>>2]=f[P>>2];f[Q+4>>2]=f[P+4>>2]}else{f[M>>2]=f[F>>2];f[H+(G*56|0)+40>>2]=f[C>>2];f[F>>2]=D;f[C>>2]=h}f[m>>2]=1124007936;v=r;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0))}f[t>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[r>>2]|0)>0){H=f[C>>2]|0;J=0;do{f[H+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[r>>2]|0))}J=f[E>>2]|0;if((J|0)!=(D|0))wL(J);G=G+1|0}while((G|0)<(s|0));Soa(f[l>>2]|0,s,B?0:f[c>>2]|0,d,e,o,f[g>>2]|0,q|0?k:0,1,i);j1(l);i=l+8|0;k=l+1464|0;do{l=k;k=k+-56|0;q=l+-20|0;g=f[q>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)V$(k);f[q>>2]=0;q=l+-40|0;g=l+-52|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[g>>2]|0)>0){q=f[l+-16>>2]|0;o=0;do{f[q+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[g>>2]|0))}g=f[l+-12>>2]|0;if((g|0)!=(l+-8|0))wL(g)}while((k|0)!=(i|0));u=j;return}function Xoa(a,c,e,g,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=+l;m=m|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0,Xa=0;o=u;u=u+688|0;q=o+552|0;r=o+296|0;s=o+168|0;t=o+104|0;v=o+88|0;w=o+76|0;x=o+64|0;y=o+56|0;z=o+160|0;A=o;do if((eS(g)|0)==65536){B=f[g+4>>2]|0;f[t>>2]=f[B>>2];C=t+4|0;D=B+4|0;f[C>>2]=f[D>>2];E=t+8|0;f[E>>2]=f[B+8>>2];f[t+12>>2]=f[B+12>>2];f[t+16>>2]=f[B+16>>2];f[t+20>>2]=f[B+20>>2];f[t+24>>2]=f[B+24>>2];f[t+28>>2]=f[B+28>>2];f[t+32>>2]=f[B+32>>2];F=f[B+36>>2]|0;f[t+36>>2]=F;f[t+40>>2]=E;E=t+48|0;G=t+44|0;f[G>>2]=E;f[E>>2]=0;f[t+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[B+44>>2]|0;E=f[G>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];H=C;break}else{f[C>>2]=0;U$(t,B);H=C;break}}else{bS(t,g,-1);H=t+4|0}while(0);f[v>>2]=0;g=v+4|0;f[g>>2]=0;f[v+8>>2]=0;f[w>>2]=0;C=w+4|0;f[C>>2]=0;f[w+8>>2]=0;f[x>>2]=0;B=x+4|0;f[B>>2]=0;f[x+8>>2]=0;f[y>>2]=0;D=y+4|0;f[D>>2]=0;E=f[H>>2]|0;if((E|0)!=2)if((E|0)>0)I=E;else{f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;J=$Xc(32)|0;f[q>>2]=J;K=q+8|0;f[K>>2]=-2147483616;L=q+4|0;f[L>>2]=25;M=J;N=269611;O=M+25|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));P=J+25|0;b[P>>0]=0;vM(-215,q,269637,269034,1531)}else I=(f[(f[t+40>>2]|0)+4>>2]|0)==1?1:2;G=t+16|0;if(!(f[G>>2]|0)){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;J=$Xc(32)|0;f[q>>2]=J;K=q+8|0;f[K>>2]=-2147483616;L=q+4|0;f[L>>2]=25;M=J;N=269611;O=M+25|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));P=J+25|0;b[P>>0]=0;vM(-215,q,269637,269034,1531)}if((E|0)<3)Q=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{F=f[t+40>>2]|0;R=0;S=1;while(1){T=Y(f[F+(R<<2)>>2]|0,S)|0;R=R+1|0;if((R|0)==(E|0)){Q=T;break}else S=T}}if((E|0)==0|(Q|0)==0){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;J=$Xc(32)|0;f[q>>2]=J;K=q+8|0;f[K>>2]=-2147483616;L=q+4|0;f[L>>2]=25;M=J;N=269611;O=M+25|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));P=J+25|0;b[P>>0]=0;vM(-215,q,269637,269034,1531)}P=f[a+40>>2]|0;J=f[P>>2]|0;f[z>>2]=f[P+4>>2];f[z+4>>2]=J;wS(i,z,f[a>>2]&7,-1,0,0);do if((eS(i)|0)==65536){z=f[i+4>>2]|0;f[A>>2]=f[z>>2];J=A+4|0;P=z+4|0;f[J>>2]=f[P>>2];L=A+8|0;f[L>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];f[A+32>>2]=f[z+32>>2];K=f[z+36>>2]|0;f[A+36>>2]=K;f[A+40>>2]=L;L=A+48|0;Q=A+44|0;f[Q>>2]=L;f[L>>2]=0;f[A+52>>2]=0;if(K|0){L=K+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[P>>2]|0)<3){P=f[z+44>>2]|0;L=f[Q>>2]|0;f[L>>2]=f[P>>2];f[L+4>>2]=f[P+4>>2];break}else{f[J>>2]=0;U$(A,z);break}}else bS(A,i,-1);while(0);i=t+40|0;Toa(a,c,e,A,I,f[i>>2]|0,k,m,v,w,y,x);e=m?f[x>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[y>>2]|0;c=f[D>>2]|0;U=l;z=f[v>>2]|0;J=f[w>>2]|0;P=f[G>>2]|0;L=f[z+(I<<2)>>2]|0;Q=f[J+((I<<1|1)<<2)>>2]|0;f[q>>2]=0;K=q+4|0;f[K>>2]=0;f[q+8>>2]=0;f[r>>2]=1123876864;f[r+4>>2]=0;Uoa(t,r,I,k,e,m,0,q);E=f[q>>2]|0;a:do switch(I|0){case 1:{S=f[J>>2]|0;R=f[J+4>>2]|0;g1c(r|0,0,256)|0;F=f[z>>2]|0;T=0;do{V=f[E+(T<<2)>>2]|0;if(V>>>0<1073741824){W=ALc(U*+n[P+V>>2])|0;b[r+T>>0]=W>>>0<256?W:(W|0)>0?255:0}T=T+1|0}while((T|0)!=256);T=c+-1|0;b:do if(c|0){W=S<<1;V=(a|0)<4;X=a+-4|0;if((S|0)==1){if(V){Z=(a|0)>0;_=L;$=F;aa=T;while(1){if(Z){ba=0;ca=$;while(1){b[_+ba>>0]=b[r+(h[ca>>0]|0)>>0]|0;ba=ba+1|0;if((ba|0)==(a|0))break;else ca=ca+1|0}da=$+a|0}else da=$;if(!aa)break b;else{_=_+Q|0;$=da+R|0;aa=aa+-1|0}}}aa=a&-4;$=(aa|0)<(a|0);_=L;Z=F;ca=T;while(1){ba=0;ea=Z;while(1){fa=ba|1;ga=b[r+(h[Z+fa>>0]|0)>>0]|0;b[_+ba>>0]=b[r+(h[ea>>0]|0)>>0]|0;b[_+fa>>0]=ga;ga=ba|2;fa=ba|3;ha=b[r+(h[Z+fa>>0]|0)>>0]|0;b[_+ga>>0]=b[r+(h[Z+ga>>0]|0)>>0]|0;b[_+fa>>0]=ha;ha=ba+4|0;if((ha|0)>(X|0))break;else{ba=ha;ea=Z+ha|0}}if($){ea=aa;ba=Z+aa|0;while(1){b[_+ea>>0]=b[r+(h[ba>>0]|0)>>0]|0;ea=ea+1|0;if((ea|0)==(a|0)){ia=a;break}else ba=ba+1|0}}else ia=aa;if(!ca)break;else{_=_+Q|0;Z=Z+ia+R|0;ca=ca+-1|0}}}else{if(V){ca=Y(a,S)|0;Z=(a|0)>0;_=L;aa=F;$=T;while(1){if(Z){ba=0;ea=aa;while(1){b[_+ba>>0]=b[r+(h[ea>>0]|0)>>0]|0;ba=ba+1|0;if((ba|0)==(a|0))break;else ea=ea+S|0}ja=aa+ca|0}else ja=aa;if(!$)break b;else{_=_+Q|0;aa=ja+R|0;$=$+-1|0}}}$=a&-4;aa=Y(S,$)|0;_=Y(a,S)|0;ca=($|0)<(a|0);Z=L;V=F;ea=T;while(1){ba=0;ha=V;while(1){fa=b[r+(h[ha+S>>0]|0)>>0]|0;b[Z+ba>>0]=b[r+(h[ha>>0]|0)>>0]|0;b[Z+(ba|1)>>0]=fa;fa=ha+W|0;ga=b[r+(h[fa+S>>0]|0)>>0]|0;b[Z+(ba|2)>>0]=b[r+(h[fa>>0]|0)>>0]|0;b[Z+(ba|3)>>0]=ga;ba=ba+4|0;if((ba|0)>(X|0))break;else ha=fa+W|0}if(ca){ha=$;ba=V+aa|0;while(1){b[Z+ha>>0]=b[r+(h[ba>>0]|0)>>0]|0;ha=ha+1|0;if((ha|0)==(a|0)){ka=_;break}else ba=ba+S|0}}else ka=aa;if(!ea)break;else{Z=Z+Q|0;V=V+ka+R|0;ea=ea+-1|0}}}}while(0);break}case 2:{R=f[J>>2]|0;S=f[J+4>>2]|0;T=f[J+8>>2]|0;F=f[J+12>>2]|0;if((c|0)!=0&(a|0)>0){ea=Y(a,R)|0;V=Y(a,T)|0;Z=f[z>>2]|0;aa=f[z+4>>2]|0;_=L;$=c;while(1){ca=Z+ea|0;W=Z;X=aa;ba=0;while(1){ha=(f[E+((h[X>>0]|0|256)<<2)>>2]|0)+(f[E+((h[W>>0]|0)<<2)>>2]|0)|0;if(ha>>>0<1073741824){fa=ALc(U*+n[P+ha>>2])|0;la=(fa>>>0<256?fa:(fa|0)>0?255:0)&255}else la=0;b[_+ba>>0]=la;ba=ba+1|0;if((ba|0)==(a|0))break;else{W=W+R|0;X=X+T|0}}$=$+-1|0;if(!$)break;else{Z=ca+S|0;aa=aa+V+F|0;_=_+Q|0}}}break}case 3:{_=f[J>>2]|0;F=f[J+4>>2]|0;V=f[J+8>>2]|0;aa=f[J+12>>2]|0;S=f[J+16>>2]|0;Z=f[J+20>>2]|0;if((c|0)!=0&(a|0)>0){$=Y(a,_)|0;T=Y(a,V)|0;R=Y(a,S)|0;ea=f[z+8>>2]|0;X=f[z+4>>2]|0;W=f[z>>2]|0;ba=L;fa=c;while(1){fa=fa+-1|0;ha=X+T|0;ga=ea;ma=X;na=W;oa=0;while(1){pa=(f[E+((h[ma>>0]|0|256)<<2)>>2]|0)+(f[E+((h[na>>0]|0)<<2)>>2]|0)+(f[E+((h[ga>>0]|0|512)<<2)>>2]|0)|0;if(pa>>>0<1073741824){qa=ALc(U*+n[P+pa>>2])|0;ra=(qa>>>0<256?qa:(qa|0)>0?255:0)&255}else ra=0;b[ba+oa>>0]=ra;oa=oa+1|0;if((oa|0)==(a|0))break;else{ga=ga+S|0;ma=ma+V|0;na=na+_|0}}if(!fa)break;else{ea=ea+R+Z|0;X=ha+aa|0;W=W+$+F|0;ba=ba+Q|0}}}break}default:if(c|0){if((a|0)>0){sa=L;ta=c}else{ba=c;while(1){F=0;do{$=z+(F<<2)|0;f[$>>2]=(f[$>>2]|0)+(f[J+((F<<1|1)<<2)>>2]|0);F=F+1|0}while((F|0)!=(I|0));ba=ba+-1|0;if(!ba)break a}}while(1){ba=0;do{F=P;ha=0;while(1){$=z+(ha<<2)|0;W=f[$>>2]|0;aa=f[E+((h[W>>0]|0|ha<<8)<<2)>>2]|0;if(aa>>>0>1073741823){ua=F;va=ha;break}X=F+aa|0;f[$>>2]=W+(f[J+(ha<<1<<2)>>2]|0);W=ha+1|0;if((W|0)<(I|0)){F=X;ha=W}else{ua=X;va=W;break}}if((va|0)!=(I|0)){b[sa+ba>>0]=0;if((va|0)<(I|0)){ha=va;do{F=z+(ha<<2)|0;f[F>>2]=(f[F>>2]|0)+(f[J+(ha<<1<<2)>>2]|0);ha=ha+1|0}while((ha|0)!=(I|0))}}else{ha=ALc(U*+n[ua>>2])|0;b[sa+ba>>0]=ha>>>0<256?ha:(ha|0)>0?255:0}ba=ba+1|0}while((ba|0)!=(a|0));wa=0;do{ba=z+(wa<<2)|0;f[ba>>2]=(f[ba>>2]|0)+(f[J+((wa<<1|1)<<2)>>2]|0);wa=wa+1|0}while((wa|0)!=(I|0));ta=ta+-1|0;if(!ta)break;else sa=sa+Q|0}}}while(0);Q=f[q>>2]|0;if(Q|0){sa=f[K>>2]|0;if((sa|0)!=(Q|0))f[K>>2]=sa+(~((sa+-4-Q|0)>>>2)<<2);cYc(Q)}break}case 2:{Q=f[y>>2]|0;sa=f[D>>2]|0;U=l;K=f[v>>2]|0;ta=f[w>>2]|0;wa=f[G>>2]|0;J=f[K+(I<<2)>>2]|0;z=f[ta+((I<<1|1)<<2)>>2]|0;a=I<<2;ua=f[t+44>>2]|0;o1c(r|0,f[i>>2]|0,a|0)|0;o1c(s|0,ua|0,a|0)|0;c:do if(!m){if(!k){ua=$Xc(64)|0;f[q>>2]=ua;f[q+8>>2]=-2147483584;f[q+4>>2]=55;M=ua;N=269147;O=M+55|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[ua+55>>0]=0;vM(-5,q,269653,269034,1389)}o1c(q|0,k|0,a|0)|0;if(sa|0){va=(Q|0)>0;E=J;P=sa;while(1){P=P+-1|0;if(va){c=0;do{L=wa;ra=0;while(1){la=K+(ra<<2)|0;ka=f[la>>2]|0;xa=+(j[ka>>1]|0);ja=f[q+(ra<<2)>>2]|0;ia=f[r+(ra<<2)>>2]|0;da=-1;while(1){ba=da+1|0;if(!(xa>=+n[ja+(ba<<2)>>2])){ya=da;break}if((ba|0)<(ia|0))da=ba;else{ya=ba;break}}if(ya>>>0>=ia>>>0){za=L;Aa=ra;break}f[la>>2]=ka+(f[ta+(ra<<1<<2)>>2]<<1);da=L+(Y(f[s+(ra<<2)>>2]|0,ya)|0)|0;ja=ra+1|0;if((ja|0)<(I|0)){L=da;ra=ja}else{za=da;Aa=ja;break}}if((Aa|0)!=(I|0)){d[E+(c<<1)>>1]=0;if((Aa|0)<(I|0)){ra=Aa;do{L=K+(ra<<2)|0;f[L>>2]=(f[L>>2]|0)+(f[ta+(ra<<1<<2)>>2]<<1);ra=ra+1|0}while((ra|0)!=(I|0))}}else{ra=ALc(U*+n[za>>2])|0;d[E+(c<<1)>>1]=ra>>>0<65536?ra:(ra|0)>0?65535:0}c=c+1|0}while((c|0)!=(Q|0));Ba=0}else Ba=0;do{c=K+(Ba<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[ta+((Ba<<1|1)<<2)>>2]<<1);Ba=Ba+1|0}while((Ba|0)!=(I|0));if(!P)break;else E=E+(z<<1)|0}}}else switch(I|0){case 1:{xa=+p[e>>3];Ca=+p[e+8>>3];E=f[r>>2]|0;P=f[ta>>2]|0;va=f[ta+4>>2]|0;if(!sa)break c;if((Q|0)<=0)break c;ua=Y(Q,P)|0;c=J;ra=f[K>>2]|0;L=sa;while(1){L=L+-1|0;ja=0;da=ra;while(1){Da=Ca+xa*+(j[da>>1]|0);ba=~~Da;ha=ba-(+(ba|0)>Da&1)|0;if(ha>>>0<E>>>0){ba=ALc(U*+n[wa+(ha<<2)>>2])|0;Ea=(ba>>>0<65536?ba:(ba|0)>0?65535:0)&65535}else Ea=0;d[c+(ja<<1)>>1]=Ea;ja=ja+1|0;if((ja|0)==(Q|0))break;else da=da+(P<<1)|0}if(!L)break;else{c=c+(z<<1)|0;ra=ra+(ua<<1)+(va<<1)|0}}break}case 2:{xa=+p[e>>3];Ca=+p[e+8>>3];Da=+p[e+16>>3];Fa=+p[e+24>>3];va=f[r>>2]|0;ua=f[r+4>>2]|0;ra=f[ta>>2]|0;c=f[ta+4>>2]|0;L=f[ta+8>>2]|0;P=f[ta+12>>2]|0;E=f[s>>2]|0;if(!((Q|0)>0&(sa|0)!=0))break c;da=Y(Q,ra)|0;ja=Y(Q,L)|0;ba=f[K>>2]|0;ha=f[K+4>>2]|0;F=J;W=sa;while(1){X=ba+(da<<1)|0;$=0;aa=ba;Z=ha;while(1){Ga=Ca+xa*+(j[aa>>1]|0);R=~~Ga;ea=R-(+(R|0)>Ga&1)|0;Ga=Fa+Da*+(j[Z>>1]|0);R=~~Ga;fa=R-(+(R|0)>Ga&1)|0;if(ea>>>0<va>>>0&fa>>>0<ua>>>0){R=wa+(Y(ea,E)|0)+(fa<<2)|0;fa=ALc(U*+n[R>>2])|0;Ha=(fa>>>0<65536?fa:(fa|0)>0?65535:0)&65535}else Ha=0;d[F+($<<1)>>1]=Ha;$=$+1|0;if(($|0)==(Q|0))break;else{aa=aa+(ra<<1)|0;Z=Z+(L<<1)|0}}W=W+-1|0;if(!W)break;else{ba=X+(c<<1)|0;ha=ha+(ja<<1)+(P<<1)|0;F=F+(z<<1)|0}}break}case 3:{Da=+p[e>>3];Fa=+p[e+8>>3];xa=+p[e+16>>3];Ca=+p[e+24>>3];Ga=+p[e+32>>3];Ia=+p[e+40>>3];F=f[r>>2]|0;P=f[r+4>>2]|0;ja=f[r+8>>2]|0;ha=f[ta>>2]|0;c=f[ta+4>>2]|0;ba=f[ta+8>>2]|0;W=f[ta+12>>2]|0;L=f[ta+16>>2]|0;ra=f[ta+20>>2]|0;E=f[s>>2]|0;ua=f[s+4>>2]|0;if(!((Q|0)>0&(sa|0)!=0))break c;va=Y(Q,ha)|0;da=Y(Q,ba)|0;Z=Y(Q,L)|0;aa=f[K>>2]|0;$=f[K+4>>2]|0;fa=f[K+8>>2]|0;R=J;ea=sa;while(1){ea=ea+-1|0;_=$+(da<<1)|0;V=aa;S=$;T=fa;na=0;while(1){Ja=Fa+Da*+(j[V>>1]|0);ma=~~Ja;ga=ma-(+(ma|0)>Ja&1)|0;Ja=Ca+xa*+(j[S>>1]|0);ma=~~Ja;oa=ma-(+(ma|0)>Ja&1)|0;Ja=Ia+Ga*+(j[T>>1]|0);ma=~~Ja;ca=ma-(+(ma|0)>Ja&1)|0;if(ga>>>0<F>>>0&oa>>>0<P>>>0&ca>>>0<ja>>>0){ma=wa+(Y(ga,E)|0)+(Y(oa,ua)|0)+(ca<<2)|0;ca=ALc(U*+n[ma>>2])|0;Ka=(ca>>>0<65536?ca:(ca|0)>0?65535:0)&65535}else Ka=0;d[R+(na<<1)>>1]=Ka;na=na+1|0;if((na|0)==(Q|0))break;else{V=V+(ha<<1)|0;S=S+(ba<<1)|0;T=T+(L<<1)|0}}if(!ea)break;else{aa=aa+(va<<1)+(c<<1)|0;$=_+(W<<1)|0;fa=fa+(Z<<1)+(ra<<1)|0;R=R+(z<<1)|0}}break}default:{if(!sa)break c;R=(k|0)==0;ra=(Q|0)>0;Z=J;fa=sa;while(1){fa=fa+-1|0;if(ra){W=0;while(1){d:do if(R){$=wa;c=0;while(1){va=K+(c<<2)|0;aa=f[va>>2]|0;ea=c<<1;Ga=+(j[aa>>1]|0)*+p[e+(ea<<3)>>3]+ +p[e+((ea|1)<<3)>>3];L=~~Ga;ba=L-(+(L|0)>Ga&1)|0;if(ba>>>0>=(f[r+(c<<2)>>2]|0)>>>0){La=$;Ma=c;break d}f[va>>2]=aa+(f[ta+(ea<<2)>>2]<<1);ea=$+(Y(f[s+(c<<2)>>2]|0,ba)|0)|0;ba=c+1|0;if((ba|0)<(I|0)){$=ea;c=ba}else{La=ea;Ma=ba;break}}}else{c=wa;$=0;while(1){ka=K+($<<2)|0;la=f[ka>>2]|0;ia=d[la>>1]|0;ba=$<<1;Ga=+(ia&65535)*+p[e+(ba<<3)>>3]+ +p[e+((ba|1)<<3)>>3];ea=~~Ga;aa=ea-(+(ea|0)>Ga&1)|0;if(aa>>>0>=(f[r+($<<2)>>2]|0)>>>0){La=c;Ma=$;break d}if(+(ia&65535)>=+n[(f[k+($<<2)>>2]|0)+4>>2]){La=c;Ma=$;break d}f[ka>>2]=la+(f[ta+(ba<<2)>>2]<<1);ba=c+(Y(f[s+($<<2)>>2]|0,aa)|0)|0;aa=$+1|0;if((aa|0)<(I|0)){c=ba;$=aa}else{La=ba;Ma=aa;break}}}while(0);if((Ma|0)!=(I|0)){d[Z+(W<<1)>>1]=0;if((Ma|0)<(I|0)){$=Ma;do{c=K+($<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[ta+($<<1<<2)>>2]<<1);$=$+1|0}while(($|0)!=(I|0))}}else{$=ALc(U*+n[La>>2])|0;d[Z+(W<<1)>>1]=$>>>0<65536?$:($|0)>0?65535:0}W=W+1|0;if((W|0)==(Q|0)){Na=0;break}}}else Na=0;do{W=K+(Na<<2)|0;f[W>>2]=(f[W>>2]|0)+(f[ta+((Na<<1|1)<<2)>>2]<<1);Na=Na+1|0}while((Na|0)!=(I|0));if(!fa)break;else Z=Z+(z<<1)|0}}}while(0);break}case 5:{z=f[y>>2]|0;y=f[D>>2]|0;U=l;D=f[v>>2]|0;Na=f[w>>2]|0;ta=f[G>>2]|0;K=f[D+(I<<2)>>2]|0;Q=f[Na+((I<<1|1)<<2)>>2]|0;La=I<<2;Ma=f[t+44>>2]|0;o1c(r|0,f[i>>2]|0,La|0)|0;o1c(s|0,Ma|0,La|0)|0;e:do if(!m){if(!k){Ma=$Xc(64)|0;f[q>>2]=Ma;f[q+8>>2]=-2147483584;f[q+4>>2]=55;M=Ma;N=269147;O=M+55|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[Ma+55>>0]=0;vM(-5,q,269653,269034,1389)}o1c(q|0,k|0,La|0)|0;if(y|0){wa=(z|0)>0;sa=K;J=y;while(1){J=J+-1|0;if(wa){Ka=0;do{Ha=ta;Ea=0;while(1){Ba=D+(Ea<<2)|0;za=f[Ba>>2]|0;l=+n[za>>2];Aa=f[q+(Ea<<2)>>2]|0;ya=f[r+(Ea<<2)>>2]|0;a=-1;while(1){Z=a+1|0;if(!(l>=+n[Aa+(Z<<2)>>2])){Oa=a;break}if((Z|0)<(ya|0))a=Z;else{Oa=Z;break}}if(Oa>>>0>=ya>>>0){Pa=Ha;Qa=Ea;break}f[Ba>>2]=za+(f[Na+(Ea<<1<<2)>>2]<<2);a=Ha+(Y(f[s+(Ea<<2)>>2]|0,Oa)|0)|0;Aa=Ea+1|0;if((Aa|0)<(I|0)){Ha=a;Ea=Aa}else{Pa=a;Qa=Aa;break}}if((Qa|0)!=(I|0)){n[sa+(Ka<<2)>>2]=0.0;if((Qa|0)<(I|0)){Ea=Qa;do{Ha=D+(Ea<<2)|0;f[Ha>>2]=(f[Ha>>2]|0)+(f[Na+(Ea<<1<<2)>>2]<<2);Ea=Ea+1|0}while((Ea|0)!=(I|0))}}else n[sa+(Ka<<2)>>2]=U*+n[Pa>>2];Ka=Ka+1|0}while((Ka|0)!=(z|0));Ra=0}else Ra=0;do{Ka=D+(Ra<<2)|0;f[Ka>>2]=(f[Ka>>2]|0)+(f[Na+((Ra<<1|1)<<2)>>2]<<2);Ra=Ra+1|0}while((Ra|0)!=(I|0));if(!J)break;else sa=sa+(Q<<2)|0}}}else switch(I|0){case 1:{l=+p[e>>3];Ga=+p[e+8>>3];sa=f[r>>2]|0;J=f[Na>>2]|0;wa=f[Na+4>>2]|0;if(!y)break e;if((z|0)<=0)break e;Ma=Y(z,J)|0;Ka=K;Ea=f[D>>2]|0;Ha=y;while(1){Ha=Ha+-1|0;Aa=0;a=Ea;while(1){Ia=Ga+l*+n[a>>2];Z=~~Ia;fa=Z-(+(Z|0)>Ia&1)|0;if(fa>>>0<sa>>>0)Sa=U*+n[ta+(fa<<2)>>2];else Sa=0.0;n[Ka+(Aa<<2)>>2]=Sa;Aa=Aa+1|0;if((Aa|0)==(z|0))break;else a=a+(J<<2)|0}if(!Ha)break;else{Ka=Ka+(Q<<2)|0;Ea=Ea+(Ma<<2)+(wa<<2)|0}}break}case 2:{l=+p[e>>3];Ga=+p[e+8>>3];Ia=+p[e+16>>3];xa=+p[e+24>>3];wa=f[r>>2]|0;Ma=f[r+4>>2]|0;Ea=f[Na>>2]|0;Ka=f[Na+4>>2]|0;Ha=f[Na+8>>2]|0;J=f[Na+12>>2]|0;sa=f[s>>2]|0;if(!((z|0)>0&(y|0)!=0))break e;a=Y(z,Ea)|0;Aa=Y(z,Ha)|0;fa=f[D>>2]|0;Z=f[D+4>>2]|0;R=K;ra=y;while(1){W=fa+(a<<2)|0;_=0;$=fa;c=Z;while(1){Ca=Ga+l*+n[$>>2];aa=~~Ca;ba=aa-(+(aa|0)>Ca&1)|0;Ca=xa+Ia*+n[c>>2];aa=~~Ca;la=aa-(+(aa|0)>Ca&1)|0;if(ba>>>0<wa>>>0&la>>>0<Ma>>>0){aa=ta+(Y(ba,sa)|0)+(la<<2)|0;Ta=U*+n[aa>>2]}else Ta=0.0;n[R+(_<<2)>>2]=Ta;_=_+1|0;if((_|0)==(z|0))break;else{$=$+(Ea<<2)|0;c=c+(Ha<<2)|0}}ra=ra+-1|0;if(!ra)break;else{fa=W+(Ka<<2)|0;Z=Z+(Aa<<2)+(J<<2)|0;R=R+(Q<<2)|0}}break}case 3:{Ia=+p[e>>3];xa=+p[e+8>>3];l=+p[e+16>>3];Ga=+p[e+24>>3];Ca=+p[e+32>>3];Da=+p[e+40>>3];R=f[r>>2]|0;J=f[r+4>>2]|0;Aa=f[r+8>>2]|0;Z=f[Na>>2]|0;Ka=f[Na+4>>2]|0;fa=f[Na+8>>2]|0;ra=f[Na+12>>2]|0;Ha=f[Na+16>>2]|0;Ea=f[Na+20>>2]|0;sa=f[s>>2]|0;Ma=f[s+4>>2]|0;if(!((z|0)>0&(y|0)!=0))break e;wa=Y(z,Z)|0;a=Y(z,fa)|0;c=Y(z,Ha)|0;$=f[D>>2]|0;_=f[D+4>>2]|0;aa=f[D+8>>2]|0;la=K;ba=y;while(1){ba=ba+-1|0;ka=_+(a<<2)|0;ia=$;ea=_;va=aa;L=0;while(1){Fa=xa+Ia*+n[ia>>2];ha=~~Fa;ua=ha-(+(ha|0)>Fa&1)|0;Fa=Ga+l*+n[ea>>2];ha=~~Fa;E=ha-(+(ha|0)>Fa&1)|0;Fa=Da+Ca*+n[va>>2];ha=~~Fa;ja=ha-(+(ha|0)>Fa&1)|0;if(ua>>>0<R>>>0&E>>>0<J>>>0&ja>>>0<Aa>>>0){ha=ta+(Y(ua,sa)|0)+(Y(E,Ma)|0)+(ja<<2)|0;Ua=U*+n[ha>>2]}else Ua=0.0;n[la+(L<<2)>>2]=Ua;L=L+1|0;if((L|0)==(z|0))break;else{ia=ia+(Z<<2)|0;ea=ea+(fa<<2)|0;va=va+(Ha<<2)|0}}if(!ba)break;else{$=$+(wa<<2)+(Ka<<2)|0;_=ka+(ra<<2)|0;aa=aa+(c<<2)+(Ea<<2)|0;la=la+(Q<<2)|0}}break}default:{if(!y)break e;la=(k|0)==0;Ea=(z|0)>0;c=K;aa=y;while(1){aa=aa+-1|0;if(Ea){ra=0;while(1){f:do if(la){_=ta;Ka=0;while(1){wa=D+(Ka<<2)|0;$=f[wa>>2]|0;ba=Ka<<1;Ca=+n[$>>2]*+p[e+(ba<<3)>>3]+ +p[e+((ba|1)<<3)>>3];Ha=~~Ca;fa=Ha-(+(Ha|0)>Ca&1)|0;if(fa>>>0>=(f[r+(Ka<<2)>>2]|0)>>>0){Va=_;Wa=Ka;break f}f[wa>>2]=$+(f[Na+(ba<<2)>>2]<<2);ba=_+(Y(f[s+(Ka<<2)>>2]|0,fa)|0)|0;fa=Ka+1|0;if((fa|0)<(I|0)){_=ba;Ka=fa}else{Va=ba;Wa=fa;break}}}else{Ka=ta;_=0;while(1){za=D+(_<<2)|0;Ba=f[za>>2]|0;Ca=+n[Ba>>2];ya=_<<1;Da=Ca*+p[e+(ya<<3)>>3]+ +p[e+((ya|1)<<3)>>3];fa=~~Da;ba=fa-(+(fa|0)>Da&1)|0;if(ba>>>0>=(f[r+(_<<2)>>2]|0)>>>0){Va=Ka;Wa=_;break f}if(Ca>=+n[(f[k+(_<<2)>>2]|0)+4>>2]){Va=Ka;Wa=_;break f}f[za>>2]=Ba+(f[Na+(ya<<2)>>2]<<2);ya=Ka+(Y(f[s+(_<<2)>>2]|0,ba)|0)|0;ba=_+1|0;if((ba|0)<(I|0)){Ka=ya;_=ba}else{Va=ya;Wa=ba;break}}}while(0);if((Wa|0)!=(I|0)){n[c+(ra<<2)>>2]=0.0;if((Wa|0)<(I|0)){_=Wa;do{Ka=D+(_<<2)|0;f[Ka>>2]=(f[Ka>>2]|0)+(f[Na+(_<<1<<2)>>2]<<2);_=_+1|0}while((_|0)!=(I|0))}}else n[c+(ra<<2)>>2]=U*+n[Va>>2];ra=ra+1|0;if((ra|0)==(z|0)){Xa=0;break}}}else Xa=0;do{ra=D+(Xa<<2)|0;f[ra>>2]=(f[ra>>2]|0)+(f[Na+((Xa<<1|1)<<2)>>2]<<2);Xa=Xa+1|0}while((Xa|0)!=(I|0));if(!aa)break;else c=c+(Q<<2)|0}}}while(0);break}default:{f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;vM(-210,q,269637,269034,1546)}}q=A+36|0;Q=f[q>>2]|0;if(Q|0?(I=Q+12|0,Q=f[I>>2]|0,f[I>>2]=Q+-1,(Q|0)==1):0)V$(A);f[q>>2]=0;q=A+16|0;Q=A+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[Q>>2]|0)>0){q=f[A+40>>2]|0;I=0;do{f[q+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[Q>>2]|0))}Q=f[A+44>>2]|0;if((Q|0)!=(A+48|0))wL(Q);Q=f[x>>2]|0;if(Q|0){x=f[B>>2]|0;if((x|0)!=(Q|0))f[B>>2]=x+(~((x+-8-Q|0)>>>3)<<3);cYc(Q)}Q=f[w>>2]|0;if(Q|0){w=f[C>>2]|0;if((w|0)!=(Q|0))f[C>>2]=w+(~((w+-4-Q|0)>>>2)<<2);cYc(Q)}Q=f[v>>2]|0;if(Q|0){v=f[g>>2]|0;if((v|0)!=(Q|0))f[g>>2]=v+(~((v+-4-Q|0)>>>2)<<2);cYc(Q)}Q=t+36|0;v=f[Q>>2]|0;if(v|0?(g=v+12|0,v=f[g>>2]|0,f[g>>2]=v+-1,(v|0)==1):0)V$(t);f[Q>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[H>>2]|0)>0){G=f[i>>2]|0;i=0;do{f[G+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[H>>2]|0))}H=f[t+44>>2]|0;if((H|0)==(t+48|0)){u=o;return}wL(H);u=o;return}function Yoa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;i=u;u=u+3696|0;j=i+3632|0;k=i+3576|0;l=i+1520|0;m=i+56|0;n=i;oS(d,-1)|0;do if((eS(d)|0)==65536){o=f[d+4>>2]|0;f[j>>2]=f[o>>2];p=j+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[j+16>>2]=f[o+16>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;t=j+44|0;f[t>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];v=j;break}else{f[p>>2]=0;U$(j,o);v=j;break}}else{bS(j,d,-1);v=j}while(0);f[k>>2]=1124007936;o=k+4|0;p=k+8|0;q=k+40|0;r=o;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0));f[q>>2]=p;s=k+48|0;w=k+44|0;f[w>>2]=s;f[s>>2]=0;f[k+52>>2]=0;x=f[v>>2]|0;y=x>>>3&511;z=y+1|0;if(!y){y=j+36|0;A=f[y>>2]|0;if(A){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1;B=k+36|0;A=f[B>>2]|0;if((A|0)!=0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0){V$(k);D=B}else D=B}else D=k+36|0;f[D>>2]=0;B=k+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[o>>2]|0)>0){A=f[q>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0;E=f[o>>2]|0}while((C|0)<(E|0));f[k>>2]=f[v>>2];if((E|0)<3)F=35;else F=37}else{f[k>>2]=f[v>>2];F=35}if((F|0)==35){v=f[j+4>>2]|0;if((v|0)<3){f[o>>2]=v;f[p>>2]=f[j+8>>2];v=k+12|0;f[v>>2]=f[j+12>>2];E=f[j+44>>2]|0;C=f[w>>2]|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2];G=v}else F=37}if((F|0)==37){U$(k,j);G=k+12|0}f[B>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];f[D>>2]=f[y>>2];H=G}else{if(!(x&16384)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;G=$Xc(32)|0;f[l>>2]=G;f[l+8>>2]=-2147483616;f[l+4>>2]=17;r=G;I=269667;t=r+17|0;do{b[r>>0]=b[I>>0]|0;r=r+1|0;I=I+1|0}while((r|0)<(t|0));b[G+17>>0]=0;vM(-215,l,269637,269034,1889)}G=f[j+4>>2]|0;o1c(l|0,f[j+40>>2]|0,G<<2|0)|0;f[l+(G<<2)>>2]=z;_$(m,G+1|0,l,x&7,f[j+16>>2]|0,0);x=k+36|0;G=f[x>>2]|0;if(G|0?(z=G+12|0,G=f[z>>2]|0,f[z>>2]=G+-1,(G|0)==1):0)V$(k);f[x>>2]=0;G=k+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[o>>2]|0)>0){z=f[q>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[o>>2]|0))}f[k>>2]=f[m>>2];y=m+4|0;z=f[y>>2]|0;f[o>>2]=z;D=m+8|0;f[p>>2]=f[D>>2];B=k+12|0;f[B>>2]=f[m+12>>2];F=m+16|0;f[G>>2]=f[F>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];f[k+32>>2]=f[m+32>>2];G=m+36|0;f[x>>2]=f[G>>2];x=k+44|0;v=f[x>>2]|0;if((v|0)==(s|0))J=z;else{wL(v);f[x>>2]=s;f[q>>2]=p;J=f[y>>2]|0}v=m+44|0;if((J|0)<3){J=f[v>>2]|0;f[s>>2]=f[J>>2];f[k+52>>2]=f[J+4>>2];K=J}else{f[x>>2]=f[v>>2];x=m+40|0;f[k+40>>2]=f[x>>2];J=m+48|0;f[v>>2]=J;f[x>>2]=D;K=J}f[m>>2]=1124007936;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[y+24>>2]=0;f[y+28>>2]=0;f[G>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((K|0)!=(m+48|0))wL(K);H=B}B=(f[p>>2]|0)==1;p=(f[H>>2]|0)==1;H=B|p;K=f[o>>2]|0;F=(f[g+4>>2]|0)-(f[g>>2]|0)|0;G=F>>2;y=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;J=pS(a,-1)|0;if((J|0)<=0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(16)|0;f[l>>2]=D;f[l+8>>2]=-2147483632;f[l+4>>2]=11;r=D;I=269685;t=r+11|0;do{b[r>>0]=b[I>>0]|0;r=r+1|0;I=I+1|0}while((r|0)<(t|0));b[D+11>>0]=0;vM(-215,l,269637,269034,1902)}if((G|0)!=(K<<1|0)?(G|0)!=2|(B|p)^1:0){if(G|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;L=$Xc(80)|0;f[l>>2]=L;M=l+8|0;f[M>>2]=-2147483568;N=l+4|0;f[N>>2]=76;r=L;I=269697;t=r+76|0;do{b[r>>0]=b[I>>0]|0;r=r+1|0;I=I+1|0}while((r|0)<(t|0));O=L+76|0;b[O>>0]=0;vM(-215,l,269637,269034,1903)}if(qS(a,0)|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;L=$Xc(80)|0;f[l>>2]=L;M=l+8|0;f[M>>2]=-2147483568;N=l+4|0;f[N>>2]=76;r=L;I=269697;t=r+76|0;do{b[r>>0]=b[I>>0]|0;r=r+1|0;I=I+1|0}while((r|0)<(t|0));O=L+76|0;b[O>>0]=0;vM(-215,l,269637,269034,1903)}}O=(y|0)==0;if(!(O|(y|0)==(K|0))?(y|0)!=1|H^1:0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;H=$Xc(48)|0;f[l>>2]=H;f[l+8>>2]=-2147483600;f[l+4>>2]=44;r=H;I=269774;t=r+44|0;do{b[r>>0]=b[I>>0]|0;r=r+1|0;I=I+1|0}while((r|0)<(t|0));b[H+44>>0]=0;vM(-215,l,269637,269034,1904)}if((F|0)>0?(H=(G|0)/2|0,(F|0)>4):0){F=f[g>>2]|0;g=0;do{f[l+(g<<2)>>2]=F+(g<<1<<2);g=g+1|0}while((g|0)<(H|0))}i1(m,J);H=n+4|0;g=n+8|0;F=n+12|0;I=n+16|0;y=n+20|0;K=n+24|0;L=n+28|0;N=n+32|0;M=n+36|0;p=n+40|0;B=n+48|0;D=n+44|0;x=n+44|0;v=0;do{bS(n,a,v);z=f[m>>2]|0;E=z+(v*56|0)|0;if((E|0)==(n|0)){C=f[M>>2]|0;if(C|0?(A=C+12|0,C=f[A>>2]|0,f[A>>2]=C+-1,(C|0)==1):0)V$(n)}else{C=z+(v*56|0)+36|0;A=f[C>>2]|0;if(A|0?(P=A+12|0,A=f[P>>2]|0,f[P>>2]=A+-1,(A|0)==1):0)V$(E);f[C>>2]=0;A=z+(v*56|0)+16|0;P=z+(v*56|0)+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[P>>2]|0)>0){Q=f[z+(v*56|0)+40>>2]|0;R=0;do{f[Q+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[P>>2]|0))}f[E>>2]=f[n>>2];f[P>>2]=f[H>>2];R=z+(v*56|0)+8|0;f[R>>2]=f[g>>2];f[z+(v*56|0)+12>>2]=f[F>>2];f[A>>2]=f[I>>2];f[z+(v*56|0)+20>>2]=f[y>>2];f[z+(v*56|0)+24>>2]=f[K>>2];f[z+(v*56|0)+28>>2]=f[L>>2];f[z+(v*56|0)+32>>2]=f[N>>2];f[C>>2]=f[M>>2];Q=z+(v*56|0)+44|0;S=f[Q>>2]|0;T=z+(v*56|0)+48|0;if((S|0)==(T|0))U=S;else{wL(S);f[Q>>2]=T;f[z+(v*56|0)+40>>2]=R;U=T}if((f[H>>2]|0)<3){T=f[x>>2]|0;f[U>>2]=f[T>>2];f[U+4>>2]=f[T+4>>2]}else{f[Q>>2]=f[x>>2];f[z+(v*56|0)+40>>2]=f[p>>2];f[x>>2]=B;f[p>>2]=g}f[n>>2]=1124007936;r=H;t=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(t|0))}f[M>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[H>>2]|0)>0){z=f[p>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[H>>2]|0))}C=f[D>>2]|0;if((C|0)!=(B|0))wL(C);v=v+1|0}while((v|0)<(J|0));Xoa(f[m>>2]|0,J,O?0:f[c>>2]|0,d,e,G|0?l:0,h,1);j1(m);l=m+8|0;G=m+1464|0;do{m=G;G=G+-56|0;e=m+-20|0;d=f[e>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(G);f[e>>2]=0;e=m+-40|0;d=m+-52|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[m+-16>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[m+-12>>2]|0;if((d|0)!=(m+-8|0))wL(d)}while((G|0)!=(l|0));l=k+36|0;G=f[l>>2]|0;if(G|0?(d=G+12|0,G=f[d>>2]|0,f[d>>2]=G+-1,(G|0)==1):0)V$(k);f[l>>2]=0;l=k+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[o>>2]|0)>0){l=f[q>>2]|0;q=0;do{f[l+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[w>>2]|0;if((o|0)!=(s|0))wL(o);o=j+36|0;s=f[o>>2]|0;if(s|0?(w=s+12|0,s=f[w>>2]|0,f[w>>2]=s+-1,(s|0)==1):0)V$(j);f[o>>2]=0;o=j+16|0;s=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[s>>2]|0)>0){o=f[j+40>>2]|0;w=0;do{f[o+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)==(j+48|0)){u=i;return}wL(s);u=i;return}function Zoa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0,ca=0.0;e=u;u=u+288|0;g=e+232|0;h=e+176|0;i=e+160|0;j=e+48|0;k=e+16|0;l=e;do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[g>>2]=f[m>>2];o=g+4|0;p=m+4|0;f[o>>2]=f[p>>2];q=g+8|0;f[q>>2]=f[m+8>>2];f[g+12>>2]=f[m+12>>2];f[g+16>>2]=f[m+16>>2];f[g+20>>2]=f[m+20>>2];f[g+24>>2]=f[m+24>>2];f[g+28>>2]=f[m+28>>2];f[g+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=q;q=g+48|0;s=g+44|0;f[s>>2]=q;f[q>>2]=0;f[g+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[m+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;U$(g,m);break}}else bS(g,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];m=h+4|0;o=a+4|0;f[m>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;s=h+44|0;f[s>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;U$(h,a);break}}else bS(h,c,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;f[j>>2]=1124007936;c=j+8|0;a=j+40|0;m=j+4|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[a>>2]=c;c=j+48|0;f[j+44>>2]=c;f[c>>2]=0;f[j+52>>2]=0;f[j+56>>2]=1124007936;c=j+64|0;a=j+96|0;m=j+60|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[a>>2]=c;c=j+104|0;f[j+100>>2]=c;f[c>>2]=0;f[j+108>>2]=0;zL(k,i,j,-1);i=f[g>>2]|0;if(!((i&7|0)==5?((f[h>>2]^i)&4095|0)==0:0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;i=$Xc(48)|0;f[l>>2]=i;f[l+8>>2]=-2147483600;f[l+4>>2]=46;m=i;t=269819;o=m+46|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));b[i+46>>0]=0;vM(-215,l,269866,269034,1935)}i=k+4|0;c=f[i>>2]|0;if(!(f[c>>2]&16384)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;v=$Xc(64)|0;f[l>>2]=v;w=l+8|0;f[w>>2]=-2147483584;x=l+4|0;f[x>>2]=58;m=v;t=269878;o=m+58|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));y=v+58|0;b[y>>0]=0;vM(-215,l,269866,269034,1939)}if(!(f[c+56>>2]&16384)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;v=$Xc(64)|0;f[l>>2]=v;w=l+8|0;f[w>>2]=-2147483584;x=l+4|0;f[x>>2]=58;m=v;t=269878;o=m+58|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));y=v+58|0;b[y>>0]=0;vM(-215,l,269866,269034,1939)}y=k+16|0;v=(d|0)==1;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;x=0;a:while(1){if(x>>>0>=(f[y>>2]|0)>>>0)break;w=f[i>>2]|0;c=f[w+16>>2]|0;a=f[w+72>>2]|0;p=Y(f[w+12>>2]|0,f[w+8>>2]|0)|0;w=Y(p,((f[g>>2]|0)>>>3&511)+1|0)|0;switch(d|0){case 1:case 4:{if((w|0)>0)if(v){p=0;F=z;while(1){G=+n[c+(p<<2)>>2];H=G-+n[a+(p<<2)>>2];s=+L(+G)>2.220446049250313e-16;I=s?F+H*H/G:F;p=p+1|0;if((p|0)==(w|0)){J=C;K=D;N=E;O=A;P=B;Q=I;break}else F=I}}else{p=0;F=z;while(1){I=+n[c+(p<<2)>>2];G=+n[a+(p<<2)>>2];H=I-G;R=I+G;s=+L(+R)>2.220446049250313e-16;G=s?F+H*H/R:F;p=p+1|0;if((p|0)==(w|0)){J=C;K=D;N=E;O=A;P=B;Q=G;break}else F=G}}else{J=C;K=D;N=E;O=A;P=B;Q=z}break}case 0:{if((w|0)>0){p=0;F=A;G=B;R=C;H=D;I=E;while(1){S=+n[c+(p<<2)>>2];T=+n[a+(p<<2)>>2];U=H+S*T;V=F+S;X=R+S*S;S=G+T;Z=I+T*T;p=p+1|0;if((p|0)==(w|0)){J=X;K=U;N=Z;O=V;P=S;Q=z;break}else{F=V;G=S;R=X;H=U;I=Z}}}else{J=C;K=D;N=E;O=A;P=B;Q=z}break}case 2:{if((w|0)>0){p=0;I=z;while(1){H=+n[a+(p<<2)>>2];R=+n[c+(p<<2)>>2];G=I+(H<R?H:R);p=p+1|0;if((p|0)==(w|0)){J=C;K=D;N=E;O=A;P=B;Q=G;break}else I=G}}else{J=C;K=D;N=E;O=A;P=B;Q=z}break}case 3:{if((w|0)>0){I=A;G=B;p=0;R=z;while(1){H=+n[c+(p<<2)>>2];F=+n[a+(p<<2)>>2];Z=R+ +M(+(H*F));U=I+H;H=G+F;p=p+1|0;if((p|0)==(w|0)){J=C;K=D;N=E;O=U;P=H;Q=Z;break}else{I=U;G=H;R=Z}}}else{J=C;K=D;N=E;O=A;P=B;Q=z}break}case 5:{if((w|0)>0){p=0;R=z;while(1){G=+n[c+(p<<2)>>2];I=G;Z=+n[a+(p<<2)>>2];if(!(+L(+G)<=2.220446049250313e-16)){s=!(+L(+Z)<=2.220446049250313e-16);_=R+I*+W(+(I/(s?Z:1.0e-10)))}else _=R;p=p+1|0;if((p|0)==(w|0)){J=C;K=D;N=E;O=A;P=B;Q=_;break}else R=_}}else{J=C;K=D;N=E;O=A;P=B;Q=z}break}default:{$=38;break a}}CL(k)|0;z=Q;A=O;B=P;C=J;D=K;E=N;x=x+1|0}if(($|0)==38){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;$=$Xc(32)|0;f[l>>2]=$;f[l+8>>2]=-2147483616;f[l+4>>2]=25;m=$;t=271934;o=m+25|0;do{b[m>>0]=b[t>>0]|0;m=m+1|0;t=t+1|0}while((m|0)<(o|0));b[$+25>>0]=0;vM(-5,l,269866,269034,2108)}switch(d|0){case 4:{aa=z*2.0;break}case 0:{d=f[g+4>>2]|0;if((d|0)<3)ba=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{l=f[g+40>>2]|0;$=0;t=1;while(1){m=Y(f[l+($<<2)>>2]|0,t)|0;$=$+1|0;if(($|0)==(d|0)){ba=m;break}else t=m}}N=1.0/+(ba>>>0);K=(C-A*A*N)*(E-B*B*N);if(+L(+K)>2.220446049250313e-16)aa=(D-B*A*N)/+M(+K);else aa=1.0;break}case 3:{K=B*A;if(+L(+K)>1.1920928955078125e-07)ca=1.0/+M(+K);else ca=1.0;K=1.0-z*ca;aa=+M(+(K<0.0?0.0:K));break}default:aa=z}ba=j+56|0;t=j+92|0;d=f[t>>2]|0;if(d|0?($=d+12|0,d=f[$>>2]|0,f[$>>2]=d+-1,(d|0)==1):0)V$(ba);f[t>>2]=0;t=j+72|0;ba=j+60|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[ba>>2]|0)>0){t=f[j+96>>2]|0;d=0;do{f[t+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[ba>>2]|0))}ba=f[j+100>>2]|0;if((ba|0)!=(j+104|0))wL(ba);ba=j+36|0;d=f[ba>>2]|0;if(d|0?(t=d+12|0,d=f[t>>2]|0,f[t>>2]=d+-1,(d|0)==1):0)V$(j);f[ba>>2]=0;ba=j+16|0;d=j+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[d>>2]|0)>0){ba=f[j+40>>2]|0;t=0;do{f[ba+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[d>>2]|0))}d=f[j+44>>2]|0;if((d|0)!=(j+48|0))wL(d);d=h+36|0;j=f[d>>2]|0;if(j|0?(t=j+12|0,j=f[t>>2]|0,f[t>>2]=j+-1,(j|0)==1):0)V$(h);f[d>>2]=0;d=h+16|0;j=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[h+40>>2]|0;t=0;do{f[d+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)!=(h+48|0))wL(j);j=g+36|0;h=f[j>>2]|0;if(h|0?(t=h+12|0,h=f[t>>2]|0,f[t>>2]=h+-1,(h|0)==1):0)V$(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return +aa}wL(h);u=e;return +aa}function _oa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;d=u;u=u+2272|0;e=d+2208|0;g=d+2200|0;h=d+2144|0;i=d+2112|0;j=d+1088|0;k=d+64|0;l=d+48|0;m=d+32|0;n=d+24|0;o=d+8|0;q=d;if(dS(a,-1)|0){r=$Xc(32)|0;f[e>>2]=r;f[e+8>>2]=-2147483616;f[e+4>>2]=22;s=r;t=269937;v=s+22|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+22>>0]=0;vM(-215,e,269960,269034,3334)}if(sS(a)|0){u=d;return}do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[e>>2]=f[r>>2];t=e+4|0;s=r+4|0;f[t>>2]=f[s>>2];v=e+8|0;f[v>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[e+16>>2]=f[r+16>>2];f[e+20>>2]=f[r+20>>2];f[e+24>>2]=f[r+24>>2];f[e+28>>2]=f[r+28>>2];f[e+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[e+36>>2]=w;x=e+40|0;f[x>>2]=v;v=e+48|0;y=e+44|0;f[y>>2]=v;f[v>>2]=0;f[e+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[s>>2]|0)<3){s=f[r+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2];z=e;A=x;break}else{f[t>>2]=0;U$(e,r);z=e;A=x;break}}else{bS(e,a,-1);z=e;A=e+40|0}while(0);a=f[A>>2]|0;x=f[a>>2]|0;f[g>>2]=f[a+4>>2];f[g+4>>2]=x;wS(c,g,f[z>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){z=f[c+4>>2]|0;f[h>>2]=f[z>>2];g=h+4|0;x=z+4|0;f[g>>2]=f[x>>2];a=h+8|0;f[a>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];r=f[z+36>>2]|0;f[h+36>>2]=r;f[h+40>>2]=a;a=h+48|0;t=h+44|0;f[t>>2]=a;f[a>>2]=0;f[h+52>>2]=0;if(r|0){a=r+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[x>>2]|0)<3){x=f[z+44>>2]|0;a=f[t>>2]|0;f[a>>2]=f[x>>2];f[a+4>>2]=f[x+4>>2];break}else{f[g>>2]=0;U$(h,z);break}}else bS(h,c,-1);while(0);WXc(i);g1c(j|0,0,1024)|0;f[l>>2]=53012;f[l+4>>2]=e;f[l+8>>2]=j;f[l+12>>2]=i;f[m>>2]=53032;f[m+4>>2]=e;f[m+8>>2]=h;f[m+12>>2]=k;c=e+8|0;z=f[c>>2]|0;f[n>>2]=0;f[n+4>>2]=z;g=e+4|0;x=f[g>>2]|0;if((x|0)<3)B=Y(f[e+12>>2]|0,z)|0;else{z=f[A>>2]|0;a=0;t=1;while(1){r=Y(f[z+(a<<2)>>2]|0,t)|0;a=a+1|0;if((a|0)==(x|0)){B=r;break}else t=r}}if(B>>>0>307199){h3(n,l,-1.0);C=0}else{$oa(l,n);C=0}while(1){D=f[j+(C<<2)>>2]|0;E=C+1|0;if(!D)C=E;else break}l=f[g>>2]|0;B=(l|0)<3;if(B)F=Y(f[e+12>>2]|0,f[c>>2]|0)|0;else{t=f[A>>2]|0;x=0;a=1;while(1){z=Y(f[t+(x<<2)>>2]|0,a)|0;x=x+1|0;if((x|0)==(l|0)){F=z;break}else a=z}}do if((F|0)!=(D|0)){G=255.0/+(F-D|0);f[k+(C<<2)>>2]=0;if((E|0)<256){a=0;x=E;do{a=(f[j+(x<<2)>>2]|0)+a|0;t=ALc(G*+(a|0))|0;f[k+(x<<2)>>2]=(t>>>0<256?t:(t|0)>0?255:0)&255;x=x+1|0}while((x|0)!=256)}if(B)H=Y(f[e+12>>2]|0,f[c>>2]|0)|0;else{x=f[A>>2]|0;a=0;t=1;while(1){z=Y(f[x+(a<<2)>>2]|0,t)|0;a=a+1|0;if((a|0)==(l|0)){H=z;break}else t=z}}if(H>>>0>307199){h3(n,m,-1.0);break}else{apa(m,n);break}}else{p[q>>3]=+(C|0);f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;mR(h,o,fT()|0)|0}while(0);XXc(i);i=h+36|0;o=f[i>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)V$(h);f[i>>2]=0;i=h+16|0;o=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[o>>2]|0)>0){i=f[h+40>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[h+44>>2]|0;if((o|0)!=(h+48|0))wL(o);o=e+36|0;h=f[o>>2]|0;if(h|0?(q=h+12|0,h=f[q>>2]|0,f[q>>2]=h+-1,(h|0)==1):0)V$(e);f[o>>2]=0;o=e+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[g>>2]|0)>0){o=f[A>>2]|0;A=0;do{f[o+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))wL(g);u=d;return}function $oa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+1024|0;d=c;g1c(d|0,0,1024)|0;e=f[a+4>>2]|0;g=f[e+48>>2]|0;i=f[b>>2]|0;j=(f[b+4>>2]|0)-i|0;b=(f[e>>2]&16384|0)!=0;k=Y(b?j:1,f[e+12>>2]|0)|0;l=(f[e+16>>2]|0)+(Y(f[f[e+44>>2]>>2]|0,i)|0)|0;i=b?1:j;j=i+-1|0;a:do if(i|0){b=k+-4|0;if((k|0)<4){e=(k|0)>0;m=l;n=j;while(1){if(e){o=0;do{p=d+((h[m+o>>0]|0)<<2)|0;f[p>>2]=(f[p>>2]|0)+1;o=o+1|0}while((o|0)!=(k|0))}if(!n)break a;else{m=m+g|0;n=n+-1|0}}}n=k&-4;m=(n|0)<(k|0);e=l;o=j;while(1){p=0;do{q=h[e+(p|1)>>0]|0;r=d+((h[e+p>>0]|0)<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=d+(q<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=h[e+(p|3)>>0]|0;q=d+((h[e+(p|2)>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;q=d+(r<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+4|0}while((p|0)<=(b|0));if(m){p=n;do{q=d+((h[e+p>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+1|0}while((p|0)!=(k|0))}if(!o)break;else{e=e+g|0;o=o+-1|0}}}while(0);g=f[a+12>>2]|0;YXc(g);k=f[a+8>>2]|0;a=0;do{j=k+(a<<2)|0;f[j>>2]=(f[j>>2]|0)+(f[d+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=256);ZXc(g);u=c;return}function apa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+4>>2]|0;e=f[d+48>>2]|0;g=f[a+8>>2]|0;i=f[g+48>>2]|0;j=f[d+12>>2]|0;k=f[c>>2]|0;l=(f[c+4>>2]|0)-k|0;c=f[a+12>>2]|0;if(!(f[d>>2]&16384)){m=j;n=l}else{a=(f[g>>2]&16384|0)!=0;o=Y(a?l:1,j)|0;m=o;n=a?1:l}l=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,k)|0)|0;d=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,k)|0)|0;k=n+-1|0;if(!n)return;n=m+-4|0;if((m|0)<4){g=(m|0)>0;a=l;o=d;j=k;while(1){if(g){p=0;do{b[o+p>>0]=f[c+((h[a+p>>0]|0)<<2)>>2];p=p+1|0}while((p|0)!=(m|0))}if(!j)break;else{a=a+e|0;o=o+i|0;j=j+-1|0}}return}j=m&-4;o=(j|0)<(m|0);a=l;l=d;d=k;while(1){k=0;do{g=k|1;p=f[c+((h[a+g>>0]|0)<<2)>>2]|0;b[l+k>>0]=f[c+((h[a+k>>0]|0)<<2)>>2];b[l+g>>0]=p;p=k|2;g=k|3;q=f[c+((h[a+g>>0]|0)<<2)>>2]|0;b[l+p>>0]=f[c+((h[a+p>>0]|0)<<2)>>2];b[l+g>>0]=q;k=k+4|0}while((k|0)<=(n|0));if(o){k=j;do{b[l+k>>0]=f[c+((h[a+k>>0]|0)<<2)>>2];k=k+1|0}while((k|0)!=(m|0))}if(!d)break;else{a=a+e|0;l=l+i|0;d=d+-1|0}}return}function bpa(a){a=a|0;cYc(a);return}function cpa(a){a=a|0;cYc(a);return}function dpa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0.0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0,xc=0;g=u;u=u+6592|0;i=g+4096|0;k=g;l=g+6272|0;m=g+6576|0;o=g+6564|0;p=g+6560|0;q=g+6544|0;r=g+6540|0;t=g+6536|0;v=g+6532|0;w=g+6528|0;x=g+6524|0;y=g+6520|0;z=g+6516|0;A=g+6512|0;B=g+6508|0;C=g+6504|0;D=g+6500|0;E=g+6496|0;F=g+6492|0;G=g+6488|0;H=g+6484|0;I=g+6480|0;J=g+6476|0;K=g+6472|0;L=g+6416|0;M=g+6552|0;N=g+6360|0;O=g+6304|0;if(((e|0)%2|0|0)!=1){P=$Xc(48)|0;f[i>>2]=P;Q=i+8|0;f[Q>>2]=-2147483600;R=i+4|0;f[R>>2]=40;S=P;T=270030;U=S+40|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));V=P+40|0;b[V>>0]=0;vM(-215,i,270071,270082,1162)}if((oS(a,-1)|0)>=3){P=$Xc(48)|0;f[i>>2]=P;Q=i+8|0;f[Q>>2]=-2147483600;R=i+4|0;f[R>>2]=40;S=P;T=270030;U=S+40|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));V=P+40|0;b[V>>0]=0;vM(-215,i,270071,270082,1162)}if((e|0)>=2?!(sS(a)|0):0){do if((eS(a)|0)==65536){V=f[a+4>>2]|0;f[L>>2]=f[V>>2];P=L+4|0;R=V+4|0;f[P>>2]=f[R>>2];Q=L+8|0;f[Q>>2]=f[V+8>>2];f[L+12>>2]=f[V+12>>2];f[L+16>>2]=f[V+16>>2];f[L+20>>2]=f[V+20>>2];f[L+24>>2]=f[V+24>>2];f[L+28>>2]=f[V+28>>2];f[L+32>>2]=f[V+32>>2];W=f[V+36>>2]|0;f[L+36>>2]=W;X=L+40|0;f[X>>2]=Q;Q=L+48|0;Z=L+44|0;f[Z>>2]=Q;f[Q>>2]=0;f[L+52>>2]=0;if(W|0){Q=W+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[R>>2]|0)<3){R=f[V+44>>2]|0;Q=f[Z>>2]|0;f[Q>>2]=f[R>>2];f[Q+4>>2]=f[R+4>>2];_=L;$=X;break}else{f[P>>2]=0;U$(L,V);_=L;$=X;break}}else{bS(L,a,-1);_=L;$=L+40|0}while(0);X=f[$>>2]|0;V=f[X>>2]|0;f[M>>2]=f[X+4>>2];f[M+4>>2]=V;wS(c,M,f[_>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){M=f[c+4>>2]|0;f[N>>2]=f[M>>2];V=N+4|0;X=M+4|0;f[V>>2]=f[X>>2];P=N+8|0;f[P>>2]=f[M+8>>2];f[N+12>>2]=f[M+12>>2];R=N+16|0;f[R>>2]=f[M+16>>2];f[N+20>>2]=f[M+20>>2];f[N+24>>2]=f[M+24>>2];f[N+28>>2]=f[M+28>>2];f[N+32>>2]=f[M+32>>2];Q=f[M+36>>2]|0;f[N+36>>2]=Q;f[N+40>>2]=P;P=N+48|0;Z=N+44|0;f[Z>>2]=P;f[P>>2]=0;f[N+52>>2]=0;if(Q|0){P=Q+12|0;f[P>>2]=(f[P>>2]|0)+1}if((f[X>>2]|0)<3){X=f[M+44>>2]|0;P=f[Z>>2]|0;f[P>>2]=f[X>>2];f[P+4>>2]=f[X+4>>2];aa=R;break}else{f[V>>2]=0;U$(N,M);aa=R;break}}else{bS(N,c,-1);aa=N+16|0}while(0);R=L+16|0;M=L+12|0;V=L+8|0;X=f[_>>2]|0;switch(e|0){case 3:{ba=1;break}case 5:{if(!(X&7)){P=(X>>>3&511)+1|0;ba=(P|0)==2|P>>>0>4}else ba=1;break}default:ba=0}f[O>>2]=1124007936;P=O+4|0;X=O+8|0;Z=O+40|0;S=P;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[Z>>2]=X;Q=O+48|0;W=O+44|0;f[W>>2]=Q;f[Q>>2]=0;f[O+52>>2]=0;a:do if(!ba){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=L;ca=k+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=O;ca=(e|0)/2|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;rR(i,k,0,0,ca,ca,17,l);da=f[O>>2]|0;if(da&7|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ea=$Xc(64)|0;f[i>>2]=ea;fa=i+8|0;f[fa>>2]=-2147483584;ga=i+4|0;f[ga>>2]=55;S=ea;T=270158;U=S+55|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));ha=ea+55|0;b[ha>>0]=0;vM(-215,i,270071,270082,1222)}switch((f[_>>2]|0)>>>3&511){case 0:case 2:case 3:break;default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ea=$Xc(64)|0;f[i>>2]=ea;fa=i+8|0;f[fa>>2]=-2147483584;ga=i+4|0;f[ga>>2]=55;S=ea;T=270158;U=S+55|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));ha=ea+55|0;b[ha>>0]=0;vM(-215,i,270071,270082,1222)}}ia=f[L+4>>2]|0;if((ia|0)<3)ja=Y(f[M>>2]|0,f[V>>2]|0)|0;else{ka=f[$>>2]|0;la=0;ma=1;while(1){na=Y(f[ka+(la<<2)>>2]|0,ma)|0;la=la+1|0;if((la|0)==(ia|0)){ja=na;break}else ma=na}}oa=+(ja>>>0)*9.5367431640625e-07;if(((oa<1.0?39:oa<4.0?21:9)|0)>=(e|0)){ma=(Y(e,e)|0)>>>1;ia=f[N+40>>2]|0;la=f[ia+4>>2]|0;ka=f[ia>>2]|0;ia=f[O+16>>2]|0;na=f[aa>>2]|0;pa=f[Q>>2]|0;qa=f[N+48>>2]|0;ra=da>>>3;sa=ra&511;ta=sa+1|0;ua=ia+(Y(pa,ka)|0)|0;if(sa>>>0>=4){sa=$Xc(32)|0;f[l>>2]=sa;f[l+8>>2]=-2147483616;f[l+4>>2]=17;S=sa;T=270214;U=S+17|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));b[sa+17>>0]=0;vM(-215,l,270232,270082,351)}if((la|0)>0){da=ka+-1|0;va=Y(pa,da)|0;wa=Y(qa,da)|0;xa=0-pa|0;ya=0-qa|0;za=ta<<6;Aa=ta<<10;Ba=(e|0)<-1;Ca=(ka|0)>0;Da=ra&65535;Ea=e<<2;Fa=(e|0)>0;Ga=e*3|0;Ha=Y(ta,e)|0;Ia=(Ha|0)>0;Ja=ca+1|0;Ka=(pa|0)!=0;La=ia;Ma=na;Na=0;while(1){Oa=(Na&1|0)==0;Pa=Oa?qa:ya;Qa=Oa?pa:xa;Ra=Oa?La:La+va|0;Sa=Oa?Ma:Ma+wa|0;g1c(i|0,0,za|0)|0;g1c(k|0,0,Aa|0)|0;b:do if(Ba)Ta=Ra;else{Oa=(Qa|0)>0;if(Ia){Ua=0;Va=Ra}else{Wa=0;Xa=Ra;while(1){if(Oa)if((Wa|0)<(da|0))Ya=169;else Za=Xa;else if(Ka&(ka-Wa|0)>1)Ya=169;else Za=Xa;if((Ya|0)==169){Ya=0;Za=Xa+Qa|0}if((Wa|0)<(ca|0)){Wa=Wa+1|0;Xa=Za}else{Ta=Za;break b}}}while(1){if((Ua|0)>0){Xa=0;do{Wa=0;do{_a=h[Va+(Wa+Xa)>>0]|0;$a=k+(Xa<<10)+(_a<<2)|0;f[$a>>2]=(f[$a>>2]|0)+1;$a=i+(Xa<<6)+(_a>>>4<<2)|0;f[$a>>2]=(f[$a>>2]|0)+1;Wa=Wa+ta|0}while((Wa|0)<(Ha|0));Xa=Xa+1|0}while((Xa|0)!=(ta|0))}else{Xa=0;do{Wa=0;do{$a=h[Va+(Wa+Xa)>>0]|0;_a=k+(Xa<<10)+($a<<2)|0;f[_a>>2]=(f[_a>>2]|0)+Ja;_a=i+(Xa<<6)+($a>>>4<<2)|0;f[_a>>2]=(f[_a>>2]|0)+Ja;Wa=Wa+ta|0}while((Wa|0)<(Ha|0));Xa=Xa+1|0}while((Xa|0)!=(ta|0))}if(Oa)if((Ua|0)<(da|0))Ya=159;else ab=Va;else if(Ka&(ka-Ua|0)>1)Ya=159;else ab=Va;if((Ya|0)==159){Ya=0;ab=Va+Qa|0}if((Ua|0)<(ca|0)){Ua=Ua+1|0;Va=ab}else{Ta=ab;break}}}while(0);c:do if(Ca){Oa=(Qa|0)>-1;Xa=(Qa|0)<1;Wa=Sa;_a=Ra;$a=0;bb=Ta;while(1){cb=0;do{db=0;eb=0;while(1){fb=(f[i+(cb<<6)+(eb<<2)>>2]|0)+db|0;if((fb|0)>(ma|0))break;else{db=fb;eb=eb+1|0}}fb=db;gb=eb<<4;while(1){fb=(f[k+(cb<<10)+(gb<<2)>>2]|0)+fb|0;if((fb|0)>(ma|0))break;else gb=gb+1|0}b[Wa+cb>>0]=gb;cb=cb+1|0}while((cb|0)!=(ta|0));cb=$a+1|0;if((cb|0)==(ka|0))break c;d:do switch(Da&511){case 0:{if(Fa)hb=0;else break d;do{fb=h[_a+hb>>0]|0;eb=h[bb+hb>>0]|0;db=k+(fb<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=i+(fb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=k+(eb<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=i+(eb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+1;hb=hb+1|0}while((hb|0)!=(e|0));break}case 2:{if(Fa)ib=0;else break d;do{gb=h[_a+ib>>0]|0;db=k+(gb<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=i+(gb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=ib+1|0;gb=h[_a+db>>0]|0;eb=k+1024+(gb<<2)|0;f[eb>>2]=(f[eb>>2]|0)+-1;eb=i+64+(gb>>>4<<2)|0;f[eb>>2]=(f[eb>>2]|0)+-1;eb=ib+2|0;gb=h[_a+eb>>0]|0;fb=k+2048+(gb<<2)|0;f[fb>>2]=(f[fb>>2]|0)+-1;fb=i+128+(gb>>>4<<2)|0;f[fb>>2]=(f[fb>>2]|0)+-1;fb=h[bb+ib>>0]|0;gb=k+(fb<<2)|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=i+(fb>>>4<<2)|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=h[bb+db>>0]|0;db=k+1024+(gb<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=i+64+(gb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=h[bb+eb>>0]|0;eb=k+2048+(db<<2)|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=i+128+(db>>>4<<2)|0;f[eb>>2]=(f[eb>>2]|0)+1;ib=ib+3|0}while((ib|0)<(Ga|0));break}default:{if(Fa)jb=0;else break d;do{eb=h[_a+jb>>0]|0;db=k+(eb<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=i+(eb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=jb|1;eb=h[_a+db>>0]|0;gb=k+1024+(eb<<2)|0;f[gb>>2]=(f[gb>>2]|0)+-1;gb=i+64+(eb>>>4<<2)|0;f[gb>>2]=(f[gb>>2]|0)+-1;gb=jb|2;eb=h[_a+gb>>0]|0;fb=k+2048+(eb<<2)|0;f[fb>>2]=(f[fb>>2]|0)+-1;fb=i+128+(eb>>>4<<2)|0;f[fb>>2]=(f[fb>>2]|0)+-1;fb=jb|3;eb=h[_a+fb>>0]|0;kb=k+3072+(eb<<2)|0;f[kb>>2]=(f[kb>>2]|0)+-1;kb=i+192+(eb>>>4<<2)|0;f[kb>>2]=(f[kb>>2]|0)+-1;kb=h[bb+jb>>0]|0;eb=k+(kb<<2)|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=i+(kb>>>4<<2)|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=h[bb+db>>0]|0;db=k+1024+(eb<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=i+64+(eb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=h[bb+gb>>0]|0;gb=k+2048+(db<<2)|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=i+128+(db>>>4<<2)|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=h[bb+fb>>0]|0;fb=k+3072+(gb<<2)|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=i+192+(gb>>>4<<2)|0;f[fb>>2]=(f[fb>>2]|0)+1;jb=jb+4|0}while((jb|0)<(Ea|0))}}while(0);fb=bb+Qa|0;if((cb|0)<(ka|0)){Wa=Wa+Pa|0;_a=($a|0)<(ca|0)?_a:_a+Qa|0;$a=cb;bb=(Xa|fb>>>0>=ua>>>0)&(Oa|fb>>>0<La>>>0)?bb:fb}else break c}}while(0);Na=Na+1|0;if((Na|0)==(la|0))break;else{La=La+ta|0;Ma=Ma+ta|0}}}break}ta=(f[N>>2]|0)>>>3&511;Ma=ta+1|0;La=f[N+8>>2]|0;la=e+-1|0;Na=(la|0)/2|0;if(ta>>>0>=4){ua=$Xc(32)|0;f[i>>2]=ua;f[i+8>>2]=-2147483616;f[i+4>>2]=17;S=ua;T=270214;U=S+17|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));b[ua+17>>0]=0;vM(-215,i,270249,270082,114)}ca=f[Q>>2]|0;ka=f[N+48>>2]|0;Ea=N+12|0;Fa=512/(Ma>>>0)|0;Ga=f[Ea>>2]|0;Da=(Fa|0)<(Ga|0)?Fa:Ga;Fa=Na<<1;ma=Da+Fa|0;Ca=Y(ma<<4,Ma)|0;Ka=Ca+16|0;f[l>>2]=0;da=l+4|0;f[da>>2]=0;f[l+8>>2]=0;do if(Ka)if((Ca|0)<-16)kWc(l);else{Ha=Ka<<1;Ja=$Xc(Ha)|0;f[l>>2]=Ja;Ia=Ja+(Ka<<1)|0;f[l+8>>2]=Ia;g1c(Ja|0,0,Ha|0)|0;f[da>>2]=Ia;lb=Ja;break}else lb=0;while(0);Ka=Y(Ma<<8,ma)|0|16;f[m>>2]=0;Ca=m+4|0;f[Ca>>2]=0;f[m+8>>2]=0;if((Ka|0)<0)kWc(m);ua=Ka<<1;Ja=$Xc(ua)|0;f[m>>2]=Ja;Ia=Ja+(Ka<<1)|0;f[m+8>>2]=Ia;g1c(Ja|0,0,ua|0)|0;f[Ca>>2]=Ia;ua=lb+15&-16;Ka=ua;Ha=Ja+15&-16;Ba=Ha;do if((Ga|0)>0){Aa=O+16|0;za=ua;wa=Ma<<1;va=Ha;xa=Ma<<9;pa=Na+2|0;ya=(la|0)>3;qa=La+-1|0;na=(La|0)>0;ia=Ma*544|0;ra=Ma<<5;sa=Fa|1;Qa=(la|0)>1;Pa=(Y(Fa,Na)|0)+Fa|0;Ra=0;Sa=Ga;e:while(1){bb=Sa-Ra|0;Oa=((Da|0)<(bb|0)?Da:bb)+Fa|0;bb=(f[Aa>>2]|0)+(Y(Ra,Ma)|0)|0;Xa=f[aa>>2]|0;$a=Y(Ra-Na|0,Ma)|0;_a=Oa<<4;g1c(za|0,0,Y(wa,_a)|0)|0;g1c(va|0,0,Y(xa,Oa)|0)|0;Wa=(Oa|0)>0;if(Wa){fb=0;do{gb=Y(fb,Oa)|0;db=fb<<4;eb=0;do{kb=bb+((Y(eb,Ma)|0)+fb)|0;mb=Ka+(((h[kb>>0]|0)>>>4|eb+gb<<4)<<1)|0;d[mb>>1]=(j[mb>>1]|0)+pa;mb=h[kb>>0]|0;kb=Ba+(((Y(mb>>>4|db,Oa)|0)+eb<<4|mb&15)<<1)|0;d[kb>>1]=(j[kb>>1]|0)+pa;eb=eb+1|0}while((eb|0)<(Oa|0));if(ya){eb=1;do{cb=bb+(Y((qa|0)<(eb|0)?qa:eb,ca)|0)|0;kb=0;do{mb=cb+((Y(kb,Ma)|0)+fb)|0;nb=Ka+(((h[mb>>0]|0)>>>4|kb+gb<<4)<<1)|0;d[nb>>1]=(d[nb>>1]|0)+1<<16>>16;nb=h[mb>>0]|0;mb=Ba+(((Y(nb>>>4|db,Oa)|0)+kb<<4|nb&15)<<1)|0;d[mb>>1]=(d[mb>>1]|0)+1<<16>>16;kb=kb+1|0}while((kb|0)<(Oa|0));eb=eb+1|0}while((eb|0)<(Na|0))}fb=fb+1|0}while((fb|0)!=(Ma|0))}fb=Xa+$a|0;if(na){eb=Oa-Na|0;db=(Na|0)<(eb|0);gb=Oa+-1|0;kb=0;do{cb=kb-Na+-1|0;mb=bb+(Y((cb|0)>0?cb:0,ca)|0)|0;cb=kb+Na|0;nb=bb+(Y((cb|0)<(qa|0)?cb:qa,ca)|0)|0;g1c(i|0,0,ia|0)|0;g1c(k|0,0,ra|0)|0;cb=Y(kb,ka)|0;ob=0;while(1){if(Wa){pb=Y(ob,Oa)|0;qb=ob<<4;rb=0;do{sb=rb+pb<<4;tb=(Y(rb,Ma)|0)+ob|0;ub=mb+tb|0;vb=Ka+(((h[ub>>0]|0)>>>4|sb)<<1)|0;d[vb>>1]=(d[vb>>1]|0)+-1<<16>>16;vb=h[ub>>0]|0;ub=Ba+(((Y(vb>>>4|qb,Oa)|0)+rb<<4|vb&15)<<1)|0;d[ub>>1]=(d[ub>>1]|0)+-1<<16>>16;ub=nb+tb|0;tb=Ka+(((h[ub>>0]|0)>>>4|sb)<<1)|0;d[tb>>1]=(d[tb>>1]|0)+1<<16>>16;tb=h[ub>>0]|0;ub=Ba+(((Y(tb>>>4|qb,Oa)|0)+rb<<4|tb&15)<<1)|0;d[ub>>1]=(d[ub>>1]|0)+1<<16>>16;rb=rb+1|0}while((rb|0)<(Oa|0));wb=qb}else wb=ob<<4;qb=0;do{rb=Y(qb+wb|0,_a)|0;pb=0;do{ub=Y(j[Ba+(pb+rb<<1)>>1]|0,sa)|0;tb=i+(ob*544|0)+32+(qb<<5)+(pb<<1)|0;d[tb>>1]=(j[tb>>1]|0)+ub;pb=pb+1|0}while((pb|0)!=16);qb=qb+1|0}while((qb|0)!=16);if(Qa){qb=Ka+((Y(ob,_a)|0)<<1)|0;pb=0;while(1){rb=0;do{ub=i+(ob*544|0)+(rb<<1)|0;d[ub>>1]=(j[ub>>1]|0)+(j[qb+(rb<<1)>>1]|0);rb=rb+1|0}while((rb|0)!=16);pb=pb+1|0;if((pb|0)>=(Fa|0))break;else qb=qb+32|0}}if(db){qb=Y(ob,Oa)|0;pb=ob+cb|0;rb=i+(ob*544|0)|0;ub=i+(ob*544|0)+2|0;tb=i+(ob*544|0)+4|0;sb=i+(ob*544|0)+6|0;vb=i+(ob*544|0)+8|0;xb=i+(ob*544|0)+10|0;yb=i+(ob*544|0)+12|0;zb=i+(ob*544|0)+14|0;Ab=i+(ob*544|0)+16|0;Bb=i+(ob*544|0)+18|0;Cb=i+(ob*544|0)+20|0;Db=i+(ob*544|0)+22|0;Eb=i+(ob*544|0)+24|0;Fb=i+(ob*544|0)+26|0;Gb=i+(ob*544|0)+28|0;Hb=i+(ob*544|0)+30|0;Ib=Na;do{Jb=Ib+Na|0;Kb=Ka+(((gb|0)<(Jb|0)?gb:Jb)+qb<<4<<1)|0;Lb=0;do{Mb=i+(ob*544|0)+(Lb<<1)|0;d[Mb>>1]=(j[Mb>>1]|0)+(j[Kb+(Lb<<1)>>1]|0);Lb=Lb+1|0}while((Lb|0)!=16);Lb=j[rb>>1]|0;do if((Lb|0)<=(Pa|0)){Kb=(j[ub>>1]|0)+Lb|0;if((Kb|0)>(Pa|0)){Nb=Lb;Ob=1;break}Mb=(j[tb>>1]|0)+Kb|0;if((Mb|0)>(Pa|0)){Nb=Kb;Ob=2;break}Kb=(j[sb>>1]|0)+Mb|0;if((Kb|0)>(Pa|0)){Nb=Mb;Ob=3;break}Mb=(j[vb>>1]|0)+Kb|0;if((Mb|0)>(Pa|0)){Nb=Kb;Ob=4;break}Kb=(j[xb>>1]|0)+Mb|0;if((Kb|0)>(Pa|0)){Nb=Mb;Ob=5;break}Mb=(j[yb>>1]|0)+Kb|0;if((Mb|0)>(Pa|0)){Nb=Kb;Ob=6;break}Kb=(j[zb>>1]|0)+Mb|0;if((Kb|0)>(Pa|0)){Nb=Mb;Ob=7;break}Mb=(j[Ab>>1]|0)+Kb|0;if((Mb|0)>(Pa|0)){Nb=Kb;Ob=8;break}Kb=(j[Bb>>1]|0)+Mb|0;if((Kb|0)>(Pa|0)){Nb=Mb;Ob=9;break}Mb=(j[Cb>>1]|0)+Kb|0;if((Mb|0)>(Pa|0)){Nb=Kb;Ob=10;break}Kb=(j[Db>>1]|0)+Mb|0;if((Kb|0)>(Pa|0)){Nb=Mb;Ob=11;break}Mb=(j[Eb>>1]|0)+Kb|0;if((Mb|0)>(Pa|0)){Nb=Kb;Ob=12;break}Kb=(j[Fb>>1]|0)+Mb|0;if((Kb|0)>(Pa|0)){Nb=Mb;Ob=13;break}Mb=(j[Gb>>1]|0)+Kb|0;if((Mb|0)>(Pa|0)){Nb=Kb;Ob=14;break}if(((j[Hb>>1]|0)+Mb|0)>(Pa|0)){Nb=Mb;Ob=15}else{Ya=273;break e}}else{Nb=0;Ob=0}while(0);Lb=k+(ob<<5)+(Ob<<1)|0;Mb=d[Lb>>1]|0;Kb=Mb&65535;Pb=Ib-Na|0;do if((Kb|0)>(Pb|0)){Qb=Ba+((Y(Ob|wb,_a)|0)<<1)|0;if((Kb|0)>(Jb|0))break;else Rb=Mb;do{Sb=Rb&65535;Tb=((Sb|0)<(Oa|0)?Sb:gb)<<4;Ub=Sb-Fa|0;Sb=(Ub|0)<1?0:(Ub<<4)+-16|0;Ub=0;do{Vb=i+(ob*544|0)+32+(Ob<<5)+(Ub<<1)|0;d[Vb>>1]=(j[Qb+(Ub+Tb<<1)>>1]|0)-(j[Qb+(Ub+Sb<<1)>>1]|0)+(j[Vb>>1]|0);Ub=Ub+1|0}while((Ub|0)!=16);Rb=Rb+1<<16>>16;d[Lb>>1]=Rb}while((Rb&65535|0)<=(Jb|0))}else{Qb=i+(ob*544|0)+32+(Ob<<5)|0;f[Qb>>2]=0;f[Qb+4>>2]=0;f[Qb+8>>2]=0;f[Qb+12>>2]=0;f[Qb+16>>2]=0;f[Qb+20>>2]=0;f[Qb+24>>2]=0;f[Qb+28>>2]=0;Qb=Y(Ob|wb,Oa)|0;Ub=Pb&65535;d[Lb>>1]=Ub;Sb=Pb&65535;Tb=Jb+1|0;Vb=(Jb|0)<(Oa|0)?Tb:Oa;if((Sb|0)<(Vb|0)){Wb=Ba+(Qb+Pb<<4<<1)|0;Xb=Ub;while(1){Ub=0;do{Yb=i+(ob*544|0)+32+(Ob<<5)+(Ub<<1)|0;d[Yb>>1]=(j[Yb>>1]|0)+(j[Wb+(Ub<<1)>>1]|0);Ub=Ub+1|0}while((Ub|0)!=16);Xb=Xb+1<<16>>16;d[Lb>>1]=Xb;Ub=Xb&65535;if((Ub|0)>=(Vb|0)){Zb=Ub;break}else Wb=Wb+32|0}}else Zb=Sb;if((Zb|0)>(Jb|0))break;Wb=Ba+(Qb+gb<<4<<1)|0;Vb=Tb-Oa|0;Xb=0;do{Ub=Y(j[Wb+(Xb<<1)>>1]|0,Vb)|0;Yb=i+(ob*544|0)+32+(Ob<<5)+(Xb<<1)|0;d[Yb>>1]=(j[Yb>>1]|0)+Ub;Xb=Xb+1|0}while((Xb|0)!=16);d[Lb>>1]=Tb}while(0);Lb=Ka+(((Pb|0)>0?Pb:0)+qb<<4<<1)|0;Jb=0;do{Mb=i+(ob*544|0)+(Jb<<1)|0;d[Mb>>1]=(j[Mb>>1]|0)-(j[Lb+(Jb<<1)>>1]|0);Jb=Jb+1|0}while((Jb|0)!=16);Jb=(j[i+(ob*544|0)+32+(Ob<<5)>>1]|0)+Nb|0;do if((Jb|0)<=(Pa|0)){Lb=(j[i+(ob*544|0)+32+(Ob<<5)+2>>1]|0)+Jb|0;if((Lb|0)>(Pa|0)){_b=1;break}Pb=(j[i+(ob*544|0)+32+(Ob<<5)+4>>1]|0)+Lb|0;if((Pb|0)>(Pa|0)){_b=2;break}Lb=(j[i+(ob*544|0)+32+(Ob<<5)+6>>1]|0)+Pb|0;if((Lb|0)>(Pa|0)){_b=3;break}Pb=(j[i+(ob*544|0)+32+(Ob<<5)+8>>1]|0)+Lb|0;if((Pb|0)>(Pa|0)){_b=4;break}Lb=(j[i+(ob*544|0)+32+(Ob<<5)+10>>1]|0)+Pb|0;if((Lb|0)>(Pa|0)){_b=5;break}Pb=(j[i+(ob*544|0)+32+(Ob<<5)+12>>1]|0)+Lb|0;if((Pb|0)>(Pa|0)){_b=6;break}Lb=(j[i+(ob*544|0)+32+(Ob<<5)+14>>1]|0)+Pb|0;if((Lb|0)>(Pa|0)){_b=7;break}Pb=(j[i+(ob*544|0)+32+(Ob<<5)+16>>1]|0)+Lb|0;if((Pb|0)>(Pa|0)){_b=8;break}Lb=(j[i+(ob*544|0)+32+(Ob<<5)+18>>1]|0)+Pb|0;if((Lb|0)>(Pa|0)){_b=9;break}Pb=(j[i+(ob*544|0)+32+(Ob<<5)+20>>1]|0)+Lb|0;if((Pb|0)>(Pa|0)){_b=10;break}Lb=(j[i+(ob*544|0)+32+(Ob<<5)+22>>1]|0)+Pb|0;if((Lb|0)>(Pa|0)){_b=11;break}Pb=(j[i+(ob*544|0)+32+(Ob<<5)+24>>1]|0)+Lb|0;if((Pb|0)>(Pa|0)){_b=12;break}Lb=(j[i+(ob*544|0)+32+(Ob<<5)+26>>1]|0)+Pb|0;if((Lb|0)>(Pa|0)){_b=13;break}Pb=(j[i+(ob*544|0)+32+(Ob<<5)+28>>1]|0)+Lb|0;if((Pb|0)>(Pa|0)){_b=14;break}if(((j[i+(ob*544|0)+32+(Ob<<5)+30>>1]|0)+Pb|0)>(Pa|0))_b=15;else{Ya=288;break e}}else _b=0;while(0);Jb=fb+(pb+(Y(Ib,Ma)|0))|0;b[Jb>>0]=_b|Ob<<4;Ib=Ib+1|0}while((Ib|0)<(eb|0))}if((ob|0)<(ta|0))ob=ob+1|0;else break}kb=kb+1|0}while((kb|0)<(La|0))}Ra=Ra+Da|0;Sa=f[Ea>>2]|0;if((Sa|0)<=(Ra|0)){Ya=198;break}}if((Ya|0)==198){Ra=f[m>>2]|0;if(!Ra)break;$b=f[Ca>>2]|0;ac=Ra;bc=Ra;Ya=200;break}else if((Ya|0)==273){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=6;b[o>>0]=b[270266]|0;b[o+1>>0]=b[270267]|0;b[o+2>>0]=b[270268]|0;b[o+3>>0]=b[270269]|0;b[o+4>>0]=b[270270]|0;b[o+5>>0]=b[270271]|0;b[o+6>>0]=0;vM(-215,o,270249,270082,228)}else if((Ya|0)==288){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=6;b[o>>0]=b[270273]|0;b[o+1>>0]=b[270274]|0;b[o+2>>0]=b[270275]|0;b[o+3>>0]=b[270276]|0;b[o+4>>0]=b[270277]|0;b[o+5>>0]=b[270278]|0;b[o+6>>0]=0;vM(-215,o,270249,270082,324)}}else{$b=Ia;ac=Ja;bc=Ja;Ya=200}while(0);if((Ya|0)==200){if(($b|0)!=(ac|0))f[Ca>>2]=$b+(~(($b+-2-ac|0)>>>1)<<1);cYc(bc)}Ja=f[l>>2]|0;if(Ja|0){Ia=f[da>>2]|0;if((Ia|0)!=(Ja|0))f[da>>2]=Ia+(~((Ia+-2-Ja|0)>>>1)<<1);cYc(Ja)}}else{if((f[aa>>2]|0)==(f[R>>2]|0)){Ja=i+8|0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=O;jR(L,i)}else{Ja=L+36|0;Ia=f[Ja>>2]|0;if(Ia){Ea=Ia+12|0;f[Ea>>2]=(f[Ea>>2]|0)+1;Ea=O+36|0;Ia=f[Ea>>2]|0;if((Ia|0)!=0?(Da=Ia+12|0,Ia=f[Da>>2]|0,f[Da>>2]=Ia+-1,(Ia|0)==1):0){V$(O);cc=Ea}else cc=Ea}else cc=O+36|0;f[cc>>2]=0;Ea=O+16|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[P>>2]|0)>0){Ia=f[Z>>2]|0;Da=0;do{f[Ia+(Da<<2)>>2]=0;Da=Da+1|0;dc=f[P>>2]|0}while((Da|0)<(dc|0));f[O>>2]=f[_>>2];if((dc|0)<3)Ya=37;else Ya=39}else{f[O>>2]=f[_>>2];Ya=37}if((Ya|0)==37){Da=f[L+4>>2]|0;if((Da|0)<3){f[P>>2]=Da;f[X>>2]=f[V>>2];f[O+12>>2]=f[M>>2];Da=f[L+44>>2]|0;Ia=f[W>>2]|0;f[Ia>>2]=f[Da>>2];f[Ia+4>>2]=f[Da+4>>2]}else Ya=39}if((Ya|0)==39)U$(O,L);f[Ea>>2]=f[R>>2];f[O+20>>2]=f[L+20>>2];f[O+24>>2]=f[L+24>>2];f[O+28>>2]=f[L+28>>2];f[O+32>>2]=f[L+32>>2];f[cc>>2]=f[Ja>>2]}Da=f[O>>2]|0;switch(Da&7){case 0:{epa(O,N,e);break a;break}case 2:{Ia=f[O+16>>2]|0;da=f[aa>>2]|0;Ca=(f[Q>>2]|0)>>>1;La=(f[N+48>>2]|0)>>>1;ta=f[N+40>>2]|0;Ma=f[ta+4>>2]|0;Ka=f[ta>>2]|0;ta=Da>>>3;Ba=ta&511;Fa=Ba+1|0;switch(e|0){case 3:{Na=(Ka|0)==1;if((Ma|0)==1|Na){ka=Ka+Ma|0;ca=ka+-1|0;Ga=Na?Fa:Ca;la=Na?0:Ca-Fa|0;Ha=Na?Fa:La;if((ka|0)<=1)break a;Na=0-Ga|0;ua=ka+-2|0;ka=da;ma=0;Ra=Ia;while(1){Sa=(ma|0)>0?Na:0;Pa=(ma|0)<(ua|0)?Ga:0;Qa=0;sa=Ra;while(1){ra=d[sa+(Sa<<1)>>1]|0;ia=d[sa>>1]|0;qa=j[sa+(Pa<<1)>>1]|0;na=(ia&65535)<(ra&65535);ya=(na?ia:ra)&65535;pa=(na?ra:ia)&65535;ia=qa>>>0<pa>>>0?qa:pa;d[ka+(Qa<<1)>>1]=(ia|0)<(ya|0)?ya:ia;Qa=Qa+1|0;if((Qa|0)==(Fa|0))break;else sa=sa+2|0}ma=ma+1|0;if((ma|0)>=(ca|0))break a;else{ka=ka+(Ha<<1)|0;Ra=Ra+(Fa<<1)+(la<<1)|0}}}la=Y(Ma,Fa)|0;if((Ka|0)<=0)break a;Ra=Ka+-1|0;Ha=(ta|-512)^511;ka=Ha+-1+la|0;ca=la-Fa|0;ma=da;Ga=0;while(1){ua=Ga+-1|0;Na=Ia+((Y((ua|0)>0?ua:0,Ca)|0)<<1)|0;ua=Ia+((Y(Ga,Ca)|0)<<1)|0;Ga=Ga+1|0;Ja=Ia+((Y((Ra|0)<(Ga|0)?Ra:Ga,Ca)|0)<<1)|0;Ea=Fa;sa=0;f:while(1){if((sa|0)<(Ea|0)){Qa=sa;do{Pa=Qa-((Qa|0)>(Ba|0)?Fa:0)|0;Sa=((Qa|0)<(ca|0)?Fa:0)+Qa|0;ia=d[Na+(Pa<<1)>>1]|0;ya=d[Na+(Qa<<1)>>1]|0;pa=d[Na+(Sa<<1)>>1]|0;qa=d[ua+(Pa<<1)>>1]|0;ra=d[ua+(Qa<<1)>>1]|0;na=d[ua+(Sa<<1)>>1]|0;xa=d[Ja+(Pa<<1)>>1]|0;Pa=d[Ja+(Qa<<1)>>1]|0;va=d[Ja+(Sa<<1)>>1]|0;Sa=(pa&65535)<(ya&65535);wa=Sa?pa:ya;za=Sa?ya:pa;pa=(na&65535)<(ra&65535);ya=pa?na:ra;Sa=pa?ra:na;na=(va&65535)<(Pa&65535);ra=na?va:Pa;pa=na?Pa:va;va=(wa&65535)<(ia&65535);Pa=(va?wa:ia)&65535;na=va?ia:wa;wa=(ya&65535)<(qa&65535);ia=(wa?ya:qa)&65535;va=wa?qa:ya;ya=(ra&65535)<(xa&65535);qa=(ya?ra:xa)&65535;wa=ya?xa:ra;ra=(za&65535)<(na&65535);xa=(ra?za:na)&65535;ya=(ra?na:za)&65535;za=(Sa&65535)<(va&65535);na=za?Sa:va;ra=(za?va:Sa)&65535;Sa=(pa&65535)<(wa&65535);va=Sa?pa:wa;za=(Sa?wa:pa)&65535;pa=ia>>>0<Pa>>>0?Pa:ia;ia=za>>>0<ra>>>0?za:ra;ra=(va&65535)<(na&65535);za=(ra?va:na)&65535;Pa=(ra?na:va)&65535;va=(qa|0)<(pa|0)?pa:qa;qa=za>>>0<xa>>>0?xa:za;za=(ia|0)<(ya|0)?ia:ya;ya=(Pa|0)<(qa|0)?Pa:qa;qa=(za|0)<(ya|0);Pa=qa?za:ya;ia=qa?ya:za;za=(Pa|0)<(va|0)?va:Pa;d[ma+(Qa<<1)>>1]=(ia|0)<(za|0)?ia:za;Qa=Qa+1|0}while((Qa|0)!=(Ea|0));ec=Ea}else ec=sa;if((Ea|0)==(la|0))break;if((ec|0)>(ka|0)){Ea=la;sa=ec;continue}else fc=ec;while(1){Qa=Na+(fc<<1)|0;za=d[Qa+(Ha<<1)>>1]|0;ia=d[Qa>>1]|0;Pa=d[Qa+(Fa<<1)>>1]|0;Qa=ua+(fc<<1)|0;va=d[Qa+(Ha<<1)>>1]|0;ya=d[Qa>>1]|0;qa=d[Qa+(Fa<<1)>>1]|0;Qa=Ja+(fc<<1)|0;xa=d[Qa+(Ha<<1)>>1]|0;pa=d[Qa>>1]|0;na=d[Qa+(Fa<<1)>>1]|0;Qa=(Pa&65535)<(ia&65535);ra=Qa?Pa:ia;wa=Qa?ia:Pa;Pa=(qa&65535)<(ya&65535);ia=Pa?qa:ya;Qa=Pa?ya:qa;qa=(na&65535)<(pa&65535);ya=qa?na:pa;Pa=qa?pa:na;na=(ra&65535)<(za&65535);pa=(na?ra:za)&65535;qa=na?za:ra;ra=(ia&65535)<(va&65535);za=(ra?ia:va)&65535;na=ra?va:ia;ia=(ya&65535)<(xa&65535);va=(ia?ya:xa)&65535;ra=ia?xa:ya;ya=(wa&65535)<(qa&65535);xa=(ya?wa:qa)&65535;ia=(ya?qa:wa)&65535;wa=(Qa&65535)<(na&65535);qa=wa?Qa:na;ya=(wa?na:Qa)&65535;Qa=(Pa&65535)<(ra&65535);na=Qa?Pa:ra;wa=(Qa?ra:Pa)&65535;Pa=za>>>0<pa>>>0?pa:za;za=wa>>>0<ya>>>0?wa:ya;ya=(na&65535)<(qa&65535);wa=(ya?na:qa)&65535;pa=(ya?qa:na)&65535;na=(va|0)<(Pa|0)?Pa:va;va=wa>>>0<xa>>>0?xa:wa;wa=(za|0)<(ia|0)?za:ia;ia=(pa|0)<(va|0)?pa:va;va=(wa|0)<(ia|0);pa=va?wa:ia;za=va?ia:wa;wa=(pa|0)<(na|0)?na:pa;d[ma+(fc<<1)>>1]=(za|0)<(wa|0)?za:wa;wa=fc+1|0;if((fc|0)<(ka|0))fc=wa;else{Ea=la;sa=wa;continue f}}}if((Ga|0)==(Ka|0))break;else ma=ma+(La<<1)|0}break}case 5:{ma=(Ka|0)==1;if((Ma|0)==1|ma){Ga=Ka+Ma|0;la=Ga+-1|0;ka=ma?Fa:Ca;Ha=ma?0:Ca-Fa|0;ca=ma?Fa:La;if((Ga|0)<=1)break a;ma=0-ka|0;Ra=ma<<1;sa=Ga+-2|0;Ea=Ga+-3|0;Ga=ka<<1;Ja=da;ua=0;Na=Ia;while(1){wa=(ua|0)>0?ma:0;za=(ua|0)>1?Ra:wa;pa=(ua|0)<(sa|0)?ka:0;na=(ua|0)<(Ea|0)?Ga:pa;ia=Na;va=0;while(1){xa=d[ia+(za<<1)>>1]|0;Pa=d[ia+(wa<<1)>>1]|0;qa=d[ia>>1]|0;ya=d[ia+(pa<<1)>>1]|0;ra=d[ia+(na<<1)>>1]|0;Qa=(Pa&65535)<(xa&65535);Sa=(Qa?Pa:xa)&65535;Aa=(Qa?xa:Pa)&65535;Pa=(ra&65535)<(ya&65535);xa=Pa?ra:ya;Qa=Pa?ya:ra;ra=(xa&65535)<(qa&65535);ya=(ra?xa:qa)&65535;Pa=ra?qa:xa;xa=(Qa&65535)<(Pa&65535);qa=(xa?Qa:Pa)&65535;ra=(xa?Pa:Qa)&65535;Qa=ya>>>0<Sa>>>0?Sa:ya;ya=(ra|0)<(Qa|0)?ra:Qa;Qa=qa>>>0<Aa>>>0?qa:Aa;d[Ja+(va<<1)>>1]=(ya|0)<(Qa|0)?Qa:ya;va=va+1|0;if((va|0)==(Fa|0))break;else ia=ia+2|0}ua=ua+1|0;if((ua|0)>=(la|0))break a;else{Ja=Ja+(ca<<1)|0;Na=Na+(Fa<<1)+(Ha<<1)|0}}}Ha=Y(Ma,Fa)|0;if((Ka|0)<=0)break a;Na=Ka+-1|0;ca=Fa<<1;Ja=0-ca|0;la=Ha+~ca|0;ua=(ta|-512)^511;Ga=Ha-Fa|0;Ea=Ha-ca|0;ka=da;sa=0;while(1){Ra=sa+-2|0;ma=Ia+((Y((Ra|0)>0?Ra:0,Ca)|0)<<1)|0;Ra=sa+-1|0;ia=Ia+((Y((Ra|0)>0?Ra:0,Ca)|0)<<1)|0;Ra=Ia+((Y(sa,Ca)|0)<<1)|0;va=sa;sa=sa+1|0;na=Ia+((Y((Na|0)<(sa|0)?Na:sa,Ca)|0)<<1)|0;pa=va+2|0;va=Ia+((Y((Na|0)<(pa|0)?Na:pa,Ca)|0)<<1)|0;pa=ca;wa=0;g:while(1){if((wa|0)<(pa|0)){za=wa;do{ya=za-((za|0)>(Ba|0)?Fa:0)|0;Qa=(za|0)<(ca|0)?ya:za-ca|0;Aa=((za|0)<(Ga|0)?Fa:0)+za|0;qa=(za|0)<(Ea|0)?za+ca|0:Aa;ra=d[ma+(Qa<<1)>>1]|0;Sa=d[ma+(ya<<1)>>1]|0;Pa=d[ma+(za<<1)>>1]|0;xa=d[ma+(Aa<<1)>>1]|0;kb=d[ma+(qa<<1)>>1]|0;eb=d[ia+(Qa<<1)>>1]|0;fb=d[ia+(ya<<1)>>1]|0;Oa=d[ia+(za<<1)>>1]|0;gb=d[ia+(Aa<<1)>>1]|0;_a=d[ia+(qa<<1)>>1]|0;db=d[Ra+(Qa<<1)>>1]|0;Wa=d[Ra+(ya<<1)>>1]|0;bb=d[Ra+(za<<1)>>1]|0;$a=d[Ra+(Aa<<1)>>1]|0;Xa=d[Ra+(qa<<1)>>1]|0;ob=d[na+(Qa<<1)>>1]|0;cb=d[na+(ya<<1)>>1]|0;nb=d[na+(za<<1)>>1]|0;mb=d[na+(Aa<<1)>>1]|0;Ib=d[na+(qa<<1)>>1]|0;pb=d[va+(Qa<<1)>>1]|0;Qa=d[va+(ya<<1)>>1]|0;ya=d[va+(za<<1)>>1]|0;qb=d[va+(Aa<<1)>>1]|0;Aa=d[va+(qa<<1)>>1]|0;qa=(Pa&65535)<(Sa&65535)?Pa:Sa;Hb=(Pa&65535)>(Sa&65535)?Pa:Sa;Sa=(qa&65535)<(ra&65535);Pa=Sa?qa:ra;Gb=Sa?ra:qa;qa=(Hb&65535)<(Gb&65535);ra=qa?Hb:Gb;Sa=qa?Gb:Hb;Hb=(eb&65535)<(kb&65535);Gb=Hb?eb:kb;qa=Hb?kb:eb;eb=(Gb&65535)<(xa&65535);kb=eb?Gb:xa;Hb=eb?xa:Gb;Gb=(qa&65535)<(Hb&65535);xa=Gb?qa:Hb;eb=Gb?Hb:qa;qa=(kb&65535)<(Pa&65535);Hb=qa?kb:Pa;Gb=qa?Pa:kb;kb=(eb&65535)<(Sa&65535);Pa=kb?eb:Sa;qa=kb?Sa:eb;eb=(Gb&65535)<(Pa&65535);Sa=eb?Gb:Pa;kb=eb?Pa:Gb;Gb=(xa&65535)<(ra&65535);Pa=Gb?xa:ra;eb=Gb?ra:xa;xa=(Sa&65535)<(Pa&65535);ra=xa?Sa:Pa;Gb=xa?Pa:Sa;Sa=(eb&65535)<(kb&65535);Pa=Sa?eb:kb;xa=Sa?kb:eb;eb=(gb&65535)<(Oa&65535);kb=eb?gb:Oa;Sa=eb?Oa:gb;gb=(kb&65535)<(fb&65535);Oa=gb?kb:fb;eb=gb?fb:kb;kb=(Sa&65535)<(eb&65535);fb=kb?Sa:eb;gb=kb?eb:Sa;Sa=(Wa&65535)<(db&65535);eb=Sa?Wa:db;kb=Sa?db:Wa;Wa=(eb&65535)<(_a&65535);db=Wa?eb:_a;Sa=Wa?_a:eb;eb=(kb&65535)<(Sa&65535);_a=eb?kb:Sa;Wa=eb?Sa:kb;kb=(db&65535)<(Oa&65535);Sa=kb?db:Oa;eb=kb?Oa:db;db=(Wa&65535)<(gb&65535);Oa=db?Wa:gb;kb=db?gb:Wa;Wa=(eb&65535)<(Oa&65535);gb=Wa?eb:Oa;db=Wa?Oa:eb;eb=(_a&65535)<(fb&65535);Oa=eb?_a:fb;Wa=eb?fb:_a;_a=(gb&65535)<(Oa&65535);fb=_a?gb:Oa;eb=_a?Oa:gb;gb=(Wa&65535)<(db&65535);Oa=gb?Wa:db;_a=gb?db:Wa;Wa=(Sa&65535)<(Hb&65535);db=(Wa?Sa:Hb)&65535;gb=Wa?Hb:Sa;Sa=(_a&65535)<(xa&65535);Hb=Sa?_a:xa;Wa=Sa?xa:_a;_a=(gb&65535)<(Hb&65535);xa=_a?gb:Hb;Sa=_a?Hb:gb;gb=(eb&65535)<(Gb&65535);Hb=gb?eb:Gb;_a=gb?Gb:eb;eb=(xa&65535)<(Hb&65535);Gb=eb?xa:Hb;gb=eb?Hb:xa;xa=(_a&65535)<(Sa&65535);Hb=xa?_a:Sa;eb=xa?Sa:_a;_a=(fb&65535)<(ra&65535);Sa=_a?fb:ra;xa=_a?ra:fb;fb=(kb&65535)<(qa&65535);ra=fb?kb:qa;_a=(fb?qa:kb)&65535;kb=(xa&65535)<(ra&65535);qa=kb?xa:ra;fb=kb?ra:xa;xa=(Oa&65535)<(Pa&65535);ra=xa?Oa:Pa;kb=xa?Pa:Oa;Oa=(qa&65535)<(ra&65535);Pa=Oa?qa:ra;xa=Oa?ra:qa;qa=(kb&65535)<(fb&65535);ra=qa?kb:fb;Oa=qa?fb:kb;kb=(Gb&65535)<(Sa&65535);fb=(kb?Gb:Sa)&65535;qa=(kb?Sa:Gb)&65535;Gb=(gb&65535)<(Pa&65535);Sa=(Gb?gb:Pa)&65535;kb=(Gb?Pa:gb)&65535;gb=(Hb&65535)<(xa&65535);Pa=(gb?Hb:xa)&65535;Gb=(gb?xa:Hb)&65535;Hb=(eb&65535)<(ra&65535);xa=(Hb?eb:ra)&65535;gb=(Hb?ra:eb)&65535;eb=(Wa&65535)<(Oa&65535);ra=(eb?Wa:Oa)&65535;Hb=(eb?Oa:Wa)&65535;Wa=(Xa&65535)<($a&65535);Oa=Wa?Xa:$a;eb=Wa?$a:Xa;Xa=(Oa&65535)<(bb&65535);$a=Xa?Oa:bb;Wa=Xa?bb:Oa;Oa=(eb&65535)<(Wa&65535);bb=Oa?eb:Wa;Xa=Oa?Wa:eb;eb=(nb&65535)<(cb&65535);Wa=eb?nb:cb;Oa=eb?cb:nb;nb=(Wa&65535)<(ob&65535);cb=nb?Wa:ob;eb=nb?ob:Wa;Wa=(Oa&65535)<(eb&65535);ob=Wa?Oa:eb;nb=Wa?eb:Oa;Oa=(cb&65535)<($a&65535);eb=Oa?cb:$a;Wa=Oa?$a:cb;cb=(nb&65535)<(Xa&65535);$a=cb?nb:Xa;Oa=cb?Xa:nb;nb=(Wa&65535)<($a&65535);Xa=nb?Wa:$a;cb=nb?$a:Wa;Wa=(ob&65535)<(bb&65535);$a=Wa?ob:bb;nb=Wa?bb:ob;ob=(Xa&65535)<($a&65535);bb=ob?Xa:$a;Wa=ob?$a:Xa;Xa=(nb&65535)<(cb&65535);$a=Xa?nb:cb;ob=Xa?cb:nb;nb=(pb&65535)<(Ib&65535);cb=nb?pb:Ib;Xa=nb?Ib:pb;pb=(cb&65535)<(mb&65535);Ib=pb?cb:mb;nb=pb?mb:cb;cb=(Xa&65535)<(nb&65535);mb=cb?Xa:nb;pb=cb?nb:Xa;Xa=(ya&65535)<(Qa&65535);nb=Xa?ya:Qa;cb=Xa?Qa:ya;ya=(Aa&65535)<(qb&65535);Qa=ya?Aa:qb;Xa=ya?qb:Aa;Aa=(Qa&65535)<(nb&65535);qb=Aa?Qa:nb;ya=Aa?nb:Qa;Qa=(Xa&65535)<(cb&65535);nb=Qa?Xa:cb;Aa=Qa?cb:Xa;Xa=(ya&65535)<(nb&65535);cb=Xa?ya:nb;Qa=Xa?nb:ya;ya=(qb&65535)<(Ib&65535);nb=ya?qb:Ib;Xa=ya?Ib:qb;qb=(Qa&65535)<(pb&65535);Ib=qb?Qa:pb;ya=qb?pb:Qa;Qa=(Xa&65535)<(Ib&65535);pb=Qa?Xa:Ib;qb=Qa?Ib:Xa;Xa=(cb&65535)<(mb&65535);Ib=Xa?cb:mb;Qa=Xa?mb:cb;cb=(Aa&65535)<(Qa&65535);mb=cb?Aa:Qa;Xa=cb?Qa:Aa;Aa=(pb&65535)<(Ib&65535);Qa=Aa?pb:Ib;cb=Aa?Ib:pb;pb=(mb&65535)<(qb&65535);Ib=pb?mb:qb;Aa=pb?qb:mb;mb=(Xa&65535)<(ya&65535);qb=mb?Xa:ya;pb=mb?ya:Xa;Xa=(nb&65535)<(eb&65535);ya=(Xa?nb:eb)&65535;mb=Xa?eb:nb;nb=(Aa&65535)<(ob&65535);eb=nb?Aa:ob;Xa=nb?ob:Aa;Aa=(mb&65535)<(eb&65535);ob=Aa?mb:eb;nb=Aa?eb:mb;mb=(cb&65535)<(Wa&65535);eb=mb?cb:Wa;Aa=mb?Wa:cb;cb=(pb&65535)<(Aa&65535);Wa=cb?pb:Aa;mb=cb?Aa:pb;pb=(ob&65535)<(eb&65535);Aa=pb?ob:eb;cb=pb?eb:ob;ob=(Wa&65535)<(nb&65535);eb=ob?Wa:nb;pb=ob?nb:Wa;Wa=(mb&65535)<(Xa&65535);nb=Wa?mb:Xa;ob=Wa?Xa:mb;mb=(Qa&65535)<(bb&65535);Xa=mb?Qa:bb;Wa=mb?bb:Qa;Qa=(qb&65535)<(Oa&65535);bb=Qa?qb:Oa;mb=Qa?Oa:qb;qb=(Wa&65535)<(bb&65535);Oa=qb?Wa:bb;Qa=qb?bb:Wa;Wa=(Ib&65535)<($a&65535);bb=Wa?Ib:$a;qb=Wa?$a:Ib;Ib=(Oa&65535)<(bb&65535);$a=Ib?Oa:bb;Wa=Ib?bb:Oa;Oa=(qb&65535)<(Qa&65535);bb=Oa?qb:Qa;Ib=Oa?Qa:qb;qb=(Aa&65535)<(Xa&65535);Qa=(qb?Aa:Xa)&65535;Oa=(qb?Xa:Aa)&65535;Aa=(cb&65535)<($a&65535);Xa=(Aa?cb:$a)&65535;qb=(Aa?$a:cb)&65535;cb=(eb&65535)<(Wa&65535);$a=(cb?eb:Wa)&65535;Aa=(cb?Wa:eb)&65535;eb=(pb&65535)<(bb&65535);Wa=(eb?pb:bb)&65535;cb=(eb?bb:pb)&65535;pb=(nb&65535)<(Ib&65535);bb=(pb?nb:Ib)&65535;eb=(pb?Ib:nb)&65535;nb=(ob&65535)<(mb&65535);Ib=(nb?ob:mb)&65535;pb=(nb?mb:ob)&65535;ob=ya>>>0<db>>>0?db:ya;ya=cb>>>0<gb>>>0?cb:gb;gb=(ob|0)<(ya|0)?ya:ob;ob=qb>>>0<kb>>>0?kb:qb;qb=(pb|0)<(ob|0)?pb:ob;ob=(qb|0)<(gb|0)?qb:gb;gb=Oa>>>0<qa>>>0?qa:Oa;Oa=eb>>>0<Hb>>>0?eb:Hb;Hb=(gb|0)<(Oa|0)?gb:Oa;Oa=Aa>>>0<Gb>>>0?Aa:Gb;Gb=(Hb|0)<(Oa|0)?Oa:Hb;Hb=(ob|0)<(Gb|0)?Gb:ob;ob=Qa>>>0<fb>>>0?fb:Qa;Qa=bb>>>0<ra>>>0?bb:ra;ra=(ob|0)<(Qa|0)?Qa:ob;ob=$a>>>0<Pa>>>0?Pa:$a;$a=(ob|0)<(ra|0)?ob:ra;ra=Xa>>>0<Sa>>>0?Sa:Xa;Xa=Ib>>>0<_a>>>0?Ib:_a;_a=(ra|0)<(Xa|0)?ra:Xa;Xa=Wa>>>0<xa>>>0?Wa:xa;xa=(_a|0)<(Xa|0)?Xa:_a;_a=($a|0)<(xa|0)?$a:xa;d[ka+(za<<1)>>1]=(Hb|0)<(_a|0)?_a:Hb;za=za+1|0}while((za|0)!=(pa|0));gc=pa}else gc=wa;if((pa|0)==(Ha|0))break;if((gc|0)>(la|0)){pa=Ha;wa=gc;continue}else hc=gc;while(1){za=ma+(hc<<1)|0;Hb=d[za+(Ja<<1)>>1]|0;_a=d[za+(ua<<1)>>1]|0;xa=d[za>>1]|0;$a=d[za+(Fa<<1)>>1]|0;Xa=d[za+(ca<<1)>>1]|0;za=ia+(hc<<1)|0;Wa=d[za+(Ja<<1)>>1]|0;ra=d[za+(ua<<1)>>1]|0;Ib=d[za>>1]|0;Sa=d[za+(Fa<<1)>>1]|0;ob=d[za+(ca<<1)>>1]|0;za=Ra+(hc<<1)|0;Pa=d[za+(Ja<<1)>>1]|0;Qa=d[za+(ua<<1)>>1]|0;bb=d[za>>1]|0;fb=d[za+(Fa<<1)>>1]|0;Gb=d[za+(ca<<1)>>1]|0;za=na+(hc<<1)|0;Oa=d[za+(Ja<<1)>>1]|0;Aa=d[za+(ua<<1)>>1]|0;gb=d[za>>1]|0;eb=d[za+(Fa<<1)>>1]|0;qa=d[za+(ca<<1)>>1]|0;za=va+(hc<<1)|0;qb=d[za+(Ja<<1)>>1]|0;pb=d[za+(ua<<1)>>1]|0;kb=d[za>>1]|0;ya=d[za+(Fa<<1)>>1]|0;cb=d[za+(ca<<1)>>1]|0;za=(xa&65535)<(_a&65535)?xa:_a;db=(xa&65535)>(_a&65535)?xa:_a;_a=(za&65535)<(Hb&65535);xa=_a?za:Hb;mb=_a?Hb:za;za=(db&65535)<(mb&65535);Hb=za?db:mb;_a=za?mb:db;db=(Wa&65535)<(Xa&65535);mb=db?Wa:Xa;za=db?Xa:Wa;Wa=(mb&65535)<($a&65535);Xa=Wa?mb:$a;db=Wa?$a:mb;mb=(za&65535)<(db&65535);$a=mb?za:db;Wa=mb?db:za;za=(Xa&65535)<(xa&65535);db=za?Xa:xa;mb=za?xa:Xa;Xa=(Wa&65535)<(_a&65535);xa=Xa?Wa:_a;za=Xa?_a:Wa;Wa=(mb&65535)<(xa&65535);_a=Wa?mb:xa;Xa=Wa?xa:mb;mb=($a&65535)<(Hb&65535);xa=mb?$a:Hb;Wa=mb?Hb:$a;$a=(_a&65535)<(xa&65535);Hb=$a?_a:xa;mb=$a?xa:_a;_a=(Wa&65535)<(Xa&65535);xa=_a?Wa:Xa;$a=_a?Xa:Wa;Wa=(Sa&65535)<(Ib&65535);Xa=Wa?Sa:Ib;_a=Wa?Ib:Sa;Sa=(Xa&65535)<(ra&65535);Ib=Sa?Xa:ra;Wa=Sa?ra:Xa;Xa=(_a&65535)<(Wa&65535);ra=Xa?_a:Wa;Sa=Xa?Wa:_a;_a=(Qa&65535)<(Pa&65535);Wa=_a?Qa:Pa;Xa=_a?Pa:Qa;Qa=(Wa&65535)<(ob&65535);Pa=Qa?Wa:ob;_a=Qa?ob:Wa;Wa=(Xa&65535)<(_a&65535);ob=Wa?Xa:_a;Qa=Wa?_a:Xa;Xa=(Pa&65535)<(Ib&65535);_a=Xa?Pa:Ib;Wa=Xa?Ib:Pa;Pa=(Qa&65535)<(Sa&65535);Ib=Pa?Qa:Sa;Xa=Pa?Sa:Qa;Qa=(Wa&65535)<(Ib&65535);Sa=Qa?Wa:Ib;Pa=Qa?Ib:Wa;Wa=(ob&65535)<(ra&65535);Ib=Wa?ob:ra;Qa=Wa?ra:ob;ob=(Sa&65535)<(Ib&65535);ra=ob?Sa:Ib;Wa=ob?Ib:Sa;Sa=(Qa&65535)<(Pa&65535);Ib=Sa?Qa:Pa;ob=Sa?Pa:Qa;Qa=(_a&65535)<(db&65535);Pa=(Qa?_a:db)&65535;Sa=Qa?db:_a;_a=(ob&65535)<($a&65535);db=_a?ob:$a;Qa=_a?$a:ob;ob=(Sa&65535)<(db&65535);$a=ob?Sa:db;_a=ob?db:Sa;Sa=(Wa&65535)<(mb&65535);db=Sa?Wa:mb;ob=Sa?mb:Wa;Wa=($a&65535)<(db&65535);mb=Wa?$a:db;Sa=Wa?db:$a;$a=(ob&65535)<(_a&65535);db=$a?ob:_a;Wa=$a?_a:ob;ob=(ra&65535)<(Hb&65535);_a=ob?ra:Hb;$a=ob?Hb:ra;ra=(Xa&65535)<(za&65535);Hb=ra?Xa:za;ob=(ra?za:Xa)&65535;Xa=($a&65535)<(Hb&65535);za=Xa?$a:Hb;ra=Xa?Hb:$a;$a=(Ib&65535)<(xa&65535);Hb=$a?Ib:xa;Xa=$a?xa:Ib;Ib=(za&65535)<(Hb&65535);xa=Ib?za:Hb;$a=Ib?Hb:za;za=(Xa&65535)<(ra&65535);Hb=za?Xa:ra;Ib=za?ra:Xa;Xa=(mb&65535)<(_a&65535);ra=(Xa?mb:_a)&65535;za=(Xa?_a:mb)&65535;mb=(Sa&65535)<(xa&65535);_a=(mb?Sa:xa)&65535;Xa=(mb?xa:Sa)&65535;Sa=(db&65535)<($a&65535);xa=(Sa?db:$a)&65535;mb=(Sa?$a:db)&65535;db=(Wa&65535)<(Hb&65535);$a=(db?Wa:Hb)&65535;Sa=(db?Hb:Wa)&65535;Wa=(Qa&65535)<(Ib&65535);Hb=(Wa?Qa:Ib)&65535;db=(Wa?Ib:Qa)&65535;Qa=(Gb&65535)<(fb&65535);Ib=Qa?Gb:fb;Wa=Qa?fb:Gb;Gb=(Ib&65535)<(bb&65535);fb=Gb?Ib:bb;Qa=Gb?bb:Ib;Ib=(Wa&65535)<(Qa&65535);bb=Ib?Wa:Qa;Gb=Ib?Qa:Wa;Wa=(gb&65535)<(Aa&65535);Qa=Wa?gb:Aa;Ib=Wa?Aa:gb;gb=(Qa&65535)<(Oa&65535);Aa=gb?Qa:Oa;Wa=gb?Oa:Qa;Qa=(Ib&65535)<(Wa&65535);Oa=Qa?Ib:Wa;gb=Qa?Wa:Ib;Ib=(Aa&65535)<(fb&65535);Wa=Ib?Aa:fb;Qa=Ib?fb:Aa;Aa=(gb&65535)<(Gb&65535);fb=Aa?gb:Gb;Ib=Aa?Gb:gb;gb=(Qa&65535)<(fb&65535);Gb=gb?Qa:fb;Aa=gb?fb:Qa;Qa=(Oa&65535)<(bb&65535);fb=Qa?Oa:bb;gb=Qa?bb:Oa;Oa=(Gb&65535)<(fb&65535);bb=Oa?Gb:fb;Qa=Oa?fb:Gb;Gb=(gb&65535)<(Aa&65535);fb=Gb?gb:Aa;Oa=Gb?Aa:gb;gb=(qb&65535)<(qa&65535);Aa=gb?qb:qa;Gb=gb?qa:qb;qb=(Aa&65535)<(eb&65535);qa=qb?Aa:eb;gb=qb?eb:Aa;Aa=(Gb&65535)<(gb&65535);eb=Aa?Gb:gb;qb=Aa?gb:Gb;Gb=(kb&65535)<(pb&65535);gb=Gb?kb:pb;Aa=Gb?pb:kb;kb=(cb&65535)<(ya&65535);pb=kb?cb:ya;Gb=kb?ya:cb;cb=(pb&65535)<(gb&65535);ya=cb?pb:gb;kb=cb?gb:pb;pb=(Gb&65535)<(Aa&65535);gb=pb?Gb:Aa;cb=pb?Aa:Gb;Gb=(kb&65535)<(gb&65535);Aa=Gb?kb:gb;pb=Gb?gb:kb;kb=(ya&65535)<(qa&65535);gb=kb?ya:qa;Gb=kb?qa:ya;ya=(pb&65535)<(qb&65535);qa=ya?pb:qb;kb=ya?qb:pb;pb=(Gb&65535)<(qa&65535);qb=pb?Gb:qa;ya=pb?qa:Gb;Gb=(Aa&65535)<(eb&65535);qa=Gb?Aa:eb;pb=Gb?eb:Aa;Aa=(cb&65535)<(pb&65535);eb=Aa?cb:pb;Gb=Aa?pb:cb;cb=(qb&65535)<(qa&65535);pb=cb?qb:qa;Aa=cb?qa:qb;qb=(eb&65535)<(ya&65535);qa=qb?eb:ya;cb=qb?ya:eb;eb=(Gb&65535)<(kb&65535);ya=eb?Gb:kb;qb=eb?kb:Gb;Gb=(gb&65535)<(Wa&65535);kb=(Gb?gb:Wa)&65535;eb=Gb?Wa:gb;gb=(cb&65535)<(Oa&65535);Wa=gb?cb:Oa;Gb=gb?Oa:cb;cb=(eb&65535)<(Wa&65535);Oa=cb?eb:Wa;gb=cb?Wa:eb;eb=(Aa&65535)<(Qa&65535);Wa=eb?Aa:Qa;cb=eb?Qa:Aa;Aa=(qb&65535)<(cb&65535);Qa=Aa?qb:cb;eb=Aa?cb:qb;qb=(Oa&65535)<(Wa&65535);cb=qb?Oa:Wa;Aa=qb?Wa:Oa;Oa=(Qa&65535)<(gb&65535);Wa=Oa?Qa:gb;qb=Oa?gb:Qa;Qa=(eb&65535)<(Gb&65535);gb=Qa?eb:Gb;Oa=Qa?Gb:eb;eb=(pb&65535)<(bb&65535);Gb=eb?pb:bb;Qa=eb?bb:pb;pb=(ya&65535)<(Ib&65535);bb=pb?ya:Ib;eb=pb?Ib:ya;ya=(Qa&65535)<(bb&65535);Ib=ya?Qa:bb;pb=ya?bb:Qa;Qa=(qa&65535)<(fb&65535);bb=Qa?qa:fb;ya=Qa?fb:qa;qa=(Ib&65535)<(bb&65535);fb=qa?Ib:bb;Qa=qa?bb:Ib;Ib=(ya&65535)<(pb&65535);bb=Ib?ya:pb;qa=Ib?pb:ya;ya=(cb&65535)<(Gb&65535);pb=(ya?cb:Gb)&65535;Ib=(ya?Gb:cb)&65535;cb=(Aa&65535)<(fb&65535);Gb=(cb?Aa:fb)&65535;ya=(cb?fb:Aa)&65535;Aa=(Wa&65535)<(Qa&65535);fb=(Aa?Wa:Qa)&65535;cb=(Aa?Qa:Wa)&65535;Wa=(qb&65535)<(bb&65535);Qa=(Wa?qb:bb)&65535;Aa=(Wa?bb:qb)&65535;qb=(gb&65535)<(qa&65535);bb=(qb?gb:qa)&65535;Wa=(qb?qa:gb)&65535;gb=(Oa&65535)<(eb&65535);qa=(gb?Oa:eb)&65535;qb=(gb?eb:Oa)&65535;Oa=kb>>>0<Pa>>>0?Pa:kb;kb=Aa>>>0<Sa>>>0?Aa:Sa;Sa=(Oa|0)<(kb|0)?kb:Oa;Oa=ya>>>0<Xa>>>0?Xa:ya;ya=(qb|0)<(Oa|0)?qb:Oa;Oa=(ya|0)<(Sa|0)?ya:Sa;Sa=Ib>>>0<za>>>0?za:Ib;Ib=Wa>>>0<db>>>0?Wa:db;db=(Sa|0)<(Ib|0)?Sa:Ib;Ib=cb>>>0<mb>>>0?cb:mb;mb=(db|0)<(Ib|0)?Ib:db;db=(Oa|0)<(mb|0)?mb:Oa;Oa=pb>>>0<ra>>>0?ra:pb;pb=bb>>>0<Hb>>>0?bb:Hb;Hb=(Oa|0)<(pb|0)?pb:Oa;Oa=fb>>>0<xa>>>0?xa:fb;fb=(Oa|0)<(Hb|0)?Oa:Hb;Hb=Gb>>>0<_a>>>0?_a:Gb;Gb=qa>>>0<ob>>>0?qa:ob;ob=(Hb|0)<(Gb|0)?Hb:Gb;Gb=Qa>>>0<$a>>>0?Qa:$a;$a=(ob|0)<(Gb|0)?Gb:ob;ob=(fb|0)<($a|0)?fb:$a;d[ka+(hc<<1)>>1]=(db|0)<(ob|0)?ob:db;db=hc+1|0;if((hc|0)<(la|0))hc=db;else{pa=Ha;wa=db;continue g}}}if((sa|0)==(Ka|0))break;else ka=ka+(La<<1)|0}break}default:break a}break}case 3:{La=f[O+16>>2]|0;ka=f[aa>>2]|0;Ka=(f[Q>>2]|0)>>>1;sa=(f[N+48>>2]|0)>>>1;Ha=f[N+40>>2]|0;la=f[Ha+4>>2]|0;ca=f[Ha>>2]|0;Ha=Da>>>3;Fa=Ha&511;ua=Fa+1|0;switch(e|0){case 3:{Ja=(ca|0)==1;if((la|0)==1|Ja){Ea=ca+la|0;Ga=Ea+-1|0;Ba=Ja?ua:Ka;Ca=Ja?0:Ka-ua|0;Na=Ja?ua:sa;if((Ea|0)<=1)break a;Ja=0-Ba|0;Ia=Ea+-2|0;Ea=ka;da=0;ta=La;while(1){Ma=(da|0)>0?Ja:0;wa=(da|0)<(Ia|0)?Ba:0;pa=0;va=ta;while(1){na=d[va+(Ma<<1)>>1]|0;Ra=d[va>>1]|0;ia=d[va+(wa<<1)>>1]|0;ma=Ra<<16>>16<na<<16>>16;db=(ma?Ra:na)<<16>>16;ob=(ma?na:Ra)<<16>>16;Ra=(ia|0)<(ob|0)?ia:ob;d[Ea+(pa<<1)>>1]=(Ra|0)<(db|0)?db:Ra;pa=pa+1|0;if((pa|0)==(ua|0))break;else va=va+2|0}da=da+1|0;if((da|0)>=(Ga|0))break a;else{Ea=Ea+(Na<<1)|0;ta=ta+(ua<<1)+(Ca<<1)|0}}}Ca=Y(la,ua)|0;if((ca|0)<=0)break a;ta=ca+-1|0;Na=(Ha|-512)^511;Ea=Na+-1+Ca|0;Ga=Ca-ua|0;da=ka;Ba=0;while(1){Ia=Ba+-1|0;Ja=La+((Y((Ia|0)>0?Ia:0,Ka)|0)<<1)|0;Ia=La+((Y(Ba,Ka)|0)<<1)|0;Ba=Ba+1|0;va=La+((Y((ta|0)<(Ba|0)?ta:Ba,Ka)|0)<<1)|0;pa=ua;wa=0;h:while(1){if((wa|0)<(pa|0)){Ma=wa;do{Ra=Ma-((Ma|0)>(Fa|0)?ua:0)|0;db=((Ma|0)<(Ga|0)?ua:0)+Ma|0;ob=d[Ja+(Ra<<1)>>1]|0;ia=d[Ja+(Ma<<1)>>1]|0;na=d[Ja+(db<<1)>>1]|0;ma=d[Ia+(Ra<<1)>>1]|0;$a=d[Ia+(Ma<<1)>>1]|0;fb=d[Ia+(db<<1)>>1]|0;Gb=d[va+(Ra<<1)>>1]|0;Ra=d[va+(Ma<<1)>>1]|0;Qa=d[va+(db<<1)>>1]|0;db=na<<16>>16<ia<<16>>16;Hb=db?na:ia;qa=db?ia:na;na=fb<<16>>16<$a<<16>>16;ia=na?fb:$a;db=na?$a:fb;fb=Qa<<16>>16<Ra<<16>>16;$a=fb?Qa:Ra;na=fb?Ra:Qa;Qa=Hb<<16>>16<ob<<16>>16;Ra=(Qa?Hb:ob)<<16>>16;fb=Qa?ob:Hb;Hb=ia<<16>>16<ma<<16>>16;ob=(Hb?ia:ma)<<16>>16;Qa=Hb?ma:ia;ia=$a<<16>>16<Gb<<16>>16;ma=(ia?$a:Gb)<<16>>16;Hb=ia?Gb:$a;$a=qa<<16>>16<fb<<16>>16;Gb=($a?qa:fb)<<16>>16;ia=($a?fb:qa)<<16>>16;qa=db<<16>>16<Qa<<16>>16;fb=qa?db:Qa;$a=(qa?Qa:db)<<16>>16;db=na<<16>>16<Hb<<16>>16;Qa=db?na:Hb;qa=(db?Hb:na)<<16>>16;na=(ob|0)<(Ra|0)?Ra:ob;ob=(qa|0)<($a|0)?qa:$a;$a=Qa<<16>>16<fb<<16>>16;qa=($a?Qa:fb)<<16>>16;Ra=($a?fb:Qa)<<16>>16;Qa=(ma|0)<(na|0)?na:ma;ma=(qa|0)<(Gb|0)?Gb:qa;qa=(ob|0)<(ia|0)?ob:ia;ia=(Ra|0)<(ma|0)?Ra:ma;ma=(qa|0)<(ia|0);Ra=ma?qa:ia;ob=ma?ia:qa;qa=(Ra|0)<(Qa|0)?Qa:Ra;d[da+(Ma<<1)>>1]=(ob|0)<(qa|0)?ob:qa;Ma=Ma+1|0}while((Ma|0)!=(pa|0));ic=pa}else ic=wa;if((pa|0)==(Ca|0))break;if((ic|0)>(Ea|0)){pa=Ca;wa=ic;continue}else jc=ic;while(1){Ma=Ja+(jc<<1)|0;qa=d[Ma+(Na<<1)>>1]|0;ob=d[Ma>>1]|0;Ra=d[Ma+(ua<<1)>>1]|0;Ma=Ia+(jc<<1)|0;Qa=d[Ma+(Na<<1)>>1]|0;ia=d[Ma>>1]|0;ma=d[Ma+(ua<<1)>>1]|0;Ma=va+(jc<<1)|0;Gb=d[Ma+(Na<<1)>>1]|0;na=d[Ma>>1]|0;fb=d[Ma+(ua<<1)>>1]|0;Ma=Ra<<16>>16<ob<<16>>16;$a=Ma?Ra:ob;Hb=Ma?ob:Ra;Ra=ma<<16>>16<ia<<16>>16;ob=Ra?ma:ia;Ma=Ra?ia:ma;ma=fb<<16>>16<na<<16>>16;ia=ma?fb:na;Ra=ma?na:fb;fb=$a<<16>>16<qa<<16>>16;na=(fb?$a:qa)<<16>>16;ma=fb?qa:$a;$a=ob<<16>>16<Qa<<16>>16;qa=($a?ob:Qa)<<16>>16;fb=$a?Qa:ob;ob=ia<<16>>16<Gb<<16>>16;Qa=(ob?ia:Gb)<<16>>16;$a=ob?Gb:ia;ia=Hb<<16>>16<ma<<16>>16;Gb=(ia?Hb:ma)<<16>>16;ob=(ia?ma:Hb)<<16>>16;Hb=Ma<<16>>16<fb<<16>>16;ma=Hb?Ma:fb;ia=(Hb?fb:Ma)<<16>>16;Ma=Ra<<16>>16<$a<<16>>16;fb=Ma?Ra:$a;Hb=(Ma?$a:Ra)<<16>>16;Ra=(qa|0)<(na|0)?na:qa;qa=(Hb|0)<(ia|0)?Hb:ia;ia=fb<<16>>16<ma<<16>>16;Hb=(ia?fb:ma)<<16>>16;na=(ia?ma:fb)<<16>>16;fb=(Qa|0)<(Ra|0)?Ra:Qa;Qa=(Hb|0)<(Gb|0)?Gb:Hb;Hb=(qa|0)<(ob|0)?qa:ob;ob=(na|0)<(Qa|0)?na:Qa;Qa=(Hb|0)<(ob|0);na=Qa?Hb:ob;qa=Qa?ob:Hb;Hb=(na|0)<(fb|0)?fb:na;d[da+(jc<<1)>>1]=(qa|0)<(Hb|0)?qa:Hb;Hb=jc+1|0;if((jc|0)<(Ea|0))jc=Hb;else{pa=Ca;wa=Hb;continue h}}}if((Ba|0)==(ca|0))break;else da=da+(sa<<1)|0}break}case 5:{da=(ca|0)==1;if((la|0)==1|da){Ba=ca+la|0;Ca=Ba+-1|0;Ea=da?ua:Ka;Na=da?0:Ka-ua|0;Ga=da?ua:sa;if((Ba|0)<=1)break a;da=0-Ea|0;ta=da<<1;wa=Ba+-2|0;pa=Ba+-3|0;Ba=Ea<<1;va=ka;Ia=0;Ja=La;while(1){Hb=(Ia|0)>0?da:0;qa=(Ia|0)>1?ta:Hb;na=(Ia|0)<(wa|0)?Ea:0;fb=(Ia|0)<(pa|0)?Ba:na;ob=Ja;Qa=0;while(1){Gb=d[ob+(qa<<1)>>1]|0;Ra=d[ob+(Hb<<1)>>1]|0;ma=d[ob>>1]|0;ia=d[ob+(na<<1)>>1]|0;$a=d[ob+(fb<<1)>>1]|0;Ma=Ra<<16>>16<Gb<<16>>16;db=(Ma?Ra:Gb)<<16>>16;_a=(Ma?Gb:Ra)<<16>>16;Ra=$a<<16>>16<ia<<16>>16;Gb=Ra?$a:ia;Ma=Ra?ia:$a;$a=Gb<<16>>16<ma<<16>>16;ia=($a?Gb:ma)<<16>>16;Ra=$a?ma:Gb;Gb=Ma<<16>>16<Ra<<16>>16;ma=(Gb?Ma:Ra)<<16>>16;$a=(Gb?Ra:Ma)<<16>>16;Ma=(ia|0)<(db|0)?db:ia;ia=($a|0)<(Ma|0)?$a:Ma;Ma=(ma|0)<(_a|0)?ma:_a;d[va+(Qa<<1)>>1]=(ia|0)<(Ma|0)?Ma:ia;Qa=Qa+1|0;if((Qa|0)==(ua|0))break;else ob=ob+2|0}Ia=Ia+1|0;if((Ia|0)>=(Ca|0))break a;else{va=va+(Ga<<1)|0;Ja=Ja+(ua<<1)+(Na<<1)|0}}}Na=Y(la,ua)|0;if((ca|0)<=0)break a;Ja=ca+-1|0;Ga=ua<<1;va=0-Ga|0;Ca=Na+~Ga|0;Ia=(Ha|-512)^511;Ba=Na-ua|0;pa=Na-Ga|0;Ea=ka;wa=0;while(1){ta=wa+-2|0;da=La+((Y((ta|0)>0?ta:0,Ka)|0)<<1)|0;ta=wa+-1|0;ob=La+((Y((ta|0)>0?ta:0,Ka)|0)<<1)|0;ta=La+((Y(wa,Ka)|0)<<1)|0;Qa=wa;wa=wa+1|0;fb=La+((Y((Ja|0)<(wa|0)?Ja:wa,Ka)|0)<<1)|0;na=Qa+2|0;Qa=La+((Y((Ja|0)<(na|0)?Ja:na,Ka)|0)<<1)|0;na=Ga;Hb=0;i:while(1){if((Hb|0)<(na|0)){qa=Hb;do{ia=qa-((qa|0)>(Fa|0)?ua:0)|0;Ma=(qa|0)<(Ga|0)?ia:qa-Ga|0;_a=((qa|0)<(Ba|0)?ua:0)+qa|0;ma=(qa|0)<(pa|0)?qa+Ga|0:_a;$a=d[da+(Ma<<1)>>1]|0;db=d[da+(ia<<1)>>1]|0;Ra=d[da+(qa<<1)>>1]|0;Gb=d[da+(_a<<1)>>1]|0;Oa=d[da+(ma<<1)>>1]|0;xa=d[ob+(Ma<<1)>>1]|0;pb=d[ob+(ia<<1)>>1]|0;bb=d[ob+(qa<<1)>>1]|0;ra=d[ob+(_a<<1)>>1]|0;mb=d[ob+(ma<<1)>>1]|0;Ib=d[ta+(Ma<<1)>>1]|0;cb=d[ta+(ia<<1)>>1]|0;Sa=d[ta+(qa<<1)>>1]|0;Wa=d[ta+(_a<<1)>>1]|0;za=d[ta+(ma<<1)>>1]|0;ya=d[fb+(Ma<<1)>>1]|0;qb=d[fb+(ia<<1)>>1]|0;Xa=d[fb+(qa<<1)>>1]|0;kb=d[fb+(_a<<1)>>1]|0;Aa=d[fb+(ma<<1)>>1]|0;Pa=d[Qa+(Ma<<1)>>1]|0;Ma=d[Qa+(ia<<1)>>1]|0;ia=d[Qa+(qa<<1)>>1]|0;eb=d[Qa+(_a<<1)>>1]|0;_a=d[Qa+(ma<<1)>>1]|0;ma=Ra<<16>>16<db<<16>>16?Ra:db;gb=Ra<<16>>16>db<<16>>16?Ra:db;db=ma<<16>>16<$a<<16>>16;Ra=db?ma:$a;nb=db?$a:ma;ma=gb<<16>>16<nb<<16>>16;$a=ma?gb:nb;db=ma?nb:gb;gb=xa<<16>>16<Oa<<16>>16;nb=gb?xa:Oa;ma=gb?Oa:xa;xa=nb<<16>>16<Gb<<16>>16;Oa=xa?nb:Gb;gb=xa?Gb:nb;nb=ma<<16>>16<gb<<16>>16;Gb=nb?ma:gb;xa=nb?gb:ma;ma=Oa<<16>>16<Ra<<16>>16;gb=ma?Oa:Ra;nb=ma?Ra:Oa;Oa=xa<<16>>16<db<<16>>16;Ra=Oa?xa:db;ma=Oa?db:xa;xa=nb<<16>>16<Ra<<16>>16;db=xa?nb:Ra;Oa=xa?Ra:nb;nb=Gb<<16>>16<$a<<16>>16;Ra=nb?Gb:$a;xa=nb?$a:Gb;Gb=db<<16>>16<Ra<<16>>16;$a=Gb?db:Ra;nb=Gb?Ra:db;db=xa<<16>>16<Oa<<16>>16;Ra=db?xa:Oa;Gb=db?Oa:xa;xa=ra<<16>>16<bb<<16>>16;Oa=xa?ra:bb;db=xa?bb:ra;ra=Oa<<16>>16<pb<<16>>16;bb=ra?Oa:pb;xa=ra?pb:Oa;Oa=db<<16>>16<xa<<16>>16;pb=Oa?db:xa;ra=Oa?xa:db;db=cb<<16>>16<Ib<<16>>16;xa=db?cb:Ib;Oa=db?Ib:cb;cb=xa<<16>>16<mb<<16>>16;Ib=cb?xa:mb;db=cb?mb:xa;xa=Oa<<16>>16<db<<16>>16;mb=xa?Oa:db;cb=xa?db:Oa;Oa=Ib<<16>>16<bb<<16>>16;db=Oa?Ib:bb;xa=Oa?bb:Ib;Ib=cb<<16>>16<ra<<16>>16;bb=Ib?cb:ra;Oa=Ib?ra:cb;cb=xa<<16>>16<bb<<16>>16;ra=cb?xa:bb;Ib=cb?bb:xa;xa=mb<<16>>16<pb<<16>>16;bb=xa?mb:pb;cb=xa?pb:mb;mb=ra<<16>>16<bb<<16>>16;pb=mb?ra:bb;xa=mb?bb:ra;ra=cb<<16>>16<Ib<<16>>16;bb=ra?cb:Ib;mb=ra?Ib:cb;cb=db<<16>>16<gb<<16>>16;Ib=(cb?db:gb)<<16>>16;ra=cb?gb:db;db=mb<<16>>16<Gb<<16>>16;gb=db?mb:Gb;cb=db?Gb:mb;mb=ra<<16>>16<gb<<16>>16;Gb=mb?ra:gb;db=mb?gb:ra;ra=xa<<16>>16<nb<<16>>16;gb=ra?xa:nb;mb=ra?nb:xa;xa=Gb<<16>>16<gb<<16>>16;nb=xa?Gb:gb;ra=xa?gb:Gb;Gb=mb<<16>>16<db<<16>>16;gb=Gb?mb:db;xa=Gb?db:mb;mb=pb<<16>>16<$a<<16>>16;db=mb?pb:$a;Gb=mb?$a:pb;pb=Oa<<16>>16<ma<<16>>16;$a=pb?Oa:ma;mb=(pb?ma:Oa)<<16>>16;Oa=Gb<<16>>16<$a<<16>>16;ma=Oa?Gb:$a;pb=Oa?$a:Gb;Gb=bb<<16>>16<Ra<<16>>16;$a=Gb?bb:Ra;Oa=Gb?Ra:bb;bb=ma<<16>>16<$a<<16>>16;Ra=bb?ma:$a;Gb=bb?$a:ma;ma=Oa<<16>>16<pb<<16>>16;$a=ma?Oa:pb;bb=ma?pb:Oa;Oa=nb<<16>>16<db<<16>>16;pb=(Oa?nb:db)<<16>>16;ma=(Oa?db:nb)<<16>>16;nb=ra<<16>>16<Ra<<16>>16;db=(nb?ra:Ra)<<16>>16;Oa=(nb?Ra:ra)<<16>>16;ra=gb<<16>>16<Gb<<16>>16;Ra=(ra?gb:Gb)<<16>>16;nb=(ra?Gb:gb)<<16>>16;gb=xa<<16>>16<$a<<16>>16;Gb=(gb?xa:$a)<<16>>16;ra=(gb?$a:xa)<<16>>16;xa=cb<<16>>16<bb<<16>>16;$a=(xa?cb:bb)<<16>>16;gb=(xa?bb:cb)<<16>>16;cb=za<<16>>16<Wa<<16>>16;bb=cb?za:Wa;xa=cb?Wa:za;za=bb<<16>>16<Sa<<16>>16;Wa=za?bb:Sa;cb=za?Sa:bb;bb=xa<<16>>16<cb<<16>>16;Sa=bb?xa:cb;za=bb?cb:xa;xa=Xa<<16>>16<qb<<16>>16;cb=xa?Xa:qb;bb=xa?qb:Xa;Xa=cb<<16>>16<ya<<16>>16;qb=Xa?cb:ya;xa=Xa?ya:cb;cb=bb<<16>>16<xa<<16>>16;ya=cb?bb:xa;Xa=cb?xa:bb;bb=qb<<16>>16<Wa<<16>>16;xa=bb?qb:Wa;cb=bb?Wa:qb;qb=Xa<<16>>16<za<<16>>16;Wa=qb?Xa:za;bb=qb?za:Xa;Xa=cb<<16>>16<Wa<<16>>16;za=Xa?cb:Wa;qb=Xa?Wa:cb;cb=ya<<16>>16<Sa<<16>>16;Wa=cb?ya:Sa;Xa=cb?Sa:ya;ya=za<<16>>16<Wa<<16>>16;Sa=ya?za:Wa;cb=ya?Wa:za;za=Xa<<16>>16<qb<<16>>16;Wa=za?Xa:qb;ya=za?qb:Xa;Xa=Pa<<16>>16<Aa<<16>>16;qb=Xa?Pa:Aa;za=Xa?Aa:Pa;Pa=qb<<16>>16<kb<<16>>16;Aa=Pa?qb:kb;Xa=Pa?kb:qb;qb=za<<16>>16<Xa<<16>>16;kb=qb?za:Xa;Pa=qb?Xa:za;za=ia<<16>>16<Ma<<16>>16;Xa=za?ia:Ma;qb=za?Ma:ia;ia=_a<<16>>16<eb<<16>>16;Ma=ia?_a:eb;za=ia?eb:_a;_a=Ma<<16>>16<Xa<<16>>16;eb=_a?Ma:Xa;ia=_a?Xa:Ma;Ma=za<<16>>16<qb<<16>>16;Xa=Ma?za:qb;_a=Ma?qb:za;za=ia<<16>>16<Xa<<16>>16;qb=za?ia:Xa;Ma=za?Xa:ia;ia=eb<<16>>16<Aa<<16>>16;Xa=ia?eb:Aa;za=ia?Aa:eb;eb=Ma<<16>>16<Pa<<16>>16;Aa=eb?Ma:Pa;ia=eb?Pa:Ma;Ma=za<<16>>16<Aa<<16>>16;Pa=Ma?za:Aa;eb=Ma?Aa:za;za=qb<<16>>16<kb<<16>>16;Aa=za?qb:kb;Ma=za?kb:qb;qb=_a<<16>>16<Ma<<16>>16;kb=qb?_a:Ma;za=qb?Ma:_a;_a=Pa<<16>>16<Aa<<16>>16;Ma=_a?Pa:Aa;qb=_a?Aa:Pa;Pa=kb<<16>>16<eb<<16>>16;Aa=Pa?kb:eb;_a=Pa?eb:kb;kb=za<<16>>16<ia<<16>>16;eb=kb?za:ia;Pa=kb?ia:za;za=Xa<<16>>16<xa<<16>>16;ia=(za?Xa:xa)<<16>>16;kb=za?xa:Xa;Xa=_a<<16>>16<ya<<16>>16;xa=Xa?_a:ya;za=Xa?ya:_a;_a=kb<<16>>16<xa<<16>>16;ya=_a?kb:xa;Xa=_a?xa:kb;kb=qb<<16>>16<cb<<16>>16;xa=kb?qb:cb;_a=kb?cb:qb;qb=Pa<<16>>16<_a<<16>>16;cb=qb?Pa:_a;kb=qb?_a:Pa;Pa=ya<<16>>16<xa<<16>>16;_a=Pa?ya:xa;qb=Pa?xa:ya;ya=cb<<16>>16<Xa<<16>>16;xa=ya?cb:Xa;Pa=ya?Xa:cb;cb=kb<<16>>16<za<<16>>16;Xa=cb?kb:za;ya=cb?za:kb;kb=Ma<<16>>16<Sa<<16>>16;za=kb?Ma:Sa;cb=kb?Sa:Ma;Ma=eb<<16>>16<bb<<16>>16;Sa=Ma?eb:bb;kb=Ma?bb:eb;eb=cb<<16>>16<Sa<<16>>16;bb=eb?cb:Sa;Ma=eb?Sa:cb;cb=Aa<<16>>16<Wa<<16>>16;Sa=cb?Aa:Wa;eb=cb?Wa:Aa;Aa=bb<<16>>16<Sa<<16>>16;Wa=Aa?bb:Sa;cb=Aa?Sa:bb;bb=eb<<16>>16<Ma<<16>>16;Sa=bb?eb:Ma;Aa=bb?Ma:eb;eb=_a<<16>>16<za<<16>>16;Ma=(eb?_a:za)<<16>>16;bb=(eb?za:_a)<<16>>16;_a=qb<<16>>16<Wa<<16>>16;za=(_a?qb:Wa)<<16>>16;eb=(_a?Wa:qb)<<16>>16;qb=xa<<16>>16<cb<<16>>16;Wa=(qb?xa:cb)<<16>>16;_a=(qb?cb:xa)<<16>>16;xa=Pa<<16>>16<Sa<<16>>16;cb=(xa?Pa:Sa)<<16>>16;qb=(xa?Sa:Pa)<<16>>16;Pa=Xa<<16>>16<Aa<<16>>16;Sa=(Pa?Xa:Aa)<<16>>16;xa=(Pa?Aa:Xa)<<16>>16;Xa=ya<<16>>16<kb<<16>>16;Aa=(Xa?ya:kb)<<16>>16;Pa=(Xa?kb:ya)<<16>>16;ya=(ia|0)<(Ib|0)?Ib:ia;ia=(qb|0)<(ra|0)?qb:ra;ra=(ya|0)<(ia|0)?ia:ya;ya=(eb|0)<(Oa|0)?Oa:eb;eb=(Pa|0)<(ya|0)?Pa:ya;ya=(eb|0)<(ra|0)?eb:ra;ra=(bb|0)<(ma|0)?ma:bb;bb=(xa|0)<(gb|0)?xa:gb;gb=(ra|0)<(bb|0)?ra:bb;bb=(_a|0)<(nb|0)?_a:nb;nb=(gb|0)<(bb|0)?bb:gb;gb=(ya|0)<(nb|0)?nb:ya;ya=(Ma|0)<(pb|0)?pb:Ma;Ma=(Sa|0)<($a|0)?Sa:$a;$a=(ya|0)<(Ma|0)?Ma:ya;ya=(Wa|0)<(Ra|0)?Ra:Wa;Wa=(ya|0)<($a|0)?ya:$a;$a=(za|0)<(db|0)?db:za;za=(Aa|0)<(mb|0)?Aa:mb;mb=($a|0)<(za|0)?$a:za;za=(cb|0)<(Gb|0)?cb:Gb;Gb=(mb|0)<(za|0)?za:mb;mb=(Wa|0)<(Gb|0)?Wa:Gb;d[Ea+(qa<<1)>>1]=(gb|0)<(mb|0)?mb:gb;qa=qa+1|0}while((qa|0)!=(na|0));kc=na}else kc=Hb;if((na|0)==(Na|0))break;if((kc|0)>(Ca|0)){na=Na;Hb=kc;continue}else lc=kc;while(1){qa=da+(lc<<1)|0;gb=d[qa+(va<<1)>>1]|0;mb=d[qa+(Ia<<1)>>1]|0;Gb=d[qa>>1]|0;Wa=d[qa+(ua<<1)>>1]|0;za=d[qa+(Ga<<1)>>1]|0;qa=ob+(lc<<1)|0;cb=d[qa+(va<<1)>>1]|0;$a=d[qa+(Ia<<1)>>1]|0;Aa=d[qa>>1]|0;db=d[qa+(ua<<1)>>1]|0;ya=d[qa+(Ga<<1)>>1]|0;qa=ta+(lc<<1)|0;Ra=d[qa+(va<<1)>>1]|0;Ma=d[qa+(Ia<<1)>>1]|0;Sa=d[qa>>1]|0;pb=d[qa+(ua<<1)>>1]|0;nb=d[qa+(Ga<<1)>>1]|0;qa=fb+(lc<<1)|0;bb=d[qa+(va<<1)>>1]|0;_a=d[qa+(Ia<<1)>>1]|0;ra=d[qa>>1]|0;xa=d[qa+(ua<<1)>>1]|0;ma=d[qa+(Ga<<1)>>1]|0;qa=Qa+(lc<<1)|0;eb=d[qa+(va<<1)>>1]|0;Pa=d[qa+(Ia<<1)>>1]|0;Oa=d[qa>>1]|0;ia=d[qa+(ua<<1)>>1]|0;qb=d[qa+(Ga<<1)>>1]|0;qa=Gb<<16>>16<mb<<16>>16?Gb:mb;Ib=Gb<<16>>16>mb<<16>>16?Gb:mb;mb=qa<<16>>16<gb<<16>>16;Gb=mb?qa:gb;kb=mb?gb:qa;qa=Ib<<16>>16<kb<<16>>16;gb=qa?Ib:kb;mb=qa?kb:Ib;Ib=cb<<16>>16<za<<16>>16;kb=Ib?cb:za;qa=Ib?za:cb;cb=kb<<16>>16<Wa<<16>>16;za=cb?kb:Wa;Ib=cb?Wa:kb;kb=qa<<16>>16<Ib<<16>>16;Wa=kb?qa:Ib;cb=kb?Ib:qa;qa=za<<16>>16<Gb<<16>>16;Ib=qa?za:Gb;kb=qa?Gb:za;za=cb<<16>>16<mb<<16>>16;Gb=za?cb:mb;qa=za?mb:cb;cb=kb<<16>>16<Gb<<16>>16;mb=cb?kb:Gb;za=cb?Gb:kb;kb=Wa<<16>>16<gb<<16>>16;Gb=kb?Wa:gb;cb=kb?gb:Wa;Wa=mb<<16>>16<Gb<<16>>16;gb=Wa?mb:Gb;kb=Wa?Gb:mb;mb=cb<<16>>16<za<<16>>16;Gb=mb?cb:za;Wa=mb?za:cb;cb=db<<16>>16<Aa<<16>>16;za=cb?db:Aa;mb=cb?Aa:db;db=za<<16>>16<$a<<16>>16;Aa=db?za:$a;cb=db?$a:za;za=mb<<16>>16<cb<<16>>16;$a=za?mb:cb;db=za?cb:mb;mb=Ma<<16>>16<Ra<<16>>16;cb=mb?Ma:Ra;za=mb?Ra:Ma;Ma=cb<<16>>16<ya<<16>>16;Ra=Ma?cb:ya;mb=Ma?ya:cb;cb=za<<16>>16<mb<<16>>16;ya=cb?za:mb;Ma=cb?mb:za;za=Ra<<16>>16<Aa<<16>>16;mb=za?Ra:Aa;cb=za?Aa:Ra;Ra=Ma<<16>>16<db<<16>>16;Aa=Ra?Ma:db;za=Ra?db:Ma;Ma=cb<<16>>16<Aa<<16>>16;db=Ma?cb:Aa;Ra=Ma?Aa:cb;cb=ya<<16>>16<$a<<16>>16;Aa=cb?ya:$a;Ma=cb?$a:ya;ya=db<<16>>16<Aa<<16>>16;$a=ya?db:Aa;cb=ya?Aa:db;db=Ma<<16>>16<Ra<<16>>16;Aa=db?Ma:Ra;ya=db?Ra:Ma;Ma=mb<<16>>16<Ib<<16>>16;Ra=(Ma?mb:Ib)<<16>>16;db=Ma?Ib:mb;mb=ya<<16>>16<Wa<<16>>16;Ib=mb?ya:Wa;Ma=mb?Wa:ya;ya=db<<16>>16<Ib<<16>>16;Wa=ya?db:Ib;mb=ya?Ib:db;db=cb<<16>>16<kb<<16>>16;Ib=db?cb:kb;ya=db?kb:cb;cb=Wa<<16>>16<Ib<<16>>16;kb=cb?Wa:Ib;db=cb?Ib:Wa;Wa=ya<<16>>16<mb<<16>>16;Ib=Wa?ya:mb;cb=Wa?mb:ya;ya=$a<<16>>16<gb<<16>>16;mb=ya?$a:gb;Wa=ya?gb:$a;$a=za<<16>>16<qa<<16>>16;gb=$a?za:qa;ya=($a?qa:za)<<16>>16;za=Wa<<16>>16<gb<<16>>16;qa=za?Wa:gb;$a=za?gb:Wa;Wa=Aa<<16>>16<Gb<<16>>16;gb=Wa?Aa:Gb;za=Wa?Gb:Aa;Aa=qa<<16>>16<gb<<16>>16;Gb=Aa?qa:gb;Wa=Aa?gb:qa;qa=za<<16>>16<$a<<16>>16;gb=qa?za:$a;Aa=qa?$a:za;za=kb<<16>>16<mb<<16>>16;$a=(za?kb:mb)<<16>>16;qa=(za?mb:kb)<<16>>16;kb=db<<16>>16<Gb<<16>>16;mb=(kb?db:Gb)<<16>>16;za=(kb?Gb:db)<<16>>16;db=Ib<<16>>16<Wa<<16>>16;Gb=(db?Ib:Wa)<<16>>16;kb=(db?Wa:Ib)<<16>>16;Ib=cb<<16>>16<gb<<16>>16;Wa=(Ib?cb:gb)<<16>>16;db=(Ib?gb:cb)<<16>>16;cb=Ma<<16>>16<Aa<<16>>16;gb=(cb?Ma:Aa)<<16>>16;Ib=(cb?Aa:Ma)<<16>>16;Ma=nb<<16>>16<pb<<16>>16;Aa=Ma?nb:pb;cb=Ma?pb:nb;nb=Aa<<16>>16<Sa<<16>>16;pb=nb?Aa:Sa;Ma=nb?Sa:Aa;Aa=cb<<16>>16<Ma<<16>>16;Sa=Aa?cb:Ma;nb=Aa?Ma:cb;cb=ra<<16>>16<_a<<16>>16;Ma=cb?ra:_a;Aa=cb?_a:ra;ra=Ma<<16>>16<bb<<16>>16;_a=ra?Ma:bb;cb=ra?bb:Ma;Ma=Aa<<16>>16<cb<<16>>16;bb=Ma?Aa:cb;ra=Ma?cb:Aa;Aa=_a<<16>>16<pb<<16>>16;cb=Aa?_a:pb;Ma=Aa?pb:_a;_a=ra<<16>>16<nb<<16>>16;pb=_a?ra:nb;Aa=_a?nb:ra;ra=Ma<<16>>16<pb<<16>>16;nb=ra?Ma:pb;_a=ra?pb:Ma;Ma=bb<<16>>16<Sa<<16>>16;pb=Ma?bb:Sa;ra=Ma?Sa:bb;bb=nb<<16>>16<pb<<16>>16;Sa=bb?nb:pb;Ma=bb?pb:nb;nb=ra<<16>>16<_a<<16>>16;pb=nb?ra:_a;bb=nb?_a:ra;ra=eb<<16>>16<ma<<16>>16;_a=ra?eb:ma;nb=ra?ma:eb;eb=_a<<16>>16<xa<<16>>16;ma=eb?_a:xa;ra=eb?xa:_a;_a=nb<<16>>16<ra<<16>>16;xa=_a?nb:ra;eb=_a?ra:nb;nb=Oa<<16>>16<Pa<<16>>16;ra=nb?Oa:Pa;_a=nb?Pa:Oa;Oa=qb<<16>>16<ia<<16>>16;Pa=Oa?qb:ia;nb=Oa?ia:qb;qb=Pa<<16>>16<ra<<16>>16;ia=qb?Pa:ra;Oa=qb?ra:Pa;Pa=nb<<16>>16<_a<<16>>16;ra=Pa?nb:_a;qb=Pa?_a:nb;nb=Oa<<16>>16<ra<<16>>16;_a=nb?Oa:ra;Pa=nb?ra:Oa;Oa=ia<<16>>16<ma<<16>>16;ra=Oa?ia:ma;nb=Oa?ma:ia;ia=Pa<<16>>16<eb<<16>>16;ma=ia?Pa:eb;Oa=ia?eb:Pa;Pa=nb<<16>>16<ma<<16>>16;eb=Pa?nb:ma;ia=Pa?ma:nb;nb=_a<<16>>16<xa<<16>>16;ma=nb?_a:xa;Pa=nb?xa:_a;_a=qb<<16>>16<Pa<<16>>16;xa=_a?qb:Pa;nb=_a?Pa:qb;qb=eb<<16>>16<ma<<16>>16;Pa=qb?eb:ma;_a=qb?ma:eb;eb=xa<<16>>16<ia<<16>>16;ma=eb?xa:ia;qb=eb?ia:xa;xa=nb<<16>>16<Oa<<16>>16;ia=xa?nb:Oa;eb=xa?Oa:nb;nb=ra<<16>>16<cb<<16>>16;Oa=(nb?ra:cb)<<16>>16;xa=nb?cb:ra;ra=qb<<16>>16<bb<<16>>16;cb=ra?qb:bb;nb=ra?bb:qb;qb=xa<<16>>16<cb<<16>>16;bb=qb?xa:cb;ra=qb?cb:xa;xa=_a<<16>>16<Ma<<16>>16;cb=xa?_a:Ma;qb=xa?Ma:_a;_a=eb<<16>>16<qb<<16>>16;Ma=_a?eb:qb;xa=_a?qb:eb;eb=bb<<16>>16<cb<<16>>16;qb=eb?bb:cb;_a=eb?cb:bb;bb=Ma<<16>>16<ra<<16>>16;cb=bb?Ma:ra;eb=bb?ra:Ma;Ma=xa<<16>>16<nb<<16>>16;ra=Ma?xa:nb;bb=Ma?nb:xa;xa=Pa<<16>>16<Sa<<16>>16;nb=xa?Pa:Sa;Ma=xa?Sa:Pa;Pa=ia<<16>>16<Aa<<16>>16;Sa=Pa?ia:Aa;xa=Pa?Aa:ia;ia=Ma<<16>>16<Sa<<16>>16;Aa=ia?Ma:Sa;Pa=ia?Sa:Ma;Ma=ma<<16>>16<pb<<16>>16;Sa=Ma?ma:pb;ia=Ma?pb:ma;ma=Aa<<16>>16<Sa<<16>>16;pb=ma?Aa:Sa;Ma=ma?Sa:Aa;Aa=ia<<16>>16<Pa<<16>>16;Sa=Aa?ia:Pa;ma=Aa?Pa:ia;ia=qb<<16>>16<nb<<16>>16;Pa=(ia?qb:nb)<<16>>16;Aa=(ia?nb:qb)<<16>>16;qb=_a<<16>>16<pb<<16>>16;nb=(qb?_a:pb)<<16>>16;ia=(qb?pb:_a)<<16>>16;_a=cb<<16>>16<Ma<<16>>16;pb=(_a?cb:Ma)<<16>>16;qb=(_a?Ma:cb)<<16>>16;cb=eb<<16>>16<Sa<<16>>16;Ma=(cb?eb:Sa)<<16>>16;_a=(cb?Sa:eb)<<16>>16;eb=ra<<16>>16<ma<<16>>16;Sa=(eb?ra:ma)<<16>>16;cb=(eb?ma:ra)<<16>>16;ra=bb<<16>>16<xa<<16>>16;ma=(ra?bb:xa)<<16>>16;eb=(ra?xa:bb)<<16>>16;bb=(Oa|0)<(Ra|0)?Ra:Oa;Oa=(_a|0)<(db|0)?_a:db;db=(bb|0)<(Oa|0)?Oa:bb;bb=(ia|0)<(za|0)?za:ia;ia=(eb|0)<(bb|0)?eb:bb;bb=(ia|0)<(db|0)?ia:db;db=(Aa|0)<(qa|0)?qa:Aa;Aa=(cb|0)<(Ib|0)?cb:Ib;Ib=(db|0)<(Aa|0)?db:Aa;Aa=(qb|0)<(kb|0)?qb:kb;kb=(Ib|0)<(Aa|0)?Aa:Ib;Ib=(bb|0)<(kb|0)?kb:bb;bb=(Pa|0)<($a|0)?$a:Pa;Pa=(Sa|0)<(gb|0)?Sa:gb;gb=(bb|0)<(Pa|0)?Pa:bb;bb=(pb|0)<(Gb|0)?Gb:pb;pb=(bb|0)<(gb|0)?bb:gb;gb=(nb|0)<(mb|0)?mb:nb;nb=(ma|0)<(ya|0)?ma:ya;ya=(gb|0)<(nb|0)?gb:nb;nb=(Ma|0)<(Wa|0)?Ma:Wa;Wa=(ya|0)<(nb|0)?nb:ya;ya=(pb|0)<(Wa|0)?pb:Wa;d[Ea+(lc<<1)>>1]=(Ib|0)<(ya|0)?ya:Ib;Ib=lc+1|0;if((lc|0)<(Ca|0))lc=Ib;else{na=Na;Hb=Ib;continue i}}}if((wa|0)==(ca|0))break;else Ea=Ea+(sa<<1)|0}break}default:break a}break}case 5:{sa=f[O+16>>2]|0;Ea=f[aa>>2]|0;ca=(f[Q>>2]|0)>>>2;wa=(f[N+48>>2]|0)>>>2;Na=f[N+40>>2]|0;Ca=f[Na+4>>2]|0;Ga=f[Na>>2]|0;Na=Da>>>3;ua=Na&511;Ia=ua+1|0;switch(e|0){case 3:{va=(Ga|0)==1;if((Ca|0)==1|va){pa=Ga+Ca|0;Ba=pa+-1|0;Fa=va?Ia:ca;Ka=va?0:ca-Ia|0;Ja=va?Ia:wa;if((pa|0)<=1)break a;va=0-Fa|0;La=pa+-2|0;pa=sa;ka=Ea;Ha=0;while(1){la=(Ha|0)>0?va:0;Hb=(Ha|0)<(La|0)?Fa:0;na=0;Qa=pa;while(1){fb=f[Qa+(la<<2)>>2]|0;f[i>>2]=fb;ta=f[Qa>>2]|0;f[k>>2]=ta;oa=+n[Qa+(Hb<<2)>>2];mc=(f[s>>2]=fb,+n[s>>2]);nc=(f[s>>2]=ta,+n[s>>2]);ta=nc<mc;oc=+n[(ta?k:i)>>2];pc=ta?mc:nc;nc=oa<pc?oa:pc;n[ka+(na<<2)>>2]=nc<oc?oc:nc;na=na+1|0;if((na|0)==(Ia|0))break;else Qa=Qa+4|0}Ha=Ha+1|0;if((Ha|0)>=(Ba|0))break a;else{pa=pa+(Ia<<2)+(Ka<<2)|0;ka=ka+(Ja<<2)|0}}}Ja=Y(Ca,Ia)|0;if((Ga|0)<=0)break a;ka=Ga+-1|0;Ka=(Na|-512)^511;pa=Ka+-1+Ja|0;Ba=Ja-Ia|0;Ha=Ea;Fa=0;while(1){La=Fa+-1|0;va=sa+((Y((La|0)>0?La:0,ca)|0)<<2)|0;La=sa+((Y(Fa,ca)|0)<<2)|0;Fa=Fa+1|0;Da=sa+((Y((ka|0)<(Fa|0)?ka:Fa,ca)|0)<<2)|0;Qa=Ia;na=0;j:while(1){if((na|0)<(Qa|0)){Hb=na;do{la=Hb-((Hb|0)>(ua|0)?Ia:0)|0;ta=((Hb|0)<(Ba|0)?Ia:0)+Hb|0;fb=f[va+(la<<2)>>2]|0;ob=f[va+(Hb<<2)>>2]|0;f[i>>2]=ob;da=f[va+(ta<<2)>>2]|0;f[k>>2]=da;Ib=f[La+(la<<2)>>2]|0;ya=f[La+(Hb<<2)>>2]|0;f[l>>2]=ya;Wa=f[La+(ta<<2)>>2]|0;f[m>>2]=Wa;pb=f[Da+(la<<2)>>2]|0;la=f[Da+(Hb<<2)>>2]|0;f[o>>2]=la;nb=f[Da+(ta<<2)>>2]|0;f[p>>2]=nb;nc=(f[s>>2]=ob,+n[s>>2]);oc=(f[s>>2]=da,+n[s>>2]);da=oc<nc;ob=f[(da?k:i)>>2]|0;pc=da?nc:oc;n[k>>2]=pc;oc=(f[s>>2]=ya,+n[s>>2]);nc=(f[s>>2]=Wa,+n[s>>2]);Wa=nc<oc;ya=f[(Wa?m:l)>>2]|0;oa=Wa?oc:nc;n[m>>2]=oa;nc=(f[s>>2]=la,+n[s>>2]);oc=(f[s>>2]=nb,+n[s>>2]);nb=oc<nc;la=f[(nb?p:o)>>2]|0;mc=nb?nc:oc;n[p>>2]=mc;oc=(f[s>>2]=fb,+n[s>>2]);nc=(f[s>>2]=ob,+n[s>>2]);nb=nc<oc;qc=nb?oc:nc;n[i>>2]=qc;nc=(f[s>>2]=Ib,+n[s>>2]);oc=(f[s>>2]=ya,+n[s>>2]);Wa=oc<nc;rc=Wa?nc:oc;n[l>>2]=rc;oc=(f[s>>2]=pb,+n[s>>2]);nc=(f[s>>2]=la,+n[s>>2]);da=nc<oc;sc=da?oc:nc;n[o>>2]=sc;ta=pc<qc;nc=ta?+n[k>>2]:+n[i>>2];oc=ta?qc:pc;n[k>>2]=oc;ta=oa<rc;Ma=f[(ta?m:l)>>2]|0;f[l>>2]=Ma;pc=ta?rc:oa;n[m>>2]=pc;ta=mc<sc;gb=f[(ta?p:o)>>2]|0;f[o>>2]=gb;oa=ta?sc:mc;n[p>>2]=oa;mc=(f[s>>2]=nb?ob:fb,+n[s>>2]);sc=(f[s>>2]=Wa?ya:Ib,+n[s>>2]);rc=sc<mc?mc:sc;Ib=f[(oa<pc?p:m)>>2]|0;f[m>>2]=Ib;pc=(f[s>>2]=Ma,+n[s>>2]);oa=(f[s>>2]=gb,+n[s>>2]);gb=oa<pc;sc=gb?+n[o>>2]:+n[l>>2];mc=gb?pc:oa;n[o>>2]=mc;oa=(f[s>>2]=da?la:pb,+n[s>>2]);pc=oa<rc?rc:oa;oa=sc<nc?nc:sc;n[l>>2]=oa;pb=f[((f[s>>2]=Ib,+n[s>>2])<oc?m:k)>>2]|0;f[k>>2]=pb;Ib=f[(mc<oa?o:l)>>2]|0;f[l>>2]=Ib;oa=(f[s>>2]=Ib,+n[s>>2]);mc=(f[s>>2]=pb,+n[s>>2]);pb=mc<oa;oc=pb?+n[k>>2]:(f[s>>2]=Ib,+n[s>>2]);sc=pb?oa:mc;n[k>>2]=sc;mc=oc<pc?pc:oc;n[l>>2]=mc;f[Ha+(Hb<<2)>>2]=f[(sc<mc?k:l)>>2];Hb=Hb+1|0}while((Hb|0)!=(Qa|0));tc=Qa}else tc=na;if((Qa|0)==(Ja|0))break;if((tc|0)>(pa|0)){Qa=Ja;na=tc;continue}else uc=tc;while(1){Hb=va+(uc<<2)|0;pb=f[Hb+(Ka<<2)>>2]|0;Ib=f[Hb>>2]|0;f[i>>2]=Ib;la=f[Hb+(Ia<<2)>>2]|0;f[k>>2]=la;Hb=La+(uc<<2)|0;da=f[Hb+(Ka<<2)>>2]|0;gb=f[Hb>>2]|0;f[l>>2]=gb;Ma=f[Hb+(Ia<<2)>>2]|0;f[m>>2]=Ma;Hb=Da+(uc<<2)|0;ya=f[Hb+(Ka<<2)>>2]|0;Wa=f[Hb>>2]|0;f[o>>2]=Wa;fb=f[Hb+(Ia<<2)>>2]|0;f[p>>2]=fb;mc=(f[s>>2]=Ib,+n[s>>2]);sc=(f[s>>2]=la,+n[s>>2]);la=sc<mc;Ib=f[(la?k:i)>>2]|0;oc=la?mc:sc;n[k>>2]=oc;sc=(f[s>>2]=gb,+n[s>>2]);mc=(f[s>>2]=Ma,+n[s>>2]);Ma=mc<sc;gb=f[(Ma?m:l)>>2]|0;pc=Ma?sc:mc;n[m>>2]=pc;mc=(f[s>>2]=Wa,+n[s>>2]);sc=(f[s>>2]=fb,+n[s>>2]);fb=sc<mc;Wa=f[(fb?p:o)>>2]|0;oa=fb?mc:sc;n[p>>2]=oa;sc=(f[s>>2]=pb,+n[s>>2]);mc=(f[s>>2]=Ib,+n[s>>2]);fb=mc<sc;nc=fb?sc:mc;n[i>>2]=nc;mc=(f[s>>2]=da,+n[s>>2]);sc=(f[s>>2]=gb,+n[s>>2]);Ma=sc<mc;rc=Ma?mc:sc;n[l>>2]=rc;sc=(f[s>>2]=ya,+n[s>>2]);mc=(f[s>>2]=Wa,+n[s>>2]);la=mc<sc;qc=la?sc:mc;n[o>>2]=qc;Hb=oc<nc;mc=Hb?+n[k>>2]:+n[i>>2];sc=Hb?nc:oc;n[k>>2]=sc;Hb=pc<rc;ob=f[(Hb?m:l)>>2]|0;f[l>>2]=ob;oc=Hb?rc:pc;n[m>>2]=oc;Hb=oa<qc;nb=f[(Hb?p:o)>>2]|0;f[o>>2]=nb;pc=Hb?qc:oa;n[p>>2]=pc;oa=(f[s>>2]=fb?Ib:pb,+n[s>>2]);qc=(f[s>>2]=Ma?gb:da,+n[s>>2]);rc=qc<oa?oa:qc;da=f[(pc<oc?p:m)>>2]|0;f[m>>2]=da;oc=(f[s>>2]=ob,+n[s>>2]);pc=(f[s>>2]=nb,+n[s>>2]);nb=pc<oc;qc=nb?+n[o>>2]:+n[l>>2];oa=nb?oc:pc;n[o>>2]=oa;pc=(f[s>>2]=la?Wa:ya,+n[s>>2]);oc=pc<rc?rc:pc;pc=qc<mc?mc:qc;n[l>>2]=pc;ya=f[((f[s>>2]=da,+n[s>>2])<sc?m:k)>>2]|0;f[k>>2]=ya;da=f[(oa<pc?o:l)>>2]|0;f[l>>2]=da;pc=(f[s>>2]=da,+n[s>>2]);oa=(f[s>>2]=ya,+n[s>>2]);ya=oa<pc;sc=ya?+n[k>>2]:(f[s>>2]=da,+n[s>>2]);qc=ya?pc:oa;n[k>>2]=qc;oa=sc<oc?oc:sc;n[l>>2]=oa;f[Ha+(uc<<2)>>2]=f[(qc<oa?k:l)>>2];ya=uc+1|0;if((uc|0)<(pa|0))uc=ya;else{Qa=Ja;na=ya;continue j}}}if((Fa|0)==(Ga|0))break;else Ha=Ha+(wa<<2)|0}break}case 5:{Ha=(Ga|0)==1;if((Ca|0)==1|Ha){Fa=Ga+Ca|0;Ja=Fa+-1|0;pa=Ha?Ia:ca;Ka=Ha?0:ca-Ia|0;Ba=Ha?Ia:wa;if((Fa|0)<=1)break a;Ha=0-pa|0;ka=Ha<<1;na=Fa+-2|0;Qa=Fa+-3|0;Fa=pa<<1;Da=sa;La=Ea;va=0;while(1){ya=(va|0)>0?Ha:0;da=(va|0)>1?ka:ya;Wa=(va|0)<(na|0)?pa:0;la=(va|0)<(Qa|0)?Fa:Wa;nb=Da;ob=0;while(1){gb=f[nb+(da<<2)>>2]|0;f[i>>2]=gb;Ma=f[nb+(ya<<2)>>2]|0;f[k>>2]=Ma;pb=f[nb>>2]|0;f[l>>2]=pb;Ib=f[nb+(Wa<<2)>>2]|0;f[m>>2]=Ib;fb=f[nb+(la<<2)>>2]|0;f[o>>2]=fb;oa=(f[s>>2]=gb,+n[s>>2]);qc=(f[s>>2]=Ma,+n[s>>2]);Ma=qc<oa;sc=+n[(Ma?k:i)>>2];oc=Ma?oa:qc;qc=(f[s>>2]=Ib,+n[s>>2]);oa=(f[s>>2]=fb,+n[s>>2]);fb=oa<qc;Ib=f[(fb?o:m)>>2]|0;f[m>>2]=Ib;pc=fb?qc:oa;n[o>>2]=pc;oa=(f[s>>2]=pb,+n[s>>2]);qc=(f[s>>2]=Ib,+n[s>>2]);pb=qc<oa;mc=pb?(f[s>>2]=Ib,+n[s>>2]):+n[l>>2];rc=pb?oa:qc;n[m>>2]=rc;pb=pc<rc;qc=pb?+n[o>>2]:rc;oa=pb?rc:pc;n[o>>2]=oa;pc=mc<sc?sc:mc;n[l>>2]=pc;mc=oa<pc?oa:pc;pc=qc<oc?qc:oc;n[La+(ob<<2)>>2]=mc<pc?pc:mc;ob=ob+1|0;if((ob|0)==(Ia|0))break;else nb=nb+4|0}va=va+1|0;if((va|0)>=(Ja|0))break a;else{Da=Da+(Ia<<2)+(Ka<<2)|0;La=La+(Ba<<2)|0}}}Ba=Y(Ca,Ia)|0;if((Ga|0)<=0)break a;La=Ga+-1|0;Ka=Ia<<1;Da=0-Ka|0;Ja=Ba+~Ka|0;va=(Na|-512)^511;Fa=Ba-Ia|0;Qa=Ba-Ka|0;pa=Ea;na=0;while(1){ka=na+-2|0;Ha=sa+((Y((ka|0)>0?ka:0,ca)|0)<<2)|0;ka=na+-1|0;nb=sa+((Y((ka|0)>0?ka:0,ca)|0)<<2)|0;ka=sa+((Y(na,ca)|0)<<2)|0;ob=na;na=na+1|0;la=sa+((Y((La|0)<(na|0)?La:na,ca)|0)<<2)|0;Wa=ob+2|0;ob=sa+((Y((La|0)<(Wa|0)?La:Wa,ca)|0)<<2)|0;Wa=Ka;ya=0;k:while(1){if((ya|0)<(Wa|0)){da=ya;do{pb=da-((da|0)>(ua|0)?Ia:0)|0;Ib=(da|0)<(Ka|0)?pb:da-Ka|0;fb=((da|0)<(Fa|0)?Ia:0)+da|0;Ma=(da|0)<(Qa|0)?da+Ka|0:fb;f[i>>2]=f[Ha+(Ib<<2)>>2];gb=f[Ha+(pb<<2)>>2]|0;f[k>>2]=gb;Hb=f[Ha+(da<<2)>>2]|0;f[l>>2]=Hb;f[m>>2]=f[Ha+(fb<<2)>>2];f[o>>2]=f[Ha+(Ma<<2)>>2];f[p>>2]=f[nb+(Ib<<2)>>2];f[q>>2]=f[nb+(pb<<2)>>2];f[r>>2]=f[nb+(da<<2)>>2];f[t>>2]=f[nb+(fb<<2)>>2];f[v>>2]=f[nb+(Ma<<2)>>2];f[w>>2]=f[ka+(Ib<<2)>>2];f[x>>2]=f[ka+(pb<<2)>>2];f[y>>2]=f[ka+(da<<2)>>2];f[z>>2]=f[ka+(fb<<2)>>2];f[A>>2]=f[ka+(Ma<<2)>>2];f[B>>2]=f[la+(Ib<<2)>>2];f[C>>2]=f[la+(pb<<2)>>2];f[D>>2]=f[la+(da<<2)>>2];f[E>>2]=f[la+(fb<<2)>>2];f[F>>2]=f[la+(Ma<<2)>>2];f[G>>2]=f[ob+(Ib<<2)>>2];f[H>>2]=f[ob+(pb<<2)>>2];f[I>>2]=f[ob+(da<<2)>>2];f[J>>2]=f[ob+(fb<<2)>>2];f[K>>2]=f[ob+(Ma<<2)>>2];mc=(f[s>>2]=gb,+n[s>>2]);pc=(f[s>>2]=Hb,+n[s>>2]);Hb=pc<mc;gb=f[(Hb?l:k)>>2]|0;f[k>>2]=gb;oc=Hb?mc:pc;n[l>>2]=oc;pc=+n[i>>2];mc=(f[s>>2]=gb,+n[s>>2]);gb=mc<pc;Hb=f[(gb?k:i)>>2]|0;f[i>>2]=Hb;qc=gb?pc:mc;n[k>>2]=qc;gb=oc<qc;Ma=f[(gb?l:k)>>2]|0;f[k>>2]=Ma;mc=gb?qc:oc;n[l>>2]=mc;oc=+n[o>>2];qc=+n[p>>2];gb=qc<oc;fb=f[(gb?p:o)>>2]|0;f[o>>2]=fb;pc=gb?oc:qc;n[p>>2]=pc;qc=+n[m>>2];oc=(f[s>>2]=fb,+n[s>>2]);fb=oc<qc;gb=f[(fb?o:m)>>2]|0;f[m>>2]=gb;oa=fb?qc:oc;n[o>>2]=oa;fb=pc<oa;pb=f[(fb?p:o)>>2]|0;f[o>>2]=pb;oc=fb?oa:pc;n[p>>2]=oc;pc=(f[s>>2]=Hb,+n[s>>2]);oa=(f[s>>2]=gb,+n[s>>2]);gb=oa<pc;f[i>>2]=f[(gb?m:i)>>2];qc=gb?pc:oa;n[m>>2]=qc;gb=oc<mc;Hb=f[(gb?p:l)>>2]|0;f[l>>2]=Hb;n[p>>2]=gb?mc:oc;oc=(f[s>>2]=Hb,+n[s>>2]);Hb=qc<oc;gb=f[(Hb?m:l)>>2]|0;f[l>>2]=gb;mc=Hb?oc:qc;n[m>>2]=mc;qc=(f[s>>2]=Ma,+n[s>>2]);oc=(f[s>>2]=pb,+n[s>>2]);pb=oc<qc;Ma=f[(pb?o:k)>>2]|0;f[k>>2]=Ma;oa=pb?qc:oc;n[o>>2]=oa;oc=(f[s>>2]=Ma,+n[s>>2]);qc=(f[s>>2]=gb,+n[s>>2]);gb=qc<oc;f[k>>2]=f[(gb?l:k)>>2];n[l>>2]=gb?oc:qc;gb=oa<mc;f[m>>2]=f[(gb?o:m)>>2];n[o>>2]=gb?mc:oa;oa=+n[r>>2];mc=+n[t>>2];gb=mc<oa;Ma=f[(gb?t:r)>>2]|0;f[r>>2]=Ma;qc=gb?oa:mc;n[t>>2]=qc;mc=+n[q>>2];oa=(f[s>>2]=Ma,+n[s>>2]);Ma=oa<mc;gb=f[(Ma?r:q)>>2]|0;f[q>>2]=gb;oc=Ma?mc:oa;n[r>>2]=oc;Ma=qc<oc;pb=f[(Ma?t:r)>>2]|0;f[r>>2]=pb;oa=Ma?oc:qc;n[t>>2]=oa;qc=+n[w>>2];oc=+n[x>>2];Ma=oc<qc;Hb=f[(Ma?x:w)>>2]|0;f[w>>2]=Hb;mc=Ma?qc:oc;n[x>>2]=mc;oc=+n[v>>2];qc=(f[s>>2]=Hb,+n[s>>2]);Hb=qc<oc;Ma=f[(Hb?w:v)>>2]|0;f[v>>2]=Ma;pc=Hb?oc:qc;n[w>>2]=pc;Hb=mc<pc;fb=f[(Hb?x:w)>>2]|0;f[w>>2]=fb;qc=Hb?pc:mc;n[x>>2]=qc;mc=(f[s>>2]=gb,+n[s>>2]);pc=(f[s>>2]=Ma,+n[s>>2]);Ma=pc<mc;gb=f[(Ma?v:q)>>2]|0;f[q>>2]=gb;oc=Ma?mc:pc;n[v>>2]=oc;Ma=qc<oa;Hb=f[(Ma?x:t)>>2]|0;f[t>>2]=Hb;pc=Ma?oa:qc;n[x>>2]=pc;qc=(f[s>>2]=Hb,+n[s>>2]);Hb=oc<qc;Ma=f[(Hb?v:t)>>2]|0;f[t>>2]=Ma;oa=Hb?qc:oc;n[v>>2]=oa;oc=(f[s>>2]=pb,+n[s>>2]);qc=(f[s>>2]=fb,+n[s>>2]);fb=qc<oc;pb=f[(fb?w:r)>>2]|0;f[r>>2]=pb;mc=fb?oc:qc;n[w>>2]=mc;qc=(f[s>>2]=pb,+n[s>>2]);oc=(f[s>>2]=Ma,+n[s>>2]);Ma=oc<qc;pb=f[(Ma?t:r)>>2]|0;f[r>>2]=pb;sc=Ma?qc:oc;n[t>>2]=sc;Ma=mc<oa;fb=f[(Ma?w:v)>>2]|0;f[v>>2]=fb;oc=Ma?oa:mc;n[w>>2]=oc;mc=+n[i>>2];oa=(f[s>>2]=gb,+n[s>>2]);gb=oa<mc;f[i>>2]=f[(gb?q:i)>>2];qc=gb?mc:oa;n[q>>2]=qc;oa=+n[o>>2];gb=oc<oa;Ma=f[(gb?w:o)>>2]|0;f[o>>2]=Ma;n[w>>2]=gb?oa:oc;oc=(f[s>>2]=Ma,+n[s>>2]);Ma=qc<oc;gb=f[(Ma?q:o)>>2]|0;f[o>>2]=gb;oa=Ma?oc:qc;n[q>>2]=oa;qc=+n[l>>2];Ma=sc<qc;Hb=f[(Ma?t:l)>>2]|0;f[l>>2]=Hb;oc=Ma?qc:sc;n[t>>2]=oc;sc=(f[s>>2]=Hb,+n[s>>2]);qc=(f[s>>2]=gb,+n[s>>2]);gb=qc<sc;Hb=f[(gb?o:l)>>2]|0;f[l>>2]=Hb;mc=gb?sc:qc;n[o>>2]=mc;gb=oc<oa;Ma=f[(gb?t:q)>>2]|0;f[q>>2]=Ma;qc=gb?oa:oc;n[t>>2]=qc;oc=+n[k>>2];oa=(f[s>>2]=pb,+n[s>>2]);pb=oa<oc;gb=f[(pb?r:k)>>2]|0;f[k>>2]=gb;sc=pb?oc:oa;n[r>>2]=sc;oa=+n[p>>2];pb=pc<oa;Ib=f[(pb?x:p)>>2]|0;f[p>>2]=Ib;n[x>>2]=pb?oa:pc;pc=(f[s>>2]=Ib,+n[s>>2]);Ib=sc<pc;pb=f[(Ib?r:p)>>2]|0;f[p>>2]=pb;oa=Ib?pc:sc;n[r>>2]=oa;sc=+n[m>>2];pc=(f[s>>2]=fb,+n[s>>2]);fb=pc<sc;Ib=f[(fb?v:m)>>2]|0;f[m>>2]=Ib;oc=fb?sc:pc;n[v>>2]=oc;pc=(f[s>>2]=Ib,+n[s>>2]);sc=(f[s>>2]=pb,+n[s>>2]);pb=sc<pc;Ib=f[(pb?p:m)>>2]|0;f[m>>2]=Ib;rc=pb?pc:sc;n[p>>2]=rc;pb=oc<oa;fb=f[(pb?v:r)>>2]|0;f[r>>2]=fb;sc=pb?oa:oc;n[v>>2]=sc;oc=(f[s>>2]=gb,+n[s>>2]);oa=(f[s>>2]=Hb,+n[s>>2]);Hb=oa<oc;f[k>>2]=f[(Hb?l:k)>>2];n[l>>2]=Hb?oc:oa;oa=(f[s>>2]=Ib,+n[s>>2]);Ib=mc<oa;f[m>>2]=f[(Ib?o:m)>>2];n[o>>2]=Ib?oa:mc;mc=(f[s>>2]=Ma,+n[s>>2]);Ma=mc<rc;f[p>>2]=f[(Ma?q:p)>>2];n[q>>2]=Ma?rc:mc;mc=(f[s>>2]=fb,+n[s>>2]);fb=qc<mc;f[r>>2]=f[(fb?t:r)>>2];n[t>>2]=fb?mc:qc;qc=+n[w>>2];fb=qc<sc;f[v>>2]=f[(fb?w:v)>>2];n[w>>2]=fb?sc:qc;qc=+n[z>>2];sc=+n[A>>2];fb=sc<qc;Ma=f[(fb?A:z)>>2]|0;f[z>>2]=Ma;mc=fb?qc:sc;n[A>>2]=mc;sc=+n[y>>2];qc=(f[s>>2]=Ma,+n[s>>2]);Ma=qc<sc;fb=f[(Ma?z:y)>>2]|0;f[y>>2]=fb;rc=Ma?sc:qc;n[z>>2]=rc;Ma=mc<rc;Ib=f[(Ma?A:z)>>2]|0;f[z>>2]=Ib;qc=Ma?rc:mc;n[A>>2]=qc;mc=+n[C>>2];rc=+n[D>>2];Ma=rc<mc;Hb=f[(Ma?D:C)>>2]|0;f[C>>2]=Hb;sc=Ma?mc:rc;n[D>>2]=sc;rc=+n[B>>2];mc=(f[s>>2]=Hb,+n[s>>2]);Hb=mc<rc;Ma=f[(Hb?C:B)>>2]|0;f[B>>2]=Ma;oa=Hb?rc:mc;n[C>>2]=oa;Hb=sc<oa;gb=f[(Hb?D:C)>>2]|0;f[C>>2]=gb;mc=Hb?oa:sc;n[D>>2]=mc;sc=(f[s>>2]=fb,+n[s>>2]);oa=(f[s>>2]=Ma,+n[s>>2]);Ma=oa<sc;f[y>>2]=f[(Ma?B:y)>>2];rc=Ma?sc:oa;n[B>>2]=rc;Ma=mc<qc;fb=f[(Ma?D:A)>>2]|0;f[A>>2]=fb;n[D>>2]=Ma?qc:mc;mc=(f[s>>2]=fb,+n[s>>2]);fb=rc<mc;Ma=f[(fb?B:A)>>2]|0;f[A>>2]=Ma;qc=fb?mc:rc;n[B>>2]=qc;rc=(f[s>>2]=Ib,+n[s>>2]);mc=(f[s>>2]=gb,+n[s>>2]);gb=mc<rc;Ib=f[(gb?C:z)>>2]|0;f[z>>2]=Ib;oa=gb?rc:mc;n[C>>2]=oa;mc=(f[s>>2]=Ib,+n[s>>2]);rc=(f[s>>2]=Ma,+n[s>>2]);Ma=rc<mc;f[z>>2]=f[(Ma?A:z)>>2];n[A>>2]=Ma?mc:rc;Ma=oa<qc;f[B>>2]=f[(Ma?C:B)>>2];n[C>>2]=Ma?qc:oa;oa=+n[F>>2];qc=+n[G>>2];Ma=qc<oa;Ib=f[(Ma?G:F)>>2]|0;f[F>>2]=Ib;rc=Ma?oa:qc;n[G>>2]=rc;qc=+n[E>>2];oa=(f[s>>2]=Ib,+n[s>>2]);Ib=oa<qc;Ma=f[(Ib?F:E)>>2]|0;f[E>>2]=Ma;mc=Ib?qc:oa;n[F>>2]=mc;Ib=rc<mc;gb=f[(Ib?G:F)>>2]|0;f[F>>2]=gb;oa=Ib?mc:rc;n[G>>2]=oa;rc=+n[H>>2];mc=+n[I>>2];Ib=mc<rc;fb=f[(Ib?I:H)>>2]|0;f[H>>2]=fb;qc=Ib?rc:mc;n[I>>2]=qc;mc=+n[J>>2];rc=+n[K>>2];Ib=rc<mc;Hb=f[(Ib?K:J)>>2]|0;f[J>>2]=Hb;sc=Ib?mc:rc;n[K>>2]=sc;rc=(f[s>>2]=fb,+n[s>>2]);mc=(f[s>>2]=Hb,+n[s>>2]);Hb=mc<rc;fb=f[(Hb?J:H)>>2]|0;f[H>>2]=fb;oc=Hb?rc:mc;n[J>>2]=oc;Hb=sc<qc;Ib=f[(Hb?K:I)>>2]|0;f[I>>2]=Ib;mc=Hb?qc:sc;n[K>>2]=mc;sc=(f[s>>2]=Ib,+n[s>>2]);Ib=oc<sc;Hb=f[(Ib?J:I)>>2]|0;f[I>>2]=Hb;qc=Ib?sc:oc;n[J>>2]=qc;oc=(f[s>>2]=Ma,+n[s>>2]);sc=(f[s>>2]=fb,+n[s>>2]);fb=sc<oc;Ma=f[(fb?H:E)>>2]|0;f[E>>2]=Ma;rc=fb?oc:sc;n[H>>2]=rc;fb=qc<oa;Ib=f[(fb?J:G)>>2]|0;f[G>>2]=Ib;sc=fb?oa:qc;n[J>>2]=sc;qc=(f[s>>2]=Ib,+n[s>>2]);Ib=rc<qc;fb=f[(Ib?H:G)>>2]|0;f[G>>2]=fb;oa=Ib?qc:rc;n[H>>2]=oa;rc=(f[s>>2]=gb,+n[s>>2]);qc=(f[s>>2]=Hb,+n[s>>2]);Hb=qc<rc;gb=f[(Hb?I:F)>>2]|0;f[F>>2]=gb;oc=Hb?rc:qc;n[I>>2]=oc;Hb=mc<oc;Ib=f[(Hb?K:I)>>2]|0;f[I>>2]=Ib;qc=Hb?oc:mc;n[K>>2]=qc;mc=(f[s>>2]=gb,+n[s>>2]);oc=(f[s>>2]=fb,+n[s>>2]);fb=oc<mc;gb=f[(fb?G:F)>>2]|0;f[F>>2]=gb;rc=fb?mc:oc;n[G>>2]=rc;oc=(f[s>>2]=Ib,+n[s>>2]);Ib=oc<oa;f[H>>2]=f[(Ib?I:H)>>2];mc=Ib?oa:oc;n[I>>2]=mc;Ib=qc<sc;fb=f[(Ib?K:J)>>2]|0;f[J>>2]=fb;oc=Ib?sc:qc;n[K>>2]=oc;qc=+n[y>>2];sc=(f[s>>2]=Ma,+n[s>>2]);Ma=sc<qc;f[y>>2]=f[(Ma?E:y)>>2];oa=Ma?qc:sc;n[E>>2]=oa;sc=+n[C>>2];Ma=mc<sc;Ib=f[(Ma?I:C)>>2]|0;f[C>>2]=Ib;qc=Ma?sc:mc;n[I>>2]=qc;mc=(f[s>>2]=Ib,+n[s>>2]);Ib=oa<mc;Ma=f[(Ib?E:C)>>2]|0;f[C>>2]=Ma;sc=Ib?mc:oa;n[E>>2]=sc;oa=+n[A>>2];Ib=rc<oa;Hb=f[(Ib?G:A)>>2]|0;f[A>>2]=Hb;mc=Ib?oa:rc;n[G>>2]=mc;Ib=oc<mc;pb=f[(Ib?K:G)>>2]|0;f[G>>2]=pb;rc=Ib?mc:oc;n[K>>2]=rc;oc=(f[s>>2]=Hb,+n[s>>2]);mc=(f[s>>2]=Ma,+n[s>>2]);Ma=mc<oc;Hb=f[(Ma?C:A)>>2]|0;f[A>>2]=Hb;oa=Ma?oc:mc;n[C>>2]=oa;mc=(f[s>>2]=pb,+n[s>>2]);pb=mc<sc;Ma=f[(pb?G:E)>>2]|0;f[E>>2]=Ma;oc=pb?sc:mc;n[G>>2]=oc;pb=rc<qc;Ib=f[(pb?K:I)>>2]|0;f[I>>2]=Ib;mc=pb?qc:rc;n[K>>2]=mc;rc=+n[z>>2];qc=(f[s>>2]=gb,+n[s>>2]);gb=qc<rc;pb=f[(gb?F:z)>>2]|0;f[z>>2]=pb;sc=gb?rc:qc;n[F>>2]=sc;qc=+n[D>>2];rc=(f[s>>2]=fb,+n[s>>2]);fb=rc<qc;gb=f[(fb?J:D)>>2]|0;f[D>>2]=gb;pc=fb?qc:rc;n[J>>2]=pc;rc=(f[s>>2]=gb,+n[s>>2]);gb=sc<rc;fb=f[(gb?F:D)>>2]|0;f[D>>2]=fb;qc=gb?rc:sc;n[F>>2]=qc;sc=+n[B>>2];rc=+n[H>>2];gb=rc<sc;ta=f[(gb?H:B)>>2]|0;f[B>>2]=ta;nc=gb?sc:rc;n[H>>2]=nc;rc=(f[s>>2]=ta,+n[s>>2]);sc=(f[s>>2]=fb,+n[s>>2]);fb=sc<rc;ta=f[(fb?D:B)>>2]|0;f[B>>2]=ta;vc=fb?rc:sc;n[D>>2]=vc;fb=nc<qc;gb=f[(fb?H:F)>>2]|0;f[F>>2]=gb;sc=fb?qc:nc;n[H>>2]=sc;nc=(f[s>>2]=pb,+n[s>>2]);qc=(f[s>>2]=Hb,+n[s>>2]);Hb=qc<nc;f[z>>2]=f[(Hb?A:z)>>2];rc=Hb?nc:qc;n[A>>2]=rc;qc=(f[s>>2]=ta,+n[s>>2]);ta=oa<qc;f[B>>2]=f[(ta?C:B)>>2];nc=ta?qc:oa;n[C>>2]=nc;oa=(f[s>>2]=Ma,+n[s>>2]);Ma=oa<vc;f[D>>2]=f[(Ma?E:D)>>2];qc=Ma?vc:oa;n[E>>2]=qc;oa=(f[s>>2]=gb,+n[s>>2]);gb=oc<oa;f[F>>2]=f[(gb?G:F)>>2];vc=gb?oa:oc;n[G>>2]=vc;oc=(f[s>>2]=Ib,+n[s>>2]);Ib=oc<sc;f[H>>2]=f[(Ib?I:H)>>2];oa=Ib?sc:oc;n[I>>2]=oa;Ib=mc<pc;f[J>>2]=f[(Ib?K:J)>>2];oc=Ib?pc:mc;n[K>>2]=oc;mc=+n[i>>2];pc=+n[y>>2];Ib=pc<mc;f[i>>2]=f[(Ib?y:i)>>2];sc=Ib?mc:pc;n[y>>2]=sc;pc=+n[t>>2];Ib=vc<pc;gb=f[(Ib?G:t)>>2]|0;f[t>>2]=gb;n[G>>2]=Ib?pc:vc;vc=(f[s>>2]=gb,+n[s>>2]);gb=sc<vc;f[t>>2]=f[(gb?y:t)>>2];pc=gb?vc:sc;n[y>>2]=pc;sc=+n[o>>2];gb=nc<sc;f[o>>2]=f[(gb?C:o)>>2];vc=gb?sc:nc;n[C>>2]=vc;gb=oc<vc;Ib=f[(gb?K:C)>>2]|0;f[C>>2]=Ib;n[K>>2]=gb?vc:oc;oc=(f[s>>2]=Ib,+n[s>>2]);Ib=oc<pc;gb=f[(Ib?C:y)>>2]|0;f[y>>2]=gb;n[C>>2]=Ib?pc:oc;oc=+n[l>>2];Ib=rc<oc;f[l>>2]=f[(Ib?A:l)>>2];pc=Ib?oc:rc;n[A>>2]=pc;Ib=f[(oa<+n[w>>2]?I:w)>>2]|0;f[w>>2]=Ib;Ma=f[(pc<(f[s>>2]=Ib,+n[s>>2])?A:w)>>2]|0;f[w>>2]=Ma;Ib=f[(qc<+n[q>>2]?E:q)>>2]|0;f[q>>2]=Ib;qc=(f[s>>2]=Ib,+n[s>>2]);pc=(f[s>>2]=Ma,+n[s>>2]);oa=pc<qc?qc:pc;n[w>>2]=oa;pc=(f[s>>2]=gb,+n[s>>2]);qc=pc<oa?oa:pc;pc=+n[k>>2];oa=+n[z>>2];rc=oa<pc?pc:oa;n[z>>2]=rc;gb=f[(+n[H>>2]<+n[v>>2]?H:v)>>2]|0;f[v>>2]=gb;oa=(f[s>>2]=gb,+n[s>>2]);pc=rc<oa?oa:rc;n[z>>2]=pc;rc=+n[p>>2];oa=+n[D>>2];oc=oa<rc?rc:oa;n[D>>2]=oc;oa=oc<pc?oc:+n[z>>2];oc=+n[m>>2];pc=+n[B>>2];rc=pc<oc?oc:pc;n[B>>2]=rc;gb=f[(+n[J>>2]<+n[x>>2]?J:x)>>2]|0;f[x>>2]=gb;Ma=rc<(f[s>>2]=gb,+n[s>>2]);rc=Ma?+n[B>>2]:(f[s>>2]=gb,+n[s>>2]);pc=+n[r>>2];oc=+n[F>>2];vc=oc<pc?oc:pc;pc=rc<vc?vc:rc;rc=oa<pc?oa:pc;n[pa+(da<<2)>>2]=qc<rc?rc:qc;da=da+1|0}while((da|0)!=(Wa|0));wc=Wa}else wc=ya;if((Wa|0)==(Ba|0))break;if((wc|0)>(Ja|0)){Wa=Ba;ya=wc;continue}else xc=wc;while(1){da=Ha+(xc<<2)|0;f[i>>2]=f[da+(Da<<2)>>2];gb=f[da+(va<<2)>>2]|0;f[k>>2]=gb;Ma=f[da>>2]|0;f[l>>2]=Ma;f[m>>2]=f[da+(Ia<<2)>>2];f[o>>2]=f[da+(Ka<<2)>>2];da=nb+(xc<<2)|0;f[p>>2]=f[da+(Da<<2)>>2];f[q>>2]=f[da+(va<<2)>>2];f[r>>2]=f[da>>2];f[t>>2]=f[da+(Ia<<2)>>2];f[v>>2]=f[da+(Ka<<2)>>2];da=ka+(xc<<2)|0;f[w>>2]=f[da+(Da<<2)>>2];f[x>>2]=f[da+(va<<2)>>2];f[y>>2]=f[da>>2];f[z>>2]=f[da+(Ia<<2)>>2];f[A>>2]=f[da+(Ka<<2)>>2];da=la+(xc<<2)|0;f[B>>2]=f[da+(Da<<2)>>2];f[C>>2]=f[da+(va<<2)>>2];f[D>>2]=f[da>>2];f[E>>2]=f[da+(Ia<<2)>>2];f[F>>2]=f[da+(Ka<<2)>>2];da=ob+(xc<<2)|0;f[G>>2]=f[da+(Da<<2)>>2];f[H>>2]=f[da+(va<<2)>>2];f[I>>2]=f[da>>2];f[J>>2]=f[da+(Ia<<2)>>2];f[K>>2]=f[da+(Ka<<2)>>2];qc=(f[s>>2]=gb,+n[s>>2]);rc=(f[s>>2]=Ma,+n[s>>2]);Ma=rc<qc;gb=f[(Ma?l:k)>>2]|0;f[k>>2]=gb;pc=Ma?qc:rc;n[l>>2]=pc;rc=+n[i>>2];qc=(f[s>>2]=gb,+n[s>>2]);gb=qc<rc;Ma=f[(gb?k:i)>>2]|0;f[i>>2]=Ma;oa=gb?rc:qc;n[k>>2]=oa;gb=pc<oa;da=f[(gb?l:k)>>2]|0;f[k>>2]=da;qc=gb?oa:pc;n[l>>2]=qc;pc=+n[o>>2];oa=+n[p>>2];gb=oa<pc;Ib=f[(gb?p:o)>>2]|0;f[o>>2]=Ib;rc=gb?pc:oa;n[p>>2]=rc;oa=+n[m>>2];pc=(f[s>>2]=Ib,+n[s>>2]);Ib=pc<oa;gb=f[(Ib?o:m)>>2]|0;f[m>>2]=gb;vc=Ib?oa:pc;n[o>>2]=vc;Ib=rc<vc;ta=f[(Ib?p:o)>>2]|0;f[o>>2]=ta;pc=Ib?vc:rc;n[p>>2]=pc;rc=(f[s>>2]=Ma,+n[s>>2]);vc=(f[s>>2]=gb,+n[s>>2]);gb=vc<rc;f[i>>2]=f[(gb?m:i)>>2];oa=gb?rc:vc;n[m>>2]=oa;gb=pc<qc;Ma=f[(gb?p:l)>>2]|0;f[l>>2]=Ma;n[p>>2]=gb?qc:pc;pc=(f[s>>2]=Ma,+n[s>>2]);Ma=oa<pc;gb=f[(Ma?m:l)>>2]|0;f[l>>2]=gb;qc=Ma?pc:oa;n[m>>2]=qc;oa=(f[s>>2]=da,+n[s>>2]);pc=(f[s>>2]=ta,+n[s>>2]);ta=pc<oa;da=f[(ta?o:k)>>2]|0;f[k>>2]=da;vc=ta?oa:pc;n[o>>2]=vc;pc=(f[s>>2]=da,+n[s>>2]);oa=(f[s>>2]=gb,+n[s>>2]);gb=oa<pc;f[k>>2]=f[(gb?l:k)>>2];n[l>>2]=gb?pc:oa;gb=vc<qc;f[m>>2]=f[(gb?o:m)>>2];n[o>>2]=gb?qc:vc;vc=+n[r>>2];qc=+n[t>>2];gb=qc<vc;da=f[(gb?t:r)>>2]|0;f[r>>2]=da;oa=gb?vc:qc;n[t>>2]=oa;qc=+n[q>>2];vc=(f[s>>2]=da,+n[s>>2]);da=vc<qc;gb=f[(da?r:q)>>2]|0;f[q>>2]=gb;pc=da?qc:vc;n[r>>2]=pc;da=oa<pc;ta=f[(da?t:r)>>2]|0;f[r>>2]=ta;vc=da?pc:oa;n[t>>2]=vc;oa=+n[w>>2];pc=+n[x>>2];da=pc<oa;Ma=f[(da?x:w)>>2]|0;f[w>>2]=Ma;qc=da?oa:pc;n[x>>2]=qc;pc=+n[v>>2];oa=(f[s>>2]=Ma,+n[s>>2]);Ma=oa<pc;da=f[(Ma?w:v)>>2]|0;f[v>>2]=da;rc=Ma?pc:oa;n[w>>2]=rc;Ma=qc<rc;Ib=f[(Ma?x:w)>>2]|0;f[w>>2]=Ib;oa=Ma?rc:qc;n[x>>2]=oa;qc=(f[s>>2]=gb,+n[s>>2]);rc=(f[s>>2]=da,+n[s>>2]);da=rc<qc;gb=f[(da?v:q)>>2]|0;f[q>>2]=gb;pc=da?qc:rc;n[v>>2]=pc;da=oa<vc;Ma=f[(da?x:t)>>2]|0;f[t>>2]=Ma;rc=da?vc:oa;n[x>>2]=rc;oa=(f[s>>2]=Ma,+n[s>>2]);Ma=pc<oa;da=f[(Ma?v:t)>>2]|0;f[t>>2]=da;vc=Ma?oa:pc;n[v>>2]=vc;pc=(f[s>>2]=ta,+n[s>>2]);oa=(f[s>>2]=Ib,+n[s>>2]);Ib=oa<pc;ta=f[(Ib?w:r)>>2]|0;f[r>>2]=ta;qc=Ib?pc:oa;n[w>>2]=qc;oa=(f[s>>2]=ta,+n[s>>2]);pc=(f[s>>2]=da,+n[s>>2]);da=pc<oa;ta=f[(da?t:r)>>2]|0;f[r>>2]=ta;oc=da?oa:pc;n[t>>2]=oc;da=qc<vc;Ib=f[(da?w:v)>>2]|0;f[v>>2]=Ib;pc=da?vc:qc;n[w>>2]=pc;qc=+n[i>>2];vc=(f[s>>2]=gb,+n[s>>2]);gb=vc<qc;f[i>>2]=f[(gb?q:i)>>2];oa=gb?qc:vc;n[q>>2]=oa;vc=+n[o>>2];gb=pc<vc;da=f[(gb?w:o)>>2]|0;f[o>>2]=da;n[w>>2]=gb?vc:pc;pc=(f[s>>2]=da,+n[s>>2]);da=oa<pc;gb=f[(da?q:o)>>2]|0;f[o>>2]=gb;vc=da?pc:oa;n[q>>2]=vc;oa=+n[l>>2];da=oc<oa;Ma=f[(da?t:l)>>2]|0;f[l>>2]=Ma;pc=da?oa:oc;n[t>>2]=pc;oc=(f[s>>2]=Ma,+n[s>>2]);oa=(f[s>>2]=gb,+n[s>>2]);gb=oa<oc;Ma=f[(gb?o:l)>>2]|0;f[l>>2]=Ma;qc=gb?oc:oa;n[o>>2]=qc;gb=pc<vc;da=f[(gb?t:q)>>2]|0;f[q>>2]=da;oa=gb?vc:pc;n[t>>2]=oa;pc=+n[k>>2];vc=(f[s>>2]=ta,+n[s>>2]);ta=vc<pc;gb=f[(ta?r:k)>>2]|0;f[k>>2]=gb;oc=ta?pc:vc;n[r>>2]=oc;vc=+n[p>>2];ta=rc<vc;Hb=f[(ta?x:p)>>2]|0;f[p>>2]=Hb;n[x>>2]=ta?vc:rc;rc=(f[s>>2]=Hb,+n[s>>2]);Hb=oc<rc;ta=f[(Hb?r:p)>>2]|0;f[p>>2]=ta;vc=Hb?rc:oc;n[r>>2]=vc;oc=+n[m>>2];rc=(f[s>>2]=Ib,+n[s>>2]);Ib=rc<oc;Hb=f[(Ib?v:m)>>2]|0;f[m>>2]=Hb;pc=Ib?oc:rc;n[v>>2]=pc;rc=(f[s>>2]=Hb,+n[s>>2]);oc=(f[s>>2]=ta,+n[s>>2]);ta=oc<rc;Hb=f[(ta?p:m)>>2]|0;f[m>>2]=Hb;nc=ta?rc:oc;n[p>>2]=nc;ta=pc<vc;Ib=f[(ta?v:r)>>2]|0;f[r>>2]=Ib;oc=ta?vc:pc;n[v>>2]=oc;pc=(f[s>>2]=gb,+n[s>>2]);vc=(f[s>>2]=Ma,+n[s>>2]);Ma=vc<pc;f[k>>2]=f[(Ma?l:k)>>2];n[l>>2]=Ma?pc:vc;vc=(f[s>>2]=Hb,+n[s>>2]);Hb=qc<vc;f[m>>2]=f[(Hb?o:m)>>2];n[o>>2]=Hb?vc:qc;qc=(f[s>>2]=da,+n[s>>2]);da=qc<nc;f[p>>2]=f[(da?q:p)>>2];n[q>>2]=da?nc:qc;qc=(f[s>>2]=Ib,+n[s>>2]);Ib=oa<qc;f[r>>2]=f[(Ib?t:r)>>2];n[t>>2]=Ib?qc:oa;oa=+n[w>>2];Ib=oa<oc;f[v>>2]=f[(Ib?w:v)>>2];n[w>>2]=Ib?oc:oa;oa=+n[z>>2];oc=+n[A>>2];Ib=oc<oa;da=f[(Ib?A:z)>>2]|0;f[z>>2]=da;qc=Ib?oa:oc;n[A>>2]=qc;oc=+n[y>>2];oa=(f[s>>2]=da,+n[s>>2]);da=oa<oc;Ib=f[(da?z:y)>>2]|0;f[y>>2]=Ib;nc=da?oc:oa;n[z>>2]=nc;da=qc<nc;Hb=f[(da?A:z)>>2]|0;f[z>>2]=Hb;oa=da?nc:qc;n[A>>2]=oa;qc=+n[C>>2];nc=+n[D>>2];da=nc<qc;Ma=f[(da?D:C)>>2]|0;f[C>>2]=Ma;oc=da?qc:nc;n[D>>2]=oc;nc=+n[B>>2];qc=(f[s>>2]=Ma,+n[s>>2]);Ma=qc<nc;da=f[(Ma?C:B)>>2]|0;f[B>>2]=da;vc=Ma?nc:qc;n[C>>2]=vc;Ma=oc<vc;gb=f[(Ma?D:C)>>2]|0;f[C>>2]=gb;qc=Ma?vc:oc;n[D>>2]=qc;oc=(f[s>>2]=Ib,+n[s>>2]);vc=(f[s>>2]=da,+n[s>>2]);da=vc<oc;f[y>>2]=f[(da?B:y)>>2];nc=da?oc:vc;n[B>>2]=nc;da=qc<oa;Ib=f[(da?D:A)>>2]|0;f[A>>2]=Ib;n[D>>2]=da?oa:qc;qc=(f[s>>2]=Ib,+n[s>>2]);Ib=nc<qc;da=f[(Ib?B:A)>>2]|0;f[A>>2]=da;oa=Ib?qc:nc;n[B>>2]=oa;nc=(f[s>>2]=Hb,+n[s>>2]);qc=(f[s>>2]=gb,+n[s>>2]);gb=qc<nc;Hb=f[(gb?C:z)>>2]|0;f[z>>2]=Hb;vc=gb?nc:qc;n[C>>2]=vc;qc=(f[s>>2]=Hb,+n[s>>2]);nc=(f[s>>2]=da,+n[s>>2]);da=nc<qc;f[z>>2]=f[(da?A:z)>>2];n[A>>2]=da?qc:nc;da=vc<oa;f[B>>2]=f[(da?C:B)>>2];n[C>>2]=da?oa:vc;vc=+n[F>>2];oa=+n[G>>2];da=oa<vc;Hb=f[(da?G:F)>>2]|0;f[F>>2]=Hb;nc=da?vc:oa;n[G>>2]=nc;oa=+n[E>>2];vc=(f[s>>2]=Hb,+n[s>>2]);Hb=vc<oa;da=f[(Hb?F:E)>>2]|0;f[E>>2]=da;qc=Hb?oa:vc;n[F>>2]=qc;Hb=nc<qc;gb=f[(Hb?G:F)>>2]|0;f[F>>2]=gb;vc=Hb?qc:nc;n[G>>2]=vc;nc=+n[H>>2];qc=+n[I>>2];Hb=qc<nc;Ib=f[(Hb?I:H)>>2]|0;f[H>>2]=Ib;oa=Hb?nc:qc;n[I>>2]=oa;qc=+n[J>>2];nc=+n[K>>2];Hb=nc<qc;Ma=f[(Hb?K:J)>>2]|0;f[J>>2]=Ma;oc=Hb?qc:nc;n[K>>2]=oc;nc=(f[s>>2]=Ib,+n[s>>2]);qc=(f[s>>2]=Ma,+n[s>>2]);Ma=qc<nc;Ib=f[(Ma?J:H)>>2]|0;f[H>>2]=Ib;pc=Ma?nc:qc;n[J>>2]=pc;Ma=oc<oa;Hb=f[(Ma?K:I)>>2]|0;f[I>>2]=Hb;qc=Ma?oa:oc;n[K>>2]=qc;oc=(f[s>>2]=Hb,+n[s>>2]);Hb=pc<oc;Ma=f[(Hb?J:I)>>2]|0;f[I>>2]=Ma;oa=Hb?oc:pc;n[J>>2]=oa;pc=(f[s>>2]=da,+n[s>>2]);oc=(f[s>>2]=Ib,+n[s>>2]);Ib=oc<pc;da=f[(Ib?H:E)>>2]|0;f[E>>2]=da;nc=Ib?pc:oc;n[H>>2]=nc;Ib=oa<vc;Hb=f[(Ib?J:G)>>2]|0;f[G>>2]=Hb;oc=Ib?vc:oa;n[J>>2]=oc;oa=(f[s>>2]=Hb,+n[s>>2]);Hb=nc<oa;Ib=f[(Hb?H:G)>>2]|0;f[G>>2]=Ib;vc=Hb?oa:nc;n[H>>2]=vc;nc=(f[s>>2]=gb,+n[s>>2]);oa=(f[s>>2]=Ma,+n[s>>2]);Ma=oa<nc;gb=f[(Ma?I:F)>>2]|0;f[F>>2]=gb;pc=Ma?nc:oa;n[I>>2]=pc;Ma=qc<pc;Hb=f[(Ma?K:I)>>2]|0;f[I>>2]=Hb;oa=Ma?pc:qc;n[K>>2]=oa;qc=(f[s>>2]=gb,+n[s>>2]);pc=(f[s>>2]=Ib,+n[s>>2]);Ib=pc<qc;gb=f[(Ib?G:F)>>2]|0;f[F>>2]=gb;nc=Ib?qc:pc;n[G>>2]=nc;pc=(f[s>>2]=Hb,+n[s>>2]);Hb=pc<vc;f[H>>2]=f[(Hb?I:H)>>2];qc=Hb?vc:pc;n[I>>2]=qc;Hb=oa<oc;Ib=f[(Hb?K:J)>>2]|0;f[J>>2]=Ib;pc=Hb?oc:oa;n[K>>2]=pc;oa=+n[y>>2];oc=(f[s>>2]=da,+n[s>>2]);da=oc<oa;f[y>>2]=f[(da?E:y)>>2];vc=da?oa:oc;n[E>>2]=vc;oc=+n[C>>2];da=qc<oc;Hb=f[(da?I:C)>>2]|0;f[C>>2]=Hb;oa=da?oc:qc;n[I>>2]=oa;qc=(f[s>>2]=Hb,+n[s>>2]);Hb=vc<qc;da=f[(Hb?E:C)>>2]|0;f[C>>2]=da;oc=Hb?qc:vc;n[E>>2]=oc;vc=+n[A>>2];Hb=nc<vc;Ma=f[(Hb?G:A)>>2]|0;f[A>>2]=Ma;qc=Hb?vc:nc;n[G>>2]=qc;Hb=pc<qc;ta=f[(Hb?K:G)>>2]|0;f[G>>2]=ta;nc=Hb?qc:pc;n[K>>2]=nc;pc=(f[s>>2]=Ma,+n[s>>2]);qc=(f[s>>2]=da,+n[s>>2]);da=qc<pc;Ma=f[(da?C:A)>>2]|0;f[A>>2]=Ma;vc=da?pc:qc;n[C>>2]=vc;qc=(f[s>>2]=ta,+n[s>>2]);ta=qc<oc;da=f[(ta?G:E)>>2]|0;f[E>>2]=da;pc=ta?oc:qc;n[G>>2]=pc;ta=nc<oa;Hb=f[(ta?K:I)>>2]|0;f[I>>2]=Hb;qc=ta?oa:nc;n[K>>2]=qc;nc=+n[z>>2];oa=(f[s>>2]=gb,+n[s>>2]);gb=oa<nc;ta=f[(gb?F:z)>>2]|0;f[z>>2]=ta;oc=gb?nc:oa;n[F>>2]=oc;oa=+n[D>>2];nc=(f[s>>2]=Ib,+n[s>>2]);Ib=nc<oa;gb=f[(Ib?J:D)>>2]|0;f[D>>2]=gb;rc=Ib?oa:nc;n[J>>2]=rc;nc=(f[s>>2]=gb,+n[s>>2]);gb=oc<nc;Ib=f[(gb?F:D)>>2]|0;f[D>>2]=Ib;oa=gb?nc:oc;n[F>>2]=oa;oc=+n[B>>2];nc=+n[H>>2];gb=nc<oc;pb=f[(gb?H:B)>>2]|0;f[B>>2]=pb;sc=gb?oc:nc;n[H>>2]=sc;nc=(f[s>>2]=pb,+n[s>>2]);oc=(f[s>>2]=Ib,+n[s>>2]);Ib=oc<nc;pb=f[(Ib?D:B)>>2]|0;f[B>>2]=pb;mc=Ib?nc:oc;n[D>>2]=mc;Ib=sc<oa;gb=f[(Ib?H:F)>>2]|0;f[F>>2]=gb;oc=Ib?oa:sc;n[H>>2]=oc;sc=(f[s>>2]=ta,+n[s>>2]);oa=(f[s>>2]=Ma,+n[s>>2]);Ma=oa<sc;f[z>>2]=f[(Ma?A:z)>>2];nc=Ma?sc:oa;n[A>>2]=nc;oa=(f[s>>2]=pb,+n[s>>2]);pb=vc<oa;f[B>>2]=f[(pb?C:B)>>2];sc=pb?oa:vc;n[C>>2]=sc;vc=(f[s>>2]=da,+n[s>>2]);da=vc<mc;f[D>>2]=f[(da?E:D)>>2];oa=da?mc:vc;n[E>>2]=oa;vc=(f[s>>2]=gb,+n[s>>2]);gb=pc<vc;f[F>>2]=f[(gb?G:F)>>2];mc=gb?vc:pc;n[G>>2]=mc;pc=(f[s>>2]=Hb,+n[s>>2]);Hb=pc<oc;f[H>>2]=f[(Hb?I:H)>>2];vc=Hb?oc:pc;n[I>>2]=vc;Hb=qc<rc;f[J>>2]=f[(Hb?K:J)>>2];pc=Hb?rc:qc;n[K>>2]=pc;qc=+n[i>>2];rc=+n[y>>2];Hb=rc<qc;f[i>>2]=f[(Hb?y:i)>>2];oc=Hb?qc:rc;n[y>>2]=oc;rc=+n[t>>2];Hb=mc<rc;gb=f[(Hb?G:t)>>2]|0;f[t>>2]=gb;n[G>>2]=Hb?rc:mc;mc=(f[s>>2]=gb,+n[s>>2]);gb=oc<mc;f[t>>2]=f[(gb?y:t)>>2];rc=gb?mc:oc;n[y>>2]=rc;oc=+n[o>>2];gb=sc<oc;f[o>>2]=f[(gb?C:o)>>2];mc=gb?oc:sc;n[C>>2]=mc;gb=pc<mc;Hb=f[(gb?K:C)>>2]|0;f[C>>2]=Hb;n[K>>2]=gb?mc:pc;pc=(f[s>>2]=Hb,+n[s>>2]);Hb=pc<rc;gb=f[(Hb?C:y)>>2]|0;f[y>>2]=gb;n[C>>2]=Hb?rc:pc;pc=+n[l>>2];Hb=nc<pc;f[l>>2]=f[(Hb?A:l)>>2];rc=Hb?pc:nc;n[A>>2]=rc;Hb=f[(vc<+n[w>>2]?I:w)>>2]|0;f[w>>2]=Hb;da=f[(rc<(f[s>>2]=Hb,+n[s>>2])?A:w)>>2]|0;f[w>>2]=da;Hb=f[(oa<+n[q>>2]?E:q)>>2]|0;f[q>>2]=Hb;oa=(f[s>>2]=Hb,+n[s>>2]);rc=(f[s>>2]=da,+n[s>>2]);vc=rc<oa?oa:rc;n[w>>2]=vc;rc=(f[s>>2]=gb,+n[s>>2]);oa=rc<vc?vc:rc;rc=+n[k>>2];vc=+n[z>>2];nc=vc<rc?rc:vc;n[z>>2]=nc;gb=f[(+n[H>>2]<+n[v>>2]?H:v)>>2]|0;f[v>>2]=gb;vc=(f[s>>2]=gb,+n[s>>2]);rc=nc<vc?vc:nc;n[z>>2]=rc;nc=+n[p>>2];vc=+n[D>>2];pc=vc<nc?nc:vc;n[D>>2]=pc;vc=pc<rc?pc:+n[z>>2];pc=+n[m>>2];rc=+n[B>>2];nc=rc<pc?pc:rc;n[B>>2]=nc;gb=f[(+n[J>>2]<+n[x>>2]?J:x)>>2]|0;f[x>>2]=gb;da=nc<(f[s>>2]=gb,+n[s>>2]);nc=da?+n[B>>2]:(f[s>>2]=gb,+n[s>>2]);rc=+n[r>>2];pc=+n[F>>2];mc=pc<rc?pc:rc;rc=nc<mc?mc:nc;nc=vc<rc?vc:rc;n[pa+(xc<<2)>>2]=oa<nc?nc:oa;gb=xc+1|0;if((xc|0)<(Ja|0))xc=gb;else{Wa=Ba;ya=gb;continue k}}}if((na|0)==(Ga|0))break;else pa=pa+(wa<<2)|0}break}default:break a}break}default:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;vM(-210,i,270071,270082,1213)}}}while(0);i=O+36|0;xc=f[i>>2]|0;if(xc|0?(F=xc+12|0,xc=f[F>>2]|0,f[F>>2]=xc+-1,(xc|0)==1):0)V$(O);f[i>>2]=0;i=O+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[P>>2]|0)>0){i=f[Z>>2]|0;Z=0;do{f[i+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[P>>2]|0))}P=f[W>>2]|0;if((P|0)!=(Q|0))wL(P);P=N+36|0;Q=f[P>>2]|0;if(Q|0?(W=Q+12|0,Q=f[W>>2]|0,f[W>>2]=Q+-1,(Q|0)==1):0)V$(N);f[P>>2]=0;P=N+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[P>>2]|0)>0){aa=f[N+40>>2]|0;Q=0;do{f[aa+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[P>>2]|0))}P=f[N+44>>2]|0;if((P|0)!=(N+48|0))wL(P);P=L+36|0;N=f[P>>2]|0;if(N|0?(Q=N+12|0,N=f[Q>>2]|0,f[Q>>2]=N+-1,(N|0)==1):0)V$(L);f[P>>2]=0;P=L+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[P>>2]|0)>0){R=f[$>>2]|0;$=0;do{f[R+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[P>>2]|0))}P=f[L+44>>2]|0;if((P|0)!=(L+48|0))wL(P);u=g;return}uS(a,c);u=g;return}function epa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0;e=u;u=u+128|0;g=e+100|0;i=e;j=f[a+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=f[c+48>>2]|0;n=f[c+40>>2]|0;c=f[n+4>>2]|0;o=f[n>>2]|0;n=(f[a>>2]|0)>>>3;a=n&511;p=a+1|0;switch(d|0){case 3:{d=(o|0)==1;if((c|0)==1|d){q=o+c|0;r=q+-1|0;s=d?p:l;t=d?0:l-p|0;v=d?p:m;if((q|0)<=1){u=e;return}d=0-s|0;w=q+-2|0;q=j;x=k;y=0;while(1){z=(y|0)>0?d:0;A=(y|0)<(w|0)?s:0;B=0;C=q;while(1){D=h[C+z>>0]|0;E=h[C>>0]|0;F=D-E+256|0;if(F>>>0<769)G=h[274204+F>>0]|0;else G=0;F=G+E|0;E=F-(h[C+A>>0]|0)+256|0;if(E>>>0<769)H=h[274204+E>>0]|0;else H=0;E=F-H|0;F=(D|256)-G-E|0;if(F>>>0<769)I=h[274204+F>>0]|0;else I=0;b[x+B>>0]=I+E;B=B+1|0;if((B|0)==(p|0))break;else C=C+1|0}y=y+1|0;if((y|0)>=(r|0))break;else{q=q+p+t|0;x=x+v|0}}u=e;return}v=Y(p,c)|0;if((o|0)<=0){u=e;return}x=o+-1|0;t=(n|-512)^511;q=t+-1+v|0;r=v-p|0;y=k;I=0;while(1){G=I+-1|0;H=j+(Y((G|0)>0?G:0,l)|0)|0;G=j+(Y(I,l)|0)|0;I=I+1|0;s=j+(Y((x|0)<(I|0)?x:I,l)|0)|0;w=p;d=0;a:while(1){if((d|0)<(w|0)){C=d;do{B=C-((C|0)>(a|0)?p:0)|0;A=((C|0)<(r|0)?p:0)+C|0;z=h[H+B>>0]|0;E=h[H+C>>0]|0;F=h[H+A>>0]|0;D=h[G+B>>0]|0;J=h[G+C>>0]|0;K=h[G+A>>0]|0;L=h[s+B>>0]|0;B=h[s+C>>0]|0;M=h[s+A>>0]|0;A=E-F+256|0;if(A>>>0<769)N=h[274204+A>>0]|0;else N=0;A=N+F|0;F=E-N|0;E=J-K+256|0;if(E>>>0<769)O=h[274204+E>>0]|0;else O=0;E=O+K|0;K=J-O|0;J=B-M+256|0;if(J>>>0<769)P=h[274204+J>>0]|0;else P=0;J=P+M|0;M=B-P|0;B=z-F+256|0;if(B>>>0<769)Q=h[274204+B>>0]|0;else Q=0;B=Q+F|0;F=D-K+256|0;if(F>>>0<769)R=h[274204+F>>0]|0;else R=0;F=R+K|0;K=D-R|0;D=L-M+256|0;if(D>>>0<769)S=h[274204+D>>0]|0;else S=0;D=S+M|0;M=L-S|0;L=B-A+256|0;if(L>>>0<769)T=h[274204+L>>0]|0;else T=0;L=T+A|0;A=F-E+256|0;if(A>>>0<769)U=h[274204+A>>0]|0;else U=0;A=U+E|0;E=F-U|0;F=D-J+256|0;if(F>>>0<769)V=h[274204+F>>0]|0;else V=0;F=D-V|0;D=(z|256)-Q-K|0;if(D>>>0<769)W=h[274204+D>>0]|0;else W=0;D=256-J+A-V|0;if(D>>>0<769)X=h[274204+D>>0]|0;else X=0;D=E-F+256|0;if(D>>>0<769)Z=h[274204+D>>0]|0;else Z=0;D=E-Z|0;E=K+256-M+W|0;if(E>>>0<769)_=h[274204+E>>0]|0;else _=0;E=B+256-T-D|0;if(E>>>0<769)$=h[274204+E>>0]|0;else $=0;E=$+D|0;D=L+256-A+X|0;if(D>>>0<769)aa=h[274204+D>>0]|0;else aa=0;D=L-aa|0;L=256-F-Z+E|0;if(L>>>0<769)ba=h[274204+L>>0]|0;else ba=0;L=E-ba|0;E=L-D+256|0;if(E>>>0<769)ca=h[274204+E>>0]|0;else ca=0;E=L-ca|0;L=M+256+_-E|0;if(L>>>0<769)da=h[274204+L>>0]|0;else da=0;L=da+E|0;E=256-D-ca+L|0;if(E>>>0<769)ea=h[274204+E>>0]|0;else ea=0;b[y+C>>0]=L-ea;C=C+1|0}while((C|0)!=(w|0));fa=w}else fa=d;if((w|0)==(v|0))break;if((fa|0)>(q|0)){w=v;d=fa;continue}else ga=fa;while(1){C=H+ga|0;L=h[C+t>>0]|0;E=h[C>>0]|0;D=h[C+p>>0]|0;C=G+ga|0;M=h[C+t>>0]|0;F=h[C>>0]|0;A=h[C+p>>0]|0;C=s+ga|0;B=h[C+t>>0]|0;K=h[C>>0]|0;J=h[C+p>>0]|0;C=E-D+256|0;if(C>>>0<769)ha=h[274204+C>>0]|0;else ha=0;C=ha+D|0;D=E-ha|0;E=F-A+256|0;if(E>>>0<769)ia=h[274204+E>>0]|0;else ia=0;E=ia+A|0;A=F-ia|0;F=K-J+256|0;if(F>>>0<769)ja=h[274204+F>>0]|0;else ja=0;F=ja+J|0;J=K-ja|0;K=L-D+256|0;if(K>>>0<769)ka=h[274204+K>>0]|0;else ka=0;K=ka+D|0;D=M-A+256|0;if(D>>>0<769)la=h[274204+D>>0]|0;else la=0;D=la+A|0;A=M-la|0;M=B-J+256|0;if(M>>>0<769)ma=h[274204+M>>0]|0;else ma=0;M=ma+J|0;J=B-ma|0;B=K-C+256|0;if(B>>>0<769)na=h[274204+B>>0]|0;else na=0;B=na+C|0;C=D-E+256|0;if(C>>>0<769)oa=h[274204+C>>0]|0;else oa=0;C=oa+E|0;E=D-oa|0;D=M-F+256|0;if(D>>>0<769)pa=h[274204+D>>0]|0;else pa=0;D=M-pa|0;M=(L|256)-ka-A|0;if(M>>>0<769)qa=h[274204+M>>0]|0;else qa=0;M=256-F+C-pa|0;if(M>>>0<769)ra=h[274204+M>>0]|0;else ra=0;M=E-D+256|0;if(M>>>0<769)sa=h[274204+M>>0]|0;else sa=0;M=E-sa|0;E=A+256-J+qa|0;if(E>>>0<769)ta=h[274204+E>>0]|0;else ta=0;E=K+256-na-M|0;if(E>>>0<769)ua=h[274204+E>>0]|0;else ua=0;E=ua+M|0;M=B+256-C+ra|0;if(M>>>0<769)va=h[274204+M>>0]|0;else va=0;M=B-va|0;B=256-D-sa+E|0;if(B>>>0<769)wa=h[274204+B>>0]|0;else wa=0;B=E-wa|0;E=B-M+256|0;if(E>>>0<769)xa=h[274204+E>>0]|0;else xa=0;E=B-xa|0;B=J+256+ta-E|0;if(B>>>0<769)ya=h[274204+B>>0]|0;else ya=0;B=ya+E|0;E=256-M-xa+B|0;if(E>>>0<769)za=h[274204+E>>0]|0;else za=0;b[y+ga>>0]=B-za;B=ga+1|0;if((ga|0)<(q|0))ga=B;else{w=v;d=B;continue a}}}if((I|0)==(o|0))break;else y=y+m|0}u=e;return}case 5:{y=(o|0)==1;if((c|0)==1|y){I=o+c|0;v=I+-1|0;ga=y?p:l;q=y?0:l-p|0;za=y?p:m;if((I|0)<=1){u=e;return}y=0-ga|0;xa=y<<1;ya=I+-2|0;ta=I+-3|0;I=ga<<1;wa=j;sa=k;va=0;while(1){ra=(va|0)>0?y:0;ua=(va|0)>1?xa:ra;na=(va|0)<(ya|0)?ga:0;qa=(va|0)<(ta|0)?I:na;pa=wa;ka=0;while(1){oa=h[pa+ua>>0]|0;ma=h[pa+ra>>0]|0;la=h[pa>>0]|0;ja=h[pa+na>>0]|0;ia=h[pa+qa>>0]|0;ha=oa-ma+256|0;if(ha>>>0<769)Aa=h[274204+ha>>0]|0;else Aa=0;ha=ja-ia+256|0;if(ha>>>0<769)Ba=h[274204+ha>>0]|0;else Ba=0;ha=Ba+ia|0;ia=ja-Ba|0;ja=la-ia+256|0;if(ja>>>0<769)Ca=h[274204+ja>>0]|0;else Ca=0;ja=Ca+ia|0;ia=la-Ca|0;la=ja-ha+256|0;if(la>>>0<769)Da=h[274204+la>>0]|0;else Da=0;la=(oa|256)-Aa-ia|0;if(la>>>0<769)Ea=h[274204+la>>0]|0;else Ea=0;la=Ea+ia|0;ia=256-ha-Da+la|0;if(ia>>>0<769)Fa=h[274204+ia>>0]|0;else Fa=0;ia=la-Fa|0;la=Aa+ma+256|0;ma=la-ja+Da|0;if(ma>>>0<769)Ga=h[274204+ma>>0]|0;else Ga=0;ma=la-ia-Ga|0;if(ma>>>0<769)Ha=h[274204+ma>>0]|0;else Ha=0;b[sa+ka>>0]=Ha+ia;ka=ka+1|0;if((ka|0)==(p|0))break;else pa=pa+1|0}va=va+1|0;if((va|0)>=(v|0))break;else{wa=wa+p+q|0;sa=sa+za|0}}u=e;return}za=Y(p,c)|0;if((o|0)<=0){u=e;return}c=g+4|0;sa=g+8|0;q=o+-1|0;wa=g+12|0;v=g+16|0;va=p<<1;Ha=0-va|0;Ga=za+-1-va|0;Da=(n|-512)^511;n=i+4|0;Aa=i+8|0;Fa=i+16|0;Ea=i+20|0;Ca=i+12|0;Ba=i+28|0;I=i+32|0;ta=i+24|0;ga=i+40|0;ya=i+44|0;xa=i+36|0;y=i+52|0;pa=i+56|0;ka=i+48|0;qa=i+64|0;na=i+68|0;ra=i+60|0;ua=i+76|0;ia=i+80|0;ma=i+72|0;la=i+84|0;ja=i+88|0;ha=i+92|0;oa=i+96|0;t=za-p|0;fa=za-va|0;ea=i+4|0;ca=i+8|0;da=i+16|0;_=i+20|0;ba=i+12|0;Z=i+28|0;aa=i+32|0;X=i+24|0;$=i+40|0;T=i+44|0;W=i+36|0;V=i+52|0;Q=i+56|0;U=i+48|0;S=i+64|0;R=i+68|0;P=i+60|0;O=i+76|0;N=i+80|0;r=i+72|0;x=i+84|0;d=i+88|0;w=i+92|0;s=i+96|0;G=k;k=0;while(1){H=k+-2|0;B=j+(Y((H|0)>0?H:0,l)|0)|0;f[g>>2]=B;B=k+-1|0;H=j+(Y((B|0)>0?B:0,l)|0)|0;f[c>>2]=H;H=j+(Y(k,l)|0)|0;f[sa>>2]=H;H=k;k=k+1|0;B=j+(Y((q|0)<(k|0)?q:k,l)|0)|0;f[wa>>2]=B;B=H+2|0;H=j+(Y((q|0)<(B|0)?q:B,l)|0)|0;f[v>>2]=H;H=va;B=0;b:while(1){if((B|0)<(H|0)){E=B;do{M=E-((E|0)>(a|0)?p:0)|0;J=(E|0)<(va|0)?M:E-va|0;D=((E|0)<(t|0)?p:0)+E|0;C=(E|0)<(fa|0)?E+va|0:D;K=f[g>>2]|0;f[i>>2]=h[K+J>>0];A=h[K+M>>0]|0;f[ea>>2]=A;F=h[K+E>>0]|0;f[ca>>2]=F;L=h[K+D>>0]|0;f[ba>>2]=L;z=h[K+C>>0]|0;f[da>>2]=z;K=f[c>>2]|0;Ia=h[K+J>>0]|0;f[_>>2]=Ia;Ja=h[K+M>>0]|0;f[X>>2]=Ja;Ka=h[K+E>>0]|0;f[Z>>2]=Ka;La=h[K+D>>0]|0;f[aa>>2]=La;Ma=h[K+C>>0]|0;f[W>>2]=Ma;K=f[sa>>2]|0;Na=h[K+J>>0]|0;f[$>>2]=Na;Oa=h[K+M>>0]|0;f[T>>2]=Oa;Pa=h[K+E>>0]|0;f[U>>2]=Pa;Qa=h[K+D>>0]|0;f[V>>2]=Qa;Ra=h[K+C>>0]|0;f[Q>>2]=Ra;K=f[wa>>2]|0;Sa=h[K+J>>0]|0;f[P>>2]=Sa;Ta=h[K+M>>0]|0;f[S>>2]=Ta;Ua=h[K+E>>0]|0;f[R>>2]=Ua;Va=h[K+D>>0]|0;f[r>>2]=Va;Wa=h[K+C>>0]|0;f[O>>2]=Wa;K=f[v>>2]|0;Xa=h[K+J>>0]|0;f[N>>2]=Xa;J=h[K+M>>0]|0;f[x>>2]=J;M=h[K+E>>0]|0;f[d>>2]=M;Ya=h[K+D>>0]|0;f[w>>2]=Ya;D=h[K+C>>0]|0;f[s>>2]=D;C=A-F+256|0;if(C>>>0<769)Za=h[274204+C>>0]|0;else Za=0;C=Za+F|0;f[ca>>2]=C;F=(f[ea>>2]|0)-Za|0;f[ea>>2]=F;A=f[i>>2]|0;K=A-F+256|0;if(K>>>0<769)_a=h[274204+K>>0]|0;else _a=0;K=_a+F|0;f[ea>>2]=K;F=A-_a|0;f[i>>2]=F;A=K-C+256|0;if(A>>>0<769)$a=h[274204+A>>0]|0;else $a=0;A=$a+C|0;f[ca>>2]=A;C=K-$a|0;f[ea>>2]=C;K=z-Ia+256|0;if(K>>>0<769)ab=h[274204+K>>0]|0;else ab=0;K=ab+Ia|0;f[_>>2]=K;Ia=z-ab|0;f[da>>2]=Ia;z=L-Ia+256|0;if(z>>>0<769)bb=h[274204+z>>0]|0;else bb=0;z=bb+Ia|0;f[da>>2]=z;Ia=L-bb|0;f[ba>>2]=Ia;L=z-K+256|0;if(L>>>0<769)cb=h[274204+L>>0]|0;else cb=0;L=cb+K|0;f[_>>2]=L;K=z-cb|0;f[da>>2]=K;z=F-Ia+256|0;if(z>>>0<769)db=h[274204+z>>0]|0;else db=0;z=db+Ia|0;f[ba>>2]=z;Ia=F-db|0;f[i>>2]=Ia;F=A-L+256|0;if(F>>>0<769)eb=h[274204+F>>0]|0;else eb=0;F=eb+L|0;f[_>>2]=F;L=A-eb|0;f[ca>>2]=L;A=L-z+256|0;if(A>>>0<769)fb=h[274204+A>>0]|0;else fb=0;A=fb+z|0;f[ba>>2]=A;z=L-fb|0;f[ca>>2]=z;L=C-K+256|0;if(L>>>0<769)gb=h[274204+L>>0]|0;else gb=0;L=gb+K|0;f[da>>2]=L;K=C-gb|0;f[ea>>2]=K;C=K-z+256|0;if(C>>>0<769)hb=h[274204+C>>0]|0;else hb=0;C=hb+z|0;f[ca>>2]=C;z=K-hb|0;f[ea>>2]=z;K=A-L+256|0;if(K>>>0<769)ib=h[274204+K>>0]|0;else ib=0;K=ib+L|0;f[da>>2]=K;L=A-ib|0;f[ba>>2]=L;A=Ka-La+256|0;if(A>>>0<769)jb=h[274204+A>>0]|0;else jb=0;A=jb+La|0;f[aa>>2]=A;La=Ka-jb|0;f[Z>>2]=La;Ka=Ja-La+256|0;if(Ka>>>0<769)kb=h[274204+Ka>>0]|0;else kb=0;Ka=kb+La|0;f[Z>>2]=Ka;La=Ja-kb|0;f[X>>2]=La;Ja=Ka-A+256|0;if(Ja>>>0<769)lb=h[274204+Ja>>0]|0;else lb=0;Ja=lb+A|0;f[aa>>2]=Ja;A=Ka-lb|0;f[Z>>2]=A;Ka=Na-Oa+256|0;if(Ka>>>0<769)mb=h[274204+Ka>>0]|0;else mb=0;Ka=mb+Oa|0;f[T>>2]=Ka;Oa=Na-mb|0;f[$>>2]=Oa;Na=Ma-Oa+256|0;if(Na>>>0<769)nb=h[274204+Na>>0]|0;else nb=0;Na=nb+Oa|0;f[$>>2]=Na;Oa=Ma-nb|0;f[W>>2]=Oa;Ma=Na-Ka+256|0;if(Ma>>>0<769)ob=h[274204+Ma>>0]|0;else ob=0;Ma=ob+Ka|0;f[T>>2]=Ma;Ka=Na-ob|0;f[$>>2]=Ka;Na=La-Oa+256|0;if(Na>>>0<769)pb=h[274204+Na>>0]|0;else pb=0;Na=pb+Oa|0;f[W>>2]=Na;Oa=La-pb|0;f[X>>2]=Oa;La=Ja-Ma+256|0;if(La>>>0<769)qb=h[274204+La>>0]|0;else qb=0;La=qb+Ma|0;f[T>>2]=La;Ma=Ja-qb|0;f[aa>>2]=Ma;Ja=Ma-Na+256|0;if(Ja>>>0<769)rb=h[274204+Ja>>0]|0;else rb=0;Ja=rb+Na|0;f[W>>2]=Ja;Na=Ma-rb|0;f[aa>>2]=Na;Ma=A-Ka+256|0;if(Ma>>>0<769)sb=h[274204+Ma>>0]|0;else sb=0;Ma=sb+Ka|0;f[$>>2]=Ma;Ka=A-sb|0;f[Z>>2]=Ka;A=Ka-Na+256|0;if(A>>>0<769)tb=h[274204+A>>0]|0;else tb=0;A=tb+Na|0;f[aa>>2]=A;Na=Ka-tb|0;f[Z>>2]=Na;Ka=Ja-Ma+256|0;if(Ka>>>0<769)ub=h[274204+Ka>>0]|0;else ub=0;Ka=ub+Ma|0;f[$>>2]=Ka;Ma=Ja-ub|0;f[W>>2]=Ma;Ja=Ia-Oa+256|0;if(Ja>>>0<769)vb=h[274204+Ja>>0]|0;else vb=0;Ja=vb+Oa|0;f[X>>2]=Ja;Oa=Ia-vb|0;f[i>>2]=Oa;Ia=K-Ka+256|0;if(Ia>>>0<769)wb=h[274204+Ia>>0]|0;else wb=0;Ia=wb+Ka|0;f[$>>2]=Ia;Ka=K-wb|0;f[da>>2]=Ka;K=Ka-Ja+256|0;if(K>>>0<769)xb=h[274204+K>>0]|0;else xb=0;K=xb+Ja|0;f[X>>2]=K;Ja=Ka-xb|0;f[da>>2]=Ja;Ka=C-A+256|0;if(Ka>>>0<769)yb=h[274204+Ka>>0]|0;else yb=0;Ka=yb+A|0;f[aa>>2]=Ka;A=C-yb|0;f[ca>>2]=A;C=A-Ja+256|0;if(C>>>0<769)zb=h[274204+C>>0]|0;else zb=0;C=zb+Ja|0;f[da>>2]=C;Ja=A-zb|0;f[ca>>2]=Ja;A=K-Ka+256|0;if(A>>>0<769)Ab=h[274204+A>>0]|0;else Ab=0;A=Ab+Ka|0;f[aa>>2]=A;Ka=K-Ab|0;f[X>>2]=Ka;K=z-Na+256|0;if(K>>>0<769)Bb=h[274204+K>>0]|0;else Bb=0;K=Bb+Na|0;f[Z>>2]=K;Na=z-Bb|0;f[ea>>2]=Na;z=F-La+256|0;if(z>>>0<769)Cb=h[274204+z>>0]|0;else Cb=0;z=Cb+La|0;f[T>>2]=z;La=F-Cb|0;f[_>>2]=La;F=La-K+256|0;if(F>>>0<769)Db=h[274204+F>>0]|0;else Db=0;F=Db+K|0;f[Z>>2]=F;K=La-Db|0;f[_>>2]=K;La=L-Ma+256|0;if(La>>>0<769)Eb=h[274204+La>>0]|0;else Eb=0;La=Eb+Ma|0;f[W>>2]=La;Ma=L-Eb|0;f[ba>>2]=Ma;L=Ma-K+256|0;if(L>>>0<769)Fb=h[274204+L>>0]|0;else Fb=0;L=Fb+K|0;f[_>>2]=L;K=Ma-Fb|0;f[ba>>2]=K;Ma=F-La+256|0;if(Ma>>>0<769)Gb=h[274204+Ma>>0]|0;else Gb=0;Ma=Gb+La|0;f[W>>2]=Ma;La=F-Gb|0;f[Z>>2]=La;F=Na-Ja+256|0;if(F>>>0<769)Hb=h[274204+F>>0]|0;else Hb=0;F=Hb+Ja|0;f[ca>>2]=F;Ja=Na-Hb|0;f[ea>>2]=Ja;Na=K-C+256|0;if(Na>>>0<769)Ib=h[274204+Na>>0]|0;else Ib=0;Na=Ib+C|0;f[da>>2]=Na;C=K-Ib|0;f[ba>>2]=C;K=L-Ka+256|0;if(K>>>0<769)Jb=h[274204+K>>0]|0;else Jb=0;K=Jb+Ka|0;f[X>>2]=K;Ka=L-Jb|0;f[_>>2]=Ka;L=La-A+256|0;if(L>>>0<769)Kb=h[274204+L>>0]|0;else Kb=0;L=Kb+A|0;f[aa>>2]=L;A=La-Kb|0;f[Z>>2]=A;La=Ma-Ia+256|0;if(La>>>0<769)Lb=h[274204+La>>0]|0;else Lb=0;La=Lb+Ia|0;f[$>>2]=La;Ia=Ma-Lb|0;f[W>>2]=Ia;Ma=Qa-Ra+256|0;if(Ma>>>0<769)Mb=h[274204+Ma>>0]|0;else Mb=0;Ma=Mb+Ra|0;f[Q>>2]=Ma;Ra=Qa-Mb|0;f[V>>2]=Ra;Qa=Pa-Ra+256|0;if(Qa>>>0<769)Nb=h[274204+Qa>>0]|0;else Nb=0;Qa=Nb+Ra|0;f[V>>2]=Qa;Ra=Pa-Nb|0;f[U>>2]=Ra;Pa=Qa-Ma+256|0;if(Pa>>>0<769)Ob=h[274204+Pa>>0]|0;else Ob=0;Pa=Ob+Ma|0;f[Q>>2]=Pa;Ma=Qa-Ob|0;f[V>>2]=Ma;Qa=Ta-Ua+256|0;if(Qa>>>0<769)Pb=h[274204+Qa>>0]|0;else Pb=0;Qa=Pb+Ua|0;f[R>>2]=Qa;Ua=Ta-Pb|0;f[S>>2]=Ua;Ta=Sa-Ua+256|0;if(Ta>>>0<769)Qb=h[274204+Ta>>0]|0;else Qb=0;Ta=Qb+Ua|0;f[S>>2]=Ta;Ua=Sa-Qb|0;f[P>>2]=Ua;Sa=Ta-Qa+256|0;if(Sa>>>0<769)Rb=h[274204+Sa>>0]|0;else Rb=0;Sa=Rb+Qa|0;f[R>>2]=Sa;Qa=Ta-Rb|0;f[S>>2]=Qa;Ta=Ra-Ua+256|0;if(Ta>>>0<769)Sb=h[274204+Ta>>0]|0;else Sb=0;Ta=Sb+Ua|0;f[P>>2]=Ta;Ua=Ra-Sb|0;f[U>>2]=Ua;Ra=Pa-Sa+256|0;if(Ra>>>0<769)Tb=h[274204+Ra>>0]|0;else Tb=0;Ra=Tb+Sa|0;f[R>>2]=Ra;Sa=Pa-Tb|0;f[Q>>2]=Sa;Pa=Sa-Ta+256|0;if(Pa>>>0<769)Ub=h[274204+Pa>>0]|0;else Ub=0;Pa=Ub+Ta|0;f[P>>2]=Pa;Ta=Sa-Ub|0;f[Q>>2]=Ta;Sa=Ma-Qa+256|0;if(Sa>>>0<769)Vb=h[274204+Sa>>0]|0;else Vb=0;Sa=Vb+Qa|0;f[S>>2]=Sa;Qa=Ma-Vb|0;f[V>>2]=Qa;Ma=Qa-Ta+256|0;if(Ma>>>0<769)Wb=h[274204+Ma>>0]|0;else Wb=0;Ma=Wb+Ta|0;f[Q>>2]=Ma;Ta=Qa-Wb|0;f[V>>2]=Ta;Qa=Pa-Sa+256|0;if(Qa>>>0<769)Xb=h[274204+Qa>>0]|0;else Xb=0;Qa=Xb+Sa|0;f[S>>2]=Qa;Sa=Pa-Xb|0;f[P>>2]=Sa;Pa=Wa-Xa+256|0;if(Pa>>>0<769)Yb=h[274204+Pa>>0]|0;else Yb=0;Pa=Yb+Xa|0;f[N>>2]=Pa;Xa=Wa-Yb|0;f[O>>2]=Xa;Wa=Va-Xa+256|0;if(Wa>>>0<769)Zb=h[274204+Wa>>0]|0;else Zb=0;Wa=Zb+Xa|0;f[O>>2]=Wa;Xa=Va-Zb|0;f[r>>2]=Xa;Va=Wa-Pa+256|0;if(Va>>>0<769)_b=h[274204+Va>>0]|0;else _b=0;Va=_b+Pa|0;f[N>>2]=Va;Pa=Wa-_b|0;f[O>>2]=Pa;Wa=J-M+256|0;if(Wa>>>0<769)$b=h[274204+Wa>>0]|0;else $b=0;Wa=$b+M|0;f[d>>2]=Wa;M=J-$b|0;f[x>>2]=M;J=Ya-D+256|0;if(J>>>0<769)ac=h[274204+J>>0]|0;else ac=0;J=ac+D|0;f[s>>2]=J;D=Ya-ac|0;f[w>>2]=D;Ya=M-D+256|0;if(Ya>>>0<769)bc=h[274204+Ya>>0]|0;else bc=0;Ya=bc+D|0;f[w>>2]=Ya;D=M-bc|0;f[x>>2]=D;M=Wa-J+256|0;if(M>>>0<769)cc=h[274204+M>>0]|0;else cc=0;M=cc+J|0;f[s>>2]=M;J=Wa-cc|0;f[d>>2]=J;Wa=J-Ya+256|0;if(Wa>>>0<769)dc=h[274204+Wa>>0]|0;else dc=0;Wa=dc+Ya|0;f[w>>2]=Wa;Ya=J-dc|0;f[d>>2]=Ya;J=Xa-D+256|0;if(J>>>0<769)ec=h[274204+J>>0]|0;else ec=0;J=ec+D|0;f[x>>2]=J;D=Xa-ec|0;f[r>>2]=D;Xa=Va-Wa+256|0;if(Xa>>>0<769)fc=h[274204+Xa>>0]|0;else fc=0;Xa=fc+Wa|0;f[w>>2]=Xa;Wa=Va-fc|0;f[N>>2]=Wa;Va=Wa-J+256|0;if(Va>>>0<769)gc=h[274204+Va>>0]|0;else gc=0;Va=gc+J|0;f[x>>2]=Va;J=Wa-gc|0;f[N>>2]=J;Wa=Pa-Ya+256|0;if(Wa>>>0<769)hc=h[274204+Wa>>0]|0;else hc=0;Wa=hc+Ya|0;f[d>>2]=Wa;Ya=Pa-hc|0;f[O>>2]=Ya;Pa=Wa-M+256|0;if(Pa>>>0<769)ic=h[274204+Pa>>0]|0;else ic=0;Pa=ic+M|0;f[s>>2]=Pa;M=Wa-ic|0;f[d>>2]=M;Wa=Ya-J+256|0;if(Wa>>>0<769)jc=h[274204+Wa>>0]|0;else jc=0;Wa=jc+J|0;f[N>>2]=Wa;J=Ya-jc|0;f[O>>2]=J;Ya=Va-M+256|0;if(Ya>>>0<769)kc=h[274204+Ya>>0]|0;else kc=0;Ya=kc+M|0;f[d>>2]=Ya;M=Va-kc|0;f[x>>2]=M;Va=Xa-Pa+256|0;if(Va>>>0<769)lc=h[274204+Va>>0]|0;else lc=0;Va=lc+Pa|0;f[s>>2]=Va;Pa=Xa-lc|0;f[w>>2]=Pa;Xa=Ua-D+256|0;if(Xa>>>0<769)mc=h[274204+Xa>>0]|0;else mc=0;Xa=mc+D|0;f[r>>2]=Xa;D=Ua-mc|0;f[U>>2]=D;Ua=Qa-Ya+256|0;if(Ua>>>0<769)nc=h[274204+Ua>>0]|0;else nc=0;Ua=nc+Ya|0;f[d>>2]=Ua;Ya=Qa-nc|0;f[S>>2]=Ya;Qa=Ya-Xa+256|0;if(Qa>>>0<769)oc=h[274204+Qa>>0]|0;else oc=0;Qa=oc+Xa|0;f[r>>2]=Qa;Xa=Ya-oc|0;f[S>>2]=Xa;Ya=Ma-Wa+256|0;if(Ya>>>0<769)pc=h[274204+Ya>>0]|0;else pc=0;Ya=pc+Wa|0;f[N>>2]=Ya;Wa=Ma-pc|0;f[Q>>2]=Wa;Ma=Ya-Va+256|0;if(Ma>>>0<769)qc=h[274204+Ma>>0]|0;else qc=0;Ma=qc+Va|0;f[s>>2]=Ma;Va=Ya-qc|0;f[N>>2]=Va;Ya=Wa-Xa+256|0;if(Ya>>>0<769)rc=h[274204+Ya>>0]|0;else rc=0;Ya=rc+Xa|0;f[S>>2]=Ya;Xa=Wa-rc|0;f[Q>>2]=Xa;Wa=Qa-Va+256|0;if(Wa>>>0<769)sc=h[274204+Wa>>0]|0;else sc=0;Wa=sc+Va|0;f[N>>2]=Wa;Va=Qa-sc|0;f[r>>2]=Va;Qa=Ua-Ma+256|0;if(Qa>>>0<769)tc=h[274204+Qa>>0]|0;else tc=0;Qa=tc+Ma|0;f[s>>2]=Qa;Ma=Ua-tc|0;f[d>>2]=Ma;Ua=Ta-J+256|0;if(Ua>>>0<769)uc=h[274204+Ua>>0]|0;else uc=0;Ua=uc+J|0;f[O>>2]=Ua;J=Ta-uc|0;f[V>>2]=J;Ta=Ra-Pa+256|0;if(Ta>>>0<769)vc=h[274204+Ta>>0]|0;else vc=0;Ta=vc+Pa|0;f[w>>2]=Ta;Pa=Ra-vc|0;f[R>>2]=Pa;Ra=Pa-Ua+256|0;if(Ra>>>0<769)wc=h[274204+Ra>>0]|0;else wc=0;Ra=wc+Ua|0;f[O>>2]=Ra;Ua=Pa-wc|0;f[R>>2]=Ua;Pa=Sa-M+256|0;if(Pa>>>0<769)xc=h[274204+Pa>>0]|0;else xc=0;Pa=xc+M|0;f[x>>2]=Pa;M=Sa-xc|0;f[P>>2]=M;Sa=M-Ua+256|0;if(Sa>>>0<769)yc=h[274204+Sa>>0]|0;else yc=0;Sa=yc+Ua|0;f[R>>2]=Sa;Ua=M-yc|0;f[P>>2]=Ua;M=Ra-Pa+256|0;if(M>>>0<769)zc=h[274204+M>>0]|0;else zc=0;M=zc+Pa|0;f[x>>2]=M;Pa=Ra-zc|0;f[O>>2]=Pa;Ra=J-Xa+256|0;if(Ra>>>0<769)Ac=h[274204+Ra>>0]|0;else Ac=0;Ra=Ac+Xa|0;f[Q>>2]=Ra;Xa=J-Ac|0;f[V>>2]=Xa;J=Ua-Ya+256|0;if(J>>>0<769)Bc=h[274204+J>>0]|0;else Bc=0;J=Bc+Ya|0;f[S>>2]=J;Ya=Ua-Bc|0;f[P>>2]=Ya;Ua=Sa-Va+256|0;if(Ua>>>0<769)Cc=h[274204+Ua>>0]|0;else Cc=0;Ua=Cc+Va|0;f[r>>2]=Ua;Va=Sa-Cc|0;f[R>>2]=Va;Sa=Pa-Wa+256|0;if(Sa>>>0<769)Dc=h[274204+Sa>>0]|0;else Dc=0;Sa=Dc+Wa|0;f[N>>2]=Sa;Wa=Pa-Dc|0;f[O>>2]=Wa;Pa=M-Ma+256|0;if(Pa>>>0<769)Ec=h[274204+Pa>>0]|0;else Ec=0;Pa=Ec+Ma|0;f[d>>2]=Pa;Ma=M-Ec|0;f[x>>2]=Ma;M=Ta-Qa+256|0;if(M>>>0<769)Fc=h[274204+M>>0]|0;else Fc=0;M=Fc+Qa|0;f[s>>2]=M;Qa=Ta-Fc|0;f[w>>2]=Qa;Ta=Oa-D+256|0;if(Ta>>>0<769)Gc=h[274204+Ta>>0]|0;else Gc=0;Ta=Gc+D|0;f[U>>2]=Ta;f[i>>2]=Oa-Gc;Oa=L-Sa+256|0;if(Oa>>>0<769)Hc=h[274204+Oa>>0]|0;else Hc=0;f[N>>2]=Hc+Sa;Sa=L-Hc|0;f[aa>>2]=Sa;L=Sa-Ta+256|0;if(L>>>0<769)Ic=h[274204+L>>0]|0;else Ic=0;L=Ic+Ta|0;f[U>>2]=L;f[aa>>2]=Sa-Ic;Sa=Na-J+256|0;if(Sa>>>0<769)Jc=h[274204+Sa>>0]|0;else Jc=0;Sa=Jc+J|0;f[S>>2]=Sa;f[da>>2]=Na-Jc;Na=Sa-M+256|0;if(Na>>>0<769)Kc=h[274204+Na>>0]|0;else Kc=0;f[s>>2]=Kc+M;M=Sa-Kc|0;f[S>>2]=M;Sa=L-M+256|0;if(Sa>>>0<769)Lc=h[274204+Sa>>0]|0;else Lc=0;f[S>>2]=Lc+M;M=L-Lc|0;f[U>>2]=M;L=F-Ra+256|0;if(L>>>0<769)Mc=h[274204+L>>0]|0;else Mc=0;L=Mc+Ra|0;f[Q>>2]=L;f[ca>>2]=F-Mc;F=La-Pa+256|0;if(F>>>0<769)Nc=h[274204+F>>0]|0;else Nc=0;f[d>>2]=Nc+Pa;Pa=La-Nc|0;f[$>>2]=Pa;La=Pa-L+256|0;if(La>>>0<769)Oc=h[274204+La>>0]|0;else Oc=0;f[Q>>2]=Oc+L;L=Pa-Oc|0;f[$>>2]=L;Pa=K-Ua+256|0;if(Pa>>>0<769)Pc=h[274204+Pa>>0]|0;else Pc=0;f[r>>2]=Pc+Ua;Ua=K-Pc|0;f[X>>2]=Ua;K=Ua-L+256|0;if(K>>>0<769)Qc=h[274204+K>>0]|0;else Qc=0;K=Qc+L|0;f[$>>2]=K;f[X>>2]=Ua-Qc;Ua=K-M+256|0;if(Ua>>>0<769)Rc=h[274204+Ua>>0]|0;else Rc=0;Ua=Rc+M|0;f[U>>2]=Ua;f[$>>2]=K-Rc;K=Ja-Xa+256|0;if(K>>>0<769)Sc=h[274204+K>>0]|0;else Sc=0;K=Sc+Xa|0;f[V>>2]=K;f[ea>>2]=Ja-Sc;Ja=Ia-Ma+256|0;if(Ja>>>0<769)Tc=h[274204+Ja>>0]|0;else Tc=0;f[x>>2]=Tc+Ma;Ma=Ia-Tc|0;f[W>>2]=Ma;Ia=Ma-K+256|0;if(Ia>>>0<769)Uc=h[274204+Ia>>0]|0;else Uc=0;Ia=Uc+K|0;f[V>>2]=Ia;f[W>>2]=Ma-Uc;Ma=Ka-Va+256|0;if(Ma>>>0<769)Vc=h[274204+Ma>>0]|0;else Vc=0;Ma=Vc+Va|0;f[R>>2]=Ma;f[_>>2]=Ka-Vc;Ka=Ia-Ma+256|0;if(Ka>>>0<769)Wc=h[274204+Ka>>0]|0;else Wc=0;f[R>>2]=Wc+Ma;Ma=Ia-Wc|0;f[V>>2]=Ma;Ia=C-Ya+256|0;if(Ia>>>0<769)Xc=h[274204+Ia>>0]|0;else Xc=0;Ia=Xc+Ya|0;f[P>>2]=Ia;f[ba>>2]=C-Xc;C=z-Qa+256|0;if(C>>>0<769)Yc=h[274204+C>>0]|0;else Yc=0;f[w>>2]=Yc+Qa;Qa=z-Yc|0;f[T>>2]=Qa;z=Qa-Ia+256|0;if(z>>>0<769)Zc=h[274204+z>>0]|0;else Zc=0;f[P>>2]=Zc+Ia;Ia=Qa-Zc|0;f[T>>2]=Ia;Qa=A-Wa+256|0;if(Qa>>>0<769)_c=h[274204+Qa>>0]|0;else _c=0;f[O>>2]=_c+Wa;Wa=A-_c|0;f[Z>>2]=Wa;A=Wa-Ia+256|0;if(A>>>0<769)$c=h[274204+A>>0]|0;else $c=0;A=$c+Ia|0;f[T>>2]=A;f[Z>>2]=Wa-$c;Wa=A-Ma+256|0;if(Wa>>>0<769)ad=h[274204+Wa>>0]|0;else ad=0;f[V>>2]=ad+Ma;Ma=A-ad|0;f[T>>2]=Ma;A=Ma-Ua+256|0;if(A>>>0<769)bd=h[274204+A>>0]|0;else bd=0;b[G+E>>0]=bd+Ua;E=E+1|0}while((E|0)!=(H|0));cd=H}else cd=B;if((H|0)==(za|0))break;if((cd|0)>(Ga|0)){H=za;B=cd;continue}else dd=cd;while(1){E=(f[g>>2]|0)+dd|0;f[i>>2]=h[E+Ha>>0];Ua=h[E+Da>>0]|0;f[n>>2]=Ua;A=h[E>>0]|0;f[Aa>>2]=A;Ma=h[E+p>>0]|0;f[Ca>>2]=Ma;Wa=h[E+va>>0]|0;f[Fa>>2]=Wa;E=(f[c>>2]|0)+dd|0;Ia=h[E+Ha>>0]|0;f[Ea>>2]=Ia;Qa=h[E+Da>>0]|0;f[ta>>2]=Qa;z=h[E>>0]|0;f[Ba>>2]=z;C=h[E+p>>0]|0;f[I>>2]=C;Ya=h[E+va>>0]|0;f[xa>>2]=Ya;E=(f[sa>>2]|0)+dd|0;Ka=h[E+Ha>>0]|0;f[ga>>2]=Ka;Va=h[E+Da>>0]|0;f[ya>>2]=Va;K=h[E>>0]|0;f[ka>>2]=K;Ja=h[E+p>>0]|0;f[y>>2]=Ja;Xa=h[E+va>>0]|0;f[pa>>2]=Xa;E=(f[wa>>2]|0)+dd|0;M=h[E+Ha>>0]|0;f[ra>>2]=M;L=h[E+Da>>0]|0;f[qa>>2]=L;Pa=h[E>>0]|0;f[na>>2]=Pa;La=h[E+p>>0]|0;f[ma>>2]=La;F=h[E+va>>0]|0;f[ua>>2]=F;E=(f[v>>2]|0)+dd|0;Ra=h[E+Ha>>0]|0;f[ia>>2]=Ra;Sa=h[E+Da>>0]|0;f[la>>2]=Sa;Na=h[E>>0]|0;f[ja>>2]=Na;J=h[E+p>>0]|0;f[ha>>2]=J;Ta=h[E+va>>0]|0;f[oa>>2]=Ta;E=Ua-A+256|0;if(E>>>0<769)ed=h[274204+E>>0]|0;else ed=0;E=ed+A|0;f[Aa>>2]=E;A=(f[n>>2]|0)-ed|0;f[n>>2]=A;Ua=f[i>>2]|0;Oa=Ua-A+256|0;if(Oa>>>0<769)fd=h[274204+Oa>>0]|0;else fd=0;Oa=fd+A|0;f[n>>2]=Oa;A=Ua-fd|0;f[i>>2]=A;Ua=Oa-E+256|0;if(Ua>>>0<769)gd=h[274204+Ua>>0]|0;else gd=0;Ua=gd+E|0;f[Aa>>2]=Ua;E=Oa-gd|0;f[n>>2]=E;Oa=Wa-Ia+256|0;if(Oa>>>0<769)hd=h[274204+Oa>>0]|0;else hd=0;Oa=hd+Ia|0;f[Ea>>2]=Oa;Ia=Wa-hd|0;f[Fa>>2]=Ia;Wa=Ma-Ia+256|0;if(Wa>>>0<769)id=h[274204+Wa>>0]|0;else id=0;Wa=id+Ia|0;f[Fa>>2]=Wa;Ia=Ma-id|0;f[Ca>>2]=Ia;Ma=Wa-Oa+256|0;if(Ma>>>0<769)jd=h[274204+Ma>>0]|0;else jd=0;Ma=jd+Oa|0;f[Ea>>2]=Ma;Oa=Wa-jd|0;f[Fa>>2]=Oa;Wa=A-Ia+256|0;if(Wa>>>0<769)kd=h[274204+Wa>>0]|0;else kd=0;Wa=kd+Ia|0;f[Ca>>2]=Wa;Ia=A-kd|0;f[i>>2]=Ia;A=Ua-Ma+256|0;if(A>>>0<769)ld=h[274204+A>>0]|0;else ld=0;A=ld+Ma|0;f[Ea>>2]=A;Ma=Ua-ld|0;f[Aa>>2]=Ma;Ua=Ma-Wa+256|0;if(Ua>>>0<769)md=h[274204+Ua>>0]|0;else md=0;Ua=md+Wa|0;f[Ca>>2]=Ua;Wa=Ma-md|0;f[Aa>>2]=Wa;Ma=E-Oa+256|0;if(Ma>>>0<769)nd=h[274204+Ma>>0]|0;else nd=0;Ma=nd+Oa|0;f[Fa>>2]=Ma;Oa=E-nd|0;f[n>>2]=Oa;E=Oa-Wa+256|0;if(E>>>0<769)od=h[274204+E>>0]|0;else od=0;E=od+Wa|0;f[Aa>>2]=E;Wa=Oa-od|0;f[n>>2]=Wa;Oa=Ua-Ma+256|0;if(Oa>>>0<769)pd=h[274204+Oa>>0]|0;else pd=0;Oa=pd+Ma|0;f[Fa>>2]=Oa;Ma=Ua-pd|0;f[Ca>>2]=Ma;Ua=z-C+256|0;if(Ua>>>0<769)qd=h[274204+Ua>>0]|0;else qd=0;Ua=qd+C|0;f[I>>2]=Ua;C=z-qd|0;f[Ba>>2]=C;z=Qa-C+256|0;if(z>>>0<769)rd=h[274204+z>>0]|0;else rd=0;z=rd+C|0;f[Ba>>2]=z;C=Qa-rd|0;f[ta>>2]=C;Qa=z-Ua+256|0;if(Qa>>>0<769)sd=h[274204+Qa>>0]|0;else sd=0;Qa=sd+Ua|0;f[I>>2]=Qa;Ua=z-sd|0;f[Ba>>2]=Ua;z=Ka-Va+256|0;if(z>>>0<769)td=h[274204+z>>0]|0;else td=0;z=td+Va|0;f[ya>>2]=z;Va=Ka-td|0;f[ga>>2]=Va;Ka=Ya-Va+256|0;if(Ka>>>0<769)ud=h[274204+Ka>>0]|0;else ud=0;Ka=ud+Va|0;f[ga>>2]=Ka;Va=Ya-ud|0;f[xa>>2]=Va;Ya=Ka-z+256|0;if(Ya>>>0<769)vd=h[274204+Ya>>0]|0;else vd=0;Ya=vd+z|0;f[ya>>2]=Ya;z=Ka-vd|0;f[ga>>2]=z;Ka=C-Va+256|0;if(Ka>>>0<769)wd=h[274204+Ka>>0]|0;else wd=0;Ka=wd+Va|0;f[xa>>2]=Ka;Va=C-wd|0;f[ta>>2]=Va;C=Qa-Ya+256|0;if(C>>>0<769)xd=h[274204+C>>0]|0;else xd=0;C=xd+Ya|0;f[ya>>2]=C;Ya=Qa-xd|0;f[I>>2]=Ya;Qa=Ya-Ka+256|0;if(Qa>>>0<769)yd=h[274204+Qa>>0]|0;else yd=0;Qa=yd+Ka|0;f[xa>>2]=Qa;Ka=Ya-yd|0;f[I>>2]=Ka;Ya=Ua-z+256|0;if(Ya>>>0<769)zd=h[274204+Ya>>0]|0;else zd=0;Ya=zd+z|0;f[ga>>2]=Ya;z=Ua-zd|0;f[Ba>>2]=z;Ua=z-Ka+256|0;if(Ua>>>0<769)Ad=h[274204+Ua>>0]|0;else Ad=0;Ua=Ad+Ka|0;f[I>>2]=Ua;Ka=z-Ad|0;f[Ba>>2]=Ka;z=Qa-Ya+256|0;if(z>>>0<769)Bd=h[274204+z>>0]|0;else Bd=0;z=Bd+Ya|0;f[ga>>2]=z;Ya=Qa-Bd|0;f[xa>>2]=Ya;Qa=Ia-Va+256|0;if(Qa>>>0<769)Cd=h[274204+Qa>>0]|0;else Cd=0;Qa=Cd+Va|0;f[ta>>2]=Qa;Va=Ia-Cd|0;f[i>>2]=Va;Ia=Oa-z+256|0;if(Ia>>>0<769)Dd=h[274204+Ia>>0]|0;else Dd=0;Ia=Dd+z|0;f[ga>>2]=Ia;z=Oa-Dd|0;f[Fa>>2]=z;Oa=z-Qa+256|0;if(Oa>>>0<769)Ed=h[274204+Oa>>0]|0;else Ed=0;Oa=Ed+Qa|0;f[ta>>2]=Oa;Qa=z-Ed|0;f[Fa>>2]=Qa;z=E-Ua+256|0;if(z>>>0<769)Fd=h[274204+z>>0]|0;else Fd=0;z=Fd+Ua|0;f[I>>2]=z;Ua=E-Fd|0;f[Aa>>2]=Ua;E=Ua-Qa+256|0;if(E>>>0<769)Gd=h[274204+E>>0]|0;else Gd=0;E=Gd+Qa|0;f[Fa>>2]=E;Qa=Ua-Gd|0;f[Aa>>2]=Qa;Ua=Oa-z+256|0;if(Ua>>>0<769)Hd=h[274204+Ua>>0]|0;else Hd=0;Ua=Hd+z|0;f[I>>2]=Ua;z=Oa-Hd|0;f[ta>>2]=z;Oa=Wa-Ka+256|0;if(Oa>>>0<769)Id=h[274204+Oa>>0]|0;else Id=0;Oa=Id+Ka|0;f[Ba>>2]=Oa;Ka=Wa-Id|0;f[n>>2]=Ka;Wa=A-C+256|0;if(Wa>>>0<769)Jd=h[274204+Wa>>0]|0;else Jd=0;Wa=Jd+C|0;f[ya>>2]=Wa;C=A-Jd|0;f[Ea>>2]=C;A=C-Oa+256|0;if(A>>>0<769)Kd=h[274204+A>>0]|0;else Kd=0;A=Kd+Oa|0;f[Ba>>2]=A;Oa=C-Kd|0;f[Ea>>2]=Oa;C=Ma-Ya+256|0;if(C>>>0<769)Ld=h[274204+C>>0]|0;else Ld=0;C=Ld+Ya|0;f[xa>>2]=C;Ya=Ma-Ld|0;f[Ca>>2]=Ya;Ma=Ya-Oa+256|0;if(Ma>>>0<769)Md=h[274204+Ma>>0]|0;else Md=0;Ma=Md+Oa|0;f[Ea>>2]=Ma;Oa=Ya-Md|0;f[Ca>>2]=Oa;Ya=A-C+256|0;if(Ya>>>0<769)Nd=h[274204+Ya>>0]|0;else Nd=0;Ya=Nd+C|0;f[xa>>2]=Ya;C=A-Nd|0;f[Ba>>2]=C;A=Ka-Qa+256|0;if(A>>>0<769)Od=h[274204+A>>0]|0;else Od=0;A=Od+Qa|0;f[Aa>>2]=A;Qa=Ka-Od|0;f[n>>2]=Qa;Ka=Oa-E+256|0;if(Ka>>>0<769)Pd=h[274204+Ka>>0]|0;else Pd=0;Ka=Pd+E|0;f[Fa>>2]=Ka;E=Oa-Pd|0;f[Ca>>2]=E;Oa=Ma-z+256|0;if(Oa>>>0<769)Qd=h[274204+Oa>>0]|0;else Qd=0;Oa=Qd+z|0;f[ta>>2]=Oa;z=Ma-Qd|0;f[Ea>>2]=z;Ma=C-Ua+256|0;if(Ma>>>0<769)Rd=h[274204+Ma>>0]|0;else Rd=0;Ma=Rd+Ua|0;f[I>>2]=Ma;Ua=C-Rd|0;f[Ba>>2]=Ua;C=Ya-Ia+256|0;if(C>>>0<769)Sd=h[274204+C>>0]|0;else Sd=0;C=Sd+Ia|0;f[ga>>2]=C;Ia=Ya-Sd|0;f[xa>>2]=Ia;Ya=Ja-Xa+256|0;if(Ya>>>0<769)Td=h[274204+Ya>>0]|0;else Td=0;Ya=Td+Xa|0;f[pa>>2]=Ya;Xa=Ja-Td|0;f[y>>2]=Xa;Ja=K-Xa+256|0;if(Ja>>>0<769)Ud=h[274204+Ja>>0]|0;else Ud=0;Ja=Ud+Xa|0;f[y>>2]=Ja;Xa=K-Ud|0;f[ka>>2]=Xa;K=Ja-Ya+256|0;if(K>>>0<769)Vd=h[274204+K>>0]|0;else Vd=0;K=Vd+Ya|0;f[pa>>2]=K;Ya=Ja-Vd|0;f[y>>2]=Ya;Ja=L-Pa+256|0;if(Ja>>>0<769)Wd=h[274204+Ja>>0]|0;else Wd=0;Ja=Wd+Pa|0;f[na>>2]=Ja;Pa=L-Wd|0;f[qa>>2]=Pa;L=M-Pa+256|0;if(L>>>0<769)Xd=h[274204+L>>0]|0;else Xd=0;L=Xd+Pa|0;f[qa>>2]=L;Pa=M-Xd|0;f[ra>>2]=Pa;M=L-Ja+256|0;if(M>>>0<769)Yd=h[274204+M>>0]|0;else Yd=0;M=Yd+Ja|0;f[na>>2]=M;Ja=L-Yd|0;f[qa>>2]=Ja;L=Xa-Pa+256|0;if(L>>>0<769)Zd=h[274204+L>>0]|0;else Zd=0;L=Zd+Pa|0;f[ra>>2]=L;Pa=Xa-Zd|0;f[ka>>2]=Pa;Xa=K-M+256|0;if(Xa>>>0<769)_d=h[274204+Xa>>0]|0;else _d=0;Xa=_d+M|0;f[na>>2]=Xa;M=K-_d|0;f[pa>>2]=M;K=M-L+256|0;if(K>>>0<769)$d=h[274204+K>>0]|0;else $d=0;K=$d+L|0;f[ra>>2]=K;L=M-$d|0;f[pa>>2]=L;M=Ya-Ja+256|0;if(M>>>0<769)ae=h[274204+M>>0]|0;else ae=0;M=ae+Ja|0;f[qa>>2]=M;Ja=Ya-ae|0;f[y>>2]=Ja;Ya=Ja-L+256|0;if(Ya>>>0<769)be=h[274204+Ya>>0]|0;else be=0;Ya=be+L|0;f[pa>>2]=Ya;L=Ja-be|0;f[y>>2]=L;Ja=K-M+256|0;if(Ja>>>0<769)ce=h[274204+Ja>>0]|0;else ce=0;Ja=ce+M|0;f[qa>>2]=Ja;M=K-ce|0;f[ra>>2]=M;K=F-Ra+256|0;if(K>>>0<769)de=h[274204+K>>0]|0;else de=0;K=de+Ra|0;f[ia>>2]=K;Ra=F-de|0;f[ua>>2]=Ra;F=La-Ra+256|0;if(F>>>0<769)ee=h[274204+F>>0]|0;else ee=0;F=ee+Ra|0;f[ua>>2]=F;Ra=La-ee|0;f[ma>>2]=Ra;La=F-K+256|0;if(La>>>0<769)fe=h[274204+La>>0]|0;else fe=0;La=fe+K|0;f[ia>>2]=La;K=F-fe|0;f[ua>>2]=K;F=Sa-Na+256|0;if(F>>>0<769)ge=h[274204+F>>0]|0;else ge=0;F=ge+Na|0;f[ja>>2]=F;Na=Sa-ge|0;f[la>>2]=Na;Sa=J-Ta+256|0;if(Sa>>>0<769)he=h[274204+Sa>>0]|0;else he=0;Sa=he+Ta|0;f[oa>>2]=Sa;Ta=J-he|0;f[ha>>2]=Ta;J=Na-Ta+256|0;if(J>>>0<769)ie=h[274204+J>>0]|0;else ie=0;J=ie+Ta|0;f[ha>>2]=J;Ta=Na-ie|0;f[la>>2]=Ta;Na=F-Sa+256|0;if(Na>>>0<769)je=h[274204+Na>>0]|0;else je=0;Na=je+Sa|0;f[oa>>2]=Na;Sa=F-je|0;f[ja>>2]=Sa;F=Sa-J+256|0;if(F>>>0<769)ke=h[274204+F>>0]|0;else ke=0;F=ke+J|0;f[ha>>2]=F;J=Sa-ke|0;f[ja>>2]=J;Sa=Ra-Ta+256|0;if(Sa>>>0<769)le=h[274204+Sa>>0]|0;else le=0;Sa=le+Ta|0;f[la>>2]=Sa;Ta=Ra-le|0;f[ma>>2]=Ta;Ra=La-F+256|0;if(Ra>>>0<769)me=h[274204+Ra>>0]|0;else me=0;Ra=me+F|0;f[ha>>2]=Ra;F=La-me|0;f[ia>>2]=F;La=F-Sa+256|0;if(La>>>0<769)ne=h[274204+La>>0]|0;else ne=0;La=ne+Sa|0;f[la>>2]=La;Sa=F-ne|0;f[ia>>2]=Sa;F=K-J+256|0;if(F>>>0<769)oe=h[274204+F>>0]|0;else oe=0;F=oe+J|0;f[ja>>2]=F;J=K-oe|0;f[ua>>2]=J;K=F-Na+256|0;if(K>>>0<769)pe=h[274204+K>>0]|0;else pe=0;K=pe+Na|0;f[oa>>2]=K;Na=F-pe|0;f[ja>>2]=Na;F=J-Sa+256|0;if(F>>>0<769)qe=h[274204+F>>0]|0;else qe=0;F=qe+Sa|0;f[ia>>2]=F;Sa=J-qe|0;f[ua>>2]=Sa;J=La-Na+256|0;if(J>>>0<769)re=h[274204+J>>0]|0;else re=0;J=re+Na|0;f[ja>>2]=J;Na=La-re|0;f[la>>2]=Na;La=Ra-K+256|0;if(La>>>0<769)se=h[274204+La>>0]|0;else se=0;La=se+K|0;f[oa>>2]=La;K=Ra-se|0;f[ha>>2]=K;Ra=Pa-Ta+256|0;if(Ra>>>0<769)te=h[274204+Ra>>0]|0;else te=0;Ra=te+Ta|0;f[ma>>2]=Ra;Ta=Pa-te|0;f[ka>>2]=Ta;Pa=Ja-J+256|0;if(Pa>>>0<769)ue=h[274204+Pa>>0]|0;else ue=0;Pa=ue+J|0;f[ja>>2]=Pa;J=Ja-ue|0;f[qa>>2]=J;Ja=J-Ra+256|0;if(Ja>>>0<769)ve=h[274204+Ja>>0]|0;else ve=0;Ja=ve+Ra|0;f[ma>>2]=Ja;Ra=J-ve|0;f[qa>>2]=Ra;J=Ya-F+256|0;if(J>>>0<769)we=h[274204+J>>0]|0;else we=0;J=we+F|0;f[ia>>2]=J;F=Ya-we|0;f[pa>>2]=F;Ya=J-La+256|0;if(Ya>>>0<769)xe=h[274204+Ya>>0]|0;else xe=0;Ya=xe+La|0;f[oa>>2]=Ya;La=J-xe|0;f[ia>>2]=La;J=F-Ra+256|0;if(J>>>0<769)ye=h[274204+J>>0]|0;else ye=0;J=ye+Ra|0;f[qa>>2]=J;Ra=F-ye|0;f[pa>>2]=Ra;F=Ja-La+256|0;if(F>>>0<769)ze=h[274204+F>>0]|0;else ze=0;F=ze+La|0;f[ia>>2]=F;La=Ja-ze|0;f[ma>>2]=La;Ja=Pa-Ya+256|0;if(Ja>>>0<769)Ae=h[274204+Ja>>0]|0;else Ae=0;Ja=Ae+Ya|0;f[oa>>2]=Ja;Ya=Pa-Ae|0;f[ja>>2]=Ya;Pa=L-Sa+256|0;if(Pa>>>0<769)Be=h[274204+Pa>>0]|0;else Be=0;Pa=Be+Sa|0;f[ua>>2]=Pa;Sa=L-Be|0;f[y>>2]=Sa;L=Xa-K+256|0;if(L>>>0<769)Ce=h[274204+L>>0]|0;else Ce=0;L=Ce+K|0;f[ha>>2]=L;K=Xa-Ce|0;f[na>>2]=K;Xa=K-Pa+256|0;if(Xa>>>0<769)De=h[274204+Xa>>0]|0;else De=0;Xa=De+Pa|0;f[ua>>2]=Xa;Pa=K-De|0;f[na>>2]=Pa;K=M-Na+256|0;if(K>>>0<769)Ee=h[274204+K>>0]|0;else Ee=0;K=Ee+Na|0;f[la>>2]=K;Na=M-Ee|0;f[ra>>2]=Na;M=Na-Pa+256|0;if(M>>>0<769)Fe=h[274204+M>>0]|0;else Fe=0;M=Fe+Pa|0;f[na>>2]=M;Pa=Na-Fe|0;f[ra>>2]=Pa;Na=Xa-K+256|0;if(Na>>>0<769)Ge=h[274204+Na>>0]|0;else Ge=0;Na=Ge+K|0;f[la>>2]=Na;K=Xa-Ge|0;f[ua>>2]=K;Xa=Sa-Ra+256|0;if(Xa>>>0<769)He=h[274204+Xa>>0]|0;else He=0;Xa=He+Ra|0;f[pa>>2]=Xa;Ra=Sa-He|0;f[y>>2]=Ra;Sa=Pa-J+256|0;if(Sa>>>0<769)Ie=h[274204+Sa>>0]|0;else Ie=0;Sa=Ie+J|0;f[qa>>2]=Sa;J=Pa-Ie|0;f[ra>>2]=J;Pa=M-La+256|0;if(Pa>>>0<769)Je=h[274204+Pa>>0]|0;else Je=0;Pa=Je+La|0;f[ma>>2]=Pa;La=M-Je|0;f[na>>2]=La;M=K-F+256|0;if(M>>>0<769)Ke=h[274204+M>>0]|0;else Ke=0;M=Ke+F|0;f[ia>>2]=M;F=K-Ke|0;f[ua>>2]=F;K=Na-Ya+256|0;if(K>>>0<769)Le=h[274204+K>>0]|0;else Le=0;K=Le+Ya|0;f[ja>>2]=K;Ya=Na-Le|0;f[la>>2]=Ya;Na=L-Ja+256|0;if(Na>>>0<769)Me=h[274204+Na>>0]|0;else Me=0;Na=Me+Ja|0;f[oa>>2]=Na;Ja=L-Me|0;f[ha>>2]=Ja;L=Va-Ta+256|0;if(L>>>0<769)Ne=h[274204+L>>0]|0;else Ne=0;L=Ne+Ta|0;f[ka>>2]=L;f[i>>2]=Va-Ne;Va=Ma-M+256|0;if(Va>>>0<769)Oe=h[274204+Va>>0]|0;else Oe=0;f[ia>>2]=Oe+M;M=Ma-Oe|0;f[I>>2]=M;Ma=M-L+256|0;if(Ma>>>0<769)Pe=h[274204+Ma>>0]|0;else Pe=0;Ma=Pe+L|0;f[ka>>2]=Ma;f[I>>2]=M-Pe;M=Ka-Sa+256|0;if(M>>>0<769)Qe=h[274204+M>>0]|0;else Qe=0;M=Qe+Sa|0;f[qa>>2]=M;f[Fa>>2]=Ka-Qe;Ka=M-Na+256|0;if(Ka>>>0<769)Re=h[274204+Ka>>0]|0;else Re=0;f[oa>>2]=Re+Na;Na=M-Re|0;f[qa>>2]=Na;M=Ma-Na+256|0;if(M>>>0<769)Se=h[274204+M>>0]|0;else Se=0;f[qa>>2]=Se+Na;Na=Ma-Se|0;f[ka>>2]=Na;Ma=A-Xa+256|0;if(Ma>>>0<769)Te=h[274204+Ma>>0]|0;else Te=0;Ma=Te+Xa|0;f[pa>>2]=Ma;f[Aa>>2]=A-Te;A=C-K+256|0;if(A>>>0<769)Ue=h[274204+A>>0]|0;else Ue=0;f[ja>>2]=Ue+K;K=C-Ue|0;f[ga>>2]=K;C=K-Ma+256|0;if(C>>>0<769)Ve=h[274204+C>>0]|0;else Ve=0;f[pa>>2]=Ve+Ma;Ma=K-Ve|0;f[ga>>2]=Ma;K=Oa-Pa+256|0;if(K>>>0<769)We=h[274204+K>>0]|0;else We=0;f[ma>>2]=We+Pa;Pa=Oa-We|0;f[ta>>2]=Pa;Oa=Pa-Ma+256|0;if(Oa>>>0<769)Xe=h[274204+Oa>>0]|0;else Xe=0;Oa=Xe+Ma|0;f[ga>>2]=Oa;f[ta>>2]=Pa-Xe;Pa=Oa-Na+256|0;if(Pa>>>0<769)Ye=h[274204+Pa>>0]|0;else Ye=0;Pa=Ye+Na|0;f[ka>>2]=Pa;f[ga>>2]=Oa-Ye;Oa=Qa-Ra+256|0;if(Oa>>>0<769)Ze=h[274204+Oa>>0]|0;else Ze=0;Oa=Ze+Ra|0;f[y>>2]=Oa;f[n>>2]=Qa-Ze;Qa=Ia-Ya+256|0;if(Qa>>>0<769)_e=h[274204+Qa>>0]|0;else _e=0;f[la>>2]=_e+Ya;Ya=Ia-_e|0;f[xa>>2]=Ya;Ia=Ya-Oa+256|0;if(Ia>>>0<769)$e=h[274204+Ia>>0]|0;else $e=0;Ia=$e+Oa|0;f[y>>2]=Ia;f[xa>>2]=Ya-$e;Ya=z-La+256|0;if(Ya>>>0<769)af=h[274204+Ya>>0]|0;else af=0;Ya=af+La|0;f[na>>2]=Ya;f[Ea>>2]=z-af;z=Ia-Ya+256|0;if(z>>>0<769)bf=h[274204+z>>0]|0;else bf=0;f[na>>2]=bf+Ya;Ya=Ia-bf|0;f[y>>2]=Ya;Ia=E-J+256|0;if(Ia>>>0<769)cf=h[274204+Ia>>0]|0;else cf=0;Ia=cf+J|0;f[ra>>2]=Ia;f[Ca>>2]=E-cf;E=Wa-Ja+256|0;if(E>>>0<769)df=h[274204+E>>0]|0;else df=0;f[ha>>2]=df+Ja;Ja=Wa-df|0;f[ya>>2]=Ja;Wa=Ja-Ia+256|0;if(Wa>>>0<769)ef=h[274204+Wa>>0]|0;else ef=0;f[ra>>2]=ef+Ia;Ia=Ja-ef|0;f[ya>>2]=Ia;Ja=Ua-F+256|0;if(Ja>>>0<769)ff=h[274204+Ja>>0]|0;else ff=0;f[ua>>2]=ff+F;F=Ua-ff|0;f[Ba>>2]=F;Ua=F-Ia+256|0;if(Ua>>>0<769)gf=h[274204+Ua>>0]|0;else gf=0;Ua=gf+Ia|0;f[ya>>2]=Ua;f[Ba>>2]=F-gf;F=Ua-Ya+256|0;if(F>>>0<769)hf=h[274204+F>>0]|0;else hf=0;f[y>>2]=hf+Ya;Ya=Ua-hf|0;f[ya>>2]=Ya;Ua=Ya-Pa+256|0;if(Ua>>>0<769)jf=h[274204+Ua>>0]|0;else jf=0;b[G+dd>>0]=jf+Pa;Pa=dd+1|0;if((dd|0)<(Ga|0))dd=Pa;else{H=za;B=Pa;continue b}}}if((k|0)==(o|0))break;else G=G+m|0}u=e;return}default:{u=e;return}}}function fpa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=u;u=u+48|0;h=g+12|0;i=g;if(!((c|0)!=0&(d|0)!=0&(e|0)!=0)){j=$Xc(48)|0;f[h>>2]=j;f[h+8>>2]=-2147483600;f[h+4>>2]=45;k=j;l=270280;m=k+45|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+45>>0]=0;vM(-215,h,270326,270344,47)}j=f[c>>2]|0;if((((j&-65536|0)==1111621632?(n=f[c+24>>2]|0,(n|0)>0):0)?(f[c+20>>2]|0)>0:0)?f[c+16>>2]|0:0){if((j&4088|0)==0&(n|0)==2){o3(c,h,2,0)|0;o=h}else o=c;c=f[o>>2]|0;h=c&4095;if((c&4094|0)!=12){n=$Xc(96)|0;f[i>>2]=n;f[i+8>>2]=-2147483552;f[i+4>>2]=87;k=n;l=270448;m=k+87|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[n+87>>0]=0;vM(-210,i,270326,270344,63)}n=f[o+24>>2]|0;if((n|0)!=1)if((c&16384|0)==0?1:(f[o+20>>2]|0)!=1){p=$Xc(80)|0;f[i>>2]=p;q=i+8|0;f[q>>2]=-2147483568;r=i+4|0;f[r>>2]=75;k=p;l=270536;m=k+75|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));s=p+75|0;b[s>>0]=0;vM(-5,i,270326,270344,68)}else{t=1;v=a&28672;w=h|v;x=c>>>3;y=x&511;z=y+1|0;A=c<<2;B=A&28;C=675553809>>>B;D=C&15;E=Y(D,z)|0;F=o+16|0;G=f[F>>2]|0;H=Y(t,n)|0;uT(w,88,E,G,H,d,e)|0;u=g;return d|0}if(!(c&16384)){p=$Xc(80)|0;f[i>>2]=p;q=i+8|0;f[q>>2]=-2147483568;r=i+4|0;f[r>>2]=75;k=p;l=270536;m=k+75|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));s=p+75|0;b[s>>0]=0;vM(-5,i,270326,270344,68)}t=f[o+20>>2]|0;v=a&28672;w=h|v;x=c>>>3;y=x&511;z=y+1|0;A=c<<2;B=A&28;C=675553809>>>B;D=C&15;E=Y(D,z)|0;F=o+16|0;G=f[F>>2]|0;H=Y(t,n)|0;uT(w,88,E,G,H,d,e)|0;u=g;return d|0}d=$Xc(48)|0;f[i>>2]=d;f[i+8>>2]=-2147483600;f[i+4>>2]=33;k=d;l=270414;m=k+33|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[d+33>>0]=0;vM(-5,i,270326,270344,54);return 0}function gpa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0.0,Qb=0,Rb=0,Sb=0,Tb=0.0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0;i=u;u=u+1520|0;k=i+472|0;l=i;m=i+328|0;o=i+248|0;p=i+192|0;q=i+320|0;r=i+312|0;s=i+136|0;t=i+304|0;do if((eS(a)|0)==65536){v=f[a+4>>2]|0;f[o>>2]=f[v>>2];w=o+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=o+8|0;f[y>>2]=f[v+8>>2];f[o+12>>2]=f[v+12>>2];f[o+16>>2]=f[v+16>>2];f[o+20>>2]=f[v+20>>2];f[o+24>>2]=f[v+24>>2];f[o+28>>2]=f[v+28>>2];f[o+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[o+36>>2]=z;A=o+40|0;f[A>>2]=y;y=o+48|0;B=o+44|0;f[B>>2]=y;f[y>>2]=0;f[o+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];C=o;D=A;break}else{f[w>>2]=0;U$(o,v);C=o;D=A;break}}else{bS(o,a,-1);C=o;D=o+40|0}while(0);f[p>>2]=1124007936;a=p+4|0;A=p+8|0;v=p+40|0;w=a;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));f[v>>2]=A;y=p+48|0;B=p+44|0;f[B>>2]=y;f[y>>2]=0;f[p+52>>2]=0;z=f[D>>2]|0;E=f[z+4>>2]|0;F=f[z>>2]|0;G=f[C>>2]|0;C=G>>>3&511;H=G&7;G=(H|0)==0;I=(H|0)==2;if((H|2|0)!=2){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;J=$Xc(48)|0;f[k>>2]=J;f[k+8>>2]=-2147483600;f[k+4>>2]=33;w=J;K=270612;x=w+33|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[J+33>>0]=0;vM(-215,k,270646,270658,1670)}J=o+16|0;if(!(f[J>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;L=$Xc(16)|0;f[k>>2]=L;M=k+8|0;f[M>>2]=-2147483632;N=k+4|0;f[N>>2]=12;w=L;K=471150;x=w+12|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));O=L+12|0;b[O>>0]=0;vM(-215,k,270646,270658,1671)}P=o+4|0;Q=f[P>>2]|0;if((Q|0)<3)R=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{S=1;T=F;while(1){U=Y(f[z+(S<<2)>>2]|0,T)|0;S=S+1|0;if((S|0)==(Q|0)){R=U;break}else T=U}}if((Q|0)==0|(R|0)==0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;L=$Xc(16)|0;f[k>>2]=L;M=k+8|0;f[M>>2]=-2147483632;N=k+4|0;f[N>>2]=12;w=L;K=471150;x=w+12|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));O=L+12|0;b[O>>0]=0;vM(-215,k,270646,270658,1671)}a:do switch(e|0){case 89:case 88:case 87:case 86:{if(!((g|0)<2&(C|0)==0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;O=$Xc(32)|0;f[k>>2]=O;f[k+8>>2]=-2147483616;f[k+4>>2]=20;w=O;K=270734;x=w+20|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[O+20>>0]=0;vM(-215,k,270646,270658,1678)}f[q>>2]=E;f[q+4>>2]=F;wS(c,q,H,-1,0,0);do if((eS(c)|0)==65536){L=f[c+4>>2]|0;f[k>>2]=f[L>>2];N=k+4|0;M=L+4|0;f[N>>2]=f[M>>2];R=k+8|0;f[R>>2]=f[L+8>>2];f[k+12>>2]=f[L+12>>2];f[k+16>>2]=f[L+16>>2];f[k+20>>2]=f[L+20>>2];f[k+24>>2]=f[L+24>>2];f[k+28>>2]=f[L+28>>2];f[k+32>>2]=f[L+32>>2];Q=f[L+36>>2]|0;f[k+36>>2]=Q;f[k+40>>2]=R;R=k+48|0;T=k+44|0;f[T>>2]=R;f[R>>2]=0;f[k+52>>2]=0;if(Q|0){R=Q+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[M>>2]|0)<3){M=f[L+44>>2]|0;R=f[T>>2]|0;f[R>>2]=f[M>>2];f[R+4>>2]=f[M+4>>2];break}else{f[N>>2]=0;U$(k,L);break}}else bS(k,c,-1);while(0);O=p+36|0;L=f[O>>2]|0;if(L|0?(N=L+12|0,L=f[N>>2]|0,f[N>>2]=L+-1,(L|0)==1):0)V$(p);f[O>>2]=0;L=p+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[a>>2]|0)>0){N=f[v>>2]|0;M=0;do{f[N+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[a>>2]|0))}f[p>>2]=f[k>>2];M=k+4|0;N=f[M>>2]|0;f[a>>2]=N;R=k+8|0;f[A>>2]=f[R>>2];T=p+12|0;f[T>>2]=f[k+12>>2];Q=k+16|0;f[L>>2]=f[Q>>2];f[p+20>>2]=f[k+20>>2];f[p+24>>2]=f[k+24>>2];f[p+28>>2]=f[k+28>>2];f[p+32>>2]=f[k+32>>2];S=k+36|0;f[O>>2]=f[S>>2];z=p+44|0;U=f[z>>2]|0;if((U|0)==(y|0))V=N;else{wL(U);f[z>>2]=y;f[v>>2]=A;V=f[M>>2]|0}U=k+44|0;if((V|0)<3){N=f[U>>2]|0;f[y>>2]=f[N>>2];f[p+52>>2]=f[N+4>>2];W=N}else{f[z>>2]=f[U>>2];z=k+40|0;f[p+40>>2]=f[z>>2];N=k+48|0;f[U>>2]=N;f[z>>2]=R;W=N}f[k>>2]=1124007936;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;f[M+24>>2]=0;f[M+28>>2]=0;f[S>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((W|0)!=(k+48|0))wL(W);if(G){Q=f[D>>2]|0;S=f[Q+4>>2]|0;M=f[Q>>2]|0;Q=k+4|0;N=(e&-2|0)==86;R=M+-2|0;f[Q>>2]=R;f[k>>2]=S+-2;if((M|0)>2){f[l>>2]=0;f[l+4>>2]=R;hpa(m,o,p,((e|0)==87|(e|0)==89)&1,N,k,N?1868:4899,N?4899:1868);N=f[a>>2]|0;if((N|0)<3)X=Y(f[T>>2]|0,f[A>>2]|0)|0;else{R=f[v>>2]|0;M=0;S=1;while(1){z=Y(f[R+(M<<2)>>2]|0,S)|0;M=M+1|0;if((M|0)==(N|0)){X=z;break}else S=z}}h3(l,m,+(X>>>0)*.0000152587890625);ipa(m)}S=f[v>>2]|0;N=f[S+4>>2]|0;M=f[S>>2]|0;f[k>>2]=N;f[Q>>2]=M;S=f[L>>2]|0;R=f[y>>2]|0;z=(N|0)>0;if((M|0)>2){if(z){N=0;do{b[S+N>>0]=b[S+(N+R)>>0]|0;U=f[Q>>2]|0;Z=S+((Y(U+-2|0,R)|0)+N)|0;_=S+((Y(U+-1|0,R)|0)+N)|0;b[_>>0]=b[Z>>0]|0;N=N+1|0}while((N|0)<(f[k>>2]|0))}}else if(z?(N=S+(Y(M+-1|0,R)|0)|0,b[N>>0]=0,b[S>>0]=0,(f[k>>2]|0)>1):0){N=1;do{Z=S+((Y((f[Q>>2]|0)+-1|0,R)|0)+N)|0;b[Z>>0]=0;b[S+N>>0]=0;N=N+1|0}while((N|0)<(f[k>>2]|0))}$=O;break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;N=$Xc(64)|0;f[k>>2]=N;f[k+8>>2]=-2147483584;f[k+4>>2]=54;w=N;K=270755;x=w+54|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[N+54>>0]=0;vM(-210,k,270646,270658,1688)}S=f[D>>2]|0;R=f[S+4>>2]|0;Q=f[S>>2]|0;S=k+4|0;M=(e&-2|0)==86;z=Q+-2|0;f[S>>2]=z;f[k>>2]=R+-2;if((Q|0)>2){f[l>>2]=0;f[l+4>>2]=z;jpa(m,o,p,((e|0)==87|(e|0)==89)&1,M,k,M?1868:4899,M?4899:1868);M=f[a>>2]|0;if((M|0)<3)aa=Y(f[T>>2]|0,f[A>>2]|0)|0;else{z=f[v>>2]|0;Q=0;R=1;while(1){Z=Y(f[z+(Q<<2)>>2]|0,R)|0;Q=Q+1|0;if((Q|0)==(M|0)){aa=Z;break}else R=Z}}h3(l,m,+(aa>>>0)*.0000152587890625);kpa(m)}R=f[v>>2]|0;M=f[R+4>>2]|0;Q=f[R>>2]|0;f[k>>2]=M;f[S>>2]=Q;R=f[L>>2]|0;z=(f[y>>2]|0)>>>1;T=(M|0)>0;if((Q|0)>2){if(T){N=Y(z,Q+-2|0)|0;Z=Y(z,Q+-1|0)|0;_=0;do{d[R+(_<<1)>>1]=d[R+(_+z<<1)>>1]|0;d[R+(_+Z<<1)>>1]=d[R+(_+N<<1)>>1]|0;_=_+1|0}while((_|0)!=(M|0))}}else if(T){_=Y(z,Q+-1|0)|0;N=0;do{d[R+(N+_<<1)>>1]=0;d[R+(N<<1)>>1]=0;N=N+1|0}while((N|0)!=(M|0))}$=O;break}case 142:case 141:case 140:case 139:{ba=(g|0)<1?4:g;ca=70;break}case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:{ba=g;ca=70;break}case 138:case 137:case 136:case 135:{if(!(((g|0)<1|(g|0)==3)&(C|0)==0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;M=$Xc(32)|0;f[k>>2]=M;f[k+8>>2]=-2147483616;f[k+4>>2]=20;w=M;K=270899;x=w+20|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[M+20>>0]=0;vM(-215,k,270646,270658,1729)}f[t>>2]=E;f[t+4>>2]=F;wS(c,t,H|16,-1,0,0);do if((eS(c)|0)==65536){O=f[c+4>>2]|0;f[k>>2]=f[O>>2];N=k+4|0;R=O+4|0;f[N>>2]=f[R>>2];_=k+8|0;f[_>>2]=f[O+8>>2];f[k+12>>2]=f[O+12>>2];f[k+16>>2]=f[O+16>>2];f[k+20>>2]=f[O+20>>2];f[k+24>>2]=f[O+24>>2];f[k+28>>2]=f[O+28>>2];f[k+32>>2]=f[O+32>>2];Q=f[O+36>>2]|0;f[k+36>>2]=Q;f[k+40>>2]=_;_=k+48|0;z=k+44|0;f[z>>2]=_;f[_>>2]=0;f[k+52>>2]=0;if(Q|0){_=Q+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[R>>2]|0)<3){R=f[O+44>>2]|0;_=f[z>>2]|0;f[_>>2]=f[R>>2];f[_+4>>2]=f[R+4>>2];break}else{f[N>>2]=0;U$(k,O);break}}else bS(k,c,-1);while(0);M=p+36|0;O=f[M>>2]|0;if(O|0?(N=O+12|0,O=f[N>>2]|0,f[N>>2]=O+-1,(O|0)==1):0)V$(p);f[M>>2]=0;O=p+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[a>>2]|0)>0){N=f[v>>2]|0;R=0;do{f[N+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[a>>2]|0))}f[p>>2]=f[k>>2];R=k+4|0;N=f[R>>2]|0;f[a>>2]=N;_=k+8|0;f[A>>2]=f[_>>2];z=p+12|0;f[z>>2]=f[k+12>>2];Q=k+16|0;f[O>>2]=f[Q>>2];f[p+20>>2]=f[k+20>>2];f[p+24>>2]=f[k+24>>2];f[p+28>>2]=f[k+28>>2];f[p+32>>2]=f[k+32>>2];T=k+36|0;f[M>>2]=f[T>>2];Z=p+44|0;L=f[Z>>2]|0;if((L|0)==(y|0))da=N;else{wL(L);f[Z>>2]=y;f[v>>2]=A;da=f[R>>2]|0}L=k+44|0;if((da|0)<3){N=f[L>>2]|0;f[y>>2]=f[N>>2];f[p+52>>2]=f[N+4>>2];ea=N}else{f[Z>>2]=f[L>>2];Z=k+40|0;f[p+40>>2]=f[Z>>2];N=k+48|0;f[L>>2]=N;f[Z>>2]=_;ea=N}f[k>>2]=1124007936;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;f[R+16>>2]=0;f[R+20>>2]=0;f[R+24>>2]=0;f[R+28>>2]=0;f[T>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((ea|0)!=(k+48|0))wL(ea);if(G){Q=f[D>>2]|0;T=f[Q+4>>2]|0;R=f[Q>>2]|0;f[k>>2]=T;Q=k+4|0;f[Q>>2]=R;b:do if(!((T|0)<3|(R|0)<3)){f[k>>2]=T+-2;f[Q>>2]=R+-2;opa(l,o,p,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);N=f[Q>>2]|0;f[m>>2]=0;f[m+4>>2]=N;N=f[a>>2]|0;if((N|0)<3)fa=Y(f[z>>2]|0,f[A>>2]|0)|0;else{_=f[v>>2]|0;Z=0;L=1;while(1){S=Y(f[_+(Z<<2)>>2]|0,L)|0;Z=Z+1|0;if((Z|0)==(N|0)){fa=S;break}else L=S}}h3(m,l,+(fa>>>0)*.0000152587890625);ppa(l);L=f[v>>2]|0;N=f[L+4>>2]|0;Z=f[L>>2]|0;f[Q>>2]=Z;L=f[p>>2]|0;_=Y((L>>>3&511)+1|0,N)|0;f[k>>2]=_;N=((f[y>>2]|0)>>>0)/((675553809>>>(L<<2&28)&15)>>>0)|0;L=f[O>>2]|0;S=L+(Y(N,Z+-1|0)|0)|0;U=(_|0)>0;if((Z|0)<=2){if(U)ga=0;else break;while(1){b[S+ga>>0]=0;b[L+ga>>0]=0;ga=ga+1|0;if((ga|0)>=(f[k>>2]|0))break b}}if(U){Z=L+N|0;_=S+(0-N)|0;ha=0;do{b[L+ha>>0]=b[Z+ha>>0]|0;b[S+ha>>0]=b[_+ha>>0]|0;ha=ha+1|0}while((ha|0)<(f[k>>2]|0))}}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;lR(p,l)|0}while(0);$=M;break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;Q=$Xc(80)|0;f[k>>2]=Q;f[k+8>>2]=-2147483568;f[k+4>>2]=74;w=Q;K=270920;x=w+74|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[Q+74>>0]=0;vM(-210,k,270646,270658,1738)}R=f[D>>2]|0;T=f[R+4>>2]|0;ha=f[R>>2]|0;f[k>>2]=T;R=k+4|0;f[R>>2]=ha;c:do if(!((T|0)<3|(ha|0)<3)){f[k>>2]=T+-2;f[R>>2]=ha+-2;qpa(l,o,p,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);_=f[R>>2]|0;f[m>>2]=0;f[m+4>>2]=_;_=f[a>>2]|0;if((_|0)<3)ia=Y(f[z>>2]|0,f[A>>2]|0)|0;else{S=f[v>>2]|0;Z=0;L=1;while(1){N=Y(f[S+(Z<<2)>>2]|0,L)|0;Z=Z+1|0;if((Z|0)==(_|0)){ia=N;break}else L=N}}h3(m,l,+(ia>>>0)*.0000152587890625);rpa(l);L=f[v>>2]|0;_=f[L+4>>2]|0;Z=f[L>>2]|0;f[R>>2]=Z;L=f[p>>2]|0;S=Y((L>>>3&511)+1|0,_)|0;f[k>>2]=S;_=((f[y>>2]|0)>>>0)/((675553809>>>(L<<2&28)&15)>>>0)|0;L=f[O>>2]|0;N=L+((Y(_,Z+-1|0)|0)<<1)|0;U=(S|0)>0;if((Z|0)<=2){if(U)ja=0;else break;while(1){d[N+(ja<<1)>>1]=0;d[L+(ja<<1)>>1]=0;ja=ja+1|0;if((ja|0)==(S|0))break c}}if(U){Z=L+(_<<1)|0;ka=N+(0-_<<1)|0;la=0;do{d[L+(la<<1)>>1]=d[Z+(la<<1)>>1]|0;d[N+(la<<1)>>1]=d[ka+(la<<1)>>1]|0;la=la+1|0}while((la|0)!=(S|0))}}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;lR(p,l)|0}while(0);$=M;break}default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;O=$Xc(48)|0;f[k>>2]=O;f[k+8>>2]=-2147483600;f[k+4>>2]=43;w=O;K=270995;x=w+43|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[O+43>>0]=0;vM(-206,k,270646,270658,1743)}}while(0);if((ca|0)==70){ca=(ba|0)<1?3:ba;if(!((C|0)==0&(ca+-3|0)>>>0<2)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;C=$Xc(48)|0;f[k>>2]=C;f[k+8>>2]=-2147483600;f[k+4>>2]=34;w=C;K=270810;x=w+34|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[C+34>>0]=0;vM(-215,k,270646,270658,1700)}f[r>>2]=E;f[r+4>>2]=F;wS(c,r,(ca<<3)+-8|H,-1,0,0);do if((eS(c)|0)==65536){H=f[c+4>>2]|0;f[s>>2]=f[H>>2];ca=s+4|0;r=H+4|0;f[ca>>2]=f[r>>2];F=s+8|0;f[F>>2]=f[H+8>>2];f[s+12>>2]=f[H+12>>2];f[s+16>>2]=f[H+16>>2];f[s+20>>2]=f[H+20>>2];f[s+24>>2]=f[H+24>>2];f[s+28>>2]=f[H+28>>2];f[s+32>>2]=f[H+32>>2];E=f[H+36>>2]|0;f[s+36>>2]=E;f[s+40>>2]=F;F=s+48|0;C=s+44|0;f[C>>2]=F;f[F>>2]=0;f[s+52>>2]=0;if(E|0){F=E+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[r>>2]|0)<3){r=f[H+44>>2]|0;F=f[C>>2]|0;f[F>>2]=f[r>>2];f[F+4>>2]=f[r+4>>2];break}else{f[ca>>2]=0;U$(s,H);break}}else bS(s,c,-1);while(0);d:do switch(e|0){case 46:case 47:case 48:case 49:case 139:case 140:case 141:case 142:{if(G){lpa(o,s,e);break d}if(!I){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;c=$Xc(64)|0;f[k>>2]=c;f[k+8>>2]=-2147483584;f[k+4>>2]=53;w=c;K=270845;x=w+53|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[c+53>>0]=0;vM(-210,k,270646,270658,1715)}O=(f[s+48>>2]|0)>>>1;H=f[D>>2]|0;ca=f[H+4>>2]|0;r=f[H>>2]|0;f[k>>2]=ca;H=k+4|0;f[H>>2]=r;switch(e|0){case 46:case 47:case 139:{ma=-1;break}default:ma=(e|0)==140?-1:1}switch(e|0){case 142:case 47:case 49:case 140:{na=1;break}default:na=0}F=((f[s>>2]|0)>>>3&511)+1|0;C=r+-2|0;f[H>>2]=C;f[k>>2]=ca+-2;if((r|0)>2){f[l>>2]=0;f[l+4>>2]=C;mpa(m,o,s,na,ma,k);C=f[s+4>>2]|0;if((C|0)<3)oa=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{r=f[s+40>>2]|0;ca=0;E=1;while(1){ba=Y(f[r+(ca<<2)>>2]|0,E)|0;ca=ca+1|0;if((ca|0)==(C|0)){oa=ba;break}else E=ba}}h3(l,m,+(oa>>>0)*.0000152587890625);npa(m)}E=f[s+40>>2]|0;C=f[E+4>>2]|0;ca=f[E>>2]|0;f[k>>2]=C;f[H>>2]=ca;E=f[s+16>>2]|0;r=Y(C,F)|0;C=(r|0)>0;if((ca|0)>2){if(C){c=Y(ca+-2|0,O)|0;ba=Y(ca+-1|0,O)|0;ja=0;do{d[E+(ja<<1)>>1]=d[E+(ja+O<<1)>>1]|0;d[E+(ja+ba<<1)>>1]=d[E+(ja+c<<1)>>1]|0;ja=ja+1|0}while((ja|0)!=(r|0))}}else if(C){ja=Y(ca+-1|0,O)|0;c=0;do{d[E+(c+ja<<1)>>1]=0;d[E+(c<<1)>>1]=0;c=c+1|0}while((c|0)!=(r|0))}break}default:{if(!G){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;r=$Xc(16)|0;f[k>>2]=r;f[k+8>>2]=-2147483632;f[k+4>>2]=14;w=r;K=473858;x=w+14|0;do{b[w>>0]=b[K>>0]|0;w=w+1|0;K=K+1|0}while((w|0)<(x|0));b[r+14>>0]=0;vM(-215,k,270646,270658,1719)}c=f[J>>2]|0;E=f[o+48>>2]|0;ja=f[s+16>>2]|0;O=f[s+48>>2]|0;ca=f[D>>2]|0;C=f[ca+4>>2]|0;ba=f[ca>>2]|0;if((((C|0)>(ba|0)?ba:C)|0)<8){lpa(o,s,e);break d}ca=C<<1;F=C*3|0;H=C<<2;ia=C*5|0;A=C*6|0;ga=C*49|0;fa=C*147|0;ea=k+8|0;f[k>>2]=ea;da=k+4|0;f[da>>2]=fa;if(fa>>>0>520){t=bYc(fa>>>0>2147483647?-1:fa<<1)|0;f[k>>2]=t;pa=t}else pa=ea;t=E<<1;fa=c+t|0;c=ba+-4|0;if((c|0)>2){g=C+-2|0;aa=C+-1|0;X=(aa|0)>1;W=~E;V=E+-1|0;q=0-E|0;M=1-E|0;R=E+1|0;z=(g|0)>2;ha=F+-9|0;T=g*3|0;Q=C+1|0;S=ca|1;la=ca+-1|0;ka=F+-1|0;N=F+1|0;Z=q<<1;L=Z+-1|0;_=Z|1;U=t+-1|0;qa=t|1;ra=-2-E|0;sa=E+-2|0;ta=2-E|0;ua=E+2|0;va=H|1;wa=H+-1|0;xa=ia+-1|0;ya=ia+1|0;za=Y(E,-2)|0;Aa=za+2|0;Ba=A|1;Ca=t+-2|0;Da=A+-1|0;Ea=za+-2|0;za=t+2|0;Fa=g+C|0;Ga=g+ca|0;Ha=g+F|0;Ia=g+H|0;Ja=g+ia|0;Ka=g+A|0;La=(e|1|0)==63?0:2;Ma=2;Na=(e|0)!=62&(e|0)!=64;while(1){Oa=Y(Ma,O)|0;Pa=(Ma|0)==2?-1:1;do{Qa=Pa+Ma|0;Ra=pa+((Y((Qa+-1|0)%3|0,ga)|0)<<1)+2|0;d[Ra+(g<<1)>>1]=0;d[Ra+-2>>1]=0;d[Ra+(Fa<<1)>>1]=0;d[Ra+(aa<<1)>>1]=0;d[Ra+(Ga<<1)>>1]=0;d[Ra+(la<<1)>>1]=0;d[Ra+(Ha<<1)>>1]=0;d[Ra+(ka<<1)>>1]=0;d[Ra+(Ia<<1)>>1]=0;d[Ra+(wa<<1)>>1]=0;d[Ra+(Ja<<1)>>1]=0;d[Ra+(xa<<1)>>1]=0;d[Ra+(Ka<<1)>>1]=0;d[Ra+(Da<<1)>>1]=0;if(X){Sa=Ra;Ra=fa+(Y(Qa,E)|0)+1|0;Qa=1;while(1){Ta=Ra+W|0;Ua=Ra+V|0;Va=(h[Ta>>0]|0)-(h[Ua>>0]|0)|0;Wa=Ra+q|0;Xa=Ra+E|0;Ya=(h[Wa>>0]|0)-(h[Xa>>0]|0)|0;Za=Ra+M|0;_a=Ra+R|0;$a=(h[Za>>0]|0)-(h[_a>>0]|0)|0;d[Sa>>1]=(((Ya|0)>-1?Ya:0-Ya|0)<<1)+((Va|0)>-1?Va:0-Va|0)+(($a|0)>-1?$a:0-$a|0);$a=(h[Ta>>0]|0)-(h[Za>>0]|0)|0;Va=Ra+-1|0;Ra=Ra+1|0;Ya=(h[Va>>0]|0)-(h[Ra>>0]|0)|0;ab=(h[Ua>>0]|0)-(h[_a>>0]|0)|0;d[Sa+(C<<1)>>1]=(((Ya|0)>-1?Ya:0-Ya|0)<<1)+(($a|0)>-1?$a:0-$a|0)+((ab|0)>-1?ab:0-ab|0);ab=(h[Za>>0]|0)-(h[Ua>>0]|0)|0;Ua=Sa+(ca<<1)|0;d[Ua>>1]=((ab|0)>-1?ab:0-ab|0)<<1;ab=(h[Ta>>0]|0)-(h[_a>>0]|0)|0;_a=Sa+(F<<1)|0;d[_a>>1]=((ab|0)>-1?ab:0-ab|0)<<1;ab=(h[Wa>>0]|0)-(h[Va>>0]|0)|0;Ta=(h[Xa>>0]|0)-(h[Ra>>0]|0)|0;d[Sa+(H<<1)>>1]=((ab|0)>-1?ab:0-ab|0)+(j[Ua>>1]|0)+((Ta|0)>-1?Ta:0-Ta|0);Ta=(h[Wa>>0]|0)-(h[Ra>>0]|0)|0;Ua=(h[Xa>>0]|0)-(h[Va>>0]|0)|0;d[Sa+(ia<<1)>>1]=((Ta|0)>-1?Ta:0-Ta|0)+(j[_a>>1]|0)+((Ua|0)>-1?Ua:0-Ua|0);d[Sa+(A<<1)>>1]=((h[Va>>0]|0)+(h[Wa>>0]|0)+(h[Ra>>0]|0)+(h[Xa>>0]|0)|0)>>>1;Qa=Qa+1|0;if((Qa|0)==(aa|0))break;else Sa=Sa+2|0}}Pa=Pa+1|0}while((Pa|0)!=2);Pa=ja+Oa|0;if(z){Sa=La^2;Qa=Na;Ra=pa+((Y((Ma|0)%3|0,ga)|0)<<1)+4|0;Xa=pa+((Y((Ma+-1|0)%3|0,ga)|0)<<1)+4|0;Wa=pa+((Y((Ma+-2|0)%3|0,ga)|0)<<1)+4|0;Va=Pa+6|0;Ua=fa+(Y(Ma,E)|0)+2|0;_a=2;while(1){Ta=j[Xa>>1]|0;ab=Ta+(j[Wa>>1]|0)|0;Za=(j[Ra>>1]|0)+Ta|0;Ta=j[Xa+(C<<1)>>1]|0;$a=Ta+(j[Xa+(aa<<1)>>1]|0)|0;Ya=(j[Xa+(Q<<1)>>1]|0)+Ta|0;Ta=Za>>>0<ab>>>0?Za:ab;bb=($a|0)<(Ta|0)?$a:Ta;Ta=(Ya|0)<(bb|0)?Ya:bb;bb=ab>>>0<Za>>>0?Za:ab;cb=(bb|0)<($a|0)?$a:bb;bb=(cb|0)<(Ya|0)?Ya:cb;if(Qa){cb=j[Xa+(ca<<1)>>1]|0;db=(j[Wa+(S<<1)>>1]|0)+(j[Wa+(ca<<1)>>1]|0)+cb+(j[Xa+(S<<1)>>1]|0)|0;eb=(j[Xa+(la<<1)>>1]|0)+cb+(j[Ra+(ca<<1)>>1]|0)+(j[Ra+(la<<1)>>1]|0)|0;cb=j[Xa+(F<<1)>>1]|0;fb=(j[Wa+(ka<<1)>>1]|0)+(j[Wa+(F<<1)>>1]|0)+cb+(j[Xa+(ka<<1)>>1]|0)|0;gb=(j[Xa+(N<<1)>>1]|0)+cb+(j[Ra+(F<<1)>>1]|0)+(j[Ra+(N<<1)>>1]|0)|0;cb=(db|0)<(Ta|0)?db:Ta;hb=(eb|0)<(cb|0)?eb:cb;cb=(fb|0)<(hb|0)?fb:hb;hb=(bb|0)<(db|0)?db:bb;ib=(hb|0)<(eb|0)?eb:hb;hb=(ib|0)<(fb|0)?fb:ib;ib=(hb|0)<(gb|0)?gb:hb;hb=((ib|0)<2?1:ib>>>1)+((gb|0)<(cb|0)?gb:cb)|0;if((ab|0)<(hb|0)){jb=1;kb=(h[Ua+q>>0]|0)<<1;lb=(h[Ua>>0]|0)+(h[Ua+Z>>0]|0)|0;mb=(h[Ua+_>>0]|0)+(h[Ua+L>>0]|0)|0}else{jb=0;kb=0;lb=0;mb=0}if((Za|0)<(hb|0)){nb=jb+1|0;ob=((h[Ua+E>>0]|0)<<1)+kb|0;pb=(h[Ua+t>>0]|0)+lb+(h[Ua>>0]|0)|0;qb=(h[Ua+U>>0]|0)+mb+(h[Ua+qa>>0]|0)|0}else{nb=jb;ob=kb;pb=lb;qb=mb}if(($a|0)<(hb|0)){rb=nb+1|0;sb=(h[Ua+ra>>0]|0)+ob+(h[Ua+sa>>0]|0)|0;tb=(h[Ua+-2>>0]|0)+pb+(h[Ua>>0]|0)|0;ub=((h[Ua+-1>>0]|0)<<1)+qb|0}else{rb=nb;sb=ob;tb=pb;ub=qb}if((Ya|0)<(hb|0)){vb=rb+1|0;wb=(h[Ua+ta>>0]|0)+sb+(h[Ua+ua>>0]|0)|0;xb=(h[Ua+2>>0]|0)+tb+(h[Ua>>0]|0)|0;yb=((h[Ua+1>>0]|0)<<1)+ub|0}else{vb=rb;wb=sb;xb=tb;yb=ub}if((db|0)<(hb|0)){zb=vb+1|0;Ab=(h[Ua+q>>0]|0)+wb+(h[Ua+ta>>0]|0)|0;Bb=((h[Ua+M>>0]|0)<<1)+xb|0;Cb=(h[Ua+_>>0]|0)+yb+(h[Ua+1>>0]|0)|0}else{zb=vb;Ab=wb;Bb=xb;Cb=yb}if((eb|0)<(hb|0)){Db=zb+1|0;Eb=(h[Ua+E>>0]|0)+Ab+(h[Ua+sa>>0]|0)|0;Fb=((h[Ua+V>>0]|0)<<1)+Bb|0;Gb=(h[Ua+U>>0]|0)+Cb+(h[Ua+-1>>0]|0)|0}else{Db=zb;Eb=Ab;Fb=Bb;Gb=Cb}if((fb|0)<(hb|0)){Hb=Db+1|0;Ib=(h[Ua+ra>>0]|0)+Eb+(h[Ua+q>>0]|0)|0;Jb=((h[Ua+W>>0]|0)<<1)+Fb|0;Kb=(h[Ua+L>>0]|0)+Gb+(h[Ua+-1>>0]|0)|0}else{Hb=Db;Ib=Eb;Jb=Fb;Kb=Gb}if((gb|0)<(hb|0)){Lb=Hb+1|0;Mb=(h[Ua+ua>>0]|0)+Ib+(h[Ua+E>>0]|0)|0;Nb=((h[Ua+R>>0]|0)<<1)+Jb|0;Ob=(h[Ua+qa>>0]|0)+Kb+(h[Ua+1>>0]|0)|0}else{Lb=Hb;Mb=Ib;Nb=Jb;Ob=Kb}hb=h[Ua>>0]|0;Pb=+n[53044+(Lb<<2)>>2];Qb=hb;Rb=(ALc(+(Ob-Nb|0)*Pb)|0)+hb|0;Sb=hb;Tb=Pb;Ub=Mb-Nb|0}else{hb=j[Xa+(H<<1)>>1]|0;gb=hb+(j[Wa+(va<<1)>>1]|0)|0;fb=(j[Ra+(wa<<1)>>1]|0)+hb|0;hb=j[Xa+(ia<<1)>>1]|0;eb=hb+(j[Wa+(xa<<1)>>1]|0)|0;db=(j[Ra+(ya<<1)>>1]|0)+hb|0;hb=(gb|0)<(Ta|0)?gb:Ta;Ta=(fb|0)<(hb|0)?fb:hb;hb=(eb|0)<(Ta|0)?eb:Ta;Ta=(bb|0)<(gb|0)?gb:bb;bb=(Ta|0)<(fb|0)?fb:Ta;Ta=(bb|0)<(eb|0)?eb:bb;bb=(Ta|0)<(db|0)?db:Ta;Ta=((bb|0)<2?1:bb>>>1)+((db|0)<(hb|0)?db:hb)|0;hb=h[Ua>>0]|0;if((ab|0)<(Ta|0)){Vb=1;Wb=(h[Ua+M>>0]|0)+(h[Ua+W>>0]|0)|0;Xb=(h[Ua+q>>0]|0)<<1;Yb=(h[Ua+Z>>0]|0)+hb|0}else{Vb=0;Wb=0;Xb=0;Yb=0}if((Za|0)<(Ta|0)){Zb=Vb+1|0;_b=(h[Ua+V>>0]|0)+Wb+(h[Ua+R>>0]|0)|0;$b=((h[Ua+E>>0]|0)<<1)+Xb|0;ac=Yb+hb+(h[Ua+t>>0]|0)|0}else{Zb=Vb;_b=Wb;$b=Xb;ac=Yb}if(($a|0)<(Ta|0)){bc=Zb+1|0;cc=(h[Ua+W>>0]|0)+_b+(h[Ua+V>>0]|0)|0;dc=((h[Ua+-1>>0]|0)<<1)+$b|0;ec=ac+hb+(h[Ua+-2>>0]|0)|0}else{bc=Zb;cc=_b;dc=$b;ec=ac}if((Ya|0)<(Ta|0)){fc=bc+1|0;gc=(h[Ua+M>>0]|0)+cc+(h[Ua+R>>0]|0)|0;hc=((h[Ua+1>>0]|0)<<1)+dc|0;ic=ec+hb+(h[Ua+2>>0]|0)|0}else{fc=bc;gc=cc;hc=dc;ic=ec}if((gb|0)<(Ta|0)){jc=fc+1|0;kc=((h[Ua+M>>0]|0)<<1)+gc|0;lc=(j[Wa+(Ba<<1)>>1]|0)+hc|0;mc=ic+hb+(h[Ua+Aa>>0]|0)|0}else{jc=fc;kc=gc;lc=hc;mc=ic}if((fb|0)<(Ta|0)){nc=jc+1|0;oc=((h[Ua+V>>0]|0)<<1)+kc|0;pc=(j[Ra+(Da<<1)>>1]|0)+lc|0;qc=mc+hb+(h[Ua+Ca>>0]|0)|0}else{nc=jc;oc=kc;pc=lc;qc=mc}if((eb|0)<(Ta|0)){rc=nc+1|0;sc=((h[Ua+M>>0]|0)<<1)+oc|0;tc=(j[Wa+(Da<<1)>>1]|0)+pc|0;uc=qc+hb+(h[Ua+Ea>>0]|0)|0}else{rc=nc;sc=oc;tc=pc;uc=qc}if((db|0)<(Ta|0)){vc=rc+1|0;wc=((h[Ua+M>>0]|0)<<1)+sc|0;xc=(j[Ra+(Ba<<1)>>1]|0)+tc|0;yc=uc+hb+(h[Ua+za>>0]|0)|0}else{vc=rc;wc=sc;xc=tc;yc=uc}Pb=+n[53044+(vc<<2)>>2];Qb=(ALc(+(xc-yc|0)*Pb)|0)+hb|0;Rb=hb;Sb=hb;Tb=Pb;Ub=wc-yc|0}hb=(ALc(+(Ub|0)*Tb)|0)+Sb|0;b[Va+La>>0]=hb>>>0<256?hb:(hb|0)>0?255:0;b[Va+1>>0]=Qb>>>0<256?Qb:(Qb|0)>0?255:0;b[Va+Sa>>0]=Rb>>>0<256?Rb:(Rb|0)>0?255:0;_a=_a+1|0;if((_a|0)==(g|0)){zc=Sa;break}else{Qa=Qa^1;Ra=Ra+2|0;Xa=Xa+2|0;Wa=Wa+2|0;Va=Va+3|0;Ua=Ua+1|0}}}else zc=La^2;Ua=ha+Oa|0;Va=Oa+T|0;Wa=ja+(Oa+5)|0;b[Wa>>0]=b[ja+(Oa+8)>>0]|0;b[ja+Va>>0]=b[ja+Ua>>0]|0;Xa=ja+(Oa+4)|0;b[Xa>>0]=b[ja+(Oa+7)>>0]|0;b[ja+(Va+1)>>0]=b[ja+(Ua+1)>>0]|0;Ra=ja+(Oa+3)|0;b[Ra>>0]=b[ja+(Oa+6)>>0]|0;b[ja+(Va+2)>>0]=b[ja+(Ua+2)>>0]|0;b[ja+(Oa+2)>>0]=b[Wa>>0]|0;b[ja+(Va+3)>>0]=b[ja+(Ua+3)>>0]|0;b[ja+(Oa+1)>>0]=b[Xa>>0]|0;b[ja+(Va+4)>>0]=b[ja+(Ua+4)>>0]|0;b[Pa>>0]=b[Ra>>0]|0;b[ja+(Va+5)>>0]=b[ja+(Ua+5)>>0]|0;Ma=Ma+1|0;if((Ma|0)==(c|0))break;else{La=zc;Na=Na^1}}}if((F|0)>0){Na=O<<1;La=Y(ba+-5|0,O)|0;Ma=Y(ba+-1|0,O)|0;T=Y(ba+-2|0,O)|0;ha=Y(ba+-3|0,O)|0;g=Y(c,O)|0;za=0;do{Ba=b[ja+(za+Na)>>0]|0;b[ja+(za+O)>>0]=Ba;b[ja+za>>0]=Ba;Ba=b[ja+(za+La)>>0]|0;b[ja+(za+Ma)>>0]=Ba;b[ja+(za+T)>>0]=Ba;b[ja+(za+ha)>>0]=Ba;b[ja+(za+g)>>0]=Ba;za=za+1|0}while((za|0)!=(F|0))}F=f[k>>2]|0;if((F|0)!=(ea|0)){if(F|0)dYc(F);f[k>>2]=ea;f[da>>2]=520}}}while(0);k=s+36|0;zc=f[k>>2]|0;if(zc|0?(Rb=zc+12|0,zc=f[Rb>>2]|0,f[Rb>>2]=zc+-1,(zc|0)==1):0)V$(s);f[k>>2]=0;k=s+16|0;zc=s+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[zc>>2]|0)>0){k=f[s+40>>2]|0;Rb=0;do{f[k+(Rb<<2)>>2]=0;Rb=Rb+1|0}while((Rb|0)<(f[zc>>2]|0))}zc=f[s+44>>2]|0;if((zc|0)!=(s+48|0))wL(zc);$=p+36|0}zc=f[$>>2]|0;if(zc|0?(s=zc+12|0,zc=f[s>>2]|0,f[s>>2]=zc+-1,(zc|0)==1):0)V$(p);f[$>>2]=0;$=p+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[a>>2]|0)>0){$=f[v>>2]|0;v=0;do{f[$+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[B>>2]|0;if((a|0)!=(y|0))wL(a);a=o+36|0;y=f[a>>2]|0;if(y|0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0)V$(o);f[a>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[P>>2]|0)>0){J=f[D>>2]|0;D=0;do{f[J+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[P>>2]|0))}P=f[o+44>>2]|0;if((P|0)==(o+48|0)){u=i;return}wL(P);u=i;return}function hpa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=53188;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;U$(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;U$(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function ipa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53188;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function jpa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=53168;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;U$(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;U$(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function kpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53168;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function lpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+160|0;g=e+144|0;h=e+136|0;i=e;j=f[c+48>>2]|0;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;f[g>>2]=l;k=g+4|0;f[k>>2]=m;switch(d|0){case 46:case 47:case 139:{n=-1;break}default:n=(d|0)==140?-1:1}switch(d|0){case 142:case 47:case 49:case 140:{o=1;break}default:o=0}d=((f[c>>2]|0)>>>3&511)+1|0;p=m+-2|0;f[k>>2]=p;f[g>>2]=l+-2;if((m|0)>2){f[h>>2]=0;f[h+4>>2]=p;ypa(i,a,c,o,n,g);n=f[c+4>>2]|0;if((n|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;a=0;p=1;while(1){m=Y(f[o+(a<<2)>>2]|0,p)|0;a=a+1|0;if((a|0)==(n|0)){q=m;break}else p=m}}h3(h,i,+(q>>>0)*.0000152587890625);zpa(i)}i=f[c+40>>2]|0;q=f[i+4>>2]|0;h=f[i>>2]|0;f[g>>2]=q;f[k>>2]=h;i=f[c+16>>2]|0;c=(Y(q,d)|0)>0;if((h|0)>2){if(c)r=0;else{u=e;return}do{b[i+r>>0]=b[i+(r+j)>>0]|0;q=f[k>>2]|0;p=i+((Y(q+-2|0,j)|0)+r)|0;n=i+((Y(q+-1|0,j)|0)+r)|0;b[n>>0]=b[p>>0]|0;r=r+1|0}while((r|0)<(Y(f[g>>2]|0,d)|0));u=e;return}if(!c){u=e;return}c=i+(Y(h+-1|0,j)|0)|0;b[c>>0]=0;b[i>>0]=0;if((Y(f[g>>2]|0,d)|0)>1)s=1;else{u=e;return}do{c=i+((Y((f[k>>2]|0)+-1|0,j)|0)+s)|0;b[c>>0]=0;b[i+s>>0]=0;s=s+1|0}while((s|0)<(Y(f[g>>2]|0,d)|0));u=e;return}function mpa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=53128;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;U$(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;U$(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function npa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53128;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function opa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=53108;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;U$(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;U$(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function ppa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53108;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function qpa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=53088;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;U$(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;U$(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function rpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53088;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function spa(a){a=a|0;rpa(a);cYc(a);return}function tpa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=f[a+60>>2]|0;e=(c>>>3&511)+1|0;g=e<<1;h=((f[a+52>>2]|0)>>>0)/((675553809>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;i=f[a+108>>2]|0;k=(i>>>0)/((675553809>>>(c<<2&28)&15)>>>0)|0;c=f[b>>2]|0;l=c+1|0;m=f[b+4>>2]|0;if((c|0)>=(m|0))return;b=c&1;n=(f[a+76>>2]|0)+(Y(l,i)|0)+(e<<1)|0;i=0-h|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~h;r=1-h|0;s=h+-1|0;t=h+1|0;u=c;c=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+2|0;l=b^f[a+124>>2];v=b^f[a+128>>2];while(1){if(!v){w=1;x=c;y=n}else{a=l<<1;d[c+(a<<1)>>1]=((j[n+(h<<1)>>1]|0)+(j[n+(i<<1)>>1]|0)|0)>>>1;d[c+2>>1]=d[n>>1]|0;b=n+2|0;d[c+(2-a<<1)>>1]=((j[b>>1]|0)+(j[n+-2>>1]|0)|0)>>>1;w=2;x=c+(e<<1)|0;y=b}b=f[o>>2]|0;a=(w|0)<(b|0);if(!l)if(a){z=w;A=x;B=y;while(1){C=B+(r<<1)|0;D=B+(t<<1)|0;d[A>>1]=((j[B+(k<<1)>>1]|0)+2+(j[C>>1]|0)+(j[B+(s<<1)>>1]|0)+(j[D>>1]|0)|0)>>>2;E=j[B+-2>>1]|0;F=B+2|0;G=d[F>>1]|0;H=E-(G&65535)|0;I=j[B+(h<<1)>>1]|0;J=d[B+(i<<1)>>1]|0;K=I-(J&65535)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);d[A+2>>1]=((L?I:E)+1+((L?J:G)&65535)|0)>>>1;d[A+4>>1]=d[B>>1]|0;d[A+6>>1]=((j[C>>1]|0)+1+(j[D>>1]|0)|0)>>>1;d[A+8>>1]=d[F>>1]|0;F=B+4|0;d[A+10>>1]=((j[B>>1]|0)+1+(j[F>>1]|0)|0)>>>1;D=z+2|0;C=A+(g<<1)|0;if((D|0)<(b|0)){z=D;A=C;B=F}else{M=D;N=C;O=F;break}}}else{M=w;N=x;O=y}else if(a){B=w;A=x;z=y;while(1){d[A>>1]=d[z>>1]|0;F=j[z+-2>>1]|0;C=z+2|0;D=d[C>>1]|0;G=F-(D&65535)|0;J=j[z+(h<<1)>>1]|0;L=d[z+(i<<1)>>1]|0;E=J-(L&65535)|0;I=(((G|0)>-1?G:0-G|0)|0)>(((E|0)>-1?E:0-E|0)|0);d[A+2>>1]=((I?J:F)+1+((I?L:D)&65535)|0)>>>1;D=z+(r<<1)|0;L=z+(t<<1)|0;d[A+4>>1]=((j[D>>1]|0)+(j[z+(k<<1)>>1]|0)+(j[z+(s<<1)>>1]|0)+(j[L>>1]|0)|0)>>>2;I=z+4|0;d[A+6>>1]=((j[z>>1]|0)+1+(j[I>>1]|0)|0)>>>1;d[A+8>>1]=d[C>>1]|0;d[A+10>>1]=((j[D>>1]|0)+1+(j[L>>1]|0)|0)>>>1;L=B+2|0;D=A+(g<<1)|0;if((L|0)<(b|0)){B=L;A=D;z=I}else{M=L;N=D;O=I;break}}}else{M=w;N=x;O=y}if((M|0)>(b|0)){P=N;Q=O}else{z=l<<1;d[N+(z<<1)>>1]=((j[O+(k<<1)>>1]|0)+2+(j[O+(r<<1)>>1]|0)+(j[O+(s<<1)>>1]|0)+(j[O+(t<<1)>>1]|0)|0)>>>2;A=j[O+-2>>1]|0;B=O+2|0;a=d[B>>1]|0;I=A-(a&65535)|0;D=j[O+(h<<1)>>1]|0;L=d[O+(i<<1)>>1]|0;C=D-(L&65535)|0;F=(((I|0)>-1?I:0-I|0)|0)>(((C|0)>-1?C:0-C|0)|0);d[N+2>>1]=((F?D:A)+1+((F?L:a)&65535)|0)>>>1;d[N+(2-z<<1)>>1]=d[O>>1]|0;P=N+(e<<1)|0;Q=B}B=0;do{d[P+(B<<1)>>1]=d[P+(B-e<<1)>>1]|0;d[P+(q+B<<1)>>1]=d[P+(p+B<<1)>>1]|0;B=B+1|0}while((B|0)!=(e|0));u=u+1|0;if((u|0)>=(m|0))break;else{c=P+(g<<1)|0;n=Q+4|0;l=l^1;v=v^1}}return}function upa(a){a=a|0;ppa(a);cYc(a);return}function vpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=f[a+60>>2]|0;e=(d>>>3&511)+1|0;g=e<<1;i=((f[a+52>>2]|0)>>>0)/((675553809>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;j=f[a+108>>2]|0;k=(j>>>0)/((675553809>>>(d<<2&28)&15)>>>0)|0;d=f[c>>2]|0;l=d+1|0;m=c+4|0;if((d|0)>=(f[m>>2]|0))return;c=d&1;n=(f[a+76>>2]|0)+(Y(l,j)|0)+e|0;j=0-i|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~i;r=1-i|0;s=i+-1|0;t=i+1|0;u=d;d=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+1|0;l=c^f[a+124>>2];v=c^f[a+128>>2];while(1){if(!v){w=1;x=d;y=n}else{a=l<<1;b[d+a>>0]=((h[n+i>>0]|0)+(h[n+j>>0]|0)|0)>>>1;b[d+1>>0]=b[n>>0]|0;c=n+1|0;b[d+(2-a)>>0]=((h[c>>0]|0)+(h[n+-1>>0]|0)|0)>>>1;w=2;x=d+e|0;y=c}c=f[o>>2]|0;a=(w|0)<(c|0);if(!l)if(a){z=w;A=x;B=y;while(1){C=B+r|0;D=B+t|0;b[A>>0]=((h[B+k>>0]|0)+2+(h[C>>0]|0)+(h[B+s>>0]|0)+(h[D>>0]|0)|0)>>>2;E=h[B+-1>>0]|0;F=B+1|0;G=b[F>>0]|0;H=E-(G&255)|0;I=h[B+i>>0]|0;J=b[B+j>>0]|0;K=I-(J&255)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);b[A+1>>0]=((L?I:E)+1+((L?J:G)&255)|0)>>>1;b[A+2>>0]=b[B>>0]|0;b[A+3>>0]=((h[C>>0]|0)+1+(h[D>>0]|0)|0)>>>1;b[A+4>>0]=b[F>>0]|0;F=B+2|0;b[A+5>>0]=((h[B>>0]|0)+1+(h[F>>0]|0)|0)>>>1;D=z+2|0;C=A+g|0;G=f[o>>2]|0;if((D|0)<(G|0)){z=D;A=C;B=F}else{M=D;N=C;O=F;P=G;break}}}else{M=w;N=x;O=y;P=c}else if(a){B=w;A=x;z=y;while(1){b[A>>0]=b[z>>0]|0;G=h[z+-1>>0]|0;F=z+1|0;C=b[F>>0]|0;D=G-(C&255)|0;J=h[z+i>>0]|0;L=b[z+j>>0]|0;E=J-(L&255)|0;I=(((D|0)>-1?D:0-D|0)|0)>(((E|0)>-1?E:0-E|0)|0);b[A+1>>0]=((I?J:G)+1+((I?L:C)&255)|0)>>>1;C=z+r|0;L=z+t|0;b[A+2>>0]=((h[C>>0]|0)+(h[z+k>>0]|0)+(h[z+s>>0]|0)+(h[L>>0]|0)|0)>>>2;I=z+2|0;b[A+3>>0]=((h[z>>0]|0)+1+(h[I>>0]|0)|0)>>>1;b[A+4>>0]=b[F>>0]|0;b[A+5>>0]=((h[C>>0]|0)+1+(h[L>>0]|0)|0)>>>1;L=B+2|0;C=A+g|0;F=f[o>>2]|0;if((L|0)<(F|0)){B=L;A=C;z=I}else{M=L;N=C;O=I;P=F;break}}}else{M=w;N=x;O=y;P=c}if((M|0)>(P|0)){Q=N;R=O}else{z=l<<1;b[N+z>>0]=((h[O+k>>0]|0)+2+(h[O+r>>0]|0)+(h[O+s>>0]|0)+(h[O+t>>0]|0)|0)>>>2;A=h[O+-1>>0]|0;B=O+1|0;a=b[B>>0]|0;F=A-(a&255)|0;I=h[O+i>>0]|0;C=b[O+j>>0]|0;L=I-(C&255)|0;G=(((F|0)>-1?F:0-F|0)|0)>(((L|0)>-1?L:0-L|0)|0);b[N+1>>0]=((G?I:A)+1+((G?C:a)&255)|0)>>>1;b[N+(2-z)>>0]=b[O>>0]|0;Q=N+e|0;R=B}B=0;do{b[Q+B>>0]=b[Q+(B-e)>>0]|0;b[Q+(q+B)>>0]=b[Q+(p+B)>>0]|0;B=B+1|0}while((B|0)!=(e|0));u=u+1|0;if((u|0)>=(f[m>>2]|0))break;else{d=Q+g|0;n=R+2|0;l=l^1;v=v^1}}return}function wpa(a){a=a|0;npa(a);cYc(a);return}function xpa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=((f[a+60>>2]|0)>>>3&511)+1|0;e=c<<1;g=f[a+52>>2]|0;h=g>>>1;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=f[a+120>>2]|0;m=f[a+116>>2]|0;n=(i&1|0)==0;o=f[b+4>>2]|0;if((i|0)>=(o|0))return;b=(f[a+76>>2]|0)+((Y(k,i+1|0)|0)<<1)+(c<<1)+2|0;p=(f[a+20>>2]|0)+((Y(i,h)|0)<<1)|0;q=a+124|0;a=f[q>>2]|0;r=(a|0)<1;s=(c|0)==3;t=Y(a,c)|0;u=t+1|0;v=t+-1|0;w=t+2|0;x=g|1;g=h+2|0;y=h+1|0;z=(c|0)==4;A=h<<1;B=A+2|0;C=A|1;D=h+3|0;E=b;b=i;i=p;p=n?m:(m|0)==0&1;m=n?l:0-l|0;while(1){l=i+(a<<1)|0;if(r){d[E+(u<<1)>>1]=0;d[E+(t<<1)>>1]=0;d[E+(v<<1)>>1]=0;if(s){F=-4;G=0;H=-3;I=-2}else{d[E+-6>>1]=0;d[E+-8>>1]=0;F=-2;G=-1;H=w;I=-5}d[E+(I<<1)>>1]=0;d[E+(H<<1)>>1]=G;d[E+(F<<1)>>1]=G;J=p;K=m}else{n=(p|0)!=0;if(n){L=i+2|0;M=((j[i+(h<<1)>>1]|0)+1+(j[i+(g<<1)>>1]|0)|0)>>>1;d[E+(0-m<<1)>>1]=((j[L>>1]|0)+1+(j[i+(x<<1)>>1]|0)|0)>>>1;d[E>>1]=d[i+(y<<1)>>1]|0;d[E+(m<<1)>>1]=M;if(z)d[E+4>>1]=-1;N=E+(c<<1)|0;O=L}else{N=E;O=i}L=(m|0)>0;M=l+-4|0;P=O>>>0>M>>>0;do if(s)if(L){if(P){Q=N;R=O;break}else{S=O;T=N}while(1){U=S+4|0;V=S+(B<<1)|0;W=S+(g<<1)|0;X=((j[S+2>>1]|0)+2+(j[S+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[S+(C<<1)>>1]|0)|0)>>>2;d[T+-2>>1]=((j[S>>1]|0)+2+(j[U>>1]|0)+(j[S+(A<<1)>>1]|0)+(j[V>>1]|0)|0)>>>2;d[T>>1]=X;X=S+(y<<1)|0;d[T+2>>1]=d[X>>1]|0;Z=((j[X>>1]|0)+1+(j[S+(D<<1)>>1]|0)|0)>>>1;d[T+4>>1]=((j[U>>1]|0)+1+(j[V>>1]|0)|0)>>>1;d[T+6>>1]=d[W>>1]|0;d[T+8>>1]=Z;Z=T+(e<<1)|0;if(U>>>0>M>>>0){Q=Z;R=U;break}else{S=U;T=Z}}}else{if(P){Q=N;R=O;break}else{_=O;$=N}while(1){Z=_+4|0;U=_+(B<<1)|0;W=_+(g<<1)|0;V=((j[_+2>>1]|0)+2+(j[_+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[_+(C<<1)>>1]|0)|0)>>>2;d[$+2>>1]=((j[_>>1]|0)+2+(j[Z>>1]|0)+(j[_+(A<<1)>>1]|0)+(j[U>>1]|0)|0)>>>2;d[$>>1]=V;V=_+(y<<1)|0;d[$+-2>>1]=d[V>>1]|0;X=((j[V>>1]|0)+1+(j[_+(D<<1)>>1]|0)|0)>>>1;d[$+8>>1]=((j[Z>>1]|0)+1+(j[U>>1]|0)|0)>>>1;d[$+6>>1]=d[W>>1]|0;d[$+4>>1]=X;X=$+(e<<1)|0;if(Z>>>0>M>>>0){Q=X;R=Z;break}else{_=Z;$=X}}}else if(L){if(P){Q=N;R=O;break}else{aa=O;ba=N}while(1){X=aa+4|0;Z=aa+(B<<1)|0;W=aa+(g<<1)|0;U=((j[aa+2>>1]|0)+2+(j[aa+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[aa+(C<<1)>>1]|0)|0)>>>2;d[ba+-2>>1]=((j[aa>>1]|0)+2+(j[X>>1]|0)+(j[aa+(A<<1)>>1]|0)+(j[Z>>1]|0)|0)>>>2;d[ba>>1]=U;U=aa+(y<<1)|0;d[ba+2>>1]=d[U>>1]|0;d[ba+4>>1]=-1;V=((j[U>>1]|0)+1+(j[aa+(D<<1)>>1]|0)|0)>>>1;d[ba+6>>1]=((j[X>>1]|0)+1+(j[Z>>1]|0)|0)>>>1;d[ba+8>>1]=d[W>>1]|0;d[ba+10>>1]=V;d[ba+12>>1]=-1;V=ba+(e<<1)|0;if(X>>>0>M>>>0){Q=V;R=X;break}else{aa=X;ba=V}}}else{if(P){Q=N;R=O;break}else{ca=O;da=N}while(1){V=ca+4|0;X=ca+(B<<1)|0;W=((j[ca>>1]|0)+2+(j[V>>1]|0)+(j[ca+(A<<1)>>1]|0)+(j[X>>1]|0)|0)>>>2;Z=ca+(g<<1)|0;U=((j[ca+2>>1]|0)+2+(j[ca+(h<<1)>>1]|0)+(j[Z>>1]|0)+(j[ca+(C<<1)>>1]|0)|0)>>>2;ea=ca+(y<<1)|0;d[da+-2>>1]=d[ea>>1]|0;d[da>>1]=U;d[da+2>>1]=W;d[da+4>>1]=-1;W=((j[V>>1]|0)+1+(j[X>>1]|0)|0)>>>1;d[da+6>>1]=((j[ea>>1]|0)+1+(j[ca+(D<<1)>>1]|0)|0)>>>1;d[da+8>>1]=d[Z>>1]|0;d[da+10>>1]=W;d[da+12>>1]=-1;W=da+(e<<1)|0;if(V>>>0>M>>>0){Q=W;R=V;break}else{ca=V;da=W}}}while(0);if(R>>>0<l>>>0?(M=((j[R+2>>1]|0)+2+(j[R+(h<<1)>>1]|0)+(j[R+(g<<1)>>1]|0)+(j[R+(C<<1)>>1]|0)|0)>>>2,d[Q+(0-m<<1)>>1]=((j[R>>1]|0)+2+(j[R+4>>1]|0)+(j[R+(A<<1)>>1]|0)+(j[R+(B<<1)>>1]|0)|0)>>>2,d[Q>>1]=M,d[Q+(m<<1)>>1]=d[R+(y<<1)>>1]|0,z):0)d[Q+4>>1]=-1;M=d[E+-2>>1]|0;P=d[E+2>>1]|0;L=d[E>>1]|0;W=Y(f[q>>2]|0,c)|0;V=W+-4|0;if(s){d[E+-8>>1]=M;d[E+-6>>1]=L;d[E+-4>>1]=P;fa=W;ga=d[E+(V<<1)>>1]|0;ha=1}else{d[E+-10>>1]=M;d[E+-8>>1]=L;d[E+-6>>1]=P;d[E+-4>>1]=d[E+4>>1]|0;P=d[E+(W+-5<<1)>>1]|0;d[E+(W<<1)>>1]=d[E+(V<<1)>>1]|0;fa=W+1|0;ga=P;ha=2}d[E+(W+-1<<1)>>1]=ga;d[E+(fa<<1)>>1]=d[E+(W+-3<<1)>>1]|0;d[E+(ha+W<<1)>>1]=d[E+(W+-2<<1)>>1]|0;J=(n^1)&1;K=0-m|0}b=b+1|0;if((b|0)>=(o|0))break;else{E=E+(k<<1)|0;i=i+(h<<1)|0;p=J;m=K}}return}function ypa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=53148;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;U$(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;U$(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function zpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53148;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function Apa(a){a=a|0;zpa(a);cYc(a);return}function Bpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=((f[a+60>>2]|0)>>>3&511)+1|0;e=d<<1;g=f[a+52>>2]|0;i=f[c>>2]|0;j=f[a+108>>2]|0;k=f[a+120>>2]|0;l=f[a+116>>2]|0;m=(i&1|0)==0;n=c+4|0;if((i|0)>=(f[n>>2]|0))return;c=(f[a+76>>2]|0)+(Y(i+1|0,j)|0)+d+1|0;o=a+124|0;p=(d|0)==3;q=g<<1;r=q|1;s=g+2|0;t=g+1|0;u=(d|0)==4;v=q+2|0;w=g+3|0;x=c;c=i;y=(f[a+20>>2]|0)+(Y(i,g)|0)|0;i=m?l:(l|0)==0&1;l=m?k:0-k|0;while(1){k=f[o>>2]|0;m=y+k|0;if((k|0)<1){a=x+((Y(k,d)|0)+1)|0;b[a>>0]=0;a=x+(Y(f[o>>2]|0,d)|0)|0;b[a>>0]=0;a=x+((Y(f[o>>2]|0,d)|0)+-1)|0;b[a>>0]=0;if(p){b[x+-2>>0]=0;z=-4;A=0;B=-3}else{b[x+-3>>0]=0;b[x+-4>>0]=0;b[x+-5>>0]=0;z=-2;A=-1;B=(Y(f[o>>2]|0,d)|0)+2|0}b[x+B>>0]=A;b[x+z>>0]=A;C=i;D=l}else{a=(i|0)!=0;if(a){k=y+1|0;E=((h[y+g>>0]|0)+1+(h[y+s>>0]|0)|0)>>>1;b[x+(0-l)>>0]=((h[k>>0]|0)+1+(h[y+r>>0]|0)|0)>>>1;b[x>>0]=b[y+t>>0]|0;b[x+l>>0]=E;if(u)b[x+2>>0]=-1;F=x+d|0;G=k}else{F=x;G=y}k=(l|0)>0;E=m+-2|0;H=G>>>0>E>>>0;do if(p)if(k){if(H){I=F;J=G;break}else{K=G;L=F}while(1){M=K+2|0;N=K+v|0;O=K+s|0;P=((h[K+1>>0]|0)+2+(h[K+g>>0]|0)+(h[O>>0]|0)+(h[K+r>>0]|0)|0)>>>2;b[L+-1>>0]=((h[K>>0]|0)+2+(h[M>>0]|0)+(h[K+q>>0]|0)+(h[N>>0]|0)|0)>>>2;b[L>>0]=P;P=K+t|0;b[L+1>>0]=b[P>>0]|0;Q=((h[P>>0]|0)+1+(h[K+w>>0]|0)|0)>>>1;b[L+2>>0]=((h[M>>0]|0)+1+(h[N>>0]|0)|0)>>>1;b[L+3>>0]=b[O>>0]|0;b[L+4>>0]=Q;Q=L+e|0;if(M>>>0>E>>>0){I=Q;J=M;break}else{K=M;L=Q}}}else{if(H){I=F;J=G;break}else{R=G;S=F}while(1){Q=R+2|0;M=R+v|0;O=R+s|0;N=((h[R+1>>0]|0)+2+(h[R+g>>0]|0)+(h[O>>0]|0)+(h[R+r>>0]|0)|0)>>>2;b[S+1>>0]=((h[R>>0]|0)+2+(h[Q>>0]|0)+(h[R+q>>0]|0)+(h[M>>0]|0)|0)>>>2;b[S>>0]=N;N=R+t|0;b[S+-1>>0]=b[N>>0]|0;P=((h[N>>0]|0)+1+(h[R+w>>0]|0)|0)>>>1;b[S+4>>0]=((h[Q>>0]|0)+1+(h[M>>0]|0)|0)>>>1;b[S+3>>0]=b[O>>0]|0;b[S+2>>0]=P;P=S+e|0;if(Q>>>0>E>>>0){I=P;J=Q;break}else{R=Q;S=P}}}else if(k){if(H){I=F;J=G;break}else{T=G;U=F}while(1){P=T+2|0;Q=T+v|0;O=T+s|0;M=((h[T+1>>0]|0)+2+(h[T+g>>0]|0)+(h[O>>0]|0)+(h[T+r>>0]|0)|0)>>>2;b[U+-1>>0]=((h[T>>0]|0)+2+(h[P>>0]|0)+(h[T+q>>0]|0)+(h[Q>>0]|0)|0)>>>2;b[U>>0]=M;M=T+t|0;b[U+1>>0]=b[M>>0]|0;b[U+2>>0]=-1;N=((h[M>>0]|0)+1+(h[T+w>>0]|0)|0)>>>1;b[U+3>>0]=((h[P>>0]|0)+1+(h[Q>>0]|0)|0)>>>1;b[U+4>>0]=b[O>>0]|0;b[U+5>>0]=N;b[U+6>>0]=-1;N=U+e|0;if(P>>>0>E>>>0){I=N;J=P;break}else{T=P;U=N}}}else{if(H){I=F;J=G;break}else{V=G;W=F}while(1){N=V+2|0;P=V+v|0;O=((h[V>>0]|0)+2+(h[N>>0]|0)+(h[V+q>>0]|0)+(h[P>>0]|0)|0)>>>2;Q=V+s|0;M=((h[V+1>>0]|0)+2+(h[V+g>>0]|0)+(h[Q>>0]|0)+(h[V+r>>0]|0)|0)>>>2;X=V+t|0;b[W+-1>>0]=b[X>>0]|0;b[W>>0]=M;b[W+1>>0]=O;b[W+2>>0]=-1;O=((h[N>>0]|0)+1+(h[P>>0]|0)|0)>>>1;b[W+3>>0]=((h[X>>0]|0)+1+(h[V+w>>0]|0)|0)>>>1;b[W+4>>0]=b[Q>>0]|0;b[W+5>>0]=O;b[W+6>>0]=-1;O=W+e|0;if(N>>>0>E>>>0){I=O;J=N;break}else{V=N;W=O}}}while(0);if(J>>>0<m>>>0?(E=((h[J+1>>0]|0)+2+(h[J+g>>0]|0)+(h[J+s>>0]|0)+(h[J+r>>0]|0)|0)>>>2,b[I+(0-l)>>0]=((h[J>>0]|0)+2+(h[J+2>>0]|0)+(h[J+q>>0]|0)+(h[J+v>>0]|0)|0)>>>2,b[I>>0]=E,b[I+l>>0]=b[J+t>>0]|0,u):0)b[I+2>>0]=-1;E=b[x+-1>>0]|0;H=b[x+1>>0]|0;k=b[x>>0]|0;if(p){b[x+-4>>0]=E;b[x+-3>>0]=k;b[x+-2>>0]=H;O=(f[o>>2]|0)*3|0;b[x+(O+-1)>>0]=b[x+(O+-4)>>0]|0;O=(f[o>>2]|0)*3|0;Z=O;_=O;$=1}else{b[x+-5>>0]=E;b[x+-4>>0]=k;b[x+-3>>0]=H;b[x+-2>>0]=b[x+2>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+(H+-1)>>0]=b[x+(H+-5)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+H>>0]=b[x+(H+-4)>>0]|0;H=Y(f[o>>2]|0,d)|0;Z=H;_=H+1|0;$=2}b[x+_>>0]=b[x+(Z+-3)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+(H+$)>>0]=b[x+(H+-2)>>0]|0;C=(a^1)&1;D=0-l|0}c=c+1|0;if((c|0)>=(f[n>>2]|0))break;else{x=x+j|0;y=y+g|0;i=C;l=D}}return}function Cpa(a){a=a|0;kpa(a);cYc(a);return}function Dpa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=f[a+52>>2]|0;e=c>>>1;g=(f[a+108>>2]|0)>>>1;h=f[a+132>>2]|0;i=f[a+136>>2]|0;k=f[a+116>>2]|0;l=f[b>>2]|0;m=(l&1|0)==0;n=f[b+4>>2]|0;if((l|0)>=(n|0))return;b=(f[a+76>>2]|0)+(g+1<<1)+((Y(l,g)|0)<<1)|0;o=(f[a+20>>2]|0)+((Y(l,e)|0)<<1)|0;p=f[a+124>>2]|0;a=(p|0)<1;q=c|1;c=e+2|0;r=e+1|0;s=e<<1;t=s+2|0;u=s|1;v=e+3|0;w=p+-1|0;x=b;b=l;l=o;o=m?k:(k|0)==0&1;k=m?i:h;y=m?h:i;while(1){i=l+(p<<1)|0;if(a){d[x+(p<<1)>>1]=0;d[x+-2>>1]=0;z=k;A=o;B=y}else{h=(o|0)!=0;if(h){m=l+2|0;C=Y((j[l+(q<<1)>>1]|0)+(j[m>>1]|0)|0,k)|0;D=Y((j[l+(c<<1)>>1]|0)+(j[l+(e<<1)>>1]|0)|0,y)|0;d[x>>1]=(C+16384+D+((j[l+(r<<1)>>1]|0)*19234|0)|0)>>>15;E=x+2|0;F=m}else{E=x;F=l}m=i+-4|0;if(F>>>0>m>>>0){G=E;H=F}else{D=y<<2;C=F;I=E;while(1){J=C+4|0;K=C+(t<<1)|0;L=Y((j[J>>1]|0)+(j[C>>1]|0)+(j[C+(s<<1)>>1]|0)+(j[K>>1]|0)|0,k)|0;M=C+(c<<1)|0;N=C+(r<<1)|0;O=(L+32768+(((j[C+(e<<1)>>1]|0)+(j[C+2>>1]|0)+(j[M>>1]|0)+(j[C+(u<<1)>>1]|0)|0)*9617|0)+(Y(D,j[N>>1]|0)|0)|0)>>>16&65535;d[I>>1]=O;O=Y((j[K>>1]|0)+(j[J>>1]|0)|0,k)|0;K=Y((j[C+(v<<1)>>1]|0)+(j[N>>1]|0)|0,y)|0;d[I+2>>1]=(O+16384+K+((j[M>>1]|0)*19234|0)|0)>>>15;M=I+4|0;if(J>>>0>m>>>0){G=M;H=J;break}else{C=J;I=M}}}if(H>>>0<i>>>0){I=Y((j[H+4>>1]|0)+(j[H>>1]|0)+(j[H+(s<<1)>>1]|0)+(j[H+(t<<1)>>1]|0)|0,k)|0;C=(I+32768+(((j[H+(e<<1)>>1]|0)+(j[H+2>>1]|0)+(j[H+(c<<1)>>1]|0)+(j[H+(u<<1)>>1]|0)|0)*9617|0)+(Y(y<<2,j[H+(r<<1)>>1]|0)|0)|0)>>>16&65535;d[G>>1]=C}d[x+-2>>1]=d[x>>1]|0;d[x+(p<<1)>>1]=d[x+(w<<1)>>1]|0;z=y;A=(h^1)&1;B=k}b=b+1|0;if((b|0)>=(n|0))break;else{x=x+(g<<1)|0;l=l+(e<<1)|0;o=A;k=z;y=B}}return}function Epa(a){a=a|0;ipa(a);cYc(a);return}function Fpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+52>>2]|0;e=f[a+108>>2]|0;g=f[a+132>>2]|0;i=f[a+136>>2]|0;j=f[a+116>>2]|0;k=f[c>>2]|0;l=(k&1|0)==0;m=c+4|0;if((k|0)>=(f[m>>2]|0))return;c=(f[a+76>>2]|0)+(e+1)+(Y(k,e)|0)|0;n=(f[a+20>>2]|0)+(Y(k,d)|0)|0;o=a+124|0;a=d<<1;p=a|1;q=d+2|0;r=d+1|0;s=a+2|0;t=d+3|0;u=c;c=k;k=n;n=l?j:(j|0)==0&1;j=l?i:g;v=l?g:i;while(1){i=f[o>>2]|0;g=k+i|0;if((i|0)<1){b[u+i>>0]=0;b[u+-1>>0]=0;w=j;x=n;y=v}else{i=(n|0)!=0;if(i){l=k+1|0;z=Y((h[k+p>>0]|0)+(h[l>>0]|0)|0,j)|0;A=Y((h[k+q>>0]|0)+(h[k+d>>0]|0)|0,v)|0;b[u>>0]=(z+16384+A+((h[k+r>>0]|0)*19234|0)|0)>>>15;B=u+1|0;C=l}else{B=u;C=k}l=g+-2|0;if(C>>>0>l>>>0){D=B;E=C}else{A=v<<2;z=C;F=B;while(1){G=z+2|0;H=z+s|0;I=Y((h[G>>0]|0)+(h[z>>0]|0)+(h[z+a>>0]|0)+(h[H>>0]|0)|0,j)|0;J=z+q|0;K=z+r|0;L=(I+32768+(((h[z+d>>0]|0)+(h[z+1>>0]|0)+(h[J>>0]|0)+(h[z+p>>0]|0)|0)*9617|0)+(Y(A,h[K>>0]|0)|0)|0)>>>16&255;b[F>>0]=L;L=Y((h[H>>0]|0)+(h[G>>0]|0)|0,j)|0;H=Y((h[z+t>>0]|0)+(h[K>>0]|0)|0,v)|0;b[F+1>>0]=(L+16384+H+((h[J>>0]|0)*19234|0)|0)>>>15;J=F+2|0;if(G>>>0>l>>>0){D=J;E=G;break}else{z=G;F=J}}}if(E>>>0<g>>>0){F=Y((h[E+2>>0]|0)+(h[E>>0]|0)+(h[E+a>>0]|0)+(h[E+s>>0]|0)|0,j)|0;z=(F+32768+(((h[E+d>>0]|0)+(h[E+1>>0]|0)+(h[E+q>>0]|0)+(h[E+p>>0]|0)|0)*9617|0)+(Y(v<<2,h[E+r>>0]|0)|0)|0)>>>16&255;b[D>>0]=z}b[u+-1>>0]=b[u>>0]|0;z=f[o>>2]|0;b[u+z>>0]=b[u+(z+-1)>>0]|0;w=v;x=(i^1)&1;y=j}c=c+1|0;if((c|0)>=(f[m>>2]|0))break;else{u=u+e|0;k=k+d|0;n=x;j=w;v=y}}return}function Gpa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+144|0;h=g+80|0;i=g+72|0;j=g+16|0;k=g;if(!e){l=$Xc(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=29;m=l;n=271443;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+29>>0]=0;vM(-215,h,271473,271481,883)}do if((eS(a)|0)==65536){l=f[a+4>>2]|0;f[h>>2]=f[l>>2];n=h+4|0;m=l+4|0;f[n>>2]=f[m>>2];o=h+8|0;f[o>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=o;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[l+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[n>>2]=0;U$(h,l);break}}else bS(h,a,-1);while(0);a=f[d>>2]|0;if((a|0)>=1?(l=f[d+4>>2]|0,(l|0)>=1):0){r=a;s=l}else{r=((f[h+12>>2]|0)+1|0)/2|0;s=((f[h+8>>2]|0)+1|0)/2|0}f[i>>2]=r;f[i+4>>2]=s;wS(c,i,f[h>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){i=f[c+4>>2]|0;f[j>>2]=f[i>>2];s=j+4|0;r=i+4|0;f[s>>2]=f[r>>2];l=j+8|0;f[l>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];a=j+16|0;f[a>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];d=f[i+36>>2]|0;f[j+36>>2]=d;f[j+40>>2]=l;l=j+48|0;n=j+44|0;f[n>>2]=l;f[l>>2]=0;f[j+52>>2]=0;if(d|0){l=d+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[r>>2]|0)<3){r=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[r>>2];f[l+4>>2]=f[r+4>>2];t=a;break}else{f[s>>2]=0;U$(j,i);t=a;break}}else{bS(j,c,-1);t=j+16|0}while(0);c=h+16|0;switch(f[h>>2]&7){case 0:{v=426;break}case 3:{v=427;break}case 2:{v=428;break}case 5:{v=429;break}case 6:{v=430;break}default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;vM(-210,k,271473,271481,919)}}Ti[v&511](h,j,e);e=j+36|0;v=f[e>>2]|0;if(v|0?(k=v+12|0,v=f[k>>2]|0,f[k>>2]=v+-1,(v|0)==1):0)V$(j);f[e>>2]=0;e=j+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[e>>2]|0)>0){t=f[j+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(j+48|0))wL(e);e=h+36|0;j=f[e>>2]|0;if(j|0?(v=j+12|0,j=f[v>>2]|0,f[v>>2]=j+-1,(j|0)==1):0)V$(h);f[e>>2]=0;e=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){c=f[h+40>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function Hpa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+30816|0;h=g+29752|0;i=g+15416|0;j=g+1080|0;k=g+16|0;l=g;m=a+16|0;if(!(f[m>>2]|0)){n=$Xc(16)|0;f[h>>2]=n;o=h+8|0;f[o>>2]=-2147483632;p=h+4|0;f[p>>2]=13;q=n;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+13|0;b[t>>0]=0;vM(-215,h,271554,271481,399)}v=f[a+4>>2]|0;if((v|0)<3)w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{x=f[a+40>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if((v|0)==0|(w|0)==0){n=$Xc(16)|0;f[h>>2]=n;o=h+8|0;f[o>>2]=-2147483632;p=h+4|0;f[p>>2]=13;q=n;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+13|0;b[t>>0]=0;vM(-215,h,271554,271481,399)}t=f[a+40>>2]|0;n=f[t+4>>2]|0;r=f[t>>2]|0;t=f[c+40>>2]|0;q=f[t+4>>2]|0;s=f[t>>2]|0;t=(f[a>>2]|0)>>>3;p=(t&511)+1|0;o=Y(p,q)|0;w=o+15&-16;v=(w*5|0)+16|0;z=h+8|0;f[h>>2]=z;y=h+4|0;f[y>>2]=v;if(v>>>0>264){x=bYc(v>>>0>1073741823?-1:v<<2)|0;f[h>>2]=x;B=x}else B=z;x=B+15&-16;B=k+8|0;f[k>>2]=B;v=k+4|0;f[v>>2]=o;if(o>>>0>264){A=bYc(o>>>0>1073741823?-1:o<<2)|0;f[k>>2]=A;C=A}else C=B;if(!((n|0)>0&(r|0)>0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(144)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483504;F=l+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,l,271554,271481,414)}A=(q<<1)-n|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(144)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483504;F=l+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,l,271554,271481,414)}A=(s<<1)-r|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(144)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483504;F=l+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,l,271554,271481,414)}l=((n+-3|0)/2|0)+1|0;G=(q|0)<(l|0)?q:l;l=(G<<1)+-2|0;q=0;do{D=Y(qR(q+-2|0,n,e)|0,p)|0;F=Y(qR(l+q|0,n,e)|0,p)|0;E=Y(q,p)|0;A=0;do{H=A+E|0;f[i+(H<<2)>>2]=A+D;f[j+(H<<2)>>2]=A+F;A=A+1|0}while((A|0)!=(p|0));q=q+1|0}while((q|0)<7);q=Y(p,G)|0;G=(o|0)>0;if(G){n=p<<1;l=0;do{A=(Y(n,(l|0)/(p|0)|0)|0)+((l|0)%(p|0)|0)|0;f[C+(l<<2)>>2]=A;l=l+1|0}while((l|0)!=(o|0))}if((s|0)>0){l=c+16|0;n=c+44|0;c=a+44|0;a=t&65535;t=p<<1;A=p*3|0;F=p<<2;D=-2;E=0;while(1){H=(f[l>>2]|0)+(Y(f[f[n>>2]>>2]|0,E)|0)|0;I=E<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=x+((Y((L+2|0)%5|0,w)|0)<<2)|0;N=qR(L,r,e)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((d[O+(f[P+(R+A<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+p<<2)>>2]<<1)>>1]|0)<<2)+((d[O+(f[P+(R+t<<2)>>2]<<1)>>1]|0)*6|0)+(d[O+(f[P+(R<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+F<<2)>>2]<<1)>>1]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(o|0))break;switch(a&511){case 0:{if((S|0)<(q|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(d[O+(T+-2<<1)>>1]|0)+((d[O+(T<<1)>>1]|0)*6|0)+((d[O+((T|1)<<1)>>1]|0)+(d[O+(T+-1<<1)>>1]|0)<<2)+(d[O+(T+2<<1)>>1]|0);R=R+1|0}while((R|0)<(q|0));U=q}else U=S;break}case 2:{if((S|0)<(q|0)){R=S;while(1){T=O+(R<<1<<1)|0;V=(d[T+-10>>1]|0)+((d[T+2>>1]|0)*6|0)+((d[T+8>>1]|0)+(d[T+-4>>1]|0)<<2)+(d[T+14>>1]|0)|0;W=(d[T+-8>>1]|0)+((d[T+4>>1]|0)*6|0)+((d[T+10>>1]|0)+(d[T+-2>>1]|0)<<2)+(d[T+16>>1]|0)|0;f[M+(R<<2)>>2]=(d[T+-12>>1]|0)+((d[T>>1]|0)*6|0)+((d[T+6>>1]|0)+(d[T+-6>>1]|0)<<2)+(d[T+12>>1]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(q|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(q|0)){R=S;while(1){W=O+(R<<1<<1)|0;V=(d[W+-14>>1]|0)+((d[W+2>>1]|0)*6|0)+((d[W+10>>1]|0)+(d[W+-6>>1]|0)<<2)+(d[W+18>>1]|0)|0;f[M+(R<<2)>>2]=(d[W+-16>>1]|0)+((d[W>>1]|0)*6|0)+((d[W+8>>1]|0)+(d[W+-8>>1]|0)<<2)+(d[W+16>>1]|0);f[M+(R+1<<2)>>2]=V;V=(d[W+-10>>1]|0)+((d[W+6>>1]|0)*6|0)+((d[W+14>>1]|0)+(d[W+-2>>1]|0)<<2)+(d[W+22>>1]|0)|0;f[M+(R+2<<2)>>2]=(d[W+-12>>1]|0)+((d[W+4>>1]|0)*6|0)+((d[W+12>>1]|0)+(d[W+-4>>1]|0)<<2)+(d[W+20>>1]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(q|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(q|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(d[O+(V-t<<1)>>1]|0)+((d[O+(V<<1)>>1]|0)*6|0)+((d[O+(V+p<<1)>>1]|0)+(d[O+(V-p<<1)>>1]|0)<<2)+(d[O+(V+t<<1)>>1]|0);R=R+1|0}while((R|0)<(q|0));U=q}else U=S}N=o;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=x+((Y((I|0)%5|0,w)|0)<<2)|0;Q=x+((Y((I|1|0)%5|0,w)|0)<<2)|0;P=x+((Y((J|0)%5|0,w)|0)<<2)|0;N=x+((Y((I+3|0)%5|0,w)|0)<<2)|0;O=x+((Y((I+4|0)%5|0,w)|0)<<2)|0;if(G){M=0;do{d[H+(M<<1)>>1]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(o|0))}E=E+1|0;if((E|0)>=(s|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(B|0)){if(K|0)dYc(K);f[k>>2]=B;f[v>>2]=264}v=f[h>>2]|0;if((v|0)==(z|0)){u=g;return}if(v|0)dYc(v);f[h>>2]=z;f[y>>2]=264;u=g;return}function Ipa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+30816|0;h=g+29752|0;i=g+15416|0;k=g+1080|0;l=g+16|0;m=g;n=a+16|0;if(!(f[n>>2]|0)){o=$Xc(16)|0;f[h>>2]=o;p=h+8|0;f[p>>2]=-2147483632;q=h+4|0;f[q>>2]=13;r=o;s=371335;t=r+13|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));v=o+13|0;b[v>>0]=0;vM(-215,h,271554,271481,399)}w=f[a+4>>2]|0;if((w|0)<3)x=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{y=f[a+40>>2]|0;z=0;A=1;while(1){B=Y(f[y+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(w|0)){x=B;break}else A=B}}if((w|0)==0|(x|0)==0){o=$Xc(16)|0;f[h>>2]=o;p=h+8|0;f[p>>2]=-2147483632;q=h+4|0;f[q>>2]=13;r=o;s=371335;t=r+13|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));v=o+13|0;b[v>>0]=0;vM(-215,h,271554,271481,399)}v=f[a+40>>2]|0;o=f[v+4>>2]|0;s=f[v>>2]|0;v=f[c+40>>2]|0;r=f[v+4>>2]|0;t=f[v>>2]|0;v=(f[a>>2]|0)>>>3;q=(v&511)+1|0;p=Y(q,r)|0;x=p+15&-16;w=(x*5|0)+16|0;A=h+8|0;f[h>>2]=A;z=h+4|0;f[z>>2]=w;if(w>>>0>264){y=bYc(w>>>0>1073741823?-1:w<<2)|0;f[h>>2]=y;C=y}else C=A;y=C+15&-16;C=l+8|0;f[l>>2]=C;w=l+4|0;f[w>>2]=p;if(p>>>0>264){B=bYc(p>>>0>1073741823?-1:p<<2)|0;f[l>>2]=B;D=B}else D=C;if(!((o|0)>0&(s|0)>0)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;E=$Xc(144)|0;f[m>>2]=E;F=m+8|0;f[F>>2]=-2147483504;G=m+4|0;f[G>>2]=129;o1c(E|0,271563,129)|0;H=E+129|0;b[H>>0]=0;vM(-215,m,271554,271481,414)}B=(r<<1)-o|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;E=$Xc(144)|0;f[m>>2]=E;F=m+8|0;f[F>>2]=-2147483504;G=m+4|0;f[G>>2]=129;o1c(E|0,271563,129)|0;H=E+129|0;b[H>>0]=0;vM(-215,m,271554,271481,414)}B=(t<<1)-s|0;if((((B|0)>-1?B:0-B|0)|0)>=3){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;E=$Xc(144)|0;f[m>>2]=E;F=m+8|0;f[F>>2]=-2147483504;G=m+4|0;f[G>>2]=129;o1c(E|0,271563,129)|0;H=E+129|0;b[H>>0]=0;vM(-215,m,271554,271481,414)}m=((o+-3|0)/2|0)+1|0;H=(r|0)<(m|0)?r:m;m=(H<<1)+-2|0;r=0;do{E=Y(qR(r+-2|0,o,e)|0,q)|0;G=Y(qR(m+r|0,o,e)|0,q)|0;F=Y(r,q)|0;B=0;do{I=B+F|0;f[i+(I<<2)>>2]=B+E;f[k+(I<<2)>>2]=B+G;B=B+1|0}while((B|0)!=(q|0));r=r+1|0}while((r|0)<7);r=Y(q,H)|0;H=(p|0)>0;if(H){o=q<<1;m=0;do{B=(Y(o,(m|0)/(q|0)|0)|0)+((m|0)%(q|0)|0)|0;f[D+(m<<2)>>2]=B;m=m+1|0}while((m|0)!=(p|0))}if((t|0)>0){m=c+16|0;o=c+44|0;c=a+44|0;a=v&65535;v=q<<1;B=q*3|0;G=q<<2;E=-2;F=0;while(1){I=(f[m>>2]|0)+(Y(f[f[o>>2]>>2]|0,F)|0)|0;J=F<<1;K=J+2|0;if((E|0)>(K|0))L=E;else{M=E;while(1){N=y+((Y((M+2|0)%5|0,x)|0)<<2)|0;O=qR(M,s,e)|0;P=(f[n>>2]|0)+(Y(f[f[c>>2]>>2]|0,O)|0)|0;O=q;Q=i;R=0;while(1){if((R|0)<(O|0)){S=R;do{f[N+(S<<2)>>2]=((j[P+(f[Q+(S+B<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+q<<2)>>2]<<1)>>1]|0)<<2)+((j[P+(f[Q+(S+v<<2)>>2]<<1)>>1]|0)*6|0)+(j[P+(f[Q+(S<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+G<<2)>>2]<<1)>>1]|0);S=S+1|0}while((S|0)!=(O|0));T=O}else T=R;if((T|0)==(p|0))break;switch(a&511){case 0:{if((T|0)<(r|0)){S=T;do{U=S<<1;f[N+(S<<2)>>2]=(j[P+(U+-2<<1)>>1]|0)+((j[P+(U<<1)>>1]|0)*6|0)+((j[P+((U|1)<<1)>>1]|0)+(j[P+(U+-1<<1)>>1]|0)<<2)+(j[P+(U+2<<1)>>1]|0);S=S+1|0}while((S|0)<(r|0));V=r}else V=T;break}case 2:{if((T|0)<(r|0)){S=T;while(1){U=P+(S<<1<<1)|0;W=(j[U+-10>>1]|0)+((j[U+2>>1]|0)*6|0)+((j[U+8>>1]|0)+(j[U+-4>>1]|0)<<2)+(j[U+14>>1]|0)|0;X=(j[U+-8>>1]|0)+((j[U+4>>1]|0)*6|0)+((j[U+10>>1]|0)+(j[U+-2>>1]|0)<<2)+(j[U+16>>1]|0)|0;f[N+(S<<2)>>2]=(j[U+-12>>1]|0)+((j[U>>1]|0)*6|0)+((j[U+6>>1]|0)+(j[U+-6>>1]|0)<<2)+(j[U+12>>1]|0);f[N+(S+1<<2)>>2]=W;f[N+(S+2<<2)>>2]=X;X=S+3|0;if((X|0)<(r|0))S=X;else{V=X;break}}}else V=T;break}case 3:{if((T|0)<(r|0)){S=T;while(1){X=P+(S<<1<<1)|0;W=(j[X+-14>>1]|0)+((j[X+2>>1]|0)*6|0)+((j[X+10>>1]|0)+(j[X+-6>>1]|0)<<2)+(j[X+18>>1]|0)|0;f[N+(S<<2)>>2]=(j[X+-16>>1]|0)+((j[X>>1]|0)*6|0)+((j[X+8>>1]|0)+(j[X+-8>>1]|0)<<2)+(j[X+16>>1]|0);f[N+(S+1<<2)>>2]=W;W=(j[X+-10>>1]|0)+((j[X+6>>1]|0)*6|0)+((j[X+14>>1]|0)+(j[X+-2>>1]|0)<<2)+(j[X+22>>1]|0)|0;f[N+(S+2<<2)>>2]=(j[X+-12>>1]|0)+((j[X+4>>1]|0)*6|0)+((j[X+12>>1]|0)+(j[X+-4>>1]|0)<<2)+(j[X+20>>1]|0);f[N+(S+3<<2)>>2]=W;W=S+4|0;if((W|0)<(r|0))S=W;else{V=W;break}}}else V=T;break}default:if((T|0)<(r|0)){S=T;do{W=f[D+(S<<2)>>2]|0;f[N+(S<<2)>>2]=(j[P+(W-v<<1)>>1]|0)+((j[P+(W<<1)>>1]|0)*6|0)+((j[P+(W+q<<1)>>1]|0)+(j[P+(W-q<<1)>>1]|0)<<2)+(j[P+(W+v<<1)>>1]|0);S=S+1|0}while((S|0)<(r|0));V=r}else V=T}O=p;Q=k+(0-V<<2)|0;R=V}R=M+1|0;if((M|0)<(K|0))M=R;else{L=R;break}}}M=y+((Y((J|0)%5|0,x)|0)<<2)|0;R=y+((Y((J|1|0)%5|0,x)|0)<<2)|0;Q=y+((Y((K|0)%5|0,x)|0)<<2)|0;O=y+((Y((J+3|0)%5|0,x)|0)<<2)|0;P=y+((Y((J+4|0)%5|0,x)|0)<<2)|0;if(H){N=0;do{d[I+(N<<1)>>1]=(((f[Q+(N<<2)>>2]|0)*6|0)+128+(f[M+(N<<2)>>2]|0)+((f[O+(N<<2)>>2]|0)+(f[R+(N<<2)>>2]|0)<<2)+(f[P+(N<<2)>>2]|0)|0)>>>8;N=N+1|0}while((N|0)!=(p|0))}F=F+1|0;if((F|0)>=(t|0))break;else E=L}}L=f[l>>2]|0;if((L|0)!=(C|0)){if(L|0)dYc(L);f[l>>2]=C;f[w>>2]=264}w=f[h>>2]|0;if((w|0)==(A|0)){u=g;return}if(w|0)dYc(w);f[h>>2]=A;f[z>>2]=264;u=g;return}function Jpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30816|0;g=e+29752|0;h=e+15416|0;i=e+1080|0;j=e+16|0;k=e;l=a+16|0;if(!(f[l>>2]|0)){m=$Xc(16)|0;f[g>>2]=m;o=g+8|0;f[o>>2]=-2147483632;p=g+4|0;f[p>>2]=13;q=m;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=m+13|0;b[t>>0]=0;vM(-215,g,271554,271481,399)}v=f[a+4>>2]|0;if((v|0)<3)w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{x=f[a+40>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if((v|0)==0|(w|0)==0){m=$Xc(16)|0;f[g>>2]=m;o=g+8|0;f[o>>2]=-2147483632;p=g+4|0;f[p>>2]=13;q=m;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=m+13|0;b[t>>0]=0;vM(-215,g,271554,271481,399)}t=f[a+40>>2]|0;m=f[t+4>>2]|0;r=f[t>>2]|0;t=f[c+40>>2]|0;q=f[t+4>>2]|0;s=f[t>>2]|0;t=(f[a>>2]|0)>>>3;p=(t&511)+1|0;o=Y(p,q)|0;w=o+15&-16;v=(w*5|0)+16|0;z=g+8|0;f[g>>2]=z;y=g+4|0;f[y>>2]=v;if(v>>>0>264){x=bYc(v>>>0>1073741823?-1:v<<2)|0;f[g>>2]=x;B=x}else B=z;x=B+15&-16;B=j+8|0;f[j>>2]=B;v=j+4|0;f[v>>2]=o;if(o>>>0>264){A=bYc(o>>>0>1073741823?-1:o<<2)|0;f[j>>2]=A;C=A}else C=B;if(!((m|0)>0&(r|0)>0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(144)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483504;F=k+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,k,271554,271481,414)}A=(q<<1)-m|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(144)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483504;F=k+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,k,271554,271481,414)}A=(s<<1)-r|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(144)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483504;F=k+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,k,271554,271481,414)}k=((m+-3|0)/2|0)+1|0;G=(q|0)<(k|0)?q:k;k=(G<<1)+-2|0;q=0;do{D=Y(qR(q+-2|0,m,d)|0,p)|0;F=Y(qR(k+q|0,m,d)|0,p)|0;E=Y(q,p)|0;A=0;do{H=A+E|0;f[h+(H<<2)>>2]=A+D;f[i+(H<<2)>>2]=A+F;A=A+1|0}while((A|0)!=(p|0));q=q+1|0}while((q|0)<7);q=Y(p,G)|0;G=(o|0)>0;if(G){m=p<<1;k=0;do{A=(Y(m,(k|0)/(p|0)|0)|0)+((k|0)%(p|0)|0)|0;f[C+(k<<2)>>2]=A;k=k+1|0}while((k|0)!=(o|0))}if((s|0)>0){k=c+16|0;m=c+44|0;c=a+44|0;a=t&65535;t=p<<1;A=p*3|0;F=p<<2;D=-2;E=0;while(1){H=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,E)|0)|0;I=E<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=x+((Y((L+2|0)%5|0,w)|0)<<2)|0;N=qR(L,r,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{n[M+(R<<2)>>2]=+n[O+(f[P+(R<<2)>>2]<<2)>>2]+(+n[O+(f[P+(R+t<<2)>>2]<<2)>>2]*6.0+(+n[O+(f[P+(R+p<<2)>>2]<<2)>>2]+ +n[O+(f[P+(R+A<<2)>>2]<<2)>>2])*4.0)+ +n[O+(f[P+(R+F<<2)>>2]<<2)>>2];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(o|0))break;switch(a&511){case 0:{if((S|0)<(q|0)){R=S;do{T=R<<1;n[M+(R<<2)>>2]=+n[O+(T+2<<2)>>2]+(+n[O+(T+-2<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T+-1<<2)>>2]+ +n[O+((T|1)<<2)>>2])*4.0));R=R+1|0}while((R|0)<(q|0));U=q}else U=S;break}case 2:{if((S|0)<(q|0)){R=S;while(1){T=O+(R<<1<<2)|0;V=+n[T+28>>2]+(+n[T+-20>>2]+(+n[T+4>>2]*6.0+(+n[T+-8>>2]+ +n[T+16>>2])*4.0));W=+n[T+32>>2]+(+n[T+-16>>2]+(+n[T+8>>2]*6.0+(+n[T+-4>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+24>>2]+(+n[T+-24>>2]+(+n[T>>2]*6.0+(+n[T+-12>>2]+ +n[T+12>>2])*4.0));n[M+(R+1<<2)>>2]=V;n[M+(R+2<<2)>>2]=W;T=R+3|0;if((T|0)<(q|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(q|0)){R=S;while(1){T=O+(R<<1<<2)|0;W=+n[T+36>>2]+(+n[T+-28>>2]+(+n[T+4>>2]*6.0+(+n[T+-12>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+32>>2]+(+n[T+-32>>2]+(+n[T>>2]*6.0+(+n[T+-16>>2]+ +n[T+16>>2])*4.0));n[M+(R+1<<2)>>2]=W;W=+n[T+44>>2]+(+n[T+-20>>2]+(+n[T+12>>2]*6.0+(+n[T+-4>>2]+ +n[T+28>>2])*4.0));n[M+(R+2<<2)>>2]=+n[T+40>>2]+(+n[T+-24>>2]+(+n[T+8>>2]*6.0+(+n[T+-8>>2]+ +n[T+24>>2])*4.0));n[M+(R+3<<2)>>2]=W;T=R+4|0;if((T|0)<(q|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(q|0)){R=S;do{T=f[C+(R<<2)>>2]|0;n[M+(R<<2)>>2]=+n[O+(T+t<<2)>>2]+(+n[O+(T-t<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T-p<<2)>>2]+ +n[O+(T+p<<2)>>2])*4.0));R=R+1|0}while((R|0)<(q|0));U=q}else U=S}N=o;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=x+((Y((I|0)%5|0,w)|0)<<2)|0;Q=x+((Y((I|1|0)%5|0,w)|0)<<2)|0;P=x+((Y((J|0)%5|0,w)|0)<<2)|0;N=x+((Y((I+3|0)%5|0,w)|0)<<2)|0;O=x+((Y((I+4|0)%5|0,w)|0)<<2)|0;if(G){M=0;do{n[H+(M<<2)>>2]=(+n[O+(M<<2)>>2]+(+n[L+(M<<2)>>2]+(+n[P+(M<<2)>>2]*6.0+(+n[Q+(M<<2)>>2]+ +n[N+(M<<2)>>2])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(o|0))}E=E+1|0;if((E|0)>=(s|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(B|0)){if(K|0)dYc(K);f[j>>2]=B;f[v>>2]=264}v=f[g>>2]|0;if((v|0)==(z|0)){u=e;return}if(v|0)dYc(v);f[g>>2]=z;f[y>>2]=264;u=e;return}function Kpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30848|0;g=e;h=e+16512|0;i=e+2176|0;j=e+1112|0;k=e+1096|0;l=a+16|0;if(!(f[l>>2]|0)){m=$Xc(16)|0;f[g>>2]=m;n=g+8|0;f[n>>2]=-2147483632;o=g+4|0;f[o>>2]=13;q=m;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=m+13|0;b[t>>0]=0;vM(-215,g,271554,271481,399)}v=f[a+4>>2]|0;if((v|0)<3)w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{x=f[a+40>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if((v|0)==0|(w|0)==0){m=$Xc(16)|0;f[g>>2]=m;n=g+8|0;f[n>>2]=-2147483632;o=g+4|0;f[o>>2]=13;q=m;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=m+13|0;b[t>>0]=0;vM(-215,g,271554,271481,399)}t=f[a+40>>2]|0;m=f[t+4>>2]|0;r=f[t>>2]|0;t=f[c+40>>2]|0;q=f[t+4>>2]|0;s=f[t>>2]|0;t=(f[a>>2]|0)>>>3;o=(t&511)+1|0;n=Y(o,q)|0;w=n+15&-16;v=(w*5|0)+16|0;z=g+8|0;f[g>>2]=z;y=g+4|0;f[y>>2]=v;if(v>>>0>136){x=bYc(v>>>0>536870911?-1:v<<3)|0;f[g>>2]=x;B=x}else B=z;x=B+15&-16;B=j+8|0;f[j>>2]=B;v=j+4|0;f[v>>2]=n;if(n>>>0>264){A=bYc(n>>>0>1073741823?-1:n<<2)|0;f[j>>2]=A;C=A}else C=B;if(!((m|0)>0&(r|0)>0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(144)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483504;F=k+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,k,271554,271481,414)}A=(q<<1)-m|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(144)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483504;F=k+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,k,271554,271481,414)}A=(s<<1)-r|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;D=$Xc(144)|0;f[k>>2]=D;E=k+8|0;f[E>>2]=-2147483504;F=k+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,k,271554,271481,414)}k=((m+-3|0)/2|0)+1|0;G=(q|0)<(k|0)?q:k;k=(G<<1)+-2|0;q=0;do{D=Y(qR(q+-2|0,m,d)|0,o)|0;F=Y(qR(k+q|0,m,d)|0,o)|0;E=Y(q,o)|0;A=0;do{H=A+E|0;f[h+(H<<2)>>2]=A+D;f[i+(H<<2)>>2]=A+F;A=A+1|0}while((A|0)!=(o|0));q=q+1|0}while((q|0)<7);q=Y(o,G)|0;G=(n|0)>0;if(G){m=o<<1;k=0;do{A=(Y(m,(k|0)/(o|0)|0)|0)+((k|0)%(o|0)|0)|0;f[C+(k<<2)>>2]=A;k=k+1|0}while((k|0)!=(n|0))}if((s|0)>0){k=c+16|0;m=c+44|0;c=a+44|0;a=t&65535;t=o<<1;A=o*3|0;F=o<<2;D=-2;E=0;while(1){H=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,E)|0)|0;I=E<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=x+((Y((L+2|0)%5|0,w)|0)<<3)|0;N=qR(L,r,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=o;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{p[M+(R<<3)>>3]=+p[O+(f[P+(R<<2)>>2]<<3)>>3]+(+p[O+(f[P+(R+t<<2)>>2]<<3)>>3]*6.0+(+p[O+(f[P+(R+o<<2)>>2]<<3)>>3]+ +p[O+(f[P+(R+A<<2)>>2]<<3)>>3])*4.0)+ +p[O+(f[P+(R+F<<2)>>2]<<3)>>3];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(n|0))break;switch(a&511){case 0:{if((S|0)<(q|0)){R=S;do{T=R<<1;p[M+(R<<3)>>3]=+p[O+(T+2<<3)>>3]+(+p[O+(T+-2<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T+-1<<3)>>3]+ +p[O+((T|1)<<3)>>3])*4.0));R=R+1|0}while((R|0)<(q|0));U=q}else U=S;break}case 2:{if((S|0)<(q|0)){R=S;while(1){T=O+(R<<1<<3)|0;V=+p[T+56>>3]+(+p[T+-40>>3]+(+p[T+8>>3]*6.0+(+p[T+-16>>3]+ +p[T+32>>3])*4.0));W=+p[T+64>>3]+(+p[T+-32>>3]+(+p[T+16>>3]*6.0+(+p[T+-8>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+48>>3]+(+p[T+-48>>3]+(+p[T>>3]*6.0+(+p[T+-24>>3]+ +p[T+24>>3])*4.0));p[M+(R+1<<3)>>3]=V;p[M+(R+2<<3)>>3]=W;T=R+3|0;if((T|0)<(q|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(q|0)){R=S;while(1){T=O+(R<<1<<3)|0;W=+p[T+72>>3]+(+p[T+-56>>3]+(+p[T+8>>3]*6.0+(+p[T+-24>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+64>>3]+(+p[T+-64>>3]+(+p[T>>3]*6.0+(+p[T+-32>>3]+ +p[T+32>>3])*4.0));p[M+(R+1<<3)>>3]=W;W=+p[T+88>>3]+(+p[T+-40>>3]+(+p[T+24>>3]*6.0+(+p[T+-8>>3]+ +p[T+56>>3])*4.0));p[M+(R+2<<3)>>3]=+p[T+80>>3]+(+p[T+-48>>3]+(+p[T+16>>3]*6.0+(+p[T+-16>>3]+ +p[T+48>>3])*4.0));p[M+(R+3<<3)>>3]=W;T=R+4|0;if((T|0)<(q|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(q|0)){R=S;do{T=f[C+(R<<2)>>2]|0;p[M+(R<<3)>>3]=+p[O+(T+t<<3)>>3]+(+p[O+(T-t<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T-o<<3)>>3]+ +p[O+(T+o<<3)>>3])*4.0));R=R+1|0}while((R|0)<(q|0));U=q}else U=S}N=n;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=x+((Y((I|0)%5|0,w)|0)<<3)|0;Q=x+((Y((I|1|0)%5|0,w)|0)<<3)|0;P=x+((Y((J|0)%5|0,w)|0)<<3)|0;N=x+((Y((I+3|0)%5|0,w)|0)<<3)|0;O=x+((Y((I+4|0)%5|0,w)|0)<<3)|0;if(G){M=0;do{p[H+(M<<3)>>3]=(+p[O+(M<<3)>>3]+(+p[L+(M<<3)>>3]+(+p[P+(M<<3)>>3]*6.0+(+p[Q+(M<<3)>>3]+ +p[N+(M<<3)>>3])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(n|0))}E=E+1|0;if((E|0)>=(s|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(B|0)){if(K|0)dYc(K);f[j>>2]=B;f[v>>2]=264}v=f[g>>2]|0;if((v|0)==(z|0)){u=e;return}if(v|0)dYc(v);f[g>>2]=z;f[y>>2]=136;u=e;return}function Lpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+30816|0;g=e+29752|0;i=e+15416|0;j=e+1080|0;k=e+16|0;l=e;m=a+16|0;if(!(f[m>>2]|0)){n=$Xc(16)|0;f[g>>2]=n;o=g+8|0;f[o>>2]=-2147483632;p=g+4|0;f[p>>2]=13;q=n;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+13|0;b[t>>0]=0;vM(-215,g,271554,271481,399)}v=f[a+4>>2]|0;if((v|0)<3)w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{x=f[a+40>>2]|0;y=0;z=1;while(1){A=Y(f[x+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(v|0)){w=A;break}else z=A}}if((v|0)==0|(w|0)==0){n=$Xc(16)|0;f[g>>2]=n;o=g+8|0;f[o>>2]=-2147483632;p=g+4|0;f[p>>2]=13;q=n;r=371335;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=n+13|0;b[t>>0]=0;vM(-215,g,271554,271481,399)}t=f[a+40>>2]|0;n=f[t+4>>2]|0;r=f[t>>2]|0;t=f[c+40>>2]|0;q=f[t+4>>2]|0;s=f[t>>2]|0;t=(f[a>>2]|0)>>>3;p=(t&511)+1|0;o=Y(p,q)|0;w=o+15&-16;v=(w*5|0)+16|0;z=g+8|0;f[g>>2]=z;y=g+4|0;f[y>>2]=v;if(v>>>0>264){x=bYc(v>>>0>1073741823?-1:v<<2)|0;f[g>>2]=x;B=x}else B=z;x=B+15&-16;B=k+8|0;f[k>>2]=B;v=k+4|0;f[v>>2]=o;if(o>>>0>264){A=bYc(o>>>0>1073741823?-1:o<<2)|0;f[k>>2]=A;C=A}else C=B;if(!((n|0)>0&(r|0)>0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(144)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483504;F=l+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,l,271554,271481,414)}A=(q<<1)-n|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(144)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483504;F=l+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,l,271554,271481,414)}A=(s<<1)-r|0;if((((A|0)>-1?A:0-A|0)|0)>=3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;D=$Xc(144)|0;f[l>>2]=D;E=l+8|0;f[E>>2]=-2147483504;F=l+4|0;f[F>>2]=129;o1c(D|0,271563,129)|0;G=D+129|0;b[G>>0]=0;vM(-215,l,271554,271481,414)}l=((n+-3|0)/2|0)+1|0;G=(q|0)<(l|0)?q:l;l=(G<<1)+-2|0;q=0;do{D=Y(qR(q+-2|0,n,d)|0,p)|0;F=Y(qR(l+q|0,n,d)|0,p)|0;E=Y(q,p)|0;A=0;do{H=A+E|0;f[i+(H<<2)>>2]=A+D;f[j+(H<<2)>>2]=A+F;A=A+1|0}while((A|0)!=(p|0));q=q+1|0}while((q|0)<7);q=Y(p,G)|0;G=(o|0)>0;if(G){n=p<<1;l=0;do{A=(Y(n,(l|0)/(p|0)|0)|0)+((l|0)%(p|0)|0)|0;f[C+(l<<2)>>2]=A;l=l+1|0}while((l|0)!=(o|0))}if((s|0)>0){l=c+16|0;n=c+44|0;c=a+44|0;a=t&65535;t=p<<1;A=p*3|0;F=p<<2;D=-2;E=0;while(1){H=(f[l>>2]|0)+(Y(f[f[n>>2]>>2]|0,E)|0)|0;I=E<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=x+((Y((L+2|0)%5|0,w)|0)<<2)|0;N=qR(L,r,d)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((h[O+(f[P+(R+A<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+p<<2)>>2]|0)>>0]|0)<<2)+((h[O+(f[P+(R+t<<2)>>2]|0)>>0]|0)*6|0)+(h[O+(f[P+(R<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+F<<2)>>2]|0)>>0]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(o|0))break;switch(a&511){case 0:{if((S|0)<(q|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(h[O+(T+-2)>>0]|0)+((h[O+T>>0]|0)*6|0)+((h[O+(T|1)>>0]|0)+(h[O+(T+-1)>>0]|0)<<2)+(h[O+(T+2)>>0]|0);R=R+1|0}while((R|0)<(q|0));U=q}else U=S;break}case 2:{if((S|0)<(q|0)){R=S;while(1){T=O+(R<<1)|0;V=(h[T+-5>>0]|0)+((h[T+1>>0]|0)*6|0)+((h[T+4>>0]|0)+(h[T+-2>>0]|0)<<2)+(h[T+7>>0]|0)|0;W=(h[T+-4>>0]|0)+((h[T+2>>0]|0)*6|0)+((h[T+5>>0]|0)+(h[T+-1>>0]|0)<<2)+(h[T+8>>0]|0)|0;f[M+(R<<2)>>2]=(h[T+-6>>0]|0)+((h[T>>0]|0)*6|0)+((h[T+3>>0]|0)+(h[T+-3>>0]|0)<<2)+(h[T+6>>0]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(q|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(q|0)){R=S;while(1){W=O+(R<<1)|0;V=(h[W+-7>>0]|0)+((h[W+1>>0]|0)*6|0)+((h[W+5>>0]|0)+(h[W+-3>>0]|0)<<2)+(h[W+9>>0]|0)|0;f[M+(R<<2)>>2]=(h[W+-8>>0]|0)+((h[W>>0]|0)*6|0)+((h[W+4>>0]|0)+(h[W+-4>>0]|0)<<2)+(h[W+8>>0]|0);f[M+(R+1<<2)>>2]=V;V=(h[W+-5>>0]|0)+((h[W+3>>0]|0)*6|0)+((h[W+7>>0]|0)+(h[W+-1>>0]|0)<<2)+(h[W+11>>0]|0)|0;f[M+(R+2<<2)>>2]=(h[W+-6>>0]|0)+((h[W+2>>0]|0)*6|0)+((h[W+6>>0]|0)+(h[W+-2>>0]|0)<<2)+(h[W+10>>0]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(q|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(q|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(h[O+(V-t)>>0]|0)+((h[O+V>>0]|0)*6|0)+((h[O+(V+p)>>0]|0)+(h[O+(V-p)>>0]|0)<<2)+(h[O+(V+t)>>0]|0);R=R+1|0}while((R|0)<(q|0));U=q}else U=S}N=o;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=x+((Y((I|0)%5|0,w)|0)<<2)|0;Q=x+((Y((I|1|0)%5|0,w)|0)<<2)|0;P=x+((Y((J|0)%5|0,w)|0)<<2)|0;N=x+((Y((I+3|0)%5|0,w)|0)<<2)|0;O=x+((Y((I+4|0)%5|0,w)|0)<<2)|0;if(G){M=0;do{b[H+M>>0]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(o|0))}E=E+1|0;if((E|0)>=(s|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(B|0)){if(K|0)dYc(K);f[k>>2]=B;f[v>>2]=264}v=f[g>>2]|0;if((v|0)==(z|0)){u=e;return}if(v|0)dYc(v);f[g>>2]=z;f[y>>2]=264;u=e;return}function Mpa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+144|0;h=g+80|0;i=g+72|0;j=g+16|0;k=g;if((e|0)!=4){e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=28;l=e;m=271693;n=l+28|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[e+28>>0]=0;vM(-215,h,271722,271481,990)}do if((eS(a)|0)==65536){e=f[a+4>>2]|0;f[h>>2]=f[e>>2];m=h+4|0;l=e+4|0;f[m>>2]=f[l>>2];n=h+8|0;f[n>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];o=f[e+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=n;n=h+48|0;p=h+44|0;f[p>>2]=n;f[n>>2]=0;f[h+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[l>>2]|0)<3){l=f[e+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[l>>2];f[n+4>>2]=f[l+4>>2];break}else{f[m>>2]=0;U$(h,e);break}}else bS(h,a,-1);while(0);a=f[d>>2]|0;if((a|0)>=1?(e=f[d+4>>2]|0,(e|0)>=1):0){q=a;r=e}else{q=f[h+12>>2]<<1;r=f[h+8>>2]<<1}f[i>>2]=q;f[i+4>>2]=r;wS(c,i,f[h>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){i=f[c+4>>2]|0;f[j>>2]=f[i>>2];r=j+4|0;q=i+4|0;f[r>>2]=f[q>>2];e=j+8|0;f[e>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];a=f[i+36>>2]|0;f[j+36>>2]=a;f[j+40>>2]=e;e=j+48|0;d=j+44|0;f[d>>2]=e;f[e>>2]=0;f[j+52>>2]=0;if(a|0){e=a+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[q>>2]|0)<3){q=f[i+44>>2]|0;e=f[d>>2]|0;f[e>>2]=f[q>>2];f[e+4>>2]=f[q+4>>2];break}else{f[r>>2]=0;U$(j,i);break}}else bS(j,c,-1);while(0);switch(f[h>>2]&7){case 0:{s=431;break}case 3:{s=432;break}case 2:{s=433;break}case 5:{s=434;break}case 6:{s=435;break}default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;vM(-210,k,271722,271481,1022)}}Ti[s&511](h,j,4);s=j+36|0;k=f[s>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)V$(j);f[s>>2]=0;s=j+16|0;k=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){s=f[j+40>>2]|0;c=0;do{f[s+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=h+36|0;j=f[k>>2]|0;if(j|0?(c=j+12|0,j=f[c>>2]|0,f[c>>2]=j+-1,(j|0)==1):0)V$(h);f[k>>2]=0;k=h+16|0;j=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[h+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)==(h+48|0)){u=g;return}wL(j);u=g;return}function Npa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=u;u=u+2144|0;g=e+1080|0;h=e+16|0;i=e;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=h+8|0;f[h>>2]=p;v=h+4|0;f[v>>2]=t;if(t>>>0>264){w=bYc(t>>>0>1073741823?-1:t<<2)|0;f[h>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((m|0)%2|0|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;y=$Xc(128)|0;f[i>>2]=y;z=i+8|0;f[z>>2]=-2147483520;A=i+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,i,271848,271481,537)}w=l<<1;k=n-w|0;if((((k|0)>-1?k:0-k|0)|0)!=((n|0)%2|0|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;y=$Xc(128)|0;f[i>>2]=y;z=i+8|0;f[z>>2]=-2147483520;A=i+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,i,271848,271481,537)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;E=0;do{y=(Y(m,(E|0)/(j|0)|0)|0)+((E|0)%(j|0)|0)|0;f[x+(E<<2)>>2]=y;E=E+1|0}while((E|0)!=(t|0))}if((l|0)>0){E=c+16|0;m=c+44|0;y=n+-1|0;C=(i|0)>0;B=a+16|0;D=a+44|0;a=(t|0)==(j|0);A=t-j|0;z=(i|0)>(t<<1|0);t=c+12|0;k=(j|0)<(A|0);F=-1;G=0;while(1){H=G<<1;I=f[E>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(y|0)<(L|0)?y:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(qR(J<<1,w,4)|0)/2|0;P=(f[B>>2]|0)+(Y(f[f[D>>2]>>2]|0,O)|0)|0;if(!a){if(z){O=0;do{Q=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+A|0;S=f[x+(R<<2)>>2]|0;Q=d[P+(R<<1)>>1]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(d[P+(R-j<<1)>>1]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=d[P+(O<<1)>>1]|0;R=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+A|0;R=f[x+(S<<2)>>2]|0;T=d[P+(S<<1)>>1]|0;f[N+(R<<2)>>2]=(T*7|0)+(d[P+(S-j<<1)>>1]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(k){O=j;do{T=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R*6|0)+(d[P+(O-j<<1)>>1]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(A|0))}}else{O=0;do{R=d[P+(O<<1)>>1]<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(C){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&65535;d[H+(P<<1)>>1]=((S+R<<2)+32|0)>>>6;d[K+(P<<1)>>1]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0))break;else F=M}}if((n|0)>(w|0)?(n=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=n+(Y(M,w+-2|0)|0)|0,F=n+(Y(M,w)|0)|0,(i|0)>0):0){w=0;do{d[F+(w<<1)>>1]=d[c+(w<<1)>>1]|0;w=w+1|0}while((w|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(p|0)){if(i|0)dYc(i);f[h>>2]=p;f[v>>2]=264}v=f[g>>2]|0;if((v|0)==(q|0)){u=e;return}if(v|0)dYc(v);f[g>>2]=q;f[r>>2]=264;u=e;return}function Opa(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+2144|0;g=e+1080|0;h=e+16|0;i=e;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=((f[a>>2]|0)>>>3&511)+1|0;p=(Y(k,n+1|0)|0)+15&-16;q=(p*3|0)+16|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=bYc(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=v+15&-16;v=Y(k,l)|0;q=h+8|0;f[h>>2]=q;w=h+4|0;f[w>>2]=v;if(v>>>0>264){x=bYc(v>>>0>1073741823?-1:v<<2)|0;f[h>>2]=x;y=x}else y=q;x=n-(l<<1)|0;if((((x|0)>-1?x:0-x|0)|0)!=((n|0)%2|0|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;z=$Xc(128)|0;f[i>>2]=z;A=i+8|0;f[A>>2]=-2147483520;B=i+4|0;f[B>>2]=119;C=z;D=271728;E=C+119|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+119|0;b[F>>0]=0;vM(-215,i,271848,271481,537)}x=m<<1;l=o-x|0;if((((l|0)>-1?l:0-l|0)|0)!=((o|0)%2|0|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;z=$Xc(128)|0;f[i>>2]=z;A=i+8|0;f[A>>2]=-2147483520;B=i+4|0;f[B>>2]=119;C=z;D=271728;E=C+119|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+119|0;b[F>>0]=0;vM(-215,i,271848,271481,537)}i=Y(k,n)|0;if((v|0)>0){n=k<<1;F=0;do{z=(Y(n,(F|0)/(k|0)|0)|0)+((F|0)%(k|0)|0)|0;f[y+(F<<2)>>2]=z;F=F+1|0}while((F|0)!=(v|0))}if((m|0)>0){F=c+16|0;n=c+44|0;z=o+-1|0;D=(i|0)>0;C=a+16|0;E=a+44|0;a=(v|0)==(k|0);B=v-k|0;A=(i|0)>(v<<1|0);v=c+12|0;l=(k|0)<(B|0);G=-1;H=0;while(1){I=H<<1;J=f[F>>2]|0;K=f[f[n>>2]>>2]|0;L=J+(Y(K,I)|0)|0;M=I|1;I=J+(Y(K,(z|0)<(M|0)?z:M)|0)|0;M=H;H=H+1|0;if((G|0)>(H|0))N=G;else{K=G;while(1){J=K+1|0;O=t+((Y((J|0)%3|0,p)|0)<<2)|0;P=(qR(K<<1,x,4)|0)/2|0;Q=(f[C>>2]|0)+(Y(f[f[E>>2]>>2]|0,P)|0)|0;if(!a){if(A){P=0;do{R=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(R<<2)>>2]=(T<<1)+(S*6|0);f[O+(R+k<<2)>>2]=T+S<<2;S=P+B|0;T=f[y+(S<<2)>>2]|0;R=j[Q+(S<<1)>>1]|0;U=R<<3;f[O+(T<<2)>>2]=(R*7|0)+(j[Q+(S-k<<1)>>1]|0);f[O+(T+k<<2)>>2]=U;f[O+(P+-1+(f[v>>2]|0)<<2)>>2]=U;P=P+1|0}while((P|0)!=(k|0))}else{P=0;do{U=f[y+(P<<2)>>2]|0;T=j[Q+(P<<1)>>1]|0;S=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S<<1)+(T*6|0);f[O+(U+k<<2)>>2]=S+T<<2;T=P+B|0;S=f[y+(T<<2)>>2]|0;U=j[Q+(T<<1)>>1]|0;f[O+(S<<2)>>2]=(U*7|0)+(j[Q+(T-k<<1)>>1]|0);f[O+(S+k<<2)>>2]=U<<3;P=P+1|0}while((P|0)!=(k|0))}if(l){P=k;do{U=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S*6|0)+(j[Q+(P-k<<1)>>1]|0)+T;f[O+(U+k<<2)>>2]=T+S<<2;P=P+1|0}while((P|0)!=(B|0))}}else{P=0;do{S=(j[Q+(P<<1)>>1]|0)<<3;f[O+(P+k<<2)>>2]=S;f[O+(P<<2)>>2]=S;P=P+1|0}while((P|0)!=(k|0))}if((K|0)>(M|0)){N=J;break}else K=J}}K=t+((Y((M|0)%3|0,p)|0)<<2)|0;P=t+((Y((H|0)%3|0,p)|0)<<2)|0;O=t+((Y((M+2|0)%3|0,p)|0)<<2)|0;if(D){Q=0;do{S=f[P+(Q<<2)>>2]|0;T=f[O+(Q<<2)>>2]|0;U=((S*6|0)+32+T+(f[K+(Q<<2)>>2]|0)|0)>>>6&65535;d[I+(Q<<1)>>1]=((T+S<<2)+32|0)>>>6;d[L+(Q<<1)>>1]=U;Q=Q+1|0}while((Q|0)!=(i|0))}if((H|0)>=(m|0))break;else G=N}}if((o|0)>(x|0)?(o=f[c+16>>2]|0,N=f[f[c+44>>2]>>2]|0,c=o+(Y(N,x+-2|0)|0)|0,G=o+(Y(N,x)|0)|0,(i|0)>0):0){x=0;do{d[G+(x<<1)>>1]=d[c+(x<<1)>>1]|0;x=x+1|0}while((x|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(q|0)){if(i|0)dYc(i);f[h>>2]=q;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(r|0)){u=e;return}if(w|0)dYc(w);f[g>>2]=r;f[s>>2]=264;u=e;return}function Ppa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0;d=u;u=u+2144|0;e=d+1080|0;g=d+16|0;h=d;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(i,l+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=bYc(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=l-(j<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((l|0)%2|0|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(128)|0;f[h>>2]=y;z=h+8|0;f[z>>2]=-2147483520;A=h+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,h,271848,271481,537)}w=k<<1;j=m-w|0;if((((j|0)>-1?j:0-j|0)|0)!=((m|0)%2|0|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(128)|0;f[h>>2]=y;z=h+8|0;f[z>>2]=-2147483520;A=h+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,h,271848,271481,537)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;E=0;do{y=(Y(l,(E|0)/(i|0)|0)|0)+((E|0)%(i|0)|0)|0;f[x+(E<<2)>>2]=y;E=E+1|0}while((E|0)!=(t|0))}if((k|0)>0){E=c+16|0;l=c+44|0;y=m+-1|0;C=(h|0)>0;B=a+16|0;D=a+44|0;a=(t|0)==(i|0);A=t-i|0;z=(h|0)>(t<<1|0);t=c+12|0;j=(i|0)<(A|0);F=-1;G=0;while(1){H=G<<1;I=f[E>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(y|0)<(L|0)?y:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(qR(J<<1,w,4)|0)/2|0;P=(f[B>>2]|0)+(Y(f[f[D>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(z){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(R<<2)>>2]=S*6.0+T*2.0;n[N+(R+i<<2)>>2]=(S+T)*4.0;R=Q+A|0;U=f[x+(R<<2)>>2]|0;T=+n[P+(R<<2)>>2];S=T*8.0;n[N+(U<<2)>>2]=+n[P+(R-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=S;n[N+(Q+-1+O<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(O<<2)>>2]=S*6.0+T*2.0;n[N+(O+i<<2)>>2]=(S+T)*4.0;O=Q+A|0;U=f[x+(O<<2)>>2]|0;T=+n[P+(O<<2)>>2];n[N+(U<<2)>>2]=+n[P+(O-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(j){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+n[P+(Q<<2)>>2];S=+n[P+(Q+i<<2)>>2];n[N+(U<<2)>>2]=S+(+n[P+(Q-i<<2)>>2]+T*6.0);n[N+(U+i<<2)>>2]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(A|0))}}else{Q=0;do{S=+n[P+(Q<<2)>>2]*8.0;n[N+(Q+i<<2)>>2]=S;n[N+(Q<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;Q=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(C){P=0;do{S=+n[Q+(P<<2)>>2];T=+n[N+(P<<2)>>2];V=(T+(S*6.0+ +n[J+(P<<2)>>2]))*.015625;n[H+(P<<2)>>2]=(S+T)*4.0*.015625;n[K+(P<<2)>>2]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0))break;else F=M}}if((m|0)>(w|0)?(m=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=m+(Y(M,w+-2|0)|0)|0,F=m+(Y(M,w)|0)|0,(h|0)>0):0){w=0;do{f[F+(w<<2)>>2]=f[c+(w<<2)>>2];w=w+1|0}while((w|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(p|0)){if(h|0)dYc(h);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)dYc(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function Qpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0;d=u;u=u+2176|0;e=d;g=d+1112|0;h=d+1096|0;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;n=(Y(i,l+1|0)|0)+15&-16;o=(n*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=o;if(o>>>0>136){s=bYc(o>>>0>536870911?-1:o<<3)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;o=g+8|0;f[g>>2]=o;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=bYc(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=o;w=l-(j<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((l|0)%2|0|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(128)|0;f[h>>2]=y;z=h+8|0;f[z>>2]=-2147483520;A=h+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,h,271848,271481,537)}w=k<<1;j=m-w|0;if((((j|0)>-1?j:0-j|0)|0)!=((m|0)%2|0|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=$Xc(128)|0;f[h>>2]=y;z=h+8|0;f[z>>2]=-2147483520;A=h+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,h,271848,271481,537)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;E=0;do{y=(Y(l,(E|0)/(i|0)|0)|0)+((E|0)%(i|0)|0)|0;f[x+(E<<2)>>2]=y;E=E+1|0}while((E|0)!=(t|0))}if((k|0)>0){E=c+16|0;l=c+44|0;y=m+-1|0;C=(h|0)>0;B=a+16|0;D=a+44|0;a=(t|0)==(i|0);A=t-i|0;z=(h|0)>(t<<1|0);t=c+12|0;j=(i|0)<(A|0);F=-1;G=0;while(1){H=G<<1;I=f[E>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(y|0)<(L|0)?y:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,n)|0)<<3)|0;O=(qR(J<<1,w,4)|0)/2|0;P=(f[B>>2]|0)+(Y(f[f[D>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(z){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(R<<3)>>3]=S*6.0+T*2.0;p[N+(R+i<<3)>>3]=(S+T)*4.0;R=Q+A|0;U=f[x+(R<<2)>>2]|0;T=+p[P+(R<<3)>>3];S=T*8.0;p[N+(U<<3)>>3]=+p[P+(R-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=S;p[N+(Q+-1+O<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(O<<3)>>3]=S*6.0+T*2.0;p[N+(O+i<<3)>>3]=(S+T)*4.0;O=Q+A|0;U=f[x+(O<<2)>>2]|0;T=+p[P+(O<<3)>>3];p[N+(U<<3)>>3]=+p[P+(O-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(j){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+p[P+(Q<<3)>>3];S=+p[P+(Q+i<<3)>>3];p[N+(U<<3)>>3]=S+(+p[P+(Q-i<<3)>>3]+T*6.0);p[N+(U+i<<3)>>3]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(A|0))}}else{Q=0;do{S=+p[P+(Q<<3)>>3]*8.0;p[N+(Q+i<<3)>>3]=S;p[N+(Q<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,n)|0)<<3)|0;Q=s+((Y((G|0)%3|0,n)|0)<<3)|0;N=s+((Y((L+2|0)%3|0,n)|0)<<3)|0;if(C){P=0;do{S=+p[Q+(P<<3)>>3];T=+p[N+(P<<3)>>3];V=(T+(S*6.0+ +p[J+(P<<3)>>3]))*.015625;p[H+(P<<3)>>3]=(S+T)*4.0*.015625;p[K+(P<<3)>>3]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0))break;else F=M}}if((m|0)>(w|0)?(m=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=m+(Y(M,w+-2|0)|0)|0,F=m+(Y(M,w)|0)|0,(h|0)>0):0){w=0;do{p[F+(w<<3)>>3]=+p[c+(w<<3)>>3];w=w+1|0}while((w|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(o|0)){if(h|0)dYc(h);f[g>>2]=o;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)dYc(v);f[e>>2]=q;f[r>>2]=136;u=d;return}function Rpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=u;u=u+2144|0;e=d+1080|0;g=d+16|0;i=d;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=bYc(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=bYc(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if((((w|0)>-1?w:0-w|0)|0)!=((m|0)%2|0|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;y=$Xc(128)|0;f[i>>2]=y;z=i+8|0;f[z>>2]=-2147483520;A=i+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,i,271848,271481,537)}w=l<<1;k=n-w|0;if((((k|0)>-1?k:0-k|0)|0)!=((n|0)%2|0|0)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;y=$Xc(128)|0;f[i>>2]=y;z=i+8|0;f[z>>2]=-2147483520;A=i+4|0;f[A>>2]=119;B=y;C=271728;D=B+119|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+119|0;b[E>>0]=0;vM(-215,i,271848,271481,537)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;E=0;do{y=(Y(m,(E|0)/(j|0)|0)|0)+((E|0)%(j|0)|0)|0;f[x+(E<<2)>>2]=y;E=E+1|0}while((E|0)!=(t|0))}if((l|0)>0){E=c+16|0;m=c+44|0;y=n+-1|0;C=(i|0)>0;B=a+16|0;D=a+44|0;a=(t|0)==(j|0);A=t-j|0;z=(i|0)>(t<<1|0);t=c+12|0;k=(j|0)<(A|0);F=-1;G=0;while(1){H=G<<1;I=f[E>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(y|0)<(L|0)?y:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(qR(J<<1,w,4)|0)/2|0;P=(f[B>>2]|0)+(Y(f[f[D>>2]>>2]|0,O)|0)|0;if(!a){if(z){O=0;do{Q=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+A|0;S=f[x+(R<<2)>>2]|0;Q=h[P+R>>0]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(h[P+(R-j)>>0]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=h[P+O>>0]|0;R=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+A|0;R=f[x+(S<<2)>>2]|0;T=h[P+S>>0]|0;f[N+(R<<2)>>2]=(T*7|0)+(h[P+(S-j)>>0]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(k){O=j;do{T=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R*6|0)+(h[P+(O-j)>>0]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(A|0))}}else{O=0;do{R=(h[P+O>>0]|0)<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(C){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&255;b[H+P>>0]=((S+R<<2)+32|0)>>>6;b[K+P>>0]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0))break;else F=M}}if((n|0)>(w|0)?(n=f[c+16>>2]|0,M=f[f[c+44>>2]>>2]|0,c=n+(Y(M,w+-2|0)|0)|0,F=n+(Y(M,w)|0)|0,(i|0)>0):0){w=0;do{b[F+w>>0]=b[c+w>>0]|0;w=w+1|0}while((w|0)!=(i|0))}i=f[g>>2]|0;if((i|0)!=(p|0)){if(i|0)dYc(i);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)dYc(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function Spa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;g=u;u=u+112|0;h=g+56|0;i=g;if(sS(a)|0){j=$Xc(16)|0;f[h>>2]=j;f[h+8>>2]=-2147483632;f[h+4>>2]=13;k=j;l=371335;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+13>>0]=0;vM(-215,h,271925,271855,181)}a:do if((e|0)<1)switch(d|0){case 120:case 119:case 122:case 121:case 112:case 111:case 104:case 105:case 102:case 103:case 94:case 95:case 96:case 97:case 9:case 29:case 19:case 28:case 18:case 5:case 2:case 0:{n=4;break a;break}case 116:case 115:case 118:case 117:case 108:case 107:case 100:case 101:case 98:case 99:case 90:case 91:case 92:case 93:case 8:case 25:case 15:case 24:case 14:case 4:case 3:case 1:{n=3;break a;break}default:{n=0;break a}}else n=e;while(0);do switch(d|0){case 5:case 4:case 3:case 1:case 2:case 0:{if((rS(a,-1)|0)==1){Qxa(a,c,n);u=g;return}else{Exa(a,c,n,d>>>0>1);u=g;return}break}case 27:case 17:case 23:case 13:case 26:case 16:case 22:case 12:{e=d+-12|0;b:do if(e>>>0<15){j=(11178>>>(e&32767)&1)!=0;switch(d|0){case 20:case 21:case 19:case 18:case 15:case 14:case 17:case 16:case 13:case 12:{o=j;p=6;break b;break}case 24:case 25:case 26:case 23:case 22:{q=j;r=13;break b;break}default:{}}o=j;p=0}else{q=1;r=13}while(0);if((r|0)==13){o=q;p=5}Hxa(a,c,o,p);u=g;return}case 29:case 19:case 25:case 15:case 28:case 18:case 24:case 14:{e=d+-14|0;c:do if(e>>>0<15){j=(10986>>>(e&32767)&1)!=0;switch(d|0){case 24:case 27:case 26:case 23:case 22:case 25:case 28:{s=j;r=18;break c;break}case 20:case 21:case 19:case 18:case 15:case 14:case 17:case 16:{t=j;v=6;break c;break}default:{}}t=j;v=0}else{s=1;r=18}while(0);if((r|0)==18){t=s;v=5}Kxa(a,c,n,t,v);u=g;return}case 11:case 7:case 10:case 6:{switch(d|0){case 10:case 6:{w=0;break}default:w=1}Nxa(a,c,w);u=g;return}case 31:case 21:{switch(d|0){case 22:case 30:case 31:case 29:case 28:case 25:case 24:case 27:case 26:case 23:{x=5;break}case 21:{x=6;break}default:x=0}Txa(a,c,x);u=g;return}case 9:case 8:{Qxa(a,c,n);u=g;return}case 30:case 20:{switch(d|0){case 22:case 30:case 29:case 28:case 25:case 24:case 27:case 26:case 23:{y=5;break}case 20:case 21:{y=6;break}default:y=0}Wxa(a,c,y);u=g;return}case 83:case 82:case 37:case 36:{switch(d|0){case 40:case 80:case 78:case 58:case 38:case 82:case 36:case 56:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 68:case 66:case 52:{z=0;break}default:z=1}QFa(a,c,z,(d|1|0)==37);u=g;return}case 85:case 84:case 39:case 38:{switch(d|0){case 40:case 80:case 78:case 84:case 38:case 82:case 58:case 56:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 68:case 66:case 52:{A=0;break}default:A=1}RFa(a,c,n,A,(d|1|0)==39);u=g;return}case 33:case 32:{qDa(a,c,(d|0)!=32);u=g;return}case 35:case 34:{tDa(a,c,n,(d|0)!=34);u=g;return}case 67:case 41:case 66:case 40:{e=d+-40|0;if(e>>>0<27)B=(65711086>>>(e&134217727)&1|0)!=0;else B=1;AGa(a,c,B,(d+-66|0)>>>0<8);u=g;return}case 69:case 53:case 68:case 52:{e=d+-52|0;if(e>>>0<17)C=(48810>>>(e&131071)&1|0)!=0;else C=1;zGa(a,c,C,(d+-66|0)>>>0<8);u=g;return}case 71:case 55:case 70:case 54:{e=d+-54|0;if(e>>>0<17)D=(44970>>>(e&131071)&1|0)!=0;else D=1;CGa(a,c,n,D,(d+-66|0)>>>0<8);u=g;return}case 73:case 61:case 72:case 60:{e=d+-60|0;if(e>>>0<13)E=(2750>>>(e&8191)&1)!=0;else E=1;BGa(a,c,n,E,(d+-66|0)>>>0<8);u=g;return}case 75:case 45:case 74:case 44:{e=d+-44|0;if(e>>>0<31){j=(717138622>>>(e&2147483647)&1|0)!=0;if(e>>>0<16){F=j;G=((-3901&65535)>>>(e&65535)&1)!=0}else{F=j;G=0}}else{F=1;G=0}iDa(a,c,F,G);u=g;return}case 77:case 51:case 76:case 50:{j=d+-50|0;if(j>>>0<27){e=(44759722>>>(j&134217727)&1|0)!=0;j=d+-44|0;if(j>>>0<16){H=e;I=((-3901&65535)>>>(j&65535)&1)!=0}else{H=e;I=0}}else{H=1;I=0}lDa(a,c,H,I);u=g;return}case 79:case 57:case 78:case 56:{e=d+-56|0;if(e>>>0<23){j=(2796522>>>(e&8388607)&1|0)!=0;e=d+-44|0;if(e>>>0<16){J=j;K=((-3901&65535)>>>(e&65535)&1)!=0}else{J=j;K=0}}else{J=1;K=0}mDa(a,c,n,J,K);u=g;return}case 81:case 59:case 80:case 58:{j=d+-58|0;if(j>>>0<23){e=(2796282>>>(j&8388607)&1|0)!=0;j=d+-44|0;if(j>>>0<16){L=e;M=((-3901&65535)>>>(j&65535)&1)!=0}else{L=e;M=0}}else{L=1;M=0}pDa(a,c,n,L,M);u=g;return}case 142:case 141:case 140:case 139:case 138:case 137:case 136:case 135:case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:case 89:case 88:case 87:case 86:{f[h>>2]=1124007936;e=h+4|0;j=h+8|0;N=h+40|0;k=e;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[N>>2]=j;O=h+48|0;P=h+44|0;f[P>>2]=O;f[O>>2]=0;f[h+52>>2]=0;Q=a+4|0;if((f[Q>>2]|0)!=(f[c+4>>2]|0)){do if((eS(a)|0)==65536){R=f[Q>>2]|0;f[i>>2]=f[R>>2];S=i+4|0;T=R+4|0;f[S>>2]=f[T>>2];U=i+8|0;f[U>>2]=f[R+8>>2];f[i+12>>2]=f[R+12>>2];f[i+16>>2]=f[R+16>>2];f[i+20>>2]=f[R+20>>2];f[i+24>>2]=f[R+24>>2];f[i+28>>2]=f[R+28>>2];f[i+32>>2]=f[R+32>>2];V=f[R+36>>2]|0;f[i+36>>2]=V;f[i+40>>2]=U;U=i+48|0;W=i+44|0;f[W>>2]=U;f[U>>2]=0;f[i+52>>2]=0;if(V|0){U=V+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[T>>2]|0)<3){T=f[R+44>>2]|0;U=f[W>>2]|0;f[U>>2]=f[T>>2];f[U+4>>2]=f[T+4>>2];break}else{f[S>>2]=0;U$(i,R);break}}else bS(i,a,-1);while(0);Q=h+36|0;R=f[Q>>2]|0;if(R|0?(S=R+12|0,R=f[S>>2]|0,f[S>>2]=R+-1,(R|0)==1):0)V$(h);f[Q>>2]=0;R=h+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[e>>2]|0)>0){S=f[N>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[e>>2]|0))}f[h>>2]=f[i>>2];T=i+4|0;S=f[T>>2]|0;f[e>>2]=S;U=i+8|0;f[j>>2]=f[U>>2];f[h+12>>2]=f[i+12>>2];W=i+16|0;f[R>>2]=f[W>>2];f[h+20>>2]=f[i+20>>2];f[h+24>>2]=f[i+24>>2];f[h+28>>2]=f[i+28>>2];f[h+32>>2]=f[i+32>>2];V=i+36|0;f[Q>>2]=f[V>>2];X=h+44|0;Y=f[X>>2]|0;if((Y|0)==(O|0))Z=S;else{wL(Y);f[X>>2]=O;f[N>>2]=j;Z=f[T>>2]|0}Y=i+44|0;if((Z|0)<3){S=f[Y>>2]|0;f[O>>2]=f[S>>2];f[h+52>>2]=f[S+4>>2];_=S}else{f[X>>2]=f[Y>>2];X=i+40|0;f[h+40>>2]=f[X>>2];S=i+48|0;f[Y>>2]=S;f[X>>2]=U;_=S}f[i>>2]=1124007936;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;f[T+16>>2]=0;f[T+20>>2]=0;f[T+24>>2]=0;f[T+28>>2]=0;f[V>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((_|0)!=(i+48|0))wL(_)}else{W=i+8|0;f[W>>2]=0;f[W+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;uS(a,i)}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=h;gpa(i,c,d,n);W=h+36|0;V=f[W>>2]|0;if(V|0?(T=V+12|0,V=f[T>>2]|0,f[T>>2]=V+-1,(V|0)==1):0)V$(h);f[W>>2]=0;W=h+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[e>>2]|0)>0){W=f[N>>2]|0;V=0;do{f[W+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[e>>2]|0))}e=f[P>>2]|0;if((e|0)!=(O|0))wL(e);u=g;return}case 94:case 95:case 96:case 97:case 90:case 91:case 92:case 93:{e=d+-91|0;V=e>>>0>6|(e&1|0)!=0;switch(d|0){case 94:case 95:case 90:case 91:{$=0;break}case 96:case 97:case 92:case 93:{$=1;break}default:$=-1}bGa(a,c,n,V,$);u=g;return}case 104:case 105:case 100:case 101:case 102:case 103:case 98:case 99:{V=d+-99|0;e=V>>>0>6|(V&1|0)!=0;switch(d|0){case 102:case 103:case 98:case 99:{aa=1;break}case 104:case 105:case 100:case 101:{aa=0;break}default:aa=-1}_Fa(a,c,n,e,aa);u=g;return}case 106:{XFa(a,c);u=g;return}case 130:case 129:case 128:case 127:case 134:case 133:case 132:case 131:{e=d+-128|0;V=e>>>0>6|(e&1|0)!=0;switch(d|0){case 134:case 133:case 132:case 131:{ba=2;break}case 130:case 129:case 128:case 127:{ba=1;break}default:ba=-1}UFa(a,c,V,ba);u=g;return}case 122:case 121:case 120:case 119:case 118:case 117:case 116:case 115:case 112:case 111:case 108:case 107:{V=d+-107|0;if(V>>>0<6)ca=51>>>(V&63)&1;else ca=0;V=d+-108|0;d:do if(V>>>0<15){e=(10990>>>(V&32767)&1)!=0;switch(d|0){case 119:case 116:case 115:case 112:case 111:case 108:case 120:{da=e;r=118;break d;break}case 122:case 121:case 118:case 117:{ea=1;fa=e;break d;break}default:{}}ea=-1;fa=e}else{da=1;r=118}while(0);if((r|0)==118){ea=0;fa=da}SFa(a,c,n,fa,ea,ca);u=g;return}case 124:case 123:{TFa(a,c,(d|0)==123&1);u=g;return}case 125:{Zxa(a,c);u=g;return}case 126:{aya(a,c);u=g;return}default:{V=$Xc(48)|0;f[h>>2]=V;f[h+8>>2]=-2147483600;f[h+4>>2]=41;k=V;l=370061;m=k+41|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[V+41>>0]=0;vM(-206,h,271925,271855,354)}}while(0)}function Tpa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0;g=u;u=u+304|0;h=g+248|0;i=g+192|0;j=g;Nwa(j,a,0);Twa(j,h);Nwa(j,c,0);Twa(j,i);switch(d|0){case 1:{d=0;c=0;e=0.0;a=0;while(1){k=+p[h+(a<<3)>>3];l=+L(+k);m=+p[i+(a<<3)>>3];n=+L(+m);c=k!=k|0.0!=0.0|k==0.0?c:1;d=m!=m|0.0!=0.0|m==0.0?d:1;if(l>1.0e-05&n>1.0e-05){o=1.0/((k>0.0?1.0:k<0.0?-1.0:0.0)*+wLc(l));q=e+ +L(+(1.0/((m>0.0?1.0:m<0.0?-1.0:0.0)*+wLc(n))-o))}else q=e;a=a+1|0;if((a|0)==7)break;else e=q}r=(d&1)!=0;s=(c&1)!=0;t=q;v=s^r;w=v?1797693134862315708145274.0e284:t;u=g;return +w}case 2:{c=0;d=0;a=0;q=0.0;while(1){e=+p[h+(c<<3)>>3];o=+L(+e);n=+p[i+(c<<3)>>3];m=+L(+n);a=e!=e|0.0!=0.0|e==0.0?a:1;d=n!=n|0.0!=0.0|n==0.0?d:1;if(o>1.0e-05&m>1.0e-05){l=(e>0.0?1.0:e<0.0?-1.0:0.0)*+wLc(o);x=q+ +L(+((n>0.0?1.0:n<0.0?-1.0:0.0)*+wLc(m)-l))}else x=q;c=c+1|0;if((c|0)==7)break;else q=x}r=(d&1)!=0;s=(a&1)!=0;t=x;v=s^r;w=v?1797693134862315708145274.0e284:t;u=g;return +w}case 3:{a=0;d=0;c=0;x=0.0;while(1){q=+p[h+(a<<3)>>3];l=+L(+q);m=+p[i+(a<<3)>>3];n=+L(+m);y=c|q==q&0.0==0.0&q!=0.0;z=d|m==m&0.0==0.0&m!=0.0;if(l>1.0e-05&n>1.0e-05?(o=(q>0.0?1.0:q<0.0?-1.0:0.0)*+wLc(l),l=+L(+((o-(m>0.0?1.0:m<0.0?-1.0:0.0)*+wLc(n))/o)),x<l):0)A=l;else A=x;a=a+1|0;if((a|0)==7){r=z;s=y;t=A;break}else{d=z;c=y;x=A}}v=s^r;w=v?1797693134862315708145274.0e284:t;u=g;return +w}default:{g=$Xc(32)|0;f[j>>2]=g;f[j+8>>2]=-2147483616;f[j+4>>2]=25;v=g;r=271934;s=v+25|0;do{b[v>>0]=b[r>>0]|0;v=v+1|0;r=r+1|0}while((v|0)<(s|0));b[g+25>>0]=0;vM(-5,j,271960,271972,161)}}return +(0.0)}function Upa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=$Xc(152)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=53208;g=c+16|0;yP(g);f[g>>2]=53236;p[c+24>>3]=b;f[c+32>>2]=d;f[c+36>>2]=e;f[c+40>>2]=1124007936;e=c+48|0;d=c+80|0;h=c+44|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[d>>2]=e;e=c+88|0;f[c+84>>2]=e;f[e>>2]=0;f[c+92>>2]=0;f[c+96>>2]=1124007936;e=c+104|0;d=c+136|0;h=c+100|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[d>>2]=e;e=c+144|0;f[c+140>>2]=e;f[e>>2]=0;f[c+148>>2]=0;f[a>>2]=g;f[a+4>>2]=c;return}function Vpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53236;b=a+80|0;c=a+116|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+96|0;b=a+84|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+120>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+124>>2]|0;if((b|0)!=(a+128|0))wL(b);b=a+24|0;d=a+60|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+40|0;b=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+64>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){qP(a);return}wL(b);qP(a);return}function Wpa(a){a=a|0;Vpa(a);cYc(a);return}function Xpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;e=u;u=u+208|0;g=e+192|0;h=e+56|0;i=e+136|0;j=e+72|0;k=e;l=e+128|0;if(dS(c,-1)|0?(dS(c,-1)|0)!=2:0){m=$Xc(64)|0;f[g>>2]=m;f[g+8>>2]=-2147483584;f[g+4>>2]=49;o=m;q=272050;r=o+49|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[m+49>>0]=0;vM(-215,g,473123,272100,351)}m=(dS(c,-1)|0)==0;s=m?256:65536;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;cS(g,c,-1);m=a+16|0;if(!((f[g>>2]|0)%(f[m>>2]|0)|0)){cS(i,c,-1);t=a+20|0;v=f[t>>2]|0;if(!((f[i+4>>2]|0)%(v|0)|0)){cS(g,c,-1);w=f[g>>2]|0;x=f[m>>2]|0;cS(i,c,-1);y=(f[i+4>>2]|0)/(f[t>>2]|0)|0;z=c;A=f[z+4>>2]|0;B=h;f[B>>2]=f[z>>2];f[B+4>>2]=A;f[h+8>>2]=f[c+8>>2];C=f[c+12>>2]|0;D=(w|0)/(x|0)|0;E=y}else{F=t;G=v;H=8}}else{v=a+20|0;F=v;G=f[v>>2]|0;H=8}if((H|0)==8){H=a+24|0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=H;cS(i,c,-1);v=f[i+4>>2]|0;t=f[F>>2]|0;y=f[m>>2]|0;cS(j,c,-1);x=f[j>>2]|0;w=f[m>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;rR(c,g,0,G-((v|0)%(t|0)|0)|0,0,y-((x|0)%(w|0)|0)|0,4,k);w=f[a+64>>2]|0;x=(f[w+4>>2]|0)/(f[m>>2]|0)|0;y=(f[w>>2]|0)/(f[F>>2]|0)|0;f[h>>2]=16842752;f[h+4>>2]=H;f[h+8>>2]=0;C=0;D=x;E=y}f[h+12>>2]=C;C=Y(E,D)|0;I=+(s+-1|0)/+(C|0);J=+p[a+8>>3];if(J>0.0){y=~~(J*+(C|0)/+(s|0));K=(y|0)>1?y:1}else K=0;do if((eS(c)|0)==65536){y=f[c+4>>2]|0;f[i>>2]=f[y>>2];C=i+4|0;x=y+4|0;f[C>>2]=f[x>>2];H=i+8|0;f[H>>2]=f[y+8>>2];f[i+12>>2]=f[y+12>>2];f[i+16>>2]=f[y+16>>2];f[i+20>>2]=f[y+20>>2];f[i+24>>2]=f[y+24>>2];f[i+28>>2]=f[y+28>>2];f[i+32>>2]=f[y+32>>2];F=f[y+36>>2]|0;f[i+36>>2]=F;w=i+40|0;f[w>>2]=H;H=i+48|0;t=i+44|0;f[t>>2]=H;f[H>>2]=0;f[i+52>>2]=0;if(F|0){H=F+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[x>>2]|0)<3){x=f[y+44>>2]|0;H=f[t>>2]|0;f[H>>2]=f[x>>2];f[H+4>>2]=f[x+4>>2];L=w;M=i;break}else{f[C>>2]=0;U$(i,y);L=w;M=i;break}}else{bS(i,c,-1);L=i+40|0;M=i}while(0);w=f[L>>2]|0;y=f[w>>2]|0;f[l>>2]=f[w+4>>2];f[l+4>>2]=y;wS(d,l,f[M>>2]&4095,-1,0,0);do if((eS(d)|0)==65536){l=f[d+4>>2]|0;f[j>>2]=f[l>>2];y=j+4|0;w=l+4|0;f[y>>2]=f[w>>2];C=j+8|0;f[C>>2]=f[l+8>>2];f[j+12>>2]=f[l+12>>2];f[j+16>>2]=f[l+16>>2];f[j+20>>2]=f[l+20>>2];f[j+24>>2]=f[l+24>>2];f[j+28>>2]=f[l+28>>2];f[j+32>>2]=f[l+32>>2];x=f[l+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=C;C=j+48|0;H=j+44|0;f[H>>2]=C;f[C>>2]=0;f[j+52>>2]=0;if(x|0){C=x+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[w>>2]|0)<3){w=f[l+44>>2]|0;C=f[H>>2]|0;f[C>>2]=f[w>>2];f[C+4>>2]=f[w+4>>2];break}else{f[y>>2]=0;U$(j,l);break}}else bS(j,d,-1);while(0);do if((eS(h)|0)==65536){d=f[h+4>>2]|0;f[k>>2]=f[d>>2];l=k+4|0;y=d+4|0;f[l>>2]=f[y>>2];w=k+8|0;f[w>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];f[k+16>>2]=f[d+16>>2];f[k+20>>2]=f[d+20>>2];f[k+24>>2]=f[d+24>>2];f[k+28>>2]=f[d+28>>2];f[k+32>>2]=f[d+32>>2];C=f[d+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=w;w=k+48|0;H=k+44|0;f[H>>2]=w;f[w>>2]=0;f[k+52>>2]=0;if(C|0){w=C+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[y>>2]|0)<3){y=f[d+44>>2]|0;w=f[H>>2]|0;f[w>>2]=f[y>>2];f[w+4>>2]=f[y+4>>2];break}else{f[l>>2]=0;U$(k,d);break}}else bS(k,h,-1);while(0);h=a+80|0;d=f[m>>2]|0;l=a+20|0;y=f[l>>2]|0;w=Y(y,d)|0;d=(dS(c,-1)|0)&4095;y=a+84|0;if(!(((((f[y>>2]|0)<3?(f[a+88>>2]|0)==(w|0):0)?(f[a+92>>2]|0)==(s|0):0)?(f[h>>2]&4095|0)==(d|0):0)?(f[a+96>>2]|0)!=0:0)){f[g>>2]=w;f[g+4>>2]=s;S$(h,2,g,d)}if(!(dS(c,-1)|0)){d=$Xc(148)|0;f[d+4>>2]=0;f[d+8>>2]=0;f[d>>2]=53300;s=d+12|0;f[s>>2]=53328;w=d+16|0;f[w>>2]=f[k>>2];H=d+20|0;C=k+4|0;x=f[C>>2]|0;f[H>>2]=x;t=d+24|0;f[t>>2]=f[k+8>>2];f[d+28>>2]=f[k+12>>2];f[d+32>>2]=f[k+16>>2];f[d+36>>2]=f[k+20>>2];f[d+40>>2]=f[k+24>>2];f[d+44>>2]=f[k+28>>2];f[d+48>>2]=f[k+32>>2];F=f[k+36>>2]|0;f[d+52>>2]=F;f[d+56>>2]=t;t=d+64|0;v=d+60|0;f[v>>2]=t;f[t>>2]=0;f[d+68>>2]=0;if(!F)N=x;else{x=F+12|0;f[x>>2]=(f[x>>2]|0)+1;N=f[C>>2]|0}if((N|0)<3){N=f[k+44>>2]|0;C=f[v>>2]|0;f[C>>2]=f[N>>2];f[C+4>>2]=f[N+4>>2]}else{f[H>>2]=0;U$(w,k)}w=d+72|0;f[w>>2]=f[h>>2];H=d+76|0;N=f[y>>2]|0;f[H>>2]=N;C=d+80|0;f[C>>2]=f[a+88>>2];f[d+84>>2]=f[a+92>>2];f[d+88>>2]=f[a+96>>2];f[d+92>>2]=f[a+100>>2];f[d+96>>2]=f[a+104>>2];f[d+100>>2]=f[a+108>>2];f[d+104>>2]=f[a+112>>2];v=f[a+116>>2]|0;f[d+108>>2]=v;f[d+112>>2]=C;C=d+120|0;x=d+116|0;f[x>>2]=C;f[C>>2]=0;f[d+124>>2]=0;if(!v)O=N;else{N=v+12|0;f[N>>2]=(f[N>>2]|0)+1;O=f[y>>2]|0}if((O|0)<3){O=f[a+124>>2]|0;N=f[x>>2]|0;f[N>>2]=f[O>>2];f[N+4>>2]=f[O+4>>2]}else{f[H>>2]=0;U$(w,h)}f[d+128>>2]=D;f[d+132>>2]=E;f[d+136>>2]=f[m>>2];f[d+140>>2]=K;n[d+144>>2]=I;TXc(d);UXc(d);P=s;Q=d}else{if((dS(c,-1)|0)!=2){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;d=$Xc(32)|0;f[g>>2]=d;f[g+8>>2]=-2147483616;f[g+4>>2]=16;o=d;q=272170;r=o+16|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));b[d+16>>0]=0;vM(-5,g,473123,272100,416)}d=$Xc(148)|0;f[d+4>>2]=0;f[d+8>>2]=0;f[d>>2]=53348;q=d+12|0;f[q>>2]=53376;o=d+16|0;f[o>>2]=f[k>>2];r=d+20|0;s=k+4|0;w=f[s>>2]|0;f[r>>2]=w;H=d+24|0;f[H>>2]=f[k+8>>2];f[d+28>>2]=f[k+12>>2];f[d+32>>2]=f[k+16>>2];f[d+36>>2]=f[k+20>>2];f[d+40>>2]=f[k+24>>2];f[d+44>>2]=f[k+28>>2];f[d+48>>2]=f[k+32>>2];O=f[k+36>>2]|0;f[d+52>>2]=O;f[d+56>>2]=H;H=d+64|0;N=d+60|0;f[N>>2]=H;f[H>>2]=0;f[d+68>>2]=0;if(!O)R=w;else{w=O+12|0;f[w>>2]=(f[w>>2]|0)+1;R=f[s>>2]|0}if((R|0)<3){R=f[k+44>>2]|0;s=f[N>>2]|0;f[s>>2]=f[R>>2];f[s+4>>2]=f[R+4>>2]}else{f[r>>2]=0;U$(o,k)}o=d+72|0;f[o>>2]=f[h>>2];r=d+76|0;R=f[y>>2]|0;f[r>>2]=R;s=d+80|0;f[s>>2]=f[a+88>>2];f[d+84>>2]=f[a+92>>2];f[d+88>>2]=f[a+96>>2];f[d+92>>2]=f[a+100>>2];f[d+96>>2]=f[a+104>>2];f[d+100>>2]=f[a+108>>2];f[d+104>>2]=f[a+112>>2];N=f[a+116>>2]|0;f[d+108>>2]=N;f[d+112>>2]=s;s=d+120|0;w=d+116|0;f[w>>2]=s;f[s>>2]=0;f[d+124>>2]=0;if(!N)S=R;else{R=N+12|0;f[R>>2]=(f[R>>2]|0)+1;S=f[y>>2]|0}if((S|0)<3){S=f[a+124>>2]|0;R=f[w>>2]|0;f[R>>2]=f[S>>2];f[R+4>>2]=f[S+4>>2]}else{f[r>>2]=0;U$(o,h)}f[d+128>>2]=D;f[d+132>>2]=E;f[d+136>>2]=f[m>>2];f[d+140>>2]=K;n[d+144>>2]=I;TXc(d);UXc(d);P=q;Q=d}d=Y(f[l>>2]|0,f[m>>2]|0)|0;f[g>>2]=0;f[g+4>>2]=d;h3(g,P,-1.0);do if(!(dS(c,-1)|0)){P=$Xc(1280)|0;f[P+4>>2]=0;f[P+8>>2]=0;f[P>>2]=53396;d=P+12|0;f[d>>2]=53424;q=P+16|0;f[q>>2]=f[M>>2];K=P+20|0;o=i+4|0;r=f[o>>2]|0;f[K>>2]=r;S=P+24|0;R=i+8|0;f[S>>2]=f[R>>2];w=i+12|0;f[P+28>>2]=f[w>>2];f[P+32>>2]=f[i+16>>2];f[P+36>>2]=f[i+20>>2];f[P+40>>2]=f[i+24>>2];f[P+44>>2]=f[i+28>>2];f[P+48>>2]=f[i+32>>2];N=f[i+36>>2]|0;f[P+52>>2]=N;f[P+56>>2]=S;S=P+64|0;s=P+60|0;f[s>>2]=S;f[S>>2]=0;f[P+68>>2]=0;if(!N)T=r;else{r=N+12|0;f[r>>2]=(f[r>>2]|0)+1;T=f[o>>2]|0}if((T|0)<3){o=f[i+44>>2]|0;r=f[s>>2]|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2]}else{f[K>>2]=0;U$(q,i)}q=P+72|0;f[q>>2]=f[j>>2];K=P+76|0;o=j+4|0;r=f[o>>2]|0;f[K>>2]=r;s=P+80|0;f[s>>2]=f[j+8>>2];f[P+84>>2]=f[j+12>>2];f[P+88>>2]=f[j+16>>2];f[P+92>>2]=f[j+20>>2];f[P+96>>2]=f[j+24>>2];f[P+100>>2]=f[j+28>>2];f[P+104>>2]=f[j+32>>2];N=f[j+36>>2]|0;f[P+108>>2]=N;f[P+112>>2]=s;s=P+120|0;S=P+116|0;f[S>>2]=s;f[s>>2]=0;f[P+124>>2]=0;if(!N)U=r;else{r=N+12|0;f[r>>2]=(f[r>>2]|0)+1;U=f[o>>2]|0}if((U|0)<3){o=f[j+44>>2]|0;r=f[S>>2]|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2]}else{f[K>>2]=0;U$(q,j)}q=P+128|0;f[q>>2]=f[h>>2];K=P+132|0;o=f[y>>2]|0;f[K>>2]=o;r=P+136|0;f[r>>2]=f[a+88>>2];f[P+140>>2]=f[a+92>>2];f[P+144>>2]=f[a+96>>2];f[P+148>>2]=f[a+100>>2];f[P+152>>2]=f[a+104>>2];f[P+156>>2]=f[a+108>>2];f[P+160>>2]=f[a+112>>2];S=f[a+116>>2]|0;f[P+164>>2]=S;f[P+168>>2]=r;r=P+176|0;N=P+172|0;f[N>>2]=r;f[r>>2]=0;f[P+180>>2]=0;if(!S)V=o;else{o=S+12|0;f[o>>2]=(f[o>>2]|0)+1;V=f[y>>2]|0}if((V|0)<3){o=f[a+124>>2]|0;S=f[N>>2]|0;f[S>>2]=f[o>>2];f[S+4>>2]=f[o+4>>2]}else{f[K>>2]=0;U$(q,h)}f[P+184>>2]=D;f[P+188>>2]=E;q=P+192|0;K=f[m>>2]|0;f[q>>2]=K;f[P+196>>2]=f[l>>2];o=P+200|0;S=P+208|0;f[o>>2]=S;N=f[w>>2]|0;w=N<<2;f[P+204>>2]=w;if(w>>>0>264){s=bYc(w>>>0>1073741823?-1:w<<2)|0;f[o>>2]=s;W=s}else W=S;f[P+1264>>2]=W;S=W+(N<<2)|0;f[P+1268>>2]=S;s=S+(N<<2)|0;f[P+1272>>2]=s;o=s+(N<<2)|0;f[P+1276>>2]=o;w=f[r>>2]|0;I=1.0/+(D|0);a:do if((N|0)>0){r=N+-1|0;O=0;H=K;while(1){J=I*+(O|0)+-.5;x=~~J;v=x-(+(x|0)>J&1)|0;x=v+1|0;X=J-+(v|0);n[s+(O<<2)>>2]=X;n[o+(O<<2)>>2]=1.0-X;C=H+-1|0;F=Y((v|0)>0?v:0,w)|0;f[W+(O<<2)>>2]=F;F=Y((C|0)<(x|0)?C:x,w)|0;f[S+(O<<2)>>2]=F;if((O|0)==(r|0))break a;O=O+1|0;H=f[q>>2]|0}}while(0);TXc(P);UXc(P);Z=R;_=d;$=P}else{if((dS(c,-1)|0)!=2){Z=i+8|0;_=0;$=0;break}q=$Xc(1280)|0;f[q+4>>2]=0;f[q+8>>2]=0;f[q>>2]=53444;S=q+12|0;f[S>>2]=53472;w=q+16|0;f[w>>2]=f[M>>2];o=q+20|0;s=i+4|0;K=f[s>>2]|0;f[o>>2]=K;N=q+24|0;H=i+8|0;f[N>>2]=f[H>>2];O=i+12|0;f[q+28>>2]=f[O>>2];f[q+32>>2]=f[i+16>>2];f[q+36>>2]=f[i+20>>2];f[q+40>>2]=f[i+24>>2];f[q+44>>2]=f[i+28>>2];f[q+48>>2]=f[i+32>>2];r=f[i+36>>2]|0;f[q+52>>2]=r;f[q+56>>2]=N;N=q+64|0;F=q+60|0;f[F>>2]=N;f[N>>2]=0;f[q+68>>2]=0;if(!r)aa=K;else{K=r+12|0;f[K>>2]=(f[K>>2]|0)+1;aa=f[s>>2]|0}if((aa|0)<3){s=f[i+44>>2]|0;K=f[F>>2]|0;f[K>>2]=f[s>>2];f[K+4>>2]=f[s+4>>2]}else{f[o>>2]=0;U$(w,i)}w=q+72|0;f[w>>2]=f[j>>2];o=q+76|0;s=j+4|0;K=f[s>>2]|0;f[o>>2]=K;F=q+80|0;f[F>>2]=f[j+8>>2];f[q+84>>2]=f[j+12>>2];f[q+88>>2]=f[j+16>>2];f[q+92>>2]=f[j+20>>2];f[q+96>>2]=f[j+24>>2];f[q+100>>2]=f[j+28>>2];f[q+104>>2]=f[j+32>>2];r=f[j+36>>2]|0;f[q+108>>2]=r;f[q+112>>2]=F;F=q+120|0;N=q+116|0;f[N>>2]=F;f[F>>2]=0;f[q+124>>2]=0;if(!r)ba=K;else{K=r+12|0;f[K>>2]=(f[K>>2]|0)+1;ba=f[s>>2]|0}if((ba|0)<3){s=f[j+44>>2]|0;K=f[N>>2]|0;f[K>>2]=f[s>>2];f[K+4>>2]=f[s+4>>2]}else{f[o>>2]=0;U$(w,j)}w=q+128|0;f[w>>2]=f[h>>2];o=q+132|0;s=f[y>>2]|0;f[o>>2]=s;K=q+136|0;f[K>>2]=f[a+88>>2];f[q+140>>2]=f[a+92>>2];f[q+144>>2]=f[a+96>>2];f[q+148>>2]=f[a+100>>2];f[q+152>>2]=f[a+104>>2];f[q+156>>2]=f[a+108>>2];f[q+160>>2]=f[a+112>>2];N=f[a+116>>2]|0;f[q+164>>2]=N;f[q+168>>2]=K;K=q+176|0;r=q+172|0;f[r>>2]=K;f[K>>2]=0;f[q+180>>2]=0;if(!N)ca=s;else{s=N+12|0;f[s>>2]=(f[s>>2]|0)+1;ca=f[y>>2]|0}if((ca|0)<3){s=f[a+124>>2]|0;N=f[r>>2]|0;f[N>>2]=f[s>>2];f[N+4>>2]=f[s+4>>2]}else{f[o>>2]=0;U$(w,h)}f[q+184>>2]=D;f[q+188>>2]=E;w=q+192|0;o=f[m>>2]|0;f[w>>2]=o;f[q+196>>2]=f[l>>2];s=q+200|0;N=q+208|0;f[s>>2]=N;r=f[O>>2]|0;O=r<<2;f[q+204>>2]=O;if(O>>>0>264){F=bYc(O>>>0>1073741823?-1:O<<2)|0;f[s>>2]=F;da=F}else da=N;f[q+1264>>2]=da;N=da+(r<<2)|0;f[q+1268>>2]=N;F=N+(r<<2)|0;f[q+1272>>2]=F;s=F+(r<<2)|0;f[q+1276>>2]=s;O=(f[K>>2]|0)>>>1;I=1.0/+(D|0);b:do if((r|0)>0){K=r+-1|0;x=0;C=o;while(1){X=I*+(x|0)+-.5;v=~~X;t=v-(+(v|0)>X&1)|0;v=t+1|0;J=X-+(t|0);n[F+(x<<2)>>2]=J;n[s+(x<<2)>>2]=1.0-J;G=C+-1|0;A=Y((t|0)>0?t:0,O)|0;f[da+(x<<2)>>2]=A;A=Y((G|0)<(v|0)?G:v,O)|0;f[N+(x<<2)>>2]=A;if((x|0)==(K|0))break b;x=x+1|0;C=f[w>>2]|0}}while(0);TXc(q);UXc(q);Z=H;_=S;$=q}while(0);da=f[Z>>2]|0;f[g>>2]=0;f[g+4>>2]=da;h3(g,_,-1.0);if($|0)UXc($);UXc(Q);Q=k+36|0;$=f[Q>>2]|0;if($|0?(_=$+12|0,$=f[_>>2]|0,f[_>>2]=$+-1,($|0)==1):0)V$(k);f[Q>>2]=0;Q=k+16|0;$=k+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[$>>2]|0)>0){Q=f[k+40>>2]|0;_=0;do{f[Q+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[$>>2]|0))}$=f[k+44>>2]|0;if(($|0)!=(k+48|0))wL($);$=j+36|0;k=f[$>>2]|0;if(k|0?(_=k+12|0,k=f[_>>2]|0,f[_>>2]=k+-1,(k|0)==1):0)V$(j);f[$>>2]=0;$=j+16|0;k=j+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[k>>2]|0)>0){$=f[j+40>>2]|0;_=0;do{f[$+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(_=j+12|0,j=f[_>>2]|0,f[_>>2]=j+-1,(j|0)==1):0)V$(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[L>>2]|0;L=0;do{f[k+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=e;return}wL(j);u=e;return}function Ypa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function Zpa(a){a=a|0;return +(+p[a+8>>3])}function _pa(a,b){a=a|0;b=b|0;f[a+16>>2]=f[b>>2];f[a+20>>2]=f[b+4>>2];return}function $pa(a,b){a=a|0;b=b|0;var c=0;c=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=c;return}function aqa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=a+80|0;d=a+116|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+96|0;b=a+84|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)<=0)return;d=f[a+120>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0));return}function bqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53472;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)dYc(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))wL(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)V$(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))wL(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;wL(d);return}function cqa(a){a=a|0;bqa(a);cYc(a);return}function dqa(a,b){a=a|0;b=b|0;var c=0.0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;c=1.0/+(f[a+176>>2]|0);e=f[b>>2]|0;g=f[b+4>>2]|0;if((e|0)>=(g|0))return;b=f[a+20>>2]|0;h=f[f[a+48>>2]>>2]|0;i=f[a+76>>2]|0;k=f[f[a+104>>2]>>2]|0;l=(f[a+184>>2]|0)+-1|0;m=f[a+180>>2]|0;o=f[a+132>>2]|0;p=f[f[a+160>>2]>>2]|0;q=f[a+16>>2]|0;if((q|0)<=0)return;r=f[a+1252>>2]|0;s=f[a+1256>>2]|0;t=f[a+1264>>2]|0;u=f[a+1260>>2]|0;a=e;do{e=b+(Y(h,a)|0)|0;v=i+(Y(k,a)|0)|0;w=c*+(a|0)+-.5;x=~~w;y=x-(+(x|0)>w&1)|0;x=y+1|0;z=w-+(y|0);w=1.0-z;A=o+(Y(Y(m,(y|0)>0?y:0)|0,p)|0)|0;y=o+(Y(Y((l|0)<(x|0)?l:x,m)|0,p)|0)|0;x=0;do{B=j[e+(x<<1)>>1]|0;C=(f[r+(x<<2)>>2]|0)+B|0;D=(f[s+(x<<2)>>2]|0)+B|0;E=+n[t+(x<<2)>>2];F=+n[u+(x<<2)>>2];B=ALc(w*(+(j[A+(C<<1)>>1]|0)*E+ +(j[A+(D<<1)>>1]|0)*F)+z*(E*+(j[y+(C<<1)>>1]|0)+F*+(j[y+(D<<1)>>1]|0)))|0;d[v+(x<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+1|0}while((x|0)<(q|0));a=a+1|0}while((a|0)<(g|0));return}function eqa(a){a=a|0;f[a>>2]=53444;bqa(a+12|0);NXc(a);return}function fqa(a){a=a|0;f[a>>2]=53444;bqa(a+12|0);NXc(a);cYc(a);return}function gqa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function hqa(a){a=a|0;cYc(a);return}function iqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53424;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)dYc(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))wL(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)V$(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))wL(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;wL(d);return}function jqa(a){a=a|0;iqa(a);cYc(a);return}function kqa(a,c){a=a|0;c=c|0;var d=0.0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0;d=1.0/+(f[a+176>>2]|0);e=f[c>>2]|0;g=c+4|0;c=f[g>>2]|0;if((e|0)>=(c|0))return;i=a+20|0;j=a+48|0;k=a+76|0;l=a+104|0;m=a+184|0;o=a+180|0;p=a+132|0;q=a+160|0;r=a+16|0;s=a+1252|0;t=a+1256|0;u=a+1264|0;v=a+1260|0;a=e;e=c;c=f[r>>2]|0;while(1){w=(f[i>>2]|0)+(Y(f[f[j>>2]>>2]|0,a)|0)|0;x=(f[k>>2]|0)+(Y(f[f[l>>2]>>2]|0,a)|0)|0;y=d*+(a|0)+-.5;z=~~y;A=z-(+(z|0)>y&1)|0;z=A+1|0;B=y-+(A|0);y=1.0-B;C=(f[m>>2]|0)+-1|0;D=f[o>>2]|0;E=Y(D,(A|0)>0?A:0)|0;A=f[p>>2]|0;F=f[f[q>>2]>>2]|0;G=A+(Y(E,F)|0)|0;E=A+(Y(Y((C|0)<(z|0)?C:z,D)|0,F)|0)|0;if((c|0)>0){F=0;do{D=h[w+F>>0]|0;z=(f[(f[s>>2]|0)+(F<<2)>>2]|0)+D|0;C=(f[(f[t>>2]|0)+(F<<2)>>2]|0)+D|0;H=+n[(f[u>>2]|0)+(F<<2)>>2];I=+n[(f[v>>2]|0)+(F<<2)>>2];D=ALc(y*(+(h[G+z>>0]|0)*H+ +(h[G+C>>0]|0)*I)+B*(H*+(h[E+z>>0]|0)+I*+(h[E+C>>0]|0)))|0;b[x+F>>0]=D>>>0<256?D:(D|0)>0?255:0;F=F+1|0;J=f[r>>2]|0}while((F|0)<(J|0));K=J;L=f[g>>2]|0}else{K=c;L=e}a=a+1|0;if((a|0)>=(L|0))break;else{e=L;c=K}}return}function lqa(a){a=a|0;f[a>>2]=53396;iqa(a+12|0);NXc(a);return}function mqa(a){a=a|0;f[a>>2]=53396;iqa(a+12|0);NXc(a);cYc(a);return}function nqa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function oqa(a){a=a|0;cYc(a);return}function pqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53376;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function qqa(a){a=a|0;pqa(a);cYc(a);return}function rqa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0;c=u;u=u+262224|0;e=c+262200|0;g=c+262144|0;h=c;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=b+4|0;if((i|0)>=(f[l>>2]|0)){u=c;return}b=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,i)|0)|0;a=i;while(1){i=f[b>>2]|0;E=f[m>>2]|0;F=Y(E,(a|0)%(i|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(a|0)/(i|0)|0)|0;f[p>>2]=G;f[q>>2]=E;f[r>>2]=F;Z$(g,s,e);g1c(h|0,0,262144)|0;F=f[r>>2]|0;E=(f[t>>2]|0)>>>1;G=f[v>>2]|0;i=F+-1|0;a:do if(F|0){H=f[q>>2]|0;I=H+-4|0;if((H|0)<4){J=(H|0)>0;K=G;L=i;while(1){if(J){M=0;do{N=h+((j[K+(M<<1)>>1]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;M=M+1|0}while((M|0)!=(H|0))}if(!L)break a;else{K=K+(E<<1)|0;L=L+-1|0}}}L=H&-4;K=(L|0)<(H|0);J=G;M=i;while(1){N=0;do{O=j[J+((N|1)<<1)>>1]|0;P=h+((j[J+(N<<1)>>1]|0)<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=h+(O<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=j[J+((N|3)<<1)>>1]|0;O=h+((j[J+((N|2)<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;O=h+(P<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+4|0}while((N|0)<=(I|0));if(K){N=L;do{O=h+((j[J+(N<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+1|0}while((N|0)!=(H|0))}if(!M)break;else{J=J+(E<<1)|0;M=M+-1|0}}}while(0);E=f[x>>2]|0;if((E|0)>0){i=0;G=0;while(1){F=h+(i<<2)|0;M=f[F>>2]|0;if((M|0)>(E|0)){f[F>>2]=E;Q=M+G-E|0}else Q=G;i=i+1|0;if((i|0)==65536)break;else G=Q}G=(Q|0)/65536|0;i=G<<16;E=0;do{M=h+(E<<2)|0;f[M>>2]=(f[M>>2]|0)+G;E=E+1|0}while((E|0)!=65536);E=Q-i|0;if(E|0?(G=65536/(E|0)|0,M=(G|0)>1?G:1,(E|0)>0):0){G=0;F=E;while(1){E=h+(G<<2)|0;f[E>>2]=(f[E>>2]|0)+1;G=G+M|0;if(!((F|0)>1&(G|0)<65536))break;else F=F+-1|0}}}R=+n[y>>2];F=0;G=0;do{F=(f[h+(G<<2)>>2]|0)+F|0;M=ALc(R*+(F|0))|0;d[D+(G<<1)>>1]=M>>>0<65536?M:(M|0)>0?65535:0;G=G+1|0}while((G|0)!=65536);G=f[z>>2]|0;if(G|0?(F=G+12|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)V$(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){G=f[B>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[A>>2]|0))}F=f[w>>2]|0;if((F|0)!=(C|0))wL(F);a=a+1|0;if((a|0)>=(f[l>>2]|0))break;else D=D+(k<<1)|0}u=c;return}function sqa(a){a=a|0;f[a>>2]=53348;pqa(a+12|0);NXc(a);return}function tqa(a){a=a|0;f[a>>2]=53348;pqa(a+12|0);NXc(a);cYc(a);return}function uqa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function vqa(a){a=a|0;cYc(a);return}function wqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53328;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))wL(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function xqa(a){a=a|0;wqa(a);cYc(a);return}function yqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+1104|0;e=d+1080|0;g=d+1024|0;i=d;j=f[c>>2]|0;k=f[a+108>>2]|0;l=c+4|0;if((j|0)>=(f[l>>2]|0)){u=d;return}c=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,j)|0)|0;a=j;while(1){j=f[c>>2]|0;E=f[m>>2]|0;F=Y(E,(a|0)%(j|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(a|0)/(j|0)|0)|0;f[p>>2]=G;f[q>>2]=E;f[r>>2]=F;Z$(g,s,e);g1c(i|0,0,1024)|0;F=f[r>>2]|0;E=f[t>>2]|0;if(F|0){G=f[q>>2]|0;j=(G|0)<4;H=G+-4|0;I=f[v>>2]|0;J=F;while(1){J=J+-1|0;if(j)K=0;else{F=0;while(1){L=h[I+(F|1)>>0]|0;M=i+((h[I+F>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=i+(L<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[I+(F|3)>>0]|0;L=i+((h[I+(F|2)>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=i+(M<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=F+4|0;if((L|0)>(H|0)){K=L;break}else F=L}}if((K|0)<(G|0)){F=K;do{L=i+((h[I+F>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;F=F+1|0}while((F|0)!=(G|0))}if(!J)break;else I=I+E|0}}E=f[x>>2]|0;if((E|0)>0){I=0;J=0;while(1){G=i+(I<<2)|0;H=f[G>>2]|0;if((H|0)>(E|0)){f[G>>2]=E;N=H+J-E|0}else N=J;I=I+1|0;if((I|0)==256)break;else J=N}J=(N|0)/256|0;I=J<<8;E=0;do{H=i+(E<<2)|0;f[H>>2]=(f[H>>2]|0)+J;E=E+1|0}while((E|0)!=256);E=N-I|0;if((E|0)!=0?(J=256/(E|0)|0,H=(J|0)>1?J:1,(E|0)>0):0){J=0;G=E;while(1){E=i+(J<<2)|0;f[E>>2]=(f[E>>2]|0)+1;J=J+H|0;if(!((G|0)>1&(J|0)<256)){O=0;P=0;break}else G=G+-1|0}}else{O=0;P=0}}else{O=0;P=0}do{O=(f[i+(P<<2)>>2]|0)+O|0;G=ALc(+n[y>>2]*+(O|0))|0;b[D+P>>0]=G>>>0<256?G:(G|0)>0?255:0;P=P+1|0}while((P|0)!=256);G=f[z>>2]|0;if(G|0?(J=G+12|0,G=f[J>>2]|0,f[J>>2]=G+-1,(G|0)==1):0)V$(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){G=f[B>>2]|0;J=0;do{f[G+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[A>>2]|0))}J=f[w>>2]|0;if((J|0)!=(C|0))wL(J);a=a+1|0;if((a|0)>=(f[l>>2]|0))break;else D=D+k|0}u=d;return}function zqa(a){a=a|0;f[a>>2]=53300;wqa(a+12|0);NXc(a);return}function Aqa(a){a=a|0;f[a>>2]=53300;wqa(a+12|0);NXc(a);cYc(a);return}function Bqa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Cqa(a){a=a|0;cYc(a);return}function Dqa(a){a=a|0;f[a>>2]=53208;Vpa(a+16|0);NXc(a);return}function Eqa(a){a=a|0;f[a>>2]=53208;Vpa(a+16|0);NXc(a);cYc(a);return}function Fqa(a){a=a|0;Vpa(a+16|0);return}function Gqa(a){a=a|0;cYc(a);return}function Hqa(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0;g=u;u=u+16|0;h=g;if((c|0)<=0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=5;b[h>>0]=b[468382]|0;b[h+1>>0]=b[468383]|0;b[h+2>>0]=b[468384]|0;b[h+3>>0]=b[468385]|0;b[h+4>>0]=b[468386]|0;b[h+5>>0]=0;vM(-215,h,272904,272922,63)}i=d<=0.0&((c|0)<8&(c&1|0)!=0)?53484+((c>>>1)*28|0)|0:0;j=(e|0)==5;if((e+-5|0)>>>0>=2){k=$Xc(48)|0;f[h>>2]=k;f[h+8>>2]=-2147483600;f[h+4>>2]=34;l=k;m=272993;o=l+34|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));b[k+34>>0]=0;vM(-215,h,272904,272922,76)}f[a>>2]=1124007936;k=a+8|0;m=a+40|0;l=a+4|0;o=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(o|0));f[m>>2]=k;k=a+48|0;f[a+44>>2]=k;f[k>>2]=0;f[a+52>>2]=0;f[h>>2]=c;f[h+4>>2]=1;S$(a,2,h,e&4095);e=f[a+16>>2]|0;q=+(c+-1|0)*.5;r=d>0.0?d:(q+-1.0)*.3+.8;d=-.5/(r*r);if(i)if(j){a=0;r=0.0;while(1){s=+n[i+(a<<2)>>2];n[e+(a<<2)>>2]=s;t=r+s;a=a+1|0;if((a|0)==(c|0)){v=t;break}else r=t}}else{a=0;r=0.0;while(1){t=+n[i+(a<<2)>>2];p[e+(a<<3)>>3]=t;s=r+t;a=a+1|0;if((a|0)==(c|0)){v=s;break}else r=s}}else{a=0;r=0.0;while(1){s=+(a|0)-q;t=+V(+(s*(d*s)));if(j){s=t;n[e+(a<<2)>>2]=s;w=s}else{p[e+(a<<3)>>3]=t;w=t}t=r+w;a=a+1|0;if((a|0)==(c|0)){v=t;break}else r=t}}r=1.0/v;if(j){j=0;do{a=e+(j<<2)|0;n[a>>2]=r*+n[a>>2];j=j+1|0}while((j|0)!=(c|0));u=g;return}else{j=0;do{a=e+(j<<3)|0;p[a>>3]=r*+p[a>>3];j=j+1|0}while((j|0)!=(c|0));u=g;return}}function Iqa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+64|0;j=i;k=d&7;l=!(h<=0.0)?h:g;d=f[e>>2]|0;if(g>0.0&(d|0)<1){m=zLc(((k|0)==0?3.0:4.0)*g*2.0+1.0)|0|1;f[e>>2]=m;n=m}else n=d;d=e+4|0;m=f[d>>2]|0;if(l>0.0&(m|0)<1){o=zLc(((k|0)==0?3.0:4.0)*l*2.0+1.0)|0|1;f[d>>2]=o;p=o}else p=m;if(!((n|0)>0&((n|0)%2|0|0)==1)){q=$Xc(96)|0;f[j>>2]=q;r=j+8|0;f[r>>2]=-2147483552;s=j+4|0;f[s>>2]=84;t=q;v=273028;w=t+84|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+84|0;b[x>>0]=0;vM(-215,j,273113,272922,2140)}if(!((p|0)>0&((p|0)%2|0|0)==1)){q=$Xc(96)|0;f[j>>2]=q;r=j+8|0;f[r>>2]=-2147483552;s=j+4|0;f[s>>2]=84;t=q;v=273028;w=t+84|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+84|0;b[x>>0]=0;vM(-215,j,273113,272922,2140)}h=g<0.0?0.0:g;g=l<0.0?0.0:l;x=k>>>0>5?k:5;Hqa(j,n,h,x);n=a+36|0;k=f[n>>2]|0;if((j|0)==(a|0)){q=j+36|0;if((k|0)!=0?(v=k+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){V$(j);y=q}else y=q}else{if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)V$(a);f[n>>2]=0;k=a+16|0;q=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[q>>2]|0)>0){s=f[a+40>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[q>>2]|0))}f[a>>2]=f[j>>2];v=j+4|0;s=f[v>>2]|0;f[q>>2]=s;q=j+8|0;r=a+8|0;f[r>>2]=f[q>>2];f[a+12>>2]=f[j+12>>2];f[k>>2]=f[j+16>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];k=j+36|0;f[n>>2]=f[k>>2];n=a+44|0;p=f[n>>2]|0;m=a+48|0;if((p|0)==(m|0)){z=s;A=p}else{wL(p);f[n>>2]=m;f[a+40>>2]=r;z=f[v>>2]|0;A=m}m=j+44|0;if((z|0)<3){z=f[m>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2]}else{f[n>>2]=f[m>>2];n=j+40|0;f[a+40>>2]=f[n>>2];f[m>>2]=j+48;f[n>>2]=q}f[j>>2]=1124007936;t=v;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));y=k}f[y>>2]=0;y=j+16|0;k=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[k>>2]|0)>0){y=f[j+40>>2]|0;v=0;do{f[y+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);k=f[d>>2]|0;if((k|0)==(f[e>>2]|0)?+L(+(h-g))<2.220446049250313e-16:0){if((c|0)==(a|0)){u=i;return}e=a+36|0;d=f[e>>2]|0;if(d|0){v=d+12|0;f[v>>2]=(f[v>>2]|0)+1}v=c+36|0;d=f[v>>2]|0;if(d|0?(y=d+12|0,d=f[y>>2]|0,f[y>>2]=d+-1,(d|0)==1):0)V$(c);f[v>>2]=0;d=c+16|0;y=c+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[y>>2]|0)>0){q=f[c+40>>2]|0;n=0;do{f[q+(n<<2)>>2]=0;n=n+1|0;B=f[y>>2]|0}while((n|0)<(B|0));f[c>>2]=f[a>>2];if((B|0)<3)C=42;else C=44}else{f[c>>2]=f[a>>2];C=42}if((C|0)==42){B=f[a+4>>2]|0;if((B|0)<3){f[y>>2]=B;f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];B=f[a+44>>2]|0;y=f[c+44>>2]|0;f[y>>2]=f[B>>2];f[y+4>>2]=f[B+4>>2]}else C=44}if((C|0)==44)U$(c,a);f[d>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[v>>2]=f[e>>2];u=i;return}Hqa(j,k,g,x);x=c+36|0;k=f[x>>2]|0;if((j|0)==(c|0)){e=j+36|0;if((k|0)!=0?(v=k+12|0,a=f[v>>2]|0,f[v>>2]=a+-1,(a|0)==1):0){V$(j);D=e}else D=e}else{if(k|0?(e=k+12|0,k=f[e>>2]|0,f[e>>2]=k+-1,(k|0)==1):0)V$(c);f[x>>2]=0;k=c+16|0;e=c+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[e>>2]|0)>0){a=f[c+40>>2]|0;v=0;do{f[a+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[e>>2]|0))}f[c>>2]=f[j>>2];v=j+4|0;a=f[v>>2]|0;f[e>>2]=a;e=j+8|0;d=c+8|0;f[d>>2]=f[e>>2];f[c+12>>2]=f[j+12>>2];f[k>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+28>>2]=f[j+28>>2];f[c+32>>2]=f[j+32>>2];k=j+36|0;f[x>>2]=f[k>>2];x=c+44|0;C=f[x>>2]|0;B=c+48|0;if((C|0)==(B|0)){E=a;F=C}else{wL(C);f[x>>2]=B;f[c+40>>2]=d;E=f[v>>2]|0;F=B}B=j+44|0;if((E|0)<3){E=f[B>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2]}else{f[x>>2]=f[B>>2];x=j+40|0;f[c+40>>2]=f[x>>2];f[B>>2]=j+48;f[x>>2]=e}f[j>>2]=1124007936;t=v;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));D=k}f[D>>2]=0;D=j+16|0;k=j+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[k>>2]|0)>0){D=f[j+40>>2]|0;t=0;do{f[D+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))wL(k);u=i;return}function Jqa(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;j=u;u=u+416|0;k=j+352|0;l=j+336|0;m=j+344|0;n=j+280|0;o=j+224|0;p=j+168|0;q=j+112|0;r=j+104|0;s=j+96|0;t=j+80|0;v=j+56|0;w=j;x=j+72|0;y=dS(a,-1)|0;cS(l,a,-1);f[m>>2]=f[l>>2];z=l+4|0;f[m+4>>2]=f[z>>2];wS(c,m,y,-1,0,0);m=i&-17;do if(m|0){if(!(i&16)){do if((eS(a)|0)==65536){A=f[a+4>>2]|0;f[k>>2]=f[A>>2];B=k+4|0;C=A+4|0;f[B>>2]=f[C>>2];D=k+8|0;f[D>>2]=f[A+8>>2];f[k+12>>2]=f[A+12>>2];f[k+16>>2]=f[A+16>>2];f[k+20>>2]=f[A+20>>2];f[k+24>>2]=f[A+24>>2];f[k+28>>2]=f[A+28>>2];f[k+32>>2]=f[A+32>>2];E=k+36|0;F=f[A+36>>2]|0;f[E>>2]=F;f[k+40>>2]=D;D=k+48|0;G=k+44|0;f[G>>2]=D;f[D>>2]=0;f[k+52>>2]=0;if(F|0){D=F+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[G>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];H=E;I=k;break}else{f[B>>2]=0;U$(k,A);H=E;I=k;break}}else{bS(k,a,-1);H=k+36|0;I=k}while(0);E=(f[I>>2]&32768|0)==0;A=f[H>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)V$(k);f[H>>2]=0;A=k+16|0;B=k+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[k+40>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[B>>2]|0))}B=f[k+44>>2]|0;if((B|0)!=(k+48|0))wL(B);if(!E)break}if((f[z>>2]|0)==1)f[e+4>>2]=1;if((f[l>>2]|0)==1)f[e>>2]=1}while(0);if((f[e>>2]|0)==1?(f[e+4>>2]|0)==1:0){uS(a,c);u=j;return}l=y&7;f[n>>2]=1124007936;z=n+4|0;H=n+8|0;I=n+40|0;B=z;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[I>>2]=H;H=n+48|0;A=n+44|0;f[A>>2]=H;f[H>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;D=o+4|0;G=o+8|0;F=o+40|0;B=D;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[F>>2]=G;G=o+48|0;J=o+44|0;f[J>>2]=G;f[G>>2]=0;f[o+52>>2]=0;Iqa(n,o,y,e,g,h);do if((eS(a)|0)==65536){y=f[a+4>>2]|0;f[p>>2]=f[y>>2];K=p+4|0;M=y+4|0;f[K>>2]=f[M>>2];N=p+8|0;f[N>>2]=f[y+8>>2];f[p+12>>2]=f[y+12>>2];f[p+16>>2]=f[y+16>>2];f[p+20>>2]=f[y+20>>2];f[p+24>>2]=f[y+24>>2];f[p+28>>2]=f[y+28>>2];f[p+32>>2]=f[y+32>>2];O=f[y+36>>2]|0;f[p+36>>2]=O;f[p+40>>2]=N;N=p+48|0;P=p+44|0;f[P>>2]=N;f[N>>2]=0;f[p+52>>2]=0;if(O|0){N=O+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[M>>2]|0)<3){M=f[y+44>>2]|0;N=f[P>>2]|0;f[N>>2]=f[M>>2];f[N+4>>2]=f[M+4>>2];break}else{f[K>>2]=0;U$(p,y);break}}else bS(p,a,-1);while(0);do if((eS(c)|0)==65536){y=f[c+4>>2]|0;f[q>>2]=f[y>>2];K=q+4|0;M=y+4|0;f[K>>2]=f[M>>2];N=q+8|0;f[N>>2]=f[y+8>>2];f[q+12>>2]=f[y+12>>2];f[q+16>>2]=f[y+16>>2];f[q+20>>2]=f[y+20>>2];f[q+24>>2]=f[y+24>>2];f[q+28>>2]=f[y+28>>2];f[q+32>>2]=f[y+32>>2];P=f[y+36>>2]|0;f[q+36>>2]=P;f[q+40>>2]=N;N=q+48|0;O=q+44|0;f[O>>2]=N;f[N>>2]=0;f[q+52>>2]=0;if(P|0){N=P+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[M>>2]|0)<3){M=f[y+44>>2]|0;N=f[O>>2]|0;f[N>>2]=f[M>>2];f[N+4>>2]=f[M+4>>2];break}else{f[K>>2]=0;U$(q,y);break}}else bS(q,c,-1);while(0);f[r>>2]=0;f[r+4>>2]=0;c=p+12|0;y=p+8|0;K=f[y>>2]|0;f[s>>2]=f[c>>2];f[s+4>>2]=K;K=(i&16|0)!=0;if(!K)e0(p,s,r);r=p+16|0;s=p+44|0;M=p+44|0;N=q+16|0;O=q+44|0;P=e+4|0;Q=(l|0)==0;if(K|Q^1)if(Q)R=60;else R=155;else{do if((eS(a)|0)==65536){K=f[a+4>>2]|0;f[k>>2]=f[K>>2];S=k+4|0;T=K+4|0;f[S>>2]=f[T>>2];U=k+8|0;f[U>>2]=f[K+8>>2];f[k+12>>2]=f[K+12>>2];f[k+16>>2]=f[K+16>>2];f[k+20>>2]=f[K+20>>2];f[k+24>>2]=f[K+24>>2];f[k+28>>2]=f[K+28>>2];f[k+32>>2]=f[K+32>>2];V=k+36|0;W=f[K+36>>2]|0;f[V>>2]=W;f[k+40>>2]=U;U=k+48|0;X=k+44|0;f[X>>2]=U;f[U>>2]=0;f[k+52>>2]=0;if(W|0){U=W+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[T>>2]|0)<3){T=f[K+44>>2]|0;U=f[X>>2]|0;f[U>>2]=f[T>>2];f[U+4>>2]=f[T+4>>2];Y=k;Z=V;break}else{f[S>>2]=0;U$(k,K);Y=k;Z=V;break}}else{bS(k,a,-1);Y=k;Z=k+36|0}while(0);a=(f[Y>>2]&32768|0)==0;Y=f[Z>>2]|0;if(Y|0?(V=Y+12|0,Y=f[V>>2]|0,f[V>>2]=Y+-1,(Y|0)==1):0)V$(k);f[Z>>2]=0;Z=k+16|0;Y=k+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[Y>>2]|0)>0){Z=f[k+40>>2]|0;V=0;do{f[Z+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[Y>>2]|0))}Y=f[k+44>>2]|0;if((Y|0)!=(k+48|0))wL(Y);if(a)R=60;else R=155}if((R|0)==60){f[t>>2]=0;a=t+4|0;f[a>>2]=0;f[t+8>>2]=0;f[v>>2]=0;Y=v+4|0;f[Y>>2]=0;f[v+8>>2]=0;_=!(h<=0.0)?h:g;V=f[e>>2]|0;if(g>0.0&(V|0)<1){Z=zLc((Q?3.0:4.0)*g*2.0+1.0)|0|1;f[e>>2]=Z;$=Z}else $=V;V=f[P>>2]|0;if(_>0.0&(V|0)<1){Z=zLc(_*(Q?3.0:4.0)*2.0+1.0)|0|1;f[P>>2]=Z;aa=Z}else aa=V;if(!(($|0)>0&(($|0)%2|0|0)==1)){ba=$Xc(96)|0;f[k>>2]=ba;ca=k+8|0;f[ca>>2]=-2147483552;da=k+4|0;f[da>>2]=84;B=ba;ea=273028;C=B+84|0;do{b[B>>0]=b[ea>>0]|0;B=B+1|0;ea=ea+1|0}while((B|0)<(C|0));fa=ba+84|0;b[fa>>0]=0;vM(-215,k,273113,272922,2140)}if(!((aa|0)>0&((aa|0)%2|0|0)==1)){ba=$Xc(96)|0;f[k>>2]=ba;ca=k+8|0;f[ca>>2]=-2147483552;da=k+4|0;f[da>>2]=84;B=ba;ea=273028;C=B+84|0;do{b[B>>0]=b[ea>>0]|0;B=B+1|0;ea=ea+1|0}while((B|0)<(C|0));fa=ba+84|0;b[fa>>0]=0;vM(-215,k,273113,272922,2140)}h=g<0.0?0.0:g;g=_<0.0?0.0:_;Kqa($,h,t);$=f[P>>2]|0;do if(($|0)==(f[e>>2]|0)?+L(+(h-g))<2.220446049250313e-16:0){P=f[t>>2]|0;fa=f[a>>2]|0;ba=fa;ea=P;da=ba-ea|0;ca=da>>1;aa=v+8|0;V=f[aa>>2]|0;Z=f[v>>2]|0;Q=Z;if(ca>>>0<=V-Z>>1>>>0){K=f[Y>>2]|0;S=K-Z>>1;T=ca>>>0>S>>>0;U=T?P+(S<<1)|0:fa;fa=K;S=K;if((U|0)==(P|0))ga=Q;else{K=P;X=Q;while(1){d[X>>1]=d[K>>1]|0;K=K+2|0;if((K|0)==(U|0))break;else X=X+2|0}ga=Q+(((U+-2-ea|0)>>>1)+1<<1)|0}if(T){X=ba-U|0;if((X|0)<=0)break;o1c(S|0,U|0,X|0)|0;f[Y>>2]=(f[Y>>2]|0)+(X>>>1<<1);break}else{if((fa|0)==(ga|0))break;f[Y>>2]=fa+(~((fa+-2-ga|0)>>>1)<<1);break}}X=Z;if(!Z)ha=V;else{K=f[Y>>2]|0;if((K|0)!=(Q|0))f[Y>>2]=K+(~((K+-2-Z|0)>>>1)<<1);cYc(X);f[aa>>2]=0;f[Y>>2]=0;f[v>>2]=0;ha=0}if((da|0)<0)kWc(v);X=ha>>1>>>0<1073741823?(ha>>>0<ca>>>0?ca:ha):2147483647;if((X|0)<0)kWc(v);K=$Xc(X<<1)|0;f[Y>>2]=K;f[v>>2]=K;f[aa>>2]=K+(X<<1);if((da|0)>0){o1c(K|0,P|0,da|0)|0;f[Y>>2]=K+(da>>>1<<1)}}else R=88;while(0);if((R|0)==88)Kqa($,g,v);$=f[r>>2]|0;ha=f[N>>2]|0;if(($|0)==(ha|0)){f[w>>2]=1124007936;ga=w+4|0;e=w+8|0;K=w+40|0;B=ga;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[K>>2]=e;B=w+48|0;f[w+44>>2]=B;f[B>>2]=0;f[w+52>>2]=0;C=k+8|0;f[C>>2]=0;f[C+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=w;jR(p,k);C=p+36|0;X=f[C>>2]|0;if(X|0?(E=X+12|0,X=f[E>>2]|0,f[E>>2]=X+-1,(X|0)==1):0)V$(p);f[C>>2]=0;X=p+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[X>>2]|0)>0){E=f[p+40>>2]|0;W=0;do{f[E+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[X>>2]|0))}f[p>>2]=f[w>>2];W=f[ga>>2]|0;f[X>>2]=W;f[y>>2]=f[e>>2];f[c>>2]=f[w+12>>2];c=w+16|0;f[r>>2]=f[c>>2];f[p+20>>2]=f[w+20>>2];f[p+24>>2]=f[w+24>>2];f[p+28>>2]=f[w+28>>2];f[p+32>>2]=f[w+32>>2];X=w+36|0;f[C>>2]=f[X>>2];C=f[M>>2]|0;E=p+48|0;if((C|0)==(E|0))ia=W;else{wL(C);f[M>>2]=E;f[p+40>>2]=y;ia=f[ga>>2]|0}y=w+44|0;if((ia|0)<3){ia=f[y>>2]|0;f[E>>2]=f[ia>>2];f[p+52>>2]=f[ia+4>>2];ja=ia}else{f[M>>2]=f[y>>2];f[p+40>>2]=f[K>>2];f[y>>2]=B;f[K>>2]=e;ja=B}f[w>>2]=1124007936;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;f[ga+16>>2]=0;f[ga+20>>2]=0;f[ga+24>>2]=0;f[ga+28>>2]=0;f[X>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((ja|0)!=(B|0))wL(ja);ka=p;la=f[r>>2]|0;ma=f[N>>2]|0}else{ka=p;la=$;ma=ha}ha=((f[f[s>>2]>>2]|0)>>>0)/((675553809>>>(f[ka>>2]<<2&28)&15)>>>0)|0;ka=f[q>>2]|0;$=((f[f[O>>2]>>2]|0)>>>0)/((675553809>>>(ka<<2&28)&15)>>>0)|0;ja=f[q+12>>2]|0;B=f[q+8>>2]|0;c=f[t>>2]|0;X=f[a>>2]|0;ga=c;e=X-ga|0;K=e>>1;y=f[v>>2]|0;M=(f[Y>>2]|0)-y|0;ia=M>>1;f[k>>2]=53604;f[k+4>>2]=la;f[k+8>>2]=ma;f[k+12>>2]=ha;f[k+16>>2]=$;f[k+20>>2]=ja;f[k+24>>2]=B;f[k+28>>2]=(ka>>>3&511)+1;f[k+32>>2]=c;f[k+36>>2]=y;f[k+40>>2]=K;f[k+44>>2]=ia;f[k+48>>2]=m;m=X;a:do switch(K|0){case 1:{f[k+52>>2]=(d[c>>1]|0)==256?103:102;break}case 3:{X=d[c>>1]|0;if((X<<16>>16==64?(d[c+2>>1]|0)==128:0)?(d[c+4>>1]|0)==64:0)na=110;else{ka=d[c+4>>1]|0;na=((X&65535)<=(ka&65535)?1:((X&65535)-(ka&65535)&65535)<<16>>16==0)?105:104}f[k+52>>2]=na;break}case 5:{if(((((d[c+4>>1]|0)==96?(d[c+2>>1]|0)==64:0)?(d[c+6>>1]|0)==64:0)?(d[c>>1]|0)==16:0)?(d[c+8>>1]|0)==16:0)oa=111;else if((d[c>>1]|0)==(d[c+8>>1]|0))oa=(d[c+2>>1]|0)==(d[c+6>>1]|0)?107:106;else oa=106;f[k+52>>2]=oa;break}default:{ka=k+52|0;if(((K|0)%2|0|0)!=1){f[ka>>2]=109;break a}f[ka>>2]=108;if((e|0)>2){X=K>>>1;ja=0;while(1){if((d[c+(ja<<1)>>1]|0)!=(d[c+(K+~ja<<1)>>1]|0))break;ja=ja+1|0;if((ja|0)>=(X|0))break a}f[ka>>2]=109}}}while(0);b:do switch(ia|0){case 1:{f[k+56>>2]=(d[y>>1]|0)==256?150:149;break}case 3:{if((d[y>>1]|0)==64?(d[y+2>>1]|0)==128:0)pa=(d[y+4>>1]|0)==64?152:151;else pa=151;f[k+56>>2]=pa;break}case 5:{if((((d[y+4>>1]|0)==96?(d[y+2>>1]|0)==64:0)?(d[y+6>>1]|0)==64:0)?(d[y>>1]|0)==16:0)qa=(d[y+8>>1]|0)==16?154:153;else qa=153;f[k+56>>2]=qa;break}default:{K=k+56|0;if(((ia|0)%2|0|0)!=1){f[K>>2]=156;break b}f[K>>2]=155;if((M|0)>2){e=ia>>>1;oa=0;while(1){if((d[y+(oa<<1)>>1]|0)!=(d[y+(ia+~oa<<1)>>1]|0))break;oa=oa+1|0;if((oa|0)>=(e|0))break b}f[K>>2]=156}}}while(0);f[w>>2]=0;f[w+4>>2]=B;B=i3()|0;ia=j3()|0;y=(ia|0)<(B|0)?ia:B;h3(w,k,+(((y|0)>1?y:1)|0));y=f[v>>2]|0;if(y|0){B=f[Y>>2]|0;if((B|0)!=(y|0))f[Y>>2]=B+(~((B+-2-y|0)>>>1)<<1);cYc(y)}if(c|0){if((m|0)!=(c|0))f[a>>2]=m+(~((m+-2-ga|0)>>>1)<<1);cYc(c)}}else if((R|0)==155){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=p;R=t+8|0;f[R>>2]=0;f[R+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=q;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=n;f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=o;f[x>>2]=-1;f[x+4>>2]=-1;Aja(k,t,l,v,w,x,0.0,i)}i=q+36|0;x=f[i>>2]|0;if(x|0?(w=x+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0)V$(q);f[i>>2]=0;i=q+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[i>>2]|0)>0){N=f[q+40>>2]|0;x=0;do{f[N+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[i>>2]|0))}i=f[O>>2]|0;if((i|0)!=(q+48|0))wL(i);i=p+36|0;q=f[i>>2]|0;if(q|0?(O=q+12|0,q=f[O>>2]|0,f[O>>2]=q+-1,(q|0)==1):0)V$(p);f[i>>2]=0;i=p+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[p+40>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[i>>2]|0))}i=f[s>>2]|0;if((i|0)!=(p+48|0))wL(i);i=o+36|0;p=f[i>>2]|0;if(p|0?(s=p+12|0,p=f[s>>2]|0,f[s>>2]=p+-1,(p|0)==1):0)V$(o);f[i>>2]=0;i=o+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[D>>2]|0)>0){i=f[F>>2]|0;F=0;do{f[i+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[J>>2]|0;if((D|0)!=(G|0))wL(D);D=n+36|0;G=f[D>>2]|0;if(G|0?(J=G+12|0,G=f[J>>2]|0,f[J>>2]=G+-1,(G|0)==1):0)V$(n);f[D>>2]=0;D=n+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[z>>2]|0)>0){D=f[I>>2]|0;I=0;do{f[D+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[z>>2]|0))}z=f[A>>2]|0;if((z|0)!=(H|0))wL(z);u=j;return}function Kqa(a,b,c){a=a|0;b=+b;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+112|0;g=e+104|0;h=e+96|0;i=e+88|0;j=e+80|0;k=e+64|0;l=e+56|0;m=e+40|0;n=e+32|0;o=e+24|0;q=e+16|0;r=e+8|0;s=e;a:do if(!(b<=0.0))t=7;else switch(a|0){case 1:{p[i>>3]=1.0;NGc(h,256);ZGc(g,i,h);v=(RGc(g)|0)&65535;w=$Xc(2)|0;x=w+2|0;d[w>>1]=v;y=w;z=x;A=x;break a;break}case 3:{p[i>>3]=.25;NGc(h,256);ZGc(g,i,h);x=(RGc(g)|0)&65535;p[j>>3]=.5;NGc(h,256);ZGc(g,j,h);w=(RGc(g)|0)&65535;p[k>>3]=.25;NGc(h,256);ZGc(g,k,h);v=(RGc(g)|0)&65535;B=$Xc(6)|0;C=B+6|0;d[B>>1]=x;d[B+2>>1]=w;d[B+4>>1]=v;y=B;z=C;A=C;break a;break}case 5:{p[i>>3]=.0625;NGc(h,256);ZGc(g,i,h);C=(RGc(g)|0)&65535;p[j>>3]=.25;NGc(h,256);ZGc(g,j,h);B=(RGc(g)|0)&65535;p[k>>3]=.375;NGc(h,256);ZGc(g,k,h);v=(RGc(g)|0)&65535;p[l>>3]=.25;NGc(h,256);ZGc(g,l,h);w=(RGc(g)|0)&65535;p[m>>3]=.0625;NGc(h,256);ZGc(g,m,h);x=(RGc(g)|0)&65535;D=$Xc(10)|0;E=D+10|0;d[D>>1]=C;d[D+2>>1]=B;d[D+4>>1]=v;d[D+6>>1]=w;d[D+8>>1]=x;y=D;z=E;A=E;break a;break}case 7:{p[i>>3]=.03125;NGc(h,256);ZGc(g,i,h);E=(RGc(g)|0)&65535;p[j>>3]=.109375;NGc(h,256);ZGc(g,j,h);D=(RGc(g)|0)&65535;p[k>>3]=.21875;NGc(h,256);ZGc(g,k,h);x=(RGc(g)|0)&65535;p[l>>3]=.28125;NGc(h,256);ZGc(g,l,h);w=(RGc(g)|0)&65535;p[m>>3]=.21875;NGc(h,256);ZGc(g,m,h);v=(RGc(g)|0)&65535;p[n>>3]=.109375;NGc(h,256);ZGc(g,n,h);B=(RGc(g)|0)&65535;p[o>>3]=.03125;NGc(h,256);ZGc(g,o,h);C=(RGc(g)|0)&65535;F=$Xc(14)|0;G=F+14|0;d[F>>1]=E;d[F+2>>1]=D;d[F+4>>1]=x;d[F+6>>1]=w;d[F+8>>1]=v;d[F+10>>1]=B;d[F+12>>1]=C;y=F;z=G;A=G;break a;break}default:{t=7;break a}}while(0);if((t|0)==7){if(b>0.0)p[i>>3]=b;else{NGc(g,a);p[h>>3]=.15;p[j>>3]=.35;cHc(i,g,h,j)}p[q>>3]=-.125;ZGc(g,i,i);_Gc(j,q,g);f[k>>2]=0;q=k+4|0;f[q>>2]=0;f[k+8>>2]=0;i=(a|0)==0;if(i){p[l>>3]=0.0;H=0;I=l}else{if(a>>>0>536870911)kWc(k);t=a<<3;o=$Xc(t)|0;f[k>>2]=o;G=o+(a<<3)|0;f[k+8>>2]=G;g1c(o|0,0,t|0)|0;f[q>>2]=G;p[l>>3]=0.0;G=1-a|0;t=0;while(1){NGc(r,Y(G,G)|0);ZGc(h,r,j);dHc(g,h);o=(f[k>>2]|0)+(t<<3)|0;if((g|0)!=(o|0)){F=g;C=f[F+4>>2]|0;B=o;f[B>>2]=f[F>>2];f[B+4>>2]=C}VGc(g,l,o);o=g;C=f[o+4>>2]|0;B=l;f[B>>2]=f[o>>2];f[B+4>>2]=C;t=t+1|0;if((t|0)>=(a|0)){H=1;I=l;break}else G=G+2|0}}G=s;f[G>>2]=0;f[G+4>>2]=1072693248;_Gc(g,s,l);s=g;G=f[s+4>>2]|0;I=l;f[I>>2]=f[s>>2];f[I+4>>2]=G;f[m>>2]=0;G=m+4|0;f[G>>2]=0;f[m+8>>2]=0;do if(!i)if((a|0)<0)kWc(m);else{I=a<<1;s=$Xc(I)|0;f[m>>2]=s;t=s+(a<<1)|0;f[m+8>>2]=t;g1c(s|0,0,I|0)|0;f[G>>2]=t;J=t;K=s;break}else{J=0;K=0}while(0);if(H){H=0;do{ZGc(n,(f[k>>2]|0)+(H<<3)|0,l);i=f[m>>2]|0;if((f[n+4>>2]|0)<0)L=0;else{NGc(h,256);ZGc(g,n,h);L=(RGc(g)|0)&65535}d[i+(H<<1)>>1]=L;H=H+1|0}while((H|0)<(a|0));a=m+8|0;M=a;N=f[a>>2]|0;O=f[G>>2]|0;P=f[m>>2]|0}else{M=m+8|0;N=J;O=J;P=K}f[M>>2]=0;M=f[k>>2]|0;if(M|0){k=f[q>>2]|0;if((k|0)!=(M|0))f[q>>2]=k+(~((k+-8-M|0)>>>3)<<3);cYc(M)}y=P;z=O;A=N}N=f[c>>2]|0;O=c+4|0;if(!N){Q=c+8|0;f[c>>2]=y;f[O>>2]=z;f[Q>>2]=A;u=e;return}P=f[O>>2]|0;if((P|0)!=(N|0))f[O>>2]=P+(~((P+-2-N|0)>>>1)<<1);cYc(N);N=c+8|0;f[N>>2]=0;f[O>>2]=0;f[c>>2]=0;Q=N;f[c>>2]=y;f[O>>2]=z;f[Q>>2]=A;u=e;return}function Lqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0;i=Y(g,b)|0;if((i|0)>0)j=0;else return;do{d[f+(j<<1)>>1]=(h[a+j>>0]|0)<<8;j=j+1|0}while((j|0)!=(i|0));return}function Mqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;i=Y(g,b)|0;if((i|0)<=0)return;b=0;do{g=Y(h[a+b>>0]|0,j[c>>1]|0)|0;d[f+(b<<1)>>1]=g>>>0<65535?g:65535;b=b+1|0}while((b|0)!=(i|0));return}function Nqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((g|0)==1){if(!i)k=d[c+2>>1]|0;else{e=(j[c>>1]|0)<<1&65534;l=e+(j[c+2>>1]|0)|0;k=e>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{e=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=e>>>0<65535?e:65535;k=k+1|0}while((k|0)!=(b|0));return}k=(i|0)!=0;if(k){l=qR(-1,g,i)|0;if((b|0)>0){e=c+2|0;m=Y(l,b)|0;l=0;do{n=Y(h[a+l>>0]|0,j[e>>1]|0)|0;o=(Y((h[a+(l+m)>>0]|0)+(h[a+(l+b)>>0]|0)|0,j[c>>1]|0)|0)+n&65535;d[f+(l<<1)>>1]=o;l=l+1|0}while((l|0)!=(b|0))}}else if((b|0)>0){l=c+2|0;m=0;do{e=Y(h[a+m>>0]|0,j[l>>1]|0)|0;o=e>>>0<65535?e:65535;e=Y(h[a+(m+b)>>0]|0,j[c>>1]|0)|0;n=(e>>>0<65535?e:65535)+o|0;d[f+(m<<1)>>1]=o>>>0>(n&65535)>>>0?-1:n&65535;m=m+1|0}while((m|0)!=(b|0))}m=a+b|0;l=f+(b<<1)|0;n=g+-1|0;o=Y(n,b)|0;if((o|0)>(b|0)){e=c+2|0;p=0-b|0;q=f+(Y((g<<1)+-2|0,b)|0)|0;f=m;r=l;s=b;while(1){t=Y(h[f>>0]|0,j[e>>1]|0)|0;u=(Y((h[f+b>>0]|0)+(h[f+p>>0]|0)|0,j[c>>1]|0)|0)+t&65535;d[r>>1]=u;s=s+1|0;if((s|0)==(o|0))break;else{f=f+1|0;r=r+2|0}}v=a+o|0;w=q}else{v=m;w=l}if(k){k=Y((qR(g,g,i)|0)-n|0,b)|0;if((b|0)<=0)return;n=c+2|0;i=0;do{g=Y(h[v+i>>0]|0,j[n>>1]|0)|0;l=(Y((h[v+(i+k)>>0]|0)+(h[v+(i-b)>>0]|0)|0,j[c>>1]|0)|0)+g&65535;d[w+(i<<1)>>1]=l;i=i+1|0}while((i|0)!=(b|0));return}else{if((b|0)<=0)return;i=c+2|0;k=0;do{n=Y(h[v+(k-b)>>0]|0,j[c>>1]|0)|0;l=n>>>0<65535?n:65535;n=Y(h[v+k>>0]|0,j[i>>1]|0)|0;g=(n>>>0<65535?n:65535)+l|0;d[w+(k<<1)>>1]=l>>>0>(g&65535)>>>0?-1:g&65535;k=k+1|0}while((k|0)!=(b|0));return}}function Oqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if((g|0)==1){if(!i)k=d[c+2>>1]|0;else{e=j[c>>1]|0;l=(j[c+2>>1]|0)+e&65535;m=e>>>0>l>>>0?65535:l;l=m+(j[c+4>>1]|0)|0;k=m>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{m=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=m>>>0<65535?m:65535;k=k+1|0}while((k|0)!=(b|0));return}k=(b|0)>0;if(k){l=c+2|0;m=c+4|0;e=0;do{n=Y(h[a+e>>0]|0,j[l>>1]|0)|0;o=n>>>0<65535?n:65535;n=Y(h[a+(e+b)>>0]|0,j[m>>1]|0)|0;p=(n>>>0<65535?n:65535)+o|0;d[f+(e<<1)>>1]=o>>>0>(p&65535)>>>0?-1:p&65535;e=e+1|0}while((e|0)!=(b|0))}e=(i|0)!=0;if(e?(m=qR(-1,g,i)|0,k):0){l=Y(m,b)|0;m=0;do{p=Y(h[a+(m+l)>>0]|0,j[c>>1]|0)|0;o=f+(m<<1)|0;n=j[o>>1]|0;q=(p>>>0<65535?p:65535)+n|0;d[o>>1]=n>>>0>(q&65535)>>>0?-1:q&65535;m=m+1|0}while((m|0)!=(b|0))}m=a+b|0;l=f+(b<<1)|0;q=g+-1|0;n=Y(q,b)|0;if((n|0)>(b|0)){o=0-b|0;p=c+2|0;r=c+4|0;s=f+(Y((g<<1)+-2|0,b)|0)|0;f=m;t=l;u=b;while(1){v=Y(h[f+o>>0]|0,j[c>>1]|0)|0;w=v>>>0<65535?v:65535;v=Y(h[f>>0]|0,j[p>>1]|0)|0;x=(v>>>0<65535?v:65535)+w&65535;v=Y(h[f+b>>0]|0,j[r>>1]|0)|0;y=w>>>0>x>>>0?65535:x;x=y+(v>>>0<65535?v:65535)|0;d[t>>1]=y>>>0>(x&65535)>>>0?-1:x&65535;u=u+1|0;if((u|0)==(n|0))break;else{f=f+1|0;t=t+2|0}}z=a+n|0;A=s}else{z=m;A=l}if(k){l=c+2|0;m=0;do{s=Y(h[z+(m-b)>>0]|0,j[c>>1]|0)|0;n=s>>>0<65535?s:65535;s=Y(h[z+m>>0]|0,j[l>>1]|0)|0;a=(s>>>0<65535?s:65535)+n|0;d[A+(m<<1)>>1]=n>>>0>(a&65535)>>>0?-1:a&65535;m=m+1|0}while((m|0)!=(b|0))}if(!e)return;e=Y((qR(g,g,i)|0)-q|0,b)|0;if(!k)return;k=c+4|0;c=0;do{q=Y(h[z+(c+e)>>0]|0,j[k>>1]|0)|0;i=A+(c<<1)|0;g=j[i>>1]|0;m=(q>>>0<65535?q:65535)+g|0;d[i>>1]=g>>>0>(m&65535)>>>0?-1:m&65535;c=c+1|0}while((c|0)!=(b|0));return}function Pqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((g|0)==1){e=(b|0)>0;if(!i){if(e)k=0;else return;do{d[f+(k<<1)>>1]=(h[a+k>>0]|0)<<7;k=k+1|0}while((k|0)!=(b|0));return}else{if(e)l=0;else return;do{d[f+(l<<1)>>1]=(h[a+l>>0]|0)<<8;l=l+1|0}while((l|0)!=(b|0));return}}l=(b|0)>0;if(l){e=0;do{d[f+(e<<1)>>1]=((h[a+(e+b)>>0]|0)<<6)+((h[a+e>>0]|0)<<7);e=e+1|0}while((e|0)!=(b|0))}e=(i|0)!=0;if(e?(k=qR(-1,g,i)|0,l):0){c=Y(k,b)|0;k=0;do{m=f+(k<<1)|0;n=j[m>>1]|0;o=((h[a+(k+c)>>0]|0)<<6)+n|0;d[m>>1]=n>>>0>(o&65535)>>>0?-1:o&65535;k=k+1|0}while((k|0)!=(b|0))}k=a+b|0;c=f+(b<<1)|0;o=g+-1|0;n=Y(o,b)|0;if((n|0)>(b|0)){m=0-b|0;p=f+(Y((g<<1)+-2|0,b)|0)|0;f=k;q=c;r=b;while(1){d[q>>1]=(h[f+b>>0]|0)+(h[f+m>>0]|0)+((h[f>>0]|0)<<1)<<6;r=r+1|0;if((r|0)==(n|0))break;else{f=f+1|0;q=q+2|0}}s=a+n|0;t=p}else{s=k;t=c}if(l){c=0;do{d[t+(c<<1)>>1]=((h[s+c>>0]|0)<<7)+((h[s+(c-b)>>0]|0)<<6);c=c+1|0}while((c|0)!=(b|0))}if(!e)return;e=Y((qR(g,g,i)|0)-o|0,b)|0;if(l)u=0;else return;do{l=t+(u<<1)|0;o=j[l>>1]|0;i=((h[s+(u+e)>>0]|0)<<6)+o|0;d[l>>1]=o>>>0>(i&65535)>>>0?-1:i&65535;u=u+1|0}while((u|0)!=(b|0));return}function Qqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(g|0){case 1:{if(!i)k=d[c+4>>1]|0;else{e=j[c>>1]|0;l=(j[c+2>>1]|0)+e|0;m=e>>>0>(l&65535)>>>0?65534:l<<1&65534;l=m+(j[c+4>>1]|0)|0;k=m>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{m=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=m>>>0<65535?m:65535;k=k+1|0}while((k|0)!=(b|0));return}case 2:{if(!i){if((b|0)<=0)return;k=c+4|0;l=c+2|0;m=0;do{e=a+m|0;n=Y(h[e>>0]|0,j[k>>1]|0)|0;o=n>>>0<65535?n:65535;n=m+b|0;p=a+n|0;q=Y(h[p>>0]|0,j[l>>1]|0)|0;r=(q>>>0<65535?q:65535)+o|0;d[f+(m<<1)>>1]=o>>>0>(r&65535)>>>0?-1:r&65535;r=Y(h[e>>0]|0,j[l>>1]|0)|0;e=r>>>0<65535?r:65535;r=Y(h[p>>0]|0,j[k>>1]|0)|0;p=(r>>>0<65535?r:65535)+e|0;d[f+(n<<1)>>1]=e>>>0>(p&65535)>>>0?-1:p&65535;m=m+1|0}while((m|0)!=(b|0));return}else{m=Y(qR(-2,2,i)|0,b)|0;k=Y(qR(-1,2,i)|0,b)|0;l=Y(qR(2,2,i)|0,b)|0;p=Y(qR(3,2,i)|0,b)|0;if((b|0)<=0)return;e=c+2|0;n=c+4|0;r=0;do{o=a+(r+k)|0;q=r+b|0;s=a+q|0;t=Y((h[s>>0]|0)+(h[o>>0]|0)|0,j[e>>1]|0)|0;u=a+r|0;v=(Y(h[u>>0]|0,j[n>>1]|0)|0)+t|0;t=a+(r+l)|0;w=v+(Y((h[a+(r+m)>>0]|0)+(h[t>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(r<<1)>>1]=w;w=Y((h[a+(r+p)>>0]|0)+(h[o>>0]|0)|0,j[c>>1]|0)|0;o=(Y((h[t>>0]|0)+(h[u>>0]|0)|0,j[e>>1]|0)|0)+w|0;w=o+(Y(h[s>>0]|0,j[n>>1]|0)|0)&65535;d[f+(q<<1)>>1]=w;r=r+1|0}while((r|0)!=(b|0));return}break}case 3:{if(!i){if((b|0)<=0)return;r=c+4|0;n=c+2|0;e=b<<1;p=0;do{m=a+p|0;l=Y(h[m>>0]|0,j[r>>1]|0)|0;k=l>>>0<65535?l:65535;l=p+b|0;w=a+l|0;q=Y(h[w>>0]|0,j[n>>1]|0)|0;s=(q>>>0<65535?q:65535)+k&65535;q=p+e|0;o=a+q|0;u=Y(h[o>>0]|0,j[c>>1]|0)|0;t=k>>>0>s>>>0?65535:s;s=t+(u>>>0<65535?u:65535)|0;d[f+(p<<1)>>1]=t>>>0>(s&65535)>>>0?-1:s&65535;s=Y((h[o>>0]|0)+(h[m>>0]|0)|0,j[n>>1]|0)|0;t=(Y(h[w>>0]|0,j[r>>1]|0)|0)+s&65535;d[f+(l<<1)>>1]=t;t=Y(h[m>>0]|0,j[c>>1]|0)|0;m=t>>>0<65535?t:65535;t=Y(h[w>>0]|0,j[n>>1]|0)|0;w=(t>>>0<65535?t:65535)+m&65535;t=Y(h[o>>0]|0,j[r>>1]|0)|0;o=m>>>0>w>>>0?65535:w;w=o+(t>>>0<65535?t:65535)|0;d[f+(q<<1)>>1]=o>>>0>(w&65535)>>>0?-1:w&65535;p=p+1|0}while((p|0)!=(b|0));return}else{p=Y(qR(-2,3,i)|0,b)|0;r=Y(qR(-1,3,i)|0,b)|0;n=Y(qR(3,3,i)|0,b)|0;e=Y(qR(4,3,i)|0,b)|0;if((b|0)<=0)return;w=c+4|0;o=c+2|0;q=b<<1;t=0;do{m=a+t|0;l=Y(h[m>>0]|0,j[w>>1]|0)|0;s=t+b|0;u=a+s|0;k=a+(t+r)|0;v=(Y((h[k>>0]|0)+(h[u>>0]|0)|0,j[o>>1]|0)|0)+l|0;l=t+q|0;x=a+l|0;y=v+(Y((h[a+(t+p)>>0]|0)+(h[x>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(t<<1)>>1]=y;y=Y(h[u>>0]|0,j[w>>1]|0)|0;v=(Y((h[x>>0]|0)+(h[m>>0]|0)|0,j[o>>1]|0)|0)+y|0;y=a+(t+n)|0;z=v+(Y((h[y>>0]|0)+(h[k>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(s<<1)>>1]=z;z=Y((h[a+(t+e)>>0]|0)+(h[m>>0]|0)|0,j[c>>1]|0)|0;m=(Y((h[y>>0]|0)+(h[u>>0]|0)|0,j[o>>1]|0)|0)+z|0;z=m+(Y(h[x>>0]|0,j[w>>1]|0)|0)&65535;d[f+(l<<1)>>1]=z;t=t+1|0}while((t|0)!=(b|0));return}break}default:{t=(i|0)!=0;if(t){w=Y(qR(-2,g,i)|0,b)|0;o=Y(qR(-1,g,i)|0,b)|0;if((b|0)>0){e=c+4|0;n=c+2|0;p=b<<1;q=b*3|0;r=0;do{z=a+r|0;l=Y(h[z>>0]|0,j[e>>1]|0)|0;x=r+b|0;m=a+x|0;u=a+(r+o)|0;y=(Y((h[u>>0]|0)+(h[m>>0]|0)|0,j[n>>1]|0)|0)+l|0;l=a+(r+p)|0;s=y+(Y((h[a+(r+w)>>0]|0)+(h[l>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(r<<1)>>1]=s;s=Y((h[l>>0]|0)+(h[z>>0]|0)|0,j[n>>1]|0)|0;z=(Y(h[m>>0]|0,j[e>>1]|0)|0)+s|0;s=z+(Y((h[u>>0]|0)+(h[a+(r+q)>>0]|0)|0,j[c>>1]|0)|0)&65535;d[f+(x<<1)>>1]=s;r=r+1|0}while((r|0)!=(b|0))}}else if((b|0)>0){r=c+4|0;q=c+2|0;e=b<<1;n=b*3|0;w=0;do{p=a+w|0;o=Y(h[p>>0]|0,j[r>>1]|0)|0;s=o>>>0<65535?o:65535;o=w+b|0;x=a+o|0;u=Y(h[x>>0]|0,j[q>>1]|0)|0;z=(u>>>0<65535?u:65535)+s&65535;u=a+(w+e)|0;m=Y(h[u>>0]|0,j[c>>1]|0)|0;l=s>>>0>z>>>0?65535:z;z=l+(m>>>0<65535?m:65535)|0;d[f+(w<<1)>>1]=l>>>0>(z&65535)>>>0?-1:z&65535;z=Y((h[u>>0]|0)+(h[p>>0]|0)|0,j[q>>1]|0)|0;p=(Y(h[x>>0]|0,j[r>>1]|0)|0)+z|0;z=p+(Y(h[a+(w+n)>>0]|0,j[c>>1]|0)|0)&65535;d[f+(o<<1)>>1]=z;w=w+1|0}while((w|0)!=(b|0))}w=b<<1;n=a+w|0;r=f+(w<<1)|0;q=g+-2|0;e=Y(q,b)|0;if((w|0)<(e|0)){z=Y(b,-2)|0;o=c+2|0;p=0-b|0;x=c+4|0;u=f+(Y((g<<1)+-4|0,b)|0)|0;f=n;l=r;m=w;while(1){s=Y((h[f+w>>0]|0)+(h[f+z>>0]|0)|0,j[c>>1]|0)|0;y=(Y((h[f+b>>0]|0)+(h[f+p>>0]|0)|0,j[o>>1]|0)|0)+s|0;s=y+(Y(h[f>>0]|0,j[x>>1]|0)|0)&65535;d[l>>1]=s;m=m+1|0;if((m|0)==(e|0))break;else{f=f+1|0;l=l+2|0}}A=a+e|0;B=u}else{A=n;B=r}if(t){t=Y((qR(g,g,i)|0)-q|0,b)|0;r=Y((qR(g+1|0,g,i)|0)-q|0,b)|0;if((b|0)<=0)return;q=c+2|0;i=c+4|0;g=0;do{n=A+(g+t)|0;u=Y((h[n>>0]|0)+(h[A+(g-w)>>0]|0)|0,j[c>>1]|0)|0;e=A+(g-b)|0;a=g+b|0;l=A+a|0;f=(Y((h[l>>0]|0)+(h[e>>0]|0)|0,j[q>>1]|0)|0)+u|0;u=A+g|0;m=f+(Y(h[u>>0]|0,j[i>>1]|0)|0)&65535;d[B+(g<<1)>>1]=m;m=Y((h[A+(g+r)>>0]|0)+(h[e>>0]|0)|0,j[c>>1]|0)|0;e=(Y((h[n>>0]|0)+(h[u>>0]|0)|0,j[q>>1]|0)|0)+m|0;m=e+(Y(h[l>>0]|0,j[i>>1]|0)|0)&65535;d[B+(a<<1)>>1]=m;g=g+1|0}while((g|0)!=(b|0));return}else{if((b|0)<=0)return;g=c+2|0;i=c+4|0;q=0;do{r=Y(h[A+(q-w)>>0]|0,j[c>>1]|0)|0;t=A+(q-b)|0;m=q+b|0;a=A+m|0;l=(Y((h[a>>0]|0)+(h[t>>0]|0)|0,j[g>>1]|0)|0)+r|0;r=A+q|0;e=l+(Y(h[r>>0]|0,j[i>>1]|0)|0)&65535;d[B+(q<<1)>>1]=e;e=Y(h[t>>0]|0,j[c>>1]|0)|0;t=e>>>0<65535?e:65535;e=Y(h[r>>0]|0,j[g>>1]|0)|0;r=(e>>>0<65535?e:65535)+t&65535;e=Y(h[a>>0]|0,j[i>>1]|0)|0;a=t>>>0>r>>>0?65535:r;r=a+(e>>>0<65535?e:65535)|0;d[B+(m<<1)>>1]=a>>>0>(r&65535)>>>0?-1:r&65535;q=q+1|0}while((q|0)!=(b|0));return}}}}function Rqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;switch(g|0){case 1:{if(!i)k=d[c+4>>1]|0;else{e=j[c>>1]|0;l=(j[c+2>>1]|0)+e&65535;m=e>>>0>l>>>0?65535:l;l=m+(j[c+4>>1]|0)&65535;e=m>>>0>l>>>0?65535:l;l=e+(j[c+6>>1]|0)&65535;m=e>>>0>l>>>0?65535:l;l=m+(j[c+8>>1]|0)|0;k=m>>>0>(l&65535)>>>0?-1:l&65535}if((b|0)<=0)return;l=k&65535;k=0;do{m=Y(h[a+k>>0]|0,l)|0;d[f+(k<<1)>>1]=m>>>0<65535?m:65535;k=k+1|0}while((k|0)!=(b|0));return}case 2:{if(!i){if((b|0)<=0)return;k=c+4|0;l=c+6|0;m=c+2|0;e=0;do{n=a+e|0;o=Y(h[n>>0]|0,j[k>>1]|0)|0;p=o>>>0<65535?o:65535;o=e+b|0;q=a+o|0;r=Y(h[q>>0]|0,j[l>>1]|0)|0;s=(r>>>0<65535?r:65535)+p|0;d[f+(e<<1)>>1]=p>>>0>(s&65535)>>>0?-1:s&65535;s=Y(h[n>>0]|0,j[m>>1]|0)|0;n=s>>>0<65535?s:65535;s=Y(h[q>>0]|0,j[k>>1]|0)|0;q=(s>>>0<65535?s:65535)+n|0;d[f+(o<<1)>>1]=n>>>0>(q&65535)>>>0?-1:q&65535;e=e+1|0}while((e|0)!=(b|0));return}else{e=Y(qR(-2,2,i)|0,b)|0;k=Y(qR(-1,2,i)|0,b)|0;m=Y(qR(2,2,i)|0,b)|0;l=Y(qR(3,2,i)|0,b)|0;if((b|0)<=0)return;q=c+2|0;n=c+4|0;o=c+6|0;s=c+8|0;p=0;do{r=a+(p+k)|0;t=Y(h[r>>0]|0,j[q>>1]|0)|0;u=t>>>0<65535?t:65535;t=a+p|0;v=Y(h[t>>0]|0,j[n>>1]|0)|0;w=(v>>>0<65535?v:65535)+u&65535;v=p+b|0;x=a+v|0;y=Y(h[x>>0]|0,j[o>>1]|0)|0;z=u>>>0>w>>>0?65535:w;w=z+(y>>>0<65535?y:65535)&65535;y=a+(p+m)|0;u=Y(h[y>>0]|0,j[s>>1]|0)|0;A=z>>>0>w>>>0?65535:w;w=A+(u>>>0<65535?u:65535)&65535;u=Y(h[a+(p+e)>>0]|0,j[c>>1]|0)|0;z=A>>>0>w>>>0?65535:w;w=z+(u>>>0<65535?u:65535)|0;d[f+(p<<1)>>1]=z>>>0>(w&65535)>>>0?-1:w&65535;w=Y(h[r>>0]|0,j[c>>1]|0)|0;r=w>>>0<65535?w:65535;w=Y(h[t>>0]|0,j[q>>1]|0)|0;t=(w>>>0<65535?w:65535)+r&65535;w=Y(h[x>>0]|0,j[n>>1]|0)|0;x=r>>>0>t>>>0?65535:t;t=x+(w>>>0<65535?w:65535)&65535;w=Y(h[y>>0]|0,j[o>>1]|0)|0;y=x>>>0>t>>>0?65535:t;t=y+(w>>>0<65535?w:65535)&65535;w=Y(h[a+(p+l)>>0]|0,j[s>>1]|0)|0;x=y>>>0>t>>>0?65535:t;t=x+(w>>>0<65535?w:65535)|0;d[f+(v<<1)>>1]=x>>>0>(t&65535)>>>0?-1:t&65535;p=p+1|0}while((p|0)!=(b|0));return}break}case 3:{if(!i){if((b|0)<=0)return;p=c+4|0;s=c+6|0;l=b<<1;o=c+8|0;n=c+2|0;q=0;do{e=a+q|0;m=Y(h[e>>0]|0,j[p>>1]|0)|0;k=m>>>0<65535?m:65535;m=q+b|0;t=a+m|0;x=Y(h[t>>0]|0,j[s>>1]|0)|0;v=(x>>>0<65535?x:65535)+k&65535;x=q+l|0;w=a+x|0;y=Y(h[w>>0]|0,j[o>>1]|0)|0;r=k>>>0>v>>>0?65535:v;v=r+(y>>>0<65535?y:65535)|0;d[f+(q<<1)>>1]=r>>>0>(v&65535)>>>0?-1:v&65535;v=Y(h[e>>0]|0,j[n>>1]|0)|0;r=v>>>0<65535?v:65535;v=Y(h[t>>0]|0,j[p>>1]|0)|0;y=(v>>>0<65535?v:65535)+r&65535;v=Y(h[w>>0]|0,j[s>>1]|0)|0;k=r>>>0>y>>>0?65535:y;y=k+(v>>>0<65535?v:65535)|0;d[f+(m<<1)>>1]=k>>>0>(y&65535)>>>0?-1:y&65535;y=Y(h[e>>0]|0,j[c>>1]|0)|0;e=y>>>0<65535?y:65535;y=Y(h[t>>0]|0,j[n>>1]|0)|0;t=(y>>>0<65535?y:65535)+e&65535;y=Y(h[w>>0]|0,j[p>>1]|0)|0;w=e>>>0>t>>>0?65535:t;t=w+(y>>>0<65535?y:65535)|0;d[f+(x<<1)>>1]=w>>>0>(t&65535)>>>0?-1:t&65535;q=q+1|0}while((q|0)!=(b|0));return}else{q=Y(qR(-2,3,i)|0,b)|0;p=Y(qR(-1,3,i)|0,b)|0;n=Y(qR(3,3,i)|0,b)|0;s=Y(qR(4,3,i)|0,b)|0;if((b|0)<=0)return;o=c+4|0;l=c+6|0;t=b<<1;w=c+8|0;x=c+2|0;y=0;do{e=a+y|0;k=Y(h[e>>0]|0,j[o>>1]|0)|0;m=k>>>0<65535?k:65535;k=y+b|0;v=a+k|0;r=Y(h[v>>0]|0,j[l>>1]|0)|0;z=(r>>>0<65535?r:65535)+m&65535;r=y+t|0;u=a+r|0;A=Y(h[u>>0]|0,j[w>>1]|0)|0;B=m>>>0>z>>>0?65535:z;z=B+(A>>>0<65535?A:65535)&65535;A=Y(h[a+(y+q)>>0]|0,j[c>>1]|0)|0;m=B>>>0>z>>>0?65535:z;z=m+(A>>>0<65535?A:65535)&65535;A=a+(y+p)|0;B=Y(h[A>>0]|0,j[x>>1]|0)|0;C=m>>>0>z>>>0?65535:z;z=C+(B>>>0<65535?B:65535)|0;d[f+(y<<1)>>1]=C>>>0>(z&65535)>>>0?-1:z&65535;z=Y(h[e>>0]|0,j[x>>1]|0)|0;C=z>>>0<65535?z:65535;z=Y(h[v>>0]|0,j[o>>1]|0)|0;B=(z>>>0<65535?z:65535)+C&65535;z=Y(h[u>>0]|0,j[l>>1]|0)|0;m=C>>>0>B>>>0?65535:B;B=m+(z>>>0<65535?z:65535)&65535;z=Y(h[A>>0]|0,j[c>>1]|0)|0;A=m>>>0>B>>>0?65535:B;B=A+(z>>>0<65535?z:65535)&65535;z=a+(y+n)|0;m=Y(h[z>>0]|0,j[w>>1]|0)|0;C=A>>>0>B>>>0?65535:B;B=C+(m>>>0<65535?m:65535)|0;d[f+(k<<1)>>1]=C>>>0>(B&65535)>>>0?-1:B&65535;B=Y(h[e>>0]|0,j[c>>1]|0)|0;e=B>>>0<65535?B:65535;B=Y(h[v>>0]|0,j[x>>1]|0)|0;v=(B>>>0<65535?B:65535)+e&65535;B=Y(h[u>>0]|0,j[o>>1]|0)|0;u=e>>>0>v>>>0?65535:v;v=u+(B>>>0<65535?B:65535)&65535;B=Y(h[z>>0]|0,j[l>>1]|0)|0;z=u>>>0>v>>>0?65535:v;v=z+(B>>>0<65535?B:65535)&65535;B=Y(h[a+(y+s)>>0]|0,j[w>>1]|0)|0;u=z>>>0>v>>>0?65535:v;v=u+(B>>>0<65535?B:65535)|0;d[f+(r<<1)>>1]=u>>>0>(v&65535)>>>0?-1:v&65535;y=y+1|0}while((y|0)!=(b|0));return}break}default:{y=(b|0)>0;if(y){w=c+4|0;s=c+6|0;l=b<<1;o=c+8|0;x=c+2|0;n=b*3|0;p=0;do{q=a+p|0;t=Y(h[q>>0]|0,j[w>>1]|0)|0;v=t>>>0<65535?t:65535;t=p+b|0;u=a+t|0;r=Y(h[u>>0]|0,j[s>>1]|0)|0;B=(r>>>0<65535?r:65535)+v&65535;r=a+(p+l)|0;z=Y(h[r>>0]|0,j[o>>1]|0)|0;e=v>>>0>B>>>0?65535:B;B=e+(z>>>0<65535?z:65535)|0;d[f+(p<<1)>>1]=e>>>0>(B&65535)>>>0?-1:B&65535;B=Y(h[q>>0]|0,j[x>>1]|0)|0;q=B>>>0<65535?B:65535;B=Y(h[u>>0]|0,j[w>>1]|0)|0;u=(B>>>0<65535?B:65535)+q&65535;B=Y(h[r>>0]|0,j[s>>1]|0)|0;r=q>>>0>u>>>0?65535:u;u=r+(B>>>0<65535?B:65535)&65535;B=Y(h[a+(p+n)>>0]|0,j[o>>1]|0)|0;q=r>>>0>u>>>0?65535:u;u=q+(B>>>0<65535?B:65535)|0;d[f+(t<<1)>>1]=q>>>0>(u&65535)>>>0?-1:u&65535;p=p+1|0}while((p|0)!=(b|0))}p=(i|0)!=0;if(p?(o=Y(qR(-2,g,i)|0,b)|0,n=Y(qR(-1,g,i)|0,b)|0,y):0){s=c+2|0;w=0;do{x=Y(h[a+(w+o)>>0]|0,j[c>>1]|0)|0;l=f+(w<<1)|0;u=j[l>>1]|0;q=(x>>>0<65535?x:65535)+u&65535;x=a+(w+n)|0;t=Y(h[x>>0]|0,j[s>>1]|0)|0;B=u>>>0>q>>>0?65535:q;q=B+(t>>>0<65535?t:65535)|0;d[l>>1]=B>>>0>(q&65535)>>>0?-1:q&65535;q=Y(h[x>>0]|0,j[c>>1]|0)|0;x=f+(w+b<<1)|0;B=j[x>>1]|0;l=(q>>>0<65535?q:65535)+B|0;d[x>>1]=B>>>0>(l&65535)>>>0?-1:l&65535;w=w+1|0}while((w|0)!=(b|0))}w=b<<1;s=a+w|0;n=f+(w<<1)|0;o=g+-2|0;l=Y(o,b)|0;if((w|0)<(l|0)){B=Y(b,-2)|0;x=0-b|0;q=c+2|0;t=c+4|0;u=c+6|0;r=c+8|0;e=f+(Y((g<<1)+-4|0,b)|0)|0;f=s;z=n;v=w;while(1){C=Y(h[f+B>>0]|0,j[c>>1]|0)|0;k=C>>>0<65535?C:65535;C=Y(h[f+x>>0]|0,j[q>>1]|0)|0;m=(C>>>0<65535?C:65535)+k&65535;C=Y(h[f>>0]|0,j[t>>1]|0)|0;A=k>>>0>m>>>0?65535:m;m=A+(C>>>0<65535?C:65535)&65535;C=Y(h[f+b>>0]|0,j[u>>1]|0)|0;k=A>>>0>m>>>0?65535:m;m=k+(C>>>0<65535?C:65535)&65535;C=Y(h[f+w>>0]|0,j[r>>1]|0)|0;A=k>>>0>m>>>0?65535:m;m=A+(C>>>0<65535?C:65535)|0;d[z>>1]=A>>>0>(m&65535)>>>0?-1:m&65535;v=v+1|0;if((v|0)==(l|0))break;else{f=f+1|0;z=z+2|0}}D=a+l|0;E=e}else{D=s;E=n}if(y){n=c+2|0;s=c+4|0;e=c+6|0;l=0;do{a=Y(h[D+(l-w)>>0]|0,j[c>>1]|0)|0;z=a>>>0<65535?a:65535;a=D+(l-b)|0;f=Y(h[a>>0]|0,j[n>>1]|0)|0;v=(f>>>0<65535?f:65535)+z&65535;f=D+l|0;r=Y(h[f>>0]|0,j[s>>1]|0)|0;u=z>>>0>v>>>0?65535:v;v=u+(r>>>0<65535?r:65535)&65535;r=l+b|0;z=D+r|0;t=Y(h[z>>0]|0,j[e>>1]|0)|0;q=u>>>0>v>>>0?65535:v;v=q+(t>>>0<65535?t:65535)|0;d[E+(l<<1)>>1]=q>>>0>(v&65535)>>>0?-1:v&65535;v=Y(h[a>>0]|0,j[c>>1]|0)|0;a=v>>>0<65535?v:65535;v=Y(h[f>>0]|0,j[n>>1]|0)|0;f=(v>>>0<65535?v:65535)+a&65535;v=Y(h[z>>0]|0,j[s>>1]|0)|0;z=a>>>0>f>>>0?65535:f;f=z+(v>>>0<65535?v:65535)|0;d[E+(r<<1)>>1]=z>>>0>(f&65535)>>>0?-1:f&65535;l=l+1|0}while((l|0)!=(b|0))}if(!p)return;p=Y((qR(g,g,i)|0)-o|0,b)|0;l=Y((qR(g+1|0,g,i)|0)-o|0,b)|0;if(!y)return;y=c+8|0;o=c+6|0;c=0;do{i=D+(c+p)|0;g=Y(h[i>>0]|0,j[y>>1]|0)|0;s=E+(c<<1)|0;n=j[s>>1]|0;e=(g>>>0<65535?g:65535)+n|0;d[s>>1]=n>>>0>(e&65535)>>>0?-1:e&65535;e=Y(h[i>>0]|0,j[o>>1]|0)|0;i=E+(c+b<<1)|0;n=j[i>>1]|0;s=(e>>>0<65535?e:65535)+n&65535;e=Y(h[D+(c+l)>>0]|0,j[y>>1]|0)|0;g=n>>>0>s>>>0?65535:s;s=g+(e>>>0<65535?e:65535)|0;d[i>>1]=g>>>0>(s&65535)>>>0?-1:s&65535;c=c+1|0}while((c|0)!=(b|0));return}}}function Sqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;switch(g|0){case 1:{e=(b|0)>0;if(!i){if(e)k=0;else return;do{d[f+(k<<1)>>1]=(h[a+k>>0]|0)*96;k=k+1|0}while((k|0)!=(b|0));return}else{if(e)l=0;else return;do{d[f+(l<<1)>>1]=(h[a+l>>0]|0)<<8;l=l+1|0}while((l|0)!=(b|0));return}break}case 2:{if(!i){if((b|0)>0)m=0;else return;do{l=a+m|0;e=m+b|0;k=a+e|0;d[f+(m<<1)>>1]=((h[k>>0]|0)<<6)+((h[l>>0]|0)*96|0);d[f+(e<<1)>>1]=((h[k>>0]|0)*96|0)+((h[l>>0]|0)<<6);m=m+1|0}while((m|0)!=(b|0));return}else{m=Y(qR(-2,2,i)|0,b)|0;l=Y(qR(-1,2,i)|0,b)|0;k=Y(qR(2,2,i)|0,b)|0;e=Y(qR(3,2,i)|0,b)|0;if((b|0)>0)n=0;else return;do{c=a+n|0;o=a+(n+l)|0;p=((h[o>>0]|0)<<6)+((h[c>>0]|0)*96|0)|0;q=n+b|0;r=a+q|0;s=((h[r>>0]|0)<<6)+p&65504;t=a+(n+k)|0;u=p>>>0>s>>>0?65535:s;s=u+((h[t>>0]|0)<<4)&65535;p=u>>>0>s>>>0?65535:s;s=p+((h[a+(n+m)>>0]|0)<<4)|0;d[f+(n<<1)>>1]=p>>>0>(s&65535)>>>0?-1:s&65535;s=((h[c>>0]|0)<<6)+((h[r>>0]|0)*96|0)|0;r=((h[t>>0]|0)<<6)+s&65504;t=s>>>0>r>>>0?65535:r;r=t+((h[o>>0]|0)<<4)&65535;o=t>>>0>r>>>0?65535:r;r=o+((h[a+(n+e)>>0]|0)<<4)|0;d[f+(q<<1)>>1]=o>>>0>(r&65535)>>>0?-1:r&65535;n=n+1|0}while((n|0)!=(b|0));return}break}case 3:{if(!i){if((b|0)<=0)return;n=b<<1;e=0;do{m=a+e|0;k=e+b|0;l=a+k|0;r=((h[l>>0]|0)<<6)+((h[m>>0]|0)*96|0)|0;o=e+n|0;q=a+o|0;t=((h[q>>0]|0)<<4)+r|0;d[f+(e<<1)>>1]=r>>>0>(t&65520)>>>0?-1:t&65535;t=((h[m>>0]|0)<<6)+((h[l>>0]|0)*96|0)|0;r=((h[q>>0]|0)<<6)+t|0;d[f+(k<<1)>>1]=t>>>0>(r&65504)>>>0?-1:r&65535;r=((h[l>>0]|0)<<6)+((h[q>>0]|0)*96|0)|0;q=((h[m>>0]|0)<<4)+r|0;d[f+(o<<1)>>1]=r>>>0>(q&65520)>>>0?-1:q&65535;e=e+1|0}while((e|0)!=(b|0));return}else{e=Y(qR(-2,3,i)|0,b)|0;n=Y(qR(-1,3,i)|0,b)|0;q=Y(qR(3,3,i)|0,b)|0;r=Y(qR(4,3,i)|0,b)|0;if((b|0)<=0)return;o=b<<1;m=0;do{l=a+m|0;t=m+b|0;k=a+t|0;s=((h[k>>0]|0)<<6)+((h[l>>0]|0)*96|0)|0;c=a+(m+n)|0;p=((h[c>>0]|0)<<6)+s&65504;u=m+o|0;v=a+u|0;w=s>>>0>p>>>0?65535:p;p=w+((h[v>>0]|0)<<4)&65535;s=w>>>0>p>>>0?65535:p;p=s+((h[a+(m+e)>>0]|0)<<4)|0;d[f+(m<<1)>>1]=s>>>0>(p&65535)>>>0?-1:p&65535;p=((h[l>>0]|0)<<6)+((h[k>>0]|0)*96|0)|0;s=((h[v>>0]|0)<<6)+p&65504;w=p>>>0>s>>>0?65535:s;s=w+((h[c>>0]|0)<<4)&65535;c=a+(m+q)|0;p=w>>>0>s>>>0?65535:s;s=p+((h[c>>0]|0)<<4)|0;d[f+(t<<1)>>1]=p>>>0>(s&65535)>>>0?-1:s&65535;s=((h[k>>0]|0)<<6)+((h[v>>0]|0)*96|0)|0;v=((h[c>>0]|0)<<6)+s&65504;c=s>>>0>v>>>0?65535:v;v=c+((h[l>>0]|0)<<4)&65535;l=c>>>0>v>>>0?65535:v;v=l+((h[a+(m+r)>>0]|0)<<4)|0;d[f+(u<<1)>>1]=l>>>0>(v&65535)>>>0?-1:v&65535;m=m+1|0}while((m|0)!=(b|0));return}break}default:{m=(b|0)>0;if(m){r=b<<1;q=b*3|0;e=0;do{o=a+e|0;n=e+b|0;v=a+n|0;l=((h[v>>0]|0)<<6)+((h[o>>0]|0)*96|0)|0;u=a+(e+r)|0;c=((h[u>>0]|0)<<4)+l|0;d[f+(e<<1)>>1]=l>>>0>(c&65520)>>>0?-1:c&65535;c=((h[o>>0]|0)<<6)+((h[v>>0]|0)*96|0)|0;v=((h[u>>0]|0)<<6)+c&65504;u=c>>>0>v>>>0?65535:v;v=u+((h[a+(e+q)>>0]|0)<<4)|0;d[f+(n<<1)>>1]=u>>>0>(v&65535)>>>0?-1:v&65535;e=e+1|0}while((e|0)!=(b|0))}e=(i|0)!=0;if(e?(q=Y(qR(-2,g,i)|0,b)|0,r=Y(qR(-1,g,i)|0,b)|0,m):0){v=0;do{u=f+(v<<1)|0;n=j[u>>1]|0;c=((h[a+(v+q)>>0]|0)<<4)+n&65535;o=a+(v+r)|0;l=n>>>0>c>>>0?65535:c;c=l+((h[o>>0]|0)<<6)|0;d[u>>1]=l>>>0>(c&65535)>>>0?-1:c&65535;c=f+(v+b<<1)|0;l=j[c>>1]|0;u=((h[o>>0]|0)<<4)+l|0;d[c>>1]=l>>>0>(u&65535)>>>0?-1:u&65535;v=v+1|0}while((v|0)!=(b|0))}v=b<<1;r=a+v|0;q=f+(v<<1)|0;u=g+-2|0;l=Y(u,b)|0;if((v|0)<(l|0)){c=0-b|0;o=Y(b,-2)|0;n=f+(Y((g<<1)+-4|0,b)|0)|0;f=r;s=q;k=v;while(1){d[s>>1]=(h[f+o>>0]|0)+((h[f>>0]|0)*6|0)+((h[f+b>>0]|0)+(h[f+c>>0]|0)<<2)+(h[f+v>>0]|0)<<4;k=k+1|0;if((k|0)==(l|0))break;else{f=f+1|0;s=s+2|0}}x=a+l|0;y=n}else{x=r;y=q}if(m){q=0;do{r=x+q|0;n=x+(q-b)|0;l=((h[n>>0]|0)<<6)+((h[r>>0]|0)*96|0)|0;a=q+b|0;s=x+a|0;f=((h[s>>0]|0)<<6)+l&65504;k=l>>>0>f>>>0?65535:f;f=k+((h[x+(q-v)>>0]|0)<<4)|0;d[y+(q<<1)>>1]=k>>>0>(f&65535)>>>0?-1:f&65535;f=((h[r>>0]|0)<<6)+((h[s>>0]|0)*96|0)|0;s=((h[n>>0]|0)<<4)+f|0;d[y+(a<<1)>>1]=f>>>0>(s&65520)>>>0?-1:s&65535;q=q+1|0}while((q|0)!=(b|0))}if(!e)return;e=Y((qR(g,g,i)|0)-u|0,b)|0;q=Y((qR(g+1|0,g,i)|0)-u|0,b)|0;if(m)z=0;else return;do{m=x+(z+e)|0;u=y+(z<<1)|0;i=j[u>>1]|0;g=((h[m>>0]|0)<<4)+i|0;d[u>>1]=i>>>0>(g&65535)>>>0?-1:g&65535;g=y+(z+b<<1)|0;i=j[g>>1]|0;u=((h[m>>0]|0)<<6)+i&65535;m=i>>>0>u>>>0?65535:u;u=m+((h[x+(z+q)>>0]|0)<<4)|0;d[g>>1]=m>>>0>(u&65535)>>>0?-1:u&65535;z=z+1|0}while((z|0)!=(b|0));return}}}function Tqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=(e|0)/2|0;l=e-k|0;m=(k|0)>(g|0)?g:k;if((m|0)>0){n=(b|0)>0;o=(i|0)!=0;p=k+-1|0;q=~g;r=n^1;s=f;t=0;u=p;v=p-e|0;p=l;while(1){w=u-((v|0)>(q|0)?v:q)|0;if(n){x=c+(k-t<<1)|0;y=0;do{z=Y(h[a+y>>0]|0,j[x>>1]|0)|0;d[s+(y<<1)>>1]=z>>>0<65535?z:65535;y=y+1|0}while((y|0)!=(b|0))}a:do if(o?(y=t-k|0,(y|0)<0):0){if(n){A=0;B=y}else{x=y;while(1){qR(x,g,i)|0;if((x|0)<-1)x=x+1|0;else break a}}while(1){x=Y(qR(B,g,i)|0,b)|0;y=c+(A<<1)|0;z=0;do{C=Y(h[a+(z+x)>>0]|0,j[y>>1]|0)|0;D=s+(z<<1)|0;E=j[D>>1]|0;F=(C>>>0<65535?C:65535)+E|0;d[D>>1]=E>>>0>(F&65535)>>>0?-1:F&65535;z=z+1|0}while((z|0)!=(b|0));if((B|0)<-1){A=A+1|0;B=B+1|0}else break}}while(0);z=k-t+1|0;y=t+l|0;x=(y|0)>(g|0)?g:y;F=(x|0)<2;if(F|r){G=F?z:w;H=F?1:x}else{F=z;z=1;while(1){E=Y(z,b)|0;D=c+(F<<1)|0;C=0;do{I=Y(h[a+(C+E)>>0]|0,j[D>>1]|0)|0;J=s+(C<<1)|0;K=j[J>>1]|0;L=(I>>>0<65535?I:65535)+K|0;d[J>>1]=K>>>0>(L&65535)>>>0?-1:L&65535;C=C+1|0}while((C|0)!=(b|0));z=z+1|0;C=F+1|0;if((z|0)>=(x|0)){G=C;H=x;break}else F=C}}b:do if(o&(H|0)<(y|0)){if(n){M=G;N=H}else{F=H;while(1){qR(F,g,i)|0;F=F+1|0;if((F|0)==(p|0))break b}}while(1){F=Y(qR(N,g,i)|0,b)|0;x=c+(M<<1)|0;z=0;do{w=Y(h[a+(z+F)>>0]|0,j[x>>1]|0)|0;C=s+(z<<1)|0;D=j[C>>1]|0;E=(w>>>0<65535?w:65535)+D|0;d[C>>1]=D>>>0>(E&65535)>>>0?-1:E&65535;z=z+1|0}while((z|0)!=(b|0));N=N+1|0;if((N|0)==(p|0))break;else M=M+1|0}}while(0);t=t+1|0;y=s+(b<<1)|0;if((t|0)>=(m|0)){O=y;P=m;break}else{s=y;u=u+-1|0;v=v+-1|0;p=p+1|0}}}else{O=f;P=0}f=Y(P,b)|0;p=Y(1-l+g|0,b)|0;do if((f|0)<(p|0)){l=Y(k,b)|0;v=c+(k<<1)|0;u=e+-1|0;s=Y(k+g+1-P-e|0,b)|0;m=a+s|0;if((e|0)>1){Q=a;R=O;S=f}else{t=a;M=O;N=f;while(1){H=Y(h[t+l>>0]|0,j[v>>1]|0)|0;d[M>>1]=H>>>0<65535?H:65535;N=N+1|0;if((N|0)==(p|0))break;else{t=t+1|0;M=M+2|0}}T=m;U=O+(s<<1)|0;V=p;break}while(1){M=Y(h[Q+l>>0]|0,j[v>>1]|0)|0;t=(M>>>0<65535?M:65535)&65535;d[R>>1]=t;M=0;N=t;do{t=Q+(Y(M,b)|0)|0;H=j[c+(M<<1)>>1]|0;G=Y(h[t>>0]|0,H)|0;t=N&65535;n=(G>>>0<65535?G:65535)+t&65535;G=Q+(Y(u-M|0,b)|0)|0;o=Y(h[G>>0]|0,H)|0;H=t>>>0>n>>>0?65535:n;n=H+(o>>>0<65535?o:65535)|0;N=H>>>0>(n&65535)>>>0?-1:n&65535;d[R>>1]=N;M=M+1|0}while((M|0)<(k|0));S=S+1|0;if((S|0)==(p|0))break;else{Q=Q+1|0;R=R+2|0}}T=m;U=O+(s<<1)|0;V=p}else{T=a;U=O;V=f}while(0);f=(V|0)/(b|0)|0;V=f-k|0;O=g-k|0;if((V|0)>=(O|0))return;a=(b|0)>0;p=(i|0)!=0;R=a^1;Q=T;T=V;V=U;U=k+g-f|0;while(1){if(a){f=0;do{k=Y(h[Q+f>>0]|0,j[c>>1]|0)|0;d[V+(f<<1)>>1]=k>>>0<65535?k:65535;f=f+1|0}while((f|0)!=(b|0))}f=g-T|0;s=(f|0)<2;if(s|R)W=s?1:f;else{s=1;do{m=Y(s,b)|0;k=c+(s<<1)|0;S=0;do{P=Y(h[Q+(S+m)>>0]|0,j[k>>1]|0)|0;u=V+(S<<1)|0;v=j[u>>1]|0;l=(P>>>0<65535?P:65535)+v|0;d[u>>1]=v>>>0>(l&65535)>>>0?-1:l&65535;S=S+1|0}while((S|0)!=(b|0));s=s+1|0}while((s|0)!=(U|0));W=f}c:do if(p&(W|0)<(e|0)){if(a)X=W;else{f=W;while(1){qR(f+T|0,g,i)|0;f=f+1|0;if((f|0)==(e|0))break c}}do{f=Y((qR(X+T|0,g,i)|0)-T|0,b)|0;s=c+(X<<1)|0;S=0;do{k=Y(h[Q+(S+f)>>0]|0,j[s>>1]|0)|0;m=V+(S<<1)|0;l=j[m>>1]|0;v=(k>>>0<65535?k:65535)+l|0;d[m>>1]=l>>>0>(v&65535)>>>0?-1:v&65535;S=S+1|0}while((S|0)!=(b|0));X=X+1|0}while((X|0)!=(e|0))}while(0);T=T+1|0;if((T|0)==(O|0))break;else{Q=Q+b|0;V=V+(b<<1)|0;U=U+-1|0}}return}function Uqa(a,b,c,e,f,g,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=(e|0)/2|0;l=e-k|0;m=(k|0)>(g|0)?g:k;if((m|0)>0){n=(b|0)>0;o=(i|0)!=0;p=k+-1|0;q=~g;r=n^1;s=f;t=0;u=p;v=p-e|0;p=l;while(1){w=u-((v|0)>(q|0)?v:q)|0;if(n){x=c+(k-t<<1)|0;y=0;do{z=Y(h[a+y>>0]|0,j[x>>1]|0)|0;d[s+(y<<1)>>1]=z>>>0<65535?z:65535;y=y+1|0}while((y|0)!=(b|0))}a:do if(o?(y=t-k|0,(y|0)<0):0){if(n){A=0;B=y}else{x=y;while(1){qR(x,g,i)|0;if((x|0)<-1)x=x+1|0;else break a}}while(1){x=Y(qR(B,g,i)|0,b)|0;y=c+(A<<1)|0;z=0;do{C=Y(h[a+(z+x)>>0]|0,j[y>>1]|0)|0;D=s+(z<<1)|0;E=j[D>>1]|0;F=(C>>>0<65535?C:65535)+E|0;d[D>>1]=E>>>0>(F&65535)>>>0?-1:F&65535;z=z+1|0}while((z|0)!=(b|0));if((B|0)<-1){A=A+1|0;B=B+1|0}else break}}while(0);z=k-t+1|0;y=t+l|0;x=(y|0)>(g|0)?g:y;F=(x|0)<2;if(F|r){G=F?z:w;H=F?1:x}else{F=z;z=1;while(1){E=Y(z,b)|0;D=c+(F<<1)|0;C=0;do{I=Y(h[a+(C+E)>>0]|0,j[D>>1]|0)|0;J=s+(C<<1)|0;K=j[J>>1]|0;L=(I>>>0<65535?I:65535)+K|0;d[J>>1]=K>>>0>(L&65535)>>>0?-1:L&65535;C=C+1|0}while((C|0)!=(b|0));z=z+1|0;C=F+1|0;if((z|0)>=(x|0)){G=C;H=x;break}else F=C}}b:do if(o&(H|0)<(y|0)){if(n){M=G;N=H}else{F=H;while(1){qR(F,g,i)|0;F=F+1|0;if((F|0)==(p|0))break b}}while(1){F=Y(qR(N,g,i)|0,b)|0;x=c+(M<<1)|0;z=0;do{w=Y(h[a+(z+F)>>0]|0,j[x>>1]|0)|0;C=s+(z<<1)|0;D=j[C>>1]|0;E=(w>>>0<65535?w:65535)+D|0;d[C>>1]=D>>>0>(E&65535)>>>0?-1:E&65535;z=z+1|0}while((z|0)!=(b|0));N=N+1|0;if((N|0)==(p|0))break;else M=M+1|0}}while(0);t=t+1|0;y=s+(b<<1)|0;if((t|0)>=(m|0)){O=y;P=m;break}else{s=y;u=u+-1|0;v=v+-1|0;p=p+1|0}}}else{O=f;P=0}f=Y(P,b)|0;p=Y(1-l+g|0,b)|0;do if((f|0)<(p|0)){l=Y(k+g+1-P-e|0,b)|0;v=a+l|0;if((e|0)>1){Q=a;R=O;S=f}else{u=a;s=O;m=f;while(1){t=Y(h[u>>0]|0,j[c>>1]|0)|0;d[s>>1]=t>>>0<65535?t:65535;m=m+1|0;if((m|0)==(p|0))break;else{u=u+1|0;s=s+2|0}}T=v;U=O+(l<<1)|0;V=p;break}while(1){s=Y(h[Q>>0]|0,j[c>>1]|0)|0;u=(s>>>0<65535?s:65535)&65535;d[R>>1]=u;s=1;m=u;do{u=Q+(Y(s,b)|0)|0;t=Y(h[u>>0]|0,j[c+(s<<1)>>1]|0)|0;u=m&65535;M=(t>>>0<65535?t:65535)+u|0;m=u>>>0>(M&65535)>>>0?-1:M&65535;d[R>>1]=m;s=s+1|0}while((s|0)!=(e|0));S=S+1|0;if((S|0)==(p|0))break;else{Q=Q+1|0;R=R+2|0}}T=v;U=O+(l<<1)|0;V=p}else{T=a;U=O;V=f}while(0);f=(V|0)/(b|0)|0;V=f-k|0;O=g-k|0;if((V|0)>=(O|0))return;a=(b|0)>0;p=(i|0)!=0;R=a^1;Q=T;T=V;V=U;U=k+g-f|0;while(1){if(a){f=0;do{k=Y(h[Q+f>>0]|0,j[c>>1]|0)|0;d[V+(f<<1)>>1]=k>>>0<65535?k:65535;f=f+1|0}while((f|0)!=(b|0))}f=g-T|0;l=(f|0)<2;if(l|R)W=l?1:f;else{l=1;do{v=Y(l,b)|0;k=c+(l<<1)|0;S=0;do{P=Y(h[Q+(S+v)>>0]|0,j[k>>1]|0)|0;s=V+(S<<1)|0;m=j[s>>1]|0;M=(P>>>0<65535?P:65535)+m|0;d[s>>1]=m>>>0>(M&65535)>>>0?-1:M&65535;S=S+1|0}while((S|0)!=(b|0));l=l+1|0}while((l|0)!=(U|0));W=f}c:do if(p&(W|0)<(e|0)){if(a)X=W;else{f=W;while(1){qR(f+T|0,g,i)|0;f=f+1|0;if((f|0)==(e|0))break c}}do{f=Y((qR(X+T|0,g,i)|0)-T|0,b)|0;l=c+(X<<1)|0;S=0;do{k=Y(h[Q+(S+f)>>0]|0,j[l>>1]|0)|0;v=V+(S<<1)|0;M=j[v>>1]|0;m=(k>>>0<65535?k:65535)+M|0;d[v>>1]=M>>>0>(m&65535)>>>0?-1:m&65535;S=S+1|0}while((S|0)!=(b|0));X=X+1|0}while((X|0)!=(e|0))}while(0);T=T+1|0;if((T|0)==(O|0))break;else{Q=Q+b|0;V=V+(b<<1)|0;U=U+-1|0}}return}function Vqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;d=f[a>>2]|0;if((g|0)>0)h=0;else return;do{b[e+h>>0]=((j[d+(h<<1)>>1]|0)+128|0)>>>8;h=h+1|0}while((h|0)!=(g|0));return}function Wqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;d=f[a>>2]|0;if((g|0)<=0)return;a=0;do{h=((Y(j[d+(a<<1)>>1]|0,j[c>>1]|0)|0)+32768|0)>>>16;b[e+a>>0]=h>>>0<255?h:255;a=a+1|0}while((a|0)!=(g|0));return}function Xqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;if((g|0)<=0)return;d=a+8|0;c=a+4|0;h=0;do{b[e+h>>0]=((j[(f[a>>2]|0)+(h<<1)>>1]|0)+512+(j[(f[d>>2]|0)+(h<<1)>>1]|0)+((j[(f[c>>2]|0)+(h<<1)>>1]|0)<<1)|0)>>>10;h=h+1|0}while((h|0)!=(g|0));return}function Yqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0;if((g|0)<=0)return;d=a+4|0;h=c+2|0;i=a+8|0;k=c+4|0;l=0;do{m=Y(j[(f[a>>2]|0)+(l<<1)>>1]|0,j[c>>1]|0)|0;n=(Y(j[(f[d>>2]|0)+(l<<1)>>1]|0,j[h>>1]|0)|0)+m|0;o=n>>>0<m>>>0?-1:n;n=(Y(j[(f[i>>2]|0)+(l<<1)>>1]|0,j[k>>1]|0)|0)+o|0;m=n>>>0<o>>>0?0:(n+32768|0)>>>16;b[e+l>>0]=m>>>0<255?m:255;l=l+1|0}while((l|0)!=(g|0));return}function Zqa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0;if((g|0)<=0)return;d=a+8|0;c=a+4|0;h=a+12|0;i=a+16|0;k=0;do{b[e+k>>0]=(((j[(f[d>>2]|0)+(k<<1)>>1]|0)*6|0)+2048+((j[(f[h>>2]|0)+(k<<1)>>1]|0)+(j[(f[c>>2]|0)+(k<<1)>>1]|0)<<2)+(j[(f[a>>2]|0)+(k<<1)>>1]|0)+(j[(f[i>>2]|0)+(k<<1)>>1]|0)|0)>>>12;k=k+1|0}while((k|0)!=(g|0));return}function _qa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((g|0)<=0)return;d=a+4|0;h=c+2|0;i=a+8|0;k=c+4|0;l=a+12|0;m=c+6|0;n=a+16|0;o=c+8|0;p=0;do{q=Y(j[(f[a>>2]|0)+(p<<1)>>1]|0,j[c>>1]|0)|0;r=(Y(j[(f[d>>2]|0)+(p<<1)>>1]|0,j[h>>1]|0)|0)+q|0;s=r>>>0<q>>>0?-1:r;r=(Y(j[(f[i>>2]|0)+(p<<1)>>1]|0,j[k>>1]|0)|0)+s|0;q=r>>>0<s>>>0?-1:r;r=(Y(j[(f[l>>2]|0)+(p<<1)>>1]|0,j[m>>1]|0)|0)+q|0;s=r>>>0<q>>>0?-1:r;r=(Y(j[(f[n>>2]|0)+(p<<1)>>1]|0,j[o>>1]|0)|0)+s|0;q=r>>>0<s>>>0?0:(r+32768|0)>>>16;b[e+p>>0]=q>>>0<255?q:255;p=p+1|0}while((p|0)!=(g|0));return}function $qa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0;if((g|0)<=0)return;if((d|0)>1)h=0;else{i=0;do{k=((Y(j[(f[a>>2]|0)+(i<<1)>>1]|0,j[c>>1]|0)|0)+32768|0)>>>16;b[e+i>>0]=k>>>0<255?k:255;i=i+1|0}while((i|0)!=(g|0));return}do{i=1;k=Y(j[(f[a>>2]|0)+(h<<1)>>1]|0,j[c>>1]|0)|0;do{l=(Y(j[(f[a+(i<<2)>>2]|0)+(h<<1)>>1]|0,j[c+(i<<1)>>1]|0)|0)+k|0;k=l>>>0<k>>>0?-1:l;i=i+1|0}while((i|0)!=(d|0));i=(k+32768|0)>>>16;b[e+h>>0]=i>>>0<255?i:255;h=h+1|0}while((h|0)!=(g|0));return}function ara(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0;if((g|0)<=0)return;if((d|0)>1)h=0;else{i=0;do{k=((Y(j[(f[a>>2]|0)+(i<<1)>>1]|0,j[c>>1]|0)|0)+32768|0)>>>16;b[e+i>>0]=k>>>0<255?k:255;i=i+1|0}while((i|0)!=(g|0));return}do{i=1;k=Y(j[(f[a>>2]|0)+(h<<1)>>1]|0,j[c>>1]|0)|0;do{l=(Y(j[(f[a+(i<<2)>>2]|0)+(h<<1)>>1]|0,j[c+(i<<1)>>1]|0)|0)+k|0;k=l>>>0<k>>>0?-1:l;i=i+1|0}while((i|0)!=(d|0));i=(k+32768|0)>>>16;b[e+h>>0]=i>>>0<255?i:255;h=h+1|0}while((h|0)!=(g|0));return}function bra(a){a=a|0;cYc(a);return}function cra(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;d=u;u=u+2128|0;e=d+1072|0;g=d+8|0;h=d;i=a+20|0;k=f[i>>2]|0;l=a+28|0;m=f[l>>2]|0;n=Y(m,k)|0;o=a+44|0;p=f[o>>2]|0;q=Y(n,p)|0;n=e+8|0;g1c(n|0,0,1040)|0;f[e>>2]=n;r=e+4|0;f[r>>2]=q;if(q>>>0>520){s=bYc(q>>>0>2147483647?-1:q<<1)|0;g1c(s|0,0,q<<1|0)|0;f[e>>2]=s;t=s}else t=n;s=p<<1;q=g+8|0;f[g>>2]=q;v=g+4|0;f[v>>2]=s;if(s>>>0>264){w=bYc(s>>>0>1073741823?-1:s<<2)|0;f[g>>2]=w;x=w}else x=q;w=f[c>>2]|0;a:do if((p|0)==1){f[x>>2]=t;s=c+4|0;if((w|0)<(f[s>>2]|0)){y=a+52|0;z=a+4|0;A=a+12|0;B=a+32|0;C=a+40|0;D=a+48|0;E=a+56|0;F=a+36|0;G=a+8|0;H=a+16|0;I=w;J=m;K=t;L=k;while(1){M=(f[z>>2]|0)+(Y(f[A>>2]|0,I)|0)|0;Ii[f[y>>2]&127](M,J,f[B>>2]|0,f[C>>2]|0,K,L,f[D>>2]|0);M=(f[G>>2]|0)+(Y(f[H>>2]|0,I)|0)|0;N=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[E>>2]&255](x,f[F>>2]|0,f[o>>2]|0,M,N);N=I+1|0;if((N|0)>=(f[s>>2]|0))break a;I=N;J=f[l>>2]|0;K=f[x>>2]|0;L=f[i>>2]|0}}}else{L=a+48|0;K=f[L>>2]|0;J=(p|0)/2|0;I=p-J|0;s=I+-1|0;F=w-J|0;if(K|0){E=(F|0)>0?F:0;H=I+w|0;f[h>>2]=H;G=a+24|0;D=f[G>>2]|0;if((E|0)<(((D|0)<(H|0)?D:H)|0)){C=a+52|0;B=a+4|0;y=a+12|0;A=a+32|0;z=a+40|0;N=E;M=0;O=K;K=k;P=m;Q=p;while(1){R=t+((Y(Y(K,M)|0,P)|0)<<1)|0;S=x+(M<<2)|0;f[S>>2]=R;f[x+(Q+M<<2)>>2]=R;R=(f[B>>2]|0)+(Y(f[y>>2]|0,N)|0)|0;Ii[f[C>>2]&127](R,P,f[A>>2]|0,f[z>>2]|0,f[S>>2]|0,K,O);T=N+1|0;U=M+1|0;V=f[G>>2]|0;if((T|0)>=(((V|0)<(H|0)?V:H)|0))break;N=T;M=U;O=f[L>>2]|0;K=f[i>>2]|0;P=f[l>>2]|0;Q=f[o>>2]|0}W=f[h>>2]|0;X=T;Z=U;_=V}else{W=H;X=E;Z=0;_=D}b:do if((X|0)<(W|0)){Q=a+52|0;P=a+4|0;K=a+12|0;O=a+32|0;M=a+40|0;N=X;z=Z;A=_;while(1){C=qR(N,A,f[L>>2]|0)|0;y=(f[o>>2]|0)+z|0;if((C|0)<(E|0)){B=f[i>>2]|0;S=Y(B,z)|0;R=f[l>>2]|0;$=t+((Y(S,R)|0)<<1)|0;S=x+(z<<2)|0;f[S>>2]=$;f[x+(y<<2)>>2]=$;$=(f[P>>2]|0)+(Y(f[K>>2]|0,C)|0)|0;Ii[f[Q>>2]&127]($,R,f[O>>2]|0,f[M>>2]|0,f[S>>2]|0,B,f[L>>2]|0)}else{B=f[x+(C-E<<2)>>2]|0;f[x+(z<<2)>>2]=B;f[x+(y<<2)>>2]=B}B=N+1|0;y=z+1|0;if((B|0)>=(W|0)){aa=B;ba=y;break b}N=B;z=y;A=f[G>>2]|0}}else{aa=X;ba=Z}while(0);if((F|0)<0){E=f[h>>2]|0;D=a+52|0;H=a+4|0;A=a+12|0;z=a+32|0;N=a+40|0;M=F;while(1){O=qR(M,f[G>>2]|0,f[L>>2]|0)|0;Q=f[o>>2]|0;K=(Q<<1)+M|0;P=Q+M|0;if((O|0)<(E|0)){Q=f[x+(O<<2)>>2]|0;f[x+(P<<2)>>2]=Q;f[x+(K<<2)>>2]=Q}else{Q=f[i>>2]|0;y=Y(Q,P)|0;B=f[l>>2]|0;C=t+((Y(y,B)|0)<<1)|0;y=x+(P<<2)|0;f[y>>2]=C;f[x+(K<<2)>>2]=C;C=(f[H>>2]|0)+(Y(f[A>>2]|0,O)|0)|0;Ii[f[D>>2]&127](C,B,f[z>>2]|0,f[N>>2]|0,f[y>>2]|0,Q,f[L>>2]|0)}if((M|0)<-1)M=M+1|0;else break}}M=a+56|0;N=a+36|0;z=a+8|0;D=a+16|0;A=(f[z>>2]|0)+(Y(f[D>>2]|0,w)|0)|0;H=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+(ba<<2)|0,f[N>>2]|0,f[o>>2]|0,A,H);H=f[o>>2]|0;A=c+4|0;E=(f[A>>2]|0)+s|0;Q=f[G>>2]|0;y=(ba|0)%(H|0)|0;B=(E|0)<(Q|0)?E:Q;f[h>>2]=B;Q=w+1|0;if((aa|0)<(((B|0)<(H|0)?B:H)|0)){E=a+52|0;C=a+4|0;O=a+12|0;K=a+32|0;P=a+40|0;S=Q;R=aa;$=y;ca=H;do{H=f[i>>2]|0;da=Y(H,$)|0;ea=f[l>>2]|0;fa=t+((Y(da,ea)|0)<<1)|0;da=x+($<<2)|0;f[da>>2]=fa;f[x+(ca+$<<2)>>2]=fa;fa=(f[C>>2]|0)+(Y(f[O>>2]|0,R)|0)|0;Ii[f[E>>2]&127](fa,ea,f[K>>2]|0,f[P>>2]|0,f[da>>2]|0,H,f[L>>2]|0);H=f[o>>2]|0;$=($+1|0)%(H|0)|0;da=(f[z>>2]|0)+(Y(f[D>>2]|0,S)|0)|0;ea=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+($<<2)|0,f[N>>2]|0,H,da,ea);R=R+1|0;S=S+1|0;ca=f[o>>2]|0}while((R|0)<(((B|0)<(ca|0)?B:ca)|0));ga=f[h>>2]|0;ha=S;ia=R;ja=$}else{ga=B;ha=Q;ia=aa;ja=y}if((ia|0)<(ga|0)){ca=a+52|0;P=a+4|0;K=a+12|0;E=a+32|0;O=a+40|0;C=ha;ea=ia;da=ja;while(1){H=(f[P>>2]|0)+(Y(f[K>>2]|0,ea)|0)|0;Ii[f[ca>>2]&127](H,f[l>>2]|0,f[E>>2]|0,f[O>>2]|0,f[x+(da<<2)>>2]|0,f[i>>2]|0,f[L>>2]|0);H=f[o>>2]|0;fa=(da+1|0)%(H|0)|0;ka=(f[z>>2]|0)+(Y(f[D>>2]|0,C)|0)|0;la=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+(fa<<2)|0,f[N>>2]|0,H,ka,la);la=ea+1|0;ka=C+1|0;if((la|0)<(ga|0)){C=ka;ea=la;da=fa}else{ma=ka;na=la;oa=fa;break}}}else{ma=ha;na=ia;oa=ja}if((na|0)<((f[A>>2]|0)+s|0)){da=a+52|0;ea=a+4|0;C=a+12|0;O=a+32|0;E=a+40|0;ca=ma;K=na;P=oa;while(1){y=qR(K,f[G>>2]|0,f[L>>2]|0)|0;Q=K-y|0;B=f[o>>2]|0;if((Q|0)>(B|0)){$=(f[ea>>2]|0)+(Y(f[C>>2]|0,y)|0)|0;Ii[f[da>>2]&127]($,f[l>>2]|0,f[O>>2]|0,f[E>>2]|0,f[x+(P<<2)>>2]|0,f[i>>2]|0,f[L>>2]|0)}else{$=f[x+(((P-Q+B|0)%(B|0)|0)<<2)>>2]|0;f[x+(P<<2)>>2]=$;f[x+(B+P<<2)>>2]=$}$=f[o>>2]|0;P=(P+1|0)%($|0)|0;B=(f[z>>2]|0)+(Y(f[D>>2]|0,ca)|0)|0;Q=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[M>>2]&255](x+(P<<2)|0,f[N>>2]|0,$,B,Q);K=K+1|0;if((K|0)>=((f[A>>2]|0)+s|0))break;else ca=ca+1|0}}break}ca=I+w|0;A=a+24|0;K=f[A>>2]|0;N=(K|0)<(ca|0)?K:ca;f[h>>2]=N;ca=(F|0)>0;K=ca?F:0;c:do if((K|0)<(N|0)){P=a+52|0;M=a+4|0;D=a+12|0;z=a+32|0;E=a+40|0;O=K;da=0;C=k;ea=m;G=p;Q=0;while(1){B=t+((Y(Y(C,da)|0,ea)|0)<<1)|0;$=x+(da<<2)|0;f[$>>2]=B;f[x+(G+da<<2)>>2]=B;B=(f[M>>2]|0)+(Y(f[D>>2]|0,O)|0)|0;Ii[f[P>>2]&127](B,ea,f[z>>2]|0,f[E>>2]|0,f[$>>2]|0,C,Q);pa=O+1|0;qa=da+1|0;if((pa|0)>=(N|0))break;O=pa;da=qa;C=f[i>>2]|0;ea=f[l>>2]|0;G=f[o>>2]|0;Q=f[L>>2]|0}Q=a+36|0;G=f[Q>>2]|0;switch(da|0){case 0:{ea=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;C=Y(f[l>>2]|0,f[i>>2]|0)|0;O=f[x>>2]|0;if((C|0)<=0){ra=1;sa=pa;ta=Q;break c}E=G+((ca?0:0-F|0)<<1)|0;z=0;do{P=((Y(j[O+(z<<1)>>1]|0,j[E>>1]|0)|0)+32768|0)>>>16;b[ea+z>>0]=P>>>0<255?P:255;z=z+1|0}while((z|0)!=(C|0));ra=qa;sa=pa;ta=Q;break}case 2:{C=G+((ca?0:0-F|0)<<1)|0;z=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;ea=Y(f[l>>2]|0,f[i>>2]|0)|0;if((ea|0)<=0){ra=3;sa=pa;ta=Q;break c}E=x+4|0;O=C+2|0;da=x+8|0;P=C+4|0;D=0;do{M=Y(j[(f[x>>2]|0)+(D<<1)>>1]|0,j[C>>1]|0)|0;$=(Y(j[(f[E>>2]|0)+(D<<1)>>1]|0,j[O>>1]|0)|0)+M|0;B=$>>>0<M>>>0?-1:$;$=(Y(j[(f[da>>2]|0)+(D<<1)>>1]|0,j[P>>1]|0)|0)+B|0;M=$>>>0<B>>>0?0:($+32768|0)>>>16;b[z+D>>0]=M>>>0<255?M:255;D=D+1|0}while((D|0)!=(ea|0));ra=qa;sa=pa;ta=Q;break}case 4:{ea=G+((ca?0:0-F|0)<<1)|0;D=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;z=Y(f[l>>2]|0,f[i>>2]|0)|0;if((z|0)<=0){ra=5;sa=pa;ta=Q;break c}P=x+4|0;da=ea+2|0;O=x+8|0;E=ea+4|0;C=x+12|0;M=ea+6|0;$=x+16|0;B=ea+8|0;y=0;do{R=Y(j[(f[x>>2]|0)+(y<<1)>>1]|0,j[ea>>1]|0)|0;S=(Y(j[(f[P>>2]|0)+(y<<1)>>1]|0,j[da>>1]|0)|0)+R|0;fa=S>>>0<R>>>0?-1:S;S=(Y(j[(f[O>>2]|0)+(y<<1)>>1]|0,j[E>>1]|0)|0)+fa|0;R=S>>>0<fa>>>0?-1:S;S=(Y(j[(f[C>>2]|0)+(y<<1)>>1]|0,j[M>>1]|0)|0)+R|0;fa=S>>>0<R>>>0?-1:S;S=(Y(j[(f[$>>2]|0)+(y<<1)>>1]|0,j[B>>1]|0)|0)+fa|0;R=S>>>0<fa>>>0?0:(S+32768|0)>>>16;b[D+y>>0]=R>>>0<255?R:255;y=y+1|0}while((y|0)!=(z|0));ra=qa;sa=pa;ta=Q;break}default:{ua=qa;va=pa;wa=Q;xa=G;ya=58;break c}}}else{z=a+36|0;ua=0;va=K;wa=z;xa=f[z>>2]|0;ya=58}while(0);d:do if((ya|0)==58){N=xa+((ca?0:0-F|0)<<1)|0;I=(f[a+8>>2]|0)+(Y(f[a+16>>2]|0,w)|0)|0;z=Y(f[l>>2]|0,f[i>>2]|0)|0;if((z|0)>0){if((ua|0)>1)za=0;else{y=0;while(1){D=((Y(j[(f[x>>2]|0)+(y<<1)>>1]|0,j[N>>1]|0)|0)+32768|0)>>>16;b[I+y>>0]=D>>>0<255?D:255;y=y+1|0;if((y|0)==(z|0)){ra=ua;sa=va;ta=wa;break d}}}do{y=1;G=Y(j[(f[x>>2]|0)+(za<<1)>>1]|0,j[N>>1]|0)|0;do{Q=(Y(j[(f[x+(y<<2)>>2]|0)+(za<<1)>>1]|0,j[N+(y<<1)>>1]|0)|0)+G|0;G=Q>>>0<G>>>0?-1:Q;y=y+1|0}while((y|0)!=(ua|0));y=(G+32768|0)>>>16;b[I+za>>0]=y>>>0<255?y:255;za=za+1|0}while((za|0)!=(z|0));ra=ua;sa=va;ta=wa}else{ra=ua;sa=va;ta=wa}}while(0);F=f[o>>2]|0;ca=c+4|0;z=(f[ca>>2]|0)+s|0;I=f[A>>2]|0;N=(ra|0)%(F|0)|0;y=(z|0)<(I|0)?z:I;f[h>>2]=y;I=w+1|0;if((sa|0)<(((y|0)<(F|0)?y:F)|0)){z=a+52|0;Q=a+4|0;D=a+12|0;B=a+32|0;$=a+40|0;M=a+16|0;C=a+8|0;E=x+4|0;O=x+8|0;da=x+12|0;P=x+16|0;ea=I;R=sa;S=N;fa=F;while(1){la=f[i>>2]|0;ka=Y(la,S)|0;H=f[l>>2]|0;Aa=t+((Y(ka,H)|0)<<1)|0;ka=x+(S<<2)|0;f[ka>>2]=Aa;f[x+(fa+S<<2)>>2]=Aa;Aa=(f[Q>>2]|0)+(Y(f[D>>2]|0,R)|0)|0;Ii[f[z>>2]&127](Aa,H,f[B>>2]|0,f[$>>2]|0,f[ka>>2]|0,la,f[L>>2]|0);la=S+1|0;ka=~S;H=f[ta>>2]|0;Aa=f[C>>2]|0;Ba=Y(f[i>>2]|0,f[l>>2]|0)|0;Ca=Y(f[M>>2]|0,ea)|0;e:do if((la|0)==3){Da=H+(f[o>>2]<<1)+(ka<<1)|0;Ea=Aa+Ca|0;if((Ba|0)>0){Fa=Da+2|0;Ga=Da+4|0;Ha=0;do{Ia=Y(j[(f[x>>2]|0)+(Ha<<1)>>1]|0,j[Da>>1]|0)|0;Ja=(Y(j[(f[E>>2]|0)+(Ha<<1)>>1]|0,j[Fa>>1]|0)|0)+Ia|0;Ka=Ja>>>0<Ia>>>0?-1:Ja;Ja=(Y(j[(f[O>>2]|0)+(Ha<<1)>>1]|0,j[Ga>>1]|0)|0)+Ka|0;Ia=Ja>>>0<Ka>>>0?0:(Ja+32768|0)>>>16;b[Ea+Ha>>0]=Ia>>>0<255?Ia:255;Ha=Ha+1|0}while((Ha|0)!=(Ba|0))}}else{Ha=H+(f[o>>2]<<1)+(ka<<1)|0;Ea=Aa+Ca|0;Ga=(Ba|0)>0;if((la|0)==5){if(!Ga)break;Fa=Ha+2|0;Da=Ha+4|0;G=Ha+6|0;Ia=Ha+8|0;Ja=0;while(1){Ka=Y(j[(f[x>>2]|0)+(Ja<<1)>>1]|0,j[Ha>>1]|0)|0;La=(Y(j[(f[E>>2]|0)+(Ja<<1)>>1]|0,j[Fa>>1]|0)|0)+Ka|0;Ma=La>>>0<Ka>>>0?-1:La;La=(Y(j[(f[O>>2]|0)+(Ja<<1)>>1]|0,j[Da>>1]|0)|0)+Ma|0;Ka=La>>>0<Ma>>>0?-1:La;La=(Y(j[(f[da>>2]|0)+(Ja<<1)>>1]|0,j[G>>1]|0)|0)+Ka|0;Ma=La>>>0<Ka>>>0?-1:La;La=(Y(j[(f[P>>2]|0)+(Ja<<1)>>1]|0,j[Ia>>1]|0)|0)+Ma|0;Ka=La>>>0<Ma>>>0?0:(La+32768|0)>>>16;b[Ea+Ja>>0]=Ka>>>0<255?Ka:255;Ja=Ja+1|0;if((Ja|0)==(Ba|0))break e}}if(Ga){if((R|0)>0)Na=0;else{Ja=0;while(1){Ia=((Y(j[(f[x>>2]|0)+(Ja<<1)>>1]|0,j[Ha>>1]|0)|0)+32768|0)>>>16;b[Ea+Ja>>0]=Ia>>>0<255?Ia:255;Ja=Ja+1|0;if((Ja|0)==(Ba|0))break e}}do{Ja=1;Ga=Y(j[(f[x>>2]|0)+(Na<<1)>>1]|0,j[Ha>>1]|0)|0;while(1){Ia=(Y(j[(f[x+(Ja<<2)>>2]|0)+(Na<<1)>>1]|0,j[Ha+(Ja<<1)>>1]|0)|0)+Ga|0;Ga=Ia>>>0<Ga>>>0?-1:Ia;if((Ja|0)==(R|0))break;else Ja=Ja+1|0}Ja=(Ga+32768|0)>>>16;b[Ea+Na>>0]=Ja>>>0<255?Ja:255;Na=Na+1|0}while((Na|0)!=(Ba|0))}}while(0);Ba=f[o>>2]|0;Ca=(la|0)%(Ba|0)|0;Aa=R+1|0;ka=ea+1|0;if((Aa|0)<(((y|0)<(Ba|0)?y:Ba)|0)){ea=ka;R=Aa;S=Ca;fa=Ba}else{Oa=ka;Pa=Ca;Qa=Aa;Ra=Ba;break}}}else{Oa=I;Pa=N;Qa=sa;Ra=F}if((Qa-K|0)<(Ra|0)){fa=Oa-J|0;S=f[ca>>2]|0;R=S-J|0;if((fa|0)<(((R|0)<0?R:0)|0)){R=a+16|0;ea=a+8|0;y=x+4|0;P=x+8|0;da=x+12|0;O=x+16|0;E=Oa;M=fa;while(1){C=f[A>>2]|0;$=0-M|0;B=f[ta>>2]|0;z=f[ea>>2]|0;D=Y(f[R>>2]|0,E)|0;Q=Y(f[i>>2]|0,f[l>>2]|0)|0;f:do if((C|0)==3){s=B+($<<1)|0;Ba=z+D|0;if((Q|0)>0){Aa=s+2|0;Ca=s+4|0;ka=0;do{H=Y(j[(f[x>>2]|0)+(ka<<1)>>1]|0,j[s>>1]|0)|0;Ea=(Y(j[(f[y>>2]|0)+(ka<<1)>>1]|0,j[Aa>>1]|0)|0)+H|0;Ha=Ea>>>0<H>>>0?-1:Ea;Ea=(Y(j[(f[P>>2]|0)+(ka<<1)>>1]|0,j[Ca>>1]|0)|0)+Ha|0;H=Ea>>>0<Ha>>>0?0:(Ea+32768|0)>>>16;b[Ba+ka>>0]=H>>>0<255?H:255;ka=ka+1|0}while((ka|0)!=(Q|0))}}else{ka=B+($<<1)|0;Ba=z+D|0;Ca=(Q|0)>0;if((C|0)==5){if(!Ca)break;Aa=ka+2|0;s=ka+4|0;H=ka+6|0;Ea=ka+8|0;Ha=0;while(1){Ja=Y(j[(f[x>>2]|0)+(Ha<<1)>>1]|0,j[ka>>1]|0)|0;Ia=(Y(j[(f[y>>2]|0)+(Ha<<1)>>1]|0,j[Aa>>1]|0)|0)+Ja|0;G=Ia>>>0<Ja>>>0?-1:Ia;Ia=(Y(j[(f[P>>2]|0)+(Ha<<1)>>1]|0,j[s>>1]|0)|0)+G|0;Ja=Ia>>>0<G>>>0?-1:Ia;Ia=(Y(j[(f[da>>2]|0)+(Ha<<1)>>1]|0,j[H>>1]|0)|0)+Ja|0;G=Ia>>>0<Ja>>>0?-1:Ia;Ia=(Y(j[(f[O>>2]|0)+(Ha<<1)>>1]|0,j[Ea>>1]|0)|0)+G|0;Ja=Ia>>>0<G>>>0?0:(Ia+32768|0)>>>16;b[Ba+Ha>>0]=Ja>>>0<255?Ja:255;Ha=Ha+1|0;if((Ha|0)==(Q|0))break f}}if(Ca){if((C|0)>1)Sa=0;else{Ha=0;while(1){Ea=((Y(j[(f[x>>2]|0)+(Ha<<1)>>1]|0,j[ka>>1]|0)|0)+32768|0)>>>16;b[Ba+Ha>>0]=Ea>>>0<255?Ea:255;Ha=Ha+1|0;if((Ha|0)==(Q|0))break f}}do{Ha=1;Ca=Y(j[(f[x>>2]|0)+(Sa<<1)>>1]|0,j[ka>>1]|0)|0;do{Ea=(Y(j[(f[x+(Ha<<2)>>2]|0)+(Sa<<1)>>1]|0,j[ka+(Ha<<1)>>1]|0)|0)+Ca|0;Ca=Ea>>>0<Ca>>>0?-1:Ea;Ha=Ha+1|0}while((Ha|0)!=(C|0));Ha=(Ca+32768|0)>>>16;b[Ba+Sa>>0]=Ha>>>0<255?Ha:255;Sa=Sa+1|0}while((Sa|0)!=(Q|0))}}while(0);Q=M+1|0;C=E+1|0;D=f[ca>>2]|0;z=D-J|0;if((Q|0)<(((z|0)<0?z:0)|0)){E=C;M=Q}else{Ta=C;Ua=Q;Va=D;break}}}else{Ta=Oa;Ua=fa;Va=S}if((Ua|0)<(Va-J|0)){M=0-K|0;E=a+8|0;O=a+16|0;da=Ta;P=Ua;while(1){y=(f[A>>2]|0)-P|0;g:do if((y|0)==3){R=x+(P<<2)+(M<<2)|0;ea=f[ta>>2]|0;F=(f[E>>2]|0)+(Y(f[O>>2]|0,da)|0)|0;N=Y(f[l>>2]|0,f[i>>2]|0)|0;if((N|0)>0){I=R+4|0;D=ea+2|0;Q=R+8|0;C=ea+4|0;z=0;do{$=Y(j[(f[R>>2]|0)+(z<<1)>>1]|0,j[ea>>1]|0)|0;B=(Y(j[(f[I>>2]|0)+(z<<1)>>1]|0,j[D>>1]|0)|0)+$|0;la=B>>>0<$>>>0?-1:B;B=(Y(j[(f[Q>>2]|0)+(z<<1)>>1]|0,j[C>>1]|0)|0)+la|0;$=B>>>0<la>>>0?0:(B+32768|0)>>>16;b[F+z>>0]=$>>>0<255?$:255;z=z+1|0}while((z|0)!=(N|0))}}else{N=x+(P<<2)+(M<<2)|0;z=f[ta>>2]|0;F=(f[E>>2]|0)+(Y(f[O>>2]|0,da)|0)|0;C=Y(f[l>>2]|0,f[i>>2]|0)|0;Q=(C|0)>0;if((y|0)==5){if(!Q)break;D=N+4|0;I=z+2|0;ea=N+8|0;R=z+4|0;$=N+12|0;B=z+6|0;la=N+16|0;Ba=z+8|0;ka=0;while(1){Ha=Y(j[(f[N>>2]|0)+(ka<<1)>>1]|0,j[z>>1]|0)|0;Ga=(Y(j[(f[D>>2]|0)+(ka<<1)>>1]|0,j[I>>1]|0)|0)+Ha|0;Ea=Ga>>>0<Ha>>>0?-1:Ga;Ga=(Y(j[(f[ea>>2]|0)+(ka<<1)>>1]|0,j[R>>1]|0)|0)+Ea|0;Ha=Ga>>>0<Ea>>>0?-1:Ga;Ga=(Y(j[(f[$>>2]|0)+(ka<<1)>>1]|0,j[B>>1]|0)|0)+Ha|0;Ea=Ga>>>0<Ha>>>0?-1:Ga;Ga=(Y(j[(f[la>>2]|0)+(ka<<1)>>1]|0,j[Ba>>1]|0)|0)+Ea|0;Ha=Ga>>>0<Ea>>>0?0:(Ga+32768|0)>>>16;b[F+ka>>0]=Ha>>>0<255?Ha:255;ka=ka+1|0;if((ka|0)==(C|0))break g}}if(Q){if((y|0)>1)Wa=0;else{ka=0;while(1){Ba=((Y(j[(f[N>>2]|0)+(ka<<1)>>1]|0,j[z>>1]|0)|0)+32768|0)>>>16;b[F+ka>>0]=Ba>>>0<255?Ba:255;ka=ka+1|0;if((ka|0)==(C|0))break g}}do{ka=1;Q=Y(j[(f[N>>2]|0)+(Wa<<1)>>1]|0,j[z>>1]|0)|0;do{Ba=(Y(j[(f[N+(ka<<2)>>2]|0)+(Wa<<1)>>1]|0,j[z+(ka<<1)>>1]|0)|0)+Q|0;Q=Ba>>>0<Q>>>0?-1:Ba;ka=ka+1|0}while((ka|0)!=(y|0));ka=(Q+32768|0)>>>16;b[F+Wa>>0]=ka>>>0<255?ka:255;Wa=Wa+1|0}while((Wa|0)!=(C|0))}}while(0);P=P+1|0;if((P|0)>=((f[ca>>2]|0)-J|0))break;else da=da+1|0}}}else{da=f[h>>2]|0;if((Qa|0)<(da|0)){P=a+52|0;O=a+4|0;E=a+12|0;M=a+32|0;K=a+40|0;S=a+56|0;fa=a+8|0;y=a+16|0;C=Oa;F=Qa;z=Pa;while(1){N=(f[O>>2]|0)+(Y(f[E>>2]|0,F)|0)|0;Ii[f[P>>2]&127](N,f[l>>2]|0,f[M>>2]|0,f[K>>2]|0,f[x+(z<<2)>>2]|0,f[i>>2]|0,f[L>>2]|0);N=f[o>>2]|0;ka=(z+1|0)%(N|0)|0;Ca=(f[fa>>2]|0)+(Y(f[y>>2]|0,C)|0)|0;Ba=Y(f[l>>2]|0,f[i>>2]|0)|0;gi[f[S>>2]&255](x+(ka<<2)|0,f[ta>>2]|0,N,Ca,Ba);F=F+1|0;Ba=C+1|0;if((F|0)>=(da|0)){Xa=Ba;Ya=ka;break}else{C=Ba;z=ka}}}else{Xa=Oa;Ya=Pa}z=Xa-J|0;if((z|0)<((f[ca>>2]|0)-J|0)){C=a+16|0;da=a+8|0;F=Xa;S=z;z=(Ya+1|0)%(f[o>>2]|0)|0;while(1){y=(f[A>>2]|0)-S|0;fa=f[ta>>2]|0;L=f[da>>2]|0;K=Y(f[i>>2]|0,f[l>>2]|0)|0;M=Y(f[C>>2]|0,F)|0;h:do if((y|0)==3){P=x+(z<<2)|0;E=L+M|0;if((K|0)>0){O=P+4|0;ka=fa+2|0;Ba=P+8|0;Ca=fa+4|0;N=0;do{la=Y(j[(f[P>>2]|0)+(N<<1)>>1]|0,j[fa>>1]|0)|0;B=(Y(j[(f[O>>2]|0)+(N<<1)>>1]|0,j[ka>>1]|0)|0)+la|0;$=B>>>0<la>>>0?-1:B;B=(Y(j[(f[Ba>>2]|0)+(N<<1)>>1]|0,j[Ca>>1]|0)|0)+$|0;la=B>>>0<$>>>0?0:(B+32768|0)>>>16;b[E+N>>0]=la>>>0<255?la:255;N=N+1|0}while((N|0)!=(K|0))}}else{N=x+(z<<2)|0;E=L+M|0;Ca=(K|0)>0;if((y|0)==5){if(!Ca)break;Ba=N+4|0;ka=fa+2|0;O=N+8|0;P=fa+4|0;la=N+12|0;B=fa+6|0;$=N+16|0;R=fa+8|0;ea=0;while(1){I=Y(j[(f[N>>2]|0)+(ea<<1)>>1]|0,j[fa>>1]|0)|0;D=(Y(j[(f[Ba>>2]|0)+(ea<<1)>>1]|0,j[ka>>1]|0)|0)+I|0;Ha=D>>>0<I>>>0?-1:D;D=(Y(j[(f[O>>2]|0)+(ea<<1)>>1]|0,j[P>>1]|0)|0)+Ha|0;I=D>>>0<Ha>>>0?-1:D;D=(Y(j[(f[la>>2]|0)+(ea<<1)>>1]|0,j[B>>1]|0)|0)+I|0;Ha=D>>>0<I>>>0?-1:D;D=(Y(j[(f[$>>2]|0)+(ea<<1)>>1]|0,j[R>>1]|0)|0)+Ha|0;I=D>>>0<Ha>>>0?0:(D+32768|0)>>>16;b[E+ea>>0]=I>>>0<255?I:255;ea=ea+1|0;if((ea|0)==(K|0))break h}}if(Ca){if((y|0)>1)Za=0;else{ea=0;while(1){R=((Y(j[(f[N>>2]|0)+(ea<<1)>>1]|0,j[fa>>1]|0)|0)+32768|0)>>>16;b[E+ea>>0]=R>>>0<255?R:255;ea=ea+1|0;if((ea|0)==(K|0))break h}}do{ea=1;Ca=Y(j[(f[N>>2]|0)+(Za<<1)>>1]|0,j[fa>>1]|0)|0;do{R=(Y(j[(f[N+(ea<<2)>>2]|0)+(Za<<1)>>1]|0,j[fa+(ea<<1)>>1]|0)|0)+Ca|0;Ca=R>>>0<Ca>>>0?-1:R;ea=ea+1|0}while((ea|0)!=(y|0));ea=(Ca+32768|0)>>>16;b[E+Za>>0]=ea>>>0<255?ea:255;Za=Za+1|0}while((Za|0)!=(K|0))}}while(0);S=S+1|0;if((S|0)>=((f[ca>>2]|0)-J|0))break;else{F=F+1|0;z=z+1|0}}}}}while(0);Za=f[g>>2]|0;if((Za|0)!=(q|0)){if(Za|0)dYc(Za);f[g>>2]=q;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(n|0)){u=d;return}if(v|0)dYc(v);f[e>>2]=n;f[r>>2]=520;u=d;return}function dra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,M=0;d=a;e=f[d>>2]|0;g=f[d+4>>2]|0;d=d1c(e|0,g|0,-1,-1)|0;h=J;i=a+8|0;a=f[i>>2]|0;j=f[i+4>>2]|0;i=d1c(a|0,j|0,-1,-1)|0;k=J;if((g|0)<0|(g|0)==0&e>>>0<1|((j|0)<0|(j|0)==0&a>>>0<1)){l=0;return l|0}m=b+8|0;n=c+8|0;o=b;p=f[o>>2]|0;q=f[o+4>>2]|0;o=l1c(p|0,q|0,63)|0;r=m;s=f[r>>2]|0;t=f[r+4>>2]|0;r=l1c(s|0,t|0,61)|0;u=(((q|0)>(g|0)|(q|0)==(g|0)&p>>>0>=e>>>0)&1)<<1|o|r&4|(((t|0)>(j|0)|(t|0)==(j|0)&s>>>0>=a>>>0)&1)<<3;r=c;o=f[r>>2]|0;v=f[r+4>>2]|0;r=l1c(o|0,v|0,63)|0;w=n;x=f[w>>2]|0;y=f[w+4>>2]|0;w=l1c(x|0,y|0,61)|0;z=(((v|0)>(g|0)|(v|0)==(g|0)&o>>>0>=e>>>0)&1)<<1|r|w&4|(((y|0)>(j|0)|(y|0)==(j|0)&x>>>0>=a>>>0)&1)<<3;if(!((z&u|0)!=0|(z|u|0)==0)){if(!(u&12)){A=u;B=p;C=q;D=s;E=t}else{a=u>>>0<8;j=a?0:i;w=a?0:k;a=c1c(j|0,w|0,s|0,t|0)|0;F=+(a>>>0)+4294967296.0*+(J|0);a=c1c(o|0,v|0,p|0,q|0)|0;G=(+(a>>>0)+4294967296.0*+(J|0))*F;a=c1c(x|0,y|0,s|0,t|0)|0;F=G/(+(a>>>0)+4294967296.0*+(J|0));a=d1c(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,p|0,q|0)|0;q=J;p=b;f[p>>2]=a;f[p+4>>2]=q;p=m;f[p>>2]=j;f[p+4>>2]=w;p=l1c(a|0,q|0,63)|0;A=(((q|0)>(g|0)|(q|0)==(g|0)&a>>>0>=e>>>0)&1)<<1|p;B=a;C=q;D=j;E=w}if(!(z&12))H=z;else{w=z>>>0<8;j=w?0:i;i=w?0:k;k=n;w=f[k>>2]|0;q=f[k+4>>2]|0;k=c1c(j|0,i|0,w|0,q|0)|0;F=+(k>>>0)+4294967296.0*+(J|0);k=c;a=f[k>>2]|0;p=f[k+4>>2]|0;k=c1c(a|0,p|0,B|0,C|0)|0;G=F*(+(k>>>0)+4294967296.0*+(J|0));k=c1c(w|0,q|0,D|0,E|0)|0;F=G/(+(k>>>0)+4294967296.0*+(J|0));k=d1c(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,a|0,p|0)|0;p=J;a=c;f[a>>2]=k;f[a+4>>2]=p;a=n;f[a>>2]=j;f[a+4>>2]=i;i=l1c(k|0,p|0,63)|0;H=(((p|0)>(g|0)|(p|0)==(g|0)&k>>>0>=e>>>0)&1)<<1|i}if(!((H&A|0)!=0|(H|A|0)==0)){if(A|0){i=(A|0)==1;e=i?0:d;k=i?0:h;i=b;g=f[i>>2]|0;p=f[i+4>>2]|0;i=c1c(e|0,k|0,g|0,p|0)|0;F=+(i>>>0)+4294967296.0*+(J|0);i=n;a=m;j=f[a>>2]|0;E=f[a+4>>2]|0;a=c1c(f[i>>2]|0,f[i+4>>2]|0,j|0,E|0)|0;G=F*(+(a>>>0)+4294967296.0*+(J|0));a=c;i=c1c(f[a>>2]|0,f[a+4>>2]|0,g|0,p|0)|0;F=G/(+(i>>>0)+4294967296.0*+(J|0));i=d1c(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,j|0,E|0)|0;E=m;f[E>>2]=i;f[E+4>>2]=J;E=b;f[E>>2]=e;f[E+4>>2]=k}if(!H){I=0;M=0}else{k=(H|0)==1;E=k?0:d;d=k?0:h;h=c;k=f[h>>2]|0;e=f[h+4>>2]|0;h=c1c(E|0,d|0,k|0,e|0)|0;F=+(h>>>0)+4294967296.0*+(J|0);h=n;i=f[h>>2]|0;j=f[h+4>>2]|0;h=m;m=c1c(i|0,j|0,f[h>>2]|0,f[h+4>>2]|0)|0;G=F*(+(m>>>0)+4294967296.0*+(J|0));m=b;b=c1c(k|0,e|0,f[m>>2]|0,f[m+4>>2]|0)|0;F=G/(+(b>>>0)+4294967296.0*+(J|0));b=d1c(~~F>>>0|0,(+L(F)>=1.0?(F>0.0?~~+Z(+K(F/4294967296.0),4294967295.0)>>>0:~~+X((F-+(~~F>>>0))/4294967296.0)>>>0):0)|0,i|0,j|0)|0;j=n;f[j>>2]=b;f[j+4>>2]=J;j=c;f[j>>2]=E;f[j+4>>2]=d;I=0;M=0}}else{I=H;M=A}}else{I=z;M=u}l=(M|I|0)==0;return l|0}function era(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;m=a+20|0;f[m>>2]=-1;n=(g|0)==8;switch(g|0){case 4:case 8:break;default:{g=$Xc(48)|0;f[j>>2]=g;f[j+8>>2]=-2147483600;f[j+4>>2]=38;o=g;p=354369;q=o+38|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));b[g+38>>0]=0;vM(-215,j,273195,273208,168)}}g=f[d>>2]|0;p=f[c+12>>2]|0;o=f[e>>2]|0;if((g>>>0<p>>>0&o>>>0<p>>>0?(p=f[c+8>>2]|0,(f[d+4>>2]|0)>>>0<p>>>0):0)?(q=f[e+4>>2]|0,q>>>0<p>>>0):0){r=o;s=q}else{q=f[c+40>>2]|0;p=f[q+4>>2]|0;t=f[q>>2]|0;q=d+4|0;v=f[q>>2]|0;w=j;f[w>>2]=g;f[w+4>>2]=((g|0)<0)<<31>>31;g=j+8|0;w=g;f[w>>2]=v;f[w+4>>2]=((v|0)<0)<<31>>31;v=e+4|0;w=f[v>>2]|0;x=k;f[x>>2]=o;f[x+4>>2]=((o|0)<0)<<31>>31;o=k+8|0;x=o;f[x>>2]=w;f[x+4>>2]=((w|0)<0)<<31>>31;w=l;f[w>>2]=p;f[w+4>>2]=((p|0)<0)<<31>>31;p=l+8|0;f[p>>2]=t;f[p+4>>2]=((t|0)<0)<<31>>31;t=dra(l,j,k)|0;f[d>>2]=f[j>>2];f[q>>2]=f[g>>2];g=f[k>>2]|0;f[e>>2]=g;e=f[o>>2]|0;f[v>>2]=e;if(t){r=g;s=e}else{f[a>>2]=f[c+16>>2];e=a+16|0;f[a+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;y=0;z=0;A=a+8|0;f[A>>2]=z;B=a+12|0;f[B>>2]=y;u=i;return}}e=f[c+4>>2]|0;if((e|0)>0)C=f[(f[c+44>>2]|0)+(e+-1<<2)>>2]|0;else C=0;e=c+48|0;g=f[e>>2]|0;t=f[d>>2]|0;v=r-t|0;o=d+4|0;k=f[o>>2]|0;q=s-k|0;j=v>>31;l=(j^v)-j|0;if(h){h=j&(t^r)^t;f[d>>2]=h;d=(s^k)&j^k;f[o>>2]=d;D=(q^j)-j|0;E=C;F=d;G=h}else{D=q;E=(j^C)-j|0;F=k;G=t}t=c+16|0;c=(f[t>>2]|0)+(Y(F,g)|0)+(Y(G,C)|0)|0;f[a>>2]=c;c=D>>31;G=(c^D)-c|0;D=(c^g)-c|0;c=(G|0)>(l|0);g=(c?G:0)^l;l=(c?g:0)^G;G=(c?l:0)^g;g=(c?D:0)^E;E=(c?g:0)^D;D=(c?E:0)^g;g=G<<1;c=l<<1;if(n){H=g;I=G-c|0;J=G;K=E}else{H=g+c|0;I=0;J=G+l|0;K=E-D|0}f[a+16>>2]=I;f[a+28>>2]=H;f[a+24>>2]=0-c;f[a+36>>2]=K;f[a+32>>2]=D;f[m>>2]=J+1;f[a+4>>2]=f[t>>2];y=C;z=f[e>>2]|0;A=a+8|0;f[A>>2]=z;B=a+12|0;f[B>>2]=y;u=i;return}function fra(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=u;u=u+64|0;j=i+40|0;k=i+16|0;l=i;m=i+32|0;f[j>>2]=0;n=j+4|0;f[n>>2]=0;f[j+8>>2]=0;o=+(f[a+4>>2]|0);p[k>>3]=+(f[a>>2]|0);p[k+8>>3]=o;o=+(f[b+4>>2]|0);p[l>>3]=+(f[b>>2]|0);p[l+8>>3]=o;gra(k,l,c,d,e,g,j);g=h+4|0;e=f[g>>2]|0;d=f[h>>2]|0;c=e;if((e|0)==(d|0)|(c|0)==(d|0))q=e;else{e=c+(~((c+-8-d|0)>>>3)<<3)|0;f[g>>2]=e;q=e}e=f[n>>2]|0;c=f[j>>2]|0;l=c;if((e|0)==(c|0)){r=d;s=q;t=l}else{q=m+4|0;d=h+8|0;k=0;b=-2147483648;v=-2147483648;w=l;x=l;l=c;c=e;while(1){e=zLc(+p[w+(k<<4)>>3])|0;f[m>>2]=e;y=zLc(+p[w+(k<<4)+8>>3])|0;f[q>>2]=y;if((e|0)!=(b|0)|(y|0)!=(v|0)){z=f[g>>2]|0;if((z|0)==(f[d>>2]|0)){Nw(h,m);A=f[n>>2]|0;B=f[j>>2]|0}else{f[z>>2]=e;f[z+4>>2]=y;f[g>>2]=z+8;A=c;B=l}C=f[m>>2]|0;D=f[q>>2]|0;E=B;F=A;G=B}else{C=b;D=v;E=l;F=c;G=x}k=k+1|0;if(k>>>0>=F-E>>4>>>0)break;else{b=C;v=D;w=E;x=G;l=E;c=F}}r=f[h>>2]|0;s=f[g>>2]|0;t=G}if((s-r|0)==8){hra(h,2,a);H=f[j>>2]|0}else H=t;if(!H){u=i;return}t=f[n>>2]|0;if((t|0)!=(H|0))f[n>>2]=t+(~((t+-16-H|0)>>>4)<<4);cYc(H);u=i;return}function gra(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0;i=u;u=u+16|0;j=i;k=((c|0)>0?c:0)+359-c|0;l=k-((k>>>0)%360|0)+c|0;c=~l;k=l+((c|0)>-361?c:-361)+360|0;c=l+(((k>>>0)%360|0)-k)|0;k=(d|0)>(e|0);l=k?d:e;m=k?e:d;if((m|0)<0){k=~((e|0)<(d|0)?e:d);d=((m|0)>-360?m:-360)+k+360|0;e=d-((d>>>0)%360|0)|0;o=e+359-k|0;q=l+e+360|0}else{o=m;q=l}if((q|0)>360){l=q+-361|0;m=l-((l>>>0)%360|0)|0;r=o+-360-m|0;s=q+-360-m|0}else{r=o;s=q}q=(s-r|0)>360;o=q?360:s;s=q?0:r;r=(c>>31&360)+c|0;t=+n[53616+(r<<2)>>2];v=+n[53616+(450-r<<2)>>2];r=h+4|0;c=f[r>>2]|0;q=f[h>>2]|0;m=c;if((c|0)==(q|0)|(m|0)==(q|0)){w=c;x=m}else{c=m+(~((m+-16-q|0)>>>4)<<4)|0;f[r>>2]=c;w=c;x=c}c=o+g|0;if((s|0)<(c|0)){m=b+8|0;y=v;v=t;l=a+8|0;e=j+8|0;k=h+8|0;d=s;s=x;while(1){x=(d|0)>(o|0)?o:d;z=(x|0)<0?x+360|0:x;t=+p[b>>3]*+n[53616+(450-z<<2)>>2];A=+p[m>>3]*+n[53616+(z<<2)>>2];B=y*t+ +p[a>>3]-v*A;p[j>>3]=B;C=y*A+(v*t+ +p[l>>3]);p[e>>3]=C;if((s|0)==(f[k>>2]|0))ira(h,j);else{p[s>>3]=B;p[s+8>>3]=C;f[r>>2]=s+16}z=d+g|0;if((z|0)>=(c|0))break;d=z;s=f[r>>2]|0}D=f[h>>2]|0;E=f[r>>2]|0}else{D=q;E=w}if((E-D|0)!=16){u=i;return}jra(h,2,a);u=i;return}function hra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>3>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>3;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+4|0;o=m;m=h;while(1){f[m>>2]=f[c>>2];f[m+4>>2]=f[j>>2];o=o+-1|0;if(!o)break;else m=m+8|0}}if(!l){m=h+(b<<3)|0;if((n|0)==(m|0))return;else{p=i;q=n+(~((n+-8-m|0)>>>3)<<3)|0;break}}else{m=b-k|0;o=c+4|0;j=m;r=n;while(1){f[r>>2]=f[c>>2];f[r+4>>2]=f[o>>2];j=j+-1|0;if(!j)break;else r=r+8|0}p=i;q=n+(m<<3)|0;break}}else{r=g;if(!g)s=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-8-g|0)>>>3)<<3);cYc(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;s=0}if(b>>>0>536870911)kWc(a);j=s>>2;r=s>>3>>>0<268435455?(j>>>0<b>>>0?b:j):536870911;if(r>>>0>536870911)kWc(a);j=$Xc(r<<3)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<3);r=c+4|0;k=b;l=j;while(1){f[l>>2]=f[c>>2];f[l+4>>2]=f[r>>2];k=k+-1|0;if(!k)break;else l=l+8|0}p=o;q=j+(b<<3)|0}while(0);f[p>>2]=q;return}function ira(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;p[l>>3]=+p[b>>3];p[n+(g<<4)+8>>3]=+p[b+8>>3];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;p[j+-16>>3]=+p[n>>3];p[j+-8>>3]=+p[m+-8>>3];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function jra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=m;m=h;while(1){p[m>>3]=+p[c>>3];p[m+8>>3]=+p[j>>3];o=o+-1|0;if(!o)break;else m=m+16|0}}if(!l){m=h+(b<<4)|0;if((n|0)==(m|0))return;else{q=i;r=n+(~((n+-16-m|0)>>>4)<<4)|0;break}}else{m=b-k|0;o=c+8|0;j=m;s=n;while(1){p[s>>3]=+p[c>>3];p[s+8>>3]=+p[o>>3];j=j+-1|0;if(!j)break;else s=s+16|0}q=i;r=n+(m<<4)|0;break}}else{s=g;if(!g)t=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-16-g|0)>>>4)<<4);cYc(s);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;t=0}if(b>>>0>268435455)kWc(a);j=t>>3;s=t>>4>>>0<134217727?(j>>>0<b>>>0?b:j):268435455;if(s>>>0>268435455)kWc(a);j=$Xc(s<<4)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(s<<4);s=c+8|0;k=b;l=j;while(1){p[l>>3]=+p[c>>3];p[l+8>>3]=+p[s>>3];k=k+-1|0;if(!k)break;else l=l+16|0}q=o;r=j+(b<<4)|0}while(0);f[q>>2]=r;return}function kra(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;j=u;u=u+128|0;k=j+64|0;l=j+32|0;m=j+16|0;n=j;do if((eS(a)|0)==65536){o=f[a+4>>2]|0;f[k>>2]=f[o>>2];p=k+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=k+8|0;f[r>>2]=f[o+8>>2];f[k+12>>2]=f[o+12>>2];f[k+16>>2]=f[o+16>>2];f[k+20>>2]=f[o+20>>2];f[k+24>>2]=f[o+24>>2];f[k+28>>2]=f[o+28>>2];f[k+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=r;r=k+48|0;t=k+44|0;f[t>>2]=r;f[r>>2]=0;f[k+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;U$(k,o);break}}else bS(k,a,-1);while(0);if((h|0)==16)v=(f[k>>2]&7|0)==0?16:8;else v=h;if((g+-1|0)>>>0>=32767){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;h=$Xc(48)|0;f[l>>2]=h;f[l+8>>2]=-2147483600;f[l+4>>2]=43;w=h;x=273280;y=w+43|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[h+43>>0]=0;vM(-215,l,273324,273208,1811)}if(i>>>0>=17){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;h=$Xc(32)|0;f[l>>2]=h;f[l+8>>2]=-2147483616;f[l+4>>2]=31;w=h;x=273329;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[h+31>>0]=0;vM(-215,l,273324,273208,1812)}q3(e,l,f[k>>2]&4095,0);e=f[c>>2]|0;h=f[c+4>>2]|0;c=m;f[c>>2]=e;f[c+4>>2]=((e|0)<0)<<31>>31;e=m+8|0;f[e>>2]=h;f[e+4>>2]=((h|0)<0)<<31>>31;h=f[d>>2]|0;e=f[d+4>>2]|0;d=n;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;h=n+8|0;f[h>>2]=e;f[h+4>>2]=((e|0)<0)<<31>>31;lra(k,m,n,l,g,v,3,i);i=k+36|0;v=f[i>>2]|0;if(v|0?(g=v+12|0,v=f[g>>2]|0,f[g>>2]=v+-1,(v|0)==1):0)V$(k);f[i>>2]=0;i=k+16|0;v=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[v>>2]|0)>0){i=f[k+40>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[v>>2]|0))}v=f[k+44>>2]|0;if((v|0)==(k+48|0)){u=j;return}wL(v);u=j;return}function lra(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0.0,O=0.0,P=0.0,Q=0.0;j=u;u=u+176|0;k=j+80|0;l=j+64|0;m=j+48|0;n=j+32|0;o=j+96|0;p=j+160|0;q=j+16|0;r=j;s=16-i|0;t=b;v=u1c(f[t>>2]|0,f[t+4>>2]|0,s|0)|0;t=b;f[t>>2]=v;f[t+4>>2]=J;t=b+8|0;v=t;w=u1c(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=t;f[v>>2]=w;f[v+4>>2]=J;v=c;w=u1c(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=J;x=c;f[x>>2]=w;f[x+4>>2]=v;x=c+8|0;y=x;z=u1c(f[y>>2]|0,f[y+4>>2]|0,s|0)|0;s=J;y=x;f[y>>2]=z;f[y+4>>2]=s;if((e|0)<2){if((g|0)>=16){y=b;A=f[y+4>>2]|0;B=m;f[B>>2]=f[y>>2];f[B+4>>2]=A;A=t;B=f[A+4>>2]|0;y=m+8|0;f[y>>2]=f[A>>2];f[y+4>>2]=B;B=n;f[B>>2]=w;f[B+4>>2]=v;B=n+8|0;f[B>>2]=z;f[B+4>>2]=s;ora(a,m,n,d);u=j;return}a:do if(i|0){switch(g|0){case 1:case 4:{break a;break}default:{}}n=b;m=f[n+4>>2]|0;B=k;f[B>>2]=f[n>>2];f[B+4>>2]=m;m=t;B=f[m+4>>2]|0;n=k+8|0;f[n>>2]=f[m>>2];f[n+4>>2]=B;B=l;f[B>>2]=w;f[B+4>>2]=v;B=l+8|0;f[B>>2]=z;f[B+4>>2]=s;nra(a,k,l,d);u=j;return}while(0);l=b;k=d1c(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=k1c(k|0,J|0,16)|0;k=b;f[k>>2]=l;f[k+4>>2]=J;k=t;l=d1c(f[k>>2]|0,f[k+4>>2]|0,32768,0)|0;k=k1c(l|0,J|0,16)|0;l=t;f[l>>2]=k;f[l+4>>2]=J;l=c;k=d1c(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=k1c(k|0,J|0,16)|0;k=J;i=c;f[i>>2]=l;f[i+4>>2]=k;i=x;B=d1c(f[i>>2]|0,f[i+4>>2]|0,32768,0)|0;i=k1c(B|0,J|0,16)|0;B=J;n=x;f[n>>2]=i;f[n+4>>2]=B;n=b;m=f[n>>2]|0;y=f[n+4>>2]|0;n=d1c(m|0,y|0,-2147483648,0)|0;A=J;C=t;D=f[C>>2]|0;E=f[C+4>>2]|0;C=d1c(D|0,E|0,-2147483648,0)|0;F=J;G=d1c(l|0,k|0,-2147483648,0)|0;H=J;I=d1c(i|0,B|0,-2147483648,0)|0;K=J;mra(a,A>>>0<1|(A|0)==1&n>>>0<0?m:(y|0)>0|(y|0)==0&m>>>0>0?2147483647:-2147483648,F>>>0<1|(F|0)==1&C>>>0<0?D:(E|0)>0|(E|0)==0&D>>>0>0?2147483647:-2147483648,H>>>0<1|(H|0)==1&G>>>0<0?l:(k|0)>0|(k|0)==0&l>>>0>0?2147483647:-2147483648,K>>>0<1|(K|0)==1&I>>>0<0?i:(B|0)>0|(B|0)==0&i>>>0>0?2147483647:-2147483648,d,g);u=j;return}i=o;B=i+64|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(B|0));i=b;B=f[i>>2]|0;I=f[i+4>>2]|0;i=c1c(B|0,I|0,w|0,v|0)|0;N=(+(i>>>0)+4294967296.0*+(J|0))*.0000152587890625;i=t;K=f[i>>2]|0;l=f[i+4>>2]|0;i=c1c(z|0,s|0,K|0,l|0)|0;O=(+(i>>>0)+4294967296.0*+(J|0))*.0000152587890625;P=N*N+O*O;i=e<<15;if(+L(+P)>2.220446049250313e-16){Q=(+(i|0)+ +(e<<16&65536|0)*.5)/+M(+P);e=zLc(O*Q)|0;k=((e|0)<0)<<31>>31;G=zLc(N*Q)|0;H=((G|0)<0)<<31>>31;D=d1c(e|0,k|0,B|0,I|0)|0;E=o;f[E>>2]=D;f[E+4>>2]=J;E=d1c(K|0,l|0,G|0,H|0)|0;D=o+8|0;f[D>>2]=E;f[D+4>>2]=J;D=c1c(B|0,I|0,e|0,k|0)|0;I=o+16|0;f[I>>2]=D;f[I+4>>2]=J;I=c1c(K|0,l|0,G|0,H|0)|0;l=o+24|0;f[l>>2]=I;f[l+4>>2]=J;l=c1c(w|0,v|0,e|0,k|0)|0;I=o+32|0;f[I>>2]=l;f[I+4>>2]=J;I=c1c(z|0,s|0,G|0,H|0)|0;l=o+40|0;f[l>>2]=I;f[l+4>>2]=J;l=d1c(w|0,v|0,e|0,k|0)|0;k=o+48|0;f[k>>2]=l;f[k+4>>2]=J;k=d1c(z|0,s|0,G|0,H|0)|0;H=o+56|0;f[H>>2]=k;f[H+4>>2]=J;pra(a,o,4,d,g,16)}o=p+4|0;H=i+32768>>16;k=q+8|0;G=((i|0)<0)<<31>>31;s=r+8|0;z=(h&1|0)==0;if((g|0)<16){if(!z){l=b;e=d1c(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=l1c(e|0,J|0,16)|0;e=t;v=d1c(f[e>>2]|0,f[e+4>>2]|0,32768,0)|0;e=l1c(v|0,J|0,16)|0;f[p>>2]=l;f[o>>2]=e;qra(a,p,H,d,1)}e=c;l=f[e>>2]|0;v=f[e+4>>2]|0;e=b;f[e>>2]=l;f[e+4>>2]=v;e=x;w=f[e>>2]|0;I=f[e+4>>2]|0;e=t;f[e>>2]=w;f[e+4>>2]=I;if(h&2|0){e=d1c(l|0,v|0,32768,0)|0;v=l1c(e|0,J|0,16)|0;e=d1c(w|0,I|0,32768,0)|0;I=l1c(e|0,J|0,16)|0;f[p>>2]=v;f[o>>2]=I;qra(a,p,H,d,1)}}else{if(!z){z=b;H=f[z+4>>2]|0;p=q;f[p>>2]=f[z>>2];f[p+4>>2]=H;H=t;p=f[H+4>>2]|0;z=k;f[z>>2]=f[H>>2];f[z+4>>2]=p;p=r;f[p>>2]=i;f[p+4>>2]=G;p=s;f[p>>2]=i;f[p+4>>2]=G;rra(a,q,r,0,0,360,d,-1,g)}p=c;z=f[p>>2]|0;H=f[p+4>>2]|0;p=b;f[p>>2]=z;f[p+4>>2]=H;p=x;I=f[p>>2]|0;o=f[p+4>>2]|0;p=t;f[p>>2]=I;f[p+4>>2]=o;if(h&2|0){h=q;f[h>>2]=z;f[h+4>>2]=H;H=k;f[H>>2]=I;f[H+4>>2]=o;o=r;f[o>>2]=i;f[o+4>>2]=G;o=s;f[o>>2]=i;f[o+4>>2]=G;rra(a,q,r,0,0,360,d,-1,g)}}g=c;c=f[g+4>>2]|0;d=b;f[d>>2]=f[g>>2];f[d+4>>2]=c;c=x;x=f[c+4>>2]|0;d=t;f[d>>2]=f[c>>2];f[d+4>>2]=x;u=j;return}function mra(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+64|0;k=j+16|0;l=j+8|0;m=j;switch(i|0){case 0:{n=8;break}case 1:{n=4;break}default:n=i}f[l>>2]=c;f[l+4>>2]=d;f[m>>2]=e;f[m+4>>2]=g;era(k,a,l,m,n,1);n=f[k+20>>2]|0;m=f[a+4>>2]|0;if((m|0)>0)o=f[(f[a+44>>2]|0)+(m+-1<<2)>>2]|0;else o=0;if((n|0)<=0){u=j;return}m=k+16|0;a=k+24|0;l=k+28|0;g=k+32|0;e=k+36|0;d=h+1|0;c=h+2|0;switch(o|0){case 1:{i=0;p=f[k>>2]|0;do{b[p>>0]=b[h>>0]|0;i=i+1|0;q=f[m>>2]|0;r=q>>31;f[m>>2]=(f[a>>2]|0)+q+(f[l>>2]&r);p=(f[k>>2]|0)+((f[e>>2]&r)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}case 3:{i=0;p=f[k>>2]|0;do{b[p>>0]=b[h>>0]|0;b[p+1>>0]=b[d>>0]|0;b[p+2>>0]=b[c>>0]|0;i=i+1|0;r=f[m>>2]|0;q=r>>31;f[m>>2]=(f[a>>2]|0)+r+(f[l>>2]&q);p=(f[k>>2]|0)+((f[e>>2]&q)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}default:{i=0;p=f[k>>2]|0;do{o1c(p|0,h|0,o|0)|0;i=i+1|0;c=f[m>>2]|0;d=c>>31;f[m>>2]=(f[a>>2]|0)+c+(f[l>>2]&d);p=(f[k>>2]|0)+((f[e>>2]&d)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}}}function nra(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;g=u;u=u+16|0;h=g;i=b[e>>0]|0;j=b[e+1>>0]|0;k=b[e+2>>0]|0;l=f[a+4>>2]|0;if((l|0)>0)m=f[(f[a+44>>2]|0)+(l+-1<<2)>>2]|0;else m=0;l=f[a+16>>2]|0;n=f[a+48>>2]|0;o=f[a+40>>2]|0;a=f[o+4>>2]|0;p=f[o>>2]|0;o=u1c(a|0,((a|0)<0)<<31>>31|0,16)|0;q=J;r=u1c(p|0,((p|0)<0)<<31>>31|0,16)|0;s=h;f[s>>2]=o;f[s+4>>2]=q;q=h+8|0;f[q>>2]=r;f[q+4>>2]=J;if(!(dra(h,c,d)|0)){u=g;return}h=d;q=f[h>>2]|0;r=f[h+4>>2]|0;h=c;s=f[h>>2]|0;o=f[h+4>>2]|0;h=c1c(q|0,r|0,s|0,o|0)|0;t=J;v=d+8|0;w=v;x=f[w>>2]|0;y=f[w+4>>2]|0;w=c+8|0;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=c1c(x|0,y|0,A|0,B|0)|0;C=J;D=k1c(h|0,t|0,63)|0;E=J;F=c1c(D^h|0,E^t|0,D|0,E|0)|0;G=J;H=k1c(z|0,C|0,63)|0;I=J;K=c1c(H^z|0,I^C|0,H|0,I|0)|0;L=J;M=(G|0)>(L|0)|(G|0)==(L|0)&F>>>0>K>>>0;if(M){N=c1c(z^D|0,C^E|0,D|0,E|0)|0;C=D&q^s;z=E&r^o;O=c;f[O>>2]=C;f[O+4>>2]=z;O=d;P=f[O>>2]^C&D;C=f[O+4>>2]^z&E;z=d;f[z>>2]=P;f[z+4>>2]=C;z=c;O=f[z>>2]^P&D;P=f[z+4>>2]^C&E;C=c;f[C>>2]=O;f[C+4>>2]=P;C=D&x^A;z=E&y^B;Q=w;f[Q>>2]=C;f[Q+4>>2]=z;Q=v;R=f[Q>>2]^C&D;C=f[Q+4>>2]^z&E;z=v;f[z>>2]=R;f[z+4>>2]=C;z=w;Q=f[z>>2]^R&D;D=f[z+4>>2]^C&E;E=w;f[E>>2]=Q;f[E+4>>2]=D;E=u1c(N|0,J|0,16)|0;N=v1c(E|0,J|0,F|1|0,G|0)|0;S=d;T=O;U=P;V=O;W=P;X=Q;Z=D;_=N;$=J;aa=65536;ba=0}else{N=c1c(H^h|0,I^t|0,H|0,I|0)|0;t=H&q^s;s=I&r^o;o=c;f[o>>2]=t;f[o+4>>2]=s;o=d;r=f[o>>2]^t&H;t=f[o+4>>2]^s&I;s=d;f[s>>2]=r;f[s+4>>2]=t;s=c;o=f[s>>2]^r&H;r=f[s+4>>2]^t&I;t=c;f[t>>2]=o;f[t+4>>2]=r;t=A^x&H;x=B^y&I;y=w;f[y>>2]=t;f[y+4>>2]=x;y=v;B=f[y>>2]^t&H;t=f[y+4>>2]^x&I;x=v;f[x>>2]=B;f[x+4>>2]=t;x=w;y=f[x>>2]^B&H;H=f[x+4>>2]^t&I;I=w;f[I>>2]=y;f[I+4>>2]=H;I=u1c(N|0,J|0,16)|0;N=v1c(I|0,J|0,K|1|0,L|0)|0;S=v;T=y;U=H;V=o;W=r;X=y;Z=H;_=65536;$=0;aa=N;ba=J}N=S;S=c1c(f[N>>2]|0,f[N+4>>2]|0,T|0,U|0)|0;U=l1c(S|0,J|0,16)|0;S=d1c(V|0,W|0,32768,0)|0;W=c;f[W>>2]=S;f[W+4>>2]=J;W=d1c(X|0,Z|0,32768,0)|0;Z=w;f[Z>>2]=W;f[Z+4>>2]=J;Z=d;d=v;v=f[d>>2]|0;W=f[d+4>>2]|0;d=d1c(f[Z>>2]|0,f[Z+4>>2]|0,32768,0)|0;Z=J;X=d1c(v|0,W|0,32768,0)|0;W=l1c(X|0,J|0,16)|0;X=l1c(d|0,Z|0,16)|0;Z=(X|0)>-1;switch(m|0){case 3:{if(Z?(d=l+(Y(W,n)|0)+(X*3|0)|0,(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1)):0){b[d>>0]=i;b[d+1>>0]=j;b[d+2>>0]=k}if(M){d=c;v=k1c(f[d>>2]|0,f[d+4>>2]|0,16)|0;d=J;S=c;f[S>>2]=v;f[S+4>>2]=d;if((U|0)<=-1){u=g;return}S=w;V=U;T=f[S>>2]|0;N=f[S+4>>2]|0;S=v;v=d;while(1){d=l1c(T|0,N|0,16)|0;if((S|0)>-1?(H=l+(Y(d,n)|0)+(S*3|0)|0,(d|0)<(p|0)&((S|0)<(a|0)&(d|0)>-1)):0){b[H>>0]=i;b[H+1>>0]=j;b[H+2>>0]=k;H=c;d=w;ca=f[H>>2]|0;da=f[H+4>>2]|0;ea=f[d>>2]|0;fa=f[d+4>>2]|0}else{ca=S;da=v;ea=T;fa=N}S=d1c(ca|0,da|0,1,0)|0;v=J;d=c;f[d>>2]=S;f[d+4>>2]=v;T=d1c(ea|0,fa|0,_|0,$|0)|0;N=J;d=w;f[d>>2]=T;f[d+4>>2]=N;if((V|0)<=0)break;else V=V+-1|0}u=g;return}else{V=w;N=k1c(f[V>>2]|0,f[V+4>>2]|0,16)|0;V=J;T=w;f[T>>2]=N;f[T+4>>2]=V;if((U|0)<=-1){u=g;return}T=c;fa=U;ea=f[T>>2]|0;v=f[T+4>>2]|0;T=N;N=V;while(1){V=l1c(ea|0,v|0,16)|0;if((V|0)>-1?(S=l+(Y(T,n)|0)+(V*3|0)|0,(T|0)<(p|0)&((V|0)<(a|0)&(T|0)>-1)):0){b[S>>0]=i;b[S+1>>0]=j;b[S+2>>0]=k;S=c;V=w;ga=f[S>>2]|0;ha=f[S+4>>2]|0;ia=f[V>>2]|0;ja=f[V+4>>2]|0}else{ga=ea;ha=v;ia=T;ja=N}ea=d1c(ga|0,ha|0,aa|0,ba|0)|0;v=J;V=c;f[V>>2]=ea;f[V+4>>2]=v;T=d1c(ia|0,ja|0,1,0)|0;N=J;V=w;f[V>>2]=T;f[V+4>>2]=N;if((fa|0)<=0)break;else fa=fa+-1|0}u=g;return}break}case 1:{if(Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0){fa=l+(Y(W,n)|0)+X|0;b[fa>>0]=i}if(M){fa=c;N=k1c(f[fa>>2]|0,f[fa+4>>2]|0,16)|0;fa=J;T=c;f[T>>2]=N;f[T+4>>2]=fa;if((U|0)<=-1){u=g;return}T=w;ja=U;ia=f[T>>2]|0;v=f[T+4>>2]|0;T=N;N=fa;while(1){fa=l1c(ia|0,v|0,16)|0;if((T|0)>-1?(fa|0)<(p|0)&((T|0)<(a|0)&(fa|0)>-1):0){ea=l+(Y(fa,n)|0)+T|0;b[ea>>0]=i;ea=c;fa=w;ka=f[ea>>2]|0;la=f[ea+4>>2]|0;ma=f[fa>>2]|0;na=f[fa+4>>2]|0}else{ka=T;la=N;ma=ia;na=v}T=d1c(ka|0,la|0,1,0)|0;N=J;fa=c;f[fa>>2]=T;f[fa+4>>2]=N;ia=d1c(ma|0,na|0,_|0,$|0)|0;v=J;fa=w;f[fa>>2]=ia;f[fa+4>>2]=v;if((ja|0)<=0)break;else ja=ja+-1|0}u=g;return}else{ja=w;v=k1c(f[ja>>2]|0,f[ja+4>>2]|0,16)|0;ja=J;ia=w;f[ia>>2]=v;f[ia+4>>2]=ja;if((U|0)<=-1){u=g;return}ia=c;na=U;ma=f[ia>>2]|0;N=f[ia+4>>2]|0;ia=v;v=ja;while(1){ja=l1c(ma|0,N|0,16)|0;if((ja|0)>-1?(ia|0)<(p|0)&((ja|0)<(a|0)&(ia|0)>-1):0){T=l+(Y(ia,n)|0)+ja|0;b[T>>0]=i;T=c;ja=w;oa=f[T>>2]|0;pa=f[T+4>>2]|0;qa=f[ja>>2]|0;ra=f[ja+4>>2]|0}else{oa=ma;pa=N;qa=ia;ra=v}ma=d1c(oa|0,pa|0,aa|0,ba|0)|0;N=J;ja=c;f[ja>>2]=ma;f[ja+4>>2]=N;ia=d1c(qa|0,ra|0,1,0)|0;v=J;ja=w;f[ja>>2]=ia;f[ja+4>>2]=v;if((na|0)<=0)break;else na=na+-1|0}u=g;return}break}default:{if((Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0)?(Z=l+(Y(W,n)|0)+(Y(X,m)|0)|0,X=((m|0)<0)<<31>>31,(m|0)>0):0){W=0;na=0;do{b[Z+W>>0]=b[e+W>>0]|0;W=d1c(W|0,na|0,1,0)|0;na=J}while((na|0)<(X|0)|(na|0)==(X|0)&W>>>0<m>>>0)}if(M){M=c;W=k1c(f[M>>2]|0,f[M+4>>2]|0,16)|0;M=J;X=c;f[X>>2]=W;f[X+4>>2]=M;if((U|0)<=-1){u=g;return}X=((m|0)<0)<<31>>31;na=w;Z=f[na>>2]|0;v=f[na+4>>2]|0;if((m|0)>0){sa=U;ta=Z;ua=v;va=W;wa=M}else{na=U;ia=W;W=M;M=Z;Z=v;while(1){ia=d1c(ia|0,W|0,1,0)|0;W=J;M=d1c(M|0,Z|0,_|0,$|0)|0;Z=J;if((na|0)<=0)break;else na=na+-1|0}na=c;f[na>>2]=ia;f[na+4>>2]=W;W=w;f[W>>2]=M;f[W+4>>2]=Z;u=g;return}while(1){Z=l1c(ta|0,ua|0,16)|0;if((va|0)>-1?(Z|0)<(p|0)&((va|0)<(a|0)&(Z|0)>-1):0){W=l+(Y(Z,n)|0)+(Y(va,m)|0)|0;Z=0;M=0;do{b[W+Z>>0]=b[e+Z>>0]|0;Z=d1c(Z|0,M|0,1,0)|0;M=J}while((M|0)<(X|0)|(M|0)==(X|0)&Z>>>0<m>>>0);Z=c;M=w;xa=f[Z>>2]|0;ya=f[Z+4>>2]|0;za=f[M>>2]|0;Aa=f[M+4>>2]|0}else{xa=va;ya=wa;za=ta;Aa=ua}va=d1c(xa|0,ya|0,1,0)|0;wa=J;M=c;f[M>>2]=va;f[M+4>>2]=wa;ta=d1c(za|0,Aa|0,_|0,$|0)|0;ua=J;M=w;f[M>>2]=ta;f[M+4>>2]=ua;if((sa|0)<=0)break;else sa=sa+-1|0}u=g;return}else{sa=w;ua=k1c(f[sa>>2]|0,f[sa+4>>2]|0,16)|0;sa=J;ta=w;f[ta>>2]=ua;f[ta+4>>2]=sa;if((U|0)<=-1){u=g;return}ta=((m|0)<0)<<31>>31;$=c;_=f[$>>2]|0;Aa=f[$+4>>2]|0;if((m|0)>0){Ba=U;Ca=_;Da=Aa;Ea=ua;Fa=sa}else{$=U;U=_;_=Aa;Aa=ua;ua=sa;while(1){U=d1c(U|0,_|0,aa|0,ba|0)|0;_=J;Aa=d1c(Aa|0,ua|0,1,0)|0;ua=J;if(($|0)<=0)break;else $=$+-1|0}$=c;f[$>>2]=U;f[$+4>>2]=_;_=w;f[_>>2]=Aa;f[_+4>>2]=ua;u=g;return}while(1){ua=l1c(Ca|0,Da|0,16)|0;if((ua|0)>-1?(Ea|0)<(p|0)&((ua|0)<(a|0)&(Ea|0)>-1):0){_=l+(Y(Ea,n)|0)+(Y(ua,m)|0)|0;ua=0;Aa=0;do{b[_+ua>>0]=b[e+ua>>0]|0;ua=d1c(ua|0,Aa|0,1,0)|0;Aa=J}while((Aa|0)<(ta|0)|(Aa|0)==(ta|0)&ua>>>0<m>>>0);ua=c;Aa=w;Ga=f[ua>>2]|0;Ha=f[ua+4>>2]|0;Ia=f[Aa>>2]|0;Ja=f[Aa+4>>2]|0}else{Ga=Ca;Ha=Da;Ia=Ea;Ja=Fa}Ca=d1c(Ga|0,Ha|0,aa|0,ba|0)|0;Da=J;Aa=c;f[Aa>>2]=Ca;f[Aa+4>>2]=Da;Ea=d1c(Ia|0,Ja|0,1,0)|0;Fa=J;Aa=w;f[Aa>>2]=Ea;f[Aa+4>>2]=Fa;if((Ba|0)<=0)break;else Ba=Ba+-1|0}u=g;return}}}}function ora(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+64|0;i=g+16|0;j=g;k=h[e>>0]|0;l=h[e+1>>0]|0;m=h[e+2>>0]|0;n=h[e+3>>0]|0;o=f[a>>2]|0;p=o>>>3;q=f[a+16>>2]|0;r=f[a+48>>2]|0;s=f[a+40>>2]|0;t=f[s+4>>2]|0;v=f[s>>2]|0;s=p&65535;switch(s&511){case 0:case 2:case 3:{if(!(o&7)){o=c;w=d1c(f[o>>2]|0,f[o+4>>2]|0,-131072,-1)|0;o=c;f[o>>2]=w;f[o+4>>2]=J;o=c+8|0;w=o;x=d1c(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=o;f[w>>2]=x;f[w+4>>2]=J;w=d;x=d1c(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=d;f[w>>2]=x;f[w+4>>2]=J;w=d+8|0;x=w;y=d1c(f[x>>2]|0,f[x+4>>2]|0,-131072,-1)|0;x=w;f[x>>2]=y;f[x+4>>2]=J;x=q+((p&511)+1+r<<1)|0;p=u1c(t|0,((t|0)<0)<<31>>31|0,16)|0;t=d1c(p|0,J|0,-327679,-1)|0;p=J;q=u1c(v|0,((v|0)<0)<<31>>31|0,16)|0;v=d1c(q|0,J|0,-327679,-1)|0;q=j;f[q>>2]=t;f[q+4>>2]=p;p=j+8|0;f[p>>2]=v;f[p+4>>2]=J;if(!(dra(j,c,d)|0)){u=g;return}j=d;p=f[j>>2]|0;v=f[j+4>>2]|0;j=c;q=f[j>>2]|0;t=f[j+4>>2]|0;j=c1c(p|0,v|0,q|0,t|0)|0;y=J;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=o;C=f[z>>2]|0;D=f[z+4>>2]|0;z=c1c(A|0,B|0,C|0,D|0)|0;E=J;F=k1c(j|0,y|0,63)|0;G=J;H=c1c(F^j|0,G^y|0,F|0,G|0)|0;I=J;K=k1c(z|0,E|0,63)|0;L=J;M=c1c(K^z|0,L^E|0,K|0,L|0)|0;N=J;O=(I|0)>(N|0)|(I|0)==(N|0)&H>>>0>M>>>0;if(O){P=c1c(z^F|0,E^G|0,F|0,G|0)|0;E=F&p^q;z=G&v^t;Q=c;f[Q>>2]=E;f[Q+4>>2]=z;Q=d;R=f[Q>>2]^E&F;E=f[Q+4>>2]^z&G;z=d;f[z>>2]=R;f[z+4>>2]=E;z=c;Q=f[z+4>>2]^E&G;E=c;f[E>>2]=f[z>>2]^R&F;f[E+4>>2]=Q;Q=F&A^C;E=G&B^D;R=o;f[R>>2]=Q;f[R+4>>2]=E;R=w;z=f[R>>2]^Q&F;Q=f[R+4>>2]^E&G;E=w;f[E>>2]=z;f[E+4>>2]=Q;E=o;R=f[E>>2]^z&F;F=f[E+4>>2]^Q&G;G=u1c(P|0,J|0,16)|0;P=v1c(G|0,J|0,H|1|0,I|0)|0;I=J;H=d;G=d1c(f[H>>2]|0,f[H+4>>2]|0,65536,0)|0;H=J;Q=d;f[Q>>2]=G;f[Q+4>>2]=H;Q=l1c(G|0,H|0,16)|0;E=J;z=c;S=f[z>>2]|0;T=f[z+4>>2]|0;z=l1c(S|0,T|0,16)|0;U=c1c(Q|0,E|0,z|0,J|0)|0;z=c1c(0,0,P|0,I|0)|0;E=x1c(S&65535|0,0,z|0,J|0)|0;z=k1c(E|0,J|0,16)|0;E=J;Q=d1c(R|0,F|0,32768,0)|0;F=d1c(Q|0,J|0,z|0,E|0)|0;E=J;z=o;f[z>>2]=F;f[z+4>>2]=E;z=l1c(P|0,I|0,11)|0;Q=k1c(S|0,T|0,9)|0;R=J;V=k1c(G|0,H|0,9)|0;W=U;X=z&63^((I|0)<0?63:0);Z=J;_=R;$=Q;aa=V;ba=S;ca=T;da=P;ea=I;fa=F;ga=E;ha=65536;ia=0}else{E=c1c(K^j|0,L^y|0,K|0,L|0)|0;y=K&p^q;q=L&v^t;t=c;f[t>>2]=y;f[t+4>>2]=q;t=d;v=f[t>>2]^y&K;y=f[t+4>>2]^q&L;q=d;f[q>>2]=v;f[q+4>>2]=y;q=c;t=f[q>>2]^v&K;v=f[q+4>>2]^y&L;y=C^A&K;A=D^B&L;B=o;f[B>>2]=y;f[B+4>>2]=A;B=w;D=f[B>>2]^y&K;y=f[B+4>>2]^A&L;A=w;f[A>>2]=D;f[A+4>>2]=y;A=o;B=f[A+4>>2]^y&L;L=o;f[L>>2]=f[A>>2]^D&K;f[L+4>>2]=B;B=u1c(E|0,J|0,16)|0;E=v1c(B|0,J|0,M|1|0,N|0)|0;N=J;M=w;B=d1c(f[M>>2]|0,f[M+4>>2]|0,65536,0)|0;M=J;L=w;f[L>>2]=B;f[L+4>>2]=M;L=l1c(B|0,M|0,16)|0;w=J;K=o;D=f[K>>2]|0;A=f[K+4>>2]|0;K=l1c(D|0,A|0,16)|0;y=c1c(L|0,w|0,K|0,J|0)|0;K=c1c(0,0,E|0,N|0)|0;w=x1c(D&65535|0,0,K|0,J|0)|0;K=k1c(w|0,J|0,16)|0;w=J;L=d1c(t|0,v|0,32768,0)|0;v=d1c(L|0,J|0,K|0,w|0)|0;w=J;K=c;f[K>>2]=v;f[K+4>>2]=w;K=l1c(E|0,N|0,11)|0;L=l1c(D|0,A|0,9)|0;t=J;C=l1c(B|0,M|0,9)|0;W=y;X=K&63^((N|0)<0?63:0);Z=J;_=t;$=L;aa=C;ba=v;ca=w;da=65536;ea=0;fa=D;ga=A;ha=E;ia=N}N=$&120;$=aa&120;if(!(X&32))ja=h[273420+X>>0]|0;else ja=256;X=ja<<7;aa=Y(ja,120-N|4)|0;E=Y(ja,$|4)|0;f[i>>2]=0;f[i+32>>2]=ja;A=c1c($|0,0,N|0,0)|0;N=J;$=x1c(ja|0,0,A&120|4|0,0)|0;D=l1c($|0,J|0,8)|0;f[i+12>>2]=D;f[i+4>>2]=D;f[i+8>>2]=aa>>>8&511;D=d1c(A|0,N|0,128,0)|0;N=x1c(ja|0,0,D|4|0,J|0)|0;D=l1c(N|0,J|0,8)|0;f[i+16>>2]=D&511;f[i+20>>2]=(aa+X|0)>>>8&511;f[i+24>>2]=E>>>8;f[i+28>>2]=(E+X|0)>>>8&511;switch(s&511){case 2:{s=(W|0)>-1;if(O){if(!s){u=g;return}X=k1c(ba|0,ca|0,16)|0;E=x1c(X|0,J|0,3,0)|0;X=0;aa=x+E|0;E=W;D=fa;N=ga;while(1){ja=k1c(D|0,N|0,16)|0;A=d1c(ja|0,J|0,-1,-1)|0;ja=x1c(A|0,J|0,r|0,0)|0;A=aa+ja|0;ja=f[i+(((((X|0)>1?2:1)&(X|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;$=l1c(D|0,N|0,11)|0;w=$&31;$=(Y(f[55420+((w|32)<<2)>>2]|0,ja)|0)>>>8&255;v=h[A>>0]|0;C=(((Y(k-v|0,$)|0)+127|0)>>>8)+v|0;v=A+1|0;L=h[v>>0]|0;t=(((Y(l-L|0,$)|0)+127|0)>>>8)+L|0;L=A+2|0;_=h[L>>0]|0;Z=(((Y(m-_|0,$)|0)+127|0)>>>8)+_|0;_=(((Y(l-(t&255)|0,$)|0)+127|0)>>>8)+t|0;t=(((Y(m-(Z&255)|0,$)|0)+127|0)>>>8)+Z|0;Z=(((Y(k-(C&255)|0,$)|0)+127|0)>>>8)+C&255;b[A>>0]=Z;b[v>>0]=_;b[L>>0]=t;t=A+r|0;A=(Y(f[55420+(w<<2)>>2]|0,ja)|0)>>>8&255;L=h[t>>0]|0;_=(((Y(k-L|0,A)|0)+127|0)>>>8)+L|0;L=t+1|0;v=h[L>>0]|0;Z=(((Y(l-v|0,A)|0)+127|0)>>>8)+v|0;v=t+2|0;C=h[v>>0]|0;$=(((Y(m-C|0,A)|0)+127|0)>>>8)+C|0;C=(((Y(l-(Z&255)|0,A)|0)+127|0)>>>8)+Z|0;Z=(((Y(m-($&255)|0,A)|0)+127|0)>>>8)+$|0;$=(((Y(k-(_&255)|0,A)|0)+127|0)>>>8)+_&255;b[t>>0]=$;b[L>>0]=C;b[v>>0]=Z;Z=t+r|0;t=(Y(f[55420+((w^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[Z>>0]|0;w=(((Y(k-ja|0,t)|0)+127|0)>>>8)+ja|0;ja=Z+1|0;v=h[ja>>0]|0;C=(((Y(l-v|0,t)|0)+127|0)>>>8)+v|0;v=Z+2|0;L=h[v>>0]|0;$=(((Y(m-L|0,t)|0)+127|0)>>>8)+L|0;L=(((Y(l-(C&255)|0,t)|0)+127|0)>>>8)+C|0;C=(((Y(m-($&255)|0,t)|0)+127|0)>>>8)+$|0;$=(((Y(k-(w&255)|0,t)|0)+127|0)>>>8)+w&255;b[Z>>0]=$;b[ja>>0]=L;b[v>>0]=C;C=o;D=d1c(f[C>>2]|0,f[C+4>>2]|0,da|0,ea|0)|0;N=J;C=o;f[C>>2]=D;f[C+4>>2]=N;if((E|0)<=0)break;else{X=X+1|0;aa=aa+3|0;E=E+-1|0}}u=g;return}else{if(!s){u=g;return}s=k1c(fa|0,ga|0,16)|0;E=x1c(s|0,J|0,r|0,0)|0;s=0;aa=x+E|0;E=W;X=ba;N=ca;while(1){D=k1c(X|0,N|0,16)|0;C=x1c(D|0,J|0,3,0)|0;D=d1c(C|0,J|0,-3,0)|0;C=aa+D|0;D=f[i+(((((s|0)>1?2:1)&(s|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;v=l1c(X|0,N|0,11)|0;L=v&31;v=(Y(f[55420+((L|32)<<2)>>2]|0,D)|0)>>>8&255;ja=h[C>>0]|0;$=(((Y(k-ja|0,v)|0)+127|0)>>>8)+ja|0;ja=C+1|0;Z=h[ja>>0]|0;w=(((Y(l-Z|0,v)|0)+127|0)>>>8)+Z|0;Z=C+2|0;t=h[Z>>0]|0;_=(((Y(m-t|0,v)|0)+127|0)>>>8)+t|0;t=(((Y(l-(w&255)|0,v)|0)+127|0)>>>8)+w|0;w=(((Y(m-(_&255)|0,v)|0)+127|0)>>>8)+_|0;_=(((Y(k-($&255)|0,v)|0)+127|0)>>>8)+$&255;b[C>>0]=_;b[ja>>0]=t;b[Z>>0]=w;w=C+3|0;C=(Y(f[55420+(L<<2)>>2]|0,D)|0)>>>8&255;Z=h[w>>0]|0;t=(((Y(k-Z|0,C)|0)+127|0)>>>8)+Z|0;Z=w+1|0;ja=h[Z>>0]|0;_=(((Y(l-ja|0,C)|0)+127|0)>>>8)+ja|0;ja=w+2|0;$=h[ja>>0]|0;v=(((Y(m-$|0,C)|0)+127|0)>>>8)+$|0;$=(((Y(l-(_&255)|0,C)|0)+127|0)>>>8)+_|0;_=(((Y(m-(v&255)|0,C)|0)+127|0)>>>8)+v|0;v=(((Y(k-(t&255)|0,C)|0)+127|0)>>>8)+t&255;b[w>>0]=v;b[Z>>0]=$;b[ja>>0]=_;_=w+3|0;w=(Y(f[55420+((L^63)<<2)>>2]|0,D)|0)>>>8&255;D=h[_>>0]|0;L=(((Y(k-D|0,w)|0)+127|0)>>>8)+D|0;D=_+1|0;ja=h[D>>0]|0;$=(((Y(l-ja|0,w)|0)+127|0)>>>8)+ja|0;ja=_+2|0;Z=h[ja>>0]|0;v=(((Y(m-Z|0,w)|0)+127|0)>>>8)+Z|0;Z=(((Y(l-($&255)|0,w)|0)+127|0)>>>8)+$|0;$=(((Y(m-(v&255)|0,w)|0)+127|0)>>>8)+v|0;v=(((Y(k-(L&255)|0,w)|0)+127|0)>>>8)+L&255;b[_>>0]=v;b[D>>0]=Z;b[ja>>0]=$;$=c;X=d1c(f[$>>2]|0,f[$+4>>2]|0,ha|0,ia|0)|0;N=J;$=c;f[$>>2]=X;f[$+4>>2]=N;if((E|0)<=0)break;else{s=s+1|0;aa=aa+r|0;E=E+-1|0}}u=g;return}break}case 0:{E=(W|0)>-1;if(O){if(!E){u=g;return}aa=l1c(ba|0,ca|0,16)|0;s=0;N=x+aa|0;aa=W;X=fa;$=ga;while(1){ja=k1c(X|0,$|0,16)|0;Z=d1c(ja|0,J|0,-1,-1)|0;ja=x1c(Z|0,J|0,r|0,0)|0;Z=N+ja|0;ja=f[i+(((((s|0)>1?2:1)&(s|2))*3|0)+(((aa|0)>1?2:1)&(aa|2))<<2)>>2]|0;D=l1c(X|0,$|0,11)|0;v=D&31;D=(Y(f[55420+((v|32)<<2)>>2]|0,ja)|0)>>>8&255;_=h[Z>>0]|0;L=(((Y(k-_|0,D)|0)+127|0)>>>8)+_|0;_=(((Y(k-(L&255)|0,D)|0)+127|0)>>>8)+L&255;b[Z>>0]=_;_=Z+r|0;Z=(Y(f[55420+(v<<2)>>2]|0,ja)|0)>>>8&255;L=h[_>>0]|0;D=(((Y(k-L|0,Z)|0)+127|0)>>>8)+L|0;L=(((Y(k-(D&255)|0,Z)|0)+127|0)>>>8)+D&255;b[_>>0]=L;L=_+r|0;_=(Y(f[55420+((v^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[L>>0]|0;v=(((Y(k-ja|0,_)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(v&255)|0,_)|0)+127|0)>>>8)+v&255;b[L>>0]=ja;ja=o;X=d1c(f[ja>>2]|0,f[ja+4>>2]|0,da|0,ea|0)|0;$=J;ja=o;f[ja>>2]=X;f[ja+4>>2]=$;if((aa|0)<=0)break;else{s=s+1|0;N=N+1|0;aa=aa+-1|0}}u=g;return}else{if(!E){u=g;return}E=k1c(fa|0,ga|0,16)|0;aa=x1c(E|0,J|0,r|0,0)|0;E=0;N=x+aa|0;aa=W;s=ba;$=ca;while(1){X=l1c(s|0,$|0,16)|0;ja=d1c(X|0,J|0,-1,0)|0;X=N+ja|0;ja=f[i+(((((E|0)>1?2:1)&(E|2))*3|0)+(((aa|0)>1?2:1)&(aa|2))<<2)>>2]|0;L=l1c(s|0,$|0,11)|0;v=L&31;L=(Y(f[55420+((v|32)<<2)>>2]|0,ja)|0)>>>8&255;_=h[X>>0]|0;D=(((Y(k-_|0,L)|0)+127|0)>>>8)+_|0;_=(((Y(k-(D&255)|0,L)|0)+127|0)>>>8)+D&255;b[X>>0]=_;_=X+1|0;X=(Y(f[55420+(v<<2)>>2]|0,ja)|0)>>>8&255;D=h[_>>0]|0;L=(((Y(k-D|0,X)|0)+127|0)>>>8)+D|0;D=(((Y(k-(L&255)|0,X)|0)+127|0)>>>8)+L&255;b[_>>0]=D;D=_+1|0;_=(Y(f[55420+((v^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[D>>0]|0;v=(((Y(k-ja|0,_)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(v&255)|0,_)|0)+127|0)>>>8)+v&255;b[D>>0]=ja;ja=c;s=d1c(f[ja>>2]|0,f[ja+4>>2]|0,ha|0,ia|0)|0;$=J;ja=c;f[ja>>2]=s;f[ja+4>>2]=$;if((aa|0)<=0)break;else{E=E+1|0;N=N+r|0;aa=aa+-1|0}}u=g;return}break}default:{aa=(W|0)>-1;if(O){if(!aa){u=g;return}O=k1c(ba|0,ca|0,16)|0;N=u1c(O|0,J|0,2)|0;O=x+N|0;N=0;E=W;$=fa;s=ga;while(1){ja=k1c($|0,s|0,16)|0;D=d1c(ja|0,J|0,-1,-1)|0;ja=x1c(D|0,J|0,r|0,0)|0;D=O+ja|0;ja=f[i+(((((N|0)>1?2:1)&(N|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;v=l1c($|0,s|0,11)|0;_=v&31;v=(Y(f[55420+((_|32)<<2)>>2]|0,ja)|0)>>>8&255;L=h[D>>0]|0;X=(((Y(k-L|0,v)|0)+127|0)>>>8)+L|0;L=D+1|0;Z=h[L>>0]|0;w=(((Y(l-Z|0,v)|0)+127|0)>>>8)+Z|0;Z=D+2|0;t=h[Z>>0]|0;C=(((Y(m-t|0,v)|0)+127|0)>>>8)+t|0;t=D+3|0;A=h[t>>0]|0;K=(((Y(n-A|0,v)|0)+127|0)>>>8)+A|0;A=(((Y(l-(w&255)|0,v)|0)+127|0)>>>8)+w|0;w=(((Y(m-(C&255)|0,v)|0)+127|0)>>>8)+C|0;C=(((Y(n-(K&255)|0,v)|0)+127|0)>>>8)+K|0;K=(((Y(k-(X&255)|0,v)|0)+127|0)>>>8)+X&255;b[D>>0]=K;b[L>>0]=A;b[Z>>0]=w;b[t>>0]=C;C=D+r|0;D=(Y(f[55420+(_<<2)>>2]|0,ja)|0)>>>8&255;t=h[C>>0]|0;w=(((Y(k-t|0,D)|0)+127|0)>>>8)+t|0;t=C+1|0;Z=h[t>>0]|0;A=(((Y(l-Z|0,D)|0)+127|0)>>>8)+Z|0;Z=C+2|0;L=h[Z>>0]|0;K=(((Y(m-L|0,D)|0)+127|0)>>>8)+L|0;L=C+3|0;X=h[L>>0]|0;v=(((Y(n-X|0,D)|0)+127|0)>>>8)+X|0;X=(((Y(l-(A&255)|0,D)|0)+127|0)>>>8)+A|0;A=(((Y(m-(K&255)|0,D)|0)+127|0)>>>8)+K|0;K=(((Y(n-(v&255)|0,D)|0)+127|0)>>>8)+v|0;v=(((Y(k-(w&255)|0,D)|0)+127|0)>>>8)+w&255;b[C>>0]=v;b[t>>0]=X;b[Z>>0]=A;b[L>>0]=K;K=C+r|0;C=(Y(f[55420+((_^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[K>>0]|0;_=(((Y(k-ja|0,C)|0)+127|0)>>>8)+ja|0;ja=K+1|0;L=h[ja>>0]|0;A=(((Y(l-L|0,C)|0)+127|0)>>>8)+L|0;L=K+2|0;Z=h[L>>0]|0;X=(((Y(m-Z|0,C)|0)+127|0)>>>8)+Z|0;Z=K+3|0;t=h[Z>>0]|0;v=(((Y(n-t|0,C)|0)+127|0)>>>8)+t|0;t=(((Y(l-(A&255)|0,C)|0)+127|0)>>>8)+A|0;A=(((Y(m-(X&255)|0,C)|0)+127|0)>>>8)+X|0;X=(((Y(n-(v&255)|0,C)|0)+127|0)>>>8)+v|0;v=(((Y(k-(_&255)|0,C)|0)+127|0)>>>8)+_&255;b[K>>0]=v;b[ja>>0]=t;b[L>>0]=A;b[Z>>0]=X;X=o;$=d1c(f[X>>2]|0,f[X+4>>2]|0,da|0,ea|0)|0;s=J;X=o;f[X>>2]=$;f[X+4>>2]=s;if((E|0)<=0)break;else{O=O+4|0;N=N+1|0;E=E+-1|0}}u=g;return}else{if(!aa){u=g;return}aa=k1c(fa|0,ga|0,16)|0;ga=x1c(aa|0,J|0,r|0,0)|0;aa=x+ga|0;ga=0;x=W;W=ba;ba=ca;while(1){ca=k1c(W|0,ba|0,16)|0;fa=u1c(ca|0,J|0,2)|0;ca=d1c(fa|0,J|0,-4,0)|0;fa=aa+ca|0;ca=f[i+(((((ga|0)>1?2:1)&(ga|2))*3|0)+(((x|0)>1?2:1)&(x|2))<<2)>>2]|0;E=l1c(W|0,ba|0,11)|0;N=E&31;E=(Y(f[55420+((N|32)<<2)>>2]|0,ca)|0)>>>8&255;O=h[fa>>0]|0;s=(((Y(k-O|0,E)|0)+127|0)>>>8)+O|0;O=fa+1|0;$=h[O>>0]|0;o=(((Y(l-$|0,E)|0)+127|0)>>>8)+$|0;$=fa+2|0;ea=h[$>>0]|0;da=(((Y(m-ea|0,E)|0)+127|0)>>>8)+ea|0;ea=fa+3|0;X=h[ea>>0]|0;Z=(((Y(n-X|0,E)|0)+127|0)>>>8)+X|0;X=(((Y(l-(o&255)|0,E)|0)+127|0)>>>8)+o|0;o=(((Y(m-(da&255)|0,E)|0)+127|0)>>>8)+da|0;da=(((Y(n-(Z&255)|0,E)|0)+127|0)>>>8)+Z|0;Z=(((Y(k-(s&255)|0,E)|0)+127|0)>>>8)+s&255;b[fa>>0]=Z;b[O>>0]=X;b[$>>0]=o;b[ea>>0]=da;da=fa+4|0;fa=(Y(f[55420+(N<<2)>>2]|0,ca)|0)>>>8&255;ea=h[da>>0]|0;o=(((Y(k-ea|0,fa)|0)+127|0)>>>8)+ea|0;ea=da+1|0;$=h[ea>>0]|0;X=(((Y(l-$|0,fa)|0)+127|0)>>>8)+$|0;$=da+2|0;O=h[$>>0]|0;Z=(((Y(m-O|0,fa)|0)+127|0)>>>8)+O|0;O=da+3|0;s=h[O>>0]|0;E=(((Y(n-s|0,fa)|0)+127|0)>>>8)+s|0;s=(((Y(l-(X&255)|0,fa)|0)+127|0)>>>8)+X|0;X=(((Y(m-(Z&255)|0,fa)|0)+127|0)>>>8)+Z|0;Z=(((Y(n-(E&255)|0,fa)|0)+127|0)>>>8)+E|0;E=(((Y(k-(o&255)|0,fa)|0)+127|0)>>>8)+o&255;b[da>>0]=E;b[ea>>0]=s;b[$>>0]=X;b[O>>0]=Z;Z=da+4|0;da=(Y(f[55420+((N^63)<<2)>>2]|0,ca)|0)>>>8&255;ca=h[Z>>0]|0;N=(((Y(k-ca|0,da)|0)+127|0)>>>8)+ca|0;ca=Z+1|0;O=h[ca>>0]|0;X=(((Y(l-O|0,da)|0)+127|0)>>>8)+O|0;O=Z+2|0;$=h[O>>0]|0;s=(((Y(m-$|0,da)|0)+127|0)>>>8)+$|0;$=Z+3|0;ea=h[$>>0]|0;E=(((Y(n-ea|0,da)|0)+127|0)>>>8)+ea|0;ea=(((Y(l-(X&255)|0,da)|0)+127|0)>>>8)+X|0;X=(((Y(m-(s&255)|0,da)|0)+127|0)>>>8)+s|0;s=(((Y(n-(E&255)|0,da)|0)+127|0)>>>8)+E|0;E=(((Y(k-(N&255)|0,da)|0)+127|0)>>>8)+N&255;b[Z>>0]=E;b[ca>>0]=ea;b[O>>0]=X;b[$>>0]=s;s=c;W=d1c(f[s>>2]|0,f[s+4>>2]|0,ha|0,ia|0)|0;ba=J;s=c;f[s>>2]=W;f[s+4>>2]=ba;if((x|0)<=0)break;else{aa=aa+r|0;ga=ga+1|0;x=x+-1|0}}u=g;return}}}}break}default:{}}x=c;ga=l1c(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=c+8|0;c=l1c(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=d;r=l1c(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=d+8|0;d=l1c(f[x>>2]|0,f[x+4>>2]|0,16)|0;mra(a,ga,c,r,d,e,8);u=g;return}function pra(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;i=u;u=u+128|0;j=i+64|0;k=i+48|0;l=i+32|0;m=i+16|0;n=i;o=1<<h>>1;p=f[a+16>>2]|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[a+4>>2]|0;if((q|0)>0)t=f[(f[a+44>>2]|0)+(q+-1<<2)>>2]|0;else t=0;q=(g|0)<16;v=q?32768:65535;w=q?0:0;x=q?32768:0;y=q?0:0;z=d+-1|0;A=c+(z<<4)|0;B=c+(z<<4)+8|0;C=f[B>>2]|0;D=f[B+4>>2]|0;B=16-h|0;E=u1c(f[A>>2]|0,f[A+4>>2]|0,B|0)|0;A=J;F=u1c(C|0,D|0,B|0)|0;D=J;C=c;G=f[C>>2]|0;H=f[C+4>>2]|0;C=c+8|0;I=f[C>>2]|0;K=f[C+4>>2]|0;a:do if((d|0)>0){C=(h|0)==0;L=k+8|0;M=l+8|0;N=m+8|0;O=n+8|0;if((g|0)<9){P=0;Q=0;R=H;S=G;T=E;U=A;V=F;W=D;X=K;Z=K;_=I;$=I;aa=K;ba=I;ca=H;da=H;ea=G;fa=G}else{ga=0;ha=0;ia=K;ja=K;ka=I;la=I;ma=K;na=I;oa=H;pa=H;qa=G;ra=G;sa=H;ta=G;ua=E;va=A;wa=F;xa=D;while(1){ya=(ia|0)<(ja|0)|(ia|0)==(ja|0)&ka>>>0<la>>>0;za=ya?ga:ha;Aa=ya?ka:la;Ba=ya?ia:ja;ya=(ma|0)<(ia|0)|(ma|0)==(ia|0)&na>>>0<ka>>>0;Ca=ya?ka:na;Da=ya?ia:ma;ya=(oa|0)<(pa|0)|(oa|0)==(pa|0)&qa>>>0<ra>>>0;Ea=ya?ra:qa;Fa=ya?pa:oa;ya=(sa|0)>(pa|0)|(sa|0)==(pa|0)&ta>>>0>ra>>>0;Ga=ya?ra:ta;Ha=ya?pa:sa;ya=u1c(ra|0,pa|0,B|0)|0;Ia=J;Ja=u1c(ka|0,ia|0,B|0)|0;Ka=J;La=m;f[La>>2]=ua;f[La+4>>2]=va;La=N;f[La>>2]=wa;f[La+4>>2]=xa;La=n;f[La>>2]=ya;f[La+4>>2]=Ia;La=O;f[La>>2]=Ja;f[La+4>>2]=Ka;ora(a,m,n,e);La=ga+1|0;if((La|0)==(d|0)){Ma=za;Na=Aa;Oa=Ba;Pa=Ca;Qa=Da;Ra=Ea;Sa=Fa;Ta=Ga;Ua=Ha;break a}Va=c+(La<<4)|0;Wa=c+(La<<4)+8|0;ga=La;ha=za;ia=f[Wa+4>>2]|0;ja=Ba;ka=f[Wa>>2]|0;la=Aa;ma=Da;na=Ca;oa=Fa;pa=f[Va+4>>2]|0;qa=Ea;ra=f[Va>>2]|0;sa=Ha;ta=Ga;ua=ya;va=Ia;wa=Ja;xa=Ka}}while(1){xa=(X|0)<(Z|0)|(X|0)==(Z|0)&_>>>0<$>>>0;wa=xa?P:Q;va=xa?_:$;ua=xa?X:Z;xa=(aa|0)<(X|0)|(aa|0)==(X|0)&ba>>>0<_>>>0;ta=xa?_:ba;sa=xa?X:aa;xa=(ca|0)<(da|0)|(ca|0)==(da|0)&ea>>>0<fa>>>0;ra=xa?fa:ea;qa=xa?da:ca;xa=(R|0)>(da|0)|(R|0)==(da|0)&S>>>0>fa>>>0;pa=xa?fa:S;oa=xa?da:R;xa=u1c(fa|0,da|0,B|0)|0;na=J;ma=u1c(_|0,X|0,B|0)|0;la=J;if(C){ka=l1c(T|0,U|0,16)|0;ja=l1c(V|0,W|0,16)|0;ia=l1c(xa|0,na|0,16)|0;ha=l1c(ma|0,la|0,16)|0;mra(a,ka,ja,ia,ha,e,g)}else{ha=k;f[ha>>2]=T;f[ha+4>>2]=U;ha=L;f[ha>>2]=V;f[ha+4>>2]=W;ha=l;f[ha>>2]=xa;f[ha+4>>2]=na;ha=M;f[ha>>2]=ma;f[ha+4>>2]=la;nra(a,k,l,e)}ha=P+1|0;if((ha|0)==(d|0)){Ma=wa;Na=va;Oa=ua;Pa=ta;Qa=sa;Ra=ra;Sa=qa;Ta=pa;Ua=oa;break a}ia=c+(ha<<4)|0;ja=c+(ha<<4)+8|0;P=ha;Q=wa;R=oa;S=pa;T=xa;U=na;V=ma;W=la;X=f[ja+4>>2]|0;Z=ua;_=f[ja>>2]|0;$=va;aa=sa;ba=ta;ca=qa;da=f[ia+4>>2]|0;ea=ra;fa=f[ia>>2]|0}}else{Ma=0;Na=I;Oa=K;Pa=I;Qa=K;Ra=G;Sa=H;Ta=G;Ua=H}while(0);H=((o|0)<0)<<31>>31;G=d1c(Na|0,Oa|0,o|0,H|0)|0;Oa=k1c(G|0,J|0,h|0)|0;G=d1c(Pa|0,Qa|0,o|0,H|0)|0;Qa=k1c(G|0,J|0,h|0)|0;G=J;if((d|0)<3){u=i;return}Pa=d1c(Ra|0,Sa|0,o|0,H|0)|0;Sa=k1c(Pa|0,J|0,h|0)|0;Pa=J;Pa=d1c(Ta|0,Ua|0,o|0,H|0)|0;Ua=k1c(Pa|0,J|0,h|0)|0;if(!((Sa|Qa|0)>-1&(Ua|0)<(r|0))){u=i;return}if((Oa|0)>=(s|0)){u=i;return}Ua=s+-1|0;s=((Ua|0)<0)<<31>>31;Sa=(G|0)>(s|0)|(G|0)==(s|0)&Qa>>>0>Ua>>>0;s=Sa?Ua:Qa;Qa=j+32|0;f[Qa>>2]=Ma;f[j>>2]=Ma;Ma=j+56|0;f[Ma>>2]=Oa;Ua=j+24|0;f[Ua>>2]=Oa;Sa=j+4|0;f[Sa>>2]=1;G=j+36|0;f[G>>2]=z;z=j+40|0;Pa=z;f[Pa>>2]=-65536;f[Pa+4>>2]=-1;Pa=j+8|0;Ta=Pa;f[Ta>>2]=-65536;f[Ta+4>>2]=-1;Ta=j+48|0;Ra=Ta;f[Ra>>2]=0;f[Ra+4>>2]=0;Ra=j+16|0;Na=Ra;f[Na>>2]=0;f[Na+4>>2]=0;Na=a+48|0;a=p+(Y(f[Na>>2]|0,Oa)|0)|0;p=r+-1|0;K=(t|0)==1;I=(h|0)==16?0:B;B=Oa;fa=a;a=d;ea=-65536;da=-1;ca=-65536;ba=-1;while(1){if(!q?!((B|0)<(s|0)|(B|0)==(Oa|0)):0){Xa=a;Ya=ba;Za=da;_a=ca;$a=ea}else ab=18;b:do if((ab|0)==18){ab=0;c:do if((B|0)<(f[Ua>>2]|0)){bb=a;cb=ca;db=ba}else{aa=f[Sa>>2]|0;$=f[j>>2]|0;_=a;while(1){Z=$+aa|0;eb=Z-((Z|0)<(d|0)?0:d)|0;Z=_;_=_+-1|0;if((Z|0)<=0){bb=_;cb=ca;db=ba;break c}Z=c+(eb<<4)+8|0;X=d1c(f[Z>>2]|0,f[Z+4>>2]|0,o|0,H|0)|0;fb=k1c(X|0,J|0,h|0)|0;if((fb|0)>(B|0))break;else $=eb}aa=c+($<<4)|0;X=c+(eb<<4)|0;Z=f[X>>2]|0;W=f[X+4>>2]|0;X=u1c(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;V=u1c(Z|0,W|0,I|0)|0;f[Ua>>2]=fb;W=c1c(V|0,J|0,X|0,aa|0)|0;V=u1c(W|0,J|0,1)|0;W=fb-B|0;Z=d1c(V|0,J|0,W|0,((W|0)<0)<<31>>31|0)|0;V=W<<1;W=v1c(Z|0,J|0,V|0,((V|0)<0)<<31>>31|0)|0;V=Ra;f[V>>2]=W;f[V+4>>2]=J;V=Pa;f[V>>2]=X;f[V+4>>2]=aa;f[j>>2]=eb;bb=_;cb=X;db=aa}while(0);if((B|0)<(f[Ma>>2]|0)){Xa=bb;Ya=db;Za=da;_a=cb;$a=ea}else{aa=f[G>>2]|0;X=f[Qa>>2]|0;V=bb;while(1){W=X+aa|0;gb=W-((W|0)<(d|0)?0:d)|0;W=V;V=V+-1|0;if((W|0)<=0){Xa=V;Ya=db;Za=da;_a=cb;$a=ea;break b}W=c+(gb<<4)+8|0;Z=d1c(f[W>>2]|0,f[W+4>>2]|0,o|0,H|0)|0;hb=k1c(Z|0,J|0,h|0)|0;if((hb|0)>(B|0))break;else X=gb}aa=c+(X<<4)|0;Z=c+(gb<<4)|0;W=f[Z>>2]|0;U=f[Z+4>>2]|0;Z=u1c(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;T=u1c(W|0,U|0,I|0)|0;f[Ma>>2]=hb;U=c1c(T|0,J|0,Z|0,aa|0)|0;T=u1c(U|0,J|0,1)|0;U=hb-B|0;W=d1c(T|0,J|0,U|0,((U|0)<0)<<31>>31|0)|0;T=U<<1;U=v1c(W|0,J|0,T|0,((T|0)<0)<<31>>31|0)|0;T=Ta;f[T>>2]=U;f[T+4>>2]=J;T=z;f[T>>2]=Z;f[T+4>>2]=aa;f[Qa>>2]=gb;Xa=V;Ya=db;Za=aa;_a=cb;$a=Z}}while(0);if((Xa|0)<0){ab=35;break}do if((B|0)>-1?(Z=(Ya|0)>(Za|0)|(Ya|0)==(Za|0)&_a>>>0>$a>>>0,aa=j+((Z&1)<<5)+8|0,T=d1c(f[aa>>2]|0,f[aa+4>>2]|0,v|0,w|0)|0,aa=l1c(T|0,J|0,16)|0,T=j+(((Z^1)&1)<<5)+8|0,Z=d1c(f[T>>2]|0,f[T+4>>2]|0,x|0,y|0)|0,T=l1c(Z|0,J|0,16)|0,(aa|0)<(r|0)&(T|0)>-1):0){Z=Y((aa|0)>0?aa:0,t)|0;aa=fa+Z|0;U=Y(((T|0)<(r|0)?T:p)+1|0,t)|0;T=fa+U|0;if(K){g1c(aa|0,b[e>>0]|0,T-aa|0)|0;break}if((Z|0)<(U|0)){o1c(aa|0,e|0,t|0)|0;ib=aa+t|0}else ib=aa;if(ib>>>0<T>>>0){U=T;Z=t;W=ib;while(1){o1c(W|0,aa|0,Z|0)|0;W=W+Z|0;S=Z<<1;R=U-W|0;if(W>>>0>=T>>>0)break;else Z=R>>>0<S>>>0?R:S}}}while(0);Z=Ra;T=Pa;ca=d1c(f[T>>2]|0,f[T+4>>2]|0,f[Z>>2]|0,f[Z+4>>2]|0)|0;ba=J;Z=Pa;f[Z>>2]=ca;f[Z+4>>2]=ba;Z=Ta;T=z;ea=d1c(f[T>>2]|0,f[T+4>>2]|0,f[Z>>2]|0,f[Z+4>>2]|0)|0;da=J;Z=z;f[Z>>2]=ea;f[Z+4>>2]=da;if((B|0)>=(s|0)){ab=35;break}else{B=B+1|0;fa=fa+(f[Na>>2]|0)|0;a=Xa}}if((ab|0)==35){u=i;return}}function qra(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;h=f[a+40>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=f[a+48>>2]|0;k=f[a+4>>2]|0;if((k|0)>0)l=f[(f[a+44>>2]|0)+(k+-1<<2)>>2]|0;else l=0;k=f[a+16>>2]|0;a=f[c>>2]|0;if((a|0)>=(d|0)&(a|0)<(i-d|0)){m=f[c+4>>2]|0;n=(m|0)<(j-d|0)&(m|0)>=(d|0)}else n=0;if((d|0)<0)return;m=c+4|0;o=(g|0)!=0;g=(l|0)==1;p=i+-1|0;q=d;r=0;s=1;t=(d<<1)+-1|0;d=0;u=a;while(1){a=f[m>>2]|0;v=a-r|0;w=a+r|0;x=a-q|0;y=a+q|0;a=u-q|0;z=u+q|0;A=u-r|0;B=u+r|0;do if(n){C=k+(Y(v,h)|0)|0;D=k+(Y(w,h)|0)|0;E=Y(a,l)|0;F=C+E|0;if(!o){o1c(F|0,e|0,l|0)|0;o1c(D+E|0,e|0,l|0)|0;G=Y(z,l)|0;o1c(C+G|0,e|0,l|0)|0;o1c(D+G|0,e|0,l|0)|0;G=k+(Y(x,h)|0)|0;H=k+(Y(y,h)|0)|0;I=Y(A,l)|0;o1c(G+I|0,e|0,l|0)|0;o1c(H+I|0,e|0,l|0)|0;I=Y(B,l)|0;o1c(G+I|0,e|0,l|0)|0;o1c(H+I|0,e|0,l|0)|0;break}I=Y(z+1|0,l)|0;H=C+I|0;if(!g){C=(I|0)>(E|0);if(C){o1c(F|0,e|0,l|0)|0;J=F+l|0}else J=F;if(J>>>0<H>>>0){G=H;K=l;L=J;while(1){o1c(L|0,F|0,K|0)|0;L=L+K|0;M=K<<1;N=G-L|0;if(L>>>0>=H>>>0)break;else K=N>>>0<M>>>0?N:M}}K=D+E|0;L=D+I|0;if(C){o1c(K|0,e|0,l|0)|0;O=D+E+l|0}else O=K;if(O>>>0<L>>>0){G=L;M=l;N=O;while(1){o1c(N|0,K|0,M|0)|0;N=N+M|0;P=M<<1;Q=G-N|0;if(N>>>0>=L>>>0)break;else M=Q>>>0<P>>>0?Q:P}}}else{g1c(F|0,b[e>>0]|0,H-F|0)|0;g1c(D+E|0,b[e>>0]|0,I-E|0)|0}M=k+(Y(x,h)|0)|0;L=k+(Y(y,h)|0)|0;N=Y(A,l)|0;G=M+N|0;K=Y(B+1|0,l)|0;C=M+K|0;if(g){g1c(G|0,b[e>>0]|0,C-G|0)|0;g1c(L+N|0,b[e>>0]|0,K-N|0)|0;break}M=(K|0)>(N|0);if(M){o1c(G|0,e|0,l|0)|0;R=G+l|0}else R=G;if(R>>>0<C>>>0){P=C;Q=l;S=R;while(1){o1c(S|0,G|0,Q|0)|0;S=S+Q|0;T=Q<<1;U=P-S|0;if(S>>>0>=C>>>0)break;else Q=U>>>0<T>>>0?U:T}}Q=L+N|0;C=L+K|0;if(M){o1c(Q|0,e|0,l|0)|0;V=L+N+l|0}else V=Q;if(V>>>0<C>>>0){S=C;P=l;G=V;while(1){o1c(G|0,Q|0,P|0)|0;G=G+P|0;E=P<<1;I=S-G|0;if(G>>>0>=C>>>0)break;else P=I>>>0<E>>>0?I:E}}}else if((a|0)<(i|0)&(z|0)>-1?(x|0)<(j|0)&(y|0)>-1:0){P=o?((a|0)>0?a:0):a;C=o&(z|0)>=(i|0)?p:z;do if(v>>>0<j>>>0){G=k+(Y(v,h)|0)|0;if(!o){if((P|0)>-1)o1c(G+(Y(P,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;o1c(G+(Y(C,l)|0)|0,e|0,l|0)|0;break}S=Y(P,l)|0;Q=G+S|0;N=Y(C+1|0,l)|0;L=G+N|0;if(g){g1c(Q|0,b[e>>0]|0,L-Q|0)|0;break}if((S|0)<(N|0)){o1c(Q|0,e|0,l|0)|0;W=Q+l|0}else W=Q;if(W>>>0<L>>>0){N=L;S=l;G=W;while(1){o1c(G|0,Q|0,S|0)|0;G=G+S|0;M=S<<1;K=N-G|0;if(G>>>0>=L>>>0)break;else S=K>>>0<M>>>0?K:M}}}while(0);do if(w>>>0<j>>>0){S=k+(Y(w,h)|0)|0;if(!o){if((P|0)>-1)o1c(S+(Y(P,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;o1c(S+(Y(C,l)|0)|0,e|0,l|0)|0;break}L=Y(P,l)|0;G=S+L|0;N=Y(C+1|0,l)|0;Q=S+N|0;if(g){g1c(G|0,b[e>>0]|0,Q-G|0)|0;break}if((L|0)<(N|0)){o1c(G|0,e|0,l|0)|0;X=G+l|0}else X=G;if(X>>>0<Q>>>0){N=Q;L=l;S=X;while(1){o1c(S|0,G|0,L|0)|0;S=S+L|0;M=L<<1;K=N-S|0;if(S>>>0>=Q>>>0)break;else L=K>>>0<M>>>0?K:M}}}while(0);if((A|0)<(i|0)&(B|0)>-1){C=o?((A|0)>0?A:0):A;P=o&(B|0)>=(i|0)?p:B;do if(x>>>0<j>>>0){L=k+(Y(x,h)|0)|0;if(!o){if((C|0)>-1)o1c(L+(Y(C,l)|0)|0,e|0,l|0)|0;if((P|0)>=(i|0))break;o1c(L+(Y(P,l)|0)|0,e|0,l|0)|0;break}Q=Y(C,l)|0;S=L+Q|0;N=Y(P+1|0,l)|0;G=L+N|0;if(g){g1c(S|0,b[e>>0]|0,G-S|0)|0;break}if((Q|0)<(N|0)){o1c(S|0,e|0,l|0)|0;Z=S+l|0}else Z=S;if(Z>>>0<G>>>0){N=G;Q=l;L=Z;while(1){o1c(L|0,S|0,Q|0)|0;L=L+Q|0;M=Q<<1;K=N-L|0;if(L>>>0>=G>>>0)break;else Q=K>>>0<M>>>0?K:M}}}while(0);if(y>>>0<j>>>0){Q=k+(Y(y,h)|0)|0;if(!o){if((C|0)>-1)o1c(Q+(Y(C,l)|0)|0,e|0,l|0)|0;if((P|0)>=(i|0))break;o1c(Q+(Y(P,l)|0)|0,e|0,l|0)|0;break}G=Y(C,l)|0;L=Q+G|0;N=Y(P+1|0,l)|0;S=Q+N|0;if(g){g1c(L|0,b[e>>0]|0,S-L|0)|0;break}if((G|0)<(N|0)){o1c(L|0,e|0,l|0)|0;_=L+l|0}else _=L;if(_>>>0<S>>>0){N=S;G=l;Q=_;while(1){o1c(Q|0,L|0,G|0)|0;Q=Q+G|0;M=G<<1;K=N-Q|0;if(Q>>>0>=S>>>0)break;else G=K>>>0<M>>>0?K:M}}}}}while(0);y=d+s|0;x=(y|0)>0;B=(x<<31>>31)+q|0;if((B|0)<=(r|0))break;A=y-(x?t:0)|0;q=B;r=r+1|0;s=s+2|0;t=t-(x?2:0)|0;d=A;u=f[c>>2]|0}return}function rra(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;k=u;u=u+80|0;l=k+68|0;m=k+32|0;n=k;o=k+56|0;q=k+16|0;r=k+48|0;s=c;t=f[s>>2]|0;v=f[s+4>>2]|0;s=(v|0)>-1|(v|0)==-1&t>>>0>4294967295;w=c1c(0,0,t|0,v|0)|0;x=s?t:w;w=s?v:J;v=c;f[v>>2]=x;f[v+4>>2]=w;v=c+8|0;c=v;s=f[c>>2]|0;t=f[c+4>>2]|0;c=(t|0)>-1|(t|0)==-1&s>>>0>4294967295;y=c1c(0,0,s|0,t|0)|0;z=c?s:y;y=c?t:J;t=v;f[t>>2]=z;f[t+4>>2]=y;t=(w|0)<(y|0)|(w|0)==(y|0)&x>>>0<z>>>0;v=d1c((t?z:x)|0,(t?y:w)|0,32768,0)|0;t=l1c(v|0,J|0,16)|0;if((t|0)<3)A=90;else A=(t|0)<10?30:(t|0)<15?18:5;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;v=b;c=b+8|0;s=c;B=+((f[s>>2]|0)>>>0)+4294967296.0*+(f[s+4>>2]|0);p[m>>3]=+((f[v>>2]|0)>>>0)+4294967296.0*+(f[v+4>>2]|0);p[m+8>>3]=B;p[n>>3]=+(x>>>0)+4294967296.0*+(w|0);p[n+8>>3]=+(z>>>0)+4294967296.0*+(y|0);gra(m,n,d,e,g,A,l);f[o>>2]=0;A=o+4|0;f[A>>2]=0;f[o+8>>2]=0;d=f[t>>2]|0;n=f[l>>2]|0;if((d|0)==(n|0)){C=0;D=0}else{m=q+8|0;y=o+8|0;z=0;w=n;n=-1;x=-1;v=-1;s=-1;E=d;while(1){d=w;F=zLc(+p[d+(z<<4)>>3]*.0000152587890625)|0;G=u1c(F|0,((F|0)<0)<<31>>31|0,16)|0;F=J;H=zLc(+p[d+(z<<4)+8>>3]*.0000152587890625)|0;I=u1c(H|0,((H|0)<0)<<31>>31|0,16)|0;H=J;K=zLc(+p[d+(z<<4)>>3]-(+(G>>>0)+4294967296.0*+(F|0)))|0;L=d1c(K|0,((K|0)<0)<<31>>31|0,G|0,F|0)|0;F=J;G=q;f[G>>2]=L;f[G+4>>2]=F;G=zLc(+p[d+(z<<4)+8>>3]-(+(I>>>0)+4294967296.0*+(H|0)))|0;d=d1c(G|0,((G|0)<0)<<31>>31|0,I|0,H|0)|0;H=J;I=m;f[I>>2]=d;f[I+4>>2]=H;if((L|0)!=(v|0)|(F|0)!=(s|0)|((d|0)!=(n|0)|(H|0)!=(x|0))){I=f[A>>2]|0;if((I|0)==(f[y>>2]|0)){sra(o,q);M=f[t>>2]|0;N=f[l>>2]|0}else{G=I;f[G>>2]=L;f[G+4>>2]=F;F=I+8|0;f[F>>2]=d;f[F+4>>2]=H;f[A>>2]=I+16;M=E;N=w}I=q;H=m;O=N;P=M;Q=f[H>>2]|0;R=f[H+4>>2]|0;S=f[I>>2]|0;T=f[I+4>>2]|0}else{O=w;P=E;Q=n;R=x;S=v;T=s}z=z+1|0;if(z>>>0>=P-O>>4>>>0)break;else{w=O;n=Q;x=R;v=S;s=T;E=P}}C=f[A>>2]|0;D=f[o>>2]|0}if((C-D|0)==16)tra(o,2,b);do if((i|0)<=-1){if((g-e|0)>359){D=f[o>>2]|0;pra(a,D,(f[A>>2]|0)-D>>4,h,j,16);break}D=f[A>>2]|0;if((D|0)==(f[o+8>>2]|0)){sra(o,b);U=f[A>>2]|0}else{C=b;P=f[C+4>>2]|0;E=D;f[E>>2]=f[C>>2];f[E+4>>2]=P;P=c;E=f[P+4>>2]|0;C=D+8|0;f[C>>2]=f[P>>2];f[C+4>>2]=E;E=D+16|0;f[A>>2]=E;U=E}f[q>>2]=0;E=q+4|0;f[E>>2]=0;f[q+8>>2]=0;D=f[o>>2]|0;f[r>>2]=0;f[r+4>>2]=0;vra(a,D,U-D>>4,q,h,j,16,r);wra(a,q,h);D=f[q>>2]|0;if(D|0){C=f[E>>2]|0;if((C|0)!=(D|0))f[E>>2]=C+(~((C+-32-D|0)>>>5)<<5);cYc(D)}}else{D=f[o>>2]|0;ura(a,D,(f[A>>2]|0)-D>>4,0,h,i,j,16)}while(0);j=f[o>>2]|0;if(j|0){o=f[A>>2]|0;if((o|0)!=(j|0))f[A>>2]=o+(~((o+-16-j|0)>>>4)<<4);cYc(j)}j=f[l>>2]|0;if(!j){u=k;return}l=f[t>>2]|0;if((l|0)!=(j|0))f[t>>2]=l+(~((l+-16-j|0)>>>4)<<4);cYc(j);u=k;return}function sra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;m=b;k=f[m+4>>2]|0;o=l;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=b+8|0;b=f[k+4>>2]|0;o=n+(g<<4)+8|0;f[o>>2]=f[k>>2];f[o+4>>2]=b;b=l+16|0;if((j|0)==(i|0))p=l;else{o=j+-16-e|0;k=j;j=l;while(1){g=k;k=k+-16|0;n=k;m=f[n+4>>2]|0;q=j+-16|0;f[q>>2]=f[n>>2];f[q+4>>2]=m;m=g+-8|0;g=f[m+4>>2]|0;q=j+-8|0;f[q>>2]=f[m>>2];f[q+4>>2]=g;if((k|0)==(i|0))break;else j=j+-16|0}p=l+(~(o>>>4)<<4)|0}f[a>>2]=p;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function tra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=m;m=h;while(1){p=c;q=f[p+4>>2]|0;r=m;f[r>>2]=f[p>>2];f[r+4>>2]=q;q=j;r=f[q+4>>2]|0;p=m+8|0;f[p>>2]=f[q>>2];f[p+4>>2]=r;o=o+-1|0;if(!o)break;else m=m+16|0}}if(!l){m=h+(b<<4)|0;if((n|0)==(m|0))return;else{s=i;t=n+(~((n+-16-m|0)>>>4)<<4)|0;break}}else{m=b-k|0;o=c+8|0;j=m;r=n;while(1){p=c;q=f[p+4>>2]|0;u=r;f[u>>2]=f[p>>2];f[u+4>>2]=q;q=o;u=f[q+4>>2]|0;p=r+8|0;f[p>>2]=f[q>>2];f[p+4>>2]=u;j=j+-1|0;if(!j)break;else r=r+16|0}s=i;t=n+(m<<4)|0;break}}else{r=g;if(!g)v=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-16-g|0)>>>4)<<4);cYc(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;v=0}if(b>>>0>268435455)kWc(a);j=v>>3;r=v>>4>>>0<134217727?(j>>>0<b>>>0?b:j):268435455;if(r>>>0>268435455)kWc(a);j=$Xc(r<<4)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<4);r=c+8|0;k=b;l=j;while(1){u=c;p=f[u+4>>2]|0;q=l;f[q>>2]=f[u>>2];f[q+4>>2]=p;p=r;q=f[p+4>>2]|0;u=l+8|0;f[u>>2]=f[p>>2];f[u+4>>2]=q;k=k+-1|0;if(!k)break;else l=l+16|0}s=o;t=j+(b<<4)|0}while(0);f[s>>2]=t;return}function ura(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;if((c|0)==0|(d|0)<1){u=k;return}if(!((h|0)>-1&j>>>0<17)){o=$Xc(64)|0;f[l>>2]=o;f[l+8>>2]=-2147483584;f[l+4>>2]=49;p=o;q=273361;r=p+49|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));b[o+49>>0]=0;vM(-215,l,273411,273208,1720)}l=(e^1)&1;o=e?d+-1|0:0;if((l|0)>=(d|0)){u=k;return}q=c+(o<<4)+8|0;p=c+(o<<4)|0;o=m+8|0;r=n+8|0;s=e?2:3;e=l;l=f[p>>2]|0;t=f[p+4>>2]|0;p=f[q>>2]|0;v=f[q+4>>2]|0;while(1){q=c+(e<<4)|0;w=l;l=f[q>>2]|0;x=t;t=f[q+4>>2]|0;q=c+(e<<4)+8|0;y=p;p=f[q>>2]|0;z=v;v=f[q+4>>2]|0;q=m;f[q>>2]=w;f[q+4>>2]=x;x=o;f[x>>2]=y;f[x+4>>2]=z;z=n;f[z>>2]=l;f[z+4>>2]=t;z=r;f[z>>2]=p;f[z+4>>2]=v;lra(a,m,n,g,h,i,s,j);e=e+1|0;if((e|0)==(d|0))break;else s=2}u=k;return}function vra(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+96|0;k=j+80|0;l=j+64|0;m=j+32|0;n=j+16|0;o=j;p=(f[i+4>>2]|0)+(1<<h>>1)|0;q=c+-1|0;r=b+(q<<4)|0;s=f[r>>2]|0;t=f[r+4>>2]|0;r=k+8|0;v=b+(q<<4)+8|0;q=f[v>>2]|0;w=f[v+4>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;v=f[i>>2]|0;x=d1c(v|0,((v|0)<0)<<31>>31|0,s|0,t|0)|0;t=16-h|0;s=u1c(x|0,J|0,t|0)|0;x=J;v=k;f[v>>2]=s;f[v+4>>2]=x;v=((p|0)<0)<<31>>31;y=d1c(q|0,w|0,p|0,v|0)|0;w=k1c(y|0,J|0,h|0)|0;y=J;q=r;f[q>>2]=w;f[q+4>>2]=y;q=d+4|0;Dra(d,((f[q>>2]|0)-(f[d>>2]|0)>>5)+c|0);if((c|0)<=0){u=j;return}z=l+8|0;A=(g|0)<16;B=m+4|0;C=m+8|0;D=m+16|0;E=d+8|0;F=n+8|0;G=o+8|0;H=0;I=s;s=x;x=w;w=y;do{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;y=b+(H<<4)|0;K=b+(H<<4)+8|0;L=f[K>>2]|0;M=f[K+4>>2]|0;K=f[i>>2]|0;N=d1c(K|0,((K|0)<0)<<31>>31|0,f[y>>2]|0,f[y+4>>2]|0)|0;y=I;I=u1c(N|0,J|0,t|0)|0;N=s;s=J;K=l;f[K>>2]=I;f[K+4>>2]=s;K=d1c(L|0,M|0,p|0,v|0)|0;M=x;x=k1c(K|0,J|0,h|0)|0;K=w;w=J;L=z;f[L>>2]=x;f[L+4>>2]=w;if(A){L=d1c(y|0,N|0,32768,0)|0;O=k1c(L|0,J|0,16)|0;L=J;P=d1c(I|0,s|0,32768,0)|0;Q=k1c(P|0,J|0,16)|0;P=J;R=d1c(O|0,L|0,-2147483648,0)|0;S=J;T=d1c(M|0,K|0,-2147483648,0)|0;U=J;V=d1c(Q|0,P|0,-2147483648,0)|0;W=J;X=d1c(x|0,w|0,-2147483648,0)|0;Y=J;mra(a,S>>>0<1|(S|0)==1&R>>>0<0?O:(L|0)>0|(L|0)==0&O>>>0>0?2147483647:-2147483648,U>>>0<1|(U|0)==1&T>>>0<0?M:(K|0)>0|(K|0)==0&M>>>0>0?2147483647:-2147483648,W>>>0<1|(W|0)==1&V>>>0<0?Q:(P|0)>0|(P|0)==0&Q>>>0>0?2147483647:-2147483648,Y>>>0<1|(Y|0)==1&X>>>0<0?x:(w|0)>0|(w|0)==0&x>>>0>0?2147483647:-2147483648,e,g)}else{X=u1c(M|0,K|0,16)|0;Y=J;Q=u1c(x|0,w|0,16)|0;P=n;f[P>>2]=y;f[P+4>>2]=N;P=F;f[P>>2]=X;f[P+4>>2]=Y;Y=o;f[Y>>2]=I;f[Y+4>>2]=s;Y=G;f[Y>>2]=Q;f[Y+4>>2]=J;ora(a,n,o,e)}do if(!((x|0)==(M|0)&(w|0)==(K|0))){Y=(w|0)>(K|0)|(w|0)==(K|0)&x>>>0>M>>>0;Q=Y?k:l;f[m>>2]=f[Q+8>>2];f[B>>2]=f[(Y?l:k)+8>>2];Y=Q;Q=f[Y+4>>2]|0;P=C;f[P>>2]=f[Y>>2];f[P+4>>2]=Q;Q=c1c(I|0,s|0,y|0,N|0)|0;P=J;Y=c1c(x|0,w|0,M|0,K|0)|0;X=v1c(Q|0,P|0,Y|0,J|0)|0;Y=D;f[Y>>2]=X;f[Y+4>>2]=J;Y=f[q>>2]|0;if((Y|0)==(f[E>>2]|0)){yra(d,m);break}else{f[Y>>2]=f[m>>2];f[Y+4>>2]=f[m+4>>2];f[Y+8>>2]=f[m+8>>2];f[Y+12>>2]=f[m+12>>2];f[Y+16>>2]=f[m+16>>2];f[Y+20>>2]=f[m+20>>2];f[Y+24>>2]=f[m+24>>2];f[Y+28>>2]=f[m+28>>2];f[q>>2]=(f[q>>2]|0)+32;break}}while(0);H=H+1|0;K=k;f[K>>2]=I;f[K+4>>2]=s;K=r;f[K>>2]=x;f[K+4>>2]=w}while((H|0)!=(c|0));u=j;return}function wra(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+48|0;g=e+32|0;h=e;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=j-k|0;m=l>>5;n=f[a+40>>2]|0;o=f[n+4>>2]|0;p=f[n>>2]|0;n=f[a+4>>2]|0;q=k;k=j;if((n|0)>0)r=f[(f[a+44>>2]|0)+(n+-1<<2)>>2]|0;else r=0;if((l|0)<64){u=e;return}else{s=-2147483648;t=2147483647;v=0;w=2147483647;x=-1;y=-1;z=-1}while(1){l=q+(v<<5)+8|0;n=f[l>>2]|0;j=f[l+4>>2]|0;l=f[q+(v<<5)+4>>2]|0;A=f[q+(v<<5)>>2]|0;B=l-A|0;C=q+(v<<5)+16|0;D=x1c(B|0,((B|0)<0)<<31>>31|0,f[C>>2]|0,f[C+4>>2]|0)|0;C=d1c(D|0,J|0,n|0,j|0)|0;D=J;t=(A|0)<(t|0)?A:t;s=(s|0)<(l|0)?l:s;l=(j|0)<(w|0)|(j|0)==(w|0)&n>>>0<x>>>0;A=l?n:x;B=l?j:w;l=(y|0)<(j|0)|(y|0)==(j|0)&z>>>0<n>>>0;E=l?n:z;n=l?j:y;j=(D|0)<(B|0)|(D|0)==(B|0)&C>>>0<A>>>0;x=j?C:A;w=j?D:B;B=(n|0)<(D|0)|(n|0)==(D|0)&E>>>0<C>>>0;y=B?D:n;v=v+1|0;if((v|0)>=(m|0))break;else z=B?C:E}if((s|0)<0){u=e;return}if((y|0)<0|(t|0)>=(p|0)){u=e;return}t=u1c(o|0,((o|0)<0)<<31>>31|0,16)|0;y=J;if(!((w|0)<(y|0)|(w|0)==(y|0)&x>>>0<t>>>0)){u=e;return}xra(q,k,g);f[h>>2]=2147483647;g=f[i>>2]|0;if((g|0)==(f[c+8>>2]|0))yra(c,h);else{f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[i>>2]=(f[i>>2]|0)+32}i=h+24|0;f[i>>2]=0;g=f[c>>2]|0;k=(s|0)>(p|0)?p:s;s=f[g>>2]|0;if((s|0)>=(k|0)){u=e;return}p=a+16|0;q=a+44|0;a=o+-1|0;t=(r|0)==1;x=s;s=g;g=0;y=0;while(1){a:do if((x|0)<0){w=f[c>>2]|0;z=0;v=h;E=y;C=s;B=g;while(1){b:do if(!E)F=22;else{n=v+24|0;D=E;while(1){if((f[D+4>>2]|0)!=(x|0))break;j=D+24|0;f[n>>2]=f[j>>2];A=f[j>>2]|0;if(!A){F=22;break b}else D=A}if((f[C>>2]|0)<=(x|0)?(A=D+8|0,j=f[A+4>>2]|0,l=C+8|0,G=f[l+4>>2]|0,!((j|0)<(G|0)|((j|0)==(G|0)?(f[A>>2]|0)>>>0<(f[l>>2]|0)>>>0:0))):0)if((B|0)<(m|0)){H=D;I=n;F=24;break}else{K=C;L=B;break a}M=D;N=f[D+24>>2]|0;O=C;P=B}while(0);if((F|0)==22){F=0;if(!((B|0)<(m|0)?(f[C>>2]|0)==(x|0):0)){K=C;L=B;break a}H=0;I=v+24|0;F=24}if((F|0)==24){F=0;f[I>>2]=C;f[C+24>>2]=H;l=B+1|0;M=C;N=H;O=w+(l<<5)|0;P=l}if(z|0){l=v+16|0;A=v+8|0;G=A;j=d1c(f[G>>2]|0,f[G+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=A;f[l>>2]=j;f[l+4>>2]=J;l=M+16|0;j=M+8|0;A=j;G=d1c(f[A>>2]|0,f[A+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=j;f[l>>2]=G;f[l+4>>2]=J}z=z^1;v=M;E=N;C=O;B=P}}else{B=0;C=h;E=y;v=s;z=g;while(1){c:do if(!E)F=31;else{w=C+24|0;l=E;while(1){if((f[l+4>>2]|0)!=(x|0))break;G=l+24|0;f[w>>2]=f[G>>2];j=f[G>>2]|0;if(!j){F=31;break c}else l=j}if((f[v>>2]|0)<=(x|0)?(D=l+8|0,n=f[D+4>>2]|0,j=v+8|0,G=f[j+4>>2]|0,!((n|0)<(G|0)|((n|0)==(G|0)?(f[D>>2]|0)>>>0<(f[j>>2]|0)>>>0:0))):0)if((z|0)<(m|0)){Q=l;R=w;F=40;break}else{K=v;L=z;break a}S=l;T=f[l+24>>2]|0;U=v;V=z}while(0);if((F|0)==31){F=0;if(!((z|0)<(m|0)?(f[v>>2]|0)==(x|0):0)){K=v;L=z;break a}Q=0;R=C+24|0;F=40}if((F|0)==40){F=0;f[R>>2]=v;f[v+24>>2]=Q;j=z+1|0;S=v;T=Q;U=(f[c>>2]|0)+(j<<5)|0;V=j}if(B|0){j=(f[p>>2]|0)+(Y(f[f[q>>2]>>2]|0,x)|0)|0;D=C+8|0;G=D;n=f[G>>2]|0;A=f[G+4>>2]|0;G=S+8|0;W=G;X=f[W>>2]|0;Z=f[W+4>>2]|0;W=(A|0)>(Z|0)|(A|0)==(Z|0)&n>>>0>X>>>0;_=d1c((W?X:n)|0,(W?Z:A)|0,65535,0)|0;$=l1c(_|0,J|0,16)|0;_=l1c((W?n:X)|0,(W?A:Z)|0,16)|0;do if((_|0)>-1&($|0)<(o|0)){Z=Y(($|0)>0?$:0,r)|0;A=j+Z|0;W=Y(((_|0)<(o|0)?_:a)+1|0,r)|0;X=j+W|0;if(t){g1c(A|0,b[d>>0]|0,X-A|0)|0;break}if((Z|0)<(W|0)){o1c(A|0,d|0,r|0)|0;aa=A+r|0}else aa=A;if(aa>>>0<X>>>0){W=X;Z=r;n=aa;while(1){o1c(n|0,A|0,Z|0)|0;n=n+Z|0;ba=Z<<1;ca=W-n|0;if(n>>>0>=X>>>0)break;else Z=ca>>>0<ba>>>0?ca:ba}}}while(0);j=C+16|0;_=D;$=d1c(f[_>>2]|0,f[_+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=D;f[j>>2]=$;f[j+4>>2]=J;j=S+16|0;$=G;_=d1c(f[$>>2]|0,f[$+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=G;f[j>>2]=_;f[j+4>>2]=J}B=B^1;C=S;E=T;v=U;z=V}}while(0);z=0;v=0;E=f[i>>2]|0;while(1){d:do if((E|0)==(v|0)){da=z;ea=h}else{C=z;B=h;j=E;while(1){_=j+24|0;$=f[_>>2]|0;if(!$){da=C;ea=B;break d}Z=j+8|0;X=f[Z>>2]|0;n=f[Z+4>>2]|0;Z=C;W=B;A=$;while(1){$=A+8|0;l=f[$+4>>2]|0;if(!((n|0)>(l|0)|((n|0)==(l|0)?X>>>0>(f[$>>2]|0)>>>0:0)))break;f[W+24>>2]=A;$=A+24|0;f[_>>2]=f[$>>2];f[$>>2]=j;$=f[_>>2]|0;if(!$){da=1;ea=A;break d}else{l=A;Z=1;A=$;W=l}}if((A|0)==(v|0)){da=Z;ea=j;break}else{W=j;C=Z;j=A;B=W}}}while(0);if(!da)break;E=f[i>>2]|0;if(!((ea|0)!=(h|0)&(ea|0)!=(E|0)))break;else{z=da;v=ea}}v=x+1|0;if((v|0)>=(k|0))break;x=v;s=K;g=L;y=f[i>>2]|0}u=e;return}function xra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;d=u;u=u+32|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-32|0;i=a+-64|0;j=a+-24|0;k=a+-16|0;l=g;while(1){m=l;b:while(1){n=m;o=b-n|0;p=o>>5;switch(p|0){case 2:{q=5;break a;break}case 3:{q=11;break a;break}case 4:{q=12;break a;break}case 5:{q=13;break a;break}case 1:case 0:{q=107;break a;break}default:{}}if((o|0)<992){q=15;break a}r=(p|0)/2|0;s=m+(r<<5)|0;if((o|0)>31968){o=(p|0)/4|0;t=Bra(m,m+(o<<5)|0,s,s+(o<<5)|0,h,c)|0}else t=zra(m,s,h,c)|0;o=f[m>>2]|0;p=f[s>>2]|0;if((o|0)==(p|0)){v=m+8|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=m+(r<<5)+8|0;y=f[v>>2]|0;z=f[v+4>>2]|0;if((w|0)==(y|0)&(x|0)==(z|0)){v=m+16|0;A=m+(r<<5)+16|0;B=f[v+4>>2]|0;C=f[A+4>>2]|0;D=f[v>>2]|0;E=f[A>>2]|0}else{B=x;C=z;D=w;E=y}if((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0){F=h;G=t;break}}else if((o|0)<(p|0)){F=h;G=t;break}if((m|0)!=(i|0)){y=m+(r<<5)+8|0;w=m+(r<<5)+16|0;r=h;H=i;while(1){z=f[H>>2]|0;if((z|0)==(p|0)){x=r+-24|0;A=f[x>>2]|0;v=f[x+4>>2]|0;x=y;I=f[x>>2]|0;J=f[x+4>>2]|0;if((A|0)==(I|0)&(v|0)==(J|0)){x=r+-16|0;K=w;L=f[x+4>>2]|0;M=f[K+4>>2]|0;N=f[x>>2]|0;O=f[K>>2]|0}else{L=v;M=J;N=A;O=I}if((L|0)<(M|0)|(L|0)==(M|0)&N>>>0<O>>>0){q=77;break b}}else if((z|0)<(p|0)){q=77;break b}z=H+-32|0;if((m|0)==(z|0))break;else{I=H;H=z;r=I}}}r=m+32|0;p=f[h>>2]|0;if((o|0)==(p|0)){w=m+8|0;y=f[w>>2]|0;I=f[w+4>>2]|0;w=j;z=f[w>>2]|0;A=f[w+4>>2]|0;if((y|0)==(z|0)&(I|0)==(A|0)){w=m+16|0;J=k;P=f[w+4>>2]|0;Q=f[J+4>>2]|0;R=f[w>>2]|0;S=f[J>>2]|0}else{P=I;Q=A;R=y;S=z}if((P|0)<(Q|0)|(P|0)==(Q|0)&R>>>0<S>>>0)T=r;else q=46}else if((o|0)<(p|0))T=r;else q=46;if((q|0)==46){q=0;if((r|0)==(h|0)){q=107;break a}p=m+8|0;z=m+16|0;y=r;while(1){r=f[y>>2]|0;if((o|0)==(r|0)){A=p;I=f[A>>2]|0;J=f[A+4>>2]|0;A=y+8|0;w=f[A>>2]|0;v=f[A+4>>2]|0;if((I|0)==(w|0)&(J|0)==(v|0)){A=z;K=y+16|0;U=f[A+4>>2]|0;V=f[K+4>>2]|0;W=f[A>>2]|0;X=f[K>>2]|0}else{U=J;V=v;W=I;X=w}if((U|0)<(V|0)|(U|0)==(V|0)&W>>>0<X>>>0)break}else if((o|0)<(r|0))break;r=y+32|0;if((r|0)==(h|0)){q=107;break a}else y=r}f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];f[e+8>>2]=f[y+8>>2];f[e+12>>2]=f[y+12>>2];f[e+16>>2]=f[y+16>>2];f[e+20>>2]=f[y+20>>2];f[e+24>>2]=f[y+24>>2];f[e+28>>2]=f[y+28>>2];f[y>>2]=f[h>>2];f[y+4>>2]=f[h+4>>2];f[y+8>>2]=f[h+8>>2];f[y+12>>2]=f[h+12>>2];f[y+16>>2]=f[h+16>>2];f[y+20>>2]=f[h+20>>2];f[y+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];T=y+32|0}if((T|0)==(h|0)){q=107;break a}o=m+8|0;z=m+16|0;p=h;r=T;while(1){w=f[m>>2]|0;I=r;while(1){v=f[I>>2]|0;if((w|0)==(v|0)){J=o;K=f[J>>2]|0;A=f[J+4>>2]|0;J=I+8|0;x=f[J>>2]|0;Y=f[J+4>>2]|0;if((K|0)==(x|0)&(A|0)==(Y|0)){J=z;Z=I+16|0;_=f[J+4>>2]|0;$=f[Z+4>>2]|0;aa=f[J>>2]|0;ba=f[Z>>2]|0}else{_=A;$=Y;aa=K;ba=x}if((_|0)<($|0)|(_|0)==($|0)&aa>>>0<ba>>>0){ca=p;break}}else if((w|0)<(v|0)){ca=p;break}I=I+32|0}while(1){v=ca;ca=ca+-32|0;x=f[ca>>2]|0;if((w|0)!=(x|0))if((w|0)<(x|0)){ca=ca;continue}else break;x=o;K=f[x>>2]|0;Y=f[x+4>>2]|0;x=v+-24|0;A=f[x>>2]|0;Z=f[x+4>>2]|0;if((K|0)==(A|0)&(Y|0)==(Z|0)){x=z;J=v+-16|0;da=f[x+4>>2]|0;ea=f[J+4>>2]|0;fa=f[x>>2]|0;ga=f[J>>2]|0}else{da=Y;ea=Z;fa=K;ga=A}if(!((da|0)<(ea|0)|(da|0)==(ea|0)&fa>>>0<ga>>>0))break}if(I>>>0>=ca>>>0){m=I;continue b};f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[e+16>>2]=f[I+16>>2];f[e+20>>2]=f[I+20>>2];f[e+24>>2]=f[I+24>>2];f[e+28>>2]=f[I+28>>2];f[I>>2]=f[ca>>2];f[I+4>>2]=f[ca+4>>2];f[I+8>>2]=f[ca+8>>2];f[I+12>>2]=f[ca+12>>2];f[I+16>>2]=f[ca+16>>2];f[I+20>>2]=f[ca+20>>2];f[I+24>>2]=f[ca+24>>2];f[ca>>2]=f[e>>2];f[ca+4>>2]=f[e+4>>2];f[ca+8>>2]=f[e+8>>2];f[ca+12>>2]=f[e+12>>2];f[ca+16>>2]=f[e+16>>2];f[ca+20>>2]=f[e+20>>2];f[ca+24>>2]=f[e+24>>2];p=ca;r=I+32|0}}if((q|0)==77){q=0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[H>>2];f[m+4>>2]=f[H+4>>2];f[m+8>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];f[m+16>>2]=f[H+16>>2];f[m+20>>2]=f[H+20>>2];f[m+24>>2]=f[H+24>>2];f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];f[H+16>>2]=f[e+16>>2];f[H+20>>2]=f[e+20>>2];f[H+24>>2]=f[e+24>>2];F=H;G=t+1|0}r=m+32|0;c:do if(r>>>0<F>>>0){p=s;z=F;o=r;y=G;while(1){w=f[p>>2]|0;A=p+8|0;K=p+16|0;Z=o;while(1){Y=f[Z>>2]|0;if((Y|0)==(w|0)){J=Z+8|0;x=f[J>>2]|0;v=f[J+4>>2]|0;J=A;ha=f[J>>2]|0;ia=f[J+4>>2]|0;if((x|0)==(ha|0)&(v|0)==(ia|0)){J=Z+16|0;ja=K;ka=f[J+4>>2]|0;la=f[ja+4>>2]|0;ma=f[J>>2]|0;na=f[ja>>2]|0}else{ka=v;la=ia;ma=x;na=ha}if(!((ka|0)<(la|0)|(ka|0)==(la|0)&ma>>>0<na>>>0)){oa=z;break}}else if((Y|0)>=(w|0)){oa=z;break}Z=Z+32|0}while(1){I=oa;oa=oa+-32|0;Y=f[oa>>2]|0;if((Y|0)!=(w|0))if((Y|0)<(w|0))break;else{oa=oa;continue}Y=I+-24|0;ha=f[Y>>2]|0;x=f[Y+4>>2]|0;Y=A;ia=f[Y>>2]|0;v=f[Y+4>>2]|0;if((ha|0)==(ia|0)&(x|0)==(v|0)){Y=I+-16|0;I=K;pa=f[Y+4>>2]|0;qa=f[I+4>>2]|0;ra=f[Y>>2]|0;sa=f[I>>2]|0}else{pa=x;qa=v;ra=ha;sa=ia}if((pa|0)<(qa|0)|(pa|0)==(qa|0)&ra>>>0<sa>>>0)break}if(Z>>>0>oa>>>0){ta=p;ua=y;va=Z;break c};f[e>>2]=f[Z>>2];f[e+4>>2]=f[Z+4>>2];f[e+8>>2]=f[Z+8>>2];f[e+12>>2]=f[Z+12>>2];f[e+16>>2]=f[Z+16>>2];f[e+20>>2]=f[Z+20>>2];f[e+24>>2]=f[Z+24>>2];f[e+28>>2]=f[Z+28>>2];f[Z>>2]=f[oa>>2];f[Z+4>>2]=f[oa+4>>2];f[Z+8>>2]=f[oa+8>>2];f[Z+12>>2]=f[oa+12>>2];f[Z+16>>2]=f[oa+16>>2];f[Z+20>>2]=f[oa+20>>2];f[Z+24>>2]=f[oa+24>>2];f[oa>>2]=f[e>>2];f[oa+4>>2]=f[e+4>>2];f[oa+8>>2]=f[e+8>>2];f[oa+12>>2]=f[e+12>>2];f[oa+16>>2]=f[e+16>>2];f[oa+20>>2]=f[e+20>>2];f[oa+24>>2]=f[e+24>>2];p=(p|0)==(Z|0)?oa:p;z=oa;o=Z+32|0;y=y+1|0}}else{ta=s;ua=G;va=r}while(0);do if((va|0)==(ta|0))wa=ua;else{r=f[ta>>2]|0;y=f[va>>2]|0;if((r|0)==(y|0)){o=ta+8|0;z=f[o>>2]|0;p=f[o+4>>2]|0;o=va+8|0;K=f[o>>2]|0;A=f[o+4>>2]|0;if((z|0)==(K|0)&(p|0)==(A|0)){o=ta+16|0;w=va+16|0;xa=f[o+4>>2]|0;ya=f[w+4>>2]|0;za=f[o>>2]|0;Aa=f[w>>2]|0}else{xa=p;ya=A;za=z;Aa=K}if(!((xa|0)<(ya|0)|(xa|0)==(ya|0)&za>>>0<Aa>>>0)){wa=ua;break}}else if((r|0)>=(y|0)){wa=ua;break};f[e>>2]=f[va>>2];f[e+4>>2]=f[va+4>>2];f[e+8>>2]=f[va+8>>2];f[e+12>>2]=f[va+12>>2];f[e+16>>2]=f[va+16>>2];f[e+20>>2]=f[va+20>>2];f[e+24>>2]=f[va+24>>2];f[e+28>>2]=f[va+28>>2];f[va>>2]=f[ta>>2];f[va+4>>2]=f[ta+4>>2];f[va+8>>2]=f[ta+8>>2];f[va+12>>2]=f[ta+12>>2];f[va+16>>2]=f[ta+16>>2];f[va+20>>2]=f[ta+20>>2];f[va+24>>2]=f[ta+24>>2];f[ta>>2]=f[e>>2];f[ta+4>>2]=f[e+4>>2];f[ta+8>>2]=f[e+8>>2];f[ta+12>>2]=f[e+12>>2];f[ta+16>>2]=f[e+16>>2];f[ta+20>>2]=f[e+20>>2];f[ta+24>>2]=f[e+24>>2];wa=ua+1|0}while(0);if(!wa){Ba=Cra(m,va,c)|0;y=va+32|0;if(Cra(y,a,c)|0){q=106;break}if(Ba){l=y;continue}}y=va;if((y-n|0)>=(b-y|0)){q=105;break}xra(m,va,c);l=va+32|0}if((q|0)==105){q=0;xra(va+32|0,a,c);g=m;a=va;continue}else if((q|0)==106){q=0;if(Ba){q=107;break}else{g=m;a=va;continue}}}if((q|0)==5){va=f[h>>2]|0;g=f[m>>2]|0;if((va|0)==(g|0)){Ba=j;j=f[Ba>>2]|0;n=f[Ba+4>>2]|0;Ba=m+8|0;wa=f[Ba>>2]|0;ua=f[Ba+4>>2]|0;if((j|0)==(wa|0)&(n|0)==(ua|0)){Ba=k;k=m+16|0;Ca=f[Ba+4>>2]|0;Da=f[k+4>>2]|0;Ea=f[Ba>>2]|0;Fa=f[k>>2]|0}else{Ca=n;Da=ua;Ea=j;Fa=wa}if(!((Ca|0)<(Da|0)|(Ca|0)==(Da|0)&Ea>>>0<Fa>>>0)){u=d;return}}else if((va|0)>=(g|0)){u=d;return};f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];u=d;return}else if((q|0)==11){zra(m,m+32|0,h,c)|0;u=d;return}else if((q|0)==12){Ara(m,m+32|0,m+64|0,h,c)|0;u=d;return}else if((q|0)==13){Bra(m,m+32|0,m+64|0,m+96|0,h,c)|0;u=d;return}else if((q|0)==15){h=m+64|0;zra(m,m+32|0,h,c)|0;c=m+96|0;if((c|0)==(a|0)){u=d;return}else{Ga=c;Ha=h}while(1){h=f[Ga>>2]|0;c=f[Ha>>2]|0;if((h|0)==(c|0)){e=Ga+8|0;g=f[e>>2]|0;va=f[e+4>>2]|0;e=Ha+8|0;Fa=f[e>>2]|0;Ea=f[e+4>>2]|0;if((g|0)==(Fa|0)&(va|0)==(Ea|0)){e=Ga+16|0;Da=Ha+16|0;Ia=f[e+4>>2]|0;Ja=f[Da+4>>2]|0;Ka=f[e>>2]|0;La=f[Da>>2]|0}else{Ia=va;Ja=Ea;Ka=g;La=Fa}if((Ia|0)<(Ja|0)|(Ia|0)==(Ja|0)&Ka>>>0<La>>>0){Ma=g;Na=va;q=22}}else if((h|0)<(c|0)){c=Ga+8|0;Ma=f[c>>2]|0;Na=f[c+4>>2]|0;q=22}if((q|0)==22){q=0;c=f[Ga+4>>2]|0;va=Ga+16|0;g=f[va>>2]|0;Fa=f[va+4>>2]|0;va=f[Ga+24>>2]|0;f[Ga>>2]=f[Ha>>2];f[Ga+4>>2]=f[Ha+4>>2];f[Ga+8>>2]=f[Ha+8>>2];f[Ga+12>>2]=f[Ha+12>>2];f[Ga+16>>2]=f[Ha+16>>2];f[Ga+20>>2]=f[Ha+20>>2];f[Ga+24>>2]=f[Ha+24>>2];d:do if((Ha|0)==(m|0))Oa=m;else{Ea=Ha;while(1){Da=Ea;Ea=Ea+-32|0;e=f[Ea>>2]|0;if((h|0)==(e|0)){Ca=Da+-24|0;wa=f[Ca>>2]|0;j=f[Ca+4>>2]|0;if((Ma|0)==(wa|0)&(Na|0)==(j|0)){Ca=Da+-16|0;Pa=Fa;Qa=f[Ca+4>>2]|0;Ra=g;Sa=f[Ca>>2]|0}else{Pa=Na;Qa=j;Ra=Ma;Sa=wa}if(!((Pa|0)<(Qa|0)|(Pa|0)==(Qa|0)&Ra>>>0<Sa>>>0)){Oa=Da;break d}}else if((h|0)>=(e|0)){Oa=Da;break d};f[Da>>2]=f[Ea>>2];f[Da+4>>2]=f[Ea+4>>2];f[Da+8>>2]=f[Ea+8>>2];f[Da+12>>2]=f[Ea+12>>2];f[Da+16>>2]=f[Ea+16>>2];f[Da+20>>2]=f[Ea+20>>2];f[Da+24>>2]=f[Ea+24>>2];if((Ea|0)==(m|0)){Oa=m;break}}}while(0);f[Oa>>2]=h;f[Oa+4>>2]=c;Ea=Oa+8|0;f[Ea>>2]=Ma;f[Ea+4>>2]=Na;Ea=Oa+16|0;f[Ea>>2]=g;f[Ea+4>>2]=Fa;f[Oa+24>>2]=va}Ea=Ga+32|0;if((Ea|0)==(a|0))break;else{Da=Ga;Ga=Ea;Ha=Da}}u=d;return}else if((q|0)==107){u=d;return}}function yra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>5;h=g+1|0;if(h>>>0>134217727)kWc(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>4;l=j>>5>>>0<67108863?(k>>>0<h>>>0?h:k):134217727;do if(l)if(l>>>0>134217727){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l<<5)|0;break}else m=0;while(0);k=m+(g<<5)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];b=k+(0-g<<5)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+32;f[i>>2]=m+(l<<5);if(!d)return;cYc(d);return}function zra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+32|0;e=d;g=f[b>>2]|0;h=f[a>>2]|0;if((g|0)==(h|0)){i=b+8|0;j=f[i>>2]|0;k=f[i+4>>2]|0;i=a+8|0;l=f[i>>2]|0;m=f[i+4>>2]|0;if((j|0)==(l|0)&(k|0)==(m|0)){i=b+16|0;n=a+16|0;o=f[i+4>>2]|0;p=f[n+4>>2]|0;q=f[i>>2]|0;r=f[n>>2]|0}else{o=k;p=m;q=j;r=l}s=(o|0)<(p|0)|(o|0)==(p|0)&q>>>0<r>>>0}else s=(g|0)<(h|0);h=f[c>>2]|0;if((h|0)==(g|0)){r=c+8|0;q=f[r>>2]|0;p=f[r+4>>2]|0;r=b+8|0;o=f[r>>2]|0;l=f[r+4>>2]|0;if((q|0)==(o|0)&(p|0)==(l|0)){r=c+16|0;j=b+16|0;t=f[r+4>>2]|0;v=f[j+4>>2]|0;w=f[r>>2]|0;x=f[j>>2]|0}else{t=p;v=l;w=q;x=o}y=(t|0)<(v|0)|(t|0)==(v|0)&w>>>0<x>>>0}else y=(h|0)<(g|0);if(!s){if(!y){z=0;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];s=f[b>>2]|0;g=f[a>>2]|0;if((s|0)==(g|0)){h=b+8|0;x=f[h>>2]|0;w=f[h+4>>2]|0;h=a+8|0;v=f[h>>2]|0;t=f[h+4>>2]|0;if((x|0)==(v|0)&(w|0)==(t|0)){h=b+16|0;o=a+16|0;A=f[h+4>>2]|0;B=f[o+4>>2]|0;C=f[h>>2]|0;D=f[o>>2]|0}else{A=w;B=t;C=x;D=v}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){z=1;u=d;return z|0}}else if((s|0)>=(g|0)){z=1;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];z=2;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];if(y){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=1;u=d;return z|0};f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];a=f[c>>2]|0;y=f[b>>2]|0;if((a|0)==(y|0)){g=c+8|0;s=f[g>>2]|0;D=f[g+4>>2]|0;g=b+8|0;C=f[g>>2]|0;B=f[g+4>>2]|0;if((s|0)==(C|0)&(D|0)==(B|0)){g=c+16|0;A=b+16|0;E=f[g+4>>2]|0;F=f[A+4>>2]|0;G=f[g>>2]|0;H=f[A>>2]|0}else{E=D;F=B;G=s;H=C}if(!((E|0)<(F|0)|(E|0)==(F|0)&G>>>0<H>>>0)){z=1;u=d;return z|0}}else if((a|0)>=(y|0)){z=1;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=2;u=d;return z|0}function Ara(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+32|0;h=g;i=zra(a,b,c,e)|0;e=f[d>>2]|0;j=f[c>>2]|0;if((e|0)==(j|0)){k=d+8|0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c+8|0;n=f[k>>2]|0;o=f[k+4>>2]|0;if((l|0)==(n|0)&(m|0)==(o|0)){k=d+16|0;p=c+16|0;q=f[k+4>>2]|0;r=f[p+4>>2]|0;s=f[k>>2]|0;t=f[p>>2]|0}else{q=m;r=o;s=l;t=n}if(!((q|0)<(r|0)|(q|0)==(r|0)&s>>>0<t>>>0)){v=i;u=g;return v|0}}else if((e|0)>=(j|0)){v=i;u=g;return v|0};f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[h+8>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];f[d+8>>2]=f[h+8>>2];f[d+12>>2]=f[h+12>>2];f[d+16>>2]=f[h+16>>2];f[d+20>>2]=f[h+20>>2];f[d+24>>2]=f[h+24>>2];d=i+1|0;j=f[c>>2]|0;e=f[b>>2]|0;if((j|0)==(e|0)){t=c+8|0;s=f[t>>2]|0;r=f[t+4>>2]|0;t=b+8|0;q=f[t>>2]|0;n=f[t+4>>2]|0;if((s|0)==(q|0)&(r|0)==(n|0)){t=c+16|0;l=b+16|0;w=f[t+4>>2]|0;x=f[l+4>>2]|0;y=f[t>>2]|0;z=f[l>>2]|0}else{w=r;x=n;y=s;z=q}if(!((w|0)<(x|0)|(w|0)==(x|0)&y>>>0<z>>>0)){v=d;u=g;return v|0}}else if((j|0)>=(e|0)){v=d;u=g;return v|0};f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[h+8>>2]=f[b+8>>2];f[h+12>>2]=f[b+12>>2];f[h+16>>2]=f[b+16>>2];f[h+20>>2]=f[b+20>>2];f[h+24>>2]=f[b+24>>2];f[h+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];c=i+2|0;d=f[b>>2]|0;e=f[a>>2]|0;if((d|0)==(e|0)){j=b+8|0;z=f[j>>2]|0;y=f[j+4>>2]|0;j=a+8|0;x=f[j>>2]|0;w=f[j+4>>2]|0;if((z|0)==(x|0)&(y|0)==(w|0)){j=b+16|0;q=a+16|0;A=f[j+4>>2]|0;B=f[q+4>>2]|0;C=f[j>>2]|0;D=f[q>>2]|0}else{A=y;B=w;C=z;D=x}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){v=c;u=g;return v|0}}else if((d|0)>=(e|0)){v=c;u=g;return v|0};f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[h>>2];f[b+4>>2]=f[h+4>>2];f[b+8>>2]=f[h+8>>2];f[b+12>>2]=f[h+12>>2];f[b+16>>2]=f[h+16>>2];f[b+20>>2]=f[h+20>>2];f[b+24>>2]=f[h+24>>2];v=i+3|0;u=g;return v|0}function Bra(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+32|0;i=h;j=Ara(a,b,c,d,g)|0;g=f[e>>2]|0;k=f[d>>2]|0;if((g|0)==(k|0)){l=e+8|0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=d+8|0;o=f[l>>2]|0;p=f[l+4>>2]|0;if((m|0)==(o|0)&(n|0)==(p|0)){l=e+16|0;q=d+16|0;r=f[l+4>>2]|0;s=f[q+4>>2]|0;t=f[l>>2]|0;v=f[q>>2]|0}else{r=n;s=p;t=m;v=o}if(!((r|0)<(s|0)|(r|0)==(s|0)&t>>>0<v>>>0)){w=j;u=h;return w|0}}else if((g|0)>=(k|0)){w=j;u=h;return w|0};f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[d+16>>2]=f[e+16>>2];f[d+20>>2]=f[e+20>>2];f[d+24>>2]=f[e+24>>2];f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];e=j+1|0;k=f[d>>2]|0;g=f[c>>2]|0;if((k|0)==(g|0)){v=d+8|0;t=f[v>>2]|0;s=f[v+4>>2]|0;v=c+8|0;r=f[v>>2]|0;o=f[v+4>>2]|0;if((t|0)==(r|0)&(s|0)==(o|0)){v=d+16|0;m=c+16|0;x=f[v+4>>2]|0;y=f[m+4>>2]|0;z=f[v>>2]|0;A=f[m>>2]|0}else{x=s;y=o;z=t;A=r}if(!((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0)){w=e;u=h;return w|0}}else if((k|0)>=(g|0)){w=e;u=h;return w|0};f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];f[d+8>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];f[d+16>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];d=j+2|0;e=f[c>>2]|0;g=f[b>>2]|0;if((e|0)==(g|0)){k=c+8|0;A=f[k>>2]|0;z=f[k+4>>2]|0;k=b+8|0;y=f[k>>2]|0;x=f[k+4>>2]|0;if((A|0)==(y|0)&(z|0)==(x|0)){k=c+16|0;r=b+16|0;B=f[k+4>>2]|0;C=f[r+4>>2]|0;D=f[k>>2]|0;E=f[r>>2]|0}else{B=z;C=x;D=A;E=y}if(!((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0)){w=d;u=h;return w|0}}else if((e|0)>=(g|0)){w=d;u=h;return w|0};f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];f[i+16>>2]=f[b+16>>2];f[i+20>>2]=f[b+20>>2];f[i+24>>2]=f[b+24>>2];f[i+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];c=j+3|0;d=f[b>>2]|0;g=f[a>>2]|0;if((d|0)==(g|0)){e=b+8|0;E=f[e>>2]|0;D=f[e+4>>2]|0;e=a+8|0;C=f[e>>2]|0;B=f[e+4>>2]|0;if((E|0)==(C|0)&(D|0)==(B|0)){e=b+16|0;y=a+16|0;F=f[e+4>>2]|0;G=f[y+4>>2]|0;H=f[e>>2]|0;I=f[y>>2]|0}else{F=D;G=B;H=E;I=C}if(!((F|0)<(G|0)|(F|0)==(G|0)&H>>>0<I>>>0)){w=c;u=h;return w|0}}else if((d|0)>=(g|0)){w=c;u=h;return w|0};f[i>>2]=f[a>>2];f[i+4>>2]=f[a+4>>2];f[i+8>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[i>>2];f[b+4>>2]=f[i+4>>2];f[b+8>>2]=f[i+8>>2];f[b+12>>2]=f[i+12>>2];f[b+16>>2]=f[i+16>>2];f[b+20>>2]=f[i+20>>2];f[b+24>>2]=f[i+24>>2];w=j+4|0;u=h;return w|0}function Cra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+32|0;e=d;switch(b-a>>5|0){case 2:{g=b+-32|0;h=f[g>>2]|0;i=f[a>>2]|0;if((h|0)==(i|0)){j=b+-24|0;k=f[j>>2]|0;l=f[j+4>>2]|0;j=a+8|0;m=f[j>>2]|0;n=f[j+4>>2]|0;if((k|0)==(m|0)&(l|0)==(n|0)){j=b+-16|0;o=a+16|0;p=f[j+4>>2]|0;q=f[o+4>>2]|0;r=f[j>>2]|0;s=f[o>>2]|0}else{p=l;q=n;r=k;s=m}if(!((p|0)<(q|0)|(p|0)==(q|0)&r>>>0<s>>>0)){t=1;u=d;return t|0}}else if((h|0)>=(i|0)){t=1;u=d;return t|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[a+20>>2]=f[g+20>>2];f[a+24>>2]=f[g+24>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];t=1;u=d;return t|0}case 3:{zra(a,a+32|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 4:{Ara(a,a+32|0,a+64|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 5:{Bra(a,a+32|0,a+64|0,a+96|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 1:case 0:{t=1;u=d;return t|0}default:{g=a+64|0;zra(a,a+32|0,g,c)|0;c=a+96|0;a:do if((c|0)==(b|0)){v=1;w=0}else{i=c;h=0;s=g;while(1){r=f[i>>2]|0;q=f[s>>2]|0;if((r|0)==(q|0)){p=i+8|0;m=f[p>>2]|0;k=f[p+4>>2]|0;p=s+8|0;n=f[p>>2]|0;l=f[p+4>>2]|0;if((m|0)==(n|0)&(k|0)==(l|0)){p=i+16|0;o=s+16|0;x=f[p+4>>2]|0;y=f[o+4>>2]|0;z=f[p>>2]|0;A=f[o>>2]|0}else{x=k;y=l;z=m;A=n}if((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0){B=m;C=k;D=19}else E=h}else if((r|0)<(q|0)){q=i+8|0;B=f[q>>2]|0;C=f[q+4>>2]|0;D=19}else E=h;if((D|0)==19){D=0;q=f[i+4>>2]|0;k=i+16|0;m=f[k>>2]|0;n=f[k+4>>2]|0;k=i+24|0;l=f[k+4>>2]|0;o=e;f[o>>2]=f[k>>2];f[o+4>>2]=l;f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[i+8>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];b:do if((s|0)==(a|0))F=a;else{l=s;while(1){o=l;l=l+-32|0;k=f[l>>2]|0;if((r|0)==(k|0)){p=o+-24|0;j=f[p>>2]|0;G=f[p+4>>2]|0;if((B|0)==(j|0)&(C|0)==(G|0)){p=o+-16|0;H=n;I=f[p+4>>2]|0;J=m;K=f[p>>2]|0}else{H=C;I=G;J=B;K=j}if(!((H|0)<(I|0)|(H|0)==(I|0)&J>>>0<K>>>0)){F=o;break b}}else if((r|0)>=(k|0)){F=o;break b};f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];if((l|0)==(a|0)){F=a;break}}}while(0);f[F>>2]=r;f[F+4>>2]=q;l=F+8|0;f[l>>2]=B;f[l+4>>2]=C;l=F+16|0;f[l>>2]=m;f[l+4>>2]=n;f[F+24>>2]=f[e>>2];l=h+1|0;if((l|0)==8){v=0;w=(i+32|0)==(b|0);break a}else E=l}l=i+32|0;if((l|0)==(b|0)){v=1;w=0;break}else{o=i;i=l;h=E;s=o}}}while(0);t=w|v;u=d;return t|0}}return 0}function Dra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>5>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>134217727){g=af(8)|0;hYc(g,512536);f[g>>2]=192348;ig(g|0,25336,2140)}g=(f[e>>2]|0)-d|0;h=g>>5;i=$Xc(b<<5)|0;j=i+(h<<5)|0;k=j+(0-h<<5)|0;if((g|0)>0)o1c(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<5);if(!d)return;cYc(d);return}function Era(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;j=u;u=u+160|0;k=j+96|0;l=j+64|0;m=j;do if((eS(a)|0)==65536){n=f[a+4>>2]|0;f[k>>2]=f[n>>2];o=k+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[n+8>>2];f[k+12>>2]=f[n+12>>2];f[k+16>>2]=f[n+16>>2];f[k+20>>2]=f[n+20>>2];f[k+24>>2]=f[n+24>>2];f[k+28>>2]=f[n+28>>2];f[k+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;s=k+44|0;f[s>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;U$(k,n);break}}else bS(k,a,-1);while(0);if((h|0)==16)t=(f[k>>2]&7|0)==0?16:8;else t=h;if((g|0)>=32768){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;h=$Xc(32)|0;f[l>>2]=h;f[l+8>>2]=-2147483616;f[l+4>>2]=26;v=h;w=273452;x=v+26|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[h+26>>0]=0;vM(-215,l,273479,273208,1850)}if(i>>>0>=17){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;h=$Xc(32)|0;f[l>>2]=h;f[l+8>>2]=-2147483616;f[l+4>>2]=31;v=h;w=273329;x=v+31|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));b[h+31>>0]=0;vM(-215,l,273479,273208,1851)}q3(e,l,f[k>>2]&4095,0);e=f[c>>2]|0;h=((e|0)<0)<<31>>31;w=f[c+4>>2]|0;c=((w|0)<0)<<31>>31;v=m;f[v>>2]=e;f[v+4>>2]=h;v=m+8|0;f[v>>2]=w;f[v+4>>2]=c;v=f[d>>2]|0;x=((v|0)<0)<<31>>31;a=m+16|0;f[a>>2]=v;f[a+4>>2]=x;a=m+24|0;f[a>>2]=w;f[a+4>>2]=c;c=f[d+4>>2]|0;d=((c|0)<0)<<31>>31;a=m+32|0;f[a>>2]=v;f[a+4>>2]=x;x=m+40|0;f[x>>2]=c;f[x+4>>2]=d;x=m+48|0;f[x>>2]=e;f[x+4>>2]=h;h=m+56|0;f[h>>2]=c;f[h+4>>2]=d;if((g|0)>-1)ura(k,m,4,1,l,g,t,i);else pra(k,m,4,l,t,i);i=k+36|0;t=f[i>>2]|0;if(t|0?(l=t+12|0,t=f[l>>2]|0,f[l>>2]=t+-1,(t|0)==1):0)V$(k);f[i>>2]=0;i=k+16|0;t=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[t>>2]|0)>0){i=f[k+40>>2]|0;l=0;do{f[i+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[t>>2]|0))}t=f[k+44>>2]|0;if((t|0)==(k+48|0)){u=j;return}wL(t);u=j;return}function Fra(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h+8|0;j=h;k=f[b+8>>2]|0;if((k|0)<1){u=h;return}l=f[b+12>>2]|0;if((l|0)<1){u=h;return}m=f[b>>2]|0;n=f[b+4>>2]|0;f[i>>2]=m;f[i+4>>2]=n;b=-1<<g;f[j>>2]=m+b+k;f[j+4>>2]=n+b+l;Era(a,i,j,c,d,e,g);u=h;return}function Gra(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;j=u;u=u+128|0;k=j+72|0;l=j+32|0;m=j+16|0;n=j;o=j+64|0;do if((eS(a)|0)==65536){p=f[a+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;f[k+40>>2]=s;s=k+48|0;v=k+44|0;f[v>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;U$(k,p);break}}else bS(k,a,-1);while(0);if((h|0)==16)w=(f[k>>2]&7|0)==0?16:8;else w=h;if(!((i|0)<17&((g|0)<32768&(i|d|0)>-1))){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;h=$Xc(80)|0;f[l>>2]=h;f[l+8>>2]=-2147483568;f[l+4>>2]=76;a=h;p=273489;q=a+76|0;do{b[a>>0]=b[p>>0]|0;a=a+1|0;p=p+1|0}while((a|0)<(q|0));b[h+76>>0]=0;vM(-215,l,273566,273208,1895)}q3(e,l,f[k>>2]&4095,0);if((i|0)>0|((g|0)>1|(w|0)!=8)){e=f[c>>2]|0;h=f[c+4>>2]|0;p=16-i|0;i=u1c(e|0,((e|0)<0)<<31>>31|0,p|0)|0;e=J;a=u1c(h|0,((h|0)<0)<<31>>31|0,p|0)|0;h=J;q=u1c(d|0,((d|0)<0)<<31>>31|0,p|0)|0;p=J;r=m;f[r>>2]=i;f[r+4>>2]=e;e=m+8|0;f[e>>2]=a;f[e+4>>2]=h;h=n;f[h>>2]=q;f[h+4>>2]=p;h=n+8|0;f[h>>2]=q;f[h+4>>2]=p;rra(k,m,n,0,0,360,l,g,w)}else{f[o>>2]=f[c>>2];f[o+4>>2]=f[c+4>>2];qra(k,o,d,l,g>>>31)}g=k+36|0;l=f[g>>2]|0;if(l|0?(d=l+12|0,l=f[d>>2]|0,f[d>>2]=l+-1,(l|0)==1):0)V$(k);f[g>>2]=0;g=k+16|0;l=k+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[l>>2]|0)>0){g=f[k+40>>2]|0;d=0;do{f[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)==(k+48|0)){u=j;return}wL(l);u=j;return}function Hra(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+128|0;n=m+64|0;o=m+32|0;p=m+16|0;q=m;do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[n>>2]=f[r>>2];s=n+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=n+8|0;f[v>>2]=f[r+8>>2];f[n+12>>2]=f[r+12>>2];f[n+16>>2]=f[r+16>>2];f[n+20>>2]=f[r+20>>2];f[n+24>>2]=f[r+24>>2];f[n+28>>2]=f[r+28>>2];f[n+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[n+36>>2]=w;f[n+40>>2]=v;v=n+48|0;x=n+44|0;f[x>>2]=v;f[v>>2]=0;f[n+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;U$(n,r);break}}else bS(n,a,-1);while(0);if((k|0)==16)y=(f[n>>2]&7|0)==0?16:8;else y=k;if((f[d>>2]|0)<=-1){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;z=$Xc(112)|0;f[o>>2]=z;A=o+8|0;f[A>>2]=-2147483536;B=o+4|0;f[B>>2]=100;C=z;D=273573;E=C+100|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+100|0;b[F>>0]=0;vM(-215,o,273674,273208,1927)}k=d+4|0;if(!((l|0)<17&((j|0)<32768?(f[k>>2]|l|0)>-1:0))){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;z=$Xc(112)|0;f[o>>2]=z;A=o+8|0;f[A>>2]=-2147483536;B=o+4|0;f[B>>2]=100;C=z;D=273573;E=C+100|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));F=z+100|0;b[F>>0]=0;vM(-215,o,273674,273208,1927)}q3(i,o,f[n>>2]&4095,0);i=zLc(e)|0;F=zLc(g)|0;z=zLc(h)|0;D=f[c>>2]|0;C=f[c+4>>2]|0;c=f[d>>2]|0;d=f[k>>2]|0;k=16-l|0;l=u1c(D|0,((D|0)<0)<<31>>31|0,k|0)|0;D=J;E=u1c(C|0,((C|0)<0)<<31>>31|0,k|0)|0;C=J;B=u1c(c|0,((c|0)<0)<<31>>31|0,k|0)|0;c=J;A=u1c(d|0,((d|0)<0)<<31>>31|0,k|0)|0;k=p;f[k>>2]=l;f[k+4>>2]=D;D=p+8|0;f[D>>2]=E;f[D+4>>2]=C;C=q;f[C>>2]=B;f[C+4>>2]=c;c=q+8|0;f[c>>2]=A;f[c+4>>2]=J;rra(n,p,q,i,F,z,o,j,y);y=n+36|0;j=f[y>>2]|0;if(j|0?(o=j+12|0,j=f[o>>2]|0,f[o>>2]=j+-1,(j|0)==1):0)V$(n);f[y>>2]=0;y=n+16|0;j=n+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){y=f[n+40>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}j=f[n+44>>2]|0;if((j|0)==(n+48|0)){u=m;return}wL(j);u=m;return}function Ira(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0;h=u;u=u+128|0;i=h+64|0;j=h+32|0;k=h+16|0;l=h;do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[i>>2]=f[m>>2];o=i+4|0;p=m+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[m+8>>2];f[i+12>>2]=f[m+12>>2];f[i+16>>2]=f[m+16>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[m+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;U$(i,m);break}}else bS(i,a,-1);while(0);if((g|0)==16)t=(f[i>>2]&7|0)==0?16:8;else t=g;g=c+8|0;if(!(+n[g>>2]>=0.0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=$Xc(80)|0;f[j>>2]=v;w=j+8|0;f[w>>2]=-2147483568;x=j+4|0;f[x>>2]=73;y=v;z=273682;A=y+73|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));B=v+73|0;b[B>>0]=0;vM(-215,j,273674,273208,1957)}a=c+12|0;if(!((e|0)<32768&+n[a>>2]>=0.0)){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;v=$Xc(80)|0;f[j>>2]=v;w=j+8|0;f[w>>2]=-2147483568;x=j+4|0;f[x>>2]=73;y=v;z=273682;A=y+73|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));B=v+73|0;b[B>>0]=0;vM(-215,j,273674,273208,1957)}q3(d,j,f[i>>2]&4095,0);d=ALc(+n[c+16>>2])|0;C=+n[c>>2];B=ALc(C)|0;D=+n[c+4>>2];c=ALc(D)|0;v=u1c(B|0,((B|0)<0)<<31>>31|0,16)|0;z=J;y=ALc((C-+(B|0))*65536.0)|0;B=d1c(y|0,((y|0)<0)<<31>>31|0,v|0,z|0)|0;z=J;v=u1c(c|0,((c|0)<0)<<31>>31|0,16)|0;y=J;A=ALc((D-+(c|0))*65536.0)|0;c=d1c(A|0,((A|0)<0)<<31>>31|0,v|0,y|0)|0;y=J;D=+n[g>>2];g=ALc(D)|0;C=+n[a>>2];a=ALc(C)|0;v=u1c(g|0,((g|0)<0)<<31>>31|0,15)|0;A=J;x=ALc((D-+(g|0))*32768.0)|0;g=d1c(x|0,((x|0)<0)<<31>>31|0,v|0,A|0)|0;A=J;v=u1c(a|0,((a|0)<0)<<31>>31|0,15)|0;x=J;w=ALc((C-+(a|0))*32768.0)|0;a=d1c(w|0,((w|0)<0)<<31>>31|0,v|0,x|0)|0;x=k;f[x>>2]=B;f[x+4>>2]=z;z=k+8|0;f[z>>2]=c;f[z+4>>2]=y;y=l;f[y>>2]=g;f[y+4>>2]=A;A=l+8|0;f[A>>2]=a;f[A+4>>2]=J;rra(i,k,l,d,0,360,j,e,t);t=i+36|0;e=f[t>>2]|0;if(e|0?(j=e+12|0,e=f[j>>2]|0,f[j>>2]=e+-1,(e|0)==1):0)V$(i);f[t>>2]=0;t=i+16|0;e=i+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[e>>2]|0)>0){t=f[i+40>>2]|0;j=0;do{f[t+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[e>>2]|0))}e=f[i+44>>2]|0;if((e|0)==(i+48|0)){u=h;return}wL(e);u=h;return}function Jra(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;m=u;u=u+128|0;n=m+16|0;o=m+72|0;p=m+56|0;q=m+52|0;r=m+48|0;s=m;t=c+11|0;v=b[t>>0]|0;w=c+4|0;if(!((v<<24>>24<0?f[w>>2]|0:v&255)|0)){u=m;return}do if((eS(a)|0)==65536){v=f[a+4>>2]|0;f[o>>2]=f[v>>2];x=o+4|0;y=v+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[v+8>>2];f[o+12>>2]=f[v+12>>2];f[o+16>>2]=f[v+16>>2];f[o+20>>2]=f[v+20>>2];f[o+24>>2]=f[v+24>>2];f[o+28>>2]=f[v+28>>2];f[o+32>>2]=f[v+32>>2];A=f[v+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;B=o+44|0;f[B>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[v+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;U$(o,v);break}}else bS(o,a,-1);while(0);a=(e&16|0)!=0;switch(e&15){case 0:{C=60156;break}case 1:{C=a?55676:56060;break}case 2:{C=59772;break}case 3:{C=a?56444:56828;break}case 4:{C=a?57468:57852;break}case 5:{C=a?58236:58620;break}case 6:{C=59388;break}case 7:{C=59004;break}default:{a=$Xc(32)|0;f[n>>2]=a;f[n+8>>2]=-2147483616;f[n+4>>2]=17;v=a;x=273756;y=v+17|0;do{b[v>>0]=b[x>>0]|0;v=v+1|0;x=x+1|0}while((v|0)<(y|0));b[a+17>>0]=0;vM(-211,n,273774,273208,2215)}}q3(i,n,f[o>>2]&4095,0);i=0-(f[C>>2]&15)|0;a=zLc(g*65536.0)|0;if((k|0)==16)D=(f[o>>2]&7|0)==0?16:8;else D=k;k=l?0-a|0:a;l=f[d>>2]|0;x=f[d+4>>2]|0;d=u1c(x|0,((x|0)<0)<<31>>31|0,16)|0;x=Y(k,i)|0;i=d1c(d|0,J|0,x|0,((x|0)<0)<<31>>31|0)|0;x=J;f[p>>2]=0;d=p+4|0;f[d>>2]=0;f[p+8>>2]=0;v=p+8|0;y=$Xc(16384)|0;z=y;f[p>>2]=z;f[d>>2]=z;f[v>>2]=y+16384;f[q>>2]=0;z=b[t>>0]|0;if(((z<<24>>24<0?f[w>>2]|0:z&255)|0)>0){B=u1c(l|0,((l|0)<0)<<31>>31|0,16)|0;l=((a|0)<0)<<31>>31;A=((k|0)<0)<<31>>31;E=s+8|0;F=z;z=0;G=B;B=J;while(1){f[r>>2]=h[(F<<24>>24<0?f[c>>2]|0:c)+z>>0];Kra(r,q,c,e);H=f[62048+(f[C+((f[r>>2]|0)+-31<<2)>>2]<<2)>>2]|0;I=(h[H>>0]|0)+-82|0;K=(h[H+1>>0]|0)+-82|0;L=x1c(K|0,((K|0)<0)<<31>>31|0,a|0,l|0)|0;K=J;M=x1c(I|0,((I|0)<0)<<31>>31|0,a|0,l|0)|0;I=c1c(G|0,B|0,M|0,J|0)|0;M=J;N=f[d>>2]|0;O=f[p>>2]|0;P=N;if(!((N|0)==(O|0)|(P|0)==(O|0)))f[d>>2]=P+(~((P+-16-O|0)>>>4)<<4);O=H+2|0;a:while(1){H=b[O>>0]|0;switch(H<<24>>24){case 0:case 32:break;default:{P=(H&255)+-82|0;N=(h[O+1>>0]|0)+-82|0;Q=d1c(x1c(P|0,((P|0)<0)<<31>>31|0,a|0,l|0)|0,J|0,I|0,M|0)|0;P=J;R=d1c(i|0,x|0,x1c(N|0,((N|0)<0)<<31>>31|0,k|0,A|0)|0,J|0)|0;N=s;f[N>>2]=Q;f[N+4>>2]=P;N=E;f[N>>2]=R;f[N+4>>2]=J;N=f[d>>2]|0;if(N>>>0<(f[v>>2]|0)>>>0){R=N;f[R>>2]=Q;f[R+4>>2]=P;P=E;R=f[P+4>>2]|0;Q=N+8|0;f[Q>>2]=f[P>>2];f[Q+4>>2]=R;f[d>>2]=N+16}else Lra(p,s);O=O+2|0;continue a}}N=f[p>>2]|0;R=(f[d>>2]|0)-N>>4;if(R>>>0>1){ura(o,N,R,0,n,j,D,16);S=b[O>>0]|0}else S=H;if(!(S<<24>>24))break;H=O+1|0;R=f[d>>2]|0;N=f[p>>2]|0;Q=R;if((R|0)==(N|0)|(Q|0)==(N|0)){O=H;continue}f[d>>2]=Q+(~((Q+-16-N|0)>>>4)<<4);O=H}G=d1c(I|0,M|0,L|0,K|0)|0;z=(f[q>>2]|0)+1|0;f[q>>2]=z;F=b[t>>0]|0;if((z|0)>=((F<<24>>24<0?f[w>>2]|0:F&255)|0))break;else B=J}B=f[p>>2]|0;if(B|0){T=B;U=B;V=24}}else{T=y;U=y;V=24}if((V|0)==24){V=f[d>>2]|0;if((V|0)!=(T|0))f[d>>2]=V+(~((V+-16-T|0)>>>4)<<4);cYc(U)}U=o+36|0;T=f[U>>2]|0;if(T|0?(V=T+12|0,T=f[V>>2]|0,f[V>>2]=T+-1,(T|0)==1):0)V$(o);f[U>>2]=0;U=o+16|0;T=o+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[T>>2]|0)>0){U=f[o+40>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[T>>2]|0))}T=f[o+44>>2]|0;if((T|0)!=(o+48|0))wL(T);u=m;return}function Kra(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;if((e|0)==3&(g|0)>127){switch(g|0){case 208:{e=(f[c>>2]|0)+1|0;i=(b[d+11>>0]|0)<0;if(((b[(i?f[d>>2]|0:d)+e>>0]|0)+112&255)<48){f[c>>2]=e;j=175;k=127;l=(h[(i?f[d>>2]|0:d)+e>>0]|0)+-17|0}else m=8;break}case 209:{e=(f[c>>2]|0)+1|0;i=(b[d+11>>0]|0)<0;n=b[(i?f[d>>2]|0:d)+e>>0]|0;if(n<<24>>24<0&(n&255)<144){f[c>>2]=e;j=191;k=175;l=(h[(i?f[d>>2]|0:d)+e>>0]|0)+47|0}else m=8;break}default:if((g|0)>191)m=8;else{j=127;k=32;l=63}}if((m|0)==8){m=(f[c>>2]|0)+1|0;if(!(b[((b[d+11>>0]|0)<0?f[d>>2]|0:d)+m>>0]|0))o=g;else{f[c>>2]=m;o=f[a>>2]|0}if((o|0)>223){m=f[c>>2]|0;e=m+1|0;i=(b[d+11>>0]|0)<0;if(!(b[(i?f[d>>2]|0:d)+e>>0]|0)){p=o;q=m}else{f[c>>2]=e;p=f[a>>2]|0;q=e}if((p|0)>239){e=q+1|0;if(!(b[(i?f[d>>2]|0:d)+e>>0]|0)){r=p;s=q}else{f[c>>2]=e;r=f[a>>2]|0;s=e}if((r|0)>247){e=s+1|0;if(!(b[(i?f[d>>2]|0:d)+e>>0]|0)){t=r;u=s}else{f[c>>2]=e;t=f[a>>2]|0;u=e}if((t|0)>251?(t=u+1|0,(b[(i?f[d>>2]|0:d)+t>>0]|0)!=0):0){f[c>>2]=t;j=127;k=32;l=63}else{j=127;k=32;l=63}}else{j=127;k=32;l=63}}else{j=127;k=32;l=63}}else{j=127;k=32;l=63}}f[a>>2]=l;v=j;w=k;x=l}else{v=127;w=32;x=g}if(!((x|0)>=(v|0)|(x|0)<(w|0)))return;f[a>>2]=63;return}function Lra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;m=b;k=f[m+4>>2]|0;o=l;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=b+8|0;b=f[k+4>>2]|0;o=n+(g<<4)+8|0;f[o>>2]=f[k>>2];f[o+4>>2]=b;b=l+16|0;if((j|0)==(i|0))p=l;else{o=j+-16-e|0;k=j;j=l;while(1){g=k;k=k+-16|0;n=k;m=f[n+4>>2]|0;q=j+-16|0;f[q>>2]=f[n>>2];f[q+4>>2]=m;m=g+-8|0;g=f[m+4>>2]|0;q=j+-8|0;f[q>>2]=f[m>>2];f[q+4>>2]=g;if((k|0)==(i|0))break;else j=j+-16|0}p=l+(~(o>>>4)<<4)|0}f[a>>2]=p;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function Mra(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0;l=u;u=u+368|0;m=l+304|0;n=l+96|0;o=l+64|0;q=l+248|0;r=l+192|0;s=l+160|0;t=l+148|0;v=l+136|0;w=l+32|0;x=l;y=l+128|0;do if((eS(a)|0)==65536){z=f[a+4>>2]|0;f[q>>2]=f[z>>2];A=q+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=q+8|0;f[C>>2]=f[z+8>>2];f[q+12>>2]=f[z+12>>2];f[q+16>>2]=f[z+16>>2];f[q+20>>2]=f[z+20>>2];f[q+24>>2]=f[z+24>>2];f[q+28>>2]=f[z+28>>2];f[q+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[q+36>>2]=D;f[q+40>>2]=C;C=q+48|0;E=q+44|0;f[E>>2]=C;f[C>>2]=0;f[q+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;U$(q,z);break}}else bS(q,a,-1);while(0);do if((eS(i)|0)==65536){a=f[i+4>>2]|0;f[r>>2]=f[a>>2];z=r+4|0;A=a+4|0;f[z>>2]=f[A>>2];B=r+8|0;f[B>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];C=f[a+36>>2]|0;f[r+36>>2]=C;f[r+40>>2]=B;B=r+48|0;E=r+44|0;f[E>>2]=B;f[B>>2]=0;f[r+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[a+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;U$(r,a);break}}else bS(r,i,-1);while(0);i=f[q+8>>2]|0;a=q+4|0;z=(f[a>>2]|0)==1?1:f[q+12>>2]|0;A=f[q>>2]|0;B=q+16|0;E=f[B>>2]|0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=E;f[s+20>>2]=i;f[s+24>>2]=z;z=q+44|0;f[s+4>>2]=f[f[z>>2]>>2];f[s>>2]=A&20479|1111621632;A=pS(c,-1)|0;f[t>>2]=0;i=t+4|0;f[i>>2]=0;f[t+8>>2]=0;f[v>>2]=0;E=v+4|0;f[E>>2]=0;f[v+8>>2]=0;if(A|0){Nra(t,A);C=f[E>>2]|0;D=f[v>>2]|0;F=(C-D|0)/20|0;G=D;D=C;if(A>>>0<=F>>>0){if(A>>>0<F>>>0?(C=G+(A*20|0)|0,(D|0)!=(C|0)):0)f[E>>2]=D+(~(((D+-20-C|0)>>>0)/20|0)*20|0)}else Ora(v,A-F|0);F=f[t>>2]|0;C=0;do{f[F+(C*56|0)+52>>2]=0;C=C+1|0}while((C|0)!=(A|0));C=(d|0)>-1;do if(C)if((A|0)>(d|0)){H=d;I=d+1|0;J=28;break}else{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;F=$Xc(48)|0;f[m>>2]=F;f[m+8>>2]=-2147483600;f[m+4>>2]=41;K=F;L=273786;M=K+41|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));b[F+41>>0]=0;vM(-215,m,273828,273208,2498)}else if(!A){N=0;O=A;P=0}else{H=0;I=A;J=28}while(0);a:do if((J|0)==28){d=c+4|0;D=m+4|0;G=m+8|0;Q=m+12|0;R=m+16|0;S=m+20|0;T=m+24|0;U=m+28|0;V=m+32|0;W=m+36|0;X=m+40|0;Z=m+48|0;_=m+44|0;$=m+52|0;aa=H;while(1){do if((aa|0)<0&(eS(c)|0)==65536){ba=f[d>>2]|0;f[m>>2]=f[ba>>2];ca=ba+4|0;f[D>>2]=f[ca>>2];f[G>>2]=f[ba+8>>2];f[Q>>2]=f[ba+12>>2];f[R>>2]=f[ba+16>>2];f[S>>2]=f[ba+20>>2];f[T>>2]=f[ba+24>>2];f[U>>2]=f[ba+28>>2];f[V>>2]=f[ba+32>>2];da=f[ba+36>>2]|0;f[W>>2]=da;f[X>>2]=G;f[_>>2]=Z;f[Z>>2]=0;f[$>>2]=0;if(da|0){ea=da+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[ca>>2]|0)<3){ca=f[ba+44>>2]|0;ea=f[_>>2]|0;f[ea>>2]=f[ca>>2];f[ea+4>>2]=f[ca+4>>2];break}else{f[D>>2]=0;U$(m,ba);break}}else bS(m,c,aa);while(0);if(f[R>>2]|0){ba=f[D>>2]|0;if((ba|0)<3)fa=Y(f[Q>>2]|0,f[G>>2]|0)|0;else{ca=f[X>>2]|0;ea=0;da=1;while(1){ga=Y(f[ca+(ea<<2)>>2]|0,da)|0;ea=ea+1|0;if((ea|0)==(ba|0)){fa=ga;break}else da=ga}}if(!((ba|0)==0|(fa|0)==0)){da=k0(m,2,4,1)|0;if((da|0)<=0)break;uT(20492,56,8,f[R>>2]|0,da,(f[t>>2]|0)+(aa*56|0)|0,(f[v>>2]|0)+(aa*20|0)|0)|0}}da=f[W>>2]|0;if(da|0?(ea=da+12|0,da=f[ea>>2]|0,f[ea>>2]=da+-1,(da|0)==1):0)V$(m);f[W>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[D>>2]|0)>0){da=f[X>>2]|0;ea=0;do{f[da+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[D>>2]|0))}ea=f[_>>2]|0;if((ea|0)!=(Z|0))wL(ea);aa=aa+1|0;if(aa>>>0>=I>>>0){N=H;O=I;P=1;break a}}f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;aa=$Xc(16)|0;f[n>>2]=aa;f[n+8>>2]=-2147483632;f[n+4>>2]=11;K=aa;L=273841;M=K+11|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));b[aa+11>>0]=0;vM(-215,n,273828,273208,2509)}while(0);I=f[r+16>>2]|0;do if(I){H=f[r+4>>2]|0;fa=(H|0)<3;if(fa)ha=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{Z=f[r+40>>2]|0;_=0;D=1;while(1){X=Y(f[Z+(_<<2)>>2]|0,D)|0;_=_+1|0;if((_|0)==(H|0)){ha=X;break}else D=X}}if(!((j|0)==0|((H|0)==0|(ha|0)==0))){D=O-N|0;if(fa)ia=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{_=f[r+40>>2]|0;Z=0;aa=1;while(1){X=Y(f[_+(Z<<2)>>2]|0,aa)|0;Z=Z+1|0;if((Z|0)==(H|0)){ia=X;break}else aa=X}}if((ia|0)!=(A|0)){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;ja=$Xc(64)|0;f[m>>2]=ja;ka=m+8|0;f[ka>>2]=-2147483584;la=m+4|0;f[la>>2]=62;K=ja;L=273853;M=K+62|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));ma=ja+62|0;b[ma>>0]=0;vM(-215,m,273828,273208,2523)}if((f[r>>2]&4095|0)!=28){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;ja=$Xc(64)|0;f[m>>2]=ja;ka=m+8|0;f[ka>>2]=-2147483584;la=m+4|0;f[la>>2]=62;K=ja;L=273853;M=K+62|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));ma=ja+62|0;b[ma>>0]=0;vM(-215,m,273828,273208,2523)}if((D|0)!=(A|0)){aa=f[I+(N<<4)+8>>2]|0;if((aa|0)<=-1)break;Pra(c,A,I,aa,t,v);H=f[t>>2]|0;f[H+(N*56|0)+20>>2]=H+(aa*56|0);break}if(P){aa=f[t>>2]|0;H=N;do{Z=f[I+(H<<4)>>2]|0;_=f[I+(H<<4)+4>>2]|0;fa=f[I+(H<<4)+8>>2]|0;X=f[I+(H<<4)+12>>2]|0;f[aa+(H*56|0)+12>>2]=Z>>>0<A>>>0?aa+(Z*56|0)|0:0;f[aa+(H*56|0)+8>>2]=_>>>0<A>>>0?aa+(_*56|0)|0:0;f[aa+(H*56|0)+20>>2]=fa>>>0<A>>>0?aa+(fa*56|0)|0:0;f[aa+(H*56|0)+16>>2]=X>>>0<A>>>0?aa+(X*56|0)|0:0;H=H+1|0}while((H|0)!=(O|0))}}else J=60}else J=60;while(0);if((J|0)==60?P:0){P=O+-1|0;J=f[t>>2]|0;A=N;do{I=A;A=A+1|0;f[J+(I*56|0)+12>>2]=I>>>0<P>>>0?J+(A*56|0)|0:0;f[J+(I*56|0)+8>>2]=I>>>0>N>>>0?J+((I+-1|0)*56|0)|0:0}while((A|0)!=(O|0))}O=(f[t>>2]|0)+(N*56|0)|0;na=+p[e>>3];p[w>>3]=na;oa=+p[e+8>>3];p[w+8>>3]=oa;pa=+p[e+16>>3];p[w+16>>3]=pa;qa=+p[e+24>>3];p[w+24>>3]=qa;p[x>>3]=na;p[x+8>>3]=oa;p[x+16>>3]=pa;p[x+24>>3]=qa;e=f[k+4>>2]|0;f[y>>2]=f[k>>2];f[y+4>>2]=e;f[o>>2]=f[w>>2];f[o+4>>2]=f[w+4>>2];f[o+8>>2]=f[w+8>>2];f[o+12>>2]=f[w+12>>2];f[o+16>>2]=f[w+16>>2];f[o+20>>2]=f[w+20>>2];f[o+24>>2]=f[w+24>>2];f[o+28>>2]=f[w+28>>2];f[n>>2]=f[x>>2];f[n+4>>2]=f[x+4>>2];f[n+8>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[m>>2]=f[y>>2];f[m+4>>2]=f[y+4>>2];Qra(s,O,o,n,C?0-j|0:j,g,h,m);m=f[v>>2]|0;if(m|0){v=f[E>>2]|0;if((v|0)!=(m|0))f[E>>2]=v+(~(((v+-20-m|0)>>>0)/20|0)*20|0);cYc(m)}}m=f[t>>2]|0;if(m|0){t=f[i>>2]|0;if((t|0)!=(m|0))f[i>>2]=t+(~(((t+-56-m|0)>>>0)/56|0)*56|0);cYc(m)}m=r+36|0;t=f[m>>2]|0;if(t|0?(i=t+12|0,t=f[i>>2]|0,f[i>>2]=t+-1,(t|0)==1):0)V$(r);f[m>>2]=0;m=r+16|0;t=r+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[t>>2]|0)>0){m=f[r+40>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))wL(t);t=q+36|0;r=f[t>>2]|0;if(r|0?(i=r+12|0,r=f[i>>2]|0,f[i>>2]=r+-1,(r|0)==1):0)V$(q);f[t>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){B=f[q+40>>2]|0;t=0;do{f[B+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[a>>2]|0))}a=f[z>>2]|0;if((a|0)==(q+48|0)){u=l;return}wL(a);u=l;return}function Nra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/56|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+56|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/56|0;g=i+b|0;if(g>>>0>76695844)kWc(a);l=(d-h|0)/56|0;h=l<<1;d=l>>>0<38347922?(h>>>0<g>>>0?g:h):76695844;do if(d)if(d>>>0>76695844){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{m=$Xc(d*56|0)|0;break}else m=0;while(0);h=m+(i*56|0)|0;i=m+(d*56|0)|0;d=b;b=h;m=h;do{j=b;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+56|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(((b|0)/-56|0)*56|0)|0;if((b|0)>0)o1c(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;cYc(d);return}function Ora(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)kWc(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=k+(d*20|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-20|0)*20|0)|0;if((b|0)>0)o1c(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;cYc(d);return}function Pra(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+64|0;i=h;if((d|0)<=-1){u=h;return}j=i+16|0;k=i+4|0;l=i+8|0;m=i+12|0;n=i+36|0;o=i+40|0;p=i+44|0;q=i+48|0;r=d;do{bS(i,a,r);d=f[j>>2]|0;s=f[k>>2]|0;if(!d)t=0;else{if((s|0)<3)v=Y(f[m>>2]|0,f[l>>2]|0)|0;else{w=f[o>>2]|0;x=0;y=1;while(1){z=Y(f[w+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(s|0)){v=z;break}else y=z}}t=(s|0)==0|(v|0)==0?0:d}if((s|0)<3)A=Y(f[m>>2]|0,f[l>>2]|0)|0;else{y=f[o>>2]|0;x=0;w=1;while(1){z=Y(f[y+(x<<2)>>2]|0,w)|0;x=x+1|0;if((x|0)==(s|0)){A=z;break}else w=z}}uT(20492,56,8,t,A,(f[e>>2]|0)+(r*56|0)|0,(f[g>>2]|0)+(r*20|0)|0)|0;w=c+(r<<4)|0;s=f[w>>2]|0;x=f[c+(r<<4)+4>>2]|0;y=f[c+(r<<4)+8>>2]|0;d=f[c+(r<<4)+12>>2]|0;z=f[e>>2]|0;f[z+(r*56|0)+12>>2]=(s|0)>-1&(s|0)<(b|0)?z+(s*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+8>>2]=(x|0)>-1&(x|0)<(b|0)?s+(x*56|0)|0:0;x=(y|0)>-1;s=f[e>>2]|0;f[s+(r*56|0)+20>>2]=x&(y|0)<(b|0)?s+(y*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+16>>2]=(d|0)>-1&(d|0)<(b|0)?s+(d*56|0)|0:0;if(x)Pra(a,b,c,y,e,g);y=f[n>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)V$(i);f[n>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){y=f[o>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[k>>2]|0))}x=f[p>>2]|0;if((x|0)!=(q|0))wL(x);r=f[w>>2]|0}while((r|0)>-1);u=h;return}function Qra(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;l=u;u=u+384|0;m=l+368|0;n=l+356|0;o=l+344|0;q=l+208|0;r=l+176|0;s=l+288|0;t=l+144|0;v=l+112|0;w=l+256|0;x=l+80|0;y=l+96|0;z=l+64|0;A=l+48|0;B=l+32|0;C=l+248|0;D=l+16|0;E=l;F=l+240|0;f[n>>2]=0;G=n+4|0;f[G>>2]=0;f[n+8>>2]=0;f[o>>2]=0;H=o+4|0;f[H>>2]=0;f[o+8>>2]=0;I=+p[d+8>>3];J=+p[d+16>>3];K=+p[d+24>>3];p[q>>3]=+p[d>>3];p[q+8>>3]=I;p[q+16>>3]=J;p[q+24>>3]=K;K=+p[e+8>>3];J=+p[e+16>>3];I=+p[e+24>>3];p[r>>3]=+p[e>>3];p[r+8>>3]=K;p[r+16>>3]=J;p[r+24>>3]=I;gT(s,a,0,1,0,0);a=f[k>>2]|0;e=f[k+4>>2]|0;if((j|0)==16)L=(f[s>>2]&7|0)==0?16:8;else L=j;do if(c|0){if((i|0)>=32768){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;j=$Xc(32)|0;f[w>>2]=j;f[w+8>>2]=-2147483616;f[w+4>>2]=26;M=j;N=273452;O=M+26|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[j+26>>0]=0;vM(-215,w,273916,273208,2582)}q3(q,t,f[s>>2]&4095,0);q3(r,v,f[s>>2]&4095,0);k=(g|0)>-2147483646?g:-2147483646;d=(k|0)==2147483647?2147483646:k;k=c+12|0;if((d|0)<0){P=f[k>>2]|0;f[k>>2]=0;Q=1-d|0;R=P}else{Q=d;R=0}FT(m,c,Q);d=w+12|0;P=(i|0)<0;S=w+20|0;T=x+8|0;U=o+8|0;V=(i|0)>-1;W=D+8|0;X=E+8|0;Y=x+8|0;Z=F+4|0;_=y+8|0;$=z+8|0;aa=x+8|0;ba=A+8|0;ca=B+8|0;da=C+4|0;a:while(1){ea=GT(m)|0;if(!ea){fa=61;break}ga=f[ea+24>>2]|0;ha=f[ea>>2]|0;ia=ha&4095;ja=(ha&32768|0)==0?t:v;tT(ea,w,0);ha=f[d>>2]|0;if(!ha){fa=11;break}if(P?(ka=f[H>>2]|0,la=f[o>>2]|0,ma=ka,!((ka|0)==(la|0)|(ma|0)==(la|0))):0)f[H>>2]=ma+(~((ma+-16-la|0)>>>4)<<4);la=f[ea>>2]|0;do if((la&12288|0)==4096){if(!((la&16384|0)==0?1:(f[ea+28>>2]|0)!=1)){ma=ea+56|0;ka=f[ma>>2]|0;na=ea+60|0;oa=f[na>>2]|0;pa=b[ha>>0]|0;qa=ka+a|0;ra=oa+e|0;b:do if((ga|0)>0){if(V){sa=pa;ta=0;ua=qa;va=ka;wa=oa;xa=ra;ya=ha;while(1){za=b[ya>>0]|0;Aa=ya+1|0;f[d>>2]=Aa;if(Aa>>>0>=(f[S>>2]|0)>>>0)BT(w,1);Aa=za<<24>>24;if(za<<24>>24==sa<<24>>24){Ba=sa;Ca=ua;Da=xa}else{Ea=y;f[Ea>>2]=ua;f[Ea+4>>2]=((ua|0)<0)<<31>>31;Ea=_;f[Ea>>2]=xa;f[Ea+4>>2]=((xa|0)<0)<<31>>31;Ea=z;f[Ea>>2]=va;f[Ea+4>>2]=((va|0)<0)<<31>>31;Ea=$;f[Ea>>2]=wa;f[Ea+4>>2]=((wa|0)<0)<<31>>31;lra(s,y,z,ja,i,L,2,0);Ba=za;Ca=va;Da=wa}za=ta+1|0;if((za|0)>=(ga|0)){Fa=Ca;Ga=Da;break b}sa=Ba;ta=za;ua=Ca;va=(f[60540+(Aa<<3)>>2]|0)+va|0;wa=(f[60540+(Aa<<3)+4>>2]|0)+wa|0;xa=Da;ya=f[d>>2]|0}}else{Ha=pa;Ia=0;Ja=qa;Ka=ka;La=oa;Ma=ra;Na=ha}while(1){ya=b[Na>>0]|0;xa=Na+1|0;f[d>>2]=xa;if(xa>>>0>=(f[S>>2]|0)>>>0)BT(w,1);xa=ya<<24>>24;if(ya<<24>>24==Ha<<24>>24){Oa=Ha;Pa=Ja;Qa=Ma}else{wa=((Ka|0)<0)<<31>>31;va=x;f[va>>2]=Ka;f[va+4>>2]=wa;va=aa;f[va>>2]=La;f[va+4>>2]=((La|0)<0)<<31>>31;va=f[H>>2]|0;if(va>>>0<(f[U>>2]|0)>>>0){ua=va;f[ua>>2]=Ka;f[ua+4>>2]=wa;wa=aa;ua=f[wa+4>>2]|0;ta=va+8|0;f[ta>>2]=f[wa>>2];f[ta+4>>2]=ua;f[H>>2]=va+16}else Lra(o,x);Oa=ya;Pa=Ka;Qa=La}ya=Ia+1|0;if((ya|0)>=(ga|0)){Fa=Pa;Ga=Qa;break b}Ha=Oa;Ia=ya;Ja=Pa;Ka=(f[60540+(xa<<3)>>2]|0)+Ka|0;La=(f[60540+(xa<<3)+4>>2]|0)+La|0;Ma=Qa;Na=f[d>>2]|0}}else{Fa=qa;Ga=ra}while(0);if(V){ra=A;f[ra>>2]=Fa;f[ra+4>>2]=((Fa|0)<0)<<31>>31;ra=ba;f[ra>>2]=Ga;f[ra+4>>2]=((Ga|0)<0)<<31>>31;ra=(f[ma>>2]|0)+a|0;qa=(f[na>>2]|0)+e|0;oa=B;f[oa>>2]=ra;f[oa+4>>2]=((ra|0)<0)<<31>>31;ra=ca;f[ra>>2]=qa;f[ra+4>>2]=((qa|0)<0)<<31>>31;lra(s,A,B,ja,i,L,2,0);break}else{qa=f[o>>2]|0;ra=(f[H>>2]|0)-qa>>4;f[C>>2]=a;f[da>>2]=e;vra(s,qa,ra,n,t,L,0,C);break}}if((la&4094|0)==12){if((ia|0)!=12){fa=39;break a}ra=ga-(la>>>14&1^1)|0;qa=ha;oa=qa;ka=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;oa=qa+4|0;qa=h[oa>>0]|h[oa+1>>0]<<8|h[oa+2>>0]<<16|h[oa+3>>0]<<24;oa=ha+8|0;f[d>>2]=oa;if(oa>>>0>=(f[S>>2]|0)>>>0)BT(w,1);oa=ka+a|0;ka=qa+e|0;if(P){qa=((oa|0)<0)<<31>>31;pa=x;f[pa>>2]=oa;f[pa+4>>2]=qa;pa=T;f[pa>>2]=ka;f[pa+4>>2]=((ka|0)<0)<<31>>31;pa=f[H>>2]|0;if(pa>>>0<(f[U>>2]|0)>>>0){xa=pa;f[xa>>2]=oa;f[xa+4>>2]=qa;qa=T;xa=f[qa+4>>2]|0;ya=pa+8|0;f[ya>>2]=f[qa>>2];f[ya+4>>2]=xa;f[H>>2]=pa+16}else Lra(o,x)}c:do if((ra|0)>0){if(V){pa=0;xa=oa;ya=ka;while(1){qa=f[d>>2]|0;va=qa;ua=va;ta=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;ua=va+4|0;va=h[ua>>0]|h[ua+1>>0]<<8|h[ua+2>>0]<<16|h[ua+3>>0]<<24;ua=qa+8|0;f[d>>2]=ua;if(ua>>>0>=(f[S>>2]|0)>>>0)BT(w,1);ua=xa;xa=ta+a|0;ta=D;f[ta>>2]=ua;f[ta+4>>2]=((ua|0)<0)<<31>>31;ua=W;f[ua>>2]=ya;f[ua+4>>2]=((ya|0)<0)<<31>>31;ya=va+e|0;va=E;f[va>>2]=xa;f[va+4>>2]=((xa|0)<0)<<31>>31;va=X;f[va>>2]=ya;f[va+4>>2]=((ya|0)<0)<<31>>31;lra(s,D,E,ja,i,L,2,0);pa=pa+1|0;if((pa|0)>=(ra|0))break c}}else Ra=0;do{pa=f[d>>2]|0;ya=pa;xa=ya;va=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;xa=ya+4|0;ya=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;xa=pa+8|0;f[d>>2]=xa;if(xa>>>0>=(f[S>>2]|0)>>>0)BT(w,1);xa=va+a|0;va=ya+e|0;ya=((xa|0)<0)<<31>>31;pa=x;f[pa>>2]=xa;f[pa+4>>2]=ya;pa=Y;f[pa>>2]=va;f[pa+4>>2]=((va|0)<0)<<31>>31;va=f[H>>2]|0;if(va>>>0<(f[U>>2]|0)>>>0){pa=va;f[pa>>2]=xa;f[pa+4>>2]=ya;ya=Y;pa=f[ya+4>>2]|0;xa=va+8|0;f[xa>>2]=f[ya>>2];f[xa+4>>2]=pa;f[H>>2]=va+16}else Lra(o,x);Ra=Ra+1|0}while((Ra|0)<(ra|0))}while(0);if(P){ra=f[o>>2]|0;ka=(f[H>>2]|0)-ra>>4;f[F>>2]=0;f[Z>>2]=0;vra(s,ra,ka,n,t,L,0,F)}}}while(0)}if((fa|0)==11){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;Z=$Xc(32)|0;f[x>>2]=Z;f[x+8>>2]=-2147483616;f[x+4>>2]=18;M=Z;N=273931;O=M+18|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[Z+18>>0]=0;vM(-215,x,273916,273208,2606)}else if((fa|0)==39){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;Y=$Xc(32)|0;f[x>>2]=Y;f[x+8>>2]=-2147483616;f[x+4>>2]=21;M=Y;N=273950;O=M+21|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));b[Y+21>>0]=0;vM(-215,x,273916,273208,2649)}else if((fa|0)==61){if(P)wra(s,n,t);if(!R)break;f[k>>2]=R;break}}while(0);R=s+36|0;t=f[R>>2]|0;if(t|0?(fa=t+12|0,t=f[fa>>2]|0,f[fa>>2]=t+-1,(t|0)==1):0)V$(s);f[R>>2]=0;R=s+16|0;t=s+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[t>>2]|0)>0){R=f[s+40>>2]|0;fa=0;do{f[R+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))wL(t);t=f[o>>2]|0;if(t|0){o=f[H>>2]|0;if((o|0)!=(t|0))f[H>>2]=o+(~((o+-16-t|0)>>>4)<<4);cYc(t)}t=f[n>>2]|0;if(!t){u=l;return}n=f[G>>2]|0;if((n|0)!=(t|0))f[G>>2]=n+(~((n+-32-t|0)>>>5)<<5);cYc(t);u=l;return}function Rra(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;g=u;u=u+1312|0;i=g+120|0;j=g+100|0;k=g+40|0;l=g+16|0;m=g;o=a+24|0;p=f[o>>2]|0;q=p+8|0;r=i+8|0;f[i>>2]=r;t=i+4|0;f[t>>2]=q;if(q>>>0>59){v=bYc(q>>>0>214748364?-1:q*20|0)|0;f[i>>2]=v;w=v}else w=r;v=a+56|0;q=f[v>>2]|0;x=f[v+4>>2]|0;v=f[a>>2]|0;if((v&12288|0)!=4096){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;y=$Xc(48)|0;f[m>>2]=y;z=m+8|0;f[z>>2]=-2147483600;A=m+4|0;f[A>>2]=32;B=y;C=273972;D=B+32|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+32|0;b[E>>0]=0;vM(-215,m,274005,274029,74)}if((v&16384|0)==0?1:(f[a+28>>2]|0)!=1){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;y=$Xc(48)|0;f[m>>2]=y;z=m+8|0;f[z>>2]=-2147483600;A=m+4|0;f[A>>2]=32;B=y;C=273972;D=B+32|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));E=y+32|0;b[E>>0]=0;vM(-215,m,274005,274029,74)}if((c|0)<=87){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;E=$Xc(48)|0;f[m>>2]=E;f[m+8>>2]=-2147483600;f[m+4>>2]=37;B=E;C=274100;D=B+37|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));b[E+37>>0]=0;vM(-215,m,274005,274029,75)}wT(v&-4096|12,c,8,d,l);if(f[o>>2]|0){o=k+32|0;b[o>>0]=0;iEa(a,k);a=j+16|0;f[a>>2]=0;a:do if((p|0)>0){d=k+28|0;c=k+12|0;v=k+36|0;m=(e|0)==1;E=l+12|0;C=l+20|0;B=k+20|0;D=k+40|0;if((e|0)<3)F=0;else{y=j;A=0;while(1){z=b[f[d>>2]>>0]|0;G=f[c>>2]|0;f[d>>2]=G;H=v;I=f[H>>2]|0;J=f[H+4>>2]|0;H=G;if(!G)K=b[o>>0]|0;else{G=b[H>>0]|0;b[o>>0]=G;L=H+1|0;f[c>>2]=L;if(L>>>0<(f[B>>2]|0)>>>0){N=G;O=I}else{BT(k,1);N=b[o>>0]|0;O=f[v>>2]|0}G=N<<24>>24;f[v>>2]=O+(b[k+44+(G<<1)>>0]|0);f[D>>2]=(f[D>>2]|0)+(b[k+44+(G<<1)+1>>0]|0);K=N}G=(K<<24>>24)-z|0;z=f[60604+(G+7<<2)>>2]|0;L=w+(A*20|0)|0;if(!G)P=y;else{f[y+16>>2]=L;P=L}f[w+(A*20|0)+12>>2]=z;z=w+(A*20|0)|0;f[z>>2]=I;f[z+4>>2]=J;J=A+1|0;if((J|0)<(p|0)){y=P;A=J}else{Q=P;R=J;break a}}}while(1){A=b[f[d>>2]>>0]|0;y=f[c>>2]|0;f[d>>2]=y;J=v;z=f[J>>2]|0;I=f[J+4>>2]|0;J=y;if(!y)S=b[o>>0]|0;else{y=b[J>>0]|0;b[o>>0]=y;L=J+1|0;f[c>>2]=L;if(L>>>0<(f[B>>2]|0)>>>0){T=y;U=z}else{BT(k,1);T=b[o>>0]|0;U=f[v>>2]|0}y=T<<24>>24;f[v>>2]=U+(b[k+44+(y<<1)>>0]|0);f[D>>2]=(f[D>>2]|0)+(b[k+44+(y<<1)+1>>0]|0);S=T}if(m|S<<24>>24!=A<<24>>24){A=f[E>>2]|0;if(A>>>0<(f[C>>2]|0)>>>0)V=A;else{zT(l);V=f[E>>2]|0}A=V;y=A;b[y>>0]=z;b[y+1>>0]=z>>8;b[y+2>>0]=z>>16;b[y+3>>0]=z>>24;z=A+4|0;b[z>>0]=I;b[z+1>>0]=I>>8;b[z+2>>0]=I>>16;b[z+3>>0]=I>>24;f[E>>2]=(f[E>>2]|0)+8}I=F+1|0;if((I|0)<(p|0))F=I;else{Q=j;R=I;break}}}else{Q=j;R=0}while(0);if((e|0)>=3){f[Q+16>>2]=0;Q=f[a>>2]|0;F=w;p=(e|0)==4;e=Q;do{V=(e-F|0)/20|0;S=f[e>>2]|0;T=f[e+4>>2]|0;k=1;U=0;o=0;while(1){P=V-k|0;K=((P|0)<0?R:0)+P|0;P=k+V|0;N=P-((P|0)>=(R|0)?R:0)|0;P=f[w+(K*20|0)>>2]|0;O=(f[w+(N*20|0)>>2]|0)-P|0;E=f[w+(K*20|0)+4>>2]|0;K=(f[w+(N*20|0)+4>>2]|0)-E|0;N=(Y(K,K)|0)+(Y(O,O)|0)|0;C=(Y(K,S-P|0)|0)-(Y(T-E|0,O)|0)|0;O=(n[s>>2]=+(U|0)*+(N|0)-+(o|0)*+(C|0),f[s>>2]|0);if((k|0)>1){if((o|0)>=(N|0))break;if((U|0)>0&(O|0)<1)break;if((U|0)<0&(O|0)>-1)break}k=k+1|0;U=C;o=N}o=k+-1|0;f[e+8>>2]=o;if(p){U=o;N=0;while(1){C=V-U|0;O=((C|0)<0?R:0)+C|0;C=U+V|0;E=C-((C|0)>=(R|0)?R:0)|0;C=(f[w+(O*20|0)>>2]|0)-S|0;P=(f[w+(O*20|0)+4>>2]|0)-T|0;O=(f[w+(E*20|0)>>2]|0)-S|0;K=(f[w+(E*20|0)+4>>2]|0)-T|0;if((P|C|0)==0|(K|O|0)==0){W=N;break}X=+(C|0);Z=+(P|0);_=+(O|0);$=+(K|0);aa=+((Y(K,P)|0)+(Y(O,C)|0)|0)/+M(+((X*X+Z*Z)*(_*_+$*$)))+1.1;C=(n[s>>2]=aa,f[s>>2]|0);if(!((U|0)>=(o|0)|(C|0)>(N|0))){W=N;break}if((U|0)>1){U=U+-1|0;N=C}else{W=C;break}}f[e+12>>2]=W}e=f[e+16>>2]|0}while((e|0)!=0);ba=j;ca=Q;while(1){Q=f[ca+8>>2]>>1;e=ca+12|0;W=f[e>>2]|0;N=(ca-F|0)/20|0;b:do if((Q|0)<1)da=ca;else{U=1;while(1){o=N-U|0;if((f[w+((((o|0)<0?R:0)+o|0)*20|0)+12>>2]|0)>(W|0))break;o=U+N|0;if((f[w+((o-((o|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0)>(W|0))break;if((U|0)<(Q|0))U=U+1|0;else{da=ca;break b}}f[ba+16>>2]=f[ca+16>>2];f[e>>2]=0;da=ba}while(0);ca=f[ca+16>>2]|0;if(!ca)break;else ba=da}da=j;ba=f[a>>2]|0;while(1){do if((f[ba+8>>2]|0)==1){ca=ba+12|0;e=f[ca>>2]|0;Q=ba-F|0;W=(Q|0)/20|0;N=W+1|0;if((e|0)>(f[w+((W+-1+((Q|0)<20?R:0)|0)*20|0)+12>>2]|0)?(e|0)>(f[w+((N-((N|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0):0){ea=ba;break}f[da+16>>2]=f[ba+16>>2];f[ca>>2]=0;ea=da}else ea=ba;while(0);ba=f[ba+16>>2]|0;if(!ba)break;else da=ea}do if(!p){if(f[w+12>>2]|0?(ea=R+-1|0,f[w+(ea*20|0)+12>>2]|0):0){c:do if((R|0)>1){da=1;while(1){if(!(f[w+(da*20|0)+12>>2]|0)){fa=da;break c}f[w+((da+-1|0)*20|0)+12>>2]=0;ba=da+1|0;if((ba|0)<(R|0))da=ba;else{fa=ba;break}}}else fa=1;while(0);if((fa|0)==(R|0))break;da=fa+-1|0;d:do if((R|0)>2){ba=R+-2|0;ca=ea;while(1){if(!(f[w+(ba*20|0)+12>>2]|0)){ga=ca;break d}f[w+(ba*20|0)+16>>2]=0;f[w+(ca*20|0)+12>>2]=0;if((ba|0)>1){N=ba;ba=ba+-1|0;ca=N}else{ga=ba;break}}}else ga=ea;while(0);if((da|0)==0&(ga|0)==(ea|0)){ba=((f[w+16>>2]|0)-F|0)/20|0;ca=w+(R*20|0)|0;f[ca>>2]=f[w>>2];f[ca+4>>2]=f[w+4>>2];f[ca+8>>2]=f[w+8>>2];f[ca+12>>2]=f[w+12>>2];f[ca+16>>2]=f[w+16>>2];f[w+(R*20|0)+16>>2]=0;f[w+(ea*20|0)+16>>2]=ca;ha=ba}else ha=da;f[a>>2]=w+(ha*20|0)}ba=j;ca=f[a>>2]|0;while(1){N=ca+16|0;e=f[N>>2]|0;e:do if(!e){ia=1;ja=ba;ka=ca;la=e;ma=N}else{Q=1;W=ba;U=ca;o=e;T=N;while(1){if((o-U|0)!=20){ia=Q;ja=W;ka=U;la=o;ma=T;break e}S=Q+1|0;V=o+16|0;k=f[V>>2]|0;if(!k){ia=S;ja=U;ka=o;la=k;ma=V;break}else{C=o;O=U;Q=S;o=k;T=V;U=C;W=O}}}while(0);if((ia|0)>1){do if((ia|0)==2){N=f[ja+12>>2]|0;e=f[ka+12>>2]|0;if((N|0)<=(e|0)){if((N|0)!=(e|0)){na=ka;oa=ba;break}if((f[ja+8>>2]|0)>(f[ka+8>>2]|0)){na=ka;oa=ba;break}}na=la;oa=ja}else{na=ka;oa=f[ba+16>>2]|0}while(0);f[oa+16>>2]=na;pa=f[ma>>2]|0}else pa=la;if(!pa)break;else{ba=ka;ca=pa}}}while(0);pa=l+12|0;ka=l+20|0;la=f[a>>2]|0;a=f[pa>>2]|0;do{if(a>>>0<(f[ka>>2]|0)>>>0)qa=a;else{zT(l);qa=f[pa>>2]|0}ma=la;na=ma;oa=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=ma+4|0;ma=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=qa;ja=na;b[ja>>0]=oa;b[ja+1>>0]=oa>>8;b[ja+2>>0]=oa>>16;b[ja+3>>0]=oa>>24;oa=na+4|0;b[oa>>0]=ma;b[oa+1>>0]=ma>>8;b[oa+2>>0]=ma>>16;b[oa+3>>0]=ma>>24;a=(f[pa>>2]|0)+8|0;f[pa>>2]=a;la=f[la+16>>2]|0}while((la|0)!=0)}}else{la=l+12|0;a=f[la>>2]|0;if(a>>>0<(f[l+20>>2]|0)>>>0)ra=a;else{zT(l);ra=f[la>>2]|0}a=ra;ra=a;b[ra>>0]=q;b[ra+1>>0]=q>>8;b[ra+2>>0]=q>>16;b[ra+3>>0]=q>>24;q=a+4|0;b[q>>0]=x;b[q+1>>0]=x>>8;b[q+2>>0]=x>>16;b[q+3>>0]=x>>24;f[la>>2]=(f[la>>2]|0)+8}la=yT(l)|0;l=f[i>>2]|0;if((l|0)==(r|0)){u=g;return la|0}if(l|0)dYc(l);f[i>>2]=r;f[t>>2]=59;u=g;return la|0}function Sra(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+2304|0;h=g+2248|0;i=g+1152|0;j=g+56|0;k=g;do if((eS(a)|0)==65536){l=f[a+4>>2]|0;f[h>>2]=f[l>>2];m=h+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=h+8|0;f[o>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=o;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;U$(h,l);break}}else bS(h,a,-1);while(0);a=k0(h,2,-1,1)|0;l=f[h>>2]|0;m=l&7;if(!((a|0)>-1&(m|1|0)==5)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=$Xc(64)|0;f[i>>2]=n;f[i+8>>2]=-2147483584;f[i+4>>2]=52;o=n;q=274138;p=o+52|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(p|0));b[n+52>>0]=0;vM(-215,i,274191,274029,682)}if(a){n=i+8|0;g1c(n|0,0,1088)|0;f[i>>2]=n;q=i+4|0;o=a>>>0>136;f[q>>2]=a;if(o){p=bYc(a>>>0>536870911?-1:a<<3)|0;g1c(p|0,0,a<<3|0)|0;f[i>>2]=p;r=p}else r=n;p=j+8|0;g1c(p|0,0,1088)|0;f[j>>2]=p;s=j+4|0;f[s>>2]=a;if(o){o=bYc(a>>>0>536870911?-1:a<<3)|0;g1c(o|0,0,a<<3|0)|0;f[j>>2]=o}switch(l&7){case 4:{t=Tra(f[h+16>>2]|0,a,r,e,d,j)|0;break}case 5:{t=Ura(f[h+16>>2]|0,a,r,e,d,j)|0;break}default:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;vM(-210,k,274191,274029,700)}}Tj(k,t,1,m|8,r,0);jR(k,c);r=k+36|0;m=f[r>>2]|0;if(m|0?(t=m+12|0,m=f[t>>2]|0,f[t>>2]=m+-1,(m|0)==1):0)V$(k);f[r>>2]=0;r=k+16|0;m=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[m>>2]|0)>0){r=f[k+40>>2]|0;t=0;do{f[r+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))wL(m);m=f[j>>2]|0;if((m|0)!=(p|0)){if(m|0)dYc(m);f[j>>2]=p;f[s>>2]=136}s=f[i>>2]|0;if((s|0)!=(n|0)){if(s|0)dYc(s);f[i>>2]=n;f[q>>2]=136}}else vS(c);c=h+36|0;q=f[c>>2]|0;if(q|0?(n=q+12|0,q=f[n>>2]|0,f[n>>2]=q+-1,(q|0)==1):0)V$(h);f[c>>2]=0;c=h+16|0;q=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[q>>2]|0)>0){c=f[h+40>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[q>>2]|0))}q=f[h+44>>2]|0;if((q|0)==(h+48|0)){u=g;return}wL(q);u=g;return}function Tra(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0.0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;if(!d){m=b+-1|0;if((f[a+(m<<3)>>2]|0)==(f[a>>2]|0)?(f[a+(m<<3)+4>>2]|0)==(f[a+4>>2]|0):0){n=1;o=7}else{if(!i){f[h>>2]=0;p=0}else p=i;q=j;f[q>>2]=0;f[q+4>>2]=m;r=1;s=j;t=p;u=0;v=b;o=41}}else{n=3;o=7}do if((o|0)==7){if((b|0)>1){p=0;m=0;q=0;while(1){w=(m+q|0)%(b|0)|0;x=f[a+(w<<3)>>2]|0;y=f[a+(w<<3)+4>>2]|0;z=w+1|0;w=1;e=0.0;A=(z|0)>=(b|0)?0:z;z=q;do{B=A+1|0;C=A;A=(B|0)>=(b|0)?0:B;D=+((f[a+(C<<3)>>2]|0)-x|0);E=+((f[a+(C<<3)+4>>2]|0)-y|0);F=D*D+E*E;C=F>e;z=C?w:z;e=C?F:e;w=w+1|0}while((w|0)!=(b|0));p=p+1|0;if((p|0)>=(n|0)){G=A;H=e;I=x;J=z;K=y;break}else{m=A;q=z}}}else{q=0;m=0;do{M=(m|0)%(b|0)|0;p=M+1|0;m=(p|0)>=(b|0)?0:p;q=q+1|0}while((q|0)<(n|0));G=m;H=0.0;I=f[a+(M<<3)>>2]|0;J=0;K=f[a+(M<<3)+4>>2]|0}if(H<=l){f[c>>2]=I;f[c+4>>2]=K;N=1;break}q=(G|0)%(b|0)|0;p=(q+J|0)%(b|0)|0;if(!i){w=(i*3|0)>>>1;C=f[h>>2]|0;if(C>>>0<w>>>0){B=f[g>>2]|0;O=g+8|0;f[g>>2]=O;f[h>>2]=w;if((C|0)!=0&(O|0)!=(B|0)){P=B;Q=f[P+4>>2]|0;R=O;f[R>>2]=f[P>>2];f[R+4>>2]=Q;if((C|0)!=1){Q=B+8|0;R=f[Q+4>>2]|0;P=g+16|0;f[P>>2]=f[Q>>2];f[P+4>>2]=R;if((C|0)==2)S=C;else{R=2;do{P=B+(R<<3)|0;Q=f[P+4>>2]|0;O=(f[g>>2]|0)+(R<<3)|0;f[O>>2]=f[P>>2];f[O+4>>2]=Q;R=R+1|0}while((R|0)!=(C|0));S=C}}else S=1}else S=C;do{R=(f[g>>2]|0)+(S<<3)|0;f[R>>2]=0;f[R+4>>2]=0;S=S+1|0}while((S|0)!=(w|0));if(!((B|0)==(g+8|0)|(B|0)==0))dYc(B)}else f[h>>2]=w;T=f[g>>2]|0;U=f[h>>2]|0}else{T=j;U=i}C=T;f[C>>2]=p;f[C+4>>2]=q;if(U>>>0>1){V=T;W=U}else{C=U*3|0;R=C>>>1;m=f[h>>2]|0;if(m>>>0<R>>>0){Q=f[g>>2]|0;if(C>>>0>273){C=bYc(R>>>0>536870911?-1:R<<3)|0;g1c(C|0,0,R<<3|0)|0;X=C}else X=g+8|0;f[g>>2]=X;f[h>>2]=R;if((m|0)!=0&(X|0)!=(Q|0)){C=Q;O=f[C+4>>2]|0;P=X;f[P>>2]=f[C>>2];f[P+4>>2]=O;if((m|0)!=1){O=Q+8|0;P=f[O+4>>2]|0;C=X+8|0;f[C>>2]=f[O>>2];f[C+4>>2]=P;if((m|0)==2)Z=m;else{P=2;do{C=Q+(P<<3)|0;O=f[C+4>>2]|0;_=(f[g>>2]|0)+(P<<3)|0;f[_>>2]=f[C>>2];f[_+4>>2]=O;P=P+1|0}while((P|0)!=(m|0));Z=m}}else Z=1}else Z=m;do{P=(f[g>>2]|0)+(Z<<3)|0;f[P>>2]=0;f[P+4>>2]=0;Z=Z+1|0}while((Z|0)!=(R|0));if(!((Q|0)==(g+8|0)|(Q|0)==0))dYc(Q)}else f[h>>2]=R;V=f[g>>2]|0;W=f[h>>2]|0}m=V+8|0;f[m>>2]=q;f[m+4>>2]=p;r=2;s=V;t=W;u=1;v=p;o=41}while(0);if((o|0)==41){o=b+-1|0;W=g+8|0;V=0;Z=r;r=s;s=t;t=v;a:while(1){v=V;X=Z;U=t;while(1){$=X+-1|0;T=r+($<<3)|0;aa=f[T>>2]|0;ba=f[T+4>>2]|0;T=f[a+(aa<<3)>>2]|0;i=f[a+(aa<<3)+4>>2]|0;j=aa+1|0;S=(j|0)>=(b|0)?0:j;if((S|0)!=(ba|0)){H=+((f[a+(ba<<3)>>2]|0)-T|0);F=+((f[a+(ba<<3)+4>>2]|0)-i|0);E=0.0;j=S;ca=U;b:while(1){S=j;do{if((S|0)==(ba|0))break b;J=S+1|0;G=S;S=(J|0)>=(b|0)?0:J;da=+L(+(H*+((f[a+(G<<3)+4>>2]|0)-i|0)-F*+((f[a+(G<<3)>>2]|0)-T|0)))}while(!(da>E));E=da;j=S;ca=(o+S|0)%(b|0)|0}if(!(E*E<=l*(F*F+H*H)))break;else ea=ca}else ea=U;j=v+1|0;f[c+(v<<3)>>2]=T;f[c+(v<<3)+4>>2]=i;if(!$){fa=j;break a}else{v=j;X=$;U=ea}}if($>>>0<s>>>0){ga=r;ha=s}else{U=s*3|0;p=U>>>1;q=f[h>>2]|0;if(q>>>0<p>>>0){R=f[g>>2]|0;if(U>>>0>273){U=bYc(p>>>0>536870911?-1:p<<3)|0;g1c(U|0,0,p<<3|0)|0;ia=U}else ia=W;f[g>>2]=ia;f[h>>2]=p;if((q|0)!=0&(ia|0)!=(R|0)){U=R;Q=f[U+4>>2]|0;j=ia;f[j>>2]=f[U>>2];f[j+4>>2]=Q;if((q|0)!=1){Q=R+8|0;j=f[Q+4>>2]|0;U=ia+8|0;f[U>>2]=f[Q>>2];f[U+4>>2]=j;if((q|0)==2)ja=q;else{j=2;do{U=R+(j<<3)|0;Q=f[U+4>>2]|0;z=(f[g>>2]|0)+(j<<3)|0;f[z>>2]=f[U>>2];f[z+4>>2]=Q;j=j+1|0}while((j|0)!=(q|0));ja=q}}else ja=1}else ja=q;do{j=(f[g>>2]|0)+(ja<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ja=ja+1|0}while((ja|0)!=(p|0));if(!((R|0)==(W|0)|(R|0)==0))dYc(R)}else f[h>>2]=p;ga=f[g>>2]|0;ha=f[h>>2]|0}q=ga+($<<3)|0;f[q>>2]=ca;f[q+4>>2]=ba;if(X>>>0<ha>>>0){ka=ga;la=ha}else{q=ha*3|0;j=q>>>1;Q=f[h>>2]|0;if(Q>>>0<j>>>0){z=f[g>>2]|0;if(q>>>0>273){q=bYc(j>>>0>536870911?-1:j<<3)|0;g1c(q|0,0,j<<3|0)|0;ma=q}else ma=W;f[g>>2]=ma;f[h>>2]=j;if((Q|0)!=0&(ma|0)!=(z|0)){q=z;U=f[q+4>>2]|0;A=ma;f[A>>2]=f[q>>2];f[A+4>>2]=U;if((Q|0)!=1){U=z+8|0;A=f[U+4>>2]|0;q=ma+8|0;f[q>>2]=f[U>>2];f[q+4>>2]=A;if((Q|0)==2)na=Q;else{A=2;do{q=z+(A<<3)|0;U=f[q+4>>2]|0;y=(f[g>>2]|0)+(A<<3)|0;f[y>>2]=f[q>>2];f[y+4>>2]=U;A=A+1|0}while((A|0)!=(Q|0));na=Q}}else na=1}else na=Q;do{A=(f[g>>2]|0)+(na<<3)|0;f[A>>2]=0;f[A+4>>2]=0;na=na+1|0}while((na|0)!=(j|0));if(!((z|0)==(W|0)|(z|0)==0))dYc(z)}else f[h>>2]=j;ka=f[g>>2]|0;la=f[h>>2]|0}Z=X+1|0;Q=ka+(X<<3)|0;f[Q>>2]=aa;f[Q+4>>2]=ca;if(!Z){fa=v;break}else{V=v;r=ka;s=la;t=ca}}if(u)N=fa;else{f[c+(fa<<3)>>2]=f[a+(o<<3)>>2];f[c+(fa<<3)+4>>2]=f[a+(o<<3)+4>>2];N=fa+1|0}}fa=d?N+-1|0:0;o=fa+1|0;a=(o|0)>=(N|0)?0:o;o=f[c+(a<<3)>>2]|0;u=f[c+(a<<3)+4>>2]|0;ca=a+1|0;t=(d^1)&1;la=N-t|0;if((N|0)>2&(t|0)<(la|0)){da=l*.5;s=a;ka=t;t=N;r=(ca|0)>=(N|0)?0:ca;ca=o;V=f[c+(fa<<3)>>2]|0;Z=u;aa=f[c+(fa<<3)+4>>2]|0;while(1){fa=f[c+(r<<3)>>2]|0;h=f[c+(r<<3)+4>>2]|0;g=r+1|0;W=(g|0)>=(N|0)?0:g;g=fa-V|0;l=+(g|0);na=h-aa|0;e=+(na|0);ma=ca-V|0;ha=Z-aa|0;D=+L(+(+(ma|0)*e-+(ha|0)*l));if(((Y(h-Z|0,ha)|0)+(Y(fa-ca|0,ma)|0)|0)>-1&((na|0)!=0&(g|0?D*D<=da*(l*l+e*e):0))){f[c+(s<<3)>>2]=fa;f[c+(s<<3)+4>>2]=h;g=s+1|0;na=W+1|0;oa=(g|0)>=(N|0)?0:g;pa=ka+1|0;qa=t+-1|0;ra=(na|0)>=(N|0)?0:na;sa=f[c+(W<<3)>>2]|0;ta=fa;ua=f[c+(W<<3)+4>>2]|0;va=h}else{f[c+(s<<3)>>2]=ca;f[c+(s<<3)+4>>2]=Z;na=s+1|0;oa=(na|0)>=(N|0)?0:na;pa=ka;qa=t;ra=W;sa=fa;ta=ca;ua=h;va=Z}ka=pa+1|0;if(!((qa|0)>2&(ka|0)<(la|0))){wa=oa;xa=qa;ya=sa;za=ua;break}else{s=oa;t=qa;r=ra;ca=sa;V=ta;Z=ua;aa=va}}}else{wa=a;xa=N;ya=o;za=u}if(d){k=xa;return k|0}f[c+(wa<<3)>>2]=ya;f[c+(wa<<3)+4>>2]=za;k=xa;return k|0}function Ura(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;do if(d){m=3;o=8}else{p=b+-1|0;if(!(+n[a+(p<<3)>>2]!=+n[a>>2])?!(+n[a+(p<<3)+4>>2]!=+n[a+4>>2]):0){m=1;o=8;break}if(!i){f[h>>2]=0;q=0}else q=i;r=j;f[r>>2]=0;f[r+4>>2]=p;t=1;u=j;v=q;w=0;x=b;o=42}while(0);do if((o|0)==8){if((b|0)>1){q=0;p=0;r=0;while(1){y=(p+r|0)%(b|0)|0;z=f[a+(y<<3)>>2]|0;A=f[a+(y<<3)+4>>2]|0;B=y+1|0;e=(f[s>>2]=z,+n[s>>2]);C=(f[s>>2]=A,+n[s>>2]);y=1;D=0.0;E=(B|0)>=(b|0)?0:B;B=r;do{F=E+1|0;G=E;E=(F|0)>=(b|0)?0:F;H=+n[a+(G<<3)>>2]-e;I=+n[a+(G<<3)+4>>2]-C;J=H*H+I*I;G=J>D;B=G?y:B;D=G?J:D;y=y+1|0}while((y|0)!=(b|0));q=q+1|0;if((q|0)>=(m|0)){K=E;M=D;N=z;O=B;P=A;break}else{p=E;r=B}}}else{r=0;p=0;do{Q=(p|0)%(b|0)|0;q=Q+1|0;p=(q|0)>=(b|0)?0:q;r=r+1|0}while((r|0)<(m|0));K=p;M=0.0;N=f[a+(Q<<3)>>2]|0;O=0;P=f[a+(Q<<3)+4>>2]|0}if(M<=l){f[c>>2]=N;f[c+4>>2]=P;R=1;break}r=(K|0)%(b|0)|0;q=(r+O|0)%(b|0)|0;if(!i){y=(i*3|0)>>>1;G=f[h>>2]|0;if(G>>>0<y>>>0){F=f[g>>2]|0;S=g+8|0;f[g>>2]=S;f[h>>2]=y;if((G|0)!=0&(S|0)!=(F|0)){T=F;U=f[T+4>>2]|0;V=S;f[V>>2]=f[T>>2];f[V+4>>2]=U;if((G|0)!=1){U=F+8|0;V=f[U+4>>2]|0;T=g+16|0;f[T>>2]=f[U>>2];f[T+4>>2]=V;if((G|0)==2)W=G;else{V=2;do{T=F+(V<<3)|0;U=f[T+4>>2]|0;S=(f[g>>2]|0)+(V<<3)|0;f[S>>2]=f[T>>2];f[S+4>>2]=U;V=V+1|0}while((V|0)!=(G|0));W=G}}else W=1}else W=G;do{V=(f[g>>2]|0)+(W<<3)|0;f[V>>2]=0;f[V+4>>2]=0;W=W+1|0}while((W|0)!=(y|0));if(!((F|0)==(g+8|0)|(F|0)==0))dYc(F)}else f[h>>2]=y;X=f[g>>2]|0;Y=f[h>>2]|0}else{X=j;Y=i}G=X;f[G>>2]=q;f[G+4>>2]=r;if(Y>>>0>1){Z=X;_=Y}else{G=Y*3|0;V=G>>>1;p=f[h>>2]|0;if(p>>>0<V>>>0){U=f[g>>2]|0;if(G>>>0>273){G=bYc(V>>>0>536870911?-1:V<<3)|0;g1c(G|0,0,V<<3|0)|0;$=G}else $=g+8|0;f[g>>2]=$;f[h>>2]=V;if((p|0)!=0&($|0)!=(U|0)){G=U;S=f[G+4>>2]|0;T=$;f[T>>2]=f[G>>2];f[T+4>>2]=S;if((p|0)!=1){S=U+8|0;T=f[S+4>>2]|0;G=$+8|0;f[G>>2]=f[S>>2];f[G+4>>2]=T;if((p|0)==2)aa=p;else{T=2;do{G=U+(T<<3)|0;S=f[G+4>>2]|0;ba=(f[g>>2]|0)+(T<<3)|0;f[ba>>2]=f[G>>2];f[ba+4>>2]=S;T=T+1|0}while((T|0)!=(p|0));aa=p}}else aa=1}else aa=p;do{T=(f[g>>2]|0)+(aa<<3)|0;f[T>>2]=0;f[T+4>>2]=0;aa=aa+1|0}while((aa|0)!=(V|0));if(!((U|0)==(g+8|0)|(U|0)==0))dYc(U)}else f[h>>2]=V;Z=f[g>>2]|0;_=f[h>>2]|0}p=Z+8|0;f[p>>2]=r;f[p+4>>2]=q;t=2;u=Z;v=_;w=1;x=q;o=42}while(0);if((o|0)==42){o=b+-1|0;_=g+8|0;Z=0;aa=t;t=u;u=v;v=x;a:while(1){x=Z;$=aa;Y=v;while(1){ca=$+-1|0;X=t+(ca<<3)|0;da=f[X>>2]|0;ea=f[X+4>>2]|0;X=f[a+(da<<3)>>2]|0;i=f[a+(da<<3)+4>>2]|0;j=da+1|0;W=(j|0)>=(b|0)?0:j;if((W|0)!=(ea|0)){M=(f[s>>2]=X,+n[s>>2]);C=+n[a+(ea<<3)>>2]-M;e=(f[s>>2]=i,+n[s>>2]);J=+n[a+(ea<<3)+4>>2]-e;I=0.0;j=W;fa=Y;b:while(1){W=j;do{if((W|0)==(ea|0))break b;O=W+1|0;K=W;W=(O|0)>=(b|0)?0:O;ga=+L(+(C*(+n[a+(K<<3)+4>>2]-e)-J*(+n[a+(K<<3)>>2]-M)))}while(!(ga>I));I=ga;j=W;fa=(o+W|0)%(b|0)|0}if(!(I*I<=l*(J*J+C*C)))break;else ha=fa}else ha=Y;j=x+1|0;f[c+(x<<3)>>2]=X;f[c+(x<<3)+4>>2]=i;if(!ca){ia=j;break a}else{x=j;$=ca;Y=ha}}if(ca>>>0<u>>>0){ja=t;ka=u}else{Y=u*3|0;q=Y>>>1;r=f[h>>2]|0;if(r>>>0<q>>>0){V=f[g>>2]|0;if(Y>>>0>273){Y=bYc(q>>>0>536870911?-1:q<<3)|0;g1c(Y|0,0,q<<3|0)|0;la=Y}else la=_;f[g>>2]=la;f[h>>2]=q;if((r|0)!=0&(la|0)!=(V|0)){Y=V;U=f[Y+4>>2]|0;j=la;f[j>>2]=f[Y>>2];f[j+4>>2]=U;if((r|0)!=1){U=V+8|0;j=f[U+4>>2]|0;Y=la+8|0;f[Y>>2]=f[U>>2];f[Y+4>>2]=j;if((r|0)==2)ma=r;else{j=2;do{Y=V+(j<<3)|0;U=f[Y+4>>2]|0;B=(f[g>>2]|0)+(j<<3)|0;f[B>>2]=f[Y>>2];f[B+4>>2]=U;j=j+1|0}while((j|0)!=(r|0));ma=r}}else ma=1}else ma=r;do{j=(f[g>>2]|0)+(ma<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ma=ma+1|0}while((ma|0)!=(q|0));if(!((V|0)==(_|0)|(V|0)==0))dYc(V)}else f[h>>2]=q;ja=f[g>>2]|0;ka=f[h>>2]|0}r=ja+(ca<<3)|0;f[r>>2]=fa;f[r+4>>2]=ea;if($>>>0<ka>>>0){na=ja;oa=ka}else{r=ka*3|0;j=r>>>1;U=f[h>>2]|0;if(U>>>0<j>>>0){B=f[g>>2]|0;if(r>>>0>273){r=bYc(j>>>0>536870911?-1:j<<3)|0;g1c(r|0,0,j<<3|0)|0;pa=r}else pa=_;f[g>>2]=pa;f[h>>2]=j;if((U|0)!=0&(pa|0)!=(B|0)){r=B;Y=f[r+4>>2]|0;E=pa;f[E>>2]=f[r>>2];f[E+4>>2]=Y;if((U|0)!=1){Y=B+8|0;E=f[Y+4>>2]|0;r=pa+8|0;f[r>>2]=f[Y>>2];f[r+4>>2]=E;if((U|0)==2)qa=U;else{E=2;do{r=B+(E<<3)|0;Y=f[r+4>>2]|0;A=(f[g>>2]|0)+(E<<3)|0;f[A>>2]=f[r>>2];f[A+4>>2]=Y;E=E+1|0}while((E|0)!=(U|0));qa=U}}else qa=1}else qa=U;do{E=(f[g>>2]|0)+(qa<<3)|0;f[E>>2]=0;f[E+4>>2]=0;qa=qa+1|0}while((qa|0)!=(j|0));if(!((B|0)==(_|0)|(B|0)==0))dYc(B)}else f[h>>2]=j;na=f[g>>2]|0;oa=f[h>>2]|0}aa=$+1|0;U=na+($<<3)|0;f[U>>2]=da;f[U+4>>2]=fa;if(!aa){ia=x;break}else{Z=x;t=na;u=oa;v=fa}}if(w)R=ia;else{f[c+(ia<<3)>>2]=f[a+(o<<3)>>2];f[c+(ia<<3)+4>>2]=f[a+(o<<3)+4>>2];R=ia+1|0}}ia=d?R+-1|0:0;o=ia+1|0;a=(o|0)>=(R|0)?0:o;o=f[c+(a<<3)>>2]|0;w=f[c+(a<<3)+4>>2]|0;fa=a+1|0;v=(d^1)&1;oa=R-v|0;if((R|0)>2&(v|0)<(oa|0)){ga=l*.5;u=a;na=v;v=R;t=(fa|0)>=(R|0)?0:fa;fa=o;Z=f[c+(ia<<3)>>2]|0;aa=w;da=f[c+(ia<<3)+4>>2]|0;while(1){ia=f[c+(t<<3)>>2]|0;h=f[c+(t<<3)+4>>2]|0;g=t+1|0;_=(g|0)>=(R|0)?0:g;l=(f[s>>2]=ia,+n[s>>2]);M=(f[s>>2]=Z,+n[s>>2]);e=l-M;D=e;H=(f[s>>2]=h,+n[s>>2]);ra=(f[s>>2]=da,+n[s>>2]);sa=H-ra;ta=sa;ua=(f[s>>2]=fa,+n[s>>2]);va=ua-M;M=(f[s>>2]=aa,+n[s>>2]);wa=M-ra;ra=+L(+(va*ta-wa*D));if(va*(l-ua)+wa*(H-M)>=0.0&(sa!=0.0&(e!=0.0?ra*ra<=ga*(D*D+ta*ta):0))){f[c+(u<<3)>>2]=ia;f[c+(u<<3)+4>>2]=h;g=u+1|0;qa=_+1|0;xa=(g|0)>=(R|0)?0:g;ya=na+1|0;za=v+-1|0;Aa=(qa|0)>=(R|0)?0:qa;Ba=f[c+(_<<3)>>2]|0;Ca=ia;Da=f[c+(_<<3)+4>>2]|0;Ea=h}else{f[c+(u<<3)>>2]=fa;f[c+(u<<3)+4>>2]=aa;qa=u+1|0;xa=(qa|0)>=(R|0)?0:qa;ya=na;za=v;Aa=_;Ba=ia;Ca=fa;Da=h;Ea=aa}na=ya+1|0;if(!((za|0)>2&(na|0)<(oa|0))){Fa=xa;Ga=za;Ha=Ba;Ia=Da;break}else{u=xa;v=za;t=Aa;fa=Ba;Z=Ca;aa=Da;da=Ea}}}else{Fa=a;Ga=R;Ha=o;Ia=w}if(d){k=Ga;return k|0}f[c+(Fa<<3)>>2]=Ha;f[c+(Fa<<3)+4>>2]=Ia;k=Ga;return k|0}function Vra(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+32|0;i=h;j=h+8|0;k=c&7;l=d&7;if((d^c)&4088|0){m=$Xc(48)|0;f[j>>2]=m;f[j+8>>2]=-2147483600;f[j+4>>2]=40;n=m;o=274973;p=n+40|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+40>>0]=0;vM(-215,j,275014,275030,1405)}m=(g|0)<0?(e|0)/2|0:g;g=(k|0)==0;o=(l|0)==4;do if(!(g&o)){if(g&(l|0)==2){n=$Xc(24)|0;f[n+4>>2]=0;f[n+8>>2]=0;f[n>>2]=60700;p=n+12|0;Wba(p);q=n;r=60952;s=p;break}p=(l|0)==6;if(g&p){n=$Xc(24)|0;f[n+4>>2]=0;f[n+8>>2]=0;f[n>>2]=60728;t=n+12|0;Wba(t);q=n;r=60972;s=t;break}t=(k|0)==2;if(t&o){n=$Xc(24)|0;f[n+4>>2]=0;f[n+8>>2]=0;f[n>>2]=60756;v=n+12|0;Wba(v);q=n;r=60992;s=v;break}if(t&p){t=$Xc(24)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=60784;v=t+12|0;Wba(v);q=t;r=61012;s=v;break}v=(k|0)==3;if(v&o){t=$Xc(24)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=60812;n=t+12|0;Wba(n);q=t;r=61032;s=n;break}if((k|0)==4&o){n=$Xc(24)|0;f[n+4>>2]=0;f[n+8>>2]=0;f[n>>2]=60840;t=n+12|0;Wba(t);q=n;r=61052;s=t;break}if(v&p){v=$Xc(24)|0;f[v+4>>2]=0;f[v+8>>2]=0;f[v>>2]=60868;t=v+12|0;Wba(t);q=v;r=61072;s=t;break}if((k|0)==5&p){t=$Xc(24)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=60896;v=t+12|0;Wba(v);q=t;r=61092;s=v;break}if((k|0)==6&p){p=$Xc(24)|0;f[p+4>>2]=0;f[p+8>>2]=0;f[p>>2]=60924;v=p+12|0;Wba(v);q=p;r=61112;s=v;break}else{f[i>>2]=c;f[i+4>>2]=d;DM(j,275105,i);vM(-213,j,275014,275030,1433)}}else{v=$Xc(24)|0;f[v+4>>2]=0;f[v+8>>2]=0;f[v>>2]=60672;p=v+12|0;Wba(p);q=v;r=61132;s=p}while(0);f[s>>2]=r;f[q+16>>2]=e;f[q+20>>2]=m;f[a>>2]=s;f[a+4>>2]=q;u=h;return}function Wra(a){a=a|0;cYc(a);return}function Xra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{f[c+(k<<2)>>2]=(h[b+(k+e)>>0]|0)+(h[b+k>>0]|0)+(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{f[c+(l<<2)>>2]=(h[b+(l+e)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+d)>>0]|0)+(h[b+(l+k)>>0]|0)+(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){j=(h[b+l>>0]|0)+g|0;l=l+1|0;if((l|0)==(a|0)){m=j;break}else g=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=m;o=0}else return;do{n=(h[b+(o+a)>>0]|0)-(h[b+o>>0]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(i|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;g=0;while(1){l=(h[b+g>>0]|0)+m|0;j=(h[b+(g+1)>>0]|0)+n|0;k=(h[b+(g+2)>>0]|0)+o|0;g=g+3|0;if((g|0)>=(a|0)){p=k;q=j;r=l;break}else{o=k;n=j;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((i|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(h[b+r>>0]|0)-(h[b+v>>0]|0)+u|0;t=(h[b+(r+1)>>0]|0)-(h[b+(v+1)>>0]|0)+t|0;s=(h[b+(r+2)>>0]|0)-(h[b+(v+2)>>0]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(i|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(h[b+r>>0]|0)+u|0;p=(h[b+(r|1)>>0]|0)+t|0;m=(h[b+(r|2)>>0]|0)+s|0;n=(h[b+(r|3)>>0]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((i|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(h[b+z>>0]|0)-(h[b+E>>0]|0)+D|0;C=(h[b+(z+1)>>0]|0)-(h[b+(E|1)>>0]|0)+C|0;B=(h[b+(z+2)>>0]|0)-(h[b+(E|2)>>0]|0)+B|0;A=(h[b+(z+3)>>0]|0)-(h[b+(E|3)>>0]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(i|0));return}default:{if((e|0)<=0)return;E=(i|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(h[C+z>>0]|0)+D|0;z=z+e|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(h[C+(y+a)>>0]|0)-(h[C+y>>0]|0)+z|0;y=y+e|0;f[B+(y<<2)>>2]=z}while((y|0)<(i|0))}A=A+1|0;if((A|0)==(e|0))break;else{B=B+4|0;C=C+1|0}}return}if(E){F=0;G=c;H=b}else{g1c(c|0,0,e<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(h[H+(b+a)>>0]|0)-(h[H+b>>0]|0)+c|0;b=b+e|0;f[G+(b<<2)>>2]=c}while((b|0)<(i|0));F=F+1|0;if((F|0)==(e|0))break;else{G=G+4|0;H=H+1|0}}return}}}}function Yra(a){a=a|0;cYc(a);return}function Zra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+p[b+(j<<3)>>3]+ +p[b+(j+e<<3)>>3]+ +p[b+(j+i<<3)>>3];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+p[b+(k<<3)>>3]+ +p[b+(k+e<<3)>>3]+ +p[b+(k+d<<3)>>3]+ +p[b+(k+j<<3)>>3]+ +p[b+(k+i<<3)>>3];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){l=0.0;g=0;while(1){m=l+ +p[b+(g<<3)>>3];g=g+1|0;if((g|0)==(a|0)){n=m;break}else l=m}}else n=0.0;p[c>>3]=n;if((h|0)>0){o=n;q=0}else return;do{o=o+(+p[b+(q+a<<3)>>3]-+p[b+(q<<3)>>3]);q=q+1|0;p[c+(q<<3)>>3]=o}while((q|0)!=(h|0));return}case 3:{if((a|0)>0){o=0.0;n=0.0;l=0.0;q=0;while(1){m=l+ +p[b+(q<<3)>>3];r=n+ +p[b+(q+1<<3)>>3];s=o+ +p[b+(q+2<<3)>>3];q=q+3|0;if((q|0)>=(a|0)){t=s;u=r;v=m;break}else{o=s;n=r;l=m}}}else{t=0.0;u=0.0;v=0.0}p[c>>3]=v;p[c+8>>3]=u;p[c+16>>3]=t;if((h|0)>0){w=t;x=u;y=v;z=0}else return;do{q=z+a|0;y=y+(+p[b+(q<<3)>>3]-+p[b+(z<<3)>>3]);x=x+(+p[b+(q+1<<3)>>3]-+p[b+(z+1<<3)>>3]);w=w+(+p[b+(q+2<<3)>>3]-+p[b+(z+2<<3)>>3]);q=z;z=z+3|0;p[c+(z<<3)>>3]=y;p[c+(q+4<<3)>>3]=x;p[c+(q+5<<3)>>3]=w}while((z|0)<(h|0));return}case 4:{if((a|0)>0){w=0.0;x=0.0;y=0.0;v=0.0;z=0;while(1){u=v+ +p[b+(z<<3)>>3];t=y+ +p[b+((z|1)<<3)>>3];l=x+ +p[b+((z|2)<<3)>>3];n=w+ +p[b+((z|3)<<3)>>3];z=z+4|0;if((z|0)>=(a|0)){A=n;B=l;C=t;D=u;break}else{w=n;x=l;y=t;v=u}}}else{A=0.0;B=0.0;C=0.0;D=0.0}p[c>>3]=D;p[c+8>>3]=C;p[c+16>>3]=B;p[c+24>>3]=A;if((h|0)>0){E=A;F=B;G=C;H=D;I=0}else return;do{z=I+a|0;H=H+(+p[b+(z<<3)>>3]-+p[b+(I<<3)>>3]);G=G+(+p[b+(z+1<<3)>>3]-+p[b+((I|1)<<3)>>3]);F=F+(+p[b+(z+2<<3)>>3]-+p[b+((I|2)<<3)>>3]);E=E+(+p[b+(z+3<<3)>>3]-+p[b+((I|3)<<3)>>3]);z=I;I=I+4|0;p[c+(I<<3)>>3]=H;p[c+(z+5<<3)>>3]=G;p[c+(z+6<<3)>>3]=F;p[c+(z+7<<3)>>3]=E}while((I|0)<(h|0));return}default:{if((e|0)<=0)return;I=(h|0)>0;if((a|0)>0){z=0;q=c;g=b;while(1){E=0.0;k=0;do{E=E+ +p[g+(k<<3)>>3];k=k+e|0}while((k|0)<(a|0));p[q>>3]=E;if(I){F=E;k=0;do{F=F+(+p[g+(k+a<<3)>>3]-+p[g+(k<<3)>>3]);k=k+e|0;p[q+(k<<3)>>3]=F}while((k|0)<(h|0))}z=z+1|0;if((z|0)==(e|0))break;else{q=q+8|0;g=g+8|0}}return}if(I){J=0;K=c;L=b}else{g1c(c|0,0,e<<3|0)|0;return}while(1){p[K>>3]=0.0;F=0.0;c=0;do{F=F+(+p[L+(c+a<<3)>>3]-+p[L+(c<<3)>>3]);c=c+e|0;p[K+(c<<3)>>3]=F}while((c|0)<(h|0));J=J+1|0;if((J|0)==(e|0))break;else{K=K+8|0;L=L+8|0}}return}}}}function _ra(a){a=a|0;cYc(a);return}function $ra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+n[b+(j<<2)>>2]+ +n[b+(j+e<<2)>>2]+ +n[b+(j+i<<2)>>2];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+n[b+(k<<2)>>2]+ +n[b+(k+e<<2)>>2]+ +n[b+(k+d<<2)>>2]+ +n[b+(k+j<<2)>>2]+ +n[b+(k+i<<2)>>2];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){l=0.0;g=0;while(1){m=l+ +n[b+(g<<2)>>2];g=g+1|0;if((g|0)==(a|0)){o=m;break}else l=m}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=o;r=0}else return;do{q=q+(+n[b+(r+a<<2)>>2]-+n[b+(r<<2)>>2]);r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(h|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;l=0.0;r=0;while(1){m=l+ +n[b+(r<<2)>>2];s=o+ +n[b+(r+1<<2)>>2];t=q+ +n[b+(r+2<<2)>>2];r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=m;break}else{q=t;o=s;l=m}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((h|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+n[b+(r<<2)>>2]-+n[b+(A<<2)>>2]);y=y+(+n[b+(r+1<<2)>>2]-+n[b+(A+1<<2)>>2]);x=x+(+n[b+(r+2<<2)>>2]-+n[b+(A+2<<2)>>2]);r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(h|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +n[b+(A<<2)>>2];u=z+ +n[b+((A|1)<<2)>>2];l=y+ +n[b+((A|2)<<2)>>2];o=x+ +n[b+((A|3)<<2)>>2];A=A+4|0;if((A|0)>=(a|0)){B=o;C=l;D=u;E=v;break}else{x=o;y=l;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((h|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+n[b+(A<<2)>>2]-+n[b+(J<<2)>>2]);H=H+(+n[b+(A+1<<2)>>2]-+n[b+((J|1)<<2)>>2]);G=G+(+n[b+(A+2<<2)>>2]-+n[b+((J|2)<<2)>>2]);F=F+(+n[b+(A+3<<2)>>2]-+n[b+((J|3)<<2)>>2]);A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(h|0));return}default:{if((e|0)<=0)return;J=(h|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;k=0;do{F=F+ +n[g+(k<<2)>>2];k=k+e|0}while((k|0)<(a|0));p[r>>3]=F;if(J){G=F;k=0;do{G=G+(+n[g+(k+a<<2)>>2]-+n[g+(k<<2)>>2]);k=k+e|0;p[r+(k<<3)>>3]=G}while((k|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+4|0}}return}if(J){K=0;L=c;M=b}else{g1c(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+n[M+(c+a<<2)>>2]-+n[M+(c<<2)>>2]);c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(h|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+4|0}}return}}}}function asa(a){a=a|0;cYc(a);return}function bsa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{p[c+(k<<3)>>3]=+(d[b+(k<<1)>>1]|0)+ +(d[b+(k+g<<1)>>1]|0)+ +(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{p[c+(l<<3)>>3]=+(d[b+(l<<1)>>1]|0)+ +(d[b+(l+g<<1)>>1]|0)+ +(d[b+(l+e<<1)>>1]|0)+ +(d[b+(l+k<<1)>>1]|0)+ +(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){m=0.0;h=0;while(1){n=m+ +(d[b+(h<<1)>>1]|0);h=h+1|0;if((h|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=o;r=0}else return;do{q=q+(+(d[b+(r+a<<1)>>1]|0)-+(d[b+(r<<1)>>1]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(i|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(d[b+(r<<1)>>1]|0);s=o+ +(d[b+(r+1<<1)>>1]|0);t=q+ +(d[b+(r+2<<1)>>1]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((i|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(d[b+(r<<1)>>1]|0)-+(d[b+(A<<1)>>1]|0));y=y+(+(d[b+(r+1<<1)>>1]|0)-+(d[b+(A+1<<1)>>1]|0));x=x+(+(d[b+(r+2<<1)>>1]|0)-+(d[b+(A+2<<1)>>1]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(i|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(d[b+(A<<1)>>1]|0);u=z+ +(d[b+((A|1)<<1)>>1]|0);m=y+ +(d[b+((A|2)<<1)>>1]|0);o=x+ +(d[b+((A|3)<<1)>>1]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((i|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(d[b+(A<<1)>>1]|0)-+(d[b+(J<<1)>>1]|0));H=H+(+(d[b+(A+1<<1)>>1]|0)-+(d[b+((J|1)<<1)>>1]|0));G=G+(+(d[b+(A+2<<1)>>1]|0)-+(d[b+((J|2)<<1)>>1]|0));F=F+(+(d[b+(A+3<<1)>>1]|0)-+(d[b+((J|3)<<1)>>1]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(i|0));return}default:{if((g|0)<=0)return;J=(i|0)>0;if((a|0)>0){A=0;r=c;h=b;while(1){F=0.0;l=0;do{F=F+ +(d[h+(l<<1)>>1]|0);l=l+g|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(d[h+(l+a<<1)>>1]|0)-+(d[h+(l<<1)>>1]|0));l=l+g|0;p[r+(l<<3)>>3]=G}while((l|0)<(i|0))}A=A+1|0;if((A|0)==(g|0))break;else{r=r+8|0;h=h+2|0}}return}if(J){K=0;L=c;M=b}else{g1c(c|0,0,g<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(d[M+(c+a<<1)>>1]|0)-+(d[M+(c<<1)>>1]|0));c=c+g|0;p[L+(c<<3)>>3]=G}while((c|0)<(i|0));K=K+1|0;if((K|0)==(g|0))break;else{L=L+8|0;M=M+2|0}}return}}}}function csa(a){a=a|0;cYc(a);return}function dsa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{f[c+(j<<2)>>2]=(f[b+(j+e<<2)>>2]|0)+(f[b+(j<<2)>>2]|0)+(f[b+(j+i<<2)>>2]|0);j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{f[c+(k<<2)>>2]=(f[b+(k+e<<2)>>2]|0)+(f[b+(k<<2)>>2]|0)+(f[b+(k+d<<2)>>2]|0)+(f[b+(k+j<<2)>>2]|0)+(f[b+(k+i<<2)>>2]|0);k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;k=0;while(1){i=(f[b+(k<<2)>>2]|0)+g|0;k=k+1|0;if((k|0)==(a|0)){l=i;break}else g=i}}else l=0;f[c>>2]=l;if((h|0)>0){m=l;n=0}else return;do{m=(f[b+(n+a<<2)>>2]|0)-(f[b+(n<<2)>>2]|0)+m|0;n=n+1|0;f[c+(n<<2)>>2]=m}while((n|0)!=(h|0));return}case 3:{if((a|0)>0){n=0;m=0;l=0;g=0;while(1){k=(f[b+(g<<2)>>2]|0)+l|0;i=(f[b+(g+1<<2)>>2]|0)+m|0;j=(f[b+(g+2<<2)>>2]|0)+n|0;g=g+3|0;if((g|0)>=(a|0)){o=j;p=i;q=k;break}else{n=j;m=i;l=k}}}else{o=0;p=0;q=0}f[c>>2]=q;f[c+4>>2]=p;f[c+8>>2]=o;if((h|0)>0){r=o;s=p;t=q;u=0}else return;do{q=u+a|0;t=(f[b+(q<<2)>>2]|0)-(f[b+(u<<2)>>2]|0)+t|0;s=(f[b+(q+1<<2)>>2]|0)-(f[b+(u+1<<2)>>2]|0)+s|0;r=(f[b+(q+2<<2)>>2]|0)-(f[b+(u+2<<2)>>2]|0)+r|0;q=u;u=u+3|0;f[c+(u<<2)>>2]=t;f[c+(q+4<<2)>>2]=s;f[c+(q+5<<2)>>2]=r}while((u|0)<(h|0));return}case 4:{if((a|0)>0){u=0;r=0;s=0;t=0;q=0;while(1){p=(f[b+(q<<2)>>2]|0)+t|0;o=(f[b+((q|1)<<2)>>2]|0)+s|0;l=(f[b+((q|2)<<2)>>2]|0)+r|0;m=(f[b+((q|3)<<2)>>2]|0)+u|0;q=q+4|0;if((q|0)>=(a|0)){v=m;w=l;x=o;y=p;break}else{u=m;r=l;s=o;t=p}}}else{v=0;w=0;x=0;y=0}f[c>>2]=y;f[c+4>>2]=x;f[c+8>>2]=w;f[c+12>>2]=v;if((h|0)>0){z=v;A=w;B=x;C=y;D=0}else return;do{y=D+a|0;C=(f[b+(y<<2)>>2]|0)-(f[b+(D<<2)>>2]|0)+C|0;B=(f[b+(y+1<<2)>>2]|0)-(f[b+((D|1)<<2)>>2]|0)+B|0;A=(f[b+(y+2<<2)>>2]|0)-(f[b+((D|2)<<2)>>2]|0)+A|0;z=(f[b+(y+3<<2)>>2]|0)-(f[b+((D|3)<<2)>>2]|0)+z|0;y=D;D=D+4|0;f[c+(D<<2)>>2]=C;f[c+(y+5<<2)>>2]=B;f[c+(y+6<<2)>>2]=A;f[c+(y+7<<2)>>2]=z}while((D|0)<(h|0));return}default:{if((e|0)<=0)return;D=(h|0)>0;if((a|0)>0){z=0;A=c;B=b;while(1){C=0;y=0;do{C=(f[B+(y<<2)>>2]|0)+C|0;y=y+e|0}while((y|0)<(a|0));f[A>>2]=C;if(D){y=C;x=0;do{y=(f[B+(x+a<<2)>>2]|0)-(f[B+(x<<2)>>2]|0)+y|0;x=x+e|0;f[A+(x<<2)>>2]=y}while((x|0)<(h|0))}z=z+1|0;if((z|0)==(e|0))break;else{A=A+4|0;B=B+4|0}}return}if(D){E=0;F=c;G=b}else{g1c(c|0,0,e<<2|0)|0;return}while(1){f[F>>2]=0;c=0;b=0;do{c=(f[G+(b+a<<2)>>2]|0)-(f[G+(b<<2)>>2]|0)+c|0;b=b+e|0;f[F+(b<<2)>>2]=c}while((b|0)<(h|0));E=E+1|0;if((E|0)==(e|0))break;else{F=F+4|0;G=G+4|0}}return}}}}function esa(a){a=a|0;cYc(a);return}function fsa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{f[c+(k<<2)>>2]=(d[b+(k+g<<1)>>1]|0)+(d[b+(k<<1)>>1]|0)+(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{f[c+(l<<2)>>2]=(d[b+(l+g<<1)>>1]|0)+(d[b+(l<<1)>>1]|0)+(d[b+(l+e<<1)>>1]|0)+(d[b+(l+k<<1)>>1]|0)+(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){h=0;l=0;while(1){j=(d[b+(l<<1)>>1]|0)+h|0;l=l+1|0;if((l|0)==(a|0)){m=j;break}else h=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=m;o=0}else return;do{n=(d[b+(o+a<<1)>>1]|0)-(d[b+(o<<1)>>1]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(i|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;h=0;while(1){l=(d[b+(h<<1)>>1]|0)+m|0;j=(d[b+(h+1<<1)>>1]|0)+n|0;k=(d[b+(h+2<<1)>>1]|0)+o|0;h=h+3|0;if((h|0)>=(a|0)){p=k;q=j;r=l;break}else{o=k;n=j;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((i|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(d[b+(r<<1)>>1]|0)-(d[b+(v<<1)>>1]|0)+u|0;t=(d[b+(r+1<<1)>>1]|0)-(d[b+(v+1<<1)>>1]|0)+t|0;s=(d[b+(r+2<<1)>>1]|0)-(d[b+(v+2<<1)>>1]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(i|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(d[b+(r<<1)>>1]|0)+u|0;p=(d[b+((r|1)<<1)>>1]|0)+t|0;m=(d[b+((r|2)<<1)>>1]|0)+s|0;n=(d[b+((r|3)<<1)>>1]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((i|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(d[b+(z<<1)>>1]|0)-(d[b+(E<<1)>>1]|0)+D|0;C=(d[b+(z+1<<1)>>1]|0)-(d[b+((E|1)<<1)>>1]|0)+C|0;B=(d[b+(z+2<<1)>>1]|0)-(d[b+((E|2)<<1)>>1]|0)+B|0;A=(d[b+(z+3<<1)>>1]|0)-(d[b+((E|3)<<1)>>1]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(i|0));return}default:{if((g|0)<=0)return;E=(i|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(d[C+(z<<1)>>1]|0)+D|0;z=z+g|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(d[C+(y+a<<1)>>1]|0)-(d[C+(y<<1)>>1]|0)+z|0;y=y+g|0;f[B+(y<<2)>>2]=z}while((y|0)<(i|0))}A=A+1|0;if((A|0)==(g|0))break;else{B=B+4|0;C=C+2|0}}return}if(E){F=0;G=c;H=b}else{g1c(c|0,0,g<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(d[H+(b+a<<1)>>1]|0)-(d[H+(b<<1)>>1]|0)+c|0;b=b+g|0;f[G+(b<<2)>>2]=c}while((b|0)<(i|0));F=F+1|0;if((F|0)==(g|0))break;else{G=G+4|0;H=H+2|0}}return}}}}function gsa(a){a=a|0;cYc(a);return}function hsa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{p[c+(k<<3)>>3]=+(j[b+(k<<1)>>1]|0)+ +(j[b+(k+e<<1)>>1]|0)+ +(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{p[c+(l<<3)>>3]=+(j[b+(l<<1)>>1]|0)+ +(j[b+(l+e<<1)>>1]|0)+ +(j[b+(l+d<<1)>>1]|0)+ +(j[b+(l+k<<1)>>1]|0)+ +(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){m=0.0;g=0;while(1){n=m+ +(j[b+(g<<1)>>1]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=o;r=0}else return;do{q=q+(+(j[b+(r+a<<1)>>1]|0)-+(j[b+(r<<1)>>1]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(h|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(j[b+(r<<1)>>1]|0);s=o+ +(j[b+(r+1<<1)>>1]|0);t=q+ +(j[b+(r+2<<1)>>1]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((h|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(j[b+(r<<1)>>1]|0)-+(j[b+(A<<1)>>1]|0));y=y+(+(j[b+(r+1<<1)>>1]|0)-+(j[b+(A+1<<1)>>1]|0));x=x+(+(j[b+(r+2<<1)>>1]|0)-+(j[b+(A+2<<1)>>1]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(h|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(j[b+(A<<1)>>1]|0);u=z+ +(j[b+((A|1)<<1)>>1]|0);m=y+ +(j[b+((A|2)<<1)>>1]|0);o=x+ +(j[b+((A|3)<<1)>>1]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((h|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(j[b+(A<<1)>>1]|0)-+(j[b+(J<<1)>>1]|0));H=H+(+(j[b+(A+1<<1)>>1]|0)-+(j[b+((J|1)<<1)>>1]|0));G=G+(+(j[b+(A+2<<1)>>1]|0)-+(j[b+((J|2)<<1)>>1]|0));F=F+(+(j[b+(A+3<<1)>>1]|0)-+(j[b+((J|3)<<1)>>1]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(h|0));return}default:{if((e|0)<=0)return;J=(h|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;l=0;do{F=F+ +(j[g+(l<<1)>>1]|0);l=l+e|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(j[g+(l+a<<1)>>1]|0)-+(j[g+(l<<1)>>1]|0));l=l+e|0;p[r+(l<<3)>>3]=G}while((l|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+2|0}}return}if(J){K=0;L=c;M=b}else{g1c(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(j[M+(c+a<<1)>>1]|0)-+(j[M+(c<<1)>>1]|0));c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(h|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+2|0}}return}}}}function isa(a){a=a|0;cYc(a);return}function jsa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{f[c+(k<<2)>>2]=(j[b+(k+e<<1)>>1]|0)+(j[b+(k<<1)>>1]|0)+(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{f[c+(l<<2)>>2]=(j[b+(l+e<<1)>>1]|0)+(j[b+(l<<1)>>1]|0)+(j[b+(l+d<<1)>>1]|0)+(j[b+(l+k<<1)>>1]|0)+(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){i=(j[b+(l<<1)>>1]|0)+g|0;l=l+1|0;if((l|0)==(a|0)){m=i;break}else g=i}}else m=0;f[c>>2]=m;if((h|0)>0){n=m;o=0}else return;do{n=(j[b+(o+a<<1)>>1]|0)-(j[b+(o<<1)>>1]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(h|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;g=0;while(1){l=(j[b+(g<<1)>>1]|0)+m|0;i=(j[b+(g+1<<1)>>1]|0)+n|0;k=(j[b+(g+2<<1)>>1]|0)+o|0;g=g+3|0;if((g|0)>=(a|0)){p=k;q=i;r=l;break}else{o=k;n=i;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((h|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(j[b+(r<<1)>>1]|0)-(j[b+(v<<1)>>1]|0)+u|0;t=(j[b+(r+1<<1)>>1]|0)-(j[b+(v+1<<1)>>1]|0)+t|0;s=(j[b+(r+2<<1)>>1]|0)-(j[b+(v+2<<1)>>1]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(h|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(j[b+(r<<1)>>1]|0)+u|0;p=(j[b+((r|1)<<1)>>1]|0)+t|0;m=(j[b+((r|2)<<1)>>1]|0)+s|0;n=(j[b+((r|3)<<1)>>1]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((h|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(j[b+(z<<1)>>1]|0)-(j[b+(E<<1)>>1]|0)+D|0;C=(j[b+(z+1<<1)>>1]|0)-(j[b+((E|1)<<1)>>1]|0)+C|0;B=(j[b+(z+2<<1)>>1]|0)-(j[b+((E|2)<<1)>>1]|0)+B|0;A=(j[b+(z+3<<1)>>1]|0)-(j[b+((E|3)<<1)>>1]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(h|0));return}default:{if((e|0)<=0)return;E=(h|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(j[C+(z<<1)>>1]|0)+D|0;z=z+e|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(j[C+(y+a<<1)>>1]|0)-(j[C+(y<<1)>>1]|0)+z|0;y=y+e|0;f[B+(y<<2)>>2]=z}while((y|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{B=B+4|0;C=C+2|0}}return}if(E){F=0;G=c;H=b}else{g1c(c|0,0,e<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(j[H+(b+a<<1)>>1]|0)-(j[H+(b<<1)>>1]|0)+c|0;b=b+e|0;f[G+(b<<2)>>2]=c}while((b|0)<(h|0));F=F+1|0;if((F|0)==(e|0))break;else{G=G+4|0;H=H+2|0}}return}}}}function ksa(a){a=a|0;cYc(a);return}function lsa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{p[c+(k<<3)>>3]=+(h[b+k>>0]|0)+ +(h[b+(k+e)>>0]|0)+ +(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{p[c+(l<<3)>>3]=+(h[b+l>>0]|0)+ +(h[b+(l+e)>>0]|0)+ +(h[b+(l+d)>>0]|0)+ +(h[b+(l+k)>>0]|0)+ +(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){m=0.0;g=0;while(1){n=m+ +(h[b+g>>0]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=o;r=0}else return;do{q=q+(+(h[b+(r+a)>>0]|0)-+(h[b+r>>0]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(i|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(h[b+r>>0]|0);s=o+ +(h[b+(r+1)>>0]|0);t=q+ +(h[b+(r+2)>>0]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((i|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(h[b+r>>0]|0)-+(h[b+A>>0]|0));y=y+(+(h[b+(r+1)>>0]|0)-+(h[b+(A+1)>>0]|0));x=x+(+(h[b+(r+2)>>0]|0)-+(h[b+(A+2)>>0]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(i|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(h[b+A>>0]|0);u=z+ +(h[b+(A|1)>>0]|0);m=y+ +(h[b+(A|2)>>0]|0);o=x+ +(h[b+(A|3)>>0]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((i|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(h[b+A>>0]|0)-+(h[b+J>>0]|0));H=H+(+(h[b+(A+1)>>0]|0)-+(h[b+(J|1)>>0]|0));G=G+(+(h[b+(A+2)>>0]|0)-+(h[b+(J|2)>>0]|0));F=F+(+(h[b+(A+3)>>0]|0)-+(h[b+(J|3)>>0]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(i|0));return}default:{if((e|0)<=0)return;J=(i|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;l=0;do{F=F+ +(h[g+l>>0]|0);l=l+e|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(h[g+(l+a)>>0]|0)-+(h[g+l>>0]|0));l=l+e|0;p[r+(l<<3)>>3]=G}while((l|0)<(i|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+1|0}}return}if(J){K=0;L=c;M=b}else{g1c(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(h[M+(c+a)>>0]|0)-+(h[M+c>>0]|0));c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(i|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+1|0}}return}}}}function msa(a){a=a|0;cYc(a);return}function nsa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=Y(i,g)|0;j=Y(e+-1|0,g)|0;switch(i|0){case 3:{i=Y(g,e)|0;if((i|0)<=0)return;k=g<<1;l=0;do{d[c+(l<<1)>>1]=(h[b+(l+g)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+k)>>0]|0);l=l+1|0}while((l|0)!=(i|0));return}case 5:{i=Y(g,e)|0;if((i|0)<=0)return;e=g<<1;l=g*3|0;k=g<<2;m=0;do{d[c+(m<<1)>>1]=(h[b+(m+g)>>0]|0)+(h[b+m>>0]|0)+(h[b+(m+e)>>0]|0)+(h[b+(m+l)>>0]|0)+(h[b+(m+k)>>0]|0);m=m+1|0}while((m|0)!=(i|0));return}default:switch(g|0){case 1:{if((a|0)>0){i=0;m=0;do{i=(h[b+m>>0]|0)+(i&65535)|0;m=m+1|0}while((m|0)!=(a|0));n=i&65535}else n=0;d[c>>1]=n;if((j|0)>0){o=n;p=0}else return;do{o=(h[b+(p+a)>>0]|0)+(o&65535)-(h[b+p>>0]|0)&65535;p=p+1|0;d[c+(p<<1)>>1]=o}while((p|0)!=(j|0));return}case 3:{if((a|0)>0){p=0;o=0;n=0;i=0;do{n=(h[b+i>>0]|0)+(n&65535)|0;o=(h[b+(i+1)>>0]|0)+(o&65535)|0;p=(h[b+(i+2)>>0]|0)+(p&65535)|0;i=i+3|0}while((i|0)<(a|0));q=p&65535;r=o&65535;s=n&65535}else{q=0;r=0;s=0}d[c>>1]=s;d[c+2>>1]=r;d[c+4>>1]=q;if((j|0)>0){t=q;u=r;v=s;w=0}else return;do{s=w+a|0;v=(h[b+s>>0]|0)+(v&65535)-(h[b+w>>0]|0)&65535;u=(h[b+(s+1)>>0]|0)+(u&65535)-(h[b+(w+1)>>0]|0)&65535;t=(h[b+(s+2)>>0]|0)+(t&65535)-(h[b+(w+2)>>0]|0)&65535;s=w;w=w+3|0;d[c+(w<<1)>>1]=v;d[c+(s+4<<1)>>1]=u;d[c+(s+5<<1)>>1]=t}while((w|0)<(j|0));return}case 4:{if((a|0)>0){w=0;t=0;u=0;v=0;s=0;do{v=(h[b+s>>0]|0)+(v&65535)|0;u=(h[b+(s|1)>>0]|0)+(u&65535)|0;t=(h[b+(s|2)>>0]|0)+(t&65535)|0;w=(h[b+(s|3)>>0]|0)+(w&65535)|0;s=s+4|0}while((s|0)<(a|0));x=w&65535;y=t&65535;z=u&65535;A=v&65535}else{x=0;y=0;z=0;A=0}d[c>>1]=A;d[c+2>>1]=z;d[c+4>>1]=y;d[c+6>>1]=x;if((j|0)>0){B=x;C=y;D=z;E=A;F=0}else return;do{A=F+a|0;E=(h[b+A>>0]|0)+(E&65535)-(h[b+F>>0]|0)&65535;D=(h[b+(A+1)>>0]|0)+(D&65535)-(h[b+(F|1)>>0]|0)&65535;C=(h[b+(A+2)>>0]|0)+(C&65535)-(h[b+(F|2)>>0]|0)&65535;B=(h[b+(A+3)>>0]|0)+(B&65535)-(h[b+(F|3)>>0]|0)&65535;A=F;F=F+4|0;d[c+(F<<1)>>1]=E;d[c+(A+5<<1)>>1]=D;d[c+(A+6<<1)>>1]=C;d[c+(A+7<<1)>>1]=B}while((F|0)<(j|0));return}default:{if((g|0)<=0)return;F=(j|0)>0;if((a|0)>0){B=0;C=c;D=b;while(1){E=0;A=0;do{E=(h[D+A>>0]|0)+(E&65535)|0;A=A+g|0}while((A|0)<(a|0));d[C>>1]=E;if(F){A=E;z=0;do{A=(h[D+(z+a)>>0]|0)+(A&65535)-(h[D+z>>0]|0)|0;z=z+g|0;d[C+(z<<1)>>1]=A}while((z|0)<(j|0))}B=B+1|0;if((B|0)==(g|0))break;else{C=C+2|0;D=D+1|0}}return}if(F){G=0;H=c;I=b}else{g1c(c|0,0,g<<1|0)|0;return}while(1){d[H>>1]=0;c=0;b=0;do{c=(h[I+(b+a)>>0]|0)+(c&65535)-(h[I+b>>0]|0)|0;b=b+g|0;d[H+(b<<1)>>1]=c}while((b|0)<(j|0));G=G+1|0;if((G|0)==(g|0))break;else{H=H+2|0;I=I+1|0}}return}}}}function osa(a){a=a|0;f[a>>2]=60924;NXc(a);return}function psa(a){a=a|0;f[a>>2]=60924;NXc(a);cYc(a);return}function qsa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function rsa(a){a=a|0;cYc(a);return}function ssa(a){a=a|0;f[a>>2]=60896;NXc(a);return}function tsa(a){a=a|0;f[a>>2]=60896;NXc(a);cYc(a);return}function usa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function vsa(a){a=a|0;cYc(a);return}function wsa(a){a=a|0;f[a>>2]=60868;NXc(a);return}function xsa(a){a=a|0;f[a>>2]=60868;NXc(a);cYc(a);return}function ysa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function zsa(a){a=a|0;cYc(a);return}function Asa(a){a=a|0;f[a>>2]=60840;NXc(a);return}function Bsa(a){a=a|0;f[a>>2]=60840;NXc(a);cYc(a);return}function Csa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Dsa(a){a=a|0;cYc(a);return}function Esa(a){a=a|0;f[a>>2]=60812;NXc(a);return}function Fsa(a){a=a|0;f[a>>2]=60812;NXc(a);cYc(a);return}function Gsa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Hsa(a){a=a|0;cYc(a);return}function Isa(a){a=a|0;f[a>>2]=60784;NXc(a);return}function Jsa(a){a=a|0;f[a>>2]=60784;NXc(a);cYc(a);return}function Ksa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Lsa(a){a=a|0;cYc(a);return}function Msa(a){a=a|0;f[a>>2]=60756;NXc(a);return}function Nsa(a){a=a|0;f[a>>2]=60756;NXc(a);cYc(a);return}function Osa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Psa(a){a=a|0;cYc(a);return}function Qsa(a){a=a|0;f[a>>2]=60728;NXc(a);return}function Rsa(a){a=a|0;f[a>>2]=60728;NXc(a);cYc(a);return}function Ssa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Tsa(a){a=a|0;cYc(a);return}function Usa(a){a=a|0;f[a>>2]=60700;NXc(a);return}function Vsa(a){a=a|0;f[a>>2]=60700;NXc(a);cYc(a);return}function Wsa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Xsa(a){a=a|0;cYc(a);return}function Ysa(a){a=a|0;f[a>>2]=60672;NXc(a);return}function Zsa(a){a=a|0;f[a>>2]=60672;NXc(a);cYc(a);return}function _sa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function $sa(a){a=a|0;cYc(a);return}function ata(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+48|0;j=i+8|0;k=i+24|0;l=i+20|0;m=i+16|0;n=i;f[l>>2]=e;f[m>>2]=g;p[n>>3]=h;o=c&7;q=d&7;if((d^c)&4088|0){r=$Xc(48)|0;f[k>>2]=r;f[k+8>>2]=-2147483600;f[k+4>>2]=40;s=r;t=276027;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[r+40>>0]=0;vM(-215,k,276068,275030,1441)}if((g|0)<0){r=(e|0)/2|0;f[m>>2]=r;w=r}else w=g;g=(q|0)==0;r=(o|0)==4;if(r&g){t=$Xc(56)|0;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=61152;s=t+16|0;Xba(s);f[s>>2]=61180;f[t+44>>2]=0;f[t+48>>2]=0;f[t+52>>2]=0;f[t+20>>2]=e;f[t+24>>2]=w;p[t+32>>3]=h;f[t+40>>2]=0;x=t;y=s;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}if((o|0)==2&g){bta(k,l,m,n);x=f[k+4>>2]|0;y=f[k>>2]|0;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}n=(o|0)==6;if(n&g){g=$Xc(56)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=61204;o=g+16|0;Xba(o);f[o>>2]=61232;f[g+44>>2]=0;f[g+48>>2]=0;f[g+52>>2]=0;f[g+20>>2]=e;f[g+24>>2]=w;p[g+32>>3]=h;f[g+40>>2]=0;x=g;y=o;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}o=(q|0)==2;if(r&o){g=$Xc(56)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=61256;m=g+16|0;Xba(m);f[m>>2]=61284;f[g+44>>2]=0;f[g+48>>2]=0;f[g+52>>2]=0;f[g+20>>2]=e;f[g+24>>2]=w;p[g+32>>3]=h;f[g+40>>2]=0;x=g;y=m;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}if(n&o){o=$Xc(56)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=61308;m=o+16|0;Xba(m);f[m>>2]=61336;f[o+44>>2]=0;f[o+48>>2]=0;f[o+52>>2]=0;f[o+20>>2]=e;f[o+24>>2]=w;p[o+32>>3]=h;f[o+40>>2]=0;x=o;y=m;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}m=(q|0)==3;if(r&m){o=$Xc(56)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=61360;g=o+16|0;Xba(g);f[g>>2]=61388;f[o+44>>2]=0;f[o+48>>2]=0;f[o+52>>2]=0;f[o+20>>2]=e;f[o+24>>2]=w;p[o+32>>3]=h;f[o+40>>2]=0;x=o;y=g;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}if(n&m){m=$Xc(56)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=61412;g=m+16|0;Xba(g);f[g>>2]=61440;f[m+44>>2]=0;f[m+48>>2]=0;f[m+52>>2]=0;f[m+20>>2]=e;f[m+24>>2]=w;p[m+32>>3]=h;f[m+40>>2]=0;x=m;y=g;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}if(r&(q|0)==4){g=$Xc(56)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=61464;m=g+16|0;Xba(m);f[m>>2]=61492;f[g+44>>2]=0;f[g+48>>2]=0;f[g+52>>2]=0;f[g+20>>2]=e;f[g+24>>2]=w;p[g+32>>3]=h;f[g+40>>2]=0;x=g;y=m;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}m=(q|0)==5;if(r&m){g=$Xc(56)|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=61516;o=g+16|0;Xba(o);f[o>>2]=61544;f[g+44>>2]=0;f[g+48>>2]=0;f[g+52>>2]=0;f[g+20>>2]=e;f[g+24>>2]=w;p[g+32>>3]=h;f[g+40>>2]=0;x=g;y=o;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}if(n&m){m=$Xc(56)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=61568;o=m+16|0;Xba(o);f[o>>2]=61596;f[m+44>>2]=0;f[m+48>>2]=0;f[m+52>>2]=0;f[m+20>>2]=e;f[m+24>>2]=w;p[m+32>>3]=h;f[m+40>>2]=0;x=m;y=o;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}o=(q|0)==6;if(r&o){r=$Xc(56)|0;f[r+4>>2]=0;f[r+8>>2]=0;f[r>>2]=61620;q=r+16|0;Xba(q);f[q>>2]=61648;f[r+44>>2]=0;f[r+48>>2]=0;f[r+52>>2]=0;f[r+20>>2]=e;f[r+24>>2]=w;p[r+32>>3]=h;f[r+40>>2]=0;x=r;y=q;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}if(!(n&o)){f[j>>2]=c;f[j+4>>2]=d;DM(k,276087,j);vM(-213,k,276068,275030,1473)}k=$Xc(56)|0;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=61672;j=k+16|0;Xba(j);f[j>>2]=61700;f[k+44>>2]=0;f[k+48>>2]=0;f[k+52>>2]=0;f[k+20>>2]=e;f[k+24>>2]=w;p[k+32>>3]=h;f[k+40>>2]=0;x=k;y=j;f[a>>2]=y;z=a+4|0;f[z>>2]=x;u=i;return}function bta(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0,k=0;e=$Xc(64)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=61724;g=e+16|0;h=f[b>>2]|0;b=f[c>>2]|0;i=+p[d>>3];Xba(g);f[g>>2]=61752;f[e+52>>2]=0;f[e+56>>2]=0;f[e+60>>2]=0;f[e+20>>2]=h;f[e+24>>2]=b;p[e+32>>3]=i;f[e+40>>2]=0;b=e+44|0;f[b>>2]=0;h=e+48|0;f[h>>2]=1;if(!(i!=1.0)){j=a+4|0;f[a>>2]=g;f[j>>2]=e;return}d=zLc(1.0/i)|0;i=8388608.0/+(d|0);c=~~i;k=c-(+(c|0)>i&1)|0;f[h>>2]=k;c=(d|0)/2|0;f[b>>2]=c;if(i-+(k|0)<.5){f[b>>2]=c+1;j=a+4|0;f[a>>2]=g;f[j>>2]=e;return}else{f[h>>2]=k+1;j=a+4|0;f[a>>2]=g;f[j>>2]=e;return}}function cta(a){a=a|0;var b=0,c=0;f[a>>2]=61700;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function dta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61700;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function eta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{v=$Xc(32)|0;f[j>>2]=v;f[j+8>>2]=-2147483616;f[j+4>>2]=19;t=v;z=276161;A=t+19|0;do{b[t>>0]=b[z>>0]|0;t=t+1|0;z=z+1|0}while((t|0)<(A|0));b[v+19>>0]=0;vM(-215,j,528391,275030,212)}}else{B=q;C=s;D=9}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(t=s+(h<<3)|0,(z|0)!=(t|0)):0){f[n>>2]=z+(~((z+-8-t|0)>>>3)<<3);E=s}else E=s;else{Voa(m,h-r|0);E=f[m>>2]|0}t=a+24|0;f[t>>2]=0;B=t;C=E;D=9}while(0);if((D|0)==9){g1c(C|0,0,h<<3|0)|0;D=f[B>>2]|0;E=f[a+4>>2]|0;a=E+-1|0;if((D|0)<(a|0)){if((h|0)>0){m=c;r=D;while(1){s=f[m>>2]|0;n=0;do{o=C+(n<<3)|0;p[o>>3]=+p[s+(n<<3)>>3]+ +p[o>>3];n=n+1|0}while((n|0)!=(h|0));n=r+1|0;s=m+4|0;if((n|0)<(a|0)){m=s;r=n}else{F=n;G=s;break}}}else{r=D+1|0;m=(a|0)>(r|0)?a:r;F=m;G=c+(m-D<<2)|0}f[B>>2]=F;w=G;x=E;y=C}else{w=c;x=E;y=C}}if(!g){u=i;return}C=1-x|0;x=h+-2|0;E=(h|0)<2;c=h&-2;G=d;d=w;w=g;while(1){w=w+-1|0;g=f[d>>2]|0;F=f[d+(C<<2)>>2]|0;if(l){if(E)H=0;else{B=0;do{D=y+(B<<3)|0;I=+p[D>>3]+ +p[g+(B<<3)>>3];m=B|1;r=y+(m<<3)|0;J=+p[r>>3]+ +p[g+(m<<3)>>3];p[G+(B<<3)>>3]=k*I;p[G+(m<<3)>>3]=k*J;K=J-+p[F+(m<<3)>>3];p[D>>3]=I-+p[F+(B<<3)>>3];p[r>>3]=K;B=B+2|0}while((B|0)<=(x|0));H=c}if((H|0)<(h|0)){B=H;do{r=y+(B<<3)|0;K=+p[r>>3]+ +p[g+(B<<3)>>3];p[G+(B<<3)>>3]=k*K;p[r>>3]=K-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(h|0))}}else{if(E)L=0;else{B=0;do{r=y+(B<<3)|0;K=+p[r>>3]+ +p[g+(B<<3)>>3];D=B|1;m=y+(D<<3)|0;I=+p[m>>3]+ +p[g+(D<<3)>>3];p[G+(B<<3)>>3]=K;p[G+(D<<3)>>3]=I;J=I-+p[F+(D<<3)>>3];p[r>>3]=K-+p[F+(B<<3)>>3];p[m>>3]=J;B=B+2|0}while((B|0)<=(x|0));L=c}if((L|0)<(h|0)){B=L;do{m=y+(B<<3)|0;J=+p[m>>3]+ +p[g+(B<<3)>>3];p[G+(B<<3)>>3]=J;p[m>>3]=J-+p[F+(B<<3)>>3];B=B+1|0}while((B|0)!=(h|0))}}if(!w)break;else{G=G+e|0;d=d+4|0}}u=i;return}function fta(a){a=a|0;f[a+24>>2]=0;return}function gta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61672;f[a+16>>2]=61700;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function hta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61672;f[a+16>>2]=61700;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function ita(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function jta(a){a=a|0;cYc(a);return}function kta(a){a=a|0;var b=0,c=0;f[a>>2]=61648;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function lta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61648;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function mta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{v=$Xc(32)|0;f[j>>2]=v;f[j+8>>2]=-2147483616;f[j+4>>2]=19;t=v;z=276161;A=t+19|0;do{b[t>>0]=b[z>>0]|0;t=t+1|0;z=z+1|0}while((t|0)<(A|0));b[v+19>>0]=0;vM(-215,j,528391,275030,212)}}else{B=q;C=s;D=9}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(t=s+(h<<2)|0,(z|0)!=(t|0)):0){f[n>>2]=z+(~((z+-4-t|0)>>>2)<<2);E=s}else E=s;else{CS(m,h-r|0);E=f[m>>2]|0}t=a+24|0;f[t>>2]=0;B=t;C=E;D=9}while(0);do if((D|0)==9){g1c(C|0,0,h<<2|0)|0;E=f[B>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((E|0)<(s|0)){if((h|0)>0)F=c;else{n=c;o=E;do{o=o+1|0;n=n+4|0}while((o|0)<(s|0));f[B>>2]=o;w=n;x=r;y=C;break}while(1){s=f[F>>2]|0;q=0;do{v=C+(q<<2)|0;f[v>>2]=(f[v>>2]|0)+(f[s+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(h|0));q=(f[B>>2]|0)+1|0;f[B>>2]=q;s=F+4|0;v=f[m>>2]|0;if((q|0)<(v+-1|0))F=s;else{w=s;x=v;y=C;break}}}else{w=c;x=r;y=C}}while(0);if(!g){u=i;return}C=a+4|0;a=h+-2|0;c=(h|0)<2;F=h&-2;B=d;d=w;w=g;g=x;while(1){x=w+-1|0;D=f[d>>2]|0;m=f[d+(1-g<<2)>>2]|0;if(l){if(c)G=0;else{n=0;do{o=y+(n<<2)|0;v=(f[D+(n<<2)>>2]|0)+(f[o>>2]|0)|0;s=n|1;q=y+(s<<2)|0;E=(f[D+(s<<2)>>2]|0)+(f[q>>2]|0)|0;p[B+(n<<3)>>3]=k*+(v|0);p[B+(s<<3)>>3]=k*+(E|0);j=E-(f[m+(s<<2)>>2]|0)|0;f[o>>2]=v-(f[m+(n<<2)>>2]|0);f[q>>2]=j;n=n+2|0}while((n|0)<=(a|0));G=F}if((G|0)<(h|0)){n=G;do{r=y+(n<<2)|0;j=(f[D+(n<<2)>>2]|0)+(f[r>>2]|0)|0;p[B+(n<<3)>>3]=k*+(j|0);f[r>>2]=j-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}}else{if(c)H=0;else{n=0;do{j=y+(n<<2)|0;r=(f[D+(n<<2)>>2]|0)+(f[j>>2]|0)|0;q=n|1;v=y+(q<<2)|0;o=(f[D+(q<<2)>>2]|0)+(f[v>>2]|0)|0;p[B+(n<<3)>>3]=+(r|0);p[B+(q<<3)>>3]=+(o|0);s=o-(f[m+(q<<2)>>2]|0)|0;f[j>>2]=r-(f[m+(n<<2)>>2]|0);f[v>>2]=s;n=n+2|0}while((n|0)<=(a|0));H=F}if((H|0)<(h|0)){n=H;do{s=y+(n<<2)|0;v=(f[D+(n<<2)>>2]|0)+(f[s>>2]|0)|0;p[B+(n<<3)>>3]=+(v|0);f[s>>2]=v-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}}if(!x)break;B=B+e|0;d=d+4|0;w=x;g=f[C>>2]|0}u=i;return}function nta(a){a=a|0;f[a+24>>2]=0;return}function ota(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61620;f[a+16>>2]=61648;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);return}function pta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61620;f[a+16>>2]=61648;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);cYc(a);return}function qta(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function rta(a){a=a|0;cYc(a);return}function sta(a){a=a|0;var b=0,c=0;f[a>>2]=61596;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function tta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61596;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function uta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>3;t=r;do if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{w=$Xc(32)|0;f[j>>2]=w;f[j+8>>2]=-2147483616;f[j+4>>2]=19;v=w;A=276161;B=v+19|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(B|0));b[w+19>>0]=0;vM(-215,j,528391,275030,212)}}else{C=r;D=t;E=9}}else{A=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(v=t+(h<<3)|0,(A|0)!=(v|0)):0){f[o>>2]=A+(~((A+-8-v|0)>>>3)<<3);F=t}else F=t;else{Voa(m,h-s|0);F=f[m>>2]|0}v=a+24|0;f[v>>2]=0;C=v;D=F;E=9}while(0);if((E|0)==9){g1c(D|0,0,h<<3|0)|0;E=f[C>>2]|0;F=f[a+4>>2]|0;a=F+-1|0;if((E|0)<(a|0)){if((h|0)>0){m=c;s=E;while(1){t=f[m>>2]|0;o=0;do{q=D+(o<<3)|0;p[q>>3]=+p[t+(o<<3)>>3]+ +p[q>>3];o=o+1|0}while((o|0)!=(h|0));o=s+1|0;t=m+4|0;if((o|0)<(a|0)){m=t;s=o}else{G=o;H=t;break}}}else{s=E+1|0;m=(a|0)>(s|0)?a:s;G=m;H=c+(m-E<<2)|0}f[C>>2]=G;x=H;y=F;z=D}else{x=c;y=F;z=D}}if(!g){u=i;return}D=1-y|0;y=h+-2|0;F=(h|0)<2;c=h&-2;H=d;d=x;x=g;while(1){x=x+-1|0;g=f[d>>2]|0;G=f[d+(D<<2)>>2]|0;if(l){if(F)I=0;else{C=0;do{E=z+(C<<3)|0;J=+p[E>>3]+ +p[g+(C<<3)>>3];m=C|1;s=z+(m<<3)|0;K=+p[s>>3]+ +p[g+(m<<3)>>3];n[H+(C<<2)>>2]=k*J;n[H+(m<<2)>>2]=k*K;L=K-+p[G+(m<<3)>>3];p[E>>3]=J-+p[G+(C<<3)>>3];p[s>>3]=L;C=C+2|0}while((C|0)<=(y|0));I=c}if((I|0)<(h|0)){C=I;do{s=z+(C<<3)|0;L=+p[s>>3]+ +p[g+(C<<3)>>3];n[H+(C<<2)>>2]=k*L;p[s>>3]=L-+p[G+(C<<3)>>3];C=C+1|0}while((C|0)!=(h|0))}}else{if(F)M=0;else{C=0;do{s=z+(C<<3)|0;L=+p[s>>3]+ +p[g+(C<<3)>>3];E=C|1;m=z+(E<<3)|0;J=+p[m>>3]+ +p[g+(E<<3)>>3];n[H+(C<<2)>>2]=L;n[H+(E<<2)>>2]=J;K=J-+p[G+(E<<3)>>3];p[s>>3]=L-+p[G+(C<<3)>>3];p[m>>3]=K;C=C+2|0}while((C|0)<=(y|0));M=c}if((M|0)<(h|0)){C=M;do{m=z+(C<<3)|0;K=+p[m>>3]+ +p[g+(C<<3)>>3];n[H+(C<<2)>>2]=K;p[m>>3]=K-+p[G+(C<<3)>>3];C=C+1|0}while((C|0)!=(h|0))}}if(!x)break;else{H=H+e|0;d=d+4|0}}u=i;return}function vta(a){a=a|0;f[a+24>>2]=0;return}function wta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61568;f[a+16>>2]=61596;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function xta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61568;f[a+16>>2]=61596;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function yta(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function zta(a){a=a|0;cYc(a);return}function Ata(a){a=a|0;var b=0,c=0;f[a>>2]=61544;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function Bta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61544;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function Cta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>2;t=r;do if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{w=$Xc(32)|0;f[j>>2]=w;f[j+8>>2]=-2147483616;f[j+4>>2]=19;v=w;A=276161;B=v+19|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(B|0));b[w+19>>0]=0;vM(-215,j,528391,275030,1090)}}else{C=r;D=t;E=9}}else{A=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(v=t+(h<<2)|0,(A|0)!=(v|0)):0){f[o>>2]=A+(~((A+-4-v|0)>>>2)<<2);F=t}else F=t;else{CS(m,h-s|0);F=f[m>>2]|0}v=a+24|0;f[v>>2]=0;C=v;D=F;E=9}while(0);do if((E|0)==9){g1c(D|0,0,h<<2|0)|0;F=f[C>>2]|0;m=a+4|0;s=f[m>>2]|0;t=s+-1|0;if((F|0)<(t|0)){if((h|0)>0)G=c;else{o=c;q=F;do{q=q+1|0;o=o+4|0}while((q|0)<(t|0));f[C>>2]=q;x=o;y=s;z=D;break}while(1){t=f[G>>2]|0;r=0;do{w=D+(r<<2)|0;f[w>>2]=(f[w>>2]|0)+(f[t+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(h|0));r=(f[C>>2]|0)+1|0;f[C>>2]=r;t=G+4|0;w=f[m>>2]|0;if((r|0)<(w+-1|0))G=t;else{x=t;y=w;z=D;break}}}else{x=c;y=s;z=D}}while(0);D=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=x;G=y;C=D;while(1){E=f[c>>2]|0;m=f[c+(1-G<<2)>>2]|0;if(a){o=0;do{q=z+(o<<2)|0;w=(f[E+(o<<2)>>2]|0)+(f[q>>2]|0)|0;n[l+(o<<2)>>2]=k*+(w|0);f[q>>2]=w-(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0))}if(!C)break;l=l+e|0;c=c+4|0;G=f[g>>2]|0;C=C+-1|0}u=i;return}if(a){H=d;I=x;J=D;K=y}else{u=i;return}while(1){y=f[I>>2]|0;D=f[I+(1-K<<2)>>2]|0;x=0;do{d=z+(x<<2)|0;a=(f[y+(x<<2)>>2]|0)+(f[d>>2]|0)|0;n[H+(x<<2)>>2]=+(a|0);f[d>>2]=a-(f[D+(x<<2)>>2]|0);x=x+1|0}while((x|0)!=(h|0));if(!J)break;H=H+e|0;I=I+4|0;J=J+-1|0;K=f[g>>2]|0}u=i;return}function Dta(a){a=a|0;f[a+24>>2]=0;return}function Eta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61516;f[a+16>>2]=61544;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);return}function Fta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61516;f[a+16>>2]=61544;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);cYc(a);return}function Gta(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Hta(a){a=a|0;cYc(a);return}function Ita(a){a=a|0;var b=0,c=0;f[a>>2]=61492;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function Jta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61492;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function Kta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{v=$Xc(32)|0;f[j>>2]=v;f[j+8>>2]=-2147483616;f[j+4>>2]=19;t=v;z=276161;A=t+19|0;do{b[t>>0]=b[z>>0]|0;t=t+1|0;z=z+1|0}while((t|0)<(A|0));b[v+19>>0]=0;vM(-215,j,528391,275030,954)}}else{B=q;C=s;D=9}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(t=s+(h<<2)|0,(z|0)!=(t|0)):0){f[n>>2]=z+(~((z+-4-t|0)>>>2)<<2);E=s}else E=s;else{CS(m,h-r|0);E=f[m>>2]|0}t=a+24|0;f[t>>2]=0;B=t;C=E;D=9}while(0);do if((D|0)==9){g1c(C|0,0,h<<2|0)|0;E=f[B>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((E|0)<(s|0)){if((h|0)>0)F=c;else{n=c;o=E;do{o=o+1|0;n=n+4|0}while((o|0)<(s|0));f[B>>2]=o;w=n;x=r;y=C;break}while(1){s=f[F>>2]|0;q=0;do{v=C+(q<<2)|0;f[v>>2]=(f[v>>2]|0)+(f[s+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(h|0));q=(f[B>>2]|0)+1|0;f[B>>2]=q;s=F+4|0;v=f[m>>2]|0;if((q|0)<(v+-1|0))F=s;else{w=s;x=v;y=C;break}}}else{w=c;x=r;y=C}}while(0);C=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=w;F=x;B=C;while(1){D=f[c>>2]|0;m=f[c+(1-F<<2)>>2]|0;if(a){n=0;do{o=y+(n<<2)|0;v=(f[D+(n<<2)>>2]|0)+(f[o>>2]|0)|0;s=zLc(k*+(v|0))|0;f[l+(n<<2)>>2]=s;f[o>>2]=v-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}if(!B)break;l=l+e|0;c=c+4|0;F=f[g>>2]|0;B=B+-1|0}u=i;return}if(a){G=d;H=w;I=C;J=x}else{u=i;return}while(1){x=f[H>>2]|0;C=f[H+(1-J<<2)>>2]|0;w=0;do{d=y+(w<<2)|0;a=(f[x+(w<<2)>>2]|0)+(f[d>>2]|0)|0;f[G+(w<<2)>>2]=a;f[d>>2]=a-(f[C+(w<<2)>>2]|0);w=w+1|0}while((w|0)!=(h|0));if(!I)break;G=G+e|0;H=H+4|0;I=I+-1|0;J=f[g>>2]|0}u=i;return}function Lta(a){a=a|0;f[a+24>>2]=0;return}function Mta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61464;f[a+16>>2]=61492;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);return}function Nta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61464;f[a+16>>2]=61492;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);cYc(a);return}function Ota(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Pta(a){a=a|0;cYc(a);return}function Qta(a){a=a|0;var b=0,c=0;f[a>>2]=61440;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function Rta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61440;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function Sta(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{w=$Xc(32)|0;f[k>>2]=w;f[k+8>>2]=-2147483616;f[k+4>>2]=19;v=w;A=276161;B=v+19|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(B|0));b[w+19>>0]=0;vM(-215,k,528391,275030,212)}}else{C=r;D=t;E=9}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(v=t+(i<<3)|0,(A|0)!=(v|0)):0){f[o>>2]=A+(~((A+-8-v|0)>>>3)<<3);F=t}else F=t;else{Voa(n,i-s|0);F=f[n>>2]|0}v=a+24|0;f[v>>2]=0;C=v;D=F;E=9}while(0);if((E|0)==9){g1c(D|0,0,i<<3|0)|0;E=f[C>>2]|0;F=f[a+4>>2]|0;a=F+-1|0;if((E|0)<(a|0)){if((i|0)>0){n=c;s=E;while(1){t=f[n>>2]|0;o=0;do{q=D+(o<<3)|0;p[q>>3]=+p[t+(o<<3)>>3]+ +p[q>>3];o=o+1|0}while((o|0)!=(i|0));o=s+1|0;t=n+4|0;if((o|0)<(a|0)){n=t;s=o}else{G=o;H=t;break}}}else{s=E+1|0;n=(a|0)>(s|0)?a:s;G=n;H=c+(n-E<<2)|0}f[C>>2]=G;x=H;y=F;z=D}else{x=c;y=F;z=D}}if(!h){u=j;return}D=1-y|0;y=i+-2|0;F=(i|0)<2;c=i&-2;H=e;e=x;x=h;while(1){x=x+-1|0;h=f[e>>2]|0;G=f[e+(D<<2)>>2]|0;if(m){if(F)I=0;else{C=0;do{E=z+(C<<3)|0;J=+p[E>>3]+ +p[h+(C<<3)>>3];n=C|1;s=z+(n<<3)|0;K=+p[s>>3]+ +p[h+(n<<3)>>3];a=zLc(l*J)|0;d[H+(C<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=zLc(l*K)|0;d[H+(n<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;L=K-+p[G+(n<<3)>>3];p[E>>3]=J-+p[G+(C<<3)>>3];p[s>>3]=L;C=C+2|0}while((C|0)<=(y|0));I=c}if((I|0)<(i|0)){C=I;do{s=z+(C<<3)|0;L=+p[s>>3]+ +p[h+(C<<3)>>3];E=zLc(l*L)|0;d[H+(C<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;p[s>>3]=L-+p[G+(C<<3)>>3];C=C+1|0}while((C|0)!=(i|0))}}else{if(F)M=0;else{C=0;do{s=z+(C<<3)|0;L=+p[s>>3]+ +p[h+(C<<3)>>3];E=C|1;n=z+(E<<3)|0;J=+p[n>>3]+ +p[h+(E<<3)>>3];a=zLc(L)|0;d[H+(C<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=zLc(J)|0;d[H+(E<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;K=J-+p[G+(E<<3)>>3];p[s>>3]=L-+p[G+(C<<3)>>3];p[n>>3]=K;C=C+2|0}while((C|0)<=(y|0));M=c}if((M|0)<(i|0)){C=M;do{n=z+(C<<3)|0;K=+p[n>>3]+ +p[h+(C<<3)>>3];s=zLc(K)|0;d[H+(C<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;p[n>>3]=K-+p[G+(C<<3)>>3];C=C+1|0}while((C|0)!=(i|0))}}if(!x)break;else{H=H+g|0;e=e+4|0}}u=j;return}function Tta(a){a=a|0;f[a+24>>2]=0;return}function Uta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61412;f[a+16>>2]=61440;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function Vta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61412;f[a+16>>2]=61440;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Wta(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Xta(a){a=a|0;cYc(a);return}function Yta(a){a=a|0;var b=0,c=0;f[a>>2]=61388;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function Zta(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61388;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function _ta(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{w=$Xc(32)|0;f[k>>2]=w;f[k+8>>2]=-2147483616;f[k+4>>2]=19;v=w;A=276161;B=v+19|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(B|0));b[w+19>>0]=0;vM(-215,k,528391,275030,656)}}else{C=r;D=t;E=9}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(v=t+(i<<2)|0,(A|0)!=(v|0)):0){f[o>>2]=A+(~((A+-4-v|0)>>>2)<<2);F=t}else F=t;else{CS(n,i-s|0);F=f[n>>2]|0}v=a+24|0;f[v>>2]=0;C=v;D=F;E=9}while(0);do if((E|0)==9){g1c(D|0,0,i<<2|0)|0;F=f[C>>2]|0;n=a+4|0;s=f[n>>2]|0;t=s+-1|0;if((F|0)<(t|0)){if((i|0)>0)G=c;else{o=c;q=F;do{q=q+1|0;o=o+4|0}while((q|0)<(t|0));f[C>>2]=q;x=o;y=s;z=D;break}while(1){t=f[G>>2]|0;r=0;do{w=D+(r<<2)|0;f[w>>2]=(f[w>>2]|0)+(f[t+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(i|0));r=(f[C>>2]|0)+1|0;f[C>>2]=r;t=G+4|0;w=f[n>>2]|0;if((r|0)<(w+-1|0))G=t;else{x=t;y=w;z=D;break}}}else{x=c;y=s;z=D}}while(0);D=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=e;c=x;G=y;C=D;while(1){E=f[c>>2]|0;n=f[c+(1-G<<2)>>2]|0;if(a){o=0;do{q=z+(o<<2)|0;w=(f[E+(o<<2)>>2]|0)+(f[q>>2]|0)|0;t=zLc(l*+(w|0))|0;d[m+(o<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;f[q>>2]=w-(f[n+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(i|0))}if(!C)break;m=m+g|0;c=c+4|0;G=f[h>>2]|0;C=C+-1|0}u=j;return}else{C=e;e=x;x=y;y=D;while(1){D=f[e>>2]|0;G=f[e+(1-x<<2)>>2]|0;if(a){c=0;do{m=z+(c<<2)|0;o=(f[D+(c<<2)>>2]|0)+(f[m>>2]|0)|0;d[C+(c<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;f[m>>2]=o-(f[G+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(i|0))}if(!y)break;C=C+g|0;e=e+4|0;x=f[h>>2]|0;y=y+-1|0}u=j;return}}function $ta(a){a=a|0;f[a+24>>2]=0;return}function aua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61360;f[a+16>>2]=61388;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);return}function bua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61360;f[a+16>>2]=61388;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);cYc(a);return}function cua(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function dua(a){a=a|0;cYc(a);return}function eua(a){a=a|0;var b=0,c=0;f[a>>2]=61336;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function fua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61336;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function gua(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{w=$Xc(32)|0;f[k>>2]=w;f[k+8>>2]=-2147483616;f[k+4>>2]=19;v=w;A=276161;B=v+19|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(B|0));b[w+19>>0]=0;vM(-215,k,528391,275030,212)}}else{C=r;D=t;E=9}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(v=t+(i<<3)|0,(A|0)!=(v|0)):0){f[o>>2]=A+(~((A+-8-v|0)>>>3)<<3);F=t}else F=t;else{Voa(n,i-s|0);F=f[n>>2]|0}v=a+24|0;f[v>>2]=0;C=v;D=F;E=9}while(0);if((E|0)==9){g1c(D|0,0,i<<3|0)|0;E=f[C>>2]|0;F=f[a+4>>2]|0;a=F+-1|0;if((E|0)<(a|0)){if((i|0)>0){n=c;s=E;while(1){t=f[n>>2]|0;o=0;do{q=D+(o<<3)|0;p[q>>3]=+p[t+(o<<3)>>3]+ +p[q>>3];o=o+1|0}while((o|0)!=(i|0));o=s+1|0;t=n+4|0;if((o|0)<(a|0)){n=t;s=o}else{G=o;H=t;break}}}else{s=E+1|0;n=(a|0)>(s|0)?a:s;G=n;H=c+(n-E<<2)|0}f[C>>2]=G;x=H;y=F;z=D}else{x=c;y=F;z=D}}if(!h){u=j;return}D=1-y|0;y=i+-2|0;F=(i|0)<2;c=i&-2;H=e;e=x;x=h;while(1){x=x+-1|0;h=f[e>>2]|0;G=f[e+(D<<2)>>2]|0;if(m){if(F)I=0;else{C=0;do{E=z+(C<<3)|0;J=+p[E>>3]+ +p[h+(C<<3)>>3];n=C|1;s=z+(n<<3)|0;K=+p[s>>3]+ +p[h+(n<<3)>>3];a=zLc(l*J)|0;d[H+(C<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=zLc(l*K)|0;d[H+(n<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;L=K-+p[G+(n<<3)>>3];p[E>>3]=J-+p[G+(C<<3)>>3];p[s>>3]=L;C=C+2|0}while((C|0)<=(y|0));I=c}if((I|0)<(i|0)){C=I;do{s=z+(C<<3)|0;L=+p[s>>3]+ +p[h+(C<<3)>>3];E=zLc(l*L)|0;d[H+(C<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;p[s>>3]=L-+p[G+(C<<3)>>3];C=C+1|0}while((C|0)!=(i|0))}}else{if(F)M=0;else{C=0;do{s=z+(C<<3)|0;L=+p[s>>3]+ +p[h+(C<<3)>>3];E=C|1;n=z+(E<<3)|0;J=+p[n>>3]+ +p[h+(E<<3)>>3];a=zLc(L)|0;d[H+(C<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=zLc(J)|0;d[H+(E<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;K=J-+p[G+(E<<3)>>3];p[s>>3]=L-+p[G+(C<<3)>>3];p[n>>3]=K;C=C+2|0}while((C|0)<=(y|0));M=c}if((M|0)<(i|0)){C=M;do{n=z+(C<<3)|0;K=+p[n>>3]+ +p[h+(C<<3)>>3];s=zLc(K)|0;d[H+(C<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;p[n>>3]=K-+p[G+(C<<3)>>3];C=C+1|0}while((C|0)!=(i|0))}}if(!x)break;else{H=H+g|0;e=e+4|0}}u=j;return}function hua(a){a=a|0;f[a+24>>2]=0;return}function iua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61308;f[a+16>>2]=61336;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function jua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61308;f[a+16>>2]=61336;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function kua(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function lua(a){a=a|0;cYc(a);return}function mua(a){a=a|0;var b=0,c=0;f[a>>2]=61284;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function nua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61284;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function oua(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;do if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(v){w=f[a+4>>2]|0;if((v|0)==(w+-1|0)){x=c+(v<<2)|0;y=w;z=t;break}else{w=$Xc(32)|0;f[k>>2]=w;f[k+8>>2]=-2147483616;f[k+4>>2]=19;v=w;A=276161;B=v+19|0;do{b[v>>0]=b[A>>0]|0;v=v+1|0;A=A+1|0}while((v|0)<(B|0));b[w+19>>0]=0;vM(-215,k,528391,275030,806)}}else{C=r;D=t;E=9}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(v=t+(i<<2)|0,(A|0)!=(v|0)):0){f[o>>2]=A+(~((A+-4-v|0)>>>2)<<2);F=t}else F=t;else{CS(n,i-s|0);F=f[n>>2]|0}v=a+24|0;f[v>>2]=0;C=v;D=F;E=9}while(0);do if((E|0)==9){g1c(D|0,0,i<<2|0)|0;F=f[C>>2]|0;n=a+4|0;s=f[n>>2]|0;t=s+-1|0;if((F|0)<(t|0)){if((i|0)>0)G=c;else{o=c;q=F;do{q=q+1|0;o=o+4|0}while((q|0)<(t|0));f[C>>2]=q;x=o;y=s;z=D;break}while(1){t=f[G>>2]|0;r=0;do{w=D+(r<<2)|0;f[w>>2]=(f[w>>2]|0)+(f[t+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(i|0));r=(f[C>>2]|0)+1|0;f[C>>2]=r;t=G+4|0;w=f[n>>2]|0;if((r|0)<(w+-1|0))G=t;else{x=t;y=w;z=D;break}}}else{x=c;y=s;z=D}}while(0);D=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=e;c=x;G=y;C=D;while(1){E=f[c>>2]|0;n=f[c+(1-G<<2)>>2]|0;if(a){o=0;do{q=z+(o<<2)|0;w=(f[E+(o<<2)>>2]|0)+(f[q>>2]|0)|0;t=zLc(l*+(w|0))|0;d[m+(o<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;f[q>>2]=w-(f[n+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(i|0))}if(!C)break;m=m+g|0;c=c+4|0;G=f[h>>2]|0;C=C+-1|0}u=j;return}else{C=e;e=x;x=y;y=D;while(1){D=f[e>>2]|0;G=f[e+(1-x<<2)>>2]|0;if(a){c=0;do{m=z+(c<<2)|0;o=(f[D+(c<<2)>>2]|0)+(f[m>>2]|0)|0;d[C+(c<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;f[m>>2]=o-(f[G+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(i|0))}if(!y)break;C=C+g|0;e=e+4|0;x=f[h>>2]|0;y=y+-1|0}u=j;return}}function pua(a){a=a|0;f[a+24>>2]=0;return}function qua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61256;f[a+16>>2]=61284;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);return}function rua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61256;f[a+16>>2]=61284;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);cYc(a);return}function sua(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function tua(a){a=a|0;cYc(a);return}function uua(a){a=a|0;var b=0,c=0;f[a>>2]=61232;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function vua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61232;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function wua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{v=$Xc(32)|0;f[j>>2]=v;f[j+8>>2]=-2147483616;f[j+4>>2]=19;t=v;z=276161;A=t+19|0;do{b[t>>0]=b[z>>0]|0;t=t+1|0;z=z+1|0}while((t|0)<(A|0));b[v+19>>0]=0;vM(-215,j,528391,275030,212)}}else{B=q;C=s;D=9}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(t=s+(h<<3)|0,(z|0)!=(t|0)):0){f[n>>2]=z+(~((z+-8-t|0)>>>3)<<3);E=s}else E=s;else{Voa(m,h-r|0);E=f[m>>2]|0}t=a+24|0;f[t>>2]=0;B=t;C=E;D=9}while(0);if((D|0)==9){g1c(C|0,0,h<<3|0)|0;D=f[B>>2]|0;E=f[a+4>>2]|0;m=E+-1|0;if((D|0)<(m|0)){if((h|0)>0){r=c;s=D;while(1){n=f[r>>2]|0;o=0;do{j=C+(o<<3)|0;p[j>>3]=+p[n+(o<<3)>>3]+ +p[j>>3];o=o+1|0}while((o|0)!=(h|0));o=s+1|0;n=r+4|0;if((o|0)<(m|0)){r=n;s=o}else{F=o;G=n;break}}}else{s=D+1|0;r=(m|0)>(s|0)?m:s;F=r;G=c+(r-D<<2)|0}f[B>>2]=F;w=G;x=E;y=C}else{w=c;x=E;y=C}}if(!g){u=i;return}C=a+4|0;a=h+-2|0;E=(h|0)<2;c=h&-2;G=d;d=w;w=g;g=x;while(1){x=w+-1|0;F=f[d>>2]|0;B=f[d+(1-g<<2)>>2]|0;if(l){if(E)H=0;else{D=0;do{r=y+(D<<3)|0;I=+p[r>>3]+ +p[F+(D<<3)>>3];s=D|1;m=y+(s<<3)|0;J=+p[m>>3]+ +p[F+(s<<3)>>3];n=zLc(k*I)|0;b[G+D>>0]=n>>>0<256?n:(n|0)>0?255:0;n=zLc(k*J)|0;b[G+s>>0]=n>>>0<256?n:(n|0)>0?255:0;K=J-+p[B+(s<<3)>>3];p[r>>3]=I-+p[B+(D<<3)>>3];p[m>>3]=K;D=D+2|0}while((D|0)<=(a|0));H=c}if((H|0)<(h|0)){D=H;do{m=y+(D<<3)|0;K=+p[m>>3]+ +p[F+(D<<3)>>3];r=zLc(k*K)|0;b[G+D>>0]=r>>>0<256?r:(r|0)>0?255:0;p[m>>3]=K-+p[B+(D<<3)>>3];D=D+1|0}while((D|0)!=(h|0))}}else{if(E)L=0;else{D=0;do{m=y+(D<<3)|0;K=+p[m>>3]+ +p[F+(D<<3)>>3];r=D|1;s=y+(r<<3)|0;I=+p[s>>3]+ +p[F+(r<<3)>>3];n=zLc(K)|0;b[G+D>>0]=n>>>0<256?n:(n|0)>0?255:0;n=zLc(I)|0;b[G+r>>0]=n>>>0<256?n:(n|0)>0?255:0;J=I-+p[B+(r<<3)>>3];p[m>>3]=K-+p[B+(D<<3)>>3];p[s>>3]=J;D=D+2|0}while((D|0)<=(a|0));L=c}if((L|0)<(h|0)){D=L;do{s=y+(D<<3)|0;J=+p[s>>3]+ +p[F+(D<<3)>>3];m=zLc(J)|0;b[G+D>>0]=m>>>0<256?m:(m|0)>0?255:0;p[s>>3]=J-+p[B+(D<<3)>>3];D=D+1|0}while((D|0)!=(h|0))}}if(!x)break;G=G+e|0;d=d+4|0;w=x;g=f[C>>2]|0}u=i;return}function xua(a){a=a|0;f[a+24>>2]=0;return}function yua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61204;f[a+16>>2]=61232;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function zua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61204;f[a+16>>2]=61232;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function Aua(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Bua(a){a=a|0;cYc(a);return}function Cua(a){a=a|0;var b=0,c=0;f[a>>2]=61752;b=f[a+36>>2]|0;if(!b)return;c=a+40|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-2-b|0)>>>1)<<1);cYc(b);return}function Dua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61752;b=f[a+36>>2]|0;if(!b){cYc(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-2-b|0)>>>1)<<1);cYc(b);cYc(a);return}function Eua(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=u;u=u+16|0;l=k;m=f[a+32>>2]|0;n=f[a+28>>2]|0;o=+p[a+16>>3]!=1.0;q=a+36|0;r=a+40|0;s=f[r>>2]|0;t=f[q>>2]|0;v=s-t>>1;w=t;do if((v|0)==(i|0)){t=a+24|0;x=f[t>>2]|0;if(x){y=f[a+4>>2]|0;if((x|0)==(y+-1|0)){z=c+(x<<2)|0;A=y;B=w;break}else{y=$Xc(32)|0;f[l>>2]=y;f[l+8>>2]=-2147483616;f[l+4>>2]=19;x=y;C=276161;D=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(D|0));b[y+19>>0]=0;vM(-215,l,528391,275030,492)}}else{E=t;F=w;G=9}}else{C=s;if(v>>>0>=i>>>0)if(v>>>0>i>>>0?(x=w+(i<<1)|0,(C|0)!=(x|0)):0){f[r>>2]=C+(~((C+-2-x|0)>>>1)<<1);H=w}else H=w;else{Gua(q,i-v|0);H=f[q>>2]|0}x=a+24|0;f[x>>2]=0;E=x;F=H;G=9}while(0);if((G|0)==9){g1c(F|0,0,i<<1|0)|0;G=f[E>>2]|0;H=f[a+4>>2]|0;q=H+-1|0;if((G|0)<(q|0)){if((i|0)>0){v=c;w=G;while(1){r=f[v>>2]|0;s=0;do{l=F+(s<<1)|0;d[l>>1]=(j[l>>1]|0)+(j[r+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0));s=w+1|0;r=v+4|0;if((s|0)<(q|0)){v=r;w=s}else{I=s;J=r;break}}}else{w=G+1|0;v=(q|0)>(w|0)?q:w;I=v;J=c+(v-G<<2)|0}f[E>>2]=I;z=J;A=H;B=F}else{z=c;A=H;B=F}}F=h+-1|0;if(!h){u=k;return}h=a+4|0;a=(i|0)>0;if(o){o=e;H=z;c=A;J=F;while(1){I=f[H>>2]|0;E=f[H+(1-c<<2)>>2]|0;if(a){G=0;do{v=B+(G<<1)|0;w=(j[I+(G<<1)>>1]|0)+(j[v>>1]|0)|0;q=(Y(w+n|0,m)|0)>>>23&255;b[o+G>>0]=q;d[v>>1]=w-(j[E+(G<<1)>>1]|0);G=G+1|0}while((G|0)!=(i|0))}if(!J)break;o=o+g|0;H=H+4|0;c=f[h>>2]|0;J=J+-1|0}u=k;return}else{J=e;e=z;z=A;A=F;while(1){F=f[e>>2]|0;c=f[e+(1-z<<2)>>2]|0;if(a){H=0;do{o=B+(H<<1)|0;m=(j[F+(H<<1)>>1]|0)+(j[o>>1]|0)|0;b[J+H>>0]=m>>>0<256?m:m|0?255:0;d[o>>1]=m-(j[c+(H<<1)>>1]|0);H=H+1|0}while((H|0)!=(i|0))}if(!A)break;J=J+g|0;e=e+4|0;z=f[h>>2]|0;A=A+-1|0}u=k;return}}function Fua(a){a=a|0;f[a+24>>2]=0;return}function Gua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>1>>>0>=b>>>0){g1c(g|0,0,b<<1|0)|0;f[e>>2]=g+(b<<1);return}h=f[a>>2]|0;i=g-h|0;g=i>>1;j=g+b|0;if((j|0)<0)kWc(a);k=d-h|0;d=k>>1>>>0<1073741823?(k>>>0<j>>>0?j:k):2147483647;do if(d)if((d|0)<0){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{l=$Xc(d<<1)|0;break}else l=0;while(0);k=l+(g<<1)|0;g1c(k|0,0,b<<1|0)|0;j=k+(0-g<<1)|0;if((i|0)>0)o1c(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=k+(b<<1);f[c>>2]=l+(d<<1);if(!h)return;cYc(h);return}function Hua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61724;f[a+16>>2]=61752;b=f[a+52>>2]|0;if(!b){NXc(a);return}c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-2-b|0)>>>1)<<1);cYc(b);NXc(a);return}function Iua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61724;f[a+16>>2]=61752;b=f[a+52>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-2-b|0)>>>1)<<1);cYc(b);NXc(a);cYc(a);return}function Jua(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Kua(a){a=a|0;cYc(a);return}function Lua(a){a=a|0;var b=0,c=0;f[a>>2]=61180;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);cYc(b);return}function Mua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61180;b=f[a+28>>2]|0;if(!b){cYc(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);cYc(a);return}function Nua(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;do if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(t){v=f[a+4>>2]|0;if((t|0)==(v+-1|0)){w=c+(t<<2)|0;x=v;y=s;break}else{v=$Xc(32)|0;f[j>>2]=v;f[j+8>>2]=-2147483616;f[j+4>>2]=19;t=v;z=276161;A=t+19|0;do{b[t>>0]=b[z>>0]|0;t=t+1|0;z=z+1|0}while((t|0)<(A|0));b[v+19>>0]=0;vM(-215,j,528391,275030,320)}}else{B=q;C=s;D=9}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(t=s+(h<<2)|0,(z|0)!=(t|0)):0){f[n>>2]=z+(~((z+-4-t|0)>>>2)<<2);E=s}else E=s;else{CS(m,h-r|0);E=f[m>>2]|0}t=a+24|0;f[t>>2]=0;B=t;C=E;D=9}while(0);do if((D|0)==9){g1c(C|0,0,h<<2|0)|0;E=f[B>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((E|0)<(s|0)){if((h|0)>0)F=c;else{n=c;o=E;do{o=o+1|0;n=n+4|0}while((o|0)<(s|0));f[B>>2]=o;w=n;x=r;y=C;break}while(1){s=f[F>>2]|0;q=0;do{v=C+(q<<2)|0;f[v>>2]=(f[v>>2]|0)+(f[s+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(h|0));q=(f[B>>2]|0)+1|0;f[B>>2]=q;s=F+4|0;v=f[m>>2]|0;if((q|0)<(v+-1|0))F=s;else{w=s;x=v;y=C;break}}}else{w=c;x=r;y=C}}while(0);C=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=w;F=x;B=C;while(1){D=f[c>>2]|0;m=f[c+(1-F<<2)>>2]|0;if(a){n=0;do{o=y+(n<<2)|0;v=(f[D+(n<<2)>>2]|0)+(f[o>>2]|0)|0;s=zLc(k*+(v|0))|0;b[l+n>>0]=s>>>0<256?s:(s|0)>0?255:0;f[o>>2]=v-(f[m+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(h|0))}if(!B)break;l=l+e|0;c=c+4|0;F=f[g>>2]|0;B=B+-1|0}u=i;return}else{B=d;d=w;w=x;x=C;while(1){C=f[d>>2]|0;F=f[d+(1-w<<2)>>2]|0;if(a){c=0;do{l=y+(c<<2)|0;n=(f[C+(c<<2)>>2]|0)+(f[l>>2]|0)|0;b[B+c>>0]=n>>>0<256?n:(n|0)>0?255:0;f[l>>2]=n-(f[F+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(h|0))}if(!x)break;B=B+e|0;d=d+4|0;w=f[g>>2]|0;x=x+-1|0}u=i;return}}function Oua(a){a=a|0;f[a+24>>2]=0;return}function Pua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61152;f[a+16>>2]=61180;b=f[a+44>>2]|0;if(!b){NXc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);return}function Qua(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=61152;f[a+16>>2]=61180;b=f[a+44>>2]|0;if(!b){NXc(a);cYc(a);return}c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b);NXc(a);cYc(a);return}function Rua(a){a=a|0;var b=0;b=a+16|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Sua(a){a=a|0;cYc(a);return}function Tua(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+40|0;m=i+32|0;n=b&7;o=b&4088;p=(n|0)==0;if(p)if((c&7|0)==0?(Y(f[d+4>>2]|0,f[d>>2]|0)|0)<257:0)q=2;else r=5;else if(n>>>0<5)r=5;else q=6;do if((r|0)==5){if(g?(s=Y(f[d+4>>2]|0,f[d>>2]|0)|0,(s|0)>((p?8388608:(n|0)==2?32768:65536)|0)):0){q=6;break}q=4}while(0);n=q|o;Vra(k,b,n,f[d>>2]|0,f[e>>2]|0);o=f[d+4>>2]|0;if(g)t=1.0/+(Y(f[d>>2]|0,o)|0);else t=1.0;ata(l,n,c,o,f[e+4>>2]|0,t);f[m>>2]=0;e=m+4|0;f[e>>2]=0;o=$Xc(212)|0;f[o+4>>2]=0;f[o+8>>2]=0;f[o>>2]=52040;d=o+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;Zba(d,m,k,l,b,c,n,h,-1,j);f[a>>2]=d;f[a+4>>2]=o;o=f[e>>2]|0;if(o|0)UXc(o);o=f[l+4>>2]|0;if(o|0)UXc(o);o=f[k+4>>2]|0;if(!o){u=i;return}UXc(o);u=i;return}function Uua(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+160|0;j=i+104|0;k=i+40|0;l=i+48|0;m=i+32|0;n=i+24|0;o=i+16|0;p=i+8|0;q=i;do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[j>>2]=f[r>>2];s=j+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[j+16>>2]=f[r+16>>2];f[j+20>>2]=f[r+20>>2];f[j+24>>2]=f[r+24>>2];f[j+28>>2]=f[r+28>>2];f[j+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[j+36>>2]=w;x=j+40|0;f[x>>2]=v;v=j+48|0;y=j+44|0;f[y>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=x;A=j;break}else{f[s>>2]=0;U$(j,r);z=x;A=j;break}}else{bS(j,a,-1);z=j+40|0;A=j}while(0);a=f[A>>2]|0;x=f[z>>2]|0;r=f[x>>2]|0;f[k>>2]=f[x+4>>2];f[k+4>>2]=r;wS(b,k,((c|0)<0?a:c)&7|a&4088,-1,0,0);do if((eS(b)|0)==65536){a=f[b+4>>2]|0;f[l>>2]=f[a>>2];c=l+4|0;k=a+4|0;f[c>>2]=f[k>>2];r=l+8|0;f[r>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=r;r=l+48|0;s=l+44|0;f[s>>2]=r;f[r>>2]=0;f[l+52>>2]=0;if(x|0){r=x+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+44>>2]|0;r=f[s>>2]|0;f[r>>2]=f[k>>2];f[r+4>>2]=f[k+4>>2];break}else{f[c>>2]=0;U$(l,a);break}}else bS(l,b,-1);while(0);b=(h&16|0)==0;if(!(b|g^1)){a=f[j+8>>2]|0;if((a|0)==1)f[d+4>>2]=1;c=f[j+12>>2]|0;if((c|0)==1){f[d>>2]=1;B=1;C=a}else{B=c;C=a}}else{B=f[j+12>>2]|0;C=f[j+8>>2]|0}f[m>>2]=0;f[m+4>>2]=0;f[n>>2]=B;f[n+4>>2]=C;if(b)e0(j,n,m);b=j+16|0;C=j+44|0;B=l+16|0;a=l+44|0;c=f[A>>2]&4095;A=f[l>>2]&4095;f[p>>2]=f[d>>2];f[p+4>>2]=f[d+4>>2];f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];Tua(o,c,A,p,q,g,h&-17);h=f[o>>2]|0;gi[f[(f[h>>2]|0)+20>>2]&255](h,j,l,n,m);m=f[o+4>>2]|0;if(m|0)UXc(m);m=l+36|0;o=f[m>>2]|0;if(o|0?(n=o+12|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)V$(l);f[m>>2]=0;m=l+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[m>>2]|0)>0){B=f[l+40>>2]|0;o=0;do{f[B+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[m>>2]|0))}m=f[a>>2]|0;if((m|0)!=(l+48|0))wL(m);m=j+36|0;l=f[m>>2]|0;if(l|0?(a=l+12|0,l=f[a>>2]|0,f[a>>2]=l+-1,(l|0)==1):0)V$(j);f[m>>2]=0;m=j+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[m>>2]|0)>0){b=f[z>>2]|0;z=0;do{f[b+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[m>>2]|0))}m=f[C>>2]|0;if((m|0)==(j+48|0)){u=i;return}wL(m);u=i;return}function Vua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];Uua(a,b,-1,h,i,1,e);u=g;return}function Wua(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;i=u;u=u+192|0;j=i+32|0;k=i;l=i+184|0;m=i+120|0;n=i+176|0;o=i+64|0;p=i+56|0;q=i+48|0;r=i+40|0;s=dS(a,-1)|0;t=s&7;v=s&4088;cS(l,a,-1);w=(c|0)<0?(t>>>0<5?5:6):c;if(!((h|0)==0|g^1)){if((f[l+4>>2]|0)==1)f[d+4>>2]=1;if((f[l>>2]|0)==1)f[d>>2]=1}c=(t|0)==0;t=(c?4:6)|v;x=w&7|v;do if((eS(a)|0)==65536){v=f[a+4>>2]|0;f[m>>2]=f[v>>2];w=m+4|0;y=v+4|0;f[w>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[v+8>>2];f[m+12>>2]=f[v+12>>2];f[m+16>>2]=f[v+16>>2];f[m+20>>2]=f[v+20>>2];f[m+24>>2]=f[v+24>>2];f[m+28>>2]=f[v+28>>2];f[m+32>>2]=f[v+32>>2];A=f[v+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;B=m+44|0;f[B>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[v+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[w>>2]=0;U$(m,v);break}}else bS(m,a,-1);while(0);f[n>>2]=f[l>>2];f[n+4>>2]=f[l+4>>2];wS(b,n,x,-1,0,0);do if((eS(b)|0)==65536){n=f[b+4>>2]|0;f[o>>2]=f[n>>2];l=o+4|0;a=n+4|0;f[l>>2]=f[a>>2];v=o+8|0;f[v>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];f[o+16>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];w=f[n+36>>2]|0;f[o+36>>2]=w;f[o+40>>2]=v;v=o+48|0;y=o+44|0;f[y>>2]=v;f[v>>2]=0;f[o+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[a>>2]|0)<3){a=f[n+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[a>>2];f[v+4>>2]=f[a+4>>2];break}else{f[l>>2]=0;U$(o,n);break}}else bS(o,b,-1);while(0);b=f[d>>2]|0;n=f[e>>2]|0;l=(n|0)<0?(b|0)/2|0:n;a:do if(c){n=$Xc(24)|0;f[n+4>>2]=0;f[n+8>>2]=0;f[n>>2]=61776;a=n+12|0;Wba(a);C=n;D=61996;E=a}else switch(s&7){case 2:{a=$Xc(24)|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=61804;n=a+12|0;Wba(n);C=a;D=61916;E=n;break a;break}case 3:{n=$Xc(24)|0;f[n+4>>2]=0;f[n+8>>2]=0;f[n>>2]=61832;a=n+12|0;Wba(a);C=n;D=61936;E=a;break a;break}case 5:{a=$Xc(24)|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=61860;n=a+12|0;Wba(n);C=a;D=61956;E=n;break a;break}case 6:{n=$Xc(24)|0;f[n+4>>2]=0;f[n+8>>2]=0;f[n>>2]=61888;a=n+12|0;Wba(a);C=n;D=61976;E=a;break a;break}default:{f[j>>2]=s;f[j+4>>2]=t;DM(k,275105,j);vM(-213,k,277273,275030,1755)}}while(0);f[E>>2]=D;f[C+16>>2]=b;f[C+20>>2]=l;f[p>>2]=E;E=p+4|0;f[E>>2]=C;C=f[d+4>>2]|0;if(g)F=1.0/+(Y(f[d>>2]|0,C)|0);else F=1.0;ata(q,t,x,C,f[e+4>>2]|0,F);f[r>>2]=0;e=r+4|0;f[e>>2]=0;C=$Xc(212)|0;f[C+4>>2]=0;f[C+8>>2]=0;f[C>>2]=52040;d=C+12|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Zba(d,r,p,q,s,x,t,h,-1,k);h=f[e>>2]|0;if(h|0)UXc(h);f[k>>2]=0;f[k+4>>2]=0;h=f[m+8>>2]|0;f[r>>2]=f[m+12>>2];f[r+4>>2]=h;e0(m,r,k);gi[f[(f[d>>2]|0)+20>>2]&255](d,m,o,r,k);UXc(C);C=f[q+4>>2]|0;if(C|0)UXc(C);C=f[E>>2]|0;if(C|0)UXc(C);C=o+36|0;E=f[C>>2]|0;if(E|0?(q=E+12|0,E=f[q>>2]|0,f[q>>2]=E+-1,(E|0)==1):0)V$(o);f[C>>2]=0;C=o+16|0;E=o+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[E>>2]|0)>0){C=f[o+40>>2]|0;q=0;do{f[C+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[E>>2]|0))}E=f[o+44>>2]|0;if((E|0)!=(o+48|0))wL(E);E=m+36|0;o=f[E>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)V$(m);f[E>>2]=0;E=m+16|0;o=m+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[o>>2]|0)>0){E=f[m+40>>2]|0;q=0;do{f[E+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)==(m+48|0)){u=i;return}wL(o);u=i;return}function Xua(a){a=a|0;cYc(a);return}function Yua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){i=c;j=0;k=b;while(1){l=0;m=0;do{n=h[k+m>>0]|0;l=(Y(n,n)|0)+l|0;m=m+e|0}while((m|0)<(g|0));f[i>>2]=l;if(d){m=0;n=l;do{o=h[k+m>>0]|0;p=h[k+(m+g)>>0]|0;n=(Y(p,p)|0)-(Y(o,o)|0)+n|0;m=m+e|0;f[i+(m<<2)>>2]=n}while((m|0)<(a|0))}j=j+1|0;if((j|0)==(e|0))break;else{i=i+4|0;k=k+1|0}}return}if(d){q=c;r=0;s=b}else{g1c(c|0,0,e<<2|0)|0;return}while(1){f[q>>2]=0;c=0;b=0;do{d=h[s+c>>0]|0;k=h[s+(c+g)>>0]|0;b=(Y(k,k)|0)-(Y(d,d)|0)+b|0;c=c+e|0;f[q+(c<<2)>>2]=b}while((c|0)<(a|0));r=r+1|0;if((r|0)==(e|0))break;else{q=q+4|0;s=s+1|0}}return}function Zua(a){a=a|0;cYc(a);return}function _ua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,q=0,r=0,s=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;j=b;while(1){k=0.0;l=0;do{m=+p[j+(l<<3)>>3];k=k+m*m;l=l+e|0}while((l|0)<(g|0));p[h>>3]=k;if(d){l=0;m=k;do{n=+p[j+(l<<3)>>3];o=+p[j+(l+g<<3)>>3];m=m+(o*o-n*n);l=l+e|0;p[h+(l<<3)>>3]=m}while((l|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;j=j+8|0}}return}if(d){q=c;r=0;s=b}else{g1c(c|0,0,e<<3|0)|0;return}while(1){p[q>>3]=0.0;c=0;m=0.0;do{k=+p[s+(c<<3)>>3];n=+p[s+(c+g<<3)>>3];m=m+(n*n-k*k);c=c+e|0;p[q+(c<<3)>>3]=m}while((c|0)<(a|0));r=r+1|0;if((r|0)==(e|0))break;else{q=q+8|0;s=s+8|0}}return}function $ua(a){a=a|0;cYc(a);return}function ava(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0.0,l=0,m=0.0,o=0.0,q=0.0,r=0,s=0,t=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;j=b;while(1){k=0.0;l=0;do{m=+n[j+(l<<2)>>2];k=k+m*m;l=l+e|0}while((l|0)<(g|0));p[h>>3]=k;if(d){l=0;m=k;do{o=+n[j+(l<<2)>>2];q=+n[j+(l+g<<2)>>2];m=m+(q*q-o*o);l=l+e|0;p[h+(l<<3)>>3]=m}while((l|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;j=j+4|0}}return}if(d){r=c;s=0;t=b}else{g1c(c|0,0,e<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;m=0.0;do{k=+n[t+(c<<2)>>2];o=+n[t+(c+g<<2)>>2];m=m+(o*o-k*k);c=c+e|0;p[r+(c<<3)>>3]=m}while((c|0)<(a|0));s=s+1|0;if((s|0)==(e|0))break;else{r=r+8|0;t=t+4|0}}return}function bva(a){a=a|0;cYc(a);return}function cva(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(e+-1|0,g)|0;if((g|0)<=0)return;e=(a|0)>0;if((h|0)>0){i=c;j=0;k=b;while(1){l=0.0;m=0;do{n=+(d[k+(m<<1)>>1]|0);l=l+n*n;m=m+g|0}while((m|0)<(h|0));p[i>>3]=l;if(e){m=0;n=l;do{o=+(d[k+(m<<1)>>1]|0);q=+(d[k+(m+h<<1)>>1]|0);n=n+(q*q-o*o);m=m+g|0;p[i+(m<<3)>>3]=n}while((m|0)<(a|0))}j=j+1|0;if((j|0)==(g|0))break;else{i=i+8|0;k=k+2|0}}return}if(e){r=c;s=0;t=b}else{g1c(c|0,0,g<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;n=0.0;do{l=+(d[t+(c<<1)>>1]|0);o=+(d[t+(c+h<<1)>>1]|0);n=n+(o*o-l*l);c=c+g|0;p[r+(c<<3)>>3]=n}while((c|0)<(a|0));s=s+1|0;if((s|0)==(g|0))break;else{r=r+8|0;t=t+2|0}}return}function dva(a){a=a|0;cYc(a);return}function eva(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;k=b;while(1){l=0.0;m=0;do{n=+(j[k+(m<<1)>>1]|0);l=l+n*n;m=m+e|0}while((m|0)<(g|0));p[h>>3]=l;if(d){m=0;n=l;do{o=+(j[k+(m<<1)>>1]|0);q=+(j[k+(m+g<<1)>>1]|0);n=n+(q*q-o*o);m=m+e|0;p[h+(m<<3)>>3]=n}while((m|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;k=k+2|0}}return}if(d){r=c;s=0;t=b}else{g1c(c|0,0,e<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;n=0.0;do{l=+(j[t+(c<<1)>>1]|0);o=+(j[t+(c+g<<1)>>1]|0);n=n+(o*o-l*l);c=c+e|0;p[r+(c<<3)>>3]=n}while((c|0)<(a|0));s=s+1|0;if((s|0)==(e|0))break;else{r=r+8|0;t=t+2|0}}return}function fva(a){a=a|0;f[a>>2]=61888;NXc(a);return}function gva(a){a=a|0;f[a>>2]=61888;NXc(a);cYc(a);return}function hva(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function iva(a){a=a|0;cYc(a);return}function jva(a){a=a|0;f[a>>2]=61860;NXc(a);return}function kva(a){a=a|0;f[a>>2]=61860;NXc(a);cYc(a);return}function lva(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function mva(a){a=a|0;cYc(a);return}function nva(a){a=a|0;f[a>>2]=61832;NXc(a);return}function ova(a){a=a|0;f[a>>2]=61832;NXc(a);cYc(a);return}function pva(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function qva(a){a=a|0;cYc(a);return}function rva(a){a=a|0;f[a>>2]=61804;NXc(a);return}function sva(a){a=a|0;f[a>>2]=61804;NXc(a);cYc(a);return}function tva(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function uva(a){a=a|0;cYc(a);return}function vva(a){a=a|0;f[a>>2]=61776;NXc(a);return}function wva(a){a=a|0;f[a>>2]=61776;NXc(a);cYc(a);return}function xva(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function yva(a){a=a|0;cYc(a);return}function zva(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0;i=u;u=u+384|0;j=i+104|0;k=i+88|0;l=i+320|0;m=i+32|0;o=i+272|0;q=i;r=i+312|0;s=i+216|0;t=i+160|0;cS(r,a,-1);wS(c,r,dS(a,-1)|0,-1,0,0);do if((eS(a)|0)==65536){r=f[a+4>>2]|0;f[s>>2]=f[r>>2];v=s+4|0;w=r+4|0;f[v>>2]=f[w>>2];x=s+8|0;f[x>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];y=f[r+36>>2]|0;f[s+36>>2]=y;f[s+40>>2]=x;x=s+48|0;z=s+44|0;f[z>>2]=x;f[x>>2]=0;f[s+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[r+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;U$(s,r);break}}else bS(s,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[t>>2]=f[a>>2];r=t+4|0;v=a+4|0;f[r>>2]=f[v>>2];w=t+8|0;f[w>>2]=f[a+8>>2];f[t+12>>2]=f[a+12>>2];f[t+16>>2]=f[a+16>>2];f[t+20>>2]=f[a+20>>2];f[t+24>>2]=f[a+24>>2];f[t+28>>2]=f[a+28>>2];f[t+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[t+36>>2]=x;f[t+40>>2]=w;w=t+48|0;z=t+44|0;f[z>>2]=w;f[w>>2]=0;f[t+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[a+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[r>>2]=0;U$(t,a);break}}else bS(t,c,-1);while(0);c=f[s>>2]|0;switch(c&7){case 0:{a=(c>>>3&511)+1|0;r=f[f[s+40>>2]>>2]|0;switch(c&4095){case 16:case 0:break;default:{A=$Xc(80)|0;f[j>>2]=A;B=j+8|0;f[B>>2]=-2147483568;C=j+4|0;f[C>>2]=72;D=A;E=277747;F=D+72|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));G=A+72|0;b[G>>0]=0;vM(-215,j,277820,277839,340)}}if((f[s+16>>2]|0)==(f[t+16>>2]|0)){A=$Xc(80)|0;f[j>>2]=A;B=j+8|0;f[B>>2]=-2147483568;C=j+4|0;f[C>>2]=72;D=A;E=277747;F=D+72|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));G=A+72|0;b[G>>0]=0;vM(-215,j,277820,277839,340)}H=!(e<=0.0)?e:1.0;I=!(g<=0.0)?g:1.0;J=-.5/(H*H);H=-.5/(I*I);if((d|0)<1)K=zLc(I*1.5)|0;else K=d>>>1;G=(K|0)>1?K:1;K=G<<1|1;f[j>>2]=1124007936;A=j+4|0;C=j+8|0;B=j+40|0;D=A;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[B>>2]=C;C=j+48|0;v=j+44|0;f[v>>2]=C;f[C>>2]=0;f[j+52>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=s;w=l+8|0;f[w>>2]=0;f[w+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;rR(k,l,G,G,G,G,h,m);w=a<<8;z=a<<10;x=$Xc(z)|0;g1c(x|0,0,z|0)|0;z=Y(K,K)|0;f[k>>2]=0;K=k+4|0;f[K>>2]=0;f[k+8>>2]=0;if(z>>>0>1073741823)kWc(k);y=z<<2;N=$Xc(y)|0;f[k>>2]=N;O=N+(z<<2)|0;f[k+8>>2]=O;g1c(N|0,0,y|0)|0;f[K>>2]=O;O=$Xc(y)|0;g1c(O|0,0,y|0)|0;y=0;do{I=+V(+(J*+(Y(y,y)|0)));n[x+(y<<2)>>2]=I;y=y+1|0}while((y|0)!=(w|0));w=0-G|0;if((G|0)<(w|0))P=0;else{J=+(G|0);y=f[C>>2]|0;z=0;Q=w;while(1){I=+(Q|0);R=I*I;S=Y(Q,y)|0;T=w;U=z;while(1){I=+(T|0);W=+M(+(R+I*I));if(W>J)X=U;else{Z=(Y(T,a)|0)+S|0;I=+V(+(H*(W*W)));n[N+(U<<2)>>2]=I;f[O+(U<<2)>>2]=Z;X=U+1|0}if((T|0)<(G|0)){T=T+1|0;U=X}else break}if((Q|0)<(G|0)){z=X;Q=Q+1|0}else{P=X;break}}}f[l>>2]=62016;f[l+4>>2]=j;f[l+8>>2]=t;f[l+12>>2]=G;f[l+16>>2]=P;f[l+20>>2]=O;f[l+24>>2]=N;f[l+28>>2]=x;f[m>>2]=0;f[m+4>>2]=r;r=f[t+4>>2]|0;if((r|0)<3)_=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{N=f[t+40>>2]|0;P=0;G=1;while(1){X=Y(f[N+(P<<2)>>2]|0,G)|0;P=P+1|0;if((P|0)==(r|0)){_=X;break}else G=X}}h3(m,l,+(_>>>0)*.0000152587890625);cYc(O);O=f[k>>2]|0;if(O|0){_=f[K>>2]|0;if((_|0)!=(O|0))f[K>>2]=_+(~((_+-4-O|0)>>>2)<<2);cYc(O)}cYc(x);x=j+36|0;O=f[x>>2]|0;if(O|0?(_=O+12|0,O=f[_>>2]|0,f[_>>2]=O+-1,(O|0)==1):0)V$(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[A>>2]|0)>0){x=f[B>>2]|0;B=0;do{f[x+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[A>>2]|0))}A=f[v>>2]|0;if((A|0)!=(C|0))wL(A);break}case 5:{A=(c>>>3&511)+1|0;p[j>>3]=-1.0;p[k>>3]=1.0;C=f[f[s+40>>2]>>2]|0;switch(c&4095){case 21:case 5:break;default:{$=$Xc(80)|0;f[l>>2]=$;aa=l+8|0;f[aa>>2]=-2147483568;ba=l+4|0;f[ba>>2]=74;D=$;E=277920;F=D+74|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));ca=$+74|0;b[ca>>0]=0;vM(-215,l,277995,277839,560)}}if((f[s+16>>2]|0)==(f[t+16>>2]|0)){$=$Xc(80)|0;f[l>>2]=$;aa=l+8|0;f[aa>>2]=-2147483568;ba=l+4|0;f[ba>>2]=74;D=$;E=277920;F=D+74|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));ca=$+74|0;b[ca>>0]=0;vM(-215,l,277995,277839,560)}H=!(e<=0.0)?e:1.0;e=!(g<=0.0)?g:1.0;g=-.5/(H*H);J=-.5/(e*e);if((d|0)<1)da=zLc(e*1.5)|0;else da=d>>>1;d=(da|0)>1?da:1;da=d<<1|1;g0(m,s,1,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;SP(l,j,k,0,0,fT()|0);ca=m+36|0;$=f[ca>>2]|0;if($|0?(ba=$+12|0,$=f[ba>>2]|0,f[ba>>2]=$+-1,($|0)==1):0)V$(m);f[ca>>2]=0;ca=m+16|0;$=m+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[$>>2]|0)>0){ca=f[m+40>>2]|0;ba=0;do{f[ca+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[$>>2]|0))}$=f[m+44>>2]|0;if(($|0)!=(m+48|0))wL($);if(!(+L(+(+p[j>>3]-+p[k>>3]))<1.1920928955078125e-07)){f[l>>2]=1124007936;$=l+4|0;ba=l+8|0;ca=l+40|0;D=$;F=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(F|0));f[ca>>2]=ba;ba=l+48|0;aa=l+44|0;f[aa>>2]=ba;f[ba>>2]=0;f[l+52>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=o+8|0;f[c>>2]=0;f[c+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[q+28>>2]=0;rR(m,o,d,d,d,d,h,q);e=+p[j>>3]-H*5.0;p[j>>3]=e;h=m+8|0;f[h>>2]=0;f[h+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=l;_L(m,e);h=Y(da,da)|0;f[m>>2]=0;da=m+4|0;f[da>>2]=0;f[m+8>>2]=0;if(h>>>0>1073741823)kWc(m);c=h<<2;v=$Xc(c)|0;f[m>>2]=v;B=v+(h<<2)|0;f[m+8>>2]=B;g1c(v|0,0,c|0)|0;f[da>>2]=B;B=$Xc(c)|0;g1c(B|0,0,c|0)|0;e=+p[k>>3];H=+p[j>>3];k=A<<12;c=k|2;h=c<<2;x=$Xc(h)|0;g1c(x|0,0,h|0)|0;R=+(k|0)/(+(A|0)*(e-H));k=0;H=1.0;while(1){if(H>0.0){e=+(k|0)/R;I=+V(+(g*(e*e)));ea=I;fa=I}else{ea=H;fa=0.0}n[x+(k<<2)>>2]=fa;k=k+1|0;if((k|0)==(c|0))break;else H=ea}c=0-d|0;if((d|0)<(c|0))ga=0;else{ea=+(d|0);k=(f[ba>>2]|0)>>>2;h=0;O=c;while(1){H=+(O|0);fa=H*H;_=Y(O,k)|0;K=c;G=h;while(1){H=+(K|0);g=+M(+(fa+H*H));if(g>ea)ha=G;else{r=(Y(K,A)|0)+_|0;H=+V(+(J*(g*g)));n[v+(G<<2)>>2]=H;f[B+(G<<2)>>2]=r;ha=G+1|0}if((K|0)<(d|0)){K=K+1|0;G=ha}else break}if((O|0)<(d|0)){h=ha;O=O+1|0}else{ga=ha;break}}}f[o>>2]=62036;f[o+4>>2]=A;f[o+8>>2]=d;f[o+12>>2]=ga;f[o+16>>2]=B;f[o+20>>2]=l;f[o+24>>2]=t;n[o+28>>2]=R;f[o+32>>2]=v;f[o+36>>2]=x;f[q>>2]=0;f[q+4>>2]=C;C=f[t+4>>2]|0;if((C|0)<3)ia=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{v=f[t+40>>2]|0;ga=0;d=1;while(1){A=Y(f[v+(ga<<2)>>2]|0,d)|0;ga=ga+1|0;if((ga|0)==(C|0)){ia=A;break}else d=A}}h3(q,o,+(ia>>>0)*.0000152587890625);cYc(x);cYc(B);B=f[m>>2]|0;if(B|0){m=f[da>>2]|0;if((m|0)!=(B|0))f[da>>2]=m+(~((m+-4-B|0)>>>2)<<2);cYc(B)}B=l+36|0;m=f[B>>2]|0;if(m|0?(da=m+12|0,m=f[da>>2]|0,f[da>>2]=m+-1,(m|0)==1):0)V$(l);f[B>>2]=0;B=l+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[$>>2]|0)>0){B=f[ca>>2]|0;ca=0;do{f[B+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[$>>2]|0))}$=f[aa>>2]|0;if(($|0)!=(ba|0))wL($)}else{$=l+8|0;f[$>>2]=0;f[$+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=t;jR(s,l)}break}default:{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;l=$Xc(64)|0;f[j>>2]=l;f[j+8>>2]=-2147483584;f[j+4>>2]=61;D=l;E=278015;F=D+61|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[l+61>>0]=0;vM(-210,j,278077,277839,756)}}j=t+36|0;l=f[j>>2]|0;if(l|0?(E=l+12|0,l=f[E>>2]|0,f[E>>2]=l+-1,(l|0)==1):0)V$(t);f[j>>2]=0;j=t+16|0;l=t+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[l>>2]|0)>0){j=f[t+40>>2]|0;E=0;do{f[j+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[l>>2]|0))}l=f[t+44>>2]|0;if((l|0)!=(t+48|0))wL(l);l=s+36|0;t=f[l>>2]|0;if(t|0?(E=t+12|0,t=f[E>>2]|0,f[E>>2]=t+-1,(t|0)==1):0)V$(s);f[l>>2]=0;l=s+16|0;t=s+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[t>>2]|0)>0){l=f[s+40>>2]|0;E=0;do{f[l+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)==(s+48|0)){u=i;return}wL(t);u=i;return}function Ava(a){a=a|0;cYc(a);return}function Bva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0;d=u;u=u+1072|0;e=d;g=a+24|0;h=f[g>>2]|0;i=f[(f[h+40>>2]|0)+4>>2]|0;j=f[c>>2]|0;k=c+4|0;if((j|0)>=(f[k>>2]|0)){u=d;return}c=a+20|0;l=a+8|0;m=a+4|0;o=i+15|0;p=o&-16;q=o+p|0;r=e+8|0;s=e+4|0;t=q>>>0>264;v=q>>>0>1073741823?-1:q<<2;w=a+12|0;x=a+16|0;y=(i|0)>0;z=a+28|0;A=a+32|0;B=a+36|0;a=o+(p*3|0)|0;o=e+8|0;C=e+4|0;D=a>>>0>264;E=a>>>0>1073741823?-1:a<<2;F=q<<2;G=a<<2;H=j;j=h;a:while(1){h=f[c>>2]|0;I=f[l>>2]|0;J=(f[h+16>>2]|0)+(Y(f[f[h+44>>2]>>2]|0,I+H|0)|0)|0;h=f[m>>2]|0;K=J+((Y(h,I)|0)<<2)|0;I=(f[j+16>>2]|0)+(Y(f[f[j+44>>2]>>2]|0,H)|0)|0;switch(h|0){case 1:{f[e>>2]=r;f[s>>2]=q;if(t){h=bYc(v)|0;f[e>>2]=h;M=h}else M=r;g1c(M|0,0,F|0)|0;h=f[e>>2]|0;J=h+15&-16;N=J+(p<<2)|0;O=f[w>>2]|0;P=h;if((O|0)>0){Q=f[x>>2]|0;if(y){R=f[A>>2]|0;S=f[B>>2]|0;T=0;do{U=K+(f[Q+(T<<2)>>2]<<2)|0;V=R+(T<<2)|0;W=0;do{X=+n[U+(W<<2)>>2];Z=+L(+(X-+n[K+(W<<2)>>2]));_=Z*+n[z>>2];$=~~_;aa=$-(+($|0)>_&1)|0;Z=+n[S+(aa<<2)>>2];ba=+n[V>>2]*(Z+(+n[S+(aa+1<<2)>>2]-Z)*(_-+(aa|0)));aa=N+(W<<2)|0;n[aa>>2]=+n[aa>>2]+ba;aa=J+(W<<2)|0;n[aa>>2]=+n[aa>>2]+X*ba;W=W+1|0}while((W|0)!=(i|0));T=T+1|0}while((T|0)<(O|0));ca=12}}else ca=12;if((ca|0)==12?(ca=0,y):0){O=0;do{n[I+(O<<2)>>2]=+n[J+(O<<2)>>2]/+n[N+(O<<2)>>2];O=O+1|0}while((O|0)!=(i|0))}if((P|0)!=(r|0)){if(h|0)dYc(h);f[e>>2]=r;f[s>>2]=264}break}case 3:{f[e>>2]=o;f[C>>2]=a;if(D){O=bYc(E)|0;f[e>>2]=O;da=O}else da=o;g1c(da|0,0,G|0)|0;O=f[e>>2]|0;N=O+15&-16;J=N+(p<<2)|0;T=J+(p<<2)|0;S=T+(p<<2)|0;R=f[w>>2]|0;Q=O;if((R|0)>0){W=f[x>>2]|0;if(y){V=f[A>>2]|0;U=f[B>>2]|0;aa=0;do{$=V+(aa<<2)|0;ea=K+(f[W+(aa<<2)>>2]<<2)|0;fa=K;ga=0;while(1){ba=+n[ea>>2];X=+n[ea+4>>2];_=+n[ea+8>>2];Z=+L(+(ba-+n[fa>>2]));ha=Z+ +L(+(X-+n[fa+4>>2]));Z=ha+ +L(+(_-+n[fa+8>>2]));ha=Z*+n[z>>2];ia=~~ha;ja=ia-(+(ia|0)>ha&1)|0;Z=+n[U+(ja<<2)>>2];ka=+n[$>>2]*(Z+(+n[U+(ja+1<<2)>>2]-Z)*(ha-+(ja|0)));ja=S+(ga<<2)|0;n[ja>>2]=+n[ja>>2]+ka;ja=N+(ga<<2)|0;n[ja>>2]=+n[ja>>2]+ba*ka;ja=J+(ga<<2)|0;n[ja>>2]=+n[ja>>2]+X*ka;ja=T+(ga<<2)|0;n[ja>>2]=+n[ja>>2]+_*ka;ga=ga+1|0;if((ga|0)==(i|0))break;else{ea=ea+12|0;fa=fa+12|0}}aa=aa+1|0}while((aa|0)<(R|0));ca=28}}else ca=28;if((ca|0)==28?(ca=0,y):0){R=I;aa=0;while(1){U=S+(aa<<2)|0;ka=1.0/+n[U>>2];n[U>>2]=ka;n[R>>2]=ka*+n[N+(aa<<2)>>2];n[R+4>>2]=+n[J+(aa<<2)>>2]*+n[U>>2];n[R+8>>2]=+n[T+(aa<<2)>>2]*+n[U>>2];aa=aa+1|0;if((aa|0)==(i|0))break;else R=R+12|0}}if((Q|0)!=(o|0)){if(O|0)dYc(O);f[e>>2]=o;f[C>>2]=264}break}default:{ca=19;break a}}R=H+1|0;if((R|0)>=(f[k>>2]|0)){ca=37;break}H=R;j=f[g>>2]|0}if((ca|0)==19){f[e+8>>2]=0;b[e+11>>0]=7;b[e>>0]=b[278093]|0;b[e+1>>0]=b[278094]|0;b[e+2>>0]=b[278095]|0;b[e+3>>0]=b[278096]|0;b[e+4>>0]=b[278097]|0;b[e+5>>0]=b[278098]|0;b[e+6>>0]=b[278099]|0;b[e+7>>0]=0;vM(-215,e,528391,277839,467)}else if((ca|0)==37){u=d;return}}function Cva(a){a=a|0;cYc(a);return}function Dva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;d=u;u=u+1072|0;e=d;g=a+8|0;i=f[g>>2]|0;j=(f[i>>2]|0)>>>3&511;k=j+1|0;l=f[(f[i+40>>2]|0)+4>>2]|0;m=f[c>>2]|0;o=c+4|0;if((m|0)>=(f[o>>2]|0)){u=d;return}c=a+4|0;p=a+12|0;q=(j|0)==0;j=l+15|0;r=j&-16;s=j+r|0;t=e+8|0;v=e+4|0;w=s>>>0>264;x=s>>>0>1073741823?-1:s<<2;y=a+16|0;z=a+20|0;A=(l|0)>0;B=a+24|0;C=a+28|0;a=j+(r*3|0)|0;j=e+8|0;D=e+4|0;E=a>>>0>264;F=a>>>0>1073741823?-1:a<<2;G=s<<2;H=a<<2;I=m;m=i;while(1){i=f[c>>2]|0;J=f[p>>2]|0;K=(f[i+16>>2]|0)+(Y(f[f[i+44>>2]>>2]|0,J+I|0)|0)+(Y(J,k)|0)|0;J=(f[m+16>>2]|0)+(Y(f[f[m+44>>2]>>2]|0,I)|0)|0;if(q){f[e>>2]=t;f[v>>2]=s;if(w){i=bYc(x)|0;f[e>>2]=i;L=i}else L=t;g1c(L|0,0,G|0)|0;i=f[e>>2]|0;M=i+15&-16;N=M+(r<<2)|0;O=f[y>>2]|0;P=i;a:do if((O|0)>0){if(!A){i=0;while(1){i=i+1|0;if((i|0)>=(O|0))break a}}i=f[z>>2]|0;Q=f[B>>2]|0;R=f[C>>2]|0;S=0;do{T=K+(f[i+(S<<2)>>2]|0)|0;U=Q+(S<<2)|0;V=0;do{W=b[T+V>>0]|0;X=(W&255)-(h[K+V>>0]|0)|0;Z=+n[U>>2]*+n[R+(((X|0)>-1?X:0-X|0)<<2)>>2];X=N+(V<<2)|0;n[X>>2]=+n[X>>2]+Z;X=M+(V<<2)|0;n[X>>2]=+(W&255)*Z+ +n[X>>2];V=V+1|0}while((V|0)!=(l|0));S=S+1|0}while((S|0)<(O|0))}while(0);if(A){O=0;do{S=(ALc(+n[M+(O<<2)>>2]/+n[N+(O<<2)>>2])|0)&255;b[J+O>>0]=S;O=O+1|0}while((O|0)!=(l|0));_=f[e>>2]|0}else _=P;if((_|0)!=(t|0)){if(_|0)dYc(_);f[e>>2]=t;f[v>>2]=264}}else{f[e>>2]=j;f[D>>2]=a;if(E){O=bYc(F)|0;f[e>>2]=O;$=O}else $=j;g1c($|0,0,H|0)|0;O=f[e>>2]|0;N=O+15&-16;M=N+(r<<2)|0;S=M+(r<<2)|0;R=S+(r<<2)|0;Q=f[y>>2]|0;i=O;b:do if((Q|0)>0){if(!A){O=0;while(1){O=O+1|0;if((O|0)>=(Q|0))break b}}O=f[z>>2]|0;V=f[B>>2]|0;U=f[C>>2]|0;T=0;do{X=V+(T<<2)|0;W=K;aa=K+(f[O+(T<<2)>>2]|0)|0;ba=0;while(1){ca=b[aa>>0]|0;da=b[aa+1>>0]|0;ea=b[aa+2>>0]|0;fa=(ca&255)-(h[W>>0]|0)|0;ga=(da&255)-(h[W+1>>0]|0)|0;ha=(ea&255)-(h[W+2>>0]|0)|0;Z=+n[X>>2]*+n[U+(((ga|0)>-1?ga:0-ga|0)+((fa|0)>-1?fa:0-fa|0)+((ha|0)>-1?ha:0-ha|0)<<2)>>2];ha=R+(ba<<2)|0;n[ha>>2]=+n[ha>>2]+Z;ha=N+(ba<<2)|0;n[ha>>2]=+(ca&255)*Z+ +n[ha>>2];ha=M+(ba<<2)|0;n[ha>>2]=+(da&255)*Z+ +n[ha>>2];ha=S+(ba<<2)|0;n[ha>>2]=+(ea&255)*Z+ +n[ha>>2];ba=ba+1|0;if((ba|0)==(l|0))break;else{W=W+3|0;aa=aa+3|0}}T=T+1|0}while((T|0)<(Q|0))}while(0);if(A){Q=J;K=0;while(1){P=R+(K<<2)|0;Z=1.0/+n[P>>2];n[P>>2]=Z;T=(ALc(Z*+n[N+(K<<2)>>2])|0)&255;b[Q>>0]=T;T=(ALc(+n[M+(K<<2)>>2]*+n[P>>2])|0)&255;b[Q+1>>0]=T;T=(ALc(+n[S+(K<<2)>>2]*+n[P>>2])|0)&255;b[Q+2>>0]=T;K=K+1|0;if((K|0)==(l|0))break;else Q=Q+3|0}ia=f[e>>2]|0}else ia=i;if((ia|0)!=(j|0)){if(ia|0)dYc(ia);f[e>>2]=j;f[D>>2]=264}}Q=I+1|0;if((Q|0)>=(f[o>>2]|0))break;I=Q;m=f[g>>2]|0}u=d;return}function Eva(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;g=u;u=u+3312|0;h=g;i=g+3248|0;j=g+2184|0;k=g+1120|0;l=g+56|0;m=a+4|0;o=c+4|0;if((f[m>>2]|0)==(f[o>>2]|0)){p=$Xc(48)|0;f[h>>2]=p;f[h+8>>2]=-2147483600;f[h+4>>2]=34;q=p;r=353853;s=q+34|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[p+34>>0]=0;vM(-215,h,353888,353899,133)}do if((eS(a)|0)==65536){p=f[m>>2]|0;f[i>>2]=f[p>>2];t=i+4|0;v=p+4|0;f[t>>2]=f[v>>2];w=i+8|0;f[w>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];x=f[p+36>>2]|0;f[i+36>>2]=x;f[i+40>>2]=w;w=i+48|0;y=i+44|0;f[y>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[p+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;U$(i,p);break}}else bS(i,a,-1);while(0);a=k0(i,2,-1,1)|0;m=f[i>>2]&7;if((a|0)<=-1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=$Xc(64)|0;f[h>>2]=z;A=h+8|0;f[A>>2]=-2147483584;B=h+4|0;f[B>>2]=50;q=z;r=353972;s=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));C=z+50|0;b[C>>0]=0;vM(-215,h,353888,353899,137)}p=(m|0)==5;if((m|1|0)!=5){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=$Xc(64)|0;f[h>>2]=z;A=h+8|0;f[A>>2]=-2147483584;B=h+4|0;f[B>>2]=50;q=z;r=353972;s=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));C=z+50|0;b[C>>0]=0;vM(-215,h,353888,353899,137)}if(a){if(YS(c)|0)D=(dS(c,-1)|0)!=4;else D=e;e=j+8|0;f[j>>2]=e;C=j+4|0;z=a>>>0>264;f[C>>2]=a;if(z){B=bYc(a>>>0>1073741823?-1:a<<2)|0;f[j>>2]=B;E=B}else E=e;B=a+2|0;A=k+8|0;f[k>>2]=A;t=k+4|0;f[t>>2]=B;if(B>>>0>264){v=bYc(B>>>0>1073741823?-1:B<<2)|0;f[k>>2]=v;F=v}else F=A;v=l+8|0;f[l>>2]=v;B=l+4|0;f[B>>2]=a;if(z){z=bYc(a>>>0>1073741823?-1:a<<2)|0;f[l>>2]=z;G=z}else G=v;z=f[i+16>>2]|0;if(!(f[i>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=$Xc(32)|0;f[h>>2]=w;f[h+8>>2]=-2147483616;f[h+4>>2]=21;q=w;r=354023;s=q+21|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[w+21>>0]=0;vM(-215,h,353888,353899,156)}else H=0;do{f[E+(H<<2)>>2]=z+(H<<3);H=H+1|0}while((H|0)!=(a|0));H=E+(a<<2)|0;if(p){Gva(E,H,h);if((a|0)>1){w=1;r=0;q=0;while(1){I=+n[(f[E+(w<<2)>>2]|0)+4>>2];s=+n[(f[E+(r<<2)>>2]|0)+4>>2]>I?w:r;y=+n[(f[E+(q<<2)>>2]|0)+4>>2]<I?w:q;w=w+1|0;if((w|0)==(a|0)){J=s;K=y;break}else{r=s;q=y}}}else{J=0;K=0}}else{Fva(E,H,h);if((a|0)>1){H=0;q=0;r=1;while(1){w=f[(f[E+(r<<2)>>2]|0)+4>>2]|0;y=(f[(f[E+(H<<2)>>2]|0)+4>>2]|0)>(w|0)?r:H;s=(f[(f[E+(q<<2)>>2]|0)+4>>2]|0)<(w|0)?r:q;r=r+1|0;if((r|0)==(a|0)){J=y;K=s;break}else{H=y;q=s}}}else{J=0;K=0}}q=f[E>>2]|0;H=a+-1|0;a=f[E+(H<<2)>>2]|0;if((f[q>>2]|0)==(f[a>>2]|0)?(f[q+4>>2]|0)==(f[a+4>>2]|0):0){f[G>>2]=0;L=1}else{a=F;if(p){q=Iva(E,0,K,F,-1,1)|0;r=F+(q<<2)|0;M=r;N=Iva(E,H,K,r,-1,-1)|0;O=q}else{q=Hva(E,0,K,F,-1,1)|0;r=F+(q<<2)|0;M=r;N=Hva(E,H,K,r,-1,-1)|0;O=q}q=M;M=d?a:q;r=d?O:N;K=d?q:a;q=d?N:O;O=r+-1|0;if((r|0)>1){N=M;s=z;y=0;do{f[G+(y<<2)>>2]=(f[E+(f[N+(y<<2)>>2]<<2)>>2]|0)-s>>3;y=y+1|0}while((y|0)!=(O|0));P=O}else P=0;if((q|0)>1){O=K;y=z;s=q+P+-1|0;N=P;w=q;do{w=w+-1|0;x=N;N=N+1|0;f[G+(x<<2)>>2]=(f[E+(f[O+(w<<2)>>2]<<2)>>2]|0)-y>>3}while((N|0)!=(s|0));if((q|0)>2){Q=s;R=K+4|0;S=47}else{T=s;S=45}}else{T=P;S=45}if((S|0)==45)if((r|0)>2){Q=T;R=M+(r+-2<<2)|0;S=47}else{U=T;V=-1}if((S|0)==47){U=Q;V=f[R>>2]|0}if(p){p=Iva(E,0,J,F,1,-1)|0;R=F+(p<<2)|0;W=R;X=p;Z=Iva(E,H,J,R,1,1)|0}else{R=Hva(E,0,J,F,1,-1)|0;p=F+(R<<2)|0;W=p;X=R;Z=Hva(E,H,J,p,1,1)|0}p=W;W=d?p:a;J=d?Z:X;H=d?a:p;p=d?X:Z;do if((V|0)>-1){do if((J|0)>2){_=W+4|0;S=56}else{if((J+p|0)<=2){$=-1;break}_=H+(2-J<<2)|0;S=56}while(0);if((S|0)==56)$=f[_>>2]|0;if(($|0)!=(V|0)){if(($|0)<=-1){S=62;break}Z=f[E+($<<2)>>2]|0;X=f[E+(V<<2)>>2]|0;if((f[Z>>2]|0)!=(f[X>>2]|0)){S=62;break}if((f[Z+4>>2]|0)!=(f[X+4>>2]|0)){S=62;break}}X=(p|0)<2?p:2;if((J|0)<2){aa=X;ba=U}else{ca=X;da=2;ea=1;S=63}}else S=62;while(0);if((S|0)==62)if((J|0)>1){ca=p;da=J;ea=J+-1|0;S=63}else{aa=p;ba=U}if((S|0)==63){S=W;W=z;p=da+U|0;da=U;U=0;while(1){f[G+(da<<2)>>2]=(f[E+(f[S+(U<<2)>>2]<<2)>>2]|0)-W>>3;U=U+1|0;if((U|0)==(ea|0))break;else da=da+1|0}aa=ca;ba=p+-1|0}if((aa|0)>1){p=H;H=z;ca=aa+ba|0;da=ba;ea=aa;while(1){ea=ea+-1|0;f[G+(da<<2)>>2]=(f[E+(f[p+(ea<<2)>>2]<<2)>>2]|0)-H>>3;if((ea|0)<=1)break;else da=da+1|0}L=ca+-1|0}else L=ba}if(D){ZS(c,L,1,m|8,-1,0,0);do if((eS(c)|0)==65536){m=f[o>>2]|0;f[h>>2]=f[m>>2];D=h+4|0;ba=m+4|0;f[D>>2]=f[ba>>2];ca=h+8|0;f[ca>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];da=f[m+36>>2]|0;f[h+36>>2]=da;f[h+40>>2]=ca;ca=h+48|0;ea=h+44|0;f[ea>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(da|0){ca=da+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[ba>>2]|0)<3){ba=f[m+44>>2]|0;ca=f[ea>>2]|0;f[ca>>2]=f[ba>>2];f[ca+4>>2]=f[ba+4>>2];fa=h;break}else{f[D>>2]=0;U$(h,m);fa=h;break}}else{bS(h,c,-1);fa=h}while(0);if(!(f[fa>>2]&16384))ga=f[f[h+44>>2]>>2]|0;else ga=8;if((L|0)>0){fa=f[h+16>>2]|0;o=0;do{m=f[G+(o<<2)>>2]|0;D=fa+(Y(o,ga)|0)|0;f[D>>2]=f[z+(m<<3)>>2];f[D+4>>2]=f[z+(m<<3)+4>>2];o=o+1|0}while((o|0)!=(L|0))}o=h+36|0;z=f[o>>2]|0;do if(z|0){ga=z+12|0;fa=f[ga>>2]|0;f[ga>>2]=fa+-1;if((fa|0)!=1)break;V$(h)}while(0);f[o>>2]=0;o=h+16|0;z=h+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[z>>2]|0)>0){o=f[h+40>>2]|0;fa=0;do{f[o+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[z>>2]|0))}z=f[h+44>>2]|0;if((z|0)!=(h+48|0))wL(z)}else{f[h>>2]=1124007940;z=h+4|0;f[z>>2]=2;fa=h+8|0;f[fa>>2]=L;f[h+12>>2]=1;o=h+16|0;f[o>>2]=G;f[h+20>>2]=G;ga=h+24|0;m=h+40|0;D=ga+8|0;f[D>>2]=0;f[D+4>>2]=0;f[m>>2]=fa;fa=h+48|0;D=h+44|0;f[D>>2]=fa;f[fa>>2]=4;f[h+52>>2]=4;ba=G+(L<<2)|0;f[h+28>>2]=ba;f[ga>>2]=ba+-4+4;R$(h);jR(h,c);ba=h+36|0;ga=f[ba>>2]|0;if(ga|0?(L=ga+12|0,ga=f[L>>2]|0,f[L>>2]=ga+-1,(ga|0)==1):0)V$(h);f[ba>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[z>>2]|0)>0){o=f[m>>2]|0;m=0;do{f[o+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[z>>2]|0))}z=f[D>>2]|0;if((z|0)!=(fa|0))wL(z)}z=f[l>>2]|0;if((z|0)!=(v|0)){if(z|0)dYc(z);f[l>>2]=v;f[B>>2]=264}B=f[k>>2]|0;if((B|0)!=(A|0)){if(B|0)dYc(B);f[k>>2]=A;f[t>>2]=264}t=f[j>>2]|0;if((t|0)!=(e|0)){if(t|0)dYc(t);f[j>>2]=e;f[C>>2]=264}}else vS(c);c=i+36|0;C=f[c>>2]|0;if(C|0?(e=C+12|0,C=f[e>>2]|0,f[e>>2]=C+-1,(C|0)==1):0)V$(i);f[c>>2]=0;c=i+16|0;C=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[C>>2]|0)>0){c=f[i+40>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[C>>2]|0))}C=f[i+44>>2]|0;if((C|0)==(i+48|0)){u=g;return}wL(C);u=g;return}function Fva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}n=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){o=(l|0)/4|0;p=Ova(i,i+(o<<2)|0,n,n+(o<<2)|0,e,c)|0}else{o=f[n>>2]|0;q=f[i>>2]|0;r=f[o>>2]|0;s=f[q>>2]|0;t=o;u=q;if((r|0)>=(s|0))if((r|0)==(s|0))v=(f[o+4>>2]|0)<(f[q+4>>2]|0);else v=0;else v=1;w=f[e>>2]|0;x=f[w>>2]|0;y=w;if((x|0)>=(r|0))if((x|0)==(r|0))z=(f[w+4>>2]|0)<(f[o+4>>2]|0);else z=0;else z=1;if(!v){if(!z){p=0;break}f[n>>2]=y;f[e>>2]=t;o=f[n>>2]|0;w=f[i>>2]|0;r=f[o>>2]|0;x=f[w>>2]|0;A=w;B=o;if((r|0)>=(x|0)){if((r|0)!=(x|0)){p=1;break}if((f[o+4>>2]|0)>=(f[w+4>>2]|0)){p=1;break}}f[i>>2]=B;f[n>>2]=A;p=2;break}if(z){f[i>>2]=y;f[e>>2]=u;p=1;break}f[i>>2]=t;f[n>>2]=u;t=f[e>>2]|0;y=f[t>>2]|0;A=t;if((y|0)>=(s|0)){if((y|0)!=(s|0)){p=1;break}if((f[t+4>>2]|0)>=(f[q+4>>2]|0)){p=1;break}}f[n>>2]=A;f[e>>2]=u;p=2}while(0);C=f[i>>2]|0;l=f[n>>2]|0;k=f[C>>2]|0;u=f[l>>2]|0;if((k|0)<(u|0)){D=e;E=p;break}if((k|0)==(u|0)?(f[C+4>>2]|0)<(f[l+4>>2]|0):0){D=e;E=p;break}if((i|0)!=(g|0)){A=l+4|0;F=g;while(1){G=f[F>>2]|0;l=f[G>>2]|0;if((l|0)<(u|0)){m=82;break b}if((l|0)==(u|0)?(f[G+4>>2]|0)<(f[A>>2]|0):0){m=82;break b}l=F+-4|0;if((i|0)==(l|0))break;else F=l}}A=i+4|0;u=f[e>>2]|0;l=f[u>>2]|0;q=u;do if((k|0)<(l|0))H=A;else{if((k|0)==(l|0)?(f[C+4>>2]|0)<(f[u+4>>2]|0):0){H=A;break}if((A|0)==(e|0)){m=107;break a}t=C+4|0;s=A;while(1){I=f[s>>2]|0;y=f[I>>2]|0;if((k|0)<(y|0))break;if((k|0)==(y|0)?(f[t>>2]|0)<(f[I+4>>2]|0):0)break;y=s+4|0;if((y|0)==(e|0)){m=107;break a}else s=y}f[s>>2]=q;f[e>>2]=I;H=s+4|0}while(0);if((H|0)==(e|0)){m=107;break a}else{J=e;K=H}while(1){q=f[i>>2]|0;k=f[K>>2]|0;A=f[q>>2]|0;u=f[k>>2]|0;c:do if((A|0)<(u|0))L=K;else{l=q+4|0;t=K;y=u;B=k;while(1){if((A|0)==(y|0)?(f[l>>2]|0)<(f[B+4>>2]|0):0){L=t;break c}w=t+4|0;B=f[w>>2]|0;y=f[B>>2]|0;if((A|0)<(y|0)){L=w;break}else t=w}}while(0);k=q+4|0;u=J;while(1){s=u;u=u+-4|0;M=f[u>>2]|0;s=f[M>>2]|0;if((A|0)<(s|0)){u=u;continue}if((A|0)!=(s|0))break;if((f[k>>2]|0)>=(f[M+4>>2]|0))break}if(L>>>0>=u>>>0){i=L;continue b}k=f[L>>2]|0;f[L>>2]=M;f[u>>2]=k;J=u;K=L+4|0}}if((m|0)==82){m=0;f[i>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=i+4|0;d:do if(k>>>0<D>>>0){A=n;q=D;s=k;t=E;while(1){y=f[A>>2]|0;B=f[y>>2]|0;l=y+4|0;y=s;while(1){N=f[y>>2]|0;w=f[N>>2]|0;if((w|0)>=(B|0)){if((w|0)!=(B|0))break;if((f[N+4>>2]|0)>=(f[l>>2]|0))break}y=y+4|0}u=N;w=q+-4|0;o=f[w>>2]|0;x=f[o>>2]|0;e:do if((x|0)<(B|0))O=w;else{r=x;P=o;Q=w;while(1){if((r|0)==(B|0)?(f[P+4>>2]|0)<(f[l>>2]|0):0){O=Q;break e}R=Q+-4|0;P=f[R>>2]|0;r=f[P>>2]|0;if((r|0)<(B|0)){O=R;break}else Q=R}}while(0);if(y>>>0>O>>>0){S=A;T=t;U=y;break d}f[y>>2]=f[O>>2];f[O>>2]=u;A=(A|0)==(y|0)?O:A;q=O;s=y+4|0;t=t+1|0}}else{S=n;T=E;U=k}while(0);do if((U|0)==(S|0))V=T;else{k=f[S>>2]|0;t=f[U>>2]|0;s=f[k>>2]|0;q=f[t>>2]|0;A=t;B=k;if((s|0)>=(q|0)){if((s|0)!=(q|0)){V=T;break}if((f[k+4>>2]|0)>=(f[t+4>>2]|0)){V=T;break}}f[U>>2]=B;f[S>>2]=A;V=T+1|0}while(0);if(!V){W=Qva(i,U,c)|0;A=U+4|0;if(Qva(A,a,c)|0){m=106;break}if(W){h=A;continue}}A=U;if((A-j|0)>=(b-A|0)){m=105;break}Fva(i,U,c);h=U+4|0}if((m|0)==105){m=0;Fva(U+4|0,a,c);d=i;a=U;continue}else if((m|0)==106){m=0;if(W){m=107;break}else{d=i;a=U;continue}}}if((m|0)==5){U=f[e>>2]|0;d=f[i>>2]|0;W=f[U>>2]|0;j=f[d>>2]|0;V=d;T=U;if((W|0)>=(j|0)){if((W|0)!=(j|0))return;if((f[U+4>>2]|0)>=(f[d+4>>2]|0))return}f[i>>2]=T;f[e>>2]=V;return}else if((m|0)==9){V=i+4|0;T=f[V>>2]|0;d=f[i>>2]|0;U=f[T>>2]|0;j=f[d>>2]|0;W=T;S=d;if((U|0)>=(j|0))if((U|0)==(j|0))X=(f[T+4>>2]|0)<(f[d+4>>2]|0);else X=0;else X=1;E=f[e>>2]|0;n=f[E>>2]|0;O=E;if((n|0)>=(U|0))if((n|0)==(U|0))Y=(f[E+4>>2]|0)<(f[T+4>>2]|0);else Y=0;else Y=1;if(!X){if(!Y)return;f[V>>2]=O;f[e>>2]=W;X=f[V>>2]|0;T=f[i>>2]|0;E=f[X>>2]|0;U=f[T>>2]|0;n=T;N=X;if((E|0)>=(U|0)){if((E|0)!=(U|0))return;if((f[X+4>>2]|0)>=(f[T+4>>2]|0))return}f[i>>2]=N;f[V>>2]=n;return}if(Y){f[i>>2]=O;f[e>>2]=S;return}f[i>>2]=W;f[V>>2]=S;W=f[e>>2]|0;O=f[W>>2]|0;Y=W;if((O|0)>=(j|0)){if((O|0)!=(j|0))return;if((f[W+4>>2]|0)>=(f[d+4>>2]|0))return}f[V>>2]=Y;f[e>>2]=S;return}else if((m|0)==27){Nva(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){Ova(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){Pva(i,a,c);return}else if((m|0)==107)return}
function Gva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}o=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){p=(l|0)/4|0;q=Kva(i,i+(p<<2)|0,o,o+(p<<2)|0,e,c)|0}else{p=f[o>>2]|0;r=f[i>>2]|0;s=+n[p>>2];t=+n[r>>2];u=p;v=r;if(!(s<t))if(s==t)w=+n[p+4>>2]<+n[r+4>>2];else w=0;else w=1;x=f[e>>2]|0;y=+n[x>>2];z=x;if(!(y<s))if(y==s)A=+n[x+4>>2]<+n[p+4>>2];else A=0;else A=1;if(!w){if(!A){q=0;break}f[o>>2]=z;f[e>>2]=u;p=f[o>>2]|0;x=f[i>>2]|0;s=+n[p>>2];y=+n[x>>2];B=x;C=p;if(!(s<y)){if(!(s==y)){q=1;break}if(!(+n[p+4>>2]<+n[x+4>>2])){q=1;break}}f[i>>2]=C;f[o>>2]=B;q=2;break}if(A){f[i>>2]=z;f[e>>2]=v;q=1;break}f[i>>2]=u;f[o>>2]=v;u=f[e>>2]|0;y=+n[u>>2];z=u;if(!(y<t)){if(!(y==t)){q=1;break}if(!(+n[u+4>>2]<+n[r+4>>2])){q=1;break}}f[o>>2]=z;f[e>>2]=v;q=2}while(0);D=f[i>>2]|0;l=f[o>>2]|0;t=+n[D>>2];y=+n[l>>2];if(t<y){E=e;F=q;break}if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){E=e;F=q;break}if((i|0)!=(g|0)){k=l+4|0;G=g;while(1){H=f[G>>2]|0;s=+n[H>>2];if(s<y){m=82;break b}if(s==y?+n[H+4>>2]<+n[k>>2]:0){m=82;break b}l=G+-4|0;if((i|0)==(l|0))break;else G=l}}k=i+4|0;l=f[e>>2]|0;y=+n[l>>2];v=l;do if(t<y)I=k;else{if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){I=k;break}if((k|0)==(e|0)){m=107;break a}z=D+4|0;r=k;while(1){J=f[r>>2]|0;s=+n[J>>2];if(t<s)break;if(t==s?+n[z>>2]<+n[J+4>>2]:0)break;u=r+4|0;if((u|0)==(e|0)){m=107;break a}else r=u}f[r>>2]=v;f[e>>2]=J;I=r+4|0}while(0);if((I|0)==(e|0)){m=107;break a}else{K=e;L=I}while(1){v=f[i>>2]|0;k=f[L>>2]|0;t=+n[v>>2];y=+n[k>>2];c:do if(t<y)M=L;else{l=v+4|0;z=L;s=y;u=k;while(1){if(t==s?+n[l>>2]<+n[u+4>>2]:0){M=z;break c}B=z+4|0;u=f[B>>2]|0;s=+n[u>>2];if(t<s){M=B;break}else z=B}}while(0);k=v+4|0;r=K;while(1){z=r;r=r+-4|0;N=f[r>>2]|0;y=+n[N>>2];if(t<y){r=r;continue}if(!(t==y))break;if(!(+n[k>>2]<+n[N+4>>2]))break}if(M>>>0>=r>>>0){i=M;continue b}k=f[M>>2]|0;f[M>>2]=N;f[r>>2]=k;K=r;L=M+4|0}}if((m|0)==82){m=0;f[i>>2]=H;f[G>>2]=D;E=G;F=q+1|0}k=i+4|0;d:do if(k>>>0<E>>>0){v=o;z=E;u=k;l=F;while(1){B=f[v>>2]|0;t=+n[B>>2];C=B+4|0;B=u;while(1){O=f[B>>2]|0;y=+n[O>>2];if(!(y<t)){if(!(y==t))break;if(!(+n[O+4>>2]<+n[C>>2]))break}B=B+4|0}r=O;x=z+-4|0;p=f[x>>2]|0;y=+n[p>>2];e:do if(y<t)P=x;else{s=y;Q=p;R=x;while(1){if(s==t?+n[Q+4>>2]<+n[C>>2]:0){P=R;break e}S=R+-4|0;Q=f[S>>2]|0;s=+n[Q>>2];if(s<t){P=S;break}else R=S}}while(0);if(B>>>0>P>>>0){T=v;U=l;V=B;break d}f[B>>2]=f[P>>2];f[P>>2]=r;v=(v|0)==(B|0)?P:v;z=P;u=B+4|0;l=l+1|0}}else{T=o;U=F;V=k}while(0);do if((V|0)==(T|0))W=U;else{k=f[T>>2]|0;l=f[V>>2]|0;t=+n[k>>2];y=+n[l>>2];u=l;z=k;if(!(t<y)){if(!(t==y)){W=U;break}if(!(+n[k+4>>2]<+n[l+4>>2])){W=U;break}}f[V>>2]=z;f[T>>2]=u;W=U+1|0}while(0);if(!W){X=Mva(i,V,c)|0;u=V+4|0;if(Mva(u,a,c)|0){m=106;break}if(X){h=u;continue}}u=V;if((u-j|0)>=(b-u|0)){m=105;break}Gva(i,V,c);h=V+4|0}if((m|0)==105){m=0;Gva(V+4|0,a,c);d=i;a=V;continue}else if((m|0)==106){m=0;if(X){m=107;break}else{d=i;a=V;continue}}}if((m|0)==5){V=f[e>>2]|0;d=f[i>>2]|0;y=+n[V>>2];t=+n[d>>2];X=d;j=V;if(!(y<t)){if(!(y==t))return;if(!(+n[V+4>>2]<+n[d+4>>2]))return}f[i>>2]=j;f[e>>2]=X;return}else if((m|0)==9){X=i+4|0;j=f[X>>2]|0;d=f[i>>2]|0;t=+n[j>>2];y=+n[d>>2];V=j;W=d;if(!(t<y))if(t==y)Y=+n[j+4>>2]<+n[d+4>>2];else Y=0;else Y=1;U=f[e>>2]|0;s=+n[U>>2];T=U;if(!(s<t))if(s==t)Z=+n[U+4>>2]<+n[j+4>>2];else Z=0;else Z=1;if(!Y){if(!Z)return;f[X>>2]=T;f[e>>2]=V;Y=f[X>>2]|0;j=f[i>>2]|0;t=+n[Y>>2];s=+n[j>>2];U=j;F=Y;if(!(t<s)){if(!(t==s))return;if(!(+n[Y+4>>2]<+n[j+4>>2]))return}f[i>>2]=F;f[X>>2]=U;return}if(Z){f[i>>2]=T;f[e>>2]=W;return}f[i>>2]=V;f[X>>2]=W;V=f[e>>2]|0;s=+n[V>>2];T=V;if(!(s<y)){if(!(s==y))return;if(!(+n[V+4>>2]<+n[d+4>>2]))return}f[X>>2]=T;f[e>>2]=W;return}else if((m|0)==27){Jva(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){Kva(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){Lva(i,a,c);return}else if((m|0)==107)return}function Hva(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if((f[k>>2]|0)==(f[l>>2]|0)?(f[k+4>>2]|0)==(f[l+4>>2]|0):0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))n=3;else{o=b;p=i;q=j;r=3;while(1){s=d+(r+-1<<2)|0;t=a+(o<<2)|0;u=f[a+(p<<2)>>2]|0;b:do if((o|0)!=(b|0)){v=u+4|0;w=q;while(1){x=f[v>>2]|0;y=f[a+(w<<2)>>2]|0;z=(f[y+4>>2]|0)-x|0;if((((z|0)>0&1)-(z>>>31)|0)!=(e|0))break;A=w+h|0;f[s>>2]=A;if((A|0)==(m|0)){n=r;break a}else w=A}v=f[u>>2]|0;A=f[t>>2]|0;B=v-(f[A>>2]|0)|0;C=x-(f[A+4>>2]|0)|0;A=(Y(C,(f[y>>2]|0)-v|0)|0)-(Y(B,z)|0)|0;if((C|B|0)==0?1:(((A|0)>0&1)-(A>>>31)|0)!=(g|0)){f[d+(r+-2<<2)>>2]=w;D=f[d+(r+-4<<2)>>2]|0;E=o;F=w;G=-1}else{H=p;I=w;J=15}}else{A=p;B=q;C=u;while(1){v=C+4|0;K=B;while(1){L=f[v>>2]|0;M=f[a+(K<<2)>>2]|0;N=(f[M+4>>2]|0)-L|0;if((((N|0)>0&1)-(N>>>31)|0)!=(e|0))break;O=K+h|0;f[s>>2]=O;if((O|0)==(m|0)){n=r;break a}else K=O}v=f[C>>2]|0;O=f[t>>2]|0;P=v-(f[O>>2]|0)|0;Q=L-(f[O+4>>2]|0)|0;O=(Y(Q,(f[M>>2]|0)-v|0)|0)-(Y(P,N)|0)|0;if(!((Q|P|0)==0?1:(((O|0)>0&1)-(O>>>31)|0)!=(g|0))){H=A;I=K;J=15;break b}f[l>>2]=K;O=K+h|0;f[k>>2]=O;if((O|0)==(m|0)){n=r;break a}else{A=K;B=O;C=M}}}while(0);if((J|0)==15){J=0;t=I+h|0;f[d+(r<<2)>>2]=t;D=H;E=I;F=t;G=1}t=r+G|0;if((F|0)==(m|0)){n=t;break}else{o=D;p=E;q=F;r=t}}}while(0);R=n+-1|0;return R|0}while(0);f[d>>2]=b;R=1;return R|0}function Iva(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if(+n[k>>2]==+n[l>>2]?+n[k+4>>2]==+n[l+4>>2]:0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))o=3;else{p=b;q=i;r=j;s=3;while(1){t=d+(s+-1<<2)|0;u=a+(p<<2)|0;v=f[a+(q<<2)>>2]|0;w=+n[v+4>>2];b:do if((p|0)==(b|0)){x=q;y=r;z=w;A=v;while(1){B=y;while(1){C=f[a+(B<<2)>>2]|0;D=+n[C+4>>2];E=D-z;if(((E>0.0&1)-(E<0.0&1)|0)!=(e|0))break;F=B+h|0;f[t>>2]=F;if((F|0)==(m|0)){o=s;break a}else B=F}G=+n[A>>2];F=f[u>>2]|0;H=G-+n[F>>2];I=z-+n[F+4>>2];J=(+n[C>>2]-G)*I-E*H;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?H!=0.0|I!=0.0:0){K=x;L=B;M=16;break b}f[l>>2]=B;F=B+h|0;f[k>>2]=F;if((F|0)==(m|0)){o=s;break a}else{x=B;y=F;z=D;A=C}}}else{A=r;while(1){N=f[a+(A<<2)>>2]|0;O=+n[N+4>>2]-w;if(((O>0.0&1)-(O<0.0&1)|0)!=(e|0))break;y=A+h|0;f[t>>2]=y;if((y|0)==(m|0)){o=s;break a}else A=y}z=+n[v>>2];y=f[u>>2]|0;I=z-+n[y>>2];H=w-+n[y+4>>2];J=(+n[N>>2]-z)*H-O*I;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?I!=0.0|H!=0.0:0){K=q;L=A;M=16;break}f[d+(s+-2<<2)>>2]=A;P=f[d+(s+-4<<2)>>2]|0;Q=p;R=A;S=-1}while(0);if((M|0)==16){M=0;u=L+h|0;f[d+(s<<2)>>2]=u;P=K;Q=L;R=u;S=1}u=s+S|0;if((R|0)==(m|0)){o=u;break}else{p=P;q=Q;r=R;s=u}}}while(0);T=o+-1|0;return T|0}while(0);f[d>>2]=b;T=1;return T|0}function Jva(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h<o)){if(!(h==o)){v=1;w=e;x=j;break}if(!(+n[r+4>>2]<+n[s+4>>2])){v=1;w=e;x=j;break}}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=2;w=t;x=t}else{v=0;w=m;x=p}else{if(q){f[a>>2]=p;f[c>>2]=k;v=1;w=g;x=k;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o<i)){if(!(o==i)){v=1;w=t;x=u;break}if(!(+n[t+4>>2]<+n[g+4>>2])){v=1;w=t;x=u;break}}f[b>>2]=u;f[c>>2]=k;v=2;w=g;x=k}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[w>>2];g=k;if(!(i<o)){if(!(i==o)){y=v;return y|0}if(!(+n[k+4>>2]<+n[w+4>>2])){y=v;return y|0}}f[c>>2]=g;f[d>>2]=x;x=v+1|0;d=f[c>>2]|0;g=f[b>>2]|0;o=+n[d>>2];i=+n[g>>2];w=g;k=d;if(!(o<i)){if(!(o==i)){y=x;return y|0}if(!(+n[d+4>>2]<+n[g+4>>2])){y=x;return y|0}}f[b>>2]=k;f[c>>2]=w;w=v+2|0;c=f[b>>2]|0;k=f[a>>2]|0;i=+n[c>>2];o=+n[k>>2];x=k;g=c;if(!(i<o)){if(!(i==o)){y=w;return y|0}if(!(+n[c+4>>2]<+n[k+4>>2])){y=w;return y|0}}f[a>>2]=g;f[b>>2]=x;y=v+3|0;return y|0}function Kva(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=Jva(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j<k)){if(!(j==k)){o=h;return o|0}if(!(+n[g+4>>2]<+n[i+4>>2])){o=h;return o|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;k=+n[e>>2];j=+n[m>>2];i=m;g=e;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[e+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[c>>2]=g;f[d>>2]=i;i=h+2|0;d=f[c>>2]|0;g=f[b>>2]|0;j=+n[d>>2];k=+n[g>>2];l=g;m=d;if(!(j<k)){if(!(j==k)){o=i;return o|0}if(!(+n[d+4>>2]<+n[g+4>>2])){o=i;return o|0}}f[b>>2]=m;f[c>>2]=l;l=h+3|0;c=f[b>>2]|0;m=f[a>>2]|0;k=+n[c>>2];j=+n[m>>2];i=m;g=c;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[c+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[a>>2]=g;f[b>>2]=i;o=h+4|0;return o|0}function Lva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o<i)){if(!(o==i)){r=j;s=e;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=j;s=e;break}}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o<i)){if(!(o==i)){r=p;s=m;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=p;s=m;break}}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=g;u=c;v=s;w=r}while(1){r=f[t>>2]|0;i=+n[r>>2];o=+n[v>>2];s=r;if(!(i<o)){if(i==o?(c=r+4|0,+n[c>>2]<+n[v+4>>2]):0){x=c;y=25}}else{x=r+4|0;y=25}if((y|0)==25){y=0;f[t>>2]=w;a:do if((u|0)==(a|0))z=u;else{r=u;c=u;while(1){g=c;c=r+-4|0;k=f[c>>2]|0;o=+n[k>>2];p=k;if(!(i<o)){if(!(i==o)){z=g;break a}if(!(+n[x>>2]<+n[k+4>>2])){z=g;break a}}f[g>>2]=p;if((c|0)==(a|0)){z=c;break}else r=c}}while(0);f[z>>2]=s}c=t+4|0;if((c|0)==(b|0))break;r=f[t>>2]|0;p=t;t=c;v=r;w=r;u=p}return}function Mva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h<i)){if(!(h==i)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i<h))if(i==h)o=+n[k+4>>2]<+n[g+4>>2];else o=0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q<i))if(q==i)s=+n[p+4>>2]<+n[k+4>>2];else s=0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i<q)){if(!(i==q)){l=1;return l|0}if(!(+n[o+4>>2]<+n[k+4>>2])){l=1;return l|0}}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q<h)){if(!(q==h)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{Jva(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{Kva(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h<q))if(h==q)u=+n[d+4>>2]<+n[r+4>>2];else u=0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i<h))if(i==h)v=+n[e+4>>2]<+n[d+4>>2];else v=0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i<q)){if(!(i==q)){w=d;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=d;break}}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i<q)){if(!(i==q)){w=e;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=e;break}}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=r;s=0;m=c;e=w;while(1){j=f[g>>2]|0;q=+n[j>>2];i=+n[e>>2];v=j;if(!(q<i))if(q==i?(d=j+4|0,+n[d>>2]<+n[e+4>>2]):0){z=d;A=49}else B=s;else{z=j+4|0;A=49}if((A|0)==49){A=0;f[g>>2]=f[m>>2];b:do if((m|0)==(a|0))C=m;else{j=m;d=m;while(1){u=d;d=j+-4|0;p=f[d>>2]|0;i=+n[p>>2];t=p;if(!(q<i)){if(!(q==i)){C=u;break b}if(!(+n[z>>2]<+n[p+4>>2])){C=u;break b}}f[u>>2]=t;if((d|0)==(a|0)){C=d;break}else j=d}}while(0);f[C>>2]=v;d=s+1|0;if((d|0)==8){x=0;y=(g+4|0)==(b|0);break a}else B=d}d=g+4|0;if((d|0)==(b|0)){x=1;y=0;break a}j=f[g>>2]|0;t=g;g=d;s=B;e=j;m=t}}while(0);l=y|x;return l|0}}return 0}function Nva(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[b>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[b>>2]=o;f[c>>2]=j;h=f[b>>2]|0;n=f[a>>2]|0;q=f[h>>2]|0;r=f[n>>2]|0;s=n;t=h;if((q|0)>=(r|0)){if((q|0)!=(r|0)){u=1;v=e;w=j;break}if((f[h+4>>2]|0)>=(f[n+4>>2]|0)){u=1;v=e;w=j;break}}f[a>>2]=t;f[b>>2]=s;s=f[c>>2]|0;u=2;v=s;w=s}else{u=0;v=m;w=o}else{if(p){f[a>>2]=o;f[c>>2]=k;u=1;v=g;w=k;break}f[a>>2]=j;f[b>>2]=k;s=f[c>>2]|0;t=f[s>>2]|0;n=s;if((t|0)>=(i|0)){if((t|0)!=(i|0)){u=1;v=s;w=n;break}if((f[s+4>>2]|0)>=(f[g+4>>2]|0)){u=1;v=s;w=n;break}}f[b>>2]=n;f[c>>2]=k;u=2;v=g;w=k}while(0);k=f[d>>2]|0;g=f[k>>2]|0;i=f[v>>2]|0;j=k;if((g|0)>=(i|0)){if((g|0)!=(i|0)){x=u;return x|0}if((f[k+4>>2]|0)>=(f[v+4>>2]|0)){x=u;return x|0}}f[c>>2]=j;f[d>>2]=w;w=u+1|0;d=f[c>>2]|0;j=f[b>>2]|0;v=f[d>>2]|0;k=f[j>>2]|0;i=j;g=d;if((v|0)>=(k|0)){if((v|0)!=(k|0)){x=w;return x|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){x=w;return x|0}}f[b>>2]=g;f[c>>2]=i;i=u+2|0;c=f[b>>2]|0;g=f[a>>2]|0;w=f[c>>2]|0;j=f[g>>2]|0;d=g;k=c;if((w|0)>=(j|0)){if((w|0)!=(j|0)){x=i;return x|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){x=i;return x|0}}f[a>>2]=k;f[b>>2]=d;x=u+3|0;return x|0}function Ova(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=Nva(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=f[g>>2]|0;k=f[i>>2]|0;l=i;m=g;if((j|0)>=(k|0)){if((j|0)!=(k|0)){n=h;return n|0}if((f[g+4>>2]|0)>=(f[i+4>>2]|0)){n=h;return n|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;i=f[e>>2]|0;g=f[m>>2]|0;k=m;j=e;if((i|0)>=(g|0)){if((i|0)!=(g|0)){n=l;return n|0}if((f[e+4>>2]|0)>=(f[m+4>>2]|0)){n=l;return n|0}}f[c>>2]=j;f[d>>2]=k;k=h+2|0;d=f[c>>2]|0;j=f[b>>2]|0;l=f[d>>2]|0;m=f[j>>2]|0;e=j;g=d;if((l|0)>=(m|0)){if((l|0)!=(m|0)){n=k;return n|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){n=k;return n|0}}f[b>>2]=g;f[c>>2]=e;e=h+3|0;c=f[b>>2]|0;g=f[a>>2]|0;k=f[c>>2]|0;j=f[g>>2]|0;d=g;m=c;if((k|0)>=(j|0)){if((k|0)!=(j|0)){n=e;return n|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){n=e;return n|0}}f[a>>2]=m;f[b>>2]=d;n=h+4|0;return n|0}function Pva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[d>>2]=o;f[c>>2]=j;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=j;r=e;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=j;r=e;break}}f[a>>2]=o;f[d>>2]=k;q=j;r=e}else{q=o;r=m}else{if(p){f[a>>2]=o;f[c>>2]=k;q=k;r=g;break}f[a>>2]=j;f[d>>2]=k;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=o;r=m;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=o;r=m;break}}f[d>>2]=o;f[c>>2]=k;q=k;r=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{s=g;t=c;u=r;v=q}while(1){q=f[s>>2]|0;r=f[q>>2]|0;c=f[u>>2]|0;g=q;if((r|0)>=(c|0)){if((r|0)==(c|0)?(c=q+4|0,(f[c>>2]|0)<(f[u+4>>2]|0)):0){w=c;x=25}}else{w=q+4|0;x=25}if((x|0)==25){x=0;f[s>>2]=v;a:do if((t|0)==(a|0))y=t;else{q=t;c=t;while(1){k=c;c=q+-4|0;o=f[c>>2]|0;d=f[o>>2]|0;m=o;if((r|0)>=(d|0)){if((r|0)!=(d|0)){y=k;break a}if((f[w>>2]|0)>=(f[o+4>>2]|0)){y=k;break a}}f[k>>2]=m;if((c|0)==(a|0)){y=c;break}else q=c}}while(0);f[y>>2]=g}r=s+4|0;if((r|0)==(b|0))break;c=f[s>>2]|0;q=s;s=r;u=c;v=c;t=q}return}function Qva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=g;k=e;if((h|0)>=(i|0)){if((h|0)!=(i|0)){l=1;return l|0}if((f[e+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;e=f[k>>2]|0;i=f[g>>2]|0;h=k;m=g;if((e|0)>=(i|0))if((e|0)==(i|0))n=(f[k+4>>2]|0)<(f[g+4>>2]|0);else n=0;else n=1;o=f[d>>2]|0;p=f[o>>2]|0;q=o;if((p|0)>=(e|0))if((p|0)==(e|0))r=(f[o+4>>2]|0)<(f[k+4>>2]|0);else r=0;else r=1;if(!n){if(!r){l=1;return l|0}f[j>>2]=q;f[d>>2]=h;n=f[j>>2]|0;k=f[a>>2]|0;o=f[n>>2]|0;e=f[k>>2]|0;p=k;s=n;if((o|0)>=(e|0)){if((o|0)!=(e|0)){l=1;return l|0}if((f[n+4>>2]|0)>=(f[k+4>>2]|0)){l=1;return l|0}}f[a>>2]=s;f[j>>2]=p;l=1;return l|0}if(r){f[a>>2]=q;f[d>>2]=m;l=1;return l|0}f[a>>2]=h;f[j>>2]=m;h=f[d>>2]|0;q=f[h>>2]|0;r=h;if((q|0)>=(i|0)){if((q|0)!=(i|0)){l=1;return l|0}if((f[h+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{Nva(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{Ova(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;j=f[d>>2]|0;g=f[r>>2]|0;h=d;i=r;if((j|0)>=(g|0))if((j|0)==(g|0))t=(f[d+4>>2]|0)<(f[r+4>>2]|0);else t=0;else t=1;q=f[c>>2]|0;p=f[q>>2]|0;s=q;if((p|0)>=(j|0))if((p|0)==(j|0))u=(f[q+4>>2]|0)<(f[d+4>>2]|0);else u=0;else u=1;do if(!t)if(u){f[m>>2]=s;f[c>>2]=h;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=d;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=d;break}}f[a>>2]=s;f[m>>2]=i;v=d}else v=q;else{if(u){f[a>>2]=s;f[c>>2]=i;v=r;break}f[a>>2]=h;f[m>>2]=i;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=q;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=q;break}}f[m>>2]=s;f[c>>2]=i;v=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){w=1;x=0}else{i=r;s=0;m=c;q=v;while(1){g=f[i>>2]|0;p=f[g>>2]|0;h=f[q>>2]|0;u=g;if((p|0)>=(h|0))if((p|0)==(h|0)?(h=g+4|0,(f[h>>2]|0)<(f[q+4>>2]|0)):0){y=h;z=49}else A=s;else{y=g+4|0;z=49}if((z|0)==49){z=0;f[i>>2]=f[m>>2];b:do if((m|0)==(a|0))B=m;else{g=m;h=m;while(1){d=h;h=g+-4|0;t=f[h>>2]|0;j=f[t>>2]|0;k=t;if((p|0)>=(j|0)){if((p|0)!=(j|0)){B=d;break b}if((f[y>>2]|0)>=(f[t+4>>2]|0)){B=d;break b}}f[d>>2]=k;if((h|0)==(a|0)){B=h;break}else g=h}}while(0);f[B>>2]=u;p=s+1|0;if((p|0)==8){w=0;x=(i+4|0)==(b|0);break a}else A=p}p=i+4|0;if((p|0)==(b|0)){w=1;x=0;break a}h=f[i>>2]|0;g=i;i=p;s=A;q=h;m=g}}while(0);l=x|w;return l|0}}return 0}function Rva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0.0;e=u;u=u+192|0;g=e+128|0;h=e+72|0;i=e+56|0;j=e;do if((eS(a)|0)==65536){k=f[a+4>>2]|0;f[g>>2]=f[k>>2];l=g+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=g+8|0;f[n>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=n;n=g+48|0;p=g+44|0;f[p>>2]=n;f[n>>2]=0;f[g+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;U$(g,k);break}}else bS(g,a,-1);while(0);a=k0(g,2,4,1)|0;if((a|0)<=-1){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=$Xc(16)|0;f[h>>2]=k;f[h+8>>2]=-2147483632;f[h+4>>2]=12;q=k;r=354045;s=q+12|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[k+12>>0]=0;vM(-215,h,354058,353899,274)}if((a|0)>=4){do if((eS(c)|0)==65536){k=f[c+4>>2]|0;f[h>>2]=f[k>>2];l=h+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=h+8|0;f[n>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];p=f[k+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=n;n=h+48|0;o=h+44|0;f[o>>2]=n;f[n>>2]=0;f[h+52>>2]=0;if(p|0){n=p+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[o>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;U$(h,k);break}}else bS(h,c,-1);while(0);c=k0(h,1,4,1)|0;if((c|0)<=0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=$Xc(16)|0;f[i>>2]=k;f[i+8>>2]=-2147483632;f[i+4>>2]=11;q=k;r=354075;s=q+11|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[k+11>>0]=0;vM(-215,i,354058,353899,284)}k=f[g+16>>2]|0;l=h+16|0;m=f[l>>2]|0;n=h+44|0;f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;if((c|0)>=3){p=f[m+4>>2]|0;t=f[m>>2]|0;v=f[m+8>>2]|0;w=(((v|0)>(p|0)&1)+((p|0)>(t|0)&1)+((t|0)>(v|0)&1)|0)!=2;v=c+-1|0;p=f[m+((w?0:v)<<2)>>2]|0;if(!((p|0)>-1&(p|0)<(a|0))){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;x=$Xc(32)|0;f[j>>2]=x;f[j+8>>2]=-2147483616;f[j+4>>2]=29;q=x;r=354087;s=q+29|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));b[x+29>>0]=0;vM(-215,j,354058,353899,300)}x=j+4|0;y=j+8|0;z=j+12|0;A=i+8|0;a:do if(w){B=0;C=p;while(1){D=C;C=f[m+(v-B<<2)>>2]|0;if(!((C|0)>-1&(C|0)<(a|0)))break;E=f[k+(D<<3)>>2]|0;F=f[k+(D<<3)+4>>2]|0;G=(f[k+(C<<3)>>2]|0)-E|0;H=+(G|0);I=(f[k+(C<<3)+4>>2]|0)-F|0;J=+(I|0);if(!(I|G))K=0.0;else K=1.0/+M(+(H*H+J*J));G=D+1|0;I=(G|0)<(a|0)?G:0;if((I|0)!=(C|0)){G=0;N=0.0;O=-1;P=I;do{Q=K*+L(+(H*+((f[k+(P<<3)+4>>2]|0)-F|0)-J*+((f[k+(P<<3)>>2]|0)-E|0)));I=Q>N;O=I?P:O;N=I?Q:N;G=G|I;I=P+1|0;P=(I|0)<(a|0)?I:0}while((P|0)!=(C|0));if(G){P=zLc(N*256.0)|0;f[j>>2]=D;f[x>>2]=C;f[y>>2]=O;f[z>>2]=P;P=f[o>>2]|0;if(P>>>0<(f[A>>2]|0)>>>0){f[P>>2]=D;f[P+4>>2]=f[x>>2];f[P+8>>2]=f[y>>2];f[P+12>>2]=f[z>>2];f[o>>2]=P+16}else Sva(i,j)}}B=B+1|0;if((c|0)<=(B|0))break a}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;R=$Xc(32)|0;f[j>>2]=R;S=j+8|0;f[S>>2]=-2147483616;T=j+4|0;f[T>>2]=29;q=R;r=354117;s=q+29|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));U=R+29|0;b[U>>0]=0;vM(-215,j,354058,353899,305)}else{if((t|0)>-1&(t|0)<(a|0)){V=0;W=p;X=t}else{f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;R=$Xc(32)|0;f[j>>2]=R;S=j+8|0;f[S>>2]=-2147483616;T=j+4|0;f[T>>2]=29;q=R;r=354117;s=q+29|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));U=R+29|0;b[U>>0]=0;vM(-215,j,354058,353899,305)}while(1){B=f[k+(W<<3)>>2]|0;C=f[k+(W<<3)+4>>2]|0;P=(f[k+(X<<3)>>2]|0)-B|0;J=+(P|0);E=(f[k+(X<<3)+4>>2]|0)-C|0;H=+(E|0);if(!(E|P))Y=0.0;else Y=1.0/+M(+(J*J+H*H));P=W+1|0;E=(P|0)<(a|0)?P:0;if((E|0)!=(X|0)){P=0;Q=0.0;F=-1;I=E;do{Z=Y*+L(+(J*+((f[k+(I<<3)+4>>2]|0)-C|0)-H*+((f[k+(I<<3)>>2]|0)-B|0)));E=Z>Q;F=E?I:F;Q=E?Z:Q;P=P|E;E=I+1|0;I=(E|0)<(a|0)?E:0}while((I|0)!=(X|0));if(P){I=zLc(Q*256.0)|0;f[j>>2]=W;f[x>>2]=X;f[y>>2]=F;f[z>>2]=I;I=f[o>>2]|0;if(I>>>0<(f[A>>2]|0)>>>0){f[I>>2]=W;f[I+4>>2]=f[x>>2];f[I+8>>2]=f[y>>2];f[I+12>>2]=f[z>>2];f[o>>2]=I+16}else Sva(i,j)}}V=V+1|0;if((c|0)<=(V|0))break a;I=f[m+(V<<2)>>2]|0;if(!((I|0)>-1&(I|0)<(a|0)))break;else{B=X;X=I;W=B}}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;R=$Xc(32)|0;f[j>>2]=R;S=j+8|0;f[S>>2]=-2147483616;T=j+4|0;f[T>>2]=29;q=R;r=354117;s=q+29|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));U=R+29|0;b[U>>0]=0;vM(-215,j,354058,353899,305)}while(0);f[j>>2]=1124024348;U=j+4|0;f[U>>2]=2;R=j+8|0;r=f[o>>2]|0;q=f[i>>2]|0;s=r-q|0;f[R>>2]=s>>4;f[j+12>>2]=1;T=j+16|0;S=j+40|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;f[T+16>>2]=0;f[T+20>>2]=0;f[S>>2]=R;R=j+48|0;W=j+44|0;f[W>>2]=R;f[R>>2]=0;X=j+52|0;f[X>>2]=0;a=q;if((a|0)!=(r|0)){f[X>>2]=16;f[R>>2]=16;f[T>>2]=a;f[j+20>>2]=a;a=q+s|0;f[j+24>>2]=a;f[j+28>>2]=a}jR(j,d);a=j+36|0;s=f[a>>2]|0;if(s|0?(q=s+12|0,s=f[q>>2]|0,f[q>>2]=s+-1,(s|0)==1):0)V$(j);f[a>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[U>>2]|0)>0){T=f[S>>2]|0;S=0;do{f[T+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[U>>2]|0))}U=f[W>>2]|0;if((U|0)!=(R|0))wL(U)}else vS(d);U=f[i>>2]|0;if(U|0){i=f[o>>2]|0;if((i|0)!=(U|0))f[o>>2]=i+(~((i+-16-U|0)>>>4)<<4);cYc(U)}U=h+36|0;i=f[U>>2]|0;if(i|0?(o=i+12|0,i=f[o>>2]|0,f[o>>2]=i+-1,(i|0)==1):0)V$(h);f[U>>2]=0;U=h+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[U>>2]|0)>0){l=f[h+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[U>>2]|0))}U=f[n>>2]|0;if((U|0)!=(h+48|0))wL(U)}else vS(d);d=g+36|0;U=f[d>>2]|0;if(U|0?(h=U+12|0,U=f[h>>2]|0,f[h>>2]=U+-1,(U|0)==1):0)V$(g);f[d>>2]=0;d=g+16|0;U=g+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[U>>2]|0)>0){d=f[g+40>>2]|0;h=0;do{f[d+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[U>>2]|0))}U=f[g+44>>2]|0;if((U|0)==(g+48|0)){u=e;return}wL(U);u=e;return}function Sva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function Tva(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0;c=u;u=u+80|0;d=c+16|0;e=c;do if((eS(a)|0)==65536){g=f[a+4>>2]|0;f[d>>2]=f[g>>2];h=d+4|0;i=g+4|0;f[h>>2]=f[i>>2];j=d+8|0;f[j>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[d+36>>2]=k;f[d+40>>2]=j;j=d+48|0;l=d+44|0;f[l>>2]=j;f[j>>2]=0;f[d+52>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[g+44>>2]|0;j=f[l>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];break}else{f[h>>2]=0;U$(d,g);break}}else bS(d,a,-1);while(0);a=k0(d,2,-1,1)|0;g=f[d>>2]&7;if((a|0)<=-1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;m=$Xc(64)|0;f[e>>2]=m;o=e+8|0;f[o>>2]=-2147483584;p=e+4|0;f[p>>2]=50;q=m;r=353972;t=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));v=m+50|0;b[v>>0]=0;vM(-215,e,354147,353899,392)}h=(g|0)==4;if((g|1|0)!=5){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;m=$Xc(64)|0;f[e>>2]=m;o=e+8|0;f[o>>2]=-2147483584;p=e+4|0;f[p>>2]=50;q=m;r=353972;t=q+50|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));v=m+50|0;b[v>>0]=0;vM(-215,e,354147,353899,392)}a:do if(a){e=f[d+16>>2]|0;if(h){v=((a<<1)+-2|0)%(a|0)|0;m=a+-1|0;r=f[e+(m<<3)>>2]|0;q=f[e+(m<<3)+4>>2]|0;m=r-(f[e+(v<<3)>>2]|0)|0;t=q-(f[e+(v<<3)+4>>2]|0)|0;v=0;p=0;o=r;r=q;while(1){q=o;o=f[e+(p<<3)>>2]|0;g=r;r=f[e+(p<<3)+4>>2]|0;i=m;m=o-q|0;q=t;t=r-g|0;g=Y(m,q)|0;q=Y(t,i)|0;v=((q|0)>(g|0)?1:(q|0)<(g|0)?2:3)|v;p=p+1|0;if((v|0)==3){w=0;break a}if((p|0)>=(a|0)){w=1;break}}}else{p=((a<<1)+-2|0)%(a|0)|0;v=a+-1|0;t=f[e+(v<<3)>>2]|0;m=f[e+(v<<3)+4>>2]|0;x=(f[s>>2]=m,+n[s>>2])-+n[e+(p<<3)+4>>2];y=(f[s>>2]=t,+n[s>>2])-+n[e+(p<<3)>>2];z=x;p=0;v=0;r=t;t=m;while(1){m=r;r=f[e+(v<<3)>>2]|0;o=t;t=f[e+(v<<3)+4>>2]|0;x=(f[s>>2]=r,+n[s>>2]);A=y;y=x-(f[s>>2]=m,+n[s>>2]);x=(f[s>>2]=t,+n[s>>2]);B=z;z=x-(f[s>>2]=o,+n[s>>2]);x=B*y;B=A*z;p=(B>x?1:B<x?2:3)|p;v=v+1|0;if((p|0)==3){w=0;break a}if((v|0)>=(a|0)){w=1;break}}}}else w=0;while(0);a=d+36|0;h=f[a>>2]|0;if(h|0?(v=h+12|0,h=f[v>>2]|0,f[v>>2]=h+-1,(h|0)==1):0)V$(d);f[a>>2]=0;a=d+16|0;h=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[d+40>>2]|0;v=0;do{f[a+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[h>>2]|0))}h=f[d+44>>2]|0;if((h|0)==(d+48|0)){u=c;return w|0}wL(h);u=c;return w|0}function Uva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Vva(a,b,c,d,-1)|0}function Vva(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+144|0;i=h+80|0;j=h+16|0;k=h+24|0;l=h+136|0;m=h;do if((eS(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];o=i+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[i+36>>2]=r;s=i+40|0;f[s>>2]=q;q=i+48|0;t=i+44|0;f[t>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=s;break}else{f[o>>2]=0;U$(i,n);v=s;break}}else{bS(i,a,-1);v=i+40|0}while(0);a=f[v>>2]|0;s=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=s;wS(c,j,e&7,-1,0,0);do if((eS(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];s=k+4|0;a=j+4|0;f[s>>2]=f[a>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=n;n=k+48|0;p=k+44|0;f[p>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[a>>2];f[n+4>>2]=f[a+4>>2];break}else{f[s>>2]=0;U$(k,j);break}}else bS(k,c,-1);while(0);switch(e|0){case 4:case 2:break;default:{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=$Xc(48)|0;f[m>>2]=e;f[m+8>>2]=-2147483600;f[m+4>>2]=37;c=e;j=354163;s=c+37|0;do{b[c>>0]=b[j>>0]|0;c=c+1|0;j=j+1|0}while((c|0)<(s|0));b[e+37>>0]=0;vM(-210,m,354201,354221,4004)}}m=Wva(i,k,d,g,l)|0;l=k+36|0;g=f[l>>2]|0;if(g|0?(d=g+12|0,g=f[d>>2]|0,f[d>>2]=g+-1,(g|0)==1):0)V$(k);f[l>>2]=0;l=k+16|0;g=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[g>>2]|0)>0){l=f[k+40>>2]|0;d=0;do{f[l+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[g>>2]|0))}g=f[k+44>>2]|0;if((g|0)!=(k+48|0))wL(g);g=i+36|0;k=f[g>>2]|0;if(k|0?(d=k+12|0,k=f[d>>2]|0,f[d>>2]=k+-1,(k|0)==1):0)V$(i);f[g>>2]=0;g=i+16|0;k=i+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[k>>2]|0)>0){g=f[v>>2]|0;v=0;do{f[g+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)==(i+48|0)){u=h;return m|0}wL(k);u=h;return m|0}function Wva(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+32|0;i=h;j=h+17|0;k=h+16|0;l=h+15|0;m=h+14|0;n=h+13|0;o=h+12|0;p=f[c>>2]|0;if(p&4088|0){q=$Xc(48)|0;f[i>>2]=q;r=i+8|0;f[r>>2]=-2147483600;s=i+4|0;f[s>>2]=38;t=q;v=354305;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+38|0;b[x>>0]=0;vM(-215,i,354344,354221,3927)}y=f[a>>2]|0;if(y&4088|0){q=$Xc(48)|0;f[i>>2]=q;r=i+8|0;f[r>>2]=-2147483600;s=i+4|0;f[s>>2]=38;t=q;v=354305;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+38|0;b[x>>0]=0;vM(-215,i,354344,354221,3927)}x=(d|0)==8;q=(d|0)==4;switch(d|0){case 4:case 8:break;default:{s=$Xc(48)|0;f[i>>2]=s;f[i+8>>2]=-2147483600;f[i+4>>2]=38;t=s;v=354369;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+38>>0]=0;vM(-215,i,354344,354221,3928)}}s=(e|0)==1;r=(e|0)==0;z=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{e=$Xc(80)|0;f[i>>2]=e;f[i+8>>2]=-2147483568;f[i+4>>2]=67;t=e;v=354408;w=t+67|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[e+67>>0]=0;vM(-215,i,354344,354221,3929)}}e=p&7;A=k3()|0;B=i3()|0;if((y&6|1|0)!=1){y=$Xc(48)|0;f[i>>2]=y;f[i+8>>2]=-2147483600;f[i+4>>2]=34;t=y;v=354476;w=t+34|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[y+34>>0]=0;vM(-215,i,354344,354221,3936)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(e|0)==0;a:do if(q|r){if(!B){switch(p&7){case 2:{D=(Xva(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=Zva(l,a,c,d,g)|0;u=h;return D|0}else{D=Yva(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|x&(s|z)^1)){switch(p&7){case 2:{D=(_va(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=awa(o,a,c,d,g)|0;u=h;return D|0}else{D=$va(n,a,c,d,g)|0;u=h;return D|0}}while(0);D=$Xc(32)|0;f[i>>2]=D;f[i+8>>2]=-2147483616;f[i+4>>2]=28;t=D;v=354511;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[D+28>>0]=0;vM(-210,i,354344,354221,3982);return 0}function Xva(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h=u;u=u+16|0;a=h;i=f[e+8>>2]|0;if((i|0)!=(f[c+8>>2]|0)){k=$Xc(32)|0;f[a>>2]=k;f[a+8>>2]=-2147483616;f[a+4>>2]=26;l=k;m=355005;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+26>>0]=0;vM(-215,a,528391,354221,656)}k=f[e+12>>2]|0;if((k|0)!=(f[c+12>>2]|0)){o=$Xc(32)|0;f[a>>2]=o;f[a+8>>2]=-2147483616;f[a+4>>2]=26;l=o;m=355032;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+26>>0]=0;vM(-215,a,528391,354221,657)}switch(g|0){case 4:case 8:break;default:{o=$Xc(48)|0;f[a>>2]=o;f[a+8>>2]=-2147483600;f[a+4>>2]=38;l=o;m=354369;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[o+38>>0]=0;vM(-215,a,528391,354221,658)}}a=vL((Y(k,i)|0)+3&-2)|0;d[a>>1]=0;o=(i|0)>0;if((g|0)==8){if(!o){p=1;wL(a);u=h;return p|0}g=(k|0)>0;m=k+-1|0;l=f[c+16>>2]|0;n=f[f[c+44>>2]>>2]|0;q=f[e+16>>2]|0;r=f[f[e+44>>2]>>2]|0;s=0-n|0;t=0-r|0;v=1;w=0;while(1){x=l+(Y(n,w)|0)|0;y=x+s|0;z=q+(Y(r,w)|0)|0;A=z+t|0;if(g){B=(w|0)>0;C=0;D=v;while(1){a:do if(!(b[x+C>>0]|0)){d[z+(C<<1)>>1]=0;E=D}else{if(B){if(b[y+C>>0]|0){d[z+(C<<1)>>1]=d[A+(C<<1)>>1]|0;E=D;break}F=(C|0)>0;if((C|0)<(m|0)?(G=C+1|0,b[y+G>>0]|0):0){H=d[A+(G<<1)>>1]|0;do if(F){G=C+-1|0;if(!(b[y+G>>0]|0)){I=C+-1|0;if(!(b[x+I>>0]|0)){J=H;break}K=d[z+(I<<1)>>1]|0;I=K;while(1){L=d[a+((I&65535)<<1)>>1]|0;if((L&65535)<(I&65535))I=L;else break}if(K<<16>>16==H<<16>>16)M=I;else{L=H;while(1){N=d[a+((L&65535)<<1)>>1]|0;if((N&65535)<(L&65535))L=N;else break}N=(I&65535)>(L&65535)?L:I;O=H;do{P=a+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=N}while((O&65535)<(Q&65535));M=N}N=K;do{O=a+((N&65535)<<1)|0;I=N;N=d[O>>1]|0;d[O>>1]=M}while((N&65535)<(I&65535));J=M}else{N=d[A+(G<<1)>>1]|0;K=N;while(1){I=d[a+((K&65535)<<1)>>1]|0;if((I&65535)<(K&65535))K=I;else break}if(N<<16>>16==H<<16>>16)R=K;else{G=H;while(1){I=d[a+((G&65535)<<1)>>1]|0;if((I&65535)<(G&65535))G=I;else break}I=(K&65535)>(G&65535)?G:K;O=H;do{L=a+((O&65535)<<1)|0;Q=O;O=d[L>>1]|0;d[L>>1]=I}while((O&65535)<(Q&65535));R=I}I=N;do{O=a+((I&65535)<<1)|0;K=I;I=d[O>>1]|0;d[O>>1]=R}while((I&65535)<(K&65535));d[z+(C<<1)>>1]=R;E=D;break a}}else J=H;while(0);d[z+(C<<1)>>1]=J;E=D;break}if(F){H=C+-1|0;if(!(b[y+H>>0]|0))S=46;else{d[z+(C<<1)>>1]=d[A+(H<<1)>>1]|0;E=D;break}}}else if((C|0)>0)S=46;if((S|0)==46?(S=0,H=C+-1|0,b[x+H>>0]|0):0){d[z+(C<<1)>>1]=d[z+(H<<1)>>1]|0;E=D;break}d[z+(C<<1)>>1]=D;H=D&65535;d[a+(H<<1)>>1]=D;E=H+1&65535}while(0);C=C+1|0;if((C|0)==(k|0)){T=E;break}else D=E}}else T=v;w=w+1|0;if((w|0)==(i|0)){U=T;break}else v=T}}else{if(!o){p=1;wL(a);u=h;return p|0}T=(k|0)>0;v=f[c+16>>2]|0;w=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;E=f[f[e+44>>2]>>2]|0;S=0-w|0;J=0-E|0;R=0;M=1;while(1){m=v+(Y(w,R)|0)|0;g=m+S|0;t=c+(Y(E,R)|0)|0;r=t+J|0;b:do if(T){if((R|0)>0){V=0;W=M}else{q=0;s=M;while(1){do if(!(b[m+q>>0]|0)){d[t+(q<<1)>>1]=0;X=s}else{if((q|0)>0?(n=q+-1|0,b[m+n>>0]|0):0){d[t+(q<<1)>>1]=d[t+(n<<1)>>1]|0;X=s;break}d[t+(q<<1)>>1]=s;n=s&65535;d[a+(n<<1)>>1]=s;X=n+1&65535}while(0);q=q+1|0;if((q|0)==(k|0)){Z=X;break b}else s=X}}while(1){do if(!(b[m+V>>0]|0)){d[t+(V<<1)>>1]=0;_=W}else{s=(V|0)>0;if(!(b[g+V>>0]|0)){if(s?(q=V+-1|0,b[m+q>>0]|0):0){d[t+(V<<1)>>1]=d[t+(q<<1)>>1]|0;_=W;break}d[t+(V<<1)>>1]=W;q=W&65535;d[a+(q<<1)>>1]=W;_=q+1&65535;break}q=d[r+(V<<1)>>1]|0;if(s?(s=V+-1|0,(b[m+s>>0]|0)!=0):0){F=d[t+(s<<1)>>1]|0;s=F;while(1){n=d[a+((s&65535)<<1)>>1]|0;if((n&65535)<(s&65535))s=n;else break}if(F<<16>>16==q<<16>>16)$=s;else{n=q;while(1){l=d[a+((n&65535)<<1)>>1]|0;if((l&65535)<(n&65535))n=l;else break}l=(s&65535)>(n&65535)?n:s;D=q;do{C=a+((D&65535)<<1)|0;z=D;D=d[C>>1]|0;d[C>>1]=l}while((D&65535)<(z&65535));$=l}l=F;do{D=a+((l&65535)<<1)|0;s=l;l=d[D>>1]|0;d[D>>1]=$}while((l&65535)<(s&65535));aa=$}else aa=q;d[t+(V<<1)>>1]=aa;_=W}while(0);V=V+1|0;if((V|0)==(k|0)){Z=_;break}else W=_}}else Z=M;while(0);R=R+1|0;if((R|0)==(i|0)){U=Z;break}else M=Z}}if((U&65535)>1){Z=U&65535;U=1;M=1;while(1){R=a+(M<<1)|0;_=j[R>>1]|0;if(_>>>0<M>>>0){d[R>>1]=d[a+(_<<1)>>1]|0;ba=U}else{d[R>>1]=U;ba=(U&65535)+1&65535}M=M+1|0;if((M|0)==(Z|0)){ca=ba;break}else U=ba}}else ca=1;if(!o){p=ca;wL(a);u=h;return p|0}o=f[e+16>>2]|0;ba=f[f[e+44>>2]>>2]|0;e=0;do{U=o+(Y(ba,e)|0)|0;Z=U+(k<<1)|0;if((U|0)!=(Z|0)){M=U;do{d[M>>1]=d[a+(j[M>>1]<<1)>>1]|0;M=M+2|0}while((M|0)!=(Z|0))}e=e+1|0}while((e|0)!=(i|0));p=ca;wL(a);u=h;return p|0}function Yva(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;g=u;u=u+16|0;a=g;h=f[d+8>>2]|0;if((h|0)!=(f[c+8>>2]|0)){i=$Xc(32)|0;f[a>>2]=i;f[a+8>>2]=-2147483616;f[a+4>>2]=26;j=i;k=355005;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+26>>0]=0;vM(-215,a,528391,354221,656)}i=f[d+12>>2]|0;if((i|0)!=(f[c+12>>2]|0)){m=$Xc(32)|0;f[a>>2]=m;f[a+8>>2]=-2147483616;f[a+4>>2]=26;j=m;k=355032;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[m+26>>0]=0;vM(-215,a,528391,354221,657)}switch(e|0){case 4:case 8:break;default:{m=$Xc(48)|0;f[a>>2]=m;f[a+8>>2]=-2147483600;f[a+4>>2]=38;j=m;k=354369;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[m+38>>0]=0;vM(-215,a,528391,354221,658)}}a=vL((((Y(i,h)|0)+1|0)>>>1<<2)+4|0)|0;f[a>>2]=0;m=(h|0)>0;if((e|0)==8){if(!m){n=1;wL(a);u=g;return n|0}e=(i|0)>0;k=i+-1|0;j=f[c+16>>2]|0;l=f[c+44>>2]|0;o=f[d+16>>2]|0;p=f[d+44>>2]|0;q=1;r=0;while(1){s=f[l>>2]|0;t=j+(Y(s,r)|0)|0;v=t+(0-s)|0;s=f[p>>2]|0;w=o+(Y(s,r)|0)|0;x=w+(0-s)|0;if(e){s=(r|0)>0;y=0;z=q;while(1){a:do if(!(b[t+y>>0]|0)){f[w+(y<<2)>>2]=0;A=z}else{if(s){if(b[v+y>>0]|0){f[w+(y<<2)>>2]=f[x+(y<<2)>>2];A=z;break}B=(y|0)>0;if((y|0)<(k|0)?(C=y+1|0,b[v+C>>0]|0):0){D=f[x+(C<<2)>>2]|0;do if(B){C=y+-1|0;if(!(b[v+C>>0]|0)){E=y+-1|0;if(!(b[t+E>>0]|0)){F=D;break}G=f[w+(E<<2)>>2]|0;E=G;while(1){H=f[a+(E<<2)>>2]|0;if((H|0)<(E|0))E=H;else break}if((G|0)==(D|0))I=E;else{H=D;while(1){J=f[a+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(E|0)>(H|0)?H:E;K=D;do{L=a+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=J}while((K|0)<(M|0));I=J}J=G;do{K=a+(J<<2)|0;E=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(E|0));F=I}else{J=f[x+(C<<2)>>2]|0;G=J;while(1){E=f[a+(G<<2)>>2]|0;if((E|0)<(G|0))G=E;else break}if((J|0)==(D|0))N=G;else{C=D;while(1){E=f[a+(C<<2)>>2]|0;if((E|0)<(C|0))C=E;else break}E=(G|0)>(C|0)?C:G;K=D;do{H=a+(K<<2)|0;M=K;K=f[H>>2]|0;f[H>>2]=E}while((K|0)<(M|0));N=E}E=J;do{K=a+(E<<2)|0;G=E;E=f[K>>2]|0;f[K>>2]=N}while((E|0)<(G|0));f[w+(y<<2)>>2]=N;A=z;break a}}else F=D;while(0);f[w+(y<<2)>>2]=F;A=z;break}if(B){D=y+-1|0;if(!(b[v+D>>0]|0))O=46;else{f[w+(y<<2)>>2]=f[x+(D<<2)>>2];A=z;break}}}else if((y|0)>0)O=46;if((O|0)==46?(O=0,D=y+-1|0,b[t+D>>0]|0):0){f[w+(y<<2)>>2]=f[w+(D<<2)>>2];A=z;break}f[w+(y<<2)>>2]=z;f[a+(z<<2)>>2]=z;A=z+1|0}while(0);y=y+1|0;if((y|0)==(i|0)){P=A;break}else z=A}}else P=q;r=r+1|0;if((r|0)==(h|0)){Q=P;break}else q=P}}else{if(!m){n=1;wL(a);u=g;return n|0}P=(i|0)>0;q=f[c+16>>2]|0;r=f[c+44>>2]|0;c=f[d+16>>2]|0;A=f[d+44>>2]|0;O=0;F=1;while(1){N=f[r>>2]|0;I=q+(Y(N,O)|0)|0;k=I+(0-N)|0;N=f[A>>2]|0;e=c+(Y(N,O)|0)|0;o=e+(0-N)|0;b:do if(P){if((O|0)>0){R=0;S=F}else{N=0;p=F;while(1){do if(!(b[I+N>>0]|0)){f[e+(N<<2)>>2]=0;T=p}else{if((N|0)>0?(j=N+-1|0,b[I+j>>0]|0):0){f[e+(N<<2)>>2]=f[e+(j<<2)>>2];T=p;break}f[e+(N<<2)>>2]=p;f[a+(p<<2)>>2]=p;T=p+1|0}while(0);N=N+1|0;if((N|0)==(i|0)){U=T;break b}else p=T}}while(1){do if(!(b[I+R>>0]|0)){f[e+(R<<2)>>2]=0;V=S}else{p=(R|0)>0;if(!(b[k+R>>0]|0)){if(p?(N=R+-1|0,b[I+N>>0]|0):0){f[e+(R<<2)>>2]=f[e+(N<<2)>>2];V=S;break}f[e+(R<<2)>>2]=S;f[a+(S<<2)>>2]=S;V=S+1|0;break}N=f[o+(R<<2)>>2]|0;if(p?(p=R+-1|0,(b[I+p>>0]|0)!=0):0){B=f[e+(p<<2)>>2]|0;p=B;while(1){j=f[a+(p<<2)>>2]|0;if((j|0)<(p|0))p=j;else break}if((B|0)==(N|0))W=p;else{j=N;while(1){l=f[a+(j<<2)>>2]|0;if((l|0)<(j|0))j=l;else break}l=(p|0)>(j|0)?j:p;z=N;do{y=a+(z<<2)|0;w=z;z=f[y>>2]|0;f[y>>2]=l}while((z|0)<(w|0));W=l}l=B;do{z=a+(l<<2)|0;p=l;l=f[z>>2]|0;f[z>>2]=W}while((l|0)<(p|0));X=W}else X=N;f[e+(R<<2)>>2]=X;V=S}while(0);R=R+1|0;if((R|0)==(i|0)){U=V;break}else S=V}}else U=F;while(0);O=O+1|0;if((O|0)==(h|0)){Q=U;break}else F=U}}if((Q|0)>1){U=1;F=1;while(1){O=a+(F<<2)|0;V=f[O>>2]|0;if((V|0)<(F|0)){f[O>>2]=f[a+(V<<2)>>2];Z=U}else{f[O>>2]=U;Z=U+1|0}F=F+1|0;if((F|0)==(Q|0)){_=Z;break}else U=Z}}else _=1;if(!m){n=_;wL(a);u=g;return n|0}m=f[d+16>>2]|0;Z=f[d+44>>2]|0;d=0;do{U=m+(Y(f[Z>>2]|0,d)|0)|0;Q=U+(i<<2)|0;if((U|0)!=(Q|0)){F=U;do{f[F>>2]=f[a+(f[F>>2]<<2)>>2];F=F+4|0}while((F|0)!=(Q|0))}d=d+1|0}while((d|0)!=(h|0));n=_;wL(a);u=g;return n|0}function Zva(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+48|0;h=a+28|0;i=a+24|0;j=a;k=f[c+8>>2]|0;l=d+8|0;if((k|0)!=(f[l>>2]|0)){m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=m;o=354540;p=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[m+26>>0]=0;vM(-215,h,528391,354221,578)}m=f[c+12>>2]|0;q=d+12|0;if((m|0)!=(f[q>>2]|0)){r=$Xc(32)|0;f[h>>2]=r;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=r;o=354567;p=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[r+26>>0]=0;vM(-215,h,528391,354221,579)}switch(e|0){case 4:case 8:break;default:{r=$Xc(48)|0;f[h>>2]=r;f[h+8>>2]=-2147483600;f[h+4>>2]=38;n=r;o=354369;p=n+38|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[r+38>>0]=0;vM(-215,h,528391,354221,580)}}r=((Y(m,k)|0)+1|0)>>>1;o=vL(k<<2)|0;n=vL((r<<2)+4|0)|0;f[n>>2]=0;f[h>>2]=0;f[h+4>>2]=k;r=(k|0)/2|0;p=(i3()|0)<<2;s=(p|0)<(r|0)?p:r;t=+(((s|0)>1?s:1)|0);f[i>>2]=1;if((e|0)==8){f[j>>2]=75300;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=n;f[j+16>>2]=o;h3(h,j,t);gwa(d,n,o);if((k|0)>0){e=(m+1|0)/2|0;s=0;do{r=s+1|0;p=(Y((r|0)/2|0,e)|0)+1|0;v=f[o+(r<<2)>>2]|0;r=v+p|0;if((v|0)>0){v=p;do{p=n+(v<<2)|0;w=f[p>>2]|0;if((w|0)<(v|0))f[p>>2]=f[n+(w<<2)>>2];else{f[p>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}v=v+1|0}while((v|0)<(r|0))}s=f[o+(s<<2)>>2]|0}while((s|0)<(k|0))}}else{f[j>>2]=75320;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=n;f[j+16>>2]=o;h3(h,j,t);c=f[q>>2]|0;q=f[l>>2]|0;l=f[o>>2]|0;a:do if((l|0)<(q|0)){s=f[d+16>>2]|0;e=f[d+44>>2]|0;if((c|0)>0)x=l;else{r=l;while(1){r=f[o+(r<<2)>>2]|0;if((r|0)>=(q|0))break a}}do{r=f[e>>2]|0;v=s+(Y(r,x)|0)|0;p=v+(0-r)|0;r=0;do{w=v+(r<<2)|0;y=f[w>>2]|0;if((y|0)>0?(z=f[p+(r<<2)>>2]|0,(z|0)>0):0){A=z;while(1){B=f[n+(A<<2)>>2]|0;if((B|0)<(A|0))A=B;else break}if((z|0)==(y|0))C=A;else{B=y;while(1){D=f[n+(B<<2)>>2]|0;if((D|0)<(B|0))B=D;else break}D=(A|0)>(B|0)?B:A;E=y;do{F=n+(E<<2)|0;G=E;E=f[F>>2]|0;f[F>>2]=D}while((E|0)<(G|0));C=D}D=z;do{E=n+(D<<2)|0;y=D;D=f[E>>2]|0;f[E>>2]=C}while((D|0)<(y|0));f[w>>2]=C}r=r+1|0}while((r|0)!=(c|0));x=f[o+(x<<2)>>2]|0}while((x|0)<(q|0))}while(0);if((k|0)>0){q=0;do{x=(((Y(q,m)|0)+1|0)/2|0)+1|0;c=f[o+(q+1<<2)>>2]|0;C=c+x|0;if((c|0)>0){c=x;do{x=n+(c<<2)|0;l=f[x>>2]|0;if((l|0)<(c|0))f[x>>2]=f[n+(l<<2)>>2];else{f[x>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(C|0))}q=f[o+(q<<2)>>2]|0}while((q|0)<(k|0))}}q=bYc((k|0)>-1?k:-1)|0;f[j>>2]=75340;f[j+4>>2]=d;f[j+8>>2]=n;f[j+12>>2]=g;f[j+16>>2]=q;f[j+20>>2]=i;h3(h,j,t);dYc(q);wL(o);wL(n);u=a;return f[i>>2]|0}function _va(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;h=u;u=u+16|0;a=h;i=f[c+8>>2]|0;k=e+8|0;if((i|0)!=(f[k>>2]|0)){l=$Xc(32)|0;f[a>>2]=l;f[a+8>>2]=-2147483616;f[a+4>>2]=26;m=l;n=354540;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+26>>0]=0;vM(-215,a,528391,354221,2589)}l=f[c+12>>2]|0;p=e+12|0;if((l|0)!=(f[p>>2]|0)){q=$Xc(32)|0;f[a>>2]=q;f[a+8>>2]=-2147483616;f[a+4>>2]=26;m=q;n=354567;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[q+26>>0]=0;vM(-215,a,528391,354221,2590)}if((g|0)!=8){g=$Xc(32)|0;f[a>>2]=g;f[a+8>>2]=-2147483616;f[a+4>>2]=17;m=g;n=354594;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[g+17>>0]=0;vM(-215,a,528391,354221,2591)}a=vL((Y(((i+1|0)/2|0)<<1,(l+1|0)/2|0)|0)+2|0)|0;d[a>>1]=0;if((i|0)>0){g=c+16|0;n=c+44|0;m=e+16|0;o=e+44|0;q=(l|0)>0;r=1;s=0;while(1){t=f[f[n>>2]>>2]|0;v=(f[g>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[o>>2]>>2]|0;z=(f[m>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(i|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(l|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;J=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(J){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;L=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}do if((L|0)>-1){if(!(b[x+L>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}M=d[t+(E<<1)>>1]|0;N=d[z+(L<<1)>>1]|0;O=M;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(M<<16>>16==N<<16>>16)Q=O;else{P=N;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=N;do{T=a+((S&65535)<<1)|0;U=S;S=d[T>>1]|0;d[T>>1]=R}while((S&65535)<(U&65535));Q=R}R=M;do{S=a+((R&65535)<<1)|0;N=R;R=d[S>>1]|0;d[S>>1]=Q}while((R&65535)<(N&65535));d[z+(E<<1)>>1]=Q;K=F;break a}while(0);R=d[t+(E<<1)>>1]|0;M=d[z+(L<<1)>>1]|0;N=R;while(1){S=d[a+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(R<<16>>16==M<<16>>16)V=N;else{L=M;while(1){S=d[a+((L&65535)<<1)>>1]|0;if((S&65535)<(L&65535))L=S;else break}S=(N&65535)>(L&65535)?L:N;O=M;do{P=a+((O&65535)<<1)|0;U=O;O=d[P>>1]|0;d[P>>1]=S}while((O&65535)<(U&65535));V=S}S=R;do{O=a+((S&65535)<<1)|0;M=S;S=d[O>>1]|0;d[O>>1]=V}while((S&65535)<(M&65535));d[z+(E<<1)>>1]=V;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;M=S;while(1){O=d[a+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}if(S<<16>>16==R<<16>>16)W=M;else{O=R;while(1){N=d[a+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(M&65535)>(O&65535)?O:M;L=R;do{U=a+((L&65535)<<1)|0;P=L;L=d[U>>1]|0;d[U>>1]=N}while((L&65535)<(P&65535));W=N}N=S;do{L=a+((N&65535)<<1)|0;R=N;N=d[L>>1]|0;d[L>>1]=W}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=W;K=F;break a}N=E+2|0;if((N|0)>=(l|0))break;if(!(b[x+N>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){S=d[t+(N<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;L=S;while(1){M=d[a+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==R<<16>>16)X=L;else{M=R;while(1){O=d[a+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(L&65535)>(M&65535)?M:L;P=R;do{U=a+((P&65535)<<1)|0;T=P;P=d[U>>1]|0;d[U>>1]=O}while((P&65535)<(T&65535));X=O}O=S;do{P=a+((O&65535)<<1)|0;R=O;O=d[P>>1]|0;d[P>>1]=X}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=X;K=F;break a}O=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}S=d[t+(N<<1)>>1]|0;R=d[z+(O<<1)>>1]|0;P=S;while(1){L=d[a+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(S<<16>>16==R<<16>>16)Z=P;else{L=R;while(1){M=d[a+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}M=(P&65535)>(L&65535)?L:P;T=R;do{U=a+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(_&65535));Z=M}M=S;do{T=a+((M&65535)<<1)|0;R=M;M=d[T>>1]|0;d[T>>1]=Z}while((M&65535)<(R&65535));d[z+(E<<1)>>1]=Z;K=F;break a}while(0);M=d[t+(N<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;R=M;while(1){T=d[a+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(M<<16>>16==S<<16>>16)$=R;else{O=S;while(1){T=d[a+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}T=(R&65535)>(O&65535)?O:R;P=S;do{L=a+((P&65535)<<1)|0;_=P;P=d[L>>1]|0;d[L>>1]=T}while((P&65535)<(_&65535));$=T}T=M;do{P=a+((T&65535)<<1)|0;S=T;T=d[P>>1]|0;d[P>>1]=$}while((T&65535)<(S&65535));d[z+(E<<1)>>1]=$;K=F;break a}while(0);T=d[t+(N<<1)>>1]|0;M=d[z+(E+-2<<1)>>1]|0;S=T;while(1){P=d[a+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(T<<16>>16==M<<16>>16)aa=S;else{N=M;while(1){P=d[a+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(S&65535)>(N&65535)?N:S;R=M;do{O=a+((R&65535)<<1)|0;_=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(_&65535));aa=P}P=T;do{R=a+((P&65535)<<1)|0;M=P;P=d[R>>1]|0;d[R>>1]=aa}while((P&65535)<(M&65535));d[z+(E<<1)>>1]=aa;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){P=E+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=T;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;R=M;while(1){S=d[a+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(M<<16>>16==T<<16>>16)ba=R;else{S=T;while(1){N=d[a+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}N=(R&65535)>(S&65535)?S:R;_=T;do{O=a+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=N}while((_&65535)<(L&65535));ba=N}N=M;do{_=a+((N&65535)<<1)|0;T=N;N=d[_>>1]|0;d[_>>1]=ba}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=ba;K=F;break a}if(!(b[x+P>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(P<<1)>>1]|0;T=N;while(1){_=d[a+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(N<<16>>16==M<<16>>16)ca=T;else{_=M;while(1){R=d[a+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(T&65535)>(_&65535)?_:T;S=M;do{L=a+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=R}while((S&65535)<(O&65535));ca=R}R=N;do{S=a+((R&65535)<<1)|0;M=R;R=d[S>>1]|0;d[S>>1]=ca}while((R&65535)<(M&65535));d[z+(E<<1)>>1]=ca;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;R=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){S=d[a+((M&65535)<<1)>>1]|0;if((S&65535)<(M&65535))M=S;else break}if(N<<16>>16==R<<16>>16)da=M;else{S=R;while(1){T=d[a+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}T=(M&65535)>(S&65535)?S:M;_=R;do{O=a+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=T}while((_&65535)<(L&65535));da=T}T=N;do{_=a+((T&65535)<<1)|0;R=T;T=d[_>>1]|0;d[_>>1]=da}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=da;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=T;while(1){_=d[a+((R&65535)<<1)>>1]|0;if((_&65535)<(R&65535))R=_;else break}if(T<<16>>16==N<<16>>16)ea=R;else{_=N;while(1){M=d[a+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(R&65535)>(_&65535)?_:R;S=N;do{L=a+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=M}while((S&65535)<(O&65535));ea=M}M=T;do{S=a+((M&65535)<<1)|0;N=M;M=d[S>>1]|0;d[S>>1]=ea}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=ea;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;T=d[z+(P<<1)>>1]|0;N=M;while(1){S=d[a+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(M<<16>>16==T<<16>>16)fa=N;else{P=T;while(1){S=d[a+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(N&65535)>(P&65535)?P:N;R=T;do{_=a+((R&65535)<<1)|0;O=R;R=d[_>>1]|0;d[_>>1]=S}while((R&65535)<(O&65535));fa=S}S=M;do{R=a+((S&65535)<<1)|0;T=S;S=d[R>>1]|0;d[R>>1]=fa}while((S&65535)<(T&65535));d[z+(E<<1)>>1]=fa;K=F;break a}S=E+2|0;do if(!((S|0)>=(l|0)|C)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}R=d[t+(S<<1)>>1]|0;N=R;while(1){P=d[a+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}if(R<<16>>16==T<<16>>16)ga=N;else{P=T;while(1){O=d[a+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(N&65535)>(P&65535)?P:N;_=T;do{L=a+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=O}while((_&65535)<(U&65535));ga=O}O=R;do{_=a+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=ga}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=ga;K=F;break a}if(!(b[x+M>>0]|0)){O=d[t+(S<<1)>>1]|0;R=d[z+(M<<1)>>1]|0;T=O;while(1){_=d[a+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(O<<16>>16==R<<16>>16)ha=T;else{_=R;while(1){N=d[a+((_&65535)<<1)>>1]|0;if((N&65535)<(_&65535))_=N;else break}N=(T&65535)>(_&65535)?_:T;P=R;do{U=a+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=N}while((P&65535)<(L&65535));ha=N}N=O;do{P=a+((N&65535)<<1)|0;R=N;N=d[P>>1]|0;d[P>>1]=ha}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=ha;K=F;break a}if(!(b[y+I>>0]|0)){N=d[t+(S<<1)>>1]|0;O=d[z+(M<<1)>>1]|0;R=N;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(N<<16>>16==O<<16>>16)ia=R;else{P=O;while(1){T=d[a+((P&65535)<<1)>>1]|0;if((T&65535)<(P&65535))P=T;else break}T=(R&65535)>(P&65535)?P:R;_=O;do{L=a+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=T}while((_&65535)<(U&65535));ia=T}T=N;do{_=a+((T&65535)<<1)|0;O=T;T=d[_>>1]|0;d[_>>1]=ia}while((T&65535)<(O&65535));d[z+(E<<1)>>1]=ia;K=F;break a}T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}N=d[t+(S<<1)>>1]|0;O=N;while(1){_=d[a+((O&65535)<<1)>>1]|0;if((_&65535)<(O&65535))O=_;else break}if(N<<16>>16==T<<16>>16)ja=O;else{_=T;while(1){R=d[a+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(O&65535)>(_&65535)?_:O;P=T;do{U=a+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=R}while((P&65535)<(L&65535));ja=R}R=N;do{P=a+((R&65535)<<1)|0;T=R;R=d[P>>1]|0;d[P>>1]=ja}while((R&65535)<(T&65535));d[z+(E<<1)>>1]=ja;K=F;break a}while(0);R=d[t+(S<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;T=R;while(1){P=d[a+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}if(R<<16>>16==N<<16>>16)ka=T;else{M=N;while(1){P=d[a+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(T&65535)>(M&65535)?M:T;O=N;do{_=a+((O&65535)<<1)|0;L=O;O=d[_>>1]|0;d[_>>1]=P}while((O&65535)<(L&65535));ka=P}P=R;do{O=a+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=ka}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=ka;K=F;break a}while(0);P=E+-2|0;if(!(b[x+E>>0]|0)){R=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;O=R;while(1){T=d[a+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}if(R<<16>>16==N<<16>>16)la=O;else{T=N;while(1){M=d[a+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(O&65535)>(T&65535)?T:O;L=N;do{_=a+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=M}while((L&65535)<(U&65535));la=M}M=R;do{L=a+((M&65535)<<1)|0;N=M;M=d[L>>1]|0;d[L>>1]=la}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=la;K=F;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){M=d[t+(S<<1)>>1]|0;R=d[z+(P<<1)>>1]|0;N=M;while(1){L=d[a+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}if(M<<16>>16==R<<16>>16)ma=N;else{L=R;while(1){O=d[a+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(N&65535)>(L&65535)?L:N;T=R;do{U=a+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=O}while((T&65535)<(_&65535));ma=O}O=M;do{T=a+((O&65535)<<1)|0;R=O;O=d[T>>1]|0;d[T>>1]=ma}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ma;K=F;break a}if(!(b[x+P>>0]|0)){O=d[t+(E<<1)>>1]|0;M=d[t+(S<<1)>>1]|0;R=O;while(1){T=d[a+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(O<<16>>16==M<<16>>16)na=R;else{T=M;while(1){N=d[a+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(R&65535)>(T&65535)?T:R;L=M;do{_=a+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=N}while((L&65535)<(U&65535));na=N}N=O;do{L=a+((N&65535)<<1)|0;M=N;N=d[L>>1]|0;d[L>>1]=na}while((N&65535)<(M&65535));N=d[z+(P<<1)>>1]|0;O=na;while(1){M=d[a+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}if(na<<16>>16==N<<16>>16)oa=O;else{M=N;while(1){L=d[a+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(O&65535)>(M&65535)?M:O;R=N;do{T=a+((R&65535)<<1)|0;U=R;R=d[T>>1]|0;d[T>>1]=L}while((R&65535)<(U&65535));oa=L}L=na;do{R=a+((L&65535)<<1)|0;N=L;L=d[R>>1]|0;d[R>>1]=oa}while((L&65535)<(N&65535));d[z+(E<<1)>>1]=oa;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;L=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=L;while(1){O=d[a+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(L<<16>>16==N<<16>>16)pa=R;else{O=N;while(1){M=d[a+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}M=(R&65535)>(O&65535)?O:R;U=N;do{T=a+((U&65535)<<1)|0;_=U;U=d[T>>1]|0;d[T>>1]=M}while((U&65535)<(_&65535));pa=M}M=L;do{U=a+((M&65535)<<1)|0;N=M;M=d[U>>1]|0;d[U>>1]=pa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=pa;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=d[t+(S<<1)>>1]|0;N=M;while(1){U=d[a+((N&65535)<<1)>>1]|0;if((U&65535)<(N&65535))N=U;else break}if(M<<16>>16==L<<16>>16)qa=N;else{U=L;while(1){R=d[a+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}R=(N&65535)>(U&65535)?U:N;O=L;do{_=a+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=R}while((O&65535)<(T&65535));qa=R}R=M;do{O=a+((R&65535)<<1)|0;L=R;R=d[O>>1]|0;d[O>>1]=qa}while((R&65535)<(L&65535));R=d[z+(P<<1)>>1]|0;M=qa;while(1){L=d[a+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}if(qa<<16>>16==R<<16>>16)ra=M;else{L=R;while(1){O=d[a+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(M&65535)>(L&65535)?L:M;N=R;do{U=a+((N&65535)<<1)|0;T=N;N=d[U>>1]|0;d[U>>1]=O}while((N&65535)<(T&65535));ra=O}O=qa;do{N=a+((O&65535)<<1)|0;R=O;O=d[N>>1]|0;d[N>>1]=ra}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ra;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;R=d[t+(S<<1)>>1]|0;N=O;while(1){M=d[a+((N&65535)<<1)>>1]|0;if((M&65535)<(N&65535))N=M;else break}if(O<<16>>16==R<<16>>16)sa=N;else{M=R;while(1){L=d[a+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(N&65535)>(M&65535)?M:N;T=R;do{U=a+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(_&65535));sa=L}L=O;do{T=a+((L&65535)<<1)|0;R=L;L=d[T>>1]|0;d[T>>1]=sa}while((L&65535)<(R&65535));L=d[z+(P<<1)>>1]|0;O=sa;while(1){R=d[a+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}if(sa<<16>>16==L<<16>>16)ta=O;else{P=L;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;T=L;do{N=a+((T&65535)<<1)|0;M=T;T=d[N>>1]|0;d[N>>1]=R}while((T&65535)<(M&65535));ta=R}R=sa;do{T=a+((R&65535)<<1)|0;L=R;R=d[T>>1]|0;d[T>>1]=ta}while((R&65535)<(L&65535));d[z+(E<<1)>>1]=ta;K=F;break a}while(0);S=E+-2|0;if(!(b[x+E>>0]|0)){ua=S;break}do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}if(!(b[x+S>>0]|0)){R=d[t+(E<<1)>>1]|0;L=d[z+(S<<1)>>1]|0;T=R;while(1){O=d[a+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(R<<16>>16==L<<16>>16)va=T;else{O=L;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(T&65535)>(O&65535)?O:T;M=L;do{N=a+((M&65535)<<1)|0;_=M;M=d[N>>1]|0;d[N>>1]=P}while((M&65535)<(_&65535));va=P}P=R;do{M=a+((P&65535)<<1)|0;L=P;P=d[M>>1]|0;d[M>>1]=va}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=va;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;R=d[z+(S<<1)>>1]|0;L=P;while(1){M=d[a+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(P<<16>>16==R<<16>>16)wa=L;else{M=R;while(1){T=d[a+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}T=(L&65535)>(M&65535)?M:L;O=R;do{_=a+((O&65535)<<1)|0;N=O;O=d[_>>1]|0;d[_>>1]=T}while((O&65535)<(N&65535));wa=T}T=P;do{O=a+((T&65535)<<1)|0;R=T;T=d[O>>1]|0;d[O>>1]=wa}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=wa;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[z+(S<<1)>>1]|0;R=T;while(1){O=d[a+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(T<<16>>16==P<<16>>16)xa=R;else{S=P;while(1){O=d[a+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}O=(R&65535)>(S&65535)?S:R;L=P;do{M=a+((L&65535)<<1)|0;N=L;L=d[M>>1]|0;d[M>>1]=O}while((L&65535)<(N&65535));xa=O}O=T;do{L=a+((O&65535)<<1)|0;P=O;O=d[L>>1]|0;d[L>>1]=xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=xa;K=F;break a}else ua=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ua<<1)>>1]|0;K=F;break a}while(0);do if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(l|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[t+(O<<1)>>1]|0;L=T;while(1){R=d[a+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(T<<16>>16==P<<16>>16)ya=L;else{R=P;while(1){S=d[a+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(L&65535)>(R&65535)?R:L;N=P;do{M=a+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=S}while((N&65535)<(_&65535));ya=S}S=T;do{N=a+((S&65535)<<1)|0;P=S;S=d[N>>1]|0;d[N>>1]=ya}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=ya;K=F;break a}while(0);if(!(b[x+E>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break}if(J){if(b[w+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(b[v+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}}d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break a}if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(l|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;T=d[t+(O<<1)>>1]|0;P=S;while(1){N=d[a+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(S<<16>>16==T<<16>>16)za=P;else{N=T;while(1){L=d[a+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}L=(P&65535)>(N&65535)?N:P;R=T;do{_=a+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=L}while((R&65535)<(M&65535));za=L}L=S;do{R=a+((L&65535)<<1)|0;T=L;L=d[R>>1]|0;d[R>>1]=za}while((L&65535)<(T&65535));d[z+(E<<1)>>1]=za;K=F;break a}while(0);if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}}d[z+(E<<1)>>1]=F;O=F&65535;d[a+(O<<1)>>1]=F;K=O+1&65535;break a}while(0);d[z+(E<<1)>>1]=0;K=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;J=(I|0)<(l|0);if(B&J?b[x+I>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}L=d[t+(E<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;T=L;while(1){R=d[a+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(L<<16>>16==S<<16>>16)Aa=T;else{R=S;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=S;do{M=a+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=P}while((N&65535)<(_&65535));Aa=P}P=L;do{N=a+((P&65535)<<1)|0;S=P;P=d[N>>1]|0;d[N>>1]=Aa}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=Aa;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;L=d[z+(O<<1)>>1]|0;S=P;while(1){N=d[a+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}if(P<<16>>16==L<<16>>16)Ba=S;else{O=L;while(1){N=d[a+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(S&65535)>(O&65535)?O:S;T=L;do{R=a+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));Ba=N}N=P;do{T=a+((N&65535)<<1)|0;L=N;N=d[T>>1]|0;d[T>>1]=Ba}while((N&65535)<(L&65535));d[z+(E<<1)>>1]=Ba;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;L=N;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(N<<16>>16==P<<16>>16)Ca=L;else{T=P;while(1){S=d[a+((T&65535)<<1)>>1]|0;if((S&65535)<(T&65535))T=S;else break}S=(L&65535)>(T&65535)?T:L;O=P;do{_=a+((O&65535)<<1)|0;R=O;O=d[_>>1]|0;d[_>>1]=S}while((O&65535)<(R&65535));Ca=S}S=N;do{O=a+((S&65535)<<1)|0;P=S;S=d[O>>1]|0;d[O>>1]=Ca}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=Ca;K=F;break}if(J?b[v+I>>0]|0:0){S=E+2|0;do if(B&(S|0)<(l|0)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){N=d[t+(S<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;O=N;while(1){L=d[a+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}if(N<<16>>16==P<<16>>16)Da=O;else{L=P;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}T=(O&65535)>(L&65535)?L:O;R=P;do{_=a+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=T}while((R&65535)<(M&65535));Da=T}T=N;do{R=a+((T&65535)<<1)|0;P=T;T=d[R>>1]|0;d[R>>1]=Da}while((T&65535)<(P&65535));d[z+(E<<1)>>1]=Da;K=F;break a}T=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}do if((T|0)>-1){if(!(b[x+T>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}N=d[t+(S<<1)>>1]|0;P=d[z+(T<<1)>>1]|0;R=N;while(1){O=d[a+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(N<<16>>16==P<<16>>16)Ea=R;else{O=P;while(1){L=d[a+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}L=(R&65535)>(O&65535)?O:R;M=P;do{_=a+((M&65535)<<1)|0;U=M;M=d[_>>1]|0;d[_>>1]=L}while((M&65535)<(U&65535));Ea=L}L=N;do{M=a+((L&65535)<<1)|0;P=L;L=d[M>>1]|0;d[M>>1]=Ea}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=Ea;K=F;break a}while(0);L=d[t+(S<<1)>>1]|0;N=d[z+(T<<1)>>1]|0;P=L;while(1){M=d[a+((P&65535)<<1)>>1]|0;if((M&65535)<(P&65535))P=M;else break}if(L<<16>>16==N<<16>>16)Fa=P;else{T=N;while(1){M=d[a+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(P&65535)>(T&65535)?T:P;R=N;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=M}while((R&65535)<(U&65535));Fa=M}M=L;do{R=a+((M&65535)<<1)|0;N=M;M=d[R>>1]|0;d[R>>1]=Fa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Fa;K=F;break a}while(0);M=d[t+(S<<1)>>1]|0;L=d[z+(E+-2<<1)>>1]|0;N=M;while(1){R=d[a+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(M<<16>>16==L<<16>>16)Ga=N;else{R=L;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(N&65535)>(R&65535)?R:N;T=L;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=P}while((T&65535)<(O&65535));Ga=P}P=M;do{T=a+((P&65535)<<1)|0;L=P;P=d[T>>1]|0;d[T>>1]=Ga}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ga;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(A?b[w+G>>0]|0:0){S=E|1;I=(S|0)<(l|0);if(!(C|I^1)?b[x+S>>0]|0:0){J=E+-2|0;do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[x+G>>0]|0){P=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=P;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=M;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(M<<16>>16==P<<16>>16)Ha=L;else{T=P;while(1){N=d[a+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(L&65535)>(T&65535)?T:L;R=P;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=N}while((R&65535)<(U&65535));Ha=N}N=M;do{R=a+((N&65535)<<1)|0;P=N;N=d[R>>1]|0;d[R>>1]=Ha}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ha;K=F;break a}if(!(b[x+J>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(J<<1)>>1]|0;P=N;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(N<<16>>16==M<<16>>16)Ia=P;else{R=M;while(1){L=d[a+((R&65535)<<1)>>1]|0;if((L&65535)<(R&65535))R=L;else break}L=(P&65535)>(R&65535)?R:P;T=M;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(O&65535));Ia=L}L=N;do{T=a+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Ia}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Ia;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;L=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){T=d[a+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(N<<16>>16==L<<16>>16)Ja=M;else{T=L;while(1){P=d[a+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=L;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Ja=P}P=N;do{R=a+((P&65535)<<1)|0;L=P;P=d[R>>1]|0;d[R>>1]=Ja}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ja;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;N=d[z+(J<<1)>>1]|0;L=P;while(1){R=d[a+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(P<<16>>16==N<<16>>16)Ka=L;else{R=N;while(1){M=d[a+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(L&65535)>(R&65535)?R:L;T=N;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Ka=M}M=P;do{T=a+((M&65535)<<1)|0;N=M;M=d[T>>1]|0;d[T>>1]=Ka}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Ka;K=F;break a}while(0);if(b[x+E>>0]|0){M=d[t+(E<<1)>>1]|0;P=d[z+(J<<1)>>1]|0;N=M;while(1){T=d[a+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(M<<16>>16==P<<16>>16)La=N;else{T=P;while(1){L=d[a+((T&65535)<<1)>>1]|0;if((L&65535)<(T&65535))T=L;else break}L=(N&65535)>(T&65535)?T:N;R=P;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=L}while((R&65535)<(U&65535));La=L}L=M;do{R=a+((L&65535)<<1)|0;P=L;L=d[R>>1]|0;d[R>>1]=La}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=La;K=F;break}L=d[t+(E<<1)>>1]|0;if(!(b[x+G>>0]|0)){M=d[z+(J<<1)>>1]|0;P=L;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(L<<16>>16==M<<16>>16)Ma=P;else{R=M;while(1){N=d[a+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(P&65535)>(R&65535)?R:P;T=M;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=N}while((T&65535)<(O&65535));Ma=N}N=L;do{T=a+((N&65535)<<1)|0;M=N;N=d[T>>1]|0;d[T>>1]=Ma}while((N&65535)<(M&65535));d[z+(E<<1)>>1]=Ma;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;N=d[z+(J<<1)>>1]|0;M=L;while(1){T=d[a+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(L<<16>>16==N<<16>>16)Na=M;else{T=N;while(1){P=d[a+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=N;do{O=a+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Na=P}P=L;do{R=a+((P&65535)<<1)|0;N=P;P=d[R>>1]|0;d[R>>1]=Na}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=Na;K=F;break a}while(0);P=d[t+(J<<1)>>1]|0;N=P;while(1){R=d[a+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(P<<16>>16==L<<16>>16)Oa=N;else{R=L;while(1){M=d[a+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(N&65535)>(R&65535)?R:N;T=L;do{U=a+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Oa=M}M=P;do{T=a+((M&65535)<<1)|0;L=M;M=d[T>>1]|0;d[T>>1]=Oa}while((M&65535)<(L&65535));M=d[z+(J<<1)>>1]|0;P=Oa;while(1){L=d[a+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(Oa<<16>>16==M<<16>>16)Pa=P;else{J=M;while(1){L=d[a+((J&65535)<<1)>>1]|0;if((L&65535)<(J&65535))J=L;else break}L=(P&65535)>(J&65535)?J:P;T=M;do{N=a+((T&65535)<<1)|0;R=T;T=d[N>>1]|0;d[N>>1]=L}while((T&65535)<(R&65535));Pa=L}L=Oa;do{T=a+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Pa}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Pa;K=F;break}if(I?b[v+S>>0]|0:0){L=E+2|0;do if(!((L|0)>=(l|0)|C)){if(!(b[x+L>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}P=d[t+(L<<1)>>1]|0;J=P;while(1){R=d[a+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(P<<16>>16==T<<16>>16)Qa=J;else{R=T;while(1){N=d[a+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=T;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Qa=N}N=P;do{O=a+((N&65535)<<1)|0;T=N;N=d[O>>1]|0;d[O>>1]=Qa}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=Qa;K=F;break a}while(0);N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[a+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)Ra=T;else{O=P;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;R=P;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Ra=J}J=N;do{R=a+((J&65535)<<1)|0;P=J;J=d[R>>1]|0;d[R>>1]=Ra}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=Ra;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;if(!(b[x+M>>0]|0)){J=d[t+(L<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;P=J;while(1){R=d[a+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(J<<16>>16==N<<16>>16)Sa=P;else{R=N;while(1){T=d[a+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}T=(P&65535)>(R&65535)?R:P;O=N;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(_&65535));Sa=T}T=J;do{O=a+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=Sa}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=Sa;K=F;break a}if(!(b[y+G>>0]|0)){T=d[t+(L<<1)>>1]|0;J=d[z+(M<<1)>>1]|0;N=T;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)Ta=N;else{O=J;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;R=J;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=P}while((R&65535)<(U&65535));Ta=P}P=T;do{R=a+((P&65535)<<1)|0;J=P;P=d[R>>1]|0;d[R>>1]=Ta}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=Ta;K=F;break a}P=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}T=d[t+(L<<1)>>1]|0;J=T;while(1){R=d[a+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(T<<16>>16==P<<16>>16)Ua=J;else{R=P;while(1){N=d[a+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=P;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Ua=N}N=T;do{O=a+((N&65535)<<1)|0;P=N;N=d[O>>1]|0;d[O>>1]=Ua}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ua;K=F;break a}while(0);if(!(b[x+E>>0]|0)){N=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=N;while(1){O=d[a+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(N<<16>>16==T<<16>>16)Va=P;else{O=T;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(P&65535)>(O&65535)?O:P;R=T;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Va=J}J=N;do{R=a+((J&65535)<<1)|0;T=J;J=d[R>>1]|0;d[R>>1]=Va}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=Va;K=F;break a}if(!(b[x+M>>0]|0)){J=d[t+(E<<1)>>1]|0;N=d[t+(L<<1)>>1]|0;T=J;while(1){R=d[a+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(J<<16>>16==N<<16>>16)Wa=T;else{R=N;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;O=N;do{U=a+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=P}while((O&65535)<(_&65535));Wa=P}P=J;do{O=a+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=Wa}while((P&65535)<(N&65535));P=d[z+(M<<1)>>1]|0;J=Wa;while(1){N=d[a+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}if(Wa<<16>>16==P<<16>>16)Xa=J;else{N=P;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(J&65535)>(N&65535)?N:J;T=P;do{R=a+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=O}while((T&65535)<(_&65535));Xa=O}O=Wa;do{T=a+((O&65535)<<1)|0;P=O;O=d[T>>1]|0;d[T>>1]=Xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=Xa;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;O=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=O;while(1){J=d[a+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(O<<16>>16==P<<16>>16)Ya=T;else{J=P;while(1){N=d[a+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(T&65535)>(J&65535)?J:T;_=P;do{R=a+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=N}while((_&65535)<(U&65535));Ya=N}N=O;do{_=a+((N&65535)<<1)|0;P=N;N=d[_>>1]|0;d[_>>1]=Ya}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ya;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;O=d[t+(L<<1)>>1]|0;P=N;while(1){_=d[a+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(N<<16>>16==O<<16>>16)Za=P;else{_=O;while(1){T=d[a+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;J=O;do{U=a+((J&65535)<<1)|0;R=J;J=d[U>>1]|0;d[U>>1]=T}while((J&65535)<(R&65535));Za=T}T=N;do{J=a+((T&65535)<<1)|0;O=T;T=d[J>>1]|0;d[J>>1]=Za}while((T&65535)<(O&65535));T=d[z+(M<<1)>>1]|0;N=Za;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(Za<<16>>16==T<<16>>16)_a=N;else{O=T;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(N&65535)>(O&65535)?O:N;P=T;do{_=a+((P&65535)<<1)|0;R=P;P=d[_>>1]|0;d[_>>1]=J}while((P&65535)<(R&65535));_a=J}J=Za;do{P=a+((J&65535)<<1)|0;T=J;J=d[P>>1]|0;d[P>>1]=_a}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=_a;K=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=J;while(1){N=d[a+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(J<<16>>16==T<<16>>16)$a=P;else{N=T;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(P&65535)>(N&65535)?N:P;R=T;do{_=a+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=O}while((R&65535)<(U&65535));$a=O}O=J;do{R=a+((O&65535)<<1)|0;T=O;O=d[R>>1]|0;d[R>>1]=$a}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=$a;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;J=d[t+(L<<1)>>1]|0;T=O;while(1){R=d[a+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(O<<16>>16==J<<16>>16)ab=T;else{R=J;while(1){P=d[a+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=J;do{U=a+((N&65535)<<1)|0;_=N;N=d[U>>1]|0;d[U>>1]=P}while((N&65535)<(_&65535));ab=P}P=O;do{N=a+((P&65535)<<1)|0;J=P;P=d[N>>1]|0;d[N>>1]=ab}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;O=ab;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}if(ab<<16>>16==P<<16>>16)bb=O;else{J=P;while(1){N=d[a+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(O&65535)>(J&65535)?J:O;T=P;do{R=a+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));bb=N}N=ab;do{T=a+((N&65535)<<1)|0;P=N;N=d[T>>1]|0;d[T>>1]=bb}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=bb;K=F;break a}if(!(b[x+G>>0]|0)){N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[a+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)cb=T;else{O=P;while(1){J=d[a+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;_=P;do{R=a+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=J}while((_&65535)<(U&65535));cb=J}J=N;do{_=a+((J&65535)<<1)|0;P=J;J=d[_>>1]|0;d[_>>1]=cb}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=cb;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;if(b[y+E>>0]|0){N=d[z+(M<<1)>>1]|0;P=J;while(1){_=d[a+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(J<<16>>16==N<<16>>16)db=P;else{_=N;while(1){T=d[a+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;O=N;do{U=a+((O&65535)<<1)|0;R=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(R&65535));db=T}T=J;do{O=a+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=db}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=db;K=F;break a}T=d[t+(M<<1)>>1]|0;N=T;while(1){O=d[a+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)eb=N;else{O=J;while(1){P=d[a+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;_=J;do{R=a+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=P}while((_&65535)<(U&65535));eb=P}P=T;do{_=a+((P&65535)<<1)|0;J=P;P=d[_>>1]|0;d[_>>1]=eb}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;T=eb;while(1){J=d[a+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(eb<<16>>16==P<<16>>16)fb=T;else{J=P;while(1){_=d[a+((J&65535)<<1)>>1]|0;if((_&65535)<(J&65535))J=_;else break}_=(T&65535)>(J&65535)?J:T;N=P;do{O=a+((N&65535)<<1)|0;U=N;N=d[O>>1]|0;d[O>>1]=_}while((N&65535)<(U&65535));fb=_}_=eb;do{N=a+((_&65535)<<1)|0;P=_;_=d[N>>1]|0;d[N>>1]=fb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=fb;K=F;break a}while(0);_=d[t+(M<<1)>>1]|0;P=d[t+(L<<1)>>1]|0;N=_;while(1){T=d[a+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(_<<16>>16==P<<16>>16)gb=N;else{T=P;while(1){J=d[a+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}J=(N&65535)>(T&65535)?T:N;U=P;do{O=a+((U&65535)<<1)|0;R=U;U=d[O>>1]|0;d[O>>1]=J}while((U&65535)<(R&65535));gb=J}J=_;do{U=a+((J&65535)<<1)|0;P=J;J=d[U>>1]|0;d[U>>1]=gb}while((J&65535)<(P&65535));J=d[z+(M<<1)>>1]|0;_=gb;while(1){P=d[a+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}if(gb<<16>>16==J<<16>>16)hb=_;else{M=J;while(1){P=d[a+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(_&65535)>(M&65535)?M:_;U=J;do{N=a+((U&65535)<<1)|0;T=U;U=d[N>>1]|0;d[N>>1]=P}while((U&65535)<(T&65535));hb=P}P=gb;do{U=a+((P&65535)<<1)|0;J=P;P=d[U>>1]|0;d[U>>1]=hb}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=hb;K=F;break a}while(0);do if(B){L=E+-2|0;if(b[x+G>>0]|0){S=d[z+(L<<1)>>1]|0;do if((L|0)>-1){if(!(b[v+L>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);I=d[t+(L<<1)>>1]|0;P=I;while(1){J=d[a+((P&65535)<<1)>>1]|0;if((J&65535)<(P&65535))P=J;else break}if(I<<16>>16==S<<16>>16)ib=P;else{J=S;while(1){U=d[a+((J&65535)<<1)>>1]|0;if((U&65535)<(J&65535))J=U;else break}U=(P&65535)>(J&65535)?J:P;_=S;do{M=a+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=U}while((_&65535)<(T&65535));ib=U}U=I;do{_=a+((U&65535)<<1)|0;S=U;U=d[_>>1]|0;d[_>>1]=ib}while((U&65535)<(S&65535));d[z+(E<<1)>>1]=ib;K=F;break a}if(!(b[x+E>>0]|0)){jb=L;break}do if((L|0)>-1){if(!(b[v+L>>0]|0))break;if(!(b[x+L>>0]|0)){U=d[t+(E<<1)>>1]|0;I=d[z+(L<<1)>>1]|0;S=U;while(1){_=d[a+((S&65535)<<1)>>1]|0;if((_&65535)<(S&65535))S=_;else break}if(U<<16>>16==I<<16>>16)kb=S;else{_=I;while(1){P=d[a+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}P=(S&65535)>(_&65535)?_:S;J=I;do{T=a+((J&65535)<<1)|0;M=J;J=d[T>>1]|0;d[T>>1]=P}while((J&65535)<(M&65535));kb=P}P=U;do{J=a+((P&65535)<<1)|0;I=P;P=d[J>>1]|0;d[J>>1]=kb}while((P&65535)<(I&65535));d[z+(E<<1)>>1]=kb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;U=d[z+(L<<1)>>1]|0;I=P;while(1){J=d[a+((I&65535)<<1)>>1]|0;if((J&65535)<(I&65535))I=J;else break}if(P<<16>>16==U<<16>>16)lb=I;else{J=U;while(1){S=d[a+((J&65535)<<1)>>1]|0;if((S&65535)<(J&65535))J=S;else break}S=(I&65535)>(J&65535)?J:I;_=U;do{M=a+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=S}while((_&65535)<(T&65535));lb=S}S=P;do{_=a+((S&65535)<<1)|0;U=S;S=d[_>>1]|0;d[_>>1]=lb}while((S&65535)<(U&65535));d[z+(E<<1)>>1]=lb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[z+(L<<1)>>1]|0;U=S;while(1){_=d[a+((U&65535)<<1)>>1]|0;if((_&65535)<(U&65535))U=_;else break}if(S<<16>>16==P<<16>>16)mb=U;else{L=P;while(1){_=d[a+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}_=(U&65535)>(L&65535)?L:U;I=P;do{J=a+((I&65535)<<1)|0;T=I;I=d[J>>1]|0;d[J>>1]=_}while((I&65535)<(T&65535));mb=_}_=S;do{I=a+((_&65535)<<1)|0;P=_;_=d[I>>1]|0;d[I>>1]=mb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=mb;K=F;break a}else jb=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(jb<<1)>>1]|0;K=F;break}do if(B){_=E+-2|0;if(b[x+G>>0]|0){S=d[z+(_<<1)>>1]|0;do if((_|0)>-1){if(!(b[v+_>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);P=d[t+(_<<1)>>1]|0;I=P;while(1){U=d[a+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(P<<16>>16==S<<16>>16)nb=I;else{U=S;while(1){L=d[a+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;T=S;do{J=a+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=L}while((T&65535)<(M&65535));nb=L}L=P;do{T=a+((L&65535)<<1)|0;S=L;L=d[T>>1]|0;d[T>>1]=nb}while((L&65535)<(S&65535));d[z+(E<<1)>>1]=nb;K=F;break a}if(!(b[x+E>>0]|0)){ob=_;break}do if((_|0)>-1){if(!(b[v+_>>0]|0))break;if(!(b[x+_>>0]|0)){L=d[t+(E<<1)>>1]|0;P=d[z+(_<<1)>>1]|0;S=L;while(1){T=d[a+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}if(L<<16>>16==P<<16>>16)pb=S;else{T=P;while(1){I=d[a+((T&65535)<<1)>>1]|0;if((I&65535)<(T&65535))T=I;else break}I=(S&65535)>(T&65535)?T:S;U=P;do{M=a+((U&65535)<<1)|0;J=U;U=d[M>>1]|0;d[M>>1]=I}while((U&65535)<(J&65535));pb=I}I=L;do{U=a+((I&65535)<<1)|0;P=I;I=d[U>>1]|0;d[U>>1]=pb}while((I&65535)<(P&65535));d[z+(E<<1)>>1]=pb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(_<<1)>>1]|0;K=F;break a}while(0);I=d[t+(E<<1)>>1]|0;L=d[z+(_<<1)>>1]|0;P=I;while(1){U=d[a+((P&65535)<<1)>>1]|0;if((U&65535)<(P&65535))P=U;else break}if(I<<16>>16==L<<16>>16)qb=P;else{U=L;while(1){S=d[a+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(P&65535)>(U&65535)?U:P;T=L;do{J=a+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=S}while((T&65535)<(M&65535));qb=S}S=I;do{T=a+((S&65535)<<1)|0;L=S;S=d[T>>1]|0;d[T>>1]=qb}while((S&65535)<(L&65535));d[z+(E<<1)>>1]=qb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;I=d[z+(_<<1)>>1]|0;L=S;while(1){T=d[a+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(S<<16>>16==I<<16>>16)rb=L;else{_=I;while(1){T=d[a+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(L&65535)>(_&65535)?_:L;P=I;do{U=a+((P&65535)<<1)|0;M=P;P=d[U>>1]|0;d[U>>1]=T}while((P&65535)<(M&65535));rb=T}T=S;do{P=a+((T&65535)<<1)|0;I=T;T=d[P>>1]|0;d[P>>1]=rb}while((T&65535)<(I&65535));d[z+(E<<1)>>1]=rb;K=F;break a}else ob=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ob<<1)>>1]|0;K=F;break}}T=E|1;S=(T|0)<(l|0);if(!(C|S^1)?b[x+T>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(H?b[x+G>>0]|0:0){I=d[t+(E<<1)>>1]|0;do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=I;K=F;break a}while(0);P=d[t+(E+-2<<1)>>1]|0;L=P;while(1){_=d[a+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}if(P<<16>>16==I<<16>>16)sb=L;else{_=I;while(1){M=d[a+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(L&65535)>(_&65535)?_:L;U=I;do{J=a+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=M}while((U&65535)<(N&65535));sb=M}M=P;do{U=a+((M&65535)<<1)|0;I=M;M=d[U>>1]|0;d[U>>1]=sb}while((M&65535)<(I&65535));d[z+(E<<1)>>1]=sb;K=F;break}d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(S?b[v+T>>0]|0:0){M=E+2|0;if(!((M|0)>=(l|0)|C)?b[x+M>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[t+(M<<1)>>1]|0;I=S;while(1){U=d[a+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(S<<16>>16==P<<16>>16)tb=I;else{U=P;while(1){L=d[a+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;_=P;do{N=a+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=L}while((_&65535)<(J&65535));tb=L}L=S;do{_=a+((L&65535)<<1)|0;P=L;L=d[_>>1]|0;d[_>>1]=tb}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=tb;K=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+T>>0]|0))break;L=d[t+(M<<1)>>1]|0;if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}S=d[t+(E+-2<<1)>>1]|0;P=S;while(1){_=d[a+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(S<<16>>16==L<<16>>16)ub=P;else{_=L;while(1){I=d[a+((_&65535)<<1)>>1]|0;if((I&65535)<(_&65535))_=I;else break}I=(P&65535)>(_&65535)?_:P;U=L;do{J=a+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=I}while((U&65535)<(N&65535));ub=I}I=S;do{U=a+((I&65535)<<1)|0;L=I;I=d[U>>1]|0;d[U>>1]=ub}while((I&65535)<(L&65535));d[z+(E<<1)>>1]=ub;K=F;break a}while(0);I=d[t+(E+-2<<1)>>1]|0;S=d[t+(M<<1)>>1]|0;L=I;while(1){U=d[a+((L&65535)<<1)>>1]|0;if((U&65535)<(L&65535))L=U;else break}if(I<<16>>16==S<<16>>16)vb=L;else{U=S;while(1){P=d[a+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(L&65535)>(U&65535)?U:L;_=S;do{N=a+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=P}while((_&65535)<(J&65535));vb=P}P=I;do{_=a+((P&65535)<<1)|0;S=P;P=d[_>>1]|0;d[_>>1]=vb}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=vb;K=F;break a}while(0);d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;M=F&65535;d[a+(M<<1)>>1]=F;K=M+1&65535;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=F;M=F&65535;d[a+(M<<1)>>1]=F;K=M+1&65535}while(0);E=E+2|0;if((E|0)>=(l|0)){wb=K;break}else F=K}}else wb=r;s=s+2|0;if((s|0)>=(i|0))break;else r=wb}if((wb&65535)>1){r=wb&65535;wb=1;i=1;while(1){s=a+(i<<1)|0;K=j[s>>1]|0;if(K>>>0<i>>>0){d[s>>1]=d[a+(K<<1)>>1]|0;xb=wb}else{d[s>>1]=wb;xb=(wb&65535)+1&65535}i=i+1|0;if((i|0)==(r|0)){yb=xb;break}else wb=xb}}else yb=1}else yb=1;xb=f[k>>2]|0;k=f[p>>2]|0;p=(k&1|0)!=0;wb=(xb|0)>0;if(!(xb&1)){if(!p){if(!wb){wL(a);u=h;return yb|0}r=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;s=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;l=(k|0)>0;vb=0;do{ub=r+(Y(i,vb)|0)|0;tb=ub+i|0;sb=s+(Y(K,vb)|0)|0;ob=sb+K|0;if(l){rb=0;do{qb=sb+(rb<<1)|0;pb=d[qb>>1]|0;do if(pb<<16>>16){nb=d[a+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[ub+rb>>0]|0)==0?0:nb;jb=rb|1;d[sb+(jb<<1)>>1]=(b[ub+jb>>0]|0)==0?0:nb;d[ob+(rb<<1)>>1]=(b[tb+rb>>0]|0)==0?0:nb;mb=ob+(jb<<1)|0;if(!(b[tb+jb>>0]|0)){d[mb>>1]=0;break}else{d[mb>>1]=nb;break}}else{d[qb>>1]=0;nb=rb|1;d[sb+(nb<<1)>>1]=0;d[ob+(rb<<1)>>1]=0;d[ob+(nb<<1)>>1]=0}while(0);rb=rb+2|0}while((rb|0)<(k|0))}vb=vb+2|0}while((vb|0)<(xb|0));wL(a);u=h;return yb|0}if(!wb){wL(a);u=h;return yb|0}vb=f[c+16>>2]|0;l=f[f[c+44>>2]>>2]|0;K=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;i=(k|0)>0;r=0;do{rb=vb+(Y(l,r)|0)|0;ob=rb+l|0;sb=K+(Y(s,r)|0)|0;tb=sb+s|0;if(i){ub=0;do{qb=sb+(ub<<1)|0;pb=d[qb>>1]|0;do if(!(pb<<16>>16)){d[qb>>1]=0;d[tb+(ub<<1)>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[sb+(nb<<1)>>1]=0;d[tb+(nb<<1)>>1]=0}}else{nb=d[a+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[rb+ub>>0]|0)==0?0:nb;d[tb+(ub<<1)>>1]=(b[ob+ub>>0]|0)==0?0:nb;mb=ub|1;if((mb|0)<(k|0)){d[sb+(mb<<1)>>1]=(b[rb+mb>>0]|0)==0?0:nb;jb=tb+(mb<<1)|0;if(!(b[ob+mb>>0]|0)){d[jb>>1]=0;break}else{d[jb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}r=r+2|0}while((r|0)<(xb|0));wL(a);u=h;return yb|0}if(!p){if(!wb){wL(a);u=h;return yb|0}p=f[c+16>>2]|0;r=f[f[c+44>>2]>>2]|0;i=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;K=(k|0)>0;l=0;do{vb=p+(Y(r,l)|0)|0;ub=vb+r|0;ob=i+(Y(s,l)|0)|0;tb=ob+s|0;if(K){rb=l|1;sb=(rb|0)<(xb|0);qb=(rb|0)<(xb|0);rb=0;do{pb=ob+(rb<<1)|0;nb=d[pb>>1]|0;do if(!(nb<<16>>16)){d[pb>>1]=0;jb=rb|1;d[ob+(jb<<1)>>1]=0;if(sb){d[tb+(rb<<1)>>1]=0;d[tb+(jb<<1)>>1]=0}}else{jb=d[a+((nb&65535)<<1)>>1]|0;d[pb>>1]=(b[vb+rb>>0]|0)==0?0:jb;mb=rb|1;d[ob+(mb<<1)>>1]=(b[vb+mb>>0]|0)==0?0:jb;if(qb){d[tb+(rb<<1)>>1]=(b[ub+rb>>0]|0)==0?0:jb;lb=tb+(mb<<1)|0;if(!(b[ub+mb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=jb;break}}}while(0);rb=rb+2|0}while((rb|0)<(k|0))}l=l+2|0}while((l|0)<(xb|0));wL(a);u=h;return yb|0}if(!wb){wL(a);u=h;return yb|0}wb=f[c+16>>2]|0;l=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;e=(k|0)>0;s=0;do{i=wb+(Y(l,s)|0)|0;r=i+l|0;p=c+(Y(K,s)|0)|0;rb=p+K|0;if(e){ub=s|1;tb=(ub|0)<(xb|0);qb=(ub|0)<(xb|0);vb=(ub|0)<(xb|0);ob=(ub|0)<(xb|0);ub=0;do{sb=p+(ub<<1)|0;pb=d[sb>>1]|0;do if(!(pb<<16>>16)){d[sb>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[p+(nb<<1)>>1]=0;if(!tb)break;d[rb+(ub<<1)>>1]=0;d[rb+(nb<<1)>>1]=0;break}else{if(!qb)break;d[rb+(ub<<1)>>1]=0;break}}else{nb=d[a+((pb&65535)<<1)>>1]|0;d[sb>>1]=(b[i+ub>>0]|0)==0?0:nb;jb=ub|1;if((jb|0)<(k|0)){d[p+(jb<<1)>>1]=(b[i+jb>>0]|0)==0?0:nb;if(!vb)break;d[rb+(ub<<1)>>1]=(b[r+ub>>0]|0)==0?0:nb;lb=rb+(jb<<1)|0;if(!(b[r+jb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}else{if(!ob)break;lb=rb+(ub<<1)|0;if(!(b[r+ub>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}s=s+2|0}while((s|0)<(xb|0));wL(a);u=h;return yb|0}function $va(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0;g=u;u=u+16|0;a=g;h=f[c+8>>2]|0;i=d+8|0;if((h|0)!=(f[i>>2]|0)){j=$Xc(32)|0;f[a>>2]=j;f[a+8>>2]=-2147483616;f[a+4>>2]=26;k=j;l=354540;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+26>>0]=0;vM(-215,a,528391,354221,2589)}j=f[c+12>>2]|0;n=d+12|0;if((j|0)!=(f[n>>2]|0)){o=$Xc(32)|0;f[a>>2]=o;f[a+8>>2]=-2147483616;f[a+4>>2]=26;k=o;l=354567;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[o+26>>0]=0;vM(-215,a,528391,354221,2590)}if((e|0)!=8){e=$Xc(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=17;k=e;l=354594;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[e+17>>0]=0;vM(-215,a,528391,354221,2591)}a=vL((Y(((h+1|0)/2|0)<<2,(j+1|0)/2|0)|0)+4|0)|0;f[a>>2]=0;if((h|0)>0){e=c+16|0;l=c+44|0;k=d+16|0;m=d+44|0;o=(j|0)>0;p=1;q=0;while(1){r=f[f[l>>2]>>2]|0;s=(f[e>>2]|0)+(Y(r,q)|0)|0;t=0-r|0;v=s+t|0;w=v+t|0;t=s+r|0;r=f[f[m>>2]>>2]|0;x=(f[k>>2]|0)+(Y(r,q)|0)|0;y=0-r|0;r=x+y+y|0;if(o){y=(q|1|0)<(h|0);z=(q|0)>0;A=z^1;B=(q+-2|0)>-1;C=0;D=p;while(1){a:do if(!(b[s+C>>0]|0)){E=C|1;F=(E|0)<(j|0);if(y?b[t+C>>0]|0:0){G=C+-1|0;H=(C|0)>0;if(F?b[s+E>>0]|0:0){do if(H){if(b[s+G>>0]|0){do if(z){if(b[v+E>>0]|0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;J=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}K=f[r+(C<<2)>>2]|0;L=f[x+(J<<2)>>2]|0;M=K;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((K|0)==(L|0))O=M;else{N=L;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=L;do{R=a+(Q<<2)|0;S=Q;Q=f[R>>2]|0;f[R>>2]=P}while((Q|0)<(S|0));O=P}P=K;do{Q=a+(P<<2)|0;L=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(L|0));f[x+(C<<2)>>2]=O;I=D;break a}while(0);P=f[r+(C<<2)>>2]|0;K=f[x+(J<<2)>>2]|0;L=P;while(1){Q=f[a+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((P|0)==(K|0))T=L;else{J=K;while(1){Q=f[a+(J<<2)>>2]|0;if((Q|0)<(J|0))J=Q;else break}Q=(L|0)>(J|0)?J:L;M=K;do{N=a+(M<<2)|0;S=M;M=f[N>>2]|0;f[N>>2]=Q}while((M|0)<(S|0));T=Q}Q=P;do{M=a+(Q<<2)|0;K=Q;Q=f[M>>2]|0;f[M>>2]=T}while((Q|0)<(K|0));f[x+(C<<2)>>2]=T;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;K=Q;while(1){M=f[a+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((Q|0)==(P|0))U=K;else{M=P;while(1){L=f[a+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(K|0)>(M|0)?M:K;J=P;do{S=a+(J<<2)|0;N=J;J=f[S>>2]|0;f[S>>2]=L}while((J|0)<(N|0));U=L}L=Q;do{J=a+(L<<2)|0;P=L;L=f[J>>2]|0;f[J>>2]=U}while((L|0)<(P|0));f[x+(C<<2)>>2]=U;I=D;break a}L=C+2|0;if((L|0)>=(j|0))break;if(!(b[v+L>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){Q=f[r+(L<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;J=Q;while(1){K=f[a+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((Q|0)==(P|0))V=J;else{K=P;while(1){M=f[a+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(J|0)>(K|0)?K:J;N=P;do{S=a+(N<<2)|0;R=N;N=f[S>>2]|0;f[S>>2]=M}while((N|0)<(R|0));V=M}M=Q;do{N=a+(M<<2)|0;P=M;M=f[N>>2]|0;f[N>>2]=V}while((M|0)<(P|0));f[x+(C<<2)>>2]=V;I=D;break a}M=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}Q=f[r+(L<<2)>>2]|0;P=f[x+(M<<2)>>2]|0;N=Q;while(1){J=f[a+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Q|0)==(P|0))W=N;else{J=P;while(1){K=f[a+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}K=(N|0)>(J|0)?J:N;R=P;do{S=a+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(X|0));W=K}K=Q;do{R=a+(K<<2)|0;P=K;K=f[R>>2]|0;f[R>>2]=W}while((K|0)<(P|0));f[x+(C<<2)>>2]=W;I=D;break a}while(0);K=f[r+(L<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;P=K;while(1){R=f[a+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((K|0)==(Q|0))Z=P;else{M=Q;while(1){R=f[a+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(P|0)>(M|0)?M:P;N=Q;do{J=a+(N<<2)|0;X=N;N=f[J>>2]|0;f[J>>2]=R}while((N|0)<(X|0));Z=R}R=K;do{N=a+(R<<2)|0;Q=R;R=f[N>>2]|0;f[N>>2]=Z}while((R|0)<(Q|0));f[x+(C<<2)>>2]=Z;I=D;break a}while(0);R=f[r+(L<<2)>>2]|0;K=f[x+(C+-2<<2)>>2]|0;Q=R;while(1){N=f[a+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((R|0)==(K|0))_=Q;else{L=K;while(1){N=f[a+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}N=(Q|0)>(L|0)?L:Q;P=K;do{M=a+(P<<2)|0;X=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(X|0));_=N}N=R;do{P=a+(N<<2)|0;K=N;N=f[P>>2]|0;f[P>>2]=_}while((N|0)<(K|0));f[x+(C<<2)>>2]=_;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[t+G>>0]|0))break;do if(z){if(b[v+E>>0]|0){N=C+-2|0;do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=R;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;P=K;while(1){Q=f[a+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((K|0)==(R|0))$=P;else{Q=R;while(1){L=f[a+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}L=(P|0)>(Q|0)?Q:P;X=R;do{M=a+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=L}while((X|0)<(J|0));$=L}L=K;do{X=a+(L<<2)|0;R=L;L=f[X>>2]|0;f[X>>2]=$}while((L|0)<(R|0));f[x+(C<<2)>>2]=$;I=D;break a}if(!(b[v+N>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(N<<2)>>2]|0;R=L;while(1){X=f[a+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((L|0)==(K|0))aa=R;else{X=K;while(1){P=f[a+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(R|0)>(X|0)?X:R;Q=K;do{J=a+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=P}while((Q|0)<(M|0));aa=P}P=L;do{Q=a+(P<<2)|0;K=P;P=f[Q>>2]|0;f[Q>>2]=aa}while((P|0)<(K|0));f[x+(C<<2)>>2]=aa;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;P=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){Q=f[a+(K<<2)>>2]|0;if((Q|0)<(K|0))K=Q;else break}if((L|0)==(P|0))ba=K;else{Q=P;while(1){R=f[a+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}R=(K|0)>(Q|0)?Q:K;X=P;do{M=a+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=R}while((X|0)<(J|0));ba=R}R=L;do{X=a+(R<<2)|0;P=R;R=f[X>>2]|0;f[X>>2]=ba}while((R|0)<(P|0));f[x+(C<<2)>>2]=ba;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=R;while(1){X=f[a+(P<<2)>>2]|0;if((X|0)<(P|0))P=X;else break}if((R|0)==(L|0))ca=P;else{X=L;while(1){K=f[a+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(P|0)>(X|0)?X:P;Q=L;do{J=a+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=K}while((Q|0)<(M|0));ca=K}K=R;do{Q=a+(K<<2)|0;L=K;K=f[Q>>2]|0;f[Q>>2]=ca}while((K|0)<(L|0));f[x+(C<<2)>>2]=ca;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;R=f[x+(N<<2)>>2]|0;L=K;while(1){Q=f[a+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((K|0)==(R|0))da=L;else{N=R;while(1){Q=f[a+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(L|0)>(N|0)?N:L;P=R;do{X=a+(P<<2)|0;M=P;P=f[X>>2]|0;f[X>>2]=Q}while((P|0)<(M|0));da=Q}Q=K;do{P=a+(Q<<2)|0;R=Q;Q=f[P>>2]|0;f[P>>2]=da}while((Q|0)<(R|0));f[x+(C<<2)>>2]=da;I=D;break a}Q=C+2|0;do if(!((Q|0)>=(j|0)|A)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}P=f[r+(Q<<2)>>2]|0;L=P;while(1){N=f[a+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}if((P|0)==(R|0))ea=L;else{N=R;while(1){M=f[a+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(L|0)>(N|0)?N:L;X=R;do{J=a+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=M}while((X|0)<(S|0));ea=M}M=P;do{X=a+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=ea}while((M|0)<(R|0));f[x+(C<<2)>>2]=ea;I=D;break a}if(!(b[v+K>>0]|0)){M=f[r+(Q<<2)>>2]|0;P=f[x+(K<<2)>>2]|0;R=M;while(1){X=f[a+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((M|0)==(P|0))fa=R;else{X=P;while(1){L=f[a+(X<<2)>>2]|0;if((L|0)<(X|0))X=L;else break}L=(R|0)>(X|0)?X:R;N=P;do{S=a+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=L}while((N|0)<(J|0));fa=L}L=M;do{N=a+(L<<2)|0;P=L;L=f[N>>2]|0;f[N>>2]=fa}while((L|0)<(P|0));f[x+(C<<2)>>2]=fa;I=D;break a}if(!(b[w+G>>0]|0)){L=f[r+(Q<<2)>>2]|0;M=f[x+(K<<2)>>2]|0;P=L;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((L|0)==(M|0))ga=P;else{N=M;while(1){R=f[a+(N<<2)>>2]|0;if((R|0)<(N|0))N=R;else break}R=(P|0)>(N|0)?N:P;X=M;do{J=a+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=R}while((X|0)<(S|0));ga=R}R=L;do{X=a+(R<<2)|0;M=R;R=f[X>>2]|0;f[X>>2]=ga}while((R|0)<(M|0));f[x+(C<<2)>>2]=ga;I=D;break a}R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}L=f[r+(Q<<2)>>2]|0;M=L;while(1){X=f[a+(M<<2)>>2]|0;if((X|0)<(M|0))M=X;else break}if((L|0)==(R|0))ha=M;else{X=R;while(1){P=f[a+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(M|0)>(X|0)?X:M;N=R;do{S=a+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=P}while((N|0)<(J|0));ha=P}P=L;do{N=a+(P<<2)|0;R=P;P=f[N>>2]|0;f[N>>2]=ha}while((P|0)<(R|0));f[x+(C<<2)>>2]=ha;I=D;break a}while(0);P=f[r+(Q<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;R=P;while(1){N=f[a+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(L|0))ia=R;else{K=L;while(1){N=f[a+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(R|0)>(K|0)?K:R;M=L;do{X=a+(M<<2)|0;J=M;M=f[X>>2]|0;f[X>>2]=N}while((M|0)<(J|0));ia=N}N=P;do{M=a+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=ia}while((N|0)<(L|0));f[x+(C<<2)>>2]=ia;I=D;break a}while(0);N=C+-2|0;if(!(b[v+C>>0]|0)){P=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;M=P;while(1){R=f[a+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((P|0)==(L|0))ja=M;else{R=L;while(1){K=f[a+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(M|0)>(R|0)?R:M;J=L;do{X=a+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=K}while((J|0)<(S|0));ja=K}K=P;do{J=a+(K<<2)|0;L=K;K=f[J>>2]|0;f[J>>2]=ja}while((K|0)<(L|0));f[x+(C<<2)>>2]=ja;I=D;break a}do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){K=f[r+(Q<<2)>>2]|0;P=f[x+(N<<2)>>2]|0;L=K;while(1){J=f[a+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}if((K|0)==(P|0))ka=L;else{J=P;while(1){M=f[a+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(L|0)>(J|0)?J:L;R=P;do{S=a+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=M}while((R|0)<(X|0));ka=M}M=K;do{R=a+(M<<2)|0;P=M;M=f[R>>2]|0;f[R>>2]=ka}while((M|0)<(P|0));f[x+(C<<2)>>2]=ka;I=D;break a}if(!(b[v+N>>0]|0)){M=f[r+(C<<2)>>2]|0;K=f[r+(Q<<2)>>2]|0;P=M;while(1){R=f[a+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((M|0)==(K|0))la=P;else{R=K;while(1){L=f[a+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(P|0)>(R|0)?R:P;J=K;do{X=a+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=L}while((J|0)<(S|0));la=L}L=M;do{J=a+(L<<2)|0;K=L;L=f[J>>2]|0;f[J>>2]=la}while((L|0)<(K|0));L=f[x+(N<<2)>>2]|0;M=la;while(1){K=f[a+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}if((la|0)==(L|0))ma=M;else{K=L;while(1){J=f[a+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(M|0)>(K|0)?K:M;P=L;do{R=a+(P<<2)|0;S=P;P=f[R>>2]|0;f[R>>2]=J}while((P|0)<(S|0));ma=J}J=la;do{P=a+(J<<2)|0;L=J;J=f[P>>2]|0;f[P>>2]=ma}while((J|0)<(L|0));f[x+(C<<2)>>2]=ma;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;J=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=J;while(1){M=f[a+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((J|0)==(L|0))na=P;else{M=L;while(1){K=f[a+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}K=(P|0)>(M|0)?M:P;S=L;do{R=a+(S<<2)|0;X=S;S=f[R>>2]|0;f[R>>2]=K}while((S|0)<(X|0));na=K}K=J;do{S=a+(K<<2)|0;L=K;K=f[S>>2]|0;f[S>>2]=na}while((K|0)<(L|0));f[x+(C<<2)>>2]=na;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=f[r+(Q<<2)>>2]|0;L=K;while(1){S=f[a+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}if((K|0)==(J|0))oa=L;else{S=J;while(1){P=f[a+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(L|0)>(S|0)?S:L;M=J;do{X=a+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=P}while((M|0)<(R|0));oa=P}P=K;do{M=a+(P<<2)|0;J=P;P=f[M>>2]|0;f[M>>2]=oa}while((P|0)<(J|0));P=f[x+(N<<2)>>2]|0;K=oa;while(1){J=f[a+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}if((oa|0)==(P|0))pa=K;else{J=P;while(1){M=f[a+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(K|0)>(J|0)?J:K;L=P;do{S=a+(L<<2)|0;R=L;L=f[S>>2]|0;f[S>>2]=M}while((L|0)<(R|0));pa=M}M=oa;do{L=a+(M<<2)|0;P=M;M=f[L>>2]|0;f[L>>2]=pa}while((M|0)<(P|0));f[x+(C<<2)>>2]=pa;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;P=f[r+(Q<<2)>>2]|0;L=M;while(1){K=f[a+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}if((M|0)==(P|0))qa=L;else{K=P;while(1){J=f[a+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(L|0)>(K|0)?K:L;R=P;do{S=a+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(X|0));qa=J}J=M;do{R=a+(J<<2)|0;P=J;J=f[R>>2]|0;f[R>>2]=qa}while((J|0)<(P|0));J=f[x+(N<<2)>>2]|0;M=qa;while(1){P=f[a+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((qa|0)==(J|0))ra=M;else{N=J;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;R=J;do{L=a+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=P}while((R|0)<(K|0));ra=P}P=qa;do{R=a+(P<<2)|0;J=P;P=f[R>>2]|0;f[R>>2]=ra}while((P|0)<(J|0));f[x+(C<<2)>>2]=ra;I=D;break a}while(0);Q=C+-2|0;if(!(b[v+C>>0]|0)){sa=Q;break}do if((Q|0)>-1){if(!(b[s+Q>>0]|0))break;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}if(!(b[v+Q>>0]|0)){P=f[r+(C<<2)>>2]|0;J=f[x+(Q<<2)>>2]|0;R=P;while(1){M=f[a+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((P|0)==(J|0))ta=R;else{M=J;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(R|0)>(M|0)?M:R;K=J;do{L=a+(K<<2)|0;X=K;K=f[L>>2]|0;f[L>>2]=N}while((K|0)<(X|0));ta=N}N=P;do{K=a+(N<<2)|0;J=N;N=f[K>>2]|0;f[K>>2]=ta}while((N|0)<(J|0));f[x+(C<<2)>>2]=ta;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;P=f[x+(Q<<2)>>2]|0;J=N;while(1){K=f[a+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((N|0)==(P|0))ua=J;else{K=P;while(1){R=f[a+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}R=(J|0)>(K|0)?K:J;M=P;do{X=a+(M<<2)|0;L=M;M=f[X>>2]|0;f[X>>2]=R}while((M|0)<(L|0));ua=R}R=N;do{M=a+(R<<2)|0;P=R;R=f[M>>2]|0;f[M>>2]=ua}while((R|0)<(P|0));f[x+(C<<2)>>2]=ua;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[x+(Q<<2)>>2]|0;P=R;while(1){M=f[a+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((R|0)==(N|0))va=P;else{Q=N;while(1){M=f[a+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}M=(P|0)>(Q|0)?Q:P;J=N;do{K=a+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=M}while((J|0)<(L|0));va=M}M=R;do{J=a+(M<<2)|0;N=M;M=f[J>>2]|0;f[J>>2]=va}while((M|0)<(N|0));f[x+(C<<2)>>2]=va;I=D;break a}else sa=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(sa<<2)>>2];I=D;break a}while(0);do if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(j|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[r+(M<<2)>>2]|0;J=R;while(1){P=f[a+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((R|0)==(N|0))wa=J;else{P=N;while(1){Q=f[a+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(J|0)>(P|0)?P:J;L=N;do{K=a+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=Q}while((L|0)<(X|0));wa=Q}Q=R;do{L=a+(Q<<2)|0;N=Q;Q=f[L>>2]|0;f[L>>2]=wa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=wa;I=D;break a}while(0);if(!(b[v+C>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break}if(H){if(b[t+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(b[s+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}}f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break}do if(F){if(!(b[s+E>>0]|0)){if(!y)break;if(!(b[t+E>>0]|0))break;f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break a}if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(j|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;R=f[r+(M<<2)>>2]|0;N=Q;while(1){L=f[a+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((Q|0)==(R|0))xa=N;else{L=R;while(1){J=f[a+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}J=(N|0)>(L|0)?L:N;P=R;do{X=a+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=J}while((P|0)<(K|0));xa=J}J=Q;do{P=a+(J<<2)|0;R=J;J=f[P>>2]|0;f[P>>2]=xa}while((J|0)<(R|0));f[x+(C<<2)>>2]=xa;I=D;break a}while(0);if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}}f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break a}while(0);f[x+(C<<2)>>2]=0;I=D}else{E=C+-1|0;F=(C|0)>0;if(F){if(b[s+E>>0]|0){G=C|1;H=(G|0)<(j|0);if(z&H?b[v+G>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}do if(B){if(!(b[w+C>>0]|0))break;M=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}J=f[r+(C<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;R=J;while(1){P=f[a+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((J|0)==(Q|0))ya=R;else{P=Q;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=Q;do{K=a+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(X|0));ya=N}N=J;do{L=a+(N<<2)|0;Q=N;N=f[L>>2]|0;f[L>>2]=ya}while((N|0)<(Q|0));f[x+(C<<2)>>2]=ya;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;J=f[x+(M<<2)>>2]|0;Q=N;while(1){L=f[a+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}if((N|0)==(J|0))za=Q;else{M=J;while(1){L=f[a+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(Q|0)>(M|0)?M:Q;R=J;do{P=a+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));za=L}L=N;do{R=a+(L<<2)|0;J=L;L=f[R>>2]|0;f[R>>2]=za}while((L|0)<(J|0));f[x+(C<<2)>>2]=za;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;J=L;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((L|0)==(N|0))Aa=J;else{R=N;while(1){Q=f[a+(R<<2)>>2]|0;if((Q|0)<(R|0))R=Q;else break}Q=(J|0)>(R|0)?R:J;M=N;do{X=a+(M<<2)|0;P=M;M=f[X>>2]|0;f[X>>2]=Q}while((M|0)<(P|0));Aa=Q}Q=L;do{M=a+(Q<<2)|0;N=Q;Q=f[M>>2]|0;f[M>>2]=Aa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=Aa;I=D;break}if(H?b[s+G>>0]|0:0){Q=C+2|0;do if(z&(Q|0)<(j|0)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+G>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){L=f[r+(Q<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;M=L;while(1){J=f[a+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}if((L|0)==(N|0))Ba=M;else{J=N;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}R=(M|0)>(J|0)?J:M;P=N;do{X=a+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=R}while((P|0)<(K|0));Ba=R}R=L;do{P=a+(R<<2)|0;N=R;R=f[P>>2]|0;f[P>>2]=Ba}while((R|0)<(N|0));f[x+(C<<2)>>2]=Ba;I=D;break a}R=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}L=f[r+(Q<<2)>>2]|0;N=f[x+(R<<2)>>2]|0;P=L;while(1){M=f[a+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((L|0)==(N|0))Ca=P;else{M=N;while(1){J=f[a+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}J=(P|0)>(M|0)?M:P;K=N;do{X=a+(K<<2)|0;S=K;K=f[X>>2]|0;f[X>>2]=J}while((K|0)<(S|0));Ca=J}J=L;do{K=a+(J<<2)|0;N=J;J=f[K>>2]|0;f[K>>2]=Ca}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ca;I=D;break a}while(0);J=f[r+(Q<<2)>>2]|0;L=f[x+(R<<2)>>2]|0;N=J;while(1){K=f[a+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((J|0)==(L|0))Da=N;else{R=L;while(1){K=f[a+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(N|0)>(R|0)?R:N;P=L;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=K}while((P|0)<(S|0));Da=K}K=J;do{P=a+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=Da}while((K|0)<(L|0));f[x+(C<<2)>>2]=Da;I=D;break a}while(0);K=f[r+(Q<<2)>>2]|0;J=f[x+(C+-2<<2)>>2]|0;L=K;while(1){P=f[a+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((K|0)==(J|0))Ea=L;else{P=J;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(L|0)>(P|0)?P:L;R=J;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=N}while((R|0)<(M|0));Ea=N}N=K;do{R=a+(N<<2)|0;J=N;N=f[R>>2]|0;f[R>>2]=Ea}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ea;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(y?b[t+E>>0]|0:0){Q=C|1;G=(Q|0)<(j|0);if(!(A|G^1)?b[v+Q>>0]|0:0){H=C+-2|0;do if((H|0)>-1){if(!(b[s+H>>0]|0))break;if(b[v+E>>0]|0){N=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=N;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=K;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((K|0)==(N|0))Fa=J;else{R=N;while(1){L=f[a+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(J|0)>(R|0)?R:J;P=N;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=L}while((P|0)<(S|0));Fa=L}L=K;do{P=a+(L<<2)|0;N=L;L=f[P>>2]|0;f[P>>2]=Fa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Fa;I=D;break a}if(!(b[v+H>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(H<<2)>>2]|0;N=L;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((L|0)==(K|0))Ga=N;else{P=K;while(1){J=f[a+(P<<2)>>2]|0;if((J|0)<(P|0))P=J;else break}J=(N|0)>(P|0)?P:N;R=K;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(M|0));Ga=J}J=L;do{R=a+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Ga}while((J|0)<(K|0));f[x+(C<<2)>>2]=Ga;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;J=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){R=f[a+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((L|0)==(J|0))Ha=K;else{R=J;while(1){N=f[a+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=J;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));Ha=N}N=L;do{P=a+(N<<2)|0;J=N;N=f[P>>2]|0;f[P>>2]=Ha}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ha;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;L=f[x+(H<<2)>>2]|0;J=N;while(1){P=f[a+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((N|0)==(L|0))Ia=J;else{P=L;while(1){K=f[a+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(J|0)>(P|0)?P:J;R=L;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ia=K}K=N;do{R=a+(K<<2)|0;L=K;K=f[R>>2]|0;f[R>>2]=Ia}while((K|0)<(L|0));f[x+(C<<2)>>2]=Ia;I=D;break a}while(0);if(b[v+C>>0]|0){K=f[r+(C<<2)>>2]|0;N=f[x+(H<<2)>>2]|0;L=K;while(1){R=f[a+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((K|0)==(N|0))Ja=L;else{R=N;while(1){J=f[a+(R<<2)>>2]|0;if((J|0)<(R|0))R=J;else break}J=(L|0)>(R|0)?R:L;P=N;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=J}while((P|0)<(S|0));Ja=J}J=K;do{P=a+(J<<2)|0;N=J;J=f[P>>2]|0;f[P>>2]=Ja}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ja;I=D;break}J=f[r+(C<<2)>>2]|0;if(!(b[v+E>>0]|0)){K=f[x+(H<<2)>>2]|0;N=J;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((J|0)==(K|0))Ka=N;else{P=K;while(1){L=f[a+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=K;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=L}while((R|0)<(M|0));Ka=L}L=J;do{R=a+(L<<2)|0;K=L;L=f[R>>2]|0;f[R>>2]=Ka}while((L|0)<(K|0));f[x+(C<<2)>>2]=Ka;I=D;break}do if(B){if(!(b[w+C>>0]|0))break;L=f[x+(H<<2)>>2]|0;K=J;while(1){R=f[a+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((J|0)==(L|0))La=K;else{R=L;while(1){N=f[a+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=L;do{M=a+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));La=N}N=J;do{P=a+(N<<2)|0;L=N;N=f[P>>2]|0;f[P>>2]=La}while((N|0)<(L|0));f[x+(C<<2)>>2]=La;I=D;break a}while(0);N=f[r+(H<<2)>>2]|0;L=N;while(1){P=f[a+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((N|0)==(J|0))Ma=L;else{P=J;while(1){K=f[a+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(L|0)>(P|0)?P:L;R=J;do{S=a+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ma=K}K=N;do{R=a+(K<<2)|0;J=K;K=f[R>>2]|0;f[R>>2]=Ma}while((K|0)<(J|0));K=f[x+(H<<2)>>2]|0;N=Ma;while(1){J=f[a+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Ma|0)==(K|0))Na=N;else{H=K;while(1){J=f[a+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(N|0)>(H|0)?H:N;R=K;do{L=a+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=J}while((R|0)<(P|0));Na=J}J=Ma;do{R=a+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Na}while((J|0)<(K|0));f[x+(C<<2)>>2]=Na;I=D;break}if(G?b[s+Q>>0]|0:0){J=C+2|0;do if(!((J|0)>=(j|0)|A)){if(!(b[v+J>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+E>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}N=f[r+(J<<2)>>2]|0;H=N;while(1){P=f[a+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((N|0)==(R|0))Oa=H;else{P=R;while(1){L=f[a+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=R;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Oa=L}L=N;do{M=a+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=Oa}while((L|0)<(R|0));f[x+(C<<2)>>2]=Oa;I=D;break a}while(0);L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[a+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))Pa=R;else{M=N;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;P=N;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Pa=H}H=L;do{P=a+(H<<2)|0;N=H;H=f[P>>2]|0;f[P>>2]=Pa}while((H|0)<(N|0));f[x+(C<<2)>>2]=Pa;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;if(!(b[v+K>>0]|0)){H=f[r+(J<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;N=H;while(1){P=f[a+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((H|0)==(L|0))Qa=N;else{P=L;while(1){R=f[a+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(N|0)>(P|0)?P:N;M=L;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(X|0));Qa=R}R=H;do{M=a+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=Qa}while((R|0)<(L|0));f[x+(C<<2)>>2]=Qa;I=D;break a}if(!(b[w+E>>0]|0)){R=f[r+(J<<2)>>2]|0;H=f[x+(K<<2)>>2]|0;L=R;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))Ra=L;else{M=H;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;P=H;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=N}while((P|0)<(S|0));Ra=N}N=R;do{P=a+(N<<2)|0;H=N;N=f[P>>2]|0;f[P>>2]=Ra}while((N|0)<(H|0));f[x+(C<<2)>>2]=Ra;I=D;break a}N=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}R=f[r+(J<<2)>>2]|0;H=R;while(1){P=f[a+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((R|0)==(N|0))Sa=H;else{P=N;while(1){L=f[a+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=N;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Sa=L}L=R;do{M=a+(L<<2)|0;N=L;L=f[M>>2]|0;f[M>>2]=Sa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Sa;I=D;break a}while(0);if(!(b[v+C>>0]|0)){L=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=L;while(1){M=f[a+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((L|0)==(R|0))Ta=N;else{M=R;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(N|0)>(M|0)?M:N;P=R;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Ta=H}H=L;do{P=a+(H<<2)|0;R=H;H=f[P>>2]|0;f[P>>2]=Ta}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ta;I=D;break a}if(!(b[v+K>>0]|0)){H=f[r+(C<<2)>>2]|0;L=f[r+(J<<2)>>2]|0;R=H;while(1){P=f[a+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((H|0)==(L|0))Ua=R;else{P=L;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;M=L;do{S=a+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=N}while((M|0)<(X|0));Ua=N}N=H;do{M=a+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=Ua}while((N|0)<(L|0));N=f[x+(K<<2)>>2]|0;H=Ua;while(1){L=f[a+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}if((Ua|0)==(N|0))Va=H;else{L=N;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(H|0)>(L|0)?L:H;R=N;do{P=a+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=M}while((R|0)<(X|0));Va=M}M=Ua;do{R=a+(M<<2)|0;N=M;M=f[R>>2]|0;f[R>>2]=Va}while((M|0)<(N|0));f[x+(C<<2)>>2]=Va;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;M=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=M;while(1){H=f[a+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((M|0)==(N|0))Wa=R;else{H=N;while(1){L=f[a+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(R|0)>(H|0)?H:R;X=N;do{P=a+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=L}while((X|0)<(S|0));Wa=L}L=M;do{X=a+(L<<2)|0;N=L;L=f[X>>2]|0;f[X>>2]=Wa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Wa;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;M=f[r+(J<<2)>>2]|0;N=L;while(1){X=f[a+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((L|0)==(M|0))Xa=N;else{X=M;while(1){R=f[a+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;H=M;do{S=a+(H<<2)|0;P=H;H=f[S>>2]|0;f[S>>2]=R}while((H|0)<(P|0));Xa=R}R=L;do{H=a+(R<<2)|0;M=R;R=f[H>>2]|0;f[H>>2]=Xa}while((R|0)<(M|0));R=f[x+(K<<2)>>2]|0;L=Xa;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((Xa|0)==(R|0))Ya=L;else{M=R;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(L|0)>(M|0)?M:L;N=R;do{X=a+(N<<2)|0;P=N;N=f[X>>2]|0;f[X>>2]=H}while((N|0)<(P|0));Ya=H}H=Xa;do{N=a+(H<<2)|0;R=H;H=f[N>>2]|0;f[N>>2]=Ya}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ya;I=D;break a}while(0);if(b[v+C>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=H;while(1){L=f[a+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((H|0)==(R|0))Za=N;else{L=R;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(N|0)>(L|0)?L:N;P=R;do{X=a+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=M}while((P|0)<(S|0));Za=M}M=H;do{P=a+(M<<2)|0;R=M;M=f[P>>2]|0;f[P>>2]=Za}while((M|0)<(R|0));f[x+(C<<2)>>2]=Za;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;H=f[r+(J<<2)>>2]|0;R=M;while(1){P=f[a+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(H|0))_a=R;else{P=H;while(1){N=f[a+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=H;do{S=a+(L<<2)|0;X=L;L=f[S>>2]|0;f[S>>2]=N}while((L|0)<(X|0));_a=N}N=M;do{L=a+(N<<2)|0;H=N;N=f[L>>2]|0;f[L>>2]=_a}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;M=_a;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}if((_a|0)==(N|0))$a=M;else{H=N;while(1){L=f[a+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(M|0)>(H|0)?H:M;R=N;do{P=a+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));$a=L}L=_a;do{R=a+(L<<2)|0;N=L;L=f[R>>2]|0;f[R>>2]=$a}while((L|0)<(N|0));f[x+(C<<2)>>2]=$a;I=D;break a}if(!(b[v+E>>0]|0)){L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[a+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))ab=R;else{M=N;while(1){H=f[a+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;X=N;do{P=a+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=H}while((X|0)<(S|0));ab=H}H=L;do{X=a+(H<<2)|0;N=H;H=f[X>>2]|0;f[X>>2]=ab}while((H|0)<(N|0));f[x+(C<<2)>>2]=ab;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;if(b[w+C>>0]|0){L=f[x+(K<<2)>>2]|0;N=H;while(1){X=f[a+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((H|0)==(L|0))bb=N;else{X=L;while(1){R=f[a+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;M=L;do{S=a+(M<<2)|0;P=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(P|0));bb=R}R=H;do{M=a+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=bb}while((R|0)<(L|0));f[x+(C<<2)>>2]=bb;I=D;break a}R=f[r+(K<<2)>>2]|0;L=R;while(1){M=f[a+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))cb=L;else{M=H;while(1){N=f[a+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;X=H;do{P=a+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=N}while((X|0)<(S|0));cb=N}N=R;do{X=a+(N<<2)|0;H=N;N=f[X>>2]|0;f[X>>2]=cb}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;R=cb;while(1){H=f[a+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((cb|0)==(N|0))db=R;else{H=N;while(1){X=f[a+(H<<2)>>2]|0;if((X|0)<(H|0))H=X;else break}X=(R|0)>(H|0)?H:R;L=N;do{M=a+(L<<2)|0;S=L;L=f[M>>2]|0;f[M>>2]=X}while((L|0)<(S|0));db=X}X=cb;do{L=a+(X<<2)|0;N=X;X=f[L>>2]|0;f[L>>2]=db}while((X|0)<(N|0));f[x+(C<<2)>>2]=db;I=D;break a}while(0);X=f[r+(K<<2)>>2]|0;N=f[r+(J<<2)>>2]|0;L=X;while(1){R=f[a+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((X|0)==(N|0))eb=L;else{R=N;while(1){H=f[a+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}H=(L|0)>(R|0)?R:L;S=N;do{M=a+(S<<2)|0;P=S;S=f[M>>2]|0;f[M>>2]=H}while((S|0)<(P|0));eb=H}H=X;do{S=a+(H<<2)|0;N=H;H=f[S>>2]|0;f[S>>2]=eb}while((H|0)<(N|0));H=f[x+(K<<2)>>2]|0;X=eb;while(1){N=f[a+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}if((eb|0)==(H|0))fb=X;else{K=H;while(1){N=f[a+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(X|0)>(K|0)?K:X;S=H;do{L=a+(S<<2)|0;R=S;S=f[L>>2]|0;f[L>>2]=N}while((S|0)<(R|0));fb=N}N=eb;do{S=a+(N<<2)|0;H=N;N=f[S>>2]|0;f[S>>2]=fb}while((N|0)<(H|0));f[x+(C<<2)>>2]=fb;I=D;break a}while(0);do if(z){J=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(J<<2)>>2]|0;do if((J|0)>-1){if(!(b[s+J>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);G=f[r+(J<<2)>>2]|0;N=G;while(1){H=f[a+(N<<2)>>2]|0;if((H|0)<(N|0))N=H;else break}if((G|0)==(Q|0))gb=N;else{H=Q;while(1){S=f[a+(H<<2)>>2]|0;if((S|0)<(H|0))H=S;else break}S=(N|0)>(H|0)?H:N;X=Q;do{K=a+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=S}while((X|0)<(R|0));gb=S}S=G;do{X=a+(S<<2)|0;Q=S;S=f[X>>2]|0;f[X>>2]=gb}while((S|0)<(Q|0));f[x+(C<<2)>>2]=gb;I=D;break a}if(!(b[v+C>>0]|0)){hb=J;break}do if((J|0)>-1){if(!(b[s+J>>0]|0))break;if(!(b[v+J>>0]|0)){S=f[r+(C<<2)>>2]|0;G=f[x+(J<<2)>>2]|0;Q=S;while(1){X=f[a+(Q<<2)>>2]|0;if((X|0)<(Q|0))Q=X;else break}if((S|0)==(G|0))ib=Q;else{X=G;while(1){N=f[a+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}N=(Q|0)>(X|0)?X:Q;H=G;do{R=a+(H<<2)|0;K=H;H=f[R>>2]|0;f[R>>2]=N}while((H|0)<(K|0));ib=N}N=S;do{H=a+(N<<2)|0;G=N;N=f[H>>2]|0;f[H>>2]=ib}while((N|0)<(G|0));f[x+(C<<2)>>2]=ib;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;S=f[x+(J<<2)>>2]|0;G=N;while(1){H=f[a+(G<<2)>>2]|0;if((H|0)<(G|0))G=H;else break}if((N|0)==(S|0))jb=G;else{H=S;while(1){Q=f[a+(H<<2)>>2]|0;if((Q|0)<(H|0))H=Q;else break}Q=(G|0)>(H|0)?H:G;X=S;do{K=a+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=Q}while((X|0)<(R|0));jb=Q}Q=N;do{X=a+(Q<<2)|0;S=Q;Q=f[X>>2]|0;f[X>>2]=jb}while((Q|0)<(S|0));f[x+(C<<2)>>2]=jb;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[x+(J<<2)>>2]|0;S=Q;while(1){X=f[a+(S<<2)>>2]|0;if((X|0)<(S|0))S=X;else break}if((Q|0)==(N|0))kb=S;else{J=N;while(1){X=f[a+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}X=(S|0)>(J|0)?J:S;G=N;do{H=a+(G<<2)|0;R=G;G=f[H>>2]|0;f[H>>2]=X}while((G|0)<(R|0));kb=X}X=Q;do{G=a+(X<<2)|0;N=X;X=f[G>>2]|0;f[G>>2]=kb}while((X|0)<(N|0));f[x+(C<<2)>>2]=kb;I=D;break a}else hb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(hb<<2)>>2];I=D;break}do if(z){X=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(X<<2)>>2]|0;do if((X|0)>-1){if(!(b[s+X>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);N=f[r+(X<<2)>>2]|0;G=N;while(1){S=f[a+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((N|0)==(Q|0))lb=G;else{S=Q;while(1){J=f[a+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;R=Q;do{H=a+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=J}while((R|0)<(K|0));lb=J}J=N;do{R=a+(J<<2)|0;Q=J;J=f[R>>2]|0;f[R>>2]=lb}while((J|0)<(Q|0));f[x+(C<<2)>>2]=lb;I=D;break a}if(!(b[v+C>>0]|0)){mb=X;break}do if((X|0)>-1){if(!(b[s+X>>0]|0))break;if(!(b[v+X>>0]|0)){J=f[r+(C<<2)>>2]|0;N=f[x+(X<<2)>>2]|0;Q=J;while(1){R=f[a+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}if((J|0)==(N|0))nb=Q;else{R=N;while(1){G=f[a+(R<<2)>>2]|0;if((G|0)<(R|0))R=G;else break}G=(Q|0)>(R|0)?R:Q;S=N;do{K=a+(S<<2)|0;H=S;S=f[K>>2]|0;f[K>>2]=G}while((S|0)<(H|0));nb=G}G=J;do{S=a+(G<<2)|0;N=G;G=f[S>>2]|0;f[S>>2]=nb}while((G|0)<(N|0));f[x+(C<<2)>>2]=nb;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(X<<2)>>2];I=D;break a}while(0);G=f[r+(C<<2)>>2]|0;J=f[x+(X<<2)>>2]|0;N=G;while(1){S=f[a+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((G|0)==(J|0))ob=N;else{S=J;while(1){Q=f[a+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(N|0)>(S|0)?S:N;R=J;do{H=a+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=Q}while((R|0)<(K|0));ob=Q}Q=G;do{R=a+(Q<<2)|0;J=Q;Q=f[R>>2]|0;f[R>>2]=ob}while((Q|0)<(J|0));f[x+(C<<2)>>2]=ob;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;G=f[x+(X<<2)>>2]|0;J=Q;while(1){R=f[a+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((Q|0)==(G|0))pb=J;else{X=G;while(1){R=f[a+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(J|0)>(X|0)?X:J;N=G;do{S=a+(N<<2)|0;K=N;N=f[S>>2]|0;f[S>>2]=R}while((N|0)<(K|0));pb=R}R=Q;do{N=a+(R<<2)|0;G=R;R=f[N>>2]|0;f[N>>2]=pb}while((R|0)<(G|0));f[x+(C<<2)>>2]=pb;I=D;break a}else mb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(mb<<2)>>2];I=D;break}}R=C|1;Q=(R|0)<(j|0);if(!(A|Q^1)?b[v+R>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(F?b[v+E>>0]|0:0){G=f[r+(C<<2)>>2]|0;do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=G;I=D;break a}while(0);N=f[r+(C+-2<<2)>>2]|0;J=N;while(1){X=f[a+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}if((N|0)==(G|0))qb=J;else{X=G;while(1){K=f[a+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(J|0)>(X|0)?X:J;S=G;do{H=a+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=K}while((S|0)<(L|0));qb=K}K=N;do{S=a+(K<<2)|0;G=K;K=f[S>>2]|0;f[S>>2]=qb}while((K|0)<(G|0));f[x+(C<<2)>>2]=qb;I=D;break}f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(Q?b[s+R>>0]|0:0){K=C+2|0;if(!((K|0)>=(j|0)|A)?b[v+K>>0]|0:0){if(b[v+C>>0]|0){do if(B){if(!(b[w+R>>0]|0))break;f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[r+(K<<2)>>2]|0;G=Q;while(1){S=f[a+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((Q|0)==(N|0))rb=G;else{S=N;while(1){J=f[a+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;X=N;do{L=a+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=J}while((X|0)<(H|0));rb=J}J=Q;do{X=a+(J<<2)|0;N=J;J=f[X>>2]|0;f[X>>2]=rb}while((J|0)<(N|0));f[x+(C<<2)>>2]=rb;I=D;break}do if(F){if(!(b[v+E>>0]|0))break;do if(B){if(!(b[w+R>>0]|0))break;J=f[r+(K<<2)>>2]|0;if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}Q=f[r+(C+-2<<2)>>2]|0;N=Q;while(1){X=f[a+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((Q|0)==(J|0))sb=N;else{X=J;while(1){G=f[a+(X<<2)>>2]|0;if((G|0)<(X|0))X=G;else break}G=(N|0)>(X|0)?X:N;S=J;do{H=a+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=G}while((S|0)<(L|0));sb=G}G=Q;do{S=a+(G<<2)|0;J=G;G=f[S>>2]|0;f[S>>2]=sb}while((G|0)<(J|0));f[x+(C<<2)>>2]=sb;I=D;break a}while(0);G=f[r+(C+-2<<2)>>2]|0;Q=f[r+(K<<2)>>2]|0;J=G;while(1){S=f[a+(J<<2)>>2]|0;if((S|0)<(J|0))J=S;else break}if((G|0)==(Q|0))tb=J;else{S=Q;while(1){N=f[a+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(J|0)>(S|0)?S:J;X=Q;do{L=a+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=N}while((X|0)<(H|0));tb=N}N=G;do{X=a+(N<<2)|0;Q=N;N=f[X>>2]|0;f[X>>2]=tb}while((N|0)<(Q|0));f[x+(C<<2)>>2]=tb;I=D;break a}while(0);f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}do if(!(A|F^1)){if(!(b[v+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(!(A|F^1)?b[v+E>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=D;f[a+(D<<2)>>2]=D;I=D+1|0}while(0);C=C+2|0;if((C|0)>=(j|0)){ub=I;break}else D=I}}else ub=p;q=q+2|0;if((q|0)>=(h|0))break;else p=ub}if((ub|0)>1){p=1;h=1;while(1){q=a+(h<<2)|0;I=f[q>>2]|0;if((I|0)<(h|0)){f[q>>2]=f[a+(I<<2)>>2];vb=p}else{f[q>>2]=p;vb=p+1|0}h=h+1|0;if((h|0)==(ub|0)){wb=vb;break}else p=vb}}else wb=1}else wb=1;vb=f[i>>2]|0;p=f[n>>2]|0;ub=(p&1|0)!=0;h=(vb|0)>0;if(!(vb&1)){if(!ub){if(!h){wL(a);u=g;return wb|0}q=f[c+16>>2]|0;I=f[c+44>>2]|0;j=f[d+16>>2]|0;tb=f[d+44>>2]|0;sb=0;rb=p;qb=vb;while(1){mb=f[I>>2]|0;pb=q+(Y(mb,sb)|0)|0;ob=pb+mb|0;mb=f[tb>>2]|0;nb=j+(Y(mb,sb)|0)|0;lb=nb+mb|0;if((rb|0)>0){mb=0;do{hb=nb+(mb<<2)|0;kb=f[hb>>2]|0;do if((kb|0)>0){jb=f[a+(kb<<2)>>2]|0;f[hb>>2]=(b[pb+mb>>0]|0)==0?0:jb;ib=mb|1;f[nb+(ib<<2)>>2]=(b[pb+ib>>0]|0)==0?0:jb;f[lb+(mb<<2)>>2]=(b[ob+mb>>0]|0)==0?0:jb;gb=lb+(ib<<2)|0;if(!(b[ob+ib>>0]|0)){f[gb>>2]=0;break}else{f[gb>>2]=jb;break}}else{f[hb>>2]=0;jb=mb|1;f[nb+(jb<<2)>>2]=0;f[lb+(mb<<2)>>2]=0;f[lb+(jb<<2)>>2]=0}while(0);mb=mb+2|0;xb=f[n>>2]|0}while((mb|0)<(xb|0));yb=f[i>>2]|0;zb=xb}else{yb=qb;zb=rb}sb=sb+2|0;if((sb|0)>=(yb|0))break;else{rb=zb;qb=yb}}wL(a);u=g;return wb|0}if(!h){wL(a);u=g;return wb|0}yb=f[c+16>>2]|0;qb=f[c+44>>2]|0;zb=f[d+16>>2]|0;rb=f[d+44>>2]|0;sb=0;xb=p;j=vb;while(1){tb=f[qb>>2]|0;q=yb+(Y(tb,sb)|0)|0;I=q+tb|0;tb=f[rb>>2]|0;mb=zb+(Y(tb,sb)|0)|0;lb=mb+tb|0;if((xb|0)>0){tb=0;do{nb=mb+(tb<<2)|0;ob=f[nb>>2]|0;do if((ob|0)>0){pb=f[a+(ob<<2)>>2]|0;f[nb>>2]=(b[q+tb>>0]|0)==0?0:pb;f[lb+(tb<<2)>>2]=(b[I+tb>>0]|0)==0?0:pb;hb=tb|1;if((hb|0)<(f[n>>2]|0)){f[mb+(hb<<2)>>2]=(b[q+hb>>0]|0)==0?0:pb;kb=lb+(hb<<2)|0;if(!(b[I+hb>>0]|0)){f[kb>>2]=0;break}else{f[kb>>2]=pb;break}}}else{f[nb>>2]=0;f[lb+(tb<<2)>>2]=0;pb=tb|1;if((pb|0)<(f[n>>2]|0)){f[mb+(pb<<2)>>2]=0;f[lb+(pb<<2)>>2]=0}}while(0);tb=tb+2|0;Ab=f[n>>2]|0}while((tb|0)<(Ab|0));Bb=f[i>>2]|0;Cb=Ab}else{Bb=j;Cb=xb}sb=sb+2|0;if((sb|0)>=(Bb|0))break;else{xb=Cb;j=Bb}}wL(a);u=g;return wb|0}if(!ub){if(!h){wL(a);u=g;return wb|0}ub=f[c+16>>2]|0;Bb=f[c+44>>2]|0;j=f[d+16>>2]|0;Cb=f[d+44>>2]|0;xb=0;sb=p;Ab=vb;while(1){zb=f[Bb>>2]|0;rb=ub+(Y(zb,xb)|0)|0;yb=rb+zb|0;zb=f[Cb>>2]|0;qb=j+(Y(zb,xb)|0)|0;tb=qb+zb|0;if((sb|0)>0){zb=xb|1;lb=0;do{mb=qb+(lb<<2)|0;I=f[mb>>2]|0;do if((I|0)>0){q=f[a+(I<<2)>>2]|0;f[mb>>2]=(b[rb+lb>>0]|0)==0?0:q;nb=lb|1;f[qb+(nb<<2)>>2]=(b[rb+nb>>0]|0)==0?0:q;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=(b[yb+lb>>0]|0)==0?0:q;ob=tb+(nb<<2)|0;if(!(b[yb+nb>>0]|0)){f[ob>>2]=0;break}else{f[ob>>2]=q;break}}}else{f[mb>>2]=0;q=lb|1;f[qb+(q<<2)>>2]=0;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=0;f[tb+(q<<2)>>2]=0}}while(0);lb=lb+2|0;Db=f[n>>2]|0}while((lb|0)<(Db|0));Eb=f[i>>2]|0;Fb=Db}else{Eb=Ab;Fb=sb}xb=xb+2|0;if((xb|0)>=(Eb|0))break;else{sb=Fb;Ab=Eb}}wL(a);u=g;return wb|0}if(!h){wL(a);u=g;return wb|0}h=f[c+16>>2]|0;Eb=f[c+44>>2]|0;c=f[d+16>>2]|0;Ab=f[d+44>>2]|0;d=0;Fb=p;p=vb;while(1){vb=f[Eb>>2]|0;sb=h+(Y(vb,d)|0)|0;xb=sb+vb|0;vb=f[Ab>>2]|0;Db=c+(Y(vb,d)|0)|0;j=Db+vb|0;if((Fb|0)>0){vb=d|1;Cb=0;do{ub=Db+(Cb<<2)|0;Bb=f[ub>>2]|0;do if((Bb|0)>0){lb=f[a+(Bb<<2)>>2]|0;f[ub>>2]=(b[sb+Cb>>0]|0)==0?0:lb;tb=Cb|1;if((tb|0)<(f[n>>2]|0)){f[Db+(tb<<2)>>2]=(b[sb+tb>>0]|0)==0?0:lb;if((vb|0)>=(f[i>>2]|0))break;f[j+(Cb<<2)>>2]=(b[xb+Cb>>0]|0)==0?0:lb;zb=j+(tb<<2)|0;if(!(b[xb+tb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}else{if((vb|0)>=(f[i>>2]|0))break;zb=j+(Cb<<2)|0;if(!(b[xb+Cb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}}else{f[ub>>2]=0;lb=Cb|1;if((lb|0)<(f[n>>2]|0)){f[Db+(lb<<2)>>2]=0;if((vb|0)>=(f[i>>2]|0))break;f[j+(Cb<<2)>>2]=0;f[j+(lb<<2)>>2]=0;break}else{if((vb|0)>=(f[i>>2]|0))break;f[j+(Cb<<2)>>2]=0;break}}while(0);Cb=Cb+2|0;Gb=f[n>>2]|0}while((Cb|0)<(Gb|0));Hb=f[i>>2]|0;Ib=Gb}else{Hb=p;Ib=Fb}d=d+2|0;if((d|0)>=(Hb|0))break;else{Fb=Ib;p=Hb}}wL(a);u=g;return wb|0}function awa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=f[c+8>>2]|0;if((k|0)!=(f[d+8>>2]|0)){l=$Xc(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=26;m=l;n=354540;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+26>>0]=0;vM(-215,h,528391,354221,2526)}l=f[c+12>>2]|0;if((l|0)!=(f[d+12>>2]|0)){p=$Xc(32)|0;f[h>>2]=p;f[h+8>>2]=-2147483616;f[h+4>>2]=26;m=p;n=354567;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[p+26>>0]=0;vM(-215,h,528391,354221,2527)}if((e|0)!=8){e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=17;m=e;n=354594;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[e+17>>0]=0;vM(-215,h,528391,354221,2528)}e=(l+1|0)/2|0;l=vL(k<<2)|0;n=vL((Y(((k+1|0)/2|0)<<2,e)|0)+4|0)|0;f[n>>2]=0;f[h>>2]=0;f[h+4>>2]=k;m=(k|0)/2|0;o=(i3()|0)<<2;p=(o|0)<(m|0)?o:m;q=+(((p|0)>1?p:1)|0);f[i>>2]=75260;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=n;f[i+16>>2]=l;h3(h,i,q);bwa(c,d,n,l);f[i>>2]=1;if((k|0)>0)r=0;else{s=(k|0)>-1;t=s?k:-1;v=bYc(t)|0;f[j>>2]=75280;w=j+4|0;f[w>>2]=c;x=j+8|0;f[x>>2]=d;y=j+12|0;f[y>>2]=n;z=j+16|0;f[z>>2]=g;A=j+20|0;f[A>>2]=v;B=j+24|0;f[B>>2]=i;h3(h,j,q);dYc(v);wL(l);wL(n);C=f[i>>2]|0;u=a;return C|0}do{p=r+1|0;m=(Y((p|0)/2|0,e)|0)+1|0;o=f[l+(p<<2)>>2]|0;p=o+m|0;if((o|0)>0){o=m;do{m=n+(o<<2)|0;D=f[m>>2]|0;if((D|0)<(o|0))f[m>>2]=f[n+(D<<2)>>2];else{f[m>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}o=o+1|0}while((o|0)<(p|0))}r=f[l+(r<<2)>>2]|0}while((r|0)<(k|0));s=(k|0)>-1;t=s?k:-1;v=bYc(t)|0;f[j>>2]=75280;w=j+4|0;f[w>>2]=c;x=j+8|0;f[x>>2]=d;y=j+12|0;f[y>>2]=n;z=j+16|0;f[z>>2]=g;A=j+20|0;f[A>>2]=v;B=j+24|0;f[B>>2]=i;h3(h,j,q);dYc(v);wL(l);wL(n);C=f[i>>2]|0;u=a;return C|0}function bwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function cwa(a){a=a|0;cYc(a);return}function dwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;d=a+8|0;g=f[d>>2]|0;h=(f[g+8>>2]&1|0)==0;i=f[g+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if((e|0)>0){if(h){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=e;o=g;p=i;while(1){q=f[l>>2]|0;r=f[f[q+44>>2]>>2]|0;s=(f[q+16>>2]|0)+(Y(r,n)|0)|0;q=s+r|0;r=f[f[o+44>>2]>>2]|0;t=(f[o+16>>2]|0)+(Y(r,n)|0)|0;u=t+r|0;if((p|0)>0){r=0;do{v=t+(r<<2)|0;w=f[v>>2]|0;do if((w|0)>0){x=f[(f[m>>2]|0)+(w<<2)>>2]|0;f[v>>2]=(b[s+r>>0]|0)==0?0:x;y=r|1;f[t+(y<<2)>>2]=(b[s+y>>0]|0)==0?0:x;f[u+(r<<2)>>2]=(b[q+r>>0]|0)==0?0:x;z=u+(y<<2)|0;if(!(b[q+y>>0]|0)){f[z>>2]=0;break}else{f[z>>2]=x;break}}else{f[v>>2]=0;x=r|1;f[t+(x<<2)>>2]=0;f[u+(r<<2)>>2]=0;f[u+(x<<2)>>2]=0}while(0);r=r+2|0;v=f[d>>2]|0;w=f[v+12>>2]|0}while((r|0)<(w|0));A=w;B=v}else{A=p;B=o}n=n+2|0;if((n|0)>=(c|0))break;else{o=B;p=A}}return}if(!k)return;A=a+4|0;p=a+12|0;B=e;o=g;n=i;while(1){m=f[A>>2]|0;l=f[f[m+44>>2]>>2]|0;r=(f[m+16>>2]|0)+(Y(l,B)|0)|0;m=r+l|0;l=f[f[o+44>>2]>>2]|0;u=(f[o+16>>2]|0)+(Y(l,B)|0)|0;t=u+l|0;if((n|0)>0){l=0;do{q=u+(l<<2)|0;s=f[q>>2]|0;do if((s|0)>0){v=f[(f[p>>2]|0)+(s<<2)>>2]|0;f[q>>2]=(b[r+l>>0]|0)==0?0:v;f[t+(l<<2)>>2]=(b[m+l>>0]|0)==0?0:v;w=l|1;if((w|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(w<<2)>>2]=(b[r+w>>0]|0)==0?0:v;x=t+(w<<2)|0;if(!(b[m+w>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=v;break}}}else{f[q>>2]=0;f[t+(l<<2)>>2]=0;v=l|1;if((v|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(v<<2)>>2]=0;f[t+(v<<2)>>2]=0}}while(0);l=l+2|0;q=f[d>>2]|0;s=f[q+12>>2]|0}while((l|0)<(s|0));C=s;D=q}else{C=n;D=o}B=B+2|0;if((B|0)>=(c|0))break;else{o=D;n=C}}return}if(!j){if(!k)return;C=a+4|0;n=a+12|0;D=e;o=g;B=i;while(1){p=f[C>>2]|0;A=f[f[p+44>>2]>>2]|0;l=(f[p+16>>2]|0)+(Y(A,D)|0)|0;p=l+A|0;A=f[f[o+44>>2]>>2]|0;t=(f[o+16>>2]|0)+(Y(A,D)|0)|0;u=t+A|0;if((B|0)>0){A=D+1|0;m=0;do{r=t+(m<<2)|0;q=f[r>>2]|0;do if((q|0)>0){s=f[(f[n>>2]|0)+(q<<2)>>2]|0;f[r>>2]=(b[l+m>>0]|0)==0?0:s;v=m|1;f[t+(v<<2)>>2]=(b[l+v>>0]|0)==0?0:s;if((A|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=(b[p+m>>0]|0)==0?0:s;x=u+(v<<2)|0;if(!(b[p+v>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=s;break}}}else{f[r>>2]=0;s=m|1;f[t+(s<<2)>>2]=0;if((A|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=0;f[u+(s<<2)>>2]=0}}while(0);m=m+2|0;r=f[d>>2]|0;q=f[r+12>>2]|0}while((m|0)<(q|0));E=q;F=r}else{E=B;F=o}D=D+2|0;if((D|0)>=(c|0))break;else{o=F;B=E}}return}if(!k)return;E=a+4|0;B=a+12|0;F=e;o=g;D=i;while(1){n=f[E>>2]|0;C=f[f[n+44>>2]>>2]|0;m=(f[n+16>>2]|0)+(Y(C,F)|0)|0;n=m+C|0;C=f[f[o+44>>2]>>2]|0;u=(f[o+16>>2]|0)+(Y(C,F)|0)|0;A=u+C|0;if((D|0)>0){C=F+1|0;t=0;do{p=u+(t<<2)|0;l=f[p>>2]|0;do if((l|0)>0){r=f[(f[B>>2]|0)+(l<<2)>>2]|0;f[p>>2]=(b[m+t>>0]|0)==0?0:r;q=t|1;s=f[d>>2]|0;if((q|0)<(f[s+12>>2]|0)){f[u+(q<<2)>>2]=(b[m+q>>0]|0)==0?0:r;if((C|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[A+(t<<2)>>2]=(b[n+t>>0]|0)==0?0:r;x=A+(q<<2)|0;if(!(b[n+q>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=r;break}}else{if((C|0)>=(f[s+8>>2]|0))break;s=A+(t<<2)|0;if(!(b[n+t>>0]|0)){f[s>>2]=0;break}else{f[s>>2]=r;break}}}else{f[p>>2]=0;r=t|1;s=f[d>>2]|0;if((r|0)<(f[s+12>>2]|0)){f[u+(r<<2)>>2]=0;if((C|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[A+(t<<2)>>2]=0;f[A+(r<<2)>>2]=0;break}else{if((C|0)>=(f[s+8>>2]|0))break;f[A+(t<<2)>>2]=0;break}}while(0);t=t+2|0;p=f[d>>2]|0;l=f[p+12>>2]|0}while((t|0)<(l|0));G=l;H=p}else{G=D;H=o}F=F+2|0;if((F|0)>=(c|0))break;else{o=H;D=G}}return}else{if(h){if(!j){if(!k)return;h=a+4|0;G=a+12|0;D=e;H=g;o=i;while(1){F=f[h>>2]|0;B=f[f[F+44>>2]>>2]|0;E=(f[F+16>>2]|0)+(Y(B,D)|0)|0;F=E+B|0;B=f[f[H+44>>2]>>2]|0;t=(f[H+16>>2]|0)+(Y(B,D)|0)|0;A=t+B|0;if((o|0)>0){B=0;do{C=t+(B<<2)|0;u=f[C>>2]|0;do if((u|0)>0){n=f[(f[G>>2]|0)+(u<<2)>>2]|0;f[C>>2]=(b[E+B>>0]|0)==0?0:n;m=B|1;f[t+(m<<2)>>2]=(b[E+m>>0]|0)==0?0:n;f[A+(B<<2)>>2]=(b[F+B>>0]|0)==0?0:n;p=A+(m<<2)|0;if(!(b[F+m>>0]|0)){f[p>>2]=0;break}else{f[p>>2]=n;break}}else{f[C>>2]=0;n=B|1;f[t+(n<<2)>>2]=0;f[A+(B<<2)>>2]=0;f[A+(n<<2)>>2]=0}while(0);B=B+2|0;C=f[d>>2]|0;u=f[C+12>>2]|0}while((B|0)<(u|0));I=u;J=C}else{I=o;J=H}D=D+2|0;if((D|0)>=(c|0))break;else{H=J;o=I}}return}if(!k)return;I=a+4|0;o=a+12|0;J=e;H=g;D=i;while(1){G=f[I>>2]|0;h=f[f[G+44>>2]>>2]|0;B=(f[G+16>>2]|0)+(Y(h,J)|0)|0;G=B+h|0;h=f[f[H+44>>2]>>2]|0;A=(f[H+16>>2]|0)+(Y(h,J)|0)|0;t=A+h|0;if((D|0)>0){h=0;do{F=A+(h<<2)|0;E=f[F>>2]|0;do if((E|0)>0){C=f[(f[o>>2]|0)+(E<<2)>>2]|0;f[F>>2]=(b[B+h>>0]|0)==0?0:C;f[t+(h<<2)>>2]=(b[G+h>>0]|0)==0?0:C;u=h|1;if((u|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[A+(u<<2)>>2]=(b[B+u>>0]|0)==0?0:C;n=t+(u<<2)|0;if(!(b[G+u>>0]|0)){f[n>>2]=0;break}else{f[n>>2]=C;break}}}else{f[F>>2]=0;f[t+(h<<2)>>2]=0;C=h|1;if((C|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[A+(C<<2)>>2]=0;f[t+(C<<2)>>2]=0}}while(0);h=h+2|0;F=f[d>>2]|0;E=f[F+12>>2]|0}while((h|0)<(E|0));K=E;L=F}else{K=D;L=H}J=J+2|0;if((J|0)>=(c|0))break;else{H=L;D=K}}return}if(!j){if(!k)return;j=a+4|0;K=a+12|0;D=e;L=g;H=i;while(1){J=f[j>>2]|0;o=f[f[J+44>>2]>>2]|0;I=(f[J+16>>2]|0)+(Y(o,D)|0)|0;J=I+o|0;o=f[f[L+44>>2]>>2]|0;h=(f[L+16>>2]|0)+(Y(o,D)|0)|0;t=h+o|0;if((H|0)>0){o=D+1|0;A=0;do{G=h+(A<<2)|0;B=f[G>>2]|0;do if((B|0)>0){F=f[(f[K>>2]|0)+(B<<2)>>2]|0;f[G>>2]=(b[I+A>>0]|0)==0?0:F;E=A|1;f[h+(E<<2)>>2]=(b[I+E>>0]|0)==0?0:F;if((o|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(A<<2)>>2]=(b[J+A>>0]|0)==0?0:F;C=t+(E<<2)|0;if(!(b[J+E>>0]|0)){f[C>>2]=0;break}else{f[C>>2]=F;break}}}else{f[G>>2]=0;F=A|1;f[h+(F<<2)>>2]=0;if((o|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(A<<2)>>2]=0;f[t+(F<<2)>>2]=0}}while(0);A=A+2|0;G=f[d>>2]|0;B=f[G+12>>2]|0}while((A|0)<(B|0));M=B;N=G}else{M=H;N=L}D=D+2|0;if((D|0)>=(c|0))break;else{L=N;H=M}}return}if(!k)return;k=a+4|0;M=a+12|0;a=e;e=g;g=i;while(1){i=f[k>>2]|0;H=f[f[i+44>>2]>>2]|0;N=(f[i+16>>2]|0)+(Y(H,a)|0)|0;i=N+H|0;H=f[f[e+44>>2]>>2]|0;L=(f[e+16>>2]|0)+(Y(H,a)|0)|0;D=L+H|0;if((g|0)>0){H=a+1|0;K=0;do{j=L+(K<<2)|0;A=f[j>>2]|0;do if((A|0)>0){t=f[(f[M>>2]|0)+(A<<2)>>2]|0;f[j>>2]=(b[N+K>>0]|0)==0?0:t;o=K|1;h=f[d>>2]|0;if((o|0)<(f[h+12>>2]|0)){f[L+(o<<2)>>2]=(b[N+o>>0]|0)==0?0:t;if((H|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[D+(K<<2)>>2]=(b[i+K>>0]|0)==0?0:t;J=D+(o<<2)|0;if(!(b[i+o>>0]|0)){f[J>>2]=0;break}else{f[J>>2]=t;break}}else{if((H|0)>=(f[h+8>>2]|0))break;h=D+(K<<2)|0;if(!(b[i+K>>0]|0)){f[h>>2]=0;break}else{f[h>>2]=t;break}}}else{f[j>>2]=0;t=K|1;h=f[d>>2]|0;if((t|0)<(f[h+12>>2]|0)){f[L+(t<<2)>>2]=0;if((H|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[D+(K<<2)>>2]=0;f[D+(t<<2)>>2]=0;break}else{if((H|0)>=(f[h+8>>2]|0))break;f[D+(K<<2)>>2]=0;break}}while(0);K=K+2|0;j=f[d>>2]|0;A=f[j+12>>2]|0}while((K|0)<(A|0));O=A;P=j}else{O=g;P=e}a=a+2|0;if((a|0)>=(c|0))break;else{e=P;g=O}}return}}function ewa(a){a=a|0;cYc(a);return}function fwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=j;p=h;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=e;s=j;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,a)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,a)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(a+1|0)<(m|0);A=(a|0)>(e|0);B=A^1;C=(a|0)>(c|0);D=0;E=s;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=s;a=a+2|0;if((a|0)>=(f[d>>2]|0))break;else s=wb}o=wb;p=f[g>>2]|0;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}function gwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function hwa(a){a=a|0;cYc(a);return}function iwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=(c|0)<(d|0);if((c|0)>0){if(!b)return;e=a+4|0;g=a+8|0;h=c;do{i=f[e>>2]|0;j=(f[i+16>>2]|0)+(Y(f[f[i+44>>2]>>2]|0,h)|0)|0;k=j+(f[i+12>>2]<<2)|0;if((j|0)!=(k|0)){i=f[g>>2]|0;l=j;do{f[l>>2]=f[i+(f[l>>2]<<2)>>2];l=l+4|0}while((l|0)!=(k|0))}h=h+1|0}while((h|0)!=(d|0));return}else{if(!b)return;b=a+4|0;h=a+8|0;a=c;do{c=f[b>>2]|0;g=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;e=g+(f[c+12>>2]<<2)|0;if((g|0)!=(e|0)){c=f[h>>2]|0;k=g;do{f[k>>2]=f[c+(f[k>>2]<<2)>>2];k=k+4|0}while((k|0)!=(e|0))}a=a+1|0}while((a|0)!=(d|0));return}}function jwa(a){a=a|0;cYc(a);return}function kwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=d;s=i;t=k;k=h;while(1){h=f[f[t+44>>2]>>2]|0;u=(f[t+16>>2]|0)+(Y(h,a)|0)|0;v=u+(0-h)|0;h=f[f[k+44>>2]>>2]|0;w=(f[k+16>>2]|0)+(Y(h,a)|0)|0;x=w+(0-h)|0;a:do if(q){if((a|0)>(d|0)){y=0;z=s}else{h=0;A=s;while(1){do if(!(b[u+h>>0]|0)){f[w+(h<<2)>>2]=0;B=A}else{if((h|0)>0?(C=h+-1|0,b[u+C>>0]|0):0){f[w+(h<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(h<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);h=h+1|0;if((h|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(h=y+-1|0,b[u+h>>0]|0):0){f[w+(y<<2)>>2]=f[w+(h<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}h=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(h|0))H=A;else{G=h;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=h;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=h;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=s;while(0);w=a+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=w;s=D;t=f[j>>2]|0;k=f[g>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function lwa(a){a=a|0;cYc(a);return}function mwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=d;u=j;v=n;n=l;l=i;while(1){i=f[f[n+44>>2]>>2]|0;w=(f[n+16>>2]|0)+(Y(i,a)|0)|0;x=w+(0-i)|0;i=f[f[l+44>>2]>>2]|0;y=(f[l+16>>2]|0)+(Y(i,a)|0)|0;z=y+(0-i)|0;if(r){i=(a|0)>(d|0);A=i^1;B=0;C=u;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(i){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=D;U=f[e>>2]|0}else{T=u;U=v}C=a+1|0;if((C|0)==(U|0)){o=T;break}a=C;u=T;v=U;n=f[k>>2]|0;l=f[h>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function nwa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return owa(a,b,c,d,e,f,-1)|0}function owa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;j=u;u=u+272|0;k=j+216|0;l=j+152|0;m=j+160|0;n=j+16|0;o=j;do if((eS(a)|0)==65536){p=f[a+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;v=k+40|0;f[v>>2]=s;s=k+48|0;w=k+44|0;f[w>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=v;break}else{f[q>>2]=0;U$(k,p);x=v;break}}else{bS(k,a,-1);x=k+40|0}while(0);a=f[x>>2]|0;v=f[a>>2]|0;f[l>>2]=f[a+4>>2];f[l+4>>2]=v;wS(c,l,h&7,-1,0,0);do if((eS(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];v=m+4|0;a=l+4|0;f[v>>2]=f[a>>2];p=m+8|0;f[p>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[l+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[v>>2]=0;U$(m,l);break}}else bS(m,c,-1);while(0);f[n>>2]=d;f[n+4>>2]=1124007936;d=n+12|0;c=n+44|0;l=n+8|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[c>>2]=d;d=n+52|0;f[n+48>>2]=d;f[d>>2]=0;f[n+56>>2]=0;f[n+60>>2]=e;f[n+64>>2]=1124007936;e=n+72|0;d=n+104|0;l=n+68|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[d>>2]=e;e=n+112|0;f[n+108>>2]=e;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;switch(h|0){case 4:case 2:break;default:{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;h=$Xc(48)|0;f[o>>2]=h;f[o+8>>2]=-2147483600;f[o+4>>2]=37;l=h;e=354163;v=l+37|0;do{b[l>>0]=b[e>>0]|0;l=l+1|0;e=e+1|0}while((l|0)<(v|0));b[h+37>>0]=0;vM(-210,o,355059,354221,4029)}}o=pwa(k,m,g,i,n)|0;qwa(n);n=m+36|0;i=f[n>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)V$(m);f[n>>2]=0;n=m+16|0;i=m+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[m+40>>2]|0;g=0;do{f[n+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[m+44>>2]|0;if((i|0)!=(m+48|0))wL(i);i=k+36|0;m=f[i>>2]|0;if(m|0?(g=m+12|0,m=f[g>>2]|0,f[g>>2]=m+-1,(m|0)==1):0)V$(k);f[i>>2]=0;i=k+16|0;m=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[m>>2]|0)>0){i=f[x>>2]|0;x=0;do{f[i+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)==(k+48|0)){u=j;return o|0}wL(m);u=j;return o|0}function pwa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+32|0;i=h;j=h+17|0;k=h+16|0;l=h+15|0;m=h+14|0;n=h+13|0;o=h+12|0;p=f[c>>2]|0;if(p&4088|0){q=$Xc(48)|0;f[i>>2]=q;r=i+8|0;f[r>>2]=-2147483600;s=i+4|0;f[s>>2]=38;t=q;v=354305;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+38|0;b[x>>0]=0;vM(-215,i,354344,354221,3927)}y=f[a>>2]|0;if(y&4088|0){q=$Xc(48)|0;f[i>>2]=q;r=i+8|0;f[r>>2]=-2147483600;s=i+4|0;f[s>>2]=38;t=q;v=354305;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));x=q+38|0;b[x>>0]=0;vM(-215,i,354344,354221,3927)}x=(d|0)==8;q=(d|0)==4;switch(d|0){case 4:case 8:break;default:{s=$Xc(48)|0;f[i>>2]=s;f[i+8>>2]=-2147483600;f[i+4>>2]=38;t=s;v=354369;w=t+38|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[s+38>>0]=0;vM(-215,i,354344,354221,3928)}}s=(e|0)==1;r=(e|0)==0;z=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{e=$Xc(80)|0;f[i>>2]=e;f[i+8>>2]=-2147483568;f[i+4>>2]=67;t=e;v=354408;w=t+67|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[e+67>>0]=0;vM(-215,i,354344,354221,3929)}}e=p&7;A=k3()|0;B=i3()|0;if((y&6|1|0)!=1){y=$Xc(48)|0;f[i>>2]=y;f[i+8>>2]=-2147483600;f[i+4>>2]=34;t=y;v=354476;w=t+34|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[y+34>>0]=0;vM(-215,i,354344,354221,3936)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(e|0)==0;a:do if(q|r){if(!B){switch(p&7){case 2:{D=(rwa(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=twa(l,a,c,d,g)|0;u=h;return D|0}else{D=swa(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|x&(s|z)^1)){switch(p&7){case 2:{D=(uwa(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=wwa(o,a,c,d,g)|0;u=h;return D|0}else{D=vwa(n,a,c,d,g)|0;u=h;return D|0}}while(0);D=$Xc(32)|0;f[i>>2]=D;f[i+8>>2]=-2147483616;f[i+4>>2]=28;t=D;v=354511;w=t+28|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));b[D+28>>0]=0;vM(-210,i,354344,354221,3982);return 0}function qwa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+120>>2]|0;if(b|0){c=a+124|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);cYc(b)}b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)V$(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))wL(b);b=a+4|0;c=a+40|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+20|0;b=a+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+44>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;wL(b);return}function rwa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0;a=u;u=u+16|0;i=a;k=f[e+8>>2]|0;if((k|0)!=(f[c+8>>2]|0)){l=$Xc(32)|0;f[i>>2]=l;f[i+8>>2]=-2147483616;f[i+4>>2]=26;m=l;n=355005;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+26>>0]=0;vM(-215,i,528391,354221,656)}l=f[e+12>>2]|0;if((l|0)!=(f[c+12>>2]|0)){q=$Xc(32)|0;f[i>>2]=q;f[i+8>>2]=-2147483616;f[i+4>>2]=26;m=q;n=355032;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[q+26>>0]=0;vM(-215,i,528391,354221,657)}switch(g|0){case 4:case 8:break;default:{q=$Xc(48)|0;f[i>>2]=q;f[i+8>>2]=-2147483600;f[i+4>>2]=38;m=q;n=354369;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[q+38>>0]=0;vM(-215,i,528391,354221,658)}}i=vL((Y(l,k)|0)+3&-2)|0;d[i>>1]=0;q=(k|0)>0;if((g|0)==8)if(q){g=(l|0)>0;n=l+-1|0;m=f[c+16>>2]|0;o=f[f[c+44>>2]>>2]|0;r=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;t=0-o|0;v=0-s|0;w=1;x=0;while(1){y=m+(Y(o,x)|0)|0;z=y+t|0;A=r+(Y(s,x)|0)|0;B=A+v|0;if(g){C=(x|0)>0;D=0;E=w;while(1){a:do if(!(b[y+D>>0]|0)){d[A+(D<<1)>>1]=0;F=E}else{if(C){if(b[z+D>>0]|0){d[A+(D<<1)>>1]=d[B+(D<<1)>>1]|0;F=E;break}G=(D|0)>0;if((D|0)<(n|0)?(H=D+1|0,b[z+H>>0]|0):0){I=d[B+(H<<1)>>1]|0;do if(G){H=D+-1|0;if(!(b[z+H>>0]|0)){K=D+-1|0;if(!(b[y+K>>0]|0)){L=I;break}M=d[A+(K<<1)>>1]|0;K=M;while(1){N=d[i+((K&65535)<<1)>>1]|0;if((N&65535)<(K&65535))K=N;else break}if(M<<16>>16==I<<16>>16)O=K;else{N=I;while(1){P=d[i+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(K&65535)>(N&65535)?N:K;Q=I;do{R=i+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=P}while((Q&65535)<(S&65535));O=P}P=M;do{Q=i+((P&65535)<<1)|0;K=P;P=d[Q>>1]|0;d[Q>>1]=O}while((P&65535)<(K&65535));L=O}else{P=d[B+(H<<1)>>1]|0;M=P;while(1){K=d[i+((M&65535)<<1)>>1]|0;if((K&65535)<(M&65535))M=K;else break}if(P<<16>>16==I<<16>>16)T=M;else{H=I;while(1){K=d[i+((H&65535)<<1)>>1]|0;if((K&65535)<(H&65535))H=K;else break}K=(M&65535)>(H&65535)?H:M;Q=I;do{N=i+((Q&65535)<<1)|0;S=Q;Q=d[N>>1]|0;d[N>>1]=K}while((Q&65535)<(S&65535));T=K}K=P;do{Q=i+((K&65535)<<1)|0;M=K;K=d[Q>>1]|0;d[Q>>1]=T}while((K&65535)<(M&65535));d[A+(D<<1)>>1]=T;F=E;break a}}else L=I;while(0);d[A+(D<<1)>>1]=L;F=E;break}if(G){I=D+-1|0;if(!(b[z+I>>0]|0))U=46;else{d[A+(D<<1)>>1]=d[B+(I<<1)>>1]|0;F=E;break}}}else if((D|0)>0)U=46;if((U|0)==46?(U=0,I=D+-1|0,b[y+I>>0]|0):0){d[A+(D<<1)>>1]=d[A+(I<<1)>>1]|0;F=E;break}d[A+(D<<1)>>1]=E;I=E&65535;d[i+(I<<1)>>1]=E;F=I+1&65535}while(0);D=D+1|0;if((D|0)==(l|0)){V=F;break}else E=F}}else V=w;x=x+1|0;if((x|0)==(k|0)){W=V;U=81;break}else w=V}}else U=80;else if(q){V=(l|0)>0;w=f[c+16>>2]|0;x=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;F=f[f[e+44>>2]>>2]|0;L=0-x|0;T=0-F|0;O=0;n=1;while(1){g=w+(Y(x,O)|0)|0;v=g+L|0;s=c+(Y(F,O)|0)|0;r=s+T|0;b:do if(V){if((O|0)>0){X=0;Z=n}else{t=0;o=n;while(1){do if(!(b[g+t>>0]|0)){d[s+(t<<1)>>1]=0;_=o}else{if((t|0)>0?(m=t+-1|0,b[g+m>>0]|0):0){d[s+(t<<1)>>1]=d[s+(m<<1)>>1]|0;_=o;break}d[s+(t<<1)>>1]=o;m=o&65535;d[i+(m<<1)>>1]=o;_=m+1&65535}while(0);t=t+1|0;if((t|0)==(l|0)){$=_;break b}else o=_}}while(1){do if(!(b[g+X>>0]|0)){d[s+(X<<1)>>1]=0;aa=Z}else{o=(X|0)>0;if(!(b[v+X>>0]|0)){if(o?(t=X+-1|0,b[g+t>>0]|0):0){d[s+(X<<1)>>1]=d[s+(t<<1)>>1]|0;aa=Z;break}d[s+(X<<1)>>1]=Z;t=Z&65535;d[i+(t<<1)>>1]=Z;aa=t+1&65535;break}t=d[r+(X<<1)>>1]|0;if(o?(o=X+-1|0,(b[g+o>>0]|0)!=0):0){G=d[s+(o<<1)>>1]|0;o=G;while(1){m=d[i+((o&65535)<<1)>>1]|0;if((m&65535)<(o&65535))o=m;else break}if(G<<16>>16==t<<16>>16)ba=o;else{m=t;while(1){E=d[i+((m&65535)<<1)>>1]|0;if((E&65535)<(m&65535))m=E;else break}E=(o&65535)>(m&65535)?m:o;D=t;do{A=i+((D&65535)<<1)|0;y=D;D=d[A>>1]|0;d[A>>1]=E}while((D&65535)<(y&65535));ba=E}E=G;do{D=i+((E&65535)<<1)|0;o=E;E=d[D>>1]|0;d[D>>1]=ba}while((E&65535)<(o&65535));ca=ba}else ca=t;d[s+(X<<1)>>1]=ca;aa=Z}while(0);X=X+1|0;if((X|0)==(l|0)){$=aa;break}else Z=aa}}else $=n;while(0);O=O+1|0;if((O|0)==(k|0)){W=$;U=81;break}else n=$}}else U=80;if((U|0)==80){ywa(h,1);da=1}else if((U|0)==81){if((W&65535)>1){U=W&65535;W=1;$=1;while(1){n=i+($<<1)|0;O=j[n>>1]|0;if(O>>>0<$>>>0){d[n>>1]=d[i+(O<<1)>>1]|0;ea=W}else{d[n>>1]=W;ea=(W&65535)+1&65535}$=$+1|0;if(($|0)==(U|0)){fa=ea;break}else W=ea}}else fa=1;ywa(h,fa&65535);if(q){q=f[e+16>>2]|0;ea=f[e+44>>2]|0;e=f[h+20>>2]|0;W=f[h+48>>2]|0;U=f[h+120>>2]|0;$=0;do{n=q+(Y(f[ea>>2]|0,$)|0)|0;O=n+(l<<1)|0;if((n|0)!=(O|0)){aa=(($|0)<0)<<31>>31;Z=n;n=0;while(1){X=d[i+(j[Z>>1]<<1)>>1]|0;d[Z>>1]=X;ca=X&65535;X=e+(Y(f[W>>2]|0,ca)|0)|0;ba=f[X>>2]|0;f[X>>2]=(ba|0)>(n|0)?n:ba;ba=X+8|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<(n|0)?n:_;_=X+4|0;ba=f[_>>2]|0;f[_>>2]=(ba|0)>($|0)?$:ba;ba=X+12|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<($|0)?$:_;_=X+16|0;f[_>>2]=(f[_>>2]|0)+1;_=U+(ca<<4)|0;X=_;ba=d1c(f[X>>2]|0,f[X+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;X=_;f[X>>2]=ba;f[X+4>>2]=J;X=U+(ca<<4)+8|0;ca=X;ba=d1c(f[ca>>2]|0,f[ca+4>>2]|0,$|0,aa|0)|0;ca=X;f[ca>>2]=ba;f[ca+4>>2]=J;Z=Z+2|0;if((Z|0)==(O|0))break;else n=n+1|0}}$=$+1|0}while(($|0)!=(k|0));da=fa}else da=fa}fa=h+12|0;if((f[fa>>2]|0)<=0){wL(i);u=a;return da|0}k=f[h+20>>2]|0;$=f[h+48>>2]|0;U=f[h+120>>2]|0;W=f[h+80>>2]|0;e=f[h+108>>2]|0;h=0;do{l=k+(Y(f[$>>2]|0,h)|0)|0;ea=l+8|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[l>>2]|0);ea=l+12|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[l+4>>2]|0);ea=W+(Y(f[e>>2]|0,h)|0)|0;ga=+((f[l+16>>2]|0)>>>0);l=U+(h<<4)|0;p[ea>>3]=(+((f[l>>2]|0)>>>0)+4294967296.0*+((f[l+4>>2]|0)>>>0))/ga;l=U+(h<<4)+8|0;p[ea+8>>3]=(+((f[l>>2]|0)>>>0)+4294967296.0*+((f[l+4>>2]|0)>>>0))/ga;h=h+1|0}while((h|0)<(f[fa>>2]|0));wL(i);u=a;return da|0}function swa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0;a=u;u=u+16|0;h=a;i=f[d+8>>2]|0;if((i|0)!=(f[c+8>>2]|0)){j=$Xc(32)|0;f[h>>2]=j;f[h+8>>2]=-2147483616;f[h+4>>2]=26;k=j;l=355005;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+26>>0]=0;vM(-215,h,528391,354221,656)}j=f[d+12>>2]|0;if((j|0)!=(f[c+12>>2]|0)){n=$Xc(32)|0;f[h>>2]=n;f[h+8>>2]=-2147483616;f[h+4>>2]=26;k=n;l=355032;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[n+26>>0]=0;vM(-215,h,528391,354221,657)}switch(e|0){case 4:case 8:break;default:{n=$Xc(48)|0;f[h>>2]=n;f[h+8>>2]=-2147483600;f[h+4>>2]=38;k=n;l=354369;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[n+38>>0]=0;vM(-215,h,528391,354221,658)}}h=vL((((Y(j,i)|0)+1|0)>>>1<<2)+4|0)|0;f[h>>2]=0;n=(i|0)>0;if((e|0)==8)if(n){e=(j|0)>0;l=j+-1|0;k=f[c+16>>2]|0;m=f[c+44>>2]|0;o=f[d+16>>2]|0;q=f[d+44>>2]|0;r=1;s=0;while(1){t=f[m>>2]|0;v=k+(Y(t,s)|0)|0;w=v+(0-t)|0;t=f[q>>2]|0;x=o+(Y(t,s)|0)|0;y=x+(0-t)|0;if(e){t=(s|0)>0;z=0;A=r;while(1){a:do if(!(b[v+z>>0]|0)){f[x+(z<<2)>>2]=0;B=A}else{if(t){if(b[w+z>>0]|0){f[x+(z<<2)>>2]=f[y+(z<<2)>>2];B=A;break}C=(z|0)>0;if((z|0)<(l|0)?(D=z+1|0,b[w+D>>0]|0):0){E=f[y+(D<<2)>>2]|0;do if(C){D=z+-1|0;if(!(b[w+D>>0]|0)){F=z+-1|0;if(!(b[v+F>>0]|0)){G=E;break}H=f[x+(F<<2)>>2]|0;F=H;while(1){I=f[h+(F<<2)>>2]|0;if((I|0)<(F|0))F=I;else break}if((H|0)==(E|0))K=F;else{I=E;while(1){L=f[h+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(F|0)>(I|0)?I:F;M=E;do{N=h+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=L}while((M|0)<(O|0));K=L}L=H;do{M=h+(L<<2)|0;F=L;L=f[M>>2]|0;f[M>>2]=K}while((L|0)<(F|0));G=K}else{L=f[y+(D<<2)>>2]|0;H=L;while(1){F=f[h+(H<<2)>>2]|0;if((F|0)<(H|0))H=F;else break}if((L|0)==(E|0))P=H;else{D=E;while(1){F=f[h+(D<<2)>>2]|0;if((F|0)<(D|0))D=F;else break}F=(H|0)>(D|0)?D:H;M=E;do{I=h+(M<<2)|0;O=M;M=f[I>>2]|0;f[I>>2]=F}while((M|0)<(O|0));P=F}F=L;do{M=h+(F<<2)|0;H=F;F=f[M>>2]|0;f[M>>2]=P}while((F|0)<(H|0));f[x+(z<<2)>>2]=P;B=A;break a}}else G=E;while(0);f[x+(z<<2)>>2]=G;B=A;break}if(C){E=z+-1|0;if(!(b[w+E>>0]|0))Q=46;else{f[x+(z<<2)>>2]=f[y+(E<<2)>>2];B=A;break}}}else if((z|0)>0)Q=46;if((Q|0)==46?(Q=0,E=z+-1|0,b[v+E>>0]|0):0){f[x+(z<<2)>>2]=f[x+(E<<2)>>2];B=A;break}f[x+(z<<2)>>2]=A;f[h+(A<<2)>>2]=A;B=A+1|0}while(0);z=z+1|0;if((z|0)==(j|0)){R=B;break}else A=B}}else R=r;s=s+1|0;if((s|0)==(i|0)){S=R;Q=81;break}else r=R}}else Q=80;else if(n){R=(j|0)>0;r=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[d+16>>2]|0;B=f[d+44>>2]|0;G=0;P=1;while(1){K=f[s>>2]|0;l=r+(Y(K,G)|0)|0;e=l+(0-K)|0;K=f[B>>2]|0;o=c+(Y(K,G)|0)|0;q=o+(0-K)|0;b:do if(R){if((G|0)>0){T=0;U=P}else{K=0;k=P;while(1){do if(!(b[l+K>>0]|0)){f[o+(K<<2)>>2]=0;V=k}else{if((K|0)>0?(m=K+-1|0,b[l+m>>0]|0):0){f[o+(K<<2)>>2]=f[o+(m<<2)>>2];V=k;break}f[o+(K<<2)>>2]=k;f[h+(k<<2)>>2]=k;V=k+1|0}while(0);K=K+1|0;if((K|0)==(j|0)){W=V;break b}else k=V}}while(1){do if(!(b[l+T>>0]|0)){f[o+(T<<2)>>2]=0;X=U}else{k=(T|0)>0;if(!(b[e+T>>0]|0)){if(k?(K=T+-1|0,b[l+K>>0]|0):0){f[o+(T<<2)>>2]=f[o+(K<<2)>>2];X=U;break}f[o+(T<<2)>>2]=U;f[h+(U<<2)>>2]=U;X=U+1|0;break}K=f[q+(T<<2)>>2]|0;if(k?(k=T+-1|0,(b[l+k>>0]|0)!=0):0){C=f[o+(k<<2)>>2]|0;k=C;while(1){m=f[h+(k<<2)>>2]|0;if((m|0)<(k|0))k=m;else break}if((C|0)==(K|0))Z=k;else{m=K;while(1){A=f[h+(m<<2)>>2]|0;if((A|0)<(m|0))m=A;else break}A=(k|0)>(m|0)?m:k;z=K;do{x=h+(z<<2)|0;v=z;z=f[x>>2]|0;f[x>>2]=A}while((z|0)<(v|0));Z=A}A=C;do{z=h+(A<<2)|0;k=A;A=f[z>>2]|0;f[z>>2]=Z}while((A|0)<(k|0));_=Z}else _=K;f[o+(T<<2)>>2]=_;X=U}while(0);T=T+1|0;if((T|0)==(j|0)){W=X;break}else U=X}}else W=P;while(0);G=G+1|0;if((G|0)==(i|0)){S=W;Q=81;break}else P=W}}else Q=80;if((Q|0)==80){ywa(g,1);$=1}else if((Q|0)==81){if((S|0)>1){Q=1;W=1;while(1){P=h+(W<<2)|0;G=f[P>>2]|0;if((G|0)<(W|0)){f[P>>2]=f[h+(G<<2)>>2];aa=Q}else{f[P>>2]=Q;aa=Q+1|0}W=W+1|0;if((W|0)==(S|0)){ba=aa;break}else Q=aa}}else ba=1;ywa(g,ba);if(n){n=f[d+16>>2]|0;aa=f[d+44>>2]|0;d=f[g+20>>2]|0;Q=f[g+48>>2]|0;S=f[g+120>>2]|0;W=0;do{P=n+(Y(f[aa>>2]|0,W)|0)|0;G=P+(j<<2)|0;if((P|0)!=(G|0)){X=((W|0)<0)<<31>>31;U=P;P=0;while(1){T=f[h+(f[U>>2]<<2)>>2]|0;f[U>>2]=T;_=d+(Y(f[Q>>2]|0,T)|0)|0;Z=f[_>>2]|0;f[_>>2]=(Z|0)>(P|0)?P:Z;Z=_+8|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(P|0)?P:V;V=_+4|0;Z=f[V>>2]|0;f[V>>2]=(Z|0)>(W|0)?W:Z;Z=_+12|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(W|0)?W:V;V=_+16|0;f[V>>2]=(f[V>>2]|0)+1;V=S+(T<<4)|0;_=V;Z=d1c(f[_>>2]|0,f[_+4>>2]|0,P|0,((P|0)<0)<<31>>31|0)|0;_=V;f[_>>2]=Z;f[_+4>>2]=J;_=S+(T<<4)+8|0;T=_;Z=d1c(f[T>>2]|0,f[T+4>>2]|0,W|0,X|0)|0;T=_;f[T>>2]=Z;f[T+4>>2]=J;U=U+4|0;if((U|0)==(G|0))break;else P=P+1|0}}W=W+1|0}while((W|0)!=(i|0));$=ba}else $=ba}ba=g+12|0;if((f[ba>>2]|0)<=0){wL(h);u=a;return $|0}i=f[g+20>>2]|0;W=f[g+48>>2]|0;S=f[g+120>>2]|0;Q=f[g+80>>2]|0;d=f[g+108>>2]|0;g=0;do{j=i+(Y(f[W>>2]|0,g)|0)|0;aa=j+8|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[j>>2]|0);aa=j+12|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[j+4>>2]|0);aa=Q+(Y(f[d>>2]|0,g)|0)|0;ca=+((f[j+16>>2]|0)>>>0);j=S+(g<<4)|0;p[aa>>3]=(+((f[j>>2]|0)>>>0)+4294967296.0*+((f[j+4>>2]|0)>>>0))/ca;j=S+(g<<4)+8|0;p[aa+8>>3]=(+((f[j>>2]|0)>>>0)+4294967296.0*+((f[j+4>>2]|0)>>>0))/ca;g=g+1|0}while((g|0)<(f[ba>>2]|0));wL(h);u=a;return $|0}function twa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+48|0;h=a+28|0;i=a+24|0;j=a;k=f[c+8>>2]|0;l=d+8|0;if((k|0)!=(f[l>>2]|0)){m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=m;o=354540;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[m+26>>0]=0;vM(-215,h,528391,354221,578)}m=f[c+12>>2]|0;r=d+12|0;if((m|0)!=(f[r>>2]|0)){s=$Xc(32)|0;f[h>>2]=s;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=s;o=354567;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[s+26>>0]=0;vM(-215,h,528391,354221,579)}switch(e|0){case 4:case 8:break;default:{s=$Xc(48)|0;f[h>>2]=s;f[h+8>>2]=-2147483600;f[h+4>>2]=38;n=s;o=354369;q=n+38|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[s+38>>0]=0;vM(-215,h,528391,354221,580)}}s=((Y(m,k)|0)+1|0)>>>1;o=vL(k<<2)|0;t=vL((s<<2)+4|0)|0;f[t>>2]=0;f[h>>2]=0;f[h+4>>2]=k;s=(k|0)/2|0;v=(i3()|0)<<2;w=(v|0)<(s|0)?v:s;x=+(((w|0)>1?w:1)|0);f[i>>2]=1;if((e|0)==8){f[j>>2]=75400;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=t;f[j+16>>2]=o;h3(h,j,x);Fwa(d,t,o);if((k|0)>0){e=(m+1|0)/2|0;w=0;do{s=w+1|0;v=(Y((s|0)/2|0,e)|0)+1|0;y=f[o+(s<<2)>>2]|0;s=y+v|0;if((y|0)>0){y=v;do{v=t+(y<<2)|0;z=f[v>>2]|0;if((z|0)<(y|0))f[v>>2]=f[t+(z<<2)>>2];else{f[v>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}y=y+1|0}while((y|0)<(s|0))}w=f[o+(w<<2)>>2]|0}while((w|0)<(k|0))}}else{f[j>>2]=75420;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=t;f[j+16>>2]=o;h3(h,j,x);c=f[r>>2]|0;r=f[l>>2]|0;w=f[o>>2]|0;a:do if((w|0)<(r|0)){e=f[d+16>>2]|0;s=f[d+44>>2]|0;if((c|0)>0)A=w;else{y=w;while(1){y=f[o+(y<<2)>>2]|0;if((y|0)>=(r|0))break a}}do{y=f[s>>2]|0;v=e+(Y(y,A)|0)|0;z=v+(0-y)|0;y=0;do{B=v+(y<<2)|0;C=f[B>>2]|0;if((C|0)>0?(D=f[z+(y<<2)>>2]|0,(D|0)>0):0){E=D;while(1){F=f[t+(E<<2)>>2]|0;if((F|0)<(E|0))E=F;else break}if((D|0)==(C|0))G=E;else{F=C;while(1){H=f[t+(F<<2)>>2]|0;if((H|0)<(F|0))F=H;else break}H=(E|0)>(F|0)?F:E;I=C;do{K=t+(I<<2)|0;L=I;I=f[K>>2]|0;f[K>>2]=H}while((I|0)<(L|0));G=H}H=D;do{I=t+(H<<2)|0;C=H;H=f[I>>2]|0;f[I>>2]=G}while((H|0)<(C|0));f[B>>2]=G}y=y+1|0}while((y|0)!=(c|0));A=f[o+(A<<2)>>2]|0}while((A|0)<(r|0))}while(0);if((k|0)>0){r=0;do{A=(((Y(r,m)|0)+1|0)/2|0)+1|0;c=f[o+(r+1<<2)>>2]|0;G=c+A|0;if((c|0)>0){c=A;do{A=t+(c<<2)|0;w=f[A>>2]|0;if((w|0)<(c|0))f[A>>2]=f[t+(w<<2)>>2];else{f[A>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(G|0))}r=f[o+(r<<2)>>2]|0}while((r|0)<(k|0))}}r=k*136|0;m=bYc(k>>>0>31580641|r>>>0>4294967291?-1:r+4|0)|0;f[m>>2]=k;r=m+4|0;if(k|0){G=r+(k*136|0)|0;k=r;do{f[k>>2]=0;f[k+4>>2]=1124007936;c=k+12|0;A=k+44|0;n=k+8|0;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[A>>2]=c;w=k+52|0;f[k+48>>2]=w;f[w>>2]=0;f[k+56>>2]=0;f[k+60>>2]=0;f[k+64>>2]=1124007936;w=k+72|0;e=k+104|0;n=k+68|0;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[e>>2]=w;c=k+112|0;f[k+108>>2]=c;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;k=k+136|0}while((k|0)!=(G|0))}ywa(g,f[i>>2]|0);f[j>>2]=75440;f[j+4>>2]=d;f[j+8>>2]=t;f[j+12>>2]=g;f[j+16>>2]=r;f[j+20>>2]=i;h3(h,j,x);j=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(j|0)){h=g+20|0;d=g+48|0;G=g+120|0;k=l;l=f[i>>2]|0;while(1){if((l|0)>0){n=r+(k*136|0)+120|0;q=f[r+(k*136|0)+20>>2]|0;c=f[r+(k*136|0)+48>>2]|0;A=0;s=l;while(1){y=q+(Y(f[c>>2]|0,A)|0)|0;z=y+16|0;if((f[z>>2]|0)>0){v=(f[h>>2]|0)+(Y(f[f[d>>2]>>2]|0,A)|0)|0;H=f[v>>2]|0;D=f[y>>2]|0;f[v>>2]=(H|0)>(D|0)?D:H;H=v+8|0;f[H>>2]=f[((f[H>>2]|0)<(f[y+8>>2]|0)?y:v)+8>>2];H=v+4|0;f[H>>2]=f[((f[H>>2]|0)>(f[y+4>>2]|0)?y:v)+4>>2];H=v+12|0;f[H>>2]=f[((f[H>>2]|0)<(f[y+12>>2]|0)?y:v)+12>>2];y=v+16|0;f[y>>2]=(f[y>>2]|0)+(f[z>>2]|0);z=f[n>>2]|0;y=z+(A<<4)|0;v=f[G>>2]|0;H=v+(A<<4)|0;D=H;C=d1c(f[D>>2]|0,f[D+4>>2]|0,f[y>>2]|0,f[y+4>>2]|0)|0;y=H;f[y>>2]=C;f[y+4>>2]=J;y=z+(A<<4)+8|0;z=v+(A<<4)+8|0;v=z;C=d1c(f[v>>2]|0,f[v+4>>2]|0,f[y>>2]|0,f[y+4>>2]|0)|0;y=z;f[y>>2]=C;f[y+4>>2]=J;M=f[i>>2]|0}else M=s;A=A+1|0;if((A|0)>=(M|0)){N=M;break}else s=M}}else N=l;k=f[r+(k*136|0)+132>>2]|0;if((k|0)>=(j|0))break;else l=N}}N=g+12|0;if((f[N>>2]|0)>0){l=f[g+20>>2]|0;j=f[g+48>>2]|0;k=f[g+120>>2]|0;M=f[g+80>>2]|0;G=f[g+108>>2]|0;g=0;do{d=l+(Y(f[j>>2]|0,g)|0)|0;h=d+8|0;f[h>>2]=(f[h>>2]|0)+1-(f[d>>2]|0);h=d+12|0;f[h>>2]=(f[h>>2]|0)+1-(f[d+4>>2]|0);h=M+(Y(f[G>>2]|0,g)|0)|0;x=+((f[d+16>>2]|0)>>>0);d=k+(g<<4)|0;p[h>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/x;d=k+(g<<4)+8|0;p[h+8>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/x;g=g+1|0}while((g|0)<(f[N>>2]|0))}N=r+((f[m>>2]|0)*136|0)|0;if((r|0)==(N|0)){dYc(m);wL(o);wL(t);O=f[i>>2]|0;u=a;return O|0}else P=N;do{P=P+-136|0;qwa(P)}while((P|0)!=(r|0));dYc(m);wL(o);wL(t);O=f[i>>2]|0;u=a;return O|0}function uwa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0.0;a=u;u=u+16|0;i=a;k=f[c+8>>2]|0;l=e+8|0;if((k|0)!=(f[l>>2]|0)){m=$Xc(32)|0;f[i>>2]=m;f[i+8>>2]=-2147483616;f[i+4>>2]=26;n=m;o=354540;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[m+26>>0]=0;vM(-215,i,528391,354221,2589)}m=f[c+12>>2]|0;r=e+12|0;if((m|0)!=(f[r>>2]|0)){s=$Xc(32)|0;f[i>>2]=s;f[i+8>>2]=-2147483616;f[i+4>>2]=26;n=s;o=354567;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[s+26>>0]=0;vM(-215,i,528391,354221,2590)}if((g|0)!=8){g=$Xc(32)|0;f[i>>2]=g;f[i+8>>2]=-2147483616;f[i+4>>2]=17;n=g;o=354594;q=n+17|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[g+17>>0]=0;vM(-215,i,528391,354221,2591)}i=vL((Y(((k+1|0)/2|0)<<1,(m+1|0)/2|0)|0)+2|0)|0;d[i>>1]=0;if((k|0)>0){g=c+16|0;o=c+44|0;n=e+16|0;q=e+44|0;s=(m|0)>0;t=1;v=0;while(1){w=f[f[o>>2]>>2]|0;x=(f[g>>2]|0)+(Y(w,v)|0)|0;y=0-w|0;z=x+y|0;A=z+y|0;y=x+w|0;w=f[f[q>>2]>>2]|0;B=(f[n>>2]|0)+(Y(w,v)|0)|0;C=0-w|0;w=B+C+C|0;if(s){C=(v|1|0)<(k|0);D=(v|0)>0;E=D^1;F=(v+-2|0)>-1;G=0;H=t;while(1){a:do if(!(b[x+G>>0]|0)){I=G|1;K=(I|0)<(m|0);if(C?b[y+G>>0]|0:0){L=G+-1|0;M=(G|0)>0;if(K?b[x+I>>0]|0:0){do if(M){if(b[x+L>>0]|0){do if(D){if(b[z+I>>0]|0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;O=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}do if((O|0)>-1){if(!(b[z+O>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}P=d[w+(G<<1)>>1]|0;Q=d[B+(O<<1)>>1]|0;R=P;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(P<<16>>16==Q<<16>>16)T=R;else{S=Q;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;V=Q;do{W=i+((V&65535)<<1)|0;X=V;V=d[W>>1]|0;d[W>>1]=U}while((V&65535)<(X&65535));T=U}U=P;do{V=i+((U&65535)<<1)|0;Q=U;U=d[V>>1]|0;d[V>>1]=T}while((U&65535)<(Q&65535));d[B+(G<<1)>>1]=T;N=H;break a}while(0);U=d[w+(G<<1)>>1]|0;P=d[B+(O<<1)>>1]|0;Q=U;while(1){V=d[i+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(U<<16>>16==P<<16>>16)Z=Q;else{O=P;while(1){V=d[i+((O&65535)<<1)>>1]|0;if((V&65535)<(O&65535))O=V;else break}V=(Q&65535)>(O&65535)?O:Q;R=P;do{S=i+((R&65535)<<1)|0;X=R;R=d[S>>1]|0;d[S>>1]=V}while((R&65535)<(X&65535));Z=V}V=U;do{R=i+((V&65535)<<1)|0;P=V;V=d[R>>1]|0;d[R>>1]=Z}while((V&65535)<(P&65535));d[B+(G<<1)>>1]=Z;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;P=V;while(1){R=d[i+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(V<<16>>16==U<<16>>16)_=P;else{R=U;while(1){Q=d[i+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(P&65535)>(R&65535)?R:P;O=U;do{X=i+((O&65535)<<1)|0;S=O;O=d[X>>1]|0;d[X>>1]=Q}while((O&65535)<(S&65535));_=Q}Q=V;do{O=i+((Q&65535)<<1)|0;U=Q;Q=d[O>>1]|0;d[O>>1]=_}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=_;N=H;break a}Q=G+2|0;if((Q|0)>=(m|0))break;if(!(b[z+Q>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){V=d[w+(Q<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;O=V;while(1){P=d[i+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(V<<16>>16==U<<16>>16)$=O;else{P=U;while(1){R=d[i+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=U;do{X=i+((S&65535)<<1)|0;W=S;S=d[X>>1]|0;d[X>>1]=R}while((S&65535)<(W&65535));$=R}R=V;do{S=i+((R&65535)<<1)|0;U=R;R=d[S>>1]|0;d[S>>1]=$}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=$;N=H;break a}R=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}V=d[w+(Q<<1)>>1]|0;U=d[B+(R<<1)>>1]|0;S=V;while(1){O=d[i+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(V<<16>>16==U<<16>>16)aa=S;else{O=U;while(1){P=d[i+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(S&65535)>(O&65535)?O:S;W=U;do{X=i+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(ba&65535));aa=P}P=V;do{W=i+((P&65535)<<1)|0;U=P;P=d[W>>1]|0;d[W>>1]=aa}while((P&65535)<(U&65535));d[B+(G<<1)>>1]=aa;N=H;break a}while(0);P=d[w+(Q<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;U=P;while(1){W=d[i+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(P<<16>>16==V<<16>>16)ca=U;else{R=V;while(1){W=d[i+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}W=(U&65535)>(R&65535)?R:U;S=V;do{O=i+((S&65535)<<1)|0;ba=S;S=d[O>>1]|0;d[O>>1]=W}while((S&65535)<(ba&65535));ca=W}W=P;do{S=i+((W&65535)<<1)|0;V=W;W=d[S>>1]|0;d[S>>1]=ca}while((W&65535)<(V&65535));d[B+(G<<1)>>1]=ca;N=H;break a}while(0);W=d[w+(Q<<1)>>1]|0;P=d[B+(G+-2<<1)>>1]|0;V=W;while(1){S=d[i+((V&65535)<<1)>>1]|0;if((S&65535)<(V&65535))V=S;else break}if(W<<16>>16==P<<16>>16)da=V;else{Q=P;while(1){S=d[i+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}S=(V&65535)>(Q&65535)?Q:V;U=P;do{R=i+((U&65535)<<1)|0;ba=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(ba&65535));da=S}S=W;do{U=i+((S&65535)<<1)|0;P=S;S=d[U>>1]|0;d[U>>1]=da}while((S&65535)<(P&65535));d[B+(G<<1)>>1]=da;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[y+L>>0]|0))break;do if(D){if(b[z+I>>0]|0){S=G+-2|0;do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=W;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;U=P;while(1){V=d[i+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}if(P<<16>>16==W<<16>>16)ea=U;else{V=W;while(1){Q=d[i+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}Q=(U&65535)>(V&65535)?V:U;ba=W;do{R=i+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=Q}while((ba&65535)<(O&65535));ea=Q}Q=P;do{ba=i+((Q&65535)<<1)|0;W=Q;Q=d[ba>>1]|0;d[ba>>1]=ea}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=ea;N=H;break a}if(!(b[z+S>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(S<<1)>>1]|0;W=Q;while(1){ba=d[i+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(Q<<16>>16==P<<16>>16)fa=W;else{ba=P;while(1){U=d[i+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(W&65535)>(ba&65535)?ba:W;V=P;do{O=i+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=U}while((V&65535)<(R&65535));fa=U}U=Q;do{V=i+((U&65535)<<1)|0;P=U;U=d[V>>1]|0;d[V>>1]=fa}while((U&65535)<(P&65535));d[B+(G<<1)>>1]=fa;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;U=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){V=d[i+((P&65535)<<1)>>1]|0;if((V&65535)<(P&65535))P=V;else break}if(Q<<16>>16==U<<16>>16)ga=P;else{V=U;while(1){W=d[i+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}W=(P&65535)>(V&65535)?V:P;ba=U;do{R=i+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=W}while((ba&65535)<(O&65535));ga=W}W=Q;do{ba=i+((W&65535)<<1)|0;U=W;W=d[ba>>1]|0;d[ba>>1]=ga}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=ga;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=W;while(1){ba=d[i+((U&65535)<<1)>>1]|0;if((ba&65535)<(U&65535))U=ba;else break}if(W<<16>>16==Q<<16>>16)ha=U;else{ba=Q;while(1){P=d[i+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(U&65535)>(ba&65535)?ba:U;V=Q;do{O=i+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=P}while((V&65535)<(R&65535));ha=P}P=W;do{V=i+((P&65535)<<1)|0;Q=P;P=d[V>>1]|0;d[V>>1]=ha}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=ha;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;W=d[B+(S<<1)>>1]|0;Q=P;while(1){V=d[i+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(P<<16>>16==W<<16>>16)ia=Q;else{S=W;while(1){V=d[i+((S&65535)<<1)>>1]|0;if((V&65535)<(S&65535))S=V;else break}V=(Q&65535)>(S&65535)?S:Q;U=W;do{ba=i+((U&65535)<<1)|0;R=U;U=d[ba>>1]|0;d[ba>>1]=V}while((U&65535)<(R&65535));ia=V}V=P;do{U=i+((V&65535)<<1)|0;W=V;V=d[U>>1]|0;d[U>>1]=ia}while((V&65535)<(W&65535));d[B+(G<<1)>>1]=ia;N=H;break a}V=G+2|0;do if(!((V|0)>=(m|0)|E)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}U=d[w+(V<<1)>>1]|0;Q=U;while(1){S=d[i+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}if(U<<16>>16==W<<16>>16)ja=Q;else{S=W;while(1){R=d[i+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}R=(Q&65535)>(S&65535)?S:Q;ba=W;do{O=i+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=R}while((ba&65535)<(X&65535));ja=R}R=U;do{ba=i+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=ja}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=ja;N=H;break a}if(!(b[z+P>>0]|0)){R=d[w+(V<<1)>>1]|0;U=d[B+(P<<1)>>1]|0;W=R;while(1){ba=d[i+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(R<<16>>16==U<<16>>16)ka=W;else{ba=U;while(1){Q=d[i+((ba&65535)<<1)>>1]|0;if((Q&65535)<(ba&65535))ba=Q;else break}Q=(W&65535)>(ba&65535)?ba:W;S=U;do{X=i+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=Q}while((S&65535)<(O&65535));ka=Q}Q=R;do{S=i+((Q&65535)<<1)|0;U=Q;Q=d[S>>1]|0;d[S>>1]=ka}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=ka;N=H;break a}if(!(b[A+L>>0]|0)){Q=d[w+(V<<1)>>1]|0;R=d[B+(P<<1)>>1]|0;U=Q;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}if(Q<<16>>16==R<<16>>16)la=U;else{S=R;while(1){W=d[i+((S&65535)<<1)>>1]|0;if((W&65535)<(S&65535))S=W;else break}W=(U&65535)>(S&65535)?S:U;ba=R;do{O=i+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=W}while((ba&65535)<(X&65535));la=W}W=Q;do{ba=i+((W&65535)<<1)|0;R=W;W=d[ba>>1]|0;d[ba>>1]=la}while((W&65535)<(R&65535));d[B+(G<<1)>>1]=la;N=H;break a}W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}Q=d[w+(V<<1)>>1]|0;R=Q;while(1){ba=d[i+((R&65535)<<1)>>1]|0;if((ba&65535)<(R&65535))R=ba;else break}if(Q<<16>>16==W<<16>>16)ma=R;else{ba=W;while(1){U=d[i+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(R&65535)>(ba&65535)?ba:R;S=W;do{X=i+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=U}while((S&65535)<(O&65535));ma=U}U=Q;do{S=i+((U&65535)<<1)|0;W=U;U=d[S>>1]|0;d[S>>1]=ma}while((U&65535)<(W&65535));d[B+(G<<1)>>1]=ma;N=H;break a}while(0);U=d[w+(V<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;W=U;while(1){S=d[i+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}if(U<<16>>16==Q<<16>>16)na=W;else{P=Q;while(1){S=d[i+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(W&65535)>(P&65535)?P:W;R=Q;do{ba=i+((R&65535)<<1)|0;O=R;R=d[ba>>1]|0;d[ba>>1]=S}while((R&65535)<(O&65535));na=S}S=U;do{R=i+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=na}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=na;N=H;break a}while(0);S=G+-2|0;if(!(b[z+G>>0]|0)){U=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;R=U;while(1){W=d[i+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}if(U<<16>>16==Q<<16>>16)oa=R;else{W=Q;while(1){P=d[i+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(R&65535)>(W&65535)?W:R;O=Q;do{ba=i+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=P}while((O&65535)<(X&65535));oa=P}P=U;do{O=i+((P&65535)<<1)|0;Q=P;P=d[O>>1]|0;d[O>>1]=oa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=oa;N=H;break a}do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){P=d[w+(V<<1)>>1]|0;U=d[B+(S<<1)>>1]|0;Q=P;while(1){O=d[i+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}if(P<<16>>16==U<<16>>16)pa=Q;else{O=U;while(1){R=d[i+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(Q&65535)>(O&65535)?O:Q;W=U;do{X=i+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=R}while((W&65535)<(ba&65535));pa=R}R=P;do{W=i+((R&65535)<<1)|0;U=R;R=d[W>>1]|0;d[W>>1]=pa}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=pa;N=H;break a}if(!(b[z+S>>0]|0)){R=d[w+(G<<1)>>1]|0;P=d[w+(V<<1)>>1]|0;U=R;while(1){W=d[i+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(R<<16>>16==P<<16>>16)qa=U;else{W=P;while(1){Q=d[i+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(U&65535)>(W&65535)?W:U;O=P;do{ba=i+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=Q}while((O&65535)<(X&65535));qa=Q}Q=R;do{O=i+((Q&65535)<<1)|0;P=Q;Q=d[O>>1]|0;d[O>>1]=qa}while((Q&65535)<(P&65535));Q=d[B+(S<<1)>>1]|0;R=qa;while(1){P=d[i+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(qa<<16>>16==Q<<16>>16)ra=R;else{P=Q;while(1){O=d[i+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(R&65535)>(P&65535)?P:R;U=Q;do{W=i+((U&65535)<<1)|0;X=U;U=d[W>>1]|0;d[W>>1]=O}while((U&65535)<(X&65535));ra=O}O=qa;do{U=i+((O&65535)<<1)|0;Q=O;O=d[U>>1]|0;d[U>>1]=ra}while((O&65535)<(Q&65535));d[B+(G<<1)>>1]=ra;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;O=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=O;while(1){R=d[i+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(O<<16>>16==Q<<16>>16)sa=U;else{R=Q;while(1){P=d[i+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(U&65535)>(R&65535)?R:U;X=Q;do{W=i+((X&65535)<<1)|0;ba=X;X=d[W>>1]|0;d[W>>1]=P}while((X&65535)<(ba&65535));sa=P}P=O;do{X=i+((P&65535)<<1)|0;Q=P;P=d[X>>1]|0;d[X>>1]=sa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=sa;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=d[w+(V<<1)>>1]|0;Q=P;while(1){X=d[i+((Q&65535)<<1)>>1]|0;if((X&65535)<(Q&65535))Q=X;else break}if(P<<16>>16==O<<16>>16)ta=Q;else{X=O;while(1){U=d[i+((X&65535)<<1)>>1]|0;if((U&65535)<(X&65535))X=U;else break}U=(Q&65535)>(X&65535)?X:Q;R=O;do{ba=i+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=U}while((R&65535)<(W&65535));ta=U}U=P;do{R=i+((U&65535)<<1)|0;O=U;U=d[R>>1]|0;d[R>>1]=ta}while((U&65535)<(O&65535));U=d[B+(S<<1)>>1]|0;P=ta;while(1){O=d[i+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(ta<<16>>16==U<<16>>16)ua=P;else{O=U;while(1){R=d[i+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(P&65535)>(O&65535)?O:P;Q=U;do{X=i+((Q&65535)<<1)|0;W=Q;Q=d[X>>1]|0;d[X>>1]=R}while((Q&65535)<(W&65535));ua=R}R=ta;do{Q=i+((R&65535)<<1)|0;U=R;R=d[Q>>1]|0;d[Q>>1]=ua}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=ua;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;U=d[w+(V<<1)>>1]|0;Q=R;while(1){P=d[i+((Q&65535)<<1)>>1]|0;if((P&65535)<(Q&65535))Q=P;else break}if(R<<16>>16==U<<16>>16)va=Q;else{P=U;while(1){O=d[i+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(Q&65535)>(P&65535)?P:Q;W=U;do{X=i+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(ba&65535));va=O}O=R;do{W=i+((O&65535)<<1)|0;U=O;O=d[W>>1]|0;d[W>>1]=va}while((O&65535)<(U&65535));O=d[B+(S<<1)>>1]|0;R=va;while(1){U=d[i+((R&65535)<<1)>>1]|0;if((U&65535)<(R&65535))R=U;else break}if(va<<16>>16==O<<16>>16)wa=R;else{S=O;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;W=O;do{Q=i+((W&65535)<<1)|0;P=W;W=d[Q>>1]|0;d[Q>>1]=U}while((W&65535)<(P&65535));wa=U}U=va;do{W=i+((U&65535)<<1)|0;O=U;U=d[W>>1]|0;d[W>>1]=wa}while((U&65535)<(O&65535));d[B+(G<<1)>>1]=wa;N=H;break a}while(0);V=G+-2|0;if(!(b[z+G>>0]|0)){xa=V;break}do if((V|0)>-1){if(!(b[x+V>>0]|0))break;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}if(!(b[z+V>>0]|0)){U=d[w+(G<<1)>>1]|0;O=d[B+(V<<1)>>1]|0;W=U;while(1){R=d[i+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(U<<16>>16==O<<16>>16)ya=W;else{R=O;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(W&65535)>(R&65535)?R:W;P=O;do{Q=i+((P&65535)<<1)|0;ba=P;P=d[Q>>1]|0;d[Q>>1]=S}while((P&65535)<(ba&65535));ya=S}S=U;do{P=i+((S&65535)<<1)|0;O=S;S=d[P>>1]|0;d[P>>1]=ya}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=ya;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;U=d[B+(V<<1)>>1]|0;O=S;while(1){P=d[i+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(S<<16>>16==U<<16>>16)za=O;else{P=U;while(1){W=d[i+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}W=(O&65535)>(P&65535)?P:O;R=U;do{ba=i+((R&65535)<<1)|0;Q=R;R=d[ba>>1]|0;d[ba>>1]=W}while((R&65535)<(Q&65535));za=W}W=S;do{R=i+((W&65535)<<1)|0;U=W;W=d[R>>1]|0;d[R>>1]=za}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=za;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[B+(V<<1)>>1]|0;U=W;while(1){R=d[i+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(W<<16>>16==S<<16>>16)Aa=U;else{V=S;while(1){R=d[i+((V&65535)<<1)>>1]|0;if((R&65535)<(V&65535))V=R;else break}R=(U&65535)>(V&65535)?V:U;O=S;do{P=i+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=R}while((O&65535)<(Q&65535));Aa=R}R=W;do{O=i+((R&65535)<<1)|0;S=R;R=d[O>>1]|0;d[O>>1]=Aa}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=Aa;N=H;break a}else xa=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(xa<<1)>>1]|0;N=H;break a}while(0);do if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(m|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[w+(R<<1)>>1]|0;O=W;while(1){U=d[i+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(W<<16>>16==S<<16>>16)Ba=O;else{U=S;while(1){V=d[i+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}V=(O&65535)>(U&65535)?U:O;Q=S;do{P=i+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=V}while((Q&65535)<(ba&65535));Ba=V}V=W;do{Q=i+((V&65535)<<1)|0;S=V;V=d[Q>>1]|0;d[Q>>1]=Ba}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Ba;N=H;break a}while(0);if(!(b[z+G>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break}if(M){if(b[y+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(b[x+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}}d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break}do if(K){if(!(b[x+I>>0]|0)){if(!C)break;if(!(b[y+I>>0]|0))break;d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break a}if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(m|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;W=d[w+(R<<1)>>1]|0;S=V;while(1){Q=d[i+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(V<<16>>16==W<<16>>16)Ca=S;else{Q=W;while(1){O=d[i+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}O=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=i+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=O}while((U&65535)<(P&65535));Ca=O}O=V;do{U=i+((O&65535)<<1)|0;W=O;O=d[U>>1]|0;d[U>>1]=Ca}while((O&65535)<(W&65535));d[B+(G<<1)>>1]=Ca;N=H;break a}while(0);if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}}d[B+(G<<1)>>1]=H;R=H&65535;d[i+(R<<1)>>1]=H;N=R+1&65535;break a}while(0);d[B+(G<<1)>>1]=0;N=H}else{I=G+-1|0;K=(G|0)>0;if(K){if(b[x+I>>0]|0){L=G|1;M=(L|0)<(m|0);if(D&M?b[z+L>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;R=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}O=d[w+(G<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;W=O;while(1){U=d[i+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(O<<16>>16==V<<16>>16)Da=W;else{U=V;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=V;do{P=i+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=S}while((Q&65535)<(ba&65535));Da=S}S=O;do{Q=i+((S&65535)<<1)|0;V=S;S=d[Q>>1]|0;d[Q>>1]=Da}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=Da;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;O=d[B+(R<<1)>>1]|0;V=S;while(1){Q=d[i+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}if(S<<16>>16==O<<16>>16)Ea=V;else{R=O;while(1){Q=d[i+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(V&65535)>(R&65535)?R:V;W=O;do{U=i+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));Ea=Q}Q=S;do{W=i+((Q&65535)<<1)|0;O=Q;Q=d[W>>1]|0;d[W>>1]=Ea}while((Q&65535)<(O&65535));d[B+(G<<1)>>1]=Ea;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;O=Q;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(Q<<16>>16==S<<16>>16)Fa=O;else{W=S;while(1){V=d[i+((W&65535)<<1)>>1]|0;if((V&65535)<(W&65535))W=V;else break}V=(O&65535)>(W&65535)?W:O;R=S;do{ba=i+((R&65535)<<1)|0;U=R;R=d[ba>>1]|0;d[ba>>1]=V}while((R&65535)<(U&65535));Fa=V}V=Q;do{R=i+((V&65535)<<1)|0;S=V;V=d[R>>1]|0;d[R>>1]=Fa}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Fa;N=H;break}if(M?b[x+L>>0]|0:0){V=G+2|0;do if(D&(V|0)<(m|0)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+L>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){Q=d[w+(V<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;R=Q;while(1){O=d[i+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(Q<<16>>16==S<<16>>16)Ga=R;else{O=S;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}W=(R&65535)>(O&65535)?O:R;U=S;do{ba=i+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=W}while((U&65535)<(P&65535));Ga=W}W=Q;do{U=i+((W&65535)<<1)|0;S=W;W=d[U>>1]|0;d[U>>1]=Ga}while((W&65535)<(S&65535));d[B+(G<<1)>>1]=Ga;N=H;break a}W=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}do if((W|0)>-1){if(!(b[z+W>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}Q=d[w+(V<<1)>>1]|0;S=d[B+(W<<1)>>1]|0;U=Q;while(1){R=d[i+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(Q<<16>>16==S<<16>>16)Ha=U;else{R=S;while(1){O=d[i+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}O=(U&65535)>(R&65535)?R:U;P=S;do{ba=i+((P&65535)<<1)|0;X=P;P=d[ba>>1]|0;d[ba>>1]=O}while((P&65535)<(X&65535));Ha=O}O=Q;do{P=i+((O&65535)<<1)|0;S=O;O=d[P>>1]|0;d[P>>1]=Ha}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Ha;N=H;break a}while(0);O=d[w+(V<<1)>>1]|0;Q=d[B+(W<<1)>>1]|0;S=O;while(1){P=d[i+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(O<<16>>16==Q<<16>>16)Ia=S;else{W=Q;while(1){P=d[i+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(S&65535)>(W&65535)?W:S;U=Q;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=P}while((U&65535)<(X&65535));Ia=P}P=O;do{U=i+((P&65535)<<1)|0;Q=P;P=d[U>>1]|0;d[U>>1]=Ia}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Ia;N=H;break a}while(0);P=d[w+(V<<1)>>1]|0;O=d[B+(G+-2<<1)>>1]|0;Q=P;while(1){U=d[i+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(P<<16>>16==O<<16>>16)Ja=Q;else{U=O;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(Q&65535)>(U&65535)?U:Q;W=O;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=S}while((W&65535)<(R&65535));Ja=S}S=P;do{W=i+((S&65535)<<1)|0;O=S;S=d[W>>1]|0;d[W>>1]=Ja}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ja;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(C?b[y+I>>0]|0:0){V=G|1;L=(V|0)<(m|0);if(!(E|L^1)?b[z+V>>0]|0:0){M=G+-2|0;do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[z+I>>0]|0){S=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=S;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=P;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(P<<16>>16==S<<16>>16)Ka=O;else{W=S;while(1){Q=d[i+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(O&65535)>(W&65535)?W:O;U=S;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=Q}while((U&65535)<(X&65535));Ka=Q}Q=P;do{U=i+((Q&65535)<<1)|0;S=Q;Q=d[U>>1]|0;d[U>>1]=Ka}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Ka;N=H;break a}if(!(b[z+M>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(M<<1)>>1]|0;S=Q;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(Q<<16>>16==P<<16>>16)La=S;else{U=P;while(1){O=d[i+((U&65535)<<1)>>1]|0;if((O&65535)<(U&65535))U=O;else break}O=(S&65535)>(U&65535)?U:S;W=P;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(R&65535));La=O}O=Q;do{W=i+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=La}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=La;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;O=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){W=d[i+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(Q<<16>>16==O<<16>>16)Ma=P;else{W=O;while(1){S=d[i+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=O;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Ma=S}S=Q;do{U=i+((S&65535)<<1)|0;O=S;S=d[U>>1]|0;d[U>>1]=Ma}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ma;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;Q=d[B+(M<<1)>>1]|0;O=S;while(1){U=d[i+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(S<<16>>16==Q<<16>>16)Na=O;else{U=Q;while(1){P=d[i+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(O&65535)>(U&65535)?U:O;W=Q;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Na=P}P=S;do{W=i+((P&65535)<<1)|0;Q=P;P=d[W>>1]|0;d[W>>1]=Na}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Na;N=H;break a}while(0);if(b[z+G>>0]|0){P=d[w+(G<<1)>>1]|0;S=d[B+(M<<1)>>1]|0;Q=P;while(1){W=d[i+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(P<<16>>16==S<<16>>16)Oa=Q;else{W=S;while(1){O=d[i+((W&65535)<<1)>>1]|0;if((O&65535)<(W&65535))W=O;else break}O=(Q&65535)>(W&65535)?W:Q;U=S;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=O}while((U&65535)<(X&65535));Oa=O}O=P;do{U=i+((O&65535)<<1)|0;S=O;O=d[U>>1]|0;d[U>>1]=Oa}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Oa;N=H;break}O=d[w+(G<<1)>>1]|0;if(!(b[z+I>>0]|0)){P=d[B+(M<<1)>>1]|0;S=O;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(O<<16>>16==P<<16>>16)Pa=S;else{U=P;while(1){Q=d[i+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(S&65535)>(U&65535)?U:S;W=P;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=Q}while((W&65535)<(R&65535));Pa=Q}Q=O;do{W=i+((Q&65535)<<1)|0;P=Q;Q=d[W>>1]|0;d[W>>1]=Pa}while((Q&65535)<(P&65535));d[B+(G<<1)>>1]=Pa;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;Q=d[B+(M<<1)>>1]|0;P=O;while(1){W=d[i+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(O<<16>>16==Q<<16>>16)Qa=P;else{W=Q;while(1){S=d[i+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=Q;do{R=i+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Qa=S}S=O;do{U=i+((S&65535)<<1)|0;Q=S;S=d[U>>1]|0;d[U>>1]=Qa}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=Qa;N=H;break a}while(0);S=d[w+(M<<1)>>1]|0;Q=S;while(1){U=d[i+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(S<<16>>16==O<<16>>16)Ra=Q;else{U=O;while(1){P=d[i+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(Q&65535)>(U&65535)?U:Q;W=O;do{X=i+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Ra=P}P=S;do{W=i+((P&65535)<<1)|0;O=P;P=d[W>>1]|0;d[W>>1]=Ra}while((P&65535)<(O&65535));P=d[B+(M<<1)>>1]|0;S=Ra;while(1){O=d[i+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(Ra<<16>>16==P<<16>>16)Sa=S;else{M=P;while(1){O=d[i+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(S&65535)>(M&65535)?M:S;W=P;do{Q=i+((W&65535)<<1)|0;U=W;W=d[Q>>1]|0;d[Q>>1]=O}while((W&65535)<(U&65535));Sa=O}O=Ra;do{W=i+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=Sa}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=Sa;N=H;break}if(L?b[x+V>>0]|0:0){O=G+2|0;do if(!((O|0)>=(m|0)|E)){if(!(b[z+O>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+I>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}S=d[w+(O<<1)>>1]|0;M=S;while(1){U=d[i+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(S<<16>>16==W<<16>>16)Ta=M;else{U=W;while(1){Q=d[i+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=W;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Ta=Q}Q=S;do{R=i+((Q&65535)<<1)|0;W=Q;Q=d[R>>1]|0;d[R>>1]=Ta}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=Ta;N=H;break a}while(0);Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[i+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)Ua=W;else{R=S;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;U=S;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ua=M}M=Q;do{U=i+((M&65535)<<1)|0;S=M;M=d[U>>1]|0;d[U>>1]=Ua}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=Ua;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;if(!(b[z+P>>0]|0)){M=d[w+(O<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;S=M;while(1){U=d[i+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(M<<16>>16==Q<<16>>16)Va=S;else{U=Q;while(1){W=d[i+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}W=(S&65535)>(U&65535)?U:S;R=Q;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(ba&65535));Va=W}W=M;do{R=i+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=Va}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=Va;N=H;break a}if(!(b[A+I>>0]|0)){W=d[w+(O<<1)>>1]|0;M=d[B+(P<<1)>>1]|0;Q=W;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)Wa=Q;else{R=M;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;U=M;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=S}while((U&65535)<(X&65535));Wa=S}S=W;do{U=i+((S&65535)<<1)|0;M=S;S=d[U>>1]|0;d[U>>1]=Wa}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=Wa;N=H;break a}S=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}W=d[w+(O<<1)>>1]|0;M=W;while(1){U=d[i+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(W<<16>>16==S<<16>>16)Xa=M;else{U=S;while(1){Q=d[i+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=S;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Xa=Q}Q=W;do{R=i+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=Xa}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Xa;N=H;break a}while(0);if(!(b[z+G>>0]|0)){Q=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=Q;while(1){R=d[i+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}if(Q<<16>>16==W<<16>>16)Ya=S;else{R=W;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(S&65535)>(R&65535)?R:S;U=W;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ya=M}M=Q;do{U=i+((M&65535)<<1)|0;W=M;M=d[U>>1]|0;d[U>>1]=Ya}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=Ya;N=H;break a}if(!(b[z+P>>0]|0)){M=d[w+(G<<1)>>1]|0;Q=d[w+(O<<1)>>1]|0;W=M;while(1){U=d[i+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(M<<16>>16==Q<<16>>16)Za=W;else{U=Q;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;R=Q;do{X=i+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=S}while((R&65535)<(ba&65535));Za=S}S=M;do{R=i+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=Za}while((S&65535)<(Q&65535));S=d[B+(P<<1)>>1]|0;M=Za;while(1){Q=d[i+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}if(Za<<16>>16==S<<16>>16)_a=M;else{Q=S;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(M&65535)>(Q&65535)?Q:M;W=S;do{U=i+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=R}while((W&65535)<(ba&65535));_a=R}R=Za;do{W=i+((R&65535)<<1)|0;S=R;R=d[W>>1]|0;d[W>>1]=_a}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=_a;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;R=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=R;while(1){M=d[i+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(R<<16>>16==S<<16>>16)$a=W;else{M=S;while(1){Q=d[i+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(W&65535)>(M&65535)?M:W;ba=S;do{U=i+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=Q}while((ba&65535)<(X&65535));$a=Q}Q=R;do{ba=i+((Q&65535)<<1)|0;S=Q;Q=d[ba>>1]|0;d[ba>>1]=$a}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=$a;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;R=d[w+(O<<1)>>1]|0;S=Q;while(1){ba=d[i+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(Q<<16>>16==R<<16>>16)ab=S;else{ba=R;while(1){W=d[i+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;M=R;do{X=i+((M&65535)<<1)|0;U=M;M=d[X>>1]|0;d[X>>1]=W}while((M&65535)<(U&65535));ab=W}W=Q;do{M=i+((W&65535)<<1)|0;R=W;W=d[M>>1]|0;d[M>>1]=ab}while((W&65535)<(R&65535));W=d[B+(P<<1)>>1]|0;Q=ab;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(ab<<16>>16==W<<16>>16)bb=Q;else{R=W;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(Q&65535)>(R&65535)?R:Q;S=W;do{ba=i+((S&65535)<<1)|0;U=S;S=d[ba>>1]|0;d[ba>>1]=M}while((S&65535)<(U&65535));bb=M}M=ab;do{S=i+((M&65535)<<1)|0;W=M;M=d[S>>1]|0;d[S>>1]=bb}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=bb;N=H;break a}while(0);if(b[z+G>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=M;while(1){Q=d[i+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(M<<16>>16==W<<16>>16)cb=S;else{Q=W;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=i+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=R}while((U&65535)<(X&65535));cb=R}R=M;do{U=i+((R&65535)<<1)|0;W=R;R=d[U>>1]|0;d[U>>1]=cb}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=cb;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;M=d[w+(O<<1)>>1]|0;W=R;while(1){U=d[i+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(R<<16>>16==M<<16>>16)db=W;else{U=M;while(1){S=d[i+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=M;do{X=i+((Q&65535)<<1)|0;ba=Q;Q=d[X>>1]|0;d[X>>1]=S}while((Q&65535)<(ba&65535));db=S}S=R;do{Q=i+((S&65535)<<1)|0;M=S;S=d[Q>>1]|0;d[Q>>1]=db}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;R=db;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}if(db<<16>>16==S<<16>>16)eb=R;else{M=S;while(1){Q=d[i+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(R&65535)>(M&65535)?M:R;W=S;do{U=i+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));eb=Q}Q=db;do{W=i+((Q&65535)<<1)|0;S=Q;Q=d[W>>1]|0;d[W>>1]=eb}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=eb;N=H;break a}if(!(b[z+I>>0]|0)){Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[i+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)fb=W;else{R=S;while(1){M=d[i+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;ba=S;do{U=i+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=M}while((ba&65535)<(X&65535));fb=M}M=Q;do{ba=i+((M&65535)<<1)|0;S=M;M=d[ba>>1]|0;d[ba>>1]=fb}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=fb;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;if(b[A+G>>0]|0){Q=d[B+(P<<1)>>1]|0;S=M;while(1){ba=d[i+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(M<<16>>16==Q<<16>>16)gb=S;else{ba=Q;while(1){W=d[i+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;R=Q;do{X=i+((R&65535)<<1)|0;U=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(U&65535));gb=W}W=M;do{R=i+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=gb}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=gb;N=H;break a}W=d[w+(P<<1)>>1]|0;Q=W;while(1){R=d[i+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)hb=Q;else{R=M;while(1){S=d[i+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;ba=M;do{U=i+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=S}while((ba&65535)<(X&65535));hb=S}S=W;do{ba=i+((S&65535)<<1)|0;M=S;S=d[ba>>1]|0;d[ba>>1]=hb}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;W=hb;while(1){M=d[i+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(hb<<16>>16==S<<16>>16)ib=W;else{M=S;while(1){ba=d[i+((M&65535)<<1)>>1]|0;if((ba&65535)<(M&65535))M=ba;else break}ba=(W&65535)>(M&65535)?M:W;Q=S;do{R=i+((Q&65535)<<1)|0;X=Q;Q=d[R>>1]|0;d[R>>1]=ba}while((Q&65535)<(X&65535));ib=ba}ba=hb;do{Q=i+((ba&65535)<<1)|0;S=ba;ba=d[Q>>1]|0;d[Q>>1]=ib}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=ib;N=H;break a}while(0);ba=d[w+(P<<1)>>1]|0;S=d[w+(O<<1)>>1]|0;Q=ba;while(1){W=d[i+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(ba<<16>>16==S<<16>>16)jb=Q;else{W=S;while(1){M=d[i+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}M=(Q&65535)>(W&65535)?W:Q;X=S;do{R=i+((X&65535)<<1)|0;U=X;X=d[R>>1]|0;d[R>>1]=M}while((X&65535)<(U&65535));jb=M}M=ba;do{X=i+((M&65535)<<1)|0;S=M;M=d[X>>1]|0;d[X>>1]=jb}while((M&65535)<(S&65535));M=d[B+(P<<1)>>1]|0;ba=jb;while(1){S=d[i+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}if(jb<<16>>16==M<<16>>16)kb=ba;else{P=M;while(1){S=d[i+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(ba&65535)>(P&65535)?P:ba;X=M;do{Q=i+((X&65535)<<1)|0;W=X;X=d[Q>>1]|0;d[Q>>1]=S}while((X&65535)<(W&65535));kb=S}S=jb;do{X=i+((S&65535)<<1)|0;M=S;S=d[X>>1]|0;d[X>>1]=kb}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=kb;N=H;break a}while(0);do if(D){O=G+-2|0;if(b[z+I>>0]|0){V=d[B+(O<<1)>>1]|0;do if((O|0)>-1){if(!(b[x+O>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);L=d[w+(O<<1)>>1]|0;S=L;while(1){M=d[i+((S&65535)<<1)>>1]|0;if((M&65535)<(S&65535))S=M;else break}if(L<<16>>16==V<<16>>16)lb=S;else{M=V;while(1){X=d[i+((M&65535)<<1)>>1]|0;if((X&65535)<(M&65535))M=X;else break}X=(S&65535)>(M&65535)?M:S;ba=V;do{P=i+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=X}while((ba&65535)<(W&65535));lb=X}X=L;do{ba=i+((X&65535)<<1)|0;V=X;X=d[ba>>1]|0;d[ba>>1]=lb}while((X&65535)<(V&65535));d[B+(G<<1)>>1]=lb;N=H;break a}if(!(b[z+G>>0]|0)){mb=O;break}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(!(b[z+O>>0]|0)){X=d[w+(G<<1)>>1]|0;L=d[B+(O<<1)>>1]|0;V=X;while(1){ba=d[i+((V&65535)<<1)>>1]|0;if((ba&65535)<(V&65535))V=ba;else break}if(X<<16>>16==L<<16>>16)nb=V;else{ba=L;while(1){S=d[i+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}S=(V&65535)>(ba&65535)?ba:V;M=L;do{W=i+((M&65535)<<1)|0;P=M;M=d[W>>1]|0;d[W>>1]=S}while((M&65535)<(P&65535));nb=S}S=X;do{M=i+((S&65535)<<1)|0;L=S;S=d[M>>1]|0;d[M>>1]=nb}while((S&65535)<(L&65535));d[B+(G<<1)>>1]=nb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;X=d[B+(O<<1)>>1]|0;L=S;while(1){M=d[i+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==X<<16>>16)ob=L;else{M=X;while(1){V=d[i+((M&65535)<<1)>>1]|0;if((V&65535)<(M&65535))M=V;else break}V=(L&65535)>(M&65535)?M:L;ba=X;do{P=i+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=V}while((ba&65535)<(W&65535));ob=V}V=S;do{ba=i+((V&65535)<<1)|0;X=V;V=d[ba>>1]|0;d[ba>>1]=ob}while((V&65535)<(X&65535));d[B+(G<<1)>>1]=ob;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[B+(O<<1)>>1]|0;X=V;while(1){ba=d[i+((X&65535)<<1)>>1]|0;if((ba&65535)<(X&65535))X=ba;else break}if(V<<16>>16==S<<16>>16)pb=X;else{O=S;while(1){ba=d[i+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}ba=(X&65535)>(O&65535)?O:X;L=S;do{M=i+((L&65535)<<1)|0;W=L;L=d[M>>1]|0;d[M>>1]=ba}while((L&65535)<(W&65535));pb=ba}ba=V;do{L=i+((ba&65535)<<1)|0;S=ba;ba=d[L>>1]|0;d[L>>1]=pb}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=pb;N=H;break a}else mb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(mb<<1)>>1]|0;N=H;break}do if(D){ba=G+-2|0;if(b[z+I>>0]|0){V=d[B+(ba<<1)>>1]|0;do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);S=d[w+(ba<<1)>>1]|0;L=S;while(1){X=d[i+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(S<<16>>16==V<<16>>16)qb=L;else{X=V;while(1){O=d[i+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;W=V;do{M=i+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=O}while((W&65535)<(P&65535));qb=O}O=S;do{W=i+((O&65535)<<1)|0;V=O;O=d[W>>1]|0;d[W>>1]=qb}while((O&65535)<(V&65535));d[B+(G<<1)>>1]=qb;N=H;break a}if(!(b[z+G>>0]|0)){rb=ba;break}do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;if(!(b[z+ba>>0]|0)){O=d[w+(G<<1)>>1]|0;S=d[B+(ba<<1)>>1]|0;V=O;while(1){W=d[i+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}if(O<<16>>16==S<<16>>16)sb=V;else{W=S;while(1){L=d[i+((W&65535)<<1)>>1]|0;if((L&65535)<(W&65535))W=L;else break}L=(V&65535)>(W&65535)?W:V;X=S;do{P=i+((X&65535)<<1)|0;M=X;X=d[P>>1]|0;d[P>>1]=L}while((X&65535)<(M&65535));sb=L}L=O;do{X=i+((L&65535)<<1)|0;S=L;L=d[X>>1]|0;d[X>>1]=sb}while((L&65535)<(S&65535));d[B+(G<<1)>>1]=sb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(ba<<1)>>1]|0;N=H;break a}while(0);L=d[w+(G<<1)>>1]|0;O=d[B+(ba<<1)>>1]|0;S=L;while(1){X=d[i+((S&65535)<<1)>>1]|0;if((X&65535)<(S&65535))S=X;else break}if(L<<16>>16==O<<16>>16)tb=S;else{X=O;while(1){V=d[i+((X&65535)<<1)>>1]|0;if((V&65535)<(X&65535))X=V;else break}V=(S&65535)>(X&65535)?X:S;W=O;do{M=i+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=V}while((W&65535)<(P&65535));tb=V}V=L;do{W=i+((V&65535)<<1)|0;O=V;V=d[W>>1]|0;d[W>>1]=tb}while((V&65535)<(O&65535));d[B+(G<<1)>>1]=tb;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;L=d[B+(ba<<1)>>1]|0;O=V;while(1){W=d[i+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(V<<16>>16==L<<16>>16)ub=O;else{ba=L;while(1){W=d[i+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(O&65535)>(ba&65535)?ba:O;S=L;do{X=i+((S&65535)<<1)|0;P=S;S=d[X>>1]|0;d[X>>1]=W}while((S&65535)<(P&65535));ub=W}W=V;do{S=i+((W&65535)<<1)|0;L=W;W=d[S>>1]|0;d[S>>1]=ub}while((W&65535)<(L&65535));d[B+(G<<1)>>1]=ub;N=H;break a}else rb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(rb<<1)>>1]|0;N=H;break}}W=G|1;V=(W|0)<(m|0);if(!(E|V^1)?b[z+W>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(K?b[z+I>>0]|0:0){L=d[w+(G<<1)>>1]|0;do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=L;N=H;break a}while(0);S=d[w+(G+-2<<1)>>1]|0;O=S;while(1){ba=d[i+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}if(S<<16>>16==L<<16>>16)vb=O;else{ba=L;while(1){P=d[i+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(O&65535)>(ba&65535)?ba:O;X=L;do{M=i+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=P}while((X&65535)<(Q&65535));vb=P}P=S;do{X=i+((P&65535)<<1)|0;L=P;P=d[X>>1]|0;d[X>>1]=vb}while((P&65535)<(L&65535));d[B+(G<<1)>>1]=vb;N=H;break}d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(V?b[x+W>>0]|0:0){P=G+2|0;if(!((P|0)>=(m|0)|E)?b[z+P>>0]|0:0){if(b[z+G>>0]|0){do if(F){if(!(b[A+W>>0]|0))break;d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[w+(P<<1)>>1]|0;L=V;while(1){X=d[i+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(V<<16>>16==S<<16>>16)wb=L;else{X=S;while(1){O=d[i+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;ba=S;do{Q=i+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=O}while((ba&65535)<(M&65535));wb=O}O=V;do{ba=i+((O&65535)<<1)|0;S=O;O=d[ba>>1]|0;d[ba>>1]=wb}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=wb;N=H;break}do if(K){if(!(b[z+I>>0]|0))break;do if(F){if(!(b[A+W>>0]|0))break;O=d[w+(P<<1)>>1]|0;if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}V=d[w+(G+-2<<1)>>1]|0;S=V;while(1){ba=d[i+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(V<<16>>16==O<<16>>16)xb=S;else{ba=O;while(1){L=d[i+((ba&65535)<<1)>>1]|0;if((L&65535)<(ba&65535))ba=L;else break}L=(S&65535)>(ba&65535)?ba:S;X=O;do{M=i+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=L}while((X&65535)<(Q&65535));xb=L}L=V;do{X=i+((L&65535)<<1)|0;O=L;L=d[X>>1]|0;d[X>>1]=xb}while((L&65535)<(O&65535));d[B+(G<<1)>>1]=xb;N=H;break a}while(0);L=d[w+(G+-2<<1)>>1]|0;V=d[w+(P<<1)>>1]|0;O=L;while(1){X=d[i+((O&65535)<<1)>>1]|0;if((X&65535)<(O&65535))O=X;else break}if(L<<16>>16==V<<16>>16)yb=O;else{X=V;while(1){S=d[i+((X&65535)<<1)>>1]|0;if((S&65535)<(X&65535))X=S;else break}S=(O&65535)>(X&65535)?X:O;ba=V;do{Q=i+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=S}while((ba&65535)<(M&65535));yb=S}S=L;do{ba=i+((S&65535)<<1)|0;V=S;S=d[ba>>1]|0;d[ba>>1]=yb}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=yb;N=H;break a}while(0);d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}do if(!(E|K^1)){if(!(b[z+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;P=H&65535;d[i+(P<<1)>>1]=H;N=P+1&65535;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(!(E|K^1)?b[z+I>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=H;P=H&65535;d[i+(P<<1)>>1]=H;N=P+1&65535}while(0);G=G+2|0;if((G|0)>=(m|0)){zb=N;break}else H=N}}else zb=t;v=v+2|0;if((v|0)>=(k|0))break;else t=zb}if((zb&65535)>1){t=zb&65535;zb=1;k=1;while(1){v=i+(k<<1)|0;N=j[v>>1]|0;if(N>>>0<k>>>0){d[v>>1]=d[i+(N<<1)>>1]|0;Ab=zb}else{d[v>>1]=zb;Ab=(zb&65535)+1&65535}k=k+1|0;if((k|0)==(t|0)){Bb=Ab;break}else zb=Ab}}else Bb=1}else Bb=1;ywa(h,Bb&65535);Ab=f[l>>2]|0;zb=f[r>>2]|0;t=(zb&1|0)!=0;k=(Ab|0)>0;b:do if(!(Ab&1)){if(!t){if(!k)break;v=c+16|0;N=c+44|0;m=e+16|0;yb=e+44|0;xb=h+20|0;wb=h+120|0;vb=h+48|0;rb=0;ub=zb;tb=Ab;while(1){sb=f[f[N>>2]>>2]|0;qb=(f[v>>2]|0)+(Y(sb,rb)|0)|0;mb=qb+sb|0;sb=f[f[yb>>2]>>2]|0;pb=(f[m>>2]|0)+(Y(sb,rb)|0)|0;ob=pb+sb|0;if((ub|0)>0){sb=((rb|0)<0)<<31>>31;nb=rb|1;lb=((nb|0)<0)<<31>>31;kb=0;do{jb=pb+(kb<<1)|0;ib=d[jb>>1]|0;do if(ib<<16>>16){hb=d[i+((ib&65535)<<1)>>1]|0;if(!(b[qb+kb>>0]|0)){d[jb>>1]=0;gb=f[xb>>2]|0;fb=f[gb>>2]|0;f[gb>>2]=(fb|0)>(kb|0)?kb:fb;fb=gb+8|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(kb|0)?kb:eb;eb=gb+4|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)>(rb|0)?rb:fb;fb=gb+12|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(rb|0)?rb:eb;eb=gb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=f[wb>>2]|0;fb=eb;db=d1c(f[fb>>2]|0,f[fb+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;fb=eb;f[fb>>2]=db;f[fb+4>>2]=J;Cb=eb+8|0;Db=gb;Eb=eb}else{d[jb>>1]=hb;eb=hb&65535;gb=f[xb>>2]|0;fb=gb+(Y(f[f[vb>>2]>>2]|0,eb)|0)|0;db=f[fb>>2]|0;f[fb>>2]=(db|0)>(kb|0)?kb:db;db=fb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(kb|0)?kb:cb;cb=fb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(rb|0)?rb:db;db=fb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(rb|0)?rb:cb;cb=fb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[wb>>2]|0;fb=cb+(eb<<4)|0;db=fb;bb=d1c(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=fb;f[db>>2]=bb;f[db+4>>2]=J;Cb=cb+(eb<<4)+8|0;Db=gb;Eb=cb}cb=Cb;gb=d1c(f[cb>>2]|0,f[cb+4>>2]|0,rb|0,sb|0)|0;cb=Cb;f[cb>>2]=gb;f[cb+4>>2]=J;cb=kb|1;gb=pb+(cb<<1)|0;if(!(b[qb+cb>>0]|0)){d[gb>>1]=0;Fb=0;Gb=Db}else{d[gb>>1]=hb;gb=hb&65535;Fb=gb;Gb=Db+(Y(f[f[vb>>2]>>2]|0,gb)|0)|0}gb=f[Gb>>2]|0;f[Gb>>2]=(gb|0)>(cb|0)?cb:gb;gb=Gb+8|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(cb|0)?cb:eb;eb=Gb+4|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)>(rb|0)?rb:gb;gb=Gb+12|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(rb|0)?rb:eb;eb=Gb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(Fb<<4)|0;gb=eb;db=d1c(f[gb>>2]|0,f[gb+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;gb=eb;f[gb>>2]=db;f[gb+4>>2]=J;gb=Eb+(Fb<<4)+8|0;db=gb;eb=d1c(f[db>>2]|0,f[db+4>>2]|0,rb|0,sb|0)|0;db=gb;f[db>>2]=eb;f[db+4>>2]=J;db=ob+(kb<<1)|0;if(!(b[mb+kb>>0]|0)){d[db>>1]=0;Hb=0;Ib=Db}else{d[db>>1]=hb;db=hb&65535;Hb=db;Ib=Db+(Y(f[f[vb>>2]>>2]|0,db)|0)|0}db=f[Ib>>2]|0;f[Ib>>2]=(db|0)>(kb|0)?kb:db;db=Ib+8|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(kb|0)?kb:eb;eb=Ib+4|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(nb|0)?nb:db;db=Ib+12|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(nb|0)?nb:eb;eb=Ib+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(Hb<<4)|0;db=eb;gb=d1c(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=eb;f[db>>2]=gb;f[db+4>>2]=J;db=Eb+(Hb<<4)+8|0;gb=db;eb=d1c(f[gb>>2]|0,f[gb+4>>2]|0,nb|0,lb|0)|0;gb=db;f[gb>>2]=eb;f[gb+4>>2]=J;gb=ob+(cb<<1)|0;if(!(b[mb+cb>>0]|0)){d[gb>>1]=0;eb=f[Db>>2]|0;f[Db>>2]=(eb|0)>(cb|0)?cb:eb;eb=Db+8|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)<(cb|0)?cb:db;db=Db+4|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)>(nb|0)?nb:eb;eb=Db+12|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)<(nb|0)?nb:db;db=Db+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Eb;eb=d1c(f[db>>2]|0,f[db+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;db=Eb;f[db>>2]=eb;f[db+4>>2]=J;Jb=Eb+8|0;break}else{d[gb>>1]=hb;gb=hb&65535;hb=Db+(Y(f[f[vb>>2]>>2]|0,gb)|0)|0;db=f[hb>>2]|0;f[hb>>2]=(db|0)>(cb|0)?cb:db;db=hb+8|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(cb|0)?cb:eb;eb=hb+4|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(nb|0)?nb:db;db=hb+12|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(nb|0)?nb:eb;eb=hb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(gb<<4)|0;hb=eb;db=d1c(f[hb>>2]|0,f[hb+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;cb=eb;f[cb>>2]=db;f[cb+4>>2]=J;Jb=Eb+(gb<<4)+8|0;break}}else{d[jb>>1]=0;gb=kb|1;d[pb+(gb<<1)>>1]=0;d[ob+(kb<<1)>>1]=0;d[ob+(gb<<1)>>1]=0;cb=f[xb>>2]|0;db=f[cb>>2]|0;eb=(db|0)>(kb|0)?kb:db;db=cb+8|0;hb=f[db>>2]|0;bb=(hb|0)<(kb|0)?kb:hb;hb=cb+4|0;fb=f[hb>>2]|0;ab=(fb|0)>(rb|0)?rb:fb;fb=cb+12|0;$a=f[fb>>2]|0;_a=($a|0)<(rb|0)?rb:$a;$a=cb+16|0;Za=f[$a>>2]|0;Ya=f[wb>>2]|0;Xa=((kb|0)<0)<<31>>31;Wa=Ya;Va=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,Xa|0)|0;Wa=J;Ua=Ya+8|0;Ta=Ua;Sa=d1c(f[Ta>>2]|0,f[Ta+4>>2]|0,rb|0,sb|0)|0;Ta=J;Ra=(eb|0)>(gb|0)?gb:eb;eb=((gb|0)<0)<<31>>31;Qa=d1c(Va|0,Wa|0,gb|0,eb|0)|0;Wa=J;Va=d1c(Sa|0,Ta|0,rb|0,sb|0)|0;Ta=J;Sa=d1c(Qa|0,Wa|0,kb|0,Xa|0)|0;Xa=J;Wa=d1c(Va|0,Ta|0,nb|0,lb|0)|0;Ta=Ua;f[Ta>>2]=Wa;f[Ta+4>>2]=J;f[cb>>2]=(Ra|0)>(kb|0)?kb:Ra;f[db>>2]=(bb|0)<(gb|0)?gb:bb;f[hb>>2]=(ab|0)>(nb|0)?nb:ab;f[fb>>2]=(_a|0)<(nb|0)?nb:_a;f[$a>>2]=Za+4;Za=d1c(Sa|0,Xa|0,gb|0,eb|0)|0;eb=Ya;f[eb>>2]=Za;f[eb+4>>2]=J;Jb=Ua}while(0);jb=Jb;ib=d1c(f[jb>>2]|0,f[jb+4>>2]|0,nb|0,lb|0)|0;jb=Jb;f[jb>>2]=ib;f[jb+4>>2]=J;kb=kb+2|0;Kb=f[r>>2]|0}while((kb|0)<(Kb|0));Lb=f[l>>2]|0;Mb=Kb}else{Lb=tb;Mb=ub}rb=rb+2|0;if((rb|0)>=(Lb|0))break b;else{ub=Mb;tb=Lb}}}if(k){tb=h+20|0;ub=h+120|0;rb=h+48|0;wb=f[c+16>>2]|0;xb=f[c+44>>2]|0;vb=f[e+16>>2]|0;m=f[e+44>>2]|0;yb=0;v=zb;N=Ab;while(1){kb=f[xb>>2]|0;lb=wb+(Y(kb,yb)|0)|0;nb=lb+kb|0;kb=f[m>>2]|0;sb=vb+(Y(kb,yb)|0)|0;ob=sb+kb|0;if((v|0)>0){kb=((yb|0)<0)<<31>>31;pb=yb|1;mb=((pb|0)<0)<<31>>31;qb=0;do{jb=sb+(qb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;d[ob+(qb<<1)>>1]=0;I=f[tb>>2]|0;K=f[I>>2]|0;Ua=(K|0)>(qb|0)?qb:K;K=I+8|0;eb=f[K>>2]|0;Za=(eb|0)<(qb|0)?qb:eb;eb=I+4|0;Ya=f[eb>>2]|0;gb=(Ya|0)>(yb|0)?yb:Ya;Ya=I+12|0;Xa=f[Ya>>2]|0;Sa=(Xa|0)<(yb|0)?yb:Xa;Xa=I+16|0;$a=f[Xa>>2]|0;_a=f[ub>>2]|0;fb=((qb|0)<0)<<31>>31;ab=_a;hb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,fb|0)|0;ab=J;bb=_a+8|0;db=bb;Ra=d1c(f[db>>2]|0,f[db+4>>2]|0,yb|0,kb|0)|0;db=J;f[I>>2]=Ua;f[K>>2]=Za;cb=(gb|0)>(pb|0)?pb:gb;f[eb>>2]=cb;gb=(Sa|0)<(pb|0)?pb:Sa;f[Ya>>2]=gb;f[Xa>>2]=$a+2;Sa=d1c(hb|0,ab|0,qb|0,fb|0)|0;fb=J;ab=_a;f[ab>>2]=Sa;f[ab+4>>2]=fb;ab=d1c(Ra|0,db|0,pb|0,mb|0)|0;db=J;Ra=bb;f[Ra>>2]=ab;f[Ra+4>>2]=db;Ra=qb|1;if((Ra|0)<(f[r>>2]|0)){d[sb+(Ra<<1)>>1]=0;d[ob+(Ra<<1)>>1]=0;hb=((Ra|0)<0)<<31>>31;Ta=d1c(Sa|0,fb|0,Ra|0,hb|0)|0;fb=J;Sa=d1c(ab|0,db|0,yb|0,kb|0)|0;db=J;f[I>>2]=(Ua|0)>(Ra|0)?Ra:Ua;f[K>>2]=(Za|0)<(Ra|0)?Ra:Za;f[eb>>2]=(cb|0)>(yb|0)?yb:cb;f[Ya>>2]=gb;f[Xa>>2]=$a+4;$a=d1c(Ta|0,fb|0,Ra|0,hb|0)|0;hb=_a;f[hb>>2]=$a;f[hb+4>>2]=J;hb=d1c(Sa|0,db|0,pb|0,mb|0)|0;db=bb;f[db>>2]=hb;f[db+4>>2]=J}}else{db=d[i+((ib&65535)<<1)>>1]|0;if(!(b[lb+qb>>0]|0)){d[jb>>1]=0;hb=f[tb>>2]|0;bb=f[hb>>2]|0;f[hb>>2]=(bb|0)>(qb|0)?qb:bb;bb=hb+8|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(qb|0)?qb:Sa;Sa=hb+4|0;bb=f[Sa>>2]|0;f[Sa>>2]=(bb|0)>(yb|0)?yb:bb;bb=hb+12|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(yb|0)?yb:Sa;Sa=hb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=f[ub>>2]|0;bb=Sa;$a=d1c(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;bb=Sa;f[bb>>2]=$a;f[bb+4>>2]=J;Nb=Sa+8|0;Ob=hb;Pb=Sa}else{d[jb>>1]=db;Sa=db&65535;hb=f[tb>>2]|0;bb=hb+(Y(f[f[rb>>2]>>2]|0,Sa)|0)|0;$a=f[bb>>2]|0;f[bb>>2]=($a|0)>(qb|0)?qb:$a;$a=bb+8|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(qb|0)?qb:_a;_a=bb+4|0;$a=f[_a>>2]|0;f[_a>>2]=($a|0)>(yb|0)?yb:$a;$a=bb+12|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(yb|0)?yb:_a;_a=bb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[ub>>2]|0;bb=_a+(Sa<<4)|0;$a=bb;Ra=d1c(f[$a>>2]|0,f[$a+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;$a=bb;f[$a>>2]=Ra;f[$a+4>>2]=J;Nb=_a+(Sa<<4)+8|0;Ob=hb;Pb=_a}_a=Nb;hb=d1c(f[_a>>2]|0,f[_a+4>>2]|0,yb|0,kb|0)|0;_a=Nb;f[_a>>2]=hb;f[_a+4>>2]=J;_a=ob+(qb<<1)|0;if(!(b[nb+qb>>0]|0)){d[_a>>1]=0;Qb=0;Rb=Ob}else{d[_a>>1]=db;_a=db&65535;Qb=_a;Rb=Ob+(Y(f[f[rb>>2]>>2]|0,_a)|0)|0}_a=f[Rb>>2]|0;f[Rb>>2]=(_a|0)>(qb|0)?qb:_a;_a=Rb+8|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(qb|0)?qb:hb;hb=Rb+4|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)>(pb|0)?pb:_a;_a=Rb+12|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(pb|0)?pb:hb;hb=Rb+16|0;f[hb>>2]=(f[hb>>2]|0)+1;hb=Pb+(Qb<<4)|0;_a=hb;Sa=d1c(f[_a>>2]|0,f[_a+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;_a=hb;f[_a>>2]=Sa;f[_a+4>>2]=J;_a=Pb+(Qb<<4)+8|0;Sa=_a;hb=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,pb|0,mb|0)|0;Sa=_a;f[Sa>>2]=hb;f[Sa+4>>2]=J;Sa=qb|1;if((Sa|0)<(f[r>>2]|0)){hb=sb+(Sa<<1)|0;if(!(b[lb+Sa>>0]|0)){d[hb>>1]=0;Sb=0;Tb=Ob}else{d[hb>>1]=db;hb=db&65535;Sb=hb;Tb=Ob+(Y(f[f[rb>>2]>>2]|0,hb)|0)|0}hb=f[Tb>>2]|0;f[Tb>>2]=(hb|0)>(Sa|0)?Sa:hb;hb=Tb+8|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)<(Sa|0)?Sa:_a;_a=Tb+4|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)>(yb|0)?yb:hb;hb=Tb+12|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)<(yb|0)?yb:_a;_a=Tb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=Pb+(Sb<<4)|0;hb=_a;$a=d1c(f[hb>>2]|0,f[hb+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;hb=_a;f[hb>>2]=$a;f[hb+4>>2]=J;hb=Pb+(Sb<<4)+8|0;$a=hb;_a=d1c(f[$a>>2]|0,f[$a+4>>2]|0,yb|0,kb|0)|0;$a=hb;f[$a>>2]=_a;f[$a+4>>2]=J;$a=ob+(Sa<<1)|0;if(!(b[nb+Sa>>0]|0)){d[$a>>1]=0;_a=f[Ob>>2]|0;f[Ob>>2]=(_a|0)>(Sa|0)?Sa:_a;_a=Ob+8|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(Sa|0)?Sa:hb;hb=Ob+4|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)>(pb|0)?pb:_a;_a=Ob+12|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(pb|0)?pb:hb;hb=Ob+16|0;f[hb>>2]=(f[hb>>2]|0)+1;hb=Pb;_a=d1c(f[hb>>2]|0,f[hb+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;hb=Pb;f[hb>>2]=_a;f[hb+4>>2]=J;hb=Pb+8|0;_a=hb;Ra=d1c(f[_a>>2]|0,f[_a+4>>2]|0,pb|0,mb|0)|0;_a=hb;f[_a>>2]=Ra;f[_a+4>>2]=J;break}else{d[$a>>1]=db;$a=db&65535;db=Ob+(Y(f[f[rb>>2]>>2]|0,$a)|0)|0;_a=f[db>>2]|0;f[db>>2]=(_a|0)>(Sa|0)?Sa:_a;_a=db+8|0;Ra=f[_a>>2]|0;f[_a>>2]=(Ra|0)<(Sa|0)?Sa:Ra;Ra=db+4|0;_a=f[Ra>>2]|0;f[Ra>>2]=(_a|0)>(pb|0)?pb:_a;_a=db+12|0;Ra=f[_a>>2]|0;f[_a>>2]=(Ra|0)<(pb|0)?pb:Ra;Ra=db+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=Pb+($a<<4)|0;db=Ra;_a=d1c(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;Sa=Ra;f[Sa>>2]=_a;f[Sa+4>>2]=J;Sa=Pb+($a<<4)+8|0;$a=Sa;_a=d1c(f[$a>>2]|0,f[$a+4>>2]|0,pb|0,mb|0)|0;$a=Sa;f[$a>>2]=_a;f[$a+4>>2]=J;break}}}while(0);qb=qb+2|0;Ub=f[r>>2]|0}while((qb|0)<(Ub|0));Vb=f[l>>2]|0;Wb=Ub}else{Vb=N;Wb=v}yb=yb+2|0;if((yb|0)>=(Vb|0))break;else{v=Wb;N=Vb}}}}else{if(!t){if(!k)break;N=h+20|0;v=h+120|0;yb=h+48|0;rb=f[c+16>>2]|0;ub=f[c+44>>2]|0;tb=f[e+16>>2]|0;vb=f[e+44>>2]|0;m=0;wb=zb;xb=Ab;while(1){qb=f[ub>>2]|0;mb=rb+(Y(qb,m)|0)|0;pb=mb+qb|0;qb=f[vb>>2]|0;nb=tb+(Y(qb,m)|0)|0;ob=nb+qb|0;if((wb|0)>0){qb=((m|0)<0)<<31>>31;kb=m|1;lb=((kb|0)<0)<<31>>31;sb=0;do{jb=nb+(sb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;$a=sb|1;d[nb+($a<<1)>>1]=0;_a=f[N>>2]|0;Sa=f[_a>>2]|0;Ra=(Sa|0)>(sb|0)?sb:Sa;Sa=_a+8|0;db=f[Sa>>2]|0;hb=(db|0)<(sb|0)?sb:db;db=_a+4|0;bb=f[db>>2]|0;fb=(bb|0)>(m|0)?m:bb;bb=_a+12|0;Ta=f[bb>>2]|0;Xa=(Ta|0)<(m|0)?m:Ta;Ta=_a+16|0;gb=f[Ta>>2]|0;Ya=f[v>>2]|0;cb=((sb|0)<0)<<31>>31;eb=Ya;Za=d1c(f[eb>>2]|0,f[eb+4>>2]|0,sb|0,cb|0)|0;eb=J;K=Ya+8|0;Ua=K;I=d1c(f[Ua>>2]|0,f[Ua+4>>2]|0,m|0,qb|0)|0;Ua=J;ab=(Ra|0)>($a|0)?$a:Ra;f[_a>>2]=ab;Ra=(hb|0)<($a|0)?$a:hb;f[Sa>>2]=Ra;f[db>>2]=fb;f[bb>>2]=Xa;f[Ta>>2]=gb+2;hb=(($a|0)<0)<<31>>31;Wa=d1c(Za|0,eb|0,$a|0,hb|0)|0;eb=J;Za=Ya;f[Za>>2]=Wa;f[Za+4>>2]=eb;Za=d1c(I|0,Ua|0,m|0,qb|0)|0;Ua=J;I=K;f[I>>2]=Za;f[I+4>>2]=Ua;if((kb|0)<(f[l>>2]|0)){d[ob+(sb<<1)>>1]=0;d[ob+($a<<1)>>1]=0;I=d1c(Wa|0,eb|0,sb|0,cb|0)|0;cb=J;eb=d1c(Za|0,Ua|0,kb|0,lb|0)|0;Ua=J;f[_a>>2]=(ab|0)>(sb|0)?sb:ab;f[Sa>>2]=Ra;f[db>>2]=(fb|0)>(kb|0)?kb:fb;f[bb>>2]=(Xa|0)<(kb|0)?kb:Xa;f[Ta>>2]=gb+4;gb=d1c(I|0,cb|0,$a|0,hb|0)|0;hb=Ya;f[hb>>2]=gb;f[hb+4>>2]=J;hb=d1c(eb|0,Ua|0,kb|0,lb|0)|0;Ua=K;f[Ua>>2]=hb;f[Ua+4>>2]=J}}else{Ua=d[i+((ib&65535)<<1)>>1]|0;if(!(b[mb+sb>>0]|0)){d[jb>>1]=0;hb=f[N>>2]|0;K=f[hb>>2]|0;f[hb>>2]=(K|0)>(sb|0)?sb:K;K=hb+8|0;eb=f[K>>2]|0;f[K>>2]=(eb|0)<(sb|0)?sb:eb;eb=hb+4|0;K=f[eb>>2]|0;f[eb>>2]=(K|0)>(m|0)?m:K;K=hb+12|0;eb=f[K>>2]|0;f[K>>2]=(eb|0)<(m|0)?m:eb;eb=hb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=f[v>>2]|0;K=eb;gb=d1c(f[K>>2]|0,f[K+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;K=eb;f[K>>2]=gb;f[K+4>>2]=J;Xb=eb+8|0;Yb=hb;Zb=eb}else{d[jb>>1]=Ua;eb=Ua&65535;hb=f[N>>2]|0;K=hb+(Y(f[f[yb>>2]>>2]|0,eb)|0)|0;gb=f[K>>2]|0;f[K>>2]=(gb|0)>(sb|0)?sb:gb;gb=K+8|0;Ya=f[gb>>2]|0;f[gb>>2]=(Ya|0)<(sb|0)?sb:Ya;Ya=K+4|0;gb=f[Ya>>2]|0;f[Ya>>2]=(gb|0)>(m|0)?m:gb;gb=K+12|0;Ya=f[gb>>2]|0;f[gb>>2]=(Ya|0)<(m|0)?m:Ya;Ya=K+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[v>>2]|0;K=Ya+(eb<<4)|0;gb=K;$a=d1c(f[gb>>2]|0,f[gb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;gb=K;f[gb>>2]=$a;f[gb+4>>2]=J;Xb=Ya+(eb<<4)+8|0;Yb=hb;Zb=Ya}Ya=Xb;hb=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,m|0,qb|0)|0;Ya=Xb;f[Ya>>2]=hb;f[Ya+4>>2]=J;Ya=sb|1;hb=nb+(Ya<<1)|0;if(!(b[mb+Ya>>0]|0)){d[hb>>1]=0;_b=0;$b=Yb}else{d[hb>>1]=Ua;hb=Ua&65535;_b=hb;$b=Yb+(Y(f[f[yb>>2]>>2]|0,hb)|0)|0}hb=f[$b>>2]|0;f[$b>>2]=(hb|0)>(Ya|0)?Ya:hb;hb=$b+8|0;eb=f[hb>>2]|0;f[hb>>2]=(eb|0)<(Ya|0)?Ya:eb;eb=$b+4|0;hb=f[eb>>2]|0;f[eb>>2]=(hb|0)>(m|0)?m:hb;hb=$b+12|0;eb=f[hb>>2]|0;f[hb>>2]=(eb|0)<(m|0)?m:eb;eb=$b+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Zb+(_b<<4)|0;hb=eb;gb=d1c(f[hb>>2]|0,f[hb+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;hb=eb;f[hb>>2]=gb;f[hb+4>>2]=J;hb=Zb+(_b<<4)+8|0;gb=hb;eb=d1c(f[gb>>2]|0,f[gb+4>>2]|0,m|0,qb|0)|0;gb=hb;f[gb>>2]=eb;f[gb+4>>2]=J;if((kb|0)<(f[l>>2]|0)){gb=ob+(sb<<1)|0;if(!(b[pb+sb>>0]|0)){d[gb>>1]=0;ac=0;bc=Yb}else{d[gb>>1]=Ua;gb=Ua&65535;ac=gb;bc=Yb+(Y(f[f[yb>>2]>>2]|0,gb)|0)|0}gb=f[bc>>2]|0;f[bc>>2]=(gb|0)>(sb|0)?sb:gb;gb=bc+8|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(sb|0)?sb:eb;eb=bc+4|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)>(kb|0)?kb:gb;gb=bc+12|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(kb|0)?kb:eb;eb=bc+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Zb+(ac<<4)|0;gb=eb;hb=d1c(f[gb>>2]|0,f[gb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;gb=eb;f[gb>>2]=hb;f[gb+4>>2]=J;gb=Zb+(ac<<4)+8|0;hb=gb;eb=d1c(f[hb>>2]|0,f[hb+4>>2]|0,kb|0,lb|0)|0;hb=gb;f[hb>>2]=eb;f[hb+4>>2]=J;hb=ob+(Ya<<1)|0;if(!(b[pb+Ya>>0]|0)){d[hb>>1]=0;eb=f[Yb>>2]|0;f[Yb>>2]=(eb|0)>(Ya|0)?Ya:eb;eb=Yb+8|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)<(Ya|0)?Ya:gb;gb=Yb+4|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)>(kb|0)?kb:eb;eb=Yb+12|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)<(kb|0)?kb:gb;gb=Yb+16|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=Zb;eb=d1c(f[gb>>2]|0,f[gb+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;gb=Zb;f[gb>>2]=eb;f[gb+4>>2]=J;gb=Zb+8|0;eb=gb;$a=d1c(f[eb>>2]|0,f[eb+4>>2]|0,kb|0,lb|0)|0;eb=gb;f[eb>>2]=$a;f[eb+4>>2]=J;break}else{d[hb>>1]=Ua;hb=Ua&65535;Ua=Yb+(Y(f[f[yb>>2]>>2]|0,hb)|0)|0;eb=f[Ua>>2]|0;f[Ua>>2]=(eb|0)>(Ya|0)?Ya:eb;eb=Ua+8|0;$a=f[eb>>2]|0;f[eb>>2]=($a|0)<(Ya|0)?Ya:$a;$a=Ua+4|0;eb=f[$a>>2]|0;f[$a>>2]=(eb|0)>(kb|0)?kb:eb;eb=Ua+12|0;$a=f[eb>>2]|0;f[eb>>2]=($a|0)<(kb|0)?kb:$a;$a=Ua+16|0;f[$a>>2]=(f[$a>>2]|0)+1;$a=Zb+(hb<<4)|0;Ua=$a;eb=d1c(f[Ua>>2]|0,f[Ua+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;Ya=$a;f[Ya>>2]=eb;f[Ya+4>>2]=J;Ya=Zb+(hb<<4)+8|0;hb=Ya;eb=d1c(f[hb>>2]|0,f[hb+4>>2]|0,kb|0,lb|0)|0;hb=Ya;f[hb>>2]=eb;f[hb+4>>2]=J;break}}}while(0);sb=sb+2|0;cc=f[r>>2]|0}while((sb|0)<(cc|0));dc=f[l>>2]|0;ec=cc}else{dc=xb;ec=wb}m=m+2|0;if((m|0)>=(dc|0))break b;else{wb=ec;xb=dc}}}if(k){xb=h+20|0;wb=h+120|0;m=h+48|0;yb=f[c+16>>2]|0;v=f[c+44>>2]|0;N=f[e+16>>2]|0;tb=f[e+44>>2]|0;vb=0;rb=zb;ub=Ab;while(1){sb=f[v>>2]|0;lb=yb+(Y(sb,vb)|0)|0;kb=lb+sb|0;sb=f[tb>>2]|0;pb=N+(Y(sb,vb)|0)|0;ob=pb+sb|0;if((rb|0)>0){sb=((vb|0)<0)<<31>>31;qb=vb|1;mb=((qb|0)<0)<<31>>31;nb=0;do{jb=pb+(nb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;hb=f[xb>>2]|0;eb=f[hb>>2]|0;Ya=(eb|0)>(nb|0)?nb:eb;f[hb>>2]=Ya;eb=hb+8|0;$a=f[eb>>2]|0;Ua=($a|0)<(nb|0)?nb:$a;f[eb>>2]=Ua;$a=hb+4|0;gb=f[$a>>2]|0;K=(gb|0)>(vb|0)?vb:gb;f[$a>>2]=K;gb=hb+12|0;cb=f[gb>>2]|0;I=(cb|0)<(vb|0)?vb:cb;f[gb>>2]=I;cb=hb+16|0;Ta=f[cb>>2]|0;f[cb>>2]=Ta+1;Xa=f[wb>>2]|0;bb=((nb|0)<0)<<31>>31;fb=Xa;db=d1c(f[fb>>2]|0,f[fb+4>>2]|0,nb|0,bb|0)|0;fb=J;Ra=Xa;f[Ra>>2]=db;f[Ra+4>>2]=fb;Ra=Xa+8|0;Sa=Ra;ab=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,vb|0,sb|0)|0;Sa=J;_a=Ra;f[_a>>2]=ab;f[_a+4>>2]=Sa;_a=nb|1;if((_a|0)<(f[r>>2]|0)){d[pb+(_a<<1)>>1]=0;Za=(Ya|0)>(_a|0)?_a:Ya;f[hb>>2]=Za;Wa=(Ua|0)<(_a|0)?_a:Ua;f[eb>>2]=Wa;f[$a>>2]=K;f[gb>>2]=I;f[cb>>2]=Ta+2;Va=((_a|0)<0)<<31>>31;Qa=d1c(db|0,fb|0,_a|0,Va|0)|0;Pa=J;Oa=Xa;f[Oa>>2]=Qa;f[Oa+4>>2]=Pa;Oa=d1c(ab|0,Sa|0,vb|0,sb|0)|0;Na=J;Ma=Ra;f[Ma>>2]=Oa;f[Ma+4>>2]=Na;if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;d[ob+(_a<<1)>>1]=0;Ma=d1c(Qa|0,Pa|0,nb|0,bb|0)|0;Pa=J;Qa=d1c(Oa|0,Na|0,qb|0,mb|0)|0;Na=J;f[hb>>2]=(Za|0)>(nb|0)?nb:Za;f[eb>>2]=Wa;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[gb>>2]=(I|0)<(qb|0)?qb:I;f[cb>>2]=Ta+4;Wa=d1c(Ma|0,Pa|0,_a|0,Va|0)|0;Va=Xa;f[Va>>2]=Wa;f[Va+4>>2]=J;Va=d1c(Qa|0,Na|0,qb|0,mb|0)|0;Na=Ra;f[Na>>2]=Va;f[Na+4>>2]=J;break}else{if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;f[hb>>2]=Ya;f[eb>>2]=Ua;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[gb>>2]=(I|0)<(qb|0)?qb:I;f[cb>>2]=Ta+2;Ta=d1c(db|0,fb|0,nb|0,bb|0)|0;bb=Xa;f[bb>>2]=Ta;f[bb+4>>2]=J;bb=d1c(ab|0,Sa|0,qb|0,mb|0)|0;Sa=Ra;f[Sa>>2]=bb;f[Sa+4>>2]=J;break}}else{Sa=d[i+((ib&65535)<<1)>>1]|0;if(!(b[lb+nb>>0]|0)){d[jb>>1]=0;bb=f[xb>>2]|0;Ra=f[bb>>2]|0;f[bb>>2]=(Ra|0)>(nb|0)?nb:Ra;Ra=bb+8|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(nb|0)?nb:ab;ab=bb+4|0;Ra=f[ab>>2]|0;f[ab>>2]=(Ra|0)>(vb|0)?vb:Ra;Ra=bb+12|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(vb|0)?vb:ab;ab=bb+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=f[wb>>2]|0;Ra=ab;Ta=d1c(f[Ra>>2]|0,f[Ra+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ra=ab;f[Ra>>2]=Ta;f[Ra+4>>2]=J;fc=ab+8|0;gc=bb;hc=ab}else{d[jb>>1]=Sa;ab=Sa&65535;bb=f[xb>>2]|0;Ra=bb+(Y(f[f[m>>2]>>2]|0,ab)|0)|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(nb|0)?nb:Ta;Ta=Ra+8|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(nb|0)?nb:Xa;Xa=Ra+4|0;Ta=f[Xa>>2]|0;f[Xa>>2]=(Ta|0)>(vb|0)?vb:Ta;Ta=Ra+12|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(vb|0)?vb:Xa;Xa=Ra+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[wb>>2]|0;Ra=Xa+(ab<<4)|0;Ta=Ra;fb=d1c(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=Ra;f[Ta>>2]=fb;f[Ta+4>>2]=J;fc=Xa+(ab<<4)+8|0;gc=bb;hc=Xa}Xa=fc;bb=d1c(f[Xa>>2]|0,f[Xa+4>>2]|0,vb|0,sb|0)|0;Xa=fc;f[Xa>>2]=bb;f[Xa+4>>2]=J;Xa=nb|1;if((Xa|0)>=(f[r>>2]|0)){if((qb|0)>=(f[l>>2]|0))break;bb=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[bb>>1]=0;ab=f[gc>>2]|0;f[gc>>2]=(ab|0)>(nb|0)?nb:ab;ab=gc+8|0;Ta=f[ab>>2]|0;f[ab>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=gc+4|0;ab=f[Ta>>2]|0;f[Ta>>2]=(ab|0)>(qb|0)?qb:ab;ab=gc+12|0;Ta=f[ab>>2]|0;f[ab>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=gc+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc;ab=d1c(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=hc;f[Ta>>2]=ab;f[Ta+4>>2]=J;Ta=hc+8|0;ab=Ta;fb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,mb|0)|0;ab=Ta;f[ab>>2]=fb;f[ab+4>>2]=J;break}else{d[bb>>1]=Sa;bb=Sa&65535;ab=gc+(Y(f[f[m>>2]>>2]|0,bb)|0)|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)>(nb|0)?nb:fb;fb=ab+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=ab+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=ab+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=ab+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc+(bb<<4)|0;ab=Ta;fb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;ab=Ta;f[ab>>2]=fb;f[ab+4>>2]=J;ab=hc+(bb<<4)+8|0;bb=ab;fb=d1c(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=ab;f[bb>>2]=fb;f[bb+4>>2]=J;break}}bb=pb+(Xa<<1)|0;if(!(b[lb+Xa>>0]|0)){d[bb>>1]=0;ic=0;jc=gc}else{d[bb>>1]=Sa;bb=Sa&65535;ic=bb;jc=gc+(Y(f[f[m>>2]>>2]|0,bb)|0)|0}bb=f[jc>>2]|0;f[jc>>2]=(bb|0)>(Xa|0)?Xa:bb;bb=jc+8|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(Xa|0)?Xa:fb;fb=jc+4|0;bb=f[fb>>2]|0;f[fb>>2]=(bb|0)>(vb|0)?vb:bb;bb=jc+12|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(vb|0)?vb:fb;fb=jc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=hc+(ic<<4)|0;bb=fb;ab=d1c(f[bb>>2]|0,f[bb+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;bb=fb;f[bb>>2]=ab;f[bb+4>>2]=J;bb=hc+(ic<<4)+8|0;ab=bb;fb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,vb|0,sb|0)|0;ab=bb;f[ab>>2]=fb;f[ab+4>>2]=J;if((qb|0)<(f[l>>2]|0)){ab=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[ab>>1]=0;kc=0;lc=gc}else{d[ab>>1]=Sa;ab=Sa&65535;kc=ab;lc=gc+(Y(f[f[m>>2]>>2]|0,ab)|0)|0}ab=f[lc>>2]|0;f[lc>>2]=(ab|0)>(nb|0)?nb:ab;ab=lc+8|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)<(nb|0)?nb:fb;fb=lc+4|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)>(qb|0)?qb:ab;ab=lc+12|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)<(qb|0)?qb:fb;fb=lc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=hc+(kc<<4)|0;ab=fb;bb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;ab=fb;f[ab>>2]=bb;f[ab+4>>2]=J;ab=hc+(kc<<4)+8|0;bb=ab;fb=d1c(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=ab;f[bb>>2]=fb;f[bb+4>>2]=J;bb=ob+(Xa<<1)|0;if(!(b[kb+Xa>>0]|0)){d[bb>>1]=0;fb=f[gc>>2]|0;f[gc>>2]=(fb|0)>(Xa|0)?Xa:fb;fb=gc+8|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)<(Xa|0)?Xa:ab;ab=gc+4|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)>(qb|0)?qb:fb;fb=gc+12|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)<(qb|0)?qb:ab;ab=gc+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=hc;fb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;ab=hc;f[ab>>2]=fb;f[ab+4>>2]=J;ab=hc+8|0;fb=ab;Ta=d1c(f[fb>>2]|0,f[fb+4>>2]|0,qb|0,mb|0)|0;fb=ab;f[fb>>2]=Ta;f[fb+4>>2]=J;break}else{d[bb>>1]=Sa;bb=Sa&65535;Sa=gc+(Y(f[f[m>>2]>>2]|0,bb)|0)|0;fb=f[Sa>>2]|0;f[Sa>>2]=(fb|0)>(Xa|0)?Xa:fb;fb=Sa+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(Xa|0)?Xa:Ta;Ta=Sa+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=Sa+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=Sa+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc+(bb<<4)|0;Sa=Ta;fb=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;Xa=Ta;f[Xa>>2]=fb;f[Xa+4>>2]=J;Xa=hc+(bb<<4)+8|0;bb=Xa;fb=d1c(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=Xa;f[bb>>2]=fb;f[bb+4>>2]=J;break}}}while(0);nb=nb+2|0;mc=f[r>>2]|0}while((nb|0)<(mc|0));nc=f[l>>2]|0;oc=mc}else{nc=ub;oc=rb}vb=vb+2|0;if((vb|0)>=(nc|0))break;else{rb=oc;ub=nc}}}}while(0);nc=h+12|0;if((f[nc>>2]|0)<=0){wL(i);u=a;return Bb|0}oc=f[h+20>>2]|0;mc=f[h+48>>2]|0;l=f[h+120>>2]|0;r=f[h+80>>2]|0;hc=f[h+108>>2]|0;h=0;do{gc=oc+(Y(f[mc>>2]|0,h)|0)|0;kc=gc+8|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[gc>>2]|0);kc=gc+12|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[gc+4>>2]|0);kc=r+(Y(f[hc>>2]|0,h)|0)|0;pc=+((f[gc+16>>2]|0)>>>0);gc=l+(h<<4)|0;p[kc>>3]=(+((f[gc>>2]|0)>>>0)+4294967296.0*+((f[gc+4>>2]|0)>>>0))/pc;gc=l+(h<<4)+8|0;p[kc+8>>3]=(+((f[gc>>2]|0)>>>0)+4294967296.0*+((f[gc+4>>2]|0)>>>0))/pc;h=h+1|0}while((h|0)<(f[nc>>2]|0));wL(i);u=a;return Bb|0}function vwa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0.0;a=u;u=u+16|0;h=a;i=f[c+8>>2]|0;j=d+8|0;if((i|0)!=(f[j>>2]|0)){k=$Xc(32)|0;f[h>>2]=k;f[h+8>>2]=-2147483616;f[h+4>>2]=26;l=k;m=354540;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+26>>0]=0;vM(-215,h,528391,354221,2589)}k=f[c+12>>2]|0;o=d+12|0;if((k|0)!=(f[o>>2]|0)){q=$Xc(32)|0;f[h>>2]=q;f[h+8>>2]=-2147483616;f[h+4>>2]=26;l=q;m=354567;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[q+26>>0]=0;vM(-215,h,528391,354221,2590)}if((e|0)!=8){e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=17;l=e;m=354594;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[e+17>>0]=0;vM(-215,h,528391,354221,2591)}h=vL((Y(((i+1|0)/2|0)<<2,(k+1|0)/2|0)|0)+4|0)|0;f[h>>2]=0;if((i|0)>0){e=c+16|0;m=c+44|0;l=d+16|0;n=d+44|0;q=(k|0)>0;r=1;s=0;while(1){t=f[f[m>>2]>>2]|0;v=(f[e>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[n>>2]>>2]|0;z=(f[l>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(i|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(k|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;K=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(K){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;M=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}N=f[t+(E<<2)>>2]|0;O=f[z+(M<<2)>>2]|0;P=N;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((N|0)==(O|0))R=P;else{Q=O;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;T=O;do{U=h+(T<<2)|0;V=T;T=f[U>>2]|0;f[U>>2]=S}while((T|0)<(V|0));R=S}S=N;do{T=h+(S<<2)|0;O=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(O|0));f[z+(E<<2)>>2]=R;L=F;break a}while(0);S=f[t+(E<<2)>>2]|0;N=f[z+(M<<2)>>2]|0;O=S;while(1){T=f[h+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((S|0)==(N|0))W=O;else{M=N;while(1){T=f[h+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}T=(O|0)>(M|0)?M:O;P=N;do{Q=h+(P<<2)|0;V=P;P=f[Q>>2]|0;f[Q>>2]=T}while((P|0)<(V|0));W=T}T=S;do{P=h+(T<<2)|0;N=T;T=f[P>>2]|0;f[P>>2]=W}while((T|0)<(N|0));f[z+(E<<2)>>2]=W;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;N=T;while(1){P=f[h+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((T|0)==(S|0))X=N;else{P=S;while(1){O=f[h+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(N|0)>(P|0)?P:N;M=S;do{V=h+(M<<2)|0;Q=M;M=f[V>>2]|0;f[V>>2]=O}while((M|0)<(Q|0));X=O}O=T;do{M=h+(O<<2)|0;S=O;O=f[M>>2]|0;f[M>>2]=X}while((O|0)<(S|0));f[z+(E<<2)>>2]=X;L=F;break a}O=E+2|0;if((O|0)>=(k|0))break;if(!(b[x+O>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){T=f[t+(O<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;M=T;while(1){N=f[h+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((T|0)==(S|0))Z=M;else{N=S;while(1){P=f[h+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=S;do{V=h+(Q<<2)|0;U=Q;Q=f[V>>2]|0;f[V>>2]=P}while((Q|0)<(U|0));Z=P}P=T;do{Q=h+(P<<2)|0;S=P;P=f[Q>>2]|0;f[Q>>2]=Z}while((P|0)<(S|0));f[z+(E<<2)>>2]=Z;L=F;break a}P=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}T=f[t+(O<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;Q=T;while(1){M=f[h+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((T|0)==(S|0))_=Q;else{M=S;while(1){N=f[h+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(Q|0)>(M|0)?M:Q;U=S;do{V=h+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<($|0));_=N}N=T;do{U=h+(N<<2)|0;S=N;N=f[U>>2]|0;f[U>>2]=_}while((N|0)<(S|0));f[z+(E<<2)>>2]=_;L=F;break a}while(0);N=f[t+(O<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;S=N;while(1){U=f[h+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((N|0)==(T|0))aa=S;else{P=T;while(1){U=f[h+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}U=(S|0)>(P|0)?P:S;Q=T;do{M=h+(Q<<2)|0;$=Q;Q=f[M>>2]|0;f[M>>2]=U}while((Q|0)<($|0));aa=U}U=N;do{Q=h+(U<<2)|0;T=U;U=f[Q>>2]|0;f[Q>>2]=aa}while((U|0)<(T|0));f[z+(E<<2)>>2]=aa;L=F;break a}while(0);U=f[t+(O<<2)>>2]|0;N=f[z+(E+-2<<2)>>2]|0;T=U;while(1){Q=f[h+(T<<2)>>2]|0;if((Q|0)<(T|0))T=Q;else break}if((U|0)==(N|0))ba=T;else{O=N;while(1){Q=f[h+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}Q=(T|0)>(O|0)?O:T;S=N;do{P=h+(S<<2)|0;$=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<($|0));ba=Q}Q=U;do{S=h+(Q<<2)|0;N=Q;Q=f[S>>2]|0;f[S>>2]=ba}while((Q|0)<(N|0));f[z+(E<<2)>>2]=ba;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){Q=E+-2|0;do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=U;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;S=N;while(1){T=f[h+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((N|0)==(U|0))ca=S;else{T=U;while(1){O=f[h+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(S|0)>(T|0)?T:S;$=U;do{P=h+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=O}while(($|0)<(M|0));ca=O}O=N;do{$=h+(O<<2)|0;U=O;O=f[$>>2]|0;f[$>>2]=ca}while((O|0)<(U|0));f[z+(E<<2)>>2]=ca;L=F;break a}if(!(b[x+Q>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(Q<<2)>>2]|0;U=O;while(1){$=f[h+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((O|0)==(N|0))da=U;else{$=N;while(1){S=f[h+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(U|0)>($|0)?$:U;T=N;do{M=h+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=S}while((T|0)<(P|0));da=S}S=O;do{T=h+(S<<2)|0;N=S;S=f[T>>2]|0;f[T>>2]=da}while((S|0)<(N|0));f[z+(E<<2)>>2]=da;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;S=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){T=f[h+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((O|0)==(S|0))ea=N;else{T=S;while(1){U=f[h+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}U=(N|0)>(T|0)?T:N;$=S;do{P=h+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=U}while(($|0)<(M|0));ea=U}U=O;do{$=h+(U<<2)|0;S=U;U=f[$>>2]|0;f[$>>2]=ea}while((U|0)<(S|0));f[z+(E<<2)>>2]=ea;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=U;while(1){$=f[h+(S<<2)>>2]|0;if(($|0)<(S|0))S=$;else break}if((U|0)==(O|0))fa=S;else{$=O;while(1){N=f[h+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(S|0)>($|0)?$:S;T=O;do{M=h+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=N}while((T|0)<(P|0));fa=N}N=U;do{T=h+(N<<2)|0;O=N;N=f[T>>2]|0;f[T>>2]=fa}while((N|0)<(O|0));f[z+(E<<2)>>2]=fa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;U=f[z+(Q<<2)>>2]|0;O=N;while(1){T=f[h+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((N|0)==(U|0))ga=O;else{Q=U;while(1){T=f[h+(Q<<2)>>2]|0;if((T|0)<(Q|0))Q=T;else break}T=(O|0)>(Q|0)?Q:O;S=U;do{$=h+(S<<2)|0;P=S;S=f[$>>2]|0;f[$>>2]=T}while((S|0)<(P|0));ga=T}T=N;do{S=h+(T<<2)|0;U=T;T=f[S>>2]|0;f[S>>2]=ga}while((T|0)<(U|0));f[z+(E<<2)>>2]=ga;L=F;break a}T=E+2|0;do if(!((T|0)>=(k|0)|C)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}S=f[t+(T<<2)>>2]|0;O=S;while(1){Q=f[h+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}if((S|0)==(U|0))ha=O;else{Q=U;while(1){P=f[h+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}P=(O|0)>(Q|0)?Q:O;$=U;do{M=h+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=P}while(($|0)<(V|0));ha=P}P=S;do{$=h+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=ha}while((P|0)<(U|0));f[z+(E<<2)>>2]=ha;L=F;break a}if(!(b[x+N>>0]|0)){P=f[t+(T<<2)>>2]|0;S=f[z+(N<<2)>>2]|0;U=P;while(1){$=f[h+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((P|0)==(S|0))ia=U;else{$=S;while(1){O=f[h+($<<2)>>2]|0;if((O|0)<($|0))$=O;else break}O=(U|0)>($|0)?$:U;Q=S;do{V=h+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=O}while((Q|0)<(M|0));ia=O}O=P;do{Q=h+(O<<2)|0;S=O;O=f[Q>>2]|0;f[Q>>2]=ia}while((O|0)<(S|0));f[z+(E<<2)>>2]=ia;L=F;break a}if(!(b[y+I>>0]|0)){O=f[t+(T<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;S=O;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}if((O|0)==(P|0))ja=S;else{Q=P;while(1){U=f[h+(Q<<2)>>2]|0;if((U|0)<(Q|0))Q=U;else break}U=(S|0)>(Q|0)?Q:S;$=P;do{M=h+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=U}while(($|0)<(V|0));ja=U}U=O;do{$=h+(U<<2)|0;P=U;U=f[$>>2]|0;f[$>>2]=ja}while((U|0)<(P|0));f[z+(E<<2)>>2]=ja;L=F;break a}U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}O=f[t+(T<<2)>>2]|0;P=O;while(1){$=f[h+(P<<2)>>2]|0;if(($|0)<(P|0))P=$;else break}if((O|0)==(U|0))ka=P;else{$=U;while(1){S=f[h+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(P|0)>($|0)?$:P;Q=U;do{V=h+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=S}while((Q|0)<(M|0));ka=S}S=O;do{Q=h+(S<<2)|0;U=S;S=f[Q>>2]|0;f[Q>>2]=ka}while((S|0)<(U|0));f[z+(E<<2)>>2]=ka;L=F;break a}while(0);S=f[t+(T<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;U=S;while(1){Q=f[h+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}if((S|0)==(O|0))la=U;else{N=O;while(1){Q=f[h+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(U|0)>(N|0)?N:U;P=O;do{$=h+(P<<2)|0;M=P;P=f[$>>2]|0;f[$>>2]=Q}while((P|0)<(M|0));la=Q}Q=S;do{P=h+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=la}while((Q|0)<(O|0));f[z+(E<<2)>>2]=la;L=F;break a}while(0);Q=E+-2|0;if(!(b[x+E>>0]|0)){S=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;P=S;while(1){U=f[h+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}if((S|0)==(O|0))ma=P;else{U=O;while(1){N=f[h+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(P|0)>(U|0)?U:P;M=O;do{$=h+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=N}while((M|0)<(V|0));ma=N}N=S;do{M=h+(N<<2)|0;O=N;N=f[M>>2]|0;f[M>>2]=ma}while((N|0)<(O|0));f[z+(E<<2)>>2]=ma;L=F;break a}do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){N=f[t+(T<<2)>>2]|0;S=f[z+(Q<<2)>>2]|0;O=N;while(1){M=f[h+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}if((N|0)==(S|0))na=O;else{M=S;while(1){P=f[h+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(O|0)>(M|0)?M:O;U=S;do{V=h+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=P}while((U|0)<($|0));na=P}P=N;do{U=h+(P<<2)|0;S=P;P=f[U>>2]|0;f[U>>2]=na}while((P|0)<(S|0));f[z+(E<<2)>>2]=na;L=F;break a}if(!(b[x+Q>>0]|0)){P=f[t+(E<<2)>>2]|0;N=f[t+(T<<2)>>2]|0;S=P;while(1){U=f[h+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((P|0)==(N|0))oa=S;else{U=N;while(1){O=f[h+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;M=N;do{$=h+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=O}while((M|0)<(V|0));oa=O}O=P;do{M=h+(O<<2)|0;N=O;O=f[M>>2]|0;f[M>>2]=oa}while((O|0)<(N|0));O=f[z+(Q<<2)>>2]|0;P=oa;while(1){N=f[h+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((oa|0)==(O|0))pa=P;else{N=O;while(1){M=f[h+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(P|0)>(N|0)?N:P;S=O;do{U=h+(S<<2)|0;V=S;S=f[U>>2]|0;f[U>>2]=M}while((S|0)<(V|0));pa=M}M=oa;do{S=h+(M<<2)|0;O=M;M=f[S>>2]|0;f[S>>2]=pa}while((M|0)<(O|0));f[z+(E<<2)>>2]=pa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;M=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=M;while(1){P=f[h+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((M|0)==(O|0))qa=S;else{P=O;while(1){N=f[h+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(S|0)>(P|0)?P:S;V=O;do{U=h+(V<<2)|0;$=V;V=f[U>>2]|0;f[U>>2]=N}while((V|0)<($|0));qa=N}N=M;do{V=h+(N<<2)|0;O=N;N=f[V>>2]|0;f[V>>2]=qa}while((N|0)<(O|0));f[z+(E<<2)>>2]=qa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=f[t+(T<<2)>>2]|0;O=N;while(1){V=f[h+(O<<2)>>2]|0;if((V|0)<(O|0))O=V;else break}if((N|0)==(M|0))ra=O;else{V=M;while(1){S=f[h+(V<<2)>>2]|0;if((S|0)<(V|0))V=S;else break}S=(O|0)>(V|0)?V:O;P=M;do{$=h+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=S}while((P|0)<(U|0));ra=S}S=N;do{P=h+(S<<2)|0;M=S;S=f[P>>2]|0;f[P>>2]=ra}while((S|0)<(M|0));S=f[z+(Q<<2)>>2]|0;N=ra;while(1){M=f[h+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((ra|0)==(S|0))sa=N;else{M=S;while(1){P=f[h+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(N|0)>(M|0)?M:N;O=S;do{V=h+(O<<2)|0;U=O;O=f[V>>2]|0;f[V>>2]=P}while((O|0)<(U|0));sa=P}P=ra;do{O=h+(P<<2)|0;S=P;P=f[O>>2]|0;f[O>>2]=sa}while((P|0)<(S|0));f[z+(E<<2)>>2]=sa;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;S=f[t+(T<<2)>>2]|0;O=P;while(1){N=f[h+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}if((P|0)==(S|0))ta=O;else{N=S;while(1){M=f[h+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(O|0)>(N|0)?N:O;U=S;do{V=h+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<($|0));ta=M}M=P;do{U=h+(M<<2)|0;S=M;M=f[U>>2]|0;f[U>>2]=ta}while((M|0)<(S|0));M=f[z+(Q<<2)>>2]|0;P=ta;while(1){S=f[h+(P<<2)>>2]|0;if((S|0)<(P|0))P=S;else break}if((ta|0)==(M|0))ua=P;else{Q=M;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;U=M;do{O=h+(U<<2)|0;N=U;U=f[O>>2]|0;f[O>>2]=S}while((U|0)<(N|0));ua=S}S=ta;do{U=h+(S<<2)|0;M=S;S=f[U>>2]|0;f[U>>2]=ua}while((S|0)<(M|0));f[z+(E<<2)>>2]=ua;L=F;break a}while(0);T=E+-2|0;if(!(b[x+E>>0]|0)){va=T;break}do if((T|0)>-1){if(!(b[v+T>>0]|0))break;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}if(!(b[x+T>>0]|0)){S=f[t+(E<<2)>>2]|0;M=f[z+(T<<2)>>2]|0;U=S;while(1){P=f[h+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((S|0)==(M|0))wa=U;else{P=M;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(U|0)>(P|0)?P:U;N=M;do{O=h+(N<<2)|0;$=N;N=f[O>>2]|0;f[O>>2]=Q}while((N|0)<($|0));wa=Q}Q=S;do{N=h+(Q<<2)|0;M=Q;Q=f[N>>2]|0;f[N>>2]=wa}while((Q|0)<(M|0));f[z+(E<<2)>>2]=wa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;S=f[z+(T<<2)>>2]|0;M=Q;while(1){N=f[h+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((Q|0)==(S|0))xa=M;else{N=S;while(1){U=f[h+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}U=(M|0)>(N|0)?N:M;P=S;do{$=h+(P<<2)|0;O=P;P=f[$>>2]|0;f[$>>2]=U}while((P|0)<(O|0));xa=U}U=Q;do{P=h+(U<<2)|0;S=U;U=f[P>>2]|0;f[P>>2]=xa}while((U|0)<(S|0));f[z+(E<<2)>>2]=xa;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[z+(T<<2)>>2]|0;S=U;while(1){P=f[h+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((U|0)==(Q|0))ya=S;else{T=Q;while(1){P=f[h+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}P=(S|0)>(T|0)?T:S;M=Q;do{N=h+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=P}while((M|0)<(O|0));ya=P}P=U;do{M=h+(P<<2)|0;Q=P;P=f[M>>2]|0;f[M>>2]=ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=ya;L=F;break a}else va=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(va<<2)>>2];L=F;break a}while(0);do if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(k|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[t+(P<<2)>>2]|0;M=U;while(1){S=f[h+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((U|0)==(Q|0))za=M;else{S=Q;while(1){T=f[h+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}T=(M|0)>(S|0)?S:M;O=Q;do{N=h+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=T}while((O|0)<($|0));za=T}T=U;do{O=h+(T<<2)|0;Q=T;T=f[O>>2]|0;f[O>>2]=za}while((T|0)<(Q|0));f[z+(E<<2)>>2]=za;L=F;break a}while(0);if(!(b[x+E>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break}if(K){if(b[w+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(b[v+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}}f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break a}if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(k|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;U=f[t+(P<<2)>>2]|0;Q=T;while(1){O=f[h+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((T|0)==(U|0))Aa=Q;else{O=U;while(1){M=f[h+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}M=(Q|0)>(O|0)?O:Q;S=U;do{$=h+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=M}while((S|0)<(N|0));Aa=M}M=T;do{S=h+(M<<2)|0;U=M;M=f[S>>2]|0;f[S>>2]=Aa}while((M|0)<(U|0));f[z+(E<<2)>>2]=Aa;L=F;break a}while(0);if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}}f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break a}while(0);f[z+(E<<2)>>2]=0;L=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;K=(I|0)<(k|0);if(B&K?b[x+I>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}do if(D){if(!(b[y+E>>0]|0))break;P=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}M=f[t+(E<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;U=M;while(1){S=f[h+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((M|0)==(T|0))Ba=U;else{S=T;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=T;do{N=h+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=Q}while((O|0)<($|0));Ba=Q}Q=M;do{O=h+(Q<<2)|0;T=Q;Q=f[O>>2]|0;f[O>>2]=Ba}while((Q|0)<(T|0));f[z+(E<<2)>>2]=Ba;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;T=Q;while(1){O=f[h+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}if((Q|0)==(M|0))Ca=T;else{P=M;while(1){O=f[h+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(T|0)>(P|0)?P:T;U=M;do{S=h+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));Ca=O}O=Q;do{U=h+(O<<2)|0;M=O;O=f[U>>2]|0;f[U>>2]=Ca}while((O|0)<(M|0));f[z+(E<<2)>>2]=Ca;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;M=O;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((O|0)==(Q|0))Da=M;else{U=Q;while(1){T=f[h+(U<<2)>>2]|0;if((T|0)<(U|0))U=T;else break}T=(M|0)>(U|0)?U:M;P=Q;do{$=h+(P<<2)|0;S=P;P=f[$>>2]|0;f[$>>2]=T}while((P|0)<(S|0));Da=T}T=O;do{P=h+(T<<2)|0;Q=T;T=f[P>>2]|0;f[P>>2]=Da}while((T|0)<(Q|0));f[z+(E<<2)>>2]=Da;L=F;break}if(K?b[v+I>>0]|0:0){T=E+2|0;do if(B&(T|0)<(k|0)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){O=f[t+(T<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;P=O;while(1){M=f[h+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((O|0)==(Q|0))Ea=P;else{M=Q;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}U=(P|0)>(M|0)?M:P;S=Q;do{$=h+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=U}while((S|0)<(N|0));Ea=U}U=O;do{S=h+(U<<2)|0;Q=U;U=f[S>>2]|0;f[S>>2]=Ea}while((U|0)<(Q|0));f[z+(E<<2)>>2]=Ea;L=F;break a}U=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}do if((U|0)>-1){if(!(b[x+U>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}O=f[t+(T<<2)>>2]|0;Q=f[z+(U<<2)>>2]|0;S=O;while(1){P=f[h+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((O|0)==(Q|0))Fa=S;else{P=Q;while(1){M=f[h+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(S|0)>(P|0)?P:S;N=Q;do{$=h+(N<<2)|0;V=N;N=f[$>>2]|0;f[$>>2]=M}while((N|0)<(V|0));Fa=M}M=O;do{N=h+(M<<2)|0;Q=M;M=f[N>>2]|0;f[N>>2]=Fa}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Fa;L=F;break a}while(0);M=f[t+(T<<2)>>2]|0;O=f[z+(U<<2)>>2]|0;Q=M;while(1){N=f[h+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((M|0)==(O|0))Ga=Q;else{U=O;while(1){N=f[h+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(Q|0)>(U|0)?U:Q;S=O;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=N}while((S|0)<(V|0));Ga=N}N=M;do{S=h+(N<<2)|0;O=N;N=f[S>>2]|0;f[S>>2]=Ga}while((N|0)<(O|0));f[z+(E<<2)>>2]=Ga;L=F;break a}while(0);N=f[t+(T<<2)>>2]|0;M=f[z+(E+-2<<2)>>2]|0;O=N;while(1){S=f[h+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((N|0)==(M|0))Ha=O;else{S=M;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(O|0)>(S|0)?S:O;U=M;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=Q}while((U|0)<(P|0));Ha=Q}Q=N;do{U=h+(Q<<2)|0;M=Q;Q=f[U>>2]|0;f[U>>2]=Ha}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ha;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(A?b[w+G>>0]|0:0){T=E|1;I=(T|0)<(k|0);if(!(C|I^1)?b[x+T>>0]|0:0){K=E+-2|0;do if((K|0)>-1){if(!(b[v+K>>0]|0))break;if(b[x+G>>0]|0){Q=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=Q;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=N;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((N|0)==(Q|0))Ia=M;else{U=Q;while(1){O=f[h+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(M|0)>(U|0)?U:M;S=Q;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=O}while((S|0)<(V|0));Ia=O}O=N;do{S=h+(O<<2)|0;Q=O;O=f[S>>2]|0;f[S>>2]=Ia}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Ia;L=F;break a}if(!(b[x+K>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;Q=O;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((O|0)==(N|0))Ja=Q;else{S=N;while(1){M=f[h+(S<<2)>>2]|0;if((M|0)<(S|0))S=M;else break}M=(Q|0)>(S|0)?S:Q;U=N;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<(P|0));Ja=M}M=O;do{U=h+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Ja}while((M|0)<(N|0));f[z+(E<<2)>>2]=Ja;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;M=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){U=f[h+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((O|0)==(M|0))Ka=N;else{U=M;while(1){Q=f[h+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=M;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Ka=Q}Q=O;do{S=h+(Q<<2)|0;M=Q;Q=f[S>>2]|0;f[S>>2]=Ka}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ka;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;O=f[z+(K<<2)>>2]|0;M=Q;while(1){S=f[h+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((Q|0)==(O|0))La=M;else{S=O;while(1){N=f[h+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(M|0)>(S|0)?S:M;U=O;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));La=N}N=Q;do{U=h+(N<<2)|0;O=N;N=f[U>>2]|0;f[U>>2]=La}while((N|0)<(O|0));f[z+(E<<2)>>2]=La;L=F;break a}while(0);if(b[x+E>>0]|0){N=f[t+(E<<2)>>2]|0;Q=f[z+(K<<2)>>2]|0;O=N;while(1){U=f[h+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((N|0)==(Q|0))Ma=O;else{U=Q;while(1){M=f[h+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=Q;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=M}while((S|0)<(V|0));Ma=M}M=N;do{S=h+(M<<2)|0;Q=M;M=f[S>>2]|0;f[S>>2]=Ma}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Ma;L=F;break}M=f[t+(E<<2)>>2]|0;if(!(b[x+G>>0]|0)){N=f[z+(K<<2)>>2]|0;Q=M;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((M|0)==(N|0))Na=Q;else{S=N;while(1){O=f[h+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(Q|0)>(S|0)?S:Q;U=N;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=O}while((U|0)<(P|0));Na=O}O=M;do{U=h+(O<<2)|0;N=O;O=f[U>>2]|0;f[U>>2]=Na}while((O|0)<(N|0));f[z+(E<<2)>>2]=Na;L=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=f[z+(K<<2)>>2]|0;N=M;while(1){U=f[h+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((M|0)==(O|0))Oa=N;else{U=O;while(1){Q=f[h+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=O;do{P=h+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Oa=Q}Q=M;do{S=h+(Q<<2)|0;O=Q;Q=f[S>>2]|0;f[S>>2]=Oa}while((Q|0)<(O|0));f[z+(E<<2)>>2]=Oa;L=F;break a}while(0);Q=f[t+(K<<2)>>2]|0;O=Q;while(1){S=f[h+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((Q|0)==(M|0))Pa=O;else{S=M;while(1){N=f[h+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(O|0)>(S|0)?S:O;U=M;do{V=h+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));Pa=N}N=Q;do{U=h+(N<<2)|0;M=N;N=f[U>>2]|0;f[U>>2]=Pa}while((N|0)<(M|0));N=f[z+(K<<2)>>2]|0;Q=Pa;while(1){M=f[h+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((Pa|0)==(N|0))Qa=Q;else{K=N;while(1){M=f[h+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(Q|0)>(K|0)?K:Q;U=N;do{O=h+(U<<2)|0;S=U;U=f[O>>2]|0;f[O>>2]=M}while((U|0)<(S|0));Qa=M}M=Pa;do{U=h+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Qa}while((M|0)<(N|0));f[z+(E<<2)>>2]=Qa;L=F;break}if(I?b[v+T>>0]|0:0){M=E+2|0;do if(!((M|0)>=(k|0)|C)){if(!(b[x+M>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}Q=f[t+(M<<2)>>2]|0;K=Q;while(1){S=f[h+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((Q|0)==(U|0))Ra=K;else{S=U;while(1){O=f[h+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=U;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Ra=O}O=Q;do{P=h+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=Ra}while((O|0)<(U|0));f[z+(E<<2)>>2]=Ra;L=F;break a}while(0);O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[h+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))Sa=U;else{P=Q;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;S=Q;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Sa=K}K=O;do{S=h+(K<<2)|0;Q=K;K=f[S>>2]|0;f[S>>2]=Sa}while((K|0)<(Q|0));f[z+(E<<2)>>2]=Sa;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;if(!(b[x+N>>0]|0)){K=f[t+(M<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;Q=K;while(1){S=f[h+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((K|0)==(O|0))Ta=Q;else{S=O;while(1){U=f[h+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(Q|0)>(S|0)?S:Q;P=O;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<($|0));Ta=U}U=K;do{P=h+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=Ta}while((U|0)<(O|0));f[z+(E<<2)>>2]=Ta;L=F;break a}if(!(b[y+G>>0]|0)){U=f[t+(M<<2)>>2]|0;K=f[z+(N<<2)>>2]|0;O=U;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))Ua=O;else{P=K;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;S=K;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=Q}while((S|0)<(V|0));Ua=Q}Q=U;do{S=h+(Q<<2)|0;K=Q;Q=f[S>>2]|0;f[S>>2]=Ua}while((Q|0)<(K|0));f[z+(E<<2)>>2]=Ua;L=F;break a}Q=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}U=f[t+(M<<2)>>2]|0;K=U;while(1){S=f[h+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((U|0)==(Q|0))Va=K;else{S=Q;while(1){O=f[h+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=Q;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Va=O}O=U;do{P=h+(O<<2)|0;Q=O;O=f[P>>2]|0;f[P>>2]=Va}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Va;L=F;break a}while(0);if(!(b[x+E>>0]|0)){O=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=O;while(1){P=f[h+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}if((O|0)==(U|0))Wa=Q;else{P=U;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(Q|0)>(P|0)?P:Q;S=U;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Wa=K}K=O;do{S=h+(K<<2)|0;U=K;K=f[S>>2]|0;f[S>>2]=Wa}while((K|0)<(U|0));f[z+(E<<2)>>2]=Wa;L=F;break a}if(!(b[x+N>>0]|0)){K=f[t+(E<<2)>>2]|0;O=f[t+(M<<2)>>2]|0;U=K;while(1){S=f[h+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((K|0)==(O|0))Xa=U;else{S=O;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;P=O;do{V=h+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=Q}while((P|0)<($|0));Xa=Q}Q=K;do{P=h+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=Xa}while((Q|0)<(O|0));Q=f[z+(N<<2)>>2]|0;K=Xa;while(1){O=f[h+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}if((Xa|0)==(Q|0))Ya=K;else{O=Q;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(K|0)>(O|0)?O:K;U=Q;do{S=h+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=P}while((U|0)<($|0));Ya=P}P=Xa;do{U=h+(P<<2)|0;Q=P;P=f[U>>2]|0;f[U>>2]=Ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=Ya;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;P=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=P;while(1){K=f[h+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((P|0)==(Q|0))Za=U;else{K=Q;while(1){O=f[h+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(U|0)>(K|0)?K:U;$=Q;do{S=h+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=O}while(($|0)<(V|0));Za=O}O=P;do{$=h+(O<<2)|0;Q=O;O=f[$>>2]|0;f[$>>2]=Za}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Za;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;P=f[t+(M<<2)>>2]|0;Q=O;while(1){$=f[h+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((O|0)==(P|0))_a=Q;else{$=P;while(1){U=f[h+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;K=P;do{V=h+(K<<2)|0;S=K;K=f[V>>2]|0;f[V>>2]=U}while((K|0)<(S|0));_a=U}U=O;do{K=h+(U<<2)|0;P=U;U=f[K>>2]|0;f[K>>2]=_a}while((U|0)<(P|0));U=f[z+(N<<2)>>2]|0;O=_a;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((_a|0)==(U|0))$a=O;else{P=U;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(O|0)>(P|0)?P:O;Q=U;do{$=h+(Q<<2)|0;S=Q;Q=f[$>>2]|0;f[$>>2]=K}while((Q|0)<(S|0));$a=K}K=_a;do{Q=h+(K<<2)|0;U=K;K=f[Q>>2]|0;f[Q>>2]=$a}while((K|0)<(U|0));f[z+(E<<2)>>2]=$a;L=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=K;while(1){O=f[h+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((K|0)==(U|0))ab=Q;else{O=U;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(Q|0)>(O|0)?O:Q;S=U;do{$=h+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=P}while((S|0)<(V|0));ab=P}P=K;do{S=h+(P<<2)|0;U=P;P=f[S>>2]|0;f[S>>2]=ab}while((P|0)<(U|0));f[z+(E<<2)>>2]=ab;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;K=f[t+(M<<2)>>2]|0;U=P;while(1){S=f[h+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((P|0)==(K|0))bb=U;else{S=K;while(1){Q=f[h+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=K;do{V=h+(O<<2)|0;$=O;O=f[V>>2]|0;f[V>>2]=Q}while((O|0)<($|0));bb=Q}Q=P;do{O=h+(Q<<2)|0;K=Q;Q=f[O>>2]|0;f[O>>2]=bb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;P=bb;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((bb|0)==(Q|0))cb=P;else{K=Q;while(1){O=f[h+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(P|0)>(K|0)?K:P;U=Q;do{S=h+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));cb=O}O=bb;do{U=h+(O<<2)|0;Q=O;O=f[U>>2]|0;f[U>>2]=cb}while((O|0)<(Q|0));f[z+(E<<2)>>2]=cb;L=F;break a}if(!(b[x+G>>0]|0)){O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[h+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))db=U;else{P=Q;while(1){K=f[h+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;$=Q;do{S=h+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=K}while(($|0)<(V|0));db=K}K=O;do{$=h+(K<<2)|0;Q=K;K=f[$>>2]|0;f[$>>2]=db}while((K|0)<(Q|0));f[z+(E<<2)>>2]=db;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;if(b[y+E>>0]|0){O=f[z+(N<<2)>>2]|0;Q=K;while(1){$=f[h+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((K|0)==(O|0))eb=Q;else{$=O;while(1){U=f[h+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;P=O;do{V=h+(P<<2)|0;S=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<(S|0));eb=U}U=K;do{P=h+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=eb}while((U|0)<(O|0));f[z+(E<<2)>>2]=eb;L=F;break a}U=f[t+(N<<2)>>2]|0;O=U;while(1){P=f[h+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))fb=O;else{P=K;while(1){Q=f[h+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;$=K;do{S=h+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=Q}while(($|0)<(V|0));fb=Q}Q=U;do{$=h+(Q<<2)|0;K=Q;Q=f[$>>2]|0;f[$>>2]=fb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;U=fb;while(1){K=f[h+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((fb|0)==(Q|0))gb=U;else{K=Q;while(1){$=f[h+(K<<2)>>2]|0;if(($|0)<(K|0))K=$;else break}$=(U|0)>(K|0)?K:U;O=Q;do{P=h+(O<<2)|0;V=O;O=f[P>>2]|0;f[P>>2]=$}while((O|0)<(V|0));gb=$}$=fb;do{O=h+($<<2)|0;Q=$;$=f[O>>2]|0;f[O>>2]=gb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=gb;L=F;break a}while(0);$=f[t+(N<<2)>>2]|0;Q=f[t+(M<<2)>>2]|0;O=$;while(1){U=f[h+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if(($|0)==(Q|0))hb=O;else{U=Q;while(1){K=f[h+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}K=(O|0)>(U|0)?U:O;V=Q;do{P=h+(V<<2)|0;S=V;V=f[P>>2]|0;f[P>>2]=K}while((V|0)<(S|0));hb=K}K=$;do{V=h+(K<<2)|0;Q=K;K=f[V>>2]|0;f[V>>2]=hb}while((K|0)<(Q|0));K=f[z+(N<<2)>>2]|0;$=hb;while(1){Q=f[h+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}if((hb|0)==(K|0))ib=$;else{N=K;while(1){Q=f[h+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=($|0)>(N|0)?N:$;V=K;do{O=h+(V<<2)|0;U=V;V=f[O>>2]|0;f[O>>2]=Q}while((V|0)<(U|0));ib=Q}Q=hb;do{V=h+(Q<<2)|0;K=Q;Q=f[V>>2]|0;f[V>>2]=ib}while((Q|0)<(K|0));f[z+(E<<2)>>2]=ib;L=F;break a}while(0);do if(B){M=E+-2|0;if(b[x+G>>0]|0){T=f[z+(M<<2)>>2]|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);I=f[t+(M<<2)>>2]|0;Q=I;while(1){K=f[h+(Q<<2)>>2]|0;if((K|0)<(Q|0))Q=K;else break}if((I|0)==(T|0))jb=Q;else{K=T;while(1){V=f[h+(K<<2)>>2]|0;if((V|0)<(K|0))K=V;else break}V=(Q|0)>(K|0)?K:Q;$=T;do{N=h+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=V}while(($|0)<(U|0));jb=V}V=I;do{$=h+(V<<2)|0;T=V;V=f[$>>2]|0;f[$>>2]=jb}while((V|0)<(T|0));f[z+(E<<2)>>2]=jb;L=F;break a}if(!(b[x+E>>0]|0)){kb=M;break}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(!(b[x+M>>0]|0)){V=f[t+(E<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;T=V;while(1){$=f[h+(T<<2)>>2]|0;if(($|0)<(T|0))T=$;else break}if((V|0)==(I|0))lb=T;else{$=I;while(1){Q=f[h+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}Q=(T|0)>($|0)?$:T;K=I;do{U=h+(K<<2)|0;N=K;K=f[U>>2]|0;f[U>>2]=Q}while((K|0)<(N|0));lb=Q}Q=V;do{K=h+(Q<<2)|0;I=Q;Q=f[K>>2]|0;f[K>>2]=lb}while((Q|0)<(I|0));f[z+(E<<2)>>2]=lb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;V=f[z+(M<<2)>>2]|0;I=Q;while(1){K=f[h+(I<<2)>>2]|0;if((K|0)<(I|0))I=K;else break}if((Q|0)==(V|0))mb=I;else{K=V;while(1){T=f[h+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(I|0)>(K|0)?K:I;$=V;do{N=h+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=T}while(($|0)<(U|0));mb=T}T=Q;do{$=h+(T<<2)|0;V=T;T=f[$>>2]|0;f[$>>2]=mb}while((T|0)<(V|0));f[z+(E<<2)>>2]=mb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[z+(M<<2)>>2]|0;V=T;while(1){$=f[h+(V<<2)>>2]|0;if(($|0)<(V|0))V=$;else break}if((T|0)==(Q|0))nb=V;else{M=Q;while(1){$=f[h+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}$=(V|0)>(M|0)?M:V;I=Q;do{K=h+(I<<2)|0;U=I;I=f[K>>2]|0;f[K>>2]=$}while((I|0)<(U|0));nb=$}$=T;do{I=h+($<<2)|0;Q=$;$=f[I>>2]|0;f[I>>2]=nb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=nb;L=F;break a}else kb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(kb<<2)>>2];L=F;break}do if(B){$=E+-2|0;if(b[x+G>>0]|0){T=f[z+($<<2)>>2]|0;do if(($|0)>-1){if(!(b[v+$>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);Q=f[t+($<<2)>>2]|0;I=Q;while(1){V=f[h+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((Q|0)==(T|0))ob=I;else{V=T;while(1){M=f[h+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;U=T;do{K=h+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=M}while((U|0)<(N|0));ob=M}M=Q;do{U=h+(M<<2)|0;T=M;M=f[U>>2]|0;f[U>>2]=ob}while((M|0)<(T|0));f[z+(E<<2)>>2]=ob;L=F;break a}if(!(b[x+E>>0]|0)){pb=$;break}do if(($|0)>-1){if(!(b[v+$>>0]|0))break;if(!(b[x+$>>0]|0)){M=f[t+(E<<2)>>2]|0;Q=f[z+($<<2)>>2]|0;T=M;while(1){U=f[h+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((M|0)==(Q|0))qb=T;else{U=Q;while(1){I=f[h+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(T|0)>(U|0)?U:T;V=Q;do{N=h+(V<<2)|0;K=V;V=f[N>>2]|0;f[N>>2]=I}while((V|0)<(K|0));qb=I}I=M;do{V=h+(I<<2)|0;Q=I;I=f[V>>2]|0;f[V>>2]=qb}while((I|0)<(Q|0));f[z+(E<<2)>>2]=qb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+($<<2)>>2];L=F;break a}while(0);I=f[t+(E<<2)>>2]|0;M=f[z+($<<2)>>2]|0;Q=I;while(1){V=f[h+(Q<<2)>>2]|0;if((V|0)<(Q|0))Q=V;else break}if((I|0)==(M|0))rb=Q;else{V=M;while(1){T=f[h+(V<<2)>>2]|0;if((T|0)<(V|0))V=T;else break}T=(Q|0)>(V|0)?V:Q;U=M;do{K=h+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=T}while((U|0)<(N|0));rb=T}T=I;do{U=h+(T<<2)|0;M=T;T=f[U>>2]|0;f[U>>2]=rb}while((T|0)<(M|0));f[z+(E<<2)>>2]=rb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;I=f[z+($<<2)>>2]|0;M=T;while(1){U=f[h+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((T|0)==(I|0))sb=M;else{$=I;while(1){U=f[h+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(M|0)>($|0)?$:M;Q=I;do{V=h+(Q<<2)|0;N=Q;Q=f[V>>2]|0;f[V>>2]=U}while((Q|0)<(N|0));sb=U}U=T;do{Q=h+(U<<2)|0;I=U;U=f[Q>>2]|0;f[Q>>2]=sb}while((U|0)<(I|0));f[z+(E<<2)>>2]=sb;L=F;break a}else pb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(pb<<2)>>2];L=F;break}}U=E|1;T=(U|0)<(k|0);if(!(C|T^1)?b[x+U>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(H?b[x+G>>0]|0:0){I=f[t+(E<<2)>>2]|0;do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=I;L=F;break a}while(0);Q=f[t+(E+-2<<2)>>2]|0;M=Q;while(1){$=f[h+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}if((Q|0)==(I|0))tb=M;else{$=I;while(1){N=f[h+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(M|0)>($|0)?$:M;V=I;do{K=h+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=N}while((V|0)<(O|0));tb=N}N=Q;do{V=h+(N<<2)|0;I=N;N=f[V>>2]|0;f[V>>2]=tb}while((N|0)<(I|0));f[z+(E<<2)>>2]=tb;L=F;break}f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(T?b[v+U>>0]|0:0){N=E+2|0;if(!((N|0)>=(k|0)|C)?b[x+N>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+U>>0]|0))break;f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[t+(N<<2)>>2]|0;I=T;while(1){V=f[h+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((T|0)==(Q|0))ub=I;else{V=Q;while(1){M=f[h+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;$=Q;do{O=h+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=M}while(($|0)<(K|0));ub=M}M=T;do{$=h+(M<<2)|0;Q=M;M=f[$>>2]|0;f[$>>2]=ub}while((M|0)<(Q|0));f[z+(E<<2)>>2]=ub;L=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+U>>0]|0))break;M=f[t+(N<<2)>>2]|0;if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}T=f[t+(E+-2<<2)>>2]|0;Q=T;while(1){$=f[h+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((T|0)==(M|0))vb=Q;else{$=M;while(1){I=f[h+($<<2)>>2]|0;if((I|0)<($|0))$=I;else break}I=(Q|0)>($|0)?$:Q;V=M;do{K=h+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=I}while((V|0)<(O|0));vb=I}I=T;do{V=h+(I<<2)|0;M=I;I=f[V>>2]|0;f[V>>2]=vb}while((I|0)<(M|0));f[z+(E<<2)>>2]=vb;L=F;break a}while(0);I=f[t+(E+-2<<2)>>2]|0;T=f[t+(N<<2)>>2]|0;M=I;while(1){V=f[h+(M<<2)>>2]|0;if((V|0)<(M|0))M=V;else break}if((I|0)==(T|0))wb=M;else{V=T;while(1){Q=f[h+(V<<2)>>2]|0;if((Q|0)<(V|0))V=Q;else break}Q=(M|0)>(V|0)?V:M;$=T;do{O=h+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=Q}while(($|0)<(K|0));wb=Q}Q=I;do{$=h+(Q<<2)|0;T=Q;Q=f[$>>2]|0;f[$>>2]=wb}while((Q|0)<(T|0));f[z+(E<<2)>>2]=wb;L=F;break a}while(0);f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=F;f[h+(F<<2)>>2]=F;L=F+1|0}while(0);E=E+2|0;if((E|0)>=(k|0)){xb=L;break}else F=L}}else xb=r;s=s+2|0;if((s|0)>=(i|0))break;else r=xb}if((xb|0)>1){r=1;i=1;while(1){s=h+(i<<2)|0;L=f[s>>2]|0;if((L|0)<(i|0)){f[s>>2]=f[h+(L<<2)>>2];yb=r}else{f[s>>2]=r;yb=r+1|0}i=i+1|0;if((i|0)==(xb|0)){zb=yb;break}else r=yb}}else zb=1}else zb=1;ywa(g,zb);yb=f[j>>2]|0;r=f[o>>2]|0;xb=(r&1|0)!=0;i=(yb|0)>0;b:do if(!(yb&1)){if(!xb){if(!i)break;s=c+16|0;L=c+44|0;k=d+16|0;wb=d+44|0;vb=g+20|0;ub=g+120|0;tb=g+48|0;pb=0;sb=r;rb=yb;while(1){qb=f[f[L>>2]>>2]|0;ob=(f[s>>2]|0)+(Y(qb,pb)|0)|0;kb=ob+qb|0;qb=f[f[wb>>2]>>2]|0;nb=(f[k>>2]|0)+(Y(qb,pb)|0)|0;mb=nb+qb|0;if((sb|0)>0){qb=((pb|0)<0)<<31>>31;lb=pb|1;jb=((lb|0)<0)<<31>>31;ib=0;do{hb=nb+(ib<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){fb=f[h+(gb<<2)>>2]|0;if(!(b[ob+ib>>0]|0)){f[hb>>2]=0;eb=f[vb>>2]|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(ib|0)?ib:cb;cb=eb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(pb|0)?pb:db;db=eb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(pb|0)?pb:cb;cb=eb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[ub>>2]|0;db=cb;bb=d1c(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=cb;f[db>>2]=bb;f[db+4>>2]=J;Ab=cb+8|0;Bb=eb;Cb=cb}else{f[hb>>2]=fb;cb=f[vb>>2]|0;eb=cb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(ib|0)?ib:bb;bb=eb+4|0;db=f[bb>>2]|0;f[bb>>2]=(db|0)>(pb|0)?pb:db;db=eb+12|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(pb|0)?pb:bb;bb=eb+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=f[ub>>2]|0;eb=bb+(fb<<4)|0;db=eb;ab=d1c(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=eb;f[db>>2]=ab;f[db+4>>2]=J;Ab=bb+(fb<<4)+8|0;Bb=cb;Cb=bb}bb=Ab;cb=d1c(f[bb>>2]|0,f[bb+4>>2]|0,pb|0,qb|0)|0;bb=Ab;f[bb>>2]=cb;f[bb+4>>2]=J;bb=ib|1;cb=nb+(bb<<2)|0;if(!(b[ob+bb>>0]|0)){f[cb>>2]=0;Db=0;Eb=Bb}else{f[cb>>2]=fb;Db=fb;Eb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}cb=f[Eb>>2]|0;f[Eb>>2]=(cb|0)>(bb|0)?bb:cb;cb=Eb+8|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(bb|0)?bb:db;db=Eb+4|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)>(pb|0)?pb:cb;cb=Eb+12|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(pb|0)?pb:db;db=Eb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(Db<<4)|0;cb=db;ab=d1c(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;cb=db;f[cb>>2]=ab;f[cb+4>>2]=J;cb=Cb+(Db<<4)+8|0;ab=cb;db=d1c(f[ab>>2]|0,f[ab+4>>2]|0,pb|0,qb|0)|0;ab=cb;f[ab>>2]=db;f[ab+4>>2]=J;ab=mb+(ib<<2)|0;if(!(b[kb+ib>>0]|0)){f[ab>>2]=0;Fb=0;Gb=Bb}else{f[ab>>2]=fb;Fb=fb;Gb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}ab=f[Gb>>2]|0;f[Gb>>2]=(ab|0)>(ib|0)?ib:ab;ab=Gb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(ib|0)?ib:db;db=Gb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=Gb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=Gb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(Fb<<4)|0;ab=db;cb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;ab=db;f[ab>>2]=cb;f[ab+4>>2]=J;ab=Cb+(Fb<<4)+8|0;cb=ab;db=d1c(f[cb>>2]|0,f[cb+4>>2]|0,lb|0,jb|0)|0;cb=ab;f[cb>>2]=db;f[cb+4>>2]=J;cb=mb+(bb<<2)|0;if(!(b[kb+bb>>0]|0)){f[cb>>2]=0;db=f[Bb>>2]|0;f[Bb>>2]=(db|0)>(bb|0)?bb:db;db=Bb+8|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(bb|0)?bb:ab;ab=Bb+4|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)>(lb|0)?lb:db;db=Bb+12|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(lb|0)?lb:ab;ab=Bb+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=Cb;db=d1c(f[ab>>2]|0,f[ab+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;ab=Cb;f[ab>>2]=db;f[ab+4>>2]=J;Hb=Cb+8|0;break}else{f[cb>>2]=fb;cb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;ab=f[cb>>2]|0;f[cb>>2]=(ab|0)>(bb|0)?bb:ab;ab=cb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(bb|0)?bb:db;db=cb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=cb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=cb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(fb<<4)|0;cb=db;ab=d1c(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;bb=db;f[bb>>2]=ab;f[bb+4>>2]=J;Hb=Cb+(fb<<4)+8|0;break}}else{f[hb>>2]=0;fb=ib|1;f[nb+(fb<<2)>>2]=0;f[mb+(ib<<2)>>2]=0;f[mb+(fb<<2)>>2]=0;bb=f[vb>>2]|0;ab=f[bb>>2]|0;db=(ab|0)>(ib|0)?ib:ab;ab=bb+8|0;cb=f[ab>>2]|0;eb=(cb|0)<(ib|0)?ib:cb;cb=bb+4|0;$a=f[cb>>2]|0;_a=($a|0)>(pb|0)?pb:$a;$a=bb+12|0;Za=f[$a>>2]|0;Ya=(Za|0)<(pb|0)?pb:Za;Za=bb+16|0;Xa=f[Za>>2]|0;Wa=f[ub>>2]|0;Va=((ib|0)<0)<<31>>31;Ua=Wa;Ta=d1c(f[Ua>>2]|0,f[Ua+4>>2]|0,ib|0,Va|0)|0;Ua=J;Sa=Wa+8|0;Ra=Sa;Qa=d1c(f[Ra>>2]|0,f[Ra+4>>2]|0,pb|0,qb|0)|0;Ra=J;Pa=(db|0)>(fb|0)?fb:db;db=((fb|0)<0)<<31>>31;Oa=d1c(Ta|0,Ua|0,fb|0,db|0)|0;Ua=J;Ta=d1c(Qa|0,Ra|0,pb|0,qb|0)|0;Ra=J;Qa=d1c(Oa|0,Ua|0,ib|0,Va|0)|0;Va=J;Ua=d1c(Ta|0,Ra|0,lb|0,jb|0)|0;Ra=Sa;f[Ra>>2]=Ua;f[Ra+4>>2]=J;f[bb>>2]=(Pa|0)>(ib|0)?ib:Pa;f[ab>>2]=(eb|0)<(fb|0)?fb:eb;f[cb>>2]=(_a|0)>(lb|0)?lb:_a;f[$a>>2]=(Ya|0)<(lb|0)?lb:Ya;f[Za>>2]=Xa+4;Xa=d1c(Qa|0,Va|0,fb|0,db|0)|0;db=Wa;f[db>>2]=Xa;f[db+4>>2]=J;Hb=Sa}while(0);hb=Hb;gb=d1c(f[hb>>2]|0,f[hb+4>>2]|0,lb|0,jb|0)|0;hb=Hb;f[hb>>2]=gb;f[hb+4>>2]=J;ib=ib+2|0;Ib=f[o>>2]|0}while((ib|0)<(Ib|0));Jb=f[j>>2]|0;Kb=Ib}else{Jb=rb;Kb=sb}pb=pb+2|0;if((pb|0)>=(Jb|0))break b;else{sb=Kb;rb=Jb}}}if(i){rb=g+20|0;sb=g+120|0;pb=g+48|0;ub=f[c+16>>2]|0;vb=f[c+44>>2]|0;tb=f[d+16>>2]|0;k=f[d+44>>2]|0;wb=0;s=r;L=yb;while(1){ib=f[vb>>2]|0;jb=ub+(Y(ib,wb)|0)|0;lb=jb+ib|0;ib=f[k>>2]|0;qb=tb+(Y(ib,wb)|0)|0;mb=qb+ib|0;if((s|0)>0){ib=((wb|0)<0)<<31>>31;nb=wb|1;kb=((nb|0)<0)<<31>>31;ob=0;do{hb=qb+(ob<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){G=f[h+(gb<<2)>>2]|0;if(!(b[jb+ob>>0]|0)){f[hb>>2]=0;H=f[rb>>2]|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ob|0)?ob:db;db=H+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(wb|0)?wb:Sa;Sa=H+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(wb|0)?wb:db;db=H+16|0;f[db>>2]=(f[db>>2]|0)+1;db=f[sb>>2]|0;Sa=db;Xa=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Lb=db+8|0;Mb=H;Nb=db}else{f[hb>>2]=G;db=f[rb>>2]|0;H=db+(Y(f[f[pb>>2]>>2]|0,G)|0)|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ob|0)?ob:Xa;Xa=H+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(wb|0)?wb:Sa;Sa=H+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(wb|0)?wb:Xa;Xa=H+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[sb>>2]|0;H=Xa+(G<<4)|0;Sa=H;Wa=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Lb=Xa+(G<<4)+8|0;Mb=db;Nb=Xa}Xa=Lb;db=d1c(f[Xa>>2]|0,f[Xa+4>>2]|0,wb|0,ib|0)|0;Xa=Lb;f[Xa>>2]=db;f[Xa+4>>2]=J;Xa=mb+(ob<<2)|0;if(!(b[lb+ob>>0]|0)){f[Xa>>2]=0;Ob=0;Pb=Mb}else{f[Xa>>2]=G;Ob=G;Pb=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0}Xa=f[Pb>>2]|0;f[Pb>>2]=(Xa|0)>(ob|0)?ob:Xa;Xa=Pb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ob|0)?ob:db;db=Pb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Pb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Pb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Nb+(Ob<<4)|0;Xa=db;Sa=d1c(f[Xa>>2]|0,f[Xa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Xa=db;f[Xa>>2]=Sa;f[Xa+4>>2]=J;Xa=Nb+(Ob<<4)+8|0;Sa=Xa;db=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,nb|0,kb|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;Sa=ob|1;if((Sa|0)<(f[o>>2]|0)){db=qb+(Sa<<2)|0;if(!(b[jb+Sa>>0]|0)){f[db>>2]=0;Qb=0;Rb=Mb}else{f[db>>2]=G;Qb=G;Rb=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0}db=f[Rb>>2]|0;f[Rb>>2]=(db|0)>(Sa|0)?Sa:db;db=Rb+8|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(Sa|0)?Sa:Xa;Xa=Rb+4|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)>(wb|0)?wb:db;db=Rb+12|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(wb|0)?wb:Xa;Xa=Rb+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=Nb+(Qb<<4)|0;db=Xa;Wa=d1c(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Xa;f[db>>2]=Wa;f[db+4>>2]=J;db=Nb+(Qb<<4)+8|0;Wa=db;Xa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,wb|0,ib|0)|0;Wa=db;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=mb+(Sa<<2)|0;if(!(b[lb+Sa>>0]|0)){f[Wa>>2]=0;Xa=f[Mb>>2]|0;f[Mb>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Mb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(Sa|0)?Sa:db;db=Mb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Mb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Mb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Nb;Xa=d1c(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Nb;f[db>>2]=Xa;f[db+4>>2]=J;db=Nb+8|0;Xa=db;H=d1c(f[Xa>>2]|0,f[Xa+4>>2]|0,nb|0,kb|0)|0;Xa=db;f[Xa>>2]=H;f[Xa+4>>2]=J;break}else{f[Wa>>2]=G;Wa=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Wa+8|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(Sa|0)?Sa:H;H=Wa+4|0;Xa=f[H>>2]|0;f[H>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Wa+12|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(nb|0)?nb:H;H=Wa+16|0;f[H>>2]=(f[H>>2]|0)+1;H=Nb+(G<<4)|0;Wa=H;Xa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=Nb+(G<<4)+8|0;G=Sa;Xa=d1c(f[G>>2]|0,f[G+4>>2]|0,nb|0,kb|0)|0;G=Sa;f[G>>2]=Xa;f[G+4>>2]=J;break}}}else{f[hb>>2]=0;f[mb+(ob<<2)>>2]=0;G=f[rb>>2]|0;Xa=f[G>>2]|0;Sa=G+8|0;H=f[Sa>>2]|0;Wa=G+4|0;db=f[Wa>>2]|0;fb=(db|0)>(wb|0)?wb:db;db=G+12|0;Va=f[db>>2]|0;Qa=(Va|0)<(wb|0)?wb:Va;Va=G+16|0;Za=f[Va>>2]|0;Ya=f[sb>>2]|0;$a=((ob|0)<0)<<31>>31;_a=Ya;cb=d1c(f[_a>>2]|0,f[_a+4>>2]|0,ob|0,$a|0)|0;_a=J;eb=Ya+8|0;ab=eb;Pa=d1c(f[ab>>2]|0,f[ab+4>>2]|0,wb|0,ib|0)|0;ab=J;f[G>>2]=(Xa|0)>(ob|0)?ob:Xa;f[Sa>>2]=(H|0)<(ob|0)?ob:H;f[Wa>>2]=(fb|0)>(nb|0)?nb:fb;f[db>>2]=(Qa|0)<(nb|0)?nb:Qa;f[Va>>2]=Za+2;Za=d1c(cb|0,_a|0,ob|0,$a|0)|0;$a=J;_a=Ya;f[_a>>2]=Za;f[_a+4>>2]=$a;_a=d1c(Pa|0,ab|0,nb|0,kb|0)|0;ab=J;Pa=eb;f[Pa>>2]=_a;f[Pa+4>>2]=ab;Pa=ob|1;if((Pa|0)<(f[o>>2]|0)){f[qb+(Pa<<2)>>2]=0;f[mb+(Pa<<2)>>2]=0;cb=f[G>>2]|0;Qa=f[Sa>>2]|0;fb=f[Wa>>2]|0;H=(fb|0)>(wb|0)?wb:fb;fb=f[db>>2]|0;Xa=(fb|0)<(wb|0)?wb:fb;fb=f[Va>>2]|0;bb=((Pa|0)<0)<<31>>31;Ra=d1c(Za|0,$a|0,Pa|0,bb|0)|0;$a=J;Za=d1c(_a|0,ab|0,wb|0,ib|0)|0;ab=J;f[G>>2]=(cb|0)>(Pa|0)?Pa:cb;f[Sa>>2]=(Qa|0)<(Pa|0)?Pa:Qa;f[Wa>>2]=(H|0)>(nb|0)?nb:H;f[db>>2]=(Xa|0)<(nb|0)?nb:Xa;f[Va>>2]=fb+2;fb=d1c(Ra|0,$a|0,Pa|0,bb|0)|0;bb=Ya;f[bb>>2]=fb;f[bb+4>>2]=J;bb=d1c(Za|0,ab|0,nb|0,kb|0)|0;ab=eb;f[ab>>2]=bb;f[ab+4>>2]=J}}while(0);ob=ob+2|0;Sb=f[o>>2]|0}while((ob|0)<(Sb|0));Tb=f[j>>2]|0;Ub=Sb}else{Tb=L;Ub=s}wb=wb+2|0;if((wb|0)>=(Tb|0))break;else{s=Ub;L=Tb}}}}else{if(!xb){if(!i)break;L=g+20|0;s=g+120|0;wb=g+48|0;sb=f[c+16>>2]|0;rb=f[c+44>>2]|0;pb=f[d+16>>2]|0;tb=f[d+44>>2]|0;k=0;ub=r;vb=yb;while(1){ob=f[rb>>2]|0;kb=sb+(Y(ob,k)|0)|0;nb=kb+ob|0;ob=f[tb>>2]|0;ib=pb+(Y(ob,k)|0)|0;mb=ib+ob|0;if((ub|0)>0){ob=((k|0)<0)<<31>>31;qb=k|1;lb=((qb|0)<0)<<31>>31;jb=0;do{hb=ib+(jb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){ab=f[h+(gb<<2)>>2]|0;if(!(b[kb+jb>>0]|0)){f[hb>>2]=0;bb=f[L>>2]|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(jb|0)?jb:Za;Za=bb+4|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(k|0)?k:eb;eb=bb+12|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(k|0)?k:Za;Za=bb+16|0;f[Za>>2]=(f[Za>>2]|0)+1;Za=f[s>>2]|0;eb=Za;fb=d1c(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=Za;f[eb>>2]=fb;f[eb+4>>2]=J;Vb=Za+8|0;Wb=bb;Xb=Za}else{f[hb>>2]=ab;Za=f[L>>2]|0;bb=Za+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(jb|0)?jb:fb;fb=bb+4|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)>(k|0)?k:eb;eb=bb+12|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(k|0)?k:fb;fb=bb+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=f[s>>2]|0;bb=fb+(ab<<4)|0;eb=bb;Ya=d1c(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=bb;f[eb>>2]=Ya;f[eb+4>>2]=J;Vb=fb+(ab<<4)+8|0;Wb=Za;Xb=fb}fb=Vb;Za=d1c(f[fb>>2]|0,f[fb+4>>2]|0,k|0,ob|0)|0;fb=Vb;f[fb>>2]=Za;f[fb+4>>2]=J;fb=jb|1;Za=ib+(fb<<2)|0;if(!(b[kb+fb>>0]|0)){f[Za>>2]=0;Yb=0;Zb=Wb}else{f[Za>>2]=ab;Yb=ab;Zb=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0}Za=f[Zb>>2]|0;f[Zb>>2]=(Za|0)>(fb|0)?fb:Za;Za=Zb+8|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(fb|0)?fb:eb;eb=Zb+4|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)>(k|0)?k:Za;Za=Zb+12|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(k|0)?k:eb;eb=Zb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Xb+(Yb<<4)|0;Za=eb;Ya=d1c(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Za=eb;f[Za>>2]=Ya;f[Za+4>>2]=J;Za=Xb+(Yb<<4)+8|0;Ya=Za;eb=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,k|0,ob|0)|0;Ya=Za;f[Ya>>2]=eb;f[Ya+4>>2]=J;if((qb|0)<(f[j>>2]|0)){Ya=mb+(jb<<2)|0;if(!(b[nb+jb>>0]|0)){f[Ya>>2]=0;_b=0;$b=Wb}else{f[Ya>>2]=ab;_b=ab;$b=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0}Ya=f[$b>>2]|0;f[$b>>2]=(Ya|0)>(jb|0)?jb:Ya;Ya=$b+8|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(jb|0)?jb:eb;eb=$b+4|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)>(qb|0)?qb:Ya;Ya=$b+12|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(qb|0)?qb:eb;eb=$b+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Xb+(_b<<4)|0;Ya=eb;Za=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;Ya=eb;f[Ya>>2]=Za;f[Ya+4>>2]=J;Ya=Xb+(_b<<4)+8|0;Za=Ya;eb=d1c(f[Za>>2]|0,f[Za+4>>2]|0,qb|0,lb|0)|0;Za=Ya;f[Za>>2]=eb;f[Za+4>>2]=J;Za=mb+(fb<<2)|0;if(!(b[nb+fb>>0]|0)){f[Za>>2]=0;eb=f[Wb>>2]|0;f[Wb>>2]=(eb|0)>(fb|0)?fb:eb;eb=Wb+8|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(fb|0)?fb:Ya;Ya=Wb+4|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)>(qb|0)?qb:eb;eb=Wb+12|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(qb|0)?qb:Ya;Ya=Wb+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=Xb;eb=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Ya=Xb;f[Ya>>2]=eb;f[Ya+4>>2]=J;Ya=Xb+8|0;eb=Ya;bb=d1c(f[eb>>2]|0,f[eb+4>>2]|0,qb|0,lb|0)|0;eb=Ya;f[eb>>2]=bb;f[eb+4>>2]=J;break}else{f[Za>>2]=ab;Za=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(fb|0)?fb:eb;eb=Za+8|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(fb|0)?fb:bb;bb=Za+4|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(qb|0)?qb:eb;eb=Za+12|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(qb|0)?qb:bb;bb=Za+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=Xb+(ab<<4)|0;Za=bb;eb=d1c(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;fb=bb;f[fb>>2]=eb;f[fb+4>>2]=J;fb=Xb+(ab<<4)+8|0;ab=fb;eb=d1c(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,lb|0)|0;ab=fb;f[ab>>2]=eb;f[ab+4>>2]=J;break}}}else{f[hb>>2]=0;ab=jb|1;f[ib+(ab<<2)>>2]=0;eb=f[L>>2]|0;fb=f[eb>>2]|0;bb=(fb|0)>(jb|0)?jb:fb;fb=eb+8|0;Za=f[fb>>2]|0;Ya=(Za|0)<(jb|0)?jb:Za;Za=eb+4|0;Pa=f[Za>>2]|0;$a=eb+12|0;Ra=f[$a>>2]|0;Va=eb+16|0;Xa=f[Va>>2]|0;db=f[s>>2]|0;H=((jb|0)<0)<<31>>31;Wa=db;Qa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,jb|0,H|0)|0;Wa=J;Sa=db+8|0;cb=Sa;G=d1c(f[cb>>2]|0,f[cb+4>>2]|0,k|0,ob|0)|0;cb=J;f[eb>>2]=(bb|0)>(ab|0)?ab:bb;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(Pa|0)>(k|0)?k:Pa;f[$a>>2]=(Ra|0)<(k|0)?k:Ra;f[Va>>2]=Xa+2;Xa=((ab|0)<0)<<31>>31;Ra=d1c(Qa|0,Wa|0,ab|0,Xa|0)|0;Wa=J;Qa=db;f[Qa>>2]=Ra;f[Qa+4>>2]=Wa;Qa=d1c(G|0,cb|0,k|0,ob|0)|0;cb=J;G=Sa;f[G>>2]=Qa;f[G+4>>2]=cb;if((qb|0)<(f[j>>2]|0)){f[mb+(jb<<2)>>2]=0;f[mb+(ab<<2)>>2]=0;G=f[eb>>2]|0;Pa=(G|0)>(jb|0)?jb:G;G=f[fb>>2]|0;Ya=(G|0)<(jb|0)?jb:G;G=f[Za>>2]|0;bb=f[$a>>2]|0;_a=f[Va>>2]|0;Ua=d1c(Ra|0,Wa|0,jb|0,H|0)|0;H=J;Wa=d1c(Qa|0,cb|0,qb|0,lb|0)|0;cb=J;f[eb>>2]=(Pa|0)>(ab|0)?ab:Pa;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(G|0)>(qb|0)?qb:G;f[$a>>2]=(bb|0)<(qb|0)?qb:bb;f[Va>>2]=_a+2;_a=d1c(Ua|0,H|0,ab|0,Xa|0)|0;Xa=db;f[Xa>>2]=_a;f[Xa+4>>2]=J;Xa=d1c(Wa|0,cb|0,qb|0,lb|0)|0;cb=Sa;f[cb>>2]=Xa;f[cb+4>>2]=J}}while(0);jb=jb+2|0;ac=f[o>>2]|0}while((jb|0)<(ac|0));bc=f[j>>2]|0;cc=ac}else{bc=vb;cc=ub}k=k+2|0;if((k|0)>=(bc|0))break b;else{ub=cc;vb=bc}}}if(i){vb=g+20|0;ub=g+120|0;k=g+48|0;s=f[c+16>>2]|0;L=f[c+44>>2]|0;wb=f[d+16>>2]|0;pb=f[d+44>>2]|0;tb=0;sb=r;rb=yb;while(1){jb=f[L>>2]|0;lb=s+(Y(jb,tb)|0)|0;qb=lb+jb|0;jb=f[pb>>2]|0;mb=wb+(Y(jb,tb)|0)|0;ob=mb+jb|0;if((sb|0)>0){jb=((tb|0)<0)<<31>>31;ib=tb|1;nb=((ib|0)<0)<<31>>31;kb=0;do{hb=mb+(kb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){cb=f[h+(gb<<2)>>2]|0;if(!(b[lb+kb>>0]|0)){f[hb>>2]=0;Xa=f[vb>>2]|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(kb|0)?kb:Wa;Wa=Xa+4|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=Xa+12|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(tb|0)?tb:Wa;Wa=Xa+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[ub>>2]|0;Sa=Wa;_a=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Wa;f[Sa>>2]=_a;f[Sa+4>>2]=J;dc=Wa+8|0;ec=Xa;fc=Wa}else{f[hb>>2]=cb;Wa=f[vb>>2]|0;Xa=Wa+(Y(f[f[k>>2]>>2]|0,cb)|0)|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(kb|0)?kb:_a;_a=Xa+4|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=Xa+12|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(tb|0)?tb:_a;_a=Xa+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[ub>>2]|0;Xa=_a+(cb<<4)|0;Sa=Xa;db=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;dc=_a+(cb<<4)+8|0;ec=Wa;fc=_a}_a=dc;Wa=d1c(f[_a>>2]|0,f[_a+4>>2]|0,tb|0,jb|0)|0;_a=dc;f[_a>>2]=Wa;f[_a+4>>2]=J;_a=kb|1;if((_a|0)>=(f[o>>2]|0)){if((ib|0)>=(f[j>>2]|0))break;Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;Sa=f[ec>>2]|0;f[ec>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=ec+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(kb|0)?kb:db;db=ec+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=ec+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ib|0)?ib:db;db=ec+16|0;f[db>>2]=(f[db>>2]|0)+1;db=fc;Sa=d1c(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=fc;f[db>>2]=Sa;f[db+4>>2]=J;db=fc+8|0;Sa=db;Xa=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}else{f[Wa>>2]=cb;Wa=ec+(Y(f[f[k>>2]>>2]|0,cb)|0)|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Wa+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=Wa+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=Wa+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=Wa+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(cb<<4)|0;Wa=Xa;Sa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=fc+(cb<<4)+8|0;Sa=Wa;Xa=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}}Sa=mb+(_a<<2)|0;if(!(b[lb+_a>>0]|0)){f[Sa>>2]=0;gc=0;hc=ec}else{f[Sa>>2]=cb;gc=cb;hc=ec+(Y(f[f[k>>2]>>2]|0,cb)|0)|0}Sa=f[hc>>2]|0;f[hc>>2]=(Sa|0)>(_a|0)?_a:Sa;Sa=hc+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(_a|0)?_a:Xa;Xa=hc+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=hc+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(tb|0)?tb:Xa;Xa=hc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(gc<<4)|0;Sa=Xa;Wa=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Sa=fc+(gc<<4)+8|0;Wa=Sa;Xa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,tb|0,jb|0)|0;Wa=Sa;f[Wa>>2]=Xa;f[Wa+4>>2]=J;if((ib|0)<(f[j>>2]|0)){Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;ic=0;jc=ec}else{f[Wa>>2]=cb;ic=cb;jc=ec+(Y(f[f[k>>2]>>2]|0,cb)|0)|0}Wa=f[jc>>2]|0;f[jc>>2]=(Wa|0)>(kb|0)?kb:Wa;Wa=jc+8|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=jc+4|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)>(ib|0)?ib:Wa;Wa=jc+12|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=jc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(ic<<4)|0;Wa=Xa;Sa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=fc+(ic<<4)+8|0;Sa=Wa;Xa=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=ob+(_a<<2)|0;if(!(b[qb+_a>>0]|0)){f[Sa>>2]=0;Xa=f[ec>>2]|0;f[ec>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=ec+8|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(_a|0)?_a:Wa;Wa=ec+4|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=ec+12|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(ib|0)?ib:Wa;Wa=ec+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=fc;Xa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Wa=fc;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=fc+8|0;Xa=Wa;db=d1c(f[Xa>>2]|0,f[Xa+4>>2]|0,ib|0,nb|0)|0;Xa=Wa;f[Xa>>2]=db;f[Xa+4>>2]=J;break}else{f[Sa>>2]=cb;Sa=ec+(Y(f[f[k>>2]>>2]|0,cb)|0)|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=Sa+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(_a|0)?_a:db;db=Sa+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=Sa+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ib|0)?ib:db;db=Sa+16|0;f[db>>2]=(f[db>>2]|0)+1;db=fc+(cb<<4)|0;Sa=db;Xa=d1c(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;_a=db;f[_a>>2]=Xa;f[_a+4>>2]=J;_a=fc+(cb<<4)+8|0;cb=_a;Xa=d1c(f[cb>>2]|0,f[cb+4>>2]|0,ib|0,nb|0)|0;cb=_a;f[cb>>2]=Xa;f[cb+4>>2]=J;break}}}else{f[hb>>2]=0;cb=f[vb>>2]|0;Xa=f[cb>>2]|0;f[cb>>2]=(Xa|0)>(kb|0)?kb:Xa;Xa=cb+8|0;_a=f[Xa>>2]|0;f[Xa>>2]=(_a|0)<(kb|0)?kb:_a;_a=cb+4|0;db=f[_a>>2]|0;f[_a>>2]=(db|0)>(tb|0)?tb:db;db=cb+12|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)<(tb|0)?tb:Sa;Sa=cb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Wa=f[ub>>2]|0;ab=((kb|0)<0)<<31>>31;H=Wa;Ua=d1c(f[H>>2]|0,f[H+4>>2]|0,kb|0,ab|0)|0;H=J;Va=Wa;f[Va>>2]=Ua;f[Va+4>>2]=H;Va=Wa+8|0;bb=Va;$a=d1c(f[bb>>2]|0,f[bb+4>>2]|0,tb|0,jb|0)|0;bb=J;G=Va;f[G>>2]=$a;f[G+4>>2]=bb;G=kb|1;if((G|0)<(f[o>>2]|0)){f[mb+(G<<2)>>2]=0;Za=f[cb>>2]|0;f[cb>>2]=(Za|0)>(G|0)?G:Za;Za=f[Xa>>2]|0;f[Xa>>2]=(Za|0)<(G|0)?G:Za;Za=f[_a>>2]|0;f[_a>>2]=(Za|0)>(tb|0)?tb:Za;Za=f[db>>2]|0;f[db>>2]=(Za|0)<(tb|0)?tb:Za;f[Sa>>2]=(f[Sa>>2]|0)+1;Za=((G|0)<0)<<31>>31;Ya=d1c(Ua|0,H|0,G|0,Za|0)|0;fb=J;Pa=Wa;f[Pa>>2]=Ya;f[Pa+4>>2]=fb;Pa=d1c($a|0,bb|0,tb|0,jb|0)|0;eb=J;Qa=Va;f[Qa>>2]=Pa;f[Qa+4>>2]=eb;if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;f[ob+(G<<2)>>2]=0;Qa=f[cb>>2]|0;Ra=(Qa|0)>(kb|0)?kb:Qa;Qa=f[Xa>>2]|0;Ta=(Qa|0)<(kb|0)?kb:Qa;Qa=f[_a>>2]|0;Oa=f[db>>2]|0;Na=f[Sa>>2]|0;Ma=d1c(Ya|0,fb|0,kb|0,ab|0)|0;fb=J;Ya=d1c(Pa|0,eb|0,ib|0,nb|0)|0;eb=J;f[cb>>2]=(Ra|0)>(G|0)?G:Ra;f[Xa>>2]=(Ta|0)<(G|0)?G:Ta;f[_a>>2]=(Qa|0)>(ib|0)?ib:Qa;f[db>>2]=(Oa|0)<(ib|0)?ib:Oa;f[Sa>>2]=Na+2;Na=d1c(Ma|0,fb|0,G|0,Za|0)|0;Za=Wa;f[Za>>2]=Na;f[Za+4>>2]=J;Za=d1c(Ya|0,eb|0,ib|0,nb|0)|0;eb=Va;f[eb>>2]=Za;f[eb+4>>2]=J;break}else{if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;eb=f[cb>>2]|0;f[cb>>2]=(eb|0)>(kb|0)?kb:eb;eb=f[Xa>>2]|0;f[Xa>>2]=(eb|0)<(kb|0)?kb:eb;eb=f[_a>>2]|0;f[_a>>2]=(eb|0)>(ib|0)?ib:eb;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(ib|0)?ib:eb;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=d1c(Ua|0,H|0,kb|0,ab|0)|0;ab=Wa;f[ab>>2]=Sa;f[ab+4>>2]=J;ab=d1c($a|0,bb|0,ib|0,nb|0)|0;bb=Va;f[bb>>2]=ab;f[bb+4>>2]=J;break}}while(0);kb=kb+2|0;kc=f[o>>2]|0}while((kb|0)<(kc|0));lc=f[j>>2]|0;mc=kc}else{lc=rb;mc=sb}tb=tb+2|0;if((tb|0)>=(lc|0))break;else{sb=mc;rb=lc}}}}while(0);lc=g+12|0;if((f[lc>>2]|0)<=0){wL(h);u=a;return zb|0}mc=f[g+20>>2]|0;kc=f[g+48>>2]|0;j=f[g+120>>2]|0;o=f[g+80>>2]|0;fc=f[g+108>>2]|0;g=0;do{ec=mc+(Y(f[kc>>2]|0,g)|0)|0;ic=ec+8|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[ec>>2]|0);ic=ec+12|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[ec+4>>2]|0);ic=o+(Y(f[fc>>2]|0,g)|0)|0;nc=+((f[ec+16>>2]|0)>>>0);ec=j+(g<<4)|0;p[ic>>3]=(+((f[ec>>2]|0)>>>0)+4294967296.0*+((f[ec+4>>2]|0)>>>0))/nc;ec=j+(g<<4)+8|0;p[ic+8>>3]=(+((f[ec>>2]|0)>>>0)+4294967296.0*+((f[ec+4>>2]|0)>>>0))/nc;g=g+1|0}while((g|0)<(f[lc>>2]|0));wL(h);u=a;return zb|0}function wwa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=f[c+8>>2]|0;l=d+8|0;if((k|0)!=(f[l>>2]|0)){m=$Xc(32)|0;f[h>>2]=m;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=m;o=354540;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[m+26>>0]=0;vM(-215,h,528391,354221,2526)}m=f[c+12>>2]|0;if((m|0)!=(f[d+12>>2]|0)){r=$Xc(32)|0;f[h>>2]=r;f[h+8>>2]=-2147483616;f[h+4>>2]=26;n=r;o=354567;q=n+26|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[r+26>>0]=0;vM(-215,h,528391,354221,2527)}if((e|0)!=8){e=$Xc(32)|0;f[h>>2]=e;f[h+8>>2]=-2147483616;f[h+4>>2]=17;n=e;o=354594;q=n+17|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));b[e+17>>0]=0;vM(-215,h,528391,354221,2528)}e=(m+1|0)/2|0;m=vL(k<<2)|0;o=vL((Y(((k+1|0)/2|0)<<2,e)|0)+4|0)|0;f[o>>2]=0;f[h>>2]=0;f[h+4>>2]=k;r=(k|0)/2|0;s=(i3()|0)<<2;t=(s|0)<(r|0)?s:r;v=+(((t|0)>1?t:1)|0);f[i>>2]=75360;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=o;f[i+16>>2]=m;h3(h,i,v);xwa(c,d,o,m);f[i>>2]=1;if((k|0)>0){t=0;do{r=t+1|0;s=(Y((r|0)/2|0,e)|0)+1|0;w=f[m+(r<<2)>>2]|0;r=w+s|0;if((w|0)>0){w=s;do{s=o+(w<<2)|0;x=f[s>>2]|0;if((x|0)<(w|0))f[s>>2]=f[o+(x<<2)>>2];else{f[s>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}w=w+1|0}while((w|0)<(r|0))}t=f[m+(t<<2)>>2]|0}while((t|0)<(k|0))}t=k*136|0;e=bYc(k>>>0>31580641|t>>>0>4294967291?-1:t+4|0)|0;f[e>>2]=k;t=e+4|0;if(k|0){r=t+(k*136|0)|0;k=t;do{f[k>>2]=0;f[k+4>>2]=1124007936;w=k+12|0;s=k+44|0;n=k+8|0;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[s>>2]=w;x=k+52|0;f[k+48>>2]=x;f[x>>2]=0;f[k+56>>2]=0;f[k+60>>2]=0;f[k+64>>2]=1124007936;x=k+72|0;y=k+104|0;n=k+68|0;q=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(q|0));f[y>>2]=x;w=k+112|0;f[k+108>>2]=w;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;k=k+136|0}while((k|0)!=(r|0))}ywa(g,f[i>>2]|0);f[j>>2]=75380;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=o;f[j+16>>2]=g;f[j+20>>2]=t;f[j+24>>2]=i;h3(h,j,v);j=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(j|0)){h=g+20|0;d=g+48|0;c=g+120|0;r=l;l=f[i>>2]|0;while(1){if((l|0)>0){k=t+(r*136|0)+120|0;n=f[t+(r*136|0)+20>>2]|0;q=f[t+(r*136|0)+48>>2]|0;w=0;s=l;while(1){z=n+(Y(f[q>>2]|0,w)|0)|0;A=z+16|0;if((f[A>>2]|0)>0){B=(f[h>>2]|0)+(Y(f[f[d>>2]>>2]|0,w)|0)|0;C=f[B>>2]|0;D=f[z>>2]|0;f[B>>2]=(C|0)>(D|0)?D:C;C=B+8|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+8>>2]|0)?z:B)+8>>2];C=B+4|0;f[C>>2]=f[((f[C>>2]|0)>(f[z+4>>2]|0)?z:B)+4>>2];C=B+12|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+12>>2]|0)?z:B)+12>>2];z=B+16|0;f[z>>2]=(f[z>>2]|0)+(f[A>>2]|0);A=f[k>>2]|0;z=A+(w<<4)|0;B=f[c>>2]|0;C=B+(w<<4)|0;D=C;E=d1c(f[D>>2]|0,f[D+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=C;f[z>>2]=E;f[z+4>>2]=J;z=A+(w<<4)+8|0;A=B+(w<<4)+8|0;B=A;E=d1c(f[B>>2]|0,f[B+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=A;f[z>>2]=E;f[z+4>>2]=J;F=f[i>>2]|0}else F=s;w=w+1|0;if((w|0)>=(F|0)){G=F;break}else s=F}}else G=l;r=f[t+(r*136|0)+132>>2]|0;if((r|0)>=(j|0))break;else l=G}}G=g+12|0;if((f[G>>2]|0)>0){l=f[g+20>>2]|0;j=f[g+48>>2]|0;r=f[g+120>>2]|0;F=f[g+80>>2]|0;c=f[g+108>>2]|0;g=0;do{d=l+(Y(f[j>>2]|0,g)|0)|0;h=d+8|0;f[h>>2]=(f[h>>2]|0)+1-(f[d>>2]|0);h=d+12|0;f[h>>2]=(f[h>>2]|0)+1-(f[d+4>>2]|0);h=F+(Y(f[c>>2]|0,g)|0)|0;v=+((f[d+16>>2]|0)>>>0);d=r+(g<<4)|0;p[h>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/v;d=r+(g<<4)+8|0;p[h+8>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/v;g=g+1|0}while((g|0)<(f[G>>2]|0))}G=t+((f[e>>2]|0)*136|0)|0;if((t|0)==(G|0)){dYc(e);wL(m);wL(o);H=f[i>>2]|0;u=a;return H|0}else I=G;do{I=I+-136|0;qwa(I)}while((I|0)!=(t|0));dYc(e);wL(m);wL(o);H=f[i>>2]|0;u=a;return H|0}function xwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function ywa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+80|0;d=c+64|0;e=c;g=c+56|0;h=f[a>>2]|0;f[d>>2]=5;f[d+4>>2]=b;wS(h,d,4,-1,0,0);d=f[a>>2]|0;do if((eS(d)|0)==65536){h=f[d+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;U$(e,h);break}}else bS(e,d,-1);while(0);d=a+4|0;if((d|0)==(e|0)){h=e+36|0;i=f[h>>2]|0;if((i|0)!=0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0){V$(e);n=h}else n=h}else{h=a+40|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)V$(d);f[h>>2]=0;i=a+20|0;j=a+8|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){k=f[a+44>>2]|0;m=0;do{f[k+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[j>>2]|0))}f[d>>2]=f[e>>2];d=e+4|0;m=f[d>>2]|0;f[j>>2]=m;j=e+8|0;k=a+12|0;f[k>>2]=f[j>>2];f[a+16>>2]=f[e+12>>2];f[i>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];i=e+36|0;f[h>>2]=f[i>>2];h=a+48|0;l=f[h>>2]|0;o=a+52|0;if((l|0)==(o|0)){p=m;q=l}else{wL(l);f[h>>2]=o;f[a+44>>2]=k;p=f[d>>2]|0;q=o}o=e+44|0;if((p|0)<3){p=f[o>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2]}else{f[h>>2]=f[o>>2];h=e+40|0;f[a+44>>2]=f[h>>2];f[o>>2]=e+48;f[h>>2]=j}f[e>>2]=1124007936;r=d;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));n=i}f[n>>2]=0;n=e+16|0;i=e+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[e+40>>2]|0;d=0;do{f[n+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))wL(i);i=a+60|0;d=f[i>>2]|0;f[g>>2]=2;f[g+4>>2]=b;wS(d,g,6,-1,0,0);g=f[i>>2]|0;do if((eS(g)|0)==65536){i=f[g+4>>2]|0;f[e>>2]=f[i>>2];d=e+4|0;n=i+4|0;f[d>>2]=f[n>>2];j=e+8|0;f[j>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];h=f[i+36>>2]|0;f[e+36>>2]=h;f[e+40>>2]=j;j=e+48|0;o=e+44|0;f[o>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if(h|0){j=h+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[n>>2]|0)<3){n=f[i+44>>2]|0;j=f[o>>2]|0;f[j>>2]=f[n>>2];f[j+4>>2]=f[n+4>>2];break}else{f[d>>2]=0;U$(e,i);break}}else bS(e,g,-1);while(0);g=a+64|0;if((g|0)==(e|0)){i=e+36|0;d=f[i>>2]|0;if((d|0)!=0?(n=d+12|0,d=f[n>>2]|0,f[n>>2]=d+-1,(d|0)==1):0){V$(e);t=i}else t=i}else{i=a+100|0;d=f[i>>2]|0;if(d|0?(n=d+12|0,d=f[n>>2]|0,f[n>>2]=d+-1,(d|0)==1):0)V$(g);f[i>>2]=0;d=a+80|0;n=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[n>>2]|0)>0){j=f[a+104>>2]|0;o=0;do{f[j+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}f[g>>2]=f[e>>2];g=e+4|0;o=f[g>>2]|0;f[n>>2]=o;n=e+8|0;j=a+72|0;f[j>>2]=f[n>>2];f[a+76>>2]=f[e+12>>2];f[d>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];d=e+36|0;f[i>>2]=f[d>>2];i=a+108|0;h=f[i>>2]|0;p=a+112|0;if((h|0)==(p|0)){v=o;w=h}else{wL(h);f[i>>2]=p;f[a+104>>2]=j;v=f[g>>2]|0;w=p}p=e+44|0;if((v|0)<3){v=f[p>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2]}else{f[i>>2]=f[p>>2];i=e+40|0;f[a+104>>2]=f[i>>2];f[p>>2]=e+48;f[i>>2]=n}f[e>>2]=1124007936;r=g;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));t=d}f[t>>2]=0;t=e+16|0;d=e+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[d>>2]|0)>0){t=f[e+40>>2]|0;r=0;do{f[t+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[d>>2]|0))}d=f[e+44>>2]|0;if((d|0)!=(e+48|0))wL(d);if((b|0)>0){d=f[a+20>>2]|0;r=f[a+48>>2]|0;t=0;do{s=d+(Y(f[r>>2]|0,t)|0)|0;f[s>>2]=2147483647;f[s+4>>2]=2147483647;f[s+8>>2]=-2147483648;f[s+12>>2]=-2147483648;f[s+16>>2]=0;t=t+1|0}while((t|0)!=(b|0))}t=a+120|0;r=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;a=f[r>>2]|0;d=f[t>>2]|0;s=a-d>>4;g=a;if(s>>>0<b>>>0){Cwa(t,b-s|0,e);u=c;return}if(s>>>0<=b>>>0){u=c;return}s=d+(b<<4)|0;if((g|0)==(s|0)){u=c;return}f[r>>2]=g+(~((g+-16-s|0)>>>4)<<4);u=c;return}function zwa(a){a=a|0;cYc(a);return}function Awa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;if((e|0)>0){d=a+20|0;Bwa((f[d>>2]|0)+(e*136|0)|0,f[f[a+24>>2]>>2]|0);g=f[d>>2]|0;f[g+(e*136|0)+132>>2]=c;d=a+8|0;h=f[d>>2]|0;i=f[h+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if(!(f[h+8>>2]&1)){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=g+(e*136|0)+20|0;o=g+(e*136|0)+120|0;p=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;r=g+(e*136|0)+48|0;s=g+(e*136|0)+48|0;t=g+(e*136|0)+20|0;u=g+(e*136|0)+48|0;v=g+(e*136|0)+120|0;w=g+(e*136|0)+20|0;x=g+(e*136|0)+120|0;y=e;z=h;A=i;while(1){B=f[l>>2]|0;C=f[f[B+44>>2]>>2]|0;D=(f[B+16>>2]|0)+(Y(C,y)|0)|0;B=D+C|0;C=f[f[z+44>>2]>>2]|0;E=(f[z+16>>2]|0)+(Y(C,y)|0)|0;F=E+C|0;if((A|0)>0){C=((y|0)<0)<<31>>31;G=y+1|0;H=((G|0)<0)<<31>>31;I=0;do{K=E+(I<<2)|0;L=f[K>>2]|0;do if((L|0)>0){M=f[(f[m>>2]|0)+(L<<2)>>2]|0;if(!(b[D+I>>0]|0)){f[K>>2]=0;N=f[n>>2]|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(I|0)?I:P;P=N+4|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(y|0)?y:O;O=N+12|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(y|0)?y:P;P=N+16|0;f[P>>2]=(f[P>>2]|0)+1;P=f[o>>2]|0;O=P;Q=d1c(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=P;f[O>>2]=Q;f[O+4>>2]=J;R=P+8|0;S=N;T=P}else{f[K>>2]=M;P=f[t>>2]|0;N=P+(Y(f[f[u>>2]>>2]|0,M)|0)|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(I|0)?I:Q;Q=N+4|0;O=f[Q>>2]|0;f[Q>>2]=(O|0)>(y|0)?y:O;O=N+12|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(y|0)?y:Q;Q=N+16|0;f[Q>>2]=(f[Q>>2]|0)+1;Q=f[v>>2]|0;N=Q+(M<<4)|0;O=N;U=d1c(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=N;f[O>>2]=U;f[O+4>>2]=J;R=Q+(M<<4)+8|0;S=P;T=Q}Q=R;P=d1c(f[Q>>2]|0,f[Q+4>>2]|0,y|0,C|0)|0;Q=R;f[Q>>2]=P;f[Q+4>>2]=J;Q=I|1;P=E+(Q<<2)|0;if(!(b[D+Q>>0]|0)){f[P>>2]=0;V=0;W=S}else{f[P>>2]=M;V=M;W=S+(Y(f[f[s>>2]>>2]|0,M)|0)|0}P=f[W>>2]|0;f[W>>2]=(P|0)>(Q|0)?Q:P;P=W+8|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(Q|0)?Q:O;O=W+4|0;P=f[O>>2]|0;f[O>>2]=(P|0)>(y|0)?y:P;P=W+12|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(y|0)?y:O;O=W+16|0;f[O>>2]=(f[O>>2]|0)+1;O=T+(V<<4)|0;P=O;U=d1c(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;P=O;f[P>>2]=U;f[P+4>>2]=J;P=T+(V<<4)+8|0;U=P;O=d1c(f[U>>2]|0,f[U+4>>2]|0,y|0,C|0)|0;U=P;f[U>>2]=O;f[U+4>>2]=J;U=F+(I<<2)|0;if(!(b[B+I>>0]|0)){f[U>>2]=0;X=0;Z=S}else{f[U>>2]=M;X=M;Z=S+(Y(f[f[r>>2]>>2]|0,M)|0)|0}U=f[Z>>2]|0;f[Z>>2]=(U|0)>(I|0)?I:U;U=Z+8|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(I|0)?I:O;O=Z+4|0;U=f[O>>2]|0;f[O>>2]=(U|0)>(G|0)?G:U;U=Z+12|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(G|0)?G:O;O=Z+16|0;f[O>>2]=(f[O>>2]|0)+1;O=T+(X<<4)|0;U=O;P=d1c(f[U>>2]|0,f[U+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;U=O;f[U>>2]=P;f[U+4>>2]=J;U=T+(X<<4)+8|0;P=U;O=d1c(f[P>>2]|0,f[P+4>>2]|0,G|0,H|0)|0;P=U;f[P>>2]=O;f[P+4>>2]=J;P=F+(Q<<2)|0;O=f[p>>2]|0;if(!(b[B+Q>>0]|0)){f[P>>2]=0;U=f[O>>2]|0;f[O>>2]=(U|0)>(Q|0)?Q:U;U=O+8|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(Q|0)?Q:N;N=O+4|0;U=f[N>>2]|0;f[N>>2]=(U|0)>(G|0)?G:U;U=O+12|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(G|0)?G:N;N=O+16|0;f[N>>2]=(f[N>>2]|0)+1;N=T;U=d1c(f[N>>2]|0,f[N+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;N=T;f[N>>2]=U;f[N+4>>2]=J;_=T+8|0;break}else{f[P>>2]=M;P=O+(Y(f[f[q>>2]>>2]|0,M)|0)|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(Q|0)?Q:O;O=P+8|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(Q|0)?Q:N;N=P+4|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(G|0)?G:O;O=P+12|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(G|0)?G:N;N=P+16|0;f[N>>2]=(f[N>>2]|0)+1;N=T+(M<<4)|0;P=N;O=d1c(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;Q=N;f[Q>>2]=O;f[Q+4>>2]=J;_=T+(M<<4)+8|0;break}}else{f[K>>2]=0;M=I|1;f[E+(M<<2)>>2]=0;f[F+(I<<2)>>2]=0;f[F+(M<<2)>>2]=0;Q=f[w>>2]|0;O=f[Q>>2]|0;N=(O|0)>(I|0)?I:O;O=Q+8|0;P=f[O>>2]|0;U=(P|0)<(I|0)?I:P;P=Q+4|0;$=f[P>>2]|0;aa=($|0)>(y|0)?y:$;$=Q+12|0;ba=f[$>>2]|0;ca=(ba|0)<(y|0)?y:ba;ba=Q+16|0;da=f[ba>>2]|0;ea=f[x>>2]|0;fa=((I|0)<0)<<31>>31;ga=ea;ha=d1c(f[ga>>2]|0,f[ga+4>>2]|0,I|0,fa|0)|0;ga=J;ia=ea+8|0;ja=ia;ka=d1c(f[ja>>2]|0,f[ja+4>>2]|0,y|0,C|0)|0;ja=J;la=(N|0)>(M|0)?M:N;N=((M|0)<0)<<31>>31;ma=d1c(ha|0,ga|0,M|0,N|0)|0;ga=J;ha=d1c(ka|0,ja|0,y|0,C|0)|0;ja=J;ka=d1c(ma|0,ga|0,I|0,fa|0)|0;fa=J;ga=d1c(ha|0,ja|0,G|0,H|0)|0;ja=ia;f[ja>>2]=ga;f[ja+4>>2]=J;f[Q>>2]=(la|0)>(I|0)?I:la;f[O>>2]=(U|0)<(M|0)?M:U;f[P>>2]=(aa|0)>(G|0)?G:aa;f[$>>2]=(ca|0)<(G|0)?G:ca;f[ba>>2]=da+4;da=d1c(ka|0,fa|0,M|0,N|0)|0;N=ea;f[N>>2]=da;f[N+4>>2]=J;_=ia}while(0);K=_;L=d1c(f[K>>2]|0,f[K+4>>2]|0,G|0,H|0)|0;K=_;f[K>>2]=L;f[K+4>>2]=J;I=I+2|0;K=f[d>>2]|0;L=f[K+12>>2]|0}while((I|0)<(L|0));na=L;oa=K}else{na=A;oa=z}y=y+2|0;if((y|0)>=(c|0))break;else{z=oa;A=na}}return}if(!k)return;na=a+4|0;A=a+12|0;oa=g+(e*136|0)+20|0;z=g+(e*136|0)+120|0;y=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;x=g+(e*136|0)+48|0;w=g+(e*136|0)+48|0;T=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;p=g+(e*136|0)+120|0;X=g+(e*136|0)+20|0;Z=g+(e*136|0)+120|0;r=e;S=h;V=i;while(1){W=f[na>>2]|0;s=f[f[W+44>>2]>>2]|0;R=(f[W+16>>2]|0)+(Y(s,r)|0)|0;W=R+s|0;s=f[f[S+44>>2]>>2]|0;v=(f[S+16>>2]|0)+(Y(s,r)|0)|0;u=v+s|0;if((V|0)>0){s=((r|0)<0)<<31>>31;t=r+1|0;o=((t|0)<0)<<31>>31;n=0;do{m=v+(n<<2)|0;l=f[m>>2]|0;do if((l|0)>0){I=f[(f[A>>2]|0)+(l<<2)>>2]|0;if(!(b[R+n>>0]|0)){f[m>>2]=0;H=f[oa>>2]|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(n|0)?n:C;C=H+4|0;G=f[C>>2]|0;f[C>>2]=(G|0)>(r|0)?r:G;G=H+12|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(r|0)?r:C;C=H+16|0;f[C>>2]=(f[C>>2]|0)+1;C=f[z>>2]|0;G=C;F=d1c(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;pa=C+8|0;qa=H;ra=C}else{f[m>>2]=I;C=f[T>>2]|0;H=C+(Y(f[f[q>>2]>>2]|0,I)|0)|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(n|0)?n:F;F=H+4|0;G=f[F>>2]|0;f[F>>2]=(G|0)>(r|0)?r:G;G=H+12|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(r|0)?r:F;F=H+16|0;f[F>>2]=(f[F>>2]|0)+1;F=f[p>>2]|0;H=F+(I<<4)|0;G=H;E=d1c(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=H;f[G>>2]=E;f[G+4>>2]=J;pa=F+(I<<4)+8|0;qa=C;ra=F}F=pa;C=d1c(f[F>>2]|0,f[F+4>>2]|0,r|0,s|0)|0;F=pa;f[F>>2]=C;f[F+4>>2]=J;F=u+(n<<2)|0;if(!(b[W+n>>0]|0)){f[F>>2]=0;sa=0;ta=qa}else{f[F>>2]=I;sa=I;ta=qa+(Y(f[f[w>>2]>>2]|0,I)|0)|0}F=f[ta>>2]|0;f[ta>>2]=(F|0)>(n|0)?n:F;F=ta+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(n|0)?n:C;C=ta+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=ta+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=ta+16|0;f[C>>2]=(f[C>>2]|0)+1;C=ra+(sa<<4)|0;F=C;G=d1c(f[F>>2]|0,f[F+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;F=C;f[F>>2]=G;f[F+4>>2]=J;F=ra+(sa<<4)+8|0;G=F;C=d1c(f[G>>2]|0,f[G+4>>2]|0,t|0,o|0)|0;G=F;f[G>>2]=C;f[G+4>>2]=J;G=n|1;if((G|0)<(f[(f[d>>2]|0)+12>>2]|0)){C=v+(G<<2)|0;if(!(b[R+G>>0]|0)){f[C>>2]=0;ua=0;va=qa}else{f[C>>2]=I;ua=I;va=qa+(Y(f[f[x>>2]>>2]|0,I)|0)|0}C=f[va>>2]|0;f[va>>2]=(C|0)>(G|0)?G:C;C=va+8|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(G|0)?G:F;F=va+4|0;C=f[F>>2]|0;f[F>>2]=(C|0)>(r|0)?r:C;C=va+12|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(r|0)?r:F;F=va+16|0;f[F>>2]=(f[F>>2]|0)+1;F=ra+(ua<<4)|0;C=F;E=d1c(f[C>>2]|0,f[C+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;C=F;f[C>>2]=E;f[C+4>>2]=J;C=ra+(ua<<4)+8|0;E=C;F=d1c(f[E>>2]|0,f[E+4>>2]|0,r|0,s|0)|0;E=C;f[E>>2]=F;f[E+4>>2]=J;E=u+(G<<2)|0;F=f[y>>2]|0;if(!(b[W+G>>0]|0)){f[E>>2]=0;C=f[F>>2]|0;f[F>>2]=(C|0)>(G|0)?G:C;C=F+8|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(G|0)?G:H;H=F+4|0;C=f[H>>2]|0;f[H>>2]=(C|0)>(t|0)?t:C;C=F+12|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(t|0)?t:H;H=F+16|0;f[H>>2]=(f[H>>2]|0)+1;H=ra;C=d1c(f[H>>2]|0,f[H+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;H=ra;f[H>>2]=C;f[H+4>>2]=J;H=ra+8|0;C=H;B=d1c(f[C>>2]|0,f[C+4>>2]|0,t|0,o|0)|0;C=H;f[C>>2]=B;f[C+4>>2]=J;break}else{f[E>>2]=I;E=F+(Y(f[f[_>>2]>>2]|0,I)|0)|0;F=f[E>>2]|0;f[E>>2]=(F|0)>(G|0)?G:F;F=E+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(G|0)?G:C;C=E+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=E+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=E+16|0;f[C>>2]=(f[C>>2]|0)+1;C=ra+(I<<4)|0;E=C;F=d1c(f[E>>2]|0,f[E+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;G=ra+(I<<4)+8|0;I=G;F=d1c(f[I>>2]|0,f[I+4>>2]|0,t|0,o|0)|0;I=G;f[I>>2]=F;f[I+4>>2]=J;break}}}else{f[m>>2]=0;f[u+(n<<2)>>2]=0;I=f[X>>2]|0;F=f[I>>2]|0;G=I+8|0;C=f[G>>2]|0;E=I+4|0;B=f[E>>2]|0;H=(B|0)>(r|0)?r:B;B=I+12|0;D=f[B>>2]|0;K=(D|0)<(r|0)?r:D;D=I+16|0;L=f[D>>2]|0;ia=f[Z>>2]|0;N=((n|0)<0)<<31>>31;da=ia;ea=d1c(f[da>>2]|0,f[da+4>>2]|0,n|0,N|0)|0;da=J;M=ia+8|0;fa=M;ka=d1c(f[fa>>2]|0,f[fa+4>>2]|0,r|0,s|0)|0;fa=J;f[I>>2]=(F|0)>(n|0)?n:F;f[G>>2]=(C|0)<(n|0)?n:C;f[E>>2]=(H|0)>(t|0)?t:H;f[B>>2]=(K|0)<(t|0)?t:K;f[D>>2]=L+2;L=d1c(ea|0,da|0,n|0,N|0)|0;N=J;da=ia;f[da>>2]=L;f[da+4>>2]=N;da=d1c(ka|0,fa|0,t|0,o|0)|0;fa=J;ka=M;f[ka>>2]=da;f[ka+4>>2]=fa;ka=n|1;if((ka|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[v+(ka<<2)>>2]=0;f[u+(ka<<2)>>2]=0;ea=f[I>>2]|0;K=f[G>>2]|0;H=f[E>>2]|0;C=(H|0)>(r|0)?r:H;H=f[B>>2]|0;F=(H|0)<(r|0)?r:H;H=f[D>>2]|0;ba=((ka|0)<0)<<31>>31;ca=d1c(L|0,N|0,ka|0,ba|0)|0;N=J;L=d1c(da|0,fa|0,r|0,s|0)|0;fa=J;f[I>>2]=(ea|0)>(ka|0)?ka:ea;f[G>>2]=(K|0)<(ka|0)?ka:K;f[E>>2]=(C|0)>(t|0)?t:C;f[B>>2]=(F|0)<(t|0)?t:F;f[D>>2]=H+2;H=d1c(ca|0,N|0,ka|0,ba|0)|0;ba=ia;f[ba>>2]=H;f[ba+4>>2]=J;ba=d1c(L|0,fa|0,t|0,o|0)|0;fa=M;f[fa>>2]=ba;f[fa+4>>2]=J}}while(0);n=n+2|0;m=f[d>>2]|0;l=f[m+12>>2]|0}while((n|0)<(l|0));wa=l;xa=m}else{wa=V;xa=S}r=r+2|0;if((r|0)>=(c|0))break;else{S=xa;V=wa}}return}if(!j){if(!k)return;j=a+4|0;wa=a+12|0;V=g+(e*136|0)+20|0;xa=g+(e*136|0)+120|0;S=g+(e*136|0)+20|0;r=g+(e*136|0)+48|0;Z=g+(e*136|0)+48|0;X=g+(e*136|0)+48|0;ra=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;y=g+(e*136|0)+120|0;ua=g+(e*136|0)+20|0;va=g+(e*136|0)+120|0;x=e;qa=h;sa=i;while(1){ta=f[j>>2]|0;w=f[f[ta+44>>2]>>2]|0;pa=(f[ta+16>>2]|0)+(Y(w,x)|0)|0;ta=pa+w|0;w=f[f[qa+44>>2]>>2]|0;p=(f[qa+16>>2]|0)+(Y(w,x)|0)|0;q=p+w|0;if((sa|0)>0){w=((x|0)<0)<<31>>31;T=x+1|0;z=((T|0)<0)<<31>>31;oa=0;do{A=p+(oa<<2)|0;na=f[A>>2]|0;do if((na|0)>0){n=f[(f[wa>>2]|0)+(na<<2)>>2]|0;if(!(b[pa+oa>>0]|0)){f[A>>2]=0;o=f[V>>2]|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(oa|0)?oa:t;t=o+8|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(oa|0)?oa:s;s=o+4|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(x|0)?x:t;t=o+12|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(x|0)?x:s;s=o+16|0;f[s>>2]=(f[s>>2]|0)+1;s=f[xa>>2]|0;t=s;u=d1c(f[t>>2]|0,f[t+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;t=s;f[t>>2]=u;f[t+4>>2]=J;ya=s+8|0;za=o;Aa=s}else{f[A>>2]=n;s=f[ra>>2]|0;o=s+(Y(f[f[_>>2]>>2]|0,n)|0)|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(oa|0)?oa:t;t=o+8|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(oa|0)?oa:u;u=o+4|0;t=f[u>>2]|0;f[u>>2]=(t|0)>(x|0)?x:t;t=o+12|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(x|0)?x:u;u=o+16|0;f[u>>2]=(f[u>>2]|0)+1;u=f[y>>2]|0;o=u+(n<<4)|0;t=o;v=d1c(f[t>>2]|0,f[t+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;t=o;f[t>>2]=v;f[t+4>>2]=J;ya=u+(n<<4)+8|0;za=s;Aa=u}u=ya;s=d1c(f[u>>2]|0,f[u+4>>2]|0,x|0,w|0)|0;u=ya;f[u>>2]=s;f[u+4>>2]=J;u=oa|1;s=p+(u<<2)|0;if(!(b[pa+u>>0]|0)){f[s>>2]=0;Ba=0;Ca=za}else{f[s>>2]=n;Ba=n;Ca=za+(Y(f[f[X>>2]>>2]|0,n)|0)|0}s=f[Ca>>2]|0;f[Ca>>2]=(s|0)>(u|0)?u:s;s=Ca+8|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(u|0)?u:t;t=Ca+4|0;s=f[t>>2]|0;f[t>>2]=(s|0)>(x|0)?x:s;s=Ca+12|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(x|0)?x:t;t=Ca+16|0;f[t>>2]=(f[t>>2]|0)+1;t=Aa+(Ba<<4)|0;s=t;v=d1c(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;s=t;f[s>>2]=v;f[s+4>>2]=J;s=Aa+(Ba<<4)+8|0;v=s;t=d1c(f[v>>2]|0,f[v+4>>2]|0,x|0,w|0)|0;v=s;f[v>>2]=t;f[v+4>>2]=J;if((T|0)<(f[(f[d>>2]|0)+8>>2]|0)){v=q+(oa<<2)|0;if(!(b[ta+oa>>0]|0)){f[v>>2]=0;Da=0;Ea=za}else{f[v>>2]=n;Da=n;Ea=za+(Y(f[f[Z>>2]>>2]|0,n)|0)|0}v=f[Ea>>2]|0;f[Ea>>2]=(v|0)>(oa|0)?oa:v;v=Ea+8|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(oa|0)?oa:t;t=Ea+4|0;v=f[t>>2]|0;f[t>>2]=(v|0)>(T|0)?T:v;v=Ea+12|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(T|0)?T:t;t=Ea+16|0;f[t>>2]=(f[t>>2]|0)+1;t=Aa+(Da<<4)|0;v=t;s=d1c(f[v>>2]|0,f[v+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;v=t;f[v>>2]=s;f[v+4>>2]=J;v=Aa+(Da<<4)+8|0;s=v;t=d1c(f[s>>2]|0,f[s+4>>2]|0,T|0,z|0)|0;s=v;f[s>>2]=t;f[s+4>>2]=J;s=q+(u<<2)|0;t=f[S>>2]|0;if(!(b[ta+u>>0]|0)){f[s>>2]=0;v=f[t>>2]|0;f[t>>2]=(v|0)>(u|0)?u:v;v=t+8|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(u|0)?u:o;o=t+4|0;v=f[o>>2]|0;f[o>>2]=(v|0)>(T|0)?T:v;v=t+12|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(T|0)?T:o;o=t+16|0;f[o>>2]=(f[o>>2]|0)+1;o=Aa;v=d1c(f[o>>2]|0,f[o+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;o=Aa;f[o>>2]=v;f[o+4>>2]=J;o=Aa+8|0;v=o;W=d1c(f[v>>2]|0,f[v+4>>2]|0,T|0,z|0)|0;v=o;f[v>>2]=W;f[v+4>>2]=J;break}else{f[s>>2]=n;s=t+(Y(f[f[r>>2]>>2]|0,n)|0)|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(u|0)?u:t;t=s+8|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(u|0)?u:v;v=s+4|0;t=f[v>>2]|0;f[v>>2]=(t|0)>(T|0)?T:t;t=s+12|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(T|0)?T:v;v=s+16|0;f[v>>2]=(f[v>>2]|0)+1;v=Aa+(n<<4)|0;s=v;t=d1c(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;u=v;f[u>>2]=t;f[u+4>>2]=J;u=Aa+(n<<4)+8|0;n=u;t=d1c(f[n>>2]|0,f[n+4>>2]|0,T|0,z|0)|0;n=u;f[n>>2]=t;f[n+4>>2]=J;break}}}else{f[A>>2]=0;n=oa|1;f[p+(n<<2)>>2]=0;t=f[ua>>2]|0;u=f[t>>2]|0;v=(u|0)>(oa|0)?oa:u;u=t+8|0;s=f[u>>2]|0;W=(s|0)<(oa|0)?oa:s;s=t+4|0;o=f[s>>2]|0;R=t+12|0;m=f[R>>2]|0;l=t+16|0;fa=f[l>>2]|0;ba=f[va>>2]|0;M=((oa|0)<0)<<31>>31;L=ba;H=d1c(f[L>>2]|0,f[L+4>>2]|0,oa|0,M|0)|0;L=J;ia=ba+8|0;ka=ia;N=d1c(f[ka>>2]|0,f[ka+4>>2]|0,x|0,w|0)|0;ka=J;f[t>>2]=(v|0)>(n|0)?n:v;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(o|0)>(x|0)?x:o;f[R>>2]=(m|0)<(x|0)?x:m;f[l>>2]=fa+2;fa=((n|0)<0)<<31>>31;m=d1c(H|0,L|0,n|0,fa|0)|0;L=J;H=ba;f[H>>2]=m;f[H+4>>2]=L;H=d1c(N|0,ka|0,x|0,w|0)|0;ka=J;N=ia;f[N>>2]=H;f[N+4>>2]=ka;if((T|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[q+(oa<<2)>>2]=0;f[q+(n<<2)>>2]=0;N=f[t>>2]|0;o=(N|0)>(oa|0)?oa:N;N=f[u>>2]|0;W=(N|0)<(oa|0)?oa:N;N=f[s>>2]|0;v=f[R>>2]|0;ca=f[l>>2]|0;D=d1c(m|0,L|0,oa|0,M|0)|0;M=J;L=d1c(H|0,ka|0,T|0,z|0)|0;ka=J;f[t>>2]=(o|0)>(n|0)?n:o;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(N|0)>(T|0)?T:N;f[R>>2]=(v|0)<(T|0)?T:v;f[l>>2]=ca+2;ca=d1c(D|0,M|0,n|0,fa|0)|0;fa=ba;f[fa>>2]=ca;f[fa+4>>2]=J;fa=d1c(L|0,ka|0,T|0,z|0)|0;ka=ia;f[ka>>2]=fa;f[ka+4>>2]=J}}while(0);oa=oa+2|0;A=f[d>>2]|0;na=f[A+12>>2]|0}while((oa|0)<(na|0));Fa=na;Ga=A}else{Fa=sa;Ga=qa}x=x+2|0;if((x|0)>=(c|0))break;else{qa=Ga;sa=Fa}}return}if(!k)return;k=a+4|0;Fa=a+12|0;sa=g+(e*136|0)+20|0;Ga=g+(e*136|0)+120|0;qa=g+(e*136|0)+20|0;x=g+(e*136|0)+48|0;va=g+(e*136|0)+48|0;ua=g+(e*136|0)+48|0;Aa=g+(e*136|0)+20|0;r=g+(e*136|0)+48|0;S=g+(e*136|0)+20|0;Da=g+(e*136|0)+48|0;Ea=g+(e*136|0)+120|0;Z=g+(e*136|0)+20|0;za=g+(e*136|0)+120|0;g=e;Ba=h;h=i;while(1){i=f[k>>2]|0;Ca=f[f[i+44>>2]>>2]|0;X=(f[i+16>>2]|0)+(Y(Ca,g)|0)|0;i=X+Ca|0;Ca=f[f[Ba+44>>2]>>2]|0;ya=(f[Ba+16>>2]|0)+(Y(Ca,g)|0)|0;y=ya+Ca|0;if((h|0)>0){Ca=((g|0)<0)<<31>>31;_=g+1|0;ra=((_|0)<0)<<31>>31;xa=0;do{V=ya+(xa<<2)|0;wa=f[V>>2]|0;do if((wa|0)>0){j=f[(f[Fa>>2]|0)+(wa<<2)>>2]|0;if(!(b[X+xa>>0]|0)){f[V>>2]=0;oa=f[sa>>2]|0;z=f[oa>>2]|0;f[oa>>2]=(z|0)>(xa|0)?xa:z;z=oa+8|0;T=f[z>>2]|0;f[z>>2]=(T|0)<(xa|0)?xa:T;T=oa+4|0;z=f[T>>2]|0;f[T>>2]=(z|0)>(g|0)?g:z;z=oa+12|0;T=f[z>>2]|0;f[z>>2]=(T|0)<(g|0)?g:T;T=oa+16|0;f[T>>2]=(f[T>>2]|0)+1;T=f[Ga>>2]|0;z=T;q=d1c(f[z>>2]|0,f[z+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;z=T;f[z>>2]=q;f[z+4>>2]=J;Ha=T+8|0;Ia=oa;Ja=T}else{f[V>>2]=j;T=f[S>>2]|0;oa=T+(Y(f[f[Da>>2]>>2]|0,j)|0)|0;z=f[oa>>2]|0;f[oa>>2]=(z|0)>(xa|0)?xa:z;z=oa+8|0;q=f[z>>2]|0;f[z>>2]=(q|0)<(xa|0)?xa:q;q=oa+4|0;z=f[q>>2]|0;f[q>>2]=(z|0)>(g|0)?g:z;z=oa+12|0;q=f[z>>2]|0;f[z>>2]=(q|0)<(g|0)?g:q;q=oa+16|0;f[q>>2]=(f[q>>2]|0)+1;q=f[Ea>>2]|0;oa=q+(j<<4)|0;z=oa;w=d1c(f[z>>2]|0,f[z+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;z=oa;f[z>>2]=w;f[z+4>>2]=J;Ha=q+(j<<4)+8|0;Ia=T;Ja=q}q=Ha;T=d1c(f[q>>2]|0,f[q+4>>2]|0,g|0,Ca|0)|0;q=Ha;f[q>>2]=T;f[q+4>>2]=J;q=xa|1;T=f[d>>2]|0;if((q|0)>=(f[T+12>>2]|0)){if((_|0)>=(f[T+8>>2]|0))break;T=y+(xa<<2)|0;z=f[Aa>>2]|0;if(!(b[i+xa>>0]|0)){f[T>>2]=0;w=f[z>>2]|0;f[z>>2]=(w|0)>(xa|0)?xa:w;w=z+8|0;oa=f[w>>2]|0;f[w>>2]=(oa|0)<(xa|0)?xa:oa;oa=z+4|0;w=f[oa>>2]|0;f[oa>>2]=(w|0)>(_|0)?_:w;w=z+12|0;oa=f[w>>2]|0;f[w>>2]=(oa|0)<(_|0)?_:oa;oa=z+16|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=Ja;w=d1c(f[oa>>2]|0,f[oa+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;oa=Ja;f[oa>>2]=w;f[oa+4>>2]=J;oa=Ja+8|0;w=oa;p=d1c(f[w>>2]|0,f[w+4>>2]|0,_|0,ra|0)|0;w=oa;f[w>>2]=p;f[w+4>>2]=J;break}else{f[T>>2]=j;T=z+(Y(f[f[r>>2]>>2]|0,j)|0)|0;z=f[T>>2]|0;f[T>>2]=(z|0)>(xa|0)?xa:z;z=T+8|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(xa|0)?xa:w;w=T+4|0;z=f[w>>2]|0;f[w>>2]=(z|0)>(_|0)?_:z;z=T+12|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(_|0)?_:w;w=T+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(j<<4)|0;T=w;z=d1c(f[T>>2]|0,f[T+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;T=w;f[T>>2]=z;f[T+4>>2]=J;T=Ja+(j<<4)+8|0;z=T;w=d1c(f[z>>2]|0,f[z+4>>2]|0,_|0,ra|0)|0;z=T;f[z>>2]=w;f[z+4>>2]=J;break}}z=ya+(q<<2)|0;if(!(b[X+q>>0]|0)){f[z>>2]=0;Ka=0;La=Ia}else{f[z>>2]=j;Ka=j;La=Ia+(Y(f[f[ua>>2]>>2]|0,j)|0)|0}z=f[La>>2]|0;f[La>>2]=(z|0)>(q|0)?q:z;z=La+8|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(q|0)?q:w;w=La+4|0;z=f[w>>2]|0;f[w>>2]=(z|0)>(g|0)?g:z;z=La+12|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(g|0)?g:w;w=La+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(Ka<<4)|0;z=w;T=d1c(f[z>>2]|0,f[z+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;z=w;f[z>>2]=T;f[z+4>>2]=J;z=Ja+(Ka<<4)+8|0;T=z;w=d1c(f[T>>2]|0,f[T+4>>2]|0,g|0,Ca|0)|0;T=z;f[T>>2]=w;f[T+4>>2]=J;if((_|0)<(f[(f[d>>2]|0)+8>>2]|0)){T=y+(xa<<2)|0;if(!(b[i+xa>>0]|0)){f[T>>2]=0;Ma=0;Na=Ia}else{f[T>>2]=j;Ma=j;Na=Ia+(Y(f[f[va>>2]>>2]|0,j)|0)|0}T=f[Na>>2]|0;f[Na>>2]=(T|0)>(xa|0)?xa:T;T=Na+8|0;w=f[T>>2]|0;f[T>>2]=(w|0)<(xa|0)?xa:w;w=Na+4|0;T=f[w>>2]|0;f[w>>2]=(T|0)>(_|0)?_:T;T=Na+12|0;w=f[T>>2]|0;f[T>>2]=(w|0)<(_|0)?_:w;w=Na+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(Ma<<4)|0;T=w;z=d1c(f[T>>2]|0,f[T+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;T=w;f[T>>2]=z;f[T+4>>2]=J;T=Ja+(Ma<<4)+8|0;z=T;w=d1c(f[z>>2]|0,f[z+4>>2]|0,_|0,ra|0)|0;z=T;f[z>>2]=w;f[z+4>>2]=J;z=y+(q<<2)|0;w=f[qa>>2]|0;if(!(b[i+q>>0]|0)){f[z>>2]=0;T=f[w>>2]|0;f[w>>2]=(T|0)>(q|0)?q:T;T=w+8|0;p=f[T>>2]|0;f[T>>2]=(p|0)<(q|0)?q:p;p=w+4|0;T=f[p>>2]|0;f[p>>2]=(T|0)>(_|0)?_:T;T=w+12|0;p=f[T>>2]|0;f[T>>2]=(p|0)<(_|0)?_:p;p=w+16|0;f[p>>2]=(f[p>>2]|0)+1;p=Ja;T=d1c(f[p>>2]|0,f[p+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;p=Ja;f[p>>2]=T;f[p+4>>2]=J;p=Ja+8|0;T=p;oa=d1c(f[T>>2]|0,f[T+4>>2]|0,_|0,ra|0)|0;T=p;f[T>>2]=oa;f[T+4>>2]=J;break}else{f[z>>2]=j;z=w+(Y(f[f[x>>2]>>2]|0,j)|0)|0;w=f[z>>2]|0;f[z>>2]=(w|0)>(q|0)?q:w;w=z+8|0;T=f[w>>2]|0;f[w>>2]=(T|0)<(q|0)?q:T;T=z+4|0;w=f[T>>2]|0;f[T>>2]=(w|0)>(_|0)?_:w;w=z+12|0;T=f[w>>2]|0;f[w>>2]=(T|0)<(_|0)?_:T;T=z+16|0;f[T>>2]=(f[T>>2]|0)+1;T=Ja+(j<<4)|0;z=T;w=d1c(f[z>>2]|0,f[z+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;q=T;f[q>>2]=w;f[q+4>>2]=J;q=Ja+(j<<4)+8|0;j=q;w=d1c(f[j>>2]|0,f[j+4>>2]|0,_|0,ra|0)|0;j=q;f[j>>2]=w;f[j+4>>2]=J;break}}}else{f[V>>2]=0;j=f[Z>>2]|0;w=f[j>>2]|0;f[j>>2]=(w|0)>(xa|0)?xa:w;w=j+8|0;q=f[w>>2]|0;f[w>>2]=(q|0)<(xa|0)?xa:q;q=j+4|0;T=f[q>>2]|0;f[q>>2]=(T|0)>(g|0)?g:T;T=j+12|0;z=f[T>>2]|0;f[T>>2]=(z|0)<(g|0)?g:z;z=j+16|0;f[z>>2]=(f[z>>2]|0)+1;oa=f[za>>2]|0;p=((xa|0)<0)<<31>>31;ta=oa;pa=d1c(f[ta>>2]|0,f[ta+4>>2]|0,xa|0,p|0)|0;ta=J;A=oa;f[A>>2]=pa;f[A+4>>2]=ta;A=oa+8|0;na=A;ka=d1c(f[na>>2]|0,f[na+4>>2]|0,g|0,Ca|0)|0;na=J;fa=A;f[fa>>2]=ka;f[fa+4>>2]=na;fa=xa|1;ia=f[d>>2]|0;if((fa|0)<(f[ia+12>>2]|0)){f[ya+(fa<<2)>>2]=0;L=f[j>>2]|0;f[j>>2]=(L|0)>(fa|0)?fa:L;L=f[w>>2]|0;f[w>>2]=(L|0)<(fa|0)?fa:L;L=f[q>>2]|0;f[q>>2]=(L|0)>(g|0)?g:L;L=f[T>>2]|0;f[T>>2]=(L|0)<(g|0)?g:L;f[z>>2]=(f[z>>2]|0)+1;L=((fa|0)<0)<<31>>31;ca=d1c(pa|0,ta|0,fa|0,L|0)|0;ba=J;n=oa;f[n>>2]=ca;f[n+4>>2]=ba;n=d1c(ka|0,na|0,g|0,Ca|0)|0;M=J;D=A;f[D>>2]=n;f[D+4>>2]=M;if((_|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[y+(xa<<2)>>2]=0;f[y+(fa<<2)>>2]=0;D=f[j>>2]|0;l=(D|0)>(xa|0)?xa:D;D=f[w>>2]|0;v=(D|0)<(xa|0)?xa:D;D=f[q>>2]|0;R=f[T>>2]|0;N=f[z>>2]|0;s=d1c(ca|0,ba|0,xa|0,p|0)|0;ba=J;ca=d1c(n|0,M|0,_|0,ra|0)|0;M=J;f[j>>2]=(l|0)>(fa|0)?fa:l;f[w>>2]=(v|0)<(fa|0)?fa:v;f[q>>2]=(D|0)>(_|0)?_:D;f[T>>2]=(R|0)<(_|0)?_:R;f[z>>2]=N+2;N=d1c(s|0,ba|0,fa|0,L|0)|0;L=oa;f[L>>2]=N;f[L+4>>2]=J;L=d1c(ca|0,M|0,_|0,ra|0)|0;M=A;f[M>>2]=L;f[M+4>>2]=J;break}else{if((_|0)>=(f[ia+8>>2]|0))break;f[y+(xa<<2)>>2]=0;ia=f[j>>2]|0;f[j>>2]=(ia|0)>(xa|0)?xa:ia;ia=f[w>>2]|0;f[w>>2]=(ia|0)<(xa|0)?xa:ia;ia=f[q>>2]|0;f[q>>2]=(ia|0)>(_|0)?_:ia;ia=f[T>>2]|0;f[T>>2]=(ia|0)<(_|0)?_:ia;f[z>>2]=(f[z>>2]|0)+1;z=d1c(pa|0,ta|0,xa|0,p|0)|0;p=oa;f[p>>2]=z;f[p+4>>2]=J;p=d1c(ka|0,na|0,_|0,ra|0)|0;na=A;f[na>>2]=p;f[na+4>>2]=J;break}}while(0);xa=xa+2|0;V=f[d>>2]|0;wa=f[V+12>>2]|0}while((xa|0)<(wa|0));Oa=wa;Pa=V}else{Oa=h;Pa=Ba}g=g+2|0;if((g|0)>=(c|0))break;else{Ba=Pa;h=Oa}}return}else{Oa=a+16|0;f[(f[Oa>>2]|0)+132>>2]=c;h=a+8|0;Pa=f[h>>2]|0;Ba=f[Pa+12>>2]|0;g=(Ba&1|0)!=0;d=(e|0)<(c|0);if(!(f[Pa+8>>2]&1)){if(!g){if(!d)return;za=a+4|0;Z=a+12|0;Ja=e;x=Pa;qa=Ba;while(1){Ma=f[za>>2]|0;Na=f[f[Ma+44>>2]>>2]|0;va=(f[Ma+16>>2]|0)+(Y(Na,Ja)|0)|0;Ma=va+Na|0;Na=f[f[x+44>>2]>>2]|0;Ia=(f[x+16>>2]|0)+(Y(Na,Ja)|0)|0;Ka=Ia+Na|0;if((qa|0)>0){Na=((Ja|0)<0)<<31>>31;La=Ja+1|0;ua=((La|0)<0)<<31>>31;r=0;do{Aa=Ia+(r<<2)|0;Ha=f[Aa>>2]|0;do if((Ha|0)>0){Ea=f[(f[Z>>2]|0)+(Ha<<2)>>2]|0;if(!(b[va+r>>0]|0)){f[Aa>>2]=0;Da=f[Oa>>2]|0;S=f[Da+20>>2]|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)>(r|0)?r:Ga;Ga=S+8|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(r|0)?r:sa;sa=S+4|0;Ga=f[sa>>2]|0;f[sa>>2]=(Ga|0)>(Ja|0)?Ja:Ga;Ga=S+12|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(Ja|0)?Ja:sa;sa=S+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;S=d1c(f[Da>>2]|0,f[Da+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=S;f[Da+4>>2]=J;Qa=sa+8|0}else{f[Aa>>2]=Ea;sa=f[Oa>>2]|0;Da=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;S=f[Da>>2]|0;f[Da>>2]=(S|0)>(r|0)?r:S;S=Da+8|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)<(r|0)?r:Ga;Ga=Da+4|0;S=f[Ga>>2]|0;f[Ga>>2]=(S|0)>(Ja|0)?Ja:S;S=Da+12|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)<(Ja|0)?Ja:Ga;Ga=Da+16|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Ga=f[sa+120>>2]|0;sa=Ga+(Ea<<4)|0;Da=sa;S=d1c(f[Da>>2]|0,f[Da+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=S;f[Da+4>>2]=J;Qa=Ga+(Ea<<4)+8|0}Ga=Qa;Da=d1c(f[Ga>>2]|0,f[Ga+4>>2]|0,Ja|0,Na|0)|0;Ga=Qa;f[Ga>>2]=Da;f[Ga+4>>2]=J;Ga=r|1;Da=Ia+(Ga<<2)|0;if(!(b[va+Ga>>0]|0)){f[Da>>2]=0;S=f[Oa>>2]|0;sa=f[S+20>>2]|0;Fa=f[sa>>2]|0;f[sa>>2]=(Fa|0)>(Ga|0)?Ga:Fa;Fa=sa+8|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ga|0)?Ga:k;k=sa+4|0;Fa=f[k>>2]|0;f[k>>2]=(Fa|0)>(Ja|0)?Ja:Fa;Fa=sa+12|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ja|0)?Ja:k;k=sa+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[S+120>>2]|0;S=k;sa=d1c(f[S>>2]|0,f[S+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;S=k;f[S>>2]=sa;f[S+4>>2]=J;Ra=k+8|0}else{f[Da>>2]=Ea;Da=f[Oa>>2]|0;k=(f[Da+20>>2]|0)+(Y(f[f[Da+48>>2]>>2]|0,Ea)|0)|0;S=f[k>>2]|0;f[k>>2]=(S|0)>(Ga|0)?Ga:S;S=k+8|0;sa=f[S>>2]|0;f[S>>2]=(sa|0)<(Ga|0)?Ga:sa;sa=k+4|0;S=f[sa>>2]|0;f[sa>>2]=(S|0)>(Ja|0)?Ja:S;S=k+12|0;sa=f[S>>2]|0;f[S>>2]=(sa|0)<(Ja|0)?Ja:sa;sa=k+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa+(Ea<<4)|0;k=Da;S=d1c(f[k>>2]|0,f[k+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;k=Da;f[k>>2]=S;f[k+4>>2]=J;Ra=sa+(Ea<<4)+8|0}sa=Ra;k=d1c(f[sa>>2]|0,f[sa+4>>2]|0,Ja|0,Na|0)|0;sa=Ra;f[sa>>2]=k;f[sa+4>>2]=J;sa=Ka+(r<<2)|0;if(!(b[Ma+r>>0]|0)){f[sa>>2]=0;k=f[Oa>>2]|0;S=f[k+20>>2]|0;Da=f[S>>2]|0;f[S>>2]=(Da|0)>(r|0)?r:Da;Da=S+8|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)<(r|0)?r:Fa;Fa=S+4|0;Da=f[Fa>>2]|0;f[Fa>>2]=(Da|0)>(La|0)?La:Da;Da=S+12|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)<(La|0)?La:Fa;Fa=S+16|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Fa=f[k+120>>2]|0;k=Fa;S=d1c(f[k>>2]|0,f[k+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;k=Fa;f[k>>2]=S;f[k+4>>2]=J;Sa=Fa+8|0}else{f[sa>>2]=Ea;sa=f[Oa>>2]|0;Fa=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)>(r|0)?r:k;k=Fa+8|0;S=f[k>>2]|0;f[k>>2]=(S|0)<(r|0)?r:S;S=Fa+4|0;k=f[S>>2]|0;f[S>>2]=(k|0)>(La|0)?La:k;k=Fa+12|0;S=f[k>>2]|0;f[k>>2]=(S|0)<(La|0)?La:S;S=Fa+16|0;f[S>>2]=(f[S>>2]|0)+1;S=f[sa+120>>2]|0;sa=S+(Ea<<4)|0;Fa=sa;k=d1c(f[Fa>>2]|0,f[Fa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Fa=sa;f[Fa>>2]=k;f[Fa+4>>2]=J;Sa=S+(Ea<<4)+8|0}S=Sa;Fa=d1c(f[S>>2]|0,f[S+4>>2]|0,La|0,ua|0)|0;S=Sa;f[S>>2]=Fa;f[S+4>>2]=J;S=Ka+(Ga<<2)|0;if(!(b[Ma+Ga>>0]|0)){f[S>>2]=0;Fa=f[Oa>>2]|0;k=f[Fa+20>>2]|0;sa=f[k>>2]|0;f[k>>2]=(sa|0)>(Ga|0)?Ga:sa;sa=k+8|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(Ga|0)?Ga:Da;Da=k+4|0;sa=f[Da>>2]|0;f[Da>>2]=(sa|0)>(La|0)?La:sa;sa=k+12|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(La|0)?La:Da;Da=k+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Fa+120>>2]|0;Fa=Da;k=d1c(f[Fa>>2]|0,f[Fa+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;Fa=Da;f[Fa>>2]=k;f[Fa+4>>2]=J;Ta=Da+8|0;break}else{f[S>>2]=Ea;S=f[Oa>>2]|0;Da=(f[S+20>>2]|0)+(Y(f[f[S+48>>2]>>2]|0,Ea)|0)|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)>(Ga|0)?Ga:Fa;Fa=Da+8|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ga|0)?Ga:k;k=Da+4|0;Fa=f[k>>2]|0;f[k>>2]=(Fa|0)>(La|0)?La:Fa;Fa=Da+12|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(La|0)?La:k;k=Da+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[S+120>>2]|0;S=k+(Ea<<4)|0;Da=S;Fa=d1c(f[Da>>2]|0,f[Da+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;Ga=S;f[Ga>>2]=Fa;f[Ga+4>>2]=J;Ta=k+(Ea<<4)+8|0;break}}else{f[Aa>>2]=0;Ea=r|1;f[Ia+(Ea<<2)>>2]=0;f[Ka+(r<<2)>>2]=0;f[Ka+(Ea<<2)>>2]=0;k=f[Oa>>2]|0;Ga=f[k+20>>2]|0;Fa=f[Ga>>2]|0;f[Ga>>2]=(Fa|0)>(r|0)?r:Fa;Fa=Ga+8|0;S=f[Fa>>2]|0;f[Fa>>2]=(S|0)<(r|0)?r:S;S=Ga+4|0;Fa=f[S>>2]|0;f[S>>2]=(Fa|0)>(Ja|0)?Ja:Fa;Fa=Ga+12|0;S=f[Fa>>2]|0;f[Fa>>2]=(S|0)<(Ja|0)?Ja:S;S=Ga+16|0;f[S>>2]=(f[S>>2]|0)+1;S=f[k+120>>2]|0;k=((r|0)<0)<<31>>31;Ga=S;Fa=d1c(f[Ga>>2]|0,f[Ga+4>>2]|0,r|0,k|0)|0;Ga=S;f[Ga>>2]=Fa;f[Ga+4>>2]=J;Ga=S+8|0;S=Ga;Fa=d1c(f[S>>2]|0,f[S+4>>2]|0,Ja|0,Na|0)|0;S=Ga;f[S>>2]=Fa;f[S+4>>2]=J;S=f[Oa>>2]|0;Fa=f[S+20>>2]|0;Ga=f[Fa>>2]|0;f[Fa>>2]=(Ga|0)>(Ea|0)?Ea:Ga;Ga=Fa+8|0;Da=f[Ga>>2]|0;f[Ga>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Fa+4|0;Ga=f[Da>>2]|0;f[Da>>2]=(Ga|0)>(Ja|0)?Ja:Ga;Ga=Fa+12|0;Da=f[Ga>>2]|0;f[Ga>>2]=(Da|0)<(Ja|0)?Ja:Da;Da=Fa+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[S+120>>2]|0;S=((Ea|0)<0)<<31>>31;Fa=Da;Ga=d1c(f[Fa>>2]|0,f[Fa+4>>2]|0,Ea|0,S|0)|0;Fa=Da;f[Fa>>2]=Ga;f[Fa+4>>2]=J;Fa=Da+8|0;Da=Fa;Ga=d1c(f[Da>>2]|0,f[Da+4>>2]|0,Ja|0,Na|0)|0;Da=Fa;f[Da>>2]=Ga;f[Da+4>>2]=J;Da=f[Oa>>2]|0;Ga=f[Da+20>>2]|0;Fa=f[Ga>>2]|0;f[Ga>>2]=(Fa|0)>(r|0)?r:Fa;Fa=Ga+8|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(r|0)?r:sa;sa=Ga+4|0;Fa=f[sa>>2]|0;f[sa>>2]=(Fa|0)>(La|0)?La:Fa;Fa=Ga+12|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(La|0)?La:sa;sa=Ga+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;Ga=d1c(f[Da>>2]|0,f[Da+4>>2]|0,r|0,k|0)|0;k=sa;f[k>>2]=Ga;f[k+4>>2]=J;k=sa+8|0;sa=k;Ga=d1c(f[sa>>2]|0,f[sa+4>>2]|0,La|0,ua|0)|0;sa=k;f[sa>>2]=Ga;f[sa+4>>2]=J;sa=f[Oa>>2]|0;Ga=f[sa+20>>2]|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)>(Ea|0)?Ea:k;k=Ga+8|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Ga+4|0;k=f[Da>>2]|0;f[Da>>2]=(k|0)>(La|0)?La:k;k=Ga+12|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(La|0)?La:Da;Da=Ga+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[sa+120>>2]|0;sa=Da;Ga=d1c(f[sa>>2]|0,f[sa+4>>2]|0,Ea|0,S|0)|0;S=Da;f[S>>2]=Ga;f[S+4>>2]=J;Ta=Da+8|0}while(0);Aa=Ta;Ha=d1c(f[Aa>>2]|0,f[Aa+4>>2]|0,La|0,ua|0)|0;Aa=Ta;f[Aa>>2]=Ha;f[Aa+4>>2]=J;r=r+2|0;Aa=f[h>>2]|0;Ha=f[Aa+12>>2]|0}while((r|0)<(Ha|0));Ua=Ha;Va=Aa}else{Ua=qa;Va=x}Ja=Ja+2|0;if((Ja|0)>=(c|0))break;else{x=Va;qa=Ua}}return}if(!d)return;Ua=a+4|0;qa=a+12|0;Va=e;x=Pa;Ja=Ba;while(1){Ta=f[Ua>>2]|0;Sa=f[f[Ta+44>>2]>>2]|0;Ra=(f[Ta+16>>2]|0)+(Y(Sa,Va)|0)|0;Ta=Ra+Sa|0;Sa=f[f[x+44>>2]>>2]|0;Qa=(f[x+16>>2]|0)+(Y(Sa,Va)|0)|0;Z=Qa+Sa|0;if((Ja|0)>0){Sa=((Va|0)<0)<<31>>31;za=Va+1|0;r=((za|0)<0)<<31>>31;ua=0;do{La=Qa+(ua<<2)|0;Na=f[La>>2]|0;do if((Na|0)>0){Ka=f[(f[qa>>2]|0)+(Na<<2)>>2]|0;if(!(b[Ra+ua>>0]|0)){f[La>>2]=0;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)>(ua|0)?ua:va;va=Ma+8|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)<(ua|0)?ua:Aa;Aa=Ma+4|0;va=f[Aa>>2]|0;f[Aa>>2]=(va|0)>(Va|0)?Va:va;va=Ma+12|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)<(Va|0)?Va:Aa;Aa=Ma+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Ia+120>>2]|0;Ia=Aa;Ma=d1c(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Aa;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Wa=Aa+8|0}else{f[La>>2]=Ka;Aa=f[Oa>>2]|0;Ia=(f[Aa+20>>2]|0)+(Y(f[f[Aa+48>>2]>>2]|0,Ka)|0)|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Ia+8|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(ua|0)?ua:va;va=Ia+4|0;Ma=f[va>>2]|0;f[va>>2]=(Ma|0)>(Va|0)?Va:Ma;Ma=Ia+12|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(Va|0)?Va:va;va=Ia+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Aa+120>>2]|0;Aa=va+(Ka<<4)|0;Ia=Aa;Ma=d1c(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Aa;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Wa=va+(Ka<<4)+8|0}va=Wa;Ia=d1c(f[va>>2]|0,f[va+4>>2]|0,Va|0,Sa|0)|0;va=Wa;f[va>>2]=Ia;f[va+4>>2]=J;va=Z+(ua<<2)|0;if(!(b[Ta+ua>>0]|0)){f[va>>2]=0;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;Aa=f[Ma>>2]|0;f[Ma>>2]=(Aa|0)>(ua|0)?ua:Aa;Aa=Ma+8|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)<(ua|0)?ua:Ha;Ha=Ma+4|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)>(za|0)?za:Aa;Aa=Ma+12|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)<(za|0)?za:Ha;Ha=Ma+16|0;f[Ha>>2]=(f[Ha>>2]|0)+1;Ha=f[Ia+120>>2]|0;Ia=Ha;Ma=d1c(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Ha;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Xa=Ha+8|0}else{f[va>>2]=Ka;va=f[Oa>>2]|0;Ha=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Ha>>2]|0;f[Ha>>2]=(Ia|0)>(ua|0)?ua:Ia;Ia=Ha+8|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)<(ua|0)?ua:Ma;Ma=Ha+4|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)>(za|0)?za:Ia;Ia=Ha+12|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)<(za|0)?za:Ma;Ma=Ha+16|0;f[Ma>>2]=(f[Ma>>2]|0)+1;Ma=f[va+120>>2]|0;va=Ma+(Ka<<4)|0;Ha=va;Ia=d1c(f[Ha>>2]|0,f[Ha+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ha=va;f[Ha>>2]=Ia;f[Ha+4>>2]=J;Xa=Ma+(Ka<<4)+8|0}Ma=Xa;Ha=d1c(f[Ma>>2]|0,f[Ma+4>>2]|0,za|0,r|0)|0;Ma=Xa;f[Ma>>2]=Ha;f[Ma+4>>2]=J;Ma=ua|1;if((Ma|0)<(f[(f[h>>2]|0)+12>>2]|0)){Ha=Qa+(Ma<<2)|0;if(!(b[Ra+Ma>>0]|0)){f[Ha>>2]=0;Ia=f[Oa>>2]|0;va=f[Ia+20>>2]|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)>(Ma|0)?Ma:Aa;Aa=va+8|0;Da=f[Aa>>2]|0;f[Aa>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=va+4|0;Aa=f[Da>>2]|0;f[Da>>2]=(Aa|0)>(Va|0)?Va:Aa;Aa=va+12|0;Da=f[Aa>>2]|0;f[Aa>>2]=(Da|0)<(Va|0)?Va:Da;Da=va+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ia+120>>2]|0;Ia=Da;va=d1c(f[Ia>>2]|0,f[Ia+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ia=Da;f[Ia>>2]=va;f[Ia+4>>2]=J;Ya=Da+8|0}else{f[Ha>>2]=Ka;Ha=f[Oa>>2]|0;Da=(f[Ha+20>>2]|0)+(Y(f[f[Ha+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(Ma|0)?Ma:Ia;Ia=Da+8|0;va=f[Ia>>2]|0;f[Ia>>2]=(va|0)<(Ma|0)?Ma:va;va=Da+4|0;Ia=f[va>>2]|0;f[va>>2]=(Ia|0)>(Va|0)?Va:Ia;Ia=Da+12|0;va=f[Ia>>2]|0;f[Ia>>2]=(va|0)<(Va|0)?Va:va;va=Da+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ha+120>>2]|0;Ha=va+(Ka<<4)|0;Da=Ha;Ia=d1c(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=Ha;f[Da>>2]=Ia;f[Da+4>>2]=J;Ya=va+(Ka<<4)+8|0}va=Ya;Da=d1c(f[va>>2]|0,f[va+4>>2]|0,Va|0,Sa|0)|0;va=Ya;f[va>>2]=Da;f[va+4>>2]=J;va=Z+(Ma<<2)|0;if(!(b[Ta+Ma>>0]|0)){f[va>>2]=0;Da=f[Oa>>2]|0;Ia=f[Da+20>>2]|0;Ha=f[Ia>>2]|0;f[Ia>>2]=(Ha|0)>(Ma|0)?Ma:Ha;Ha=Ia+8|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)<(Ma|0)?Ma:Aa;Aa=Ia+4|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)>(za|0)?za:Ha;Ha=Ia+12|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)<(za|0)?za:Aa;Aa=Ia+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Da+120>>2]|0;Da=Aa;Ia=d1c(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=Aa;f[Da>>2]=Ia;f[Da+4>>2]=J;Da=Aa+8|0;Aa=Da;Ia=d1c(f[Aa>>2]|0,f[Aa+4>>2]|0,za|0,r|0)|0;Aa=Da;f[Aa>>2]=Ia;f[Aa+4>>2]=J;break}else{f[va>>2]=Ka;va=f[Oa>>2]|0;Aa=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Aa>>2]|0;f[Aa>>2]=(Ia|0)>(Ma|0)?Ma:Ia;Ia=Aa+8|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=Aa+4|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(za|0)?za:Ia;Ia=Aa+12|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(za|0)?za:Da;Da=Aa+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[va+120>>2]|0;va=Da+(Ka<<4)|0;Aa=va;Ia=d1c(f[Aa>>2]|0,f[Aa+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ma=va;f[Ma>>2]=Ia;f[Ma+4>>2]=J;Ma=Da+(Ka<<4)+8|0;Ka=Ma;Da=d1c(f[Ka>>2]|0,f[Ka+4>>2]|0,za|0,r|0)|0;Ka=Ma;f[Ka>>2]=Da;f[Ka+4>>2]=J;break}}}else{f[La>>2]=0;f[Z+(ua<<2)>>2]=0;Ka=f[Oa>>2]|0;Da=f[Ka+20>>2]|0;Ma=f[Da>>2]|0;f[Da>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Da+8|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)<(ua|0)?ua:Ia;Ia=Da+4|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)>(Va|0)?Va:Ma;Ma=Da+12|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)<(Va|0)?Va:Ia;Ia=Da+16|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ia=f[Ka+120>>2]|0;Ka=((ua|0)<0)<<31>>31;Da=Ia;Ma=d1c(f[Da>>2]|0,f[Da+4>>2]|0,ua|0,Ka|0)|0;Da=Ia;f[Da>>2]=Ma;f[Da+4>>2]=J;Da=Ia+8|0;Ia=Da;Ma=d1c(f[Ia>>2]|0,f[Ia+4>>2]|0,Va|0,Sa|0)|0;Ia=Da;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;Da=f[Ma>>2]|0;f[Ma>>2]=(Da|0)>(ua|0)?ua:Da;Da=Ma+8|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(ua|0)?ua:va;va=Ma+4|0;Da=f[va>>2]|0;f[va>>2]=(Da|0)>(za|0)?za:Da;Da=Ma+12|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(za|0)?za:va;va=Ma+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ia+120>>2]|0;Ia=va;Ma=d1c(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,Ka|0)|0;Ka=va;f[Ka>>2]=Ma;f[Ka+4>>2]=J;Ka=va+8|0;va=Ka;Ma=d1c(f[va>>2]|0,f[va+4>>2]|0,za|0,r|0)|0;va=Ka;f[va>>2]=Ma;f[va+4>>2]=J;va=ua|1;if((va|0)<(f[(f[h>>2]|0)+12>>2]|0)){f[Qa+(va<<2)>>2]=0;f[Z+(va<<2)>>2]=0;Ma=f[Oa>>2]|0;Ka=f[Ma+20>>2]|0;Ia=f[Ka>>2]|0;f[Ka>>2]=(Ia|0)>(va|0)?va:Ia;Ia=Ka+8|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(va|0)?va:Da;Da=Ka+4|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(Va|0)?Va:Ia;Ia=Ka+12|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(Va|0)?Va:Da;Da=Ka+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ma+120>>2]|0;Ma=((va|0)<0)<<31>>31;Ka=Da;Ia=d1c(f[Ka>>2]|0,f[Ka+4>>2]|0,va|0,Ma|0)|0;Ka=Da;f[Ka>>2]=Ia;f[Ka+4>>2]=J;Ka=Da+8|0;Da=Ka;Ia=d1c(f[Da>>2]|0,f[Da+4>>2]|0,Va|0,Sa|0)|0;Da=Ka;f[Da>>2]=Ia;f[Da+4>>2]=J;Da=f[Oa>>2]|0;Ia=f[Da+20>>2]|0;Ka=f[Ia>>2]|0;f[Ia>>2]=(Ka|0)>(va|0)?va:Ka;Ka=Ia+8|0;Aa=f[Ka>>2]|0;f[Ka>>2]=(Aa|0)<(va|0)?va:Aa;Aa=Ia+4|0;Ka=f[Aa>>2]|0;f[Aa>>2]=(Ka|0)>(za|0)?za:Ka;Ka=Ia+12|0;Aa=f[Ka>>2]|0;f[Ka>>2]=(Aa|0)<(za|0)?za:Aa;Aa=Ia+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Da+120>>2]|0;Da=Aa;Ia=d1c(f[Da>>2]|0,f[Da+4>>2]|0,va|0,Ma|0)|0;Ma=Aa;f[Ma>>2]=Ia;f[Ma+4>>2]=J;Ma=Aa+8|0;Aa=Ma;Ia=d1c(f[Aa>>2]|0,f[Aa+4>>2]|0,za|0,r|0)|0;Aa=Ma;f[Aa>>2]=Ia;f[Aa+4>>2]=J}}while(0);ua=ua+2|0;La=f[h>>2]|0;Na=f[La+12>>2]|0}while((ua|0)<(Na|0));Za=Na;_a=La}else{Za=Ja;_a=x}Va=Va+2|0;if((Va|0)>=(c|0))break;else{x=_a;Ja=Za}}return}if(!g){if(!d)return;g=a+4|0;Za=a+12|0;Ja=e;_a=Pa;x=Ba;while(1){Va=f[g>>2]|0;Ya=f[f[Va+44>>2]>>2]|0;Xa=(f[Va+16>>2]|0)+(Y(Ya,Ja)|0)|0;Va=Xa+Ya|0;Ya=f[f[_a+44>>2]>>2]|0;Wa=(f[_a+16>>2]|0)+(Y(Ya,Ja)|0)|0;qa=Wa+Ya|0;if((x|0)>0){Ya=((Ja|0)<0)<<31>>31;Ua=Ja+1|0;ua=((Ua|0)<0)<<31>>31;r=0;do{za=Wa+(r<<2)|0;Sa=f[za>>2]|0;do if((Sa|0)>0){Z=f[(f[Za>>2]|0)+(Sa<<2)>>2]|0;if(!(b[Xa+r>>0]|0)){f[za>>2]=0;Qa=f[Oa>>2]|0;Ta=f[Qa+20>>2]|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)>(r|0)?r:Ra;Ra=Ta+8|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(r|0)?r:La;La=Ta+4|0;Ra=f[La>>2]|0;f[La>>2]=(Ra|0)>(Ja|0)?Ja:Ra;Ra=Ta+12|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(Ja|0)?Ja:La;La=Ta+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ta=d1c(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=La+8|0}else{f[za>>2]=Z;La=f[Oa>>2]|0;Qa=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;Ta=f[Qa>>2]|0;f[Qa>>2]=(Ta|0)>(r|0)?r:Ta;Ta=Qa+8|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(r|0)?r:Ra;Ra=Qa+4|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(Ja|0)?Ja:Ta;Ta=Qa+12|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(Ja|0)?Ja:Ra;Ra=Qa+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=f[La+120>>2]|0;La=Ra+(Z<<4)|0;Qa=La;Ta=d1c(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=Ra+(Z<<4)+8|0}Ra=$a;Qa=d1c(f[Ra>>2]|0,f[Ra+4>>2]|0,Ja|0,Ya|0)|0;Ra=$a;f[Ra>>2]=Qa;f[Ra+4>>2]=J;Ra=r|1;Qa=Wa+(Ra<<2)|0;if(!(b[Xa+Ra>>0]|0)){f[Qa>>2]=0;Ta=f[Oa>>2]|0;La=f[Ta+20>>2]|0;Na=f[La>>2]|0;f[La>>2]=(Na|0)>(Ra|0)?Ra:Na;Na=La+8|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)<(Ra|0)?Ra:Aa;Aa=La+4|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)>(Ja|0)?Ja:Na;Na=La+12|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)<(Ja|0)?Ja:Aa;Aa=La+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Ta+120>>2]|0;Ta=Aa;La=d1c(f[Ta>>2]|0,f[Ta+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ta=Aa;f[Ta>>2]=La;f[Ta+4>>2]=J;ab=Aa+8|0}else{f[Qa>>2]=Z;Qa=f[Oa>>2]|0;Aa=(f[Qa+20>>2]|0)+(Y(f[f[Qa+48>>2]>>2]|0,Z)|0)|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)>(Ra|0)?Ra:Ta;Ta=Aa+8|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Ra|0)?Ra:La;La=Aa+4|0;Ta=f[La>>2]|0;f[La>>2]=(Ta|0)>(Ja|0)?Ja:Ta;Ta=Aa+12|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Ja|0)?Ja:La;La=Aa+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La+(Z<<4)|0;Aa=Qa;Ta=d1c(f[Aa>>2]|0,f[Aa+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Aa=Qa;f[Aa>>2]=Ta;f[Aa+4>>2]=J;ab=La+(Z<<4)+8|0}La=ab;Aa=d1c(f[La>>2]|0,f[La+4>>2]|0,Ja|0,Ya|0)|0;La=ab;f[La>>2]=Aa;f[La+4>>2]=J;if((Ua|0)<(f[(f[h>>2]|0)+8>>2]|0)){La=qa+(r<<2)|0;if(!(b[Va+r>>0]|0)){f[La>>2]=0;Aa=f[Oa>>2]|0;Ta=f[Aa+20>>2]|0;Qa=f[Ta>>2]|0;f[Ta>>2]=(Qa|0)>(r|0)?r:Qa;Qa=Ta+8|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(r|0)?r:Na;Na=Ta+4|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)>(Ua|0)?Ua:Qa;Qa=Ta+12|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(Ua|0)?Ua:Na;Na=Ta+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[Aa+120>>2]|0;Aa=Na;Ta=d1c(f[Aa>>2]|0,f[Aa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Aa=Na;f[Aa>>2]=Ta;f[Aa+4>>2]=J;bb=Na+8|0}else{f[La>>2]=Z;La=f[Oa>>2]|0;Na=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Na+8|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(r|0)?r:Ta;Ta=Na+4|0;Aa=f[Ta>>2]|0;f[Ta>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Na+12|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(Ua|0)?Ua:Ta;Ta=Na+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[La+120>>2]|0;La=Ta+(Z<<4)|0;Na=La;Aa=d1c(f[Na>>2]|0,f[Na+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Na=La;f[Na>>2]=Aa;f[Na+4>>2]=J;bb=Ta+(Z<<4)+8|0}Ta=bb;Na=d1c(f[Ta>>2]|0,f[Ta+4>>2]|0,Ua|0,ua|0)|0;Ta=bb;f[Ta>>2]=Na;f[Ta+4>>2]=J;Ta=qa+(Ra<<2)|0;if(!(b[Va+Ra>>0]|0)){f[Ta>>2]=0;Na=f[Oa>>2]|0;Aa=f[Na+20>>2]|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)>(Ra|0)?Ra:La;La=Aa+8|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Ra|0)?Ra:Qa;Qa=Aa+4|0;La=f[Qa>>2]|0;f[Qa>>2]=(La|0)>(Ua|0)?Ua:La;La=Aa+12|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Ua|0)?Ua:Qa;Qa=Aa+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Na+120>>2]|0;Na=Qa;Aa=d1c(f[Na>>2]|0,f[Na+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Na=Qa;f[Na>>2]=Aa;f[Na+4>>2]=J;Na=Qa+8|0;Qa=Na;Aa=d1c(f[Qa>>2]|0,f[Qa+4>>2]|0,Ua|0,ua|0)|0;Qa=Na;f[Qa>>2]=Aa;f[Qa+4>>2]=J;break}else{f[Ta>>2]=Z;Ta=f[Oa>>2]|0;Qa=(f[Ta+20>>2]|0)+(Y(f[f[Ta+48>>2]>>2]|0,Z)|0)|0;Aa=f[Qa>>2]|0;f[Qa>>2]=(Aa|0)>(Ra|0)?Ra:Aa;Aa=Qa+8|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)<(Ra|0)?Ra:Na;Na=Qa+4|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Qa+12|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)<(Ua|0)?Ua:Na;Na=Qa+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[Ta+120>>2]|0;Ta=Na+(Z<<4)|0;Qa=Ta;Aa=d1c(f[Qa>>2]|0,f[Qa+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ra=Ta;f[Ra>>2]=Aa;f[Ra+4>>2]=J;Ra=Na+(Z<<4)+8|0;Z=Ra;Na=d1c(f[Z>>2]|0,f[Z+4>>2]|0,Ua|0,ua|0)|0;Z=Ra;f[Z>>2]=Na;f[Z+4>>2]=J;break}}}else{f[za>>2]=0;Z=r|1;f[Wa+(Z<<2)>>2]=0;Na=f[Oa>>2]|0;Ra=f[Na+20>>2]|0;Aa=f[Ra>>2]|0;f[Ra>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Ra+8|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(r|0)?r:Ta;Ta=Ra+4|0;Aa=f[Ta>>2]|0;f[Ta>>2]=(Aa|0)>(Ja|0)?Ja:Aa;Aa=Ra+12|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(Ja|0)?Ja:Ta;Ta=Ra+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[Na+120>>2]|0;Na=((r|0)<0)<<31>>31;Ra=Ta;Aa=d1c(f[Ra>>2]|0,f[Ra+4>>2]|0,r|0,Na|0)|0;Ra=Ta;f[Ra>>2]=Aa;f[Ra+4>>2]=J;Ra=Ta+8|0;Ta=Ra;Aa=d1c(f[Ta>>2]|0,f[Ta+4>>2]|0,Ja|0,Ya|0)|0;Ta=Ra;f[Ta>>2]=Aa;f[Ta+4>>2]=J;Ta=f[Oa>>2]|0;Aa=f[Ta+20>>2]|0;Ra=f[Aa>>2]|0;f[Aa>>2]=(Ra|0)>(Z|0)?Z:Ra;Ra=Aa+8|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=Aa+4|0;Ra=f[Qa>>2]|0;f[Qa>>2]=(Ra|0)>(Ja|0)?Ja:Ra;Ra=Aa+12|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Ja|0)?Ja:Qa;Qa=Aa+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Ta+120>>2]|0;Ta=((Z|0)<0)<<31>>31;Aa=Qa;Ra=d1c(f[Aa>>2]|0,f[Aa+4>>2]|0,Z|0,Ta|0)|0;Aa=Qa;f[Aa>>2]=Ra;f[Aa+4>>2]=J;Aa=Qa+8|0;Qa=Aa;Ra=d1c(f[Qa>>2]|0,f[Qa+4>>2]|0,Ja|0,Ya|0)|0;Qa=Aa;f[Qa>>2]=Ra;f[Qa+4>>2]=J;if((Ua|0)<(f[(f[h>>2]|0)+8>>2]|0)){f[qa+(r<<2)>>2]=0;f[qa+(Z<<2)>>2]=0;Qa=f[Oa>>2]|0;Ra=f[Qa+20>>2]|0;Aa=f[Ra>>2]|0;f[Ra>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Ra+8|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)<(r|0)?r:La;La=Ra+4|0;Aa=f[La>>2]|0;f[La>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Ra+12|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)<(Ua|0)?Ua:La;La=Ra+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ra=d1c(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,Na|0)|0;Na=La;f[Na>>2]=Ra;f[Na+4>>2]=J;Na=La+8|0;La=Na;Ra=d1c(f[La>>2]|0,f[La+4>>2]|0,Ua|0,ua|0)|0;La=Na;f[La>>2]=Ra;f[La+4>>2]=J;La=f[Oa>>2]|0;Ra=f[La+20>>2]|0;Na=f[Ra>>2]|0;f[Ra>>2]=(Na|0)>(Z|0)?Z:Na;Na=Ra+8|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=Ra+4|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)>(Ua|0)?Ua:Na;Na=Ra+12|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Ua|0)?Ua:Qa;Qa=Ra+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[La+120>>2]|0;La=Qa;Ra=d1c(f[La>>2]|0,f[La+4>>2]|0,Z|0,Ta|0)|0;Ta=Qa;f[Ta>>2]=Ra;f[Ta+4>>2]=J;Ta=Qa+8|0;Qa=Ta;Ra=d1c(f[Qa>>2]|0,f[Qa+4>>2]|0,Ua|0,ua|0)|0;Qa=Ta;f[Qa>>2]=Ra;f[Qa+4>>2]=J}}while(0);r=r+2|0;za=f[h>>2]|0;Sa=f[za+12>>2]|0}while((r|0)<(Sa|0));cb=Sa;db=za}else{cb=x;db=_a}Ja=Ja+2|0;if((Ja|0)>=(c|0))break;else{_a=db;x=cb}}return}if(!d)return;d=a+4|0;cb=a+12|0;a=e;e=Pa;Pa=Ba;while(1){Ba=f[d>>2]|0;x=f[f[Ba+44>>2]>>2]|0;db=(f[Ba+16>>2]|0)+(Y(x,a)|0)|0;Ba=db+x|0;x=f[f[e+44>>2]>>2]|0;_a=(f[e+16>>2]|0)+(Y(x,a)|0)|0;Ja=_a+x|0;if((Pa|0)>0){x=((a|0)<0)<<31>>31;bb=a+1|0;ab=((bb|0)<0)<<31>>31;$a=0;do{Za=_a+($a<<2)|0;g=f[Za>>2]|0;do if((g|0)>0){r=f[(f[cb>>2]|0)+(g<<2)>>2]|0;if(!(b[db+$a>>0]|0)){f[Za>>2]=0;ua=f[Oa>>2]|0;Ua=f[ua+20>>2]|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)>($a|0)?$a:qa;qa=Ua+8|0;Ya=f[qa>>2]|0;f[qa>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=Ua+4|0;qa=f[Ya>>2]|0;f[Ya>>2]=(qa|0)>(a|0)?a:qa;qa=Ua+12|0;Ya=f[qa>>2]|0;f[qa>>2]=(Ya|0)<(a|0)?a:Ya;Ya=Ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[ua+120>>2]|0;ua=Ya;Ua=d1c(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;eb=Ya+8|0}else{f[Za>>2]=r;Ya=f[Oa>>2]|0;ua=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,r)|0)|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=ua+8|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)<($a|0)?$a:qa;qa=ua+4|0;Ua=f[qa>>2]|0;f[qa>>2]=(Ua|0)>(a|0)?a:Ua;Ua=ua+12|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)<(a|0)?a:qa;qa=ua+16|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=f[Ya+120>>2]|0;Ya=qa+(r<<4)|0;ua=Ya;Ua=d1c(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;eb=qa+(r<<4)+8|0}qa=eb;ua=d1c(f[qa>>2]|0,f[qa+4>>2]|0,a|0,x|0)|0;qa=eb;f[qa>>2]=ua;f[qa+4>>2]=J;qa=$a|1;ua=f[h>>2]|0;if((qa|0)>=(f[ua+12>>2]|0)){if((bb|0)>=(f[ua+8>>2]|0))break;ua=Ja+($a<<2)|0;if(!(b[Ba+$a>>0]|0)){f[ua>>2]=0;Ua=f[Oa>>2]|0;Ya=f[Ua+20>>2]|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=Ya+8|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)<($a|0)?$a:Va;Va=Ya+4|0;Wa=f[Va>>2]|0;f[Va>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Ya+12|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)<(bb|0)?bb:Va;Va=Ya+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[Ua+120>>2]|0;Ua=Va;Ya=d1c(f[Ua>>2]|0,f[Ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Ua=Va;f[Ua>>2]=Ya;f[Ua+4>>2]=J;Ua=Va+8|0;Va=Ua;Ya=d1c(f[Va>>2]|0,f[Va+4>>2]|0,bb|0,ab|0)|0;Va=Ua;f[Va>>2]=Ya;f[Va+4>>2]=J;break}else{f[ua>>2]=r;ua=f[Oa>>2]|0;Va=(f[ua+20>>2]|0)+(Y(f[f[ua+48>>2]>>2]|0,r)|0)|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Va+8|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)<($a|0)?$a:Ua;Ua=Va+4|0;Ya=f[Ua>>2]|0;f[Ua>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Va+12|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)<(bb|0)?bb:Ua;Ua=Va+16|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Ua=f[ua+120>>2]|0;ua=Ua+(r<<4)|0;Va=ua;Ya=d1c(f[Va>>2]|0,f[Va+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Va=ua;f[Va>>2]=Ya;f[Va+4>>2]=J;Va=Ua+(r<<4)+8|0;Ua=Va;Ya=d1c(f[Ua>>2]|0,f[Ua+4>>2]|0,bb|0,ab|0)|0;Ua=Va;f[Ua>>2]=Ya;f[Ua+4>>2]=J;break}}Ua=_a+(qa<<2)|0;if(!(b[db+qa>>0]|0)){f[Ua>>2]=0;Ya=f[Oa>>2]|0;Va=f[Ya+20>>2]|0;ua=f[Va>>2]|0;f[Va>>2]=(ua|0)>(qa|0)?qa:ua;ua=Va+8|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(qa|0)?qa:Wa;Wa=Va+4|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)>(a|0)?a:ua;ua=Va+12|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(a|0)?a:Wa;Wa=Va+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[Ya+120>>2]|0;Ya=Wa;Va=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;Ya=Wa;f[Ya>>2]=Va;f[Ya+4>>2]=J;fb=Wa+8|0}else{f[Ua>>2]=r;Ua=f[Oa>>2]|0;Wa=(f[Ua+20>>2]|0)+(Y(f[f[Ua+48>>2]>>2]|0,r)|0)|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)>(qa|0)?qa:Ya;Ya=Wa+8|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<(qa|0)?qa:Va;Va=Wa+4|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>(a|0)?a:Ya;Ya=Wa+12|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<(a|0)?a:Va;Va=Wa+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[Ua+120>>2]|0;Ua=Va+(r<<4)|0;Wa=Ua;Ya=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;Wa=Ua;f[Wa>>2]=Ya;f[Wa+4>>2]=J;fb=Va+(r<<4)+8|0}Va=fb;Wa=d1c(f[Va>>2]|0,f[Va+4>>2]|0,a|0,x|0)|0;Va=fb;f[Va>>2]=Wa;f[Va+4>>2]=J;if((bb|0)<(f[(f[h>>2]|0)+8>>2]|0)){Va=Ja+($a<<2)|0;if(!(b[Ba+$a>>0]|0)){f[Va>>2]=0;Wa=f[Oa>>2]|0;Ya=f[Wa+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=Ya+8|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>(bb|0)?bb:Ua;Ua=Ya+12|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Wa+120>>2]|0;Wa=ua;Ya=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Wa=ua;f[Wa>>2]=Ya;f[Wa+4>>2]=J;gb=ua+8|0}else{f[Va>>2]=r;Va=f[Oa>>2]|0;ua=(f[Va+20>>2]|0)+(Y(f[f[Va+48>>2]>>2]|0,r)|0)|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=ua+8|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=ua+4|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=ua+12|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Va+120>>2]|0;Va=Ya+(r<<4)|0;ua=Va;Wa=d1c(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Va;f[ua>>2]=Wa;f[ua+4>>2]=J;gb=Ya+(r<<4)+8|0}Ya=gb;ua=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=gb;f[Ya>>2]=ua;f[Ya+4>>2]=J;Ya=Ja+(qa<<2)|0;if(!(b[Ba+qa>>0]|0)){f[Ya>>2]=0;ua=f[Oa>>2]|0;Wa=f[ua+20>>2]|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)>(qa|0)?qa:Va;Va=Wa+8|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)<(qa|0)?qa:Ua;Ua=Wa+4|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)>(bb|0)?bb:Va;Va=Wa+12|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)<(bb|0)?bb:Ua;Ua=Wa+16|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Ua=f[ua+120>>2]|0;ua=Ua;Wa=d1c(f[ua>>2]|0,f[ua+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;ua=Ua;f[ua>>2]=Wa;f[ua+4>>2]=J;ua=Ua+8|0;Ua=ua;Wa=d1c(f[Ua>>2]|0,f[Ua+4>>2]|0,bb|0,ab|0)|0;Ua=ua;f[Ua>>2]=Wa;f[Ua+4>>2]=J;break}else{f[Ya>>2]=r;Ya=f[Oa>>2]|0;Ua=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,r)|0)|0;Wa=f[Ua>>2]|0;f[Ua>>2]=(Wa|0)>(qa|0)?qa:Wa;Wa=Ua+8|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(qa|0)?qa:ua;ua=Ua+4|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Ua+12|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ua+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Ya+120>>2]|0;Ya=ua+(r<<4)|0;Ua=Ya;Wa=d1c(f[Ua>>2]|0,f[Ua+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;qa=Ya;f[qa>>2]=Wa;f[qa+4>>2]=J;qa=ua+(r<<4)+8|0;r=qa;ua=d1c(f[r>>2]|0,f[r+4>>2]|0,bb|0,ab|0)|0;r=qa;f[r>>2]=ua;f[r+4>>2]=J;break}}}else{f[Za>>2]=0;r=f[Oa>>2]|0;ua=f[r+20>>2]|0;qa=f[ua>>2]|0;f[ua>>2]=(qa|0)>($a|0)?$a:qa;qa=ua+8|0;Wa=f[qa>>2]|0;f[qa>>2]=(Wa|0)<($a|0)?$a:Wa;Wa=ua+4|0;qa=f[Wa>>2]|0;f[Wa>>2]=(qa|0)>(a|0)?a:qa;qa=ua+12|0;Wa=f[qa>>2]|0;f[qa>>2]=(Wa|0)<(a|0)?a:Wa;Wa=ua+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[r+120>>2]|0;r=(($a|0)<0)<<31>>31;ua=Wa;qa=d1c(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,r|0)|0;ua=Wa;f[ua>>2]=qa;f[ua+4>>2]=J;ua=Wa+8|0;Wa=ua;qa=d1c(f[Wa>>2]|0,f[Wa+4>>2]|0,a|0,x|0)|0;Wa=ua;f[Wa>>2]=qa;f[Wa+4>>2]=J;Wa=$a|1;qa=f[h>>2]|0;if((Wa|0)<(f[qa+12>>2]|0)){f[_a+(Wa<<2)>>2]=0;ua=f[Oa>>2]|0;Ya=f[ua+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>(Wa|0)?Wa:Ua;Ua=Ya+8|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)<(Wa|0)?Wa:Va;Va=Ya+4|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)>(a|0)?a:Ua;Ua=Ya+12|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)<(a|0)?a:Va;Va=Ya+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[ua+120>>2]|0;ua=((Wa|0)<0)<<31>>31;Ya=Va;Ua=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,Wa|0,ua|0)|0;Ya=Va;f[Ya>>2]=Ua;f[Ya+4>>2]=J;Ya=Va+8|0;Va=Ya;Ua=d1c(f[Va>>2]|0,f[Va+4>>2]|0,a|0,x|0)|0;Va=Ya;f[Va>>2]=Ua;f[Va+4>>2]=J;if((bb|0)>=(f[(f[h>>2]|0)+8>>2]|0))break;f[Ja+($a<<2)>>2]=0;f[Ja+(Wa<<2)>>2]=0;Va=f[Oa>>2]|0;Ua=f[Va+20>>2]|0;Ya=f[Ua>>2]|0;f[Ua>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Ua+8|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<($a|0)?$a:Xa;Xa=Ua+4|0;Ya=f[Xa>>2]|0;f[Xa>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Ua+12|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<(bb|0)?bb:Xa;Xa=Ua+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[Va+120>>2]|0;Va=Xa;Ua=d1c(f[Va>>2]|0,f[Va+4>>2]|0,$a|0,r|0)|0;Va=Xa;f[Va>>2]=Ua;f[Va+4>>2]=J;Va=Xa+8|0;Xa=Va;Ua=d1c(f[Xa>>2]|0,f[Xa+4>>2]|0,bb|0,ab|0)|0;Xa=Va;f[Xa>>2]=Ua;f[Xa+4>>2]=J;Xa=f[Oa>>2]|0;Ua=f[Xa+20>>2]|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)>(Wa|0)?Wa:Va;Va=Ua+8|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)<(Wa|0)?Wa:Ya;Ya=Ua+4|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)>(bb|0)?bb:Va;Va=Ua+12|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=Ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Xa+120>>2]|0;Xa=Ya;Ua=d1c(f[Xa>>2]|0,f[Xa+4>>2]|0,Wa|0,ua|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;ua=Ya+8|0;Ya=ua;Ua=d1c(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=ua;f[Ya>>2]=Ua;f[Ya+4>>2]=J;break}else{if((bb|0)>=(f[qa+8>>2]|0))break;f[Ja+($a<<2)>>2]=0;qa=f[Oa>>2]|0;Ya=f[qa+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=Ya+8|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>(bb|0)?bb:Ua;Ua=Ya+12|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[qa+120>>2]|0;qa=ua;Ya=d1c(f[qa>>2]|0,f[qa+4>>2]|0,$a|0,r|0)|0;r=ua;f[r>>2]=Ya;f[r+4>>2]=J;r=ua+8|0;ua=r;Ya=d1c(f[ua>>2]|0,f[ua+4>>2]|0,bb|0,ab|0)|0;ua=r;f[ua>>2]=Ya;f[ua+4>>2]=J;break}}while(0);$a=$a+2|0;Za=f[h>>2]|0;g=f[Za+12>>2]|0}while(($a|0)<(g|0));hb=g;ib=Za}else{hb=Pa;ib=e}a=a+2|0;if((a|0)>=(c|0))break;else{e=ib;Pa=hb}}return}}function Bwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+80|0;d=c;e=c+16|0;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;l=e+48|0;m=e+44|0;f[m>>2]=l;f[l>>2]=0;f[e+52>>2]=0;f[d>>2]=b;f[d+4>>2]=5;S$(e,2,d,4);n=a+4|0;if((n|0)==(e|0)){o=e+36|0;p=f[o>>2]|0;if((p|0)!=0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0){V$(e);r=o}else r=o}else{o=a+40|0;p=f[o>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)V$(n);f[o>>2]=0;p=a+20|0;q=a+8|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[q>>2]|0)>0){s=f[a+44>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[q>>2]|0))}f[n>>2]=f[e>>2];n=f[g>>2]|0;f[q>>2]=n;q=a+12|0;f[q>>2]=f[h>>2];f[a+16>>2]=f[e+12>>2];f[p>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];p=e+36|0;f[o>>2]=f[p>>2];o=a+48|0;t=f[o>>2]|0;s=a+52|0;if((t|0)==(s|0)){v=n;w=t}else{wL(t);f[o>>2]=s;f[a+44>>2]=q;v=f[g>>2]|0;w=s}s=e+44|0;if((v|0)<3){v=f[s>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2]}else{f[o>>2]=f[s>>2];f[a+44>>2]=f[i>>2];f[s>>2]=l;f[i>>2]=h}f[e>>2]=1124007936;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));r=p}f[r>>2]=0;r=e+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[g>>2]|0)>0){r=f[i>>2]|0;i=0;do{f[r+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[m>>2]|0;if((g|0)!=(l|0))wL(g);if((b|0)>0){g=f[a+20>>2]|0;l=f[a+48>>2]|0;m=0;do{i=g+(Y(f[l>>2]|0,m)|0)|0;f[i>>2]=2147483647;f[i+4>>2]=2147483647;f[i+8>>2]=-2147483648;f[i+12>>2]=-2147483648;f[i+16>>2]=0;m=m+1|0}while((m|0)!=(b|0))}m=a+120|0;l=a+124|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;a=f[l>>2]|0;g=f[m>>2]|0;i=a-g>>4;r=a;if(i>>>0<b>>>0){Cwa(m,b-i|0,d);u=c;return}if(i>>>0<=b>>>0){u=c;return}i=g+(b<<4)|0;if((r|0)==(i|0)){u=c;return}f[l>>2]=r+(~((r+-16-i|0)>>>4)<<4);u=c;return}function Cwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>4>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];f[j+12>>2]=f[c+12>>2];j=(f[g>>2]|0)+16|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>4;h=j+b|0;if(h>>>0>268435455)kWc(a);k=e-i|0;i=k>>3;e=k>>4>>>0<134217727?(i>>>0<h>>>0?h:i):268435455;do if(e)if(e>>>0>268435455){i=af(8)|0;hYc(i,512536);f[i>>2]=192348;ig(i|0,25336,2140)}else{l=$Xc(e<<4)|0;break}else l=0;while(0);i=l+(j<<4)|0;j=l+(e<<4)|0;e=b;b=i;l=i;do{f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];b=l+16|0;l=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>4)<<4)|0;if((b|0)>0)o1c(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=l;f[d>>2]=j;if(!e)return;cYc(e);return}function Dwa(a){a=a|0;cYc(a);return}function Ewa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=j;p=h;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=e;s=j;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,a)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,a)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(a+1|0)<(m|0);A=(a|0)>(e|0);B=A^1;C=(a|0)>(c|0);D=0;E=s;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=s;a=a+2|0;if((a|0)>=(f[d>>2]|0))break;else s=wb}o=wb;p=f[g>>2]|0;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}function Fwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function Gwa(a){a=a|0;cYc(a);return}function Hwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>0){b=a+16|0;Bwa((f[b>>2]|0)+(c*136|0)|0,f[f[a+20>>2]>>2]|0);e=f[b>>2]|0;f[e+(c*136|0)+132>>2]=d;if((c|0)>=(d|0))return;b=a+4|0;g=a+8|0;h=e+(c*136|0)+20|0;i=e+(c*136|0)+48|0;j=e+(c*136|0)+120|0;e=c;do{k=f[b>>2]|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,e)|0)|0;m=l+(f[k+12>>2]<<2)|0;if((l|0)!=(m|0)){k=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=f[j>>2]|0;q=((e|0)<0)<<31>>31;r=0;s=l;while(1){l=f[k+(f[s>>2]<<2)>>2]|0;f[s>>2]=l;t=n+(Y(f[o>>2]|0,l)|0)|0;u=f[t>>2]|0;f[t>>2]=(u|0)>(r|0)?r:u;u=t+8|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(r|0)?r:v;v=t+4|0;u=f[v>>2]|0;f[v>>2]=(u|0)>(e|0)?e:u;u=t+12|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(e|0)?e:v;v=t+16|0;f[v>>2]=(f[v>>2]|0)+1;v=p+(l<<4)|0;t=v;u=d1c(f[t>>2]|0,f[t+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;t=v;f[t>>2]=u;f[t+4>>2]=J;t=p+(l<<4)+8|0;l=t;u=d1c(f[l>>2]|0,f[l+4>>2]|0,e|0,q|0)|0;l=t;f[l>>2]=u;f[l+4>>2]=J;s=s+4|0;if((s|0)==(m|0))break;else r=r+1|0}}e=e+1|0}while((e|0)!=(d|0));return}else{e=a+12|0;f[(f[e>>2]|0)+132>>2]=d;if((c|0)>=(d|0))return;j=a+4|0;i=a+8|0;a=c;do{c=f[j>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;g=h+(f[c+12>>2]<<2)|0;if((h|0)!=(g|0)){c=f[i>>2]|0;b=((a|0)<0)<<31>>31;r=h;h=0;while(1){m=f[c+(f[r>>2]<<2)>>2]|0;f[r>>2]=m;s=f[e>>2]|0;q=(f[s+20>>2]|0)+(Y(f[f[s+48>>2]>>2]|0,m)|0)|0;p=f[q>>2]|0;f[q>>2]=(p|0)>(h|0)?h:p;p=q+8|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(h|0)?h:o;o=q+4|0;p=f[o>>2]|0;f[o>>2]=(p|0)>(a|0)?a:p;p=q+12|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(a|0)?a:o;o=q+16|0;f[o>>2]=(f[o>>2]|0)+1;o=f[s+120>>2]|0;s=o+(m<<4)|0;q=s;p=d1c(f[q>>2]|0,f[q+4>>2]|0,h|0,((h|0)<0)<<31>>31|0)|0;q=s;f[q>>2]=p;f[q+4>>2]=J;q=o+(m<<4)+8|0;m=q;o=d1c(f[m>>2]|0,f[m+4>>2]|0,a|0,b|0)|0;m=q;f[m>>2]=o;f[m+4>>2]=J;r=r+4|0;if((r|0)==(g|0))break;else h=h+1|0}}a=a+1|0}while((a|0)!=(d|0));return}}function Iwa(a){a=a|0;cYc(a);return}function Jwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=d;s=i;t=k;k=h;while(1){h=f[f[t+44>>2]>>2]|0;u=(f[t+16>>2]|0)+(Y(h,a)|0)|0;v=u+(0-h)|0;h=f[f[k+44>>2]>>2]|0;w=(f[k+16>>2]|0)+(Y(h,a)|0)|0;x=w+(0-h)|0;a:do if(q){if((a|0)>(d|0)){y=0;z=s}else{h=0;A=s;while(1){do if(!(b[u+h>>0]|0)){f[w+(h<<2)>>2]=0;B=A}else{if((h|0)>0?(C=h+-1|0,b[u+C>>0]|0):0){f[w+(h<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(h<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);h=h+1|0;if((h|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(h=y+-1|0,b[u+h>>0]|0):0){f[w+(y<<2)>>2]=f[w+(h<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}h=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(h|0))H=A;else{G=h;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=h;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=h;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=s;while(0);w=a+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=w;s=D;t=f[j>>2]|0;k=f[g>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function Kwa(a){a=a|0;cYc(a);return}function Lwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=d;u=j;v=n;n=l;l=i;while(1){i=f[f[n+44>>2]>>2]|0;w=(f[n+16>>2]|0)+(Y(i,a)|0)|0;x=w+(0-i)|0;i=f[f[l+44>>2]>>2]|0;y=(f[l+16>>2]|0)+(Y(i,a)|0)|0;z=y+(0-i)|0;if(r){i=(a|0)>(d|0);A=i^1;B=0;C=u;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(i){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=D;U=f[e>>2]|0}else{T=u;U=v}C=a+1|0;if((C|0)==(U|0)){o=T;break}a=C;u=T;v=U;n=f[k>>2]|0;l=f[h>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function Mwa(a){a=a|0;g1c(a|0,0,192)|0;return}function Nwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0;e=u;u=u+1344|0;g=e+256|0;h=e+312|0;i=e+248|0;j=e+192|0;k=e+136|0;l=e+8|0;m=e+120|0;o=e+104|0;q=e;r=e+88|0;s=dS(c,-1)|0;t=s&7;v=s&4088;cS(i,c,-1);if((f[i>>2]|0)>=1?(w=i+4|0,(f[w>>2]|0)>=1):0){do if((eS(c)|0)==65536){x=f[c+4>>2]|0;f[j>>2]=f[x>>2];y=j+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[x+8>>2];f[j+12>>2]=f[x+12>>2];f[j+16>>2]=f[x+16>>2];f[j+20>>2]=f[x+20>>2];f[j+24>>2]=f[x+24>>2];f[j+28>>2]=f[x+28>>2];f[j+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[j+36>>2]=B;f[j+40>>2]=A;A=j+48|0;C=j+44|0;f[C>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;U$(j,x);break}}else bS(j,c,-1);while(0);if((t|1|0)==5&(k0(j,2,-1,1)|0)>-1){g1c(a|0,0,192)|0;c=k0(j,2,-1,1)|0;x=f[j>>2]|0;y=(x&7|0)==5;z=f[j+16>>2]|0;if((x&6|0)!=4){x=$Xc(64)|0;f[g>>2]=x;f[g+8>>2]=-2147483584;f[g+4>>2]=54;D=x;E=355506;F=D+54|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[x+54>>0]=0;vM(-215,g,355561,355576,101)}if(c|0){x=c+-1|0;if(y){G=+n[z+(x<<3)+4>>2];H=+n[z+(x<<3)>>2]}else{G=+(f[z+(x<<3)+4>>2]|0);H=+(f[z+(x<<3)>>2]|0)}I=H*H;J=G*G;if((c|0)>0)if(y){y=0;K=0.0;N=0.0;O=J;P=I;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=H;_=G;while(1){$=Z;Z=+n[z+(y<<3)>>2];aa=_;_=+n[z+(y<<3)+4>>2];ba=P;P=Z*Z;ca=O;O=_*_;da=$*_-aa*Z;ea=$+Z;fa=aa+_;ga=K+da;ha=ea*da;ia=N+ha;ja=fa*da;ka=Q+ja;la=R+da*(P+$*ea);ma=X+da*($*(aa+fa)+Z*(_+fa));na=W+da*(O+aa*fa);oa=V+(ba+P)*ha;ha=S+(ca+O)*ja;ja=U+da*(ba*(aa*3.0+_)+$*(Z*2.0)*fa+P*(aa+_*3.0));fa=T+da*(O*($+Z*3.0)+(ca*($*3.0+Z)+ea*(aa*(_*2.0))));y=y+1|0;if((y|0)==(c|0)){pa=ga;qa=ia;ra=ka;sa=la;ta=ha;ua=fa;va=ja;wa=oa;xa=na;ya=ma;break}else{K=ga;N=ia;Q=ka;R=la;S=ha;T=fa;U=ja;V=oa;W=na;X=ma}}}else{y=0;X=0.0;W=0.0;V=J;J=I;I=0.0;U=0.0;T=0.0;S=0.0;R=0.0;Q=0.0;N=0.0;K=0.0;_=H;H=G;while(1){G=_;_=+(f[z+(y<<3)>>2]|0);Z=H;H=+(f[z+(y<<3)+4>>2]|0);O=J;J=_*_;P=V;V=H*H;ma=G*H-Z*_;na=G+_;oa=Z+H;ja=X+ma;fa=na*ma;ha=W+fa;la=oa*ma;ka=I+la;ia=U+ma*(J+G*na);ga=K+ma*(G*(Z+oa)+_*(H+oa));aa=N+ma*(V+Z*oa);ea=Q+(O+J)*fa;fa=T+(P+V)*la;la=R+ma*(O*(Z*3.0+H)+G*(_*2.0)*oa+J*(Z+H*3.0));oa=S+ma*(V*(G+_*3.0)+(P*(G*3.0+_)+na*(Z*(H*2.0))));y=y+1|0;if((y|0)==(c|0)){pa=ja;qa=ha;ra=ka;sa=ia;ta=fa;ua=oa;va=la;wa=ea;xa=aa;ya=ga;break}else{X=ja;W=ha;I=ka;U=ia;T=fa;S=oa;R=la;Q=ea;N=aa;K=ga}}}else{pa=0.0;qa=0.0;ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0}if(+L(+pa)>1.1920928955078125e-07){c=pa>0.0;K=c?.16666666666666666:-.16666666666666666;N=c?.08333333333333333:-.08333333333333333;Q=c?.05:-.05;R=c?.016666666666666666:-.016666666666666666;S=pa*(c?.5:-.5);p[a>>3]=S;pa=qa*K;p[a+8>>3]=pa;qa=ra*K;p[a+16>>3]=qa;K=sa*N;p[a+24>>3]=K;sa=ya*(c?.041666666666666664:-.041666666666666664);p[a+32>>3]=sa;ya=xa*N;p[a+40>>3]=ya;N=wa*Q;p[a+48>>3]=N;wa=va*R;p[a+56>>3]=wa;va=ua*R;p[a+64>>3]=va;R=ta*Q;p[a+72>>3]=R;c=+L(+S)>2.220446049250313e-16;Q=1.0/S;S=c?Q:0.0;ta=c?qa*Q:0.0;ua=c?pa*Q:0.0;Q=pa*ua;xa=K-Q;K=pa*ta;pa=sa-K;sa=qa*ta;ra=ya-sa;p[a+80>>3]=xa;p[a+88>>3]=pa;p[a+96>>3]=ra;ya=N-ua*(Q+xa*3.0);p[a+104>>3]=ya;Q=pa+pa;N=wa-ua*(qa*ua+Q)-ta*xa;p[a+112>>3]=N;qa=va-ta*(K+Q)-ua*ra;p[a+120>>3]=qa;ua=R-ta*(sa+ra*3.0);p[a+128>>3]=ua;sa=S*S;ta=sa*+M(+(+L(+S)));p[a+136>>3]=sa*xa;p[a+144>>3]=sa*pa;p[a+152>>3]=sa*ra;p[a+160>>3]=ya*ta;p[a+168>>3]=N*ta;p[a+176>>3]=qa*ta;p[a+184>>3]=ua*ta}}}else{if(v|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=$Xc(48)|0;f[g>>2]=v;f[g+8>>2]=-2147483600;f[g+4>>2]=43;D=v;E=355648;F=D+43|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[v+43>>0]=0;vM(-5,g,355692,355576,681)}a:do if((t|0)==0|d)za=1281;else switch(s&7){case 2:{za=1282;break a;break}case 3:{za=1283;break a;break}case 5:{za=1284;break a;break}case 6:{za=1285;break a;break}default:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;vM(-210,g,355692,355576,696)}}while(0);f[g>>2]=f[j>>2];s=g+4|0;t=j+4|0;v=f[t>>2]|0;f[s>>2]=v;E=g+8|0;f[E>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];D=g+16|0;f[D>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];F=g+36|0;c=f[j+36>>2]|0;f[F>>2]=c;y=g+40|0;f[y>>2]=E;E=g+48|0;z=g+44|0;f[z>>2]=E;f[E>>2]=0;f[g+52>>2]=0;if(!c)Aa=v;else{v=c+12|0;f[v>>2]=(f[v>>2]|0)+1;Aa=f[t>>2]|0}if((Aa|0)<3){Aa=f[j+44>>2]|0;t=f[z>>2]|0;f[t>>2]=f[Aa>>2];f[t+4>>2]=f[Aa+4>>2]}else{f[s>>2]=0;U$(g,j)}Aa=f[w>>2]|0;if((Aa|0)>0){t=l+4|0;v=l+8|0;c=l+12|0;x=l+4|0;A=l+8|0;C=l+12|0;B=l+16|0;Ba=l+20|0;Ca=l+24|0;Da=l+28|0;Ea=l+40|0;Fa=l+48|0;Ga=l+44|0;Ha=l+52|0;Ia=m+8|0;Ja=m+12|0;Ka=m+4|0;La=o+8|0;Ma=o+12|0;Na=o+4|0;Oa=r+8|0;Pa=r+4|0;Qa=l+36|0;Ra=k+36|0;Sa=k+16|0;Ta=k+4|0;Ua=k+40|0;Va=k+8|0;Wa=k+12|0;Xa=k+44|0;Ya=k+20|0;Za=k+24|0;_a=k+28|0;$a=l+32|0;ab=k+32|0;bb=l+8|0;cb=l+16|0;db=l+24|0;eb=l+32|0;fb=l+40|0;gb=l+48|0;hb=l+56|0;ib=l+64|0;jb=l+72|0;kb=k+48|0;lb=Ca+8|0;mb=0;ta=0.0;ua=0.0;qa=0.0;N=0.0;ya=0.0;ra=0.0;sa=0.0;pa=0.0;xa=0.0;S=0.0;nb=Aa;Aa=f[i>>2]|0;while(1){ob=nb-mb|0;pb=(ob|0)<32?ob:32;if((Aa|0)>0){R=+(mb|0);ob=0;Q=ta;K=ua;va=qa;wa=N;T=ya;U=ra;I=sa;W=pa;X=xa;H=S;qb=Aa;do{rb=qb-ob|0;sb=(rb|0)<32?rb:32;f[l>>2]=ob;f[t>>2]=mb;f[v>>2]=sb;f[c>>2]=pb;Z$(k,g,l);if(d){f[l>>2]=1124007936;f[x>>2]=2;f[A>>2]=pb;f[C>>2]=sb;f[B>>2]=h;f[Ba>>2]=h;rb=lb;f[rb>>2]=0;f[rb+4>>2]=0;f[Ea>>2]=A;f[Ga>>2]=Fa;rb=Y(sb,pb)|0;f[Fa>>2]=sb;f[Ha>>2]=1;tb=h+rb|0;f[Da>>2]=tb;f[Ca>>2]=tb+(0-sb)+sb;R$(l);f[Ia>>2]=0;f[Ja>>2]=0;f[m>>2]=16842752;f[Ka>>2]=k;p[q>>3]=0.0;f[o>>2]=-1056833530;f[Na>>2]=q;f[La>>2]=1;f[Ma>>2]=1;sb=Oa;f[sb>>2]=0;f[sb+4>>2]=0;f[r>>2]=33619968;f[Pa>>2]=l;M1(m,o,r,5);sb=f[Qa>>2]|0;if(sb|0){tb=sb+12|0;f[tb>>2]=(f[tb>>2]|0)+1}tb=f[Ra>>2]|0;do if(tb|0){sb=tb+12|0;rb=f[sb>>2]|0;f[sb>>2]=rb+-1;if((rb|0)!=1)break;V$(k)}while(0);f[Ra>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[Ta>>2]|0)>0){tb=f[Ua>>2]|0;rb=0;do{f[tb+(rb<<2)>>2]=0;rb=rb+1|0;ub=f[Ta>>2]|0}while((rb|0)<(ub|0));f[k>>2]=f[l>>2];if((ub|0)<3)vb=63;else vb=65}else{f[k>>2]=f[l>>2];vb=63}do if((vb|0)==63){vb=0;rb=f[x>>2]|0;if((rb|0)>=3){vb=65;break}f[Ta>>2]=rb;f[Va>>2]=f[A>>2];f[Wa>>2]=f[C>>2];rb=f[Ga>>2]|0;tb=f[Xa>>2]|0;f[tb>>2]=f[rb>>2];f[tb+4>>2]=f[rb+4>>2]}while(0);if((vb|0)==65){vb=0;U$(k,l)}f[Sa>>2]=f[B>>2];f[Ya>>2]=f[Ba>>2];f[Za>>2]=f[Ca>>2];f[_a>>2]=f[Da>>2];f[ab>>2]=f[$a>>2];rb=f[Qa>>2]|0;f[Ra>>2]=rb;do if(rb|0){tb=rb+12|0;sb=f[tb>>2]|0;f[tb>>2]=sb+-1;if((sb|0)!=1)break;V$(l)}while(0);f[Qa>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[x>>2]|0)>0){rb=f[Ea>>2]|0;sb=0;do{f[rb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[x>>2]|0))}sb=f[Ga>>2]|0;if((sb|0)!=(Fa|0))wL(sb)}mi[za&2047](k,l);_=+p[l>>3];if(d){V=_*.00392156862745098;p[l>>3]=V;J=+p[bb>>3]*.00392156862745098;p[bb>>3]=J;ga=+p[cb>>3]*.00392156862745098;p[cb>>3]=ga;aa=+p[db>>3]*.00392156862745098;p[db>>3]=aa;ea=+p[eb>>3]*.00392156862745098;p[eb>>3]=ea;la=+p[fb>>3]*.00392156862745098;p[fb>>3]=la;oa=+p[gb>>3]*.00392156862745098;p[gb>>3]=oa;fa=+p[hb>>3]*.00392156862745098;p[hb>>3]=fa;ia=+p[ib>>3]*.00392156862745098;p[ib>>3]=ia;ka=+p[jb>>3]*.00392156862745098;p[jb>>3]=ka;wb=V;xb=J;yb=ga;zb=aa;Ab=ea;Bb=la;Cb=oa;Db=fa;Eb=ia;Fb=ka}else{wb=_;xb=+p[bb>>3];yb=+p[cb>>3];zb=+p[db>>3];Ab=+p[eb>>3];Bb=+p[fb>>3];Cb=+p[gb>>3];Db=+p[hb>>3];Eb=+p[ib>>3];Fb=+p[jb>>3]}_=+(ob|0);ka=_*wb;ia=R*wb;Q=Q+wb;fa=xb+ka;H=H+fa;oa=ia+yb;K=K+oa;va=va+(zb+_*(ka+xb*2.0));la=_*oa;oa=R*xb;wa=wa+(oa+(Ab+la));T=T+(Bb+R*(ia+yb*2.0));U=U+(Cb+_*(zb*3.0+_*(ka+xb*3.0)));I=I+(R*zb+(Db+_*(la+(oa+Ab)*2.0)));W=W+(_*Bb+(Eb+R*(R*fa+(_*yb+Ab)*2.0)));X=X+(R*(R*(ia+yb*3.0)+Bb*3.0)+Fb);sb=f[Ra>>2]|0;do if(sb|0){rb=sb+12|0;tb=f[rb>>2]|0;f[rb>>2]=tb+-1;if((tb|0)!=1)break;V$(k)}while(0);f[Ra>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[Ta>>2]|0)>0){sb=f[Ua>>2]|0;tb=0;do{f[sb+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[Ta>>2]|0))}tb=f[Xa>>2]|0;if((tb|0)!=(kb|0))wL(tb);ob=ob+32|0;qb=f[i>>2]|0}while((qb|0)>(ob|0));Gb=Q;Hb=K;Ib=va;Jb=wa;Kb=T;Lb=U;Mb=I;Nb=W;Ob=X;Pb=H;Qb=f[w>>2]|0;Rb=qb}else{Gb=ta;Hb=ua;Ib=qa;Jb=N;Kb=ya;Lb=ra;Mb=sa;Nb=pa;Ob=xa;Pb=S;Qb=nb;Rb=Aa}mb=mb+32|0;if((Qb|0)<=(mb|0)){Sb=Gb;Tb=Hb;Ub=Ib;Vb=Jb;Wb=Kb;Xb=Lb;Yb=Mb;Zb=Nb;_b=Ob;$b=Pb;break}else{ta=Gb;ua=Hb;qa=Ib;N=Jb;ya=Kb;ra=Lb;sa=Mb;pa=Nb;xa=Ob;S=Pb;nb=Qb;Aa=Rb}}}else{Sb=0.0;Tb=0.0;Ub=0.0;Vb=0.0;Wb=0.0;Xb=0.0;Yb=0.0;Zb=0.0;_b=0.0;$b=0.0}Rb=+L(+Sb)>2.220446049250313e-16;Pb=1.0/Sb;S=Rb?Pb:0.0;Ob=Rb?Tb*Pb:0.0;xa=Rb?$b*Pb:0.0;Pb=$b*xa;Nb=Ub-Pb;pa=$b*Ob;Mb=Vb-pa;sa=Tb*Ob;Lb=Wb-sa;ra=Xb-xa*(Pb+Nb*3.0);Pb=Mb+Mb;Kb=Yb-xa*(Tb*xa+Pb)-Ob*Nb;ya=Zb-Ob*(pa+Pb)-xa*Lb;xa=_b-Ob*(sa+Lb*3.0);sa=S*S;Ob=+M(+(+L(+S)))*sa;p[a>>3]=Sb;p[a+8>>3]=$b;p[a+16>>3]=Tb;p[a+24>>3]=Ub;p[a+32>>3]=Vb;p[a+40>>3]=Wb;p[a+48>>3]=Xb;p[a+56>>3]=Yb;p[a+64>>3]=Zb;p[a+72>>3]=_b;p[a+80>>3]=Nb;p[a+88>>3]=Mb;p[a+96>>3]=Lb;p[a+104>>3]=ra;p[a+112>>3]=Kb;p[a+120>>3]=ya;p[a+128>>3]=xa;p[a+136>>3]=sa*Nb;p[a+144>>3]=sa*Mb;p[a+152>>3]=sa*Lb;p[a+160>>3]=Ob*ra;p[a+168>>3]=Ob*Kb;p[a+176>>3]=Ob*ya;p[a+184>>3]=Ob*xa;Rb=f[F>>2]|0;if(Rb|0?(Aa=Rb+12|0,Rb=f[Aa>>2]|0,f[Aa>>2]=Rb+-1,(Rb|0)==1):0)V$(g);f[F>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[s>>2]|0)>0){D=f[y>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[s>>2]|0))}s=f[z>>2]|0;if((s|0)!=(E|0))wL(s)}s=j+36|0;E=f[s>>2]|0;if(E|0?(z=E+12|0,E=f[z>>2]|0,f[z>>2]=E+-1,(E|0)==1):0)V$(j);f[s>>2]=0;s=j+16|0;E=j+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[E>>2]|0)>0){s=f[j+40>>2]|0;z=0;do{f[s+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[E>>2]|0))}E=f[j+44>>2]|0;if((E|0)!=(j+48|0))wL(E);u=e;return}g1c(a|0,0,192)|0;u=e;return}function Owa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;e=f[c+4>>2]|0;g=f[c>>2]|0;if((g|0)>0?(c=f[a+16>>2]|0,h=f[f[a+44>>2]>>2]|0,(e|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(h,a)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=d[D+(H<<1)>>1]|0;M=Y(L,H)|0;G=L+G|0;F=M+F|0;L=Y(M,H)|0;E=L+E|0;M=Y(L,H)|0;I=d1c(M|0,((M|0)<0)<<31>>31|0,I|0,K|0)|0;K=J;H=H+1|0}while((H|0)!=(e|0));H=Y(G,a)|0;D=Y(a,a)|0;M=((H|0)<0)<<31>>31;L=x1c(H|0,M|0,D|0,0)|0;z=d1c(z|0,A|0,L|0,J|0)|0;A=J;L=((F|0)<0)<<31>>31;N=x1c(F|0,L|0,D|0,0)|0;B=d1c(B|0,C|0,N|0,J|0)|0;C=J;N=((E|0)<0)<<31>>31;O=x1c(E|0,N|0,a|0,((a|0)<0)<<31>>31|0)|0;i=d1c(i|0,j|0,O|0,J|0)|0;j=J;k=d1c(k|0,l|0,I|0,K|0)|0;l=J;O=Y(G,D)|0;m=d1c(m|0,n|0,O|0,((O|0)<0)<<31>>31|0)|0;n=J;O=Y(F,a)|0;o=d1c(o|0,q|0,O|0,((O|0)<0)<<31>>31|0)|0;q=J;r=d1c(r|0,s|0,E|0,N|0)|0;s=J;t=d1c(t|0,u|0,H|0,M|0)|0;u=J;v=d1c(v|0,w|0,F|0,L|0)|0;w=J;x=d1c(x|0,y|0,G|0,((G|0)<0)<<31>>31|0)|0;y=J;a=a+1|0}while((a|0)!=(g|0));P=+(x>>>0)+4294967296.0*+(y|0);Q=+(v>>>0)+4294967296.0*+(w|0);R=+(t>>>0)+4294967296.0*+(u|0);S=+(r>>>0)+4294967296.0*+(s|0);T=+(o>>>0)+4294967296.0*+(q|0);U=+(m>>>0)+4294967296.0*+(n|0);V=+(k>>>0)+4294967296.0*+(l|0);W=+(i>>>0)+4294967296.0*+(j|0);X=+(B>>>0)+4294967296.0*+(C|0);Z=+(z>>>0)+4294967296.0*+(A|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function Pwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;o=d+56|0;q=d+48|0;r=d+40|0;s=d+32|0;t=d+24|0;v=d+16|0;w=d+8|0;if((g|0)>0){x=0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;while(1){I=k+(Y(l,x)|0)|0;J=0.0;K=0.0;L=0.0;M=0.0;N=0;do{O=+n[I+(N<<2)>>2];P=+(N|0);Q=P*O;M=M+O;L=L+Q;O=P*Q;K=K+O;J=J+P*O;N=N+1|0}while((N|0)!=(g|0));O=+(x|0);P=O*M;Q=+(Y(x,x)|0);R=Q*P+y;S=Q*L+z;T=O*K+A;U=J+B;V=Q*M+C;Q=O*L+D;O=K+E;W=P+F;P=L+G;X=M+H;x=x+1|0;if((x|0)==(h|0)){Z=R;_=S;$=T;aa=U;ba=V;ca=Q;da=O;ea=W;fa=P;ga=X;break}else{y=R;z=S;A=T;B=U;C=V;D=Q;E=O;F=W;G=P;H=X}}}else{x=0;H=0.0;G=0.0;F=0.0;E=0.0;D=0.0;C=0.0;while(1){B=+(x|0)*0.0;A=+(Y(x,x)|0);z=A*B+H;y=A*0.0;A=y+G;X=B+F;P=y+E;y=B+D;W=B+C;x=x+1|0;if((x|0)==(h|0)){Z=z;_=A;$=X;aa=0.0;ba=P;ca=y;da=0.0;ea=W;fa=0.0;ga=0.0;break}else{H=z;G=A;F=X;E=P;D=y;C=W}}}p[a>>3]=Z;p[m>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[w>>3]=fa;p[d>>3]=ga;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function Qwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;n=d+56|0;o=d+48|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;v=d+8|0;if((g|0)>0){w=0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;while(1){H=k+(Y(l,w)|0)|0;I=0.0;J=0.0;K=0.0;L=0.0;M=0;do{N=+p[H+(M<<3)>>3];O=+(M|0);P=O*N;L=L+N;K=K+P;N=O*P;J=J+N;I=I+O*N;M=M+1|0}while((M|0)!=(g|0));N=+(w|0);O=N*L;P=+(Y(w,w)|0);Q=P*O+x;R=P*K+y;S=N*J+z;T=I+A;U=P*L+B;P=N*K+C;N=J+D;V=O+E;O=K+F;W=L+G;w=w+1|0;if((w|0)==(h|0)){X=Q;Z=R;_=S;$=T;aa=U;ba=P;ca=N;da=V;ea=O;fa=W;break}else{x=Q;y=R;z=S;A=T;B=U;C=P;D=N;E=V;F=O;G=W}}}else{w=0;G=0.0;F=0.0;E=0.0;D=0.0;C=0.0;B=0.0;while(1){A=+(w|0)*0.0;z=+(Y(w,w)|0);y=z*A+G;x=z*0.0;z=x+F;W=A+E;O=x+D;x=A+C;V=A+B;w=w+1|0;if((w|0)==(h|0)){X=y;Z=z;_=W;$=0.0;aa=O;ba=x;ca=0.0;da=V;ea=0.0;fa=0.0;break}else{G=y;F=z;E=W;D=O;C=x;B=V}}}p[a>>3]=X;p[m>>3]=Z;p[n>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[d>>3]=fa;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function Rwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;do{t=c+(Y(g,a)|0)|0;u=0;v=0;w=0;x=0;y=0;do{z=h[t+y>>0]|0;A=Y(z,y)|0;x=z+x|0;w=A+w|0;z=Y(A,y)|0;v=z+v|0;u=(Y(z,y)|0)+u|0;y=y+1|0}while((y|0)!=(d|0));y=Y(x,a)|0;t=Y(a,a)|0;i=i+(Y(y,t)|0)|0;j=j+(Y(w,t)|0)|0;k=k+(Y(v,a)|0)|0;l=l+u|0;m=m+(Y(x,t)|0)|0;n=n+(Y(w,a)|0)|0;o=o+v|0;q=q+y|0;r=r+w|0;s=s+x|0;a=a+1|0}while((a|0)!=(e|0));B=+(s|0);C=+(r|0);D=+(q|0);E=+(o|0);F=+(n|0);G=+(m|0);H=+(l|0);I=+(k|0);J=+(j|0);K=+(i|0)}else{B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0}p[b>>3]=B;p[b+8>>3]=C;p[b+16>>3]=D;p[b+24>>3]=E;p[b+32>>3]=F;p[b+40>>3]=G;p[b+48>>3]=H;p[b+56>>3]=I;p[b+64>>3]=J;p[b+72>>3]=K;return}function Swa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;h=0;i=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(g,a)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=j[D+(H<<1)>>1]|0;M=Y(L,H)|0;G=L+G|0;F=M+F|0;L=Y(M,H)|0;E=L+E|0;M=Y(L,H)|0;I=d1c(M|0,((M|0)<0)<<31>>31|0,I|0,K|0)|0;K=J;H=H+1|0}while((H|0)!=(d|0));H=Y(G,a)|0;D=Y(a,a)|0;M=((H|0)<0)<<31>>31;L=x1c(H|0,M|0,D|0,0)|0;z=d1c(z|0,A|0,L|0,J|0)|0;A=J;L=((F|0)<0)<<31>>31;N=x1c(F|0,L|0,D|0,0)|0;B=d1c(B|0,C|0,N|0,J|0)|0;C=J;N=((E|0)<0)<<31>>31;O=x1c(E|0,N|0,a|0,((a|0)<0)<<31>>31|0)|0;h=d1c(h|0,i|0,O|0,J|0)|0;i=J;k=d1c(k|0,l|0,I|0,K|0)|0;l=J;O=Y(G,D)|0;m=d1c(m|0,n|0,O|0,((O|0)<0)<<31>>31|0)|0;n=J;O=Y(F,a)|0;o=d1c(o|0,q|0,O|0,((O|0)<0)<<31>>31|0)|0;q=J;r=d1c(r|0,s|0,E|0,N|0)|0;s=J;t=d1c(t|0,u|0,H|0,M|0)|0;u=J;v=d1c(v|0,w|0,F|0,L|0)|0;w=J;x=d1c(x|0,y|0,G|0,((G|0)<0)<<31>>31|0)|0;y=J;a=a+1|0}while((a|0)!=(e|0));P=+(x>>>0)+4294967296.0*+(y|0);Q=+(v>>>0)+4294967296.0*+(w|0);R=+(t>>>0)+4294967296.0*+(u|0);S=+(r>>>0)+4294967296.0*+(s|0);T=+(o>>>0)+4294967296.0*+(q|0);U=+(m>>>0)+4294967296.0*+(n|0);V=+(k>>>0)+4294967296.0*+(l|0);W=+(h>>>0)+4294967296.0*+(i|0);X=+(B>>>0)+4294967296.0*+(C|0);Z=+(z>>>0)+4294967296.0*+(A|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function Twa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0,h=0.0,i=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;c=a+160|0;d=a+176|0;e=+p[c>>3]+ +p[d>>3];f=a+168|0;g=a+184|0;h=+p[f>>3]+ +p[g>>3];i=e*e;j=h*h;k=a+144|0;l=+p[k>>3]*4.0;m=+p[a+136>>3];n=+p[a+152>>3];o=m-n;p[b>>3]=m+n;p[b+8>>3]=o*o+l*+p[k>>3];p[b+24>>3]=i+j;p[b+40>>3]=h*(e*l)+(i-j)*o;o=e*(i-j*3.0);e=h*(i*3.0-j);j=+p[c>>3]-+p[d>>3]*3.0;i=+p[f>>3]*3.0-+p[g>>3];p[b+16>>3]=j*j+i*i;p[b+32>>3]=o*j+e*i;p[b+48>>3]=o*i-e*j;return}function Uwa(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+48|0;m=l+40|0;n=l+12|0;o=l;p=k?2:0;switch(h|0){case 0:{Vwa(o,i,j,p);f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=75460;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=o;h3(m,n,+(Y(g,e)|0)*.0000152587890625);u=l;return}case 2:{Wwa(o,i,j,p);f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=75480;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=o;h3(m,n,+(Y(g,e)|0)*.0000152587890625);u=l;return}default:{Xwa(o,i,j,p);f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=75500;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=o;h3(m,n,+(Y(g,e)|0)*.0000152587890625);u=l;return}}}function Vwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;if((c+-3|0)>>>0>=2){c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=24;i=c;j=355745;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[c+24>>0]=0;vM(-215,h,355770,355778,70)}if((d+-3|0)>>>0<2){u=g;return}else{g=$Xc(32)|0;f[h>>2]=g;f[h+8>>2]=-2147483616;f[h+4>>2]=24;i=g;j=355852;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[g+24>>0]=0;vM(-215,h,355770,355778,71)}}function Wwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;if((c+-3|0)>>>0>=2){c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=24;i=c;j=355745;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[c+24>>0]=0;vM(-215,h,355770,355778,70)}if((d+-3|0)>>>0<2){u=g;return}else{g=$Xc(32)|0;f[h>>2]=g;f[h+8>>2]=-2147483616;f[h+4>>2]=24;i=g;j=355852;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[g+24>>0]=0;vM(-215,h,355770,355778,71)}}function Xwa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;if((c+-3|0)>>>0>=2){c=$Xc(32)|0;f[h>>2]=c;f[h+8>>2]=-2147483616;f[h+4>>2]=24;i=c;j=355745;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[c+24>>0]=0;vM(-215,h,355770,355778,70)}if((d+-3|0)>>>0<2){u=g;return}else{g=$Xc(32)|0;f[h>>2]=g;f[h+8>>2]=-2147483616;f[h+4>>2]=24;i=g;j=355852;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[g+24>>0]=0;vM(-215,h,355770,355778,71)}}function Ywa(a){a=a|0;cYc(a);return}function Zwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;if((h|0)<=0){i=c;do i=i+1|0;while((i|0)<(d|0));return}i=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=i;i=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c>>2]|0;l=f[c+4>>2]|0;m=f[c+8>>2]|0;c=m^2;if((l|0)==4)if((k|0)==4){o=j;p=0;q=i;while(1){r=f[q+4>>2]|0;s=f[q+8>>2]|0;f[o+(m<<2)>>2]=f[q>>2];f[o+4>>2]=r;f[o+(c<<2)>>2]=s;f[o+12>>2]=f[q+12>>2];p=p+1|0;if((p|0)==(h|0))break;else{o=o+16|0;q=q+16|0}}}else{q=j;o=0;p=i;while(1){s=f[p+4>>2]|0;r=f[p+8>>2]|0;f[q+(m<<2)>>2]=f[p>>2];f[q+4>>2]=s;f[q+(c<<2)>>2]=r;n[q+12>>2]=1.0;o=o+1|0;if((o|0)==(h|0))break;else{q=q+16|0;p=p+(k<<2)|0}}}else{p=j;q=0;o=i;while(1){r=f[o+4>>2]|0;s=f[o+8>>2]|0;f[p+(m<<2)>>2]=f[o>>2];f[p+4>>2]=r;f[p+(c<<2)>>2]=s;q=q+1|0;if((q|0)==(h|0))break;else{p=p+(l<<2)|0;o=o+(k<<2)|0}}}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;i=i+b|0}}return}function _wa(a){a=a|0;cYc(a);return}function $wa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+8>>2]|0;g=f[a+16>>2]|0;h=a+24|0;i=f[a+20>>2]|0;if((i|0)<=0){j=c;do j=j+1|0;while((j|0)<(e|0));return}j=(f[a+12>>2]|0)+(Y(g,c)|0)|0;k=j;j=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[h>>2]|0;l=f[c>>2]|0;m=f[c+4>>2]|0;n=f[c+8>>2]|0;c=n^2;if((m|0)==4)if((l|0)==4){o=k;p=0;q=j;while(1){r=d[q+2>>1]|0;s=d[q+4>>1]|0;d[o+(n<<1)>>1]=d[q>>1]|0;d[o+2>>1]=r;d[o+(c<<1)>>1]=s;d[o+6>>1]=d[q+6>>1]|0;p=p+1|0;if((p|0)==(i|0))break;else{o=o+8|0;q=q+8|0}}}else{q=k;o=0;p=j;while(1){s=d[p+2>>1]|0;r=d[p+4>>1]|0;d[q+(n<<1)>>1]=d[p>>1]|0;d[q+2>>1]=s;d[q+(c<<1)>>1]=r;d[q+6>>1]=-1;o=o+1|0;if((o|0)==(i|0))break;else{q=q+8|0;p=p+(l<<1)|0}}}else{p=k;q=0;o=j;while(1){r=d[o+2>>1]|0;s=d[o+4>>1]|0;d[p+(n<<1)>>1]=d[o>>1]|0;d[p+2>>1]=r;d[p+(c<<1)>>1]=s;q=q+1|0;if((q|0)==(i|0))break;else{p=p+(m<<1)|0;o=o+(l<<1)|0}}}a=a+1|0;if((a|0)>=(e|0))break;else{k=k+g|0;j=j+b|0}}return}function axa(a){a=a|0;cYc(a);return}function bxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;h=c+4|0;if((d|0)>=(f[h>>2]|0))return;c=(f[a+12>>2]|0)+(Y(f[g>>2]|0,d)|0)|0;i=a+24|0;j=a+20|0;k=c;c=(f[a+4>>2]|0)+(Y(f[e>>2]|0,d)|0)|0;a=d;while(1){d=f[i>>2]|0;l=f[j>>2]|0;m=f[d>>2]|0;n=f[d+4>>2]|0;o=f[d+8>>2]|0;a:do if((l|0)>0){d=o^2;if((n|0)!=4){p=k;q=0;r=c;while(1){s=b[r+1>>0]|0;t=b[r+2>>0]|0;b[p+o>>0]=b[r>>0]|0;b[p+1>>0]=s;b[p+d>>0]=t;q=q+1|0;if((q|0)==(l|0))break a;else{p=p+n|0;r=r+m|0}}}if((m|0)==4){r=k;p=0;q=c;while(1){t=b[q+1>>0]|0;s=b[q+2>>0]|0;b[r+o>>0]=b[q>>0]|0;b[r+1>>0]=t;b[r+d>>0]=s;b[r+3>>0]=b[q+3>>0]|0;p=p+1|0;if((p|0)==(l|0))break;else{r=r+4|0;q=q+4|0}}}else{q=k;r=0;p=c;while(1){s=b[p+1>>0]|0;t=b[p+2>>0]|0;b[q+o>>0]=b[p>>0]|0;b[q+1>>0]=s;b[q+d>>0]=t;b[q+3>>0]=-1;r=r+1|0;if((r|0)==(l|0))break;else{q=q+4|0;p=p+m|0}}}}while(0);a=a+1|0;if((a|0)>=(f[h>>2]|0))break;else{k=k+(f[g>>2]|0)|0;c=c+(f[e>>2]|0)|0}}return}function cxa(a){a=a|0;cYc(a);return}function dxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){exa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function exa(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0;i=f[a+4>>2]|0;j=(f[a>>2]|0)==3;k=(g|0)>0;if((f[a+8>>2]|0)==6)if(j){if(!k)return;a=i^2;l=c;m=0;while(1){d[e+(m<<1)>>1]=(b[l+1>>0]&-4&255)<<3|(h[l+i>>0]|0)>>>3|(b[l+a>>0]&-8&255)<<8;m=m+1|0;if((m|0)==(g|0))break;else l=l+3|0}return}else{if(!k)return;l=i^2;m=c;a=0;while(1){d[e+(a<<1)>>1]=(b[m+1>>0]&-4&255)<<3|(h[m+i>>0]|0)>>>3|(b[m+l>>0]&-8&255)<<8;a=a+1|0;if((a|0)==(g|0))break;else m=m+4|0}return}else if(j){if(!k)return;j=i^2;m=c;a=0;while(1){d[e+(a<<1)>>1]=(b[m+1>>0]&-8&255)<<2|(h[m+i>>0]|0)>>>3|(b[m+j>>0]&-8&255)<<7;a=a+1|0;if((a|0)==(g|0))break;else m=m+3|0}return}else{if(!k)return;k=i^2;m=c;c=0;while(1){d[e+(c<<1)>>1]=(b[m+1>>0]&-8&255)<<2|(h[m+i>>0]|0)>>>3|(b[m+k>>0]&-8&255)<<7|(b[m+3>>0]|0?32768:0);c=c+1|0;if((c|0)==(g|0))break;else m=m+4|0}return}}function fxa(a){a=a|0;cYc(a);return}function gxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){hxa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function hxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(e|0)>0;if((f[a+8>>2]|0)==6){if(!i)return;a=h^2;if((g|0)==4){k=0;l=d;while(1){m=j[c+(k<<1)>>1]|0;b[l+h>>0]=m<<3;b[l+1>>0]=m>>>3&252;b[l+a>>0]=m>>>8&248;b[l+3>>0]=-1;k=k+1|0;if((k|0)==(e|0))break;else l=l+4|0}return}else{l=0;k=d;while(1){m=j[c+(l<<1)>>1]|0;b[k+h>>0]=m<<3;b[k+1>>0]=m>>>3&252;b[k+a>>0]=m>>>8&248;l=l+1|0;if((l|0)==(e|0))break;else k=k+g|0}return}}else{if(!i)return;i=h^2;if((g|0)==4){k=0;l=d;while(1){a=j[c+(k<<1)>>1]|0;b[l+h>>0]=a<<3;b[l+1>>0]=a>>>2&248;b[l+i>>0]=a>>>7&248;b[l+3>>0]=a<<16>>31;k=k+1|0;if((k|0)==(e|0))break;else l=l+4|0}return}else{l=0;k=d;while(1){d=j[c+(l<<1)>>1]|0;b[k+h>>0]=d<<3;b[k+1>>0]=d>>>2&248;b[k+i>>0]=d>>>7&248;l=l+1|0;if((l|0)==(e|0))break;else k=k+g|0}return}}}function ixa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=u;u=u+3120|0;l=k+3104|0;m=k+3076|0;n=k;o=j?2:0;switch(h|0){case 0:{f[n>>2]=i;h=f[75552+((o^2)<<2)>>2]|0;p=f[75552+(o<<2)>>2]|0;o=0;q=0;r=16384;s=0;while(1){f[n+4+(s<<2)>>2]=o;f[n+4+(s+256<<2)>>2]=q;f[n+4+(s+512<<2)>>2]=r;s=s+1|0;if((s|0)==256)break;else{o=o+h|0;q=q+19235|0;r=r+p|0}}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=75572;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=n;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}case 2:{f[n>>2]=i;p=n+4|0;f[p>>2]=f[18896];f[p+4>>2]=f[18897];f[p+8>>2]=f[18898];if(!j){f[p>>2]=1868;f[n+12>>2]=4899}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=75604;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=n;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}default:{f[n>>2]=i;i=n+4|0;f[i>>2]=f[18904];f[i+4>>2]=f[18905];f[i+8>>2]=f[18906];if(!j){f[i>>2]=1038710997;f[n+12>>2]=1050220167}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=75636;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=n;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}}}function jxa(a){a=a|0;cYc(a);return}function kxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;if((h|0)<=0){i=c;do i=i+1|0;while((i|0)<(d|0));return}i=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=i;i=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c>>2]|0;l=+n[c+4>>2];m=+n[c+8>>2];o=+n[c+12>>2];c=i;p=0;while(1){n[j+(p<<2)>>2]=l*+n[c>>2]+m*+n[c+4>>2]+o*+n[c+8>>2];p=p+1|0;if((p|0)==(h|0))break;else c=c+(k<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;i=i+b|0}}return}function lxa(a){a=a|0;cYc(a);return}function mxa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+16>>2]|0;g=(f[a+12>>2]|0)+(Y(b,c)|0)|0;h=f[a+8>>2]|0;i=(f[a+4>>2]|0)+(Y(h,c)|0)|0;k=a+24|0;l=f[a+20>>2]|0;a=(l|0)>0;m=g;g=i;i=c;while(1){c=f[k>>2]|0;n=f[c>>2]|0;o=f[c+4>>2]|0;p=f[c+8>>2]|0;q=f[c+12>>2]|0;if(a){c=g;r=0;while(1){s=Y(j[c>>1]|0,o)|0;t=Y(j[c+2>>1]|0,p)|0;u=(s+8192+t+(Y(j[c+4>>1]|0,q)|0)|0)>>>14&65535;d[m+(r<<1)>>1]=u;r=r+1|0;if((r|0)==(l|0))break;else c=c+(n<<1)|0}}i=i+1|0;if((i|0)>=(e|0))break;else{m=m+b|0;g=g+h|0}}return}function nxa(a){a=a|0;cYc(a);return}function oxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;i=c+4|0;c=f[i>>2]|0;if((d|0)>=(c|0))return;j=f[g>>2]|0;k=(f[a+12>>2]|0)+(Y(j,d)|0)|0;l=f[e>>2]|0;m=a+24|0;n=a+20|0;o=k;k=(f[a+4>>2]|0)+(Y(l,d)|0)|0;a=d;d=c;c=j;j=l;while(1){l=f[m>>2]|0;p=f[n>>2]|0;q=f[l>>2]|0;if((p|0)>0){r=k;s=0;while(1){b[o+s>>0]=((f[l+4+((h[r+1>>0]|0|256)<<2)>>2]|0)+(f[l+4+((h[r>>0]|0)<<2)>>2]|0)+(f[l+4+((h[r+2>>0]|0|512)<<2)>>2]|0)|0)>>>15;s=s+1|0;if((s|0)==(p|0))break;else r=r+q|0}t=f[e>>2]|0;u=f[g>>2]|0;v=f[i>>2]|0}else{t=j;u=c;v=d}a=a+1|0;if((a|0)>=(v|0))break;else{o=o+u|0;k=k+t|0;d=v;c=u;j=t}}return}function pxa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+4|0;m=j;switch(h|0){case 0:{f[m>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=75656;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=m;h3(k,l,+(Y(g,e)|0)*.0000152587890625);u=j;return}case 2:{f[m>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=75676;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=m;h3(k,l,+(Y(g,e)|0)*.0000152587890625);u=j;return}default:{f[m>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=75696;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=m;h3(k,l,+(Y(g,e)|0)*.0000152587890625);u=j;return}}}function qxa(a){a=a|0;cYc(a);return}function rxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;if((h|0)<=0){i=c;do i=i+1|0;while((i|0)<(d|0));return}i=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=i;i=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){if((f[f[g>>2]>>2]|0)==3){c=j;k=0;while(1){l=f[i+(k<<2)>>2]|0;f[c+8>>2]=l;f[c+4>>2]=l;f[c>>2]=l;k=k+1|0;if((k|0)==(h|0))break;else c=c+12|0}}else{c=0;k=j;while(1){l=f[i+(c<<2)>>2]|0;f[k+8>>2]=l;f[k+4>>2]=l;f[k>>2]=l;n[k+12>>2]=1.0;c=c+1|0;if((c|0)==(h|0))break;else k=k+16|0}}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;i=i+b|0}}return}function sxa(a){a=a|0;cYc(a);return}function txa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+8>>2]|0;g=f[a+16>>2]|0;h=a+24|0;i=f[a+20>>2]|0;if((i|0)<=0){j=c;do j=j+1|0;while((j|0)<(e|0));return}j=(f[a+12>>2]|0)+(Y(g,c)|0)|0;k=j;j=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){if((f[f[h>>2]>>2]|0)==3){c=k;l=0;while(1){m=d[j+(l<<1)>>1]|0;d[c+4>>1]=m;d[c+2>>1]=m;d[c>>1]=m;l=l+1|0;if((l|0)==(i|0))break;else c=c+6|0}}else{c=0;l=k;while(1){m=d[j+(c<<1)>>1]|0;d[l+4>>1]=m;d[l+2>>1]=m;d[l>>1]=m;d[l+6>>1]=-1;c=c+1|0;if((c|0)==(i|0))break;else l=l+8|0}}a=a+1|0;if((a|0)>=(e|0))break;else{k=k+g|0;j=j+b|0}}return}function uxa(a){a=a|0;cYc(a);return}function vxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;h=c+4|0;if((d|0)>=(f[h>>2]|0))return;c=(f[a+12>>2]|0)+(Y(f[g>>2]|0,d)|0)|0;i=a+24|0;j=a+20|0;k=c;c=(f[a+4>>2]|0)+(Y(f[e>>2]|0,d)|0)|0;a=d;while(1){d=f[j>>2]|0;l=(d|0)>0;if((f[f[i>>2]>>2]|0)==3){if(l){m=k;n=0;while(1){o=b[c+n>>0]|0;b[m+2>>0]=o;b[m+1>>0]=o;b[m>>0]=o;n=n+1|0;if((n|0)==(d|0))break;else m=m+3|0}}}else if(l){m=0;n=k;while(1){o=b[c+m>>0]|0;b[n+2>>0]=o;b[n+1>>0]=o;b[n>>0]=o;b[n+3>>0]=-1;m=m+1|0;if((m|0)==(d|0))break;else n=n+4|0}}a=a+1|0;if((a|0)>=(f[h>>2]|0))break;else{k=k+(f[g>>2]|0)|0;c=c+(f[e>>2]|0)|0}}return}function wxa(a){a=a|0;cYc(a);return}function xxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;h=c+4|0;if((d|0)>=(f[h>>2]|0))return;c=(f[a+12>>2]|0)+(Y(f[g>>2]|0,d)|0)|0;i=a+24|0;k=a+20|0;l=c;c=(f[a+4>>2]|0)+(Y(f[e>>2]|0,d)|0)|0;a=d;while(1){d=f[k>>2]|0;m=(d|0)>0;if((f[f[i>>2]>>2]|0)==6){if(m){n=0;do{o=j[c+(n<<1)>>1]|0;b[l+n>>0]=(((o>>>3&252)*9617|0)+8192+((o<<3&248)*1868|0)+((o>>>8&248)*4899|0)|0)>>>14;n=n+1|0}while((n|0)!=(d|0))}}else if(m){n=0;do{o=j[c+(n<<1)>>1]|0;b[l+n>>0]=(((o>>>2&248)*9617|0)+8192+((o<<3&248)*1868|0)+((o>>>7&248)*4899|0)|0)>>>14;n=n+1|0}while((n|0)!=(d|0))}a=a+1|0;if((a|0)>=(f[h>>2]|0))break;else{l=l+(f[g>>2]|0)|0;c=c+(f[e>>2]|0)|0}}return}function yxa(a){a=a|0;cYc(a);return}function zxa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[b>>2]|0;e=f[b+4>>2]|0;if((c|0)>=(e|0))return;b=f[a+16>>2]|0;g=(f[a+12>>2]|0)+(Y(b,c)|0)|0;i=f[a+8>>2]|0;j=(f[a+4>>2]|0)+(Y(i,c)|0)|0;k=a+24|0;l=f[a+20>>2]|0;a=(l|0)>0;m=g;g=j;j=c;while(1){if((f[f[k>>2]>>2]|0)==6){if(a){c=0;do{n=h[g+c>>0]|0;d[m+(c<<1)>>1]=n<<3&2016|n>>>3|n<<8&63488;c=c+1|0}while((c|0)!=(l|0))}}else if(a){c=0;do{n=(h[g+c>>0]|0)>>>3;d[m+(c<<1)>>1]=n<<5|n|n<<10;c=c+1|0}while((c|0)!=(l|0))}j=j+1|0;if((j|0)>=(e|0))break;else{m=m+b|0;g=g+i|0}}return}function Axa(a){a=a|0;cYc(a);return}function Bxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;i=c+4|0;c=f[i>>2]|0;if((d|0)>=(c|0))return;j=f[g>>2]|0;k=(f[a+12>>2]|0)+(Y(j,d)|0)|0;l=f[e>>2]|0;m=a+20|0;n=k;k=(f[a+4>>2]|0)+(Y(l,d)|0)|0;a=d;d=c;c=j;j=l;while(1){l=f[m>>2]|0;if((l|0)>0){o=n;p=0;q=k;while(1){r=b[q+1>>0]|0;s=b[q+2>>0]|0;t=b[q+3>>0]|0;u=t&255;v=((((Y(u,h[q>>0]|0)|0)+128|0)>>>0)/255|0)&255;b[o>>0]=v;v=((((Y(u,r&255)|0)+128|0)>>>0)/255|0)&255;b[o+1>>0]=v;v=((((Y(u,s&255)|0)+128|0)>>>0)/255|0)&255;b[o+2>>0]=v;b[o+3>>0]=t;p=p+1|0;if((p|0)==(l|0))break;else{o=o+4|0;q=q+4|0}}w=f[e>>2]|0;x=f[g>>2]|0;y=f[i>>2]|0}else{w=j;x=c;y=d}a=a+1|0;if((a|0)>=(y|0))break;else{n=n+x|0;k=k+w|0;d=y;c=x;j=w}}return}function Cxa(a){a=a|0;cYc(a);return}function Dxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[c>>2]|0;e=a+8|0;g=a+16|0;i=c+4|0;c=f[i>>2]|0;if((d|0)>=(c|0))return;j=f[g>>2]|0;k=(f[a+12>>2]|0)+(Y(j,d)|0)|0;l=f[e>>2]|0;m=a+20|0;n=k;k=(f[a+4>>2]|0)+(Y(l,d)|0)|0;a=d;d=c;c=j;j=l;while(1){l=f[m>>2]|0;if((l|0)>0){o=n;p=0;q=k;while(1){r=b[q+3>>0]|0;s=r&255;if(!(r<<24>>24)){b[o>>0]=0;t=0;u=0}else{v=b[q+2>>0]|0;w=b[q+1>>0]|0;x=(r&255)>>>1&255;b[o>>0]=((((h[q>>0]|0)*255|0)+x|0)>>>0)/(s>>>0)|0;t=(((((w&255)*255|0)+x|0)>>>0)/(s>>>0)|0)&255;u=((((v&255)*255|0)+x|0)>>>0)/(s>>>0)|0}b[o+1>>0]=t;b[o+2>>0]=u;b[o+3>>0]=r;p=p+1|0;if((p|0)==(l|0))break;else{o=o+4|0;q=q+4|0}}y=f[e>>2]|0;z=f[g>>2]|0;A=f[i>>2]|0}else{y=j;z=c;A=d}a=a+1|0;if((a|0)>=(A|0))break;else{n=n+z|0;k=k+y|0;d=A;c=z;j=y}}return}function Exa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;Fxa(g,a,b,c);Uwa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,d);Gxa(g);u=e;return}function Fxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=x>>>3;z=(y&511)+1|0;f[a+116>>2]=z;A=x&7;B=a+112|0;f[B>>2]=A;if((y&510|0)!=2)sV(z,75788);if((e+-3|0)>>>0>=2)sV(e,75816);switch(x&7){case 0:case 2:case 5:break;default:pV(A,75844)}A=c+4|0;x=d+4|0;if((f[A>>2]|0)!=(f[x>>2]|0)){do if((eS(c)|0)==65536){z=f[A>>2]|0;f[h>>2]=f[z>>2];y=h+4|0;C=z+4|0;f[y>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];E=f[z+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[z+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[y>>2]=0;U$(h,z);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){A=h+36|0;z=f[A>>2]|0;if((z|0)!=0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0){V$(h);G=A}else G=A}else{A=a+36|0;z=f[A>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)V$(a);f[A>>2]=0;z=a+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[l>>2]|0;C=0;do{f[y+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];C=h+4|0;y=f[C>>2]|0;f[j>>2]=y;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[z>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];z=h+36|0;f[A>>2]=f[z>>2];A=a+44|0;D=f[A>>2]|0;if((D|0)==(o|0))H=y;else{wL(D);f[A>>2]=o;f[l>>2]=k;H=f[C>>2]|0}k=h+44|0;if((H|0)<3){H=f[k>>2]|0;f[o>>2]=f[H>>2];f[a+52>>2]=f[H+4>>2]}else{f[A>>2]=f[k>>2];A=h+40|0;f[a+40>>2]=f[A>>2];f[k>>2]=h+48;f[A>>2]=j}f[h>>2]=1124007936;m=C;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));G=z}f[G>>2]=0;G=h+16|0;z=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[z>>2]|0)>0){G=f[h+40>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[z>>2]|0))}z=f[h+44>>2]|0;if((z|0)!=(h+48|0))wL(z)}else{z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;z=f[c>>2]|0;f[v>>2]=l;f[w>>2]=z;f[i>>2]=l;f[i+4>>2]=z;wS(d,i,f[B>>2]&7|(e<<3)+-8,-1,0,0);do if((eS(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];B=h+4|0;i=e+4|0;f[B>>2]=f[i>>2];z=h+8|0;f[z>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=z;z=h+48|0;w=h+44|0;f[w>>2]=z;f[z>>2]=0;f[h+52>>2]=0;if(l|0){z=l+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;z=f[w>>2]|0;f[z>>2]=f[i>>2];f[z+4>>2]=f[i+4>>2];break}else{f[B>>2]=0;U$(h,e);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;x=f[d>>2]|0;if((x|0)!=0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0){V$(h);I=d}else I=d}else{d=a+92|0;x=f[d>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)V$(p);f[d>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;B=0;do{f[e+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;B=f[p>>2]|0;f[q>>2]=B;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];x=h+36|0;f[d>>2]=f[x>>2];d=a+100|0;e=f[d>>2]|0;if((e|0)==(t|0))J=B;else{wL(e);f[d>>2]=t;f[s>>2]=r;J=f[p>>2]|0}r=h+44|0;if((J|0)<3){J=f[r>>2]|0;f[t>>2]=f[J>>2];f[a+108>>2]=f[J+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));I=x}f[I>>2]=0;I=h+16|0;x=h+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[x>>2]|0)>0){I=f[h+40>>2]|0;m=0;do{f[I+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)==(h+48|0)){u=g;return}wL(x);u=g;return}function Gxa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function Hxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+176|0;g=e+168|0;h=e+140|0;i=e+128|0;j=e;Ixa(j,a,b,2);b=f[j+16>>2]|0;a=f[j+48>>2]|0;k=f[j+72>>2]|0;l=f[j+104>>2]|0;m=f[j+12>>2]|0;n=f[j+8>>2]|0;f[i>>2]=f[j+116>>2];f[i+4>>2]=c?2:0;f[i+8>>2]=d;f[g>>2]=0;f[g+4>>2]=n;f[h>>2]=75520;f[h+4>>2]=b;f[h+8>>2]=a;f[h+12>>2]=k;f[h+16>>2]=l;f[h+20>>2]=m;f[h+24>>2]=i;h3(g,h,+(Y(n,m)|0)*.0000152587890625);Jxa(j);u=e;return}function Ixa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=x>>>3;z=(y&511)+1|0;f[a+116>>2]=z;A=x&7;x=a+112|0;f[x>>2]=A;if((y&510|0)!=2)sV(z,75872);if((e|0)!=2)sV(e,75900);if(A|0)pV(A,75928);A=c+4|0;e=d+4|0;if((f[A>>2]|0)!=(f[e>>2]|0)){do if((eS(c)|0)==65536){z=f[A>>2]|0;f[h>>2]=f[z>>2];y=h+4|0;B=z+4|0;f[y>>2]=f[B>>2];C=h+8|0;f[C>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=C;C=h+48|0;E=h+44|0;f[E>>2]=C;f[C>>2]=0;f[h+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[y>>2]=0;U$(h,z);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){A=h+36|0;z=f[A>>2]|0;if((z|0)!=0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0){V$(h);F=A}else F=A}else{A=a+36|0;z=f[A>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)V$(a);f[A>>2]=0;z=a+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[l>>2]|0;B=0;do{f[y+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];B=h+4|0;y=f[B>>2]|0;f[j>>2]=y;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[z>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];z=h+36|0;f[A>>2]=f[z>>2];A=a+44|0;C=f[A>>2]|0;if((C|0)==(o|0))G=y;else{wL(C);f[A>>2]=o;f[l>>2]=k;G=f[B>>2]|0}k=h+44|0;if((G|0)<3){G=f[k>>2]|0;f[o>>2]=f[G>>2];f[a+52>>2]=f[G+4>>2]}else{f[A>>2]=f[k>>2];A=h+40|0;f[a+40>>2]=f[A>>2];f[k>>2]=h+48;f[A>>2]=j}f[h>>2]=1124007936;m=B;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));F=z}f[F>>2]=0;F=h+16|0;z=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[z>>2]|0)>0){F=f[h+40>>2]|0;B=0;do{f[F+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[h+44>>2]|0;if((z|0)!=(h+48|0))wL(z)}else{z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;z=f[c>>2]|0;f[v>>2]=l;f[w>>2]=z;f[i>>2]=l;f[i+4>>2]=z;wS(d,i,f[x>>2]&7|8,-1,0,0);do if((eS(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;z=x+4|0;f[i>>2]=f[z>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[z>>2];f[l+4>>2]=f[z+4>>2];break}else{f[i>>2]=0;U$(h,x);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;e=f[d>>2]|0;if((e|0)!=0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0){V$(h);H=d}else H=d}else{d=a+92|0;e=f[d>>2]|0;if(e|0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0)V$(p);f[d>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){x=f[s>>2]|0;i=0;do{f[x+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];e=h+36|0;f[d>>2]=f[e>>2];d=a+100|0;x=f[d>>2]|0;if((x|0)==(t|0))I=i;else{wL(x);f[d>>2]=t;f[s>>2]=r;I=f[p>>2]|0}r=h+44|0;if((I|0)<3){I=f[r>>2]|0;f[t>>2]=f[I>>2];f[a+108>>2]=f[I+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=e}f[H>>2]=0;H=h+16|0;e=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[e>>2]|0)>0){H=f[h+40>>2]|0;m=0;do{f[H+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function Jxa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function Kxa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+176|0;h=g+168|0;i=g+140|0;j=g+128|0;k=g;l=(c|0)<1?3:c;Lxa(k,a,b,l);b=f[k+16>>2]|0;a=f[k+48>>2]|0;c=f[k+72>>2]|0;m=f[k+104>>2]|0;n=f[k+12>>2]|0;o=f[k+8>>2]|0;f[j>>2]=l;f[j+4>>2]=d?2:0;f[j+8>>2]=e;f[h>>2]=0;f[h+4>>2]=o;f[i>>2]=75540;f[i+4>>2]=b;f[i+8>>2]=a;f[i+12>>2]=c;f[i+16>>2]=m;f[i+20>>2]=n;f[i+24>>2]=j;h3(h,i,+(Y(o,n)|0)*.0000152587890625);Mxa(k);u=g;return}function Lxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=(x>>>3&511)+1|0;f[a+116>>2]=y;z=x&7;x=a+112|0;f[x>>2]=z;if((y|0)!=2)sV(y,75956);if((e+-3|0)>>>0>=2)sV(e,75984);if(z|0)pV(z,76012);z=c+4|0;y=d+4|0;if((f[z>>2]|0)!=(f[y>>2]|0)){do if((eS(c)|0)==65536){A=f[z>>2]|0;f[h>>2]=f[A>>2];B=h+4|0;C=A+4|0;f[B>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[A+8>>2];f[h+12>>2]=f[A+12>>2];f[h+16>>2]=f[A+16>>2];f[h+20>>2]=f[A+20>>2];f[h+24>>2]=f[A+24>>2];f[h+28>>2]=f[A+28>>2];f[h+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;U$(h,A);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){z=h+36|0;A=f[z>>2]|0;if((A|0)!=0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0){V$(h);G=z}else G=z}else{z=a+36|0;A=f[z>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)V$(a);f[z>>2]=0;A=a+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[j>>2]|0)>0){B=f[l>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];C=h+4|0;B=f[C>>2]|0;f[j>>2]=B;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[A>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];A=h+36|0;f[z>>2]=f[A>>2];z=a+44|0;D=f[z>>2]|0;if((D|0)==(o|0))H=B;else{wL(D);f[z>>2]=o;f[l>>2]=k;H=f[C>>2]|0}k=h+44|0;if((H|0)<3){H=f[k>>2]|0;f[o>>2]=f[H>>2];f[a+52>>2]=f[H+4>>2]}else{f[z>>2]=f[k>>2];z=h+40|0;f[a+40>>2]=f[z>>2];f[k>>2]=h+48;f[z>>2]=j}f[h>>2]=1124007936;m=C;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));G=A}f[G>>2]=0;G=h+16|0;A=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){G=f[h+40>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[h+44>>2]|0;if((A|0)!=(h+48|0))wL(A)}else{A=h+8|0;f[A>>2]=0;f[A+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;A=f[c>>2]|0;f[v>>2]=l;f[w>>2]=A;f[i>>2]=l;f[i+4>>2]=A;wS(d,i,f[x>>2]&7|(e<<3)+-8,-1,0,0);do if((eS(d)|0)==65536){e=f[y>>2]|0;f[h>>2]=f[e>>2];x=h+4|0;i=e+4|0;f[x>>2]=f[i>>2];A=h+8|0;f[A>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=A;A=h+48|0;w=h+44|0;f[w>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(l|0){A=l+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;A=f[w>>2]|0;f[A>>2]=f[i>>2];f[A+4>>2]=f[i+4>>2];break}else{f[x>>2]=0;U$(h,e);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;y=f[d>>2]|0;if((y|0)!=0?(e=y+12|0,y=f[e>>2]|0,f[e>>2]=y+-1,(y|0)==1):0){V$(h);I=d}else I=d}else{d=a+92|0;y=f[d>>2]|0;if(y|0?(e=y+12|0,y=f[e>>2]|0,f[e>>2]=y+-1,(y|0)==1):0)V$(p);f[d>>2]=0;y=a+72|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;x=f[p>>2]|0;f[q>>2]=x;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[y>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];y=h+36|0;f[d>>2]=f[y>>2];d=a+100|0;e=f[d>>2]|0;if((e|0)==(t|0))J=x;else{wL(e);f[d>>2]=t;f[s>>2]=r;J=f[p>>2]|0}r=h+44|0;if((J|0)<3){J=f[r>>2]|0;f[t>>2]=f[J>>2];f[a+108>>2]=f[J+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));I=y}f[I>>2]=0;I=h+16|0;y=h+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[y>>2]|0)>0){I=f[h+40>>2]|0;m=0;do{f[I+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)==(h+48|0)){u=g;return}wL(y);u=g;return}function Mxa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function Nxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+128|0;e=d;Oxa(e,a,b,1);ixa(f[e+16>>2]|0,f[e+48>>2]|0,f[e+72>>2]|0,f[e+104>>2]|0,f[e+12>>2]|0,f[e+8>>2]|0,f[e+112>>2]|0,f[e+116>>2]|0,c);Pxa(e);u=d;return}function Oxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=x>>>3;z=(y&511)+1|0;f[a+116>>2]=z;A=x&7;B=a+112|0;f[B>>2]=A;if((y&510|0)!=2)sV(z,76040);if((e|0)!=1)sV(e,76068);switch(x&7){case 0:case 2:case 5:break;default:pV(A,76096)}A=c+4|0;x=d+4|0;if((f[A>>2]|0)!=(f[x>>2]|0)){do if((eS(c)|0)==65536){e=f[A>>2]|0;f[h>>2]=f[e>>2];z=h+4|0;y=e+4|0;f[z>>2]=f[y>>2];C=h+8|0;f[C>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];D=f[e+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=C;C=h+48|0;E=h+44|0;f[E>>2]=C;f[C>>2]=0;f[h+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[y>>2]|0)<3){y=f[e+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[y>>2];f[C+4>>2]=f[y+4>>2];break}else{f[z>>2]=0;U$(h,e);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){A=h+36|0;e=f[A>>2]|0;if((e|0)!=0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0){V$(h);F=A}else F=A}else{A=a+36|0;e=f[A>>2]|0;if(e|0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0)V$(a);f[A>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];y=h+4|0;z=f[y>>2]|0;f[j>>2]=z;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];e=h+36|0;f[A>>2]=f[e>>2];A=a+44|0;C=f[A>>2]|0;if((C|0)==(o|0))G=z;else{wL(C);f[A>>2]=o;f[l>>2]=k;G=f[y>>2]|0}k=h+44|0;if((G|0)<3){G=f[k>>2]|0;f[o>>2]=f[G>>2];f[a+52>>2]=f[G+4>>2]}else{f[A>>2]=f[k>>2];A=h+40|0;f[a+40>>2]=f[A>>2];f[k>>2]=h+48;f[A>>2]=j}f[h>>2]=1124007936;m=y;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));F=e}f[F>>2]=0;F=h+16|0;e=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[e>>2]|0)>0){F=f[h+40>>2]|0;y=0;do{f[F+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)!=(h+48|0))wL(e)}else{e=h+8|0;f[e>>2]=0;f[e+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;e=f[c>>2]|0;f[v>>2]=l;f[w>>2]=e;f[i>>2]=l;f[i+4>>2]=e;wS(d,i,f[B>>2]&7,-1,0,0);do if((eS(d)|0)==65536){B=f[x>>2]|0;f[h>>2]=f[B>>2];i=h+4|0;e=B+4|0;f[i>>2]=f[e>>2];l=h+8|0;f[l>>2]=f[B+8>>2];f[h+12>>2]=f[B+12>>2];f[h+16>>2]=f[B+16>>2];f[h+20>>2]=f[B+20>>2];f[h+24>>2]=f[B+24>>2];f[h+28>>2]=f[B+28>>2];f[h+32>>2]=f[B+32>>2];w=f[B+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[e>>2]|0)<3){e=f[B+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];break}else{f[i>>2]=0;U$(h,B);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;x=f[d>>2]|0;if((x|0)!=0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0){V$(h);H=d}else H=d}else{d=a+92|0;x=f[d>>2]|0;if(x|0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0)V$(p);f[d>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){B=f[s>>2]|0;i=0;do{f[B+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];x=h+36|0;f[d>>2]=f[x>>2];d=a+100|0;B=f[d>>2]|0;if((B|0)==(t|0))I=i;else{wL(B);f[d>>2]=t;f[s>>2]=r;I=f[p>>2]|0}r=h+44|0;if((I|0)<3){I=f[r>>2]|0;f[t>>2]=f[I>>2];f[a+108>>2]=f[I+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=x}f[H>>2]=0;H=h+16|0;x=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[x>>2]|0)>0){H=f[h+40>>2]|0;m=0;do{f[H+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)==(h+48|0)){u=g;return}wL(x);u=g;return}function Pxa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function Qxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+128|0;e=d;g=(c|0)<1?3:c;Rxa(e,a,b,g);pxa(f[e+16>>2]|0,f[e+48>>2]|0,f[e+72>>2]|0,f[e+104>>2]|0,f[e+12>>2]|0,f[e+8>>2]|0,f[e+112>>2]|0,g);Sxa(e);u=d;return}function Rxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=x>>>3&511;z=y+1|0;f[a+116>>2]=z;A=x&7;B=a+112|0;f[B>>2]=A;if(y|0)sV(z,76124);if((e+-3|0)>>>0>=2)sV(e,76152);switch(x&7){case 0:case 2:case 5:break;default:pV(A,76180)}A=c+4|0;x=d+4|0;if((f[A>>2]|0)!=(f[x>>2]|0)){do if((eS(c)|0)==65536){z=f[A>>2]|0;f[h>>2]=f[z>>2];y=h+4|0;C=z+4|0;f[y>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];E=f[z+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[z+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[y>>2]=0;U$(h,z);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){A=h+36|0;z=f[A>>2]|0;if((z|0)!=0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0){V$(h);G=A}else G=A}else{A=a+36|0;z=f[A>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)V$(a);f[A>>2]=0;z=a+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[l>>2]|0;C=0;do{f[y+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];C=h+4|0;y=f[C>>2]|0;f[j>>2]=y;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[z>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];z=h+36|0;f[A>>2]=f[z>>2];A=a+44|0;D=f[A>>2]|0;if((D|0)==(o|0))H=y;else{wL(D);f[A>>2]=o;f[l>>2]=k;H=f[C>>2]|0}k=h+44|0;if((H|0)<3){H=f[k>>2]|0;f[o>>2]=f[H>>2];f[a+52>>2]=f[H+4>>2]}else{f[A>>2]=f[k>>2];A=h+40|0;f[a+40>>2]=f[A>>2];f[k>>2]=h+48;f[A>>2]=j}f[h>>2]=1124007936;m=C;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));G=z}f[G>>2]=0;G=h+16|0;z=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[z>>2]|0)>0){G=f[h+40>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[z>>2]|0))}z=f[h+44>>2]|0;if((z|0)!=(h+48|0))wL(z)}else{z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;z=f[c>>2]|0;f[v>>2]=l;f[w>>2]=z;f[i>>2]=l;f[i+4>>2]=z;wS(d,i,f[B>>2]&7|(e<<3)+-8,-1,0,0);do if((eS(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];B=h+4|0;i=e+4|0;f[B>>2]=f[i>>2];z=h+8|0;f[z>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=z;z=h+48|0;w=h+44|0;f[w>>2]=z;f[z>>2]=0;f[h+52>>2]=0;if(l|0){z=l+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;z=f[w>>2]|0;f[z>>2]=f[i>>2];f[z+4>>2]=f[i+4>>2];break}else{f[B>>2]=0;U$(h,e);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;x=f[d>>2]|0;if((x|0)!=0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0){V$(h);I=d}else I=d}else{d=a+92|0;x=f[d>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)V$(p);f[d>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;B=0;do{f[e+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;B=f[p>>2]|0;f[q>>2]=B;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];x=h+36|0;f[d>>2]=f[x>>2];d=a+100|0;e=f[d>>2]|0;if((e|0)==(t|0))J=B;else{wL(e);f[d>>2]=t;f[s>>2]=r;J=f[p>>2]|0}r=h+44|0;if((J|0)<3){J=f[r>>2]|0;f[t>>2]=f[J>>2];f[a+108>>2]=f[J+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));I=x}f[I>>2]=0;I=h+16|0;x=h+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[x>>2]|0)>0){I=f[h+40>>2]|0;m=0;do{f[I+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)==(h+48|0)){u=g;return}wL(x);u=g;return}function Sxa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function Txa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+176|0;e=d+160|0;g=d+132|0;h=d+128|0;i=d;Uxa(i,a,b,1);b=f[i+16>>2]|0;a=f[i+48>>2]|0;j=f[i+72>>2]|0;k=f[i+104>>2]|0;l=f[i+12>>2]|0;m=f[i+8>>2]|0;f[h>>2]=c;f[e>>2]=0;f[e+4>>2]=m;f[g>>2]=75716;f[g+4>>2]=b;f[g+8>>2]=a;f[g+12>>2]=j;f[g+16>>2]=k;f[g+20>>2]=l;f[g+24>>2]=h;h3(e,g,+(Y(m,l)|0)*.0000152587890625);Vxa(i);u=d;return}function Uxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=(x>>>3&511)+1|0;f[a+116>>2]=y;z=x&7;x=a+112|0;f[x>>2]=z;if((y|0)!=2)sV(y,76208);if((e|0)!=1)sV(e,76236);if(z|0)pV(z,76264);z=c+4|0;e=d+4|0;if((f[z>>2]|0)!=(f[e>>2]|0)){do if((eS(c)|0)==65536){y=f[z>>2]|0;f[h>>2]=f[y>>2];A=h+4|0;B=y+4|0;f[A>>2]=f[B>>2];C=h+8|0;f[C>>2]=f[y+8>>2];f[h+12>>2]=f[y+12>>2];f[h+16>>2]=f[y+16>>2];f[h+20>>2]=f[y+20>>2];f[h+24>>2]=f[y+24>>2];f[h+28>>2]=f[y+28>>2];f[h+32>>2]=f[y+32>>2];D=f[y+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=C;C=h+48|0;E=h+44|0;f[E>>2]=C;f[C>>2]=0;f[h+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[y+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;U$(h,y);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){V$(h);F=z}else F=z}else{z=a+36|0;y=f[z>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)V$(a);f[z>>2]=0;y=a+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];B=h+4|0;A=f[B>>2]|0;f[j>>2]=A;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[y>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];y=h+36|0;f[z>>2]=f[y>>2];z=a+44|0;C=f[z>>2]|0;if((C|0)==(o|0))G=A;else{wL(C);f[z>>2]=o;f[l>>2]=k;G=f[B>>2]|0}k=h+44|0;if((G|0)<3){G=f[k>>2]|0;f[o>>2]=f[G>>2];f[a+52>>2]=f[G+4>>2]}else{f[z>>2]=f[k>>2];z=h+40|0;f[a+40>>2]=f[z>>2];f[k>>2]=h+48;f[z>>2]=j}f[h>>2]=1124007936;m=B;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));F=y}f[F>>2]=0;F=h+16|0;y=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[y>>2]|0)>0){F=f[h+40>>2]|0;B=0;do{f[F+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)!=(h+48|0))wL(y)}else{y=h+8|0;f[y>>2]=0;f[y+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;y=f[c>>2]|0;f[v>>2]=l;f[w>>2]=y;f[i>>2]=l;f[i+4>>2]=y;wS(d,i,f[x>>2]&7,-1,0,0);do if((eS(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;y=x+4|0;f[i>>2]=f[y>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[y>>2]|0)<3){y=f[x+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];break}else{f[i>>2]=0;U$(h,x);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;e=f[d>>2]|0;if((e|0)!=0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0){V$(h);H=d}else H=d}else{d=a+92|0;e=f[d>>2]|0;if(e|0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0)V$(p);f[d>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){x=f[s>>2]|0;i=0;do{f[x+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];e=h+36|0;f[d>>2]=f[e>>2];d=a+100|0;x=f[d>>2]|0;if((x|0)==(t|0))I=i;else{wL(x);f[d>>2]=t;f[s>>2]=r;I=f[p>>2]|0}r=h+44|0;if((I|0)<3){I=f[r>>2]|0;f[t>>2]=f[I>>2];f[a+108>>2]=f[I+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=e}f[H>>2]=0;H=h+16|0;e=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[e>>2]|0)>0){H=f[h+40>>2]|0;m=0;do{f[H+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function Vxa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function Wxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+176|0;e=d+160|0;g=d+132|0;h=d+128|0;i=d;Xxa(i,a,b,2);b=f[i+16>>2]|0;a=f[i+48>>2]|0;j=f[i+72>>2]|0;k=f[i+104>>2]|0;l=f[i+12>>2]|0;m=f[i+8>>2]|0;f[h>>2]=c;f[e>>2]=0;f[e+4>>2]=m;f[g>>2]=75736;f[g+4>>2]=b;f[g+8>>2]=a;f[g+12>>2]=j;f[g+16>>2]=k;f[g+20>>2]=l;f[g+24>>2]=h;h3(e,g,+(Y(m,l)|0)*.0000152587890625);Yxa(i);u=d;return}function Xxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=x>>>3&511;z=y+1|0;f[a+116>>2]=z;A=x&7;x=a+112|0;f[x>>2]=A;if(y|0)sV(z,76292);if((e|0)!=2)sV(e,76320);if(A|0)pV(A,76348);A=c+4|0;e=d+4|0;if((f[A>>2]|0)!=(f[e>>2]|0)){do if((eS(c)|0)==65536){z=f[A>>2]|0;f[h>>2]=f[z>>2];y=h+4|0;B=z+4|0;f[y>>2]=f[B>>2];C=h+8|0;f[C>>2]=f[z+8>>2];f[h+12>>2]=f[z+12>>2];f[h+16>>2]=f[z+16>>2];f[h+20>>2]=f[z+20>>2];f[h+24>>2]=f[z+24>>2];f[h+28>>2]=f[z+28>>2];f[h+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=C;C=h+48|0;E=h+44|0;f[E>>2]=C;f[C>>2]=0;f[h+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[y>>2]=0;U$(h,z);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){A=h+36|0;z=f[A>>2]|0;if((z|0)!=0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0){V$(h);F=A}else F=A}else{A=a+36|0;z=f[A>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)V$(a);f[A>>2]=0;z=a+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){y=f[l>>2]|0;B=0;do{f[y+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];B=h+4|0;y=f[B>>2]|0;f[j>>2]=y;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[z>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];z=h+36|0;f[A>>2]=f[z>>2];A=a+44|0;C=f[A>>2]|0;if((C|0)==(o|0))G=y;else{wL(C);f[A>>2]=o;f[l>>2]=k;G=f[B>>2]|0}k=h+44|0;if((G|0)<3){G=f[k>>2]|0;f[o>>2]=f[G>>2];f[a+52>>2]=f[G+4>>2]}else{f[A>>2]=f[k>>2];A=h+40|0;f[a+40>>2]=f[A>>2];f[k>>2]=h+48;f[A>>2]=j}f[h>>2]=1124007936;m=B;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));F=z}f[F>>2]=0;F=h+16|0;z=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[z>>2]|0)>0){F=f[h+40>>2]|0;B=0;do{f[F+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[h+44>>2]|0;if((z|0)!=(h+48|0))wL(z)}else{z=h+8|0;f[z>>2]=0;f[z+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;z=f[c>>2]|0;f[v>>2]=l;f[w>>2]=z;f[i>>2]=l;f[i+4>>2]=z;wS(d,i,f[x>>2]&7|8,-1,0,0);do if((eS(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;z=x+4|0;f[i>>2]=f[z>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[z>>2];f[l+4>>2]=f[z+4>>2];break}else{f[i>>2]=0;U$(h,x);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;e=f[d>>2]|0;if((e|0)!=0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0){V$(h);H=d}else H=d}else{d=a+92|0;e=f[d>>2]|0;if(e|0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0)V$(p);f[d>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){x=f[s>>2]|0;i=0;do{f[x+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];e=h+36|0;f[d>>2]=f[e>>2];d=a+100|0;x=f[d>>2]|0;if((x|0)==(t|0))I=i;else{wL(x);f[d>>2]=t;f[s>>2]=r;I=f[p>>2]|0}r=h+44|0;if((I|0)<3){I=f[r>>2]|0;f[t>>2]=f[I>>2];f[a+108>>2]=f[I+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=e}f[H>>2]=0;H=h+16|0;e=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[e>>2]|0)>0){H=f[h+40>>2]|0;m=0;do{f[H+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function Yxa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function Zxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+176|0;d=c+160|0;e=c+128|0;g=c;_xa(g,a,b,4);b=f[g+16>>2]|0;a=f[g+48>>2]|0;h=f[g+72>>2]|0;i=f[g+104>>2]|0;j=f[g+12>>2]|0;k=f[g+8>>2]|0;f[d>>2]=0;f[d+4>>2]=k;f[e>>2]=75756;f[e+4>>2]=b;f[e+8>>2]=a;f[e+12>>2]=h;f[e+16>>2]=i;f[e+20>>2]=j;f[e+24>>2]=c+168;h3(d,e,+(Y(k,j)|0)*.0000152587890625);$xa(g);u=c;return}function _xa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=(x>>>3&511)+1|0;f[a+116>>2]=y;z=x&7;x=a+112|0;f[x>>2]=z;if((y|0)!=4)sV(y,76376);if((e|0)!=4)sV(e,76404);if(z|0)pV(z,76432);z=c+4|0;e=d+4|0;if((f[z>>2]|0)!=(f[e>>2]|0)){do if((eS(c)|0)==65536){y=f[z>>2]|0;f[h>>2]=f[y>>2];A=h+4|0;B=y+4|0;f[A>>2]=f[B>>2];C=h+8|0;f[C>>2]=f[y+8>>2];f[h+12>>2]=f[y+12>>2];f[h+16>>2]=f[y+16>>2];f[h+20>>2]=f[y+20>>2];f[h+24>>2]=f[y+24>>2];f[h+28>>2]=f[y+28>>2];f[h+32>>2]=f[y+32>>2];D=f[y+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=C;C=h+48|0;E=h+44|0;f[E>>2]=C;f[C>>2]=0;f[h+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[y+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;U$(h,y);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){V$(h);F=z}else F=z}else{z=a+36|0;y=f[z>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)V$(a);f[z>>2]=0;y=a+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){A=f[l>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];B=h+4|0;A=f[B>>2]|0;f[j>>2]=A;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[y>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];y=h+36|0;f[z>>2]=f[y>>2];z=a+44|0;C=f[z>>2]|0;if((C|0)==(o|0))G=A;else{wL(C);f[z>>2]=o;f[l>>2]=k;G=f[B>>2]|0}k=h+44|0;if((G|0)<3){G=f[k>>2]|0;f[o>>2]=f[G>>2];f[a+52>>2]=f[G+4>>2]}else{f[z>>2]=f[k>>2];z=h+40|0;f[a+40>>2]=f[z>>2];f[k>>2]=h+48;f[z>>2]=j}f[h>>2]=1124007936;m=B;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));F=y}f[F>>2]=0;F=h+16|0;y=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[y>>2]|0)>0){F=f[h+40>>2]|0;B=0;do{f[F+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)!=(h+48|0))wL(y)}else{y=h+8|0;f[y>>2]=0;f[y+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;y=f[c>>2]|0;f[v>>2]=l;f[w>>2]=y;f[i>>2]=l;f[i+4>>2]=y;wS(d,i,f[x>>2]&7|24,-1,0,0);do if((eS(d)|0)==65536){x=f[e>>2]|0;f[h>>2]=f[x>>2];i=h+4|0;y=x+4|0;f[i>>2]=f[y>>2];l=h+8|0;f[l>>2]=f[x+8>>2];f[h+12>>2]=f[x+12>>2];f[h+16>>2]=f[x+16>>2];f[h+20>>2]=f[x+20>>2];f[h+24>>2]=f[x+24>>2];f[h+28>>2]=f[x+28>>2];f[h+32>>2]=f[x+32>>2];w=f[x+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[y>>2]|0)<3){y=f[x+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];break}else{f[i>>2]=0;U$(h,x);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;e=f[d>>2]|0;if((e|0)!=0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0){V$(h);H=d}else H=d}else{d=a+92|0;e=f[d>>2]|0;if(e|0?(x=e+12|0,e=f[x>>2]|0,f[x>>2]=e+-1,(e|0)==1):0)V$(p);f[d>>2]=0;e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){x=f[s>>2]|0;i=0;do{f[x+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];e=h+36|0;f[d>>2]=f[e>>2];d=a+100|0;x=f[d>>2]|0;if((x|0)==(t|0))I=i;else{wL(x);f[d>>2]=t;f[s>>2]=r;I=f[p>>2]|0}r=h+44|0;if((I|0)<3){I=f[r>>2]|0;f[t>>2]=f[I>>2];f[a+108>>2]=f[I+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=e}f[H>>2]=0;H=h+16|0;e=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[e>>2]|0)>0){H=f[h+40>>2]|0;m=0;do{f[H+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)==(h+48|0)){u=g;return}wL(e);u=g;return}function $xa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function aya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+176|0;d=c+160|0;e=c+128|0;g=c;_xa(g,a,b,4);b=f[g+16>>2]|0;a=f[g+48>>2]|0;h=f[g+72>>2]|0;i=f[g+104>>2]|0;j=f[g+12>>2]|0;k=f[g+8>>2]|0;f[d>>2]=0;f[d+4>>2]=k;f[e>>2]=75776;f[e+4>>2]=b;f[e+8>>2]=a;f[e+12>>2]=h;f[e+16>>2]=i;f[e+20>>2]=j;f[e+24>>2]=c+168;h3(d,e,+(Y(k,j)|0)*.0000152587890625);$xa(g);u=c;return}function bya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0;d=u;u=u+4240|0;e=d+4184|0;g=d+4128|0;i=d+4112|0;j=d+2064|0;k=d+12|0;l=d;do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[e>>2]=f[m>>2];n=e+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=e+8|0;f[p>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[e+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[e+36>>2]=q;f[e+40>>2]=p;p=e+48|0;r=e+44|0;f[r>>2]=p;f[p>>2]=0;f[e+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;U$(e,m);break}}else bS(e,a,-1);while(0);do if((eS(c)|0)==65536){a=f[c+4>>2]|0;f[g>>2]=f[a>>2];m=g+4|0;n=a+4|0;f[m>>2]=f[n>>2];o=g+8|0;f[o>>2]=f[a+8>>2];f[g+12>>2]=f[a+12>>2];f[g+16>>2]=f[a+16>>2];f[g+20>>2]=f[a+20>>2];f[g+24>>2]=f[a+24>>2];f[g+28>>2]=f[a+28>>2];f[g+32>>2]=f[a+32>>2];p=f[a+36>>2]|0;f[g+36>>2]=p;f[g+40>>2]=o;o=g+48|0;r=g+44|0;f[r>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[a+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];break}else{f[m>>2]=0;U$(g,a);break}}else bS(g,c,-1);while(0);c=e+40|0;a=f[c>>2]|0;m=f[a+4>>2]|0;n=f[a>>2]|0;f[i>>2]=0;a=i+4|0;f[a>>2]=0;f[i+8>>2]=0;g1c(j|0,0,2048)|0;if((f[e>>2]&4095|0)!=16){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;s=$Xc(48)|0;f[l>>2]=s;t=l+8|0;f[t>>2]=-2147483600;v=l+4|0;f[v>>2]=47;w=s;x=358551;y=w+47|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+47|0;b[z>>0]=0;vM(-215,l,358599,358609,161)}if((f[g>>2]&4095|0)!=4){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;s=$Xc(48)|0;f[l>>2]=s;t=l+8|0;f[t>>2]=-2147483600;v=l+4|0;f[v>>2]=47;w=s;x=358551;y=w+47|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));z=s+47|0;b[z>>0]=0;vM(-215,l,358599,358609,161)}z=g+40|0;s=f[z>>2]|0;if(!((n|0)==(f[s>>2]|0)?(m|0)==(f[s+4>>2]|0):0)){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;s=$Xc(32)|0;f[l>>2]=s;f[l+8>>2]=-2147483616;f[l+4>>2]=24;w=s;x=369423;y=w+24|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));b[s+24>>0]=0;vM(-215,l,358599,358609,162)}l=e+16|0;s=f[l>>2]|0;x=e+48|0;w=f[x>>2]|0;y=g+16|0;v=f[y>>2]|0;t=g+48|0;o=f[t>>2]|0;g1c(k|0,0,1024)|0;r=e+44|0;p=g+44|0;q=o>>>2;o=256;do{f[k+(o<<2)>>2]=o+-256;o=o+1|0}while((o|0)!=513);o=n+-1|0;if((m|0)>0){n=Y(q,o)|0;A=0;do{f[v+(A+n<<2)>>2]=-1;f[v+(A<<2)>>2]=-1;A=A+1|0}while((A|0)!=(m|0))}if((o|0)>1){A=m+-1|0;m=(A|0)>1;n=0-q|0;B=0-w|0;C=0;D=v;v=s;s=1;E=0;F=0;G=0;H=0;I=0;J=0;while(1){v=v+w|0;D=D+(q<<2)|0;f[D+(A<<2)>>2]=-1;f[D>>2]=-1;if(m){K=Y(s,q)|0;L=Y(s,w)|0;M=C;N=1;O=J;P=E;Q=F;R=G;S=H;T=I;while(1){U=D+(N<<2)|0;V=f[U>>2]|0;if((V|0)>=0)if(!V)W=33;else{X=M;Z=P;_=Q;$=R;aa=S;ba=T;ca=O}else{f[U>>2]=0;W=33}do if((W|0)==33){W=0;if((f[U+-4>>2]|0)>0){V=N*3|0;da=v+V|0;ea=da+-3|0;fa=(h[da>>0]|0)-(h[ea>>0]|0)|0;ga=(h[da+1>>0]|0)-(h[ea+1>>0]|0)|0;ha=(ga|0)>-1?ga:0-ga|0;ga=(h[da+2>>0]|0)-(h[ea+2>>0]|0)|0;ea=(ga|0)>-1?ga:0-ga|0;ia=ea+(f[k+((f[k+(((fa|0)>-1?fa:0-fa|0)+256-ha<<2)>>2]|0)+256+ha-ea<<2)>>2]|0)|0;ja=f[U+4>>2]|0;ka=da;la=V}else{V=f[U+4>>2]|0;if(((V|0)<=0?(f[U+(n<<2)>>2]|0)<=0:0)?(f[U+(q<<2)>>2]|0)<=0:0){X=M;Z=P;_=Q;$=R;aa=S;ba=T;ca=O;break}da=N*3|0;ia=256;ja=V;ka=v+da|0;la=da}if((ja|0)>0){da=(h[ka>>0]|0)-(h[ka+3>>0]|0)|0;V=(h[ka+1>>0]|0)-(h[ka+4>>0]|0)|0;ea=(V|0)>-1?V:0-V|0;V=(h[ka+2>>0]|0)-(h[ka+5>>0]|0)|0;ha=(V|0)>-1?V:0-V|0;ma=ia-(f[k+(ia+256-(f[k+((f[k+(((da|0)>-1?da:0-da|0)+256-ea<<2)>>2]|0)+256+ea-ha<<2)>>2]|0)-ha<<2)>>2]|0)|0}else ma=ia;if((f[U+(n<<2)>>2]|0)>0){ha=ka+B|0;ea=(h[ka>>0]|0)-(h[ha>>0]|0)|0;da=(h[ka+1>>0]|0)-(h[ha+1>>0]|0)|0;V=(da|0)>-1?da:0-da|0;da=(h[ka+2>>0]|0)-(h[ha+2>>0]|0)|0;ha=(da|0)>-1?da:0-da|0;na=ma-(f[k+(ma+256-(f[k+((f[k+(((ea|0)>-1?ea:0-ea|0)+256-V<<2)>>2]|0)+256+V-ha<<2)>>2]|0)-ha<<2)>>2]|0)|0}else na=ma;if((f[U+(q<<2)>>2]|0)>0){ha=ka+w|0;V=(h[ka>>0]|0)-(h[ha>>0]|0)|0;ea=(h[ka+1>>0]|0)-(h[ha+1>>0]|0)|0;da=(ea|0)>-1?ea:0-ea|0;ea=(h[ka+2>>0]|0)-(h[ha+2>>0]|0)|0;ha=(ea|0)>-1?ea:0-ea|0;oa=na-(f[k+(na+256-(f[k+((f[k+(((V|0)>-1?V:0-V|0)+256-da<<2)>>2]|0)+256+da-ha<<2)>>2]|0)-ha<<2)>>2]|0)|0}else oa=na;if(!M){ha=f[a>>2]|0;da=ha-O|0;V=(da|0)/12|0;ea=V*3|0;fa=(ea|0)>257?(ea|0)/2|0:128;ea=O;ga=ha;do if(fa>>>0>V>>>0){cya(i,fa-V|0);W=51}else{if(fa>>>0>=V>>>0){W=51;break}ha=ea+(fa*12|0)|0;if((ga|0)==(ha|0)){pa=V;qa=T;break}f[a>>2]=ga+(~(((ga+-12-ha|0)>>>0)/12|0)*12|0);pa=V;qa=T}while(0);do if((W|0)==51){W=0;ga=f[i>>2]|0;if(da|0){pa=V;qa=ga;break}f[ga>>2]=0;pa=1;qa=ga}while(0);V=fa+-1|0;if((pa|0)<(V|0)){da=pa;do{ga=da;da=da+1|0;f[qa+(ga*12|0)>>2]=da}while((da|0)!=(V|0))}f[qa+(V*12|0)>>2]=0;ra=pa;sa=qa}else{ra=M;sa=T}da=sa+(ra*12|0)|0;fa=f[da>>2]|0;f[da>>2]=0;f[sa+(ra*12|0)+4>>2]=N+K;f[sa+(ra*12|0)+8>>2]=la+L;da=j+(oa<<3)+4|0;ga=f[da>>2]|0;ea=f[i>>2]|0;f[((ga|0)==0?j+(oa<<3)|0:ea+(ga*12|0)|0)>>2]=ra;f[da>>2]=ra;f[U>>2]=-2;da=ea;X=fa;Z=da;_=da;$=da;aa=da;ba=ea;ca=da}while(0);N=N+1|0;if((N|0)>=(A|0)){ta=X;ua=Z;va=_;wa=$;xa=aa;ya=ba;za=ca;break}else{M=X;O=ca;P=Z;Q=_;R=$;S=aa;T=ba}}}else{ta=C;ua=E;va=F;wa=G;xa=H;ya=I;za=J}s=s+1|0;if((s|0)>=(o|0)){Aa=ta;Ba=ua;Ca=va;Da=wa;Ea=xa;Fa=ya;break}else{C=ta;E=ua;F=va;G=wa;H=xa;I=ya;J=za}}}else{Aa=0;Ba=0;Ca=0;Da=0;Ea=0;Fa=0}za=0;while(1){if(f[j+(za<<3)>>2]|0){Ga=za;W=62;break}za=za+1|0;if((za|0)>=256){W=61;break}}if((W|0)==61)if((za|0)==256)Ha=Fa;else{Ga=za;W=62}a:do if((W|0)==62){za=f[l>>2]|0;J=f[y>>2]|0;ya=0-q|0;I=0-w|0;xa=Ga;H=Aa;wa=Ba;G=Ca;va=Da;F=Ea;ua=Fa;while(1){E=xa;ta=H;while(1){C=f[j+(E<<3)>>2]|0;b:do if(!C){o=E;while(1){Ia=o+1|0;if((Ia|0)>=256)break;s=f[j+(Ia<<3)>>2]|0;if(!s)o=Ia;else{Ja=Ia;Ka=s;break b}}if((Ia|0)==256){Ha=ua;break a}Ja=Ia;Ka=f[j+(Ia<<3)>>2]|0}else{Ja=E;Ka=C}while(0);C=ua+(Ka*12|0)|0;V=f[C>>2]|0;f[j+(Ja<<3)>>2]=V;if(!V)f[j+(Ja<<3)+4>>2]=0;f[C>>2]=ta;La=f[ua+(Ka*12|0)+4>>2]|0;Ma=f[ua+(Ka*12|0)+8>>2]|0;Na=J+(La<<2)|0;Oa=Na+-4|0;Pa=f[Oa>>2]|0;C=(Pa|0)>0?Pa:0;Qa=Na+4|0;Ra=f[Qa>>2]|0;if((Ra|0)>0)Sa=(Pa|0)<1?Ra:(Ra|0)==(C|0)?C:-1;else Sa=C;Ta=Na+(ya<<2)|0;C=f[Ta>>2]|0;if((C|0)>0)Ua=(Sa|0)==0?C:(C|0)==(Sa|0)?Sa:-1;else Ua=Sa;Va=Na+(q<<2)|0;Wa=f[Va>>2]|0;if((Wa|0)>0)if(!Ua){W=77;break}else Xa=(Wa|0)==(Ua|0)?Ua:-1;else Xa=Ua;f[Na>>2]=Xa;if((Xa|0)==-1){E=Ja;ta=Ka}else break}if((W|0)==77){W=0;f[Na>>2]=Wa}ta=za+Ma|0;if(!Pa){E=ta+-3|0;C=(h[ta>>0]|0)-(h[E>>0]|0)|0;V=(h[ta+1>>0]|0)-(h[E+1>>0]|0)|0;o=(V|0)>-1?V:0-V|0;V=(h[ta+2>>0]|0)-(h[E+2>>0]|0)|0;E=(V|0)>-1?V:0-V|0;V=E+(f[k+((f[k+(((C|0)>-1?C:0-C|0)+256-o<<2)>>2]|0)+256+o-E<<2)>>2]|0)|0;if(!Ka){E=f[a>>2]|0;o=E-F|0;C=(o|0)/12|0;s=C*3|0;ba=(s|0)>257?(s|0)/2|0:128;s=F;aa=E;if(ba>>>0<=C>>>0)if(ba>>>0<C>>>0){E=s+(ba*12|0)|0;if((aa|0)==(E|0)){Ya=C;Za=ua}else{f[a>>2]=aa+(~(((aa+-12-E|0)>>>0)/12|0)*12|0);Ya=C;Za=ua}}else W=86;else{cya(i,ba-C|0);W=86}if((W|0)==86){W=0;E=f[i>>2]|0;if(!o){f[E>>2]=0;Ya=1;Za=E}else{Ya=C;Za=E}}E=ba+-1|0;if((Ya|0)<(E|0)){ba=Ya;do{C=ba;ba=ba+1|0;f[Za+(C*12|0)>>2]=ba}while((ba|0)!=(E|0))}f[Za+(E*12|0)>>2]=0;_a=Ya;$a=Za}else{_a=Ka;$a=ua}ba=$a+(_a*12|0)|0;C=f[ba>>2]|0;f[ba>>2]=0;f[$a+(_a*12|0)+4>>2]=La+-1;f[$a+(_a*12|0)+8>>2]=Ma+-3;ba=j+(V<<3)+4|0;o=f[ba>>2]|0;aa=f[i>>2]|0;f[((o|0)==0?j+(V<<3)|0:aa+(o*12|0)|0)>>2]=_a;f[ba>>2]=_a;ba=Ja-(f[k+(Ja+256-V<<2)>>2]|0)|0;f[Oa>>2]=-2;o=aa;ab=ba;bb=C;cb=f[Qa>>2]|0;db=o;eb=o;fb=o;gb=o;hb=aa}else{ab=Ja;bb=Ka;cb=Ra;db=va;eb=wa;fb=G;gb=F;hb=ua}if(!cb){aa=ta+3|0;o=(h[ta>>0]|0)-(h[aa>>0]|0)|0;C=(h[ta+1>>0]|0)-(h[aa+1>>0]|0)|0;ba=(C|0)>-1?C:0-C|0;C=(h[ta+2>>0]|0)-(h[aa+2>>0]|0)|0;aa=(C|0)>-1?C:0-C|0;C=aa+(f[k+((f[k+(((o|0)>-1?o:0-o|0)+256-ba<<2)>>2]|0)+256+ba-aa<<2)>>2]|0)|0;if(!bb){aa=f[a>>2]|0;ba=aa-db|0;o=(ba|0)/12|0;s=o*3|0;$=(s|0)>257?(s|0)/2|0:128;s=db;_=aa;if($>>>0<=o>>>0)if($>>>0<o>>>0){aa=s+($*12|0)|0;if((_|0)==(aa|0)){ib=o;jb=hb}else{f[a>>2]=_+(~(((_+-12-aa|0)>>>0)/12|0)*12|0);ib=o;jb=hb}}else W=99;else{cya(i,$-o|0);W=99}if((W|0)==99){W=0;aa=f[i>>2]|0;if(!ba){f[aa>>2]=0;ib=1;jb=aa}else{ib=o;jb=aa}}aa=$+-1|0;if((ib|0)<(aa|0)){$=ib;do{o=$;$=$+1|0;f[jb+(o*12|0)>>2]=$}while(($|0)!=(aa|0))}f[jb+(aa*12|0)>>2]=0;kb=ib;lb=jb}else{kb=bb;lb=hb}$=lb+(kb*12|0)|0;V=f[$>>2]|0;f[$>>2]=0;f[lb+(kb*12|0)+4>>2]=La+1;f[lb+(kb*12|0)+8>>2]=Ma+3;$=j+(C<<3)+4|0;E=f[$>>2]|0;o=f[i>>2]|0;f[((E|0)==0?j+(C<<3)|0:o+(E*12|0)|0)>>2]=kb;f[$>>2]=kb;$=ab-(f[k+(ab+256-C<<2)>>2]|0)|0;f[Qa>>2]=-2;E=o;mb=$;nb=V;ob=E;pb=E;qb=E;rb=E;sb=o}else{mb=ab;nb=bb;ob=fb;pb=eb;qb=db;rb=gb;sb=hb}if(!(f[Ta>>2]|0)){o=ta+I|0;E=(h[ta>>0]|0)-(h[o>>0]|0)|0;V=(h[ta+1>>0]|0)-(h[o+1>>0]|0)|0;$=(V|0)>-1?V:0-V|0;V=(h[ta+2>>0]|0)-(h[o+2>>0]|0)|0;o=(V|0)>-1?V:0-V|0;V=o+(f[k+((f[k+(((E|0)>-1?E:0-E|0)+256-$<<2)>>2]|0)+256+$-o<<2)>>2]|0)|0;if(!nb){o=f[a>>2]|0;$=o-ob|0;E=($|0)/12|0;ba=E*3|0;_=(ba|0)>257?(ba|0)/2|0:128;ba=ob;s=o;if(_>>>0<=E>>>0)if(_>>>0<E>>>0){o=ba+(_*12|0)|0;if((s|0)==(o|0)){tb=E;ub=sb}else{f[a>>2]=s+(~(((s+-12-o|0)>>>0)/12|0)*12|0);tb=E;ub=sb}}else W=112;else{cya(i,_-E|0);W=112}if((W|0)==112){W=0;o=f[i>>2]|0;if(!$){f[o>>2]=0;tb=1;ub=o}else{tb=E;ub=o}}o=_+-1|0;if((tb|0)<(o|0)){_=tb;do{E=_;_=_+1|0;f[ub+(E*12|0)>>2]=_}while((_|0)!=(o|0))}f[ub+(o*12|0)>>2]=0;vb=tb;wb=ub}else{vb=nb;wb=sb}_=wb+(vb*12|0)|0;C=f[_>>2]|0;f[_>>2]=0;f[wb+(vb*12|0)+4>>2]=La-q;f[wb+(vb*12|0)+8>>2]=Ma-w;_=j+(V<<3)+4|0;aa=f[_>>2]|0;E=f[i>>2]|0;f[((aa|0)==0?j+(V<<3)|0:E+(aa*12|0)|0)>>2]=vb;f[_>>2]=vb;_=mb-(f[k+(mb+256-V<<2)>>2]|0)|0;f[Ta>>2]=-2;aa=E;xb=C;yb=_;zb=aa;Ab=aa;Bb=aa;Cb=aa;Db=E}else{xb=nb;yb=mb;zb=pb;Ab=ob;Bb=qb;Cb=rb;Db=sb}if(f[Va>>2]|0){xa=yb;H=xb;wa=zb;G=Ab;va=Bb;F=Cb;ua=Db;continue}E=ta+w|0;aa=(h[ta>>0]|0)-(h[E>>0]|0)|0;_=(h[ta+1>>0]|0)-(h[E+1>>0]|0)|0;C=(_|0)>-1?_:0-_|0;_=(h[ta+2>>0]|0)-(h[E+2>>0]|0)|0;E=(_|0)>-1?_:0-_|0;_=E+(f[k+((f[k+(((aa|0)>-1?aa:0-aa|0)+256-C<<2)>>2]|0)+256+C-E<<2)>>2]|0)|0;if(!xb){E=f[a>>2]|0;C=E-zb|0;aa=(C|0)/12|0;$=aa*3|0;s=($|0)>257?($|0)/2|0:128;$=zb;ba=E;if(s>>>0<=aa>>>0)if(s>>>0<aa>>>0){E=$+(s*12|0)|0;if((ba|0)==(E|0)){Eb=aa;Fb=Db}else{f[a>>2]=ba+(~(((ba+-12-E|0)>>>0)/12|0)*12|0);Eb=aa;Fb=Db}}else W=125;else{cya(i,s-aa|0);W=125}if((W|0)==125){W=0;E=f[i>>2]|0;if(!C){f[E>>2]=0;Eb=1;Fb=E}else{Eb=aa;Fb=E}}E=s+-1|0;if((Eb|0)<(E|0)){s=Eb;do{aa=s;s=s+1|0;f[Fb+(aa*12|0)>>2]=s}while((s|0)!=(E|0))}f[Fb+(E*12|0)>>2]=0;Gb=Eb;Hb=Fb}else{Gb=xb;Hb=Db}s=Hb+(Gb*12|0)|0;ta=f[s>>2]|0;f[s>>2]=0;f[Hb+(Gb*12|0)+4>>2]=La+q;f[Hb+(Gb*12|0)+8>>2]=Ma+w;s=j+(_<<3)+4|0;V=f[s>>2]|0;o=f[i>>2]|0;f[((V|0)==0?j+(_<<3)|0:o+(V*12|0)|0)>>2]=Gb;f[s>>2]=Gb;s=yb-(f[k+(yb+256-_<<2)>>2]|0)|0;f[Va>>2]=-2;V=o;xa=s;H=ta;wa=V;G=V;va=V;F=V;ua=o}}while(0);if(Ha|0){Va=f[a>>2]|0;if((Va|0)!=(Ha|0))f[a>>2]=Va+(~(((Va+-12-Ha|0)>>>0)/12|0)*12|0);cYc(Ha)}Ha=g+36|0;Va=f[Ha>>2]|0;if(Va|0?(a=Va+12|0,Va=f[a>>2]|0,f[a>>2]=Va+-1,(Va|0)==1):0)V$(g);f[Ha>>2]=0;Ha=g+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[Ha>>2]|0)>0){y=f[z>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[Ha>>2]|0))}Ha=f[p>>2]|0;if((Ha|0)!=(t|0))wL(Ha);Ha=e+36|0;t=f[Ha>>2]|0;if(t|0?(p=t+12|0,t=f[p>>2]|0,f[p>>2]=t+-1,(t|0)==1):0)V$(e);f[Ha>>2]=0;Ha=e+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[Ha>>2]|0)>0){l=f[c>>2]|0;c=0;do{f[l+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[Ha>>2]|0))}Ha=f[r>>2]|0;if((Ha|0)==(x|0)){u=d;return}wL(Ha);u=d;return}function cya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)kWc(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=k+(d*12|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-12|0)*12|0)|0;if((b|0)>0)o1c(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;cYc(d);return}function dya(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=h+4|0;k=(g|0)<0?(e|0)/2|0:g;if((c|1|0)!=1){g=$Xc(48)|0;f[j>>2]=g;f[j+8>>2]=-2147483600;f[j+4>>2]=39;l=g;m=358686;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[g+39>>0]=0;vM(-215,j,358726,358749,853)}g=(d&7|0)==0;a:do if(!c){if(g){m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=76468;l=m+12|0;Wba(l);o=m;p=76928;q=l;break}switch(d&7){case 2:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=76496;m=l+12|0;Wba(m);o=l;p=76748;q=m;break a;break}case 3:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=76524;l=m+12|0;Wba(l);o=m;p=76768;q=l;break a;break}case 5:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=76552;m=l+12|0;Wba(m);o=l;p=76788;q=m;break a;break}case 6:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=76580;l=m+12|0;Wba(l);o=m;p=76808;q=l;break a;break}default:{f[i>>2]=d;DM(j,358819,i);vM(-213,j,358726,358749,891)}}}else{if(g){l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=76608;m=l+12|0;Wba(m);o=l;p=76828;q=m;break}switch(d&7){case 2:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=76636;l=m+12|0;Wba(l);o=m;p=76848;q=l;break a;break}case 3:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=76664;m=l+12|0;Wba(m);o=l;p=76868;q=m;break a;break}case 5:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=76692;l=m+12|0;Wba(l);o=m;p=76888;q=l;break a;break}case 6:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=76720;m=l+12|0;Wba(m);o=l;p=76908;q=m;break a;break}default:{f[i>>2]=d;DM(j,358819,i);vM(-213,j,358726,358749,891)}}}while(0);f[q>>2]=p;f[o+16>>2]=e;f[o+20>>2]=k;f[a>>2]=q;f[a+4>>2]=o;u=h;return}function eya(a){a=a|0;cYc(a);return}function fya(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=s-(h[r>>0]|0)+256|0;if(t>>>0<769)u=h[274204+t>>0]|0;else u=0;b[n+q>>0]=s-u;t=s-(h[r+j>>0]|0)+256|0;if(t>>>0<769)v=h[274204+t>>0]|0;else v=0;b[n+(q+g)>>0]=s-v;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=b[q+g>>0]|0;t=j;while(1){r=s&255;w=r-(h[q+t>>0]|0)+256|0;if(w>>>0<769)x=h[274204+w>>0]|0;else x=0;y=r-x|0;t=t+g|0;if((t|0)>=(i|0))break;else s=y&255}s=y&255;r=s-(h[q>>0]|0)+256|0;if(r>>>0<769)z=h[274204+r>>0]|0;else z=0;b[n+p>>0]=y-z;r=s-(h[q+t>>0]|0)+256|0;if(r>>>0<769)A=h[274204+r>>0]|0;else A=0;b[n+(p+g)>>0]=y-A;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;s=b[r>>0]|0;w=g;do{C=s&255;D=C-(h[r+w>>0]|0)+256|0;if(D>>>0<769)E=h[274204+D>>0]|0;else E=0;s=C-E&255;w=w+g|0}while((w|0)<(i|0));b[n+B>>0]=s;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function gya(a){a=a|0;cYc(a);return}function hya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=r<s?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=r<s?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;r=+p[o+(e<<3)>>3];q=h;do{s=+p[o+(q<<3)>>3];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=r<s?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=r<s?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;s=+p[t>>3];v=e;do{w=+p[t+(v<<3)>>3];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function iya(a){a=a|0;cYc(a);return}function jya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=r<s?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=r<s?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;r=+n[p+(e<<2)>>2];q=h;do{s=+n[p+(q<<2)>>2];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=r<s?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=r<s?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;s=+n[t>>2];v=e;do{w=+n[t+(v<<2)>>2];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function kya(a){a=a|0;cYc(a);return}function lya(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=r<<16>>16<s<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=r<<16>>16<s<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=r<<16>>16<q<<16>>16?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=r<<16>>16<q<<16>>16?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=r<<16>>16<q<<16>>16?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=u<<16>>16<w<<16>>16?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function mya(a){a=a|0;cYc(a);return}function nya(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(r&65535)<(s&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(r&65535)<(s&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=(r&65535)<(q&65535)?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(r&65535)<(q&65535)?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=(r&65535)<(q&65535)?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=(u&65535)<(w&65535)?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function oya(a){a=a|0;cYc(a);return}function pya(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=(h[r>>0]|0)-s+256|0;if(t>>>0<769)u=h[274204+t>>0]|0;else u=0;b[n+q>>0]=u+s;t=(h[r+j>>0]|0)-s+256|0;if(t>>>0<769)v=h[274204+t>>0]|0;else v=0;b[n+(q+g)>>0]=v+s;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=b[q+g>>0]|0;t=j;while(1){r=s&255;w=(h[q+t>>0]|0)-r+256|0;if(w>>>0<769)x=h[274204+w>>0]|0;else x=0;y=x+r|0;t=t+g|0;if((t|0)>=(i|0))break;else s=y&255}s=y&255;r=(h[q>>0]|0)-s+256|0;if(r>>>0<769)z=h[274204+r>>0]|0;else z=0;b[n+p>>0]=z+y;r=(h[q+t>>0]|0)-s+256|0;if(r>>>0<769)A=h[274204+r>>0]|0;else A=0;b[n+(p+g)>>0]=A+y;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;s=b[r>>0]|0;w=g;do{C=s&255;D=(h[r+w>>0]|0)-C+256|0;if(D>>>0<769)E=h[274204+D>>0]|0;else E=0;s=E+C&255;w=w+g|0}while((w|0)<(i|0));b[n+B>>0]=s;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function qya(a){a=a|0;cYc(a);return}function rya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=s<r?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=s<r?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;r=+p[o+(e<<3)>>3];q=h;do{s=+p[o+(q<<3)>>3];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=s<r?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=s<r?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;s=+p[t>>3];v=e;do{w=+p[t+(v<<3)>>3];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function sya(a){a=a|0;cYc(a);return}function tya(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=s<r?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=s<r?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;r=+n[p+(e<<2)>>2];q=h;do{s=+n[p+(q<<2)>>2];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=s<r?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=s<r?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;s=+n[t>>2];v=e;do{w=+n[t+(v<<2)>>2];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function uya(a){a=a|0;cYc(a);return}function vya(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=s<<16>>16<r<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=s<<16>>16<r<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=q<<16>>16<r<<16>>16?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=q<<16>>16<r<<16>>16?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=q<<16>>16<r<<16>>16?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=w<<16>>16<u<<16>>16?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function wya(a){a=a|0;cYc(a);return}function xya(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(s&65535)<(r&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(s&65535)<(r&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=(q&65535)<(r&65535)?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(q&65535)<(r&65535)?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=(q&65535)<(r&65535)?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=(w&65535)<(u&65535)?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function yya(a){a=a|0;f[a>>2]=76720;NXc(a);return}function zya(a){a=a|0;f[a>>2]=76720;NXc(a);cYc(a);return}function Aya(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Bya(a){a=a|0;cYc(a);return}function Cya(a){a=a|0;f[a>>2]=76692;NXc(a);return}function Dya(a){a=a|0;f[a>>2]=76692;NXc(a);cYc(a);return}function Eya(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Fya(a){a=a|0;cYc(a);return}function Gya(a){a=a|0;f[a>>2]=76664;NXc(a);return}function Hya(a){a=a|0;f[a>>2]=76664;NXc(a);cYc(a);return}function Iya(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Jya(a){a=a|0;cYc(a);return}function Kya(a){a=a|0;f[a>>2]=76636;NXc(a);return}function Lya(a){a=a|0;f[a>>2]=76636;NXc(a);cYc(a);return}function Mya(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Nya(a){a=a|0;cYc(a);return}function Oya(a){a=a|0;f[a>>2]=76608;NXc(a);return}function Pya(a){a=a|0;f[a>>2]=76608;NXc(a);cYc(a);return}function Qya(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Rya(a){a=a|0;cYc(a);return}function Sya(a){a=a|0;f[a>>2]=76580;NXc(a);return}function Tya(a){a=a|0;f[a>>2]=76580;NXc(a);cYc(a);return}function Uya(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Vya(a){a=a|0;cYc(a);return}function Wya(a){a=a|0;f[a>>2]=76552;NXc(a);return}function Xya(a){a=a|0;f[a>>2]=76552;NXc(a);cYc(a);return}function Yya(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Zya(a){a=a|0;cYc(a);return}function _ya(a){a=a|0;f[a>>2]=76524;NXc(a);return}function $ya(a){a=a|0;f[a>>2]=76524;NXc(a);cYc(a);return}function aza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function bza(a){a=a|0;cYc(a);return}function cza(a){a=a|0;f[a>>2]=76496;NXc(a);return}function dza(a){a=a|0;f[a>>2]=76496;NXc(a);cYc(a);return}function eza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function fza(a){a=a|0;cYc(a);return}function gza(a){a=a|0;f[a>>2]=76468;NXc(a);return}function hza(a){a=a|0;f[a>>2]=76468;NXc(a);cYc(a);return}function iza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function jza(a){a=a|0;cYc(a);return}function kza(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=h+4|0;k=(g|0)<0?(e|0)/2|0:g;if((c|1|0)!=1){g=$Xc(48)|0;f[j>>2]=g;f[j+8>>2]=-2147483600;f[j+4>>2]=39;l=g;m=358686;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[g+39>>0]=0;vM(-215,j,360497,358749,899)}g=(d&7|0)==0;a:do if(!c){if(g){m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=76948;l=m+12|0;Xba(l);o=m;p=77444;q=l;break}switch(d&7){case 2:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=76976;m=l+12|0;Xba(m);o=l;p=77228;q=m;break a;break}case 3:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=77004;l=m+12|0;Xba(l);o=m;p=77252;q=l;break a;break}case 5:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=77032;m=l+12|0;Xba(m);o=l;p=77276;q=m;break a;break}case 6:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=77060;l=m+12|0;Xba(l);o=m;p=77300;q=l;break a;break}default:{f[i>>2]=d;DM(j,358819,i);vM(-213,j,360497,358749,937)}}}else{if(g){l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=77088;m=l+12|0;Xba(m);o=l;p=77324;q=m;break}switch(d&7){case 2:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=77116;l=m+12|0;Xba(l);o=m;p=77348;q=l;break a;break}case 3:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=77144;m=l+12|0;Xba(m);o=l;p=77372;q=m;break a;break}case 5:{m=$Xc(28)|0;f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=77172;l=m+12|0;Xba(l);o=m;p=77396;q=l;break a;break}case 6:{l=$Xc(28)|0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=77200;m=l+12|0;Xba(m);o=l;p=77420;q=m;break a;break}default:{f[i>>2]=d;DM(j,358819,i);vM(-213,j,360497,358749,937)}}}while(0);f[q>>2]=p;f[o+16>>2]=e;f[o+20>>2]=k;f[a>>2]=q;f[a+4>>2]=o;u=h;return}function lza(a){a=a|0;cYc(a);return}function mza(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=c;r=g;while(1){if(l)s=0;else{t=q+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=z;A=y;B=x;C=w;D=2;while(1){E=(f[q+(D<<2)>>2]|0)+u|0;F=C&255;G=F-(h[E>>0]|0)+256|0;if(G>>>0<769)H=h[274204+G>>0]|0;else H=0;G=F-H&255;F=B&255;I=F-(h[E+1>>0]|0)+256|0;if(I>>>0<769)J=h[274204+I>>0]|0;else J=0;I=F-J&255;F=A&255;K=F-(h[E+2>>0]|0)+256|0;if(K>>>0<769)L=h[274204+K>>0]|0;else L=0;K=F-L&255;F=v&255;M=F-(h[E+3>>0]|0)+256|0;if(M>>>0<769)N=h[274204+M>>0]|0;else N=0;M=F-N&255;D=D+1|0;if((D|0)==(j|0)){O=M;P=K;Q=I;R=G;S=j;break}else{v=M;A=K;B=I;C=G}}}else{O=z;P=y;Q=x;R=w;S=2}C=(f[q>>2]|0)+u|0;B=R&255;A=B-(h[C>>0]|0)+256|0;if(A>>>0<769)T=h[274204+A>>0]|0;else T=0;b[p+u>>0]=B-T;A=Q&255;v=A-(h[C+1>>0]|0)+256|0;if(v>>>0<769)U=h[274204+v>>0]|0;else U=0;b[p+(u|1)>>0]=A-U;v=P&255;D=v-(h[C+2>>0]|0)+256|0;if(D>>>0<769)V=h[274204+D>>0]|0;else V=0;b[p+(u|2)>>0]=v-V;D=O&255;G=D-(h[C+3>>0]|0)+256|0;if(G>>>0<769)W=h[274204+G>>0]|0;else W=0;b[p+(u|3)>>0]=D-W;G=(f[q+(S<<2)>>2]|0)+u|0;C=B-(h[G>>0]|0)+256|0;if(C>>>0<769)X=h[274204+C>>0]|0;else X=0;C=u+e|0;b[p+C>>0]=B-X;B=A-(h[G+1>>0]|0)+256|0;if(B>>>0<769)Y=h[274204+B>>0]|0;else Y=0;b[p+(C+1)>>0]=A-Y;A=v-(h[G+2>>0]|0)+256|0;if(A>>>0<769)Z=h[274204+A>>0]|0;else Z=0;b[p+(C+2)>>0]=v-Z;v=D-(h[G+3>>0]|0)+256|0;if(v>>>0<769)_=h[274204+v>>0]|0;else _=0;b[p+(C+3)>>0]=D-_;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=q+4|0;if(!m){t=q+8|0;D=s;while(1){C=h[(f[u>>2]|0)+D>>0]|0;v=C-(h[(f[q>>2]|0)+D>>0]|0)+256|0;if(v>>>0<769)$=h[274204+v>>0]|0;else $=0;b[p+D>>0]=C-$;v=C-(h[(f[t>>2]|0)+D>>0]|0)+256|0;if(v>>>0<769)aa=h[274204+v>>0]|0;else aa=0;b[p+(D+e)>>0]=C-aa;D=D+1|0;if((D|0)==(i|0))break a}}D=q+(j<<2)|0;t=s;do{w=b[(f[u>>2]|0)+t>>0]|0;x=2;while(1){y=w&255;z=y-(h[(f[q+(x<<2)>>2]|0)+t>>0]|0)+256|0;if(z>>>0<769)ba=h[274204+z>>0]|0;else ba=0;ca=y-ba|0;x=x+1|0;if((x|0)==(j|0))break;else w=ca&255}w=ca&255;x=w-(h[(f[q>>2]|0)+t>>0]|0)+256|0;if(x>>>0<769)da=h[274204+x>>0]|0;else da=0;b[p+t>>0]=ca-da;x=w-(h[(f[D>>2]|0)+t>>0]|0)+256|0;if(x>>>0<769)ea=h[274204+x>>0]|0;else ea=0;b[p+(t+e)>>0]=ca-ea;t=t+1|0}while((t|0)!=(i|0))}while(0);t=r+-2|0;D=p+n|0;u=q+8|0;if((t|0)>1){p=D;q=u;r=t}else{fa=D;ga=u;ha=t;break}}}else{fa=d;ga=c;ha=g}if((ha|0)<=0)return;g=i+-4|0;c=(i|0)<4;d=i&-4;r=ga;ga=ha;ha=fa;while(1){b:do if(c)ia=0;else{if(a)ja=0;else{fa=0;while(1){q=(f[r>>2]|0)+fa|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ea=b[q+3>>0]|0;b[ha+fa>>0]=b[q>>0]|0;b[ha+(fa|1)>>0]=p;b[ha+(fa|2)>>0]=n;b[ha+(fa|3)>>0]=ea;fa=fa+4|0;if((fa|0)>(g|0)){ia=d;break b}}}do{fa=(f[r>>2]|0)+ja|0;ea=b[fa+3>>0]|0;n=b[fa+2>>0]|0;p=b[fa+1>>0]|0;q=b[fa>>0]|0;fa=1;do{ca=(f[r+(fa<<2)>>2]|0)+ja|0;da=q&255;ba=da-(h[ca>>0]|0)+256|0;if(ba>>>0<769)ka=h[274204+ba>>0]|0;else ka=0;q=da-ka&255;da=p&255;ba=da-(h[ca+1>>0]|0)+256|0;if(ba>>>0<769)la=h[274204+ba>>0]|0;else la=0;p=da-la&255;da=n&255;ba=da-(h[ca+2>>0]|0)+256|0;if(ba>>>0<769)ma=h[274204+ba>>0]|0;else ma=0;n=da-ma&255;da=ea&255;ba=da-(h[ca+3>>0]|0)+256|0;if(ba>>>0<769)na=h[274204+ba>>0]|0;else na=0;ea=da-na&255;fa=fa+1|0}while((fa|0)!=(j|0));b[ha+ja>>0]=q;b[ha+(ja|1)>>0]=p;b[ha+(ja|2)>>0]=n;b[ha+(ja|3)>>0]=ea;ja=ja+4|0}while((ja|0)<=(g|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{fa=ia;while(1){b[ha+fa>>0]=b[(f[r>>2]|0)+fa>>0]|0;fa=fa+1|0;if((fa|0)==(i|0))break c}}do{fa=b[(f[r>>2]|0)+oa>>0]|0;da=1;do{ba=fa&255;ca=ba-(h[(f[r+(da<<2)>>2]|0)+oa>>0]|0)+256|0;if(ca>>>0<769)pa=h[274204+ca>>0]|0;else pa=0;fa=ba-pa&255;da=da+1|0}while((da|0)!=(j|0));b[ha+oa>>0]=fa;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((ga|0)>1){r=r+4|0;ga=ga+-1|0;ha=ha+e|0}else break}return}function nza(a){a=a|0;cYc(a);return}function oza(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=b;q=e;while(1){a:do if(j)r=0;else{s=f[o+4>>2]|0;t=f[o>>2]|0;if(!k){u=f[o+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=x<B?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=y<B?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=z<B?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=A<B?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=x<B?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=y<x?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=z<y?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[o+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;A=+p[C+24>>3];z=+p[C+16>>3];y=+p[C+8>>3];x=+p[C>>3];C=2;do{w=(f[o+(C<<2)>>2]|0)+(u<<3)|0;B=+p[w>>3];x=x<B?B:x;B=+p[w+8>>3];y=y<B?B:y;B=+p[w+16>>3];z=z<B?B:z;B=+p[w+24>>3];A=A<B?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<3)|0;B=+p[C>>3];p[n+(u<<3)>>3]=x<B?B:x;B=+p[C+8>>3];p[n+((u|1)<<3)>>3]=y<B?B:y;B=+p[C+16>>3];p[n+((u|2)<<3)>>3]=z<B?B:z;B=+p[C+24>>3];p[n+((u|3)<<3)>>3]=A<B?B:A;C=v+(u<<3)|0;B=+p[C>>3];w=u+a|0;p[n+(w<<3)>>3]=x<B?B:x;B=+p[C+8>>3];p[n+(w+1<<3)>>3]=y<B?B:y;B=+p[C+16>>3];p[n+(w+2<<3)>>3]=z<B?B:z;B=+p[C+24>>3];p[n+(w+3<<3)>>3]=A<B?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[o+4>>2]|0;v=f[o>>2]|0;if(!k){t=f[o+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=B<D?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[o+(h<<2)>>2]|0;t=r;do{B=+p[u+(t<<3)>>3];w=2;do{D=+p[(f[o+(w<<2)>>2]|0)+(t<<3)>>3];B=B<D?D:B;w=w+1|0}while((w|0)!=(h|0));A=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=B<A?A:B;A=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=B<A?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=n+(l<<3)|0;v=o+8|0;if((t|0)>1){n=s;o=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{o=0;while(1){n=E+(o<<3)|0;A=+p[n+8>>3];z=+p[n+16>>3];y=+p[n+24>>3];p[G+(o<<3)>>3]=+p[n>>3];p[G+((o|1)<<3)>>3]=A;p[G+((o|2)<<3)>>3]=z;p[G+((o|3)<<3)>>3]=y;o=o+4|0;if((o|0)>(e|0)){H=c;break c}}}do{o=E+(I<<3)|0;y=+p[o+24>>3];z=+p[o+16>>3];A=+p[o+8>>3];x=+p[o>>3];o=1;do{n=(f[q+(o<<2)>>2]|0)+(I<<3)|0;D=+p[n>>3];x=x<D?D:x;D=+p[n+8>>3];A=A<D?D:A;D=+p[n+16>>3];z=z<D?D:z;D=+p[n+24>>3];y=y<D?D:y;o=o+1|0}while((o|0)!=(h|0));p[G+(I<<3)>>3]=x;p[G+((I|1)<<3)>>3]=A;p[G+((I|2)<<3)>>3]=z;p[G+((I|3)<<3)>>3]=y;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{o=H;while(1){p[G+(o<<3)>>3]=+p[E+(o<<3)>>3];o=o+1|0;if((o|0)==(g|0))break d}}do{B=+p[E+(J<<3)>>3];o=1;do{D=+p[(f[q+(o<<2)>>2]|0)+(J<<3)>>3];B=B<D?D:B;o=o+1|0}while((o|0)!=(h|0));p[G+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<3)|0}else break}return}function pza(a){a=a|0;cYc(a);return}function qza(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=b;q=e;while(1){a:do if(j)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!k){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=x<B?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=y<B?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=z<B?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=A<B?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=x<B?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=y<x?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=z<y?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[p+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;A=+n[C+12>>2];z=+n[C+8>>2];y=+n[C+4>>2];x=+n[C>>2];C=2;do{w=(f[p+(C<<2)>>2]|0)+(u<<2)|0;B=+n[w>>2];x=x<B?B:x;B=+n[w+4>>2];y=y<B?B:y;B=+n[w+8>>2];z=z<B?B:z;B=+n[w+12>>2];A=A<B?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<2)|0;B=+n[C>>2];n[o+(u<<2)>>2]=x<B?B:x;B=+n[C+4>>2];n[o+((u|1)<<2)>>2]=y<B?B:y;B=+n[C+8>>2];n[o+((u|2)<<2)>>2]=z<B?B:z;B=+n[C+12>>2];n[o+((u|3)<<2)>>2]=A<B?B:A;C=v+(u<<2)|0;B=+n[C>>2];w=u+a|0;n[o+(w<<2)>>2]=x<B?B:x;B=+n[C+4>>2];n[o+(w+1<<2)>>2]=y<B?B:y;B=+n[C+8>>2];n[o+(w+2<<2)>>2]=z<B?B:z;B=+n[C+12>>2];n[o+(w+3<<2)>>2]=A<B?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!k){t=f[p+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=B<D?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[p+(h<<2)>>2]|0;t=r;do{B=+n[u+(t<<2)>>2];w=2;do{D=+n[(f[p+(w<<2)>>2]|0)+(t<<2)>>2];B=B<D?D:B;w=w+1|0}while((w|0)!=(h|0));A=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=B<A?A:B;A=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=B<A?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=o+(l<<2)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{p=0;while(1){o=E+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[G+(p<<2)>>2]=f[o>>2];f[G+((p|1)<<2)>>2]=l;f[G+((p|2)<<2)>>2]=r;f[G+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(e|0)){H=c;break c}}}do{p=E+(I<<2)|0;A=+n[p+12>>2];z=+n[p+8>>2];y=+n[p+4>>2];x=+n[p>>2];p=1;do{k=(f[q+(p<<2)>>2]|0)+(I<<2)|0;D=+n[k>>2];x=x<D?D:x;D=+n[k+4>>2];y=y<D?D:y;D=+n[k+8>>2];z=z<D?D:z;D=+n[k+12>>2];A=A<D?D:A;p=p+1|0}while((p|0)!=(h|0));n[G+(I<<2)>>2]=x;n[G+((I|1)<<2)>>2]=y;n[G+((I|2)<<2)>>2]=z;n[G+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{p=H;while(1){f[G+(p<<2)>>2]=f[E+(p<<2)>>2];p=p+1|0;if((p|0)==(g|0))break d}}do{B=+n[E+(J<<2)>>2];p=1;do{D=+n[(f[q+(p<<2)>>2]|0)+(J<<2)>>2];B=B<D?D:B;p=p+1|0}while((p|0)!=(h|0));n[G+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<2)|0}else break}return}function rza(a){a=a|0;cYc(a);return}function sza(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=x<<16>>16<B<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=y<<16>>16<B<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=z<<16>>16<B<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=A<<16>>16<B<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=x<<16>>16<w<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=y<<16>>16<x<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=z<<16>>16<y<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=A<<16>>16<z<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=y<<16>>16<w<<16>>16?w:y;w=d[x+2>>1]|0;B=B<<16>>16<w<<16>>16?w:B;w=d[x+4>>1]|0;C=C<<16>>16<w<<16>>16?w:C;w=d[x+6>>1]|0;z=z<<16>>16<w<<16>>16?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=y<<16>>16<w<<16>>16?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=B<<16>>16<w<<16>>16?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=C<<16>>16<w<<16>>16?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=z<<16>>16<w<<16>>16?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=y<<16>>16<A<<16>>16?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=B<<16>>16<A<<16>>16?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=C<<16>>16<A<<16>>16?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=z<<16>>16<A<<16>>16?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=A<<16>>16<x<<16>>16?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=A<<16>>16<x<<16>>16?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=A<<16>>16<w<<16>>16?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=A<<16>>16<x<<16>>16?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=A<<16>>16<x<<16>>16?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=o<<16>>16<j<<16>>16?j:o;j=d[n+2>>1]|0;m=m<<16>>16<j<<16>>16?j:m;j=d[n+4>>1]|0;r=r<<16>>16<j<<16>>16?j:r;j=d[n+6>>1]|0;l=l<<16>>16<j<<16>>16?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=p<<16>>16<j<<16>>16?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function tza(a){a=a|0;cYc(a);return}function uza(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(x&65535)<(B&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(y&65535)<(B&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(z&65535)<(B&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(A&65535)<(B&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(x&65535)<(w&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(y&65535)<(x&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(z&65535)<(y&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(A&65535)<(z&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=(y&65535)<(w&65535)?w:y;w=d[x+2>>1]|0;B=(B&65535)<(w&65535)?w:B;w=d[x+4>>1]|0;C=(C&65535)<(w&65535)?w:C;w=d[x+6>>1]|0;z=(z&65535)<(w&65535)?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=(y&65535)<(w&65535)?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=(B&65535)<(w&65535)?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=(C&65535)<(w&65535)?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=(z&65535)<(w&65535)?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=(y&65535)<(A&65535)?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=(B&65535)<(A&65535)?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=(C&65535)<(A&65535)?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=(z&65535)<(A&65535)?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(A&65535)<(x&65535)?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(A&65535)<(x&65535)?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=(A&65535)<(w&65535)?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(A&65535)<(x&65535)?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(A&65535)<(x&65535)?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=(o&65535)<(j&65535)?j:o;j=d[n+2>>1]|0;m=(m&65535)<(j&65535)?j:m;j=d[n+4>>1]|0;r=(r&65535)<(j&65535)?j:r;j=d[n+6>>1]|0;l=(l&65535)<(j&65535)?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=(p&65535)<(j&65535)?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function vza(a){a=a|0;cYc(a);return}function wza(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=c;r=g;while(1){if(l)s=0;else{t=q+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=z;A=y;B=x;C=w;D=2;while(1){E=(f[q+(D<<2)>>2]|0)+u|0;F=C&255;G=(h[E>>0]|0)-F+256|0;if(G>>>0<769)H=h[274204+G>>0]|0;else H=0;G=H+F&255;F=B&255;I=(h[E+1>>0]|0)-F+256|0;if(I>>>0<769)J=h[274204+I>>0]|0;else J=0;I=J+F&255;F=A&255;K=(h[E+2>>0]|0)-F+256|0;if(K>>>0<769)L=h[274204+K>>0]|0;else L=0;K=L+F&255;F=v&255;M=(h[E+3>>0]|0)-F+256|0;if(M>>>0<769)N=h[274204+M>>0]|0;else N=0;M=N+F&255;D=D+1|0;if((D|0)==(j|0)){O=M;P=K;Q=I;R=G;S=j;break}else{v=M;A=K;B=I;C=G}}}else{O=z;P=y;Q=x;R=w;S=2}C=(f[q>>2]|0)+u|0;B=R&255;A=(h[C>>0]|0)-B+256|0;if(A>>>0<769)T=h[274204+A>>0]|0;else T=0;b[p+u>>0]=T+B;A=Q&255;v=(h[C+1>>0]|0)-A+256|0;if(v>>>0<769)U=h[274204+v>>0]|0;else U=0;b[p+(u|1)>>0]=U+A;v=P&255;D=(h[C+2>>0]|0)-v+256|0;if(D>>>0<769)V=h[274204+D>>0]|0;else V=0;b[p+(u|2)>>0]=V+v;D=O&255;G=(h[C+3>>0]|0)-D+256|0;if(G>>>0<769)W=h[274204+G>>0]|0;else W=0;b[p+(u|3)>>0]=W+D;G=(f[q+(S<<2)>>2]|0)+u|0;C=(h[G>>0]|0)-B+256|0;if(C>>>0<769)X=h[274204+C>>0]|0;else X=0;C=u+e|0;b[p+C>>0]=X+B;B=(h[G+1>>0]|0)-A+256|0;if(B>>>0<769)Y=h[274204+B>>0]|0;else Y=0;b[p+(C+1)>>0]=Y+A;A=(h[G+2>>0]|0)-v+256|0;if(A>>>0<769)Z=h[274204+A>>0]|0;else Z=0;b[p+(C+2)>>0]=Z+v;v=(h[G+3>>0]|0)-D+256|0;if(v>>>0<769)_=h[274204+v>>0]|0;else _=0;b[p+(C+3)>>0]=_+D;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=q+4|0;if(!m){t=q+8|0;D=s;while(1){C=h[(f[u>>2]|0)+D>>0]|0;v=(h[(f[q>>2]|0)+D>>0]|0)-C+256|0;if(v>>>0<769)$=h[274204+v>>0]|0;else $=0;b[p+D>>0]=$+C;v=(h[(f[t>>2]|0)+D>>0]|0)-C+256|0;if(v>>>0<769)aa=h[274204+v>>0]|0;else aa=0;b[p+(D+e)>>0]=aa+C;D=D+1|0;if((D|0)==(i|0))break a}}D=q+(j<<2)|0;t=s;do{w=b[(f[u>>2]|0)+t>>0]|0;x=2;while(1){y=w&255;z=(h[(f[q+(x<<2)>>2]|0)+t>>0]|0)-y+256|0;if(z>>>0<769)ba=h[274204+z>>0]|0;else ba=0;ca=ba+y|0;x=x+1|0;if((x|0)==(j|0))break;else w=ca&255}w=ca&255;x=(h[(f[q>>2]|0)+t>>0]|0)-w+256|0;if(x>>>0<769)da=h[274204+x>>0]|0;else da=0;b[p+t>>0]=da+ca;x=(h[(f[D>>2]|0)+t>>0]|0)-w+256|0;if(x>>>0<769)ea=h[274204+x>>0]|0;else ea=0;b[p+(t+e)>>0]=ea+ca;t=t+1|0}while((t|0)!=(i|0))}while(0);t=r+-2|0;D=p+n|0;u=q+8|0;if((t|0)>1){p=D;q=u;r=t}else{fa=D;ga=u;ha=t;break}}}else{fa=d;ga=c;ha=g}if((ha|0)<=0)return;g=i+-4|0;c=(i|0)<4;d=i&-4;r=ga;ga=ha;ha=fa;while(1){b:do if(c)ia=0;else{if(a)ja=0;else{fa=0;while(1){q=(f[r>>2]|0)+fa|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ca=b[q+3>>0]|0;b[ha+fa>>0]=b[q>>0]|0;b[ha+(fa|1)>>0]=p;b[ha+(fa|2)>>0]=n;b[ha+(fa|3)>>0]=ca;fa=fa+4|0;if((fa|0)>(g|0)){ia=d;break b}}}do{fa=(f[r>>2]|0)+ja|0;ca=b[fa+3>>0]|0;n=b[fa+2>>0]|0;p=b[fa+1>>0]|0;q=b[fa>>0]|0;fa=1;do{ea=(f[r+(fa<<2)>>2]|0)+ja|0;da=q&255;ba=(h[ea>>0]|0)-da+256|0;if(ba>>>0<769)ka=h[274204+ba>>0]|0;else ka=0;q=ka+da&255;da=p&255;ba=(h[ea+1>>0]|0)-da+256|0;if(ba>>>0<769)la=h[274204+ba>>0]|0;else la=0;p=la+da&255;da=n&255;ba=(h[ea+2>>0]|0)-da+256|0;if(ba>>>0<769)ma=h[274204+ba>>0]|0;else ma=0;n=ma+da&255;da=ca&255;ba=(h[ea+3>>0]|0)-da+256|0;if(ba>>>0<769)na=h[274204+ba>>0]|0;else na=0;ca=na+da&255;fa=fa+1|0}while((fa|0)!=(j|0));b[ha+ja>>0]=q;b[ha+(ja|1)>>0]=p;b[ha+(ja|2)>>0]=n;b[ha+(ja|3)>>0]=ca;ja=ja+4|0}while((ja|0)<=(g|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{fa=ia;while(1){b[ha+fa>>0]=b[(f[r>>2]|0)+fa>>0]|0;fa=fa+1|0;if((fa|0)==(i|0))break c}}do{fa=b[(f[r>>2]|0)+oa>>0]|0;da=1;do{ba=fa&255;ea=(h[(f[r+(da<<2)>>2]|0)+oa>>0]|0)-ba+256|0;if(ea>>>0<769)pa=h[274204+ea>>0]|0;else pa=0;fa=pa+ba&255;da=da+1|0}while((da|0)!=(j|0));b[ha+oa>>0]=fa;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((ga|0)>1){r=r+4|0;ga=ga+-1|0;ha=ha+e|0}else break}return}function xza(a){a=a|0;cYc(a);return}function yza(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=b;q=e;while(1){a:do if(j)r=0;else{s=f[o+4>>2]|0;t=f[o>>2]|0;if(!k){u=f[o+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=B<x?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=B<y?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=B<z?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=B<A?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=B<x?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=x<y?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=y<z?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[o+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;A=+p[C+24>>3];z=+p[C+16>>3];y=+p[C+8>>3];x=+p[C>>3];C=2;do{w=(f[o+(C<<2)>>2]|0)+(u<<3)|0;B=+p[w>>3];x=B<x?B:x;B=+p[w+8>>3];y=B<y?B:y;B=+p[w+16>>3];z=B<z?B:z;B=+p[w+24>>3];A=B<A?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<3)|0;B=+p[C>>3];p[n+(u<<3)>>3]=B<x?B:x;B=+p[C+8>>3];p[n+((u|1)<<3)>>3]=B<y?B:y;B=+p[C+16>>3];p[n+((u|2)<<3)>>3]=B<z?B:z;B=+p[C+24>>3];p[n+((u|3)<<3)>>3]=B<A?B:A;C=v+(u<<3)|0;B=+p[C>>3];w=u+a|0;p[n+(w<<3)>>3]=B<x?B:x;B=+p[C+8>>3];p[n+(w+1<<3)>>3]=B<y?B:y;B=+p[C+16>>3];p[n+(w+2<<3)>>3]=B<z?B:z;B=+p[C+24>>3];p[n+(w+3<<3)>>3]=B<A?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[o+4>>2]|0;v=f[o>>2]|0;if(!k){t=f[o+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=D<B?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[o+(h<<2)>>2]|0;t=r;do{B=+p[u+(t<<3)>>3];w=2;do{D=+p[(f[o+(w<<2)>>2]|0)+(t<<3)>>3];B=D<B?D:B;w=w+1|0}while((w|0)!=(h|0));A=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=A<B?A:B;A=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=A<B?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=n+(l<<3)|0;v=o+8|0;if((t|0)>1){n=s;o=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{o=0;while(1){n=E+(o<<3)|0;A=+p[n+8>>3];z=+p[n+16>>3];y=+p[n+24>>3];p[G+(o<<3)>>3]=+p[n>>3];p[G+((o|1)<<3)>>3]=A;p[G+((o|2)<<3)>>3]=z;p[G+((o|3)<<3)>>3]=y;o=o+4|0;if((o|0)>(e|0)){H=c;break c}}}do{o=E+(I<<3)|0;y=+p[o+24>>3];z=+p[o+16>>3];A=+p[o+8>>3];x=+p[o>>3];o=1;do{n=(f[q+(o<<2)>>2]|0)+(I<<3)|0;D=+p[n>>3];x=D<x?D:x;D=+p[n+8>>3];A=D<A?D:A;D=+p[n+16>>3];z=D<z?D:z;D=+p[n+24>>3];y=D<y?D:y;o=o+1|0}while((o|0)!=(h|0));p[G+(I<<3)>>3]=x;p[G+((I|1)<<3)>>3]=A;p[G+((I|2)<<3)>>3]=z;p[G+((I|3)<<3)>>3]=y;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{o=H;while(1){p[G+(o<<3)>>3]=+p[E+(o<<3)>>3];o=o+1|0;if((o|0)==(g|0))break d}}do{B=+p[E+(J<<3)>>3];o=1;do{D=+p[(f[q+(o<<2)>>2]|0)+(J<<3)>>3];B=D<B?D:B;o=o+1|0}while((o|0)!=(h|0));p[G+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<3)|0}else break}return}function zza(a){a=a|0;cYc(a);return}function Aza(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=b;q=e;while(1){a:do if(j)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!k){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=B<x?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=B<y?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=B<z?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=B<A?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=B<x?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=x<y?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=y<z?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[p+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;A=+n[C+12>>2];z=+n[C+8>>2];y=+n[C+4>>2];x=+n[C>>2];C=2;do{w=(f[p+(C<<2)>>2]|0)+(u<<2)|0;B=+n[w>>2];x=B<x?B:x;B=+n[w+4>>2];y=B<y?B:y;B=+n[w+8>>2];z=B<z?B:z;B=+n[w+12>>2];A=B<A?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<2)|0;B=+n[C>>2];n[o+(u<<2)>>2]=B<x?B:x;B=+n[C+4>>2];n[o+((u|1)<<2)>>2]=B<y?B:y;B=+n[C+8>>2];n[o+((u|2)<<2)>>2]=B<z?B:z;B=+n[C+12>>2];n[o+((u|3)<<2)>>2]=B<A?B:A;C=v+(u<<2)|0;B=+n[C>>2];w=u+a|0;n[o+(w<<2)>>2]=B<x?B:x;B=+n[C+4>>2];n[o+(w+1<<2)>>2]=B<y?B:y;B=+n[C+8>>2];n[o+(w+2<<2)>>2]=B<z?B:z;B=+n[C+12>>2];n[o+(w+3<<2)>>2]=B<A?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!k){t=f[p+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=D<B?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[p+(h<<2)>>2]|0;t=r;do{B=+n[u+(t<<2)>>2];w=2;do{D=+n[(f[p+(w<<2)>>2]|0)+(t<<2)>>2];B=D<B?D:B;w=w+1|0}while((w|0)!=(h|0));A=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=A<B?A:B;A=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=A<B?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=o+(l<<2)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{p=0;while(1){o=E+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[G+(p<<2)>>2]=f[o>>2];f[G+((p|1)<<2)>>2]=l;f[G+((p|2)<<2)>>2]=r;f[G+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(e|0)){H=c;break c}}}do{p=E+(I<<2)|0;A=+n[p+12>>2];z=+n[p+8>>2];y=+n[p+4>>2];x=+n[p>>2];p=1;do{k=(f[q+(p<<2)>>2]|0)+(I<<2)|0;D=+n[k>>2];x=D<x?D:x;D=+n[k+4>>2];y=D<y?D:y;D=+n[k+8>>2];z=D<z?D:z;D=+n[k+12>>2];A=D<A?D:A;p=p+1|0}while((p|0)!=(h|0));n[G+(I<<2)>>2]=x;n[G+((I|1)<<2)>>2]=y;n[G+((I|2)<<2)>>2]=z;n[G+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{p=H;while(1){f[G+(p<<2)>>2]=f[E+(p<<2)>>2];p=p+1|0;if((p|0)==(g|0))break d}}do{B=+n[E+(J<<2)>>2];p=1;do{D=+n[(f[q+(p<<2)>>2]|0)+(J<<2)>>2];B=D<B?D:B;p=p+1|0}while((p|0)!=(h|0));n[G+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<2)|0}else break}return}function Bza(a){a=a|0;cYc(a);return}function Cza(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=B<<16>>16<x<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=B<<16>>16<y<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=B<<16>>16<z<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=B<<16>>16<A<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=w<<16>>16<x<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=x<<16>>16<y<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=y<<16>>16<z<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=z<<16>>16<A<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=w<<16>>16<y<<16>>16?w:y;w=d[x+2>>1]|0;B=w<<16>>16<B<<16>>16?w:B;w=d[x+4>>1]|0;C=w<<16>>16<C<<16>>16?w:C;w=d[x+6>>1]|0;z=w<<16>>16<z<<16>>16?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=w<<16>>16<y<<16>>16?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=w<<16>>16<B<<16>>16?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=w<<16>>16<C<<16>>16?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=w<<16>>16<z<<16>>16?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=A<<16>>16<y<<16>>16?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=A<<16>>16<B<<16>>16?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=A<<16>>16<C<<16>>16?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=A<<16>>16<z<<16>>16?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=x<<16>>16<A<<16>>16?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=x<<16>>16<A<<16>>16?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=w<<16>>16<A<<16>>16?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=x<<16>>16<A<<16>>16?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=x<<16>>16<A<<16>>16?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=j<<16>>16<o<<16>>16?j:o;j=d[n+2>>1]|0;m=j<<16>>16<m<<16>>16?j:m;j=d[n+4>>1]|0;r=j<<16>>16<r<<16>>16?j:r;j=d[n+6>>1]|0;l=j<<16>>16<l<<16>>16?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=j<<16>>16<p<<16>>16?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function Dza(a){a=a|0;cYc(a);return}function Eza(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(B&65535)<(x&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(B&65535)<(y&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(B&65535)<(z&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(B&65535)<(A&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(w&65535)<(x&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(x&65535)<(y&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(y&65535)<(z&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(z&65535)<(A&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=(w&65535)<(y&65535)?w:y;w=d[x+2>>1]|0;B=(w&65535)<(B&65535)?w:B;w=d[x+4>>1]|0;C=(w&65535)<(C&65535)?w:C;w=d[x+6>>1]|0;z=(w&65535)<(z&65535)?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=(w&65535)<(y&65535)?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=(w&65535)<(B&65535)?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=(w&65535)<(C&65535)?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=(w&65535)<(z&65535)?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=(A&65535)<(y&65535)?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=(A&65535)<(B&65535)?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=(A&65535)<(C&65535)?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=(A&65535)<(z&65535)?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(x&65535)<(A&65535)?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(x&65535)<(A&65535)?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=(w&65535)<(A&65535)?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(x&65535)<(A&65535)?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(x&65535)<(A&65535)?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=(j&65535)<(o&65535)?j:o;j=d[n+2>>1]|0;m=(j&65535)<(m&65535)?j:m;j=d[n+4>>1]|0;r=(j&65535)<(r&65535)?j:r;j=d[n+6>>1]|0;l=(j&65535)<(l&65535)?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=(j&65535)<(p&65535)?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function Fza(a){a=a|0;f[a>>2]=77200;NXc(a);return}function Gza(a){a=a|0;f[a>>2]=77200;NXc(a);cYc(a);return}function Hza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Iza(a){a=a|0;cYc(a);return}function Jza(a){a=a|0;f[a>>2]=77172;NXc(a);return}function Kza(a){a=a|0;f[a>>2]=77172;NXc(a);cYc(a);return}function Lza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Mza(a){a=a|0;cYc(a);return}function Nza(a){a=a|0;f[a>>2]=77144;NXc(a);return}function Oza(a){a=a|0;f[a>>2]=77144;NXc(a);cYc(a);return}function Pza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Qza(a){a=a|0;cYc(a);return}function Rza(a){a=a|0;f[a>>2]=77116;NXc(a);return}function Sza(a){a=a|0;f[a>>2]=77116;NXc(a);cYc(a);return}function Tza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Uza(a){a=a|0;cYc(a);return}function Vza(a){a=a|0;f[a>>2]=77088;NXc(a);return}function Wza(a){a=a|0;f[a>>2]=77088;NXc(a);cYc(a);return}function Xza(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function Yza(a){a=a|0;cYc(a);return}function Zza(a){a=a|0;f[a>>2]=77060;NXc(a);return}function _za(a){a=a|0;f[a>>2]=77060;NXc(a);cYc(a);return}function $za(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function aAa(a){a=a|0;cYc(a);return}function bAa(a){a=a|0;f[a>>2]=77032;NXc(a);return}function cAa(a){a=a|0;f[a>>2]=77032;NXc(a);cYc(a);return}function dAa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function eAa(a){a=a|0;cYc(a);return}function fAa(a){a=a|0;f[a>>2]=77004;NXc(a);return}function gAa(a){a=a|0;f[a>>2]=77004;NXc(a);cYc(a);return}function hAa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function iAa(a){a=a|0;cYc(a);return}function jAa(a){a=a|0;f[a>>2]=76976;NXc(a);return}function kAa(a){a=a|0;f[a>>2]=76976;NXc(a);cYc(a);return}function lAa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function mAa(a){a=a|0;cYc(a);return}function nAa(a){a=a|0;f[a>>2]=76948;NXc(a);return}function oAa(a){a=a|0;f[a>>2]=76948;NXc(a);cYc(a);return}function pAa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function qAa(a){a=a|0;cYc(a);return}function rAa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+8|0;do if((eS(e)|0)==65536){l=f[e+4>>2]|0;f[k>>2]=f[l>>2];m=k+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=k+8|0;f[o>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];f[k+20>>2]=f[l+20>>2];f[k+24>>2]=f[l+24>>2];f[k+28>>2]=f[l+28>>2];f[k+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[k+36>>2]=p;q=k+40|0;f[q>>2]=o;o=k+48|0;r=k+44|0;f[r>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;U$(k,l);s=q;break}}else{bS(k,e,-1);s=k+40|0}while(0);e=d&7;q=f[g>>2]|0;l=g+4|0;m=f[l>>2]|0;n=f[s>>2]|0;o=f[n+4>>2]|0;r=f[n>>2]|0;n=(q|0)==-1?(o|0)/2|0:q;q=(m|0)==-1?(r|0)/2|0:m;if(!((n|0)>-1&(n|0)<(o|0))){t=$Xc(64)|0;f[j>>2]=t;v=j+8|0;f[v>>2]=-2147483584;w=j+4|0;f[w>>2]=52;x=t;y=362293;z=x+52|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));A=t+52|0;b[A>>0]=0;vM(-215,j,362346,362362,363)}if((q|0)<0|(q|0)>=(r|0)){t=$Xc(64)|0;f[j>>2]=t;v=j+8|0;f[v>>2]=-2147483584;w=j+4|0;f[w>>2]=52;x=t;y=362293;z=x+52|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));A=t+52|0;b[A>>0]=0;vM(-215,j,362346,362362,363)}f[g>>2]=n;f[l>>2]=q;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;l=$Xc(48)|0;f[j>>2]=l;f[j+8>>2]=-2147483600;f[j+4>>2]=39;x=l;y=358686;z=x+39|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[l+39>>0]=0;vM(-215,j,362439,358749,946)}l=(e|0)==0;a:do if(!c){if(l){e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77468;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;sAa(y,k,j);B=y;C=e;break}switch(d&7){case 2:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77496;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;tAa(y,k,j);B=y;C=e;break a;break}case 3:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77524;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;uAa(y,k,j);B=y;C=e;break a;break}case 5:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77552;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;vAa(y,k,j);B=y;C=e;break a;break}case 6:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77580;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;wAa(y,k,j);B=y;C=e;break a;break}default:{f[i>>2]=d;DM(j,358819,i);vM(-213,j,362439,358749,974)}}}else{if(l){e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77608;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;xAa(y,k,j);B=y;C=e;break}switch(d&7){case 2:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77636;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;yAa(y,k,j);B=y;C=e;break a;break}case 3:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77664;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;zAa(y,k,j);B=y;C=e;break a;break}case 5:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77692;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;AAa(y,k,j);B=y;C=e;break a;break}case 6:{e=$Xc(60)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=77720;y=e+12|0;f[j>>2]=n;f[j+4>>2]=q;BAa(y,k,j);B=y;C=e;break a;break}default:{f[i>>2]=d;DM(j,358819,i);vM(-213,j,362439,358749,974)}}}while(0);f[a>>2]=B;f[a+4>>2]=C;C=k+36|0;a=f[C>>2]|0;if(a|0?(B=a+12|0,a=f[B>>2]|0,f[B>>2]=a+-1,(a|0)==1):0)V$(k);f[C>>2]=0;C=k+16|0;a=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[a>>2]|0)>0){C=f[s>>2]|0;s=0;do{f[C+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[a>>2]|0))}a=f[k+44>>2]|0;if((a|0)==(k+48|0)){u=h;return}wL(a);u=h;return}function sAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77964;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function tAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77940;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function uAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77916;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function vAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77892;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function wAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77868;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function xAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77844;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function yAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77820;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function zAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77796;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function AAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77772;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function BAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;Yba(a);f[a>>2]=77748;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=$Xc(32)|0;f[g>>2]=l;f[g+8>>2]=-2147483616;f[g+4>>2]=23;a=l;d=362459;m=a+23|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(m|0));b[l+23>>0]=0;vM(-215,g,362483,358749,788)}f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;uha(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;d=h-i>>2;a=i;i=h;if(c>>>0<=d>>>0){if(c>>>0<d>>>0?(h=a+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Vba(j,c-d|0);d=f[g>>2]|0;if(!d){u=e;return}if((f[l>>2]|0)!=(d|0))f[l>>2]=d;cYc(d);u=e;return}function CAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77748;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function DAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77748;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function EAa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<3)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(n)s=0;else{c=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=c+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[b+(r<<3)>>3]=+p[u>>3];p[b+((r|1)<<3)>>3]=v;p[b+((r|2)<<3)>>3]=w;p[b+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<3)|0;x=+p[r+24>>3];w=+p[r+16>>3];v=+p[r+8>>3];y=+p[r>>3];r=1;do{u=(f[j+(r<<2)>>2]|0)+(t<<3)|0;z=+p[u>>3];y=y<z?z:y;z=+p[u+8>>3];v=v<z?z:v;z=+p[u+16>>3];w=w<z?z:w;z=+p[u+24>>3];x=x<z?z:x;r=r+1|0}while((r|0)<(a|0));p[b+(t<<3)>>3]=y;p[b+((t|1)<<3)>>3]=v;p[b+((t|2)<<3)>>3]=w;p[b+((t|3)<<3)>>3]=x;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(o)A=s;else{r=s;while(1){p[b+(r<<3)>>3]=+p[c+(r<<3)>>3];r=r+1|0;if((r|0)==(l|0))break b}}do{z=+p[c+(A<<3)>>3];r=1;do{B=+p[(f[j+(r<<2)>>2]|0)+(A<<3)>>3];z=z<B?B:z;r=r+1|0}while((r|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function FAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77720;f[a+12>>2]=77748;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function GAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77720;f[a+12>>2]=77748;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function HAa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function IAa(a){a=a|0;cYc(a);return}function JAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77772;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function KAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77772;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function LAa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<2)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[b+(r<<2)>>2]=f[u>>2];f[b+((r|1)<<2)>>2]=v;f[b+((r|2)<<2)>>2]=w;f[b+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<2)|0;y=+n[r+12>>2];z=+n[r+8>>2];A=+n[r+4>>2];B=+n[r>>2];r=1;do{x=(f[j+(r<<2)>>2]|0)+(t<<2)|0;C=+n[x>>2];B=B<C?C:B;C=+n[x+4>>2];A=A<C?C:A;C=+n[x+8>>2];z=z<C?C:z;C=+n[x+12>>2];y=y<C?C:y;r=r+1|0}while((r|0)<(a|0));n[b+(t<<2)>>2]=B;n[b+((t|1)<<2)>>2]=A;n[b+((t|2)<<2)>>2]=z;n[b+((t|3)<<2)>>2]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(p)D=s;else{r=s;while(1){f[b+(r<<2)>>2]=f[c+(r<<2)>>2];r=r+1|0;if((r|0)==(l|0))break b}}do{C=+n[c+(D<<2)>>2];r=1;do{E=+n[(f[j+(r<<2)>>2]|0)+(D<<2)>>2];C=C<E?E:C;r=r+1|0}while((r|0)<(a|0));n[b+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function MAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77692;f[a+12>>2]=77772;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function NAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77692;f[a+12>>2]=77772;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function OAa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function PAa(a){a=a|0;cYc(a);return}function QAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77796;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function RAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77796;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function SAa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=u<<16>>16<z<<16>>16?z:u;z=d[y+2>>1]|0;v=v<<16>>16<z<<16>>16?z:v;z=d[y+4>>1]|0;w=w<<16>>16<z<<16>>16?z:w;z=d[y+6>>1]|0;x=x<<16>>16<z<<16>>16?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=r<<16>>16<y<<16>>16?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function TAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77664;f[a+12>>2]=77796;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function UAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77664;f[a+12>>2]=77796;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function VAa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function WAa(a){a=a|0;cYc(a);return}function XAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77820;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function YAa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77820;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function ZAa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=(u&65535)<(z&65535)?z:u;z=d[y+2>>1]|0;v=(v&65535)<(z&65535)?z:v;z=d[y+4>>1]|0;w=(w&65535)<(z&65535)?z:w;z=d[y+6>>1]|0;x=(x&65535)<(z&65535)?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=(r&65535)<(y&65535)?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function _Aa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77636;f[a+12>>2]=77820;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function $Aa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77636;f[a+12>>2]=77820;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function aBa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function bBa(a){a=a|0;cYc(a);return}function cBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77844;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function dBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77844;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function eBa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=c;c=d;d=g;while(1){if(i){g=0;do{s=(f[r+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(g<<3)>>2]|0,j)|0)|0;f[l+(g<<2)>>2]=s;g=g+1|0}while((g|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{g=0;while(1){s=(f[l>>2]|0)+g|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[c+g>>0]=b[s>>0]|0;b[c+(g|1)>>0]=v;b[c+(g|2)>>0]=w;b[c+(g|3)>>0]=x;g=g+4|0;if((g|0)>(o|0)){t=m;break a}}}do{g=(f[l>>2]|0)+u|0;x=b[g+3>>0]|0;w=b[g+2>>0]|0;v=b[g+1>>0]|0;s=b[g>>0]|0;g=1;do{y=(f[l+(g<<2)>>2]|0)+u|0;z=s&255;A=(h[y>>0]|0)-z+256|0;if(A>>>0<769)B=h[274204+A>>0]|0;else B=0;s=B+z&255;z=v&255;A=(h[y+1>>0]|0)-z+256|0;if(A>>>0<769)C=h[274204+A>>0]|0;else C=0;v=C+z&255;z=w&255;A=(h[y+2>>0]|0)-z+256|0;if(A>>>0<769)D=h[274204+A>>0]|0;else D=0;w=D+z&255;z=x&255;A=(h[y+3>>0]|0)-z+256|0;if(A>>>0<769)E=h[274204+A>>0]|0;else E=0;x=E+z&255;g=g+1|0}while((g|0)<(a|0));b[c+u>>0]=s;b[c+(u|1)>>0]=v;b[c+(u|2)>>0]=w;b[c+(u|3)>>0]=x;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{g=t;while(1){b[c+g>>0]=b[(f[l>>2]|0)+g>>0]|0;g=g+1|0;if((g|0)==(n|0))break b}}do{g=b[(f[l>>2]|0)+F>>0]|0;z=1;do{A=g&255;y=(h[(f[l+(z<<2)>>2]|0)+F>>0]|0)-A+256|0;if(y>>>0<769)G=h[274204+y>>0]|0;else G=0;g=G+A&255;z=z+1|0}while((z|0)<(a|0));b[c+F>>0]=g;F=F+1|0}while((F|0)!=(n|0))}while(0);if((d|0)>1){r=r+4|0;c=c+e|0;d=d+-1|0}else break}return}function fBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77608;f[a+12>>2]=77844;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function gBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77608;f[a+12>>2]=77844;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function hBa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function iBa(a){a=a|0;cYc(a);return}function jBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77868;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function kBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77868;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function lBa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<3)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(n)s=0;else{c=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=c+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[b+(r<<3)>>3]=+p[u>>3];p[b+((r|1)<<3)>>3]=v;p[b+((r|2)<<3)>>3]=w;p[b+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<3)|0;x=+p[r+24>>3];w=+p[r+16>>3];v=+p[r+8>>3];y=+p[r>>3];r=1;do{u=(f[j+(r<<2)>>2]|0)+(t<<3)|0;z=+p[u>>3];y=z<y?z:y;z=+p[u+8>>3];v=z<v?z:v;z=+p[u+16>>3];w=z<w?z:w;z=+p[u+24>>3];x=z<x?z:x;r=r+1|0}while((r|0)<(a|0));p[b+(t<<3)>>3]=y;p[b+((t|1)<<3)>>3]=v;p[b+((t|2)<<3)>>3]=w;p[b+((t|3)<<3)>>3]=x;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(o)A=s;else{r=s;while(1){p[b+(r<<3)>>3]=+p[c+(r<<3)>>3];r=r+1|0;if((r|0)==(l|0))break b}}do{z=+p[c+(A<<3)>>3];r=1;do{B=+p[(f[j+(r<<2)>>2]|0)+(A<<3)>>3];z=B<z?B:z;r=r+1|0}while((r|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function mBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77580;f[a+12>>2]=77868;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function nBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77580;f[a+12>>2]=77868;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function oBa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function pBa(a){a=a|0;cYc(a);return}function qBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77892;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function rBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77892;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function sBa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<2)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[b+(r<<2)>>2]=f[u>>2];f[b+((r|1)<<2)>>2]=v;f[b+((r|2)<<2)>>2]=w;f[b+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<2)|0;y=+n[r+12>>2];z=+n[r+8>>2];A=+n[r+4>>2];B=+n[r>>2];r=1;do{x=(f[j+(r<<2)>>2]|0)+(t<<2)|0;C=+n[x>>2];B=C<B?C:B;C=+n[x+4>>2];A=C<A?C:A;C=+n[x+8>>2];z=C<z?C:z;C=+n[x+12>>2];y=C<y?C:y;r=r+1|0}while((r|0)<(a|0));n[b+(t<<2)>>2]=B;n[b+((t|1)<<2)>>2]=A;n[b+((t|2)<<2)>>2]=z;n[b+((t|3)<<2)>>2]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(p)D=s;else{r=s;while(1){f[b+(r<<2)>>2]=f[c+(r<<2)>>2];r=r+1|0;if((r|0)==(l|0))break b}}do{C=+n[c+(D<<2)>>2];r=1;do{E=+n[(f[j+(r<<2)>>2]|0)+(D<<2)>>2];C=E<C?E:C;r=r+1|0}while((r|0)<(a|0));n[b+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function tBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77552;f[a+12>>2]=77892;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function uBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77552;f[a+12>>2]=77892;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function vBa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function wBa(a){a=a|0;cYc(a);return}function xBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77916;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function yBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77916;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function zBa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=z<<16>>16<u<<16>>16?z:u;z=d[y+2>>1]|0;v=z<<16>>16<v<<16>>16?z:v;z=d[y+4>>1]|0;w=z<<16>>16<w<<16>>16?z:w;z=d[y+6>>1]|0;x=z<<16>>16<x<<16>>16?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=y<<16>>16<r<<16>>16?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function ABa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77524;f[a+12>>2]=77916;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function BBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77524;f[a+12>>2]=77916;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function CBa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function DBa(a){a=a|0;cYc(a);return}function EBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77940;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function FBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77940;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function GBa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=(z&65535)<(u&65535)?z:u;z=d[y+2>>1]|0;v=(z&65535)<(v&65535)?z:v;z=d[y+4>>1]|0;w=(z&65535)<(w&65535)?z:w;z=d[y+6>>1]|0;x=(z&65535)<(x&65535)?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=(y&65535)<(r&65535)?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function HBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77496;f[a+12>>2]=77940;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function IBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77496;f[a+12>>2]=77940;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function JBa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function KBa(a){a=a|0;cYc(a);return}function LBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77964;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);cYc(b);return}function MBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77964;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+20>>2]|0;if(!b){cYc(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);cYc(a);return}function NBa(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=c;c=d;d=g;while(1){if(i){g=0;do{s=(f[r+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(g<<3)>>2]|0,j)|0)|0;f[l+(g<<2)>>2]=s;g=g+1|0}while((g|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{g=0;while(1){s=(f[l>>2]|0)+g|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[c+g>>0]=b[s>>0]|0;b[c+(g|1)>>0]=v;b[c+(g|2)>>0]=w;b[c+(g|3)>>0]=x;g=g+4|0;if((g|0)>(o|0)){t=m;break a}}}do{g=(f[l>>2]|0)+u|0;x=b[g+3>>0]|0;w=b[g+2>>0]|0;v=b[g+1>>0]|0;s=b[g>>0]|0;g=1;do{y=(f[l+(g<<2)>>2]|0)+u|0;z=s&255;A=z-(h[y>>0]|0)+256|0;if(A>>>0<769)B=h[274204+A>>0]|0;else B=0;s=z-B&255;z=v&255;A=z-(h[y+1>>0]|0)+256|0;if(A>>>0<769)C=h[274204+A>>0]|0;else C=0;v=z-C&255;z=w&255;A=z-(h[y+2>>0]|0)+256|0;if(A>>>0<769)D=h[274204+A>>0]|0;else D=0;w=z-D&255;z=x&255;A=z-(h[y+3>>0]|0)+256|0;if(A>>>0<769)E=h[274204+A>>0]|0;else E=0;x=z-E&255;g=g+1|0}while((g|0)<(a|0));b[c+u>>0]=s;b[c+(u|1)>>0]=v;b[c+(u|2)>>0]=w;b[c+(u|3)>>0]=x;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{g=t;while(1){b[c+g>>0]=b[(f[l>>2]|0)+g>>0]|0;g=g+1|0;if((g|0)==(n|0))break b}}do{g=b[(f[l>>2]|0)+F>>0]|0;z=1;do{A=g&255;y=A-(h[(f[l+(z<<2)>>2]|0)+F>>0]|0)+256|0;if(y>>>0<769)G=h[274204+y>>0]|0;else G=0;g=A-G&255;z=z+1|0}while((z|0)<(a|0));b[c+F>>0]=g;F=F+1|0}while((F|0)!=(n|0))}while(0);if((d|0)>1){r=r+4|0;c=c+e|0;d=d+-1|0}else break}return}function OBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77468;f[a+12>>2]=77964;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);return}function PBa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=77468;f[a+12>>2]=77964;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);cYc(b)}b=f[a+32>>2]|0;if(!b){NXc(a);cYc(a);return}d=a+36|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);cYc(b);NXc(a);cYc(a);return}function QBa(a){a=a|0;var b=0;b=a+12|0;Yi[f[f[b>>2]>>2]&4095](b);return}function RBa(a){a=a|0;cYc(a);return}function SBa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0;k=u;u=u+144|0;l=k+128|0;m=k+72|0;n=k+64|0;o=k+56|0;q=k;r=k+32|0;s=k+48|0;do if((eS(e)|0)==65536){t=f[e+4>>2]|0;f[m>>2]=f[t>>2];v=m+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[t+8>>2];f[m+12>>2]=f[t+12>>2];f[m+16>>2]=f[t+16>>2];f[m+20>>2]=f[t+20>>2];f[m+24>>2]=f[t+24>>2];f[m+28>>2]=f[t+28>>2];f[m+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[m+36>>2]=y;z=m+40|0;f[z>>2]=x;x=m+48|0;A=m+44|0;f[A>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];B=z;break}else{f[v>>2]=0;U$(m,t);B=z;break}}else{bS(m,e,-1);B=m+40|0}while(0);e=f[g>>2]|0;z=g+4|0;t=f[z>>2]|0;v=f[B>>2]|0;w=f[v+4>>2]|0;x=f[v>>2]|0;v=(e|0)==-1?(w|0)/2|0:e;e=(t|0)==-1?(x|0)/2|0:t;if(!((v|0)>-1&(v|0)<(w|0))){C=$Xc(64)|0;f[l>>2]=C;D=l+8|0;f[D>>2]=-2147483584;E=l+4|0;f[E>>2]=52;F=C;G=362293;H=F+52|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=C+52|0;b[I>>0]=0;vM(-215,l,362346,362362,363)}if((e|0)<0|(e|0)>=(x|0)){C=$Xc(64)|0;f[l>>2]=C;D=l+8|0;f[D>>2]=-2147483584;E=l+4|0;f[E>>2]=52;F=C;G=362293;H=F+52|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=C+52|0;b[I>>0]=0;vM(-215,l,362346,362362,363)}f[g>>2]=v;f[z>>2]=e;f[l>>2]=0;e=l+4|0;f[e>>2]=0;f[n>>2]=0;v=n+4|0;f[v>>2]=0;f[o>>2]=0;I=o+4|0;f[I>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;C=jP(q)|0;E=m+8|0;D=f[m+12>>2]|0;if((C|0)==(Y(D,f[E>>2]|0)|0)){dya(q,c,d,D,f[g>>2]|0);D=f[q>>2]|0;C=f[q+4>>2]|0;x=(C|0)==0;if(!x)TXc(C);f[l>>2]=D;D=f[e>>2]|0;f[e>>2]=C;if(D|0)UXc(D);if(!x)UXc(C);kza(q,c,d,f[E>>2]|0,f[z>>2]|0);E=f[q>>2]|0;C=f[q+4>>2]|0;x=(C|0)==0;if(!x)TXc(C);f[n>>2]=E;E=f[v>>2]|0;f[v>>2]=C;if(E|0)UXc(E);if(!x)UXc(C)}else{f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;f[s>>2]=f[g>>2];f[s+4>>2]=f[z>>2];rAa(q,c,d,r,s);s=f[q>>2]|0;z=f[q+4>>2]|0;g=(z|0)==0;if(!g)TXc(z);f[o>>2]=s;s=f[I>>2]|0;f[I>>2]=z;if(s|0)UXc(s);if(!g)UXc(z)}J=+p[j>>3];p[q>>3]=J;K=+p[j+8>>3];z=q+8|0;p[z>>3]=K;L=+p[j+16>>3];g=q+16|0;p[g>>3]=L;M=+p[j+24>>3];j=q+24|0;p[j>>3]=M;do if(((h|0)==0|(i|0)==0)&J==1797693134862315708145274.0e284&K==1797693134862315708145274.0e284?!(M!=1797693134862315708145274.0e284|L!=1797693134862315708145274.0e284):0){s=d&7;C=(s|2|0)==2;x=(s|0)==3;E=(s|0)==5;s=d&255;switch(s&7){case 0:case 2:case 3:case 5:case 6:break;default:{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;D=$Xc(96)|0;f[r>>2]=D;f[r+8>>2]=-2147483552;f[r+4>>2]=90;F=D;G=364025;H=F+90|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[D+90>>0]=0;vM(-215,r,364116,358749,1004)}}if(c|0){N=C?0.0:x?-32768.0:E?-3402823466385288598117041.0e14:-1797693134862315708145274.0e284;p[q>>3]=N;p[z>>3]=N;p[g>>3]=N;p[j>>3]=N;break}switch(s&7){case 0:{O=255.0;break}case 2:{O=65535.0;break}default:O=x?32767.0:E?3402823466385288598117041.0e14:1797693134862315708145274.0e284}p[q>>3]=O;p[z>>3]=O;p[g>>3]=O;p[j>>3]=O}while(0);j=$Xc(212)|0;f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=52040;g=j+12|0;Zba(g,o,l,n,d,d,d,h,i,q);f[a>>2]=g;f[a+4>>2]=j;j=f[I>>2]|0;if(j|0)UXc(j);j=f[v>>2]|0;if(j|0)UXc(j);j=f[e>>2]|0;if(j|0)UXc(j);j=m+36|0;e=f[j>>2]|0;if(e|0?(v=e+12|0,e=f[v>>2]|0,f[v>>2]=e+-1,(e|0)==1):0)V$(m);f[j>>2]=0;j=m+16|0;e=m+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[e>>2]|0)>0){j=f[B>>2]|0;B=0;do{f[j+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[e>>2]|0))}e=f[m+44>>2]|0;if((e|0)==(m+48|0)){u=k;return}wL(e);u=k;return}function TBa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+16|0;h=g;if(c>>>0>=3){i=$Xc(80)|0;f[h>>2]=i;f[h+8>>2]=-2147483568;f[h+4>>2]=69;j=i;k=364139;l=j+69|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+69>>0]=0;vM(-215,h,364209,358749,1028)}i=f[e>>2]|0;m=e+4|0;n=f[m>>2]|0;o=f[d>>2]|0;p=d+4|0;q=f[p>>2]|0;r=(o|0)/2|0;s=(i|0)==-1?r:i;i=(n|0)==-1?(q|0)/2|0:n;if(!((s|0)>-1&(s|0)<(o|0))){t=$Xc(64)|0;f[h>>2]=t;v=h+8|0;f[v>>2]=-2147483584;w=h+4|0;f[w>>2]=52;j=t;k=362293;l=j+52|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));x=t+52|0;b[x>>0]=0;vM(-215,h,362346,362362,363)}if((i|0)<0|(i|0)>=(q|0)){t=$Xc(64)|0;f[h>>2]=t;v=h+8|0;f[v>>2]=-2147483584;w=h+4|0;f[w>>2]=52;j=t;k=362293;l=j+52|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));x=t+52|0;b[x>>0]=0;vM(-215,h,362346,362362,363)}f[e>>2]=s;f[m>>2]=i;i=f[p>>2]|0;s=(o|0)==1&(i|0)==1?0:c;if((s|0)==2){c=(i|0)/2|0;y=+(c|0);z=(i+1|0)>>>0>2?1.0/(y*y):0.0;A=r;B=c}else{z=0.0;A=0;B=0}f[a>>2]=1124007936;c=a+8|0;r=a+40|0;j=a+4|0;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[r>>2]=c;c=a+48|0;r=a+44|0;f[r>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[h>>2]=i;f[h+4>>2]=o;S$(a,2,h,0);if((f[p>>2]|0)<=0){u=g;return}h=a+16|0;y=+(A|0);a=Y(B,B)|0;if(!s){o=0;i=f[d>>2]|0;while(1){c=(f[h>>2]|0)+(Y(f[f[r>>2]>>2]|0,o)|0)|0;if((i|0)>0){g1c(c|0,1,i|0)|0;C=i;D=f[d>>2]|0}else{C=0;D=i}if((C|0)<(D|0)){j=C;do{b[c+j>>0]=0;j=j+1|0;l=f[d>>2]|0}while((j|0)<(l|0));E=l}else E=D;o=o+1|0;if((o|0)>=(f[p>>2]|0))break;else i=E}u=g;return}E=(s|0)==1;s=0;do{i=f[h>>2]|0;o=Y(f[f[r>>2]>>2]|0,s)|0;D=i+o|0;do if(E)if((s|0)!=(f[m>>2]|0)){C=f[e>>2]|0;j=C+1|0;if((C|0)>0){F=j;G=C;H=23;break}else{I=0;J=j;H=24;break}}else{I=0;J=f[d>>2]|0;H=24;break}else{j=s-B|0;if((((j|0)>-1?j:0-j|0)|0)<=(B|0)){C=zLc(y*+M(+(z*+(a-(Y(j,j)|0)|0))))|0;j=A-C|0;c=C+A|0;C=f[d>>2]|0;l=(C|0)<=(c|0)?C:c+1|0;if((j|0)>0){F=l;G=j;H=23}else{I=0;J=l;H=24}}else K=0}while(0);if((H|0)==23){H=0;g1c(D|0,0,G|0)|0;I=G;J=F;H=24}if((H|0)==24){H=0;if((J|0)>(I|0)){g1c(i+(I+o)|0,1,J-I|0)|0;K=J}else K=I}if((K|0)<(f[d>>2]|0)){l=K;do{b[D+l>>0]=0;l=l+1|0}while((l|0)<(f[d>>2]|0))}s=s+1|0}while((s|0)<(f[p>>2]|0));u=g;return}function UBa(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y,z,A,B,C,D,E){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;var F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0;E=u;u=u+224|0;F=E+168|0;G=E+160|0;H=E+152|0;I=E+96|0;J=E+88|0;K=E;L=E+80|0;M=E+72|0;N=E+64|0;O=E+56|0;f[G>>2]=x;f[G+4>>2]=y;cM(F,G,t,v,w);P=+p[C>>3];Q=+p[C+8>>3];R=+p[C+16>>3];S=+p[C+24>>3];f[I+8>>2]=0;f[I+12>>2]=0;f[I>>2]=16842752;f[I+4>>2]=F;f[J>>2]=z;f[J+4>>2]=A;p[K>>3]=P;p[K+8>>3]=Q;p[K+16>>3]=R;p[K+24>>3]=S;SBa(H,a,b,I,J,B,B,K);f[L>>2]=i;f[L+4>>2]=j;cM(I,L,b,d,e);f[M>>2]=i;f[M+4>>2]=j;cM(K,M,c,g,h);f[N>>2]=m;f[N+4>>2]=n;f[O>>2]=k;f[O+4>>2]=l;l=f[H>>2]|0;gi[f[(f[l>>2]|0)+20>>2]&255](l,I,K,O,N);f[N>>2]=r;f[N+4>>2]=s;f[O>>2]=o;f[O+4>>2]=q;if((D|0)>1){q=1;do{gi[f[(f[l>>2]|0)+20>>2]&255](l,K,K,O,N);q=q+1|0}while((q|0)<(D|0))}D=K+36|0;q=f[D>>2]|0;if(q|0?(N=q+12|0,q=f[N>>2]|0,f[N>>2]=q+-1,(q|0)==1):0)V$(K);f[D>>2]=0;D=K+16|0;q=K+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[q>>2]|0)>0){D=f[K+40>>2]|0;N=0;do{f[D+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[q>>2]|0))}q=f[K+44>>2]|0;if((q|0)!=(K+48|0))wL(q);q=I+36|0;K=f[q>>2]|0;if(K|0?(N=K+12|0,K=f[N>>2]|0,f[N>>2]=K+-1,(K|0)==1):0)V$(I);f[q>>2]=0;q=I+16|0;K=I+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[K>>2]|0)>0){q=f[I+40>>2]|0;N=0;do{f[q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[I+44>>2]|0;if((K|0)!=(I+48|0))wL(K);K=f[H+4>>2]|0;if(K|0)UXc(K);K=F+36|0;H=f[K>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)V$(F);f[K>>2]=0;K=F+16|0;H=F+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[H>>2]|0)>0){K=f[F+40>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[F+44>>2]|0;if((H|0)==(F+48|0)){u=E;return}wL(H);u=E;return}function VBa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];WBa(0,a,b,c,j,e,g,h);u=i;return}function WBa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=u;u=u+240|0;l=k+184|0;m=k+128|0;n=k+120|0;o=k+112|0;p=k+104|0;q=k+96|0;r=k+32|0;s=k+40|0;t=k+24|0;v=k+16|0;w=k+8|0;x=k;do if((eS(e)|0)==65536){y=f[e+4>>2]|0;f[m>>2]=f[y>>2];z=m+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=m+8|0;f[B>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];C=m+16|0;f[C>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];D=f[y+36>>2]|0;f[m+36>>2]=D;f[m+40>>2]=B;B=m+48|0;E=m+44|0;f[E>>2]=B;f[B>>2]=0;f[m+52>>2]=0;if(D|0){B=D+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];F=C;break}else{f[z>>2]=0;U$(m,y);F=C;break}}else{bS(m,e,-1);F=m+16|0}while(0);e=(f[F>>2]|0)==0;if(!e){C=f[m+4>>2]|0;if((C|0)<3)G=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{y=f[m+40>>2]|0;z=0;A=1;while(1){B=Y(f[y+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(C|0)){G=B;break}else A=B}}if(!((C|0)==0|(G|0)==0)){G=f[m+40>>2]|0;H=f[G+4>>2]|0;I=f[G>>2]|0}else{H=3;I=3}}else{H=3;I=3}G=f[g>>2]|0;C=g+4|0;A=f[C>>2]|0;z=(G|0)==-1?(H|0)/2|0:G;G=(A|0)==-1?(I|0)/2|0:A;if(!((z|0)>-1&(z|0)<(H|0))){J=$Xc(64)|0;f[l>>2]=J;K=l+8|0;f[K>>2]=-2147483584;L=l+4|0;f[L>>2]=52;M=J;N=362293;O=M+52|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));P=J+52|0;b[P>>0]=0;vM(-215,l,362346,362362,363)}if((G|0)<0|(G|0)>=(I|0)){J=$Xc(64)|0;f[l>>2]=J;K=l+8|0;f[K>>2]=-2147483584;L=l+4|0;f[L>>2]=52;M=J;N=362293;O=M+52|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));P=J+52|0;b[P>>0]=0;vM(-215,l,362346,362362,363)}f[g>>2]=z;f[C>>2]=G;if((h|0)!=0?(G=m+8|0,z=m+12|0,P=Y(f[z>>2]|0,f[G>>2]|0)|0,(P|0)!=1):0){if(!e){e=m+4|0;J=f[e>>2]|0;if((J|0)<3)Q=P;else{P=f[m+40>>2]|0;N=0;M=1;while(1){O=Y(f[P+(N<<2)>>2]|0,M)|0;N=N+1|0;if((N|0)==(J|0)){Q=O;break}else M=O}}if(!((J|0)==0|(Q|0)==0))if((h|0)>1?(f[l+8>>2]=0,f[l+12>>2]=0,f[l>>2]=16842752,f[l+4>>2]=m,Q=jP(l)|0,(Q|0)==(Y(f[z>>2]|0,f[G>>2]|0)|0)):0){Q=Y(f[g>>2]|0,h)|0;J=Y(f[C>>2]|0,h)|0;f[g>>2]=Q;f[C>>2]=J;M=h+-1|0;N=(Y(H+-1|0,M)|0)+H|0;H=(Y(I+-1|0,M)|0)+I|0;f[p>>2]=N;f[p+4>>2]=H;f[q>>2]=Q;f[q+4>>2]=J;TBa(l,0,p,q);q=m+36|0;p=f[q>>2]|0;if(p|0?(J=p+12|0,p=f[J>>2]|0,f[J>>2]=p+-1,(p|0)==1):0)V$(m);f[q>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[e>>2]|0)>0){p=f[m+40>>2]|0;J=0;do{f[p+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[e>>2]|0))}f[m>>2]=f[l>>2];J=l+4|0;p=f[J>>2]|0;f[e>>2]=p;e=l+8|0;f[G>>2]=f[e>>2];f[z>>2]=f[l+12>>2];Q=l+16|0;f[F>>2]=f[Q>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];H=l+36|0;f[q>>2]=f[H>>2];q=m+44|0;N=f[q>>2]|0;I=m+48|0;if((N|0)==(I|0))R=p;else{wL(N);f[q>>2]=I;f[m+40>>2]=G;R=f[J>>2]|0}N=l+44|0;if((R|0)<3){R=f[N>>2]|0;f[I>>2]=f[R>>2];f[m+52>>2]=f[R+4>>2];S=R}else{f[q>>2]=f[N>>2];q=l+40|0;f[m+40>>2]=f[q>>2];R=l+48|0;f[N>>2]=R;f[q>>2]=e;S=R}f[l>>2]=1124007936;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;f[J+16>>2]=0;f[J+20>>2]=0;f[J+24>>2]=0;f[J+28>>2]=0;f[H>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((S|0)!=(l+48|0))wL(S);T=1}else T=h;else U=26}else U=26;if((U|0)==26){U=h<<1|1;f[n>>2]=U;f[n+4>>2]=U;f[o>>2]=-1;f[o+4>>2]=-1;TBa(l,0,n,o);o=m+36|0;n=f[o>>2]|0;if(n|0?(U=n+12|0,n=f[U>>2]|0,f[U>>2]=n+-1,(n|0)==1):0)V$(m);f[o>>2]=0;n=m+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[n>>2]|0)>0){U=f[m+40>>2]|0;S=0;do{f[U+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[n>>2]|0))}f[m>>2]=f[l>>2];S=l+4|0;U=f[S>>2]|0;f[n>>2]=U;n=l+8|0;f[G>>2]=f[n>>2];f[z>>2]=f[l+12>>2];Q=l+16|0;f[F>>2]=f[Q>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];H=l+36|0;f[o>>2]=f[H>>2];o=m+44|0;J=f[o>>2]|0;R=m+48|0;if((J|0)==(R|0))V=U;else{wL(J);f[o>>2]=R;f[m+40>>2]=G;V=f[S>>2]|0}J=l+44|0;if((V|0)<3){V=f[J>>2]|0;f[R>>2]=f[V>>2];f[m+52>>2]=f[V+4>>2];W=V}else{f[o>>2]=f[J>>2];o=l+40|0;f[m+40>>2]=f[o>>2];V=l+48|0;f[J>>2]=V;f[o>>2]=n;W=V}f[l>>2]=1124007936;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;f[S+16>>2]=0;f[S+20>>2]=0;f[S+24>>2]=0;f[S+28>>2]=0;f[H>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((W|0)!=(l+48|0))wL(W);f[g>>2]=h;f[C>>2]=h;T=1}do if((eS(c)|0)==65536){h=f[c+4>>2]|0;f[l>>2]=f[h>>2];W=l+4|0;Q=h+4|0;f[W>>2]=f[Q>>2];H=l+8|0;f[H>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];S=f[h+36>>2]|0;f[l+36>>2]=S;V=l+40|0;f[V>>2]=H;H=l+48|0;n=l+44|0;f[n>>2]=H;f[H>>2]=0;f[l+52>>2]=0;if(S|0){H=S+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[Q>>2]|0)<3){Q=f[h+44>>2]|0;H=f[n>>2]|0;f[H>>2]=f[Q>>2];f[H+4>>2]=f[Q+4>>2];X=V;Z=l;break}else{f[W>>2]=0;U$(l,h);X=V;Z=l;break}}else{bS(l,c,-1);X=l+40|0;Z=l}while(0);V=f[X>>2]|0;h=f[V>>2]|0;f[r>>2]=f[V+4>>2];f[r+4>>2]=h;wS(d,r,f[Z>>2]&4095,-1,0,0);do if((eS(d)|0)==65536){r=f[d+4>>2]|0;f[s>>2]=f[r>>2];h=s+4|0;V=r+4|0;f[h>>2]=f[V>>2];W=s+8|0;f[W>>2]=f[r+8>>2];Q=s+12|0;f[Q>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];H=f[r+36>>2]|0;f[s+36>>2]=H;f[s+40>>2]=W;n=s+48|0;S=s+44|0;f[S>>2]=n;f[n>>2]=0;f[s+52>>2]=0;if(H|0){n=H+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[V>>2]|0)<3){V=f[r+44>>2]|0;n=f[S>>2]|0;f[n>>2]=f[V>>2];f[n+4>>2]=f[V+4>>2];_=Q;$=W;break}else{f[h>>2]=0;U$(s,r);_=Q;$=W;break}}else{bS(s,d,-1);_=s+12|0;$=s+8|0}while(0);f[t>>2]=0;W=t+4|0;f[W>>2]=0;Q=l+12|0;r=f[Q>>2]|0;h=l+8|0;V=f[h>>2]|0;f[v>>2]=r;n=v+4|0;f[n>>2]=V;f[w>>2]=0;S=w+4|0;f[S>>2]=0;H=f[_>>2]|0;_=f[$>>2]|0;f[x>>2]=H;$=x+4|0;f[$>>2]=_;o=(i&16|0)!=0;if(o){aa=r;ba=V;ca=r;da=V;ea=0;fa=0;ga=H;ha=_;ia=0;ja=0}else{e0(l,v,t);e0(s,x,w);aa=f[Q>>2]|0;ba=f[h>>2]|0;ca=f[v>>2]|0;da=f[n>>2]|0;ea=f[t>>2]|0;fa=f[W>>2]|0;ga=f[x>>2]|0;ha=f[$>>2]|0;ia=f[w>>2]|0;ja=f[S>>2]|0}S=f[Z>>2]|0;Z=l+16|0;w=l+48|0;$=s+16|0;x=s+48|0;UBa(a,S&4095,f[s>>2]&4095,f[Z>>2]|0,f[w>>2]|0,f[$>>2]|0,f[x>>2]|0,aa,ba,ca,da,ea,fa,ga,ha,ia,ja,f[m>>2]&4095,f[F>>2]|0,f[m+48>>2]|0,f[z>>2]|0,f[G>>2]|0,f[g>>2]|0,f[C>>2]|0,i&-17,j,T,(S&32768|0)!=0&(o^1));o=s+36|0;S=f[o>>2]|0;if(S|0?(T=S+12|0,S=f[T>>2]|0,f[T>>2]=S+-1,(S|0)==1):0)V$(s);f[o>>2]=0;o=s+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[o>>2]|0)>0){$=f[s+40>>2]|0;S=0;do{f[$+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[o>>2]|0))}o=f[s+44>>2]|0;if((o|0)!=(x|0))wL(o);o=l+36|0;x=f[o>>2]|0;if(x|0?(s=x+12|0,x=f[s>>2]|0,f[s>>2]=x+-1,(x|0)==1):0)V$(l);f[o>>2]=0;o=l+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[o>>2]|0)>0){Z=f[X>>2]|0;X=0;do{f[Z+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(w|0))wL(o)}else uS(c,d);d=m+36|0;c=f[d>>2]|0;if(c|0?(o=c+12|0,c=f[o>>2]|0,f[o>>2]=c+-1,(c|0)==1):0)V$(m);f[d>>2]=0;d=m+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[d>>2]|0)>0){F=f[m+40>>2]|0;c=0;do{f[F+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[m+44>>2]|0;if((d|0)==(m+48|0)){u=k;return}wL(d);u=k;return}function XBa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];WBa(1,a,b,c,j,e,g,h);u=i;return}function YBa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;k=u;u=u+816|0;l=k+32|0;m=k+744|0;n=k+680|0;o=k+624|0;q=k+808|0;r=k+800|0;s=k+568|0;t=k+512|0;v=k+736|0;w=k+456|0;x=k+400|0;y=k+344|0;z=k+288|0;A=k;B=k+272|0;C=k+256|0;do if((eS(e)|0)==65536){D=f[e+4>>2]|0;f[o>>2]=f[D>>2];E=o+4|0;F=D+4|0;f[E>>2]=f[F>>2];G=o+8|0;f[G>>2]=f[D+8>>2];f[o+12>>2]=f[D+12>>2];H=o+16|0;f[H>>2]=f[D+16>>2];f[o+20>>2]=f[D+20>>2];f[o+24>>2]=f[D+24>>2];f[o+28>>2]=f[D+28>>2];f[o+32>>2]=f[D+32>>2];I=f[D+36>>2]|0;f[o+36>>2]=I;f[o+40>>2]=G;G=o+48|0;J=o+44|0;f[J>>2]=G;f[G>>2]=0;f[o+52>>2]=0;if(I|0){G=I+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[D+44>>2]|0;G=f[J>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];K=H;break}else{f[E>>2]=0;U$(o,D);K=H;break}}else{bS(o,e,-1);K=o+16|0}while(0);if(f[K>>2]|0){e=f[o+4>>2]|0;if((e|0)<3)L=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{H=f[o+40>>2]|0;D=0;E=1;while(1){F=Y(f[H+(D<<2)>>2]|0,E)|0;D=D+1|0;if((D|0)==(e|0)){L=F;break}else E=F}}if((e|0)==0|(L|0)==0)M=14}else M=14;if((M|0)==14){f[q>>2]=3;f[q+4>>2]=3;f[r>>2]=1;f[r+4>>2]=1;TBa(l,0,q,r);r=o+36|0;q=f[r>>2]|0;if(q|0?(L=q+12|0,q=f[L>>2]|0,f[L>>2]=q+-1,(q|0)==1):0)V$(o);f[r>>2]=0;q=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[q>>2]|0)>0){L=f[o+40>>2]|0;e=0;do{f[L+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[q>>2]|0))}f[o>>2]=f[l>>2];e=l+4|0;L=f[e>>2]|0;f[q>>2]=L;q=l+8|0;E=o+8|0;f[E>>2]=f[q>>2];f[o+12>>2]=f[l+12>>2];D=l+16|0;f[K>>2]=f[D>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];f[o+28>>2]=f[l+28>>2];f[o+32>>2]=f[l+32>>2];H=l+36|0;f[r>>2]=f[H>>2];r=o+44|0;F=f[r>>2]|0;G=o+48|0;if((F|0)==(G|0))N=L;else{wL(F);f[r>>2]=G;f[o+40>>2]=E;N=f[e>>2]|0}E=l+44|0;if((N|0)<3){N=f[E>>2]|0;f[G>>2]=f[N>>2];f[o+52>>2]=f[N+4>>2];O=N}else{f[r>>2]=f[E>>2];r=l+40|0;f[o+40>>2]=f[r>>2];N=l+48|0;f[E>>2]=N;f[r>>2]=q;O=N}f[l>>2]=1124007936;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[H>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((O|0)!=(l+48|0))wL(O)}do if((eS(a)|0)==65536){O=f[a+4>>2]|0;f[s>>2]=f[O>>2];D=s+4|0;H=O+4|0;f[D>>2]=f[H>>2];e=s+8|0;f[e>>2]=f[O+8>>2];f[s+12>>2]=f[O+12>>2];f[s+16>>2]=f[O+16>>2];f[s+20>>2]=f[O+20>>2];f[s+24>>2]=f[O+24>>2];f[s+28>>2]=f[O+28>>2];f[s+32>>2]=f[O+32>>2];N=f[O+36>>2]|0;f[s+36>>2]=N;q=s+40|0;f[q>>2]=e;e=s+48|0;r=s+44|0;f[r>>2]=e;f[e>>2]=0;f[s+52>>2]=0;if(N|0){e=N+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[H>>2]|0)<3){H=f[O+44>>2]|0;e=f[r>>2]|0;f[e>>2]=f[H>>2];f[e+4>>2]=f[H+4>>2];P=q;Q=s;break}else{f[D>>2]=0;U$(s,O);P=q;Q=s;break}}else{bS(s,a,-1);P=s+40|0;Q=s}while(0);f[t>>2]=1124007936;a=t+4|0;q=t+8|0;O=t+40|0;D=a;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[O>>2]=q;e=t+48|0;r=t+44|0;f[r>>2]=e;f[e>>2]=0;f[t+52>>2]=0;N=f[P>>2]|0;E=f[N>>2]|0;f[v>>2]=f[N+4>>2];f[v+4>>2]=E;wS(c,v,f[Q>>2]&4095,-1,0,0);do if((eS(c)|0)==65536){v=f[c+4>>2]|0;f[w>>2]=f[v>>2];E=w+4|0;N=v+4|0;f[E>>2]=f[N>>2];G=w+8|0;f[G>>2]=f[v+8>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];F=f[v+36>>2]|0;f[w+36>>2]=F;f[w+40>>2]=G;G=w+48|0;L=w+44|0;f[L>>2]=G;f[G>>2]=0;f[w+52>>2]=0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[N>>2]|0)<3){N=f[v+44>>2]|0;G=f[L>>2]|0;f[G>>2]=f[N>>2];f[G+4>>2]=f[N+4>>2];break}else{f[E>>2]=0;U$(w,v);break}}else bS(w,c,-1);while(0);a:do switch(d|0){case 0:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;WBa(0,m,n,x,l,h,i,j);break}case 1:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;WBa(1,m,n,x,l,h,i,j);break}case 2:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=g+4|0;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;WBa(0,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=w;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;WBa(1,m,n,x,l,h,i,j);break}case 3:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;v=g+4|0;c=f[v>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;WBa(1,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=w;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=f[v>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=c;WBa(0,m,n,x,l,h,i,j);break}case 4:{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;c=g+4|0;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;WBa(0,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;v=f[c>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=v;WBa(1,m,n,x,l,h,i,j);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=w;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;v=n+8|0;f[v>>2]=0;f[v+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;G1(l,m,n,fT()|0,-1);break}case 5:{v=w+16|0;if((f[s+16>>2]|0)!=(f[v>>2]|0)){c=w+36|0;E=f[c>>2]|0;if(E|0){N=E+12|0;f[N>>2]=(f[N>>2]|0)+1}N=t+36|0;E=f[N>>2]|0;if(E|0?(G=E+12|0,E=f[G>>2]|0,f[G>>2]=E+-1,(E|0)==1):0)V$(t);f[N>>2]=0;E=t+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[a>>2]|0)>0){G=f[O>>2]|0;L=0;do{f[G+(L<<2)>>2]=0;L=L+1|0;R=f[a>>2]|0}while((L|0)<(R|0));f[t>>2]=f[w>>2];if((R|0)<3)M=59;else M=61}else{f[t>>2]=f[w>>2];M=59}if((M|0)==59){L=f[w+4>>2]|0;if((L|0)<3){f[a>>2]=L;f[q>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];L=f[w+44>>2]|0;G=f[r>>2]|0;f[G>>2]=f[L>>2];f[G+4>>2]=f[L+4>>2]}else M=61}if((M|0)==61)U$(t,w);f[E>>2]=f[v>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[N>>2]=f[c>>2]}f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;L=n+8|0;f[L>>2]=0;f[L+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;L=g+4|0;G=f[L>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=G;WBa(0,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;G=n+8|0;f[G>>2]=0;f[G+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;G=f[L>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=G;WBa(1,m,n,x,l,h,i,j);W_(l,s,t);G=f[l>>2]|0;ei[f[(f[G>>2]|0)+12>>2]&511](G,l,w,-1);Zj(l);break}case 6:{G=w+16|0;if((f[s+16>>2]|0)!=(f[G>>2]|0)){L=w+36|0;F=f[L>>2]|0;if(F|0){J=F+12|0;f[J>>2]=(f[J>>2]|0)+1}J=t+36|0;F=f[J>>2]|0;if(F|0?(I=F+12|0,F=f[I>>2]|0,f[I>>2]=F+-1,(F|0)==1):0)V$(t);f[J>>2]=0;F=t+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[a>>2]|0)>0){I=f[O>>2]|0;S=0;do{f[I+(S<<2)>>2]=0;S=S+1|0;T=f[a>>2]|0}while((S|0)<(T|0));f[t>>2]=f[w>>2];if((T|0)<3)M=75;else M=77}else{f[t>>2]=f[w>>2];M=75}if((M|0)==75){S=f[w+4>>2]|0;if((S|0)<3){f[a>>2]=S;f[q>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];S=f[w+44>>2]|0;I=f[r>>2]|0;f[I>>2]=f[S>>2];f[I+4>>2]=f[S+4>>2]}else M=77}if((M|0)==77)U$(t,w);f[F>>2]=f[G>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[J>>2]=f[L>>2]}f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;S=n+8|0;f[S>>2]=0;f[S+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;S=g+4|0;I=f[S>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=I;WBa(1,m,n,x,l,h,i,j);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;I=n+8|0;f[I>>2]=0;f[I+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=t;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=o;I=f[S>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=I;WBa(0,m,n,x,l,h,i,j);W_(l,t,s);I=f[l>>2]|0;ei[f[(f[I>>2]|0)+12>>2]&511](I,l,w,-1);Zj(l);break}case 7:{if(f[Q>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;I=$Xc(32)|0;f[l>>2]=I;f[l+8>>2]=-2147483616;f[l+4>>2]=21;D=I;U=369201;H=D+21|0;do{b[D>>0]=b[U>>0]|0;D=D+1|0;U=U+1|0}while((D|0)<(H|0));b[I+21>>0]=0;vM(-215,l,364231,358749,2113)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=o;if((jP(l)|0)<1){L=l+8|0;f[L>>2]=0;f[L+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=w;jR(s,l);break a}f[m>>2]=1124007936;L=m+4|0;J=m+8|0;G=m+40|0;D=L;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[G>>2]=J;I=m+48|0;F=m+44|0;f[F>>2]=I;f[I>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;S=n+4|0;c=n+8|0;N=n+40|0;D=S;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[N>>2]=c;J=n+48|0;v=n+44|0;f[v>>2]=J;f[J>>2]=0;f[n+52>>2]=0;f[x>>2]=1124007936;E=x+4|0;V=x+8|0;W=x+40|0;D=E;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[W>>2]=V;c=x+48|0;X=x+44|0;f[X>>2]=c;f[c>>2]=0;f[x+52>>2]=0;f[y>>2]=1124007936;Z=y+4|0;_=y+8|0;$=y+40|0;D=Z;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[$>>2]=_;aa=y+48|0;ba=y+44|0;f[ba>>2]=aa;f[aa>>2]=0;f[y+52>>2]=0;h$(l,o,1.0);ca=f[l>>2]|0;ei[f[(f[ca>>2]|0)+12>>2]&511](ca,l,m,-1);Zj(l);h$(l,o,-1.0);ca=f[l>>2]|0;ei[f[(f[ca>>2]|0)+12>>2]&511](ca,l,n,-1);Zj(l);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;if((jP(l)|0)<1){ca=f[P>>2]|0;da=f[ca+4>>2]|0;ea=f[ca>>2]|0;ca=f[Q>>2]&4095;p[A>>3]=255.0;fa=A+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;f[fa+16>>2]=0;f[fa+20>>2]=0;f[z>>2]=1124007936;fa=z+4|0;ga=z+8|0;ha=z+40|0;D=fa;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[ha>>2]=ga;ia=z+48|0;f[z+44>>2]=ia;f[ia>>2]=0;f[z+52>>2]=0;f[l>>2]=ea;f[l+4>>2]=da;S$(z,2,l,ca);lR(z,A)|0;ja=x+36|0;ka=f[ja>>2]|0;if(ka|0?(la=ka+12|0,ka=f[la>>2]|0,f[la>>2]=ka+-1,(ka|0)==1):0)V$(x);f[ja>>2]=0;ka=x+16|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[E>>2]|0)>0){la=f[W>>2]|0;ma=0;do{f[la+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[E>>2]|0))}f[x>>2]=f[z>>2];ma=f[fa>>2]|0;f[E>>2]=ma;f[V>>2]=f[ga>>2];f[x+12>>2]=f[z+12>>2];la=z+16|0;f[ka>>2]=f[la>>2];f[x+20>>2]=f[z+20>>2];f[x+24>>2]=f[z+24>>2];f[x+28>>2]=f[z+28>>2];f[x+32>>2]=f[z+32>>2];ca=z+36|0;f[ja>>2]=f[ca>>2];da=x+44|0;ea=f[da>>2]|0;if((ea|0)==(c|0))na=ma;else{wL(ea);f[da>>2]=c;f[W>>2]=V;na=f[fa>>2]|0}ea=z+44|0;if((na|0)<3){ma=f[ea>>2]|0;f[c>>2]=f[ma>>2];f[x+52>>2]=f[ma+4>>2];oa=ma}else{f[da>>2]=f[ea>>2];f[x+40>>2]=f[ha>>2];f[ea>>2]=ia;f[ha>>2]=ga;oa=ia}f[z>>2]=1124007936;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;f[fa+16>>2]=0;f[fa+20>>2]=0;f[fa+24>>2]=0;f[fa+28>>2]=0;f[ca>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((oa|0)!=(ia|0))wL(oa)}else{f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=s;la=A+8|0;f[la>>2]=0;f[la+4>>2]=0;f[A>>2]=33619968;f[A+4>>2]=x;f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=m;la=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=la;WBa(0,z,A,B,l,h,i,j)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=n;if((jP(l)|0)<1){la=f[P>>2]|0;ca=f[la+4>>2]|0;ea=f[la>>2]|0;la=f[Q>>2]&4095;p[A>>3]=255.0;da=A+8|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;f[da+16>>2]=0;f[da+20>>2]=0;f[z>>2]=1124007936;da=z+4|0;ma=z+8|0;pa=z+40|0;D=da;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[pa>>2]=ma;ia=z+48|0;f[z+44>>2]=ia;f[ia>>2]=0;f[z+52>>2]=0;f[l>>2]=ea;f[l+4>>2]=ca;S$(z,2,l,la);lR(z,A)|0;fa=y+36|0;ga=f[fa>>2]|0;if(ga|0?(ha=ga+12|0,ga=f[ha>>2]|0,f[ha>>2]=ga+-1,(ga|0)==1):0)V$(y);f[fa>>2]=0;ga=y+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[Z>>2]|0)>0){ha=f[$>>2]|0;V=0;do{f[ha+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[Z>>2]|0))}f[y>>2]=f[z>>2];V=f[da>>2]|0;f[Z>>2]=V;f[_>>2]=f[ma>>2];f[y+12>>2]=f[z+12>>2];ha=z+16|0;f[ga>>2]=f[ha>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];f[y+32>>2]=f[z+32>>2];la=z+36|0;f[fa>>2]=f[la>>2];ca=y+44|0;ea=f[ca>>2]|0;if((ea|0)==(aa|0))qa=V;else{wL(ea);f[ca>>2]=aa;f[$>>2]=_;qa=f[da>>2]|0}ea=z+44|0;if((qa|0)<3){V=f[ea>>2]|0;f[aa>>2]=f[V>>2];f[y+52>>2]=f[V+4>>2];ra=V}else{f[ca>>2]=f[ea>>2];f[y+40>>2]=f[pa>>2];f[ea>>2]=ia;f[pa>>2]=ma;ra=ia}f[z>>2]=1124007936;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;f[da+16>>2]=0;f[da+20>>2]=0;f[da+24>>2]=0;f[da+28>>2]=0;f[la>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((ra|0)!=(ia|0))wL(ra)}else{f[z>>2]=1124007936;ha=z+4|0;la=z+8|0;ea=z+40|0;D=ha;H=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(H|0));f[ea>>2]=la;ia=z+48|0;da=z+44|0;f[da>>2]=ia;f[ia>>2]=0;f[z+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=s;ma=A+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[A>>2]=33619968;f[A+4>>2]=z;z1(l,A,fT()|0);f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=z;ma=B+8|0;f[ma>>2]=0;f[ma+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=y;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=n;ma=f[g+4>>2]|0;f[l>>2]=f[g>>2];f[l+4>>2]=ma;WBa(0,A,B,C,l,h,i,j);ma=z+36|0;pa=f[ma>>2]|0;if(pa|0?(_=pa+12|0,pa=f[_>>2]|0,f[_>>2]=pa+-1,(pa|0)==1):0)V$(z);f[ma>>2]=0;ma=z+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ha>>2]|0)>0){ma=f[ea>>2]|0;pa=0;do{f[ma+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[ha>>2]|0))}ha=f[da>>2]|0;if((ha|0)!=(ia|0))wL(ha)}i$(l,x,y);ha=f[l>>2]|0;ei[f[(f[ha>>2]|0)+12>>2]&511](ha,l,w,-1);Zj(l);ha=y+36|0;pa=f[ha>>2]|0;if(pa|0?(ma=pa+12|0,pa=f[ma>>2]|0,f[ma>>2]=pa+-1,(pa|0)==1):0)V$(y);f[ha>>2]=0;ha=y+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[Z>>2]|0)>0){ha=f[$>>2]|0;pa=0;do{f[ha+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[Z>>2]|0))}Z=f[ba>>2]|0;if((Z|0)!=(aa|0))wL(Z);Z=x+36|0;pa=f[Z>>2]|0;if(pa|0?(ha=pa+12|0,pa=f[ha>>2]|0,f[ha>>2]=pa+-1,(pa|0)==1):0)V$(x);f[Z>>2]=0;Z=x+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[E>>2]|0)>0){Z=f[W>>2]|0;pa=0;do{f[Z+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[E>>2]|0))}E=f[X>>2]|0;if((E|0)!=(c|0))wL(E);E=n+36|0;pa=f[E>>2]|0;if(pa|0?(Z=pa+12|0,pa=f[Z>>2]|0,f[Z>>2]=pa+-1,(pa|0)==1):0)V$(n);f[E>>2]=0;E=n+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[S>>2]|0)>0){E=f[N>>2]|0;pa=0;do{f[E+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[S>>2]|0))}S=f[v>>2]|0;if((S|0)!=(J|0))wL(S);S=m+36|0;pa=f[S>>2]|0;do if(pa|0){E=pa+12|0;N=f[E>>2]|0;f[E>>2]=N+-1;if((N|0)!=1)break;V$(m)}while(0);f[S>>2]=0;pa=m+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[L>>2]|0)>0){pa=f[G>>2]|0;J=0;do{f[pa+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[L>>2]|0))}L=f[F>>2]|0;if((L|0)!=(I|0))wL(L);break}default:{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;L=$Xc(32)|0;f[l>>2]=L;f[l+8>>2]=-2147483616;f[l+4>>2]=31;D=L;U=364244;H=D+31|0;do{b[D>>0]=b[U>>0]|0;D=D+1|0;U=U+1|0}while((D|0)<(H|0));b[L+31>>0]=0;vM(-5,l,364231,358749,2141)}}while(0);l=w+36|0;U=f[l>>2]|0;if(U|0?(D=U+12|0,U=f[D>>2]|0,f[D>>2]=U+-1,(U|0)==1):0)V$(w);f[l>>2]=0;l=w+16|0;U=w+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[U>>2]|0)>0){l=f[w+40>>2]|0;D=0;do{f[l+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[U>>2]|0))}U=f[w+44>>2]|0;if((U|0)!=(w+48|0))wL(U);U=t+36|0;w=f[U>>2]|0;if(w|0?(D=w+12|0,w=f[D>>2]|0,f[D>>2]=w+-1,(w|0)==1):0)V$(t);f[U>>2]=0;U=t+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[a>>2]|0)>0){U=f[O>>2]|0;O=0;do{f[U+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(e|0))wL(a);a=s+36|0;e=f[a>>2]|0;if(e|0?(r=e+12|0,e=f[r>>2]|0,f[r>>2]=e+-1,(e|0)==1):0)V$(s);f[a>>2]=0;a=s+16|0;e=s+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[e>>2]|0)>0){a=f[P>>2]|0;P=0;do{f[a+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[e>>2]|0))}e=f[s+44>>2]|0;if((e|0)!=(s+48|0))wL(e);e=o+36|0;s=f[e>>2]|0;if(s|0?(P=s+12|0,s=f[P>>2]|0,f[P>>2]=s+-1,(s|0)==1):0)V$(o);f[e>>2]=0;e=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[e>>2]|0)>0){K=f[o+40>>2]|0;s=0;do{f[K+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[e>>2]|0))}e=f[o+44>>2]|0;if((e|0)==(o+48|0)){u=k;return}wL(e);u=k;return}function ZBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+128|0;h=g+64|0;i=g;j=g+8|0;do if((eS(a)|0)==65536){k=f[a+4>>2]|0;f[h>>2]=f[k>>2];l=h+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=h+8|0;f[n>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[h+36>>2]=o;p=h+40|0;f[p>>2]=n;n=h+48|0;q=h+44|0;f[q>>2]=n;f[n>>2]=0;f[h+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];r=p;break}else{f[l>>2]=0;U$(h,k);r=p;break}}else{bS(h,a,-1);r=h+40|0}while(0);a=f[r>>2]|0;p=f[a>>2]|0;f[i>>2]=f[a+4>>2];f[i+4>>2]=p;wS(b,i,5,-1,0,0);do if((eS(b)|0)==65536){i=f[b+4>>2]|0;f[j>>2]=f[i>>2];p=j+4|0;a=i+4|0;f[p>>2]=f[a>>2];k=j+8|0;f[k>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];l=f[i+36>>2]|0;f[j+36>>2]=l;f[j+40>>2]=k;k=j+48|0;m=j+44|0;f[m>>2]=k;f[k>>2]=0;f[j+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[a>>2]|0)<3){a=f[i+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[a>>2];f[k+4>>2]=f[a+4>>2];break}else{f[p>>2]=0;U$(j,i);break}}else bS(j,b,-1);while(0);_Ba(h,j,c,d,0,0.0,e);e=j+36|0;d=f[e>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(j);f[e>>2]=0;e=j+16|0;d=j+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[j+40>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[j+44>>2]|0;if((d|0)!=(j+48|0))wL(d);d=h+36|0;j=f[d>>2]|0;if(j|0?(c=j+12|0,j=f[c>>2]|0,f[c>>2]=j+-1,(j|0)==1):0)V$(h);f[d>>2]=0;d=h+16|0;j=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[r>>2]|0;r=0;do{f[d+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[j>>2]|0))}j=f[h+44>>2]|0;if((j|0)==(h+48|0)){u=g;return}wL(j);u=g;return}function _Ba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0;j=u;u=u+224|0;k=j+200|0;l=j+144|0;m=j+88|0;o=j+24|0;p=j;q=j+80|0;r=j+16|0;s=f[a>>2]|0;t=(e|0)>0;v=+(d|0)*(t?+(1<<e+-1|0):4.0);w=(e|0)<0?v*2.0:v;v=1.0/((s&7|0)==0?w*255.0:w);switch(s&4095){case 5:case 0:break;default:{s=$Xc(48)|0;f[k>>2]=s;f[k+8>>2]=-2147483600;f[k+4>>2]=47;x=s;y=364276;z=x+47|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[s+47>>0]=0;vM(-215,k,364324,364344,265)}}f[l>>2]=1124007936;s=l+4|0;y=l+8|0;A=l+40|0;x=s;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[A>>2]=y;y=l+48|0;B=l+44|0;f[B>>2]=y;f[y>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;C=m+4|0;D=m+8|0;E=m+40|0;x=C;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[E>>2]=D;D=m+48|0;F=m+44|0;f[F>>2]=D;f[D>>2]=0;f[m+52>>2]=0;if(t){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;soa(k,o,5,1,0,e,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;soa(k,o,5,0,1,e,v,0.0,i)}else{f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;toa(k,o,5,1,0,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;toa(k,o,5,0,1,v,0.0,i)}e=f[a+40>>2]|0;a=f[e+4>>2]|0;t=f[e>>2]|0;f[o>>2]=1124007936;e=o+4|0;G=o+8|0;H=o+40|0;x=e;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[H>>2]=G;G=o+48|0;x=o+44|0;f[x>>2]=G;f[G>>2]=0;f[o+52>>2]=0;f[k>>2]=t;f[k+4>>2]=a;S$(o,2,k,21);if((t|0)>0?(z=f[o+16>>2]|0,I=f[f[x>>2]>>2]|0,J=f[l+16>>2]|0,K=f[f[B>>2]>>2]|0,N=f[m+16>>2]|0,O=f[f[F>>2]>>2]|0,(a|0)>0):0){P=0;do{Q=z+(Y(I,P)|0)|0;R=J+(Y(K,P)|0)|0;S=N+(Y(O,P)|0)|0;T=0;do{v=+n[R+(T<<2)>>2];w=+n[S+(T<<2)>>2];U=T*3|0;n[Q+(U<<2)>>2]=v*v;n[Q+(U+1<<2)>>2]=v*w;n[Q+(U+2<<2)>>2]=w*w;T=T+1|0}while((T|0)!=(a|0));P=P+1|0}while((P|0)!=(t|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=o;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=o;t=f[o>>2]&7;f[q>>2]=d;f[q+4>>2]=d;f[r>>2]=-1;f[r+4>>2]=-1;Uua(k,p,t,q,r,0,i);a:do switch(g|0){case 0:{i=f[c+16>>2]|0;r=f[c+44>>2]|0;q=f[H>>2]|0;t=f[q+4>>2]|0;p=f[q>>2]|0;if(f[o>>2]&16384){q=(f[c>>2]&16384|0)!=0;k=Y(q?p:1,t)|0;if(q){V=k;W=1}else{X=k;Z=14}}else{X=t;Z=14}if((Z|0)==14)if((p|0)>0){V=X;W=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;k=f[r>>2]|0;if((V|0)>0){r=0;do{q=p+(Y(r,t)|0)|0;d=i+(Y(r,k)|0)|0;P=0;do{a=P*3|0;w=+n[q+(a<<2)>>2]*.5;v=+n[q+(a+1<<2)>>2];_=+n[q+(a+2<<2)>>2]*.5;$=w-_;aa=w+_-+M(+(v*v+$*$));n[d+(P<<2)>>2]=aa;P=P+1|0}while((P|0)!=(V|0));r=r+1|0}while((r|0)!=(W|0))}break}case 1:{r=f[c+16>>2]|0;k=f[c+44>>2]|0;i=f[H>>2]|0;t=f[i+4>>2]|0;p=f[i>>2]|0;if(f[o>>2]&16384){i=(f[c>>2]&16384|0)!=0;P=Y(i?p:1,t)|0;if(i){ba=P;ca=1}else{da=P;Z=21}}else{da=t;Z=21}if((Z|0)==21)if((p|0)>0){ba=da;ca=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;P=f[k>>2]|0;if((ba|0)>0){k=0;do{i=p+(Y(k,t)|0)|0;d=r+(Y(k,P)|0)|0;q=0;do{a=q*3|0;aa=+n[i+(a<<2)>>2];$=+n[i+(a+1<<2)>>2];v=+n[i+(a+2<<2)>>2];_=aa+v;n[d+(q<<2)>>2]=aa*v-$*$-_*(_*h);q=q+1|0}while((q|0)!=(ba|0));k=k+1|0}while((k|0)!=(ca|0))}break}case 2:{k=f[c+16>>2]|0;P=f[c+44>>2]|0;r=f[H>>2]|0;t=f[r+4>>2]|0;p=f[r>>2]|0;if(f[o>>2]&16384){r=(f[c>>2]&16384|0)!=0;q=Y(r?p:1,t)|0;if(r){ea=q;fa=1}else{ga=q;Z=28}}else{ga=t;Z=28}if((Z|0)==28)if((p|0)>0){ea=ga;fa=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;q=f[P>>2]|0;P=(ea|0)>0;r=0;do{d=p+(Y(r,t)|0)|0;i=k+(Y(r,q)|0)|0;if(P){a=0;do{O=a*3|0;_=+n[d+(O<<2)>>2];$=+n[d+(O+1<<2)>>2];v=$;aa=+n[d+(O+2<<2)>>2];w=(_+aa)*.5;ha=_-aa;ia=+M(+(v*v+ha*ha*.25));ha=ia+w;ja=w-ia;ia=ha-_;w=+L(+$);if(w+ +L(+ia)<.0001){$=ha-aa;ka=w+ +L(+$);la=1.0/(ka+1.1920928955078125e-07);if(ka<.0001){ma=v*la;na=$*la}else{ma=v;na=$}}else{ma=ia;na=v}ia=1.0/+M(+(na*na+ma*ma+2.220446049250313e-16));O=a*6|0;n[i+(O<<2)>>2]=ha;n[i+(O+2<<2)>>2]=na*ia;n[i+(O+3<<2)>>2]=ma*ia;ia=ja-_;if(w+ +L(+ia)<.0001){_=ja-aa;aa=w+ +L(+_);w=1.0/(aa+1.1920928955078125e-07);if(aa<.0001){oa=v*w;pa=_*w}else{oa=v;pa=_}}else{oa=ia;pa=v}v=1.0/+M(+(pa*pa+oa*oa+2.220446049250313e-16));n[i+((O|1)<<2)>>2]=ja;n[i+(O+4<<2)>>2]=pa*v;n[i+(O+5<<2)>>2]=oa*v;a=a+1|0}while((a|0)!=(ea|0))}r=r+1|0}while((r|0)!=(fa|0));break}default:{}}while(0);fa=o+36|0;ea=f[fa>>2]|0;if(ea|0?(ga=ea+12|0,ea=f[ga>>2]|0,f[ga>>2]=ea+-1,(ea|0)==1):0)V$(o);f[fa>>2]=0;fa=o+16|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[e>>2]|0)>0){fa=f[H>>2]|0;H=0;do{f[fa+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[e>>2]|0))}e=f[x>>2]|0;if((e|0)!=(G|0))wL(e);e=m+36|0;G=f[e>>2]|0;if(G|0?(x=G+12|0,G=f[x>>2]|0,f[x>>2]=G+-1,(G|0)==1):0)V$(m);f[e>>2]=0;e=m+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[C>>2]|0)>0){e=f[E>>2]|0;E=0;do{f[e+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[F>>2]|0;if((C|0)!=(D|0))wL(C);C=l+36|0;D=f[C>>2]|0;if(D|0?(F=D+12|0,D=f[F>>2]|0,f[F>>2]=D+-1,(D|0)==1):0)V$(l);f[C>>2]=0;C=l+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[s>>2]|0)>0){C=f[A>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[s>>2]|0))}s=f[B>>2]|0;if((s|0)==(y|0)){u=j;return}wL(s);u=j;return}function $Ba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+128|0;i=h+64|0;j=h;k=h+8|0;do if((eS(a)|0)==65536){l=f[a+4>>2]|0;f[i>>2]=f[l>>2];m=i+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=i+8|0;f[o>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[i+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[i+36>>2]=p;q=i+40|0;f[q>>2]=o;o=i+48|0;r=i+44|0;f[r>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;U$(i,l);s=q;break}}else{bS(i,a,-1);s=i+40|0}while(0);a=f[s>>2]|0;q=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=q;wS(b,j,5,-1,0,0);do if((eS(b)|0)==65536){j=f[b+4>>2]|0;f[k>>2]=f[j>>2];q=k+4|0;a=j+4|0;f[q>>2]=f[a>>2];l=k+8|0;f[l>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];m=f[j+36>>2]|0;f[k+36>>2]=m;f[k+40>>2]=l;l=k+48|0;n=k+44|0;f[n>>2]=l;f[l>>2]=0;f[k+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[a>>2];f[l+4>>2]=f[a+4>>2];break}else{f[q>>2]=0;U$(k,j);break}}else bS(k,b,-1);while(0);_Ba(i,k,c,d,1,e,g);g=k+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(k);f[g>>2]=0;g=k+16|0;d=k+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[k+40>>2]|0;c=0;do{f[g+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))wL(d);d=i+36|0;k=f[d>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)V$(i);f[d>>2]=0;d=i+16|0;k=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[s>>2]|0;s=0;do{f[d+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)==(i+48|0)){u=h;return}wL(k);u=h;return}function aCa(){var a=0,b=0,c=0,d=0,e=0;a=u;u=u+32|0;b=a+8|0;c=a;d=a+16|0;e=530048;f[e>>2]=1149814285;f[e+4>>2]=1071277473;e=530056;f[e>>2]=963447064;f[e+4>>2]=1071047319;e=530064;f[e>>2]=-768008872;f[e+4>>2]=1070012441;e=530072;f[e>>2]=-1494786058;f[e+4>>2]=1070282957;e=530080;f[e>>2]=963447064;f[e+4>>2]=1072095895;e=530088;f[e>>2]=-423037099;f[e+4>>2]=1068661162;e=530096;f[e>>2]=-959598773;f[e+4>>2]=1066650698;e=530104;f[e>>2]=-1259765448;f[e+4>>2]=1069450094;e=530112;f[e>>2]=1947784849;f[e+4>>2]=1072588866;e=530120;f[e>>2]=1090715535;f[e+4>>2]=1074392192;e=530128;f[e>>2]=-1724858866;f[e+4>>2]=-1074227158;e=530136;f[e>>2]=1480217529;f[e+4>>2]=-1075845121;e=530144;f[e>>2]=682521843;f[e+4>>2]=-1074854875;e=530152;f[e>>2]=596210180;f[e+4>>2]=1073611791;e=530160;f[e>>2]=-102254581;f[e+4>>2]=1067796179;e=530168;f[e>>2]=137164076;f[e+4>>2]=1068269029;e=530176;f[e>>2]=-1107483087;f[e+4>>2]=-1077273068;e=530184;f[e>>2]=-261408890;f[e+4>>2]=1072753342;e=530192;f[e>>2]=-1282855192;f[e+4>>2]=1072589346;e=530200;f[e>>2]=0;f[e+4>>2]=1072693248;e=530208;f[e>>2]=1349925401;f[e+4>>2]=1072786313;CGc(b,2048);CGc(c,3);JGc(d,b,c);f[222200]=f[d>>2];CGc(888804,-134);CGc(888808,220);HGc(888812,888808,888804);CGc(888816,-140);CGc(888820,122);HGc(888824,888820,888816);NGc(b,809);NGc(c,2e4);_Gc(530216,b,c);NGc(b,7827);NGc(c,25e5);_Gc(530224,b,c);NGc(b,323);NGc(c,25);_Gc(530232,b,c);NGc(b,12);NGc(c,5);_Gc(530240,b,c);NGc(b,11);NGc(c,200);_Gc(530248,b,c);CGc(b,216);CGc(c,24389);JGc(888828,b,c);CGc(b,841);CGc(c,108);JGc(888832,b,c);CGc(b,16);CGc(c,116);JGc(888836,b,c);CGc(888840,255);u=a;return}function bCa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;k=u;u=u+80|0;l=k+72|0;m=k+40|0;o=k;switch(h|0){case 0:{f[o>>2]=i;h=o+4|0;q=h;r=77980;s=q+36|0;do{f[q>>2]=f[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));if(!j){f[h>>2]=739;f[o+12>>2]=1689;f[o+16>>2]=296;f[o+24>>2]=871;f[o+28>>2]=3892;f[o+36>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=78024;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}case 2:{f[o>>2]=i;h=o+4|0;q=h;r=77980;s=q+36|0;do{f[q>>2]=f[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));if(!j){f[h>>2]=739;f[o+12>>2]=1689;f[o+16>>2]=296;f[o+24>>2]=871;f[o+28>>2]=3892;f[o+36>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=78044;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}default:{f[o>>2]=i;t=+p[66256];i=o+4|0;n[i>>2]=t;n[o+8>>2]=+p[66257];v=+p[66258];h=o+12|0;n[h>>2]=v;w=+p[66259];r=o+16|0;n[r>>2]=w;n[o+20>>2]=+p[66260];x=+p[66261];q=o+24|0;n[q>>2]=x;y=+p[66262];s=o+28|0;n[s>>2]=y;n[o+32>>2]=+p[66263];z=+p[66264];A=o+36|0;n[A>>2]=z;if(!j){n[i>>2]=v;n[h>>2]=t;n[r>>2]=x;n[q>>2]=w;n[s>>2]=z;n[A>>2]=y}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=78064;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}}}function cCa(a){a=a|0;cYc(a);return}function dCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>=(d|0))return;b=f[a+8>>2]|0;e=f[a+16>>2]|0;g=a+24|0;h=f[a+20>>2]|0;i=h*3|0;if((h|0)<=0){h=c;do h=h+1|0;while((h|0)<(d|0));return}h=(f[a+12>>2]|0)+(Y(e,c)|0)|0;j=h;h=(f[a+4>>2]|0)+(Y(b,c)|0)|0;a=c;while(1){c=f[g>>2]|0;k=f[c>>2]|0;l=+n[c+4>>2];m=+n[c+8>>2];o=+n[c+12>>2];p=+n[c+16>>2];q=+n[c+20>>2];r=+n[c+24>>2];s=+n[c+28>>2];t=+n[c+32>>2];u=+n[c+36>>2];c=0;v=h;while(1){w=+n[v>>2];x=+n[v+4>>2];y=+n[v+8>>2];n[j+(c<<2)>>2]=l*w+m*x+o*y;n[j+(c+1<<2)>>2]=p*w+q*x+r*y;n[j+(c+2<<2)>>2]=s*w+t*x+u*y;c=c+3|0;if((c|0)>=(i|0))break;else v=v+(k<<2)|0}a=a+1|0;if((a|0)>=(d|0))break;else{j=j+e|0;h=h+b|0}}return}function eCa(a){a=a|0;cYc(a);return}function fCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){gCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function gCa(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=b}else return;while(1){b=j[s>>1]|0;e=Y(b,h)|0;t=j[s+2>>1]|0;u=Y(t,i)|0;v=j[s+4>>1]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(b,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(b,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;d[c+(r<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[c+(r+1<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[c+(r+2<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+(g<<1)|0}return}function hCa(a){a=a|0;cYc(a);return}function iCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){jCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function jCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=c}else return;while(1){c=h[s>>0]|0;e=Y(c,i)|0;t=h[s+1>>0]|0;u=Y(t,j)|0;v=h[s+2>>0]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(c,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(c,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;b[d+r>>0]=w>>>0<256?w:(w|0)>0?255:0;b[d+(r+1)>>0]=u>>>0<256?u:(u|0)>0?255:0;b[d+(r+2)>>0]=e>>>0<256?e:(e|0)>0?255:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+g|0}return}function kCa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0;k=u;u=u+80|0;l=k+72|0;m=k+44|0;o=k;q=j?2:0;switch(h|0){case 0:{f[o>>2]=i;f[o+4>>2]=q;h=o+8|0;r=h;s=78076;t=r+36|0;do{f[r>>2]=f[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));if(!j){f[h>>2]=228;f[o+32>>2]=13273;f[o+12>>2]=-836;f[o+36>>2]=-6296;f[o+16>>2]=4331;f[o+40>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=78120;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}case 2:{f[o>>2]=i;f[o+4>>2]=q;h=o+8|0;r=h;s=78076;t=r+36|0;do{f[r>>2]=f[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));if(!j){f[h>>2]=228;f[o+32>>2]=13273;f[o+12>>2]=-836;f[o+36>>2]=-6296;f[o+16>>2]=4331;f[o+40>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=78140;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}default:{f[o>>2]=i;f[o+4>>2]=q;v=+p[66265];q=o+8|0;n[q>>2]=v;w=+p[66266];i=o+12|0;n[i>>2]=w;x=+p[66267];h=o+16|0;n[h>>2]=x;n[o+20>>2]=+p[66268];n[o+24>>2]=+p[66269];n[o+28>>2]=+p[66270];y=+p[66271];s=o+32|0;n[s>>2]=y;z=+p[66272];r=o+36|0;n[r>>2]=z;A=+p[66273];t=o+40|0;n[t>>2]=A;if(!j){n[q>>2]=y;n[s>>2]=v;n[i>>2]=z;n[r>>2]=w;n[h>>2]=A;n[t>>2]=x}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=78160;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;h3(l,m,+(Y(g,e)|0)*.0000152587890625);u=k;return}}}function lCa(a){a=a|0;cYc(a);return}function mCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){nCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function nCa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0.0;e=f[a>>2]|0;g=+n[a+8>>2];h=+n[a+12>>2];i=+n[a+16>>2];j=+n[a+20>>2];k=+n[a+24>>2];l=+n[a+28>>2];m=+n[a+32>>2];o=+n[a+36>>2];p=+n[a+40>>2];a=d*3|0;if((d|0)<=0)return;if((e|0)==4){d=0;q=c;while(1){r=+n[b+(d<<2)>>2];s=+n[b+(d+1<<2)>>2];t=+n[b+(d+2<<2)>>2];n[q>>2]=g*r+h*s+i*t;n[q+4>>2]=j*r+k*s+l*t;n[q+8>>2]=m*r+o*s+p*t;n[q+12>>2]=1.0;d=d+3|0;if((d|0)>=(a|0))break;else q=q+16|0}return}else{q=0;d=c;while(1){t=+n[b+(q<<2)>>2];s=+n[b+(q+1<<2)>>2];r=+n[b+(q+2<<2)>>2];n[d>>2]=g*t+h*s+i*r;n[d+4>>2]=j*t+k*s+l*r;n[d+8>>2]=m*t+o*s+p*r;q=q+3|0;if((q|0)>=(a|0))break;else d=d+(e<<2)|0}return}}function oCa(a){a=a|0;cYc(a);return}function pCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){qCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function qCa(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;h=f[a+8>>2]|0;i=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=0;r=c;while(1){s=j[b+(e<<1)>>1]|0;t=Y(s,h)|0;u=j[b+(e+1<<1)>>1]|0;v=Y(u,i)|0;w=j[b+(e+2<<1)>>1]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;d[r>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[r+2>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[r+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[r+6>>1]=-1;e=e+3|0;if((e|0)>=(a|0))break;else r=r+8|0}return}else{r=0;e=c;while(1){c=j[b+(r<<1)>>1]|0;t=Y(c,h)|0;v=j[b+(r+1<<1)>>1]|0;x=Y(v,i)|0;w=j[b+(r+2<<1)>>1]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(c,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(c,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;d[e>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+2>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[e+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else e=e+(g<<1)|0}return}}function rCa(a){a=a|0;cYc(a);return}function sCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){tCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function tCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;i=f[a+8>>2]|0;j=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=0;r=d;while(1){s=h[c+e>>0]|0;t=Y(s,i)|0;u=h[c+(e+1)>>0]|0;v=Y(u,j)|0;w=h[c+(e+2)>>0]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;b[r>>0]=x>>>0<256?x:(x|0)>0?255:0;b[r+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[r+2>>0]=t>>>0<256?t:(t|0)>0?255:0;b[r+3>>0]=-1;e=e+3|0;if((e|0)>=(a|0))break;else r=r+4|0}return}else{r=0;e=d;while(1){d=h[c+r>>0]|0;t=Y(d,i)|0;v=h[c+(r+1)>>0]|0;x=Y(v,j)|0;w=h[c+(r+2)>>0]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(d,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(d,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;b[e>>0]=u>>>0<256?u:(u|0)>0?255:0;b[e+1>>0]=x>>>0<256?x:(x|0)>0?255:0;b[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;r=r+3|0;if((r|0)>=(a|0))break;else e=e+g|0}return}}function uCa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0;n=u;u=u+112|0;o=n+96|0;p=n+68|0;q=n;r=k?2:0;k=(i|0)==0;if(l)if(k){vCa(q,j,r,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78180;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{wCa(q,j,r,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78200;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else if(k){f[q>>2]=j;xCa(q+4|0,3,r,0,0,m);f[q+56>>2]=j;f[q+60>>2]=r;yCa();b[q+64>>0]=m&1;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78220;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{xCa(q,j,r,0,0,m);f[q+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78240;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}}function vCa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+96|0;j=i+64|0;k=i+40|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;b[a+40>>0]=h&1;yCa();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[132548];f[j+4>>2]=f[132549];f[j+8>>2]=f[132550];f[j+12>>2]=f[132551];f[j+16>>2]=f[132552];f[j+20>>2]=f[132553]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[530456]|0)==0?X0c(530456)|0:0)NGc(530464,4096);if((f[19563]|0)<=0){u=i;return}g=(e|0)==0;h=d^2;c=k+8|0;r=k+16|0;s=k+8|0;t=k+16|0;v=0;while(1){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;w=v*3|0;if(g){x=530048+(w<<3)|0;if((x|0)!=(k|0)){y=x;x=f[y+4>>2]|0;z=k;f[z>>2]=f[y>>2];f[z+4>>2]=x}x=w+1|0;z=530048+(x<<3)|0;if((z|0)!=(c|0)){y=z;z=f[y+4>>2]|0;A=c;f[A>>2]=f[y>>2];f[A+4>>2]=z}z=530048+(w+2<<3)|0;if((z|0)==(r|0))B=x;else{A=z;z=f[A+4>>2]|0;y=r;f[y>>2]=f[A>>2];f[y+4>>2]=z;B=x}}else{p[k>>3]=+n[e+(w<<2)>>2];x=w+1|0;p[s>>3]=+n[e+(x<<2)>>2];p[t>>3]=+n[e+(w+2<<2)>>2];B=x}ZGc(m,530464,k);x=j+(v<<3)|0;_Gc(l,m,x);z=RGc(l)|0;f[a+4+(w+h<<2)>>2]=z;ZGc(o,530464,c);_Gc(l,o,x);z=RGc(l)|0;y=a+4+(B<<2)|0;f[y>>2]=z;ZGc(q,530464,r);_Gc(l,q,x);x=RGc(l)|0;f[a+4+(w+d<<2)>>2]=x;x=f[a+4+(w<<2)>>2]|0;if((x|0)<=-1){C=19;break}z=f[y>>2]|0;if((z|0)<=-1){C=19;break}y=f[a+4+(w+2<<2)>>2]|0;if((y|0)<=-1){C=19;break}if((z+x+y|0)>=8192){C=19;break}v=v+1|0;if((v|0)>=(f[19563]|0)){C=9;break}}if((C|0)==9){u=i;return}else if((C|0)==19){C=$Xc(144)|0;f[l>>2]=C;f[l+8>>2]=-2147483504;f[l+4>>2]=128;i=C;v=365255;a=i+128|0;do{b[i>>0]=b[v>>0]|0;i=i+1|0;v=v+1|0}while((i|0)<(a|0));b[C+128>>0]=0;vM(-215,l,365384,364957,1686)}}function wCa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+128|0;j=i+120|0;k=i+64|0;l=i+40|0;m=i+32|0;o=i+24|0;q=i+108|0;r=i+96|0;t=i+16|0;v=i+8|0;w=i;x=i+92|0;y=i+88|0;f[a>>2]=c;c=a+40|0;b[c>>0]=h&1;h=a+44|0;f[h>>2]=d;f[j>>2]=3;yCa();d=(e|0)!=0;z=(g|0)!=0;if(d|z)A=0;else A=b[c>>0]|0;b[a+41>>0]=A;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;if(z){p[k>>3]=+n[g>>2];p[k+8>>3]=+n[g+4>>2];p[k+16>>3]=+n[g+8>>2]}else{f[k>>2]=f[132548];f[k+4>>2]=f[132549];f[k+8>>2]=f[132550];f[k+12>>2]=f[132551];f[k+16>>2]=f[132552];f[k+20>>2]=f[132553]}g=m;f[g>>2]=0;f[g+4>>2]=1072693248;_Gc(l,m,k);m=l+8|0;f[m>>2]=0;f[m+4>>2]=1072693248;m=o;f[m>>2]=0;f[m+4>>2]=1072693248;_Gc(l+16|0,o,k+16|0);if((f[j>>2]|0)<=0){u=i;return}k=q+4|0;o=q+8|0;m=0;while(1){f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;g=l+(m<<3)|0;z=m*3|0;if(d){p[t>>3]=+n[e+(z<<2)>>2];ZGc(v,g,t);UGc(r,v);f[q>>2]=f[r>>2];A=z+1|0;p[t>>3]=+n[e+(A<<2)>>2];ZGc(v,g,t);UGc(r,v);f[k>>2]=f[r>>2];p[t>>3]=+n[e+(z+2<<2)>>2];ZGc(v,g,t);UGc(r,v);f[o>>2]=f[r>>2];B=A}else{ZGc(w,g,530048+(z<<3)|0);UGc(r,w);f[q>>2]=f[r>>2];A=z+1|0;ZGc(w,g,530048+(A<<3)|0);UGc(r,w);f[k>>2]=f[r>>2];ZGc(w,g,530048+(z+2<<3)|0);UGc(r,w);f[o>>2]=f[r>>2];B=A}A=f[q>>2]|0;f[a+4+((f[h>>2]^2)+z<<2)>>2]=A;g=f[k>>2]|0;f[a+4+(B<<2)>>2]=g;c=f[o>>2]|0;f[a+4+((f[h>>2]|0)+z<<2)>>2]=c;z=!((f[s>>2]=A,+n[s>>2])>=0.0);A=z|!((f[s>>2]=g,+n[s>>2])>=0.0);if(A|!((f[s>>2]=c,+n[s>>2])>=0.0)){C=12;break}EGc(x,q,k);EGc(y,x,o);CGc(r,1024);if(!(LGc(y,r)|0)){C=12;break}m=m+1|0;if((m|0)>=(f[j>>2]|0)){C=8;break}}if((C|0)==8){u=i;return}else if((C|0)==12){C=$Xc(96)|0;f[r>>2]=C;f[r+8>>2]=-2147483552;f[r+4>>2]=93;i=C;j=365107;m=i+93|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(m|0));b[C+93>>0]=0;vM(-215,r,365201,364957,1762)}}function xCa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+128|0;j=i+124|0;k=i+56|0;l=i+108|0;m=i+112|0;o=i+104|0;q=i+40|0;r=i+100|0;s=i+32|0;t=i+24|0;v=i+16|0;w=i+8|0;x=i;y=i+96|0;z=i+92|0;A=i+88|0;B=i+84|0;C=i+80|0;f[a>>2]=c;b[a+48>>0]=h&1;yCa();f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[j>>2]=0;a:do if((f[j>>2]|0)<3){if(g|0)while(1){p[k+(f[j>>2]<<3)>>3]=+n[g+(f[j>>2]<<2)>>2];f[j>>2]=(f[j>>2]|0)+1;if((f[j>>2]|0)>=3)break a}do{h=530192+(f[j>>2]<<3)|0;c=k+(f[j>>2]<<3)|0;if((h|0)!=(c|0)){D=h;h=f[D+4>>2]|0;E=c;f[E>>2]=f[D>>2];f[E+4>>2]=h}f[j>>2]=(f[j>>2]|0)+1}while((f[j>>2]|0)<3)}while(0);f[j>>2]=0;b:do if((f[j>>2]|0)<3){g=(e|0)==0;h=(d|0)==0;while(1){E=(f[j>>2]|0)*3|0;if(g){n[a+4+((f[j>>2]|0)*3<<2)>>2]=+p[530048+(E<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=+p[530048+(((f[j>>2]|0)*3|0)+1<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=+p[530048+(((f[j>>2]|0)*3|0)+2<<3)>>3]}else{f[a+4+((f[j>>2]|0)*3<<2)>>2]=f[e+(E<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+1<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+2<<2)>>2]}if(h){E=a+4+((f[j>>2]|0)*3<<2)|0;D=a+4+(((f[j>>2]|0)*3|0)+2<<2)|0;c=f[E>>2]|0;f[E>>2]=f[D>>2];f[D>>2]=c}if(!(+n[a+4+((f[j>>2]|0)*3<<2)>>2]>=0.0)){F=18;break}if(!(+n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]>=0.0)){F=18;break}if(!(+n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]>=0.0)){F=18;break}f[l>>2]=f[a+4+((f[j>>2]|0)*3<<2)>>2];f[m>>2]=f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2];EGc(o,l,m);f[q>>2]=f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2];EGc(r,o,q);n[s>>2]=1.5;if(!(LGc(r,s)|0)){F=18;break}f[j>>2]=(f[j>>2]|0)+1;if((f[j>>2]|0)>=3)break b}if((F|0)==18){h=$Xc(160)|0;f[m>>2]=h;f[m+8>>2]=-2147483488;f[m+4>>2]=158;o1c(h|0,364785,158)|0;b[h+158>>0]=0;vM(-215,m,364944,364957,2840)}}while(0);F=k+8|0;NGc(s,15);ZGc(q,F,s);VGc(t,k,q);NGc(w,3);ZGc(v,k+16|0,w);VGc(x,t,v);UGc(m,x);f[y>>2]=1065353216;f[v>>2]=872415232;x=KGc(m,v)|0;f[s>>2]=f[(x?m:v)>>2];JGc(q,y,s);f[m>>2]=f[q>>2];CGc(q,52);IGc(z,m,q);UGc(s,k);IGc(A,z,s);f[a+40>>2]=f[A>>2];CGc(q,117);IGc(B,m,q);UGc(s,F);IGc(C,B,s);f[a+44>>2]=f[C>>2];C=q;f[C>>2]=0;f[C+4>>2]=1072693248;if($Gc(F,q)|0){u=i;return}else{i=$Xc(32)|0;f[q>>2]=i;f[q+8>>2]=-2147483616;f[q+4>>2]=31;F=i;C=365031;a=F+31|0;do{b[F>>0]=b[C>>0]|0;F=F+1|0;C=C+1|0}while((F|0)<(a|0));b[i+31>>0]=0;vM(-215,q,364944,364957,2854)}}function yCa(){var a=0,c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0;a=u;u=u+14928|0;c=a+120|0;e=a+80|0;g=a+56|0;h=a+48|0;i=a+40|0;j=a+14912|0;k=a+32|0;l=a+24|0;m=a+16|0;o=a+14908|0;p=a+14904|0;q=a+14900|0;r=a+14896|0;s=a+14892|0;t=a+14888|0;v=a+14884|0;w=a+14880|0;x=a+14876|0;y=a+14872|0;z=a+14868|0;A=a+14864|0;B=a+14860|0;C=a+14856|0;D=a+14852|0;E=a+14848|0;F=a+14844|0;G=a+14840|0;H=a+13792|0;I=a+13784|0;K=a+12736|0;L=a+12732|0;M=a+12728|0;N=a+12724|0;O=a+12720|0;P=a+12716|0;Q=a+12712|0;R=a+12708|0;S=a+12704|0;T=a+12700|0;U=a+12696|0;V=a+12692|0;W=a+12688|0;X=a+12684|0;Z=a+12676|0;_=a+12664|0;$=a+12652|0;aa=a+12644|0;ba=a+12632|0;ca=a+12620|0;da=a+12612|0;ea=a+12596|0;fa=a+12588|0;ga=a+12580|0;ha=a+12572|0;ia=a+12564|0;ja=a+12560|0;ka=a+12552|0;la=a+12544|0;ma=a+12540|0;na=a+12532|0;oa=a+12528|0;pa=a+12524|0;qa=a+12520|0;ra=a+12516|0;sa=a+12512|0;ta=a+12508|0;ua=a+12504|0;va=a+12500|0;wa=a+12496|0;xa=a+12492|0;ya=a+12488|0;za=a+12484|0;Aa=a+12480|0;Ba=a+12476|0;Ca=a+12472|0;Da=a+8372|0;Ea=a+4272|0;Fa=a+172|0;Ga=a+168|0;Ha=a+12680|0;Ia=a+12672|0;Ja=a+12668|0;Ka=a+12660|0;La=a+12656|0;Ma=a+12648|0;Na=a+12640|0;Oa=a+12636|0;Pa=a+12628|0;Qa=a+12624|0;Ra=a+12616|0;Sa=a+12608|0;Ta=a+12604|0;Ua=a+12600|0;Va=a+12592|0;Wa=a+12584|0;Xa=a+12576|0;Ya=a+12568|0;Za=a+164|0;_a=a+8|0;$a=a;ab=a+12556|0;bb=a+160|0;cb=a+12548|0;db=a+156|0;eb=a+12536|0;if(b[1163507]|0){u=a;return}g1c(Da|0,0,4100)|0;g1c(Ea|0,0,4100)|0;g1c(Fa|0,0,4100)|0;f[Ha>>2]=1065353216;f[c>>2]=f[222200];JGc(Ga,Ha,c);Ha=0;do{CGc(e,Ha);IGc(c,Ga,e);if(LGc(c,888828)|0)bHc(e,c,888832,888836);else hHc(e,c);fb=Da+(Ha<<2)|0;if((e|0)!=(fb|0))f[fb>>2]=f[e>>2];Ha=Ha+1|0}while((Ha|0)!=1025);Ha=HCa(Da)|0;f[222212]=Ha;f[Ia>>2]=1065353216;n[e>>2]=1024.0;JGc(c,Ia,e);f[Ga>>2]=f[c>>2];Ia=0;do{CGc(e,Ia);IGc(c,Ga,e);f[Ja>>2]=f[c>>2];ICa(e,Ja);Ha=Ea+(Ia<<2)|0;if((e|0)!=(Ha|0))f[Ha>>2]=f[e>>2];f[Ka>>2]=f[c>>2];JCa(e,Ka);Ha=Fa+(Ia<<2)|0;if((e|0)!=(Ha|0))f[Ha>>2]=f[e>>2];Ia=Ia+1|0}while((Ia|0)!=1025);Ia=HCa(Ea)|0;f[222211]=Ia;Ia=HCa(Fa)|0;f[222219]=Ia;if((b[530312]|0)==0?X0c(530312)|0:0)CGc(888880,2040);Ia=0;do{CGc(La,Ia);JGc(c,La,888840);f[Ma>>2]=f[c>>2];ICa(g,Ma);IGc(e,888880,g);Fa=(QGc(e)|0)&65535;d[1135584+(Ia<<1)>>1]=Fa;d[1136096+(Ia<<1)>>1]=Ia<<3;Ia=Ia+1|0}while((Ia|0)!=256);if((b[530320]|0)==0?X0c(530320)|0:0){f[Na>>2]=1065353216;CGc(c,4096);JGc(888884,Na,c)}Na=0;do{CGc(e,Na);IGc(c,888884,e);f[Oa>>2]=f[c>>2];JCa(g,Oa);IGc(e,888840,g);Ia=(QGc(e)|0)&65535;d[1136608+(Na<<1)>>1]=Ia;IGc(e,888840,c);Ia=(PGc(e)|0)&65535;d[1144800+(Na<<1)>>1]=Ia;Na=Na+1|0}while((Na|0)!=4096);if((b[530328]|0)==0?X0c(530328)|0:0)n[222222]=1.0/(+n[222210]*8.0);if((b[530336]|0)==0?X0c(530336)|0:0)CGc(888892,32768);Na=0;do{CGc(e,Na);IGc(c,888888,e);if(LGc(c,888828)|0)bHc(g,c,888832,888836);else hHc(g,c);IGc(e,888892,g);Oa=(QGc(e)|0)&65535;d[1152992+(Na<<1)>>1]=Oa;Na=Na+1|0}while((Na|0)!=3072);Na=0;do{if((Na|0)<21){CGc(Pa,Y(Na,2949120)|0);CGc(e,414613);JGc(c,Pa,e);Oa=QGc(c)|0;CGc(Qa,16384);CGc(Ra,16);CGc(g,116);JGc(Sa,Ra,g);CGc(Ta,Na*5|0);CGc(i,1479);JGc(h,Ta,i);EGc(e,Sa,h);IGc(c,Qa,e);gb=Oa;hb=QGc(c)|0}else{CGc(Ua,Y(Na,1638400)|0);CGc(e,29580);JGc(Va,Ua,e);CGc(Wa,262144);CGc(h,116);JGc(g,Wa,h);EGc(c,Va,g);Oa=QGc(c)|0;IGc(Xa,c,c);IGc(Ya,Xa,c);CGc(g,268435456);JGc(e,Ya,g);gb=QGc(e)|0;hb=Oa}Oa=Na<<1;d[1159136+(Oa<<1)>>1]=gb;d[1159136+((Oa|1)<<1)>>1]=hb;Na=Na+1|0}while((Na|0)!=256);Na=dN(147456)|0;hb=-8145;do{if((hb|0)<3391)ib=((hb*108|0)/841|0)+-290|0;else ib=(Y((Y(hb,hb)|0)>>>14,hb)|0)/16384|0;f[Na+(hb+8145<<2)>>2]=ib;hb=hb+1|0}while((hb|0)!=28719);f[222224]=Na;NGc(e,15);ZGc(c,530200,e);VGc(_a,530192,c);NGc(h,3);ZGc(g,530208,h);VGc($a,_a,g);UGc(Za,$a);f[ab>>2]=1065353216;f[g>>2]=872415232;$a=KGc(Za,g)|0;f[e>>2]=f[($a?Za:g)>>2];JGc(c,ab,e);f[Za>>2]=f[c>>2];CGc(c,52);IGc(cb,Za,c);UGc(e,530192);IGc(bb,cb,e);CGc(c,117);IGc(eb,Za,c);UGc(e,530200);IGc(db,eb,e);f[e>>2]=1065353216;CGc(g,4);JGc(c,e,g);eb=dN(262144)|0;Za=dN(262144)|0;cb=dN(524288)|0;ab=0;do{CGc(h,ab*100|0);JGc(g,h,888840);$a=ab<<8;_a=0;do{CGc(j,_a);IGc(k,j,888812);JGc(l,k,888840);EGc(i,l,888804);CGc(o,9);IGc(q,g,bb);EGc(p,i,q);IGc(m,o,p);CGc(q,16);IGc(p,m,q);Na=QGc(p)|0;f[eb+(_a+$a<<2)>>2]=Na;_a=_a+1|0}while((_a|0)!=256);jb=0;do{CGc(r,jb);IGc(s,r,888824);JGc(t,s,888840);EGc(i,t,888816);IGc(q,g,db);EGc(p,i,q);JGc(m,c,p);_a=KGc(m,c)|0;Na=f[c>>2]|0;if(_a)f[m>>2]=Na;f[p>>2]=Na^-2147483648;if(LGc(m,p)|0)f[m>>2]=f[c>>2]^-2147483648;CGc(q,16777216);IGc(p,m,q);Na=QGc(p)|0;_a=jb+$a|0;f[Za+(_a<<2)>>2]=Na;hb=Y(Na,ab)|0;Na=x1c(hb|0,((hb|0)<0)<<31>>31|0,249600,0)|0;hb=cb+(_a<<3)|0;f[hb>>2]=Na;f[hb+4>>2]=J;jb=jb+1|0}while((jb|0)!=256);ab=ab+1|0}while((ab|0)!=256);f[222225]=eb;f[222226]=Za;f[222227]=cb;cb=c;Za=cb+36|0;do{f[cb>>2]=0;cb=cb+4|0}while((cb|0)<(Za|0));cb=e;Za=cb+36|0;do{f[cb>>2]=0;cb=cb+4|0}while((cb|0)<(Za|0));cb=h;f[cb>>2]=0;f[cb+4>>2]=1072693248;_Gc(g,h,530192);h=g+8|0;f[h>>2]=0;f[h+4>>2]=1072693248;h=i;f[h>>2]=0;f[h+4>>2]=1072693248;_Gc(g+16|0,i,530208);i=0;do{h=i*3|0;cb=530048+(h<<3)|0;UGc(j,cb);Za=h+2|0;eb=e+(Za<<2)|0;if((j|0)!=(eb|0))f[eb>>2]=f[j>>2];eb=h+1|0;ab=530048+(eb<<3)|0;UGc(j,ab);jb=e+(eb<<2)|0;if((j|0)!=(jb|0))f[jb>>2]=f[j>>2];jb=530048+(Za<<3)|0;UGc(j,jb);$a=e+(h<<2)|0;if((j|0)!=($a|0))f[$a>>2]=f[j>>2];$a=g+(i<<3)|0;ZGc(k,jb,$a);UGc(j,k);jb=c+(h<<2)|0;if((j|0)!=(jb|0))f[jb>>2]=f[j>>2];ZGc(l,ab,$a);UGc(j,l);ab=c+(eb<<2)|0;if((j|0)!=(ab|0))f[ab>>2]=f[j>>2];ZGc(m,cb,$a);UGc(j,m);$a=c+(Za<<2)|0;if((j|0)!=($a|0))f[$a>>2]=f[j>>2];i=i+1|0}while((i|0)!=3);f[j>>2]=f[c>>2];f[o>>2]=f[c+4>>2];f[p>>2]=f[c+8>>2];f[q>>2]=f[c+12>>2];f[r>>2]=f[c+16>>2];f[s>>2]=f[c+20>>2];f[t>>2]=f[c+24>>2];f[v>>2]=f[c+28>>2];f[w>>2]=f[c+32>>2];f[x>>2]=f[e>>2];f[y>>2]=f[e+4>>2];f[z>>2]=f[e+8>>2];f[A>>2]=f[e+12>>2];f[B>>2]=f[e+16>>2];f[C>>2]=f[e+20>>2];f[D>>2]=f[e+24>>2];f[E>>2]=f[e+28>>2];f[F>>2]=f[e+32>>2];if((b[530344]|0)==0?X0c(530344)|0:0)CGc(888912,32);if((b[530352]|0)==0?X0c(530352)|0:0)CGc(888916,116);if((b[530360]|0)==0?X0c(530360)|0:0)CGc(888920,16);if((b[530368]|0)==0?X0c(530368)|0:0)CGc(888924,500);if((b[530376]|0)==0?X0c(530376)|0:0)CGc(888928,200);if((b[530384]|0)==0?X0c(530384)|0:0)CGc(888932,100);if((b[530392]|0)==0?X0c(530392)|0:0)CGc(888936,128);if((b[530400]|0)==0?X0c(530400)|0:0)CGc(888940,256);if((b[530408]|0)==0?X0c(530408)|0:0)CGc(888944,16384);if((b[530416]|0)==0?X0c(530416)|0:0){CGc(G,24389);CGc(H,27);JGc(888948,G,H)}if((b[530424]|0)==0?X0c(530424)|0:0){CGc(I,9);CGc(H,4);JGc(888952,I,H)}if((b[530432]|0)==0?X0c(530432)|0:0)CGc(888956,15);if((b[530440]|0)==0?X0c(530440)|0:0)CGc(888960,3);I=H+8|0;G=H+4|0;f[G>>2]=107811;e=bYc(215622)|0;f[H>>2]=e;e=K+8|0;f[K>>2]=e;c=K+4|0;f[c>>2]=107811;i=bYc(215622)|0;f[K>>2]=i;i=0;do{m=i*3|0;l=0;do{k=(l*99|0)+m|0;g=0;do{$a=k+(g*3267|0)|0;CGc(M,i);JGc(L,M,888912);CGc(O,l);JGc(N,O,888912);CGc(Q,g);JGc(P,Q,888912);f[S>>2]=f[L>>2];ICa(R,S);f[L>>2]=f[R>>2];f[T>>2]=f[N>>2];ICa(R,T);f[N>>2]=f[R>>2];f[U>>2]=f[P>>2];ICa(R,U);f[P>>2]=f[R>>2];IGc(V,L,j);IGc(W,N,o);EGc(X,V,W);IGc(Z,P,p);EGc(R,X,Z);IGc(_,L,q);IGc(Z,N,r);EGc($,_,Z);IGc(aa,P,s);EGc(W,$,aa);IGc(ba,L,t);IGc(aa,N,v);EGc(ca,ba,aa);IGc(da,P,w);EGc(Z,ca,da);if(KGc(R,888828)|0)hHc(aa,R);else bHc(aa,R,888832,888836);if(KGc(W,888828)|0)hHc(da,W);else bHc(da,W,888832,888836);if(KGc(Z,888828)|0)hHc(ea,Z);else bHc(ea,Z,888832,888836);if(KGc(W,888828)|0){IGc(ga,888916,da);HGc(fa,ga,888920)}else IGc(fa,888948,W);HGc(ia,aa,da);IGc(ha,888924,ia);HGc(ja,da,ea);IGc(ia,888928,ja);IGc(ka,888944,fa);JGc(ja,ka,888932);Za=(QGc(ja)|0)&65535;d[(f[H>>2]|0)+($a<<1)>>1]=Za;EGc(la,ha,888936);IGc(ma,888944,la);JGc(ja,ma,888940);Za=(QGc(ja)|0)&65535;cb=$a+1|0;d[(f[H>>2]|0)+(cb<<1)>>1]=Za;EGc(la,ia,888936);IGc(na,888944,la);JGc(ja,na,888940);Za=(QGc(ja)|0)&65535;ab=$a+2|0;d[(f[H>>2]|0)+(ab<<1)>>1]=Za;IGc(oa,L,x);IGc(W,N,y);EGc(pa,oa,W);IGc(Z,P,z);EGc(R,pa,Z);IGc(qa,L,A);IGc(Z,N,B);EGc(ra,qa,Z);IGc(aa,P,C);EGc(W,ra,aa);IGc(sa,L,D);IGc(aa,N,E);EGc(ta,sa,aa);IGc(da,P,F);EGc(Z,ta,da);if(LGc(W,888828)|0)bHc(aa,W,888832,888836);else hHc(aa,W);IGc(ua,aa,888916);HGc(da,ua,888920);f[aa>>2]=f[da>>2];CGc(va,52);IGc(ha,888956,W);EGc(wa,R,ha);IGc(ia,888960,Z);EGc(fa,wa,ia);n[ja>>2]=1.1920928955078125e-07;Za=KGc(fa,ja)|0;f[ea>>2]=f[(Za?fa:ja)>>2];JGc(da,va,ea);IGc(xa,R,da);HGc(fa,xa,bb);IGc(ea,aa,fa);IGc(ya,888952,W);IGc(za,ya,da);HGc(ha,za,db);IGc(fa,aa,ha);IGc(Aa,888944,aa);JGc(ha,Aa,888932);Za=(QGc(ha)|0)&65535;d[(f[K>>2]|0)+($a<<1)>>1]=Za;HGc(ia,ea,888804);IGc(Ba,888944,ia);JGc(ha,Ba,888812);Za=(QGc(ha)|0)&65535;d[(f[K>>2]|0)+(cb<<1)>>1]=Za;HGc(ia,fa,888816);IGc(Ca,888944,ia);JGc(ha,Ca,888824);Za=(QGc(ha)|0)&65535;d[(f[K>>2]|0)+(ab<<1)>>1]=Za;g=g+1|0}while((g|0)<33);l=l+1|0}while((l|0)<33);i=i+1|0}while((i|0)<33);i=dN(1724976)|0;ha=dN(1724976)|0;Ca=f[H>>2]|0;ia=f[K>>2]|0;fa=0;do{Ba=fa*24|0;ea=0;do{Aa=(ea*792|0)+Ba|0;aa=ea;ea=ea+1|0;db=((ea|0)<32?ea:32)*99|0;za=aa*99|0;aa=0;do{da=Aa+(aa*26136|0)|0;ya=aa*3267|0;aa=aa+1|0;W=((aa|0)<32?aa:32)*3267|0;bb=0;do{xa=bb+fa|0;R=((xa|0)<32?xa:32)*3|0;xa=da+(bb<<2)|0;va=R+za|0;ja=va+ya|0;d[i+(xa<<1)>>1]=d[Ca+(ja<<1)>>1]|0;wa=ja+1|0;Z=xa+8|0;d[i+(Z<<1)>>1]=d[Ca+(wa<<1)>>1]|0;ua=ja+2|0;ta=xa+16|0;d[i+(ta<<1)>>1]=d[Ca+(ua<<1)>>1]|0;d[ha+(xa<<1)>>1]=d[ia+(ja<<1)>>1]|0;d[ha+(Z<<1)>>1]=d[ia+(wa<<1)>>1]|0;d[ha+(ta<<1)>>1]=d[ia+(ua<<1)>>1]|0;ua=va+W|0;va=xa|1;d[i+(va<<1)>>1]=d[Ca+(ua<<1)>>1]|0;ta=ua+1|0;wa=va+8|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;Z=ua+2|0;ja=va+16|0;d[i+(ja<<1)>>1]=d[Ca+(Z<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(ua<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;d[ha+(ja<<1)>>1]=d[ia+(Z<<1)>>1]|0;Z=R+db|0;R=xa|2;ja=Z+ya|0;d[i+(R<<1)>>1]=d[Ca+(ja<<1)>>1]|0;ta=ja+1|0;wa=R+8|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;ua=ja+2|0;va=R+16|0;d[i+(va<<1)>>1]=d[Ca+(ua<<1)>>1]|0;d[ha+(R<<1)>>1]=d[ia+(ja<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(ua<<1)>>1]|0;ua=Z+W|0;Z=xa|3;d[i+(Z<<1)>>1]=d[Ca+(ua<<1)>>1]|0;xa=ua+1|0;va=Z+8|0;d[i+(va<<1)>>1]=d[Ca+(xa<<1)>>1]|0;ta=ua+2|0;wa=Z+16|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;d[ha+(Z<<1)>>1]=d[ia+(ua<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(xa<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;bb=bb+1|0}while((bb|0)!=2)}while((aa|0)!=33)}while((ea|0)!=33);fa=fa+1|0}while((fa|0)!=33);fa=i;i=ha;ha=f[K>>2]|0;if((ha|0)!=(e|0)){if(ha|0)dYc(ha);f[K>>2]=e;f[c>>2]=520}c=f[H>>2]|0;if((c|0)!=(I|0)){if(c|0)dYc(c);f[H>>2]=I;f[G>>2]=520}f[132576]=fa;f[132577]=i;i=0;do{fa=i<<3;G=16-i<<16>>16;I=0;do{H=(I<<7)+fa|0;c=16-I<<16>>16;e=Y(c,G)|0;K=Y(I,G)|0;ha=Y(c,i)|0;c=Y(I,i)|0;ia=0;do{Ca=1070048+(H+(ia<<11)<<1)|0;ea=16-ia<<16>>16;Ba=(Y(ea,e)|0)&65535;d[Ca>>1]=Ba;Ba=(Y(ia,e)|0)&65535;d[Ca+2>>1]=Ba;Ba=(Y(ea,K)|0)&65535;d[Ca+4>>1]=Ba;Ba=(Y(ia,K)|0)&65535;d[Ca+6>>1]=Ba;Ba=(Y(ea,ha)|0)&65535;d[Ca+8>>1]=Ba;Ba=(Y(ia,ha)|0)&65535;d[Ca+10>>1]=Ba;Ba=(Y(ea,c)|0)&65535;d[Ca+12>>1]=Ba;Ba=(Y(ia,c)|0)&65535;d[Ca+14>>1]=Ba;ia=ia+1|0}while((ia|0)!=16);I=I+1|0}while((I|0)!=16);i=i+1|0}while((i|0)!=16);b[1163507]=1;u=a;return}function zCa(a){a=a|0;cYc(a);return}function ACa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){BCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function BCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=b[a+48>>0]|0?f[222211]|0:0;p=+n[a+4>>2];q=+n[a+8>>2];r=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=e*3|0;if((e|0)<=0){u=g;return}e=(o|0)==0;B=f[222212]|0;C=a+40|0;D=a+44|0;a=c;c=0;while(1){E=f[a>>2]|0;f[h>>2]=E;F=f[a+4>>2]|0;f[i>>2]=F;G=f[a+8>>2]|0;f[j>>2]=G;n[k>>2]=0.0;H=(f[s>>2]=E,+n[s>>2])<0.0?k:h;n[l>>2]=1.0;E=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[h>>2]=E;n[k>>2]=0.0;H=(f[s>>2]=F,+n[s>>2])<0.0?k:i;n[l>>2]=1.0;F=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[i>>2]=F;n[k>>2]=0.0;H=(f[s>>2]=G,+n[s>>2])<0.0?k:j;n[l>>2]=1.0;G=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[j>>2]=G;I=(f[s>>2]=E,+n[s>>2]);J=(f[s>>2]=F,+n[s>>2]);K=(f[s>>2]=G,+n[s>>2]);if(e){L=K;M=J;N=I}else{O=I*1024.0;G=~~O;F=(G|0)>0?G:0;G=(F|0)<1023?F:1023;I=O-+(G|0);F=o+(G<<2<<2)|0;O=+n[F>>2]+I*(+n[F+4>>2]+I*(+n[F+8>>2]+ +n[F+12>>2]*I));n[h>>2]=O;I=J*1024.0;F=~~I;G=(F|0)>0?F:0;F=(G|0)<1023?G:1023;J=I-+(F|0);G=o+(F<<2<<2)|0;I=+n[G>>2]+J*(+n[G+4>>2]+J*(+n[G+8>>2]+ +n[G+12>>2]*J));n[i>>2]=I;J=K*1024.0;G=~~J;F=(G|0)>0?G:0;G=(F|0)<1023?F:1023;K=J-+(G|0);F=o+(G<<2<<2)|0;J=+n[F>>2]+K*(+n[F+4>>2]+K*(+n[F+8>>2]+ +n[F+12>>2]*K));n[j>>2]=J;L=J;M=I;N=O}O=p*N+q*M+r*L;I=t*N+v*M+w*L;J=+n[222200]*I;F=~~J;G=(F|0)>0?F:0;F=(G|0)<1023?G:1023;K=J-+(F|0);G=B+(F<<2<<2)|0;J=(+n[G>>2]+K*(+n[G+4>>2]+K*(+n[G+8>>2]+ +n[G+12>>2]*K)))*116.0+-16.0;K=(x*N+y*M+z*L)*3.0+(O+I*15.0);P=52.0/(K<1.1920928955078125e-07?1.1920928955078125e-07:K);K=(O*P-+n[C>>2])*J;O=(I*2.25*P-+n[D>>2])*J;n[d+(c<<2)>>2]=J;n[d+(c+1<<2)>>2]=K;n[d+(c+2<<2)>>2]=O;c=c+3|0;if((c|0)>=(A|0))break;else a=a+(m<<2)|0}u=g;return}function CCa(a){a=a|0;cYc(a);return}function DCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){ECa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function ECa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0;g=u;u=u+3104|0;i=g;j=g+3088|0;k=g+3092|0;l=g+3084|0;m=g+3080|0;o=g+3076|0;p=g+3072|0;if(b[a+64>>0]|0){FCa(a+56|0,c,d,e);u=g;return}q=f[a>>2]|0;if((e|0)>0){r=a+4|0;a=c;c=d;d=0;while(1){s=e-d|0;t=(s|0)<256?s:256;if((b[530256]|0)==0?X0c(530256)|0:0){f[j>>2]=1065353216;JGc(888852,j,888840)}v=t*3|0;w=(s|0)>0;if(w){x=+n[222213];s=0;y=a;while(1){n[i+(s<<2)>>2]=+(h[y>>0]|0)*x;n[i+(s+1<<2)>>2]=+(h[y+1>>0]|0)*x;n[i+(s+2<<2)>>2]=+(h[y+2>>0]|0)*x;s=s+3|0;z=y+q|0;if((s|0)>=(v|0)){A=z;break}else y=z}}else A=a;BCa(r,i,i,t);if((b[530264]|0)==0?X0c(530264)|0:0){CGc(k,100);JGc(888856,888840,k)}if((b[530272]|0)==0?X0c(530272)|0:0)JGc(888860,888840,888812);if((b[530280]|0)==0?X0c(530280)|0:0)JGc(888864,888840,888824);if((b[530288]|0)==0?X0c(530288)|0:0){f[l>>2]=f[222201]^-2147483648;IGc(m,l,888840);JGc(888868,m,888812)}if((b[530296]|0)==0?X0c(530296)|0:0){f[o>>2]=f[222204]^-2147483648;IGc(p,o,888840);JGc(888872,p,888824)}if(w){y=0;do{s=ALc(+n[i+(y<<2)>>2]*+n[222214])|0;b[c+y>>0]=s>>>0<256?s:(s|0)>0?255:0;s=y+1|0;z=ALc(+n[i+(s<<2)>>2]*+n[222215]+ +n[222217])|0;b[c+s>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+2|0;s=ALc(+n[i+(z<<2)>>2]*+n[222216]+ +n[222218])|0;b[c+z>>0]=s>>>0<256?s:(s|0)>0?255:0;y=y+3|0}while((y|0)<(v|0))}d=d+256|0;if((d|0)>=(e|0))break;else{a=A;c=c+768|0}}}u=g;return}function FCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;i=g+8|0;j=g+4|0;k=g;l=f[a>>2]|0;m=f[a+4>>2]|0;a=e*3|0;if((e|0)<=0){u=g;return}e=m^2;n=0;o=c;while(1){GCa((h[o+m>>0]|0)<<6,(h[o+1>>0]|0)<<6,(h[o+e>>0]|0)<<6,f[132577]|0,i,j,k);c=f[i>>2]|0;p=(c|0)/64|0;b[d+n>>0]=p>>>0<256?p:(c|0)>63?255:0;c=f[j>>2]|0;p=(c|0)/64|0;b[d+(n+1)>>0]=p>>>0<256?p:(c|0)>63?255:0;c=f[k>>2]|0;p=(c|0)/64|0;b[d+(n+2)>>0]=p>>>0<256?p:(c|0)>63?255:0;n=n+3|0;if((n|0)>=(a|0))break;else o=o+l|0}u=g;return}function GCa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;j=u;u=u+96|0;k=j+64|0;l=j+32|0;m=j;n=e+(((b>>9)*792|0)+((a>>9)*24|0)+((c>>9)*26136|0)<<1)|0;f[k>>2]=d[n>>1];f[l>>2]=d[n+16>>1];f[m>>2]=d[n+32>>1];e=k+4|0;f[e>>2]=d[n+2>>1];o=l+4|0;f[o>>2]=d[n+18>>1];p=m+4|0;f[p>>2]=d[n+34>>1];q=k+8|0;f[q>>2]=d[n+4>>1];r=l+8|0;f[r>>2]=d[n+20>>1];s=m+8|0;f[s>>2]=d[n+36>>1];t=k+12|0;f[t>>2]=d[n+6>>1];v=l+12|0;f[v>>2]=d[n+22>>1];w=m+12|0;f[w>>2]=d[n+38>>1];x=k+16|0;f[x>>2]=d[n+8>>1];y=l+16|0;f[y>>2]=d[n+24>>1];z=m+16|0;f[z>>2]=d[n+40>>1];A=k+20|0;f[A>>2]=d[n+10>>1];B=l+20|0;f[B>>2]=d[n+26>>1];C=m+20|0;f[C>>2]=d[n+42>>1];D=k+24|0;f[D>>2]=d[n+12>>1];E=l+24|0;f[E>>2]=d[n+28>>1];F=m+24|0;f[F>>2]=d[n+44>>1];G=d[n+14>>1]|0;f[k+28>>2]=G;H=l+28|0;f[H>>2]=d[n+30>>1];I=m+28|0;f[I>>2]=d[n+46>>1];n=b<<2&1920|a>>>2&120|c<<6&30720;c=d[1070048+(n<<1)>>1]|0;a=d[1070048+((n|1)<<1)>>1]|0;b=d[1070048+((n|2)<<1)>>1]|0;J=d[1070048+((n|3)<<1)>>1]|0;K=d[1070048+((n|4)<<1)>>1]|0;L=d[1070048+((n|5)<<1)>>1]|0;M=d[1070048+((n|6)<<1)>>1]|0;N=d[1070048+((n|7)<<1)>>1]|0;n=Y(c,f[k>>2]|0)|0;k=(Y(a,f[e>>2]|0)|0)+n|0;n=k+(Y(b,f[q>>2]|0)|0)|0;q=n+(Y(J,f[t>>2]|0)|0)|0;t=q+(Y(K,f[x>>2]|0)|0)|0;x=t+(Y(L,f[A>>2]|0)|0)|0;A=x+(Y(M,f[D>>2]|0)|0)+(Y(N,G)|0)|0;f[g>>2]=A;A=Y(f[l>>2]|0,c)|0;l=(Y(f[o>>2]|0,a)|0)+A|0;A=l+(Y(f[r>>2]|0,b)|0)|0;r=A+(Y(f[v>>2]|0,J)|0)|0;v=r+(Y(f[y>>2]|0,K)|0)|0;y=v+(Y(f[B>>2]|0,L)|0)|0;B=y+(Y(f[E>>2]|0,M)|0)|0;E=B+(Y(f[H>>2]|0,N)|0)|0;f[h>>2]=E;E=Y(f[m>>2]|0,c)|0;c=(Y(f[p>>2]|0,a)|0)+E|0;E=c+(Y(f[s>>2]|0,b)|0)|0;b=E+(Y(f[w>>2]|0,J)|0)|0;J=b+(Y(f[z>>2]|0,K)|0)|0;K=J+(Y(L,f[C>>2]|0)|0)|0;C=K+(Y(M,f[F>>2]|0)|0)|0;F=C+(Y(N,f[I>>2]|0)|0)|0;f[i>>2]=F;f[g>>2]=(f[g>>2]|0)+2048>>12;f[h>>2]=(f[h>>2]|0)+2048>>12;f[i>>2]=(f[i>>2]|0)+2048>>12;u=j;return}function HCa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;b=u;u=u+64|0;c=b+56|0;d=b+52|0;e=b+48|0;g=b+44|0;h=b+40|0;i=b+36|0;j=b+32|0;k=b+24|0;l=b+20|0;m=b+28|0;o=b+16|0;p=b+12|0;q=b+4|0;r=b+8|0;s=b;t=dN(16384)|0;CGc(c,2);CGc(d,3);CGc(e,4);CGc(g,0);n[t+4>>2]=0.0;n[t>>2]=0.0;v=1;do{w=v;v=v+1|0;IGc(i,a+(w<<2)|0,c);HGc(j,a+(v<<2)|0,i);x=w+-1|0;EGc(k,j,a+(x<<2)|0);IGc(h,k,d);f[l>>2]=1065353216;y=x<<2;HGc(m,e,t+(y<<2)|0);JGc(i,l,m);x=w<<2;w=t+(x<<2)|0;if((i|0)!=(w|0))f[w>>2]=f[i>>2];HGc(o,h,t+((y|1)<<2)|0);IGc(m,o,i);y=t+((x|1)<<2)|0;if((m|0)!=(y|0))f[y>>2]=f[m>>2]}while((v|0)!=1024);v=0;do{o=1024-v|0;l=o+-1|0;e=l<<2;k=t+((e|1)<<2)|0;j=t+(e<<2)|0;IGc(i,j,g);HGc(h,k,i);y=a+(l<<2)|0;HGc(p,a+(o<<2)|0,y);IGc(q,h,c);EGc(r,g,q);JGc(m,r,d);HGc(i,p,m);HGc(s,g,h);JGc(m,s,d);if((y|0)!=(j|0))f[j>>2]=f[y>>2];if((i|0)!=(k|0))f[k>>2]=f[i>>2];k=t+((e|2)<<2)|0;if((h|0)!=(k|0))f[k>>2]=f[h>>2];k=t+((e|3)<<2)|0;if((m|0)!=(k|0))f[k>>2]=f[m>>2];f[g>>2]=f[h>>2];v=v+1|0}while((v|0)!=1024);u=b;return t|0}function ICa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+48|0;d=c+40|0;e=c+24|0;g=c+32|0;h=c+8|0;i=c+16|0;j=c;DGc(d,b);if(aHc(d,530216)|0){_Gc(e,d,530232);UGc(a,e);u=c;return}else{VGc(h,d,530248);d=j;f[d>>2]=0;f[d+4>>2]=1072693248;VGc(i,j,530248);_Gc(g,h,i);gHc(e,g,530240);UGc(a,e);u=c;return}}function JCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c+56|0;e=c+40|0;g=c+48|0;h=c+24|0;i=c+16|0;j=c+32|0;k=c+8|0;l=c;DGc(d,b);if(aHc(d,530224)|0){ZGc(e,d,530232);UGc(a,e);u=c;return}else{b=h;f[b>>2]=0;f[b+4>>2]=1072693248;_Gc(g,h,530240);gHc(i,d,g);g=k;f[g>>2]=0;f[g+4>>2]=1072693248;VGc(j,k,530248);ZGc(l,i,j);YGc(e,l,530248);UGc(a,e);u=c;return}}function KCa(a){a=a|0;cYc(a);return}function LCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){MCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function MCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=f[a+44>>2]|0;p=b[a+40>>0]|0?f[222211]|0:0;q=+n[a+4>>2];r=+n[a+8>>2];s=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=e*3|0;if((b[a+41>>0]|0)!=0&(e|0)>0){e=o^2;a=f[132576]|0;B=0;C=c;while(1){D=+n[C+(o<<2)>>2];if(!(D<0.0))if(D>1.0)E=1.0;else E=D;else E=0.0;D=+n[C+4>>2];if(!(D<0.0))if(D>1.0)F=1.0;else F=D;else F=0.0;D=+n[C+(e<<2)>>2];if(!(D<0.0))if(D>1.0)G=1.0;else G=D;else G=0.0;H=ALc(E*16384.0)|0;I=ALc(F*16384.0)|0;GCa(H,I,ALc(G*16384.0)|0,a,h,i,j);D=+(f[i>>2]|0)*.00006103515625;J=+(f[j>>2]|0)*.00006103515625;n[d+(B<<2)>>2]=+(f[h>>2]|0)*.00006103515625*100.0;n[d+(B+1<<2)>>2]=D*256.0+-128.0;n[d+(B+2<<2)>>2]=J*256.0+-128.0;I=B+3|0;H=C+(m<<2)|0;if((I|0)<(A|0)){B=I;C=H}else{K=H;L=I;break}}}else{K=c;L=0}if((b[530448]|0)==0?X0c(530448)|0:0){CGc(k,16);CGc(h,116);JGc(l,k,h);f[222241]=f[l>>2]}if((L|0)>=(A|0)){u=g;return}l=(p|0)==0;h=L;L=K;while(1){G=+n[L>>2];if(!(G<0.0))if(G>1.0)M=1.0;else M=G;else M=0.0;G=+n[L+4>>2];if(!(G<0.0))if(G>1.0)N=1.0;else N=G;else N=0.0;G=+n[L+8>>2];if(!(G<0.0))if(G>1.0)O=1.0;else O=G;else O=0.0;if(l){P=M;Q=N;R=O}else{G=M*1024.0;K=~~G;k=(K|0)>0?K:0;K=(k|0)<1023?k:1023;F=G-+(K|0);k=p+(K<<2<<2)|0;G=N*1024.0;K=~~G;c=(K|0)>0?K:0;K=(c|0)<1023?c:1023;E=G-+(K|0);c=p+(K<<2<<2)|0;G=O*1024.0;K=~~G;C=(K|0)>0?K:0;K=(C|0)<1023?C:1023;J=G-+(K|0);C=p+(K<<2<<2)|0;P=+n[k>>2]+F*(+n[k+4>>2]+F*(F*+n[k+12>>2]+ +n[k+8>>2]));Q=+n[c>>2]+E*(+n[c+4>>2]+E*(E*+n[c+12>>2]+ +n[c+8>>2]));R=+n[C>>2]+J*(+n[C+4>>2]+J*(J*+n[C+12>>2]+ +n[C+8>>2]))}J=s*R+(r*Q+q*P);E=w*R+(v*Q+t*P);F=z*R+(y*Q+x*P);if(J>.008856000378727913)S=+KL(J);else S=J*7.7870001792907715+ +n[222241];C=E>.008856000378727913;if(C)T=+KL(E);else T=E*7.7870001792907715+ +n[222241];if(F>.008856000378727913)U=+KL(F);else U=F*7.7870001792907715+ +n[222241];n[d+(h<<2)>>2]=C?T*116.0+-16.0:E*903.2999877929688;n[d+(h+1<<2)>>2]=(S-T)*500.0;n[d+(h+2<<2)>>2]=(T-U)*200.0;h=h+3|0;if((h|0)>=(A|0))break;else L=L+(m<<2)|0}u=g;return}function NCa(a){a=a|0;cYc(a);return}function OCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){PCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function PCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=b[a+40>>0]|0?1135584:1136096;i=f[a>>2]|0;k=f[a+4>>2]|0;l=f[a+8>>2]|0;m=f[a+12>>2]|0;n=f[a+16>>2]|0;o=f[a+20>>2]|0;p=f[a+24>>2]|0;q=f[a+28>>2]|0;r=f[a+32>>2]|0;s=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){t=0;u=c}else return;while(1){c=j[g+(h[u>>0]<<1)>>1]|0;e=j[g+(h[u+1>>0]<<1)>>1]|0;v=j[g+(h[u+2>>0]<<1)>>1]|0;w=1152992+((Y(c,k)|0)+2048+(Y(e,l)|0)+(Y(v,m)|0)>>12<<1)|0;x=1152992+((Y(c,n)|0)+2048+(Y(e,o)|0)+(Y(v,p)|0)>>12<<1)|0;y=j[x>>1]|0;x=1152992+((Y(c,q)|0)+2048+(Y(e,r)|0)+(Y(v,s)|0)>>12<<1)|0;v=(y*296|0)+-1320550>>15;e=(((j[w>>1]|0)-y|0)*500|0)+4210688>>15;w=((y-(j[x>>1]|0)|0)*200|0)+4210688>>15;b[d+t>>0]=v>>>0<256?v:(v|0)>0?255:0;b[d+(t+1)>>0]=e>>>0<256?e:(e|0)>0?255:0;b[d+(t+2)>>0]=w>>>0<256?w:(w|0)>0?255:0;t=t+3|0;if((t|0)>=(a|0))break;else u=u+i|0}return}function QCa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0;n=u;u=u+144|0;o=n+136|0;p=n+104|0;q=n;r=k?2:0;k=(i|0)==0;if(l)if(k){RCa(q,3,r,0,0,m);SCa(q+56|0,j,r,0,0,m);f[q+100>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78264;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{RCa(q,j,r,0,0,m);f[q+56>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78284;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else if(k){f[q>>2]=j;TCa(q+4|0,j,r,0,0,m);UCa(q+56|0,j,r,0,0,m);b[q+100>>0]=1;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78304;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}else{TCa(q,j,r,0,0,m);f[q+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=78324;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=q;h3(o,p,+(Y(h,g)|0)*.0000152587890625);u=n;return}}function RCa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+96|0;j=i+48|0;k=i+24|0;l=i+16|0;m=i+8|0;o=i;q=i+80|0;r=i+76|0;s=i+72|0;f[a>>2]=c;b[a+40>>0]=h&1;h=a+52|0;f[h>>2]=d;yCa();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[132548];f[j+4>>2]=f[132549];f[j+8>>2]=f[132550];f[j+12>>2]=f[132551];f[j+16>>2]=f[132552];f[j+20>>2]=f[132553]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=k+8|0;d=k+16|0;if(e|0){c=k+8|0;t=k+16|0;p[k>>3]=+n[e>>2];p[c>>3]=+n[e+12>>2];p[t>>3]=+n[e+24>>2];ZGc(l,k,j);n[a+4+((f[h>>2]^2)*3<<2)>>2]=+p[l>>3];ZGc(m,g,j);n[a+16>>2]=+p[m>>3];ZGc(o,d,j);n[a+4+((f[h>>2]|0)*3<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+4>>2];p[c>>3]=+n[e+16>>2];p[t>>3]=+n[e+28>>2];v=j+8|0;ZGc(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+1<<2)>>2]=+p[l>>3];ZGc(m,g,v);n[a+20>>2]=+p[m>>3];ZGc(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+1<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+8>>2];p[c>>3]=+n[e+20>>2];p[t>>3]=+n[e+32>>2];e=j+16|0;ZGc(l,k,e);n[a+4+(((f[h>>2]^2)*3|0)+2<<2)>>2]=+p[l>>3];ZGc(m,g,e);n[a+24>>2]=+p[m>>3];ZGc(o,d,e);n[a+4+(((f[h>>2]|0)*3|0)+2<<2)>>2]=+p[o>>3];CGc(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;CGc(r,6);CGc(k,29);JGc(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}e=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;t=530120+(e<<3)|0;if((t|0)!=(k|0)){c=t;t=f[c+4>>2]|0;v=k;f[v>>2]=f[c>>2];f[v+4>>2]=t}t=e+3|0;v=530120+(t<<3)|0;if((v|0)!=(g|0)){c=v;v=f[c+4>>2]|0;A=g;f[A>>2]=f[c>>2];f[A+4>>2]=v}v=530120+(e+6<<3)|0;if((v|0)!=(d|0)){A=v;v=f[A+4>>2]|0;c=d;f[c>>2]=f[A>>2];f[c+4>>2]=v}v=j+(e<<3)|0;ZGc(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+e<<2)>>2]=+p[l>>3];ZGc(m,g,v);n[a+4+(t<<2)>>2]=+p[m>>3];ZGc(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+e<<2)>>2]=+p[o>>3];e=e+1|0}while((e|0)!=3);CGc(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;CGc(r,6);CGc(k,29);JGc(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}function SCa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+80|0;j=i+56|0;k=i+32|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[132548];f[j+4>>2]=f[132549];f[j+8>>2]=f[132550];f[j+12>>2]=f[132551];f[j+16>>2]=f[132552];f[j+20>>2]=f[132553]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[530512]|0)==0?X0c(530512)|0:0)NGc(530520,4096);g=d*3|0;c=k+8|0;r=k+16|0;s=(d^2)*3|0;if(e|0){d=k+8|0;t=k+16|0;v=0;do{p[k>>3]=+n[e+(v<<2)>>2];w=v+3|0;p[d>>3]=+n[e+(w<<2)>>2];p[t>>3]=+n[e+(v+6<<2)>>2];ZGc(m,530520,k);x=j+(v<<3)|0;ZGc(l,m,x);y=RGc(l)|0;f[a+4+(v+g<<2)>>2]=y;ZGc(o,530520,c);ZGc(l,o,x);y=RGc(l)|0;f[a+4+(w<<2)>>2]=y;ZGc(q,530520,r);ZGc(l,q,x);x=RGc(l)|0;f[a+4+(v+s<<2)>>2]=x;v=v+1|0}while((v|0)!=3);z=h?1136608:1144800;A=a+40|0;f[A>>2]=z;u=i;return}v=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;e=530120+(v<<3)|0;if((e|0)!=(k|0)){t=e;e=f[t+4>>2]|0;d=k;f[d>>2]=f[t>>2];f[d+4>>2]=e}e=v+3|0;d=530120+(e<<3)|0;if((d|0)!=(c|0)){t=d;d=f[t+4>>2]|0;x=c;f[x>>2]=f[t>>2];f[x+4>>2]=d}d=530120+(v+6<<3)|0;if((d|0)!=(r|0)){x=d;d=f[x+4>>2]|0;t=r;f[t>>2]=f[x>>2];f[t+4>>2]=d}ZGc(m,530520,k);d=j+(v<<3)|0;ZGc(l,m,d);t=RGc(l)|0;f[a+4+(v+g<<2)>>2]=t;ZGc(o,530520,c);ZGc(l,o,d);t=RGc(l)|0;f[a+4+(e<<2)>>2]=t;ZGc(q,530520,r);ZGc(l,q,d);d=RGc(l)|0;f[a+4+(v+s<<2)>>2]=d;v=v+1|0}while((v|0)!=3);z=h?1136608:1144800;A=a+40|0;f[A>>2]=z;u=i;return}function TCa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+112|0;j=i+56|0;k=i+108|0;l=i+40|0;m=i+24|0;o=i+32|0;q=i+16|0;r=i+8|0;s=i;t=i+104|0;v=i+100|0;w=i+96|0;x=i+92|0;y=i+88|0;z=i+84|0;A=i+80|0;f[a>>2]=c;b[a+48>>0]=h&1;yCa();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[132548];f[j+4>>2]=f[132549];f[j+8>>2]=f[132550];f[j+12>>2]=f[132551];f[j+16>>2]=f[132552];f[j+20>>2]=f[132553]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=(d^2)*3|0;h=d*3|0;if(!e){UGc(k,530120);d=f[k>>2]|0;UGc(k,530144);c=f[k>>2]|0;UGc(k,530168);B=f[k>>2]|0;f[a+4+(g<<2)>>2]=d;f[a+16>>2]=c;f[a+4+(h<<2)>>2]=B;UGc(k,530128);B=f[k>>2]|0;UGc(k,530152);c=f[k>>2]|0;UGc(k,530176);d=f[k>>2]|0;f[a+4+(g+1<<2)>>2]=B;f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;UGc(k,530136);d=f[k>>2]|0;UGc(k,530160);c=f[k>>2]|0;UGc(k,530184);C=f[k>>2]|0;D=c;E=d}else{d=f[e+12>>2]|0;c=f[e+24>>2]|0;f[a+4+(g<<2)>>2]=f[e>>2];f[a+16>>2]=d;f[a+4+(h<<2)>>2]=c;c=f[e+16>>2]|0;d=f[e+28>>2]|0;f[a+4+(g+1<<2)>>2]=f[e+4>>2];f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;C=f[e+32>>2]|0;D=f[e+20>>2]|0;E=f[e+8>>2]|0}f[a+4+(g+2<<2)>>2]=E;f[a+24>>2]=D;f[a+4+(h+2<<2)>>2]=C;C=j+8|0;NGc(m,15);ZGc(l,C,m);VGc(o,j,l);NGc(r,3);ZGc(q,j+16|0,r);VGc(s,o,q);UGc(k,s);f[t>>2]=1065353216;f[q>>2]=872415232;s=KGc(k,q)|0;f[m>>2]=f[(s?k:q)>>2];JGc(l,t,m);f[k>>2]=f[l>>2];CGc(v,52);IGc(w,v,k);UGc(l,j);IGc(x,w,l);f[a+40>>2]=f[x>>2];CGc(y,117);IGc(z,y,k);UGc(l,C);IGc(A,z,l);f[a+44>>2]=f[A>>2];A=l;f[A>>2]=0;f[A+4>>2]=1072693248;if($Gc(C,l)|0){u=i;return}else{i=$Xc(32)|0;f[l>>2]=i;f[l+8>>2]=-2147483616;f[l+4>>2]=31;C=i;A=365031;a=C+31|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(a|0));b[i+31>>0]=0;vM(-215,l,365482,364957,3179)}}function UCa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0;g=u;u=u+32|0;i=g+8|0;j=g;f[a>>2]=c;yCa();if((b[530496]|0)==0?X0c(530496)|0:0)NGc(530504,4096);c=d*3|0;k=i+8|0;l=i+16|0;m=(d^2)*3|0;if(!e){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=530120;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=530144;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=530168;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;ZGc(j,530504,i);d=RGc(j)|0;f[a+4+(c<<2)>>2]=d;ZGc(j,530504,k);d=RGc(j)|0;f[a+16>>2]=d;ZGc(j,530504,l);d=RGc(j)|0;f[a+4+(m<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=530128;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=530152;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=530176;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;ZGc(j,530504,i);d=RGc(j)|0;f[a+4+(c+1<<2)>>2]=d;ZGc(j,530504,k);d=RGc(j)|0;f[a+20>>2]=d;ZGc(j,530504,l);d=RGc(j)|0;f[a+4+(m+1<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=530136;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=530160;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=530184;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;ZGc(j,530504,i);d=RGc(j)|0;f[a+4+(c+2<<2)>>2]=d;ZGc(j,530504,k);d=RGc(j)|0;f[a+24>>2]=d;ZGc(j,530504,l);d=RGc(j)|0;f[a+4+(m+2<<2)>>2]=d;r=h?1136608:1144800;s=a+40|0;f[s>>2]=r;u=g;return}else{p[i>>3]=+n[e>>2];d=i+8|0;p[d>>3]=+n[e+12>>2];o=i+16|0;p[o>>3]=+n[e+24>>2];ZGc(j,530504,i);q=RGc(j)|0;f[a+4+(c<<2)>>2]=q;ZGc(j,530504,k);q=RGc(j)|0;f[a+16>>2]=q;ZGc(j,530504,l);q=RGc(j)|0;f[a+4+(m<<2)>>2]=q;p[i>>3]=+n[e+4>>2];p[d>>3]=+n[e+16>>2];p[o>>3]=+n[e+28>>2];ZGc(j,530504,i);q=RGc(j)|0;f[a+4+(c+1<<2)>>2]=q;ZGc(j,530504,k);q=RGc(j)|0;f[a+20>>2]=q;ZGc(j,530504,l);q=RGc(j)|0;f[a+4+(m+1<<2)>>2]=q;p[i>>3]=+n[e+8>>2];p[d>>3]=+n[e+20>>2];p[o>>3]=+n[e+32>>2];ZGc(j,530504,i);i=RGc(j)|0;f[a+4+(c+2<<2)>>2]=i;ZGc(j,530504,k);k=RGc(j)|0;f[a+24>>2]=k;ZGc(j,530504,l);l=RGc(j)|0;f[a+4+(m+2<<2)>>2]=l;r=h?1136608:1144800;s=a+40|0;f[s>>2]=r;u=g;return}}function VCa(a){a=a|0;cYc(a);return}function WCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){XCa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function XCa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=b[a+48>>0]|0?f[222219]|0:0;p=+n[a+4>>2];q=+n[a+8>>2];r=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=+n[a+40>>2];B=+n[a+44>>2];a=e*3|0;if((e|0)<=0){u=g;return}e=(o|0)==0;C=(m|0)==4;D=d;d=0;while(1){E=+n[c+(d<<2)>>2];if(!(E>=8.0))F=E*.001107051968574524;else{G=(E+16.0)*.008620689623057842;F=G*(G*G)}G=(+n[c+(d+1<<2)>>2]+A*E)*3.0;H=.25/(B*E+ +n[c+(d+2<<2)>>2]);I=H>.25?.25:H;H=I<-.25?-.25:I;I=H*(G*(F*3.0));J=((E*156.0-G)*H+-5.0)*F;H=r*J+(q*F+p*I);n[h>>2]=H;G=w*J+(v*F+t*I);n[i>>2]=G;E=z*J+(y*F+x*I);n[j>>2]=E;n[k>>2]=0.0;K=H<0.0?k:h;n[l>>2]=1.0;L=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[h>>2]=L;n[k>>2]=0.0;K=G<0.0?k:i;n[l>>2]=1.0;M=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[i>>2]=M;n[k>>2]=0.0;K=E<0.0?k:j;n[l>>2]=1.0;N=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[j>>2]=N;if(e)O=L;else{E=(f[s>>2]=N,+n[s>>2]);G=(f[s>>2]=M,+n[s>>2]);H=(f[s>>2]=L,+n[s>>2])*1024.0;L=~~H;M=(L|0)>0?L:0;L=(M|0)<1023?M:1023;I=H-+(L|0);M=o+(L<<2<<2)|0;H=+n[M>>2]+I*(+n[M+4>>2]+I*(+n[M+8>>2]+ +n[M+12>>2]*I));n[h>>2]=H;I=G*1024.0;M=~~I;L=(M|0)>0?M:0;M=(L|0)<1023?L:1023;G=I-+(M|0);L=o+(M<<2<<2)|0;n[i>>2]=+n[L>>2]+G*(+n[L+4>>2]+G*(+n[L+8>>2]+ +n[L+12>>2]*G));G=E*1024.0;L=~~G;M=(L|0)>0?L:0;L=(M|0)<1023?M:1023;E=G-+(L|0);M=o+(L<<2<<2)|0;n[j>>2]=+n[M>>2]+E*(+n[M+4>>2]+E*(+n[M+8>>2]+ +n[M+12>>2]*E));O=(n[s>>2]=H,f[s>>2]|0)}f[D>>2]=O;f[D+4>>2]=f[i>>2];f[D+8>>2]=f[j>>2];if(C)n[D+12>>2]=1.0;d=d+3|0;if((d|0)>=(a|0))break;else D=D+(m<<2)|0}u=g;return}function YCa(a){a=a|0;cYc(a);return}function ZCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){_Ca(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function _Ca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;g=u;u=u+3088|0;i=g;j=g+3072|0;if(b[a+100>>0]|0){$Ca(a+56|0,c,d,e);u=g;return}k=f[a>>2]|0;if((b[530472]|0)==0?X0c(530472)|0:0){CGc(j,100);JGc(888968,j,888840)}if((b[530480]|0)==0?X0c(530480)|0:0)JGc(888972,888812,888840);if((b[530488]|0)==0?X0c(530488)|0:0)JGc(888976,888824,888840);if((e|0)>0){j=a+4|0;a=(k|0)==4;l=c;c=d;d=0;m=~e;while(1){o=(Y((m|0)>-257?m:-257,-3)|0)+-19|0;p=((o|0)>16?o:16)+-1&-16;o=p+16|0;q=e-d|0;r=(q|0)<256?q:256;s=+n[222242];t=+n[222243];v=+n[222244];w=+n[222201];x=+n[222204];q=r*3|0;y=q+-48|0;if((y|0)>0){z=0;while(1){A=l+z|0;B=b[A+4>>0]|0;C=b[A+5>>0]|0;D=b[A+6>>0]|0;E=b[A+7>>0]|0;F=b[A+8>>0]|0;G=b[A+9>>0]|0;H=b[A+10>>0]|0;I=b[A+11>>0]|0;J=b[A+12>>0]|0;K=b[A+13>>0]|0;L=b[A+14>>0]|0;M=b[A+15>>0]|0;N=i+(z<<2)|0;O=w+t*+(h[A+1>>0]|0);P=x+v*+(h[A+2>>0]|0);Q=s*+(h[A+3>>0]|0)+0.0;n[N>>2]=s*+(h[A>>0]|0)+0.0;n[N+4>>2]=O;n[N+8>>2]=P;n[N+12>>2]=Q;n[N+16>>2]=w+t*+(B&255);n[N+20>>2]=x+v*+(C&255);n[N+24>>2]=s*+(D&255)+0.0;n[N+28>>2]=w+t*+(E&255);n[N+32>>2]=x+v*+(F&255);n[N+36>>2]=s*+(G&255)+0.0;n[N+40>>2]=w+t*+(H&255);n[N+44>>2]=x+v*+(I&255);n[N+48>>2]=s*+(J&255)+0.0;n[N+52>>2]=w+t*+(K&255);n[N+56>>2]=x+v*+(L&255);n[N+60>>2]=s*+(M&255)+0.0;M=A+16|0;L=b[M+4>>0]|0;K=b[M+5>>0]|0;J=b[M+6>>0]|0;I=b[M+7>>0]|0;H=b[M+8>>0]|0;G=b[M+9>>0]|0;F=b[M+10>>0]|0;E=b[M+11>>0]|0;D=b[M+12>>0]|0;C=b[M+13>>0]|0;B=b[M+14>>0]|0;R=b[M+15>>0]|0;Q=x+v*+(h[M+1>>0]|0);P=s*+(h[M+2>>0]|0)+0.0;O=w+t*+(h[M+3>>0]|0);n[N+64>>2]=w+t*+(h[M>>0]|0);n[N+68>>2]=Q;n[N+72>>2]=P;n[N+76>>2]=O;n[N+80>>2]=x+v*+(L&255);n[N+84>>2]=s*+(K&255)+0.0;n[N+88>>2]=w+t*+(J&255);n[N+92>>2]=x+v*+(I&255);n[N+96>>2]=s*+(H&255)+0.0;n[N+100>>2]=w+t*+(G&255);n[N+104>>2]=x+v*+(F&255);n[N+108>>2]=s*+(E&255)+0.0;n[N+112>>2]=w+t*+(D&255);n[N+116>>2]=x+v*+(C&255);n[N+120>>2]=s*+(B&255)+0.0;n[N+124>>2]=w+t*+(R&255);R=A+32|0;A=b[R+4>>0]|0;B=b[R+5>>0]|0;C=b[R+6>>0]|0;D=b[R+7>>0]|0;E=b[R+8>>0]|0;F=b[R+9>>0]|0;G=b[R+10>>0]|0;H=b[R+11>>0]|0;I=b[R+12>>0]|0;J=b[R+13>>0]|0;K=b[R+14>>0]|0;L=b[R+15>>0]|0;O=s*+(h[R+1>>0]|0)+0.0;P=w+t*+(h[R+2>>0]|0);Q=x+v*+(h[R+3>>0]|0);n[N+128>>2]=x+v*+(h[R>>0]|0);n[N+132>>2]=O;n[N+136>>2]=P;n[N+140>>2]=Q;n[N+144>>2]=s*+(A&255)+0.0;n[N+148>>2]=w+t*+(B&255);n[N+152>>2]=x+v*+(C&255);n[N+156>>2]=s*+(D&255)+0.0;n[N+160>>2]=w+t*+(E&255);n[N+164>>2]=x+v*+(F&255);n[N+168>>2]=s*+(G&255)+0.0;n[N+172>>2]=w+t*+(H&255);n[N+176>>2]=x+v*+(I&255);n[N+180>>2]=s*+(J&255)+0.0;n[N+184>>2]=w+t*+(K&255);n[N+188>>2]=x+v*+(L&255);L=z+48|0;if((L|0)<(y|0))z=L;else{S=L;break}}}else S=0;if((S|0)<(q|0)){v=+n[222242];x=+n[222243];t=+n[222201];w=+n[222244];s=+n[222204];z=S;do{n[i+(z<<2)>>2]=+(h[l+z>>0]|0)*v;y=z+1|0;n[i+(y<<2)>>2]=+(h[l+y>>0]|0)*x+t;y=z+2|0;n[i+(y<<2)>>2]=+(h[l+y>>0]|0)*w+s;z=z+3|0}while((z|0)<(q|0))}XCa(j,i,i,r);z=q+-16|0;if((q|0)>16){y=c+16|0;L=c;N=0;while(1){K=i+(N<<2)|0;s=+n[K+16>>2];w=+n[K+20>>2];t=+n[K+24>>2];x=+n[K+28>>2];v=+n[K+32>>2];Q=+n[K+36>>2];P=+n[K+40>>2];O=+n[K+44>>2];T=+n[K+48>>2];U=+n[K+52>>2];V=+n[K+56>>2];W=+n[K+60>>2];X=+n[K+4>>2]*255.0;Z=+n[K+8>>2]*255.0;_=+n[K+12>>2]*255.0;J=ALc(+n[K>>2]*255.0)|0;K=ALc(X)|0;I=ALc(Z)|0;H=ALc(_)|0;G=ALc(s*255.0)|0;F=ALc(w*255.0)|0;E=ALc(t*255.0)|0;D=ALc(x*255.0)|0;C=ALc(v*255.0)|0;B=ALc(Q*255.0)|0;A=ALc(P*255.0)|0;R=ALc(O*255.0)|0;M=ALc(T*255.0)|0;$=ALc(U*255.0)|0;aa=ALc(V*255.0)|0;ba=ALc(W*255.0)|0;ca=((J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768)&65535;J=((C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768)&65535;C=((K+32768|0)>>>0<65536?K:(K|0)>0?32767:32768)&65535;K=((B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768)&65535;B=((I+32768|0)>>>0<65536?I:(I|0)>0?32767:32768)&65535;I=((A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768)&65535;A=((H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768)&65535;H=((R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768)&65535;R=((G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768)&65535;G=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=((F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768)&65535;F=(($+32768|0)>>>0<65536?$:($|0)>0?32767:32768)&65535;$=((E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768)&65535;E=((aa+32768|0)>>>0<65536?aa:(aa|0)>0?32767:32768)&65535;aa=((D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768)&65535;D=((ba+32768|0)>>>0<65536?ba:(ba|0)>0?32767:32768)&65535;b[L>>0]=ca>>>0<255?ca:255;b[L+1>>0]=C>>>0<255?C:255;b[L+2>>0]=B>>>0<255?B:255;b[L+3>>0]=A>>>0<255?A:255;b[L+4>>0]=R>>>0<255?R:255;b[L+5>>0]=M>>>0<255?M:255;b[L+6>>0]=$>>>0<255?$:255;b[L+7>>0]=aa>>>0<255?aa:255;b[L+8>>0]=J>>>0<255?J:255;b[L+9>>0]=K>>>0<255?K:255;b[L+10>>0]=I>>>0<255?I:255;b[L+11>>0]=H>>>0<255?H:255;b[L+12>>0]=G>>>0<255?G:255;b[L+13>>0]=F>>>0<255?F:255;b[L+14>>0]=E>>>0<255?E:255;b[L+15>>0]=D>>>0<255?D:255;N=N+16|0;if((N|0)>=(z|0))break;else L=L+16|0}da=y+p|0;ea=o}else{da=c;ea=0}if((ea|0)<(q|0))if(a){L=da;z=ea;while(1){N=ALc(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=N>>>0<256?N:(N|0)>0?255:0;N=ALc(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=N>>>0<256?N:(N|0)>0?255:0;N=ALc(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=N>>>0<256?N:(N|0)>0?255:0;b[L+3>>0]=-1;z=z+3|0;N=L+4|0;if((z|0)>=(q|0)){fa=N;break}else L=N}}else{L=da;z=ea;while(1){o=ALc(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=o>>>0<256?o:(o|0)>0?255:0;o=ALc(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=ALc(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=o>>>0<256?o:(o|0)>0?255:0;z=z+3|0;o=L+k|0;if((z|0)>=(q|0)){fa=o;break}else L=o}}else fa=da;d=d+256|0;if((d|0)>=(e|0))break;else{l=l+768|0;c=fa;m=m+256|0}}}u=g;return}function $Ca(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}if((k|0)==4){e=0;m=d;while(1){aDa(a,b[c+e>>0]|0,b[c+(e+1)>>0]|0,b[c+(e+2)>>0]|0,h,i,j);n=f[j>>2]|0;b[m>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[i>>2]|0;b[m+1>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[h>>2]|0;b[m+2>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+3>>0]=-1;e=e+3|0;if((e|0)>=(l|0))break;else m=m+4|0}u=g;return}else{m=0;e=d;while(1){aDa(a,b[c+m>>0]|0,b[c+(m+1)>>0]|0,b[c+(m+2)>>0]|0,h,i,j);d=f[j>>2]|0;b[e>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[i>>2]|0;b[e+1>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[h>>2]|0;b[e+2>>0]=d>>>0<256?d:(d|0)>0?255:0;m=m+3|0;if((m|0)>=(l|0))break;else e=e+k|0}u=g;return}}function aDa(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=b&255;b=d[1159136+(k<<1<<1)>>1]|0;l=k<<8;k=f[(f[222225]|0)+((l|c&255)<<2)>>2]|0;c=e&255|l;l=f[(f[222226]|0)+(c<<2)>>2]|0;e=x1c(l|0,((l|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;k=J;l=v1c(e|0,k|0,16384,0)|0;m=b&65535;n=Y(l,m)|0;l=(n|0)/16384|0;o=(f[222227]|0)+(c<<3)|0;c=f[o>>2]|0;p=f[o+4>>2]|0;o=x1c(e|0,k|0,-85,-1)|0;k=d1c(o|0,J|0,c|0,p|0)|0;p=v1c(k|0,J|0,16384,0)|0;k=d1c(p|0,J|0,-20889600,-1)|0;p=x1c(k|0,J|0,b&65535|0,0)|0;b=v1c(p|0,J|0,16384,0)|0;p=((b|0)/256|0)+((b|0)/65536|0)|0;b=(n|0)>16383?((l|0)<32768?l:32768):0;l=(p|0)>0?((p|0)<32768?p:32768):0;p=f[a+16>>2]|0;n=f[a+20>>2]|0;k=f[a+24>>2]|0;c=f[a+28>>2]|0;o=f[a+32>>2]|0;e=f[a+36>>2]|0;q=(Y(f[a+8>>2]|0,m)|0)+8192+(Y(b,f[a+4>>2]|0)|0)+(Y(l,f[a+12>>2]|0)|0)>>14;f[g>>2]=q;q=(Y(n,m)|0)+8192+(Y(b,p)|0)+(Y(l,k)|0)>>14;f[h>>2]=q;q=(Y(c,b)|0)+8192+(Y(o,m)|0)+(Y(l,e)|0)>>14;f[i>>2]=q;q=f[g>>2]|0;f[g>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[h>>2]|0;f[h>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[i>>2]|0;f[i>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[a+40>>2]|0;f[g>>2]=j[q+(f[g>>2]<<1)>>1];f[h>>2]=j[q+(f[h>>2]<<1)>>1];f[i>>2]=j[q+(f[i>>2]<<1)>>1];return}function bDa(a){a=a|0;cYc(a);return}function cDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){dDa(f[h>>2]|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function dDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0;g=f[a>>2]|0;h=b[a+40>>0]|0?f[222219]|0:0;i=+n[a+4>>2];j=+n[a+8>>2];k=+n[a+12>>2];l=+n[a+16>>2];m=+n[a+20>>2];o=+n[a+24>>2];p=+n[a+28>>2];q=+n[a+32>>2];r=+n[a+36>>2];s=e*3|0;if((e|0)<=0)return;e=a+44|0;t=a+48|0;a=(h|0)==0;u=(g|0)==4;v=d;d=0;while(1){w=+n[c+(d<<2)>>2];if(!(w<=+n[e>>2])){x=(w+16.0)/116.0;y=x;z=x*(x*x)}else{x=w/903.2999877929688;y=x*7.7870001792907715+.13793103396892548;z=x}x=+n[c+(d+1<<2)>>2]/500.0+y;w=y-+n[c+(d+2<<2)>>2]/200.0;A=+n[t>>2];if(!(x<=A))B=x*(x*x);else B=(x+-.13793103396892548)/7.7870001792907715;if(!(w<=A))C=w*(w*w);else C=(w+-.13793103396892548)/7.7870001792907715;w=j*z+i*B+k*C;A=m*z+l*B+o*C;x=q*z+p*B+r*C;D=w<0.0?0.0:w>1.0?1.0:w;w=A<0.0?0.0:A>1.0?1.0:A;A=x<0.0?0.0:x>1.0?1.0:x;if(a){E=A;F=w;G=D}else{x=D*1024.0;H=~~x;I=(H|0)>0?H:0;H=(I|0)<1023?I:1023;D=x-+(H|0);I=h+(H<<2<<2)|0;x=w*1024.0;H=~~x;J=(H|0)>0?H:0;H=(J|0)<1023?J:1023;w=x-+(H|0);J=h+(H<<2<<2)|0;x=A*1024.0;H=~~x;K=(H|0)>0?H:0;H=(K|0)<1023?K:1023;A=x-+(H|0);K=h+(H<<2<<2)|0;E=+n[K>>2]+A*(+n[K+4>>2]+A*(A*+n[K+12>>2]+ +n[K+8>>2]));F=+n[J>>2]+w*(+n[J+4>>2]+w*(w*+n[J+12>>2]+ +n[J+8>>2]));G=+n[I>>2]+D*(+n[I+4>>2]+D*(D*+n[I+12>>2]+ +n[I+8>>2]))}n[v>>2]=G;n[v+4>>2]=F;n[v+8>>2]=E;if(u)n[v+12>>2]=1.0;d=d+3|0;if((d|0)>=(s|0))break;else v=v+(g<<2)|0}return}function eDa(a){a=a|0;cYc(a);return}function fDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;d=a+8|0;e=a+16|0;g=b+4|0;if((c|0)>=(f[g>>2]|0))return;b=(f[a+12>>2]|0)+(Y(f[e>>2]|0,c)|0)|0;h=a+24|0;i=a+20|0;j=b;b=(f[a+4>>2]|0)+(Y(f[d>>2]|0,c)|0)|0;a=c;while(1){gDa((f[h>>2]|0)+56|0,b,j,f[i>>2]|0);a=a+1|0;if((a|0)>=(f[g>>2]|0))break;else{j=j+(f[e>>2]|0)|0;b=b+(f[d>>2]|0)|0}}return}function gDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}if((k|0)==4){e=0;m=d;while(1){hDa(a,b[c+e>>0]|0,b[c+(e+1)>>0]|0,b[c+(e+2)>>0]|0,h,i,j);n=f[j>>2]|0;b[m>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[i>>2]|0;b[m+1>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[h>>2]|0;b[m+2>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+3>>0]=-1;e=e+3|0;if((e|0)>=(l|0))break;else m=m+4|0}u=g;return}else{m=0;e=d;while(1){hDa(a,b[c+m>>0]|0,b[c+(m+1)>>0]|0,b[c+(m+2)>>0]|0,h,i,j);d=f[j>>2]|0;b[e>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[i>>2]|0;b[e+1>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[h>>2]|0;b[e+2>>0]=d>>>0<256?d:(d|0)>0?255:0;m=m+3|0;if((m|0)>=(l|0))break;else e=e+k|0}u=g;return}}function hDa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0;i=(b&255)<<1;b=j[1159136+((i|1)<<1)>>1]|0;k=f[222224]|0;l=f[k+(((((c&255)*268435|0)+128|0)>>>13)+-4194+b+8145<<2)>>2]|0;c=f[k+(10484-((((d&255)*41943|0)+16|0)>>>9)+b+8145<<2)>>2]|0;b=j[1159136+(i<<1)>>1]|0;i=f[a+16>>2]|0;d=f[a+20>>2]|0;k=f[a+24>>2]|0;m=f[a+28>>2]|0;n=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(Y(f[a+4>>2]|0,l)|0)+8192+(Y(f[a+8>>2]|0,b)|0)+(Y(f[a+12>>2]|0,c)|0)>>14;f[e>>2]=p;p=(Y(i,l)|0)+8192+(Y(d,b)|0)+(Y(k,c)|0)>>14;f[g>>2]=p;p=(Y(m,l)|0)+8192+(Y(n,b)|0)+(Y(o,c)|0)>>14;f[h>>2]=p;p=f[e>>2]|0;f[e>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[g>>2]|0;f[g>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[h>>2]|0;f[h>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[a+40>>2]|0;f[e>>2]=j[p+(f[e>>2]<<1)>>1];f[g>>2]=j[p+(f[g>>2]<<1)>>1];f[h>>2]=j[p+(f[h>>2]<<1)>>1];return}function iDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;jDa(g,a,b,3);uCa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,1,d);kDa(g);u=e;return}function jDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=x>>>3;z=(y&511)+1|0;f[a+116>>2]=z;A=x&7;B=a+112|0;f[B>>2]=A;if((y&510|0)!=2)sV(z,78336);if((e|0)!=3)sV(e,78364);switch(x&7){case 0:case 5:break;default:pV(A,78392)}A=c+4|0;x=d+4|0;if((f[A>>2]|0)!=(f[x>>2]|0)){do if((eS(c)|0)==65536){e=f[A>>2]|0;f[h>>2]=f[e>>2];z=h+4|0;y=e+4|0;f[z>>2]=f[y>>2];C=h+8|0;f[C>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];D=f[e+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=C;C=h+48|0;E=h+44|0;f[E>>2]=C;f[C>>2]=0;f[h+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[y>>2]|0)<3){y=f[e+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[y>>2];f[C+4>>2]=f[y+4>>2];break}else{f[z>>2]=0;U$(h,e);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){A=h+36|0;e=f[A>>2]|0;if((e|0)!=0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0){V$(h);F=A}else F=A}else{A=a+36|0;e=f[A>>2]|0;if(e|0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0)V$(a);f[A>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];y=h+4|0;z=f[y>>2]|0;f[j>>2]=z;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];e=h+36|0;f[A>>2]=f[e>>2];A=a+44|0;C=f[A>>2]|0;if((C|0)==(o|0))G=z;else{wL(C);f[A>>2]=o;f[l>>2]=k;G=f[y>>2]|0}k=h+44|0;if((G|0)<3){G=f[k>>2]|0;f[o>>2]=f[G>>2];f[a+52>>2]=f[G+4>>2]}else{f[A>>2]=f[k>>2];A=h+40|0;f[a+40>>2]=f[A>>2];f[k>>2]=h+48;f[A>>2]=j}f[h>>2]=1124007936;m=y;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));F=e}f[F>>2]=0;F=h+16|0;e=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[e>>2]|0)>0){F=f[h+40>>2]|0;y=0;do{f[F+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)!=(h+48|0))wL(e)}else{e=h+8|0;f[e>>2]=0;f[e+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;e=f[c>>2]|0;f[v>>2]=l;f[w>>2]=e;f[i>>2]=l;f[i+4>>2]=e;wS(d,i,f[B>>2]&7|16,-1,0,0);do if((eS(d)|0)==65536){B=f[x>>2]|0;f[h>>2]=f[B>>2];i=h+4|0;e=B+4|0;f[i>>2]=f[e>>2];l=h+8|0;f[l>>2]=f[B+8>>2];f[h+12>>2]=f[B+12>>2];f[h+16>>2]=f[B+16>>2];f[h+20>>2]=f[B+20>>2];f[h+24>>2]=f[B+24>>2];f[h+28>>2]=f[B+28>>2];f[h+32>>2]=f[B+32>>2];w=f[B+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[e>>2]|0)<3){e=f[B+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];break}else{f[i>>2]=0;U$(h,B);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;x=f[d>>2]|0;if((x|0)!=0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0){V$(h);H=d}else H=d}else{d=a+92|0;x=f[d>>2]|0;if(x|0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0)V$(p);f[d>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){B=f[s>>2]|0;i=0;do{f[B+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];x=h+36|0;f[d>>2]=f[x>>2];d=a+100|0;B=f[d>>2]|0;if((B|0)==(t|0))I=i;else{wL(B);f[d>>2]=t;f[s>>2]=r;I=f[p>>2]|0}r=h+44|0;if((I|0)<3){I=f[r>>2]|0;f[t>>2]=f[I>>2];f[a+108>>2]=f[I+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=x}f[H>>2]=0;H=h+16|0;x=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[x>>2]|0)>0){H=f[h+40>>2]|0;m=0;do{f[H+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)==(h+48|0)){u=g;return}wL(x);u=g;return}function kDa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function lDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+128|0;g=e;jDa(g,a,b,3);uCa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,f[g+116>>2]|0,c,0,d);kDa(g);u=e;return}function mDa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;nDa(h,a,b,i);QCa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,1,e);oDa(h);u=g;return}function nDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=(x>>>3&511)+1|0;f[a+116>>2]=y;z=x&7;A=a+112|0;f[A>>2]=z;if((y|0)!=3)sV(y,78420);if((e+-3|0)>>>0>=2)sV(e,78448);switch(x&7){case 0:case 5:break;default:pV(z,78476)}z=c+4|0;x=d+4|0;if((f[z>>2]|0)!=(f[x>>2]|0)){do if((eS(c)|0)==65536){y=f[z>>2]|0;f[h>>2]=f[y>>2];B=h+4|0;C=y+4|0;f[B>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[y+8>>2];f[h+12>>2]=f[y+12>>2];f[h+16>>2]=f[y+16>>2];f[h+20>>2]=f[y+20>>2];f[h+24>>2]=f[y+24>>2];f[h+28>>2]=f[y+28>>2];f[h+32>>2]=f[y+32>>2];E=f[y+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[y+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;U$(h,y);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0){V$(h);G=z}else G=z}else{z=a+36|0;y=f[z>>2]|0;if(y|0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0)V$(a);f[z>>2]=0;y=a+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){B=f[l>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];C=h+4|0;B=f[C>>2]|0;f[j>>2]=B;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[y>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];y=h+36|0;f[z>>2]=f[y>>2];z=a+44|0;D=f[z>>2]|0;if((D|0)==(o|0))H=B;else{wL(D);f[z>>2]=o;f[l>>2]=k;H=f[C>>2]|0}k=h+44|0;if((H|0)<3){H=f[k>>2]|0;f[o>>2]=f[H>>2];f[a+52>>2]=f[H+4>>2]}else{f[z>>2]=f[k>>2];z=h+40|0;f[a+40>>2]=f[z>>2];f[k>>2]=h+48;f[z>>2]=j}f[h>>2]=1124007936;m=C;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));G=y}f[G>>2]=0;G=h+16|0;y=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[y>>2]|0)>0){G=f[h+40>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)!=(h+48|0))wL(y)}else{y=h+8|0;f[y>>2]=0;f[y+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;y=f[c>>2]|0;f[v>>2]=l;f[w>>2]=y;f[i>>2]=l;f[i+4>>2]=y;wS(d,i,f[A>>2]&7|(e<<3)+-8,-1,0,0);do if((eS(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];A=h+4|0;i=e+4|0;f[A>>2]=f[i>>2];y=h+8|0;f[y>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=y;y=h+48|0;w=h+44|0;f[w>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(l|0){y=l+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;y=f[w>>2]|0;f[y>>2]=f[i>>2];f[y+4>>2]=f[i+4>>2];break}else{f[A>>2]=0;U$(h,e);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;x=f[d>>2]|0;if((x|0)!=0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0){V$(h);I=d}else I=d}else{d=a+92|0;x=f[d>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)V$(p);f[d>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;A=0;do{f[e+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;A=f[p>>2]|0;f[q>>2]=A;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];x=h+36|0;f[d>>2]=f[x>>2];d=a+100|0;e=f[d>>2]|0;if((e|0)==(t|0))J=A;else{wL(e);f[d>>2]=t;f[s>>2]=r;J=f[p>>2]|0}r=h+44|0;if((J|0)<3){J=f[r>>2]|0;f[t>>2]=f[J>>2];f[a+108>>2]=f[J+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));I=x}f[I>>2]=0;I=h+16|0;x=h+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[x>>2]|0)>0){I=f[h+40>>2]|0;m=0;do{f[I+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)==(h+48|0)){u=g;return}wL(x);u=g;return}function oDa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function pDa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+128|0;h=g;i=(c|0)<1?3:c;nDa(h,a,b,i);QCa(f[h+16>>2]|0,f[h+48>>2]|0,f[h+72>>2]|0,f[h+104>>2]|0,f[h+12>>2]|0,f[h+8>>2]|0,f[h+112>>2]|0,i,d,0,e);oDa(h);u=g;return}function qDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+128|0;e=d;rDa(e,a,b,3);bCa(f[e+16>>2]|0,f[e+48>>2]|0,f[e+72>>2]|0,f[e+104>>2]|0,f[e+12>>2]|0,f[e+8>>2]|0,f[e+112>>2]|0,f[e+116>>2]|0,c);sDa(e);u=d;return}function rDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=x>>>3;z=(y&511)+1|0;f[a+116>>2]=z;A=x&7;B=a+112|0;f[B>>2]=A;if((y&510|0)!=2)sV(z,78504);if((e|0)!=3)sV(e,78532);switch(x&7){case 0:case 2:case 5:break;default:pV(A,78560)}A=c+4|0;x=d+4|0;if((f[A>>2]|0)!=(f[x>>2]|0)){do if((eS(c)|0)==65536){e=f[A>>2]|0;f[h>>2]=f[e>>2];z=h+4|0;y=e+4|0;f[z>>2]=f[y>>2];C=h+8|0;f[C>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];D=f[e+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=C;C=h+48|0;E=h+44|0;f[E>>2]=C;f[C>>2]=0;f[h+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[y>>2]|0)<3){y=f[e+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[y>>2];f[C+4>>2]=f[y+4>>2];break}else{f[z>>2]=0;U$(h,e);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){A=h+36|0;e=f[A>>2]|0;if((e|0)!=0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0){V$(h);F=A}else F=A}else{A=a+36|0;e=f[A>>2]|0;if(e|0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0)V$(a);f[A>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[j>>2]|0)>0){z=f[l>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];y=h+4|0;z=f[y>>2]|0;f[j>>2]=z;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[e>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];e=h+36|0;f[A>>2]=f[e>>2];A=a+44|0;C=f[A>>2]|0;if((C|0)==(o|0))G=z;else{wL(C);f[A>>2]=o;f[l>>2]=k;G=f[y>>2]|0}k=h+44|0;if((G|0)<3){G=f[k>>2]|0;f[o>>2]=f[G>>2];f[a+52>>2]=f[G+4>>2]}else{f[A>>2]=f[k>>2];A=h+40|0;f[a+40>>2]=f[A>>2];f[k>>2]=h+48;f[A>>2]=j}f[h>>2]=1124007936;m=y;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));F=e}f[F>>2]=0;F=h+16|0;e=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[e>>2]|0)>0){F=f[h+40>>2]|0;y=0;do{f[F+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[e>>2]|0))}e=f[h+44>>2]|0;if((e|0)!=(h+48|0))wL(e)}else{e=h+8|0;f[e>>2]=0;f[e+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;e=f[c>>2]|0;f[v>>2]=l;f[w>>2]=e;f[i>>2]=l;f[i+4>>2]=e;wS(d,i,f[B>>2]&7|16,-1,0,0);do if((eS(d)|0)==65536){B=f[x>>2]|0;f[h>>2]=f[B>>2];i=h+4|0;e=B+4|0;f[i>>2]=f[e>>2];l=h+8|0;f[l>>2]=f[B+8>>2];f[h+12>>2]=f[B+12>>2];f[h+16>>2]=f[B+16>>2];f[h+20>>2]=f[B+20>>2];f[h+24>>2]=f[B+24>>2];f[h+28>>2]=f[B+28>>2];f[h+32>>2]=f[B+32>>2];w=f[B+36>>2]|0;f[h+36>>2]=w;f[h+40>>2]=l;l=h+48|0;v=h+44|0;f[v>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(w|0){l=w+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[e>>2]|0)<3){e=f[B+44>>2]|0;l=f[v>>2]|0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];break}else{f[i>>2]=0;U$(h,B);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;x=f[d>>2]|0;if((x|0)!=0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0){V$(h);H=d}else H=d}else{d=a+92|0;x=f[d>>2]|0;if(x|0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0)V$(p);f[d>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){B=f[s>>2]|0;i=0;do{f[B+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;i=f[p>>2]|0;f[q>>2]=i;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];x=h+36|0;f[d>>2]=f[x>>2];d=a+100|0;B=f[d>>2]|0;if((B|0)==(t|0))I=i;else{wL(B);f[d>>2]=t;f[s>>2]=r;I=f[p>>2]|0}r=h+44|0;if((I|0)<3){I=f[r>>2]|0;f[t>>2]=f[I>>2];f[a+108>>2]=f[I+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));H=x}f[H>>2]=0;H=h+16|0;x=h+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[x>>2]|0)>0){H=f[h+40>>2]|0;m=0;do{f[H+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)==(h+48|0)){u=g;return}wL(x);u=g;return}function sDa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function tDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+128|0;g=e;h=(c|0)<1?3:c;uDa(g,a,b,h);kCa(f[g+16>>2]|0,f[g+48>>2]|0,f[g+72>>2]|0,f[g+104>>2]|0,f[g+12>>2]|0,f[g+8>>2]|0,f[g+112>>2]|0,h,d);vDa(g);u=e;return}function uDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+64|0;h=g+8|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;p=a+56|0;f[p>>2]=1124007936;q=a+60|0;r=a+64|0;s=a+96|0;m=q;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[s>>2]=r;t=a+104|0;f[a+100>>2]=t;f[t>>2]=0;f[a+108>>2]=0;v=a+120|0;f[v>>2]=0;w=a+124|0;f[w>>2]=0;if(sS(c)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=$Xc(16)|0;f[h>>2]=x;f[h+8>>2]=-2147483632;f[h+4>>2]=13;m=x;y=371335;n=m+13|0;do{b[m>>0]=b[y>>0]|0;m=m+1|0;y=y+1|0}while((m|0)<(n|0));b[x+13>>0]=0;vM(-215,h,371349,371359,254)}x=dS(c,-1)|0;y=(x>>>3&511)+1|0;f[a+116>>2]=y;z=x&7;A=a+112|0;f[A>>2]=z;if((y|0)!=3)sV(y,78588);if((e+-3|0)>>>0>=2)sV(e,78616);switch(x&7){case 0:case 2:case 5:break;default:pV(z,78644)}z=c+4|0;x=d+4|0;if((f[z>>2]|0)!=(f[x>>2]|0)){do if((eS(c)|0)==65536){y=f[z>>2]|0;f[h>>2]=f[y>>2];B=h+4|0;C=y+4|0;f[B>>2]=f[C>>2];D=h+8|0;f[D>>2]=f[y+8>>2];f[h+12>>2]=f[y+12>>2];f[h+16>>2]=f[y+16>>2];f[h+20>>2]=f[y+20>>2];f[h+24>>2]=f[y+24>>2];f[h+28>>2]=f[y+28>>2];f[h+32>>2]=f[y+32>>2];E=f[y+36>>2]|0;f[h+36>>2]=E;f[h+40>>2]=D;D=h+48|0;F=h+44|0;f[F>>2]=D;f[D>>2]=0;f[h+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[y+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;U$(h,y);break}}else bS(h,c,-1);while(0);if((a|0)==(h|0)){z=h+36|0;y=f[z>>2]|0;if((y|0)!=0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0){V$(h);G=z}else G=z}else{z=a+36|0;y=f[z>>2]|0;if(y|0?(B=y+12|0,y=f[B>>2]|0,f[B>>2]=y+-1,(y|0)==1):0)V$(a);f[z>>2]=0;y=a+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[j>>2]|0)>0){B=f[l>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[j>>2]|0))}f[a>>2]=f[h>>2];C=h+4|0;B=f[C>>2]|0;f[j>>2]=B;j=h+8|0;f[k>>2]=f[j>>2];f[a+12>>2]=f[h+12>>2];f[y>>2]=f[h+16>>2];f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];y=h+36|0;f[z>>2]=f[y>>2];z=a+44|0;D=f[z>>2]|0;if((D|0)==(o|0))H=B;else{wL(D);f[z>>2]=o;f[l>>2]=k;H=f[C>>2]|0}k=h+44|0;if((H|0)<3){H=f[k>>2]|0;f[o>>2]=f[H>>2];f[a+52>>2]=f[H+4>>2]}else{f[z>>2]=f[k>>2];z=h+40|0;f[a+40>>2]=f[z>>2];f[k>>2]=h+48;f[z>>2]=j}f[h>>2]=1124007936;m=C;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));G=y}f[G>>2]=0;G=h+16|0;y=h+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[y>>2]|0)>0){G=f[h+40>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[y>>2]|0))}y=f[h+44>>2]|0;if((y|0)!=(h+48|0))wL(y)}else{y=h+8|0;f[y>>2]=0;f[y+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=a;uS(c,h)}c=f[l>>2]|0;l=f[c+4>>2]|0;y=f[c>>2]|0;f[v>>2]=l;f[w>>2]=y;f[i>>2]=l;f[i+4>>2]=y;wS(d,i,f[A>>2]&7|(e<<3)+-8,-1,0,0);do if((eS(d)|0)==65536){e=f[x>>2]|0;f[h>>2]=f[e>>2];A=h+4|0;i=e+4|0;f[A>>2]=f[i>>2];y=h+8|0;f[y>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[h+36>>2]=l;f[h+40>>2]=y;y=h+48|0;w=h+44|0;f[w>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(l|0){y=l+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[i>>2]|0)<3){i=f[e+44>>2]|0;y=f[w>>2]|0;f[y>>2]=f[i>>2];f[y+4>>2]=f[i+4>>2];break}else{f[A>>2]=0;U$(h,e);break}}else bS(h,d,-1);while(0);if((p|0)==(h|0)){d=h+36|0;x=f[d>>2]|0;if((x|0)!=0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0){V$(h);I=d}else I=d}else{d=a+92|0;x=f[d>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)V$(p);f[d>>2]=0;x=a+72|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[q>>2]|0)>0){e=f[s>>2]|0;A=0;do{f[e+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[q>>2]|0))}f[p>>2]=f[h>>2];p=h+4|0;A=f[p>>2]|0;f[q>>2]=A;q=h+8|0;f[r>>2]=f[q>>2];f[a+68>>2]=f[h+12>>2];f[x>>2]=f[h+16>>2];f[a+76>>2]=f[h+20>>2];f[a+80>>2]=f[h+24>>2];f[a+84>>2]=f[h+28>>2];f[a+88>>2]=f[h+32>>2];x=h+36|0;f[d>>2]=f[x>>2];d=a+100|0;e=f[d>>2]|0;if((e|0)==(t|0))J=A;else{wL(e);f[d>>2]=t;f[s>>2]=r;J=f[p>>2]|0}r=h+44|0;if((J|0)<3){J=f[r>>2]|0;f[t>>2]=f[J>>2];f[a+108>>2]=f[J+4>>2]}else{f[d>>2]=f[r>>2];d=h+40|0;f[a+96>>2]=f[d>>2];f[r>>2]=h+48;f[d>>2]=q}f[h>>2]=1124007936;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));I=x}f[I>>2]=0;I=h+16|0;x=h+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[x>>2]|0)>0){I=f[h+40>>2]|0;m=0;do{f[I+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)==(h+48|0)){u=g;return}wL(x);u=g;return}function vDa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+56|0;c=a+92|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)V$(b);f[c>>2]=0;c=a+72|0;b=a+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+96>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+100>>2]|0;if((b|0)!=(a+104|0))wL(b);b=a+36|0;d=f[b>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)V$(a);f[b>>2]=0;b=a+16|0;d=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+40>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+44>>2]|0;if((d|0)==(a+48|0))return;wL(d);return}function wDa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;i=+i;var j=0,k=0,l=0.0;a:do if(YS(b)|0){j=dS(b,-1)|0;switch(j|0){case 13:case 21:{k=j;break a;break}default:{}}qV(j,78672)}else k=13;while(0);l=c;c=d;if(f==0.0&g==0.0){xDa(a,b,k,l,c,e,2147483647,h,i);return}else{j=zLc(f)|0;yDa(a,b,k,l,c,e,j,zLc(g)|0,2147483647,h,i);return}}function xDa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0;l=u;u=u+2544|0;m=l+224|0;o=l+2480|0;p=l+2424|0;q=l;r=l+2408|0;s=l+1344|0;t=l+280|0;v=(d|0)==13;switch(d|0){case 13:case 21:break;default:qV(d,78728)}do if((eS(a)|0)==65536){w=f[a+4>>2]|0;f[o>>2]=f[w>>2];x=o+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[w+8>>2];f[o+12>>2]=f[w+12>>2];f[o+16>>2]=f[w+16>>2];f[o+20>>2]=f[w+20>>2];f[o+24>>2]=f[w+24>>2];f[o+28>>2]=f[w+28>>2];f[o+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;B=o+44|0;f[B>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];C=o;break}else{f[x>>2]=0;U$(o,w);C=o;break}}else{bS(o,a,-1);C=o}while(0);D=1.0/e;if(f[C>>2]&4095|0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;C=$Xc(32)|0;f[m>>2]=C;f[m+8>>2]=-2147483616;f[m+4>>2]=21;E=C;F=366587;G=E+21|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[C+21>>0]=0;vM(-215,m,366863,366624,120)}if((i|0)<=0){f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;C=$Xc(16)|0;f[m>>2]=C;f[m+8>>2]=-2147483632;f[m+4>>2]=12;E=C;F=366694;G=E+12|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));b[C+12>>0]=0;vM(-215,m,366863,366624,121)}C=o+16|0;F=f[C>>2]|0;a=o+44|0;w=o+48|0;x=f[w>>2]|0;y=f[o+12>>2]|0;z=f[o+8>>2]|0;if(!(k>=j))oV(k,j,78756);B=zLc((k-j)/g)|0;A=ALc(+(z+y<<1|1|0)/e)|0;H=A+2|0;p$(q,B+2|0,H,4);f[p>>2]=1124007936;I=p+4|0;J=p+8|0;K=p+40|0;E=I;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[K>>2]=J;J=p+48|0;E=p+44|0;f[E>>2]=J;f[J>>2]=0;f[p+52>>2]=0;G=f[q>>2]|0;ei[f[(f[G>>2]|0)+12>>2]&511](G,q,p,-1);Zj(q);f[r>>2]=0;q=r+4|0;f[q>>2]=0;f[r+8>>2]=0;G=s+8|0;f[s>>2]=G;L=s+4|0;M=B>>>0>264;f[L>>2]=B;if(M){N=bYc(B>>>0>1073741823?-1:B<<2)|0;f[s>>2]=N;Q=N}else Q=G;N=t+8|0;f[t>>2]=N;R=t+4|0;f[R>>2]=B;if(M){M=bYc(B>>>0>1073741823?-1:B<<2)|0;f[t>>2]=M;S=M}else S=N;M=p+16|0;T=f[M>>2]|0;U=(B|0)>0;if(U){k=D;D=j;V=0;while(1){W=D;X=k*+P(+W);n[Q+(V<<2)>>2]=X;X=k*+O(+W);n[S+(V<<2)>>2]=X;V=V+1|0;if((V|0)==(B|0))break;else D=D+g}}if((z|0)>0?(V=((A+-1|0)/2|0)+1|0,(y|0)>0):0){Z=0;do{_=Y(Z,x)|0;D=+(Z|0);if(U){$=0;do{if(b[F+($+_)>>0]|0){k=+($|0);aa=0;do{ba=aa;aa=aa+1|0;ca=T+(V+(Y(aa,H)|0)+(ALc(k*+n[S+(ba<<2)>>2]+D*+n[Q+(ba<<2)>>2])|0)<<2)|0;f[ca>>2]=(f[ca>>2]|0)+1}while((aa|0)!=(B|0))}$=$+1|0}while(($|0)!=(y|0))}Z=Z+1|0}while((Z|0)!=(z|0))}if((A|0)>0?(z=-2-A|0,Z=r+8|0,U):0){U=0;do{y=0;do{y=y+1|0;Q=(Y(y,H)|0)+U|0;S=Q+1|0;f[m>>2]=S;V=f[T+(S<<2)>>2]|0;do if(((((V|0)>(h|0)?(V|0)>(f[T+(Q<<2)>>2]|0):0)?(V|0)>=(f[T+(Q+2<<2)>>2]|0):0)?(V|0)>(f[T+(z+S<<2)>>2]|0):0)?(V|0)>=(f[T+(S+H<<2)>>2]|0):0){F=f[q>>2]|0;if((F|0)==(f[Z>>2]|0)){Tv(r,m);break}else{f[F>>2]=S;f[q>>2]=F+4;break}}while(0)}while((y|0)!=(B|0));U=U+1|0}while((U|0)!=(A|0));da=f[r>>2]|0;ea=f[q>>2]|0}else{da=0;ea=0}f[m>>2]=T;BDa(da,ea,m);ea=(f[q>>2]|0)-(f[r>>2]|0)>>2;da=(ea|0)<(i|0)?ea:i;D=1.0/+(H|0);ZS(c,da,1,d,-1,0,0);do if((eS(c)|0)==65536){d=f[c+4>>2]|0;f[m>>2]=f[d>>2];i=m+4|0;ea=d+4|0;f[i>>2]=f[ea>>2];U=m+8|0;f[U>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];B=f[d+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=U;U=m+48|0;Z=m+44|0;f[Z>>2]=U;f[U>>2]=0;f[m+52>>2]=0;if(B|0){U=B+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[d+44>>2]|0;U=f[Z>>2]|0;f[U>>2]=f[ea>>2];f[U+4>>2]=f[ea+4>>2];break}else{f[i>>2]=0;U$(m,d);break}}else bS(m,c,-1);while(0);if((da|0)>0){k=+(A+-1|0)*.5;X=j;A=m+16|0;c=m+40|0;d=m+44|0;i=m+12|0;if(v){v=0;do{ea=f[(f[r>>2]|0)+(v<<2)>>2]|0;j=D*+(ea|0);U=~~j;Z=U-(+(U|0)>j&1)|0;j=(+(ea+-1-(Y(Z,H)|0)|0)-k)*e;W=X+ +(Z+-1|0)*g;Z=f[A>>2]|0;do if((f[m>>2]&16384|0)==0?(ea=f[c>>2]|0,(f[ea>>2]|0)!=1):0){U=f[f[d>>2]>>2]|0;if((f[ea+4>>2]|0)==1){fa=Z+(Y(U,v)|0)|0;break}else{ea=f[i>>2]|0;B=(v|0)/(ea|0)|0;fa=Z+(Y(B,U)|0)+(v-(Y(B,ea)|0)<<3)|0;break}}else ga=59;while(0);if((ga|0)==59){ga=0;fa=Z+(v<<3)|0}n[fa>>2]=j;n[fa+4>>2]=W;v=v+1|0}while((v|0)<(da|0))}else{v=0;do{fa=f[(f[r>>2]|0)+(v<<2)>>2]|0;ha=D*+(fa|0);ea=~~ha;B=ea-(+(ea|0)>ha&1)|0;ha=(+(fa+-1-(Y(B,H)|0)|0)-k)*e;ia=X+ +(B+-1|0)*g;ja=+(f[T+(fa<<2)>>2]|0);fa=f[A>>2]|0;do if((f[m>>2]&16384|0)==0?(B=f[c>>2]|0,(f[B>>2]|0)!=1):0){ea=f[f[d>>2]>>2]|0;if((f[B+4>>2]|0)==1){ka=fa+(Y(ea,v)|0)|0;break}else{B=f[i>>2]|0;U=(v|0)/(B|0)|0;ka=fa+(Y(U,ea)|0)+((v-(Y(U,B)|0)|0)*12|0)|0;break}}else ga=63;while(0);if((ga|0)==63){ga=0;ka=fa+(v*12|0)|0}n[ka>>2]=ha;n[ka+4>>2]=ia;n[ka+8>>2]=ja;v=v+1|0}while((v|0)<(da|0))}}da=m+36|0;v=f[da>>2]|0;if(v|0?(ka=v+12|0,v=f[ka>>2]|0,f[ka>>2]=v+-1,(v|0)==1):0)V$(m);f[da>>2]=0;da=m+16|0;v=m+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[v>>2]|0)>0){da=f[m+40>>2]|0;ka=0;do{f[da+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[v>>2]|0))}v=f[m+44>>2]|0;if((v|0)!=(m+48|0))wL(v);v=f[t>>2]|0;if((v|0)!=(N|0)){if(v|0)dYc(v);f[t>>2]=N;f[R>>2]=264}R=f[s>>2]|0;if((R|0)!=(G|0)){if(R|0)dYc(R);f[s>>2]=G;f[L>>2]=264}L=f[r>>2]|0;if(L|0){r=f[q>>2]|0;if((r|0)!=(L|0))f[q>>2]=r+(~((r+-4-L|0)>>>2)<<2);cYc(L)}L=p+36|0;r=f[L>>2]|0;if(r|0?(q=r+12|0,r=f[q>>2]|0,f[q>>2]=r+-1,(r|0)==1):0)V$(p);f[L>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[I>>2]|0)>0){M=f[K>>2]|0;K=0;do{f[M+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[I>>2]|0))}I=f[E>>2]|0;if((I|0)!=(J|0))wL(I);I=o+36|0;J=f[I>>2]|0;do if(J|0){E=J+12|0;K=f[E>>2]|0;f[E>>2]=K+-1;if((K|0)!=1)break;V$(o)}while(0);f[I>>2]=0;I=o+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[I>>2]|0)>0){C=f[o+40>>2]|0;o=0;do{f[C+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[I>>2]|0))}I=f[a>>2]|0;if((I|0)==(w|0)){u=l;return}wL(I);u=l;return}function yDa(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=+e;g=+g;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;o=+o;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,N=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;p=u;u=u+192|0;q=p+128|0;r=p+116|0;s=p+104|0;t=p+92|0;v=p+80|0;w=p+68|0;x=p+56|0;y=p;z=(d|0)==13;switch(d|0){case 13:case 21:break;default:qV(d,78700)}do if((eS(a)|0)==65536){A=f[a+4>>2]|0;f[q>>2]=f[A>>2];B=q+4|0;C=A+4|0;f[B>>2]=f[C>>2];D=q+8|0;f[D>>2]=f[A+8>>2];f[q+12>>2]=f[A+12>>2];f[q+16>>2]=f[A+16>>2];f[q+20>>2]=f[A+20>>2];f[q+24>>2]=f[A+24>>2];f[q+28>>2]=f[A+28>>2];f[q+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[q+36>>2]=E;f[q+40>>2]=D;D=q+48|0;F=q+44|0;f[F>>2]=D;f[D>>2]=0;f[q+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];G=q;break}else{f[B>>2]=0;U$(q,A);G=q;break}}else{bS(q,a,-1);G=q}while(0);A=Y(k,j)|0;f[r>>2]=0;B=r+4|0;f[B>>2]=0;f[r+8>>2]=0;if(f[G>>2]&4095|0){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;G=$Xc(32)|0;f[s>>2]=G;f[s+8>>2]=-2147483616;f[s+4>>2]=21;H=G;I=366587;J=H+21|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[G+21>>0]=0;vM(-215,s,366609,366624,262)}if((l|0)<=0){f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;G=$Xc(16)|0;f[s>>2]=G;f[s+8>>2]=-2147483632;f[s+4>>2]=12;H=G;I=366694;J=H+12|0;do{b[H>>0]=b[I>>0]|0;H=H+1|0;I=I+1|0}while((H|0)<(J|0));b[G+12>>0]=0;vM(-215,s,366609,366624,263)}G=(i|0)<255?i:255;i=q+16|0;I=f[i>>2]|0;H=q+44|0;J=q+48|0;C=f[J>>2]|0;D=f[q+12>>2]|0;F=f[q+8>>2]|0;K=1.0/e;N=1.0/g;P=+(j|0);Q=e/P;R=g/+(k|0);S=1.0/Q;T=1.0/R;U=+(D|0);V=+(F|0);W=K*+M(+(U*U+V*V));j=~~W;E=j-(+(j|0)>W&1)|0;W=N;V=W*6.283185307179586;j=~~V;X=j-(+(j|0)>V&1)|0;f[s>>2]=G;n[s+4>>2]=-1.0;n[s+8>>2]=0.0;j=r+8|0;zDa(r,s);Z=Y(k*5|0,X)|0;f[s>>2]=0;_=s+4|0;f[_>>2]=0;f[s+8>>2]=0;if(!Z)$=0;else{if(Z>>>0>1073741823)kWc(s);aa=Z<<2;ba=$Xc(aa)|0;f[s>>2]=ba;ca=ba+(Z<<2)|0;f[s+8>>2]=ca;g1c(ba|0,0,aa|0)|0;f[_>>2]=ca;ca=0;do{V=+O(+(R*+(ca|0)*.20000000298023224));n[ba+(ca<<2)>>2]=V;ca=ca+1|0}while((ca|0)!=(Z|0));$=ba}ba=Y(E,X)|0;f[t>>2]=0;Z=t+4|0;f[Z>>2]=0;f[t+8>>2]=0;if(!ba)da=0;else{if((ba|0)<0)kWc(t);ca=$Xc(ba)|0;f[Z>>2]=ca;f[t>>2]=ca;f[t+8>>2]=ca+ba;aa=ba;ea=ca;do{b[ea>>0]=0;ea=(f[Z>>2]|0)+1|0;f[Z>>2]=ea;aa=aa+-1|0}while((aa|0)!=0);da=f[t>>2]|0}aa=(F|0)>0;if(aa&(D|0)>0){ea=0;ca=0;while(1){fa=Y(ea,C)|0;ga=0;ha=ca;do{ha=((b[I+(ga+fa)>>0]|0)!=0&1)+ha|0;ga=ga+1|0}while((ga|0)!=(D|0));ea=ea+1|0;if((ea|0)==(F|0)){ia=ha;break}else ca=ha}}else ia=0;f[v>>2]=0;ca=v+4|0;f[ca>>2]=0;f[v+8>>2]=0;ea=(ia|0)==0;do if(!ea)if(ia>>>0>1073741823)kWc(v);else{ga=ia<<2;fa=$Xc(ga)|0;f[v>>2]=fa;ja=fa+(ia<<2)|0;f[v+8>>2]=ja;g1c(fa|0,0,ga|0)|0;f[ca>>2]=ja;ka=fa;break}else ka=0;while(0);f[w>>2]=0;fa=w+4|0;f[fa>>2]=0;f[w+8>>2]=0;if(ea){la=0;ma=0}else{ea=ia<<2;ja=$Xc(ea)|0;f[w>>2]=ja;ga=ja+(ia<<2)|0;f[w+8>>2]=ga;g1c(ja|0,0,ea|0)|0;f[fa>>2]=ga;la=ja;ma=ja}if(aa){aa=(D|0)>0;ja=0;ga=0;while(1){if(aa){ea=Y(ga,C)|0;V=+(ga|0)+.5;U=V;na=U*U;oa=0;pa=ja;while(1){if(b[I+(oa+ea)>>0]|0){f[ka+(pa<<2)>>2]=oa;f[la+(pa<<2)>>2]=ga;qa=pa+1|0;U=+(oa|0)+.5;ra=+L(+(+$L(V,U)*.01745329238474369));sa=U;U=+M(+(na+sa*sa));sa=K*U;ta=W*(ra+1.5707963267948966);ua=~~ta;va=da+(ua-(+(ua|0)>ta&1))|0;b[va>>0]=(b[va>>0]|0)+1<<24>>24;ta=e/U;U=ta<g?ta:g;ta=N*U;wa=3.141592653589793/U;va=~~wa;ua=va-(+(va|0)>wa&1)|0;if((ua|0)>1){wa=N*(ra+U);ra=-1.5707963705062866;va=-1;xa=1;while(1){ra=U+ra;ya=~~wa;za=va;va=(Y(~~(sa*+O(+ra)),X)|0)+(ya-(+(ya|0)>wa&1))|0;ya=da+va|0;b[ya>>0]=((va|0)!=(za|0)&1)+(h[ya>>0]|0);xa=xa+1|0;if((xa|0)==(ua|0)){Aa=qa;break}else wa=ta+wa}}else Aa=qa}else Aa=pa;oa=oa+1|0;if((oa|0)>=(D|0)){Ba=Aa;break}else pa=Aa}}else Ba=ja;ga=ga+1|0;if((ga|0)>=(F|0))break;else ja=Ba}}Ba=(E|0)>0;if(Ba&(X|0)>0){ja=0;F=0;while(1){ga=Y(ja,X)|0;Aa=0;D=F;do{D=((h[da+(Aa+ga)>>0]|0)>(G|0)&1)+D|0;Aa=Aa+1|0}while((Aa|0)!=(X|0));ja=ja+1|0;if((ja|0)==(E|0)){Ca=D;break}else F=D}}else Ca=0;if((Ca*100|0)>(ba|0)){xDa(a,c,d,e,g,G,l,m,o);Da=la;Ea=ma}else{ma=A+2|0;f[x>>2]=0;a=x+4|0;f[a>>2]=0;f[x+8>>2]=0;if(!ma)Fa=0;else{if((A|0)<-2)kWc(x);ba=$Xc(ma)|0;f[a>>2]=ba;f[x>>2]=ba;f[x+8>>2]=ba+ma;Ca=ma;ma=ba;do{b[ma>>0]=0;ma=(f[a>>2]|0)+1|0;f[a>>2]=ma;Ca=Ca+-1|0}while((Ca|0)!=0);Fa=f[x>>2]|0}Ca=Fa+1|0;if(Ba){Ba=(X|0)>0;Fa=(ia|0)>0;o=T;ma=(k|0)>0;ba=(A|0)>0;F=y+4|0;ja=y+8|0;Aa=0;while(1){if(Ba){ga=Y(Aa,X)|0;T=+(Aa|0);m=P*T;N=T*e;I=0;do{do if((h[da+(I+ga)>>0]|0)>(G|0)){g1c(Ca|0,0,A|0)|0;a:do if(Fa){C=Y(I,k)|0;if(ma)Ga=0;else{aa=0;while(1){+$L(+(f[la+(aa<<2)>>2]|0)+.5,+(f[ka+(aa<<2)>>2]|0)+.5);aa=aa+1|0;if((aa|0)>=(ia|0))break a}}do{T=+(f[la+(Ga<<2)>>2]|0)+.5;W=+(f[ka+(Ga<<2)>>2]|0)+.5;K=W;na=T;V=S*+M(+(na*na+K*K));K=o*(+L(+(+$L(T,W)*.01745329238474369))+1.5707963267948966);aa=~~K;pa=(C-aa+(+(aa|0)>K&1)|0)*5|0;aa=0;while(1){K=V*+n[$+(((pa|0)>-1?pa:0-pa|0)<<2)>>2]-m;oa=~~K;ea=(Y(oa-(+(oa|0)>K&1)|0,k)|0)+aa|0;oa=ea>>31&~ea^ea;ea=Ca+(((oa|0)>=(A|0)?oa^A:0)^oa)|0;b[ea>>0]=(b[ea>>0]|0)+1<<24>>24;aa=aa+1|0;if((aa|0)==(k|0))break;else pa=pa+5|0}Ga=Ga+1|0}while((Ga|0)<(ia|0))}while(0);if(!ba)break;V=+(I|0)*g;C=f[B>>2]|0;pa=f[r>>2]|0;aa=0;ea=pa;oa=C;ha=pa;pa=C;while(1){C=oa-ea|0;ua=((C|0)/12|0)+-1|0;if((C|0)>=12){xa=b[Ca+aa>>0]|0;if((f[ha+(ua*12|0)>>2]|0)<(xa&255|0)){Ha=xa;Ia=74}else{Ja=pa;Ka=ha;La=ha;Ma=oa}}else{Ha=b[Ca+aa>>0]|0;Ia=74}if((Ia|0)==74){Ia=0;f[y>>2]=Ha&255;n[F>>2]=N+Q*+((aa|0)/(k|0)|0|0);n[ja>>2]=V+R*+((aa|0)%(k|0)|0|0)+-1.5707963705062866;if((pa|0)==(f[j>>2]|0))ADa(r,y);else{f[pa>>2]=f[y>>2];f[pa+4>>2]=f[y+4>>2];f[pa+8>>2]=f[y+8>>2];f[B>>2]=(f[B>>2]|0)+12}b:do if((C|0)>0){xa=ua;while(1){va=f[r>>2]|0;ya=va+(xa*12|0)|0;if((f[ya>>2]|0)>(f[y>>2]|0)){Na=xa;break b}za=va+((xa+1|0)*12|0)|0;f[za>>2]=f[ya>>2];f[za+4>>2]=f[ya+4>>2];f[za+8>>2]=f[ya+8>>2];ya=xa+-1|0;if((xa|0)>0)xa=ya;else{Na=ya;break}}}else Na=ua;while(0);ua=(f[r>>2]|0)+((Na+1|0)*12|0)|0;f[ua>>2]=f[y>>2];f[ua+4>>2]=f[y+4>>2];f[ua+8>>2]=f[y+8>>2];ua=f[B>>2]|0;C=f[r>>2]|0;xa=ua;if(((ua-C|0)/12|0|0)>(l|0)){ya=xa+-12|0;f[B>>2]=ya;Oa=ya;Pa=ya}else{Oa=xa;Pa=ua}Ja=Oa;Ka=C;La=C;Ma=Pa}aa=aa+1|0;if((aa|0)>=(A|0))break;else{ea=La;oa=Ma;ha=Ka;pa=Ja}}}while(0);I=I+1|0}while((I|0)<(X|0))}Aa=Aa+1|0;if((Aa|0)>=(E|0)){Qa=B;Ra=r;break}}}else{Qa=B;Ra=r}ZS(c,((f[Qa>>2]|0)-(f[Ra>>2]|0)|0)/12|0,1,d,-1,0,0);do if((eS(c)|0)==65536){d=f[c+4>>2]|0;f[y>>2]=f[d>>2];E=y+4|0;Aa=d+4|0;f[E>>2]=f[Aa>>2];X=y+8|0;f[X>>2]=f[d+8>>2];f[y+12>>2]=f[d+12>>2];f[y+16>>2]=f[d+16>>2];f[y+20>>2]=f[d+20>>2];f[y+24>>2]=f[d+24>>2];f[y+28>>2]=f[d+28>>2];f[y+32>>2]=f[d+32>>2];Ja=f[d+36>>2]|0;f[y+36>>2]=Ja;f[y+40>>2]=X;X=y+48|0;Ka=y+44|0;f[Ka>>2]=X;f[X>>2]=0;f[y+52>>2]=0;if(Ja|0){X=Ja+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[Aa>>2]|0)<3){Aa=f[d+44>>2]|0;X=f[Ka>>2]|0;f[X>>2]=f[Aa>>2];f[X+4>>2]=f[Aa+4>>2];break}else{f[E>>2]=0;U$(y,d);break}}else bS(y,c,-1);while(0);c=f[Qa>>2]|0;d=f[Ra>>2]|0;E=d;if((c|0)!=(d|0)){Aa=y+16|0;X=y+40|0;Ka=y+44|0;Ja=y+12|0;if(z){z=0;Ma=E;La=d;A=c;while(1){R=+n[Ma+(z*12|0)+4>>2];if(R<0.0){Sa=La;Ta=A}else{Pa=f[Ma+(z*12|0)+8>>2]|0;Oa=f[Aa>>2]|0;do if(!(f[y>>2]&16384)){l=f[X>>2]|0;if((f[l>>2]|0)==1){Ia=101;break}Na=f[f[Ka>>2]>>2]|0;if((f[l+4>>2]|0)==1){Ua=Oa+(Y(Na,z)|0)|0;break}else{l=f[Ja>>2]|0;j=(z|0)/(l|0)|0;Ua=Oa+(Y(j,Na)|0)+(z-(Y(j,l)|0)<<3)|0;break}}else Ia=101;while(0);if((Ia|0)==101){Ia=0;Ua=Oa+(z<<3)|0}n[Ua>>2]=R;f[Ua+4>>2]=Pa;Sa=f[Ra>>2]|0;Ta=f[Qa>>2]|0}z=z+1|0;if(z>>>0>=((Ta-Sa|0)/12|0)>>>0)break;else{Ma=Sa;La=Sa;A=Ta}}}else{Ta=0;A=E;E=d;d=c;while(1){Q=+n[A+(Ta*12|0)+4>>2];if(Q<0.0){Va=E;Wa=d}else{c=f[A+(Ta*12|0)+8>>2]|0;g=+(f[A+(Ta*12|0)>>2]|0);Sa=f[Aa>>2]|0;do if(!(f[y>>2]&16384)){La=f[X>>2]|0;if((f[La>>2]|0)==1){Ia=120;break}Ma=f[f[Ka>>2]>>2]|0;if((f[La+4>>2]|0)==1){Xa=Sa+(Y(Ma,Ta)|0)|0;break}else{La=f[Ja>>2]|0;z=(Ta|0)/(La|0)|0;Xa=Sa+(Y(z,Ma)|0)+((Ta-(Y(z,La)|0)|0)*12|0)|0;break}}else Ia=120;while(0);if((Ia|0)==120){Ia=0;Xa=Sa+(Ta*12|0)|0}n[Xa>>2]=Q;f[Xa+4>>2]=c;n[Xa+8>>2]=g;Va=f[Ra>>2]|0;Wa=f[Qa>>2]|0}Ta=Ta+1|0;if(Ta>>>0>=((Wa-Va|0)/12|0)>>>0)break;else{A=Va;E=Va;d=Wa}}}}Wa=y+36|0;d=f[Wa>>2]|0;if(d|0?(Va=d+12|0,d=f[Va>>2]|0,f[Va>>2]=d+-1,(d|0)==1):0)V$(y);f[Wa>>2]=0;Wa=y+16|0;d=y+4|0;f[Wa>>2]=0;f[Wa+4>>2]=0;f[Wa+8>>2]=0;f[Wa+12>>2]=0;if((f[d>>2]|0)>0){Wa=f[y+40>>2]|0;Va=0;do{f[Wa+(Va<<2)>>2]=0;Va=Va+1|0}while((Va|0)<(f[d>>2]|0))}d=f[y+44>>2]|0;if((d|0)!=(y+48|0))wL(d);d=f[x>>2]|0;if(d|0){if((f[a>>2]|0)!=(d|0))f[a>>2]=d;cYc(d)}d=f[w>>2]|0;Da=d;Ea=d}if(Da|0){d=f[fa>>2]|0;if((d|0)!=(Da|0))f[fa>>2]=d+(~((d+-4-Da|0)>>>2)<<2);cYc(Ea)}Ea=f[v>>2]|0;if(Ea|0){v=f[ca>>2]|0;if((v|0)!=(Ea|0))f[ca>>2]=v+(~((v+-4-Ea|0)>>>2)<<2);cYc(Ea)}Ea=f[t>>2]|0;if(Ea|0){if((f[Z>>2]|0)!=(Ea|0))f[Z>>2]=Ea;cYc(Ea)}Ea=f[s>>2]|0;if(Ea|0){s=f[_>>2]|0;if((s|0)!=(Ea|0))f[_>>2]=s+(~((s+-4-Ea|0)>>>2)<<2);cYc(Ea)}Ea=f[r>>2]|0;if(Ea|0){r=f[B>>2]|0;if((r|0)!=(Ea|0))f[B>>2]=r+(~(((r+-12-Ea|0)>>>0)/12|0)*12|0);cYc(Ea)}Ea=q+36|0;r=f[Ea>>2]|0;if(r|0?(B=r+12|0,r=f[B>>2]|0,f[B>>2]=r+-1,(r|0)==1):0)V$(q);f[Ea>>2]=0;Ea=q+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[Ea>>2]|0)>0){i=f[q+40>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[Ea>>2]|0))}Ea=f[H>>2]|0;if((Ea|0)==(J|0)){u=p;return}wL(Ea);u=p;return}function zDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)kWc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;cYc(d);return}function ADa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)kWc(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=af(8)|0;hYc(k,512536);f[k>>2]=192348;ig(k|0,25336,2140)}else{m=$Xc(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)o1c(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;cYc(d);return}function BDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=15;break a;break}case 5:{l=16;break a;break}case 1:case 0:{l=63;break a;break}default:{}}if((j|0)<124){l=18;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)<=3996){n=f[m>>2]|0;o=f[h>>2]|0;p=f[c>>2]|0;q=f[p+(n<<2)>>2]|0;r=p+(o<<2)|0;s=f[r>>2]|0;t=f[e>>2]|0;u=f[p+(t<<2)>>2]|0;v=(u|0)>(q|0)|(t|0)<(n|0)&(u|0)==(q|0);if(!((q|0)>(s|0)|(n|0)<(o|0)&(q|0)==(s|0))){if(!v){w=0;x=p;break}f[m>>2]=t;f[e>>2]=n;s=f[m>>2]|0;q=f[h>>2]|0;u=f[p+(s<<2)>>2]|0;y=f[p+(q<<2)>>2]|0;if(!((u|0)>(y|0)|(s|0)<(q|0)&(u|0)==(y|0))){w=1;x=p;break}f[h>>2]=s;f[m>>2]=q;w=2;x=p;break}if(v){f[h>>2]=t;f[e>>2]=o;w=1;x=p;break}f[h>>2]=n;f[m>>2]=o;n=f[e>>2]|0;t=f[p+(n<<2)>>2]|0;v=f[r>>2]|0;if((t|0)>(v|0)|(n|0)<(o|0)&(t|0)==(v|0)){f[m>>2]=n;f[e>>2]=o;w=2;x=p}else{w=1;x=p}}else{p=(k|0)/4|0;o=DDa(h,h+(p<<2)|0,m,m+(p<<2)|0,e,c)|0;w=o;x=f[c>>2]|0}while(0);z=f[h>>2]|0;k=f[m>>2]|0;j=f[x+(z<<2)>>2]|0;o=f[x+(k<<2)>>2]|0;if((j|0)>(o|0)|(z|0)<(k|0)&(j|0)==(o|0)){A=e;B=w;break}o=f[c>>2]|0;j=o+(k<<2)|0;C=e;while(1){C=C+-4|0;if((h|0)==(C|0))break;D=f[C>>2]|0;p=f[o+(D<<2)>>2]|0;n=f[j>>2]|0;if((p|0)>(n|0)|(D|0)<(k|0)&(p|0)==(n|0)){l=45;break b}}k=h+4|0;j=f[e>>2]|0;n=f[o+(z<<2)>>2]|0;p=f[o+(j<<2)>>2]|0;if((n|0)>(p|0)|(z|0)<(j|0)&(n|0)==(p|0))E=k;else{if((k|0)==(e|0)){l=63;break a}else F=k;while(1){G=f[F>>2]|0;k=f[o+(G<<2)>>2]|0;if((n|0)>(k|0)|(z|0)<(G|0)&(n|0)==(k|0))break;k=F+4|0;if((k|0)==(e|0)){l=63;break a}else F=k}f[F>>2]=j;f[e>>2]=G;E=F+4|0}if((E|0)==(e|0)){l=63;break a}n=f[c>>2]|0;o=e;k=E;while(1){p=f[h>>2]|0;v=f[n+(p<<2)>>2]|0;t=k;while(1){H=f[t>>2]|0;r=f[n+(H<<2)>>2]|0;I=t+4|0;if((v|0)>(r|0)|(p|0)<(H|0)&(v|0)==(r|0)){J=o;break}else t=I}do{J=J+-4|0;K=f[J>>2]|0;r=f[n+(K<<2)>>2]|0}while((v|0)>(r|0)|(p|0)<(K|0)&(v|0)==(r|0));if(t>>>0>=J>>>0){h=t;continue b}f[t>>2]=K;f[J>>2]=H;o=J;k=I}}if((l|0)==45){l=0;f[h>>2]=D;f[C>>2]=z;A=C;B=w+1|0}k=h+4|0;c:do if(k>>>0<A>>>0){o=f[c>>2]|0;n=m;j=A;v=k;p=B;while(1){r=f[n>>2]|0;q=f[o+(r<<2)>>2]|0;s=v;while(1){L=f[s>>2]|0;y=f[o+(L<<2)>>2]|0;M=s+4|0;if((y|0)>(q|0)|(L|0)<(r|0)&(y|0)==(q|0))s=M;else{N=j;break}}do{N=N+-4|0;O=f[N>>2]|0;t=f[o+(O<<2)>>2]|0}while(!((t|0)>(q|0)|(O|0)<(r|0)&(t|0)==(q|0)));if(s>>>0>N>>>0){P=n;Q=p;R=s;break c}f[s>>2]=O;f[N>>2]=L;n=(n|0)==(s|0)?N:n;j=N;v=M;p=p+1|0}}else{P=m;Q=B;R=k}while(0);if((R|0)!=(P|0)?(k=f[P>>2]|0,p=f[R>>2]|0,v=f[c>>2]|0,j=f[v+(k<<2)>>2]|0,n=f[v+(p<<2)>>2]|0,(j|0)>(n|0)|(k|0)<(p|0)&(j|0)==(n|0)):0){f[R>>2]=k;f[P>>2]=p;S=Q+1|0}else S=Q;if(!S){T=FDa(h,R,c)|0;p=R+4|0;if(FDa(p,a,c)|0){l=62;break}if(T){g=p;continue}}p=R;if((p-i|0)>=(b-p|0)){l=61;break}BDa(h,R,c);g=R+4|0}if((l|0)==61){l=0;BDa(R+4|0,a,c);d=h;a=R;continue}else if((l|0)==62){l=0;if(T){l=63;break}else{d=h;a=R;continue}}}if((l|0)==5){R=f[e>>2]|0;d=f[h>>2]|0;T=f[c>>2]|0;i=f[T+(R<<2)>>2]|0;S=f[T+(d<<2)>>2]|0;if(!((i|0)>(S|0)|(R|0)<(d|0)&(i|0)==(S|0)))return;f[h>>2]=R;f[e>>2]=d;return}else if((l|0)==7){d=h+4|0;R=f[d>>2]|0;S=f[h>>2]|0;i=f[c>>2]|0;T=f[i+(R<<2)>>2]|0;Q=i+(S<<2)|0;P=f[Q>>2]|0;B=f[e>>2]|0;m=f[i+(B<<2)>>2]|0;M=(m|0)>(T|0)|(B|0)<(R|0)&(m|0)==(T|0);if(!((T|0)>(P|0)|(R|0)<(S|0)&(T|0)==(P|0))){if(!M)return;f[d>>2]=B;f[e>>2]=R;P=f[d>>2]|0;T=f[h>>2]|0;m=f[i+(P<<2)>>2]|0;N=f[i+(T<<2)>>2]|0;if(!((m|0)>(N|0)|(P|0)<(T|0)&(m|0)==(N|0)))return;f[h>>2]=P;f[d>>2]=T;return}if(M){f[h>>2]=B;f[e>>2]=S;return}f[h>>2]=R;f[d>>2]=S;R=f[e>>2]|0;B=f[i+(R<<2)>>2]|0;i=f[Q>>2]|0;if(!((B|0)>(i|0)|(R|0)<(S|0)&(B|0)==(i|0)))return;f[d>>2]=R;f[e>>2]=S;return}else if((l|0)==15){CDa(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==16){DDa(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==18){EDa(h,a,c);return}else if((l|0)==63)return}function CDa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[b>>2]|0;h=f[a>>2]|0;i=f[e>>2]|0;e=f[i+(g<<2)>>2]|0;j=i+(h<<2)|0;k=f[j>>2]|0;l=f[c>>2]|0;m=f[i+(l<<2)>>2]|0;n=(m|0)>(e|0)|(l|0)<(g|0)&(m|0)==(e|0);do if((e|0)>(k|0)|(g|0)<(h|0)&(e|0)==(k|0)){if(n){f[a>>2]=l;f[c>>2]=h;o=1;p=h;break}f[a>>2]=g;f[b>>2]=h;m=f[c>>2]|0;q=f[i+(m<<2)>>2]|0;r=f[j>>2]|0;if((q|0)>(r|0)|(m|0)<(h|0)&(q|0)==(r|0)){f[b>>2]=m;f[c>>2]=h;o=2;p=h}else{o=1;p=m}}else if(n){f[b>>2]=l;f[c>>2]=g;m=f[b>>2]|0;r=f[a>>2]|0;q=f[i+(m<<2)>>2]|0;s=f[i+(r<<2)>>2]|0;if((q|0)>(s|0)|(m|0)<(r|0)&(q|0)==(s|0)){f[a>>2]=m;f[b>>2]=r;o=2;p=f[c>>2]|0}else{o=1;p=g}}else{o=0;p=l}while(0);l=f[d>>2]|0;g=f[i+(l<<2)>>2]|0;n=f[i+(p<<2)>>2]|0;if(!((g|0)>(n|0)|(l|0)<(p|0)&(g|0)==(n|0))){t=o;return t|0}f[c>>2]=l;f[d>>2]=p;p=f[c>>2]|0;d=f[b>>2]|0;l=f[i+(p<<2)>>2]|0;n=f[i+(d<<2)>>2]|0;if(!((l|0)>(n|0)|(p|0)<(d|0)&(l|0)==(n|0))){t=o+1|0;return t|0}f[b>>2]=p;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;p=f[i+(d<<2)>>2]|0;n=f[i+(c<<2)>>2]|0;if(!((p|0)>(n|0)|(d|0)<(c|0)&(p|0)==(n|0))){t=o+2|0;return t|0}f[a>>2]=d;f[b>>2]=c;t=o+3|0;return t|0}function DDa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=CDa(a,b,c,d,g)|0;i=f[e>>2]|0;j=f[d>>2]|0;k=f[g>>2]|0;g=f[k+(i<<2)>>2]|0;l=f[k+(j<<2)>>2]|0;if(!((g|0)>(l|0)|(i|0)<(j|0)&(g|0)==(l|0))){m=h;return m|0}f[d>>2]=i;f[e>>2]=j;j=f[d>>2]|0;e=f[c>>2]|0;i=f[k+(j<<2)>>2]|0;l=f[k+(e<<2)>>2]|0;if(!((i|0)>(l|0)|(j|0)<(e|0)&(i|0)==(l|0))){m=h+1|0;return m|0}f[c>>2]=j;f[d>>2]=e;e=f[c>>2]|0;d=f[b>>2]|0;j=f[k+(e<<2)>>2]|0;l=f[k+(d<<2)>>2]|0;if(!((j|0)>(l|0)|(e|0)<(d|0)&(j|0)==(l|0))){m=h+2|0;return m|0}f[b>>2]=e;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;e=f[k+(d<<2)>>2]|0;l=f[k+(c<<2)>>2]|0;if(!((e|0)>(l|0)|(d|0)<(c|0)&(e|0)==(l|0))){m=h+3|0;return m|0}f[a>>2]=d;f[b>>2]=c;m=h+4|0;return m|0}function EDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+8|0;e=a+4|0;g=f[e>>2]|0;h=f[a>>2]|0;i=f[c>>2]|0;j=f[i+(g<<2)>>2]|0;k=i+(h<<2)|0;l=f[k>>2]|0;m=f[d>>2]|0;n=i+(m<<2)|0;o=f[n>>2]|0;p=(o|0)>(j|0)|(m|0)<(g|0)&(o|0)==(j|0);do if((j|0)>(l|0)|(g|0)<(h|0)&(j|0)==(l|0)){if(p){f[a>>2]=m;f[d>>2]=h;q=h;break}f[a>>2]=g;f[e>>2]=h;o=f[n>>2]|0;r=f[k>>2]|0;if((o|0)>(r|0)|(m|0)<(h|0)&(o|0)==(r|0)){f[e>>2]=m;f[d>>2]=h;q=h}else q=m}else if(p){f[e>>2]=m;f[d>>2]=g;r=f[n>>2]|0;o=f[k>>2]|0;if((r|0)>(o|0)|(m|0)<(h|0)&(r|0)==(o|0)){f[a>>2]=m;f[e>>2]=h;q=g}else q=g}else q=m;while(0);m=a+12|0;if((m|0)==(b|0))return;else{s=m;t=d;u=i;v=q}while(1){q=f[s>>2]|0;i=f[u+(q<<2)>>2]|0;d=f[u+(v<<2)>>2]|0;if((i|0)>(d|0)|(q|0)<(v|0)&(i|0)==(d|0)){d=f[c>>2]|0;i=d+(q<<2)|0;m=t;g=s;h=v;while(1){f[g>>2]=h;if((m|0)==(a|0)){w=a;break}e=m+-4|0;h=f[e>>2]|0;k=f[i>>2]|0;n=f[d+(h<<2)>>2]|0;if(!((k|0)>(n|0)|(q|0)<(h|0)&(k|0)==(n|0))){w=m;break}else{n=m;m=e;g=n}}f[w>>2]=q;x=d}else x=u;g=s+4|0;if((g|0)==(b|0))break;m=f[s>>2]|0;h=s;s=g;u=x;v=m;t=h}return}function FDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[c>>2]|0;i=f[h+(e<<2)>>2]|0;j=f[h+(g<<2)>>2]|0;if(!((i|0)>(j|0)|(e|0)<(g|0)&(i|0)==(j|0))){k=1;return k|0}f[a>>2]=e;f[d>>2]=g;k=1;return k|0}case 3:{g=a+4|0;d=b+-4|0;e=f[g>>2]|0;j=f[a>>2]|0;i=f[c>>2]|0;h=f[i+(e<<2)>>2]|0;l=i+(j<<2)|0;m=f[l>>2]|0;n=f[d>>2]|0;o=f[i+(n<<2)>>2]|0;p=(o|0)>(h|0)|(n|0)<(e|0)&(o|0)==(h|0);if(!((h|0)>(m|0)|(e|0)<(j|0)&(h|0)==(m|0))){if(!p){k=1;return k|0}f[g>>2]=n;f[d>>2]=e;m=f[g>>2]|0;h=f[a>>2]|0;o=f[i+(m<<2)>>2]|0;q=f[i+(h<<2)>>2]|0;if(!((o|0)>(q|0)|(m|0)<(h|0)&(o|0)==(q|0))){k=1;return k|0}f[a>>2]=m;f[g>>2]=h;k=1;return k|0}if(p){f[a>>2]=n;f[d>>2]=j;k=1;return k|0}f[a>>2]=e;f[g>>2]=j;e=f[d>>2]|0;n=f[i+(e<<2)>>2]|0;i=f[l>>2]|0;if(!((n|0)>(i|0)|(e|0)<(j|0)&(n|0)==(i|0))){k=1;return k|0}f[g>>2]=e;f[d>>2]=j;k=1;return k|0}case 4:{CDa(a,a+4|0,a+8|0,b+-4|0,c)|0;k=1;return k|0}case 5:{DDa(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;k=1;return k|0}case 1:case 0:{k=1;return k|0}default:{j=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;i=f[c>>2]|0;n=f[i+(e<<2)>>2]|0;l=i+(g<<2)|0;p=f[l>>2]|0;h=f[j>>2]|0;m=i+(h<<2)|0;q=f[m>>2]|0;o=(q|0)>(n|0)|(h|0)<(e|0)&(q|0)==(n|0);do if((n|0)>(p|0)|(e|0)<(g|0)&(n|0)==(p|0)){if(o){f[a>>2]=h;f[j>>2]=g;r=g;break}f[a>>2]=e;f[d>>2]=g;q=f[m>>2]|0;s=f[l>>2]|0;if((q|0)>(s|0)|(h|0)<(g|0)&(q|0)==(s|0)){f[d>>2]=h;f[j>>2]=g;r=g}else r=h}else if(o){f[d>>2]=h;f[j>>2]=e;s=f[m>>2]|0;q=f[l>>2]|0;if((s|0)>(q|0)|(h|0)<(g|0)&(s|0)==(q|0)){f[a>>2]=h;f[d>>2]=g;r=e}else r=e}else r=h;while(0);h=a+12|0;a:do if((h|0)==(b|0)){t=1;u=0}else{e=h;g=0;d=j;l=i;m=r;while(1){o=f[e>>2]|0;p=f[l+(o<<2)>>2]|0;n=f[l+(m<<2)>>2]|0;if((p|0)>(n|0)|(o|0)<(m|0)&(p|0)==(n|0)){n=f[c>>2]|0;p=n+(o<<2)|0;q=d;s=e;v=m;while(1){f[s>>2]=v;if((q|0)==(a|0)){w=a;break}x=q+-4|0;v=f[x>>2]|0;y=f[p>>2]|0;z=f[n+(v<<2)>>2]|0;if(!((y|0)>(z|0)|(o|0)<(v|0)&(y|0)==(z|0))){w=q;break}else{z=q;q=x;s=z}}f[w>>2]=o;s=g+1|0;if((s|0)==8){t=0;u=(e+4|0)==(b|0);break a}else{A=s;B=n}}else{A=g;B=l}s=e+4|0;if((s|0)==(b|0)){t=1;u=0;break a}q=f[e>>2]|0;v=e;e=s;g=A;l=B;m=q;d=v}}while(0);k=u|t;return k|0}}return 0}function GDa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;i=u;u=u+128|0;j=i+72|0;k=i+56|0;l=i;do if((eS(a)|0)==65536){m=f[a+4>>2]|0;f[j>>2]=f[m>>2];n=j+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=j+8|0;f[p>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[j+16>>2]=f[m+16>>2];f[j+20>>2]=f[m+20>>2];f[j+24>>2]=f[m+24>>2];f[j+28>>2]=f[m+28>>2];f[j+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[j+36>>2]=q;f[j+40>>2]=p;p=j+48|0;r=j+44|0;f[r>>2]=p;f[p>>2]=0;f[j+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;U$(j,m);break}}else bS(j,a,-1);while(0);f[k>>2]=0;a=k+4|0;f[a>>2]=0;f[k+8>>2]=0;m=zLc(g)|0;HDa(j,c,d,e,m,zLc(h)|0,k,2147483647);f[l>>2]=1124024348;m=l+4|0;f[m>>2]=2;e=l+8|0;n=f[a>>2]|0;o=f[k>>2]|0;p=n-o|0;f[e>>2]=p>>4;f[l+12>>2]=1;r=l+16|0;q=l+40|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[q>>2]=e;e=l+48|0;s=l+44|0;f[s>>2]=e;f[e>>2]=0;t=l+52|0;f[t>>2]=0;v=o;if((v|0)!=(n|0)){f[t>>2]=16;f[e>>2]=16;f[r>>2]=v;f[l+20>>2]=v;v=o+p|0;f[l+24>>2]=v;f[l+28>>2]=v}jR(l,b);b=l+36|0;v=f[b>>2]|0;if(v|0?(p=v+12|0,v=f[p>>2]|0,f[p>>2]=v+-1,(v|0)==1):0)V$(l);f[b>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[m>>2]|0)>0){r=f[q>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[m>>2]|0))}m=f[s>>2]|0;if((m|0)!=(e|0))wL(m);m=f[k>>2]|0;if(m|0){k=f[a>>2]|0;if((k|0)!=(m|0))f[a>>2]=k+(~((k+-16-m|0)>>>4)<<4);cYc(m)}m=j+36|0;k=f[m>>2]|0;if(k|0?(a=k+12|0,k=f[a>>2]|0,f[a>>2]=k+-1,(k|0)==1):0)V$(j);f[m>>2]=0;m=j+16|0;k=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[j+40>>2]|0;a=0;do{f[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=i;return}wL(k);u=i;return}function HDa(a,c,d,e,g,h,i,j){a=a|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;k=u;u=u+416|0;l=k+392|0;m=k+384|0;o=k+328|0;p=k;q=k+272|0;r=k+256|0;s=k+240|0;t=k+224|0;f[m>>2]=0;v=m+4|0;f[v>>2]=0;w=1.0/c;if(f[a>>2]&4095|0){x=$Xc(32)|0;f[l>>2]=x;f[l+8>>2]=-2147483616;f[l+4>>2]=23;y=x;z=367166;A=y+23|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));b[x+23>>0]=0;vM(-215,l,367190,366624,471)}x=f[a+12>>2]|0;z=f[a+8>>2]|0;B=d;C=zLc(3.141592653589793/B)|0;D=ALc(+(z+x<<1|1|0)/c)|0;p$(p,C,D,4);f[o>>2]=1124007936;E=o+4|0;F=o+8|0;G=o+40|0;y=E;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[G>>2]=F;F=o+48|0;H=o+44|0;f[H>>2]=F;f[F>>2]=0;f[o+52>>2]=0;I=f[p>>2]|0;ei[f[(f[I>>2]|0)+12>>2]&511](I,p,o,-1);Zj(p);f[q>>2]=1124007936;p=q+4|0;I=q+8|0;K=q+40|0;y=p;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[K>>2]=I;I=q+48|0;y=q+44|0;f[y>>2]=I;f[I>>2]=0;f[q+52>>2]=0;f[l>>2]=z;f[l+4>>2]=x;S$(q,2,l,0);A=C<<1;f[l>>2]=0;M=l+4|0;f[M>>2]=0;f[l+8>>2]=0;if(C){if(A>>>0>1073741823)kWc(l);N=C<<3;Q=$Xc(N)|0;f[l>>2]=Q;R=Q+(A<<2)|0;f[l+8>>2]=R;g1c(Q|0,0,N|0)|0;f[M>>2]=R;R=(C|0)>0;if(R){c=w;N=0;do{w=B*+(N|0);d=c*+O(+w);A=N<<1;n[Q+(A<<2)>>2]=d;d=c*+P(+w);n[Q+((A|1)<<2)>>2]=d;N=N+1|0}while((N|0)!=(C|0));S=R;T=Q}else{S=0;T=Q}}else{S=0;T=0}Q=q+16|0;R=f[Q>>2]|0;f[r>>2]=0;N=r+4|0;f[N>>2]=0;f[r+8>>2]=0;f[v>>2]=0;do if((z|0)>0){A=a+16|0;U=a+44|0;V=r+8|0;if((x|0)>0){W=R;X=0}else{Z=0;do Z=Z+1|0;while((Z|0)<(z|0));f[m>>2]=0;f[v>>2]=Z;_=0;$=0;aa=0;break}while(1){ba=(f[A>>2]|0)+(Y(f[f[U>>2]>>2]|0,X)|0)|0;ca=W+(Y(f[f[y>>2]>>2]|0,X)|0)|0;f[m>>2]=0;da=0;do{ea=ca+da|0;do if(b[ba+da>>0]|0){b[ea>>0]=1;fa=f[N>>2]|0;if((fa|0)==(f[V>>2]|0)){Nw(r,m);break}else{f[fa>>2]=f[m>>2];f[fa+4>>2]=f[v>>2];f[N>>2]=fa+8;break}}else b[ea>>0]=0;while(0);da=(f[m>>2]|0)+1|0;f[m>>2]=da}while((da|0)<(x|0));da=(f[v>>2]|0)+1|0;f[v>>2]=da;if((da|0)>=(z|0))break;W=f[Q>>2]|0;X=da}V=f[r>>2]|0;_=V;$=f[N>>2]|0;aa=V}else{_=0;$=0;aa=0}while(0);X=$-_|0;a:do if((X|0)>0){_=e+-1|0;$=o+16|0;W=(D+-1|0)/2|0;v=s+8|0;m=s+12|0;a=s+4|0;V=t+4|0;U=t+8|0;A=t+12|0;Z=i+4|0;da=i+8|0;ba=S^1;ca=X>>>3;ea=-1;fa=-1;ga=aa;while(1){ha=x1c(ea|0,0,-130063606,0)|0;ia=d1c(ha|0,J|0,fa|0,0)|0;ha=J;ja=(ia>>>0)%(ca>>>0)|0;ka=f[ga+(ja<<3)>>2]|0;la=f[ga+(ja<<3)+4>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;ma=f[$>>2]|0;na=ca+-1|0;f[ga+(ja<<3)>>2]=f[ga+(na<<3)>>2];f[ga+(ja<<3)+4>>2]=f[ga+(na<<3)+4>>2];ja=R+((Y(la,x)|0)+ka)|0;if(!((b[ja>>0]|0)==0|ba)){c=+(ka|0);B=+(la|0);ja=_;oa=0;pa=0;qa=ma;while(1){ma=oa<<1;ra=qa+((ALc(c*+n[T+(ma<<2)>>2]+B*+n[T+((ma|1)<<2)>>2])|0)+W<<2)|0;ma=f[ra>>2]|0;sa=ma+1|0;f[ra>>2]=sa;ra=(ja|0)>(ma|0);pa=ra?pa:oa;ja=ra?ja:sa;oa=oa+1|0;if((oa|0)==(C|0))break;else qa=qa+(D<<2)|0}if((ja|0)>=(e|0)){qa=pa<<1;B=+n[T+((qa|1)<<2)>>2];c=+n[T+(qa<<2)>>2];d=+L(+-B);w=+L(+c);if(d>w){ta=0;ua=ALc(c*65536.0/d)|0;va=B<-0.0?1:-1;wa=la<<16|32768;xa=ka}else{ta=1;ua=c>0.0?1:-1;va=ALc(B*-65536.0/w)|0;wa=la;xa=ka<<16|32768}qa=0-va|0;oa=0-ua|0;sa=wa>>16;ra=xa>>16;if(((ta?ra:xa)|0)>=0){ma=f[a>>2]|0;ya=f[s>>2]|0;b:do if(ta){za=ra;Aa=ya;Ba=wa;Ca=ma;Da=xa;Ea=0;while(1){if(!((Ba|0)<(z|0)&((za|0)<(x|0)&(Ba|0)>-1))){Fa=Aa;Ga=Ca;break b}Ha=R+(Y(Ba,x)|0)+za|0;if(!(b[Ha>>0]|0))if((Ea|0)<(h|0)){Ia=Aa;Ja=Ca;Ka=Ea+1|0}else{Fa=Aa;Ga=Ca;break b}else{Ia=za;Ja=Ba;Ka=0}Da=Da+va|0;za=Da>>16;if((za|0)<0){Fa=Ia;Ga=Ja;break}else{Aa=Ia;Ba=Ba+ua|0;Ca=Ja;Ea=Ka}}}else{Ea=xa;Ca=ya;Ba=sa;Aa=ma;za=wa;Da=0;while(1){if(!((Ba|0)<(z|0)&((Ea|0)<(x|0)&(Ba|0)>-1))){Fa=Ca;Ga=Aa;break b}Ha=R+(Y(Ba,x)|0)+Ea|0;if(!(b[Ha>>0]|0))if((Da|0)<(h|0)){La=Ca;Ma=Aa;Na=Da+1|0}else{Fa=Ca;Ga=Aa;break b}else{La=Ea;Ma=Ba;Na=0}Ea=Ea+va|0;Ha=za+ua|0;if((Ea|0)<0){Fa=La;Ga=Ma;break}else{Ca=La;Ba=Ha>>16;Aa=Ma;za=Ha;Da=Na}}}while(0);f[a>>2]=Ga;f[s>>2]=Fa;ma=f[m>>2]|0;ya=f[v>>2]|0;c:do if(ta){ka=ra;la=ya;pa=wa;ja=ma;Da=xa;za=0;while(1){if(!((pa|0)<(z|0)&((ka|0)<(x|0)&(pa|0)>-1))){Oa=la;Pa=ja;break c}Aa=R+(Y(pa,x)|0)+ka|0;if(!(b[Aa>>0]|0))if((za|0)<(h|0)){Qa=la;Ra=ja;Sa=za+1|0}else{Oa=la;Pa=ja;break c}else{Qa=ka;Ra=pa;Sa=0}Da=Da-va|0;ka=Da>>16;if((ka|0)<0){Oa=Qa;Pa=Ra;break}else{la=Qa;pa=pa-ua|0;ja=Ra;za=Sa}}}else{za=xa;ja=ya;pa=sa;la=ma;ka=wa;Da=0;while(1){if(!((pa|0)<(z|0)&((za|0)<(x|0)&(pa|0)>-1))){Oa=ja;Pa=la;break c}Aa=R+(Y(pa,x)|0)+za|0;if(!(b[Aa>>0]|0))if((Da|0)<(h|0)){Ta=ja;Ua=la;Va=Da+1|0}else{Oa=ja;Pa=la;break c}else{Ta=za;Ua=pa;Va=0}za=za-va|0;Aa=ka-ua|0;if((za|0)<0){Oa=Ta;Pa=Ua;break}else{ja=Ta;pa=Aa>>16;la=Ua;ka=Aa;Da=Va}}}while(0);f[m>>2]=Pa;f[v>>2]=Oa}ma=(f[v>>2]|0)-(f[s>>2]|0)|0;if((((ma|0)>-1?ma:0-ma|0)|0)<(g|0)){ma=(f[m>>2]|0)-(f[a>>2]|0)|0;Wa=(((ma|0)>-1?ma:0-ma|0)|0)>=(g|0)}else Wa=1;ma=Wa&S;sa=0;do{ya=(sa|0)==1;ra=ya?qa:va;Da=ya?oa:ua;ya=s+(sa<<3)|0;ka=s+(sa<<3)+4|0;d:do if(ta){la=wa;pa=xa;while(1){ja=pa>>16;za=R+(Y(la,x)|0)+ja|0;if(b[za>>0]|0){if(ma){w=+(ja|0);B=+(la|0);Aa=0;Ba=f[$>>2]|0;while(1){Ca=Aa<<1;Ea=Ba+((ALc(w*+n[T+(Ca<<2)>>2]+B*+n[T+((Ca|1)<<2)>>2])|0)+W<<2)|0;f[Ea>>2]=(f[Ea>>2]|0)+-1;Aa=Aa+1|0;if((Aa|0)==(C|0))break;else Ba=Ba+(D<<2)|0}}b[za>>0]=0}if((la|0)==(f[ka>>2]|0)?(ja|0)==(f[ya>>2]|0):0)break d;la=la+Da|0;pa=pa+ra|0}}else{if(Wa){Xa=wa;Ya=xa}else{pa=f[ka>>2]|0;la=f[ya>>2]|0;Ba=wa;Aa=xa;while(1){Ea=Ba>>16;Ca=R+(Y(Ea,x)|0)+Aa|0;if(b[Ca>>0]|0)b[Ca>>0]=0;if((Ea|0)==(pa|0)&(Aa|0)==(la|0))break d;Ba=Ba+Da|0;Aa=Aa+ra|0}}while(1){Aa=Xa>>16;Ba=R+(Y(Aa,x)|0)+Ya|0;if(b[Ba>>0]|0){if(S){B=+(Ya|0);w=+(Aa|0);la=0;pa=f[$>>2]|0;while(1){Ea=la<<1;Ca=pa+((ALc(B*+n[T+(Ea<<2)>>2]+w*+n[T+((Ea|1)<<2)>>2])|0)+W<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+-1;la=la+1|0;if((la|0)==(C|0))break;else pa=pa+(D<<2)|0}}b[Ba>>0]=0}if((Aa|0)==(f[ka>>2]|0)?(Ya|0)==(f[ya>>2]|0):0)break d;Xa=Xa+Da|0;Ya=Ya+ra|0}}while(0);sa=sa+1|0}while((sa|0)!=2);if(Wa){sa=f[s>>2]|0;ma=f[a>>2]|0;oa=f[v>>2]|0;qa=f[m>>2]|0;f[t>>2]=sa;f[V>>2]=ma;f[U>>2]=oa;f[A>>2]=qa;qa=f[Z>>2]|0;if((qa|0)==(f[da>>2]|0)){IDa(i,t);Za=f[Z>>2]|0}else{f[qa>>2]=sa;f[qa+4>>2]=f[V>>2];f[qa+8>>2]=f[U>>2];f[qa+12>>2]=f[A>>2];sa=qa+16|0;f[Z>>2]=sa;Za=sa}if((Za-(f[i>>2]|0)>>4|0)>=(j|0))break}}}if((ca|0)<=1)break a;ca=na;ea=ia;fa=ha;ga=f[r>>2]|0}}while(0);j=f[r>>2]|0;if(j|0){r=f[N>>2]|0;if((r|0)!=(j|0))f[N>>2]=r+(~((r+-8-j|0)>>>3)<<3);cYc(j)}j=f[l>>2]|0;if(j|0){l=f[M>>2]|0;if((l|0)!=(j|0))f[M>>2]=l+(~((l+-4-j|0)>>>2)<<2);cYc(j)}j=q+36|0;l=f[j>>2]|0;if(l|0?(M=l+12|0,l=f[M>>2]|0,f[M>>2]=l+-1,(l|0)==1):0)V$(q);f[j>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[p>>2]|0)>0){Q=f[K>>2]|0;K=0;do{f[Q+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[p>>2]|0))}p=f[y>>2]|0;if((p|0)!=(I|0))wL(p);p=o+36|0;I=f[p>>2]|0;if(I|0?(y=I+12|0,I=f[y>>2]|0,f[y>>2]=I+-1,(I|0)==1):0)V$(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[E>>2]|0)>0){p=f[G>>2]|0;G=0;do{f[p+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[H>>2]|0;if((E|0)==(F|0)){u=k;return}wL(E);u=k;return}function IDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function JDa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;KDa(a,b,c,d,e,f,g,h,i,-1);return}function KDa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=+i;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0;m=u;u=u+608|0;o=m;p=m+552|0;q=m+520|0;r=m+464|0;t=m+408|0;v=m+352|0;w=m+324|0;x=m+312|0;y=m+256|0;z=m+200|0;A=m+144|0;B=m+128|0;C=m+72|0;D=m+16|0;if(YS(c)|0){E=dS(c,-1)|0;if((E|8|0)==29)F=E;else qV(E,78784)}else F=21;if(sS(a)|0){G=$Xc(96)|0;f[o>>2]=G;H=o+8|0;f[H>>2]=-2147483552;I=o+4|0;f[I>>2]=82;J=G;K=367214;L=J+82|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));M=G+82|0;b[M>>0]=0;vM(-215,o,367297,366624,1736)}if(dS(a,-1)|0){G=$Xc(96)|0;f[o>>2]=G;H=o+8|0;f[H>>2]=-2147483552;I=o+4|0;f[I>>2]=82;J=G;K=367214;L=J+82|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));M=G+82|0;b[M>>0]=0;vM(-215,o,367297,366624,1736)}if((eS(a)|0)!=65536?(eS(a)|0)!=655360:0){G=$Xc(96)|0;f[o>>2]=G;H=o+8|0;f[H>>2]=-2147483552;I=o+4|0;f[I>>2]=82;J=G;K=367214;L=J+82|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));M=G+82|0;b[M>>0]=0;vM(-215,o,367297,366624,1736)}if((((eS(c)|0)!=65536?(eS(c)|0)!=196608:0)?(eS(c)|0)!=786432:0)?(eS(c)|0)!=917504:0){M=$Xc(48)|0;f[o>>2]=M;f[o+8>>2]=-2147483600;f[o+4>>2]=39;J=M;K=367310;L=J+39|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[M+39>>0]=0;vM(-215,o,367297,366624,1737)}if(e<=0.0|g<=0.0|h<=0.0|i<=0.0){M=$Xc(80)|0;f[o>>2]=M;f[o+8>>2]=-2147483568;f[o+4>>2]=76;J=M;K=367350;L=J+76|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[M+76>>0]=0;vM(-211,o,367297,366624,1740)}M=zLc(h)|0;G=zLc(i)|0;I=zLc(3.0)|0;H=(j|0)>0?j:0;j=(l|0)<0?2147483647:l;l=(k|0)<0;if((k|0)<1){E=lS(a,-1)|0;N=mS(a,-1)|0;O=(E|0)<(N|0)?N:E}else O=(H|0)<(k|0)?k:H+2|0;if((d|0)!=3){d=$Xc(80)|0;f[o>>2]=d;f[o+8>>2]=-2147483568;f[o+4>>2]=69;J=d;K=367555;L=J+69|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[d+69>>0]=0;vM(-5,o,367297,366624,1771)}switch(F|0){case 21:{i=e;h=g;switch(I|0){case 3:case 5:case 7:case -1:break;default:{F=$Xc(80)|0;f[o>>2]=F;f[o+8>>2]=-2147483568;f[o+4>>2]=73;J=F;K=367427;L=J+73|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[F+73>>0]=0;vM(-215,o,367501,366624,1631)}}F=i<1.0?1065353216:(n[s>>2]=i,f[s>>2]|0);i=(f[s>>2]=F,+n[s>>2]);P=1.0/i;f[r>>2]=1124007936;d=r+4|0;k=r+8|0;E=r+40|0;J=d;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[E>>2]=k;N=r+48|0;Q=r+44|0;f[Q>>2]=N;f[N>>2]=0;f[r+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;J=R;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[T>>2]=S;S=t+48|0;U=t+44|0;f[U>>2]=S;f[S>>2]=0;f[t+52>>2]=0;f[v>>2]=1124007936;V=v+4|0;W=v+8|0;X=v+40|0;J=V;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[X>>2]=W;W=v+48|0;Z=v+44|0;f[Z>>2]=W;f[W>>2]=0;f[v+52>>2]=0;_=o+8|0;f[_>>2]=0;f[_+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=t;soa(a,o,3,1,0,I,1.0,0.0,1);_=o+8|0;f[_>>2]=0;f[_+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=v;soa(a,o,3,0,1,I,1.0,0.0,1);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=t;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=v;_=q+8|0;f[_>>2]=0;f[_+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=r;_=(M|0)/2|0;Qoa(o,p,q,+(((_|0)>1?_:1)|0),+(M|0),0);WXc(w);_=i3()|0;$=(_|0)>1;f[x>>2]=0;aa=x+4|0;f[aa>>2]=0;f[x+8>>2]=0;LDa(y,lS(a,-1)|0,mS(a,-1)|0);ba=f[k>>2]|0;f[o>>2]=0;f[o+4>>2]=ba;f[p>>2]=78820;f[p+4>>2]=r;f[p+8>>2]=t;f[p+12>>2]=v;f[p+16>>2]=H;f[p+20>>2]=O;n[p+24>>2]=P;f[p+28>>2]=x;f[p+32>>2]=y;f[p+48>>2]=w;ca=P*+(f[r+12>>2]|0);k=~~ca;da=(+(k|0)<ca&1)+k|0;f[p+36>>2]=da;ca=P*+(ba|0);ba=~~ca;f[p+40>>2]=(+(ba|0)<ca&1)+ba;f[p+44>>2]=da+2;ca=+(((_|0)>1?_:1)|0);h3(o,p,ca);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=-2130640896;f[o+4>>2]=y;_=jP(o)|0;if((_|0)>=1){da=f[x>>2]|0;f[z>>2]=f[da>>2];ba=z+4|0;k=da+4|0;f[ba>>2]=f[k>>2];ea=z+8|0;f[ea>>2]=f[da+8>>2];fa=z+12|0;f[fa>>2]=f[da+12>>2];ga=z+16|0;f[ga>>2]=f[da+16>>2];f[z+20>>2]=f[da+20>>2];f[z+24>>2]=f[da+24>>2];f[z+28>>2]=f[da+28>>2];f[z+32>>2]=f[da+32>>2];ha=z+36|0;ia=f[da+36>>2]|0;f[ha>>2]=ia;ja=z+40|0;f[ja>>2]=ea;ka=z+48|0;la=z+44|0;f[la>>2]=ka;f[ka>>2]=0;f[z+52>>2]=0;if(ia|0){ma=ia+12|0;f[ma>>2]=(f[ma>>2]|0)+1}if((f[k>>2]|0)<3){k=f[da+44>>2]|0;ma=f[la>>2]|0;f[ma>>2]=f[k>>2];f[ma+4>>2]=f[k+4>>2]}else{f[ba>>2]=0;U$(z,da)}da=f[aa>>2]|0;k=f[x>>2]|0;ma=k;if(((da-k|0)/56|0)>>>0>1){k=o+8|0;ia=o+12|0;na=o+4|0;oa=p+8|0;pa=p+12|0;qa=p+4|0;ra=q+8|0;sa=q+4|0;ta=1;ua=ma;while(1){f[k>>2]=0;f[ia>>2]=0;f[o>>2]=16842752;f[na>>2]=z;f[oa>>2]=0;f[pa>>2]=0;f[p>>2]=16842752;f[qa>>2]=ua+(ta*56|0);va=ra;f[va>>2]=0;f[va+4>>2]=0;f[q>>2]=33619968;f[sa>>2]=z;E1(o,p,q,fT()|0,-1);ta=ta+1|0;va=f[aa>>2]|0;wa=f[x>>2]|0;xa=wa;if(ta>>>0>=((va-wa|0)/56|0)>>>0){ya=xa;za=va;break}else ua=xa}}else{ya=ma;za=da}da=za;if((da|0)!=(ya|0)){za=da;do{da=za+-56|0;f[aa>>2]=da;ma=za+-20|0;ua=f[ma>>2]|0;if(ua|0?(ta=ua+12|0,ua=f[ta>>2]|0,f[ta>>2]=ua+-1,(ua|0)==1):0)V$(da);f[ma>>2]=0;ma=za+-40|0;da=za+-52|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[da>>2]|0)>0){ma=f[za+-16>>2]|0;ua=0;do{f[ma+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[da>>2]|0))}da=f[za+-12>>2]|0;if((da|0)!=(za+-8|0))wL(da);za=f[aa>>2]|0}while((za|0)!=(ya|0))}f[p>>2]=0;ya=p+4|0;f[ya>>2]=0;f[p+8>>2]=0;za=f[ea>>2]|0;f[o>>2]=1;f[o+4>>2]=za+-1;f[q>>2]=78840;f[q+4>>2]=z;f[q+8>>2]=p;f[q+12>>2]=G;f[q+28>>2]=w;f[q+16>>2]=f[fa>>2];f[q+20>>2]=za;f[q+24>>2]=f[ga>>2];h3(o,q,$?+((za+-2|0)/4|0|0):1.0);za=f[ya>>2]|0;$=f[p>>2]|0;ea=za-$>>2;aa=$;if(!ea)Aa=aa;else{f[o>>2]=f[ga>>2];BDa(aa,za,o);f[q>>2]=0;za=q+4|0;f[za>>2]=0;f[q+8>>2]=0;aa=q+8|0;$=$Xc(3072)|0;da=$;f[q>>2]=da;f[za>>2]=da;f[aa>>2]=$+3072;a:do if(l){$=f[fa>>2]|0;ua=f[p>>2]|0;ma=(f[ya>>2]|0)-ua>>2;P=h*h;if(ma|0){ta=o+4|0;sa=o+8|0;ra=0;qa=ua;ua=da;pa=da;while(1){oa=f[qa+(ra<<2)>>2]|0;na=(oa|0)/($|0)|0;Ba=i*(+(oa-(Y(na,$)|0)|0)+.5);Ca=i*(+(na|0)+.5);n[o>>2]=Ba;n[ta>>2]=Ca;n[sa>>2]=0.0;na=pa-ua|0;oa=(na|0)/12|0;ia=ua;k=pa;if(na){na=1;xa=0;do{Da=Ba-+n[ia+(xa*12|0)>>2];Ea=Ca-+n[ia+(xa*12|0)+4>>2];va=!(Da*Da+Ea*Ea<P);na=na&va;xa=xa+1|0}while(xa>>>0<oa>>>0&va);if(na)Fa=49}else Fa=49;do if((Fa|0)==49){Fa=0;if((k|0)==(f[aa>>2]|0)){MDa(q,o);break}else{n[pa>>2]=Ba;f[k+4>>2]=f[ta>>2];f[k+8>>2]=f[sa>>2];f[za>>2]=k+12;break}}while(0);k=ra+1|0;if((k|0)==(ma|0))break a;ra=k;qa=f[p>>2]|0;ua=f[q>>2]|0;pa=f[za>>2]|0}}}else{f[A>>2]=0;pa=A+4|0;f[pa>>2]=0;f[A+8>>2]=0;do if((_|0)<(Y(O,O)|0)){f[B>>2]=0;ua=B+4|0;f[ua>>2]=0;f[B+8>>2]=0;NDa(B,_);qa=y+8|0;ra=f[qa>>2]|0;if((ra|0)>0){ma=y+16|0;sa=y+44|0;ta=y+12|0;$=o+4|0;k=B+8|0;na=0;oa=ra;ra=f[ta>>2]|0;while(1){xa=(f[ma>>2]|0)+(Y(f[f[sa>>2]>>2]|0,na)|0)|0;if((ra|0)>0){ia=ra;va=0;while(1){if(!(b[xa+va>>0]|0))Ga=ia;else{f[o>>2]=va;f[$>>2]=na;wa=f[ua>>2]|0;if(wa>>>0<(f[k>>2]|0)>>>0){f[wa>>2]=va;f[wa+4>>2]=f[$>>2];f[ua>>2]=wa+8;Ha=ia}else{ODa(B,o);Ha=f[ta>>2]|0}Ga=Ha}va=va+1|0;if((va|0)>=(Ga|0))break;else ia=Ga}Ia=Ga;Ja=f[qa>>2]|0}else{Ia=ra;Ja=oa}na=na+1|0;if((na|0)>=(Ja|0))break;else{oa=Ja;ra=Ia}}}f[C>>2]=0;f[C+4>>2]=ea;ra=f[fa>>2]|0;f[D>>2]=78860;f[D+4>>2]=B;f[D+8>>2]=_;f[D+12>>2]=p;f[D+16>>2]=A;f[D+20>>2]=ra;f[D+24>>2]=G;f[D+28>>2]=H;f[D+32>>2]=O;f[D+36>>2]=F;f[D+52>>2]=w;P=+(H|0);n[D+44>>2]=P*P;P=+(O|0);n[D+48>>2]=P*P;f[D+40>>2]=(f[ya>>2]|0)-(f[p>>2]|0)>>2;if((_|0)<=0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=8;ra=o;f[ra>>2]=2052291182;f[ra+4>>2]=807419424;b[o+8>>0]=0;vM(-215,o,367522,366624,1395)}h3(C,D,ca);ra=f[B>>2]|0;if(ra|0){oa=f[ua>>2]|0;if((oa|0)!=(ra|0))f[ua>>2]=oa+(~((oa+-8-ra|0)>>>3)<<3);cYc(ra)}}else{f[B>>2]=0;f[B+4>>2]=ea;ra=f[fa>>2]|0;f[C>>2]=78880;f[C+4>>2]=y;f[C+8>>2]=_;f[C+12>>2]=p;f[C+16>>2]=A;f[C+20>>2]=ra;f[C+24>>2]=G;f[C+28>>2]=H;f[C+32>>2]=O;f[C+36>>2]=F;f[C+52>>2]=w;P=+(H|0);n[C+44>>2]=P*P;P=+(O|0);n[C+48>>2]=P*P;f[C+40>>2]=(f[ya>>2]|0)-(f[p>>2]|0)>>2;if((_|0)>0){h3(B,C,ca);break}else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=8;ra=o;f[ra>>2]=2052291182;f[ra+4>>2]=807419424;b[o+8>>0]=0;vM(-215,o,367522,366624,1395)}}while(0);ra=f[A>>2]|0;oa=f[pa>>2]|0;f[o>>2]=618;QDa(ra,oa,o);oa=f[A>>2]|0;ra=f[pa>>2]|0;if((oa|0)!=(ra|0)){na=o+4|0;qa=o+8|0;ta=oa;do{oa=f[ta>>2]|0;f[o>>2]=oa;f[na>>2]=f[ta+4>>2];f[qa>>2]=f[ta+8>>2];$=f[za>>2]|0;if($>>>0<(f[aa>>2]|0)>>>0){f[$>>2]=oa;f[$+4>>2]=f[na>>2];f[$+8>>2]=f[qa>>2];f[za>>2]=$+12}else uba(q,o);ta=ta+16|0}while((ta|0)!=(ra|0))}P=h*h;ra=f[za>>2]|0;ta=f[q>>2]|0;qa=(ra-ta|0)/12|0;if(qa>>>0>1){na=1;$=1;oa=ra;k=ta;while(1){sa=k;ma=f[sa+($*12|0)>>2]|0;ia=f[sa+($*12|0)+4>>2]|0;va=f[sa+($*12|0)+8>>2]|0;Ba=(f[s>>2]=ma,+n[s>>2]);Ca=(f[s>>2]=ia,+n[s>>2]);if(na){xa=1;wa=0;do{Ea=Ba-+n[sa+(wa*12|0)>>2];Da=Ca-+n[sa+(wa*12|0)+4>>2];Ka=!(Ea*Ea+Da*Da<P);xa=xa&Ka;wa=wa+1|0}while(wa>>>0<na>>>0&Ka);if(!xa){La=na;Ma=k;Na=oa}else Fa=91}else Fa=91;if((Fa|0)==91){Fa=0;f[sa+(na*12|0)>>2]=ma;f[sa+(na*12|0)+4>>2]=ia;f[sa+(na*12|0)+8>>2]=va;La=na+1|0;Ma=f[q>>2]|0;Na=f[za>>2]|0}$=$+1|0;wa=(Na-Ma|0)/12|0;if($>>>0>=wa>>>0){Oa=La;Pa=wa;Qa=Ma;Ra=Na;break}else{na=La;oa=Na;k=Ma}}}else{Oa=1;Pa=qa;Qa=ta;Ra=ra}k=Qa;oa=Ra;do if(Oa>>>0>Pa>>>0)RDa(q,Oa-Pa|0);else{if(Oa>>>0>=Pa>>>0)break;na=k+(Oa*12|0)|0;if((oa|0)==(na|0))break;f[za>>2]=oa+(~(((oa+-12-na|0)>>>0)/12|0)*12|0)}while(0);oa=f[A>>2]|0;if(oa|0){k=f[pa>>2]|0;if((k|0)!=(oa|0))f[pa>>2]=k+(~((k+-16-oa|0)>>>4)<<4);cYc(oa)}}while(0);Oa=f[q>>2]|0;Pa=(f[za>>2]|0)-Oa|0;Ra=(Pa|0)/12|0;Qa=Oa;if(!Pa)Sa=Oa;else{Pa=(Ra|0)<(j|0)?Ra:j;f[A>>2]=1124007957;Ra=A+4|0;f[Ra>>2]=2;Ma=A+8|0;f[Ma>>2]=1;f[A+12>>2]=Pa;Na=A+16|0;f[Na>>2]=Qa;f[A+20>>2]=Qa;La=A+24|0;aa=A+40|0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;f[aa>>2]=Ma;Ma=A+48|0;_=A+44|0;f[_>>2]=Ma;F=A+52|0;f[F>>2]=0;f[Ma>>2]=0;if((Oa|0)==0&(Pa|0)!=0){Oa=$Xc(32)|0;f[o>>2]=Oa;f[o+8>>2]=-2147483616;f[o+4>>2]=28;J=Oa;K=470314;L=J+28|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[Oa+28>>0]=0;vM(-215,o,470343,470347,548)}Oa=Pa*12|0;f[Ma>>2]=Oa;f[F>>2]=12;F=Qa+Oa|0;f[A+28>>2]=F;f[La>>2]=F+(0-Oa)+Oa;R$(A);jR(A,c);Oa=A+36|0;F=f[Oa>>2]|0;do if(F|0){La=F+12|0;Qa=f[La>>2]|0;f[La>>2]=Qa+-1;if((Qa|0)!=1)break;V$(A)}while(0);f[Oa>>2]=0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[Ra>>2]|0)>0){Na=f[aa>>2]|0;aa=0;do{f[Na+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[Ra>>2]|0))}Ra=f[_>>2]|0;if((Ra|0)!=(Ma|0))wL(Ra);Sa=f[q>>2]|0}if(Sa|0){Ra=f[za>>2]|0;if((Ra|0)!=(Sa|0))f[za>>2]=Ra+(~(((Ra+-12-Sa|0)>>>0)/12|0)*12|0);cYc(Sa)}Aa=f[p>>2]|0}if(Aa|0){Sa=f[ya>>2]|0;if((Sa|0)!=(Aa|0))f[ya>>2]=Sa+(~((Sa+-4-Aa|0)>>>2)<<2);cYc(Aa)}Aa=f[ha>>2]|0;if(Aa|0?(Sa=Aa+12|0,Aa=f[Sa>>2]|0,f[Sa>>2]=Aa+-1,(Aa|0)==1):0)V$(z);f[ha>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[ba>>2]|0)>0){ga=f[ja>>2]|0;ja=0;do{f[ga+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[ba>>2]|0))}ba=f[la>>2]|0;if((ba|0)!=(ka|0))wL(ba)}ba=y+36|0;ka=f[ba>>2]|0;if(ka|0?(la=ka+12|0,ka=f[la>>2]|0,f[la>>2]=ka+-1,(ka|0)==1):0)V$(y);f[ba>>2]=0;ba=y+16|0;ka=y+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ka>>2]|0)>0){ba=f[y+40>>2]|0;la=0;do{f[ba+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[ka>>2]|0))}ka=f[y+44>>2]|0;if((ka|0)!=(y+48|0))wL(ka);hx(x);XXc(w);ka=v+36|0;la=f[ka>>2]|0;if(la|0?(ba=la+12|0,la=f[ba>>2]|0,f[ba>>2]=la+-1,(la|0)==1):0)V$(v);f[ka>>2]=0;ka=v+16|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[V>>2]|0)>0){ka=f[X>>2]|0;X=0;do{f[ka+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[V>>2]|0))}V=f[Z>>2]|0;if((V|0)!=(W|0))wL(V);V=t+36|0;W=f[V>>2]|0;if(W|0?(Z=W+12|0,W=f[Z>>2]|0,f[Z>>2]=W+-1,(W|0)==1):0)V$(t);f[V>>2]=0;V=t+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){V=f[T>>2]|0;T=0;do{f[V+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[U>>2]|0;if((R|0)!=(S|0))wL(R);R=r+36|0;S=f[R>>2]|0;do if(S|0){U=S+12|0;T=f[U>>2]|0;f[U>>2]=T+-1;if((T|0)!=1)break;V$(r)}while(0);f[R>>2]=0;R=r+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[d>>2]|0)>0){R=f[E>>2]|0;E=0;do{f[R+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[d>>2]|0))}d=f[Q>>2]|0;if((d|0)!=(N|0))wL(d);u=m;return}case 29:{h=e;e=g;switch(I|0){case 3:case 5:case 7:case -1:break;default:{d=$Xc(80)|0;f[o>>2]=d;f[o+8>>2]=-2147483568;f[o+4>>2]=73;J=d;K=367427;L=J+73|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[d+73>>0]=0;vM(-215,o,367501,366624,1631)}}d=h<1.0?1065353216:(n[s>>2]=h,f[s>>2]|0);h=(f[s>>2]=d,+n[s>>2]);g=1.0/h;f[r>>2]=1124007936;N=r+4|0;Q=r+8|0;E=r+40|0;J=N;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[E>>2]=Q;R=r+48|0;S=r+44|0;f[S>>2]=R;f[R>>2]=0;f[r+52>>2]=0;f[t>>2]=1124007936;T=t+4|0;U=t+8|0;V=t+40|0;J=T;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[V>>2]=U;U=t+48|0;W=t+44|0;f[W>>2]=U;f[U>>2]=0;f[t+52>>2]=0;f[v>>2]=1124007936;Z=v+4|0;X=v+8|0;ka=v+40|0;J=Z;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[ka>>2]=X;X=v+48|0;la=v+44|0;f[la>>2]=X;f[X>>2]=0;f[v+52>>2]=0;ba=o+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=t;soa(a,o,3,1,0,I,1.0,0.0,1);ba=o+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=v;soa(a,o,3,0,1,I,1.0,0.0,1);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=t;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=v;I=q+8|0;f[I>>2]=0;f[I+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=r;I=(M|0)/2|0;Qoa(o,p,q,+(((I|0)>1?I:1)|0),+(M|0),0);WXc(w);M=i3()|0;I=(M|0)>1;f[x>>2]=0;ba=x+4|0;f[ba>>2]=0;f[x+8>>2]=0;ja=lS(a,-1)|0;LDa(y,ja,mS(a,-1)|0);a=f[Q>>2]|0;f[o>>2]=0;f[o+4>>2]=a;f[p>>2]=78820;f[p+4>>2]=r;f[p+8>>2]=t;f[p+12>>2]=v;f[p+16>>2]=H;f[p+20>>2]=O;n[p+24>>2]=g;f[p+28>>2]=x;f[p+32>>2]=y;f[p+48>>2]=w;ca=g*+(f[r+12>>2]|0);Q=~~ca;ja=(+(Q|0)<ca&1)+Q|0;f[p+36>>2]=ja;ca=g*+(a|0);a=~~ca;f[p+40>>2]=(+(a|0)<ca&1)+a;f[p+44>>2]=ja+2;ca=+(((M|0)>1?M:1)|0);h3(o,p,ca);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=-2130640896;f[o+4>>2]=y;M=jP(o)|0;if((M|0)>=1){ja=f[x>>2]|0;f[z>>2]=f[ja>>2];a=z+4|0;Q=ja+4|0;f[a>>2]=f[Q>>2];ga=z+8|0;f[ga>>2]=f[ja+8>>2];ha=z+12|0;f[ha>>2]=f[ja+12>>2];Aa=z+16|0;f[Aa>>2]=f[ja+16>>2];f[z+20>>2]=f[ja+20>>2];f[z+24>>2]=f[ja+24>>2];f[z+28>>2]=f[ja+28>>2];f[z+32>>2]=f[ja+32>>2];Sa=z+36|0;ya=f[ja+36>>2]|0;f[Sa>>2]=ya;Ra=z+40|0;f[Ra>>2]=ga;za=z+48|0;Ma=z+44|0;f[Ma>>2]=za;f[za>>2]=0;f[z+52>>2]=0;if(ya|0){_=ya+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[Q>>2]|0)<3){Q=f[ja+44>>2]|0;_=f[Ma>>2]|0;f[_>>2]=f[Q>>2];f[_+4>>2]=f[Q+4>>2]}else{f[a>>2]=0;U$(z,ja)}ja=f[ba>>2]|0;Q=f[x>>2]|0;_=Q;if(((ja-Q|0)/56|0)>>>0>1){Q=o+8|0;ya=o+12|0;aa=o+4|0;Na=p+8|0;Oa=p+12|0;F=p+4|0;Qa=q+8|0;La=q+4|0;Pa=1;fa=_;while(1){f[Q>>2]=0;f[ya>>2]=0;f[o>>2]=16842752;f[aa>>2]=z;f[Na>>2]=0;f[Oa>>2]=0;f[p>>2]=16842752;f[F>>2]=fa+(Pa*56|0);ea=Qa;f[ea>>2]=0;f[ea+4>>2]=0;f[q>>2]=33619968;f[La>>2]=z;E1(o,p,q,fT()|0,-1);Pa=Pa+1|0;ea=f[ba>>2]|0;Ia=f[x>>2]|0;Ja=Ia;if(Pa>>>0>=((ea-Ia|0)/56|0)>>>0){Ta=Ja;Ua=ea;break}else fa=Ja}}else{Ta=_;Ua=ja}ja=Ua;if((ja|0)!=(Ta|0)){Ua=ja;do{ja=Ua+-56|0;f[ba>>2]=ja;_=Ua+-20|0;fa=f[_>>2]|0;if(fa|0?(Pa=fa+12|0,fa=f[Pa>>2]|0,f[Pa>>2]=fa+-1,(fa|0)==1):0)V$(ja);f[_>>2]=0;_=Ua+-40|0;ja=Ua+-52|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[ja>>2]|0)>0){_=f[Ua+-16>>2]|0;fa=0;do{f[_+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ja>>2]|0))}ja=f[Ua+-12>>2]|0;if((ja|0)!=(Ua+-8|0))wL(ja);Ua=f[ba>>2]|0}while((Ua|0)!=(Ta|0))}f[p>>2]=0;Ta=p+4|0;f[Ta>>2]=0;f[p+8>>2]=0;Ua=f[ga>>2]|0;f[o>>2]=1;f[o+4>>2]=Ua+-1;f[q>>2]=78840;f[q+4>>2]=z;f[q+8>>2]=p;f[q+12>>2]=G;f[q+28>>2]=w;f[q+16>>2]=f[ha>>2];f[q+20>>2]=Ua;f[q+24>>2]=f[Aa>>2];h3(o,q,I?+((Ua+-2|0)/4|0|0):1.0);Ua=f[Ta>>2]|0;I=f[p>>2]|0;ga=Ua-I>>2;ba=I;if(!ga)Va=ba;else{f[o>>2]=f[Aa>>2];BDa(ba,Ua,o);f[q>>2]=0;Ua=q+4|0;f[Ua>>2]=0;f[q+8>>2]=0;ba=q+8|0;I=$Xc(4096)|0;ja=I;f[q>>2]=ja;f[Ua>>2]=ja;f[ba>>2]=I+4096;b:do if(l){I=f[ha>>2]|0;fa=f[p>>2]|0;_=(f[Ta>>2]|0)-fa>>2;g=e*e;if(_|0){pa=o+4|0;Pa=o+8|0;La=o+12|0;Qa=0;F=fa;fa=ja;Oa=ja;while(1){Na=f[F+(Qa<<2)>>2]|0;aa=(Na|0)/(I|0)|0;i=h*(+(Na-(Y(aa,I)|0)|0)+.5);P=h*(+(aa|0)+.5);n[o>>2]=i;n[pa>>2]=P;n[Pa>>2]=0.0;n[La>>2]=+(Na|0);Na=Oa-fa>>4;aa=fa;ya=Oa;if(Na){Q=1;Ja=0;do{Ca=i-+n[aa+(Ja<<4)>>2];Ba=P-+n[aa+(Ja<<4)+4>>2];ea=!(Ca*Ca+Ba*Ba<g);Q=Q&ea;Ja=Ja+1|0}while(Ja>>>0<Na>>>0&ea);if(Q)Fa=189}else Fa=189;do if((Fa|0)==189){Fa=0;if((ya|0)==(f[ba>>2]|0)){SDa(q,o);break}else{n[Oa>>2]=i;f[ya+4>>2]=f[pa>>2];f[ya+8>>2]=f[Pa>>2];f[ya+12>>2]=f[La>>2];f[Ua>>2]=ya+16;break}}while(0);ya=Qa+1|0;if((ya|0)==(_|0))break b;Qa=ya;F=f[p>>2]|0;fa=f[q>>2]|0;Oa=f[Ua>>2]|0}}}else{f[A>>2]=0;Oa=A+4|0;f[Oa>>2]=0;f[A+8>>2]=0;do if((M|0)<(Y(O,O)|0)){f[B>>2]=0;fa=B+4|0;f[fa>>2]=0;f[B+8>>2]=0;NDa(B,M);F=y+8|0;Qa=f[F>>2]|0;if((Qa|0)>0){_=y+16|0;La=y+44|0;Pa=y+12|0;pa=o+4|0;I=B+8|0;ya=0;Q=Qa;Qa=f[Pa>>2]|0;while(1){Na=(f[_>>2]|0)+(Y(f[f[La>>2]>>2]|0,ya)|0)|0;if((Qa|0)>0){Ja=Qa;aa=0;while(1){if(!(b[Na+aa>>0]|0))Wa=Ja;else{f[o>>2]=aa;f[pa>>2]=ya;va=f[fa>>2]|0;if(va>>>0<(f[I>>2]|0)>>>0){f[va>>2]=aa;f[va+4>>2]=f[pa>>2];f[fa>>2]=va+8;Xa=Ja}else{ODa(B,o);Xa=f[Pa>>2]|0}Wa=Xa}aa=aa+1|0;if((aa|0)>=(Wa|0))break;else Ja=Wa}Ya=Wa;Za=f[F>>2]|0}else{Ya=Qa;Za=Q}ya=ya+1|0;if((ya|0)>=(Za|0))break;else{Q=Za;Qa=Ya}}}f[C>>2]=0;f[C+4>>2]=ga;Qa=f[ha>>2]|0;f[D>>2]=78860;f[D+4>>2]=B;f[D+8>>2]=M;f[D+12>>2]=p;f[D+16>>2]=A;f[D+20>>2]=Qa;f[D+24>>2]=G;f[D+28>>2]=H;f[D+32>>2]=O;f[D+36>>2]=d;f[D+52>>2]=w;g=+(H|0);n[D+44>>2]=g*g;g=+(O|0);n[D+48>>2]=g*g;f[D+40>>2]=(f[Ta>>2]|0)-(f[p>>2]|0)>>2;if((M|0)<=0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=8;Qa=o;f[Qa>>2]=2052291182;f[Qa+4>>2]=807419424;b[o+8>>0]=0;vM(-215,o,367522,366624,1395)}h3(C,D,ca);Qa=f[B>>2]|0;if(Qa|0){Q=f[fa>>2]|0;if((Q|0)!=(Qa|0))f[fa>>2]=Q+(~((Q+-8-Qa|0)>>>3)<<3);cYc(Qa)}}else{f[B>>2]=0;f[B+4>>2]=ga;Qa=f[ha>>2]|0;f[C>>2]=78880;f[C+4>>2]=y;f[C+8>>2]=M;f[C+12>>2]=p;f[C+16>>2]=A;f[C+20>>2]=Qa;f[C+24>>2]=G;f[C+28>>2]=H;f[C+32>>2]=O;f[C+36>>2]=d;f[C+52>>2]=w;g=+(H|0);n[C+44>>2]=g*g;g=+(O|0);n[C+48>>2]=g*g;f[C+40>>2]=(f[Ta>>2]|0)-(f[p>>2]|0)>>2;if((M|0)>0){h3(B,C,ca);break}else{f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[o+11>>0]=8;Qa=o;f[Qa>>2]=2052291182;f[Qa+4>>2]=807419424;b[o+8>>0]=0;vM(-215,o,367522,366624,1395)}}while(0);Qa=f[A>>2]|0;Q=f[Oa>>2]|0;f[o>>2]=618;QDa(Qa,Q,o);Q=f[A>>2]|0;Qa=f[Oa>>2]|0;if((Q|0)!=(Qa|0)){ya=o+4|0;F=o+8|0;Pa=o+12|0;pa=Q;do{Q=f[pa>>2]|0;I=f[pa+4>>2]|0;La=f[pa+8>>2]|0;g=+(f[pa+12>>2]|0);f[o>>2]=Q;f[ya>>2]=I;f[F>>2]=La;n[Pa>>2]=g;La=f[Ua>>2]|0;if(La>>>0<(f[ba>>2]|0)>>>0){f[La>>2]=Q;f[La+4>>2]=f[ya>>2];f[La+8>>2]=f[F>>2];f[La+12>>2]=f[Pa>>2];f[Ua>>2]=La+16}else TDa(q,o);pa=pa+16|0}while((pa|0)!=(Qa|0))}g=e*e;Qa=f[Ua>>2]|0;pa=f[q>>2]|0;Pa=Qa-pa>>4;if(Pa>>>0>1){F=1;ya=1;La=pa;Q=Qa;while(1){I=La;_=f[I+(ya<<4)>>2]|0;Ja=f[I+(ya<<4)+4>>2]|0;aa=f[I+(ya<<4)+8>>2]|0;Na=f[I+(ya<<4)+12>>2]|0;i=(f[s>>2]=_,+n[s>>2]);P=(f[s>>2]=Ja,+n[s>>2]);if(F){va=1;sa=0;do{Ba=i-+n[I+(sa<<4)>>2];Ca=P-+n[I+(sa<<4)+4>>2];ia=!(Ba*Ba+Ca*Ca<g);va=va&ia;sa=sa+1|0}while(sa>>>0<F>>>0&ia);if(!va){_a=F;$a=La;ab=Q}else Fa=231}else Fa=231;if((Fa|0)==231){Fa=0;f[I+(F<<4)>>2]=_;f[I+(F<<4)+4>>2]=Ja;f[I+(F<<4)+8>>2]=aa;f[I+(F<<4)+12>>2]=Na;_a=F+1|0;$a=f[q>>2]|0;ab=f[Ua>>2]|0}ya=ya+1|0;sa=ab-$a>>4;if(ya>>>0>=sa>>>0){bb=_a;cb=sa;db=$a;eb=ab;break}else{F=_a;La=$a;Q=ab}}}else{bb=1;cb=Pa;db=pa;eb=Qa}Q=db;La=eb;do if(bb>>>0>cb>>>0)UDa(q,bb-cb|0);else{if(bb>>>0>=cb>>>0)break;F=Q+(bb<<4)|0;if((La|0)==(F|0))break;f[Ua>>2]=La+(~((La+-16-F|0)>>>4)<<4)}while(0);La=f[A>>2]|0;if(La|0){Q=f[Oa>>2]|0;if((Q|0)!=(La|0))f[Oa>>2]=Q+(~((Q+-16-La|0)>>>4)<<4);cYc(La)}}while(0);bb=f[q>>2]|0;cb=(f[Ua>>2]|0)-bb>>4;eb=bb;if(!cb)fb=bb;else{db=(cb|0)<(j|0)?cb:j;f[A>>2]=1124007965;j=A+4|0;f[j>>2]=2;cb=A+8|0;f[cb>>2]=1;f[A+12>>2]=db;ab=A+16|0;f[ab>>2]=eb;f[A+20>>2]=eb;$a=A+24|0;_a=A+40|0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;f[_a>>2]=cb;cb=A+48|0;Fa=A+44|0;f[Fa>>2]=cb;ba=A+52|0;f[ba>>2]=0;f[cb>>2]=0;if((bb|0)==0&(db|0)!=0){bb=$Xc(32)|0;f[o>>2]=bb;f[o+8>>2]=-2147483616;f[o+4>>2]=28;J=bb;K=470314;L=J+28|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[bb+28>>0]=0;vM(-215,o,470343,470347,548)}bb=db<<4;f[cb>>2]=bb;f[ba>>2]=16;ba=eb+bb|0;f[A+28>>2]=ba;f[$a>>2]=ba+(0-bb)+bb;R$(A);jR(A,c);c=A+36|0;bb=f[c>>2]|0;do if(bb|0){ba=bb+12|0;$a=f[ba>>2]|0;f[ba>>2]=$a+-1;if(($a|0)!=1)break;V$(A)}while(0);f[c>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[j>>2]|0)>0){ab=f[_a>>2]|0;_a=0;do{f[ab+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[j>>2]|0))}j=f[Fa>>2]|0;if((j|0)!=(cb|0))wL(j);fb=f[q>>2]|0}if(fb|0){q=f[Ua>>2]|0;if((q|0)!=(fb|0))f[Ua>>2]=q+(~((q+-16-fb|0)>>>4)<<4);cYc(fb)}Va=f[p>>2]|0}if(Va|0){p=f[Ta>>2]|0;if((p|0)!=(Va|0))f[Ta>>2]=p+(~((p+-4-Va|0)>>>2)<<2);cYc(Va)}Va=f[Sa>>2]|0;if(Va|0?(p=Va+12|0,Va=f[p>>2]|0,f[p>>2]=Va+-1,(Va|0)==1):0)V$(z);f[Sa>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[a>>2]|0)>0){Aa=f[Ra>>2]|0;Ra=0;do{f[Aa+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[a>>2]|0))}a=f[Ma>>2]|0;if((a|0)!=(za|0))wL(a)}a=y+36|0;za=f[a>>2]|0;if(za|0?(Ma=za+12|0,za=f[Ma>>2]|0,f[Ma>>2]=za+-1,(za|0)==1):0)V$(y);f[a>>2]=0;a=y+16|0;za=y+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[za>>2]|0)>0){a=f[y+40>>2]|0;Ma=0;do{f[a+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[za>>2]|0))}za=f[y+44>>2]|0;if((za|0)!=(y+48|0))wL(za);hx(x);XXc(w);w=v+36|0;x=f[w>>2]|0;if(x|0?(za=x+12|0,x=f[za>>2]|0,f[za>>2]=x+-1,(x|0)==1):0)V$(v);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[Z>>2]|0)>0){w=f[ka>>2]|0;ka=0;do{f[w+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[Z>>2]|0))}Z=f[la>>2]|0;if((Z|0)!=(X|0))wL(Z);Z=t+36|0;X=f[Z>>2]|0;if(X|0?(la=X+12|0,X=f[la>>2]|0,f[la>>2]=X+-1,(X|0)==1):0)V$(t);f[Z>>2]=0;Z=t+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[T>>2]|0)>0){Z=f[V>>2]|0;V=0;do{f[Z+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[T>>2]|0))}T=f[W>>2]|0;if((T|0)!=(U|0))wL(T);T=r+36|0;U=f[T>>2]|0;do if(U|0){W=U+12|0;V=f[W>>2]|0;f[W>>2]=V+-1;if((V|0)!=1)break;V$(r)}while(0);f[T>>2]=0;T=r+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[N>>2]|0)>0){T=f[E>>2]|0;E=0;do{f[T+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[N>>2]|0))}N=f[S>>2]|0;if((N|0)!=(R|0))wL(N);u=m;return}default:{m=$Xc(16)|0;f[o>>2]=m;f[o+8>>2]=-2147483632;f[o+4>>2]=14;J=m;K=366811;L=J+14|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));b[m+14>>0]=0;vM(-2,o,367297,366624,1768)}}}function LDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d;f[a>>2]=1124007936;g=a+8|0;h=a+40|0;i=a+4|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+48|0;f[a+44>>2]=g;f[g>>2]=0;f[a+52>>2]=0;f[e>>2]=b;f[e+4>>2]=c;S$(a,2,e,0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;lR(a,e)|0;u=d;return}function MDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)kWc(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/12|0;l=k<<1;m=k>>>0<178956970?(l>>>0<h>>>0?h:l):357913941;do if(m)if(m>>>0>357913941){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m*12|0)|0;break}else n=0;while(0);l=n+(g*12|0)|0;h=n+(m*12|0)|0;f[l>>2]=f[b>>2];f[n+(g*12|0)+4>>2]=f[b+4>>2];f[n+(g*12|0)+8>>2]=f[b+8>>2];b=l+12|0;if((j|0)==(i|0))o=l;else{g=j;j=l;while(1){l=j+-12|0;n=g;g=g+-12|0;f[l>>2]=f[g>>2];f[j+-8>>2]=f[n+-8>>2];f[j+-4>>2]=f[n+-4>>2];if((g|0)==(i|0)){o=l;break}else j=l}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function NDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[a>>2]|0;e=d;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>536870911){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}h=f[g>>2]|0;i=$Xc(b<<3)|0;j=i+(h-d>>3<<3)|0;k=j;l=i+(b<<3)|0;b=h;if((b|0)==(e|0))m=k;else{h=b+-8-d|0;i=b;b=j;while(1){n=i;i=i+-8|0;f[b+-8>>2]=f[i>>2];f[b+-4>>2]=f[n+-4>>2];if((i|0)==(e|0))break;else b=b+-8|0}m=j+(~(h>>>3)<<3)|0}f[a>>2]=m;f[g>>2]=k;f[c>>2]=l;if(!d)return;cYc(d);return}function ODa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;while(1){m=n;n=n+-8|0;f[j+-8>>2]=f[n>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function PDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,g=0.0,h=0;c=f[a+12>>2]|0;d=f[b+12>>2]|0;if((c|0)<=(d|0))if((c|0)>=(d|0)){e=+n[a+8>>2];g=+n[b+8>>2];if(!(e>g))if(!(e<g)){g=+n[a>>2];e=+n[b>>2];if(!(g<e))if(!(g>e)?+n[a+4>>2]<+n[b+4>>2]:0)h=1;else h=0;else h=1}else h=0;else h=1}else h=0;else h=1;return h|0}function QDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-16|0;i=a+-12|0;j=a+-8|0;k=a+-4|0;l=g;while(1){m=l;b:while(1){n=m;o=b-n|0;p=o>>4;switch(p|0){case 2:{q=5;break a;break}case 3:{q=7;break a;break}case 4:{q=8;break a;break}case 5:{q=12;break a;break}case 1:case 0:{q=56;break a;break}default:{}}if((o|0)<112){q=14;break a}r=m+(((p|0)/2|0)<<4)|0;if((o|0)>15984){o=(p|0)/4|0;s=WDa(m,m+(o<<4)|0,r,r+(o<<4)|0,h,c)|0}else s=VDa(m,r,h,c)|0;if(Mi[f[c>>2]&1023](m,r)|0){t=h;v=s;break}else w=h;while(1){x=w+-16|0;if((m|0)==(x|0))break;if(Mi[f[c>>2]&1023](x,r)|0){q=39;break b}else w=x}o=m+16|0;if(Mi[f[c>>2]&1023](m,h)|0)y=o;else{if((o|0)==(h|0)){q=56;break a}else z=o;while(1){if(Mi[f[c>>2]&1023](m,z)|0)break;o=z+16|0;if((o|0)==(h|0)){q=56;break a}else z=o}o=f[z>>2]|0;p=f[z+4>>2]|0;A=f[z+8>>2]|0;B=f[z+12>>2]|0;f[z>>2]=f[h>>2];f[z+4>>2]=f[h+4>>2];f[z+8>>2]=f[h+8>>2];f[z+12>>2]=f[h+12>>2];f[h>>2]=o;f[i>>2]=p;f[j>>2]=A;f[k>>2]=B;y=z+16|0}if((y|0)==(h|0)){q=56;break a}else{C=h;D=y}while(1){B=D;while(1){E=B+16|0;if(Mi[f[c>>2]&1023](m,B)|0){F=C;break}else B=E}while(1){G=F+-16|0;if(Mi[f[c>>2]&1023](m,G)|0)F=G;else break}if(B>>>0>=G>>>0){m=B;continue b}A=f[B>>2]|0;p=f[B+4>>2]|0;o=f[B+8>>2]|0;H=f[B+12>>2]|0;f[B>>2]=f[G>>2];f[B+4>>2]=f[G+4>>2];f[B+8>>2]=f[G+8>>2];f[B+12>>2]=f[G+12>>2];f[G>>2]=A;f[F+-12>>2]=p;f[F+-8>>2]=o;f[F+-4>>2]=H;C=G;D=E}}if((q|0)==39){q=0;H=f[m>>2]|0;o=f[m+4>>2]|0;p=f[m+8>>2]|0;A=f[m+12>>2]|0;f[m>>2]=f[x>>2];f[m+4>>2]=f[x+4>>2];f[m+8>>2]=f[x+8>>2];f[m+12>>2]=f[x+12>>2];f[x>>2]=H;f[w+-12>>2]=o;f[w+-8>>2]=p;f[w+-4>>2]=A;t=x;v=s+1|0}A=m+16|0;c:do if(A>>>0<t>>>0){p=r;o=t;H=A;I=v;while(1){J=H;while(1){K=J+16|0;if(Mi[f[c>>2]&1023](J,p)|0)J=K;else{L=o;break}}while(1){M=L+-16|0;if(Mi[f[c>>2]&1023](M,p)|0)break;else L=M}if(J>>>0>M>>>0){N=p;O=I;P=J;break c}B=f[J>>2]|0;Q=f[J+4>>2]|0;R=f[J+8>>2]|0;S=f[J+12>>2]|0;f[J>>2]=f[M>>2];f[J+4>>2]=f[M+4>>2];f[J+8>>2]=f[M+8>>2];f[J+12>>2]=f[M+12>>2];f[M>>2]=B;f[L+-12>>2]=Q;f[L+-8>>2]=R;f[L+-4>>2]=S;p=(p|0)==(J|0)?M:p;o=M;H=K;I=I+1|0}}else{N=r;O=v;P=A}while(0);if((P|0)!=(N|0)?Mi[f[c>>2]&1023](N,P)|0:0){A=f[P>>2]|0;I=f[P+4>>2]|0;H=f[P+8>>2]|0;o=f[P+12>>2]|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];f[N>>2]=A;f[N+4>>2]=I;f[N+8>>2]=H;f[N+12>>2]=o;T=O+1|0}else T=O;if(!T){U=XDa(m,P,c)|0;o=P+16|0;if(XDa(o,a,c)|0){q=55;break}if(U){l=o;continue}}o=P;if((o-n|0)>=(b-o|0)){q=54;break}QDa(m,P,c);l=P+16|0}if((q|0)==54){q=0;QDa(P+16|0,a,c);g=m;a=P;continue}else if((q|0)==55){q=0;if(U){q=56;break}else{g=m;a=P;continue}}}if((q|0)==5){if(!(Mi[f[c>>2]&1023](h,m)|0)){u=d;return}P=f[m>>2]|0;g=f[m+4>>2]|0;U=f[m+8>>2]|0;n=f[m+12>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[h>>2]=P;f[i>>2]=g;f[j>>2]=U;f[k>>2]=n;u=d;return}else if((q|0)==7){VDa(m,m+16|0,h,c)|0;u=d;return}else if((q|0)==8){n=m+16|0;U=m+32|0;VDa(m,n,U,c)|0;if(!(Mi[f[c>>2]&1023](h,U)|0)){u=d;return}g=f[U>>2]|0;P=m+36|0;T=f[P>>2]|0;O=m+40|0;N=f[O>>2]|0;v=m+44|0;r=f[v>>2]|0;f[U>>2]=f[h>>2];f[U+4>>2]=f[h+4>>2];f[U+8>>2]=f[h+8>>2];f[U+12>>2]=f[h+12>>2];f[h>>2]=g;f[i>>2]=T;f[j>>2]=N;f[k>>2]=r;if(!(Mi[f[c>>2]&1023](U,n)|0)){u=d;return}r=f[n>>2]|0;k=m+20|0;N=f[k>>2]|0;j=m+24|0;T=f[j>>2]|0;i=m+28|0;g=f[i>>2]|0;f[n>>2]=f[U>>2];f[n+4>>2]=f[U+4>>2];f[n+8>>2]=f[U+8>>2];f[n+12>>2]=f[U+12>>2];f[U>>2]=r;f[P>>2]=N;f[O>>2]=T;f[v>>2]=g;if(!(Mi[f[c>>2]&1023](n,m)|0)){u=d;return}g=f[m>>2]|0;v=f[m+4>>2]|0;T=f[m+8>>2]|0;O=f[m+12>>2]|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];f[m+12>>2]=f[n+12>>2];f[n>>2]=g;f[k>>2]=v;f[j>>2]=T;f[i>>2]=O;u=d;return}else if((q|0)==12){WDa(m,m+16|0,m+32|0,m+48|0,h,c)|0;u=d;return}else if((q|0)==14){h=m+32|0;VDa(m,m+16|0,h,c)|0;O=m+48|0;if((O|0)==(a|0)){u=d;return}i=e+4|0;T=e+8|0;j=e+12|0;v=O;O=h;while(1){if(Mi[f[c>>2]&1023](v,O)|0){f[e>>2]=f[v>>2];f[i>>2]=f[v+4>>2];f[T>>2]=f[v+8>>2];f[j>>2]=f[v+12>>2];h=O;k=v;while(1){f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];if((h|0)==(m|0))break;g=h+-16|0;if(Mi[f[c>>2]&1023](e,g)|0){n=h;h=g;k=n}else break}f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2]}k=v+16|0;if((k|0)==(a|0))break;else{n=v;v=k;O=n}}u=d;return}else if((q|0)==56){u=d;return}}function RDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)kWc(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=h;g=k+(d*12|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=b;b=b+-12|0;j=i;i=i+-12|0;f[b>>2]=f[i>>2];f[h+-8>>2]=f[j+-8>>2];f[h+-4>>2]=f[j+-4>>2]}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function SDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;do{m=j;j=j+-16|0;k=n;n=n+-16|0;f[j>>2]=f[n>>2];f[m+-12>>2]=f[k+-12>>2];f[m+-8>>2]=f[k+-8>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function TDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)kWc(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=af(8)|0;hYc(l,512536);f[l>>2]=192348;ig(l|0,25336,2140)}else{n=$Xc(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;do{m=j;j=j+-16|0;k=n;n=n+-16|0;f[j>>2]=f[n>>2];f[m+-12>>2]=f[k+-12>>2];f[m+-8>>2]=f[k+-8>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;cYc(e);return}function UDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)kWc(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=af(8)|0;hYc(h,512536);f[h>>2]=192348;ig(h|0,25336,2140)}else{k=$Xc(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;do{n=b;b=b+-16|0;o=j;j=j+-16|0;f[b>>2]=f[j>>2];f[n+-12>>2]=f[o+-12>>2];f[n+-8>>2]=f[o+-8>>2];f[n+-4>>2]=f[o+-4>>2]}while((j|0)!=(g|0));l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;cYc(m);return}function VDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=Mi[f[d>>2]&1023](b,a)|0;g=Mi[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;i=b+4|0;j=f[i>>2]|0;k=b+8|0;l=f[k>>2]|0;m=b+12|0;n=f[m>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=e;f[c+4>>2]=j;f[c+8>>2]=l;f[c+12>>2]=n;if(!(Mi[f[d>>2]&1023](b,a)|0)){h=1;return h|0}n=f[a>>2]|0;l=f[a+4>>2]|0;j=f[a+8>>2]|0;e=f[a+12>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=n;f[i>>2]=l;f[k>>2]=j;f[m>>2]=e;h=2;return h|0}e=f[a>>2]|0;m=f[a+4>>2]|0;j=f[a+8>>2]|0;k=f[a+12>>2]|0;if(g){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[c>>2]=e;f[c+4>>2]=m;f[c+8>>2]=j;f[c+12>>2]=k;h=1;return h|0};f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=e;e=b+4|0;f[e>>2]=m;m=b+8|0;f[m>>2]=j;j=b+12|0;f[j>>2]=k;if(!(Mi[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;k=f[e>>2]|0;e=f[m>>2]|0;m=f[j>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=d;f[c+4>>2]=k;f[c+8>>2]=e;f[c+12>>2]=m;h=2;return h|0}function WDa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=VDa(a,b,c,g)|0;if(Mi[f[g>>2]&1023](d,c)|0){i=f[c>>2]|0;j=c+4|0;k=f[j>>2]|0;l=c+8|0;m=f[l>>2]|0;n=c+12|0;o=f[n>>2]|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=i;f[d+4>>2]=k;f[d+8>>2]=m;f[d+12>>2]=o;o=h+1|0;if(Mi[f[g>>2]&1023](c,b)|0){m=f[b>>2]|0;k=b+4|0;i=f[k>>2]|0;p=b+8|0;q=f[p>>2]|0;r=b+12|0;s=f[r>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=m;f[j>>2]=i;f[l>>2]=q;f[n>>2]=s;if(Mi[f[g>>2]&1023](b,a)|0){s=f[a>>2]|0;n=f[a+4>>2]|0;q=f[a+8>>2]|0;l=f[a+12>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=s;f[k>>2]=n;f[p>>2]=q;f[r>>2]=l;t=h+3|0}else t=h+2|0}else t=o}else t=h;if(!(Mi[f[g>>2]&1023](e,d)|0)){u=t;return u|0}h=f[d>>2]|0;o=d+4|0;l=f[o>>2]|0;r=d+8|0;q=f[r>>2]|0;p=d+12|0;n=f[p>>2]|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[e>>2]=h;f[e+4>>2]=l;f[e+8>>2]=q;f[e+12>>2]=n;if(!(Mi[f[g>>2]&1023](d,c)|0)){u=t+1|0;return u|0}n=f[c>>2]|0;e=c+4|0;q=f[e>>2]|0;l=c+8|0;h=f[l>>2]|0;k=c+12|0;s=f[k>>2]|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[d>>2]=n;f[o>>2]=q;f[r>>2]=h;f[p>>2]=s;if(!(Mi[f[g>>2]&1023](c,b)|0)){u=t+2|0;return u|0}s=f[b>>2]|0;p=b+4|0;h=f[p>>2]|0;r=b+8|0;q=f[r>>2]|0;o=b+12|0;n=f[o>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[c>>2]=s;f[e>>2]=h;f[l>>2]=q;f[k>>2]=n;if(!(Mi[f[g>>2]&1023](b,a)|0)){u=t+3|0;return u|0}g=f[a>>2]|0;n=f[a+4>>2]|0;k=f[a+8>>2]|0;q=f[a+12>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[b>>2]=g;f[p>>2]=n;f[r>>2]=k;f[o>>2]=q;u=t+4|0;return u|0}function XDa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;switch(b-a>>4|0){case 2:{g=b+-16|0;if(!(Mi[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;l=f[a+12>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[g>>2]=i;f[b+-12>>2]=j;f[b+-8>>2]=k;f[b+-4>>2]=l;h=1;u=d;return h|0}case 3:{VDa(a,a+16|0,b+-16|0,c)|0;h=1;u=d;return h|0}case 4:{l=a+16|0;k=a+32|0;j=b+-16|0;VDa(a,l,k,c)|0;if(!(Mi[f[c>>2]&1023](j,k)|0)){h=1;u=d;return h|0}i=f[k>>2]|0;g=a+36|0;m=f[g>>2]|0;n=a+40|0;o=f[n>>2]|0;p=a+44|0;q=f[p>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];f[k+8>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[j>>2]=i;f[b+-12>>2]=m;f[b+-8>>2]=o;f[b+-4>>2]=q;if(!(Mi[f[c>>2]&1023](k,l)|0)){h=1;u=d;return h|0}q=f[l>>2]|0;o=a+20|0;m=f[o>>2]|0;i=a+24|0;j=f[i>>2]|0;r=a+28|0;s=f[r>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[k>>2]=q;f[g>>2]=m;f[n>>2]=j;f[p>>2]=s;if(!(Mi[f[c>>2]&1023](l,a)|0)){h=1;u=d;return h|0}s=f[a>>2]|0;p=f[a+4>>2]|0;j=f[a+8>>2]|0;n=f[a+12>>2]|0;f[a>>2]=f[l>>2];f[a+4>>2]=f[l+4>>2];f[a+8>>2]=f[l+8>>2];f[a+12>>2]=f[l+12>>2];f[l>>2]=s;f[o>>2]=p;f[i>>2]=j;f[r>>2]=n;h=1;u=d;return h|0}case 5:{WDa(a,a+16|0,a+32|0,a+48|0,b+-16|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{n=a+32|0;VDa(a,a+16|0,n,c)|0;r=a+48|0;a:do if((r|0)==(b|0)){t=1;v=0}else{j=e+4|0;i=e+8|0;p=e+12|0;o=r;s=0;l=n;while(1){if(Mi[f[c>>2]&1023](o,l)|0){f[e>>2]=f[o>>2];f[j>>2]=f[o+4>>2];f[i>>2]=f[o+8>>2];f[p>>2]=f[o+12>>2];m=l;g=o;while(1){f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];f[g+8>>2]=f[m+8>>2];f[g+12>>2]=f[m+12>>2];if((m|0)==(a|0))break;q=m+-16|0;if(Mi[f[c>>2]&1023](e,q)|0){k=m;m=q;g=k}else break}f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];g=s+1|0;if((g|0)==8){t=0;v=(o+16|0)==(b|0);break a}else w=g}else w=s;g=o+16|0;if((g|0)==(b|0)){t=1;v=0;break}else{k=o;o=g;s=w;l=k}}}while(0);h=v|t;u=d;return h|0}}return 0}function YDa(a){a=a|0;cYc(a);return}
function V$c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+11|0;h=b[g>>0]|0;i=c+4|0;a:do if(!((h<<24>>24<0?f[i>>2]|0:h&255)|0))W$c(a,c);else{j=UNc(528869)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(J_c(c,528869,j)|0)==0:0){A$c(c,528881);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=UNc(528952)|0;if(j>>>0>4294967279)jYc(a);if(j>>>0<11){b[a+11>>0]=j;l=a}else{k=j+16&-16;m=o_c(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;l=m}$Mc(l,528952,j)|0;b[e>>0]=0;VNc(l+j|0,e);break}j=UNc(528965)|0;m=b[g>>0]|0;if((j|0)==((m<<24>>24<0?f[i>>2]|0:m&255)|0)?(J_c(c,528965,j)|0)==0:0){A$c(c,528978);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=UNc(529028)|0;if(j>>>0>4294967279)jYc(a);if(j>>>0<11){b[a+11>>0]=j;n=a}else{m=j+16&-16;k=o_c(m)|0;f[a>>2]=k;f[a+8>>2]=m|-2147483648;f[a+4>>2]=j;n=k}$Mc(n,529028,j)|0;b[e>>0]=0;VNc(n+j|0,e);break}j=UNc(529042)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(J_c(c,529042,j)|0)==0:0){A$c(c,529055);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=UNc(529105)|0;if(j>>>0>4294967279)jYc(a);if(j>>>0<11){b[a+11>>0]=j;o=a}else{k=j+16&-16;m=o_c(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;o=m}$Mc(o,529105,j)|0;b[e>>0]=0;VNc(o+j|0,e);break}j=UNc(529119)|0;m=b[g>>0]|0;k=f[i>>2]|0;do if((j|0)==((m<<24>>24<0?k:m&255)|0)){if(J_c(c,529119,j)|0){p=f[i>>2]|0;q=b[g>>0]|0;break}A$c(c,529133);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=UNc(529184)|0;if(r>>>0>4294967279)jYc(a);if(r>>>0<11){b[a+11>>0]=r;s=a}else{t=r+16&-16;v=o_c(t)|0;f[a>>2]=v;f[a+8>>2]=t|-2147483648;f[a+4>>2]=r;s=v}$Mc(s,529184,r)|0;b[e>>0]=0;VNc(s+r|0,e);break a}else{p=k;q=m}while(0);m=q<<24>>24<0;k=m?f[c>>2]|0:c;j=k+(m?p:q&255)|0;b:do if((b[j+-1>>0]|0)==62){m=1;r=j;c:while(1){v=r;d:while(1){w=v+-1|0;if((w|0)==(k|0))break c;x=v+-2|0;switch(b[x>>0]|0){case 60:{y=43;break d;break}case 62:{y=44;break d;break}default:v=w}}if((y|0)==43){y=0;v=m+-1|0;if(!v){z=x;break b}else{m=v;r=w;continue}}else if((y|0)==44){y=0;m=m+1|0;r=w;continue}}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=0;while(1){if((r|0)==3)break a;f[a+(r<<2)>>2]=0;r=r+1|0}}else z=j;while(0);j=z;while(1){r=j+-1|0;if((r|0)==(k|0)){A=k;break}if((b[r>>0]|0)==58){A=j;break}else j=r}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=z-A|0;if(j>>>0>4294967279)jYc(a);if(j>>>0<11){b[a+11>>0]=j;B=a}else{k=j+16&-16;r=o_c(k)|0;f[a>>2]=r;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;B=r}r=A;k=B;while(1){if((r|0)==(z|0))break;VNc(k,r);r=r+1|0;k=k+1|0}b[e>>0]=0;VNc(B+j|0,e)}while(0);u=d;return}function W$c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)jYc(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=o_c(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}$Mc(i,g,h)|0;b[e>>0]=0;VNc(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function X$c(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((a|0)!=(b|0)){d=D$c(a,b,c)|0;if((d|0)==(a|0))e=F$c(a,b,c)|0;else e=d;if((e|0)!=(a|0)?(d=f[c+4>>2]|0,(f[c>>2]|0)!=(d|0)):0){y_c(d+-24|0,0,528119)|0;g=e}else g=a}else g=a;return g|0}function Y$c(a){a=a|0;var b=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}b=a+12|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function Z$c(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+32|0;c=b;d=a+4|0;e=(((f[d>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;g=_$c(a)|0;if(g>>>0<e>>>0)kWc(a);else{h=f[a>>2]|0;i=((f[a+8>>2]|0)-h|0)/24|0;j=i<<1;$$c(c,i>>>0<g>>>1>>>0?(j>>>0<e>>>0?e:j):g,((f[d>>2]|0)-h|0)/24|0,a+12|0);h=c+8|0;d=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;Y$c(d);f[h>>2]=d+24;a0c(a,c);b0c(c);u=b;return}}function _$c(a){a=a|0;return 178956970}function $$c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=c0c(d,b)|0;f[a>>2]=e;d=e+(c*24|0)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b*24|0);return}function a0c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=g+-24|0;S_c((f[e>>2]|0)+-24|0,h);f[e>>2]=(f[e>>2]|0)+-24;g=h}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function b0c(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;a_c(e)}c=f[a>>2]|0;if(c|0)q_c(f[a+16>>2]|0,c,((f[a+12>>2]|0)-c|0)/24|0);return}function c0c(a,b){a=a|0;b=b|0;return d0c(f[a>>2]|0,b*24|0)|0}function d0c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=l_c(b)|0;b=a+4096|0;d=f[b>>2]|0;if((a+4096-d|0)>>>0<c>>>0)e=jIc(c)|0;else{f[b>>2]=d+c;e=d}return e|0}function e0c(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+12|0;k=Y_c(a,c)|0;if(!((k|0)==(a|0)|(k|0)==(c|0))?(b[k>>0]|0)==69:0){c=d+11|0;l=b[c>>0]|0;m=d+4|0;do if((l<<24>>24<0?f[m>>2]|0:l&255)>>>0<=3){n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;Y$c(o);f[n>>2]=(f[n>>2]|0)+24;break}else{Z$c(e);break}}else{$_c(j,528049,d);z_c(j,528047)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}Q_c(h,i);n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){S_c(o,h);f[n>>2]=(f[n>>2]|0)+24}else T_c(e,h);a_c(h);r_c(i);r_c(j)}while(0);j=e+4|0;if((b[a>>0]|0)==110){S$c((f[j>>2]|0)+-24|0,45);p=a+1|0}else p=a;R$c((f[j>>2]|0)+-24|0,p,k);p=b[c>>0]|0;c=p<<24>>24<0;e=c?f[m>>2]|0:p&255;if(e>>>0<4)d_c((f[j>>2]|0)+-24|0,c?f[d>>2]|0:d,e)|0;q=k+1|0}else q=a;u=g;return q|0}function f0c(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=4;$Mc(a,c,4)|0;b[e>>0]=0;VNc(a+4|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function g0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e;h=e+44|0;i=e+48|0;j=e+8|0;k=e+32|0;a:do if((c-a|0)>>>0>8){l=0;m=h;while(1){o=b[a+l>>0]|0;q=o<<24>>24;r=a+(l|1)|0;if((l|0)==8){s=6;break}if(!(VJc(q)|0))break;t=b[r>>0]|0;b[m>>0]=t+(((q+-48|0)>>>0<10?0:9)+q<<4)+((t+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((s|0)==6){if(o<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;t=h;while(1){q=l+-1|0;if(t>>>0>=q>>>0)break b;v=b[t>>0]|0;b[t>>0]=b[q>>0]|0;b[q>>0]=v;l=q;t=t+1|0}}while(0);t=i;l=t+24|0;do{b[t>>0]=0;t=t+1|0}while((t|0)<(l|0));p[g>>3]=+n[h>>2];t=oJc(i,24,529361,g)|0;if(t>>>0>23)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(t>>>0<11){b[k+11>>0]=t;w=k}else{l=t+16&-16;q=o_c(l)|0;f[k>>2]=q;f[k+8>>2]=l|-2147483648;f[k+4>>2]=t;w=q}$Mc(w,i,t)|0;b[g>>0]=0;VNc(w+t|0,g);Q_c(j,k);t=d+4|0;q=f[t>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){S_c(q,j);f[t>>2]=(f[t>>2]|0)+24}else T_c(d,j);a_c(j);r_c(k);x=r}else x=a;y=x;break a}while(0);y=a}else y=a;while(0);u=e;return y|0}function h0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>16){l=0;m=h;while(1){n=b[a+l>>0]|0;o=n<<24>>24;q=a+(l|1)|0;if((l|0)==16){r=6;break}if(!(VJc(o)|0))break;s=b[q>>0]|0;b[m>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;s=h;while(1){o=l+-1|0;if(s>>>0>=o>>>0)break b;t=b[s>>0]|0;b[s>>0]=b[o>>0]|0;b[o>>0]=t;l=o;s=s+1|0}}while(0);s=i;l=s+32|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(l|0));p[g>>3]=+p[h>>3];s=oJc(i,32,529358,g)|0;if(s>>>0>31)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{l=s+16&-16;o=o_c(l)|0;f[k>>2]=o;f[k+8>>2]=l|-2147483648;f[k+4>>2]=s;v=o}$Mc(v,i,s)|0;b[g>>0]=0;VNc(v+s|0,g);Q_c(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){S_c(o,j);f[s>>2]=(f[s>>2]|0)+24}else T_c(d,j);a_c(j);r_c(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function i0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>20){l=0;m=h;while(1){n=b[a+l>>0]|0;o=n<<24>>24;q=a+(l|1)|0;if((l|0)==20){r=6;break}if(!(VJc(o)|0))break;s=b[q>>0]|0;b[m>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;s=h;while(1){o=l+-1|0;if(s>>>0>=o>>>0)break b;t=b[s>>0]|0;b[s>>0]=b[o>>0]|0;b[o>>0]=t;l=o;s=s+1|0}}while(0);s=i;l=s+40|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(l|0));p[g>>3]=+p[h>>3];s=oJc(i,40,529353,g)|0;if(s>>>0>39)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{l=s+16&-16;o=o_c(l)|0;f[k>>2]=o;f[k+8>>2]=l|-2147483648;f[k+4>>2]=s;v=o}$Mc(v,i,s)|0;b[g>>0]=0;VNc(v+s|0,g);Q_c(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){S_c(o,j);f[s>>2]=(f[s>>2]|0)+24}else T_c(d,j);a_c(j);r_c(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function j0c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=o_c(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=13;$Mc(g,c,13)|0;b[e>>0]=0;VNc(g+13|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function k0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+8|0;j=e;a:do if((a|0)!=(c|0)?(b[a>>0]|0)==78:0){k=w_c(a+1|0,c,g)|0;b:do if((k|0)!=(c|0)){l=d+52|0;f[l>>2]=0;m=k+1|0;switch(b[k>>0]|0){case 82:{n=1;o=6;break}case 79:{n=2;o=6;break}default:p=k}if((o|0)==6){f[l>>2]=n;p=m}m=d+4|0;l=f[m>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;Y$c(l);f[m>>2]=(f[m>>2]|0)+24}else Z$c(d);if(((c-p|0)>1?(b[p>>0]|0)==83:0)?(b[p+1>>0]|0)==116:0){A$c((f[m>>2]|0)+-24|0,529425);q=p+2|0}else q=p;if((q|0)==(c|0)){l=f[m>>2]|0;r=l+-24|0;s=l;while(1){if((s|0)==(r|0))break b;l=s+-24|0;f[m>>2]=l;a_c(l);s=f[m>>2]|0}}s=d+16|0;r=h+11|0;l=h+4|0;t=d+12|0;v=d+20|0;w=d+24|0;x=i+12|0;y=i+4|0;z=i+8|0;A=i+12|0;B=i+4|0;C=i+8|0;D=i+11|0;E=i+4|0;F=i+11|0;G=i+4|0;H=i+12|0;I=i+4|0;J=i+8|0;K=i+12|0;L=i+4|0;M=i+8|0;N=i+11|0;O=i+4|0;P=i+12|0;Q=i+4|0;R=i+8|0;S=i+11|0;T=i+4|0;U=0;V=q;c:while(1){W=V;d:while(1){X=b[W>>0]|0;Y=W+1|0;if(X<<24>>24==69)break c;switch(X<<24>>24|0){case 83:{o=21;break d;break}case 84:{o=37;break d;break}case 68:{o=51;break d;break}case 73:break;case 76:{if((Y|0)==(c|0))break b;else{W=Y;continue d}break}default:break d}X=M_c(W,c,d)|0;if((X|0)==(W|0)|(X|0)==(c|0))break b;N_c(h,(f[m>>2]|0)+-24|0);Z=f[m>>2]|0;_=Z+-24|0;$=Z;while(1){if(($|0)==(_|0))break;aa=$+-24|0;f[m>>2]=aa;a_c(aa);$=f[m>>2]|0}$=b[r>>0]|0;_=$<<24>>24<0;d_c(Z+-48|0,_?f[h>>2]|0:h,_?f[l>>2]|0:$&255)|0;$=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];E_c(i,$,j);$=f[v>>2]|0;if($>>>0<(f[w>>2]|0)>>>0){f[$>>2]=0;_=$+4|0;f[_>>2]=0;aa=f[x>>2]|0;f[$+8>>2]=0;f[$+12>>2]=aa;f[$>>2]=f[i>>2];f[_>>2]=f[y>>2];f[$+8>>2]=f[z>>2];f[z>>2]=0;f[y>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(s,i);b_c(i);r_c(h);W=X}e:do if((o|0)==21){o=0;if((Y|0)!=(c|0)?(b[Y>>0]|0)==116:0)break;$=V_c(W,c,d)|0;if(($|0)==(W|0)|($|0)==(c|0))break b;N_c(h,(f[m>>2]|0)+-24|0);_=f[m>>2]|0;aa=_+-24|0;ba=_;while(1){if((ba|0)==(aa|0))break;ca=ba+-24|0;f[m>>2]=ca;a_c(ca);ba=f[m>>2]|0}ba=_+-48|0;aa=b[ba+11>>0]|0;if(aa<<24>>24<0)da=f[_+-44>>2]|0;else da=aa&255;if(!da)o0c(ba,h);else{$_c(i,528121,h);ba=b[F>>0]|0;aa=ba<<24>>24<0;d_c((f[m>>2]|0)+-24|0,aa?f[i>>2]|0:i,aa?f[G>>2]|0:ba&255)|0;r_c(i);ba=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];E_c(i,ba,j);ba=f[v>>2]|0;if(ba>>>0<(f[w>>2]|0)>>>0){f[ba>>2]=0;aa=ba+4|0;f[aa>>2]=0;X=f[H>>2]|0;f[ba+8>>2]=0;f[ba+12>>2]=X;f[ba>>2]=f[i>>2];f[aa>>2]=f[I>>2];f[ba+8>>2]=f[J>>2];f[J>>2]=0;f[I>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(s,i);b_c(i)}r_c(h);U=1;V=$;continue c}else if((o|0)==37){o=0;ba=L_c(W,c,d)|0;if((ba|0)==(W|0)|(ba|0)==(c|0))break b;N_c(h,(f[m>>2]|0)+-24|0);aa=f[m>>2]|0;X=aa+-24|0;Z=aa;while(1){if((Z|0)==(X|0))break;ca=Z+-24|0;f[m>>2]=ca;a_c(ca);Z=f[m>>2]|0}Z=aa+-48|0;X=b[Z+11>>0]|0;if(X<<24>>24<0)ea=f[aa+-44>>2]|0;else ea=X&255;if(!ea)o0c(Z,h);else{$_c(i,528121,h);Z=b[N>>0]|0;X=Z<<24>>24<0;d_c((f[m>>2]|0)+-24|0,X?f[i>>2]|0:i,X?f[O>>2]|0:Z&255)|0;r_c(i)}Z=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];E_c(i,Z,j);Z=f[v>>2]|0;if(Z>>>0<(f[w>>2]|0)>>>0){f[Z>>2]=0;X=Z+4|0;f[X>>2]=0;$=f[K>>2]|0;f[Z+8>>2]=0;f[Z+12>>2]=$;f[Z>>2]=f[i>>2];f[X>>2]=f[L>>2];f[Z+8>>2]=f[M>>2];f[M>>2]=0;f[L>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(s,i);b_c(i);r_c(h);U=1;V=ba;continue c}else if((o|0)==51){o=0;if((Y|0)!=(c|0))switch(b[Y>>0]|0){case 84:case 116:break;default:break e}Z=W_c(W,c,d)|0;if((Z|0)==(W|0)|(Z|0)==(c|0))break b;N_c(h,(f[m>>2]|0)+-24|0);X=f[m>>2]|0;$=X+-24|0;_=X;while(1){if((_|0)==($|0))break;ca=_+-24|0;f[m>>2]=ca;a_c(ca);_=f[m>>2]|0}_=X+-48|0;$=b[_+11>>0]|0;if($<<24>>24<0)fa=f[X+-44>>2]|0;else fa=$&255;if(!fa)o0c(_,h);else{$_c(i,528121,h);_=b[S>>0]|0;$=_<<24>>24<0;d_c((f[m>>2]|0)+-24|0,$?f[i>>2]|0:i,$?f[T>>2]|0:_&255)|0;r_c(i)}_=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];E_c(i,_,j);_=f[v>>2]|0;if(_>>>0<(f[w>>2]|0)>>>0){f[_>>2]=0;$=_+4|0;f[$>>2]=0;ba=f[P>>2]|0;f[_+8>>2]=0;f[_+12>>2]=ba;f[_>>2]=f[i>>2];f[$>>2]=f[Q>>2];f[_+8>>2]=f[R>>2];f[R>>2]=0;f[Q>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(s,i);b_c(i);r_c(h);U=1;V=Z;continue c}while(0);_=G$c(W,c,d)|0;if((_|0)==(W|0)|(_|0)==(c|0))break b;N_c(h,(f[m>>2]|0)+-24|0);$=f[m>>2]|0;ba=$+-24|0;aa=$;while(1){if((aa|0)==(ba|0))break;ca=aa+-24|0;f[m>>2]=ca;a_c(ca);aa=f[m>>2]|0}aa=$+-48|0;ba=b[aa+11>>0]|0;if(ba<<24>>24<0)ga=f[$+-44>>2]|0;else ga=ba&255;if(!ga)o0c(aa,h);else{$_c(i,528121,h);aa=b[D>>0]|0;ba=aa<<24>>24<0;d_c((f[m>>2]|0)+-24|0,ba?f[i>>2]|0:i,ba?f[E>>2]|0:aa&255)|0;r_c(i)}aa=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];E_c(i,aa,j);aa=f[v>>2]|0;if(aa>>>0<(f[w>>2]|0)>>>0){f[aa>>2]=0;ba=aa+4|0;f[ba>>2]=0;W=f[A>>2]|0;f[aa+8>>2]=0;f[aa+12>>2]=W;f[aa>>2]=f[i>>2];f[ba>>2]=f[B>>2];f[aa+8>>2]=f[C>>2];f[C>>2]=0;f[B>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else F_c(s,i);b_c(i);r_c(h);U=1;V=_}f[d+48>>2]=f[g>>2];f:do if(U?(V=f[v>>2]|0,(f[s>>2]|0)!=(V|0)):0){B=V+-16|0;C=V;while(1){if((C|0)==(B|0))break f;V=C+-16|0;f[v>>2]=V;b_c(V);C=f[v>>2]|0}}while(0);ha=Y;break a}while(0);ha=a}else ha=a;while(0);u=e;return ha|0}function l0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;a:do if(((((a|0)!=(c|0)?(b[a>>0]|0)==90:0)?(h=a+1|0,i=s_c(h,c,d)|0,!((i|0)==(h|0)|(i|0)==(c|0))):0)?(b[i>>0]|0)==69:0)?(h=i+1|0,(h|0)!=(c|0)):0){j=i+2|0;switch(b[h>>0]|0){case 115:{i=n0c(j,c)|0;k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=i;break a}z_c(k+-24|0,529408)|0;l=i;break a;break}case 100:{if((j|0)==(c|0)){l=a;break a}i=Y_c(j,c)|0;if((i|0)==(c|0)){l=a;break a}if((b[i>>0]|0)!=95){l=a;break a}j=i+1|0;i=U_c(j,c,d)|0;k=d+4|0;if((i|0)==(j|0)){j=f[k>>2]|0;m=j+-24|0;n=j;while(1){if((n|0)==(m|0)){l=a;break a}j=n+-24|0;f[k>>2]=j;a_c(j);n=f[k>>2]|0}}n=f[k>>2]|0;if(((n-(f[d>>2]|0)|0)/24|0)>>>0<2){l=a;break a}N_c(g,n+-24|0);n=f[k>>2]|0;m=n+-24|0;j=n;while(1){if((j|0)==(m|0))break;o=j+-24|0;f[k>>2]=o;a_c(o);j=f[k>>2]|0}z_c(n+-48|0,528121)|0;j=b[g+11>>0]|0;m=j<<24>>24<0;d_c((f[k>>2]|0)+-24|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:j&255)|0;r_c(g);l=i;break a;break}default:{j=U_c(h,c,d)|0;if((j|0)==(h|0)){m=d+4|0;o=f[m>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0)){l=a;break a}o=q+-24|0;f[m>>2]=o;a_c(o);q=f[m>>2]|0}}m=n0c(j,c)|0;q=d+4|0;p=f[q>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){l=m;break a}N_c(g,p+-24|0);p=f[q>>2]|0;h=p+-24|0;i=p;while(1){if((i|0)==(h|0))break;k=i+-24|0;f[q>>2]=k;a_c(k);i=f[q>>2]|0}z_c(p+-48|0,528121)|0;i=b[g+11>>0]|0;h=i<<24>>24<0;d_c((f[q>>2]|0)+-24|0,h?f[g>>2]|0:g,h?f[g+4>>2]|0:i&255)|0;r_c(g);l=m;break a}}}else l=a;while(0);u=e;return l|0}function m0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;if((c-a|0)>1){if((b[a>>0]|0)==83?(b[a+1>>0]|0)==116:0){e=a+2|0;if((e|0)==(c|0)){g=0;h=c}else{g=0;h=(b[e>>0]|0)==76?a+3|0:e}}else{g=1;h=a}e=G$c(h,c,d)|0;c=(e|0)==(h|0);if(!(g|c)){g=f[d+4>>2]|0;if((f[d>>2]|0)==(g|0))i=a;else{y_c(g+-24|0,0,528343)|0;i=e}}else i=c?a:e}else i=a;return i|0}function n0c(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:do if((a|0)!=(c|0)){d=b[a>>0]|0;e=a+1|0;if(d<<24>>24!=95){if(((d<<24>>24)+-48|0)>>>0<10)f=e;else{g=a;break}while(1){if((f|0)==(c|0)){g=c;break a}if(((b[f>>0]|0)+-48|0)>>>0>=10){g=f;break a}f=f+1|0}}if((e|0)!=(c|0)){d=b[e>>0]|0;h=a+2|0;if(((d<<24>>24)+-48|0)>>>0>=10)if(d<<24>>24==95){d=h;do{i=d;d=d+1|0;if((i|0)==(c|0)){g=a;break a}j=b[i>>0]|0}while(((j<<24>>24)+-48|0)>>>0<10);return (j<<24>>24==95?d:a)|0}else g=a;else g=h}else g=a}else g=a;while(0);return g|0}function o0c(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;B$c(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)}return}function p0c(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=o_c(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=21;$Mc(e,529440,21)|0;b[d>>0]=0;VNc(e+21|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function q0c(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function r0c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=t0c(a)|0;if(i>>>0<h>>>0)kWc(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;u0c(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;q0c(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;v0c(a,e);w0c(e);u=c;return}}function s0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;a:do if((a|0)==(c|0))e=a;else{f=a+1|0;switch(b[a>>0]|0){case 88:{g=Z_c(f,c,d)|0;if((g|0)==(f|0)|(g|0)==(c|0)){e=a;break a}e=(b[g>>0]|0)==69?g+1|0:a;break a;break}case 74:{if((f|0)==(c|0)){e=a;break a}else h=f;while(1){if((b[h>>0]|0)==69)break;g=s0c(h,c,d)|0;if((g|0)==(h|0)){e=a;break a}else h=g}e=h+1|0;break a;break}case 76:{if((f|0)!=(c|0)?(b[f>>0]|0)==90:0){g=a+2|0;i=s_c(g,c,d)|0;if((i|0)==(g|0)|(i|0)==(c|0)){e=a;break a}e=(b[i>>0]|0)==69?i+1|0:a;break a}e=a$c(a,c,d)|0;break a;break}default:{e=v_c(a,c,d)|0;break a}}}while(0);return e|0}function t0c(a){a=a|0;return 268435455}function u0c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=x0c(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function v0c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function w0c(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;h_c(e)}c=f[a>>2]|0;if(c|0)m_c(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function x0c(a,b){a=a|0;b=b|0;return d0c(f[a>>2]|0,b<<4)|0}function y0c(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=2;$Mc(a,529465,2)|0;b[d>>0]=0;VNc(a+2|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function z0c(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+11|0;h=b[g>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=j>>>0<11?j:11;l=j;m=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=j>>>0<11?j:11;l=j;m=10}if((k-l+m|0)>>>0<c>>>0)n_c(a,m,l+c-k-m|0,l,0,k,c,529468);else{if(i)n=f[a>>2]|0;else n=a;do if((k|0)!=(c|0)){i=l-k|0;if(!i){o=k;p=0;q=529468;r=c;s=17}else{if(k>>>0>c>>>0){qYc(n,529468,c)|0;qYc(n+c|0,n+k|0,i)|0;t=k;v=c;break}do if(n>>>0<529468>>>0&(n+l|0)>>>0>529468>>>0)if((n+k|0)>>>0>529468>>>0){qYc(n,529468,k)|0;w=0;x=k;y=529468+c|0;z=c-k|0;break}else{w=k;x=0;y=529468+(c-k)|0;z=c;break}else{w=k;x=0;y=529468;z=c}while(0);m=n+x|0;qYc(m+z|0,m+w|0,i)|0;o=w;p=x;q=y;r=z;s=17}}else{o=c;p=0;q=529468;r=c;s=17}while(0);if((s|0)==17){qYc(n+p|0,q,r)|0;t=o;v=r}r=v-t+l|0;if((b[g>>0]|0)<0)f[a+4>>2]=r;else b[g>>0]=r;b[e>>0]=0;VNc(n+r|0,e)}u=d;return}function A0c(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=f[a+4>>2]|0;else l=j&255;if(l>>>0<c>>>0)kYc(a);if(k)m=(f[a+8>>2]&2147483647)+-1|0;else m=10;j=l+e|0;if((m-l|0)>>>0>=e>>>0){if(e|0){if(k)n=f[a>>2]|0;else n=a;k=l-c|0;o=n+c|0;if(!k)p=d;else{qYc(o+e|0,o,k)|0;p=o>>>0<=d>>>0&(n+l|0)>>>0>d>>>0?d+e|0:d}qYc(o,p,e)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;b[h>>0]=0;VNc(n+j|0,h)}}else n_c(a,m,j-m|0,l,c,0,e,d);u=g;return a|0}function B0c(a){a=a|0;return 268435455}function C0c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=F0c(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function D0c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function E0c(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;b_c(e)}c=f[a>>2]|0;if(c|0)i_c(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function F0c(a,b){a=a|0;b=b|0;return d0c(f[a>>2]|0,b<<4)|0}function G0c(a){a=a|0;var b=0;if(!(_$c(a)|0))kWc(a);else{b=c0c(a+12|0,1)|0;f[a+4>>2]=b;f[a>>2]=b;f[a+8>>2]=b+24;return}}function H0c(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=a+11|0;g=b[e>>0]|0;if(g<<24>>24<0){h=f[a>>2]|0;i=f[a+4>>2]|0}else{h=a;i=g&255}j=(i|0)!=0&1;k=i-j|0;if(!k)l=g;else{qYc(h,h+j|0,k)|0;l=b[e>>0]|0}if(l<<24>>24<0)f[a+4>>2]=k;else b[e>>0]=k;b[d>>0]=0;VNc(h+k|0,d);u=c;return}function I0c(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=7;$Mc(a,529241,7)|0;b[d>>0]=0;VNc(a+7|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function J0c(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=3;$Mc(a,c,3)|0;b[e>>0]=0;VNc(a+3|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function K0c(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=o_c(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=18;$Mc(e,529661,18)|0;b[d>>0]=0;VNc(e+18|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function L0c(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=8;$Mc(a,c,8)|0;b[e>>0]=0;VNc(a+8|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function M0c(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=6;$Mc(a,529654,6)|0;b[d>>0]=0;VNc(a+6|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function N0c(a,b){a=a|0;b=b|0;f[a>>2]=b;f[a+4>>2]=f[b>>2];return}function O0c(a,c){a=a|0;c=c|0;f[a>>2]=c;b[a+4>>0]=b[c>>0]|0;return}function P0c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+64|0;g=e+60|0;h=e+48|0;i=e+36|0;j=e+24|0;k=e+12|0;l=e;a:do if((c-a|0)>2){m=a+2|0;n=a+1|0;switch(b[a>>0]|0){case 84:break;case 71:{switch(b[n>>0]|0){case 86:{o=U_c(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}y_c(r+-24|0,0,529879)|0;p=o;q=60;break a;break}case 82:{o=U_c(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}y_c(r+-24|0,0,529899)|0;p=o;q=60;break a;break}default:{p=a;q=60;break a}}break}default:{p=a;q=60;break a}}switch(b[n>>0]|0){case 86:{o=v_c(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}y_c(r+-24|0,0,529728)|0;p=o;q=60;break a;break}case 84:{o=v_c(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}y_c(r+-24|0,0,529740)|0;p=o;q=60;break a;break}case 73:{o=v_c(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}y_c(r+-24|0,0,529749)|0;p=o;q=60;break a;break}case 83:{o=v_c(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}y_c(r+-24|0,0,529763)|0;p=o;q=60;break a;break}case 99:{o=S0c(m,c)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=S0c(o,c)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=s_c(r,c,d)|0;if((o|0)==(r|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}y_c(r+-24|0,0,529782)|0;p=o;q=60;break a;break}case 67:{o=v_c(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=Y_c(o,c)|0;if((r|0)==(o|0)|(r|0)==(c|0)){p=a;q=60;break a}if((b[r>>0]|0)!=95){p=a;q=60;break a}o=r+1|0;r=v_c(o,c,d)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=d+4|0;t=f[o>>2]|0;if(((t-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}N_c(h,t+-24|0);t=f[o>>2]|0;v=t+-24|0;w=t;while(1){if((w|0)==(v|0))break;t=w+-24|0;f[o>>2]=t;a_c(t);w=f[o>>2]|0}y_c(h,0,529809)|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];w=0;while(1){if((w|0)==3)break;f[h+(w<<2)>>2]=0;w=w+1|0}z_c(k,529834)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}N_c(l,(f[o>>2]|0)+-24|0);w=b[l+11>>0]|0;v=w<<24>>24<0;d_c(j,v?f[l>>2]|0:l,v?f[l+4>>2]|0:w&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}w=f[o>>2]|0;v=w+-24|0;t=v+11|0;if((b[t>>0]|0)<0){x=f[v>>2]|0;b[g>>0]=0;VNc(x,g);f[w+-20>>2]=0}else{b[g>>0]=0;VNc(v,g);b[t>>0]=0}__c(v);f[v>>2]=f[i>>2];f[v+4>>2]=f[i+4>>2];f[v+8>>2]=f[i+8>>2];v=0;while(1){if((v|0)==3)break;f[i+(v<<2)>>2]=0;v=v+1|0}r_c(i);r_c(l);r_c(j);r_c(k);r_c(h);p=r;q=60;break a;break}default:{v=S0c(n,c)|0;do if((v|0)!=(n|0)){o=s_c(v,c,d)|0;if((o|0)!=(v|0)){t=f[d+4>>2]|0;if((f[d>>2]|0)!=(t|0)){w=t+-24|0;if((b[m>>0]|0)==118){y_c(w,0,529839)|0;y=0;z=o;break}else{y_c(w,0,529857)|0;y=0;z=o;break}}else{y=1;z=a}}else{y=0;z=a}}else{y=3;z=a}while(0);switch(y&3){case 3:case 0:{p=z;q=60;break a;break}default:{}}if(!y){p=z;q=60;break a}else{s=a;break a}}}}else{p=a;q=60}while(0);if((q|0)==60)s=p;u=e;return s|0}function Q0c(a){a=a|0;b[f[a>>2]>>0]=b[a+4>>0]|0;return}function R0c(a){a=a|0;f[f[a>>2]>>2]=f[a+4>>2];return}function S0c(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;a:do if((a|0)!=(c|0)){d=a+1|0;switch(b[a>>0]|0){case 104:{e=Y_c(d,c)|0;if((e|0)==(d|0)|(e|0)==(c|0)){f=a;break a}return ((b[e>>0]|0)==95?e+1|0:a)|0}case 118:break;default:{f=a;break a}}e=Y_c(d,c)|0;if((!((e|0)==(d|0)|(e|0)==(c|0))?(b[e>>0]|0)==95:0)?(d=e+1|0,e=Y_c(d,c)|0,!((e|0)==(d|0)|(e|0)==(c|0))):0)f=(b[e>>0]|0)==95?e+1|0:a;else f=a}else f=a;while(0);return f|0}function T0c(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function U0c(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function V0c(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function W0c(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function X0c(a){a=a|0;var c=0;if((b[a>>0]|0)==1)c=0;else{b[a>>0]=1;c=1}return c|0}function Y0c(a){a=a|0;return}function Z0c(a){a=a|0;return}function _0c(){var a=0;a=f[224503]|0;f[224503]=a+0;return a|0}function $0c(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=hj[f[(f[a>>2]|0)+16>>2]&511](a,b,e)|0;if(g)f[c>>2]=f[e>>2];u=d;return g&1|0}function a1c(a){a=a|0;var b=0;if(!a)b=0;else b=(kZc(a,25280,25400,0)|0)!=0;return b&1|0}function b1c(){}function c1c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return (J=e,a-c>>>0|0)|0}function d1c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return (J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function e1c(a){a=a|0;return 0}function f1c(a){a=a|0;return 0}function g1c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=a+d|0;c=c&255;if((d|0)>=67){while(a&3){b[a>>0]=c;a=a+1|0}g=e&-4|0;h=g-64|0;i=c|c<<8|c<<16|c<<24;while((a|0)<=(h|0)){f[a>>2]=i;f[a+4>>2]=i;f[a+8>>2]=i;f[a+12>>2]=i;f[a+16>>2]=i;f[a+20>>2]=i;f[a+24>>2]=i;f[a+28>>2]=i;f[a+32>>2]=i;f[a+36>>2]=i;f[a+40>>2]=i;f[a+44>>2]=i;f[a+48>>2]=i;f[a+52>>2]=i;f[a+56>>2]=i;f[a+60>>2]=i;a=a+64|0}while((a|0)<(g|0)){f[a>>2]=i;a=a+4|0}}while((a|0)<(e|0)){b[a>>0]=c;a=a+1|0}return e-d|0}function h1c(a){a=a|0;var c=0;c=b[w+(a&255)>>0]|0;if((c|0)<8)return c|0;c=b[w+(a>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=b[w+(a>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (b[w+(a>>>24)>>0]|0)+24|0}function i1c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=a;h=b;i=h;j=c;k=d;l=k;if(!i){m=(e|0)!=0;if(!l){if(m){f[e>>2]=(g>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return (J=n,o)|0}else{if(!m){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=b&0;n=0;o=0;return (J=n,o)|0}}m=(l|0)==0;do if(j){if(!m){p=($(l|0)|0)-($(i|0)|0)|0;if(p>>>0<=31){q=p+1|0;r=31-p|0;s=p-31>>31;t=q;u=g>>>(q>>>0)&s|i<<r;v=i>>>(q>>>0)&s;w=0;x=g<<r;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}r=j-1|0;if(r&j|0){s=($(j|0)|0)+33-($(i|0)|0)|0;q=64-s|0;p=32-s|0;y=p>>31;z=s-32|0;A=z>>31;t=s;u=p-1>>31&i>>>(z>>>0)|(i<<p|g>>>(s>>>0))&A;v=A&i>>>(s>>>0);w=g<<q&y;x=(i<<q|g>>>(z>>>0))&y|g<<p&s-33>>31;break}if(e|0){f[e>>2]=r&g;f[e+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return (J=n,o)|0}else{r=h1c(j|0)|0;n=i>>>(r>>>0)|0;o=i<<32-r|g>>>(r>>>0)|0;return (J=n,o)|0}}else{if(m){if(e|0){f[e>>2]=(i>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return (J=n,o)|0}if(!g){if(e|0){f[e>>2]=0;f[e+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return (J=n,o)|0}r=l-1|0;if(!(r&l)){if(e|0){f[e>>2]=a|0;f[e+4>>2]=r&i|b&0}n=0;o=i>>>((h1c(l|0)|0)>>>0);return (J=n,o)|0}r=($(l|0)|0)-($(i|0)|0)|0;if(r>>>0<=30){s=r+1|0;p=31-r|0;t=s;u=i<<p|g>>>(s>>>0);v=i>>>(s>>>0);w=0;x=g<<p;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}while(0);if(!t){B=x;C=w;D=v;E=u;F=0;G=0}else{b=c|0|0;c=k|d&0;d=d1c(b|0,c|0,-1,-1)|0;k=J;h=x;x=w;w=v;v=u;u=t;t=0;do{a=h;h=x>>>31|h<<1;x=t|x<<1;g=v<<1|a>>>31|0;a=v>>>31|w<<1|0;c1c(d|0,k|0,g|0,a|0)|0;i=J;l=i>>31|((i|0)<0?-1:0)<<1;t=l&1;v=c1c(g|0,a|0,l&b|0,(((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1)&c|0)|0;w=J;u=u-1|0}while((u|0)!=0);B=h;C=x;D=w;E=v;F=0;G=t}t=C;C=0;if(e|0){f[e>>2]=E;f[e+4>>2]=D}n=(t|0)>>>31|(B|C)<<1|(C<<1|t>>>31)&0|F;o=(t<<1|0>>>31)&-2|G;return (J=n,o)|0}function j1c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e|0;h=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;j=d>>31|((d|0)<0?-1:0)<<1;k=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;l=c1c(h^a|0,i^b|0,h|0,i|0)|0;b=J;i1c(l,b,c1c(j^c|0,k^d|0,j|0,k|0)|0,J,g)|0;k=c1c(f[g>>2]^h|0,f[g+4>>2]^i|0,h|0,i|0)|0;i=J;u=e;return (J=i,k)|0}function k1c(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function l1c(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function m1c(a){a=a|0;return 0}function n1c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return i1c(a,b,c,d,0)|0}function o1c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if((d|0)>=8192)return Sd(a|0,c|0,d|0)|0;e=a|0;g=a+d|0;if((a&3)==(c&3)){while(a&3){if(!d)return e|0;b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0;d=d-1|0}h=g&-4|0;d=h-64|0;while((a|0)<=(d|0)){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[a+36>>2]=f[c+36>>2];f[a+40>>2]=f[c+40>>2];f[a+44>>2]=f[c+44>>2];f[a+48>>2]=f[c+48>>2];f[a+52>>2]=f[c+52>>2];f[a+56>>2]=f[c+56>>2];f[a+60>>2]=f[c+60>>2];a=a+64|0;c=c+64|0}while((a|0)<(h|0)){f[a>>2]=f[c>>2];a=a+4|0;c=c+4|0}}else{h=g-4|0;while((a|0)<(h|0)){b[a>>0]=b[c>>0]|0;b[a+1>>0]=b[c+1>>0]|0;b[a+2>>0]=b[c+2>>0]|0;b[a+3>>0]=b[c+3>>0]|0;a=a+4|0;c=c+4|0}}while((a|0)<(g|0)){b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}return e|0}function p1c(a){a=a|0;var b=0,c=0;a=a+15&-16|0;b=f[r>>2]|0;c=b+a|0;if((a|0)>0&(c|0)<(b|0)|(c|0)<0){ea()|0;qe(12);return -1}f[r>>2]=c;if((c|0)>(da()|0)?(ca()|0)==0:0){f[r>>2]=b;qe(12);return -1}return b|0}function q1c(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if((c|0)<(a|0)&(a|0)<(c+d|0)){e=a;c=c+d|0;a=a+d|0;while((d|0)>0){a=a-1|0;c=c-1|0;d=d-1|0;b[a>>0]=b[c>>0]|0}a=e}else o1c(a,c,d)|0;return a|0}function r1c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e|0;i1c(a,b,c,d,g)|0;u=e;return (J=f[g+4>>2]|0,f[g>>2]|0)|0}function s1c(a){a=a|0;return (a&255)<<24|(a>>8&255)<<16|(a>>16&255)<<8|a>>>24|0}function t1c(a,b,c){a=a|0;b=b|0;c=c|0;c=$(b)|0;if((c|0)==32)c=c+($(a)|0)|0;J=0;return c|0}function u1c(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function v1c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=c1c(e^a|0,f^b|0,e|0,f|0)|0;b=J;a=g^e;e=h^f;return c1c((i1c(i,b,c1c(g^c|0,h^d|0,g|0,h|0)|0,J,0)|0)^a|0,J^e|0,a|0,e|0)|0}function w1c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=Y(d,c)|0;f=a>>>16;a=(e>>>16)+(Y(d,f)|0)|0;d=b>>>16;b=Y(d,c)|0;return (J=(a>>>16)+(Y(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function x1c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=w1c(e,a)|0;f=J;return (J=(Y(b,a)|0)+(Y(d,e)|0)+f|f&0,c|0|0)|0}function y1c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return rg[a&3](b|0,c|0,d|0,e|0,f|0,+g)|0}function z1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;sg[a&1](b|0,c|0,d|0,e|0,+f,+g,+h)}function A1c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;tg[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)}function B1c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;ug[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)}function C1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;vg[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0)}function D1c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;wg[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i)}function E1c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xg[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function F1c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;yg[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0,l|0)}function G1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;zg[a&7](b|0,c|0,d|0,e|0,+f,+g,h|0)}function H1c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;Ag[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0)}function I1c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;Bg[a&3](b|0,c|0,+d,e|0,f|0,g|0)}function J1c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;Cg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)}function K1c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;Dg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l)}function L1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;Eg[a&1](b|0,c|0,d|0,+e,+f,+g,+h)}function M1c(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;return Fg[a&1](b|0,+c,d|0)|0}function N1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;Gg[a&3](b|0,c|0,+d,+e,f|0,+g,+h)}function O1c(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;Hg[a&15](b|0,+c,d|0)}function P1c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;Ig[a&3](b|0,c|0,+d,+e,f|0,g|0)}function Q1c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;Jg[a&3](b|0,c|0,+d,+e,f|0,+g)}function R1c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;return Kg[a&1](b|0,c|0,d|0,+e,f|0)|0}function S1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;Lg[a&7](b|0,c|0,d|0,e|0,f|0,+g,h|0)}function T1c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;Mg[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i,+j)}function U1c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Ng[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0)}function V1c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;Og[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j)}function W1c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=+k;Pg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,+k)}function X1c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;Qg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0)}function Y1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Rg[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0)}function Z1c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;return Sg[a&1](b|0,c|0,d|0,+e,+f)|0}function _1c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;Tg[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h)}function $1c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;k=k|0;Ug[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j,k|0)}function a2c(a,b){a=a|0;b=b|0;return +Vg[a&31](b|0)}function b2c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;Wg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0)}function c2c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return Xg[a&1](b|0,c|0,d|0,+e,+f,g|0)|0}function d2c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;Yg[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j,k|0)}function e2c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;Zg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0,+l)}function f2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;_g[a&3](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0)}function g2c(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;$g[a&1](+b,c|0,d|0)}function h2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return +ah[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function i2c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;k=k|0;return bh[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j,k|0)|0}function j2c(a,b,c){a=a|0;b=b|0;c=c|0;return +ch[a&31](b|0,c|0)}function k2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;dh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0)}function l2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;eh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,+j)}function m2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;fh[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j)}function n2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;return gh[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i)|0}function o2c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hh[a&127](b|0,c|0,d|0,e|0)|0}function p2c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;ih[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0,l|0)}function q2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;jh[a&1](b|0,c|0,d|0,+e,+f,+g,h|0)}function r2c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;kh[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k)}function s2c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return lh[a&7](b|0,c|0,d|0,+e)|0}function t2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;return mh[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0,+i)|0}function u2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return nh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function v2c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return oh[a&1](b|0,c|0,+d,+e,f|0)|0}function w2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;ph[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0)}function x2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=+h;qh[a&1](b|0,c|0,+d,+e,f|0,g|0,+h)}function y2c(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;k=+k;l=l|0;m=m|0;n=n|0;return rh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0,+k,l|0,m|0,n|0)|0}function z2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;sh[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0)}function A2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;th[a&1](b|0,c|0,+d,e|0,f|0,g|0,+h)}function B2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;uh[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0)}function C2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;vh[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0)}function D2c(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;wh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l,+m,n|0)}function E2c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return +xh[a&1](b|0,c|0,d|0,+e,+f,g|0)}function F2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;i=i|0;yh[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0,i|0)}function G2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return +zh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function H2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=+i;Ah[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,+i)}function I2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Bh[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0,j|0)}function J2c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return Ch[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function K2c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Dh[a&15](b|0,c|0,d|0,e|0,f|0,+g)}function L2c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;k=k|0;Eh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0,k|0)}function M2c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fh[a&255](b|0,c|0,d|0,e|0,f|0,g|0)}function N2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;Gh[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0)}function O2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;Hh[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0)}function P2c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;Ih[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0)}function Q2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;Jh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0)}function R2c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;Kh[a&15](b|0,c|0,d|0,+e,+f)}function S2c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;Lh[a&7](b|0,c|0,d|0,+e,f|0)}function T2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;return Mh[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0)|0}function U2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;Nh[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i)}function V2c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Oh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function W2c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;return Ph[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j)|0}function X2c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +Qh[a&1](b|0,c|0,+d,+e,f|0)}function Y2c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;return Rh[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0)|0}function Z2c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +Sh[a&31](b|0,c|0,d|0)}function _2c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;Th[a&3](b|0,c|0,d|0,+e,+f,+g)}function $2c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Uh[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0)}function a3c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;return Vh[a&1](b|0,c|0,+d,+e,f|0,g|0)|0}function b3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;Wh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i)}function c3c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;Xh[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0,+j,k|0)}function d3c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;Yh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0,+k)}function e3c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Zh[a&7](b|0,c|0,d|0,+e,+f,g|0)}function f3c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _h[a&127](b|0,c|0,d|0,e|0,f|0)|0}function g3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;$h[a&63](b|0,c|0,d|0,+e)}function h3c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;return ai[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0)|0}function i3c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;bi[a&3](b|0,c|0,+d,e|0,f|0)}function j3c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return ci[a&7](b|0,c|0,d|0,e|0,+f)|0}function k3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;di[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0)}function l3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ei[a&511](b|0,c|0,d|0,e|0)}function m3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;fi[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0,+i)}function n3c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gi[a&255](b|0,c|0,d|0,e|0,f|0)}function o3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;return hi[a&1](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)|0}function p3c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;ii[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function q3c(a,b,c){a=a|0;b=b|0;c=+c;ji[a&31](b|0,+c)}function r3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;return ki[a&3](b|0,c|0,+d,e|0)|0}function s3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return li[a&3](b|0,c|0,+d,+e)|0}function t3c(a,b,c){a=a|0;b=b|0;c=c|0;mi[a&2047](b|0,c|0)}function u3c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ni[a&31](b|0,c|0,d|0,e|0,+f)}function v3c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;oi[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0)}function w3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return pi[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function x3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;qi[a&7](b|0,c|0,+d,+e)}function y3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ri[a&15](b|0,c|0,+d,e|0)}function z3c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;si[a&1](b|0,c|0,d|0,+e,f|0,g|0,+h,+i,j|0)}function A3c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;return ti[a&1](b|0,c|0,d|0,+e,f|0,g|0)|0}function B3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +ui[a&1](b|0,c|0,d|0,+e)}function C3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;vi[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0)}function D3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wi[a&255](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function E3c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;xi[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0,k|0)}function F3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;yi[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i)}function G3c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;zi[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i,j|0)}function H3c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +Ai[a&15](b|0,c|0,d|0,e|0)}function I3c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;Bi[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k,l|0)}function J3c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;k=+k;Ci[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j,+k)}function K3c(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;Di[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,+m)}function L3c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;Ei[a&7](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0)}function M3c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;Fi[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j)}function N3c(a,b,c){a=a|0;b=b|0;c=+c;return Gi[a&1](b|0,+c)|0}function O3c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;Hi[a&1](b|0,c|0,d|0,+e,+f,g|0,+h)}function P3c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ii[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function Q3c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;Ji[a&1](b|0,c|0,+d,e|0,+f,+g,h|0)}function R3c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Ki[a&7](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function S3c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Li[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function T3c(a,b,c){a=a|0;b=b|0;c=c|0;return Mi[a&1023](b|0,c|0)|0}function U3c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;Ni[a&7](b|0,c|0,+d,+e,f|0)}function V3c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;Oi[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0)}function W3c(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Pi[a&1](+b,c|0,d|0,e|0)}function X3c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;Qi[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0)}function Y3c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;j=+j;Ri[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i,+j)}function Z3c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;Si[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0)}function _3c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ti[a&511](b|0,c|0,d|0)}function $3c(a){a=a|0;Ui[a&255]()}function a4c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;Vi[a&63](b|0,c|0,+d)}function b4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=+h;return Wi[a&1](b|0,c|0,+d,+e,f|0,g|0,+h)|0}function c4c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Xi[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0)}function d4c(a,b){a=a|0;b=b|0;Yi[a&4095](b|0)}function e4c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;Zi[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0,+k,l|0)}function f4c(a,b){a=a|0;b=b|0;return _i[a&2047](b|0)|0}function g4c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;$i[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j,k|0)}function h4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aj[a&1](b|0,+c,d|0,+e,+f,g|0)}function i4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;bj[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i)}function j4c(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;cj[a&7](b|0,+c,d|0,e|0)}function k4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;return dj[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0)|0}function l4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ej[a&15](b|0,c|0,d|0,e|0,+f,g|0)}function m4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;fj[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0)}function n4c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;gj[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0)}function o4c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hj[a&511](b|0,c|0,d|0)|0}function p4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;ij[a&1](b|0,c|0,+d,e|0,+f,g|0,h|0)}function q4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;jj[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i)}function r4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;kj[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0)}function s4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=+i;lj[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,+i)}function t4c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;return mj[a&7](b|0,c|0,+d)|0}function u4c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;nj[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,+k,+l)}function v4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;oj[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0)}function w4c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return +pj[a&7](b|0,c|0,d|0,e|0,f|0)}function x4c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return +qj[a&1](b|0,c|0,d|0,e|0,+f)}function y4c(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;return rj[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0)|0}function z4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;return sj[a&1](b|0,c|0,d|0,e|0,+f,+g)|0}function A4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;tj[a&7](b|0,c|0,d|0,+e,f|0,g|0)}function B4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return uj[a&7](b|0,c|0,d|0,e|0,+f,g|0)|0}function C4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;return vj[a&3](b|0,c|0,+d,e|0,f|0,g|0)|0}function D4c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return wj[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0,j|0)|0}function E4c(a){a=a|0;return xj[a&63]()|0}function F4c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;return yj[a&3](b|0,c|0,+d,e|0,f|0)|0}function G4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return +zj[a&3](b|0,c|0,d|0,e|0,f|0,g|0)}function H4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Aj[a&3](b|0,c|0,+d,e|0,f|0,g|0,h|0,i|0)|0}function I4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Bj[a&1](b|0,+c,d|0,+e,+f,g|0,h|0)}function J4c(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;Cj[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0,m|0)}function K4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;return Dj[a&1](b|0,c|0,d|0,e|0,f|0,+g,+h)|0}function L4c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;Ej[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0)}function M4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Fj[a&1](b|0,c|0,+d,e|0,+f,g|0)}function N4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Gj[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function O4c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;i=i|0;Hj[a&1](b|0,c|0,+d,e|0,+f,+g,h|0,i|0)}function P4c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;Ij[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j)}function Q4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Jj[a&7](b|0,c|0,d|0,e|0,+f,+g)}function R4c(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;Kj[a&1](b|0,+c,d|0,e|0,f|0)}function S4c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(0);return 0}function T4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;aa(1)}function U4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;aa(2)}function V4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;aa(3)}function W4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;aa(4)}function X4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;aa(5)}function Y4c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(6);return 0}function Z4c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(7)}function _4c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;aa(8)}function $4c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;aa(9)}function a5c(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(10)}function b5c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(11)}function c5c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(12)}function d5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;aa(13)}function e5c(a,b,c){a=a|0;b=+b;c=c|0;aa(14);return 0}function f5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;aa(15)}function g5c(a,b,c){a=a|0;b=+b;c=c|0;aa(16)}function h5c(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;aa(17)}function i5c(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;aa(18)}function j5c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;aa(19);return 0}function k5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;aa(20)}function l5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;i=+i;aa(21)}function m5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(22)}function n5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;aa(23)}function o5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;aa(24)}function p5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;aa(25)}function q5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(26)}function r5c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;aa(27);return 0}function s5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;aa(28)}function t5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;aa(29)}function u5c(a){a=a|0;aa(30);return 0.0}function v5c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(31)}function w5c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(32);return 0}function x5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(33)}function y5c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(34)}function z5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(35)}function A5c(a,b,c){a=+a;b=b|0;c=c|0;aa(36)}function B5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(37);return 0.0}function C5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=j|0;aa(38);return 0}function D5c(a,b){a=a|0;b=b|0;aa(39);return 0.0}function E5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(40)}function F5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;aa(41)}function G5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;aa(42)}function H5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;aa(43);return 0}function I5c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(44);return 0}function J5c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(45)}function K5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;aa(46)}function L5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;aa(47)}function M5c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(48);return 0}function N5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(49);return 0}function O5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(50);return 0}function P5c(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(51);return 0}function Q5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;aa(52)}function R5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;aa(53)}function S5c(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=+j;k=k|0;l=l|0;m=m|0;aa(54);return 0}function T5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(55)}function U5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=+g;aa(56)}function V5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(57)}function W5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(58)}function X5c(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;m=m|0;aa(59)}function Y5c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(60);return 0.0}function Z5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;aa(61)}function _5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(62);return 0.0}function $5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(63)}function a6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(64)}function b6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(65);return 0}function c6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(66)}function d6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;aa(67)}function e6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(68)}function f6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;aa(69)}function g6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;aa(70)}function h6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;aa(71)}function i6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(72)}function j6c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;aa(73)}function k6c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;aa(74)}function l6c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(75);return 0}function m6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;aa(76)}function n6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(77)}function o6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;aa(78);return 0}function p6c(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(79);return 0.0}function q6c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;aa(80);return 0}function r6c(a,b,c){a=a|0;b=b|0;c=c|0;aa(81);return 0.0}function s6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;aa(82)}function t6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(83)}function u6c(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;aa(84);return 0}function v6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;aa(85)}function w6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;aa(86)}function x6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;aa(87)}function y6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(88)}function z6c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(89);return 0}function A6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(90)}function B6c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;aa(91);return 0}function C6c(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(92)}function D6c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(93);return 0}function E6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;aa(94)}function F6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(95)}function G6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(96)}function H6c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(97)}function I6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;aa(98);return 0}function J6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(99)}function K6c(a,b){a=a|0;b=+b;aa(100)}function L6c(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(101);return 0}function M6c(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(102);return 0}function N6c(a,b){a=a|0;b=b|0;aa(103)}function O6c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(104)}function P6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;aa(105)}function Q6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;aa(106);return 0}function R6c(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(107)}function S6c(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(108)}function T6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(109)}function U6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;aa(110);return 0}function V6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(111);return 0.0}function W6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;aa(112)}function X6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(113)}function Y6c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(114)}function Z6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;aa(115)}function _6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(116)}function $6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(117);return 0.0}function a7c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;aa(118)}function b7c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;aa(119)}function c7c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;aa(120)}function d7c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;aa(121)}function e7c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;aa(122)}function f7c(a,b){a=a|0;b=+b;aa(123);return 0}function g7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;aa(124)}function h7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(125)}function i7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aa(126)}function j7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;aa(127)}function k7c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(128)}function l7c(a,b){a=a|0;b=b|0;aa(129);return 0}function m7c(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(130)}function n7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;aa(131)}function o7c(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;aa(132)}function p7c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;aa(133)}function q7c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;aa(134)}function r7c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;aa(135)}function s7c(a,b,c){a=a|0;b=b|0;c=c|0;aa(136)}function t7c(){aa(137)}function u7c(){zf()}function v7c(a,b,c){a=a|0;b=b|0;c=+c;aa(138)}function w7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=+g;aa(139);return 0}function x7c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(140)}function y7c(a){a=a|0;aa(141)}function z7c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;aa(142)}function A7c(a){a=a|0;aa(143);return 0}function B7c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(144)}function C7c(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;aa(145)}function D7c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;aa(146)}function E7c(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;aa(147)}function F7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;aa(148);return 0}function G7c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;aa(149)}function H7c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;aa(150)}function I7c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(151)}function J7c(a,b,c){a=a|0;b=b|0;c=c|0;aa(152);return 0}function K7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;g=g|0;aa(153)}function L7c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;aa(154)}function M7c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(155)}function N7c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;aa(156)}function O7c(a,b,c){a=a|0;b=b|0;c=+c;aa(157);return 0}function P7c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;aa(158)}function Q7c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;aa(159)}function R7c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(160);return 0.0}function S7c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(161);return 0.0}function T7c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(162);return 0}function U7c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;aa(163);return 0}function V7c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;aa(164)}function W7c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;aa(165);return 0}function X7c(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(166);return 0}function Y7c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(167);return 0}function Z7c(){aa(168);return 0}function _7c(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(169);return 0}function $7c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(170);return 0.0}function a8c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(171);return 0}function b8c(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(172)}function c8c(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(173)}function d8c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;aa(174);return 0}function e8c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;aa(175)}function f8c(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;aa(176)}function g8c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(177);return 0}function h8c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(178)}function i8c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;aa(179)}function j8c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;aa(180)}function k8c(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;aa(181)}


// EMSCRIPTEN_END_FUNCS
var rg=[S4c,kUc,qUc,S4c];var sg=[T4c,aB];var tg=[U4c,tVb,Cq,tu,AJ,Xu,U4c,U4c];var ug=[V4c,gB,rm,Hv];var vg=[W4c,uVb,Hs,Gu];var wg=[X4c,ms];var xg=[Y4c,oL,pL,qL,rL,sL,tL,uL,CO,DO,EO,FO,GO,HO,IO,JO,KO,LO,MO,NO,OO,PO,QO,RO,SO,TO,UO,VO,WO,Tba,jic,kic,sPc,tPc,uPc,vPc,wPc,xPc,yPc,zPc,APc,BPc,CPc,mQc,nQc,oQc,pQc,qQc,rQc,sQc,tQc,uQc,vQc,wQc,PQc,RQc,eRc,gRc,rRc,sRc,tRc,uRc,vRc,cSc,dSc,eSc,fSc,gSc,lUc,rUc,gy,xn,gC,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c,Y4c];var yg=[Z4c,NC];var zg=[_4c,UA,WA,mm,BB,oD,_t,_4c];var Ag=[$4c,am];var Bg=[a5c,Jr,ov,a5c];var Cg=[b5c,RB,GC,b5c];var Dg=[c5c,fn];var Eg=[d5c,bm];var Fg=[e5c,GG];var Gg=[f5c,gm,jm,f5c];var Hg=[g5c,bpc,cpc,Ouc,Tuc,Rwc,Ryc,Aq,Zs,g5c,g5c,g5c,g5c,g5c,g5c,g5c];var Ig=[h5c,Tl,rq,st];var Jg=[i5c,hm,km,i5c];var Kg=[j5c,$F];var Lg=[k5c,oC,Ro,dE,iF,UH,kJ,Cu];var Mg=[l5c,em];var Ng=[m5c,qD];var Og=[n5c,qB];var Pg=[o5c,lD];var Qg=[p5c,pE];var Rg=[q5c,RA,np,ZD];var Sg=[r5c,aL];var Tg=[s5c,hB,sm,Iv];var Ug=[t5c,Xt];var Vg=[u5c,Zpa,YKb,_Kb,eLb,VLb,bNb,NNb,lWb,nWb,pWb,rWb,tWb,vWb,xWb,DWb,eXb,rXb,BXb,Puc,Juc,Swc,Syc,Bn,Vn,mq,u5c,u5c,u5c,u5c,u5c,u5c];var Wg=[v5c,sJ];var Xg=[w5c,$K];var Yg=[x5c,vVb,ks,x5c];var Zg=[y5c,pD];var _g=[z5c,mD,rD,z5c];var $g=[A5c,lo];var ah=[B5c,$C,Hp,ED];var bh=[C5c,xI];var ch=[D5c,CSb,USb,$mc,lnc,bk,mz,uz,Cz,Kz,Sz,Zz,fA,jA,rA,vA,Im,An,iC,Fp,lq,pq,nr,pF,fG,MG,yH,fK,D5c,D5c,D5c,D5c];var dh=[E5c,rp];var eh=[F5c,lp];var fh=[G5c,ls];var gh=[H5c,zI];var hh=[I5c,FL,GL,HL,IL,JL,O$,t3,z4,Rba,Sba,aKa,ZKa,Bfc,jhc,khc,vhc,xhc,yhc,zhc,Ahc,Bhc,Ehc,Ghc,Hhc,Ihc,Uhc,dic,mic,oic,Llc,Wlc,Ylc,fmc,smc,Imc,Umc,enc,qnc,Cnc,Onc,_nc,yVc,VVc,WVc,XVc,bWc,dy,ey,iy,uy,Ky,My,zl,Py,Cl,Sy,Fl,Vy,Il,Yy,Ll,Ol,Pl,JA,bw,Xw,px,Fx,Vx,un,dC,zn,LC,hD,jD,kr,xE,LE,OE,VE,DI,UI,MJ,kK,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c,I5c];var ih=[J5c,XTb,yu,J5c];var jh=[K5c,Fo];var kh=[L5c,fF];var lh=[M5c,Cy,rw,Hw,aG,XK,M5c,M5c];var mh=[N5c,IH];var nh=[O5c,PSc,VSc,STc,TTc,bUc,cUc,fC];var oh=[P5c,DH];var ph=[Q5c,qq];var qh=[R5c,rt];var rh=[S5c,_E];var sh=[T5c,Do];var th=[U5c,Bm];var uh=[V5c,WTb,Bq,su,zJ,V5c,V5c,V5c];var vh=[W5c,Ir,nv,W5c];var wh=[X5c,qY,nY,oY,pY,X5c,X5c,X5c];var xh=[Y5c,zE];var yh=[Z5c,eD];var zh=[_5c,DD];var Ah=[$5c,uB];var Bh=[a6c,$l];var Ch=[b6c,BK];var Dh=[c6c,iB,tm,$m,So,jF,VH,lJ,Du,c6c,c6c,c6c,c6c,c6c,c6c,c6c];var Eh=[d6c,ZA];var Fh=[e6c,HM,BR,CR,DR,ER,FR,GR,HR,IR,JR,KR,LR,MR,NR,JY,KY,LY,MY,NY,OY,PY,CY,DY,EY,FY,GY,HY,IY,e1,f1,g1,h1,T5,s6,R9,wea,uea,Fea,Dea,Oea,Mea,Xea,Vea,ffa,dfa,ofa,mfa,xfa,vfa,Gfa,Efa,Pfa,Nfa,Yfa,Wfa,gga,ega,jga,tga,rga,wga,Cga,kma,lma,mma,nma,oma,Nua,wua,oua,gua,_ta,Sta,Kta,Cta,uta,mta,eta,Eua,Eza,Cza,Aza,yza,wza,uza,sza,qza,oza,mza,XHa,PMc,dSb,MLb,jMb,WMb,CNb,BQb,XQb,sVb,xVb,Lhc,Nhc,gpc,hpc,Dtc,lzc,nvc,guc,zyc,gDc,tAc,bAc,ACc,UEc,pEc,ADc,fNc,xUc,CUc,dZc,mZc,PZc,oB,ym,vB,EB,Ym,KB,dn,ln,WB,pn,_B,_n,sC,fo,vC,po,EC,zo,RC,Mo,XC,Vo,_C,up,Kp,HD,KD,eq,Oq,Rq,iE,Yq,nE,fr,sE,zr,CE,Dr,mt,qH,Lt,bI,Nt,dI,gI,xJ,SY,RY,tyc,uyc,vyc,fvc,gvc,hvc,ivc,uCc,vCc,wCc,mAc,nAc,oAc,pAc,iEc,jEc,kEc,lEc,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c];var Gh=[f6c,VTb,Fu,f6c];var Hh=[g6c,VC,dr,vJ];var Ih=[h6c,tJ];var Jh=[i6c,PC];var Kh=[j6c,Uj,TA,Xl,Zl,dm,Km,pp,ar,Gv,j6c,j6c,j6c,j6c,j6c,j6c];var Lh=[k6c,zB,ho,hq,rs,Js,Ht,Iu];var Mh=[l6c,FE,EK,l6c];var Nh=[m6c,fm];var Oh=[n6c,B$,gn,SB,AC,so,HC,n6c];var Ph=[o6c,yI];var Qh=[p6c,tr];var Rh=[q6c,AI];var Sh=[r6c,oZ,pZ,qZ,rZ,sZ,tZ,uZ,y4,dhc,ehc,By,_y,cz,AB,tn,_o,Ep,BD,kq,VD,oq,XD,xq,mr,r6c,r6c,r6c,r6c,r6c,r6c,r6c];var Th=[s6c,cm,ap,s6c];var Uh=[t6c,Hr,mv,t6c];var Vh=[u6c,CH];var Wh=[v6c,eB];var Xh=[w6c,en];var Yh=[x6c,qp];var Zh=[y6c,SA,Wl,Yl,Jm,op,$q,Fv];var _h=[z6c,YN,ZN,_N,$N,aO,bO,cO,dO,eO,fO,gO,hO,iO,jO,kO,lO,mO,nO,oO,pO,qO,bV,cV,dV,eV,fV,gV,hV,i6,H6,eaa,cOa,OOa,gsb,zsb,Ssb,jtb,Ctb,Vtb,mub,Fub,avb,uvb,Lvb,Zvb,kwb,Cwb,Mwb,Xwb,ixb,yxb,Nxb,Wxb,gyb,ryb,Eyb,Tyb,Fzb,jAb,JAb,XAb,kBb,MBb,QCb,eDb,vDb,TDb,oEb,IEb,dFb,mFb,Jhc,lic,nic,gPc,mPc,NQc,OQc,QQc,UQc,cRc,dRc,fRc,jRc,HUc,KUc,ZUc,aVc,AVc,dWc,SUc,VUc,gVc,jVc,fy,Sj,Ny,Qy,Ty,Wy,Zy,cC,yn,hC,wE,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c,z6c];var $h=[A6c,fWb,phc,qhc,Zhc,_hc,Wj,ck,ow,Ew,_l,jC,io,vp,iq,br,ss,Bs,Ks,Ws,It,Ju,Bv,YY,XY,_Y,ZY,aZ,$Y,cZ,bZ,eZ,dZ,gZ,fZ,iZ,hZ,kZ,jZ,mZ,lZ,kba,jba,iba,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c,A6c];var ai=[B6c,Etc,hK,B6c];var bi=[C6c,Kr,pv,C6c];var ci=[D6c,SQc,TQc,hRc,iRc,CI,jK,D6c];var di=[E6c,QC];var ei=[F6c,RL,SL,TL,UL,VL,WL,XL,IM,ON,PN,QN,RN,fY,gY,hY,iY,XZ,xZ,FZ,GZ,HZ,IZ,YZ,QZ,a_,PZ,d_,h_,i_,j_,p_,q_,r_,B_,H_,N_,Q_,X5,w6,V9,YHa,bKa,mKa,CKa,IKa,TKa,sLa,yLa,QMc,QNa,RNa,KOa,_rb,rsb,Ksb,btb,utb,Ntb,eub,xub,Uub,rvb,Gvb,Yvb,fwb,zwb,Wwb,dxb,txb,Kxb,Vxb,dyb,oyb,Byb,Qyb,$yb,Bzb,Qzb,dAb,CAb,UAb,eBb,JBb,NCb,bDb,rDb,LDb,VDb,kEb,qEb,HEb,JEb,aFb,lFb,UKb,aSb,bSb,cSb,rLb,$Rb,FPb,GPb,LRb,nXb,j_b,B1b,C1b,Ygc,ghc,lhc,nhc,rhc,shc,thc,uhc,whc,Vhc,Xhc,$hc,aic,bic,cic,eic,pic,qic,Nlc,Qlc,Rlc,hmc,kmc,lmc,umc,xmc,ymc,Kmc,Nmc,Omc,Wmc,Zmc,_mc,gnc,jnc,knc,snc,vnc,wnc,Enc,Hnc,Inc,Qnc,Tnc,Unc,aoc,doc,eoc,$oc,apc,fpc,hqc,iqc,Ctc,uzc,gzc,puc,Kuc,Luc,vvc,Bwc,lxc,Wxc,syc,Hyc,pDc,cDc,kAc,BAc,UAc,oBc,XBc,tCc,ICc,bFc,QEc,JDc,SDc,TDc,xEc,gNc,hPc,nPc,fZc,oZc,RZc,Ik,$j,Yj,py,Xk,ty,Zk,xy,bl,Hy,kl,ml,ol,ql,sl,ul,wl,sk,tk,_v,Uw,lx,Cx,Sx,pm,kB,tB,Dm,Lm,CB,Pm,Rm,Um,GB,_m,nn,rn,sn,Fn,lC,On,Rn,Tn,Wn,ao,eo,ro,Ho,TC,Oo,Uo,gp,jp,vD,yp,Cp,zD,Mp,Rp,Vp,OD,gq,zq,Fq,fE,Iq,gE,Qq,Tq,kE,Wq,_q,rr,Br,Fr,Or,Rr,qs,DF,HF,JF,PF,wG,NG,gt,jH,it,lH,kt,lt,Pt,St,Tt,jI,bu,hu,ku,xu,EJ,Mu,$u,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c,F6c];var fi=[G6c,yt];var gi=[H6c,BV,CV,DV,EV,FV,GV,HV,IV,JV,KV,wZ,_0,U0,A4,Kaa,Laa,Maa,Naa,Oaa,Paa,Qaa,Uba,pca,wca,Dca,Kca,Rca,Yca,dda,kda,rda,yda,Ida,Gda,Sda,Qda,nsa,lsa,jsa,hsa,fsa,dsa,bsa,$ra,Zra,Xra,eva,cva,ava,_ua,Yua,xya,vya,tya,rya,pya,nya,lya,jya,hya,fya,YNa,ezb,iAb,QDb,Zgc,mhc,ohc,Fhc,Khc,Mhc,Qhc,Rhc,Shc,Thc,Whc,Yhc,Voc,eZc,nZc,QZc,sy,jB,um,zm,Cm,wB,Tm,FB,Zm,LB,mn,XB,qn,$B,aC,kC,Nn,$n,tC,co,go,qo,FC,Go,SC,No,To,YC,Wo,xD,Bp,yD,Lp,ID,Qp,ND,fq,yq,eE,Pq,Sq,jE,Vq,Zq,oE,gr,qr,Ar,DE,Er,kF,iH,kH,mH,nH,nt,Mt,Ot,eI,Rt,hI,iI,II,mJ,Eu,VY,UY,Wqa,Vqa,Yqa,Xqa,_qa,Zqa,$qa,ara,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c,H6c];var hi=[I6c,bL];var ii=[J6c,kv];var ji=[K6c,Ypa,XKb,ZKb,dLb,ULb,aNb,MNb,mWb,oWb,qWb,sWb,uWb,wWb,yWb,EWb,fXb,sXb,CXb,Rs,_s,at,zt,Bt,Ct,ev,yv,K6c,K6c,K6c,K6c,K6c];var ki=[L6c,IE,rG,HK];var li=[M6c,iD,EH,M6c];var mi=[N6c,NMc,tN,GN,tP,uP,wP,xP,nQ,lQ,jQ,wQ,F$,P$,y$,Z1,_1,$1,a2,w3,g4,q4,x4,U5,t6,S9,uaa,Vaa,$aa,Ima,lka,qka,vka,Aka,Fka,Pka,Vka,$ka,fla,lla,wla,Cla,Ila,Ola,Ula,bma,dma,fma,hma,jma,rma,uma,xma,Bma,Fma,_ma,lna,yna,Lna,Yna,coa,Hoa,Aoa,$oa,apa,tpa,vpa,xpa,Bpa,Dpa,Fpa,_pa,$pa,yqa,rqa,kqa,dqa,cra,Dva,Bva,fwa,dwa,mwa,kwa,iwa,Ewa,Awa,Lwa,Jwa,Hwa,bxa,$wa,Zwa,dxa,gxa,oxa,mxa,kxa,vxa,txa,rxa,xxa,zxa,Bxa,Dxa,iCa,fCa,dCa,sCa,pCa,mCa,OCa,LCa,DCa,ACa,fDa,cDa,ZCa,WCa,hEa,dEa,bEa,ZDa,wEa,uEa,FEa,CEa,AEa,PEa,MEa,JEa,SEa,TEa,UEa,VEa,WEa,XEa,YEa,ZEa,hFa,iFa,jFa,kFa,pFa,sFa,tFa,uFa,vFa,wFa,xFa,yFa,zFa,AFa,BFa,CFa,DFa,lGa,jGa,gGa,eGa,xGa,vGa,sGa,pGa,VHa,CMa,ilc,llc,mlc,BRa,FRa,GRa,HRa,JRa,YTa,$Ta,aUa,bUa,cUa,iTa,pTa,sTa,qlc,vTa,ulc,xTa,_Sa,bTa,cTa,dTa,eTa,WRa,XRa,aSa,bSa,dSa,gSa,rlc,AUa,DUa,EUa,FUa,GUa,cVa,fVa,gVa,hVa,iVa,lWa,oWa,pWa,qWa,rWa,CVa,JVa,PVa,SVa,VVa,XVa,YWa,$Wa,aXa,bXa,cXa,sXa,vXa,wXa,xXa,yXa,TXa,WXa,XXa,YXa,ZXa,BZa,EZa,FZa,GZa,HZa,SZa,VZa,WZa,XZa,YZa,j_a,m_a,n_a,o_a,p_a,A_a,D_a,E_a,F_a,G_a,S_a,V_a,W_a,X_a,Y_a,i$a,l$a,m$a,n$a,o$a,A$a,D$a,E$a,F$a,G$a,R$a,U$a,V$a,W$a,X$a,h0a,k0a,l0a,m0a,n0a,E0a,H0a,I0a,J0a,K0a,I1a,L1a,M1a,N1a,O1a,Y1a,$1a,a2a,b2a,c2a,m2a,p2a,q2a,r2a,s2a,C2a,F2a,G2a,H2a,I2a,S2a,V2a,W2a,X2a,Y2a,g3a,j3a,k3a,l3a,m3a,w3a,z3a,A3a,B3a,C3a,M3a,P3a,Q3a,R3a,S3a,a4a,d4a,e4a,f4a,g4a,r4a,u4a,v4a,w4a,x4a,H4a,K4a,L4a,M4a,N4a,X4a,_4a,$4a,a5a,b5a,r5a,u5a,v5a,w5a,x5a,I5a,L5a,M5a,N5a,O5a,Y5a,$5a,a6a,b6a,c6a,m6a,p6a,q6a,r6a,s6a,C6a,F6a,G6a,H6a,I6a,S6a,V6a,W6a,X6a,Y6a,g7a,j7a,k7a,l7a,m7a,x7a,A7a,B7a,C7a,D7a,N7a,Q7a,R7a,S7a,T7a,b8a,e8a,f8a,g8a,h8a,r8a,u8a,v8a,w8a,x8a,H8a,K8a,L8a,M8a,N8a,Y8a,$8a,a9a,b9a,c9a,m9a,p9a,q9a,r9a,s9a,C9a,F9a,G9a,H9a,I9a,S9a,V9a,W9a,X9a,Y9a,gab,jab,kab,lab,mab,zab,Cab,Dab,Eab,Fab,Vab,Yab,Zab,_ab,$ab,kbb,nbb,obb,pbb,qbb,Bbb,Ebb,Fbb,Gbb,Hbb,Tbb,Wbb,Xbb,Ybb,Zbb,jcb,mcb,ncb,ocb,pcb,Acb,Dcb,Ecb,Fcb,Gcb,Scb,Vcb,Wcb,Xcb,Ycb,jdb,mdb,ndb,odb,pdb,Bdb,Edb,Fdb,Gdb,Hdb,Sdb,Vdb,Wdb,Xdb,Ydb,heb,keb,leb,meb,neb,yeb,Beb,Ceb,Deb,Eeb,Qeb,Teb,Ueb,Veb,Web,ffb,ifb,jfb,kfb,lfb,yfb,Bfb,Cfb,Dfb,Efb,Pfb,Sfb,Tfb,Ufb,Vfb,fgb,igb,jgb,kgb,lgb,xgb,Agb,Bgb,Cgb,Dgb,Ogb,Rgb,Sgb,Tgb,Ugb,khb,nhb,ohb,phb,qhb,Ahb,Dhb,Ehb,Fhb,Ghb,Qhb,Thb,Uhb,Vhb,Whb,eib,hib,iib,jib,kib,xib,Aib,Bib,Cib,Dib,Tib,Wib,Xib,Yib,Zib,ijb,ljb,mjb,njb,ojb,Ajb,Djb,Ejb,Fjb,Gjb,Yjb,$jb,akb,bkb,ckb,wkb,zkb,Akb,Bkb,Ckb,Okb,Rkb,Skb,Tkb,Ukb,Slb,Vlb,Wlb,Xlb,Ylb,umb,xmb,ymb,zmb,Amb,Mmb,Pmb,Qmb,Rmb,Smb,inb,lnb,mnb,nnb,onb,ynb,Bnb,Cnb,Dnb,Enb,Onb,Rnb,Snb,Tnb,Unb,eob,hob,iob,job,kob,wob,zob,Aob,Bob,Cob,Uob,Xob,Yob,Zob,_ob,kpb,npb,opb,ppb,qpb,Lpb,Opb,Ppb,Qpb,Rpb,nqb,qqb,rqb,sqb,tqb,Fqb,Iqb,Jqb,Kqb,Lqb,ksb,Dsb,Wsb,ntb,Gtb,Ztb,qub,Lub,fvb,Qvb,pwb,Cxb,kzb,tAb,yDb,_Db,vEb,tEb,KEb,LEb,MEb,xFb,AFb,BFb,CFb,DFb,XFb,_Fb,$Fb,aGb,bGb,pGb,sGb,tGb,uGb,vGb,wHb,zHb,AHb,BHb,CHb,NGb,UGb,_Gb,bHb,eHb,gHb,gIb,jIb,kIb,lIb,mIb,GIb,JIb,KIb,LIb,MIb,$Ib,cJb,dJb,eJb,fJb,xJb,AJb,BJb,CJb,DJb,RJb,UJb,VJb,WJb,XJb,yKb,BKb,CKb,DKb,EKb,XRb,YRb,RKb,VKb,$Kb,bLb,kLb,sLb,uLb,wLb,KLb,LLb,HLb,QLb,SLb,WLb,YLb,_Lb,iMb,UMb,_Mb,cNb,eNb,gNb,iNb,kNb,mNb,oNb,ANb,BNb,xNb,GNb,INb,KNb,ONb,QNb,SNb,kOb,rOb,uOb,OOb,MOb,TOb,VOb,oPb,lPb,iPb,fPb,bPb,_Ob,APb,CPb,HPb,JPb,LPb,NPb,mQb,nQb,pQb,RQb,SQb,TQb,FRb,MRb,ORb,QRb,wSb,ASb,RSb,sTb,STb,ZTb,aUb,bUb,iUb,hVb,mVb,rVb,EVb,NVb,dWb,eWb,gWb,iWb,kWb,AWb,CWb,LWb,TWb,YWb,ZWb,$Wb,aXb,bXb,dXb,qXb,uXb,wXb,yXb,AXb,EXb,kZb,qZb,vZb,AZb,S3b,V3b,W3b,X3b,Y3b,M4b,P4b,Q4b,R4b,S4b,f5b,i5b,j5b,k5b,l5b,z5b,C5b,D5b,E5b,F5b,U5b,X5b,Y5b,Z5b,_5b,m6b,p6b,q6b,r6b,s6b,I6b,L6b,M6b,N6b,O6b,c7b,f7b,g7b,h7b,i7b,z7b,C7b,D7b,E7b,F7b,S7b,V7b,W7b,X7b,Y7b,j8b,m8b,n8b,o8b,p8b,D8b,G8b,H8b,I8b,J8b,W8b,Z8b,_8b,$8b,a9b,o9b,r9b,s9b,t9b,u9b,I9b,L9b,M9b,N9b,O9b,cac,fac,gac,hac,iac,yac,Bac,Cac,Dac,Eac,Vac,Yac,Zac,_ac,$ac,obc,rbc,sbc,tbc,ubc,Mbc,Pbc,Qbc,Rbc,Sbc,ecc,hcc,icc,jcc,kcc,zcc,Ccc,Dcc,Ecc,Fcc,Vcc,Ycc,Zcc,_cc,$cc,mdc,pdc,qdc,rdc,sdc,Odc,Rdc,Sdc,Tdc,Udc,hec,kec,lec,mec,nec,Fec,Iec,Jec,Kec,Lec,plc,dgc,egc,Ejc,Wjc,Xjc,akc,bkc,dkc,gkc,Mlc,Plc,gmc,jmc,tmc,wmc,Jmc,Mmc,Vmc,Ymc,fnc,inc,rnc,unc,Dnc,Gnc,Pnc,Snc,$nc,coc,Ftc,nzc,ozc,tzc,$yc,azc,fzc,iuc,juc,ouc,uuc,ovc,pvc,uvc,Bvc,Lvc,uwc,vwc,Awc,Zvc,hwc,exc,fxc,kxc,txc,Pxc,Qxc,Vxc,hyc,lyc,myc,ryc,Ayc,Byc,Gyc,vzc,Fzc,iDc,jDc,oDc,XCc,YCc,bDc,dAc,eAc,jAc,uAc,vAc,AAc,NAc,OAc,TAc,hBc,iBc,nBc,wBc,QBc,RBc,WBc,iCc,mCc,nCc,sCc,BCc,CCc,HCc,WEc,XEc,aFc,JEc,KEc,PEc,CDc,DDc,IDc,qEc,rEc,wEc,zFc,JFc,BGc,dNc,FOc,MOc,TOc,_Oc,bTc,cTc,dTc,eTc,gTc,hTc,nTc,oTc,pTc,qTc,sTc,tTc,yTc,zTc,ATc,BTc,DTc,ETc,JTc,KTc,LTc,MTc,OTc,PTc,yUc,DUc,IVc,JVc,KVc,PVc,QVc,RVc,Jk,Kk,Lk,Mk,Nk,Ok,Pk,Qk,Rk,fk,el,dk,ik,jk,Xj,lk,mk,nk,uk,vk,wk,rk,qk,Ov,cw,sw,Iw,Yw,qx,Gx,Om,Wm,En,Hn,Yn,Ko,Qo,$o,xp,Ap,Np,Up,Yp,_p,bq,vq,Hq,Kq,hr,uE,vE,or,pr,ur,wr,xr,Gr,Nr,Qr,Vr,Xr,Zr,$r,as,cs,es,gs,js,us,ws,ys,Ds,Es,Fs,Gs,Ms,Os,Ps,Qs,Us,Ys,JG,dt,ft,ot,pt,qt,wt,At,Jt,_H,Qt,Vt,Wt,du,fu,gu,iu,ju,mu,ou,pu,qu,Lu,Ou,Qu,Ru,Su,Tu,Uu,Vu,Wu,bv,dv,fv,gv,hv,iv,jv,sv,uv,vv,wv,xv,zv,Av,Dv,XV,YV,ZV,_V,$V,aW,IW,HW,GW,FW,EW,DW,CW,BW,AW,zW,yW,xW,wW,vW,uW,tW,sW,rW,qW,pW,oW,nW,mW,lW,kW,jW,iW,hW,gW,fW,eW,dW,cW,bW,Rwa,Swa,Owa,Pwa,Qwa,EQa,FQa,GQa,HQa,IQa,JQa,KQa,LQa,MQa,NQa,OQa,PQa,QQa,RQa,SQa,TQa,UQa,VQa,WQa,XQa,YQa,ZQa,_Qa,$Qa,aRa,bRa,cRa,dRa,eRa,fRa,gRa,hRa,iRa,jRa,kRa,lRa,mRa,nRa,oRa,pRa,qRa,KHc,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c];var ni=[O6c,JZ,LZ,Ohc,Phc,qy,YA,om,Mn,xC,uD,ps,CF,OF,vG,Ft,YH,au,wu,DJ,_u,O6c,O6c,O6c,O6c,O6c,O6c,O6c,O6c,O6c,O6c,O6c];var oi=[P6c,_A];var pi=[Q6c,gK];var qi=[R6c,Vl,Cn,ip,tq,ut,R6c,R6c];var ri=[S6c,KZ,k_,s_,C_,I_,R_,Hm,$D,Lr,Ss,qv,S6c,S6c,S6c,S6c];var si=[T6c,wVb];var ti=[U6c,_F];var ui=[V6c,Pp];var vi=[W6c,Eo];var wi=[X6c,LP,MP,NP,OP,PP,QP,RP,ZQ,_Q,$Q,aR,bR,cR,dR,eR,fR,gR,JT,KT,LT,MT,NT,OT,PT,QT,RT,ST,TT,UT,VT,WT,XT,YT,ZT,_T,$T,aU,bU,cU,dU,eU,fU,gU,hU,iU,jU,kU,lU,mU,nU,oU,pU,qU,rU,sU,tU,uU,vU,wU,xU,yU,zU,AU,BU,CU,DU,EU,FU,GU,HU,IU,JU,KU,LU,MU,NU,OU,PU,QU,RU,SU,UU,VU,WU,XU,YU,ZU,_U,ZW,_W,$W,aX,bX,cX,dX,eX,fX,gX,hX,iX,jX,kX,lX,mX,nX,oX,pX,qX,rX,sX,tX,uX,vX,wX,xX,yX,zX,AX,BX,CX,DX,EX,FX,GX,HX,IX,JX,KX,LX,MX,NX,OX,PX,QX,RX,SX,TX,UX,VX,WX,XX,YX,ZX,_X,$X,aY,bY,cY,z$,A$,IB,NB,jn,UB,YB,Jn,nC,qC,no,CC,xo,JC,UC,sD,FD,cq,SD,lE,AE,$H,iR,Nna,Mna,Pna,Ona,Rna,Qna,Tna,Sna,Vna,Una,Ana,zna,Cna,Bna,Ena,Dna,Gna,Fna,Ina,Hna,nna,mna,pna,ona,rna,qna,tna,sna,vna,una,ana,$ma,cna,bna,ena,dna,gna,fna,ina,hna,Pma,Oma,Rma,Qma,Tma,Sma,Vma,Uma,Xma,Wma,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c,X6c];var xi=[Y6c,Co];var yi=[Z6c,rB,qE,Z6c];var zi=[_6c,lB,vm,_6c];var Ai=[$6c,Chc,Dhc,$y,dz,bC,Zo,cD,AD,UD,nq,_D,$6c,$6c,$6c,$6c];var Bi=[a7c,eF];var Ci=[b7c,cB];var Di=[c7c,QB];var Ei=[d7c,yVb,cE,hF,TH,jJ,Bu,d7c];var Fi=[e7c,dB];var Gi=[f7c,HG];var Hi=[g7c,fB];var Ii=[h7c,uR,vR,wR,xR,yR,zR,AR,w4,Faa,Gaa,Haa,Iaa,Jaa,Aaa,Baa,Caa,Daa,Eaa,vaa,waa,xaa,yaa,zaa,Lha,Sha,Zha,eia,lia,sia,zia,Gia,Nia,Uia,$ia,gja,nja,Xla,Yla,Zla,_la,$la,EAa,LAa,SAa,ZAa,eBa,lBa,sBa,zBa,GBa,NBa,isb,Bsb,Usb,ltb,Etb,Xtb,oub,Hub,cvb,LAb,gVb,XWb,sB,Xm,JB,cn,OB,kn,VB,on,ZB,Kn,Zn,rC,uC,oo,DC,yo,KC,Jo,Lo,ZC,tp,tD,Jp,GD,dq,TD,Nq,hE,Xq,mE,rE,yr,BE,Cr,pH,Kt,aI,cI,Mqa,Lqa,Oqa,Nqa,Rqa,Qqa,Tqa,Uqa,Pqa,Sqa,xGc,wGc,vGc,uGc,tGc,sGc,rGc,zGc,yGc,qGc,h7c,h7c,h7c,h7c,h7c,h7c];var Ji=[i7c,yB];var Ki=[j7c,nB,xm,MB,WC,er,wJ,j7c];var Li=[k7c,Q8,R8,S8,T8,U8,V8,W8,J8,K8,L8,M8,N8,O8,P8,v8,w8,x8,y8,z8,A8,B8,C8,D8,E8,F8,G8,H8,I8,X8,Y8,Z8,_8,$8,a9,b9,n9,o9,p9,q9,s9,r9,t9,u9,v9,w9,x9,y9,z9,A9,I9,J9,K9,L9,M9,N9,O9,B9,C9,D9,E9,F9,G9,H9,g9,h9,i9,j9,k9,l9,m9,O1,P1,Q1,R1,S1,T1,U1,ola,pla,qla,rla,sla,Hka,Ika,Jka,Kka,Lka,dka,eka,fka,gka,hka,hn,TB,mC,mo,BC,wo,IC,RD,uY,rY,sY,tY,e9,c9,d9,f9,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c,k7c];var Mi=[l7c,KM,LM,kP,lP,mP,nP,oP,WZ,SZ,$Z,c_,g_,o_,A_,G_,M_,P_,C$,t0,S0,OXc,h6,G6,daa,sha,pEa,_Ha,$Ha,vLa,pLa,kLa,fLa,aLa,WKa,QKa,LKa,FKa,zKa,uKa,jKa,VJa,bMa,gMa,WMc,YMc,SNa,TNa,UNa,_Na,$Na,tOa,LOa,MOa,FOa,QPa,uRa,zRa,JZb,TTa,BTa,kTa,qTa,TSa,YSa,SRa,URa,tUa,yUa,XUa,aVa,eWa,jWa,tVa,vVa,LVa,QVa,RWa,WWa,lXa,qXa,NXa,RXa,wZa,zZa,NZa,QZa,e_a,h_a,v_a,y_a,N_a,Q_a,d$a,g$a,v$a,y$a,M$a,P$a,c0a,f0a,z0a,C0a,D1a,G1a,T1a,W1a,h2a,k2a,x2a,A2a,N2a,Q2a,b3a,e3a,r3a,u3a,H3a,K3a,X3a,_3a,m4a,p4a,C4a,F4a,S4a,V4a,m5a,p5a,D5a,G5a,T5a,W5a,h6a,k6a,x6a,A6a,N6a,Q6a,b7a,e7a,s7a,v7a,I7a,L7a,Y7a,$7a,m8a,p8a,C8a,F8a,T8a,W8a,h9a,k9a,x9a,A9a,N9a,Q9a,bab,eab,uab,xab,Qab,Tab,fbb,ibb,wbb,zbb,Obb,Rbb,ecb,hcb,vcb,ycb,Ncb,Qcb,edb,hdb,wdb,zdb,Ndb,Qdb,ceb,feb,teb,web,Leb,Oeb,afb,dfb,tfb,wfb,Kfb,Nfb,agb,dgb,sgb,vgb,Jgb,Mgb,fhb,ihb,vhb,yhb,Lhb,Ohb,$hb,cib,sib,vib,Oib,Rib,djb,gjb,vjb,yjb,Tjb,Wjb,rkb,ukb,Jkb,Mkb,Nlb,Qlb,pmb,smb,Hmb,Kmb,dnb,gnb,tnb,wnb,Jnb,Mnb,$nb,cob,rob,uob,Pob,Sob,fpb,ipb,Gpb,Jpb,iqb,lqb,Aqb,Dqb,$rb,esb,Xrb,ssb,xsb,osb,Lsb,Qsb,Hsb,ctb,htb,_sb,vtb,Atb,rtb,Otb,Ttb,Ktb,fub,kub,bub,yub,Dub,uub,Qub,Vub,_ub,kvb,svb,Cvb,Hvb,Kvb,Vvb,cwb,gwb,uwb,Awb,Kwb,Gwb,Rwb,axb,exb,oxb,uxb,xxb,Hxb,Lxb,Sxb,eyb,ayb,lyb,pyb,wyb,Cyb,Lyb,Ryb,Yyb,azb,qzb,Czb,Lzb,Rzb,Tzb,Zzb,eAb,yAb,DAb,HAb,QAb,VAb,aBb,fBb,ABb,KBb,DCb,OCb,XCb,cDb,mDb,sDb,MDb,RDb,SDb,EDb,lEb,fEb,CEb,wEb,xEb,VEb,bFb,iFb,qFb,vFb,QFb,VFb,iGb,nGb,pHb,uHb,EGb,GGb,WGb,$Gb,$Hb,eIb,zIb,EIb,UIb,ZIb,qJb,vJb,KJb,PJb,rKb,wKb,DSb,vTb,UTb,yUb,uUb,nVb,lZb,BZb,L3b,Q3b,F4b,K4b,_4b,d5b,s5b,x5b,N5b,S5b,f6b,k6b,B6b,G6b,X6b,a7b,s7b,x7b,L7b,Q7b,c8b,h8b,w8b,B8b,P8b,U8b,h9b,m9b,B9b,G9b,X9b,aac,rac,wac,Oac,Tac,hbc,mbc,Fbc,Kbc,Zbc,ccc,scc,xcc,Occ,Tcc,fdc,kdc,Hdc,Mdc,aec,fec,yec,Dec,wfc,agc,nlc,pgc,Mgc,Ngc,Ogc,fic,gic,wlc,Fjc,EZb,Sjc,Ujc,Jlc,Klc,Slc,Tlc,Zlc,dmc,emc,mmc,qmc,rmc,zmc,Gmc,Hmc,Pmc,Smc,Tmc,cnc,dnc,onc,pnc,xnc,Anc,Bnc,Jnc,Mnc,Nnc,Vnc,Ync,Znc,foc,zoc,Jqc,yuc,zuc,Fvc,Gvc,Pvc,Qvc,bwc,cwc,lwc,mwc,xxc,yxc,zzc,Azc,Jzc,Kzc,ABc,BBc,DFc,EFc,NFc,OFc,SHc,THc,UHc,mNc,oNc,IOc,POc,WOc,bPc,tVc,vVc,xVc,YVc,_Vc,aWc,$x,ay,jy,ly,my,ny,yy,dl,Ay,Ey,Iy,xl,Al,Dl,Gl,Jl,Ml,Ql,gz,kz,qz,yz,Gz,Oz,Qz,Uz,Vz,Wz,$z,bA,lA,pA,zA,BA,DA,EA,GA,IA,$v,pw,Fw,Vw,mx,Dx,Tx,HB,wn,pC,Bo,dD,CD,MD,QD,KE,NE,RE,is,aF,lF,nF,rF,tF,vF,GF,XF,YF,cG,gG,hG,tG,LG,XG,hH,oH,rH,wH,xH,GH,KH,ZH,kI,tI,uI,wI,FI,RI,SI,TI,WI,YI,ru,qJ,yJ,JJ,KJ,LJ,OJ,QJ,bK,dK,eK,mK,qK,zK,JK,LK,WK,ZK,PDa,cCb,WBb,nCb,ugc,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c,l7c];var Ni=[m7c,Ul,im,lm,sq,tt,m7c,m7c];var Oi=[n7c,fD];var Pi=[o7c,ko];var Qi=[p7c,uJ];var Ri=[q7c,Yt];var Si=[r7c,OC];var Ti=[s7c,LV,MV,NV,OV,PV,QV,RV,SV,TV,UV,KW,LW,MW,NW,OW,PW,QW,yZ,zZ,AZ,BZ,CZ,DZ,EZ,NZ,OZ,RZ,l_,u_,v_,J_,x$,L0,I0,w0,x0,y0,z0,A0,B0,F2,D2,A2,x2,u2,Y1,v4,V5,Y5,Z5,u6,x6,y6,T9,W9,X9,Xpa,ONa,PNa,VNa,WNa,XNa,ZNa,aOa,JOa,NOa,cSa,asb,bsb,csb,dsb,fsb,tsb,usb,vsb,wsb,ysb,Msb,Nsb,Osb,Psb,Rsb,dtb,etb,ftb,gtb,itb,wtb,xtb,ytb,ztb,Btb,Ptb,Qtb,Rtb,Stb,Utb,gub,hub,iub,jub,lub,zub,Aub,Bub,Cub,Eub,Wub,Xub,Yub,Zub,$ub,qvb,tvb,Ivb,Jvb,hwb,iwb,jwb,ywb,Bwb,Jwb,Lwb,Vwb,fxb,gxb,hxb,vxb,wxb,Mxb,fyb,qyb,Ayb,Dyb,Syb,bzb,czb,dzb,Azb,Dzb,Ezb,Pzb,Szb,cAb,fAb,gAb,hAb,lAb,mAb,EAb,FAb,GAb,IAb,TAb,WAb,dBb,gBb,hBb,iBb,jBb,LBb,MCb,PCb,aDb,dDb,qDb,tDb,uDb,KDb,NDb,ODb,PDb,$Db,jEb,mEb,nEb,GEb,$Eb,cFb,AQb,WQb,ESb,VSb,wTb,oVb,qVb,Rgc,Tgc,Vgc,Xgc,_gc,ckc,Olc,Xlc,_lc,imc,nmc,vmc,Amc,Lmc,Xmc,hnc,tnc,Fnc,Rnc,boc,Yoc,Zoc,_oc,dpc,epc,Epc,Kqc,vuc,wuc,xuc,Cuc,Cvc,Dvc,Evc,Jvc,Mvc,Nvc,Ovc,Tvc,_vc,$vc,awc,fwc,iwc,jwc,kwc,pwc,uxc,vxc,wxc,Bxc,wzc,xzc,yzc,Dzc,Gzc,Hzc,Izc,Nzc,xBc,yBc,zBc,EBc,WDc,$Dc,AFc,BFc,CFc,HFc,KFc,LFc,MFc,RFc,Hk,ak,_j,ky,Vj,Wk,Yk,_k,wy,gk,cl,gl,ek,hl,hk,Gy,kk,jl,ll,nl,pl,rl,tl,vl,hz,lz,rz,zz,Hz,Pz,Rz,aA,cA,mA,qA,AA,CA,pk,Zv,Pv,Rv,dw,fw,tw,vw,Tw,Jw,Lw,kx,Zw,$w,Bx,rx,tx,Rx,Hx,Jx,qm,Am,Em,Mm,Nm,DB,Qm,Sm,Vm,Gn,In,Pn,Sn,Un,Xn,bo,jo,Io,Po,bp,ep,hp,kp,wp,wD,zp,Dp,Op,Sp,Tp,Wp,Xp,Zp,$p,aq,jq,wq,Gq,Jq,Lq,Mq,Uq,cr,tE,yE,sr,vr,Pr,Tr,Ur,Wr,Yr,_r,bs,ds,fs,dF,mF,oF,sF,uF,wF,ts,EF,vs,xs,IF,zs,Cs,QF,VF,WF,Ls,eG,Xs,FG,bt,ct,ht,jt,zH,AH,fI,Ut,vI,cu,HI,lu,ZI,_I,$I,Ku,Nu,RJ,SJ,TJ,aK,cK,av,pK,AK,NK,Cv,_P,ZP,aQ,$P,mba,lba,Lpa,Hpa,Ipa,Jpa,Kpa,Rpa,Npa,Opa,Ppa,Qpa,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c,s7c];var Ui=[t7c,u7c,XYc,KRa,LRa,MRa,NRa,mUa,oUa,HUa,IUa,JUa,jVa,kVa,nVa,oVa,pVa,dXa,eXa,fXa,gXa,_Xa,$Xa,cYa,dYa,eYa,fYa,gYa,hYa,iYa,jYa,kYa,lYa,mYa,nYa,oYa,pYa,qYa,rYa,sYa,tYa,uYa,vYa,wYa,xYa,yYa,zYa,AYa,BYa,CYa,DYa,EYa,FYa,GYa,HYa,IYa,JYa,KYa,LYa,MYa,NYa,OYa,PYa,QYa,RYa,SYa,TYa,UYa,VYa,WYa,XYa,YYa,ZYa,_Ya,$Ya,aZa,bZa,cZa,dZa,eZa,fZa,gZa,hZa,iZa,jZa,kZa,lZa,mZa,nZa,oZa,pZa,qZa,rZa,sZa,Zlb,_lb,bmb,cmb,dmb,emb,fmb,gmb,hmb,imb,jmb,kmb,lmb,EFb,FFb,IFb,JFb,KFb,LFb,MFb,nIb,oIb,rIb,sIb,tIb,uIb,vIb,FKb,GKb,HKb,TXb,UXb,f_b,k_b,m_b,T2b,a1b,e1b,u1b,h2b,U2b,Z3b,_3b,b4b,c4b,d4b,e4b,f4b,g4b,h4b,i4b,j4b,k4b,l4b,m4b,n4b,o4b,p4b,q4b,r4b,s4b,t4b,u4b,v4b,w4b,x4b,y4b,z4b,A4b,B4b,ijc,xlc,ylc,zlc,Alc,Blc,Clc,Dlc,Elc,Flc,Glc,joc,voc,woc,qqc,rqc,qZc,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c,t7c];var Vi=[v7c,TR,UR,VR,WR,XR,YR,ZR,_R,$R,aS,W5,v6,U9,nz,vz,Dz,Lz,Tz,_z,gA,kA,sA,wA,nw,Dw,Dn,uq,Mr,qF,iG,Ts,KG,vt,JH,oK,rv,MK,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c,v7c];var Wi=[w7c,BH];var Xi=[x7c,aE,hJ,zu];var Yi=[y7c,qM,rM,tM,uM,MM,NM,OM,PM,QM,RM,tNc,uNc,vNc,wNc,FM,GM,NNc,ONc,PNc,QNc,RNc,SNc,DNc,ENc,FNc,GNc,ZM,_M,$M,aN,qN,rN,DN,EN,qP,rP,sP,g3,mQ,kQ,iQ,tQ,uQ,vZ,VZ,_Z,b_,f_,n_,z_,F_,L_,O_,G$,H$,I$,w$,M$,p0,M0,J0,K0,NXc,r0,s0,u0,O0,$0,V0,W0,Q0,R0,T0,_2,$2,a3,b3,W2,X2,Y2,Z2,S2,T2,U2,V2,O2,P2,Q2,R2,K2,L2,M2,N2,G2,H2,I2,J2,V1,E2,C2,z2,w2,t2,X1,p2,q2,r2,s2,m2,n2,o2,r3,s3,v3,Q3,R3,S3,T3,X4,Y4,Z4,_4,d4,e4,j4,k4,l4,s4,a6,b6,c6,d6,R5,S5,_5,m6,n6,o6,p6,f6,g6,A6,B6,C6,D6,r6,z6,L6,M6,N6,O6,F6,Z9,_9,$9,aaa,Q9,Y9,kaa,laa,maa,naa,caa,taa,Taa,Uaa,Zaa,_aa,Hba,Iba,Jba,Kba,Lba,Mba,Nba,Oba,Pba,Qba,Tda,Uda,Vda,Wda,Jda,Kda,Lda,Mda,zda,Ada,Bda,Cda,sda,tda,uda,vda,lda,mda,nda,oda,eda,fda,gda,hda,Zca,_ca,$ca,ada,Sca,Tca,Uca,Vca,Lca,Mca,Nca,Oca,Eca,Fca,Gca,Hca,xca,yca,zca,Aca,qca,rca,sca,tca,nca,oca,uca,vca,Bca,Cca,Ica,Jca,Pca,Qca,Wca,Xca,bda,cda,ida,jda,pda,qda,wda,xda,Eda,Hda,Fda,Oda,Rda,Pda,lha,mha,nha,oha,hha,iha,jha,kha,dha,eha,fha,gha,$ga,aha,bha,cha,Xga,Yga,Zga,_ga,Tga,Uga,Vga,Wga,Pga,Qga,Rga,Sga,Lga,Mga,Nga,Oga,Hga,Iga,Jga,Kga,Dga,Ega,Fga,Gga,xga,yga,zga,Aga,kga,lga,mga,nga,Zfa,_fa,$fa,aga,Qfa,Rfa,Sfa,Tfa,Hfa,Ifa,Jfa,Kfa,yfa,zfa,Afa,Bfa,pfa,qfa,rfa,sfa,gfa,hfa,ifa,jfa,Yea,Zea,_ea,$ea,Pea,Qea,Rea,Sea,Gea,Hea,Iea,Jea,xea,yea,zea,Aea,sea,vea,tea,Bea,Eea,Cea,Kea,Nea,Lea,Tea,Wea,Uea,bfa,efa,cfa,kfa,nfa,lfa,tfa,wfa,ufa,Cfa,Ffa,Dfa,Lfa,Ofa,Mfa,Ufa,Xfa,Vfa,cga,fga,dga,iga,pga,sga,qga,vga,Bga,qha,rha,tha,oja,pja,qja,rja,hja,ija,jja,kja,aja,bja,cja,dja,Via,Wia,Xia,Yia,Oia,Pia,Qia,Ria,Hia,Iia,Jia,Kia,Aia,Bia,Cia,Dia,tia,uia,via,wia,mia,nia,oia,pia,fia,gia,hia,iia,_ha,$ha,aia,bia,Tha,Uha,Vha,Wha,Mha,Nha,Oha,Pha,Jha,Kha,Qha,Rha,Xha,Yha,cia,dia,jia,kia,qia,ria,xia,yia,Eia,Fia,Lia,Mia,Sia,Tia,Zia,_ia,eja,fja,lja,mja,tja,uja,vja,wja,aka,Hma,jka,kka,oka,pka,tka,uka,yka,zka,Dka,Eka,Nka,Oka,Tka,Uka,Zka,_ka,dla,ela,jla,kla,ula,vla,Ala,Bla,Gla,Hla,Mla,Nla,Sla,Tla,ama,cma,ema,gma,ima,pma,qma,sma,tma,vma,wma,zma,Ama,Dma,Ema,Zma,kna,xna,Kna,Xna,aoa,boa,Foa,Goa,zoa,cpa,bpa,rpa,spa,ppa,upa,npa,wpa,zpa,Apa,kpa,Cpa,ipa,Epa,Dqa,Eqa,Fqa,Gqa,Vpa,Wpa,aqa,zqa,Aqa,Bqa,Cqa,wqa,xqa,sqa,tqa,uqa,vqa,pqa,qqa,lqa,mqa,nqa,oqa,iqa,jqa,eqa,fqa,gqa,hqa,bqa,cqa,bra,Ysa,Zsa,_sa,$sa,Usa,Vsa,Wsa,Xsa,Qsa,Rsa,Ssa,Tsa,Msa,Nsa,Osa,Psa,Isa,Jsa,Ksa,Lsa,Esa,Fsa,Gsa,Hsa,Asa,Bsa,Csa,Dsa,wsa,xsa,ysa,zsa,ssa,tsa,usa,vsa,osa,psa,qsa,rsa,msa,ksa,isa,gsa,esa,csa,asa,_ra,Yra,Wra,Pua,Qua,Rua,Sua,Lua,Mua,Oua,yua,zua,Aua,Bua,uua,vua,xua,qua,rua,sua,tua,mua,nua,pua,iua,jua,kua,lua,eua,fua,hua,aua,bua,cua,dua,Yta,Zta,$ta,Uta,Vta,Wta,Xta,Qta,Rta,Tta,Mta,Nta,Ota,Pta,Ita,Jta,Lta,Eta,Fta,Gta,Hta,Ata,Bta,Dta,wta,xta,yta,zta,sta,tta,vta,ota,pta,qta,rta,kta,lta,nta,gta,hta,ita,jta,cta,dta,fta,Hua,Iua,Jua,Kua,Cua,Dua,Fua,vva,wva,xva,yva,rva,sva,tva,uva,nva,ova,pva,qva,jva,kva,lva,mva,fva,gva,hva,iva,dva,bva,$ua,Zua,Xua,Cva,Ava,ewa,cwa,lwa,jwa,hwa,Dwa,zwa,Kwa,Iwa,Gwa,axa,_wa,Ywa,cxa,fxa,nxa,lxa,jxa,uxa,sxa,qxa,wxa,yxa,Axa,Cxa,gza,hza,iza,jza,cza,dza,eza,fza,_ya,$ya,aza,bza,Wya,Xya,Yya,Zya,Sya,Tya,Uya,Vya,Oya,Pya,Qya,Rya,Kya,Lya,Mya,Nya,Gya,Hya,Iya,Jya,Cya,Dya,Eya,Fya,yya,zya,Aya,Bya,wya,uya,sya,qya,oya,mya,kya,iya,gya,eya,nAa,oAa,pAa,qAa,jAa,kAa,lAa,mAa,fAa,gAa,hAa,iAa,bAa,cAa,dAa,eAa,Zza,_za,$za,aAa,Vza,Wza,Xza,Yza,Rza,Sza,Tza,Uza,Nza,Oza,Pza,Qza,Jza,Kza,Lza,Mza,Fza,Gza,Hza,Iza,Dza,Bza,zza,xza,vza,tza,rza,pza,nza,lza,OBa,PBa,QBa,RBa,HBa,IBa,JBa,KBa,ABa,BBa,CBa,DBa,tBa,uBa,vBa,wBa,mBa,nBa,oBa,pBa,fBa,gBa,hBa,iBa,_Aa,$Aa,aBa,bBa,TAa,UAa,VAa,WAa,MAa,NAa,OAa,PAa,FAa,GAa,HAa,IAa,CAa,DAa,JAa,KAa,QAa,RAa,XAa,YAa,cBa,dBa,jBa,kBa,qBa,rBa,xBa,yBa,EBa,FBa,LBa,MBa,hCa,eCa,cCa,rCa,oCa,lCa,NCa,KCa,CCa,zCa,eDa,bDa,YCa,VCa,gEa,cEa,aEa,YDa,nEa,oEa,qEa,vEa,tEa,EEa,BEa,zEa,OEa,LEa,IEa,fFa,eFa,dFa,cFa,bFa,aFa,$Ea,_Ea,oFa,nFa,mFa,lFa,qFa,PFa,OFa,NFa,MFa,LFa,KFa,JFa,IFa,HFa,GFa,FFa,EFa,kGa,iGa,fGa,dGa,wGa,uGa,rGa,oGa,a_b,gHa,hHa,aIa,bIa,cIa,dIa,SHa,UHa,oJa,pJa,qJa,rJa,tLa,uLa,wLa,nLa,oLa,qLa,iLa,jLa,lLa,dLa,eLa,gLa,_Ka,$Ka,bLa,UKa,VKa,XKa,OKa,PKa,RKa,JKa,KKa,MKa,DKa,EKa,GKa,xKa,yKa,AKa,sKa,tKa,vKa,hKa,iKa,kKa,TJa,UJa,WJa,_Ja,gKa,$Ja,lKa,wKa,BKa,HKa,NKa,SKa,YKa,cLa,hLa,mLa,rLa,xLa,$La,aMa,cMa,eMa,fMa,hMa,oMa,pMa,qMa,rMa,DMa,FMa,GMa,rNa,sNa,tNa,uNa,vNa,wNa,JNa,KNa,MNa,NNa,bOa,rOa,sOa,uOa,HOa,IOa,DOa,EOa,GOa,OPa,PPa,RPa,TPa,UPa,VPa,WPa,rRa,sRa,xRa,slc,ESa,RTa,WTa,gTa,QTa,nTa,QSa,RSa,WSa,QRa,RRa,_Ra,$Ra,hTa,GTa,CTa,DTa,qUa,rUa,wUa,UUa,VUa,_Ua,bWa,cWa,hWa,rVa,sVa,yVa,zVa,HVa,IVa,NVa,aWa,_Va,$Va,uWa,OWa,PWa,UWa,iXa,jXa,oXa,KXa,LXa,PXa,tZa,uZa,xZa,KZa,LZa,OZa,b_a,c_a,f_a,s_a,t_a,w_a,K_a,L_a,O_a,a$a,b$a,e$a,s$a,t$a,w$a,J$a,K$a,N$a,$$a,a0a,d0a,w0a,x0a,A0a,A1a,B1a,E1a,Q1a,R1a,U1a,e2a,f2a,i2a,u2a,v2a,y2a,K2a,L2a,O2a,_2a,$2a,c3a,o3a,p3a,s3a,E3a,F3a,I3a,U3a,V3a,Y3a,j4a,k4a,n4a,z4a,A4a,D4a,P4a,Q4a,T4a,j5a,k5a,n5a,A5a,B5a,E5a,Q5a,R5a,U5a,e6a,f6a,i6a,u6a,v6a,y6a,K6a,L6a,O6a,_6a,$6a,c7a,p7a,q7a,t7a,F7a,G7a,J7a,V7a,W7a,Z7a,j8a,k8a,n8a,z8a,A8a,D8a,Q8a,R8a,U8a,e9a,f9a,i9a,u9a,v9a,y9a,K9a,L9a,O9a,_9a,$9a,cab,rab,sab,vab,Nab,Oab,Rab,cbb,dbb,gbb,tbb,ubb,xbb,Lbb,Mbb,Pbb,bcb,ccb,fcb,scb,tcb,wcb,Kcb,Lcb,Ocb,bdb,cdb,fdb,tdb,udb,xdb,Kdb,Ldb,Odb,$db,aeb,deb,qeb,reb,ueb,Ieb,Jeb,Meb,Zeb,_eb,bfb,qfb,rfb,ufb,Hfb,Ifb,Lfb,Zfb,_fb,bgb,pgb,qgb,tgb,Ggb,Hgb,Kgb,chb,dhb,ghb,shb,thb,whb,Ihb,Jhb,Mhb,Yhb,Zhb,aib,pib,qib,tib,Lib,Mib,Pib,ajb,bjb,ejb,sjb,tjb,wjb,Qjb,Rjb,Ujb,okb,pkb,skb,Gkb,Hkb,Kkb,Klb,Llb,Olb,mmb,nmb,qmb,Emb,Fmb,Imb,anb,bnb,enb,qnb,rnb,unb,Gnb,Hnb,Knb,Ynb,Znb,aob,oob,pob,sob,Mob,Nob,Qob,cpb,dpb,gpb,Dpb,Epb,Hpb,fqb,gqb,jqb,xqb,yqb,Bqb,Zrb,Vrb,Wrb,Yrb,jsb,qsb,msb,nsb,psb,Csb,Jsb,Fsb,Gsb,Isb,Vsb,atb,Ysb,Zsb,$sb,mtb,ttb,ptb,qtb,stb,Ftb,Mtb,Itb,Jtb,Ltb,Ytb,dub,$tb,aub,cub,pub,wub,sub,tub,vub,Kub,Oub,Pub,Rub,Sub,Tub,evb,ivb,jvb,lvb,ovb,pvb,Avb,Bvb,Dvb,Evb,Fvb,Pvb,Tvb,Uvb,Wvb,Xvb,awb,bwb,dwb,ewb,nwb,owb,swb,twb,vwb,wwb,xwb,Iwb,Ewb,Fwb,Hwb,Pwb,Qwb,Swb,Twb,Uwb,_wb,$wb,bxb,cxb,mxb,nxb,pxb,rxb,sxb,Bxb,Fxb,Gxb,Ixb,Jxb,Qxb,Rxb,Txb,Uxb,cyb,_xb,$xb,byb,jyb,kyb,myb,nyb,uyb,vyb,xyb,yyb,zyb,Jyb,Kyb,Myb,Nyb,Pyb,Oyb,Wyb,Xyb,Zyb,_yb,jzb,ozb,pzb,rzb,yzb,zzb,Jzb,Kzb,Mzb,Nzb,Ozb,Xzb,Yzb,_zb,$zb,bAb,aAb,rAb,sAb,wAb,xAb,zAb,AAb,BAb,OAb,PAb,RAb,SAb,_Ab,$Ab,bBb,cBb,yBb,zBb,BBb,HBb,IBb,BCb,CCb,ECb,ICb,LCb,JCb,VCb,WCb,YCb,_Cb,$Cb,kDb,lDb,nDb,oDb,pDb,xDb,IDb,JDb,GDb,HDb,CDb,DDb,FDb,YDb,ZDb,bEb,hEb,iEb,dEb,eEb,gEb,uEb,sEb,AEb,BEb,DEb,EEb,FEb,TEb,UEb,WEb,ZEb,_Eb,XEb,YEb,gFb,hFb,jFb,kFb,nFb,oFb,tFb,NFb,OFb,TFb,fGb,gGb,lGb,mHb,nHb,sHb,CGb,DGb,JGb,KGb,SGb,TGb,YGb,lHb,jHb,kHb,FHb,YHb,ZHb,cIb,wIb,xIb,CIb,RIb,SIb,XIb,nJb,oJb,tJb,HJb,IJb,NJb,oKb,pKb,uKb,fLb,gLb,hLb,iLb,WRb,TKb,yLb,zLb,ALb,BLb,qLb,cMb,dMb,eMb,fMb,JLb,gMb,hMb,MMb,NMb,OMb,PMb,VMb,tNb,uNb,vNb,wNb,WNb,XNb,YNb,ZNb,zNb,jOb,qOb,tOb,NOb,LOb,SOb,UOb,nPb,kPb,hPb,XOb,ePb,aPb,YOb,ZOb,zPb,DPb,EPb,cQb,dQb,eQb,fQb,gQb,hQb,iQb,jQb,kQb,lQb,qQb,yQb,KQb,LQb,MQb,NQb,OQb,PQb,QQb,VQb,aRb,bRb,cRb,dRb,fRb,gRb,hRb,iRb,nRb,oRb,pRb,qRb,jRb,kRb,lRb,mRb,BRb,CRb,DRb,ERb,SRb,TRb,URb,VRb,KRb,tSb,uSb,BSb,FSb,KSb,LSb,MSb,NSb,OSb,PSb,WSb,bTb,cTb,dTb,eTb,lTb,mTb,nTb,oTb,hTb,iTb,jTb,kTb,pTb,qTb,xTb,KTb,LTb,MTb,NTb,GTb,HTb,ITb,JTb,CTb,DTb,ETb,FTb,QTb,RTb,gUb,hUb,wUb,xUb,zUb,sUb,tUb,vUb,WUb,XUb,YUb,ZUb,eVb,fVb,kVb,lVb,CVb,DVb,LVb,MVb,bWb,cWb,KWb,OWb,PWb,QWb,RWb,SWb,gXb,hXb,iXb,jXb,WWb,IXb,JXb,KXb,LXb,mXb,oXb,hZb,iZb,nZb,oZb,tZb,xZb,yZb,ZZb,_Zb,b_b,c_b,R2b,S2b,z1b,A1b,ipc,x1b,Z1b,_1b,h3b,i3b,u3b,v3b,I3b,J3b,O3b,C4b,D4b,I4b,X4b,Y4b,b5b,p5b,q5b,v5b,K5b,L5b,Q5b,c6b,d6b,i6b,y6b,z6b,E6b,U6b,V6b,_6b,p7b,q7b,v7b,I7b,J7b,O7b,$7b,a8b,f8b,t8b,u8b,z8b,M8b,N8b,S8b,e9b,f9b,k9b,y9b,z9b,E9b,U9b,V9b,_9b,oac,pac,uac,Lac,Mac,Rac,ebc,fbc,kbc,Cbc,Dbc,Ibc,Wbc,Xbc,acc,pcc,qcc,vcc,Lcc,Mcc,Rcc,cdc,ddc,idc,Edc,Fdc,Kdc,Zdc,_dc,dec,vec,wec,Bec,xfc,yfc,Zfc,_fc,jlc,ngc,ogc,mrc,sgc,Kgc,Lgc,Bjc,Cjc,Hjc,Ijc,Ljc,Mjc,Ojc,Pjc,Qjc,Rjc,_jc,$jc,Hlc,Ilc,cmc,pmc,Fmc,Rmc,bnc,nnc,znc,Lnc,Xnc,xoc,yoc,Woc,Xoc,Cpc,Dpc,njc,gqc,N_b,Hqc,nrc,Atc,Btc,Htc,izc,jzc,kzc,Yyc,Zyc,_yc,duc,euc,fuc,Duc,Euc,Guc,Muc,Quc,Huc,Suc,Uuc,kvc,lvc,mvc,Kvc,Uvc,rwc,swc,twc,gwc,qwc,Ewc,Owc,Pwc,bxc,cxc,dxc,Cxc,Kxc,Oxc,Jxc,gyc,iyc,jyc,kyc,wyc,xyc,yyc,Pyc,Ezc,Ozc,dDc,eDc,fDc,UCc,VCc,WCc,_zc,$zc,aAc,qAc,rAc,sAc,KAc,LAc,MAc,eBc,fBc,gBc,FBc,NBc,PBc,MBc,hCc,jCc,kCc,lCc,xCc,yCc,zCc,REc,SEc,TEc,GEc,HEc,IEc,xDc,yDc,zDc,ODc,UDc,YDc,PDc,_Dc,aEc,mEc,nEc,oEc,IFc,SFc,AGc,HMc,JMc,LMc,MMc,bNc,cNc,yNc,zNc,ANc,BNc,INc,JNc,KNc,LNc,DOc,EOc,KOc,LOc,ROc,SOc,YOc,ZOc,dPc,ePc,fPc,kPc,lPc,qPc,rPc,kQc,lQc,LQc,MQc,aRc,bRc,oRc,pRc,$Rc,aSc,NSc,OSc,TSc,USc,ZSc,_Sc,jTc,kTc,uTc,vTc,FTc,GTc,QTc,RTc,$Tc,aUc,iUc,jUc,oUc,pUc,uUc,vUc,zUc,AUc,jPc,PUc,EUc,cVc,dVc,oVc,pVc,rVc,sVc,EVc,FVc,LVc,MVc,SVc,TVc,eWc,fWc,gWc,_Yc,$Yc,aZc,bZc,lZc,wZc,xZc,CZc,DZc,EZc,FZc,HZc,JZc,MZc,OZc,Xx,fz,jz,pz,tz,xz,Bz,Fz,Jz,Nz,Yz,eA,iA,oA,uA,yA,Sl,yk,Wv,kw,Aw,Qw,gx,yx,Ox,ir,jr,UE,RVb,SVb,AF,LF,SF,Ns,mG,oG,Vs,AG,CG,$s,RG,TG,et,aH,cH,eH,tH,xt,OH,QH,oI,qI,eu,MI,OI,nu,dJ,fJ,GJ,Pu,XJ,ZJ,cv,uK,wK,tv,RK,TK,Ev,gL,nYc,bN,pQ,j2,i2,h2,g2,f2,e2,d2,k2,b1b,BHa,rHa,AHa,IHa,PHa,OHa,nJa,zJa,QMa,dPa,DQa,ORa,GSa,DSa,uSa,NSa,nUa,KUa,mVa,hXa,bYa,i5a,g5a,ikb,gkb,eqb,amb,_mb,Sqb,Qqb,Xpb,Upb,Bpb,aqb,HFb,qIb,IKb,L_b,A0b,W1b,d3b,l3b,a4b,Bgc,Akc,zkc,hlc,src,Hrc,Nrc,Trc,Zrc,dsc,jsc,psc,rsc,Twc,yOc,KPc,MPc,FRc,HRc,JRc,NYc,rSc,tSc,vSc,UTc,kIc,rZc,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c,y7c];var Zi=[z7c,PB];var _i=[A7c,sM,RMc,SMc,JM,VMc,sN,FN,vP,vQ,D$,E$,l2,u3,f4,h4,i4,n4,o4,p4,r4,t4,u4,THa,ZHa,tMa,EMa,UMc,tRa,vRa,wRa,yRa,ARa,CRa,ERa,tlc,IRa,STa,UTa,VTa,XTa,ATa,ZTa,jTa,lTa,mTa,oTa,rTa,tTa,wTa,ETa,FTa,SSa,USa,VSa,XSa,ZSa,$Sa,YRa,ZRa,eSa,fSa,yTa,zTa,sUa,uUa,vUa,xUa,zUa,BUa,WUa,YUa,ZUa,$Ua,bVa,dVa,dWa,fWa,gWa,iWa,kWa,mWa,wVa,xVa,AVa,BVa,KVa,MVa,OVa,RVa,TVa,WVa,YVa,ZVa,vWa,wWa,QWa,SWa,TWa,VWa,XWa,ZWa,kXa,mXa,nXa,pXa,rXa,tXa,MXa,OXa,QXa,SXa,UXa,vZa,yZa,AZa,CZa,MZa,PZa,RZa,TZa,d_a,g_a,i_a,k_a,u_a,x_a,z_a,B_a,M_a,P_a,R_a,T_a,c$a,f$a,h$a,j$a,u$a,x$a,z$a,B$a,L$a,O$a,Q$a,S$a,b0a,e0a,g0a,i0a,y0a,B0a,D0a,F0a,C1a,F1a,H1a,J1a,S1a,V1a,X1a,Z1a,g2a,j2a,l2a,n2a,w2a,z2a,B2a,D2a,M2a,P2a,R2a,T2a,a3a,d3a,f3a,h3a,q3a,t3a,v3a,x3a,G3a,J3a,L3a,N3a,W3a,Z3a,$3a,b4a,l4a,o4a,q4a,s4a,B4a,E4a,G4a,I4a,R4a,U4a,W4a,Y4a,l5a,o5a,q5a,s5a,C5a,F5a,H5a,J5a,S5a,V5a,X5a,Z5a,g6a,j6a,l6a,n6a,w6a,z6a,B6a,D6a,M6a,P6a,R6a,T6a,a7a,d7a,f7a,h7a,r7a,u7a,w7a,y7a,H7a,K7a,M7a,O7a,X7a,_7a,a8a,c8a,l8a,o8a,q8a,s8a,B8a,E8a,G8a,I8a,S8a,V8a,X8a,Z8a,g9a,j9a,l9a,n9a,w9a,z9a,B9a,D9a,M9a,P9a,R9a,T9a,aab,dab,fab,hab,tab,wab,yab,Aab,Pab,Sab,Uab,Wab,ebb,hbb,jbb,lbb,vbb,ybb,Abb,Cbb,Nbb,Qbb,Sbb,Ubb,dcb,gcb,icb,kcb,ucb,xcb,zcb,Bcb,Mcb,Pcb,Rcb,Tcb,ddb,gdb,idb,kdb,vdb,ydb,Adb,Cdb,Mdb,Pdb,Rdb,Tdb,beb,eeb,geb,ieb,seb,veb,xeb,zeb,Keb,Neb,Peb,Reb,$eb,cfb,efb,gfb,sfb,vfb,xfb,zfb,Jfb,Mfb,Ofb,Qfb,$fb,cgb,egb,ggb,rgb,ugb,wgb,ygb,Igb,Lgb,Ngb,Pgb,ehb,hhb,jhb,lhb,uhb,xhb,zhb,Bhb,Khb,Nhb,Phb,Rhb,_hb,bib,dib,fib,rib,uib,wib,yib,Nib,Qib,Sib,Uib,cjb,fjb,hjb,jjb,ujb,xjb,zjb,Bjb,Sjb,Vjb,Xjb,Zjb,qkb,tkb,vkb,xkb,Ikb,Lkb,Nkb,Pkb,Mlb,Plb,Rlb,Tlb,omb,rmb,tmb,vmb,Gmb,Jmb,Lmb,Nmb,cnb,fnb,hnb,jnb,snb,vnb,xnb,znb,Inb,Lnb,Nnb,Pnb,_nb,bob,dob,fob,qob,tob,vob,xob,Oob,Rob,Tob,Vob,epb,hpb,jpb,lpb,Fpb,Ipb,Kpb,Mpb,hqb,kqb,mqb,oqb,zqb,Cqb,Eqb,Gqb,pFb,rFb,sFb,uFb,wFb,yFb,PFb,RFb,SFb,UFb,WFb,YFb,hGb,jGb,kGb,mGb,oGb,qGb,oHb,qHb,rHb,tHb,vHb,xHb,HGb,IGb,LGb,MGb,VGb,XGb,ZGb,aHb,cHb,fHb,hHb,iHb,GHb,HHb,_Hb,aIb,bIb,dIb,fIb,hIb,yIb,AIb,BIb,DIb,FIb,HIb,TIb,VIb,WIb,YIb,_Ib,aJb,pJb,rJb,sJb,uJb,wJb,yJb,JJb,LJb,MJb,OJb,QJb,SJb,qKb,sKb,tKb,vKb,xKb,zKb,ZRb,eSb,fSb,gSb,WKb,aLb,cLb,tLb,vLb,xLb,NLb,OLb,PLb,RLb,TLb,XLb,ZLb,$Lb,kMb,lMb,mMb,XMb,YMb,ZMb,$Mb,dNb,fNb,hNb,jNb,lNb,nNb,pNb,DNb,ENb,FNb,HNb,JNb,LNb,PNb,RNb,TNb,IPb,KPb,MPb,OPb,oQb,zQb,UQb,NRb,PRb,RRb,xSb,SSb,tTb,TTb,YTb,_Tb,$Tb,hWb,jWb,zWb,BWb,_Wb,cXb,pXb,tXb,vXb,xXb,zXb,DXb,mZb,rZb,sZb,wZb,CZb,$Zb,K3b,M3b,N3b,P3b,R3b,T3b,E4b,G4b,H4b,J4b,L4b,N4b,Z4b,$4b,a5b,c5b,e5b,g5b,r5b,t5b,u5b,w5b,y5b,A5b,M5b,O5b,P5b,R5b,T5b,V5b,e6b,g6b,h6b,j6b,l6b,n6b,A6b,C6b,D6b,F6b,H6b,J6b,W6b,Y6b,Z6b,$6b,b7b,d7b,r7b,t7b,u7b,w7b,y7b,A7b,K7b,M7b,N7b,P7b,R7b,T7b,b8b,d8b,e8b,g8b,i8b,k8b,v8b,x8b,y8b,A8b,C8b,E8b,O8b,Q8b,R8b,T8b,V8b,X8b,g9b,i9b,j9b,l9b,n9b,p9b,A9b,C9b,D9b,F9b,H9b,J9b,W9b,Y9b,Z9b,$9b,bac,dac,qac,sac,tac,vac,xac,zac,Nac,Pac,Qac,Sac,Uac,Wac,gbc,ibc,jbc,lbc,nbc,pbc,Ebc,Gbc,Hbc,Jbc,Lbc,Nbc,Ybc,_bc,$bc,bcc,dcc,fcc,rcc,tcc,ucc,wcc,ycc,Acc,Ncc,Pcc,Qcc,Scc,Ucc,Wcc,edc,gdc,hdc,jdc,ldc,ndc,Gdc,Idc,Jdc,Ldc,Ndc,Pdc,$dc,bec,cec,eec,gec,iec,xec,zec,Aec,Cec,Eec,Gec,$fc,bgc,klc,olc,cgc,hic,iic,Gjc,Njc,Yjc,Zjc,ekc,fkc,pzc,qzc,rzc,szc,bzc,czc,dzc,ezc,kuc,luc,muc,nuc,Auc,Buc,Nuc,Iuc,qvc,rvc,svc,tvc,Hvc,Ivc,Rvc,Svc,wwc,xwc,ywc,zwc,dwc,ewc,nwc,owc,Qwc,gxc,hxc,ixc,jxc,zxc,Axc,Rxc,Sxc,Txc,Uxc,nyc,oyc,pyc,qyc,Cyc,Dyc,Eyc,Fyc,Qyc,Bzc,Czc,Lzc,Mzc,kDc,lDc,mDc,nDc,ZCc,_Cc,$Cc,aDc,fAc,gAc,hAc,iAc,wAc,xAc,yAc,zAc,PAc,QAc,RAc,SAc,jBc,kBc,lBc,mBc,CBc,DBc,SBc,TBc,UBc,VBc,oCc,pCc,qCc,rCc,DCc,ECc,FCc,GCc,YEc,ZEc,_Ec,$Ec,LEc,MEc,NEc,OEc,EDc,FDc,GDc,HDc,VDc,XDc,QDc,RDc,sEc,tEc,uEc,vEc,FFc,GFc,PFc,QFc,rIc,hNc,iNc,kNc,lNc,GOc,NOc,UOc,VOc,$Oc,aPc,qRc,xRc,yRc,zRc,ARc,BRc,CRc,DRc,bSc,iSc,jSc,kSc,lSc,mSc,nSc,oSc,$Sc,aTc,fTc,lTc,mTc,rTc,wTc,xTc,CTc,HTc,ITc,NTc,IUc,JUc,LUc,_Uc,$Uc,bVc,GVc,HVc,NVc,OVc,TUc,UUc,WUc,hVc,iVc,kVc,yZc,GZc,Wx,Zx,_x,Sk,Tk,Uk,Vk,$k,al,fl,il,HA,ok,KA,Vv,Yv,Qv,jw,mw,ew,zw,Cw,uw,Pw,Sw,Kw,fx,jx,_w,xx,Ax,sx,Nx,Qx,Ix,Qn,fp,Gp,TE,YE,$E,cF,zF,KF,MF,NF,RF,TF,UF,dG,jG,lG,nG,pG,qG,uG,xG,zG,BG,DG,EG,IG,OG,QG,SG,UG,VG,YG,ZG,$G,bH,dH,fH,gH,sH,uH,vH,HH,LH,NH,PH,RH,SH,lI,nI,pI,rI,sI,GI,JI,LI,NI,PI,QI,XI,aJ,cJ,eJ,oJ,pJ,$Ub,FJ,HJ,IJ,PJ,UJ,WJ,YJ,_J,$J,nK,rK,tK,vK,xK,yK,KK,OK,QK,SK,UK,VK,_K,dL,fL,Hab,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c,A7c];var $i=[B7c,pB,yY,vY,wY,xY,B7c,B7c];var aj=[C7c,Gm];var bj=[D7c,mB,wm,D7c];var cj=[E7c,MZ,t_,D_,zC,E7c,E7c,E7c];var dj=[F7c,ZF];var ej=[G7c,zVb,Ln,wC,Eq,os,BF,Et,XH,vu,CJ,Zu,G7c,G7c,G7c,G7c];var fj=[H7c,mp,sp,YD];var gj=[I7c,lv];var hj=[J7c,OMc,TMc,XMc,m4,WHa,uMa,vMa,wMa,xMa,yMa,zMa,AMa,BMa,dOa,DRa,_Ta,uTa,aTa,TRa,VRa,CUa,eVa,nWa,uVa,UVa,_Wa,uXa,VXa,DZa,UZa,l_a,C_a,U_a,k$a,C$a,T$a,j0a,G0a,K1a,_1a,o2a,E2a,U2a,i3a,y3a,O3a,c4a,t4a,J4a,Z4a,t5a,K5a,_5a,o6a,E6a,U6a,i7a,z7a,P7a,d8a,t8a,J8a,_8a,o9a,E9a,U9a,iab,Bab,Xab,mbb,Dbb,Vbb,lcb,Ccb,Ucb,ldb,Ddb,Udb,jeb,Aeb,Seb,hfb,Afb,Rfb,hgb,zgb,Qgb,mhb,Chb,Shb,gib,zib,Vib,kjb,Cjb,_jb,ykb,Qkb,Ulb,wmb,Omb,knb,Anb,Qnb,gob,yob,Wob,mpb,Npb,pqb,Hqb,hsb,Asb,Tsb,ktb,Dtb,Wtb,nub,Gub,bvb,Mvb,jxb,zxb,Xxb,Fyb,fzb,Gzb,Uzb,kAb,KAb,lBb,UDb,pEb,zFb,ZFb,rGb,yHb,FGb,dHb,iIb,IIb,bJb,zJb,TJb,AKb,vSb,ySb,zSb,QSb,TSb,rTb,uTb,pVb,jZb,pZb,Xsc,uZb,zZb,y1b,U3b,O4b,h5b,B5b,W5b,o6b,K6b,e7b,B7b,U7b,l8b,F8b,Y8b,q9b,K9b,eac,Aac,Xac,qbc,Obc,gcc,Bcc,Xcc,odc,Qdc,jec,Hec,zfc,Afc,Cfc,KZb,tgc,Pgc,Qgc,Sgc,Ugc,Wgc,$gc,ahc,bhc,chc,fhc,hhc,ihc,ric,sic,Djc,Jjc,Tjc,Vjc,Ulc,Vlc,$lc,omc,Bmc,Qmc,anc,mnc,ync,Knc,Wnc,goc,Iqc,orc,Gtc,sIc,tIc,AIc,yIc,LJc,eNc,jNc,nNc,HOc,OOc,iPc,oPc,wUc,BUc,uVc,wVc,zVc,UVc,ZVc,$Vc,cWc,cZc,IZc,KZc,NZc,by,cy,hy,ry,vy,zy,Dy,Fy,Jy,Ly,yl,Oy,Bl,Ry,El,Uy,Hl,Xy,Kl,Nl,Rl,FA,aw,Sv,qw,gw,Gw,ww,Ww,Mw,nx,ax,Ex,ux,Ux,Kx,vn,eC,Ao,MC,gD,kD,LD,PD,lr,ME,PE,QE,SE,hs,WE,FF,bG,WG,EI,VI,gJ,NJ,lK,YK,JHc,wKc,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c,J7c];var ij=[K7c,cp];var jj=[L7c,$A];var kj=[M7c,nD];var lj=[N7c,Zt];var mj=[O7c,JE,sG,FH,IK,O7c,O7c,O7c];var nj=[P7c,Jma,Kma,Lma,Mma,Nma,P7c,P7c];var oj=[Q7c,Dq,ns,Dt,WH,uu,BJ,Yu];var pj=[R7c,az,bz,Yo,bD,WD,R7c,R7c];var qj=[S7c,JD];var rj=[T7c,ZE];var sj=[U7c,BI];var tj=[V7c,CQb,YQb,Is,Gt,Hu,V7c,V7c];var uj=[W7c,mzc,huc,hDc,cAc,VEc,BDc,iK];var vj=[X7c,GE,FK,X7c];var wj=[Y7c,CK];var xj=[Z7c,Yx,ez,iz,oz,sz,wz,Az,Ez,Iz,Mz,Xz,dA,hA,nA,tA,xA,Xv,lw,Bw,Rw,ix,zx,Px,XE,kG,yG,PG,_G,MH,mI,KI,bJ,nJ,VJ,sK,PK,eL,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c,Z7c];var yj=[_7c,HE,GK,_7c];var zj=[$7c,Xo,aD,Ip];var Aj=[a8c,EE,DK,a8c];var Bj=[b8c,Fm];var Cj=[c8c,rJ];var Dj=[d8c,cL];var Ej=[e8c,bE,iJ,Au];var Fj=[f8c,dp];var Gj=[g8c,N$,wRc,hSc,FUc,GUc,XUc,YUc,QUc,RUc,eVc,fVc,g8c,g8c,g8c,g8c];var Hj=[h8c,xB];var Ij=[i8c,gF];var Jj=[j8c,oy,VA,XA,bB,nm,$t,j8c];var Kj=[k8c,yC];return{dynCall_vididdi:h4c,___cxx_global_var_init:nFc,dynCall_iiidii:F4c,dynCall_viiiidiidd:m2c,dynCall_viiiiiiiiidd:u4c,dynCall_viiiddiiid:l2c,dynCall_viiiiidi:S1c,dynCall_viiidiiiidi:c3c,_bitshift64Lshr:l1c,dynCall_viiiiddidd:Y3c,dynCall_viiiiidd:_1c,dynCall_viiididi:V3c,__GLOBAL__sub_I_versions_pb_cc:LKb,dynCall_viiidddii:C3c,dynCall_iiiddiiid:t2c,dynCall_viiiiiiiiiid:K1c,dynCall_diii:Z2c,dynCall_viiiiiiiiiii:J1c,_bitshift64Ashr:k1c,dynCall_viiiiidiiddi:I3c,dynCall_viiddidd:N1c,_sbrk:p1c,__GLOBAL__sub_I_imgwarp_cpp:qaa,_memcpy:o1c,dynCall_iiiiiddiddi:i2c,dynCall_vi:d4c,dynCall_iiid:t4c,__GLOBAL__sub_I_bind_cpp:gIc,dynCall_viiiiddiiid:W1c,dynCall_viiidiiii:N2c,dynCall_viiiiiidd:i4c,dynCall_viiiiddiiii:U1c,dynCall_vidiii:R4c,dynCall_viiidiiid:H2c,dynCall_iiii:o4c,dynCall_iiidd:s3c,__GLOBAL__I_000101:uOc,dynCall_viidiiiiiii:p3c,dynCall_viidiiid:A2c,_emscripten_get_global_libc:qIc,dynCall_iiidiiiii:H4c,dynCall_iiiiiiii:u2c,dynCall_viidiiii:C2c,__GLOBAL__sub_I_opencv_caffe_pb_cc:Ykb,stackSave:Mj,dynCall_viiiii:n3c,___cxa_can_catch:$0c,_free:kIc,runPostSets:b1c,dynCall_viiiiii:M2c,dynCall_viiiid:u3c,dynCall_viiiiid:K2c,dynCall_diiiddi:E2c,dynCall_iiiiiddi:Y2c,dynCall_iiidiiii:T2c,dynCall_iiiiii:f3c,dynCall_viiiiddid:s4c,dynCall_viiiiiiidi:X1c,dynCall_viiiiddd:z1c,dynCall_diiiiiiii:G2c,dynCall_viiiidiiddi:d2c,dynCall_viiiiddi:G1c,___cxx_global_var_init_29:pFc,___cxx_global_var_init_28:oFc,dynCall_viiidddd:L1c,dynCall_iiiidd:Z1c,dynCall_viiiddddi:H1c,dynCall_viiidddi:q2c,dynCall_iiiidi:R1c,dynCall_vidii:j4c,dynCall_viiiddiii:m4c,setThrew:Pj,dynCall_viiiiiiiddi:g4c,dynCall_viiiiiddi:B1c,dynCall_viid:a4c,dynCall_viiiiddiddi:$1c,dynCall_viiddiiid:m3c,dynCall_viiiiidiiiii:p2c,dynCall_viiiddiiiid:d3c,dynCall_viiiddiiii:k2c,dynCall_iiiii:o2c,dynCall_viiiddidddd:J3c,___cxa_is_pointer_type:a1c,_llvm_ctlz_i64:t1c,dynCall_iiiid:s2c,dynCall_viididdi:Q3c,dynCall_viiiidddd:q4c,__GLOBAL__sub_I_status_cc:K_b,dynCall_iiidiii:C4c,dynCall_viiiiidiidd:r2c,dynCall_viiiiddddii:L2c,dynCall_viiiiiiidd:V1c,dynCall_viiiddd:_2c,stackAlloc:Lj,dynCall_iiiiidd:z4c,dynCall_viiiddi:e3c,dynCall_viididii:p4c,dynCall_iiiiidi:B4c,dynCall_viiiidddi:k3c,__GLOBAL__sub_I_color_lab_cpp:aCa,___divdi3:v1c,getTempRet0:Rj,___cxx_global_var_init_38:yFc,dynCall_iiidiiiiiii:J2c,___cxx_global_var_init_34:uFc,___cxx_global_var_init_35:vFc,___cxx_global_var_init_36:wFc,___cxx_global_var_init_37:xFc,___cxx_global_var_init_30:qFc,___cxx_global_var_init_31:rFc,___cxx_global_var_init_32:sFc,___cxx_global_var_init_33:tFc,dynCall_diiii:H3c,dynCall_viiiidi:l4c,dynCall_viiid:g3c,dynCall_dii:j2c,dynCall_vdii:g2c,__GLOBAL__sub_I_dnn_cpp:iOa,dynCall_viiii:l3c,dynCall_iiidiiiiii:D4c,_llvm_bswap_i32:s1c,__GLOBAL__sub_I_message_cc:ioc,dynCall_diiiiiii:h2c,dynCall_vididdii:I4c,establishStackSpace:Oj,dynCall_viiiidddiii:Z3c,dynCall_viiidddiiii:E3c,dynCall_viiiidii:v4c,_pthread_mutex_lock:f1c,__GLOBAL__sub_I_kmeans_cpp:gQ,__GLOBAL__sub_I_function_pb_cc:UHb,dynCall_viiiiiiddi:G3c,dynCall_diiiid:x4c,__GLOBAL__sub_I_umatrix_cpp:oQ,dynCall_viiidiiddi:z3c,dynCall_i:E4c,dynCall_iiiidiii:k4c,dynCall_viiiiiiiiii:V2c,dynCall_iiiiiii:E1c,__GLOBAL__sub_I_system_cpp:SM,__GLOBAL__sub_I_graph_pb_cc:KWa,dynCall_diiiiii:G4c,dynCall_vdiii:W3c,dynCall_iiiiiid:y1c,dynCall_viiididii:F2c,dynCall_viiddii:P1c,dynCall_diiiii:w4c,dynCall_iiiiiiiii:N4c,dynCall_iid:N3c,dynCall_iii:T3c,dynCall_viiiidddii:Q2c,dynCall_viiddid:Q1c,_memset:g1c,dynCall_diiddi:X2c,dynCall_viididi:M4c,__GLOBAL__sub_I_darknet_io_cpp:qrb,dynCall_viiidi:S2c,__GLOBAL__sub_I_prior_box_layer_cpp:lzb,dynCall_viiidd:R2c,dynCall_viiiiiidiiiii:J4c,dynCall_viiiiiii:P3c,_i64Subtract:c1c,dynCall_viiiiddiii:f2c,__GLOBAL__sub_I_init_cpp:AQa,setTempRet0:Qj,dynCall_viiiddiddd:M3c,dynCall_viiiiiid:R3c,dynCall_viiiiidiid:P4c,__GLOBAL__sub_I_op_def_pb_cc:lKb,dynCall_iiiiiddidd:W2c,___remdi3:j1c,__GLOBAL__sub_I_iostream_cpp:vOc,dynCall_viiiddddii:I2c,dynCall_viiidddiii:z2c,_pthread_cond_broadcast:m1c,__GLOBAL__sub_I_descriptor_pb_cc:afc,dynCall_viiiiiidiii:P2c,__GLOBAL__sub_I_tensor_shape_pb_cc:GXa,dynCall_iiidi:r3c,dynCall_viiiiiidiiii:b2c,dynCall_iiiiidii:h3c,dynCall_viiiiddii:r4c,dynCall_iiiiidiii:w3c,dynCall_viiiiiidi:O2c,dynCall_vidi:O1c,dynCall_iidi:M1c,_malloc:jIc,dynCall_viiddiii:w2c,_emscripten_replace_memory:qg,dynCall_viidiii:I1c,dynCall_viiiiddiiiid:e2c,dynCall_v:$3c,dynCall_viiddiid:x2c,__GLOBAL__sub_I_attr_value_pb_cc:gUa,dynCall_viidii:i3c,dynCall_viiiiiiiiiiid:K3c,dynCall_iiiiiiiididiii:y2c,dynCall_viidi:y3c,dynCall_iiiiiiddi:o3c,___udivdi3:n1c,dynCall_vid:q3c,dynCall_di:a2c,dynCall_diiid:B3c,__GLOBAL__sub_I_tensor_pb_cc:RUa,__GLOBAL__sub_I_opencv_onnx_pb_cc:arb,dynCall_viidiiiii:$2c,_bitshift64Shl:u1c,dynCall_viiiiiiiiiiddi:D2c,_fflush:pKc,dynCall_viiiiiiid:F3c,__GLOBAL__sub_I_types_pb_cc:lUa,dynCall_viiiiidiii:L4c,dynCall_viidiiiiii:n4c,dynCall_viiiiidiiii:c4c,___cxa_demangle:WZc,__GLOBAL__sub_I_detection_output_layer_cpp:vBb,dynCall_iiiiiddid:n2c,___muldi3:x1c,dynCall_viiiidd:Q4c,dynCall_vii:t3c,___uremdi3:r1c,dynCall_viiiiiiiii:S3c,dynCall_iiiiiidd:K4c,dynCall_viiiiiiii:D3c,dynCall_iiiddii:a3c,dynCall_viiiiddddi:v3c,_i64Add:d1c,dynCall_viiiiiidii:X3c,_pthread_mutex_unlock:e1c,dynCall_viiidii:A4c,dynCall_viiiidiii:A1c,stackRestore:Nj,dynCall_viiddi:U3c,___getTypeName:iIc,dynCall_viiiddid:O3c,dynCall_viii:_3c,dynCall_iiiiiiiiiiiii:y4c,dynCall_viiiddii:Y1c,dynCall_viiiidiid:D1c,___errno_location:vIc,dynCall_viididdii:O4c,dynCall_viidd:x3c,dynCall_ii:f4c,dynCall_iiiiid:j3c,_memmove:q1c,dynCall_viiiiidii:L3c,dynCall_viiiddidd:b3c,__GLOBAL__sub_I_bindings_cpp:hL,dynCall_viiddiddd:U2c,dynCall_iiiddi:v2c,dynCall_iiiddiid:b4c,dynCall_viiiidiiiidi:e4c,dynCall_iiiiddi:c2c,dynCall_iiiidii:A3c,dynCall_viiiidiiii:B2c,dynCall_viiidiii:C1c,dynCall_viiiidddiiii:F1c,dynCall_viiddidddd:T1c}})


// EMSCRIPTEN_END_ASM
(OpenCVJSModule.asmGlobalArg,OpenCVJSModule.asmLibraryArg,buffer);var __GLOBAL__sub_I_attr_value_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_attr_value_pb_cc"]=asm["__GLOBAL__sub_I_attr_value_pb_cc"];var ___cxx_global_var_init_29=OpenCVJSModule["___cxx_global_var_init_29"]=asm["___cxx_global_var_init_29"];var ___cxx_global_var_init_28=OpenCVJSModule["___cxx_global_var_init_28"]=asm["___cxx_global_var_init_28"];var ___cxx_global_var_init=OpenCVJSModule["___cxx_global_var_init"]=asm["___cxx_global_var_init"];var __GLOBAL__sub_I_op_def_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_op_def_pb_cc"]=asm["__GLOBAL__sub_I_op_def_pb_cc"];var stackSave=OpenCVJSModule["stackSave"]=asm["stackSave"];var getTempRet0=OpenCVJSModule["getTempRet0"]=asm["getTempRet0"];var ___udivdi3=OpenCVJSModule["___udivdi3"]=asm["___udivdi3"];var setThrew=OpenCVJSModule["setThrew"]=asm["setThrew"];var __GLOBAL__sub_I_system_cpp=OpenCVJSModule["__GLOBAL__sub_I_system_cpp"]=asm["__GLOBAL__sub_I_system_cpp"];var __GLOBAL__sub_I_graph_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_graph_pb_cc"]=asm["__GLOBAL__sub_I_graph_pb_cc"];var _bitshift64Lshr=OpenCVJSModule["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var __GLOBAL__sub_I_tensor_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_tensor_pb_cc"]=asm["__GLOBAL__sub_I_tensor_pb_cc"];var __GLOBAL__sub_I_init_cpp=OpenCVJSModule["__GLOBAL__sub_I_init_cpp"]=asm["__GLOBAL__sub_I_init_cpp"];var _bitshift64Shl=OpenCVJSModule["_bitshift64Shl"]=asm["_bitshift64Shl"];var _sbrk=OpenCVJSModule["_sbrk"]=asm["_sbrk"];var _fflush=OpenCVJSModule["_fflush"]=asm["_fflush"];var __GLOBAL__sub_I_types_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_types_pb_cc"]=asm["__GLOBAL__sub_I_types_pb_cc"];var ___cxa_is_pointer_type=OpenCVJSModule["___cxa_is_pointer_type"]=asm["___cxa_is_pointer_type"];var _llvm_ctlz_i64=OpenCVJSModule["_llvm_ctlz_i64"]=asm["_llvm_ctlz_i64"];var _bitshift64Ashr=OpenCVJSModule["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _memset=OpenCVJSModule["_memset"]=asm["_memset"];var __GLOBAL__sub_I_status_cc=OpenCVJSModule["__GLOBAL__sub_I_status_cc"]=asm["__GLOBAL__sub_I_status_cc"];var ___cxa_demangle=OpenCVJSModule["___cxa_demangle"]=asm["___cxa_demangle"];var ___cxx_global_var_init_34=OpenCVJSModule["___cxx_global_var_init_34"]=asm["___cxx_global_var_init_34"];var __GLOBAL__sub_I_imgwarp_cpp=OpenCVJSModule["__GLOBAL__sub_I_imgwarp_cpp"]=asm["__GLOBAL__sub_I_imgwarp_cpp"];var _memcpy=OpenCVJSModule["_memcpy"]=asm["_memcpy"];var __GLOBAL__sub_I_darknet_io_cpp=OpenCVJSModule["__GLOBAL__sub_I_darknet_io_cpp"]=asm["__GLOBAL__sub_I_darknet_io_cpp"];var _llvm_bswap_i32=OpenCVJSModule["_llvm_bswap_i32"]=asm["_llvm_bswap_i32"];var ___muldi3=OpenCVJSModule["___muldi3"]=asm["___muldi3"];var __GLOBAL__sub_I_prior_box_layer_cpp=OpenCVJSModule["__GLOBAL__sub_I_prior_box_layer_cpp"]=asm["__GLOBAL__sub_I_prior_box_layer_cpp"];var __GLOBAL__sub_I_versions_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_versions_pb_cc"]=asm["__GLOBAL__sub_I_versions_pb_cc"];var ___uremdi3=OpenCVJSModule["___uremdi3"]=asm["___uremdi3"];var __GLOBAL__sub_I_color_lab_cpp=OpenCVJSModule["__GLOBAL__sub_I_color_lab_cpp"]=asm["__GLOBAL__sub_I_color_lab_cpp"];var ___divdi3=OpenCVJSModule["___divdi3"]=asm["___divdi3"];var stackAlloc=OpenCVJSModule["stackAlloc"]=asm["stackAlloc"];var _i64Subtract=OpenCVJSModule["_i64Subtract"]=asm["_i64Subtract"];var __GLOBAL__sub_I_bind_cpp=OpenCVJSModule["__GLOBAL__sub_I_bind_cpp"]=asm["__GLOBAL__sub_I_bind_cpp"];var ___cxx_global_var_init_38=OpenCVJSModule["___cxx_global_var_init_38"]=asm["___cxx_global_var_init_38"];var setTempRet0=OpenCVJSModule["setTempRet0"]=asm["setTempRet0"];var _i64Add=OpenCVJSModule["_i64Add"]=asm["_i64Add"];var ___cxx_global_var_init_35=OpenCVJSModule["___cxx_global_var_init_35"]=asm["___cxx_global_var_init_35"];var ___cxx_global_var_init_36=OpenCVJSModule["___cxx_global_var_init_36"]=asm["___cxx_global_var_init_36"];var ___cxx_global_var_init_37=OpenCVJSModule["___cxx_global_var_init_37"]=asm["___cxx_global_var_init_37"];var ___cxx_global_var_init_30=OpenCVJSModule["___cxx_global_var_init_30"]=asm["___cxx_global_var_init_30"];var _pthread_mutex_unlock=OpenCVJSModule["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var ___cxx_global_var_init_32=OpenCVJSModule["___cxx_global_var_init_32"]=asm["___cxx_global_var_init_32"];var __GLOBAL__I_000101=OpenCVJSModule["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var __GLOBAL__sub_I_umatrix_cpp=OpenCVJSModule["__GLOBAL__sub_I_umatrix_cpp"]=asm["__GLOBAL__sub_I_umatrix_cpp"];var _emscripten_get_global_libc=OpenCVJSModule["_emscripten_get_global_libc"]=asm["_emscripten_get_global_libc"];var ___getTypeName=OpenCVJSModule["___getTypeName"]=asm["___getTypeName"];var __GLOBAL__sub_I_detection_output_layer_cpp=OpenCVJSModule["__GLOBAL__sub_I_detection_output_layer_cpp"]=asm["__GLOBAL__sub_I_detection_output_layer_cpp"];var __GLOBAL__sub_I_iostream_cpp=OpenCVJSModule["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var __GLOBAL__sub_I_dnn_cpp=OpenCVJSModule["__GLOBAL__sub_I_dnn_cpp"]=asm["__GLOBAL__sub_I_dnn_cpp"];var _pthread_cond_broadcast=OpenCVJSModule["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var __GLOBAL__sub_I_function_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_function_pb_cc"]=asm["__GLOBAL__sub_I_function_pb_cc"];var __GLOBAL__sub_I_descriptor_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_descriptor_pb_cc"]=asm["__GLOBAL__sub_I_descriptor_pb_cc"];var ___errno_location=OpenCVJSModule["___errno_location"]=asm["___errno_location"];var __GLOBAL__sub_I_message_cc=OpenCVJSModule["__GLOBAL__sub_I_message_cc"]=asm["__GLOBAL__sub_I_message_cc"];var __GLOBAL__sub_I_tensor_shape_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_tensor_shape_pb_cc"]=asm["__GLOBAL__sub_I_tensor_shape_pb_cc"];var ___cxa_can_catch=OpenCVJSModule["___cxa_can_catch"]=asm["___cxa_can_catch"];var _free=OpenCVJSModule["_free"]=asm["_free"];var runPostSets=OpenCVJSModule["runPostSets"]=asm["runPostSets"];var establishStackSpace=OpenCVJSModule["establishStackSpace"]=asm["establishStackSpace"];var _memmove=OpenCVJSModule["_memmove"]=asm["_memmove"];var __GLOBAL__sub_I_bindings_cpp=OpenCVJSModule["__GLOBAL__sub_I_bindings_cpp"]=asm["__GLOBAL__sub_I_bindings_cpp"];var stackRestore=OpenCVJSModule["stackRestore"]=asm["stackRestore"];var _malloc=OpenCVJSModule["_malloc"]=asm["_malloc"];var _pthread_mutex_lock=OpenCVJSModule["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var __GLOBAL__sub_I_kmeans_cpp=OpenCVJSModule["__GLOBAL__sub_I_kmeans_cpp"]=asm["__GLOBAL__sub_I_kmeans_cpp"];var _emscripten_replace_memory=OpenCVJSModule["_emscripten_replace_memory"]=asm["_emscripten_replace_memory"];var __GLOBAL__sub_I_opencv_onnx_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_opencv_onnx_pb_cc"]=asm["__GLOBAL__sub_I_opencv_onnx_pb_cc"];var ___remdi3=OpenCVJSModule["___remdi3"]=asm["___remdi3"];var __GLOBAL__sub_I_opencv_caffe_pb_cc=OpenCVJSModule["__GLOBAL__sub_I_opencv_caffe_pb_cc"]=asm["__GLOBAL__sub_I_opencv_caffe_pb_cc"];var ___cxx_global_var_init_31=OpenCVJSModule["___cxx_global_var_init_31"]=asm["___cxx_global_var_init_31"];var ___cxx_global_var_init_33=OpenCVJSModule["___cxx_global_var_init_33"]=asm["___cxx_global_var_init_33"];var dynCall_iiiiiid=OpenCVJSModule["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_viiiiddd=OpenCVJSModule["dynCall_viiiiddd"]=asm["dynCall_viiiiddd"];var dynCall_viiiidiii=OpenCVJSModule["dynCall_viiiidiii"]=asm["dynCall_viiiidiii"];var dynCall_viiiiiddi=OpenCVJSModule["dynCall_viiiiiddi"]=asm["dynCall_viiiiiddi"];var dynCall_viiidiii=OpenCVJSModule["dynCall_viiidiii"]=asm["dynCall_viiidiii"];var dynCall_viiiidiid=OpenCVJSModule["dynCall_viiiidiid"]=asm["dynCall_viiiidiid"];var dynCall_iiiiiii=OpenCVJSModule["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_viiiidddiiii=OpenCVJSModule["dynCall_viiiidddiiii"]=asm["dynCall_viiiidddiiii"];var dynCall_viiiiddi=OpenCVJSModule["dynCall_viiiiddi"]=asm["dynCall_viiiiddi"];var dynCall_viiiddddi=OpenCVJSModule["dynCall_viiiddddi"]=asm["dynCall_viiiddddi"];var dynCall_viidiii=OpenCVJSModule["dynCall_viidiii"]=asm["dynCall_viidiii"];var dynCall_viiiiiiiiiii=OpenCVJSModule["dynCall_viiiiiiiiiii"]=asm["dynCall_viiiiiiiiiii"];var dynCall_viiiiiiiiiid=OpenCVJSModule["dynCall_viiiiiiiiiid"]=asm["dynCall_viiiiiiiiiid"];var dynCall_viiidddd=OpenCVJSModule["dynCall_viiidddd"]=asm["dynCall_viiidddd"];var dynCall_iidi=OpenCVJSModule["dynCall_iidi"]=asm["dynCall_iidi"];var dynCall_viiddidd=OpenCVJSModule["dynCall_viiddidd"]=asm["dynCall_viiddidd"];var dynCall_vidi=OpenCVJSModule["dynCall_vidi"]=asm["dynCall_vidi"];var dynCall_viiddii=OpenCVJSModule["dynCall_viiddii"]=asm["dynCall_viiddii"];var dynCall_viiddid=OpenCVJSModule["dynCall_viiddid"]=asm["dynCall_viiddid"];var dynCall_iiiidi=OpenCVJSModule["dynCall_iiiidi"]=asm["dynCall_iiiidi"];var dynCall_viiiiidi=OpenCVJSModule["dynCall_viiiiidi"]=asm["dynCall_viiiiidi"];var dynCall_viiddidddd=OpenCVJSModule["dynCall_viiddidddd"]=asm["dynCall_viiddidddd"];var dynCall_viiiiddiiii=OpenCVJSModule["dynCall_viiiiddiiii"]=asm["dynCall_viiiiddiiii"];var dynCall_viiiiiiidd=OpenCVJSModule["dynCall_viiiiiiidd"]=asm["dynCall_viiiiiiidd"];var dynCall_viiiiddiiid=OpenCVJSModule["dynCall_viiiiddiiid"]=asm["dynCall_viiiiddiiid"];var dynCall_viiiiiiidi=OpenCVJSModule["dynCall_viiiiiiidi"]=asm["dynCall_viiiiiiidi"];var dynCall_viiiddii=OpenCVJSModule["dynCall_viiiddii"]=asm["dynCall_viiiddii"];var dynCall_iiiidd=OpenCVJSModule["dynCall_iiiidd"]=asm["dynCall_iiiidd"];var dynCall_viiiiidd=OpenCVJSModule["dynCall_viiiiidd"]=asm["dynCall_viiiiidd"];var dynCall_viiiiddiddi=OpenCVJSModule["dynCall_viiiiddiddi"]=asm["dynCall_viiiiddiddi"];var dynCall_di=OpenCVJSModule["dynCall_di"]=asm["dynCall_di"];var dynCall_viiiiiidiiii=OpenCVJSModule["dynCall_viiiiiidiiii"]=asm["dynCall_viiiiiidiiii"];var dynCall_iiiiddi=OpenCVJSModule["dynCall_iiiiddi"]=asm["dynCall_iiiiddi"];var dynCall_viiiidiiddi=OpenCVJSModule["dynCall_viiiidiiddi"]=asm["dynCall_viiiidiiddi"];var dynCall_viiiiddiiiid=OpenCVJSModule["dynCall_viiiiddiiiid"]=asm["dynCall_viiiiddiiiid"];var dynCall_viiiiddiii=OpenCVJSModule["dynCall_viiiiddiii"]=asm["dynCall_viiiiddiii"];var dynCall_vdii=OpenCVJSModule["dynCall_vdii"]=asm["dynCall_vdii"];var dynCall_diiiiiii=OpenCVJSModule["dynCall_diiiiiii"]=asm["dynCall_diiiiiii"];var dynCall_iiiiiddiddi=OpenCVJSModule["dynCall_iiiiiddiddi"]=asm["dynCall_iiiiiddiddi"];var dynCall_dii=OpenCVJSModule["dynCall_dii"]=asm["dynCall_dii"];var dynCall_viiiddiiii=OpenCVJSModule["dynCall_viiiddiiii"]=asm["dynCall_viiiddiiii"];var dynCall_viiiddiiid=OpenCVJSModule["dynCall_viiiddiiid"]=asm["dynCall_viiiddiiid"];var dynCall_viiiidiidd=OpenCVJSModule["dynCall_viiiidiidd"]=asm["dynCall_viiiidiidd"];var dynCall_iiiiiddid=OpenCVJSModule["dynCall_iiiiiddid"]=asm["dynCall_iiiiiddid"];var dynCall_iiiii=OpenCVJSModule["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiiiidiiiii=OpenCVJSModule["dynCall_viiiiidiiiii"]=asm["dynCall_viiiiidiiiii"];var dynCall_viiidddi=OpenCVJSModule["dynCall_viiidddi"]=asm["dynCall_viiidddi"];var dynCall_viiiiidiidd=OpenCVJSModule["dynCall_viiiiidiidd"]=asm["dynCall_viiiiidiidd"];var dynCall_iiiid=OpenCVJSModule["dynCall_iiiid"]=asm["dynCall_iiiid"];var dynCall_iiiddiiid=OpenCVJSModule["dynCall_iiiddiiid"]=asm["dynCall_iiiddiiid"];var dynCall_iiiiiiii=OpenCVJSModule["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_iiiddi=OpenCVJSModule["dynCall_iiiddi"]=asm["dynCall_iiiddi"];var dynCall_viiddiii=OpenCVJSModule["dynCall_viiddiii"]=asm["dynCall_viiddiii"];var dynCall_viiddiid=OpenCVJSModule["dynCall_viiddiid"]=asm["dynCall_viiddiid"];var dynCall_iiiiiiiididiii=OpenCVJSModule["dynCall_iiiiiiiididiii"]=asm["dynCall_iiiiiiiididiii"];var dynCall_viiidddiii=OpenCVJSModule["dynCall_viiidddiii"]=asm["dynCall_viiidddiii"];var dynCall_viidiiid=OpenCVJSModule["dynCall_viidiiid"]=asm["dynCall_viidiiid"];var dynCall_viiiidiiii=OpenCVJSModule["dynCall_viiiidiiii"]=asm["dynCall_viiiidiiii"];var dynCall_viidiiii=OpenCVJSModule["dynCall_viidiiii"]=asm["dynCall_viidiiii"];var dynCall_viiiiiiiiiiddi=OpenCVJSModule["dynCall_viiiiiiiiiiddi"]=asm["dynCall_viiiiiiiiiiddi"];var dynCall_diiiddi=OpenCVJSModule["dynCall_diiiddi"]=asm["dynCall_diiiddi"];var dynCall_viiididii=OpenCVJSModule["dynCall_viiididii"]=asm["dynCall_viiididii"];var dynCall_diiiiiiii=OpenCVJSModule["dynCall_diiiiiiii"]=asm["dynCall_diiiiiiii"];var dynCall_viiidiiid=OpenCVJSModule["dynCall_viiidiiid"]=asm["dynCall_viiidiiid"];var dynCall_viiiddddii=OpenCVJSModule["dynCall_viiiddddii"]=asm["dynCall_viiiddddii"];var dynCall_iiidiiiiiii=OpenCVJSModule["dynCall_iiidiiiiiii"]=asm["dynCall_iiidiiiiiii"];var dynCall_viiiiid=OpenCVJSModule["dynCall_viiiiid"]=asm["dynCall_viiiiid"];var dynCall_viiiiddddii=OpenCVJSModule["dynCall_viiiiddddii"]=asm["dynCall_viiiiddddii"];var dynCall_viiiiii=OpenCVJSModule["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_viiidiiii=OpenCVJSModule["dynCall_viiidiiii"]=asm["dynCall_viiidiiii"];var dynCall_viiiiiidi=OpenCVJSModule["dynCall_viiiiiidi"]=asm["dynCall_viiiiiidi"];var dynCall_viiiiiidiii=OpenCVJSModule["dynCall_viiiiiidiii"]=asm["dynCall_viiiiiidiii"];var dynCall_viiiidddii=OpenCVJSModule["dynCall_viiiidddii"]=asm["dynCall_viiiidddii"];var dynCall_viiidd=OpenCVJSModule["dynCall_viiidd"]=asm["dynCall_viiidd"];var dynCall_viiidi=OpenCVJSModule["dynCall_viiidi"]=asm["dynCall_viiidi"];var dynCall_iiidiiii=OpenCVJSModule["dynCall_iiidiiii"]=asm["dynCall_iiidiiii"];var dynCall_viiddiddd=OpenCVJSModule["dynCall_viiddiddd"]=asm["dynCall_viiddiddd"];var dynCall_viiiiiiiiii=OpenCVJSModule["dynCall_viiiiiiiiii"]=asm["dynCall_viiiiiiiiii"];var dynCall_iiiiiddidd=OpenCVJSModule["dynCall_iiiiiddidd"]=asm["dynCall_iiiiiddidd"];var dynCall_diiddi=OpenCVJSModule["dynCall_diiddi"]=asm["dynCall_diiddi"];var dynCall_iiiiiddi=OpenCVJSModule["dynCall_iiiiiddi"]=asm["dynCall_iiiiiddi"];var dynCall_diii=OpenCVJSModule["dynCall_diii"]=asm["dynCall_diii"];var dynCall_viiiddd=OpenCVJSModule["dynCall_viiiddd"]=asm["dynCall_viiiddd"];var dynCall_viidiiiii=OpenCVJSModule["dynCall_viidiiiii"]=asm["dynCall_viidiiiii"];var dynCall_iiiddii=OpenCVJSModule["dynCall_iiiddii"]=asm["dynCall_iiiddii"];var dynCall_viiiddidd=OpenCVJSModule["dynCall_viiiddidd"]=asm["dynCall_viiiddidd"];var dynCall_viiidiiiidi=OpenCVJSModule["dynCall_viiidiiiidi"]=asm["dynCall_viiidiiiidi"];var dynCall_viiiddiiiid=OpenCVJSModule["dynCall_viiiddiiiid"]=asm["dynCall_viiiddiiiid"];var dynCall_viiiddi=OpenCVJSModule["dynCall_viiiddi"]=asm["dynCall_viiiddi"];var dynCall_iiiiii=OpenCVJSModule["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiid=OpenCVJSModule["dynCall_viiid"]=asm["dynCall_viiid"];var dynCall_iiiiidii=OpenCVJSModule["dynCall_iiiiidii"]=asm["dynCall_iiiiidii"];var dynCall_viidii=OpenCVJSModule["dynCall_viidii"]=asm["dynCall_viidii"];var dynCall_iiiiid=OpenCVJSModule["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_viiiidddi=OpenCVJSModule["dynCall_viiiidddi"]=asm["dynCall_viiiidddi"];var dynCall_viiii=OpenCVJSModule["dynCall_viiii"]=asm["dynCall_viiii"];var dynCall_viiddiiid=OpenCVJSModule["dynCall_viiddiiid"]=asm["dynCall_viiddiiid"];var dynCall_viiiii=OpenCVJSModule["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_iiiiiiddi=OpenCVJSModule["dynCall_iiiiiiddi"]=asm["dynCall_iiiiiiddi"];var dynCall_viidiiiiiii=OpenCVJSModule["dynCall_viidiiiiiii"]=asm["dynCall_viidiiiiiii"];var dynCall_vid=OpenCVJSModule["dynCall_vid"]=asm["dynCall_vid"];var dynCall_iiidi=OpenCVJSModule["dynCall_iiidi"]=asm["dynCall_iiidi"];var dynCall_iiidd=OpenCVJSModule["dynCall_iiidd"]=asm["dynCall_iiidd"];var dynCall_vii=OpenCVJSModule["dynCall_vii"]=asm["dynCall_vii"];var dynCall_viiiid=OpenCVJSModule["dynCall_viiiid"]=asm["dynCall_viiiid"];var dynCall_viiiiddddi=OpenCVJSModule["dynCall_viiiiddddi"]=asm["dynCall_viiiiddddi"];var dynCall_iiiiidiii=OpenCVJSModule["dynCall_iiiiidiii"]=asm["dynCall_iiiiidiii"];var dynCall_viidd=OpenCVJSModule["dynCall_viidd"]=asm["dynCall_viidd"];var dynCall_viidi=OpenCVJSModule["dynCall_viidi"]=asm["dynCall_viidi"];var dynCall_viiidiiddi=OpenCVJSModule["dynCall_viiidiiddi"]=asm["dynCall_viiidiiddi"];var dynCall_iiiidii=OpenCVJSModule["dynCall_iiiidii"]=asm["dynCall_iiiidii"];var dynCall_diiid=OpenCVJSModule["dynCall_diiid"]=asm["dynCall_diiid"];var dynCall_viiidddii=OpenCVJSModule["dynCall_viiidddii"]=asm["dynCall_viiidddii"];var dynCall_viiiiiiii=OpenCVJSModule["dynCall_viiiiiiii"]=asm["dynCall_viiiiiiii"];var dynCall_viiidddiiii=OpenCVJSModule["dynCall_viiidddiiii"]=asm["dynCall_viiidddiiii"];var dynCall_viiiiiiid=OpenCVJSModule["dynCall_viiiiiiid"]=asm["dynCall_viiiiiiid"];var dynCall_viiiiiiddi=OpenCVJSModule["dynCall_viiiiiiddi"]=asm["dynCall_viiiiiiddi"];var dynCall_diiii=OpenCVJSModule["dynCall_diiii"]=asm["dynCall_diiii"];var dynCall_viiiiidiiddi=OpenCVJSModule["dynCall_viiiiidiiddi"]=asm["dynCall_viiiiidiiddi"];var dynCall_viiiddidddd=OpenCVJSModule["dynCall_viiiddidddd"]=asm["dynCall_viiiddidddd"];var dynCall_viiiiiiiiiiid=OpenCVJSModule["dynCall_viiiiiiiiiiid"]=asm["dynCall_viiiiiiiiiiid"];var dynCall_viiiiidii=OpenCVJSModule["dynCall_viiiiidii"]=asm["dynCall_viiiiidii"];var dynCall_viiiddiddd=OpenCVJSModule["dynCall_viiiddiddd"]=asm["dynCall_viiiddiddd"];var dynCall_iid=OpenCVJSModule["dynCall_iid"]=asm["dynCall_iid"];var dynCall_viiiddid=OpenCVJSModule["dynCall_viiiddid"]=asm["dynCall_viiiddid"];var dynCall_viiiiiii=OpenCVJSModule["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viididdi=OpenCVJSModule["dynCall_viididdi"]=asm["dynCall_viididdi"];var dynCall_viiiiiid=OpenCVJSModule["dynCall_viiiiiid"]=asm["dynCall_viiiiiid"];var dynCall_viiiiiiiii=OpenCVJSModule["dynCall_viiiiiiiii"]=asm["dynCall_viiiiiiiii"];var dynCall_iii=OpenCVJSModule["dynCall_iii"]=asm["dynCall_iii"];var dynCall_viiddi=OpenCVJSModule["dynCall_viiddi"]=asm["dynCall_viiddi"];var dynCall_viiididi=OpenCVJSModule["dynCall_viiididi"]=asm["dynCall_viiididi"];var dynCall_vdiii=OpenCVJSModule["dynCall_vdiii"]=asm["dynCall_vdiii"];var dynCall_viiiiiidii=OpenCVJSModule["dynCall_viiiiiidii"]=asm["dynCall_viiiiiidii"];var dynCall_viiiiddidd=OpenCVJSModule["dynCall_viiiiddidd"]=asm["dynCall_viiiiddidd"];var dynCall_viiiidddiii=OpenCVJSModule["dynCall_viiiidddiii"]=asm["dynCall_viiiidddiii"];var dynCall_viii=OpenCVJSModule["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=OpenCVJSModule["dynCall_v"]=asm["dynCall_v"];var dynCall_viid=OpenCVJSModule["dynCall_viid"]=asm["dynCall_viid"];var dynCall_iiiddiid=OpenCVJSModule["dynCall_iiiddiid"]=asm["dynCall_iiiddiid"];var dynCall_viiiiidiiii=OpenCVJSModule["dynCall_viiiiidiiii"]=asm["dynCall_viiiiidiiii"];var dynCall_vi=OpenCVJSModule["dynCall_vi"]=asm["dynCall_vi"];var dynCall_viiiidiiiidi=OpenCVJSModule["dynCall_viiiidiiiidi"]=asm["dynCall_viiiidiiiidi"];var dynCall_ii=OpenCVJSModule["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viiiiiiiddi=OpenCVJSModule["dynCall_viiiiiiiddi"]=asm["dynCall_viiiiiiiddi"];var dynCall_vididdi=OpenCVJSModule["dynCall_vididdi"]=asm["dynCall_vididdi"];var dynCall_viiiiiidd=OpenCVJSModule["dynCall_viiiiiidd"]=asm["dynCall_viiiiiidd"];var dynCall_vidii=OpenCVJSModule["dynCall_vidii"]=asm["dynCall_vidii"];var dynCall_iiiidiii=OpenCVJSModule["dynCall_iiiidiii"]=asm["dynCall_iiiidiii"];var dynCall_viiiidi=OpenCVJSModule["dynCall_viiiidi"]=asm["dynCall_viiiidi"];var dynCall_viiiddiii=OpenCVJSModule["dynCall_viiiddiii"]=asm["dynCall_viiiddiii"];var dynCall_viidiiiiii=OpenCVJSModule["dynCall_viidiiiiii"]=asm["dynCall_viidiiiiii"];var dynCall_iiii=OpenCVJSModule["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viididii=OpenCVJSModule["dynCall_viididii"]=asm["dynCall_viididii"];var dynCall_viiiidddd=OpenCVJSModule["dynCall_viiiidddd"]=asm["dynCall_viiiidddd"];var dynCall_viiiiddii=OpenCVJSModule["dynCall_viiiiddii"]=asm["dynCall_viiiiddii"];var dynCall_viiiiddid=OpenCVJSModule["dynCall_viiiiddid"]=asm["dynCall_viiiiddid"];var dynCall_iiid=OpenCVJSModule["dynCall_iiid"]=asm["dynCall_iiid"];var dynCall_viiiiiiiiidd=OpenCVJSModule["dynCall_viiiiiiiiidd"]=asm["dynCall_viiiiiiiiidd"];var dynCall_viiiidii=OpenCVJSModule["dynCall_viiiidii"]=asm["dynCall_viiiidii"];var dynCall_diiiii=OpenCVJSModule["dynCall_diiiii"]=asm["dynCall_diiiii"];var dynCall_diiiid=OpenCVJSModule["dynCall_diiiid"]=asm["dynCall_diiiid"];var dynCall_iiiiiiiiiiiii=OpenCVJSModule["dynCall_iiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiii"];var dynCall_iiiiidd=OpenCVJSModule["dynCall_iiiiidd"]=asm["dynCall_iiiiidd"];var dynCall_viiidii=OpenCVJSModule["dynCall_viiidii"]=asm["dynCall_viiidii"];var dynCall_iiiiidi=OpenCVJSModule["dynCall_iiiiidi"]=asm["dynCall_iiiiidi"];var dynCall_iiidiii=OpenCVJSModule["dynCall_iiidiii"]=asm["dynCall_iiidiii"];var dynCall_iiidiiiiii=OpenCVJSModule["dynCall_iiidiiiiii"]=asm["dynCall_iiidiiiiii"];var dynCall_i=OpenCVJSModule["dynCall_i"]=asm["dynCall_i"];var dynCall_iiidii=OpenCVJSModule["dynCall_iiidii"]=asm["dynCall_iiidii"];var dynCall_diiiiii=OpenCVJSModule["dynCall_diiiiii"]=asm["dynCall_diiiiii"];var dynCall_iiidiiiii=OpenCVJSModule["dynCall_iiidiiiii"]=asm["dynCall_iiidiiiii"];var dynCall_vididdii=OpenCVJSModule["dynCall_vididdii"]=asm["dynCall_vididdii"];var dynCall_viiiiiidiiiii=OpenCVJSModule["dynCall_viiiiiidiiiii"]=asm["dynCall_viiiiiidiiiii"];var dynCall_iiiiiidd=OpenCVJSModule["dynCall_iiiiiidd"]=asm["dynCall_iiiiiidd"];var dynCall_viiiiidiii=OpenCVJSModule["dynCall_viiiiidiii"]=asm["dynCall_viiiiidiii"];var dynCall_viididi=OpenCVJSModule["dynCall_viididi"]=asm["dynCall_viididi"];var dynCall_iiiiiiiii=OpenCVJSModule["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_viididdii=OpenCVJSModule["dynCall_viididdii"]=asm["dynCall_viididdii"];var dynCall_viiiiidiid=OpenCVJSModule["dynCall_viiiiidiid"]=asm["dynCall_viiiiidiid"];var dynCall_viiiidd=OpenCVJSModule["dynCall_viiiidd"]=asm["dynCall_viiiidd"];var dynCall_vidiii=OpenCVJSModule["dynCall_vidiii"]=asm["dynCall_vidiii"];Runtime.stackAlloc=OpenCVJSModule["stackAlloc"];Runtime.stackSave=OpenCVJSModule["stackSave"];Runtime.stackRestore=OpenCVJSModule["stackRestore"];Runtime.establishStackSpace=OpenCVJSModule["establishStackSpace"];Runtime.setTempRet0=OpenCVJSModule["setTempRet0"];Runtime.getTempRet0=OpenCVJSModule["getTempRet0"];OpenCVJSModule["asm"]=asm;OpenCVJSModule["then"]=(function(func){if(OpenCVJSModule["calledRun"]){func(OpenCVJSModule)}else{var old=OpenCVJSModule["onRuntimeInitialized"];OpenCVJSModule["onRuntimeInitialized"]=(function(){if(old)old();func(OpenCVJSModule)})}return OpenCVJSModule});function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!OpenCVJSModule["calledRun"])run();if(!OpenCVJSModule["calledRun"])dependenciesFulfilled=runCaller};OpenCVJSModule["callMain"]=OpenCVJSModule.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(OpenCVJSModule["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=OpenCVJSModule["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){OpenCVJSModule["noExitRuntime"]=true;return}else{var toLog=e;if(e&&typeof e==="object"&&e.stack){toLog=[e,e.stack]}OpenCVJSModule.printErr("exception thrown: "+toLog);OpenCVJSModule["quit"](1,e)}}finally{calledMain=true}};function run(args){args=args||OpenCVJSModule["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(OpenCVJSModule["calledRun"])return;function doRun(){if(OpenCVJSModule["calledRun"])return;OpenCVJSModule["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(OpenCVJSModule["onRuntimeInitialized"])OpenCVJSModule["onRuntimeInitialized"]();if(OpenCVJSModule["_main"]&&shouldRunNow)OpenCVJSModule["callMain"](args);postRun()}if(OpenCVJSModule["setStatus"]){OpenCVJSModule["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){OpenCVJSModule["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}OpenCVJSModule["run"]=OpenCVJSModule.run=run;function exit(status,implicit){if(implicit&&OpenCVJSModule["noExitRuntime"]){return}if(OpenCVJSModule["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(OpenCVJSModule["onExit"])OpenCVJSModule["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}OpenCVJSModule["quit"](status,new ExitStatus(status))}OpenCVJSModule["exit"]=OpenCVJSModule.exit=exit;var abortDecorators=[];function abort(what){if(OpenCVJSModule["onAbort"]){OpenCVJSModule["onAbort"](what)}if(what!==undefined){OpenCVJSModule.print(what);OpenCVJSModule.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}OpenCVJSModule["abort"]=OpenCVJSModule.abort=abort;if(OpenCVJSModule["preInit"]){if(typeof OpenCVJSModule["preInit"]=="function")OpenCVJSModule["preInit"]=[OpenCVJSModule["preInit"]];while(OpenCVJSModule["preInit"].length>0){OpenCVJSModule["preInit"].pop()()}}var shouldRunNow=true;if(OpenCVJSModule["noInitialRun"]){shouldRunNow=false}run();OpenCVJSModule["imread"]=(function(imageSource){var img=null;if(typeof imageSource==="string"){img=document.getElementById(imageSource)}else{img=imageSource}var canvas=null;var ctx=null;if(img instanceof HTMLImageElement){canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;ctx=canvas.getContext("2d");ctx.drawImage(img,0,0,img.width,img.height)}else if(img instanceof HTMLCanvasElement){canvas=img;ctx=canvas.getContext("2d")}else{throw new Error("Please input the valid canvas or img id.");return}var imgData=ctx.getImageData(0,0,canvas.width,canvas.height);return cv.matFromImageData(imgData)});OpenCVJSModule["imshow"]=(function(canvasSource,mat){var canvas=null;if(typeof canvasSource==="string"){canvas=document.getElementById(canvasSource)}else{canvas=canvasSource}if(!(canvas instanceof HTMLCanvasElement)){throw new Error("Please input the valid canvas element or id.");return}if(!(mat instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}var img=new cv.Mat;var depth=mat.type()%8;var scale=depth<=cv.CV_8S?1:depth<=cv.CV_32S?1/256:255;var shift=depth===cv.CV_8S||depth===cv.CV_16S?128:0;mat.convertTo(img,cv.CV_8U,scale,shift);switch(img.type()){case cv.CV_8UC1:cv.cvtColor(img,img,cv.COLOR_GRAY2RGBA);break;case cv.CV_8UC3:cv.cvtColor(img,img,cv.COLOR_RGB2RGBA);break;case cv.CV_8UC4:break;default:throw new Error("Bad number of channels (Source image must have 1, 3 or 4 channels)");return}var imgData=new ImageData(new Uint8ClampedArray(img.data),img.cols,img.rows);var ctx=canvas.getContext("2d");ctx.clearRect(0,0,canvas.width,canvas.height);canvas.width=imgData.width;canvas.height=imgData.height;ctx.putImageData(imgData,0,0);img.delete()});OpenCVJSModule["VideoCapture"]=(function(videoSource){var video=null;if(typeof videoSource==="string"){video=document.getElementById(videoSource)}else{video=videoSource}if(!(video instanceof HTMLVideoElement)){throw new Error("Please input the valid video element or id.");return}var canvas=document.createElement("canvas");canvas.width=video.width;canvas.height=video.height;var ctx=canvas.getContext("2d");this.video=video;this.read=(function(frame){if(!(frame instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}if(frame.type()!==cv.CV_8UC4){throw new Error("Bad type of input mat: the type should be cv.CV_8UC4.");return}if(frame.cols!==video.width||frame.rows!==video.height){throw new Error("Bad size of input mat: the size should be same as the video.");return}ctx.drawImage(video,0,0,video.width,video.height);frame.data.set(ctx.getImageData(0,0,video.width,video.height).data)})});function Range(start,end){this.start=typeof start==="undefined"?0:start;this.end=typeof end==="undefined"?0:end}OpenCVJSModule["Range"]=Range;function Point(x,y){this.x=typeof x==="undefined"?0:x;this.y=typeof y==="undefined"?0:y}OpenCVJSModule["Point"]=Point;function Size(width,height){this.width=typeof width==="undefined"?0:width;this.height=typeof height==="undefined"?0:height}OpenCVJSModule["Size"]=Size;function Rect(){switch(arguments.length){case 0:{this.x=0;this.y=0;this.width=0;this.height=0;break};case 1:{var rect=arguments[0];this.x=rect.x;this.y=rect.y;this.width=rect.width;this.height=rect.height;break};case 2:{var point=arguments[0];var size=arguments[1];this.x=point.x;this.y=point.y;this.width=size.width;this.height=size.height;break};case 4:{this.x=arguments[0];this.y=arguments[1];this.width=arguments[2];this.height=arguments[3];break};default:{throw new Error("Invalid arguments")}}}OpenCVJSModule["Rect"]=Rect;function RotatedRect(){switch(arguments.length){case 0:{this.center={x:0,y:0};this.size={width:0,height:0};this.angle=0;break};case 3:{this.center=arguments[0];this.size=arguments[1];this.angle=arguments[2];break};default:{throw new Error("Invalid arguments")}}}RotatedRect.points=(function(obj){return OpenCVJSModule.rotatedRectPoints(obj)});RotatedRect.boundingRect=(function(obj){return OpenCVJSModule.rotatedRectBoundingRect(obj)});RotatedRect.boundingRect2f=(function(obj){return OpenCVJSModule.rotatedRectBoundingRect2f(obj)});OpenCVJSModule["RotatedRect"]=RotatedRect;function Scalar(v0,v1,v2,v3){this.push(typeof v0==="undefined"?0:v0);this.push(typeof v1==="undefined"?0:v1);this.push(typeof v2==="undefined"?0:v2);this.push(typeof v3==="undefined"?0:v3)}Scalar.prototype=new Array;Scalar.all=(function(v){return new Scalar(v,v,v,v)});OpenCVJSModule["Scalar"]=Scalar;function MinMaxLoc(){switch(arguments.length){case 0:{this.minVal=0;this.maxVal=0;this.minLoc=new Point;this.maxLoc=new Point;break};case 4:{this.minVal=arguments[0];this.maxVal=arguments[1];this.minLoc=arguments[2];this.maxLoc=arguments[3];break};default:{throw new Error("Invalid arguments")}}}OpenCVJSModule["MinMaxLoc"]=MinMaxLoc;function Circle(){switch(arguments.length){case 0:{this.center=new Point;this.radius=0;break};case 2:{this.center=arguments[0];this.radius=arguments[1];break};default:{throw new Error("Invalid arguments")}}}OpenCVJSModule["Circle"]=Circle;function TermCriteria(){switch(arguments.length){case 0:{this.type=0;this.maxCount=0;this.epsilon=0;break};case 3:{this.type=arguments[0];this.maxCount=arguments[1];this.epsilon=arguments[2];break};default:{throw new Error("Invalid arguments")}}}OpenCVJSModule["TermCriteria"]=TermCriteria;OpenCVJSModule["matFromArray"]=(function(rows,cols,type,array){var mat=new cv.Mat(rows,cols,type);switch(type){case cv.CV_8U:case cv.CV_8UC1:case cv.CV_8UC2:case cv.CV_8UC3:case cv.CV_8UC4:{mat.data.set(array);break};case cv.CV_8S:case cv.CV_8SC1:case cv.CV_8SC2:case cv.CV_8SC3:case cv.CV_8SC4:{mat.data8S.set(array);break};case cv.CV_16U:case cv.CV_16UC1:case cv.CV_16UC2:case cv.CV_16UC3:case cv.CV_16UC4:{mat.data16U.set(array);break};case cv.CV_16S:case cv.CV_16SC1:case cv.CV_16SC2:case cv.CV_16SC3:case cv.CV_16SC4:{mat.data16S.set(array);break};case cv.CV_32S:case cv.CV_32SC1:case cv.CV_32SC2:case cv.CV_32SC3:case cv.CV_32SC4:{mat.data32S.set(array);break};case cv.CV_32F:case cv.CV_32FC1:case cv.CV_32FC2:case cv.CV_32FC3:case cv.CV_32FC4:{mat.data32F.set(array);break};case cv.CV_64F:case cv.CV_64FC1:case cv.CV_64FC2:case cv.CV_64FC3:case cv.CV_64FC4:{mat.data64F.set(array);break};default:{throw new Error("Type is unsupported")}}return mat});OpenCVJSModule["matFromImageData"]=(function(imageData){var mat=new cv.Mat(imageData.height,imageData.width,cv.CV_8UC4);mat.data.set(imageData.data);return mat})



OpenCVJSModule.Mat.prototype.DATA = function() {
    switch (this.type())
    {
        case cv.CV_8UC1: 
        case cv.CV_8UC2: 
        case cv.CV_8UC3: 
        case cv.CV_8UC4: 
            return this.data;
        case cv.CV_8SC1: 
        case cv.CV_8SC2: 
        case cv.CV_8SC3: 
        case cv.CV_8SC4: 
            return this.data8S;
        case cv.CV_16UC1: 
        case cv.CV_16UC2: 
        case cv.CV_16UC3: 
        case cv.CV_16UC4: 
            return this.data16U;
        case cv.CV_16SC1: 
        case cv.CV_16SC2: 
        case cv.CV_16SC3: 
        case cv.CV_16SC4: 
            return this.data16S;
        case cv.CV_32SC1: 
        case cv.CV_32SC2: 
        case cv.CV_32SC3: 
        case cv.CV_32SC4: 
            return this.data32S;
        case cv.CV_32FC1: 
        case cv.CV_32FC2: 
        case cv.CV_32FC3: 
        case cv.CV_32FC4: 
            return this.data32F;
        case cv.CV_64FC1: 
        case cv.CV_64FC2: 
        case cv.CV_64FC3: 
        case cv.CV_64FC4: 
            return this.data64F;
    }
};

OpenCVJSModule.Mat.prototype.PTR = function(x,y=-1) {
    switch (this.type())
    {
        case cv.CV_8UC1: 
        case cv.CV_8UC2: 
        case cv.CV_8UC3: 
        case cv.CV_8UC4: 
            return y < 0 ? this.ucharPtr(x) : this.ucharPtr(x,y);
        case cv.CV_8SC1: 
        case cv.CV_8SC2: 
        case cv.CV_8SC3: 
        case cv.CV_8SC4: 
            return y < 0 ? this.charPtr(x) : this.charPtr(x,y);
        case cv.CV_16UC1: 
        case cv.CV_16UC2: 
        case cv.CV_16UC3: 
        case cv.CV_16UC4: 
            return y < 0 ? this.ushortPtr(x) : this.ushortPtr(x,y);
        case cv.CV_16SC1: 
        case cv.CV_16SC2: 
        case cv.CV_16SC3: 
        case cv.CV_16SC4: 
            return y < 0 ? this.shortPtr(x) : this.shortPtr(x,y);
        case cv.CV_32SC1: 
        case cv.CV_32SC2: 
        case cv.CV_32SC3: 
        case cv.CV_32SC4: 
            return y < 0 ? this.intPtr(x) : this.intPtr(x,y);
        case cv.CV_32FC1: 
        case cv.CV_32FC2: 
        case cv.CV_32FC3: 
        case cv.CV_32FC4: 
            return y < 0 ? this.floatPtr(x) : this.floatPtr(x,y);
        case cv.CV_64FC1: 
        case cv.CV_64FC2: 
        case cv.CV_64FC3: 
        case cv.CV_64FC4: 
            return y < 0 ? this.doublePtr(x) : this.doublePtr(x,y);
    }
};

OpenCVJSModule.Mat.prototype.addConstant = function(constant) {
    let dst = new cv.Mat();
    cv.addWeighted(this, 1, this, 0, constant, dst);
    return dst;
};

OpenCVJSModule.Mat.prototype.constantSubtract = function(constant) {
    let dst = new cv.Mat();
    cv.addWeighted(this, -1, this, 0, constant, dst);
    return dst;
};

OpenCVJSModule.Mat.prototype.mmul = function(src1) {
    let dst = new cv.Mat();
    cv.gemm(this,src1,1,dst,0,dst);
    return dst;
};

OpenCVJSModule.Mat.prototype.mulConstant = function(constant) {
    let dst = new cv.Mat();
    cv.addWeighted(this, constant, this, 0, 0, dst);
    return dst;
};

OpenCVJSModule.Mat.prototype.constantDivide = function(constant) {
    let dst = new cv.Mat(this.rows, this.cols, this.type(), new cv.Scalar(constant));
    cv.divide(dst, this, dst);
    return dst;
};

OpenCVJSModule.Mat.prototype.reshape = function(rows) {
    return cv.matFromArray(rows, this.rows * this.cols / rows, this.type(), this.DATA());
};

//signle channels
OpenCVJSModule.Mat.prototype.sum = function() {
    return numeric.sum(this.DATA());
};

OpenCVJSModule["norm2"]=(function(src1, src2){
    let sub12 = new cv.Mat();
    cv.subtract(src1, src2, sub12);
    let normDouble = cv.norm(sub12);
    sub12.delete();
    return normDouble;
});

OpenCVJSModule.Mat.prototype.Diag = function(d=0) {
    if (this.channels() > 1) {
        return this.diag(d);
    }
    let dst = new cv.Mat();
    cv.cvtColor(this, dst, cv.COLOR_GRAY2BGR);
    cv.cvtColor(dst.diag(d), dst, cv.COLOR_BGR2GRAY);
    return dst;
};

OpenCVJSModule.Mat.prototype.vconcat = function(src1) {
    let input = new cv.MatVector();
    let dst = new cv.Mat();
    input.push_back(this);
    input.push_back(src1);
    cv.vconcat(input, dst);
    input.delete();
    return dst;
};

OpenCVJSModule.Mat.prototype.hconcat = function(src1) {
    let input = new cv.MatVector();
    let dst = new cv.Mat();
    input.push_back(this);
    input.push_back(src1);
    cv.hconcat(input, dst);
    input.delete();
    return dst;
};

// OpenCVJSModule.Mat.prototype._row = OpenCVJSModule.Mat.prototype.row;
// OpenCVJSModule.Mat.prototype.row = function(d) {
//     if (this.channels() > 1) {
//         return this._row(d);
//     }
//     return this._row(d);

//     return cv.matFromArray(1, this.cols, this.type(), this.PTR(d));
// };

OpenCVJSModule.Mat.prototype._col = OpenCVJSModule.Mat.prototype.col;
OpenCVJSModule.Mat.prototype.col = function(d) {
    if (this.channels() > 1) {
        return this._col(d);
    }
    let dst = new cv.Mat();
    cv.cvtColor(this, dst, cv.COLOR_GRAY2BGR);
    cv.cvtColor(dst._col(d), dst, cv.COLOR_BGR2GRAY);
    return dst;
};

OpenCVJSModule.Mat.prototype.replaceMatOnRect = function(src1, rect) {
    for (var i = 0; i < rect.height; ++i) {
        for (var j = 0; j < rect.width; ++j) {
            this.PTR(i+rect.y, j+rect.x)[0] = src1.PTR(i, j)[0];
        }
    }
};

OpenCVJSModule.Mat.prototype.replaceMatOnRow = function(arr, d) {
    this.floatPtr(d).forEach(function(part, index, theArray) {
        theArray[index] = arr[index];
    });
};

OpenCVJSModule.Mat.prototype.replaceMatOnCol = function(arr, d) {
    for (var i = 0; i < this.rows; ++i)
    {
        this.PTR(i, d)[0] = arr[i];
    }
};

OpenCVJSModule.Mat.prototype.replaceMatOnPoint = function(constant, x, y) {
    this.PTR(x, y)[0] = constant;
};

OpenCVJSModule.Mat.prototype.addOnCol = function(constant, d) {
    for (var i = 0; i < this.rows; ++i)
    {
        this.PTR(i, d)[0] += constant;
    }
};

OpenCVJSModule.Mat.prototype.rectAdd = function(src1, rect) {
    let height = rect.height;
    let width = rect.width;
    for (var i = 0; i < height; ++i) {
        for (var j = 0; j < width; ++j) {
            this.PTR(rect.y+i, rect.x+j)[0] += src1.PTR(i, j)[0];
        }
    }
};

OpenCVJSModule.Mat.prototype.rectSubtract = function(src1, rect) {
    let height = rect.height;
    let width = rect.width;
    for (var i = 0; i < height; ++i) {
        for (var j = 0; j < width; ++j) {
            this.PTR(rect.y+i, rect.x+j)[0] -= src1.PTR(i, j)[0];
        }
    }
};

//single channel
OpenCVJSModule.Mat.prototype.mds = function() {
    let src1Array = this.DATA;
    let src1Length = src1Array.length;
    let mean = src1Array.reduce(function(x,y){return x+y;})/src1Length;
    let dev= src1Array.map(function(x){return (x-mean)*(x-mean);});
    let stddev = Math.sqrt(dev.reduce(function(x,y){return x+y;})/src1Length);
    return {m:mean, d:dev, s:stddev};
};

// OpenCVJSModule["roi"]=(function(src1, rect){
// 	let src2 = new this.Mat();
// 	let planesI = new this.MatVector();
// 	planesI.push_back(src1);
// 	this.merge(planesI, src2);
// 	src2 = src2.roi(rect);
// 	this.split(src2, planesI);
// 	src2 = planesI.get(0);
// 	planesI.delete();
// 	return src2;
// });
OpenCVJSModule.Mat.prototype._roi = OpenCVJSModule.Mat.prototype.roi;
OpenCVJSModule.Mat.prototype.roi = function(rect) {
    if (this.channels() > 1) {
        return this._roi(rect);
    }
    var dst = new cv.Mat();
    cv.cvtColor(this, dst, cv.COLOR_GRAY2BGR);
    cv.cvtColor(dst._roi(rect), dst, cv.COLOR_BGR2GRAY);
    return dst;
};

OpenCVJSModule.Mat.prototype.svd = function() {
    let src1Array = [];
    for (var i = 0; i < this.rows; ++i)
    {
        src1Array[i] = this.PTR(i);
    }
    let svd = numeric.svd(src1Array);
    let svdArrayU = [].concat.apply([],svd.U);
    let svdArrayS = [].concat.apply([],svd.S);
    let svdArrayV = [].concat.apply([],svd.V);
    return {u:cv.matFromArray(svd.U.length, svd.U[0].length, this.type(), svdArrayU),
            w:cv.matFromArray(svd.S.length, 1, this.type(), svdArrayS),
            vt:cv.matFromArray(svd.V.length, svd.V[0].length, this.type(), svdArrayV).t()};
};

//CV_32FC1
OpenCVJSModule["RodriguesFromArray"]=(function(arr){
    let theta = Math.sqrt(arr[0]*arr[0] + arr[1]*arr[1] + arr[2]*arr[2]);

    let c = Math.cos(theta);
    let s = Math.sin(theta);
    let c1 = 1 - c;
    let itheta = theta ? 1/theta : 0;

    let r = {x:arr[0]*itheta, y:arr[1]*itheta, z:arr[2]*itheta};

    let rrt = cv.matFromArray(3, 3, cv.CV_32FC1, [r.x*r.x, r.x*r.y, r.x*r.z, r.x*r.y, r.y*r.y, r.y*r.z, r.x*r.z, r.y*r.z, r.z*r.z]);
    let r_x = cv.matFromArray(3, 3, cv.CV_32FC1, [0, -r.z, r.y, r.z, 0, -r.x, -r.y, r.x, 0]);

    let m1 = r_x.mulConstant(s);
    let m2 = rrt.mulConstant(c1);
    let m3 = cv.Mat.eye(3,3,cv.CV_32FC1);
    let m4 = m3.mulConstant(c);
    let m5 = new this.Mat();
    cv.add(m4, m2, m5);
    let dst = new this.Mat();
    cv.add(m5,m1,dst);

    rrt.delete();
    r_x.delete();
    m1.delete();
    m2.delete();
    m3.delete();
    m4.delete();
    m5.delete();
    return dst;
});

OpenCVJSModule.Mat.prototype.RodriguesFromMat = function() {
    let svd = this.svd();
    let R = (svd.u).mmul(svd.vt);

    let r = {x: R.PTR(2, 1)[0] - R.PTR(1, 2)[0], y: R.PTR(0, 2)[0] - R.PTR(2, 0)[0], z: R.PTR(1, 0)[0] - R.PTR(0, 1)[0]};

    let s = Math.sqrt((r.x*r.x + r.y*r.y + r.z*r.z)*0.25);
    let c = (R.PTR(0, 0)[0] + R.PTR(1, 1)[0] + R.PTR(2, 2)[0] - 1)*0.5;
    c = c > 1 ? 1 : c < -1 ? -1 : c;
    let theta = Math.acos(c);

    if( s < 1e-5 )
    {
        let t = 0;
        if( c > 0 )
            r = {x:0, y:0, z:0};
        else
        {
            t = (R.PTR(0, 0)[0] + 1)*0.5;
            r.x = Math.sqrt(Math.max(t,0));
            t = (R.PTR(1, 1)[0] + 1)*0.5;
            r.y = Math.sqrt(Math.max(t,0))*(R.PTR(0, 1)[0] < 0 ? -1 : 1);
            t = (R.PTR(2, 2)[0] + 1)*0.5;
            r.z = Math.sqrt(Math.max(t,0))*(R.PTR(0, 2)[0] < 0 ? -1 : 1);
            if( Math.abs(r.x) < Math.abs(r.y) && Math.abs(r.x) < Math.abs(r.z) && (R.PTR(1, 2)[0] > 0) != (r.y*r.z > 0) )
                r.z = -r.z;
            theta /= Math.sqrt(r.x*r.x + r.y*r.y + r.z*r.z);
            r.x *= theta;
            r.y *= theta;
            r.z *= theta;
        }
    }
    else
    {
        let vth = 1/(2*s);

        vth *= theta;

        r.x *= vth;
        r.y *= vth;
        r.z *= vth;
    }

    svd.u.delete();
    svd.w.delete();
    svd.vt.delete();
    R.delete();
    return [r.x, r.y, r.z];
};



OpenCVJSModule.Mat.prototype.dftSplit = function() {
    let M = this.rows;
    let N = this.cols;

    let colOneArray = [];
    let colLastArray = [];

    let realMat = cv.Mat.zeros(M,N,this.type());
    let imagMat = cv.Mat.zeros(M,N,this.type());

    for (var m = 0; m <= M - 1; m++) {
        colOneArray.push(this.PTR(m, 0)[0]);
        colLastArray.push(this.PTR(m, N-1)[0]);
        for (var n = 1, i = 1; n <= N-2; n+=2, i++) {
            realMat.PTR(m, i)[0] = this.PTR(m, n)[0];
            imagMat.PTR(m, i)[0] = this.PTR(m, n+1)[0];
        }
    }

    realMat.PTR(0, 0)[0] = colOneArray[0];
    realMat.PTR(M/2, 0)[0] = colOneArray[M-1];
    realMat.PTR(0, N/2)[0] = colLastArray[0];
    realMat.PTR(M/2, N/2)[0] = colLastArray[M-1];
    for (var m = 1, i = 1; m <= M - 2; m+=2, i++) {
        realMat.PTR(i, 0)[0] = colOneArray[m];
        imagMat.PTR(i, 0)[0] = colOneArray[m+1];

        realMat.PTR(i, N/2)[0] = colLastArray[m];
        imagMat.PTR(i, N/2)[0] = colLastArray[m+1];
    }

    return {r:realMat, i:imagMat};
};

OpenCVJSModule["mulSpectrums"]=(function(src1, src2, conjB = false){
    let planesI = src1.dftSplit();
    let realI = planesI.r;
    let imagI = planesI.i;

    let planesII = src2.dftSplit();
    let realII = planesII.r;
    let imagII = planesII.i;

    if (conjB === true) {
        imagII = imagII.mulConstant(-1);
    }
    let realMulMat = new cv.Mat();
    cv.subtract(realI.mul(realII, 1), imagI.mul(imagII, 1), realMulMat);
    let imagMulMat = new cv.Mat();
    cv.add(realI.mul(imagII, 1), imagI.mul(realII, 1), imagMulMat);

    let M = realI.rows;
    let N = realI.cols;

    let centerArray = [];
    for (var m = 0; m <= M - 1; m++) {
        for (var n = 1; n <= N / 2 - 1; n++) {
            centerArray.push(realMulMat.PTR(m, n)[0]);
            centerArray.push(imagMulMat.PTR(m, n)[0]);
        }
    }
    let centerMat = cv.matFromArray(M, N - 2, src1.type(), centerArray);

    let colOneArray = [realMulMat.PTR(0, 0)[0]];
    for (var m = 1; m <= M / 2 - 1; m++) {
        colOneArray.push(realMulMat.PTR(m, 0)[0]);
        colOneArray.push(imagMulMat.PTR(m, 0)[0]);
    }
    colOneArray.push(realMulMat.PTR(M / 2, 0)[0]);

    let colLastArray = [realMulMat.PTR(0, N / 2)[0]];
    for (var m = 1; m <= M / 2 - 1; m++) {
        colLastArray.push(realMulMat.PTR(m, N / 2)[0]);
        colLastArray.push(imagMulMat.PTR(m, N / 2)[0]);
    }
    colLastArray.push(realMulMat.PTR(M / 2, N / 2)[0]);

    let dst = cv.Mat.zeros(M, N, src1.type());
    dst.replaceMatOnRect(centerMat, new cv.Rect(1, 0, N - 2, M));
    dst.replaceMatOnCol(colOneArray, 0);
    dst.replaceMatOnCol(colLastArray, N - 1);
    return dst;
});

OpenCVJSModule["mulSpectrums2Channel"]=(function(complexI, complexII, conjB = false){
    let planesI = new cv.MatVector();
    cv.split(complexI, planesI);
    let realI = planesI.get(0);
    let imagI = planesI.get(1);

    let planesII = new cv.MatVector();
    cv.split(complexII, planesII);
    let realII = planesII.get(0);
    let imagII = planesII.get(1);
    if (conjB === true) {
        imagII = imagII.mulConstant(-1);
    }
    let realMulMat = new cv.Mat();
    cv.subtract(realI.mul(realII, 1), imagI.mul(imagII, 1), realMulMat);
    let imagMulMat = new cv.Mat();
    cv.add(realI.mul(imagII, 1), imagI.mul(realII, 1), imagMulMat);

    let M = realI.rows;
    let N = realI.cols;

    let centerArray = [];
    for (var m = 0; m <= M - 1; m++) {
        for (var n = 1; n <= N / 2 - 1; n++) {
            centerArray.push(realMulMat.floatPtr(m, n)[0]);
            centerArray.push(imagMulMat.floatPtr(m, n)[0]);
        }
    }
    let centerMat = cv.matFromArray(M, N - 2, cv.CV_32FC1, centerArray);

    let colOneArray = [realMulMat.floatPtr(0, 0)[0]];
    for (var m = 1; m <= M / 2 - 1; m++) {
        colOneArray.push(realMulMat.floatPtr(m, 0)[0]);
        colOneArray.push(imagMulMat.floatPtr(m, 0)[0]);
    }
    colOneArray.push(realMulMat.floatPtr(M / 2, 0)[0]);

    let colLastArray = [realMulMat.floatPtr(0, N / 2)[0]];
    for (var m = 1; m <= M / 2 - 1; m++) {
        colLastArray.push(realMulMat.floatPtr(m, N / 2)[0]);
        colLastArray.push(imagMulMat.floatPtr(m, N / 2)[0]);
    }
    colLastArray.push(realMulMat.floatPtr(M / 2, N / 2)[0]);

    let dst = cv.Mat.zeros(M, N, cv.CV_32FC1);
    dst.replaceMatOnRect(centerMat, new cv.Rect(1, 0, N - 2, M));
    dst.replaceMatOnCol(colOneArray, 0);
    dst.replaceMatOnCol(colLastArray, N - 1);
    return dst;
});



  return cv;
};

if (typeof OpenCVJSModule === "object" && OpenCVJSModule.exports) {
  OpenCVJSModule['exports'] = cv;
};

  if (typeof OpenCVJSModule === 'undefined')
    OpenCVJSModule = {};
  return cv(OpenCVJSModule);
}));















///////////////////////////numeric.js/////////////////////////









"use strict";var numeric=(typeof exports==="undefined")?(function numeric(){}):(exports);if(typeof global!=="undefined"){global.numeric=numeric}numeric.version="1.2.6";numeric.bench=function bench(f,interval){var t1,t2,n,i;if(typeof interval==="undefined"){interval=15}n=0.5;t1=new Date();while(1){n*=2;for(i=n;i>3;i-=4){f();f();f();f()}while(i>0){f();i--}t2=new Date();if(t2-t1>interval){break}}for(i=n;i>3;i-=4){f();f();f();f()}while(i>0){f();i--}t2=new Date();return 1000*(3*n-1)/(t2-t1)};numeric._myIndexOf=(function _myIndexOf(w){var n=this.length,k;for(k=0;k<n;++k){if(this[k]===w){return k}}return -1});numeric.myIndexOf=(Array.prototype.indexOf)?Array.prototype.indexOf:numeric._myIndexOf;numeric.Function=Function;numeric.precision=4;numeric.largeArray=50;numeric.prettyPrint=function prettyPrint(x){function fmtnum(x){if(x===0){return"0"}if(isNaN(x)){return"NaN"}if(x<0){return"-"+fmtnum(-x)}if(isFinite(x)){var scale=Math.floor(Math.log(x)/Math.log(10));var normalized=x/Math.pow(10,scale);var basic=normalized.toPrecision(numeric.precision);if(parseFloat(basic)===10){scale++;normalized=1;basic=normalized.toPrecision(numeric.precision)}return parseFloat(basic).toString()+"e"+scale.toString()}return"Infinity"}var ret=[];function foo(x){var k;if(typeof x==="undefined"){ret.push(Array(numeric.precision+8).join(" "));return false}if(typeof x==="string"){ret.push('"'+x+'"');return false}if(typeof x==="boolean"){ret.push(x.toString());return false}if(typeof x==="number"){var a=fmtnum(x);var b=x.toPrecision(numeric.precision);var c=parseFloat(x.toString()).toString();var d=[a,b,c,parseFloat(b).toString(),parseFloat(c).toString()];for(k=1;k<d.length;k++){if(d[k].length<a.length){a=d[k]}}ret.push(Array(numeric.precision+8-a.length).join(" ")+a);return false}if(x===null){ret.push("null");return false}if(typeof x==="function"){ret.push(x.toString());var flag=false;for(k in x){if(x.hasOwnProperty(k)){if(flag){ret.push(",\n")}else{ret.push("\n{")}flag=true;ret.push(k);ret.push(": \n");foo(x[k])}}if(flag){ret.push("}\n")}return true}if(x instanceof Array){if(x.length>numeric.largeArray){ret.push("...Large Array...");return true}var flag=false;ret.push("[");for(k=0;k<x.length;k++){if(k>0){ret.push(",");if(flag){ret.push("\n ")}}flag=foo(x[k])}ret.push("]");return true}ret.push("{");var flag=false;for(k in x){if(x.hasOwnProperty(k)){if(flag){ret.push(",\n")}flag=true;ret.push(k);ret.push(": \n");foo(x[k])}}ret.push("}");return true}foo(x);return ret.join("")};numeric.parseDate=function parseDate(d){function foo(d){if(typeof d==="string"){return Date.parse(d.replace(/-/g,"/"))}if(!(d instanceof Array)){throw new Error("parseDate: parameter must be arrays of strings")}var ret=[],k;for(k=0;k<d.length;k++){ret[k]=foo(d[k])}return ret}return foo(d)};numeric.parseFloat=function parseFloat_(d){function foo(d){if(typeof d==="string"){return parseFloat(d)}if(!(d instanceof Array)){throw new Error("parseFloat: parameter must be arrays of strings")}var ret=[],k;for(k=0;k<d.length;k++){ret[k]=foo(d[k])}return ret}return foo(d)};numeric.parseCSV=function parseCSV(t){var foo=t.split("\n");var j,k;var ret=[];var pat=/(([^'",]*)|('[^']*')|("[^"]*")),/g;var patnum=/^\s*(([+-]?[0-9]+(\.[0-9]*)?(e[+-]?[0-9]+)?)|([+-]?[0-9]*(\.[0-9]+)?(e[+-]?[0-9]+)?))\s*$/;var stripper=function(n){return n.substr(0,n.length-1)};var count=0;for(k=0;k<foo.length;k++){var bar=(foo[k]+",").match(pat),baz;if(bar.length>0){ret[count]=[];for(j=0;j<bar.length;j++){baz=stripper(bar[j]);if(patnum.test(baz)){ret[count][j]=parseFloat(baz)}else{ret[count][j]=baz}}count++}}return ret};numeric.toCSV=function toCSV(A){var s=numeric.dim(A);var i,j,m,n,row,ret;m=s[0];n=s[1];ret=[];for(i=0;i<m;i++){row=[];for(j=0;j<m;j++){row[j]=A[i][j].toString()}ret[i]=row.join(", ")}return ret.join("\n")+"\n"};numeric.getURL=function getURL(url){var client=new XMLHttpRequest();client.open("GET",url,false);client.send();return client};numeric.imageURL=function imageURL(img){function base64(A){var n=A.length,i,x,y,z,p,q,r,s;var key="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";var ret="";for(i=0;i<n;i+=3){x=A[i];y=A[i+1];z=A[i+2];p=x>>2;q=((x&3)<<4)+(y>>4);r=((y&15)<<2)+(z>>6);s=z&63;if(i+1>=n){r=s=64}else{if(i+2>=n){s=64}}ret+=key.charAt(p)+key.charAt(q)+key.charAt(r)+key.charAt(s)}return ret}function crc32Array(a,from,to){if(typeof from==="undefined"){from=0}if(typeof to==="undefined"){to=a.length}var table=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918000,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117];var crc=-1,y=0,n=a.length,i;for(i=from;i<to;i++){y=(crc^a[i])&255;crc=(crc>>>8)^table[y]}return crc^(-1)}var h=img[0].length,w=img[0][0].length,s1,s2,next,k,length,a,b,i,j,adler32,crc32;var stream=[137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,(w>>24)&255,(w>>16)&255,(w>>8)&255,w&255,(h>>24)&255,(h>>16)&255,(h>>8)&255,h&255,8,2,0,0,0,-1,-2,-3,-4,-5,-6,-7,-8,73,68,65,84,8,29];crc32=crc32Array(stream,12,29);stream[29]=(crc32>>24)&255;stream[30]=(crc32>>16)&255;stream[31]=(crc32>>8)&255;stream[32]=(crc32)&255;s1=1;s2=0;for(i=0;i<h;i++){if(i<h-1){stream.push(0)}else{stream.push(1)}a=(3*w+1+(i===0))&255;b=((3*w+1+(i===0))>>8)&255;stream.push(a);stream.push(b);stream.push((~a)&255);stream.push((~b)&255);if(i===0){stream.push(0)}for(j=0;j<w;j++){for(k=0;k<3;k++){a=img[k][i][j];if(a>255){a=255}else{if(a<0){a=0}else{a=Math.round(a)}}s1=(s1+a)%65521;s2=(s2+s1)%65521;stream.push(a)}}stream.push(0)}adler32=(s2<<16)+s1;stream.push((adler32>>24)&255);stream.push((adler32>>16)&255);stream.push((adler32>>8)&255);stream.push((adler32)&255);length=stream.length-41;stream[33]=(length>>24)&255;stream[34]=(length>>16)&255;stream[35]=(length>>8)&255;stream[36]=(length)&255;crc32=crc32Array(stream,37);stream.push((crc32>>24)&255);stream.push((crc32>>16)&255);stream.push((crc32>>8)&255);stream.push((crc32)&255);stream.push(0);stream.push(0);stream.push(0);stream.push(0);stream.push(73);stream.push(69);stream.push(78);stream.push(68);stream.push(174);stream.push(66);stream.push(96);stream.push(130);return"data:image/png;base64,"+base64(stream)};numeric._dim=function _dim(x){var ret=[];while(typeof x==="object"){ret.push(x.length);x=x[0]}return ret};numeric.dim=function dim(x){var y,z;if(typeof x==="object"){y=x[0];if(typeof y==="object"){z=y[0];if(typeof z==="object"){return numeric._dim(x)}return[x.length,y.length]}return[x.length]}return[]};numeric.mapreduce=function mapreduce(body,init){return Function("x","accum","_s","_k",'if(typeof accum === "undefined") accum = '+init+";\n"+'if(typeof x === "number") { var xi = x; '+body+"; return accum; }\n"+'if(typeof _s === "undefined") _s = numeric.dim(x);\n'+'if(typeof _k === "undefined") _k = 0;\n'+"var _n = _s[_k];\n"+"var i,xi;\n"+"if(_k < _s.length-1) {\n"+"    for(i=_n-1;i>=0;i--) {\n"+"        accum = arguments.callee(x[i],accum,_s,_k+1);\n"+"    }"+"    return accum;\n"+"}\n"+"for(i=_n-1;i>=1;i-=2) { \n"+"    xi = x[i];\n"+"    "+body+";\n"+"    xi = x[i-1];\n"+"    "+body+";\n"+"}\n"+"if(i === 0) {\n"+"    xi = x[i];\n"+"    "+body+"\n"+"}\n"+"return accum;")};numeric.mapreduce2=function mapreduce2(body,setup){return Function("x","var n = x.length;\n"+"var i,xi;\n"+setup+";\n"+"for(i=n-1;i!==-1;--i) { \n"+"    xi = x[i];\n"+"    "+body+";\n"+"}\n"+"return accum;")};numeric.same=function same(x,y){var i,n;if(!(x instanceof Array)||!(y instanceof Array)){return false}n=x.length;if(n!==y.length){return false}for(i=0;i<n;i++){if(x[i]===y[i]){continue}if(typeof x[i]==="object"){if(!same(x[i],y[i])){return false}}else{return false}}return true};numeric.rep=function rep(s,v,k){if(typeof k==="undefined"){k=0}var n=s[k],ret=Array(n),i;if(k===s.length-1){for(i=n-2;i>=0;i-=2){ret[i+1]=v;ret[i]=v}if(i===-1){ret[0]=v}return ret}for(i=n-1;i>=0;i--){ret[i]=numeric.rep(s,v,k+1)}return ret};numeric.dotMMsmall=function dotMMsmall(x,y){var i,j,k,p,q,r,ret,foo,bar,woo,i0,k0,p0,r0;p=x.length;q=y.length;r=y[0].length;ret=Array(p);for(i=p-1;i>=0;i--){foo=Array(r);bar=x[i];for(k=r-1;k>=0;k--){woo=bar[q-1]*y[q-1][k];for(j=q-2;j>=1;j-=2){i0=j-1;woo+=bar[j]*y[j][k]+bar[i0]*y[i0][k]}if(j===0){woo+=bar[0]*y[0][k]}foo[k]=woo}ret[i]=foo}return ret};numeric._getCol=function _getCol(A,j,x){var n=A.length,i;for(i=n-1;i>0;--i){x[i]=A[i][j];--i;x[i]=A[i][j]}if(i===0){x[0]=A[0][j]}};numeric.dotMMbig=function dotMMbig(x,y){var gc=numeric._getCol,p=y.length,v=Array(p);var m=x.length,n=y[0].length,A=new Array(m),xj;var VV=numeric.dotVV;var i,j,k,z;--p;--m;for(i=m;i!==-1;--i){A[i]=Array(n)}--n;for(i=n;i!==-1;--i){gc(y,i,v);for(j=m;j!==-1;--j){z=0;xj=x[j];A[j][i]=VV(xj,v)}}return A};numeric.dotMV=function dotMV(x,y){var p=x.length,q=y.length,i;var ret=Array(p),dotVV=numeric.dotVV;for(i=p-1;i>=0;i--){ret[i]=dotVV(x[i],y)}return ret};numeric.dotVM=function dotVM(x,y){var i,j,k,p,q,r,ret,foo,bar,woo,i0,k0,p0,r0,s1,s2,s3,baz,accum;p=x.length;q=y[0].length;ret=Array(q);for(k=q-1;k>=0;k--){woo=x[p-1]*y[p-1][k];for(j=p-2;j>=1;j-=2){i0=j-1;woo+=x[j]*y[j][k]+x[i0]*y[i0][k]}if(j===0){woo+=x[0]*y[0][k]}ret[k]=woo}return ret};numeric.dotVV=function dotVV(x,y){var i,n=x.length,i1,ret=x[n-1]*y[n-1];for(i=n-2;i>=1;i-=2){i1=i-1;ret+=x[i]*y[i]+x[i1]*y[i1]}if(i===0){ret+=x[0]*y[0]}return ret};numeric.dot=function dot(x,y){var d=numeric.dim;switch(d(x).length*1000+d(y).length){case 2002:if(y.length<10){return numeric.dotMMsmall(x,y)}else{return numeric.dotMMbig(x,y)}case 2001:return numeric.dotMV(x,y);case 1002:return numeric.dotVM(x,y);case 1001:return numeric.dotVV(x,y);case 1000:return numeric.mulVS(x,y);case 1:return numeric.mulSV(x,y);case 0:return x*y;default:throw new Error("numeric.dot only works on vectors and matrices")}};numeric.diag=function diag(d){var i,i1,j,n=d.length,A=Array(n),Ai;for(i=n-1;i>=0;i--){Ai=Array(n);i1=i+2;for(j=n-1;j>=i1;j-=2){Ai[j]=0;Ai[j-1]=0}if(j>i){Ai[j]=0}Ai[i]=d[i];for(j=i-1;j>=1;j-=2){Ai[j]=0;Ai[j-1]=0}if(j===0){Ai[0]=0}A[i]=Ai}return A};numeric.getDiag=function(A){var n=Math.min(A.length,A[0].length),i,ret=Array(n);for(i=n-1;i>=1;--i){ret[i]=A[i][i];--i;ret[i]=A[i][i]}if(i===0){ret[0]=A[0][0]}return ret};numeric.identity=function identity(n){return numeric.diag(numeric.rep([n],1))};numeric.pointwise=function pointwise(params,body,setup){if(typeof setup==="undefined"){setup=""}var fun=[];var k;var avec=/\[i\]$/,p,thevec="";var haveret=false;for(k=0;k<params.length;k++){if(avec.test(params[k])){p=params[k].substring(0,params[k].length-3);thevec=p}else{p=params[k]}if(p==="ret"){haveret=true}fun.push(p)}fun[params.length]="_s";fun[params.length+1]="_k";fun[params.length+2]=('if(typeof _s === "undefined") _s = numeric.dim('+thevec+");\n"+'if(typeof _k === "undefined") _k = 0;\n'+"var _n = _s[_k];\n"+"var i"+(haveret?"":", ret = Array(_n)")+";\n"+"if(_k < _s.length-1) {\n"+"    for(i=_n-1;i>=0;i--) ret[i] = arguments.callee("+params.join(",")+",_s,_k+1);\n"+"    return ret;\n"+"}\n"+setup+"\n"+"for(i=_n-1;i!==-1;--i) {\n"+"    "+body+"\n"+"}\n"+"return ret;");return Function.apply(null,fun)};numeric.pointwise2=function pointwise2(params,body,setup){if(typeof setup==="undefined"){setup=""}var fun=[];var k;var avec=/\[i\]$/,p,thevec="";var haveret=false;for(k=0;k<params.length;k++){if(avec.test(params[k])){p=params[k].substring(0,params[k].length-3);thevec=p}else{p=params[k]}if(p==="ret"){haveret=true}fun.push(p)}fun[params.length]=("var _n = "+thevec+".length;\n"+"var i"+(haveret?"":", ret = Array(_n)")+";\n"+setup+"\n"+"for(i=_n-1;i!==-1;--i) {\n"+body+"\n"+"}\n"+"return ret;");return Function.apply(null,fun)};numeric._biforeach=(function _biforeach(x,y,s,k,f){if(k===s.length-1){f(x,y);return}var i,n=s[k];for(i=n-1;i>=0;i--){_biforeach(typeof x==="object"?x[i]:x,typeof y==="object"?y[i]:y,s,k+1,f)}});numeric._biforeach2=(function _biforeach2(x,y,s,k,f){if(k===s.length-1){return f(x,y)}var i,n=s[k],ret=Array(n);for(i=n-1;i>=0;--i){ret[i]=_biforeach2(typeof x==="object"?x[i]:x,typeof y==="object"?y[i]:y,s,k+1,f)}return ret});numeric._foreach=(function _foreach(x,s,k,f){if(k===s.length-1){f(x);return}var i,n=s[k];for(i=n-1;i>=0;i--){_foreach(x[i],s,k+1,f)}});numeric._foreach2=(function _foreach2(x,s,k,f){if(k===s.length-1){return f(x)}var i,n=s[k],ret=Array(n);for(i=n-1;i>=0;i--){ret[i]=_foreach2(x[i],s,k+1,f)}return ret});numeric.ops2={add:"+",sub:"-",mul:"*",div:"/",mod:"%",and:"&&",or:"||",eq:"===",neq:"!==",lt:"<",gt:">",leq:"<=",geq:">=",band:"&",bor:"|",bxor:"^",lshift:"<<",rshift:">>",rrshift:">>>"};numeric.opseq={addeq:"+=",subeq:"-=",muleq:"*=",diveq:"/=",modeq:"%=",lshifteq:"<<=",rshifteq:">>=",rrshifteq:">>>=",bandeq:"&=",boreq:"|=",bxoreq:"^="};numeric.mathfuns=["abs","acos","asin","atan","ceil","cos","exp","floor","log","round","sin","sqrt","tan","isNaN","isFinite"];numeric.mathfuns2=["atan2","pow","max","min"];numeric.ops1={neg:"-",not:"!",bnot:"~",clone:""};numeric.mapreducers={any:["if(xi) return true;","var accum = false;"],all:["if(!xi) return false;","var accum = true;"],sum:["accum += xi;","var accum = 0;"],prod:["accum *= xi;","var accum = 1;"],norm2Squared:["accum += xi*xi;","var accum = 0;"],norminf:["accum = max(accum,abs(xi));","var accum = 0, max = Math.max, abs = Math.abs;"],norm1:["accum += abs(xi)","var accum = 0, abs = Math.abs;"],sup:["accum = max(accum,xi);","var accum = -Infinity, max = Math.max;"],inf:["accum = min(accum,xi);","var accum = Infinity, min = Math.min;"]};(function(){var i,o;for(i=0;i<numeric.mathfuns2.length;++i){o=numeric.mathfuns2[i];numeric.ops2[o]=o}for(i in numeric.ops2){if(numeric.ops2.hasOwnProperty(i)){o=numeric.ops2[i];var code,codeeq,setup="";if(numeric.myIndexOf.call(numeric.mathfuns2,i)!==-1){setup="var "+o+" = Math."+o+";\n";code=function(r,x,y){return r+" = "+o+"("+x+","+y+")"};codeeq=function(x,y){return x+" = "+o+"("+x+","+y+")"}}else{code=function(r,x,y){return r+" = "+x+" "+o+" "+y};if(numeric.opseq.hasOwnProperty(i+"eq")){codeeq=function(x,y){return x+" "+o+"= "+y}}else{codeeq=function(x,y){return x+" = "+x+" "+o+" "+y}}}numeric[i+"VV"]=numeric.pointwise2(["x[i]","y[i]"],code("ret[i]","x[i]","y[i]"),setup);numeric[i+"SV"]=numeric.pointwise2(["x","y[i]"],code("ret[i]","x","y[i]"),setup);numeric[i+"VS"]=numeric.pointwise2(["x[i]","y"],code("ret[i]","x[i]","y"),setup);numeric[i]=Function("var n = arguments.length, i, x = arguments[0], y;\n"+"var VV = numeric."+i+"VV, VS = numeric."+i+"VS, SV = numeric."+i+"SV;\n"+"var dim = numeric.dim;\n"+"for(i=1;i!==n;++i) { \n"+"  y = arguments[i];\n"+'  if(typeof x === "object") {\n'+'      if(typeof y === "object") x = numeric._biforeach2(x,y,dim(x),0,VV);\n'+"      else x = numeric._biforeach2(x,y,dim(x),0,VS);\n"+'  } else if(typeof y === "object") x = numeric._biforeach2(x,y,dim(y),0,SV);\n'+"  else "+codeeq("x","y")+"\n"+"}\nreturn x;\n");numeric[o]=numeric[i];numeric[i+"eqV"]=numeric.pointwise2(["ret[i]","x[i]"],codeeq("ret[i]","x[i]"),setup);numeric[i+"eqS"]=numeric.pointwise2(["ret[i]","x"],codeeq("ret[i]","x"),setup);numeric[i+"eq"]=Function("var n = arguments.length, i, x = arguments[0], y;\n"+"var V = numeric."+i+"eqV, S = numeric."+i+"eqS\n"+"var s = numeric.dim(x);\n"+"for(i=1;i!==n;++i) { \n"+"  y = arguments[i];\n"+'  if(typeof y === "object") numeric._biforeach(x,y,s,0,V);\n'+"  else numeric._biforeach(x,y,s,0,S);\n"+"}\nreturn x;\n")}}for(i=0;i<numeric.mathfuns2.length;++i){o=numeric.mathfuns2[i];delete numeric.ops2[o]}for(i=0;i<numeric.mathfuns.length;++i){o=numeric.mathfuns[i];numeric.ops1[o]=o}for(i in numeric.ops1){if(numeric.ops1.hasOwnProperty(i)){setup="";o=numeric.ops1[i];if(numeric.myIndexOf.call(numeric.mathfuns,i)!==-1){if(Math.hasOwnProperty(o)){setup="var "+o+" = Math."+o+";\n"}}numeric[i+"eqV"]=numeric.pointwise2(["ret[i]"],"ret[i] = "+o+"(ret[i]);",setup);numeric[i+"eq"]=Function("x",'if(typeof x !== "object") return '+o+"x\n"+"var i;\n"+"var V = numeric."+i+"eqV;\n"+"var s = numeric.dim(x);\n"+"numeric._foreach(x,s,0,V);\n"+"return x;\n");numeric[i+"V"]=numeric.pointwise2(["x[i]"],"ret[i] = "+o+"(x[i]);",setup);numeric[i]=Function("x",'if(typeof x !== "object") return '+o+"(x)\n"+"var i;\n"+"var V = numeric."+i+"V;\n"+"var s = numeric.dim(x);\n"+"return numeric._foreach2(x,s,0,V);\n")}}for(i=0;i<numeric.mathfuns.length;++i){o=numeric.mathfuns[i];delete numeric.ops1[o]}for(i in numeric.mapreducers){if(numeric.mapreducers.hasOwnProperty(i)){o=numeric.mapreducers[i];numeric[i+"V"]=numeric.mapreduce2(o[0],o[1]);numeric[i]=Function("x","s","k",o[1]+'if(typeof x !== "object") {'+"    xi = x;\n"+o[0]+";\n"+"    return accum;\n"+"}"+'if(typeof s === "undefined") s = numeric.dim(x);\n'+'if(typeof k === "undefined") k = 0;\n'+"if(k === s.length-1) return numeric."+i+"V(x);\n"+"var xi;\n"+"var n = x.length, i;\n"+"for(i=n-1;i!==-1;--i) {\n"+"   xi = arguments.callee(x[i]);\n"+o[0]+";\n"+"}\n"+"return accum;\n")}}}());numeric.truncVV=numeric.pointwise(["x[i]","y[i]"],"ret[i] = round(x[i]/y[i])*y[i];","var round = Math.round;");numeric.truncVS=numeric.pointwise(["x[i]","y"],"ret[i] = round(x[i]/y)*y;","var round = Math.round;");numeric.truncSV=numeric.pointwise(["x","y[i]"],"ret[i] = round(x/y[i])*y[i];","var round = Math.round;");numeric.trunc=function trunc(x,y){if(typeof x==="object"){if(typeof y==="object"){return numeric.truncVV(x,y)}return numeric.truncVS(x,y)}if(typeof y==="object"){return numeric.truncSV(x,y)}return Math.round(x/y)*y};numeric.inv=function inv(x){var s=numeric.dim(x),abs=Math.abs,m=s[0],n=s[1];var A=numeric.clone(x),Ai,Aj;var I=numeric.identity(m),Ii,Ij;var i,j,k,x;for(j=0;j<n;++j){var i0=-1;var v0=-1;for(i=j;i!==m;++i){k=abs(A[i][j]);if(k>v0){i0=i;v0=k}}Aj=A[i0];A[i0]=A[j];A[j]=Aj;Ij=I[i0];I[i0]=I[j];I[j]=Ij;x=Aj[j];for(k=j;k!==n;++k){Aj[k]/=x}for(k=n-1;k!==-1;--k){Ij[k]/=x}for(i=m-1;i!==-1;--i){if(i!==j){Ai=A[i];Ii=I[i];x=Ai[j];for(k=j+1;k!==n;++k){Ai[k]-=Aj[k]*x}for(k=n-1;k>0;--k){Ii[k]-=Ij[k]*x;--k;Ii[k]-=Ij[k]*x}if(k===0){Ii[0]-=Ij[0]*x}}}}return I};numeric.det=function det(x){var s=numeric.dim(x);if(s.length!==2||s[0]!==s[1]){throw new Error("numeric: det() only works on square matrices")}var n=s[0],ret=1,i,j,k,A=numeric.clone(x),Aj,Ai,alpha,temp,k1,k2,k3;for(j=0;j<n-1;j++){k=j;for(i=j+1;i<n;i++){if(Math.abs(A[i][j])>Math.abs(A[k][j])){k=i}}if(k!==j){temp=A[k];A[k]=A[j];A[j]=temp;ret*=-1}Aj=A[j];for(i=j+1;i<n;i++){Ai=A[i];alpha=Ai[j]/Aj[j];for(k=j+1;k<n-1;k+=2){k1=k+1;Ai[k]-=Aj[k]*alpha;Ai[k1]-=Aj[k1]*alpha}if(k!==n){Ai[k]-=Aj[k]*alpha}}if(Aj[j]===0){return 0}ret*=Aj[j]}return ret*A[j][j]};numeric.transpose=function transpose(x){var i,j,m=x.length,n=x[0].length,ret=Array(n),A0,A1,Bj;for(j=0;j<n;j++){ret[j]=Array(m)}for(i=m-1;i>=1;i-=2){A1=x[i];A0=x[i-1];for(j=n-1;j>=1;--j){Bj=ret[j];Bj[i]=A1[j];Bj[i-1]=A0[j];--j;Bj=ret[j];Bj[i]=A1[j];Bj[i-1]=A0[j]}if(j===0){Bj=ret[0];Bj[i]=A1[0];Bj[i-1]=A0[0]}}if(i===0){A0=x[0];for(j=n-1;j>=1;--j){ret[j][0]=A0[j];--j;ret[j][0]=A0[j]}if(j===0){ret[0][0]=A0[0]}}return ret};numeric.negtranspose=function negtranspose(x){var i,j,m=x.length,n=x[0].length,ret=Array(n),A0,A1,Bj;for(j=0;j<n;j++){ret[j]=Array(m)}for(i=m-1;i>=1;i-=2){A1=x[i];A0=x[i-1];for(j=n-1;j>=1;--j){Bj=ret[j];Bj[i]=-A1[j];Bj[i-1]=-A0[j];--j;Bj=ret[j];Bj[i]=-A1[j];Bj[i-1]=-A0[j]}if(j===0){Bj=ret[0];Bj[i]=-A1[0];Bj[i-1]=-A0[0]}}if(i===0){A0=x[0];for(j=n-1;j>=1;--j){ret[j][0]=-A0[j];--j;ret[j][0]=-A0[j]}if(j===0){ret[0][0]=-A0[0]}}return ret};numeric._random=function _random(s,k){var i,n=s[k],ret=Array(n),rnd;if(k===s.length-1){rnd=Math.random;for(i=n-1;i>=1;i-=2){ret[i]=rnd();ret[i-1]=rnd()}if(i===0){ret[0]=rnd()}return ret}for(i=n-1;i>=0;i--){ret[i]=_random(s,k+1)}return ret};numeric.random=function random(s){return numeric._random(s,0)};numeric.norm2=function norm2(x){return Math.sqrt(numeric.norm2Squared(x))};numeric.linspace=function linspace(a,b,n){if(typeof n==="undefined"){n=Math.max(Math.round(b-a)+1,1)}if(n<2){return n===1?[a]:[]}var i,ret=Array(n);n--;for(i=n;i>=0;i--){ret[i]=(i*b+(n-i)*a)/n}return ret};numeric.getBlock=function getBlock(x,from,to){var s=numeric.dim(x);function foo(x,k){var i,a=from[k],n=to[k]-a,ret=Array(n);if(k===s.length-1){for(i=n;i>=0;i--){ret[i]=x[i+a]}return ret}for(i=n;i>=0;i--){ret[i]=foo(x[i+a],k+1)}return ret}return foo(x,0)};numeric.setBlock=function setBlock(x,from,to,B){var s=numeric.dim(x);function foo(x,y,k){var i,a=from[k],n=to[k]-a;if(k===s.length-1){for(i=n;i>=0;i--){x[i+a]=y[i]}}for(i=n;i>=0;i--){foo(x[i+a],y[i],k+1)}}foo(x,B,0);return x};numeric.getRange=function getRange(A,I,J){var m=I.length,n=J.length;var i,j;var B=Array(m),Bi,AI;for(i=m-1;i!==-1;--i){B[i]=Array(n);Bi=B[i];AI=A[I[i]];for(j=n-1;j!==-1;--j){Bi[j]=AI[J[j]]}}return B};numeric.blockMatrix=function blockMatrix(X){var s=numeric.dim(X);if(s.length<4){return numeric.blockMatrix([X])}var m=s[0],n=s[1],M,N,i,j,Xij;M=0;N=0;for(i=0;i<m;++i){M+=X[i][0].length}for(j=0;j<n;++j){N+=X[0][j][0].length}var Z=Array(M);for(i=0;i<M;++i){Z[i]=Array(N)}var I=0,J,ZI,k,l,Xijk;for(i=0;i<m;++i){J=N;for(j=n-1;j!==-1;--j){Xij=X[i][j];J-=Xij[0].length;for(k=Xij.length-1;k!==-1;--k){Xijk=Xij[k];ZI=Z[I+k];for(l=Xijk.length-1;l!==-1;--l){ZI[J+l]=Xijk[l]}}}I+=X[i][0].length}return Z};numeric.tensor=function tensor(x,y){if(typeof x==="number"||typeof y==="number"){return numeric.mul(x,y)}var s1=numeric.dim(x),s2=numeric.dim(y);if(s1.length!==1||s2.length!==1){throw new Error("numeric: tensor product is only defined for vectors")}var m=s1[0],n=s2[0],A=Array(m),Ai,i,j,xi;for(i=m-1;i>=0;i--){Ai=Array(n);xi=x[i];for(j=n-1;j>=3;--j){Ai[j]=xi*y[j];--j;Ai[j]=xi*y[j];--j;Ai[j]=xi*y[j];--j;Ai[j]=xi*y[j]}while(j>=0){Ai[j]=xi*y[j];--j}A[i]=Ai}return A};numeric.T=function T(x,y){this.x=x;this.y=y};numeric.t=function t(x,y){return new numeric.T(x,y)};numeric.Tbinop=function Tbinop(rr,rc,cr,cc,setup){var io=numeric.indexOf;if(typeof setup!=="string"){var k;setup="";for(k in numeric){if(numeric.hasOwnProperty(k)&&(rr.indexOf(k)>=0||rc.indexOf(k)>=0||cr.indexOf(k)>=0||cc.indexOf(k)>=0)&&k.length>1){setup+="var "+k+" = numeric."+k+";\n"}}}return Function(["y"],"var x = this;\n"+"if(!(y instanceof numeric.T)) { y = new numeric.T(y); }\n"+setup+"\n"+"if(x.y) {"+"  if(y.y) {"+"    return new numeric.T("+cc+");\n"+"  }\n"+"  return new numeric.T("+cr+");\n"+"}\n"+"if(y.y) {\n"+"  return new numeric.T("+rc+");\n"+"}\n"+"return new numeric.T("+rr+");\n")};numeric.T.prototype.add=numeric.Tbinop("add(x.x,y.x)","add(x.x,y.x),y.y","add(x.x,y.x),x.y","add(x.x,y.x),add(x.y,y.y)");numeric.T.prototype.sub=numeric.Tbinop("sub(x.x,y.x)","sub(x.x,y.x),neg(y.y)","sub(x.x,y.x),x.y","sub(x.x,y.x),sub(x.y,y.y)");numeric.T.prototype.mul=numeric.Tbinop("mul(x.x,y.x)","mul(x.x,y.x),mul(x.x,y.y)","mul(x.x,y.x),mul(x.y,y.x)","sub(mul(x.x,y.x),mul(x.y,y.y)),add(mul(x.x,y.y),mul(x.y,y.x))");numeric.T.prototype.reciprocal=function reciprocal(){var mul=numeric.mul,div=numeric.div;if(this.y){var d=numeric.add(mul(this.x,this.x),mul(this.y,this.y));return new numeric.T(div(this.x,d),div(numeric.neg(this.y),d))}return new T(div(1,this.x))};numeric.T.prototype.div=function div(y){if(!(y instanceof numeric.T)){y=new numeric.T(y)}if(y.y){return this.mul(y.reciprocal())}var div=numeric.div;if(this.y){return new numeric.T(div(this.x,y.x),div(this.y,y.x))}return new numeric.T(div(this.x,y.x))};numeric.T.prototype.dot=numeric.Tbinop("dot(x.x,y.x)","dot(x.x,y.x),dot(x.x,y.y)","dot(x.x,y.x),dot(x.y,y.x)","sub(dot(x.x,y.x),dot(x.y,y.y)),add(dot(x.x,y.y),dot(x.y,y.x))");numeric.T.prototype.transpose=function transpose(){var t=numeric.transpose,x=this.x,y=this.y;if(y){return new numeric.T(t(x),t(y))}return new numeric.T(t(x))};numeric.T.prototype.transjugate=function transjugate(){var t=numeric.transpose,x=this.x,y=this.y;if(y){return new numeric.T(t(x),numeric.negtranspose(y))}return new numeric.T(t(x))};numeric.Tunop=function Tunop(r,c,s){if(typeof s!=="string"){s=""}return Function("var x = this;\n"+s+"\n"+"if(x.y) {"+"  "+c+";\n"+"}\n"+r+";\n")};numeric.T.prototype.exp=numeric.Tunop("return new numeric.T(ex)","return new numeric.T(mul(cos(x.y),ex),mul(sin(x.y),ex))","var ex = numeric.exp(x.x), cos = numeric.cos, sin = numeric.sin, mul = numeric.mul;");numeric.T.prototype.conj=numeric.Tunop("return new numeric.T(x.x);","return new numeric.T(x.x,numeric.neg(x.y));");numeric.T.prototype.neg=numeric.Tunop("return new numeric.T(neg(x.x));","return new numeric.T(neg(x.x),neg(x.y));","var neg = numeric.neg;");numeric.T.prototype.sin=numeric.Tunop("return new numeric.T(numeric.sin(x.x))","return x.exp().sub(x.neg().exp()).div(new numeric.T(0,2));");numeric.T.prototype.cos=numeric.Tunop("return new numeric.T(numeric.cos(x.x))","return x.exp().add(x.neg().exp()).div(2);");numeric.T.prototype.abs=numeric.Tunop("return new numeric.T(numeric.abs(x.x));","return new numeric.T(numeric.sqrt(numeric.add(mul(x.x,x.x),mul(x.y,x.y))));","var mul = numeric.mul;");numeric.T.prototype.log=numeric.Tunop("return new numeric.T(numeric.log(x.x));","var theta = new numeric.T(numeric.atan2(x.y,x.x)), r = x.abs();\n"+"return new numeric.T(numeric.log(r.x),theta.x);");numeric.T.prototype.norm2=numeric.Tunop("return numeric.norm2(x.x);","var f = numeric.norm2Squared;\n"+"return Math.sqrt(f(x.x)+f(x.y));");numeric.T.prototype.inv=function inv(){var A=this;if(typeof A.y==="undefined"){return new numeric.T(numeric.inv(A.x))}var n=A.x.length,i,j,k;var Rx=numeric.identity(n),Ry=numeric.rep([n,n],0);var Ax=numeric.clone(A.x),Ay=numeric.clone(A.y);var Aix,Aiy,Ajx,Ajy,Rix,Riy,Rjx,Rjy;var i,j,k,d,d1,ax,ay,bx,by,temp;for(i=0;i<n;i++){ax=Ax[i][i];ay=Ay[i][i];d=ax*ax+ay*ay;k=i;for(j=i+1;j<n;j++){ax=Ax[j][i];ay=Ay[j][i];d1=ax*ax+ay*ay;if(d1>d){k=j;d=d1}}if(k!==i){temp=Ax[i];Ax[i]=Ax[k];Ax[k]=temp;temp=Ay[i];Ay[i]=Ay[k];Ay[k]=temp;temp=Rx[i];Rx[i]=Rx[k];Rx[k]=temp;temp=Ry[i];Ry[i]=Ry[k];Ry[k]=temp}Aix=Ax[i];Aiy=Ay[i];Rix=Rx[i];Riy=Ry[i];ax=Aix[i];ay=Aiy[i];for(j=i+1;j<n;j++){bx=Aix[j];by=Aiy[j];Aix[j]=(bx*ax+by*ay)/d;Aiy[j]=(by*ax-bx*ay)/d}for(j=0;j<n;j++){bx=Rix[j];by=Riy[j];Rix[j]=(bx*ax+by*ay)/d;Riy[j]=(by*ax-bx*ay)/d}for(j=i+1;j<n;j++){Ajx=Ax[j];Ajy=Ay[j];Rjx=Rx[j];Rjy=Ry[j];ax=Ajx[i];ay=Ajy[i];for(k=i+1;k<n;k++){bx=Aix[k];by=Aiy[k];Ajx[k]-=bx*ax-by*ay;Ajy[k]-=by*ax+bx*ay}for(k=0;k<n;k++){bx=Rix[k];by=Riy[k];Rjx[k]-=bx*ax-by*ay;Rjy[k]-=by*ax+bx*ay}}}for(i=n-1;i>0;i--){Rix=Rx[i];Riy=Ry[i];for(j=i-1;j>=0;j--){Rjx=Rx[j];Rjy=Ry[j];ax=Ax[j][i];ay=Ay[j][i];for(k=n-1;k>=0;k--){bx=Rix[k];by=Riy[k];Rjx[k]-=ax*bx-ay*by;Rjy[k]-=ax*by+ay*bx}}}return new numeric.T(Rx,Ry)};numeric.T.prototype.get=function get(i){var x=this.x,y=this.y,k=0,ik,n=i.length;if(y){while(k<n){ik=i[k];x=x[ik];y=y[ik];k++}return new numeric.T(x,y)}while(k<n){ik=i[k];x=x[ik];k++}return new numeric.T(x)};numeric.T.prototype.set=function set(i,v){var x=this.x,y=this.y,k=0,ik,n=i.length,vx=v.x,vy=v.y;if(n===0){if(vy){this.y=vy}else{if(y){this.y=undefined}}this.x=x;return this}if(vy){if(y){}else{y=numeric.rep(numeric.dim(x),0);this.y=y}while(k<n-1){ik=i[k];x=x[ik];y=y[ik];k++}ik=i[k];x[ik]=vx;y[ik]=vy;return this}if(y){while(k<n-1){ik=i[k];x=x[ik];y=y[ik];k++}ik=i[k];x[ik]=vx;if(vx instanceof Array){y[ik]=numeric.rep(numeric.dim(vx),0)}else{y[ik]=0}return this}while(k<n-1){ik=i[k];x=x[ik];k++}ik=i[k];x[ik]=vx;return this};numeric.T.prototype.getRows=function getRows(i0,i1){var n=i1-i0+1,j;var rx=Array(n),ry,x=this.x,y=this.y;for(j=i0;j<=i1;j++){rx[j-i0]=x[j]}if(y){ry=Array(n);for(j=i0;j<=i1;j++){ry[j-i0]=y[j]}return new numeric.T(rx,ry)}return new numeric.T(rx)};numeric.T.prototype.setRows=function setRows(i0,i1,A){var j;var rx=this.x,ry=this.y,x=A.x,y=A.y;for(j=i0;j<=i1;j++){rx[j]=x[j-i0]}if(y){if(!ry){ry=numeric.rep(numeric.dim(rx),0);this.y=ry}for(j=i0;j<=i1;j++){ry[j]=y[j-i0]}}else{if(ry){for(j=i0;j<=i1;j++){ry[j]=numeric.rep([x[j-i0].length],0)}}}return this};numeric.T.prototype.getRow=function getRow(k){var x=this.x,y=this.y;if(y){return new numeric.T(x[k],y[k])}return new numeric.T(x[k])};numeric.T.prototype.setRow=function setRow(i,v){var rx=this.x,ry=this.y,x=v.x,y=v.y;rx[i]=x;if(y){if(!ry){ry=numeric.rep(numeric.dim(rx),0);this.y=ry}ry[i]=y}else{if(ry){ry=numeric.rep([x.length],0)}}return this};numeric.T.prototype.getBlock=function getBlock(from,to){var x=this.x,y=this.y,b=numeric.getBlock;if(y){return new numeric.T(b(x,from,to),b(y,from,to))}return new numeric.T(b(x,from,to))};numeric.T.prototype.setBlock=function setBlock(from,to,A){if(!(A instanceof numeric.T)){A=new numeric.T(A)}var x=this.x,y=this.y,b=numeric.setBlock,Ax=A.x,Ay=A.y;if(Ay){if(!y){this.y=numeric.rep(numeric.dim(this),0);y=this.y}b(x,from,to,Ax);b(y,from,to,Ay);return this}b(x,from,to,Ax);if(y){b(y,from,to,numeric.rep(numeric.dim(Ax),0))}};numeric.T.rep=function rep(s,v){var T=numeric.T;if(!(v instanceof T)){v=new T(v)}var x=v.x,y=v.y,r=numeric.rep;if(y){return new T(r(s,x),r(s,y))}return new T(r(s,x))};numeric.T.diag=function diag(d){if(!(d instanceof numeric.T)){d=new numeric.T(d)}var x=d.x,y=d.y,diag=numeric.diag;if(y){return new numeric.T(diag(x),diag(y))}return new numeric.T(diag(x))};numeric.T.eig=function eig(){if(this.y){throw new Error("eig: not implemented for complex matrices.")}return numeric.eig(this.x)};numeric.T.identity=function identity(n){return new numeric.T(numeric.identity(n))};numeric.T.prototype.getDiag=function getDiag(){var n=numeric;var x=this.x,y=this.y;if(y){return new n.T(n.getDiag(x),n.getDiag(y))}return new n.T(n.getDiag(x))};numeric.house=function house(x){var v=numeric.clone(x);var s=x[0]>=0?1:-1;var alpha=s*numeric.norm2(x);v[0]+=alpha;var foo=numeric.norm2(v);if(foo===0){throw new Error("eig: internal error")}return numeric.div(v,foo)};numeric.toUpperHessenberg=function toUpperHessenberg(me){var s=numeric.dim(me);if(s.length!==2||s[0]!==s[1]){throw new Error("numeric: toUpperHessenberg() only works on square matrices")}var m=s[0],i,j,k,x,v,A=numeric.clone(me),B,C,Ai,Ci,Q=numeric.identity(m),Qi;for(j=0;j<m-2;j++){x=Array(m-j-1);for(i=j+1;i<m;i++){x[i-j-1]=A[i][j]}if(numeric.norm2(x)>0){v=numeric.house(x);B=numeric.getBlock(A,[j+1,j],[m-1,m-1]);C=numeric.tensor(v,numeric.dot(v,B));for(i=j+1;i<m;i++){Ai=A[i];Ci=C[i-j-1];for(k=j;k<m;k++){Ai[k]-=2*Ci[k-j]}}B=numeric.getBlock(A,[0,j+1],[m-1,m-1]);C=numeric.tensor(numeric.dot(B,v),v);for(i=0;i<m;i++){Ai=A[i];Ci=C[i];for(k=j+1;k<m;k++){Ai[k]-=2*Ci[k-j-1]}}B=Array(m-j-1);for(i=j+1;i<m;i++){B[i-j-1]=Q[i]}C=numeric.tensor(v,numeric.dot(v,B));for(i=j+1;i<m;i++){Qi=Q[i];Ci=C[i-j-1];for(k=0;k<m;k++){Qi[k]-=2*Ci[k]}}}}return{H:A,Q:Q}};numeric.epsilon=2.220446049250313e-16;numeric.QRFrancis=function(H,maxiter){if(typeof maxiter==="undefined"){maxiter=10000}H=numeric.clone(H);var H0=numeric.clone(H);var s=numeric.dim(H),m=s[0],x,v,a,b,c,d,det,tr,Hloc,Q=numeric.identity(m),Qi,Hi,B,C,Ci,i,j,k,iter;if(m<3){return{Q:Q,B:[[0,m-1]]}}var epsilon=numeric.epsilon;for(iter=0;iter<maxiter;iter++){for(j=0;j<m-1;j++){if(Math.abs(H[j+1][j])<epsilon*(Math.abs(H[j][j])+Math.abs(H[j+1][j+1]))){var QH1=numeric.QRFrancis(numeric.getBlock(H,[0,0],[j,j]),maxiter);var QH2=numeric.QRFrancis(numeric.getBlock(H,[j+1,j+1],[m-1,m-1]),maxiter);B=Array(j+1);for(i=0;i<=j;i++){B[i]=Q[i]}C=numeric.dot(QH1.Q,B);for(i=0;i<=j;i++){Q[i]=C[i]}B=Array(m-j-1);for(i=j+1;i<m;i++){B[i-j-1]=Q[i]}C=numeric.dot(QH2.Q,B);for(i=j+1;i<m;i++){Q[i]=C[i-j-1]}return{Q:Q,B:QH1.B.concat(numeric.add(QH2.B,j+1))}}}a=H[m-2][m-2];b=H[m-2][m-1];c=H[m-1][m-2];d=H[m-1][m-1];tr=a+d;det=(a*d-b*c);Hloc=numeric.getBlock(H,[0,0],[2,2]);if(tr*tr>=4*det){var s1,s2;s1=0.5*(tr+Math.sqrt(tr*tr-4*det));s2=0.5*(tr-Math.sqrt(tr*tr-4*det));Hloc=numeric.add(numeric.sub(numeric.dot(Hloc,Hloc),numeric.mul(Hloc,s1+s2)),numeric.diag(numeric.rep([3],s1*s2)))}else{Hloc=numeric.add(numeric.sub(numeric.dot(Hloc,Hloc),numeric.mul(Hloc,tr)),numeric.diag(numeric.rep([3],det)))}x=[Hloc[0][0],Hloc[1][0],Hloc[2][0]];v=numeric.house(x);B=[H[0],H[1],H[2]];C=numeric.tensor(v,numeric.dot(v,B));for(i=0;i<3;i++){Hi=H[i];Ci=C[i];for(k=0;k<m;k++){Hi[k]-=2*Ci[k]}}B=numeric.getBlock(H,[0,0],[m-1,2]);C=numeric.tensor(numeric.dot(B,v),v);for(i=0;i<m;i++){Hi=H[i];Ci=C[i];for(k=0;k<3;k++){Hi[k]-=2*Ci[k]}}B=[Q[0],Q[1],Q[2]];C=numeric.tensor(v,numeric.dot(v,B));for(i=0;i<3;i++){Qi=Q[i];Ci=C[i];for(k=0;k<m;k++){Qi[k]-=2*Ci[k]}}var J;for(j=0;j<m-2;j++){for(k=j;k<=j+1;k++){if(Math.abs(H[k+1][k])<epsilon*(Math.abs(H[k][k])+Math.abs(H[k+1][k+1]))){var QH1=numeric.QRFrancis(numeric.getBlock(H,[0,0],[k,k]),maxiter);var QH2=numeric.QRFrancis(numeric.getBlock(H,[k+1,k+1],[m-1,m-1]),maxiter);B=Array(k+1);for(i=0;i<=k;i++){B[i]=Q[i]}C=numeric.dot(QH1.Q,B);for(i=0;i<=k;i++){Q[i]=C[i]}B=Array(m-k-1);for(i=k+1;i<m;i++){B[i-k-1]=Q[i]}C=numeric.dot(QH2.Q,B);for(i=k+1;i<m;i++){Q[i]=C[i-k-1]}return{Q:Q,B:QH1.B.concat(numeric.add(QH2.B,k+1))}}}J=Math.min(m-1,j+3);x=Array(J-j);for(i=j+1;i<=J;i++){x[i-j-1]=H[i][j]}v=numeric.house(x);B=numeric.getBlock(H,[j+1,j],[J,m-1]);C=numeric.tensor(v,numeric.dot(v,B));for(i=j+1;i<=J;i++){Hi=H[i];Ci=C[i-j-1];for(k=j;k<m;k++){Hi[k]-=2*Ci[k-j]}}B=numeric.getBlock(H,[0,j+1],[m-1,J]);C=numeric.tensor(numeric.dot(B,v),v);for(i=0;i<m;i++){Hi=H[i];Ci=C[i];for(k=j+1;k<=J;k++){Hi[k]-=2*Ci[k-j-1]}}B=Array(J-j);for(i=j+1;i<=J;i++){B[i-j-1]=Q[i]}C=numeric.tensor(v,numeric.dot(v,B));for(i=j+1;i<=J;i++){Qi=Q[i];Ci=C[i-j-1];for(k=0;k<m;k++){Qi[k]-=2*Ci[k]}}}}throw new Error("numeric: eigenvalue iteration does not converge -- increase maxiter?")};numeric.eig=function eig(A,maxiter){var QH=numeric.toUpperHessenberg(A);var QB=numeric.QRFrancis(QH.H,maxiter);var T=numeric.T;var n=A.length,i,k,flag=false,B=QB.B,H=numeric.dot(QB.Q,numeric.dot(QH.H,numeric.transpose(QB.Q)));var Q=new T(numeric.dot(QB.Q,QH.Q)),Q0;var m=B.length,j;var a,b,c,d,p1,p2,disc,x,y,p,q,n1,n2;var sqrt=Math.sqrt;for(k=0;k<m;k++){i=B[k][0];if(i===B[k][1]){}else{j=i+1;a=H[i][i];b=H[i][j];c=H[j][i];d=H[j][j];if(b===0&&c===0){continue}p1=-a-d;p2=a*d-b*c;disc=p1*p1-4*p2;if(disc>=0){if(p1<0){x=-0.5*(p1-sqrt(disc))}else{x=-0.5*(p1+sqrt(disc))}n1=(a-x)*(a-x)+b*b;n2=c*c+(d-x)*(d-x);if(n1>n2){n1=sqrt(n1);p=(a-x)/n1;q=b/n1}else{n2=sqrt(n2);p=c/n2;q=(d-x)/n2}Q0=new T([[q,-p],[p,q]]);Q.setRows(i,j,Q0.dot(Q.getRows(i,j)))}else{x=-0.5*p1;y=0.5*sqrt(-disc);n1=(a-x)*(a-x)+b*b;n2=c*c+(d-x)*(d-x);if(n1>n2){n1=sqrt(n1+y*y);p=(a-x)/n1;q=b/n1;x=0;y/=n1}else{n2=sqrt(n2+y*y);p=c/n2;q=(d-x)/n2;x=y/n2;y=0}Q0=new T([[q,-p],[p,q]],[[x,y],[y,-x]]);Q.setRows(i,j,Q0.dot(Q.getRows(i,j)))}}}var R=Q.dot(A).dot(Q.transjugate()),n=A.length,E=numeric.T.identity(n);for(j=0;j<n;j++){if(j>0){for(k=j-1;k>=0;k--){var Rk=R.get([k,k]),Rj=R.get([j,j]);if(numeric.neq(Rk.x,Rj.x)||numeric.neq(Rk.y,Rj.y)){x=R.getRow(k).getBlock([k],[j-1]);y=E.getRow(j).getBlock([k],[j-1]);E.set([j,k],(R.get([k,j]).neg().sub(x.dot(y))).div(Rk.sub(Rj)))}else{E.setRow(j,E.getRow(k));continue}}}}for(j=0;j<n;j++){x=E.getRow(j);E.setRow(j,x.div(x.norm2()))}E=E.transpose();E=Q.transjugate().dot(E);return{lambda:R.getDiag(),E:E}};numeric.ccsSparse=function ccsSparse(A){var m=A.length,n,foo,i,j,counts=[];for(i=m-1;i!==-1;--i){foo=A[i];for(j in foo){j=parseInt(j);while(j>=counts.length){counts[counts.length]=0}if(foo[j]!==0){counts[j]++}}}var n=counts.length;var Ai=Array(n+1);Ai[0]=0;for(i=0;i<n;++i){Ai[i+1]=Ai[i]+counts[i]}var Aj=Array(Ai[n]),Av=Array(Ai[n]);for(i=m-1;i!==-1;--i){foo=A[i];for(j in foo){if(foo[j]!==0){counts[j]--;Aj[Ai[j]+counts[j]]=i;Av[Ai[j]+counts[j]]=foo[j]}}}return[Ai,Aj,Av]};numeric.ccsFull=function ccsFull(A){var Ai=A[0],Aj=A[1],Av=A[2],s=numeric.ccsDim(A),m=s[0],n=s[1],i,j,j0,j1,k;var B=numeric.rep([m,n],0);for(i=0;i<n;i++){j0=Ai[i];j1=Ai[i+1];for(j=j0;j<j1;++j){B[Aj[j]][i]=Av[j]}}return B};numeric.ccsTSolve=function ccsTSolve(A,b,x,bj,xj){var Ai=A[0],Aj=A[1],Av=A[2],m=Ai.length-1,max=Math.max,n=0;if(typeof bj==="undefined"){x=numeric.rep([m],0)}if(typeof bj==="undefined"){bj=numeric.linspace(0,x.length-1)}if(typeof xj==="undefined"){xj=[]}function dfs(j){var k;if(x[j]!==0){return}x[j]=1;for(k=Ai[j];k<Ai[j+1];++k){dfs(Aj[k])}xj[n]=j;++n}var i,j,j0,j1,k,l,l0,l1,a;for(i=bj.length-1;i!==-1;--i){dfs(bj[i])}xj.length=n;for(i=xj.length-1;i!==-1;--i){x[xj[i]]=0}for(i=bj.length-1;i!==-1;--i){j=bj[i];x[j]=b[j]}for(i=xj.length-1;i!==-1;--i){j=xj[i];j0=Ai[j];j1=max(Ai[j+1],j0);for(k=j0;k!==j1;++k){if(Aj[k]===j){x[j]/=Av[k];break}}a=x[j];for(k=j0;k!==j1;++k){l=Aj[k];if(l!==j){x[l]-=a*Av[k]}}}return x};numeric.ccsDFS=function ccsDFS(n){this.k=Array(n);this.k1=Array(n);this.j=Array(n)};numeric.ccsDFS.prototype.dfs=function dfs(J,Ai,Aj,x,xj,Pinv){var m=0,foo,n=xj.length;var k=this.k,k1=this.k1,j=this.j,km,k11;if(x[J]!==0){return}x[J]=1;j[0]=J;k[0]=km=Ai[J];k1[0]=k11=Ai[J+1];while(1){if(km>=k11){xj[n]=j[m];if(m===0){return}++n;--m;km=k[m];k11=k1[m]}else{foo=Pinv[Aj[km]];if(x[foo]===0){x[foo]=1;k[m]=km;++m;j[m]=foo;km=Ai[foo];k1[m]=k11=Ai[foo+1]}else{++km}}}};numeric.ccsLPSolve=function ccsLPSolve(A,B,x,xj,I,Pinv,dfs){var Ai=A[0],Aj=A[1],Av=A[2],m=Ai.length-1,n=0;var Bi=B[0],Bj=B[1],Bv=B[2];var i,i0,i1,j,J,j0,j1,k,l,l0,l1,a;i0=Bi[I];i1=Bi[I+1];xj.length=0;for(i=i0;i<i1;++i){dfs.dfs(Pinv[Bj[i]],Ai,Aj,x,xj,Pinv)}for(i=xj.length-1;i!==-1;--i){x[xj[i]]=0}for(i=i0;i!==i1;++i){j=Pinv[Bj[i]];x[j]=Bv[i]}for(i=xj.length-1;i!==-1;--i){j=xj[i];j0=Ai[j];j1=Ai[j+1];for(k=j0;k<j1;++k){if(Pinv[Aj[k]]===j){x[j]/=Av[k];break}}a=x[j];for(k=j0;k<j1;++k){l=Pinv[Aj[k]];if(l!==j){x[l]-=a*Av[k]}}}return x};numeric.ccsLUP1=function ccsLUP1(A,threshold){var m=A[0].length-1;var L=[numeric.rep([m+1],0),[],[]],U=[numeric.rep([m+1],0),[],[]];var Li=L[0],Lj=L[1],Lv=L[2],Ui=U[0],Uj=U[1],Uv=U[2];var x=numeric.rep([m],0),xj=numeric.rep([m],0);var i,j,k,j0,j1,a,e,c,d,K;var sol=numeric.ccsLPSolve,max=Math.max,abs=Math.abs;var P=numeric.linspace(0,m-1),Pinv=numeric.linspace(0,m-1);var dfs=new numeric.ccsDFS(m);if(typeof threshold==="undefined"){threshold=1}for(i=0;i<m;++i){sol(L,A,x,xj,i,Pinv,dfs);a=-1;e=-1;for(j=xj.length-1;j!==-1;--j){k=xj[j];if(k<=i){continue}c=abs(x[k]);if(c>a){e=k;a=c}}if(abs(x[i])<threshold*a){j=P[i];a=P[e];P[i]=a;Pinv[a]=i;P[e]=j;Pinv[j]=e;a=x[i];x[i]=x[e];x[e]=a}a=Li[i];e=Ui[i];d=x[i];Lj[a]=P[i];Lv[a]=1;++a;for(j=xj.length-1;j!==-1;--j){k=xj[j];c=x[k];xj[j]=0;x[k]=0;if(k<=i){Uj[e]=k;Uv[e]=c;++e}else{Lj[a]=P[k];Lv[a]=c/d;++a}}Li[i+1]=a;Ui[i+1]=e}for(j=Lj.length-1;j!==-1;--j){Lj[j]=Pinv[Lj[j]]}return{L:L,U:U,P:P,Pinv:Pinv}};numeric.ccsDFS0=function ccsDFS0(n){this.k=Array(n);this.k1=Array(n);this.j=Array(n)};numeric.ccsDFS0.prototype.dfs=function dfs(J,Ai,Aj,x,xj,Pinv,P){var m=0,foo,n=xj.length;var k=this.k,k1=this.k1,j=this.j,km,k11;if(x[J]!==0){return}x[J]=1;j[0]=J;k[0]=km=Ai[Pinv[J]];k1[0]=k11=Ai[Pinv[J]+1];while(1){if(isNaN(km)){throw new Error("Ow!")}if(km>=k11){xj[n]=Pinv[j[m]];if(m===0){return}++n;--m;km=k[m];k11=k1[m]}else{foo=Aj[km];if(x[foo]===0){x[foo]=1;k[m]=km;++m;j[m]=foo;foo=Pinv[foo];km=Ai[foo];k1[m]=k11=Ai[foo+1]}else{++km}}}};numeric.ccsLPSolve0=function ccsLPSolve0(A,B,y,xj,I,Pinv,P,dfs){var Ai=A[0],Aj=A[1],Av=A[2],m=Ai.length-1,n=0;var Bi=B[0],Bj=B[1],Bv=B[2];var i,i0,i1,j,J,j0,j1,k,l,l0,l1,a;i0=Bi[I];i1=Bi[I+1];xj.length=0;for(i=i0;i<i1;++i){dfs.dfs(Bj[i],Ai,Aj,y,xj,Pinv,P)}for(i=xj.length-1;i!==-1;--i){j=xj[i];y[P[j]]=0}for(i=i0;i!==i1;++i){j=Bj[i];y[j]=Bv[i]}for(i=xj.length-1;i!==-1;--i){j=xj[i];l=P[j];j0=Ai[j];j1=Ai[j+1];for(k=j0;k<j1;++k){if(Aj[k]===l){y[l]/=Av[k];break}}a=y[l];for(k=j0;k<j1;++k){y[Aj[k]]-=a*Av[k]}y[l]=a}};numeric.ccsLUP0=function ccsLUP0(A,threshold){var m=A[0].length-1;var L=[numeric.rep([m+1],0),[],[]],U=[numeric.rep([m+1],0),[],[]];var Li=L[0],Lj=L[1],Lv=L[2],Ui=U[0],Uj=U[1],Uv=U[2];var y=numeric.rep([m],0),xj=numeric.rep([m],0);var i,j,k,j0,j1,a,e,c,d,K;var sol=numeric.ccsLPSolve0,max=Math.max,abs=Math.abs;var P=numeric.linspace(0,m-1),Pinv=numeric.linspace(0,m-1);var dfs=new numeric.ccsDFS0(m);if(typeof threshold==="undefined"){threshold=1}for(i=0;i<m;++i){sol(L,A,y,xj,i,Pinv,P,dfs);a=-1;e=-1;for(j=xj.length-1;j!==-1;--j){k=xj[j];if(k<=i){continue}c=abs(y[P[k]]);if(c>a){e=k;a=c}}if(abs(y[P[i]])<threshold*a){j=P[i];a=P[e];P[i]=a;Pinv[a]=i;P[e]=j;Pinv[j]=e}a=Li[i];e=Ui[i];d=y[P[i]];Lj[a]=P[i];Lv[a]=1;++a;for(j=xj.length-1;j!==-1;--j){k=xj[j];c=y[P[k]];xj[j]=0;y[P[k]]=0;if(k<=i){Uj[e]=k;Uv[e]=c;++e}else{Lj[a]=P[k];Lv[a]=c/d;++a}}Li[i+1]=a;Ui[i+1]=e}for(j=Lj.length-1;j!==-1;--j){Lj[j]=Pinv[Lj[j]]}return{L:L,U:U,P:P,Pinv:Pinv}};numeric.ccsLUP=numeric.ccsLUP0;numeric.ccsDim=function ccsDim(A){return[numeric.sup(A[1])+1,A[0].length-1]};numeric.ccsGetBlock=function ccsGetBlock(A,i,j){var s=numeric.ccsDim(A),m=s[0],n=s[1];if(typeof i==="undefined"){i=numeric.linspace(0,m-1)}else{if(typeof i==="number"){i=[i]}}if(typeof j==="undefined"){j=numeric.linspace(0,n-1)}else{if(typeof j==="number"){j=[j]}}var p,p0,p1,P=i.length,q,Q=j.length,r,jq,ip;var Bi=numeric.rep([n],0),Bj=[],Bv=[],B=[Bi,Bj,Bv];var Ai=A[0],Aj=A[1],Av=A[2];var x=numeric.rep([m],0),count=0,flags=numeric.rep([m],0);for(q=0;q<Q;++q){jq=j[q];var q0=Ai[jq];var q1=Ai[jq+1];for(p=q0;p<q1;++p){r=Aj[p];flags[r]=1;x[r]=Av[p]}for(p=0;p<P;++p){ip=i[p];if(flags[ip]){Bj[count]=p;Bv[count]=x[i[p]];++count}}for(p=q0;p<q1;++p){r=Aj[p];flags[r]=0}Bi[q+1]=count}return B};numeric.ccsDot=function ccsDot(A,B){var Ai=A[0],Aj=A[1],Av=A[2];var Bi=B[0],Bj=B[1],Bv=B[2];var sA=numeric.ccsDim(A),sB=numeric.ccsDim(B);var m=sA[0],n=sA[1],o=sB[1];var x=numeric.rep([m],0),flags=numeric.rep([m],0),xj=Array(m);var Ci=numeric.rep([o],0),Cj=[],Cv=[],C=[Ci,Cj,Cv];var i,j,k,j0,j1,i0,i1,l,p,a,b;for(k=0;k!==o;++k){j0=Bi[k];j1=Bi[k+1];p=0;for(j=j0;j<j1;++j){a=Bj[j];b=Bv[j];i0=Ai[a];i1=Ai[a+1];for(i=i0;i<i1;++i){l=Aj[i];if(flags[l]===0){xj[p]=l;flags[l]=1;p=p+1}x[l]=x[l]+Av[i]*b}}j0=Ci[k];j1=j0+p;Ci[k+1]=j1;for(j=p-1;j!==-1;--j){b=j0+j;i=xj[j];Cj[b]=i;Cv[b]=x[i];flags[i]=0;x[i]=0}Ci[k+1]=Ci[k]+p}return C};numeric.ccsLUPSolve=function ccsLUPSolve(LUP,B){var L=LUP.L,U=LUP.U,P=LUP.P;var Bi=B[0];var flag=false;if(typeof Bi!=="object"){B=[[0,B.length],numeric.linspace(0,B.length-1),B];Bi=B[0];flag=true}var Bj=B[1],Bv=B[2];var n=L[0].length-1,m=Bi.length-1;var x=numeric.rep([n],0),xj=Array(n);var b=numeric.rep([n],0),bj=Array(n);var Xi=numeric.rep([m+1],0),Xj=[],Xv=[];var sol=numeric.ccsTSolve;var i,j,j0,j1,k,J,N=0;for(i=0;i<m;++i){k=0;j0=Bi[i];j1=Bi[i+1];for(j=j0;j<j1;++j){J=LUP.Pinv[Bj[j]];bj[k]=J;b[J]=Bv[j];++k}bj.length=k;sol(L,b,x,bj,xj);for(j=bj.length-1;j!==-1;--j){b[bj[j]]=0}sol(U,x,b,xj,bj);if(flag){return b}for(j=xj.length-1;j!==-1;--j){x[xj[j]]=0}for(j=bj.length-1;j!==-1;--j){J=bj[j];Xj[N]=J;Xv[N]=b[J];b[J]=0;++N}Xi[i+1]=N}return[Xi,Xj,Xv]};numeric.ccsbinop=function ccsbinop(body,setup){if(typeof setup==="undefined"){setup=""}return Function("X","Y","var Xi = X[0], Xj = X[1], Xv = X[2];\n"+"var Yi = Y[0], Yj = Y[1], Yv = Y[2];\n"+"var n = Xi.length-1,m = Math.max(numeric.sup(Xj),numeric.sup(Yj))+1;\n"+"var Zi = numeric.rep([n+1],0), Zj = [], Zv = [];\n"+"var x = numeric.rep([m],0),y = numeric.rep([m],0);\n"+"var xk,yk,zk;\n"+"var i,j,j0,j1,k,p=0;\n"+setup+"for(i=0;i<n;++i) {\n"+"  j0 = Xi[i]; j1 = Xi[i+1];\n"+"  for(j=j0;j!==j1;++j) {\n"+"    k = Xj[j];\n"+"    x[k] = 1;\n"+"    Zj[p] = k;\n"+"    ++p;\n"+"  }\n"+"  j0 = Yi[i]; j1 = Yi[i+1];\n"+"  for(j=j0;j!==j1;++j) {\n"+"    k = Yj[j];\n"+"    y[k] = Yv[j];\n"+"    if(x[k] === 0) {\n"+"      Zj[p] = k;\n"+"      ++p;\n"+"    }\n"+"  }\n"+"  Zi[i+1] = p;\n"+"  j0 = Xi[i]; j1 = Xi[i+1];\n"+"  for(j=j0;j!==j1;++j) x[Xj[j]] = Xv[j];\n"+"  j0 = Zi[i]; j1 = Zi[i+1];\n"+"  for(j=j0;j!==j1;++j) {\n"+"    k = Zj[j];\n"+"    xk = x[k];\n"+"    yk = y[k];\n"+body+"\n"+"    Zv[j] = zk;\n"+"  }\n"+"  j0 = Xi[i]; j1 = Xi[i+1];\n"+"  for(j=j0;j!==j1;++j) x[Xj[j]] = 0;\n"+"  j0 = Yi[i]; j1 = Yi[i+1];\n"+"  for(j=j0;j!==j1;++j) y[Yj[j]] = 0;\n"+"}\n"+"return [Zi,Zj,Zv];")};(function(){var k,A,B,C;for(k in numeric.ops2){if(isFinite(eval("1"+numeric.ops2[k]+"0"))){A="[Y[0],Y[1],numeric."+k+"(X,Y[2])]"}else{A="NaN"}if(isFinite(eval("0"+numeric.ops2[k]+"1"))){B="[X[0],X[1],numeric."+k+"(X[2],Y)]"}else{B="NaN"}if(isFinite(eval("1"+numeric.ops2[k]+"0"))&&isFinite(eval("0"+numeric.ops2[k]+"1"))){C="numeric.ccs"+k+"MM(X,Y)"}else{C="NaN"}numeric["ccs"+k+"MM"]=numeric.ccsbinop("zk = xk "+numeric.ops2[k]+"yk;");numeric["ccs"+k]=Function("X","Y",'if(typeof X === "number") return '+A+";\n"+'if(typeof Y === "number") return '+B+";\n"+"return "+C+";\n")}}());numeric.ccsScatter=function ccsScatter(A){var Ai=A[0],Aj=A[1],Av=A[2];var n=numeric.sup(Aj)+1,m=Ai.length;var Ri=numeric.rep([n],0),Rj=Array(m),Rv=Array(m);var counts=numeric.rep([n],0),i;for(i=0;i<m;++i){counts[Aj[i]]++}for(i=0;i<n;++i){Ri[i+1]=Ri[i]+counts[i]}var ptr=Ri.slice(0),k,Aii;for(i=0;i<m;++i){Aii=Aj[i];k=ptr[Aii];Rj[k]=Ai[i];Rv[k]=Av[i];ptr[Aii]=ptr[Aii]+1}return[Ri,Rj,Rv]};numeric.ccsGather=function ccsGather(A){var Ai=A[0],Aj=A[1],Av=A[2];var n=Ai.length-1,m=Aj.length;var Ri=Array(m),Rj=Array(m),Rv=Array(m);var i,j,j0,j1,p;p=0;for(i=0;i<n;++i){j0=Ai[i];j1=Ai[i+1];for(j=j0;j!==j1;++j){Rj[p]=i;Ri[p]=Aj[j];Rv[p]=Av[j];++p}}return[Ri,Rj,Rv]};numeric.sdim=function dim(A,ret,k){if(typeof ret==="undefined"){ret=[]}if(typeof A!=="object"){return ret}if(typeof k==="undefined"){k=0}if(!(k in ret)){ret[k]=0}if(A.length>ret[k]){ret[k]=A.length}var i;for(i in A){if(A.hasOwnProperty(i)){dim(A[i],ret,k+1)}}return ret};numeric.sclone=function clone(A,k,n){if(typeof k==="undefined"){k=0}if(typeof n==="undefined"){n=numeric.sdim(A).length}var i,ret=Array(A.length);if(k===n-1){for(i in A){if(A.hasOwnProperty(i)){ret[i]=A[i]}}return ret}for(i in A){if(A.hasOwnProperty(i)){ret[i]=clone(A[i],k+1,n)}}return ret};numeric.sdiag=function diag(d){var n=d.length,i,ret=Array(n),i1,i2,i3;for(i=n-1;i>=1;i-=2){i1=i-1;ret[i]=[];ret[i][i]=d[i];ret[i1]=[];ret[i1][i1]=d[i1]}if(i===0){ret[0]=[];ret[0][0]=d[i]}return ret};numeric.sidentity=function identity(n){return numeric.sdiag(numeric.rep([n],1))};numeric.stranspose=function transpose(A){var ret=[],n=A.length,i,j,Ai;for(i in A){if(!(A.hasOwnProperty(i))){continue}Ai=A[i];for(j in Ai){if(!(Ai.hasOwnProperty(j))){continue}if(typeof ret[j]!=="object"){ret[j]=[]}ret[j][i]=Ai[j]}}return ret};numeric.sLUP=function LUP(A,tol){throw new Error("The function numeric.sLUP had a bug in it and has been removed. Please use the new numeric.ccsLUP function instead.")};numeric.sdotMM=function dotMM(A,B){var p=A.length,q=B.length,BT=numeric.stranspose(B),r=BT.length,Ai,BTk;var i,j,k,accum;var ret=Array(p),reti;for(i=p-1;i>=0;i--){reti=[];Ai=A[i];for(k=r-1;k>=0;k--){accum=0;BTk=BT[k];for(j in Ai){if(!(Ai.hasOwnProperty(j))){continue}if(j in BTk){accum+=Ai[j]*BTk[j]}}if(accum){reti[k]=accum}}ret[i]=reti}return ret};numeric.sdotMV=function dotMV(A,x){var p=A.length,Ai,i,j;var ret=Array(p),accum;for(i=p-1;i>=0;i--){Ai=A[i];accum=0;for(j in Ai){if(!(Ai.hasOwnProperty(j))){continue}if(x[j]){accum+=Ai[j]*x[j]}}if(accum){ret[i]=accum}}return ret};numeric.sdotVM=function dotMV(x,A){var i,j,Ai,alpha;var ret=[],accum;for(i in x){if(!x.hasOwnProperty(i)){continue}Ai=A[i];alpha=x[i];for(j in Ai){if(!Ai.hasOwnProperty(j)){continue}if(!ret[j]){ret[j]=0}ret[j]+=alpha*Ai[j]}}return ret};numeric.sdotVV=function dotVV(x,y){var i,ret=0;for(i in x){if(x[i]&&y[i]){ret+=x[i]*y[i]}}return ret};numeric.sdot=function dot(A,B){var m=numeric.sdim(A).length,n=numeric.sdim(B).length;var k=m*1000+n;switch(k){case 0:return A*B;case 1001:return numeric.sdotVV(A,B);case 2001:return numeric.sdotMV(A,B);case 1002:return numeric.sdotVM(A,B);case 2002:return numeric.sdotMM(A,B);default:throw new Error("numeric.sdot not implemented for tensors of order "+m+" and "+n)}};numeric.sscatter=function scatter(V){var n=V[0].length,Vij,i,j,m=V.length,A=[],Aj;for(i=n-1;i>=0;--i){if(!V[m-1][i]){continue}Aj=A;for(j=0;j<m-2;j++){Vij=V[j][i];if(!Aj[Vij]){Aj[Vij]=[]}Aj=Aj[Vij]}Aj[V[j][i]]=V[j+1][i]}return A};numeric.sgather=function gather(A,ret,k){if(typeof ret==="undefined"){ret=[]}if(typeof k==="undefined"){k=[]}var n,i,Ai;n=k.length;for(i in A){if(A.hasOwnProperty(i)){k[n]=parseInt(i);Ai=A[i];if(typeof Ai==="number"){if(Ai){if(ret.length===0){for(i=n+1;i>=0;--i){ret[i]=[]}}for(i=n;i>=0;--i){ret[i].push(k[i])}ret[n+1].push(Ai)}}else{gather(Ai,ret,k)}}}if(k.length>n){k.pop()}return ret};numeric.cLU=function LU(A){var I=A[0],J=A[1],V=A[2];var p=I.length,m=0,i,j,k,a,b,c;for(i=0;i<p;i++){if(I[i]>m){m=I[i]}}m++;var L=Array(m),U=Array(m),left=numeric.rep([m],Infinity),right=numeric.rep([m],-Infinity);var Ui,Uj,alpha;for(k=0;k<p;k++){i=I[k];j=J[k];if(j<left[i]){left[i]=j}if(j>right[i]){right[i]=j}}for(i=0;i<m-1;i++){if(right[i]>right[i+1]){right[i+1]=right[i]}}for(i=m-1;i>=1;i--){if(left[i]<left[i-1]){left[i-1]=left[i]}}var countL=0,countU=0;for(i=0;i<m;i++){U[i]=numeric.rep([right[i]-left[i]+1],0);L[i]=numeric.rep([i-left[i]],0);countL+=i-left[i]+1;countU+=right[i]-i+1}for(k=0;k<p;k++){i=I[k];U[i][J[k]-left[i]]=V[k]}for(i=0;i<m-1;i++){a=i-left[i];Ui=U[i];for(j=i+1;left[j]<=i&&j<m;j++){b=i-left[j];c=right[i]-i;Uj=U[j];alpha=Uj[b]/Ui[a];if(alpha){for(k=1;k<=c;k++){Uj[k+b]-=alpha*Ui[k+a]}L[j][i-left[j]]=alpha}}}var Ui=[],Uj=[],Uv=[],Li=[],Lj=[],Lv=[];var p,q,foo;p=0;q=0;for(i=0;i<m;i++){a=left[i];b=right[i];foo=U[i];for(j=i;j<=b;j++){if(foo[j-a]){Ui[p]=i;Uj[p]=j;Uv[p]=foo[j-a];p++}}foo=L[i];for(j=a;j<i;j++){if(foo[j-a]){Li[q]=i;Lj[q]=j;Lv[q]=foo[j-a];q++}}Li[q]=i;Lj[q]=i;Lv[q]=1;q++}return{U:[Ui,Uj,Uv],L:[Li,Lj,Lv]}};numeric.cLUsolve=function LUsolve(lu,b){var L=lu.L,U=lu.U,ret=numeric.clone(b);var Li=L[0],Lj=L[1],Lv=L[2];var Ui=U[0],Uj=U[1],Uv=U[2];var p=Ui.length,q=Li.length;var m=ret.length,i,j,k;k=0;for(i=0;i<m;i++){while(Lj[k]<i){ret[i]-=Lv[k]*ret[Lj[k]];k++}k++}k=p-1;for(i=m-1;i>=0;i--){while(Uj[k]>i){ret[i]-=Uv[k]*ret[Uj[k]];k--}ret[i]/=Uv[k];k--}return ret};numeric.cgrid=function grid(n,shape){if(typeof n==="number"){n=[n,n]}var ret=numeric.rep(n,-1);var i,j,count;if(typeof shape!=="function"){switch(shape){case"L":shape=function(i,j){return(i>=n[0]/2||j<n[1]/2)};break;default:shape=function(i,j){return true};break}}count=0;for(i=1;i<n[0]-1;i++){for(j=1;j<n[1]-1;j++){if(shape(i,j)){ret[i][j]=count;count++}}}return ret};numeric.cdelsq=function delsq(g){var dir=[[-1,0],[0,-1],[0,1],[1,0]];var s=numeric.dim(g),m=s[0],n=s[1],i,j,k,p,q;var Li=[],Lj=[],Lv=[];for(i=1;i<m-1;i++){for(j=1;j<n-1;j++){if(g[i][j]<0){continue}for(k=0;k<4;k++){p=i+dir[k][0];q=j+dir[k][1];if(g[p][q]<0){continue}Li.push(g[i][j]);Lj.push(g[p][q]);Lv.push(-1)}Li.push(g[i][j]);Lj.push(g[i][j]);Lv.push(4)}}return[Li,Lj,Lv]};numeric.cdotMV=function dotMV(A,x){var ret,Ai=A[0],Aj=A[1],Av=A[2],k,p=Ai.length,N;N=0;for(k=0;k<p;k++){if(Ai[k]>N){N=Ai[k]}}N++;ret=numeric.rep([N],0);for(k=0;k<p;k++){ret[Ai[k]]+=Av[k]*x[Aj[k]]}return ret};numeric.Spline=function Spline(x,yl,yr,kl,kr){this.x=x;this.yl=yl;this.yr=yr;this.kl=kl;this.kr=kr};numeric.Spline.prototype._at=function _at(x1,p){var x=this.x;var yl=this.yl;var yr=this.yr;var kl=this.kl;var kr=this.kr;var x1,a,b,t;var add=numeric.add,sub=numeric.sub,mul=numeric.mul;a=sub(mul(kl[p],x[p+1]-x[p]),sub(yr[p+1],yl[p]));b=add(mul(kr[p+1],x[p]-x[p+1]),sub(yr[p+1],yl[p]));t=(x1-x[p])/(x[p+1]-x[p]);var s=t*(1-t);return add(add(add(mul(1-t,yl[p]),mul(t,yr[p+1])),mul(a,s*(1-t))),mul(b,s*t))};numeric.Spline.prototype.at=function at(x0){if(typeof x0==="number"){var x=this.x;var n=x.length;var p,q,mid,floor=Math.floor,a,b,t;p=0;q=n-1;while(q-p>1){mid=floor((p+q)/2);if(x[mid]<=x0){p=mid}else{q=mid}}return this._at(x0,p)}var n=x0.length,i,ret=Array(n);for(i=n-1;i!==-1;--i){ret[i]=this.at(x0[i])}return ret};numeric.Spline.prototype.diff=function diff(){var x=this.x;var yl=this.yl;var yr=this.yr;var kl=this.kl;var kr=this.kr;var n=yl.length;var i,dx,dy;var zl=kl,zr=kr,pl=Array(n),pr=Array(n);var add=numeric.add,mul=numeric.mul,div=numeric.div,sub=numeric.sub;for(i=n-1;i!==-1;--i){dx=x[i+1]-x[i];dy=sub(yr[i+1],yl[i]);pl[i]=div(add(mul(dy,6),mul(kl[i],-4*dx),mul(kr[i+1],-2*dx)),dx*dx);pr[i+1]=div(add(mul(dy,-6),mul(kl[i],2*dx),mul(kr[i+1],4*dx)),dx*dx)}return new numeric.Spline(x,zl,zr,pl,pr)};numeric.Spline.prototype.roots=function roots(){function sqr(x){return x*x}function heval(y0,y1,k0,k1,x){var A=k0*2-(y1-y0);var B=-k1*2+(y1-y0);var t=(x+1)*0.5;var s=t*(1-t);return(1-t)*y0+t*y1+A*s*(1-t)+B*s*t}var ret=[];var x=this.x,yl=this.yl,yr=this.yr,kl=this.kl,kr=this.kr;if(typeof yl[0]==="number"){yl=[yl];yr=[yr];kl=[kl];kr=[kr]}var m=yl.length,n=x.length-1,i,j,k,y,s,t;var ai,bi,ci,di,ret=Array(m),ri,k0,k1,y0,y1,A,B,D,dx,cx,stops,z0,z1,zm,t0,t1,tm;var sqrt=Math.sqrt;for(i=0;i!==m;++i){ai=yl[i];bi=yr[i];ci=kl[i];di=kr[i];ri=[];for(j=0;j!==n;j++){if(j>0&&bi[j]*ai[j]<0){ri.push(x[j])}dx=(x[j+1]-x[j]);cx=x[j];y0=ai[j];y1=bi[j+1];k0=ci[j]/dx;k1=di[j+1]/dx;D=sqr(k0-k1+3*(y0-y1))+12*k1*y0;A=k1+3*y0+2*k0-3*y1;B=3*(k1+k0+2*(y0-y1));if(D<=0){z0=A/B;if(z0>x[j]&&z0<x[j+1]){stops=[x[j],z0,x[j+1]]}else{stops=[x[j],x[j+1]]}}else{z0=(A-sqrt(D))/B;z1=(A+sqrt(D))/B;stops=[x[j]];if(z0>x[j]&&z0<x[j+1]){stops.push(z0)}if(z1>x[j]&&z1<x[j+1]){stops.push(z1)}stops.push(x[j+1])}t0=stops[0];z0=this._at(t0,j);for(k=0;k<stops.length-1;k++){t1=stops[k+1];z1=this._at(t1,j);if(z0===0){ri.push(t0);t0=t1;z0=z1;continue}if(z1===0||z0*z1>0){t0=t1;z0=z1;continue}var side=0;while(1){tm=(z0*t1-z1*t0)/(z0-z1);if(tm<=t0||tm>=t1){break}zm=this._at(tm,j);if(zm*z1>0){t1=tm;z1=zm;if(side===-1){z0*=0.5}side=-1}else{if(zm*z0>0){t0=tm;z0=zm;if(side===1){z1*=0.5}side=1}else{break}}}ri.push(tm);t0=stops[k+1];z0=this._at(t0,j)}if(z1===0){ri.push(t1)}}ret[i]=ri}if(typeof this.yl[0]==="number"){return ret[0]}return ret};numeric.spline=function spline(x,y,k1,kn){var n=x.length,b=[],dx=[],dy=[];var i;var sub=numeric.sub,mul=numeric.mul,add=numeric.add;for(i=n-2;i>=0;i--){dx[i]=x[i+1]-x[i];dy[i]=sub(y[i+1],y[i])}if(typeof k1==="string"||typeof kn==="string"){k1=kn="periodic"}var T=[[],[],[]];switch(typeof k1){case"undefined":b[0]=mul(3/(dx[0]*dx[0]),dy[0]);T[0].push(0,0);T[1].push(0,1);T[2].push(2/dx[0],1/dx[0]);break;case"string":b[0]=add(mul(3/(dx[n-2]*dx[n-2]),dy[n-2]),mul(3/(dx[0]*dx[0]),dy[0]));T[0].push(0,0,0);T[1].push(n-2,0,1);T[2].push(1/dx[n-2],2/dx[n-2]+2/dx[0],1/dx[0]);break;default:b[0]=k1;T[0].push(0);T[1].push(0);T[2].push(1);break}for(i=1;i<n-1;i++){b[i]=add(mul(3/(dx[i-1]*dx[i-1]),dy[i-1]),mul(3/(dx[i]*dx[i]),dy[i]));T[0].push(i,i,i);T[1].push(i-1,i,i+1);T[2].push(1/dx[i-1],2/dx[i-1]+2/dx[i],1/dx[i])}switch(typeof kn){case"undefined":b[n-1]=mul(3/(dx[n-2]*dx[n-2]),dy[n-2]);T[0].push(n-1,n-1);T[1].push(n-2,n-1);T[2].push(1/dx[n-2],2/dx[n-2]);break;case"string":T[1][T[1].length-1]=0;break;default:b[n-1]=kn;T[0].push(n-1);T[1].push(n-1);T[2].push(1);break}if(typeof b[0]!=="number"){b=numeric.transpose(b)}else{b=[b]}var k=Array(b.length);if(typeof k1==="string"){for(i=k.length-1;i!==-1;--i){k[i]=numeric.ccsLUPSolve(numeric.ccsLUP(numeric.ccsScatter(T)),b[i]);k[i][n-1]=k[i][0]}}else{for(i=k.length-1;i!==-1;--i){k[i]=numeric.cLUsolve(numeric.cLU(T),b[i])}}if(typeof y[0]==="number"){k=k[0]}else{k=numeric.transpose(k)}return new numeric.Spline(x,y,y,k,k)};numeric.fftpow2=function fftpow2(x,y){var n=x.length;if(n===1){return}var cos=Math.cos,sin=Math.sin,i,j;var xe=Array(n/2),ye=Array(n/2),xo=Array(n/2),yo=Array(n/2);j=n/2;for(i=n-1;i!==-1;--i){--j;xo[j]=x[i];yo[j]=y[i];--i;xe[j]=x[i];ye[j]=y[i]}fftpow2(xe,ye);fftpow2(xo,yo);j=n/2;var t,k=(-6.283185307179586/n),ci,si;for(i=n-1;i!==-1;--i){--j;if(j===-1){j=n/2-1}t=k*i;ci=cos(t);si=sin(t);x[i]=xe[j]+ci*xo[j]-si*yo[j];y[i]=ye[j]+ci*yo[j]+si*xo[j]}};numeric._ifftpow2=function _ifftpow2(x,y){var n=x.length;if(n===1){return}var cos=Math.cos,sin=Math.sin,i,j;var xe=Array(n/2),ye=Array(n/2),xo=Array(n/2),yo=Array(n/2);j=n/2;for(i=n-1;i!==-1;--i){--j;xo[j]=x[i];yo[j]=y[i];--i;xe[j]=x[i];ye[j]=y[i]}_ifftpow2(xe,ye);_ifftpow2(xo,yo);j=n/2;var t,k=(6.283185307179586/n),ci,si;for(i=n-1;i!==-1;--i){--j;if(j===-1){j=n/2-1}t=k*i;ci=cos(t);si=sin(t);x[i]=xe[j]+ci*xo[j]-si*yo[j];y[i]=ye[j]+ci*yo[j]+si*xo[j]}};numeric.ifftpow2=function ifftpow2(x,y){numeric._ifftpow2(x,y);numeric.diveq(x,x.length);numeric.diveq(y,y.length)};numeric.convpow2=function convpow2(ax,ay,bx,by){numeric.fftpow2(ax,ay);numeric.fftpow2(bx,by);var i,n=ax.length,axi,bxi,ayi,byi;for(i=n-1;i!==-1;--i){axi=ax[i];ayi=ay[i];bxi=bx[i];byi=by[i];ax[i]=axi*bxi-ayi*byi;ay[i]=axi*byi+ayi*bxi}numeric.ifftpow2(ax,ay)};numeric.T.prototype.fft=function fft(){var x=this.x,y=this.y;var n=x.length,log=Math.log,log2=log(2),p=Math.ceil(log(2*n-1)/log2),m=Math.pow(2,p);var cx=numeric.rep([m],0),cy=numeric.rep([m],0),cos=Math.cos,sin=Math.sin;var k,c=(-3.141592653589793/n),t;var a=numeric.rep([m],0),b=numeric.rep([m],0),nhalf=Math.floor(n/2);for(k=0;k<n;k++){a[k]=x[k]}if(typeof y!=="undefined"){for(k=0;k<n;k++){b[k]=y[k]}}cx[0]=1;for(k=1;k<=m/2;k++){t=c*k*k;cx[k]=cos(t);cy[k]=sin(t);cx[m-k]=cos(t);cy[m-k]=sin(t)}var X=new numeric.T(a,b),Y=new numeric.T(cx,cy);X=X.mul(Y);numeric.convpow2(X.x,X.y,numeric.clone(Y.x),numeric.neg(Y.y));X=X.mul(Y);X.x.length=n;X.y.length=n;return X};numeric.T.prototype.ifft=function ifft(){var x=this.x,y=this.y;var n=x.length,log=Math.log,log2=log(2),p=Math.ceil(log(2*n-1)/log2),m=Math.pow(2,p);var cx=numeric.rep([m],0),cy=numeric.rep([m],0),cos=Math.cos,sin=Math.sin;var k,c=(3.141592653589793/n),t;var a=numeric.rep([m],0),b=numeric.rep([m],0),nhalf=Math.floor(n/2);for(k=0;k<n;k++){a[k]=x[k]}if(typeof y!=="undefined"){for(k=0;k<n;k++){b[k]=y[k]}}cx[0]=1;for(k=1;k<=m/2;k++){t=c*k*k;cx[k]=cos(t);cy[k]=sin(t);cx[m-k]=cos(t);cy[m-k]=sin(t)}var X=new numeric.T(a,b),Y=new numeric.T(cx,cy);X=X.mul(Y);numeric.convpow2(X.x,X.y,numeric.clone(Y.x),numeric.neg(Y.y));X=X.mul(Y);X.x.length=n;X.y.length=n;return X.div(n)};numeric.gradient=function gradient(f,x){var n=x.length;var f0=f(x);if(isNaN(f0)){throw new Error("gradient: f(x) is a NaN!")}var max=Math.max;var i,x0=numeric.clone(x),f1,f2,J=Array(n);var div=numeric.div,sub=numeric.sub,errest,roundoff,max=Math.max,eps=0.001,abs=Math.abs,min=Math.min;var t0,t1,t2,it=0,d1,d2,N;for(i=0;i<n;i++){var h=max(0.000001*f0,1e-8);while(1){++it;if(it>20){throw new Error("Numerical gradient fails")}x0[i]=x[i]+h;f1=f(x0);x0[i]=x[i]-h;f2=f(x0);x0[i]=x[i];if(isNaN(f1)||isNaN(f2)){h/=16;continue}J[i]=(f1-f2)/(2*h);t0=x[i]-h;t1=x[i];t2=x[i]+h;d1=(f1-f0)/h;d2=(f0-f2)/h;N=max(abs(J[i]),abs(f0),abs(f1),abs(f2),abs(t0),abs(t1),abs(t2),1e-8);errest=min(max(abs(d1-J[i]),abs(d2-J[i]),abs(d1-d2))/N,h/N);if(errest>eps){h/=16}else{break}}}return J};numeric.uncmin=function uncmin(f,x0,tol,gradient,maxit,callback,options){var grad=numeric.gradient;if(typeof options==="undefined"){options={}}if(typeof tol==="undefined"){tol=1e-8}if(typeof gradient==="undefined"){gradient=function(x){return grad(f,x)}}if(typeof maxit==="undefined"){maxit=1000}x0=numeric.clone(x0);var n=x0.length;var f0=f(x0),f1,df0;if(isNaN(f0)){throw new Error("uncmin: f(x0) is a NaN!")}var max=Math.max,norm2=numeric.norm2;tol=max(tol,numeric.epsilon);var step,g0,g1,H1=options.Hinv||numeric.identity(n);var dot=numeric.dot,inv=numeric.inv,sub=numeric.sub,add=numeric.add,ten=numeric.tensor,div=numeric.div,mul=numeric.mul;var all=numeric.all,isfinite=numeric.isFinite,neg=numeric.neg;var it=0,i,s,x1,y,Hy,Hs,ys,i0,t,nstep,t1,t2;var msg="";g0=gradient(x0);while(it<maxit){if(typeof callback==="function"){if(callback(it,x0,f0,g0,H1)){msg="Callback returned true";break}}if(!all(isfinite(g0))){msg="Gradient has Infinity or NaN";break}step=neg(dot(H1,g0));if(!all(isfinite(step))){msg="Search direction has Infinity or NaN";break}nstep=norm2(step);if(nstep<tol){msg="Newton step smaller than tol";break}t=1;df0=dot(g0,step);x1=x0;while(it<maxit){if(t*nstep<tol){break}s=mul(step,t);x1=add(x0,s);f1=f(x1);if(f1-f0>=0.1*t*df0||isNaN(f1)){t*=0.5;++it;continue}break}if(t*nstep<tol){msg="Line search step size smaller than tol";break}if(it===maxit){msg="maxit reached during line search";break}g1=gradient(x1);y=sub(g1,g0);ys=dot(y,s);Hy=dot(H1,y);H1=sub(add(H1,mul((ys+dot(y,Hy))/(ys*ys),ten(s,s))),div(add(ten(Hy,s),ten(s,Hy)),ys));x0=x1;f0=f1;g0=g1;++it}return{solution:x0,f:f0,gradient:g0,invHessian:H1,iterations:it,message:msg}};numeric.Dopri=function Dopri(x,y,f,ymid,iterations,msg,events){this.x=x;this.y=y;this.f=f;this.ymid=ymid;this.iterations=iterations;this.events=events;this.message=msg};numeric.Dopri.prototype._at=function _at(xi,j){function sqr(x){return x*x}var sol=this;var xs=sol.x;var ys=sol.y;var k1=sol.f;var ymid=sol.ymid;var n=xs.length;var x0,x1,xh,y0,y1,yh,xi;var floor=Math.floor,h;var c=0.5;var add=numeric.add,mul=numeric.mul,sub=numeric.sub,p,q,w;x0=xs[j];x1=xs[j+1];y0=ys[j];y1=ys[j+1];h=x1-x0;xh=x0+c*h;yh=ymid[j];p=sub(k1[j],mul(y0,1/(x0-xh)+2/(x0-x1)));q=sub(k1[j+1],mul(y1,1/(x1-xh)+2/(x1-x0)));w=[sqr(xi-x1)*(xi-xh)/sqr(x0-x1)/(x0-xh),sqr(xi-x0)*sqr(xi-x1)/sqr(x0-xh)/sqr(x1-xh),sqr(xi-x0)*(xi-xh)/sqr(x1-x0)/(x1-xh),(xi-x0)*sqr(xi-x1)*(xi-xh)/sqr(x0-x1)/(x0-xh),(xi-x1)*sqr(xi-x0)*(xi-xh)/sqr(x0-x1)/(x1-xh)];return add(add(add(add(mul(y0,w[0]),mul(yh,w[1])),mul(y1,w[2])),mul(p,w[3])),mul(q,w[4]))};numeric.Dopri.prototype.at=function at(x){var i,j,k,floor=Math.floor;if(typeof x!=="number"){var n=x.length,ret=Array(n);for(i=n-1;i!==-1;--i){ret[i]=this.at(x[i])}return ret}var x0=this.x;i=0;j=x0.length-1;while(j-i>1){k=floor(0.5*(i+j));if(x0[k]<=x){i=k}else{j=k}}return this._at(x,i)};numeric.dopri=function dopri(x0,x1,y0,f,tol,maxit,event){if(typeof tol==="undefined"){tol=0.000001}if(typeof maxit==="undefined"){maxit=1000}var xs=[x0],ys=[y0],k1=[f(x0,y0)],k2,k3,k4,k5,k6,k7,ymid=[];var A2=1/5;var A3=[3/40,9/40];var A4=[44/45,-56/15,32/9];var A5=[19372/6561,-25360/2187,64448/6561,-212/729];var A6=[9017/3168,-355/33,46732/5247,49/176,-5103/18656];var b=[35/384,0,500/1113,125/192,-2187/6784,11/84];var bm=[0.5*6025192743/30085553152,0,0.5*51252292925/65400821598,0.5*-2691868925/45128329728,0.5*187940372067/1594534317056,0.5*-1776094331/19743644256,0.5*11237099/235043384];var c=[1/5,3/10,4/5,8/9,1,1];var e=[-71/57600,0,71/16695,-71/1920,17253/339200,-22/525,1/40];var i=0,er,j;var h=(x1-x0)/10;var it=0;var add=numeric.add,mul=numeric.mul,y1,erinf;var max=Math.max,min=Math.min,abs=Math.abs,norminf=numeric.norminf,pow=Math.pow;var any=numeric.any,lt=numeric.lt,and=numeric.and,sub=numeric.sub;var e0,e1,ev;var ret=new numeric.Dopri(xs,ys,k1,ymid,-1,"");if(typeof event==="function"){e0=event(x0,y0)}while(x0<x1&&it<maxit){++it;if(x0+h>x1){h=x1-x0}k2=f(x0+c[0]*h,add(y0,mul(A2*h,k1[i])));k3=f(x0+c[1]*h,add(add(y0,mul(A3[0]*h,k1[i])),mul(A3[1]*h,k2)));k4=f(x0+c[2]*h,add(add(add(y0,mul(A4[0]*h,k1[i])),mul(A4[1]*h,k2)),mul(A4[2]*h,k3)));k5=f(x0+c[3]*h,add(add(add(add(y0,mul(A5[0]*h,k1[i])),mul(A5[1]*h,k2)),mul(A5[2]*h,k3)),mul(A5[3]*h,k4)));k6=f(x0+c[4]*h,add(add(add(add(add(y0,mul(A6[0]*h,k1[i])),mul(A6[1]*h,k2)),mul(A6[2]*h,k3)),mul(A6[3]*h,k4)),mul(A6[4]*h,k5)));y1=add(add(add(add(add(y0,mul(k1[i],h*b[0])),mul(k3,h*b[2])),mul(k4,h*b[3])),mul(k5,h*b[4])),mul(k6,h*b[5]));k7=f(x0+h,y1);er=add(add(add(add(add(mul(k1[i],h*e[0]),mul(k3,h*e[2])),mul(k4,h*e[3])),mul(k5,h*e[4])),mul(k6,h*e[5])),mul(k7,h*e[6]));if(typeof er==="number"){erinf=abs(er)}else{erinf=norminf(er)}if(erinf>tol){h=0.2*h*pow(tol/erinf,0.25);if(x0+h===x0){ret.msg="Step size became too small";break}continue}ymid[i]=add(add(add(add(add(add(y0,mul(k1[i],h*bm[0])),mul(k3,h*bm[2])),mul(k4,h*bm[3])),mul(k5,h*bm[4])),mul(k6,h*bm[5])),mul(k7,h*bm[6]));++i;xs[i]=x0+h;ys[i]=y1;k1[i]=k7;if(typeof event==="function"){var yi,xl=x0,xr=x0+0.5*h,xi;e1=event(xr,ymid[i-1]);ev=and(lt(e0,0),lt(0,e1));if(!any(ev)){xl=xr;xr=x0+h;e0=e1;e1=event(xr,y1);ev=and(lt(e0,0),lt(0,e1))}if(any(ev)){var xc,yc,en,ei;var side=0,sl=1,sr=1;while(1){if(typeof e0==="number"){xi=(sr*e1*xl-sl*e0*xr)/(sr*e1-sl*e0)}else{xi=xr;for(j=e0.length-1;j!==-1;--j){if(e0[j]<0&&e1[j]>0){xi=min(xi,(sr*e1[j]*xl-sl*e0[j]*xr)/(sr*e1[j]-sl*e0[j]))}}}if(xi<=xl||xi>=xr){break}yi=ret._at(xi,i-1);ei=event(xi,yi);en=and(lt(e0,0),lt(0,ei));if(any(en)){xr=xi;e1=ei;ev=en;sr=1;if(side===-1){sl*=0.5}else{sl=1}side=-1}else{xl=xi;e0=ei;sl=1;if(side===1){sr*=0.5}else{sr=1}side=1}}y1=ret._at(0.5*(x0+xi),i-1);ret.f[i]=f(xi,yi);ret.x[i]=xi;ret.y[i]=yi;ret.ymid[i-1]=y1;ret.events=ev;ret.iterations=it;return ret}}x0+=h;y0=y1;e0=e1;h=min(0.8*h*pow(tol/erinf,0.25),4*h)}ret.iterations=it;return ret};numeric.LU=function(A,fast){fast=fast||false;var abs=Math.abs;var i,j,k,absAjk,Akk,Ak,Pk,Ai;var max;var n=A.length,n1=n-1;var P=new Array(n);if(!fast){A=numeric.clone(A)}for(k=0;k<n;++k){Pk=k;Ak=A[k];max=abs(Ak[k]);for(j=k+1;j<n;++j){absAjk=abs(A[j][k]);if(max<absAjk){max=absAjk;Pk=j}}P[k]=Pk;if(Pk!=k){A[k]=A[Pk];A[Pk]=Ak;Ak=A[k]}Akk=Ak[k];for(i=k+1;i<n;++i){A[i][k]/=Akk}for(i=k+1;i<n;++i){Ai=A[i];for(j=k+1;j<n1;++j){Ai[j]-=Ai[k]*Ak[j];++j;Ai[j]-=Ai[k]*Ak[j]}if(j===n1){Ai[j]-=Ai[k]*Ak[j]}}}return{LU:A,P:P}};numeric.LUsolve=function LUsolve(LUP,b){var i,j;var LU=LUP.LU;var n=LU.length;var x=numeric.clone(b);var P=LUP.P;var Pi,LUi,LUii,tmp;for(i=n-1;i!==-1;--i){x[i]=b[i]}for(i=0;i<n;++i){Pi=P[i];if(P[i]!==i){tmp=x[i];x[i]=x[Pi];x[Pi]=tmp}LUi=LU[i];for(j=0;j<i;++j){x[i]-=x[j]*LUi[j]}}for(i=n-1;i>=0;--i){LUi=LU[i];for(j=i+1;j<n;++j){x[i]-=x[j]*LUi[j]}x[i]/=LUi[i]}return x};numeric.solve=function solve(A,b,fast){return numeric.LUsolve(numeric.LU(A,fast),b)};numeric.echelonize=function echelonize(A){var s=numeric.dim(A),m=s[0],n=s[1];var I=numeric.identity(m);var P=Array(m);var i,j,k,l,Ai,Ii,Z,a;var abs=Math.abs;var diveq=numeric.diveq;A=numeric.clone(A);for(i=0;i<m;++i){k=0;Ai=A[i];Ii=I[i];for(j=1;j<n;++j){if(abs(Ai[k])<abs(Ai[j])){k=j}}P[i]=k;diveq(Ii,Ai[k]);diveq(Ai,Ai[k]);for(j=0;j<m;++j){if(j!==i){Z=A[j];a=Z[k];for(l=n-1;l!==-1;--l){Z[l]-=Ai[l]*a}Z=I[j];for(l=m-1;l!==-1;--l){Z[l]-=Ii[l]*a}}}}return{I:I,A:A,P:P}};numeric.__solveLP=function __solveLP(c,A,b,tol,maxit,x,flag){var sum=numeric.sum,log=numeric.log,mul=numeric.mul,sub=numeric.sub,dot=numeric.dot,div=numeric.div,add=numeric.add;var m=c.length,n=b.length,y;var unbounded=false,cb,i0=0;var alpha=1;var f0,df0,AT=numeric.transpose(A),svd=numeric.svd,transpose=numeric.transpose,leq=numeric.leq,sqrt=Math.sqrt,abs=Math.abs;var muleq=numeric.muleq;var norm=numeric.norminf,any=numeric.any,min=Math.min;var all=numeric.all,gt=numeric.gt;var p=Array(m),A0=Array(n),e=numeric.rep([n],1),H;var solve=numeric.solve,z=sub(b,dot(A,x)),count;var dotcc=dot(c,c);var g;for(count=i0;count<maxit;++count){var i,j,d;for(i=n-1;i!==-1;--i){A0[i]=div(A[i],z[i])}var A1=transpose(A0);for(i=m-1;i!==-1;--i){p[i]=(sum(A1[i]))}alpha=0.25*abs(dotcc/dot(c,p));var a1=100*sqrt(dotcc/dot(p,p));if(!isFinite(alpha)||alpha>a1){alpha=a1}g=add(c,mul(alpha,p));H=dot(A1,A0);for(i=m-1;i!==-1;--i){H[i][i]+=1}d=solve(H,div(g,alpha),true);var t0=div(z,dot(A,d));var t=1;for(i=n-1;i!==-1;--i){if(t0[i]<0){t=min(t,-0.999*t0[i])}}y=sub(x,mul(d,t));z=sub(b,dot(A,y));if(!all(gt(z,0))){return{solution:x,message:"",iterations:count}}x=y;if(alpha<tol){return{solution:y,message:"",iterations:count}}if(flag){var s=dot(c,g),Ag=dot(A,g);unbounded=true;for(i=n-1;i!==-1;--i){if(s*Ag[i]<0){unbounded=false;break}}}else{if(x[m-1]>=0){unbounded=false}else{unbounded=true}}if(unbounded){return{solution:y,message:"Unbounded",iterations:count}}}return{solution:x,message:"maximum iteration count exceeded",iterations:count}};numeric._solveLP=function _solveLP(c,A,b,tol,maxit){var m=c.length,n=b.length,y;var sum=numeric.sum,log=numeric.log,mul=numeric.mul,sub=numeric.sub,dot=numeric.dot,div=numeric.div,add=numeric.add;var c0=numeric.rep([m],0).concat([1]);var J=numeric.rep([n,1],-1);var A0=numeric.blockMatrix([[A,J]]);var b0=b;var y=numeric.rep([m],0).concat(Math.max(0,numeric.sup(numeric.neg(b)))+1);var x0=numeric.__solveLP(c0,A0,b0,tol,maxit,y,false);var x=numeric.clone(x0.solution);x.length=m;var foo=numeric.inf(sub(b,dot(A,x)));if(foo<0){return{solution:NaN,message:"Infeasible",iterations:x0.iterations}}var ret=numeric.__solveLP(c,A,b,tol,maxit-x0.iterations,x,true);ret.iterations+=x0.iterations;return ret};numeric.solveLP=function solveLP(c,A,b,Aeq,beq,tol,maxit){if(typeof maxit==="undefined"){maxit=1000}if(typeof tol==="undefined"){tol=numeric.epsilon}if(typeof Aeq==="undefined"){return numeric._solveLP(c,A,b,tol,maxit)}var m=Aeq.length,n=Aeq[0].length,o=A.length;var B=numeric.echelonize(Aeq);var flags=numeric.rep([n],0);var P=B.P;var Q=[];var i;for(i=P.length-1;i!==-1;--i){flags[P[i]]=1}for(i=n-1;i!==-1;--i){if(flags[i]===0){Q.push(i)}}var g=numeric.getRange;var I=numeric.linspace(0,m-1),J=numeric.linspace(0,o-1);var Aeq2=g(Aeq,I,Q),A1=g(A,J,P),A2=g(A,J,Q),dot=numeric.dot,sub=numeric.sub;var A3=dot(A1,B.I);var A4=sub(A2,dot(A3,Aeq2)),b4=sub(b,dot(A3,beq));var c1=Array(P.length),c2=Array(Q.length);for(i=P.length-1;i!==-1;--i){c1[i]=c[P[i]]}for(i=Q.length-1;i!==-1;--i){c2[i]=c[Q[i]]}var c4=sub(c2,dot(c1,dot(B.I,Aeq2)));var S=numeric._solveLP(c4,A4,b4,tol,maxit);var x2=S.solution;if(x2!==x2){return S}var x1=dot(B.I,sub(beq,dot(Aeq2,x2)));var x=Array(c.length);for(i=P.length-1;i!==-1;--i){x[P[i]]=x1[i]}for(i=Q.length-1;i!==-1;--i){x[Q[i]]=x2[i]}return{solution:x,message:S.message,iterations:S.iterations}};numeric.MPStoLP=function MPStoLP(MPS){if(MPS instanceof String){MPS.split("\n")}var state=0;var states=["Initial state","NAME","ROWS","COLUMNS","RHS","BOUNDS","ENDATA"];var n=MPS.length;var i,j,z,N=0,rows={},sign=[],rl=0,vars={},nv=0;var name;var c=[],A=[],b=[];function err(e){throw new Error("MPStoLP: "+e+"\nLine "+i+": "+MPS[i]+"\nCurrent state: "+states[state]+"\n")}for(i=0;i<n;++i){z=MPS[i];var w0=z.match(/\S*/g);var w=[];for(j=0;j<w0.length;++j){if(w0[j]!==""){w.push(w0[j])}}if(w.length===0){continue}for(j=0;j<states.length;++j){if(z.substr(0,states[j].length)===states[j]){break}}if(j<states.length){state=j;if(j===1){name=w[1]}if(j===6){return{name:name,c:c,A:numeric.transpose(A),b:b,rows:rows,vars:vars}}continue}switch(state){case 0:case 1:err("Unexpected line");case 2:switch(w[0]){case"N":if(N===0){N=w[1]}else{err("Two or more N rows")}break;case"L":rows[w[1]]=rl;sign[rl]=1;b[rl]=0;++rl;break;case"G":rows[w[1]]=rl;sign[rl]=-1;b[rl]=0;++rl;break;case"E":rows[w[1]]=rl;sign[rl]=0;b[rl]=0;++rl;break;default:err("Parse error "+numeric.prettyPrint(w))}break;case 3:if(!vars.hasOwnProperty(w[0])){vars[w[0]]=nv;c[nv]=0;A[nv]=numeric.rep([rl],0);++nv}var p=vars[w[0]];for(j=1;j<w.length;j+=2){if(w[j]===N){c[p]=parseFloat(w[j+1]);continue}var q=rows[w[j]];A[p][q]=(sign[q]<0?-1:1)*parseFloat(w[j+1])}break;case 4:for(j=1;j<w.length;j+=2){b[rows[w[j]]]=(sign[rows[w[j]]]<0?-1:1)*parseFloat(w[j+1])}break;case 5:break;case 6:err("Internal error")}}err("Reached end of file without ENDATA")};numeric.seedrandom={pow:Math.pow,random:Math.random};(function(pool,math,width,chunks,significance,overflow,startdenom){math["seedrandom"]=function seedrandom(seed,use_entropy){var key=[];var arc4;seed=mixkey(flatten(use_entropy?[seed,pool]:arguments.length?seed:[new Date().getTime(),pool,window],3),key);arc4=new ARC4(key);mixkey(arc4.S,pool);math["random"]=function random(){var n=arc4.g(chunks);var d=startdenom;var x=0;while(n<significance){n=(n+x)*width;d*=width;x=arc4.g(1)}while(n>=overflow){n/=2;d/=2;x>>>=1}return(n+x)/d};return seed};function ARC4(key){var t,u,me=this,keylen=key.length;var i=0,j=me.i=me.j=me.m=0;me.S=[];me.c=[];if(!keylen){key=[keylen++]}while(i<width){me.S[i]=i++}for(i=0;i<width;i++){t=me.S[i];j=lowbits(j+t+key[i%keylen]);u=me.S[j];me.S[i]=u;me.S[j]=t}me.g=function getnext(count){var s=me.S;var i=lowbits(me.i+1);var t=s[i];var j=lowbits(me.j+t);var u=s[j];s[i]=u;s[j]=t;var r=s[lowbits(t+u)];while(--count){i=lowbits(i+1);t=s[i];j=lowbits(j+t);u=s[j];s[i]=u;s[j]=t;r=r*width+s[lowbits(t+u)]}me.i=i;me.j=j;return r};me.g(width)}function flatten(obj,depth,result,prop,typ){result=[];typ=typeof(obj);if(depth&&typ=="object"){for(prop in obj){if(prop.indexOf("S")<5){try{result.push(flatten(obj[prop],depth-1))}catch(e){}}}}return(result.length?result:obj+(typ!="string"?"\0":""))}function mixkey(seed,key,smear,j){seed+="";smear=0;for(j=0;j<seed.length;j++){key[lowbits(j)]=lowbits((smear^=key[lowbits(j)]*19)+seed.charCodeAt(j))}seed="";for(j in key){seed+=String.fromCharCode(key[j])}return seed}function lowbits(n){return n&(width-1)}startdenom=math.pow(width,chunks);significance=math.pow(2,significance);overflow=significance*2;mixkey(math.random(),pool)}([],numeric.seedrandom,256,6,52));(function(exports){function base0to1(A){if(typeof A!=="object"){return A}var ret=[],i,n=A.length;for(i=0;i<n;i++){ret[i+1]=base0to1(A[i])}return ret}function base1to0(A){if(typeof A!=="object"){return A}var ret=[],i,n=A.length;for(i=1;i<n;i++){ret[i-1]=base1to0(A[i])}return ret}function dpori(a,lda,n){var i,j,k,kp1,t;for(k=1;k<=n;k=k+1){a[k][k]=1/a[k][k];t=-a[k][k];for(i=1;i<k;i=i+1){a[i][k]=t*a[i][k]}kp1=k+1;if(n<kp1){break}for(j=kp1;j<=n;j=j+1){t=a[k][j];a[k][j]=0;for(i=1;i<=k;i=i+1){a[i][j]=a[i][j]+(t*a[i][k])}}}}function dposl(a,lda,n,b){var i,k,kb,t;for(k=1;k<=n;k=k+1){t=0;for(i=1;i<k;i=i+1){t=t+(a[i][k]*b[i])}b[k]=(b[k]-t)/a[k][k]}for(kb=1;kb<=n;kb=kb+1){k=n+1-kb;b[k]=b[k]/a[k][k];t=-b[k];for(i=1;i<k;i=i+1){b[i]=b[i]+(t*a[i][k])}}}function dpofa(a,lda,n,info){var i,j,jm1,k,t,s;for(j=1;j<=n;j=j+1){info[1]=j;s=0;jm1=j-1;if(jm1<1){s=a[j][j]-s;if(s<=0){break}a[j][j]=Math.sqrt(s)}else{for(k=1;k<=jm1;k=k+1){t=a[k][j];for(i=1;i<k;i=i+1){t=t-(a[i][j]*a[i][k])}t=t/a[k][k];a[k][j]=t;s=s+t*t}s=a[j][j]-s;if(s<=0){break}a[j][j]=Math.sqrt(s)}info[1]=0}}function qpgen2(dmat,dvec,fddmat,n,sol,crval,amat,bvec,fdamat,q,meq,iact,nact,iter,work,ierr){var i,j,l,l1,info,it1,iwzv,iwrv,iwrm,iwsv,iwuv,nvl,r,iwnbv,temp,sum,t1,tt,gc,gs,nu,t1inf,t2min,vsmall,tmpa,tmpb,go;r=Math.min(n,q);l=2*n+(r*(r+5))/2+2*q+1;vsmall=1e-60;do{vsmall=vsmall+vsmall;tmpa=1+0.1*vsmall;tmpb=1+0.2*vsmall}while(tmpa<=1||tmpb<=1);for(i=1;i<=n;i=i+1){work[i]=dvec[i]}for(i=n+1;i<=l;i=i+1){work[i]=0}for(i=1;i<=q;i=i+1){iact[i]=0}info=[];if(ierr[1]===0){dpofa(dmat,fddmat,n,info);if(info[1]!==0){ierr[1]=2;return}dposl(dmat,fddmat,n,dvec);dpori(dmat,fddmat,n)}else{for(j=1;j<=n;j=j+1){sol[j]=0;for(i=1;i<=j;i=i+1){sol[j]=sol[j]+dmat[i][j]*dvec[i]}}for(j=1;j<=n;j=j+1){dvec[j]=0;for(i=j;i<=n;i=i+1){dvec[j]=dvec[j]+dmat[j][i]*sol[i]}}}crval[1]=0;for(j=1;j<=n;j=j+1){sol[j]=dvec[j];crval[1]=crval[1]+work[j]*sol[j];work[j]=0;for(i=j+1;i<=n;i=i+1){dmat[i][j]=0}}crval[1]=-crval[1]/2;ierr[1]=0;iwzv=n;iwrv=iwzv+n;iwuv=iwrv+r;iwrm=iwuv+r+1;iwsv=iwrm+(r*(r+1))/2;iwnbv=iwsv+q;for(i=1;i<=q;i=i+1){sum=0;for(j=1;j<=n;j=j+1){sum=sum+amat[j][i]*amat[j][i]}work[iwnbv+i]=Math.sqrt(sum)}nact=0;iter[1]=0;iter[2]=0;function fn_goto_50(){iter[1]=iter[1]+1;l=iwsv;for(i=1;i<=q;i=i+1){l=l+1;sum=-bvec[i];for(j=1;j<=n;j=j+1){sum=sum+amat[j][i]*sol[j]}if(Math.abs(sum)<vsmall){sum=0}if(i>meq){work[l]=sum}else{work[l]=-Math.abs(sum);if(sum>0){for(j=1;j<=n;j=j+1){amat[j][i]=-amat[j][i]}bvec[i]=-bvec[i]}}}for(i=1;i<=nact;i=i+1){work[iwsv+iact[i]]=0}nvl=0;temp=0;for(i=1;i<=q;i=i+1){if(work[iwsv+i]<temp*work[iwnbv+i]){nvl=i;temp=work[iwsv+i]/work[iwnbv+i]}}if(nvl===0){return 999}return 0}function fn_goto_55(){for(i=1;i<=n;i=i+1){sum=0;for(j=1;j<=n;j=j+1){sum=sum+dmat[j][i]*amat[j][nvl]}work[i]=sum}l1=iwzv;for(i=1;i<=n;i=i+1){work[l1+i]=0}for(j=nact+1;j<=n;j=j+1){for(i=1;i<=n;i=i+1){work[l1+i]=work[l1+i]+dmat[i][j]*work[j]}}t1inf=true;for(i=nact;i>=1;i=i-1){sum=work[i];l=iwrm+(i*(i+3))/2;l1=l-i;for(j=i+1;j<=nact;j=j+1){sum=sum-work[l]*work[iwrv+j];l=l+j}sum=sum/work[l1];work[iwrv+i]=sum;if(iact[i]<meq){break}if(sum<0){break}t1inf=false;it1=i}if(!t1inf){t1=work[iwuv+it1]/work[iwrv+it1];for(i=1;i<=nact;i=i+1){if(iact[i]<meq){break}if(work[iwrv+i]<0){break}temp=work[iwuv+i]/work[iwrv+i];if(temp<t1){t1=temp;it1=i}}}sum=0;for(i=iwzv+1;i<=iwzv+n;i=i+1){sum=sum+work[i]*work[i]}if(Math.abs(sum)<=vsmall){if(t1inf){ierr[1]=1;return 999}else{for(i=1;i<=nact;i=i+1){work[iwuv+i]=work[iwuv+i]-t1*work[iwrv+i]}work[iwuv+nact+1]=work[iwuv+nact+1]+t1;return 700}}else{sum=0;for(i=1;i<=n;i=i+1){sum=sum+work[iwzv+i]*amat[i][nvl]}tt=-work[iwsv+nvl]/sum;t2min=true;if(!t1inf){if(t1<tt){tt=t1;t2min=false}}for(i=1;i<=n;i=i+1){sol[i]=sol[i]+tt*work[iwzv+i];if(Math.abs(sol[i])<vsmall){sol[i]=0}}crval[1]=crval[1]+tt*sum*(tt/2+work[iwuv+nact+1]);for(i=1;i<=nact;i=i+1){work[iwuv+i]=work[iwuv+i]-tt*work[iwrv+i]}work[iwuv+nact+1]=work[iwuv+nact+1]+tt;if(t2min){nact=nact+1;iact[nact]=nvl;l=iwrm+((nact-1)*nact)/2+1;for(i=1;i<=nact-1;i=i+1){work[l]=work[i];l=l+1}if(nact===n){work[l]=work[n]}else{for(i=n;i>=nact+1;i=i-1){if(work[i]===0){break}gc=Math.max(Math.abs(work[i-1]),Math.abs(work[i]));gs=Math.min(Math.abs(work[i-1]),Math.abs(work[i]));if(work[i-1]>=0){temp=Math.abs(gc*Math.sqrt(1+gs*gs/(gc*gc)))}else{temp=-Math.abs(gc*Math.sqrt(1+gs*gs/(gc*gc)))}gc=work[i-1]/temp;gs=work[i]/temp;if(gc===1){break}if(gc===0){work[i-1]=gs*temp;for(j=1;j<=n;j=j+1){temp=dmat[j][i-1];dmat[j][i-1]=dmat[j][i];dmat[j][i]=temp}}else{work[i-1]=temp;nu=gs/(1+gc);for(j=1;j<=n;j=j+1){temp=gc*dmat[j][i-1]+gs*dmat[j][i];dmat[j][i]=nu*(dmat[j][i-1]+temp)-dmat[j][i];dmat[j][i-1]=temp}}}work[l]=work[nact]}}else{sum=-bvec[nvl];for(j=1;j<=n;j=j+1){sum=sum+sol[j]*amat[j][nvl]}if(nvl>meq){work[iwsv+nvl]=sum}else{work[iwsv+nvl]=-Math.abs(sum);if(sum>0){for(j=1;j<=n;j=j+1){amat[j][nvl]=-amat[j][nvl]}bvec[nvl]=-bvec[nvl]}}return 700}}return 0}function fn_goto_797(){l=iwrm+(it1*(it1+1))/2+1;l1=l+it1;if(work[l1]===0){return 798}gc=Math.max(Math.abs(work[l1-1]),Math.abs(work[l1]));gs=Math.min(Math.abs(work[l1-1]),Math.abs(work[l1]));if(work[l1-1]>=0){temp=Math.abs(gc*Math.sqrt(1+gs*gs/(gc*gc)))}else{temp=-Math.abs(gc*Math.sqrt(1+gs*gs/(gc*gc)))}gc=work[l1-1]/temp;gs=work[l1]/temp;if(gc===1){return 798}if(gc===0){for(i=it1+1;i<=nact;i=i+1){temp=work[l1-1];work[l1-1]=work[l1];work[l1]=temp;l1=l1+i}for(i=1;i<=n;i=i+1){temp=dmat[i][it1];dmat[i][it1]=dmat[i][it1+1];dmat[i][it1+1]=temp}}else{nu=gs/(1+gc);for(i=it1+1;i<=nact;i=i+1){temp=gc*work[l1-1]+gs*work[l1];work[l1]=nu*(work[l1-1]+temp)-work[l1];work[l1-1]=temp;l1=l1+i}for(i=1;i<=n;i=i+1){temp=gc*dmat[i][it1]+gs*dmat[i][it1+1];dmat[i][it1+1]=nu*(dmat[i][it1]+temp)-dmat[i][it1+1];dmat[i][it1]=temp}}return 0}function fn_goto_798(){l1=l-it1;for(i=1;i<=it1;i=i+1){work[l1]=work[l];l=l+1;l1=l1+1}work[iwuv+it1]=work[iwuv+it1+1];iact[it1]=iact[it1+1];it1=it1+1;if(it1<nact){return 797}return 0}function fn_goto_799(){work[iwuv+nact]=work[iwuv+nact+1];work[iwuv+nact+1]=0;iact[nact]=0;nact=nact-1;iter[2]=iter[2]+1;return 0}go=0;while(true){go=fn_goto_50();if(go===999){return}while(true){go=fn_goto_55();if(go===0){break}if(go===999){return}if(go===700){if(it1===nact){fn_goto_799()}else{while(true){fn_goto_797();go=fn_goto_798();if(go!==797){break}}fn_goto_799()}}}}}function solveQP(Dmat,dvec,Amat,bvec,meq,factorized){Dmat=base0to1(Dmat);dvec=base0to1(dvec);Amat=base0to1(Amat);var i,n,q,nact,r,crval=[],iact=[],sol=[],work=[],iter=[],message;meq=meq||0;factorized=factorized?base0to1(factorized):[undefined,0];bvec=bvec?base0to1(bvec):[];n=Dmat.length-1;q=Amat[1].length-1;if(!bvec){for(i=1;i<=q;i=i+1){bvec[i]=0}}for(i=1;i<=q;i=i+1){iact[i]=0}nact=0;r=Math.min(n,q);for(i=1;i<=n;i=i+1){sol[i]=0}crval[1]=0;for(i=1;i<=(2*n+(r*(r+5))/2+2*q+1);i=i+1){work[i]=0}for(i=1;i<=2;i=i+1){iter[i]=0}qpgen2(Dmat,dvec,n,n,sol,crval,Amat,bvec,n,q,meq,iact,nact,iter,work,factorized);message="";if(factorized[1]===1){message="constraints are inconsistent, no solution!"}if(factorized[1]===2){message="matrix D in quadratic function is not positive definite!"}return{solution:base1to0(sol),value:base1to0(crval),unconstrained_solution:base1to0(dvec),iterations:base1to0(iter),iact:base1to0(iact),message:message}}exports.solveQP=solveQP}(numeric));numeric.svd=function svd(A){var temp;var prec=numeric.epsilon;var tolerance=1e-64/prec;var itmax=50;var c=0;var i=0;var j=0;var k=0;var l=0;var u=numeric.clone(A);var m=u.length;var n=u[0].length;if(m<n){throw"Need more rows than columns"}var e=new Array(n);var q=new Array(n);for(i=0;i<n;i++){e[i]=q[i]=0}var v=numeric.rep([n,n],0);function pythag(a,b){a=Math.abs(a);b=Math.abs(b);if(a>b){return a*Math.sqrt(1+(b*b/a/a))}else{if(b==0){return a}}return b*Math.sqrt(1+(a*a/b/b))}var f=0;var g=0;var h=0;var x=0;var y=0;var z=0;var s=0;for(i=0;i<n;i++){e[i]=g;s=0;l=i+1;for(j=i;j<m;j++){s+=(u[j][i]*u[j][i])}if(s<=tolerance){g=0}else{f=u[i][i];g=Math.sqrt(s);if(f>=0){g=-g}h=f*g-s;u[i][i]=f-g;for(j=l;j<n;j++){s=0;for(k=i;k<m;k++){s+=u[k][i]*u[k][j]}f=s/h;for(k=i;k<m;k++){u[k][j]+=f*u[k][i]}}}q[i]=g;s=0;for(j=l;j<n;j++){s=s+u[i][j]*u[i][j]}if(s<=tolerance){g=0}else{f=u[i][i+1];g=Math.sqrt(s);if(f>=0){g=-g}h=f*g-s;u[i][i+1]=f-g;for(j=l;j<n;j++){e[j]=u[i][j]/h}for(j=l;j<m;j++){s=0;for(k=l;k<n;k++){s+=(u[j][k]*u[i][k])}for(k=l;k<n;k++){u[j][k]+=s*e[k]}}}y=Math.abs(q[i])+Math.abs(e[i]);if(y>x){x=y}}for(i=n-1;i!=-1;i+=-1){if(g!=0){h=g*u[i][i+1];for(j=l;j<n;j++){v[j][i]=u[i][j]/h}for(j=l;j<n;j++){s=0;for(k=l;k<n;k++){s+=u[i][k]*v[k][j]}for(k=l;k<n;k++){v[k][j]+=(s*v[k][i])}}}for(j=l;j<n;j++){v[i][j]=0;v[j][i]=0}v[i][i]=1;g=e[i];l=i}for(i=n-1;i!=-1;i+=-1){l=i+1;g=q[i];for(j=l;j<n;j++){u[i][j]=0}if(g!=0){h=u[i][i]*g;for(j=l;j<n;j++){s=0;for(k=l;k<m;k++){s+=u[k][i]*u[k][j]}f=s/h;for(k=i;k<m;k++){u[k][j]+=f*u[k][i]}}for(j=i;j<m;j++){u[j][i]=u[j][i]/g}}else{for(j=i;j<m;j++){u[j][i]=0}}u[i][i]+=1}prec=prec*x;for(k=n-1;k!=-1;k+=-1){for(var iteration=0;iteration<itmax;iteration++){var test_convergence=false;for(l=k;l!=-1;l+=-1){if(Math.abs(e[l])<=prec){test_convergence=true;break}if(Math.abs(q[l-1])<=prec){break}}if(!test_convergence){c=0;s=1;var l1=l-1;for(i=l;i<k+1;i++){f=s*e[i];e[i]=c*e[i];if(Math.abs(f)<=prec){break}g=q[i];h=pythag(f,g);q[i]=h;c=g/h;s=-f/h;for(j=0;j<m;j++){y=u[j][l1];z=u[j][i];u[j][l1]=y*c+(z*s);u[j][i]=-y*s+(z*c)}}}z=q[k];if(l==k){if(z<0){q[k]=-z;for(j=0;j<n;j++){v[j][k]=-v[j][k]}}break}if(iteration>=itmax-1){throw"Error: no convergence."}x=q[l];y=q[k-1];g=e[k-1];h=e[k];f=((y-z)*(y+z)+(g-h)*(g+h))/(2*h*y);g=pythag(f,1);if(f<0){f=((x-z)*(x+z)+h*(y/(f-g)-h))/x}else{f=((x-z)*(x+z)+h*(y/(f+g)-h))/x}c=1;s=1;for(i=l+1;i<k+1;i++){g=e[i];y=q[i];h=s*g;g=c*g;z=pythag(f,h);e[i-1]=z;c=f/z;s=h/z;f=x*c+g*s;g=-x*s+g*c;h=y*s;y=y*c;for(j=0;j<n;j++){x=v[j][i-1];z=v[j][i];v[j][i-1]=x*c+z*s;v[j][i]=-x*s+z*c}z=pythag(f,h);q[i-1]=z;c=f/z;s=h/z;f=c*g+s*y;x=-s*g+c*y;for(j=0;j<m;j++){y=u[j][i-1];z=u[j][i];u[j][i-1]=y*c+z*s;u[j][i]=-y*s+z*c}}e[l]=0;e[k]=f;q[k]=x}}for(i=0;i<q.length;i++){if(q[i]<prec){q[i]=0}}for(i=0;i<n;i++){for(j=i-1;j>=0;j--){if(q[j]<q[i]){c=q[j];q[j]=q[i];q[i]=c;for(k=0;k<u.length;k++){temp=u[k][i];u[k][i]=u[k][j];u[k][j]=temp}for(k=0;k<v.length;k++){temp=v[k][i];v[k][i]=v[k][j];v[k][j]=temp}i=j}}}return{U:u,S:q,V:v}};







